"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// node_modules/aws-sdk/lib/json/builder.js
var require_builder = __commonJS({
  "node_modules/aws-sdk/lib/json/builder.js"(exports2, module2) {
    "use strict";
    var util = require_util();
    function JsonBuilder() {
    }
    JsonBuilder.prototype.build = function(value, shape) {
      return JSON.stringify(translate(value, shape));
    };
    function translate(value, shape) {
      if (!shape || value === void 0 || value === null)
        return void 0;
      switch (shape.type) {
        case "structure":
          return translateStructure(value, shape);
        case "map":
          return translateMap(value, shape);
        case "list":
          return translateList(value, shape);
        default:
          return translateScalar(value, shape);
      }
    }
    function translateStructure(structure, shape) {
      if (shape.isDocument) {
        return structure;
      }
      var struct = {};
      util.each(structure, function(name, value) {
        var memberShape = shape.members[name];
        if (memberShape) {
          if (memberShape.location !== "body")
            return;
          var locationName = memberShape.isLocationName ? memberShape.name : name;
          var result = translate(value, memberShape);
          if (result !== void 0)
            struct[locationName] = result;
        }
      });
      return struct;
    }
    function translateList(list, shape) {
      var out = [];
      util.arrayEach(list, function(value) {
        var result = translate(value, shape.member);
        if (result !== void 0)
          out.push(result);
      });
      return out;
    }
    function translateMap(map, shape) {
      var out = {};
      util.each(map, function(key, value) {
        var result = translate(value, shape.value);
        if (result !== void 0)
          out[key] = result;
      });
      return out;
    }
    function translateScalar(value, shape) {
      return shape.toWireFormat(value);
    }
    module2.exports = JsonBuilder;
  }
});

// node_modules/aws-sdk/lib/json/parser.js
var require_parser = __commonJS({
  "node_modules/aws-sdk/lib/json/parser.js"(exports2, module2) {
    "use strict";
    var util = require_util();
    function JsonParser() {
    }
    JsonParser.prototype.parse = function(value, shape) {
      return translate(JSON.parse(value), shape);
    };
    function translate(value, shape) {
      if (!shape || value === void 0)
        return void 0;
      switch (shape.type) {
        case "structure":
          return translateStructure(value, shape);
        case "map":
          return translateMap(value, shape);
        case "list":
          return translateList(value, shape);
        default:
          return translateScalar(value, shape);
      }
    }
    function translateStructure(structure, shape) {
      if (structure == null)
        return void 0;
      if (shape.isDocument)
        return structure;
      var struct = {};
      var shapeMembers = shape.members;
      var isAwsQueryCompatible = shape.api && shape.api.awsQueryCompatible;
      util.each(shapeMembers, function(name, memberShape) {
        var locationName = memberShape.isLocationName ? memberShape.name : name;
        if (Object.prototype.hasOwnProperty.call(structure, locationName)) {
          var value = structure[locationName];
          var result = translate(value, memberShape);
          if (result !== void 0)
            struct[name] = result;
        } else if (isAwsQueryCompatible && memberShape.defaultValue) {
          if (memberShape.type === "list") {
            struct[name] = typeof memberShape.defaultValue === "function" ? memberShape.defaultValue() : memberShape.defaultValue;
          }
        }
      });
      return struct;
    }
    function translateList(list, shape) {
      if (list == null)
        return void 0;
      var out = [];
      util.arrayEach(list, function(value) {
        var result = translate(value, shape.member);
        if (result === void 0)
          out.push(null);
        else
          out.push(result);
      });
      return out;
    }
    function translateMap(map, shape) {
      if (map == null)
        return void 0;
      var out = {};
      util.each(map, function(key, value) {
        var result = translate(value, shape.value);
        if (result === void 0)
          out[key] = null;
        else
          out[key] = result;
      });
      return out;
    }
    function translateScalar(value, shape) {
      return shape.toType(value);
    }
    module2.exports = JsonParser;
  }
});

// node_modules/aws-sdk/lib/protocol/helpers.js
var require_helpers = __commonJS({
  "node_modules/aws-sdk/lib/protocol/helpers.js"(exports2, module2) {
    "use strict";
    var util = require_util();
    var AWS2 = require_core();
    function populateHostPrefix(request) {
      var enabled = request.service.config.hostPrefixEnabled;
      if (!enabled)
        return request;
      var operationModel = request.service.api.operations[request.operation];
      if (hasEndpointDiscover(request))
        return request;
      if (operationModel.endpoint && operationModel.endpoint.hostPrefix) {
        var hostPrefixNotation = operationModel.endpoint.hostPrefix;
        var hostPrefix = expandHostPrefix(hostPrefixNotation, request.params, operationModel.input);
        prependEndpointPrefix(request.httpRequest.endpoint, hostPrefix);
        validateHostname(request.httpRequest.endpoint.hostname);
      }
      return request;
    }
    function hasEndpointDiscover(request) {
      var api = request.service.api;
      var operationModel = api.operations[request.operation];
      var isEndpointOperation = api.endpointOperation && api.endpointOperation === util.string.lowerFirst(operationModel.name);
      return operationModel.endpointDiscoveryRequired !== "NULL" || isEndpointOperation === true;
    }
    function expandHostPrefix(hostPrefixNotation, params, shape) {
      util.each(shape.members, function(name, member) {
        if (member.hostLabel === true) {
          if (typeof params[name] !== "string" || params[name] === "") {
            throw util.error(new Error(), {
              message: "Parameter " + name + " should be a non-empty string.",
              code: "InvalidParameter"
            });
          }
          var regex = new RegExp("\\{" + name + "\\}", "g");
          hostPrefixNotation = hostPrefixNotation.replace(regex, params[name]);
        }
      });
      return hostPrefixNotation;
    }
    function prependEndpointPrefix(endpoint, prefix) {
      if (endpoint.host) {
        endpoint.host = prefix + endpoint.host;
      }
      if (endpoint.hostname) {
        endpoint.hostname = prefix + endpoint.hostname;
      }
    }
    function validateHostname(hostname) {
      var labels = hostname.split(".");
      var hostPattern = /^[a-zA-Z0-9]{1}$|^[a-zA-Z0-9][a-zA-Z0-9\-]*[a-zA-Z0-9]$/;
      util.arrayEach(labels, function(label) {
        if (!label.length || label.length < 1 || label.length > 63) {
          throw util.error(new Error(), {
            code: "ValidationError",
            message: "Hostname label length should be between 1 to 63 characters, inclusive."
          });
        }
        if (!hostPattern.test(label)) {
          throw AWS2.util.error(
            new Error(),
            { code: "ValidationError", message: label + " is not hostname compatible." }
          );
        }
      });
    }
    module2.exports = {
      populateHostPrefix
    };
  }
});

// node_modules/aws-sdk/lib/protocol/json.js
var require_json = __commonJS({
  "node_modules/aws-sdk/lib/protocol/json.js"(exports2, module2) {
    "use strict";
    var util = require_util();
    var JsonBuilder = require_builder();
    var JsonParser = require_parser();
    var populateHostPrefix = require_helpers().populateHostPrefix;
    function buildRequest(req) {
      var httpRequest = req.httpRequest;
      var api = req.service.api;
      var target = api.targetPrefix + "." + api.operations[req.operation].name;
      var version = api.jsonVersion || "1.0";
      var input = api.operations[req.operation].input;
      var builder = new JsonBuilder();
      if (version === 1)
        version = "1.0";
      if (api.awsQueryCompatible) {
        if (!httpRequest.params) {
          httpRequest.params = {};
        }
        Object.assign(httpRequest.params, req.params);
      }
      httpRequest.body = builder.build(req.params || {}, input);
      httpRequest.headers["Content-Type"] = "application/x-amz-json-" + version;
      httpRequest.headers["X-Amz-Target"] = target;
      populateHostPrefix(req);
    }
    function extractError(resp) {
      var error = {};
      var httpResponse = resp.httpResponse;
      error.code = httpResponse.headers["x-amzn-errortype"] || "UnknownError";
      if (typeof error.code === "string") {
        error.code = error.code.split(":")[0];
      }
      if (httpResponse.body.length > 0) {
        try {
          var e = JSON.parse(httpResponse.body.toString());
          var code = e.__type || e.code || e.Code;
          if (code) {
            error.code = code.split("#").pop();
          }
          if (error.code === "RequestEntityTooLarge") {
            error.message = "Request body must be less than 1 MB";
          } else {
            error.message = e.message || e.Message || null;
          }
          for (var key in e || {}) {
            if (key === "code" || key === "message") {
              continue;
            }
            error["[" + key + "]"] = "See error." + key + " for details.";
            Object.defineProperty(error, key, {
              value: e[key],
              enumerable: false,
              writable: true
            });
          }
        } catch (e2) {
          error.statusCode = httpResponse.statusCode;
          error.message = httpResponse.statusMessage;
        }
      } else {
        error.statusCode = httpResponse.statusCode;
        error.message = httpResponse.statusCode.toString();
      }
      resp.error = util.error(new Error(), error);
    }
    function extractData(resp) {
      var body = resp.httpResponse.body.toString() || "{}";
      if (resp.request.service.config.convertResponseTypes === false) {
        resp.data = JSON.parse(body);
      } else {
        var operation = resp.request.service.api.operations[resp.request.operation];
        var shape = operation.output || {};
        var parser = new JsonParser();
        resp.data = parser.parse(body, shape);
      }
    }
    module2.exports = {
      buildRequest,
      extractError,
      extractData
    };
  }
});

// node_modules/aws-sdk/lib/query/query_param_serializer.js
var require_query_param_serializer = __commonJS({
  "node_modules/aws-sdk/lib/query/query_param_serializer.js"(exports2, module2) {
    "use strict";
    var util = require_util();
    function QueryParamSerializer() {
    }
    QueryParamSerializer.prototype.serialize = function(params, shape, fn) {
      serializeStructure("", params, shape, fn);
    };
    function ucfirst(shape) {
      if (shape.isQueryName || shape.api.protocol !== "ec2") {
        return shape.name;
      } else {
        return shape.name[0].toUpperCase() + shape.name.substr(1);
      }
    }
    function serializeStructure(prefix, struct, rules, fn) {
      util.each(rules.members, function(name, member) {
        var value = struct[name];
        if (value === null || value === void 0)
          return;
        var memberName = ucfirst(member);
        memberName = prefix ? prefix + "." + memberName : memberName;
        serializeMember(memberName, value, member, fn);
      });
    }
    function serializeMap(name, map, rules, fn) {
      var i = 1;
      util.each(map, function(key, value) {
        var prefix = rules.flattened ? "." : ".entry.";
        var position = prefix + i++ + ".";
        var keyName = position + (rules.key.name || "key");
        var valueName = position + (rules.value.name || "value");
        serializeMember(name + keyName, key, rules.key, fn);
        serializeMember(name + valueName, value, rules.value, fn);
      });
    }
    function serializeList(name, list, rules, fn) {
      var memberRules = rules.member || {};
      if (list.length === 0) {
        fn.call(this, name, null);
        return;
      }
      util.arrayEach(list, function(v, n) {
        var suffix = "." + (n + 1);
        if (rules.api.protocol === "ec2") {
          suffix = suffix + "";
        } else if (rules.flattened) {
          if (memberRules.name) {
            var parts = name.split(".");
            parts.pop();
            parts.push(ucfirst(memberRules));
            name = parts.join(".");
          }
        } else {
          suffix = "." + (memberRules.name ? memberRules.name : "member") + suffix;
        }
        serializeMember(name + suffix, v, memberRules, fn);
      });
    }
    function serializeMember(name, value, rules, fn) {
      if (value === null || value === void 0)
        return;
      if (rules.type === "structure") {
        serializeStructure(name, value, rules, fn);
      } else if (rules.type === "list") {
        serializeList(name, value, rules, fn);
      } else if (rules.type === "map") {
        serializeMap(name, value, rules, fn);
      } else {
        fn(name, rules.toWireFormat(value).toString());
      }
    }
    module2.exports = QueryParamSerializer;
  }
});

// node_modules/aws-sdk/lib/model/collection.js
var require_collection = __commonJS({
  "node_modules/aws-sdk/lib/model/collection.js"(exports2, module2) {
    "use strict";
    var memoizedProperty = require_util().memoizedProperty;
    function memoize(name, value, factory, nameTr) {
      memoizedProperty(this, nameTr(name), function() {
        return factory(name, value);
      });
    }
    function Collection(iterable, options, factory, nameTr, callback) {
      nameTr = nameTr || String;
      var self2 = this;
      for (var id in iterable) {
        if (Object.prototype.hasOwnProperty.call(iterable, id)) {
          memoize.call(self2, id, iterable[id], factory, nameTr);
          if (callback)
            callback(id, iterable[id]);
        }
      }
    }
    module2.exports = Collection;
  }
});

// node_modules/aws-sdk/lib/model/shape.js
var require_shape = __commonJS({
  "node_modules/aws-sdk/lib/model/shape.js"(exports2, module2) {
    "use strict";
    var Collection = require_collection();
    var util = require_util();
    function property(obj, name, value) {
      if (value !== null && value !== void 0) {
        util.property.apply(this, arguments);
      }
    }
    function memoizedProperty(obj, name) {
      if (!obj.constructor.prototype[name]) {
        util.memoizedProperty.apply(this, arguments);
      }
    }
    function Shape(shape, options, memberName) {
      options = options || {};
      property(this, "shape", shape.shape);
      property(this, "api", options.api, false);
      property(this, "type", shape.type);
      property(this, "enum", shape.enum);
      property(this, "min", shape.min);
      property(this, "max", shape.max);
      property(this, "pattern", shape.pattern);
      property(this, "location", shape.location || this.location || "body");
      property(this, "name", this.name || shape.xmlName || shape.queryName || shape.locationName || memberName);
      property(this, "isStreaming", shape.streaming || this.isStreaming || false);
      property(this, "requiresLength", shape.requiresLength, false);
      property(this, "isComposite", shape.isComposite || false);
      property(this, "isShape", true, false);
      property(this, "isQueryName", Boolean(shape.queryName), false);
      property(this, "isLocationName", Boolean(shape.locationName), false);
      property(this, "isIdempotent", shape.idempotencyToken === true);
      property(this, "isJsonValue", shape.jsonvalue === true);
      property(this, "isSensitive", shape.sensitive === true || shape.prototype && shape.prototype.sensitive === true);
      property(this, "isEventStream", Boolean(shape.eventstream), false);
      property(this, "isEvent", Boolean(shape.event), false);
      property(this, "isEventPayload", Boolean(shape.eventpayload), false);
      property(this, "isEventHeader", Boolean(shape.eventheader), false);
      property(this, "isTimestampFormatSet", Boolean(shape.timestampFormat) || shape.prototype && shape.prototype.isTimestampFormatSet === true, false);
      property(this, "endpointDiscoveryId", Boolean(shape.endpointdiscoveryid), false);
      property(this, "hostLabel", Boolean(shape.hostLabel), false);
      if (options.documentation) {
        property(this, "documentation", shape.documentation);
        property(this, "documentationUrl", shape.documentationUrl);
      }
      if (shape.xmlAttribute) {
        property(this, "isXmlAttribute", shape.xmlAttribute || false);
      }
      property(this, "defaultValue", null);
      this.toWireFormat = function(value) {
        if (value === null || value === void 0)
          return "";
        return value;
      };
      this.toType = function(value) {
        return value;
      };
    }
    Shape.normalizedTypes = {
      character: "string",
      double: "float",
      long: "integer",
      short: "integer",
      biginteger: "integer",
      bigdecimal: "float",
      blob: "binary"
    };
    Shape.types = {
      "structure": StructureShape,
      "list": ListShape,
      "map": MapShape,
      "boolean": BooleanShape,
      "timestamp": TimestampShape,
      "float": FloatShape,
      "integer": IntegerShape,
      "string": StringShape,
      "base64": Base64Shape,
      "binary": BinaryShape
    };
    Shape.resolve = function resolve(shape, options) {
      if (shape.shape) {
        var refShape = options.api.shapes[shape.shape];
        if (!refShape) {
          throw new Error("Cannot find shape reference: " + shape.shape);
        }
        return refShape;
      } else {
        return null;
      }
    };
    Shape.create = function create(shape, options, memberName) {
      if (shape.isShape)
        return shape;
      var refShape = Shape.resolve(shape, options);
      if (refShape) {
        var filteredKeys = Object.keys(shape);
        if (!options.documentation) {
          filteredKeys = filteredKeys.filter(function(name) {
            return !name.match(/documentation/);
          });
        }
        var InlineShape = function() {
          refShape.constructor.call(this, shape, options, memberName);
        };
        InlineShape.prototype = refShape;
        return new InlineShape();
      } else {
        if (!shape.type) {
          if (shape.members)
            shape.type = "structure";
          else if (shape.member)
            shape.type = "list";
          else if (shape.key)
            shape.type = "map";
          else
            shape.type = "string";
        }
        var origType = shape.type;
        if (Shape.normalizedTypes[shape.type]) {
          shape.type = Shape.normalizedTypes[shape.type];
        }
        if (Shape.types[shape.type]) {
          return new Shape.types[shape.type](shape, options, memberName);
        } else {
          throw new Error("Unrecognized shape type: " + origType);
        }
      }
    };
    function CompositeShape(shape) {
      Shape.apply(this, arguments);
      property(this, "isComposite", true);
      if (shape.flattened) {
        property(this, "flattened", shape.flattened || false);
      }
    }
    function StructureShape(shape, options) {
      var self2 = this;
      var requiredMap = null, firstInit = !this.isShape;
      CompositeShape.apply(this, arguments);
      if (firstInit) {
        property(this, "defaultValue", function() {
          return {};
        });
        property(this, "members", {});
        property(this, "memberNames", []);
        property(this, "required", []);
        property(this, "isRequired", function() {
          return false;
        });
        property(this, "isDocument", Boolean(shape.document));
      }
      if (shape.members) {
        property(this, "members", new Collection(shape.members, options, function(name, member) {
          return Shape.create(member, options, name);
        }));
        memoizedProperty(this, "memberNames", function() {
          return shape.xmlOrder || Object.keys(shape.members);
        });
        if (shape.event) {
          memoizedProperty(this, "eventPayloadMemberName", function() {
            var members = self2.members;
            var memberNames = self2.memberNames;
            for (var i = 0, iLen = memberNames.length; i < iLen; i++) {
              if (members[memberNames[i]].isEventPayload) {
                return memberNames[i];
              }
            }
          });
          memoizedProperty(this, "eventHeaderMemberNames", function() {
            var members = self2.members;
            var memberNames = self2.memberNames;
            var eventHeaderMemberNames = [];
            for (var i = 0, iLen = memberNames.length; i < iLen; i++) {
              if (members[memberNames[i]].isEventHeader) {
                eventHeaderMemberNames.push(memberNames[i]);
              }
            }
            return eventHeaderMemberNames;
          });
        }
      }
      if (shape.required) {
        property(this, "required", shape.required);
        property(this, "isRequired", function(name) {
          if (!requiredMap) {
            requiredMap = {};
            for (var i = 0; i < shape.required.length; i++) {
              requiredMap[shape.required[i]] = true;
            }
          }
          return requiredMap[name];
        }, false, true);
      }
      property(this, "resultWrapper", shape.resultWrapper || null);
      if (shape.payload) {
        property(this, "payload", shape.payload);
      }
      if (typeof shape.xmlNamespace === "string") {
        property(this, "xmlNamespaceUri", shape.xmlNamespace);
      } else if (typeof shape.xmlNamespace === "object") {
        property(this, "xmlNamespacePrefix", shape.xmlNamespace.prefix);
        property(this, "xmlNamespaceUri", shape.xmlNamespace.uri);
      }
    }
    function ListShape(shape, options) {
      var self2 = this, firstInit = !this.isShape;
      CompositeShape.apply(this, arguments);
      if (firstInit) {
        property(this, "defaultValue", function() {
          return [];
        });
      }
      if (shape.member) {
        memoizedProperty(this, "member", function() {
          return Shape.create(shape.member, options);
        });
      }
      if (this.flattened) {
        var oldName = this.name;
        memoizedProperty(this, "name", function() {
          return self2.member.name || oldName;
        });
      }
    }
    function MapShape(shape, options) {
      var firstInit = !this.isShape;
      CompositeShape.apply(this, arguments);
      if (firstInit) {
        property(this, "defaultValue", function() {
          return {};
        });
        property(this, "key", Shape.create({ type: "string" }, options));
        property(this, "value", Shape.create({ type: "string" }, options));
      }
      if (shape.key) {
        memoizedProperty(this, "key", function() {
          return Shape.create(shape.key, options);
        });
      }
      if (shape.value) {
        memoizedProperty(this, "value", function() {
          return Shape.create(shape.value, options);
        });
      }
    }
    function TimestampShape(shape) {
      var self2 = this;
      Shape.apply(this, arguments);
      if (shape.timestampFormat) {
        property(this, "timestampFormat", shape.timestampFormat);
      } else if (self2.isTimestampFormatSet && this.timestampFormat) {
        property(this, "timestampFormat", this.timestampFormat);
      } else if (this.location === "header") {
        property(this, "timestampFormat", "rfc822");
      } else if (this.location === "querystring") {
        property(this, "timestampFormat", "iso8601");
      } else if (this.api) {
        switch (this.api.protocol) {
          case "json":
          case "rest-json":
            property(this, "timestampFormat", "unixTimestamp");
            break;
          case "rest-xml":
          case "query":
          case "ec2":
            property(this, "timestampFormat", "iso8601");
            break;
        }
      }
      this.toType = function(value) {
        if (value === null || value === void 0)
          return null;
        if (typeof value.toUTCString === "function")
          return value;
        return typeof value === "string" || typeof value === "number" ? util.date.parseTimestamp(value) : null;
      };
      this.toWireFormat = function(value) {
        return util.date.format(value, self2.timestampFormat);
      };
    }
    function StringShape() {
      Shape.apply(this, arguments);
      var nullLessProtocols = ["rest-xml", "query", "ec2"];
      this.toType = function(value) {
        value = this.api && nullLessProtocols.indexOf(this.api.protocol) > -1 ? value || "" : value;
        if (this.isJsonValue) {
          return JSON.parse(value);
        }
        return value && typeof value.toString === "function" ? value.toString() : value;
      };
      this.toWireFormat = function(value) {
        return this.isJsonValue ? JSON.stringify(value) : value;
      };
    }
    function FloatShape() {
      Shape.apply(this, arguments);
      this.toType = function(value) {
        if (value === null || value === void 0)
          return null;
        return parseFloat(value);
      };
      this.toWireFormat = this.toType;
    }
    function IntegerShape() {
      Shape.apply(this, arguments);
      this.toType = function(value) {
        if (value === null || value === void 0)
          return null;
        return parseInt(value, 10);
      };
      this.toWireFormat = this.toType;
    }
    function BinaryShape() {
      Shape.apply(this, arguments);
      this.toType = function(value) {
        var buf = util.base64.decode(value);
        if (this.isSensitive && util.isNode() && typeof util.Buffer.alloc === "function") {
          var secureBuf = util.Buffer.alloc(buf.length, buf);
          buf.fill(0);
          buf = secureBuf;
        }
        return buf;
      };
      this.toWireFormat = util.base64.encode;
    }
    function Base64Shape() {
      BinaryShape.apply(this, arguments);
    }
    function BooleanShape() {
      Shape.apply(this, arguments);
      this.toType = function(value) {
        if (typeof value === "boolean")
          return value;
        if (value === null || value === void 0)
          return null;
        return value === "true";
      };
    }
    Shape.shapes = {
      StructureShape,
      ListShape,
      MapShape,
      StringShape,
      BooleanShape,
      Base64Shape
    };
    module2.exports = Shape;
  }
});

// node_modules/aws-sdk/lib/protocol/query.js
var require_query = __commonJS({
  "node_modules/aws-sdk/lib/protocol/query.js"(exports2, module2) {
    "use strict";
    var AWS2 = require_core();
    var util = require_util();
    var QueryParamSerializer = require_query_param_serializer();
    var Shape = require_shape();
    var populateHostPrefix = require_helpers().populateHostPrefix;
    function buildRequest(req) {
      var operation = req.service.api.operations[req.operation];
      var httpRequest = req.httpRequest;
      httpRequest.headers["Content-Type"] = "application/x-www-form-urlencoded; charset=utf-8";
      httpRequest.params = {
        Version: req.service.api.apiVersion,
        Action: operation.name
      };
      var builder = new QueryParamSerializer();
      builder.serialize(req.params, operation.input, function(name, value) {
        httpRequest.params[name] = value;
      });
      httpRequest.body = util.queryParamsToString(httpRequest.params);
      populateHostPrefix(req);
    }
    function extractError(resp) {
      var data, body = resp.httpResponse.body.toString();
      if (body.match("<UnknownOperationException")) {
        data = {
          Code: "UnknownOperation",
          Message: "Unknown operation " + resp.request.operation
        };
      } else {
        try {
          data = new AWS2.XML.Parser().parse(body);
        } catch (e) {
          data = {
            Code: resp.httpResponse.statusCode,
            Message: resp.httpResponse.statusMessage
          };
        }
      }
      if (data.requestId && !resp.requestId)
        resp.requestId = data.requestId;
      if (data.Errors)
        data = data.Errors;
      if (data.Error)
        data = data.Error;
      if (data.Code) {
        resp.error = util.error(new Error(), {
          code: data.Code,
          message: data.Message
        });
      } else {
        resp.error = util.error(new Error(), {
          code: resp.httpResponse.statusCode,
          message: null
        });
      }
    }
    function extractData(resp) {
      var req = resp.request;
      var operation = req.service.api.operations[req.operation];
      var shape = operation.output || {};
      var origRules = shape;
      if (origRules.resultWrapper) {
        var tmp = Shape.create({ type: "structure" });
        tmp.members[origRules.resultWrapper] = shape;
        tmp.memberNames = [origRules.resultWrapper];
        util.property(shape, "name", shape.resultWrapper);
        shape = tmp;
      }
      var parser = new AWS2.XML.Parser();
      if (shape && shape.members && !shape.members._XAMZRequestId) {
        var requestIdShape = Shape.create(
          { type: "string" },
          { api: { protocol: "query" } },
          "requestId"
        );
        shape.members._XAMZRequestId = requestIdShape;
      }
      var data = parser.parse(resp.httpResponse.body.toString(), shape);
      resp.requestId = data._XAMZRequestId || data.requestId;
      if (data._XAMZRequestId)
        delete data._XAMZRequestId;
      if (origRules.resultWrapper) {
        if (data[origRules.resultWrapper]) {
          util.update(data, data[origRules.resultWrapper]);
          delete data[origRules.resultWrapper];
        }
      }
      resp.data = data;
    }
    module2.exports = {
      buildRequest,
      extractError,
      extractData
    };
  }
});

// node_modules/aws-sdk/lib/protocol/rest.js
var require_rest = __commonJS({
  "node_modules/aws-sdk/lib/protocol/rest.js"(exports2, module2) {
    "use strict";
    var util = require_util();
    var populateHostPrefix = require_helpers().populateHostPrefix;
    function populateMethod(req) {
      req.httpRequest.method = req.service.api.operations[req.operation].httpMethod;
    }
    function generateURI(endpointPath, operationPath, input, params) {
      var uri = [endpointPath, operationPath].join("/");
      uri = uri.replace(/\/+/g, "/");
      var queryString = {}, queryStringSet = false;
      util.each(input.members, function(name, member) {
        var paramValue = params[name];
        if (paramValue === null || paramValue === void 0)
          return;
        if (member.location === "uri") {
          var regex = new RegExp("\\{" + member.name + "(\\+)?\\}");
          uri = uri.replace(regex, function(_, plus) {
            var fn = plus ? util.uriEscapePath : util.uriEscape;
            return fn(String(paramValue));
          });
        } else if (member.location === "querystring") {
          queryStringSet = true;
          if (member.type === "list") {
            queryString[member.name] = paramValue.map(function(val) {
              return util.uriEscape(member.member.toWireFormat(val).toString());
            });
          } else if (member.type === "map") {
            util.each(paramValue, function(key, value) {
              if (Array.isArray(value)) {
                queryString[key] = value.map(function(val) {
                  return util.uriEscape(String(val));
                });
              } else {
                queryString[key] = util.uriEscape(String(value));
              }
            });
          } else {
            queryString[member.name] = util.uriEscape(member.toWireFormat(paramValue).toString());
          }
        }
      });
      if (queryStringSet) {
        uri += uri.indexOf("?") >= 0 ? "&" : "?";
        var parts = [];
        util.arrayEach(Object.keys(queryString).sort(), function(key) {
          if (!Array.isArray(queryString[key])) {
            queryString[key] = [queryString[key]];
          }
          for (var i = 0; i < queryString[key].length; i++) {
            parts.push(util.uriEscape(String(key)) + "=" + queryString[key][i]);
          }
        });
        uri += parts.join("&");
      }
      return uri;
    }
    function populateURI(req) {
      var operation = req.service.api.operations[req.operation];
      var input = operation.input;
      var uri = generateURI(req.httpRequest.endpoint.path, operation.httpPath, input, req.params);
      req.httpRequest.path = uri;
    }
    function populateHeaders(req) {
      var operation = req.service.api.operations[req.operation];
      util.each(operation.input.members, function(name, member) {
        var value = req.params[name];
        if (value === null || value === void 0)
          return;
        if (member.location === "headers" && member.type === "map") {
          util.each(value, function(key, memberValue) {
            req.httpRequest.headers[member.name + key] = memberValue;
          });
        } else if (member.location === "header") {
          value = member.toWireFormat(value).toString();
          if (member.isJsonValue) {
            value = util.base64.encode(value);
          }
          req.httpRequest.headers[member.name] = value;
        }
      });
    }
    function buildRequest(req) {
      populateMethod(req);
      populateURI(req);
      populateHeaders(req);
      populateHostPrefix(req);
    }
    function extractError() {
    }
    function extractData(resp) {
      var req = resp.request;
      var data = {};
      var r = resp.httpResponse;
      var operation = req.service.api.operations[req.operation];
      var output = operation.output;
      var headers = {};
      util.each(r.headers, function(k, v) {
        headers[k.toLowerCase()] = v;
      });
      util.each(output.members, function(name, member) {
        var header = (member.name || name).toLowerCase();
        if (member.location === "headers" && member.type === "map") {
          data[name] = {};
          var location = member.isLocationName ? member.name : "";
          var pattern = new RegExp("^" + location + "(.+)", "i");
          util.each(r.headers, function(k, v) {
            var result = k.match(pattern);
            if (result !== null) {
              data[name][result[1]] = v;
            }
          });
        } else if (member.location === "header") {
          if (headers[header] !== void 0) {
            var value = member.isJsonValue ? util.base64.decode(headers[header]) : headers[header];
            data[name] = member.toType(value);
          }
        } else if (member.location === "statusCode") {
          data[name] = parseInt(r.statusCode, 10);
        }
      });
      resp.data = data;
    }
    module2.exports = {
      buildRequest,
      extractError,
      extractData,
      generateURI
    };
  }
});

// node_modules/aws-sdk/lib/protocol/rest_json.js
var require_rest_json = __commonJS({
  "node_modules/aws-sdk/lib/protocol/rest_json.js"(exports2, module2) {
    "use strict";
    var util = require_util();
    var Rest = require_rest();
    var Json = require_json();
    var JsonBuilder = require_builder();
    var JsonParser = require_parser();
    var METHODS_WITHOUT_BODY = ["GET", "HEAD", "DELETE"];
    function unsetContentLength(req) {
      var payloadMember = util.getRequestPayloadShape(req);
      if (payloadMember === void 0 && METHODS_WITHOUT_BODY.indexOf(req.httpRequest.method) >= 0) {
        delete req.httpRequest.headers["Content-Length"];
      }
    }
    function populateBody(req) {
      var builder = new JsonBuilder();
      var input = req.service.api.operations[req.operation].input;
      if (input.payload) {
        var params = {};
        var payloadShape = input.members[input.payload];
        params = req.params[input.payload];
        if (payloadShape.type === "structure") {
          req.httpRequest.body = builder.build(params || {}, payloadShape);
          applyContentTypeHeader(req);
        } else if (params !== void 0) {
          req.httpRequest.body = params;
          if (payloadShape.type === "binary" || payloadShape.isStreaming) {
            applyContentTypeHeader(req, true);
          }
        }
      } else {
        req.httpRequest.body = builder.build(req.params, input);
        applyContentTypeHeader(req);
      }
    }
    function applyContentTypeHeader(req, isBinary) {
      if (!req.httpRequest.headers["Content-Type"]) {
        var type = isBinary ? "binary/octet-stream" : "application/json";
        req.httpRequest.headers["Content-Type"] = type;
      }
    }
    function buildRequest(req) {
      Rest.buildRequest(req);
      if (METHODS_WITHOUT_BODY.indexOf(req.httpRequest.method) < 0) {
        populateBody(req);
      }
    }
    function extractError(resp) {
      Json.extractError(resp);
    }
    function extractData(resp) {
      Rest.extractData(resp);
      var req = resp.request;
      var operation = req.service.api.operations[req.operation];
      var rules = req.service.api.operations[req.operation].output || {};
      var parser;
      var hasEventOutput = operation.hasEventOutput;
      if (rules.payload) {
        var payloadMember = rules.members[rules.payload];
        var body = resp.httpResponse.body;
        if (payloadMember.isEventStream) {
          parser = new JsonParser();
          resp.data[payload] = util.createEventStream(
            AWS.HttpClient.streamsApiVersion === 2 ? resp.httpResponse.stream : body,
            parser,
            payloadMember
          );
        } else if (payloadMember.type === "structure" || payloadMember.type === "list") {
          var parser = new JsonParser();
          resp.data[rules.payload] = parser.parse(body, payloadMember);
        } else if (payloadMember.type === "binary" || payloadMember.isStreaming) {
          resp.data[rules.payload] = body;
        } else {
          resp.data[rules.payload] = payloadMember.toType(body);
        }
      } else {
        var data = resp.data;
        Json.extractData(resp);
        resp.data = util.merge(data, resp.data);
      }
    }
    module2.exports = {
      buildRequest,
      extractError,
      extractData,
      unsetContentLength
    };
  }
});

// node_modules/aws-sdk/lib/protocol/rest_xml.js
var require_rest_xml = __commonJS({
  "node_modules/aws-sdk/lib/protocol/rest_xml.js"(exports2, module2) {
    "use strict";
    var AWS2 = require_core();
    var util = require_util();
    var Rest = require_rest();
    function populateBody(req) {
      var input = req.service.api.operations[req.operation].input;
      var builder = new AWS2.XML.Builder();
      var params = req.params;
      var payload2 = input.payload;
      if (payload2) {
        var payloadMember = input.members[payload2];
        params = params[payload2];
        if (params === void 0)
          return;
        if (payloadMember.type === "structure") {
          var rootElement = payloadMember.name;
          req.httpRequest.body = builder.toXML(params, payloadMember, rootElement, true);
        } else {
          req.httpRequest.body = params;
        }
      } else {
        req.httpRequest.body = builder.toXML(params, input, input.name || input.shape || util.string.upperFirst(req.operation) + "Request");
      }
    }
    function buildRequest(req) {
      Rest.buildRequest(req);
      if (["GET", "HEAD"].indexOf(req.httpRequest.method) < 0) {
        populateBody(req);
      }
    }
    function extractError(resp) {
      Rest.extractError(resp);
      var data;
      try {
        data = new AWS2.XML.Parser().parse(resp.httpResponse.body.toString());
      } catch (e) {
        data = {
          Code: resp.httpResponse.statusCode,
          Message: resp.httpResponse.statusMessage
        };
      }
      if (data.Errors)
        data = data.Errors;
      if (data.Error)
        data = data.Error;
      if (data.Code) {
        resp.error = util.error(new Error(), {
          code: data.Code,
          message: data.Message
        });
      } else {
        resp.error = util.error(new Error(), {
          code: resp.httpResponse.statusCode,
          message: null
        });
      }
    }
    function extractData(resp) {
      Rest.extractData(resp);
      var parser;
      var req = resp.request;
      var body = resp.httpResponse.body;
      var operation = req.service.api.operations[req.operation];
      var output = operation.output;
      var hasEventOutput = operation.hasEventOutput;
      var payload2 = output.payload;
      if (payload2) {
        var payloadMember = output.members[payload2];
        if (payloadMember.isEventStream) {
          parser = new AWS2.XML.Parser();
          resp.data[payload2] = util.createEventStream(
            AWS2.HttpClient.streamsApiVersion === 2 ? resp.httpResponse.stream : resp.httpResponse.body,
            parser,
            payloadMember
          );
        } else if (payloadMember.type === "structure") {
          parser = new AWS2.XML.Parser();
          resp.data[payload2] = parser.parse(body.toString(), payloadMember);
        } else if (payloadMember.type === "binary" || payloadMember.isStreaming) {
          resp.data[payload2] = body;
        } else {
          resp.data[payload2] = payloadMember.toType(body);
        }
      } else if (body.length > 0) {
        parser = new AWS2.XML.Parser();
        var data = parser.parse(body.toString(), output);
        util.update(resp.data, data);
      }
    }
    module2.exports = {
      buildRequest,
      extractError,
      extractData
    };
  }
});

// node_modules/aws-sdk/lib/xml/escape-attribute.js
var require_escape_attribute = __commonJS({
  "node_modules/aws-sdk/lib/xml/escape-attribute.js"(exports2, module2) {
    "use strict";
    function escapeAttribute(value) {
      return value.replace(/&/g, "&amp;").replace(/'/g, "&apos;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/"/g, "&quot;");
    }
    module2.exports = {
      escapeAttribute
    };
  }
});

// node_modules/aws-sdk/lib/xml/xml-node.js
var require_xml_node = __commonJS({
  "node_modules/aws-sdk/lib/xml/xml-node.js"(exports2, module2) {
    "use strict";
    var escapeAttribute = require_escape_attribute().escapeAttribute;
    function XmlNode(name, children2) {
      if (children2 === void 0) {
        children2 = [];
      }
      this.name = name;
      this.children = children2;
      this.attributes = {};
    }
    XmlNode.prototype.addAttribute = function(name, value) {
      this.attributes[name] = value;
      return this;
    };
    XmlNode.prototype.addChildNode = function(child) {
      this.children.push(child);
      return this;
    };
    XmlNode.prototype.removeAttribute = function(name) {
      delete this.attributes[name];
      return this;
    };
    XmlNode.prototype.toString = function() {
      var hasChildren = Boolean(this.children.length);
      var xmlText = "<" + this.name;
      var attributes = this.attributes;
      for (var i = 0, attributeNames = Object.keys(attributes); i < attributeNames.length; i++) {
        var attributeName = attributeNames[i];
        var attribute = attributes[attributeName];
        if (typeof attribute !== "undefined" && attribute !== null) {
          xmlText += " " + attributeName + '="' + escapeAttribute("" + attribute) + '"';
        }
      }
      return xmlText += !hasChildren ? "/>" : ">" + this.children.map(function(c) {
        return c.toString();
      }).join("") + "</" + this.name + ">";
    };
    module2.exports = {
      XmlNode
    };
  }
});

// node_modules/aws-sdk/lib/xml/escape-element.js
var require_escape_element = __commonJS({
  "node_modules/aws-sdk/lib/xml/escape-element.js"(exports2, module2) {
    "use strict";
    function escapeElement(value) {
      return value.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/\r/g, "&#x0D;").replace(/\n/g, "&#x0A;").replace(/\u0085/g, "&#x85;").replace(/\u2028/, "&#x2028;");
    }
    module2.exports = {
      escapeElement
    };
  }
});

// node_modules/aws-sdk/lib/xml/xml-text.js
var require_xml_text = __commonJS({
  "node_modules/aws-sdk/lib/xml/xml-text.js"(exports2, module2) {
    "use strict";
    var escapeElement = require_escape_element().escapeElement;
    function XmlText(value) {
      this.value = value;
    }
    XmlText.prototype.toString = function() {
      return escapeElement("" + this.value);
    };
    module2.exports = {
      XmlText
    };
  }
});

// node_modules/aws-sdk/lib/xml/builder.js
var require_builder2 = __commonJS({
  "node_modules/aws-sdk/lib/xml/builder.js"(exports2, module2) {
    "use strict";
    var util = require_util();
    var XmlNode = require_xml_node().XmlNode;
    var XmlText = require_xml_text().XmlText;
    function XmlBuilder() {
    }
    XmlBuilder.prototype.toXML = function(params, shape, rootElement, noEmpty) {
      var xml = new XmlNode(rootElement);
      applyNamespaces(xml, shape, true);
      serialize(xml, params, shape);
      return xml.children.length > 0 || noEmpty ? xml.toString() : "";
    };
    function serialize(xml, value, shape) {
      switch (shape.type) {
        case "structure":
          return serializeStructure(xml, value, shape);
        case "map":
          return serializeMap(xml, value, shape);
        case "list":
          return serializeList(xml, value, shape);
        default:
          return serializeScalar(xml, value, shape);
      }
    }
    function serializeStructure(xml, params, shape) {
      util.arrayEach(shape.memberNames, function(memberName) {
        var memberShape = shape.members[memberName];
        if (memberShape.location !== "body")
          return;
        var value = params[memberName];
        var name = memberShape.name;
        if (value !== void 0 && value !== null) {
          if (memberShape.isXmlAttribute) {
            xml.addAttribute(name, value);
          } else if (memberShape.flattened) {
            serialize(xml, value, memberShape);
          } else {
            var element = new XmlNode(name);
            xml.addChildNode(element);
            applyNamespaces(element, memberShape);
            serialize(element, value, memberShape);
          }
        }
      });
    }
    function serializeMap(xml, map, shape) {
      var xmlKey = shape.key.name || "key";
      var xmlValue = shape.value.name || "value";
      util.each(map, function(key, value) {
        var entry = new XmlNode(shape.flattened ? shape.name : "entry");
        xml.addChildNode(entry);
        var entryKey = new XmlNode(xmlKey);
        var entryValue = new XmlNode(xmlValue);
        entry.addChildNode(entryKey);
        entry.addChildNode(entryValue);
        serialize(entryKey, key, shape.key);
        serialize(entryValue, value, shape.value);
      });
    }
    function serializeList(xml, list, shape) {
      if (shape.flattened) {
        util.arrayEach(list, function(value) {
          var name = shape.member.name || shape.name;
          var element = new XmlNode(name);
          xml.addChildNode(element);
          serialize(element, value, shape.member);
        });
      } else {
        util.arrayEach(list, function(value) {
          var name = shape.member.name || "member";
          var element = new XmlNode(name);
          xml.addChildNode(element);
          serialize(element, value, shape.member);
        });
      }
    }
    function serializeScalar(xml, value, shape) {
      xml.addChildNode(
        new XmlText(shape.toWireFormat(value))
      );
    }
    function applyNamespaces(xml, shape, isRoot) {
      var uri, prefix = "xmlns";
      if (shape.xmlNamespaceUri) {
        uri = shape.xmlNamespaceUri;
        if (shape.xmlNamespacePrefix)
          prefix += ":" + shape.xmlNamespacePrefix;
      } else if (isRoot && shape.api.xmlNamespaceUri) {
        uri = shape.api.xmlNamespaceUri;
      }
      if (uri)
        xml.addAttribute(prefix, uri);
    }
    module2.exports = XmlBuilder;
  }
});

// node_modules/aws-sdk/lib/model/operation.js
var require_operation = __commonJS({
  "node_modules/aws-sdk/lib/model/operation.js"(exports2, module2) {
    "use strict";
    var Shape = require_shape();
    var util = require_util();
    var property = util.property;
    var memoizedProperty = util.memoizedProperty;
    function Operation(name, operation, options) {
      var self2 = this;
      options = options || {};
      property(this, "name", operation.name || name);
      property(this, "api", options.api, false);
      operation.http = operation.http || {};
      property(this, "endpoint", operation.endpoint);
      property(this, "httpMethod", operation.http.method || "POST");
      property(this, "httpPath", operation.http.requestUri || "/");
      property(this, "authtype", operation.authtype || "");
      property(
        this,
        "endpointDiscoveryRequired",
        operation.endpointdiscovery ? operation.endpointdiscovery.required ? "REQUIRED" : "OPTIONAL" : "NULL"
      );
      var httpChecksumRequired = operation.httpChecksumRequired || operation.httpChecksum && operation.httpChecksum.requestChecksumRequired;
      property(this, "httpChecksumRequired", httpChecksumRequired, false);
      memoizedProperty(this, "input", function() {
        if (!operation.input) {
          return new Shape.create({ type: "structure" }, options);
        }
        return Shape.create(operation.input, options);
      });
      memoizedProperty(this, "output", function() {
        if (!operation.output) {
          return new Shape.create({ type: "structure" }, options);
        }
        return Shape.create(operation.output, options);
      });
      memoizedProperty(this, "errors", function() {
        var list = [];
        if (!operation.errors)
          return null;
        for (var i = 0; i < operation.errors.length; i++) {
          list.push(Shape.create(operation.errors[i], options));
        }
        return list;
      });
      memoizedProperty(this, "paginator", function() {
        return options.api.paginators[name];
      });
      if (options.documentation) {
        property(this, "documentation", operation.documentation);
        property(this, "documentationUrl", operation.documentationUrl);
      }
      memoizedProperty(this, "idempotentMembers", function() {
        var idempotentMembers = [];
        var input = self2.input;
        var members = input.members;
        if (!input.members) {
          return idempotentMembers;
        }
        for (var name2 in members) {
          if (!members.hasOwnProperty(name2)) {
            continue;
          }
          if (members[name2].isIdempotent === true) {
            idempotentMembers.push(name2);
          }
        }
        return idempotentMembers;
      });
      memoizedProperty(this, "hasEventOutput", function() {
        var output = self2.output;
        return hasEventStream(output);
      });
    }
    function hasEventStream(topLevelShape) {
      var members = topLevelShape.members;
      var payload2 = topLevelShape.payload;
      if (!topLevelShape.members) {
        return false;
      }
      if (payload2) {
        var payloadMember = members[payload2];
        return payloadMember.isEventStream;
      }
      for (var name in members) {
        if (!members.hasOwnProperty(name)) {
          if (members[name].isEventStream === true) {
            return true;
          }
        }
      }
      return false;
    }
    module2.exports = Operation;
  }
});

// node_modules/aws-sdk/lib/model/paginator.js
var require_paginator = __commonJS({
  "node_modules/aws-sdk/lib/model/paginator.js"(exports2, module2) {
    "use strict";
    var property = require_util().property;
    function Paginator(name, paginator) {
      property(this, "inputToken", paginator.input_token);
      property(this, "limitKey", paginator.limit_key);
      property(this, "moreResults", paginator.more_results);
      property(this, "outputToken", paginator.output_token);
      property(this, "resultKey", paginator.result_key);
    }
    module2.exports = Paginator;
  }
});

// node_modules/aws-sdk/lib/model/resource_waiter.js
var require_resource_waiter = __commonJS({
  "node_modules/aws-sdk/lib/model/resource_waiter.js"(exports2, module2) {
    "use strict";
    var util = require_util();
    var property = util.property;
    function ResourceWaiter(name, waiter, options) {
      options = options || {};
      property(this, "name", name);
      property(this, "api", options.api, false);
      if (waiter.operation) {
        property(this, "operation", util.string.lowerFirst(waiter.operation));
      }
      var self2 = this;
      var keys = [
        "type",
        "description",
        "delay",
        "maxAttempts",
        "acceptors"
      ];
      keys.forEach(function(key) {
        var value = waiter[key];
        if (value) {
          property(self2, key, value);
        }
      });
    }
    module2.exports = ResourceWaiter;
  }
});

// node_modules/aws-sdk/apis/metadata.json
var require_metadata = __commonJS({
  "node_modules/aws-sdk/apis/metadata.json"(exports2, module2) {
    module2.exports = {
      acm: {
        name: "ACM",
        cors: true
      },
      apigateway: {
        name: "APIGateway",
        cors: true
      },
      applicationautoscaling: {
        prefix: "application-autoscaling",
        name: "ApplicationAutoScaling",
        cors: true
      },
      appstream: {
        name: "AppStream"
      },
      autoscaling: {
        name: "AutoScaling",
        cors: true
      },
      batch: {
        name: "Batch"
      },
      budgets: {
        name: "Budgets"
      },
      clouddirectory: {
        name: "CloudDirectory",
        versions: [
          "2016-05-10*"
        ]
      },
      cloudformation: {
        name: "CloudFormation",
        cors: true
      },
      cloudfront: {
        name: "CloudFront",
        versions: [
          "2013-05-12*",
          "2013-11-11*",
          "2014-05-31*",
          "2014-10-21*",
          "2014-11-06*",
          "2015-04-17*",
          "2015-07-27*",
          "2015-09-17*",
          "2016-01-13*",
          "2016-01-28*",
          "2016-08-01*",
          "2016-08-20*",
          "2016-09-07*",
          "2016-09-29*",
          "2016-11-25*",
          "2017-03-25*",
          "2017-10-30*",
          "2018-06-18*",
          "2018-11-05*",
          "2019-03-26*"
        ],
        cors: true
      },
      cloudhsm: {
        name: "CloudHSM",
        cors: true
      },
      cloudsearch: {
        name: "CloudSearch"
      },
      cloudsearchdomain: {
        name: "CloudSearchDomain"
      },
      cloudtrail: {
        name: "CloudTrail",
        cors: true
      },
      cloudwatch: {
        prefix: "monitoring",
        name: "CloudWatch",
        cors: true
      },
      cloudwatchevents: {
        prefix: "events",
        name: "CloudWatchEvents",
        versions: [
          "2014-02-03*"
        ],
        cors: true
      },
      cloudwatchlogs: {
        prefix: "logs",
        name: "CloudWatchLogs",
        cors: true
      },
      codebuild: {
        name: "CodeBuild",
        cors: true
      },
      codecommit: {
        name: "CodeCommit",
        cors: true
      },
      codedeploy: {
        name: "CodeDeploy",
        cors: true
      },
      codepipeline: {
        name: "CodePipeline",
        cors: true
      },
      cognitoidentity: {
        prefix: "cognito-identity",
        name: "CognitoIdentity",
        cors: true
      },
      cognitoidentityserviceprovider: {
        prefix: "cognito-idp",
        name: "CognitoIdentityServiceProvider",
        cors: true
      },
      cognitosync: {
        prefix: "cognito-sync",
        name: "CognitoSync",
        cors: true
      },
      configservice: {
        prefix: "config",
        name: "ConfigService",
        cors: true
      },
      cur: {
        name: "CUR",
        cors: true
      },
      datapipeline: {
        name: "DataPipeline"
      },
      devicefarm: {
        name: "DeviceFarm",
        cors: true
      },
      directconnect: {
        name: "DirectConnect",
        cors: true
      },
      directoryservice: {
        prefix: "ds",
        name: "DirectoryService"
      },
      discovery: {
        name: "Discovery"
      },
      dms: {
        name: "DMS"
      },
      dynamodb: {
        name: "DynamoDB",
        cors: true
      },
      dynamodbstreams: {
        prefix: "streams.dynamodb",
        name: "DynamoDBStreams",
        cors: true
      },
      ec2: {
        name: "EC2",
        versions: [
          "2013-06-15*",
          "2013-10-15*",
          "2014-02-01*",
          "2014-05-01*",
          "2014-06-15*",
          "2014-09-01*",
          "2014-10-01*",
          "2015-03-01*",
          "2015-04-15*",
          "2015-10-01*",
          "2016-04-01*",
          "2016-09-15*"
        ],
        cors: true
      },
      ecr: {
        name: "ECR",
        cors: true
      },
      ecs: {
        name: "ECS",
        cors: true
      },
      efs: {
        prefix: "elasticfilesystem",
        name: "EFS",
        cors: true
      },
      elasticache: {
        name: "ElastiCache",
        versions: [
          "2012-11-15*",
          "2014-03-24*",
          "2014-07-15*",
          "2014-09-30*"
        ],
        cors: true
      },
      elasticbeanstalk: {
        name: "ElasticBeanstalk",
        cors: true
      },
      elb: {
        prefix: "elasticloadbalancing",
        name: "ELB",
        cors: true
      },
      elbv2: {
        prefix: "elasticloadbalancingv2",
        name: "ELBv2",
        cors: true
      },
      emr: {
        prefix: "elasticmapreduce",
        name: "EMR",
        cors: true
      },
      es: {
        name: "ES"
      },
      elastictranscoder: {
        name: "ElasticTranscoder",
        cors: true
      },
      firehose: {
        name: "Firehose",
        cors: true
      },
      gamelift: {
        name: "GameLift",
        cors: true
      },
      glacier: {
        name: "Glacier"
      },
      health: {
        name: "Health"
      },
      iam: {
        name: "IAM",
        cors: true
      },
      importexport: {
        name: "ImportExport"
      },
      inspector: {
        name: "Inspector",
        versions: [
          "2015-08-18*"
        ],
        cors: true
      },
      iot: {
        name: "Iot",
        cors: true
      },
      iotdata: {
        prefix: "iot-data",
        name: "IotData",
        cors: true
      },
      kinesis: {
        name: "Kinesis",
        cors: true
      },
      kinesisanalytics: {
        name: "KinesisAnalytics"
      },
      kms: {
        name: "KMS",
        cors: true
      },
      lambda: {
        name: "Lambda",
        cors: true
      },
      lexruntime: {
        prefix: "runtime.lex",
        name: "LexRuntime",
        cors: true
      },
      lightsail: {
        name: "Lightsail"
      },
      machinelearning: {
        name: "MachineLearning",
        cors: true
      },
      marketplacecommerceanalytics: {
        name: "MarketplaceCommerceAnalytics",
        cors: true
      },
      marketplacemetering: {
        prefix: "meteringmarketplace",
        name: "MarketplaceMetering"
      },
      mturk: {
        prefix: "mturk-requester",
        name: "MTurk",
        cors: true
      },
      mobileanalytics: {
        name: "MobileAnalytics",
        cors: true
      },
      opsworks: {
        name: "OpsWorks",
        cors: true
      },
      opsworkscm: {
        name: "OpsWorksCM"
      },
      organizations: {
        name: "Organizations"
      },
      pinpoint: {
        name: "Pinpoint"
      },
      polly: {
        name: "Polly",
        cors: true
      },
      rds: {
        name: "RDS",
        versions: [
          "2014-09-01*"
        ],
        cors: true
      },
      redshift: {
        name: "Redshift",
        cors: true
      },
      rekognition: {
        name: "Rekognition",
        cors: true
      },
      resourcegroupstaggingapi: {
        name: "ResourceGroupsTaggingAPI"
      },
      route53: {
        name: "Route53",
        cors: true
      },
      route53domains: {
        name: "Route53Domains",
        cors: true
      },
      s3: {
        name: "S3",
        dualstackAvailable: true,
        cors: true
      },
      s3control: {
        name: "S3Control",
        dualstackAvailable: true,
        xmlNoDefaultLists: true
      },
      servicecatalog: {
        name: "ServiceCatalog",
        cors: true
      },
      ses: {
        prefix: "email",
        name: "SES",
        cors: true
      },
      shield: {
        name: "Shield"
      },
      simpledb: {
        prefix: "sdb",
        name: "SimpleDB"
      },
      sms: {
        name: "SMS"
      },
      snowball: {
        name: "Snowball"
      },
      sns: {
        name: "SNS",
        cors: true
      },
      sqs: {
        name: "SQS",
        cors: true
      },
      ssm: {
        name: "SSM",
        cors: true
      },
      storagegateway: {
        name: "StorageGateway",
        cors: true
      },
      stepfunctions: {
        prefix: "states",
        name: "StepFunctions"
      },
      sts: {
        name: "STS",
        cors: true
      },
      support: {
        name: "Support"
      },
      swf: {
        name: "SWF"
      },
      xray: {
        name: "XRay",
        cors: true
      },
      waf: {
        name: "WAF",
        cors: true
      },
      wafregional: {
        prefix: "waf-regional",
        name: "WAFRegional"
      },
      workdocs: {
        name: "WorkDocs",
        cors: true
      },
      workspaces: {
        name: "WorkSpaces"
      },
      codestar: {
        name: "CodeStar"
      },
      lexmodelbuildingservice: {
        prefix: "lex-models",
        name: "LexModelBuildingService",
        cors: true
      },
      marketplaceentitlementservice: {
        prefix: "entitlement.marketplace",
        name: "MarketplaceEntitlementService"
      },
      athena: {
        name: "Athena",
        cors: true
      },
      greengrass: {
        name: "Greengrass"
      },
      dax: {
        name: "DAX"
      },
      migrationhub: {
        prefix: "AWSMigrationHub",
        name: "MigrationHub"
      },
      cloudhsmv2: {
        name: "CloudHSMV2",
        cors: true
      },
      glue: {
        name: "Glue"
      },
      mobile: {
        name: "Mobile"
      },
      pricing: {
        name: "Pricing",
        cors: true
      },
      costexplorer: {
        prefix: "ce",
        name: "CostExplorer",
        cors: true
      },
      mediaconvert: {
        name: "MediaConvert"
      },
      medialive: {
        name: "MediaLive"
      },
      mediapackage: {
        name: "MediaPackage"
      },
      mediastore: {
        name: "MediaStore"
      },
      mediastoredata: {
        prefix: "mediastore-data",
        name: "MediaStoreData",
        cors: true
      },
      appsync: {
        name: "AppSync"
      },
      guardduty: {
        name: "GuardDuty"
      },
      mq: {
        name: "MQ"
      },
      comprehend: {
        name: "Comprehend",
        cors: true
      },
      iotjobsdataplane: {
        prefix: "iot-jobs-data",
        name: "IoTJobsDataPlane"
      },
      kinesisvideoarchivedmedia: {
        prefix: "kinesis-video-archived-media",
        name: "KinesisVideoArchivedMedia",
        cors: true
      },
      kinesisvideomedia: {
        prefix: "kinesis-video-media",
        name: "KinesisVideoMedia",
        cors: true
      },
      kinesisvideo: {
        name: "KinesisVideo",
        cors: true
      },
      sagemakerruntime: {
        prefix: "runtime.sagemaker",
        name: "SageMakerRuntime"
      },
      sagemaker: {
        name: "SageMaker"
      },
      translate: {
        name: "Translate",
        cors: true
      },
      resourcegroups: {
        prefix: "resource-groups",
        name: "ResourceGroups",
        cors: true
      },
      alexaforbusiness: {
        name: "AlexaForBusiness"
      },
      cloud9: {
        name: "Cloud9"
      },
      serverlessapplicationrepository: {
        prefix: "serverlessrepo",
        name: "ServerlessApplicationRepository"
      },
      servicediscovery: {
        name: "ServiceDiscovery"
      },
      workmail: {
        name: "WorkMail"
      },
      autoscalingplans: {
        prefix: "autoscaling-plans",
        name: "AutoScalingPlans"
      },
      transcribeservice: {
        prefix: "transcribe",
        name: "TranscribeService"
      },
      connect: {
        name: "Connect",
        cors: true
      },
      acmpca: {
        prefix: "acm-pca",
        name: "ACMPCA"
      },
      fms: {
        name: "FMS"
      },
      secretsmanager: {
        name: "SecretsManager",
        cors: true
      },
      iotanalytics: {
        name: "IoTAnalytics",
        cors: true
      },
      iot1clickdevicesservice: {
        prefix: "iot1click-devices",
        name: "IoT1ClickDevicesService"
      },
      iot1clickprojects: {
        prefix: "iot1click-projects",
        name: "IoT1ClickProjects"
      },
      pi: {
        name: "PI"
      },
      neptune: {
        name: "Neptune"
      },
      mediatailor: {
        name: "MediaTailor"
      },
      eks: {
        name: "EKS"
      },
      dlm: {
        name: "DLM"
      },
      signer: {
        name: "Signer"
      },
      chime: {
        name: "Chime"
      },
      pinpointemail: {
        prefix: "pinpoint-email",
        name: "PinpointEmail"
      },
      ram: {
        name: "RAM"
      },
      route53resolver: {
        name: "Route53Resolver"
      },
      pinpointsmsvoice: {
        prefix: "sms-voice",
        name: "PinpointSMSVoice"
      },
      quicksight: {
        name: "QuickSight"
      },
      rdsdataservice: {
        prefix: "rds-data",
        name: "RDSDataService"
      },
      amplify: {
        name: "Amplify"
      },
      datasync: {
        name: "DataSync"
      },
      robomaker: {
        name: "RoboMaker"
      },
      transfer: {
        name: "Transfer"
      },
      globalaccelerator: {
        name: "GlobalAccelerator"
      },
      comprehendmedical: {
        name: "ComprehendMedical",
        cors: true
      },
      kinesisanalyticsv2: {
        name: "KinesisAnalyticsV2"
      },
      mediaconnect: {
        name: "MediaConnect"
      },
      fsx: {
        name: "FSx"
      },
      securityhub: {
        name: "SecurityHub"
      },
      appmesh: {
        name: "AppMesh",
        versions: [
          "2018-10-01*"
        ]
      },
      licensemanager: {
        prefix: "license-manager",
        name: "LicenseManager"
      },
      kafka: {
        name: "Kafka"
      },
      apigatewaymanagementapi: {
        name: "ApiGatewayManagementApi"
      },
      apigatewayv2: {
        name: "ApiGatewayV2"
      },
      docdb: {
        name: "DocDB"
      },
      backup: {
        name: "Backup"
      },
      worklink: {
        name: "WorkLink"
      },
      textract: {
        name: "Textract"
      },
      managedblockchain: {
        name: "ManagedBlockchain"
      },
      mediapackagevod: {
        prefix: "mediapackage-vod",
        name: "MediaPackageVod"
      },
      groundstation: {
        name: "GroundStation"
      },
      iotthingsgraph: {
        name: "IoTThingsGraph"
      },
      iotevents: {
        name: "IoTEvents"
      },
      ioteventsdata: {
        prefix: "iotevents-data",
        name: "IoTEventsData"
      },
      personalize: {
        name: "Personalize",
        cors: true
      },
      personalizeevents: {
        prefix: "personalize-events",
        name: "PersonalizeEvents",
        cors: true
      },
      personalizeruntime: {
        prefix: "personalize-runtime",
        name: "PersonalizeRuntime",
        cors: true
      },
      applicationinsights: {
        prefix: "application-insights",
        name: "ApplicationInsights"
      },
      servicequotas: {
        prefix: "service-quotas",
        name: "ServiceQuotas"
      },
      ec2instanceconnect: {
        prefix: "ec2-instance-connect",
        name: "EC2InstanceConnect"
      },
      eventbridge: {
        name: "EventBridge"
      },
      lakeformation: {
        name: "LakeFormation"
      },
      forecastservice: {
        prefix: "forecast",
        name: "ForecastService",
        cors: true
      },
      forecastqueryservice: {
        prefix: "forecastquery",
        name: "ForecastQueryService",
        cors: true
      },
      qldb: {
        name: "QLDB"
      },
      qldbsession: {
        prefix: "qldb-session",
        name: "QLDBSession"
      },
      workmailmessageflow: {
        name: "WorkMailMessageFlow"
      },
      codestarnotifications: {
        prefix: "codestar-notifications",
        name: "CodeStarNotifications"
      },
      savingsplans: {
        name: "SavingsPlans"
      },
      sso: {
        name: "SSO"
      },
      ssooidc: {
        prefix: "sso-oidc",
        name: "SSOOIDC"
      },
      marketplacecatalog: {
        prefix: "marketplace-catalog",
        name: "MarketplaceCatalog",
        cors: true
      },
      dataexchange: {
        name: "DataExchange"
      },
      sesv2: {
        name: "SESV2"
      },
      migrationhubconfig: {
        prefix: "migrationhub-config",
        name: "MigrationHubConfig"
      },
      connectparticipant: {
        name: "ConnectParticipant"
      },
      appconfig: {
        name: "AppConfig"
      },
      iotsecuretunneling: {
        name: "IoTSecureTunneling"
      },
      wafv2: {
        name: "WAFV2"
      },
      elasticinference: {
        prefix: "elastic-inference",
        name: "ElasticInference"
      },
      imagebuilder: {
        name: "Imagebuilder"
      },
      schemas: {
        name: "Schemas"
      },
      accessanalyzer: {
        name: "AccessAnalyzer"
      },
      codegurureviewer: {
        prefix: "codeguru-reviewer",
        name: "CodeGuruReviewer"
      },
      codeguruprofiler: {
        name: "CodeGuruProfiler"
      },
      computeoptimizer: {
        prefix: "compute-optimizer",
        name: "ComputeOptimizer"
      },
      frauddetector: {
        name: "FraudDetector"
      },
      kendra: {
        name: "Kendra"
      },
      networkmanager: {
        name: "NetworkManager"
      },
      outposts: {
        name: "Outposts"
      },
      augmentedairuntime: {
        prefix: "sagemaker-a2i-runtime",
        name: "AugmentedAIRuntime"
      },
      ebs: {
        name: "EBS"
      },
      kinesisvideosignalingchannels: {
        prefix: "kinesis-video-signaling",
        name: "KinesisVideoSignalingChannels",
        cors: true
      },
      detective: {
        name: "Detective"
      },
      codestarconnections: {
        prefix: "codestar-connections",
        name: "CodeStarconnections"
      },
      synthetics: {
        name: "Synthetics"
      },
      iotsitewise: {
        name: "IoTSiteWise"
      },
      macie2: {
        name: "Macie2"
      },
      codeartifact: {
        name: "CodeArtifact"
      },
      honeycode: {
        name: "Honeycode"
      },
      ivs: {
        name: "IVS"
      },
      braket: {
        name: "Braket"
      },
      identitystore: {
        name: "IdentityStore"
      },
      appflow: {
        name: "Appflow"
      },
      redshiftdata: {
        prefix: "redshift-data",
        name: "RedshiftData"
      },
      ssoadmin: {
        prefix: "sso-admin",
        name: "SSOAdmin"
      },
      timestreamquery: {
        prefix: "timestream-query",
        name: "TimestreamQuery"
      },
      timestreamwrite: {
        prefix: "timestream-write",
        name: "TimestreamWrite"
      },
      s3outposts: {
        name: "S3Outposts"
      },
      databrew: {
        name: "DataBrew"
      },
      servicecatalogappregistry: {
        prefix: "servicecatalog-appregistry",
        name: "ServiceCatalogAppRegistry"
      },
      networkfirewall: {
        prefix: "network-firewall",
        name: "NetworkFirewall"
      },
      mwaa: {
        name: "MWAA"
      },
      amplifybackend: {
        name: "AmplifyBackend"
      },
      appintegrations: {
        name: "AppIntegrations"
      },
      connectcontactlens: {
        prefix: "connect-contact-lens",
        name: "ConnectContactLens"
      },
      devopsguru: {
        prefix: "devops-guru",
        name: "DevOpsGuru"
      },
      ecrpublic: {
        prefix: "ecr-public",
        name: "ECRPUBLIC"
      },
      lookoutvision: {
        name: "LookoutVision"
      },
      sagemakerfeaturestoreruntime: {
        prefix: "sagemaker-featurestore-runtime",
        name: "SageMakerFeatureStoreRuntime"
      },
      customerprofiles: {
        prefix: "customer-profiles",
        name: "CustomerProfiles"
      },
      auditmanager: {
        name: "AuditManager"
      },
      emrcontainers: {
        prefix: "emr-containers",
        name: "EMRcontainers"
      },
      healthlake: {
        name: "HealthLake"
      },
      sagemakeredge: {
        prefix: "sagemaker-edge",
        name: "SagemakerEdge"
      },
      amp: {
        name: "Amp",
        cors: true
      },
      greengrassv2: {
        name: "GreengrassV2"
      },
      iotdeviceadvisor: {
        name: "IotDeviceAdvisor"
      },
      iotfleethub: {
        name: "IoTFleetHub"
      },
      iotwireless: {
        name: "IoTWireless"
      },
      location: {
        name: "Location",
        cors: true
      },
      wellarchitected: {
        name: "WellArchitected"
      },
      lexmodelsv2: {
        prefix: "models.lex.v2",
        name: "LexModelsV2"
      },
      lexruntimev2: {
        prefix: "runtime.lex.v2",
        name: "LexRuntimeV2",
        cors: true
      },
      fis: {
        name: "Fis"
      },
      lookoutmetrics: {
        name: "LookoutMetrics"
      },
      mgn: {
        name: "Mgn"
      },
      lookoutequipment: {
        name: "LookoutEquipment"
      },
      nimble: {
        name: "Nimble"
      },
      finspace: {
        name: "Finspace"
      },
      finspacedata: {
        prefix: "finspace-data",
        name: "Finspacedata"
      },
      ssmcontacts: {
        prefix: "ssm-contacts",
        name: "SSMContacts"
      },
      ssmincidents: {
        prefix: "ssm-incidents",
        name: "SSMIncidents"
      },
      applicationcostprofiler: {
        name: "ApplicationCostProfiler"
      },
      apprunner: {
        name: "AppRunner"
      },
      proton: {
        name: "Proton"
      },
      route53recoverycluster: {
        prefix: "route53-recovery-cluster",
        name: "Route53RecoveryCluster"
      },
      route53recoverycontrolconfig: {
        prefix: "route53-recovery-control-config",
        name: "Route53RecoveryControlConfig"
      },
      route53recoveryreadiness: {
        prefix: "route53-recovery-readiness",
        name: "Route53RecoveryReadiness"
      },
      chimesdkidentity: {
        prefix: "chime-sdk-identity",
        name: "ChimeSDKIdentity"
      },
      chimesdkmessaging: {
        prefix: "chime-sdk-messaging",
        name: "ChimeSDKMessaging"
      },
      snowdevicemanagement: {
        prefix: "snow-device-management",
        name: "SnowDeviceManagement"
      },
      memorydb: {
        name: "MemoryDB"
      },
      opensearch: {
        name: "OpenSearch"
      },
      kafkaconnect: {
        name: "KafkaConnect"
      },
      voiceid: {
        prefix: "voice-id",
        name: "VoiceID"
      },
      wisdom: {
        name: "Wisdom"
      },
      account: {
        name: "Account"
      },
      cloudcontrol: {
        name: "CloudControl"
      },
      grafana: {
        name: "Grafana"
      },
      panorama: {
        name: "Panorama"
      },
      chimesdkmeetings: {
        prefix: "chime-sdk-meetings",
        name: "ChimeSDKMeetings"
      },
      resiliencehub: {
        name: "Resiliencehub"
      },
      migrationhubstrategy: {
        name: "MigrationHubStrategy"
      },
      appconfigdata: {
        name: "AppConfigData"
      },
      drs: {
        name: "Drs"
      },
      migrationhubrefactorspaces: {
        prefix: "migration-hub-refactor-spaces",
        name: "MigrationHubRefactorSpaces"
      },
      evidently: {
        name: "Evidently"
      },
      inspector2: {
        name: "Inspector2"
      },
      rbin: {
        name: "Rbin"
      },
      rum: {
        name: "RUM"
      },
      backupgateway: {
        prefix: "backup-gateway",
        name: "BackupGateway"
      },
      iottwinmaker: {
        name: "IoTTwinMaker"
      },
      workspacesweb: {
        prefix: "workspaces-web",
        name: "WorkSpacesWeb"
      },
      amplifyuibuilder: {
        name: "AmplifyUIBuilder"
      },
      keyspaces: {
        name: "Keyspaces"
      },
      billingconductor: {
        name: "Billingconductor"
      },
      pinpointsmsvoicev2: {
        prefix: "pinpoint-sms-voice-v2",
        name: "PinpointSMSVoiceV2"
      },
      ivschat: {
        name: "Ivschat"
      },
      chimesdkmediapipelines: {
        prefix: "chime-sdk-media-pipelines",
        name: "ChimeSDKMediaPipelines"
      },
      emrserverless: {
        prefix: "emr-serverless",
        name: "EMRServerless"
      },
      m2: {
        name: "M2"
      },
      connectcampaigns: {
        name: "ConnectCampaigns"
      },
      redshiftserverless: {
        prefix: "redshift-serverless",
        name: "RedshiftServerless"
      },
      rolesanywhere: {
        name: "RolesAnywhere"
      },
      licensemanagerusersubscriptions: {
        prefix: "license-manager-user-subscriptions",
        name: "LicenseManagerUserSubscriptions"
      },
      backupstorage: {
        name: "BackupStorage"
      },
      privatenetworks: {
        name: "PrivateNetworks"
      },
      supportapp: {
        prefix: "support-app",
        name: "SupportApp"
      },
      controltower: {
        name: "ControlTower"
      },
      iotfleetwise: {
        name: "IoTFleetWise"
      },
      migrationhuborchestrator: {
        name: "MigrationHubOrchestrator"
      },
      connectcases: {
        name: "ConnectCases"
      },
      resourceexplorer2: {
        prefix: "resource-explorer-2",
        name: "ResourceExplorer2"
      },
      scheduler: {
        name: "Scheduler"
      },
      chimesdkvoice: {
        prefix: "chime-sdk-voice",
        name: "ChimeSDKVoice"
      },
      iotroborunner: {
        prefix: "iot-roborunner",
        name: "IoTRoboRunner"
      },
      ssmsap: {
        prefix: "ssm-sap",
        name: "SsmSap"
      },
      oam: {
        name: "OAM"
      },
      arczonalshift: {
        prefix: "arc-zonal-shift",
        name: "ARCZonalShift"
      },
      omics: {
        name: "Omics"
      },
      opensearchserverless: {
        name: "OpenSearchServerless"
      },
      securitylake: {
        name: "SecurityLake"
      },
      simspaceweaver: {
        name: "SimSpaceWeaver"
      },
      docdbelastic: {
        prefix: "docdb-elastic",
        name: "DocDBElastic"
      },
      sagemakergeospatial: {
        prefix: "sagemaker-geospatial",
        name: "SageMakerGeospatial"
      },
      codecatalyst: {
        name: "CodeCatalyst"
      },
      pipes: {
        name: "Pipes"
      },
      sagemakermetrics: {
        prefix: "sagemaker-metrics",
        name: "SageMakerMetrics"
      },
      kinesisvideowebrtcstorage: {
        prefix: "kinesis-video-webrtc-storage",
        name: "KinesisVideoWebRTCStorage"
      },
      licensemanagerlinuxsubscriptions: {
        prefix: "license-manager-linux-subscriptions",
        name: "LicenseManagerLinuxSubscriptions"
      },
      kendraranking: {
        prefix: "kendra-ranking",
        name: "KendraRanking"
      },
      cleanrooms: {
        name: "CleanRooms"
      },
      cloudtraildata: {
        prefix: "cloudtrail-data",
        name: "CloudTrailData"
      },
      tnb: {
        name: "Tnb"
      },
      internetmonitor: {
        name: "InternetMonitor"
      },
      ivsrealtime: {
        prefix: "ivs-realtime",
        name: "IVSRealTime"
      },
      vpclattice: {
        prefix: "vpc-lattice",
        name: "VPCLattice"
      },
      osis: {
        name: "OSIS"
      },
      mediapackagev2: {
        name: "MediaPackageV2"
      },
      paymentcryptography: {
        prefix: "payment-cryptography",
        name: "PaymentCryptography"
      },
      paymentcryptographydata: {
        prefix: "payment-cryptography-data",
        name: "PaymentCryptographyData"
      },
      codegurusecurity: {
        prefix: "codeguru-security",
        name: "CodeGuruSecurity"
      },
      verifiedpermissions: {
        name: "VerifiedPermissions"
      },
      appfabric: {
        name: "AppFabric"
      },
      medicalimaging: {
        prefix: "medical-imaging",
        name: "MedicalImaging"
      },
      entityresolution: {
        name: "EntityResolution"
      },
      managedblockchainquery: {
        prefix: "managedblockchain-query",
        name: "ManagedBlockchainQuery"
      },
      neptunedata: {
        name: "Neptunedata"
      },
      pcaconnectorad: {
        prefix: "pca-connector-ad",
        name: "PcaConnectorAd"
      },
      bedrock: {
        name: "Bedrock"
      },
      bedrockruntime: {
        prefix: "bedrock-runtime",
        name: "BedrockRuntime"
      },
      datazone: {
        name: "DataZone"
      },
      launchwizard: {
        prefix: "launch-wizard",
        name: "LaunchWizard"
      },
      trustedadvisor: {
        name: "TrustedAdvisor"
      },
      cloudfrontkeyvaluestore: {
        prefix: "cloudfront-keyvaluestore",
        name: "CloudFrontKeyValueStore"
      },
      inspectorscan: {
        prefix: "inspector-scan",
        name: "InspectorScan"
      },
      bcmdataexports: {
        prefix: "bcm-data-exports",
        name: "BCMDataExports"
      },
      costoptimizationhub: {
        prefix: "cost-optimization-hub",
        name: "CostOptimizationHub"
      },
      eksauth: {
        prefix: "eks-auth",
        name: "EKSAuth"
      },
      freetier: {
        name: "FreeTier"
      },
      repostspace: {
        name: "Repostspace"
      },
      workspacesthinclient: {
        prefix: "workspaces-thin-client",
        name: "WorkSpacesThinClient"
      },
      b2bi: {
        name: "B2bi"
      },
      bedrockagent: {
        prefix: "bedrock-agent",
        name: "BedrockAgent"
      },
      bedrockagentruntime: {
        prefix: "bedrock-agent-runtime",
        name: "BedrockAgentRuntime"
      },
      qbusiness: {
        name: "QBusiness"
      },
      qconnect: {
        name: "QConnect"
      },
      cleanroomsml: {
        name: "CleanRoomsML"
      },
      marketplaceagreement: {
        prefix: "marketplace-agreement",
        name: "MarketplaceAgreement"
      },
      marketplacedeployment: {
        prefix: "marketplace-deployment",
        name: "MarketplaceDeployment"
      },
      neptunegraph: {
        prefix: "neptune-graph",
        name: "NeptuneGraph"
      },
      networkmonitor: {
        name: "NetworkMonitor"
      }
    };
  }
});

// node_modules/aws-sdk/lib/model/api.js
var require_api = __commonJS({
  "node_modules/aws-sdk/lib/model/api.js"(exports2, module2) {
    "use strict";
    var Collection = require_collection();
    var Operation = require_operation();
    var Shape = require_shape();
    var Paginator = require_paginator();
    var ResourceWaiter = require_resource_waiter();
    var metadata = require_metadata();
    var util = require_util();
    var property = util.property;
    var memoizedProperty = util.memoizedProperty;
    function Api(api, options) {
      var self2 = this;
      api = api || {};
      options = options || {};
      options.api = this;
      api.metadata = api.metadata || {};
      var serviceIdentifier = options.serviceIdentifier;
      delete options.serviceIdentifier;
      property(this, "isApi", true, false);
      property(this, "apiVersion", api.metadata.apiVersion);
      property(this, "endpointPrefix", api.metadata.endpointPrefix);
      property(this, "signingName", api.metadata.signingName);
      property(this, "globalEndpoint", api.metadata.globalEndpoint);
      property(this, "signatureVersion", api.metadata.signatureVersion);
      property(this, "jsonVersion", api.metadata.jsonVersion);
      property(this, "targetPrefix", api.metadata.targetPrefix);
      property(this, "protocol", api.metadata.protocol);
      property(this, "timestampFormat", api.metadata.timestampFormat);
      property(this, "xmlNamespaceUri", api.metadata.xmlNamespace);
      property(this, "abbreviation", api.metadata.serviceAbbreviation);
      property(this, "fullName", api.metadata.serviceFullName);
      property(this, "serviceId", api.metadata.serviceId);
      if (serviceIdentifier && metadata[serviceIdentifier]) {
        property(this, "xmlNoDefaultLists", metadata[serviceIdentifier].xmlNoDefaultLists, false);
      }
      memoizedProperty(this, "className", function() {
        var name = api.metadata.serviceAbbreviation || api.metadata.serviceFullName;
        if (!name)
          return null;
        name = name.replace(/^Amazon|AWS\s*|\(.*|\s+|\W+/g, "");
        if (name === "ElasticLoadBalancing")
          name = "ELB";
        return name;
      });
      function addEndpointOperation(name, operation) {
        if (operation.endpointoperation === true) {
          property(self2, "endpointOperation", util.string.lowerFirst(name));
        }
        if (operation.endpointdiscovery && !self2.hasRequiredEndpointDiscovery) {
          property(
            self2,
            "hasRequiredEndpointDiscovery",
            operation.endpointdiscovery.required === true
          );
        }
      }
      property(this, "operations", new Collection(api.operations, options, function(name, operation) {
        return new Operation(name, operation, options);
      }, util.string.lowerFirst, addEndpointOperation));
      property(this, "shapes", new Collection(api.shapes, options, function(name, shape) {
        return Shape.create(shape, options);
      }));
      property(this, "paginators", new Collection(api.paginators, options, function(name, paginator) {
        return new Paginator(name, paginator, options);
      }));
      property(this, "waiters", new Collection(api.waiters, options, function(name, waiter) {
        return new ResourceWaiter(name, waiter, options);
      }, util.string.lowerFirst));
      if (options.documentation) {
        property(this, "documentation", api.documentation);
        property(this, "documentationUrl", api.documentationUrl);
      }
      property(this, "awsQueryCompatible", api.metadata.awsQueryCompatible);
    }
    module2.exports = Api;
  }
});

// node_modules/aws-sdk/lib/api_loader.js
var require_api_loader = __commonJS({
  "node_modules/aws-sdk/lib/api_loader.js"(exports2, module2) {
    "use strict";
    function apiLoader(svc, version) {
      if (!apiLoader.services.hasOwnProperty(svc)) {
        throw new Error("InvalidService: Failed to load api for " + svc);
      }
      return apiLoader.services[svc][version];
    }
    apiLoader.services = {};
    module2.exports = apiLoader;
  }
});

// node_modules/aws-sdk/vendor/endpoint-cache/utils/LRU.js
var require_LRU = __commonJS({
  "node_modules/aws-sdk/vendor/endpoint-cache/utils/LRU.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var LinkedListNode = (
      /** @class */
      /* @__PURE__ */ function() {
        function LinkedListNode2(key, value) {
          this.key = key;
          this.value = value;
        }
        return LinkedListNode2;
      }()
    );
    var LRUCache = (
      /** @class */
      function() {
        function LRUCache2(size) {
          this.nodeMap = {};
          this.size = 0;
          if (typeof size !== "number" || size < 1) {
            throw new Error("Cache size can only be positive number");
          }
          this.sizeLimit = size;
        }
        Object.defineProperty(LRUCache2.prototype, "length", {
          get: function() {
            return this.size;
          },
          enumerable: true,
          configurable: true
        });
        LRUCache2.prototype.prependToList = function(node) {
          if (!this.headerNode) {
            this.tailNode = node;
          } else {
            this.headerNode.prev = node;
            node.next = this.headerNode;
          }
          this.headerNode = node;
          this.size++;
        };
        LRUCache2.prototype.removeFromTail = function() {
          if (!this.tailNode) {
            return void 0;
          }
          var node = this.tailNode;
          var prevNode = node.prev;
          if (prevNode) {
            prevNode.next = void 0;
          }
          node.prev = void 0;
          this.tailNode = prevNode;
          this.size--;
          return node;
        };
        LRUCache2.prototype.detachFromList = function(node) {
          if (this.headerNode === node) {
            this.headerNode = node.next;
          }
          if (this.tailNode === node) {
            this.tailNode = node.prev;
          }
          if (node.prev) {
            node.prev.next = node.next;
          }
          if (node.next) {
            node.next.prev = node.prev;
          }
          node.next = void 0;
          node.prev = void 0;
          this.size--;
        };
        LRUCache2.prototype.get = function(key) {
          if (this.nodeMap[key]) {
            var node = this.nodeMap[key];
            this.detachFromList(node);
            this.prependToList(node);
            return node.value;
          }
        };
        LRUCache2.prototype.remove = function(key) {
          if (this.nodeMap[key]) {
            var node = this.nodeMap[key];
            this.detachFromList(node);
            delete this.nodeMap[key];
          }
        };
        LRUCache2.prototype.put = function(key, value) {
          if (this.nodeMap[key]) {
            this.remove(key);
          } else if (this.size === this.sizeLimit) {
            var tailNode = this.removeFromTail();
            var key_1 = tailNode.key;
            delete this.nodeMap[key_1];
          }
          var newNode = new LinkedListNode(key, value);
          this.nodeMap[key] = newNode;
          this.prependToList(newNode);
        };
        LRUCache2.prototype.empty = function() {
          var keys = Object.keys(this.nodeMap);
          for (var i = 0; i < keys.length; i++) {
            var key = keys[i];
            var node = this.nodeMap[key];
            this.detachFromList(node);
            delete this.nodeMap[key];
          }
        };
        return LRUCache2;
      }()
    );
    exports2.LRUCache = LRUCache;
  }
});

// node_modules/aws-sdk/vendor/endpoint-cache/index.js
var require_endpoint_cache = __commonJS({
  "node_modules/aws-sdk/vendor/endpoint-cache/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var LRU_1 = require_LRU();
    var CACHE_SIZE = 1e3;
    var EndpointCache = (
      /** @class */
      function() {
        function EndpointCache2(maxSize) {
          if (maxSize === void 0) {
            maxSize = CACHE_SIZE;
          }
          this.maxSize = maxSize;
          this.cache = new LRU_1.LRUCache(maxSize);
        }
        ;
        Object.defineProperty(EndpointCache2.prototype, "size", {
          get: function() {
            return this.cache.length;
          },
          enumerable: true,
          configurable: true
        });
        EndpointCache2.prototype.put = function(key, value) {
          var keyString = typeof key !== "string" ? EndpointCache2.getKeyString(key) : key;
          var endpointRecord = this.populateValue(value);
          this.cache.put(keyString, endpointRecord);
        };
        EndpointCache2.prototype.get = function(key) {
          var keyString = typeof key !== "string" ? EndpointCache2.getKeyString(key) : key;
          var now = Date.now();
          var records = this.cache.get(keyString);
          if (records) {
            for (var i = records.length - 1; i >= 0; i--) {
              var record = records[i];
              if (record.Expire < now) {
                records.splice(i, 1);
              }
            }
            if (records.length === 0) {
              this.cache.remove(keyString);
              return void 0;
            }
          }
          return records;
        };
        EndpointCache2.getKeyString = function(key) {
          var identifiers = [];
          var identifierNames = Object.keys(key).sort();
          for (var i = 0; i < identifierNames.length; i++) {
            var identifierName = identifierNames[i];
            if (key[identifierName] === void 0)
              continue;
            identifiers.push(key[identifierName]);
          }
          return identifiers.join(" ");
        };
        EndpointCache2.prototype.populateValue = function(endpoints) {
          var now = Date.now();
          return endpoints.map(function(endpoint) {
            return {
              Address: endpoint.Address || "",
              Expire: now + (endpoint.CachePeriodInMinutes || 1) * 60 * 1e3
            };
          });
        };
        EndpointCache2.prototype.empty = function() {
          this.cache.empty();
        };
        EndpointCache2.prototype.remove = function(key) {
          var keyString = typeof key !== "string" ? EndpointCache2.getKeyString(key) : key;
          this.cache.remove(keyString);
        };
        return EndpointCache2;
      }()
    );
    exports2.EndpointCache = EndpointCache;
  }
});

// node_modules/aws-sdk/lib/sequential_executor.js
var require_sequential_executor = __commonJS({
  "node_modules/aws-sdk/lib/sequential_executor.js"(exports2, module2) {
    "use strict";
    var AWS2 = require_core();
    AWS2.SequentialExecutor = AWS2.util.inherit({
      constructor: function SequentialExecutor() {
        this._events = {};
      },
      /**
       * @api private
       */
      listeners: function listeners(eventName) {
        return this._events[eventName] ? this._events[eventName].slice(0) : [];
      },
      on: function on(eventName, listener, toHead) {
        if (this._events[eventName]) {
          toHead ? this._events[eventName].unshift(listener) : this._events[eventName].push(listener);
        } else {
          this._events[eventName] = [listener];
        }
        return this;
      },
      onAsync: function onAsync(eventName, listener, toHead) {
        listener._isAsync = true;
        return this.on(eventName, listener, toHead);
      },
      removeListener: function removeListener(eventName, listener) {
        var listeners = this._events[eventName];
        if (listeners) {
          var length = listeners.length;
          var position = -1;
          for (var i = 0; i < length; ++i) {
            if (listeners[i] === listener) {
              position = i;
            }
          }
          if (position > -1) {
            listeners.splice(position, 1);
          }
        }
        return this;
      },
      removeAllListeners: function removeAllListeners(eventName) {
        if (eventName) {
          delete this._events[eventName];
        } else {
          this._events = {};
        }
        return this;
      },
      /**
       * @api private
       */
      emit: function emit(eventName, eventArgs, doneCallback) {
        if (!doneCallback)
          doneCallback = function() {
          };
        var listeners = this.listeners(eventName);
        var count = listeners.length;
        this.callListeners(listeners, eventArgs, doneCallback);
        return count > 0;
      },
      /**
       * @api private
       */
      callListeners: function callListeners(listeners, args, doneCallback, prevError) {
        var self2 = this;
        var error = prevError || null;
        function callNextListener(err) {
          if (err) {
            error = AWS2.util.error(error || new Error(), err);
            if (self2._haltHandlersOnError) {
              return doneCallback.call(self2, error);
            }
          }
          self2.callListeners(listeners, args, doneCallback, error);
        }
        while (listeners.length > 0) {
          var listener = listeners.shift();
          if (listener._isAsync) {
            listener.apply(self2, args.concat([callNextListener]));
            return;
          } else {
            try {
              listener.apply(self2, args);
            } catch (err) {
              error = AWS2.util.error(error || new Error(), err);
            }
            if (error && self2._haltHandlersOnError) {
              doneCallback.call(self2, error);
              return;
            }
          }
        }
        doneCallback.call(self2, error);
      },
      /**
       * Adds or copies a set of listeners from another list of
       * listeners or SequentialExecutor object.
       *
       * @param listeners [map<String,Array<Function>>, AWS.SequentialExecutor]
       *   a list of events and callbacks, or an event emitter object
       *   containing listeners to add to this emitter object.
       * @return [AWS.SequentialExecutor] the emitter object, for chaining.
       * @example Adding listeners from a map of listeners
       *   emitter.addListeners({
       *     event1: [function() { ... }, function() { ... }],
       *     event2: [function() { ... }]
       *   });
       *   emitter.emit('event1'); // emitter has event1
       *   emitter.emit('event2'); // emitter has event2
       * @example Adding listeners from another emitter object
       *   var emitter1 = new AWS.SequentialExecutor();
       *   emitter1.on('event1', function() { ... });
       *   emitter1.on('event2', function() { ... });
       *   var emitter2 = new AWS.SequentialExecutor();
       *   emitter2.addListeners(emitter1);
       *   emitter2.emit('event1'); // emitter2 has event1
       *   emitter2.emit('event2'); // emitter2 has event2
       */
      addListeners: function addListeners(listeners) {
        var self2 = this;
        if (listeners._events)
          listeners = listeners._events;
        AWS2.util.each(listeners, function(event, callbacks) {
          if (typeof callbacks === "function")
            callbacks = [callbacks];
          AWS2.util.arrayEach(callbacks, function(callback) {
            self2.on(event, callback);
          });
        });
        return self2;
      },
      /**
       * Registers an event with {on} and saves the callback handle function
       * as a property on the emitter object using a given `name`.
       *
       * @param name [String] the property name to set on this object containing
       *   the callback function handle so that the listener can be removed in
       *   the future.
       * @param (see on)
       * @return (see on)
       * @example Adding a named listener DATA_CALLBACK
       *   var listener = function() { doSomething(); };
       *   emitter.addNamedListener('DATA_CALLBACK', 'data', listener);
       *
       *   // the following prints: true
       *   console.log(emitter.DATA_CALLBACK == listener);
       */
      addNamedListener: function addNamedListener(name, eventName, callback, toHead) {
        this[name] = callback;
        this.addListener(eventName, callback, toHead);
        return this;
      },
      /**
       * @api private
       */
      addNamedAsyncListener: function addNamedAsyncListener(name, eventName, callback, toHead) {
        callback._isAsync = true;
        return this.addNamedListener(name, eventName, callback, toHead);
      },
      /**
       * Helper method to add a set of named listeners using
       * {addNamedListener}. The callback contains a parameter
       * with a handle to the `addNamedListener` method.
       *
       * @callback callback function(add)
       *   The callback function is called immediately in order to provide
       *   the `add` function to the block. This simplifies the addition of
       *   a large group of named listeners.
       *   @param add [Function] the {addNamedListener} function to call
       *     when registering listeners.
       * @example Adding a set of named listeners
       *   emitter.addNamedListeners(function(add) {
       *     add('DATA_CALLBACK', 'data', function() { ... });
       *     add('OTHER', 'otherEvent', function() { ... });
       *     add('LAST', 'lastEvent', function() { ... });
       *   });
       *
       *   // these properties are now set:
       *   emitter.DATA_CALLBACK;
       *   emitter.OTHER;
       *   emitter.LAST;
       */
      addNamedListeners: function addNamedListeners(callback) {
        var self2 = this;
        callback(
          function() {
            self2.addNamedListener.apply(self2, arguments);
          },
          function() {
            self2.addNamedAsyncListener.apply(self2, arguments);
          }
        );
        return this;
      }
    });
    AWS2.SequentialExecutor.prototype.addListener = AWS2.SequentialExecutor.prototype.on;
    module2.exports = AWS2.SequentialExecutor;
  }
});

// node_modules/aws-sdk/lib/region_config_data.json
var require_region_config_data = __commonJS({
  "node_modules/aws-sdk/lib/region_config_data.json"(exports2, module2) {
    module2.exports = {
      rules: {
        "*/*": {
          endpoint: "{service}.{region}.amazonaws.com"
        },
        "cn-*/*": {
          endpoint: "{service}.{region}.amazonaws.com.cn"
        },
        "us-iso-*/*": "usIso",
        "us-isob-*/*": "usIsob",
        "*/budgets": "globalSSL",
        "*/cloudfront": "globalSSL",
        "*/sts": "globalSSL",
        "*/importexport": {
          endpoint: "{service}.amazonaws.com",
          signatureVersion: "v2",
          globalEndpoint: true
        },
        "*/route53": "globalSSL",
        "cn-*/route53": {
          endpoint: "{service}.amazonaws.com.cn",
          globalEndpoint: true,
          signingRegion: "cn-northwest-1"
        },
        "us-gov-*/route53": "globalGovCloud",
        "us-iso-*/route53": {
          endpoint: "{service}.c2s.ic.gov",
          globalEndpoint: true,
          signingRegion: "us-iso-east-1"
        },
        "us-isob-*/route53": {
          endpoint: "{service}.sc2s.sgov.gov",
          globalEndpoint: true,
          signingRegion: "us-isob-east-1"
        },
        "*/waf": "globalSSL",
        "*/iam": "globalSSL",
        "cn-*/iam": {
          endpoint: "{service}.cn-north-1.amazonaws.com.cn",
          globalEndpoint: true,
          signingRegion: "cn-north-1"
        },
        "us-iso-*/iam": {
          endpoint: "{service}.us-iso-east-1.c2s.ic.gov",
          globalEndpoint: true,
          signingRegion: "us-iso-east-1"
        },
        "us-gov-*/iam": "globalGovCloud",
        "*/ce": {
          endpoint: "{service}.us-east-1.amazonaws.com",
          globalEndpoint: true,
          signingRegion: "us-east-1"
        },
        "cn-*/ce": {
          endpoint: "{service}.cn-northwest-1.amazonaws.com.cn",
          globalEndpoint: true,
          signingRegion: "cn-northwest-1"
        },
        "us-gov-*/sts": {
          endpoint: "{service}.{region}.amazonaws.com"
        },
        "us-gov-west-1/s3": "s3signature",
        "us-west-1/s3": "s3signature",
        "us-west-2/s3": "s3signature",
        "eu-west-1/s3": "s3signature",
        "ap-southeast-1/s3": "s3signature",
        "ap-southeast-2/s3": "s3signature",
        "ap-northeast-1/s3": "s3signature",
        "sa-east-1/s3": "s3signature",
        "us-east-1/s3": {
          endpoint: "{service}.amazonaws.com",
          signatureVersion: "s3"
        },
        "us-east-1/sdb": {
          endpoint: "{service}.amazonaws.com",
          signatureVersion: "v2"
        },
        "*/sdb": {
          endpoint: "{service}.{region}.amazonaws.com",
          signatureVersion: "v2"
        },
        "*/resource-explorer-2": "dualstackByDefault",
        "*/kendra-ranking": "dualstackByDefault",
        "*/internetmonitor": "dualstackByDefault",
        "*/codecatalyst": "globalDualstackByDefault"
      },
      fipsRules: {
        "*/*": "fipsStandard",
        "us-gov-*/*": "fipsStandard",
        "us-iso-*/*": {
          endpoint: "{service}-fips.{region}.c2s.ic.gov"
        },
        "us-iso-*/dms": "usIso",
        "us-isob-*/*": {
          endpoint: "{service}-fips.{region}.sc2s.sgov.gov"
        },
        "us-isob-*/dms": "usIsob",
        "cn-*/*": {
          endpoint: "{service}-fips.{region}.amazonaws.com.cn"
        },
        "*/api.ecr": "fips.api.ecr",
        "*/api.sagemaker": "fips.api.sagemaker",
        "*/batch": "fipsDotPrefix",
        "*/eks": "fipsDotPrefix",
        "*/models.lex": "fips.models.lex",
        "*/runtime.lex": "fips.runtime.lex",
        "*/runtime.sagemaker": {
          endpoint: "runtime-fips.sagemaker.{region}.amazonaws.com"
        },
        "*/iam": "fipsWithoutRegion",
        "*/route53": "fipsWithoutRegion",
        "*/transcribe": "fipsDotPrefix",
        "*/waf": "fipsWithoutRegion",
        "us-gov-*/transcribe": "fipsDotPrefix",
        "us-gov-*/api.ecr": "fips.api.ecr",
        "us-gov-*/models.lex": "fips.models.lex",
        "us-gov-*/runtime.lex": "fips.runtime.lex",
        "us-gov-*/access-analyzer": "fipsWithServiceOnly",
        "us-gov-*/acm": "fipsWithServiceOnly",
        "us-gov-*/acm-pca": "fipsWithServiceOnly",
        "us-gov-*/api.sagemaker": "fipsWithServiceOnly",
        "us-gov-*/appconfig": "fipsWithServiceOnly",
        "us-gov-*/application-autoscaling": "fipsWithServiceOnly",
        "us-gov-*/autoscaling": "fipsWithServiceOnly",
        "us-gov-*/autoscaling-plans": "fipsWithServiceOnly",
        "us-gov-*/batch": "fipsWithServiceOnly",
        "us-gov-*/cassandra": "fipsWithServiceOnly",
        "us-gov-*/clouddirectory": "fipsWithServiceOnly",
        "us-gov-*/cloudformation": "fipsWithServiceOnly",
        "us-gov-*/cloudshell": "fipsWithServiceOnly",
        "us-gov-*/cloudtrail": "fipsWithServiceOnly",
        "us-gov-*/config": "fipsWithServiceOnly",
        "us-gov-*/connect": "fipsWithServiceOnly",
        "us-gov-*/databrew": "fipsWithServiceOnly",
        "us-gov-*/dlm": "fipsWithServiceOnly",
        "us-gov-*/dms": "fipsWithServiceOnly",
        "us-gov-*/dynamodb": "fipsWithServiceOnly",
        "us-gov-*/ec2": "fipsWithServiceOnly",
        "us-gov-*/eks": "fipsWithServiceOnly",
        "us-gov-*/elasticache": "fipsWithServiceOnly",
        "us-gov-*/elasticbeanstalk": "fipsWithServiceOnly",
        "us-gov-*/elasticloadbalancing": "fipsWithServiceOnly",
        "us-gov-*/elasticmapreduce": "fipsWithServiceOnly",
        "us-gov-*/events": "fipsWithServiceOnly",
        "us-gov-*/fis": "fipsWithServiceOnly",
        "us-gov-*/glacier": "fipsWithServiceOnly",
        "us-gov-*/greengrass": "fipsWithServiceOnly",
        "us-gov-*/guardduty": "fipsWithServiceOnly",
        "us-gov-*/identitystore": "fipsWithServiceOnly",
        "us-gov-*/imagebuilder": "fipsWithServiceOnly",
        "us-gov-*/kafka": "fipsWithServiceOnly",
        "us-gov-*/kinesis": "fipsWithServiceOnly",
        "us-gov-*/logs": "fipsWithServiceOnly",
        "us-gov-*/mediaconvert": "fipsWithServiceOnly",
        "us-gov-*/monitoring": "fipsWithServiceOnly",
        "us-gov-*/networkmanager": "fipsWithServiceOnly",
        "us-gov-*/organizations": "fipsWithServiceOnly",
        "us-gov-*/outposts": "fipsWithServiceOnly",
        "us-gov-*/participant.connect": "fipsWithServiceOnly",
        "us-gov-*/ram": "fipsWithServiceOnly",
        "us-gov-*/rds": "fipsWithServiceOnly",
        "us-gov-*/redshift": "fipsWithServiceOnly",
        "us-gov-*/resource-groups": "fipsWithServiceOnly",
        "us-gov-*/runtime.sagemaker": "fipsWithServiceOnly",
        "us-gov-*/serverlessrepo": "fipsWithServiceOnly",
        "us-gov-*/servicecatalog-appregistry": "fipsWithServiceOnly",
        "us-gov-*/servicequotas": "fipsWithServiceOnly",
        "us-gov-*/sns": "fipsWithServiceOnly",
        "us-gov-*/sqs": "fipsWithServiceOnly",
        "us-gov-*/ssm": "fipsWithServiceOnly",
        "us-gov-*/streams.dynamodb": "fipsWithServiceOnly",
        "us-gov-*/sts": "fipsWithServiceOnly",
        "us-gov-*/support": "fipsWithServiceOnly",
        "us-gov-*/swf": "fipsWithServiceOnly",
        "us-gov-west-1/states": "fipsWithServiceOnly",
        "us-iso-east-1/elasticfilesystem": {
          endpoint: "elasticfilesystem-fips.{region}.c2s.ic.gov"
        },
        "us-gov-west-1/organizations": "fipsWithServiceOnly",
        "us-gov-west-1/route53": {
          endpoint: "route53.us-gov.amazonaws.com"
        },
        "*/resource-explorer-2": "fipsDualstackByDefault",
        "*/kendra-ranking": "dualstackByDefault",
        "*/internetmonitor": "dualstackByDefault",
        "*/codecatalyst": "fipsGlobalDualstackByDefault"
      },
      dualstackRules: {
        "*/*": {
          endpoint: "{service}.{region}.api.aws"
        },
        "cn-*/*": {
          endpoint: "{service}.{region}.api.amazonwebservices.com.cn"
        },
        "*/s3": "dualstackLegacy",
        "cn-*/s3": "dualstackLegacyCn",
        "*/s3-control": "dualstackLegacy",
        "cn-*/s3-control": "dualstackLegacyCn",
        "ap-south-1/ec2": "dualstackLegacyEc2",
        "eu-west-1/ec2": "dualstackLegacyEc2",
        "sa-east-1/ec2": "dualstackLegacyEc2",
        "us-east-1/ec2": "dualstackLegacyEc2",
        "us-east-2/ec2": "dualstackLegacyEc2",
        "us-west-2/ec2": "dualstackLegacyEc2"
      },
      dualstackFipsRules: {
        "*/*": {
          endpoint: "{service}-fips.{region}.api.aws"
        },
        "cn-*/*": {
          endpoint: "{service}-fips.{region}.api.amazonwebservices.com.cn"
        },
        "*/s3": "dualstackFipsLegacy",
        "cn-*/s3": "dualstackFipsLegacyCn",
        "*/s3-control": "dualstackFipsLegacy",
        "cn-*/s3-control": "dualstackFipsLegacyCn"
      },
      patterns: {
        globalSSL: {
          endpoint: "https://{service}.amazonaws.com",
          globalEndpoint: true,
          signingRegion: "us-east-1"
        },
        globalGovCloud: {
          endpoint: "{service}.us-gov.amazonaws.com",
          globalEndpoint: true,
          signingRegion: "us-gov-west-1"
        },
        s3signature: {
          endpoint: "{service}.{region}.amazonaws.com",
          signatureVersion: "s3"
        },
        usIso: {
          endpoint: "{service}.{region}.c2s.ic.gov"
        },
        usIsob: {
          endpoint: "{service}.{region}.sc2s.sgov.gov"
        },
        fipsStandard: {
          endpoint: "{service}-fips.{region}.amazonaws.com"
        },
        fipsDotPrefix: {
          endpoint: "fips.{service}.{region}.amazonaws.com"
        },
        fipsWithoutRegion: {
          endpoint: "{service}-fips.amazonaws.com"
        },
        "fips.api.ecr": {
          endpoint: "ecr-fips.{region}.amazonaws.com"
        },
        "fips.api.sagemaker": {
          endpoint: "api-fips.sagemaker.{region}.amazonaws.com"
        },
        "fips.models.lex": {
          endpoint: "models-fips.lex.{region}.amazonaws.com"
        },
        "fips.runtime.lex": {
          endpoint: "runtime-fips.lex.{region}.amazonaws.com"
        },
        fipsWithServiceOnly: {
          endpoint: "{service}.{region}.amazonaws.com"
        },
        dualstackLegacy: {
          endpoint: "{service}.dualstack.{region}.amazonaws.com"
        },
        dualstackLegacyCn: {
          endpoint: "{service}.dualstack.{region}.amazonaws.com.cn"
        },
        dualstackFipsLegacy: {
          endpoint: "{service}-fips.dualstack.{region}.amazonaws.com"
        },
        dualstackFipsLegacyCn: {
          endpoint: "{service}-fips.dualstack.{region}.amazonaws.com.cn"
        },
        dualstackLegacyEc2: {
          endpoint: "api.ec2.{region}.aws"
        },
        dualstackByDefault: {
          endpoint: "{service}.{region}.api.aws"
        },
        fipsDualstackByDefault: {
          endpoint: "{service}-fips.{region}.api.aws"
        },
        globalDualstackByDefault: {
          endpoint: "{service}.global.api.aws"
        },
        fipsGlobalDualstackByDefault: {
          endpoint: "{service}-fips.global.api.aws"
        }
      }
    };
  }
});

// node_modules/aws-sdk/lib/region_config.js
var require_region_config = __commonJS({
  "node_modules/aws-sdk/lib/region_config.js"(exports2, module2) {
    "use strict";
    var util = require_util();
    var regionConfig = require_region_config_data();
    function generateRegionPrefix(region) {
      if (!region)
        return null;
      var parts = region.split("-");
      if (parts.length < 3)
        return null;
      return parts.slice(0, parts.length - 2).join("-") + "-*";
    }
    function derivedKeys(service) {
      var region = service.config.region;
      var regionPrefix = generateRegionPrefix(region);
      var endpointPrefix = service.api.endpointPrefix;
      return [
        [region, endpointPrefix],
        [regionPrefix, endpointPrefix],
        [region, "*"],
        [regionPrefix, "*"],
        ["*", endpointPrefix],
        [region, "internal-*"],
        ["*", "*"]
      ].map(function(item) {
        return item[0] && item[1] ? item.join("/") : null;
      });
    }
    function applyConfig(service, config) {
      util.each(config, function(key, value) {
        if (key === "globalEndpoint")
          return;
        if (service.config[key] === void 0 || service.config[key] === null) {
          service.config[key] = value;
        }
      });
    }
    function configureEndpoint(service) {
      var keys = derivedKeys(service);
      var useFipsEndpoint = service.config.useFipsEndpoint;
      var useDualstackEndpoint = service.config.useDualstackEndpoint;
      for (var i = 0; i < keys.length; i++) {
        var key = keys[i];
        if (!key)
          continue;
        var rules = useFipsEndpoint ? useDualstackEndpoint ? regionConfig.dualstackFipsRules : regionConfig.fipsRules : useDualstackEndpoint ? regionConfig.dualstackRules : regionConfig.rules;
        if (Object.prototype.hasOwnProperty.call(rules, key)) {
          var config = rules[key];
          if (typeof config === "string") {
            config = regionConfig.patterns[config];
          }
          service.isGlobalEndpoint = !!config.globalEndpoint;
          if (config.signingRegion) {
            service.signingRegion = config.signingRegion;
          }
          if (!config.signatureVersion) {
            config.signatureVersion = "v4";
          }
          var useBearer = (service.api && service.api.signatureVersion) === "bearer";
          applyConfig(service, Object.assign(
            {},
            config,
            { signatureVersion: useBearer ? "bearer" : config.signatureVersion }
          ));
          return;
        }
      }
    }
    function getEndpointSuffix(region) {
      var regionRegexes = {
        "^(us|eu|ap|sa|ca|me)\\-\\w+\\-\\d+$": "amazonaws.com",
        "^cn\\-\\w+\\-\\d+$": "amazonaws.com.cn",
        "^us\\-gov\\-\\w+\\-\\d+$": "amazonaws.com",
        "^us\\-iso\\-\\w+\\-\\d+$": "c2s.ic.gov",
        "^us\\-isob\\-\\w+\\-\\d+$": "sc2s.sgov.gov"
      };
      var defaultSuffix = "amazonaws.com";
      var regexes = Object.keys(regionRegexes);
      for (var i = 0; i < regexes.length; i++) {
        var regionPattern = RegExp(regexes[i]);
        var dnsSuffix = regionRegexes[regexes[i]];
        if (regionPattern.test(region))
          return dnsSuffix;
      }
      return defaultSuffix;
    }
    module2.exports = {
      configureEndpoint,
      getEndpointSuffix
    };
  }
});

// node_modules/aws-sdk/lib/region/utils.js
var require_utils = __commonJS({
  "node_modules/aws-sdk/lib/region/utils.js"(exports2, module2) {
    "use strict";
    function isFipsRegion(region) {
      return typeof region === "string" && (region.startsWith("fips-") || region.endsWith("-fips"));
    }
    function isGlobalRegion(region) {
      return typeof region === "string" && ["aws-global", "aws-us-gov-global"].includes(region);
    }
    function getRealRegion(region) {
      return ["fips-aws-global", "aws-fips", "aws-global"].includes(region) ? "us-east-1" : ["fips-aws-us-gov-global", "aws-us-gov-global"].includes(region) ? "us-gov-west-1" : region.replace(/fips-(dkr-|prod-)?|-fips/, "");
    }
    module2.exports = {
      isFipsRegion,
      isGlobalRegion,
      getRealRegion
    };
  }
});

// node_modules/aws-sdk/lib/service.js
var require_service = __commonJS({
  "node_modules/aws-sdk/lib/service.js"(exports2, module2) {
    "use strict";
    var AWS2 = require_core();
    var Api = require_api();
    var regionConfig = require_region_config();
    var inherit = AWS2.util.inherit;
    var clientCount = 0;
    var region_utils = require_utils();
    AWS2.Service = inherit({
      /**
       * Create a new service object with a configuration object
       *
       * @param config [map] a map of configuration options
       */
      constructor: function Service(config) {
        if (!this.loadServiceClass) {
          throw AWS2.util.error(
            new Error(),
            "Service must be constructed with `new' operator"
          );
        }
        if (config) {
          if (config.region) {
            var region = config.region;
            if (region_utils.isFipsRegion(region)) {
              config.region = region_utils.getRealRegion(region);
              config.useFipsEndpoint = true;
            }
            if (region_utils.isGlobalRegion(region)) {
              config.region = region_utils.getRealRegion(region);
            }
          }
          if (typeof config.useDualstack === "boolean" && typeof config.useDualstackEndpoint !== "boolean") {
            config.useDualstackEndpoint = config.useDualstack;
          }
        }
        var ServiceClass = this.loadServiceClass(config || {});
        if (ServiceClass) {
          var originalConfig = AWS2.util.copy(config);
          var svc = new ServiceClass(config);
          Object.defineProperty(svc, "_originalConfig", {
            get: function() {
              return originalConfig;
            },
            enumerable: false,
            configurable: true
          });
          svc._clientId = ++clientCount;
          return svc;
        }
        this.initialize(config);
      },
      /**
       * @api private
       */
      initialize: function initialize(config) {
        var svcConfig = AWS2.config[this.serviceIdentifier];
        this.config = new AWS2.Config(AWS2.config);
        if (svcConfig)
          this.config.update(svcConfig, true);
        if (config)
          this.config.update(config, true);
        this.validateService();
        if (!this.config.endpoint)
          regionConfig.configureEndpoint(this);
        this.config.endpoint = this.endpointFromTemplate(this.config.endpoint);
        this.setEndpoint(this.config.endpoint);
        AWS2.SequentialExecutor.call(this);
        AWS2.Service.addDefaultMonitoringListeners(this);
        if ((this.config.clientSideMonitoring || AWS2.Service._clientSideMonitoring) && this.publisher) {
          var publisher = this.publisher;
          this.addNamedListener("PUBLISH_API_CALL", "apiCall", function PUBLISH_API_CALL(event) {
            process.nextTick(function() {
              publisher.eventHandler(event);
            });
          });
          this.addNamedListener("PUBLISH_API_ATTEMPT", "apiCallAttempt", function PUBLISH_API_ATTEMPT(event) {
            process.nextTick(function() {
              publisher.eventHandler(event);
            });
          });
        }
      },
      /**
       * @api private
       */
      validateService: function validateService() {
      },
      /**
       * @api private
       */
      loadServiceClass: function loadServiceClass(serviceConfig) {
        var config = serviceConfig;
        if (!AWS2.util.isEmpty(this.api)) {
          return null;
        } else if (config.apiConfig) {
          return AWS2.Service.defineServiceApi(this.constructor, config.apiConfig);
        } else if (!this.constructor.services) {
          return null;
        } else {
          config = new AWS2.Config(AWS2.config);
          config.update(serviceConfig, true);
          var version = config.apiVersions[this.constructor.serviceIdentifier];
          version = version || config.apiVersion;
          return this.getLatestServiceClass(version);
        }
      },
      /**
       * @api private
       */
      getLatestServiceClass: function getLatestServiceClass(version) {
        version = this.getLatestServiceVersion(version);
        if (this.constructor.services[version] === null) {
          AWS2.Service.defineServiceApi(this.constructor, version);
        }
        return this.constructor.services[version];
      },
      /**
       * @api private
       */
      getLatestServiceVersion: function getLatestServiceVersion(version) {
        if (!this.constructor.services || this.constructor.services.length === 0) {
          throw new Error("No services defined on " + this.constructor.serviceIdentifier);
        }
        if (!version) {
          version = "latest";
        } else if (AWS2.util.isType(version, Date)) {
          version = AWS2.util.date.iso8601(version).split("T")[0];
        }
        if (Object.hasOwnProperty(this.constructor.services, version)) {
          return version;
        }
        var keys = Object.keys(this.constructor.services).sort();
        var selectedVersion = null;
        for (var i = keys.length - 1; i >= 0; i--) {
          if (keys[i][keys[i].length - 1] !== "*") {
            selectedVersion = keys[i];
          }
          if (keys[i].substr(0, 10) <= version) {
            return selectedVersion;
          }
        }
        throw new Error("Could not find " + this.constructor.serviceIdentifier + " API to satisfy version constraint `" + version + "'");
      },
      /**
       * @api private
       */
      api: {},
      /**
       * @api private
       */
      defaultRetryCount: 3,
      /**
       * @api private
       */
      customizeRequests: function customizeRequests(callback) {
        if (!callback) {
          this.customRequestHandler = null;
        } else if (typeof callback === "function") {
          this.customRequestHandler = callback;
        } else {
          throw new Error("Invalid callback type '" + typeof callback + "' provided in customizeRequests");
        }
      },
      /**
       * Calls an operation on a service with the given input parameters.
       *
       * @param operation [String] the name of the operation to call on the service.
       * @param params [map] a map of input options for the operation
       * @callback callback function(err, data)
       *   If a callback is supplied, it is called when a response is returned
       *   from the service.
       *   @param err [Error] the error object returned from the request.
       *     Set to `null` if the request is successful.
       *   @param data [Object] the de-serialized data returned from
       *     the request. Set to `null` if a request error occurs.
       */
      makeRequest: function makeRequest(operation, params, callback) {
        if (typeof params === "function") {
          callback = params;
          params = null;
        }
        params = params || {};
        if (this.config.params) {
          var rules = this.api.operations[operation];
          if (rules) {
            params = AWS2.util.copy(params);
            AWS2.util.each(this.config.params, function(key, value) {
              if (rules.input.members[key]) {
                if (params[key] === void 0 || params[key] === null) {
                  params[key] = value;
                }
              }
            });
          }
        }
        var request = new AWS2.Request(this, operation, params);
        this.addAllRequestListeners(request);
        this.attachMonitoringEmitter(request);
        if (callback)
          request.send(callback);
        return request;
      },
      /**
       * Calls an operation on a service with the given input parameters, without
       * any authentication data. This method is useful for "public" API operations.
       *
       * @param operation [String] the name of the operation to call on the service.
       * @param params [map] a map of input options for the operation
       * @callback callback function(err, data)
       *   If a callback is supplied, it is called when a response is returned
       *   from the service.
       *   @param err [Error] the error object returned from the request.
       *     Set to `null` if the request is successful.
       *   @param data [Object] the de-serialized data returned from
       *     the request. Set to `null` if a request error occurs.
       */
      makeUnauthenticatedRequest: function makeUnauthenticatedRequest(operation, params, callback) {
        if (typeof params === "function") {
          callback = params;
          params = {};
        }
        var request = this.makeRequest(operation, params).toUnauthenticated();
        return callback ? request.send(callback) : request;
      },
      /**
       * Waits for a given state
       *
       * @param state [String] the state on the service to wait for
       * @param params [map] a map of parameters to pass with each request
       * @option params $waiter [map] a map of configuration options for the waiter
       * @option params $waiter.delay [Number] The number of seconds to wait between
       *                                       requests
       * @option params $waiter.maxAttempts [Number] The maximum number of requests
       *                                             to send while waiting
       * @callback callback function(err, data)
       *   If a callback is supplied, it is called when a response is returned
       *   from the service.
       *   @param err [Error] the error object returned from the request.
       *     Set to `null` if the request is successful.
       *   @param data [Object] the de-serialized data returned from
       *     the request. Set to `null` if a request error occurs.
       */
      waitFor: function waitFor(state, params, callback) {
        var waiter = new AWS2.ResourceWaiter(this, state);
        return waiter.wait(params, callback);
      },
      /**
       * @api private
       */
      addAllRequestListeners: function addAllRequestListeners(request) {
        var list = [
          AWS2.events,
          AWS2.EventListeners.Core,
          this.serviceInterface(),
          AWS2.EventListeners.CorePost
        ];
        for (var i = 0; i < list.length; i++) {
          if (list[i])
            request.addListeners(list[i]);
        }
        if (!this.config.paramValidation) {
          request.removeListener(
            "validate",
            AWS2.EventListeners.Core.VALIDATE_PARAMETERS
          );
        }
        if (this.config.logger) {
          request.addListeners(AWS2.EventListeners.Logger);
        }
        this.setupRequestListeners(request);
        if (typeof this.constructor.prototype.customRequestHandler === "function") {
          this.constructor.prototype.customRequestHandler(request);
        }
        if (Object.prototype.hasOwnProperty.call(this, "customRequestHandler") && typeof this.customRequestHandler === "function") {
          this.customRequestHandler(request);
        }
      },
      /**
       * Event recording metrics for a whole API call.
       * @returns {object} a subset of api call metrics
       * @api private
       */
      apiCallEvent: function apiCallEvent(request) {
        var api = request.service.api.operations[request.operation];
        var monitoringEvent = {
          Type: "ApiCall",
          Api: api ? api.name : request.operation,
          Version: 1,
          Service: request.service.api.serviceId || request.service.api.endpointPrefix,
          Region: request.httpRequest.region,
          MaxRetriesExceeded: 0,
          UserAgent: request.httpRequest.getUserAgent()
        };
        var response = request.response;
        if (response.httpResponse.statusCode) {
          monitoringEvent.FinalHttpStatusCode = response.httpResponse.statusCode;
        }
        if (response.error) {
          var error = response.error;
          var statusCode = response.httpResponse.statusCode;
          if (statusCode > 299) {
            if (error.code)
              monitoringEvent.FinalAwsException = error.code;
            if (error.message)
              monitoringEvent.FinalAwsExceptionMessage = error.message;
          } else {
            if (error.code || error.name)
              monitoringEvent.FinalSdkException = error.code || error.name;
            if (error.message)
              monitoringEvent.FinalSdkExceptionMessage = error.message;
          }
        }
        return monitoringEvent;
      },
      /**
       * Event recording metrics for an API call attempt.
       * @returns {object} a subset of api call attempt metrics
       * @api private
       */
      apiAttemptEvent: function apiAttemptEvent(request) {
        var api = request.service.api.operations[request.operation];
        var monitoringEvent = {
          Type: "ApiCallAttempt",
          Api: api ? api.name : request.operation,
          Version: 1,
          Service: request.service.api.serviceId || request.service.api.endpointPrefix,
          Fqdn: request.httpRequest.endpoint.hostname,
          UserAgent: request.httpRequest.getUserAgent()
        };
        var response = request.response;
        if (response.httpResponse.statusCode) {
          monitoringEvent.HttpStatusCode = response.httpResponse.statusCode;
        }
        if (!request._unAuthenticated && request.service.config.credentials && request.service.config.credentials.accessKeyId) {
          monitoringEvent.AccessKey = request.service.config.credentials.accessKeyId;
        }
        if (!response.httpResponse.headers)
          return monitoringEvent;
        if (request.httpRequest.headers["x-amz-security-token"]) {
          monitoringEvent.SessionToken = request.httpRequest.headers["x-amz-security-token"];
        }
        if (response.httpResponse.headers["x-amzn-requestid"]) {
          monitoringEvent.XAmznRequestId = response.httpResponse.headers["x-amzn-requestid"];
        }
        if (response.httpResponse.headers["x-amz-request-id"]) {
          monitoringEvent.XAmzRequestId = response.httpResponse.headers["x-amz-request-id"];
        }
        if (response.httpResponse.headers["x-amz-id-2"]) {
          monitoringEvent.XAmzId2 = response.httpResponse.headers["x-amz-id-2"];
        }
        return monitoringEvent;
      },
      /**
       * Add metrics of failed request.
       * @api private
       */
      attemptFailEvent: function attemptFailEvent(request) {
        var monitoringEvent = this.apiAttemptEvent(request);
        var response = request.response;
        var error = response.error;
        if (response.httpResponse.statusCode > 299) {
          if (error.code)
            monitoringEvent.AwsException = error.code;
          if (error.message)
            monitoringEvent.AwsExceptionMessage = error.message;
        } else {
          if (error.code || error.name)
            monitoringEvent.SdkException = error.code || error.name;
          if (error.message)
            monitoringEvent.SdkExceptionMessage = error.message;
        }
        return monitoringEvent;
      },
      /**
       * Attach listeners to request object to fetch metrics of each request
       * and emit data object through \'ApiCall\' and \'ApiCallAttempt\' events.
       * @api private
       */
      attachMonitoringEmitter: function attachMonitoringEmitter(request) {
        var attemptTimestamp;
        var attemptStartRealTime;
        var attemptLatency;
        var callStartRealTime;
        var attemptCount = 0;
        var region;
        var callTimestamp;
        var self2 = this;
        var addToHead = true;
        request.on("validate", function() {
          callStartRealTime = AWS2.util.realClock.now();
          callTimestamp = Date.now();
        }, addToHead);
        request.on("sign", function() {
          attemptStartRealTime = AWS2.util.realClock.now();
          attemptTimestamp = Date.now();
          region = request.httpRequest.region;
          attemptCount++;
        }, addToHead);
        request.on("validateResponse", function() {
          attemptLatency = Math.round(AWS2.util.realClock.now() - attemptStartRealTime);
        });
        request.addNamedListener("API_CALL_ATTEMPT", "success", function API_CALL_ATTEMPT() {
          var apiAttemptEvent = self2.apiAttemptEvent(request);
          apiAttemptEvent.Timestamp = attemptTimestamp;
          apiAttemptEvent.AttemptLatency = attemptLatency >= 0 ? attemptLatency : 0;
          apiAttemptEvent.Region = region;
          self2.emit("apiCallAttempt", [apiAttemptEvent]);
        });
        request.addNamedListener("API_CALL_ATTEMPT_RETRY", "retry", function API_CALL_ATTEMPT_RETRY() {
          var apiAttemptEvent = self2.attemptFailEvent(request);
          apiAttemptEvent.Timestamp = attemptTimestamp;
          attemptLatency = attemptLatency || Math.round(AWS2.util.realClock.now() - attemptStartRealTime);
          apiAttemptEvent.AttemptLatency = attemptLatency >= 0 ? attemptLatency : 0;
          apiAttemptEvent.Region = region;
          self2.emit("apiCallAttempt", [apiAttemptEvent]);
        });
        request.addNamedListener("API_CALL", "complete", function API_CALL() {
          var apiCallEvent = self2.apiCallEvent(request);
          apiCallEvent.AttemptCount = attemptCount;
          if (apiCallEvent.AttemptCount <= 0)
            return;
          apiCallEvent.Timestamp = callTimestamp;
          var latency = Math.round(AWS2.util.realClock.now() - callStartRealTime);
          apiCallEvent.Latency = latency >= 0 ? latency : 0;
          var response = request.response;
          if (response.error && response.error.retryable && typeof response.retryCount === "number" && typeof response.maxRetries === "number" && response.retryCount >= response.maxRetries) {
            apiCallEvent.MaxRetriesExceeded = 1;
          }
          self2.emit("apiCall", [apiCallEvent]);
        });
      },
      /**
       * Override this method to setup any custom request listeners for each
       * new request to the service.
       *
       * @method_abstract This is an abstract method.
       */
      setupRequestListeners: function setupRequestListeners(request) {
      },
      /**
       * Gets the signing name for a given request
       * @api private
       */
      getSigningName: function getSigningName() {
        return this.api.signingName || this.api.endpointPrefix;
      },
      /**
       * Gets the signer class for a given request
       * @api private
       */
      getSignerClass: function getSignerClass(request) {
        var version;
        var operation = null;
        var authtype = "";
        if (request) {
          var operations = request.service.api.operations || {};
          operation = operations[request.operation] || null;
          authtype = operation ? operation.authtype : "";
        }
        if (this.config.signatureVersion) {
          version = this.config.signatureVersion;
        } else if (authtype === "v4" || authtype === "v4-unsigned-body") {
          version = "v4";
        } else if (authtype === "bearer") {
          version = "bearer";
        } else {
          version = this.api.signatureVersion;
        }
        return AWS2.Signers.RequestSigner.getVersion(version);
      },
      /**
       * @api private
       */
      serviceInterface: function serviceInterface() {
        switch (this.api.protocol) {
          case "ec2":
            return AWS2.EventListeners.Query;
          case "query":
            return AWS2.EventListeners.Query;
          case "json":
            return AWS2.EventListeners.Json;
          case "rest-json":
            return AWS2.EventListeners.RestJson;
          case "rest-xml":
            return AWS2.EventListeners.RestXml;
        }
        if (this.api.protocol) {
          throw new Error("Invalid service `protocol' " + this.api.protocol + " in API config");
        }
      },
      /**
       * @api private
       */
      successfulResponse: function successfulResponse(resp) {
        return resp.httpResponse.statusCode < 300;
      },
      /**
       * How many times a failed request should be retried before giving up.
       * the defaultRetryCount can be overriden by service classes.
       *
       * @api private
       */
      numRetries: function numRetries() {
        if (this.config.maxRetries !== void 0) {
          return this.config.maxRetries;
        } else {
          return this.defaultRetryCount;
        }
      },
      /**
       * @api private
       */
      retryDelays: function retryDelays(retryCount, err) {
        return AWS2.util.calculateRetryDelay(retryCount, this.config.retryDelayOptions, err);
      },
      /**
       * @api private
       */
      retryableError: function retryableError(error) {
        if (this.timeoutError(error))
          return true;
        if (this.networkingError(error))
          return true;
        if (this.expiredCredentialsError(error))
          return true;
        if (this.throttledError(error))
          return true;
        if (error.statusCode >= 500)
          return true;
        return false;
      },
      /**
       * @api private
       */
      networkingError: function networkingError(error) {
        return error.code === "NetworkingError";
      },
      /**
       * @api private
       */
      timeoutError: function timeoutError(error) {
        return error.code === "TimeoutError";
      },
      /**
       * @api private
       */
      expiredCredentialsError: function expiredCredentialsError(error) {
        return error.code === "ExpiredTokenException";
      },
      /**
       * @api private
       */
      clockSkewError: function clockSkewError(error) {
        switch (error.code) {
          case "RequestTimeTooSkewed":
          case "RequestExpired":
          case "InvalidSignatureException":
          case "SignatureDoesNotMatch":
          case "AuthFailure":
          case "RequestInTheFuture":
            return true;
          default:
            return false;
        }
      },
      /**
       * @api private
       */
      getSkewCorrectedDate: function getSkewCorrectedDate() {
        return new Date(Date.now() + this.config.systemClockOffset);
      },
      /**
       * @api private
       */
      applyClockOffset: function applyClockOffset(newServerTime) {
        if (newServerTime) {
          this.config.systemClockOffset = newServerTime - Date.now();
        }
      },
      /**
       * @api private
       */
      isClockSkewed: function isClockSkewed(newServerTime) {
        if (newServerTime) {
          return Math.abs(this.getSkewCorrectedDate().getTime() - newServerTime) >= 3e5;
        }
      },
      /**
       * @api private
       */
      throttledError: function throttledError(error) {
        if (error.statusCode === 429)
          return true;
        switch (error.code) {
          case "ProvisionedThroughputExceededException":
          case "Throttling":
          case "ThrottlingException":
          case "RequestLimitExceeded":
          case "RequestThrottled":
          case "RequestThrottledException":
          case "TooManyRequestsException":
          case "TransactionInProgressException":
          case "EC2ThrottledException":
            return true;
          default:
            return false;
        }
      },
      /**
       * @api private
       */
      endpointFromTemplate: function endpointFromTemplate(endpoint) {
        if (typeof endpoint !== "string")
          return endpoint;
        var e = endpoint;
        e = e.replace(/\{service\}/g, this.api.endpointPrefix);
        e = e.replace(/\{region\}/g, this.config.region);
        e = e.replace(/\{scheme\}/g, this.config.sslEnabled ? "https" : "http");
        return e;
      },
      /**
       * @api private
       */
      setEndpoint: function setEndpoint(endpoint) {
        this.endpoint = new AWS2.Endpoint(endpoint, this.config);
      },
      /**
       * @api private
       */
      paginationConfig: function paginationConfig(operation, throwException) {
        var paginator = this.api.operations[operation].paginator;
        if (!paginator) {
          if (throwException) {
            var e = new Error();
            throw AWS2.util.error(e, "No pagination configuration for " + operation);
          }
          return null;
        }
        return paginator;
      }
    });
    AWS2.util.update(AWS2.Service, {
      /**
       * Adds one method for each operation described in the api configuration
       *
       * @api private
       */
      defineMethods: function defineMethods(svc) {
        AWS2.util.each(svc.prototype.api.operations, function iterator(method) {
          if (svc.prototype[method])
            return;
          var operation = svc.prototype.api.operations[method];
          if (operation.authtype === "none") {
            svc.prototype[method] = function(params, callback) {
              return this.makeUnauthenticatedRequest(method, params, callback);
            };
          } else {
            svc.prototype[method] = function(params, callback) {
              return this.makeRequest(method, params, callback);
            };
          }
        });
      },
      /**
       * Defines a new Service class using a service identifier and list of versions
       * including an optional set of features (functions) to apply to the class
       * prototype.
       *
       * @param serviceIdentifier [String] the identifier for the service
       * @param versions [Array<String>] a list of versions that work with this
       *   service
       * @param features [Object] an object to attach to the prototype
       * @return [Class<Service>] the service class defined by this function.
       */
      defineService: function defineService(serviceIdentifier, versions, features) {
        AWS2.Service._serviceMap[serviceIdentifier] = true;
        if (!Array.isArray(versions)) {
          features = versions;
          versions = [];
        }
        var svc = inherit(AWS2.Service, features || {});
        if (typeof serviceIdentifier === "string") {
          AWS2.Service.addVersions(svc, versions);
          var identifier = svc.serviceIdentifier || serviceIdentifier;
          svc.serviceIdentifier = identifier;
        } else {
          svc.prototype.api = serviceIdentifier;
          AWS2.Service.defineMethods(svc);
        }
        AWS2.SequentialExecutor.call(this.prototype);
        if (!this.prototype.publisher && AWS2.util.clientSideMonitoring) {
          var Publisher = AWS2.util.clientSideMonitoring.Publisher;
          var configProvider = AWS2.util.clientSideMonitoring.configProvider;
          var publisherConfig = configProvider();
          this.prototype.publisher = new Publisher(publisherConfig);
          if (publisherConfig.enabled) {
            AWS2.Service._clientSideMonitoring = true;
          }
        }
        AWS2.SequentialExecutor.call(svc.prototype);
        AWS2.Service.addDefaultMonitoringListeners(svc.prototype);
        return svc;
      },
      /**
       * @api private
       */
      addVersions: function addVersions(svc, versions) {
        if (!Array.isArray(versions))
          versions = [versions];
        svc.services = svc.services || {};
        for (var i = 0; i < versions.length; i++) {
          if (svc.services[versions[i]] === void 0) {
            svc.services[versions[i]] = null;
          }
        }
        svc.apiVersions = Object.keys(svc.services).sort();
      },
      /**
       * @api private
       */
      defineServiceApi: function defineServiceApi(superclass, version, apiConfig) {
        var svc = inherit(superclass, {
          serviceIdentifier: superclass.serviceIdentifier
        });
        function setApi(api) {
          if (api.isApi) {
            svc.prototype.api = api;
          } else {
            svc.prototype.api = new Api(api, {
              serviceIdentifier: superclass.serviceIdentifier
            });
          }
        }
        if (typeof version === "string") {
          if (apiConfig) {
            setApi(apiConfig);
          } else {
            try {
              setApi(AWS2.apiLoader(superclass.serviceIdentifier, version));
            } catch (err) {
              throw AWS2.util.error(err, {
                message: "Could not find API configuration " + superclass.serviceIdentifier + "-" + version
              });
            }
          }
          if (!Object.prototype.hasOwnProperty.call(superclass.services, version)) {
            superclass.apiVersions = superclass.apiVersions.concat(version).sort();
          }
          superclass.services[version] = svc;
        } else {
          setApi(version);
        }
        AWS2.Service.defineMethods(svc);
        return svc;
      },
      /**
       * @api private
       */
      hasService: function(identifier) {
        return Object.prototype.hasOwnProperty.call(AWS2.Service._serviceMap, identifier);
      },
      /**
       * @param attachOn attach default monitoring listeners to object
       *
       * Each monitoring event should be emitted from service client to service constructor prototype and then
       * to global service prototype like bubbling up. These default monitoring events listener will transfer
       * the monitoring events to the upper layer.
       * @api private
       */
      addDefaultMonitoringListeners: function addDefaultMonitoringListeners(attachOn) {
        attachOn.addNamedListener("MONITOR_EVENTS_BUBBLE", "apiCallAttempt", function EVENTS_BUBBLE(event) {
          var baseClass = Object.getPrototypeOf(attachOn);
          if (baseClass._events)
            baseClass.emit("apiCallAttempt", [event]);
        });
        attachOn.addNamedListener("CALL_EVENTS_BUBBLE", "apiCall", function CALL_EVENTS_BUBBLE(event) {
          var baseClass = Object.getPrototypeOf(attachOn);
          if (baseClass._events)
            baseClass.emit("apiCall", [event]);
        });
      },
      /**
       * @api private
       */
      _serviceMap: {}
    });
    AWS2.util.mixin(AWS2.Service, AWS2.SequentialExecutor);
    module2.exports = AWS2.Service;
  }
});

// node_modules/aws-sdk/lib/credentials.js
var require_credentials = __commonJS({
  "node_modules/aws-sdk/lib/credentials.js"() {
    "use strict";
    var AWS2 = require_core();
    AWS2.Credentials = AWS2.util.inherit({
      /**
       * A credentials object can be created using positional arguments or an options
       * hash.
       *
       * @overload AWS.Credentials(accessKeyId, secretAccessKey, sessionToken=null)
       *   Creates a Credentials object with a given set of credential information
       *   as positional arguments.
       *   @param accessKeyId [String] the AWS access key ID
       *   @param secretAccessKey [String] the AWS secret access key
       *   @param sessionToken [String] the optional AWS session token
       *   @example Create a credentials object with AWS credentials
       *     var creds = new AWS.Credentials('akid', 'secret', 'session');
       * @overload AWS.Credentials(options)
       *   Creates a Credentials object with a given set of credential information
       *   as an options hash.
       *   @option options accessKeyId [String] the AWS access key ID
       *   @option options secretAccessKey [String] the AWS secret access key
       *   @option options sessionToken [String] the optional AWS session token
       *   @example Create a credentials object with AWS credentials
       *     var creds = new AWS.Credentials({
       *       accessKeyId: 'akid', secretAccessKey: 'secret', sessionToken: 'session'
       *     });
       */
      constructor: function Credentials() {
        AWS2.util.hideProperties(this, ["secretAccessKey"]);
        this.expired = false;
        this.expireTime = null;
        this.refreshCallbacks = [];
        if (arguments.length === 1 && typeof arguments[0] === "object") {
          var creds = arguments[0].credentials || arguments[0];
          this.accessKeyId = creds.accessKeyId;
          this.secretAccessKey = creds.secretAccessKey;
          this.sessionToken = creds.sessionToken;
        } else {
          this.accessKeyId = arguments[0];
          this.secretAccessKey = arguments[1];
          this.sessionToken = arguments[2];
        }
      },
      /**
       * @return [Integer] the number of seconds before {expireTime} during which
       *   the credentials will be considered expired.
       */
      expiryWindow: 15,
      /**
       * @return [Boolean] whether the credentials object should call {refresh}
       * @note Subclasses should override this method to provide custom refresh
       *   logic.
       */
      needsRefresh: function needsRefresh() {
        var currentTime = AWS2.util.date.getDate().getTime();
        var adjustedTime = new Date(currentTime + this.expiryWindow * 1e3);
        if (this.expireTime && adjustedTime > this.expireTime) {
          return true;
        } else {
          return this.expired || !this.accessKeyId || !this.secretAccessKey;
        }
      },
      /**
       * Gets the existing credentials, refreshing them if they are not yet loaded
       * or have expired. Users should call this method before using {refresh},
       * as this will not attempt to reload credentials when they are already
       * loaded into the object.
       *
       * @callback callback function(err)
       *   When this callback is called with no error, it means either credentials
       *   do not need to be refreshed or refreshed credentials information has
       *   been loaded into the object (as the `accessKeyId`, `secretAccessKey`,
       *   and `sessionToken` properties).
       *   @param err [Error] if an error occurred, this value will be filled
       */
      get: function get(callback) {
        var self2 = this;
        if (this.needsRefresh()) {
          this.refresh(function(err) {
            if (!err)
              self2.expired = false;
            if (callback)
              callback(err);
          });
        } else if (callback) {
          callback();
        }
      },
      /**
       * @!method  getPromise()
       *   Returns a 'thenable' promise.
       *   Gets the existing credentials, refreshing them if they are not yet loaded
       *   or have expired. Users should call this method before using {refresh},
       *   as this will not attempt to reload credentials when they are already
       *   loaded into the object.
       *
       *   Two callbacks can be provided to the `then` method on the returned promise.
       *   The first callback will be called if the promise is fulfilled, and the second
       *   callback will be called if the promise is rejected.
       *   @callback fulfilledCallback function()
       *     Called if the promise is fulfilled. When this callback is called, it
       *     means either credentials do not need to be refreshed or refreshed
       *     credentials information has been loaded into the object (as the
       *     `accessKeyId`, `secretAccessKey`, and `sessionToken` properties).
       *   @callback rejectedCallback function(err)
       *     Called if the promise is rejected.
       *     @param err [Error] if an error occurred, this value will be filled
       *   @return [Promise] A promise that represents the state of the `get` call.
       *   @example Calling the `getPromise` method.
       *     var promise = credProvider.getPromise();
       *     promise.then(function() { ... }, function(err) { ... });
       */
      /**
       * @!method  refreshPromise()
       *   Returns a 'thenable' promise.
       *   Refreshes the credentials. Users should call {get} before attempting
       *   to forcibly refresh credentials.
       *
       *   Two callbacks can be provided to the `then` method on the returned promise.
       *   The first callback will be called if the promise is fulfilled, and the second
       *   callback will be called if the promise is rejected.
       *   @callback fulfilledCallback function()
       *     Called if the promise is fulfilled. When this callback is called, it
       *     means refreshed credentials information has been loaded into the object
       *     (as the `accessKeyId`, `secretAccessKey`, and `sessionToken` properties).
       *   @callback rejectedCallback function(err)
       *     Called if the promise is rejected.
       *     @param err [Error] if an error occurred, this value will be filled
       *   @return [Promise] A promise that represents the state of the `refresh` call.
       *   @example Calling the `refreshPromise` method.
       *     var promise = credProvider.refreshPromise();
       *     promise.then(function() { ... }, function(err) { ... });
       */
      /**
       * Refreshes the credentials. Users should call {get} before attempting
       * to forcibly refresh credentials.
       *
       * @callback callback function(err)
       *   When this callback is called with no error, it means refreshed
       *   credentials information has been loaded into the object (as the
       *   `accessKeyId`, `secretAccessKey`, and `sessionToken` properties).
       *   @param err [Error] if an error occurred, this value will be filled
       * @note Subclasses should override this class to reset the
       *   {accessKeyId}, {secretAccessKey} and optional {sessionToken}
       *   on the credentials object and then call the callback with
       *   any error information.
       * @see get
       */
      refresh: function refresh(callback) {
        this.expired = false;
        callback();
      },
      /**
       * @api private
       * @param callback
       */
      coalesceRefresh: function coalesceRefresh(callback, sync) {
        var self2 = this;
        if (self2.refreshCallbacks.push(callback) === 1) {
          self2.load(function onLoad(err) {
            AWS2.util.arrayEach(self2.refreshCallbacks, function(callback2) {
              if (sync) {
                callback2(err);
              } else {
                AWS2.util.defer(function() {
                  callback2(err);
                });
              }
            });
            self2.refreshCallbacks.length = 0;
          });
        }
      },
      /**
       * @api private
       * @param callback
       */
      load: function load(callback) {
        callback();
      }
    });
    AWS2.Credentials.addPromisesToClass = function addPromisesToClass(PromiseDependency) {
      this.prototype.getPromise = AWS2.util.promisifyMethod("get", PromiseDependency);
      this.prototype.refreshPromise = AWS2.util.promisifyMethod("refresh", PromiseDependency);
    };
    AWS2.Credentials.deletePromisesFromClass = function deletePromisesFromClass() {
      delete this.prototype.getPromise;
      delete this.prototype.refreshPromise;
    };
    AWS2.util.addPromises(AWS2.Credentials);
  }
});

// node_modules/aws-sdk/lib/credentials/credential_provider_chain.js
var require_credential_provider_chain = __commonJS({
  "node_modules/aws-sdk/lib/credentials/credential_provider_chain.js"() {
    "use strict";
    var AWS2 = require_core();
    AWS2.CredentialProviderChain = AWS2.util.inherit(AWS2.Credentials, {
      /**
       * Creates a new CredentialProviderChain with a default set of providers
       * specified by {defaultProviders}.
       */
      constructor: function CredentialProviderChain(providers) {
        if (providers) {
          this.providers = providers;
        } else {
          this.providers = AWS2.CredentialProviderChain.defaultProviders.slice(0);
        }
        this.resolveCallbacks = [];
      },
      /**
       * @!method  resolvePromise()
       *   Returns a 'thenable' promise.
       *   Resolves the provider chain by searching for the first set of
       *   credentials in {providers}.
       *
       *   Two callbacks can be provided to the `then` method on the returned promise.
       *   The first callback will be called if the promise is fulfilled, and the second
       *   callback will be called if the promise is rejected.
       *   @callback fulfilledCallback function(credentials)
       *     Called if the promise is fulfilled and the provider resolves the chain
       *     to a credentials object
       *     @param credentials [AWS.Credentials] the credentials object resolved
       *       by the provider chain.
       *   @callback rejectedCallback function(error)
       *     Called if the promise is rejected.
       *     @param err [Error] the error object returned if no credentials are found.
       *   @return [Promise] A promise that represents the state of the `resolve` method call.
       *   @example Calling the `resolvePromise` method.
       *     var promise = chain.resolvePromise();
       *     promise.then(function(credentials) { ... }, function(err) { ... });
       */
      /**
       * Resolves the provider chain by searching for the first set of
       * credentials in {providers}.
       *
       * @callback callback function(err, credentials)
       *   Called when the provider resolves the chain to a credentials object
       *   or null if no credentials can be found.
       *
       *   @param err [Error] the error object returned if no credentials are
       *     found.
       *   @param credentials [AWS.Credentials] the credentials object resolved
       *     by the provider chain.
       * @return [AWS.CredentialProviderChain] the provider, for chaining.
       */
      resolve: function resolve(callback) {
        var self2 = this;
        if (self2.providers.length === 0) {
          callback(new Error("No providers"));
          return self2;
        }
        if (self2.resolveCallbacks.push(callback) === 1) {
          let resolveNext2 = function(err, creds) {
            if (!err && creds || index === providers.length) {
              AWS2.util.arrayEach(self2.resolveCallbacks, function(callback2) {
                callback2(err, creds);
              });
              self2.resolveCallbacks.length = 0;
              return;
            }
            var provider = providers[index++];
            if (typeof provider === "function") {
              creds = provider.call();
            } else {
              creds = provider;
            }
            if (creds.get) {
              creds.get(function(getErr) {
                resolveNext2(getErr, getErr ? null : creds);
              });
            } else {
              resolveNext2(null, creds);
            }
          };
          var resolveNext = resolveNext2;
          var index = 0;
          var providers = self2.providers.slice(0);
          resolveNext2();
        }
        return self2;
      }
    });
    AWS2.CredentialProviderChain.defaultProviders = [];
    AWS2.CredentialProviderChain.addPromisesToClass = function addPromisesToClass(PromiseDependency) {
      this.prototype.resolvePromise = AWS2.util.promisifyMethod("resolve", PromiseDependency);
    };
    AWS2.CredentialProviderChain.deletePromisesFromClass = function deletePromisesFromClass() {
      delete this.prototype.resolvePromise;
    };
    AWS2.util.addPromises(AWS2.CredentialProviderChain);
  }
});

// node_modules/aws-sdk/lib/config.js
var require_config = __commonJS({
  "node_modules/aws-sdk/lib/config.js"() {
    "use strict";
    var AWS2 = require_core();
    require_credentials();
    require_credential_provider_chain();
    var PromisesDependency;
    AWS2.Config = AWS2.util.inherit({
      /**
       * @!endgroup
       */
      /**
       * Creates a new configuration object. This is the object that passes
       * option data along to service requests, including credentials, security,
       * region information, and some service specific settings.
       *
       * @example Creating a new configuration object with credentials and region
       *   var config = new AWS.Config({
       *     accessKeyId: 'AKID', secretAccessKey: 'SECRET', region: 'us-west-2'
       *   });
       * @option options accessKeyId [String] your AWS access key ID.
       * @option options secretAccessKey [String] your AWS secret access key.
       * @option options sessionToken [AWS.Credentials] the optional AWS
       *   session token to sign requests with.
       * @option options credentials [AWS.Credentials] the AWS credentials
       *   to sign requests with. You can either specify this object, or
       *   specify the accessKeyId and secretAccessKey options directly.
       * @option options credentialProvider [AWS.CredentialProviderChain] the
       *   provider chain used to resolve credentials if no static `credentials`
       *   property is set.
       * @option options region [String] the region to send service requests to.
       *   See {region} for more information.
       * @option options maxRetries [Integer] the maximum amount of retries to
       *   attempt with a request. See {maxRetries} for more information.
       * @option options maxRedirects [Integer] the maximum amount of redirects to
       *   follow with a request. See {maxRedirects} for more information.
       * @option options sslEnabled [Boolean] whether to enable SSL for
       *   requests.
       * @option options paramValidation [Boolean|map] whether input parameters
       *   should be validated against the operation description before sending
       *   the request. Defaults to true. Pass a map to enable any of the
       *   following specific validation features:
       *
       *   * **min** [Boolean] &mdash; Validates that a value meets the min
       *     constraint. This is enabled by default when paramValidation is set
       *     to `true`.
       *   * **max** [Boolean] &mdash; Validates that a value meets the max
       *     constraint.
       *   * **pattern** [Boolean] &mdash; Validates that a string value matches a
       *     regular expression.
       *   * **enum** [Boolean] &mdash; Validates that a string value matches one
       *     of the allowable enum values.
       * @option options computeChecksums [Boolean] whether to compute checksums
       *   for payload bodies when the service accepts it (currently supported
       *   in S3 only)
       * @option options convertResponseTypes [Boolean] whether types are converted
       *     when parsing response data. Currently only supported for JSON based
       *     services. Turning this off may improve performance on large response
       *     payloads. Defaults to `true`.
       * @option options correctClockSkew [Boolean] whether to apply a clock skew
       *     correction and retry requests that fail because of an skewed client
       *     clock. Defaults to `false`.
       * @option options s3ForcePathStyle [Boolean] whether to force path
       *   style URLs for S3 objects.
       * @option options s3BucketEndpoint [Boolean] whether the provided endpoint
       *   addresses an individual bucket (false if it addresses the root API
       *   endpoint). Note that setting this configuration option requires an
       *   `endpoint` to be provided explicitly to the service constructor.
       * @option options s3DisableBodySigning [Boolean] whether S3 body signing
       *   should be disabled when using signature version `v4`. Body signing
       *   can only be disabled when using https. Defaults to `true`.
       * @option options s3UsEast1RegionalEndpoint ['legacy'|'regional'] when region
       *   is set to 'us-east-1', whether to send s3 request to global endpoints or
       *   'us-east-1' regional endpoints. This config is only applicable to S3 client.
       *   Defaults to `legacy`
       * @option options s3UseArnRegion [Boolean] whether to override the request region
       *   with the region inferred from requested resource's ARN. Only available for S3 buckets
       *   Defaults to `true`
       *
       * @option options retryDelayOptions [map] A set of options to configure
       *   the retry delay on retryable errors. Currently supported options are:
       *
       *   * **base** [Integer] &mdash; The base number of milliseconds to use in the
       *     exponential backoff for operation retries. Defaults to 100 ms for all
       *     services except DynamoDB, where it defaults to 50ms.
       *   * **customBackoff ** [function] &mdash; A custom function that accepts a
       *     retry count and error and returns the amount of time to delay in
       *     milliseconds. If the result is a non-zero negative value, no further
       *     retry attempts will be made. The `base` option will be ignored if this
       *     option is supplied. The function is only called for retryable errors.
       * @option options httpOptions [map] A set of options to pass to the low-level
       *   HTTP request. Currently supported options are:
       *
       *   * **proxy** [String] &mdash; the URL to proxy requests through
       *   * **agent** [http.Agent, https.Agent] &mdash; the Agent object to perform
       *     HTTP requests with. Used for connection pooling. Defaults to the global
       *     agent (`http.globalAgent`) for non-SSL connections. Note that for
       *     SSL connections, a special Agent object is used in order to enable
       *     peer certificate verification. This feature is only available in the
       *     Node.js environment.
       *   * **connectTimeout** [Integer] &mdash; Sets the socket to timeout after
       *     failing to establish a connection with the server after
       *     `connectTimeout` milliseconds. This timeout has no effect once a socket
       *     connection has been established.
       *   * **timeout** [Integer] &mdash; Sets the socket to timeout after timeout
       *     milliseconds of inactivity on the socket. Defaults to two minutes
       *     (120000).
       *   * **xhrAsync** [Boolean] &mdash; Whether the SDK will send asynchronous
       *     HTTP requests. Used in the browser environment only. Set to false to
       *     send requests synchronously. Defaults to true (async on).
       *   * **xhrWithCredentials** [Boolean] &mdash; Sets the "withCredentials"
       *     property of an XMLHttpRequest object. Used in the browser environment
       *     only. Defaults to false.
       * @option options apiVersion [String, Date] a String in YYYY-MM-DD format
       *   (or a date) that represents the latest possible API version that can be
       *   used in all services (unless overridden by `apiVersions`). Specify
       *   'latest' to use the latest possible version.
       * @option options apiVersions [map<String, String|Date>] a map of service
       *   identifiers (the lowercase service class name) with the API version to
       *   use when instantiating a service. Specify 'latest' for each individual
       *   that can use the latest available version.
       * @option options logger [#write,#log] an object that responds to .write()
       *   (like a stream) or .log() (like the console object) in order to log
       *   information about requests
       * @option options systemClockOffset [Number] an offset value in milliseconds
       *   to apply to all signing times. Use this to compensate for clock skew
       *   when your system may be out of sync with the service time. Note that
       *   this configuration option can only be applied to the global `AWS.config`
       *   object and cannot be overridden in service-specific configuration.
       *   Defaults to 0 milliseconds.
       * @option options signatureVersion [String] the signature version to sign
       *   requests with (overriding the API configuration). Possible values are:
       *   'v2', 'v3', 'v4'.
       * @option options signatureCache [Boolean] whether the signature to sign
       *   requests with (overriding the API configuration) is cached. Only applies
       *   to the signature version 'v4'. Defaults to `true`.
       * @option options dynamoDbCrc32 [Boolean] whether to validate the CRC32
       *   checksum of HTTP response bodies returned by DynamoDB. Default: `true`.
       * @option options useAccelerateEndpoint [Boolean] Whether to use the
       *   S3 Transfer Acceleration endpoint with the S3 service. Default: `false`.
       * @option options clientSideMonitoring [Boolean] whether to collect and
       *   publish this client's performance metrics of all its API requests.
       * @option options endpointDiscoveryEnabled [Boolean|undefined] whether to
       *   call operations with endpoints given by service dynamically. Setting this
       * config to `true` will enable endpoint discovery for all applicable operations.
       *   Setting it to `false` will explicitly disable endpoint discovery even though
       *   operations that require endpoint discovery will presumably fail. Leaving it
       *   to `undefined` means SDK will only do endpoint discovery when it's required.
       *   Defaults to `undefined`
       * @option options endpointCacheSize [Number] the size of the global cache storing
       *   endpoints from endpoint discovery operations. Once endpoint cache is created,
       *   updating this setting cannot change existing cache size.
       *   Defaults to 1000
       * @option options hostPrefixEnabled [Boolean] whether to marshal request
       *   parameters to the prefix of hostname.
       *   Defaults to `true`.
       * @option options stsRegionalEndpoints ['legacy'|'regional'] whether to send sts request
       *   to global endpoints or regional endpoints.
       *   Defaults to 'legacy'.
       * @option options useFipsEndpoint [Boolean] Enables FIPS compatible endpoints.
       *   Defaults to `false`.
       * @option options useDualstackEndpoint [Boolean] Enables IPv6 dualstack endpoint.
       *   Defaults to `false`.
       */
      constructor: function Config(options) {
        if (options === void 0)
          options = {};
        options = this.extractCredentials(options);
        AWS2.util.each.call(this, this.keys, function(key, value) {
          this.set(key, options[key], value);
        });
      },
      /**
       * @!group Managing Credentials
       */
      /**
       * Loads credentials from the configuration object. This is used internally
       * by the SDK to ensure that refreshable {Credentials} objects are properly
       * refreshed and loaded when sending a request. If you want to ensure that
       * your credentials are loaded prior to a request, you can use this method
       * directly to provide accurate credential data stored in the object.
       *
       * @note If you configure the SDK with static or environment credentials,
       *   the credential data should already be present in {credentials} attribute.
       *   This method is primarily necessary to load credentials from asynchronous
       *   sources, or sources that can refresh credentials periodically.
       * @example Getting your access key
       *   AWS.config.getCredentials(function(err) {
       *     if (err) console.log(err.stack); // credentials not loaded
       *     else console.log("Access Key:", AWS.config.credentials.accessKeyId);
       *   })
       * @callback callback function(err)
       *   Called when the {credentials} have been properly set on the configuration
       *   object.
       *
       *   @param err [Error] if this is set, credentials were not successfully
       *     loaded and this error provides information why.
       * @see credentials
       * @see Credentials
       */
      getCredentials: function getCredentials(callback) {
        var self2 = this;
        function finish(err) {
          callback(err, err ? null : self2.credentials);
        }
        function credError(msg, err) {
          return new AWS2.util.error(err || new Error(), {
            code: "CredentialsError",
            message: msg,
            name: "CredentialsError"
          });
        }
        function getAsyncCredentials() {
          self2.credentials.get(function(err) {
            if (err) {
              var msg = "Could not load credentials from " + self2.credentials.constructor.name;
              err = credError(msg, err);
            }
            finish(err);
          });
        }
        function getStaticCredentials() {
          var err = null;
          if (!self2.credentials.accessKeyId || !self2.credentials.secretAccessKey) {
            err = credError("Missing credentials");
          }
          finish(err);
        }
        if (self2.credentials) {
          if (typeof self2.credentials.get === "function") {
            getAsyncCredentials();
          } else {
            getStaticCredentials();
          }
        } else if (self2.credentialProvider) {
          self2.credentialProvider.resolve(function(err, creds) {
            if (err) {
              err = credError("Could not load credentials from any providers", err);
            }
            self2.credentials = creds;
            finish(err);
          });
        } else {
          finish(credError("No credentials to load"));
        }
      },
      /**
       * Loads token from the configuration object. This is used internally
       * by the SDK to ensure that refreshable {Token} objects are properly
       * refreshed and loaded when sending a request. If you want to ensure that
       * your token is loaded prior to a request, you can use this method
       * directly to provide accurate token data stored in the object.
       *
       * @note If you configure the SDK with static token, the token data should
       *   already be present in {token} attribute. This method is primarily necessary
       *   to load token from asynchronous sources, or sources that can refresh
       *   token periodically.
       * @example Getting your access token
       *   AWS.config.getToken(function(err) {
       *     if (err) console.log(err.stack); // token not loaded
       *     else console.log("Token:", AWS.config.token.token);
       *   })
       * @callback callback function(err)
       *   Called when the {token} have been properly set on the configuration object.
       *
       *   @param err [Error] if this is set, token was not successfully loaded and
       *     this error provides information why.
       * @see token
       */
      getToken: function getToken(callback) {
        var self2 = this;
        function finish(err) {
          callback(err, err ? null : self2.token);
        }
        function tokenError(msg, err) {
          return new AWS2.util.error(err || new Error(), {
            code: "TokenError",
            message: msg,
            name: "TokenError"
          });
        }
        function getAsyncToken() {
          self2.token.get(function(err) {
            if (err) {
              var msg = "Could not load token from " + self2.token.constructor.name;
              err = tokenError(msg, err);
            }
            finish(err);
          });
        }
        function getStaticToken() {
          var err = null;
          if (!self2.token.token) {
            err = tokenError("Missing token");
          }
          finish(err);
        }
        if (self2.token) {
          if (typeof self2.token.get === "function") {
            getAsyncToken();
          } else {
            getStaticToken();
          }
        } else if (self2.tokenProvider) {
          self2.tokenProvider.resolve(function(err, token) {
            if (err) {
              err = tokenError("Could not load token from any providers", err);
            }
            self2.token = token;
            finish(err);
          });
        } else {
          finish(tokenError("No token to load"));
        }
      },
      /**
       * @!group Loading and Setting Configuration Options
       */
      /**
       * @overload update(options, allowUnknownKeys = false)
       *   Updates the current configuration object with new options.
       *
       *   @example Update maxRetries property of a configuration object
       *     config.update({maxRetries: 10});
       *   @param [Object] options a map of option keys and values.
       *   @param [Boolean] allowUnknownKeys whether unknown keys can be set on
       *     the configuration object. Defaults to `false`.
       *   @see constructor
       */
      update: function update(options, allowUnknownKeys) {
        allowUnknownKeys = allowUnknownKeys || false;
        options = this.extractCredentials(options);
        AWS2.util.each.call(this, options, function(key, value) {
          if (allowUnknownKeys || Object.prototype.hasOwnProperty.call(this.keys, key) || AWS2.Service.hasService(key)) {
            this.set(key, value);
          }
        });
      },
      /**
       * Loads configuration data from a JSON file into this config object.
       * @note Loading configuration will reset all existing configuration
       *   on the object.
       * @!macro nobrowser
       * @param path [String] the path relative to your process's current
       *    working directory to load configuration from.
       * @return [AWS.Config] the same configuration object
       */
      loadFromPath: function loadFromPath(path) {
        this.clear();
        var options = JSON.parse(AWS2.util.readFileSync(path));
        var fileSystemCreds = new AWS2.FileSystemCredentials(path);
        var chain = new AWS2.CredentialProviderChain();
        chain.providers.unshift(fileSystemCreds);
        chain.resolve(function(err, creds) {
          if (err)
            throw err;
          else
            options.credentials = creds;
        });
        this.constructor(options);
        return this;
      },
      /**
       * Clears configuration data on this object
       *
       * @api private
       */
      clear: function clear() {
        AWS2.util.each.call(this, this.keys, function(key) {
          delete this[key];
        });
        this.set("credentials", void 0);
        this.set("credentialProvider", void 0);
      },
      /**
       * Sets a property on the configuration object, allowing for a
       * default value
       * @api private
       */
      set: function set(property, value, defaultValue) {
        if (value === void 0) {
          if (defaultValue === void 0) {
            defaultValue = this.keys[property];
          }
          if (typeof defaultValue === "function") {
            this[property] = defaultValue.call(this);
          } else {
            this[property] = defaultValue;
          }
        } else if (property === "httpOptions" && this[property]) {
          this[property] = AWS2.util.merge(this[property], value);
        } else {
          this[property] = value;
        }
      },
      /**
       * All of the keys with their default values.
       *
       * @constant
       * @api private
       */
      keys: {
        credentials: null,
        credentialProvider: null,
        region: null,
        logger: null,
        apiVersions: {},
        apiVersion: null,
        endpoint: void 0,
        httpOptions: {
          timeout: 12e4
        },
        maxRetries: void 0,
        maxRedirects: 10,
        paramValidation: true,
        sslEnabled: true,
        s3ForcePathStyle: false,
        s3BucketEndpoint: false,
        s3DisableBodySigning: true,
        s3UsEast1RegionalEndpoint: "legacy",
        s3UseArnRegion: void 0,
        computeChecksums: true,
        convertResponseTypes: true,
        correctClockSkew: false,
        customUserAgent: null,
        dynamoDbCrc32: true,
        systemClockOffset: 0,
        signatureVersion: null,
        signatureCache: true,
        retryDelayOptions: {},
        useAccelerateEndpoint: false,
        clientSideMonitoring: false,
        endpointDiscoveryEnabled: void 0,
        endpointCacheSize: 1e3,
        hostPrefixEnabled: true,
        stsRegionalEndpoints: "legacy",
        useFipsEndpoint: false,
        useDualstackEndpoint: false,
        token: null
      },
      /**
       * Extracts accessKeyId, secretAccessKey and sessionToken
       * from a configuration hash.
       *
       * @api private
       */
      extractCredentials: function extractCredentials(options) {
        if (options.accessKeyId && options.secretAccessKey) {
          options = AWS2.util.copy(options);
          options.credentials = new AWS2.Credentials(options);
        }
        return options;
      },
      /**
       * Sets the promise dependency the SDK will use wherever Promises are returned.
       * Passing `null` will force the SDK to use native Promises if they are available.
       * If native Promises are not available, passing `null` will have no effect.
       * @param [Constructor] dep A reference to a Promise constructor
       */
      setPromisesDependency: function setPromisesDependency(dep) {
        PromisesDependency = dep;
        if (dep === null && typeof Promise === "function") {
          PromisesDependency = Promise;
        }
        var constructors = [AWS2.Request, AWS2.Credentials, AWS2.CredentialProviderChain];
        if (AWS2.S3) {
          constructors.push(AWS2.S3);
          if (AWS2.S3.ManagedUpload) {
            constructors.push(AWS2.S3.ManagedUpload);
          }
        }
        AWS2.util.addPromises(constructors, PromisesDependency);
      },
      /**
       * Gets the promise dependency set by `AWS.config.setPromisesDependency`.
       */
      getPromisesDependency: function getPromisesDependency() {
        return PromisesDependency;
      }
    });
    AWS2.config = new AWS2.Config();
  }
});

// node_modules/aws-sdk/lib/http.js
var require_http = __commonJS({
  "node_modules/aws-sdk/lib/http.js"() {
    "use strict";
    var AWS2 = require_core();
    var inherit = AWS2.util.inherit;
    AWS2.Endpoint = inherit({
      /**
       * @overload Endpoint(endpoint)
       *   Constructs a new endpoint given an endpoint URL. If the
       *   URL omits a protocol (http or https), the default protocol
       *   set in the global {AWS.config} will be used.
       *   @param endpoint [String] the URL to construct an endpoint from
       */
      constructor: function Endpoint(endpoint, config) {
        AWS2.util.hideProperties(this, ["slashes", "auth", "hash", "search", "query"]);
        if (typeof endpoint === "undefined" || endpoint === null) {
          throw new Error("Invalid endpoint: " + endpoint);
        } else if (typeof endpoint !== "string") {
          return AWS2.util.copy(endpoint);
        }
        if (!endpoint.match(/^http/)) {
          var useSSL = config && config.sslEnabled !== void 0 ? config.sslEnabled : AWS2.config.sslEnabled;
          endpoint = (useSSL ? "https" : "http") + "://" + endpoint;
        }
        AWS2.util.update(this, AWS2.util.urlParse(endpoint));
        if (this.port) {
          this.port = parseInt(this.port, 10);
        } else {
          this.port = this.protocol === "https:" ? 443 : 80;
        }
      }
    });
    AWS2.HttpRequest = inherit({
      /**
       * @api private
       */
      constructor: function HttpRequest(endpoint, region) {
        endpoint = new AWS2.Endpoint(endpoint);
        this.method = "POST";
        this.path = endpoint.path || "/";
        this.headers = {};
        this.body = "";
        this.endpoint = endpoint;
        this.region = region;
        this._userAgent = "";
        this.setUserAgent();
      },
      /**
       * @api private
       */
      setUserAgent: function setUserAgent() {
        this._userAgent = this.headers[this.getUserAgentHeaderName()] = AWS2.util.userAgent();
      },
      getUserAgentHeaderName: function getUserAgentHeaderName() {
        var prefix = AWS2.util.isBrowser() ? "X-Amz-" : "";
        return prefix + "User-Agent";
      },
      /**
       * @api private
       */
      appendToUserAgent: function appendToUserAgent(agentPartial) {
        if (typeof agentPartial === "string" && agentPartial) {
          this._userAgent += " " + agentPartial;
        }
        this.headers[this.getUserAgentHeaderName()] = this._userAgent;
      },
      /**
       * @api private
       */
      getUserAgent: function getUserAgent() {
        return this._userAgent;
      },
      /**
       * @return [String] the part of the {path} excluding the
       *   query string
       */
      pathname: function pathname() {
        return this.path.split("?", 1)[0];
      },
      /**
       * @return [String] the query string portion of the {path}
       */
      search: function search() {
        var query = this.path.split("?", 2)[1];
        if (query) {
          query = AWS2.util.queryStringParse(query);
          return AWS2.util.queryParamsToString(query);
        }
        return "";
      },
      /**
       * @api private
       * update httpRequest endpoint with endpoint string
       */
      updateEndpoint: function updateEndpoint(endpointStr) {
        var newEndpoint = new AWS2.Endpoint(endpointStr);
        this.endpoint = newEndpoint;
        this.path = newEndpoint.path || "/";
        if (this.headers["Host"]) {
          this.headers["Host"] = newEndpoint.host;
        }
      }
    });
    AWS2.HttpResponse = inherit({
      /**
       * @api private
       */
      constructor: function HttpResponse() {
        this.statusCode = void 0;
        this.headers = {};
        this.body = void 0;
        this.streaming = false;
        this.stream = null;
      },
      /**
       * Disables buffering on the HTTP response and returns the stream for reading.
       * @return [Stream, XMLHttpRequest, null] the underlying stream object.
       *   Use this object to directly read data off of the stream.
       * @note This object is only available after the {AWS.Request~httpHeaders}
       *   event has fired. This method must be called prior to
       *   {AWS.Request~httpData}.
       * @example Taking control of a stream
       *   request.on('httpHeaders', function(statusCode, headers) {
       *     if (statusCode < 300) {
       *       if (headers.etag === 'xyz') {
       *         // pipe the stream, disabling buffering
       *         var stream = this.response.httpResponse.createUnbufferedStream();
       *         stream.pipe(process.stdout);
       *       } else { // abort this request and set a better error message
       *         this.abort();
       *         this.response.error = new Error('Invalid ETag');
       *       }
       *     }
       *   }).send(console.log);
       */
      createUnbufferedStream: function createUnbufferedStream() {
        this.streaming = true;
        return this.stream;
      }
    });
    AWS2.HttpClient = inherit({});
    AWS2.HttpClient.getInstance = function getInstance() {
      if (this.singleton === void 0) {
        this.singleton = new this();
      }
      return this.singleton;
    };
  }
});

// node_modules/aws-sdk/lib/discover_endpoint.js
var require_discover_endpoint = __commonJS({
  "node_modules/aws-sdk/lib/discover_endpoint.js"(exports2, module2) {
    "use strict";
    var AWS2 = require_core();
    var util = require_util();
    var endpointDiscoveryEnabledEnvs = ["AWS_ENABLE_ENDPOINT_DISCOVERY", "AWS_ENDPOINT_DISCOVERY_ENABLED"];
    function getCacheKey(request) {
      var service = request.service;
      var api = service.api || {};
      var operations = api.operations;
      var identifiers = {};
      if (service.config.region) {
        identifiers.region = service.config.region;
      }
      if (api.serviceId) {
        identifiers.serviceId = api.serviceId;
      }
      if (service.config.credentials.accessKeyId) {
        identifiers.accessKeyId = service.config.credentials.accessKeyId;
      }
      return identifiers;
    }
    function marshallCustomIdentifiersHelper(result, params, shape) {
      if (!shape || params === void 0 || params === null)
        return;
      if (shape.type === "structure" && shape.required && shape.required.length > 0) {
        util.arrayEach(shape.required, function(name) {
          var memberShape = shape.members[name];
          if (memberShape.endpointDiscoveryId === true) {
            var locationName = memberShape.isLocationName ? memberShape.name : name;
            result[locationName] = String(params[name]);
          } else {
            marshallCustomIdentifiersHelper(result, params[name], memberShape);
          }
        });
      }
    }
    function marshallCustomIdentifiers(request, shape) {
      var identifiers = {};
      marshallCustomIdentifiersHelper(identifiers, request.params, shape);
      return identifiers;
    }
    function optionalDiscoverEndpoint(request) {
      var service = request.service;
      var api = service.api;
      var operationModel = api.operations ? api.operations[request.operation] : void 0;
      var inputShape = operationModel ? operationModel.input : void 0;
      var identifiers = marshallCustomIdentifiers(request, inputShape);
      var cacheKey = getCacheKey(request);
      if (Object.keys(identifiers).length > 0) {
        cacheKey = util.update(cacheKey, identifiers);
        if (operationModel)
          cacheKey.operation = operationModel.name;
      }
      var endpoints = AWS2.endpointCache.get(cacheKey);
      if (endpoints && endpoints.length === 1 && endpoints[0].Address === "") {
        return;
      } else if (endpoints && endpoints.length > 0) {
        request.httpRequest.updateEndpoint(endpoints[0].Address);
      } else {
        var endpointRequest = service.makeRequest(api.endpointOperation, {
          Operation: operationModel.name,
          Identifiers: identifiers
        });
        addApiVersionHeader(endpointRequest);
        endpointRequest.removeListener("validate", AWS2.EventListeners.Core.VALIDATE_PARAMETERS);
        endpointRequest.removeListener("retry", AWS2.EventListeners.Core.RETRY_CHECK);
        AWS2.endpointCache.put(cacheKey, [{
          Address: "",
          CachePeriodInMinutes: 1
        }]);
        endpointRequest.send(function(err, data) {
          if (data && data.Endpoints) {
            AWS2.endpointCache.put(cacheKey, data.Endpoints);
          } else if (err) {
            AWS2.endpointCache.put(cacheKey, [{
              Address: "",
              CachePeriodInMinutes: 1
              //not to make more endpoint operation in next 1 minute
            }]);
          }
        });
      }
    }
    var requestQueue = {};
    function requiredDiscoverEndpoint(request, done) {
      var service = request.service;
      var api = service.api;
      var operationModel = api.operations ? api.operations[request.operation] : void 0;
      var inputShape = operationModel ? operationModel.input : void 0;
      var identifiers = marshallCustomIdentifiers(request, inputShape);
      var cacheKey = getCacheKey(request);
      if (Object.keys(identifiers).length > 0) {
        cacheKey = util.update(cacheKey, identifiers);
        if (operationModel)
          cacheKey.operation = operationModel.name;
      }
      var cacheKeyStr = AWS2.EndpointCache.getKeyString(cacheKey);
      var endpoints = AWS2.endpointCache.get(cacheKeyStr);
      if (endpoints && endpoints.length === 1 && endpoints[0].Address === "") {
        if (!requestQueue[cacheKeyStr])
          requestQueue[cacheKeyStr] = [];
        requestQueue[cacheKeyStr].push({ request, callback: done });
        return;
      } else if (endpoints && endpoints.length > 0) {
        request.httpRequest.updateEndpoint(endpoints[0].Address);
        done();
      } else {
        var endpointRequest = service.makeRequest(api.endpointOperation, {
          Operation: operationModel.name,
          Identifiers: identifiers
        });
        endpointRequest.removeListener("validate", AWS2.EventListeners.Core.VALIDATE_PARAMETERS);
        addApiVersionHeader(endpointRequest);
        AWS2.endpointCache.put(cacheKeyStr, [{
          Address: "",
          CachePeriodInMinutes: 60
          //long-live cache
        }]);
        endpointRequest.send(function(err, data) {
          if (err) {
            request.response.error = util.error(err, { retryable: false });
            AWS2.endpointCache.remove(cacheKey);
            if (requestQueue[cacheKeyStr]) {
              var pendingRequests = requestQueue[cacheKeyStr];
              util.arrayEach(pendingRequests, function(requestContext) {
                requestContext.request.response.error = util.error(err, { retryable: false });
                requestContext.callback();
              });
              delete requestQueue[cacheKeyStr];
            }
          } else if (data) {
            AWS2.endpointCache.put(cacheKeyStr, data.Endpoints);
            request.httpRequest.updateEndpoint(data.Endpoints[0].Address);
            if (requestQueue[cacheKeyStr]) {
              var pendingRequests = requestQueue[cacheKeyStr];
              util.arrayEach(pendingRequests, function(requestContext) {
                requestContext.request.httpRequest.updateEndpoint(data.Endpoints[0].Address);
                requestContext.callback();
              });
              delete requestQueue[cacheKeyStr];
            }
          }
          done();
        });
      }
    }
    function addApiVersionHeader(endpointRequest) {
      var api = endpointRequest.service.api;
      var apiVersion = api.apiVersion;
      if (apiVersion && !endpointRequest.httpRequest.headers["x-amz-api-version"]) {
        endpointRequest.httpRequest.headers["x-amz-api-version"] = apiVersion;
      }
    }
    function invalidateCachedEndpoints(response) {
      var error = response.error;
      var httpResponse = response.httpResponse;
      if (error && (error.code === "InvalidEndpointException" || httpResponse.statusCode === 421)) {
        var request = response.request;
        var operations = request.service.api.operations || {};
        var inputShape = operations[request.operation] ? operations[request.operation].input : void 0;
        var identifiers = marshallCustomIdentifiers(request, inputShape);
        var cacheKey = getCacheKey(request);
        if (Object.keys(identifiers).length > 0) {
          cacheKey = util.update(cacheKey, identifiers);
          if (operations[request.operation])
            cacheKey.operation = operations[request.operation].name;
        }
        AWS2.endpointCache.remove(cacheKey);
      }
    }
    function hasCustomEndpoint(client) {
      if (client._originalConfig && client._originalConfig.endpoint && client._originalConfig.endpointDiscoveryEnabled === true) {
        throw util.error(new Error(), {
          code: "ConfigurationException",
          message: "Custom endpoint is supplied; endpointDiscoveryEnabled must not be true."
        });
      }
      ;
      var svcConfig = AWS2.config[client.serviceIdentifier] || {};
      return Boolean(AWS2.config.endpoint || svcConfig.endpoint || client._originalConfig && client._originalConfig.endpoint);
    }
    function isFalsy(value) {
      return ["false", "0"].indexOf(value) >= 0;
    }
    function resolveEndpointDiscoveryConfig(request) {
      var service = request.service || {};
      if (service.config.endpointDiscoveryEnabled !== void 0) {
        return service.config.endpointDiscoveryEnabled;
      }
      if (util.isBrowser())
        return void 0;
      for (var i = 0; i < endpointDiscoveryEnabledEnvs.length; i++) {
        var env = endpointDiscoveryEnabledEnvs[i];
        if (Object.prototype.hasOwnProperty.call(process.env, env)) {
          if (process.env[env] === "" || process.env[env] === void 0) {
            throw util.error(new Error(), {
              code: "ConfigurationException",
              message: "environmental variable " + env + " cannot be set to nothing"
            });
          }
          return !isFalsy(process.env[env]);
        }
      }
      var configFile = {};
      try {
        configFile = AWS2.util.iniLoader ? AWS2.util.iniLoader.loadFrom({
          isConfig: true,
          filename: process.env[AWS2.util.sharedConfigFileEnv]
        }) : {};
      } catch (e) {
      }
      var sharedFileConfig = configFile[process.env.AWS_PROFILE || AWS2.util.defaultProfile] || {};
      if (Object.prototype.hasOwnProperty.call(sharedFileConfig, "endpoint_discovery_enabled")) {
        if (sharedFileConfig.endpoint_discovery_enabled === void 0) {
          throw util.error(new Error(), {
            code: "ConfigurationException",
            message: "config file entry 'endpoint_discovery_enabled' cannot be set to nothing"
          });
        }
        return !isFalsy(sharedFileConfig.endpoint_discovery_enabled);
      }
      return void 0;
    }
    function discoverEndpoint(request, done) {
      var service = request.service || {};
      if (hasCustomEndpoint(service) || request.isPresigned())
        return done();
      var operations = service.api.operations || {};
      var operationModel = operations[request.operation];
      var isEndpointDiscoveryRequired = operationModel ? operationModel.endpointDiscoveryRequired : "NULL";
      var isEnabled = resolveEndpointDiscoveryConfig(request);
      var hasRequiredEndpointDiscovery = service.api.hasRequiredEndpointDiscovery;
      if (isEnabled || hasRequiredEndpointDiscovery) {
        request.httpRequest.appendToUserAgent("endpoint-discovery");
      }
      switch (isEndpointDiscoveryRequired) {
        case "OPTIONAL":
          if (isEnabled || hasRequiredEndpointDiscovery) {
            optionalDiscoverEndpoint(request);
            request.addNamedListener("INVALIDATE_CACHED_ENDPOINTS", "extractError", invalidateCachedEndpoints);
          }
          done();
          break;
        case "REQUIRED":
          if (isEnabled === false) {
            request.response.error = util.error(new Error(), {
              code: "ConfigurationException",
              message: "Endpoint Discovery is disabled but " + service.api.className + "." + request.operation + "() requires it. Please check your configurations."
            });
            done();
            break;
          }
          request.addNamedListener("INVALIDATE_CACHED_ENDPOINTS", "extractError", invalidateCachedEndpoints);
          requiredDiscoverEndpoint(request, done);
          break;
        case "NULL":
        default:
          done();
          break;
      }
    }
    module2.exports = {
      discoverEndpoint,
      requiredDiscoverEndpoint,
      optionalDiscoverEndpoint,
      marshallCustomIdentifiers,
      getCacheKey,
      invalidateCachedEndpoint: invalidateCachedEndpoints
    };
  }
});

// node_modules/aws-sdk/lib/event_listeners.js
var require_event_listeners = __commonJS({
  "node_modules/aws-sdk/lib/event_listeners.js"() {
    "use strict";
    var AWS2 = require_core();
    var SequentialExecutor = require_sequential_executor();
    var DISCOVER_ENDPOINT = require_discover_endpoint().discoverEndpoint;
    AWS2.EventListeners = {
      /**
       * @!attribute VALIDATE_CREDENTIALS
       *   A request listener that validates whether the request is being
       *   sent with credentials.
       *   Handles the {AWS.Request~validate 'validate' Request event}
       *   @example Sending a request without validating credentials
       *     var listener = AWS.EventListeners.Core.VALIDATE_CREDENTIALS;
       *     request.removeListener('validate', listener);
       *   @readonly
       *   @return [Function]
       * @!attribute VALIDATE_REGION
       *   A request listener that validates whether the region is set
       *   for a request.
       *   Handles the {AWS.Request~validate 'validate' Request event}
       *   @example Sending a request without validating region configuration
       *     var listener = AWS.EventListeners.Core.VALIDATE_REGION;
       *     request.removeListener('validate', listener);
       *   @readonly
       *   @return [Function]
       * @!attribute VALIDATE_PARAMETERS
       *   A request listener that validates input parameters in a request.
       *   Handles the {AWS.Request~validate 'validate' Request event}
       *   @example Sending a request without validating parameters
       *     var listener = AWS.EventListeners.Core.VALIDATE_PARAMETERS;
       *     request.removeListener('validate', listener);
       *   @example Disable parameter validation globally
       *     AWS.EventListeners.Core.removeListener('validate',
       *       AWS.EventListeners.Core.VALIDATE_REGION);
       *   @readonly
       *   @return [Function]
       * @!attribute SEND
       *   A request listener that initiates the HTTP connection for a
       *   request being sent. Handles the {AWS.Request~send 'send' Request event}
       *   @example Replacing the HTTP handler
       *     var listener = AWS.EventListeners.Core.SEND;
       *     request.removeListener('send', listener);
       *     request.on('send', function(response) {
       *       customHandler.send(response);
       *     });
       *   @return [Function]
       *   @readonly
       * @!attribute HTTP_DATA
       *   A request listener that reads data from the HTTP connection in order
       *   to build the response data.
       *   Handles the {AWS.Request~httpData 'httpData' Request event}.
       *   Remove this handler if you are overriding the 'httpData' event and
       *   do not want extra data processing and buffering overhead.
       *   @example Disabling default data processing
       *     var listener = AWS.EventListeners.Core.HTTP_DATA;
       *     request.removeListener('httpData', listener);
       *   @return [Function]
       *   @readonly
       */
      Core: {}
      /* doc hack */
    };
    function getOperationAuthtype(req) {
      if (!req.service.api.operations) {
        return "";
      }
      var operation = req.service.api.operations[req.operation];
      return operation ? operation.authtype : "";
    }
    function getIdentityType(req) {
      var service = req.service;
      if (service.config.signatureVersion) {
        return service.config.signatureVersion;
      }
      if (service.api.signatureVersion) {
        return service.api.signatureVersion;
      }
      return getOperationAuthtype(req);
    }
    AWS2.EventListeners = {
      Core: new SequentialExecutor().addNamedListeners(function(add, addAsync) {
        addAsync(
          "VALIDATE_CREDENTIALS",
          "validate",
          function VALIDATE_CREDENTIALS(req, done) {
            if (!req.service.api.signatureVersion && !req.service.config.signatureVersion)
              return done();
            var identityType = getIdentityType(req);
            if (identityType === "bearer") {
              req.service.config.getToken(function(err) {
                if (err) {
                  req.response.error = AWS2.util.error(err, { code: "TokenError" });
                }
                done();
              });
              return;
            }
            req.service.config.getCredentials(function(err) {
              if (err) {
                req.response.error = AWS2.util.error(
                  err,
                  {
                    code: "CredentialsError",
                    message: "Missing credentials in config, if using AWS_CONFIG_FILE, set AWS_SDK_LOAD_CONFIG=1"
                  }
                );
              }
              done();
            });
          }
        );
        add("VALIDATE_REGION", "validate", function VALIDATE_REGION(req) {
          if (!req.service.isGlobalEndpoint) {
            var dnsHostRegex = new RegExp(/^([a-zA-Z0-9]|[a-zA-Z0-9][a-zA-Z0-9-]{0,61}[a-zA-Z0-9])$/);
            if (!req.service.config.region) {
              req.response.error = AWS2.util.error(
                new Error(),
                { code: "ConfigError", message: "Missing region in config" }
              );
            } else if (!dnsHostRegex.test(req.service.config.region)) {
              req.response.error = AWS2.util.error(
                new Error(),
                { code: "ConfigError", message: "Invalid region in config" }
              );
            }
          }
        });
        add("BUILD_IDEMPOTENCY_TOKENS", "validate", function BUILD_IDEMPOTENCY_TOKENS(req) {
          if (!req.service.api.operations) {
            return;
          }
          var operation = req.service.api.operations[req.operation];
          if (!operation) {
            return;
          }
          var idempotentMembers = operation.idempotentMembers;
          if (!idempotentMembers.length) {
            return;
          }
          var params = AWS2.util.copy(req.params);
          for (var i = 0, iLen = idempotentMembers.length; i < iLen; i++) {
            if (!params[idempotentMembers[i]]) {
              params[idempotentMembers[i]] = AWS2.util.uuid.v4();
            }
          }
          req.params = params;
        });
        add("VALIDATE_PARAMETERS", "validate", function VALIDATE_PARAMETERS(req) {
          if (!req.service.api.operations) {
            return;
          }
          var rules = req.service.api.operations[req.operation].input;
          var validation = req.service.config.paramValidation;
          new AWS2.ParamValidator(validation).validate(rules, req.params);
        });
        add("COMPUTE_CHECKSUM", "afterBuild", function COMPUTE_CHECKSUM(req) {
          if (!req.service.api.operations) {
            return;
          }
          var operation = req.service.api.operations[req.operation];
          if (!operation) {
            return;
          }
          var body = req.httpRequest.body;
          var isNonStreamingPayload = body && (AWS2.util.Buffer.isBuffer(body) || typeof body === "string");
          var headers = req.httpRequest.headers;
          if (operation.httpChecksumRequired && req.service.config.computeChecksums && isNonStreamingPayload && !headers["Content-MD5"]) {
            var md5 = AWS2.util.crypto.md5(body, "base64");
            headers["Content-MD5"] = md5;
          }
        });
        addAsync("COMPUTE_SHA256", "afterBuild", function COMPUTE_SHA256(req, done) {
          req.haltHandlersOnError();
          if (!req.service.api.operations) {
            return;
          }
          var operation = req.service.api.operations[req.operation];
          var authtype = operation ? operation.authtype : "";
          if (!req.service.api.signatureVersion && !authtype && !req.service.config.signatureVersion)
            return done();
          if (req.service.getSignerClass(req) === AWS2.Signers.V4) {
            var body = req.httpRequest.body || "";
            if (authtype.indexOf("unsigned-body") >= 0) {
              req.httpRequest.headers["X-Amz-Content-Sha256"] = "UNSIGNED-PAYLOAD";
              return done();
            }
            AWS2.util.computeSha256(body, function(err, sha) {
              if (err) {
                done(err);
              } else {
                req.httpRequest.headers["X-Amz-Content-Sha256"] = sha;
                done();
              }
            });
          } else {
            done();
          }
        });
        add("SET_CONTENT_LENGTH", "afterBuild", function SET_CONTENT_LENGTH(req) {
          var authtype = getOperationAuthtype(req);
          var payloadMember = AWS2.util.getRequestPayloadShape(req);
          if (req.httpRequest.headers["Content-Length"] === void 0) {
            try {
              var length = AWS2.util.string.byteLength(req.httpRequest.body);
              req.httpRequest.headers["Content-Length"] = length;
            } catch (err) {
              if (payloadMember && payloadMember.isStreaming) {
                if (payloadMember.requiresLength) {
                  throw err;
                } else if (authtype.indexOf("unsigned-body") >= 0) {
                  req.httpRequest.headers["Transfer-Encoding"] = "chunked";
                  return;
                } else {
                  throw err;
                }
              }
              throw err;
            }
          }
        });
        add("SET_HTTP_HOST", "afterBuild", function SET_HTTP_HOST(req) {
          req.httpRequest.headers["Host"] = req.httpRequest.endpoint.host;
        });
        add("SET_TRACE_ID", "afterBuild", function SET_TRACE_ID(req) {
          var traceIdHeaderName = "X-Amzn-Trace-Id";
          if (AWS2.util.isNode() && !Object.hasOwnProperty.call(req.httpRequest.headers, traceIdHeaderName)) {
            var ENV_LAMBDA_FUNCTION_NAME = "AWS_LAMBDA_FUNCTION_NAME";
            var ENV_TRACE_ID = "_X_AMZN_TRACE_ID";
            var functionName = process.env[ENV_LAMBDA_FUNCTION_NAME];
            var traceId = process.env[ENV_TRACE_ID];
            if (typeof functionName === "string" && functionName.length > 0 && typeof traceId === "string" && traceId.length > 0) {
              req.httpRequest.headers[traceIdHeaderName] = traceId;
            }
          }
        });
        add("RESTART", "restart", function RESTART() {
          var err = this.response.error;
          if (!err || !err.retryable)
            return;
          this.httpRequest = new AWS2.HttpRequest(
            this.service.endpoint,
            this.service.region
          );
          if (this.response.retryCount < this.service.config.maxRetries) {
            this.response.retryCount++;
          } else {
            this.response.error = null;
          }
        });
        var addToHead = true;
        addAsync("DISCOVER_ENDPOINT", "sign", DISCOVER_ENDPOINT, addToHead);
        addAsync("SIGN", "sign", function SIGN(req, done) {
          var service = req.service;
          var identityType = getIdentityType(req);
          if (!identityType || identityType.length === 0)
            return done();
          if (identityType === "bearer") {
            service.config.getToken(function(err, token) {
              if (err) {
                req.response.error = err;
                return done();
              }
              try {
                var SignerClass = service.getSignerClass(req);
                var signer = new SignerClass(req.httpRequest);
                signer.addAuthorization(token);
              } catch (e) {
                req.response.error = e;
              }
              done();
            });
          } else {
            service.config.getCredentials(function(err, credentials) {
              if (err) {
                req.response.error = err;
                return done();
              }
              try {
                var date = service.getSkewCorrectedDate();
                var SignerClass = service.getSignerClass(req);
                var operations = req.service.api.operations || {};
                var operation = operations[req.operation];
                var signer = new SignerClass(
                  req.httpRequest,
                  service.getSigningName(req),
                  {
                    signatureCache: service.config.signatureCache,
                    operation,
                    signatureVersion: service.api.signatureVersion
                  }
                );
                signer.setServiceClientId(service._clientId);
                delete req.httpRequest.headers["Authorization"];
                delete req.httpRequest.headers["Date"];
                delete req.httpRequest.headers["X-Amz-Date"];
                signer.addAuthorization(credentials, date);
                req.signedAt = date;
              } catch (e) {
                req.response.error = e;
              }
              done();
            });
          }
        });
        add("VALIDATE_RESPONSE", "validateResponse", function VALIDATE_RESPONSE(resp) {
          if (this.service.successfulResponse(resp, this)) {
            resp.data = {};
            resp.error = null;
          } else {
            resp.data = null;
            resp.error = AWS2.util.error(
              new Error(),
              { code: "UnknownError", message: "An unknown error occurred." }
            );
          }
        });
        add("ERROR", "error", function ERROR(err, resp) {
          var awsQueryCompatible = resp.request.service.api.awsQueryCompatible;
          if (awsQueryCompatible) {
            var headers = resp.httpResponse.headers;
            var queryErrorCode = headers ? headers["x-amzn-query-error"] : void 0;
            if (queryErrorCode && queryErrorCode.includes(";")) {
              resp.error.code = queryErrorCode.split(";")[0];
            }
          }
        }, true);
        addAsync("SEND", "send", function SEND(resp, done) {
          resp.httpResponse._abortCallback = done;
          resp.error = null;
          resp.data = null;
          function callback(httpResp) {
            resp.httpResponse.stream = httpResp;
            var stream = resp.request.httpRequest.stream;
            var service = resp.request.service;
            var api = service.api;
            var operationName = resp.request.operation;
            var operation = api.operations[operationName] || {};
            httpResp.on("headers", function onHeaders(statusCode, headers, statusMessage) {
              resp.request.emit(
                "httpHeaders",
                [statusCode, headers, resp, statusMessage]
              );
              if (!resp.httpResponse.streaming) {
                if (AWS2.HttpClient.streamsApiVersion === 2) {
                  if (operation.hasEventOutput && service.successfulResponse(resp)) {
                    resp.request.emit("httpDone");
                    done();
                    return;
                  }
                  httpResp.on("readable", function onReadable() {
                    var data = httpResp.read();
                    if (data !== null) {
                      resp.request.emit("httpData", [data, resp]);
                    }
                  });
                } else {
                  httpResp.on("data", function onData(data) {
                    resp.request.emit("httpData", [data, resp]);
                  });
                }
              }
            });
            httpResp.on("end", function onEnd() {
              if (!stream || !stream.didCallback) {
                if (AWS2.HttpClient.streamsApiVersion === 2 && (operation.hasEventOutput && service.successfulResponse(resp))) {
                  return;
                }
                resp.request.emit("httpDone");
                done();
              }
            });
          }
          function progress(httpResp) {
            httpResp.on("sendProgress", function onSendProgress(value) {
              resp.request.emit("httpUploadProgress", [value, resp]);
            });
            httpResp.on("receiveProgress", function onReceiveProgress(value) {
              resp.request.emit("httpDownloadProgress", [value, resp]);
            });
          }
          function error(err) {
            if (err.code !== "RequestAbortedError") {
              var errCode = err.code === "TimeoutError" ? err.code : "NetworkingError";
              err = AWS2.util.error(err, {
                code: errCode,
                region: resp.request.httpRequest.region,
                hostname: resp.request.httpRequest.endpoint.hostname,
                retryable: true
              });
            }
            resp.error = err;
            resp.request.emit("httpError", [resp.error, resp], function() {
              done();
            });
          }
          function executeSend() {
            var http = AWS2.HttpClient.getInstance();
            var httpOptions = resp.request.service.config.httpOptions || {};
            try {
              var stream = http.handleRequest(
                resp.request.httpRequest,
                httpOptions,
                callback,
                error
              );
              progress(stream);
            } catch (err) {
              error(err);
            }
          }
          var timeDiff = (resp.request.service.getSkewCorrectedDate() - this.signedAt) / 1e3;
          if (timeDiff >= 60 * 10) {
            this.emit("sign", [this], function(err) {
              if (err)
                done(err);
              else
                executeSend();
            });
          } else {
            executeSend();
          }
        });
        add(
          "HTTP_HEADERS",
          "httpHeaders",
          function HTTP_HEADERS(statusCode, headers, resp, statusMessage) {
            resp.httpResponse.statusCode = statusCode;
            resp.httpResponse.statusMessage = statusMessage;
            resp.httpResponse.headers = headers;
            resp.httpResponse.body = AWS2.util.buffer.toBuffer("");
            resp.httpResponse.buffers = [];
            resp.httpResponse.numBytes = 0;
            var dateHeader = headers.date || headers.Date;
            var service = resp.request.service;
            if (dateHeader) {
              var serverTime = Date.parse(dateHeader);
              if (service.config.correctClockSkew && service.isClockSkewed(serverTime)) {
                service.applyClockOffset(serverTime);
              }
            }
          }
        );
        add("HTTP_DATA", "httpData", function HTTP_DATA(chunk, resp) {
          if (chunk) {
            if (AWS2.util.isNode()) {
              resp.httpResponse.numBytes += chunk.length;
              var total = resp.httpResponse.headers["content-length"];
              var progress = { loaded: resp.httpResponse.numBytes, total };
              resp.request.emit("httpDownloadProgress", [progress, resp]);
            }
            resp.httpResponse.buffers.push(AWS2.util.buffer.toBuffer(chunk));
          }
        });
        add("HTTP_DONE", "httpDone", function HTTP_DONE(resp) {
          if (resp.httpResponse.buffers && resp.httpResponse.buffers.length > 0) {
            var body = AWS2.util.buffer.concat(resp.httpResponse.buffers);
            resp.httpResponse.body = body;
          }
          delete resp.httpResponse.numBytes;
          delete resp.httpResponse.buffers;
        });
        add("FINALIZE_ERROR", "retry", function FINALIZE_ERROR(resp) {
          if (resp.httpResponse.statusCode) {
            resp.error.statusCode = resp.httpResponse.statusCode;
            if (resp.error.retryable === void 0) {
              resp.error.retryable = this.service.retryableError(resp.error, this);
            }
          }
        });
        add("INVALIDATE_CREDENTIALS", "retry", function INVALIDATE_CREDENTIALS(resp) {
          if (!resp.error)
            return;
          switch (resp.error.code) {
            case "RequestExpired":
            case "ExpiredTokenException":
            case "ExpiredToken":
              resp.error.retryable = true;
              resp.request.service.config.credentials.expired = true;
          }
        });
        add("EXPIRED_SIGNATURE", "retry", function EXPIRED_SIGNATURE(resp) {
          var err = resp.error;
          if (!err)
            return;
          if (typeof err.code === "string" && typeof err.message === "string") {
            if (err.code.match(/Signature/) && err.message.match(/expired/)) {
              resp.error.retryable = true;
            }
          }
        });
        add("CLOCK_SKEWED", "retry", function CLOCK_SKEWED(resp) {
          if (!resp.error)
            return;
          if (this.service.clockSkewError(resp.error) && this.service.config.correctClockSkew) {
            resp.error.retryable = true;
          }
        });
        add("REDIRECT", "retry", function REDIRECT(resp) {
          if (resp.error && resp.error.statusCode >= 300 && resp.error.statusCode < 400 && resp.httpResponse.headers["location"]) {
            this.httpRequest.endpoint = new AWS2.Endpoint(resp.httpResponse.headers["location"]);
            this.httpRequest.headers["Host"] = this.httpRequest.endpoint.host;
            resp.error.redirect = true;
            resp.error.retryable = true;
          }
        });
        add("RETRY_CHECK", "retry", function RETRY_CHECK(resp) {
          if (resp.error) {
            if (resp.error.redirect && resp.redirectCount < resp.maxRedirects) {
              resp.error.retryDelay = 0;
            } else if (resp.retryCount < resp.maxRetries) {
              resp.error.retryDelay = this.service.retryDelays(resp.retryCount, resp.error) || 0;
            }
          }
        });
        addAsync("RESET_RETRY_STATE", "afterRetry", function RESET_RETRY_STATE(resp, done) {
          var delay, willRetry = false;
          if (resp.error) {
            delay = resp.error.retryDelay || 0;
            if (resp.error.retryable && resp.retryCount < resp.maxRetries) {
              resp.retryCount++;
              willRetry = true;
            } else if (resp.error.redirect && resp.redirectCount < resp.maxRedirects) {
              resp.redirectCount++;
              willRetry = true;
            }
          }
          if (willRetry && delay >= 0) {
            resp.error = null;
            setTimeout(done, delay);
          } else {
            done();
          }
        });
      }),
      CorePost: new SequentialExecutor().addNamedListeners(function(add) {
        add("EXTRACT_REQUEST_ID", "extractData", AWS2.util.extractRequestId);
        add("EXTRACT_REQUEST_ID", "extractError", AWS2.util.extractRequestId);
        add("ENOTFOUND_ERROR", "httpError", function ENOTFOUND_ERROR(err) {
          function isDNSError(err2) {
            return err2.errno === "ENOTFOUND" || typeof err2.errno === "number" && typeof AWS2.util.getSystemErrorName === "function" && ["EAI_NONAME", "EAI_NODATA"].indexOf(AWS2.util.getSystemErrorName(err2.errno) >= 0);
          }
          if (err.code === "NetworkingError" && isDNSError(err)) {
            var message = "Inaccessible host: `" + err.hostname + "' at port `" + err.port + "'. This service may not be available in the `" + err.region + "' region.";
            this.response.error = AWS2.util.error(new Error(message), {
              code: "UnknownEndpoint",
              region: err.region,
              hostname: err.hostname,
              retryable: true,
              originalError: err
            });
          }
        });
      }),
      Logger: new SequentialExecutor().addNamedListeners(function(add) {
        add("LOG_REQUEST", "complete", function LOG_REQUEST(resp) {
          var req = resp.request;
          var logger = req.service.config.logger;
          if (!logger)
            return;
          function filterSensitiveLog(inputShape, shape) {
            if (!shape) {
              return shape;
            }
            if (inputShape.isSensitive) {
              return "***SensitiveInformation***";
            }
            switch (inputShape.type) {
              case "structure":
                var struct = {};
                AWS2.util.each(shape, function(subShapeName, subShape) {
                  if (Object.prototype.hasOwnProperty.call(inputShape.members, subShapeName)) {
                    struct[subShapeName] = filterSensitiveLog(inputShape.members[subShapeName], subShape);
                  } else {
                    struct[subShapeName] = subShape;
                  }
                });
                return struct;
              case "list":
                var list = [];
                AWS2.util.arrayEach(shape, function(subShape, index) {
                  list.push(filterSensitiveLog(inputShape.member, subShape));
                });
                return list;
              case "map":
                var map = {};
                AWS2.util.each(shape, function(key, value) {
                  map[key] = filterSensitiveLog(inputShape.value, value);
                });
                return map;
              default:
                return shape;
            }
          }
          function buildMessage() {
            var time = resp.request.service.getSkewCorrectedDate().getTime();
            var delta = (time - req.startTime.getTime()) / 1e3;
            var ansi = logger.isTTY ? true : false;
            var status = resp.httpResponse.statusCode;
            var censoredParams = req.params;
            if (req.service.api.operations && req.service.api.operations[req.operation] && req.service.api.operations[req.operation].input) {
              var inputShape = req.service.api.operations[req.operation].input;
              censoredParams = filterSensitiveLog(inputShape, req.params);
            }
            var params = require("util").inspect(censoredParams, true, null);
            var message = "";
            if (ansi)
              message += "\x1B[33m";
            message += "[AWS " + req.service.serviceIdentifier + " " + status;
            message += " " + delta.toString() + "s " + resp.retryCount + " retries]";
            if (ansi)
              message += "\x1B[0;1m";
            message += " " + AWS2.util.string.lowerFirst(req.operation);
            message += "(" + params + ")";
            if (ansi)
              message += "\x1B[0m";
            return message;
          }
          var line = buildMessage();
          if (typeof logger.log === "function") {
            logger.log(line);
          } else if (typeof logger.write === "function") {
            logger.write(line + "\n");
          }
        });
      }),
      Json: new SequentialExecutor().addNamedListeners(function(add) {
        var svc = require_json();
        add("BUILD", "build", svc.buildRequest);
        add("EXTRACT_DATA", "extractData", svc.extractData);
        add("EXTRACT_ERROR", "extractError", svc.extractError);
      }),
      Rest: new SequentialExecutor().addNamedListeners(function(add) {
        var svc = require_rest();
        add("BUILD", "build", svc.buildRequest);
        add("EXTRACT_DATA", "extractData", svc.extractData);
        add("EXTRACT_ERROR", "extractError", svc.extractError);
      }),
      RestJson: new SequentialExecutor().addNamedListeners(function(add) {
        var svc = require_rest_json();
        add("BUILD", "build", svc.buildRequest);
        add("EXTRACT_DATA", "extractData", svc.extractData);
        add("EXTRACT_ERROR", "extractError", svc.extractError);
        add("UNSET_CONTENT_LENGTH", "afterBuild", svc.unsetContentLength);
      }),
      RestXml: new SequentialExecutor().addNamedListeners(function(add) {
        var svc = require_rest_xml();
        add("BUILD", "build", svc.buildRequest);
        add("EXTRACT_DATA", "extractData", svc.extractData);
        add("EXTRACT_ERROR", "extractError", svc.extractError);
      }),
      Query: new SequentialExecutor().addNamedListeners(function(add) {
        var svc = require_query();
        add("BUILD", "build", svc.buildRequest);
        add("EXTRACT_DATA", "extractData", svc.extractData);
        add("EXTRACT_ERROR", "extractError", svc.extractError);
      })
    };
  }
});

// node_modules/aws-sdk/lib/state_machine.js
var require_state_machine = __commonJS({
  "node_modules/aws-sdk/lib/state_machine.js"(exports2, module2) {
    "use strict";
    function AcceptorStateMachine(states, state) {
      this.currentState = state || null;
      this.states = states || {};
    }
    AcceptorStateMachine.prototype.runTo = function runTo(finalState, done, bindObject, inputError) {
      if (typeof finalState === "function") {
        inputError = bindObject;
        bindObject = done;
        done = finalState;
        finalState = null;
      }
      var self2 = this;
      var state = self2.states[self2.currentState];
      state.fn.call(bindObject || self2, inputError, function(err) {
        if (err) {
          if (state.fail)
            self2.currentState = state.fail;
          else
            return done ? done.call(bindObject, err) : null;
        } else {
          if (state.accept)
            self2.currentState = state.accept;
          else
            return done ? done.call(bindObject) : null;
        }
        if (self2.currentState === finalState) {
          return done ? done.call(bindObject, err) : null;
        }
        self2.runTo(finalState, done, bindObject, err);
      });
    };
    AcceptorStateMachine.prototype.addState = function addState(name, acceptState, failState, fn) {
      if (typeof acceptState === "function") {
        fn = acceptState;
        acceptState = null;
        failState = null;
      } else if (typeof failState === "function") {
        fn = failState;
        failState = null;
      }
      if (!this.currentState)
        this.currentState = name;
      this.states[name] = { accept: acceptState, fail: failState, fn };
      return this;
    };
    module2.exports = AcceptorStateMachine;
  }
});

// node_modules/jmespath/jmespath.js
var require_jmespath = __commonJS({
  "node_modules/jmespath/jmespath.js"(exports2) {
    "use strict";
    (function(exports3) {
      "use strict";
      function isArray(obj) {
        if (obj !== null) {
          return Object.prototype.toString.call(obj) === "[object Array]";
        } else {
          return false;
        }
      }
      function isObject(obj) {
        if (obj !== null) {
          return Object.prototype.toString.call(obj) === "[object Object]";
        } else {
          return false;
        }
      }
      function strictDeepEqual(first, second) {
        if (first === second) {
          return true;
        }
        var firstType = Object.prototype.toString.call(first);
        if (firstType !== Object.prototype.toString.call(second)) {
          return false;
        }
        if (isArray(first) === true) {
          if (first.length !== second.length) {
            return false;
          }
          for (var i = 0; i < first.length; i++) {
            if (strictDeepEqual(first[i], second[i]) === false) {
              return false;
            }
          }
          return true;
        }
        if (isObject(first) === true) {
          var keysSeen = {};
          for (var key in first) {
            if (hasOwnProperty.call(first, key)) {
              if (strictDeepEqual(first[key], second[key]) === false) {
                return false;
              }
              keysSeen[key] = true;
            }
          }
          for (var key2 in second) {
            if (hasOwnProperty.call(second, key2)) {
              if (keysSeen[key2] !== true) {
                return false;
              }
            }
          }
          return true;
        }
        return false;
      }
      function isFalse(obj) {
        if (obj === "" || obj === false || obj === null) {
          return true;
        } else if (isArray(obj) && obj.length === 0) {
          return true;
        } else if (isObject(obj)) {
          for (var key in obj) {
            if (obj.hasOwnProperty(key)) {
              return false;
            }
          }
          return true;
        } else {
          return false;
        }
      }
      function objValues(obj) {
        var keys = Object.keys(obj);
        var values = [];
        for (var i = 0; i < keys.length; i++) {
          values.push(obj[keys[i]]);
        }
        return values;
      }
      function merge(a, b) {
        var merged = {};
        for (var key in a) {
          merged[key] = a[key];
        }
        for (var key2 in b) {
          merged[key2] = b[key2];
        }
        return merged;
      }
      var trimLeft;
      if (typeof String.prototype.trimLeft === "function") {
        trimLeft = function(str) {
          return str.trimLeft();
        };
      } else {
        trimLeft = function(str) {
          return str.match(/^\s*(.*)/)[1];
        };
      }
      var TYPE_NUMBER = 0;
      var TYPE_ANY = 1;
      var TYPE_STRING = 2;
      var TYPE_ARRAY = 3;
      var TYPE_OBJECT = 4;
      var TYPE_BOOLEAN = 5;
      var TYPE_EXPREF = 6;
      var TYPE_NULL = 7;
      var TYPE_ARRAY_NUMBER = 8;
      var TYPE_ARRAY_STRING = 9;
      var TYPE_NAME_TABLE = {
        0: "number",
        1: "any",
        2: "string",
        3: "array",
        4: "object",
        5: "boolean",
        6: "expression",
        7: "null",
        8: "Array<number>",
        9: "Array<string>"
      };
      var TOK_EOF = "EOF";
      var TOK_UNQUOTEDIDENTIFIER = "UnquotedIdentifier";
      var TOK_QUOTEDIDENTIFIER = "QuotedIdentifier";
      var TOK_RBRACKET = "Rbracket";
      var TOK_RPAREN = "Rparen";
      var TOK_COMMA = "Comma";
      var TOK_COLON = "Colon";
      var TOK_RBRACE = "Rbrace";
      var TOK_NUMBER = "Number";
      var TOK_CURRENT = "Current";
      var TOK_EXPREF = "Expref";
      var TOK_PIPE = "Pipe";
      var TOK_OR = "Or";
      var TOK_AND = "And";
      var TOK_EQ = "EQ";
      var TOK_GT = "GT";
      var TOK_LT = "LT";
      var TOK_GTE = "GTE";
      var TOK_LTE = "LTE";
      var TOK_NE = "NE";
      var TOK_FLATTEN = "Flatten";
      var TOK_STAR = "Star";
      var TOK_FILTER = "Filter";
      var TOK_DOT = "Dot";
      var TOK_NOT = "Not";
      var TOK_LBRACE = "Lbrace";
      var TOK_LBRACKET = "Lbracket";
      var TOK_LPAREN = "Lparen";
      var TOK_LITERAL = "Literal";
      var basicTokens = {
        ".": TOK_DOT,
        "*": TOK_STAR,
        ",": TOK_COMMA,
        ":": TOK_COLON,
        "{": TOK_LBRACE,
        "}": TOK_RBRACE,
        "]": TOK_RBRACKET,
        "(": TOK_LPAREN,
        ")": TOK_RPAREN,
        "@": TOK_CURRENT
      };
      var operatorStartToken = {
        "<": true,
        ">": true,
        "=": true,
        "!": true
      };
      var skipChars = {
        " ": true,
        "	": true,
        "\n": true
      };
      function isAlpha(ch) {
        return ch >= "a" && ch <= "z" || ch >= "A" && ch <= "Z" || ch === "_";
      }
      function isNum(ch) {
        return ch >= "0" && ch <= "9" || ch === "-";
      }
      function isAlphaNum(ch) {
        return ch >= "a" && ch <= "z" || ch >= "A" && ch <= "Z" || ch >= "0" && ch <= "9" || ch === "_";
      }
      function Lexer() {
      }
      Lexer.prototype = {
        tokenize: function(stream) {
          var tokens = [];
          this._current = 0;
          var start;
          var identifier;
          var token;
          while (this._current < stream.length) {
            if (isAlpha(stream[this._current])) {
              start = this._current;
              identifier = this._consumeUnquotedIdentifier(stream);
              tokens.push({
                type: TOK_UNQUOTEDIDENTIFIER,
                value: identifier,
                start
              });
            } else if (basicTokens[stream[this._current]] !== void 0) {
              tokens.push({
                type: basicTokens[stream[this._current]],
                value: stream[this._current],
                start: this._current
              });
              this._current++;
            } else if (isNum(stream[this._current])) {
              token = this._consumeNumber(stream);
              tokens.push(token);
            } else if (stream[this._current] === "[") {
              token = this._consumeLBracket(stream);
              tokens.push(token);
            } else if (stream[this._current] === '"') {
              start = this._current;
              identifier = this._consumeQuotedIdentifier(stream);
              tokens.push({
                type: TOK_QUOTEDIDENTIFIER,
                value: identifier,
                start
              });
            } else if (stream[this._current] === "'") {
              start = this._current;
              identifier = this._consumeRawStringLiteral(stream);
              tokens.push({
                type: TOK_LITERAL,
                value: identifier,
                start
              });
            } else if (stream[this._current] === "`") {
              start = this._current;
              var literal = this._consumeLiteral(stream);
              tokens.push({
                type: TOK_LITERAL,
                value: literal,
                start
              });
            } else if (operatorStartToken[stream[this._current]] !== void 0) {
              tokens.push(this._consumeOperator(stream));
            } else if (skipChars[stream[this._current]] !== void 0) {
              this._current++;
            } else if (stream[this._current] === "&") {
              start = this._current;
              this._current++;
              if (stream[this._current] === "&") {
                this._current++;
                tokens.push({ type: TOK_AND, value: "&&", start });
              } else {
                tokens.push({ type: TOK_EXPREF, value: "&", start });
              }
            } else if (stream[this._current] === "|") {
              start = this._current;
              this._current++;
              if (stream[this._current] === "|") {
                this._current++;
                tokens.push({ type: TOK_OR, value: "||", start });
              } else {
                tokens.push({ type: TOK_PIPE, value: "|", start });
              }
            } else {
              var error = new Error("Unknown character:" + stream[this._current]);
              error.name = "LexerError";
              throw error;
            }
          }
          return tokens;
        },
        _consumeUnquotedIdentifier: function(stream) {
          var start = this._current;
          this._current++;
          while (this._current < stream.length && isAlphaNum(stream[this._current])) {
            this._current++;
          }
          return stream.slice(start, this._current);
        },
        _consumeQuotedIdentifier: function(stream) {
          var start = this._current;
          this._current++;
          var maxLength = stream.length;
          while (stream[this._current] !== '"' && this._current < maxLength) {
            var current = this._current;
            if (stream[current] === "\\" && (stream[current + 1] === "\\" || stream[current + 1] === '"')) {
              current += 2;
            } else {
              current++;
            }
            this._current = current;
          }
          this._current++;
          return JSON.parse(stream.slice(start, this._current));
        },
        _consumeRawStringLiteral: function(stream) {
          var start = this._current;
          this._current++;
          var maxLength = stream.length;
          while (stream[this._current] !== "'" && this._current < maxLength) {
            var current = this._current;
            if (stream[current] === "\\" && (stream[current + 1] === "\\" || stream[current + 1] === "'")) {
              current += 2;
            } else {
              current++;
            }
            this._current = current;
          }
          this._current++;
          var literal = stream.slice(start + 1, this._current - 1);
          return literal.replace("\\'", "'");
        },
        _consumeNumber: function(stream) {
          var start = this._current;
          this._current++;
          var maxLength = stream.length;
          while (isNum(stream[this._current]) && this._current < maxLength) {
            this._current++;
          }
          var value = parseInt(stream.slice(start, this._current));
          return { type: TOK_NUMBER, value, start };
        },
        _consumeLBracket: function(stream) {
          var start = this._current;
          this._current++;
          if (stream[this._current] === "?") {
            this._current++;
            return { type: TOK_FILTER, value: "[?", start };
          } else if (stream[this._current] === "]") {
            this._current++;
            return { type: TOK_FLATTEN, value: "[]", start };
          } else {
            return { type: TOK_LBRACKET, value: "[", start };
          }
        },
        _consumeOperator: function(stream) {
          var start = this._current;
          var startingChar = stream[start];
          this._current++;
          if (startingChar === "!") {
            if (stream[this._current] === "=") {
              this._current++;
              return { type: TOK_NE, value: "!=", start };
            } else {
              return { type: TOK_NOT, value: "!", start };
            }
          } else if (startingChar === "<") {
            if (stream[this._current] === "=") {
              this._current++;
              return { type: TOK_LTE, value: "<=", start };
            } else {
              return { type: TOK_LT, value: "<", start };
            }
          } else if (startingChar === ">") {
            if (stream[this._current] === "=") {
              this._current++;
              return { type: TOK_GTE, value: ">=", start };
            } else {
              return { type: TOK_GT, value: ">", start };
            }
          } else if (startingChar === "=") {
            if (stream[this._current] === "=") {
              this._current++;
              return { type: TOK_EQ, value: "==", start };
            }
          }
        },
        _consumeLiteral: function(stream) {
          this._current++;
          var start = this._current;
          var maxLength = stream.length;
          var literal;
          while (stream[this._current] !== "`" && this._current < maxLength) {
            var current = this._current;
            if (stream[current] === "\\" && (stream[current + 1] === "\\" || stream[current + 1] === "`")) {
              current += 2;
            } else {
              current++;
            }
            this._current = current;
          }
          var literalString = trimLeft(stream.slice(start, this._current));
          literalString = literalString.replace("\\`", "`");
          if (this._looksLikeJSON(literalString)) {
            literal = JSON.parse(literalString);
          } else {
            literal = JSON.parse('"' + literalString + '"');
          }
          this._current++;
          return literal;
        },
        _looksLikeJSON: function(literalString) {
          var startingChars = '[{"';
          var jsonLiterals = ["true", "false", "null"];
          var numberLooking = "-0123456789";
          if (literalString === "") {
            return false;
          } else if (startingChars.indexOf(literalString[0]) >= 0) {
            return true;
          } else if (jsonLiterals.indexOf(literalString) >= 0) {
            return true;
          } else if (numberLooking.indexOf(literalString[0]) >= 0) {
            try {
              JSON.parse(literalString);
              return true;
            } catch (ex) {
              return false;
            }
          } else {
            return false;
          }
        }
      };
      var bindingPower = {};
      bindingPower[TOK_EOF] = 0;
      bindingPower[TOK_UNQUOTEDIDENTIFIER] = 0;
      bindingPower[TOK_QUOTEDIDENTIFIER] = 0;
      bindingPower[TOK_RBRACKET] = 0;
      bindingPower[TOK_RPAREN] = 0;
      bindingPower[TOK_COMMA] = 0;
      bindingPower[TOK_RBRACE] = 0;
      bindingPower[TOK_NUMBER] = 0;
      bindingPower[TOK_CURRENT] = 0;
      bindingPower[TOK_EXPREF] = 0;
      bindingPower[TOK_PIPE] = 1;
      bindingPower[TOK_OR] = 2;
      bindingPower[TOK_AND] = 3;
      bindingPower[TOK_EQ] = 5;
      bindingPower[TOK_GT] = 5;
      bindingPower[TOK_LT] = 5;
      bindingPower[TOK_GTE] = 5;
      bindingPower[TOK_LTE] = 5;
      bindingPower[TOK_NE] = 5;
      bindingPower[TOK_FLATTEN] = 9;
      bindingPower[TOK_STAR] = 20;
      bindingPower[TOK_FILTER] = 21;
      bindingPower[TOK_DOT] = 40;
      bindingPower[TOK_NOT] = 45;
      bindingPower[TOK_LBRACE] = 50;
      bindingPower[TOK_LBRACKET] = 55;
      bindingPower[TOK_LPAREN] = 60;
      function Parser() {
      }
      Parser.prototype = {
        parse: function(expression) {
          this._loadTokens(expression);
          this.index = 0;
          var ast = this.expression(0);
          if (this._lookahead(0) !== TOK_EOF) {
            var t = this._lookaheadToken(0);
            var error = new Error(
              "Unexpected token type: " + t.type + ", value: " + t.value
            );
            error.name = "ParserError";
            throw error;
          }
          return ast;
        },
        _loadTokens: function(expression) {
          var lexer = new Lexer();
          var tokens = lexer.tokenize(expression);
          tokens.push({ type: TOK_EOF, value: "", start: expression.length });
          this.tokens = tokens;
        },
        expression: function(rbp) {
          var leftToken = this._lookaheadToken(0);
          this._advance();
          var left = this.nud(leftToken);
          var currentToken = this._lookahead(0);
          while (rbp < bindingPower[currentToken]) {
            this._advance();
            left = this.led(currentToken, left);
            currentToken = this._lookahead(0);
          }
          return left;
        },
        _lookahead: function(number) {
          return this.tokens[this.index + number].type;
        },
        _lookaheadToken: function(number) {
          return this.tokens[this.index + number];
        },
        _advance: function() {
          this.index++;
        },
        nud: function(token) {
          var left;
          var right;
          var expression;
          switch (token.type) {
            case TOK_LITERAL:
              return { type: "Literal", value: token.value };
            case TOK_UNQUOTEDIDENTIFIER:
              return { type: "Field", name: token.value };
            case TOK_QUOTEDIDENTIFIER:
              var node = { type: "Field", name: token.value };
              if (this._lookahead(0) === TOK_LPAREN) {
                throw new Error("Quoted identifier not allowed for function names.");
              }
              return node;
            case TOK_NOT:
              right = this.expression(bindingPower.Not);
              return { type: "NotExpression", children: [right] };
            case TOK_STAR:
              left = { type: "Identity" };
              right = null;
              if (this._lookahead(0) === TOK_RBRACKET) {
                right = { type: "Identity" };
              } else {
                right = this._parseProjectionRHS(bindingPower.Star);
              }
              return { type: "ValueProjection", children: [left, right] };
            case TOK_FILTER:
              return this.led(token.type, { type: "Identity" });
            case TOK_LBRACE:
              return this._parseMultiselectHash();
            case TOK_FLATTEN:
              left = { type: TOK_FLATTEN, children: [{ type: "Identity" }] };
              right = this._parseProjectionRHS(bindingPower.Flatten);
              return { type: "Projection", children: [left, right] };
            case TOK_LBRACKET:
              if (this._lookahead(0) === TOK_NUMBER || this._lookahead(0) === TOK_COLON) {
                right = this._parseIndexExpression();
                return this._projectIfSlice({ type: "Identity" }, right);
              } else if (this._lookahead(0) === TOK_STAR && this._lookahead(1) === TOK_RBRACKET) {
                this._advance();
                this._advance();
                right = this._parseProjectionRHS(bindingPower.Star);
                return {
                  type: "Projection",
                  children: [{ type: "Identity" }, right]
                };
              }
              return this._parseMultiselectList();
            case TOK_CURRENT:
              return { type: TOK_CURRENT };
            case TOK_EXPREF:
              expression = this.expression(bindingPower.Expref);
              return { type: "ExpressionReference", children: [expression] };
            case TOK_LPAREN:
              var args = [];
              while (this._lookahead(0) !== TOK_RPAREN) {
                if (this._lookahead(0) === TOK_CURRENT) {
                  expression = { type: TOK_CURRENT };
                  this._advance();
                } else {
                  expression = this.expression(0);
                }
                args.push(expression);
              }
              this._match(TOK_RPAREN);
              return args[0];
            default:
              this._errorToken(token);
          }
        },
        led: function(tokenName, left) {
          var right;
          switch (tokenName) {
            case TOK_DOT:
              var rbp = bindingPower.Dot;
              if (this._lookahead(0) !== TOK_STAR) {
                right = this._parseDotRHS(rbp);
                return { type: "Subexpression", children: [left, right] };
              }
              this._advance();
              right = this._parseProjectionRHS(rbp);
              return { type: "ValueProjection", children: [left, right] };
            case TOK_PIPE:
              right = this.expression(bindingPower.Pipe);
              return { type: TOK_PIPE, children: [left, right] };
            case TOK_OR:
              right = this.expression(bindingPower.Or);
              return { type: "OrExpression", children: [left, right] };
            case TOK_AND:
              right = this.expression(bindingPower.And);
              return { type: "AndExpression", children: [left, right] };
            case TOK_LPAREN:
              var name = left.name;
              var args = [];
              var expression, node;
              while (this._lookahead(0) !== TOK_RPAREN) {
                if (this._lookahead(0) === TOK_CURRENT) {
                  expression = { type: TOK_CURRENT };
                  this._advance();
                } else {
                  expression = this.expression(0);
                }
                if (this._lookahead(0) === TOK_COMMA) {
                  this._match(TOK_COMMA);
                }
                args.push(expression);
              }
              this._match(TOK_RPAREN);
              node = { type: "Function", name, children: args };
              return node;
            case TOK_FILTER:
              var condition = this.expression(0);
              this._match(TOK_RBRACKET);
              if (this._lookahead(0) === TOK_FLATTEN) {
                right = { type: "Identity" };
              } else {
                right = this._parseProjectionRHS(bindingPower.Filter);
              }
              return { type: "FilterProjection", children: [left, right, condition] };
            case TOK_FLATTEN:
              var leftNode = { type: TOK_FLATTEN, children: [left] };
              var rightNode = this._parseProjectionRHS(bindingPower.Flatten);
              return { type: "Projection", children: [leftNode, rightNode] };
            case TOK_EQ:
            case TOK_NE:
            case TOK_GT:
            case TOK_GTE:
            case TOK_LT:
            case TOK_LTE:
              return this._parseComparator(left, tokenName);
            case TOK_LBRACKET:
              var token = this._lookaheadToken(0);
              if (token.type === TOK_NUMBER || token.type === TOK_COLON) {
                right = this._parseIndexExpression();
                return this._projectIfSlice(left, right);
              }
              this._match(TOK_STAR);
              this._match(TOK_RBRACKET);
              right = this._parseProjectionRHS(bindingPower.Star);
              return { type: "Projection", children: [left, right] };
            default:
              this._errorToken(this._lookaheadToken(0));
          }
        },
        _match: function(tokenType) {
          if (this._lookahead(0) === tokenType) {
            this._advance();
          } else {
            var t = this._lookaheadToken(0);
            var error = new Error("Expected " + tokenType + ", got: " + t.type);
            error.name = "ParserError";
            throw error;
          }
        },
        _errorToken: function(token) {
          var error = new Error("Invalid token (" + token.type + '): "' + token.value + '"');
          error.name = "ParserError";
          throw error;
        },
        _parseIndexExpression: function() {
          if (this._lookahead(0) === TOK_COLON || this._lookahead(1) === TOK_COLON) {
            return this._parseSliceExpression();
          } else {
            var node = {
              type: "Index",
              value: this._lookaheadToken(0).value
            };
            this._advance();
            this._match(TOK_RBRACKET);
            return node;
          }
        },
        _projectIfSlice: function(left, right) {
          var indexExpr = { type: "IndexExpression", children: [left, right] };
          if (right.type === "Slice") {
            return {
              type: "Projection",
              children: [indexExpr, this._parseProjectionRHS(bindingPower.Star)]
            };
          } else {
            return indexExpr;
          }
        },
        _parseSliceExpression: function() {
          var parts = [null, null, null];
          var index = 0;
          var currentToken = this._lookahead(0);
          while (currentToken !== TOK_RBRACKET && index < 3) {
            if (currentToken === TOK_COLON) {
              index++;
              this._advance();
            } else if (currentToken === TOK_NUMBER) {
              parts[index] = this._lookaheadToken(0).value;
              this._advance();
            } else {
              var t = this._lookahead(0);
              var error = new Error("Syntax error, unexpected token: " + t.value + "(" + t.type + ")");
              error.name = "Parsererror";
              throw error;
            }
            currentToken = this._lookahead(0);
          }
          this._match(TOK_RBRACKET);
          return {
            type: "Slice",
            children: parts
          };
        },
        _parseComparator: function(left, comparator) {
          var right = this.expression(bindingPower[comparator]);
          return { type: "Comparator", name: comparator, children: [left, right] };
        },
        _parseDotRHS: function(rbp) {
          var lookahead = this._lookahead(0);
          var exprTokens = [TOK_UNQUOTEDIDENTIFIER, TOK_QUOTEDIDENTIFIER, TOK_STAR];
          if (exprTokens.indexOf(lookahead) >= 0) {
            return this.expression(rbp);
          } else if (lookahead === TOK_LBRACKET) {
            this._match(TOK_LBRACKET);
            return this._parseMultiselectList();
          } else if (lookahead === TOK_LBRACE) {
            this._match(TOK_LBRACE);
            return this._parseMultiselectHash();
          }
        },
        _parseProjectionRHS: function(rbp) {
          var right;
          if (bindingPower[this._lookahead(0)] < 10) {
            right = { type: "Identity" };
          } else if (this._lookahead(0) === TOK_LBRACKET) {
            right = this.expression(rbp);
          } else if (this._lookahead(0) === TOK_FILTER) {
            right = this.expression(rbp);
          } else if (this._lookahead(0) === TOK_DOT) {
            this._match(TOK_DOT);
            right = this._parseDotRHS(rbp);
          } else {
            var t = this._lookaheadToken(0);
            var error = new Error("Sytanx error, unexpected token: " + t.value + "(" + t.type + ")");
            error.name = "ParserError";
            throw error;
          }
          return right;
        },
        _parseMultiselectList: function() {
          var expressions = [];
          while (this._lookahead(0) !== TOK_RBRACKET) {
            var expression = this.expression(0);
            expressions.push(expression);
            if (this._lookahead(0) === TOK_COMMA) {
              this._match(TOK_COMMA);
              if (this._lookahead(0) === TOK_RBRACKET) {
                throw new Error("Unexpected token Rbracket");
              }
            }
          }
          this._match(TOK_RBRACKET);
          return { type: "MultiSelectList", children: expressions };
        },
        _parseMultiselectHash: function() {
          var pairs = [];
          var identifierTypes = [TOK_UNQUOTEDIDENTIFIER, TOK_QUOTEDIDENTIFIER];
          var keyToken, keyName, value, node;
          for (; ; ) {
            keyToken = this._lookaheadToken(0);
            if (identifierTypes.indexOf(keyToken.type) < 0) {
              throw new Error("Expecting an identifier token, got: " + keyToken.type);
            }
            keyName = keyToken.value;
            this._advance();
            this._match(TOK_COLON);
            value = this.expression(0);
            node = { type: "KeyValuePair", name: keyName, value };
            pairs.push(node);
            if (this._lookahead(0) === TOK_COMMA) {
              this._match(TOK_COMMA);
            } else if (this._lookahead(0) === TOK_RBRACE) {
              this._match(TOK_RBRACE);
              break;
            }
          }
          return { type: "MultiSelectHash", children: pairs };
        }
      };
      function TreeInterpreter(runtime) {
        this.runtime = runtime;
      }
      TreeInterpreter.prototype = {
        search: function(node, value) {
          return this.visit(node, value);
        },
        visit: function(node, value) {
          var matched, current, result, first, second, field, left, right, collected, i;
          switch (node.type) {
            case "Field":
              if (value !== null && isObject(value)) {
                field = value[node.name];
                if (field === void 0) {
                  return null;
                } else {
                  return field;
                }
              }
              return null;
            case "Subexpression":
              result = this.visit(node.children[0], value);
              for (i = 1; i < node.children.length; i++) {
                result = this.visit(node.children[1], result);
                if (result === null) {
                  return null;
                }
              }
              return result;
            case "IndexExpression":
              left = this.visit(node.children[0], value);
              right = this.visit(node.children[1], left);
              return right;
            case "Index":
              if (!isArray(value)) {
                return null;
              }
              var index = node.value;
              if (index < 0) {
                index = value.length + index;
              }
              result = value[index];
              if (result === void 0) {
                result = null;
              }
              return result;
            case "Slice":
              if (!isArray(value)) {
                return null;
              }
              var sliceParams = node.children.slice(0);
              var computed = this.computeSliceParams(value.length, sliceParams);
              var start = computed[0];
              var stop = computed[1];
              var step = computed[2];
              result = [];
              if (step > 0) {
                for (i = start; i < stop; i += step) {
                  result.push(value[i]);
                }
              } else {
                for (i = start; i > stop; i += step) {
                  result.push(value[i]);
                }
              }
              return result;
            case "Projection":
              var base = this.visit(node.children[0], value);
              if (!isArray(base)) {
                return null;
              }
              collected = [];
              for (i = 0; i < base.length; i++) {
                current = this.visit(node.children[1], base[i]);
                if (current !== null) {
                  collected.push(current);
                }
              }
              return collected;
            case "ValueProjection":
              base = this.visit(node.children[0], value);
              if (!isObject(base)) {
                return null;
              }
              collected = [];
              var values = objValues(base);
              for (i = 0; i < values.length; i++) {
                current = this.visit(node.children[1], values[i]);
                if (current !== null) {
                  collected.push(current);
                }
              }
              return collected;
            case "FilterProjection":
              base = this.visit(node.children[0], value);
              if (!isArray(base)) {
                return null;
              }
              var filtered = [];
              var finalResults = [];
              for (i = 0; i < base.length; i++) {
                matched = this.visit(node.children[2], base[i]);
                if (!isFalse(matched)) {
                  filtered.push(base[i]);
                }
              }
              for (var j = 0; j < filtered.length; j++) {
                current = this.visit(node.children[1], filtered[j]);
                if (current !== null) {
                  finalResults.push(current);
                }
              }
              return finalResults;
            case "Comparator":
              first = this.visit(node.children[0], value);
              second = this.visit(node.children[1], value);
              switch (node.name) {
                case TOK_EQ:
                  result = strictDeepEqual(first, second);
                  break;
                case TOK_NE:
                  result = !strictDeepEqual(first, second);
                  break;
                case TOK_GT:
                  result = first > second;
                  break;
                case TOK_GTE:
                  result = first >= second;
                  break;
                case TOK_LT:
                  result = first < second;
                  break;
                case TOK_LTE:
                  result = first <= second;
                  break;
                default:
                  throw new Error("Unknown comparator: " + node.name);
              }
              return result;
            case TOK_FLATTEN:
              var original = this.visit(node.children[0], value);
              if (!isArray(original)) {
                return null;
              }
              var merged = [];
              for (i = 0; i < original.length; i++) {
                current = original[i];
                if (isArray(current)) {
                  merged.push.apply(merged, current);
                } else {
                  merged.push(current);
                }
              }
              return merged;
            case "Identity":
              return value;
            case "MultiSelectList":
              if (value === null) {
                return null;
              }
              collected = [];
              for (i = 0; i < node.children.length; i++) {
                collected.push(this.visit(node.children[i], value));
              }
              return collected;
            case "MultiSelectHash":
              if (value === null) {
                return null;
              }
              collected = {};
              var child;
              for (i = 0; i < node.children.length; i++) {
                child = node.children[i];
                collected[child.name] = this.visit(child.value, value);
              }
              return collected;
            case "OrExpression":
              matched = this.visit(node.children[0], value);
              if (isFalse(matched)) {
                matched = this.visit(node.children[1], value);
              }
              return matched;
            case "AndExpression":
              first = this.visit(node.children[0], value);
              if (isFalse(first) === true) {
                return first;
              }
              return this.visit(node.children[1], value);
            case "NotExpression":
              first = this.visit(node.children[0], value);
              return isFalse(first);
            case "Literal":
              return node.value;
            case TOK_PIPE:
              left = this.visit(node.children[0], value);
              return this.visit(node.children[1], left);
            case TOK_CURRENT:
              return value;
            case "Function":
              var resolvedArgs = [];
              for (i = 0; i < node.children.length; i++) {
                resolvedArgs.push(this.visit(node.children[i], value));
              }
              return this.runtime.callFunction(node.name, resolvedArgs);
            case "ExpressionReference":
              var refNode = node.children[0];
              refNode.jmespathType = TOK_EXPREF;
              return refNode;
            default:
              throw new Error("Unknown node type: " + node.type);
          }
        },
        computeSliceParams: function(arrayLength, sliceParams) {
          var start = sliceParams[0];
          var stop = sliceParams[1];
          var step = sliceParams[2];
          var computed = [null, null, null];
          if (step === null) {
            step = 1;
          } else if (step === 0) {
            var error = new Error("Invalid slice, step cannot be 0");
            error.name = "RuntimeError";
            throw error;
          }
          var stepValueNegative = step < 0 ? true : false;
          if (start === null) {
            start = stepValueNegative ? arrayLength - 1 : 0;
          } else {
            start = this.capSliceRange(arrayLength, start, step);
          }
          if (stop === null) {
            stop = stepValueNegative ? -1 : arrayLength;
          } else {
            stop = this.capSliceRange(arrayLength, stop, step);
          }
          computed[0] = start;
          computed[1] = stop;
          computed[2] = step;
          return computed;
        },
        capSliceRange: function(arrayLength, actualValue, step) {
          if (actualValue < 0) {
            actualValue += arrayLength;
            if (actualValue < 0) {
              actualValue = step < 0 ? -1 : 0;
            }
          } else if (actualValue >= arrayLength) {
            actualValue = step < 0 ? arrayLength - 1 : arrayLength;
          }
          return actualValue;
        }
      };
      function Runtime2(interpreter) {
        this._interpreter = interpreter;
        this.functionTable = {
          // name: [function, <signature>]
          // The <signature> can be:
          //
          // {
          //   args: [[type1, type2], [type1, type2]],
          //   variadic: true|false
          // }
          //
          // Each arg in the arg list is a list of valid types
          // (if the function is overloaded and supports multiple
          // types.  If the type is "any" then no type checking
          // occurs on the argument.  Variadic is optional
          // and if not provided is assumed to be false.
          abs: { _func: this._functionAbs, _signature: [{ types: [TYPE_NUMBER] }] },
          avg: { _func: this._functionAvg, _signature: [{ types: [TYPE_ARRAY_NUMBER] }] },
          ceil: { _func: this._functionCeil, _signature: [{ types: [TYPE_NUMBER] }] },
          contains: {
            _func: this._functionContains,
            _signature: [
              { types: [TYPE_STRING, TYPE_ARRAY] },
              { types: [TYPE_ANY] }
            ]
          },
          "ends_with": {
            _func: this._functionEndsWith,
            _signature: [{ types: [TYPE_STRING] }, { types: [TYPE_STRING] }]
          },
          floor: { _func: this._functionFloor, _signature: [{ types: [TYPE_NUMBER] }] },
          length: {
            _func: this._functionLength,
            _signature: [{ types: [TYPE_STRING, TYPE_ARRAY, TYPE_OBJECT] }]
          },
          map: {
            _func: this._functionMap,
            _signature: [{ types: [TYPE_EXPREF] }, { types: [TYPE_ARRAY] }]
          },
          max: {
            _func: this._functionMax,
            _signature: [{ types: [TYPE_ARRAY_NUMBER, TYPE_ARRAY_STRING] }]
          },
          "merge": {
            _func: this._functionMerge,
            _signature: [{ types: [TYPE_OBJECT], variadic: true }]
          },
          "max_by": {
            _func: this._functionMaxBy,
            _signature: [{ types: [TYPE_ARRAY] }, { types: [TYPE_EXPREF] }]
          },
          sum: { _func: this._functionSum, _signature: [{ types: [TYPE_ARRAY_NUMBER] }] },
          "starts_with": {
            _func: this._functionStartsWith,
            _signature: [{ types: [TYPE_STRING] }, { types: [TYPE_STRING] }]
          },
          min: {
            _func: this._functionMin,
            _signature: [{ types: [TYPE_ARRAY_NUMBER, TYPE_ARRAY_STRING] }]
          },
          "min_by": {
            _func: this._functionMinBy,
            _signature: [{ types: [TYPE_ARRAY] }, { types: [TYPE_EXPREF] }]
          },
          type: { _func: this._functionType, _signature: [{ types: [TYPE_ANY] }] },
          keys: { _func: this._functionKeys, _signature: [{ types: [TYPE_OBJECT] }] },
          values: { _func: this._functionValues, _signature: [{ types: [TYPE_OBJECT] }] },
          sort: { _func: this._functionSort, _signature: [{ types: [TYPE_ARRAY_STRING, TYPE_ARRAY_NUMBER] }] },
          "sort_by": {
            _func: this._functionSortBy,
            _signature: [{ types: [TYPE_ARRAY] }, { types: [TYPE_EXPREF] }]
          },
          join: {
            _func: this._functionJoin,
            _signature: [
              { types: [TYPE_STRING] },
              { types: [TYPE_ARRAY_STRING] }
            ]
          },
          reverse: {
            _func: this._functionReverse,
            _signature: [{ types: [TYPE_STRING, TYPE_ARRAY] }]
          },
          "to_array": { _func: this._functionToArray, _signature: [{ types: [TYPE_ANY] }] },
          "to_string": { _func: this._functionToString, _signature: [{ types: [TYPE_ANY] }] },
          "to_number": { _func: this._functionToNumber, _signature: [{ types: [TYPE_ANY] }] },
          "not_null": {
            _func: this._functionNotNull,
            _signature: [{ types: [TYPE_ANY], variadic: true }]
          }
        };
      }
      Runtime2.prototype = {
        callFunction: function(name, resolvedArgs) {
          var functionEntry = this.functionTable[name];
          if (functionEntry === void 0) {
            throw new Error("Unknown function: " + name + "()");
          }
          this._validateArgs(name, resolvedArgs, functionEntry._signature);
          return functionEntry._func.call(this, resolvedArgs);
        },
        _validateArgs: function(name, args, signature) {
          var pluralized;
          if (signature[signature.length - 1].variadic) {
            if (args.length < signature.length) {
              pluralized = signature.length === 1 ? " argument" : " arguments";
              throw new Error("ArgumentError: " + name + "() takes at least" + signature.length + pluralized + " but received " + args.length);
            }
          } else if (args.length !== signature.length) {
            pluralized = signature.length === 1 ? " argument" : " arguments";
            throw new Error("ArgumentError: " + name + "() takes " + signature.length + pluralized + " but received " + args.length);
          }
          var currentSpec;
          var actualType;
          var typeMatched;
          for (var i = 0; i < signature.length; i++) {
            typeMatched = false;
            currentSpec = signature[i].types;
            actualType = this._getTypeName(args[i]);
            for (var j = 0; j < currentSpec.length; j++) {
              if (this._typeMatches(actualType, currentSpec[j], args[i])) {
                typeMatched = true;
                break;
              }
            }
            if (!typeMatched) {
              var expected = currentSpec.map(function(typeIdentifier) {
                return TYPE_NAME_TABLE[typeIdentifier];
              }).join(",");
              throw new Error("TypeError: " + name + "() expected argument " + (i + 1) + " to be type " + expected + " but received type " + TYPE_NAME_TABLE[actualType] + " instead.");
            }
          }
        },
        _typeMatches: function(actual, expected, argValue) {
          if (expected === TYPE_ANY) {
            return true;
          }
          if (expected === TYPE_ARRAY_STRING || expected === TYPE_ARRAY_NUMBER || expected === TYPE_ARRAY) {
            if (expected === TYPE_ARRAY) {
              return actual === TYPE_ARRAY;
            } else if (actual === TYPE_ARRAY) {
              var subtype;
              if (expected === TYPE_ARRAY_NUMBER) {
                subtype = TYPE_NUMBER;
              } else if (expected === TYPE_ARRAY_STRING) {
                subtype = TYPE_STRING;
              }
              for (var i = 0; i < argValue.length; i++) {
                if (!this._typeMatches(
                  this._getTypeName(argValue[i]),
                  subtype,
                  argValue[i]
                )) {
                  return false;
                }
              }
              return true;
            }
          } else {
            return actual === expected;
          }
        },
        _getTypeName: function(obj) {
          switch (Object.prototype.toString.call(obj)) {
            case "[object String]":
              return TYPE_STRING;
            case "[object Number]":
              return TYPE_NUMBER;
            case "[object Array]":
              return TYPE_ARRAY;
            case "[object Boolean]":
              return TYPE_BOOLEAN;
            case "[object Null]":
              return TYPE_NULL;
            case "[object Object]":
              if (obj.jmespathType === TOK_EXPREF) {
                return TYPE_EXPREF;
              } else {
                return TYPE_OBJECT;
              }
          }
        },
        _functionStartsWith: function(resolvedArgs) {
          return resolvedArgs[0].lastIndexOf(resolvedArgs[1]) === 0;
        },
        _functionEndsWith: function(resolvedArgs) {
          var searchStr = resolvedArgs[0];
          var suffix = resolvedArgs[1];
          return searchStr.indexOf(suffix, searchStr.length - suffix.length) !== -1;
        },
        _functionReverse: function(resolvedArgs) {
          var typeName = this._getTypeName(resolvedArgs[0]);
          if (typeName === TYPE_STRING) {
            var originalStr = resolvedArgs[0];
            var reversedStr = "";
            for (var i = originalStr.length - 1; i >= 0; i--) {
              reversedStr += originalStr[i];
            }
            return reversedStr;
          } else {
            var reversedArray = resolvedArgs[0].slice(0);
            reversedArray.reverse();
            return reversedArray;
          }
        },
        _functionAbs: function(resolvedArgs) {
          return Math.abs(resolvedArgs[0]);
        },
        _functionCeil: function(resolvedArgs) {
          return Math.ceil(resolvedArgs[0]);
        },
        _functionAvg: function(resolvedArgs) {
          var sum = 0;
          var inputArray = resolvedArgs[0];
          for (var i = 0; i < inputArray.length; i++) {
            sum += inputArray[i];
          }
          return sum / inputArray.length;
        },
        _functionContains: function(resolvedArgs) {
          return resolvedArgs[0].indexOf(resolvedArgs[1]) >= 0;
        },
        _functionFloor: function(resolvedArgs) {
          return Math.floor(resolvedArgs[0]);
        },
        _functionLength: function(resolvedArgs) {
          if (!isObject(resolvedArgs[0])) {
            return resolvedArgs[0].length;
          } else {
            return Object.keys(resolvedArgs[0]).length;
          }
        },
        _functionMap: function(resolvedArgs) {
          var mapped = [];
          var interpreter = this._interpreter;
          var exprefNode = resolvedArgs[0];
          var elements = resolvedArgs[1];
          for (var i = 0; i < elements.length; i++) {
            mapped.push(interpreter.visit(exprefNode, elements[i]));
          }
          return mapped;
        },
        _functionMerge: function(resolvedArgs) {
          var merged = {};
          for (var i = 0; i < resolvedArgs.length; i++) {
            var current = resolvedArgs[i];
            for (var key in current) {
              merged[key] = current[key];
            }
          }
          return merged;
        },
        _functionMax: function(resolvedArgs) {
          if (resolvedArgs[0].length > 0) {
            var typeName = this._getTypeName(resolvedArgs[0][0]);
            if (typeName === TYPE_NUMBER) {
              return Math.max.apply(Math, resolvedArgs[0]);
            } else {
              var elements = resolvedArgs[0];
              var maxElement = elements[0];
              for (var i = 1; i < elements.length; i++) {
                if (maxElement.localeCompare(elements[i]) < 0) {
                  maxElement = elements[i];
                }
              }
              return maxElement;
            }
          } else {
            return null;
          }
        },
        _functionMin: function(resolvedArgs) {
          if (resolvedArgs[0].length > 0) {
            var typeName = this._getTypeName(resolvedArgs[0][0]);
            if (typeName === TYPE_NUMBER) {
              return Math.min.apply(Math, resolvedArgs[0]);
            } else {
              var elements = resolvedArgs[0];
              var minElement = elements[0];
              for (var i = 1; i < elements.length; i++) {
                if (elements[i].localeCompare(minElement) < 0) {
                  minElement = elements[i];
                }
              }
              return minElement;
            }
          } else {
            return null;
          }
        },
        _functionSum: function(resolvedArgs) {
          var sum = 0;
          var listToSum = resolvedArgs[0];
          for (var i = 0; i < listToSum.length; i++) {
            sum += listToSum[i];
          }
          return sum;
        },
        _functionType: function(resolvedArgs) {
          switch (this._getTypeName(resolvedArgs[0])) {
            case TYPE_NUMBER:
              return "number";
            case TYPE_STRING:
              return "string";
            case TYPE_ARRAY:
              return "array";
            case TYPE_OBJECT:
              return "object";
            case TYPE_BOOLEAN:
              return "boolean";
            case TYPE_EXPREF:
              return "expref";
            case TYPE_NULL:
              return "null";
          }
        },
        _functionKeys: function(resolvedArgs) {
          return Object.keys(resolvedArgs[0]);
        },
        _functionValues: function(resolvedArgs) {
          var obj = resolvedArgs[0];
          var keys = Object.keys(obj);
          var values = [];
          for (var i = 0; i < keys.length; i++) {
            values.push(obj[keys[i]]);
          }
          return values;
        },
        _functionJoin: function(resolvedArgs) {
          var joinChar = resolvedArgs[0];
          var listJoin = resolvedArgs[1];
          return listJoin.join(joinChar);
        },
        _functionToArray: function(resolvedArgs) {
          if (this._getTypeName(resolvedArgs[0]) === TYPE_ARRAY) {
            return resolvedArgs[0];
          } else {
            return [resolvedArgs[0]];
          }
        },
        _functionToString: function(resolvedArgs) {
          if (this._getTypeName(resolvedArgs[0]) === TYPE_STRING) {
            return resolvedArgs[0];
          } else {
            return JSON.stringify(resolvedArgs[0]);
          }
        },
        _functionToNumber: function(resolvedArgs) {
          var typeName = this._getTypeName(resolvedArgs[0]);
          var convertedValue;
          if (typeName === TYPE_NUMBER) {
            return resolvedArgs[0];
          } else if (typeName === TYPE_STRING) {
            convertedValue = +resolvedArgs[0];
            if (!isNaN(convertedValue)) {
              return convertedValue;
            }
          }
          return null;
        },
        _functionNotNull: function(resolvedArgs) {
          for (var i = 0; i < resolvedArgs.length; i++) {
            if (this._getTypeName(resolvedArgs[i]) !== TYPE_NULL) {
              return resolvedArgs[i];
            }
          }
          return null;
        },
        _functionSort: function(resolvedArgs) {
          var sortedArray = resolvedArgs[0].slice(0);
          sortedArray.sort();
          return sortedArray;
        },
        _functionSortBy: function(resolvedArgs) {
          var sortedArray = resolvedArgs[0].slice(0);
          if (sortedArray.length === 0) {
            return sortedArray;
          }
          var interpreter = this._interpreter;
          var exprefNode = resolvedArgs[1];
          var requiredType = this._getTypeName(
            interpreter.visit(exprefNode, sortedArray[0])
          );
          if ([TYPE_NUMBER, TYPE_STRING].indexOf(requiredType) < 0) {
            throw new Error("TypeError");
          }
          var that = this;
          var decorated = [];
          for (var i = 0; i < sortedArray.length; i++) {
            decorated.push([i, sortedArray[i]]);
          }
          decorated.sort(function(a, b) {
            var exprA = interpreter.visit(exprefNode, a[1]);
            var exprB = interpreter.visit(exprefNode, b[1]);
            if (that._getTypeName(exprA) !== requiredType) {
              throw new Error(
                "TypeError: expected " + requiredType + ", received " + that._getTypeName(exprA)
              );
            } else if (that._getTypeName(exprB) !== requiredType) {
              throw new Error(
                "TypeError: expected " + requiredType + ", received " + that._getTypeName(exprB)
              );
            }
            if (exprA > exprB) {
              return 1;
            } else if (exprA < exprB) {
              return -1;
            } else {
              return a[0] - b[0];
            }
          });
          for (var j = 0; j < decorated.length; j++) {
            sortedArray[j] = decorated[j][1];
          }
          return sortedArray;
        },
        _functionMaxBy: function(resolvedArgs) {
          var exprefNode = resolvedArgs[1];
          var resolvedArray = resolvedArgs[0];
          var keyFunction = this.createKeyFunction(exprefNode, [TYPE_NUMBER, TYPE_STRING]);
          var maxNumber = -Infinity;
          var maxRecord;
          var current;
          for (var i = 0; i < resolvedArray.length; i++) {
            current = keyFunction(resolvedArray[i]);
            if (current > maxNumber) {
              maxNumber = current;
              maxRecord = resolvedArray[i];
            }
          }
          return maxRecord;
        },
        _functionMinBy: function(resolvedArgs) {
          var exprefNode = resolvedArgs[1];
          var resolvedArray = resolvedArgs[0];
          var keyFunction = this.createKeyFunction(exprefNode, [TYPE_NUMBER, TYPE_STRING]);
          var minNumber = Infinity;
          var minRecord;
          var current;
          for (var i = 0; i < resolvedArray.length; i++) {
            current = keyFunction(resolvedArray[i]);
            if (current < minNumber) {
              minNumber = current;
              minRecord = resolvedArray[i];
            }
          }
          return minRecord;
        },
        createKeyFunction: function(exprefNode, allowedTypes) {
          var that = this;
          var interpreter = this._interpreter;
          var keyFunc = function(x) {
            var current = interpreter.visit(exprefNode, x);
            if (allowedTypes.indexOf(that._getTypeName(current)) < 0) {
              var msg = "TypeError: expected one of " + allowedTypes + ", received " + that._getTypeName(current);
              throw new Error(msg);
            }
            return current;
          };
          return keyFunc;
        }
      };
      function compile(stream) {
        var parser = new Parser();
        var ast = parser.parse(stream);
        return ast;
      }
      function tokenize(stream) {
        var lexer = new Lexer();
        return lexer.tokenize(stream);
      }
      function search(data, expression) {
        var parser = new Parser();
        var runtime = new Runtime2();
        var interpreter = new TreeInterpreter(runtime);
        runtime._interpreter = interpreter;
        var node = parser.parse(expression);
        return interpreter.search(node, data);
      }
      exports3.tokenize = tokenize;
      exports3.compile = compile;
      exports3.search = search;
      exports3.strictDeepEqual = strictDeepEqual;
    })(typeof exports2 === "undefined" ? exports2.jmespath = {} : exports2);
  }
});

// node_modules/aws-sdk/lib/request.js
var require_request = __commonJS({
  "node_modules/aws-sdk/lib/request.js"() {
    "use strict";
    var AWS2 = require_core();
    var AcceptorStateMachine = require_state_machine();
    var inherit = AWS2.util.inherit;
    var domain = AWS2.util.domain;
    var jmespath = require_jmespath();
    var hardErrorStates = { success: 1, error: 1, complete: 1 };
    function isTerminalState(machine) {
      return Object.prototype.hasOwnProperty.call(hardErrorStates, machine._asm.currentState);
    }
    var fsm = new AcceptorStateMachine();
    fsm.setupStates = function() {
      var transition = function(_, done) {
        var self2 = this;
        self2._haltHandlersOnError = false;
        self2.emit(self2._asm.currentState, function(err) {
          if (err) {
            if (isTerminalState(self2)) {
              if (domain && self2.domain instanceof domain.Domain) {
                err.domainEmitter = self2;
                err.domain = self2.domain;
                err.domainThrown = false;
                self2.domain.emit("error", err);
              } else {
                throw err;
              }
            } else {
              self2.response.error = err;
              done(err);
            }
          } else {
            done(self2.response.error);
          }
        });
      };
      this.addState("validate", "build", "error", transition);
      this.addState("build", "afterBuild", "restart", transition);
      this.addState("afterBuild", "sign", "restart", transition);
      this.addState("sign", "send", "retry", transition);
      this.addState("retry", "afterRetry", "afterRetry", transition);
      this.addState("afterRetry", "sign", "error", transition);
      this.addState("send", "validateResponse", "retry", transition);
      this.addState("validateResponse", "extractData", "extractError", transition);
      this.addState("extractError", "extractData", "retry", transition);
      this.addState("extractData", "success", "retry", transition);
      this.addState("restart", "build", "error", transition);
      this.addState("success", "complete", "complete", transition);
      this.addState("error", "complete", "complete", transition);
      this.addState("complete", null, null, transition);
    };
    fsm.setupStates();
    AWS2.Request = inherit({
      /**
       * Creates a request for an operation on a given service with
       * a set of input parameters.
       *
       * @param service [AWS.Service] the service to perform the operation on
       * @param operation [String] the operation to perform on the service
       * @param params [Object] parameters to send to the operation.
       *   See the operation's documentation for the format of the
       *   parameters.
       */
      constructor: function Request(service, operation, params) {
        var endpoint = service.endpoint;
        var region = service.config.region;
        var customUserAgent = service.config.customUserAgent;
        if (service.signingRegion) {
          region = service.signingRegion;
        } else if (service.isGlobalEndpoint) {
          region = "us-east-1";
        }
        this.domain = domain && domain.active;
        this.service = service;
        this.operation = operation;
        this.params = params || {};
        this.httpRequest = new AWS2.HttpRequest(endpoint, region);
        this.httpRequest.appendToUserAgent(customUserAgent);
        this.startTime = service.getSkewCorrectedDate();
        this.response = new AWS2.Response(this);
        this._asm = new AcceptorStateMachine(fsm.states, "validate");
        this._haltHandlersOnError = false;
        AWS2.SequentialExecutor.call(this);
        this.emit = this.emitEvent;
      },
      /**
       * @!group Sending a Request
       */
      /**
       * @overload send(callback = null)
       *   Sends the request object.
       *
       *   @callback callback function(err, data)
       *     If a callback is supplied, it is called when a response is returned
       *     from the service.
       *     @context [AWS.Request] the request object being sent.
       *     @param err [Error] the error object returned from the request.
       *       Set to `null` if the request is successful.
       *     @param data [Object] the de-serialized data returned from
       *       the request. Set to `null` if a request error occurs.
       *   @example Sending a request with a callback
       *     request = s3.putObject({Bucket: 'bucket', Key: 'key'});
       *     request.send(function(err, data) { console.log(err, data); });
       *   @example Sending a request with no callback (using event handlers)
       *     request = s3.putObject({Bucket: 'bucket', Key: 'key'});
       *     request.on('complete', function(response) { ... }); // register a callback
       *     request.send();
       */
      send: function send(callback) {
        if (callback) {
          this.httpRequest.appendToUserAgent("callback");
          this.on("complete", function(resp) {
            callback.call(resp, resp.error, resp.data);
          });
        }
        this.runTo();
        return this.response;
      },
      /**
       * @!method  promise()
       *   Sends the request and returns a 'thenable' promise.
       *
       *   Two callbacks can be provided to the `then` method on the returned promise.
       *   The first callback will be called if the promise is fulfilled, and the second
       *   callback will be called if the promise is rejected.
       *   @callback fulfilledCallback function(data)
       *     Called if the promise is fulfilled.
       *     @param data [Object] the de-serialized data returned from the request.
       *   @callback rejectedCallback function(error)
       *     Called if the promise is rejected.
       *     @param error [Error] the error object returned from the request.
       *   @return [Promise] A promise that represents the state of the request.
       *   @example Sending a request using promises.
       *     var request = s3.putObject({Bucket: 'bucket', Key: 'key'});
       *     var result = request.promise();
       *     result.then(function(data) { ... }, function(error) { ... });
       */
      /**
       * @api private
       */
      build: function build(callback) {
        return this.runTo("send", callback);
      },
      /**
       * @api private
       */
      runTo: function runTo(state, done) {
        this._asm.runTo(state, done, this);
        return this;
      },
      /**
       * Aborts a request, emitting the error and complete events.
       *
       * @!macro nobrowser
       * @example Aborting a request after sending
       *   var params = {
       *     Bucket: 'bucket', Key: 'key',
       *     Body: Buffer.alloc(1024 * 1024 * 5) // 5MB payload
       *   };
       *   var request = s3.putObject(params);
       *   request.send(function (err, data) {
       *     if (err) console.log("Error:", err.code, err.message);
       *     else console.log(data);
       *   });
       *
       *   // abort request in 1 second
       *   setTimeout(request.abort.bind(request), 1000);
       *
       *   // prints "Error: RequestAbortedError Request aborted by user"
       * @return [AWS.Request] the same request object, for chaining.
       * @since v1.4.0
       */
      abort: function abort() {
        this.removeAllListeners("validateResponse");
        this.removeAllListeners("extractError");
        this.on("validateResponse", function addAbortedError(resp) {
          resp.error = AWS2.util.error(new Error("Request aborted by user"), {
            code: "RequestAbortedError",
            retryable: false
          });
        });
        if (this.httpRequest.stream && !this.httpRequest.stream.didCallback) {
          this.httpRequest.stream.abort();
          if (this.httpRequest._abortCallback) {
            this.httpRequest._abortCallback();
          } else {
            this.removeAllListeners("send");
          }
        }
        return this;
      },
      /**
       * Iterates over each page of results given a pageable request, calling
       * the provided callback with each page of data. After all pages have been
       * retrieved, the callback is called with `null` data.
       *
       * @note This operation can generate multiple requests to a service.
       * @example Iterating over multiple pages of objects in an S3 bucket
       *   var pages = 1;
       *   s3.listObjects().eachPage(function(err, data) {
       *     if (err) return;
       *     console.log("Page", pages++);
       *     console.log(data);
       *   });
       * @example Iterating over multiple pages with an asynchronous callback
       *   s3.listObjects(params).eachPage(function(err, data, done) {
       *     doSomethingAsyncAndOrExpensive(function() {
       *       // The next page of results isn't fetched until done is called
       *       done();
       *     });
       *   });
       * @callback callback function(err, data, [doneCallback])
       *   Called with each page of resulting data from the request. If the
       *   optional `doneCallback` is provided in the function, it must be called
       *   when the callback is complete.
       *
       *   @param err [Error] an error object, if an error occurred.
       *   @param data [Object] a single page of response data. If there is no
       *     more data, this object will be `null`.
       *   @param doneCallback [Function] an optional done callback. If this
       *     argument is defined in the function declaration, it should be called
       *     when the next page is ready to be retrieved. This is useful for
       *     controlling serial pagination across asynchronous operations.
       *   @return [Boolean] if the callback returns `false`, pagination will
       *     stop.
       *
       * @see AWS.Request.eachItem
       * @see AWS.Response.nextPage
       * @since v1.4.0
       */
      eachPage: function eachPage(callback) {
        callback = AWS2.util.fn.makeAsync(callback, 3);
        function wrappedCallback(response) {
          callback.call(response, response.error, response.data, function(result) {
            if (result === false)
              return;
            if (response.hasNextPage()) {
              response.nextPage().on("complete", wrappedCallback).send();
            } else {
              callback.call(response, null, null, AWS2.util.fn.noop);
            }
          });
        }
        this.on("complete", wrappedCallback).send();
      },
      /**
       * Enumerates over individual items of a request, paging the responses if
       * necessary.
       *
       * @api experimental
       * @since v1.4.0
       */
      eachItem: function eachItem(callback) {
        var self2 = this;
        function wrappedCallback(err, data) {
          if (err)
            return callback(err, null);
          if (data === null)
            return callback(null, null);
          var config = self2.service.paginationConfig(self2.operation);
          var resultKey = config.resultKey;
          if (Array.isArray(resultKey))
            resultKey = resultKey[0];
          var items = jmespath.search(data, resultKey);
          var continueIteration = true;
          AWS2.util.arrayEach(items, function(item) {
            continueIteration = callback(null, item);
            if (continueIteration === false) {
              return AWS2.util.abort;
            }
          });
          return continueIteration;
        }
        this.eachPage(wrappedCallback);
      },
      /**
       * @return [Boolean] whether the operation can return multiple pages of
       *   response data.
       * @see AWS.Response.eachPage
       * @since v1.4.0
       */
      isPageable: function isPageable() {
        return this.service.paginationConfig(this.operation) ? true : false;
      },
      /**
       * Sends the request and converts the request object into a readable stream
       * that can be read from or piped into a writable stream.
       *
       * @note The data read from a readable stream contains only
       *   the raw HTTP body contents.
       * @example Manually reading from a stream
       *   request.createReadStream().on('data', function(data) {
       *     console.log("Got data:", data.toString());
       *   });
       * @example Piping a request body into a file
       *   var out = fs.createWriteStream('/path/to/outfile.jpg');
       *   s3.service.getObject(params).createReadStream().pipe(out);
       * @return [Stream] the readable stream object that can be piped
       *   or read from (by registering 'data' event listeners).
       * @!macro nobrowser
       */
      createReadStream: function createReadStream() {
        var streams = AWS2.util.stream;
        var req = this;
        var stream = null;
        if (AWS2.HttpClient.streamsApiVersion === 2) {
          stream = new streams.PassThrough();
          process.nextTick(function() {
            req.send();
          });
        } else {
          stream = new streams.Stream();
          stream.readable = true;
          stream.sent = false;
          stream.on("newListener", function(event) {
            if (!stream.sent && event === "data") {
              stream.sent = true;
              process.nextTick(function() {
                req.send();
              });
            }
          });
        }
        this.on("error", function(err) {
          stream.emit("error", err);
        });
        this.on("httpHeaders", function streamHeaders(statusCode, headers, resp) {
          if (statusCode < 300) {
            req.removeListener("httpData", AWS2.EventListeners.Core.HTTP_DATA);
            req.removeListener("httpError", AWS2.EventListeners.Core.HTTP_ERROR);
            req.on("httpError", function streamHttpError(error) {
              resp.error = error;
              resp.error.retryable = false;
            });
            var shouldCheckContentLength = false;
            var expectedLen;
            if (req.httpRequest.method !== "HEAD") {
              expectedLen = parseInt(headers["content-length"], 10);
            }
            if (expectedLen !== void 0 && !isNaN(expectedLen) && expectedLen >= 0) {
              shouldCheckContentLength = true;
              var receivedLen = 0;
            }
            var checkContentLengthAndEmit = function checkContentLengthAndEmit2() {
              if (shouldCheckContentLength && receivedLen !== expectedLen) {
                stream.emit("error", AWS2.util.error(
                  new Error("Stream content length mismatch. Received " + receivedLen + " of " + expectedLen + " bytes."),
                  { code: "StreamContentLengthMismatch" }
                ));
              } else if (AWS2.HttpClient.streamsApiVersion === 2) {
                stream.end();
              } else {
                stream.emit("end");
              }
            };
            var httpStream = resp.httpResponse.createUnbufferedStream();
            if (AWS2.HttpClient.streamsApiVersion === 2) {
              if (shouldCheckContentLength) {
                var lengthAccumulator = new streams.PassThrough();
                lengthAccumulator._write = function(chunk) {
                  if (chunk && chunk.length) {
                    receivedLen += chunk.length;
                  }
                  return streams.PassThrough.prototype._write.apply(this, arguments);
                };
                lengthAccumulator.on("end", checkContentLengthAndEmit);
                stream.on("error", function(err) {
                  shouldCheckContentLength = false;
                  httpStream.unpipe(lengthAccumulator);
                  lengthAccumulator.emit("end");
                  lengthAccumulator.end();
                });
                httpStream.pipe(lengthAccumulator).pipe(stream, { end: false });
              } else {
                httpStream.pipe(stream);
              }
            } else {
              if (shouldCheckContentLength) {
                httpStream.on("data", function(arg) {
                  if (arg && arg.length) {
                    receivedLen += arg.length;
                  }
                });
              }
              httpStream.on("data", function(arg) {
                stream.emit("data", arg);
              });
              httpStream.on("end", checkContentLengthAndEmit);
            }
            httpStream.on("error", function(err) {
              shouldCheckContentLength = false;
              stream.emit("error", err);
            });
          }
        });
        return stream;
      },
      /**
       * @param [Array,Response] args This should be the response object,
       *   or an array of args to send to the event.
       * @api private
       */
      emitEvent: function emit(eventName, args, done) {
        if (typeof args === "function") {
          done = args;
          args = null;
        }
        if (!done)
          done = function() {
          };
        if (!args)
          args = this.eventParameters(eventName, this.response);
        var origEmit = AWS2.SequentialExecutor.prototype.emit;
        origEmit.call(this, eventName, args, function(err) {
          if (err)
            this.response.error = err;
          done.call(this, err);
        });
      },
      /**
       * @api private
       */
      eventParameters: function eventParameters(eventName) {
        switch (eventName) {
          case "restart":
          case "validate":
          case "sign":
          case "build":
          case "afterValidate":
          case "afterBuild":
            return [this];
          case "error":
            return [this.response.error, this.response];
          default:
            return [this.response];
        }
      },
      /**
       * @api private
       */
      presign: function presign(expires, callback) {
        if (!callback && typeof expires === "function") {
          callback = expires;
          expires = null;
        }
        return new AWS2.Signers.Presign().sign(this.toGet(), expires, callback);
      },
      /**
       * @api private
       */
      isPresigned: function isPresigned() {
        return Object.prototype.hasOwnProperty.call(this.httpRequest.headers, "presigned-expires");
      },
      /**
       * @api private
       */
      toUnauthenticated: function toUnauthenticated() {
        this._unAuthenticated = true;
        this.removeListener("validate", AWS2.EventListeners.Core.VALIDATE_CREDENTIALS);
        this.removeListener("sign", AWS2.EventListeners.Core.SIGN);
        return this;
      },
      /**
       * @api private
       */
      toGet: function toGet() {
        if (this.service.api.protocol === "query" || this.service.api.protocol === "ec2") {
          this.removeListener("build", this.buildAsGet);
          this.addListener("build", this.buildAsGet);
        }
        return this;
      },
      /**
       * @api private
       */
      buildAsGet: function buildAsGet(request) {
        request.httpRequest.method = "GET";
        request.httpRequest.path = request.service.endpoint.path + "?" + request.httpRequest.body;
        request.httpRequest.body = "";
        delete request.httpRequest.headers["Content-Length"];
        delete request.httpRequest.headers["Content-Type"];
      },
      /**
       * @api private
       */
      haltHandlersOnError: function haltHandlersOnError() {
        this._haltHandlersOnError = true;
      }
    });
    AWS2.Request.addPromisesToClass = function addPromisesToClass(PromiseDependency) {
      this.prototype.promise = function promise() {
        var self2 = this;
        this.httpRequest.appendToUserAgent("promise");
        return new PromiseDependency(function(resolve, reject) {
          self2.on("complete", function(resp) {
            if (resp.error) {
              reject(resp.error);
            } else {
              resolve(Object.defineProperty(
                resp.data || {},
                "$response",
                { value: resp }
              ));
            }
          });
          self2.runTo();
        });
      };
    };
    AWS2.Request.deletePromisesFromClass = function deletePromisesFromClass() {
      delete this.prototype.promise;
    };
    AWS2.util.addPromises(AWS2.Request);
    AWS2.util.mixin(AWS2.Request, AWS2.SequentialExecutor);
  }
});

// node_modules/aws-sdk/lib/response.js
var require_response = __commonJS({
  "node_modules/aws-sdk/lib/response.js"() {
    "use strict";
    var AWS2 = require_core();
    var inherit = AWS2.util.inherit;
    var jmespath = require_jmespath();
    AWS2.Response = inherit({
      /**
       * @api private
       */
      constructor: function Response(request) {
        this.request = request;
        this.data = null;
        this.error = null;
        this.retryCount = 0;
        this.redirectCount = 0;
        this.httpResponse = new AWS2.HttpResponse();
        if (request) {
          this.maxRetries = request.service.numRetries();
          this.maxRedirects = request.service.config.maxRedirects;
        }
      },
      /**
       * Creates a new request for the next page of response data, calling the
       * callback with the page data if a callback is provided.
       *
       * @callback callback function(err, data)
       *   Called when a page of data is returned from the next request.
       *
       *   @param err [Error] an error object, if an error occurred in the request
       *   @param data [Object] the next page of data, or null, if there are no
       *     more pages left.
       * @return [AWS.Request] the request object for the next page of data
       * @return [null] if no callback is provided and there are no pages left
       *   to retrieve.
       * @since v1.4.0
       */
      nextPage: function nextPage(callback) {
        var config;
        var service = this.request.service;
        var operation = this.request.operation;
        try {
          config = service.paginationConfig(operation, true);
        } catch (e) {
          this.error = e;
        }
        if (!this.hasNextPage()) {
          if (callback)
            callback(this.error, null);
          else if (this.error)
            throw this.error;
          return null;
        }
        var params = AWS2.util.copy(this.request.params);
        if (!this.nextPageTokens) {
          return callback ? callback(null, null) : null;
        } else {
          var inputTokens = config.inputToken;
          if (typeof inputTokens === "string")
            inputTokens = [inputTokens];
          for (var i = 0; i < inputTokens.length; i++) {
            params[inputTokens[i]] = this.nextPageTokens[i];
          }
          return service.makeRequest(this.request.operation, params, callback);
        }
      },
      /**
       * @return [Boolean] whether more pages of data can be returned by further
       *   requests
       * @since v1.4.0
       */
      hasNextPage: function hasNextPage() {
        this.cacheNextPageTokens();
        if (this.nextPageTokens)
          return true;
        if (this.nextPageTokens === void 0)
          return void 0;
        else
          return false;
      },
      /**
       * @api private
       */
      cacheNextPageTokens: function cacheNextPageTokens() {
        if (Object.prototype.hasOwnProperty.call(this, "nextPageTokens"))
          return this.nextPageTokens;
        this.nextPageTokens = void 0;
        var config = this.request.service.paginationConfig(this.request.operation);
        if (!config)
          return this.nextPageTokens;
        this.nextPageTokens = null;
        if (config.moreResults) {
          if (!jmespath.search(this.data, config.moreResults)) {
            return this.nextPageTokens;
          }
        }
        var exprs = config.outputToken;
        if (typeof exprs === "string")
          exprs = [exprs];
        AWS2.util.arrayEach.call(this, exprs, function(expr) {
          var output = jmespath.search(this.data, expr);
          if (output) {
            this.nextPageTokens = this.nextPageTokens || [];
            this.nextPageTokens.push(output);
          }
        });
        return this.nextPageTokens;
      }
    });
  }
});

// node_modules/aws-sdk/lib/resource_waiter.js
var require_resource_waiter2 = __commonJS({
  "node_modules/aws-sdk/lib/resource_waiter.js"() {
    "use strict";
    var AWS2 = require_core();
    var inherit = AWS2.util.inherit;
    var jmespath = require_jmespath();
    function CHECK_ACCEPTORS(resp) {
      var waiter = resp.request._waiter;
      var acceptors = waiter.config.acceptors;
      var acceptorMatched = false;
      var state = "retry";
      acceptors.forEach(function(acceptor) {
        if (!acceptorMatched) {
          var matcher = waiter.matchers[acceptor.matcher];
          if (matcher && matcher(resp, acceptor.expected, acceptor.argument)) {
            acceptorMatched = true;
            state = acceptor.state;
          }
        }
      });
      if (!acceptorMatched && resp.error)
        state = "failure";
      if (state === "success") {
        waiter.setSuccess(resp);
      } else {
        waiter.setError(resp, state === "retry");
      }
    }
    AWS2.ResourceWaiter = inherit({
      /**
       * Waits for a given state on a service object
       * @param service [Service] the service object to wait on
       * @param state [String] the state (defined in waiter configuration) to wait
       *   for.
       * @example Create a waiter for running EC2 instances
       *   var ec2 = new AWS.EC2;
       *   var waiter = new AWS.ResourceWaiter(ec2, 'instanceRunning');
       */
      constructor: function constructor(service, state) {
        this.service = service;
        this.state = state;
        this.loadWaiterConfig(this.state);
      },
      service: null,
      state: null,
      config: null,
      matchers: {
        path: function(resp, expected, argument) {
          try {
            var result = jmespath.search(resp.data, argument);
          } catch (err) {
            return false;
          }
          return jmespath.strictDeepEqual(result, expected);
        },
        pathAll: function(resp, expected, argument) {
          try {
            var results = jmespath.search(resp.data, argument);
          } catch (err) {
            return false;
          }
          if (!Array.isArray(results))
            results = [results];
          var numResults = results.length;
          if (!numResults)
            return false;
          for (var ind = 0; ind < numResults; ind++) {
            if (!jmespath.strictDeepEqual(results[ind], expected)) {
              return false;
            }
          }
          return true;
        },
        pathAny: function(resp, expected, argument) {
          try {
            var results = jmespath.search(resp.data, argument);
          } catch (err) {
            return false;
          }
          if (!Array.isArray(results))
            results = [results];
          var numResults = results.length;
          for (var ind = 0; ind < numResults; ind++) {
            if (jmespath.strictDeepEqual(results[ind], expected)) {
              return true;
            }
          }
          return false;
        },
        status: function(resp, expected) {
          var statusCode = resp.httpResponse.statusCode;
          return typeof statusCode === "number" && statusCode === expected;
        },
        error: function(resp, expected) {
          if (typeof expected === "string" && resp.error) {
            return expected === resp.error.code;
          }
          return expected === !!resp.error;
        }
      },
      listeners: new AWS2.SequentialExecutor().addNamedListeners(function(add) {
        add("RETRY_CHECK", "retry", function(resp) {
          var waiter = resp.request._waiter;
          if (resp.error && resp.error.code === "ResourceNotReady") {
            resp.error.retryDelay = (waiter.config.delay || 0) * 1e3;
          }
        });
        add("CHECK_OUTPUT", "extractData", CHECK_ACCEPTORS);
        add("CHECK_ERROR", "extractError", CHECK_ACCEPTORS);
      }),
      /**
       * @return [AWS.Request]
       */
      wait: function wait(params, callback) {
        if (typeof params === "function") {
          callback = params;
          params = void 0;
        }
        if (params && params.$waiter) {
          params = AWS2.util.copy(params);
          if (typeof params.$waiter.delay === "number") {
            this.config.delay = params.$waiter.delay;
          }
          if (typeof params.$waiter.maxAttempts === "number") {
            this.config.maxAttempts = params.$waiter.maxAttempts;
          }
          delete params.$waiter;
        }
        var request = this.service.makeRequest(this.config.operation, params);
        request._waiter = this;
        request.response.maxRetries = this.config.maxAttempts;
        request.addListeners(this.listeners);
        if (callback)
          request.send(callback);
        return request;
      },
      setSuccess: function setSuccess(resp) {
        resp.error = null;
        resp.data = resp.data || {};
        resp.request.removeAllListeners("extractData");
      },
      setError: function setError(resp, retryable) {
        resp.data = null;
        resp.error = AWS2.util.error(resp.error || new Error(), {
          code: "ResourceNotReady",
          message: "Resource is not in the state " + this.state,
          retryable
        });
      },
      /**
       * Loads waiter configuration from API configuration
       *
       * @api private
       */
      loadWaiterConfig: function loadWaiterConfig(state) {
        if (!this.service.api.waiters[state]) {
          throw new AWS2.util.error(new Error(), {
            code: "StateNotFoundError",
            message: "State " + state + " not found."
          });
        }
        this.config = AWS2.util.copy(this.service.api.waiters[state]);
      }
    });
  }
});

// node_modules/aws-sdk/lib/signers/v2.js
var require_v2 = __commonJS({
  "node_modules/aws-sdk/lib/signers/v2.js"(exports2, module2) {
    "use strict";
    var AWS2 = require_core();
    var inherit = AWS2.util.inherit;
    AWS2.Signers.V2 = inherit(AWS2.Signers.RequestSigner, {
      addAuthorization: function addAuthorization(credentials, date) {
        if (!date)
          date = AWS2.util.date.getDate();
        var r = this.request;
        r.params.Timestamp = AWS2.util.date.iso8601(date);
        r.params.SignatureVersion = "2";
        r.params.SignatureMethod = "HmacSHA256";
        r.params.AWSAccessKeyId = credentials.accessKeyId;
        if (credentials.sessionToken) {
          r.params.SecurityToken = credentials.sessionToken;
        }
        delete r.params.Signature;
        r.params.Signature = this.signature(credentials);
        r.body = AWS2.util.queryParamsToString(r.params);
        r.headers["Content-Length"] = r.body.length;
      },
      signature: function signature(credentials) {
        return AWS2.util.crypto.hmac(credentials.secretAccessKey, this.stringToSign(), "base64");
      },
      stringToSign: function stringToSign() {
        var parts = [];
        parts.push(this.request.method);
        parts.push(this.request.endpoint.host.toLowerCase());
        parts.push(this.request.pathname());
        parts.push(AWS2.util.queryParamsToString(this.request.params));
        return parts.join("\n");
      }
    });
    module2.exports = AWS2.Signers.V2;
  }
});

// node_modules/aws-sdk/lib/signers/v3.js
var require_v3 = __commonJS({
  "node_modules/aws-sdk/lib/signers/v3.js"(exports2, module2) {
    "use strict";
    var AWS2 = require_core();
    var inherit = AWS2.util.inherit;
    AWS2.Signers.V3 = inherit(AWS2.Signers.RequestSigner, {
      addAuthorization: function addAuthorization(credentials, date) {
        var datetime = AWS2.util.date.rfc822(date);
        this.request.headers["X-Amz-Date"] = datetime;
        if (credentials.sessionToken) {
          this.request.headers["x-amz-security-token"] = credentials.sessionToken;
        }
        this.request.headers["X-Amzn-Authorization"] = this.authorization(credentials, datetime);
      },
      authorization: function authorization(credentials) {
        return "AWS3 AWSAccessKeyId=" + credentials.accessKeyId + ",Algorithm=HmacSHA256,SignedHeaders=" + this.signedHeaders() + ",Signature=" + this.signature(credentials);
      },
      signedHeaders: function signedHeaders() {
        var headers = [];
        AWS2.util.arrayEach(this.headersToSign(), function iterator(h) {
          headers.push(h.toLowerCase());
        });
        return headers.sort().join(";");
      },
      canonicalHeaders: function canonicalHeaders() {
        var headers = this.request.headers;
        var parts = [];
        AWS2.util.arrayEach(this.headersToSign(), function iterator(h) {
          parts.push(h.toLowerCase().trim() + ":" + String(headers[h]).trim());
        });
        return parts.sort().join("\n") + "\n";
      },
      headersToSign: function headersToSign() {
        var headers = [];
        AWS2.util.each(this.request.headers, function iterator(k) {
          if (k === "Host" || k === "Content-Encoding" || k.match(/^X-Amz/i)) {
            headers.push(k);
          }
        });
        return headers;
      },
      signature: function signature(credentials) {
        return AWS2.util.crypto.hmac(credentials.secretAccessKey, this.stringToSign(), "base64");
      },
      stringToSign: function stringToSign() {
        var parts = [];
        parts.push(this.request.method);
        parts.push("/");
        parts.push("");
        parts.push(this.canonicalHeaders());
        parts.push(this.request.body);
        return AWS2.util.crypto.sha256(parts.join("\n"));
      }
    });
    module2.exports = AWS2.Signers.V3;
  }
});

// node_modules/aws-sdk/lib/signers/v3https.js
var require_v3https = __commonJS({
  "node_modules/aws-sdk/lib/signers/v3https.js"(exports2, module2) {
    "use strict";
    var AWS2 = require_core();
    var inherit = AWS2.util.inherit;
    require_v3();
    AWS2.Signers.V3Https = inherit(AWS2.Signers.V3, {
      authorization: function authorization(credentials) {
        return "AWS3-HTTPS AWSAccessKeyId=" + credentials.accessKeyId + ",Algorithm=HmacSHA256,Signature=" + this.signature(credentials);
      },
      stringToSign: function stringToSign() {
        return this.request.headers["X-Amz-Date"];
      }
    });
    module2.exports = AWS2.Signers.V3Https;
  }
});

// node_modules/aws-sdk/lib/signers/v4_credentials.js
var require_v4_credentials = __commonJS({
  "node_modules/aws-sdk/lib/signers/v4_credentials.js"(exports2, module2) {
    "use strict";
    var AWS2 = require_core();
    var cachedSecret = {};
    var cacheQueue = [];
    var maxCacheEntries = 50;
    var v4Identifier = "aws4_request";
    module2.exports = {
      /**
       * @api private
       *
       * @param date [String]
       * @param region [String]
       * @param serviceName [String]
       * @return [String]
       */
      createScope: function createScope(date, region, serviceName) {
        return [
          date.substr(0, 8),
          region,
          serviceName,
          v4Identifier
        ].join("/");
      },
      /**
       * @api private
       *
       * @param credentials [Credentials]
       * @param date [String]
       * @param region [String]
       * @param service [String]
       * @param shouldCache [Boolean]
       * @return [String]
       */
      getSigningKey: function getSigningKey(credentials, date, region, service, shouldCache) {
        var credsIdentifier = AWS2.util.crypto.hmac(credentials.secretAccessKey, credentials.accessKeyId, "base64");
        var cacheKey = [credsIdentifier, date, region, service].join("_");
        shouldCache = shouldCache !== false;
        if (shouldCache && cacheKey in cachedSecret) {
          return cachedSecret[cacheKey];
        }
        var kDate = AWS2.util.crypto.hmac(
          "AWS4" + credentials.secretAccessKey,
          date,
          "buffer"
        );
        var kRegion = AWS2.util.crypto.hmac(kDate, region, "buffer");
        var kService = AWS2.util.crypto.hmac(kRegion, service, "buffer");
        var signingKey = AWS2.util.crypto.hmac(kService, v4Identifier, "buffer");
        if (shouldCache) {
          cachedSecret[cacheKey] = signingKey;
          cacheQueue.push(cacheKey);
          if (cacheQueue.length > maxCacheEntries) {
            delete cachedSecret[cacheQueue.shift()];
          }
        }
        return signingKey;
      },
      /**
       * @api private
       *
       * Empties the derived signing key cache. Made available for testing purposes
       * only.
       */
      emptyCache: function emptyCache() {
        cachedSecret = {};
        cacheQueue = [];
      }
    };
  }
});

// node_modules/aws-sdk/lib/signers/v4.js
var require_v4 = __commonJS({
  "node_modules/aws-sdk/lib/signers/v4.js"(exports2, module2) {
    "use strict";
    var AWS2 = require_core();
    var v4Credentials = require_v4_credentials();
    var inherit = AWS2.util.inherit;
    var expiresHeader = "presigned-expires";
    AWS2.Signers.V4 = inherit(AWS2.Signers.RequestSigner, {
      constructor: function V4(request, serviceName, options) {
        AWS2.Signers.RequestSigner.call(this, request);
        this.serviceName = serviceName;
        options = options || {};
        this.signatureCache = typeof options.signatureCache === "boolean" ? options.signatureCache : true;
        this.operation = options.operation;
        this.signatureVersion = options.signatureVersion;
      },
      algorithm: "AWS4-HMAC-SHA256",
      addAuthorization: function addAuthorization(credentials, date) {
        var datetime = AWS2.util.date.iso8601(date).replace(/[:\-]|\.\d{3}/g, "");
        if (this.isPresigned()) {
          this.updateForPresigned(credentials, datetime);
        } else {
          this.addHeaders(credentials, datetime);
        }
        this.request.headers["Authorization"] = this.authorization(credentials, datetime);
      },
      addHeaders: function addHeaders(credentials, datetime) {
        this.request.headers["X-Amz-Date"] = datetime;
        if (credentials.sessionToken) {
          this.request.headers["x-amz-security-token"] = credentials.sessionToken;
        }
      },
      updateForPresigned: function updateForPresigned(credentials, datetime) {
        var credString = this.credentialString(datetime);
        var qs = {
          "X-Amz-Date": datetime,
          "X-Amz-Algorithm": this.algorithm,
          "X-Amz-Credential": credentials.accessKeyId + "/" + credString,
          "X-Amz-Expires": this.request.headers[expiresHeader],
          "X-Amz-SignedHeaders": this.signedHeaders()
        };
        if (credentials.sessionToken) {
          qs["X-Amz-Security-Token"] = credentials.sessionToken;
        }
        if (this.request.headers["Content-Type"]) {
          qs["Content-Type"] = this.request.headers["Content-Type"];
        }
        if (this.request.headers["Content-MD5"]) {
          qs["Content-MD5"] = this.request.headers["Content-MD5"];
        }
        if (this.request.headers["Cache-Control"]) {
          qs["Cache-Control"] = this.request.headers["Cache-Control"];
        }
        AWS2.util.each.call(this, this.request.headers, function(key, value) {
          if (key === expiresHeader)
            return;
          if (this.isSignableHeader(key)) {
            var lowerKey = key.toLowerCase();
            if (lowerKey.indexOf("x-amz-meta-") === 0) {
              qs[lowerKey] = value;
            } else if (lowerKey.indexOf("x-amz-") === 0) {
              qs[key] = value;
            }
          }
        });
        var sep = this.request.path.indexOf("?") >= 0 ? "&" : "?";
        this.request.path += sep + AWS2.util.queryParamsToString(qs);
      },
      authorization: function authorization(credentials, datetime) {
        var parts = [];
        var credString = this.credentialString(datetime);
        parts.push(this.algorithm + " Credential=" + credentials.accessKeyId + "/" + credString);
        parts.push("SignedHeaders=" + this.signedHeaders());
        parts.push("Signature=" + this.signature(credentials, datetime));
        return parts.join(", ");
      },
      signature: function signature(credentials, datetime) {
        var signingKey = v4Credentials.getSigningKey(
          credentials,
          datetime.substr(0, 8),
          this.request.region,
          this.serviceName,
          this.signatureCache
        );
        return AWS2.util.crypto.hmac(signingKey, this.stringToSign(datetime), "hex");
      },
      stringToSign: function stringToSign(datetime) {
        var parts = [];
        parts.push("AWS4-HMAC-SHA256");
        parts.push(datetime);
        parts.push(this.credentialString(datetime));
        parts.push(this.hexEncodedHash(this.canonicalString()));
        return parts.join("\n");
      },
      canonicalString: function canonicalString() {
        var parts = [], pathname = this.request.pathname();
        if (this.serviceName !== "s3" && this.signatureVersion !== "s3v4")
          pathname = AWS2.util.uriEscapePath(pathname);
        parts.push(this.request.method);
        parts.push(pathname);
        parts.push(this.request.search());
        parts.push(this.canonicalHeaders() + "\n");
        parts.push(this.signedHeaders());
        parts.push(this.hexEncodedBodyHash());
        return parts.join("\n");
      },
      canonicalHeaders: function canonicalHeaders() {
        var headers = [];
        AWS2.util.each.call(this, this.request.headers, function(key, item) {
          headers.push([key, item]);
        });
        headers.sort(function(a, b) {
          return a[0].toLowerCase() < b[0].toLowerCase() ? -1 : 1;
        });
        var parts = [];
        AWS2.util.arrayEach.call(this, headers, function(item) {
          var key = item[0].toLowerCase();
          if (this.isSignableHeader(key)) {
            var value = item[1];
            if (typeof value === "undefined" || value === null || typeof value.toString !== "function") {
              throw AWS2.util.error(new Error("Header " + key + " contains invalid value"), {
                code: "InvalidHeader"
              });
            }
            parts.push(key + ":" + this.canonicalHeaderValues(value.toString()));
          }
        });
        return parts.join("\n");
      },
      canonicalHeaderValues: function canonicalHeaderValues(values) {
        return values.replace(/\s+/g, " ").replace(/^\s+|\s+$/g, "");
      },
      signedHeaders: function signedHeaders() {
        var keys = [];
        AWS2.util.each.call(this, this.request.headers, function(key) {
          key = key.toLowerCase();
          if (this.isSignableHeader(key))
            keys.push(key);
        });
        return keys.sort().join(";");
      },
      credentialString: function credentialString(datetime) {
        return v4Credentials.createScope(
          datetime.substr(0, 8),
          this.request.region,
          this.serviceName
        );
      },
      hexEncodedHash: function hash(string) {
        return AWS2.util.crypto.sha256(string, "hex");
      },
      hexEncodedBodyHash: function hexEncodedBodyHash() {
        var request = this.request;
        if (this.isPresigned() && ["s3", "s3-object-lambda"].indexOf(this.serviceName) > -1 && !request.body) {
          return "UNSIGNED-PAYLOAD";
        } else if (request.headers["X-Amz-Content-Sha256"]) {
          return request.headers["X-Amz-Content-Sha256"];
        } else {
          return this.hexEncodedHash(this.request.body || "");
        }
      },
      unsignableHeaders: [
        "authorization",
        "content-type",
        "content-length",
        "user-agent",
        expiresHeader,
        "expect",
        "x-amzn-trace-id"
      ],
      isSignableHeader: function isSignableHeader(key) {
        if (key.toLowerCase().indexOf("x-amz-") === 0)
          return true;
        return this.unsignableHeaders.indexOf(key) < 0;
      },
      isPresigned: function isPresigned() {
        return this.request.headers[expiresHeader] ? true : false;
      }
    });
    module2.exports = AWS2.Signers.V4;
  }
});

// node_modules/aws-sdk/lib/signers/s3.js
var require_s3 = __commonJS({
  "node_modules/aws-sdk/lib/signers/s3.js"(exports2, module2) {
    "use strict";
    var AWS2 = require_core();
    var inherit = AWS2.util.inherit;
    AWS2.Signers.S3 = inherit(AWS2.Signers.RequestSigner, {
      /**
       * When building the stringToSign, these sub resource params should be
       * part of the canonical resource string with their NON-decoded values
       */
      subResources: {
        "acl": 1,
        "accelerate": 1,
        "analytics": 1,
        "cors": 1,
        "lifecycle": 1,
        "delete": 1,
        "inventory": 1,
        "location": 1,
        "logging": 1,
        "metrics": 1,
        "notification": 1,
        "partNumber": 1,
        "policy": 1,
        "requestPayment": 1,
        "replication": 1,
        "restore": 1,
        "tagging": 1,
        "torrent": 1,
        "uploadId": 1,
        "uploads": 1,
        "versionId": 1,
        "versioning": 1,
        "versions": 1,
        "website": 1
      },
      // when building the stringToSign, these querystring params should be
      // part of the canonical resource string with their NON-encoded values
      responseHeaders: {
        "response-content-type": 1,
        "response-content-language": 1,
        "response-expires": 1,
        "response-cache-control": 1,
        "response-content-disposition": 1,
        "response-content-encoding": 1
      },
      addAuthorization: function addAuthorization(credentials, date) {
        if (!this.request.headers["presigned-expires"]) {
          this.request.headers["X-Amz-Date"] = AWS2.util.date.rfc822(date);
        }
        if (credentials.sessionToken) {
          this.request.headers["x-amz-security-token"] = credentials.sessionToken;
        }
        var signature = this.sign(credentials.secretAccessKey, this.stringToSign());
        var auth = "AWS " + credentials.accessKeyId + ":" + signature;
        this.request.headers["Authorization"] = auth;
      },
      stringToSign: function stringToSign() {
        var r = this.request;
        var parts = [];
        parts.push(r.method);
        parts.push(r.headers["Content-MD5"] || "");
        parts.push(r.headers["Content-Type"] || "");
        parts.push(r.headers["presigned-expires"] || "");
        var headers = this.canonicalizedAmzHeaders();
        if (headers)
          parts.push(headers);
        parts.push(this.canonicalizedResource());
        return parts.join("\n");
      },
      canonicalizedAmzHeaders: function canonicalizedAmzHeaders() {
        var amzHeaders = [];
        AWS2.util.each(this.request.headers, function(name) {
          if (name.match(/^x-amz-/i))
            amzHeaders.push(name);
        });
        amzHeaders.sort(function(a, b) {
          return a.toLowerCase() < b.toLowerCase() ? -1 : 1;
        });
        var parts = [];
        AWS2.util.arrayEach.call(this, amzHeaders, function(name) {
          parts.push(name.toLowerCase() + ":" + String(this.request.headers[name]));
        });
        return parts.join("\n");
      },
      canonicalizedResource: function canonicalizedResource() {
        var r = this.request;
        var parts = r.path.split("?");
        var path = parts[0];
        var querystring = parts[1];
        var resource = "";
        if (r.virtualHostedBucket)
          resource += "/" + r.virtualHostedBucket;
        resource += path;
        if (querystring) {
          var resources = [];
          AWS2.util.arrayEach.call(this, querystring.split("&"), function(param) {
            var name = param.split("=")[0];
            var value = param.split("=")[1];
            if (this.subResources[name] || this.responseHeaders[name]) {
              var subresource = { name };
              if (value !== void 0) {
                if (this.subResources[name]) {
                  subresource.value = value;
                } else {
                  subresource.value = decodeURIComponent(value);
                }
              }
              resources.push(subresource);
            }
          });
          resources.sort(function(a, b) {
            return a.name < b.name ? -1 : 1;
          });
          if (resources.length) {
            querystring = [];
            AWS2.util.arrayEach(resources, function(res) {
              if (res.value === void 0) {
                querystring.push(res.name);
              } else {
                querystring.push(res.name + "=" + res.value);
              }
            });
            resource += "?" + querystring.join("&");
          }
        }
        return resource;
      },
      sign: function sign(secret, string) {
        return AWS2.util.crypto.hmac(secret, string, "base64", "sha1");
      }
    });
    module2.exports = AWS2.Signers.S3;
  }
});

// node_modules/aws-sdk/lib/signers/presign.js
var require_presign = __commonJS({
  "node_modules/aws-sdk/lib/signers/presign.js"(exports2, module2) {
    "use strict";
    var AWS2 = require_core();
    var inherit = AWS2.util.inherit;
    var expiresHeader = "presigned-expires";
    function signedUrlBuilder(request) {
      var expires = request.httpRequest.headers[expiresHeader];
      var signerClass = request.service.getSignerClass(request);
      delete request.httpRequest.headers["User-Agent"];
      delete request.httpRequest.headers["X-Amz-User-Agent"];
      if (signerClass === AWS2.Signers.V4) {
        if (expires > 604800) {
          var message = "Presigning does not support expiry time greater than a week with SigV4 signing.";
          throw AWS2.util.error(new Error(), {
            code: "InvalidExpiryTime",
            message,
            retryable: false
          });
        }
        request.httpRequest.headers[expiresHeader] = expires;
      } else if (signerClass === AWS2.Signers.S3) {
        var now = request.service ? request.service.getSkewCorrectedDate() : AWS2.util.date.getDate();
        request.httpRequest.headers[expiresHeader] = parseInt(
          AWS2.util.date.unixTimestamp(now) + expires,
          10
        ).toString();
      } else {
        throw AWS2.util.error(new Error(), {
          message: "Presigning only supports S3 or SigV4 signing.",
          code: "UnsupportedSigner",
          retryable: false
        });
      }
    }
    function signedUrlSigner(request) {
      var endpoint = request.httpRequest.endpoint;
      var parsedUrl = AWS2.util.urlParse(request.httpRequest.path);
      var queryParams = {};
      if (parsedUrl.search) {
        queryParams = AWS2.util.queryStringParse(parsedUrl.search.substr(1));
      }
      var auth = request.httpRequest.headers["Authorization"].split(" ");
      if (auth[0] === "AWS") {
        auth = auth[1].split(":");
        queryParams["Signature"] = auth.pop();
        queryParams["AWSAccessKeyId"] = auth.join(":");
        AWS2.util.each(request.httpRequest.headers, function(key, value) {
          if (key === expiresHeader)
            key = "Expires";
          if (key.indexOf("x-amz-meta-") === 0) {
            delete queryParams[key];
            key = key.toLowerCase();
          }
          queryParams[key] = value;
        });
        delete request.httpRequest.headers[expiresHeader];
        delete queryParams["Authorization"];
        delete queryParams["Host"];
      } else if (auth[0] === "AWS4-HMAC-SHA256") {
        auth.shift();
        var rest = auth.join(" ");
        var signature = rest.match(/Signature=(.*?)(?:,|\s|\r?\n|$)/)[1];
        queryParams["X-Amz-Signature"] = signature;
        delete queryParams["Expires"];
      }
      endpoint.pathname = parsedUrl.pathname;
      endpoint.search = AWS2.util.queryParamsToString(queryParams);
    }
    AWS2.Signers.Presign = inherit({
      /**
       * @api private
       */
      sign: function sign(request, expireTime, callback) {
        request.httpRequest.headers[expiresHeader] = expireTime || 3600;
        request.on("build", signedUrlBuilder);
        request.on("sign", signedUrlSigner);
        request.removeListener(
          "afterBuild",
          AWS2.EventListeners.Core.SET_CONTENT_LENGTH
        );
        request.removeListener(
          "afterBuild",
          AWS2.EventListeners.Core.COMPUTE_SHA256
        );
        request.emit("beforePresign", [request]);
        if (callback) {
          request.build(function() {
            if (this.response.error)
              callback(this.response.error);
            else {
              callback(null, AWS2.util.urlFormat(request.httpRequest.endpoint));
            }
          });
        } else {
          request.build();
          if (request.response.error)
            throw request.response.error;
          return AWS2.util.urlFormat(request.httpRequest.endpoint);
        }
      }
    });
    module2.exports = AWS2.Signers.Presign;
  }
});

// node_modules/aws-sdk/lib/signers/bearer.js
var require_bearer = __commonJS({
  "node_modules/aws-sdk/lib/signers/bearer.js"() {
    "use strict";
    var AWS2 = require_core();
    AWS2.Signers.Bearer = AWS2.util.inherit(AWS2.Signers.RequestSigner, {
      constructor: function Bearer(request) {
        AWS2.Signers.RequestSigner.call(this, request);
      },
      addAuthorization: function addAuthorization(token) {
        this.request.headers["Authorization"] = "Bearer " + token.token;
      }
    });
  }
});

// node_modules/aws-sdk/lib/signers/request_signer.js
var require_request_signer = __commonJS({
  "node_modules/aws-sdk/lib/signers/request_signer.js"() {
    "use strict";
    var AWS2 = require_core();
    var inherit = AWS2.util.inherit;
    AWS2.Signers.RequestSigner = inherit({
      constructor: function RequestSigner(request) {
        this.request = request;
      },
      setServiceClientId: function setServiceClientId(id) {
        this.serviceClientId = id;
      },
      getServiceClientId: function getServiceClientId() {
        return this.serviceClientId;
      }
    });
    AWS2.Signers.RequestSigner.getVersion = function getVersion(version) {
      switch (version) {
        case "v2":
          return AWS2.Signers.V2;
        case "v3":
          return AWS2.Signers.V3;
        case "s3v4":
          return AWS2.Signers.V4;
        case "v4":
          return AWS2.Signers.V4;
        case "s3":
          return AWS2.Signers.S3;
        case "v3https":
          return AWS2.Signers.V3Https;
        case "bearer":
          return AWS2.Signers.Bearer;
      }
      throw new Error("Unknown signing version " + version);
    };
    require_v2();
    require_v3();
    require_v3https();
    require_v4();
    require_s3();
    require_presign();
    require_bearer();
  }
});

// node_modules/aws-sdk/lib/param_validator.js
var require_param_validator = __commonJS({
  "node_modules/aws-sdk/lib/param_validator.js"() {
    "use strict";
    var AWS2 = require_core();
    AWS2.ParamValidator = AWS2.util.inherit({
      /**
       * Create a new validator object.
       *
       * @param validation [Boolean|map] whether input parameters should be
       *     validated against the operation description before sending the
       *     request. Pass a map to enable any of the following specific
       *     validation features:
       *
       *     * **min** [Boolean] &mdash; Validates that a value meets the min
       *       constraint. This is enabled by default when paramValidation is set
       *       to `true`.
       *     * **max** [Boolean] &mdash; Validates that a value meets the max
       *       constraint.
       *     * **pattern** [Boolean] &mdash; Validates that a string value matches a
       *       regular expression.
       *     * **enum** [Boolean] &mdash; Validates that a string value matches one
       *       of the allowable enum values.
       */
      constructor: function ParamValidator(validation) {
        if (validation === true || validation === void 0) {
          validation = { "min": true };
        }
        this.validation = validation;
      },
      validate: function validate(shape, params, context) {
        this.errors = [];
        this.validateMember(shape, params || {}, context || "params");
        if (this.errors.length > 1) {
          var msg = this.errors.join("\n* ");
          msg = "There were " + this.errors.length + " validation errors:\n* " + msg;
          throw AWS2.util.error(
            new Error(msg),
            { code: "MultipleValidationErrors", errors: this.errors }
          );
        } else if (this.errors.length === 1) {
          throw this.errors[0];
        } else {
          return true;
        }
      },
      fail: function fail(code, message) {
        this.errors.push(AWS2.util.error(new Error(message), { code }));
      },
      validateStructure: function validateStructure(shape, params, context) {
        if (shape.isDocument)
          return true;
        this.validateType(params, context, ["object"], "structure");
        var paramName;
        for (var i = 0; shape.required && i < shape.required.length; i++) {
          paramName = shape.required[i];
          var value = params[paramName];
          if (value === void 0 || value === null) {
            this.fail(
              "MissingRequiredParameter",
              "Missing required key '" + paramName + "' in " + context
            );
          }
        }
        for (paramName in params) {
          if (!Object.prototype.hasOwnProperty.call(params, paramName))
            continue;
          var paramValue = params[paramName], memberShape = shape.members[paramName];
          if (memberShape !== void 0) {
            var memberContext = [context, paramName].join(".");
            this.validateMember(memberShape, paramValue, memberContext);
          } else if (paramValue !== void 0 && paramValue !== null) {
            this.fail(
              "UnexpectedParameter",
              "Unexpected key '" + paramName + "' found in " + context
            );
          }
        }
        return true;
      },
      validateMember: function validateMember(shape, param, context) {
        switch (shape.type) {
          case "structure":
            return this.validateStructure(shape, param, context);
          case "list":
            return this.validateList(shape, param, context);
          case "map":
            return this.validateMap(shape, param, context);
          default:
            return this.validateScalar(shape, param, context);
        }
      },
      validateList: function validateList(shape, params, context) {
        if (this.validateType(params, context, [Array])) {
          this.validateRange(shape, params.length, context, "list member count");
          for (var i = 0; i < params.length; i++) {
            this.validateMember(shape.member, params[i], context + "[" + i + "]");
          }
        }
      },
      validateMap: function validateMap(shape, params, context) {
        if (this.validateType(params, context, ["object"], "map")) {
          var mapCount = 0;
          for (var param in params) {
            if (!Object.prototype.hasOwnProperty.call(params, param))
              continue;
            this.validateMember(
              shape.key,
              param,
              context + "[key='" + param + "']"
            );
            this.validateMember(
              shape.value,
              params[param],
              context + "['" + param + "']"
            );
            mapCount++;
          }
          this.validateRange(shape, mapCount, context, "map member count");
        }
      },
      validateScalar: function validateScalar(shape, value, context) {
        switch (shape.type) {
          case null:
          case void 0:
          case "string":
            return this.validateString(shape, value, context);
          case "base64":
          case "binary":
            return this.validatePayload(value, context);
          case "integer":
          case "float":
            return this.validateNumber(shape, value, context);
          case "boolean":
            return this.validateType(value, context, ["boolean"]);
          case "timestamp":
            return this.validateType(
              value,
              context,
              [
                Date,
                /^\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}(\.\d+)?Z$/,
                "number"
              ],
              "Date object, ISO-8601 string, or a UNIX timestamp"
            );
          default:
            return this.fail("UnkownType", "Unhandled type " + shape.type + " for " + context);
        }
      },
      validateString: function validateString(shape, value, context) {
        var validTypes = ["string"];
        if (shape.isJsonValue) {
          validTypes = validTypes.concat(["number", "object", "boolean"]);
        }
        if (value !== null && this.validateType(value, context, validTypes)) {
          this.validateEnum(shape, value, context);
          this.validateRange(shape, value.length, context, "string length");
          this.validatePattern(shape, value, context);
          this.validateUri(shape, value, context);
        }
      },
      validateUri: function validateUri(shape, value, context) {
        if (shape["location"] === "uri") {
          if (value.length === 0) {
            this.fail("UriParameterError", 'Expected uri parameter to have length >= 1, but found "' + value + '" for ' + context);
          }
        }
      },
      validatePattern: function validatePattern(shape, value, context) {
        if (this.validation["pattern"] && shape["pattern"] !== void 0) {
          if (!new RegExp(shape["pattern"]).test(value)) {
            this.fail("PatternMatchError", 'Provided value "' + value + '" does not match regex pattern /' + shape["pattern"] + "/ for " + context);
          }
        }
      },
      validateRange: function validateRange(shape, value, context, descriptor) {
        if (this.validation["min"]) {
          if (shape["min"] !== void 0 && value < shape["min"]) {
            this.fail("MinRangeError", "Expected " + descriptor + " >= " + shape["min"] + ", but found " + value + " for " + context);
          }
        }
        if (this.validation["max"]) {
          if (shape["max"] !== void 0 && value > shape["max"]) {
            this.fail("MaxRangeError", "Expected " + descriptor + " <= " + shape["max"] + ", but found " + value + " for " + context);
          }
        }
      },
      validateEnum: function validateRange(shape, value, context) {
        if (this.validation["enum"] && shape["enum"] !== void 0) {
          if (shape["enum"].indexOf(value) === -1) {
            this.fail("EnumError", "Found string value of " + value + ", but expected " + shape["enum"].join("|") + " for " + context);
          }
        }
      },
      validateType: function validateType(value, context, acceptedTypes, type) {
        if (value === null || value === void 0)
          return false;
        var foundInvalidType = false;
        for (var i = 0; i < acceptedTypes.length; i++) {
          if (typeof acceptedTypes[i] === "string") {
            if (typeof value === acceptedTypes[i])
              return true;
          } else if (acceptedTypes[i] instanceof RegExp) {
            if ((value || "").toString().match(acceptedTypes[i]))
              return true;
          } else {
            if (value instanceof acceptedTypes[i])
              return true;
            if (AWS2.util.isType(value, acceptedTypes[i]))
              return true;
            if (!type && !foundInvalidType)
              acceptedTypes = acceptedTypes.slice();
            acceptedTypes[i] = AWS2.util.typeName(acceptedTypes[i]);
          }
          foundInvalidType = true;
        }
        var acceptedType = type;
        if (!acceptedType) {
          acceptedType = acceptedTypes.join(", ").replace(/,([^,]+)$/, ", or$1");
        }
        var vowel = acceptedType.match(/^[aeiou]/i) ? "n" : "";
        this.fail("InvalidParameterType", "Expected " + context + " to be a" + vowel + " " + acceptedType);
        return false;
      },
      validateNumber: function validateNumber(shape, value, context) {
        if (value === null || value === void 0)
          return;
        if (typeof value === "string") {
          var castedValue = parseFloat(value);
          if (castedValue.toString() === value)
            value = castedValue;
        }
        if (this.validateType(value, context, ["number"])) {
          this.validateRange(shape, value, context, "numeric value");
        }
      },
      validatePayload: function validatePayload(value, context) {
        if (value === null || value === void 0)
          return;
        if (typeof value === "string")
          return;
        if (value && typeof value.byteLength === "number")
          return;
        if (AWS2.util.isNode()) {
          var Stream = AWS2.util.stream.Stream;
          if (AWS2.util.Buffer.isBuffer(value) || value instanceof Stream)
            return;
        } else {
          if (typeof Blob !== void 0 && value instanceof Blob)
            return;
        }
        var types = ["Buffer", "Stream", "File", "Blob", "ArrayBuffer", "DataView"];
        if (value) {
          for (var i = 0; i < types.length; i++) {
            if (AWS2.util.isType(value, types[i]))
              return;
            if (AWS2.util.typeName(value.constructor) === types[i])
              return;
          }
        }
        this.fail("InvalidParameterType", "Expected " + context + " to be a string, Buffer, Stream, Blob, or typed array object");
      }
    });
  }
});

// node_modules/aws-sdk/lib/maintenance_mode_message.js
var require_maintenance_mode_message = __commonJS({
  "node_modules/aws-sdk/lib/maintenance_mode_message.js"(exports2, module2) {
    "use strict";
    var warning = [
      "We are formalizing our plans to enter AWS SDK for JavaScript (v2) into maintenance mode in 2023.\n",
      "Please migrate your code to use AWS SDK for JavaScript (v3).",
      "For more information, check the migration guide at https://a.co/7PzMCcy"
    ].join("\n");
    module2.exports = {
      suppress: false
    };
    function emitWarning() {
      if (typeof process === "undefined")
        return;
      if (typeof process.env === "object" && typeof process.env.AWS_EXECUTION_ENV !== "undefined" && process.env.AWS_EXECUTION_ENV.indexOf("AWS_Lambda_") === 0) {
        return;
      }
      if (typeof process.env === "object" && typeof process.env.AWS_SDK_JS_SUPPRESS_MAINTENANCE_MODE_MESSAGE !== "undefined") {
        return;
      }
      if (typeof process.emitWarning === "function") {
        process.emitWarning(warning, {
          type: "NOTE"
        });
      }
    }
    setTimeout(function() {
      if (!module2.exports.suppress) {
        emitWarning();
      }
    }, 0);
  }
});

// node_modules/aws-sdk/lib/core.js
var require_core = __commonJS({
  "node_modules/aws-sdk/lib/core.js"(exports2, module2) {
    "use strict";
    var AWS2 = { util: require_util() };
    var _hidden = {};
    _hidden.toString();
    module2.exports = AWS2;
    AWS2.util.update(AWS2, {
      /**
       * @constant
       */
      VERSION: "2.1530.0",
      /**
       * @api private
       */
      Signers: {},
      /**
       * @api private
       */
      Protocol: {
        Json: require_json(),
        Query: require_query(),
        Rest: require_rest(),
        RestJson: require_rest_json(),
        RestXml: require_rest_xml()
      },
      /**
       * @api private
       */
      XML: {
        Builder: require_builder2(),
        Parser: null
        // conditionally set based on environment
      },
      /**
       * @api private
       */
      JSON: {
        Builder: require_builder(),
        Parser: require_parser()
      },
      /**
       * @api private
       */
      Model: {
        Api: require_api(),
        Operation: require_operation(),
        Shape: require_shape(),
        Paginator: require_paginator(),
        ResourceWaiter: require_resource_waiter()
      },
      /**
       * @api private
       */
      apiLoader: require_api_loader(),
      /**
       * @api private
       */
      EndpointCache: require_endpoint_cache().EndpointCache
    });
    require_sequential_executor();
    require_service();
    require_config();
    require_http();
    require_event_listeners();
    require_request();
    require_response();
    require_resource_waiter2();
    require_request_signer();
    require_param_validator();
    require_maintenance_mode_message();
    AWS2.events = new AWS2.SequentialExecutor();
    AWS2.util.memoizedProperty(AWS2, "endpointCache", function() {
      return new AWS2.EndpointCache(AWS2.config.endpointCacheSize);
    }, true);
  }
});

// node_modules/uuid/dist/rng.js
var require_rng = __commonJS({
  "node_modules/uuid/dist/rng.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", {
      value: true
    });
    exports2.default = rng;
    var _crypto = _interopRequireDefault(require("crypto"));
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    function rng() {
      return _crypto.default.randomBytes(16);
    }
  }
});

// node_modules/uuid/dist/bytesToUuid.js
var require_bytesToUuid = __commonJS({
  "node_modules/uuid/dist/bytesToUuid.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", {
      value: true
    });
    exports2.default = void 0;
    var byteToHex = [];
    for (i = 0; i < 256; ++i) {
      byteToHex[i] = (i + 256).toString(16).substr(1);
    }
    var i;
    function bytesToUuid(buf, offset) {
      var i2 = offset || 0;
      var bth = byteToHex;
      return [bth[buf[i2++]], bth[buf[i2++]], bth[buf[i2++]], bth[buf[i2++]], "-", bth[buf[i2++]], bth[buf[i2++]], "-", bth[buf[i2++]], bth[buf[i2++]], "-", bth[buf[i2++]], bth[buf[i2++]], "-", bth[buf[i2++]], bth[buf[i2++]], bth[buf[i2++]], bth[buf[i2++]], bth[buf[i2++]], bth[buf[i2++]]].join("");
    }
    var _default = bytesToUuid;
    exports2.default = _default;
  }
});

// node_modules/uuid/dist/v1.js
var require_v1 = __commonJS({
  "node_modules/uuid/dist/v1.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", {
      value: true
    });
    exports2.default = void 0;
    var _rng = _interopRequireDefault(require_rng());
    var _bytesToUuid = _interopRequireDefault(require_bytesToUuid());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    var _nodeId;
    var _clockseq;
    var _lastMSecs = 0;
    var _lastNSecs = 0;
    function v1(options, buf, offset) {
      var i = buf && offset || 0;
      var b = buf || [];
      options = options || {};
      var node = options.node || _nodeId;
      var clockseq = options.clockseq !== void 0 ? options.clockseq : _clockseq;
      if (node == null || clockseq == null) {
        var seedBytes = options.random || (options.rng || _rng.default)();
        if (node == null) {
          node = _nodeId = [seedBytes[0] | 1, seedBytes[1], seedBytes[2], seedBytes[3], seedBytes[4], seedBytes[5]];
        }
        if (clockseq == null) {
          clockseq = _clockseq = (seedBytes[6] << 8 | seedBytes[7]) & 16383;
        }
      }
      var msecs = options.msecs !== void 0 ? options.msecs : (/* @__PURE__ */ new Date()).getTime();
      var nsecs = options.nsecs !== void 0 ? options.nsecs : _lastNSecs + 1;
      var dt = msecs - _lastMSecs + (nsecs - _lastNSecs) / 1e4;
      if (dt < 0 && options.clockseq === void 0) {
        clockseq = clockseq + 1 & 16383;
      }
      if ((dt < 0 || msecs > _lastMSecs) && options.nsecs === void 0) {
        nsecs = 0;
      }
      if (nsecs >= 1e4) {
        throw new Error("uuid.v1(): Can't create more than 10M uuids/sec");
      }
      _lastMSecs = msecs;
      _lastNSecs = nsecs;
      _clockseq = clockseq;
      msecs += 122192928e5;
      var tl = ((msecs & 268435455) * 1e4 + nsecs) % 4294967296;
      b[i++] = tl >>> 24 & 255;
      b[i++] = tl >>> 16 & 255;
      b[i++] = tl >>> 8 & 255;
      b[i++] = tl & 255;
      var tmh = msecs / 4294967296 * 1e4 & 268435455;
      b[i++] = tmh >>> 8 & 255;
      b[i++] = tmh & 255;
      b[i++] = tmh >>> 24 & 15 | 16;
      b[i++] = tmh >>> 16 & 255;
      b[i++] = clockseq >>> 8 | 128;
      b[i++] = clockseq & 255;
      for (var n = 0; n < 6; ++n) {
        b[i + n] = node[n];
      }
      return buf ? buf : (0, _bytesToUuid.default)(b);
    }
    var _default = v1;
    exports2.default = _default;
  }
});

// node_modules/uuid/dist/v35.js
var require_v35 = __commonJS({
  "node_modules/uuid/dist/v35.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", {
      value: true
    });
    exports2.default = _default;
    exports2.URL = exports2.DNS = void 0;
    var _bytesToUuid = _interopRequireDefault(require_bytesToUuid());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    function uuidToBytes(uuid) {
      var bytes = [];
      uuid.replace(/[a-fA-F0-9]{2}/g, function(hex) {
        bytes.push(parseInt(hex, 16));
      });
      return bytes;
    }
    function stringToBytes(str) {
      str = unescape(encodeURIComponent(str));
      var bytes = new Array(str.length);
      for (var i = 0; i < str.length; i++) {
        bytes[i] = str.charCodeAt(i);
      }
      return bytes;
    }
    var DNS = "6ba7b810-9dad-11d1-80b4-00c04fd430c8";
    exports2.DNS = DNS;
    var URL = "6ba7b811-9dad-11d1-80b4-00c04fd430c8";
    exports2.URL = URL;
    function _default(name, version, hashfunc) {
      var generateUUID = function(value, namespace, buf, offset) {
        var off = buf && offset || 0;
        if (typeof value == "string")
          value = stringToBytes(value);
        if (typeof namespace == "string")
          namespace = uuidToBytes(namespace);
        if (!Array.isArray(value))
          throw TypeError("value must be an array of bytes");
        if (!Array.isArray(namespace) || namespace.length !== 16)
          throw TypeError("namespace must be uuid string or an Array of 16 byte values");
        var bytes = hashfunc(namespace.concat(value));
        bytes[6] = bytes[6] & 15 | version;
        bytes[8] = bytes[8] & 63 | 128;
        if (buf) {
          for (var idx = 0; idx < 16; ++idx) {
            buf[off + idx] = bytes[idx];
          }
        }
        return buf || (0, _bytesToUuid.default)(bytes);
      };
      try {
        generateUUID.name = name;
      } catch (err) {
      }
      generateUUID.DNS = DNS;
      generateUUID.URL = URL;
      return generateUUID;
    }
  }
});

// node_modules/uuid/dist/md5.js
var require_md5 = __commonJS({
  "node_modules/uuid/dist/md5.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", {
      value: true
    });
    exports2.default = void 0;
    var _crypto = _interopRequireDefault(require("crypto"));
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    function md5(bytes) {
      if (Array.isArray(bytes)) {
        bytes = Buffer.from(bytes);
      } else if (typeof bytes === "string") {
        bytes = Buffer.from(bytes, "utf8");
      }
      return _crypto.default.createHash("md5").update(bytes).digest();
    }
    var _default = md5;
    exports2.default = _default;
  }
});

// node_modules/uuid/dist/v3.js
var require_v32 = __commonJS({
  "node_modules/uuid/dist/v3.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", {
      value: true
    });
    exports2.default = void 0;
    var _v = _interopRequireDefault(require_v35());
    var _md = _interopRequireDefault(require_md5());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    var v3 = (0, _v.default)("v3", 48, _md.default);
    var _default = v3;
    exports2.default = _default;
  }
});

// node_modules/uuid/dist/v4.js
var require_v42 = __commonJS({
  "node_modules/uuid/dist/v4.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", {
      value: true
    });
    exports2.default = void 0;
    var _rng = _interopRequireDefault(require_rng());
    var _bytesToUuid = _interopRequireDefault(require_bytesToUuid());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    function v4(options, buf, offset) {
      var i = buf && offset || 0;
      if (typeof options == "string") {
        buf = options === "binary" ? new Array(16) : null;
        options = null;
      }
      options = options || {};
      var rnds = options.random || (options.rng || _rng.default)();
      rnds[6] = rnds[6] & 15 | 64;
      rnds[8] = rnds[8] & 63 | 128;
      if (buf) {
        for (var ii = 0; ii < 16; ++ii) {
          buf[i + ii] = rnds[ii];
        }
      }
      return buf || (0, _bytesToUuid.default)(rnds);
    }
    var _default = v4;
    exports2.default = _default;
  }
});

// node_modules/uuid/dist/sha1.js
var require_sha1 = __commonJS({
  "node_modules/uuid/dist/sha1.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", {
      value: true
    });
    exports2.default = void 0;
    var _crypto = _interopRequireDefault(require("crypto"));
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    function sha1(bytes) {
      if (Array.isArray(bytes)) {
        bytes = Buffer.from(bytes);
      } else if (typeof bytes === "string") {
        bytes = Buffer.from(bytes, "utf8");
      }
      return _crypto.default.createHash("sha1").update(bytes).digest();
    }
    var _default = sha1;
    exports2.default = _default;
  }
});

// node_modules/uuid/dist/v5.js
var require_v5 = __commonJS({
  "node_modules/uuid/dist/v5.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", {
      value: true
    });
    exports2.default = void 0;
    var _v = _interopRequireDefault(require_v35());
    var _sha = _interopRequireDefault(require_sha1());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    var v5 = (0, _v.default)("v5", 80, _sha.default);
    var _default = v5;
    exports2.default = _default;
  }
});

// node_modules/uuid/dist/index.js
var require_dist = __commonJS({
  "node_modules/uuid/dist/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", {
      value: true
    });
    Object.defineProperty(exports2, "v1", {
      enumerable: true,
      get: function() {
        return _v.default;
      }
    });
    Object.defineProperty(exports2, "v3", {
      enumerable: true,
      get: function() {
        return _v2.default;
      }
    });
    Object.defineProperty(exports2, "v4", {
      enumerable: true,
      get: function() {
        return _v3.default;
      }
    });
    Object.defineProperty(exports2, "v5", {
      enumerable: true,
      get: function() {
        return _v4.default;
      }
    });
    var _v = _interopRequireDefault(require_v1());
    var _v2 = _interopRequireDefault(require_v32());
    var _v3 = _interopRequireDefault(require_v42());
    var _v4 = _interopRequireDefault(require_v5());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
  }
});

// node_modules/aws-sdk/lib/util.js
var require_util = __commonJS({
  "node_modules/aws-sdk/lib/util.js"(exports2, module2) {
    "use strict";
    var AWS2;
    var util = {
      environment: "nodejs",
      engine: function engine() {
        if (util.isBrowser() && typeof navigator !== "undefined") {
          return navigator.userAgent;
        } else {
          var engine2 = process.platform + "/" + process.version;
          if (process.env.AWS_EXECUTION_ENV) {
            engine2 += " exec-env/" + process.env.AWS_EXECUTION_ENV;
          }
          return engine2;
        }
      },
      userAgent: function userAgent() {
        var name = util.environment;
        var agent = "aws-sdk-" + name + "/" + require_core().VERSION;
        if (name === "nodejs")
          agent += " " + util.engine();
        return agent;
      },
      uriEscape: function uriEscape(string) {
        var output = encodeURIComponent(string);
        output = output.replace(/[^A-Za-z0-9_.~\-%]+/g, escape);
        output = output.replace(/[*]/g, function(ch) {
          return "%" + ch.charCodeAt(0).toString(16).toUpperCase();
        });
        return output;
      },
      uriEscapePath: function uriEscapePath(string) {
        var parts = [];
        util.arrayEach(string.split("/"), function(part) {
          parts.push(util.uriEscape(part));
        });
        return parts.join("/");
      },
      urlParse: function urlParse(url) {
        return util.url.parse(url);
      },
      urlFormat: function urlFormat(url) {
        return util.url.format(url);
      },
      queryStringParse: function queryStringParse(qs) {
        return util.querystring.parse(qs);
      },
      queryParamsToString: function queryParamsToString(params) {
        var items = [];
        var escape2 = util.uriEscape;
        var sortedKeys = Object.keys(params).sort();
        util.arrayEach(sortedKeys, function(name) {
          var value = params[name];
          var ename = escape2(name);
          var result = ename + "=";
          if (Array.isArray(value)) {
            var vals = [];
            util.arrayEach(value, function(item) {
              vals.push(escape2(item));
            });
            result = ename + "=" + vals.sort().join("&" + ename + "=");
          } else if (value !== void 0 && value !== null) {
            result = ename + "=" + escape2(value);
          }
          items.push(result);
        });
        return items.join("&");
      },
      readFileSync: function readFileSync(path) {
        if (util.isBrowser())
          return null;
        return require("fs").readFileSync(path, "utf-8");
      },
      base64: {
        encode: function encode64(string) {
          if (typeof string === "number") {
            throw util.error(new Error("Cannot base64 encode number " + string));
          }
          if (string === null || typeof string === "undefined") {
            return string;
          }
          var buf = util.buffer.toBuffer(string);
          return buf.toString("base64");
        },
        decode: function decode64(string) {
          if (typeof string === "number") {
            throw util.error(new Error("Cannot base64 decode number " + string));
          }
          if (string === null || typeof string === "undefined") {
            return string;
          }
          return util.buffer.toBuffer(string, "base64");
        }
      },
      buffer: {
        /**
         * Buffer constructor for Node buffer and buffer pollyfill
         */
        toBuffer: function(data, encoding) {
          return typeof util.Buffer.from === "function" && util.Buffer.from !== Uint8Array.from ? util.Buffer.from(data, encoding) : new util.Buffer(data, encoding);
        },
        alloc: function(size, fill, encoding) {
          if (typeof size !== "number") {
            throw new Error("size passed to alloc must be a number.");
          }
          if (typeof util.Buffer.alloc === "function") {
            return util.Buffer.alloc(size, fill, encoding);
          } else {
            var buf = new util.Buffer(size);
            if (fill !== void 0 && typeof buf.fill === "function") {
              buf.fill(fill, void 0, void 0, encoding);
            }
            return buf;
          }
        },
        toStream: function toStream(buffer) {
          if (!util.Buffer.isBuffer(buffer))
            buffer = util.buffer.toBuffer(buffer);
          var readable = new util.stream.Readable();
          var pos = 0;
          readable._read = function(size) {
            if (pos >= buffer.length)
              return readable.push(null);
            var end = pos + size;
            if (end > buffer.length)
              end = buffer.length;
            readable.push(buffer.slice(pos, end));
            pos = end;
          };
          return readable;
        },
        /**
         * Concatenates a list of Buffer objects.
         */
        concat: function(buffers) {
          var length = 0, offset = 0, buffer = null, i;
          for (i = 0; i < buffers.length; i++) {
            length += buffers[i].length;
          }
          buffer = util.buffer.alloc(length);
          for (i = 0; i < buffers.length; i++) {
            buffers[i].copy(buffer, offset);
            offset += buffers[i].length;
          }
          return buffer;
        }
      },
      string: {
        byteLength: function byteLength(string) {
          if (string === null || string === void 0)
            return 0;
          if (typeof string === "string")
            string = util.buffer.toBuffer(string);
          if (typeof string.byteLength === "number") {
            return string.byteLength;
          } else if (typeof string.length === "number") {
            return string.length;
          } else if (typeof string.size === "number") {
            return string.size;
          } else if (typeof string.path === "string") {
            return require("fs").lstatSync(string.path).size;
          } else {
            throw util.error(
              new Error("Cannot determine length of " + string),
              { object: string }
            );
          }
        },
        upperFirst: function upperFirst(string) {
          return string[0].toUpperCase() + string.substr(1);
        },
        lowerFirst: function lowerFirst(string) {
          return string[0].toLowerCase() + string.substr(1);
        }
      },
      ini: {
        parse: function string(ini) {
          var currentSection, map = {};
          util.arrayEach(ini.split(/\r?\n/), function(line) {
            line = line.split(/(^|\s)[;#]/)[0].trim();
            var isSection = line[0] === "[" && line[line.length - 1] === "]";
            if (isSection) {
              currentSection = line.substring(1, line.length - 1);
              if (currentSection === "__proto__" || currentSection.split(/\s/)[1] === "__proto__") {
                throw util.error(
                  new Error("Cannot load profile name '" + currentSection + "' from shared ini file.")
                );
              }
            } else if (currentSection) {
              var indexOfEqualsSign = line.indexOf("=");
              var start = 0;
              var end = line.length - 1;
              var isAssignment = indexOfEqualsSign !== -1 && indexOfEqualsSign !== start && indexOfEqualsSign !== end;
              if (isAssignment) {
                var name = line.substring(0, indexOfEqualsSign).trim();
                var value = line.substring(indexOfEqualsSign + 1).trim();
                map[currentSection] = map[currentSection] || {};
                map[currentSection][name] = value;
              }
            }
          });
          return map;
        }
      },
      fn: {
        noop: function() {
        },
        callback: function(err) {
          if (err)
            throw err;
        },
        /**
         * Turn a synchronous function into as "async" function by making it call
         * a callback. The underlying function is called with all but the last argument,
         * which is treated as the callback. The callback is passed passed a first argument
         * of null on success to mimick standard node callbacks.
         */
        makeAsync: function makeAsync(fn, expectedArgs) {
          if (expectedArgs && expectedArgs <= fn.length) {
            return fn;
          }
          return function() {
            var args = Array.prototype.slice.call(arguments, 0);
            var callback = args.pop();
            var result = fn.apply(null, args);
            callback(result);
          };
        }
      },
      /**
       * Date and time utility functions.
       */
      date: {
        /**
         * @return [Date] the current JavaScript date object. Since all
         *   AWS services rely on this date object, you can override
         *   this function to provide a special time value to AWS service
         *   requests.
         */
        getDate: function getDate() {
          if (!AWS2)
            AWS2 = require_core();
          if (AWS2.config.systemClockOffset) {
            return new Date((/* @__PURE__ */ new Date()).getTime() + AWS2.config.systemClockOffset);
          } else {
            return /* @__PURE__ */ new Date();
          }
        },
        /**
         * @return [String] the date in ISO-8601 format
         */
        iso8601: function iso8601(date) {
          if (date === void 0) {
            date = util.date.getDate();
          }
          return date.toISOString().replace(/\.\d{3}Z$/, "Z");
        },
        /**
         * @return [String] the date in RFC 822 format
         */
        rfc822: function rfc822(date) {
          if (date === void 0) {
            date = util.date.getDate();
          }
          return date.toUTCString();
        },
        /**
         * @return [Integer] the UNIX timestamp value for the current time
         */
        unixTimestamp: function unixTimestamp(date) {
          if (date === void 0) {
            date = util.date.getDate();
          }
          return date.getTime() / 1e3;
        },
        /**
         * @param [String,number,Date] date
         * @return [Date]
         */
        from: function format(date) {
          if (typeof date === "number") {
            return new Date(date * 1e3);
          } else {
            return new Date(date);
          }
        },
        /**
         * Given a Date or date-like value, this function formats the
         * date into a string of the requested value.
         * @param [String,number,Date] date
         * @param [String] formatter Valid formats are:
         #   * 'iso8601'
         #   * 'rfc822'
         #   * 'unixTimestamp'
         * @return [String]
         */
        format: function format(date, formatter) {
          if (!formatter)
            formatter = "iso8601";
          return util.date[formatter](util.date.from(date));
        },
        parseTimestamp: function parseTimestamp(value) {
          if (typeof value === "number") {
            return new Date(value * 1e3);
          } else if (value.match(/^\d+$/)) {
            return new Date(value * 1e3);
          } else if (value.match(/^\d{4}/)) {
            return new Date(value);
          } else if (value.match(/^\w{3},/)) {
            return new Date(value);
          } else {
            throw util.error(
              new Error("unhandled timestamp format: " + value),
              { code: "TimestampParserError" }
            );
          }
        }
      },
      crypto: {
        crc32Table: [
          0,
          1996959894,
          3993919788,
          2567524794,
          124634137,
          1886057615,
          3915621685,
          2657392035,
          249268274,
          2044508324,
          3772115230,
          2547177864,
          162941995,
          2125561021,
          3887607047,
          2428444049,
          498536548,
          1789927666,
          4089016648,
          2227061214,
          450548861,
          1843258603,
          4107580753,
          2211677639,
          325883990,
          1684777152,
          4251122042,
          2321926636,
          335633487,
          1661365465,
          4195302755,
          2366115317,
          997073096,
          1281953886,
          3579855332,
          2724688242,
          1006888145,
          1258607687,
          3524101629,
          2768942443,
          901097722,
          1119000684,
          3686517206,
          2898065728,
          853044451,
          1172266101,
          3705015759,
          2882616665,
          651767980,
          1373503546,
          3369554304,
          3218104598,
          565507253,
          1454621731,
          3485111705,
          3099436303,
          671266974,
          1594198024,
          3322730930,
          2970347812,
          795835527,
          1483230225,
          3244367275,
          3060149565,
          1994146192,
          31158534,
          2563907772,
          4023717930,
          1907459465,
          112637215,
          2680153253,
          3904427059,
          2013776290,
          251722036,
          2517215374,
          3775830040,
          2137656763,
          141376813,
          2439277719,
          3865271297,
          1802195444,
          476864866,
          2238001368,
          4066508878,
          1812370925,
          453092731,
          2181625025,
          4111451223,
          1706088902,
          314042704,
          2344532202,
          4240017532,
          1658658271,
          366619977,
          2362670323,
          4224994405,
          1303535960,
          984961486,
          2747007092,
          3569037538,
          1256170817,
          1037604311,
          2765210733,
          3554079995,
          1131014506,
          879679996,
          2909243462,
          3663771856,
          1141124467,
          855842277,
          2852801631,
          3708648649,
          1342533948,
          654459306,
          3188396048,
          3373015174,
          1466479909,
          544179635,
          3110523913,
          3462522015,
          1591671054,
          702138776,
          2966460450,
          3352799412,
          1504918807,
          783551873,
          3082640443,
          3233442989,
          3988292384,
          2596254646,
          62317068,
          1957810842,
          3939845945,
          2647816111,
          81470997,
          1943803523,
          3814918930,
          2489596804,
          225274430,
          2053790376,
          3826175755,
          2466906013,
          167816743,
          2097651377,
          4027552580,
          2265490386,
          503444072,
          1762050814,
          4150417245,
          2154129355,
          426522225,
          1852507879,
          4275313526,
          2312317920,
          282753626,
          1742555852,
          4189708143,
          2394877945,
          397917763,
          1622183637,
          3604390888,
          2714866558,
          953729732,
          1340076626,
          3518719985,
          2797360999,
          1068828381,
          1219638859,
          3624741850,
          2936675148,
          906185462,
          1090812512,
          3747672003,
          2825379669,
          829329135,
          1181335161,
          3412177804,
          3160834842,
          628085408,
          1382605366,
          3423369109,
          3138078467,
          570562233,
          1426400815,
          3317316542,
          2998733608,
          733239954,
          1555261956,
          3268935591,
          3050360625,
          752459403,
          1541320221,
          2607071920,
          3965973030,
          1969922972,
          40735498,
          2617837225,
          3943577151,
          1913087877,
          83908371,
          2512341634,
          3803740692,
          2075208622,
          213261112,
          2463272603,
          3855990285,
          2094854071,
          198958881,
          2262029012,
          4057260610,
          1759359992,
          534414190,
          2176718541,
          4139329115,
          1873836001,
          414664567,
          2282248934,
          4279200368,
          1711684554,
          285281116,
          2405801727,
          4167216745,
          1634467795,
          376229701,
          2685067896,
          3608007406,
          1308918612,
          956543938,
          2808555105,
          3495958263,
          1231636301,
          1047427035,
          2932959818,
          3654703836,
          1088359270,
          936918e3,
          2847714899,
          3736837829,
          1202900863,
          817233897,
          3183342108,
          3401237130,
          1404277552,
          615818150,
          3134207493,
          3453421203,
          1423857449,
          601450431,
          3009837614,
          3294710456,
          1567103746,
          711928724,
          3020668471,
          3272380065,
          1510334235,
          755167117
        ],
        crc32: function crc32(data) {
          var tbl = util.crypto.crc32Table;
          var crc = 0 ^ -1;
          if (typeof data === "string") {
            data = util.buffer.toBuffer(data);
          }
          for (var i = 0; i < data.length; i++) {
            var code = data.readUInt8(i);
            crc = crc >>> 8 ^ tbl[(crc ^ code) & 255];
          }
          return (crc ^ -1) >>> 0;
        },
        hmac: function hmac(key, string, digest, fn) {
          if (!digest)
            digest = "binary";
          if (digest === "buffer") {
            digest = void 0;
          }
          if (!fn)
            fn = "sha256";
          if (typeof string === "string")
            string = util.buffer.toBuffer(string);
          return util.crypto.lib.createHmac(fn, key).update(string).digest(digest);
        },
        md5: function md5(data, digest, callback) {
          return util.crypto.hash("md5", data, digest, callback);
        },
        sha256: function sha256(data, digest, callback) {
          return util.crypto.hash("sha256", data, digest, callback);
        },
        hash: function(algorithm, data, digest, callback) {
          var hash = util.crypto.createHash(algorithm);
          if (!digest) {
            digest = "binary";
          }
          if (digest === "buffer") {
            digest = void 0;
          }
          if (typeof data === "string")
            data = util.buffer.toBuffer(data);
          var sliceFn = util.arraySliceFn(data);
          var isBuffer = util.Buffer.isBuffer(data);
          if (util.isBrowser() && typeof ArrayBuffer !== "undefined" && data && data.buffer instanceof ArrayBuffer)
            isBuffer = true;
          if (callback && typeof data === "object" && typeof data.on === "function" && !isBuffer) {
            data.on("data", function(chunk) {
              hash.update(chunk);
            });
            data.on("error", function(err) {
              callback(err);
            });
            data.on("end", function() {
              callback(null, hash.digest(digest));
            });
          } else if (callback && sliceFn && !isBuffer && typeof FileReader !== "undefined") {
            var index = 0, size = 1024 * 512;
            var reader = new FileReader();
            reader.onerror = function() {
              callback(new Error("Failed to read data."));
            };
            reader.onload = function() {
              var buf = new util.Buffer(new Uint8Array(reader.result));
              hash.update(buf);
              index += buf.length;
              reader._continueReading();
            };
            reader._continueReading = function() {
              if (index >= data.size) {
                callback(null, hash.digest(digest));
                return;
              }
              var back = index + size;
              if (back > data.size)
                back = data.size;
              reader.readAsArrayBuffer(sliceFn.call(data, index, back));
            };
            reader._continueReading();
          } else {
            if (util.isBrowser() && typeof data === "object" && !isBuffer) {
              data = new util.Buffer(new Uint8Array(data));
            }
            var out = hash.update(data).digest(digest);
            if (callback)
              callback(null, out);
            return out;
          }
        },
        toHex: function toHex(data) {
          var out = [];
          for (var i = 0; i < data.length; i++) {
            out.push(("0" + data.charCodeAt(i).toString(16)).substr(-2, 2));
          }
          return out.join("");
        },
        createHash: function createHash(algorithm) {
          return util.crypto.lib.createHash(algorithm);
        }
      },
      /** @!ignore */
      /* Abort constant */
      abort: {},
      each: function each(object, iterFunction) {
        for (var key in object) {
          if (Object.prototype.hasOwnProperty.call(object, key)) {
            var ret = iterFunction.call(this, key, object[key]);
            if (ret === util.abort)
              break;
          }
        }
      },
      arrayEach: function arrayEach(array, iterFunction) {
        for (var idx in array) {
          if (Object.prototype.hasOwnProperty.call(array, idx)) {
            var ret = iterFunction.call(this, array[idx], parseInt(idx, 10));
            if (ret === util.abort)
              break;
          }
        }
      },
      update: function update(obj1, obj2) {
        util.each(obj2, function iterator(key, item) {
          obj1[key] = item;
        });
        return obj1;
      },
      merge: function merge(obj1, obj2) {
        return util.update(util.copy(obj1), obj2);
      },
      copy: function copy(object) {
        if (object === null || object === void 0)
          return object;
        var dupe = {};
        for (var key in object) {
          dupe[key] = object[key];
        }
        return dupe;
      },
      isEmpty: function isEmpty(obj) {
        for (var prop in obj) {
          if (Object.prototype.hasOwnProperty.call(obj, prop)) {
            return false;
          }
        }
        return true;
      },
      arraySliceFn: function arraySliceFn(obj) {
        var fn = obj.slice || obj.webkitSlice || obj.mozSlice;
        return typeof fn === "function" ? fn : null;
      },
      isType: function isType(obj, type) {
        if (typeof type === "function")
          type = util.typeName(type);
        return Object.prototype.toString.call(obj) === "[object " + type + "]";
      },
      typeName: function typeName(type) {
        if (Object.prototype.hasOwnProperty.call(type, "name"))
          return type.name;
        var str = type.toString();
        var match = str.match(/^\s*function (.+)\(/);
        return match ? match[1] : str;
      },
      error: function error(err, options) {
        var originalError = null;
        if (typeof err.message === "string" && err.message !== "") {
          if (typeof options === "string" || options && options.message) {
            originalError = util.copy(err);
            originalError.message = err.message;
          }
        }
        err.message = err.message || null;
        if (typeof options === "string") {
          err.message = options;
        } else if (typeof options === "object" && options !== null) {
          util.update(err, options);
          if (options.message)
            err.message = options.message;
          if (options.code || options.name)
            err.code = options.code || options.name;
          if (options.stack)
            err.stack = options.stack;
        }
        if (typeof Object.defineProperty === "function") {
          Object.defineProperty(err, "name", { writable: true, enumerable: false });
          Object.defineProperty(err, "message", { enumerable: true });
        }
        err.name = String(options && options.name || err.name || err.code || "Error");
        err.time = /* @__PURE__ */ new Date();
        if (originalError) {
          err.originalError = originalError;
        }
        for (var key in options || {}) {
          if (key[0] === "[" && key[key.length - 1] === "]") {
            key = key.slice(1, -1);
            if (key === "code" || key === "message") {
              continue;
            }
            err["[" + key + "]"] = "See error." + key + " for details.";
            Object.defineProperty(err, key, {
              value: err[key] || options && options[key] || originalError && originalError[key],
              enumerable: false,
              writable: true
            });
          }
        }
        return err;
      },
      /**
       * @api private
       */
      inherit: function inherit(klass, features) {
        var newObject = null;
        if (features === void 0) {
          features = klass;
          klass = Object;
          newObject = {};
        } else {
          var ctor = function ConstructorWrapper() {
          };
          ctor.prototype = klass.prototype;
          newObject = new ctor();
        }
        if (features.constructor === Object) {
          features.constructor = function() {
            if (klass !== Object) {
              return klass.apply(this, arguments);
            }
          };
        }
        features.constructor.prototype = newObject;
        util.update(features.constructor.prototype, features);
        features.constructor.__super__ = klass;
        return features.constructor;
      },
      /**
       * @api private
       */
      mixin: function mixin() {
        var klass = arguments[0];
        for (var i = 1; i < arguments.length; i++) {
          for (var prop in arguments[i].prototype) {
            var fn = arguments[i].prototype[prop];
            if (prop !== "constructor") {
              klass.prototype[prop] = fn;
            }
          }
        }
        return klass;
      },
      /**
       * @api private
       */
      hideProperties: function hideProperties(obj, props) {
        if (typeof Object.defineProperty !== "function")
          return;
        util.arrayEach(props, function(key) {
          Object.defineProperty(obj, key, {
            enumerable: false,
            writable: true,
            configurable: true
          });
        });
      },
      /**
       * @api private
       */
      property: function property(obj, name, value, enumerable, isValue) {
        var opts = {
          configurable: true,
          enumerable: enumerable !== void 0 ? enumerable : true
        };
        if (typeof value === "function" && !isValue) {
          opts.get = value;
        } else {
          opts.value = value;
          opts.writable = true;
        }
        Object.defineProperty(obj, name, opts);
      },
      /**
       * @api private
       */
      memoizedProperty: function memoizedProperty(obj, name, get, enumerable) {
        var cachedValue = null;
        util.property(obj, name, function() {
          if (cachedValue === null) {
            cachedValue = get();
          }
          return cachedValue;
        }, enumerable);
      },
      /**
       * TODO Remove in major version revision
       * This backfill populates response data without the
       * top-level payload name.
       *
       * @api private
       */
      hoistPayloadMember: function hoistPayloadMember(resp) {
        var req = resp.request;
        var operationName = req.operation;
        var operation = req.service.api.operations[operationName];
        var output = operation.output;
        if (output.payload && !operation.hasEventOutput) {
          var payloadMember = output.members[output.payload];
          var responsePayload = resp.data[output.payload];
          if (payloadMember.type === "structure") {
            util.each(responsePayload, function(key, value) {
              util.property(resp.data, key, value, false);
            });
          }
        }
      },
      /**
       * Compute SHA-256 checksums of streams
       *
       * @api private
       */
      computeSha256: function computeSha256(body, done) {
        if (util.isNode()) {
          var Stream = util.stream.Stream;
          var fs = require("fs");
          if (typeof Stream === "function" && body instanceof Stream) {
            if (typeof body.path === "string") {
              var settings = {};
              if (typeof body.start === "number") {
                settings.start = body.start;
              }
              if (typeof body.end === "number") {
                settings.end = body.end;
              }
              body = fs.createReadStream(body.path, settings);
            } else {
              return done(new Error("Non-file stream objects are not supported with SigV4"));
            }
          }
        }
        util.crypto.sha256(body, "hex", function(err, sha) {
          if (err)
            done(err);
          else
            done(null, sha);
        });
      },
      /**
       * @api private
       */
      isClockSkewed: function isClockSkewed(serverTime) {
        if (serverTime) {
          util.property(
            AWS2.config,
            "isClockSkewed",
            Math.abs((/* @__PURE__ */ new Date()).getTime() - serverTime) >= 3e5,
            false
          );
          return AWS2.config.isClockSkewed;
        }
      },
      applyClockOffset: function applyClockOffset(serverTime) {
        if (serverTime)
          AWS2.config.systemClockOffset = serverTime - (/* @__PURE__ */ new Date()).getTime();
      },
      /**
       * @api private
       */
      extractRequestId: function extractRequestId(resp) {
        var requestId = resp.httpResponse.headers["x-amz-request-id"] || resp.httpResponse.headers["x-amzn-requestid"];
        if (!requestId && resp.data && resp.data.ResponseMetadata) {
          requestId = resp.data.ResponseMetadata.RequestId;
        }
        if (requestId) {
          resp.requestId = requestId;
        }
        if (resp.error) {
          resp.error.requestId = requestId;
        }
      },
      /**
       * @api private
       */
      addPromises: function addPromises(constructors, PromiseDependency) {
        var deletePromises = false;
        if (PromiseDependency === void 0 && AWS2 && AWS2.config) {
          PromiseDependency = AWS2.config.getPromisesDependency();
        }
        if (PromiseDependency === void 0 && typeof Promise !== "undefined") {
          PromiseDependency = Promise;
        }
        if (typeof PromiseDependency !== "function")
          deletePromises = true;
        if (!Array.isArray(constructors))
          constructors = [constructors];
        for (var ind = 0; ind < constructors.length; ind++) {
          var constructor = constructors[ind];
          if (deletePromises) {
            if (constructor.deletePromisesFromClass) {
              constructor.deletePromisesFromClass();
            }
          } else if (constructor.addPromisesToClass) {
            constructor.addPromisesToClass(PromiseDependency);
          }
        }
      },
      /**
       * @api private
       * Return a function that will return a promise whose fate is decided by the
       * callback behavior of the given method with `methodName`. The method to be
       * promisified should conform to node.js convention of accepting a callback as
       * last argument and calling that callback with error as the first argument
       * and success value on the second argument.
       */
      promisifyMethod: function promisifyMethod(methodName, PromiseDependency) {
        return function promise() {
          var self2 = this;
          var args = Array.prototype.slice.call(arguments);
          return new PromiseDependency(function(resolve, reject) {
            args.push(function(err, data) {
              if (err) {
                reject(err);
              } else {
                resolve(data);
              }
            });
            self2[methodName].apply(self2, args);
          });
        };
      },
      /**
       * @api private
       */
      isDualstackAvailable: function isDualstackAvailable(service) {
        if (!service)
          return false;
        var metadata = require_metadata();
        if (typeof service !== "string")
          service = service.serviceIdentifier;
        if (typeof service !== "string" || !metadata.hasOwnProperty(service))
          return false;
        return !!metadata[service].dualstackAvailable;
      },
      /**
       * @api private
       */
      calculateRetryDelay: function calculateRetryDelay(retryCount, retryDelayOptions, err) {
        if (!retryDelayOptions)
          retryDelayOptions = {};
        var customBackoff = retryDelayOptions.customBackoff || null;
        if (typeof customBackoff === "function") {
          return customBackoff(retryCount, err);
        }
        var base = typeof retryDelayOptions.base === "number" ? retryDelayOptions.base : 100;
        var delay = Math.random() * (Math.pow(2, retryCount) * base);
        return delay;
      },
      /**
       * @api private
       */
      handleRequestWithRetries: function handleRequestWithRetries(httpRequest, options, cb) {
        if (!options)
          options = {};
        var http = AWS2.HttpClient.getInstance();
        var httpOptions = options.httpOptions || {};
        var retryCount = 0;
        var errCallback = function(err) {
          var maxRetries = options.maxRetries || 0;
          if (err && err.code === "TimeoutError")
            err.retryable = true;
          if (err && err.retryable && retryCount < maxRetries) {
            var delay = util.calculateRetryDelay(retryCount, options.retryDelayOptions, err);
            if (delay >= 0) {
              retryCount++;
              setTimeout(sendRequest, delay + (err.retryAfter || 0));
              return;
            }
          }
          cb(err);
        };
        var sendRequest = function() {
          var data = "";
          http.handleRequest(httpRequest, httpOptions, function(httpResponse) {
            httpResponse.on("data", function(chunk) {
              data += chunk.toString();
            });
            httpResponse.on("end", function() {
              var statusCode = httpResponse.statusCode;
              if (statusCode < 300) {
                cb(null, data);
              } else {
                var retryAfter = parseInt(httpResponse.headers["retry-after"], 10) * 1e3 || 0;
                var err = util.error(
                  new Error(),
                  {
                    statusCode,
                    retryable: statusCode >= 500 || statusCode === 429
                  }
                );
                if (retryAfter && err.retryable)
                  err.retryAfter = retryAfter;
                errCallback(err);
              }
            });
          }, errCallback);
        };
        AWS2.util.defer(sendRequest);
      },
      /**
       * @api private
       */
      uuid: {
        v4: function uuidV4() {
          return require_dist().v4();
        }
      },
      /**
       * @api private
       */
      convertPayloadToString: function convertPayloadToString(resp) {
        var req = resp.request;
        var operation = req.operation;
        var rules = req.service.api.operations[operation].output || {};
        if (rules.payload && resp.data[rules.payload]) {
          resp.data[rules.payload] = resp.data[rules.payload].toString();
        }
      },
      /**
       * @api private
       */
      defer: function defer(callback) {
        if (typeof process === "object" && typeof process.nextTick === "function") {
          process.nextTick(callback);
        } else if (typeof setImmediate === "function") {
          setImmediate(callback);
        } else {
          setTimeout(callback, 0);
        }
      },
      /**
       * @api private
       */
      getRequestPayloadShape: function getRequestPayloadShape(req) {
        var operations = req.service.api.operations;
        if (!operations)
          return void 0;
        var operation = (operations || {})[req.operation];
        if (!operation || !operation.input || !operation.input.payload)
          return void 0;
        return operation.input.members[operation.input.payload];
      },
      getProfilesFromSharedConfig: function getProfilesFromSharedConfig(iniLoader, filename) {
        var profiles = {};
        var profilesFromConfig = {};
        if (process.env[util.configOptInEnv]) {
          var profilesFromConfig = iniLoader.loadFrom({
            isConfig: true,
            filename: process.env[util.sharedConfigFileEnv]
          });
        }
        var profilesFromCreds = {};
        try {
          var profilesFromCreds = iniLoader.loadFrom({
            filename: filename || process.env[util.configOptInEnv] && process.env[util.sharedCredentialsFileEnv]
          });
        } catch (error) {
          if (!process.env[util.configOptInEnv])
            throw error;
        }
        for (var i = 0, profileNames = Object.keys(profilesFromConfig); i < profileNames.length; i++) {
          profiles[profileNames[i]] = objectAssign(profiles[profileNames[i]] || {}, profilesFromConfig[profileNames[i]]);
        }
        for (var i = 0, profileNames = Object.keys(profilesFromCreds); i < profileNames.length; i++) {
          profiles[profileNames[i]] = objectAssign(profiles[profileNames[i]] || {}, profilesFromCreds[profileNames[i]]);
        }
        return profiles;
        function objectAssign(target, source) {
          for (var i2 = 0, keys = Object.keys(source); i2 < keys.length; i2++) {
            target[keys[i2]] = source[keys[i2]];
          }
          return target;
        }
      },
      /**
       * @api private
       */
      ARN: {
        validate: function validateARN(str) {
          return str && str.indexOf("arn:") === 0 && str.split(":").length >= 6;
        },
        parse: function parseARN(arn) {
          var matched = arn.split(":");
          return {
            partition: matched[1],
            service: matched[2],
            region: matched[3],
            accountId: matched[4],
            resource: matched.slice(5).join(":")
          };
        },
        build: function buildARN(arnObject) {
          if (arnObject.service === void 0 || arnObject.region === void 0 || arnObject.accountId === void 0 || arnObject.resource === void 0)
            throw util.error(new Error("Input ARN object is invalid"));
          return "arn:" + (arnObject.partition || "aws") + ":" + arnObject.service + ":" + arnObject.region + ":" + arnObject.accountId + ":" + arnObject.resource;
        }
      },
      /**
       * @api private
       */
      defaultProfile: "default",
      /**
       * @api private
       */
      configOptInEnv: "AWS_SDK_LOAD_CONFIG",
      /**
       * @api private
       */
      sharedCredentialsFileEnv: "AWS_SHARED_CREDENTIALS_FILE",
      /**
       * @api private
       */
      sharedConfigFileEnv: "AWS_CONFIG_FILE",
      /**
       * @api private
       */
      imdsDisabledEnv: "AWS_EC2_METADATA_DISABLED"
    };
    module2.exports = util;
  }
});

// node_modules/aws-sdk/lib/event-stream/event-message-chunker-stream.js
var require_event_message_chunker_stream = __commonJS({
  "node_modules/aws-sdk/lib/event-stream/event-message-chunker-stream.js"(exports2, module2) {
    "use strict";
    var util = require_core().util;
    var Transform = require("stream").Transform;
    var allocBuffer = util.buffer.alloc;
    function EventMessageChunkerStream(options) {
      Transform.call(this, options);
      this.currentMessageTotalLength = 0;
      this.currentMessagePendingLength = 0;
      this.currentMessage = null;
      this.messageLengthBuffer = null;
    }
    EventMessageChunkerStream.prototype = Object.create(Transform.prototype);
    EventMessageChunkerStream.prototype._transform = function(chunk, encoding, callback) {
      var chunkLength = chunk.length;
      var currentOffset = 0;
      while (currentOffset < chunkLength) {
        if (!this.currentMessage) {
          var bytesRemaining = chunkLength - currentOffset;
          if (!this.messageLengthBuffer) {
            this.messageLengthBuffer = allocBuffer(4);
          }
          var numBytesForTotal = Math.min(
            4 - this.currentMessagePendingLength,
            // remaining bytes to fill the messageLengthBuffer
            bytesRemaining
            // bytes left in chunk
          );
          chunk.copy(
            this.messageLengthBuffer,
            this.currentMessagePendingLength,
            currentOffset,
            currentOffset + numBytesForTotal
          );
          this.currentMessagePendingLength += numBytesForTotal;
          currentOffset += numBytesForTotal;
          if (this.currentMessagePendingLength < 4) {
            break;
          }
          this.allocateMessage(this.messageLengthBuffer.readUInt32BE(0));
          this.messageLengthBuffer = null;
        }
        var numBytesToWrite = Math.min(
          this.currentMessageTotalLength - this.currentMessagePendingLength,
          // number of bytes left to complete message
          chunkLength - currentOffset
          // number of bytes left in the original chunk
        );
        chunk.copy(
          this.currentMessage,
          // target buffer
          this.currentMessagePendingLength,
          // target offset
          currentOffset,
          // chunk offset
          currentOffset + numBytesToWrite
          // chunk end to write
        );
        this.currentMessagePendingLength += numBytesToWrite;
        currentOffset += numBytesToWrite;
        if (this.currentMessageTotalLength && this.currentMessageTotalLength === this.currentMessagePendingLength) {
          this.push(this.currentMessage);
          this.currentMessage = null;
          this.currentMessageTotalLength = 0;
          this.currentMessagePendingLength = 0;
        }
      }
      callback();
    };
    EventMessageChunkerStream.prototype._flush = function(callback) {
      if (this.currentMessageTotalLength) {
        if (this.currentMessageTotalLength === this.currentMessagePendingLength) {
          callback(null, this.currentMessage);
        } else {
          callback(new Error("Truncated event message received."));
        }
      } else {
        callback();
      }
    };
    EventMessageChunkerStream.prototype.allocateMessage = function(size) {
      if (typeof size !== "number") {
        throw new Error("Attempted to allocate an event message where size was not a number: " + size);
      }
      this.currentMessageTotalLength = size;
      this.currentMessagePendingLength = 4;
      this.currentMessage = allocBuffer(size);
      this.currentMessage.writeUInt32BE(size, 0);
    };
    module2.exports = {
      EventMessageChunkerStream
    };
  }
});

// node_modules/aws-sdk/lib/event-stream/int64.js
var require_int64 = __commonJS({
  "node_modules/aws-sdk/lib/event-stream/int64.js"(exports2, module2) {
    "use strict";
    var util = require_core().util;
    var toBuffer = util.buffer.toBuffer;
    function Int64(bytes) {
      if (bytes.length !== 8) {
        throw new Error("Int64 buffers must be exactly 8 bytes");
      }
      if (!util.Buffer.isBuffer(bytes))
        bytes = toBuffer(bytes);
      this.bytes = bytes;
    }
    Int64.fromNumber = function(number) {
      if (number > 9223372036854776e3 || number < -9223372036854776e3) {
        throw new Error(
          number + " is too large (or, if negative, too small) to represent as an Int64"
        );
      }
      var bytes = new Uint8Array(8);
      for (var i = 7, remaining = Math.abs(Math.round(number)); i > -1 && remaining > 0; i--, remaining /= 256) {
        bytes[i] = remaining;
      }
      if (number < 0) {
        negate(bytes);
      }
      return new Int64(bytes);
    };
    Int64.prototype.valueOf = function() {
      var bytes = this.bytes.slice(0);
      var negative = bytes[0] & 128;
      if (negative) {
        negate(bytes);
      }
      return parseInt(bytes.toString("hex"), 16) * (negative ? -1 : 1);
    };
    Int64.prototype.toString = function() {
      return String(this.valueOf());
    };
    function negate(bytes) {
      for (var i = 0; i < 8; i++) {
        bytes[i] ^= 255;
      }
      for (var i = 7; i > -1; i--) {
        bytes[i]++;
        if (bytes[i] !== 0) {
          break;
        }
      }
    }
    module2.exports = {
      Int64
    };
  }
});

// node_modules/aws-sdk/lib/event-stream/split-message.js
var require_split_message = __commonJS({
  "node_modules/aws-sdk/lib/event-stream/split-message.js"(exports2, module2) {
    "use strict";
    var util = require_core().util;
    var toBuffer = util.buffer.toBuffer;
    var PRELUDE_MEMBER_LENGTH = 4;
    var PRELUDE_LENGTH = PRELUDE_MEMBER_LENGTH * 2;
    var CHECKSUM_LENGTH = 4;
    var MINIMUM_MESSAGE_LENGTH = PRELUDE_LENGTH + CHECKSUM_LENGTH * 2;
    function splitMessage(message) {
      if (!util.Buffer.isBuffer(message))
        message = toBuffer(message);
      if (message.length < MINIMUM_MESSAGE_LENGTH) {
        throw new Error("Provided message too short to accommodate event stream message overhead");
      }
      if (message.length !== message.readUInt32BE(0)) {
        throw new Error("Reported message length does not match received message length");
      }
      var expectedPreludeChecksum = message.readUInt32BE(PRELUDE_LENGTH);
      if (expectedPreludeChecksum !== util.crypto.crc32(
        message.slice(0, PRELUDE_LENGTH)
      )) {
        throw new Error(
          "The prelude checksum specified in the message (" + expectedPreludeChecksum + ") does not match the calculated CRC32 checksum."
        );
      }
      var expectedMessageChecksum = message.readUInt32BE(message.length - CHECKSUM_LENGTH);
      if (expectedMessageChecksum !== util.crypto.crc32(
        message.slice(0, message.length - CHECKSUM_LENGTH)
      )) {
        throw new Error(
          "The message checksum did not match the expected value of " + expectedMessageChecksum
        );
      }
      var headersStart = PRELUDE_LENGTH + CHECKSUM_LENGTH;
      var headersEnd = headersStart + message.readUInt32BE(PRELUDE_MEMBER_LENGTH);
      return {
        headers: message.slice(headersStart, headersEnd),
        body: message.slice(headersEnd, message.length - CHECKSUM_LENGTH)
      };
    }
    module2.exports = {
      splitMessage
    };
  }
});

// node_modules/aws-sdk/lib/event-stream/parse-message.js
var require_parse_message = __commonJS({
  "node_modules/aws-sdk/lib/event-stream/parse-message.js"(exports2, module2) {
    "use strict";
    var Int64 = require_int64().Int64;
    var splitMessage = require_split_message().splitMessage;
    var BOOLEAN_TAG = "boolean";
    var BYTE_TAG = "byte";
    var SHORT_TAG = "short";
    var INT_TAG = "integer";
    var LONG_TAG = "long";
    var BINARY_TAG = "binary";
    var STRING_TAG = "string";
    var TIMESTAMP_TAG = "timestamp";
    var UUID_TAG = "uuid";
    function parseHeaders(headers) {
      var out = {};
      var position = 0;
      while (position < headers.length) {
        var nameLength = headers.readUInt8(position++);
        var name = headers.slice(position, position + nameLength).toString();
        position += nameLength;
        switch (headers.readUInt8(position++)) {
          case 0:
            out[name] = {
              type: BOOLEAN_TAG,
              value: true
            };
            break;
          case 1:
            out[name] = {
              type: BOOLEAN_TAG,
              value: false
            };
            break;
          case 2:
            out[name] = {
              type: BYTE_TAG,
              value: headers.readInt8(position++)
            };
            break;
          case 3:
            out[name] = {
              type: SHORT_TAG,
              value: headers.readInt16BE(position)
            };
            position += 2;
            break;
          case 4:
            out[name] = {
              type: INT_TAG,
              value: headers.readInt32BE(position)
            };
            position += 4;
            break;
          case 5:
            out[name] = {
              type: LONG_TAG,
              value: new Int64(headers.slice(position, position + 8))
            };
            position += 8;
            break;
          case 6:
            var binaryLength = headers.readUInt16BE(position);
            position += 2;
            out[name] = {
              type: BINARY_TAG,
              value: headers.slice(position, position + binaryLength)
            };
            position += binaryLength;
            break;
          case 7:
            var stringLength = headers.readUInt16BE(position);
            position += 2;
            out[name] = {
              type: STRING_TAG,
              value: headers.slice(
                position,
                position + stringLength
              ).toString()
            };
            position += stringLength;
            break;
          case 8:
            out[name] = {
              type: TIMESTAMP_TAG,
              value: new Date(
                new Int64(headers.slice(position, position + 8)).valueOf()
              )
            };
            position += 8;
            break;
          case 9:
            var uuidChars = headers.slice(position, position + 16).toString("hex");
            position += 16;
            out[name] = {
              type: UUID_TAG,
              value: uuidChars.substr(0, 8) + "-" + uuidChars.substr(8, 4) + "-" + uuidChars.substr(12, 4) + "-" + uuidChars.substr(16, 4) + "-" + uuidChars.substr(20)
            };
            break;
          default:
            throw new Error("Unrecognized header type tag");
        }
      }
      return out;
    }
    function parseMessage(message) {
      var parsed = splitMessage(message);
      return { headers: parseHeaders(parsed.headers), body: parsed.body };
    }
    module2.exports = {
      parseMessage
    };
  }
});

// node_modules/aws-sdk/lib/event-stream/parse-event.js
var require_parse_event = __commonJS({
  "node_modules/aws-sdk/lib/event-stream/parse-event.js"(exports2, module2) {
    "use strict";
    var parseMessage = require_parse_message().parseMessage;
    function parseEvent(parser, message, shape) {
      var parsedMessage = parseMessage(message);
      var messageType = parsedMessage.headers[":message-type"];
      if (messageType) {
        if (messageType.value === "error") {
          throw parseError(parsedMessage);
        } else if (messageType.value !== "event") {
          return;
        }
      }
      var eventType = parsedMessage.headers[":event-type"];
      var eventModel = shape.members[eventType.value];
      if (!eventModel) {
        return;
      }
      var result = {};
      var eventPayloadMemberName = eventModel.eventPayloadMemberName;
      if (eventPayloadMemberName) {
        var payloadShape = eventModel.members[eventPayloadMemberName];
        if (payloadShape.type === "binary") {
          result[eventPayloadMemberName] = parsedMessage.body;
        } else {
          result[eventPayloadMemberName] = parser.parse(parsedMessage.body.toString(), payloadShape);
        }
      }
      var eventHeaderNames = eventModel.eventHeaderMemberNames;
      for (var i = 0; i < eventHeaderNames.length; i++) {
        var name = eventHeaderNames[i];
        if (parsedMessage.headers[name]) {
          result[name] = eventModel.members[name].toType(parsedMessage.headers[name].value);
        }
      }
      var output = {};
      output[eventType.value] = result;
      return output;
    }
    function parseError(message) {
      var errorCode = message.headers[":error-code"];
      var errorMessage = message.headers[":error-message"];
      var error = new Error(errorMessage.value || errorMessage);
      error.code = error.name = errorCode.value || errorCode;
      return error;
    }
    module2.exports = {
      parseEvent
    };
  }
});

// node_modules/aws-sdk/lib/event-stream/event-message-unmarshaller-stream.js
var require_event_message_unmarshaller_stream = __commonJS({
  "node_modules/aws-sdk/lib/event-stream/event-message-unmarshaller-stream.js"(exports2, module2) {
    "use strict";
    var Transform = require("stream").Transform;
    var parseEvent = require_parse_event().parseEvent;
    function EventUnmarshallerStream(options) {
      options = options || {};
      options.readableObjectMode = true;
      Transform.call(this, options);
      this._readableState.objectMode = true;
      this.parser = options.parser;
      this.eventStreamModel = options.eventStreamModel;
    }
    EventUnmarshallerStream.prototype = Object.create(Transform.prototype);
    EventUnmarshallerStream.prototype._transform = function(chunk, encoding, callback) {
      try {
        var event = parseEvent(this.parser, chunk, this.eventStreamModel);
        this.push(event);
        return callback();
      } catch (err) {
        callback(err);
      }
    };
    module2.exports = {
      EventUnmarshallerStream
    };
  }
});

// node_modules/aws-sdk/lib/event-stream/streaming-create-event-stream.js
var require_streaming_create_event_stream = __commonJS({
  "node_modules/aws-sdk/lib/event-stream/streaming-create-event-stream.js"(exports2, module2) {
    "use strict";
    var EventMessageChunkerStream = require_event_message_chunker_stream().EventMessageChunkerStream;
    var EventUnmarshallerStream = require_event_message_unmarshaller_stream().EventUnmarshallerStream;
    function createEventStream(stream, parser, model) {
      var eventStream = new EventUnmarshallerStream({
        parser,
        eventStreamModel: model
      });
      var eventMessageChunker = new EventMessageChunkerStream();
      stream.pipe(
        eventMessageChunker
      ).pipe(eventStream);
      stream.on("error", function(err) {
        eventMessageChunker.emit("error", err);
      });
      eventMessageChunker.on("error", function(err) {
        eventStream.emit("error", err);
      });
      return eventStream;
    }
    module2.exports = {
      createEventStream
    };
  }
});

// node_modules/aws-sdk/lib/event-stream/event-message-chunker.js
var require_event_message_chunker = __commonJS({
  "node_modules/aws-sdk/lib/event-stream/event-message-chunker.js"(exports2, module2) {
    "use strict";
    function eventMessageChunker(buffer) {
      var messages = [];
      var offset = 0;
      while (offset < buffer.length) {
        var totalLength = buffer.readInt32BE(offset);
        var message = buffer.slice(offset, totalLength + offset);
        offset += totalLength;
        messages.push(message);
      }
      return messages;
    }
    module2.exports = {
      eventMessageChunker
    };
  }
});

// node_modules/aws-sdk/lib/event-stream/buffered-create-event-stream.js
var require_buffered_create_event_stream = __commonJS({
  "node_modules/aws-sdk/lib/event-stream/buffered-create-event-stream.js"(exports2, module2) {
    "use strict";
    var eventMessageChunker = require_event_message_chunker().eventMessageChunker;
    var parseEvent = require_parse_event().parseEvent;
    function createEventStream(body, parser, model) {
      var eventMessages = eventMessageChunker(body);
      var events = [];
      for (var i = 0; i < eventMessages.length; i++) {
        events.push(parseEvent(parser, eventMessages[i], model));
      }
      return events;
    }
    module2.exports = {
      createEventStream
    };
  }
});

// node_modules/aws-sdk/lib/realclock/nodeClock.js
var require_nodeClock = __commonJS({
  "node_modules/aws-sdk/lib/realclock/nodeClock.js"(exports2, module2) {
    "use strict";
    module2.exports = {
      //provide realtime clock for performance measurement
      now: function now() {
        var second = process.hrtime();
        return second[0] * 1e3 + second[1] / 1e6;
      }
    };
  }
});

// node_modules/aws-sdk/lib/publisher/index.js
var require_publisher = __commonJS({
  "node_modules/aws-sdk/lib/publisher/index.js"(exports2, module2) {
    "use strict";
    var util = require_core().util;
    var dgram = require("dgram");
    var stringToBuffer = util.buffer.toBuffer;
    var MAX_MESSAGE_SIZE = 1024 * 8;
    function Publisher(options) {
      options = options || {};
      this.enabled = options.enabled || false;
      this.port = options.port || 31e3;
      this.clientId = options.clientId || "";
      this.address = options.host || "127.0.0.1";
      if (this.clientId.length > 255) {
        this.clientId = this.clientId.substr(0, 255);
      }
      this.messagesInFlight = 0;
    }
    Publisher.prototype.fieldsToTrim = {
      UserAgent: 256,
      SdkException: 128,
      SdkExceptionMessage: 512,
      AwsException: 128,
      AwsExceptionMessage: 512,
      FinalSdkException: 128,
      FinalSdkExceptionMessage: 512,
      FinalAwsException: 128,
      FinalAwsExceptionMessage: 512
    };
    Publisher.prototype.trimFields = function(event) {
      var trimmableFields = Object.keys(this.fieldsToTrim);
      for (var i = 0, iLen = trimmableFields.length; i < iLen; i++) {
        var field = trimmableFields[i];
        if (event.hasOwnProperty(field)) {
          var maxLength = this.fieldsToTrim[field];
          var value = event[field];
          if (value && value.length > maxLength) {
            event[field] = value.substr(0, maxLength);
          }
        }
      }
      return event;
    };
    Publisher.prototype.eventHandler = function(event) {
      event.ClientId = this.clientId;
      this.trimFields(event);
      var message = stringToBuffer(JSON.stringify(event));
      if (!this.enabled || message.length > MAX_MESSAGE_SIZE) {
        return;
      }
      this.publishDatagram(message);
    };
    Publisher.prototype.publishDatagram = function(message) {
      var self2 = this;
      var client = this.getClient();
      this.messagesInFlight++;
      this.client.send(message, 0, message.length, this.port, this.address, function(err, bytes) {
        if (--self2.messagesInFlight <= 0) {
          self2.destroyClient();
        }
      });
    };
    Publisher.prototype.getClient = function() {
      if (!this.client) {
        this.client = dgram.createSocket("udp4");
      }
      return this.client;
    };
    Publisher.prototype.destroyClient = function() {
      if (this.client) {
        this.client.close();
        this.client = void 0;
      }
    };
    module2.exports = {
      Publisher
    };
  }
});

// node_modules/aws-sdk/lib/publisher/configuration.js
var require_configuration = __commonJS({
  "node_modules/aws-sdk/lib/publisher/configuration.js"(exports2, module2) {
    "use strict";
    var AWS2 = require_core();
    function resolveMonitoringConfig() {
      var config = {
        port: void 0,
        clientId: void 0,
        enabled: void 0,
        host: void 0
      };
      if (fromEnvironment(config) || fromConfigFile(config))
        return toJSType(config);
      return toJSType(config);
    }
    function fromEnvironment(config) {
      config.port = config.port || process.env.AWS_CSM_PORT;
      config.enabled = config.enabled || process.env.AWS_CSM_ENABLED;
      config.clientId = config.clientId || process.env.AWS_CSM_CLIENT_ID;
      config.host = config.host || process.env.AWS_CSM_HOST;
      return config.port && config.enabled && config.clientId && config.host || ["false", "0"].indexOf(config.enabled) >= 0;
    }
    function fromConfigFile(config) {
      var sharedFileConfig;
      try {
        var configFile = AWS2.util.iniLoader.loadFrom({
          isConfig: true,
          filename: process.env[AWS2.util.sharedConfigFileEnv]
        });
        var sharedFileConfig = configFile[process.env.AWS_PROFILE || AWS2.util.defaultProfile];
      } catch (err) {
        return false;
      }
      if (!sharedFileConfig)
        return config;
      config.port = config.port || sharedFileConfig.csm_port;
      config.enabled = config.enabled || sharedFileConfig.csm_enabled;
      config.clientId = config.clientId || sharedFileConfig.csm_client_id;
      config.host = config.host || sharedFileConfig.csm_host;
      return config.port && config.enabled && config.clientId && config.host;
    }
    function toJSType(config) {
      var falsyNotations = ["false", "0", void 0];
      if (!config.enabled || falsyNotations.indexOf(config.enabled.toLowerCase()) >= 0) {
        config.enabled = false;
      } else {
        config.enabled = true;
      }
      config.port = config.port ? parseInt(config.port, 10) : void 0;
      return config;
    }
    module2.exports = resolveMonitoringConfig;
  }
});

// node_modules/aws-sdk/lib/shared-ini/ini-loader.js
var require_ini_loader = __commonJS({
  "node_modules/aws-sdk/lib/shared-ini/ini-loader.js"(exports2, module2) {
    "use strict";
    var AWS2 = require_core();
    var os = require("os");
    var path = require("path");
    function parseFile(filename) {
      return AWS2.util.ini.parse(AWS2.util.readFileSync(filename));
    }
    function getProfiles(fileContent) {
      var tmpContent = {};
      Object.keys(fileContent).forEach(function(sectionName) {
        if (/^sso-session\s/.test(sectionName))
          return;
        Object.defineProperty(tmpContent, sectionName.replace(/^profile\s/, ""), {
          value: fileContent[sectionName],
          enumerable: true
        });
      });
      return tmpContent;
    }
    function getSsoSessions(fileContent) {
      var tmpContent = {};
      Object.keys(fileContent).forEach(function(sectionName) {
        if (!/^sso-session\s/.test(sectionName))
          return;
        Object.defineProperty(tmpContent, sectionName.replace(/^sso-session\s/, ""), {
          value: fileContent[sectionName],
          enumerable: true
        });
      });
      return tmpContent;
    }
    AWS2.IniLoader = AWS2.util.inherit({
      constructor: function IniLoader2() {
        this.resolvedProfiles = {};
        this.resolvedSsoSessions = {};
      },
      /** Remove all cached files. Used after config files are updated. */
      clearCachedFiles: function clearCachedFiles() {
        this.resolvedProfiles = {};
        this.resolvedSsoSessions = {};
      },
      /**
       * Load configurations from config/credentials files and cache them
       * for later use. If no file is specified it will try to load default files.
       *
       * @param options [map] information describing the file
       * @option options filename [String] ('~/.aws/credentials' or defined by
       *   AWS_SHARED_CREDENTIALS_FILE process env var or '~/.aws/config' if
       *   isConfig is set to true)
       *   path to the file to be read.
       * @option options isConfig [Boolean] (false) True to read config file.
       * @return [map<String,String>] object containing contents from file in key-value
       *   pairs.
       */
      loadFrom: function loadFrom(options) {
        options = options || {};
        var isConfig = options.isConfig === true;
        var filename = options.filename || this.getDefaultFilePath(isConfig);
        if (!this.resolvedProfiles[filename]) {
          var fileContent = parseFile(filename);
          if (isConfig) {
            Object.defineProperty(this.resolvedProfiles, filename, {
              value: getProfiles(fileContent)
            });
          } else {
            Object.defineProperty(this.resolvedProfiles, filename, { value: fileContent });
          }
        }
        return this.resolvedProfiles[filename];
      },
      /**
       * Load sso sessions from config/credentials files and cache them
       * for later use. If no file is specified it will try to load default file.
       *
       * @param options [map] information describing the file
       * @option options filename [String] ('~/.aws/config' or defined by
       *   AWS_CONFIG_FILE process env var)
       * @return [map<String,String>] object containing contents from file in key-value
       *   pairs.
       */
      loadSsoSessionsFrom: function loadSsoSessionsFrom(options) {
        options = options || {};
        var filename = options.filename || this.getDefaultFilePath(true);
        if (!this.resolvedSsoSessions[filename]) {
          var fileContent = parseFile(filename);
          Object.defineProperty(this.resolvedSsoSessions, filename, {
            value: getSsoSessions(fileContent)
          });
        }
        return this.resolvedSsoSessions[filename];
      },
      /**
       * @api private
       */
      getDefaultFilePath: function getDefaultFilePath(isConfig) {
        return path.join(
          this.getHomeDir(),
          ".aws",
          isConfig ? "config" : "credentials"
        );
      },
      /**
       * @api private
       */
      getHomeDir: function getHomeDir() {
        var env = process.env;
        var home = env.HOME || env.USERPROFILE || (env.HOMEPATH ? (env.HOMEDRIVE || "C:/") + env.HOMEPATH : null);
        if (home) {
          return home;
        }
        if (typeof os.homedir === "function") {
          return os.homedir();
        }
        throw AWS2.util.error(
          new Error("Cannot load credentials, HOME path not set")
        );
      }
    });
    var IniLoader = AWS2.IniLoader;
    module2.exports = {
      IniLoader
    };
  }
});

// node_modules/aws-sdk/lib/shared-ini/index.js
var require_shared_ini = __commonJS({
  "node_modules/aws-sdk/lib/shared-ini/index.js"(exports2, module2) {
    "use strict";
    var IniLoader = require_ini_loader().IniLoader;
    module2.exports.iniLoader = new IniLoader();
  }
});

// node_modules/aws-sdk/lib/config_regional_endpoint.js
var require_config_regional_endpoint = __commonJS({
  "node_modules/aws-sdk/lib/config_regional_endpoint.js"(exports2, module2) {
    "use strict";
    var AWS2 = require_core();
    function validateRegionalEndpointsFlagValue(configValue, errorOptions) {
      if (typeof configValue !== "string")
        return void 0;
      else if (["legacy", "regional"].indexOf(configValue.toLowerCase()) >= 0) {
        return configValue.toLowerCase();
      } else {
        throw AWS2.util.error(new Error(), errorOptions);
      }
    }
    function resolveRegionalEndpointsFlag(originalConfig, options) {
      originalConfig = originalConfig || {};
      var resolved;
      if (originalConfig[options.clientConfig]) {
        resolved = validateRegionalEndpointsFlagValue(originalConfig[options.clientConfig], {
          code: "InvalidConfiguration",
          message: 'invalid "' + options.clientConfig + '" configuration. Expect "legacy"  or "regional". Got "' + originalConfig[options.clientConfig] + '".'
        });
        if (resolved)
          return resolved;
      }
      if (!AWS2.util.isNode())
        return resolved;
      if (Object.prototype.hasOwnProperty.call(process.env, options.env)) {
        var envFlag = process.env[options.env];
        resolved = validateRegionalEndpointsFlagValue(envFlag, {
          code: "InvalidEnvironmentalVariable",
          message: "invalid " + options.env + ' environmental variable. Expect "legacy"  or "regional". Got "' + process.env[options.env] + '".'
        });
        if (resolved)
          return resolved;
      }
      var profile = {};
      try {
        var profiles = AWS2.util.getProfilesFromSharedConfig(AWS2.util.iniLoader);
        profile = profiles[process.env.AWS_PROFILE || AWS2.util.defaultProfile];
      } catch (e) {
      }
      ;
      if (profile && Object.prototype.hasOwnProperty.call(profile, options.sharedConfig)) {
        var fileFlag = profile[options.sharedConfig];
        resolved = validateRegionalEndpointsFlagValue(fileFlag, {
          code: "InvalidConfiguration",
          message: "invalid " + options.sharedConfig + ' profile config. Expect "legacy"  or "regional". Got "' + profile[options.sharedConfig] + '".'
        });
        if (resolved)
          return resolved;
      }
      return resolved;
    }
    module2.exports = resolveRegionalEndpointsFlag;
  }
});

// node_modules/aws-sdk/lib/services/sts.js
var require_sts = __commonJS({
  "node_modules/aws-sdk/lib/services/sts.js"() {
    "use strict";
    var AWS2 = require_core();
    var resolveRegionalEndpointsFlag = require_config_regional_endpoint();
    var ENV_REGIONAL_ENDPOINT_ENABLED = "AWS_STS_REGIONAL_ENDPOINTS";
    var CONFIG_REGIONAL_ENDPOINT_ENABLED = "sts_regional_endpoints";
    AWS2.util.update(AWS2.STS.prototype, {
      /**
       * @overload credentialsFrom(data, credentials = null)
       *   Creates a credentials object from STS response data containing
       *   credentials information. Useful for quickly setting AWS credentials.
       *
       *   @note This is a low-level utility function. If you want to load temporary
       *     credentials into your process for subsequent requests to AWS resources,
       *     you should use {AWS.TemporaryCredentials} instead.
       *   @param data [map] data retrieved from a call to {getFederatedToken},
       *     {getSessionToken}, {assumeRole}, or {assumeRoleWithWebIdentity}.
       *   @param credentials [AWS.Credentials] an optional credentials object to
       *     fill instead of creating a new object. Useful when modifying an
       *     existing credentials object from a refresh call.
       *   @return [AWS.TemporaryCredentials] the set of temporary credentials
       *     loaded from a raw STS operation response.
       *   @example Using credentialsFrom to load global AWS credentials
       *     var sts = new AWS.STS();
       *     sts.getSessionToken(function (err, data) {
       *       if (err) console.log("Error getting credentials");
       *       else {
       *         AWS.config.credentials = sts.credentialsFrom(data);
       *       }
       *     });
       *   @see AWS.TemporaryCredentials
       */
      credentialsFrom: function credentialsFrom(data, credentials) {
        if (!data)
          return null;
        if (!credentials)
          credentials = new AWS2.TemporaryCredentials();
        credentials.expired = false;
        credentials.accessKeyId = data.Credentials.AccessKeyId;
        credentials.secretAccessKey = data.Credentials.SecretAccessKey;
        credentials.sessionToken = data.Credentials.SessionToken;
        credentials.expireTime = data.Credentials.Expiration;
        return credentials;
      },
      assumeRoleWithWebIdentity: function assumeRoleWithWebIdentity(params, callback) {
        return this.makeUnauthenticatedRequest("assumeRoleWithWebIdentity", params, callback);
      },
      assumeRoleWithSAML: function assumeRoleWithSAML(params, callback) {
        return this.makeUnauthenticatedRequest("assumeRoleWithSAML", params, callback);
      },
      /**
       * @api private
       */
      setupRequestListeners: function setupRequestListeners(request) {
        request.addListener("validate", this.optInRegionalEndpoint, true);
      },
      /**
       * @api private
       */
      optInRegionalEndpoint: function optInRegionalEndpoint(req) {
        var service = req.service;
        var config = service.config;
        config.stsRegionalEndpoints = resolveRegionalEndpointsFlag(service._originalConfig, {
          env: ENV_REGIONAL_ENDPOINT_ENABLED,
          sharedConfig: CONFIG_REGIONAL_ENDPOINT_ENABLED,
          clientConfig: "stsRegionalEndpoints"
        });
        if (config.stsRegionalEndpoints === "regional" && service.isGlobalEndpoint) {
          if (!config.region) {
            throw AWS2.util.error(
              new Error(),
              { code: "ConfigError", message: "Missing region in config" }
            );
          }
          var insertPoint = config.endpoint.indexOf(".amazonaws.com");
          var regionalEndpoint = config.endpoint.substring(0, insertPoint) + "." + config.region + config.endpoint.substring(insertPoint);
          req.httpRequest.updateEndpoint(regionalEndpoint);
          req.httpRequest.region = config.region;
        }
      }
    });
  }
});

// node_modules/aws-sdk/apis/sts-2011-06-15.min.json
var require_sts_2011_06_15_min = __commonJS({
  "node_modules/aws-sdk/apis/sts-2011-06-15.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2011-06-15",
        endpointPrefix: "sts",
        globalEndpoint: "sts.amazonaws.com",
        protocol: "query",
        serviceAbbreviation: "AWS STS",
        serviceFullName: "AWS Security Token Service",
        serviceId: "STS",
        signatureVersion: "v4",
        uid: "sts-2011-06-15",
        xmlNamespace: "https://sts.amazonaws.com/doc/2011-06-15/"
      },
      operations: {
        AssumeRole: {
          input: {
            type: "structure",
            required: [
              "RoleArn",
              "RoleSessionName"
            ],
            members: {
              RoleArn: {},
              RoleSessionName: {},
              PolicyArns: {
                shape: "S4"
              },
              Policy: {},
              DurationSeconds: {
                type: "integer"
              },
              Tags: {
                shape: "S8"
              },
              TransitiveTagKeys: {
                type: "list",
                member: {}
              },
              ExternalId: {},
              SerialNumber: {},
              TokenCode: {},
              SourceIdentity: {},
              ProvidedContexts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ProviderArn: {},
                    ContextAssertion: {}
                  }
                }
              }
            }
          },
          output: {
            resultWrapper: "AssumeRoleResult",
            type: "structure",
            members: {
              Credentials: {
                shape: "Sl"
              },
              AssumedRoleUser: {
                shape: "Sq"
              },
              PackedPolicySize: {
                type: "integer"
              },
              SourceIdentity: {}
            }
          }
        },
        AssumeRoleWithSAML: {
          input: {
            type: "structure",
            required: [
              "RoleArn",
              "PrincipalArn",
              "SAMLAssertion"
            ],
            members: {
              RoleArn: {},
              PrincipalArn: {},
              SAMLAssertion: {
                type: "string",
                sensitive: true
              },
              PolicyArns: {
                shape: "S4"
              },
              Policy: {},
              DurationSeconds: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "AssumeRoleWithSAMLResult",
            type: "structure",
            members: {
              Credentials: {
                shape: "Sl"
              },
              AssumedRoleUser: {
                shape: "Sq"
              },
              PackedPolicySize: {
                type: "integer"
              },
              Subject: {},
              SubjectType: {},
              Issuer: {},
              Audience: {},
              NameQualifier: {},
              SourceIdentity: {}
            }
          }
        },
        AssumeRoleWithWebIdentity: {
          input: {
            type: "structure",
            required: [
              "RoleArn",
              "RoleSessionName",
              "WebIdentityToken"
            ],
            members: {
              RoleArn: {},
              RoleSessionName: {},
              WebIdentityToken: {
                type: "string",
                sensitive: true
              },
              ProviderId: {},
              PolicyArns: {
                shape: "S4"
              },
              Policy: {},
              DurationSeconds: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "AssumeRoleWithWebIdentityResult",
            type: "structure",
            members: {
              Credentials: {
                shape: "Sl"
              },
              SubjectFromWebIdentityToken: {},
              AssumedRoleUser: {
                shape: "Sq"
              },
              PackedPolicySize: {
                type: "integer"
              },
              Provider: {},
              Audience: {},
              SourceIdentity: {}
            }
          }
        },
        DecodeAuthorizationMessage: {
          input: {
            type: "structure",
            required: [
              "EncodedMessage"
            ],
            members: {
              EncodedMessage: {}
            }
          },
          output: {
            resultWrapper: "DecodeAuthorizationMessageResult",
            type: "structure",
            members: {
              DecodedMessage: {}
            }
          }
        },
        GetAccessKeyInfo: {
          input: {
            type: "structure",
            required: [
              "AccessKeyId"
            ],
            members: {
              AccessKeyId: {}
            }
          },
          output: {
            resultWrapper: "GetAccessKeyInfoResult",
            type: "structure",
            members: {
              Account: {}
            }
          }
        },
        GetCallerIdentity: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            resultWrapper: "GetCallerIdentityResult",
            type: "structure",
            members: {
              UserId: {},
              Account: {},
              Arn: {}
            }
          }
        },
        GetFederationToken: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Policy: {},
              PolicyArns: {
                shape: "S4"
              },
              DurationSeconds: {
                type: "integer"
              },
              Tags: {
                shape: "S8"
              }
            }
          },
          output: {
            resultWrapper: "GetFederationTokenResult",
            type: "structure",
            members: {
              Credentials: {
                shape: "Sl"
              },
              FederatedUser: {
                type: "structure",
                required: [
                  "FederatedUserId",
                  "Arn"
                ],
                members: {
                  FederatedUserId: {},
                  Arn: {}
                }
              },
              PackedPolicySize: {
                type: "integer"
              }
            }
          }
        },
        GetSessionToken: {
          input: {
            type: "structure",
            members: {
              DurationSeconds: {
                type: "integer"
              },
              SerialNumber: {},
              TokenCode: {}
            }
          },
          output: {
            resultWrapper: "GetSessionTokenResult",
            type: "structure",
            members: {
              Credentials: {
                shape: "Sl"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "list",
          member: {
            type: "structure",
            members: {
              arn: {}
            }
          }
        },
        S8: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sl: {
          type: "structure",
          required: [
            "AccessKeyId",
            "SecretAccessKey",
            "SessionToken",
            "Expiration"
          ],
          members: {
            AccessKeyId: {},
            SecretAccessKey: {
              type: "string",
              sensitive: true
            },
            SessionToken: {},
            Expiration: {
              type: "timestamp"
            }
          }
        },
        Sq: {
          type: "structure",
          required: [
            "AssumedRoleId",
            "Arn"
          ],
          members: {
            AssumedRoleId: {},
            Arn: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/sts-2011-06-15.paginators.json
var require_sts_2011_06_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/sts-2011-06-15.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/sts.js
var require_sts2 = __commonJS({
  "node_modules/aws-sdk/clients/sts.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["sts"] = {};
    AWS2.STS = Service.defineService("sts", ["2011-06-15"]);
    require_sts();
    Object.defineProperty(apiLoader.services["sts"], "2011-06-15", {
      get: function get() {
        var model = require_sts_2011_06_15_min();
        model.paginators = require_sts_2011_06_15_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.STS;
  }
});

// node_modules/aws-sdk/lib/credentials/temporary_credentials.js
var require_temporary_credentials = __commonJS({
  "node_modules/aws-sdk/lib/credentials/temporary_credentials.js"() {
    "use strict";
    var AWS2 = require_core();
    var STS2 = require_sts2();
    AWS2.TemporaryCredentials = AWS2.util.inherit(AWS2.Credentials, {
      /**
       * Creates a new temporary credentials object.
       *
       * @note In order to create temporary credentials, you first need to have
       *   "master" credentials configured in {AWS.Config.credentials}. These
       *   master credentials are necessary to retrieve the temporary credentials,
       *   as well as refresh the credentials when they expire.
       * @param params [map] a map of options that are passed to the
       *   {AWS.STS.assumeRole} or {AWS.STS.getSessionToken} operations.
       *   If a `RoleArn` parameter is passed in, credentials will be based on the
       *   IAM role.
       * @param masterCredentials [AWS.Credentials] the master (non-temporary) credentials
       *  used to get and refresh temporary credentials from AWS STS.
       * @example Creating a new credentials object for generic temporary credentials
       *   AWS.config.credentials = new AWS.TemporaryCredentials();
       * @example Creating a new credentials object for an IAM role
       *   AWS.config.credentials = new AWS.TemporaryCredentials({
       *     RoleArn: 'arn:aws:iam::1234567890:role/TemporaryCredentials',
       *   });
       * @see AWS.STS.assumeRole
       * @see AWS.STS.getSessionToken
       */
      constructor: function TemporaryCredentials(params, masterCredentials) {
        AWS2.Credentials.call(this);
        this.loadMasterCredentials(masterCredentials);
        this.expired = true;
        this.params = params || {};
        if (this.params.RoleArn) {
          this.params.RoleSessionName = this.params.RoleSessionName || "temporary-credentials";
        }
      },
      /**
       * Refreshes credentials using {AWS.STS.assumeRole} or
       * {AWS.STS.getSessionToken}, depending on whether an IAM role ARN was passed
       * to the credentials {constructor}.
       *
       * @callback callback function(err)
       *   Called when the STS service responds (or fails). When
       *   this callback is called with no error, it means that the credentials
       *   information has been loaded into the object (as the `accessKeyId`,
       *   `secretAccessKey`, and `sessionToken` properties).
       *   @param err [Error] if an error occurred, this value will be filled
       * @see get
       */
      refresh: function refresh(callback) {
        this.coalesceRefresh(callback || AWS2.util.fn.callback);
      },
      /**
       * @api private
       */
      load: function load(callback) {
        var self2 = this;
        self2.createClients();
        self2.masterCredentials.get(function() {
          self2.service.config.credentials = self2.masterCredentials;
          var operation = self2.params.RoleArn ? self2.service.assumeRole : self2.service.getSessionToken;
          operation.call(self2.service, function(err, data) {
            if (!err) {
              self2.service.credentialsFrom(data, self2);
            }
            callback(err);
          });
        });
      },
      /**
       * @api private
       */
      loadMasterCredentials: function loadMasterCredentials(masterCredentials) {
        this.masterCredentials = masterCredentials || AWS2.config.credentials;
        while (this.masterCredentials.masterCredentials) {
          this.masterCredentials = this.masterCredentials.masterCredentials;
        }
        if (typeof this.masterCredentials.get !== "function") {
          this.masterCredentials = new AWS2.Credentials(this.masterCredentials);
        }
      },
      /**
       * @api private
       */
      createClients: function() {
        this.service = this.service || new STS2({ params: this.params });
      }
    });
  }
});

// node_modules/aws-sdk/lib/credentials/chainable_temporary_credentials.js
var require_chainable_temporary_credentials = __commonJS({
  "node_modules/aws-sdk/lib/credentials/chainable_temporary_credentials.js"() {
    "use strict";
    var AWS2 = require_core();
    var STS2 = require_sts2();
    AWS2.ChainableTemporaryCredentials = AWS2.util.inherit(AWS2.Credentials, {
      /**
       * Creates a new temporary credentials object.
       *
       * @param options [map] a set of options
       * @option options params [map] ({}) a map of options that are passed to the
       *   {AWS.STS.assumeRole} or {AWS.STS.getSessionToken} operations.
       *   If a `RoleArn` parameter is passed in, credentials will be based on the
       *   IAM role. If a `SerialNumber` parameter is passed in, {tokenCodeFn} must
       *   also be passed in or an error will be thrown.
       * @option options masterCredentials [AWS.Credentials] the master credentials
       *   used to get and refresh temporary credentials from AWS STS. By default,
       *   AWS.config.credentials or AWS.config.credentialProvider will be used.
       * @option options tokenCodeFn [Function] (null) Function to provide
       *   `TokenCode`, if `SerialNumber` is provided for profile in {params}. Function
       *   is called with value of `SerialNumber` and `callback`, and should provide
       *   the `TokenCode` or an error to the callback in the format
       *   `callback(err, token)`.
       * @example Creating a new credentials object for generic temporary credentials
       *   AWS.config.credentials = new AWS.ChainableTemporaryCredentials();
       * @example Creating a new credentials object for an IAM role
       *   AWS.config.credentials = new AWS.ChainableTemporaryCredentials({
       *     params: {
       *       RoleArn: 'arn:aws:iam::1234567890:role/TemporaryCredentials'
       *     }
       *   });
       * @see AWS.STS.assumeRole
       * @see AWS.STS.getSessionToken
       */
      constructor: function ChainableTemporaryCredentials(options) {
        AWS2.Credentials.call(this);
        options = options || {};
        this.errorCode = "ChainableTemporaryCredentialsProviderFailure";
        this.expired = true;
        this.tokenCodeFn = null;
        var params = AWS2.util.copy(options.params) || {};
        if (params.RoleArn) {
          params.RoleSessionName = params.RoleSessionName || "temporary-credentials";
        }
        if (params.SerialNumber) {
          if (!options.tokenCodeFn || typeof options.tokenCodeFn !== "function") {
            throw new AWS2.util.error(
              new Error("tokenCodeFn must be a function when params.SerialNumber is given"),
              { code: this.errorCode }
            );
          } else {
            this.tokenCodeFn = options.tokenCodeFn;
          }
        }
        var config = AWS2.util.merge(
          {
            params,
            credentials: options.masterCredentials || AWS2.config.credentials
          },
          options.stsConfig || {}
        );
        this.service = new STS2(config);
      },
      /**
       * Refreshes credentials using {AWS.STS.assumeRole} or
       * {AWS.STS.getSessionToken}, depending on whether an IAM role ARN was passed
       * to the credentials {constructor}.
       *
       * @callback callback function(err)
       *   Called when the STS service responds (or fails). When
       *   this callback is called with no error, it means that the credentials
       *   information has been loaded into the object (as the `accessKeyId`,
       *   `secretAccessKey`, and `sessionToken` properties).
       *   @param err [Error] if an error occurred, this value will be filled
       * @see AWS.Credentials.get
       */
      refresh: function refresh(callback) {
        this.coalesceRefresh(callback || AWS2.util.fn.callback);
      },
      /**
       * @api private
       * @param callback
       */
      load: function load(callback) {
        var self2 = this;
        var operation = self2.service.config.params.RoleArn ? "assumeRole" : "getSessionToken";
        this.getTokenCode(function(err, tokenCode) {
          var params = {};
          if (err) {
            callback(err);
            return;
          }
          if (tokenCode) {
            params.TokenCode = tokenCode;
          }
          self2.service[operation](params, function(err2, data) {
            if (!err2) {
              self2.service.credentialsFrom(data, self2);
            }
            callback(err2);
          });
        });
      },
      /**
       * @api private
       */
      getTokenCode: function getTokenCode(callback) {
        var self2 = this;
        if (this.tokenCodeFn) {
          this.tokenCodeFn(this.service.config.params.SerialNumber, function(err, token) {
            if (err) {
              var message = err;
              if (err instanceof Error) {
                message = err.message;
              }
              callback(
                AWS2.util.error(
                  new Error("Error fetching MFA token: " + message),
                  { code: self2.errorCode }
                )
              );
              return;
            }
            callback(null, token);
          });
        } else {
          callback(null);
        }
      }
    });
  }
});

// node_modules/aws-sdk/lib/credentials/web_identity_credentials.js
var require_web_identity_credentials = __commonJS({
  "node_modules/aws-sdk/lib/credentials/web_identity_credentials.js"() {
    "use strict";
    var AWS2 = require_core();
    var STS2 = require_sts2();
    AWS2.WebIdentityCredentials = AWS2.util.inherit(AWS2.Credentials, {
      /**
       * Creates a new credentials object.
       * @param (see AWS.STS.assumeRoleWithWebIdentity)
       * @example Creating a new credentials object
       *   AWS.config.credentials = new AWS.WebIdentityCredentials({
       *     RoleArn: 'arn:aws:iam::1234567890:role/WebIdentity',
       *     WebIdentityToken: 'ABCDEFGHIJKLMNOP', // token from identity service
       *     RoleSessionName: 'web' // optional name, defaults to web-identity
       *   }, {
       *     // optionally provide configuration to apply to the underlying AWS.STS service client
       *     // if configuration is not provided, then configuration will be pulled from AWS.config
       *
       *     // specify timeout options
       *     httpOptions: {
       *       timeout: 100
       *     }
       *   });
       * @see AWS.STS.assumeRoleWithWebIdentity
       * @see AWS.Config
       */
      constructor: function WebIdentityCredentials(params, clientConfig) {
        AWS2.Credentials.call(this);
        this.expired = true;
        this.params = params;
        this.params.RoleSessionName = this.params.RoleSessionName || "web-identity";
        this.data = null;
        this._clientConfig = AWS2.util.copy(clientConfig || {});
      },
      /**
       * Refreshes credentials using {AWS.STS.assumeRoleWithWebIdentity}
       *
       * @callback callback function(err)
       *   Called when the STS service responds (or fails). When
       *   this callback is called with no error, it means that the credentials
       *   information has been loaded into the object (as the `accessKeyId`,
       *   `secretAccessKey`, and `sessionToken` properties).
       *   @param err [Error] if an error occurred, this value will be filled
       * @see get
       */
      refresh: function refresh(callback) {
        this.coalesceRefresh(callback || AWS2.util.fn.callback);
      },
      /**
       * @api private
       */
      load: function load(callback) {
        var self2 = this;
        self2.createClients();
        self2.service.assumeRoleWithWebIdentity(function(err, data) {
          self2.data = null;
          if (!err) {
            self2.data = data;
            self2.service.credentialsFrom(data, self2);
          }
          callback(err);
        });
      },
      /**
       * @api private
       */
      createClients: function() {
        if (!this.service) {
          var stsConfig = AWS2.util.merge({}, this._clientConfig);
          stsConfig.params = this.params;
          this.service = new STS2(stsConfig);
        }
      }
    });
  }
});

// node_modules/aws-sdk/apis/cognito-identity-2014-06-30.min.json
var require_cognito_identity_2014_06_30_min = __commonJS({
  "node_modules/aws-sdk/apis/cognito-identity-2014-06-30.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-06-30",
        endpointPrefix: "cognito-identity",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Cognito Identity",
        serviceId: "Cognito Identity",
        signatureVersion: "v4",
        targetPrefix: "AWSCognitoIdentityService",
        uid: "cognito-identity-2014-06-30"
      },
      operations: {
        CreateIdentityPool: {
          input: {
            type: "structure",
            required: [
              "IdentityPoolName",
              "AllowUnauthenticatedIdentities"
            ],
            members: {
              IdentityPoolName: {},
              AllowUnauthenticatedIdentities: {
                type: "boolean"
              },
              AllowClassicFlow: {
                type: "boolean"
              },
              SupportedLoginProviders: {
                shape: "S5"
              },
              DeveloperProviderName: {},
              OpenIdConnectProviderARNs: {
                shape: "S9"
              },
              CognitoIdentityProviders: {
                shape: "Sb"
              },
              SamlProviderARNs: {
                shape: "Sg"
              },
              IdentityPoolTags: {
                shape: "Sh"
              }
            }
          },
          output: {
            shape: "Sk"
          }
        },
        DeleteIdentities: {
          input: {
            type: "structure",
            required: [
              "IdentityIdsToDelete"
            ],
            members: {
              IdentityIdsToDelete: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UnprocessedIdentityIds: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    IdentityId: {},
                    ErrorCode: {}
                  }
                }
              }
            }
          }
        },
        DeleteIdentityPool: {
          input: {
            type: "structure",
            required: [
              "IdentityPoolId"
            ],
            members: {
              IdentityPoolId: {}
            }
          }
        },
        DescribeIdentity: {
          input: {
            type: "structure",
            required: [
              "IdentityId"
            ],
            members: {
              IdentityId: {}
            }
          },
          output: {
            shape: "Sv"
          }
        },
        DescribeIdentityPool: {
          input: {
            type: "structure",
            required: [
              "IdentityPoolId"
            ],
            members: {
              IdentityPoolId: {}
            }
          },
          output: {
            shape: "Sk"
          }
        },
        GetCredentialsForIdentity: {
          input: {
            type: "structure",
            required: [
              "IdentityId"
            ],
            members: {
              IdentityId: {},
              Logins: {
                shape: "S10"
              },
              CustomRoleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityId: {},
              Credentials: {
                type: "structure",
                members: {
                  AccessKeyId: {},
                  SecretKey: {},
                  SessionToken: {},
                  Expiration: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          authtype: "none"
        },
        GetId: {
          input: {
            type: "structure",
            required: [
              "IdentityPoolId"
            ],
            members: {
              AccountId: {},
              IdentityPoolId: {},
              Logins: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityId: {}
            }
          },
          authtype: "none"
        },
        GetIdentityPoolRoles: {
          input: {
            type: "structure",
            required: [
              "IdentityPoolId"
            ],
            members: {
              IdentityPoolId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityPoolId: {},
              Roles: {
                shape: "S1c"
              },
              RoleMappings: {
                shape: "S1e"
              }
            }
          }
        },
        GetOpenIdToken: {
          input: {
            type: "structure",
            required: [
              "IdentityId"
            ],
            members: {
              IdentityId: {},
              Logins: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityId: {},
              Token: {}
            }
          },
          authtype: "none"
        },
        GetOpenIdTokenForDeveloperIdentity: {
          input: {
            type: "structure",
            required: [
              "IdentityPoolId",
              "Logins"
            ],
            members: {
              IdentityPoolId: {},
              IdentityId: {},
              Logins: {
                shape: "S10"
              },
              PrincipalTags: {
                shape: "S1s"
              },
              TokenDuration: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityId: {},
              Token: {}
            }
          }
        },
        GetPrincipalTagAttributeMap: {
          input: {
            type: "structure",
            required: [
              "IdentityPoolId",
              "IdentityProviderName"
            ],
            members: {
              IdentityPoolId: {},
              IdentityProviderName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityPoolId: {},
              IdentityProviderName: {},
              UseDefaults: {
                type: "boolean"
              },
              PrincipalTags: {
                shape: "S1s"
              }
            }
          }
        },
        ListIdentities: {
          input: {
            type: "structure",
            required: [
              "IdentityPoolId",
              "MaxResults"
            ],
            members: {
              IdentityPoolId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              HideDisabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityPoolId: {},
              Identities: {
                type: "list",
                member: {
                  shape: "Sv"
                }
              },
              NextToken: {}
            }
          }
        },
        ListIdentityPools: {
          input: {
            type: "structure",
            required: [
              "MaxResults"
            ],
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityPools: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    IdentityPoolId: {},
                    IdentityPoolName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sh"
              }
            }
          }
        },
        LookupDeveloperIdentity: {
          input: {
            type: "structure",
            required: [
              "IdentityPoolId"
            ],
            members: {
              IdentityPoolId: {},
              IdentityId: {},
              DeveloperUserIdentifier: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityId: {},
              DeveloperUserIdentifierList: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        MergeDeveloperIdentities: {
          input: {
            type: "structure",
            required: [
              "SourceUserIdentifier",
              "DestinationUserIdentifier",
              "DeveloperProviderName",
              "IdentityPoolId"
            ],
            members: {
              SourceUserIdentifier: {},
              DestinationUserIdentifier: {},
              DeveloperProviderName: {},
              IdentityPoolId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityId: {}
            }
          }
        },
        SetIdentityPoolRoles: {
          input: {
            type: "structure",
            required: [
              "IdentityPoolId",
              "Roles"
            ],
            members: {
              IdentityPoolId: {},
              Roles: {
                shape: "S1c"
              },
              RoleMappings: {
                shape: "S1e"
              }
            }
          }
        },
        SetPrincipalTagAttributeMap: {
          input: {
            type: "structure",
            required: [
              "IdentityPoolId",
              "IdentityProviderName"
            ],
            members: {
              IdentityPoolId: {},
              IdentityProviderName: {},
              UseDefaults: {
                type: "boolean"
              },
              PrincipalTags: {
                shape: "S1s"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityPoolId: {},
              IdentityProviderName: {},
              UseDefaults: {
                type: "boolean"
              },
              PrincipalTags: {
                shape: "S1s"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "Sh"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UnlinkDeveloperIdentity: {
          input: {
            type: "structure",
            required: [
              "IdentityId",
              "IdentityPoolId",
              "DeveloperProviderName",
              "DeveloperUserIdentifier"
            ],
            members: {
              IdentityId: {},
              IdentityPoolId: {},
              DeveloperProviderName: {},
              DeveloperUserIdentifier: {}
            }
          }
        },
        UnlinkIdentity: {
          input: {
            type: "structure",
            required: [
              "IdentityId",
              "Logins",
              "LoginsToRemove"
            ],
            members: {
              IdentityId: {},
              Logins: {
                shape: "S10"
              },
              LoginsToRemove: {
                shape: "Sw"
              }
            }
          },
          authtype: "none"
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateIdentityPool: {
          input: {
            shape: "Sk"
          },
          output: {
            shape: "Sk"
          }
        }
      },
      shapes: {
        S5: {
          type: "map",
          key: {},
          value: {}
        },
        S9: {
          type: "list",
          member: {}
        },
        Sb: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ProviderName: {},
              ClientId: {},
              ServerSideTokenCheck: {
                type: "boolean"
              }
            }
          }
        },
        Sg: {
          type: "list",
          member: {}
        },
        Sh: {
          type: "map",
          key: {},
          value: {}
        },
        Sk: {
          type: "structure",
          required: [
            "IdentityPoolId",
            "IdentityPoolName",
            "AllowUnauthenticatedIdentities"
          ],
          members: {
            IdentityPoolId: {},
            IdentityPoolName: {},
            AllowUnauthenticatedIdentities: {
              type: "boolean"
            },
            AllowClassicFlow: {
              type: "boolean"
            },
            SupportedLoginProviders: {
              shape: "S5"
            },
            DeveloperProviderName: {},
            OpenIdConnectProviderARNs: {
              shape: "S9"
            },
            CognitoIdentityProviders: {
              shape: "Sb"
            },
            SamlProviderARNs: {
              shape: "Sg"
            },
            IdentityPoolTags: {
              shape: "Sh"
            }
          }
        },
        Sv: {
          type: "structure",
          members: {
            IdentityId: {},
            Logins: {
              shape: "Sw"
            },
            CreationDate: {
              type: "timestamp"
            },
            LastModifiedDate: {
              type: "timestamp"
            }
          }
        },
        Sw: {
          type: "list",
          member: {}
        },
        S10: {
          type: "map",
          key: {},
          value: {}
        },
        S1c: {
          type: "map",
          key: {},
          value: {}
        },
        S1e: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "Type"
            ],
            members: {
              Type: {},
              AmbiguousRoleResolution: {},
              RulesConfiguration: {
                type: "structure",
                required: [
                  "Rules"
                ],
                members: {
                  Rules: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Claim",
                        "MatchType",
                        "Value",
                        "RoleARN"
                      ],
                      members: {
                        Claim: {},
                        MatchType: {},
                        Value: {},
                        RoleARN: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S1s: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cognito-identity-2014-06-30.paginators.json
var require_cognito_identity_2014_06_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cognito-identity-2014-06-30.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListIdentityPools: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "IdentityPools"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/cognitoidentity.js
var require_cognitoidentity = __commonJS({
  "node_modules/aws-sdk/clients/cognitoidentity.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["cognitoidentity"] = {};
    AWS2.CognitoIdentity = Service.defineService("cognitoidentity", ["2014-06-30"]);
    Object.defineProperty(apiLoader.services["cognitoidentity"], "2014-06-30", {
      get: function get() {
        var model = require_cognito_identity_2014_06_30_min();
        model.paginators = require_cognito_identity_2014_06_30_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CognitoIdentity;
  }
});

// node_modules/aws-sdk/lib/credentials/cognito_identity_credentials.js
var require_cognito_identity_credentials = __commonJS({
  "node_modules/aws-sdk/lib/credentials/cognito_identity_credentials.js"() {
    "use strict";
    var AWS2 = require_core();
    var CognitoIdentity = require_cognitoidentity();
    var STS2 = require_sts2();
    AWS2.CognitoIdentityCredentials = AWS2.util.inherit(AWS2.Credentials, {
      /**
       * @api private
       */
      localStorageKey: {
        id: "aws.cognito.identity-id.",
        providers: "aws.cognito.identity-providers."
      },
      /**
       * Creates a new credentials object.
       * @example Creating a new credentials object
       *   AWS.config.credentials = new AWS.CognitoIdentityCredentials({
       *
       *     // either IdentityPoolId or IdentityId is required
       *     // See the IdentityPoolId param for AWS.CognitoIdentity.getID (linked below)
       *     // See the IdentityId param for AWS.CognitoIdentity.getCredentialsForIdentity
       *     // or AWS.CognitoIdentity.getOpenIdToken (linked below)
       *     IdentityPoolId: 'us-east-1:1699ebc0-7900-4099-b910-2df94f52a030',
       *     IdentityId: 'us-east-1:128d0a74-c82f-4553-916d-90053e4a8b0f'
       *
       *     // optional, only necessary when the identity pool is not configured
       *     // to use IAM roles in the Amazon Cognito Console
       *     // See the RoleArn param for AWS.STS.assumeRoleWithWebIdentity (linked below)
       *     RoleArn: 'arn:aws:iam::1234567890:role/MYAPP-CognitoIdentity',
       *
       *     // optional tokens, used for authenticated login
       *     // See the Logins param for AWS.CognitoIdentity.getID (linked below)
       *     Logins: {
       *       'graph.facebook.com': 'FBTOKEN',
       *       'www.amazon.com': 'AMAZONTOKEN',
       *       'accounts.google.com': 'GOOGLETOKEN',
       *       'api.twitter.com': 'TWITTERTOKEN',
       *       'www.digits.com': 'DIGITSTOKEN'
       *     },
       *
       *     // optional name, defaults to web-identity
       *     // See the RoleSessionName param for AWS.STS.assumeRoleWithWebIdentity (linked below)
       *     RoleSessionName: 'web',
       *
       *     // optional, only necessary when application runs in a browser
       *     // and multiple users are signed in at once, used for caching
       *     LoginId: 'example@gmail.com'
       *
       *   }, {
       *      // optionally provide configuration to apply to the underlying service clients
       *      // if configuration is not provided, then configuration will be pulled from AWS.config
       *
       *      // region should match the region your identity pool is located in
       *      region: 'us-east-1',
       *
       *      // specify timeout options
       *      httpOptions: {
       *        timeout: 100
       *      }
       *   });
       * @see AWS.CognitoIdentity.getId
       * @see AWS.CognitoIdentity.getCredentialsForIdentity
       * @see AWS.STS.assumeRoleWithWebIdentity
       * @see AWS.CognitoIdentity.getOpenIdToken
       * @see AWS.Config
       * @note If a region is not provided in the global AWS.config, or
       *   specified in the `clientConfig` to the CognitoIdentityCredentials
       *   constructor, you may encounter a 'Missing credentials in config' error
       *   when calling making a service call.
       */
      constructor: function CognitoIdentityCredentials(params, clientConfig) {
        AWS2.Credentials.call(this);
        this.expired = true;
        this.params = params;
        this.data = null;
        this._identityId = null;
        this._clientConfig = AWS2.util.copy(clientConfig || {});
        this.loadCachedId();
        var self2 = this;
        Object.defineProperty(this, "identityId", {
          get: function() {
            self2.loadCachedId();
            return self2._identityId || self2.params.IdentityId;
          },
          set: function(identityId) {
            self2._identityId = identityId;
          }
        });
      },
      /**
       * Refreshes credentials using {AWS.CognitoIdentity.getCredentialsForIdentity},
       * or {AWS.STS.assumeRoleWithWebIdentity}.
       *
       * @callback callback function(err)
       *   Called when the STS service responds (or fails). When
       *   this callback is called with no error, it means that the credentials
       *   information has been loaded into the object (as the `accessKeyId`,
       *   `secretAccessKey`, and `sessionToken` properties).
       *   @param err [Error] if an error occurred, this value will be filled
       * @see AWS.Credentials.get
       */
      refresh: function refresh(callback) {
        this.coalesceRefresh(callback || AWS2.util.fn.callback);
      },
      /**
       * @api private
       * @param callback
       */
      load: function load(callback) {
        var self2 = this;
        self2.createClients();
        self2.data = null;
        self2._identityId = null;
        self2.getId(function(err) {
          if (!err) {
            if (!self2.params.RoleArn) {
              self2.getCredentialsForIdentity(callback);
            } else {
              self2.getCredentialsFromSTS(callback);
            }
          } else {
            self2.clearIdOnNotAuthorized(err);
            callback(err);
          }
        });
      },
      /**
       * Clears the cached Cognito ID associated with the currently configured
       * identity pool ID. Use this to manually invalidate your cache if
       * the identity pool ID was deleted.
       */
      clearCachedId: function clearCache() {
        this._identityId = null;
        delete this.params.IdentityId;
        var poolId = this.params.IdentityPoolId;
        var loginId = this.params.LoginId || "";
        delete this.storage[this.localStorageKey.id + poolId + loginId];
        delete this.storage[this.localStorageKey.providers + poolId + loginId];
      },
      /**
       * @api private
       */
      clearIdOnNotAuthorized: function clearIdOnNotAuthorized(err) {
        var self2 = this;
        if (err.code == "NotAuthorizedException") {
          self2.clearCachedId();
        }
      },
      /**
       * Retrieves a Cognito ID, loading from cache if it was already retrieved
       * on this device.
       *
       * @callback callback function(err, identityId)
       *   @param err [Error, null] an error object if the call failed or null if
       *     it succeeded.
       *   @param identityId [String, null] if successful, the callback will return
       *     the Cognito ID.
       * @note If not loaded explicitly, the Cognito ID is loaded and stored in
       *   localStorage in the browser environment of a device.
       * @api private
       */
      getId: function getId(callback) {
        var self2 = this;
        if (typeof self2.params.IdentityId === "string") {
          return callback(null, self2.params.IdentityId);
        }
        self2.cognito.getId(function(err, data) {
          if (!err && data.IdentityId) {
            self2.params.IdentityId = data.IdentityId;
            callback(null, data.IdentityId);
          } else {
            callback(err);
          }
        });
      },
      /**
       * @api private
       */
      loadCredentials: function loadCredentials(data, credentials) {
        if (!data || !credentials)
          return;
        credentials.expired = false;
        credentials.accessKeyId = data.Credentials.AccessKeyId;
        credentials.secretAccessKey = data.Credentials.SecretKey;
        credentials.sessionToken = data.Credentials.SessionToken;
        credentials.expireTime = data.Credentials.Expiration;
      },
      /**
       * @api private
       */
      getCredentialsForIdentity: function getCredentialsForIdentity(callback) {
        var self2 = this;
        self2.cognito.getCredentialsForIdentity(function(err, data) {
          if (!err) {
            self2.cacheId(data);
            self2.data = data;
            self2.loadCredentials(self2.data, self2);
          } else {
            self2.clearIdOnNotAuthorized(err);
          }
          callback(err);
        });
      },
      /**
       * @api private
       */
      getCredentialsFromSTS: function getCredentialsFromSTS(callback) {
        var self2 = this;
        self2.cognito.getOpenIdToken(function(err, data) {
          if (!err) {
            self2.cacheId(data);
            self2.params.WebIdentityToken = data.Token;
            self2.webIdentityCredentials.refresh(function(webErr) {
              if (!webErr) {
                self2.data = self2.webIdentityCredentials.data;
                self2.sts.credentialsFrom(self2.data, self2);
              }
              callback(webErr);
            });
          } else {
            self2.clearIdOnNotAuthorized(err);
            callback(err);
          }
        });
      },
      /**
       * @api private
       */
      loadCachedId: function loadCachedId() {
        var self2 = this;
        if (AWS2.util.isBrowser() && !self2.params.IdentityId) {
          var id = self2.getStorage("id");
          if (id && self2.params.Logins) {
            var actualProviders = Object.keys(self2.params.Logins);
            var cachedProviders = (self2.getStorage("providers") || "").split(",");
            var intersect = cachedProviders.filter(function(n) {
              return actualProviders.indexOf(n) !== -1;
            });
            if (intersect.length !== 0) {
              self2.params.IdentityId = id;
            }
          } else if (id) {
            self2.params.IdentityId = id;
          }
        }
      },
      /**
       * @api private
       */
      createClients: function() {
        var clientConfig = this._clientConfig;
        this.webIdentityCredentials = this.webIdentityCredentials || new AWS2.WebIdentityCredentials(this.params, clientConfig);
        if (!this.cognito) {
          var cognitoConfig = AWS2.util.merge({}, clientConfig);
          cognitoConfig.params = this.params;
          this.cognito = new CognitoIdentity(cognitoConfig);
        }
        this.sts = this.sts || new STS2(clientConfig);
      },
      /**
       * @api private
       */
      cacheId: function cacheId(data) {
        this._identityId = data.IdentityId;
        this.params.IdentityId = this._identityId;
        if (AWS2.util.isBrowser()) {
          this.setStorage("id", data.IdentityId);
          if (this.params.Logins) {
            this.setStorage("providers", Object.keys(this.params.Logins).join(","));
          }
        }
      },
      /**
       * @api private
       */
      getStorage: function getStorage(key) {
        return this.storage[this.localStorageKey[key] + this.params.IdentityPoolId + (this.params.LoginId || "")];
      },
      /**
       * @api private
       */
      setStorage: function setStorage(key, val) {
        try {
          this.storage[this.localStorageKey[key] + this.params.IdentityPoolId + (this.params.LoginId || "")] = val;
        } catch (_) {
        }
      },
      /**
       * @api private
       */
      storage: function() {
        try {
          var storage = AWS2.util.isBrowser() && window.localStorage !== null && typeof window.localStorage === "object" ? window.localStorage : {};
          storage["aws.test-storage"] = "foobar";
          delete storage["aws.test-storage"];
          return storage;
        } catch (_) {
          return {};
        }
      }()
    });
  }
});

// node_modules/aws-sdk/lib/credentials/saml_credentials.js
var require_saml_credentials = __commonJS({
  "node_modules/aws-sdk/lib/credentials/saml_credentials.js"() {
    "use strict";
    var AWS2 = require_core();
    var STS2 = require_sts2();
    AWS2.SAMLCredentials = AWS2.util.inherit(AWS2.Credentials, {
      /**
       * Creates a new credentials object.
       * @param (see AWS.STS.assumeRoleWithSAML)
       * @example Creating a new credentials object
       *   AWS.config.credentials = new AWS.SAMLCredentials({
       *     RoleArn: 'arn:aws:iam::1234567890:role/SAMLRole',
       *     PrincipalArn: 'arn:aws:iam::1234567890:role/SAMLPrincipal',
       *     SAMLAssertion: 'base64-token', // base64-encoded token from IdP
       *   });
       * @see AWS.STS.assumeRoleWithSAML
       */
      constructor: function SAMLCredentials(params) {
        AWS2.Credentials.call(this);
        this.expired = true;
        this.params = params;
      },
      /**
       * Refreshes credentials using {AWS.STS.assumeRoleWithSAML}
       *
       * @callback callback function(err)
       *   Called when the STS service responds (or fails). When
       *   this callback is called with no error, it means that the credentials
       *   information has been loaded into the object (as the `accessKeyId`,
       *   `secretAccessKey`, and `sessionToken` properties).
       *   @param err [Error] if an error occurred, this value will be filled
       * @see get
       */
      refresh: function refresh(callback) {
        this.coalesceRefresh(callback || AWS2.util.fn.callback);
      },
      /**
       * @api private
       */
      load: function load(callback) {
        var self2 = this;
        self2.createClients();
        self2.service.assumeRoleWithSAML(function(err, data) {
          if (!err) {
            self2.service.credentialsFrom(data, self2);
          }
          callback(err);
        });
      },
      /**
       * @api private
       */
      createClients: function() {
        this.service = this.service || new STS2({ params: this.params });
      }
    });
  }
});

// node_modules/aws-sdk/lib/credentials/process_credentials.js
var require_process_credentials = __commonJS({
  "node_modules/aws-sdk/lib/credentials/process_credentials.js"() {
    "use strict";
    var AWS2 = require_core();
    var proc = require("child_process");
    var iniLoader = AWS2.util.iniLoader;
    AWS2.ProcessCredentials = AWS2.util.inherit(AWS2.Credentials, {
      /**
       * Creates a new ProcessCredentials object.
       *
       * @param options [map] a set of options
       * @option options profile [String] (AWS_PROFILE env var or 'default')
       *   the name of the profile to load.
       * @option options filename [String] ('~/.aws/credentials' or defined by
       *   AWS_SHARED_CREDENTIALS_FILE process env var)
       *   the filename to use when loading credentials.
       * @option options callback [Function] (err) Credentials are eagerly loaded
       *   by the constructor. When the callback is called with no error, the
       *   credentials have been loaded successfully.
       */
      constructor: function ProcessCredentials(options) {
        AWS2.Credentials.call(this);
        options = options || {};
        this.filename = options.filename;
        this.profile = options.profile || process.env.AWS_PROFILE || AWS2.util.defaultProfile;
        this.get(options.callback || AWS2.util.fn.noop);
      },
      /**
       * @api private
       */
      load: function load(callback) {
        var self2 = this;
        try {
          var profiles = AWS2.util.getProfilesFromSharedConfig(iniLoader, this.filename);
          var profile = profiles[this.profile] || {};
          if (Object.keys(profile).length === 0) {
            throw AWS2.util.error(
              new Error("Profile " + this.profile + " not found"),
              { code: "ProcessCredentialsProviderFailure" }
            );
          }
          if (profile["credential_process"]) {
            this.loadViaCredentialProcess(profile, function(err, data) {
              if (err) {
                callback(err, null);
              } else {
                self2.expired = false;
                self2.accessKeyId = data.AccessKeyId;
                self2.secretAccessKey = data.SecretAccessKey;
                self2.sessionToken = data.SessionToken;
                if (data.Expiration) {
                  self2.expireTime = new Date(data.Expiration);
                }
                callback(null);
              }
            });
          } else {
            throw AWS2.util.error(
              new Error("Profile " + this.profile + " did not include credential process"),
              { code: "ProcessCredentialsProviderFailure" }
            );
          }
        } catch (err) {
          callback(err);
        }
      },
      /**
      * Executes the credential_process and retrieves
      * credentials from the output
      * @api private
      * @param profile [map] credentials profile
      * @throws ProcessCredentialsProviderFailure
      */
      loadViaCredentialProcess: function loadViaCredentialProcess(profile, callback) {
        proc.exec(profile["credential_process"], { env: process.env }, function(err, stdOut, stdErr) {
          if (err) {
            callback(AWS2.util.error(
              new Error("credential_process returned error"),
              { code: "ProcessCredentialsProviderFailure" }
            ), null);
          } else {
            try {
              var credData = JSON.parse(stdOut);
              if (credData.Expiration) {
                var currentTime = AWS2.util.date.getDate();
                var expireTime = new Date(credData.Expiration);
                if (expireTime < currentTime) {
                  throw Error("credential_process returned expired credentials");
                }
              }
              if (credData.Version !== 1) {
                throw Error("credential_process does not return Version == 1");
              }
              callback(null, credData);
            } catch (err2) {
              callback(AWS2.util.error(
                new Error(err2.message),
                { code: "ProcessCredentialsProviderFailure" }
              ), null);
            }
          }
        });
      },
      /**
       * Loads the credentials from the credential process
       *
       * @callback callback function(err)
       *   Called after the credential process has been executed. When this
       *   callback is called with no error, it means that the credentials
       *   information has been loaded into the object (as the `accessKeyId`,
       *   `secretAccessKey`, and `sessionToken` properties).
       *   @param err [Error] if an error occurred, this value will be filled
       * @see get
       */
      refresh: function refresh(callback) {
        iniLoader.clearCachedFiles();
        this.coalesceRefresh(callback || AWS2.util.fn.callback);
      }
    });
  }
});

// node_modules/xml2js/lib/defaults.js
var require_defaults = __commonJS({
  "node_modules/xml2js/lib/defaults.js"(exports2) {
    "use strict";
    (function() {
      exports2.defaults = {
        "0.1": {
          explicitCharkey: false,
          trim: true,
          normalize: true,
          normalizeTags: false,
          attrkey: "@",
          charkey: "#",
          explicitArray: false,
          ignoreAttrs: false,
          mergeAttrs: false,
          explicitRoot: false,
          validator: null,
          xmlns: false,
          explicitChildren: false,
          childkey: "@@",
          charsAsChildren: false,
          includeWhiteChars: false,
          async: false,
          strict: true,
          attrNameProcessors: null,
          attrValueProcessors: null,
          tagNameProcessors: null,
          valueProcessors: null,
          emptyTag: ""
        },
        "0.2": {
          explicitCharkey: false,
          trim: false,
          normalize: false,
          normalizeTags: false,
          attrkey: "$",
          charkey: "_",
          explicitArray: true,
          ignoreAttrs: false,
          mergeAttrs: false,
          explicitRoot: true,
          validator: null,
          xmlns: false,
          explicitChildren: false,
          preserveChildrenOrder: false,
          childkey: "$$",
          charsAsChildren: false,
          includeWhiteChars: false,
          async: false,
          strict: true,
          attrNameProcessors: null,
          attrValueProcessors: null,
          tagNameProcessors: null,
          valueProcessors: null,
          rootName: "root",
          xmldec: {
            "version": "1.0",
            "encoding": "UTF-8",
            "standalone": true
          },
          doctype: null,
          renderOpts: {
            "pretty": true,
            "indent": "  ",
            "newline": "\n"
          },
          headless: false,
          chunkSize: 1e4,
          emptyTag: "",
          cdata: false
        }
      };
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/Utility.js
var require_Utility = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/Utility.js"(exports2, module2) {
    "use strict";
    (function() {
      var assign, getValue, isArray, isEmpty, isFunction, isObject, isPlainObject, slice = [].slice, hasProp = {}.hasOwnProperty;
      assign = function() {
        var i, key, len, source, sources, target;
        target = arguments[0], sources = 2 <= arguments.length ? slice.call(arguments, 1) : [];
        if (isFunction(Object.assign)) {
          Object.assign.apply(null, arguments);
        } else {
          for (i = 0, len = sources.length; i < len; i++) {
            source = sources[i];
            if (source != null) {
              for (key in source) {
                if (!hasProp.call(source, key))
                  continue;
                target[key] = source[key];
              }
            }
          }
        }
        return target;
      };
      isFunction = function(val) {
        return !!val && Object.prototype.toString.call(val) === "[object Function]";
      };
      isObject = function(val) {
        var ref;
        return !!val && ((ref = typeof val) === "function" || ref === "object");
      };
      isArray = function(val) {
        if (isFunction(Array.isArray)) {
          return Array.isArray(val);
        } else {
          return Object.prototype.toString.call(val) === "[object Array]";
        }
      };
      isEmpty = function(val) {
        var key;
        if (isArray(val)) {
          return !val.length;
        } else {
          for (key in val) {
            if (!hasProp.call(val, key))
              continue;
            return false;
          }
          return true;
        }
      };
      isPlainObject = function(val) {
        var ctor, proto;
        return isObject(val) && (proto = Object.getPrototypeOf(val)) && (ctor = proto.constructor) && typeof ctor === "function" && ctor instanceof ctor && Function.prototype.toString.call(ctor) === Function.prototype.toString.call(Object);
      };
      getValue = function(obj) {
        if (isFunction(obj.valueOf)) {
          return obj.valueOf();
        } else {
          return obj;
        }
      };
      module2.exports.assign = assign;
      module2.exports.isFunction = isFunction;
      module2.exports.isObject = isObject;
      module2.exports.isArray = isArray;
      module2.exports.isEmpty = isEmpty;
      module2.exports.isPlainObject = isPlainObject;
      module2.exports.getValue = getValue;
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDOMImplementation.js
var require_XMLDOMImplementation = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDOMImplementation.js"(exports2, module2) {
    "use strict";
    (function() {
      var XMLDOMImplementation;
      module2.exports = XMLDOMImplementation = function() {
        function XMLDOMImplementation2() {
        }
        XMLDOMImplementation2.prototype.hasFeature = function(feature, version) {
          return true;
        };
        XMLDOMImplementation2.prototype.createDocumentType = function(qualifiedName, publicId, systemId) {
          throw new Error("This DOM method is not implemented.");
        };
        XMLDOMImplementation2.prototype.createDocument = function(namespaceURI, qualifiedName, doctype) {
          throw new Error("This DOM method is not implemented.");
        };
        XMLDOMImplementation2.prototype.createHTMLDocument = function(title) {
          throw new Error("This DOM method is not implemented.");
        };
        XMLDOMImplementation2.prototype.getFeature = function(feature, version) {
          throw new Error("This DOM method is not implemented.");
        };
        return XMLDOMImplementation2;
      }();
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDOMErrorHandler.js
var require_XMLDOMErrorHandler = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDOMErrorHandler.js"(exports2, module2) {
    "use strict";
    (function() {
      var XMLDOMErrorHandler;
      module2.exports = XMLDOMErrorHandler = function() {
        function XMLDOMErrorHandler2() {
        }
        XMLDOMErrorHandler2.prototype.handleError = function(error) {
          throw new Error(error);
        };
        return XMLDOMErrorHandler2;
      }();
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDOMStringList.js
var require_XMLDOMStringList = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDOMStringList.js"(exports2, module2) {
    "use strict";
    (function() {
      var XMLDOMStringList;
      module2.exports = XMLDOMStringList = function() {
        function XMLDOMStringList2(arr) {
          this.arr = arr || [];
        }
        Object.defineProperty(XMLDOMStringList2.prototype, "length", {
          get: function() {
            return this.arr.length;
          }
        });
        XMLDOMStringList2.prototype.item = function(index) {
          return this.arr[index] || null;
        };
        XMLDOMStringList2.prototype.contains = function(str) {
          return this.arr.indexOf(str) !== -1;
        };
        return XMLDOMStringList2;
      }();
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDOMConfiguration.js
var require_XMLDOMConfiguration = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDOMConfiguration.js"(exports2, module2) {
    "use strict";
    (function() {
      var XMLDOMConfiguration, XMLDOMErrorHandler, XMLDOMStringList;
      XMLDOMErrorHandler = require_XMLDOMErrorHandler();
      XMLDOMStringList = require_XMLDOMStringList();
      module2.exports = XMLDOMConfiguration = function() {
        function XMLDOMConfiguration2() {
          var clonedSelf;
          this.defaultParams = {
            "canonical-form": false,
            "cdata-sections": false,
            "comments": false,
            "datatype-normalization": false,
            "element-content-whitespace": true,
            "entities": true,
            "error-handler": new XMLDOMErrorHandler(),
            "infoset": true,
            "validate-if-schema": false,
            "namespaces": true,
            "namespace-declarations": true,
            "normalize-characters": false,
            "schema-location": "",
            "schema-type": "",
            "split-cdata-sections": true,
            "validate": false,
            "well-formed": true
          };
          this.params = clonedSelf = Object.create(this.defaultParams);
        }
        Object.defineProperty(XMLDOMConfiguration2.prototype, "parameterNames", {
          get: function() {
            return new XMLDOMStringList(Object.keys(this.defaultParams));
          }
        });
        XMLDOMConfiguration2.prototype.getParameter = function(name) {
          if (this.params.hasOwnProperty(name)) {
            return this.params[name];
          } else {
            return null;
          }
        };
        XMLDOMConfiguration2.prototype.canSetParameter = function(name, value) {
          return true;
        };
        XMLDOMConfiguration2.prototype.setParameter = function(name, value) {
          if (value != null) {
            return this.params[name] = value;
          } else {
            return delete this.params[name];
          }
        };
        return XMLDOMConfiguration2;
      }();
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/NodeType.js
var require_NodeType = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/NodeType.js"(exports2, module2) {
    "use strict";
    (function() {
      module2.exports = {
        Element: 1,
        Attribute: 2,
        Text: 3,
        CData: 4,
        EntityReference: 5,
        EntityDeclaration: 6,
        ProcessingInstruction: 7,
        Comment: 8,
        Document: 9,
        DocType: 10,
        DocumentFragment: 11,
        NotationDeclaration: 12,
        Declaration: 201,
        Raw: 202,
        AttributeDeclaration: 203,
        ElementDeclaration: 204,
        Dummy: 205
      };
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLAttribute.js
var require_XMLAttribute = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLAttribute.js"(exports2, module2) {
    "use strict";
    (function() {
      var NodeType, XMLAttribute, XMLNode;
      NodeType = require_NodeType();
      XMLNode = require_XMLNode();
      module2.exports = XMLAttribute = function() {
        function XMLAttribute2(parent, name, value) {
          this.parent = parent;
          if (this.parent) {
            this.options = this.parent.options;
            this.stringify = this.parent.stringify;
          }
          if (name == null) {
            throw new Error("Missing attribute name. " + this.debugInfo(name));
          }
          this.name = this.stringify.name(name);
          this.value = this.stringify.attValue(value);
          this.type = NodeType.Attribute;
          this.isId = false;
          this.schemaTypeInfo = null;
        }
        Object.defineProperty(XMLAttribute2.prototype, "nodeType", {
          get: function() {
            return this.type;
          }
        });
        Object.defineProperty(XMLAttribute2.prototype, "ownerElement", {
          get: function() {
            return this.parent;
          }
        });
        Object.defineProperty(XMLAttribute2.prototype, "textContent", {
          get: function() {
            return this.value;
          },
          set: function(value) {
            return this.value = value || "";
          }
        });
        Object.defineProperty(XMLAttribute2.prototype, "namespaceURI", {
          get: function() {
            return "";
          }
        });
        Object.defineProperty(XMLAttribute2.prototype, "prefix", {
          get: function() {
            return "";
          }
        });
        Object.defineProperty(XMLAttribute2.prototype, "localName", {
          get: function() {
            return this.name;
          }
        });
        Object.defineProperty(XMLAttribute2.prototype, "specified", {
          get: function() {
            return true;
          }
        });
        XMLAttribute2.prototype.clone = function() {
          return Object.create(this);
        };
        XMLAttribute2.prototype.toString = function(options) {
          return this.options.writer.attribute(this, this.options.writer.filterOptions(options));
        };
        XMLAttribute2.prototype.debugInfo = function(name) {
          name = name || this.name;
          if (name == null) {
            return "parent: <" + this.parent.name + ">";
          } else {
            return "attribute: {" + name + "}, parent: <" + this.parent.name + ">";
          }
        };
        XMLAttribute2.prototype.isEqualNode = function(node) {
          if (node.namespaceURI !== this.namespaceURI) {
            return false;
          }
          if (node.prefix !== this.prefix) {
            return false;
          }
          if (node.localName !== this.localName) {
            return false;
          }
          if (node.value !== this.value) {
            return false;
          }
          return true;
        };
        return XMLAttribute2;
      }();
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLNamedNodeMap.js
var require_XMLNamedNodeMap = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLNamedNodeMap.js"(exports2, module2) {
    "use strict";
    (function() {
      var XMLNamedNodeMap;
      module2.exports = XMLNamedNodeMap = function() {
        function XMLNamedNodeMap2(nodes) {
          this.nodes = nodes;
        }
        Object.defineProperty(XMLNamedNodeMap2.prototype, "length", {
          get: function() {
            return Object.keys(this.nodes).length || 0;
          }
        });
        XMLNamedNodeMap2.prototype.clone = function() {
          return this.nodes = null;
        };
        XMLNamedNodeMap2.prototype.getNamedItem = function(name) {
          return this.nodes[name];
        };
        XMLNamedNodeMap2.prototype.setNamedItem = function(node) {
          var oldNode;
          oldNode = this.nodes[node.nodeName];
          this.nodes[node.nodeName] = node;
          return oldNode || null;
        };
        XMLNamedNodeMap2.prototype.removeNamedItem = function(name) {
          var oldNode;
          oldNode = this.nodes[name];
          delete this.nodes[name];
          return oldNode || null;
        };
        XMLNamedNodeMap2.prototype.item = function(index) {
          return this.nodes[Object.keys(this.nodes)[index]] || null;
        };
        XMLNamedNodeMap2.prototype.getNamedItemNS = function(namespaceURI, localName) {
          throw new Error("This DOM method is not implemented.");
        };
        XMLNamedNodeMap2.prototype.setNamedItemNS = function(node) {
          throw new Error("This DOM method is not implemented.");
        };
        XMLNamedNodeMap2.prototype.removeNamedItemNS = function(namespaceURI, localName) {
          throw new Error("This DOM method is not implemented.");
        };
        return XMLNamedNodeMap2;
      }();
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLElement.js
var require_XMLElement = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLElement.js"(exports2, module2) {
    "use strict";
    (function() {
      var NodeType, XMLAttribute, XMLElement, XMLNamedNodeMap, XMLNode, getValue, isFunction, isObject, ref, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      ref = require_Utility(), isObject = ref.isObject, isFunction = ref.isFunction, getValue = ref.getValue;
      XMLNode = require_XMLNode();
      NodeType = require_NodeType();
      XMLAttribute = require_XMLAttribute();
      XMLNamedNodeMap = require_XMLNamedNodeMap();
      module2.exports = XMLElement = function(superClass) {
        extend(XMLElement2, superClass);
        function XMLElement2(parent, name, attributes) {
          var child, j, len, ref1;
          XMLElement2.__super__.constructor.call(this, parent);
          if (name == null) {
            throw new Error("Missing element name. " + this.debugInfo());
          }
          this.name = this.stringify.name(name);
          this.type = NodeType.Element;
          this.attribs = {};
          this.schemaTypeInfo = null;
          if (attributes != null) {
            this.attribute(attributes);
          }
          if (parent.type === NodeType.Document) {
            this.isRoot = true;
            this.documentObject = parent;
            parent.rootObject = this;
            if (parent.children) {
              ref1 = parent.children;
              for (j = 0, len = ref1.length; j < len; j++) {
                child = ref1[j];
                if (child.type === NodeType.DocType) {
                  child.name = this.name;
                  break;
                }
              }
            }
          }
        }
        Object.defineProperty(XMLElement2.prototype, "tagName", {
          get: function() {
            return this.name;
          }
        });
        Object.defineProperty(XMLElement2.prototype, "namespaceURI", {
          get: function() {
            return "";
          }
        });
        Object.defineProperty(XMLElement2.prototype, "prefix", {
          get: function() {
            return "";
          }
        });
        Object.defineProperty(XMLElement2.prototype, "localName", {
          get: function() {
            return this.name;
          }
        });
        Object.defineProperty(XMLElement2.prototype, "id", {
          get: function() {
            throw new Error("This DOM method is not implemented." + this.debugInfo());
          }
        });
        Object.defineProperty(XMLElement2.prototype, "className", {
          get: function() {
            throw new Error("This DOM method is not implemented." + this.debugInfo());
          }
        });
        Object.defineProperty(XMLElement2.prototype, "classList", {
          get: function() {
            throw new Error("This DOM method is not implemented." + this.debugInfo());
          }
        });
        Object.defineProperty(XMLElement2.prototype, "attributes", {
          get: function() {
            if (!this.attributeMap || !this.attributeMap.nodes) {
              this.attributeMap = new XMLNamedNodeMap(this.attribs);
            }
            return this.attributeMap;
          }
        });
        XMLElement2.prototype.clone = function() {
          var att, attName, clonedSelf, ref1;
          clonedSelf = Object.create(this);
          if (clonedSelf.isRoot) {
            clonedSelf.documentObject = null;
          }
          clonedSelf.attribs = {};
          ref1 = this.attribs;
          for (attName in ref1) {
            if (!hasProp.call(ref1, attName))
              continue;
            att = ref1[attName];
            clonedSelf.attribs[attName] = att.clone();
          }
          clonedSelf.children = [];
          this.children.forEach(function(child) {
            var clonedChild;
            clonedChild = child.clone();
            clonedChild.parent = clonedSelf;
            return clonedSelf.children.push(clonedChild);
          });
          return clonedSelf;
        };
        XMLElement2.prototype.attribute = function(name, value) {
          var attName, attValue;
          if (name != null) {
            name = getValue(name);
          }
          if (isObject(name)) {
            for (attName in name) {
              if (!hasProp.call(name, attName))
                continue;
              attValue = name[attName];
              this.attribute(attName, attValue);
            }
          } else {
            if (isFunction(value)) {
              value = value.apply();
            }
            if (this.options.keepNullAttributes && value == null) {
              this.attribs[name] = new XMLAttribute(this, name, "");
            } else if (value != null) {
              this.attribs[name] = new XMLAttribute(this, name, value);
            }
          }
          return this;
        };
        XMLElement2.prototype.removeAttribute = function(name) {
          var attName, j, len;
          if (name == null) {
            throw new Error("Missing attribute name. " + this.debugInfo());
          }
          name = getValue(name);
          if (Array.isArray(name)) {
            for (j = 0, len = name.length; j < len; j++) {
              attName = name[j];
              delete this.attribs[attName];
            }
          } else {
            delete this.attribs[name];
          }
          return this;
        };
        XMLElement2.prototype.toString = function(options) {
          return this.options.writer.element(this, this.options.writer.filterOptions(options));
        };
        XMLElement2.prototype.att = function(name, value) {
          return this.attribute(name, value);
        };
        XMLElement2.prototype.a = function(name, value) {
          return this.attribute(name, value);
        };
        XMLElement2.prototype.getAttribute = function(name) {
          if (this.attribs.hasOwnProperty(name)) {
            return this.attribs[name].value;
          } else {
            return null;
          }
        };
        XMLElement2.prototype.setAttribute = function(name, value) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLElement2.prototype.getAttributeNode = function(name) {
          if (this.attribs.hasOwnProperty(name)) {
            return this.attribs[name];
          } else {
            return null;
          }
        };
        XMLElement2.prototype.setAttributeNode = function(newAttr) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLElement2.prototype.removeAttributeNode = function(oldAttr) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLElement2.prototype.getElementsByTagName = function(name) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLElement2.prototype.getAttributeNS = function(namespaceURI, localName) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLElement2.prototype.setAttributeNS = function(namespaceURI, qualifiedName, value) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLElement2.prototype.removeAttributeNS = function(namespaceURI, localName) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLElement2.prototype.getAttributeNodeNS = function(namespaceURI, localName) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLElement2.prototype.setAttributeNodeNS = function(newAttr) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLElement2.prototype.getElementsByTagNameNS = function(namespaceURI, localName) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLElement2.prototype.hasAttribute = function(name) {
          return this.attribs.hasOwnProperty(name);
        };
        XMLElement2.prototype.hasAttributeNS = function(namespaceURI, localName) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLElement2.prototype.setIdAttribute = function(name, isId) {
          if (this.attribs.hasOwnProperty(name)) {
            return this.attribs[name].isId;
          } else {
            return isId;
          }
        };
        XMLElement2.prototype.setIdAttributeNS = function(namespaceURI, localName, isId) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLElement2.prototype.setIdAttributeNode = function(idAttr, isId) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLElement2.prototype.getElementsByTagName = function(tagname) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLElement2.prototype.getElementsByTagNameNS = function(namespaceURI, localName) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLElement2.prototype.getElementsByClassName = function(classNames) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLElement2.prototype.isEqualNode = function(node) {
          var i, j, ref1;
          if (!XMLElement2.__super__.isEqualNode.apply(this, arguments).isEqualNode(node)) {
            return false;
          }
          if (node.namespaceURI !== this.namespaceURI) {
            return false;
          }
          if (node.prefix !== this.prefix) {
            return false;
          }
          if (node.localName !== this.localName) {
            return false;
          }
          if (node.attribs.length !== this.attribs.length) {
            return false;
          }
          for (i = j = 0, ref1 = this.attribs.length - 1; 0 <= ref1 ? j <= ref1 : j >= ref1; i = 0 <= ref1 ? ++j : --j) {
            if (!this.attribs[i].isEqualNode(node.attribs[i])) {
              return false;
            }
          }
          return true;
        };
        return XMLElement2;
      }(XMLNode);
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLCharacterData.js
var require_XMLCharacterData = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLCharacterData.js"(exports2, module2) {
    "use strict";
    (function() {
      var XMLCharacterData, XMLNode, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      XMLNode = require_XMLNode();
      module2.exports = XMLCharacterData = function(superClass) {
        extend(XMLCharacterData2, superClass);
        function XMLCharacterData2(parent) {
          XMLCharacterData2.__super__.constructor.call(this, parent);
          this.value = "";
        }
        Object.defineProperty(XMLCharacterData2.prototype, "data", {
          get: function() {
            return this.value;
          },
          set: function(value) {
            return this.value = value || "";
          }
        });
        Object.defineProperty(XMLCharacterData2.prototype, "length", {
          get: function() {
            return this.value.length;
          }
        });
        Object.defineProperty(XMLCharacterData2.prototype, "textContent", {
          get: function() {
            return this.value;
          },
          set: function(value) {
            return this.value = value || "";
          }
        });
        XMLCharacterData2.prototype.clone = function() {
          return Object.create(this);
        };
        XMLCharacterData2.prototype.substringData = function(offset, count) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLCharacterData2.prototype.appendData = function(arg) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLCharacterData2.prototype.insertData = function(offset, arg) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLCharacterData2.prototype.deleteData = function(offset, count) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLCharacterData2.prototype.replaceData = function(offset, count, arg) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLCharacterData2.prototype.isEqualNode = function(node) {
          if (!XMLCharacterData2.__super__.isEqualNode.apply(this, arguments).isEqualNode(node)) {
            return false;
          }
          if (node.data !== this.data) {
            return false;
          }
          return true;
        };
        return XMLCharacterData2;
      }(XMLNode);
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLCData.js
var require_XMLCData = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLCData.js"(exports2, module2) {
    "use strict";
    (function() {
      var NodeType, XMLCData, XMLCharacterData, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      NodeType = require_NodeType();
      XMLCharacterData = require_XMLCharacterData();
      module2.exports = XMLCData = function(superClass) {
        extend(XMLCData2, superClass);
        function XMLCData2(parent, text) {
          XMLCData2.__super__.constructor.call(this, parent);
          if (text == null) {
            throw new Error("Missing CDATA text. " + this.debugInfo());
          }
          this.name = "#cdata-section";
          this.type = NodeType.CData;
          this.value = this.stringify.cdata(text);
        }
        XMLCData2.prototype.clone = function() {
          return Object.create(this);
        };
        XMLCData2.prototype.toString = function(options) {
          return this.options.writer.cdata(this, this.options.writer.filterOptions(options));
        };
        return XMLCData2;
      }(XMLCharacterData);
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLComment.js
var require_XMLComment = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLComment.js"(exports2, module2) {
    "use strict";
    (function() {
      var NodeType, XMLCharacterData, XMLComment, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      NodeType = require_NodeType();
      XMLCharacterData = require_XMLCharacterData();
      module2.exports = XMLComment = function(superClass) {
        extend(XMLComment2, superClass);
        function XMLComment2(parent, text) {
          XMLComment2.__super__.constructor.call(this, parent);
          if (text == null) {
            throw new Error("Missing comment text. " + this.debugInfo());
          }
          this.name = "#comment";
          this.type = NodeType.Comment;
          this.value = this.stringify.comment(text);
        }
        XMLComment2.prototype.clone = function() {
          return Object.create(this);
        };
        XMLComment2.prototype.toString = function(options) {
          return this.options.writer.comment(this, this.options.writer.filterOptions(options));
        };
        return XMLComment2;
      }(XMLCharacterData);
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDeclaration.js
var require_XMLDeclaration = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDeclaration.js"(exports2, module2) {
    "use strict";
    (function() {
      var NodeType, XMLDeclaration, XMLNode, isObject, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      isObject = require_Utility().isObject;
      XMLNode = require_XMLNode();
      NodeType = require_NodeType();
      module2.exports = XMLDeclaration = function(superClass) {
        extend(XMLDeclaration2, superClass);
        function XMLDeclaration2(parent, version, encoding, standalone) {
          var ref;
          XMLDeclaration2.__super__.constructor.call(this, parent);
          if (isObject(version)) {
            ref = version, version = ref.version, encoding = ref.encoding, standalone = ref.standalone;
          }
          if (!version) {
            version = "1.0";
          }
          this.type = NodeType.Declaration;
          this.version = this.stringify.xmlVersion(version);
          if (encoding != null) {
            this.encoding = this.stringify.xmlEncoding(encoding);
          }
          if (standalone != null) {
            this.standalone = this.stringify.xmlStandalone(standalone);
          }
        }
        XMLDeclaration2.prototype.toString = function(options) {
          return this.options.writer.declaration(this, this.options.writer.filterOptions(options));
        };
        return XMLDeclaration2;
      }(XMLNode);
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDTDAttList.js
var require_XMLDTDAttList = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDTDAttList.js"(exports2, module2) {
    "use strict";
    (function() {
      var NodeType, XMLDTDAttList, XMLNode, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      XMLNode = require_XMLNode();
      NodeType = require_NodeType();
      module2.exports = XMLDTDAttList = function(superClass) {
        extend(XMLDTDAttList2, superClass);
        function XMLDTDAttList2(parent, elementName, attributeName, attributeType, defaultValueType, defaultValue) {
          XMLDTDAttList2.__super__.constructor.call(this, parent);
          if (elementName == null) {
            throw new Error("Missing DTD element name. " + this.debugInfo());
          }
          if (attributeName == null) {
            throw new Error("Missing DTD attribute name. " + this.debugInfo(elementName));
          }
          if (!attributeType) {
            throw new Error("Missing DTD attribute type. " + this.debugInfo(elementName));
          }
          if (!defaultValueType) {
            throw new Error("Missing DTD attribute default. " + this.debugInfo(elementName));
          }
          if (defaultValueType.indexOf("#") !== 0) {
            defaultValueType = "#" + defaultValueType;
          }
          if (!defaultValueType.match(/^(#REQUIRED|#IMPLIED|#FIXED|#DEFAULT)$/)) {
            throw new Error("Invalid default value type; expected: #REQUIRED, #IMPLIED, #FIXED or #DEFAULT. " + this.debugInfo(elementName));
          }
          if (defaultValue && !defaultValueType.match(/^(#FIXED|#DEFAULT)$/)) {
            throw new Error("Default value only applies to #FIXED or #DEFAULT. " + this.debugInfo(elementName));
          }
          this.elementName = this.stringify.name(elementName);
          this.type = NodeType.AttributeDeclaration;
          this.attributeName = this.stringify.name(attributeName);
          this.attributeType = this.stringify.dtdAttType(attributeType);
          if (defaultValue) {
            this.defaultValue = this.stringify.dtdAttDefault(defaultValue);
          }
          this.defaultValueType = defaultValueType;
        }
        XMLDTDAttList2.prototype.toString = function(options) {
          return this.options.writer.dtdAttList(this, this.options.writer.filterOptions(options));
        };
        return XMLDTDAttList2;
      }(XMLNode);
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDTDEntity.js
var require_XMLDTDEntity = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDTDEntity.js"(exports2, module2) {
    "use strict";
    (function() {
      var NodeType, XMLDTDEntity, XMLNode, isObject, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      isObject = require_Utility().isObject;
      XMLNode = require_XMLNode();
      NodeType = require_NodeType();
      module2.exports = XMLDTDEntity = function(superClass) {
        extend(XMLDTDEntity2, superClass);
        function XMLDTDEntity2(parent, pe, name, value) {
          XMLDTDEntity2.__super__.constructor.call(this, parent);
          if (name == null) {
            throw new Error("Missing DTD entity name. " + this.debugInfo(name));
          }
          if (value == null) {
            throw new Error("Missing DTD entity value. " + this.debugInfo(name));
          }
          this.pe = !!pe;
          this.name = this.stringify.name(name);
          this.type = NodeType.EntityDeclaration;
          if (!isObject(value)) {
            this.value = this.stringify.dtdEntityValue(value);
            this.internal = true;
          } else {
            if (!value.pubID && !value.sysID) {
              throw new Error("Public and/or system identifiers are required for an external entity. " + this.debugInfo(name));
            }
            if (value.pubID && !value.sysID) {
              throw new Error("System identifier is required for a public external entity. " + this.debugInfo(name));
            }
            this.internal = false;
            if (value.pubID != null) {
              this.pubID = this.stringify.dtdPubID(value.pubID);
            }
            if (value.sysID != null) {
              this.sysID = this.stringify.dtdSysID(value.sysID);
            }
            if (value.nData != null) {
              this.nData = this.stringify.dtdNData(value.nData);
            }
            if (this.pe && this.nData) {
              throw new Error("Notation declaration is not allowed in a parameter entity. " + this.debugInfo(name));
            }
          }
        }
        Object.defineProperty(XMLDTDEntity2.prototype, "publicId", {
          get: function() {
            return this.pubID;
          }
        });
        Object.defineProperty(XMLDTDEntity2.prototype, "systemId", {
          get: function() {
            return this.sysID;
          }
        });
        Object.defineProperty(XMLDTDEntity2.prototype, "notationName", {
          get: function() {
            return this.nData || null;
          }
        });
        Object.defineProperty(XMLDTDEntity2.prototype, "inputEncoding", {
          get: function() {
            return null;
          }
        });
        Object.defineProperty(XMLDTDEntity2.prototype, "xmlEncoding", {
          get: function() {
            return null;
          }
        });
        Object.defineProperty(XMLDTDEntity2.prototype, "xmlVersion", {
          get: function() {
            return null;
          }
        });
        XMLDTDEntity2.prototype.toString = function(options) {
          return this.options.writer.dtdEntity(this, this.options.writer.filterOptions(options));
        };
        return XMLDTDEntity2;
      }(XMLNode);
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDTDElement.js
var require_XMLDTDElement = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDTDElement.js"(exports2, module2) {
    "use strict";
    (function() {
      var NodeType, XMLDTDElement, XMLNode, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      XMLNode = require_XMLNode();
      NodeType = require_NodeType();
      module2.exports = XMLDTDElement = function(superClass) {
        extend(XMLDTDElement2, superClass);
        function XMLDTDElement2(parent, name, value) {
          XMLDTDElement2.__super__.constructor.call(this, parent);
          if (name == null) {
            throw new Error("Missing DTD element name. " + this.debugInfo());
          }
          if (!value) {
            value = "(#PCDATA)";
          }
          if (Array.isArray(value)) {
            value = "(" + value.join(",") + ")";
          }
          this.name = this.stringify.name(name);
          this.type = NodeType.ElementDeclaration;
          this.value = this.stringify.dtdElementValue(value);
        }
        XMLDTDElement2.prototype.toString = function(options) {
          return this.options.writer.dtdElement(this, this.options.writer.filterOptions(options));
        };
        return XMLDTDElement2;
      }(XMLNode);
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDTDNotation.js
var require_XMLDTDNotation = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDTDNotation.js"(exports2, module2) {
    "use strict";
    (function() {
      var NodeType, XMLDTDNotation, XMLNode, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      XMLNode = require_XMLNode();
      NodeType = require_NodeType();
      module2.exports = XMLDTDNotation = function(superClass) {
        extend(XMLDTDNotation2, superClass);
        function XMLDTDNotation2(parent, name, value) {
          XMLDTDNotation2.__super__.constructor.call(this, parent);
          if (name == null) {
            throw new Error("Missing DTD notation name. " + this.debugInfo(name));
          }
          if (!value.pubID && !value.sysID) {
            throw new Error("Public or system identifiers are required for an external entity. " + this.debugInfo(name));
          }
          this.name = this.stringify.name(name);
          this.type = NodeType.NotationDeclaration;
          if (value.pubID != null) {
            this.pubID = this.stringify.dtdPubID(value.pubID);
          }
          if (value.sysID != null) {
            this.sysID = this.stringify.dtdSysID(value.sysID);
          }
        }
        Object.defineProperty(XMLDTDNotation2.prototype, "publicId", {
          get: function() {
            return this.pubID;
          }
        });
        Object.defineProperty(XMLDTDNotation2.prototype, "systemId", {
          get: function() {
            return this.sysID;
          }
        });
        XMLDTDNotation2.prototype.toString = function(options) {
          return this.options.writer.dtdNotation(this, this.options.writer.filterOptions(options));
        };
        return XMLDTDNotation2;
      }(XMLNode);
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDocType.js
var require_XMLDocType = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDocType.js"(exports2, module2) {
    "use strict";
    (function() {
      var NodeType, XMLDTDAttList, XMLDTDElement, XMLDTDEntity, XMLDTDNotation, XMLDocType, XMLNamedNodeMap, XMLNode, isObject, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      isObject = require_Utility().isObject;
      XMLNode = require_XMLNode();
      NodeType = require_NodeType();
      XMLDTDAttList = require_XMLDTDAttList();
      XMLDTDEntity = require_XMLDTDEntity();
      XMLDTDElement = require_XMLDTDElement();
      XMLDTDNotation = require_XMLDTDNotation();
      XMLNamedNodeMap = require_XMLNamedNodeMap();
      module2.exports = XMLDocType = function(superClass) {
        extend(XMLDocType2, superClass);
        function XMLDocType2(parent, pubID, sysID) {
          var child, i, len, ref, ref1, ref2;
          XMLDocType2.__super__.constructor.call(this, parent);
          this.type = NodeType.DocType;
          if (parent.children) {
            ref = parent.children;
            for (i = 0, len = ref.length; i < len; i++) {
              child = ref[i];
              if (child.type === NodeType.Element) {
                this.name = child.name;
                break;
              }
            }
          }
          this.documentObject = parent;
          if (isObject(pubID)) {
            ref1 = pubID, pubID = ref1.pubID, sysID = ref1.sysID;
          }
          if (sysID == null) {
            ref2 = [pubID, sysID], sysID = ref2[0], pubID = ref2[1];
          }
          if (pubID != null) {
            this.pubID = this.stringify.dtdPubID(pubID);
          }
          if (sysID != null) {
            this.sysID = this.stringify.dtdSysID(sysID);
          }
        }
        Object.defineProperty(XMLDocType2.prototype, "entities", {
          get: function() {
            var child, i, len, nodes, ref;
            nodes = {};
            ref = this.children;
            for (i = 0, len = ref.length; i < len; i++) {
              child = ref[i];
              if (child.type === NodeType.EntityDeclaration && !child.pe) {
                nodes[child.name] = child;
              }
            }
            return new XMLNamedNodeMap(nodes);
          }
        });
        Object.defineProperty(XMLDocType2.prototype, "notations", {
          get: function() {
            var child, i, len, nodes, ref;
            nodes = {};
            ref = this.children;
            for (i = 0, len = ref.length; i < len; i++) {
              child = ref[i];
              if (child.type === NodeType.NotationDeclaration) {
                nodes[child.name] = child;
              }
            }
            return new XMLNamedNodeMap(nodes);
          }
        });
        Object.defineProperty(XMLDocType2.prototype, "publicId", {
          get: function() {
            return this.pubID;
          }
        });
        Object.defineProperty(XMLDocType2.prototype, "systemId", {
          get: function() {
            return this.sysID;
          }
        });
        Object.defineProperty(XMLDocType2.prototype, "internalSubset", {
          get: function() {
            throw new Error("This DOM method is not implemented." + this.debugInfo());
          }
        });
        XMLDocType2.prototype.element = function(name, value) {
          var child;
          child = new XMLDTDElement(this, name, value);
          this.children.push(child);
          return this;
        };
        XMLDocType2.prototype.attList = function(elementName, attributeName, attributeType, defaultValueType, defaultValue) {
          var child;
          child = new XMLDTDAttList(this, elementName, attributeName, attributeType, defaultValueType, defaultValue);
          this.children.push(child);
          return this;
        };
        XMLDocType2.prototype.entity = function(name, value) {
          var child;
          child = new XMLDTDEntity(this, false, name, value);
          this.children.push(child);
          return this;
        };
        XMLDocType2.prototype.pEntity = function(name, value) {
          var child;
          child = new XMLDTDEntity(this, true, name, value);
          this.children.push(child);
          return this;
        };
        XMLDocType2.prototype.notation = function(name, value) {
          var child;
          child = new XMLDTDNotation(this, name, value);
          this.children.push(child);
          return this;
        };
        XMLDocType2.prototype.toString = function(options) {
          return this.options.writer.docType(this, this.options.writer.filterOptions(options));
        };
        XMLDocType2.prototype.ele = function(name, value) {
          return this.element(name, value);
        };
        XMLDocType2.prototype.att = function(elementName, attributeName, attributeType, defaultValueType, defaultValue) {
          return this.attList(elementName, attributeName, attributeType, defaultValueType, defaultValue);
        };
        XMLDocType2.prototype.ent = function(name, value) {
          return this.entity(name, value);
        };
        XMLDocType2.prototype.pent = function(name, value) {
          return this.pEntity(name, value);
        };
        XMLDocType2.prototype.not = function(name, value) {
          return this.notation(name, value);
        };
        XMLDocType2.prototype.up = function() {
          return this.root() || this.documentObject;
        };
        XMLDocType2.prototype.isEqualNode = function(node) {
          if (!XMLDocType2.__super__.isEqualNode.apply(this, arguments).isEqualNode(node)) {
            return false;
          }
          if (node.name !== this.name) {
            return false;
          }
          if (node.publicId !== this.publicId) {
            return false;
          }
          if (node.systemId !== this.systemId) {
            return false;
          }
          return true;
        };
        return XMLDocType2;
      }(XMLNode);
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLRaw.js
var require_XMLRaw = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLRaw.js"(exports2, module2) {
    "use strict";
    (function() {
      var NodeType, XMLNode, XMLRaw, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      NodeType = require_NodeType();
      XMLNode = require_XMLNode();
      module2.exports = XMLRaw = function(superClass) {
        extend(XMLRaw2, superClass);
        function XMLRaw2(parent, text) {
          XMLRaw2.__super__.constructor.call(this, parent);
          if (text == null) {
            throw new Error("Missing raw text. " + this.debugInfo());
          }
          this.type = NodeType.Raw;
          this.value = this.stringify.raw(text);
        }
        XMLRaw2.prototype.clone = function() {
          return Object.create(this);
        };
        XMLRaw2.prototype.toString = function(options) {
          return this.options.writer.raw(this, this.options.writer.filterOptions(options));
        };
        return XMLRaw2;
      }(XMLNode);
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLText.js
var require_XMLText = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLText.js"(exports2, module2) {
    "use strict";
    (function() {
      var NodeType, XMLCharacterData, XMLText, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      NodeType = require_NodeType();
      XMLCharacterData = require_XMLCharacterData();
      module2.exports = XMLText = function(superClass) {
        extend(XMLText2, superClass);
        function XMLText2(parent, text) {
          XMLText2.__super__.constructor.call(this, parent);
          if (text == null) {
            throw new Error("Missing element text. " + this.debugInfo());
          }
          this.name = "#text";
          this.type = NodeType.Text;
          this.value = this.stringify.text(text);
        }
        Object.defineProperty(XMLText2.prototype, "isElementContentWhitespace", {
          get: function() {
            throw new Error("This DOM method is not implemented." + this.debugInfo());
          }
        });
        Object.defineProperty(XMLText2.prototype, "wholeText", {
          get: function() {
            var next, prev, str;
            str = "";
            prev = this.previousSibling;
            while (prev) {
              str = prev.data + str;
              prev = prev.previousSibling;
            }
            str += this.data;
            next = this.nextSibling;
            while (next) {
              str = str + next.data;
              next = next.nextSibling;
            }
            return str;
          }
        });
        XMLText2.prototype.clone = function() {
          return Object.create(this);
        };
        XMLText2.prototype.toString = function(options) {
          return this.options.writer.text(this, this.options.writer.filterOptions(options));
        };
        XMLText2.prototype.splitText = function(offset) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLText2.prototype.replaceWholeText = function(content) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        return XMLText2;
      }(XMLCharacterData);
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLProcessingInstruction.js
var require_XMLProcessingInstruction = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLProcessingInstruction.js"(exports2, module2) {
    "use strict";
    (function() {
      var NodeType, XMLCharacterData, XMLProcessingInstruction, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      NodeType = require_NodeType();
      XMLCharacterData = require_XMLCharacterData();
      module2.exports = XMLProcessingInstruction = function(superClass) {
        extend(XMLProcessingInstruction2, superClass);
        function XMLProcessingInstruction2(parent, target, value) {
          XMLProcessingInstruction2.__super__.constructor.call(this, parent);
          if (target == null) {
            throw new Error("Missing instruction target. " + this.debugInfo());
          }
          this.type = NodeType.ProcessingInstruction;
          this.target = this.stringify.insTarget(target);
          this.name = this.target;
          if (value) {
            this.value = this.stringify.insValue(value);
          }
        }
        XMLProcessingInstruction2.prototype.clone = function() {
          return Object.create(this);
        };
        XMLProcessingInstruction2.prototype.toString = function(options) {
          return this.options.writer.processingInstruction(this, this.options.writer.filterOptions(options));
        };
        XMLProcessingInstruction2.prototype.isEqualNode = function(node) {
          if (!XMLProcessingInstruction2.__super__.isEqualNode.apply(this, arguments).isEqualNode(node)) {
            return false;
          }
          if (node.target !== this.target) {
            return false;
          }
          return true;
        };
        return XMLProcessingInstruction2;
      }(XMLCharacterData);
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDummy.js
var require_XMLDummy = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDummy.js"(exports2, module2) {
    "use strict";
    (function() {
      var NodeType, XMLDummy, XMLNode, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      XMLNode = require_XMLNode();
      NodeType = require_NodeType();
      module2.exports = XMLDummy = function(superClass) {
        extend(XMLDummy2, superClass);
        function XMLDummy2(parent) {
          XMLDummy2.__super__.constructor.call(this, parent);
          this.type = NodeType.Dummy;
        }
        XMLDummy2.prototype.clone = function() {
          return Object.create(this);
        };
        XMLDummy2.prototype.toString = function(options) {
          return "";
        };
        return XMLDummy2;
      }(XMLNode);
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLNodeList.js
var require_XMLNodeList = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLNodeList.js"(exports2, module2) {
    "use strict";
    (function() {
      var XMLNodeList;
      module2.exports = XMLNodeList = function() {
        function XMLNodeList2(nodes) {
          this.nodes = nodes;
        }
        Object.defineProperty(XMLNodeList2.prototype, "length", {
          get: function() {
            return this.nodes.length || 0;
          }
        });
        XMLNodeList2.prototype.clone = function() {
          return this.nodes = null;
        };
        XMLNodeList2.prototype.item = function(index) {
          return this.nodes[index] || null;
        };
        return XMLNodeList2;
      }();
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/DocumentPosition.js
var require_DocumentPosition = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/DocumentPosition.js"(exports2, module2) {
    "use strict";
    (function() {
      module2.exports = {
        Disconnected: 1,
        Preceding: 2,
        Following: 4,
        Contains: 8,
        ContainedBy: 16,
        ImplementationSpecific: 32
      };
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLNode.js
var require_XMLNode = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLNode.js"(exports2, module2) {
    "use strict";
    (function() {
      var DocumentPosition, NodeType, XMLCData, XMLComment, XMLDeclaration, XMLDocType, XMLDummy, XMLElement, XMLNamedNodeMap, XMLNode, XMLNodeList, XMLProcessingInstruction, XMLRaw, XMLText, getValue, isEmpty, isFunction, isObject, ref1, hasProp = {}.hasOwnProperty;
      ref1 = require_Utility(), isObject = ref1.isObject, isFunction = ref1.isFunction, isEmpty = ref1.isEmpty, getValue = ref1.getValue;
      XMLElement = null;
      XMLCData = null;
      XMLComment = null;
      XMLDeclaration = null;
      XMLDocType = null;
      XMLRaw = null;
      XMLText = null;
      XMLProcessingInstruction = null;
      XMLDummy = null;
      NodeType = null;
      XMLNodeList = null;
      XMLNamedNodeMap = null;
      DocumentPosition = null;
      module2.exports = XMLNode = function() {
        function XMLNode2(parent1) {
          this.parent = parent1;
          if (this.parent) {
            this.options = this.parent.options;
            this.stringify = this.parent.stringify;
          }
          this.value = null;
          this.children = [];
          this.baseURI = null;
          if (!XMLElement) {
            XMLElement = require_XMLElement();
            XMLCData = require_XMLCData();
            XMLComment = require_XMLComment();
            XMLDeclaration = require_XMLDeclaration();
            XMLDocType = require_XMLDocType();
            XMLRaw = require_XMLRaw();
            XMLText = require_XMLText();
            XMLProcessingInstruction = require_XMLProcessingInstruction();
            XMLDummy = require_XMLDummy();
            NodeType = require_NodeType();
            XMLNodeList = require_XMLNodeList();
            XMLNamedNodeMap = require_XMLNamedNodeMap();
            DocumentPosition = require_DocumentPosition();
          }
        }
        Object.defineProperty(XMLNode2.prototype, "nodeName", {
          get: function() {
            return this.name;
          }
        });
        Object.defineProperty(XMLNode2.prototype, "nodeType", {
          get: function() {
            return this.type;
          }
        });
        Object.defineProperty(XMLNode2.prototype, "nodeValue", {
          get: function() {
            return this.value;
          }
        });
        Object.defineProperty(XMLNode2.prototype, "parentNode", {
          get: function() {
            return this.parent;
          }
        });
        Object.defineProperty(XMLNode2.prototype, "childNodes", {
          get: function() {
            if (!this.childNodeList || !this.childNodeList.nodes) {
              this.childNodeList = new XMLNodeList(this.children);
            }
            return this.childNodeList;
          }
        });
        Object.defineProperty(XMLNode2.prototype, "firstChild", {
          get: function() {
            return this.children[0] || null;
          }
        });
        Object.defineProperty(XMLNode2.prototype, "lastChild", {
          get: function() {
            return this.children[this.children.length - 1] || null;
          }
        });
        Object.defineProperty(XMLNode2.prototype, "previousSibling", {
          get: function() {
            var i;
            i = this.parent.children.indexOf(this);
            return this.parent.children[i - 1] || null;
          }
        });
        Object.defineProperty(XMLNode2.prototype, "nextSibling", {
          get: function() {
            var i;
            i = this.parent.children.indexOf(this);
            return this.parent.children[i + 1] || null;
          }
        });
        Object.defineProperty(XMLNode2.prototype, "ownerDocument", {
          get: function() {
            return this.document() || null;
          }
        });
        Object.defineProperty(XMLNode2.prototype, "textContent", {
          get: function() {
            var child, j, len, ref2, str;
            if (this.nodeType === NodeType.Element || this.nodeType === NodeType.DocumentFragment) {
              str = "";
              ref2 = this.children;
              for (j = 0, len = ref2.length; j < len; j++) {
                child = ref2[j];
                if (child.textContent) {
                  str += child.textContent;
                }
              }
              return str;
            } else {
              return null;
            }
          },
          set: function(value) {
            throw new Error("This DOM method is not implemented." + this.debugInfo());
          }
        });
        XMLNode2.prototype.setParent = function(parent) {
          var child, j, len, ref2, results;
          this.parent = parent;
          if (parent) {
            this.options = parent.options;
            this.stringify = parent.stringify;
          }
          ref2 = this.children;
          results = [];
          for (j = 0, len = ref2.length; j < len; j++) {
            child = ref2[j];
            results.push(child.setParent(this));
          }
          return results;
        };
        XMLNode2.prototype.element = function(name, attributes, text) {
          var childNode, item, j, k, key, lastChild, len, len1, ref2, ref3, val;
          lastChild = null;
          if (attributes === null && text == null) {
            ref2 = [{}, null], attributes = ref2[0], text = ref2[1];
          }
          if (attributes == null) {
            attributes = {};
          }
          attributes = getValue(attributes);
          if (!isObject(attributes)) {
            ref3 = [attributes, text], text = ref3[0], attributes = ref3[1];
          }
          if (name != null) {
            name = getValue(name);
          }
          if (Array.isArray(name)) {
            for (j = 0, len = name.length; j < len; j++) {
              item = name[j];
              lastChild = this.element(item);
            }
          } else if (isFunction(name)) {
            lastChild = this.element(name.apply());
          } else if (isObject(name)) {
            for (key in name) {
              if (!hasProp.call(name, key))
                continue;
              val = name[key];
              if (isFunction(val)) {
                val = val.apply();
              }
              if (!this.options.ignoreDecorators && this.stringify.convertAttKey && key.indexOf(this.stringify.convertAttKey) === 0) {
                lastChild = this.attribute(key.substr(this.stringify.convertAttKey.length), val);
              } else if (!this.options.separateArrayItems && Array.isArray(val) && isEmpty(val)) {
                lastChild = this.dummy();
              } else if (isObject(val) && isEmpty(val)) {
                lastChild = this.element(key);
              } else if (!this.options.keepNullNodes && val == null) {
                lastChild = this.dummy();
              } else if (!this.options.separateArrayItems && Array.isArray(val)) {
                for (k = 0, len1 = val.length; k < len1; k++) {
                  item = val[k];
                  childNode = {};
                  childNode[key] = item;
                  lastChild = this.element(childNode);
                }
              } else if (isObject(val)) {
                if (!this.options.ignoreDecorators && this.stringify.convertTextKey && key.indexOf(this.stringify.convertTextKey) === 0) {
                  lastChild = this.element(val);
                } else {
                  lastChild = this.element(key);
                  lastChild.element(val);
                }
              } else {
                lastChild = this.element(key, val);
              }
            }
          } else if (!this.options.keepNullNodes && text === null) {
            lastChild = this.dummy();
          } else {
            if (!this.options.ignoreDecorators && this.stringify.convertTextKey && name.indexOf(this.stringify.convertTextKey) === 0) {
              lastChild = this.text(text);
            } else if (!this.options.ignoreDecorators && this.stringify.convertCDataKey && name.indexOf(this.stringify.convertCDataKey) === 0) {
              lastChild = this.cdata(text);
            } else if (!this.options.ignoreDecorators && this.stringify.convertCommentKey && name.indexOf(this.stringify.convertCommentKey) === 0) {
              lastChild = this.comment(text);
            } else if (!this.options.ignoreDecorators && this.stringify.convertRawKey && name.indexOf(this.stringify.convertRawKey) === 0) {
              lastChild = this.raw(text);
            } else if (!this.options.ignoreDecorators && this.stringify.convertPIKey && name.indexOf(this.stringify.convertPIKey) === 0) {
              lastChild = this.instruction(name.substr(this.stringify.convertPIKey.length), text);
            } else {
              lastChild = this.node(name, attributes, text);
            }
          }
          if (lastChild == null) {
            throw new Error("Could not create any elements with: " + name + ". " + this.debugInfo());
          }
          return lastChild;
        };
        XMLNode2.prototype.insertBefore = function(name, attributes, text) {
          var child, i, newChild, refChild, removed;
          if (name != null ? name.type : void 0) {
            newChild = name;
            refChild = attributes;
            newChild.setParent(this);
            if (refChild) {
              i = children.indexOf(refChild);
              removed = children.splice(i);
              children.push(newChild);
              Array.prototype.push.apply(children, removed);
            } else {
              children.push(newChild);
            }
            return newChild;
          } else {
            if (this.isRoot) {
              throw new Error("Cannot insert elements at root level. " + this.debugInfo(name));
            }
            i = this.parent.children.indexOf(this);
            removed = this.parent.children.splice(i);
            child = this.parent.element(name, attributes, text);
            Array.prototype.push.apply(this.parent.children, removed);
            return child;
          }
        };
        XMLNode2.prototype.insertAfter = function(name, attributes, text) {
          var child, i, removed;
          if (this.isRoot) {
            throw new Error("Cannot insert elements at root level. " + this.debugInfo(name));
          }
          i = this.parent.children.indexOf(this);
          removed = this.parent.children.splice(i + 1);
          child = this.parent.element(name, attributes, text);
          Array.prototype.push.apply(this.parent.children, removed);
          return child;
        };
        XMLNode2.prototype.remove = function() {
          var i, ref2;
          if (this.isRoot) {
            throw new Error("Cannot remove the root element. " + this.debugInfo());
          }
          i = this.parent.children.indexOf(this);
          [].splice.apply(this.parent.children, [i, i - i + 1].concat(ref2 = [])), ref2;
          return this.parent;
        };
        XMLNode2.prototype.node = function(name, attributes, text) {
          var child, ref2;
          if (name != null) {
            name = getValue(name);
          }
          attributes || (attributes = {});
          attributes = getValue(attributes);
          if (!isObject(attributes)) {
            ref2 = [attributes, text], text = ref2[0], attributes = ref2[1];
          }
          child = new XMLElement(this, name, attributes);
          if (text != null) {
            child.text(text);
          }
          this.children.push(child);
          return child;
        };
        XMLNode2.prototype.text = function(value) {
          var child;
          if (isObject(value)) {
            this.element(value);
          }
          child = new XMLText(this, value);
          this.children.push(child);
          return this;
        };
        XMLNode2.prototype.cdata = function(value) {
          var child;
          child = new XMLCData(this, value);
          this.children.push(child);
          return this;
        };
        XMLNode2.prototype.comment = function(value) {
          var child;
          child = new XMLComment(this, value);
          this.children.push(child);
          return this;
        };
        XMLNode2.prototype.commentBefore = function(value) {
          var child, i, removed;
          i = this.parent.children.indexOf(this);
          removed = this.parent.children.splice(i);
          child = this.parent.comment(value);
          Array.prototype.push.apply(this.parent.children, removed);
          return this;
        };
        XMLNode2.prototype.commentAfter = function(value) {
          var child, i, removed;
          i = this.parent.children.indexOf(this);
          removed = this.parent.children.splice(i + 1);
          child = this.parent.comment(value);
          Array.prototype.push.apply(this.parent.children, removed);
          return this;
        };
        XMLNode2.prototype.raw = function(value) {
          var child;
          child = new XMLRaw(this, value);
          this.children.push(child);
          return this;
        };
        XMLNode2.prototype.dummy = function() {
          var child;
          child = new XMLDummy(this);
          return child;
        };
        XMLNode2.prototype.instruction = function(target, value) {
          var insTarget, insValue, instruction, j, len;
          if (target != null) {
            target = getValue(target);
          }
          if (value != null) {
            value = getValue(value);
          }
          if (Array.isArray(target)) {
            for (j = 0, len = target.length; j < len; j++) {
              insTarget = target[j];
              this.instruction(insTarget);
            }
          } else if (isObject(target)) {
            for (insTarget in target) {
              if (!hasProp.call(target, insTarget))
                continue;
              insValue = target[insTarget];
              this.instruction(insTarget, insValue);
            }
          } else {
            if (isFunction(value)) {
              value = value.apply();
            }
            instruction = new XMLProcessingInstruction(this, target, value);
            this.children.push(instruction);
          }
          return this;
        };
        XMLNode2.prototype.instructionBefore = function(target, value) {
          var child, i, removed;
          i = this.parent.children.indexOf(this);
          removed = this.parent.children.splice(i);
          child = this.parent.instruction(target, value);
          Array.prototype.push.apply(this.parent.children, removed);
          return this;
        };
        XMLNode2.prototype.instructionAfter = function(target, value) {
          var child, i, removed;
          i = this.parent.children.indexOf(this);
          removed = this.parent.children.splice(i + 1);
          child = this.parent.instruction(target, value);
          Array.prototype.push.apply(this.parent.children, removed);
          return this;
        };
        XMLNode2.prototype.declaration = function(version, encoding, standalone) {
          var doc, xmldec;
          doc = this.document();
          xmldec = new XMLDeclaration(doc, version, encoding, standalone);
          if (doc.children.length === 0) {
            doc.children.unshift(xmldec);
          } else if (doc.children[0].type === NodeType.Declaration) {
            doc.children[0] = xmldec;
          } else {
            doc.children.unshift(xmldec);
          }
          return doc.root() || doc;
        };
        XMLNode2.prototype.dtd = function(pubID, sysID) {
          var child, doc, doctype, i, j, k, len, len1, ref2, ref3;
          doc = this.document();
          doctype = new XMLDocType(doc, pubID, sysID);
          ref2 = doc.children;
          for (i = j = 0, len = ref2.length; j < len; i = ++j) {
            child = ref2[i];
            if (child.type === NodeType.DocType) {
              doc.children[i] = doctype;
              return doctype;
            }
          }
          ref3 = doc.children;
          for (i = k = 0, len1 = ref3.length; k < len1; i = ++k) {
            child = ref3[i];
            if (child.isRoot) {
              doc.children.splice(i, 0, doctype);
              return doctype;
            }
          }
          doc.children.push(doctype);
          return doctype;
        };
        XMLNode2.prototype.up = function() {
          if (this.isRoot) {
            throw new Error("The root node has no parent. Use doc() if you need to get the document object.");
          }
          return this.parent;
        };
        XMLNode2.prototype.root = function() {
          var node;
          node = this;
          while (node) {
            if (node.type === NodeType.Document) {
              return node.rootObject;
            } else if (node.isRoot) {
              return node;
            } else {
              node = node.parent;
            }
          }
        };
        XMLNode2.prototype.document = function() {
          var node;
          node = this;
          while (node) {
            if (node.type === NodeType.Document) {
              return node;
            } else {
              node = node.parent;
            }
          }
        };
        XMLNode2.prototype.end = function(options) {
          return this.document().end(options);
        };
        XMLNode2.prototype.prev = function() {
          var i;
          i = this.parent.children.indexOf(this);
          if (i < 1) {
            throw new Error("Already at the first node. " + this.debugInfo());
          }
          return this.parent.children[i - 1];
        };
        XMLNode2.prototype.next = function() {
          var i;
          i = this.parent.children.indexOf(this);
          if (i === -1 || i === this.parent.children.length - 1) {
            throw new Error("Already at the last node. " + this.debugInfo());
          }
          return this.parent.children[i + 1];
        };
        XMLNode2.prototype.importDocument = function(doc) {
          var clonedRoot;
          clonedRoot = doc.root().clone();
          clonedRoot.parent = this;
          clonedRoot.isRoot = false;
          this.children.push(clonedRoot);
          return this;
        };
        XMLNode2.prototype.debugInfo = function(name) {
          var ref2, ref3;
          name = name || this.name;
          if (name == null && !((ref2 = this.parent) != null ? ref2.name : void 0)) {
            return "";
          } else if (name == null) {
            return "parent: <" + this.parent.name + ">";
          } else if (!((ref3 = this.parent) != null ? ref3.name : void 0)) {
            return "node: <" + name + ">";
          } else {
            return "node: <" + name + ">, parent: <" + this.parent.name + ">";
          }
        };
        XMLNode2.prototype.ele = function(name, attributes, text) {
          return this.element(name, attributes, text);
        };
        XMLNode2.prototype.nod = function(name, attributes, text) {
          return this.node(name, attributes, text);
        };
        XMLNode2.prototype.txt = function(value) {
          return this.text(value);
        };
        XMLNode2.prototype.dat = function(value) {
          return this.cdata(value);
        };
        XMLNode2.prototype.com = function(value) {
          return this.comment(value);
        };
        XMLNode2.prototype.ins = function(target, value) {
          return this.instruction(target, value);
        };
        XMLNode2.prototype.doc = function() {
          return this.document();
        };
        XMLNode2.prototype.dec = function(version, encoding, standalone) {
          return this.declaration(version, encoding, standalone);
        };
        XMLNode2.prototype.e = function(name, attributes, text) {
          return this.element(name, attributes, text);
        };
        XMLNode2.prototype.n = function(name, attributes, text) {
          return this.node(name, attributes, text);
        };
        XMLNode2.prototype.t = function(value) {
          return this.text(value);
        };
        XMLNode2.prototype.d = function(value) {
          return this.cdata(value);
        };
        XMLNode2.prototype.c = function(value) {
          return this.comment(value);
        };
        XMLNode2.prototype.r = function(value) {
          return this.raw(value);
        };
        XMLNode2.prototype.i = function(target, value) {
          return this.instruction(target, value);
        };
        XMLNode2.prototype.u = function() {
          return this.up();
        };
        XMLNode2.prototype.importXMLBuilder = function(doc) {
          return this.importDocument(doc);
        };
        XMLNode2.prototype.replaceChild = function(newChild, oldChild) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLNode2.prototype.removeChild = function(oldChild) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLNode2.prototype.appendChild = function(newChild) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLNode2.prototype.hasChildNodes = function() {
          return this.children.length !== 0;
        };
        XMLNode2.prototype.cloneNode = function(deep) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLNode2.prototype.normalize = function() {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLNode2.prototype.isSupported = function(feature, version) {
          return true;
        };
        XMLNode2.prototype.hasAttributes = function() {
          return this.attribs.length !== 0;
        };
        XMLNode2.prototype.compareDocumentPosition = function(other) {
          var ref, res;
          ref = this;
          if (ref === other) {
            return 0;
          } else if (this.document() !== other.document()) {
            res = DocumentPosition.Disconnected | DocumentPosition.ImplementationSpecific;
            if (Math.random() < 0.5) {
              res |= DocumentPosition.Preceding;
            } else {
              res |= DocumentPosition.Following;
            }
            return res;
          } else if (ref.isAncestor(other)) {
            return DocumentPosition.Contains | DocumentPosition.Preceding;
          } else if (ref.isDescendant(other)) {
            return DocumentPosition.Contains | DocumentPosition.Following;
          } else if (ref.isPreceding(other)) {
            return DocumentPosition.Preceding;
          } else {
            return DocumentPosition.Following;
          }
        };
        XMLNode2.prototype.isSameNode = function(other) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLNode2.prototype.lookupPrefix = function(namespaceURI) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLNode2.prototype.isDefaultNamespace = function(namespaceURI) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLNode2.prototype.lookupNamespaceURI = function(prefix) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLNode2.prototype.isEqualNode = function(node) {
          var i, j, ref2;
          if (node.nodeType !== this.nodeType) {
            return false;
          }
          if (node.children.length !== this.children.length) {
            return false;
          }
          for (i = j = 0, ref2 = this.children.length - 1; 0 <= ref2 ? j <= ref2 : j >= ref2; i = 0 <= ref2 ? ++j : --j) {
            if (!this.children[i].isEqualNode(node.children[i])) {
              return false;
            }
          }
          return true;
        };
        XMLNode2.prototype.getFeature = function(feature, version) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLNode2.prototype.setUserData = function(key, data, handler2) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLNode2.prototype.getUserData = function(key) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLNode2.prototype.contains = function(other) {
          if (!other) {
            return false;
          }
          return other === this || this.isDescendant(other);
        };
        XMLNode2.prototype.isDescendant = function(node) {
          var child, isDescendantChild, j, len, ref2;
          ref2 = this.children;
          for (j = 0, len = ref2.length; j < len; j++) {
            child = ref2[j];
            if (node === child) {
              return true;
            }
            isDescendantChild = child.isDescendant(node);
            if (isDescendantChild) {
              return true;
            }
          }
          return false;
        };
        XMLNode2.prototype.isAncestor = function(node) {
          return node.isDescendant(this);
        };
        XMLNode2.prototype.isPreceding = function(node) {
          var nodePos, thisPos;
          nodePos = this.treePosition(node);
          thisPos = this.treePosition(this);
          if (nodePos === -1 || thisPos === -1) {
            return false;
          } else {
            return nodePos < thisPos;
          }
        };
        XMLNode2.prototype.isFollowing = function(node) {
          var nodePos, thisPos;
          nodePos = this.treePosition(node);
          thisPos = this.treePosition(this);
          if (nodePos === -1 || thisPos === -1) {
            return false;
          } else {
            return nodePos > thisPos;
          }
        };
        XMLNode2.prototype.treePosition = function(node) {
          var found, pos;
          pos = 0;
          found = false;
          this.foreachTreeNode(this.document(), function(childNode) {
            pos++;
            if (!found && childNode === node) {
              return found = true;
            }
          });
          if (found) {
            return pos;
          } else {
            return -1;
          }
        };
        XMLNode2.prototype.foreachTreeNode = function(node, func) {
          var child, j, len, ref2, res;
          node || (node = this.document());
          ref2 = node.children;
          for (j = 0, len = ref2.length; j < len; j++) {
            child = ref2[j];
            if (res = func(child)) {
              return res;
            } else {
              res = this.foreachTreeNode(child, func);
              if (res) {
                return res;
              }
            }
          }
        };
        return XMLNode2;
      }();
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLStringifier.js
var require_XMLStringifier = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLStringifier.js"(exports2, module2) {
    "use strict";
    (function() {
      var XMLStringifier, bind = function(fn, me) {
        return function() {
          return fn.apply(me, arguments);
        };
      }, hasProp = {}.hasOwnProperty;
      module2.exports = XMLStringifier = function() {
        function XMLStringifier2(options) {
          this.assertLegalName = bind(this.assertLegalName, this);
          this.assertLegalChar = bind(this.assertLegalChar, this);
          var key, ref, value;
          options || (options = {});
          this.options = options;
          if (!this.options.version) {
            this.options.version = "1.0";
          }
          ref = options.stringify || {};
          for (key in ref) {
            if (!hasProp.call(ref, key))
              continue;
            value = ref[key];
            this[key] = value;
          }
        }
        XMLStringifier2.prototype.name = function(val) {
          if (this.options.noValidation) {
            return val;
          }
          return this.assertLegalName("" + val || "");
        };
        XMLStringifier2.prototype.text = function(val) {
          if (this.options.noValidation) {
            return val;
          }
          return this.assertLegalChar(this.textEscape("" + val || ""));
        };
        XMLStringifier2.prototype.cdata = function(val) {
          if (this.options.noValidation) {
            return val;
          }
          val = "" + val || "";
          val = val.replace("]]>", "]]]]><![CDATA[>");
          return this.assertLegalChar(val);
        };
        XMLStringifier2.prototype.comment = function(val) {
          if (this.options.noValidation) {
            return val;
          }
          val = "" + val || "";
          if (val.match(/--/)) {
            throw new Error("Comment text cannot contain double-hypen: " + val);
          }
          return this.assertLegalChar(val);
        };
        XMLStringifier2.prototype.raw = function(val) {
          if (this.options.noValidation) {
            return val;
          }
          return "" + val || "";
        };
        XMLStringifier2.prototype.attValue = function(val) {
          if (this.options.noValidation) {
            return val;
          }
          return this.assertLegalChar(this.attEscape(val = "" + val || ""));
        };
        XMLStringifier2.prototype.insTarget = function(val) {
          if (this.options.noValidation) {
            return val;
          }
          return this.assertLegalChar("" + val || "");
        };
        XMLStringifier2.prototype.insValue = function(val) {
          if (this.options.noValidation) {
            return val;
          }
          val = "" + val || "";
          if (val.match(/\?>/)) {
            throw new Error("Invalid processing instruction value: " + val);
          }
          return this.assertLegalChar(val);
        };
        XMLStringifier2.prototype.xmlVersion = function(val) {
          if (this.options.noValidation) {
            return val;
          }
          val = "" + val || "";
          if (!val.match(/1\.[0-9]+/)) {
            throw new Error("Invalid version number: " + val);
          }
          return val;
        };
        XMLStringifier2.prototype.xmlEncoding = function(val) {
          if (this.options.noValidation) {
            return val;
          }
          val = "" + val || "";
          if (!val.match(/^[A-Za-z](?:[A-Za-z0-9._-])*$/)) {
            throw new Error("Invalid encoding: " + val);
          }
          return this.assertLegalChar(val);
        };
        XMLStringifier2.prototype.xmlStandalone = function(val) {
          if (this.options.noValidation) {
            return val;
          }
          if (val) {
            return "yes";
          } else {
            return "no";
          }
        };
        XMLStringifier2.prototype.dtdPubID = function(val) {
          if (this.options.noValidation) {
            return val;
          }
          return this.assertLegalChar("" + val || "");
        };
        XMLStringifier2.prototype.dtdSysID = function(val) {
          if (this.options.noValidation) {
            return val;
          }
          return this.assertLegalChar("" + val || "");
        };
        XMLStringifier2.prototype.dtdElementValue = function(val) {
          if (this.options.noValidation) {
            return val;
          }
          return this.assertLegalChar("" + val || "");
        };
        XMLStringifier2.prototype.dtdAttType = function(val) {
          if (this.options.noValidation) {
            return val;
          }
          return this.assertLegalChar("" + val || "");
        };
        XMLStringifier2.prototype.dtdAttDefault = function(val) {
          if (this.options.noValidation) {
            return val;
          }
          return this.assertLegalChar("" + val || "");
        };
        XMLStringifier2.prototype.dtdEntityValue = function(val) {
          if (this.options.noValidation) {
            return val;
          }
          return this.assertLegalChar("" + val || "");
        };
        XMLStringifier2.prototype.dtdNData = function(val) {
          if (this.options.noValidation) {
            return val;
          }
          return this.assertLegalChar("" + val || "");
        };
        XMLStringifier2.prototype.convertAttKey = "@";
        XMLStringifier2.prototype.convertPIKey = "?";
        XMLStringifier2.prototype.convertTextKey = "#text";
        XMLStringifier2.prototype.convertCDataKey = "#cdata";
        XMLStringifier2.prototype.convertCommentKey = "#comment";
        XMLStringifier2.prototype.convertRawKey = "#raw";
        XMLStringifier2.prototype.assertLegalChar = function(str) {
          var regex, res;
          if (this.options.noValidation) {
            return str;
          }
          regex = "";
          if (this.options.version === "1.0") {
            regex = /[\0-\x08\x0B\f\x0E-\x1F\uFFFE\uFFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF]/;
            if (res = str.match(regex)) {
              throw new Error("Invalid character in string: " + str + " at index " + res.index);
            }
          } else if (this.options.version === "1.1") {
            regex = /[\0\uFFFE\uFFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF]/;
            if (res = str.match(regex)) {
              throw new Error("Invalid character in string: " + str + " at index " + res.index);
            }
          }
          return str;
        };
        XMLStringifier2.prototype.assertLegalName = function(str) {
          var regex;
          if (this.options.noValidation) {
            return str;
          }
          this.assertLegalChar(str);
          regex = /^([:A-Z_a-z\xC0-\xD6\xD8-\xF6\xF8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]|[\uD800-\uDB7F][\uDC00-\uDFFF])([\x2D\.0-:A-Z_a-z\xB7\xC0-\xD6\xD8-\xF6\xF8-\u037D\u037F-\u1FFF\u200C\u200D\u203F\u2040\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]|[\uD800-\uDB7F][\uDC00-\uDFFF])*$/;
          if (!str.match(regex)) {
            throw new Error("Invalid character in name");
          }
          return str;
        };
        XMLStringifier2.prototype.textEscape = function(str) {
          var ampregex;
          if (this.options.noValidation) {
            return str;
          }
          ampregex = this.options.noDoubleEncoding ? /(?!&\S+;)&/g : /&/g;
          return str.replace(ampregex, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/\r/g, "&#xD;");
        };
        XMLStringifier2.prototype.attEscape = function(str) {
          var ampregex;
          if (this.options.noValidation) {
            return str;
          }
          ampregex = this.options.noDoubleEncoding ? /(?!&\S+;)&/g : /&/g;
          return str.replace(ampregex, "&amp;").replace(/</g, "&lt;").replace(/"/g, "&quot;").replace(/\t/g, "&#x9;").replace(/\n/g, "&#xA;").replace(/\r/g, "&#xD;");
        };
        return XMLStringifier2;
      }();
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/WriterState.js
var require_WriterState = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/WriterState.js"(exports2, module2) {
    "use strict";
    (function() {
      module2.exports = {
        None: 0,
        OpenTag: 1,
        InsideTag: 2,
        CloseTag: 3
      };
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLWriterBase.js
var require_XMLWriterBase = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLWriterBase.js"(exports2, module2) {
    "use strict";
    (function() {
      var NodeType, WriterState, XMLCData, XMLComment, XMLDTDAttList, XMLDTDElement, XMLDTDEntity, XMLDTDNotation, XMLDeclaration, XMLDocType, XMLDummy, XMLElement, XMLProcessingInstruction, XMLRaw, XMLText, XMLWriterBase, assign, hasProp = {}.hasOwnProperty;
      assign = require_Utility().assign;
      NodeType = require_NodeType();
      XMLDeclaration = require_XMLDeclaration();
      XMLDocType = require_XMLDocType();
      XMLCData = require_XMLCData();
      XMLComment = require_XMLComment();
      XMLElement = require_XMLElement();
      XMLRaw = require_XMLRaw();
      XMLText = require_XMLText();
      XMLProcessingInstruction = require_XMLProcessingInstruction();
      XMLDummy = require_XMLDummy();
      XMLDTDAttList = require_XMLDTDAttList();
      XMLDTDElement = require_XMLDTDElement();
      XMLDTDEntity = require_XMLDTDEntity();
      XMLDTDNotation = require_XMLDTDNotation();
      WriterState = require_WriterState();
      module2.exports = XMLWriterBase = function() {
        function XMLWriterBase2(options) {
          var key, ref, value;
          options || (options = {});
          this.options = options;
          ref = options.writer || {};
          for (key in ref) {
            if (!hasProp.call(ref, key))
              continue;
            value = ref[key];
            this["_" + key] = this[key];
            this[key] = value;
          }
        }
        XMLWriterBase2.prototype.filterOptions = function(options) {
          var filteredOptions, ref, ref1, ref2, ref3, ref4, ref5, ref6;
          options || (options = {});
          options = assign({}, this.options, options);
          filteredOptions = {
            writer: this
          };
          filteredOptions.pretty = options.pretty || false;
          filteredOptions.allowEmpty = options.allowEmpty || false;
          filteredOptions.indent = (ref = options.indent) != null ? ref : "  ";
          filteredOptions.newline = (ref1 = options.newline) != null ? ref1 : "\n";
          filteredOptions.offset = (ref2 = options.offset) != null ? ref2 : 0;
          filteredOptions.dontPrettyTextNodes = (ref3 = (ref4 = options.dontPrettyTextNodes) != null ? ref4 : options.dontprettytextnodes) != null ? ref3 : 0;
          filteredOptions.spaceBeforeSlash = (ref5 = (ref6 = options.spaceBeforeSlash) != null ? ref6 : options.spacebeforeslash) != null ? ref5 : "";
          if (filteredOptions.spaceBeforeSlash === true) {
            filteredOptions.spaceBeforeSlash = " ";
          }
          filteredOptions.suppressPrettyCount = 0;
          filteredOptions.user = {};
          filteredOptions.state = WriterState.None;
          return filteredOptions;
        };
        XMLWriterBase2.prototype.indent = function(node, options, level) {
          var indentLevel;
          if (!options.pretty || options.suppressPrettyCount) {
            return "";
          } else if (options.pretty) {
            indentLevel = (level || 0) + options.offset + 1;
            if (indentLevel > 0) {
              return new Array(indentLevel).join(options.indent);
            }
          }
          return "";
        };
        XMLWriterBase2.prototype.endline = function(node, options, level) {
          if (!options.pretty || options.suppressPrettyCount) {
            return "";
          } else {
            return options.newline;
          }
        };
        XMLWriterBase2.prototype.attribute = function(att, options, level) {
          var r;
          this.openAttribute(att, options, level);
          r = " " + att.name + '="' + att.value + '"';
          this.closeAttribute(att, options, level);
          return r;
        };
        XMLWriterBase2.prototype.cdata = function(node, options, level) {
          var r;
          this.openNode(node, options, level);
          options.state = WriterState.OpenTag;
          r = this.indent(node, options, level) + "<![CDATA[";
          options.state = WriterState.InsideTag;
          r += node.value;
          options.state = WriterState.CloseTag;
          r += "]]>" + this.endline(node, options, level);
          options.state = WriterState.None;
          this.closeNode(node, options, level);
          return r;
        };
        XMLWriterBase2.prototype.comment = function(node, options, level) {
          var r;
          this.openNode(node, options, level);
          options.state = WriterState.OpenTag;
          r = this.indent(node, options, level) + "<!-- ";
          options.state = WriterState.InsideTag;
          r += node.value;
          options.state = WriterState.CloseTag;
          r += " -->" + this.endline(node, options, level);
          options.state = WriterState.None;
          this.closeNode(node, options, level);
          return r;
        };
        XMLWriterBase2.prototype.declaration = function(node, options, level) {
          var r;
          this.openNode(node, options, level);
          options.state = WriterState.OpenTag;
          r = this.indent(node, options, level) + "<?xml";
          options.state = WriterState.InsideTag;
          r += ' version="' + node.version + '"';
          if (node.encoding != null) {
            r += ' encoding="' + node.encoding + '"';
          }
          if (node.standalone != null) {
            r += ' standalone="' + node.standalone + '"';
          }
          options.state = WriterState.CloseTag;
          r += options.spaceBeforeSlash + "?>";
          r += this.endline(node, options, level);
          options.state = WriterState.None;
          this.closeNode(node, options, level);
          return r;
        };
        XMLWriterBase2.prototype.docType = function(node, options, level) {
          var child, i, len, r, ref;
          level || (level = 0);
          this.openNode(node, options, level);
          options.state = WriterState.OpenTag;
          r = this.indent(node, options, level);
          r += "<!DOCTYPE " + node.root().name;
          if (node.pubID && node.sysID) {
            r += ' PUBLIC "' + node.pubID + '" "' + node.sysID + '"';
          } else if (node.sysID) {
            r += ' SYSTEM "' + node.sysID + '"';
          }
          if (node.children.length > 0) {
            r += " [";
            r += this.endline(node, options, level);
            options.state = WriterState.InsideTag;
            ref = node.children;
            for (i = 0, len = ref.length; i < len; i++) {
              child = ref[i];
              r += this.writeChildNode(child, options, level + 1);
            }
            options.state = WriterState.CloseTag;
            r += "]";
          }
          options.state = WriterState.CloseTag;
          r += options.spaceBeforeSlash + ">";
          r += this.endline(node, options, level);
          options.state = WriterState.None;
          this.closeNode(node, options, level);
          return r;
        };
        XMLWriterBase2.prototype.element = function(node, options, level) {
          var att, child, childNodeCount, firstChildNode, i, j, len, len1, name, prettySuppressed, r, ref, ref1, ref2;
          level || (level = 0);
          prettySuppressed = false;
          r = "";
          this.openNode(node, options, level);
          options.state = WriterState.OpenTag;
          r += this.indent(node, options, level) + "<" + node.name;
          ref = node.attribs;
          for (name in ref) {
            if (!hasProp.call(ref, name))
              continue;
            att = ref[name];
            r += this.attribute(att, options, level);
          }
          childNodeCount = node.children.length;
          firstChildNode = childNodeCount === 0 ? null : node.children[0];
          if (childNodeCount === 0 || node.children.every(function(e) {
            return (e.type === NodeType.Text || e.type === NodeType.Raw) && e.value === "";
          })) {
            if (options.allowEmpty) {
              r += ">";
              options.state = WriterState.CloseTag;
              r += "</" + node.name + ">" + this.endline(node, options, level);
            } else {
              options.state = WriterState.CloseTag;
              r += options.spaceBeforeSlash + "/>" + this.endline(node, options, level);
            }
          } else if (options.pretty && childNodeCount === 1 && (firstChildNode.type === NodeType.Text || firstChildNode.type === NodeType.Raw) && firstChildNode.value != null) {
            r += ">";
            options.state = WriterState.InsideTag;
            options.suppressPrettyCount++;
            prettySuppressed = true;
            r += this.writeChildNode(firstChildNode, options, level + 1);
            options.suppressPrettyCount--;
            prettySuppressed = false;
            options.state = WriterState.CloseTag;
            r += "</" + node.name + ">" + this.endline(node, options, level);
          } else {
            if (options.dontPrettyTextNodes) {
              ref1 = node.children;
              for (i = 0, len = ref1.length; i < len; i++) {
                child = ref1[i];
                if ((child.type === NodeType.Text || child.type === NodeType.Raw) && child.value != null) {
                  options.suppressPrettyCount++;
                  prettySuppressed = true;
                  break;
                }
              }
            }
            r += ">" + this.endline(node, options, level);
            options.state = WriterState.InsideTag;
            ref2 = node.children;
            for (j = 0, len1 = ref2.length; j < len1; j++) {
              child = ref2[j];
              r += this.writeChildNode(child, options, level + 1);
            }
            options.state = WriterState.CloseTag;
            r += this.indent(node, options, level) + "</" + node.name + ">";
            if (prettySuppressed) {
              options.suppressPrettyCount--;
            }
            r += this.endline(node, options, level);
            options.state = WriterState.None;
          }
          this.closeNode(node, options, level);
          return r;
        };
        XMLWriterBase2.prototype.writeChildNode = function(node, options, level) {
          switch (node.type) {
            case NodeType.CData:
              return this.cdata(node, options, level);
            case NodeType.Comment:
              return this.comment(node, options, level);
            case NodeType.Element:
              return this.element(node, options, level);
            case NodeType.Raw:
              return this.raw(node, options, level);
            case NodeType.Text:
              return this.text(node, options, level);
            case NodeType.ProcessingInstruction:
              return this.processingInstruction(node, options, level);
            case NodeType.Dummy:
              return "";
            case NodeType.Declaration:
              return this.declaration(node, options, level);
            case NodeType.DocType:
              return this.docType(node, options, level);
            case NodeType.AttributeDeclaration:
              return this.dtdAttList(node, options, level);
            case NodeType.ElementDeclaration:
              return this.dtdElement(node, options, level);
            case NodeType.EntityDeclaration:
              return this.dtdEntity(node, options, level);
            case NodeType.NotationDeclaration:
              return this.dtdNotation(node, options, level);
            default:
              throw new Error("Unknown XML node type: " + node.constructor.name);
          }
        };
        XMLWriterBase2.prototype.processingInstruction = function(node, options, level) {
          var r;
          this.openNode(node, options, level);
          options.state = WriterState.OpenTag;
          r = this.indent(node, options, level) + "<?";
          options.state = WriterState.InsideTag;
          r += node.target;
          if (node.value) {
            r += " " + node.value;
          }
          options.state = WriterState.CloseTag;
          r += options.spaceBeforeSlash + "?>";
          r += this.endline(node, options, level);
          options.state = WriterState.None;
          this.closeNode(node, options, level);
          return r;
        };
        XMLWriterBase2.prototype.raw = function(node, options, level) {
          var r;
          this.openNode(node, options, level);
          options.state = WriterState.OpenTag;
          r = this.indent(node, options, level);
          options.state = WriterState.InsideTag;
          r += node.value;
          options.state = WriterState.CloseTag;
          r += this.endline(node, options, level);
          options.state = WriterState.None;
          this.closeNode(node, options, level);
          return r;
        };
        XMLWriterBase2.prototype.text = function(node, options, level) {
          var r;
          this.openNode(node, options, level);
          options.state = WriterState.OpenTag;
          r = this.indent(node, options, level);
          options.state = WriterState.InsideTag;
          r += node.value;
          options.state = WriterState.CloseTag;
          r += this.endline(node, options, level);
          options.state = WriterState.None;
          this.closeNode(node, options, level);
          return r;
        };
        XMLWriterBase2.prototype.dtdAttList = function(node, options, level) {
          var r;
          this.openNode(node, options, level);
          options.state = WriterState.OpenTag;
          r = this.indent(node, options, level) + "<!ATTLIST";
          options.state = WriterState.InsideTag;
          r += " " + node.elementName + " " + node.attributeName + " " + node.attributeType;
          if (node.defaultValueType !== "#DEFAULT") {
            r += " " + node.defaultValueType;
          }
          if (node.defaultValue) {
            r += ' "' + node.defaultValue + '"';
          }
          options.state = WriterState.CloseTag;
          r += options.spaceBeforeSlash + ">" + this.endline(node, options, level);
          options.state = WriterState.None;
          this.closeNode(node, options, level);
          return r;
        };
        XMLWriterBase2.prototype.dtdElement = function(node, options, level) {
          var r;
          this.openNode(node, options, level);
          options.state = WriterState.OpenTag;
          r = this.indent(node, options, level) + "<!ELEMENT";
          options.state = WriterState.InsideTag;
          r += " " + node.name + " " + node.value;
          options.state = WriterState.CloseTag;
          r += options.spaceBeforeSlash + ">" + this.endline(node, options, level);
          options.state = WriterState.None;
          this.closeNode(node, options, level);
          return r;
        };
        XMLWriterBase2.prototype.dtdEntity = function(node, options, level) {
          var r;
          this.openNode(node, options, level);
          options.state = WriterState.OpenTag;
          r = this.indent(node, options, level) + "<!ENTITY";
          options.state = WriterState.InsideTag;
          if (node.pe) {
            r += " %";
          }
          r += " " + node.name;
          if (node.value) {
            r += ' "' + node.value + '"';
          } else {
            if (node.pubID && node.sysID) {
              r += ' PUBLIC "' + node.pubID + '" "' + node.sysID + '"';
            } else if (node.sysID) {
              r += ' SYSTEM "' + node.sysID + '"';
            }
            if (node.nData) {
              r += " NDATA " + node.nData;
            }
          }
          options.state = WriterState.CloseTag;
          r += options.spaceBeforeSlash + ">" + this.endline(node, options, level);
          options.state = WriterState.None;
          this.closeNode(node, options, level);
          return r;
        };
        XMLWriterBase2.prototype.dtdNotation = function(node, options, level) {
          var r;
          this.openNode(node, options, level);
          options.state = WriterState.OpenTag;
          r = this.indent(node, options, level) + "<!NOTATION";
          options.state = WriterState.InsideTag;
          r += " " + node.name;
          if (node.pubID && node.sysID) {
            r += ' PUBLIC "' + node.pubID + '" "' + node.sysID + '"';
          } else if (node.pubID) {
            r += ' PUBLIC "' + node.pubID + '"';
          } else if (node.sysID) {
            r += ' SYSTEM "' + node.sysID + '"';
          }
          options.state = WriterState.CloseTag;
          r += options.spaceBeforeSlash + ">" + this.endline(node, options, level);
          options.state = WriterState.None;
          this.closeNode(node, options, level);
          return r;
        };
        XMLWriterBase2.prototype.openNode = function(node, options, level) {
        };
        XMLWriterBase2.prototype.closeNode = function(node, options, level) {
        };
        XMLWriterBase2.prototype.openAttribute = function(att, options, level) {
        };
        XMLWriterBase2.prototype.closeAttribute = function(att, options, level) {
        };
        return XMLWriterBase2;
      }();
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLStringWriter.js
var require_XMLStringWriter = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLStringWriter.js"(exports2, module2) {
    "use strict";
    (function() {
      var XMLStringWriter, XMLWriterBase, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      XMLWriterBase = require_XMLWriterBase();
      module2.exports = XMLStringWriter = function(superClass) {
        extend(XMLStringWriter2, superClass);
        function XMLStringWriter2(options) {
          XMLStringWriter2.__super__.constructor.call(this, options);
        }
        XMLStringWriter2.prototype.document = function(doc, options) {
          var child, i, len, r, ref;
          options = this.filterOptions(options);
          r = "";
          ref = doc.children;
          for (i = 0, len = ref.length; i < len; i++) {
            child = ref[i];
            r += this.writeChildNode(child, options, 0);
          }
          if (options.pretty && r.slice(-options.newline.length) === options.newline) {
            r = r.slice(0, -options.newline.length);
          }
          return r;
        };
        return XMLStringWriter2;
      }(XMLWriterBase);
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDocument.js
var require_XMLDocument = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDocument.js"(exports2, module2) {
    "use strict";
    (function() {
      var NodeType, XMLDOMConfiguration, XMLDOMImplementation, XMLDocument, XMLNode, XMLStringWriter, XMLStringifier, isPlainObject, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      isPlainObject = require_Utility().isPlainObject;
      XMLDOMImplementation = require_XMLDOMImplementation();
      XMLDOMConfiguration = require_XMLDOMConfiguration();
      XMLNode = require_XMLNode();
      NodeType = require_NodeType();
      XMLStringifier = require_XMLStringifier();
      XMLStringWriter = require_XMLStringWriter();
      module2.exports = XMLDocument = function(superClass) {
        extend(XMLDocument2, superClass);
        function XMLDocument2(options) {
          XMLDocument2.__super__.constructor.call(this, null);
          this.name = "#document";
          this.type = NodeType.Document;
          this.documentURI = null;
          this.domConfig = new XMLDOMConfiguration();
          options || (options = {});
          if (!options.writer) {
            options.writer = new XMLStringWriter();
          }
          this.options = options;
          this.stringify = new XMLStringifier(options);
        }
        Object.defineProperty(XMLDocument2.prototype, "implementation", {
          value: new XMLDOMImplementation()
        });
        Object.defineProperty(XMLDocument2.prototype, "doctype", {
          get: function() {
            var child, i, len, ref;
            ref = this.children;
            for (i = 0, len = ref.length; i < len; i++) {
              child = ref[i];
              if (child.type === NodeType.DocType) {
                return child;
              }
            }
            return null;
          }
        });
        Object.defineProperty(XMLDocument2.prototype, "documentElement", {
          get: function() {
            return this.rootObject || null;
          }
        });
        Object.defineProperty(XMLDocument2.prototype, "inputEncoding", {
          get: function() {
            return null;
          }
        });
        Object.defineProperty(XMLDocument2.prototype, "strictErrorChecking", {
          get: function() {
            return false;
          }
        });
        Object.defineProperty(XMLDocument2.prototype, "xmlEncoding", {
          get: function() {
            if (this.children.length !== 0 && this.children[0].type === NodeType.Declaration) {
              return this.children[0].encoding;
            } else {
              return null;
            }
          }
        });
        Object.defineProperty(XMLDocument2.prototype, "xmlStandalone", {
          get: function() {
            if (this.children.length !== 0 && this.children[0].type === NodeType.Declaration) {
              return this.children[0].standalone === "yes";
            } else {
              return false;
            }
          }
        });
        Object.defineProperty(XMLDocument2.prototype, "xmlVersion", {
          get: function() {
            if (this.children.length !== 0 && this.children[0].type === NodeType.Declaration) {
              return this.children[0].version;
            } else {
              return "1.0";
            }
          }
        });
        Object.defineProperty(XMLDocument2.prototype, "URL", {
          get: function() {
            return this.documentURI;
          }
        });
        Object.defineProperty(XMLDocument2.prototype, "origin", {
          get: function() {
            return null;
          }
        });
        Object.defineProperty(XMLDocument2.prototype, "compatMode", {
          get: function() {
            return null;
          }
        });
        Object.defineProperty(XMLDocument2.prototype, "characterSet", {
          get: function() {
            return null;
          }
        });
        Object.defineProperty(XMLDocument2.prototype, "contentType", {
          get: function() {
            return null;
          }
        });
        XMLDocument2.prototype.end = function(writer) {
          var writerOptions;
          writerOptions = {};
          if (!writer) {
            writer = this.options.writer;
          } else if (isPlainObject(writer)) {
            writerOptions = writer;
            writer = this.options.writer;
          }
          return writer.document(this, writer.filterOptions(writerOptions));
        };
        XMLDocument2.prototype.toString = function(options) {
          return this.options.writer.document(this, this.options.writer.filterOptions(options));
        };
        XMLDocument2.prototype.createElement = function(tagName) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLDocument2.prototype.createDocumentFragment = function() {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLDocument2.prototype.createTextNode = function(data) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLDocument2.prototype.createComment = function(data) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLDocument2.prototype.createCDATASection = function(data) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLDocument2.prototype.createProcessingInstruction = function(target, data) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLDocument2.prototype.createAttribute = function(name) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLDocument2.prototype.createEntityReference = function(name) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLDocument2.prototype.getElementsByTagName = function(tagname) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLDocument2.prototype.importNode = function(importedNode, deep) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLDocument2.prototype.createElementNS = function(namespaceURI, qualifiedName) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLDocument2.prototype.createAttributeNS = function(namespaceURI, qualifiedName) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLDocument2.prototype.getElementsByTagNameNS = function(namespaceURI, localName) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLDocument2.prototype.getElementById = function(elementId) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLDocument2.prototype.adoptNode = function(source) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLDocument2.prototype.normalizeDocument = function() {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLDocument2.prototype.renameNode = function(node, namespaceURI, qualifiedName) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLDocument2.prototype.getElementsByClassName = function(classNames) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLDocument2.prototype.createEvent = function(eventInterface) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLDocument2.prototype.createRange = function() {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLDocument2.prototype.createNodeIterator = function(root, whatToShow, filter) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        XMLDocument2.prototype.createTreeWalker = function(root, whatToShow, filter) {
          throw new Error("This DOM method is not implemented." + this.debugInfo());
        };
        return XMLDocument2;
      }(XMLNode);
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDocumentCB.js
var require_XMLDocumentCB = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDocumentCB.js"(exports2, module2) {
    "use strict";
    (function() {
      var NodeType, WriterState, XMLAttribute, XMLCData, XMLComment, XMLDTDAttList, XMLDTDElement, XMLDTDEntity, XMLDTDNotation, XMLDeclaration, XMLDocType, XMLDocument, XMLDocumentCB, XMLElement, XMLProcessingInstruction, XMLRaw, XMLStringWriter, XMLStringifier, XMLText, getValue, isFunction, isObject, isPlainObject, ref, hasProp = {}.hasOwnProperty;
      ref = require_Utility(), isObject = ref.isObject, isFunction = ref.isFunction, isPlainObject = ref.isPlainObject, getValue = ref.getValue;
      NodeType = require_NodeType();
      XMLDocument = require_XMLDocument();
      XMLElement = require_XMLElement();
      XMLCData = require_XMLCData();
      XMLComment = require_XMLComment();
      XMLRaw = require_XMLRaw();
      XMLText = require_XMLText();
      XMLProcessingInstruction = require_XMLProcessingInstruction();
      XMLDeclaration = require_XMLDeclaration();
      XMLDocType = require_XMLDocType();
      XMLDTDAttList = require_XMLDTDAttList();
      XMLDTDEntity = require_XMLDTDEntity();
      XMLDTDElement = require_XMLDTDElement();
      XMLDTDNotation = require_XMLDTDNotation();
      XMLAttribute = require_XMLAttribute();
      XMLStringifier = require_XMLStringifier();
      XMLStringWriter = require_XMLStringWriter();
      WriterState = require_WriterState();
      module2.exports = XMLDocumentCB = function() {
        function XMLDocumentCB2(options, onData, onEnd) {
          var writerOptions;
          this.name = "?xml";
          this.type = NodeType.Document;
          options || (options = {});
          writerOptions = {};
          if (!options.writer) {
            options.writer = new XMLStringWriter();
          } else if (isPlainObject(options.writer)) {
            writerOptions = options.writer;
            options.writer = new XMLStringWriter();
          }
          this.options = options;
          this.writer = options.writer;
          this.writerOptions = this.writer.filterOptions(writerOptions);
          this.stringify = new XMLStringifier(options);
          this.onDataCallback = onData || function() {
          };
          this.onEndCallback = onEnd || function() {
          };
          this.currentNode = null;
          this.currentLevel = -1;
          this.openTags = {};
          this.documentStarted = false;
          this.documentCompleted = false;
          this.root = null;
        }
        XMLDocumentCB2.prototype.createChildNode = function(node) {
          var att, attName, attributes, child, i, len, ref1, ref2;
          switch (node.type) {
            case NodeType.CData:
              this.cdata(node.value);
              break;
            case NodeType.Comment:
              this.comment(node.value);
              break;
            case NodeType.Element:
              attributes = {};
              ref1 = node.attribs;
              for (attName in ref1) {
                if (!hasProp.call(ref1, attName))
                  continue;
                att = ref1[attName];
                attributes[attName] = att.value;
              }
              this.node(node.name, attributes);
              break;
            case NodeType.Dummy:
              this.dummy();
              break;
            case NodeType.Raw:
              this.raw(node.value);
              break;
            case NodeType.Text:
              this.text(node.value);
              break;
            case NodeType.ProcessingInstruction:
              this.instruction(node.target, node.value);
              break;
            default:
              throw new Error("This XML node type is not supported in a JS object: " + node.constructor.name);
          }
          ref2 = node.children;
          for (i = 0, len = ref2.length; i < len; i++) {
            child = ref2[i];
            this.createChildNode(child);
            if (child.type === NodeType.Element) {
              this.up();
            }
          }
          return this;
        };
        XMLDocumentCB2.prototype.dummy = function() {
          return this;
        };
        XMLDocumentCB2.prototype.node = function(name, attributes, text) {
          var ref1;
          if (name == null) {
            throw new Error("Missing node name.");
          }
          if (this.root && this.currentLevel === -1) {
            throw new Error("Document can only have one root node. " + this.debugInfo(name));
          }
          this.openCurrent();
          name = getValue(name);
          if (attributes == null) {
            attributes = {};
          }
          attributes = getValue(attributes);
          if (!isObject(attributes)) {
            ref1 = [attributes, text], text = ref1[0], attributes = ref1[1];
          }
          this.currentNode = new XMLElement(this, name, attributes);
          this.currentNode.children = false;
          this.currentLevel++;
          this.openTags[this.currentLevel] = this.currentNode;
          if (text != null) {
            this.text(text);
          }
          return this;
        };
        XMLDocumentCB2.prototype.element = function(name, attributes, text) {
          var child, i, len, oldValidationFlag, ref1, root;
          if (this.currentNode && this.currentNode.type === NodeType.DocType) {
            this.dtdElement.apply(this, arguments);
          } else {
            if (Array.isArray(name) || isObject(name) || isFunction(name)) {
              oldValidationFlag = this.options.noValidation;
              this.options.noValidation = true;
              root = new XMLDocument(this.options).element("TEMP_ROOT");
              root.element(name);
              this.options.noValidation = oldValidationFlag;
              ref1 = root.children;
              for (i = 0, len = ref1.length; i < len; i++) {
                child = ref1[i];
                this.createChildNode(child);
                if (child.type === NodeType.Element) {
                  this.up();
                }
              }
            } else {
              this.node(name, attributes, text);
            }
          }
          return this;
        };
        XMLDocumentCB2.prototype.attribute = function(name, value) {
          var attName, attValue;
          if (!this.currentNode || this.currentNode.children) {
            throw new Error("att() can only be used immediately after an ele() call in callback mode. " + this.debugInfo(name));
          }
          if (name != null) {
            name = getValue(name);
          }
          if (isObject(name)) {
            for (attName in name) {
              if (!hasProp.call(name, attName))
                continue;
              attValue = name[attName];
              this.attribute(attName, attValue);
            }
          } else {
            if (isFunction(value)) {
              value = value.apply();
            }
            if (this.options.keepNullAttributes && value == null) {
              this.currentNode.attribs[name] = new XMLAttribute(this, name, "");
            } else if (value != null) {
              this.currentNode.attribs[name] = new XMLAttribute(this, name, value);
            }
          }
          return this;
        };
        XMLDocumentCB2.prototype.text = function(value) {
          var node;
          this.openCurrent();
          node = new XMLText(this, value);
          this.onData(this.writer.text(node, this.writerOptions, this.currentLevel + 1), this.currentLevel + 1);
          return this;
        };
        XMLDocumentCB2.prototype.cdata = function(value) {
          var node;
          this.openCurrent();
          node = new XMLCData(this, value);
          this.onData(this.writer.cdata(node, this.writerOptions, this.currentLevel + 1), this.currentLevel + 1);
          return this;
        };
        XMLDocumentCB2.prototype.comment = function(value) {
          var node;
          this.openCurrent();
          node = new XMLComment(this, value);
          this.onData(this.writer.comment(node, this.writerOptions, this.currentLevel + 1), this.currentLevel + 1);
          return this;
        };
        XMLDocumentCB2.prototype.raw = function(value) {
          var node;
          this.openCurrent();
          node = new XMLRaw(this, value);
          this.onData(this.writer.raw(node, this.writerOptions, this.currentLevel + 1), this.currentLevel + 1);
          return this;
        };
        XMLDocumentCB2.prototype.instruction = function(target, value) {
          var i, insTarget, insValue, len, node;
          this.openCurrent();
          if (target != null) {
            target = getValue(target);
          }
          if (value != null) {
            value = getValue(value);
          }
          if (Array.isArray(target)) {
            for (i = 0, len = target.length; i < len; i++) {
              insTarget = target[i];
              this.instruction(insTarget);
            }
          } else if (isObject(target)) {
            for (insTarget in target) {
              if (!hasProp.call(target, insTarget))
                continue;
              insValue = target[insTarget];
              this.instruction(insTarget, insValue);
            }
          } else {
            if (isFunction(value)) {
              value = value.apply();
            }
            node = new XMLProcessingInstruction(this, target, value);
            this.onData(this.writer.processingInstruction(node, this.writerOptions, this.currentLevel + 1), this.currentLevel + 1);
          }
          return this;
        };
        XMLDocumentCB2.prototype.declaration = function(version, encoding, standalone) {
          var node;
          this.openCurrent();
          if (this.documentStarted) {
            throw new Error("declaration() must be the first node.");
          }
          node = new XMLDeclaration(this, version, encoding, standalone);
          this.onData(this.writer.declaration(node, this.writerOptions, this.currentLevel + 1), this.currentLevel + 1);
          return this;
        };
        XMLDocumentCB2.prototype.doctype = function(root, pubID, sysID) {
          this.openCurrent();
          if (root == null) {
            throw new Error("Missing root node name.");
          }
          if (this.root) {
            throw new Error("dtd() must come before the root node.");
          }
          this.currentNode = new XMLDocType(this, pubID, sysID);
          this.currentNode.rootNodeName = root;
          this.currentNode.children = false;
          this.currentLevel++;
          this.openTags[this.currentLevel] = this.currentNode;
          return this;
        };
        XMLDocumentCB2.prototype.dtdElement = function(name, value) {
          var node;
          this.openCurrent();
          node = new XMLDTDElement(this, name, value);
          this.onData(this.writer.dtdElement(node, this.writerOptions, this.currentLevel + 1), this.currentLevel + 1);
          return this;
        };
        XMLDocumentCB2.prototype.attList = function(elementName, attributeName, attributeType, defaultValueType, defaultValue) {
          var node;
          this.openCurrent();
          node = new XMLDTDAttList(this, elementName, attributeName, attributeType, defaultValueType, defaultValue);
          this.onData(this.writer.dtdAttList(node, this.writerOptions, this.currentLevel + 1), this.currentLevel + 1);
          return this;
        };
        XMLDocumentCB2.prototype.entity = function(name, value) {
          var node;
          this.openCurrent();
          node = new XMLDTDEntity(this, false, name, value);
          this.onData(this.writer.dtdEntity(node, this.writerOptions, this.currentLevel + 1), this.currentLevel + 1);
          return this;
        };
        XMLDocumentCB2.prototype.pEntity = function(name, value) {
          var node;
          this.openCurrent();
          node = new XMLDTDEntity(this, true, name, value);
          this.onData(this.writer.dtdEntity(node, this.writerOptions, this.currentLevel + 1), this.currentLevel + 1);
          return this;
        };
        XMLDocumentCB2.prototype.notation = function(name, value) {
          var node;
          this.openCurrent();
          node = new XMLDTDNotation(this, name, value);
          this.onData(this.writer.dtdNotation(node, this.writerOptions, this.currentLevel + 1), this.currentLevel + 1);
          return this;
        };
        XMLDocumentCB2.prototype.up = function() {
          if (this.currentLevel < 0) {
            throw new Error("The document node has no parent.");
          }
          if (this.currentNode) {
            if (this.currentNode.children) {
              this.closeNode(this.currentNode);
            } else {
              this.openNode(this.currentNode);
            }
            this.currentNode = null;
          } else {
            this.closeNode(this.openTags[this.currentLevel]);
          }
          delete this.openTags[this.currentLevel];
          this.currentLevel--;
          return this;
        };
        XMLDocumentCB2.prototype.end = function() {
          while (this.currentLevel >= 0) {
            this.up();
          }
          return this.onEnd();
        };
        XMLDocumentCB2.prototype.openCurrent = function() {
          if (this.currentNode) {
            this.currentNode.children = true;
            return this.openNode(this.currentNode);
          }
        };
        XMLDocumentCB2.prototype.openNode = function(node) {
          var att, chunk, name, ref1;
          if (!node.isOpen) {
            if (!this.root && this.currentLevel === 0 && node.type === NodeType.Element) {
              this.root = node;
            }
            chunk = "";
            if (node.type === NodeType.Element) {
              this.writerOptions.state = WriterState.OpenTag;
              chunk = this.writer.indent(node, this.writerOptions, this.currentLevel) + "<" + node.name;
              ref1 = node.attribs;
              for (name in ref1) {
                if (!hasProp.call(ref1, name))
                  continue;
                att = ref1[name];
                chunk += this.writer.attribute(att, this.writerOptions, this.currentLevel);
              }
              chunk += (node.children ? ">" : "/>") + this.writer.endline(node, this.writerOptions, this.currentLevel);
              this.writerOptions.state = WriterState.InsideTag;
            } else {
              this.writerOptions.state = WriterState.OpenTag;
              chunk = this.writer.indent(node, this.writerOptions, this.currentLevel) + "<!DOCTYPE " + node.rootNodeName;
              if (node.pubID && node.sysID) {
                chunk += ' PUBLIC "' + node.pubID + '" "' + node.sysID + '"';
              } else if (node.sysID) {
                chunk += ' SYSTEM "' + node.sysID + '"';
              }
              if (node.children) {
                chunk += " [";
                this.writerOptions.state = WriterState.InsideTag;
              } else {
                this.writerOptions.state = WriterState.CloseTag;
                chunk += ">";
              }
              chunk += this.writer.endline(node, this.writerOptions, this.currentLevel);
            }
            this.onData(chunk, this.currentLevel);
            return node.isOpen = true;
          }
        };
        XMLDocumentCB2.prototype.closeNode = function(node) {
          var chunk;
          if (!node.isClosed) {
            chunk = "";
            this.writerOptions.state = WriterState.CloseTag;
            if (node.type === NodeType.Element) {
              chunk = this.writer.indent(node, this.writerOptions, this.currentLevel) + "</" + node.name + ">" + this.writer.endline(node, this.writerOptions, this.currentLevel);
            } else {
              chunk = this.writer.indent(node, this.writerOptions, this.currentLevel) + "]>" + this.writer.endline(node, this.writerOptions, this.currentLevel);
            }
            this.writerOptions.state = WriterState.None;
            this.onData(chunk, this.currentLevel);
            return node.isClosed = true;
          }
        };
        XMLDocumentCB2.prototype.onData = function(chunk, level) {
          this.documentStarted = true;
          return this.onDataCallback(chunk, level + 1);
        };
        XMLDocumentCB2.prototype.onEnd = function() {
          this.documentCompleted = true;
          return this.onEndCallback();
        };
        XMLDocumentCB2.prototype.debugInfo = function(name) {
          if (name == null) {
            return "";
          } else {
            return "node: <" + name + ">";
          }
        };
        XMLDocumentCB2.prototype.ele = function() {
          return this.element.apply(this, arguments);
        };
        XMLDocumentCB2.prototype.nod = function(name, attributes, text) {
          return this.node(name, attributes, text);
        };
        XMLDocumentCB2.prototype.txt = function(value) {
          return this.text(value);
        };
        XMLDocumentCB2.prototype.dat = function(value) {
          return this.cdata(value);
        };
        XMLDocumentCB2.prototype.com = function(value) {
          return this.comment(value);
        };
        XMLDocumentCB2.prototype.ins = function(target, value) {
          return this.instruction(target, value);
        };
        XMLDocumentCB2.prototype.dec = function(version, encoding, standalone) {
          return this.declaration(version, encoding, standalone);
        };
        XMLDocumentCB2.prototype.dtd = function(root, pubID, sysID) {
          return this.doctype(root, pubID, sysID);
        };
        XMLDocumentCB2.prototype.e = function(name, attributes, text) {
          return this.element(name, attributes, text);
        };
        XMLDocumentCB2.prototype.n = function(name, attributes, text) {
          return this.node(name, attributes, text);
        };
        XMLDocumentCB2.prototype.t = function(value) {
          return this.text(value);
        };
        XMLDocumentCB2.prototype.d = function(value) {
          return this.cdata(value);
        };
        XMLDocumentCB2.prototype.c = function(value) {
          return this.comment(value);
        };
        XMLDocumentCB2.prototype.r = function(value) {
          return this.raw(value);
        };
        XMLDocumentCB2.prototype.i = function(target, value) {
          return this.instruction(target, value);
        };
        XMLDocumentCB2.prototype.att = function() {
          if (this.currentNode && this.currentNode.type === NodeType.DocType) {
            return this.attList.apply(this, arguments);
          } else {
            return this.attribute.apply(this, arguments);
          }
        };
        XMLDocumentCB2.prototype.a = function() {
          if (this.currentNode && this.currentNode.type === NodeType.DocType) {
            return this.attList.apply(this, arguments);
          } else {
            return this.attribute.apply(this, arguments);
          }
        };
        XMLDocumentCB2.prototype.ent = function(name, value) {
          return this.entity(name, value);
        };
        XMLDocumentCB2.prototype.pent = function(name, value) {
          return this.pEntity(name, value);
        };
        XMLDocumentCB2.prototype.not = function(name, value) {
          return this.notation(name, value);
        };
        return XMLDocumentCB2;
      }();
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLStreamWriter.js
var require_XMLStreamWriter = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLStreamWriter.js"(exports2, module2) {
    "use strict";
    (function() {
      var NodeType, WriterState, XMLStreamWriter, XMLWriterBase, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      NodeType = require_NodeType();
      XMLWriterBase = require_XMLWriterBase();
      WriterState = require_WriterState();
      module2.exports = XMLStreamWriter = function(superClass) {
        extend(XMLStreamWriter2, superClass);
        function XMLStreamWriter2(stream, options) {
          this.stream = stream;
          XMLStreamWriter2.__super__.constructor.call(this, options);
        }
        XMLStreamWriter2.prototype.endline = function(node, options, level) {
          if (node.isLastRootNode && options.state === WriterState.CloseTag) {
            return "";
          } else {
            return XMLStreamWriter2.__super__.endline.call(this, node, options, level);
          }
        };
        XMLStreamWriter2.prototype.document = function(doc, options) {
          var child, i, j, k, len, len1, ref, ref1, results;
          ref = doc.children;
          for (i = j = 0, len = ref.length; j < len; i = ++j) {
            child = ref[i];
            child.isLastRootNode = i === doc.children.length - 1;
          }
          options = this.filterOptions(options);
          ref1 = doc.children;
          results = [];
          for (k = 0, len1 = ref1.length; k < len1; k++) {
            child = ref1[k];
            results.push(this.writeChildNode(child, options, 0));
          }
          return results;
        };
        XMLStreamWriter2.prototype.attribute = function(att, options, level) {
          return this.stream.write(XMLStreamWriter2.__super__.attribute.call(this, att, options, level));
        };
        XMLStreamWriter2.prototype.cdata = function(node, options, level) {
          return this.stream.write(XMLStreamWriter2.__super__.cdata.call(this, node, options, level));
        };
        XMLStreamWriter2.prototype.comment = function(node, options, level) {
          return this.stream.write(XMLStreamWriter2.__super__.comment.call(this, node, options, level));
        };
        XMLStreamWriter2.prototype.declaration = function(node, options, level) {
          return this.stream.write(XMLStreamWriter2.__super__.declaration.call(this, node, options, level));
        };
        XMLStreamWriter2.prototype.docType = function(node, options, level) {
          var child, j, len, ref;
          level || (level = 0);
          this.openNode(node, options, level);
          options.state = WriterState.OpenTag;
          this.stream.write(this.indent(node, options, level));
          this.stream.write("<!DOCTYPE " + node.root().name);
          if (node.pubID && node.sysID) {
            this.stream.write(' PUBLIC "' + node.pubID + '" "' + node.sysID + '"');
          } else if (node.sysID) {
            this.stream.write(' SYSTEM "' + node.sysID + '"');
          }
          if (node.children.length > 0) {
            this.stream.write(" [");
            this.stream.write(this.endline(node, options, level));
            options.state = WriterState.InsideTag;
            ref = node.children;
            for (j = 0, len = ref.length; j < len; j++) {
              child = ref[j];
              this.writeChildNode(child, options, level + 1);
            }
            options.state = WriterState.CloseTag;
            this.stream.write("]");
          }
          options.state = WriterState.CloseTag;
          this.stream.write(options.spaceBeforeSlash + ">");
          this.stream.write(this.endline(node, options, level));
          options.state = WriterState.None;
          return this.closeNode(node, options, level);
        };
        XMLStreamWriter2.prototype.element = function(node, options, level) {
          var att, child, childNodeCount, firstChildNode, j, len, name, prettySuppressed, ref, ref1;
          level || (level = 0);
          this.openNode(node, options, level);
          options.state = WriterState.OpenTag;
          this.stream.write(this.indent(node, options, level) + "<" + node.name);
          ref = node.attribs;
          for (name in ref) {
            if (!hasProp.call(ref, name))
              continue;
            att = ref[name];
            this.attribute(att, options, level);
          }
          childNodeCount = node.children.length;
          firstChildNode = childNodeCount === 0 ? null : node.children[0];
          if (childNodeCount === 0 || node.children.every(function(e) {
            return (e.type === NodeType.Text || e.type === NodeType.Raw) && e.value === "";
          })) {
            if (options.allowEmpty) {
              this.stream.write(">");
              options.state = WriterState.CloseTag;
              this.stream.write("</" + node.name + ">");
            } else {
              options.state = WriterState.CloseTag;
              this.stream.write(options.spaceBeforeSlash + "/>");
            }
          } else if (options.pretty && childNodeCount === 1 && (firstChildNode.type === NodeType.Text || firstChildNode.type === NodeType.Raw) && firstChildNode.value != null) {
            this.stream.write(">");
            options.state = WriterState.InsideTag;
            options.suppressPrettyCount++;
            prettySuppressed = true;
            this.writeChildNode(firstChildNode, options, level + 1);
            options.suppressPrettyCount--;
            prettySuppressed = false;
            options.state = WriterState.CloseTag;
            this.stream.write("</" + node.name + ">");
          } else {
            this.stream.write(">" + this.endline(node, options, level));
            options.state = WriterState.InsideTag;
            ref1 = node.children;
            for (j = 0, len = ref1.length; j < len; j++) {
              child = ref1[j];
              this.writeChildNode(child, options, level + 1);
            }
            options.state = WriterState.CloseTag;
            this.stream.write(this.indent(node, options, level) + "</" + node.name + ">");
          }
          this.stream.write(this.endline(node, options, level));
          options.state = WriterState.None;
          return this.closeNode(node, options, level);
        };
        XMLStreamWriter2.prototype.processingInstruction = function(node, options, level) {
          return this.stream.write(XMLStreamWriter2.__super__.processingInstruction.call(this, node, options, level));
        };
        XMLStreamWriter2.prototype.raw = function(node, options, level) {
          return this.stream.write(XMLStreamWriter2.__super__.raw.call(this, node, options, level));
        };
        XMLStreamWriter2.prototype.text = function(node, options, level) {
          return this.stream.write(XMLStreamWriter2.__super__.text.call(this, node, options, level));
        };
        XMLStreamWriter2.prototype.dtdAttList = function(node, options, level) {
          return this.stream.write(XMLStreamWriter2.__super__.dtdAttList.call(this, node, options, level));
        };
        XMLStreamWriter2.prototype.dtdElement = function(node, options, level) {
          return this.stream.write(XMLStreamWriter2.__super__.dtdElement.call(this, node, options, level));
        };
        XMLStreamWriter2.prototype.dtdEntity = function(node, options, level) {
          return this.stream.write(XMLStreamWriter2.__super__.dtdEntity.call(this, node, options, level));
        };
        XMLStreamWriter2.prototype.dtdNotation = function(node, options, level) {
          return this.stream.write(XMLStreamWriter2.__super__.dtdNotation.call(this, node, options, level));
        };
        return XMLStreamWriter2;
      }(XMLWriterBase);
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/index.js
var require_lib = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/index.js"(exports2, module2) {
    "use strict";
    (function() {
      var NodeType, WriterState, XMLDOMImplementation, XMLDocument, XMLDocumentCB, XMLStreamWriter, XMLStringWriter, assign, isFunction, ref;
      ref = require_Utility(), assign = ref.assign, isFunction = ref.isFunction;
      XMLDOMImplementation = require_XMLDOMImplementation();
      XMLDocument = require_XMLDocument();
      XMLDocumentCB = require_XMLDocumentCB();
      XMLStringWriter = require_XMLStringWriter();
      XMLStreamWriter = require_XMLStreamWriter();
      NodeType = require_NodeType();
      WriterState = require_WriterState();
      module2.exports.create = function(name, xmldec, doctype, options) {
        var doc, root;
        if (name == null) {
          throw new Error("Root element needs a name.");
        }
        options = assign({}, xmldec, doctype, options);
        doc = new XMLDocument(options);
        root = doc.element(name);
        if (!options.headless) {
          doc.declaration(options);
          if (options.pubID != null || options.sysID != null) {
            doc.dtd(options);
          }
        }
        return root;
      };
      module2.exports.begin = function(options, onData, onEnd) {
        var ref1;
        if (isFunction(options)) {
          ref1 = [options, onData], onData = ref1[0], onEnd = ref1[1];
          options = {};
        }
        if (onData) {
          return new XMLDocumentCB(options, onData, onEnd);
        } else {
          return new XMLDocument(options);
        }
      };
      module2.exports.stringWriter = function(options) {
        return new XMLStringWriter(options);
      };
      module2.exports.streamWriter = function(stream, options) {
        return new XMLStreamWriter(stream, options);
      };
      module2.exports.implementation = new XMLDOMImplementation();
      module2.exports.nodeType = NodeType;
      module2.exports.writerState = WriterState;
    }).call(exports2);
  }
});

// node_modules/xml2js/lib/builder.js
var require_builder3 = __commonJS({
  "node_modules/xml2js/lib/builder.js"(exports2) {
    "use strict";
    (function() {
      "use strict";
      var builder, defaults, escapeCDATA, requiresCDATA, wrapCDATA, hasProp = {}.hasOwnProperty;
      builder = require_lib();
      defaults = require_defaults().defaults;
      requiresCDATA = function(entry) {
        return typeof entry === "string" && (entry.indexOf("&") >= 0 || entry.indexOf(">") >= 0 || entry.indexOf("<") >= 0);
      };
      wrapCDATA = function(entry) {
        return "<![CDATA[" + escapeCDATA(entry) + "]]>";
      };
      escapeCDATA = function(entry) {
        return entry.replace("]]>", "]]]]><![CDATA[>");
      };
      exports2.Builder = function() {
        function Builder(opts) {
          var key, ref, value;
          this.options = {};
          ref = defaults["0.2"];
          for (key in ref) {
            if (!hasProp.call(ref, key))
              continue;
            value = ref[key];
            this.options[key] = value;
          }
          for (key in opts) {
            if (!hasProp.call(opts, key))
              continue;
            value = opts[key];
            this.options[key] = value;
          }
        }
        Builder.prototype.buildObject = function(rootObj) {
          var attrkey, charkey, render, rootElement, rootName;
          attrkey = this.options.attrkey;
          charkey = this.options.charkey;
          if (Object.keys(rootObj).length === 1 && this.options.rootName === defaults["0.2"].rootName) {
            rootName = Object.keys(rootObj)[0];
            rootObj = rootObj[rootName];
          } else {
            rootName = this.options.rootName;
          }
          render = /* @__PURE__ */ function(_this) {
            return function(element, obj) {
              var attr, child, entry, index, key, value;
              if (typeof obj !== "object") {
                if (_this.options.cdata && requiresCDATA(obj)) {
                  element.raw(wrapCDATA(obj));
                } else {
                  element.txt(obj);
                }
              } else if (Array.isArray(obj)) {
                for (index in obj) {
                  if (!hasProp.call(obj, index))
                    continue;
                  child = obj[index];
                  for (key in child) {
                    entry = child[key];
                    element = render(element.ele(key), entry).up();
                  }
                }
              } else {
                for (key in obj) {
                  if (!hasProp.call(obj, key))
                    continue;
                  child = obj[key];
                  if (key === attrkey) {
                    if (typeof child === "object") {
                      for (attr in child) {
                        value = child[attr];
                        element = element.att(attr, value);
                      }
                    }
                  } else if (key === charkey) {
                    if (_this.options.cdata && requiresCDATA(child)) {
                      element = element.raw(wrapCDATA(child));
                    } else {
                      element = element.txt(child);
                    }
                  } else if (Array.isArray(child)) {
                    for (index in child) {
                      if (!hasProp.call(child, index))
                        continue;
                      entry = child[index];
                      if (typeof entry === "string") {
                        if (_this.options.cdata && requiresCDATA(entry)) {
                          element = element.ele(key).raw(wrapCDATA(entry)).up();
                        } else {
                          element = element.ele(key, entry).up();
                        }
                      } else {
                        element = render(element.ele(key), entry).up();
                      }
                    }
                  } else if (typeof child === "object") {
                    element = render(element.ele(key), child).up();
                  } else {
                    if (typeof child === "string" && _this.options.cdata && requiresCDATA(child)) {
                      element = element.ele(key).raw(wrapCDATA(child)).up();
                    } else {
                      if (child == null) {
                        child = "";
                      }
                      element = element.ele(key, child.toString()).up();
                    }
                  }
                }
              }
              return element;
            };
          }(this);
          rootElement = builder.create(rootName, this.options.xmldec, this.options.doctype, {
            headless: this.options.headless,
            allowSurrogateChars: this.options.allowSurrogateChars
          });
          return render(rootElement, rootObj).end(this.options.renderOpts);
        };
        return Builder;
      }();
    }).call(exports2);
  }
});

// node_modules/xml2js/node_modules/sax/lib/sax.js
var require_sax = __commonJS({
  "node_modules/xml2js/node_modules/sax/lib/sax.js"(exports2) {
    "use strict";
    (function(sax) {
      sax.parser = function(strict, opt) {
        return new SAXParser(strict, opt);
      };
      sax.SAXParser = SAXParser;
      sax.SAXStream = SAXStream;
      sax.createStream = createStream;
      sax.MAX_BUFFER_LENGTH = 64 * 1024;
      var buffers = [
        "comment",
        "sgmlDecl",
        "textNode",
        "tagName",
        "doctype",
        "procInstName",
        "procInstBody",
        "entity",
        "attribName",
        "attribValue",
        "cdata",
        "script"
      ];
      sax.EVENTS = [
        "text",
        "processinginstruction",
        "sgmldeclaration",
        "doctype",
        "comment",
        "opentagstart",
        "attribute",
        "opentag",
        "closetag",
        "opencdata",
        "cdata",
        "closecdata",
        "error",
        "end",
        "ready",
        "script",
        "opennamespace",
        "closenamespace"
      ];
      function SAXParser(strict, opt) {
        if (!(this instanceof SAXParser)) {
          return new SAXParser(strict, opt);
        }
        var parser = this;
        clearBuffers(parser);
        parser.q = parser.c = "";
        parser.bufferCheckPosition = sax.MAX_BUFFER_LENGTH;
        parser.opt = opt || {};
        parser.opt.lowercase = parser.opt.lowercase || parser.opt.lowercasetags;
        parser.looseCase = parser.opt.lowercase ? "toLowerCase" : "toUpperCase";
        parser.tags = [];
        parser.closed = parser.closedRoot = parser.sawRoot = false;
        parser.tag = parser.error = null;
        parser.strict = !!strict;
        parser.noscript = !!(strict || parser.opt.noscript);
        parser.state = S.BEGIN;
        parser.strictEntities = parser.opt.strictEntities;
        parser.ENTITIES = parser.strictEntities ? Object.create(sax.XML_ENTITIES) : Object.create(sax.ENTITIES);
        parser.attribList = [];
        if (parser.opt.xmlns) {
          parser.ns = Object.create(rootNS);
        }
        parser.trackPosition = parser.opt.position !== false;
        if (parser.trackPosition) {
          parser.position = parser.line = parser.column = 0;
        }
        emit(parser, "onready");
      }
      if (!Object.create) {
        Object.create = function(o) {
          function F() {
          }
          F.prototype = o;
          var newf = new F();
          return newf;
        };
      }
      if (!Object.keys) {
        Object.keys = function(o) {
          var a = [];
          for (var i in o)
            if (o.hasOwnProperty(i))
              a.push(i);
          return a;
        };
      }
      function checkBufferLength(parser) {
        var maxAllowed = Math.max(sax.MAX_BUFFER_LENGTH, 10);
        var maxActual = 0;
        for (var i = 0, l = buffers.length; i < l; i++) {
          var len = parser[buffers[i]].length;
          if (len > maxAllowed) {
            switch (buffers[i]) {
              case "textNode":
                closeText(parser);
                break;
              case "cdata":
                emitNode(parser, "oncdata", parser.cdata);
                parser.cdata = "";
                break;
              case "script":
                emitNode(parser, "onscript", parser.script);
                parser.script = "";
                break;
              default:
                error(parser, "Max buffer length exceeded: " + buffers[i]);
            }
          }
          maxActual = Math.max(maxActual, len);
        }
        var m = sax.MAX_BUFFER_LENGTH - maxActual;
        parser.bufferCheckPosition = m + parser.position;
      }
      function clearBuffers(parser) {
        for (var i = 0, l = buffers.length; i < l; i++) {
          parser[buffers[i]] = "";
        }
      }
      function flushBuffers(parser) {
        closeText(parser);
        if (parser.cdata !== "") {
          emitNode(parser, "oncdata", parser.cdata);
          parser.cdata = "";
        }
        if (parser.script !== "") {
          emitNode(parser, "onscript", parser.script);
          parser.script = "";
        }
      }
      SAXParser.prototype = {
        end: function() {
          end(this);
        },
        write,
        resume: function() {
          this.error = null;
          return this;
        },
        close: function() {
          return this.write(null);
        },
        flush: function() {
          flushBuffers(this);
        }
      };
      var Stream;
      try {
        Stream = require("stream").Stream;
      } catch (ex) {
        Stream = function() {
        };
      }
      if (!Stream)
        Stream = function() {
        };
      var streamWraps = sax.EVENTS.filter(function(ev) {
        return ev !== "error" && ev !== "end";
      });
      function createStream(strict, opt) {
        return new SAXStream(strict, opt);
      }
      function SAXStream(strict, opt) {
        if (!(this instanceof SAXStream)) {
          return new SAXStream(strict, opt);
        }
        Stream.apply(this);
        this._parser = new SAXParser(strict, opt);
        this.writable = true;
        this.readable = true;
        var me = this;
        this._parser.onend = function() {
          me.emit("end");
        };
        this._parser.onerror = function(er) {
          me.emit("error", er);
          me._parser.error = null;
        };
        this._decoder = null;
        streamWraps.forEach(function(ev) {
          Object.defineProperty(me, "on" + ev, {
            get: function() {
              return me._parser["on" + ev];
            },
            set: function(h) {
              if (!h) {
                me.removeAllListeners(ev);
                me._parser["on" + ev] = h;
                return h;
              }
              me.on(ev, h);
            },
            enumerable: true,
            configurable: false
          });
        });
      }
      SAXStream.prototype = Object.create(Stream.prototype, {
        constructor: {
          value: SAXStream
        }
      });
      SAXStream.prototype.write = function(data) {
        if (typeof Buffer === "function" && typeof Buffer.isBuffer === "function" && Buffer.isBuffer(data)) {
          if (!this._decoder) {
            var SD = require("string_decoder").StringDecoder;
            this._decoder = new SD("utf8");
          }
          data = this._decoder.write(data);
        }
        this._parser.write(data.toString());
        this.emit("data", data);
        return true;
      };
      SAXStream.prototype.end = function(chunk) {
        if (chunk && chunk.length) {
          this.write(chunk);
        }
        this._parser.end();
        return true;
      };
      SAXStream.prototype.on = function(ev, handler2) {
        var me = this;
        if (!me._parser["on" + ev] && streamWraps.indexOf(ev) !== -1) {
          me._parser["on" + ev] = function() {
            var args = arguments.length === 1 ? [arguments[0]] : Array.apply(null, arguments);
            args.splice(0, 0, ev);
            me.emit.apply(me, args);
          };
        }
        return Stream.prototype.on.call(me, ev, handler2);
      };
      var CDATA = "[CDATA[";
      var DOCTYPE = "DOCTYPE";
      var XML_NAMESPACE = "http://www.w3.org/XML/1998/namespace";
      var XMLNS_NAMESPACE = "http://www.w3.org/2000/xmlns/";
      var rootNS = { xml: XML_NAMESPACE, xmlns: XMLNS_NAMESPACE };
      var nameStart = /[:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]/;
      var nameBody = /[:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\u00B7\u0300-\u036F\u203F-\u2040.\d-]/;
      var entityStart = /[#:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]/;
      var entityBody = /[#:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\u00B7\u0300-\u036F\u203F-\u2040.\d-]/;
      function isWhitespace(c) {
        return c === " " || c === "\n" || c === "\r" || c === "	";
      }
      function isQuote(c) {
        return c === '"' || c === "'";
      }
      function isAttribEnd(c) {
        return c === ">" || isWhitespace(c);
      }
      function isMatch(regex, c) {
        return regex.test(c);
      }
      function notMatch(regex, c) {
        return !isMatch(regex, c);
      }
      var S = 0;
      sax.STATE = {
        BEGIN: S++,
        // leading byte order mark or whitespace
        BEGIN_WHITESPACE: S++,
        // leading whitespace
        TEXT: S++,
        // general stuff
        TEXT_ENTITY: S++,
        // &amp and such.
        OPEN_WAKA: S++,
        // <
        SGML_DECL: S++,
        // <!BLARG
        SGML_DECL_QUOTED: S++,
        // <!BLARG foo "bar
        DOCTYPE: S++,
        // <!DOCTYPE
        DOCTYPE_QUOTED: S++,
        // <!DOCTYPE "//blah
        DOCTYPE_DTD: S++,
        // <!DOCTYPE "//blah" [ ...
        DOCTYPE_DTD_QUOTED: S++,
        // <!DOCTYPE "//blah" [ "foo
        COMMENT_STARTING: S++,
        // <!-
        COMMENT: S++,
        // <!--
        COMMENT_ENDING: S++,
        // <!-- blah -
        COMMENT_ENDED: S++,
        // <!-- blah --
        CDATA: S++,
        // <![CDATA[ something
        CDATA_ENDING: S++,
        // ]
        CDATA_ENDING_2: S++,
        // ]]
        PROC_INST: S++,
        // <?hi
        PROC_INST_BODY: S++,
        // <?hi there
        PROC_INST_ENDING: S++,
        // <?hi "there" ?
        OPEN_TAG: S++,
        // <strong
        OPEN_TAG_SLASH: S++,
        // <strong /
        ATTRIB: S++,
        // <a
        ATTRIB_NAME: S++,
        // <a foo
        ATTRIB_NAME_SAW_WHITE: S++,
        // <a foo _
        ATTRIB_VALUE: S++,
        // <a foo=
        ATTRIB_VALUE_QUOTED: S++,
        // <a foo="bar
        ATTRIB_VALUE_CLOSED: S++,
        // <a foo="bar"
        ATTRIB_VALUE_UNQUOTED: S++,
        // <a foo=bar
        ATTRIB_VALUE_ENTITY_Q: S++,
        // <foo bar="&quot;"
        ATTRIB_VALUE_ENTITY_U: S++,
        // <foo bar=&quot
        CLOSE_TAG: S++,
        // </a
        CLOSE_TAG_SAW_WHITE: S++,
        // </a   >
        SCRIPT: S++,
        // <script> ...
        SCRIPT_ENDING: S++
        // <script> ... <
      };
      sax.XML_ENTITIES = {
        "amp": "&",
        "gt": ">",
        "lt": "<",
        "quot": '"',
        "apos": "'"
      };
      sax.ENTITIES = {
        "amp": "&",
        "gt": ">",
        "lt": "<",
        "quot": '"',
        "apos": "'",
        "AElig": 198,
        "Aacute": 193,
        "Acirc": 194,
        "Agrave": 192,
        "Aring": 197,
        "Atilde": 195,
        "Auml": 196,
        "Ccedil": 199,
        "ETH": 208,
        "Eacute": 201,
        "Ecirc": 202,
        "Egrave": 200,
        "Euml": 203,
        "Iacute": 205,
        "Icirc": 206,
        "Igrave": 204,
        "Iuml": 207,
        "Ntilde": 209,
        "Oacute": 211,
        "Ocirc": 212,
        "Ograve": 210,
        "Oslash": 216,
        "Otilde": 213,
        "Ouml": 214,
        "THORN": 222,
        "Uacute": 218,
        "Ucirc": 219,
        "Ugrave": 217,
        "Uuml": 220,
        "Yacute": 221,
        "aacute": 225,
        "acirc": 226,
        "aelig": 230,
        "agrave": 224,
        "aring": 229,
        "atilde": 227,
        "auml": 228,
        "ccedil": 231,
        "eacute": 233,
        "ecirc": 234,
        "egrave": 232,
        "eth": 240,
        "euml": 235,
        "iacute": 237,
        "icirc": 238,
        "igrave": 236,
        "iuml": 239,
        "ntilde": 241,
        "oacute": 243,
        "ocirc": 244,
        "ograve": 242,
        "oslash": 248,
        "otilde": 245,
        "ouml": 246,
        "szlig": 223,
        "thorn": 254,
        "uacute": 250,
        "ucirc": 251,
        "ugrave": 249,
        "uuml": 252,
        "yacute": 253,
        "yuml": 255,
        "copy": 169,
        "reg": 174,
        "nbsp": 160,
        "iexcl": 161,
        "cent": 162,
        "pound": 163,
        "curren": 164,
        "yen": 165,
        "brvbar": 166,
        "sect": 167,
        "uml": 168,
        "ordf": 170,
        "laquo": 171,
        "not": 172,
        "shy": 173,
        "macr": 175,
        "deg": 176,
        "plusmn": 177,
        "sup1": 185,
        "sup2": 178,
        "sup3": 179,
        "acute": 180,
        "micro": 181,
        "para": 182,
        "middot": 183,
        "cedil": 184,
        "ordm": 186,
        "raquo": 187,
        "frac14": 188,
        "frac12": 189,
        "frac34": 190,
        "iquest": 191,
        "times": 215,
        "divide": 247,
        "OElig": 338,
        "oelig": 339,
        "Scaron": 352,
        "scaron": 353,
        "Yuml": 376,
        "fnof": 402,
        "circ": 710,
        "tilde": 732,
        "Alpha": 913,
        "Beta": 914,
        "Gamma": 915,
        "Delta": 916,
        "Epsilon": 917,
        "Zeta": 918,
        "Eta": 919,
        "Theta": 920,
        "Iota": 921,
        "Kappa": 922,
        "Lambda": 923,
        "Mu": 924,
        "Nu": 925,
        "Xi": 926,
        "Omicron": 927,
        "Pi": 928,
        "Rho": 929,
        "Sigma": 931,
        "Tau": 932,
        "Upsilon": 933,
        "Phi": 934,
        "Chi": 935,
        "Psi": 936,
        "Omega": 937,
        "alpha": 945,
        "beta": 946,
        "gamma": 947,
        "delta": 948,
        "epsilon": 949,
        "zeta": 950,
        "eta": 951,
        "theta": 952,
        "iota": 953,
        "kappa": 954,
        "lambda": 955,
        "mu": 956,
        "nu": 957,
        "xi": 958,
        "omicron": 959,
        "pi": 960,
        "rho": 961,
        "sigmaf": 962,
        "sigma": 963,
        "tau": 964,
        "upsilon": 965,
        "phi": 966,
        "chi": 967,
        "psi": 968,
        "omega": 969,
        "thetasym": 977,
        "upsih": 978,
        "piv": 982,
        "ensp": 8194,
        "emsp": 8195,
        "thinsp": 8201,
        "zwnj": 8204,
        "zwj": 8205,
        "lrm": 8206,
        "rlm": 8207,
        "ndash": 8211,
        "mdash": 8212,
        "lsquo": 8216,
        "rsquo": 8217,
        "sbquo": 8218,
        "ldquo": 8220,
        "rdquo": 8221,
        "bdquo": 8222,
        "dagger": 8224,
        "Dagger": 8225,
        "bull": 8226,
        "hellip": 8230,
        "permil": 8240,
        "prime": 8242,
        "Prime": 8243,
        "lsaquo": 8249,
        "rsaquo": 8250,
        "oline": 8254,
        "frasl": 8260,
        "euro": 8364,
        "image": 8465,
        "weierp": 8472,
        "real": 8476,
        "trade": 8482,
        "alefsym": 8501,
        "larr": 8592,
        "uarr": 8593,
        "rarr": 8594,
        "darr": 8595,
        "harr": 8596,
        "crarr": 8629,
        "lArr": 8656,
        "uArr": 8657,
        "rArr": 8658,
        "dArr": 8659,
        "hArr": 8660,
        "forall": 8704,
        "part": 8706,
        "exist": 8707,
        "empty": 8709,
        "nabla": 8711,
        "isin": 8712,
        "notin": 8713,
        "ni": 8715,
        "prod": 8719,
        "sum": 8721,
        "minus": 8722,
        "lowast": 8727,
        "radic": 8730,
        "prop": 8733,
        "infin": 8734,
        "ang": 8736,
        "and": 8743,
        "or": 8744,
        "cap": 8745,
        "cup": 8746,
        "int": 8747,
        "there4": 8756,
        "sim": 8764,
        "cong": 8773,
        "asymp": 8776,
        "ne": 8800,
        "equiv": 8801,
        "le": 8804,
        "ge": 8805,
        "sub": 8834,
        "sup": 8835,
        "nsub": 8836,
        "sube": 8838,
        "supe": 8839,
        "oplus": 8853,
        "otimes": 8855,
        "perp": 8869,
        "sdot": 8901,
        "lceil": 8968,
        "rceil": 8969,
        "lfloor": 8970,
        "rfloor": 8971,
        "lang": 9001,
        "rang": 9002,
        "loz": 9674,
        "spades": 9824,
        "clubs": 9827,
        "hearts": 9829,
        "diams": 9830
      };
      Object.keys(sax.ENTITIES).forEach(function(key) {
        var e = sax.ENTITIES[key];
        var s2 = typeof e === "number" ? String.fromCharCode(e) : e;
        sax.ENTITIES[key] = s2;
      });
      for (var s in sax.STATE) {
        sax.STATE[sax.STATE[s]] = s;
      }
      S = sax.STATE;
      function emit(parser, event, data) {
        parser[event] && parser[event](data);
      }
      function emitNode(parser, nodeType, data) {
        if (parser.textNode)
          closeText(parser);
        emit(parser, nodeType, data);
      }
      function closeText(parser) {
        parser.textNode = textopts(parser.opt, parser.textNode);
        if (parser.textNode)
          emit(parser, "ontext", parser.textNode);
        parser.textNode = "";
      }
      function textopts(opt, text) {
        if (opt.trim)
          text = text.trim();
        if (opt.normalize)
          text = text.replace(/\s+/g, " ");
        return text;
      }
      function error(parser, er) {
        closeText(parser);
        if (parser.trackPosition) {
          er += "\nLine: " + parser.line + "\nColumn: " + parser.column + "\nChar: " + parser.c;
        }
        er = new Error(er);
        parser.error = er;
        emit(parser, "onerror", er);
        return parser;
      }
      function end(parser) {
        if (parser.sawRoot && !parser.closedRoot)
          strictFail(parser, "Unclosed root tag");
        if (parser.state !== S.BEGIN && parser.state !== S.BEGIN_WHITESPACE && parser.state !== S.TEXT) {
          error(parser, "Unexpected end");
        }
        closeText(parser);
        parser.c = "";
        parser.closed = true;
        emit(parser, "onend");
        SAXParser.call(parser, parser.strict, parser.opt);
        return parser;
      }
      function strictFail(parser, message) {
        if (typeof parser !== "object" || !(parser instanceof SAXParser)) {
          throw new Error("bad call to strictFail");
        }
        if (parser.strict) {
          error(parser, message);
        }
      }
      function newTag(parser) {
        if (!parser.strict)
          parser.tagName = parser.tagName[parser.looseCase]();
        var parent = parser.tags[parser.tags.length - 1] || parser;
        var tag = parser.tag = { name: parser.tagName, attributes: {} };
        if (parser.opt.xmlns) {
          tag.ns = parent.ns;
        }
        parser.attribList.length = 0;
        emitNode(parser, "onopentagstart", tag);
      }
      function qname(name, attribute) {
        var i = name.indexOf(":");
        var qualName = i < 0 ? ["", name] : name.split(":");
        var prefix = qualName[0];
        var local = qualName[1];
        if (attribute && name === "xmlns") {
          prefix = "xmlns";
          local = "";
        }
        return { prefix, local };
      }
      function attrib(parser) {
        if (!parser.strict) {
          parser.attribName = parser.attribName[parser.looseCase]();
        }
        if (parser.attribList.indexOf(parser.attribName) !== -1 || parser.tag.attributes.hasOwnProperty(parser.attribName)) {
          parser.attribName = parser.attribValue = "";
          return;
        }
        if (parser.opt.xmlns) {
          var qn = qname(parser.attribName, true);
          var prefix = qn.prefix;
          var local = qn.local;
          if (prefix === "xmlns") {
            if (local === "xml" && parser.attribValue !== XML_NAMESPACE) {
              strictFail(
                parser,
                "xml: prefix must be bound to " + XML_NAMESPACE + "\nActual: " + parser.attribValue
              );
            } else if (local === "xmlns" && parser.attribValue !== XMLNS_NAMESPACE) {
              strictFail(
                parser,
                "xmlns: prefix must be bound to " + XMLNS_NAMESPACE + "\nActual: " + parser.attribValue
              );
            } else {
              var tag = parser.tag;
              var parent = parser.tags[parser.tags.length - 1] || parser;
              if (tag.ns === parent.ns) {
                tag.ns = Object.create(parent.ns);
              }
              tag.ns[local] = parser.attribValue;
            }
          }
          parser.attribList.push([parser.attribName, parser.attribValue]);
        } else {
          parser.tag.attributes[parser.attribName] = parser.attribValue;
          emitNode(parser, "onattribute", {
            name: parser.attribName,
            value: parser.attribValue
          });
        }
        parser.attribName = parser.attribValue = "";
      }
      function openTag(parser, selfClosing) {
        if (parser.opt.xmlns) {
          var tag = parser.tag;
          var qn = qname(parser.tagName);
          tag.prefix = qn.prefix;
          tag.local = qn.local;
          tag.uri = tag.ns[qn.prefix] || "";
          if (tag.prefix && !tag.uri) {
            strictFail(parser, "Unbound namespace prefix: " + JSON.stringify(parser.tagName));
            tag.uri = qn.prefix;
          }
          var parent = parser.tags[parser.tags.length - 1] || parser;
          if (tag.ns && parent.ns !== tag.ns) {
            Object.keys(tag.ns).forEach(function(p) {
              emitNode(parser, "onopennamespace", {
                prefix: p,
                uri: tag.ns[p]
              });
            });
          }
          for (var i = 0, l = parser.attribList.length; i < l; i++) {
            var nv = parser.attribList[i];
            var name = nv[0];
            var value = nv[1];
            var qualName = qname(name, true);
            var prefix = qualName.prefix;
            var local = qualName.local;
            var uri = prefix === "" ? "" : tag.ns[prefix] || "";
            var a = {
              name,
              value,
              prefix,
              local,
              uri
            };
            if (prefix && prefix !== "xmlns" && !uri) {
              strictFail(parser, "Unbound namespace prefix: " + JSON.stringify(prefix));
              a.uri = prefix;
            }
            parser.tag.attributes[name] = a;
            emitNode(parser, "onattribute", a);
          }
          parser.attribList.length = 0;
        }
        parser.tag.isSelfClosing = !!selfClosing;
        parser.sawRoot = true;
        parser.tags.push(parser.tag);
        emitNode(parser, "onopentag", parser.tag);
        if (!selfClosing) {
          if (!parser.noscript && parser.tagName.toLowerCase() === "script") {
            parser.state = S.SCRIPT;
          } else {
            parser.state = S.TEXT;
          }
          parser.tag = null;
          parser.tagName = "";
        }
        parser.attribName = parser.attribValue = "";
        parser.attribList.length = 0;
      }
      function closeTag(parser) {
        if (!parser.tagName) {
          strictFail(parser, "Weird empty close tag.");
          parser.textNode += "</>";
          parser.state = S.TEXT;
          return;
        }
        if (parser.script) {
          if (parser.tagName !== "script") {
            parser.script += "</" + parser.tagName + ">";
            parser.tagName = "";
            parser.state = S.SCRIPT;
            return;
          }
          emitNode(parser, "onscript", parser.script);
          parser.script = "";
        }
        var t = parser.tags.length;
        var tagName = parser.tagName;
        if (!parser.strict) {
          tagName = tagName[parser.looseCase]();
        }
        var closeTo = tagName;
        while (t--) {
          var close = parser.tags[t];
          if (close.name !== closeTo) {
            strictFail(parser, "Unexpected close tag");
          } else {
            break;
          }
        }
        if (t < 0) {
          strictFail(parser, "Unmatched closing tag: " + parser.tagName);
          parser.textNode += "</" + parser.tagName + ">";
          parser.state = S.TEXT;
          return;
        }
        parser.tagName = tagName;
        var s2 = parser.tags.length;
        while (s2-- > t) {
          var tag = parser.tag = parser.tags.pop();
          parser.tagName = parser.tag.name;
          emitNode(parser, "onclosetag", parser.tagName);
          var x = {};
          for (var i in tag.ns) {
            x[i] = tag.ns[i];
          }
          var parent = parser.tags[parser.tags.length - 1] || parser;
          if (parser.opt.xmlns && tag.ns !== parent.ns) {
            Object.keys(tag.ns).forEach(function(p) {
              var n = tag.ns[p];
              emitNode(parser, "onclosenamespace", { prefix: p, uri: n });
            });
          }
        }
        if (t === 0)
          parser.closedRoot = true;
        parser.tagName = parser.attribValue = parser.attribName = "";
        parser.attribList.length = 0;
        parser.state = S.TEXT;
      }
      function parseEntity(parser) {
        var entity = parser.entity;
        var entityLC = entity.toLowerCase();
        var num;
        var numStr = "";
        if (parser.ENTITIES[entity]) {
          return parser.ENTITIES[entity];
        }
        if (parser.ENTITIES[entityLC]) {
          return parser.ENTITIES[entityLC];
        }
        entity = entityLC;
        if (entity.charAt(0) === "#") {
          if (entity.charAt(1) === "x") {
            entity = entity.slice(2);
            num = parseInt(entity, 16);
            numStr = num.toString(16);
          } else {
            entity = entity.slice(1);
            num = parseInt(entity, 10);
            numStr = num.toString(10);
          }
        }
        entity = entity.replace(/^0+/, "");
        if (isNaN(num) || numStr.toLowerCase() !== entity) {
          strictFail(parser, "Invalid character entity");
          return "&" + parser.entity + ";";
        }
        return String.fromCodePoint(num);
      }
      function beginWhiteSpace(parser, c) {
        if (c === "<") {
          parser.state = S.OPEN_WAKA;
          parser.startTagPosition = parser.position;
        } else if (!isWhitespace(c)) {
          strictFail(parser, "Non-whitespace before first tag.");
          parser.textNode = c;
          parser.state = S.TEXT;
        }
      }
      function charAt(chunk, i) {
        var result = "";
        if (i < chunk.length) {
          result = chunk.charAt(i);
        }
        return result;
      }
      function write(chunk) {
        var parser = this;
        if (this.error) {
          throw this.error;
        }
        if (parser.closed) {
          return error(
            parser,
            "Cannot write after close. Assign an onready handler."
          );
        }
        if (chunk === null) {
          return end(parser);
        }
        if (typeof chunk === "object") {
          chunk = chunk.toString();
        }
        var i = 0;
        var c = "";
        while (true) {
          c = charAt(chunk, i++);
          parser.c = c;
          if (!c) {
            break;
          }
          if (parser.trackPosition) {
            parser.position++;
            if (c === "\n") {
              parser.line++;
              parser.column = 0;
            } else {
              parser.column++;
            }
          }
          switch (parser.state) {
            case S.BEGIN:
              parser.state = S.BEGIN_WHITESPACE;
              if (c === "\uFEFF") {
                continue;
              }
              beginWhiteSpace(parser, c);
              continue;
            case S.BEGIN_WHITESPACE:
              beginWhiteSpace(parser, c);
              continue;
            case S.TEXT:
              if (parser.sawRoot && !parser.closedRoot) {
                var starti = i - 1;
                while (c && c !== "<" && c !== "&") {
                  c = charAt(chunk, i++);
                  if (c && parser.trackPosition) {
                    parser.position++;
                    if (c === "\n") {
                      parser.line++;
                      parser.column = 0;
                    } else {
                      parser.column++;
                    }
                  }
                }
                parser.textNode += chunk.substring(starti, i - 1);
              }
              if (c === "<" && !(parser.sawRoot && parser.closedRoot && !parser.strict)) {
                parser.state = S.OPEN_WAKA;
                parser.startTagPosition = parser.position;
              } else {
                if (!isWhitespace(c) && (!parser.sawRoot || parser.closedRoot)) {
                  strictFail(parser, "Text data outside of root node.");
                }
                if (c === "&") {
                  parser.state = S.TEXT_ENTITY;
                } else {
                  parser.textNode += c;
                }
              }
              continue;
            case S.SCRIPT:
              if (c === "<") {
                parser.state = S.SCRIPT_ENDING;
              } else {
                parser.script += c;
              }
              continue;
            case S.SCRIPT_ENDING:
              if (c === "/") {
                parser.state = S.CLOSE_TAG;
              } else {
                parser.script += "<" + c;
                parser.state = S.SCRIPT;
              }
              continue;
            case S.OPEN_WAKA:
              if (c === "!") {
                parser.state = S.SGML_DECL;
                parser.sgmlDecl = "";
              } else if (isWhitespace(c)) {
              } else if (isMatch(nameStart, c)) {
                parser.state = S.OPEN_TAG;
                parser.tagName = c;
              } else if (c === "/") {
                parser.state = S.CLOSE_TAG;
                parser.tagName = "";
              } else if (c === "?") {
                parser.state = S.PROC_INST;
                parser.procInstName = parser.procInstBody = "";
              } else {
                strictFail(parser, "Unencoded <");
                if (parser.startTagPosition + 1 < parser.position) {
                  var pad = parser.position - parser.startTagPosition;
                  c = new Array(pad).join(" ") + c;
                }
                parser.textNode += "<" + c;
                parser.state = S.TEXT;
              }
              continue;
            case S.SGML_DECL:
              if ((parser.sgmlDecl + c).toUpperCase() === CDATA) {
                emitNode(parser, "onopencdata");
                parser.state = S.CDATA;
                parser.sgmlDecl = "";
                parser.cdata = "";
              } else if (parser.sgmlDecl + c === "--") {
                parser.state = S.COMMENT;
                parser.comment = "";
                parser.sgmlDecl = "";
              } else if ((parser.sgmlDecl + c).toUpperCase() === DOCTYPE) {
                parser.state = S.DOCTYPE;
                if (parser.doctype || parser.sawRoot) {
                  strictFail(
                    parser,
                    "Inappropriately located doctype declaration"
                  );
                }
                parser.doctype = "";
                parser.sgmlDecl = "";
              } else if (c === ">") {
                emitNode(parser, "onsgmldeclaration", parser.sgmlDecl);
                parser.sgmlDecl = "";
                parser.state = S.TEXT;
              } else if (isQuote(c)) {
                parser.state = S.SGML_DECL_QUOTED;
                parser.sgmlDecl += c;
              } else {
                parser.sgmlDecl += c;
              }
              continue;
            case S.SGML_DECL_QUOTED:
              if (c === parser.q) {
                parser.state = S.SGML_DECL;
                parser.q = "";
              }
              parser.sgmlDecl += c;
              continue;
            case S.DOCTYPE:
              if (c === ">") {
                parser.state = S.TEXT;
                emitNode(parser, "ondoctype", parser.doctype);
                parser.doctype = true;
              } else {
                parser.doctype += c;
                if (c === "[") {
                  parser.state = S.DOCTYPE_DTD;
                } else if (isQuote(c)) {
                  parser.state = S.DOCTYPE_QUOTED;
                  parser.q = c;
                }
              }
              continue;
            case S.DOCTYPE_QUOTED:
              parser.doctype += c;
              if (c === parser.q) {
                parser.q = "";
                parser.state = S.DOCTYPE;
              }
              continue;
            case S.DOCTYPE_DTD:
              parser.doctype += c;
              if (c === "]") {
                parser.state = S.DOCTYPE;
              } else if (isQuote(c)) {
                parser.state = S.DOCTYPE_DTD_QUOTED;
                parser.q = c;
              }
              continue;
            case S.DOCTYPE_DTD_QUOTED:
              parser.doctype += c;
              if (c === parser.q) {
                parser.state = S.DOCTYPE_DTD;
                parser.q = "";
              }
              continue;
            case S.COMMENT:
              if (c === "-") {
                parser.state = S.COMMENT_ENDING;
              } else {
                parser.comment += c;
              }
              continue;
            case S.COMMENT_ENDING:
              if (c === "-") {
                parser.state = S.COMMENT_ENDED;
                parser.comment = textopts(parser.opt, parser.comment);
                if (parser.comment) {
                  emitNode(parser, "oncomment", parser.comment);
                }
                parser.comment = "";
              } else {
                parser.comment += "-" + c;
                parser.state = S.COMMENT;
              }
              continue;
            case S.COMMENT_ENDED:
              if (c !== ">") {
                strictFail(parser, "Malformed comment");
                parser.comment += "--" + c;
                parser.state = S.COMMENT;
              } else {
                parser.state = S.TEXT;
              }
              continue;
            case S.CDATA:
              if (c === "]") {
                parser.state = S.CDATA_ENDING;
              } else {
                parser.cdata += c;
              }
              continue;
            case S.CDATA_ENDING:
              if (c === "]") {
                parser.state = S.CDATA_ENDING_2;
              } else {
                parser.cdata += "]" + c;
                parser.state = S.CDATA;
              }
              continue;
            case S.CDATA_ENDING_2:
              if (c === ">") {
                if (parser.cdata) {
                  emitNode(parser, "oncdata", parser.cdata);
                }
                emitNode(parser, "onclosecdata");
                parser.cdata = "";
                parser.state = S.TEXT;
              } else if (c === "]") {
                parser.cdata += "]";
              } else {
                parser.cdata += "]]" + c;
                parser.state = S.CDATA;
              }
              continue;
            case S.PROC_INST:
              if (c === "?") {
                parser.state = S.PROC_INST_ENDING;
              } else if (isWhitespace(c)) {
                parser.state = S.PROC_INST_BODY;
              } else {
                parser.procInstName += c;
              }
              continue;
            case S.PROC_INST_BODY:
              if (!parser.procInstBody && isWhitespace(c)) {
                continue;
              } else if (c === "?") {
                parser.state = S.PROC_INST_ENDING;
              } else {
                parser.procInstBody += c;
              }
              continue;
            case S.PROC_INST_ENDING:
              if (c === ">") {
                emitNode(parser, "onprocessinginstruction", {
                  name: parser.procInstName,
                  body: parser.procInstBody
                });
                parser.procInstName = parser.procInstBody = "";
                parser.state = S.TEXT;
              } else {
                parser.procInstBody += "?" + c;
                parser.state = S.PROC_INST_BODY;
              }
              continue;
            case S.OPEN_TAG:
              if (isMatch(nameBody, c)) {
                parser.tagName += c;
              } else {
                newTag(parser);
                if (c === ">") {
                  openTag(parser);
                } else if (c === "/") {
                  parser.state = S.OPEN_TAG_SLASH;
                } else {
                  if (!isWhitespace(c)) {
                    strictFail(parser, "Invalid character in tag name");
                  }
                  parser.state = S.ATTRIB;
                }
              }
              continue;
            case S.OPEN_TAG_SLASH:
              if (c === ">") {
                openTag(parser, true);
                closeTag(parser);
              } else {
                strictFail(parser, "Forward-slash in opening tag not followed by >");
                parser.state = S.ATTRIB;
              }
              continue;
            case S.ATTRIB:
              if (isWhitespace(c)) {
                continue;
              } else if (c === ">") {
                openTag(parser);
              } else if (c === "/") {
                parser.state = S.OPEN_TAG_SLASH;
              } else if (isMatch(nameStart, c)) {
                parser.attribName = c;
                parser.attribValue = "";
                parser.state = S.ATTRIB_NAME;
              } else {
                strictFail(parser, "Invalid attribute name");
              }
              continue;
            case S.ATTRIB_NAME:
              if (c === "=") {
                parser.state = S.ATTRIB_VALUE;
              } else if (c === ">") {
                strictFail(parser, "Attribute without value");
                parser.attribValue = parser.attribName;
                attrib(parser);
                openTag(parser);
              } else if (isWhitespace(c)) {
                parser.state = S.ATTRIB_NAME_SAW_WHITE;
              } else if (isMatch(nameBody, c)) {
                parser.attribName += c;
              } else {
                strictFail(parser, "Invalid attribute name");
              }
              continue;
            case S.ATTRIB_NAME_SAW_WHITE:
              if (c === "=") {
                parser.state = S.ATTRIB_VALUE;
              } else if (isWhitespace(c)) {
                continue;
              } else {
                strictFail(parser, "Attribute without value");
                parser.tag.attributes[parser.attribName] = "";
                parser.attribValue = "";
                emitNode(parser, "onattribute", {
                  name: parser.attribName,
                  value: ""
                });
                parser.attribName = "";
                if (c === ">") {
                  openTag(parser);
                } else if (isMatch(nameStart, c)) {
                  parser.attribName = c;
                  parser.state = S.ATTRIB_NAME;
                } else {
                  strictFail(parser, "Invalid attribute name");
                  parser.state = S.ATTRIB;
                }
              }
              continue;
            case S.ATTRIB_VALUE:
              if (isWhitespace(c)) {
                continue;
              } else if (isQuote(c)) {
                parser.q = c;
                parser.state = S.ATTRIB_VALUE_QUOTED;
              } else {
                strictFail(parser, "Unquoted attribute value");
                parser.state = S.ATTRIB_VALUE_UNQUOTED;
                parser.attribValue = c;
              }
              continue;
            case S.ATTRIB_VALUE_QUOTED:
              if (c !== parser.q) {
                if (c === "&") {
                  parser.state = S.ATTRIB_VALUE_ENTITY_Q;
                } else {
                  parser.attribValue += c;
                }
                continue;
              }
              attrib(parser);
              parser.q = "";
              parser.state = S.ATTRIB_VALUE_CLOSED;
              continue;
            case S.ATTRIB_VALUE_CLOSED:
              if (isWhitespace(c)) {
                parser.state = S.ATTRIB;
              } else if (c === ">") {
                openTag(parser);
              } else if (c === "/") {
                parser.state = S.OPEN_TAG_SLASH;
              } else if (isMatch(nameStart, c)) {
                strictFail(parser, "No whitespace between attributes");
                parser.attribName = c;
                parser.attribValue = "";
                parser.state = S.ATTRIB_NAME;
              } else {
                strictFail(parser, "Invalid attribute name");
              }
              continue;
            case S.ATTRIB_VALUE_UNQUOTED:
              if (!isAttribEnd(c)) {
                if (c === "&") {
                  parser.state = S.ATTRIB_VALUE_ENTITY_U;
                } else {
                  parser.attribValue += c;
                }
                continue;
              }
              attrib(parser);
              if (c === ">") {
                openTag(parser);
              } else {
                parser.state = S.ATTRIB;
              }
              continue;
            case S.CLOSE_TAG:
              if (!parser.tagName) {
                if (isWhitespace(c)) {
                  continue;
                } else if (notMatch(nameStart, c)) {
                  if (parser.script) {
                    parser.script += "</" + c;
                    parser.state = S.SCRIPT;
                  } else {
                    strictFail(parser, "Invalid tagname in closing tag.");
                  }
                } else {
                  parser.tagName = c;
                }
              } else if (c === ">") {
                closeTag(parser);
              } else if (isMatch(nameBody, c)) {
                parser.tagName += c;
              } else if (parser.script) {
                parser.script += "</" + parser.tagName;
                parser.tagName = "";
                parser.state = S.SCRIPT;
              } else {
                if (!isWhitespace(c)) {
                  strictFail(parser, "Invalid tagname in closing tag");
                }
                parser.state = S.CLOSE_TAG_SAW_WHITE;
              }
              continue;
            case S.CLOSE_TAG_SAW_WHITE:
              if (isWhitespace(c)) {
                continue;
              }
              if (c === ">") {
                closeTag(parser);
              } else {
                strictFail(parser, "Invalid characters in closing tag");
              }
              continue;
            case S.TEXT_ENTITY:
            case S.ATTRIB_VALUE_ENTITY_Q:
            case S.ATTRIB_VALUE_ENTITY_U:
              var returnState;
              var buffer;
              switch (parser.state) {
                case S.TEXT_ENTITY:
                  returnState = S.TEXT;
                  buffer = "textNode";
                  break;
                case S.ATTRIB_VALUE_ENTITY_Q:
                  returnState = S.ATTRIB_VALUE_QUOTED;
                  buffer = "attribValue";
                  break;
                case S.ATTRIB_VALUE_ENTITY_U:
                  returnState = S.ATTRIB_VALUE_UNQUOTED;
                  buffer = "attribValue";
                  break;
              }
              if (c === ";") {
                if (parser.opt.unparsedEntities) {
                  var parsedEntity = parseEntity(parser);
                  parser.entity = "";
                  parser.state = returnState;
                  parser.write(parsedEntity);
                } else {
                  parser[buffer] += parseEntity(parser);
                  parser.entity = "";
                  parser.state = returnState;
                }
              } else if (isMatch(parser.entity.length ? entityBody : entityStart, c)) {
                parser.entity += c;
              } else {
                strictFail(parser, "Invalid character in entity name");
                parser[buffer] += "&" + parser.entity + c;
                parser.entity = "";
                parser.state = returnState;
              }
              continue;
            default: {
              throw new Error(parser, "Unknown state: " + parser.state);
            }
          }
        }
        if (parser.position >= parser.bufferCheckPosition) {
          checkBufferLength(parser);
        }
        return parser;
      }
      if (!String.fromCodePoint) {
        (function() {
          var stringFromCharCode = String.fromCharCode;
          var floor = Math.floor;
          var fromCodePoint = function() {
            var MAX_SIZE = 16384;
            var codeUnits = [];
            var highSurrogate;
            var lowSurrogate;
            var index = -1;
            var length = arguments.length;
            if (!length) {
              return "";
            }
            var result = "";
            while (++index < length) {
              var codePoint = Number(arguments[index]);
              if (!isFinite(codePoint) || // `NaN`, `+Infinity`, or `-Infinity`
              codePoint < 0 || // not a valid Unicode code point
              codePoint > 1114111 || // not a valid Unicode code point
              floor(codePoint) !== codePoint) {
                throw RangeError("Invalid code point: " + codePoint);
              }
              if (codePoint <= 65535) {
                codeUnits.push(codePoint);
              } else {
                codePoint -= 65536;
                highSurrogate = (codePoint >> 10) + 55296;
                lowSurrogate = codePoint % 1024 + 56320;
                codeUnits.push(highSurrogate, lowSurrogate);
              }
              if (index + 1 === length || codeUnits.length > MAX_SIZE) {
                result += stringFromCharCode.apply(null, codeUnits);
                codeUnits.length = 0;
              }
            }
            return result;
          };
          if (Object.defineProperty) {
            Object.defineProperty(String, "fromCodePoint", {
              value: fromCodePoint,
              configurable: true,
              writable: true
            });
          } else {
            String.fromCodePoint = fromCodePoint;
          }
        })();
      }
    })(typeof exports2 === "undefined" ? exports2.sax = {} : exports2);
  }
});

// node_modules/xml2js/lib/bom.js
var require_bom = __commonJS({
  "node_modules/xml2js/lib/bom.js"(exports2) {
    "use strict";
    (function() {
      "use strict";
      exports2.stripBOM = function(str) {
        if (str[0] === "\uFEFF") {
          return str.substring(1);
        } else {
          return str;
        }
      };
    }).call(exports2);
  }
});

// node_modules/xml2js/lib/processors.js
var require_processors = __commonJS({
  "node_modules/xml2js/lib/processors.js"(exports2) {
    "use strict";
    (function() {
      "use strict";
      var prefixMatch;
      prefixMatch = new RegExp(/(?!xmlns)^.*:/);
      exports2.normalize = function(str) {
        return str.toLowerCase();
      };
      exports2.firstCharLowerCase = function(str) {
        return str.charAt(0).toLowerCase() + str.slice(1);
      };
      exports2.stripPrefix = function(str) {
        return str.replace(prefixMatch, "");
      };
      exports2.parseNumbers = function(str) {
        if (!isNaN(str)) {
          str = str % 1 === 0 ? parseInt(str, 10) : parseFloat(str);
        }
        return str;
      };
      exports2.parseBooleans = function(str) {
        if (/^(?:true|false)$/i.test(str)) {
          str = str.toLowerCase() === "true";
        }
        return str;
      };
    }).call(exports2);
  }
});

// node_modules/xml2js/lib/parser.js
var require_parser2 = __commonJS({
  "node_modules/xml2js/lib/parser.js"(exports2) {
    "use strict";
    (function() {
      "use strict";
      var bom, defaults, events, isEmpty, processItem, processors, sax, setImmediate2, bind = function(fn, me) {
        return function() {
          return fn.apply(me, arguments);
        };
      }, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      sax = require_sax();
      events = require("events");
      bom = require_bom();
      processors = require_processors();
      setImmediate2 = require("timers").setImmediate;
      defaults = require_defaults().defaults;
      isEmpty = function(thing) {
        return typeof thing === "object" && thing != null && Object.keys(thing).length === 0;
      };
      processItem = function(processors2, item, key) {
        var i, len, process2;
        for (i = 0, len = processors2.length; i < len; i++) {
          process2 = processors2[i];
          item = process2(item, key);
        }
        return item;
      };
      exports2.Parser = function(superClass) {
        extend(Parser, superClass);
        function Parser(opts) {
          this.parseStringPromise = bind(this.parseStringPromise, this);
          this.parseString = bind(this.parseString, this);
          this.reset = bind(this.reset, this);
          this.assignOrPush = bind(this.assignOrPush, this);
          this.processAsync = bind(this.processAsync, this);
          var key, ref, value;
          if (!(this instanceof exports2.Parser)) {
            return new exports2.Parser(opts);
          }
          this.options = {};
          ref = defaults["0.2"];
          for (key in ref) {
            if (!hasProp.call(ref, key))
              continue;
            value = ref[key];
            this.options[key] = value;
          }
          for (key in opts) {
            if (!hasProp.call(opts, key))
              continue;
            value = opts[key];
            this.options[key] = value;
          }
          if (this.options.xmlns) {
            this.options.xmlnskey = this.options.attrkey + "ns";
          }
          if (this.options.normalizeTags) {
            if (!this.options.tagNameProcessors) {
              this.options.tagNameProcessors = [];
            }
            this.options.tagNameProcessors.unshift(processors.normalize);
          }
          this.reset();
        }
        Parser.prototype.processAsync = function() {
          var chunk, err;
          try {
            if (this.remaining.length <= this.options.chunkSize) {
              chunk = this.remaining;
              this.remaining = "";
              this.saxParser = this.saxParser.write(chunk);
              return this.saxParser.close();
            } else {
              chunk = this.remaining.substr(0, this.options.chunkSize);
              this.remaining = this.remaining.substr(this.options.chunkSize, this.remaining.length);
              this.saxParser = this.saxParser.write(chunk);
              return setImmediate2(this.processAsync);
            }
          } catch (error1) {
            err = error1;
            if (!this.saxParser.errThrown) {
              this.saxParser.errThrown = true;
              return this.emit(err);
            }
          }
        };
        Parser.prototype.assignOrPush = function(obj, key, newValue) {
          if (!(key in obj)) {
            if (!this.options.explicitArray) {
              return obj[key] = newValue;
            } else {
              return obj[key] = [newValue];
            }
          } else {
            if (!(obj[key] instanceof Array)) {
              obj[key] = [obj[key]];
            }
            return obj[key].push(newValue);
          }
        };
        Parser.prototype.reset = function() {
          var attrkey, charkey, ontext, stack;
          this.removeAllListeners();
          this.saxParser = sax.parser(this.options.strict, {
            trim: false,
            normalize: false,
            xmlns: this.options.xmlns
          });
          this.saxParser.errThrown = false;
          this.saxParser.onerror = /* @__PURE__ */ function(_this) {
            return function(error) {
              _this.saxParser.resume();
              if (!_this.saxParser.errThrown) {
                _this.saxParser.errThrown = true;
                return _this.emit("error", error);
              }
            };
          }(this);
          this.saxParser.onend = /* @__PURE__ */ function(_this) {
            return function() {
              if (!_this.saxParser.ended) {
                _this.saxParser.ended = true;
                return _this.emit("end", _this.resultObject);
              }
            };
          }(this);
          this.saxParser.ended = false;
          this.EXPLICIT_CHARKEY = this.options.explicitCharkey;
          this.resultObject = null;
          stack = [];
          attrkey = this.options.attrkey;
          charkey = this.options.charkey;
          this.saxParser.onopentag = /* @__PURE__ */ function(_this) {
            return function(node) {
              var key, newValue, obj, processedKey, ref;
              obj = /* @__PURE__ */ Object.create(null);
              obj[charkey] = "";
              if (!_this.options.ignoreAttrs) {
                ref = node.attributes;
                for (key in ref) {
                  if (!hasProp.call(ref, key))
                    continue;
                  if (!(attrkey in obj) && !_this.options.mergeAttrs) {
                    obj[attrkey] = /* @__PURE__ */ Object.create(null);
                  }
                  newValue = _this.options.attrValueProcessors ? processItem(_this.options.attrValueProcessors, node.attributes[key], key) : node.attributes[key];
                  processedKey = _this.options.attrNameProcessors ? processItem(_this.options.attrNameProcessors, key) : key;
                  if (_this.options.mergeAttrs) {
                    _this.assignOrPush(obj, processedKey, newValue);
                  } else {
                    obj[attrkey][processedKey] = newValue;
                  }
                }
              }
              obj["#name"] = _this.options.tagNameProcessors ? processItem(_this.options.tagNameProcessors, node.name) : node.name;
              if (_this.options.xmlns) {
                obj[_this.options.xmlnskey] = {
                  uri: node.uri,
                  local: node.local
                };
              }
              return stack.push(obj);
            };
          }(this);
          this.saxParser.onclosetag = /* @__PURE__ */ function(_this) {
            return function() {
              var cdata, emptyStr, key, node, nodeName, obj, objClone, old, s, xpath;
              obj = stack.pop();
              nodeName = obj["#name"];
              if (!_this.options.explicitChildren || !_this.options.preserveChildrenOrder) {
                delete obj["#name"];
              }
              if (obj.cdata === true) {
                cdata = obj.cdata;
                delete obj.cdata;
              }
              s = stack[stack.length - 1];
              if (obj[charkey].match(/^\s*$/) && !cdata) {
                emptyStr = obj[charkey];
                delete obj[charkey];
              } else {
                if (_this.options.trim) {
                  obj[charkey] = obj[charkey].trim();
                }
                if (_this.options.normalize) {
                  obj[charkey] = obj[charkey].replace(/\s{2,}/g, " ").trim();
                }
                obj[charkey] = _this.options.valueProcessors ? processItem(_this.options.valueProcessors, obj[charkey], nodeName) : obj[charkey];
                if (Object.keys(obj).length === 1 && charkey in obj && !_this.EXPLICIT_CHARKEY) {
                  obj = obj[charkey];
                }
              }
              if (isEmpty(obj)) {
                if (typeof _this.options.emptyTag === "function") {
                  obj = _this.options.emptyTag();
                } else {
                  obj = _this.options.emptyTag !== "" ? _this.options.emptyTag : emptyStr;
                }
              }
              if (_this.options.validator != null) {
                xpath = "/" + function() {
                  var i, len, results;
                  results = [];
                  for (i = 0, len = stack.length; i < len; i++) {
                    node = stack[i];
                    results.push(node["#name"]);
                  }
                  return results;
                }().concat(nodeName).join("/");
                (function() {
                  var err;
                  try {
                    return obj = _this.options.validator(xpath, s && s[nodeName], obj);
                  } catch (error1) {
                    err = error1;
                    return _this.emit("error", err);
                  }
                })();
              }
              if (_this.options.explicitChildren && !_this.options.mergeAttrs && typeof obj === "object") {
                if (!_this.options.preserveChildrenOrder) {
                  node = /* @__PURE__ */ Object.create(null);
                  if (_this.options.attrkey in obj) {
                    node[_this.options.attrkey] = obj[_this.options.attrkey];
                    delete obj[_this.options.attrkey];
                  }
                  if (!_this.options.charsAsChildren && _this.options.charkey in obj) {
                    node[_this.options.charkey] = obj[_this.options.charkey];
                    delete obj[_this.options.charkey];
                  }
                  if (Object.getOwnPropertyNames(obj).length > 0) {
                    node[_this.options.childkey] = obj;
                  }
                  obj = node;
                } else if (s) {
                  s[_this.options.childkey] = s[_this.options.childkey] || [];
                  objClone = /* @__PURE__ */ Object.create(null);
                  for (key in obj) {
                    if (!hasProp.call(obj, key))
                      continue;
                    objClone[key] = obj[key];
                  }
                  s[_this.options.childkey].push(objClone);
                  delete obj["#name"];
                  if (Object.keys(obj).length === 1 && charkey in obj && !_this.EXPLICIT_CHARKEY) {
                    obj = obj[charkey];
                  }
                }
              }
              if (stack.length > 0) {
                return _this.assignOrPush(s, nodeName, obj);
              } else {
                if (_this.options.explicitRoot) {
                  old = obj;
                  obj = /* @__PURE__ */ Object.create(null);
                  obj[nodeName] = old;
                }
                _this.resultObject = obj;
                _this.saxParser.ended = true;
                return _this.emit("end", _this.resultObject);
              }
            };
          }(this);
          ontext = /* @__PURE__ */ function(_this) {
            return function(text) {
              var charChild, s;
              s = stack[stack.length - 1];
              if (s) {
                s[charkey] += text;
                if (_this.options.explicitChildren && _this.options.preserveChildrenOrder && _this.options.charsAsChildren && (_this.options.includeWhiteChars || text.replace(/\\n/g, "").trim() !== "")) {
                  s[_this.options.childkey] = s[_this.options.childkey] || [];
                  charChild = {
                    "#name": "__text__"
                  };
                  charChild[charkey] = text;
                  if (_this.options.normalize) {
                    charChild[charkey] = charChild[charkey].replace(/\s{2,}/g, " ").trim();
                  }
                  s[_this.options.childkey].push(charChild);
                }
                return s;
              }
            };
          }(this);
          this.saxParser.ontext = ontext;
          return this.saxParser.oncdata = /* @__PURE__ */ function(_this) {
            return function(text) {
              var s;
              s = ontext(text);
              if (s) {
                return s.cdata = true;
              }
            };
          }(this);
        };
        Parser.prototype.parseString = function(str, cb) {
          var err;
          if (cb != null && typeof cb === "function") {
            this.on("end", function(result) {
              this.reset();
              return cb(null, result);
            });
            this.on("error", function(err2) {
              this.reset();
              return cb(err2);
            });
          }
          try {
            str = str.toString();
            if (str.trim() === "") {
              this.emit("end", null);
              return true;
            }
            str = bom.stripBOM(str);
            if (this.options.async) {
              this.remaining = str;
              setImmediate2(this.processAsync);
              return this.saxParser;
            }
            return this.saxParser.write(str).close();
          } catch (error1) {
            err = error1;
            if (!(this.saxParser.errThrown || this.saxParser.ended)) {
              this.emit("error", err);
              return this.saxParser.errThrown = true;
            } else if (this.saxParser.ended) {
              throw err;
            }
          }
        };
        Parser.prototype.parseStringPromise = function(str) {
          return new Promise(/* @__PURE__ */ function(_this) {
            return function(resolve, reject) {
              return _this.parseString(str, function(err, value) {
                if (err) {
                  return reject(err);
                } else {
                  return resolve(value);
                }
              });
            };
          }(this));
        };
        return Parser;
      }(events);
      exports2.parseString = function(str, a, b) {
        var cb, options, parser;
        if (b != null) {
          if (typeof b === "function") {
            cb = b;
          }
          if (typeof a === "object") {
            options = a;
          }
        } else {
          if (typeof a === "function") {
            cb = a;
          }
          options = {};
        }
        parser = new exports2.Parser(options);
        return parser.parseString(str, cb);
      };
      exports2.parseStringPromise = function(str, a) {
        var options, parser;
        if (typeof a === "object") {
          options = a;
        }
        parser = new exports2.Parser(options);
        return parser.parseStringPromise(str);
      };
    }).call(exports2);
  }
});

// node_modules/xml2js/lib/xml2js.js
var require_xml2js = __commonJS({
  "node_modules/xml2js/lib/xml2js.js"(exports2) {
    "use strict";
    (function() {
      "use strict";
      var builder, defaults, parser, processors, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      defaults = require_defaults();
      builder = require_builder3();
      parser = require_parser2();
      processors = require_processors();
      exports2.defaults = defaults.defaults;
      exports2.processors = processors;
      exports2.ValidationError = function(superClass) {
        extend(ValidationError, superClass);
        function ValidationError(message) {
          this.message = message;
        }
        return ValidationError;
      }(Error);
      exports2.Builder = builder.Builder;
      exports2.Parser = parser.Parser;
      exports2.parseString = parser.parseString;
      exports2.parseStringPromise = parser.parseStringPromise;
    }).call(exports2);
  }
});

// node_modules/aws-sdk/lib/xml/node_parser.js
var require_node_parser = __commonJS({
  "node_modules/aws-sdk/lib/xml/node_parser.js"(exports2, module2) {
    "use strict";
    var AWS2 = require_core();
    var util = AWS2.util;
    var Shape = AWS2.Model.Shape;
    var xml2js = require_xml2js();
    var options = {
      // options passed to xml2js parser
      explicitCharkey: false,
      // undocumented
      trim: false,
      // trim the leading/trailing whitespace from text nodes
      normalize: false,
      // trim interior whitespace inside text nodes
      explicitRoot: false,
      // return the root node in the resulting object?
      emptyTag: null,
      // the default value for empty nodes
      explicitArray: true,
      // always put child nodes in an array
      ignoreAttrs: false,
      // ignore attributes, only create text nodes
      mergeAttrs: false,
      // merge attributes and child elements
      validator: null
      // a callable validator
    };
    function NodeXmlParser() {
    }
    NodeXmlParser.prototype.parse = function(xml, shape) {
      shape = shape || {};
      var result = null;
      var error = null;
      var parser = new xml2js.Parser(options);
      parser.parseString(xml, function(e, r) {
        error = e;
        result = r;
      });
      if (result) {
        var data = parseXml(result, shape);
        if (result.ResponseMetadata) {
          data.ResponseMetadata = parseXml(result.ResponseMetadata[0], {});
        }
        return data;
      } else if (error) {
        throw util.error(error, { code: "XMLParserError", retryable: true });
      } else {
        return parseXml({}, shape);
      }
    };
    function parseXml(xml, shape) {
      switch (shape.type) {
        case "structure":
          return parseStructure(xml, shape);
        case "map":
          return parseMap(xml, shape);
        case "list":
          return parseList(xml, shape);
        case void 0:
        case null:
          return parseUnknown(xml);
        default:
          return parseScalar(xml, shape);
      }
    }
    function parseStructure(xml, shape) {
      var data = {};
      if (xml === null)
        return data;
      util.each(shape.members, function(memberName, memberShape) {
        var xmlName = memberShape.name;
        if (Object.prototype.hasOwnProperty.call(xml, xmlName) && Array.isArray(xml[xmlName])) {
          var xmlChild = xml[xmlName];
          if (!memberShape.flattened)
            xmlChild = xmlChild[0];
          data[memberName] = parseXml(xmlChild, memberShape);
        } else if (memberShape.isXmlAttribute && xml.$ && Object.prototype.hasOwnProperty.call(xml.$, xmlName)) {
          data[memberName] = parseScalar(xml.$[xmlName], memberShape);
        } else if (memberShape.type === "list" && !shape.api.xmlNoDefaultLists) {
          data[memberName] = memberShape.defaultValue;
        }
      });
      return data;
    }
    function parseMap(xml, shape) {
      var data = {};
      if (xml === null)
        return data;
      var xmlKey = shape.key.name || "key";
      var xmlValue = shape.value.name || "value";
      var iterable = shape.flattened ? xml : xml.entry;
      if (Array.isArray(iterable)) {
        util.arrayEach(iterable, function(child) {
          data[child[xmlKey][0]] = parseXml(child[xmlValue][0], shape.value);
        });
      }
      return data;
    }
    function parseList(xml, shape) {
      var data = [];
      var name = shape.member.name || "member";
      if (shape.flattened) {
        util.arrayEach(xml, function(xmlChild) {
          data.push(parseXml(xmlChild, shape.member));
        });
      } else if (xml && Array.isArray(xml[name])) {
        util.arrayEach(xml[name], function(child) {
          data.push(parseXml(child, shape.member));
        });
      }
      return data;
    }
    function parseScalar(text, shape) {
      if (text && text.$ && text.$.encoding === "base64") {
        shape = new Shape.create({ type: text.$.encoding });
      }
      if (text && text._)
        text = text._;
      if (typeof shape.toType === "function") {
        return shape.toType(text);
      } else {
        return text;
      }
    }
    function parseUnknown(xml) {
      if (xml === void 0 || xml === null)
        return "";
      if (typeof xml === "string")
        return xml;
      if (Array.isArray(xml)) {
        var arr = [];
        for (i = 0; i < xml.length; i++) {
          arr.push(parseXml(xml[i], {}));
        }
        return arr;
      }
      var keys = Object.keys(xml), i;
      if (keys.length === 0 || keys.length === 1 && keys[0] === "$") {
        return {};
      }
      var data = {};
      for (i = 0; i < keys.length; i++) {
        var key = keys[i], value = xml[key];
        if (key === "$")
          continue;
        if (value.length > 1) {
          data[key] = parseList(value, { member: {} });
        } else {
          data[key] = parseXml(value[0], {});
        }
      }
      return data;
    }
    module2.exports = NodeXmlParser;
  }
});

// node_modules/aws-sdk/lib/http/node.js
var require_node = __commonJS({
  "node_modules/aws-sdk/lib/http/node.js"() {
    "use strict";
    var AWS2 = require_core();
    var Stream = AWS2.util.stream.Stream;
    var TransformStream = AWS2.util.stream.Transform;
    var ReadableStream = AWS2.util.stream.Readable;
    require_http();
    var CONNECTION_REUSE_ENV_NAME = "AWS_NODEJS_CONNECTION_REUSE_ENABLED";
    AWS2.NodeHttpClient = AWS2.util.inherit({
      handleRequest: function handleRequest(httpRequest, httpOptions, callback, errCallback) {
        var self2 = this;
        var endpoint = httpRequest.endpoint;
        var pathPrefix = "";
        if (!httpOptions)
          httpOptions = {};
        if (httpOptions.proxy) {
          pathPrefix = endpoint.protocol + "//" + endpoint.hostname;
          if (endpoint.port !== 80 && endpoint.port !== 443) {
            pathPrefix += ":" + endpoint.port;
          }
          endpoint = new AWS2.Endpoint(httpOptions.proxy);
        }
        var useSSL = endpoint.protocol === "https:";
        var http = useSSL ? require("https") : require("http");
        var options = {
          host: endpoint.hostname,
          port: endpoint.port,
          method: httpRequest.method,
          headers: httpRequest.headers,
          path: pathPrefix + httpRequest.path
        };
        AWS2.util.update(options, httpOptions);
        if (!httpOptions.agent) {
          options.agent = this.getAgent(useSSL, {
            keepAlive: process.env[CONNECTION_REUSE_ENV_NAME] === "1" ? true : false
          });
        }
        delete options.proxy;
        delete options.timeout;
        var stream = http.request(options, function(httpResp) {
          if (stream.didCallback)
            return;
          callback(httpResp);
          httpResp.emit(
            "headers",
            httpResp.statusCode,
            httpResp.headers,
            httpResp.statusMessage
          );
        });
        httpRequest.stream = stream;
        stream.didCallback = false;
        if (httpOptions.connectTimeout) {
          var connectTimeoutId;
          stream.on("socket", function(socket) {
            if (socket.connecting) {
              connectTimeoutId = setTimeout(function connectTimeout() {
                if (stream.didCallback)
                  return;
                stream.didCallback = true;
                stream.abort();
                errCallback(AWS2.util.error(
                  new Error("Socket timed out without establishing a connection"),
                  { code: "TimeoutError" }
                ));
              }, httpOptions.connectTimeout);
              socket.on("connect", function() {
                clearTimeout(connectTimeoutId);
                connectTimeoutId = null;
              });
            }
          });
        }
        stream.setTimeout(httpOptions.timeout || 0, function() {
          if (stream.didCallback)
            return;
          stream.didCallback = true;
          var msg = "Connection timed out after " + httpOptions.timeout + "ms";
          errCallback(AWS2.util.error(new Error(msg), { code: "TimeoutError" }));
          stream.abort();
        });
        stream.on("error", function(err) {
          if (connectTimeoutId) {
            clearTimeout(connectTimeoutId);
            connectTimeoutId = null;
          }
          if (stream.didCallback)
            return;
          stream.didCallback = true;
          if ("ECONNRESET" === err.code || "EPIPE" === err.code || "ETIMEDOUT" === err.code) {
            errCallback(AWS2.util.error(err, { code: "TimeoutError" }));
          } else {
            errCallback(err);
          }
        });
        var expect = httpRequest.headers.Expect || httpRequest.headers.expect;
        if (expect === "100-continue") {
          stream.once("continue", function() {
            self2.writeBody(stream, httpRequest);
          });
        } else {
          this.writeBody(stream, httpRequest);
        }
        return stream;
      },
      writeBody: function writeBody(stream, httpRequest) {
        var body = httpRequest.body;
        var totalBytes = parseInt(httpRequest.headers["Content-Length"], 10);
        if (body instanceof Stream) {
          var progressStream = this.progressStream(stream, totalBytes);
          if (progressStream) {
            body.pipe(progressStream).pipe(stream);
          } else {
            body.pipe(stream);
          }
        } else if (body) {
          stream.once("finish", function() {
            stream.emit("sendProgress", {
              loaded: totalBytes,
              total: totalBytes
            });
          });
          stream.end(body);
        } else {
          stream.end();
        }
      },
      /**
       * Create the https.Agent or http.Agent according to the request schema.
       */
      getAgent: function getAgent(useSSL, agentOptions) {
        var http = useSSL ? require("https") : require("http");
        if (useSSL) {
          if (!AWS2.NodeHttpClient.sslAgent) {
            AWS2.NodeHttpClient.sslAgent = new http.Agent(AWS2.util.merge({
              rejectUnauthorized: process.env.NODE_TLS_REJECT_UNAUTHORIZED === "0" ? false : true
            }, agentOptions || {}));
            AWS2.NodeHttpClient.sslAgent.setMaxListeners(0);
            Object.defineProperty(AWS2.NodeHttpClient.sslAgent, "maxSockets", {
              enumerable: true,
              get: function() {
                var defaultMaxSockets = 50;
                var globalAgent = http.globalAgent;
                if (globalAgent && globalAgent.maxSockets !== Infinity && typeof globalAgent.maxSockets === "number") {
                  return globalAgent.maxSockets;
                }
                return defaultMaxSockets;
              }
            });
          }
          return AWS2.NodeHttpClient.sslAgent;
        } else {
          if (!AWS2.NodeHttpClient.agent) {
            AWS2.NodeHttpClient.agent = new http.Agent(agentOptions);
          }
          return AWS2.NodeHttpClient.agent;
        }
      },
      progressStream: function progressStream(stream, totalBytes) {
        if (typeof TransformStream === "undefined") {
          return;
        }
        var loadedBytes = 0;
        var reporter = new TransformStream();
        reporter._transform = function(chunk, encoding, callback) {
          if (chunk) {
            loadedBytes += chunk.length;
            stream.emit("sendProgress", {
              loaded: loadedBytes,
              total: totalBytes
            });
          }
          callback(null, chunk);
        };
        return reporter;
      },
      emitter: null
    });
    AWS2.HttpClient.prototype = AWS2.NodeHttpClient.prototype;
    AWS2.HttpClient.streamsApiVersion = ReadableStream ? 2 : 1;
  }
});

// node_modules/aws-sdk/lib/credentials/token_file_web_identity_credentials.js
var require_token_file_web_identity_credentials = __commonJS({
  "node_modules/aws-sdk/lib/credentials/token_file_web_identity_credentials.js"() {
    "use strict";
    var AWS2 = require_core();
    var fs = require("fs");
    var STS2 = require_sts2();
    var iniLoader = AWS2.util.iniLoader;
    AWS2.TokenFileWebIdentityCredentials = AWS2.util.inherit(AWS2.Credentials, {
      /**
       * @example Creating a new credentials object
       *  AWS.config.credentials = new AWS.TokenFileWebIdentityCredentials(
       *   // optionally provide configuration to apply to the underlying AWS.STS service client
       *   // if configuration is not provided, then configuration will be pulled from AWS.config
       *   {
       *     // specify timeout options
       *     httpOptions: {
       *       timeout: 100
       *     }
       *   });
       * @see AWS.Config
       */
      constructor: function TokenFileWebIdentityCredentials(clientConfig) {
        AWS2.Credentials.call(this);
        this.data = null;
        this.clientConfig = AWS2.util.copy(clientConfig || {});
      },
      /**
       * Returns params from environment variables
       *
       * @api private
       */
      getParamsFromEnv: function getParamsFromEnv() {
        var ENV_TOKEN_FILE = "AWS_WEB_IDENTITY_TOKEN_FILE", ENV_ROLE_ARN = "AWS_ROLE_ARN";
        if (process.env[ENV_TOKEN_FILE] && process.env[ENV_ROLE_ARN]) {
          return [{
            envTokenFile: process.env[ENV_TOKEN_FILE],
            roleArn: process.env[ENV_ROLE_ARN],
            roleSessionName: process.env["AWS_ROLE_SESSION_NAME"]
          }];
        }
      },
      /**
       * Returns params from shared config variables
       *
       * @api private
       */
      getParamsFromSharedConfig: function getParamsFromSharedConfig() {
        var profiles = AWS2.util.getProfilesFromSharedConfig(iniLoader);
        var profileName = process.env.AWS_PROFILE || AWS2.util.defaultProfile;
        var profile = profiles[profileName] || {};
        if (Object.keys(profile).length === 0) {
          throw AWS2.util.error(
            new Error("Profile " + profileName + " not found"),
            { code: "TokenFileWebIdentityCredentialsProviderFailure" }
          );
        }
        var paramsArray = [];
        while (!profile["web_identity_token_file"] && profile["source_profile"]) {
          paramsArray.unshift({
            roleArn: profile["role_arn"],
            roleSessionName: profile["role_session_name"]
          });
          var sourceProfile = profile["source_profile"];
          profile = profiles[sourceProfile];
        }
        paramsArray.unshift({
          envTokenFile: profile["web_identity_token_file"],
          roleArn: profile["role_arn"],
          roleSessionName: profile["role_session_name"]
        });
        return paramsArray;
      },
      /**
       * Refreshes credentials using {AWS.STS.assumeRoleWithWebIdentity}
       *
       * @callback callback function(err)
       *   Called when the STS service responds (or fails). When
       *   this callback is called with no error, it means that the credentials
       *   information has been loaded into the object (as the `accessKeyId`,
       *   `secretAccessKey`, and `sessionToken` properties).
       *   @param err [Error] if an error occurred, this value will be filled
       * @see AWS.Credentials.get
       */
      refresh: function refresh(callback) {
        this.coalesceRefresh(callback || AWS2.util.fn.callback);
      },
      /**
       * @api private
      */
      assumeRoleChaining: function assumeRoleChaining(paramsArray, callback) {
        var self2 = this;
        if (paramsArray.length === 0) {
          self2.service.credentialsFrom(self2.data, self2);
          callback();
        } else {
          var params = paramsArray.shift();
          self2.service.config.credentials = self2.service.credentialsFrom(self2.data, self2);
          self2.service.assumeRole(
            {
              RoleArn: params.roleArn,
              RoleSessionName: params.roleSessionName || "token-file-web-identity"
            },
            function(err, data) {
              self2.data = null;
              if (err) {
                callback(err);
              } else {
                self2.data = data;
                self2.assumeRoleChaining(paramsArray, callback);
              }
            }
          );
        }
      },
      /**
       * @api private
       */
      load: function load(callback) {
        var self2 = this;
        try {
          var paramsArray = self2.getParamsFromEnv();
          if (!paramsArray) {
            paramsArray = self2.getParamsFromSharedConfig();
          }
          if (paramsArray) {
            var params = paramsArray.shift();
            var oidcToken = fs.readFileSync(params.envTokenFile, { encoding: "ascii" });
            if (!self2.service) {
              self2.createClients();
            }
            self2.service.assumeRoleWithWebIdentity(
              {
                WebIdentityToken: oidcToken,
                RoleArn: params.roleArn,
                RoleSessionName: params.roleSessionName || "token-file-web-identity"
              },
              function(err, data) {
                self2.data = null;
                if (err) {
                  callback(err);
                } else {
                  self2.data = data;
                  self2.assumeRoleChaining(paramsArray, callback);
                }
              }
            );
          }
        } catch (err) {
          callback(err);
        }
      },
      /**
       * @api private
       */
      createClients: function() {
        if (!this.service) {
          var stsConfig = AWS2.util.merge({}, this.clientConfig);
          this.service = new STS2(stsConfig);
          this.service.retryableError = function(error) {
            if (error.code === "IDPCommunicationErrorException" || error.code === "InvalidIdentityToken") {
              return true;
            } else {
              return AWS2.Service.prototype.retryableError.call(this, error);
            }
          };
        }
      }
    });
  }
});

// node_modules/aws-sdk/lib/metadata_service/get_endpoint.js
var require_get_endpoint = __commonJS({
  "node_modules/aws-sdk/lib/metadata_service/get_endpoint.js"(exports2, module2) {
    "use strict";
    var getEndpoint = function() {
      return {
        IPv4: "http://169.254.169.254",
        IPv6: "http://[fd00:ec2::254]"
      };
    };
    module2.exports = getEndpoint;
  }
});

// node_modules/aws-sdk/lib/metadata_service/get_endpoint_mode.js
var require_get_endpoint_mode = __commonJS({
  "node_modules/aws-sdk/lib/metadata_service/get_endpoint_mode.js"(exports2, module2) {
    "use strict";
    var getEndpointMode = function() {
      return {
        IPv4: "IPv4",
        IPv6: "IPv6"
      };
    };
    module2.exports = getEndpointMode;
  }
});

// node_modules/aws-sdk/lib/metadata_service/get_endpoint_config_options.js
var require_get_endpoint_config_options = __commonJS({
  "node_modules/aws-sdk/lib/metadata_service/get_endpoint_config_options.js"(exports2, module2) {
    "use strict";
    var ENV_ENDPOINT_NAME = "AWS_EC2_METADATA_SERVICE_ENDPOINT";
    var CONFIG_ENDPOINT_NAME = "ec2_metadata_service_endpoint";
    var getEndpointConfigOptions = function() {
      return {
        environmentVariableSelector: function(env) {
          return env[ENV_ENDPOINT_NAME];
        },
        configFileSelector: function(profile) {
          return profile[CONFIG_ENDPOINT_NAME];
        },
        default: void 0
      };
    };
    module2.exports = getEndpointConfigOptions;
  }
});

// node_modules/aws-sdk/lib/metadata_service/get_endpoint_mode_config_options.js
var require_get_endpoint_mode_config_options = __commonJS({
  "node_modules/aws-sdk/lib/metadata_service/get_endpoint_mode_config_options.js"(exports2, module2) {
    "use strict";
    var EndpointMode = require_get_endpoint_mode()();
    var ENV_ENDPOINT_MODE_NAME = "AWS_EC2_METADATA_SERVICE_ENDPOINT_MODE";
    var CONFIG_ENDPOINT_MODE_NAME = "ec2_metadata_service_endpoint_mode";
    var getEndpointModeConfigOptions = function() {
      return {
        environmentVariableSelector: function(env) {
          return env[ENV_ENDPOINT_MODE_NAME];
        },
        configFileSelector: function(profile) {
          return profile[CONFIG_ENDPOINT_MODE_NAME];
        },
        default: EndpointMode.IPv4
      };
    };
    module2.exports = getEndpointModeConfigOptions;
  }
});

// node_modules/aws-sdk/lib/metadata_service/get_metadata_service_endpoint.js
var require_get_metadata_service_endpoint = __commonJS({
  "node_modules/aws-sdk/lib/metadata_service/get_metadata_service_endpoint.js"(exports2, module2) {
    "use strict";
    var AWS2 = require_core();
    var Endpoint = require_get_endpoint()();
    var EndpointMode = require_get_endpoint_mode()();
    var ENDPOINT_CONFIG_OPTIONS = require_get_endpoint_config_options()();
    var ENDPOINT_MODE_CONFIG_OPTIONS = require_get_endpoint_mode_config_options()();
    var getMetadataServiceEndpoint = function() {
      var endpoint = AWS2.util.loadConfig(ENDPOINT_CONFIG_OPTIONS);
      if (endpoint !== void 0)
        return endpoint;
      var endpointMode = AWS2.util.loadConfig(ENDPOINT_MODE_CONFIG_OPTIONS);
      switch (endpointMode) {
        case EndpointMode.IPv4:
          return Endpoint.IPv4;
        case EndpointMode.IPv6:
          return Endpoint.IPv6;
        default:
          throw new Error("Unsupported endpoint mode: " + endpointMode);
      }
    };
    module2.exports = getMetadataServiceEndpoint;
  }
});

// node_modules/aws-sdk/lib/metadata_service.js
var require_metadata_service = __commonJS({
  "node_modules/aws-sdk/lib/metadata_service.js"(exports2, module2) {
    "use strict";
    var AWS2 = require_core();
    require_http();
    var inherit = AWS2.util.inherit;
    var getMetadataServiceEndpoint = require_get_metadata_service_endpoint();
    var URL = require("url").URL;
    AWS2.MetadataService = inherit({
      /**
       * @return [String] the endpoint of the instance metadata service
       */
      endpoint: getMetadataServiceEndpoint(),
      /**
       * @!ignore
       */
      /**
       * Default HTTP options. By default, the metadata service is set to not
       * timeout on long requests. This means that on non-EC2 machines, this
       * request will never return. If you are calling this operation from an
       * environment that may not always run on EC2, set a `timeout` value so
       * the SDK will abort the request after a given number of milliseconds.
       */
      httpOptions: { timeout: 0 },
      /**
       * when enabled, metadata service will not fetch token
       */
      disableFetchToken: false,
      /**
       * Creates a new MetadataService object with a given set of options.
       *
       * @option options host [String] the hostname of the instance metadata
       *   service
       * @option options httpOptions [map] a map of options to pass to the
       *   underlying HTTP request:
       *
       *   * **timeout** (Number) &mdash; a timeout value in milliseconds to wait
       *     before aborting the connection. Set to 0 for no timeout.
       * @option options maxRetries [Integer] the maximum number of retries to
       *   perform for timeout errors
       * @option options retryDelayOptions [map] A set of options to configure the
       *   retry delay on retryable errors. See AWS.Config for details.
       * @option options ec2MetadataV1Disabled [boolean] Whether to block IMDS v1 fallback.
       * @option options profile [string] A profile to check for IMDSv1 fallback settings.
       * @option options filename [string] Optional filename for the config file.
       */
      constructor: function MetadataService(options) {
        if (options && options.host) {
          options.endpoint = "http://" + options.host;
          delete options.host;
        }
        this.profile = options && options.profile || process.env.AWS_PROFILE || AWS2.util.defaultProfile;
        this.ec2MetadataV1Disabled = !!(options && options.ec2MetadataV1Disabled);
        this.filename = options && options.filename;
        AWS2.util.update(this, options);
      },
      /**
       * Sends a request to the instance metadata service for a given resource.
       *
       * @param path [String] the path of the resource to get
       *
       * @param options [map] an optional map used to make request
       *
       *   * **method** (String) &mdash; HTTP request method
       *
       *   * **headers** (map<String,String>) &mdash; a map of response header keys and their respective values
       *
       * @callback callback function(err, data)
       *   Called when a response is available from the service.
       *   @param err [Error, null] if an error occurred, this value will be set
       *   @param data [String, null] if the request was successful, the body of
       *     the response
       */
      request: function request(path, options, callback) {
        if (arguments.length === 2) {
          callback = options;
          options = {};
        }
        if (process.env[AWS2.util.imdsDisabledEnv]) {
          callback(new Error("EC2 Instance Metadata Service access disabled"));
          return;
        }
        path = path || "/";
        if (URL) {
          new URL(this.endpoint);
        }
        var httpRequest = new AWS2.HttpRequest(this.endpoint + path);
        httpRequest.method = options.method || "GET";
        if (options.headers) {
          httpRequest.headers = options.headers;
        }
        AWS2.util.handleRequestWithRetries(httpRequest, this, callback);
      },
      /**
      * @api private
      */
      loadCredentialsCallbacks: [],
      /**
       * Fetches metadata token used for getting credentials
       *
       * @api private
       * @callback callback function(err, token)
       *   Called when token is loaded from the resource
       */
      fetchMetadataToken: function fetchMetadataToken(callback) {
        var self2 = this;
        var tokenFetchPath = "/latest/api/token";
        self2.request(
          tokenFetchPath,
          {
            "method": "PUT",
            "headers": {
              "x-aws-ec2-metadata-token-ttl-seconds": "21600"
            }
          },
          callback
        );
      },
      /**
       * Fetches credentials
       *
       * @api private
       * @callback cb function(err, creds)
       *   Called when credentials are loaded from the resource
       */
      fetchCredentials: function fetchCredentials(options, cb) {
        var self2 = this;
        var basePath = "/latest/meta-data/iam/security-credentials/";
        var isImdsV1Fallback = self2.disableFetchToken || !(options && options.headers && options.headers["x-aws-ec2-metadata-token"]);
        if (isImdsV1Fallback && !process.env.AWS_EC2_METADATA_DISABLED) {
          try {
            var profiles = AWS2.util.getProfilesFromSharedConfig(AWS2.util.iniLoader, this.filename);
            var profileSettings = profiles[this.profile] || {};
          } catch (e) {
            profileSettings = {};
          }
          if (profileSettings.ec2_metadata_v1_disabled && profileSettings.ec2_metadata_v1_disabled !== "false") {
            return cb(AWS2.util.error(
              new Error("AWS EC2 Metadata v1 fallback has been blocked by AWS config file profile.")
            ));
          }
          if (self2.ec2MetadataV1Disabled) {
            return cb(AWS2.util.error(
              new Error("AWS EC2 Metadata v1 fallback has been blocked by AWS.MetadataService::options.ec2MetadataV1Disabled=true.")
            ));
          }
          if (process.env.AWS_EC2_METADATA_V1_DISABLED && process.env.AWS_EC2_METADATA_V1_DISABLED !== "false") {
            return cb(AWS2.util.error(
              new Error("AWS EC2 Metadata v1 fallback has been blocked by process.env.AWS_EC2_METADATA_V1_DISABLED.")
            ));
          }
        }
        self2.request(basePath, options, function(err, roleName) {
          if (err) {
            self2.disableFetchToken = !(err.statusCode === 401);
            cb(AWS2.util.error(
              err,
              {
                message: "EC2 Metadata roleName request returned error"
              }
            ));
            return;
          }
          roleName = roleName.split("\n")[0];
          self2.request(basePath + roleName, options, function(credErr, credData) {
            if (credErr) {
              self2.disableFetchToken = !(credErr.statusCode === 401);
              cb(AWS2.util.error(
                credErr,
                {
                  message: "EC2 Metadata creds request returned error"
                }
              ));
              return;
            }
            try {
              var credentials = JSON.parse(credData);
              cb(null, credentials);
            } catch (parseError) {
              cb(parseError);
            }
          });
        });
      },
      /**
       * Loads a set of credentials stored in the instance metadata service
       *
       * @api private
       * @callback callback function(err, credentials)
       *   Called when credentials are loaded from the resource
       *   @param err [Error] if an error occurred, this value will be set
       *   @param credentials [Object] the raw JSON object containing all
       *     metadata from the credentials resource
       */
      loadCredentials: function loadCredentials(callback) {
        var self2 = this;
        self2.loadCredentialsCallbacks.push(callback);
        if (self2.loadCredentialsCallbacks.length > 1) {
          return;
        }
        function callbacks(err, creds) {
          var cb;
          while ((cb = self2.loadCredentialsCallbacks.shift()) !== void 0) {
            cb(err, creds);
          }
        }
        if (self2.disableFetchToken) {
          self2.fetchCredentials({}, callbacks);
        } else {
          self2.fetchMetadataToken(function(tokenError, token) {
            if (tokenError) {
              if (tokenError.code === "TimeoutError") {
                self2.disableFetchToken = true;
              } else if (tokenError.retryable === true) {
                callbacks(AWS2.util.error(
                  tokenError,
                  {
                    message: "EC2 Metadata token request returned error"
                  }
                ));
                return;
              } else if (tokenError.statusCode === 400) {
                callbacks(AWS2.util.error(
                  tokenError,
                  {
                    message: "EC2 Metadata token request returned 400"
                  }
                ));
                return;
              }
            }
            var options = {};
            if (token) {
              options.headers = {
                "x-aws-ec2-metadata-token": token
              };
            }
            self2.fetchCredentials(options, callbacks);
          });
        }
      }
    });
    module2.exports = AWS2.MetadataService;
  }
});

// node_modules/aws-sdk/lib/credentials/ec2_metadata_credentials.js
var require_ec2_metadata_credentials = __commonJS({
  "node_modules/aws-sdk/lib/credentials/ec2_metadata_credentials.js"() {
    "use strict";
    var AWS2 = require_core();
    require_metadata_service();
    AWS2.EC2MetadataCredentials = AWS2.util.inherit(AWS2.Credentials, {
      constructor: function EC2MetadataCredentials(options) {
        AWS2.Credentials.call(this);
        options = options ? AWS2.util.copy(options) : {};
        options = AWS2.util.merge(
          { maxRetries: this.defaultMaxRetries },
          options
        );
        if (!options.httpOptions)
          options.httpOptions = {};
        options.httpOptions = AWS2.util.merge(
          {
            timeout: this.defaultTimeout,
            connectTimeout: this.defaultConnectTimeout
          },
          options.httpOptions
        );
        this.metadataService = new AWS2.MetadataService(options);
        this.logger = options.logger || AWS2.config && AWS2.config.logger;
      },
      /**
       * @api private
       */
      defaultTimeout: 1e3,
      /**
      * @api private
      */
      defaultConnectTimeout: 1e3,
      /**
       * @api private
       */
      defaultMaxRetries: 3,
      /**
       * The original expiration of the current credential. In case of AWS
       * outage, the EC2 metadata will extend expiration of the existing
       * credential.
       */
      originalExpiration: void 0,
      /**
       * Loads the credentials from the instance metadata service
       *
       * @callback callback function(err)
       *   Called when the instance metadata service responds (or fails). When
       *   this callback is called with no error, it means that the credentials
       *   information has been loaded into the object (as the `accessKeyId`,
       *   `secretAccessKey`, and `sessionToken` properties).
       *   @param err [Error] if an error occurred, this value will be filled
       * @see get
       */
      refresh: function refresh(callback) {
        this.coalesceRefresh(callback || AWS2.util.fn.callback);
      },
      /**
       * @api private
       * @param callback
       */
      load: function load(callback) {
        var self2 = this;
        self2.metadataService.loadCredentials(function(err, creds) {
          if (err) {
            if (self2.hasLoadedCredentials()) {
              self2.extendExpirationIfExpired();
              callback();
            } else {
              callback(err);
            }
          } else {
            self2.setCredentials(creds);
            self2.extendExpirationIfExpired();
            callback();
          }
        });
      },
      /**
       * Whether this credential has been loaded.
       * @api private
       */
      hasLoadedCredentials: function hasLoadedCredentials() {
        return this.AccessKeyId && this.secretAccessKey;
      },
      /**
       * if expired, extend the expiration by 15 minutes base plus a jitter of 5
       * minutes range.
       * @api private
       */
      extendExpirationIfExpired: function extendExpirationIfExpired() {
        if (this.needsRefresh()) {
          this.originalExpiration = this.originalExpiration || this.expireTime;
          this.expired = false;
          var nextTimeout = 15 * 60 + Math.floor(Math.random() * 5 * 60);
          var currentTime = AWS2.util.date.getDate().getTime();
          this.expireTime = new Date(currentTime + nextTimeout * 1e3);
          this.logger.warn("Attempting credential expiration extension due to a credential service availability issue. A refresh of these credentials will be attempted again at " + this.expireTime + "\nFor more information, please visit: https://docs.aws.amazon.com/sdkref/latest/guide/feature-static-credentials.html");
        }
      },
      /**
       * Update the credential with new credential responded from EC2 metadata
       * service.
       * @api private
       */
      setCredentials: function setCredentials(creds) {
        var currentTime = AWS2.util.date.getDate().getTime();
        var expireTime = new Date(creds.Expiration);
        this.expired = currentTime >= expireTime ? true : false;
        this.metadata = creds;
        this.accessKeyId = creds.AccessKeyId;
        this.secretAccessKey = creds.SecretAccessKey;
        this.sessionToken = creds.Token;
        this.expireTime = expireTime;
      }
    });
  }
});

// node_modules/aws-sdk/lib/credentials/remote_credentials.js
var require_remote_credentials = __commonJS({
  "node_modules/aws-sdk/lib/credentials/remote_credentials.js"() {
    "use strict";
    var AWS2 = require_core();
    var ENV_RELATIVE_URI = "AWS_CONTAINER_CREDENTIALS_RELATIVE_URI";
    var ENV_FULL_URI = "AWS_CONTAINER_CREDENTIALS_FULL_URI";
    var ENV_AUTH_TOKEN = "AWS_CONTAINER_AUTHORIZATION_TOKEN";
    var FULL_URI_UNRESTRICTED_PROTOCOLS = ["https:"];
    var FULL_URI_ALLOWED_PROTOCOLS = ["http:", "https:"];
    var FULL_URI_ALLOWED_HOSTNAMES = ["localhost", "127.0.0.1"];
    var RELATIVE_URI_HOST = "169.254.170.2";
    AWS2.RemoteCredentials = AWS2.util.inherit(AWS2.Credentials, {
      constructor: function RemoteCredentials(options) {
        AWS2.Credentials.call(this);
        options = options ? AWS2.util.copy(options) : {};
        if (!options.httpOptions)
          options.httpOptions = {};
        options.httpOptions = AWS2.util.merge(
          this.httpOptions,
          options.httpOptions
        );
        AWS2.util.update(this, options);
      },
      /**
       * @api private
       */
      httpOptions: { timeout: 1e3 },
      /**
       * @api private
       */
      maxRetries: 3,
      /**
       * @api private
       */
      isConfiguredForEcsCredentials: function isConfiguredForEcsCredentials() {
        return Boolean(
          process && process.env && (process.env[ENV_RELATIVE_URI] || process.env[ENV_FULL_URI])
        );
      },
      /**
       * @api private
       */
      getECSFullUri: function getECSFullUri() {
        if (process && process.env) {
          var relative = process.env[ENV_RELATIVE_URI], full = process.env[ENV_FULL_URI];
          if (relative) {
            return "http://" + RELATIVE_URI_HOST + relative;
          } else if (full) {
            var parsed = AWS2.util.urlParse(full);
            if (FULL_URI_ALLOWED_PROTOCOLS.indexOf(parsed.protocol) < 0) {
              throw AWS2.util.error(
                new Error("Unsupported protocol:  AWS.RemoteCredentials supports " + FULL_URI_ALLOWED_PROTOCOLS.join(",") + " only; " + parsed.protocol + " requested."),
                { code: "ECSCredentialsProviderFailure" }
              );
            }
            if (FULL_URI_UNRESTRICTED_PROTOCOLS.indexOf(parsed.protocol) < 0 && FULL_URI_ALLOWED_HOSTNAMES.indexOf(parsed.hostname) < 0) {
              throw AWS2.util.error(
                new Error("Unsupported hostname: AWS.RemoteCredentials only supports " + FULL_URI_ALLOWED_HOSTNAMES.join(",") + " for " + parsed.protocol + "; " + parsed.protocol + "//" + parsed.hostname + " requested."),
                { code: "ECSCredentialsProviderFailure" }
              );
            }
            return full;
          } else {
            throw AWS2.util.error(
              new Error("Variable " + ENV_RELATIVE_URI + " or " + ENV_FULL_URI + " must be set to use AWS.RemoteCredentials."),
              { code: "ECSCredentialsProviderFailure" }
            );
          }
        } else {
          throw AWS2.util.error(
            new Error("No process info available"),
            { code: "ECSCredentialsProviderFailure" }
          );
        }
      },
      /**
       * @api private
       */
      getECSAuthToken: function getECSAuthToken() {
        if (process && process.env && process.env[ENV_FULL_URI]) {
          return process.env[ENV_AUTH_TOKEN];
        }
      },
      /**
       * @api private
       */
      credsFormatIsValid: function credsFormatIsValid(credData) {
        return !!credData.accessKeyId && !!credData.secretAccessKey && !!credData.sessionToken && !!credData.expireTime;
      },
      /**
       * @api private
       */
      formatCreds: function formatCreds(credData) {
        if (!!credData.credentials) {
          credData = credData.credentials;
        }
        return {
          expired: false,
          accessKeyId: credData.accessKeyId || credData.AccessKeyId,
          secretAccessKey: credData.secretAccessKey || credData.SecretAccessKey,
          sessionToken: credData.sessionToken || credData.Token,
          expireTime: new Date(credData.expiration || credData.Expiration)
        };
      },
      /**
       * @api private
       */
      request: function request(url, callback) {
        var httpRequest = new AWS2.HttpRequest(url);
        httpRequest.method = "GET";
        httpRequest.headers.Accept = "application/json";
        var token = this.getECSAuthToken();
        if (token) {
          httpRequest.headers.Authorization = token;
        }
        AWS2.util.handleRequestWithRetries(httpRequest, this, callback);
      },
      /**
       * Loads the credentials from the relative URI specified by container
       *
       * @callback callback function(err)
       *   Called when the request to the relative URI responds (or fails). When
       *   this callback is called with no error, it means that the credentials
       *   information has been loaded into the object (as the `accessKeyId`,
       *   `secretAccessKey`, `sessionToken`, and `expireTime` properties).
       *   @param err [Error] if an error occurred, this value will be filled
       * @see get
       */
      refresh: function refresh(callback) {
        this.coalesceRefresh(callback || AWS2.util.fn.callback);
      },
      /**
       * @api private
       */
      load: function load(callback) {
        var self2 = this;
        var fullUri;
        try {
          fullUri = this.getECSFullUri();
        } catch (err) {
          callback(err);
          return;
        }
        this.request(fullUri, function(err, data) {
          if (!err) {
            try {
              data = JSON.parse(data);
              var creds = self2.formatCreds(data);
              if (!self2.credsFormatIsValid(creds)) {
                throw AWS2.util.error(
                  new Error("Response data is not in valid format"),
                  { code: "ECSCredentialsProviderFailure" }
                );
              }
              AWS2.util.update(self2, creds);
            } catch (dataError) {
              err = dataError;
            }
          }
          callback(err, creds);
        });
      }
    });
  }
});

// node_modules/aws-sdk/lib/credentials/ecs_credentials.js
var require_ecs_credentials = __commonJS({
  "node_modules/aws-sdk/lib/credentials/ecs_credentials.js"() {
    "use strict";
    var AWS2 = require_core();
    AWS2.ECSCredentials = AWS2.RemoteCredentials;
  }
});

// node_modules/aws-sdk/lib/credentials/environment_credentials.js
var require_environment_credentials = __commonJS({
  "node_modules/aws-sdk/lib/credentials/environment_credentials.js"() {
    "use strict";
    var AWS2 = require_core();
    AWS2.EnvironmentCredentials = AWS2.util.inherit(AWS2.Credentials, {
      /**
       * Creates a new EnvironmentCredentials class with a given variable
       * prefix {envPrefix}. For example, to load credentials using the 'AWS'
       * prefix:
       *
       * ```javascript
       * var creds = new AWS.EnvironmentCredentials('AWS');
       * creds.accessKeyId == 'AKID' // from AWS_ACCESS_KEY_ID env var
       * ```
       *
       * @param envPrefix [String] the prefix to use (e.g., 'AWS') for environment
       *   variables. Do not include the separating underscore.
       */
      constructor: function EnvironmentCredentials(envPrefix) {
        AWS2.Credentials.call(this);
        this.envPrefix = envPrefix;
        this.get(function() {
        });
      },
      /**
       * Loads credentials from the environment using the prefixed
       * environment variables.
       *
       * @callback callback function(err)
       *   Called after the (prefixed) ACCESS_KEY_ID, SECRET_ACCESS_KEY, and
       *   SESSION_TOKEN environment variables are read. When this callback is
       *   called with no error, it means that the credentials information has
       *   been loaded into the object (as the `accessKeyId`, `secretAccessKey`,
       *   and `sessionToken` properties).
       *   @param err [Error] if an error occurred, this value will be filled
       * @see get
       */
      refresh: function refresh(callback) {
        if (!callback)
          callback = AWS2.util.fn.callback;
        if (!process || !process.env) {
          callback(AWS2.util.error(
            new Error("No process info or environment variables available"),
            { code: "EnvironmentCredentialsProviderFailure" }
          ));
          return;
        }
        var keys = ["ACCESS_KEY_ID", "SECRET_ACCESS_KEY", "SESSION_TOKEN"];
        var values = [];
        for (var i = 0; i < keys.length; i++) {
          var prefix = "";
          if (this.envPrefix)
            prefix = this.envPrefix + "_";
          values[i] = process.env[prefix + keys[i]];
          if (!values[i] && keys[i] !== "SESSION_TOKEN") {
            callback(AWS2.util.error(
              new Error("Variable " + prefix + keys[i] + " not set."),
              { code: "EnvironmentCredentialsProviderFailure" }
            ));
            return;
          }
        }
        this.expired = false;
        AWS2.Credentials.apply(this, values);
        callback();
      }
    });
  }
});

// node_modules/aws-sdk/lib/credentials/file_system_credentials.js
var require_file_system_credentials = __commonJS({
  "node_modules/aws-sdk/lib/credentials/file_system_credentials.js"() {
    "use strict";
    var AWS2 = require_core();
    AWS2.FileSystemCredentials = AWS2.util.inherit(AWS2.Credentials, {
      /**
       * @overload AWS.FileSystemCredentials(filename)
       *   Creates a new FileSystemCredentials object from a filename
       *
       *   @param filename [String] the path on disk to the JSON file to load.
       */
      constructor: function FileSystemCredentials(filename) {
        AWS2.Credentials.call(this);
        this.filename = filename;
        this.get(function() {
        });
      },
      /**
       * Loads the credentials from the {filename} on disk.
       *
       * @callback callback function(err)
       *   Called after the JSON file on disk is read and parsed. When this callback
       *   is called with no error, it means that the credentials information
       *   has been loaded into the object (as the `accessKeyId`, `secretAccessKey`,
       *   and `sessionToken` properties).
       *   @param err [Error] if an error occurred, this value will be filled
       * @see get
       */
      refresh: function refresh(callback) {
        if (!callback)
          callback = AWS2.util.fn.callback;
        try {
          var creds = JSON.parse(AWS2.util.readFileSync(this.filename));
          AWS2.Credentials.call(this, creds);
          if (!this.accessKeyId || !this.secretAccessKey) {
            throw AWS2.util.error(
              new Error("Credentials not set in " + this.filename),
              { code: "FileSystemCredentialsProviderFailure" }
            );
          }
          this.expired = false;
          callback();
        } catch (err) {
          callback(err);
        }
      }
    });
  }
});

// node_modules/aws-sdk/lib/credentials/shared_ini_file_credentials.js
var require_shared_ini_file_credentials = __commonJS({
  "node_modules/aws-sdk/lib/credentials/shared_ini_file_credentials.js"() {
    "use strict";
    var AWS2 = require_core();
    var STS2 = require_sts2();
    var iniLoader = AWS2.util.iniLoader;
    var ASSUME_ROLE_DEFAULT_REGION = "us-east-1";
    AWS2.SharedIniFileCredentials = AWS2.util.inherit(AWS2.Credentials, {
      /**
       * Creates a new SharedIniFileCredentials object.
       *
       * @param options [map] a set of options
       * @option options profile [String] (AWS_PROFILE env var or 'default')
       *   the name of the profile to load.
       * @option options filename [String] ('~/.aws/credentials' or defined by
       *   AWS_SHARED_CREDENTIALS_FILE process env var)
       *   the filename to use when loading credentials.
       * @option options disableAssumeRole [Boolean] (false) True to disable
       *   support for profiles that assume an IAM role. If true, and an assume
       *   role profile is selected, an error is raised.
       * @option options preferStaticCredentials [Boolean] (false) True to
       *   prefer static credentials to role_arn if both are present.
       * @option options tokenCodeFn [Function] (null) Function to provide
       *   STS Assume Role TokenCode, if mfa_serial is provided for profile in ini
       *   file. Function is called with value of mfa_serial and callback, and
       *   should provide the TokenCode or an error to the callback in the format
       *   callback(err, token)
       * @option options callback [Function] (err) Credentials are eagerly loaded
       *   by the constructor. When the callback is called with no error, the
       *   credentials have been loaded successfully.
       * @option options httpOptions [map] A set of options to pass to the low-level
       *   HTTP request. Currently supported options are:
       *   * **proxy** [String] &mdash; the URL to proxy requests through
       *   * **agent** [http.Agent, https.Agent] &mdash; the Agent object to perform
       *     HTTP requests with. Used for connection pooling. Defaults to the global
       *     agent (`http.globalAgent`) for non-SSL connections. Note that for
       *     SSL connections, a special Agent object is used in order to enable
       *     peer certificate verification. This feature is only available in the
       *     Node.js environment.
       *   * **connectTimeout** [Integer] &mdash; Sets the socket to timeout after
       *     failing to establish a connection with the server after
       *     `connectTimeout` milliseconds. This timeout has no effect once a socket
       *     connection has been established.
       *   * **timeout** [Integer] &mdash; The number of milliseconds a request can
       *     take before automatically being terminated.
       *     Defaults to two minutes (120000).
       */
      constructor: function SharedIniFileCredentials(options) {
        AWS2.Credentials.call(this);
        options = options || {};
        this.filename = options.filename;
        this.profile = options.profile || process.env.AWS_PROFILE || AWS2.util.defaultProfile;
        this.disableAssumeRole = Boolean(options.disableAssumeRole);
        this.preferStaticCredentials = Boolean(options.preferStaticCredentials);
        this.tokenCodeFn = options.tokenCodeFn || null;
        this.httpOptions = options.httpOptions || null;
        this.get(options.callback || AWS2.util.fn.noop);
      },
      /**
       * @api private
       */
      load: function load(callback) {
        var self2 = this;
        try {
          var profiles = AWS2.util.getProfilesFromSharedConfig(iniLoader, this.filename);
          var profile = profiles[this.profile] || {};
          if (Object.keys(profile).length === 0) {
            throw AWS2.util.error(
              new Error("Profile " + this.profile + " not found"),
              { code: "SharedIniFileCredentialsProviderFailure" }
            );
          }
          var preferStaticCredentialsToRoleArn = Boolean(
            this.preferStaticCredentials && profile["aws_access_key_id"] && profile["aws_secret_access_key"]
          );
          if (profile["role_arn"] && !preferStaticCredentialsToRoleArn) {
            this.loadRoleProfile(profiles, profile, function(err, data) {
              if (err) {
                callback(err);
              } else {
                self2.expired = false;
                self2.accessKeyId = data.Credentials.AccessKeyId;
                self2.secretAccessKey = data.Credentials.SecretAccessKey;
                self2.sessionToken = data.Credentials.SessionToken;
                self2.expireTime = data.Credentials.Expiration;
                callback(null);
              }
            });
            return;
          }
          this.accessKeyId = profile["aws_access_key_id"];
          this.secretAccessKey = profile["aws_secret_access_key"];
          this.sessionToken = profile["aws_session_token"];
          if (!this.accessKeyId || !this.secretAccessKey) {
            throw AWS2.util.error(
              new Error("Credentials not set for profile " + this.profile),
              { code: "SharedIniFileCredentialsProviderFailure" }
            );
          }
          this.expired = false;
          callback(null);
        } catch (err) {
          callback(err);
        }
      },
      /**
       * Loads the credentials from the shared credentials file
       *
       * @callback callback function(err)
       *   Called after the shared INI file on disk is read and parsed. When this
       *   callback is called with no error, it means that the credentials
       *   information has been loaded into the object (as the `accessKeyId`,
       *   `secretAccessKey`, and `sessionToken` properties).
       *   @param err [Error] if an error occurred, this value will be filled
       * @see get
       */
      refresh: function refresh(callback) {
        iniLoader.clearCachedFiles();
        this.coalesceRefresh(
          callback || AWS2.util.fn.callback,
          this.disableAssumeRole
        );
      },
      /**
       * @api private
       */
      loadRoleProfile: function loadRoleProfile(creds, roleProfile, callback) {
        if (this.disableAssumeRole) {
          throw AWS2.util.error(
            new Error("Role assumption profiles are disabled. Failed to load profile " + this.profile + " from " + creds.filename),
            { code: "SharedIniFileCredentialsProviderFailure" }
          );
        }
        var self2 = this;
        var roleArn = roleProfile["role_arn"];
        var roleSessionName = roleProfile["role_session_name"];
        var externalId = roleProfile["external_id"];
        var mfaSerial = roleProfile["mfa_serial"];
        var sourceProfileName = roleProfile["source_profile"];
        var durationSeconds = parseInt(roleProfile["duration_seconds"], 10) || void 0;
        var profileRegion = roleProfile["region"] || ASSUME_ROLE_DEFAULT_REGION;
        if (!sourceProfileName) {
          throw AWS2.util.error(
            new Error("source_profile is not set using profile " + this.profile),
            { code: "SharedIniFileCredentialsProviderFailure" }
          );
        }
        var sourceProfileExistanceTest = creds[sourceProfileName];
        if (typeof sourceProfileExistanceTest !== "object") {
          throw AWS2.util.error(
            new Error("source_profile " + sourceProfileName + " using profile " + this.profile + " does not exist"),
            { code: "SharedIniFileCredentialsProviderFailure" }
          );
        }
        var sourceCredentials = new AWS2.SharedIniFileCredentials(
          AWS2.util.merge(this.options || {}, {
            profile: sourceProfileName,
            preferStaticCredentials: true
          })
        );
        this.roleArn = roleArn;
        var sts = new STS2({
          credentials: sourceCredentials,
          region: profileRegion,
          httpOptions: this.httpOptions
        });
        var roleParams = {
          DurationSeconds: durationSeconds,
          RoleArn: roleArn,
          RoleSessionName: roleSessionName || "aws-sdk-js-" + Date.now()
        };
        if (externalId) {
          roleParams.ExternalId = externalId;
        }
        if (mfaSerial && self2.tokenCodeFn) {
          roleParams.SerialNumber = mfaSerial;
          self2.tokenCodeFn(mfaSerial, function(err, token) {
            if (err) {
              var message;
              if (err instanceof Error) {
                message = err.message;
              } else {
                message = err;
              }
              callback(
                AWS2.util.error(
                  new Error("Error fetching MFA token: " + message),
                  { code: "SharedIniFileCredentialsProviderFailure" }
                )
              );
              return;
            }
            roleParams.TokenCode = token;
            sts.assumeRole(roleParams, callback);
          });
          return;
        }
        sts.assumeRole(roleParams, callback);
      }
    });
  }
});

// node_modules/aws-sdk/lib/credentials/sso_credentials.js
var require_sso_credentials = __commonJS({
  "node_modules/aws-sdk/lib/credentials/sso_credentials.js"() {
    "use strict";
    var AWS2 = require_core();
    var path = require("path");
    var crypto = require("crypto");
    var iniLoader = AWS2.util.iniLoader;
    AWS2.SsoCredentials = AWS2.util.inherit(AWS2.Credentials, {
      /**
       * Creates a new SsoCredentials object.
       *
       * @param options [map] a set of options
       * @option options profile [String] (AWS_PROFILE env var or 'default')
       *   the name of the profile to load.
       * @option options filename [String] ('~/.aws/credentials' or defined by
       *   AWS_SHARED_CREDENTIALS_FILE process env var)
       *   the filename to use when loading credentials.
       * @option options callback [Function] (err) Credentials are eagerly loaded
       *   by the constructor. When the callback is called with no error, the
       *   credentials have been loaded successfully.
       */
      constructor: function SsoCredentials(options) {
        AWS2.Credentials.call(this);
        options = options || {};
        this.errorCode = "SsoCredentialsProviderFailure";
        this.expired = true;
        this.filename = options.filename;
        this.profile = options.profile || process.env.AWS_PROFILE || AWS2.util.defaultProfile;
        this.service = options.ssoClient;
        this.httpOptions = options.httpOptions || null;
        this.get(options.callback || AWS2.util.fn.noop);
      },
      /**
       * @api private
       */
      load: function load(callback) {
        var self2 = this;
        try {
          var profiles = AWS2.util.getProfilesFromSharedConfig(iniLoader, this.filename);
          var profile = profiles[this.profile] || {};
          if (Object.keys(profile).length === 0) {
            throw AWS2.util.error(
              new Error("Profile " + this.profile + " not found"),
              { code: self2.errorCode }
            );
          }
          if (profile.sso_session) {
            if (!profile.sso_account_id || !profile.sso_role_name) {
              throw AWS2.util.error(
                new Error("Profile " + this.profile + " with session " + profile.sso_session + ' does not have valid SSO credentials. Required parameters "sso_account_id", "sso_session", "sso_role_name". Reference: https://docs.aws.amazon.com/cli/latest/userguide/cli-configure-sso.html'),
                { code: self2.errorCode }
              );
            }
          } else {
            if (!profile.sso_start_url || !profile.sso_account_id || !profile.sso_region || !profile.sso_role_name) {
              throw AWS2.util.error(
                new Error("Profile " + this.profile + ' does not have valid SSO credentials. Required parameters "sso_account_id", "sso_region", "sso_role_name", "sso_start_url". Reference: https://docs.aws.amazon.com/cli/latest/userguide/cli-configure-sso.html'),
                { code: self2.errorCode }
              );
            }
          }
          this.getToken(this.profile, profile, function(err, token) {
            if (err) {
              return callback(err);
            }
            var request = {
              accessToken: token,
              accountId: profile.sso_account_id,
              roleName: profile.sso_role_name
            };
            if (!self2.service || self2.service.config.region !== profile.sso_region) {
              self2.service = new AWS2.SSO({
                region: profile.sso_region,
                httpOptions: self2.httpOptions
              });
            }
            self2.service.getRoleCredentials(request, function(err2, data) {
              if (err2 || !data || !data.roleCredentials) {
                callback(AWS2.util.error(
                  err2 || new Error('Please log in using "aws sso login"'),
                  { code: self2.errorCode }
                ), null);
              } else if (!data.roleCredentials.accessKeyId || !data.roleCredentials.secretAccessKey || !data.roleCredentials.sessionToken || !data.roleCredentials.expiration) {
                throw AWS2.util.error(new Error(
                  "SSO returns an invalid temporary credential."
                ));
              } else {
                self2.expired = false;
                self2.accessKeyId = data.roleCredentials.accessKeyId;
                self2.secretAccessKey = data.roleCredentials.secretAccessKey;
                self2.sessionToken = data.roleCredentials.sessionToken;
                self2.expireTime = new Date(data.roleCredentials.expiration);
                callback(null);
              }
            });
          });
        } catch (err) {
          callback(err);
        }
      },
      /**
       * @private
       * Uses legacy file system retrieval or if sso-session is set,
       * use the SSOTokenProvider.
       *
       * @param {string} profileName - name of the profile.
       * @param {object} profile - profile data containing sso_session or sso_start_url etc.
       * @param {function} callback - called with (err, (string) token).
       *
       * @returns {void}
       */
      getToken: function getToken(profileName, profile, callback) {
        var self2 = this;
        if (profile.sso_session) {
          var _iniLoader = AWS2.util.iniLoader;
          var ssoSessions = _iniLoader.loadSsoSessionsFrom();
          var ssoSession = ssoSessions[profile.sso_session];
          Object.assign(profile, ssoSession);
          var ssoTokenProvider = new AWS2.SSOTokenProvider({
            profile: profileName
          });
          ssoTokenProvider.load(function(err) {
            if (err) {
              return callback(err);
            }
            return callback(null, ssoTokenProvider.token);
          });
          return;
        }
        try {
          var EXPIRE_WINDOW_MS = 15 * 60 * 1e3;
          var hasher = crypto.createHash("sha1");
          var fileName = hasher.update(profile.sso_start_url).digest("hex") + ".json";
          var cachePath = path.join(
            iniLoader.getHomeDir(),
            ".aws",
            "sso",
            "cache",
            fileName
          );
          var cacheFile = AWS2.util.readFileSync(cachePath);
          var cacheContent = null;
          if (cacheFile) {
            cacheContent = JSON.parse(cacheFile);
          }
          if (!cacheContent) {
            throw AWS2.util.error(
              new Error("Cached credentials not found under " + this.profile + " profile. Please make sure you log in with aws sso login first"),
              { code: self2.errorCode }
            );
          }
          if (!cacheContent.startUrl || !cacheContent.region || !cacheContent.accessToken || !cacheContent.expiresAt) {
            throw AWS2.util.error(
              new Error("Cached credentials are missing required properties. Try running aws sso login.")
            );
          }
          if (new Date(cacheContent.expiresAt).getTime() - Date.now() <= EXPIRE_WINDOW_MS) {
            throw AWS2.util.error(new Error(
              "The SSO session associated with this profile has expired. To refresh this SSO session run aws sso login with the corresponding profile."
            ));
          }
          return callback(null, cacheContent.accessToken);
        } catch (err) {
          return callback(err, null);
        }
      },
      /**
       * Loads the credentials from the AWS SSO process
       *
       * @callback callback function(err)
       *   Called after the AWS SSO process has been executed. When this
       *   callback is called with no error, it means that the credentials
       *   information has been loaded into the object (as the `accessKeyId`,
       *   `secretAccessKey`, and `sessionToken` properties).
       *   @param err [Error] if an error occurred, this value will be filled
       * @see get
       */
      refresh: function refresh(callback) {
        iniLoader.clearCachedFiles();
        this.coalesceRefresh(callback || AWS2.util.fn.callback);
      }
    });
  }
});

// node_modules/aws-sdk/lib/token.js
var require_token = __commonJS({
  "node_modules/aws-sdk/lib/token.js"() {
    "use strict";
    var AWS2 = require_core();
    AWS2.Token = AWS2.util.inherit({
      /**
       * Creates a Token object with a given set of information in options hash.
       * @option options token [String] represents the literal token string.
       * @option options expireTime [Date] field representing the time at which
       *   the token expires.
       * @example Create a token object
       *   var token = new AWS.Token({ token: 'token' });
       */
      constructor: function Token(options) {
        AWS2.util.hideProperties(this, ["token"]);
        this.expired = false;
        this.expireTime = null;
        this.refreshCallbacks = [];
        if (arguments.length === 1) {
          var options = arguments[0];
          this.token = options.token;
          this.expireTime = options.expireTime;
        }
      },
      /**
       * @return [Integer] the number of seconds before {expireTime} during which
       *   the token will be considered expired.
       */
      expiryWindow: 15,
      /**
       * @return [Boolean] whether the Token object should call {refresh}
       * @note Subclasses should override this method to provide custom refresh
       *   logic.
       */
      needsRefresh: function needsRefresh() {
        var currentTime = AWS2.util.date.getDate().getTime();
        var adjustedTime = new Date(currentTime + this.expiryWindow * 1e3);
        if (this.expireTime && adjustedTime > this.expireTime)
          return true;
        return this.expired || !this.token;
      },
      /**
       * Gets the existing token, refreshing them if they are not yet loaded
       * or have expired. Users should call this method before using {refresh},
       * as this will not attempt to reload token when they are already
       * loaded into the object.
       *
       * @callback callback function(err)
       *   When this callback is called with no error, it means either token
       *   do not need to be refreshed or refreshed token information has
       *   been loaded into the object (as the `token` property).
       *   @param err [Error] if an error occurred, this value will be filled
       */
      get: function get(callback) {
        var self2 = this;
        if (this.needsRefresh()) {
          this.refresh(function(err) {
            if (!err)
              self2.expired = false;
            if (callback)
              callback(err);
          });
        } else if (callback) {
          callback();
        }
      },
      /**
       * @!method  getPromise()
       *   Returns a 'thenable' promise.
       *   Gets the existing token, refreshing it if it's not yet loaded
       *   or have expired. Users should call this method before using {refresh},
       *   as this will not attempt to reload token when it's already
       *   loaded into the object.
       *
       *   Two callbacks can be provided to the `then` method on the returned promise.
       *   The first callback will be called if the promise is fulfilled, and the second
       *   callback will be called if the promise is rejected.
       *   @callback fulfilledCallback function()
       *     Called if the promise is fulfilled. When this callback is called, it means
       *     either token does not need to be refreshed or refreshed token information
       *     has been loaded into the object (as the `token` property).
       *   @callback rejectedCallback function(err)
       *     Called if the promise is rejected.
       *     @param err [Error] if an error occurred, this value will be filled.
       *   @return [Promise] A promise that represents the state of the `get` call.
       *   @example Calling the `getPromise` method.
       *     var promise = tokenProvider.getPromise();
       *     promise.then(function() { ... }, function(err) { ... });
       */
      /**
       * @!method  refreshPromise()
       *   Returns a 'thenable' promise.
       *   Refreshes the token. Users should call {get} before attempting
       *   to forcibly refresh token.
       *
       *   Two callbacks can be provided to the `then` method on the returned promise.
       *   The first callback will be called if the promise is fulfilled, and the second
       *   callback will be called if the promise is rejected.
       *   @callback fulfilledCallback function()
       *     Called if the promise is fulfilled. When this callback is called, it
       *     means refreshed token information has been loaded into the object
       *     (as the `token` property).
       *   @callback rejectedCallback function(err)
       *     Called if the promise is rejected.
       *     @param err [Error] if an error occurred, this value will be filled.
       *   @return [Promise] A promise that represents the state of the `refresh` call.
       *   @example Calling the `refreshPromise` method.
       *     var promise = tokenProvider.refreshPromise();
       *     promise.then(function() { ... }, function(err) { ... });
       */
      /**
       * Refreshes the token. Users should call {get} before attempting
       * to forcibly refresh token.
       *
       * @callback callback function(err)
       *   When this callback is called with no error, it means refreshed
       *   token information has been loaded into the object (as the
       *   `token` property).
       *   @param err [Error] if an error occurred, this value will be filled
       * @note Subclasses should override this class to reset the
       *   {token} on the token object and then call the callback with
       *   any error information.
       * @see get
       */
      refresh: function refresh(callback) {
        this.expired = false;
        callback();
      },
      /**
       * @api private
       * @param callback
       */
      coalesceRefresh: function coalesceRefresh(callback, sync) {
        var self2 = this;
        if (self2.refreshCallbacks.push(callback) === 1) {
          self2.load(function onLoad(err) {
            AWS2.util.arrayEach(self2.refreshCallbacks, function(callback2) {
              if (sync) {
                callback2(err);
              } else {
                AWS2.util.defer(function() {
                  callback2(err);
                });
              }
            });
            self2.refreshCallbacks.length = 0;
          });
        }
      },
      /**
       * @api private
       * @param callback
       */
      load: function load(callback) {
        callback();
      }
    });
    AWS2.Token.addPromisesToClass = function addPromisesToClass(PromiseDependency) {
      this.prototype.getPromise = AWS2.util.promisifyMethod("get", PromiseDependency);
      this.prototype.refreshPromise = AWS2.util.promisifyMethod("refresh", PromiseDependency);
    };
    AWS2.Token.deletePromisesFromClass = function deletePromisesFromClass() {
      delete this.prototype.getPromise;
      delete this.prototype.refreshPromise;
    };
    AWS2.util.addPromises(AWS2.Token);
  }
});

// node_modules/aws-sdk/lib/token/token_provider_chain.js
var require_token_provider_chain = __commonJS({
  "node_modules/aws-sdk/lib/token/token_provider_chain.js"() {
    "use strict";
    var AWS2 = require_core();
    AWS2.TokenProviderChain = AWS2.util.inherit(AWS2.Token, {
      /**
       * Creates a new TokenProviderChain with a default set of providers
       * specified by {defaultProviders}.
       */
      constructor: function TokenProviderChain(providers) {
        if (providers) {
          this.providers = providers;
        } else {
          this.providers = AWS2.TokenProviderChain.defaultProviders.slice(0);
        }
        this.resolveCallbacks = [];
      },
      /**
       * @!method  resolvePromise()
       *   Returns a 'thenable' promise.
       *   Resolves the provider chain by searching for the first token in {providers}.
       *
       *   Two callbacks can be provided to the `then` method on the returned promise.
       *   The first callback will be called if the promise is fulfilled, and the second
       *   callback will be called if the promise is rejected.
       *   @callback fulfilledCallback function(token)
       *     Called if the promise is fulfilled and the provider resolves the chain
       *     to a token object
       *     @param token [AWS.Token] the token object resolved by the provider chain.
       *   @callback rejectedCallback function(error)
       *     Called if the promise is rejected.
       *     @param err [Error] the error object returned if no token is found.
       *   @return [Promise] A promise that represents the state of the `resolve` method call.
       *   @example Calling the `resolvePromise` method.
       *     var promise = chain.resolvePromise();
       *     promise.then(function(token) { ... }, function(err) { ... });
       */
      /**
       * Resolves the provider chain by searching for the first token in {providers}.
       *
       * @callback callback function(err, token)
       *   Called when the provider resolves the chain to a token object
       *   or null if no token can be found.
       *
       *   @param err [Error] the error object returned if no token is found.
       *   @param token [AWS.Token] the token object resolved by the provider chain.
       * @return [AWS.TokenProviderChain] the provider, for chaining.
       */
      resolve: function resolve(callback) {
        var self2 = this;
        if (self2.providers.length === 0) {
          callback(new Error("No providers"));
          return self2;
        }
        if (self2.resolveCallbacks.push(callback) === 1) {
          let resolveNext2 = function(err, token) {
            if (!err && token || index === providers.length) {
              AWS2.util.arrayEach(self2.resolveCallbacks, function(callback2) {
                callback2(err, token);
              });
              self2.resolveCallbacks.length = 0;
              return;
            }
            var provider = providers[index++];
            if (typeof provider === "function") {
              token = provider.call();
            } else {
              token = provider;
            }
            if (token.get) {
              token.get(function(getErr) {
                resolveNext2(getErr, getErr ? null : token);
              });
            } else {
              resolveNext2(null, token);
            }
          };
          var resolveNext = resolveNext2;
          var index = 0;
          var providers = self2.providers.slice(0);
          resolveNext2();
        }
        return self2;
      }
    });
    AWS2.TokenProviderChain.defaultProviders = [];
    AWS2.TokenProviderChain.addPromisesToClass = function addPromisesToClass(PromiseDependency) {
      this.prototype.resolvePromise = AWS2.util.promisifyMethod("resolve", PromiseDependency);
    };
    AWS2.TokenProviderChain.deletePromisesFromClass = function deletePromisesFromClass() {
      delete this.prototype.resolvePromise;
    };
    AWS2.util.addPromises(AWS2.TokenProviderChain);
  }
});

// node_modules/aws-sdk/lib/token/sso_token_provider.js
var require_sso_token_provider = __commonJS({
  "node_modules/aws-sdk/lib/token/sso_token_provider.js"() {
    "use strict";
    var AWS2 = require_core();
    var crypto = require("crypto");
    var fs = require("fs");
    var path = require("path");
    var iniLoader = AWS2.util.iniLoader;
    var lastRefreshAttemptTime = 0;
    var validateTokenKey = function validateTokenKey2(token, key) {
      if (!token[key]) {
        throw AWS2.util.error(
          new Error('Key "' + key + '" not present in SSO Token'),
          { code: "SSOTokenProviderFailure" }
        );
      }
    };
    var refreshUnsuccessful = function refreshUnsuccessful2(currentTime, tokenExpireTime, callback) {
      if (tokenExpireTime > currentTime) {
        callback(null);
      } else {
        throw AWS2.util.error(
          new Error('SSO Token refresh failed. Please log in using "aws sso login"'),
          { code: "SSOTokenProviderFailure" }
        );
      }
    };
    AWS2.SSOTokenProvider = AWS2.util.inherit(AWS2.Token, {
      /**
       * Expiry window of five minutes.
       */
      expiryWindow: 5 * 60,
      /**
       * Creates a new token object from cached access token.
       *
       * @param options [map] a set of options
       * @option options profile [String] (AWS_PROFILE env var or 'default')
       *   the name of the profile to load.
       * @option options callback [Function] (err) Token is eagerly loaded
       *   by the constructor. When the callback is called with no error, the
       *   token has been loaded successfully.
       */
      constructor: function SSOTokenProvider(options) {
        AWS2.Token.call(this);
        options = options || {};
        this.expired = true;
        this.profile = options.profile || process.env.AWS_PROFILE || AWS2.util.defaultProfile;
        this.get(options.callback || AWS2.util.fn.noop);
      },
      /**
       * Reads sso_start_url from provided profile, and reads token from
       * ~/.aws/sso/cache/<sha1-of-utf8-encoded-value-from-sso_start_url>.json
       *
       * Throws an error if required fields token and expiresAt are missing.
       * Throws an error if token has expired and metadata to perform refresh is
       * not available.
       * Attempts to refresh the token if it's within 5 minutes before expiry time.
       *
       * @api private
       */
      load: function load(callback) {
        var self2 = this;
        var profiles = iniLoader.loadFrom({ isConfig: true });
        var profile = profiles[this.profile] || {};
        if (Object.keys(profile).length === 0) {
          throw AWS2.util.error(
            new Error('Profile "' + this.profile + '" not found'),
            { code: "SSOTokenProviderFailure" }
          );
        } else if (!profile["sso_session"]) {
          throw AWS2.util.error(
            new Error('Profile "' + this.profile + '" is missing required property "sso_session".'),
            { code: "SSOTokenProviderFailure" }
          );
        }
        var ssoSessionName = profile["sso_session"];
        var ssoSessions = iniLoader.loadSsoSessionsFrom();
        var ssoSession = ssoSessions[ssoSessionName];
        if (!ssoSession) {
          throw AWS2.util.error(
            new Error('Sso session "' + ssoSessionName + '" not found'),
            { code: "SSOTokenProviderFailure" }
          );
        } else if (!ssoSession["sso_start_url"]) {
          throw AWS2.util.error(
            new Error('Sso session "' + this.profile + '" is missing required property "sso_start_url".'),
            { code: "SSOTokenProviderFailure" }
          );
        } else if (!ssoSession["sso_region"]) {
          throw AWS2.util.error(
            new Error('Sso session "' + this.profile + '" is missing required property "sso_region".'),
            { code: "SSOTokenProviderFailure" }
          );
        }
        var hasher = crypto.createHash("sha1");
        var fileName = hasher.update(ssoSessionName).digest("hex") + ".json";
        var cachePath = path.join(iniLoader.getHomeDir(), ".aws", "sso", "cache", fileName);
        var tokenFromCache = JSON.parse(fs.readFileSync(cachePath));
        if (!tokenFromCache) {
          throw AWS2.util.error(
            new Error('Cached token not found. Please log in using "aws sso login" for profile "' + this.profile + '".'),
            { code: "SSOTokenProviderFailure" }
          );
        }
        validateTokenKey(tokenFromCache, "accessToken");
        validateTokenKey(tokenFromCache, "expiresAt");
        var currentTime = AWS2.util.date.getDate().getTime();
        var adjustedTime = new Date(currentTime + this.expiryWindow * 1e3);
        var tokenExpireTime = new Date(tokenFromCache["expiresAt"]);
        if (tokenExpireTime > adjustedTime) {
          self2.token = tokenFromCache.accessToken;
          self2.expireTime = tokenExpireTime;
          self2.expired = false;
          callback(null);
          return;
        }
        if (currentTime - lastRefreshAttemptTime < 30 * 1e3) {
          refreshUnsuccessful(currentTime, tokenExpireTime, callback);
          return;
        }
        validateTokenKey(tokenFromCache, "clientId");
        validateTokenKey(tokenFromCache, "clientSecret");
        validateTokenKey(tokenFromCache, "refreshToken");
        if (!self2.service || self2.service.config.region !== ssoSession.sso_region) {
          self2.service = new AWS2.SSOOIDC({ region: ssoSession.sso_region });
        }
        var params = {
          clientId: tokenFromCache.clientId,
          clientSecret: tokenFromCache.clientSecret,
          refreshToken: tokenFromCache.refreshToken,
          grantType: "refresh_token"
        };
        lastRefreshAttemptTime = AWS2.util.date.getDate().getTime();
        self2.service.createToken(params, function(err, data) {
          if (err || !data) {
            refreshUnsuccessful(currentTime, tokenExpireTime, callback);
          } else {
            try {
              validateTokenKey(data, "accessToken");
              validateTokenKey(data, "expiresIn");
              self2.expired = false;
              self2.token = data.accessToken;
              self2.expireTime = new Date(Date.now() + data.expiresIn * 1e3);
              callback(null);
              try {
                tokenFromCache.accessToken = data.accessToken;
                tokenFromCache.expiresAt = self2.expireTime.toISOString();
                tokenFromCache.refreshToken = data.refreshToken;
                fs.writeFileSync(cachePath, JSON.stringify(tokenFromCache, null, 2));
              } catch (error) {
              }
            } catch (error) {
              refreshUnsuccessful(currentTime, tokenExpireTime, callback);
            }
          }
        });
      },
      /**
       * Loads the cached access token from disk.
       *
       * @callback callback function(err)
       *   Called after the AWS SSO process has been executed. When this
       *   callback is called with no error, it means that the token information
       *   has been loaded into the object (as the `token` property).
       *   @param err [Error] if an error occurred, this value will be filled.
       * @see get
       */
      refresh: function refresh(callback) {
        iniLoader.clearCachedFiles();
        this.coalesceRefresh(callback || AWS2.util.fn.callback);
      }
    });
  }
});

// node_modules/aws-sdk/lib/node_loader.js
var require_node_loader = __commonJS({
  "node_modules/aws-sdk/lib/node_loader.js"(exports2, module2) {
    "use strict";
    var util = require_util();
    var region_utils = require_utils();
    var isFipsRegion = region_utils.isFipsRegion;
    var getRealRegion = region_utils.getRealRegion;
    util.isBrowser = function() {
      return false;
    };
    util.isNode = function() {
      return true;
    };
    util.crypto.lib = require("crypto");
    util.Buffer = require("buffer").Buffer;
    util.domain = require("domain");
    util.stream = require("stream");
    util.url = require("url");
    util.querystring = require("querystring");
    util.environment = "nodejs";
    util.createEventStream = util.stream.Readable ? require_streaming_create_event_stream().createEventStream : require_buffered_create_event_stream().createEventStream;
    util.realClock = require_nodeClock();
    util.clientSideMonitoring = {
      Publisher: require_publisher().Publisher,
      configProvider: require_configuration()
    };
    util.iniLoader = require_shared_ini().iniLoader;
    util.getSystemErrorName = require("util").getSystemErrorName;
    util.loadConfig = function(options) {
      var envValue = options.environmentVariableSelector(process.env);
      if (envValue !== void 0) {
        return envValue;
      }
      var configFile = {};
      try {
        configFile = util.iniLoader ? util.iniLoader.loadFrom({
          isConfig: true,
          filename: process.env[util.sharedConfigFileEnv]
        }) : {};
      } catch (e) {
      }
      var sharedFileConfig = configFile[process.env.AWS_PROFILE || util.defaultProfile] || {};
      var configValue = options.configFileSelector(sharedFileConfig);
      if (configValue !== void 0) {
        return configValue;
      }
      if (typeof options.default === "function") {
        return options.default();
      }
      return options.default;
    };
    var AWS2;
    module2.exports = AWS2 = require_core();
    require_credentials();
    require_credential_provider_chain();
    require_temporary_credentials();
    require_chainable_temporary_credentials();
    require_web_identity_credentials();
    require_cognito_identity_credentials();
    require_saml_credentials();
    require_process_credentials();
    AWS2.XML.Parser = require_node_parser();
    require_node();
    require_ini_loader();
    require_token_file_web_identity_credentials();
    require_ec2_metadata_credentials();
    require_remote_credentials();
    require_ecs_credentials();
    require_environment_credentials();
    require_file_system_credentials();
    require_shared_ini_file_credentials();
    require_process_credentials();
    require_sso_credentials();
    AWS2.CredentialProviderChain.defaultProviders = [
      function() {
        return new AWS2.EnvironmentCredentials("AWS");
      },
      function() {
        return new AWS2.EnvironmentCredentials("AMAZON");
      },
      function() {
        return new AWS2.SsoCredentials();
      },
      function() {
        return new AWS2.SharedIniFileCredentials();
      },
      function() {
        return new AWS2.ECSCredentials();
      },
      function() {
        return new AWS2.ProcessCredentials();
      },
      function() {
        return new AWS2.TokenFileWebIdentityCredentials();
      },
      function() {
        return new AWS2.EC2MetadataCredentials();
      }
    ];
    require_token();
    require_token_provider_chain();
    require_sso_token_provider();
    AWS2.TokenProviderChain.defaultProviders = [
      function() {
        return new AWS2.SSOTokenProvider();
      }
    ];
    var getRegion = function() {
      var env = process.env;
      var region = env.AWS_REGION || env.AMAZON_REGION;
      if (env[AWS2.util.configOptInEnv]) {
        var toCheck = [
          { filename: env[AWS2.util.sharedCredentialsFileEnv] },
          { isConfig: true, filename: env[AWS2.util.sharedConfigFileEnv] }
        ];
        var iniLoader = AWS2.util.iniLoader;
        while (!region && toCheck.length) {
          var configFile = {};
          var fileInfo = toCheck.shift();
          try {
            configFile = iniLoader.loadFrom(fileInfo);
          } catch (err) {
            if (fileInfo.isConfig)
              throw err;
          }
          var profile = configFile[env.AWS_PROFILE || AWS2.util.defaultProfile];
          region = profile && profile.region;
        }
      }
      return region;
    };
    var getBooleanValue = function(value) {
      return value === "true" ? true : value === "false" ? false : void 0;
    };
    var USE_FIPS_ENDPOINT_CONFIG_OPTIONS = {
      environmentVariableSelector: function(env) {
        return getBooleanValue(env["AWS_USE_FIPS_ENDPOINT"]);
      },
      configFileSelector: function(profile) {
        return getBooleanValue(profile["use_fips_endpoint"]);
      },
      default: false
    };
    var USE_DUALSTACK_ENDPOINT_CONFIG_OPTIONS = {
      environmentVariableSelector: function(env) {
        return getBooleanValue(env["AWS_USE_DUALSTACK_ENDPOINT"]);
      },
      configFileSelector: function(profile) {
        return getBooleanValue(profile["use_dualstack_endpoint"]);
      },
      default: false
    };
    AWS2.util.update(AWS2.Config.prototype.keys, {
      credentials: function() {
        var credentials = null;
        new AWS2.CredentialProviderChain([
          function() {
            return new AWS2.EnvironmentCredentials("AWS");
          },
          function() {
            return new AWS2.EnvironmentCredentials("AMAZON");
          },
          function() {
            return new AWS2.SharedIniFileCredentials({ disableAssumeRole: true });
          }
        ]).resolve(function(err, creds) {
          if (!err)
            credentials = creds;
        });
        return credentials;
      },
      credentialProvider: function() {
        return new AWS2.CredentialProviderChain();
      },
      logger: function() {
        return process.env.AWSJS_DEBUG ? console : null;
      },
      region: function() {
        var region = getRegion();
        return region ? getRealRegion(region) : void 0;
      },
      tokenProvider: function() {
        return new AWS2.TokenProviderChain();
      },
      useFipsEndpoint: function() {
        var region = getRegion();
        return isFipsRegion(region) ? true : util.loadConfig(USE_FIPS_ENDPOINT_CONFIG_OPTIONS);
      },
      useDualstackEndpoint: function() {
        return util.loadConfig(USE_DUALSTACK_ENDPOINT_CONFIG_OPTIONS);
      }
    });
    AWS2.config = new AWS2.Config();
  }
});

// node_modules/aws-sdk/apis/acm-2015-12-08.min.json
var require_acm_2015_12_08_min = __commonJS({
  "node_modules/aws-sdk/apis/acm-2015-12-08.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-12-08",
        endpointPrefix: "acm",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "ACM",
        serviceFullName: "AWS Certificate Manager",
        serviceId: "ACM",
        signatureVersion: "v4",
        targetPrefix: "CertificateManager",
        uid: "acm-2015-12-08"
      },
      operations: {
        AddTagsToCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateArn",
              "Tags"
            ],
            members: {
              CertificateArn: {},
              Tags: {
                shape: "S3"
              }
            }
          }
        },
        DeleteCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateArn"
            ],
            members: {
              CertificateArn: {}
            }
          }
        },
        DescribeCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateArn"
            ],
            members: {
              CertificateArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Certificate: {
                type: "structure",
                members: {
                  CertificateArn: {},
                  DomainName: {},
                  SubjectAlternativeNames: {
                    shape: "Sc"
                  },
                  DomainValidationOptions: {
                    shape: "Sd"
                  },
                  Serial: {},
                  Subject: {},
                  Issuer: {},
                  CreatedAt: {
                    type: "timestamp"
                  },
                  IssuedAt: {
                    type: "timestamp"
                  },
                  ImportedAt: {
                    type: "timestamp"
                  },
                  Status: {},
                  RevokedAt: {
                    type: "timestamp"
                  },
                  RevocationReason: {},
                  NotBefore: {
                    type: "timestamp"
                  },
                  NotAfter: {
                    type: "timestamp"
                  },
                  KeyAlgorithm: {},
                  SignatureAlgorithm: {},
                  InUseBy: {
                    type: "list",
                    member: {}
                  },
                  FailureReason: {},
                  Type: {},
                  RenewalSummary: {
                    type: "structure",
                    required: [
                      "RenewalStatus",
                      "DomainValidationOptions",
                      "UpdatedAt"
                    ],
                    members: {
                      RenewalStatus: {},
                      DomainValidationOptions: {
                        shape: "Sd"
                      },
                      RenewalStatusReason: {},
                      UpdatedAt: {
                        type: "timestamp"
                      }
                    }
                  },
                  KeyUsages: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {}
                      }
                    }
                  },
                  ExtendedKeyUsages: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {},
                        OID: {}
                      }
                    }
                  },
                  CertificateAuthorityArn: {},
                  RenewalEligibility: {},
                  Options: {
                    shape: "S11"
                  }
                }
              }
            }
          }
        },
        ExportCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateArn",
              "Passphrase"
            ],
            members: {
              CertificateArn: {},
              Passphrase: {
                type: "blob",
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Certificate: {},
              CertificateChain: {},
              PrivateKey: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        GetAccountConfiguration: {
          output: {
            type: "structure",
            members: {
              ExpiryEvents: {
                shape: "S1a"
              }
            }
          }
        },
        GetCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateArn"
            ],
            members: {
              CertificateArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Certificate: {},
              CertificateChain: {}
            }
          }
        },
        ImportCertificate: {
          input: {
            type: "structure",
            required: [
              "Certificate",
              "PrivateKey"
            ],
            members: {
              CertificateArn: {},
              Certificate: {
                type: "blob"
              },
              PrivateKey: {
                type: "blob",
                sensitive: true
              },
              CertificateChain: {
                type: "blob"
              },
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CertificateArn: {}
            }
          }
        },
        ListCertificates: {
          input: {
            type: "structure",
            members: {
              CertificateStatuses: {
                type: "list",
                member: {}
              },
              Includes: {
                type: "structure",
                members: {
                  extendedKeyUsage: {
                    type: "list",
                    member: {}
                  },
                  keyUsage: {
                    type: "list",
                    member: {}
                  },
                  keyTypes: {
                    type: "list",
                    member: {}
                  }
                }
              },
              NextToken: {},
              MaxItems: {
                type: "integer"
              },
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              CertificateSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CertificateArn: {},
                    DomainName: {},
                    SubjectAlternativeNameSummaries: {
                      shape: "Sc"
                    },
                    HasAdditionalSubjectAlternativeNames: {
                      type: "boolean"
                    },
                    Status: {},
                    Type: {},
                    KeyAlgorithm: {},
                    KeyUsages: {
                      type: "list",
                      member: {}
                    },
                    ExtendedKeyUsages: {
                      type: "list",
                      member: {}
                    },
                    InUse: {
                      type: "boolean"
                    },
                    Exported: {
                      type: "boolean"
                    },
                    RenewalEligibility: {},
                    NotBefore: {
                      type: "timestamp"
                    },
                    NotAfter: {
                      type: "timestamp"
                    },
                    CreatedAt: {
                      type: "timestamp"
                    },
                    IssuedAt: {
                      type: "timestamp"
                    },
                    ImportedAt: {
                      type: "timestamp"
                    },
                    RevokedAt: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateArn"
            ],
            members: {
              CertificateArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S3"
              }
            }
          }
        },
        PutAccountConfiguration: {
          input: {
            type: "structure",
            required: [
              "IdempotencyToken"
            ],
            members: {
              ExpiryEvents: {
                shape: "S1a"
              },
              IdempotencyToken: {}
            }
          }
        },
        RemoveTagsFromCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateArn",
              "Tags"
            ],
            members: {
              CertificateArn: {},
              Tags: {
                shape: "S3"
              }
            }
          }
        },
        RenewCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateArn"
            ],
            members: {
              CertificateArn: {}
            }
          }
        },
        RequestCertificate: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              ValidationMethod: {},
              SubjectAlternativeNames: {
                shape: "Sc"
              },
              IdempotencyToken: {},
              DomainValidationOptions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "DomainName",
                    "ValidationDomain"
                  ],
                  members: {
                    DomainName: {},
                    ValidationDomain: {}
                  }
                }
              },
              Options: {
                shape: "S11"
              },
              CertificateAuthorityArn: {},
              Tags: {
                shape: "S3"
              },
              KeyAlgorithm: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CertificateArn: {}
            }
          }
        },
        ResendValidationEmail: {
          input: {
            type: "structure",
            required: [
              "CertificateArn",
              "Domain",
              "ValidationDomain"
            ],
            members: {
              CertificateArn: {},
              Domain: {},
              ValidationDomain: {}
            }
          }
        },
        UpdateCertificateOptions: {
          input: {
            type: "structure",
            required: [
              "CertificateArn",
              "Options"
            ],
            members: {
              CertificateArn: {},
              Options: {
                shape: "S11"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sc: {
          type: "list",
          member: {}
        },
        Sd: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              ValidationEmails: {
                type: "list",
                member: {}
              },
              ValidationDomain: {},
              ValidationStatus: {},
              ResourceRecord: {
                type: "structure",
                required: [
                  "Name",
                  "Type",
                  "Value"
                ],
                members: {
                  Name: {},
                  Type: {},
                  Value: {}
                }
              },
              ValidationMethod: {}
            }
          }
        },
        S11: {
          type: "structure",
          members: {
            CertificateTransparencyLoggingPreference: {}
          }
        },
        S1a: {
          type: "structure",
          members: {
            DaysBeforeExpiry: {
              type: "integer"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/acm-2015-12-08.paginators.json
var require_acm_2015_12_08_paginators = __commonJS({
  "node_modules/aws-sdk/apis/acm-2015-12-08.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListCertificates: {
          input_token: "NextToken",
          limit_key: "MaxItems",
          output_token: "NextToken",
          result_key: "CertificateSummaryList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/acm-2015-12-08.waiters2.json
var require_acm_2015_12_08_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/acm-2015-12-08.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        CertificateValidated: {
          delay: 60,
          maxAttempts: 40,
          operation: "DescribeCertificate",
          acceptors: [
            {
              matcher: "pathAll",
              expected: "SUCCESS",
              argument: "Certificate.DomainValidationOptions[].ValidationStatus",
              state: "success"
            },
            {
              matcher: "pathAny",
              expected: "PENDING_VALIDATION",
              argument: "Certificate.DomainValidationOptions[].ValidationStatus",
              state: "retry"
            },
            {
              matcher: "path",
              expected: "FAILED",
              argument: "Certificate.Status",
              state: "failure"
            },
            {
              matcher: "error",
              expected: "ResourceNotFoundException",
              state: "failure"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/acm.js
var require_acm = __commonJS({
  "node_modules/aws-sdk/clients/acm.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["acm"] = {};
    AWS2.ACM = Service.defineService("acm", ["2015-12-08"]);
    Object.defineProperty(apiLoader.services["acm"], "2015-12-08", {
      get: function get() {
        var model = require_acm_2015_12_08_min();
        model.paginators = require_acm_2015_12_08_paginators().pagination;
        model.waiters = require_acm_2015_12_08_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ACM;
  }
});

// node_modules/aws-sdk/lib/services/apigateway.js
var require_apigateway = __commonJS({
  "node_modules/aws-sdk/lib/services/apigateway.js"() {
    "use strict";
    var AWS2 = require_core();
    AWS2.util.update(AWS2.APIGateway.prototype, {
      /**
       * Sets the Accept header to application/json.
       *
       * @api private
       */
      setAcceptHeader: function setAcceptHeader(req) {
        var httpRequest = req.httpRequest;
        if (!httpRequest.headers.Accept) {
          httpRequest.headers["Accept"] = "application/json";
        }
      },
      /**
       * @api private
       */
      setupRequestListeners: function setupRequestListeners(request) {
        request.addListener("build", this.setAcceptHeader);
        if (request.operation === "getExport") {
          var params = request.params || {};
          if (params.exportType === "swagger") {
            request.addListener("extractData", AWS2.util.convertPayloadToString);
          }
        }
      }
    });
  }
});

// node_modules/aws-sdk/apis/apigateway-2015-07-09.min.json
var require_apigateway_2015_07_09_min = __commonJS({
  "node_modules/aws-sdk/apis/apigateway-2015-07-09.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-07-09",
        endpointPrefix: "apigateway",
        protocol: "rest-json",
        serviceFullName: "Amazon API Gateway",
        serviceId: "API Gateway",
        signatureVersion: "v4",
        uid: "apigateway-2015-07-09"
      },
      operations: {
        CreateApiKey: {
          http: {
            requestUri: "/apikeys",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              name: {},
              description: {},
              enabled: {
                type: "boolean"
              },
              generateDistinctId: {
                type: "boolean"
              },
              value: {},
              stageKeys: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    restApiId: {},
                    stageName: {}
                  }
                }
              },
              customerId: {},
              tags: {
                shape: "S6"
              }
            }
          },
          output: {
            shape: "S7"
          }
        },
        CreateAuthorizer: {
          http: {
            requestUri: "/restapis/{restapi_id}/authorizers",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "name",
              "type"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              name: {},
              type: {},
              providerARNs: {
                shape: "Sc"
              },
              authType: {},
              authorizerUri: {},
              authorizerCredentials: {},
              identitySource: {},
              identityValidationExpression: {},
              authorizerResultTtlInSeconds: {
                type: "integer"
              }
            }
          },
          output: {
            shape: "Sf"
          }
        },
        CreateBasePathMapping: {
          http: {
            requestUri: "/domainnames/{domain_name}/basepathmappings",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "domainName",
              "restApiId"
            ],
            members: {
              domainName: {
                location: "uri",
                locationName: "domain_name"
              },
              basePath: {},
              restApiId: {},
              stage: {}
            }
          },
          output: {
            shape: "Sh"
          }
        },
        CreateDeployment: {
          http: {
            requestUri: "/restapis/{restapi_id}/deployments",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "restApiId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              stageName: {},
              stageDescription: {},
              description: {},
              cacheClusterEnabled: {
                type: "boolean"
              },
              cacheClusterSize: {},
              variables: {
                shape: "S6"
              },
              canarySettings: {
                type: "structure",
                members: {
                  percentTraffic: {
                    type: "double"
                  },
                  stageVariableOverrides: {
                    shape: "S6"
                  },
                  useStageCache: {
                    type: "boolean"
                  }
                }
              },
              tracingEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "Sn"
          }
        },
        CreateDocumentationPart: {
          http: {
            requestUri: "/restapis/{restapi_id}/documentation/parts",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "location",
              "properties"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              location: {
                shape: "Ss"
              },
              properties: {}
            }
          },
          output: {
            shape: "Sv"
          }
        },
        CreateDocumentationVersion: {
          http: {
            requestUri: "/restapis/{restapi_id}/documentation/versions",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "documentationVersion"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              documentationVersion: {},
              stageName: {},
              description: {}
            }
          },
          output: {
            shape: "Sx"
          }
        },
        CreateDomainName: {
          http: {
            requestUri: "/domainnames",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "domainName"
            ],
            members: {
              domainName: {},
              certificateName: {},
              certificateBody: {},
              certificatePrivateKey: {},
              certificateChain: {},
              certificateArn: {},
              regionalCertificateName: {},
              regionalCertificateArn: {},
              endpointConfiguration: {
                shape: "Sz"
              },
              tags: {
                shape: "S6"
              },
              securityPolicy: {},
              mutualTlsAuthentication: {
                type: "structure",
                members: {
                  truststoreUri: {},
                  truststoreVersion: {}
                }
              },
              ownershipVerificationCertificateArn: {}
            }
          },
          output: {
            shape: "S14"
          }
        },
        CreateModel: {
          http: {
            requestUri: "/restapis/{restapi_id}/models",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "name",
              "contentType"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              name: {},
              description: {},
              schema: {},
              contentType: {}
            }
          },
          output: {
            shape: "S18"
          }
        },
        CreateRequestValidator: {
          http: {
            requestUri: "/restapis/{restapi_id}/requestvalidators",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "restApiId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              name: {},
              validateRequestBody: {
                type: "boolean"
              },
              validateRequestParameters: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S1a"
          }
        },
        CreateResource: {
          http: {
            requestUri: "/restapis/{restapi_id}/resources/{parent_id}",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "parentId",
              "pathPart"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              parentId: {
                location: "uri",
                locationName: "parent_id"
              },
              pathPart: {}
            }
          },
          output: {
            shape: "S1c"
          }
        },
        CreateRestApi: {
          http: {
            requestUri: "/restapis",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              description: {},
              version: {},
              cloneFrom: {},
              binaryMediaTypes: {
                shape: "S9"
              },
              minimumCompressionSize: {
                type: "integer"
              },
              apiKeySource: {},
              endpointConfiguration: {
                shape: "Sz"
              },
              policy: {},
              tags: {
                shape: "S6"
              },
              disableExecuteApiEndpoint: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S1t"
          }
        },
        CreateStage: {
          http: {
            requestUri: "/restapis/{restapi_id}/stages",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "stageName",
              "deploymentId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              stageName: {},
              deploymentId: {},
              description: {},
              cacheClusterEnabled: {
                type: "boolean"
              },
              cacheClusterSize: {},
              variables: {
                shape: "S6"
              },
              documentationVersion: {},
              canarySettings: {
                shape: "S1v"
              },
              tracingEnabled: {
                type: "boolean"
              },
              tags: {
                shape: "S6"
              }
            }
          },
          output: {
            shape: "S1w"
          }
        },
        CreateUsagePlan: {
          http: {
            requestUri: "/usageplans",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              description: {},
              apiStages: {
                shape: "S23"
              },
              throttle: {
                shape: "S26"
              },
              quota: {
                shape: "S27"
              },
              tags: {
                shape: "S6"
              }
            }
          },
          output: {
            shape: "S29"
          }
        },
        CreateUsagePlanKey: {
          http: {
            requestUri: "/usageplans/{usageplanId}/keys",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "usagePlanId",
              "keyId",
              "keyType"
            ],
            members: {
              usagePlanId: {
                location: "uri",
                locationName: "usageplanId"
              },
              keyId: {},
              keyType: {}
            }
          },
          output: {
            shape: "S2b"
          }
        },
        CreateVpcLink: {
          http: {
            requestUri: "/vpclinks",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "name",
              "targetArns"
            ],
            members: {
              name: {},
              description: {},
              targetArns: {
                shape: "S9"
              },
              tags: {
                shape: "S6"
              }
            }
          },
          output: {
            shape: "S2d"
          }
        },
        DeleteApiKey: {
          http: {
            method: "DELETE",
            requestUri: "/apikeys/{api_Key}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "apiKey"
            ],
            members: {
              apiKey: {
                location: "uri",
                locationName: "api_Key"
              }
            }
          }
        },
        DeleteAuthorizer: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}/authorizers/{authorizer_id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "authorizerId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              authorizerId: {
                location: "uri",
                locationName: "authorizer_id"
              }
            }
          }
        },
        DeleteBasePathMapping: {
          http: {
            method: "DELETE",
            requestUri: "/domainnames/{domain_name}/basepathmappings/{base_path}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "domainName",
              "basePath"
            ],
            members: {
              domainName: {
                location: "uri",
                locationName: "domain_name"
              },
              basePath: {
                location: "uri",
                locationName: "base_path"
              }
            }
          }
        },
        DeleteClientCertificate: {
          http: {
            method: "DELETE",
            requestUri: "/clientcertificates/{clientcertificate_id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "clientCertificateId"
            ],
            members: {
              clientCertificateId: {
                location: "uri",
                locationName: "clientcertificate_id"
              }
            }
          }
        },
        DeleteDeployment: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}/deployments/{deployment_id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "deploymentId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              deploymentId: {
                location: "uri",
                locationName: "deployment_id"
              }
            }
          }
        },
        DeleteDocumentationPart: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}/documentation/parts/{part_id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "documentationPartId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              documentationPartId: {
                location: "uri",
                locationName: "part_id"
              }
            }
          }
        },
        DeleteDocumentationVersion: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}/documentation/versions/{doc_version}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "documentationVersion"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              documentationVersion: {
                location: "uri",
                locationName: "doc_version"
              }
            }
          }
        },
        DeleteDomainName: {
          http: {
            method: "DELETE",
            requestUri: "/domainnames/{domain_name}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "domainName"
            ],
            members: {
              domainName: {
                location: "uri",
                locationName: "domain_name"
              }
            }
          }
        },
        DeleteGatewayResponse: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}/gatewayresponses/{response_type}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "responseType"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              responseType: {
                location: "uri",
                locationName: "response_type"
              }
            }
          }
        },
        DeleteIntegration: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}/integration",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              }
            }
          }
        },
        DeleteIntegrationResponse: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}/integration/responses/{status_code}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod",
              "statusCode"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              },
              statusCode: {
                location: "uri",
                locationName: "status_code"
              }
            }
          }
        },
        DeleteMethod: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              }
            }
          }
        },
        DeleteMethodResponse: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}/responses/{status_code}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod",
              "statusCode"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              },
              statusCode: {
                location: "uri",
                locationName: "status_code"
              }
            }
          }
        },
        DeleteModel: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}/models/{model_name}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "modelName"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              modelName: {
                location: "uri",
                locationName: "model_name"
              }
            }
          }
        },
        DeleteRequestValidator: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}/requestvalidators/{requestvalidator_id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "requestValidatorId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              requestValidatorId: {
                location: "uri",
                locationName: "requestvalidator_id"
              }
            }
          }
        },
        DeleteResource: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              }
            }
          }
        },
        DeleteRestApi: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "restApiId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              }
            }
          }
        },
        DeleteStage: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}/stages/{stage_name}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "stageName"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              stageName: {
                location: "uri",
                locationName: "stage_name"
              }
            }
          }
        },
        DeleteUsagePlan: {
          http: {
            method: "DELETE",
            requestUri: "/usageplans/{usageplanId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "usagePlanId"
            ],
            members: {
              usagePlanId: {
                location: "uri",
                locationName: "usageplanId"
              }
            }
          }
        },
        DeleteUsagePlanKey: {
          http: {
            method: "DELETE",
            requestUri: "/usageplans/{usageplanId}/keys/{keyId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "usagePlanId",
              "keyId"
            ],
            members: {
              usagePlanId: {
                location: "uri",
                locationName: "usageplanId"
              },
              keyId: {
                location: "uri",
                locationName: "keyId"
              }
            }
          }
        },
        DeleteVpcLink: {
          http: {
            method: "DELETE",
            requestUri: "/vpclinks/{vpclink_id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "vpcLinkId"
            ],
            members: {
              vpcLinkId: {
                location: "uri",
                locationName: "vpclink_id"
              }
            }
          }
        },
        FlushStageAuthorizersCache: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}/stages/{stage_name}/cache/authorizers",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "stageName"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              stageName: {
                location: "uri",
                locationName: "stage_name"
              }
            }
          }
        },
        FlushStageCache: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}/stages/{stage_name}/cache/data",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "stageName"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              stageName: {
                location: "uri",
                locationName: "stage_name"
              }
            }
          }
        },
        GenerateClientCertificate: {
          http: {
            requestUri: "/clientcertificates",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              description: {},
              tags: {
                shape: "S6"
              }
            }
          },
          output: {
            shape: "S34"
          }
        },
        GetAccount: {
          http: {
            method: "GET",
            requestUri: "/account"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            shape: "S36"
          }
        },
        GetApiKey: {
          http: {
            method: "GET",
            requestUri: "/apikeys/{api_Key}"
          },
          input: {
            type: "structure",
            required: [
              "apiKey"
            ],
            members: {
              apiKey: {
                location: "uri",
                locationName: "api_Key"
              },
              includeValue: {
                location: "querystring",
                locationName: "includeValue",
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S7"
          }
        },
        GetApiKeys: {
          http: {
            method: "GET",
            requestUri: "/apikeys"
          },
          input: {
            type: "structure",
            members: {
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              nameQuery: {
                location: "querystring",
                locationName: "name"
              },
              customerId: {
                location: "querystring",
                locationName: "customerId"
              },
              includeValues: {
                location: "querystring",
                locationName: "includeValues",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              warnings: {
                shape: "S9"
              },
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "S7"
                }
              }
            }
          }
        },
        GetAuthorizer: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/authorizers/{authorizer_id}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "authorizerId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              authorizerId: {
                location: "uri",
                locationName: "authorizer_id"
              }
            }
          },
          output: {
            shape: "Sf"
          }
        },
        GetAuthorizers: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/authorizers"
          },
          input: {
            type: "structure",
            required: [
              "restApiId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "Sf"
                }
              }
            }
          }
        },
        GetBasePathMapping: {
          http: {
            method: "GET",
            requestUri: "/domainnames/{domain_name}/basepathmappings/{base_path}"
          },
          input: {
            type: "structure",
            required: [
              "domainName",
              "basePath"
            ],
            members: {
              domainName: {
                location: "uri",
                locationName: "domain_name"
              },
              basePath: {
                location: "uri",
                locationName: "base_path"
              }
            }
          },
          output: {
            shape: "Sh"
          }
        },
        GetBasePathMappings: {
          http: {
            method: "GET",
            requestUri: "/domainnames/{domain_name}/basepathmappings"
          },
          input: {
            type: "structure",
            required: [
              "domainName"
            ],
            members: {
              domainName: {
                location: "uri",
                locationName: "domain_name"
              },
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "Sh"
                }
              }
            }
          }
        },
        GetClientCertificate: {
          http: {
            method: "GET",
            requestUri: "/clientcertificates/{clientcertificate_id}"
          },
          input: {
            type: "structure",
            required: [
              "clientCertificateId"
            ],
            members: {
              clientCertificateId: {
                location: "uri",
                locationName: "clientcertificate_id"
              }
            }
          },
          output: {
            shape: "S34"
          }
        },
        GetClientCertificates: {
          http: {
            method: "GET",
            requestUri: "/clientcertificates"
          },
          input: {
            type: "structure",
            members: {
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "S34"
                }
              }
            }
          }
        },
        GetDeployment: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/deployments/{deployment_id}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "deploymentId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              deploymentId: {
                location: "uri",
                locationName: "deployment_id"
              },
              embed: {
                shape: "S9",
                location: "querystring",
                locationName: "embed"
              }
            }
          },
          output: {
            shape: "Sn"
          }
        },
        GetDeployments: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/deployments"
          },
          input: {
            type: "structure",
            required: [
              "restApiId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "Sn"
                }
              }
            }
          }
        },
        GetDocumentationPart: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/documentation/parts/{part_id}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "documentationPartId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              documentationPartId: {
                location: "uri",
                locationName: "part_id"
              }
            }
          },
          output: {
            shape: "Sv"
          }
        },
        GetDocumentationParts: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/documentation/parts"
          },
          input: {
            type: "structure",
            required: [
              "restApiId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              type: {
                location: "querystring",
                locationName: "type"
              },
              nameQuery: {
                location: "querystring",
                locationName: "name"
              },
              path: {
                location: "querystring",
                locationName: "path"
              },
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              locationStatus: {
                location: "querystring",
                locationName: "locationStatus"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "Sv"
                }
              }
            }
          }
        },
        GetDocumentationVersion: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/documentation/versions/{doc_version}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "documentationVersion"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              documentationVersion: {
                location: "uri",
                locationName: "doc_version"
              }
            }
          },
          output: {
            shape: "Sx"
          }
        },
        GetDocumentationVersions: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/documentation/versions"
          },
          input: {
            type: "structure",
            required: [
              "restApiId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "Sx"
                }
              }
            }
          }
        },
        GetDomainName: {
          http: {
            method: "GET",
            requestUri: "/domainnames/{domain_name}"
          },
          input: {
            type: "structure",
            required: [
              "domainName"
            ],
            members: {
              domainName: {
                location: "uri",
                locationName: "domain_name"
              }
            }
          },
          output: {
            shape: "S14"
          }
        },
        GetDomainNames: {
          http: {
            method: "GET",
            requestUri: "/domainnames"
          },
          input: {
            type: "structure",
            members: {
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "S14"
                }
              }
            }
          }
        },
        GetExport: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/stages/{stage_name}/exports/{export_type}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "stageName",
              "exportType"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              stageName: {
                location: "uri",
                locationName: "stage_name"
              },
              exportType: {
                location: "uri",
                locationName: "export_type"
              },
              parameters: {
                shape: "S6",
                location: "querystring"
              },
              accepts: {
                location: "header",
                locationName: "Accept"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              contentType: {
                location: "header",
                locationName: "Content-Type"
              },
              contentDisposition: {
                location: "header",
                locationName: "Content-Disposition"
              },
              body: {
                type: "blob"
              }
            },
            payload: "body"
          }
        },
        GetGatewayResponse: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/gatewayresponses/{response_type}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "responseType"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              responseType: {
                location: "uri",
                locationName: "response_type"
              }
            }
          },
          output: {
            shape: "S48"
          }
        },
        GetGatewayResponses: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/gatewayresponses"
          },
          input: {
            type: "structure",
            required: [
              "restApiId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "S48"
                }
              }
            }
          }
        },
        GetIntegration: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}/integration"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              }
            }
          },
          output: {
            shape: "S1j"
          }
        },
        GetIntegrationResponse: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}/integration/responses/{status_code}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod",
              "statusCode"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              },
              statusCode: {
                location: "uri",
                locationName: "status_code"
              }
            }
          },
          output: {
            shape: "S1p"
          }
        },
        GetMethod: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              }
            }
          },
          output: {
            shape: "S1e"
          }
        },
        GetMethodResponse: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}/responses/{status_code}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod",
              "statusCode"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              },
              statusCode: {
                location: "uri",
                locationName: "status_code"
              }
            }
          },
          output: {
            shape: "S1h"
          }
        },
        GetModel: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/models/{model_name}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "modelName"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              modelName: {
                location: "uri",
                locationName: "model_name"
              },
              flatten: {
                location: "querystring",
                locationName: "flatten",
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S18"
          }
        },
        GetModelTemplate: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/models/{model_name}/default_template"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "modelName"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              modelName: {
                location: "uri",
                locationName: "model_name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              value: {}
            }
          }
        },
        GetModels: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/models"
          },
          input: {
            type: "structure",
            required: [
              "restApiId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "S18"
                }
              }
            }
          }
        },
        GetRequestValidator: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/requestvalidators/{requestvalidator_id}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "requestValidatorId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              requestValidatorId: {
                location: "uri",
                locationName: "requestvalidator_id"
              }
            }
          },
          output: {
            shape: "S1a"
          }
        },
        GetRequestValidators: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/requestvalidators"
          },
          input: {
            type: "structure",
            required: [
              "restApiId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "S1a"
                }
              }
            }
          }
        },
        GetResource: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              embed: {
                shape: "S9",
                location: "querystring",
                locationName: "embed"
              }
            }
          },
          output: {
            shape: "S1c"
          }
        },
        GetResources: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/resources"
          },
          input: {
            type: "structure",
            required: [
              "restApiId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              embed: {
                shape: "S9",
                location: "querystring",
                locationName: "embed"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "S1c"
                }
              }
            }
          }
        },
        GetRestApi: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              }
            }
          },
          output: {
            shape: "S1t"
          }
        },
        GetRestApis: {
          http: {
            method: "GET",
            requestUri: "/restapis"
          },
          input: {
            type: "structure",
            members: {
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "S1t"
                }
              }
            }
          }
        },
        GetSdk: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/stages/{stage_name}/sdks/{sdk_type}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "stageName",
              "sdkType"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              stageName: {
                location: "uri",
                locationName: "stage_name"
              },
              sdkType: {
                location: "uri",
                locationName: "sdk_type"
              },
              parameters: {
                shape: "S6",
                location: "querystring"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              contentType: {
                location: "header",
                locationName: "Content-Type"
              },
              contentDisposition: {
                location: "header",
                locationName: "Content-Disposition"
              },
              body: {
                type: "blob"
              }
            },
            payload: "body"
          }
        },
        GetSdkType: {
          http: {
            method: "GET",
            requestUri: "/sdktypes/{sdktype_id}"
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "sdktype_id"
              }
            }
          },
          output: {
            shape: "S51"
          }
        },
        GetSdkTypes: {
          http: {
            method: "GET",
            requestUri: "/sdktypes"
          },
          input: {
            type: "structure",
            members: {
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "S51"
                }
              }
            }
          }
        },
        GetStage: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/stages/{stage_name}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "stageName"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              stageName: {
                location: "uri",
                locationName: "stage_name"
              }
            }
          },
          output: {
            shape: "S1w"
          }
        },
        GetStages: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/stages"
          },
          input: {
            type: "structure",
            required: [
              "restApiId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              deploymentId: {
                location: "querystring",
                locationName: "deploymentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              item: {
                type: "list",
                member: {
                  shape: "S1w"
                }
              }
            }
          }
        },
        GetTags: {
          http: {
            method: "GET",
            requestUri: "/tags/{resource_arn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resource_arn"
              },
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S6"
              }
            }
          }
        },
        GetUsage: {
          http: {
            method: "GET",
            requestUri: "/usageplans/{usageplanId}/usage"
          },
          input: {
            type: "structure",
            required: [
              "usagePlanId",
              "startDate",
              "endDate"
            ],
            members: {
              usagePlanId: {
                location: "uri",
                locationName: "usageplanId"
              },
              keyId: {
                location: "querystring",
                locationName: "keyId"
              },
              startDate: {
                location: "querystring",
                locationName: "startDate"
              },
              endDate: {
                location: "querystring",
                locationName: "endDate"
              },
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            shape: "S5e"
          }
        },
        GetUsagePlan: {
          http: {
            method: "GET",
            requestUri: "/usageplans/{usageplanId}"
          },
          input: {
            type: "structure",
            required: [
              "usagePlanId"
            ],
            members: {
              usagePlanId: {
                location: "uri",
                locationName: "usageplanId"
              }
            }
          },
          output: {
            shape: "S29"
          }
        },
        GetUsagePlanKey: {
          http: {
            method: "GET",
            requestUri: "/usageplans/{usageplanId}/keys/{keyId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "usagePlanId",
              "keyId"
            ],
            members: {
              usagePlanId: {
                location: "uri",
                locationName: "usageplanId"
              },
              keyId: {
                location: "uri",
                locationName: "keyId"
              }
            }
          },
          output: {
            shape: "S2b"
          }
        },
        GetUsagePlanKeys: {
          http: {
            method: "GET",
            requestUri: "/usageplans/{usageplanId}/keys"
          },
          input: {
            type: "structure",
            required: [
              "usagePlanId"
            ],
            members: {
              usagePlanId: {
                location: "uri",
                locationName: "usageplanId"
              },
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              nameQuery: {
                location: "querystring",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "S2b"
                }
              }
            }
          }
        },
        GetUsagePlans: {
          http: {
            method: "GET",
            requestUri: "/usageplans"
          },
          input: {
            type: "structure",
            members: {
              position: {
                location: "querystring",
                locationName: "position"
              },
              keyId: {
                location: "querystring",
                locationName: "keyId"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "S29"
                }
              }
            }
          }
        },
        GetVpcLink: {
          http: {
            method: "GET",
            requestUri: "/vpclinks/{vpclink_id}"
          },
          input: {
            type: "structure",
            required: [
              "vpcLinkId"
            ],
            members: {
              vpcLinkId: {
                location: "uri",
                locationName: "vpclink_id"
              }
            }
          },
          output: {
            shape: "S2d"
          }
        },
        GetVpcLinks: {
          http: {
            method: "GET",
            requestUri: "/vpclinks"
          },
          input: {
            type: "structure",
            members: {
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "S2d"
                }
              }
            }
          }
        },
        ImportApiKeys: {
          http: {
            requestUri: "/apikeys?mode=import",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "body",
              "format"
            ],
            members: {
              body: {
                type: "blob"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              failOnWarnings: {
                location: "querystring",
                locationName: "failonwarnings",
                type: "boolean"
              }
            },
            payload: "body"
          },
          output: {
            type: "structure",
            members: {
              ids: {
                shape: "S9"
              },
              warnings: {
                shape: "S9"
              }
            }
          }
        },
        ImportDocumentationParts: {
          http: {
            method: "PUT",
            requestUri: "/restapis/{restapi_id}/documentation/parts"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "body"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              mode: {
                location: "querystring",
                locationName: "mode"
              },
              failOnWarnings: {
                location: "querystring",
                locationName: "failonwarnings",
                type: "boolean"
              },
              body: {
                type: "blob"
              }
            },
            payload: "body"
          },
          output: {
            type: "structure",
            members: {
              ids: {
                shape: "S9"
              },
              warnings: {
                shape: "S9"
              }
            }
          }
        },
        ImportRestApi: {
          http: {
            requestUri: "/restapis?mode=import",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "body"
            ],
            members: {
              failOnWarnings: {
                location: "querystring",
                locationName: "failonwarnings",
                type: "boolean"
              },
              parameters: {
                shape: "S6",
                location: "querystring"
              },
              body: {
                type: "blob"
              }
            },
            payload: "body"
          },
          output: {
            shape: "S1t"
          }
        },
        PutGatewayResponse: {
          http: {
            method: "PUT",
            requestUri: "/restapis/{restapi_id}/gatewayresponses/{response_type}",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "responseType"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              responseType: {
                location: "uri",
                locationName: "response_type"
              },
              statusCode: {},
              responseParameters: {
                shape: "S6"
              },
              responseTemplates: {
                shape: "S6"
              }
            }
          },
          output: {
            shape: "S48"
          }
        },
        PutIntegration: {
          http: {
            method: "PUT",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}/integration",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod",
              "type"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              },
              type: {},
              integrationHttpMethod: {
                locationName: "httpMethod"
              },
              uri: {},
              connectionType: {},
              connectionId: {},
              credentials: {},
              requestParameters: {
                shape: "S6"
              },
              requestTemplates: {
                shape: "S6"
              },
              passthroughBehavior: {},
              cacheNamespace: {},
              cacheKeyParameters: {
                shape: "S9"
              },
              contentHandling: {},
              timeoutInMillis: {
                type: "integer"
              },
              tlsConfig: {
                shape: "S1q"
              }
            }
          },
          output: {
            shape: "S1j"
          }
        },
        PutIntegrationResponse: {
          http: {
            method: "PUT",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}/integration/responses/{status_code}",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod",
              "statusCode"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              },
              statusCode: {
                location: "uri",
                locationName: "status_code"
              },
              selectionPattern: {},
              responseParameters: {
                shape: "S6"
              },
              responseTemplates: {
                shape: "S6"
              },
              contentHandling: {}
            }
          },
          output: {
            shape: "S1p"
          }
        },
        PutMethod: {
          http: {
            method: "PUT",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod",
              "authorizationType"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              },
              authorizationType: {},
              authorizerId: {},
              apiKeyRequired: {
                type: "boolean"
              },
              operationName: {},
              requestParameters: {
                shape: "S1f"
              },
              requestModels: {
                shape: "S6"
              },
              requestValidatorId: {},
              authorizationScopes: {
                shape: "S9"
              }
            }
          },
          output: {
            shape: "S1e"
          }
        },
        PutMethodResponse: {
          http: {
            method: "PUT",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}/responses/{status_code}",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod",
              "statusCode"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              },
              statusCode: {
                location: "uri",
                locationName: "status_code"
              },
              responseParameters: {
                shape: "S1f"
              },
              responseModels: {
                shape: "S6"
              }
            }
          },
          output: {
            shape: "S1h"
          }
        },
        PutRestApi: {
          http: {
            method: "PUT",
            requestUri: "/restapis/{restapi_id}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "body"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              mode: {
                location: "querystring",
                locationName: "mode"
              },
              failOnWarnings: {
                location: "querystring",
                locationName: "failonwarnings",
                type: "boolean"
              },
              parameters: {
                shape: "S6",
                location: "querystring"
              },
              body: {
                type: "blob"
              }
            },
            payload: "body"
          },
          output: {
            shape: "S1t"
          }
        },
        TagResource: {
          http: {
            method: "PUT",
            requestUri: "/tags/{resource_arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resource_arn"
              },
              tags: {
                shape: "S6"
              }
            }
          }
        },
        TestInvokeAuthorizer: {
          http: {
            requestUri: "/restapis/{restapi_id}/authorizers/{authorizer_id}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "authorizerId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              authorizerId: {
                location: "uri",
                locationName: "authorizer_id"
              },
              headers: {
                shape: "S6"
              },
              multiValueHeaders: {
                shape: "S6a"
              },
              pathWithQueryString: {},
              body: {},
              stageVariables: {
                shape: "S6"
              },
              additionalContext: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              clientStatus: {
                type: "integer"
              },
              log: {},
              latency: {
                type: "long"
              },
              principalId: {},
              policy: {},
              authorization: {
                shape: "S6a"
              },
              claims: {
                shape: "S6"
              }
            }
          }
        },
        TestInvokeMethod: {
          http: {
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              },
              pathWithQueryString: {},
              body: {},
              headers: {
                shape: "S6"
              },
              multiValueHeaders: {
                shape: "S6a"
              },
              clientCertificateId: {},
              stageVariables: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              status: {
                type: "integer"
              },
              body: {},
              headers: {
                shape: "S6"
              },
              multiValueHeaders: {
                shape: "S6a"
              },
              log: {},
              latency: {
                type: "long"
              }
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resource_arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resource_arn"
              },
              tagKeys: {
                shape: "S9",
                location: "querystring",
                locationName: "tagKeys"
              }
            }
          }
        },
        UpdateAccount: {
          http: {
            method: "PATCH",
            requestUri: "/account"
          },
          input: {
            type: "structure",
            members: {
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S36"
          }
        },
        UpdateApiKey: {
          http: {
            method: "PATCH",
            requestUri: "/apikeys/{api_Key}"
          },
          input: {
            type: "structure",
            required: [
              "apiKey"
            ],
            members: {
              apiKey: {
                location: "uri",
                locationName: "api_Key"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S7"
          }
        },
        UpdateAuthorizer: {
          http: {
            method: "PATCH",
            requestUri: "/restapis/{restapi_id}/authorizers/{authorizer_id}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "authorizerId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              authorizerId: {
                location: "uri",
                locationName: "authorizer_id"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "Sf"
          }
        },
        UpdateBasePathMapping: {
          http: {
            method: "PATCH",
            requestUri: "/domainnames/{domain_name}/basepathmappings/{base_path}"
          },
          input: {
            type: "structure",
            required: [
              "domainName",
              "basePath"
            ],
            members: {
              domainName: {
                location: "uri",
                locationName: "domain_name"
              },
              basePath: {
                location: "uri",
                locationName: "base_path"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "Sh"
          }
        },
        UpdateClientCertificate: {
          http: {
            method: "PATCH",
            requestUri: "/clientcertificates/{clientcertificate_id}"
          },
          input: {
            type: "structure",
            required: [
              "clientCertificateId"
            ],
            members: {
              clientCertificateId: {
                location: "uri",
                locationName: "clientcertificate_id"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S34"
          }
        },
        UpdateDeployment: {
          http: {
            method: "PATCH",
            requestUri: "/restapis/{restapi_id}/deployments/{deployment_id}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "deploymentId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              deploymentId: {
                location: "uri",
                locationName: "deployment_id"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "Sn"
          }
        },
        UpdateDocumentationPart: {
          http: {
            method: "PATCH",
            requestUri: "/restapis/{restapi_id}/documentation/parts/{part_id}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "documentationPartId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              documentationPartId: {
                location: "uri",
                locationName: "part_id"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "Sv"
          }
        },
        UpdateDocumentationVersion: {
          http: {
            method: "PATCH",
            requestUri: "/restapis/{restapi_id}/documentation/versions/{doc_version}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "documentationVersion"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              documentationVersion: {
                location: "uri",
                locationName: "doc_version"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "Sx"
          }
        },
        UpdateDomainName: {
          http: {
            method: "PATCH",
            requestUri: "/domainnames/{domain_name}"
          },
          input: {
            type: "structure",
            required: [
              "domainName"
            ],
            members: {
              domainName: {
                location: "uri",
                locationName: "domain_name"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S14"
          }
        },
        UpdateGatewayResponse: {
          http: {
            method: "PATCH",
            requestUri: "/restapis/{restapi_id}/gatewayresponses/{response_type}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "responseType"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              responseType: {
                location: "uri",
                locationName: "response_type"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S48"
          }
        },
        UpdateIntegration: {
          http: {
            method: "PATCH",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}/integration"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S1j"
          }
        },
        UpdateIntegrationResponse: {
          http: {
            method: "PATCH",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}/integration/responses/{status_code}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod",
              "statusCode"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              },
              statusCode: {
                location: "uri",
                locationName: "status_code"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S1p"
          }
        },
        UpdateMethod: {
          http: {
            method: "PATCH",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S1e"
          }
        },
        UpdateMethodResponse: {
          http: {
            method: "PATCH",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}/responses/{status_code}",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod",
              "statusCode"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              },
              statusCode: {
                location: "uri",
                locationName: "status_code"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S1h"
          }
        },
        UpdateModel: {
          http: {
            method: "PATCH",
            requestUri: "/restapis/{restapi_id}/models/{model_name}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "modelName"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              modelName: {
                location: "uri",
                locationName: "model_name"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S18"
          }
        },
        UpdateRequestValidator: {
          http: {
            method: "PATCH",
            requestUri: "/restapis/{restapi_id}/requestvalidators/{requestvalidator_id}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "requestValidatorId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              requestValidatorId: {
                location: "uri",
                locationName: "requestvalidator_id"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S1a"
          }
        },
        UpdateResource: {
          http: {
            method: "PATCH",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S1c"
          }
        },
        UpdateRestApi: {
          http: {
            method: "PATCH",
            requestUri: "/restapis/{restapi_id}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S1t"
          }
        },
        UpdateStage: {
          http: {
            method: "PATCH",
            requestUri: "/restapis/{restapi_id}/stages/{stage_name}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "stageName"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              stageName: {
                location: "uri",
                locationName: "stage_name"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S1w"
          }
        },
        UpdateUsage: {
          http: {
            method: "PATCH",
            requestUri: "/usageplans/{usageplanId}/keys/{keyId}/usage"
          },
          input: {
            type: "structure",
            required: [
              "usagePlanId",
              "keyId"
            ],
            members: {
              usagePlanId: {
                location: "uri",
                locationName: "usageplanId"
              },
              keyId: {
                location: "uri",
                locationName: "keyId"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S5e"
          }
        },
        UpdateUsagePlan: {
          http: {
            method: "PATCH",
            requestUri: "/usageplans/{usageplanId}"
          },
          input: {
            type: "structure",
            required: [
              "usagePlanId"
            ],
            members: {
              usagePlanId: {
                location: "uri",
                locationName: "usageplanId"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S29"
          }
        },
        UpdateVpcLink: {
          http: {
            method: "PATCH",
            requestUri: "/vpclinks/{vpclink_id}"
          },
          input: {
            type: "structure",
            required: [
              "vpcLinkId"
            ],
            members: {
              vpcLinkId: {
                location: "uri",
                locationName: "vpclink_id"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S2d"
          }
        }
      },
      shapes: {
        S6: {
          type: "map",
          key: {},
          value: {}
        },
        S7: {
          type: "structure",
          members: {
            id: {},
            value: {},
            name: {},
            customerId: {},
            description: {},
            enabled: {
              type: "boolean"
            },
            createdDate: {
              type: "timestamp"
            },
            lastUpdatedDate: {
              type: "timestamp"
            },
            stageKeys: {
              shape: "S9"
            },
            tags: {
              shape: "S6"
            }
          }
        },
        S9: {
          type: "list",
          member: {}
        },
        Sc: {
          type: "list",
          member: {}
        },
        Sf: {
          type: "structure",
          members: {
            id: {},
            name: {},
            type: {},
            providerARNs: {
              shape: "Sc"
            },
            authType: {},
            authorizerUri: {},
            authorizerCredentials: {},
            identitySource: {},
            identityValidationExpression: {},
            authorizerResultTtlInSeconds: {
              type: "integer"
            }
          }
        },
        Sh: {
          type: "structure",
          members: {
            basePath: {},
            restApiId: {},
            stage: {}
          }
        },
        Sn: {
          type: "structure",
          members: {
            id: {},
            description: {},
            createdDate: {
              type: "timestamp"
            },
            apiSummary: {
              type: "map",
              key: {},
              value: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    authorizationType: {},
                    apiKeyRequired: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        Ss: {
          type: "structure",
          required: [
            "type"
          ],
          members: {
            type: {},
            path: {},
            method: {},
            statusCode: {},
            name: {}
          }
        },
        Sv: {
          type: "structure",
          members: {
            id: {},
            location: {
              shape: "Ss"
            },
            properties: {}
          }
        },
        Sx: {
          type: "structure",
          members: {
            version: {},
            createdDate: {
              type: "timestamp"
            },
            description: {}
          }
        },
        Sz: {
          type: "structure",
          members: {
            types: {
              type: "list",
              member: {}
            },
            vpcEndpointIds: {
              shape: "S9"
            }
          }
        },
        S14: {
          type: "structure",
          members: {
            domainName: {},
            certificateName: {},
            certificateArn: {},
            certificateUploadDate: {
              type: "timestamp"
            },
            regionalDomainName: {},
            regionalHostedZoneId: {},
            regionalCertificateName: {},
            regionalCertificateArn: {},
            distributionDomainName: {},
            distributionHostedZoneId: {},
            endpointConfiguration: {
              shape: "Sz"
            },
            domainNameStatus: {},
            domainNameStatusMessage: {},
            securityPolicy: {},
            tags: {
              shape: "S6"
            },
            mutualTlsAuthentication: {
              type: "structure",
              members: {
                truststoreUri: {},
                truststoreVersion: {},
                truststoreWarnings: {
                  shape: "S9"
                }
              }
            },
            ownershipVerificationCertificateArn: {}
          }
        },
        S18: {
          type: "structure",
          members: {
            id: {},
            name: {},
            description: {},
            schema: {},
            contentType: {}
          }
        },
        S1a: {
          type: "structure",
          members: {
            id: {},
            name: {},
            validateRequestBody: {
              type: "boolean"
            },
            validateRequestParameters: {
              type: "boolean"
            }
          }
        },
        S1c: {
          type: "structure",
          members: {
            id: {},
            parentId: {},
            pathPart: {},
            path: {},
            resourceMethods: {
              type: "map",
              key: {},
              value: {
                shape: "S1e"
              }
            }
          }
        },
        S1e: {
          type: "structure",
          members: {
            httpMethod: {},
            authorizationType: {},
            authorizerId: {},
            apiKeyRequired: {
              type: "boolean"
            },
            requestValidatorId: {},
            operationName: {},
            requestParameters: {
              shape: "S1f"
            },
            requestModels: {
              shape: "S6"
            },
            methodResponses: {
              type: "map",
              key: {},
              value: {
                shape: "S1h"
              }
            },
            methodIntegration: {
              shape: "S1j"
            },
            authorizationScopes: {
              shape: "S9"
            }
          }
        },
        S1f: {
          type: "map",
          key: {},
          value: {
            type: "boolean"
          }
        },
        S1h: {
          type: "structure",
          members: {
            statusCode: {},
            responseParameters: {
              shape: "S1f"
            },
            responseModels: {
              shape: "S6"
            }
          }
        },
        S1j: {
          type: "structure",
          members: {
            type: {},
            httpMethod: {},
            uri: {},
            connectionType: {},
            connectionId: {},
            credentials: {},
            requestParameters: {
              shape: "S6"
            },
            requestTemplates: {
              shape: "S6"
            },
            passthroughBehavior: {},
            contentHandling: {},
            timeoutInMillis: {
              type: "integer"
            },
            cacheNamespace: {},
            cacheKeyParameters: {
              shape: "S9"
            },
            integrationResponses: {
              type: "map",
              key: {},
              value: {
                shape: "S1p"
              }
            },
            tlsConfig: {
              shape: "S1q"
            }
          }
        },
        S1p: {
          type: "structure",
          members: {
            statusCode: {},
            selectionPattern: {},
            responseParameters: {
              shape: "S6"
            },
            responseTemplates: {
              shape: "S6"
            },
            contentHandling: {}
          }
        },
        S1q: {
          type: "structure",
          members: {
            insecureSkipVerification: {
              type: "boolean"
            }
          }
        },
        S1t: {
          type: "structure",
          members: {
            id: {},
            name: {},
            description: {},
            createdDate: {
              type: "timestamp"
            },
            version: {},
            warnings: {
              shape: "S9"
            },
            binaryMediaTypes: {
              shape: "S9"
            },
            minimumCompressionSize: {
              type: "integer"
            },
            apiKeySource: {},
            endpointConfiguration: {
              shape: "Sz"
            },
            policy: {},
            tags: {
              shape: "S6"
            },
            disableExecuteApiEndpoint: {
              type: "boolean"
            },
            rootResourceId: {}
          }
        },
        S1v: {
          type: "structure",
          members: {
            percentTraffic: {
              type: "double"
            },
            deploymentId: {},
            stageVariableOverrides: {
              shape: "S6"
            },
            useStageCache: {
              type: "boolean"
            }
          }
        },
        S1w: {
          type: "structure",
          members: {
            deploymentId: {},
            clientCertificateId: {},
            stageName: {},
            description: {},
            cacheClusterEnabled: {
              type: "boolean"
            },
            cacheClusterSize: {},
            cacheClusterStatus: {},
            methodSettings: {
              type: "map",
              key: {},
              value: {
                type: "structure",
                members: {
                  metricsEnabled: {
                    type: "boolean"
                  },
                  loggingLevel: {},
                  dataTraceEnabled: {
                    type: "boolean"
                  },
                  throttlingBurstLimit: {
                    type: "integer"
                  },
                  throttlingRateLimit: {
                    type: "double"
                  },
                  cachingEnabled: {
                    type: "boolean"
                  },
                  cacheTtlInSeconds: {
                    type: "integer"
                  },
                  cacheDataEncrypted: {
                    type: "boolean"
                  },
                  requireAuthorizationForCacheControl: {
                    type: "boolean"
                  },
                  unauthorizedCacheControlHeaderStrategy: {}
                }
              }
            },
            variables: {
              shape: "S6"
            },
            documentationVersion: {},
            accessLogSettings: {
              type: "structure",
              members: {
                format: {},
                destinationArn: {}
              }
            },
            canarySettings: {
              shape: "S1v"
            },
            tracingEnabled: {
              type: "boolean"
            },
            webAclArn: {},
            tags: {
              shape: "S6"
            },
            createdDate: {
              type: "timestamp"
            },
            lastUpdatedDate: {
              type: "timestamp"
            }
          }
        },
        S23: {
          type: "list",
          member: {
            type: "structure",
            members: {
              apiId: {},
              stage: {},
              throttle: {
                type: "map",
                key: {},
                value: {
                  shape: "S26"
                }
              }
            }
          }
        },
        S26: {
          type: "structure",
          members: {
            burstLimit: {
              type: "integer"
            },
            rateLimit: {
              type: "double"
            }
          }
        },
        S27: {
          type: "structure",
          members: {
            limit: {
              type: "integer"
            },
            offset: {
              type: "integer"
            },
            period: {}
          }
        },
        S29: {
          type: "structure",
          members: {
            id: {},
            name: {},
            description: {},
            apiStages: {
              shape: "S23"
            },
            throttle: {
              shape: "S26"
            },
            quota: {
              shape: "S27"
            },
            productCode: {},
            tags: {
              shape: "S6"
            }
          }
        },
        S2b: {
          type: "structure",
          members: {
            id: {},
            type: {},
            value: {},
            name: {}
          }
        },
        S2d: {
          type: "structure",
          members: {
            id: {},
            name: {},
            description: {},
            targetArns: {
              shape: "S9"
            },
            status: {},
            statusMessage: {},
            tags: {
              shape: "S6"
            }
          }
        },
        S34: {
          type: "structure",
          members: {
            clientCertificateId: {},
            description: {},
            pemEncodedCertificate: {},
            createdDate: {
              type: "timestamp"
            },
            expirationDate: {
              type: "timestamp"
            },
            tags: {
              shape: "S6"
            }
          }
        },
        S36: {
          type: "structure",
          members: {
            cloudwatchRoleArn: {},
            throttleSettings: {
              shape: "S26"
            },
            features: {
              shape: "S9"
            },
            apiKeyVersion: {}
          }
        },
        S48: {
          type: "structure",
          members: {
            responseType: {},
            statusCode: {},
            responseParameters: {
              shape: "S6"
            },
            responseTemplates: {
              shape: "S6"
            },
            defaultResponse: {
              type: "boolean"
            }
          }
        },
        S51: {
          type: "structure",
          members: {
            id: {},
            friendlyName: {},
            description: {},
            configurationProperties: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  name: {},
                  friendlyName: {},
                  description: {},
                  required: {
                    type: "boolean"
                  },
                  defaultValue: {}
                }
              }
            }
          }
        },
        S5e: {
          type: "structure",
          members: {
            usagePlanId: {},
            startDate: {},
            endDate: {},
            position: {},
            items: {
              locationName: "values",
              type: "map",
              key: {},
              value: {
                type: "list",
                member: {
                  type: "list",
                  member: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        S6a: {
          type: "map",
          key: {},
          value: {
            shape: "S9"
          }
        },
        S6g: {
          type: "list",
          member: {
            type: "structure",
            members: {
              op: {},
              path: {},
              value: {},
              from: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/apigateway-2015-07-09.paginators.json
var require_apigateway_2015_07_09_paginators = __commonJS({
  "node_modules/aws-sdk/apis/apigateway-2015-07-09.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetApiKeys: {
          input_token: "position",
          limit_key: "limit",
          output_token: "position",
          result_key: "items"
        },
        GetBasePathMappings: {
          input_token: "position",
          limit_key: "limit",
          output_token: "position",
          result_key: "items"
        },
        GetClientCertificates: {
          input_token: "position",
          limit_key: "limit",
          output_token: "position",
          result_key: "items"
        },
        GetDeployments: {
          input_token: "position",
          limit_key: "limit",
          output_token: "position",
          result_key: "items"
        },
        GetDomainNames: {
          input_token: "position",
          limit_key: "limit",
          output_token: "position",
          result_key: "items"
        },
        GetModels: {
          input_token: "position",
          limit_key: "limit",
          output_token: "position",
          result_key: "items"
        },
        GetResources: {
          input_token: "position",
          limit_key: "limit",
          output_token: "position",
          result_key: "items"
        },
        GetRestApis: {
          input_token: "position",
          limit_key: "limit",
          output_token: "position",
          result_key: "items"
        },
        GetUsage: {
          input_token: "position",
          limit_key: "limit",
          non_aggregate_keys: [
            "usagePlanId",
            "startDate",
            "endDate"
          ],
          output_token: "position",
          result_key: "items"
        },
        GetUsagePlanKeys: {
          input_token: "position",
          limit_key: "limit",
          output_token: "position",
          result_key: "items"
        },
        GetUsagePlans: {
          input_token: "position",
          limit_key: "limit",
          output_token: "position",
          result_key: "items"
        },
        GetVpcLinks: {
          input_token: "position",
          limit_key: "limit",
          output_token: "position",
          result_key: "items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/apigateway.js
var require_apigateway2 = __commonJS({
  "node_modules/aws-sdk/clients/apigateway.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["apigateway"] = {};
    AWS2.APIGateway = Service.defineService("apigateway", ["2015-07-09"]);
    require_apigateway();
    Object.defineProperty(apiLoader.services["apigateway"], "2015-07-09", {
      get: function get() {
        var model = require_apigateway_2015_07_09_min();
        model.paginators = require_apigateway_2015_07_09_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.APIGateway;
  }
});

// node_modules/aws-sdk/apis/application-autoscaling-2016-02-06.min.json
var require_application_autoscaling_2016_02_06_min = __commonJS({
  "node_modules/aws-sdk/apis/application-autoscaling-2016-02-06.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-02-06",
        endpointPrefix: "application-autoscaling",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Application Auto Scaling",
        serviceId: "Application Auto Scaling",
        signatureVersion: "v4",
        signingName: "application-autoscaling",
        targetPrefix: "AnyScaleFrontendService",
        uid: "application-autoscaling-2016-02-06"
      },
      operations: {
        DeleteScalingPolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyName",
              "ServiceNamespace",
              "ResourceId",
              "ScalableDimension"
            ],
            members: {
              PolicyName: {},
              ServiceNamespace: {},
              ResourceId: {},
              ScalableDimension: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteScheduledAction: {
          input: {
            type: "structure",
            required: [
              "ServiceNamespace",
              "ScheduledActionName",
              "ResourceId",
              "ScalableDimension"
            ],
            members: {
              ServiceNamespace: {},
              ScheduledActionName: {},
              ResourceId: {},
              ScalableDimension: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeregisterScalableTarget: {
          input: {
            type: "structure",
            required: [
              "ServiceNamespace",
              "ResourceId",
              "ScalableDimension"
            ],
            members: {
              ServiceNamespace: {},
              ResourceId: {},
              ScalableDimension: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeScalableTargets: {
          input: {
            type: "structure",
            required: [
              "ServiceNamespace"
            ],
            members: {
              ServiceNamespace: {},
              ResourceIds: {
                shape: "Sb"
              },
              ScalableDimension: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ScalableTargets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ServiceNamespace",
                    "ResourceId",
                    "ScalableDimension",
                    "MinCapacity",
                    "MaxCapacity",
                    "RoleARN",
                    "CreationTime"
                  ],
                  members: {
                    ServiceNamespace: {},
                    ResourceId: {},
                    ScalableDimension: {},
                    MinCapacity: {
                      type: "integer"
                    },
                    MaxCapacity: {
                      type: "integer"
                    },
                    RoleARN: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    SuspendedState: {
                      shape: "Sj"
                    },
                    ScalableTargetARN: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeScalingActivities: {
          input: {
            type: "structure",
            required: [
              "ServiceNamespace"
            ],
            members: {
              ServiceNamespace: {},
              ResourceId: {},
              ScalableDimension: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              IncludeNotScaledActivities: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ScalingActivities: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ActivityId",
                    "ServiceNamespace",
                    "ResourceId",
                    "ScalableDimension",
                    "Description",
                    "Cause",
                    "StartTime",
                    "StatusCode"
                  ],
                  members: {
                    ActivityId: {},
                    ServiceNamespace: {},
                    ResourceId: {},
                    ScalableDimension: {},
                    Description: {},
                    Cause: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    StatusCode: {},
                    StatusMessage: {},
                    Details: {},
                    NotScaledReasons: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "Code"
                        ],
                        members: {
                          Code: {},
                          MaxCapacity: {
                            type: "integer"
                          },
                          MinCapacity: {
                            type: "integer"
                          },
                          CurrentCapacity: {
                            type: "integer"
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeScalingPolicies: {
          input: {
            type: "structure",
            required: [
              "ServiceNamespace"
            ],
            members: {
              PolicyNames: {
                shape: "Sb"
              },
              ServiceNamespace: {},
              ResourceId: {},
              ScalableDimension: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ScalingPolicies: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "PolicyARN",
                    "PolicyName",
                    "ServiceNamespace",
                    "ResourceId",
                    "ScalableDimension",
                    "PolicyType",
                    "CreationTime"
                  ],
                  members: {
                    PolicyARN: {},
                    PolicyName: {},
                    ServiceNamespace: {},
                    ResourceId: {},
                    ScalableDimension: {},
                    PolicyType: {},
                    StepScalingPolicyConfiguration: {
                      shape: "S10"
                    },
                    TargetTrackingScalingPolicyConfiguration: {
                      shape: "S19"
                    },
                    Alarms: {
                      shape: "S21"
                    },
                    CreationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeScheduledActions: {
          input: {
            type: "structure",
            required: [
              "ServiceNamespace"
            ],
            members: {
              ScheduledActionNames: {
                shape: "Sb"
              },
              ServiceNamespace: {},
              ResourceId: {},
              ScalableDimension: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ScheduledActions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ScheduledActionName",
                    "ScheduledActionARN",
                    "ServiceNamespace",
                    "Schedule",
                    "ResourceId",
                    "CreationTime"
                  ],
                  members: {
                    ScheduledActionName: {},
                    ScheduledActionARN: {},
                    ServiceNamespace: {},
                    Schedule: {},
                    Timezone: {},
                    ResourceId: {},
                    ScalableDimension: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    ScalableTargetAction: {
                      shape: "S28"
                    },
                    CreationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S2c"
              }
            }
          }
        },
        PutScalingPolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyName",
              "ServiceNamespace",
              "ResourceId",
              "ScalableDimension"
            ],
            members: {
              PolicyName: {},
              ServiceNamespace: {},
              ResourceId: {},
              ScalableDimension: {},
              PolicyType: {},
              StepScalingPolicyConfiguration: {
                shape: "S10"
              },
              TargetTrackingScalingPolicyConfiguration: {
                shape: "S19"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "PolicyARN"
            ],
            members: {
              PolicyARN: {},
              Alarms: {
                shape: "S21"
              }
            }
          }
        },
        PutScheduledAction: {
          input: {
            type: "structure",
            required: [
              "ServiceNamespace",
              "ScheduledActionName",
              "ResourceId",
              "ScalableDimension"
            ],
            members: {
              ServiceNamespace: {},
              Schedule: {},
              Timezone: {},
              ScheduledActionName: {},
              ResourceId: {},
              ScalableDimension: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              ScalableTargetAction: {
                shape: "S28"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RegisterScalableTarget: {
          input: {
            type: "structure",
            required: [
              "ServiceNamespace",
              "ResourceId",
              "ScalableDimension"
            ],
            members: {
              ServiceNamespace: {},
              ResourceId: {},
              ScalableDimension: {},
              MinCapacity: {
                type: "integer"
              },
              MaxCapacity: {
                type: "integer"
              },
              RoleARN: {},
              SuspendedState: {
                shape: "Sj"
              },
              Tags: {
                shape: "S2c"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ScalableTargetARN: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S2c"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        Sb: {
          type: "list",
          member: {}
        },
        Sj: {
          type: "structure",
          members: {
            DynamicScalingInSuspended: {
              type: "boolean"
            },
            DynamicScalingOutSuspended: {
              type: "boolean"
            },
            ScheduledScalingSuspended: {
              type: "boolean"
            }
          }
        },
        S10: {
          type: "structure",
          members: {
            AdjustmentType: {},
            StepAdjustments: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "ScalingAdjustment"
                ],
                members: {
                  MetricIntervalLowerBound: {
                    type: "double"
                  },
                  MetricIntervalUpperBound: {
                    type: "double"
                  },
                  ScalingAdjustment: {
                    type: "integer"
                  }
                }
              }
            },
            MinAdjustmentMagnitude: {
              type: "integer"
            },
            Cooldown: {
              type: "integer"
            },
            MetricAggregationType: {}
          }
        },
        S19: {
          type: "structure",
          required: [
            "TargetValue"
          ],
          members: {
            TargetValue: {
              type: "double"
            },
            PredefinedMetricSpecification: {
              type: "structure",
              required: [
                "PredefinedMetricType"
              ],
              members: {
                PredefinedMetricType: {},
                ResourceLabel: {}
              }
            },
            CustomizedMetricSpecification: {
              type: "structure",
              members: {
                MetricName: {},
                Namespace: {},
                Dimensions: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "Name",
                      "Value"
                    ],
                    members: {
                      Name: {},
                      Value: {}
                    }
                  }
                },
                Statistic: {},
                Unit: {},
                Metrics: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "Id"
                    ],
                    members: {
                      Expression: {},
                      Id: {},
                      Label: {},
                      MetricStat: {
                        type: "structure",
                        required: [
                          "Metric",
                          "Stat"
                        ],
                        members: {
                          Metric: {
                            type: "structure",
                            members: {
                              Dimensions: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  required: [
                                    "Name",
                                    "Value"
                                  ],
                                  members: {
                                    Name: {},
                                    Value: {}
                                  }
                                }
                              },
                              MetricName: {},
                              Namespace: {}
                            }
                          },
                          Stat: {},
                          Unit: {}
                        }
                      },
                      ReturnData: {
                        type: "boolean"
                      }
                    }
                  }
                }
              }
            },
            ScaleOutCooldown: {
              type: "integer"
            },
            ScaleInCooldown: {
              type: "integer"
            },
            DisableScaleIn: {
              type: "boolean"
            }
          }
        },
        S21: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AlarmName",
              "AlarmARN"
            ],
            members: {
              AlarmName: {},
              AlarmARN: {}
            }
          }
        },
        S28: {
          type: "structure",
          members: {
            MinCapacity: {
              type: "integer"
            },
            MaxCapacity: {
              type: "integer"
            }
          }
        },
        S2c: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/application-autoscaling-2016-02-06.paginators.json
var require_application_autoscaling_2016_02_06_paginators = __commonJS({
  "node_modules/aws-sdk/apis/application-autoscaling-2016-02-06.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeScalableTargets: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ScalableTargets"
        },
        DescribeScalingActivities: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ScalingActivities"
        },
        DescribeScalingPolicies: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ScalingPolicies"
        },
        DescribeScheduledActions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ScheduledActions"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/applicationautoscaling.js
var require_applicationautoscaling = __commonJS({
  "node_modules/aws-sdk/clients/applicationautoscaling.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["applicationautoscaling"] = {};
    AWS2.ApplicationAutoScaling = Service.defineService("applicationautoscaling", ["2016-02-06"]);
    Object.defineProperty(apiLoader.services["applicationautoscaling"], "2016-02-06", {
      get: function get() {
        var model = require_application_autoscaling_2016_02_06_min();
        model.paginators = require_application_autoscaling_2016_02_06_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ApplicationAutoScaling;
  }
});

// node_modules/aws-sdk/apis/appstream-2016-12-01.min.json
var require_appstream_2016_12_01_min = __commonJS({
  "node_modules/aws-sdk/apis/appstream-2016-12-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-12-01",
        endpointPrefix: "appstream2",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon AppStream",
        serviceId: "AppStream",
        signatureVersion: "v4",
        signingName: "appstream",
        targetPrefix: "PhotonAdminProxyService",
        uid: "appstream-2016-12-01"
      },
      operations: {
        AssociateAppBlockBuilderAppBlock: {
          input: {
            type: "structure",
            required: [
              "AppBlockArn",
              "AppBlockBuilderName"
            ],
            members: {
              AppBlockArn: {},
              AppBlockBuilderName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AppBlockBuilderAppBlockAssociation: {
                shape: "S5"
              }
            }
          }
        },
        AssociateApplicationFleet: {
          input: {
            type: "structure",
            required: [
              "FleetName",
              "ApplicationArn"
            ],
            members: {
              FleetName: {},
              ApplicationArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationFleetAssociation: {
                shape: "S8"
              }
            }
          }
        },
        AssociateApplicationToEntitlement: {
          input: {
            type: "structure",
            required: [
              "StackName",
              "EntitlementName",
              "ApplicationIdentifier"
            ],
            members: {
              StackName: {},
              EntitlementName: {},
              ApplicationIdentifier: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateFleet: {
          input: {
            type: "structure",
            required: [
              "FleetName",
              "StackName"
            ],
            members: {
              FleetName: {},
              StackName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        BatchAssociateUserStack: {
          input: {
            type: "structure",
            required: [
              "UserStackAssociations"
            ],
            members: {
              UserStackAssociations: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errors: {
                shape: "Sl"
              }
            }
          }
        },
        BatchDisassociateUserStack: {
          input: {
            type: "structure",
            required: [
              "UserStackAssociations"
            ],
            members: {
              UserStackAssociations: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errors: {
                shape: "Sl"
              }
            }
          }
        },
        CopyImage: {
          input: {
            type: "structure",
            required: [
              "SourceImageName",
              "DestinationImageName",
              "DestinationRegion"
            ],
            members: {
              SourceImageName: {},
              DestinationImageName: {},
              DestinationRegion: {},
              DestinationImageDescription: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DestinationImageName: {}
            }
          }
        },
        CreateAppBlock: {
          input: {
            type: "structure",
            required: [
              "Name",
              "SourceS3Location"
            ],
            members: {
              Name: {},
              Description: {},
              DisplayName: {},
              SourceS3Location: {
                shape: "Sw"
              },
              SetupScriptDetails: {
                shape: "Sz"
              },
              Tags: {
                shape: "S11"
              },
              PostSetupScriptDetails: {
                shape: "Sz"
              },
              PackagingType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AppBlock: {
                shape: "S16"
              }
            }
          }
        },
        CreateAppBlockBuilder: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Platform",
              "InstanceType",
              "VpcConfig"
            ],
            members: {
              Name: {},
              Description: {},
              DisplayName: {},
              Tags: {
                shape: "S11"
              },
              Platform: {},
              InstanceType: {},
              VpcConfig: {
                shape: "S1d"
              },
              EnableDefaultInternetAccess: {
                type: "boolean"
              },
              IamRoleArn: {},
              AccessEndpoints: {
                shape: "S1h"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppBlockBuilder: {
                shape: "S1l"
              }
            }
          }
        },
        CreateAppBlockBuilderStreamingURL: {
          input: {
            type: "structure",
            required: [
              "AppBlockBuilderName"
            ],
            members: {
              AppBlockBuilderName: {},
              Validity: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingURL: {},
              Expires: {
                type: "timestamp"
              }
            }
          }
        },
        CreateApplication: {
          input: {
            type: "structure",
            required: [
              "Name",
              "IconS3Location",
              "LaunchPath",
              "Platforms",
              "InstanceFamilies",
              "AppBlockArn"
            ],
            members: {
              Name: {},
              DisplayName: {},
              Description: {},
              IconS3Location: {
                shape: "Sw"
              },
              LaunchPath: {},
              WorkingDirectory: {},
              LaunchParameters: {},
              Platforms: {
                shape: "S1w"
              },
              InstanceFamilies: {
                shape: "S1y"
              },
              AppBlockArn: {},
              Tags: {
                shape: "S11"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Application: {
                shape: "S20"
              }
            }
          }
        },
        CreateDirectoryConfig: {
          input: {
            type: "structure",
            required: [
              "DirectoryName",
              "OrganizationalUnitDistinguishedNames"
            ],
            members: {
              DirectoryName: {},
              OrganizationalUnitDistinguishedNames: {
                shape: "S24"
              },
              ServiceAccountCredentials: {
                shape: "S26"
              },
              CertificateBasedAuthProperties: {
                shape: "S29"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DirectoryConfig: {
                shape: "S2c"
              }
            }
          }
        },
        CreateEntitlement: {
          input: {
            type: "structure",
            required: [
              "Name",
              "StackName",
              "AppVisibility",
              "Attributes"
            ],
            members: {
              Name: {},
              StackName: {},
              Description: {},
              AppVisibility: {},
              Attributes: {
                shape: "S2f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Entitlement: {
                shape: "S2i"
              }
            }
          }
        },
        CreateFleet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "InstanceType"
            ],
            members: {
              Name: {},
              ImageName: {},
              ImageArn: {},
              InstanceType: {},
              FleetType: {},
              ComputeCapacity: {
                shape: "S2l"
              },
              VpcConfig: {
                shape: "S1d"
              },
              MaxUserDurationInSeconds: {
                type: "integer"
              },
              DisconnectTimeoutInSeconds: {
                type: "integer"
              },
              Description: {},
              DisplayName: {},
              EnableDefaultInternetAccess: {
                type: "boolean"
              },
              DomainJoinInfo: {
                shape: "S2m"
              },
              Tags: {
                shape: "S11"
              },
              IdleDisconnectTimeoutInSeconds: {
                type: "integer"
              },
              IamRoleArn: {},
              StreamView: {},
              Platform: {},
              MaxConcurrentSessions: {
                type: "integer"
              },
              UsbDeviceFilterStrings: {
                shape: "S2o"
              },
              SessionScriptS3Location: {
                shape: "Sw"
              },
              MaxSessionsPerInstance: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Fleet: {
                shape: "S2r"
              }
            }
          }
        },
        CreateImageBuilder: {
          input: {
            type: "structure",
            required: [
              "Name",
              "InstanceType"
            ],
            members: {
              Name: {},
              ImageName: {},
              ImageArn: {},
              InstanceType: {},
              Description: {},
              DisplayName: {},
              VpcConfig: {
                shape: "S1d"
              },
              IamRoleArn: {},
              EnableDefaultInternetAccess: {
                type: "boolean"
              },
              DomainJoinInfo: {
                shape: "S2m"
              },
              AppstreamAgentVersion: {},
              Tags: {
                shape: "S11"
              },
              AccessEndpoints: {
                shape: "S1h"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ImageBuilder: {
                shape: "S2z"
              }
            }
          }
        },
        CreateImageBuilderStreamingURL: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Validity: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingURL: {},
              Expires: {
                type: "timestamp"
              }
            }
          }
        },
        CreateStack: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Description: {},
              DisplayName: {},
              StorageConnectors: {
                shape: "S37"
              },
              RedirectURL: {},
              FeedbackURL: {},
              UserSettings: {
                shape: "S3f"
              },
              ApplicationSettings: {
                shape: "S3j"
              },
              Tags: {
                shape: "S11"
              },
              AccessEndpoints: {
                shape: "S1h"
              },
              EmbedHostDomains: {
                shape: "S3l"
              },
              StreamingExperienceSettings: {
                shape: "S3n"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Stack: {
                shape: "S3q"
              }
            }
          }
        },
        CreateStreamingURL: {
          input: {
            type: "structure",
            required: [
              "StackName",
              "FleetName",
              "UserId"
            ],
            members: {
              StackName: {},
              FleetName: {},
              UserId: {},
              ApplicationId: {},
              Validity: {
                type: "long"
              },
              SessionContext: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingURL: {},
              Expires: {
                type: "timestamp"
              }
            }
          }
        },
        CreateUpdatedImage: {
          input: {
            type: "structure",
            required: [
              "existingImageName",
              "newImageName"
            ],
            members: {
              existingImageName: {},
              newImageName: {},
              newImageDescription: {},
              newImageDisplayName: {},
              newImageTags: {
                shape: "S11"
              },
              dryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              image: {
                shape: "S40"
              },
              canUpdateImage: {
                type: "boolean"
              }
            }
          }
        },
        CreateUsageReportSubscription: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              S3BucketName: {},
              Schedule: {}
            }
          }
        },
        CreateUser: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "AuthenticationType"
            ],
            members: {
              UserName: {
                shape: "Sh"
              },
              MessageAction: {},
              FirstName: {
                shape: "S4c"
              },
              LastName: {
                shape: "S4c"
              },
              AuthenticationType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAppBlock: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAppBlockBuilder: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteApplication: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDirectoryConfig: {
          input: {
            type: "structure",
            required: [
              "DirectoryName"
            ],
            members: {
              DirectoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteEntitlement: {
          input: {
            type: "structure",
            required: [
              "Name",
              "StackName"
            ],
            members: {
              Name: {},
              StackName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteFleet: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteImage: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Image: {
                shape: "S40"
              }
            }
          }
        },
        DeleteImageBuilder: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ImageBuilder: {
                shape: "S2z"
              }
            }
          }
        },
        DeleteImagePermissions: {
          input: {
            type: "structure",
            required: [
              "Name",
              "SharedAccountId"
            ],
            members: {
              Name: {},
              SharedAccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteStack: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteUsageReportSubscription: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteUser: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "AuthenticationType"
            ],
            members: {
              UserName: {
                shape: "Sh"
              },
              AuthenticationType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeAppBlockBuilderAppBlockAssociations: {
          input: {
            type: "structure",
            members: {
              AppBlockArn: {},
              AppBlockBuilderName: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AppBlockBuilderAppBlockAssociations: {
                type: "list",
                member: {
                  shape: "S5"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeAppBlockBuilders: {
          input: {
            type: "structure",
            members: {
              Names: {
                shape: "S1y"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppBlockBuilders: {
                type: "list",
                member: {
                  shape: "S1l"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeAppBlocks: {
          input: {
            type: "structure",
            members: {
              Arns: {
                shape: "S5a"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppBlocks: {
                type: "list",
                member: {
                  shape: "S16"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeApplicationFleetAssociations: {
          input: {
            type: "structure",
            members: {
              FleetName: {},
              ApplicationArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationFleetAssociations: {
                type: "list",
                member: {
                  shape: "S8"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeApplications: {
          input: {
            type: "structure",
            members: {
              Arns: {
                shape: "S5a"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Applications: {
                shape: "S45"
              },
              NextToken: {}
            }
          }
        },
        DescribeDirectoryConfigs: {
          input: {
            type: "structure",
            members: {
              DirectoryNames: {
                type: "list",
                member: {}
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DirectoryConfigs: {
                type: "list",
                member: {
                  shape: "S2c"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeEntitlements: {
          input: {
            type: "structure",
            required: [
              "StackName"
            ],
            members: {
              Name: {},
              StackName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Entitlements: {
                type: "list",
                member: {
                  shape: "S2i"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeFleets: {
          input: {
            type: "structure",
            members: {
              Names: {
                shape: "S1y"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Fleets: {
                type: "list",
                member: {
                  shape: "S2r"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeImageBuilders: {
          input: {
            type: "structure",
            members: {
              Names: {
                shape: "S1y"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ImageBuilders: {
                type: "list",
                member: {
                  shape: "S2z"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeImagePermissions: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              MaxResults: {
                type: "integer"
              },
              SharedAwsAccountIds: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              SharedImagePermissionsList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "sharedAccountId",
                    "imagePermissions"
                  ],
                  members: {
                    sharedAccountId: {},
                    imagePermissions: {
                      shape: "S46"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeImages: {
          input: {
            type: "structure",
            members: {
              Names: {
                shape: "S1y"
              },
              Arns: {
                shape: "S5a"
              },
              Type: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Images: {
                type: "list",
                member: {
                  shape: "S40"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeSessions: {
          input: {
            type: "structure",
            required: [
              "StackName",
              "FleetName"
            ],
            members: {
              StackName: {},
              FleetName: {},
              UserId: {},
              NextToken: {},
              Limit: {
                type: "integer"
              },
              AuthenticationType: {},
              InstanceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Sessions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Id",
                    "UserId",
                    "StackName",
                    "FleetName",
                    "State"
                  ],
                  members: {
                    Id: {},
                    UserId: {},
                    StackName: {},
                    FleetName: {},
                    State: {},
                    ConnectionState: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    MaxExpirationTime: {
                      type: "timestamp"
                    },
                    AuthenticationType: {},
                    NetworkAccessConfiguration: {
                      shape: "S33"
                    },
                    InstanceId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeStacks: {
          input: {
            type: "structure",
            members: {
              Names: {
                shape: "S1y"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Stacks: {
                type: "list",
                member: {
                  shape: "S3q"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeUsageReportSubscriptions: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UsageReportSubscriptions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    S3BucketName: {},
                    Schedule: {},
                    LastGeneratedReportDate: {
                      type: "timestamp"
                    },
                    SubscriptionErrors: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ErrorCode: {},
                          ErrorMessage: {}
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeUserStackAssociations: {
          input: {
            type: "structure",
            members: {
              StackName: {},
              UserName: {
                shape: "Sh"
              },
              AuthenticationType: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UserStackAssociations: {
                shape: "Sf"
              },
              NextToken: {}
            }
          }
        },
        DescribeUsers: {
          input: {
            type: "structure",
            required: [
              "AuthenticationType"
            ],
            members: {
              AuthenticationType: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Users: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AuthenticationType"
                  ],
                  members: {
                    Arn: {},
                    UserName: {
                      shape: "Sh"
                    },
                    Enabled: {
                      type: "boolean"
                    },
                    Status: {},
                    FirstName: {
                      shape: "S4c"
                    },
                    LastName: {
                      shape: "S4c"
                    },
                    CreatedTime: {
                      type: "timestamp"
                    },
                    AuthenticationType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DisableUser: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "AuthenticationType"
            ],
            members: {
              UserName: {
                shape: "Sh"
              },
              AuthenticationType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateAppBlockBuilderAppBlock: {
          input: {
            type: "structure",
            required: [
              "AppBlockArn",
              "AppBlockBuilderName"
            ],
            members: {
              AppBlockArn: {},
              AppBlockBuilderName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateApplicationFleet: {
          input: {
            type: "structure",
            required: [
              "FleetName",
              "ApplicationArn"
            ],
            members: {
              FleetName: {},
              ApplicationArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateApplicationFromEntitlement: {
          input: {
            type: "structure",
            required: [
              "StackName",
              "EntitlementName",
              "ApplicationIdentifier"
            ],
            members: {
              StackName: {},
              EntitlementName: {},
              ApplicationIdentifier: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateFleet: {
          input: {
            type: "structure",
            required: [
              "FleetName",
              "StackName"
            ],
            members: {
              FleetName: {},
              StackName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        EnableUser: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "AuthenticationType"
            ],
            members: {
              UserName: {
                shape: "Sh"
              },
              AuthenticationType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ExpireSession: {
          input: {
            type: "structure",
            required: [
              "SessionId"
            ],
            members: {
              SessionId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ListAssociatedFleets: {
          input: {
            type: "structure",
            required: [
              "StackName"
            ],
            members: {
              StackName: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Names: {
                shape: "S1y"
              },
              NextToken: {}
            }
          }
        },
        ListAssociatedStacks: {
          input: {
            type: "structure",
            required: [
              "FleetName"
            ],
            members: {
              FleetName: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Names: {
                shape: "S1y"
              },
              NextToken: {}
            }
          }
        },
        ListEntitledApplications: {
          input: {
            type: "structure",
            required: [
              "StackName",
              "EntitlementName"
            ],
            members: {
              StackName: {},
              EntitlementName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EntitledApplications: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ApplicationIdentifier"
                  ],
                  members: {
                    ApplicationIdentifier: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S11"
              }
            }
          }
        },
        StartAppBlockBuilder: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AppBlockBuilder: {
                shape: "S1l"
              }
            }
          }
        },
        StartFleet: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartImageBuilder: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              AppstreamAgentVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ImageBuilder: {
                shape: "S2z"
              }
            }
          }
        },
        StopAppBlockBuilder: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AppBlockBuilder: {
                shape: "S1l"
              }
            }
          }
        },
        StopFleet: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StopImageBuilder: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ImageBuilder: {
                shape: "S2z"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S11"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAppBlockBuilder: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Description: {},
              DisplayName: {},
              Platform: {},
              InstanceType: {},
              VpcConfig: {
                shape: "S1d"
              },
              EnableDefaultInternetAccess: {
                type: "boolean"
              },
              IamRoleArn: {},
              AccessEndpoints: {
                shape: "S1h"
              },
              AttributesToDelete: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppBlockBuilder: {
                shape: "S1l"
              }
            }
          }
        },
        UpdateApplication: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              DisplayName: {},
              Description: {},
              IconS3Location: {
                shape: "Sw"
              },
              LaunchPath: {},
              WorkingDirectory: {},
              LaunchParameters: {},
              AppBlockArn: {},
              AttributesToDelete: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Application: {
                shape: "S20"
              }
            }
          }
        },
        UpdateDirectoryConfig: {
          input: {
            type: "structure",
            required: [
              "DirectoryName"
            ],
            members: {
              DirectoryName: {},
              OrganizationalUnitDistinguishedNames: {
                shape: "S24"
              },
              ServiceAccountCredentials: {
                shape: "S26"
              },
              CertificateBasedAuthProperties: {
                shape: "S29"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DirectoryConfig: {
                shape: "S2c"
              }
            }
          }
        },
        UpdateEntitlement: {
          input: {
            type: "structure",
            required: [
              "Name",
              "StackName"
            ],
            members: {
              Name: {},
              StackName: {},
              Description: {},
              AppVisibility: {},
              Attributes: {
                shape: "S2f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Entitlement: {
                shape: "S2i"
              }
            }
          }
        },
        UpdateFleet: {
          input: {
            type: "structure",
            members: {
              ImageName: {},
              ImageArn: {},
              Name: {},
              InstanceType: {},
              ComputeCapacity: {
                shape: "S2l"
              },
              VpcConfig: {
                shape: "S1d"
              },
              MaxUserDurationInSeconds: {
                type: "integer"
              },
              DisconnectTimeoutInSeconds: {
                type: "integer"
              },
              DeleteVpcConfig: {
                deprecated: true,
                type: "boolean"
              },
              Description: {},
              DisplayName: {},
              EnableDefaultInternetAccess: {
                type: "boolean"
              },
              DomainJoinInfo: {
                shape: "S2m"
              },
              IdleDisconnectTimeoutInSeconds: {
                type: "integer"
              },
              AttributesToDelete: {
                type: "list",
                member: {}
              },
              IamRoleArn: {},
              StreamView: {},
              Platform: {},
              MaxConcurrentSessions: {
                type: "integer"
              },
              UsbDeviceFilterStrings: {
                shape: "S2o"
              },
              SessionScriptS3Location: {
                shape: "Sw"
              },
              MaxSessionsPerInstance: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Fleet: {
                shape: "S2r"
              }
            }
          }
        },
        UpdateImagePermissions: {
          input: {
            type: "structure",
            required: [
              "Name",
              "SharedAccountId",
              "ImagePermissions"
            ],
            members: {
              Name: {},
              SharedAccountId: {},
              ImagePermissions: {
                shape: "S46"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateStack: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              DisplayName: {},
              Description: {},
              Name: {},
              StorageConnectors: {
                shape: "S37"
              },
              DeleteStorageConnectors: {
                deprecated: true,
                type: "boolean"
              },
              RedirectURL: {},
              FeedbackURL: {},
              AttributesToDelete: {
                type: "list",
                member: {}
              },
              UserSettings: {
                shape: "S3f"
              },
              ApplicationSettings: {
                shape: "S3j"
              },
              AccessEndpoints: {
                shape: "S1h"
              },
              EmbedHostDomains: {
                shape: "S3l"
              },
              StreamingExperienceSettings: {
                shape: "S3n"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Stack: {
                shape: "S3q"
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          required: [
            "AppBlockArn",
            "AppBlockBuilderName"
          ],
          members: {
            AppBlockArn: {},
            AppBlockBuilderName: {}
          }
        },
        S8: {
          type: "structure",
          required: [
            "FleetName",
            "ApplicationArn"
          ],
          members: {
            FleetName: {},
            ApplicationArn: {}
          }
        },
        Sf: {
          type: "list",
          member: {
            shape: "Sg"
          }
        },
        Sg: {
          type: "structure",
          required: [
            "StackName",
            "UserName",
            "AuthenticationType"
          ],
          members: {
            StackName: {},
            UserName: {
              shape: "Sh"
            },
            AuthenticationType: {},
            SendEmailNotification: {
              type: "boolean"
            }
          }
        },
        Sh: {
          type: "string",
          sensitive: true
        },
        Sl: {
          type: "list",
          member: {
            type: "structure",
            members: {
              UserStackAssociation: {
                shape: "Sg"
              },
              ErrorCode: {},
              ErrorMessage: {}
            }
          }
        },
        Sw: {
          type: "structure",
          required: [
            "S3Bucket"
          ],
          members: {
            S3Bucket: {},
            S3Key: {}
          }
        },
        Sz: {
          type: "structure",
          required: [
            "ScriptS3Location",
            "ExecutablePath",
            "TimeoutInSeconds"
          ],
          members: {
            ScriptS3Location: {
              shape: "Sw"
            },
            ExecutablePath: {},
            ExecutableParameters: {},
            TimeoutInSeconds: {
              type: "integer"
            }
          }
        },
        S11: {
          type: "map",
          key: {},
          value: {}
        },
        S16: {
          type: "structure",
          required: [
            "Name",
            "Arn"
          ],
          members: {
            Name: {},
            Arn: {},
            Description: {},
            DisplayName: {},
            SourceS3Location: {
              shape: "Sw"
            },
            SetupScriptDetails: {
              shape: "Sz"
            },
            CreatedTime: {
              type: "timestamp"
            },
            PostSetupScriptDetails: {
              shape: "Sz"
            },
            PackagingType: {},
            State: {},
            AppBlockErrors: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  ErrorCode: {},
                  ErrorMessage: {}
                }
              }
            }
          }
        },
        S1d: {
          type: "structure",
          members: {
            SubnetIds: {
              type: "list",
              member: {}
            },
            SecurityGroupIds: {
              type: "list",
              member: {}
            }
          }
        },
        S1h: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "EndpointType"
            ],
            members: {
              EndpointType: {},
              VpceId: {}
            }
          }
        },
        S1l: {
          type: "structure",
          required: [
            "Arn",
            "Name",
            "Platform",
            "InstanceType",
            "VpcConfig",
            "State"
          ],
          members: {
            Arn: {},
            Name: {},
            DisplayName: {},
            Description: {},
            Platform: {},
            InstanceType: {},
            EnableDefaultInternetAccess: {
              type: "boolean"
            },
            IamRoleArn: {},
            VpcConfig: {
              shape: "S1d"
            },
            State: {},
            CreatedTime: {
              type: "timestamp"
            },
            AppBlockBuilderErrors: {
              shape: "S1n"
            },
            StateChangeReason: {
              type: "structure",
              members: {
                Code: {},
                Message: {}
              }
            },
            AccessEndpoints: {
              shape: "S1h"
            }
          }
        },
        S1n: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ErrorCode: {},
              ErrorMessage: {},
              ErrorTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        S1w: {
          type: "list",
          member: {}
        },
        S1y: {
          type: "list",
          member: {}
        },
        S20: {
          type: "structure",
          members: {
            Name: {},
            DisplayName: {},
            IconURL: {},
            LaunchPath: {},
            LaunchParameters: {},
            Enabled: {
              type: "boolean"
            },
            Metadata: {
              type: "map",
              key: {},
              value: {}
            },
            WorkingDirectory: {},
            Description: {},
            Arn: {},
            AppBlockArn: {},
            IconS3Location: {
              shape: "Sw"
            },
            Platforms: {
              shape: "S1w"
            },
            InstanceFamilies: {
              shape: "S1y"
            },
            CreatedTime: {
              type: "timestamp"
            }
          }
        },
        S24: {
          type: "list",
          member: {}
        },
        S26: {
          type: "structure",
          required: [
            "AccountName",
            "AccountPassword"
          ],
          members: {
            AccountName: {
              type: "string",
              sensitive: true
            },
            AccountPassword: {
              type: "string",
              sensitive: true
            }
          }
        },
        S29: {
          type: "structure",
          members: {
            Status: {},
            CertificateAuthorityArn: {}
          }
        },
        S2c: {
          type: "structure",
          required: [
            "DirectoryName"
          ],
          members: {
            DirectoryName: {},
            OrganizationalUnitDistinguishedNames: {
              shape: "S24"
            },
            ServiceAccountCredentials: {
              shape: "S26"
            },
            CreatedTime: {
              type: "timestamp"
            },
            CertificateBasedAuthProperties: {
              shape: "S29"
            }
          }
        },
        S2f: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Value"
            ],
            members: {
              Name: {},
              Value: {}
            }
          }
        },
        S2i: {
          type: "structure",
          required: [
            "Name",
            "StackName",
            "AppVisibility",
            "Attributes"
          ],
          members: {
            Name: {},
            StackName: {},
            Description: {},
            AppVisibility: {},
            Attributes: {
              shape: "S2f"
            },
            CreatedTime: {
              type: "timestamp"
            },
            LastModifiedTime: {
              type: "timestamp"
            }
          }
        },
        S2l: {
          type: "structure",
          members: {
            DesiredInstances: {
              type: "integer"
            },
            DesiredSessions: {
              type: "integer"
            }
          }
        },
        S2m: {
          type: "structure",
          members: {
            DirectoryName: {},
            OrganizationalUnitDistinguishedName: {}
          }
        },
        S2o: {
          type: "list",
          member: {}
        },
        S2r: {
          type: "structure",
          required: [
            "Arn",
            "Name",
            "InstanceType",
            "ComputeCapacityStatus",
            "State"
          ],
          members: {
            Arn: {},
            Name: {},
            DisplayName: {},
            Description: {},
            ImageName: {},
            ImageArn: {},
            InstanceType: {},
            FleetType: {},
            ComputeCapacityStatus: {
              type: "structure",
              required: [
                "Desired"
              ],
              members: {
                Desired: {
                  type: "integer"
                },
                Running: {
                  type: "integer"
                },
                InUse: {
                  type: "integer"
                },
                Available: {
                  type: "integer"
                },
                DesiredUserSessions: {
                  type: "integer"
                },
                AvailableUserSessions: {
                  type: "integer"
                },
                ActiveUserSessions: {
                  type: "integer"
                },
                ActualUserSessions: {
                  type: "integer"
                }
              }
            },
            MaxUserDurationInSeconds: {
              type: "integer"
            },
            DisconnectTimeoutInSeconds: {
              type: "integer"
            },
            State: {},
            VpcConfig: {
              shape: "S1d"
            },
            CreatedTime: {
              type: "timestamp"
            },
            FleetErrors: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  ErrorCode: {},
                  ErrorMessage: {}
                }
              }
            },
            EnableDefaultInternetAccess: {
              type: "boolean"
            },
            DomainJoinInfo: {
              shape: "S2m"
            },
            IdleDisconnectTimeoutInSeconds: {
              type: "integer"
            },
            IamRoleArn: {},
            StreamView: {},
            Platform: {},
            MaxConcurrentSessions: {
              type: "integer"
            },
            UsbDeviceFilterStrings: {
              shape: "S2o"
            },
            SessionScriptS3Location: {
              shape: "Sw"
            },
            MaxSessionsPerInstance: {
              type: "integer"
            }
          }
        },
        S2z: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            Arn: {},
            ImageArn: {},
            Description: {},
            DisplayName: {},
            VpcConfig: {
              shape: "S1d"
            },
            InstanceType: {},
            Platform: {},
            IamRoleArn: {},
            State: {},
            StateChangeReason: {
              type: "structure",
              members: {
                Code: {},
                Message: {}
              }
            },
            CreatedTime: {
              type: "timestamp"
            },
            EnableDefaultInternetAccess: {
              type: "boolean"
            },
            DomainJoinInfo: {
              shape: "S2m"
            },
            NetworkAccessConfiguration: {
              shape: "S33"
            },
            ImageBuilderErrors: {
              shape: "S1n"
            },
            AppstreamAgentVersion: {},
            AccessEndpoints: {
              shape: "S1h"
            }
          }
        },
        S33: {
          type: "structure",
          members: {
            EniPrivateIpAddress: {},
            EniId: {}
          }
        },
        S37: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ConnectorType"
            ],
            members: {
              ConnectorType: {},
              ResourceIdentifier: {},
              Domains: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S3f: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Action",
              "Permission"
            ],
            members: {
              Action: {},
              Permission: {},
              MaximumLength: {
                type: "integer"
              }
            }
          }
        },
        S3j: {
          type: "structure",
          required: [
            "Enabled"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            SettingsGroup: {}
          }
        },
        S3l: {
          type: "list",
          member: {}
        },
        S3n: {
          type: "structure",
          members: {
            PreferredProtocol: {}
          }
        },
        S3q: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Arn: {},
            Name: {},
            Description: {},
            DisplayName: {},
            CreatedTime: {
              type: "timestamp"
            },
            StorageConnectors: {
              shape: "S37"
            },
            RedirectURL: {},
            FeedbackURL: {},
            StackErrors: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  ErrorCode: {},
                  ErrorMessage: {}
                }
              }
            },
            UserSettings: {
              shape: "S3f"
            },
            ApplicationSettings: {
              type: "structure",
              members: {
                Enabled: {
                  type: "boolean"
                },
                SettingsGroup: {},
                S3BucketName: {}
              }
            },
            AccessEndpoints: {
              shape: "S1h"
            },
            EmbedHostDomains: {
              shape: "S3l"
            },
            StreamingExperienceSettings: {
              shape: "S3n"
            }
          }
        },
        S40: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            Arn: {},
            BaseImageArn: {},
            DisplayName: {},
            State: {},
            Visibility: {},
            ImageBuilderSupported: {
              type: "boolean"
            },
            ImageBuilderName: {},
            Platform: {},
            Description: {},
            StateChangeReason: {
              type: "structure",
              members: {
                Code: {},
                Message: {}
              }
            },
            Applications: {
              shape: "S45"
            },
            CreatedTime: {
              type: "timestamp"
            },
            PublicBaseImageReleasedDate: {
              type: "timestamp"
            },
            AppstreamAgentVersion: {},
            ImagePermissions: {
              shape: "S46"
            },
            ImageErrors: {
              shape: "S1n"
            }
          }
        },
        S45: {
          type: "list",
          member: {
            shape: "S20"
          }
        },
        S46: {
          type: "structure",
          members: {
            allowFleet: {
              type: "boolean"
            },
            allowImageBuilder: {
              type: "boolean"
            }
          }
        },
        S4c: {
          type: "string",
          sensitive: true
        },
        S5a: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/appstream-2016-12-01.paginators.json
var require_appstream_2016_12_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/appstream-2016-12-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeAppBlockBuilderAppBlockAssociations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeAppBlockBuilders: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeImagePermissions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeImages: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/appstream-2016-12-01.waiters2.json
var require_appstream_2016_12_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/appstream-2016-12-01.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        FleetStarted: {
          delay: 30,
          maxAttempts: 40,
          operation: "DescribeFleets",
          acceptors: [
            {
              state: "success",
              matcher: "pathAll",
              argument: "Fleets[].State",
              expected: "RUNNING"
            },
            {
              state: "failure",
              matcher: "pathAny",
              argument: "Fleets[].State",
              expected: "STOPPING"
            },
            {
              state: "failure",
              matcher: "pathAny",
              argument: "Fleets[].State",
              expected: "STOPPED"
            }
          ]
        },
        FleetStopped: {
          delay: 30,
          maxAttempts: 40,
          operation: "DescribeFleets",
          acceptors: [
            {
              state: "success",
              matcher: "pathAll",
              argument: "Fleets[].State",
              expected: "STOPPED"
            },
            {
              state: "failure",
              matcher: "pathAny",
              argument: "Fleets[].State",
              expected: "STARTING"
            },
            {
              state: "failure",
              matcher: "pathAny",
              argument: "Fleets[].State",
              expected: "RUNNING"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/appstream.js
var require_appstream = __commonJS({
  "node_modules/aws-sdk/clients/appstream.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["appstream"] = {};
    AWS2.AppStream = Service.defineService("appstream", ["2016-12-01"]);
    Object.defineProperty(apiLoader.services["appstream"], "2016-12-01", {
      get: function get() {
        var model = require_appstream_2016_12_01_min();
        model.paginators = require_appstream_2016_12_01_paginators().pagination;
        model.waiters = require_appstream_2016_12_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.AppStream;
  }
});

// node_modules/aws-sdk/apis/autoscaling-2011-01-01.min.json
var require_autoscaling_2011_01_01_min = __commonJS({
  "node_modules/aws-sdk/apis/autoscaling-2011-01-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2011-01-01",
        endpointPrefix: "autoscaling",
        protocol: "query",
        serviceFullName: "Auto Scaling",
        serviceId: "Auto Scaling",
        signatureVersion: "v4",
        uid: "autoscaling-2011-01-01",
        xmlNamespace: "http://autoscaling.amazonaws.com/doc/2011-01-01/"
      },
      operations: {
        AttachInstances: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName"
            ],
            members: {
              InstanceIds: {
                shape: "S2"
              },
              AutoScalingGroupName: {}
            }
          }
        },
        AttachLoadBalancerTargetGroups: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "TargetGroupARNs"
            ],
            members: {
              AutoScalingGroupName: {},
              TargetGroupARNs: {
                shape: "S6"
              }
            }
          },
          output: {
            resultWrapper: "AttachLoadBalancerTargetGroupsResult",
            type: "structure",
            members: {}
          }
        },
        AttachLoadBalancers: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "LoadBalancerNames"
            ],
            members: {
              AutoScalingGroupName: {},
              LoadBalancerNames: {
                shape: "Sa"
              }
            }
          },
          output: {
            resultWrapper: "AttachLoadBalancersResult",
            type: "structure",
            members: {}
          }
        },
        AttachTrafficSources: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "TrafficSources"
            ],
            members: {
              AutoScalingGroupName: {},
              TrafficSources: {
                shape: "Sd"
              }
            }
          },
          output: {
            resultWrapper: "AttachTrafficSourcesResult",
            type: "structure",
            members: {}
          }
        },
        BatchDeleteScheduledAction: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "ScheduledActionNames"
            ],
            members: {
              AutoScalingGroupName: {},
              ScheduledActionNames: {
                shape: "Sh"
              }
            }
          },
          output: {
            resultWrapper: "BatchDeleteScheduledActionResult",
            type: "structure",
            members: {
              FailedScheduledActions: {
                shape: "Sj"
              }
            }
          }
        },
        BatchPutScheduledUpdateGroupAction: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "ScheduledUpdateGroupActions"
            ],
            members: {
              AutoScalingGroupName: {},
              ScheduledUpdateGroupActions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ScheduledActionName"
                  ],
                  members: {
                    ScheduledActionName: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    Recurrence: {},
                    MinSize: {
                      type: "integer"
                    },
                    MaxSize: {
                      type: "integer"
                    },
                    DesiredCapacity: {
                      type: "integer"
                    },
                    TimeZone: {}
                  }
                }
              }
            }
          },
          output: {
            resultWrapper: "BatchPutScheduledUpdateGroupActionResult",
            type: "structure",
            members: {
              FailedScheduledUpdateGroupActions: {
                shape: "Sj"
              }
            }
          }
        },
        CancelInstanceRefresh: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName"
            ],
            members: {
              AutoScalingGroupName: {}
            }
          },
          output: {
            resultWrapper: "CancelInstanceRefreshResult",
            type: "structure",
            members: {
              InstanceRefreshId: {}
            }
          }
        },
        CompleteLifecycleAction: {
          input: {
            type: "structure",
            required: [
              "LifecycleHookName",
              "AutoScalingGroupName",
              "LifecycleActionResult"
            ],
            members: {
              LifecycleHookName: {},
              AutoScalingGroupName: {},
              LifecycleActionToken: {},
              LifecycleActionResult: {},
              InstanceId: {}
            }
          },
          output: {
            resultWrapper: "CompleteLifecycleActionResult",
            type: "structure",
            members: {}
          }
        },
        CreateAutoScalingGroup: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "MinSize",
              "MaxSize"
            ],
            members: {
              AutoScalingGroupName: {},
              LaunchConfigurationName: {},
              LaunchTemplate: {
                shape: "S14"
              },
              MixedInstancesPolicy: {
                shape: "S16"
              },
              InstanceId: {},
              MinSize: {
                type: "integer"
              },
              MaxSize: {
                type: "integer"
              },
              DesiredCapacity: {
                type: "integer"
              },
              DefaultCooldown: {
                type: "integer"
              },
              AvailabilityZones: {
                shape: "S2d"
              },
              LoadBalancerNames: {
                shape: "Sa"
              },
              TargetGroupARNs: {
                shape: "S6"
              },
              HealthCheckType: {},
              HealthCheckGracePeriod: {
                type: "integer"
              },
              PlacementGroup: {},
              VPCZoneIdentifier: {},
              TerminationPolicies: {
                shape: "S2g"
              },
              NewInstancesProtectedFromScaleIn: {
                type: "boolean"
              },
              CapacityRebalance: {
                type: "boolean"
              },
              LifecycleHookSpecificationList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "LifecycleHookName",
                    "LifecycleTransition"
                  ],
                  members: {
                    LifecycleHookName: {},
                    LifecycleTransition: {},
                    NotificationMetadata: {},
                    HeartbeatTimeout: {
                      type: "integer"
                    },
                    DefaultResult: {},
                    NotificationTargetARN: {},
                    RoleARN: {}
                  }
                }
              },
              Tags: {
                shape: "S2q"
              },
              ServiceLinkedRoleARN: {},
              MaxInstanceLifetime: {
                type: "integer"
              },
              Context: {},
              DesiredCapacityType: {},
              DefaultInstanceWarmup: {
                type: "integer"
              },
              TrafficSources: {
                shape: "Sd"
              },
              InstanceMaintenancePolicy: {
                shape: "S2y"
              }
            }
          }
        },
        CreateLaunchConfiguration: {
          input: {
            type: "structure",
            required: [
              "LaunchConfigurationName"
            ],
            members: {
              LaunchConfigurationName: {},
              ImageId: {},
              KeyName: {},
              SecurityGroups: {
                shape: "S32"
              },
              ClassicLinkVPCId: {},
              ClassicLinkVPCSecurityGroups: {
                shape: "S33"
              },
              UserData: {},
              InstanceId: {},
              InstanceType: {},
              KernelId: {},
              RamdiskId: {},
              BlockDeviceMappings: {
                shape: "S35"
              },
              InstanceMonitoring: {
                shape: "S3f"
              },
              SpotPrice: {},
              IamInstanceProfile: {},
              EbsOptimized: {
                type: "boolean"
              },
              AssociatePublicIpAddress: {
                type: "boolean"
              },
              PlacementTenancy: {},
              MetadataOptions: {
                shape: "S3k"
              }
            }
          }
        },
        CreateOrUpdateTags: {
          input: {
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "S2q"
              }
            }
          }
        },
        DeleteAutoScalingGroup: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName"
            ],
            members: {
              AutoScalingGroupName: {},
              ForceDelete: {
                type: "boolean"
              }
            }
          }
        },
        DeleteLaunchConfiguration: {
          input: {
            type: "structure",
            required: [
              "LaunchConfigurationName"
            ],
            members: {
              LaunchConfigurationName: {}
            }
          }
        },
        DeleteLifecycleHook: {
          input: {
            type: "structure",
            required: [
              "LifecycleHookName",
              "AutoScalingGroupName"
            ],
            members: {
              LifecycleHookName: {},
              AutoScalingGroupName: {}
            }
          },
          output: {
            resultWrapper: "DeleteLifecycleHookResult",
            type: "structure",
            members: {}
          }
        },
        DeleteNotificationConfiguration: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "TopicARN"
            ],
            members: {
              AutoScalingGroupName: {},
              TopicARN: {}
            }
          }
        },
        DeletePolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyName"
            ],
            members: {
              AutoScalingGroupName: {},
              PolicyName: {}
            }
          }
        },
        DeleteScheduledAction: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "ScheduledActionName"
            ],
            members: {
              AutoScalingGroupName: {},
              ScheduledActionName: {}
            }
          }
        },
        DeleteTags: {
          input: {
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "S2q"
              }
            }
          }
        },
        DeleteWarmPool: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName"
            ],
            members: {
              AutoScalingGroupName: {},
              ForceDelete: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DeleteWarmPoolResult",
            type: "structure",
            members: {}
          }
        },
        DescribeAccountLimits: {
          output: {
            resultWrapper: "DescribeAccountLimitsResult",
            type: "structure",
            members: {
              MaxNumberOfAutoScalingGroups: {
                type: "integer"
              },
              MaxNumberOfLaunchConfigurations: {
                type: "integer"
              },
              NumberOfAutoScalingGroups: {
                type: "integer"
              },
              NumberOfLaunchConfigurations: {
                type: "integer"
              }
            }
          }
        },
        DescribeAdjustmentTypes: {
          output: {
            resultWrapper: "DescribeAdjustmentTypesResult",
            type: "structure",
            members: {
              AdjustmentTypes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AdjustmentType: {}
                  }
                }
              }
            }
          }
        },
        DescribeAutoScalingGroups: {
          input: {
            type: "structure",
            members: {
              AutoScalingGroupNames: {
                shape: "S49"
              },
              NextToken: {},
              MaxRecords: {
                type: "integer"
              },
              Filters: {
                shape: "S4b"
              }
            }
          },
          output: {
            resultWrapper: "DescribeAutoScalingGroupsResult",
            type: "structure",
            required: [
              "AutoScalingGroups"
            ],
            members: {
              AutoScalingGroups: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AutoScalingGroupName",
                    "MinSize",
                    "MaxSize",
                    "DesiredCapacity",
                    "DefaultCooldown",
                    "AvailabilityZones",
                    "HealthCheckType",
                    "CreatedTime"
                  ],
                  members: {
                    AutoScalingGroupName: {},
                    AutoScalingGroupARN: {},
                    LaunchConfigurationName: {},
                    LaunchTemplate: {
                      shape: "S14"
                    },
                    MixedInstancesPolicy: {
                      shape: "S16"
                    },
                    MinSize: {
                      type: "integer"
                    },
                    MaxSize: {
                      type: "integer"
                    },
                    DesiredCapacity: {
                      type: "integer"
                    },
                    PredictedCapacity: {
                      type: "integer"
                    },
                    DefaultCooldown: {
                      type: "integer"
                    },
                    AvailabilityZones: {
                      shape: "S2d"
                    },
                    LoadBalancerNames: {
                      shape: "Sa"
                    },
                    TargetGroupARNs: {
                      shape: "S6"
                    },
                    HealthCheckType: {},
                    HealthCheckGracePeriod: {
                      type: "integer"
                    },
                    Instances: {
                      shape: "S4i"
                    },
                    CreatedTime: {
                      type: "timestamp"
                    },
                    SuspendedProcesses: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ProcessName: {},
                          SuspensionReason: {}
                        }
                      }
                    },
                    PlacementGroup: {},
                    VPCZoneIdentifier: {},
                    EnabledMetrics: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Metric: {},
                          Granularity: {}
                        }
                      }
                    },
                    Status: {},
                    Tags: {
                      shape: "S4p"
                    },
                    TerminationPolicies: {
                      shape: "S2g"
                    },
                    NewInstancesProtectedFromScaleIn: {
                      type: "boolean"
                    },
                    ServiceLinkedRoleARN: {},
                    MaxInstanceLifetime: {
                      type: "integer"
                    },
                    CapacityRebalance: {
                      type: "boolean"
                    },
                    WarmPoolConfiguration: {
                      shape: "S4r"
                    },
                    WarmPoolSize: {
                      type: "integer"
                    },
                    Context: {},
                    DesiredCapacityType: {},
                    DefaultInstanceWarmup: {
                      type: "integer"
                    },
                    TrafficSources: {
                      shape: "Sd"
                    },
                    InstanceMaintenancePolicy: {
                      shape: "S2y"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeAutoScalingInstances: {
          input: {
            type: "structure",
            members: {
              InstanceIds: {
                shape: "S2"
              },
              MaxRecords: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "DescribeAutoScalingInstancesResult",
            type: "structure",
            members: {
              AutoScalingInstances: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "InstanceId",
                    "AutoScalingGroupName",
                    "AvailabilityZone",
                    "LifecycleState",
                    "HealthStatus",
                    "ProtectedFromScaleIn"
                  ],
                  members: {
                    InstanceId: {},
                    InstanceType: {},
                    AutoScalingGroupName: {},
                    AvailabilityZone: {},
                    LifecycleState: {},
                    HealthStatus: {},
                    LaunchConfigurationName: {},
                    LaunchTemplate: {
                      shape: "S14"
                    },
                    ProtectedFromScaleIn: {
                      type: "boolean"
                    },
                    WeightedCapacity: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeAutoScalingNotificationTypes: {
          output: {
            resultWrapper: "DescribeAutoScalingNotificationTypesResult",
            type: "structure",
            members: {
              AutoScalingNotificationTypes: {
                shape: "S54"
              }
            }
          }
        },
        DescribeInstanceRefreshes: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName"
            ],
            members: {
              AutoScalingGroupName: {},
              InstanceRefreshIds: {
                type: "list",
                member: {}
              },
              NextToken: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeInstanceRefreshesResult",
            type: "structure",
            members: {
              InstanceRefreshes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InstanceRefreshId: {},
                    AutoScalingGroupName: {},
                    Status: {},
                    StatusReason: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    PercentageComplete: {
                      type: "integer"
                    },
                    InstancesToUpdate: {
                      type: "integer"
                    },
                    ProgressDetails: {
                      shape: "S5e"
                    },
                    Preferences: {
                      shape: "S5h"
                    },
                    DesiredConfiguration: {
                      shape: "S5t"
                    },
                    RollbackDetails: {
                      type: "structure",
                      members: {
                        RollbackReason: {},
                        RollbackStartTime: {
                          type: "timestamp"
                        },
                        PercentageCompleteOnRollback: {
                          type: "integer"
                        },
                        InstancesToUpdateOnRollback: {
                          type: "integer"
                        },
                        ProgressDetailsOnRollback: {
                          shape: "S5e"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeLaunchConfigurations: {
          input: {
            type: "structure",
            members: {
              LaunchConfigurationNames: {
                type: "list",
                member: {}
              },
              NextToken: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeLaunchConfigurationsResult",
            type: "structure",
            required: [
              "LaunchConfigurations"
            ],
            members: {
              LaunchConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "LaunchConfigurationName",
                    "ImageId",
                    "InstanceType",
                    "CreatedTime"
                  ],
                  members: {
                    LaunchConfigurationName: {},
                    LaunchConfigurationARN: {},
                    ImageId: {},
                    KeyName: {},
                    SecurityGroups: {
                      shape: "S32"
                    },
                    ClassicLinkVPCId: {},
                    ClassicLinkVPCSecurityGroups: {
                      shape: "S33"
                    },
                    UserData: {},
                    InstanceType: {},
                    KernelId: {},
                    RamdiskId: {},
                    BlockDeviceMappings: {
                      shape: "S35"
                    },
                    InstanceMonitoring: {
                      shape: "S3f"
                    },
                    SpotPrice: {},
                    IamInstanceProfile: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    EbsOptimized: {
                      type: "boolean"
                    },
                    AssociatePublicIpAddress: {
                      type: "boolean"
                    },
                    PlacementTenancy: {},
                    MetadataOptions: {
                      shape: "S3k"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeLifecycleHookTypes: {
          output: {
            resultWrapper: "DescribeLifecycleHookTypesResult",
            type: "structure",
            members: {
              LifecycleHookTypes: {
                shape: "S54"
              }
            }
          }
        },
        DescribeLifecycleHooks: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName"
            ],
            members: {
              AutoScalingGroupName: {},
              LifecycleHookNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "DescribeLifecycleHooksResult",
            type: "structure",
            members: {
              LifecycleHooks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LifecycleHookName: {},
                    AutoScalingGroupName: {},
                    LifecycleTransition: {},
                    NotificationTargetARN: {},
                    RoleARN: {},
                    NotificationMetadata: {},
                    HeartbeatTimeout: {
                      type: "integer"
                    },
                    GlobalTimeout: {
                      type: "integer"
                    },
                    DefaultResult: {}
                  }
                }
              }
            }
          }
        },
        DescribeLoadBalancerTargetGroups: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName"
            ],
            members: {
              AutoScalingGroupName: {},
              NextToken: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeLoadBalancerTargetGroupsResult",
            type: "structure",
            members: {
              LoadBalancerTargetGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LoadBalancerTargetGroupARN: {},
                    State: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeLoadBalancers: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName"
            ],
            members: {
              AutoScalingGroupName: {},
              NextToken: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeLoadBalancersResult",
            type: "structure",
            members: {
              LoadBalancers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LoadBalancerName: {},
                    State: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeMetricCollectionTypes: {
          output: {
            resultWrapper: "DescribeMetricCollectionTypesResult",
            type: "structure",
            members: {
              Metrics: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Metric: {}
                  }
                }
              },
              Granularities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Granularity: {}
                  }
                }
              }
            }
          }
        },
        DescribeNotificationConfigurations: {
          input: {
            type: "structure",
            members: {
              AutoScalingGroupNames: {
                shape: "S49"
              },
              NextToken: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeNotificationConfigurationsResult",
            type: "structure",
            required: [
              "NotificationConfigurations"
            ],
            members: {
              NotificationConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AutoScalingGroupName: {},
                    TopicARN: {},
                    NotificationType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribePolicies: {
          input: {
            type: "structure",
            members: {
              AutoScalingGroupName: {},
              PolicyNames: {
                type: "list",
                member: {}
              },
              PolicyTypes: {
                type: "list",
                member: {}
              },
              NextToken: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribePoliciesResult",
            type: "structure",
            members: {
              ScalingPolicies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AutoScalingGroupName: {},
                    PolicyName: {},
                    PolicyARN: {},
                    PolicyType: {},
                    AdjustmentType: {},
                    MinAdjustmentStep: {
                      shape: "S6u"
                    },
                    MinAdjustmentMagnitude: {
                      type: "integer"
                    },
                    ScalingAdjustment: {
                      type: "integer"
                    },
                    Cooldown: {
                      type: "integer"
                    },
                    StepAdjustments: {
                      shape: "S6x"
                    },
                    MetricAggregationType: {},
                    EstimatedInstanceWarmup: {
                      type: "integer"
                    },
                    Alarms: {
                      shape: "S71"
                    },
                    TargetTrackingConfiguration: {
                      shape: "S73"
                    },
                    Enabled: {
                      type: "boolean"
                    },
                    PredictiveScalingConfiguration: {
                      shape: "S7o"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeScalingActivities: {
          input: {
            type: "structure",
            members: {
              ActivityIds: {
                type: "list",
                member: {}
              },
              AutoScalingGroupName: {},
              IncludeDeletedGroups: {
                type: "boolean"
              },
              MaxRecords: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "DescribeScalingActivitiesResult",
            type: "structure",
            required: [
              "Activities"
            ],
            members: {
              Activities: {
                shape: "S8b"
              },
              NextToken: {}
            }
          }
        },
        DescribeScalingProcessTypes: {
          output: {
            resultWrapper: "DescribeScalingProcessTypesResult",
            type: "structure",
            members: {
              Processes: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ProcessName"
                  ],
                  members: {
                    ProcessName: {}
                  }
                }
              }
            }
          }
        },
        DescribeScheduledActions: {
          input: {
            type: "structure",
            members: {
              AutoScalingGroupName: {},
              ScheduledActionNames: {
                shape: "Sh"
              },
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              NextToken: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeScheduledActionsResult",
            type: "structure",
            members: {
              ScheduledUpdateGroupActions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AutoScalingGroupName: {},
                    ScheduledActionName: {},
                    ScheduledActionARN: {},
                    Time: {
                      type: "timestamp"
                    },
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    Recurrence: {},
                    MinSize: {
                      type: "integer"
                    },
                    MaxSize: {
                      type: "integer"
                    },
                    DesiredCapacity: {
                      type: "integer"
                    },
                    TimeZone: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeTags: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S4b"
              },
              NextToken: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeTagsResult",
            type: "structure",
            members: {
              Tags: {
                shape: "S4p"
              },
              NextToken: {}
            }
          }
        },
        DescribeTerminationPolicyTypes: {
          output: {
            resultWrapper: "DescribeTerminationPolicyTypesResult",
            type: "structure",
            members: {
              TerminationPolicyTypes: {
                shape: "S2g"
              }
            }
          }
        },
        DescribeTrafficSources: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName"
            ],
            members: {
              AutoScalingGroupName: {},
              TrafficSourceType: {},
              NextToken: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeTrafficSourcesResult",
            type: "structure",
            members: {
              TrafficSources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TrafficSource: {
                      deprecated: true,
                      deprecatedMessage: "TrafficSource has been replaced by Identifier"
                    },
                    State: {},
                    Identifier: {},
                    Type: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeWarmPool: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName"
            ],
            members: {
              AutoScalingGroupName: {},
              MaxRecords: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "DescribeWarmPoolResult",
            type: "structure",
            members: {
              WarmPoolConfiguration: {
                shape: "S4r"
              },
              Instances: {
                shape: "S4i"
              },
              NextToken: {}
            }
          }
        },
        DetachInstances: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "ShouldDecrementDesiredCapacity"
            ],
            members: {
              InstanceIds: {
                shape: "S2"
              },
              AutoScalingGroupName: {},
              ShouldDecrementDesiredCapacity: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DetachInstancesResult",
            type: "structure",
            members: {
              Activities: {
                shape: "S8b"
              }
            }
          }
        },
        DetachLoadBalancerTargetGroups: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "TargetGroupARNs"
            ],
            members: {
              AutoScalingGroupName: {},
              TargetGroupARNs: {
                shape: "S6"
              }
            }
          },
          output: {
            resultWrapper: "DetachLoadBalancerTargetGroupsResult",
            type: "structure",
            members: {}
          }
        },
        DetachLoadBalancers: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "LoadBalancerNames"
            ],
            members: {
              AutoScalingGroupName: {},
              LoadBalancerNames: {
                shape: "Sa"
              }
            }
          },
          output: {
            resultWrapper: "DetachLoadBalancersResult",
            type: "structure",
            members: {}
          }
        },
        DetachTrafficSources: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "TrafficSources"
            ],
            members: {
              AutoScalingGroupName: {},
              TrafficSources: {
                shape: "Sd"
              }
            }
          },
          output: {
            resultWrapper: "DetachTrafficSourcesResult",
            type: "structure",
            members: {}
          }
        },
        DisableMetricsCollection: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName"
            ],
            members: {
              AutoScalingGroupName: {},
              Metrics: {
                shape: "S96"
              }
            }
          }
        },
        EnableMetricsCollection: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "Granularity"
            ],
            members: {
              AutoScalingGroupName: {},
              Metrics: {
                shape: "S96"
              },
              Granularity: {}
            }
          }
        },
        EnterStandby: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "ShouldDecrementDesiredCapacity"
            ],
            members: {
              InstanceIds: {
                shape: "S2"
              },
              AutoScalingGroupName: {},
              ShouldDecrementDesiredCapacity: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "EnterStandbyResult",
            type: "structure",
            members: {
              Activities: {
                shape: "S8b"
              }
            }
          }
        },
        ExecutePolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyName"
            ],
            members: {
              AutoScalingGroupName: {},
              PolicyName: {},
              HonorCooldown: {
                type: "boolean"
              },
              MetricValue: {
                type: "double"
              },
              BreachThreshold: {
                type: "double"
              }
            }
          }
        },
        ExitStandby: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName"
            ],
            members: {
              InstanceIds: {
                shape: "S2"
              },
              AutoScalingGroupName: {}
            }
          },
          output: {
            resultWrapper: "ExitStandbyResult",
            type: "structure",
            members: {
              Activities: {
                shape: "S8b"
              }
            }
          }
        },
        GetPredictiveScalingForecast: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "PolicyName",
              "StartTime",
              "EndTime"
            ],
            members: {
              AutoScalingGroupName: {},
              PolicyName: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              }
            }
          },
          output: {
            resultWrapper: "GetPredictiveScalingForecastResult",
            type: "structure",
            required: [
              "LoadForecast",
              "CapacityForecast",
              "UpdateTime"
            ],
            members: {
              LoadForecast: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Timestamps",
                    "Values",
                    "MetricSpecification"
                  ],
                  members: {
                    Timestamps: {
                      shape: "S9i"
                    },
                    Values: {
                      shape: "S9j"
                    },
                    MetricSpecification: {
                      shape: "S7q"
                    }
                  }
                }
              },
              CapacityForecast: {
                type: "structure",
                required: [
                  "Timestamps",
                  "Values"
                ],
                members: {
                  Timestamps: {
                    shape: "S9i"
                  },
                  Values: {
                    shape: "S9j"
                  }
                }
              },
              UpdateTime: {
                type: "timestamp"
              }
            }
          }
        },
        PutLifecycleHook: {
          input: {
            type: "structure",
            required: [
              "LifecycleHookName",
              "AutoScalingGroupName"
            ],
            members: {
              LifecycleHookName: {},
              AutoScalingGroupName: {},
              LifecycleTransition: {},
              RoleARN: {},
              NotificationTargetARN: {},
              NotificationMetadata: {},
              HeartbeatTimeout: {
                type: "integer"
              },
              DefaultResult: {}
            }
          },
          output: {
            resultWrapper: "PutLifecycleHookResult",
            type: "structure",
            members: {}
          }
        },
        PutNotificationConfiguration: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "TopicARN",
              "NotificationTypes"
            ],
            members: {
              AutoScalingGroupName: {},
              TopicARN: {},
              NotificationTypes: {
                shape: "S54"
              }
            }
          }
        },
        PutScalingPolicy: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "PolicyName"
            ],
            members: {
              AutoScalingGroupName: {},
              PolicyName: {},
              PolicyType: {},
              AdjustmentType: {},
              MinAdjustmentStep: {
                shape: "S6u"
              },
              MinAdjustmentMagnitude: {
                type: "integer"
              },
              ScalingAdjustment: {
                type: "integer"
              },
              Cooldown: {
                type: "integer"
              },
              MetricAggregationType: {},
              StepAdjustments: {
                shape: "S6x"
              },
              EstimatedInstanceWarmup: {
                type: "integer"
              },
              TargetTrackingConfiguration: {
                shape: "S73"
              },
              Enabled: {
                type: "boolean"
              },
              PredictiveScalingConfiguration: {
                shape: "S7o"
              }
            }
          },
          output: {
            resultWrapper: "PutScalingPolicyResult",
            type: "structure",
            members: {
              PolicyARN: {},
              Alarms: {
                shape: "S71"
              }
            }
          }
        },
        PutScheduledUpdateGroupAction: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "ScheduledActionName"
            ],
            members: {
              AutoScalingGroupName: {},
              ScheduledActionName: {},
              Time: {
                type: "timestamp"
              },
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Recurrence: {},
              MinSize: {
                type: "integer"
              },
              MaxSize: {
                type: "integer"
              },
              DesiredCapacity: {
                type: "integer"
              },
              TimeZone: {}
            }
          }
        },
        PutWarmPool: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName"
            ],
            members: {
              AutoScalingGroupName: {},
              MaxGroupPreparedCapacity: {
                type: "integer"
              },
              MinSize: {
                type: "integer"
              },
              PoolState: {},
              InstanceReusePolicy: {
                shape: "S4w"
              }
            }
          },
          output: {
            resultWrapper: "PutWarmPoolResult",
            type: "structure",
            members: {}
          }
        },
        RecordLifecycleActionHeartbeat: {
          input: {
            type: "structure",
            required: [
              "LifecycleHookName",
              "AutoScalingGroupName"
            ],
            members: {
              LifecycleHookName: {},
              AutoScalingGroupName: {},
              LifecycleActionToken: {},
              InstanceId: {}
            }
          },
          output: {
            resultWrapper: "RecordLifecycleActionHeartbeatResult",
            type: "structure",
            members: {}
          }
        },
        ResumeProcesses: {
          input: {
            shape: "S9v"
          }
        },
        RollbackInstanceRefresh: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName"
            ],
            members: {
              AutoScalingGroupName: {}
            }
          },
          output: {
            resultWrapper: "RollbackInstanceRefreshResult",
            type: "structure",
            members: {
              InstanceRefreshId: {}
            }
          }
        },
        SetDesiredCapacity: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "DesiredCapacity"
            ],
            members: {
              AutoScalingGroupName: {},
              DesiredCapacity: {
                type: "integer"
              },
              HonorCooldown: {
                type: "boolean"
              }
            }
          }
        },
        SetInstanceHealth: {
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "HealthStatus"
            ],
            members: {
              InstanceId: {},
              HealthStatus: {},
              ShouldRespectGracePeriod: {
                type: "boolean"
              }
            }
          }
        },
        SetInstanceProtection: {
          input: {
            type: "structure",
            required: [
              "InstanceIds",
              "AutoScalingGroupName",
              "ProtectedFromScaleIn"
            ],
            members: {
              InstanceIds: {
                shape: "S2"
              },
              AutoScalingGroupName: {},
              ProtectedFromScaleIn: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "SetInstanceProtectionResult",
            type: "structure",
            members: {}
          }
        },
        StartInstanceRefresh: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName"
            ],
            members: {
              AutoScalingGroupName: {},
              Strategy: {},
              DesiredConfiguration: {
                shape: "S5t"
              },
              Preferences: {
                shape: "S5h"
              }
            }
          },
          output: {
            resultWrapper: "StartInstanceRefreshResult",
            type: "structure",
            members: {
              InstanceRefreshId: {}
            }
          }
        },
        SuspendProcesses: {
          input: {
            shape: "S9v"
          }
        },
        TerminateInstanceInAutoScalingGroup: {
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ShouldDecrementDesiredCapacity"
            ],
            members: {
              InstanceId: {},
              ShouldDecrementDesiredCapacity: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "TerminateInstanceInAutoScalingGroupResult",
            type: "structure",
            members: {
              Activity: {
                shape: "S8c"
              }
            }
          }
        },
        UpdateAutoScalingGroup: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName"
            ],
            members: {
              AutoScalingGroupName: {},
              LaunchConfigurationName: {},
              LaunchTemplate: {
                shape: "S14"
              },
              MixedInstancesPolicy: {
                shape: "S16"
              },
              MinSize: {
                type: "integer"
              },
              MaxSize: {
                type: "integer"
              },
              DesiredCapacity: {
                type: "integer"
              },
              DefaultCooldown: {
                type: "integer"
              },
              AvailabilityZones: {
                shape: "S2d"
              },
              HealthCheckType: {},
              HealthCheckGracePeriod: {
                type: "integer"
              },
              PlacementGroup: {},
              VPCZoneIdentifier: {},
              TerminationPolicies: {
                shape: "S2g"
              },
              NewInstancesProtectedFromScaleIn: {
                type: "boolean"
              },
              ServiceLinkedRoleARN: {},
              MaxInstanceLifetime: {
                type: "integer"
              },
              CapacityRebalance: {
                type: "boolean"
              },
              Context: {},
              DesiredCapacityType: {},
              DefaultInstanceWarmup: {
                type: "integer"
              },
              InstanceMaintenancePolicy: {
                shape: "S2y"
              }
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "list",
          member: {}
        },
        S6: {
          type: "list",
          member: {}
        },
        Sa: {
          type: "list",
          member: {}
        },
        Sd: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Identifier"
            ],
            members: {
              Identifier: {},
              Type: {}
            }
          }
        },
        Sh: {
          type: "list",
          member: {}
        },
        Sj: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ScheduledActionName"
            ],
            members: {
              ScheduledActionName: {},
              ErrorCode: {},
              ErrorMessage: {}
            }
          }
        },
        S14: {
          type: "structure",
          members: {
            LaunchTemplateId: {},
            LaunchTemplateName: {},
            Version: {}
          }
        },
        S16: {
          type: "structure",
          members: {
            LaunchTemplate: {
              type: "structure",
              members: {
                LaunchTemplateSpecification: {
                  shape: "S14"
                },
                Overrides: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      InstanceType: {},
                      WeightedCapacity: {},
                      LaunchTemplateSpecification: {
                        shape: "S14"
                      },
                      InstanceRequirements: {
                        type: "structure",
                        required: [
                          "VCpuCount",
                          "MemoryMiB"
                        ],
                        members: {
                          VCpuCount: {
                            type: "structure",
                            required: [
                              "Min"
                            ],
                            members: {
                              Min: {
                                type: "integer"
                              },
                              Max: {
                                type: "integer"
                              }
                            }
                          },
                          MemoryMiB: {
                            type: "structure",
                            required: [
                              "Min"
                            ],
                            members: {
                              Min: {
                                type: "integer"
                              },
                              Max: {
                                type: "integer"
                              }
                            }
                          },
                          CpuManufacturers: {
                            type: "list",
                            member: {}
                          },
                          MemoryGiBPerVCpu: {
                            type: "structure",
                            members: {
                              Min: {
                                type: "double"
                              },
                              Max: {
                                type: "double"
                              }
                            }
                          },
                          ExcludedInstanceTypes: {
                            type: "list",
                            member: {}
                          },
                          InstanceGenerations: {
                            type: "list",
                            member: {}
                          },
                          SpotMaxPricePercentageOverLowestPrice: {
                            type: "integer"
                          },
                          OnDemandMaxPricePercentageOverLowestPrice: {
                            type: "integer"
                          },
                          BareMetal: {},
                          BurstablePerformance: {},
                          RequireHibernateSupport: {
                            type: "boolean"
                          },
                          NetworkInterfaceCount: {
                            type: "structure",
                            members: {
                              Min: {
                                type: "integer"
                              },
                              Max: {
                                type: "integer"
                              }
                            }
                          },
                          LocalStorage: {},
                          LocalStorageTypes: {
                            type: "list",
                            member: {}
                          },
                          TotalLocalStorageGB: {
                            type: "structure",
                            members: {
                              Min: {
                                type: "double"
                              },
                              Max: {
                                type: "double"
                              }
                            }
                          },
                          BaselineEbsBandwidthMbps: {
                            type: "structure",
                            members: {
                              Min: {
                                type: "integer"
                              },
                              Max: {
                                type: "integer"
                              }
                            }
                          },
                          AcceleratorTypes: {
                            type: "list",
                            member: {}
                          },
                          AcceleratorCount: {
                            type: "structure",
                            members: {
                              Min: {
                                type: "integer"
                              },
                              Max: {
                                type: "integer"
                              }
                            }
                          },
                          AcceleratorManufacturers: {
                            type: "list",
                            member: {}
                          },
                          AcceleratorNames: {
                            type: "list",
                            member: {}
                          },
                          AcceleratorTotalMemoryMiB: {
                            type: "structure",
                            members: {
                              Min: {
                                type: "integer"
                              },
                              Max: {
                                type: "integer"
                              }
                            }
                          },
                          NetworkBandwidthGbps: {
                            type: "structure",
                            members: {
                              Min: {
                                type: "double"
                              },
                              Max: {
                                type: "double"
                              }
                            }
                          },
                          AllowedInstanceTypes: {
                            type: "list",
                            member: {}
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            InstancesDistribution: {
              type: "structure",
              members: {
                OnDemandAllocationStrategy: {},
                OnDemandBaseCapacity: {
                  type: "integer"
                },
                OnDemandPercentageAboveBaseCapacity: {
                  type: "integer"
                },
                SpotAllocationStrategy: {},
                SpotInstancePools: {
                  type: "integer"
                },
                SpotMaxPrice: {}
              }
            }
          }
        },
        S2d: {
          type: "list",
          member: {}
        },
        S2g: {
          type: "list",
          member: {}
        },
        S2q: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              ResourceId: {},
              ResourceType: {},
              Key: {},
              Value: {},
              PropagateAtLaunch: {
                type: "boolean"
              }
            }
          }
        },
        S2y: {
          type: "structure",
          members: {
            MinHealthyPercentage: {
              type: "integer"
            },
            MaxHealthyPercentage: {
              type: "integer"
            }
          }
        },
        S32: {
          type: "list",
          member: {}
        },
        S33: {
          type: "list",
          member: {}
        },
        S35: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "DeviceName"
            ],
            members: {
              VirtualName: {},
              DeviceName: {},
              Ebs: {
                type: "structure",
                members: {
                  SnapshotId: {},
                  VolumeSize: {
                    type: "integer"
                  },
                  VolumeType: {},
                  DeleteOnTermination: {
                    type: "boolean"
                  },
                  Iops: {
                    type: "integer"
                  },
                  Encrypted: {
                    type: "boolean"
                  },
                  Throughput: {
                    type: "integer"
                  }
                }
              },
              NoDevice: {
                type: "boolean"
              }
            }
          }
        },
        S3f: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            }
          }
        },
        S3k: {
          type: "structure",
          members: {
            HttpTokens: {},
            HttpPutResponseHopLimit: {
              type: "integer"
            },
            HttpEndpoint: {}
          }
        },
        S49: {
          type: "list",
          member: {}
        },
        S4b: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Values: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S4i: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "InstanceId",
              "AvailabilityZone",
              "LifecycleState",
              "HealthStatus",
              "ProtectedFromScaleIn"
            ],
            members: {
              InstanceId: {},
              InstanceType: {},
              AvailabilityZone: {},
              LifecycleState: {},
              HealthStatus: {},
              LaunchConfigurationName: {},
              LaunchTemplate: {
                shape: "S14"
              },
              ProtectedFromScaleIn: {
                type: "boolean"
              },
              WeightedCapacity: {}
            }
          }
        },
        S4p: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ResourceId: {},
              ResourceType: {},
              Key: {},
              Value: {},
              PropagateAtLaunch: {
                type: "boolean"
              }
            }
          }
        },
        S4r: {
          type: "structure",
          members: {
            MaxGroupPreparedCapacity: {
              type: "integer"
            },
            MinSize: {
              type: "integer"
            },
            PoolState: {},
            Status: {},
            InstanceReusePolicy: {
              shape: "S4w"
            }
          }
        },
        S4w: {
          type: "structure",
          members: {
            ReuseOnScaleIn: {
              type: "boolean"
            }
          }
        },
        S54: {
          type: "list",
          member: {}
        },
        S5e: {
          type: "structure",
          members: {
            LivePoolProgress: {
              type: "structure",
              members: {
                PercentageComplete: {
                  type: "integer"
                },
                InstancesToUpdate: {
                  type: "integer"
                }
              }
            },
            WarmPoolProgress: {
              type: "structure",
              members: {
                PercentageComplete: {
                  type: "integer"
                },
                InstancesToUpdate: {
                  type: "integer"
                }
              }
            }
          }
        },
        S5h: {
          type: "structure",
          members: {
            MinHealthyPercentage: {
              type: "integer"
            },
            InstanceWarmup: {
              type: "integer"
            },
            CheckpointPercentages: {
              type: "list",
              member: {
                type: "integer"
              }
            },
            CheckpointDelay: {
              type: "integer"
            },
            SkipMatching: {
              type: "boolean"
            },
            AutoRollback: {
              type: "boolean"
            },
            ScaleInProtectedInstances: {},
            StandbyInstances: {},
            AlarmSpecification: {
              type: "structure",
              members: {
                Alarms: {
                  type: "list",
                  member: {}
                }
              }
            },
            MaxHealthyPercentage: {
              type: "integer"
            }
          }
        },
        S5t: {
          type: "structure",
          members: {
            LaunchTemplate: {
              shape: "S14"
            },
            MixedInstancesPolicy: {
              shape: "S16"
            }
          }
        },
        S6u: {
          type: "integer",
          deprecated: true
        },
        S6x: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ScalingAdjustment"
            ],
            members: {
              MetricIntervalLowerBound: {
                type: "double"
              },
              MetricIntervalUpperBound: {
                type: "double"
              },
              ScalingAdjustment: {
                type: "integer"
              }
            }
          }
        },
        S71: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AlarmName: {},
              AlarmARN: {}
            }
          }
        },
        S73: {
          type: "structure",
          required: [
            "TargetValue"
          ],
          members: {
            PredefinedMetricSpecification: {
              type: "structure",
              required: [
                "PredefinedMetricType"
              ],
              members: {
                PredefinedMetricType: {},
                ResourceLabel: {}
              }
            },
            CustomizedMetricSpecification: {
              type: "structure",
              members: {
                MetricName: {},
                Namespace: {},
                Dimensions: {
                  shape: "S79"
                },
                Statistic: {},
                Unit: {},
                Metrics: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "Id"
                    ],
                    members: {
                      Id: {},
                      Expression: {},
                      MetricStat: {
                        type: "structure",
                        required: [
                          "Metric",
                          "Stat"
                        ],
                        members: {
                          Metric: {
                            shape: "S7i"
                          },
                          Stat: {},
                          Unit: {}
                        }
                      },
                      Label: {},
                      ReturnData: {
                        type: "boolean"
                      }
                    }
                  }
                }
              }
            },
            TargetValue: {
              type: "double"
            },
            DisableScaleIn: {
              type: "boolean"
            }
          }
        },
        S79: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Value"
            ],
            members: {
              Name: {},
              Value: {}
            }
          }
        },
        S7i: {
          type: "structure",
          required: [
            "Namespace",
            "MetricName"
          ],
          members: {
            Namespace: {},
            MetricName: {},
            Dimensions: {
              shape: "S79"
            }
          }
        },
        S7o: {
          type: "structure",
          required: [
            "MetricSpecifications"
          ],
          members: {
            MetricSpecifications: {
              type: "list",
              member: {
                shape: "S7q"
              }
            },
            Mode: {},
            SchedulingBufferTime: {
              type: "integer"
            },
            MaxCapacityBreachBehavior: {},
            MaxCapacityBuffer: {
              type: "integer"
            }
          }
        },
        S7q: {
          type: "structure",
          required: [
            "TargetValue"
          ],
          members: {
            TargetValue: {
              type: "double"
            },
            PredefinedMetricPairSpecification: {
              type: "structure",
              required: [
                "PredefinedMetricType"
              ],
              members: {
                PredefinedMetricType: {},
                ResourceLabel: {}
              }
            },
            PredefinedScalingMetricSpecification: {
              type: "structure",
              required: [
                "PredefinedMetricType"
              ],
              members: {
                PredefinedMetricType: {},
                ResourceLabel: {}
              }
            },
            PredefinedLoadMetricSpecification: {
              type: "structure",
              required: [
                "PredefinedMetricType"
              ],
              members: {
                PredefinedMetricType: {},
                ResourceLabel: {}
              }
            },
            CustomizedScalingMetricSpecification: {
              type: "structure",
              required: [
                "MetricDataQueries"
              ],
              members: {
                MetricDataQueries: {
                  shape: "S7y"
                }
              }
            },
            CustomizedLoadMetricSpecification: {
              type: "structure",
              required: [
                "MetricDataQueries"
              ],
              members: {
                MetricDataQueries: {
                  shape: "S7y"
                }
              }
            },
            CustomizedCapacityMetricSpecification: {
              type: "structure",
              required: [
                "MetricDataQueries"
              ],
              members: {
                MetricDataQueries: {
                  shape: "S7y"
                }
              }
            }
          }
        },
        S7y: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {},
              Expression: {},
              MetricStat: {
                type: "structure",
                required: [
                  "Metric",
                  "Stat"
                ],
                members: {
                  Metric: {
                    shape: "S7i"
                  },
                  Stat: {},
                  Unit: {}
                }
              },
              Label: {},
              ReturnData: {
                type: "boolean"
              }
            }
          }
        },
        S8b: {
          type: "list",
          member: {
            shape: "S8c"
          }
        },
        S8c: {
          type: "structure",
          required: [
            "ActivityId",
            "AutoScalingGroupName",
            "Cause",
            "StartTime",
            "StatusCode"
          ],
          members: {
            ActivityId: {},
            AutoScalingGroupName: {},
            Description: {},
            Cause: {},
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            StatusCode: {},
            StatusMessage: {},
            Progress: {
              type: "integer"
            },
            Details: {},
            AutoScalingGroupState: {},
            AutoScalingGroupARN: {}
          }
        },
        S96: {
          type: "list",
          member: {}
        },
        S9i: {
          type: "list",
          member: {
            type: "timestamp"
          }
        },
        S9j: {
          type: "list",
          member: {
            type: "double"
          }
        },
        S9v: {
          type: "structure",
          required: [
            "AutoScalingGroupName"
          ],
          members: {
            AutoScalingGroupName: {},
            ScalingProcesses: {
              type: "list",
              member: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/autoscaling-2011-01-01.paginators.json
var require_autoscaling_2011_01_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/autoscaling-2011-01-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeAutoScalingGroups: {
          input_token: "NextToken",
          limit_key: "MaxRecords",
          output_token: "NextToken",
          result_key: "AutoScalingGroups"
        },
        DescribeAutoScalingInstances: {
          input_token: "NextToken",
          limit_key: "MaxRecords",
          output_token: "NextToken",
          result_key: "AutoScalingInstances"
        },
        DescribeInstanceRefreshes: {
          input_token: "NextToken",
          limit_key: "MaxRecords",
          output_token: "NextToken"
        },
        DescribeLaunchConfigurations: {
          input_token: "NextToken",
          limit_key: "MaxRecords",
          output_token: "NextToken",
          result_key: "LaunchConfigurations"
        },
        DescribeLoadBalancerTargetGroups: {
          input_token: "NextToken",
          limit_key: "MaxRecords",
          output_token: "NextToken"
        },
        DescribeLoadBalancers: {
          input_token: "NextToken",
          limit_key: "MaxRecords",
          output_token: "NextToken"
        },
        DescribeNotificationConfigurations: {
          input_token: "NextToken",
          limit_key: "MaxRecords",
          output_token: "NextToken",
          result_key: "NotificationConfigurations"
        },
        DescribePolicies: {
          input_token: "NextToken",
          limit_key: "MaxRecords",
          output_token: "NextToken",
          result_key: "ScalingPolicies"
        },
        DescribeScalingActivities: {
          input_token: "NextToken",
          limit_key: "MaxRecords",
          output_token: "NextToken",
          result_key: "Activities"
        },
        DescribeScheduledActions: {
          input_token: "NextToken",
          limit_key: "MaxRecords",
          output_token: "NextToken",
          result_key: "ScheduledUpdateGroupActions"
        },
        DescribeTags: {
          input_token: "NextToken",
          limit_key: "MaxRecords",
          output_token: "NextToken",
          result_key: "Tags"
        },
        DescribeTrafficSources: {
          input_token: "NextToken",
          limit_key: "MaxRecords",
          output_token: "NextToken"
        },
        DescribeWarmPool: {
          input_token: "NextToken",
          limit_key: "MaxRecords",
          output_token: "NextToken",
          result_key: "Instances"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/autoscaling.js
var require_autoscaling = __commonJS({
  "node_modules/aws-sdk/clients/autoscaling.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["autoscaling"] = {};
    AWS2.AutoScaling = Service.defineService("autoscaling", ["2011-01-01"]);
    Object.defineProperty(apiLoader.services["autoscaling"], "2011-01-01", {
      get: function get() {
        var model = require_autoscaling_2011_01_01_min();
        model.paginators = require_autoscaling_2011_01_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.AutoScaling;
  }
});

// node_modules/aws-sdk/apis/batch-2016-08-10.min.json
var require_batch_2016_08_10_min = __commonJS({
  "node_modules/aws-sdk/apis/batch-2016-08-10.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-08-10",
        endpointPrefix: "batch",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "AWS Batch",
        serviceFullName: "AWS Batch",
        serviceId: "Batch",
        signatureVersion: "v4",
        uid: "batch-2016-08-10"
      },
      operations: {
        CancelJob: {
          http: {
            requestUri: "/v1/canceljob"
          },
          input: {
            type: "structure",
            required: [
              "jobId",
              "reason"
            ],
            members: {
              jobId: {},
              reason: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateComputeEnvironment: {
          http: {
            requestUri: "/v1/createcomputeenvironment"
          },
          input: {
            type: "structure",
            required: [
              "computeEnvironmentName",
              "type"
            ],
            members: {
              computeEnvironmentName: {},
              type: {},
              state: {},
              unmanagedvCpus: {
                type: "integer"
              },
              computeResources: {
                shape: "S8"
              },
              serviceRole: {},
              tags: {
                shape: "Sj"
              },
              eksConfiguration: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              computeEnvironmentName: {},
              computeEnvironmentArn: {}
            }
          }
        },
        CreateJobQueue: {
          http: {
            requestUri: "/v1/createjobqueue"
          },
          input: {
            type: "structure",
            required: [
              "jobQueueName",
              "priority",
              "computeEnvironmentOrder"
            ],
            members: {
              jobQueueName: {},
              state: {},
              schedulingPolicyArn: {},
              priority: {
                type: "integer"
              },
              computeEnvironmentOrder: {
                shape: "Sq"
              },
              tags: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobQueueName",
              "jobQueueArn"
            ],
            members: {
              jobQueueName: {},
              jobQueueArn: {}
            }
          }
        },
        CreateSchedulingPolicy: {
          http: {
            requestUri: "/v1/createschedulingpolicy"
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              fairsharePolicy: {
                shape: "Su"
              },
              tags: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "name",
              "arn"
            ],
            members: {
              name: {},
              arn: {}
            }
          }
        },
        DeleteComputeEnvironment: {
          http: {
            requestUri: "/v1/deletecomputeenvironment"
          },
          input: {
            type: "structure",
            required: [
              "computeEnvironment"
            ],
            members: {
              computeEnvironment: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteJobQueue: {
          http: {
            requestUri: "/v1/deletejobqueue"
          },
          input: {
            type: "structure",
            required: [
              "jobQueue"
            ],
            members: {
              jobQueue: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSchedulingPolicy: {
          http: {
            requestUri: "/v1/deleteschedulingpolicy"
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeregisterJobDefinition: {
          http: {
            requestUri: "/v1/deregisterjobdefinition"
          },
          input: {
            type: "structure",
            required: [
              "jobDefinition"
            ],
            members: {
              jobDefinition: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeComputeEnvironments: {
          http: {
            requestUri: "/v1/describecomputeenvironments"
          },
          input: {
            type: "structure",
            members: {
              computeEnvironments: {
                shape: "Sb"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              computeEnvironments: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "computeEnvironmentName",
                    "computeEnvironmentArn"
                  ],
                  members: {
                    computeEnvironmentName: {},
                    computeEnvironmentArn: {},
                    unmanagedvCpus: {
                      type: "integer"
                    },
                    ecsClusterArn: {},
                    tags: {
                      shape: "Sj"
                    },
                    type: {},
                    state: {},
                    status: {},
                    statusReason: {},
                    computeResources: {
                      shape: "S8"
                    },
                    serviceRole: {},
                    updatePolicy: {
                      shape: "S1c"
                    },
                    eksConfiguration: {
                      shape: "Sm"
                    },
                    containerOrchestrationType: {},
                    uuid: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeJobDefinitions: {
          http: {
            requestUri: "/v1/describejobdefinitions"
          },
          input: {
            type: "structure",
            members: {
              jobDefinitions: {
                shape: "Sb"
              },
              maxResults: {
                type: "integer"
              },
              jobDefinitionName: {},
              status: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              jobDefinitions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "jobDefinitionName",
                    "jobDefinitionArn",
                    "revision",
                    "type"
                  ],
                  members: {
                    jobDefinitionName: {},
                    jobDefinitionArn: {},
                    revision: {
                      type: "integer"
                    },
                    status: {},
                    type: {},
                    schedulingPriority: {
                      type: "integer"
                    },
                    parameters: {
                      shape: "S1k"
                    },
                    retryStrategy: {
                      shape: "S1l"
                    },
                    containerProperties: {
                      shape: "S1p"
                    },
                    timeout: {
                      shape: "S2n"
                    },
                    nodeProperties: {
                      shape: "S2o"
                    },
                    tags: {
                      shape: "Sj"
                    },
                    propagateTags: {
                      type: "boolean"
                    },
                    platformCapabilities: {
                      shape: "S2r"
                    },
                    eksProperties: {
                      shape: "S2t"
                    },
                    containerOrchestrationType: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeJobQueues: {
          http: {
            requestUri: "/v1/describejobqueues"
          },
          input: {
            type: "structure",
            members: {
              jobQueues: {
                shape: "Sb"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              jobQueues: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "jobQueueName",
                    "jobQueueArn",
                    "state",
                    "priority",
                    "computeEnvironmentOrder"
                  ],
                  members: {
                    jobQueueName: {},
                    jobQueueArn: {},
                    state: {},
                    schedulingPolicyArn: {},
                    status: {},
                    statusReason: {},
                    priority: {
                      type: "integer"
                    },
                    computeEnvironmentOrder: {
                      shape: "Sq"
                    },
                    tags: {
                      shape: "Sj"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeJobs: {
          http: {
            requestUri: "/v1/describejobs"
          },
          input: {
            type: "structure",
            required: [
              "jobs"
            ],
            members: {
              jobs: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobs: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "jobName",
                    "jobId",
                    "jobQueue",
                    "status",
                    "startedAt",
                    "jobDefinition"
                  ],
                  members: {
                    jobArn: {},
                    jobName: {},
                    jobId: {},
                    jobQueue: {},
                    status: {},
                    shareIdentifier: {},
                    schedulingPriority: {
                      type: "integer"
                    },
                    attempts: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          container: {
                            type: "structure",
                            members: {
                              containerInstanceArn: {},
                              taskArn: {},
                              exitCode: {
                                type: "integer"
                              },
                              reason: {},
                              logStreamName: {},
                              networkInterfaces: {
                                shape: "S3r"
                              }
                            }
                          },
                          startedAt: {
                            type: "long"
                          },
                          stoppedAt: {
                            type: "long"
                          },
                          statusReason: {}
                        }
                      }
                    },
                    statusReason: {},
                    createdAt: {
                      type: "long"
                    },
                    retryStrategy: {
                      shape: "S1l"
                    },
                    startedAt: {
                      type: "long"
                    },
                    stoppedAt: {
                      type: "long"
                    },
                    dependsOn: {
                      shape: "S3t"
                    },
                    jobDefinition: {},
                    parameters: {
                      shape: "S1k"
                    },
                    container: {
                      type: "structure",
                      members: {
                        image: {},
                        vcpus: {
                          type: "integer"
                        },
                        memory: {
                          type: "integer"
                        },
                        command: {
                          shape: "Sb"
                        },
                        jobRoleArn: {},
                        executionRoleArn: {},
                        volumes: {
                          shape: "S1q"
                        },
                        environment: {
                          shape: "S1x"
                        },
                        mountPoints: {
                          shape: "S1z"
                        },
                        readonlyRootFilesystem: {
                          type: "boolean"
                        },
                        ulimits: {
                          shape: "S21"
                        },
                        privileged: {
                          type: "boolean"
                        },
                        user: {},
                        exitCode: {
                          type: "integer"
                        },
                        reason: {},
                        containerInstanceArn: {},
                        taskArn: {},
                        logStreamName: {},
                        instanceType: {},
                        networkInterfaces: {
                          shape: "S3r"
                        },
                        resourceRequirements: {
                          shape: "S23"
                        },
                        linuxParameters: {
                          shape: "S26"
                        },
                        logConfiguration: {
                          shape: "S2d"
                        },
                        secrets: {
                          shape: "S2g"
                        },
                        networkConfiguration: {
                          shape: "S2i"
                        },
                        fargatePlatformConfiguration: {
                          shape: "S2k"
                        },
                        ephemeralStorage: {
                          shape: "S2l"
                        },
                        runtimePlatform: {
                          shape: "S2m"
                        }
                      }
                    },
                    nodeDetails: {
                      type: "structure",
                      members: {
                        nodeIndex: {
                          type: "integer"
                        },
                        isMainNode: {
                          type: "boolean"
                        }
                      }
                    },
                    nodeProperties: {
                      shape: "S2o"
                    },
                    arrayProperties: {
                      type: "structure",
                      members: {
                        statusSummary: {
                          type: "map",
                          key: {},
                          value: {
                            type: "integer"
                          }
                        },
                        size: {
                          type: "integer"
                        },
                        index: {
                          type: "integer"
                        }
                      }
                    },
                    timeout: {
                      shape: "S2n"
                    },
                    tags: {
                      shape: "Sj"
                    },
                    propagateTags: {
                      type: "boolean"
                    },
                    platformCapabilities: {
                      shape: "S2r"
                    },
                    eksProperties: {
                      type: "structure",
                      members: {
                        podProperties: {
                          type: "structure",
                          members: {
                            serviceAccountName: {},
                            hostNetwork: {
                              type: "boolean"
                            },
                            dnsPolicy: {},
                            containers: {
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  name: {},
                                  image: {},
                                  imagePullPolicy: {},
                                  command: {
                                    shape: "Sb"
                                  },
                                  args: {
                                    shape: "Sb"
                                  },
                                  env: {
                                    shape: "S2x"
                                  },
                                  resources: {
                                    shape: "S2z"
                                  },
                                  exitCode: {
                                    type: "integer"
                                  },
                                  reason: {},
                                  volumeMounts: {
                                    shape: "S33"
                                  },
                                  securityContext: {
                                    shape: "S35"
                                  }
                                }
                              }
                            },
                            volumes: {
                              shape: "S37"
                            },
                            podName: {},
                            nodeName: {},
                            metadata: {
                              shape: "S3c"
                            }
                          }
                        }
                      }
                    },
                    eksAttempts: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          containers: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                exitCode: {
                                  type: "integer"
                                },
                                reason: {}
                              }
                            }
                          },
                          podName: {},
                          nodeName: {},
                          startedAt: {
                            type: "long"
                          },
                          stoppedAt: {
                            type: "long"
                          },
                          statusReason: {}
                        }
                      }
                    },
                    isCancelled: {
                      type: "boolean"
                    },
                    isTerminated: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeSchedulingPolicies: {
          http: {
            requestUri: "/v1/describeschedulingpolicies"
          },
          input: {
            type: "structure",
            required: [
              "arns"
            ],
            members: {
              arns: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              schedulingPolicies: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "arn"
                  ],
                  members: {
                    name: {},
                    arn: {},
                    fairsharePolicy: {
                      shape: "Su"
                    },
                    tags: {
                      shape: "Sj"
                    }
                  }
                }
              }
            }
          }
        },
        ListJobs: {
          http: {
            requestUri: "/v1/listjobs"
          },
          input: {
            type: "structure",
            members: {
              jobQueue: {},
              arrayJobId: {},
              multiNodeJobId: {},
              jobStatus: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    values: {
                      shape: "Sb"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobSummaryList"
            ],
            members: {
              jobSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "jobId",
                    "jobName"
                  ],
                  members: {
                    jobArn: {},
                    jobId: {},
                    jobName: {},
                    createdAt: {
                      type: "long"
                    },
                    status: {},
                    statusReason: {},
                    startedAt: {
                      type: "long"
                    },
                    stoppedAt: {
                      type: "long"
                    },
                    container: {
                      type: "structure",
                      members: {
                        exitCode: {
                          type: "integer"
                        },
                        reason: {}
                      }
                    },
                    arrayProperties: {
                      type: "structure",
                      members: {
                        size: {
                          type: "integer"
                        },
                        index: {
                          type: "integer"
                        }
                      }
                    },
                    nodeProperties: {
                      type: "structure",
                      members: {
                        isMainNode: {
                          type: "boolean"
                        },
                        numNodes: {
                          type: "integer"
                        },
                        nodeIndex: {
                          type: "integer"
                        }
                      }
                    },
                    jobDefinition: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSchedulingPolicies: {
          http: {
            requestUri: "/v1/listschedulingpolicies"
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              schedulingPolicies: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn"
                  ],
                  members: {
                    arn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/v1/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sj"
              }
            }
          }
        },
        RegisterJobDefinition: {
          http: {
            requestUri: "/v1/registerjobdefinition"
          },
          input: {
            type: "structure",
            required: [
              "jobDefinitionName",
              "type"
            ],
            members: {
              jobDefinitionName: {},
              type: {},
              parameters: {
                shape: "S1k"
              },
              schedulingPriority: {
                type: "integer"
              },
              containerProperties: {
                shape: "S1p"
              },
              nodeProperties: {
                shape: "S2o"
              },
              retryStrategy: {
                shape: "S1l"
              },
              propagateTags: {
                type: "boolean"
              },
              timeout: {
                shape: "S2n"
              },
              tags: {
                shape: "Sj"
              },
              platformCapabilities: {
                shape: "S2r"
              },
              eksProperties: {
                shape: "S2t"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobDefinitionName",
              "jobDefinitionArn",
              "revision"
            ],
            members: {
              jobDefinitionName: {},
              jobDefinitionArn: {},
              revision: {
                type: "integer"
              }
            }
          }
        },
        SubmitJob: {
          http: {
            requestUri: "/v1/submitjob"
          },
          input: {
            type: "structure",
            required: [
              "jobName",
              "jobQueue",
              "jobDefinition"
            ],
            members: {
              jobName: {},
              jobQueue: {},
              shareIdentifier: {},
              schedulingPriorityOverride: {
                type: "integer"
              },
              arrayProperties: {
                type: "structure",
                members: {
                  size: {
                    type: "integer"
                  }
                }
              },
              dependsOn: {
                shape: "S3t"
              },
              jobDefinition: {},
              parameters: {
                shape: "S1k"
              },
              containerOverrides: {
                shape: "S4w"
              },
              nodeOverrides: {
                type: "structure",
                members: {
                  numNodes: {
                    type: "integer"
                  },
                  nodePropertyOverrides: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "targetNodes"
                      ],
                      members: {
                        targetNodes: {},
                        containerOverrides: {
                          shape: "S4w"
                        }
                      }
                    }
                  }
                }
              },
              retryStrategy: {
                shape: "S1l"
              },
              propagateTags: {
                type: "boolean"
              },
              timeout: {
                shape: "S2n"
              },
              tags: {
                shape: "Sj"
              },
              eksPropertiesOverride: {
                type: "structure",
                members: {
                  podProperties: {
                    type: "structure",
                    members: {
                      containers: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            image: {},
                            command: {
                              shape: "Sb"
                            },
                            args: {
                              shape: "Sb"
                            },
                            env: {
                              shape: "S2x"
                            },
                            resources: {
                              shape: "S2z"
                            }
                          }
                        }
                      },
                      metadata: {
                        shape: "S3c"
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobName",
              "jobId"
            ],
            members: {
              jobArn: {},
              jobName: {},
              jobId: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/v1/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TerminateJob: {
          http: {
            requestUri: "/v1/terminatejob"
          },
          input: {
            type: "structure",
            required: [
              "jobId",
              "reason"
            ],
            members: {
              jobId: {},
              reason: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/v1/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateComputeEnvironment: {
          http: {
            requestUri: "/v1/updatecomputeenvironment"
          },
          input: {
            type: "structure",
            required: [
              "computeEnvironment"
            ],
            members: {
              computeEnvironment: {},
              state: {},
              unmanagedvCpus: {
                type: "integer"
              },
              computeResources: {
                type: "structure",
                members: {
                  minvCpus: {
                    type: "integer"
                  },
                  maxvCpus: {
                    type: "integer"
                  },
                  desiredvCpus: {
                    type: "integer"
                  },
                  subnets: {
                    shape: "Sb"
                  },
                  securityGroupIds: {
                    shape: "Sb"
                  },
                  allocationStrategy: {},
                  instanceTypes: {
                    shape: "Sb"
                  },
                  ec2KeyPair: {},
                  instanceRole: {},
                  tags: {
                    shape: "Sc"
                  },
                  placementGroup: {},
                  bidPercentage: {
                    type: "integer"
                  },
                  launchTemplate: {
                    shape: "Sd"
                  },
                  ec2Configuration: {
                    shape: "Se"
                  },
                  updateToLatestImageVersion: {
                    type: "boolean"
                  },
                  type: {},
                  imageId: {}
                }
              },
              serviceRole: {},
              updatePolicy: {
                shape: "S1c"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              computeEnvironmentName: {},
              computeEnvironmentArn: {}
            }
          }
        },
        UpdateJobQueue: {
          http: {
            requestUri: "/v1/updatejobqueue"
          },
          input: {
            type: "structure",
            required: [
              "jobQueue"
            ],
            members: {
              jobQueue: {},
              state: {},
              schedulingPolicyArn: {},
              priority: {
                type: "integer"
              },
              computeEnvironmentOrder: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobQueueName: {},
              jobQueueArn: {}
            }
          }
        },
        UpdateSchedulingPolicy: {
          http: {
            requestUri: "/v1/updateschedulingpolicy"
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              fairsharePolicy: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S8: {
          type: "structure",
          required: [
            "type",
            "maxvCpus",
            "subnets"
          ],
          members: {
            type: {},
            allocationStrategy: {},
            minvCpus: {
              type: "integer"
            },
            maxvCpus: {
              type: "integer"
            },
            desiredvCpus: {
              type: "integer"
            },
            instanceTypes: {
              shape: "Sb"
            },
            imageId: {
              deprecated: true,
              deprecatedMessage: "This field is deprecated, use ec2Configuration[].imageIdOverride instead."
            },
            subnets: {
              shape: "Sb"
            },
            securityGroupIds: {
              shape: "Sb"
            },
            ec2KeyPair: {},
            instanceRole: {},
            tags: {
              shape: "Sc"
            },
            placementGroup: {},
            bidPercentage: {
              type: "integer"
            },
            spotIamFleetRole: {},
            launchTemplate: {
              shape: "Sd"
            },
            ec2Configuration: {
              shape: "Se"
            }
          }
        },
        Sb: {
          type: "list",
          member: {}
        },
        Sc: {
          type: "map",
          key: {},
          value: {}
        },
        Sd: {
          type: "structure",
          members: {
            launchTemplateId: {},
            launchTemplateName: {},
            version: {}
          }
        },
        Se: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "imageType"
            ],
            members: {
              imageType: {},
              imageIdOverride: {},
              imageKubernetesVersion: {}
            }
          }
        },
        Sj: {
          type: "map",
          key: {},
          value: {}
        },
        Sm: {
          type: "structure",
          required: [
            "eksClusterArn",
            "kubernetesNamespace"
          ],
          members: {
            eksClusterArn: {},
            kubernetesNamespace: {}
          }
        },
        Sq: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "order",
              "computeEnvironment"
            ],
            members: {
              order: {
                type: "integer"
              },
              computeEnvironment: {}
            }
          }
        },
        Su: {
          type: "structure",
          members: {
            shareDecaySeconds: {
              type: "integer"
            },
            computeReservation: {
              type: "integer"
            },
            shareDistribution: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "shareIdentifier"
                ],
                members: {
                  shareIdentifier: {},
                  weightFactor: {
                    type: "float"
                  }
                }
              }
            }
          }
        },
        S1c: {
          type: "structure",
          members: {
            terminateJobsOnUpdate: {
              type: "boolean"
            },
            jobExecutionTimeoutMinutes: {
              type: "long"
            }
          }
        },
        S1k: {
          type: "map",
          key: {},
          value: {}
        },
        S1l: {
          type: "structure",
          members: {
            attempts: {
              type: "integer"
            },
            evaluateOnExit: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "action"
                ],
                members: {
                  onStatusReason: {},
                  onReason: {},
                  onExitCode: {},
                  action: {}
                }
              }
            }
          }
        },
        S1p: {
          type: "structure",
          members: {
            image: {},
            vcpus: {
              deprecated: true,
              deprecatedMessage: "This field is deprecated, use resourceRequirements instead.",
              type: "integer"
            },
            memory: {
              deprecated: true,
              deprecatedMessage: "This field is deprecated, use resourceRequirements instead.",
              type: "integer"
            },
            command: {
              shape: "Sb"
            },
            jobRoleArn: {},
            executionRoleArn: {},
            volumes: {
              shape: "S1q"
            },
            environment: {
              shape: "S1x"
            },
            mountPoints: {
              shape: "S1z"
            },
            readonlyRootFilesystem: {
              type: "boolean"
            },
            privileged: {
              type: "boolean"
            },
            ulimits: {
              shape: "S21"
            },
            user: {},
            instanceType: {},
            resourceRequirements: {
              shape: "S23"
            },
            linuxParameters: {
              shape: "S26"
            },
            logConfiguration: {
              shape: "S2d"
            },
            secrets: {
              shape: "S2g"
            },
            networkConfiguration: {
              shape: "S2i"
            },
            fargatePlatformConfiguration: {
              shape: "S2k"
            },
            ephemeralStorage: {
              shape: "S2l"
            },
            runtimePlatform: {
              shape: "S2m"
            }
          }
        },
        S1q: {
          type: "list",
          member: {
            type: "structure",
            members: {
              host: {
                type: "structure",
                members: {
                  sourcePath: {}
                }
              },
              name: {},
              efsVolumeConfiguration: {
                type: "structure",
                required: [
                  "fileSystemId"
                ],
                members: {
                  fileSystemId: {},
                  rootDirectory: {},
                  transitEncryption: {},
                  transitEncryptionPort: {
                    type: "integer"
                  },
                  authorizationConfig: {
                    type: "structure",
                    members: {
                      accessPointId: {},
                      iam: {}
                    }
                  }
                }
              }
            }
          }
        },
        S1x: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              value: {}
            }
          }
        },
        S1z: {
          type: "list",
          member: {
            type: "structure",
            members: {
              containerPath: {},
              readOnly: {
                type: "boolean"
              },
              sourceVolume: {}
            }
          }
        },
        S21: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "hardLimit",
              "name",
              "softLimit"
            ],
            members: {
              hardLimit: {
                type: "integer"
              },
              name: {},
              softLimit: {
                type: "integer"
              }
            }
          }
        },
        S23: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "value",
              "type"
            ],
            members: {
              value: {},
              type: {}
            }
          }
        },
        S26: {
          type: "structure",
          members: {
            devices: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "hostPath"
                ],
                members: {
                  hostPath: {},
                  containerPath: {},
                  permissions: {
                    type: "list",
                    member: {}
                  }
                }
              }
            },
            initProcessEnabled: {
              type: "boolean"
            },
            sharedMemorySize: {
              type: "integer"
            },
            tmpfs: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "containerPath",
                  "size"
                ],
                members: {
                  containerPath: {},
                  size: {
                    type: "integer"
                  },
                  mountOptions: {
                    shape: "Sb"
                  }
                }
              }
            },
            maxSwap: {
              type: "integer"
            },
            swappiness: {
              type: "integer"
            }
          }
        },
        S2d: {
          type: "structure",
          required: [
            "logDriver"
          ],
          members: {
            logDriver: {},
            options: {
              type: "map",
              key: {},
              value: {}
            },
            secretOptions: {
              shape: "S2g"
            }
          }
        },
        S2g: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "valueFrom"
            ],
            members: {
              name: {},
              valueFrom: {}
            }
          }
        },
        S2i: {
          type: "structure",
          members: {
            assignPublicIp: {}
          }
        },
        S2k: {
          type: "structure",
          members: {
            platformVersion: {}
          }
        },
        S2l: {
          type: "structure",
          required: [
            "sizeInGiB"
          ],
          members: {
            sizeInGiB: {
              type: "integer"
            }
          }
        },
        S2m: {
          type: "structure",
          members: {
            operatingSystemFamily: {},
            cpuArchitecture: {}
          }
        },
        S2n: {
          type: "structure",
          members: {
            attemptDurationSeconds: {
              type: "integer"
            }
          }
        },
        S2o: {
          type: "structure",
          required: [
            "numNodes",
            "mainNode",
            "nodeRangeProperties"
          ],
          members: {
            numNodes: {
              type: "integer"
            },
            mainNode: {
              type: "integer"
            },
            nodeRangeProperties: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "targetNodes"
                ],
                members: {
                  targetNodes: {},
                  container: {
                    shape: "S1p"
                  }
                }
              }
            }
          }
        },
        S2r: {
          type: "list",
          member: {}
        },
        S2t: {
          type: "structure",
          members: {
            podProperties: {
              type: "structure",
              members: {
                serviceAccountName: {},
                hostNetwork: {
                  type: "boolean"
                },
                dnsPolicy: {},
                containers: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "image"
                    ],
                    members: {
                      name: {},
                      image: {},
                      imagePullPolicy: {},
                      command: {
                        shape: "Sb"
                      },
                      args: {
                        shape: "Sb"
                      },
                      env: {
                        shape: "S2x"
                      },
                      resources: {
                        shape: "S2z"
                      },
                      volumeMounts: {
                        shape: "S33"
                      },
                      securityContext: {
                        shape: "S35"
                      }
                    }
                  }
                },
                volumes: {
                  shape: "S37"
                },
                metadata: {
                  shape: "S3c"
                }
              }
            }
          }
        },
        S2x: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              value: {}
            }
          }
        },
        S2z: {
          type: "structure",
          members: {
            limits: {
              type: "map",
              key: {},
              value: {}
            },
            requests: {
              type: "map",
              key: {},
              value: {}
            }
          }
        },
        S33: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              mountPath: {},
              readOnly: {
                type: "boolean"
              }
            }
          }
        },
        S35: {
          type: "structure",
          members: {
            runAsUser: {
              type: "long"
            },
            runAsGroup: {
              type: "long"
            },
            privileged: {
              type: "boolean"
            },
            readOnlyRootFilesystem: {
              type: "boolean"
            },
            runAsNonRoot: {
              type: "boolean"
            }
          }
        },
        S37: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              hostPath: {
                type: "structure",
                members: {
                  path: {}
                }
              },
              emptyDir: {
                type: "structure",
                members: {
                  medium: {},
                  sizeLimit: {}
                }
              },
              secret: {
                type: "structure",
                required: [
                  "secretName"
                ],
                members: {
                  secretName: {},
                  optional: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        S3c: {
          type: "structure",
          members: {
            labels: {
              type: "map",
              key: {},
              value: {}
            }
          }
        },
        S3r: {
          type: "list",
          member: {
            type: "structure",
            members: {
              attachmentId: {},
              ipv6Address: {},
              privateIpv4Address: {}
            }
          }
        },
        S3t: {
          type: "list",
          member: {
            type: "structure",
            members: {
              jobId: {},
              type: {}
            }
          }
        },
        S4w: {
          type: "structure",
          members: {
            vcpus: {
              deprecated: true,
              deprecatedMessage: "This field is deprecated, use resourceRequirements instead.",
              type: "integer"
            },
            memory: {
              deprecated: true,
              deprecatedMessage: "This field is deprecated, use resourceRequirements instead.",
              type: "integer"
            },
            command: {
              shape: "Sb"
            },
            instanceType: {},
            environment: {
              shape: "S1x"
            },
            resourceRequirements: {
              shape: "S23"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/batch-2016-08-10.paginators.json
var require_batch_2016_08_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/batch-2016-08-10.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeComputeEnvironments: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "computeEnvironments"
        },
        DescribeJobDefinitions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "jobDefinitions"
        },
        DescribeJobQueues: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "jobQueues"
        },
        ListJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "jobSummaryList"
        },
        ListSchedulingPolicies: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "schedulingPolicies"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/batch.js
var require_batch = __commonJS({
  "node_modules/aws-sdk/clients/batch.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["batch"] = {};
    AWS2.Batch = Service.defineService("batch", ["2016-08-10"]);
    Object.defineProperty(apiLoader.services["batch"], "2016-08-10", {
      get: function get() {
        var model = require_batch_2016_08_10_min();
        model.paginators = require_batch_2016_08_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Batch;
  }
});

// node_modules/aws-sdk/apis/budgets-2016-10-20.min.json
var require_budgets_2016_10_20_min = __commonJS({
  "node_modules/aws-sdk/apis/budgets-2016-10-20.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-10-20",
        endpointPrefix: "budgets",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "AWSBudgets",
        serviceFullName: "AWS Budgets",
        serviceId: "Budgets",
        signatureVersion: "v4",
        targetPrefix: "AWSBudgetServiceGateway",
        uid: "budgets-2016-10-20"
      },
      operations: {
        CreateBudget: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Budget"
            ],
            members: {
              AccountId: {},
              Budget: {
                shape: "S3"
              },
              NotificationsWithSubscribers: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Notification",
                    "Subscribers"
                  ],
                  members: {
                    Notification: {
                      shape: "Sq"
                    },
                    Subscribers: {
                      shape: "Sw"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateBudgetAction: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "NotificationType",
              "ActionType",
              "ActionThreshold",
              "Definition",
              "ExecutionRoleArn",
              "ApprovalModel",
              "Subscribers"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              NotificationType: {},
              ActionType: {},
              ActionThreshold: {
                shape: "S13"
              },
              Definition: {
                shape: "S14"
              },
              ExecutionRoleArn: {},
              ApprovalModel: {},
              Subscribers: {
                shape: "Sw"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "ActionId"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              ActionId: {}
            }
          }
        },
        CreateNotification: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "Notification",
              "Subscribers"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              Notification: {
                shape: "Sq"
              },
              Subscribers: {
                shape: "Sw"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateSubscriber: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "Notification",
              "Subscriber"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              Notification: {
                shape: "Sq"
              },
              Subscriber: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteBudget: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName"
            ],
            members: {
              AccountId: {},
              BudgetName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteBudgetAction: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "ActionId"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              ActionId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "Action"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              Action: {
                shape: "S1y"
              }
            }
          }
        },
        DeleteNotification: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "Notification"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              Notification: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSubscriber: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "Notification",
              "Subscriber"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              Notification: {
                shape: "Sq"
              },
              Subscriber: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeBudget: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName"
            ],
            members: {
              AccountId: {},
              BudgetName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Budget: {
                shape: "S3"
              }
            }
          }
        },
        DescribeBudgetAction: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "ActionId"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              ActionId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "Action"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              Action: {
                shape: "S1y"
              }
            }
          }
        },
        DescribeBudgetActionHistories: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "ActionId"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              ActionId: {},
              TimePeriod: {
                shape: "Sg"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ActionHistories"
            ],
            members: {
              ActionHistories: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Timestamp",
                    "Status",
                    "EventType",
                    "ActionHistoryDetails"
                  ],
                  members: {
                    Timestamp: {
                      type: "timestamp"
                    },
                    Status: {},
                    EventType: {},
                    ActionHistoryDetails: {
                      type: "structure",
                      required: [
                        "Message",
                        "Action"
                      ],
                      members: {
                        Message: {},
                        Action: {
                          shape: "S1y"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeBudgetActionsForAccount: {
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Actions"
            ],
            members: {
              Actions: {
                shape: "S2h"
              },
              NextToken: {}
            }
          }
        },
        DescribeBudgetActionsForBudget: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Actions"
            ],
            members: {
              Actions: {
                shape: "S2h"
              },
              NextToken: {}
            }
          }
        },
        DescribeBudgetNotificationsForAccount: {
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BudgetNotificationsForAccount: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Notifications: {
                      shape: "S2p"
                    },
                    BudgetName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeBudgetPerformanceHistory: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              TimePeriod: {
                shape: "Sg"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BudgetPerformanceHistory: {
                type: "structure",
                members: {
                  BudgetName: {},
                  BudgetType: {},
                  CostFilters: {
                    shape: "Sa"
                  },
                  CostTypes: {
                    shape: "Sd"
                  },
                  TimeUnit: {},
                  BudgetedAndActualAmountsList: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        BudgetedAmount: {
                          shape: "S5"
                        },
                        ActualAmount: {
                          shape: "S5"
                        },
                        TimePeriod: {
                          shape: "Sg"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeBudgets: {
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Budgets: {
                type: "list",
                member: {
                  shape: "S3"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeNotificationsForBudget: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Notifications: {
                shape: "S2p"
              },
              NextToken: {}
            }
          }
        },
        DescribeSubscribersForNotification: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "Notification"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              Notification: {
                shape: "Sq"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Subscribers: {
                shape: "Sw"
              },
              NextToken: {}
            }
          }
        },
        ExecuteBudgetAction: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "ActionId",
              "ExecutionType"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              ActionId: {},
              ExecutionType: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "ActionId",
              "ExecutionType"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              ActionId: {},
              ExecutionType: {}
            }
          }
        },
        UpdateBudget: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "NewBudget"
            ],
            members: {
              AccountId: {},
              NewBudget: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateBudgetAction: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "ActionId"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              ActionId: {},
              NotificationType: {},
              ActionThreshold: {
                shape: "S13"
              },
              Definition: {
                shape: "S14"
              },
              ExecutionRoleArn: {},
              ApprovalModel: {},
              Subscribers: {
                shape: "Sw"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "OldAction",
              "NewAction"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              OldAction: {
                shape: "S1y"
              },
              NewAction: {
                shape: "S1y"
              }
            }
          }
        },
        UpdateNotification: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "OldNotification",
              "NewNotification"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              OldNotification: {
                shape: "Sq"
              },
              NewNotification: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateSubscriber: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "Notification",
              "OldSubscriber",
              "NewSubscriber"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              Notification: {
                shape: "Sq"
              },
              OldSubscriber: {
                shape: "Sx"
              },
              NewSubscriber: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          required: [
            "BudgetName",
            "TimeUnit",
            "BudgetType"
          ],
          members: {
            BudgetName: {},
            BudgetLimit: {
              shape: "S5"
            },
            PlannedBudgetLimits: {
              type: "map",
              key: {},
              value: {
                shape: "S5"
              }
            },
            CostFilters: {
              shape: "Sa"
            },
            CostTypes: {
              shape: "Sd"
            },
            TimeUnit: {},
            TimePeriod: {
              shape: "Sg"
            },
            CalculatedSpend: {
              type: "structure",
              required: [
                "ActualSpend"
              ],
              members: {
                ActualSpend: {
                  shape: "S5"
                },
                ForecastedSpend: {
                  shape: "S5"
                }
              }
            },
            BudgetType: {},
            LastUpdatedTime: {
              type: "timestamp"
            },
            AutoAdjustData: {
              type: "structure",
              required: [
                "AutoAdjustType"
              ],
              members: {
                AutoAdjustType: {},
                HistoricalOptions: {
                  type: "structure",
                  required: [
                    "BudgetAdjustmentPeriod"
                  ],
                  members: {
                    BudgetAdjustmentPeriod: {
                      type: "integer"
                    },
                    LookBackAvailablePeriods: {
                      type: "integer"
                    }
                  }
                },
                LastAutoAdjustTime: {
                  type: "timestamp"
                }
              }
            }
          }
        },
        S5: {
          type: "structure",
          required: [
            "Amount",
            "Unit"
          ],
          members: {
            Amount: {},
            Unit: {}
          }
        },
        Sa: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {}
          }
        },
        Sd: {
          type: "structure",
          members: {
            IncludeTax: {
              type: "boolean"
            },
            IncludeSubscription: {
              type: "boolean"
            },
            UseBlended: {
              type: "boolean"
            },
            IncludeRefund: {
              type: "boolean"
            },
            IncludeCredit: {
              type: "boolean"
            },
            IncludeUpfront: {
              type: "boolean"
            },
            IncludeRecurring: {
              type: "boolean"
            },
            IncludeOtherSubscription: {
              type: "boolean"
            },
            IncludeSupport: {
              type: "boolean"
            },
            IncludeDiscount: {
              type: "boolean"
            },
            UseAmortized: {
              type: "boolean"
            }
          }
        },
        Sg: {
          type: "structure",
          members: {
            Start: {
              type: "timestamp"
            },
            End: {
              type: "timestamp"
            }
          }
        },
        Sq: {
          type: "structure",
          required: [
            "NotificationType",
            "ComparisonOperator",
            "Threshold"
          ],
          members: {
            NotificationType: {},
            ComparisonOperator: {},
            Threshold: {
              type: "double"
            },
            ThresholdType: {},
            NotificationState: {}
          }
        },
        Sw: {
          type: "list",
          member: {
            shape: "Sx"
          }
        },
        Sx: {
          type: "structure",
          required: [
            "SubscriptionType",
            "Address"
          ],
          members: {
            SubscriptionType: {},
            Address: {
              type: "string",
              sensitive: true
            }
          }
        },
        S13: {
          type: "structure",
          required: [
            "ActionThresholdValue",
            "ActionThresholdType"
          ],
          members: {
            ActionThresholdValue: {
              type: "double"
            },
            ActionThresholdType: {}
          }
        },
        S14: {
          type: "structure",
          members: {
            IamActionDefinition: {
              type: "structure",
              required: [
                "PolicyArn"
              ],
              members: {
                PolicyArn: {},
                Roles: {
                  type: "list",
                  member: {}
                },
                Groups: {
                  type: "list",
                  member: {}
                },
                Users: {
                  type: "list",
                  member: {}
                }
              }
            },
            ScpActionDefinition: {
              type: "structure",
              required: [
                "PolicyId",
                "TargetIds"
              ],
              members: {
                PolicyId: {},
                TargetIds: {
                  type: "list",
                  member: {}
                }
              }
            },
            SsmActionDefinition: {
              type: "structure",
              required: [
                "ActionSubType",
                "Region",
                "InstanceIds"
              ],
              members: {
                ActionSubType: {},
                Region: {},
                InstanceIds: {
                  type: "list",
                  member: {}
                }
              }
            }
          }
        },
        S1y: {
          type: "structure",
          required: [
            "ActionId",
            "BudgetName",
            "NotificationType",
            "ActionType",
            "ActionThreshold",
            "Definition",
            "ExecutionRoleArn",
            "ApprovalModel",
            "Status",
            "Subscribers"
          ],
          members: {
            ActionId: {},
            BudgetName: {},
            NotificationType: {},
            ActionType: {},
            ActionThreshold: {
              shape: "S13"
            },
            Definition: {
              shape: "S14"
            },
            ExecutionRoleArn: {},
            ApprovalModel: {},
            Status: {},
            Subscribers: {
              shape: "Sw"
            }
          }
        },
        S2h: {
          type: "list",
          member: {
            shape: "S1y"
          }
        },
        S2p: {
          type: "list",
          member: {
            shape: "Sq"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/budgets-2016-10-20.paginators.json
var require_budgets_2016_10_20_paginators = __commonJS({
  "node_modules/aws-sdk/apis/budgets-2016-10-20.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeBudgetActionHistories: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ActionHistories"
        },
        DescribeBudgetActionsForAccount: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Actions"
        },
        DescribeBudgetActionsForBudget: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Actions"
        },
        DescribeBudgetNotificationsForAccount: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "BudgetNotificationsForAccount"
        },
        DescribeBudgetPerformanceHistory: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "BudgetPerformanceHistory"
        },
        DescribeBudgets: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Budgets"
        },
        DescribeNotificationsForBudget: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Notifications"
        },
        DescribeSubscribersForNotification: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Subscribers"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/budgets.js
var require_budgets = __commonJS({
  "node_modules/aws-sdk/clients/budgets.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["budgets"] = {};
    AWS2.Budgets = Service.defineService("budgets", ["2016-10-20"]);
    Object.defineProperty(apiLoader.services["budgets"], "2016-10-20", {
      get: function get() {
        var model = require_budgets_2016_10_20_min();
        model.paginators = require_budgets_2016_10_20_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Budgets;
  }
});

// node_modules/aws-sdk/apis/clouddirectory-2016-05-10.min.json
var require_clouddirectory_2016_05_10_min = __commonJS({
  "node_modules/aws-sdk/apis/clouddirectory-2016-05-10.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-05-10",
        endpointPrefix: "clouddirectory",
        protocol: "rest-json",
        serviceFullName: "Amazon CloudDirectory",
        serviceId: "CloudDirectory",
        signatureVersion: "v4",
        signingName: "clouddirectory",
        uid: "clouddirectory-2016-05-10"
      },
      operations: {
        AddFacetToObject: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/object/facets",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "SchemaFacet",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              SchemaFacet: {
                shape: "S3"
              },
              ObjectAttributeList: {
                shape: "S5"
              },
              ObjectReference: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ApplySchema: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema/apply",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "PublishedSchemaArn",
              "DirectoryArn"
            ],
            members: {
              PublishedSchemaArn: {},
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppliedSchemaArn: {},
              DirectoryArn: {}
            }
          }
        },
        AttachObject: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/object/attach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ParentReference",
              "ChildReference",
              "LinkName"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ParentReference: {
                shape: "Sf"
              },
              ChildReference: {
                shape: "Sf"
              },
              LinkName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AttachedObjectIdentifier: {}
            }
          }
        },
        AttachPolicy: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/policy/attach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "PolicyReference",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              PolicyReference: {
                shape: "Sf"
              },
              ObjectReference: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AttachToIndex: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/index/attach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "IndexReference",
              "TargetReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              IndexReference: {
                shape: "Sf"
              },
              TargetReference: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AttachedObjectIdentifier: {}
            }
          }
        },
        AttachTypedLink: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/attach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "SourceObjectReference",
              "TargetObjectReference",
              "TypedLinkFacet",
              "Attributes"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              SourceObjectReference: {
                shape: "Sf"
              },
              TargetObjectReference: {
                shape: "Sf"
              },
              TypedLinkFacet: {
                shape: "St"
              },
              Attributes: {
                shape: "Sv"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TypedLinkSpecifier: {
                shape: "Sy"
              }
            }
          }
        },
        BatchRead: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/batchread",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "Operations"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Operations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ListObjectAttributes: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        },
                        FacetFilter: {
                          shape: "S3"
                        }
                      }
                    },
                    ListObjectChildren: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    ListAttachedIndices: {
                      type: "structure",
                      required: [
                        "TargetReference"
                      ],
                      members: {
                        TargetReference: {
                          shape: "Sf"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    ListObjectParentPaths: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    GetObjectInformation: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    GetObjectAttributes: {
                      type: "structure",
                      required: [
                        "ObjectReference",
                        "SchemaFacet",
                        "AttributeNames"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        SchemaFacet: {
                          shape: "S3"
                        },
                        AttributeNames: {
                          shape: "S1a"
                        }
                      }
                    },
                    ListObjectPolicies: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    ListPolicyAttachments: {
                      type: "structure",
                      required: [
                        "PolicyReference"
                      ],
                      members: {
                        PolicyReference: {
                          shape: "Sf"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    LookupPolicy: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    ListIndex: {
                      type: "structure",
                      required: [
                        "IndexReference"
                      ],
                      members: {
                        RangesOnIndexedValues: {
                          shape: "S1f"
                        },
                        IndexReference: {
                          shape: "Sf"
                        },
                        MaxResults: {
                          type: "integer"
                        },
                        NextToken: {}
                      }
                    },
                    ListOutgoingTypedLinks: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        FilterAttributeRanges: {
                          shape: "S1k"
                        },
                        FilterTypedLink: {
                          shape: "St"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    ListIncomingTypedLinks: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        FilterAttributeRanges: {
                          shape: "S1k"
                        },
                        FilterTypedLink: {
                          shape: "St"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    GetLinkAttributes: {
                      type: "structure",
                      required: [
                        "TypedLinkSpecifier",
                        "AttributeNames"
                      ],
                      members: {
                        TypedLinkSpecifier: {
                          shape: "Sy"
                        },
                        AttributeNames: {
                          shape: "S1a"
                        }
                      }
                    }
                  }
                }
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Responses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SuccessfulResponse: {
                      type: "structure",
                      members: {
                        ListObjectAttributes: {
                          type: "structure",
                          members: {
                            Attributes: {
                              shape: "S5"
                            },
                            NextToken: {}
                          }
                        },
                        ListObjectChildren: {
                          type: "structure",
                          members: {
                            Children: {
                              shape: "S1v"
                            },
                            NextToken: {}
                          }
                        },
                        GetObjectInformation: {
                          type: "structure",
                          members: {
                            SchemaFacets: {
                              shape: "S1x"
                            },
                            ObjectIdentifier: {}
                          }
                        },
                        GetObjectAttributes: {
                          type: "structure",
                          members: {
                            Attributes: {
                              shape: "S5"
                            }
                          }
                        },
                        ListAttachedIndices: {
                          type: "structure",
                          members: {
                            IndexAttachments: {
                              shape: "S20"
                            },
                            NextToken: {}
                          }
                        },
                        ListObjectParentPaths: {
                          type: "structure",
                          members: {
                            PathToObjectIdentifiersList: {
                              shape: "S23"
                            },
                            NextToken: {}
                          }
                        },
                        ListObjectPolicies: {
                          type: "structure",
                          members: {
                            AttachedPolicyIds: {
                              shape: "S26"
                            },
                            NextToken: {}
                          }
                        },
                        ListPolicyAttachments: {
                          type: "structure",
                          members: {
                            ObjectIdentifiers: {
                              shape: "S26"
                            },
                            NextToken: {}
                          }
                        },
                        LookupPolicy: {
                          type: "structure",
                          members: {
                            PolicyToPathList: {
                              shape: "S2a"
                            },
                            NextToken: {}
                          }
                        },
                        ListIndex: {
                          type: "structure",
                          members: {
                            IndexAttachments: {
                              shape: "S20"
                            },
                            NextToken: {}
                          }
                        },
                        ListOutgoingTypedLinks: {
                          type: "structure",
                          members: {
                            TypedLinkSpecifiers: {
                              shape: "S2h"
                            },
                            NextToken: {}
                          }
                        },
                        ListIncomingTypedLinks: {
                          type: "structure",
                          members: {
                            LinkSpecifiers: {
                              shape: "S2h"
                            },
                            NextToken: {}
                          }
                        },
                        GetLinkAttributes: {
                          type: "structure",
                          members: {
                            Attributes: {
                              shape: "S5"
                            }
                          }
                        }
                      }
                    },
                    ExceptionResponse: {
                      type: "structure",
                      members: {
                        Type: {},
                        Message: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        BatchWrite: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/batchwrite",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "Operations"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Operations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreateObject: {
                      type: "structure",
                      required: [
                        "SchemaFacet",
                        "ObjectAttributeList"
                      ],
                      members: {
                        SchemaFacet: {
                          shape: "S1x"
                        },
                        ObjectAttributeList: {
                          shape: "S5"
                        },
                        ParentReference: {
                          shape: "Sf"
                        },
                        LinkName: {},
                        BatchReferenceName: {}
                      }
                    },
                    AttachObject: {
                      type: "structure",
                      required: [
                        "ParentReference",
                        "ChildReference",
                        "LinkName"
                      ],
                      members: {
                        ParentReference: {
                          shape: "Sf"
                        },
                        ChildReference: {
                          shape: "Sf"
                        },
                        LinkName: {}
                      }
                    },
                    DetachObject: {
                      type: "structure",
                      required: [
                        "ParentReference",
                        "LinkName"
                      ],
                      members: {
                        ParentReference: {
                          shape: "Sf"
                        },
                        LinkName: {},
                        BatchReferenceName: {}
                      }
                    },
                    UpdateObjectAttributes: {
                      type: "structure",
                      required: [
                        "ObjectReference",
                        "AttributeUpdates"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        AttributeUpdates: {
                          shape: "S2v"
                        }
                      }
                    },
                    DeleteObject: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    AddFacetToObject: {
                      type: "structure",
                      required: [
                        "SchemaFacet",
                        "ObjectAttributeList",
                        "ObjectReference"
                      ],
                      members: {
                        SchemaFacet: {
                          shape: "S3"
                        },
                        ObjectAttributeList: {
                          shape: "S5"
                        },
                        ObjectReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    RemoveFacetFromObject: {
                      type: "structure",
                      required: [
                        "SchemaFacet",
                        "ObjectReference"
                      ],
                      members: {
                        SchemaFacet: {
                          shape: "S3"
                        },
                        ObjectReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    AttachPolicy: {
                      type: "structure",
                      required: [
                        "PolicyReference",
                        "ObjectReference"
                      ],
                      members: {
                        PolicyReference: {
                          shape: "Sf"
                        },
                        ObjectReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    DetachPolicy: {
                      type: "structure",
                      required: [
                        "PolicyReference",
                        "ObjectReference"
                      ],
                      members: {
                        PolicyReference: {
                          shape: "Sf"
                        },
                        ObjectReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    CreateIndex: {
                      type: "structure",
                      required: [
                        "OrderedIndexedAttributeList",
                        "IsUnique"
                      ],
                      members: {
                        OrderedIndexedAttributeList: {
                          shape: "S35"
                        },
                        IsUnique: {
                          type: "boolean"
                        },
                        ParentReference: {
                          shape: "Sf"
                        },
                        LinkName: {},
                        BatchReferenceName: {}
                      }
                    },
                    AttachToIndex: {
                      type: "structure",
                      required: [
                        "IndexReference",
                        "TargetReference"
                      ],
                      members: {
                        IndexReference: {
                          shape: "Sf"
                        },
                        TargetReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    DetachFromIndex: {
                      type: "structure",
                      required: [
                        "IndexReference",
                        "TargetReference"
                      ],
                      members: {
                        IndexReference: {
                          shape: "Sf"
                        },
                        TargetReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    AttachTypedLink: {
                      type: "structure",
                      required: [
                        "SourceObjectReference",
                        "TargetObjectReference",
                        "TypedLinkFacet",
                        "Attributes"
                      ],
                      members: {
                        SourceObjectReference: {
                          shape: "Sf"
                        },
                        TargetObjectReference: {
                          shape: "Sf"
                        },
                        TypedLinkFacet: {
                          shape: "St"
                        },
                        Attributes: {
                          shape: "Sv"
                        }
                      }
                    },
                    DetachTypedLink: {
                      type: "structure",
                      required: [
                        "TypedLinkSpecifier"
                      ],
                      members: {
                        TypedLinkSpecifier: {
                          shape: "Sy"
                        }
                      }
                    },
                    UpdateLinkAttributes: {
                      type: "structure",
                      required: [
                        "TypedLinkSpecifier",
                        "AttributeUpdates"
                      ],
                      members: {
                        TypedLinkSpecifier: {
                          shape: "Sy"
                        },
                        AttributeUpdates: {
                          shape: "S3c"
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Responses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreateObject: {
                      type: "structure",
                      members: {
                        ObjectIdentifier: {}
                      }
                    },
                    AttachObject: {
                      type: "structure",
                      members: {
                        attachedObjectIdentifier: {}
                      }
                    },
                    DetachObject: {
                      type: "structure",
                      members: {
                        detachedObjectIdentifier: {}
                      }
                    },
                    UpdateObjectAttributes: {
                      type: "structure",
                      members: {
                        ObjectIdentifier: {}
                      }
                    },
                    DeleteObject: {
                      type: "structure",
                      members: {}
                    },
                    AddFacetToObject: {
                      type: "structure",
                      members: {}
                    },
                    RemoveFacetFromObject: {
                      type: "structure",
                      members: {}
                    },
                    AttachPolicy: {
                      type: "structure",
                      members: {}
                    },
                    DetachPolicy: {
                      type: "structure",
                      members: {}
                    },
                    CreateIndex: {
                      type: "structure",
                      members: {
                        ObjectIdentifier: {}
                      }
                    },
                    AttachToIndex: {
                      type: "structure",
                      members: {
                        AttachedObjectIdentifier: {}
                      }
                    },
                    DetachFromIndex: {
                      type: "structure",
                      members: {
                        DetachedObjectIdentifier: {}
                      }
                    },
                    AttachTypedLink: {
                      type: "structure",
                      members: {
                        TypedLinkSpecifier: {
                          shape: "Sy"
                        }
                      }
                    },
                    DetachTypedLink: {
                      type: "structure",
                      members: {}
                    },
                    UpdateLinkAttributes: {
                      type: "structure",
                      members: {}
                    }
                  }
                }
              }
            }
          }
        },
        CreateDirectory: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/directory/create",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "SchemaArn"
            ],
            members: {
              Name: {},
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DirectoryArn",
              "Name",
              "ObjectIdentifier",
              "AppliedSchemaArn"
            ],
            members: {
              DirectoryArn: {},
              Name: {},
              ObjectIdentifier: {},
              AppliedSchemaArn: {}
            }
          }
        },
        CreateFacet: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/facet/create",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name",
              "ObjectType"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {},
              Attributes: {
                shape: "S42"
              },
              ObjectType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateIndex: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/index",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "OrderedIndexedAttributeList",
              "IsUnique"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              OrderedIndexedAttributeList: {
                shape: "S35"
              },
              IsUnique: {
                type: "boolean"
              },
              ParentReference: {
                shape: "Sf"
              },
              LinkName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ObjectIdentifier: {}
            }
          }
        },
        CreateObject: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/object",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "SchemaFacets"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              SchemaFacets: {
                shape: "S1x"
              },
              ObjectAttributeList: {
                shape: "S5"
              },
              ParentReference: {
                shape: "Sf"
              },
              LinkName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ObjectIdentifier: {}
            }
          }
        },
        CreateSchema: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema/create",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArn: {}
            }
          }
        },
        CreateTypedLinkFacet: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/facet/create",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Facet"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Facet: {
                type: "structure",
                required: [
                  "Name",
                  "Attributes",
                  "IdentityAttributeOrder"
                ],
                members: {
                  Name: {},
                  Attributes: {
                    shape: "S4q"
                  },
                  IdentityAttributeOrder: {
                    shape: "S1a"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDirectory: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/directory",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {}
            }
          }
        },
        DeleteFacet: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/facet/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteObject: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/object/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSchema: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArn: {}
            }
          }
        },
        DeleteTypedLinkFacet: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/facet/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DetachFromIndex: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/index/detach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "IndexReference",
              "TargetReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              IndexReference: {
                shape: "Sf"
              },
              TargetReference: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DetachedObjectIdentifier: {}
            }
          }
        },
        DetachObject: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/object/detach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ParentReference",
              "LinkName"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ParentReference: {
                shape: "Sf"
              },
              LinkName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DetachedObjectIdentifier: {}
            }
          }
        },
        DetachPolicy: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/policy/detach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "PolicyReference",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              PolicyReference: {
                shape: "Sf"
              },
              ObjectReference: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DetachTypedLink: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/detach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "TypedLinkSpecifier"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              TypedLinkSpecifier: {
                shape: "Sy"
              }
            }
          }
        },
        DisableDirectory: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/directory/disable",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {}
            }
          }
        },
        EnableDirectory: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/directory/enable",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {}
            }
          }
        },
        GetAppliedSchemaVersion: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/schema/getappliedschema",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn"
            ],
            members: {
              SchemaArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AppliedSchemaArn: {}
            }
          }
        },
        GetDirectory: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/directory/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Directory"
            ],
            members: {
              Directory: {
                shape: "S5i"
              }
            }
          }
        },
        GetFacet: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/facet",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Facet: {
                type: "structure",
                members: {
                  Name: {},
                  ObjectType: {}
                }
              }
            }
          }
        },
        GetLinkAttributes: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/attributes/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "TypedLinkSpecifier",
              "AttributeNames"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              TypedLinkSpecifier: {
                shape: "Sy"
              },
              AttributeNames: {
                shape: "S1a"
              },
              ConsistencyLevel: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "S5"
              }
            }
          }
        },
        GetObjectAttributes: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/attributes/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference",
              "SchemaFacet",
              "AttributeNames"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              },
              SchemaFacet: {
                shape: "S3"
              },
              AttributeNames: {
                shape: "S1a"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "S5"
              }
            }
          }
        },
        GetObjectInformation: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/information",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaFacets: {
                shape: "S1x"
              },
              ObjectIdentifier: {}
            }
          }
        },
        GetSchemaAsJson: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/schema/json",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Document: {}
            }
          }
        },
        GetTypedLinkFacetInformation: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/facet/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityAttributeOrder: {
                shape: "S1a"
              }
            }
          }
        },
        ListAppliedSchemaArns: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/schema/applied",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {},
              SchemaArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArns: {
                shape: "S61"
              },
              NextToken: {}
            }
          }
        },
        ListAttachedIndices: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/indices",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "TargetReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              TargetReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IndexAttachments: {
                shape: "S20"
              },
              NextToken: {}
            }
          }
        },
        ListDevelopmentSchemaArns: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/schema/development",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArns: {
                shape: "S61"
              },
              NextToken: {}
            }
          }
        },
        ListDirectories: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/directory/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              state: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Directories"
            ],
            members: {
              Directories: {
                type: "list",
                member: {
                  shape: "S5i"
                }
              },
              NextToken: {}
            }
          }
        },
        ListFacetAttributes: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/facet/attributes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "S42"
              },
              NextToken: {}
            }
          }
        },
        ListFacetNames: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/facet/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FacetNames: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListIncomingTypedLinks: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/incoming",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              FilterAttributeRanges: {
                shape: "S1k"
              },
              FilterTypedLink: {
                shape: "St"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LinkSpecifiers: {
                shape: "S2h"
              },
              NextToken: {}
            }
          }
        },
        ListIndex: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/index/targets",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "IndexReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              RangesOnIndexedValues: {
                shape: "S1f"
              },
              IndexReference: {
                shape: "Sf"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IndexAttachments: {
                shape: "S20"
              },
              NextToken: {}
            }
          }
        },
        ListObjectAttributes: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/attributes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              },
              FacetFilter: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "S5"
              },
              NextToken: {}
            }
          }
        },
        ListObjectChildren: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/children",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Children: {
                shape: "S1v"
              },
              NextToken: {}
            }
          }
        },
        ListObjectParentPaths: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/parentpaths",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PathToObjectIdentifiersList: {
                shape: "S23"
              },
              NextToken: {}
            }
          }
        },
        ListObjectParents: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/parent",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Parents: {
                type: "map",
                key: {},
                value: {}
              },
              NextToken: {}
            }
          }
        },
        ListObjectPolicies: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AttachedPolicyIds: {
                shape: "S26"
              },
              NextToken: {}
            }
          }
        },
        ListOutgoingTypedLinks: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/outgoing",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              FilterAttributeRanges: {
                shape: "S1k"
              },
              FilterTypedLink: {
                shape: "St"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TypedLinkSpecifiers: {
                shape: "S2h"
              },
              NextToken: {}
            }
          }
        },
        ListPolicyAttachments: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/policy/attachment",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "PolicyReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              PolicyReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ObjectIdentifiers: {
                shape: "S26"
              },
              NextToken: {}
            }
          }
        },
        ListPublishedSchemaArns: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/schema/published",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              SchemaArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArns: {
                shape: "S61"
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/tags",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S72"
              },
              NextToken: {}
            }
          }
        },
        ListTypedLinkFacetAttributes: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/facet/attributes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "S4q"
              },
              NextToken: {}
            }
          }
        },
        ListTypedLinkFacetNames: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/facet/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FacetNames: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        LookupPolicy: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/policy/lookup",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyToPathList: {
                shape: "S2a"
              },
              NextToken: {}
            }
          }
        },
        PublishSchema: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema/publish",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DevelopmentSchemaArn",
              "Version"
            ],
            members: {
              DevelopmentSchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Version: {},
              MinorVersion: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PublishedSchemaArn: {}
            }
          }
        },
        PutSchemaFromJson: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema/json",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Document"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Document: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {}
            }
          }
        },
        RemoveFacetFromObject: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/object/facets/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "SchemaFacet",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              SchemaFacet: {
                shape: "S3"
              },
              ObjectReference: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/tags/add",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S72"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/tags/remove",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateFacet: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/facet",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {},
              AttributeUpdates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Attribute: {
                      shape: "S43"
                    },
                    Action: {}
                  }
                }
              },
              ObjectType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateLinkAttributes: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/attributes/update",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "TypedLinkSpecifier",
              "AttributeUpdates"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              TypedLinkSpecifier: {
                shape: "Sy"
              },
              AttributeUpdates: {
                shape: "S3c"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateObjectAttributes: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/object/update",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference",
              "AttributeUpdates"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              AttributeUpdates: {
                shape: "S2v"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ObjectIdentifier: {}
            }
          }
        },
        UpdateSchema: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema/update",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArn: {}
            }
          }
        },
        UpdateTypedLinkFacet: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/facet",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name",
              "AttributeUpdates",
              "IdentityAttributeOrder"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {},
              AttributeUpdates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Attribute",
                    "Action"
                  ],
                  members: {
                    Attribute: {
                      shape: "S4r"
                    },
                    Action: {}
                  }
                }
              },
              IdentityAttributeOrder: {
                shape: "S1a"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpgradeAppliedSchema: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema/upgradeapplied",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "PublishedSchemaArn",
              "DirectoryArn"
            ],
            members: {
              PublishedSchemaArn: {},
              DirectoryArn: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UpgradedSchemaArn: {},
              DirectoryArn: {}
            }
          }
        },
        UpgradePublishedSchema: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema/upgradepublished",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DevelopmentSchemaArn",
              "PublishedSchemaArn",
              "MinorVersion"
            ],
            members: {
              DevelopmentSchemaArn: {},
              PublishedSchemaArn: {},
              MinorVersion: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UpgradedSchemaArn: {}
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          members: {
            SchemaArn: {},
            FacetName: {}
          }
        },
        S5: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {
                shape: "S7"
              },
              Value: {
                shape: "S9"
              }
            }
          }
        },
        S7: {
          type: "structure",
          required: [
            "SchemaArn",
            "FacetName",
            "Name"
          ],
          members: {
            SchemaArn: {},
            FacetName: {},
            Name: {}
          }
        },
        S9: {
          type: "structure",
          members: {
            StringValue: {},
            BinaryValue: {
              type: "blob"
            },
            BooleanValue: {
              type: "boolean"
            },
            NumberValue: {},
            DatetimeValue: {
              type: "timestamp"
            }
          }
        },
        Sf: {
          type: "structure",
          members: {
            Selector: {}
          }
        },
        St: {
          type: "structure",
          required: [
            "SchemaArn",
            "TypedLinkName"
          ],
          members: {
            SchemaArn: {},
            TypedLinkName: {}
          }
        },
        Sv: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AttributeName",
              "Value"
            ],
            members: {
              AttributeName: {},
              Value: {
                shape: "S9"
              }
            }
          }
        },
        Sy: {
          type: "structure",
          required: [
            "TypedLinkFacet",
            "SourceObjectReference",
            "TargetObjectReference",
            "IdentityAttributeValues"
          ],
          members: {
            TypedLinkFacet: {
              shape: "St"
            },
            SourceObjectReference: {
              shape: "Sf"
            },
            TargetObjectReference: {
              shape: "Sf"
            },
            IdentityAttributeValues: {
              shape: "Sv"
            }
          }
        },
        S1a: {
          type: "list",
          member: {}
        },
        S1f: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AttributeKey: {
                shape: "S7"
              },
              Range: {
                shape: "S1h"
              }
            }
          }
        },
        S1h: {
          type: "structure",
          required: [
            "StartMode",
            "EndMode"
          ],
          members: {
            StartMode: {},
            StartValue: {
              shape: "S9"
            },
            EndMode: {},
            EndValue: {
              shape: "S9"
            }
          }
        },
        S1k: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Range"
            ],
            members: {
              AttributeName: {},
              Range: {
                shape: "S1h"
              }
            }
          }
        },
        S1v: {
          type: "map",
          key: {},
          value: {}
        },
        S1x: {
          type: "list",
          member: {
            shape: "S3"
          }
        },
        S20: {
          type: "list",
          member: {
            type: "structure",
            members: {
              IndexedAttributes: {
                shape: "S5"
              },
              ObjectIdentifier: {}
            }
          }
        },
        S23: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Path: {},
              ObjectIdentifiers: {
                shape: "S26"
              }
            }
          }
        },
        S26: {
          type: "list",
          member: {}
        },
        S2a: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Path: {},
              Policies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PolicyId: {},
                    ObjectIdentifier: {},
                    PolicyType: {}
                  }
                }
              }
            }
          }
        },
        S2h: {
          type: "list",
          member: {
            shape: "Sy"
          }
        },
        S2v: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ObjectAttributeKey: {
                shape: "S7"
              },
              ObjectAttributeAction: {
                type: "structure",
                members: {
                  ObjectAttributeActionType: {},
                  ObjectAttributeUpdateValue: {
                    shape: "S9"
                  }
                }
              }
            }
          }
        },
        S35: {
          type: "list",
          member: {
            shape: "S7"
          }
        },
        S3c: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AttributeKey: {
                shape: "S7"
              },
              AttributeAction: {
                type: "structure",
                members: {
                  AttributeActionType: {},
                  AttributeUpdateValue: {
                    shape: "S9"
                  }
                }
              }
            }
          }
        },
        S42: {
          type: "list",
          member: {
            shape: "S43"
          }
        },
        S43: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            AttributeDefinition: {
              type: "structure",
              required: [
                "Type"
              ],
              members: {
                Type: {},
                DefaultValue: {
                  shape: "S9"
                },
                IsImmutable: {
                  type: "boolean"
                },
                Rules: {
                  shape: "S46"
                }
              }
            },
            AttributeReference: {
              type: "structure",
              required: [
                "TargetFacetName",
                "TargetAttributeName"
              ],
              members: {
                TargetFacetName: {},
                TargetAttributeName: {}
              }
            },
            RequiredBehavior: {}
          }
        },
        S46: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              Type: {},
              Parameters: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        S4q: {
          type: "list",
          member: {
            shape: "S4r"
          }
        },
        S4r: {
          type: "structure",
          required: [
            "Name",
            "Type",
            "RequiredBehavior"
          ],
          members: {
            Name: {},
            Type: {},
            DefaultValue: {
              shape: "S9"
            },
            IsImmutable: {
              type: "boolean"
            },
            Rules: {
              shape: "S46"
            },
            RequiredBehavior: {}
          }
        },
        S5i: {
          type: "structure",
          members: {
            Name: {},
            DirectoryArn: {},
            State: {},
            CreationDateTime: {
              type: "timestamp"
            }
          }
        },
        S61: {
          type: "list",
          member: {}
        },
        S72: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/clouddirectory-2016-05-10.paginators.json
var require_clouddirectory_2016_05_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/clouddirectory-2016-05-10.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAppliedSchemaArns: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAttachedIndices: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDevelopmentSchemaArns: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDirectories: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListFacetAttributes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListFacetNames: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListIndex: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListObjectAttributes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListObjectChildren: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListObjectParentPaths: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListObjectParents: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListObjectPolicies: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListPolicyAttachments: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListPublishedSchemaArns: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListTagsForResource: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListTypedLinkFacetAttributes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListTypedLinkFacetNames: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        LookupPolicy: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/clouddirectory-2017-01-11.min.json
var require_clouddirectory_2017_01_11_min = __commonJS({
  "node_modules/aws-sdk/apis/clouddirectory-2017-01-11.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-01-11",
        endpointPrefix: "clouddirectory",
        protocol: "rest-json",
        serviceFullName: "Amazon CloudDirectory",
        serviceId: "CloudDirectory",
        signatureVersion: "v4",
        signingName: "clouddirectory",
        uid: "clouddirectory-2017-01-11"
      },
      operations: {
        AddFacetToObject: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/object/facets",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "SchemaFacet",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              SchemaFacet: {
                shape: "S3"
              },
              ObjectAttributeList: {
                shape: "S5"
              },
              ObjectReference: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ApplySchema: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema/apply",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "PublishedSchemaArn",
              "DirectoryArn"
            ],
            members: {
              PublishedSchemaArn: {},
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppliedSchemaArn: {},
              DirectoryArn: {}
            }
          }
        },
        AttachObject: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/object/attach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ParentReference",
              "ChildReference",
              "LinkName"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ParentReference: {
                shape: "Sf"
              },
              ChildReference: {
                shape: "Sf"
              },
              LinkName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AttachedObjectIdentifier: {}
            }
          }
        },
        AttachPolicy: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/policy/attach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "PolicyReference",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              PolicyReference: {
                shape: "Sf"
              },
              ObjectReference: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AttachToIndex: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/index/attach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "IndexReference",
              "TargetReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              IndexReference: {
                shape: "Sf"
              },
              TargetReference: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AttachedObjectIdentifier: {}
            }
          }
        },
        AttachTypedLink: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/attach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "SourceObjectReference",
              "TargetObjectReference",
              "TypedLinkFacet",
              "Attributes"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              SourceObjectReference: {
                shape: "Sf"
              },
              TargetObjectReference: {
                shape: "Sf"
              },
              TypedLinkFacet: {
                shape: "St"
              },
              Attributes: {
                shape: "Sv"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TypedLinkSpecifier: {
                shape: "Sy"
              }
            }
          }
        },
        BatchRead: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/batchread",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "Operations"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Operations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ListObjectAttributes: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        },
                        FacetFilter: {
                          shape: "S3"
                        }
                      }
                    },
                    ListObjectChildren: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    ListAttachedIndices: {
                      type: "structure",
                      required: [
                        "TargetReference"
                      ],
                      members: {
                        TargetReference: {
                          shape: "Sf"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    ListObjectParentPaths: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    GetObjectInformation: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    GetObjectAttributes: {
                      type: "structure",
                      required: [
                        "ObjectReference",
                        "SchemaFacet",
                        "AttributeNames"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        SchemaFacet: {
                          shape: "S3"
                        },
                        AttributeNames: {
                          shape: "S1a"
                        }
                      }
                    },
                    ListObjectParents: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    ListObjectPolicies: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    ListPolicyAttachments: {
                      type: "structure",
                      required: [
                        "PolicyReference"
                      ],
                      members: {
                        PolicyReference: {
                          shape: "Sf"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    LookupPolicy: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    ListIndex: {
                      type: "structure",
                      required: [
                        "IndexReference"
                      ],
                      members: {
                        RangesOnIndexedValues: {
                          shape: "S1g"
                        },
                        IndexReference: {
                          shape: "Sf"
                        },
                        MaxResults: {
                          type: "integer"
                        },
                        NextToken: {}
                      }
                    },
                    ListOutgoingTypedLinks: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        FilterAttributeRanges: {
                          shape: "S1l"
                        },
                        FilterTypedLink: {
                          shape: "St"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    ListIncomingTypedLinks: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        FilterAttributeRanges: {
                          shape: "S1l"
                        },
                        FilterTypedLink: {
                          shape: "St"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    GetLinkAttributes: {
                      type: "structure",
                      required: [
                        "TypedLinkSpecifier",
                        "AttributeNames"
                      ],
                      members: {
                        TypedLinkSpecifier: {
                          shape: "Sy"
                        },
                        AttributeNames: {
                          shape: "S1a"
                        }
                      }
                    }
                  }
                }
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Responses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SuccessfulResponse: {
                      type: "structure",
                      members: {
                        ListObjectAttributes: {
                          type: "structure",
                          members: {
                            Attributes: {
                              shape: "S5"
                            },
                            NextToken: {}
                          }
                        },
                        ListObjectChildren: {
                          type: "structure",
                          members: {
                            Children: {
                              shape: "S1w"
                            },
                            NextToken: {}
                          }
                        },
                        GetObjectInformation: {
                          type: "structure",
                          members: {
                            SchemaFacets: {
                              shape: "S1y"
                            },
                            ObjectIdentifier: {}
                          }
                        },
                        GetObjectAttributes: {
                          type: "structure",
                          members: {
                            Attributes: {
                              shape: "S5"
                            }
                          }
                        },
                        ListAttachedIndices: {
                          type: "structure",
                          members: {
                            IndexAttachments: {
                              shape: "S21"
                            },
                            NextToken: {}
                          }
                        },
                        ListObjectParentPaths: {
                          type: "structure",
                          members: {
                            PathToObjectIdentifiersList: {
                              shape: "S24"
                            },
                            NextToken: {}
                          }
                        },
                        ListObjectPolicies: {
                          type: "structure",
                          members: {
                            AttachedPolicyIds: {
                              shape: "S27"
                            },
                            NextToken: {}
                          }
                        },
                        ListPolicyAttachments: {
                          type: "structure",
                          members: {
                            ObjectIdentifiers: {
                              shape: "S27"
                            },
                            NextToken: {}
                          }
                        },
                        LookupPolicy: {
                          type: "structure",
                          members: {
                            PolicyToPathList: {
                              shape: "S2b"
                            },
                            NextToken: {}
                          }
                        },
                        ListIndex: {
                          type: "structure",
                          members: {
                            IndexAttachments: {
                              shape: "S21"
                            },
                            NextToken: {}
                          }
                        },
                        ListOutgoingTypedLinks: {
                          type: "structure",
                          members: {
                            TypedLinkSpecifiers: {
                              shape: "S2i"
                            },
                            NextToken: {}
                          }
                        },
                        ListIncomingTypedLinks: {
                          type: "structure",
                          members: {
                            LinkSpecifiers: {
                              shape: "S2i"
                            },
                            NextToken: {}
                          }
                        },
                        GetLinkAttributes: {
                          type: "structure",
                          members: {
                            Attributes: {
                              shape: "S5"
                            }
                          }
                        },
                        ListObjectParents: {
                          type: "structure",
                          members: {
                            ParentLinks: {
                              shape: "S2m"
                            },
                            NextToken: {}
                          }
                        }
                      }
                    },
                    ExceptionResponse: {
                      type: "structure",
                      members: {
                        Type: {},
                        Message: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        BatchWrite: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/batchwrite",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "Operations"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Operations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreateObject: {
                      type: "structure",
                      required: [
                        "SchemaFacet",
                        "ObjectAttributeList"
                      ],
                      members: {
                        SchemaFacet: {
                          shape: "S1y"
                        },
                        ObjectAttributeList: {
                          shape: "S5"
                        },
                        ParentReference: {
                          shape: "Sf"
                        },
                        LinkName: {},
                        BatchReferenceName: {}
                      }
                    },
                    AttachObject: {
                      type: "structure",
                      required: [
                        "ParentReference",
                        "ChildReference",
                        "LinkName"
                      ],
                      members: {
                        ParentReference: {
                          shape: "Sf"
                        },
                        ChildReference: {
                          shape: "Sf"
                        },
                        LinkName: {}
                      }
                    },
                    DetachObject: {
                      type: "structure",
                      required: [
                        "ParentReference",
                        "LinkName"
                      ],
                      members: {
                        ParentReference: {
                          shape: "Sf"
                        },
                        LinkName: {},
                        BatchReferenceName: {}
                      }
                    },
                    UpdateObjectAttributes: {
                      type: "structure",
                      required: [
                        "ObjectReference",
                        "AttributeUpdates"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        AttributeUpdates: {
                          shape: "S2z"
                        }
                      }
                    },
                    DeleteObject: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    AddFacetToObject: {
                      type: "structure",
                      required: [
                        "SchemaFacet",
                        "ObjectAttributeList",
                        "ObjectReference"
                      ],
                      members: {
                        SchemaFacet: {
                          shape: "S3"
                        },
                        ObjectAttributeList: {
                          shape: "S5"
                        },
                        ObjectReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    RemoveFacetFromObject: {
                      type: "structure",
                      required: [
                        "SchemaFacet",
                        "ObjectReference"
                      ],
                      members: {
                        SchemaFacet: {
                          shape: "S3"
                        },
                        ObjectReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    AttachPolicy: {
                      type: "structure",
                      required: [
                        "PolicyReference",
                        "ObjectReference"
                      ],
                      members: {
                        PolicyReference: {
                          shape: "Sf"
                        },
                        ObjectReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    DetachPolicy: {
                      type: "structure",
                      required: [
                        "PolicyReference",
                        "ObjectReference"
                      ],
                      members: {
                        PolicyReference: {
                          shape: "Sf"
                        },
                        ObjectReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    CreateIndex: {
                      type: "structure",
                      required: [
                        "OrderedIndexedAttributeList",
                        "IsUnique"
                      ],
                      members: {
                        OrderedIndexedAttributeList: {
                          shape: "S39"
                        },
                        IsUnique: {
                          type: "boolean"
                        },
                        ParentReference: {
                          shape: "Sf"
                        },
                        LinkName: {},
                        BatchReferenceName: {}
                      }
                    },
                    AttachToIndex: {
                      type: "structure",
                      required: [
                        "IndexReference",
                        "TargetReference"
                      ],
                      members: {
                        IndexReference: {
                          shape: "Sf"
                        },
                        TargetReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    DetachFromIndex: {
                      type: "structure",
                      required: [
                        "IndexReference",
                        "TargetReference"
                      ],
                      members: {
                        IndexReference: {
                          shape: "Sf"
                        },
                        TargetReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    AttachTypedLink: {
                      type: "structure",
                      required: [
                        "SourceObjectReference",
                        "TargetObjectReference",
                        "TypedLinkFacet",
                        "Attributes"
                      ],
                      members: {
                        SourceObjectReference: {
                          shape: "Sf"
                        },
                        TargetObjectReference: {
                          shape: "Sf"
                        },
                        TypedLinkFacet: {
                          shape: "St"
                        },
                        Attributes: {
                          shape: "Sv"
                        }
                      }
                    },
                    DetachTypedLink: {
                      type: "structure",
                      required: [
                        "TypedLinkSpecifier"
                      ],
                      members: {
                        TypedLinkSpecifier: {
                          shape: "Sy"
                        }
                      }
                    },
                    UpdateLinkAttributes: {
                      type: "structure",
                      required: [
                        "TypedLinkSpecifier",
                        "AttributeUpdates"
                      ],
                      members: {
                        TypedLinkSpecifier: {
                          shape: "Sy"
                        },
                        AttributeUpdates: {
                          shape: "S3g"
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Responses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreateObject: {
                      type: "structure",
                      members: {
                        ObjectIdentifier: {}
                      }
                    },
                    AttachObject: {
                      type: "structure",
                      members: {
                        attachedObjectIdentifier: {}
                      }
                    },
                    DetachObject: {
                      type: "structure",
                      members: {
                        detachedObjectIdentifier: {}
                      }
                    },
                    UpdateObjectAttributes: {
                      type: "structure",
                      members: {
                        ObjectIdentifier: {}
                      }
                    },
                    DeleteObject: {
                      type: "structure",
                      members: {}
                    },
                    AddFacetToObject: {
                      type: "structure",
                      members: {}
                    },
                    RemoveFacetFromObject: {
                      type: "structure",
                      members: {}
                    },
                    AttachPolicy: {
                      type: "structure",
                      members: {}
                    },
                    DetachPolicy: {
                      type: "structure",
                      members: {}
                    },
                    CreateIndex: {
                      type: "structure",
                      members: {
                        ObjectIdentifier: {}
                      }
                    },
                    AttachToIndex: {
                      type: "structure",
                      members: {
                        AttachedObjectIdentifier: {}
                      }
                    },
                    DetachFromIndex: {
                      type: "structure",
                      members: {
                        DetachedObjectIdentifier: {}
                      }
                    },
                    AttachTypedLink: {
                      type: "structure",
                      members: {
                        TypedLinkSpecifier: {
                          shape: "Sy"
                        }
                      }
                    },
                    DetachTypedLink: {
                      type: "structure",
                      members: {}
                    },
                    UpdateLinkAttributes: {
                      type: "structure",
                      members: {}
                    }
                  }
                }
              }
            }
          }
        },
        CreateDirectory: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/directory/create",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "SchemaArn"
            ],
            members: {
              Name: {},
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DirectoryArn",
              "Name",
              "ObjectIdentifier",
              "AppliedSchemaArn"
            ],
            members: {
              DirectoryArn: {},
              Name: {},
              ObjectIdentifier: {},
              AppliedSchemaArn: {}
            }
          }
        },
        CreateFacet: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/facet/create",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {},
              Attributes: {
                shape: "S46"
              },
              ObjectType: {},
              FacetStyle: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateIndex: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/index",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "OrderedIndexedAttributeList",
              "IsUnique"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              OrderedIndexedAttributeList: {
                shape: "S39"
              },
              IsUnique: {
                type: "boolean"
              },
              ParentReference: {
                shape: "Sf"
              },
              LinkName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ObjectIdentifier: {}
            }
          }
        },
        CreateObject: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/object",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "SchemaFacets"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              SchemaFacets: {
                shape: "S1y"
              },
              ObjectAttributeList: {
                shape: "S5"
              },
              ParentReference: {
                shape: "Sf"
              },
              LinkName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ObjectIdentifier: {}
            }
          }
        },
        CreateSchema: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema/create",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArn: {}
            }
          }
        },
        CreateTypedLinkFacet: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/facet/create",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Facet"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Facet: {
                type: "structure",
                required: [
                  "Name",
                  "Attributes",
                  "IdentityAttributeOrder"
                ],
                members: {
                  Name: {},
                  Attributes: {
                    shape: "S4v"
                  },
                  IdentityAttributeOrder: {
                    shape: "S1a"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDirectory: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/directory",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {}
            }
          }
        },
        DeleteFacet: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/facet/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteObject: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/object/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSchema: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArn: {}
            }
          }
        },
        DeleteTypedLinkFacet: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/facet/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DetachFromIndex: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/index/detach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "IndexReference",
              "TargetReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              IndexReference: {
                shape: "Sf"
              },
              TargetReference: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DetachedObjectIdentifier: {}
            }
          }
        },
        DetachObject: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/object/detach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ParentReference",
              "LinkName"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ParentReference: {
                shape: "Sf"
              },
              LinkName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DetachedObjectIdentifier: {}
            }
          }
        },
        DetachPolicy: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/policy/detach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "PolicyReference",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              PolicyReference: {
                shape: "Sf"
              },
              ObjectReference: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DetachTypedLink: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/detach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "TypedLinkSpecifier"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              TypedLinkSpecifier: {
                shape: "Sy"
              }
            }
          }
        },
        DisableDirectory: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/directory/disable",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {}
            }
          }
        },
        EnableDirectory: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/directory/enable",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {}
            }
          }
        },
        GetAppliedSchemaVersion: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/schema/getappliedschema",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn"
            ],
            members: {
              SchemaArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AppliedSchemaArn: {}
            }
          }
        },
        GetDirectory: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/directory/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Directory"
            ],
            members: {
              Directory: {
                shape: "S5n"
              }
            }
          }
        },
        GetFacet: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/facet",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Facet: {
                type: "structure",
                members: {
                  Name: {},
                  ObjectType: {},
                  FacetStyle: {}
                }
              }
            }
          }
        },
        GetLinkAttributes: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/attributes/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "TypedLinkSpecifier",
              "AttributeNames"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              TypedLinkSpecifier: {
                shape: "Sy"
              },
              AttributeNames: {
                shape: "S1a"
              },
              ConsistencyLevel: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "S5"
              }
            }
          }
        },
        GetObjectAttributes: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/attributes/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference",
              "SchemaFacet",
              "AttributeNames"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              },
              SchemaFacet: {
                shape: "S3"
              },
              AttributeNames: {
                shape: "S1a"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "S5"
              }
            }
          }
        },
        GetObjectInformation: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/information",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaFacets: {
                shape: "S1y"
              },
              ObjectIdentifier: {}
            }
          }
        },
        GetSchemaAsJson: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/schema/json",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Document: {}
            }
          }
        },
        GetTypedLinkFacetInformation: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/facet/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityAttributeOrder: {
                shape: "S1a"
              }
            }
          }
        },
        ListAppliedSchemaArns: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/schema/applied",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {},
              SchemaArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArns: {
                shape: "S66"
              },
              NextToken: {}
            }
          }
        },
        ListAttachedIndices: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/indices",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "TargetReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              TargetReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IndexAttachments: {
                shape: "S21"
              },
              NextToken: {}
            }
          }
        },
        ListDevelopmentSchemaArns: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/schema/development",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArns: {
                shape: "S66"
              },
              NextToken: {}
            }
          }
        },
        ListDirectories: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/directory/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              state: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Directories"
            ],
            members: {
              Directories: {
                type: "list",
                member: {
                  shape: "S5n"
                }
              },
              NextToken: {}
            }
          }
        },
        ListFacetAttributes: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/facet/attributes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "S46"
              },
              NextToken: {}
            }
          }
        },
        ListFacetNames: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/facet/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FacetNames: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListIncomingTypedLinks: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/incoming",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              FilterAttributeRanges: {
                shape: "S1l"
              },
              FilterTypedLink: {
                shape: "St"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LinkSpecifiers: {
                shape: "S2i"
              },
              NextToken: {}
            }
          }
        },
        ListIndex: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/index/targets",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "IndexReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              RangesOnIndexedValues: {
                shape: "S1g"
              },
              IndexReference: {
                shape: "Sf"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IndexAttachments: {
                shape: "S21"
              },
              NextToken: {}
            }
          }
        },
        ListManagedSchemaArns: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/schema/managed",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              SchemaArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArns: {
                shape: "S66"
              },
              NextToken: {}
            }
          }
        },
        ListObjectAttributes: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/attributes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              },
              FacetFilter: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "S5"
              },
              NextToken: {}
            }
          }
        },
        ListObjectChildren: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/children",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Children: {
                shape: "S1w"
              },
              NextToken: {}
            }
          }
        },
        ListObjectParentPaths: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/parentpaths",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PathToObjectIdentifiersList: {
                shape: "S24"
              },
              NextToken: {}
            }
          }
        },
        ListObjectParents: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/parent",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              },
              IncludeAllLinksToEachParent: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Parents: {
                type: "map",
                key: {},
                value: {}
              },
              NextToken: {},
              ParentLinks: {
                shape: "S2m"
              }
            }
          }
        },
        ListObjectPolicies: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AttachedPolicyIds: {
                shape: "S27"
              },
              NextToken: {}
            }
          }
        },
        ListOutgoingTypedLinks: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/outgoing",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              FilterAttributeRanges: {
                shape: "S1l"
              },
              FilterTypedLink: {
                shape: "St"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TypedLinkSpecifiers: {
                shape: "S2i"
              },
              NextToken: {}
            }
          }
        },
        ListPolicyAttachments: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/policy/attachment",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "PolicyReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              PolicyReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ObjectIdentifiers: {
                shape: "S27"
              },
              NextToken: {}
            }
          }
        },
        ListPublishedSchemaArns: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/schema/published",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              SchemaArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArns: {
                shape: "S66"
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/tags",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S79"
              },
              NextToken: {}
            }
          }
        },
        ListTypedLinkFacetAttributes: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/facet/attributes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "S4v"
              },
              NextToken: {}
            }
          }
        },
        ListTypedLinkFacetNames: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/facet/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FacetNames: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        LookupPolicy: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/policy/lookup",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyToPathList: {
                shape: "S2b"
              },
              NextToken: {}
            }
          }
        },
        PublishSchema: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema/publish",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DevelopmentSchemaArn",
              "Version"
            ],
            members: {
              DevelopmentSchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Version: {},
              MinorVersion: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PublishedSchemaArn: {}
            }
          }
        },
        PutSchemaFromJson: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema/json",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Document"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Document: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {}
            }
          }
        },
        RemoveFacetFromObject: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/object/facets/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "SchemaFacet",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              SchemaFacet: {
                shape: "S3"
              },
              ObjectReference: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/tags/add",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S79"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/tags/remove",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateFacet: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/facet",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {},
              AttributeUpdates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Attribute: {
                      shape: "S47"
                    },
                    Action: {}
                  }
                }
              },
              ObjectType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateLinkAttributes: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/attributes/update",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "TypedLinkSpecifier",
              "AttributeUpdates"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              TypedLinkSpecifier: {
                shape: "Sy"
              },
              AttributeUpdates: {
                shape: "S3g"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateObjectAttributes: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/object/update",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference",
              "AttributeUpdates"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              AttributeUpdates: {
                shape: "S2z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ObjectIdentifier: {}
            }
          }
        },
        UpdateSchema: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema/update",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArn: {}
            }
          }
        },
        UpdateTypedLinkFacet: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/facet",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name",
              "AttributeUpdates",
              "IdentityAttributeOrder"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {},
              AttributeUpdates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Attribute",
                    "Action"
                  ],
                  members: {
                    Attribute: {
                      shape: "S4w"
                    },
                    Action: {}
                  }
                }
              },
              IdentityAttributeOrder: {
                shape: "S1a"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpgradeAppliedSchema: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema/upgradeapplied",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "PublishedSchemaArn",
              "DirectoryArn"
            ],
            members: {
              PublishedSchemaArn: {},
              DirectoryArn: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UpgradedSchemaArn: {},
              DirectoryArn: {}
            }
          }
        },
        UpgradePublishedSchema: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema/upgradepublished",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DevelopmentSchemaArn",
              "PublishedSchemaArn",
              "MinorVersion"
            ],
            members: {
              DevelopmentSchemaArn: {},
              PublishedSchemaArn: {},
              MinorVersion: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UpgradedSchemaArn: {}
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          members: {
            SchemaArn: {},
            FacetName: {}
          }
        },
        S5: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {
                shape: "S7"
              },
              Value: {
                shape: "S9"
              }
            }
          }
        },
        S7: {
          type: "structure",
          required: [
            "SchemaArn",
            "FacetName",
            "Name"
          ],
          members: {
            SchemaArn: {},
            FacetName: {},
            Name: {}
          }
        },
        S9: {
          type: "structure",
          members: {
            StringValue: {},
            BinaryValue: {
              type: "blob"
            },
            BooleanValue: {
              type: "boolean"
            },
            NumberValue: {},
            DatetimeValue: {
              type: "timestamp"
            }
          }
        },
        Sf: {
          type: "structure",
          members: {
            Selector: {}
          }
        },
        St: {
          type: "structure",
          required: [
            "SchemaArn",
            "TypedLinkName"
          ],
          members: {
            SchemaArn: {},
            TypedLinkName: {}
          }
        },
        Sv: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AttributeName",
              "Value"
            ],
            members: {
              AttributeName: {},
              Value: {
                shape: "S9"
              }
            }
          }
        },
        Sy: {
          type: "structure",
          required: [
            "TypedLinkFacet",
            "SourceObjectReference",
            "TargetObjectReference",
            "IdentityAttributeValues"
          ],
          members: {
            TypedLinkFacet: {
              shape: "St"
            },
            SourceObjectReference: {
              shape: "Sf"
            },
            TargetObjectReference: {
              shape: "Sf"
            },
            IdentityAttributeValues: {
              shape: "Sv"
            }
          }
        },
        S1a: {
          type: "list",
          member: {}
        },
        S1g: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AttributeKey: {
                shape: "S7"
              },
              Range: {
                shape: "S1i"
              }
            }
          }
        },
        S1i: {
          type: "structure",
          required: [
            "StartMode",
            "EndMode"
          ],
          members: {
            StartMode: {},
            StartValue: {
              shape: "S9"
            },
            EndMode: {},
            EndValue: {
              shape: "S9"
            }
          }
        },
        S1l: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Range"
            ],
            members: {
              AttributeName: {},
              Range: {
                shape: "S1i"
              }
            }
          }
        },
        S1w: {
          type: "map",
          key: {},
          value: {}
        },
        S1y: {
          type: "list",
          member: {
            shape: "S3"
          }
        },
        S21: {
          type: "list",
          member: {
            type: "structure",
            members: {
              IndexedAttributes: {
                shape: "S5"
              },
              ObjectIdentifier: {}
            }
          }
        },
        S24: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Path: {},
              ObjectIdentifiers: {
                shape: "S27"
              }
            }
          }
        },
        S27: {
          type: "list",
          member: {}
        },
        S2b: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Path: {},
              Policies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PolicyId: {},
                    ObjectIdentifier: {},
                    PolicyType: {}
                  }
                }
              }
            }
          }
        },
        S2i: {
          type: "list",
          member: {
            shape: "Sy"
          }
        },
        S2m: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ObjectIdentifier: {},
              LinkName: {}
            }
          }
        },
        S2z: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ObjectAttributeKey: {
                shape: "S7"
              },
              ObjectAttributeAction: {
                type: "structure",
                members: {
                  ObjectAttributeActionType: {},
                  ObjectAttributeUpdateValue: {
                    shape: "S9"
                  }
                }
              }
            }
          }
        },
        S39: {
          type: "list",
          member: {
            shape: "S7"
          }
        },
        S3g: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AttributeKey: {
                shape: "S7"
              },
              AttributeAction: {
                type: "structure",
                members: {
                  AttributeActionType: {},
                  AttributeUpdateValue: {
                    shape: "S9"
                  }
                }
              }
            }
          }
        },
        S46: {
          type: "list",
          member: {
            shape: "S47"
          }
        },
        S47: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            AttributeDefinition: {
              type: "structure",
              required: [
                "Type"
              ],
              members: {
                Type: {},
                DefaultValue: {
                  shape: "S9"
                },
                IsImmutable: {
                  type: "boolean"
                },
                Rules: {
                  shape: "S4a"
                }
              }
            },
            AttributeReference: {
              type: "structure",
              required: [
                "TargetFacetName",
                "TargetAttributeName"
              ],
              members: {
                TargetFacetName: {},
                TargetAttributeName: {}
              }
            },
            RequiredBehavior: {}
          }
        },
        S4a: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              Type: {},
              Parameters: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        S4v: {
          type: "list",
          member: {
            shape: "S4w"
          }
        },
        S4w: {
          type: "structure",
          required: [
            "Name",
            "Type",
            "RequiredBehavior"
          ],
          members: {
            Name: {},
            Type: {},
            DefaultValue: {
              shape: "S9"
            },
            IsImmutable: {
              type: "boolean"
            },
            Rules: {
              shape: "S4a"
            },
            RequiredBehavior: {}
          }
        },
        S5n: {
          type: "structure",
          members: {
            Name: {},
            DirectoryArn: {},
            State: {},
            CreationDateTime: {
              type: "timestamp"
            }
          }
        },
        S66: {
          type: "list",
          member: {}
        },
        S79: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/clouddirectory-2017-01-11.paginators.json
var require_clouddirectory_2017_01_11_paginators = __commonJS({
  "node_modules/aws-sdk/apis/clouddirectory-2017-01-11.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAppliedSchemaArns: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAttachedIndices: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDevelopmentSchemaArns: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDirectories: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListFacetAttributes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListFacetNames: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListIndex: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListManagedSchemaArns: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListObjectAttributes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListObjectChildren: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListObjectParentPaths: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListObjectParents: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListObjectPolicies: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListPolicyAttachments: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListPublishedSchemaArns: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListTagsForResource: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListTypedLinkFacetAttributes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListTypedLinkFacetNames: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        LookupPolicy: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/clouddirectory.js
var require_clouddirectory = __commonJS({
  "node_modules/aws-sdk/clients/clouddirectory.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["clouddirectory"] = {};
    AWS2.CloudDirectory = Service.defineService("clouddirectory", ["2016-05-10", "2016-05-10*", "2017-01-11"]);
    Object.defineProperty(apiLoader.services["clouddirectory"], "2016-05-10", {
      get: function get() {
        var model = require_clouddirectory_2016_05_10_min();
        model.paginators = require_clouddirectory_2016_05_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(apiLoader.services["clouddirectory"], "2017-01-11", {
      get: function get() {
        var model = require_clouddirectory_2017_01_11_min();
        model.paginators = require_clouddirectory_2017_01_11_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CloudDirectory;
  }
});

// node_modules/aws-sdk/apis/cloudformation-2010-05-15.min.json
var require_cloudformation_2010_05_15_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudformation-2010-05-15.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2010-05-15",
        endpointPrefix: "cloudformation",
        protocol: "query",
        serviceFullName: "AWS CloudFormation",
        serviceId: "CloudFormation",
        signatureVersion: "v4",
        uid: "cloudformation-2010-05-15",
        xmlNamespace: "http://cloudformation.amazonaws.com/doc/2010-05-15/"
      },
      operations: {
        ActivateOrganizationsAccess: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            resultWrapper: "ActivateOrganizationsAccessResult",
            type: "structure",
            members: {}
          }
        },
        ActivateType: {
          input: {
            type: "structure",
            members: {
              Type: {},
              PublicTypeArn: {},
              PublisherId: {},
              TypeName: {},
              TypeNameAlias: {},
              AutoUpdate: {
                type: "boolean"
              },
              LoggingConfig: {
                shape: "S9"
              },
              ExecutionRoleArn: {},
              VersionBump: {},
              MajorVersion: {
                type: "long"
              }
            }
          },
          output: {
            resultWrapper: "ActivateTypeResult",
            type: "structure",
            members: {
              Arn: {}
            }
          },
          idempotent: true
        },
        BatchDescribeTypeConfigurations: {
          input: {
            type: "structure",
            required: [
              "TypeConfigurationIdentifiers"
            ],
            members: {
              TypeConfigurationIdentifiers: {
                type: "list",
                member: {
                  shape: "Si"
                }
              }
            }
          },
          output: {
            resultWrapper: "BatchDescribeTypeConfigurationsResult",
            type: "structure",
            members: {
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ErrorCode: {},
                    ErrorMessage: {},
                    TypeConfigurationIdentifier: {
                      shape: "Si"
                    }
                  }
                }
              },
              UnprocessedTypeConfigurations: {
                type: "list",
                member: {
                  shape: "Si"
                }
              },
              TypeConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Alias: {},
                    Configuration: {},
                    LastUpdated: {
                      type: "timestamp"
                    },
                    TypeArn: {},
                    TypeName: {},
                    IsDefaultConfiguration: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        CancelUpdateStack: {
          input: {
            type: "structure",
            required: [
              "StackName"
            ],
            members: {
              StackName: {},
              ClientRequestToken: {}
            }
          }
        },
        ContinueUpdateRollback: {
          input: {
            type: "structure",
            required: [
              "StackName"
            ],
            members: {
              StackName: {},
              RoleARN: {},
              ResourcesToSkip: {
                type: "list",
                member: {}
              },
              ClientRequestToken: {}
            }
          },
          output: {
            resultWrapper: "ContinueUpdateRollbackResult",
            type: "structure",
            members: {}
          }
        },
        CreateChangeSet: {
          input: {
            type: "structure",
            required: [
              "StackName",
              "ChangeSetName"
            ],
            members: {
              StackName: {},
              TemplateBody: {},
              TemplateURL: {},
              UsePreviousTemplate: {
                type: "boolean"
              },
              Parameters: {
                shape: "S1a"
              },
              Capabilities: {
                shape: "S1f"
              },
              ResourceTypes: {
                shape: "S1h"
              },
              RoleARN: {},
              RollbackConfiguration: {
                shape: "S1j"
              },
              NotificationARNs: {
                shape: "S1p"
              },
              Tags: {
                shape: "S1r"
              },
              ChangeSetName: {},
              ClientToken: {},
              Description: {},
              ChangeSetType: {},
              ResourcesToImport: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ResourceType",
                    "LogicalResourceId",
                    "ResourceIdentifier"
                  ],
                  members: {
                    ResourceType: {},
                    LogicalResourceId: {},
                    ResourceIdentifier: {
                      type: "map",
                      key: {},
                      value: {}
                    }
                  }
                }
              },
              IncludeNestedStacks: {
                type: "boolean"
              },
              OnStackFailure: {},
              ImportExistingResources: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CreateChangeSetResult",
            type: "structure",
            members: {
              Id: {},
              StackId: {}
            }
          }
        },
        CreateStack: {
          input: {
            type: "structure",
            required: [
              "StackName"
            ],
            members: {
              StackName: {},
              TemplateBody: {},
              TemplateURL: {},
              Parameters: {
                shape: "S1a"
              },
              DisableRollback: {
                type: "boolean"
              },
              RollbackConfiguration: {
                shape: "S1j"
              },
              TimeoutInMinutes: {
                type: "integer"
              },
              NotificationARNs: {
                shape: "S1p"
              },
              Capabilities: {
                shape: "S1f"
              },
              ResourceTypes: {
                shape: "S1h"
              },
              RoleARN: {},
              OnFailure: {},
              StackPolicyBody: {},
              StackPolicyURL: {},
              Tags: {
                shape: "S1r"
              },
              ClientRequestToken: {},
              EnableTerminationProtection: {
                type: "boolean"
              },
              RetainExceptOnCreate: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CreateStackResult",
            type: "structure",
            members: {
              StackId: {}
            }
          }
        },
        CreateStackInstances: {
          input: {
            type: "structure",
            required: [
              "StackSetName",
              "Regions"
            ],
            members: {
              StackSetName: {},
              Accounts: {
                shape: "S2m"
              },
              DeploymentTargets: {
                shape: "S2o"
              },
              Regions: {
                shape: "S2t"
              },
              ParameterOverrides: {
                shape: "S1a"
              },
              OperationPreferences: {
                shape: "S2v"
              },
              OperationId: {
                idempotencyToken: true
              },
              CallAs: {}
            }
          },
          output: {
            resultWrapper: "CreateStackInstancesResult",
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        CreateStackSet: {
          input: {
            type: "structure",
            required: [
              "StackSetName"
            ],
            members: {
              StackSetName: {},
              Description: {},
              TemplateBody: {},
              TemplateURL: {},
              StackId: {},
              Parameters: {
                shape: "S1a"
              },
              Capabilities: {
                shape: "S1f"
              },
              Tags: {
                shape: "S1r"
              },
              AdministrationRoleARN: {},
              ExecutionRoleName: {},
              PermissionModel: {},
              AutoDeployment: {
                shape: "S37"
              },
              CallAs: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              ManagedExecution: {
                shape: "S3a"
              }
            }
          },
          output: {
            resultWrapper: "CreateStackSetResult",
            type: "structure",
            members: {
              StackSetId: {}
            }
          }
        },
        DeactivateOrganizationsAccess: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            resultWrapper: "DeactivateOrganizationsAccessResult",
            type: "structure",
            members: {}
          }
        },
        DeactivateType: {
          input: {
            type: "structure",
            members: {
              TypeName: {},
              Type: {},
              Arn: {}
            }
          },
          output: {
            resultWrapper: "DeactivateTypeResult",
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteChangeSet: {
          input: {
            type: "structure",
            required: [
              "ChangeSetName"
            ],
            members: {
              ChangeSetName: {},
              StackName: {}
            }
          },
          output: {
            resultWrapper: "DeleteChangeSetResult",
            type: "structure",
            members: {}
          }
        },
        DeleteStack: {
          input: {
            type: "structure",
            required: [
              "StackName"
            ],
            members: {
              StackName: {},
              RetainResources: {
                type: "list",
                member: {}
              },
              RoleARN: {},
              ClientRequestToken: {}
            }
          }
        },
        DeleteStackInstances: {
          input: {
            type: "structure",
            required: [
              "StackSetName",
              "Regions",
              "RetainStacks"
            ],
            members: {
              StackSetName: {},
              Accounts: {
                shape: "S2m"
              },
              DeploymentTargets: {
                shape: "S2o"
              },
              Regions: {
                shape: "S2t"
              },
              OperationPreferences: {
                shape: "S2v"
              },
              RetainStacks: {
                type: "boolean"
              },
              OperationId: {
                idempotencyToken: true
              },
              CallAs: {}
            }
          },
          output: {
            resultWrapper: "DeleteStackInstancesResult",
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        DeleteStackSet: {
          input: {
            type: "structure",
            required: [
              "StackSetName"
            ],
            members: {
              StackSetName: {},
              CallAs: {}
            }
          },
          output: {
            resultWrapper: "DeleteStackSetResult",
            type: "structure",
            members: {}
          }
        },
        DeregisterType: {
          input: {
            type: "structure",
            members: {
              Arn: {},
              Type: {},
              TypeName: {},
              VersionId: {}
            }
          },
          output: {
            resultWrapper: "DeregisterTypeResult",
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DescribeAccountLimits: {
          input: {
            type: "structure",
            members: {
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "DescribeAccountLimitsResult",
            type: "structure",
            members: {
              AccountLimits: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Value: {
                      type: "integer"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeChangeSet: {
          input: {
            type: "structure",
            required: [
              "ChangeSetName"
            ],
            members: {
              ChangeSetName: {},
              StackName: {},
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "DescribeChangeSetResult",
            type: "structure",
            members: {
              ChangeSetName: {},
              ChangeSetId: {},
              StackId: {},
              StackName: {},
              Description: {},
              Parameters: {
                shape: "S1a"
              },
              CreationTime: {
                type: "timestamp"
              },
              ExecutionStatus: {},
              Status: {},
              StatusReason: {},
              NotificationARNs: {
                shape: "S1p"
              },
              RollbackConfiguration: {
                shape: "S1j"
              },
              Capabilities: {
                shape: "S1f"
              },
              Tags: {
                shape: "S1r"
              },
              Changes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    HookInvocationCount: {
                      type: "integer"
                    },
                    ResourceChange: {
                      type: "structure",
                      members: {
                        Action: {},
                        LogicalResourceId: {},
                        PhysicalResourceId: {},
                        ResourceType: {},
                        Replacement: {},
                        Scope: {
                          type: "list",
                          member: {}
                        },
                        Details: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              Target: {
                                type: "structure",
                                members: {
                                  Attribute: {},
                                  Name: {},
                                  RequiresRecreation: {}
                                }
                              },
                              Evaluation: {},
                              ChangeSource: {},
                              CausingEntity: {}
                            }
                          }
                        },
                        ChangeSetId: {},
                        ModuleInfo: {
                          shape: "S4r"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {},
              IncludeNestedStacks: {
                type: "boolean"
              },
              ParentChangeSetId: {},
              RootChangeSetId: {},
              OnStackFailure: {},
              ImportExistingResources: {
                type: "boolean"
              }
            }
          }
        },
        DescribeChangeSetHooks: {
          input: {
            type: "structure",
            required: [
              "ChangeSetName"
            ],
            members: {
              ChangeSetName: {},
              StackName: {},
              NextToken: {},
              LogicalResourceId: {}
            }
          },
          output: {
            resultWrapper: "DescribeChangeSetHooksResult",
            type: "structure",
            members: {
              ChangeSetId: {},
              ChangeSetName: {},
              Hooks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InvocationPoint: {},
                    FailureMode: {},
                    TypeName: {},
                    TypeVersionId: {},
                    TypeConfigurationVersionId: {},
                    TargetDetails: {
                      type: "structure",
                      members: {
                        TargetType: {},
                        ResourceTargetDetails: {
                          type: "structure",
                          members: {
                            LogicalResourceId: {},
                            ResourceType: {},
                            ResourceAction: {}
                          }
                        }
                      }
                    }
                  }
                }
              },
              Status: {},
              NextToken: {},
              StackId: {},
              StackName: {}
            }
          }
        },
        DescribeOrganizationsAccess: {
          input: {
            type: "structure",
            members: {
              CallAs: {}
            }
          },
          output: {
            resultWrapper: "DescribeOrganizationsAccessResult",
            type: "structure",
            members: {
              Status: {}
            }
          }
        },
        DescribePublisher: {
          input: {
            type: "structure",
            members: {
              PublisherId: {}
            }
          },
          output: {
            resultWrapper: "DescribePublisherResult",
            type: "structure",
            members: {
              PublisherId: {},
              PublisherStatus: {},
              IdentityProvider: {},
              PublisherProfile: {}
            }
          },
          idempotent: true
        },
        DescribeStackDriftDetectionStatus: {
          input: {
            type: "structure",
            required: [
              "StackDriftDetectionId"
            ],
            members: {
              StackDriftDetectionId: {}
            }
          },
          output: {
            resultWrapper: "DescribeStackDriftDetectionStatusResult",
            type: "structure",
            required: [
              "StackId",
              "StackDriftDetectionId",
              "DetectionStatus",
              "Timestamp"
            ],
            members: {
              StackId: {},
              StackDriftDetectionId: {},
              StackDriftStatus: {},
              DetectionStatus: {},
              DetectionStatusReason: {},
              DriftedStackResourceCount: {
                type: "integer"
              },
              Timestamp: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeStackEvents: {
          input: {
            type: "structure",
            members: {
              StackName: {},
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "DescribeStackEventsResult",
            type: "structure",
            members: {
              StackEvents: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "StackId",
                    "EventId",
                    "StackName",
                    "Timestamp"
                  ],
                  members: {
                    StackId: {},
                    EventId: {},
                    StackName: {},
                    LogicalResourceId: {},
                    PhysicalResourceId: {},
                    ResourceType: {},
                    Timestamp: {
                      type: "timestamp"
                    },
                    ResourceStatus: {},
                    ResourceStatusReason: {},
                    ResourceProperties: {},
                    ClientRequestToken: {},
                    HookType: {},
                    HookStatus: {},
                    HookStatusReason: {},
                    HookInvocationPoint: {},
                    HookFailureMode: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeStackInstance: {
          input: {
            type: "structure",
            required: [
              "StackSetName",
              "StackInstanceAccount",
              "StackInstanceRegion"
            ],
            members: {
              StackSetName: {},
              StackInstanceAccount: {},
              StackInstanceRegion: {},
              CallAs: {}
            }
          },
          output: {
            resultWrapper: "DescribeStackInstanceResult",
            type: "structure",
            members: {
              StackInstance: {
                type: "structure",
                members: {
                  StackSetId: {},
                  Region: {},
                  Account: {},
                  StackId: {},
                  ParameterOverrides: {
                    shape: "S1a"
                  },
                  Status: {},
                  StackInstanceStatus: {
                    shape: "S62"
                  },
                  StatusReason: {},
                  OrganizationalUnitId: {},
                  DriftStatus: {},
                  LastDriftCheckTimestamp: {
                    type: "timestamp"
                  },
                  LastOperationId: {}
                }
              }
            }
          }
        },
        DescribeStackResource: {
          input: {
            type: "structure",
            required: [
              "StackName",
              "LogicalResourceId"
            ],
            members: {
              StackName: {},
              LogicalResourceId: {}
            }
          },
          output: {
            resultWrapper: "DescribeStackResourceResult",
            type: "structure",
            members: {
              StackResourceDetail: {
                type: "structure",
                required: [
                  "LogicalResourceId",
                  "ResourceType",
                  "LastUpdatedTimestamp",
                  "ResourceStatus"
                ],
                members: {
                  StackName: {},
                  StackId: {},
                  LogicalResourceId: {},
                  PhysicalResourceId: {},
                  ResourceType: {},
                  LastUpdatedTimestamp: {
                    type: "timestamp"
                  },
                  ResourceStatus: {},
                  ResourceStatusReason: {},
                  Description: {},
                  Metadata: {},
                  DriftInformation: {
                    shape: "S69"
                  },
                  ModuleInfo: {
                    shape: "S4r"
                  }
                }
              }
            }
          }
        },
        DescribeStackResourceDrifts: {
          input: {
            type: "structure",
            required: [
              "StackName"
            ],
            members: {
              StackName: {},
              StackResourceDriftStatusFilters: {
                shape: "S6c"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeStackResourceDriftsResult",
            type: "structure",
            required: [
              "StackResourceDrifts"
            ],
            members: {
              StackResourceDrifts: {
                type: "list",
                member: {
                  shape: "S6g"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeStackResources: {
          input: {
            type: "structure",
            members: {
              StackName: {},
              LogicalResourceId: {},
              PhysicalResourceId: {}
            }
          },
          output: {
            resultWrapper: "DescribeStackResourcesResult",
            type: "structure",
            members: {
              StackResources: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "LogicalResourceId",
                    "ResourceType",
                    "Timestamp",
                    "ResourceStatus"
                  ],
                  members: {
                    StackName: {},
                    StackId: {},
                    LogicalResourceId: {},
                    PhysicalResourceId: {},
                    ResourceType: {},
                    Timestamp: {
                      type: "timestamp"
                    },
                    ResourceStatus: {},
                    ResourceStatusReason: {},
                    Description: {},
                    DriftInformation: {
                      shape: "S69"
                    },
                    ModuleInfo: {
                      shape: "S4r"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeStackSet: {
          input: {
            type: "structure",
            required: [
              "StackSetName"
            ],
            members: {
              StackSetName: {},
              CallAs: {}
            }
          },
          output: {
            resultWrapper: "DescribeStackSetResult",
            type: "structure",
            members: {
              StackSet: {
                type: "structure",
                members: {
                  StackSetName: {},
                  StackSetId: {},
                  Description: {},
                  Status: {},
                  TemplateBody: {},
                  Parameters: {
                    shape: "S1a"
                  },
                  Capabilities: {
                    shape: "S1f"
                  },
                  Tags: {
                    shape: "S1r"
                  },
                  StackSetARN: {},
                  AdministrationRoleARN: {},
                  ExecutionRoleName: {},
                  StackSetDriftDetectionDetails: {
                    shape: "S70"
                  },
                  AutoDeployment: {
                    shape: "S37"
                  },
                  PermissionModel: {},
                  OrganizationalUnitIds: {
                    shape: "S2q"
                  },
                  ManagedExecution: {
                    shape: "S3a"
                  },
                  Regions: {
                    shape: "S2t"
                  }
                }
              }
            }
          }
        },
        DescribeStackSetOperation: {
          input: {
            type: "structure",
            required: [
              "StackSetName",
              "OperationId"
            ],
            members: {
              StackSetName: {},
              OperationId: {},
              CallAs: {}
            }
          },
          output: {
            resultWrapper: "DescribeStackSetOperationResult",
            type: "structure",
            members: {
              StackSetOperation: {
                type: "structure",
                members: {
                  OperationId: {},
                  StackSetId: {},
                  Action: {},
                  Status: {},
                  OperationPreferences: {
                    shape: "S2v"
                  },
                  RetainStacks: {
                    type: "boolean"
                  },
                  AdministrationRoleARN: {},
                  ExecutionRoleName: {},
                  CreationTimestamp: {
                    type: "timestamp"
                  },
                  EndTimestamp: {
                    type: "timestamp"
                  },
                  DeploymentTargets: {
                    shape: "S2o"
                  },
                  StackSetDriftDetectionDetails: {
                    shape: "S70"
                  },
                  StatusReason: {},
                  StatusDetails: {
                    shape: "S7f"
                  }
                }
              }
            }
          }
        },
        DescribeStacks: {
          input: {
            type: "structure",
            members: {
              StackName: {},
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "DescribeStacksResult",
            type: "structure",
            members: {
              Stacks: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "StackName",
                    "CreationTime",
                    "StackStatus"
                  ],
                  members: {
                    StackId: {},
                    StackName: {},
                    ChangeSetId: {},
                    Description: {},
                    Parameters: {
                      shape: "S1a"
                    },
                    CreationTime: {
                      type: "timestamp"
                    },
                    DeletionTime: {
                      type: "timestamp"
                    },
                    LastUpdatedTime: {
                      type: "timestamp"
                    },
                    RollbackConfiguration: {
                      shape: "S1j"
                    },
                    StackStatus: {},
                    StackStatusReason: {},
                    DisableRollback: {
                      type: "boolean"
                    },
                    NotificationARNs: {
                      shape: "S1p"
                    },
                    TimeoutInMinutes: {
                      type: "integer"
                    },
                    Capabilities: {
                      shape: "S1f"
                    },
                    Outputs: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          OutputKey: {},
                          OutputValue: {},
                          Description: {},
                          ExportName: {}
                        }
                      }
                    },
                    RoleARN: {},
                    Tags: {
                      shape: "S1r"
                    },
                    EnableTerminationProtection: {
                      type: "boolean"
                    },
                    ParentId: {},
                    RootId: {},
                    DriftInformation: {
                      type: "structure",
                      required: [
                        "StackDriftStatus"
                      ],
                      members: {
                        StackDriftStatus: {},
                        LastCheckTimestamp: {
                          type: "timestamp"
                        }
                      }
                    },
                    RetainExceptOnCreate: {
                      type: "boolean"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeType: {
          input: {
            type: "structure",
            members: {
              Type: {},
              TypeName: {},
              Arn: {},
              VersionId: {},
              PublisherId: {},
              PublicVersionNumber: {}
            }
          },
          output: {
            resultWrapper: "DescribeTypeResult",
            type: "structure",
            members: {
              Arn: {},
              Type: {},
              TypeName: {},
              DefaultVersionId: {},
              IsDefaultVersion: {
                type: "boolean"
              },
              TypeTestsStatus: {},
              TypeTestsStatusDescription: {},
              Description: {},
              Schema: {},
              ProvisioningType: {},
              DeprecatedStatus: {},
              LoggingConfig: {
                shape: "S9"
              },
              RequiredActivatedTypes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TypeNameAlias: {},
                    OriginalTypeName: {},
                    PublisherId: {},
                    SupportedMajorVersions: {
                      type: "list",
                      member: {
                        type: "integer"
                      }
                    }
                  }
                }
              },
              ExecutionRoleArn: {},
              Visibility: {},
              SourceUrl: {},
              DocumentationUrl: {},
              LastUpdated: {
                type: "timestamp"
              },
              TimeCreated: {
                type: "timestamp"
              },
              ConfigurationSchema: {},
              PublisherId: {},
              OriginalTypeName: {},
              OriginalTypeArn: {},
              PublicVersionNumber: {},
              LatestPublicVersion: {},
              IsActivated: {
                type: "boolean"
              },
              AutoUpdate: {
                type: "boolean"
              }
            }
          },
          idempotent: true
        },
        DescribeTypeRegistration: {
          input: {
            type: "structure",
            required: [
              "RegistrationToken"
            ],
            members: {
              RegistrationToken: {}
            }
          },
          output: {
            resultWrapper: "DescribeTypeRegistrationResult",
            type: "structure",
            members: {
              ProgressStatus: {},
              Description: {},
              TypeArn: {},
              TypeVersionArn: {}
            }
          },
          idempotent: true
        },
        DetectStackDrift: {
          input: {
            type: "structure",
            required: [
              "StackName"
            ],
            members: {
              StackName: {},
              LogicalResourceIds: {
                shape: "S8g"
              }
            }
          },
          output: {
            resultWrapper: "DetectStackDriftResult",
            type: "structure",
            required: [
              "StackDriftDetectionId"
            ],
            members: {
              StackDriftDetectionId: {}
            }
          }
        },
        DetectStackResourceDrift: {
          input: {
            type: "structure",
            required: [
              "StackName",
              "LogicalResourceId"
            ],
            members: {
              StackName: {},
              LogicalResourceId: {}
            }
          },
          output: {
            resultWrapper: "DetectStackResourceDriftResult",
            type: "structure",
            required: [
              "StackResourceDrift"
            ],
            members: {
              StackResourceDrift: {
                shape: "S6g"
              }
            }
          }
        },
        DetectStackSetDrift: {
          input: {
            type: "structure",
            required: [
              "StackSetName"
            ],
            members: {
              StackSetName: {},
              OperationPreferences: {
                shape: "S2v"
              },
              OperationId: {
                idempotencyToken: true
              },
              CallAs: {}
            }
          },
          output: {
            resultWrapper: "DetectStackSetDriftResult",
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        EstimateTemplateCost: {
          input: {
            type: "structure",
            members: {
              TemplateBody: {},
              TemplateURL: {},
              Parameters: {
                shape: "S1a"
              }
            }
          },
          output: {
            resultWrapper: "EstimateTemplateCostResult",
            type: "structure",
            members: {
              Url: {}
            }
          }
        },
        ExecuteChangeSet: {
          input: {
            type: "structure",
            required: [
              "ChangeSetName"
            ],
            members: {
              ChangeSetName: {},
              StackName: {},
              ClientRequestToken: {},
              DisableRollback: {
                type: "boolean"
              },
              RetainExceptOnCreate: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ExecuteChangeSetResult",
            type: "structure",
            members: {}
          }
        },
        GetStackPolicy: {
          input: {
            type: "structure",
            required: [
              "StackName"
            ],
            members: {
              StackName: {}
            }
          },
          output: {
            resultWrapper: "GetStackPolicyResult",
            type: "structure",
            members: {
              StackPolicyBody: {}
            }
          }
        },
        GetTemplate: {
          input: {
            type: "structure",
            members: {
              StackName: {},
              ChangeSetName: {},
              TemplateStage: {}
            }
          },
          output: {
            resultWrapper: "GetTemplateResult",
            type: "structure",
            members: {
              TemplateBody: {},
              StagesAvailable: {
                type: "list",
                member: {}
              }
            }
          }
        },
        GetTemplateSummary: {
          input: {
            type: "structure",
            members: {
              TemplateBody: {},
              TemplateURL: {},
              StackName: {},
              StackSetName: {},
              CallAs: {},
              TemplateSummaryConfig: {
                type: "structure",
                members: {
                  TreatUnrecognizedResourceTypesAsWarnings: {
                    type: "boolean"
                  }
                }
              }
            }
          },
          output: {
            resultWrapper: "GetTemplateSummaryResult",
            type: "structure",
            members: {
              Parameters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ParameterKey: {},
                    DefaultValue: {},
                    ParameterType: {},
                    NoEcho: {
                      type: "boolean"
                    },
                    Description: {},
                    ParameterConstraints: {
                      type: "structure",
                      members: {
                        AllowedValues: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  }
                }
              },
              Description: {},
              Capabilities: {
                shape: "S1f"
              },
              CapabilitiesReason: {},
              ResourceTypes: {
                shape: "S1h"
              },
              Version: {},
              Metadata: {},
              DeclaredTransforms: {
                shape: "S9b"
              },
              ResourceIdentifierSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceType: {},
                    LogicalResourceIds: {
                      shape: "S8g"
                    },
                    ResourceIdentifiers: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              Warnings: {
                type: "structure",
                members: {
                  UnrecognizedResourceTypes: {
                    shape: "S1h"
                  }
                }
              }
            }
          }
        },
        ImportStacksToStackSet: {
          input: {
            type: "structure",
            required: [
              "StackSetName"
            ],
            members: {
              StackSetName: {},
              StackIds: {
                type: "list",
                member: {}
              },
              StackIdsUrl: {},
              OrganizationalUnitIds: {
                shape: "S2q"
              },
              OperationPreferences: {
                shape: "S2v"
              },
              OperationId: {
                idempotencyToken: true
              },
              CallAs: {}
            }
          },
          output: {
            resultWrapper: "ImportStacksToStackSetResult",
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        ListChangeSets: {
          input: {
            type: "structure",
            required: [
              "StackName"
            ],
            members: {
              StackName: {},
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListChangeSetsResult",
            type: "structure",
            members: {
              Summaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StackId: {},
                    StackName: {},
                    ChangeSetId: {},
                    ChangeSetName: {},
                    ExecutionStatus: {},
                    Status: {},
                    StatusReason: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    Description: {},
                    IncludeNestedStacks: {
                      type: "boolean"
                    },
                    ParentChangeSetId: {},
                    RootChangeSetId: {},
                    ImportExistingResources: {
                      type: "boolean"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListExports: {
          input: {
            type: "structure",
            members: {
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListExportsResult",
            type: "structure",
            members: {
              Exports: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ExportingStackId: {},
                    Name: {},
                    Value: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListImports: {
          input: {
            type: "structure",
            required: [
              "ExportName"
            ],
            members: {
              ExportName: {},
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListImportsResult",
            type: "structure",
            members: {
              Imports: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListStackInstanceResourceDrifts: {
          input: {
            type: "structure",
            required: [
              "StackSetName",
              "StackInstanceAccount",
              "StackInstanceRegion",
              "OperationId"
            ],
            members: {
              StackSetName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              StackInstanceResourceDriftStatuses: {
                shape: "S6c"
              },
              StackInstanceAccount: {},
              StackInstanceRegion: {},
              OperationId: {},
              CallAs: {}
            }
          },
          output: {
            resultWrapper: "ListStackInstanceResourceDriftsResult",
            type: "structure",
            members: {
              Summaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "StackId",
                    "LogicalResourceId",
                    "ResourceType",
                    "StackResourceDriftStatus",
                    "Timestamp"
                  ],
                  members: {
                    StackId: {},
                    LogicalResourceId: {},
                    PhysicalResourceId: {},
                    PhysicalResourceIdContext: {
                      shape: "S6h"
                    },
                    ResourceType: {},
                    PropertyDifferences: {
                      shape: "S6m"
                    },
                    StackResourceDriftStatus: {},
                    Timestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListStackInstances: {
          input: {
            type: "structure",
            required: [
              "StackSetName"
            ],
            members: {
              StackSetName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Values: {}
                  }
                }
              },
              StackInstanceAccount: {},
              StackInstanceRegion: {},
              CallAs: {}
            }
          },
          output: {
            resultWrapper: "ListStackInstancesResult",
            type: "structure",
            members: {
              Summaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StackSetId: {},
                    Region: {},
                    Account: {},
                    StackId: {},
                    Status: {},
                    StatusReason: {},
                    StackInstanceStatus: {
                      shape: "S62"
                    },
                    OrganizationalUnitId: {},
                    DriftStatus: {},
                    LastDriftCheckTimestamp: {
                      type: "timestamp"
                    },
                    LastOperationId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListStackResources: {
          input: {
            type: "structure",
            required: [
              "StackName"
            ],
            members: {
              StackName: {},
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListStackResourcesResult",
            type: "structure",
            members: {
              StackResourceSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "LogicalResourceId",
                    "ResourceType",
                    "LastUpdatedTimestamp",
                    "ResourceStatus"
                  ],
                  members: {
                    LogicalResourceId: {},
                    PhysicalResourceId: {},
                    ResourceType: {},
                    LastUpdatedTimestamp: {
                      type: "timestamp"
                    },
                    ResourceStatus: {},
                    ResourceStatusReason: {},
                    DriftInformation: {
                      type: "structure",
                      required: [
                        "StackResourceDriftStatus"
                      ],
                      members: {
                        StackResourceDriftStatus: {},
                        LastCheckTimestamp: {
                          type: "timestamp"
                        }
                      }
                    },
                    ModuleInfo: {
                      shape: "S4r"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListStackSetOperationResults: {
          input: {
            type: "structure",
            required: [
              "StackSetName",
              "OperationId"
            ],
            members: {
              StackSetName: {},
              OperationId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              CallAs: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Values: {}
                  }
                }
              }
            }
          },
          output: {
            resultWrapper: "ListStackSetOperationResultsResult",
            type: "structure",
            members: {
              Summaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Account: {},
                    Region: {},
                    Status: {},
                    StatusReason: {},
                    AccountGateResult: {
                      type: "structure",
                      members: {
                        Status: {},
                        StatusReason: {}
                      }
                    },
                    OrganizationalUnitId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListStackSetOperations: {
          input: {
            type: "structure",
            required: [
              "StackSetName"
            ],
            members: {
              StackSetName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              CallAs: {}
            }
          },
          output: {
            resultWrapper: "ListStackSetOperationsResult",
            type: "structure",
            members: {
              Summaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    OperationId: {},
                    Action: {},
                    Status: {},
                    CreationTimestamp: {
                      type: "timestamp"
                    },
                    EndTimestamp: {
                      type: "timestamp"
                    },
                    StatusReason: {},
                    StatusDetails: {
                      shape: "S7f"
                    },
                    OperationPreferences: {
                      shape: "S2v"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListStackSets: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Status: {},
              CallAs: {}
            }
          },
          output: {
            resultWrapper: "ListStackSetsResult",
            type: "structure",
            members: {
              Summaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StackSetName: {},
                    StackSetId: {},
                    Description: {},
                    Status: {},
                    AutoDeployment: {
                      shape: "S37"
                    },
                    PermissionModel: {},
                    DriftStatus: {},
                    LastDriftCheckTimestamp: {
                      type: "timestamp"
                    },
                    ManagedExecution: {
                      shape: "S3a"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListStacks: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              StackStatusFilter: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "ListStacksResult",
            type: "structure",
            members: {
              StackSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "StackName",
                    "CreationTime",
                    "StackStatus"
                  ],
                  members: {
                    StackId: {},
                    StackName: {},
                    TemplateDescription: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastUpdatedTime: {
                      type: "timestamp"
                    },
                    DeletionTime: {
                      type: "timestamp"
                    },
                    StackStatus: {},
                    StackStatusReason: {},
                    ParentId: {},
                    RootId: {},
                    DriftInformation: {
                      type: "structure",
                      required: [
                        "StackDriftStatus"
                      ],
                      members: {
                        StackDriftStatus: {},
                        LastCheckTimestamp: {
                          type: "timestamp"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTypeRegistrations: {
          input: {
            type: "structure",
            members: {
              Type: {},
              TypeName: {},
              TypeArn: {},
              RegistrationStatusFilter: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListTypeRegistrationsResult",
            type: "structure",
            members: {
              RegistrationTokenList: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListTypeVersions: {
          input: {
            type: "structure",
            members: {
              Type: {},
              TypeName: {},
              Arn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DeprecatedStatus: {},
              PublisherId: {}
            }
          },
          output: {
            resultWrapper: "ListTypeVersionsResult",
            type: "structure",
            members: {
              TypeVersionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    TypeName: {},
                    VersionId: {},
                    IsDefaultVersion: {
                      type: "boolean"
                    },
                    Arn: {},
                    TimeCreated: {
                      type: "timestamp"
                    },
                    Description: {},
                    PublicVersionNumber: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListTypes: {
          input: {
            type: "structure",
            members: {
              Visibility: {},
              ProvisioningType: {},
              DeprecatedStatus: {},
              Type: {},
              Filters: {
                type: "structure",
                members: {
                  Category: {},
                  PublisherId: {},
                  TypeNamePrefix: {}
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListTypesResult",
            type: "structure",
            members: {
              TypeSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    TypeName: {},
                    DefaultVersionId: {},
                    TypeArn: {},
                    LastUpdated: {
                      type: "timestamp"
                    },
                    Description: {},
                    PublisherId: {},
                    OriginalTypeName: {},
                    PublicVersionNumber: {},
                    LatestPublicVersion: {},
                    PublisherIdentity: {},
                    PublisherName: {},
                    IsActivated: {
                      type: "boolean"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        PublishType: {
          input: {
            type: "structure",
            members: {
              Type: {},
              Arn: {},
              TypeName: {},
              PublicVersionNumber: {}
            }
          },
          output: {
            resultWrapper: "PublishTypeResult",
            type: "structure",
            members: {
              PublicTypeArn: {}
            }
          },
          idempotent: true
        },
        RecordHandlerProgress: {
          input: {
            type: "structure",
            required: [
              "BearerToken",
              "OperationStatus"
            ],
            members: {
              BearerToken: {},
              OperationStatus: {},
              CurrentOperationStatus: {},
              StatusMessage: {},
              ErrorCode: {},
              ResourceModel: {},
              ClientRequestToken: {}
            }
          },
          output: {
            resultWrapper: "RecordHandlerProgressResult",
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        RegisterPublisher: {
          input: {
            type: "structure",
            members: {
              AcceptTermsAndConditions: {
                type: "boolean"
              },
              ConnectionArn: {}
            }
          },
          output: {
            resultWrapper: "RegisterPublisherResult",
            type: "structure",
            members: {
              PublisherId: {}
            }
          },
          idempotent: true
        },
        RegisterType: {
          input: {
            type: "structure",
            required: [
              "TypeName",
              "SchemaHandlerPackage"
            ],
            members: {
              Type: {},
              TypeName: {},
              SchemaHandlerPackage: {},
              LoggingConfig: {
                shape: "S9"
              },
              ExecutionRoleArn: {},
              ClientRequestToken: {}
            }
          },
          output: {
            resultWrapper: "RegisterTypeResult",
            type: "structure",
            members: {
              RegistrationToken: {}
            }
          },
          idempotent: true
        },
        RollbackStack: {
          input: {
            type: "structure",
            required: [
              "StackName"
            ],
            members: {
              StackName: {},
              RoleARN: {},
              ClientRequestToken: {},
              RetainExceptOnCreate: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "RollbackStackResult",
            type: "structure",
            members: {
              StackId: {}
            }
          }
        },
        SetStackPolicy: {
          input: {
            type: "structure",
            required: [
              "StackName"
            ],
            members: {
              StackName: {},
              StackPolicyBody: {},
              StackPolicyURL: {}
            }
          }
        },
        SetTypeConfiguration: {
          input: {
            type: "structure",
            required: [
              "Configuration"
            ],
            members: {
              TypeArn: {},
              Configuration: {},
              ConfigurationAlias: {},
              TypeName: {},
              Type: {}
            }
          },
          output: {
            resultWrapper: "SetTypeConfigurationResult",
            type: "structure",
            members: {
              ConfigurationArn: {}
            }
          }
        },
        SetTypeDefaultVersion: {
          input: {
            type: "structure",
            members: {
              Arn: {},
              Type: {},
              TypeName: {},
              VersionId: {}
            }
          },
          output: {
            resultWrapper: "SetTypeDefaultVersionResult",
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        SignalResource: {
          input: {
            type: "structure",
            required: [
              "StackName",
              "LogicalResourceId",
              "UniqueId",
              "Status"
            ],
            members: {
              StackName: {},
              LogicalResourceId: {},
              UniqueId: {},
              Status: {}
            }
          }
        },
        StopStackSetOperation: {
          input: {
            type: "structure",
            required: [
              "StackSetName",
              "OperationId"
            ],
            members: {
              StackSetName: {},
              OperationId: {},
              CallAs: {}
            }
          },
          output: {
            resultWrapper: "StopStackSetOperationResult",
            type: "structure",
            members: {}
          }
        },
        TestType: {
          input: {
            type: "structure",
            members: {
              Arn: {},
              Type: {},
              TypeName: {},
              VersionId: {},
              LogDeliveryBucket: {}
            }
          },
          output: {
            resultWrapper: "TestTypeResult",
            type: "structure",
            members: {
              TypeVersionArn: {}
            }
          },
          idempotent: true
        },
        UpdateStack: {
          input: {
            type: "structure",
            required: [
              "StackName"
            ],
            members: {
              StackName: {},
              TemplateBody: {},
              TemplateURL: {},
              UsePreviousTemplate: {
                type: "boolean"
              },
              StackPolicyDuringUpdateBody: {},
              StackPolicyDuringUpdateURL: {},
              Parameters: {
                shape: "S1a"
              },
              Capabilities: {
                shape: "S1f"
              },
              ResourceTypes: {
                shape: "S1h"
              },
              RoleARN: {},
              RollbackConfiguration: {
                shape: "S1j"
              },
              StackPolicyBody: {},
              StackPolicyURL: {},
              NotificationARNs: {
                shape: "S1p"
              },
              Tags: {
                shape: "S1r"
              },
              DisableRollback: {
                type: "boolean"
              },
              ClientRequestToken: {},
              RetainExceptOnCreate: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "UpdateStackResult",
            type: "structure",
            members: {
              StackId: {}
            }
          }
        },
        UpdateStackInstances: {
          input: {
            type: "structure",
            required: [
              "StackSetName",
              "Regions"
            ],
            members: {
              StackSetName: {},
              Accounts: {
                shape: "S2m"
              },
              DeploymentTargets: {
                shape: "S2o"
              },
              Regions: {
                shape: "S2t"
              },
              ParameterOverrides: {
                shape: "S1a"
              },
              OperationPreferences: {
                shape: "S2v"
              },
              OperationId: {
                idempotencyToken: true
              },
              CallAs: {}
            }
          },
          output: {
            resultWrapper: "UpdateStackInstancesResult",
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        UpdateStackSet: {
          input: {
            type: "structure",
            required: [
              "StackSetName"
            ],
            members: {
              StackSetName: {},
              Description: {},
              TemplateBody: {},
              TemplateURL: {},
              UsePreviousTemplate: {
                type: "boolean"
              },
              Parameters: {
                shape: "S1a"
              },
              Capabilities: {
                shape: "S1f"
              },
              Tags: {
                shape: "S1r"
              },
              OperationPreferences: {
                shape: "S2v"
              },
              AdministrationRoleARN: {},
              ExecutionRoleName: {},
              DeploymentTargets: {
                shape: "S2o"
              },
              PermissionModel: {},
              AutoDeployment: {
                shape: "S37"
              },
              OperationId: {
                idempotencyToken: true
              },
              Accounts: {
                shape: "S2m"
              },
              Regions: {
                shape: "S2t"
              },
              CallAs: {},
              ManagedExecution: {
                shape: "S3a"
              }
            }
          },
          output: {
            resultWrapper: "UpdateStackSetResult",
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        UpdateTerminationProtection: {
          input: {
            type: "structure",
            required: [
              "EnableTerminationProtection",
              "StackName"
            ],
            members: {
              EnableTerminationProtection: {
                type: "boolean"
              },
              StackName: {}
            }
          },
          output: {
            resultWrapper: "UpdateTerminationProtectionResult",
            type: "structure",
            members: {
              StackId: {}
            }
          }
        },
        ValidateTemplate: {
          input: {
            type: "structure",
            members: {
              TemplateBody: {},
              TemplateURL: {}
            }
          },
          output: {
            resultWrapper: "ValidateTemplateResult",
            type: "structure",
            members: {
              Parameters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ParameterKey: {},
                    DefaultValue: {},
                    NoEcho: {
                      type: "boolean"
                    },
                    Description: {}
                  }
                }
              },
              Description: {},
              Capabilities: {
                shape: "S1f"
              },
              CapabilitiesReason: {},
              DeclaredTransforms: {
                shape: "S9b"
              }
            }
          }
        }
      },
      shapes: {
        S9: {
          type: "structure",
          required: [
            "LogRoleArn",
            "LogGroupName"
          ],
          members: {
            LogRoleArn: {},
            LogGroupName: {}
          }
        },
        Si: {
          type: "structure",
          members: {
            TypeArn: {},
            TypeConfigurationAlias: {},
            TypeConfigurationArn: {},
            Type: {},
            TypeName: {}
          }
        },
        S1a: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ParameterKey: {},
              ParameterValue: {},
              UsePreviousValue: {
                type: "boolean"
              },
              ResolvedValue: {}
            }
          }
        },
        S1f: {
          type: "list",
          member: {}
        },
        S1h: {
          type: "list",
          member: {}
        },
        S1j: {
          type: "structure",
          members: {
            RollbackTriggers: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Arn",
                  "Type"
                ],
                members: {
                  Arn: {},
                  Type: {}
                }
              }
            },
            MonitoringTimeInMinutes: {
              type: "integer"
            }
          }
        },
        S1p: {
          type: "list",
          member: {}
        },
        S1r: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S2m: {
          type: "list",
          member: {}
        },
        S2o: {
          type: "structure",
          members: {
            Accounts: {
              shape: "S2m"
            },
            AccountsUrl: {},
            OrganizationalUnitIds: {
              shape: "S2q"
            },
            AccountFilterType: {}
          }
        },
        S2q: {
          type: "list",
          member: {}
        },
        S2t: {
          type: "list",
          member: {}
        },
        S2v: {
          type: "structure",
          members: {
            RegionConcurrencyType: {},
            RegionOrder: {
              shape: "S2t"
            },
            FailureToleranceCount: {
              type: "integer"
            },
            FailureTolerancePercentage: {
              type: "integer"
            },
            MaxConcurrentCount: {
              type: "integer"
            },
            MaxConcurrentPercentage: {
              type: "integer"
            },
            ConcurrencyMode: {}
          }
        },
        S37: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            RetainStacksOnAccountRemoval: {
              type: "boolean"
            }
          }
        },
        S3a: {
          type: "structure",
          members: {
            Active: {
              type: "boolean"
            }
          }
        },
        S4r: {
          type: "structure",
          members: {
            TypeHierarchy: {},
            LogicalIdHierarchy: {}
          }
        },
        S62: {
          type: "structure",
          members: {
            DetailedStatus: {}
          }
        },
        S69: {
          type: "structure",
          required: [
            "StackResourceDriftStatus"
          ],
          members: {
            StackResourceDriftStatus: {},
            LastCheckTimestamp: {
              type: "timestamp"
            }
          }
        },
        S6c: {
          type: "list",
          member: {}
        },
        S6g: {
          type: "structure",
          required: [
            "StackId",
            "LogicalResourceId",
            "ResourceType",
            "StackResourceDriftStatus",
            "Timestamp"
          ],
          members: {
            StackId: {},
            LogicalResourceId: {},
            PhysicalResourceId: {},
            PhysicalResourceIdContext: {
              shape: "S6h"
            },
            ResourceType: {},
            ExpectedProperties: {},
            ActualProperties: {},
            PropertyDifferences: {
              shape: "S6m"
            },
            StackResourceDriftStatus: {},
            Timestamp: {
              type: "timestamp"
            },
            ModuleInfo: {
              shape: "S4r"
            }
          }
        },
        S6h: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S6m: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "PropertyPath",
              "ExpectedValue",
              "ActualValue",
              "DifferenceType"
            ],
            members: {
              PropertyPath: {},
              ExpectedValue: {},
              ActualValue: {},
              DifferenceType: {}
            }
          }
        },
        S70: {
          type: "structure",
          members: {
            DriftStatus: {},
            DriftDetectionStatus: {},
            LastDriftCheckTimestamp: {
              type: "timestamp"
            },
            TotalStackInstancesCount: {
              type: "integer"
            },
            DriftedStackInstancesCount: {
              type: "integer"
            },
            InSyncStackInstancesCount: {
              type: "integer"
            },
            InProgressStackInstancesCount: {
              type: "integer"
            },
            FailedStackInstancesCount: {
              type: "integer"
            }
          }
        },
        S7f: {
          type: "structure",
          members: {
            FailedStackInstancesCount: {
              type: "integer"
            }
          }
        },
        S8g: {
          type: "list",
          member: {}
        },
        S9b: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudformation-2010-05-15.paginators.json
var require_cloudformation_2010_05_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloudformation-2010-05-15.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeAccountLimits: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "AccountLimits"
        },
        DescribeStackEvents: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "StackEvents"
        },
        DescribeStackResourceDrifts: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        DescribeStackResources: {
          result_key: "StackResources"
        },
        DescribeStacks: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Stacks"
        },
        ListChangeSets: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Summaries"
        },
        ListExports: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Exports"
        },
        ListImports: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Imports"
        },
        ListStackInstances: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Summaries"
        },
        ListStackResources: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "StackResourceSummaries"
        },
        ListStackSetOperationResults: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Summaries"
        },
        ListStackSetOperations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Summaries"
        },
        ListStackSets: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Summaries"
        },
        ListStacks: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "StackSummaries"
        },
        ListTypeRegistrations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListTypeVersions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListTypes: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TypeSummaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudformation-2010-05-15.waiters2.json
var require_cloudformation_2010_05_15_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/cloudformation-2010-05-15.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        StackExists: {
          delay: 5,
          operation: "DescribeStacks",
          maxAttempts: 20,
          acceptors: [
            {
              matcher: "status",
              expected: 200,
              state: "success"
            },
            {
              matcher: "error",
              expected: "ValidationError",
              state: "retry"
            }
          ]
        },
        StackCreateComplete: {
          delay: 30,
          operation: "DescribeStacks",
          maxAttempts: 120,
          description: "Wait until stack status is CREATE_COMPLETE.",
          acceptors: [
            {
              argument: "Stacks[].StackStatus",
              expected: "CREATE_COMPLETE",
              matcher: "pathAll",
              state: "success"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "UPDATE_COMPLETE",
              matcher: "pathAll",
              state: "success"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "UPDATE_IN_PROGRESS",
              matcher: "pathAll",
              state: "success"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "UPDATE_COMPLETE_CLEANUP_IN_PROGRESS",
              matcher: "pathAll",
              state: "success"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "UPDATE_FAILED",
              matcher: "pathAll",
              state: "success"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "UPDATE_ROLLBACK_IN_PROGRESS",
              matcher: "pathAll",
              state: "success"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "UPDATE_ROLLBACK_FAILED",
              matcher: "pathAll",
              state: "success"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "UPDATE_ROLLBACK_COMPLETE_CLEANUP_IN_PROGRESS",
              matcher: "pathAll",
              state: "success"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "UPDATE_ROLLBACK_COMPLETE",
              matcher: "pathAll",
              state: "success"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "CREATE_FAILED",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "DELETE_COMPLETE",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "DELETE_FAILED",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "ROLLBACK_FAILED",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "ROLLBACK_COMPLETE",
              matcher: "pathAny",
              state: "failure"
            },
            {
              expected: "ValidationError",
              matcher: "error",
              state: "failure"
            }
          ]
        },
        StackDeleteComplete: {
          delay: 30,
          operation: "DescribeStacks",
          maxAttempts: 120,
          description: "Wait until stack status is DELETE_COMPLETE.",
          acceptors: [
            {
              argument: "Stacks[].StackStatus",
              expected: "DELETE_COMPLETE",
              matcher: "pathAll",
              state: "success"
            },
            {
              expected: "ValidationError",
              matcher: "error",
              state: "success"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "DELETE_FAILED",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "CREATE_FAILED",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "ROLLBACK_FAILED",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "UPDATE_ROLLBACK_IN_PROGRESS",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "UPDATE_ROLLBACK_FAILED",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "UPDATE_ROLLBACK_COMPLETE",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "UPDATE_COMPLETE",
              matcher: "pathAny",
              state: "failure"
            }
          ]
        },
        StackUpdateComplete: {
          delay: 30,
          maxAttempts: 120,
          operation: "DescribeStacks",
          description: "Wait until stack status is UPDATE_COMPLETE.",
          acceptors: [
            {
              argument: "Stacks[].StackStatus",
              expected: "UPDATE_COMPLETE",
              matcher: "pathAll",
              state: "success"
            },
            {
              expected: "UPDATE_FAILED",
              matcher: "pathAny",
              state: "failure",
              argument: "Stacks[].StackStatus"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "UPDATE_ROLLBACK_FAILED",
              matcher: "pathAny",
              state: "failure"
            },
            {
              expected: "UPDATE_ROLLBACK_COMPLETE",
              matcher: "pathAny",
              state: "failure",
              argument: "Stacks[].StackStatus"
            },
            {
              expected: "ValidationError",
              matcher: "error",
              state: "failure"
            }
          ]
        },
        StackImportComplete: {
          delay: 30,
          maxAttempts: 120,
          operation: "DescribeStacks",
          description: "Wait until stack status is IMPORT_COMPLETE.",
          acceptors: [
            {
              argument: "Stacks[].StackStatus",
              expected: "IMPORT_COMPLETE",
              matcher: "pathAll",
              state: "success"
            },
            {
              expected: "ROLLBACK_COMPLETE",
              matcher: "pathAny",
              state: "failure",
              argument: "Stacks[].StackStatus"
            },
            {
              expected: "ROLLBACK_FAILED",
              matcher: "pathAny",
              state: "failure",
              argument: "Stacks[].StackStatus"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "IMPORT_ROLLBACK_IN_PROGRESS",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "IMPORT_ROLLBACK_FAILED",
              matcher: "pathAny",
              state: "failure"
            },
            {
              expected: "IMPORT_ROLLBACK_COMPLETE",
              matcher: "pathAny",
              state: "failure",
              argument: "Stacks[].StackStatus"
            },
            {
              expected: "ValidationError",
              matcher: "error",
              state: "failure"
            }
          ]
        },
        StackRollbackComplete: {
          delay: 30,
          operation: "DescribeStacks",
          maxAttempts: 120,
          description: "Wait until stack status is UPDATE_ROLLBACK_COMPLETE.",
          acceptors: [
            {
              argument: "Stacks[].StackStatus",
              expected: "UPDATE_ROLLBACK_COMPLETE",
              matcher: "pathAll",
              state: "success"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "UPDATE_FAILED",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "UPDATE_ROLLBACK_FAILED",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "DELETE_FAILED",
              matcher: "pathAny",
              state: "failure"
            },
            {
              expected: "ValidationError",
              matcher: "error",
              state: "failure"
            }
          ]
        },
        ChangeSetCreateComplete: {
          delay: 30,
          operation: "DescribeChangeSet",
          maxAttempts: 120,
          description: "Wait until change set status is CREATE_COMPLETE.",
          acceptors: [
            {
              argument: "Status",
              expected: "CREATE_COMPLETE",
              matcher: "path",
              state: "success"
            },
            {
              argument: "Status",
              expected: "FAILED",
              matcher: "path",
              state: "failure"
            },
            {
              expected: "ValidationError",
              matcher: "error",
              state: "failure"
            }
          ]
        },
        TypeRegistrationComplete: {
          delay: 30,
          operation: "DescribeTypeRegistration",
          maxAttempts: 120,
          description: "Wait until type registration is COMPLETE.",
          acceptors: [
            {
              argument: "ProgressStatus",
              expected: "COMPLETE",
              matcher: "path",
              state: "success"
            },
            {
              argument: "ProgressStatus",
              expected: "FAILED",
              matcher: "path",
              state: "failure"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/cloudformation.js
var require_cloudformation = __commonJS({
  "node_modules/aws-sdk/clients/cloudformation.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["cloudformation"] = {};
    AWS2.CloudFormation = Service.defineService("cloudformation", ["2010-05-15"]);
    Object.defineProperty(apiLoader.services["cloudformation"], "2010-05-15", {
      get: function get() {
        var model = require_cloudformation_2010_05_15_min();
        model.paginators = require_cloudformation_2010_05_15_paginators().pagination;
        model.waiters = require_cloudformation_2010_05_15_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CloudFormation;
  }
});

// node_modules/aws-sdk/lib/cloudfront/signer.js
var require_signer = __commonJS({
  "node_modules/aws-sdk/lib/cloudfront/signer.js"(exports2, module2) {
    "use strict";
    var AWS2 = require_core();
    var url = AWS2.util.url;
    var crypto = AWS2.util.crypto.lib;
    var base64Encode = AWS2.util.base64.encode;
    var inherit = AWS2.util.inherit;
    var queryEncode = function(string) {
      var replacements = {
        "+": "-",
        "=": "_",
        "/": "~"
      };
      return string.replace(/[\+=\/]/g, function(match) {
        return replacements[match];
      });
    };
    var signPolicy = function(policy, privateKey) {
      var sign = crypto.createSign("RSA-SHA1");
      sign.write(policy);
      return queryEncode(sign.sign(privateKey, "base64"));
    };
    var signWithCannedPolicy = function(url2, expires, keyPairId, privateKey) {
      var policy = JSON.stringify({
        Statement: [
          {
            Resource: url2,
            Condition: { DateLessThan: { "AWS:EpochTime": expires } }
          }
        ]
      });
      return {
        Expires: expires,
        "Key-Pair-Id": keyPairId,
        Signature: signPolicy(policy.toString(), privateKey)
      };
    };
    var signWithCustomPolicy = function(policy, keyPairId, privateKey) {
      policy = policy.replace(/\s/mg, "");
      return {
        Policy: queryEncode(base64Encode(policy)),
        "Key-Pair-Id": keyPairId,
        Signature: signPolicy(policy, privateKey)
      };
    };
    var determineScheme = function(url2) {
      var parts = url2.split("://");
      if (parts.length < 2) {
        throw new Error("Invalid URL.");
      }
      return parts[0].replace("*", "");
    };
    var getRtmpUrl = function(rtmpUrl) {
      var parsed = url.parse(rtmpUrl);
      return parsed.path.replace(/^\//, "") + (parsed.hash || "");
    };
    var getResource = function(url2) {
      switch (determineScheme(url2)) {
        case "http":
        case "https":
          return url2;
        case "rtmp":
          return getRtmpUrl(url2);
        default:
          throw new Error("Invalid URI scheme. Scheme must be one of http, https, or rtmp");
      }
    };
    var handleError = function(err, callback) {
      if (!callback || typeof callback !== "function") {
        throw err;
      }
      callback(err);
    };
    var handleSuccess = function(result, callback) {
      if (!callback || typeof callback !== "function") {
        return result;
      }
      callback(null, result);
    };
    AWS2.CloudFront.Signer = inherit({
      /**
       * A signer object can be used to generate signed URLs and cookies for granting
       * access to content on restricted CloudFront distributions.
       *
       * @see http://docs.aws.amazon.com/AmazonCloudFront/latest/DeveloperGuide/PrivateContent.html
       *
       * @param keyPairId [String]    (Required) The ID of the CloudFront key pair
       *                              being used.
       * @param privateKey [String]   (Required) A private key in RSA format.
       */
      constructor: function Signer(keyPairId, privateKey) {
        if (keyPairId === void 0 || privateKey === void 0) {
          throw new Error("A key pair ID and private key are required");
        }
        this.keyPairId = keyPairId;
        this.privateKey = privateKey;
      },
      /**
       * Create a signed Amazon CloudFront Cookie.
       *
       * @param options [Object]            The options to create a signed cookie.
       * @option options url [String]     The URL to which the signature will grant
       *                                  access. Required unless you pass in a full
       *                                  policy.
       * @option options expires [Number] A Unix UTC timestamp indicating when the
       *                                  signature should expire. Required unless you
       *                                  pass in a full policy.
       * @option options policy [String]  A CloudFront JSON policy. Required unless
       *                                  you pass in a url and an expiry time.
       *
       * @param cb [Function] if a callback is provided, this function will
       *   pass the hash as the second parameter (after the error parameter) to
       *   the callback function.
       *
       * @return [Object] if called synchronously (with no callback), returns the
       *   signed cookie parameters.
       * @return [null] nothing is returned if a callback is provided.
       */
      getSignedCookie: function(options, cb) {
        var signatureHash = "policy" in options ? signWithCustomPolicy(options.policy, this.keyPairId, this.privateKey) : signWithCannedPolicy(options.url, options.expires, this.keyPairId, this.privateKey);
        var cookieHash = {};
        for (var key in signatureHash) {
          if (Object.prototype.hasOwnProperty.call(signatureHash, key)) {
            cookieHash["CloudFront-" + key] = signatureHash[key];
          }
        }
        return handleSuccess(cookieHash, cb);
      },
      /**
       * Create a signed Amazon CloudFront URL.
       *
       * Keep in mind that URLs meant for use in media/flash players may have
       * different requirements for URL formats (e.g. some require that the
       * extension be removed, some require the file name to be prefixed
       * - mp4:<path>, some require you to add "/cfx/st" into your URL).
       *
       * @param options [Object]          The options to create a signed URL.
       * @option options url [String]     The URL to which the signature will grant
       *                                  access. Any query params included with
       *                                  the URL should be encoded. Required.
       * @option options expires [Number] A Unix UTC timestamp indicating when the
       *                                  signature should expire. Required unless you
       *                                  pass in a full policy.
       * @option options policy [String]  A CloudFront JSON policy. Required unless
       *                                  you pass in a url and an expiry time.
       *
       * @param cb [Function] if a callback is provided, this function will
       *   pass the URL as the second parameter (after the error parameter) to
       *   the callback function.
       *
       * @return [String] if called synchronously (with no callback), returns the
       *   signed URL.
       * @return [null] nothing is returned if a callback is provided.
       */
      getSignedUrl: function(options, cb) {
        try {
          var resource = getResource(options.url);
        } catch (err) {
          return handleError(err, cb);
        }
        var parsedUrl = url.parse(options.url, true), signatureHash = Object.prototype.hasOwnProperty.call(options, "policy") ? signWithCustomPolicy(options.policy, this.keyPairId, this.privateKey) : signWithCannedPolicy(resource, options.expires, this.keyPairId, this.privateKey);
        parsedUrl.search = null;
        for (var key in signatureHash) {
          if (Object.prototype.hasOwnProperty.call(signatureHash, key)) {
            parsedUrl.query[key] = signatureHash[key];
          }
        }
        try {
          var signedUrl = determineScheme(options.url) === "rtmp" ? getRtmpUrl(url.format(parsedUrl)) : url.format(parsedUrl);
        } catch (err) {
          return handleError(err, cb);
        }
        return handleSuccess(signedUrl, cb);
      }
    });
    module2.exports = AWS2.CloudFront.Signer;
  }
});

// node_modules/aws-sdk/lib/services/cloudfront.js
var require_cloudfront = __commonJS({
  "node_modules/aws-sdk/lib/services/cloudfront.js"() {
    "use strict";
    var AWS2 = require_core();
    require_signer();
    AWS2.util.update(AWS2.CloudFront.prototype, {
      setupRequestListeners: function setupRequestListeners(request) {
        request.addListener("extractData", AWS2.util.hoistPayloadMember);
      }
    });
  }
});

// node_modules/aws-sdk/apis/cloudfront-2016-11-25.min.json
var require_cloudfront_2016_11_25_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2016-11-25.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-11-25",
        endpointPrefix: "cloudfront",
        globalEndpoint: "cloudfront.amazonaws.com",
        protocol: "rest-xml",
        serviceAbbreviation: "CloudFront",
        serviceFullName: "Amazon CloudFront",
        serviceId: "CloudFront",
        signatureVersion: "v4",
        uid: "cloudfront-2016-11-25"
      },
      operations: {
        CreateCloudFrontOriginAccessIdentity: {
          http: {
            requestUri: "/2016-11-25/origin-access-identity/cloudfront",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "CloudFrontOriginAccessIdentityConfig"
            ],
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2",
                locationName: "CloudFrontOriginAccessIdentityConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2016-11-25/"
                }
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        CreateDistribution: {
          http: {
            requestUri: "/2016-11-25/distribution",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfig"
            ],
            members: {
              DistributionConfig: {
                shape: "S7",
                locationName: "DistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2016-11-25/"
                }
              }
            },
            payload: "DistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1s"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        CreateDistributionWithTags: {
          http: {
            requestUri: "/2016-11-25/distribution?WithTags",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfigWithTags"
            ],
            members: {
              DistributionConfigWithTags: {
                locationName: "DistributionConfigWithTags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2016-11-25/"
                },
                type: "structure",
                required: [
                  "DistributionConfig",
                  "Tags"
                ],
                members: {
                  DistributionConfig: {
                    shape: "S7"
                  },
                  Tags: {
                    shape: "S21"
                  }
                }
              }
            },
            payload: "DistributionConfigWithTags"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1s"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        CreateInvalidation: {
          http: {
            requestUri: "/2016-11-25/distribution/{DistributionId}/invalidation",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionId",
              "InvalidationBatch"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              InvalidationBatch: {
                shape: "S28",
                locationName: "InvalidationBatch",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2016-11-25/"
                }
              }
            },
            payload: "InvalidationBatch"
          },
          output: {
            type: "structure",
            members: {
              Location: {
                location: "header",
                locationName: "Location"
              },
              Invalidation: {
                shape: "S2c"
              }
            },
            payload: "Invalidation"
          }
        },
        CreateStreamingDistribution: {
          http: {
            requestUri: "/2016-11-25/streaming-distribution",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfig"
            ],
            members: {
              StreamingDistributionConfig: {
                shape: "S2e",
                locationName: "StreamingDistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2016-11-25/"
                }
              }
            },
            payload: "StreamingDistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S2i"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        CreateStreamingDistributionWithTags: {
          http: {
            requestUri: "/2016-11-25/streaming-distribution?WithTags",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfigWithTags"
            ],
            members: {
              StreamingDistributionConfigWithTags: {
                locationName: "StreamingDistributionConfigWithTags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2016-11-25/"
                },
                type: "structure",
                required: [
                  "StreamingDistributionConfig",
                  "Tags"
                ],
                members: {
                  StreamingDistributionConfig: {
                    shape: "S2e"
                  },
                  Tags: {
                    shape: "S21"
                  }
                }
              }
            },
            payload: "StreamingDistributionConfigWithTags"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S2i"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        DeleteCloudFrontOriginAccessIdentity: {
          http: {
            method: "DELETE",
            requestUri: "/2016-11-25/origin-access-identity/cloudfront/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteDistribution: {
          http: {
            method: "DELETE",
            requestUri: "/2016-11-25/distribution/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteStreamingDistribution: {
          http: {
            method: "DELETE",
            requestUri: "/2016-11-25/streaming-distribution/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        GetCloudFrontOriginAccessIdentity: {
          http: {
            method: "GET",
            requestUri: "/2016-11-25/origin-access-identity/cloudfront/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        GetCloudFrontOriginAccessIdentityConfig: {
          http: {
            method: "GET",
            requestUri: "/2016-11-25/origin-access-identity/cloudfront/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          }
        },
        GetDistribution: {
          http: {
            method: "GET",
            requestUri: "/2016-11-25/distribution/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1s"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        GetDistributionConfig: {
          http: {
            method: "GET",
            requestUri: "/2016-11-25/distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionConfig: {
                shape: "S7"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "DistributionConfig"
          }
        },
        GetInvalidation: {
          http: {
            method: "GET",
            requestUri: "/2016-11-25/distribution/{DistributionId}/invalidation/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId",
              "Id"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Invalidation: {
                shape: "S2c"
              }
            },
            payload: "Invalidation"
          }
        },
        GetStreamingDistribution: {
          http: {
            method: "GET",
            requestUri: "/2016-11-25/streaming-distribution/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S2i"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        GetStreamingDistributionConfig: {
          http: {
            method: "GET",
            requestUri: "/2016-11-25/streaming-distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistributionConfig: {
                shape: "S2e"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistributionConfig"
          }
        },
        ListCloudFrontOriginAccessIdentities: {
          http: {
            method: "GET",
            requestUri: "/2016-11-25/origin-access-identity/cloudfront"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentityList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "CloudFrontOriginAccessIdentitySummary",
                      type: "structure",
                      required: [
                        "Id",
                        "S3CanonicalUserId",
                        "Comment"
                      ],
                      members: {
                        Id: {},
                        S3CanonicalUserId: {},
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "CloudFrontOriginAccessIdentityList"
          }
        },
        ListDistributions: {
          http: {
            method: "GET",
            requestUri: "/2016-11-25/distribution"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionList: {
                shape: "S3a"
              }
            },
            payload: "DistributionList"
          }
        },
        ListDistributionsByWebACLId: {
          http: {
            method: "GET",
            requestUri: "/2016-11-25/distributionsByWebACLId/{WebACLId}"
          },
          input: {
            type: "structure",
            required: [
              "WebACLId"
            ],
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              },
              WebACLId: {
                location: "uri",
                locationName: "WebACLId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionList: {
                shape: "S3a"
              }
            },
            payload: "DistributionList"
          }
        },
        ListInvalidations: {
          http: {
            method: "GET",
            requestUri: "/2016-11-25/distribution/{DistributionId}/invalidation"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InvalidationList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "InvalidationSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "CreateTime",
                        "Status"
                      ],
                      members: {
                        Id: {},
                        CreateTime: {
                          type: "timestamp"
                        },
                        Status: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "InvalidationList"
          }
        },
        ListStreamingDistributions: {
          http: {
            method: "GET",
            requestUri: "/2016-11-25/streaming-distribution"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistributionList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "StreamingDistributionSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "ARN",
                        "Status",
                        "LastModifiedTime",
                        "DomainName",
                        "S3Origin",
                        "Aliases",
                        "TrustedSigners",
                        "Comment",
                        "PriceClass",
                        "Enabled"
                      ],
                      members: {
                        Id: {},
                        ARN: {},
                        Status: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        DomainName: {},
                        S3Origin: {
                          shape: "S2f"
                        },
                        Aliases: {
                          shape: "S8"
                        },
                        TrustedSigners: {
                          shape: "Sy"
                        },
                        Comment: {},
                        PriceClass: {},
                        Enabled: {
                          type: "boolean"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "StreamingDistributionList"
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/2016-11-25/tagging"
          },
          input: {
            type: "structure",
            required: [
              "Resource"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "S21"
              }
            },
            payload: "Tags"
          }
        },
        TagResource: {
          http: {
            requestUri: "/2016-11-25/tagging?Operation=Tag",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "Tags"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              },
              Tags: {
                shape: "S21",
                locationName: "Tags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2016-11-25/"
                }
              }
            },
            payload: "Tags"
          }
        },
        UntagResource: {
          http: {
            requestUri: "/2016-11-25/tagging?Operation=Untag",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "TagKeys"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              },
              TagKeys: {
                locationName: "TagKeys",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2016-11-25/"
                },
                type: "structure",
                members: {
                  Items: {
                    type: "list",
                    member: {
                      locationName: "Key"
                    }
                  }
                }
              }
            },
            payload: "TagKeys"
          }
        },
        UpdateCloudFrontOriginAccessIdentity: {
          http: {
            method: "PUT",
            requestUri: "/2016-11-25/origin-access-identity/cloudfront/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "CloudFrontOriginAccessIdentityConfig",
              "Id"
            ],
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2",
                locationName: "CloudFrontOriginAccessIdentityConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2016-11-25/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        UpdateDistribution: {
          http: {
            method: "PUT",
            requestUri: "/2016-11-25/distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfig",
              "Id"
            ],
            members: {
              DistributionConfig: {
                shape: "S7",
                locationName: "DistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2016-11-25/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "DistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1s"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        UpdateStreamingDistribution: {
          http: {
            method: "PUT",
            requestUri: "/2016-11-25/streaming-distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfig",
              "Id"
            ],
            members: {
              StreamingDistributionConfig: {
                shape: "S2e",
                locationName: "StreamingDistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2016-11-25/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "StreamingDistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S2i"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          required: [
            "CallerReference",
            "Comment"
          ],
          members: {
            CallerReference: {},
            Comment: {}
          }
        },
        S5: {
          type: "structure",
          required: [
            "Id",
            "S3CanonicalUserId"
          ],
          members: {
            Id: {},
            S3CanonicalUserId: {},
            CloudFrontOriginAccessIdentityConfig: {
              shape: "S2"
            }
          }
        },
        S7: {
          type: "structure",
          required: [
            "CallerReference",
            "Origins",
            "DefaultCacheBehavior",
            "Comment",
            "Enabled"
          ],
          members: {
            CallerReference: {},
            Aliases: {
              shape: "S8"
            },
            DefaultRootObject: {},
            Origins: {
              shape: "Sb"
            },
            DefaultCacheBehavior: {
              shape: "Sn"
            },
            CacheBehaviors: {
              shape: "S1a"
            },
            CustomErrorResponses: {
              shape: "S1d"
            },
            Comment: {},
            Logging: {
              type: "structure",
              required: [
                "Enabled",
                "IncludeCookies",
                "Bucket",
                "Prefix"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                IncludeCookies: {
                  type: "boolean"
                },
                Bucket: {},
                Prefix: {}
              }
            },
            PriceClass: {},
            Enabled: {
              type: "boolean"
            },
            ViewerCertificate: {
              shape: "S1i"
            },
            Restrictions: {
              shape: "S1m"
            },
            WebACLId: {},
            HttpVersion: {},
            IsIPV6Enabled: {
              type: "boolean"
            }
          }
        },
        S8: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CNAME"
              }
            }
          }
        },
        Sb: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Origin",
                type: "structure",
                required: [
                  "Id",
                  "DomainName"
                ],
                members: {
                  Id: {},
                  DomainName: {},
                  OriginPath: {},
                  CustomHeaders: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "OriginCustomHeader",
                          type: "structure",
                          required: [
                            "HeaderName",
                            "HeaderValue"
                          ],
                          members: {
                            HeaderName: {},
                            HeaderValue: {}
                          }
                        }
                      }
                    }
                  },
                  S3OriginConfig: {
                    type: "structure",
                    required: [
                      "OriginAccessIdentity"
                    ],
                    members: {
                      OriginAccessIdentity: {}
                    }
                  },
                  CustomOriginConfig: {
                    type: "structure",
                    required: [
                      "HTTPPort",
                      "HTTPSPort",
                      "OriginProtocolPolicy"
                    ],
                    members: {
                      HTTPPort: {
                        type: "integer"
                      },
                      HTTPSPort: {
                        type: "integer"
                      },
                      OriginProtocolPolicy: {},
                      OriginSslProtocols: {
                        type: "structure",
                        required: [
                          "Quantity",
                          "Items"
                        ],
                        members: {
                          Quantity: {
                            type: "integer"
                          },
                          Items: {
                            type: "list",
                            member: {
                              locationName: "SslProtocol"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sn: {
          type: "structure",
          required: [
            "TargetOriginId",
            "ForwardedValues",
            "TrustedSigners",
            "ViewerProtocolPolicy",
            "MinTTL"
          ],
          members: {
            TargetOriginId: {},
            ForwardedValues: {
              shape: "So"
            },
            TrustedSigners: {
              shape: "Sy"
            },
            ViewerProtocolPolicy: {},
            MinTTL: {
              type: "long"
            },
            AllowedMethods: {
              shape: "S12"
            },
            SmoothStreaming: {
              type: "boolean"
            },
            DefaultTTL: {
              type: "long"
            },
            MaxTTL: {
              type: "long"
            },
            Compress: {
              type: "boolean"
            },
            LambdaFunctionAssociations: {
              shape: "S16"
            }
          }
        },
        So: {
          type: "structure",
          required: [
            "QueryString",
            "Cookies"
          ],
          members: {
            QueryString: {
              type: "boolean"
            },
            Cookies: {
              type: "structure",
              required: [
                "Forward"
              ],
              members: {
                Forward: {},
                WhitelistedNames: {
                  type: "structure",
                  required: [
                    "Quantity"
                  ],
                  members: {
                    Quantity: {
                      type: "integer"
                    },
                    Items: {
                      type: "list",
                      member: {
                        locationName: "Name"
                      }
                    }
                  }
                }
              }
            },
            Headers: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Name"
                  }
                }
              }
            },
            QueryStringCacheKeys: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Name"
                  }
                }
              }
            }
          }
        },
        Sy: {
          type: "structure",
          required: [
            "Enabled",
            "Quantity"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "AwsAccountNumber"
              }
            }
          }
        },
        S12: {
          type: "structure",
          required: [
            "Quantity",
            "Items"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              shape: "S13"
            },
            CachedMethods: {
              type: "structure",
              required: [
                "Quantity",
                "Items"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  shape: "S13"
                }
              }
            }
          }
        },
        S13: {
          type: "list",
          member: {
            locationName: "Method"
          }
        },
        S16: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "LambdaFunctionAssociation",
                type: "structure",
                members: {
                  LambdaFunctionARN: {},
                  EventType: {}
                }
              }
            }
          }
        },
        S1a: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CacheBehavior",
                type: "structure",
                required: [
                  "PathPattern",
                  "TargetOriginId",
                  "ForwardedValues",
                  "TrustedSigners",
                  "ViewerProtocolPolicy",
                  "MinTTL"
                ],
                members: {
                  PathPattern: {},
                  TargetOriginId: {},
                  ForwardedValues: {
                    shape: "So"
                  },
                  TrustedSigners: {
                    shape: "Sy"
                  },
                  ViewerProtocolPolicy: {},
                  MinTTL: {
                    type: "long"
                  },
                  AllowedMethods: {
                    shape: "S12"
                  },
                  SmoothStreaming: {
                    type: "boolean"
                  },
                  DefaultTTL: {
                    type: "long"
                  },
                  MaxTTL: {
                    type: "long"
                  },
                  Compress: {
                    type: "boolean"
                  },
                  LambdaFunctionAssociations: {
                    shape: "S16"
                  }
                }
              }
            }
          }
        },
        S1d: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CustomErrorResponse",
                type: "structure",
                required: [
                  "ErrorCode"
                ],
                members: {
                  ErrorCode: {
                    type: "integer"
                  },
                  ResponsePagePath: {},
                  ResponseCode: {},
                  ErrorCachingMinTTL: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        S1i: {
          type: "structure",
          members: {
            CloudFrontDefaultCertificate: {
              type: "boolean"
            },
            IAMCertificateId: {},
            ACMCertificateArn: {},
            SSLSupportMethod: {},
            MinimumProtocolVersion: {},
            Certificate: {
              deprecated: true
            },
            CertificateSource: {
              deprecated: true
            }
          }
        },
        S1m: {
          type: "structure",
          required: [
            "GeoRestriction"
          ],
          members: {
            GeoRestriction: {
              type: "structure",
              required: [
                "RestrictionType",
                "Quantity"
              ],
              members: {
                RestrictionType: {},
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Location"
                  }
                }
              }
            }
          }
        },
        S1s: {
          type: "structure",
          required: [
            "Id",
            "ARN",
            "Status",
            "LastModifiedTime",
            "InProgressInvalidationBatches",
            "DomainName",
            "ActiveTrustedSigners",
            "DistributionConfig"
          ],
          members: {
            Id: {},
            ARN: {},
            Status: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            InProgressInvalidationBatches: {
              type: "integer"
            },
            DomainName: {},
            ActiveTrustedSigners: {
              shape: "S1u"
            },
            DistributionConfig: {
              shape: "S7"
            }
          }
        },
        S1u: {
          type: "structure",
          required: [
            "Enabled",
            "Quantity"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Signer",
                type: "structure",
                members: {
                  AwsAccountNumber: {},
                  KeyPairIds: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "KeyPairId"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S21: {
          type: "structure",
          members: {
            Items: {
              type: "list",
              member: {
                locationName: "Tag",
                type: "structure",
                required: [
                  "Key"
                ],
                members: {
                  Key: {},
                  Value: {}
                }
              }
            }
          }
        },
        S28: {
          type: "structure",
          required: [
            "Paths",
            "CallerReference"
          ],
          members: {
            Paths: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Path"
                  }
                }
              }
            },
            CallerReference: {}
          }
        },
        S2c: {
          type: "structure",
          required: [
            "Id",
            "Status",
            "CreateTime",
            "InvalidationBatch"
          ],
          members: {
            Id: {},
            Status: {},
            CreateTime: {
              type: "timestamp"
            },
            InvalidationBatch: {
              shape: "S28"
            }
          }
        },
        S2e: {
          type: "structure",
          required: [
            "CallerReference",
            "S3Origin",
            "Comment",
            "TrustedSigners",
            "Enabled"
          ],
          members: {
            CallerReference: {},
            S3Origin: {
              shape: "S2f"
            },
            Aliases: {
              shape: "S8"
            },
            Comment: {},
            Logging: {
              type: "structure",
              required: [
                "Enabled",
                "Bucket",
                "Prefix"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                Bucket: {},
                Prefix: {}
              }
            },
            TrustedSigners: {
              shape: "Sy"
            },
            PriceClass: {},
            Enabled: {
              type: "boolean"
            }
          }
        },
        S2f: {
          type: "structure",
          required: [
            "DomainName",
            "OriginAccessIdentity"
          ],
          members: {
            DomainName: {},
            OriginAccessIdentity: {}
          }
        },
        S2i: {
          type: "structure",
          required: [
            "Id",
            "ARN",
            "Status",
            "DomainName",
            "ActiveTrustedSigners",
            "StreamingDistributionConfig"
          ],
          members: {
            Id: {},
            ARN: {},
            Status: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            DomainName: {},
            ActiveTrustedSigners: {
              shape: "S1u"
            },
            StreamingDistributionConfig: {
              shape: "S2e"
            }
          }
        },
        S3a: {
          type: "structure",
          required: [
            "Marker",
            "MaxItems",
            "IsTruncated",
            "Quantity"
          ],
          members: {
            Marker: {},
            NextMarker: {},
            MaxItems: {
              type: "integer"
            },
            IsTruncated: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "DistributionSummary",
                type: "structure",
                required: [
                  "Id",
                  "ARN",
                  "Status",
                  "LastModifiedTime",
                  "DomainName",
                  "Aliases",
                  "Origins",
                  "DefaultCacheBehavior",
                  "CacheBehaviors",
                  "CustomErrorResponses",
                  "Comment",
                  "PriceClass",
                  "Enabled",
                  "ViewerCertificate",
                  "Restrictions",
                  "WebACLId",
                  "HttpVersion",
                  "IsIPV6Enabled"
                ],
                members: {
                  Id: {},
                  ARN: {},
                  Status: {},
                  LastModifiedTime: {
                    type: "timestamp"
                  },
                  DomainName: {},
                  Aliases: {
                    shape: "S8"
                  },
                  Origins: {
                    shape: "Sb"
                  },
                  DefaultCacheBehavior: {
                    shape: "Sn"
                  },
                  CacheBehaviors: {
                    shape: "S1a"
                  },
                  CustomErrorResponses: {
                    shape: "S1d"
                  },
                  Comment: {},
                  PriceClass: {},
                  Enabled: {
                    type: "boolean"
                  },
                  ViewerCertificate: {
                    shape: "S1i"
                  },
                  Restrictions: {
                    shape: "S1m"
                  },
                  WebACLId: {},
                  HttpVersion: {},
                  IsIPV6Enabled: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2016-11-25.paginators.json
var require_cloudfront_2016_11_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2016-11-25.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListCloudFrontOriginAccessIdentities: {
          input_token: "Marker",
          output_token: "CloudFrontOriginAccessIdentityList.NextMarker",
          limit_key: "MaxItems",
          more_results: "CloudFrontOriginAccessIdentityList.IsTruncated",
          result_key: "CloudFrontOriginAccessIdentityList.Items"
        },
        ListDistributions: {
          input_token: "Marker",
          output_token: "DistributionList.NextMarker",
          limit_key: "MaxItems",
          more_results: "DistributionList.IsTruncated",
          result_key: "DistributionList.Items"
        },
        ListInvalidations: {
          input_token: "Marker",
          output_token: "InvalidationList.NextMarker",
          limit_key: "MaxItems",
          more_results: "InvalidationList.IsTruncated",
          result_key: "InvalidationList.Items"
        },
        ListStreamingDistributions: {
          input_token: "Marker",
          output_token: "StreamingDistributionList.NextMarker",
          limit_key: "MaxItems",
          more_results: "StreamingDistributionList.IsTruncated",
          result_key: "StreamingDistributionList.Items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2016-11-25.waiters2.json
var require_cloudfront_2016_11_25_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2016-11-25.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        DistributionDeployed: {
          delay: 60,
          operation: "GetDistribution",
          maxAttempts: 25,
          description: "Wait until a distribution is deployed.",
          acceptors: [
            {
              expected: "Deployed",
              matcher: "path",
              state: "success",
              argument: "Distribution.Status"
            }
          ]
        },
        InvalidationCompleted: {
          delay: 20,
          operation: "GetInvalidation",
          maxAttempts: 30,
          description: "Wait until an invalidation has completed.",
          acceptors: [
            {
              expected: "Completed",
              matcher: "path",
              state: "success",
              argument: "Invalidation.Status"
            }
          ]
        },
        StreamingDistributionDeployed: {
          delay: 60,
          operation: "GetStreamingDistribution",
          maxAttempts: 25,
          description: "Wait until a streaming distribution is deployed.",
          acceptors: [
            {
              expected: "Deployed",
              matcher: "path",
              state: "success",
              argument: "StreamingDistribution.Status"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2017-03-25.min.json
var require_cloudfront_2017_03_25_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2017-03-25.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-03-25",
        endpointPrefix: "cloudfront",
        globalEndpoint: "cloudfront.amazonaws.com",
        protocol: "rest-xml",
        serviceAbbreviation: "CloudFront",
        serviceFullName: "Amazon CloudFront",
        serviceId: "CloudFront",
        signatureVersion: "v4",
        uid: "cloudfront-2017-03-25"
      },
      operations: {
        CreateCloudFrontOriginAccessIdentity: {
          http: {
            requestUri: "/2017-03-25/origin-access-identity/cloudfront",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "CloudFrontOriginAccessIdentityConfig"
            ],
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2",
                locationName: "CloudFrontOriginAccessIdentityConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-03-25/"
                }
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        CreateDistribution: {
          http: {
            requestUri: "/2017-03-25/distribution",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfig"
            ],
            members: {
              DistributionConfig: {
                shape: "S7",
                locationName: "DistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-03-25/"
                }
              }
            },
            payload: "DistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1s"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        CreateDistributionWithTags: {
          http: {
            requestUri: "/2017-03-25/distribution?WithTags",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfigWithTags"
            ],
            members: {
              DistributionConfigWithTags: {
                locationName: "DistributionConfigWithTags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-03-25/"
                },
                type: "structure",
                required: [
                  "DistributionConfig",
                  "Tags"
                ],
                members: {
                  DistributionConfig: {
                    shape: "S7"
                  },
                  Tags: {
                    shape: "S21"
                  }
                }
              }
            },
            payload: "DistributionConfigWithTags"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1s"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        CreateInvalidation: {
          http: {
            requestUri: "/2017-03-25/distribution/{DistributionId}/invalidation",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionId",
              "InvalidationBatch"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              InvalidationBatch: {
                shape: "S28",
                locationName: "InvalidationBatch",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-03-25/"
                }
              }
            },
            payload: "InvalidationBatch"
          },
          output: {
            type: "structure",
            members: {
              Location: {
                location: "header",
                locationName: "Location"
              },
              Invalidation: {
                shape: "S2c"
              }
            },
            payload: "Invalidation"
          }
        },
        CreateStreamingDistribution: {
          http: {
            requestUri: "/2017-03-25/streaming-distribution",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfig"
            ],
            members: {
              StreamingDistributionConfig: {
                shape: "S2e",
                locationName: "StreamingDistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-03-25/"
                }
              }
            },
            payload: "StreamingDistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S2i"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        CreateStreamingDistributionWithTags: {
          http: {
            requestUri: "/2017-03-25/streaming-distribution?WithTags",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfigWithTags"
            ],
            members: {
              StreamingDistributionConfigWithTags: {
                locationName: "StreamingDistributionConfigWithTags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-03-25/"
                },
                type: "structure",
                required: [
                  "StreamingDistributionConfig",
                  "Tags"
                ],
                members: {
                  StreamingDistributionConfig: {
                    shape: "S2e"
                  },
                  Tags: {
                    shape: "S21"
                  }
                }
              }
            },
            payload: "StreamingDistributionConfigWithTags"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S2i"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        DeleteCloudFrontOriginAccessIdentity: {
          http: {
            method: "DELETE",
            requestUri: "/2017-03-25/origin-access-identity/cloudfront/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteDistribution: {
          http: {
            method: "DELETE",
            requestUri: "/2017-03-25/distribution/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteServiceLinkedRole: {
          http: {
            method: "DELETE",
            requestUri: "/2017-03-25/service-linked-role/{RoleName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "RoleName"
            ],
            members: {
              RoleName: {
                location: "uri",
                locationName: "RoleName"
              }
            }
          }
        },
        DeleteStreamingDistribution: {
          http: {
            method: "DELETE",
            requestUri: "/2017-03-25/streaming-distribution/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        GetCloudFrontOriginAccessIdentity: {
          http: {
            method: "GET",
            requestUri: "/2017-03-25/origin-access-identity/cloudfront/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        GetCloudFrontOriginAccessIdentityConfig: {
          http: {
            method: "GET",
            requestUri: "/2017-03-25/origin-access-identity/cloudfront/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          }
        },
        GetDistribution: {
          http: {
            method: "GET",
            requestUri: "/2017-03-25/distribution/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1s"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        GetDistributionConfig: {
          http: {
            method: "GET",
            requestUri: "/2017-03-25/distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionConfig: {
                shape: "S7"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "DistributionConfig"
          }
        },
        GetInvalidation: {
          http: {
            method: "GET",
            requestUri: "/2017-03-25/distribution/{DistributionId}/invalidation/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId",
              "Id"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Invalidation: {
                shape: "S2c"
              }
            },
            payload: "Invalidation"
          }
        },
        GetStreamingDistribution: {
          http: {
            method: "GET",
            requestUri: "/2017-03-25/streaming-distribution/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S2i"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        GetStreamingDistributionConfig: {
          http: {
            method: "GET",
            requestUri: "/2017-03-25/streaming-distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistributionConfig: {
                shape: "S2e"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistributionConfig"
          }
        },
        ListCloudFrontOriginAccessIdentities: {
          http: {
            method: "GET",
            requestUri: "/2017-03-25/origin-access-identity/cloudfront"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentityList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "CloudFrontOriginAccessIdentitySummary",
                      type: "structure",
                      required: [
                        "Id",
                        "S3CanonicalUserId",
                        "Comment"
                      ],
                      members: {
                        Id: {},
                        S3CanonicalUserId: {},
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "CloudFrontOriginAccessIdentityList"
          }
        },
        ListDistributions: {
          http: {
            method: "GET",
            requestUri: "/2017-03-25/distribution"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionList: {
                shape: "S3b"
              }
            },
            payload: "DistributionList"
          }
        },
        ListDistributionsByWebACLId: {
          http: {
            method: "GET",
            requestUri: "/2017-03-25/distributionsByWebACLId/{WebACLId}"
          },
          input: {
            type: "structure",
            required: [
              "WebACLId"
            ],
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              },
              WebACLId: {
                location: "uri",
                locationName: "WebACLId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionList: {
                shape: "S3b"
              }
            },
            payload: "DistributionList"
          }
        },
        ListInvalidations: {
          http: {
            method: "GET",
            requestUri: "/2017-03-25/distribution/{DistributionId}/invalidation"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InvalidationList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "InvalidationSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "CreateTime",
                        "Status"
                      ],
                      members: {
                        Id: {},
                        CreateTime: {
                          type: "timestamp"
                        },
                        Status: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "InvalidationList"
          }
        },
        ListStreamingDistributions: {
          http: {
            method: "GET",
            requestUri: "/2017-03-25/streaming-distribution"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistributionList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "StreamingDistributionSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "ARN",
                        "Status",
                        "LastModifiedTime",
                        "DomainName",
                        "S3Origin",
                        "Aliases",
                        "TrustedSigners",
                        "Comment",
                        "PriceClass",
                        "Enabled"
                      ],
                      members: {
                        Id: {},
                        ARN: {},
                        Status: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        DomainName: {},
                        S3Origin: {
                          shape: "S2f"
                        },
                        Aliases: {
                          shape: "S8"
                        },
                        TrustedSigners: {
                          shape: "Sy"
                        },
                        Comment: {},
                        PriceClass: {},
                        Enabled: {
                          type: "boolean"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "StreamingDistributionList"
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/2017-03-25/tagging"
          },
          input: {
            type: "structure",
            required: [
              "Resource"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "S21"
              }
            },
            payload: "Tags"
          }
        },
        TagResource: {
          http: {
            requestUri: "/2017-03-25/tagging?Operation=Tag",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "Tags"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              },
              Tags: {
                shape: "S21",
                locationName: "Tags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-03-25/"
                }
              }
            },
            payload: "Tags"
          }
        },
        UntagResource: {
          http: {
            requestUri: "/2017-03-25/tagging?Operation=Untag",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "TagKeys"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              },
              TagKeys: {
                locationName: "TagKeys",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-03-25/"
                },
                type: "structure",
                members: {
                  Items: {
                    type: "list",
                    member: {
                      locationName: "Key"
                    }
                  }
                }
              }
            },
            payload: "TagKeys"
          }
        },
        UpdateCloudFrontOriginAccessIdentity: {
          http: {
            method: "PUT",
            requestUri: "/2017-03-25/origin-access-identity/cloudfront/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "CloudFrontOriginAccessIdentityConfig",
              "Id"
            ],
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2",
                locationName: "CloudFrontOriginAccessIdentityConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-03-25/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        UpdateDistribution: {
          http: {
            method: "PUT",
            requestUri: "/2017-03-25/distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfig",
              "Id"
            ],
            members: {
              DistributionConfig: {
                shape: "S7",
                locationName: "DistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-03-25/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "DistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1s"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        UpdateStreamingDistribution: {
          http: {
            method: "PUT",
            requestUri: "/2017-03-25/streaming-distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfig",
              "Id"
            ],
            members: {
              StreamingDistributionConfig: {
                shape: "S2e",
                locationName: "StreamingDistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-03-25/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "StreamingDistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S2i"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          required: [
            "CallerReference",
            "Comment"
          ],
          members: {
            CallerReference: {},
            Comment: {}
          }
        },
        S5: {
          type: "structure",
          required: [
            "Id",
            "S3CanonicalUserId"
          ],
          members: {
            Id: {},
            S3CanonicalUserId: {},
            CloudFrontOriginAccessIdentityConfig: {
              shape: "S2"
            }
          }
        },
        S7: {
          type: "structure",
          required: [
            "CallerReference",
            "Origins",
            "DefaultCacheBehavior",
            "Comment",
            "Enabled"
          ],
          members: {
            CallerReference: {},
            Aliases: {
              shape: "S8"
            },
            DefaultRootObject: {},
            Origins: {
              shape: "Sb"
            },
            DefaultCacheBehavior: {
              shape: "Sn"
            },
            CacheBehaviors: {
              shape: "S1a"
            },
            CustomErrorResponses: {
              shape: "S1d"
            },
            Comment: {},
            Logging: {
              type: "structure",
              required: [
                "Enabled",
                "IncludeCookies",
                "Bucket",
                "Prefix"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                IncludeCookies: {
                  type: "boolean"
                },
                Bucket: {},
                Prefix: {}
              }
            },
            PriceClass: {},
            Enabled: {
              type: "boolean"
            },
            ViewerCertificate: {
              shape: "S1i"
            },
            Restrictions: {
              shape: "S1m"
            },
            WebACLId: {},
            HttpVersion: {},
            IsIPV6Enabled: {
              type: "boolean"
            }
          }
        },
        S8: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CNAME"
              }
            }
          }
        },
        Sb: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Origin",
                type: "structure",
                required: [
                  "Id",
                  "DomainName"
                ],
                members: {
                  Id: {},
                  DomainName: {},
                  OriginPath: {},
                  CustomHeaders: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "OriginCustomHeader",
                          type: "structure",
                          required: [
                            "HeaderName",
                            "HeaderValue"
                          ],
                          members: {
                            HeaderName: {},
                            HeaderValue: {}
                          }
                        }
                      }
                    }
                  },
                  S3OriginConfig: {
                    type: "structure",
                    required: [
                      "OriginAccessIdentity"
                    ],
                    members: {
                      OriginAccessIdentity: {}
                    }
                  },
                  CustomOriginConfig: {
                    type: "structure",
                    required: [
                      "HTTPPort",
                      "HTTPSPort",
                      "OriginProtocolPolicy"
                    ],
                    members: {
                      HTTPPort: {
                        type: "integer"
                      },
                      HTTPSPort: {
                        type: "integer"
                      },
                      OriginProtocolPolicy: {},
                      OriginSslProtocols: {
                        type: "structure",
                        required: [
                          "Quantity",
                          "Items"
                        ],
                        members: {
                          Quantity: {
                            type: "integer"
                          },
                          Items: {
                            type: "list",
                            member: {
                              locationName: "SslProtocol"
                            }
                          }
                        }
                      },
                      OriginReadTimeout: {
                        type: "integer"
                      },
                      OriginKeepaliveTimeout: {
                        type: "integer"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sn: {
          type: "structure",
          required: [
            "TargetOriginId",
            "ForwardedValues",
            "TrustedSigners",
            "ViewerProtocolPolicy",
            "MinTTL"
          ],
          members: {
            TargetOriginId: {},
            ForwardedValues: {
              shape: "So"
            },
            TrustedSigners: {
              shape: "Sy"
            },
            ViewerProtocolPolicy: {},
            MinTTL: {
              type: "long"
            },
            AllowedMethods: {
              shape: "S12"
            },
            SmoothStreaming: {
              type: "boolean"
            },
            DefaultTTL: {
              type: "long"
            },
            MaxTTL: {
              type: "long"
            },
            Compress: {
              type: "boolean"
            },
            LambdaFunctionAssociations: {
              shape: "S16"
            }
          }
        },
        So: {
          type: "structure",
          required: [
            "QueryString",
            "Cookies"
          ],
          members: {
            QueryString: {
              type: "boolean"
            },
            Cookies: {
              type: "structure",
              required: [
                "Forward"
              ],
              members: {
                Forward: {},
                WhitelistedNames: {
                  type: "structure",
                  required: [
                    "Quantity"
                  ],
                  members: {
                    Quantity: {
                      type: "integer"
                    },
                    Items: {
                      type: "list",
                      member: {
                        locationName: "Name"
                      }
                    }
                  }
                }
              }
            },
            Headers: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Name"
                  }
                }
              }
            },
            QueryStringCacheKeys: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Name"
                  }
                }
              }
            }
          }
        },
        Sy: {
          type: "structure",
          required: [
            "Enabled",
            "Quantity"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "AwsAccountNumber"
              }
            }
          }
        },
        S12: {
          type: "structure",
          required: [
            "Quantity",
            "Items"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              shape: "S13"
            },
            CachedMethods: {
              type: "structure",
              required: [
                "Quantity",
                "Items"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  shape: "S13"
                }
              }
            }
          }
        },
        S13: {
          type: "list",
          member: {
            locationName: "Method"
          }
        },
        S16: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "LambdaFunctionAssociation",
                type: "structure",
                members: {
                  LambdaFunctionARN: {},
                  EventType: {}
                }
              }
            }
          }
        },
        S1a: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CacheBehavior",
                type: "structure",
                required: [
                  "PathPattern",
                  "TargetOriginId",
                  "ForwardedValues",
                  "TrustedSigners",
                  "ViewerProtocolPolicy",
                  "MinTTL"
                ],
                members: {
                  PathPattern: {},
                  TargetOriginId: {},
                  ForwardedValues: {
                    shape: "So"
                  },
                  TrustedSigners: {
                    shape: "Sy"
                  },
                  ViewerProtocolPolicy: {},
                  MinTTL: {
                    type: "long"
                  },
                  AllowedMethods: {
                    shape: "S12"
                  },
                  SmoothStreaming: {
                    type: "boolean"
                  },
                  DefaultTTL: {
                    type: "long"
                  },
                  MaxTTL: {
                    type: "long"
                  },
                  Compress: {
                    type: "boolean"
                  },
                  LambdaFunctionAssociations: {
                    shape: "S16"
                  }
                }
              }
            }
          }
        },
        S1d: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CustomErrorResponse",
                type: "structure",
                required: [
                  "ErrorCode"
                ],
                members: {
                  ErrorCode: {
                    type: "integer"
                  },
                  ResponsePagePath: {},
                  ResponseCode: {},
                  ErrorCachingMinTTL: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        S1i: {
          type: "structure",
          members: {
            CloudFrontDefaultCertificate: {
              type: "boolean"
            },
            IAMCertificateId: {},
            ACMCertificateArn: {},
            SSLSupportMethod: {},
            MinimumProtocolVersion: {},
            Certificate: {
              deprecated: true
            },
            CertificateSource: {
              deprecated: true
            }
          }
        },
        S1m: {
          type: "structure",
          required: [
            "GeoRestriction"
          ],
          members: {
            GeoRestriction: {
              type: "structure",
              required: [
                "RestrictionType",
                "Quantity"
              ],
              members: {
                RestrictionType: {},
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Location"
                  }
                }
              }
            }
          }
        },
        S1s: {
          type: "structure",
          required: [
            "Id",
            "ARN",
            "Status",
            "LastModifiedTime",
            "InProgressInvalidationBatches",
            "DomainName",
            "ActiveTrustedSigners",
            "DistributionConfig"
          ],
          members: {
            Id: {},
            ARN: {},
            Status: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            InProgressInvalidationBatches: {
              type: "integer"
            },
            DomainName: {},
            ActiveTrustedSigners: {
              shape: "S1u"
            },
            DistributionConfig: {
              shape: "S7"
            }
          }
        },
        S1u: {
          type: "structure",
          required: [
            "Enabled",
            "Quantity"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Signer",
                type: "structure",
                members: {
                  AwsAccountNumber: {},
                  KeyPairIds: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "KeyPairId"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S21: {
          type: "structure",
          members: {
            Items: {
              type: "list",
              member: {
                locationName: "Tag",
                type: "structure",
                required: [
                  "Key"
                ],
                members: {
                  Key: {},
                  Value: {}
                }
              }
            }
          }
        },
        S28: {
          type: "structure",
          required: [
            "Paths",
            "CallerReference"
          ],
          members: {
            Paths: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Path"
                  }
                }
              }
            },
            CallerReference: {}
          }
        },
        S2c: {
          type: "structure",
          required: [
            "Id",
            "Status",
            "CreateTime",
            "InvalidationBatch"
          ],
          members: {
            Id: {},
            Status: {},
            CreateTime: {
              type: "timestamp"
            },
            InvalidationBatch: {
              shape: "S28"
            }
          }
        },
        S2e: {
          type: "structure",
          required: [
            "CallerReference",
            "S3Origin",
            "Comment",
            "TrustedSigners",
            "Enabled"
          ],
          members: {
            CallerReference: {},
            S3Origin: {
              shape: "S2f"
            },
            Aliases: {
              shape: "S8"
            },
            Comment: {},
            Logging: {
              type: "structure",
              required: [
                "Enabled",
                "Bucket",
                "Prefix"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                Bucket: {},
                Prefix: {}
              }
            },
            TrustedSigners: {
              shape: "Sy"
            },
            PriceClass: {},
            Enabled: {
              type: "boolean"
            }
          }
        },
        S2f: {
          type: "structure",
          required: [
            "DomainName",
            "OriginAccessIdentity"
          ],
          members: {
            DomainName: {},
            OriginAccessIdentity: {}
          }
        },
        S2i: {
          type: "structure",
          required: [
            "Id",
            "ARN",
            "Status",
            "DomainName",
            "ActiveTrustedSigners",
            "StreamingDistributionConfig"
          ],
          members: {
            Id: {},
            ARN: {},
            Status: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            DomainName: {},
            ActiveTrustedSigners: {
              shape: "S1u"
            },
            StreamingDistributionConfig: {
              shape: "S2e"
            }
          }
        },
        S3b: {
          type: "structure",
          required: [
            "Marker",
            "MaxItems",
            "IsTruncated",
            "Quantity"
          ],
          members: {
            Marker: {},
            NextMarker: {},
            MaxItems: {
              type: "integer"
            },
            IsTruncated: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "DistributionSummary",
                type: "structure",
                required: [
                  "Id",
                  "ARN",
                  "Status",
                  "LastModifiedTime",
                  "DomainName",
                  "Aliases",
                  "Origins",
                  "DefaultCacheBehavior",
                  "CacheBehaviors",
                  "CustomErrorResponses",
                  "Comment",
                  "PriceClass",
                  "Enabled",
                  "ViewerCertificate",
                  "Restrictions",
                  "WebACLId",
                  "HttpVersion",
                  "IsIPV6Enabled"
                ],
                members: {
                  Id: {},
                  ARN: {},
                  Status: {},
                  LastModifiedTime: {
                    type: "timestamp"
                  },
                  DomainName: {},
                  Aliases: {
                    shape: "S8"
                  },
                  Origins: {
                    shape: "Sb"
                  },
                  DefaultCacheBehavior: {
                    shape: "Sn"
                  },
                  CacheBehaviors: {
                    shape: "S1a"
                  },
                  CustomErrorResponses: {
                    shape: "S1d"
                  },
                  Comment: {},
                  PriceClass: {},
                  Enabled: {
                    type: "boolean"
                  },
                  ViewerCertificate: {
                    shape: "S1i"
                  },
                  Restrictions: {
                    shape: "S1m"
                  },
                  WebACLId: {},
                  HttpVersion: {},
                  IsIPV6Enabled: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2017-03-25.paginators.json
var require_cloudfront_2017_03_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2017-03-25.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListCloudFrontOriginAccessIdentities: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "CloudFrontOriginAccessIdentityList.IsTruncated",
          output_token: "CloudFrontOriginAccessIdentityList.NextMarker",
          result_key: "CloudFrontOriginAccessIdentityList.Items"
        },
        ListDistributions: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "DistributionList.IsTruncated",
          output_token: "DistributionList.NextMarker",
          result_key: "DistributionList.Items"
        },
        ListInvalidations: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "InvalidationList.IsTruncated",
          output_token: "InvalidationList.NextMarker",
          result_key: "InvalidationList.Items"
        },
        ListStreamingDistributions: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "StreamingDistributionList.IsTruncated",
          output_token: "StreamingDistributionList.NextMarker",
          result_key: "StreamingDistributionList.Items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2017-03-25.waiters2.json
var require_cloudfront_2017_03_25_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2017-03-25.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        DistributionDeployed: {
          delay: 60,
          operation: "GetDistribution",
          maxAttempts: 25,
          description: "Wait until a distribution is deployed.",
          acceptors: [
            {
              expected: "Deployed",
              matcher: "path",
              state: "success",
              argument: "Distribution.Status"
            }
          ]
        },
        InvalidationCompleted: {
          delay: 20,
          operation: "GetInvalidation",
          maxAttempts: 30,
          description: "Wait until an invalidation has completed.",
          acceptors: [
            {
              expected: "Completed",
              matcher: "path",
              state: "success",
              argument: "Invalidation.Status"
            }
          ]
        },
        StreamingDistributionDeployed: {
          delay: 60,
          operation: "GetStreamingDistribution",
          maxAttempts: 25,
          description: "Wait until a streaming distribution is deployed.",
          acceptors: [
            {
              expected: "Deployed",
              matcher: "path",
              state: "success",
              argument: "StreamingDistribution.Status"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2017-10-30.min.json
var require_cloudfront_2017_10_30_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2017-10-30.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-10-30",
        endpointPrefix: "cloudfront",
        globalEndpoint: "cloudfront.amazonaws.com",
        protocol: "rest-xml",
        serviceAbbreviation: "CloudFront",
        serviceFullName: "Amazon CloudFront",
        serviceId: "CloudFront",
        signatureVersion: "v4",
        uid: "cloudfront-2017-10-30"
      },
      operations: {
        CreateCloudFrontOriginAccessIdentity: {
          http: {
            requestUri: "/2017-10-30/origin-access-identity/cloudfront",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "CloudFrontOriginAccessIdentityConfig"
            ],
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2",
                locationName: "CloudFrontOriginAccessIdentityConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                }
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        CreateDistribution: {
          http: {
            requestUri: "/2017-10-30/distribution",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfig"
            ],
            members: {
              DistributionConfig: {
                shape: "S7",
                locationName: "DistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                }
              }
            },
            payload: "DistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1t"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        CreateDistributionWithTags: {
          http: {
            requestUri: "/2017-10-30/distribution?WithTags",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfigWithTags"
            ],
            members: {
              DistributionConfigWithTags: {
                locationName: "DistributionConfigWithTags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                },
                type: "structure",
                required: [
                  "DistributionConfig",
                  "Tags"
                ],
                members: {
                  DistributionConfig: {
                    shape: "S7"
                  },
                  Tags: {
                    shape: "S22"
                  }
                }
              }
            },
            payload: "DistributionConfigWithTags"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1t"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        CreateFieldLevelEncryptionConfig: {
          http: {
            requestUri: "/2017-10-30/field-level-encryption",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionConfig"
            ],
            members: {
              FieldLevelEncryptionConfig: {
                shape: "S29",
                locationName: "FieldLevelEncryptionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                }
              }
            },
            payload: "FieldLevelEncryptionConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryption: {
                shape: "S2k"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryption"
          }
        },
        CreateFieldLevelEncryptionProfile: {
          http: {
            requestUri: "/2017-10-30/field-level-encryption-profile",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionProfileConfig"
            ],
            members: {
              FieldLevelEncryptionProfileConfig: {
                shape: "S2m",
                locationName: "FieldLevelEncryptionProfileConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                }
              }
            },
            payload: "FieldLevelEncryptionProfileConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfile: {
                shape: "S2t"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfile"
          }
        },
        CreateInvalidation: {
          http: {
            requestUri: "/2017-10-30/distribution/{DistributionId}/invalidation",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionId",
              "InvalidationBatch"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              InvalidationBatch: {
                shape: "S2v",
                locationName: "InvalidationBatch",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                }
              }
            },
            payload: "InvalidationBatch"
          },
          output: {
            type: "structure",
            members: {
              Location: {
                location: "header",
                locationName: "Location"
              },
              Invalidation: {
                shape: "S2z"
              }
            },
            payload: "Invalidation"
          }
        },
        CreatePublicKey: {
          http: {
            requestUri: "/2017-10-30/public-key",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "PublicKeyConfig"
            ],
            members: {
              PublicKeyConfig: {
                shape: "S31",
                locationName: "PublicKeyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                }
              }
            },
            payload: "PublicKeyConfig"
          },
          output: {
            type: "structure",
            members: {
              PublicKey: {
                shape: "S33"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKey"
          }
        },
        CreateStreamingDistribution: {
          http: {
            requestUri: "/2017-10-30/streaming-distribution",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfig"
            ],
            members: {
              StreamingDistributionConfig: {
                shape: "S35",
                locationName: "StreamingDistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                }
              }
            },
            payload: "StreamingDistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S39"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        CreateStreamingDistributionWithTags: {
          http: {
            requestUri: "/2017-10-30/streaming-distribution?WithTags",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfigWithTags"
            ],
            members: {
              StreamingDistributionConfigWithTags: {
                locationName: "StreamingDistributionConfigWithTags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                },
                type: "structure",
                required: [
                  "StreamingDistributionConfig",
                  "Tags"
                ],
                members: {
                  StreamingDistributionConfig: {
                    shape: "S35"
                  },
                  Tags: {
                    shape: "S22"
                  }
                }
              }
            },
            payload: "StreamingDistributionConfigWithTags"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S39"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        DeleteCloudFrontOriginAccessIdentity: {
          http: {
            method: "DELETE",
            requestUri: "/2017-10-30/origin-access-identity/cloudfront/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteDistribution: {
          http: {
            method: "DELETE",
            requestUri: "/2017-10-30/distribution/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteFieldLevelEncryptionConfig: {
          http: {
            method: "DELETE",
            requestUri: "/2017-10-30/field-level-encryption/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteFieldLevelEncryptionProfile: {
          http: {
            method: "DELETE",
            requestUri: "/2017-10-30/field-level-encryption-profile/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeletePublicKey: {
          http: {
            method: "DELETE",
            requestUri: "/2017-10-30/public-key/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteStreamingDistribution: {
          http: {
            method: "DELETE",
            requestUri: "/2017-10-30/streaming-distribution/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        GetCloudFrontOriginAccessIdentity: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/origin-access-identity/cloudfront/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        GetCloudFrontOriginAccessIdentityConfig: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/origin-access-identity/cloudfront/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          }
        },
        GetDistribution: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/distribution/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1t"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        GetDistributionConfig: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionConfig: {
                shape: "S7"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "DistributionConfig"
          }
        },
        GetFieldLevelEncryption: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/field-level-encryption/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryption: {
                shape: "S2k"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryption"
          }
        },
        GetFieldLevelEncryptionConfig: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/field-level-encryption/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionConfig: {
                shape: "S29"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionConfig"
          }
        },
        GetFieldLevelEncryptionProfile: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/field-level-encryption-profile/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfile: {
                shape: "S2t"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfile"
          }
        },
        GetFieldLevelEncryptionProfileConfig: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/field-level-encryption-profile/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfileConfig: {
                shape: "S2m"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfileConfig"
          }
        },
        GetInvalidation: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/distribution/{DistributionId}/invalidation/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId",
              "Id"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Invalidation: {
                shape: "S2z"
              }
            },
            payload: "Invalidation"
          }
        },
        GetPublicKey: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/public-key/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKey: {
                shape: "S33"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKey"
          }
        },
        GetPublicKeyConfig: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/public-key/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKeyConfig: {
                shape: "S31"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKeyConfig"
          }
        },
        GetStreamingDistribution: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/streaming-distribution/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S39"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        GetStreamingDistributionConfig: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/streaming-distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistributionConfig: {
                shape: "S35"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistributionConfig"
          }
        },
        ListCloudFrontOriginAccessIdentities: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/origin-access-identity/cloudfront"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentityList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "CloudFrontOriginAccessIdentitySummary",
                      type: "structure",
                      required: [
                        "Id",
                        "S3CanonicalUserId",
                        "Comment"
                      ],
                      members: {
                        Id: {},
                        S3CanonicalUserId: {},
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "CloudFrontOriginAccessIdentityList"
          }
        },
        ListDistributions: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/distribution"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionList: {
                shape: "S4g"
              }
            },
            payload: "DistributionList"
          }
        },
        ListDistributionsByWebACLId: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/distributionsByWebACLId/{WebACLId}"
          },
          input: {
            type: "structure",
            required: [
              "WebACLId"
            ],
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              },
              WebACLId: {
                location: "uri",
                locationName: "WebACLId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionList: {
                shape: "S4g"
              }
            },
            payload: "DistributionList"
          }
        },
        ListFieldLevelEncryptionConfigs: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/field-level-encryption"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "FieldLevelEncryptionSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "LastModifiedTime"
                      ],
                      members: {
                        Id: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        Comment: {},
                        QueryArgProfileConfig: {
                          shape: "S2a"
                        },
                        ContentTypeProfileConfig: {
                          shape: "S2e"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "FieldLevelEncryptionList"
          }
        },
        ListFieldLevelEncryptionProfiles: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/field-level-encryption-profile"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfileList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "FieldLevelEncryptionProfileSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "LastModifiedTime",
                        "Name",
                        "EncryptionEntities"
                      ],
                      members: {
                        Id: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        Name: {},
                        EncryptionEntities: {
                          shape: "S2n"
                        },
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "FieldLevelEncryptionProfileList"
          }
        },
        ListInvalidations: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/distribution/{DistributionId}/invalidation"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InvalidationList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "InvalidationSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "CreateTime",
                        "Status"
                      ],
                      members: {
                        Id: {},
                        CreateTime: {
                          type: "timestamp"
                        },
                        Status: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "InvalidationList"
          }
        },
        ListPublicKeys: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/public-key"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKeyList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "PublicKeySummary",
                      type: "structure",
                      required: [
                        "Id",
                        "Name",
                        "CreatedTime",
                        "EncodedKey"
                      ],
                      members: {
                        Id: {},
                        Name: {},
                        CreatedTime: {
                          type: "timestamp"
                        },
                        EncodedKey: {},
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "PublicKeyList"
          }
        },
        ListStreamingDistributions: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/streaming-distribution"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistributionList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "StreamingDistributionSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "ARN",
                        "Status",
                        "LastModifiedTime",
                        "DomainName",
                        "S3Origin",
                        "Aliases",
                        "TrustedSigners",
                        "Comment",
                        "PriceClass",
                        "Enabled"
                      ],
                      members: {
                        Id: {},
                        ARN: {},
                        Status: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        DomainName: {},
                        S3Origin: {
                          shape: "S36"
                        },
                        Aliases: {
                          shape: "S8"
                        },
                        TrustedSigners: {
                          shape: "Sy"
                        },
                        Comment: {},
                        PriceClass: {},
                        Enabled: {
                          type: "boolean"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "StreamingDistributionList"
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/tagging"
          },
          input: {
            type: "structure",
            required: [
              "Resource"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "S22"
              }
            },
            payload: "Tags"
          }
        },
        TagResource: {
          http: {
            requestUri: "/2017-10-30/tagging?Operation=Tag",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "Tags"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              },
              Tags: {
                shape: "S22",
                locationName: "Tags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                }
              }
            },
            payload: "Tags"
          }
        },
        UntagResource: {
          http: {
            requestUri: "/2017-10-30/tagging?Operation=Untag",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "TagKeys"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              },
              TagKeys: {
                locationName: "TagKeys",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                },
                type: "structure",
                members: {
                  Items: {
                    type: "list",
                    member: {
                      locationName: "Key"
                    }
                  }
                }
              }
            },
            payload: "TagKeys"
          }
        },
        UpdateCloudFrontOriginAccessIdentity: {
          http: {
            method: "PUT",
            requestUri: "/2017-10-30/origin-access-identity/cloudfront/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "CloudFrontOriginAccessIdentityConfig",
              "Id"
            ],
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2",
                locationName: "CloudFrontOriginAccessIdentityConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        UpdateDistribution: {
          http: {
            method: "PUT",
            requestUri: "/2017-10-30/distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfig",
              "Id"
            ],
            members: {
              DistributionConfig: {
                shape: "S7",
                locationName: "DistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "DistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1t"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        UpdateFieldLevelEncryptionConfig: {
          http: {
            method: "PUT",
            requestUri: "/2017-10-30/field-level-encryption/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionConfig",
              "Id"
            ],
            members: {
              FieldLevelEncryptionConfig: {
                shape: "S29",
                locationName: "FieldLevelEncryptionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "FieldLevelEncryptionConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryption: {
                shape: "S2k"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryption"
          }
        },
        UpdateFieldLevelEncryptionProfile: {
          http: {
            method: "PUT",
            requestUri: "/2017-10-30/field-level-encryption-profile/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionProfileConfig",
              "Id"
            ],
            members: {
              FieldLevelEncryptionProfileConfig: {
                shape: "S2m",
                locationName: "FieldLevelEncryptionProfileConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "FieldLevelEncryptionProfileConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfile: {
                shape: "S2t"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfile"
          }
        },
        UpdatePublicKey: {
          http: {
            method: "PUT",
            requestUri: "/2017-10-30/public-key/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "PublicKeyConfig",
              "Id"
            ],
            members: {
              PublicKeyConfig: {
                shape: "S31",
                locationName: "PublicKeyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "PublicKeyConfig"
          },
          output: {
            type: "structure",
            members: {
              PublicKey: {
                shape: "S33"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKey"
          }
        },
        UpdateStreamingDistribution: {
          http: {
            method: "PUT",
            requestUri: "/2017-10-30/streaming-distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfig",
              "Id"
            ],
            members: {
              StreamingDistributionConfig: {
                shape: "S35",
                locationName: "StreamingDistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "StreamingDistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S39"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          required: [
            "CallerReference",
            "Comment"
          ],
          members: {
            CallerReference: {},
            Comment: {}
          }
        },
        S5: {
          type: "structure",
          required: [
            "Id",
            "S3CanonicalUserId"
          ],
          members: {
            Id: {},
            S3CanonicalUserId: {},
            CloudFrontOriginAccessIdentityConfig: {
              shape: "S2"
            }
          }
        },
        S7: {
          type: "structure",
          required: [
            "CallerReference",
            "Origins",
            "DefaultCacheBehavior",
            "Comment",
            "Enabled"
          ],
          members: {
            CallerReference: {},
            Aliases: {
              shape: "S8"
            },
            DefaultRootObject: {},
            Origins: {
              shape: "Sb"
            },
            DefaultCacheBehavior: {
              shape: "Sn"
            },
            CacheBehaviors: {
              shape: "S1b"
            },
            CustomErrorResponses: {
              shape: "S1e"
            },
            Comment: {},
            Logging: {
              type: "structure",
              required: [
                "Enabled",
                "IncludeCookies",
                "Bucket",
                "Prefix"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                IncludeCookies: {
                  type: "boolean"
                },
                Bucket: {},
                Prefix: {}
              }
            },
            PriceClass: {},
            Enabled: {
              type: "boolean"
            },
            ViewerCertificate: {
              shape: "S1j"
            },
            Restrictions: {
              shape: "S1n"
            },
            WebACLId: {},
            HttpVersion: {},
            IsIPV6Enabled: {
              type: "boolean"
            }
          }
        },
        S8: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CNAME"
              }
            }
          }
        },
        Sb: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Origin",
                type: "structure",
                required: [
                  "Id",
                  "DomainName"
                ],
                members: {
                  Id: {},
                  DomainName: {},
                  OriginPath: {},
                  CustomHeaders: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "OriginCustomHeader",
                          type: "structure",
                          required: [
                            "HeaderName",
                            "HeaderValue"
                          ],
                          members: {
                            HeaderName: {},
                            HeaderValue: {}
                          }
                        }
                      }
                    }
                  },
                  S3OriginConfig: {
                    type: "structure",
                    required: [
                      "OriginAccessIdentity"
                    ],
                    members: {
                      OriginAccessIdentity: {}
                    }
                  },
                  CustomOriginConfig: {
                    type: "structure",
                    required: [
                      "HTTPPort",
                      "HTTPSPort",
                      "OriginProtocolPolicy"
                    ],
                    members: {
                      HTTPPort: {
                        type: "integer"
                      },
                      HTTPSPort: {
                        type: "integer"
                      },
                      OriginProtocolPolicy: {},
                      OriginSslProtocols: {
                        type: "structure",
                        required: [
                          "Quantity",
                          "Items"
                        ],
                        members: {
                          Quantity: {
                            type: "integer"
                          },
                          Items: {
                            type: "list",
                            member: {
                              locationName: "SslProtocol"
                            }
                          }
                        }
                      },
                      OriginReadTimeout: {
                        type: "integer"
                      },
                      OriginKeepaliveTimeout: {
                        type: "integer"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sn: {
          type: "structure",
          required: [
            "TargetOriginId",
            "ForwardedValues",
            "TrustedSigners",
            "ViewerProtocolPolicy",
            "MinTTL"
          ],
          members: {
            TargetOriginId: {},
            ForwardedValues: {
              shape: "So"
            },
            TrustedSigners: {
              shape: "Sy"
            },
            ViewerProtocolPolicy: {},
            MinTTL: {
              type: "long"
            },
            AllowedMethods: {
              shape: "S12"
            },
            SmoothStreaming: {
              type: "boolean"
            },
            DefaultTTL: {
              type: "long"
            },
            MaxTTL: {
              type: "long"
            },
            Compress: {
              type: "boolean"
            },
            LambdaFunctionAssociations: {
              shape: "S16"
            },
            FieldLevelEncryptionId: {}
          }
        },
        So: {
          type: "structure",
          required: [
            "QueryString",
            "Cookies"
          ],
          members: {
            QueryString: {
              type: "boolean"
            },
            Cookies: {
              type: "structure",
              required: [
                "Forward"
              ],
              members: {
                Forward: {},
                WhitelistedNames: {
                  type: "structure",
                  required: [
                    "Quantity"
                  ],
                  members: {
                    Quantity: {
                      type: "integer"
                    },
                    Items: {
                      type: "list",
                      member: {
                        locationName: "Name"
                      }
                    }
                  }
                }
              }
            },
            Headers: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Name"
                  }
                }
              }
            },
            QueryStringCacheKeys: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Name"
                  }
                }
              }
            }
          }
        },
        Sy: {
          type: "structure",
          required: [
            "Enabled",
            "Quantity"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "AwsAccountNumber"
              }
            }
          }
        },
        S12: {
          type: "structure",
          required: [
            "Quantity",
            "Items"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              shape: "S13"
            },
            CachedMethods: {
              type: "structure",
              required: [
                "Quantity",
                "Items"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  shape: "S13"
                }
              }
            }
          }
        },
        S13: {
          type: "list",
          member: {
            locationName: "Method"
          }
        },
        S16: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "LambdaFunctionAssociation",
                type: "structure",
                required: [
                  "LambdaFunctionARN",
                  "EventType"
                ],
                members: {
                  LambdaFunctionARN: {},
                  EventType: {}
                }
              }
            }
          }
        },
        S1b: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CacheBehavior",
                type: "structure",
                required: [
                  "PathPattern",
                  "TargetOriginId",
                  "ForwardedValues",
                  "TrustedSigners",
                  "ViewerProtocolPolicy",
                  "MinTTL"
                ],
                members: {
                  PathPattern: {},
                  TargetOriginId: {},
                  ForwardedValues: {
                    shape: "So"
                  },
                  TrustedSigners: {
                    shape: "Sy"
                  },
                  ViewerProtocolPolicy: {},
                  MinTTL: {
                    type: "long"
                  },
                  AllowedMethods: {
                    shape: "S12"
                  },
                  SmoothStreaming: {
                    type: "boolean"
                  },
                  DefaultTTL: {
                    type: "long"
                  },
                  MaxTTL: {
                    type: "long"
                  },
                  Compress: {
                    type: "boolean"
                  },
                  LambdaFunctionAssociations: {
                    shape: "S16"
                  },
                  FieldLevelEncryptionId: {}
                }
              }
            }
          }
        },
        S1e: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CustomErrorResponse",
                type: "structure",
                required: [
                  "ErrorCode"
                ],
                members: {
                  ErrorCode: {
                    type: "integer"
                  },
                  ResponsePagePath: {},
                  ResponseCode: {},
                  ErrorCachingMinTTL: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        S1j: {
          type: "structure",
          members: {
            CloudFrontDefaultCertificate: {
              type: "boolean"
            },
            IAMCertificateId: {},
            ACMCertificateArn: {},
            SSLSupportMethod: {},
            MinimumProtocolVersion: {},
            Certificate: {
              deprecated: true
            },
            CertificateSource: {
              deprecated: true
            }
          }
        },
        S1n: {
          type: "structure",
          required: [
            "GeoRestriction"
          ],
          members: {
            GeoRestriction: {
              type: "structure",
              required: [
                "RestrictionType",
                "Quantity"
              ],
              members: {
                RestrictionType: {},
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Location"
                  }
                }
              }
            }
          }
        },
        S1t: {
          type: "structure",
          required: [
            "Id",
            "ARN",
            "Status",
            "LastModifiedTime",
            "InProgressInvalidationBatches",
            "DomainName",
            "ActiveTrustedSigners",
            "DistributionConfig"
          ],
          members: {
            Id: {},
            ARN: {},
            Status: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            InProgressInvalidationBatches: {
              type: "integer"
            },
            DomainName: {},
            ActiveTrustedSigners: {
              shape: "S1v"
            },
            DistributionConfig: {
              shape: "S7"
            }
          }
        },
        S1v: {
          type: "structure",
          required: [
            "Enabled",
            "Quantity"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Signer",
                type: "structure",
                members: {
                  AwsAccountNumber: {},
                  KeyPairIds: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "KeyPairId"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S22: {
          type: "structure",
          members: {
            Items: {
              type: "list",
              member: {
                locationName: "Tag",
                type: "structure",
                required: [
                  "Key"
                ],
                members: {
                  Key: {},
                  Value: {}
                }
              }
            }
          }
        },
        S29: {
          type: "structure",
          required: [
            "CallerReference"
          ],
          members: {
            CallerReference: {},
            Comment: {},
            QueryArgProfileConfig: {
              shape: "S2a"
            },
            ContentTypeProfileConfig: {
              shape: "S2e"
            }
          }
        },
        S2a: {
          type: "structure",
          required: [
            "ForwardWhenQueryArgProfileIsUnknown"
          ],
          members: {
            ForwardWhenQueryArgProfileIsUnknown: {
              type: "boolean"
            },
            QueryArgProfiles: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "QueryArgProfile",
                    type: "structure",
                    required: [
                      "QueryArg",
                      "ProfileId"
                    ],
                    members: {
                      QueryArg: {},
                      ProfileId: {}
                    }
                  }
                }
              }
            }
          }
        },
        S2e: {
          type: "structure",
          required: [
            "ForwardWhenContentTypeIsUnknown"
          ],
          members: {
            ForwardWhenContentTypeIsUnknown: {
              type: "boolean"
            },
            ContentTypeProfiles: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "ContentTypeProfile",
                    type: "structure",
                    required: [
                      "Format",
                      "ContentType"
                    ],
                    members: {
                      Format: {},
                      ProfileId: {},
                      ContentType: {}
                    }
                  }
                }
              }
            }
          }
        },
        S2k: {
          type: "structure",
          required: [
            "Id",
            "LastModifiedTime",
            "FieldLevelEncryptionConfig"
          ],
          members: {
            Id: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            FieldLevelEncryptionConfig: {
              shape: "S29"
            }
          }
        },
        S2m: {
          type: "structure",
          required: [
            "Name",
            "CallerReference",
            "EncryptionEntities"
          ],
          members: {
            Name: {},
            CallerReference: {},
            Comment: {},
            EncryptionEntities: {
              shape: "S2n"
            }
          }
        },
        S2n: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "EncryptionEntity",
                type: "structure",
                required: [
                  "PublicKeyId",
                  "ProviderId",
                  "FieldPatterns"
                ],
                members: {
                  PublicKeyId: {},
                  ProviderId: {},
                  FieldPatterns: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "FieldPattern"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S2t: {
          type: "structure",
          required: [
            "Id",
            "LastModifiedTime",
            "FieldLevelEncryptionProfileConfig"
          ],
          members: {
            Id: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            FieldLevelEncryptionProfileConfig: {
              shape: "S2m"
            }
          }
        },
        S2v: {
          type: "structure",
          required: [
            "Paths",
            "CallerReference"
          ],
          members: {
            Paths: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Path"
                  }
                }
              }
            },
            CallerReference: {}
          }
        },
        S2z: {
          type: "structure",
          required: [
            "Id",
            "Status",
            "CreateTime",
            "InvalidationBatch"
          ],
          members: {
            Id: {},
            Status: {},
            CreateTime: {
              type: "timestamp"
            },
            InvalidationBatch: {
              shape: "S2v"
            }
          }
        },
        S31: {
          type: "structure",
          required: [
            "CallerReference",
            "Name",
            "EncodedKey"
          ],
          members: {
            CallerReference: {},
            Name: {},
            EncodedKey: {},
            Comment: {}
          }
        },
        S33: {
          type: "structure",
          required: [
            "Id",
            "CreatedTime",
            "PublicKeyConfig"
          ],
          members: {
            Id: {},
            CreatedTime: {
              type: "timestamp"
            },
            PublicKeyConfig: {
              shape: "S31"
            }
          }
        },
        S35: {
          type: "structure",
          required: [
            "CallerReference",
            "S3Origin",
            "Comment",
            "TrustedSigners",
            "Enabled"
          ],
          members: {
            CallerReference: {},
            S3Origin: {
              shape: "S36"
            },
            Aliases: {
              shape: "S8"
            },
            Comment: {},
            Logging: {
              type: "structure",
              required: [
                "Enabled",
                "Bucket",
                "Prefix"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                Bucket: {},
                Prefix: {}
              }
            },
            TrustedSigners: {
              shape: "Sy"
            },
            PriceClass: {},
            Enabled: {
              type: "boolean"
            }
          }
        },
        S36: {
          type: "structure",
          required: [
            "DomainName",
            "OriginAccessIdentity"
          ],
          members: {
            DomainName: {},
            OriginAccessIdentity: {}
          }
        },
        S39: {
          type: "structure",
          required: [
            "Id",
            "ARN",
            "Status",
            "DomainName",
            "ActiveTrustedSigners",
            "StreamingDistributionConfig"
          ],
          members: {
            Id: {},
            ARN: {},
            Status: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            DomainName: {},
            ActiveTrustedSigners: {
              shape: "S1v"
            },
            StreamingDistributionConfig: {
              shape: "S35"
            }
          }
        },
        S4g: {
          type: "structure",
          required: [
            "Marker",
            "MaxItems",
            "IsTruncated",
            "Quantity"
          ],
          members: {
            Marker: {},
            NextMarker: {},
            MaxItems: {
              type: "integer"
            },
            IsTruncated: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "DistributionSummary",
                type: "structure",
                required: [
                  "Id",
                  "ARN",
                  "Status",
                  "LastModifiedTime",
                  "DomainName",
                  "Aliases",
                  "Origins",
                  "DefaultCacheBehavior",
                  "CacheBehaviors",
                  "CustomErrorResponses",
                  "Comment",
                  "PriceClass",
                  "Enabled",
                  "ViewerCertificate",
                  "Restrictions",
                  "WebACLId",
                  "HttpVersion",
                  "IsIPV6Enabled"
                ],
                members: {
                  Id: {},
                  ARN: {},
                  Status: {},
                  LastModifiedTime: {
                    type: "timestamp"
                  },
                  DomainName: {},
                  Aliases: {
                    shape: "S8"
                  },
                  Origins: {
                    shape: "Sb"
                  },
                  DefaultCacheBehavior: {
                    shape: "Sn"
                  },
                  CacheBehaviors: {
                    shape: "S1b"
                  },
                  CustomErrorResponses: {
                    shape: "S1e"
                  },
                  Comment: {},
                  PriceClass: {},
                  Enabled: {
                    type: "boolean"
                  },
                  ViewerCertificate: {
                    shape: "S1j"
                  },
                  Restrictions: {
                    shape: "S1n"
                  },
                  WebACLId: {},
                  HttpVersion: {},
                  IsIPV6Enabled: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2017-10-30.paginators.json
var require_cloudfront_2017_10_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2017-10-30.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListCloudFrontOriginAccessIdentities: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "CloudFrontOriginAccessIdentityList.IsTruncated",
          output_token: "CloudFrontOriginAccessIdentityList.NextMarker",
          result_key: "CloudFrontOriginAccessIdentityList.Items"
        },
        ListDistributions: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "DistributionList.IsTruncated",
          output_token: "DistributionList.NextMarker",
          result_key: "DistributionList.Items"
        },
        ListInvalidations: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "InvalidationList.IsTruncated",
          output_token: "InvalidationList.NextMarker",
          result_key: "InvalidationList.Items"
        },
        ListStreamingDistributions: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "StreamingDistributionList.IsTruncated",
          output_token: "StreamingDistributionList.NextMarker",
          result_key: "StreamingDistributionList.Items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2017-10-30.waiters2.json
var require_cloudfront_2017_10_30_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2017-10-30.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        DistributionDeployed: {
          delay: 60,
          operation: "GetDistribution",
          maxAttempts: 25,
          description: "Wait until a distribution is deployed.",
          acceptors: [
            {
              expected: "Deployed",
              matcher: "path",
              state: "success",
              argument: "Distribution.Status"
            }
          ]
        },
        InvalidationCompleted: {
          delay: 20,
          operation: "GetInvalidation",
          maxAttempts: 30,
          description: "Wait until an invalidation has completed.",
          acceptors: [
            {
              expected: "Completed",
              matcher: "path",
              state: "success",
              argument: "Invalidation.Status"
            }
          ]
        },
        StreamingDistributionDeployed: {
          delay: 60,
          operation: "GetStreamingDistribution",
          maxAttempts: 25,
          description: "Wait until a streaming distribution is deployed.",
          acceptors: [
            {
              expected: "Deployed",
              matcher: "path",
              state: "success",
              argument: "StreamingDistribution.Status"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2018-06-18.min.json
var require_cloudfront_2018_06_18_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2018-06-18.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-06-18",
        endpointPrefix: "cloudfront",
        globalEndpoint: "cloudfront.amazonaws.com",
        protocol: "rest-xml",
        serviceAbbreviation: "CloudFront",
        serviceFullName: "Amazon CloudFront",
        serviceId: "CloudFront",
        signatureVersion: "v4",
        uid: "cloudfront-2018-06-18"
      },
      operations: {
        CreateCloudFrontOriginAccessIdentity: {
          http: {
            requestUri: "/2018-06-18/origin-access-identity/cloudfront",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "CloudFrontOriginAccessIdentityConfig"
            ],
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2",
                locationName: "CloudFrontOriginAccessIdentityConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                }
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        CreateDistribution: {
          http: {
            requestUri: "/2018-06-18/distribution",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfig"
            ],
            members: {
              DistributionConfig: {
                shape: "S7",
                locationName: "DistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                }
              }
            },
            payload: "DistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1t"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        CreateDistributionWithTags: {
          http: {
            requestUri: "/2018-06-18/distribution?WithTags",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfigWithTags"
            ],
            members: {
              DistributionConfigWithTags: {
                locationName: "DistributionConfigWithTags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                },
                type: "structure",
                required: [
                  "DistributionConfig",
                  "Tags"
                ],
                members: {
                  DistributionConfig: {
                    shape: "S7"
                  },
                  Tags: {
                    shape: "S22"
                  }
                }
              }
            },
            payload: "DistributionConfigWithTags"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1t"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        CreateFieldLevelEncryptionConfig: {
          http: {
            requestUri: "/2018-06-18/field-level-encryption",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionConfig"
            ],
            members: {
              FieldLevelEncryptionConfig: {
                shape: "S29",
                locationName: "FieldLevelEncryptionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                }
              }
            },
            payload: "FieldLevelEncryptionConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryption: {
                shape: "S2k"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryption"
          }
        },
        CreateFieldLevelEncryptionProfile: {
          http: {
            requestUri: "/2018-06-18/field-level-encryption-profile",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionProfileConfig"
            ],
            members: {
              FieldLevelEncryptionProfileConfig: {
                shape: "S2m",
                locationName: "FieldLevelEncryptionProfileConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                }
              }
            },
            payload: "FieldLevelEncryptionProfileConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfile: {
                shape: "S2t"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfile"
          }
        },
        CreateInvalidation: {
          http: {
            requestUri: "/2018-06-18/distribution/{DistributionId}/invalidation",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionId",
              "InvalidationBatch"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              InvalidationBatch: {
                shape: "S2v",
                locationName: "InvalidationBatch",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                }
              }
            },
            payload: "InvalidationBatch"
          },
          output: {
            type: "structure",
            members: {
              Location: {
                location: "header",
                locationName: "Location"
              },
              Invalidation: {
                shape: "S2z"
              }
            },
            payload: "Invalidation"
          }
        },
        CreatePublicKey: {
          http: {
            requestUri: "/2018-06-18/public-key",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "PublicKeyConfig"
            ],
            members: {
              PublicKeyConfig: {
                shape: "S31",
                locationName: "PublicKeyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                }
              }
            },
            payload: "PublicKeyConfig"
          },
          output: {
            type: "structure",
            members: {
              PublicKey: {
                shape: "S33"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKey"
          }
        },
        CreateStreamingDistribution: {
          http: {
            requestUri: "/2018-06-18/streaming-distribution",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfig"
            ],
            members: {
              StreamingDistributionConfig: {
                shape: "S35",
                locationName: "StreamingDistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                }
              }
            },
            payload: "StreamingDistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S39"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        CreateStreamingDistributionWithTags: {
          http: {
            requestUri: "/2018-06-18/streaming-distribution?WithTags",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfigWithTags"
            ],
            members: {
              StreamingDistributionConfigWithTags: {
                locationName: "StreamingDistributionConfigWithTags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                },
                type: "structure",
                required: [
                  "StreamingDistributionConfig",
                  "Tags"
                ],
                members: {
                  StreamingDistributionConfig: {
                    shape: "S35"
                  },
                  Tags: {
                    shape: "S22"
                  }
                }
              }
            },
            payload: "StreamingDistributionConfigWithTags"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S39"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        DeleteCloudFrontOriginAccessIdentity: {
          http: {
            method: "DELETE",
            requestUri: "/2018-06-18/origin-access-identity/cloudfront/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteDistribution: {
          http: {
            method: "DELETE",
            requestUri: "/2018-06-18/distribution/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteFieldLevelEncryptionConfig: {
          http: {
            method: "DELETE",
            requestUri: "/2018-06-18/field-level-encryption/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteFieldLevelEncryptionProfile: {
          http: {
            method: "DELETE",
            requestUri: "/2018-06-18/field-level-encryption-profile/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeletePublicKey: {
          http: {
            method: "DELETE",
            requestUri: "/2018-06-18/public-key/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteStreamingDistribution: {
          http: {
            method: "DELETE",
            requestUri: "/2018-06-18/streaming-distribution/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        GetCloudFrontOriginAccessIdentity: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/origin-access-identity/cloudfront/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        GetCloudFrontOriginAccessIdentityConfig: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/origin-access-identity/cloudfront/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          }
        },
        GetDistribution: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/distribution/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1t"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        GetDistributionConfig: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionConfig: {
                shape: "S7"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "DistributionConfig"
          }
        },
        GetFieldLevelEncryption: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/field-level-encryption/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryption: {
                shape: "S2k"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryption"
          }
        },
        GetFieldLevelEncryptionConfig: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/field-level-encryption/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionConfig: {
                shape: "S29"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionConfig"
          }
        },
        GetFieldLevelEncryptionProfile: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/field-level-encryption-profile/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfile: {
                shape: "S2t"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfile"
          }
        },
        GetFieldLevelEncryptionProfileConfig: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/field-level-encryption-profile/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfileConfig: {
                shape: "S2m"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfileConfig"
          }
        },
        GetInvalidation: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/distribution/{DistributionId}/invalidation/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId",
              "Id"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Invalidation: {
                shape: "S2z"
              }
            },
            payload: "Invalidation"
          }
        },
        GetPublicKey: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/public-key/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKey: {
                shape: "S33"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKey"
          }
        },
        GetPublicKeyConfig: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/public-key/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKeyConfig: {
                shape: "S31"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKeyConfig"
          }
        },
        GetStreamingDistribution: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/streaming-distribution/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S39"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        GetStreamingDistributionConfig: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/streaming-distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistributionConfig: {
                shape: "S35"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistributionConfig"
          }
        },
        ListCloudFrontOriginAccessIdentities: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/origin-access-identity/cloudfront"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentityList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "CloudFrontOriginAccessIdentitySummary",
                      type: "structure",
                      required: [
                        "Id",
                        "S3CanonicalUserId",
                        "Comment"
                      ],
                      members: {
                        Id: {},
                        S3CanonicalUserId: {},
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "CloudFrontOriginAccessIdentityList"
          }
        },
        ListDistributions: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/distribution"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionList: {
                shape: "S4g"
              }
            },
            payload: "DistributionList"
          }
        },
        ListDistributionsByWebACLId: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/distributionsByWebACLId/{WebACLId}"
          },
          input: {
            type: "structure",
            required: [
              "WebACLId"
            ],
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              },
              WebACLId: {
                location: "uri",
                locationName: "WebACLId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionList: {
                shape: "S4g"
              }
            },
            payload: "DistributionList"
          }
        },
        ListFieldLevelEncryptionConfigs: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/field-level-encryption"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "FieldLevelEncryptionSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "LastModifiedTime"
                      ],
                      members: {
                        Id: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        Comment: {},
                        QueryArgProfileConfig: {
                          shape: "S2a"
                        },
                        ContentTypeProfileConfig: {
                          shape: "S2e"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "FieldLevelEncryptionList"
          }
        },
        ListFieldLevelEncryptionProfiles: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/field-level-encryption-profile"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfileList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "FieldLevelEncryptionProfileSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "LastModifiedTime",
                        "Name",
                        "EncryptionEntities"
                      ],
                      members: {
                        Id: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        Name: {},
                        EncryptionEntities: {
                          shape: "S2n"
                        },
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "FieldLevelEncryptionProfileList"
          }
        },
        ListInvalidations: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/distribution/{DistributionId}/invalidation"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InvalidationList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "InvalidationSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "CreateTime",
                        "Status"
                      ],
                      members: {
                        Id: {},
                        CreateTime: {
                          type: "timestamp"
                        },
                        Status: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "InvalidationList"
          }
        },
        ListPublicKeys: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/public-key"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKeyList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "PublicKeySummary",
                      type: "structure",
                      required: [
                        "Id",
                        "Name",
                        "CreatedTime",
                        "EncodedKey"
                      ],
                      members: {
                        Id: {},
                        Name: {},
                        CreatedTime: {
                          type: "timestamp"
                        },
                        EncodedKey: {},
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "PublicKeyList"
          }
        },
        ListStreamingDistributions: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/streaming-distribution"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistributionList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "StreamingDistributionSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "ARN",
                        "Status",
                        "LastModifiedTime",
                        "DomainName",
                        "S3Origin",
                        "Aliases",
                        "TrustedSigners",
                        "Comment",
                        "PriceClass",
                        "Enabled"
                      ],
                      members: {
                        Id: {},
                        ARN: {},
                        Status: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        DomainName: {},
                        S3Origin: {
                          shape: "S36"
                        },
                        Aliases: {
                          shape: "S8"
                        },
                        TrustedSigners: {
                          shape: "Sy"
                        },
                        Comment: {},
                        PriceClass: {},
                        Enabled: {
                          type: "boolean"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "StreamingDistributionList"
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/tagging"
          },
          input: {
            type: "structure",
            required: [
              "Resource"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "S22"
              }
            },
            payload: "Tags"
          }
        },
        TagResource: {
          http: {
            requestUri: "/2018-06-18/tagging?Operation=Tag",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "Tags"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              },
              Tags: {
                shape: "S22",
                locationName: "Tags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                }
              }
            },
            payload: "Tags"
          }
        },
        UntagResource: {
          http: {
            requestUri: "/2018-06-18/tagging?Operation=Untag",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "TagKeys"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              },
              TagKeys: {
                locationName: "TagKeys",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                },
                type: "structure",
                members: {
                  Items: {
                    type: "list",
                    member: {
                      locationName: "Key"
                    }
                  }
                }
              }
            },
            payload: "TagKeys"
          }
        },
        UpdateCloudFrontOriginAccessIdentity: {
          http: {
            method: "PUT",
            requestUri: "/2018-06-18/origin-access-identity/cloudfront/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "CloudFrontOriginAccessIdentityConfig",
              "Id"
            ],
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2",
                locationName: "CloudFrontOriginAccessIdentityConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        UpdateDistribution: {
          http: {
            method: "PUT",
            requestUri: "/2018-06-18/distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfig",
              "Id"
            ],
            members: {
              DistributionConfig: {
                shape: "S7",
                locationName: "DistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "DistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1t"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        UpdateFieldLevelEncryptionConfig: {
          http: {
            method: "PUT",
            requestUri: "/2018-06-18/field-level-encryption/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionConfig",
              "Id"
            ],
            members: {
              FieldLevelEncryptionConfig: {
                shape: "S29",
                locationName: "FieldLevelEncryptionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "FieldLevelEncryptionConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryption: {
                shape: "S2k"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryption"
          }
        },
        UpdateFieldLevelEncryptionProfile: {
          http: {
            method: "PUT",
            requestUri: "/2018-06-18/field-level-encryption-profile/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionProfileConfig",
              "Id"
            ],
            members: {
              FieldLevelEncryptionProfileConfig: {
                shape: "S2m",
                locationName: "FieldLevelEncryptionProfileConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "FieldLevelEncryptionProfileConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfile: {
                shape: "S2t"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfile"
          }
        },
        UpdatePublicKey: {
          http: {
            method: "PUT",
            requestUri: "/2018-06-18/public-key/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "PublicKeyConfig",
              "Id"
            ],
            members: {
              PublicKeyConfig: {
                shape: "S31",
                locationName: "PublicKeyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "PublicKeyConfig"
          },
          output: {
            type: "structure",
            members: {
              PublicKey: {
                shape: "S33"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKey"
          }
        },
        UpdateStreamingDistribution: {
          http: {
            method: "PUT",
            requestUri: "/2018-06-18/streaming-distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfig",
              "Id"
            ],
            members: {
              StreamingDistributionConfig: {
                shape: "S35",
                locationName: "StreamingDistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "StreamingDistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S39"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          required: [
            "CallerReference",
            "Comment"
          ],
          members: {
            CallerReference: {},
            Comment: {}
          }
        },
        S5: {
          type: "structure",
          required: [
            "Id",
            "S3CanonicalUserId"
          ],
          members: {
            Id: {},
            S3CanonicalUserId: {},
            CloudFrontOriginAccessIdentityConfig: {
              shape: "S2"
            }
          }
        },
        S7: {
          type: "structure",
          required: [
            "CallerReference",
            "Origins",
            "DefaultCacheBehavior",
            "Comment",
            "Enabled"
          ],
          members: {
            CallerReference: {},
            Aliases: {
              shape: "S8"
            },
            DefaultRootObject: {},
            Origins: {
              shape: "Sb"
            },
            DefaultCacheBehavior: {
              shape: "Sn"
            },
            CacheBehaviors: {
              shape: "S1b"
            },
            CustomErrorResponses: {
              shape: "S1e"
            },
            Comment: {},
            Logging: {
              type: "structure",
              required: [
                "Enabled",
                "IncludeCookies",
                "Bucket",
                "Prefix"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                IncludeCookies: {
                  type: "boolean"
                },
                Bucket: {},
                Prefix: {}
              }
            },
            PriceClass: {},
            Enabled: {
              type: "boolean"
            },
            ViewerCertificate: {
              shape: "S1j"
            },
            Restrictions: {
              shape: "S1n"
            },
            WebACLId: {},
            HttpVersion: {},
            IsIPV6Enabled: {
              type: "boolean"
            }
          }
        },
        S8: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CNAME"
              }
            }
          }
        },
        Sb: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Origin",
                type: "structure",
                required: [
                  "Id",
                  "DomainName"
                ],
                members: {
                  Id: {},
                  DomainName: {},
                  OriginPath: {},
                  CustomHeaders: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "OriginCustomHeader",
                          type: "structure",
                          required: [
                            "HeaderName",
                            "HeaderValue"
                          ],
                          members: {
                            HeaderName: {},
                            HeaderValue: {}
                          }
                        }
                      }
                    }
                  },
                  S3OriginConfig: {
                    type: "structure",
                    required: [
                      "OriginAccessIdentity"
                    ],
                    members: {
                      OriginAccessIdentity: {}
                    }
                  },
                  CustomOriginConfig: {
                    type: "structure",
                    required: [
                      "HTTPPort",
                      "HTTPSPort",
                      "OriginProtocolPolicy"
                    ],
                    members: {
                      HTTPPort: {
                        type: "integer"
                      },
                      HTTPSPort: {
                        type: "integer"
                      },
                      OriginProtocolPolicy: {},
                      OriginSslProtocols: {
                        type: "structure",
                        required: [
                          "Quantity",
                          "Items"
                        ],
                        members: {
                          Quantity: {
                            type: "integer"
                          },
                          Items: {
                            type: "list",
                            member: {
                              locationName: "SslProtocol"
                            }
                          }
                        }
                      },
                      OriginReadTimeout: {
                        type: "integer"
                      },
                      OriginKeepaliveTimeout: {
                        type: "integer"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sn: {
          type: "structure",
          required: [
            "TargetOriginId",
            "ForwardedValues",
            "TrustedSigners",
            "ViewerProtocolPolicy",
            "MinTTL"
          ],
          members: {
            TargetOriginId: {},
            ForwardedValues: {
              shape: "So"
            },
            TrustedSigners: {
              shape: "Sy"
            },
            ViewerProtocolPolicy: {},
            MinTTL: {
              type: "long"
            },
            AllowedMethods: {
              shape: "S12"
            },
            SmoothStreaming: {
              type: "boolean"
            },
            DefaultTTL: {
              type: "long"
            },
            MaxTTL: {
              type: "long"
            },
            Compress: {
              type: "boolean"
            },
            LambdaFunctionAssociations: {
              shape: "S16"
            },
            FieldLevelEncryptionId: {}
          }
        },
        So: {
          type: "structure",
          required: [
            "QueryString",
            "Cookies"
          ],
          members: {
            QueryString: {
              type: "boolean"
            },
            Cookies: {
              type: "structure",
              required: [
                "Forward"
              ],
              members: {
                Forward: {},
                WhitelistedNames: {
                  type: "structure",
                  required: [
                    "Quantity"
                  ],
                  members: {
                    Quantity: {
                      type: "integer"
                    },
                    Items: {
                      type: "list",
                      member: {
                        locationName: "Name"
                      }
                    }
                  }
                }
              }
            },
            Headers: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Name"
                  }
                }
              }
            },
            QueryStringCacheKeys: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Name"
                  }
                }
              }
            }
          }
        },
        Sy: {
          type: "structure",
          required: [
            "Enabled",
            "Quantity"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "AwsAccountNumber"
              }
            }
          }
        },
        S12: {
          type: "structure",
          required: [
            "Quantity",
            "Items"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              shape: "S13"
            },
            CachedMethods: {
              type: "structure",
              required: [
                "Quantity",
                "Items"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  shape: "S13"
                }
              }
            }
          }
        },
        S13: {
          type: "list",
          member: {
            locationName: "Method"
          }
        },
        S16: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "LambdaFunctionAssociation",
                type: "structure",
                required: [
                  "LambdaFunctionARN",
                  "EventType"
                ],
                members: {
                  LambdaFunctionARN: {},
                  EventType: {},
                  IncludeBody: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        S1b: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CacheBehavior",
                type: "structure",
                required: [
                  "PathPattern",
                  "TargetOriginId",
                  "ForwardedValues",
                  "TrustedSigners",
                  "ViewerProtocolPolicy",
                  "MinTTL"
                ],
                members: {
                  PathPattern: {},
                  TargetOriginId: {},
                  ForwardedValues: {
                    shape: "So"
                  },
                  TrustedSigners: {
                    shape: "Sy"
                  },
                  ViewerProtocolPolicy: {},
                  MinTTL: {
                    type: "long"
                  },
                  AllowedMethods: {
                    shape: "S12"
                  },
                  SmoothStreaming: {
                    type: "boolean"
                  },
                  DefaultTTL: {
                    type: "long"
                  },
                  MaxTTL: {
                    type: "long"
                  },
                  Compress: {
                    type: "boolean"
                  },
                  LambdaFunctionAssociations: {
                    shape: "S16"
                  },
                  FieldLevelEncryptionId: {}
                }
              }
            }
          }
        },
        S1e: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CustomErrorResponse",
                type: "structure",
                required: [
                  "ErrorCode"
                ],
                members: {
                  ErrorCode: {
                    type: "integer"
                  },
                  ResponsePagePath: {},
                  ResponseCode: {},
                  ErrorCachingMinTTL: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        S1j: {
          type: "structure",
          members: {
            CloudFrontDefaultCertificate: {
              type: "boolean"
            },
            IAMCertificateId: {},
            ACMCertificateArn: {},
            SSLSupportMethod: {},
            MinimumProtocolVersion: {},
            Certificate: {
              deprecated: true
            },
            CertificateSource: {
              deprecated: true
            }
          }
        },
        S1n: {
          type: "structure",
          required: [
            "GeoRestriction"
          ],
          members: {
            GeoRestriction: {
              type: "structure",
              required: [
                "RestrictionType",
                "Quantity"
              ],
              members: {
                RestrictionType: {},
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Location"
                  }
                }
              }
            }
          }
        },
        S1t: {
          type: "structure",
          required: [
            "Id",
            "ARN",
            "Status",
            "LastModifiedTime",
            "InProgressInvalidationBatches",
            "DomainName",
            "ActiveTrustedSigners",
            "DistributionConfig"
          ],
          members: {
            Id: {},
            ARN: {},
            Status: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            InProgressInvalidationBatches: {
              type: "integer"
            },
            DomainName: {},
            ActiveTrustedSigners: {
              shape: "S1v"
            },
            DistributionConfig: {
              shape: "S7"
            }
          }
        },
        S1v: {
          type: "structure",
          required: [
            "Enabled",
            "Quantity"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Signer",
                type: "structure",
                members: {
                  AwsAccountNumber: {},
                  KeyPairIds: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "KeyPairId"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S22: {
          type: "structure",
          members: {
            Items: {
              type: "list",
              member: {
                locationName: "Tag",
                type: "structure",
                required: [
                  "Key"
                ],
                members: {
                  Key: {},
                  Value: {}
                }
              }
            }
          }
        },
        S29: {
          type: "structure",
          required: [
            "CallerReference"
          ],
          members: {
            CallerReference: {},
            Comment: {},
            QueryArgProfileConfig: {
              shape: "S2a"
            },
            ContentTypeProfileConfig: {
              shape: "S2e"
            }
          }
        },
        S2a: {
          type: "structure",
          required: [
            "ForwardWhenQueryArgProfileIsUnknown"
          ],
          members: {
            ForwardWhenQueryArgProfileIsUnknown: {
              type: "boolean"
            },
            QueryArgProfiles: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "QueryArgProfile",
                    type: "structure",
                    required: [
                      "QueryArg",
                      "ProfileId"
                    ],
                    members: {
                      QueryArg: {},
                      ProfileId: {}
                    }
                  }
                }
              }
            }
          }
        },
        S2e: {
          type: "structure",
          required: [
            "ForwardWhenContentTypeIsUnknown"
          ],
          members: {
            ForwardWhenContentTypeIsUnknown: {
              type: "boolean"
            },
            ContentTypeProfiles: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "ContentTypeProfile",
                    type: "structure",
                    required: [
                      "Format",
                      "ContentType"
                    ],
                    members: {
                      Format: {},
                      ProfileId: {},
                      ContentType: {}
                    }
                  }
                }
              }
            }
          }
        },
        S2k: {
          type: "structure",
          required: [
            "Id",
            "LastModifiedTime",
            "FieldLevelEncryptionConfig"
          ],
          members: {
            Id: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            FieldLevelEncryptionConfig: {
              shape: "S29"
            }
          }
        },
        S2m: {
          type: "structure",
          required: [
            "Name",
            "CallerReference",
            "EncryptionEntities"
          ],
          members: {
            Name: {},
            CallerReference: {},
            Comment: {},
            EncryptionEntities: {
              shape: "S2n"
            }
          }
        },
        S2n: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "EncryptionEntity",
                type: "structure",
                required: [
                  "PublicKeyId",
                  "ProviderId",
                  "FieldPatterns"
                ],
                members: {
                  PublicKeyId: {},
                  ProviderId: {},
                  FieldPatterns: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "FieldPattern"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S2t: {
          type: "structure",
          required: [
            "Id",
            "LastModifiedTime",
            "FieldLevelEncryptionProfileConfig"
          ],
          members: {
            Id: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            FieldLevelEncryptionProfileConfig: {
              shape: "S2m"
            }
          }
        },
        S2v: {
          type: "structure",
          required: [
            "Paths",
            "CallerReference"
          ],
          members: {
            Paths: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Path"
                  }
                }
              }
            },
            CallerReference: {}
          }
        },
        S2z: {
          type: "structure",
          required: [
            "Id",
            "Status",
            "CreateTime",
            "InvalidationBatch"
          ],
          members: {
            Id: {},
            Status: {},
            CreateTime: {
              type: "timestamp"
            },
            InvalidationBatch: {
              shape: "S2v"
            }
          }
        },
        S31: {
          type: "structure",
          required: [
            "CallerReference",
            "Name",
            "EncodedKey"
          ],
          members: {
            CallerReference: {},
            Name: {},
            EncodedKey: {},
            Comment: {}
          }
        },
        S33: {
          type: "structure",
          required: [
            "Id",
            "CreatedTime",
            "PublicKeyConfig"
          ],
          members: {
            Id: {},
            CreatedTime: {
              type: "timestamp"
            },
            PublicKeyConfig: {
              shape: "S31"
            }
          }
        },
        S35: {
          type: "structure",
          required: [
            "CallerReference",
            "S3Origin",
            "Comment",
            "TrustedSigners",
            "Enabled"
          ],
          members: {
            CallerReference: {},
            S3Origin: {
              shape: "S36"
            },
            Aliases: {
              shape: "S8"
            },
            Comment: {},
            Logging: {
              type: "structure",
              required: [
                "Enabled",
                "Bucket",
                "Prefix"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                Bucket: {},
                Prefix: {}
              }
            },
            TrustedSigners: {
              shape: "Sy"
            },
            PriceClass: {},
            Enabled: {
              type: "boolean"
            }
          }
        },
        S36: {
          type: "structure",
          required: [
            "DomainName",
            "OriginAccessIdentity"
          ],
          members: {
            DomainName: {},
            OriginAccessIdentity: {}
          }
        },
        S39: {
          type: "structure",
          required: [
            "Id",
            "ARN",
            "Status",
            "DomainName",
            "ActiveTrustedSigners",
            "StreamingDistributionConfig"
          ],
          members: {
            Id: {},
            ARN: {},
            Status: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            DomainName: {},
            ActiveTrustedSigners: {
              shape: "S1v"
            },
            StreamingDistributionConfig: {
              shape: "S35"
            }
          }
        },
        S4g: {
          type: "structure",
          required: [
            "Marker",
            "MaxItems",
            "IsTruncated",
            "Quantity"
          ],
          members: {
            Marker: {},
            NextMarker: {},
            MaxItems: {
              type: "integer"
            },
            IsTruncated: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "DistributionSummary",
                type: "structure",
                required: [
                  "Id",
                  "ARN",
                  "Status",
                  "LastModifiedTime",
                  "DomainName",
                  "Aliases",
                  "Origins",
                  "DefaultCacheBehavior",
                  "CacheBehaviors",
                  "CustomErrorResponses",
                  "Comment",
                  "PriceClass",
                  "Enabled",
                  "ViewerCertificate",
                  "Restrictions",
                  "WebACLId",
                  "HttpVersion",
                  "IsIPV6Enabled"
                ],
                members: {
                  Id: {},
                  ARN: {},
                  Status: {},
                  LastModifiedTime: {
                    type: "timestamp"
                  },
                  DomainName: {},
                  Aliases: {
                    shape: "S8"
                  },
                  Origins: {
                    shape: "Sb"
                  },
                  DefaultCacheBehavior: {
                    shape: "Sn"
                  },
                  CacheBehaviors: {
                    shape: "S1b"
                  },
                  CustomErrorResponses: {
                    shape: "S1e"
                  },
                  Comment: {},
                  PriceClass: {},
                  Enabled: {
                    type: "boolean"
                  },
                  ViewerCertificate: {
                    shape: "S1j"
                  },
                  Restrictions: {
                    shape: "S1n"
                  },
                  WebACLId: {},
                  HttpVersion: {},
                  IsIPV6Enabled: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2018-06-18.paginators.json
var require_cloudfront_2018_06_18_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2018-06-18.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListCloudFrontOriginAccessIdentities: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "CloudFrontOriginAccessIdentityList.IsTruncated",
          output_token: "CloudFrontOriginAccessIdentityList.NextMarker",
          result_key: "CloudFrontOriginAccessIdentityList.Items"
        },
        ListDistributions: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "DistributionList.IsTruncated",
          output_token: "DistributionList.NextMarker",
          result_key: "DistributionList.Items"
        },
        ListInvalidations: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "InvalidationList.IsTruncated",
          output_token: "InvalidationList.NextMarker",
          result_key: "InvalidationList.Items"
        },
        ListStreamingDistributions: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "StreamingDistributionList.IsTruncated",
          output_token: "StreamingDistributionList.NextMarker",
          result_key: "StreamingDistributionList.Items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2018-06-18.waiters2.json
var require_cloudfront_2018_06_18_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2018-06-18.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        DistributionDeployed: {
          delay: 60,
          operation: "GetDistribution",
          maxAttempts: 25,
          description: "Wait until a distribution is deployed.",
          acceptors: [
            {
              expected: "Deployed",
              matcher: "path",
              state: "success",
              argument: "Distribution.Status"
            }
          ]
        },
        InvalidationCompleted: {
          delay: 20,
          operation: "GetInvalidation",
          maxAttempts: 30,
          description: "Wait until an invalidation has completed.",
          acceptors: [
            {
              expected: "Completed",
              matcher: "path",
              state: "success",
              argument: "Invalidation.Status"
            }
          ]
        },
        StreamingDistributionDeployed: {
          delay: 60,
          operation: "GetStreamingDistribution",
          maxAttempts: 25,
          description: "Wait until a streaming distribution is deployed.",
          acceptors: [
            {
              expected: "Deployed",
              matcher: "path",
              state: "success",
              argument: "StreamingDistribution.Status"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2018-11-05.min.json
var require_cloudfront_2018_11_05_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2018-11-05.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-11-05",
        endpointPrefix: "cloudfront",
        globalEndpoint: "cloudfront.amazonaws.com",
        protocol: "rest-xml",
        serviceAbbreviation: "CloudFront",
        serviceFullName: "Amazon CloudFront",
        serviceId: "CloudFront",
        signatureVersion: "v4",
        uid: "cloudfront-2018-11-05"
      },
      operations: {
        CreateCloudFrontOriginAccessIdentity: {
          http: {
            requestUri: "/2018-11-05/origin-access-identity/cloudfront",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "CloudFrontOriginAccessIdentityConfig"
            ],
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2",
                locationName: "CloudFrontOriginAccessIdentityConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                }
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        CreateDistribution: {
          http: {
            requestUri: "/2018-11-05/distribution",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfig"
            ],
            members: {
              DistributionConfig: {
                shape: "S7",
                locationName: "DistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                }
              }
            },
            payload: "DistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S22"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        CreateDistributionWithTags: {
          http: {
            requestUri: "/2018-11-05/distribution?WithTags",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfigWithTags"
            ],
            members: {
              DistributionConfigWithTags: {
                locationName: "DistributionConfigWithTags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                },
                type: "structure",
                required: [
                  "DistributionConfig",
                  "Tags"
                ],
                members: {
                  DistributionConfig: {
                    shape: "S7"
                  },
                  Tags: {
                    shape: "S2b"
                  }
                }
              }
            },
            payload: "DistributionConfigWithTags"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S22"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        CreateFieldLevelEncryptionConfig: {
          http: {
            requestUri: "/2018-11-05/field-level-encryption",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionConfig"
            ],
            members: {
              FieldLevelEncryptionConfig: {
                shape: "S2i",
                locationName: "FieldLevelEncryptionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                }
              }
            },
            payload: "FieldLevelEncryptionConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryption: {
                shape: "S2t"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryption"
          }
        },
        CreateFieldLevelEncryptionProfile: {
          http: {
            requestUri: "/2018-11-05/field-level-encryption-profile",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionProfileConfig"
            ],
            members: {
              FieldLevelEncryptionProfileConfig: {
                shape: "S2v",
                locationName: "FieldLevelEncryptionProfileConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                }
              }
            },
            payload: "FieldLevelEncryptionProfileConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfile: {
                shape: "S32"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfile"
          }
        },
        CreateInvalidation: {
          http: {
            requestUri: "/2018-11-05/distribution/{DistributionId}/invalidation",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionId",
              "InvalidationBatch"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              InvalidationBatch: {
                shape: "S34",
                locationName: "InvalidationBatch",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                }
              }
            },
            payload: "InvalidationBatch"
          },
          output: {
            type: "structure",
            members: {
              Location: {
                location: "header",
                locationName: "Location"
              },
              Invalidation: {
                shape: "S38"
              }
            },
            payload: "Invalidation"
          }
        },
        CreatePublicKey: {
          http: {
            requestUri: "/2018-11-05/public-key",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "PublicKeyConfig"
            ],
            members: {
              PublicKeyConfig: {
                shape: "S3a",
                locationName: "PublicKeyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                }
              }
            },
            payload: "PublicKeyConfig"
          },
          output: {
            type: "structure",
            members: {
              PublicKey: {
                shape: "S3c"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKey"
          }
        },
        CreateStreamingDistribution: {
          http: {
            requestUri: "/2018-11-05/streaming-distribution",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfig"
            ],
            members: {
              StreamingDistributionConfig: {
                shape: "S3e",
                locationName: "StreamingDistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                }
              }
            },
            payload: "StreamingDistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S3i"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        CreateStreamingDistributionWithTags: {
          http: {
            requestUri: "/2018-11-05/streaming-distribution?WithTags",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfigWithTags"
            ],
            members: {
              StreamingDistributionConfigWithTags: {
                locationName: "StreamingDistributionConfigWithTags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                },
                type: "structure",
                required: [
                  "StreamingDistributionConfig",
                  "Tags"
                ],
                members: {
                  StreamingDistributionConfig: {
                    shape: "S3e"
                  },
                  Tags: {
                    shape: "S2b"
                  }
                }
              }
            },
            payload: "StreamingDistributionConfigWithTags"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S3i"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        DeleteCloudFrontOriginAccessIdentity: {
          http: {
            method: "DELETE",
            requestUri: "/2018-11-05/origin-access-identity/cloudfront/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteDistribution: {
          http: {
            method: "DELETE",
            requestUri: "/2018-11-05/distribution/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteFieldLevelEncryptionConfig: {
          http: {
            method: "DELETE",
            requestUri: "/2018-11-05/field-level-encryption/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteFieldLevelEncryptionProfile: {
          http: {
            method: "DELETE",
            requestUri: "/2018-11-05/field-level-encryption-profile/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeletePublicKey: {
          http: {
            method: "DELETE",
            requestUri: "/2018-11-05/public-key/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteStreamingDistribution: {
          http: {
            method: "DELETE",
            requestUri: "/2018-11-05/streaming-distribution/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        GetCloudFrontOriginAccessIdentity: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/origin-access-identity/cloudfront/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        GetCloudFrontOriginAccessIdentityConfig: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/origin-access-identity/cloudfront/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          }
        },
        GetDistribution: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/distribution/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S22"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        GetDistributionConfig: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionConfig: {
                shape: "S7"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "DistributionConfig"
          }
        },
        GetFieldLevelEncryption: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/field-level-encryption/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryption: {
                shape: "S2t"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryption"
          }
        },
        GetFieldLevelEncryptionConfig: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/field-level-encryption/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionConfig: {
                shape: "S2i"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionConfig"
          }
        },
        GetFieldLevelEncryptionProfile: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/field-level-encryption-profile/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfile: {
                shape: "S32"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfile"
          }
        },
        GetFieldLevelEncryptionProfileConfig: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/field-level-encryption-profile/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfileConfig: {
                shape: "S2v"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfileConfig"
          }
        },
        GetInvalidation: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/distribution/{DistributionId}/invalidation/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId",
              "Id"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Invalidation: {
                shape: "S38"
              }
            },
            payload: "Invalidation"
          }
        },
        GetPublicKey: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/public-key/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKey: {
                shape: "S3c"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKey"
          }
        },
        GetPublicKeyConfig: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/public-key/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKeyConfig: {
                shape: "S3a"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKeyConfig"
          }
        },
        GetStreamingDistribution: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/streaming-distribution/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S3i"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        GetStreamingDistributionConfig: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/streaming-distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistributionConfig: {
                shape: "S3e"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistributionConfig"
          }
        },
        ListCloudFrontOriginAccessIdentities: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/origin-access-identity/cloudfront"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentityList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "CloudFrontOriginAccessIdentitySummary",
                      type: "structure",
                      required: [
                        "Id",
                        "S3CanonicalUserId",
                        "Comment"
                      ],
                      members: {
                        Id: {},
                        S3CanonicalUserId: {},
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "CloudFrontOriginAccessIdentityList"
          }
        },
        ListDistributions: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/distribution"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionList: {
                shape: "S4p"
              }
            },
            payload: "DistributionList"
          }
        },
        ListDistributionsByWebACLId: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/distributionsByWebACLId/{WebACLId}"
          },
          input: {
            type: "structure",
            required: [
              "WebACLId"
            ],
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              },
              WebACLId: {
                location: "uri",
                locationName: "WebACLId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionList: {
                shape: "S4p"
              }
            },
            payload: "DistributionList"
          }
        },
        ListFieldLevelEncryptionConfigs: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/field-level-encryption"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "FieldLevelEncryptionSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "LastModifiedTime"
                      ],
                      members: {
                        Id: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        Comment: {},
                        QueryArgProfileConfig: {
                          shape: "S2j"
                        },
                        ContentTypeProfileConfig: {
                          shape: "S2n"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "FieldLevelEncryptionList"
          }
        },
        ListFieldLevelEncryptionProfiles: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/field-level-encryption-profile"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfileList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "FieldLevelEncryptionProfileSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "LastModifiedTime",
                        "Name",
                        "EncryptionEntities"
                      ],
                      members: {
                        Id: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        Name: {},
                        EncryptionEntities: {
                          shape: "S2w"
                        },
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "FieldLevelEncryptionProfileList"
          }
        },
        ListInvalidations: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/distribution/{DistributionId}/invalidation"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InvalidationList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "InvalidationSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "CreateTime",
                        "Status"
                      ],
                      members: {
                        Id: {},
                        CreateTime: {
                          type: "timestamp"
                        },
                        Status: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "InvalidationList"
          }
        },
        ListPublicKeys: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/public-key"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKeyList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "PublicKeySummary",
                      type: "structure",
                      required: [
                        "Id",
                        "Name",
                        "CreatedTime",
                        "EncodedKey"
                      ],
                      members: {
                        Id: {},
                        Name: {},
                        CreatedTime: {
                          type: "timestamp"
                        },
                        EncodedKey: {},
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "PublicKeyList"
          }
        },
        ListStreamingDistributions: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/streaming-distribution"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistributionList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "StreamingDistributionSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "ARN",
                        "Status",
                        "LastModifiedTime",
                        "DomainName",
                        "S3Origin",
                        "Aliases",
                        "TrustedSigners",
                        "Comment",
                        "PriceClass",
                        "Enabled"
                      ],
                      members: {
                        Id: {},
                        ARN: {},
                        Status: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        DomainName: {},
                        S3Origin: {
                          shape: "S3f"
                        },
                        Aliases: {
                          shape: "S8"
                        },
                        TrustedSigners: {
                          shape: "S17"
                        },
                        Comment: {},
                        PriceClass: {},
                        Enabled: {
                          type: "boolean"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "StreamingDistributionList"
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/tagging"
          },
          input: {
            type: "structure",
            required: [
              "Resource"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "S2b"
              }
            },
            payload: "Tags"
          }
        },
        TagResource: {
          http: {
            requestUri: "/2018-11-05/tagging?Operation=Tag",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "Tags"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              },
              Tags: {
                shape: "S2b",
                locationName: "Tags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                }
              }
            },
            payload: "Tags"
          }
        },
        UntagResource: {
          http: {
            requestUri: "/2018-11-05/tagging?Operation=Untag",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "TagKeys"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              },
              TagKeys: {
                locationName: "TagKeys",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                },
                type: "structure",
                members: {
                  Items: {
                    type: "list",
                    member: {
                      locationName: "Key"
                    }
                  }
                }
              }
            },
            payload: "TagKeys"
          }
        },
        UpdateCloudFrontOriginAccessIdentity: {
          http: {
            method: "PUT",
            requestUri: "/2018-11-05/origin-access-identity/cloudfront/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "CloudFrontOriginAccessIdentityConfig",
              "Id"
            ],
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2",
                locationName: "CloudFrontOriginAccessIdentityConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        UpdateDistribution: {
          http: {
            method: "PUT",
            requestUri: "/2018-11-05/distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfig",
              "Id"
            ],
            members: {
              DistributionConfig: {
                shape: "S7",
                locationName: "DistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "DistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S22"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        UpdateFieldLevelEncryptionConfig: {
          http: {
            method: "PUT",
            requestUri: "/2018-11-05/field-level-encryption/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionConfig",
              "Id"
            ],
            members: {
              FieldLevelEncryptionConfig: {
                shape: "S2i",
                locationName: "FieldLevelEncryptionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "FieldLevelEncryptionConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryption: {
                shape: "S2t"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryption"
          }
        },
        UpdateFieldLevelEncryptionProfile: {
          http: {
            method: "PUT",
            requestUri: "/2018-11-05/field-level-encryption-profile/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionProfileConfig",
              "Id"
            ],
            members: {
              FieldLevelEncryptionProfileConfig: {
                shape: "S2v",
                locationName: "FieldLevelEncryptionProfileConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "FieldLevelEncryptionProfileConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfile: {
                shape: "S32"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfile"
          }
        },
        UpdatePublicKey: {
          http: {
            method: "PUT",
            requestUri: "/2018-11-05/public-key/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "PublicKeyConfig",
              "Id"
            ],
            members: {
              PublicKeyConfig: {
                shape: "S3a",
                locationName: "PublicKeyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "PublicKeyConfig"
          },
          output: {
            type: "structure",
            members: {
              PublicKey: {
                shape: "S3c"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKey"
          }
        },
        UpdateStreamingDistribution: {
          http: {
            method: "PUT",
            requestUri: "/2018-11-05/streaming-distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfig",
              "Id"
            ],
            members: {
              StreamingDistributionConfig: {
                shape: "S3e",
                locationName: "StreamingDistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "StreamingDistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S3i"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          required: [
            "CallerReference",
            "Comment"
          ],
          members: {
            CallerReference: {},
            Comment: {}
          }
        },
        S5: {
          type: "structure",
          required: [
            "Id",
            "S3CanonicalUserId"
          ],
          members: {
            Id: {},
            S3CanonicalUserId: {},
            CloudFrontOriginAccessIdentityConfig: {
              shape: "S2"
            }
          }
        },
        S7: {
          type: "structure",
          required: [
            "CallerReference",
            "Origins",
            "DefaultCacheBehavior",
            "Comment",
            "Enabled"
          ],
          members: {
            CallerReference: {},
            Aliases: {
              shape: "S8"
            },
            DefaultRootObject: {},
            Origins: {
              shape: "Sb"
            },
            OriginGroups: {
              shape: "Sn"
            },
            DefaultCacheBehavior: {
              shape: "Sw"
            },
            CacheBehaviors: {
              shape: "S1k"
            },
            CustomErrorResponses: {
              shape: "S1n"
            },
            Comment: {},
            Logging: {
              type: "structure",
              required: [
                "Enabled",
                "IncludeCookies",
                "Bucket",
                "Prefix"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                IncludeCookies: {
                  type: "boolean"
                },
                Bucket: {},
                Prefix: {}
              }
            },
            PriceClass: {},
            Enabled: {
              type: "boolean"
            },
            ViewerCertificate: {
              shape: "S1s"
            },
            Restrictions: {
              shape: "S1w"
            },
            WebACLId: {},
            HttpVersion: {},
            IsIPV6Enabled: {
              type: "boolean"
            }
          }
        },
        S8: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CNAME"
              }
            }
          }
        },
        Sb: {
          type: "structure",
          required: [
            "Quantity",
            "Items"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Origin",
                type: "structure",
                required: [
                  "Id",
                  "DomainName"
                ],
                members: {
                  Id: {},
                  DomainName: {},
                  OriginPath: {},
                  CustomHeaders: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "OriginCustomHeader",
                          type: "structure",
                          required: [
                            "HeaderName",
                            "HeaderValue"
                          ],
                          members: {
                            HeaderName: {},
                            HeaderValue: {}
                          }
                        }
                      }
                    }
                  },
                  S3OriginConfig: {
                    type: "structure",
                    required: [
                      "OriginAccessIdentity"
                    ],
                    members: {
                      OriginAccessIdentity: {}
                    }
                  },
                  CustomOriginConfig: {
                    type: "structure",
                    required: [
                      "HTTPPort",
                      "HTTPSPort",
                      "OriginProtocolPolicy"
                    ],
                    members: {
                      HTTPPort: {
                        type: "integer"
                      },
                      HTTPSPort: {
                        type: "integer"
                      },
                      OriginProtocolPolicy: {},
                      OriginSslProtocols: {
                        type: "structure",
                        required: [
                          "Quantity",
                          "Items"
                        ],
                        members: {
                          Quantity: {
                            type: "integer"
                          },
                          Items: {
                            type: "list",
                            member: {
                              locationName: "SslProtocol"
                            }
                          }
                        }
                      },
                      OriginReadTimeout: {
                        type: "integer"
                      },
                      OriginKeepaliveTimeout: {
                        type: "integer"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sn: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "OriginGroup",
                type: "structure",
                required: [
                  "Id",
                  "FailoverCriteria",
                  "Members"
                ],
                members: {
                  Id: {},
                  FailoverCriteria: {
                    type: "structure",
                    required: [
                      "StatusCodes"
                    ],
                    members: {
                      StatusCodes: {
                        type: "structure",
                        required: [
                          "Quantity",
                          "Items"
                        ],
                        members: {
                          Quantity: {
                            type: "integer"
                          },
                          Items: {
                            type: "list",
                            member: {
                              locationName: "StatusCode",
                              type: "integer"
                            }
                          }
                        }
                      }
                    }
                  },
                  Members: {
                    type: "structure",
                    required: [
                      "Quantity",
                      "Items"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "OriginGroupMember",
                          type: "structure",
                          required: [
                            "OriginId"
                          ],
                          members: {
                            OriginId: {}
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sw: {
          type: "structure",
          required: [
            "TargetOriginId",
            "ForwardedValues",
            "TrustedSigners",
            "ViewerProtocolPolicy",
            "MinTTL"
          ],
          members: {
            TargetOriginId: {},
            ForwardedValues: {
              shape: "Sx"
            },
            TrustedSigners: {
              shape: "S17"
            },
            ViewerProtocolPolicy: {},
            MinTTL: {
              type: "long"
            },
            AllowedMethods: {
              shape: "S1b"
            },
            SmoothStreaming: {
              type: "boolean"
            },
            DefaultTTL: {
              type: "long"
            },
            MaxTTL: {
              type: "long"
            },
            Compress: {
              type: "boolean"
            },
            LambdaFunctionAssociations: {
              shape: "S1f"
            },
            FieldLevelEncryptionId: {}
          }
        },
        Sx: {
          type: "structure",
          required: [
            "QueryString",
            "Cookies"
          ],
          members: {
            QueryString: {
              type: "boolean"
            },
            Cookies: {
              type: "structure",
              required: [
                "Forward"
              ],
              members: {
                Forward: {},
                WhitelistedNames: {
                  type: "structure",
                  required: [
                    "Quantity"
                  ],
                  members: {
                    Quantity: {
                      type: "integer"
                    },
                    Items: {
                      type: "list",
                      member: {
                        locationName: "Name"
                      }
                    }
                  }
                }
              }
            },
            Headers: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Name"
                  }
                }
              }
            },
            QueryStringCacheKeys: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Name"
                  }
                }
              }
            }
          }
        },
        S17: {
          type: "structure",
          required: [
            "Enabled",
            "Quantity"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "AwsAccountNumber"
              }
            }
          }
        },
        S1b: {
          type: "structure",
          required: [
            "Quantity",
            "Items"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              shape: "S1c"
            },
            CachedMethods: {
              type: "structure",
              required: [
                "Quantity",
                "Items"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  shape: "S1c"
                }
              }
            }
          }
        },
        S1c: {
          type: "list",
          member: {
            locationName: "Method"
          }
        },
        S1f: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "LambdaFunctionAssociation",
                type: "structure",
                required: [
                  "LambdaFunctionARN",
                  "EventType"
                ],
                members: {
                  LambdaFunctionARN: {},
                  EventType: {},
                  IncludeBody: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        S1k: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CacheBehavior",
                type: "structure",
                required: [
                  "PathPattern",
                  "TargetOriginId",
                  "ForwardedValues",
                  "TrustedSigners",
                  "ViewerProtocolPolicy",
                  "MinTTL"
                ],
                members: {
                  PathPattern: {},
                  TargetOriginId: {},
                  ForwardedValues: {
                    shape: "Sx"
                  },
                  TrustedSigners: {
                    shape: "S17"
                  },
                  ViewerProtocolPolicy: {},
                  MinTTL: {
                    type: "long"
                  },
                  AllowedMethods: {
                    shape: "S1b"
                  },
                  SmoothStreaming: {
                    type: "boolean"
                  },
                  DefaultTTL: {
                    type: "long"
                  },
                  MaxTTL: {
                    type: "long"
                  },
                  Compress: {
                    type: "boolean"
                  },
                  LambdaFunctionAssociations: {
                    shape: "S1f"
                  },
                  FieldLevelEncryptionId: {}
                }
              }
            }
          }
        },
        S1n: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CustomErrorResponse",
                type: "structure",
                required: [
                  "ErrorCode"
                ],
                members: {
                  ErrorCode: {
                    type: "integer"
                  },
                  ResponsePagePath: {},
                  ResponseCode: {},
                  ErrorCachingMinTTL: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        S1s: {
          type: "structure",
          members: {
            CloudFrontDefaultCertificate: {
              type: "boolean"
            },
            IAMCertificateId: {},
            ACMCertificateArn: {},
            SSLSupportMethod: {},
            MinimumProtocolVersion: {},
            Certificate: {
              deprecated: true
            },
            CertificateSource: {
              deprecated: true
            }
          }
        },
        S1w: {
          type: "structure",
          required: [
            "GeoRestriction"
          ],
          members: {
            GeoRestriction: {
              type: "structure",
              required: [
                "RestrictionType",
                "Quantity"
              ],
              members: {
                RestrictionType: {},
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Location"
                  }
                }
              }
            }
          }
        },
        S22: {
          type: "structure",
          required: [
            "Id",
            "ARN",
            "Status",
            "LastModifiedTime",
            "InProgressInvalidationBatches",
            "DomainName",
            "ActiveTrustedSigners",
            "DistributionConfig"
          ],
          members: {
            Id: {},
            ARN: {},
            Status: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            InProgressInvalidationBatches: {
              type: "integer"
            },
            DomainName: {},
            ActiveTrustedSigners: {
              shape: "S24"
            },
            DistributionConfig: {
              shape: "S7"
            }
          }
        },
        S24: {
          type: "structure",
          required: [
            "Enabled",
            "Quantity"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Signer",
                type: "structure",
                members: {
                  AwsAccountNumber: {},
                  KeyPairIds: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "KeyPairId"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S2b: {
          type: "structure",
          members: {
            Items: {
              type: "list",
              member: {
                locationName: "Tag",
                type: "structure",
                required: [
                  "Key"
                ],
                members: {
                  Key: {},
                  Value: {}
                }
              }
            }
          }
        },
        S2i: {
          type: "structure",
          required: [
            "CallerReference"
          ],
          members: {
            CallerReference: {},
            Comment: {},
            QueryArgProfileConfig: {
              shape: "S2j"
            },
            ContentTypeProfileConfig: {
              shape: "S2n"
            }
          }
        },
        S2j: {
          type: "structure",
          required: [
            "ForwardWhenQueryArgProfileIsUnknown"
          ],
          members: {
            ForwardWhenQueryArgProfileIsUnknown: {
              type: "boolean"
            },
            QueryArgProfiles: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "QueryArgProfile",
                    type: "structure",
                    required: [
                      "QueryArg",
                      "ProfileId"
                    ],
                    members: {
                      QueryArg: {},
                      ProfileId: {}
                    }
                  }
                }
              }
            }
          }
        },
        S2n: {
          type: "structure",
          required: [
            "ForwardWhenContentTypeIsUnknown"
          ],
          members: {
            ForwardWhenContentTypeIsUnknown: {
              type: "boolean"
            },
            ContentTypeProfiles: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "ContentTypeProfile",
                    type: "structure",
                    required: [
                      "Format",
                      "ContentType"
                    ],
                    members: {
                      Format: {},
                      ProfileId: {},
                      ContentType: {}
                    }
                  }
                }
              }
            }
          }
        },
        S2t: {
          type: "structure",
          required: [
            "Id",
            "LastModifiedTime",
            "FieldLevelEncryptionConfig"
          ],
          members: {
            Id: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            FieldLevelEncryptionConfig: {
              shape: "S2i"
            }
          }
        },
        S2v: {
          type: "structure",
          required: [
            "Name",
            "CallerReference",
            "EncryptionEntities"
          ],
          members: {
            Name: {},
            CallerReference: {},
            Comment: {},
            EncryptionEntities: {
              shape: "S2w"
            }
          }
        },
        S2w: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "EncryptionEntity",
                type: "structure",
                required: [
                  "PublicKeyId",
                  "ProviderId",
                  "FieldPatterns"
                ],
                members: {
                  PublicKeyId: {},
                  ProviderId: {},
                  FieldPatterns: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "FieldPattern"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S32: {
          type: "structure",
          required: [
            "Id",
            "LastModifiedTime",
            "FieldLevelEncryptionProfileConfig"
          ],
          members: {
            Id: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            FieldLevelEncryptionProfileConfig: {
              shape: "S2v"
            }
          }
        },
        S34: {
          type: "structure",
          required: [
            "Paths",
            "CallerReference"
          ],
          members: {
            Paths: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Path"
                  }
                }
              }
            },
            CallerReference: {}
          }
        },
        S38: {
          type: "structure",
          required: [
            "Id",
            "Status",
            "CreateTime",
            "InvalidationBatch"
          ],
          members: {
            Id: {},
            Status: {},
            CreateTime: {
              type: "timestamp"
            },
            InvalidationBatch: {
              shape: "S34"
            }
          }
        },
        S3a: {
          type: "structure",
          required: [
            "CallerReference",
            "Name",
            "EncodedKey"
          ],
          members: {
            CallerReference: {},
            Name: {},
            EncodedKey: {},
            Comment: {}
          }
        },
        S3c: {
          type: "structure",
          required: [
            "Id",
            "CreatedTime",
            "PublicKeyConfig"
          ],
          members: {
            Id: {},
            CreatedTime: {
              type: "timestamp"
            },
            PublicKeyConfig: {
              shape: "S3a"
            }
          }
        },
        S3e: {
          type: "structure",
          required: [
            "CallerReference",
            "S3Origin",
            "Comment",
            "TrustedSigners",
            "Enabled"
          ],
          members: {
            CallerReference: {},
            S3Origin: {
              shape: "S3f"
            },
            Aliases: {
              shape: "S8"
            },
            Comment: {},
            Logging: {
              type: "structure",
              required: [
                "Enabled",
                "Bucket",
                "Prefix"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                Bucket: {},
                Prefix: {}
              }
            },
            TrustedSigners: {
              shape: "S17"
            },
            PriceClass: {},
            Enabled: {
              type: "boolean"
            }
          }
        },
        S3f: {
          type: "structure",
          required: [
            "DomainName",
            "OriginAccessIdentity"
          ],
          members: {
            DomainName: {},
            OriginAccessIdentity: {}
          }
        },
        S3i: {
          type: "structure",
          required: [
            "Id",
            "ARN",
            "Status",
            "DomainName",
            "ActiveTrustedSigners",
            "StreamingDistributionConfig"
          ],
          members: {
            Id: {},
            ARN: {},
            Status: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            DomainName: {},
            ActiveTrustedSigners: {
              shape: "S24"
            },
            StreamingDistributionConfig: {
              shape: "S3e"
            }
          }
        },
        S4p: {
          type: "structure",
          required: [
            "Marker",
            "MaxItems",
            "IsTruncated",
            "Quantity"
          ],
          members: {
            Marker: {},
            NextMarker: {},
            MaxItems: {
              type: "integer"
            },
            IsTruncated: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "DistributionSummary",
                type: "structure",
                required: [
                  "Id",
                  "ARN",
                  "Status",
                  "LastModifiedTime",
                  "DomainName",
                  "Aliases",
                  "Origins",
                  "DefaultCacheBehavior",
                  "CacheBehaviors",
                  "CustomErrorResponses",
                  "Comment",
                  "PriceClass",
                  "Enabled",
                  "ViewerCertificate",
                  "Restrictions",
                  "WebACLId",
                  "HttpVersion",
                  "IsIPV6Enabled"
                ],
                members: {
                  Id: {},
                  ARN: {},
                  Status: {},
                  LastModifiedTime: {
                    type: "timestamp"
                  },
                  DomainName: {},
                  Aliases: {
                    shape: "S8"
                  },
                  Origins: {
                    shape: "Sb"
                  },
                  OriginGroups: {
                    shape: "Sn"
                  },
                  DefaultCacheBehavior: {
                    shape: "Sw"
                  },
                  CacheBehaviors: {
                    shape: "S1k"
                  },
                  CustomErrorResponses: {
                    shape: "S1n"
                  },
                  Comment: {},
                  PriceClass: {},
                  Enabled: {
                    type: "boolean"
                  },
                  ViewerCertificate: {
                    shape: "S1s"
                  },
                  Restrictions: {
                    shape: "S1w"
                  },
                  WebACLId: {},
                  HttpVersion: {},
                  IsIPV6Enabled: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2018-11-05.paginators.json
var require_cloudfront_2018_11_05_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2018-11-05.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListCloudFrontOriginAccessIdentities: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "CloudFrontOriginAccessIdentityList.IsTruncated",
          output_token: "CloudFrontOriginAccessIdentityList.NextMarker",
          result_key: "CloudFrontOriginAccessIdentityList.Items"
        },
        ListDistributions: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "DistributionList.IsTruncated",
          output_token: "DistributionList.NextMarker",
          result_key: "DistributionList.Items"
        },
        ListInvalidations: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "InvalidationList.IsTruncated",
          output_token: "InvalidationList.NextMarker",
          result_key: "InvalidationList.Items"
        },
        ListStreamingDistributions: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "StreamingDistributionList.IsTruncated",
          output_token: "StreamingDistributionList.NextMarker",
          result_key: "StreamingDistributionList.Items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2018-11-05.waiters2.json
var require_cloudfront_2018_11_05_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2018-11-05.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        DistributionDeployed: {
          delay: 60,
          operation: "GetDistribution",
          maxAttempts: 25,
          description: "Wait until a distribution is deployed.",
          acceptors: [
            {
              expected: "Deployed",
              matcher: "path",
              state: "success",
              argument: "Distribution.Status"
            }
          ]
        },
        InvalidationCompleted: {
          delay: 20,
          operation: "GetInvalidation",
          maxAttempts: 30,
          description: "Wait until an invalidation has completed.",
          acceptors: [
            {
              expected: "Completed",
              matcher: "path",
              state: "success",
              argument: "Invalidation.Status"
            }
          ]
        },
        StreamingDistributionDeployed: {
          delay: 60,
          operation: "GetStreamingDistribution",
          maxAttempts: 25,
          description: "Wait until a streaming distribution is deployed.",
          acceptors: [
            {
              expected: "Deployed",
              matcher: "path",
              state: "success",
              argument: "StreamingDistribution.Status"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2019-03-26.min.json
var require_cloudfront_2019_03_26_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2019-03-26.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-03-26",
        endpointPrefix: "cloudfront",
        globalEndpoint: "cloudfront.amazonaws.com",
        protocol: "rest-xml",
        serviceAbbreviation: "CloudFront",
        serviceFullName: "Amazon CloudFront",
        serviceId: "CloudFront",
        signatureVersion: "v4",
        uid: "cloudfront-2019-03-26"
      },
      operations: {
        CreateCloudFrontOriginAccessIdentity: {
          http: {
            requestUri: "/2019-03-26/origin-access-identity/cloudfront",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "CloudFrontOriginAccessIdentityConfig"
            ],
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2",
                locationName: "CloudFrontOriginAccessIdentityConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                }
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        CreateDistribution: {
          http: {
            requestUri: "/2019-03-26/distribution",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfig"
            ],
            members: {
              DistributionConfig: {
                shape: "S7",
                locationName: "DistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                }
              }
            },
            payload: "DistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S23"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        CreateDistributionWithTags: {
          http: {
            requestUri: "/2019-03-26/distribution?WithTags",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfigWithTags"
            ],
            members: {
              DistributionConfigWithTags: {
                locationName: "DistributionConfigWithTags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                },
                type: "structure",
                required: [
                  "DistributionConfig",
                  "Tags"
                ],
                members: {
                  DistributionConfig: {
                    shape: "S7"
                  },
                  Tags: {
                    shape: "S2f"
                  }
                }
              }
            },
            payload: "DistributionConfigWithTags"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S23"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        CreateFieldLevelEncryptionConfig: {
          http: {
            requestUri: "/2019-03-26/field-level-encryption",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionConfig"
            ],
            members: {
              FieldLevelEncryptionConfig: {
                shape: "S2m",
                locationName: "FieldLevelEncryptionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                }
              }
            },
            payload: "FieldLevelEncryptionConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryption: {
                shape: "S2x"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryption"
          }
        },
        CreateFieldLevelEncryptionProfile: {
          http: {
            requestUri: "/2019-03-26/field-level-encryption-profile",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionProfileConfig"
            ],
            members: {
              FieldLevelEncryptionProfileConfig: {
                shape: "S2z",
                locationName: "FieldLevelEncryptionProfileConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                }
              }
            },
            payload: "FieldLevelEncryptionProfileConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfile: {
                shape: "S36"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfile"
          }
        },
        CreateInvalidation: {
          http: {
            requestUri: "/2019-03-26/distribution/{DistributionId}/invalidation",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionId",
              "InvalidationBatch"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              InvalidationBatch: {
                shape: "S38",
                locationName: "InvalidationBatch",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                }
              }
            },
            payload: "InvalidationBatch"
          },
          output: {
            type: "structure",
            members: {
              Location: {
                location: "header",
                locationName: "Location"
              },
              Invalidation: {
                shape: "S3c"
              }
            },
            payload: "Invalidation"
          }
        },
        CreatePublicKey: {
          http: {
            requestUri: "/2019-03-26/public-key",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "PublicKeyConfig"
            ],
            members: {
              PublicKeyConfig: {
                shape: "S3e",
                locationName: "PublicKeyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                }
              }
            },
            payload: "PublicKeyConfig"
          },
          output: {
            type: "structure",
            members: {
              PublicKey: {
                shape: "S3g"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKey"
          }
        },
        CreateStreamingDistribution: {
          http: {
            requestUri: "/2019-03-26/streaming-distribution",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfig"
            ],
            members: {
              StreamingDistributionConfig: {
                shape: "S3i",
                locationName: "StreamingDistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                }
              }
            },
            payload: "StreamingDistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S3m"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        CreateStreamingDistributionWithTags: {
          http: {
            requestUri: "/2019-03-26/streaming-distribution?WithTags",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfigWithTags"
            ],
            members: {
              StreamingDistributionConfigWithTags: {
                locationName: "StreamingDistributionConfigWithTags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                },
                type: "structure",
                required: [
                  "StreamingDistributionConfig",
                  "Tags"
                ],
                members: {
                  StreamingDistributionConfig: {
                    shape: "S3i"
                  },
                  Tags: {
                    shape: "S2f"
                  }
                }
              }
            },
            payload: "StreamingDistributionConfigWithTags"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S3m"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        DeleteCloudFrontOriginAccessIdentity: {
          http: {
            method: "DELETE",
            requestUri: "/2019-03-26/origin-access-identity/cloudfront/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteDistribution: {
          http: {
            method: "DELETE",
            requestUri: "/2019-03-26/distribution/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteFieldLevelEncryptionConfig: {
          http: {
            method: "DELETE",
            requestUri: "/2019-03-26/field-level-encryption/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteFieldLevelEncryptionProfile: {
          http: {
            method: "DELETE",
            requestUri: "/2019-03-26/field-level-encryption-profile/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeletePublicKey: {
          http: {
            method: "DELETE",
            requestUri: "/2019-03-26/public-key/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteStreamingDistribution: {
          http: {
            method: "DELETE",
            requestUri: "/2019-03-26/streaming-distribution/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        GetCloudFrontOriginAccessIdentity: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/origin-access-identity/cloudfront/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        GetCloudFrontOriginAccessIdentityConfig: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/origin-access-identity/cloudfront/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          }
        },
        GetDistribution: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/distribution/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S23"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        GetDistributionConfig: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionConfig: {
                shape: "S7"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "DistributionConfig"
          }
        },
        GetFieldLevelEncryption: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/field-level-encryption/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryption: {
                shape: "S2x"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryption"
          }
        },
        GetFieldLevelEncryptionConfig: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/field-level-encryption/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionConfig: {
                shape: "S2m"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionConfig"
          }
        },
        GetFieldLevelEncryptionProfile: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/field-level-encryption-profile/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfile: {
                shape: "S36"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfile"
          }
        },
        GetFieldLevelEncryptionProfileConfig: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/field-level-encryption-profile/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfileConfig: {
                shape: "S2z"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfileConfig"
          }
        },
        GetInvalidation: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/distribution/{DistributionId}/invalidation/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId",
              "Id"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Invalidation: {
                shape: "S3c"
              }
            },
            payload: "Invalidation"
          }
        },
        GetPublicKey: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/public-key/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKey: {
                shape: "S3g"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKey"
          }
        },
        GetPublicKeyConfig: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/public-key/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKeyConfig: {
                shape: "S3e"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKeyConfig"
          }
        },
        GetStreamingDistribution: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/streaming-distribution/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S3m"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        GetStreamingDistributionConfig: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/streaming-distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistributionConfig: {
                shape: "S3i"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistributionConfig"
          }
        },
        ListCloudFrontOriginAccessIdentities: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/origin-access-identity/cloudfront"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentityList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "CloudFrontOriginAccessIdentitySummary",
                      type: "structure",
                      required: [
                        "Id",
                        "S3CanonicalUserId",
                        "Comment"
                      ],
                      members: {
                        Id: {},
                        S3CanonicalUserId: {},
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "CloudFrontOriginAccessIdentityList"
          }
        },
        ListDistributions: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/distribution"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionList: {
                shape: "S4t"
              }
            },
            payload: "DistributionList"
          }
        },
        ListDistributionsByWebACLId: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/distributionsByWebACLId/{WebACLId}"
          },
          input: {
            type: "structure",
            required: [
              "WebACLId"
            ],
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              },
              WebACLId: {
                location: "uri",
                locationName: "WebACLId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionList: {
                shape: "S4t"
              }
            },
            payload: "DistributionList"
          }
        },
        ListFieldLevelEncryptionConfigs: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/field-level-encryption"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "FieldLevelEncryptionSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "LastModifiedTime"
                      ],
                      members: {
                        Id: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        Comment: {},
                        QueryArgProfileConfig: {
                          shape: "S2n"
                        },
                        ContentTypeProfileConfig: {
                          shape: "S2r"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "FieldLevelEncryptionList"
          }
        },
        ListFieldLevelEncryptionProfiles: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/field-level-encryption-profile"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfileList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "FieldLevelEncryptionProfileSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "LastModifiedTime",
                        "Name",
                        "EncryptionEntities"
                      ],
                      members: {
                        Id: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        Name: {},
                        EncryptionEntities: {
                          shape: "S30"
                        },
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "FieldLevelEncryptionProfileList"
          }
        },
        ListInvalidations: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/distribution/{DistributionId}/invalidation"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InvalidationList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "InvalidationSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "CreateTime",
                        "Status"
                      ],
                      members: {
                        Id: {},
                        CreateTime: {
                          type: "timestamp"
                        },
                        Status: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "InvalidationList"
          }
        },
        ListPublicKeys: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/public-key"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKeyList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "PublicKeySummary",
                      type: "structure",
                      required: [
                        "Id",
                        "Name",
                        "CreatedTime",
                        "EncodedKey"
                      ],
                      members: {
                        Id: {},
                        Name: {},
                        CreatedTime: {
                          type: "timestamp"
                        },
                        EncodedKey: {},
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "PublicKeyList"
          }
        },
        ListStreamingDistributions: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/streaming-distribution"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistributionList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "StreamingDistributionSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "ARN",
                        "Status",
                        "LastModifiedTime",
                        "DomainName",
                        "S3Origin",
                        "Aliases",
                        "TrustedSigners",
                        "Comment",
                        "PriceClass",
                        "Enabled"
                      ],
                      members: {
                        Id: {},
                        ARN: {},
                        Status: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        DomainName: {},
                        S3Origin: {
                          shape: "S3j"
                        },
                        Aliases: {
                          shape: "S8"
                        },
                        TrustedSigners: {
                          shape: "S17"
                        },
                        Comment: {},
                        PriceClass: {},
                        Enabled: {
                          type: "boolean"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "StreamingDistributionList"
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/tagging"
          },
          input: {
            type: "structure",
            required: [
              "Resource"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "S2f"
              }
            },
            payload: "Tags"
          }
        },
        TagResource: {
          http: {
            requestUri: "/2019-03-26/tagging?Operation=Tag",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "Tags"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              },
              Tags: {
                shape: "S2f",
                locationName: "Tags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                }
              }
            },
            payload: "Tags"
          }
        },
        UntagResource: {
          http: {
            requestUri: "/2019-03-26/tagging?Operation=Untag",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "TagKeys"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              },
              TagKeys: {
                locationName: "TagKeys",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                },
                type: "structure",
                members: {
                  Items: {
                    type: "list",
                    member: {
                      locationName: "Key"
                    }
                  }
                }
              }
            },
            payload: "TagKeys"
          }
        },
        UpdateCloudFrontOriginAccessIdentity: {
          http: {
            method: "PUT",
            requestUri: "/2019-03-26/origin-access-identity/cloudfront/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "CloudFrontOriginAccessIdentityConfig",
              "Id"
            ],
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2",
                locationName: "CloudFrontOriginAccessIdentityConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        UpdateDistribution: {
          http: {
            method: "PUT",
            requestUri: "/2019-03-26/distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfig",
              "Id"
            ],
            members: {
              DistributionConfig: {
                shape: "S7",
                locationName: "DistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "DistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S23"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        UpdateFieldLevelEncryptionConfig: {
          http: {
            method: "PUT",
            requestUri: "/2019-03-26/field-level-encryption/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionConfig",
              "Id"
            ],
            members: {
              FieldLevelEncryptionConfig: {
                shape: "S2m",
                locationName: "FieldLevelEncryptionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "FieldLevelEncryptionConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryption: {
                shape: "S2x"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryption"
          }
        },
        UpdateFieldLevelEncryptionProfile: {
          http: {
            method: "PUT",
            requestUri: "/2019-03-26/field-level-encryption-profile/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionProfileConfig",
              "Id"
            ],
            members: {
              FieldLevelEncryptionProfileConfig: {
                shape: "S2z",
                locationName: "FieldLevelEncryptionProfileConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "FieldLevelEncryptionProfileConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfile: {
                shape: "S36"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfile"
          }
        },
        UpdatePublicKey: {
          http: {
            method: "PUT",
            requestUri: "/2019-03-26/public-key/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "PublicKeyConfig",
              "Id"
            ],
            members: {
              PublicKeyConfig: {
                shape: "S3e",
                locationName: "PublicKeyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "PublicKeyConfig"
          },
          output: {
            type: "structure",
            members: {
              PublicKey: {
                shape: "S3g"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKey"
          }
        },
        UpdateStreamingDistribution: {
          http: {
            method: "PUT",
            requestUri: "/2019-03-26/streaming-distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfig",
              "Id"
            ],
            members: {
              StreamingDistributionConfig: {
                shape: "S3i",
                locationName: "StreamingDistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "StreamingDistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S3m"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          required: [
            "CallerReference",
            "Comment"
          ],
          members: {
            CallerReference: {},
            Comment: {}
          }
        },
        S5: {
          type: "structure",
          required: [
            "Id",
            "S3CanonicalUserId"
          ],
          members: {
            Id: {},
            S3CanonicalUserId: {},
            CloudFrontOriginAccessIdentityConfig: {
              shape: "S2"
            }
          }
        },
        S7: {
          type: "structure",
          required: [
            "CallerReference",
            "Origins",
            "DefaultCacheBehavior",
            "Comment",
            "Enabled"
          ],
          members: {
            CallerReference: {},
            Aliases: {
              shape: "S8"
            },
            DefaultRootObject: {},
            Origins: {
              shape: "Sb"
            },
            OriginGroups: {
              shape: "Sn"
            },
            DefaultCacheBehavior: {
              shape: "Sw"
            },
            CacheBehaviors: {
              shape: "S1k"
            },
            CustomErrorResponses: {
              shape: "S1n"
            },
            Comment: {
              type: "string",
              sensitive: true
            },
            Logging: {
              type: "structure",
              required: [
                "Enabled",
                "IncludeCookies",
                "Bucket",
                "Prefix"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                IncludeCookies: {
                  type: "boolean"
                },
                Bucket: {},
                Prefix: {}
              }
            },
            PriceClass: {},
            Enabled: {
              type: "boolean"
            },
            ViewerCertificate: {
              shape: "S1t"
            },
            Restrictions: {
              shape: "S1x"
            },
            WebACLId: {},
            HttpVersion: {},
            IsIPV6Enabled: {
              type: "boolean"
            }
          }
        },
        S8: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CNAME"
              }
            }
          }
        },
        Sb: {
          type: "structure",
          required: [
            "Quantity",
            "Items"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Origin",
                type: "structure",
                required: [
                  "Id",
                  "DomainName"
                ],
                members: {
                  Id: {},
                  DomainName: {},
                  OriginPath: {},
                  CustomHeaders: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "OriginCustomHeader",
                          type: "structure",
                          required: [
                            "HeaderName",
                            "HeaderValue"
                          ],
                          members: {
                            HeaderName: {},
                            HeaderValue: {}
                          }
                        }
                      }
                    }
                  },
                  S3OriginConfig: {
                    type: "structure",
                    required: [
                      "OriginAccessIdentity"
                    ],
                    members: {
                      OriginAccessIdentity: {}
                    }
                  },
                  CustomOriginConfig: {
                    type: "structure",
                    required: [
                      "HTTPPort",
                      "HTTPSPort",
                      "OriginProtocolPolicy"
                    ],
                    members: {
                      HTTPPort: {
                        type: "integer"
                      },
                      HTTPSPort: {
                        type: "integer"
                      },
                      OriginProtocolPolicy: {},
                      OriginSslProtocols: {
                        type: "structure",
                        required: [
                          "Quantity",
                          "Items"
                        ],
                        members: {
                          Quantity: {
                            type: "integer"
                          },
                          Items: {
                            type: "list",
                            member: {
                              locationName: "SslProtocol"
                            }
                          }
                        }
                      },
                      OriginReadTimeout: {
                        type: "integer"
                      },
                      OriginKeepaliveTimeout: {
                        type: "integer"
                      }
                    }
                  },
                  ConnectionAttempts: {
                    type: "integer"
                  },
                  ConnectionTimeout: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        Sn: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "OriginGroup",
                type: "structure",
                required: [
                  "Id",
                  "FailoverCriteria",
                  "Members"
                ],
                members: {
                  Id: {},
                  FailoverCriteria: {
                    type: "structure",
                    required: [
                      "StatusCodes"
                    ],
                    members: {
                      StatusCodes: {
                        type: "structure",
                        required: [
                          "Quantity",
                          "Items"
                        ],
                        members: {
                          Quantity: {
                            type: "integer"
                          },
                          Items: {
                            type: "list",
                            member: {
                              locationName: "StatusCode",
                              type: "integer"
                            }
                          }
                        }
                      }
                    }
                  },
                  Members: {
                    type: "structure",
                    required: [
                      "Quantity",
                      "Items"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "OriginGroupMember",
                          type: "structure",
                          required: [
                            "OriginId"
                          ],
                          members: {
                            OriginId: {}
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sw: {
          type: "structure",
          required: [
            "TargetOriginId",
            "ForwardedValues",
            "TrustedSigners",
            "ViewerProtocolPolicy",
            "MinTTL"
          ],
          members: {
            TargetOriginId: {},
            ForwardedValues: {
              shape: "Sx"
            },
            TrustedSigners: {
              shape: "S17"
            },
            ViewerProtocolPolicy: {},
            MinTTL: {
              type: "long"
            },
            AllowedMethods: {
              shape: "S1b"
            },
            SmoothStreaming: {
              type: "boolean"
            },
            DefaultTTL: {
              type: "long"
            },
            MaxTTL: {
              type: "long"
            },
            Compress: {
              type: "boolean"
            },
            LambdaFunctionAssociations: {
              shape: "S1f"
            },
            FieldLevelEncryptionId: {}
          }
        },
        Sx: {
          type: "structure",
          required: [
            "QueryString",
            "Cookies"
          ],
          members: {
            QueryString: {
              type: "boolean"
            },
            Cookies: {
              type: "structure",
              required: [
                "Forward"
              ],
              members: {
                Forward: {},
                WhitelistedNames: {
                  type: "structure",
                  required: [
                    "Quantity"
                  ],
                  members: {
                    Quantity: {
                      type: "integer"
                    },
                    Items: {
                      type: "list",
                      member: {
                        locationName: "Name"
                      }
                    }
                  }
                }
              }
            },
            Headers: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Name"
                  }
                }
              }
            },
            QueryStringCacheKeys: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Name"
                  }
                }
              }
            }
          }
        },
        S17: {
          type: "structure",
          required: [
            "Enabled",
            "Quantity"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "AwsAccountNumber"
              }
            }
          }
        },
        S1b: {
          type: "structure",
          required: [
            "Quantity",
            "Items"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              shape: "S1c"
            },
            CachedMethods: {
              type: "structure",
              required: [
                "Quantity",
                "Items"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  shape: "S1c"
                }
              }
            }
          }
        },
        S1c: {
          type: "list",
          member: {
            locationName: "Method"
          }
        },
        S1f: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "LambdaFunctionAssociation",
                type: "structure",
                required: [
                  "LambdaFunctionARN",
                  "EventType"
                ],
                members: {
                  LambdaFunctionARN: {},
                  EventType: {},
                  IncludeBody: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        S1k: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CacheBehavior",
                type: "structure",
                required: [
                  "PathPattern",
                  "TargetOriginId",
                  "ForwardedValues",
                  "TrustedSigners",
                  "ViewerProtocolPolicy",
                  "MinTTL"
                ],
                members: {
                  PathPattern: {},
                  TargetOriginId: {},
                  ForwardedValues: {
                    shape: "Sx"
                  },
                  TrustedSigners: {
                    shape: "S17"
                  },
                  ViewerProtocolPolicy: {},
                  MinTTL: {
                    type: "long"
                  },
                  AllowedMethods: {
                    shape: "S1b"
                  },
                  SmoothStreaming: {
                    type: "boolean"
                  },
                  DefaultTTL: {
                    type: "long"
                  },
                  MaxTTL: {
                    type: "long"
                  },
                  Compress: {
                    type: "boolean"
                  },
                  LambdaFunctionAssociations: {
                    shape: "S1f"
                  },
                  FieldLevelEncryptionId: {}
                }
              }
            }
          }
        },
        S1n: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CustomErrorResponse",
                type: "structure",
                required: [
                  "ErrorCode"
                ],
                members: {
                  ErrorCode: {
                    type: "integer"
                  },
                  ResponsePagePath: {},
                  ResponseCode: {},
                  ErrorCachingMinTTL: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        S1t: {
          type: "structure",
          members: {
            CloudFrontDefaultCertificate: {
              type: "boolean"
            },
            IAMCertificateId: {},
            ACMCertificateArn: {},
            SSLSupportMethod: {},
            MinimumProtocolVersion: {},
            Certificate: {
              deprecated: true
            },
            CertificateSource: {
              deprecated: true
            }
          }
        },
        S1x: {
          type: "structure",
          required: [
            "GeoRestriction"
          ],
          members: {
            GeoRestriction: {
              type: "structure",
              required: [
                "RestrictionType",
                "Quantity"
              ],
              members: {
                RestrictionType: {},
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Location"
                  }
                }
              }
            }
          }
        },
        S23: {
          type: "structure",
          required: [
            "Id",
            "ARN",
            "Status",
            "LastModifiedTime",
            "InProgressInvalidationBatches",
            "DomainName",
            "ActiveTrustedSigners",
            "DistributionConfig"
          ],
          members: {
            Id: {},
            ARN: {},
            Status: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            InProgressInvalidationBatches: {
              type: "integer"
            },
            DomainName: {},
            ActiveTrustedSigners: {
              shape: "S25"
            },
            DistributionConfig: {
              shape: "S7"
            },
            AliasICPRecordals: {
              shape: "S2a"
            }
          }
        },
        S25: {
          type: "structure",
          required: [
            "Enabled",
            "Quantity"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Signer",
                type: "structure",
                members: {
                  AwsAccountNumber: {},
                  KeyPairIds: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "KeyPairId"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S2a: {
          type: "list",
          member: {
            locationName: "AliasICPRecordal",
            type: "structure",
            members: {
              CNAME: {},
              ICPRecordalStatus: {}
            }
          }
        },
        S2f: {
          type: "structure",
          members: {
            Items: {
              type: "list",
              member: {
                locationName: "Tag",
                type: "structure",
                required: [
                  "Key"
                ],
                members: {
                  Key: {},
                  Value: {}
                }
              }
            }
          }
        },
        S2m: {
          type: "structure",
          required: [
            "CallerReference"
          ],
          members: {
            CallerReference: {},
            Comment: {},
            QueryArgProfileConfig: {
              shape: "S2n"
            },
            ContentTypeProfileConfig: {
              shape: "S2r"
            }
          }
        },
        S2n: {
          type: "structure",
          required: [
            "ForwardWhenQueryArgProfileIsUnknown"
          ],
          members: {
            ForwardWhenQueryArgProfileIsUnknown: {
              type: "boolean"
            },
            QueryArgProfiles: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "QueryArgProfile",
                    type: "structure",
                    required: [
                      "QueryArg",
                      "ProfileId"
                    ],
                    members: {
                      QueryArg: {},
                      ProfileId: {}
                    }
                  }
                }
              }
            }
          }
        },
        S2r: {
          type: "structure",
          required: [
            "ForwardWhenContentTypeIsUnknown"
          ],
          members: {
            ForwardWhenContentTypeIsUnknown: {
              type: "boolean"
            },
            ContentTypeProfiles: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "ContentTypeProfile",
                    type: "structure",
                    required: [
                      "Format",
                      "ContentType"
                    ],
                    members: {
                      Format: {},
                      ProfileId: {},
                      ContentType: {}
                    }
                  }
                }
              }
            }
          }
        },
        S2x: {
          type: "structure",
          required: [
            "Id",
            "LastModifiedTime",
            "FieldLevelEncryptionConfig"
          ],
          members: {
            Id: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            FieldLevelEncryptionConfig: {
              shape: "S2m"
            }
          }
        },
        S2z: {
          type: "structure",
          required: [
            "Name",
            "CallerReference",
            "EncryptionEntities"
          ],
          members: {
            Name: {},
            CallerReference: {},
            Comment: {},
            EncryptionEntities: {
              shape: "S30"
            }
          }
        },
        S30: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "EncryptionEntity",
                type: "structure",
                required: [
                  "PublicKeyId",
                  "ProviderId",
                  "FieldPatterns"
                ],
                members: {
                  PublicKeyId: {},
                  ProviderId: {},
                  FieldPatterns: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "FieldPattern"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S36: {
          type: "structure",
          required: [
            "Id",
            "LastModifiedTime",
            "FieldLevelEncryptionProfileConfig"
          ],
          members: {
            Id: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            FieldLevelEncryptionProfileConfig: {
              shape: "S2z"
            }
          }
        },
        S38: {
          type: "structure",
          required: [
            "Paths",
            "CallerReference"
          ],
          members: {
            Paths: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Path"
                  }
                }
              }
            },
            CallerReference: {}
          }
        },
        S3c: {
          type: "structure",
          required: [
            "Id",
            "Status",
            "CreateTime",
            "InvalidationBatch"
          ],
          members: {
            Id: {},
            Status: {},
            CreateTime: {
              type: "timestamp"
            },
            InvalidationBatch: {
              shape: "S38"
            }
          }
        },
        S3e: {
          type: "structure",
          required: [
            "CallerReference",
            "Name",
            "EncodedKey"
          ],
          members: {
            CallerReference: {},
            Name: {},
            EncodedKey: {},
            Comment: {}
          }
        },
        S3g: {
          type: "structure",
          required: [
            "Id",
            "CreatedTime",
            "PublicKeyConfig"
          ],
          members: {
            Id: {},
            CreatedTime: {
              type: "timestamp"
            },
            PublicKeyConfig: {
              shape: "S3e"
            }
          }
        },
        S3i: {
          type: "structure",
          required: [
            "CallerReference",
            "S3Origin",
            "Comment",
            "TrustedSigners",
            "Enabled"
          ],
          members: {
            CallerReference: {},
            S3Origin: {
              shape: "S3j"
            },
            Aliases: {
              shape: "S8"
            },
            Comment: {},
            Logging: {
              type: "structure",
              required: [
                "Enabled",
                "Bucket",
                "Prefix"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                Bucket: {},
                Prefix: {}
              }
            },
            TrustedSigners: {
              shape: "S17"
            },
            PriceClass: {},
            Enabled: {
              type: "boolean"
            }
          }
        },
        S3j: {
          type: "structure",
          required: [
            "DomainName",
            "OriginAccessIdentity"
          ],
          members: {
            DomainName: {},
            OriginAccessIdentity: {}
          }
        },
        S3m: {
          type: "structure",
          required: [
            "Id",
            "ARN",
            "Status",
            "DomainName",
            "ActiveTrustedSigners",
            "StreamingDistributionConfig"
          ],
          members: {
            Id: {},
            ARN: {},
            Status: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            DomainName: {},
            ActiveTrustedSigners: {
              shape: "S25"
            },
            StreamingDistributionConfig: {
              shape: "S3i"
            }
          }
        },
        S4t: {
          type: "structure",
          required: [
            "Marker",
            "MaxItems",
            "IsTruncated",
            "Quantity"
          ],
          members: {
            Marker: {},
            NextMarker: {},
            MaxItems: {
              type: "integer"
            },
            IsTruncated: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "DistributionSummary",
                type: "structure",
                required: [
                  "Id",
                  "ARN",
                  "Status",
                  "LastModifiedTime",
                  "DomainName",
                  "Aliases",
                  "Origins",
                  "DefaultCacheBehavior",
                  "CacheBehaviors",
                  "CustomErrorResponses",
                  "Comment",
                  "PriceClass",
                  "Enabled",
                  "ViewerCertificate",
                  "Restrictions",
                  "WebACLId",
                  "HttpVersion",
                  "IsIPV6Enabled"
                ],
                members: {
                  Id: {},
                  ARN: {},
                  Status: {},
                  LastModifiedTime: {
                    type: "timestamp"
                  },
                  DomainName: {},
                  Aliases: {
                    shape: "S8"
                  },
                  Origins: {
                    shape: "Sb"
                  },
                  OriginGroups: {
                    shape: "Sn"
                  },
                  DefaultCacheBehavior: {
                    shape: "Sw"
                  },
                  CacheBehaviors: {
                    shape: "S1k"
                  },
                  CustomErrorResponses: {
                    shape: "S1n"
                  },
                  Comment: {},
                  PriceClass: {},
                  Enabled: {
                    type: "boolean"
                  },
                  ViewerCertificate: {
                    shape: "S1t"
                  },
                  Restrictions: {
                    shape: "S1x"
                  },
                  WebACLId: {},
                  HttpVersion: {},
                  IsIPV6Enabled: {
                    type: "boolean"
                  },
                  AliasICPRecordals: {
                    shape: "S2a"
                  }
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2019-03-26.paginators.json
var require_cloudfront_2019_03_26_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2019-03-26.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListCloudFrontOriginAccessIdentities: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "CloudFrontOriginAccessIdentityList.IsTruncated",
          output_token: "CloudFrontOriginAccessIdentityList.NextMarker",
          result_key: "CloudFrontOriginAccessIdentityList.Items"
        },
        ListDistributions: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "DistributionList.IsTruncated",
          output_token: "DistributionList.NextMarker",
          result_key: "DistributionList.Items"
        },
        ListInvalidations: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "InvalidationList.IsTruncated",
          output_token: "InvalidationList.NextMarker",
          result_key: "InvalidationList.Items"
        },
        ListStreamingDistributions: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "StreamingDistributionList.IsTruncated",
          output_token: "StreamingDistributionList.NextMarker",
          result_key: "StreamingDistributionList.Items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2019-03-26.waiters2.json
var require_cloudfront_2019_03_26_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2019-03-26.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        DistributionDeployed: {
          delay: 60,
          operation: "GetDistribution",
          maxAttempts: 35,
          description: "Wait until a distribution is deployed.",
          acceptors: [
            {
              expected: "Deployed",
              matcher: "path",
              state: "success",
              argument: "Distribution.Status"
            }
          ]
        },
        InvalidationCompleted: {
          delay: 20,
          operation: "GetInvalidation",
          maxAttempts: 30,
          description: "Wait until an invalidation has completed.",
          acceptors: [
            {
              expected: "Completed",
              matcher: "path",
              state: "success",
              argument: "Invalidation.Status"
            }
          ]
        },
        StreamingDistributionDeployed: {
          delay: 60,
          operation: "GetStreamingDistribution",
          maxAttempts: 25,
          description: "Wait until a streaming distribution is deployed.",
          acceptors: [
            {
              expected: "Deployed",
              matcher: "path",
              state: "success",
              argument: "StreamingDistribution.Status"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2020-05-31.min.json
var require_cloudfront_2020_05_31_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2020-05-31.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-05-31",
        endpointPrefix: "cloudfront",
        globalEndpoint: "cloudfront.amazonaws.com",
        protocol: "rest-xml",
        serviceAbbreviation: "CloudFront",
        serviceFullName: "Amazon CloudFront",
        serviceId: "CloudFront",
        signatureVersion: "v4",
        uid: "cloudfront-2020-05-31"
      },
      operations: {
        AssociateAlias: {
          http: {
            method: "PUT",
            requestUri: "/2020-05-31/distribution/{TargetDistributionId}/associate-alias",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "TargetDistributionId",
              "Alias"
            ],
            members: {
              TargetDistributionId: {
                location: "uri",
                locationName: "TargetDistributionId"
              },
              Alias: {
                location: "querystring",
                locationName: "Alias"
              }
            }
          }
        },
        CopyDistribution: {
          http: {
            requestUri: "/2020-05-31/distribution/{PrimaryDistributionId}/copy",
            responseCode: 201
          },
          input: {
            locationName: "CopyDistributionRequest",
            xmlNamespace: {
              uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
            },
            type: "structure",
            required: [
              "PrimaryDistributionId",
              "CallerReference"
            ],
            members: {
              PrimaryDistributionId: {
                location: "uri",
                locationName: "PrimaryDistributionId"
              },
              Staging: {
                location: "header",
                locationName: "Staging",
                type: "boolean"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              },
              CallerReference: {},
              Enabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S6"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        CreateCachePolicy: {
          http: {
            requestUri: "/2020-05-31/cache-policy",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "CachePolicyConfig"
            ],
            members: {
              CachePolicyConfig: {
                shape: "S2n",
                locationName: "CachePolicyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              }
            },
            payload: "CachePolicyConfig"
          },
          output: {
            type: "structure",
            members: {
              CachePolicy: {
                shape: "S2y"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CachePolicy"
          }
        },
        CreateCloudFrontOriginAccessIdentity: {
          http: {
            requestUri: "/2020-05-31/origin-access-identity/cloudfront",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "CloudFrontOriginAccessIdentityConfig"
            ],
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S30",
                locationName: "CloudFrontOriginAccessIdentityConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S32"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        CreateContinuousDeploymentPolicy: {
          http: {
            requestUri: "/2020-05-31/continuous-deployment-policy",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ContinuousDeploymentPolicyConfig"
            ],
            members: {
              ContinuousDeploymentPolicyConfig: {
                shape: "S34",
                locationName: "ContinuousDeploymentPolicyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              }
            },
            payload: "ContinuousDeploymentPolicyConfig"
          },
          output: {
            type: "structure",
            members: {
              ContinuousDeploymentPolicy: {
                shape: "S3e"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "ContinuousDeploymentPolicy"
          }
        },
        CreateDistribution: {
          http: {
            requestUri: "/2020-05-31/distribution",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfig"
            ],
            members: {
              DistributionConfig: {
                shape: "Sh",
                locationName: "DistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              }
            },
            payload: "DistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S6"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        CreateDistributionWithTags: {
          http: {
            requestUri: "/2020-05-31/distribution?WithTags",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfigWithTags"
            ],
            members: {
              DistributionConfigWithTags: {
                locationName: "DistributionConfigWithTags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                },
                type: "structure",
                required: [
                  "DistributionConfig",
                  "Tags"
                ],
                members: {
                  DistributionConfig: {
                    shape: "Sh"
                  },
                  Tags: {
                    shape: "S3j"
                  }
                }
              }
            },
            payload: "DistributionConfigWithTags"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S6"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        CreateFieldLevelEncryptionConfig: {
          http: {
            requestUri: "/2020-05-31/field-level-encryption",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionConfig"
            ],
            members: {
              FieldLevelEncryptionConfig: {
                shape: "S3q",
                locationName: "FieldLevelEncryptionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              }
            },
            payload: "FieldLevelEncryptionConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryption: {
                shape: "S41"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryption"
          }
        },
        CreateFieldLevelEncryptionProfile: {
          http: {
            requestUri: "/2020-05-31/field-level-encryption-profile",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionProfileConfig"
            ],
            members: {
              FieldLevelEncryptionProfileConfig: {
                shape: "S43",
                locationName: "FieldLevelEncryptionProfileConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              }
            },
            payload: "FieldLevelEncryptionProfileConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfile: {
                shape: "S4a"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfile"
          }
        },
        CreateFunction: {
          http: {
            requestUri: "/2020-05-31/function",
            responseCode: 201
          },
          input: {
            locationName: "CreateFunctionRequest",
            xmlNamespace: {
              uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
            },
            type: "structure",
            required: [
              "Name",
              "FunctionConfig",
              "FunctionCode"
            ],
            members: {
              Name: {},
              FunctionConfig: {
                shape: "S4d"
              },
              FunctionCode: {
                shape: "S4j"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FunctionSummary: {
                shape: "S4l"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FunctionSummary"
          }
        },
        CreateInvalidation: {
          http: {
            requestUri: "/2020-05-31/distribution/{DistributionId}/invalidation",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionId",
              "InvalidationBatch"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              InvalidationBatch: {
                shape: "S4p",
                locationName: "InvalidationBatch",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              }
            },
            payload: "InvalidationBatch"
          },
          output: {
            type: "structure",
            members: {
              Location: {
                location: "header",
                locationName: "Location"
              },
              Invalidation: {
                shape: "S4t"
              }
            },
            payload: "Invalidation"
          }
        },
        CreateKeyGroup: {
          http: {
            requestUri: "/2020-05-31/key-group",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "KeyGroupConfig"
            ],
            members: {
              KeyGroupConfig: {
                shape: "S4v",
                locationName: "KeyGroupConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              }
            },
            payload: "KeyGroupConfig"
          },
          output: {
            type: "structure",
            members: {
              KeyGroup: {
                shape: "S4y"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "KeyGroup"
          }
        },
        CreateKeyValueStore: {
          http: {
            requestUri: "/2020-05-31/key-value-store/",
            responseCode: 201
          },
          input: {
            locationName: "CreateKeyValueStoreRequest",
            xmlNamespace: {
              uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
            },
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Comment: {},
              ImportSource: {
                type: "structure",
                required: [
                  "SourceType",
                  "SourceARN"
                ],
                members: {
                  SourceType: {},
                  SourceARN: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KeyValueStore: {
                shape: "S55"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              },
              Location: {
                location: "header",
                locationName: "Location"
              }
            },
            payload: "KeyValueStore"
          }
        },
        CreateMonitoringSubscription: {
          http: {
            requestUri: "/2020-05-31/distributions/{DistributionId}/monitoring-subscription/"
          },
          input: {
            type: "structure",
            required: [
              "MonitoringSubscription",
              "DistributionId"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              MonitoringSubscription: {
                shape: "S57",
                locationName: "MonitoringSubscription",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              }
            },
            payload: "MonitoringSubscription"
          },
          output: {
            type: "structure",
            members: {
              MonitoringSubscription: {
                shape: "S57"
              }
            },
            payload: "MonitoringSubscription"
          }
        },
        CreateOriginAccessControl: {
          http: {
            requestUri: "/2020-05-31/origin-access-control",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "OriginAccessControlConfig"
            ],
            members: {
              OriginAccessControlConfig: {
                shape: "S5c",
                locationName: "OriginAccessControlConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              }
            },
            payload: "OriginAccessControlConfig"
          },
          output: {
            type: "structure",
            members: {
              OriginAccessControl: {
                shape: "S5h"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "OriginAccessControl"
          }
        },
        CreateOriginRequestPolicy: {
          http: {
            requestUri: "/2020-05-31/origin-request-policy",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "OriginRequestPolicyConfig"
            ],
            members: {
              OriginRequestPolicyConfig: {
                shape: "S5j",
                locationName: "OriginRequestPolicyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              }
            },
            payload: "OriginRequestPolicyConfig"
          },
          output: {
            type: "structure",
            members: {
              OriginRequestPolicy: {
                shape: "S5r"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "OriginRequestPolicy"
          }
        },
        CreatePublicKey: {
          http: {
            requestUri: "/2020-05-31/public-key",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "PublicKeyConfig"
            ],
            members: {
              PublicKeyConfig: {
                shape: "S5t",
                locationName: "PublicKeyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              }
            },
            payload: "PublicKeyConfig"
          },
          output: {
            type: "structure",
            members: {
              PublicKey: {
                shape: "S5v"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKey"
          }
        },
        CreateRealtimeLogConfig: {
          http: {
            requestUri: "/2020-05-31/realtime-log-config",
            responseCode: 201
          },
          input: {
            locationName: "CreateRealtimeLogConfigRequest",
            xmlNamespace: {
              uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
            },
            type: "structure",
            required: [
              "EndPoints",
              "Fields",
              "Name",
              "SamplingRate"
            ],
            members: {
              EndPoints: {
                shape: "S5x"
              },
              Fields: {
                shape: "S60"
              },
              Name: {},
              SamplingRate: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RealtimeLogConfig: {
                shape: "S62"
              }
            }
          }
        },
        CreateResponseHeadersPolicy: {
          http: {
            requestUri: "/2020-05-31/response-headers-policy",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ResponseHeadersPolicyConfig"
            ],
            members: {
              ResponseHeadersPolicyConfig: {
                shape: "S64",
                locationName: "ResponseHeadersPolicyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              }
            },
            payload: "ResponseHeadersPolicyConfig"
          },
          output: {
            type: "structure",
            members: {
              ResponseHeadersPolicy: {
                shape: "S6x"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "ResponseHeadersPolicy"
          }
        },
        CreateStreamingDistribution: {
          http: {
            requestUri: "/2020-05-31/streaming-distribution",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfig"
            ],
            members: {
              StreamingDistributionConfig: {
                shape: "S6z",
                locationName: "StreamingDistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              }
            },
            payload: "StreamingDistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S73"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        CreateStreamingDistributionWithTags: {
          http: {
            requestUri: "/2020-05-31/streaming-distribution?WithTags",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfigWithTags"
            ],
            members: {
              StreamingDistributionConfigWithTags: {
                locationName: "StreamingDistributionConfigWithTags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                },
                type: "structure",
                required: [
                  "StreamingDistributionConfig",
                  "Tags"
                ],
                members: {
                  StreamingDistributionConfig: {
                    shape: "S6z"
                  },
                  Tags: {
                    shape: "S3j"
                  }
                }
              }
            },
            payload: "StreamingDistributionConfigWithTags"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S73"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        DeleteCachePolicy: {
          http: {
            method: "DELETE",
            requestUri: "/2020-05-31/cache-policy/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteCloudFrontOriginAccessIdentity: {
          http: {
            method: "DELETE",
            requestUri: "/2020-05-31/origin-access-identity/cloudfront/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteContinuousDeploymentPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/2020-05-31/continuous-deployment-policy/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteDistribution: {
          http: {
            method: "DELETE",
            requestUri: "/2020-05-31/distribution/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteFieldLevelEncryptionConfig: {
          http: {
            method: "DELETE",
            requestUri: "/2020-05-31/field-level-encryption/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteFieldLevelEncryptionProfile: {
          http: {
            method: "DELETE",
            requestUri: "/2020-05-31/field-level-encryption-profile/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteFunction: {
          http: {
            method: "DELETE",
            requestUri: "/2020-05-31/function/{Name}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "IfMatch",
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteKeyGroup: {
          http: {
            method: "DELETE",
            requestUri: "/2020-05-31/key-group/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteKeyValueStore: {
          http: {
            method: "DELETE",
            requestUri: "/2020-05-31/key-value-store/{Name}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "IfMatch",
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          },
          idempotent: true
        },
        DeleteMonitoringSubscription: {
          http: {
            method: "DELETE",
            requestUri: "/2020-05-31/distributions/{DistributionId}/monitoring-subscription/"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteOriginAccessControl: {
          http: {
            method: "DELETE",
            requestUri: "/2020-05-31/origin-access-control/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteOriginRequestPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/2020-05-31/origin-request-policy/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeletePublicKey: {
          http: {
            method: "DELETE",
            requestUri: "/2020-05-31/public-key/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteRealtimeLogConfig: {
          http: {
            requestUri: "/2020-05-31/delete-realtime-log-config/",
            responseCode: 204
          },
          input: {
            locationName: "DeleteRealtimeLogConfigRequest",
            xmlNamespace: {
              uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
            },
            type: "structure",
            members: {
              Name: {},
              ARN: {}
            }
          }
        },
        DeleteResponseHeadersPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/2020-05-31/response-headers-policy/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteStreamingDistribution: {
          http: {
            method: "DELETE",
            requestUri: "/2020-05-31/streaming-distribution/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DescribeFunction: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/function/{Name}/describe"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              },
              Stage: {
                location: "querystring",
                locationName: "Stage"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FunctionSummary: {
                shape: "S4l"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FunctionSummary"
          }
        },
        DescribeKeyValueStore: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/key-value-store/{Name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KeyValueStore: {
                shape: "S55"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "KeyValueStore"
          }
        },
        GetCachePolicy: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/cache-policy/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CachePolicy: {
                shape: "S2y"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CachePolicy"
          }
        },
        GetCachePolicyConfig: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/cache-policy/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CachePolicyConfig: {
                shape: "S2n"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CachePolicyConfig"
          }
        },
        GetCloudFrontOriginAccessIdentity: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/origin-access-identity/cloudfront/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S32"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        GetCloudFrontOriginAccessIdentityConfig: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/origin-access-identity/cloudfront/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S30"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          }
        },
        GetContinuousDeploymentPolicy: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/continuous-deployment-policy/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContinuousDeploymentPolicy: {
                shape: "S3e"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "ContinuousDeploymentPolicy"
          }
        },
        GetContinuousDeploymentPolicyConfig: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/continuous-deployment-policy/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContinuousDeploymentPolicyConfig: {
                shape: "S34"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "ContinuousDeploymentPolicyConfig"
          }
        },
        GetDistribution: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/distribution/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S6"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        GetDistributionConfig: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionConfig: {
                shape: "Sh"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "DistributionConfig"
          }
        },
        GetFieldLevelEncryption: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/field-level-encryption/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryption: {
                shape: "S41"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryption"
          }
        },
        GetFieldLevelEncryptionConfig: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/field-level-encryption/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionConfig: {
                shape: "S3q"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionConfig"
          }
        },
        GetFieldLevelEncryptionProfile: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/field-level-encryption-profile/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfile: {
                shape: "S4a"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfile"
          }
        },
        GetFieldLevelEncryptionProfileConfig: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/field-level-encryption-profile/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfileConfig: {
                shape: "S43"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfileConfig"
          }
        },
        GetFunction: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/function/{Name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              },
              Stage: {
                location: "querystring",
                locationName: "Stage"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FunctionCode: {
                shape: "S4j"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              }
            },
            payload: "FunctionCode"
          }
        },
        GetInvalidation: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/distribution/{DistributionId}/invalidation/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId",
              "Id"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Invalidation: {
                shape: "S4t"
              }
            },
            payload: "Invalidation"
          }
        },
        GetKeyGroup: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/key-group/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KeyGroup: {
                shape: "S4y"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "KeyGroup"
          }
        },
        GetKeyGroupConfig: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/key-group/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KeyGroupConfig: {
                shape: "S4v"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "KeyGroupConfig"
          }
        },
        GetMonitoringSubscription: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/distributions/{DistributionId}/monitoring-subscription/"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MonitoringSubscription: {
                shape: "S57"
              }
            },
            payload: "MonitoringSubscription"
          }
        },
        GetOriginAccessControl: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/origin-access-control/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OriginAccessControl: {
                shape: "S5h"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "OriginAccessControl"
          }
        },
        GetOriginAccessControlConfig: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/origin-access-control/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OriginAccessControlConfig: {
                shape: "S5c"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "OriginAccessControlConfig"
          }
        },
        GetOriginRequestPolicy: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/origin-request-policy/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OriginRequestPolicy: {
                shape: "S5r"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "OriginRequestPolicy"
          }
        },
        GetOriginRequestPolicyConfig: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/origin-request-policy/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OriginRequestPolicyConfig: {
                shape: "S5j"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "OriginRequestPolicyConfig"
          }
        },
        GetPublicKey: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/public-key/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKey: {
                shape: "S5v"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKey"
          }
        },
        GetPublicKeyConfig: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/public-key/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKeyConfig: {
                shape: "S5t"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKeyConfig"
          }
        },
        GetRealtimeLogConfig: {
          http: {
            requestUri: "/2020-05-31/get-realtime-log-config/"
          },
          input: {
            locationName: "GetRealtimeLogConfigRequest",
            xmlNamespace: {
              uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
            },
            type: "structure",
            members: {
              Name: {},
              ARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RealtimeLogConfig: {
                shape: "S62"
              }
            }
          }
        },
        GetResponseHeadersPolicy: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/response-headers-policy/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResponseHeadersPolicy: {
                shape: "S6x"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "ResponseHeadersPolicy"
          }
        },
        GetResponseHeadersPolicyConfig: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/response-headers-policy/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResponseHeadersPolicyConfig: {
                shape: "S64"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "ResponseHeadersPolicyConfig"
          }
        },
        GetStreamingDistribution: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/streaming-distribution/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S73"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        GetStreamingDistributionConfig: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/streaming-distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistributionConfig: {
                shape: "S6z"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistributionConfig"
          }
        },
        ListCachePolicies: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/cache-policy"
          },
          input: {
            type: "structure",
            members: {
              Type: {
                location: "querystring",
                locationName: "Type"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CachePolicyList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "CachePolicySummary",
                      type: "structure",
                      required: [
                        "Type",
                        "CachePolicy"
                      ],
                      members: {
                        Type: {},
                        CachePolicy: {
                          shape: "S2y"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "CachePolicyList"
          }
        },
        ListCloudFrontOriginAccessIdentities: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/origin-access-identity/cloudfront"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentityList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "CloudFrontOriginAccessIdentitySummary",
                      type: "structure",
                      required: [
                        "Id",
                        "S3CanonicalUserId",
                        "Comment"
                      ],
                      members: {
                        Id: {},
                        S3CanonicalUserId: {},
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "CloudFrontOriginAccessIdentityList"
          }
        },
        ListConflictingAliases: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/conflicting-alias",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DistributionId",
              "Alias"
            ],
            members: {
              DistributionId: {
                location: "querystring",
                locationName: "DistributionId"
              },
              Alias: {
                location: "querystring",
                locationName: "Alias"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConflictingAliasesList: {
                type: "structure",
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "ConflictingAlias",
                      type: "structure",
                      members: {
                        Alias: {},
                        DistributionId: {},
                        AccountId: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "ConflictingAliasesList"
          }
        },
        ListContinuousDeploymentPolicies: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/continuous-deployment-policy"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContinuousDeploymentPolicyList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "ContinuousDeploymentPolicySummary",
                      type: "structure",
                      required: [
                        "ContinuousDeploymentPolicy"
                      ],
                      members: {
                        ContinuousDeploymentPolicy: {
                          shape: "S3e"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "ContinuousDeploymentPolicyList"
          }
        },
        ListDistributions: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/distribution"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionList: {
                shape: "Sa2"
              }
            },
            payload: "DistributionList"
          }
        },
        ListDistributionsByCachePolicyId: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/distributionsByCachePolicyId/{CachePolicyId}"
          },
          input: {
            type: "structure",
            required: [
              "CachePolicyId"
            ],
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              },
              CachePolicyId: {
                location: "uri",
                locationName: "CachePolicyId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionIdList: {
                shape: "Sa7"
              }
            },
            payload: "DistributionIdList"
          }
        },
        ListDistributionsByKeyGroup: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/distributionsByKeyGroupId/{KeyGroupId}"
          },
          input: {
            type: "structure",
            required: [
              "KeyGroupId"
            ],
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              },
              KeyGroupId: {
                location: "uri",
                locationName: "KeyGroupId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionIdList: {
                shape: "Sa7"
              }
            },
            payload: "DistributionIdList"
          }
        },
        ListDistributionsByOriginRequestPolicyId: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/distributionsByOriginRequestPolicyId/{OriginRequestPolicyId}"
          },
          input: {
            type: "structure",
            required: [
              "OriginRequestPolicyId"
            ],
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              },
              OriginRequestPolicyId: {
                location: "uri",
                locationName: "OriginRequestPolicyId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionIdList: {
                shape: "Sa7"
              }
            },
            payload: "DistributionIdList"
          }
        },
        ListDistributionsByRealtimeLogConfig: {
          http: {
            requestUri: "/2020-05-31/distributionsByRealtimeLogConfig/"
          },
          input: {
            locationName: "ListDistributionsByRealtimeLogConfigRequest",
            xmlNamespace: {
              uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
            },
            type: "structure",
            members: {
              Marker: {},
              MaxItems: {},
              RealtimeLogConfigName: {},
              RealtimeLogConfigArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionList: {
                shape: "Sa2"
              }
            },
            payload: "DistributionList"
          }
        },
        ListDistributionsByResponseHeadersPolicyId: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/distributionsByResponseHeadersPolicyId/{ResponseHeadersPolicyId}"
          },
          input: {
            type: "structure",
            required: [
              "ResponseHeadersPolicyId"
            ],
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              },
              ResponseHeadersPolicyId: {
                location: "uri",
                locationName: "ResponseHeadersPolicyId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionIdList: {
                shape: "Sa7"
              }
            },
            payload: "DistributionIdList"
          }
        },
        ListDistributionsByWebACLId: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/distributionsByWebACLId/{WebACLId}"
          },
          input: {
            type: "structure",
            required: [
              "WebACLId"
            ],
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              },
              WebACLId: {
                location: "uri",
                locationName: "WebACLId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionList: {
                shape: "Sa2"
              }
            },
            payload: "DistributionList"
          }
        },
        ListFieldLevelEncryptionConfigs: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/field-level-encryption"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "FieldLevelEncryptionSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "LastModifiedTime"
                      ],
                      members: {
                        Id: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        Comment: {},
                        QueryArgProfileConfig: {
                          shape: "S3r"
                        },
                        ContentTypeProfileConfig: {
                          shape: "S3v"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "FieldLevelEncryptionList"
          }
        },
        ListFieldLevelEncryptionProfiles: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/field-level-encryption-profile"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfileList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "FieldLevelEncryptionProfileSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "LastModifiedTime",
                        "Name",
                        "EncryptionEntities"
                      ],
                      members: {
                        Id: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        Name: {},
                        EncryptionEntities: {
                          shape: "S44"
                        },
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "FieldLevelEncryptionProfileList"
          }
        },
        ListFunctions: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/function"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              },
              Stage: {
                location: "querystring",
                locationName: "Stage"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FunctionList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      shape: "S4l",
                      locationName: "FunctionSummary"
                    }
                  }
                }
              }
            },
            payload: "FunctionList"
          }
        },
        ListInvalidations: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/distribution/{DistributionId}/invalidation"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InvalidationList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "InvalidationSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "CreateTime",
                        "Status"
                      ],
                      members: {
                        Id: {},
                        CreateTime: {
                          type: "timestamp"
                        },
                        Status: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "InvalidationList"
          }
        },
        ListKeyGroups: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/key-group"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KeyGroupList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "KeyGroupSummary",
                      type: "structure",
                      required: [
                        "KeyGroup"
                      ],
                      members: {
                        KeyGroup: {
                          shape: "S4y"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "KeyGroupList"
          }
        },
        ListKeyValueStores: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/key-value-store"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              },
              Status: {
                location: "querystring",
                locationName: "Status"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KeyValueStoreList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      shape: "S55",
                      locationName: "KeyValueStore"
                    }
                  }
                }
              }
            },
            payload: "KeyValueStoreList"
          }
        },
        ListOriginAccessControls: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/origin-access-control"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OriginAccessControlList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "OriginAccessControlSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "Description",
                        "Name",
                        "SigningProtocol",
                        "SigningBehavior",
                        "OriginAccessControlOriginType"
                      ],
                      members: {
                        Id: {},
                        Description: {},
                        Name: {},
                        SigningProtocol: {},
                        SigningBehavior: {},
                        OriginAccessControlOriginType: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "OriginAccessControlList"
          }
        },
        ListOriginRequestPolicies: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/origin-request-policy"
          },
          input: {
            type: "structure",
            members: {
              Type: {
                location: "querystring",
                locationName: "Type"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OriginRequestPolicyList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "OriginRequestPolicySummary",
                      type: "structure",
                      required: [
                        "Type",
                        "OriginRequestPolicy"
                      ],
                      members: {
                        Type: {},
                        OriginRequestPolicy: {
                          shape: "S5r"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "OriginRequestPolicyList"
          }
        },
        ListPublicKeys: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/public-key"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKeyList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "PublicKeySummary",
                      type: "structure",
                      required: [
                        "Id",
                        "Name",
                        "CreatedTime",
                        "EncodedKey"
                      ],
                      members: {
                        Id: {},
                        Name: {},
                        CreatedTime: {
                          type: "timestamp"
                        },
                        EncodedKey: {},
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "PublicKeyList"
          }
        },
        ListRealtimeLogConfigs: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/realtime-log-config"
          },
          input: {
            type: "structure",
            members: {
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RealtimeLogConfigs: {
                type: "structure",
                required: [
                  "MaxItems",
                  "IsTruncated",
                  "Marker"
                ],
                members: {
                  MaxItems: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      shape: "S62"
                    }
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Marker: {},
                  NextMarker: {}
                }
              }
            },
            payload: "RealtimeLogConfigs"
          }
        },
        ListResponseHeadersPolicies: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/response-headers-policy"
          },
          input: {
            type: "structure",
            members: {
              Type: {
                location: "querystring",
                locationName: "Type"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResponseHeadersPolicyList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "ResponseHeadersPolicySummary",
                      type: "structure",
                      required: [
                        "Type",
                        "ResponseHeadersPolicy"
                      ],
                      members: {
                        Type: {},
                        ResponseHeadersPolicy: {
                          shape: "S6x"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "ResponseHeadersPolicyList"
          }
        },
        ListStreamingDistributions: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/streaming-distribution"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistributionList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "StreamingDistributionSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "ARN",
                        "Status",
                        "LastModifiedTime",
                        "DomainName",
                        "S3Origin",
                        "Aliases",
                        "TrustedSigners",
                        "Comment",
                        "PriceClass",
                        "Enabled"
                      ],
                      members: {
                        Id: {},
                        ARN: {},
                        Status: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        DomainName: {},
                        S3Origin: {
                          shape: "S70"
                        },
                        Aliases: {
                          shape: "Si"
                        },
                        TrustedSigners: {
                          shape: "S19"
                        },
                        Comment: {},
                        PriceClass: {},
                        Enabled: {
                          type: "boolean"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "StreamingDistributionList"
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/tagging"
          },
          input: {
            type: "structure",
            required: [
              "Resource"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "S3j"
              }
            },
            payload: "Tags"
          }
        },
        PublishFunction: {
          http: {
            requestUri: "/2020-05-31/function/{Name}/publish"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "IfMatch"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FunctionSummary: {
                shape: "S4l"
              }
            },
            payload: "FunctionSummary"
          }
        },
        TagResource: {
          http: {
            requestUri: "/2020-05-31/tagging?Operation=Tag",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "Tags"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              },
              Tags: {
                shape: "S3j",
                locationName: "Tags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              }
            },
            payload: "Tags"
          }
        },
        TestFunction: {
          http: {
            requestUri: "/2020-05-31/function/{Name}/test"
          },
          input: {
            locationName: "TestFunctionRequest",
            xmlNamespace: {
              uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
            },
            type: "structure",
            required: [
              "Name",
              "IfMatch",
              "EventObject"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              },
              Stage: {},
              EventObject: {
                type: "blob",
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TestResult: {
                type: "structure",
                members: {
                  FunctionSummary: {
                    shape: "S4l"
                  },
                  ComputeUtilization: {},
                  FunctionExecutionLogs: {
                    type: "list",
                    member: {},
                    sensitive: true
                  },
                  FunctionErrorMessage: {
                    shape: "Sq"
                  },
                  FunctionOutput: {
                    shape: "Sq"
                  }
                }
              }
            },
            payload: "TestResult"
          }
        },
        UntagResource: {
          http: {
            requestUri: "/2020-05-31/tagging?Operation=Untag",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "TagKeys"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              },
              TagKeys: {
                locationName: "TagKeys",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                },
                type: "structure",
                members: {
                  Items: {
                    type: "list",
                    member: {
                      locationName: "Key"
                    }
                  }
                }
              }
            },
            payload: "TagKeys"
          }
        },
        UpdateCachePolicy: {
          http: {
            method: "PUT",
            requestUri: "/2020-05-31/cache-policy/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "CachePolicyConfig",
              "Id"
            ],
            members: {
              CachePolicyConfig: {
                shape: "S2n",
                locationName: "CachePolicyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "CachePolicyConfig"
          },
          output: {
            type: "structure",
            members: {
              CachePolicy: {
                shape: "S2y"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CachePolicy"
          }
        },
        UpdateCloudFrontOriginAccessIdentity: {
          http: {
            method: "PUT",
            requestUri: "/2020-05-31/origin-access-identity/cloudfront/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "CloudFrontOriginAccessIdentityConfig",
              "Id"
            ],
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S30",
                locationName: "CloudFrontOriginAccessIdentityConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S32"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        UpdateContinuousDeploymentPolicy: {
          http: {
            method: "PUT",
            requestUri: "/2020-05-31/continuous-deployment-policy/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "ContinuousDeploymentPolicyConfig",
              "Id"
            ],
            members: {
              ContinuousDeploymentPolicyConfig: {
                shape: "S34",
                locationName: "ContinuousDeploymentPolicyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "ContinuousDeploymentPolicyConfig"
          },
          output: {
            type: "structure",
            members: {
              ContinuousDeploymentPolicy: {
                shape: "S3e"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "ContinuousDeploymentPolicy"
          }
        },
        UpdateDistribution: {
          http: {
            method: "PUT",
            requestUri: "/2020-05-31/distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfig",
              "Id"
            ],
            members: {
              DistributionConfig: {
                shape: "Sh",
                locationName: "DistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "DistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S6"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        UpdateDistributionWithStagingConfig: {
          http: {
            method: "PUT",
            requestUri: "/2020-05-31/distribution/{Id}/promote-staging-config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              StagingDistributionId: {
                location: "querystring",
                locationName: "StagingDistributionId"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S6"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        UpdateFieldLevelEncryptionConfig: {
          http: {
            method: "PUT",
            requestUri: "/2020-05-31/field-level-encryption/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionConfig",
              "Id"
            ],
            members: {
              FieldLevelEncryptionConfig: {
                shape: "S3q",
                locationName: "FieldLevelEncryptionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "FieldLevelEncryptionConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryption: {
                shape: "S41"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryption"
          }
        },
        UpdateFieldLevelEncryptionProfile: {
          http: {
            method: "PUT",
            requestUri: "/2020-05-31/field-level-encryption-profile/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionProfileConfig",
              "Id"
            ],
            members: {
              FieldLevelEncryptionProfileConfig: {
                shape: "S43",
                locationName: "FieldLevelEncryptionProfileConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "FieldLevelEncryptionProfileConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfile: {
                shape: "S4a"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfile"
          }
        },
        UpdateFunction: {
          http: {
            method: "PUT",
            requestUri: "/2020-05-31/function/{Name}"
          },
          input: {
            locationName: "UpdateFunctionRequest",
            xmlNamespace: {
              uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
            },
            type: "structure",
            required: [
              "IfMatch",
              "FunctionConfig",
              "FunctionCode",
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              },
              FunctionConfig: {
                shape: "S4d"
              },
              FunctionCode: {
                shape: "S4j"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FunctionSummary: {
                shape: "S4l"
              },
              ETag: {
                location: "header",
                locationName: "ETtag"
              }
            },
            payload: "FunctionSummary"
          }
        },
        UpdateKeyGroup: {
          http: {
            method: "PUT",
            requestUri: "/2020-05-31/key-group/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "KeyGroupConfig",
              "Id"
            ],
            members: {
              KeyGroupConfig: {
                shape: "S4v",
                locationName: "KeyGroupConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "KeyGroupConfig"
          },
          output: {
            type: "structure",
            members: {
              KeyGroup: {
                shape: "S4y"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "KeyGroup"
          }
        },
        UpdateKeyValueStore: {
          http: {
            method: "PUT",
            requestUri: "/2020-05-31/key-value-store/{Name}"
          },
          input: {
            locationName: "UpdateKeyValueStoreRequest",
            xmlNamespace: {
              uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
            },
            type: "structure",
            required: [
              "Name",
              "Comment",
              "IfMatch"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              },
              Comment: {},
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KeyValueStore: {
                shape: "S55"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "KeyValueStore"
          },
          idempotent: true
        },
        UpdateOriginAccessControl: {
          http: {
            method: "PUT",
            requestUri: "/2020-05-31/origin-access-control/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "OriginAccessControlConfig",
              "Id"
            ],
            members: {
              OriginAccessControlConfig: {
                shape: "S5c",
                locationName: "OriginAccessControlConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "OriginAccessControlConfig"
          },
          output: {
            type: "structure",
            members: {
              OriginAccessControl: {
                shape: "S5h"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "OriginAccessControl"
          }
        },
        UpdateOriginRequestPolicy: {
          http: {
            method: "PUT",
            requestUri: "/2020-05-31/origin-request-policy/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "OriginRequestPolicyConfig",
              "Id"
            ],
            members: {
              OriginRequestPolicyConfig: {
                shape: "S5j",
                locationName: "OriginRequestPolicyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "OriginRequestPolicyConfig"
          },
          output: {
            type: "structure",
            members: {
              OriginRequestPolicy: {
                shape: "S5r"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "OriginRequestPolicy"
          }
        },
        UpdatePublicKey: {
          http: {
            method: "PUT",
            requestUri: "/2020-05-31/public-key/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "PublicKeyConfig",
              "Id"
            ],
            members: {
              PublicKeyConfig: {
                shape: "S5t",
                locationName: "PublicKeyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "PublicKeyConfig"
          },
          output: {
            type: "structure",
            members: {
              PublicKey: {
                shape: "S5v"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKey"
          }
        },
        UpdateRealtimeLogConfig: {
          http: {
            method: "PUT",
            requestUri: "/2020-05-31/realtime-log-config/"
          },
          input: {
            locationName: "UpdateRealtimeLogConfigRequest",
            xmlNamespace: {
              uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
            },
            type: "structure",
            members: {
              EndPoints: {
                shape: "S5x"
              },
              Fields: {
                shape: "S60"
              },
              Name: {},
              ARN: {},
              SamplingRate: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RealtimeLogConfig: {
                shape: "S62"
              }
            }
          }
        },
        UpdateResponseHeadersPolicy: {
          http: {
            method: "PUT",
            requestUri: "/2020-05-31/response-headers-policy/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "ResponseHeadersPolicyConfig",
              "Id"
            ],
            members: {
              ResponseHeadersPolicyConfig: {
                shape: "S64",
                locationName: "ResponseHeadersPolicyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "ResponseHeadersPolicyConfig"
          },
          output: {
            type: "structure",
            members: {
              ResponseHeadersPolicy: {
                shape: "S6x"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "ResponseHeadersPolicy"
          }
        },
        UpdateStreamingDistribution: {
          http: {
            method: "PUT",
            requestUri: "/2020-05-31/streaming-distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfig",
              "Id"
            ],
            members: {
              StreamingDistributionConfig: {
                shape: "S6z",
                locationName: "StreamingDistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "StreamingDistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S73"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        }
      },
      shapes: {
        S6: {
          type: "structure",
          required: [
            "Id",
            "ARN",
            "Status",
            "LastModifiedTime",
            "InProgressInvalidationBatches",
            "DomainName",
            "DistributionConfig"
          ],
          members: {
            Id: {},
            ARN: {},
            Status: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            InProgressInvalidationBatches: {
              type: "integer"
            },
            DomainName: {},
            ActiveTrustedSigners: {
              shape: "S9"
            },
            ActiveTrustedKeyGroups: {
              type: "structure",
              required: [
                "Enabled",
                "Quantity"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "KeyGroup",
                    type: "structure",
                    members: {
                      KeyGroupId: {},
                      KeyPairIds: {
                        shape: "Sc"
                      }
                    }
                  }
                }
              }
            },
            DistributionConfig: {
              shape: "Sh"
            },
            AliasICPRecordals: {
              shape: "S2j"
            }
          }
        },
        S9: {
          type: "structure",
          required: [
            "Enabled",
            "Quantity"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Signer",
                type: "structure",
                members: {
                  AwsAccountNumber: {},
                  KeyPairIds: {
                    shape: "Sc"
                  }
                }
              }
            }
          }
        },
        Sc: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "KeyPairId"
              }
            }
          }
        },
        Sh: {
          type: "structure",
          required: [
            "CallerReference",
            "Origins",
            "DefaultCacheBehavior",
            "Comment",
            "Enabled"
          ],
          members: {
            CallerReference: {},
            Aliases: {
              shape: "Si"
            },
            DefaultRootObject: {},
            Origins: {
              shape: "Sk"
            },
            OriginGroups: {
              shape: "Sz"
            },
            DefaultCacheBehavior: {
              shape: "S18"
            },
            CacheBehaviors: {
              shape: "S21"
            },
            CustomErrorResponses: {
              shape: "S24"
            },
            Comment: {
              type: "string",
              sensitive: true
            },
            Logging: {
              type: "structure",
              required: [
                "Enabled",
                "IncludeCookies",
                "Bucket",
                "Prefix"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                IncludeCookies: {
                  type: "boolean"
                },
                Bucket: {},
                Prefix: {}
              }
            },
            PriceClass: {},
            Enabled: {
              type: "boolean"
            },
            ViewerCertificate: {
              shape: "S2a"
            },
            Restrictions: {
              shape: "S2e"
            },
            WebACLId: {},
            HttpVersion: {},
            IsIPV6Enabled: {
              type: "boolean"
            },
            ContinuousDeploymentPolicyId: {},
            Staging: {
              type: "boolean"
            }
          }
        },
        Si: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CNAME"
              }
            }
          }
        },
        Sk: {
          type: "structure",
          required: [
            "Quantity",
            "Items"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Origin",
                type: "structure",
                required: [
                  "Id",
                  "DomainName"
                ],
                members: {
                  Id: {},
                  DomainName: {},
                  OriginPath: {},
                  CustomHeaders: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "OriginCustomHeader",
                          type: "structure",
                          required: [
                            "HeaderName",
                            "HeaderValue"
                          ],
                          members: {
                            HeaderName: {},
                            HeaderValue: {
                              shape: "Sq"
                            }
                          }
                        }
                      }
                    }
                  },
                  S3OriginConfig: {
                    type: "structure",
                    required: [
                      "OriginAccessIdentity"
                    ],
                    members: {
                      OriginAccessIdentity: {}
                    }
                  },
                  CustomOriginConfig: {
                    type: "structure",
                    required: [
                      "HTTPPort",
                      "HTTPSPort",
                      "OriginProtocolPolicy"
                    ],
                    members: {
                      HTTPPort: {
                        type: "integer"
                      },
                      HTTPSPort: {
                        type: "integer"
                      },
                      OriginProtocolPolicy: {},
                      OriginSslProtocols: {
                        type: "structure",
                        required: [
                          "Quantity",
                          "Items"
                        ],
                        members: {
                          Quantity: {
                            type: "integer"
                          },
                          Items: {
                            type: "list",
                            member: {
                              locationName: "SslProtocol"
                            }
                          }
                        }
                      },
                      OriginReadTimeout: {
                        type: "integer"
                      },
                      OriginKeepaliveTimeout: {
                        type: "integer"
                      }
                    }
                  },
                  ConnectionAttempts: {
                    type: "integer"
                  },
                  ConnectionTimeout: {
                    type: "integer"
                  },
                  OriginShield: {
                    type: "structure",
                    required: [
                      "Enabled"
                    ],
                    members: {
                      Enabled: {
                        type: "boolean"
                      },
                      OriginShieldRegion: {}
                    }
                  },
                  OriginAccessControlId: {}
                }
              }
            }
          }
        },
        Sq: {
          type: "string",
          sensitive: true
        },
        Sz: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "OriginGroup",
                type: "structure",
                required: [
                  "Id",
                  "FailoverCriteria",
                  "Members"
                ],
                members: {
                  Id: {},
                  FailoverCriteria: {
                    type: "structure",
                    required: [
                      "StatusCodes"
                    ],
                    members: {
                      StatusCodes: {
                        type: "structure",
                        required: [
                          "Quantity",
                          "Items"
                        ],
                        members: {
                          Quantity: {
                            type: "integer"
                          },
                          Items: {
                            type: "list",
                            member: {
                              locationName: "StatusCode",
                              type: "integer"
                            }
                          }
                        }
                      }
                    }
                  },
                  Members: {
                    type: "structure",
                    required: [
                      "Quantity",
                      "Items"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "OriginGroupMember",
                          type: "structure",
                          required: [
                            "OriginId"
                          ],
                          members: {
                            OriginId: {}
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S18: {
          type: "structure",
          required: [
            "TargetOriginId",
            "ViewerProtocolPolicy"
          ],
          members: {
            TargetOriginId: {},
            TrustedSigners: {
              shape: "S19"
            },
            TrustedKeyGroups: {
              shape: "S1b"
            },
            ViewerProtocolPolicy: {},
            AllowedMethods: {
              shape: "S1e"
            },
            SmoothStreaming: {
              type: "boolean"
            },
            Compress: {
              type: "boolean"
            },
            LambdaFunctionAssociations: {
              shape: "S1i"
            },
            FunctionAssociations: {
              shape: "S1n"
            },
            FieldLevelEncryptionId: {},
            RealtimeLogConfigArn: {},
            CachePolicyId: {},
            OriginRequestPolicyId: {},
            ResponseHeadersPolicyId: {},
            ForwardedValues: {
              shape: "S1r",
              deprecated: true
            },
            MinTTL: {
              deprecated: true,
              type: "long"
            },
            DefaultTTL: {
              deprecated: true,
              type: "long"
            },
            MaxTTL: {
              deprecated: true,
              type: "long"
            }
          }
        },
        S19: {
          type: "structure",
          required: [
            "Enabled",
            "Quantity"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "AwsAccountNumber"
              }
            }
          }
        },
        S1b: {
          type: "structure",
          required: [
            "Enabled",
            "Quantity"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "KeyGroup"
              }
            }
          }
        },
        S1e: {
          type: "structure",
          required: [
            "Quantity",
            "Items"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              shape: "S1f"
            },
            CachedMethods: {
              type: "structure",
              required: [
                "Quantity",
                "Items"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  shape: "S1f"
                }
              }
            }
          }
        },
        S1f: {
          type: "list",
          member: {
            locationName: "Method"
          }
        },
        S1i: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "LambdaFunctionAssociation",
                type: "structure",
                required: [
                  "LambdaFunctionARN",
                  "EventType"
                ],
                members: {
                  LambdaFunctionARN: {},
                  EventType: {},
                  IncludeBody: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        S1n: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "FunctionAssociation",
                type: "structure",
                required: [
                  "FunctionARN",
                  "EventType"
                ],
                members: {
                  FunctionARN: {},
                  EventType: {}
                }
              }
            }
          }
        },
        S1r: {
          type: "structure",
          required: [
            "QueryString",
            "Cookies"
          ],
          members: {
            QueryString: {
              type: "boolean"
            },
            Cookies: {
              type: "structure",
              required: [
                "Forward"
              ],
              members: {
                Forward: {},
                WhitelistedNames: {
                  shape: "S1u"
                }
              }
            },
            Headers: {
              shape: "S1w"
            },
            QueryStringCacheKeys: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Name"
                  }
                }
              }
            }
          }
        },
        S1u: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Name"
              }
            }
          }
        },
        S1w: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Name"
              }
            }
          }
        },
        S21: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CacheBehavior",
                type: "structure",
                required: [
                  "PathPattern",
                  "TargetOriginId",
                  "ViewerProtocolPolicy"
                ],
                members: {
                  PathPattern: {},
                  TargetOriginId: {},
                  TrustedSigners: {
                    shape: "S19"
                  },
                  TrustedKeyGroups: {
                    shape: "S1b"
                  },
                  ViewerProtocolPolicy: {},
                  AllowedMethods: {
                    shape: "S1e"
                  },
                  SmoothStreaming: {
                    type: "boolean"
                  },
                  Compress: {
                    type: "boolean"
                  },
                  LambdaFunctionAssociations: {
                    shape: "S1i"
                  },
                  FunctionAssociations: {
                    shape: "S1n"
                  },
                  FieldLevelEncryptionId: {},
                  RealtimeLogConfigArn: {},
                  CachePolicyId: {},
                  OriginRequestPolicyId: {},
                  ResponseHeadersPolicyId: {},
                  ForwardedValues: {
                    shape: "S1r",
                    deprecated: true
                  },
                  MinTTL: {
                    deprecated: true,
                    type: "long"
                  },
                  DefaultTTL: {
                    deprecated: true,
                    type: "long"
                  },
                  MaxTTL: {
                    deprecated: true,
                    type: "long"
                  }
                }
              }
            }
          }
        },
        S24: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CustomErrorResponse",
                type: "structure",
                required: [
                  "ErrorCode"
                ],
                members: {
                  ErrorCode: {
                    type: "integer"
                  },
                  ResponsePagePath: {},
                  ResponseCode: {},
                  ErrorCachingMinTTL: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        S2a: {
          type: "structure",
          members: {
            CloudFrontDefaultCertificate: {
              type: "boolean"
            },
            IAMCertificateId: {},
            ACMCertificateArn: {},
            SSLSupportMethod: {},
            MinimumProtocolVersion: {},
            Certificate: {
              deprecated: true
            },
            CertificateSource: {
              deprecated: true
            }
          }
        },
        S2e: {
          type: "structure",
          required: [
            "GeoRestriction"
          ],
          members: {
            GeoRestriction: {
              type: "structure",
              required: [
                "RestrictionType",
                "Quantity"
              ],
              members: {
                RestrictionType: {},
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Location"
                  }
                }
              }
            }
          }
        },
        S2j: {
          type: "list",
          member: {
            locationName: "AliasICPRecordal",
            type: "structure",
            members: {
              CNAME: {},
              ICPRecordalStatus: {}
            }
          }
        },
        S2n: {
          type: "structure",
          required: [
            "Name",
            "MinTTL"
          ],
          members: {
            Comment: {},
            Name: {},
            DefaultTTL: {
              type: "long"
            },
            MaxTTL: {
              type: "long"
            },
            MinTTL: {
              type: "long"
            },
            ParametersInCacheKeyAndForwardedToOrigin: {
              type: "structure",
              required: [
                "EnableAcceptEncodingGzip",
                "HeadersConfig",
                "CookiesConfig",
                "QueryStringsConfig"
              ],
              members: {
                EnableAcceptEncodingGzip: {
                  type: "boolean"
                },
                EnableAcceptEncodingBrotli: {
                  type: "boolean"
                },
                HeadersConfig: {
                  type: "structure",
                  required: [
                    "HeaderBehavior"
                  ],
                  members: {
                    HeaderBehavior: {},
                    Headers: {
                      shape: "S1w"
                    }
                  }
                },
                CookiesConfig: {
                  type: "structure",
                  required: [
                    "CookieBehavior"
                  ],
                  members: {
                    CookieBehavior: {},
                    Cookies: {
                      shape: "S1u"
                    }
                  }
                },
                QueryStringsConfig: {
                  type: "structure",
                  required: [
                    "QueryStringBehavior"
                  ],
                  members: {
                    QueryStringBehavior: {},
                    QueryStrings: {
                      shape: "S2v"
                    }
                  }
                }
              }
            }
          }
        },
        S2v: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Name"
              }
            }
          }
        },
        S2y: {
          type: "structure",
          required: [
            "Id",
            "LastModifiedTime",
            "CachePolicyConfig"
          ],
          members: {
            Id: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            CachePolicyConfig: {
              shape: "S2n"
            }
          }
        },
        S30: {
          type: "structure",
          required: [
            "CallerReference",
            "Comment"
          ],
          members: {
            CallerReference: {},
            Comment: {}
          }
        },
        S32: {
          type: "structure",
          required: [
            "Id",
            "S3CanonicalUserId"
          ],
          members: {
            Id: {},
            S3CanonicalUserId: {},
            CloudFrontOriginAccessIdentityConfig: {
              shape: "S30"
            }
          }
        },
        S34: {
          type: "structure",
          required: [
            "StagingDistributionDnsNames",
            "Enabled"
          ],
          members: {
            StagingDistributionDnsNames: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "DnsName"
                  }
                }
              }
            },
            Enabled: {
              type: "boolean"
            },
            TrafficConfig: {
              type: "structure",
              required: [
                "Type"
              ],
              members: {
                SingleWeightConfig: {
                  type: "structure",
                  required: [
                    "Weight"
                  ],
                  members: {
                    Weight: {
                      type: "float"
                    },
                    SessionStickinessConfig: {
                      type: "structure",
                      required: [
                        "IdleTTL",
                        "MaximumTTL"
                      ],
                      members: {
                        IdleTTL: {
                          type: "integer"
                        },
                        MaximumTTL: {
                          type: "integer"
                        }
                      }
                    }
                  }
                },
                SingleHeaderConfig: {
                  type: "structure",
                  required: [
                    "Header",
                    "Value"
                  ],
                  members: {
                    Header: {},
                    Value: {}
                  }
                },
                Type: {}
              }
            }
          }
        },
        S3e: {
          type: "structure",
          required: [
            "Id",
            "LastModifiedTime",
            "ContinuousDeploymentPolicyConfig"
          ],
          members: {
            Id: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            ContinuousDeploymentPolicyConfig: {
              shape: "S34"
            }
          }
        },
        S3j: {
          type: "structure",
          members: {
            Items: {
              type: "list",
              member: {
                locationName: "Tag",
                type: "structure",
                required: [
                  "Key"
                ],
                members: {
                  Key: {},
                  Value: {}
                }
              }
            }
          }
        },
        S3q: {
          type: "structure",
          required: [
            "CallerReference"
          ],
          members: {
            CallerReference: {},
            Comment: {},
            QueryArgProfileConfig: {
              shape: "S3r"
            },
            ContentTypeProfileConfig: {
              shape: "S3v"
            }
          }
        },
        S3r: {
          type: "structure",
          required: [
            "ForwardWhenQueryArgProfileIsUnknown"
          ],
          members: {
            ForwardWhenQueryArgProfileIsUnknown: {
              type: "boolean"
            },
            QueryArgProfiles: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "QueryArgProfile",
                    type: "structure",
                    required: [
                      "QueryArg",
                      "ProfileId"
                    ],
                    members: {
                      QueryArg: {},
                      ProfileId: {}
                    }
                  }
                }
              }
            }
          }
        },
        S3v: {
          type: "structure",
          required: [
            "ForwardWhenContentTypeIsUnknown"
          ],
          members: {
            ForwardWhenContentTypeIsUnknown: {
              type: "boolean"
            },
            ContentTypeProfiles: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "ContentTypeProfile",
                    type: "structure",
                    required: [
                      "Format",
                      "ContentType"
                    ],
                    members: {
                      Format: {},
                      ProfileId: {},
                      ContentType: {}
                    }
                  }
                }
              }
            }
          }
        },
        S41: {
          type: "structure",
          required: [
            "Id",
            "LastModifiedTime",
            "FieldLevelEncryptionConfig"
          ],
          members: {
            Id: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            FieldLevelEncryptionConfig: {
              shape: "S3q"
            }
          }
        },
        S43: {
          type: "structure",
          required: [
            "Name",
            "CallerReference",
            "EncryptionEntities"
          ],
          members: {
            Name: {},
            CallerReference: {},
            Comment: {},
            EncryptionEntities: {
              shape: "S44"
            }
          }
        },
        S44: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "EncryptionEntity",
                type: "structure",
                required: [
                  "PublicKeyId",
                  "ProviderId",
                  "FieldPatterns"
                ],
                members: {
                  PublicKeyId: {},
                  ProviderId: {},
                  FieldPatterns: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "FieldPattern"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S4a: {
          type: "structure",
          required: [
            "Id",
            "LastModifiedTime",
            "FieldLevelEncryptionProfileConfig"
          ],
          members: {
            Id: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            FieldLevelEncryptionProfileConfig: {
              shape: "S43"
            }
          }
        },
        S4d: {
          type: "structure",
          required: [
            "Comment",
            "Runtime"
          ],
          members: {
            Comment: {},
            Runtime: {},
            KeyValueStoreAssociations: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "KeyValueStoreAssociation",
                    type: "structure",
                    required: [
                      "KeyValueStoreARN"
                    ],
                    members: {
                      KeyValueStoreARN: {}
                    }
                  }
                }
              }
            }
          }
        },
        S4j: {
          type: "blob",
          sensitive: true
        },
        S4l: {
          type: "structure",
          required: [
            "Name",
            "FunctionConfig",
            "FunctionMetadata"
          ],
          members: {
            Name: {},
            Status: {},
            FunctionConfig: {
              shape: "S4d"
            },
            FunctionMetadata: {
              type: "structure",
              required: [
                "FunctionARN",
                "LastModifiedTime"
              ],
              members: {
                FunctionARN: {},
                Stage: {},
                CreatedTime: {
                  type: "timestamp"
                },
                LastModifiedTime: {
                  type: "timestamp"
                }
              }
            }
          }
        },
        S4p: {
          type: "structure",
          required: [
            "Paths",
            "CallerReference"
          ],
          members: {
            Paths: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Path"
                  }
                }
              }
            },
            CallerReference: {}
          }
        },
        S4t: {
          type: "structure",
          required: [
            "Id",
            "Status",
            "CreateTime",
            "InvalidationBatch"
          ],
          members: {
            Id: {},
            Status: {},
            CreateTime: {
              type: "timestamp"
            },
            InvalidationBatch: {
              shape: "S4p"
            }
          }
        },
        S4v: {
          type: "structure",
          required: [
            "Name",
            "Items"
          ],
          members: {
            Name: {},
            Items: {
              type: "list",
              member: {
                locationName: "PublicKey"
              }
            },
            Comment: {}
          }
        },
        S4y: {
          type: "structure",
          required: [
            "Id",
            "LastModifiedTime",
            "KeyGroupConfig"
          ],
          members: {
            Id: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            KeyGroupConfig: {
              shape: "S4v"
            }
          }
        },
        S55: {
          type: "structure",
          required: [
            "Name",
            "Id",
            "Comment",
            "ARN",
            "LastModifiedTime"
          ],
          members: {
            Name: {},
            Id: {},
            Comment: {},
            ARN: {},
            Status: {},
            LastModifiedTime: {
              type: "timestamp"
            }
          }
        },
        S57: {
          type: "structure",
          members: {
            RealtimeMetricsSubscriptionConfig: {
              type: "structure",
              required: [
                "RealtimeMetricsSubscriptionStatus"
              ],
              members: {
                RealtimeMetricsSubscriptionStatus: {}
              }
            }
          }
        },
        S5c: {
          type: "structure",
          required: [
            "Name",
            "SigningProtocol",
            "SigningBehavior",
            "OriginAccessControlOriginType"
          ],
          members: {
            Name: {},
            Description: {},
            SigningProtocol: {},
            SigningBehavior: {},
            OriginAccessControlOriginType: {}
          }
        },
        S5h: {
          type: "structure",
          required: [
            "Id"
          ],
          members: {
            Id: {},
            OriginAccessControlConfig: {
              shape: "S5c"
            }
          }
        },
        S5j: {
          type: "structure",
          required: [
            "Name",
            "HeadersConfig",
            "CookiesConfig",
            "QueryStringsConfig"
          ],
          members: {
            Comment: {},
            Name: {},
            HeadersConfig: {
              type: "structure",
              required: [
                "HeaderBehavior"
              ],
              members: {
                HeaderBehavior: {},
                Headers: {
                  shape: "S1w"
                }
              }
            },
            CookiesConfig: {
              type: "structure",
              required: [
                "CookieBehavior"
              ],
              members: {
                CookieBehavior: {},
                Cookies: {
                  shape: "S1u"
                }
              }
            },
            QueryStringsConfig: {
              type: "structure",
              required: [
                "QueryStringBehavior"
              ],
              members: {
                QueryStringBehavior: {},
                QueryStrings: {
                  shape: "S2v"
                }
              }
            }
          }
        },
        S5r: {
          type: "structure",
          required: [
            "Id",
            "LastModifiedTime",
            "OriginRequestPolicyConfig"
          ],
          members: {
            Id: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            OriginRequestPolicyConfig: {
              shape: "S5j"
            }
          }
        },
        S5t: {
          type: "structure",
          required: [
            "CallerReference",
            "Name",
            "EncodedKey"
          ],
          members: {
            CallerReference: {},
            Name: {},
            EncodedKey: {},
            Comment: {}
          }
        },
        S5v: {
          type: "structure",
          required: [
            "Id",
            "CreatedTime",
            "PublicKeyConfig"
          ],
          members: {
            Id: {},
            CreatedTime: {
              type: "timestamp"
            },
            PublicKeyConfig: {
              shape: "S5t"
            }
          }
        },
        S5x: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "StreamType"
            ],
            members: {
              StreamType: {},
              KinesisStreamConfig: {
                type: "structure",
                required: [
                  "RoleARN",
                  "StreamARN"
                ],
                members: {
                  RoleARN: {},
                  StreamARN: {}
                }
              }
            }
          }
        },
        S60: {
          type: "list",
          member: {
            locationName: "Field"
          }
        },
        S62: {
          type: "structure",
          required: [
            "ARN",
            "Name",
            "SamplingRate",
            "EndPoints",
            "Fields"
          ],
          members: {
            ARN: {},
            Name: {},
            SamplingRate: {
              type: "long"
            },
            EndPoints: {
              shape: "S5x"
            },
            Fields: {
              shape: "S60"
            }
          }
        },
        S64: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Comment: {},
            Name: {},
            CorsConfig: {
              type: "structure",
              required: [
                "AccessControlAllowOrigins",
                "AccessControlAllowHeaders",
                "AccessControlAllowMethods",
                "AccessControlAllowCredentials",
                "OriginOverride"
              ],
              members: {
                AccessControlAllowOrigins: {
                  type: "structure",
                  required: [
                    "Quantity",
                    "Items"
                  ],
                  members: {
                    Quantity: {
                      type: "integer"
                    },
                    Items: {
                      type: "list",
                      member: {
                        locationName: "Origin"
                      }
                    }
                  }
                },
                AccessControlAllowHeaders: {
                  type: "structure",
                  required: [
                    "Quantity",
                    "Items"
                  ],
                  members: {
                    Quantity: {
                      type: "integer"
                    },
                    Items: {
                      type: "list",
                      member: {
                        locationName: "Header"
                      }
                    }
                  }
                },
                AccessControlAllowMethods: {
                  type: "structure",
                  required: [
                    "Quantity",
                    "Items"
                  ],
                  members: {
                    Quantity: {
                      type: "integer"
                    },
                    Items: {
                      type: "list",
                      member: {
                        locationName: "Method"
                      }
                    }
                  }
                },
                AccessControlAllowCredentials: {
                  type: "boolean"
                },
                AccessControlExposeHeaders: {
                  type: "structure",
                  required: [
                    "Quantity"
                  ],
                  members: {
                    Quantity: {
                      type: "integer"
                    },
                    Items: {
                      type: "list",
                      member: {
                        locationName: "Header"
                      }
                    }
                  }
                },
                AccessControlMaxAgeSec: {
                  type: "integer"
                },
                OriginOverride: {
                  type: "boolean"
                }
              }
            },
            SecurityHeadersConfig: {
              type: "structure",
              members: {
                XSSProtection: {
                  type: "structure",
                  required: [
                    "Override",
                    "Protection"
                  ],
                  members: {
                    Override: {
                      type: "boolean"
                    },
                    Protection: {
                      type: "boolean"
                    },
                    ModeBlock: {
                      type: "boolean"
                    },
                    ReportUri: {}
                  }
                },
                FrameOptions: {
                  type: "structure",
                  required: [
                    "Override",
                    "FrameOption"
                  ],
                  members: {
                    Override: {
                      type: "boolean"
                    },
                    FrameOption: {}
                  }
                },
                ReferrerPolicy: {
                  type: "structure",
                  required: [
                    "Override",
                    "ReferrerPolicy"
                  ],
                  members: {
                    Override: {
                      type: "boolean"
                    },
                    ReferrerPolicy: {}
                  }
                },
                ContentSecurityPolicy: {
                  type: "structure",
                  required: [
                    "Override",
                    "ContentSecurityPolicy"
                  ],
                  members: {
                    Override: {
                      type: "boolean"
                    },
                    ContentSecurityPolicy: {}
                  }
                },
                ContentTypeOptions: {
                  type: "structure",
                  required: [
                    "Override"
                  ],
                  members: {
                    Override: {
                      type: "boolean"
                    }
                  }
                },
                StrictTransportSecurity: {
                  type: "structure",
                  required: [
                    "Override",
                    "AccessControlMaxAgeSec"
                  ],
                  members: {
                    Override: {
                      type: "boolean"
                    },
                    IncludeSubdomains: {
                      type: "boolean"
                    },
                    Preload: {
                      type: "boolean"
                    },
                    AccessControlMaxAgeSec: {
                      type: "integer"
                    }
                  }
                }
              }
            },
            ServerTimingHeadersConfig: {
              type: "structure",
              required: [
                "Enabled"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                SamplingRate: {
                  type: "double"
                }
              }
            },
            CustomHeadersConfig: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "ResponseHeadersPolicyCustomHeader",
                    type: "structure",
                    required: [
                      "Header",
                      "Value",
                      "Override"
                    ],
                    members: {
                      Header: {},
                      Value: {},
                      Override: {
                        type: "boolean"
                      }
                    }
                  }
                }
              }
            },
            RemoveHeadersConfig: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "ResponseHeadersPolicyRemoveHeader",
                    type: "structure",
                    required: [
                      "Header"
                    ],
                    members: {
                      Header: {}
                    }
                  }
                }
              }
            }
          }
        },
        S6x: {
          type: "structure",
          required: [
            "Id",
            "LastModifiedTime",
            "ResponseHeadersPolicyConfig"
          ],
          members: {
            Id: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            ResponseHeadersPolicyConfig: {
              shape: "S64"
            }
          }
        },
        S6z: {
          type: "structure",
          required: [
            "CallerReference",
            "S3Origin",
            "Comment",
            "TrustedSigners",
            "Enabled"
          ],
          members: {
            CallerReference: {},
            S3Origin: {
              shape: "S70"
            },
            Aliases: {
              shape: "Si"
            },
            Comment: {},
            Logging: {
              type: "structure",
              required: [
                "Enabled",
                "Bucket",
                "Prefix"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                Bucket: {},
                Prefix: {}
              }
            },
            TrustedSigners: {
              shape: "S19"
            },
            PriceClass: {},
            Enabled: {
              type: "boolean"
            }
          }
        },
        S70: {
          type: "structure",
          required: [
            "DomainName",
            "OriginAccessIdentity"
          ],
          members: {
            DomainName: {},
            OriginAccessIdentity: {}
          }
        },
        S73: {
          type: "structure",
          required: [
            "Id",
            "ARN",
            "Status",
            "DomainName",
            "ActiveTrustedSigners",
            "StreamingDistributionConfig"
          ],
          members: {
            Id: {},
            ARN: {},
            Status: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            DomainName: {},
            ActiveTrustedSigners: {
              shape: "S9"
            },
            StreamingDistributionConfig: {
              shape: "S6z"
            }
          }
        },
        Sa2: {
          type: "structure",
          required: [
            "Marker",
            "MaxItems",
            "IsTruncated",
            "Quantity"
          ],
          members: {
            Marker: {},
            NextMarker: {},
            MaxItems: {
              type: "integer"
            },
            IsTruncated: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "DistributionSummary",
                type: "structure",
                required: [
                  "Id",
                  "ARN",
                  "Status",
                  "LastModifiedTime",
                  "DomainName",
                  "Aliases",
                  "Origins",
                  "DefaultCacheBehavior",
                  "CacheBehaviors",
                  "CustomErrorResponses",
                  "Comment",
                  "PriceClass",
                  "Enabled",
                  "ViewerCertificate",
                  "Restrictions",
                  "WebACLId",
                  "HttpVersion",
                  "IsIPV6Enabled",
                  "Staging"
                ],
                members: {
                  Id: {},
                  ARN: {},
                  Status: {},
                  LastModifiedTime: {
                    type: "timestamp"
                  },
                  DomainName: {},
                  Aliases: {
                    shape: "Si"
                  },
                  Origins: {
                    shape: "Sk"
                  },
                  OriginGroups: {
                    shape: "Sz"
                  },
                  DefaultCacheBehavior: {
                    shape: "S18"
                  },
                  CacheBehaviors: {
                    shape: "S21"
                  },
                  CustomErrorResponses: {
                    shape: "S24"
                  },
                  Comment: {},
                  PriceClass: {},
                  Enabled: {
                    type: "boolean"
                  },
                  ViewerCertificate: {
                    shape: "S2a"
                  },
                  Restrictions: {
                    shape: "S2e"
                  },
                  WebACLId: {},
                  HttpVersion: {},
                  IsIPV6Enabled: {
                    type: "boolean"
                  },
                  AliasICPRecordals: {
                    shape: "S2j"
                  },
                  Staging: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        Sa7: {
          type: "structure",
          required: [
            "Marker",
            "MaxItems",
            "IsTruncated",
            "Quantity"
          ],
          members: {
            Marker: {},
            NextMarker: {},
            MaxItems: {
              type: "integer"
            },
            IsTruncated: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "DistributionId"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2020-05-31.paginators.json
var require_cloudfront_2020_05_31_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2020-05-31.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListCloudFrontOriginAccessIdentities: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "CloudFrontOriginAccessIdentityList.IsTruncated",
          output_token: "CloudFrontOriginAccessIdentityList.NextMarker",
          result_key: "CloudFrontOriginAccessIdentityList.Items"
        },
        ListDistributions: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "DistributionList.IsTruncated",
          output_token: "DistributionList.NextMarker",
          result_key: "DistributionList.Items"
        },
        ListInvalidations: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "InvalidationList.IsTruncated",
          output_token: "InvalidationList.NextMarker",
          result_key: "InvalidationList.Items"
        },
        ListKeyValueStores: {
          input_token: "Marker",
          limit_key: "MaxItems",
          output_token: "KeyValueStoreList.NextMarker",
          result_key: "KeyValueStoreList.Items"
        },
        ListStreamingDistributions: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "StreamingDistributionList.IsTruncated",
          output_token: "StreamingDistributionList.NextMarker",
          result_key: "StreamingDistributionList.Items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2020-05-31.waiters2.json
var require_cloudfront_2020_05_31_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2020-05-31.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        DistributionDeployed: {
          delay: 60,
          operation: "GetDistribution",
          maxAttempts: 35,
          description: "Wait until a distribution is deployed.",
          acceptors: [
            {
              expected: "Deployed",
              matcher: "path",
              state: "success",
              argument: "Distribution.Status"
            }
          ]
        },
        InvalidationCompleted: {
          delay: 20,
          operation: "GetInvalidation",
          maxAttempts: 30,
          description: "Wait until an invalidation has completed.",
          acceptors: [
            {
              expected: "Completed",
              matcher: "path",
              state: "success",
              argument: "Invalidation.Status"
            }
          ]
        },
        StreamingDistributionDeployed: {
          delay: 60,
          operation: "GetStreamingDistribution",
          maxAttempts: 25,
          description: "Wait until a streaming distribution is deployed.",
          acceptors: [
            {
              expected: "Deployed",
              matcher: "path",
              state: "success",
              argument: "StreamingDistribution.Status"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/cloudfront.js
var require_cloudfront2 = __commonJS({
  "node_modules/aws-sdk/clients/cloudfront.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["cloudfront"] = {};
    AWS2.CloudFront = Service.defineService("cloudfront", ["2013-05-12*", "2013-11-11*", "2014-05-31*", "2014-10-21*", "2014-11-06*", "2015-04-17*", "2015-07-27*", "2015-09-17*", "2016-01-13*", "2016-01-28*", "2016-08-01*", "2016-08-20*", "2016-09-07*", "2016-09-29*", "2016-11-25", "2016-11-25*", "2017-03-25", "2017-03-25*", "2017-10-30", "2017-10-30*", "2018-06-18", "2018-06-18*", "2018-11-05", "2018-11-05*", "2019-03-26", "2019-03-26*", "2020-05-31"]);
    require_cloudfront();
    Object.defineProperty(apiLoader.services["cloudfront"], "2016-11-25", {
      get: function get() {
        var model = require_cloudfront_2016_11_25_min();
        model.paginators = require_cloudfront_2016_11_25_paginators().pagination;
        model.waiters = require_cloudfront_2016_11_25_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(apiLoader.services["cloudfront"], "2017-03-25", {
      get: function get() {
        var model = require_cloudfront_2017_03_25_min();
        model.paginators = require_cloudfront_2017_03_25_paginators().pagination;
        model.waiters = require_cloudfront_2017_03_25_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(apiLoader.services["cloudfront"], "2017-10-30", {
      get: function get() {
        var model = require_cloudfront_2017_10_30_min();
        model.paginators = require_cloudfront_2017_10_30_paginators().pagination;
        model.waiters = require_cloudfront_2017_10_30_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(apiLoader.services["cloudfront"], "2018-06-18", {
      get: function get() {
        var model = require_cloudfront_2018_06_18_min();
        model.paginators = require_cloudfront_2018_06_18_paginators().pagination;
        model.waiters = require_cloudfront_2018_06_18_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(apiLoader.services["cloudfront"], "2018-11-05", {
      get: function get() {
        var model = require_cloudfront_2018_11_05_min();
        model.paginators = require_cloudfront_2018_11_05_paginators().pagination;
        model.waiters = require_cloudfront_2018_11_05_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(apiLoader.services["cloudfront"], "2019-03-26", {
      get: function get() {
        var model = require_cloudfront_2019_03_26_min();
        model.paginators = require_cloudfront_2019_03_26_paginators().pagination;
        model.waiters = require_cloudfront_2019_03_26_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(apiLoader.services["cloudfront"], "2020-05-31", {
      get: function get() {
        var model = require_cloudfront_2020_05_31_min();
        model.paginators = require_cloudfront_2020_05_31_paginators().pagination;
        model.waiters = require_cloudfront_2020_05_31_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CloudFront;
  }
});

// node_modules/aws-sdk/apis/cloudhsm-2014-05-30.min.json
var require_cloudhsm_2014_05_30_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudhsm-2014-05-30.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-05-30",
        endpointPrefix: "cloudhsm",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "CloudHSM",
        serviceFullName: "Amazon CloudHSM",
        serviceId: "CloudHSM",
        signatureVersion: "v4",
        targetPrefix: "CloudHsmFrontendService",
        uid: "cloudhsm-2014-05-30"
      },
      operations: {
        AddTagsToResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagList"
            ],
            members: {
              ResourceArn: {},
              TagList: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Status"
            ],
            members: {
              Status: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This API is deprecated."
        },
        CreateHapg: {
          input: {
            type: "structure",
            required: [
              "Label"
            ],
            members: {
              Label: {}
            }
          },
          output: {
            type: "structure",
            members: {
              HapgArn: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This API is deprecated."
        },
        CreateHsm: {
          input: {
            type: "structure",
            required: [
              "SubnetId",
              "SshKey",
              "IamRoleArn",
              "SubscriptionType"
            ],
            members: {
              SubnetId: {},
              SshKey: {},
              EniIp: {},
              IamRoleArn: {},
              ExternalId: {},
              SubscriptionType: {},
              ClientToken: {},
              SyslogIp: {}
            }
          },
          output: {
            type: "structure",
            members: {
              HsmArn: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This API is deprecated."
        },
        CreateLunaClient: {
          input: {
            type: "structure",
            required: [
              "Certificate"
            ],
            members: {
              Label: {},
              Certificate: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ClientArn: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This API is deprecated."
        },
        DeleteHapg: {
          input: {
            type: "structure",
            required: [
              "HapgArn"
            ],
            members: {
              HapgArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Status"
            ],
            members: {
              Status: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This API is deprecated."
        },
        DeleteHsm: {
          input: {
            type: "structure",
            required: [
              "HsmArn"
            ],
            members: {
              HsmArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Status"
            ],
            members: {
              Status: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This API is deprecated."
        },
        DeleteLunaClient: {
          input: {
            type: "structure",
            required: [
              "ClientArn"
            ],
            members: {
              ClientArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Status"
            ],
            members: {
              Status: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This API is deprecated."
        },
        DescribeHapg: {
          input: {
            type: "structure",
            required: [
              "HapgArn"
            ],
            members: {
              HapgArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              HapgArn: {},
              HapgSerial: {},
              HsmsLastActionFailed: {
                shape: "Sz"
              },
              HsmsPendingDeletion: {
                shape: "Sz"
              },
              HsmsPendingRegistration: {
                shape: "Sz"
              },
              Label: {},
              LastModifiedTimestamp: {},
              PartitionSerialList: {
                shape: "S11"
              },
              State: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This API is deprecated."
        },
        DescribeHsm: {
          input: {
            type: "structure",
            members: {
              HsmArn: {},
              HsmSerialNumber: {}
            }
          },
          output: {
            type: "structure",
            members: {
              HsmArn: {},
              Status: {},
              StatusDetails: {},
              AvailabilityZone: {},
              EniId: {},
              EniIp: {},
              SubscriptionType: {},
              SubscriptionStartDate: {},
              SubscriptionEndDate: {},
              VpcId: {},
              SubnetId: {},
              IamRoleArn: {},
              SerialNumber: {},
              VendorName: {},
              HsmType: {},
              SoftwareVersion: {},
              SshPublicKey: {},
              SshKeyLastUpdated: {},
              ServerCertUri: {},
              ServerCertLastUpdated: {},
              Partitions: {
                type: "list",
                member: {}
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "This API is deprecated."
        },
        DescribeLunaClient: {
          input: {
            type: "structure",
            members: {
              ClientArn: {},
              CertificateFingerprint: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ClientArn: {},
              Certificate: {},
              CertificateFingerprint: {},
              LastModifiedTimestamp: {},
              Label: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This API is deprecated."
        },
        GetConfig: {
          input: {
            type: "structure",
            required: [
              "ClientArn",
              "ClientVersion",
              "HapgList"
            ],
            members: {
              ClientArn: {},
              ClientVersion: {},
              HapgList: {
                shape: "S1i"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigType: {},
              ConfigFile: {},
              ConfigCred: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This API is deprecated."
        },
        ListAvailableZones: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              AZList: {
                type: "list",
                member: {}
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "This API is deprecated."
        },
        ListHapgs: {
          input: {
            type: "structure",
            members: {
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "HapgList"
            ],
            members: {
              HapgList: {
                shape: "S1i"
              },
              NextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This API is deprecated."
        },
        ListHsms: {
          input: {
            type: "structure",
            members: {
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              HsmList: {
                shape: "Sz"
              },
              NextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This API is deprecated."
        },
        ListLunaClients: {
          input: {
            type: "structure",
            members: {
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ClientList"
            ],
            members: {
              ClientList: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This API is deprecated."
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "TagList"
            ],
            members: {
              TagList: {
                shape: "S3"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "This API is deprecated."
        },
        ModifyHapg: {
          input: {
            type: "structure",
            required: [
              "HapgArn"
            ],
            members: {
              HapgArn: {},
              Label: {},
              PartitionSerialList: {
                shape: "S11"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HapgArn: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This API is deprecated."
        },
        ModifyHsm: {
          input: {
            type: "structure",
            required: [
              "HsmArn"
            ],
            members: {
              HsmArn: {},
              SubnetId: {},
              EniIp: {},
              IamRoleArn: {},
              ExternalId: {},
              SyslogIp: {}
            }
          },
          output: {
            type: "structure",
            members: {
              HsmArn: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This API is deprecated."
        },
        ModifyLunaClient: {
          input: {
            type: "structure",
            required: [
              "ClientArn",
              "Certificate"
            ],
            members: {
              ClientArn: {},
              Certificate: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ClientArn: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This API is deprecated."
        },
        RemoveTagsFromResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeyList"
            ],
            members: {
              ResourceArn: {},
              TagKeyList: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Status"
            ],
            members: {
              Status: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This API is deprecated."
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sz: {
          type: "list",
          member: {}
        },
        S11: {
          type: "list",
          member: {}
        },
        S1i: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudhsm-2014-05-30.paginators.json
var require_cloudhsm_2014_05_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloudhsm-2014-05-30.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/cloudhsm.js
var require_cloudhsm = __commonJS({
  "node_modules/aws-sdk/clients/cloudhsm.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["cloudhsm"] = {};
    AWS2.CloudHSM = Service.defineService("cloudhsm", ["2014-05-30"]);
    Object.defineProperty(apiLoader.services["cloudhsm"], "2014-05-30", {
      get: function get() {
        var model = require_cloudhsm_2014_05_30_min();
        model.paginators = require_cloudhsm_2014_05_30_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CloudHSM;
  }
});

// node_modules/aws-sdk/apis/cloudsearch-2011-02-01.min.json
var require_cloudsearch_2011_02_01_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudsearch-2011-02-01.min.json"(exports2, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2011-02-01",
        endpointPrefix: "cloudsearch",
        serviceFullName: "Amazon CloudSearch",
        serviceId: "CloudSearch",
        signatureVersion: "v4",
        xmlNamespace: "http://cloudsearch.amazonaws.com/doc/2011-02-01/",
        protocol: "query"
      },
      operations: {
        CreateDomain: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            resultWrapper: "CreateDomainResult",
            type: "structure",
            members: {
              DomainStatus: {
                shape: "S4"
              }
            }
          }
        },
        DefineIndexField: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "IndexField"
            ],
            members: {
              DomainName: {},
              IndexField: {
                shape: "Sf"
              }
            }
          },
          output: {
            resultWrapper: "DefineIndexFieldResult",
            type: "structure",
            required: [
              "IndexField"
            ],
            members: {
              IndexField: {
                shape: "Sx"
              }
            }
          }
        },
        DefineRankExpression: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "RankExpression"
            ],
            members: {
              DomainName: {},
              RankExpression: {
                shape: "S12"
              }
            }
          },
          output: {
            resultWrapper: "DefineRankExpressionResult",
            type: "structure",
            required: [
              "RankExpression"
            ],
            members: {
              RankExpression: {
                shape: "S15"
              }
            }
          }
        },
        DeleteDomain: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            resultWrapper: "DeleteDomainResult",
            type: "structure",
            members: {
              DomainStatus: {
                shape: "S4"
              }
            }
          }
        },
        DeleteIndexField: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "IndexFieldName"
            ],
            members: {
              DomainName: {},
              IndexFieldName: {}
            }
          },
          output: {
            resultWrapper: "DeleteIndexFieldResult",
            type: "structure",
            required: [
              "IndexField"
            ],
            members: {
              IndexField: {
                shape: "Sx"
              }
            }
          }
        },
        DeleteRankExpression: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "RankName"
            ],
            members: {
              DomainName: {},
              RankName: {}
            }
          },
          output: {
            resultWrapper: "DeleteRankExpressionResult",
            type: "structure",
            required: [
              "RankExpression"
            ],
            members: {
              RankExpression: {
                shape: "S15"
              }
            }
          }
        },
        DescribeAvailabilityOptions: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            resultWrapper: "DescribeAvailabilityOptionsResult",
            type: "structure",
            members: {
              AvailabilityOptions: {
                shape: "S1e"
              }
            }
          }
        },
        DescribeDefaultSearchField: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            resultWrapper: "DescribeDefaultSearchFieldResult",
            type: "structure",
            required: [
              "DefaultSearchField"
            ],
            members: {
              DefaultSearchField: {
                shape: "S1i"
              }
            }
          }
        },
        DescribeDomains: {
          input: {
            type: "structure",
            members: {
              DomainNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "DescribeDomainsResult",
            type: "structure",
            required: [
              "DomainStatusList"
            ],
            members: {
              DomainStatusList: {
                type: "list",
                member: {
                  shape: "S4"
                }
              }
            }
          }
        },
        DescribeIndexFields: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              FieldNames: {
                shape: "S1o"
              }
            }
          },
          output: {
            resultWrapper: "DescribeIndexFieldsResult",
            type: "structure",
            required: [
              "IndexFields"
            ],
            members: {
              IndexFields: {
                type: "list",
                member: {
                  shape: "Sx"
                }
              }
            }
          }
        },
        DescribeRankExpressions: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              RankNames: {
                shape: "S1o"
              }
            }
          },
          output: {
            resultWrapper: "DescribeRankExpressionsResult",
            type: "structure",
            required: [
              "RankExpressions"
            ],
            members: {
              RankExpressions: {
                type: "list",
                member: {
                  shape: "S15"
                }
              }
            }
          }
        },
        DescribeServiceAccessPolicies: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            resultWrapper: "DescribeServiceAccessPoliciesResult",
            type: "structure",
            required: [
              "AccessPolicies"
            ],
            members: {
              AccessPolicies: {
                shape: "S1w"
              }
            }
          }
        },
        DescribeStemmingOptions: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            resultWrapper: "DescribeStemmingOptionsResult",
            type: "structure",
            required: [
              "Stems"
            ],
            members: {
              Stems: {
                shape: "S20"
              }
            }
          }
        },
        DescribeStopwordOptions: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            resultWrapper: "DescribeStopwordOptionsResult",
            type: "structure",
            required: [
              "Stopwords"
            ],
            members: {
              Stopwords: {
                shape: "S24"
              }
            }
          }
        },
        DescribeSynonymOptions: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            resultWrapper: "DescribeSynonymOptionsResult",
            type: "structure",
            required: [
              "Synonyms"
            ],
            members: {
              Synonyms: {
                shape: "S28"
              }
            }
          }
        },
        IndexDocuments: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            resultWrapper: "IndexDocumentsResult",
            type: "structure",
            members: {
              FieldNames: {
                shape: "S1o"
              }
            }
          }
        },
        UpdateAvailabilityOptions: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "MultiAZ"
            ],
            members: {
              DomainName: {},
              MultiAZ: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "UpdateAvailabilityOptionsResult",
            type: "structure",
            members: {
              AvailabilityOptions: {
                shape: "S1e"
              }
            }
          }
        },
        UpdateDefaultSearchField: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "DefaultSearchField"
            ],
            members: {
              DomainName: {},
              DefaultSearchField: {}
            }
          },
          output: {
            resultWrapper: "UpdateDefaultSearchFieldResult",
            type: "structure",
            required: [
              "DefaultSearchField"
            ],
            members: {
              DefaultSearchField: {
                shape: "S1i"
              }
            }
          }
        },
        UpdateServiceAccessPolicies: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "AccessPolicies"
            ],
            members: {
              DomainName: {},
              AccessPolicies: {}
            }
          },
          output: {
            resultWrapper: "UpdateServiceAccessPoliciesResult",
            type: "structure",
            required: [
              "AccessPolicies"
            ],
            members: {
              AccessPolicies: {
                shape: "S1w"
              }
            }
          }
        },
        UpdateStemmingOptions: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Stems"
            ],
            members: {
              DomainName: {},
              Stems: {}
            }
          },
          output: {
            resultWrapper: "UpdateStemmingOptionsResult",
            type: "structure",
            required: [
              "Stems"
            ],
            members: {
              Stems: {
                shape: "S20"
              }
            }
          }
        },
        UpdateStopwordOptions: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Stopwords"
            ],
            members: {
              DomainName: {},
              Stopwords: {}
            }
          },
          output: {
            resultWrapper: "UpdateStopwordOptionsResult",
            type: "structure",
            required: [
              "Stopwords"
            ],
            members: {
              Stopwords: {
                shape: "S24"
              }
            }
          }
        },
        UpdateSynonymOptions: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Synonyms"
            ],
            members: {
              DomainName: {},
              Synonyms: {}
            }
          },
          output: {
            resultWrapper: "UpdateSynonymOptionsResult",
            type: "structure",
            required: [
              "Synonyms"
            ],
            members: {
              Synonyms: {
                shape: "S28"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          required: [
            "DomainId",
            "DomainName",
            "RequiresIndexDocuments"
          ],
          members: {
            DomainId: {},
            DomainName: {},
            Created: {
              type: "boolean"
            },
            Deleted: {
              type: "boolean"
            },
            NumSearchableDocs: {
              type: "long"
            },
            DocService: {
              shape: "S8"
            },
            SearchService: {
              shape: "S8"
            },
            RequiresIndexDocuments: {
              type: "boolean"
            },
            Processing: {
              type: "boolean"
            },
            SearchInstanceType: {},
            SearchPartitionCount: {
              type: "integer"
            },
            SearchInstanceCount: {
              type: "integer"
            }
          }
        },
        S8: {
          type: "structure",
          members: {
            Arn: {},
            Endpoint: {}
          }
        },
        Sf: {
          type: "structure",
          required: [
            "IndexFieldName",
            "IndexFieldType"
          ],
          members: {
            IndexFieldName: {},
            IndexFieldType: {},
            UIntOptions: {
              type: "structure",
              members: {
                DefaultValue: {
                  type: "integer"
                }
              }
            },
            LiteralOptions: {
              type: "structure",
              members: {
                DefaultValue: {},
                SearchEnabled: {
                  type: "boolean"
                },
                FacetEnabled: {
                  type: "boolean"
                },
                ResultEnabled: {
                  type: "boolean"
                }
              }
            },
            TextOptions: {
              type: "structure",
              members: {
                DefaultValue: {},
                FacetEnabled: {
                  type: "boolean"
                },
                ResultEnabled: {
                  type: "boolean"
                },
                TextProcessor: {}
              }
            },
            SourceAttributes: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "SourceDataFunction"
                ],
                members: {
                  SourceDataFunction: {},
                  SourceDataCopy: {
                    type: "structure",
                    required: [
                      "SourceName"
                    ],
                    members: {
                      SourceName: {},
                      DefaultValue: {}
                    }
                  },
                  SourceDataTrimTitle: {
                    type: "structure",
                    required: [
                      "SourceName"
                    ],
                    members: {
                      SourceName: {},
                      DefaultValue: {},
                      Separator: {},
                      Language: {}
                    }
                  },
                  SourceDataMap: {
                    type: "structure",
                    required: [
                      "SourceName"
                    ],
                    members: {
                      SourceName: {},
                      DefaultValue: {},
                      Cases: {
                        type: "map",
                        key: {},
                        value: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sx: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {
              shape: "Sf"
            },
            Status: {
              shape: "Sy"
            }
          }
        },
        Sy: {
          type: "structure",
          required: [
            "CreationDate",
            "UpdateDate",
            "State"
          ],
          members: {
            CreationDate: {
              type: "timestamp"
            },
            UpdateDate: {
              type: "timestamp"
            },
            UpdateVersion: {
              type: "integer"
            },
            State: {},
            PendingDeletion: {
              type: "boolean"
            }
          }
        },
        S12: {
          type: "structure",
          required: [
            "RankName",
            "RankExpression"
          ],
          members: {
            RankName: {},
            RankExpression: {}
          }
        },
        S15: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {
              shape: "S12"
            },
            Status: {
              shape: "Sy"
            }
          }
        },
        S1e: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {
              type: "boolean"
            },
            Status: {
              shape: "Sy"
            }
          }
        },
        S1i: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {},
            Status: {
              shape: "Sy"
            }
          }
        },
        S1o: {
          type: "list",
          member: {}
        },
        S1w: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {},
            Status: {
              shape: "Sy"
            }
          }
        },
        S20: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {},
            Status: {
              shape: "Sy"
            }
          }
        },
        S24: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {},
            Status: {
              shape: "Sy"
            }
          }
        },
        S28: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {},
            Status: {
              shape: "Sy"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudsearch-2011-02-01.paginators.json
var require_cloudsearch_2011_02_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloudsearch-2011-02-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeDomains: {
          result_key: "DomainStatusList"
        },
        DescribeIndexFields: {
          result_key: "IndexFields"
        },
        DescribeRankExpressions: {
          result_key: "RankExpressions"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudsearch-2013-01-01.min.json
var require_cloudsearch_2013_01_01_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudsearch-2013-01-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2013-01-01",
        endpointPrefix: "cloudsearch",
        protocol: "query",
        serviceFullName: "Amazon CloudSearch",
        serviceId: "CloudSearch",
        signatureVersion: "v4",
        uid: "cloudsearch-2013-01-01",
        xmlNamespace: "http://cloudsearch.amazonaws.com/doc/2013-01-01/"
      },
      operations: {
        BuildSuggesters: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            resultWrapper: "BuildSuggestersResult",
            type: "structure",
            members: {
              FieldNames: {
                shape: "S4"
              }
            }
          }
        },
        CreateDomain: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            resultWrapper: "CreateDomainResult",
            type: "structure",
            members: {
              DomainStatus: {
                shape: "S8"
              }
            }
          }
        },
        DefineAnalysisScheme: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "AnalysisScheme"
            ],
            members: {
              DomainName: {},
              AnalysisScheme: {
                shape: "Sl"
              }
            }
          },
          output: {
            resultWrapper: "DefineAnalysisSchemeResult",
            type: "structure",
            required: [
              "AnalysisScheme"
            ],
            members: {
              AnalysisScheme: {
                shape: "Ss"
              }
            }
          }
        },
        DefineExpression: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Expression"
            ],
            members: {
              DomainName: {},
              Expression: {
                shape: "Sy"
              }
            }
          },
          output: {
            resultWrapper: "DefineExpressionResult",
            type: "structure",
            required: [
              "Expression"
            ],
            members: {
              Expression: {
                shape: "S11"
              }
            }
          }
        },
        DefineIndexField: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "IndexField"
            ],
            members: {
              DomainName: {},
              IndexField: {
                shape: "S13"
              }
            }
          },
          output: {
            resultWrapper: "DefineIndexFieldResult",
            type: "structure",
            required: [
              "IndexField"
            ],
            members: {
              IndexField: {
                shape: "S1n"
              }
            }
          }
        },
        DefineSuggester: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Suggester"
            ],
            members: {
              DomainName: {},
              Suggester: {
                shape: "S1p"
              }
            }
          },
          output: {
            resultWrapper: "DefineSuggesterResult",
            type: "structure",
            required: [
              "Suggester"
            ],
            members: {
              Suggester: {
                shape: "S1t"
              }
            }
          }
        },
        DeleteAnalysisScheme: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "AnalysisSchemeName"
            ],
            members: {
              DomainName: {},
              AnalysisSchemeName: {}
            }
          },
          output: {
            resultWrapper: "DeleteAnalysisSchemeResult",
            type: "structure",
            required: [
              "AnalysisScheme"
            ],
            members: {
              AnalysisScheme: {
                shape: "Ss"
              }
            }
          }
        },
        DeleteDomain: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            resultWrapper: "DeleteDomainResult",
            type: "structure",
            members: {
              DomainStatus: {
                shape: "S8"
              }
            }
          }
        },
        DeleteExpression: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "ExpressionName"
            ],
            members: {
              DomainName: {},
              ExpressionName: {}
            }
          },
          output: {
            resultWrapper: "DeleteExpressionResult",
            type: "structure",
            required: [
              "Expression"
            ],
            members: {
              Expression: {
                shape: "S11"
              }
            }
          }
        },
        DeleteIndexField: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "IndexFieldName"
            ],
            members: {
              DomainName: {},
              IndexFieldName: {}
            }
          },
          output: {
            resultWrapper: "DeleteIndexFieldResult",
            type: "structure",
            required: [
              "IndexField"
            ],
            members: {
              IndexField: {
                shape: "S1n"
              }
            }
          }
        },
        DeleteSuggester: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "SuggesterName"
            ],
            members: {
              DomainName: {},
              SuggesterName: {}
            }
          },
          output: {
            resultWrapper: "DeleteSuggesterResult",
            type: "structure",
            required: [
              "Suggester"
            ],
            members: {
              Suggester: {
                shape: "S1t"
              }
            }
          }
        },
        DescribeAnalysisSchemes: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              AnalysisSchemeNames: {
                shape: "S25"
              },
              Deployed: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeAnalysisSchemesResult",
            type: "structure",
            required: [
              "AnalysisSchemes"
            ],
            members: {
              AnalysisSchemes: {
                type: "list",
                member: {
                  shape: "Ss"
                }
              }
            }
          }
        },
        DescribeAvailabilityOptions: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              Deployed: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeAvailabilityOptionsResult",
            type: "structure",
            members: {
              AvailabilityOptions: {
                shape: "S2a"
              }
            }
          }
        },
        DescribeDomainEndpointOptions: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              Deployed: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeDomainEndpointOptionsResult",
            type: "structure",
            members: {
              DomainEndpointOptions: {
                shape: "S2e"
              }
            }
          }
        },
        DescribeDomains: {
          input: {
            type: "structure",
            members: {
              DomainNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "DescribeDomainsResult",
            type: "structure",
            required: [
              "DomainStatusList"
            ],
            members: {
              DomainStatusList: {
                type: "list",
                member: {
                  shape: "S8"
                }
              }
            }
          }
        },
        DescribeExpressions: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              ExpressionNames: {
                shape: "S25"
              },
              Deployed: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeExpressionsResult",
            type: "structure",
            required: [
              "Expressions"
            ],
            members: {
              Expressions: {
                type: "list",
                member: {
                  shape: "S11"
                }
              }
            }
          }
        },
        DescribeIndexFields: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              FieldNames: {
                type: "list",
                member: {}
              },
              Deployed: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeIndexFieldsResult",
            type: "structure",
            required: [
              "IndexFields"
            ],
            members: {
              IndexFields: {
                type: "list",
                member: {
                  shape: "S1n"
                }
              }
            }
          }
        },
        DescribeScalingParameters: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            resultWrapper: "DescribeScalingParametersResult",
            type: "structure",
            required: [
              "ScalingParameters"
            ],
            members: {
              ScalingParameters: {
                shape: "S2u"
              }
            }
          }
        },
        DescribeServiceAccessPolicies: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              Deployed: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeServiceAccessPoliciesResult",
            type: "structure",
            required: [
              "AccessPolicies"
            ],
            members: {
              AccessPolicies: {
                shape: "S2z"
              }
            }
          }
        },
        DescribeSuggesters: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              SuggesterNames: {
                shape: "S25"
              },
              Deployed: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeSuggestersResult",
            type: "structure",
            required: [
              "Suggesters"
            ],
            members: {
              Suggesters: {
                type: "list",
                member: {
                  shape: "S1t"
                }
              }
            }
          }
        },
        IndexDocuments: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            resultWrapper: "IndexDocumentsResult",
            type: "structure",
            members: {
              FieldNames: {
                shape: "S4"
              }
            }
          }
        },
        ListDomainNames: {
          output: {
            resultWrapper: "ListDomainNamesResult",
            type: "structure",
            members: {
              DomainNames: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        UpdateAvailabilityOptions: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "MultiAZ"
            ],
            members: {
              DomainName: {},
              MultiAZ: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "UpdateAvailabilityOptionsResult",
            type: "structure",
            members: {
              AvailabilityOptions: {
                shape: "S2a"
              }
            }
          }
        },
        UpdateDomainEndpointOptions: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "DomainEndpointOptions"
            ],
            members: {
              DomainName: {},
              DomainEndpointOptions: {
                shape: "S2f"
              }
            }
          },
          output: {
            resultWrapper: "UpdateDomainEndpointOptionsResult",
            type: "structure",
            members: {
              DomainEndpointOptions: {
                shape: "S2e"
              }
            }
          }
        },
        UpdateScalingParameters: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "ScalingParameters"
            ],
            members: {
              DomainName: {},
              ScalingParameters: {
                shape: "S2v"
              }
            }
          },
          output: {
            resultWrapper: "UpdateScalingParametersResult",
            type: "structure",
            required: [
              "ScalingParameters"
            ],
            members: {
              ScalingParameters: {
                shape: "S2u"
              }
            }
          }
        },
        UpdateServiceAccessPolicies: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "AccessPolicies"
            ],
            members: {
              DomainName: {},
              AccessPolicies: {}
            }
          },
          output: {
            resultWrapper: "UpdateServiceAccessPoliciesResult",
            type: "structure",
            required: [
              "AccessPolicies"
            ],
            members: {
              AccessPolicies: {
                shape: "S2z"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "list",
          member: {}
        },
        S8: {
          type: "structure",
          required: [
            "DomainId",
            "DomainName",
            "RequiresIndexDocuments"
          ],
          members: {
            DomainId: {},
            DomainName: {},
            ARN: {},
            Created: {
              type: "boolean"
            },
            Deleted: {
              type: "boolean"
            },
            DocService: {
              shape: "Sc"
            },
            SearchService: {
              shape: "Sc"
            },
            RequiresIndexDocuments: {
              type: "boolean"
            },
            Processing: {
              type: "boolean"
            },
            SearchInstanceType: {},
            SearchPartitionCount: {
              type: "integer"
            },
            SearchInstanceCount: {
              type: "integer"
            },
            Limits: {
              type: "structure",
              required: [
                "MaximumReplicationCount",
                "MaximumPartitionCount"
              ],
              members: {
                MaximumReplicationCount: {
                  type: "integer"
                },
                MaximumPartitionCount: {
                  type: "integer"
                }
              }
            }
          }
        },
        Sc: {
          type: "structure",
          members: {
            Endpoint: {}
          }
        },
        Sl: {
          type: "structure",
          required: [
            "AnalysisSchemeName",
            "AnalysisSchemeLanguage"
          ],
          members: {
            AnalysisSchemeName: {},
            AnalysisSchemeLanguage: {},
            AnalysisOptions: {
              type: "structure",
              members: {
                Synonyms: {},
                Stopwords: {},
                StemmingDictionary: {},
                JapaneseTokenizationDictionary: {},
                AlgorithmicStemming: {}
              }
            }
          }
        },
        Ss: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {
              shape: "Sl"
            },
            Status: {
              shape: "St"
            }
          }
        },
        St: {
          type: "structure",
          required: [
            "CreationDate",
            "UpdateDate",
            "State"
          ],
          members: {
            CreationDate: {
              type: "timestamp"
            },
            UpdateDate: {
              type: "timestamp"
            },
            UpdateVersion: {
              type: "integer"
            },
            State: {},
            PendingDeletion: {
              type: "boolean"
            }
          }
        },
        Sy: {
          type: "structure",
          required: [
            "ExpressionName",
            "ExpressionValue"
          ],
          members: {
            ExpressionName: {},
            ExpressionValue: {}
          }
        },
        S11: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {
              shape: "Sy"
            },
            Status: {
              shape: "St"
            }
          }
        },
        S13: {
          type: "structure",
          required: [
            "IndexFieldName",
            "IndexFieldType"
          ],
          members: {
            IndexFieldName: {},
            IndexFieldType: {},
            IntOptions: {
              type: "structure",
              members: {
                DefaultValue: {
                  type: "long"
                },
                SourceField: {},
                FacetEnabled: {
                  type: "boolean"
                },
                SearchEnabled: {
                  type: "boolean"
                },
                ReturnEnabled: {
                  type: "boolean"
                },
                SortEnabled: {
                  type: "boolean"
                }
              }
            },
            DoubleOptions: {
              type: "structure",
              members: {
                DefaultValue: {
                  type: "double"
                },
                SourceField: {},
                FacetEnabled: {
                  type: "boolean"
                },
                SearchEnabled: {
                  type: "boolean"
                },
                ReturnEnabled: {
                  type: "boolean"
                },
                SortEnabled: {
                  type: "boolean"
                }
              }
            },
            LiteralOptions: {
              type: "structure",
              members: {
                DefaultValue: {},
                SourceField: {},
                FacetEnabled: {
                  type: "boolean"
                },
                SearchEnabled: {
                  type: "boolean"
                },
                ReturnEnabled: {
                  type: "boolean"
                },
                SortEnabled: {
                  type: "boolean"
                }
              }
            },
            TextOptions: {
              type: "structure",
              members: {
                DefaultValue: {},
                SourceField: {},
                ReturnEnabled: {
                  type: "boolean"
                },
                SortEnabled: {
                  type: "boolean"
                },
                HighlightEnabled: {
                  type: "boolean"
                },
                AnalysisScheme: {}
              }
            },
            DateOptions: {
              type: "structure",
              members: {
                DefaultValue: {},
                SourceField: {},
                FacetEnabled: {
                  type: "boolean"
                },
                SearchEnabled: {
                  type: "boolean"
                },
                ReturnEnabled: {
                  type: "boolean"
                },
                SortEnabled: {
                  type: "boolean"
                }
              }
            },
            LatLonOptions: {
              type: "structure",
              members: {
                DefaultValue: {},
                SourceField: {},
                FacetEnabled: {
                  type: "boolean"
                },
                SearchEnabled: {
                  type: "boolean"
                },
                ReturnEnabled: {
                  type: "boolean"
                },
                SortEnabled: {
                  type: "boolean"
                }
              }
            },
            IntArrayOptions: {
              type: "structure",
              members: {
                DefaultValue: {
                  type: "long"
                },
                SourceFields: {},
                FacetEnabled: {
                  type: "boolean"
                },
                SearchEnabled: {
                  type: "boolean"
                },
                ReturnEnabled: {
                  type: "boolean"
                }
              }
            },
            DoubleArrayOptions: {
              type: "structure",
              members: {
                DefaultValue: {
                  type: "double"
                },
                SourceFields: {},
                FacetEnabled: {
                  type: "boolean"
                },
                SearchEnabled: {
                  type: "boolean"
                },
                ReturnEnabled: {
                  type: "boolean"
                }
              }
            },
            LiteralArrayOptions: {
              type: "structure",
              members: {
                DefaultValue: {},
                SourceFields: {},
                FacetEnabled: {
                  type: "boolean"
                },
                SearchEnabled: {
                  type: "boolean"
                },
                ReturnEnabled: {
                  type: "boolean"
                }
              }
            },
            TextArrayOptions: {
              type: "structure",
              members: {
                DefaultValue: {},
                SourceFields: {},
                ReturnEnabled: {
                  type: "boolean"
                },
                HighlightEnabled: {
                  type: "boolean"
                },
                AnalysisScheme: {}
              }
            },
            DateArrayOptions: {
              type: "structure",
              members: {
                DefaultValue: {},
                SourceFields: {},
                FacetEnabled: {
                  type: "boolean"
                },
                SearchEnabled: {
                  type: "boolean"
                },
                ReturnEnabled: {
                  type: "boolean"
                }
              }
            }
          }
        },
        S1n: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {
              shape: "S13"
            },
            Status: {
              shape: "St"
            }
          }
        },
        S1p: {
          type: "structure",
          required: [
            "SuggesterName",
            "DocumentSuggesterOptions"
          ],
          members: {
            SuggesterName: {},
            DocumentSuggesterOptions: {
              type: "structure",
              required: [
                "SourceField"
              ],
              members: {
                SourceField: {},
                FuzzyMatching: {},
                SortExpression: {}
              }
            }
          }
        },
        S1t: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {
              shape: "S1p"
            },
            Status: {
              shape: "St"
            }
          }
        },
        S25: {
          type: "list",
          member: {}
        },
        S2a: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {
              type: "boolean"
            },
            Status: {
              shape: "St"
            }
          }
        },
        S2e: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {
              shape: "S2f"
            },
            Status: {
              shape: "St"
            }
          }
        },
        S2f: {
          type: "structure",
          members: {
            EnforceHTTPS: {
              type: "boolean"
            },
            TLSSecurityPolicy: {}
          }
        },
        S2u: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {
              shape: "S2v"
            },
            Status: {
              shape: "St"
            }
          }
        },
        S2v: {
          type: "structure",
          members: {
            DesiredInstanceType: {},
            DesiredReplicationCount: {
              type: "integer"
            },
            DesiredPartitionCount: {
              type: "integer"
            }
          }
        },
        S2z: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {},
            Status: {
              shape: "St"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudsearch-2013-01-01.paginators.json
var require_cloudsearch_2013_01_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloudsearch-2013-01-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeAnalysisSchemes: {
          result_key: "AnalysisSchemes"
        },
        DescribeDomains: {
          result_key: "DomainStatusList"
        },
        DescribeExpressions: {
          result_key: "Expressions"
        },
        DescribeIndexFields: {
          result_key: "IndexFields"
        },
        DescribeSuggesters: {
          result_key: "Suggesters"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/cloudsearch.js
var require_cloudsearch = __commonJS({
  "node_modules/aws-sdk/clients/cloudsearch.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["cloudsearch"] = {};
    AWS2.CloudSearch = Service.defineService("cloudsearch", ["2011-02-01", "2013-01-01"]);
    Object.defineProperty(apiLoader.services["cloudsearch"], "2011-02-01", {
      get: function get() {
        var model = require_cloudsearch_2011_02_01_min();
        model.paginators = require_cloudsearch_2011_02_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(apiLoader.services["cloudsearch"], "2013-01-01", {
      get: function get() {
        var model = require_cloudsearch_2013_01_01_min();
        model.paginators = require_cloudsearch_2013_01_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CloudSearch;
  }
});

// node_modules/aws-sdk/lib/services/cloudsearchdomain.js
var require_cloudsearchdomain = __commonJS({
  "node_modules/aws-sdk/lib/services/cloudsearchdomain.js"() {
    "use strict";
    var AWS2 = require_core();
    AWS2.util.update(AWS2.CloudSearchDomain.prototype, {
      /**
       * @api private
       */
      validateService: function validateService() {
        if (!this.config.endpoint || this.config.endpoint.indexOf("{") >= 0) {
          var msg = "AWS.CloudSearchDomain requires an explicit `endpoint' configuration option.";
          throw AWS2.util.error(
            new Error(),
            { name: "InvalidEndpoint", message: msg }
          );
        }
      },
      /**
       * @api private
       */
      setupRequestListeners: function setupRequestListeners(request) {
        request.removeListener(
          "validate",
          AWS2.EventListeners.Core.VALIDATE_CREDENTIALS
        );
        request.onAsync("validate", this.validateCredentials);
        request.addListener("validate", this.updateRegion);
        if (request.operation === "search") {
          request.addListener("build", this.convertGetToPost);
        }
      },
      /**
       * @api private
       */
      validateCredentials: function(req, done) {
        if (!req.service.api.signatureVersion)
          return done();
        req.service.config.getCredentials(function(err) {
          if (err) {
            req.removeListener("sign", AWS2.EventListeners.Core.SIGN);
          }
          done();
        });
      },
      /**
       * @api private
       */
      convertGetToPost: function(request) {
        var httpRequest = request.httpRequest;
        var path = httpRequest.path.split("?");
        httpRequest.method = "POST";
        httpRequest.path = path[0];
        httpRequest.body = path[1];
        httpRequest.headers["Content-Length"] = httpRequest.body.length;
        httpRequest.headers["Content-Type"] = "application/x-www-form-urlencoded";
      },
      /**
       * @api private
       */
      updateRegion: function updateRegion(request) {
        var endpoint = request.httpRequest.endpoint.hostname;
        var zones = endpoint.split(".");
        request.httpRequest.region = zones[1] || request.httpRequest.region;
      }
    });
  }
});

// node_modules/aws-sdk/apis/cloudsearchdomain-2013-01-01.min.json
var require_cloudsearchdomain_2013_01_01_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudsearchdomain-2013-01-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2013-01-01",
        endpointPrefix: "cloudsearchdomain",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon CloudSearch Domain",
        serviceId: "CloudSearch Domain",
        signatureVersion: "v4",
        signingName: "cloudsearch",
        uid: "cloudsearchdomain-2013-01-01"
      },
      operations: {
        Search: {
          http: {
            method: "GET",
            requestUri: "/2013-01-01/search?format=sdk&pretty=true"
          },
          input: {
            type: "structure",
            required: [
              "query"
            ],
            members: {
              cursor: {
                location: "querystring",
                locationName: "cursor"
              },
              expr: {
                location: "querystring",
                locationName: "expr"
              },
              facet: {
                location: "querystring",
                locationName: "facet"
              },
              filterQuery: {
                location: "querystring",
                locationName: "fq"
              },
              highlight: {
                location: "querystring",
                locationName: "highlight"
              },
              partial: {
                location: "querystring",
                locationName: "partial",
                type: "boolean"
              },
              query: {
                location: "querystring",
                locationName: "q"
              },
              queryOptions: {
                location: "querystring",
                locationName: "q.options"
              },
              queryParser: {
                location: "querystring",
                locationName: "q.parser"
              },
              return: {
                location: "querystring",
                locationName: "return"
              },
              size: {
                location: "querystring",
                locationName: "size",
                type: "long"
              },
              sort: {
                location: "querystring",
                locationName: "sort"
              },
              start: {
                location: "querystring",
                locationName: "start",
                type: "long"
              },
              stats: {
                location: "querystring",
                locationName: "stats"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              status: {
                type: "structure",
                members: {
                  timems: {
                    type: "long"
                  },
                  rid: {}
                }
              },
              hits: {
                type: "structure",
                members: {
                  found: {
                    type: "long"
                  },
                  start: {
                    type: "long"
                  },
                  cursor: {},
                  hit: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        id: {},
                        fields: {
                          type: "map",
                          key: {},
                          value: {
                            type: "list",
                            member: {}
                          }
                        },
                        exprs: {
                          type: "map",
                          key: {},
                          value: {}
                        },
                        highlights: {
                          type: "map",
                          key: {},
                          value: {}
                        }
                      }
                    }
                  }
                }
              },
              facets: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    buckets: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          value: {},
                          count: {
                            type: "long"
                          }
                        }
                      }
                    }
                  }
                }
              },
              stats: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    min: {},
                    max: {},
                    count: {
                      type: "long"
                    },
                    missing: {
                      type: "long"
                    },
                    sum: {
                      type: "double"
                    },
                    sumOfSquares: {
                      type: "double"
                    },
                    mean: {},
                    stddev: {
                      type: "double"
                    }
                  }
                }
              }
            }
          }
        },
        Suggest: {
          http: {
            method: "GET",
            requestUri: "/2013-01-01/suggest?format=sdk&pretty=true"
          },
          input: {
            type: "structure",
            required: [
              "query",
              "suggester"
            ],
            members: {
              query: {
                location: "querystring",
                locationName: "q"
              },
              suggester: {
                location: "querystring",
                locationName: "suggester"
              },
              size: {
                location: "querystring",
                locationName: "size",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              status: {
                type: "structure",
                members: {
                  timems: {
                    type: "long"
                  },
                  rid: {}
                }
              },
              suggest: {
                type: "structure",
                members: {
                  query: {},
                  found: {
                    type: "long"
                  },
                  suggestions: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        suggestion: {},
                        score: {
                          type: "long"
                        },
                        id: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        UploadDocuments: {
          http: {
            requestUri: "/2013-01-01/documents/batch?format=sdk"
          },
          input: {
            type: "structure",
            required: [
              "documents",
              "contentType"
            ],
            members: {
              documents: {
                type: "blob",
                streaming: true
              },
              contentType: {
                location: "header",
                locationName: "Content-Type"
              }
            },
            payload: "documents"
          },
          output: {
            type: "structure",
            members: {
              status: {},
              adds: {
                type: "long"
              },
              deletes: {
                type: "long"
              },
              warnings: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    message: {}
                  }
                }
              }
            }
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/clients/cloudsearchdomain.js
var require_cloudsearchdomain2 = __commonJS({
  "node_modules/aws-sdk/clients/cloudsearchdomain.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["cloudsearchdomain"] = {};
    AWS2.CloudSearchDomain = Service.defineService("cloudsearchdomain", ["2013-01-01"]);
    require_cloudsearchdomain();
    Object.defineProperty(apiLoader.services["cloudsearchdomain"], "2013-01-01", {
      get: function get() {
        var model = require_cloudsearchdomain_2013_01_01_min();
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CloudSearchDomain;
  }
});

// node_modules/aws-sdk/apis/cloudtrail-2013-11-01.min.json
var require_cloudtrail_2013_11_01_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudtrail-2013-11-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2013-11-01",
        endpointPrefix: "cloudtrail",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "CloudTrail",
        serviceFullName: "AWS CloudTrail",
        serviceId: "CloudTrail",
        signatureVersion: "v4",
        targetPrefix: "com.amazonaws.cloudtrail.v20131101.CloudTrail_20131101",
        uid: "cloudtrail-2013-11-01"
      },
      operations: {
        AddTags: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "TagsList"
            ],
            members: {
              ResourceId: {},
              TagsList: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        CancelQuery: {
          input: {
            type: "structure",
            required: [
              "QueryId"
            ],
            members: {
              EventDataStore: {
                deprecated: true,
                deprecatedMessage: "EventDataStore is no longer required by CancelQueryRequest"
              },
              QueryId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "QueryId",
              "QueryStatus"
            ],
            members: {
              QueryId: {},
              QueryStatus: {}
            }
          },
          idempotent: true
        },
        CreateChannel: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Source",
              "Destinations"
            ],
            members: {
              Name: {},
              Source: {},
              Destinations: {
                shape: "Sg"
              },
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              Name: {},
              Source: {},
              Destinations: {
                shape: "Sg"
              },
              Tags: {
                shape: "S3"
              }
            }
          }
        },
        CreateEventDataStore: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              AdvancedEventSelectors: {
                shape: "So"
              },
              MultiRegionEnabled: {
                type: "boolean"
              },
              OrganizationEnabled: {
                type: "boolean"
              },
              RetentionPeriod: {
                type: "integer"
              },
              TerminationProtectionEnabled: {
                type: "boolean"
              },
              TagsList: {
                shape: "S3"
              },
              KmsKeyId: {},
              StartIngestion: {
                type: "boolean"
              },
              BillingMode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EventDataStoreArn: {},
              Name: {},
              Status: {},
              AdvancedEventSelectors: {
                shape: "So"
              },
              MultiRegionEnabled: {
                type: "boolean"
              },
              OrganizationEnabled: {
                type: "boolean"
              },
              RetentionPeriod: {
                type: "integer"
              },
              TerminationProtectionEnabled: {
                type: "boolean"
              },
              TagsList: {
                shape: "S3"
              },
              CreatedTimestamp: {
                type: "timestamp"
              },
              UpdatedTimestamp: {
                type: "timestamp"
              },
              KmsKeyId: {},
              BillingMode: {}
            }
          }
        },
        CreateTrail: {
          input: {
            type: "structure",
            required: [
              "Name",
              "S3BucketName"
            ],
            members: {
              Name: {},
              S3BucketName: {},
              S3KeyPrefix: {},
              SnsTopicName: {},
              IncludeGlobalServiceEvents: {
                type: "boolean"
              },
              IsMultiRegionTrail: {
                type: "boolean"
              },
              EnableLogFileValidation: {
                type: "boolean"
              },
              CloudWatchLogsLogGroupArn: {},
              CloudWatchLogsRoleArn: {},
              KmsKeyId: {},
              IsOrganizationTrail: {
                type: "boolean"
              },
              TagsList: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              S3BucketName: {},
              S3KeyPrefix: {},
              SnsTopicName: {
                deprecated: true
              },
              SnsTopicARN: {},
              IncludeGlobalServiceEvents: {
                type: "boolean"
              },
              IsMultiRegionTrail: {
                type: "boolean"
              },
              TrailARN: {},
              LogFileValidationEnabled: {
                type: "boolean"
              },
              CloudWatchLogsLogGroupArn: {},
              CloudWatchLogsRoleArn: {},
              KmsKeyId: {},
              IsOrganizationTrail: {
                type: "boolean"
              }
            }
          },
          idempotent: true
        },
        DeleteChannel: {
          input: {
            type: "structure",
            required: [
              "Channel"
            ],
            members: {
              Channel: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteEventDataStore: {
          input: {
            type: "structure",
            required: [
              "EventDataStore"
            ],
            members: {
              EventDataStore: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteTrail: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeregisterOrganizationDelegatedAdmin: {
          input: {
            type: "structure",
            required: [
              "DelegatedAdminAccountId"
            ],
            members: {
              DelegatedAdminAccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DescribeQuery: {
          input: {
            type: "structure",
            members: {
              EventDataStore: {
                deprecated: true,
                deprecatedMessage: "EventDataStore is no longer required by DescribeQueryRequest"
              },
              QueryId: {},
              QueryAlias: {}
            }
          },
          output: {
            type: "structure",
            members: {
              QueryId: {},
              QueryString: {},
              QueryStatus: {},
              QueryStatistics: {
                type: "structure",
                members: {
                  EventsMatched: {
                    type: "long"
                  },
                  EventsScanned: {
                    type: "long"
                  },
                  BytesScanned: {
                    type: "long"
                  },
                  ExecutionTimeInMillis: {
                    type: "integer"
                  },
                  CreationTime: {
                    type: "timestamp"
                  }
                }
              },
              ErrorMessage: {},
              DeliveryS3Uri: {},
              DeliveryStatus: {}
            }
          },
          idempotent: true
        },
        DescribeTrails: {
          input: {
            type: "structure",
            members: {
              trailNameList: {
                type: "list",
                member: {}
              },
              includeShadowTrails: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              trailList: {
                type: "list",
                member: {
                  shape: "S1w"
                }
              }
            }
          },
          idempotent: true
        },
        DisableFederation: {
          input: {
            type: "structure",
            required: [
              "EventDataStore"
            ],
            members: {
              EventDataStore: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EventDataStoreArn: {},
              FederationStatus: {}
            }
          }
        },
        EnableFederation: {
          input: {
            type: "structure",
            required: [
              "EventDataStore",
              "FederationRoleArn"
            ],
            members: {
              EventDataStore: {},
              FederationRoleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EventDataStoreArn: {},
              FederationStatus: {},
              FederationRoleArn: {}
            }
          }
        },
        GetChannel: {
          input: {
            type: "structure",
            required: [
              "Channel"
            ],
            members: {
              Channel: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              Name: {},
              Source: {},
              SourceConfig: {
                type: "structure",
                members: {
                  ApplyToAllRegions: {
                    type: "boolean"
                  },
                  AdvancedEventSelectors: {
                    shape: "So"
                  }
                }
              },
              Destinations: {
                shape: "Sg"
              },
              IngestionStatus: {
                type: "structure",
                members: {
                  LatestIngestionSuccessTime: {
                    type: "timestamp"
                  },
                  LatestIngestionSuccessEventID: {},
                  LatestIngestionErrorCode: {},
                  LatestIngestionAttemptTime: {
                    type: "timestamp"
                  },
                  LatestIngestionAttemptEventID: {}
                }
              }
            }
          },
          idempotent: true
        },
        GetEventDataStore: {
          input: {
            type: "structure",
            required: [
              "EventDataStore"
            ],
            members: {
              EventDataStore: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EventDataStoreArn: {},
              Name: {},
              Status: {},
              AdvancedEventSelectors: {
                shape: "So"
              },
              MultiRegionEnabled: {
                type: "boolean"
              },
              OrganizationEnabled: {
                type: "boolean"
              },
              RetentionPeriod: {
                type: "integer"
              },
              TerminationProtectionEnabled: {
                type: "boolean"
              },
              CreatedTimestamp: {
                type: "timestamp"
              },
              UpdatedTimestamp: {
                type: "timestamp"
              },
              KmsKeyId: {},
              BillingMode: {},
              FederationStatus: {},
              FederationRoleArn: {}
            }
          },
          idempotent: true
        },
        GetEventSelectors: {
          input: {
            type: "structure",
            required: [
              "TrailName"
            ],
            members: {
              TrailName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrailARN: {},
              EventSelectors: {
                shape: "S2b"
              },
              AdvancedEventSelectors: {
                shape: "So"
              }
            }
          },
          idempotent: true
        },
        GetImport: {
          input: {
            type: "structure",
            required: [
              "ImportId"
            ],
            members: {
              ImportId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ImportId: {},
              Destinations: {
                shape: "S2k"
              },
              ImportSource: {
                shape: "S2l"
              },
              StartEventTime: {
                type: "timestamp"
              },
              EndEventTime: {
                type: "timestamp"
              },
              ImportStatus: {},
              CreatedTimestamp: {
                type: "timestamp"
              },
              UpdatedTimestamp: {
                type: "timestamp"
              },
              ImportStatistics: {
                shape: "S2o"
              }
            }
          }
        },
        GetInsightSelectors: {
          input: {
            type: "structure",
            members: {
              TrailName: {},
              EventDataStore: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrailARN: {},
              InsightSelectors: {
                shape: "S2r"
              },
              EventDataStoreArn: {},
              InsightsDestination: {}
            }
          },
          idempotent: true
        },
        GetQueryResults: {
          input: {
            type: "structure",
            required: [
              "QueryId"
            ],
            members: {
              EventDataStore: {
                deprecated: true,
                deprecatedMessage: "EventDataStore is no longer required by GetQueryResultsRequest"
              },
              QueryId: {},
              NextToken: {},
              MaxQueryResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              QueryStatus: {},
              QueryStatistics: {
                type: "structure",
                members: {
                  ResultsCount: {
                    type: "integer"
                  },
                  TotalResultsCount: {
                    type: "integer"
                  },
                  BytesScanned: {
                    type: "long"
                  }
                }
              },
              QueryResultRows: {
                type: "list",
                member: {
                  type: "list",
                  member: {
                    type: "map",
                    key: {},
                    value: {}
                  }
                }
              },
              NextToken: {},
              ErrorMessage: {}
            }
          }
        },
        GetResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceArn: {},
              ResourcePolicy: {}
            }
          },
          idempotent: true
        },
        GetTrail: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Trail: {
                shape: "S1w"
              }
            }
          },
          idempotent: true
        },
        GetTrailStatus: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IsLogging: {
                type: "boolean"
              },
              LatestDeliveryError: {},
              LatestNotificationError: {},
              LatestDeliveryTime: {
                type: "timestamp"
              },
              LatestNotificationTime: {
                type: "timestamp"
              },
              StartLoggingTime: {
                type: "timestamp"
              },
              StopLoggingTime: {
                type: "timestamp"
              },
              LatestCloudWatchLogsDeliveryError: {},
              LatestCloudWatchLogsDeliveryTime: {
                type: "timestamp"
              },
              LatestDigestDeliveryTime: {
                type: "timestamp"
              },
              LatestDigestDeliveryError: {},
              LatestDeliveryAttemptTime: {},
              LatestNotificationAttemptTime: {},
              LatestNotificationAttemptSucceeded: {},
              LatestDeliveryAttemptSucceeded: {},
              TimeLoggingStarted: {},
              TimeLoggingStopped: {}
            }
          },
          idempotent: true
        },
        ListChannels: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Channels: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ChannelArn: {},
                    Name: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListEventDataStores: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventDataStores: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EventDataStoreArn: {},
                    Name: {},
                    TerminationProtectionEnabled: {
                      deprecated: true,
                      deprecatedMessage: "TerminationProtectionEnabled is no longer returned by ListEventDataStores",
                      type: "boolean"
                    },
                    Status: {
                      deprecated: true,
                      deprecatedMessage: "Status is no longer returned by ListEventDataStores"
                    },
                    AdvancedEventSelectors: {
                      shape: "So",
                      deprecated: true,
                      deprecatedMessage: "AdvancedEventSelectors is no longer returned by ListEventDataStores"
                    },
                    MultiRegionEnabled: {
                      deprecated: true,
                      deprecatedMessage: "MultiRegionEnabled is no longer returned by ListEventDataStores",
                      type: "boolean"
                    },
                    OrganizationEnabled: {
                      deprecated: true,
                      deprecatedMessage: "OrganizationEnabled is no longer returned by ListEventDataStores",
                      type: "boolean"
                    },
                    RetentionPeriod: {
                      deprecated: true,
                      deprecatedMessage: "RetentionPeriod is no longer returned by ListEventDataStores",
                      type: "integer"
                    },
                    CreatedTimestamp: {
                      deprecated: true,
                      deprecatedMessage: "CreatedTimestamp is no longer returned by ListEventDataStores",
                      type: "timestamp"
                    },
                    UpdatedTimestamp: {
                      deprecated: true,
                      deprecatedMessage: "UpdatedTimestamp is no longer returned by ListEventDataStores",
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListImportFailures: {
          input: {
            type: "structure",
            required: [
              "ImportId"
            ],
            members: {
              ImportId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Failures: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Location: {},
                    Status: {},
                    ErrorType: {},
                    ErrorMessage: {},
                    LastUpdatedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListImports: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              Destination: {},
              ImportStatus: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Imports: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ImportId: {},
                    ImportStatus: {},
                    Destinations: {
                      shape: "S2k"
                    },
                    CreatedTimestamp: {
                      type: "timestamp"
                    },
                    UpdatedTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListPublicKeys: {
          input: {
            type: "structure",
            members: {
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKeyList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Value: {
                      type: "blob"
                    },
                    ValidityStartTime: {
                      type: "timestamp"
                    },
                    ValidityEndTime: {
                      type: "timestamp"
                    },
                    Fingerprint: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListQueries: {
          input: {
            type: "structure",
            required: [
              "EventDataStore"
            ],
            members: {
              EventDataStore: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              QueryStatus: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Queries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    QueryId: {},
                    QueryStatus: {},
                    CreationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListTags: {
          input: {
            type: "structure",
            required: [
              "ResourceIdList"
            ],
            members: {
              ResourceIdList: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceTagList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceId: {},
                    TagsList: {
                      shape: "S3"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListTrails: {
          input: {
            type: "structure",
            members: {
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Trails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TrailARN: {},
                    Name: {},
                    HomeRegion: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        LookupEvents: {
          input: {
            type: "structure",
            members: {
              LookupAttributes: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AttributeKey",
                    "AttributeValue"
                  ],
                  members: {
                    AttributeKey: {},
                    AttributeValue: {}
                  }
                }
              },
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              EventCategory: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Events: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EventId: {},
                    EventName: {},
                    ReadOnly: {},
                    AccessKeyId: {},
                    EventTime: {
                      type: "timestamp"
                    },
                    EventSource: {},
                    Username: {},
                    Resources: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ResourceType: {},
                          ResourceName: {}
                        }
                      }
                    },
                    CloudTrailEvent: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        PutEventSelectors: {
          input: {
            type: "structure",
            required: [
              "TrailName"
            ],
            members: {
              TrailName: {},
              EventSelectors: {
                shape: "S2b"
              },
              AdvancedEventSelectors: {
                shape: "So"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrailARN: {},
              EventSelectors: {
                shape: "S2b"
              },
              AdvancedEventSelectors: {
                shape: "So"
              }
            }
          },
          idempotent: true
        },
        PutInsightSelectors: {
          input: {
            type: "structure",
            required: [
              "InsightSelectors"
            ],
            members: {
              TrailName: {},
              InsightSelectors: {
                shape: "S2r"
              },
              EventDataStore: {},
              InsightsDestination: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrailARN: {},
              InsightSelectors: {
                shape: "S2r"
              },
              EventDataStoreArn: {},
              InsightsDestination: {}
            }
          },
          idempotent: true
        },
        PutResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "ResourcePolicy"
            ],
            members: {
              ResourceArn: {},
              ResourcePolicy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceArn: {},
              ResourcePolicy: {}
            }
          },
          idempotent: true
        },
        RegisterOrganizationDelegatedAdmin: {
          input: {
            type: "structure",
            required: [
              "MemberAccountId"
            ],
            members: {
              MemberAccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        RemoveTags: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "TagsList"
            ],
            members: {
              ResourceId: {},
              TagsList: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        RestoreEventDataStore: {
          input: {
            type: "structure",
            required: [
              "EventDataStore"
            ],
            members: {
              EventDataStore: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EventDataStoreArn: {},
              Name: {},
              Status: {},
              AdvancedEventSelectors: {
                shape: "So"
              },
              MultiRegionEnabled: {
                type: "boolean"
              },
              OrganizationEnabled: {
                type: "boolean"
              },
              RetentionPeriod: {
                type: "integer"
              },
              TerminationProtectionEnabled: {
                type: "boolean"
              },
              CreatedTimestamp: {
                type: "timestamp"
              },
              UpdatedTimestamp: {
                type: "timestamp"
              },
              KmsKeyId: {},
              BillingMode: {}
            }
          }
        },
        StartEventDataStoreIngestion: {
          input: {
            type: "structure",
            required: [
              "EventDataStore"
            ],
            members: {
              EventDataStore: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartImport: {
          input: {
            type: "structure",
            members: {
              Destinations: {
                shape: "S2k"
              },
              ImportSource: {
                shape: "S2l"
              },
              StartEventTime: {
                type: "timestamp"
              },
              EndEventTime: {
                type: "timestamp"
              },
              ImportId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ImportId: {},
              Destinations: {
                shape: "S2k"
              },
              ImportSource: {
                shape: "S2l"
              },
              StartEventTime: {
                type: "timestamp"
              },
              EndEventTime: {
                type: "timestamp"
              },
              ImportStatus: {},
              CreatedTimestamp: {
                type: "timestamp"
              },
              UpdatedTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        StartLogging: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        StartQuery: {
          input: {
            type: "structure",
            members: {
              QueryStatement: {},
              DeliveryS3Uri: {},
              QueryAlias: {},
              QueryParameters: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              QueryId: {}
            }
          },
          idempotent: true
        },
        StopEventDataStoreIngestion: {
          input: {
            type: "structure",
            required: [
              "EventDataStore"
            ],
            members: {
              EventDataStore: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StopImport: {
          input: {
            type: "structure",
            required: [
              "ImportId"
            ],
            members: {
              ImportId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ImportId: {},
              ImportSource: {
                shape: "S2l"
              },
              Destinations: {
                shape: "S2k"
              },
              ImportStatus: {},
              CreatedTimestamp: {
                type: "timestamp"
              },
              UpdatedTimestamp: {
                type: "timestamp"
              },
              StartEventTime: {
                type: "timestamp"
              },
              EndEventTime: {
                type: "timestamp"
              },
              ImportStatistics: {
                shape: "S2o"
              }
            }
          }
        },
        StopLogging: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateChannel: {
          input: {
            type: "structure",
            required: [
              "Channel"
            ],
            members: {
              Channel: {},
              Destinations: {
                shape: "Sg"
              },
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              Name: {},
              Source: {},
              Destinations: {
                shape: "Sg"
              }
            }
          },
          idempotent: true
        },
        UpdateEventDataStore: {
          input: {
            type: "structure",
            required: [
              "EventDataStore"
            ],
            members: {
              EventDataStore: {},
              Name: {},
              AdvancedEventSelectors: {
                shape: "So"
              },
              MultiRegionEnabled: {
                type: "boolean"
              },
              OrganizationEnabled: {
                type: "boolean"
              },
              RetentionPeriod: {
                type: "integer"
              },
              TerminationProtectionEnabled: {
                type: "boolean"
              },
              KmsKeyId: {},
              BillingMode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EventDataStoreArn: {},
              Name: {},
              Status: {},
              AdvancedEventSelectors: {
                shape: "So"
              },
              MultiRegionEnabled: {
                type: "boolean"
              },
              OrganizationEnabled: {
                type: "boolean"
              },
              RetentionPeriod: {
                type: "integer"
              },
              TerminationProtectionEnabled: {
                type: "boolean"
              },
              CreatedTimestamp: {
                type: "timestamp"
              },
              UpdatedTimestamp: {
                type: "timestamp"
              },
              KmsKeyId: {},
              BillingMode: {},
              FederationStatus: {},
              FederationRoleArn: {}
            }
          },
          idempotent: true
        },
        UpdateTrail: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              S3BucketName: {},
              S3KeyPrefix: {},
              SnsTopicName: {},
              IncludeGlobalServiceEvents: {
                type: "boolean"
              },
              IsMultiRegionTrail: {
                type: "boolean"
              },
              EnableLogFileValidation: {
                type: "boolean"
              },
              CloudWatchLogsLogGroupArn: {},
              CloudWatchLogsRoleArn: {},
              KmsKeyId: {},
              IsOrganizationTrail: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              S3BucketName: {},
              S3KeyPrefix: {},
              SnsTopicName: {
                deprecated: true
              },
              SnsTopicARN: {},
              IncludeGlobalServiceEvents: {
                type: "boolean"
              },
              IsMultiRegionTrail: {
                type: "boolean"
              },
              TrailARN: {},
              LogFileValidationEnabled: {
                type: "boolean"
              },
              CloudWatchLogsLogGroupArn: {},
              CloudWatchLogsRoleArn: {},
              KmsKeyId: {},
              IsOrganizationTrail: {
                type: "boolean"
              }
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sg: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Type",
              "Location"
            ],
            members: {
              Type: {},
              Location: {}
            }
          }
        },
        So: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "FieldSelectors"
            ],
            members: {
              Name: {},
              FieldSelectors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Field"
                  ],
                  members: {
                    Field: {},
                    Equals: {
                      shape: "Su"
                    },
                    StartsWith: {
                      shape: "Su"
                    },
                    EndsWith: {
                      shape: "Su"
                    },
                    NotEquals: {
                      shape: "Su"
                    },
                    NotStartsWith: {
                      shape: "Su"
                    },
                    NotEndsWith: {
                      shape: "Su"
                    }
                  }
                }
              }
            }
          }
        },
        Su: {
          type: "list",
          member: {}
        },
        S1w: {
          type: "structure",
          members: {
            Name: {},
            S3BucketName: {},
            S3KeyPrefix: {},
            SnsTopicName: {
              deprecated: true
            },
            SnsTopicARN: {},
            IncludeGlobalServiceEvents: {
              type: "boolean"
            },
            IsMultiRegionTrail: {
              type: "boolean"
            },
            HomeRegion: {},
            TrailARN: {},
            LogFileValidationEnabled: {
              type: "boolean"
            },
            CloudWatchLogsLogGroupArn: {},
            CloudWatchLogsRoleArn: {},
            KmsKeyId: {},
            HasCustomEventSelectors: {
              type: "boolean"
            },
            HasInsightSelectors: {
              type: "boolean"
            },
            IsOrganizationTrail: {
              type: "boolean"
            }
          }
        },
        S2b: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ReadWriteType: {},
              IncludeManagementEvents: {
                type: "boolean"
              },
              DataResources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              ExcludeManagementEventSources: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S2k: {
          type: "list",
          member: {}
        },
        S2l: {
          type: "structure",
          required: [
            "S3"
          ],
          members: {
            S3: {
              type: "structure",
              required: [
                "S3LocationUri",
                "S3BucketRegion",
                "S3BucketAccessRoleArn"
              ],
              members: {
                S3LocationUri: {},
                S3BucketRegion: {},
                S3BucketAccessRoleArn: {}
              }
            }
          }
        },
        S2o: {
          type: "structure",
          members: {
            PrefixesFound: {
              type: "long"
            },
            PrefixesCompleted: {
              type: "long"
            },
            FilesCompleted: {
              type: "long"
            },
            EventsCompleted: {
              type: "long"
            },
            FailedEntries: {
              type: "long"
            }
          }
        },
        S2r: {
          type: "list",
          member: {
            type: "structure",
            members: {
              InsightType: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudtrail-2013-11-01.paginators.json
var require_cloudtrail_2013_11_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloudtrail-2013-11-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeTrails: {
          result_key: "trailList"
        },
        GetQueryResults: {
          input_token: "NextToken",
          output_token: "NextToken"
        },
        ListChannels: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListEventDataStores: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListImportFailures: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Failures"
        },
        ListImports: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Imports"
        },
        ListPublicKeys: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "PublicKeyList"
        },
        ListQueries: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListTags: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "ResourceTagList"
        },
        ListTrails: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Trails"
        },
        LookupEvents: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Events"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/cloudtrail.js
var require_cloudtrail = __commonJS({
  "node_modules/aws-sdk/clients/cloudtrail.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["cloudtrail"] = {};
    AWS2.CloudTrail = Service.defineService("cloudtrail", ["2013-11-01"]);
    Object.defineProperty(apiLoader.services["cloudtrail"], "2013-11-01", {
      get: function get() {
        var model = require_cloudtrail_2013_11_01_min();
        model.paginators = require_cloudtrail_2013_11_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CloudTrail;
  }
});

// node_modules/aws-sdk/apis/monitoring-2010-08-01.min.json
var require_monitoring_2010_08_01_min = __commonJS({
  "node_modules/aws-sdk/apis/monitoring-2010-08-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2010-08-01",
        endpointPrefix: "monitoring",
        protocol: "query",
        serviceAbbreviation: "CloudWatch",
        serviceFullName: "Amazon CloudWatch",
        serviceId: "CloudWatch",
        signatureVersion: "v4",
        uid: "monitoring-2010-08-01",
        xmlNamespace: "http://monitoring.amazonaws.com/doc/2010-08-01/"
      },
      operations: {
        DeleteAlarms: {
          input: {
            type: "structure",
            required: [
              "AlarmNames"
            ],
            members: {
              AlarmNames: {
                shape: "S2"
              }
            }
          }
        },
        DeleteAnomalyDetector: {
          input: {
            type: "structure",
            members: {
              Namespace: {
                deprecated: true,
                deprecatedMessage: "Use SingleMetricAnomalyDetector."
              },
              MetricName: {
                deprecated: true,
                deprecatedMessage: "Use SingleMetricAnomalyDetector."
              },
              Dimensions: {
                shape: "S7",
                deprecated: true,
                deprecatedMessage: "Use SingleMetricAnomalyDetector."
              },
              Stat: {
                deprecated: true,
                deprecatedMessage: "Use SingleMetricAnomalyDetector."
              },
              SingleMetricAnomalyDetector: {
                shape: "Sc"
              },
              MetricMathAnomalyDetector: {
                shape: "Sd"
              }
            }
          },
          output: {
            resultWrapper: "DeleteAnomalyDetectorResult",
            type: "structure",
            members: {}
          }
        },
        DeleteDashboards: {
          input: {
            type: "structure",
            required: [
              "DashboardNames"
            ],
            members: {
              DashboardNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "DeleteDashboardsResult",
            type: "structure",
            members: {}
          }
        },
        DeleteInsightRules: {
          input: {
            type: "structure",
            required: [
              "RuleNames"
            ],
            members: {
              RuleNames: {
                shape: "Sw"
              }
            }
          },
          output: {
            resultWrapper: "DeleteInsightRulesResult",
            type: "structure",
            members: {
              Failures: {
                shape: "Sz"
              }
            }
          }
        },
        DeleteMetricStream: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            resultWrapper: "DeleteMetricStreamResult",
            type: "structure",
            members: {}
          }
        },
        DescribeAlarmHistory: {
          input: {
            type: "structure",
            members: {
              AlarmName: {},
              AlarmTypes: {
                shape: "S19"
              },
              HistoryItemType: {},
              StartDate: {
                type: "timestamp"
              },
              EndDate: {
                type: "timestamp"
              },
              MaxRecords: {
                type: "integer"
              },
              NextToken: {},
              ScanBy: {}
            }
          },
          output: {
            resultWrapper: "DescribeAlarmHistoryResult",
            type: "structure",
            members: {
              AlarmHistoryItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AlarmName: {},
                    AlarmType: {},
                    Timestamp: {
                      type: "timestamp"
                    },
                    HistoryItemType: {},
                    HistorySummary: {},
                    HistoryData: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeAlarms: {
          input: {
            type: "structure",
            members: {
              AlarmNames: {
                shape: "S2"
              },
              AlarmNamePrefix: {},
              AlarmTypes: {
                shape: "S19"
              },
              ChildrenOfAlarmName: {},
              ParentsOfAlarmName: {},
              StateValue: {},
              ActionPrefix: {},
              MaxRecords: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "DescribeAlarmsResult",
            type: "structure",
            members: {
              CompositeAlarms: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ActionsEnabled: {
                      type: "boolean"
                    },
                    AlarmActions: {
                      shape: "S1t"
                    },
                    AlarmArn: {},
                    AlarmConfigurationUpdatedTimestamp: {
                      type: "timestamp"
                    },
                    AlarmDescription: {},
                    AlarmName: {},
                    AlarmRule: {},
                    InsufficientDataActions: {
                      shape: "S1t"
                    },
                    OKActions: {
                      shape: "S1t"
                    },
                    StateReason: {},
                    StateReasonData: {},
                    StateUpdatedTimestamp: {
                      type: "timestamp"
                    },
                    StateValue: {},
                    StateTransitionedTimestamp: {
                      type: "timestamp"
                    },
                    ActionsSuppressedBy: {},
                    ActionsSuppressedReason: {},
                    ActionsSuppressor: {},
                    ActionsSuppressorWaitPeriod: {
                      type: "integer"
                    },
                    ActionsSuppressorExtensionPeriod: {
                      type: "integer"
                    }
                  },
                  xmlOrder: [
                    "ActionsEnabled",
                    "AlarmActions",
                    "AlarmArn",
                    "AlarmConfigurationUpdatedTimestamp",
                    "AlarmDescription",
                    "AlarmName",
                    "AlarmRule",
                    "InsufficientDataActions",
                    "OKActions",
                    "StateReason",
                    "StateReasonData",
                    "StateUpdatedTimestamp",
                    "StateValue",
                    "StateTransitionedTimestamp",
                    "ActionsSuppressedBy",
                    "ActionsSuppressedReason",
                    "ActionsSuppressor",
                    "ActionsSuppressorWaitPeriod",
                    "ActionsSuppressorExtensionPeriod"
                  ]
                }
              },
              MetricAlarms: {
                shape: "S23"
              },
              NextToken: {}
            }
          }
        },
        DescribeAlarmsForMetric: {
          input: {
            type: "structure",
            required: [
              "MetricName",
              "Namespace"
            ],
            members: {
              MetricName: {},
              Namespace: {},
              Statistic: {},
              ExtendedStatistic: {},
              Dimensions: {
                shape: "S7"
              },
              Period: {
                type: "integer"
              },
              Unit: {}
            }
          },
          output: {
            resultWrapper: "DescribeAlarmsForMetricResult",
            type: "structure",
            members: {
              MetricAlarms: {
                shape: "S23"
              }
            }
          }
        },
        DescribeAnomalyDetectors: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Namespace: {},
              MetricName: {},
              Dimensions: {
                shape: "S7"
              },
              AnomalyDetectorTypes: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "DescribeAnomalyDetectorsResult",
            type: "structure",
            members: {
              AnomalyDetectors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Namespace: {
                      deprecated: true,
                      deprecatedMessage: "Use SingleMetricAnomalyDetector.Namespace property."
                    },
                    MetricName: {
                      deprecated: true,
                      deprecatedMessage: "Use SingleMetricAnomalyDetector.MetricName property."
                    },
                    Dimensions: {
                      shape: "S7",
                      deprecated: true,
                      deprecatedMessage: "Use SingleMetricAnomalyDetector.Dimensions property."
                    },
                    Stat: {
                      deprecated: true,
                      deprecatedMessage: "Use SingleMetricAnomalyDetector.Stat property."
                    },
                    Configuration: {
                      shape: "S2n"
                    },
                    StateValue: {},
                    SingleMetricAnomalyDetector: {
                      shape: "Sc"
                    },
                    MetricMathAnomalyDetector: {
                      shape: "Sd"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeInsightRules: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeInsightRulesResult",
            type: "structure",
            members: {
              NextToken: {},
              InsightRules: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "State",
                    "Schema",
                    "Definition"
                  ],
                  members: {
                    Name: {},
                    State: {},
                    Schema: {},
                    Definition: {},
                    ManagedRule: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        DisableAlarmActions: {
          input: {
            type: "structure",
            required: [
              "AlarmNames"
            ],
            members: {
              AlarmNames: {
                shape: "S2"
              }
            }
          }
        },
        DisableInsightRules: {
          input: {
            type: "structure",
            required: [
              "RuleNames"
            ],
            members: {
              RuleNames: {
                shape: "Sw"
              }
            }
          },
          output: {
            resultWrapper: "DisableInsightRulesResult",
            type: "structure",
            members: {
              Failures: {
                shape: "Sz"
              }
            }
          }
        },
        EnableAlarmActions: {
          input: {
            type: "structure",
            required: [
              "AlarmNames"
            ],
            members: {
              AlarmNames: {
                shape: "S2"
              }
            }
          }
        },
        EnableInsightRules: {
          input: {
            type: "structure",
            required: [
              "RuleNames"
            ],
            members: {
              RuleNames: {
                shape: "Sw"
              }
            }
          },
          output: {
            resultWrapper: "EnableInsightRulesResult",
            type: "structure",
            members: {
              Failures: {
                shape: "Sz"
              }
            }
          }
        },
        GetDashboard: {
          input: {
            type: "structure",
            required: [
              "DashboardName"
            ],
            members: {
              DashboardName: {}
            }
          },
          output: {
            resultWrapper: "GetDashboardResult",
            type: "structure",
            members: {
              DashboardArn: {},
              DashboardBody: {},
              DashboardName: {}
            }
          }
        },
        GetInsightRuleReport: {
          input: {
            type: "structure",
            required: [
              "RuleName",
              "StartTime",
              "EndTime",
              "Period"
            ],
            members: {
              RuleName: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Period: {
                type: "integer"
              },
              MaxContributorCount: {
                type: "integer"
              },
              Metrics: {
                type: "list",
                member: {}
              },
              OrderBy: {}
            }
          },
          output: {
            resultWrapper: "GetInsightRuleReportResult",
            type: "structure",
            members: {
              KeyLabels: {
                type: "list",
                member: {}
              },
              AggregationStatistic: {},
              AggregateValue: {
                type: "double"
              },
              ApproximateUniqueCount: {
                type: "long"
              },
              Contributors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Keys",
                    "ApproximateAggregateValue",
                    "Datapoints"
                  ],
                  members: {
                    Keys: {
                      type: "list",
                      member: {}
                    },
                    ApproximateAggregateValue: {
                      type: "double"
                    },
                    Datapoints: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "Timestamp",
                          "ApproximateValue"
                        ],
                        members: {
                          Timestamp: {
                            type: "timestamp"
                          },
                          ApproximateValue: {
                            type: "double"
                          }
                        }
                      }
                    }
                  }
                }
              },
              MetricDatapoints: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Timestamp"
                  ],
                  members: {
                    Timestamp: {
                      type: "timestamp"
                    },
                    UniqueContributors: {
                      type: "double"
                    },
                    MaxContributorValue: {
                      type: "double"
                    },
                    SampleCount: {
                      type: "double"
                    },
                    Average: {
                      type: "double"
                    },
                    Sum: {
                      type: "double"
                    },
                    Minimum: {
                      type: "double"
                    },
                    Maximum: {
                      type: "double"
                    }
                  }
                }
              }
            }
          }
        },
        GetMetricData: {
          input: {
            type: "structure",
            required: [
              "MetricDataQueries",
              "StartTime",
              "EndTime"
            ],
            members: {
              MetricDataQueries: {
                shape: "Se"
              },
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              NextToken: {},
              ScanBy: {},
              MaxDatapoints: {
                type: "integer"
              },
              LabelOptions: {
                type: "structure",
                members: {
                  Timezone: {}
                }
              }
            }
          },
          output: {
            resultWrapper: "GetMetricDataResult",
            type: "structure",
            members: {
              MetricDataResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Label: {},
                    Timestamps: {
                      type: "list",
                      member: {
                        type: "timestamp"
                      }
                    },
                    Values: {
                      type: "list",
                      member: {
                        type: "double"
                      }
                    },
                    StatusCode: {},
                    Messages: {
                      shape: "S45"
                    }
                  }
                }
              },
              NextToken: {},
              Messages: {
                shape: "S45"
              }
            }
          }
        },
        GetMetricStatistics: {
          input: {
            type: "structure",
            required: [
              "Namespace",
              "MetricName",
              "StartTime",
              "EndTime",
              "Period"
            ],
            members: {
              Namespace: {},
              MetricName: {},
              Dimensions: {
                shape: "S7"
              },
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Period: {
                type: "integer"
              },
              Statistics: {
                type: "list",
                member: {}
              },
              ExtendedStatistics: {
                type: "list",
                member: {}
              },
              Unit: {}
            }
          },
          output: {
            resultWrapper: "GetMetricStatisticsResult",
            type: "structure",
            members: {
              Label: {},
              Datapoints: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Timestamp: {
                      type: "timestamp"
                    },
                    SampleCount: {
                      type: "double"
                    },
                    Average: {
                      type: "double"
                    },
                    Sum: {
                      type: "double"
                    },
                    Minimum: {
                      type: "double"
                    },
                    Maximum: {
                      type: "double"
                    },
                    Unit: {},
                    ExtendedStatistics: {
                      type: "map",
                      key: {},
                      value: {
                        type: "double"
                      }
                    }
                  },
                  xmlOrder: [
                    "Timestamp",
                    "SampleCount",
                    "Average",
                    "Sum",
                    "Minimum",
                    "Maximum",
                    "Unit",
                    "ExtendedStatistics"
                  ]
                }
              }
            }
          }
        },
        GetMetricStream: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            resultWrapper: "GetMetricStreamResult",
            type: "structure",
            members: {
              Arn: {},
              Name: {},
              IncludeFilters: {
                shape: "S4j"
              },
              ExcludeFilters: {
                shape: "S4j"
              },
              FirehoseArn: {},
              RoleArn: {},
              State: {},
              CreationDate: {
                type: "timestamp"
              },
              LastUpdateDate: {
                type: "timestamp"
              },
              OutputFormat: {},
              StatisticsConfigurations: {
                shape: "S4o"
              },
              IncludeLinkedAccountsMetrics: {
                type: "boolean"
              }
            }
          }
        },
        GetMetricWidgetImage: {
          input: {
            type: "structure",
            required: [
              "MetricWidget"
            ],
            members: {
              MetricWidget: {},
              OutputFormat: {}
            }
          },
          output: {
            resultWrapper: "GetMetricWidgetImageResult",
            type: "structure",
            members: {
              MetricWidgetImage: {
                type: "blob"
              }
            }
          }
        },
        ListDashboards: {
          input: {
            type: "structure",
            members: {
              DashboardNamePrefix: {},
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListDashboardsResult",
            type: "structure",
            members: {
              DashboardEntries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DashboardName: {},
                    DashboardArn: {},
                    LastModified: {
                      type: "timestamp"
                    },
                    Size: {
                      type: "long"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListManagedInsightRules: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListManagedInsightRulesResult",
            type: "structure",
            members: {
              ManagedRules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TemplateName: {},
                    ResourceARN: {},
                    RuleState: {
                      type: "structure",
                      required: [
                        "RuleName",
                        "State"
                      ],
                      members: {
                        RuleName: {},
                        State: {}
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListMetricStreams: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListMetricStreamsResult",
            type: "structure",
            members: {
              NextToken: {},
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    CreationDate: {
                      type: "timestamp"
                    },
                    LastUpdateDate: {
                      type: "timestamp"
                    },
                    Name: {},
                    FirehoseArn: {},
                    State: {},
                    OutputFormat: {}
                  }
                }
              }
            }
          }
        },
        ListMetrics: {
          input: {
            type: "structure",
            members: {
              Namespace: {},
              MetricName: {},
              Dimensions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name"
                  ],
                  members: {
                    Name: {},
                    Value: {}
                  }
                }
              },
              NextToken: {},
              RecentlyActive: {},
              IncludeLinkedAccounts: {
                type: "boolean"
              },
              OwningAccount: {}
            }
          },
          output: {
            resultWrapper: "ListMetricsResult",
            type: "structure",
            members: {
              Metrics: {
                type: "list",
                member: {
                  shape: "Si"
                }
              },
              NextToken: {},
              OwningAccounts: {
                type: "list",
                member: {}
              }
            },
            xmlOrder: [
              "Metrics",
              "NextToken",
              "OwningAccounts"
            ]
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            resultWrapper: "ListTagsForResourceResult",
            type: "structure",
            members: {
              Tags: {
                shape: "S5s"
              }
            }
          }
        },
        PutAnomalyDetector: {
          input: {
            type: "structure",
            members: {
              Namespace: {
                deprecated: true,
                deprecatedMessage: "Use SingleMetricAnomalyDetector."
              },
              MetricName: {
                deprecated: true,
                deprecatedMessage: "Use SingleMetricAnomalyDetector."
              },
              Dimensions: {
                shape: "S7",
                deprecated: true,
                deprecatedMessage: "Use SingleMetricAnomalyDetector."
              },
              Stat: {
                deprecated: true,
                deprecatedMessage: "Use SingleMetricAnomalyDetector."
              },
              Configuration: {
                shape: "S2n"
              },
              SingleMetricAnomalyDetector: {
                shape: "Sc"
              },
              MetricMathAnomalyDetector: {
                shape: "Sd"
              }
            }
          },
          output: {
            resultWrapper: "PutAnomalyDetectorResult",
            type: "structure",
            members: {}
          }
        },
        PutCompositeAlarm: {
          input: {
            type: "structure",
            required: [
              "AlarmName",
              "AlarmRule"
            ],
            members: {
              ActionsEnabled: {
                type: "boolean"
              },
              AlarmActions: {
                shape: "S1t"
              },
              AlarmDescription: {},
              AlarmName: {},
              AlarmRule: {},
              InsufficientDataActions: {
                shape: "S1t"
              },
              OKActions: {
                shape: "S1t"
              },
              Tags: {
                shape: "S5s"
              },
              ActionsSuppressor: {},
              ActionsSuppressorWaitPeriod: {
                type: "integer"
              },
              ActionsSuppressorExtensionPeriod: {
                type: "integer"
              }
            }
          }
        },
        PutDashboard: {
          input: {
            type: "structure",
            required: [
              "DashboardName",
              "DashboardBody"
            ],
            members: {
              DashboardName: {},
              DashboardBody: {}
            }
          },
          output: {
            resultWrapper: "PutDashboardResult",
            type: "structure",
            members: {
              DashboardValidationMessages: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DataPath: {},
                    Message: {}
                  }
                }
              }
            }
          }
        },
        PutInsightRule: {
          input: {
            type: "structure",
            required: [
              "RuleName",
              "RuleDefinition"
            ],
            members: {
              RuleName: {},
              RuleState: {},
              RuleDefinition: {},
              Tags: {
                shape: "S5s"
              }
            }
          },
          output: {
            resultWrapper: "PutInsightRuleResult",
            type: "structure",
            members: {}
          }
        },
        PutManagedInsightRules: {
          input: {
            type: "structure",
            required: [
              "ManagedRules"
            ],
            members: {
              ManagedRules: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "TemplateName",
                    "ResourceARN"
                  ],
                  members: {
                    TemplateName: {},
                    ResourceARN: {},
                    Tags: {
                      shape: "S5s"
                    }
                  }
                }
              }
            }
          },
          output: {
            resultWrapper: "PutManagedInsightRulesResult",
            type: "structure",
            members: {
              Failures: {
                shape: "Sz"
              }
            }
          }
        },
        PutMetricAlarm: {
          input: {
            type: "structure",
            required: [
              "AlarmName",
              "EvaluationPeriods",
              "ComparisonOperator"
            ],
            members: {
              AlarmName: {},
              AlarmDescription: {},
              ActionsEnabled: {
                type: "boolean"
              },
              OKActions: {
                shape: "S1t"
              },
              AlarmActions: {
                shape: "S1t"
              },
              InsufficientDataActions: {
                shape: "S1t"
              },
              MetricName: {},
              Namespace: {},
              Statistic: {},
              ExtendedStatistic: {},
              Dimensions: {
                shape: "S7"
              },
              Period: {
                type: "integer"
              },
              Unit: {},
              EvaluationPeriods: {
                type: "integer"
              },
              DatapointsToAlarm: {
                type: "integer"
              },
              Threshold: {
                type: "double"
              },
              ComparisonOperator: {},
              TreatMissingData: {},
              EvaluateLowSampleCountPercentile: {},
              Metrics: {
                shape: "Se"
              },
              Tags: {
                shape: "S5s"
              },
              ThresholdMetricId: {}
            }
          }
        },
        PutMetricData: {
          input: {
            type: "structure",
            required: [
              "Namespace",
              "MetricData"
            ],
            members: {
              Namespace: {},
              MetricData: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "MetricName"
                  ],
                  members: {
                    MetricName: {},
                    Dimensions: {
                      shape: "S7"
                    },
                    Timestamp: {
                      type: "timestamp"
                    },
                    Value: {
                      type: "double"
                    },
                    StatisticValues: {
                      type: "structure",
                      required: [
                        "SampleCount",
                        "Sum",
                        "Minimum",
                        "Maximum"
                      ],
                      members: {
                        SampleCount: {
                          type: "double"
                        },
                        Sum: {
                          type: "double"
                        },
                        Minimum: {
                          type: "double"
                        },
                        Maximum: {
                          type: "double"
                        }
                      }
                    },
                    Values: {
                      type: "list",
                      member: {
                        type: "double"
                      }
                    },
                    Counts: {
                      type: "list",
                      member: {
                        type: "double"
                      }
                    },
                    Unit: {},
                    StorageResolution: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        PutMetricStream: {
          input: {
            type: "structure",
            required: [
              "Name",
              "FirehoseArn",
              "RoleArn",
              "OutputFormat"
            ],
            members: {
              Name: {},
              IncludeFilters: {
                shape: "S4j"
              },
              ExcludeFilters: {
                shape: "S4j"
              },
              FirehoseArn: {},
              RoleArn: {},
              OutputFormat: {},
              Tags: {
                shape: "S5s"
              },
              StatisticsConfigurations: {
                shape: "S4o"
              },
              IncludeLinkedAccountsMetrics: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "PutMetricStreamResult",
            type: "structure",
            members: {
              Arn: {}
            }
          }
        },
        SetAlarmState: {
          input: {
            type: "structure",
            required: [
              "AlarmName",
              "StateValue",
              "StateReason"
            ],
            members: {
              AlarmName: {},
              StateValue: {},
              StateReason: {},
              StateReasonData: {}
            }
          }
        },
        StartMetricStreams: {
          input: {
            type: "structure",
            required: [
              "Names"
            ],
            members: {
              Names: {
                shape: "S6n"
              }
            }
          },
          output: {
            resultWrapper: "StartMetricStreamsResult",
            type: "structure",
            members: {}
          }
        },
        StopMetricStreams: {
          input: {
            type: "structure",
            required: [
              "Names"
            ],
            members: {
              Names: {
                shape: "S6n"
              }
            }
          },
          output: {
            resultWrapper: "StopMetricStreamsResult",
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S5s"
              }
            }
          },
          output: {
            resultWrapper: "TagResourceResult",
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "UntagResourceResult",
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S2: {
          type: "list",
          member: {}
        },
        S7: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Value"
            ],
            members: {
              Name: {},
              Value: {}
            },
            xmlOrder: [
              "Name",
              "Value"
            ]
          }
        },
        Sc: {
          type: "structure",
          members: {
            Namespace: {},
            MetricName: {},
            Dimensions: {
              shape: "S7"
            },
            Stat: {}
          }
        },
        Sd: {
          type: "structure",
          members: {
            MetricDataQueries: {
              shape: "Se"
            }
          }
        },
        Se: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {},
              MetricStat: {
                type: "structure",
                required: [
                  "Metric",
                  "Period",
                  "Stat"
                ],
                members: {
                  Metric: {
                    shape: "Si"
                  },
                  Period: {
                    type: "integer"
                  },
                  Stat: {},
                  Unit: {}
                }
              },
              Expression: {},
              Label: {},
              ReturnData: {
                type: "boolean"
              },
              Period: {
                type: "integer"
              },
              AccountId: {}
            }
          }
        },
        Si: {
          type: "structure",
          members: {
            Namespace: {},
            MetricName: {},
            Dimensions: {
              shape: "S7"
            }
          },
          xmlOrder: [
            "Namespace",
            "MetricName",
            "Dimensions"
          ]
        },
        Sw: {
          type: "list",
          member: {}
        },
        Sz: {
          type: "list",
          member: {
            type: "structure",
            members: {
              FailureResource: {},
              ExceptionType: {},
              FailureCode: {},
              FailureDescription: {}
            }
          }
        },
        S19: {
          type: "list",
          member: {}
        },
        S1t: {
          type: "list",
          member: {}
        },
        S23: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AlarmName: {},
              AlarmArn: {},
              AlarmDescription: {},
              AlarmConfigurationUpdatedTimestamp: {
                type: "timestamp"
              },
              ActionsEnabled: {
                type: "boolean"
              },
              OKActions: {
                shape: "S1t"
              },
              AlarmActions: {
                shape: "S1t"
              },
              InsufficientDataActions: {
                shape: "S1t"
              },
              StateValue: {},
              StateReason: {},
              StateReasonData: {},
              StateUpdatedTimestamp: {
                type: "timestamp"
              },
              MetricName: {},
              Namespace: {},
              Statistic: {},
              ExtendedStatistic: {},
              Dimensions: {
                shape: "S7"
              },
              Period: {
                type: "integer"
              },
              Unit: {},
              EvaluationPeriods: {
                type: "integer"
              },
              DatapointsToAlarm: {
                type: "integer"
              },
              Threshold: {
                type: "double"
              },
              ComparisonOperator: {},
              TreatMissingData: {},
              EvaluateLowSampleCountPercentile: {},
              Metrics: {
                shape: "Se"
              },
              ThresholdMetricId: {},
              EvaluationState: {},
              StateTransitionedTimestamp: {
                type: "timestamp"
              }
            },
            xmlOrder: [
              "AlarmName",
              "AlarmArn",
              "AlarmDescription",
              "AlarmConfigurationUpdatedTimestamp",
              "ActionsEnabled",
              "OKActions",
              "AlarmActions",
              "InsufficientDataActions",
              "StateValue",
              "StateReason",
              "StateReasonData",
              "StateUpdatedTimestamp",
              "MetricName",
              "Namespace",
              "Statistic",
              "Dimensions",
              "Period",
              "Unit",
              "EvaluationPeriods",
              "Threshold",
              "ComparisonOperator",
              "ExtendedStatistic",
              "TreatMissingData",
              "EvaluateLowSampleCountPercentile",
              "DatapointsToAlarm",
              "Metrics",
              "ThresholdMetricId",
              "EvaluationState",
              "StateTransitionedTimestamp"
            ]
          }
        },
        S2n: {
          type: "structure",
          members: {
            ExcludedTimeRanges: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "StartTime",
                  "EndTime"
                ],
                members: {
                  StartTime: {
                    type: "timestamp"
                  },
                  EndTime: {
                    type: "timestamp"
                  }
                },
                xmlOrder: [
                  "StartTime",
                  "EndTime"
                ]
              }
            },
            MetricTimezone: {}
          }
        },
        S45: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Code: {},
              Value: {}
            }
          }
        },
        S4j: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Namespace: {},
              MetricNames: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S4o: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "IncludeMetrics",
              "AdditionalStatistics"
            ],
            members: {
              IncludeMetrics: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Namespace",
                    "MetricName"
                  ],
                  members: {
                    Namespace: {},
                    MetricName: {}
                  }
                }
              },
              AdditionalStatistics: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S5s: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S6n: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/monitoring-2010-08-01.paginators.json
var require_monitoring_2010_08_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/monitoring-2010-08-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeAlarmHistory: {
          input_token: "NextToken",
          limit_key: "MaxRecords",
          output_token: "NextToken",
          result_key: "AlarmHistoryItems"
        },
        DescribeAlarms: {
          input_token: "NextToken",
          limit_key: "MaxRecords",
          output_token: "NextToken",
          result_key: [
            "MetricAlarms",
            "CompositeAlarms"
          ]
        },
        DescribeAlarmsForMetric: {
          result_key: "MetricAlarms"
        },
        DescribeAnomalyDetectors: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "AnomalyDetectors"
        },
        DescribeInsightRules: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetMetricData: {
          input_token: "NextToken",
          limit_key: "MaxDatapoints",
          output_token: "NextToken",
          result_key: [
            "MetricDataResults",
            "Messages"
          ]
        },
        ListDashboards: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "DashboardEntries"
        },
        ListManagedInsightRules: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListMetricStreams: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListMetrics: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: [
            "Metrics",
            "OwningAccounts"
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/monitoring-2010-08-01.waiters2.json
var require_monitoring_2010_08_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/monitoring-2010-08-01.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        AlarmExists: {
          delay: 5,
          maxAttempts: 40,
          operation: "DescribeAlarms",
          acceptors: [
            {
              matcher: "path",
              expected: true,
              argument: "length(MetricAlarms[]) > `0`",
              state: "success"
            }
          ]
        },
        CompositeAlarmExists: {
          delay: 5,
          maxAttempts: 40,
          operation: "DescribeAlarms",
          acceptors: [
            {
              matcher: "path",
              expected: true,
              argument: "length(CompositeAlarms[]) > `0`",
              state: "success"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/cloudwatch.js
var require_cloudwatch = __commonJS({
  "node_modules/aws-sdk/clients/cloudwatch.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["cloudwatch"] = {};
    AWS2.CloudWatch = Service.defineService("cloudwatch", ["2010-08-01"]);
    Object.defineProperty(apiLoader.services["cloudwatch"], "2010-08-01", {
      get: function get() {
        var model = require_monitoring_2010_08_01_min();
        model.paginators = require_monitoring_2010_08_01_paginators().pagination;
        model.waiters = require_monitoring_2010_08_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CloudWatch;
  }
});

// node_modules/aws-sdk/apis/events-2015-10-07.min.json
var require_events_2015_10_07_min = __commonJS({
  "node_modules/aws-sdk/apis/events-2015-10-07.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-10-07",
        endpointPrefix: "events",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon CloudWatch Events",
        serviceId: "CloudWatch Events",
        signatureVersion: "v4",
        targetPrefix: "AWSEvents",
        uid: "events-2015-10-07"
      },
      operations: {
        ActivateEventSource: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        CancelReplay: {
          input: {
            type: "structure",
            required: [
              "ReplayName"
            ],
            members: {
              ReplayName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplayArn: {},
              State: {},
              StateReason: {}
            }
          }
        },
        CreateApiDestination: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ConnectionArn",
              "InvocationEndpoint",
              "HttpMethod"
            ],
            members: {
              Name: {},
              Description: {},
              ConnectionArn: {},
              InvocationEndpoint: {},
              HttpMethod: {},
              InvocationRateLimitPerSecond: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApiDestinationArn: {},
              ApiDestinationState: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              }
            }
          }
        },
        CreateArchive: {
          input: {
            type: "structure",
            required: [
              "ArchiveName",
              "EventSourceArn"
            ],
            members: {
              ArchiveName: {},
              EventSourceArn: {},
              Description: {},
              EventPattern: {},
              RetentionDays: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ArchiveArn: {},
              State: {},
              StateReason: {},
              CreationTime: {
                type: "timestamp"
              }
            }
          }
        },
        CreateConnection: {
          input: {
            type: "structure",
            required: [
              "Name",
              "AuthorizationType",
              "AuthParameters"
            ],
            members: {
              Name: {},
              Description: {},
              AuthorizationType: {},
              AuthParameters: {
                type: "structure",
                members: {
                  BasicAuthParameters: {
                    type: "structure",
                    required: [
                      "Username",
                      "Password"
                    ],
                    members: {
                      Username: {},
                      Password: {
                        shape: "S11"
                      }
                    }
                  },
                  OAuthParameters: {
                    type: "structure",
                    required: [
                      "ClientParameters",
                      "AuthorizationEndpoint",
                      "HttpMethod"
                    ],
                    members: {
                      ClientParameters: {
                        type: "structure",
                        required: [
                          "ClientID",
                          "ClientSecret"
                        ],
                        members: {
                          ClientID: {},
                          ClientSecret: {
                            shape: "S11"
                          }
                        }
                      },
                      AuthorizationEndpoint: {},
                      HttpMethod: {},
                      OAuthHttpParameters: {
                        shape: "S15"
                      }
                    }
                  },
                  ApiKeyAuthParameters: {
                    type: "structure",
                    required: [
                      "ApiKeyName",
                      "ApiKeyValue"
                    ],
                    members: {
                      ApiKeyName: {},
                      ApiKeyValue: {
                        shape: "S11"
                      }
                    }
                  },
                  InvocationHttpParameters: {
                    shape: "S15"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionArn: {},
              ConnectionState: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              }
            }
          }
        },
        CreateEventBus: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              EventSourceName: {},
              Tags: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventBusArn: {}
            }
          }
        },
        CreatePartnerEventSource: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Account"
            ],
            members: {
              Name: {},
              Account: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EventSourceArn: {}
            }
          }
        },
        DeactivateEventSource: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        DeauthorizeConnection: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionArn: {},
              ConnectionState: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastAuthorizedTime: {
                type: "timestamp"
              }
            }
          }
        },
        DeleteApiDestination: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteArchive: {
          input: {
            type: "structure",
            required: [
              "ArchiveName"
            ],
            members: {
              ArchiveName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteConnection: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionArn: {},
              ConnectionState: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastAuthorizedTime: {
                type: "timestamp"
              }
            }
          }
        },
        DeleteEventBus: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        DeletePartnerEventSource: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Account"
            ],
            members: {
              Name: {},
              Account: {}
            }
          }
        },
        DeleteRule: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              EventBusName: {},
              Force: {
                type: "boolean"
              }
            }
          }
        },
        DescribeApiDestination: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApiDestinationArn: {},
              Name: {},
              Description: {},
              ApiDestinationState: {},
              ConnectionArn: {},
              InvocationEndpoint: {},
              HttpMethod: {},
              InvocationRateLimitPerSecond: {
                type: "integer"
              },
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeArchive: {
          input: {
            type: "structure",
            required: [
              "ArchiveName"
            ],
            members: {
              ArchiveName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ArchiveArn: {},
              ArchiveName: {},
              EventSourceArn: {},
              Description: {},
              EventPattern: {},
              State: {},
              StateReason: {},
              RetentionDays: {
                type: "integer"
              },
              SizeBytes: {
                type: "long"
              },
              EventCount: {
                type: "long"
              },
              CreationTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeConnection: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionArn: {},
              Name: {},
              Description: {},
              ConnectionState: {},
              StateReason: {},
              AuthorizationType: {},
              SecretArn: {},
              AuthParameters: {
                type: "structure",
                members: {
                  BasicAuthParameters: {
                    type: "structure",
                    members: {
                      Username: {}
                    }
                  },
                  OAuthParameters: {
                    type: "structure",
                    members: {
                      ClientParameters: {
                        type: "structure",
                        members: {
                          ClientID: {}
                        }
                      },
                      AuthorizationEndpoint: {},
                      HttpMethod: {},
                      OAuthHttpParameters: {
                        shape: "S15"
                      }
                    }
                  },
                  ApiKeyAuthParameters: {
                    type: "structure",
                    members: {
                      ApiKeyName: {}
                    }
                  },
                  InvocationHttpParameters: {
                    shape: "S15"
                  }
                }
              },
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastAuthorizedTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeEventBus: {
          input: {
            type: "structure",
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Arn: {},
              Policy: {}
            }
          }
        },
        DescribeEventSource: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreatedBy: {},
              CreationTime: {
                type: "timestamp"
              },
              ExpirationTime: {
                type: "timestamp"
              },
              Name: {},
              State: {}
            }
          }
        },
        DescribePartnerEventSource: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Name: {}
            }
          }
        },
        DescribeReplay: {
          input: {
            type: "structure",
            required: [
              "ReplayName"
            ],
            members: {
              ReplayName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplayName: {},
              ReplayArn: {},
              Description: {},
              State: {},
              StateReason: {},
              EventSourceArn: {},
              Destination: {
                shape: "S2y"
              },
              EventStartTime: {
                type: "timestamp"
              },
              EventEndTime: {
                type: "timestamp"
              },
              EventLastReplayedTime: {
                type: "timestamp"
              },
              ReplayStartTime: {
                type: "timestamp"
              },
              ReplayEndTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeRule: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              EventBusName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Arn: {},
              EventPattern: {},
              ScheduleExpression: {},
              State: {},
              Description: {},
              RoleArn: {},
              ManagedBy: {},
              EventBusName: {},
              CreatedBy: {}
            }
          }
        },
        DisableRule: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              EventBusName: {}
            }
          }
        },
        EnableRule: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              EventBusName: {}
            }
          }
        },
        ListApiDestinations: {
          input: {
            type: "structure",
            members: {
              NamePrefix: {},
              ConnectionArn: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApiDestinations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApiDestinationArn: {},
                    Name: {},
                    ApiDestinationState: {},
                    ConnectionArn: {},
                    InvocationEndpoint: {},
                    HttpMethod: {},
                    InvocationRateLimitPerSecond: {
                      type: "integer"
                    },
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListArchives: {
          input: {
            type: "structure",
            members: {
              NamePrefix: {},
              EventSourceArn: {},
              State: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Archives: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ArchiveName: {},
                    EventSourceArn: {},
                    State: {},
                    StateReason: {},
                    RetentionDays: {
                      type: "integer"
                    },
                    SizeBytes: {
                      type: "long"
                    },
                    EventCount: {
                      type: "long"
                    },
                    CreationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListConnections: {
          input: {
            type: "structure",
            members: {
              NamePrefix: {},
              ConnectionState: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Connections: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ConnectionArn: {},
                    Name: {},
                    ConnectionState: {},
                    StateReason: {},
                    AuthorizationType: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    LastAuthorizedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEventBuses: {
          input: {
            type: "structure",
            members: {
              NamePrefix: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventBuses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Arn: {},
                    Policy: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEventSources: {
          input: {
            type: "structure",
            members: {
              NamePrefix: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventSources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    CreatedBy: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    ExpirationTime: {
                      type: "timestamp"
                    },
                    Name: {},
                    State: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPartnerEventSourceAccounts: {
          input: {
            type: "structure",
            required: [
              "EventSourceName"
            ],
            members: {
              EventSourceName: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PartnerEventSourceAccounts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Account: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    ExpirationTime: {
                      type: "timestamp"
                    },
                    State: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPartnerEventSources: {
          input: {
            type: "structure",
            required: [
              "NamePrefix"
            ],
            members: {
              NamePrefix: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PartnerEventSources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Name: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListReplays: {
          input: {
            type: "structure",
            members: {
              NamePrefix: {},
              State: {},
              EventSourceArn: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Replays: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ReplayName: {},
                    EventSourceArn: {},
                    State: {},
                    StateReason: {},
                    EventStartTime: {
                      type: "timestamp"
                    },
                    EventEndTime: {
                      type: "timestamp"
                    },
                    EventLastReplayedTime: {
                      type: "timestamp"
                    },
                    ReplayStartTime: {
                      type: "timestamp"
                    },
                    ReplayEndTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListRuleNamesByTarget: {
          input: {
            type: "structure",
            required: [
              "TargetArn"
            ],
            members: {
              TargetArn: {},
              EventBusName: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RuleNames: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListRules: {
          input: {
            type: "structure",
            members: {
              NamePrefix: {},
              EventBusName: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Rules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Arn: {},
                    EventPattern: {},
                    State: {},
                    Description: {},
                    ScheduleExpression: {},
                    RoleArn: {},
                    ManagedBy: {},
                    EventBusName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S1o"
              }
            }
          }
        },
        ListTargetsByRule: {
          input: {
            type: "structure",
            required: [
              "Rule"
            ],
            members: {
              Rule: {},
              EventBusName: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Targets: {
                shape: "S4n"
              },
              NextToken: {}
            }
          }
        },
        PutEvents: {
          input: {
            type: "structure",
            required: [
              "Entries"
            ],
            members: {
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Time: {
                      type: "timestamp"
                    },
                    Source: {},
                    Resources: {
                      shape: "S6n"
                    },
                    DetailType: {},
                    Detail: {},
                    EventBusName: {},
                    TraceHeader: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedEntryCount: {
                type: "integer"
              },
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EventId: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        PutPartnerEvents: {
          input: {
            type: "structure",
            required: [
              "Entries"
            ],
            members: {
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Time: {
                      type: "timestamp"
                    },
                    Source: {},
                    Resources: {
                      shape: "S6n"
                    },
                    DetailType: {},
                    Detail: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedEntryCount: {
                type: "integer"
              },
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EventId: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        PutPermission: {
          input: {
            type: "structure",
            members: {
              EventBusName: {},
              Action: {},
              Principal: {},
              StatementId: {},
              Condition: {
                type: "structure",
                required: [
                  "Type",
                  "Key",
                  "Value"
                ],
                members: {
                  Type: {},
                  Key: {},
                  Value: {}
                }
              },
              Policy: {}
            }
          }
        },
        PutRule: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              ScheduleExpression: {},
              EventPattern: {},
              State: {},
              Description: {},
              RoleArn: {},
              Tags: {
                shape: "S1o"
              },
              EventBusName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RuleArn: {}
            }
          }
        },
        PutTargets: {
          input: {
            type: "structure",
            required: [
              "Rule",
              "Targets"
            ],
            members: {
              Rule: {},
              EventBusName: {},
              Targets: {
                shape: "S4n"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedEntryCount: {
                type: "integer"
              },
              FailedEntries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TargetId: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        RemovePermission: {
          input: {
            type: "structure",
            members: {
              StatementId: {},
              RemoveAllPermissions: {
                type: "boolean"
              },
              EventBusName: {}
            }
          }
        },
        RemoveTargets: {
          input: {
            type: "structure",
            required: [
              "Rule",
              "Ids"
            ],
            members: {
              Rule: {},
              EventBusName: {},
              Ids: {
                type: "list",
                member: {}
              },
              Force: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedEntryCount: {
                type: "integer"
              },
              FailedEntries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TargetId: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        StartReplay: {
          input: {
            type: "structure",
            required: [
              "ReplayName",
              "EventSourceArn",
              "EventStartTime",
              "EventEndTime",
              "Destination"
            ],
            members: {
              ReplayName: {},
              Description: {},
              EventSourceArn: {},
              EventStartTime: {
                type: "timestamp"
              },
              EventEndTime: {
                type: "timestamp"
              },
              Destination: {
                shape: "S2y"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReplayArn: {},
              State: {},
              StateReason: {},
              ReplayStartTime: {
                type: "timestamp"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TestEventPattern: {
          input: {
            type: "structure",
            required: [
              "EventPattern",
              "Event"
            ],
            members: {
              EventPattern: {},
              Event: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Result: {
                type: "boolean"
              }
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateApiDestination: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Description: {},
              ConnectionArn: {},
              InvocationEndpoint: {},
              HttpMethod: {},
              InvocationRateLimitPerSecond: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApiDestinationArn: {},
              ApiDestinationState: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              }
            }
          }
        },
        UpdateArchive: {
          input: {
            type: "structure",
            required: [
              "ArchiveName"
            ],
            members: {
              ArchiveName: {},
              Description: {},
              EventPattern: {},
              RetentionDays: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ArchiveArn: {},
              State: {},
              StateReason: {},
              CreationTime: {
                type: "timestamp"
              }
            }
          }
        },
        UpdateConnection: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Description: {},
              AuthorizationType: {},
              AuthParameters: {
                type: "structure",
                members: {
                  BasicAuthParameters: {
                    type: "structure",
                    members: {
                      Username: {},
                      Password: {
                        shape: "S11"
                      }
                    }
                  },
                  OAuthParameters: {
                    type: "structure",
                    members: {
                      ClientParameters: {
                        type: "structure",
                        members: {
                          ClientID: {},
                          ClientSecret: {
                            shape: "S11"
                          }
                        }
                      },
                      AuthorizationEndpoint: {},
                      HttpMethod: {},
                      OAuthHttpParameters: {
                        shape: "S15"
                      }
                    }
                  },
                  ApiKeyAuthParameters: {
                    type: "structure",
                    members: {
                      ApiKeyName: {},
                      ApiKeyValue: {
                        shape: "S11"
                      }
                    }
                  },
                  InvocationHttpParameters: {
                    shape: "S15"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionArn: {},
              ConnectionState: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastAuthorizedTime: {
                type: "timestamp"
              }
            }
          }
        }
      },
      shapes: {
        S11: {
          type: "string",
          sensitive: true
        },
        S15: {
          type: "structure",
          members: {
            HeaderParameters: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Key: {},
                  Value: {
                    type: "string",
                    sensitive: true
                  },
                  IsValueSecret: {
                    type: "boolean"
                  }
                }
              }
            },
            QueryStringParameters: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Key: {},
                  Value: {
                    type: "string",
                    sensitive: true
                  },
                  IsValueSecret: {
                    type: "boolean"
                  }
                }
              }
            },
            BodyParameters: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Key: {},
                  Value: {
                    type: "string",
                    sensitive: true
                  },
                  IsValueSecret: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        S1o: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S2y: {
          type: "structure",
          required: [
            "Arn"
          ],
          members: {
            Arn: {},
            FilterArns: {
              type: "list",
              member: {}
            }
          }
        },
        S4n: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Id",
              "Arn"
            ],
            members: {
              Id: {},
              Arn: {},
              RoleArn: {},
              Input: {},
              InputPath: {},
              InputTransformer: {
                type: "structure",
                required: [
                  "InputTemplate"
                ],
                members: {
                  InputPathsMap: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  InputTemplate: {}
                }
              },
              KinesisParameters: {
                type: "structure",
                required: [
                  "PartitionKeyPath"
                ],
                members: {
                  PartitionKeyPath: {}
                }
              },
              RunCommandParameters: {
                type: "structure",
                required: [
                  "RunCommandTargets"
                ],
                members: {
                  RunCommandTargets: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Key",
                        "Values"
                      ],
                      members: {
                        Key: {},
                        Values: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  }
                }
              },
              EcsParameters: {
                type: "structure",
                required: [
                  "TaskDefinitionArn"
                ],
                members: {
                  TaskDefinitionArn: {},
                  TaskCount: {
                    type: "integer"
                  },
                  LaunchType: {},
                  NetworkConfiguration: {
                    type: "structure",
                    members: {
                      awsvpcConfiguration: {
                        type: "structure",
                        required: [
                          "Subnets"
                        ],
                        members: {
                          Subnets: {
                            shape: "S59"
                          },
                          SecurityGroups: {
                            shape: "S59"
                          },
                          AssignPublicIp: {}
                        }
                      }
                    }
                  },
                  PlatformVersion: {},
                  Group: {},
                  CapacityProviderStrategy: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "capacityProvider"
                      ],
                      members: {
                        capacityProvider: {},
                        weight: {
                          type: "integer"
                        },
                        base: {
                          type: "integer"
                        }
                      }
                    }
                  },
                  EnableECSManagedTags: {
                    type: "boolean"
                  },
                  EnableExecuteCommand: {
                    type: "boolean"
                  },
                  PlacementConstraints: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        type: {},
                        expression: {}
                      }
                    }
                  },
                  PlacementStrategy: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        type: {},
                        field: {}
                      }
                    }
                  },
                  PropagateTags: {},
                  ReferenceId: {},
                  Tags: {
                    shape: "S1o"
                  }
                }
              },
              BatchParameters: {
                type: "structure",
                required: [
                  "JobDefinition",
                  "JobName"
                ],
                members: {
                  JobDefinition: {},
                  JobName: {},
                  ArrayProperties: {
                    type: "structure",
                    members: {
                      Size: {
                        type: "integer"
                      }
                    }
                  },
                  RetryStrategy: {
                    type: "structure",
                    members: {
                      Attempts: {
                        type: "integer"
                      }
                    }
                  }
                }
              },
              SqsParameters: {
                type: "structure",
                members: {
                  MessageGroupId: {}
                }
              },
              HttpParameters: {
                type: "structure",
                members: {
                  PathParameterValues: {
                    type: "list",
                    member: {}
                  },
                  HeaderParameters: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  QueryStringParameters: {
                    type: "map",
                    key: {},
                    value: {}
                  }
                }
              },
              RedshiftDataParameters: {
                type: "structure",
                required: [
                  "Database",
                  "Sql"
                ],
                members: {
                  SecretManagerArn: {},
                  Database: {},
                  DbUser: {},
                  Sql: {},
                  StatementName: {},
                  WithEvent: {
                    type: "boolean"
                  }
                }
              },
              SageMakerPipelineParameters: {
                type: "structure",
                members: {
                  PipelineParameterList: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Name",
                        "Value"
                      ],
                      members: {
                        Name: {},
                        Value: {}
                      }
                    }
                  }
                }
              },
              DeadLetterConfig: {
                type: "structure",
                members: {
                  Arn: {}
                }
              },
              RetryPolicy: {
                type: "structure",
                members: {
                  MaximumRetryAttempts: {
                    type: "integer"
                  },
                  MaximumEventAgeInSeconds: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        S59: {
          type: "list",
          member: {}
        },
        S6n: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/events-2015-10-07.paginators.json
var require_events_2015_10_07_paginators = __commonJS({
  "node_modules/aws-sdk/apis/events-2015-10-07.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/cloudwatchevents.js
var require_cloudwatchevents = __commonJS({
  "node_modules/aws-sdk/clients/cloudwatchevents.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["cloudwatchevents"] = {};
    AWS2.CloudWatchEvents = Service.defineService("cloudwatchevents", ["2014-02-03*", "2015-10-07"]);
    Object.defineProperty(apiLoader.services["cloudwatchevents"], "2015-10-07", {
      get: function get() {
        var model = require_events_2015_10_07_min();
        model.paginators = require_events_2015_10_07_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CloudWatchEvents;
  }
});

// node_modules/aws-sdk/apis/logs-2014-03-28.min.json
var require_logs_2014_03_28_min = __commonJS({
  "node_modules/aws-sdk/apis/logs-2014-03-28.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-03-28",
        endpointPrefix: "logs",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon CloudWatch Logs",
        serviceId: "CloudWatch Logs",
        signatureVersion: "v4",
        targetPrefix: "Logs_20140328",
        uid: "logs-2014-03-28"
      },
      operations: {
        AssociateKmsKey: {
          input: {
            type: "structure",
            required: [
              "kmsKeyId"
            ],
            members: {
              logGroupName: {},
              kmsKeyId: {},
              resourceIdentifier: {}
            }
          }
        },
        CancelExportTask: {
          input: {
            type: "structure",
            required: [
              "taskId"
            ],
            members: {
              taskId: {}
            }
          }
        },
        CreateDelivery: {
          input: {
            type: "structure",
            required: [
              "deliverySourceName",
              "deliveryDestinationArn"
            ],
            members: {
              deliverySourceName: {},
              deliveryDestinationArn: {},
              tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              delivery: {
                shape: "Se"
              }
            }
          }
        },
        CreateExportTask: {
          input: {
            type: "structure",
            required: [
              "logGroupName",
              "from",
              "to",
              "destination"
            ],
            members: {
              taskName: {},
              logGroupName: {},
              logStreamNamePrefix: {},
              from: {
                type: "long"
              },
              to: {
                type: "long"
              },
              destination: {},
              destinationPrefix: {}
            }
          },
          output: {
            type: "structure",
            members: {
              taskId: {}
            }
          }
        },
        CreateLogAnomalyDetector: {
          input: {
            type: "structure",
            required: [
              "logGroupArnList"
            ],
            members: {
              logGroupArnList: {
                shape: "Sp"
              },
              detectorName: {},
              evaluationFrequency: {},
              filterPattern: {},
              kmsKeyId: {},
              anomalyVisibilityTime: {
                type: "long"
              },
              tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              anomalyDetectorArn: {}
            }
          }
        },
        CreateLogGroup: {
          input: {
            type: "structure",
            required: [
              "logGroupName"
            ],
            members: {
              logGroupName: {},
              kmsKeyId: {},
              tags: {
                shape: "Sa"
              },
              logGroupClass: {}
            }
          }
        },
        CreateLogStream: {
          input: {
            type: "structure",
            required: [
              "logGroupName",
              "logStreamName"
            ],
            members: {
              logGroupName: {},
              logStreamName: {}
            }
          }
        },
        DeleteAccountPolicy: {
          input: {
            type: "structure",
            required: [
              "policyName",
              "policyType"
            ],
            members: {
              policyName: {},
              policyType: {}
            }
          }
        },
        DeleteDataProtectionPolicy: {
          input: {
            type: "structure",
            required: [
              "logGroupIdentifier"
            ],
            members: {
              logGroupIdentifier: {}
            }
          }
        },
        DeleteDelivery: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          }
        },
        DeleteDeliveryDestination: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          }
        },
        DeleteDeliveryDestinationPolicy: {
          input: {
            type: "structure",
            required: [
              "deliveryDestinationName"
            ],
            members: {
              deliveryDestinationName: {}
            }
          }
        },
        DeleteDeliverySource: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          }
        },
        DeleteDestination: {
          input: {
            type: "structure",
            required: [
              "destinationName"
            ],
            members: {
              destinationName: {}
            }
          }
        },
        DeleteLogAnomalyDetector: {
          input: {
            type: "structure",
            required: [
              "anomalyDetectorArn"
            ],
            members: {
              anomalyDetectorArn: {}
            }
          }
        },
        DeleteLogGroup: {
          input: {
            type: "structure",
            required: [
              "logGroupName"
            ],
            members: {
              logGroupName: {}
            }
          }
        },
        DeleteLogStream: {
          input: {
            type: "structure",
            required: [
              "logGroupName",
              "logStreamName"
            ],
            members: {
              logGroupName: {},
              logStreamName: {}
            }
          }
        },
        DeleteMetricFilter: {
          input: {
            type: "structure",
            required: [
              "logGroupName",
              "filterName"
            ],
            members: {
              logGroupName: {},
              filterName: {}
            }
          }
        },
        DeleteQueryDefinition: {
          input: {
            type: "structure",
            required: [
              "queryDefinitionId"
            ],
            members: {
              queryDefinitionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              success: {
                type: "boolean"
              }
            }
          }
        },
        DeleteResourcePolicy: {
          input: {
            type: "structure",
            members: {
              policyName: {}
            }
          }
        },
        DeleteRetentionPolicy: {
          input: {
            type: "structure",
            required: [
              "logGroupName"
            ],
            members: {
              logGroupName: {}
            }
          }
        },
        DeleteSubscriptionFilter: {
          input: {
            type: "structure",
            required: [
              "logGroupName",
              "filterName"
            ],
            members: {
              logGroupName: {},
              filterName: {}
            }
          }
        },
        DescribeAccountPolicies: {
          input: {
            type: "structure",
            required: [
              "policyType"
            ],
            members: {
              policyType: {},
              policyName: {},
              accountIdentifiers: {
                shape: "S1p"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              accountPolicies: {
                type: "list",
                member: {
                  shape: "S1t"
                }
              }
            }
          }
        },
        DescribeDeliveries: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              deliveries: {
                type: "list",
                member: {
                  shape: "Se"
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeDeliveryDestinations: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              deliveryDestinations: {
                type: "list",
                member: {
                  shape: "S24"
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeDeliverySources: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              deliverySources: {
                type: "list",
                member: {
                  shape: "S2a"
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeDestinations: {
          input: {
            type: "structure",
            members: {
              DestinationNamePrefix: {},
              nextToken: {},
              limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              destinations: {
                type: "list",
                member: {
                  shape: "S2h"
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeExportTasks: {
          input: {
            type: "structure",
            members: {
              taskId: {},
              statusCode: {},
              nextToken: {},
              limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              exportTasks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    taskId: {},
                    taskName: {},
                    logGroupName: {},
                    from: {
                      type: "long"
                    },
                    to: {
                      type: "long"
                    },
                    destination: {},
                    destinationPrefix: {},
                    status: {
                      type: "structure",
                      members: {
                        code: {},
                        message: {}
                      }
                    },
                    executionInfo: {
                      type: "structure",
                      members: {
                        creationTime: {
                          type: "long"
                        },
                        completionTime: {
                          type: "long"
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeLogGroups: {
          input: {
            type: "structure",
            members: {
              accountIdentifiers: {
                shape: "S1p"
              },
              logGroupNamePrefix: {},
              logGroupNamePattern: {},
              nextToken: {},
              limit: {
                type: "integer"
              },
              includeLinkedAccounts: {
                type: "boolean"
              },
              logGroupClass: {}
            }
          },
          output: {
            type: "structure",
            members: {
              logGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    logGroupName: {},
                    creationTime: {
                      type: "long"
                    },
                    retentionInDays: {
                      type: "integer"
                    },
                    metricFilterCount: {
                      type: "integer"
                    },
                    arn: {},
                    storedBytes: {
                      type: "long"
                    },
                    kmsKeyId: {},
                    dataProtectionStatus: {},
                    inheritedProperties: {
                      type: "list",
                      member: {}
                    },
                    logGroupClass: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeLogStreams: {
          input: {
            type: "structure",
            members: {
              logGroupName: {},
              logGroupIdentifier: {},
              logStreamNamePrefix: {},
              orderBy: {},
              descending: {
                type: "boolean"
              },
              nextToken: {},
              limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              logStreams: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    logStreamName: {},
                    creationTime: {
                      type: "long"
                    },
                    firstEventTimestamp: {
                      type: "long"
                    },
                    lastEventTimestamp: {
                      type: "long"
                    },
                    lastIngestionTime: {
                      type: "long"
                    },
                    uploadSequenceToken: {},
                    arn: {},
                    storedBytes: {
                      deprecated: true,
                      deprecatedMessage: "Starting on June 17, 2019, this parameter will be deprecated for log streams, and will be reported as zero. This change applies only to log streams. The storedBytes parameter for log groups is not affected.",
                      type: "long"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeMetricFilters: {
          input: {
            type: "structure",
            members: {
              logGroupName: {},
              filterNamePrefix: {},
              nextToken: {},
              limit: {
                type: "integer"
              },
              metricName: {},
              metricNamespace: {}
            }
          },
          output: {
            type: "structure",
            members: {
              metricFilters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    filterName: {},
                    filterPattern: {},
                    metricTransformations: {
                      shape: "S3i"
                    },
                    creationTime: {
                      type: "long"
                    },
                    logGroupName: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeQueries: {
          input: {
            type: "structure",
            members: {
              logGroupName: {},
              status: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              queries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    queryId: {},
                    queryString: {},
                    status: {},
                    createTime: {
                      type: "long"
                    },
                    logGroupName: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeQueryDefinitions: {
          input: {
            type: "structure",
            members: {
              queryDefinitionNamePrefix: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              queryDefinitions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    queryDefinitionId: {},
                    name: {},
                    queryString: {},
                    lastModified: {
                      type: "long"
                    },
                    logGroupNames: {
                      shape: "S44"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeResourcePolicies: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resourcePolicies: {
                type: "list",
                member: {
                  shape: "S48"
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeSubscriptionFilters: {
          input: {
            type: "structure",
            required: [
              "logGroupName"
            ],
            members: {
              logGroupName: {},
              filterNamePrefix: {},
              nextToken: {},
              limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              subscriptionFilters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    filterName: {},
                    logGroupName: {},
                    filterPattern: {},
                    destinationArn: {},
                    roleArn: {},
                    distribution: {},
                    creationTime: {
                      type: "long"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DisassociateKmsKey: {
          input: {
            type: "structure",
            members: {
              logGroupName: {},
              resourceIdentifier: {}
            }
          }
        },
        FilterLogEvents: {
          input: {
            type: "structure",
            members: {
              logGroupName: {},
              logGroupIdentifier: {},
              logStreamNames: {
                shape: "S4i"
              },
              logStreamNamePrefix: {},
              startTime: {
                type: "long"
              },
              endTime: {
                type: "long"
              },
              filterPattern: {},
              nextToken: {},
              limit: {
                type: "integer"
              },
              interleaved: {
                deprecated: true,
                deprecatedMessage: "Starting on June 17, 2019, this parameter will be ignored and the value will be assumed to be true. The response from this operation will always interleave events from multiple log streams within a log group.",
                type: "boolean"
              },
              unmask: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              events: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    logStreamName: {},
                    timestamp: {
                      type: "long"
                    },
                    message: {},
                    ingestionTime: {
                      type: "long"
                    },
                    eventId: {}
                  }
                }
              },
              searchedLogStreams: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    logStreamName: {},
                    searchedCompletely: {
                      type: "boolean"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetDataProtectionPolicy: {
          input: {
            type: "structure",
            required: [
              "logGroupIdentifier"
            ],
            members: {
              logGroupIdentifier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              logGroupIdentifier: {},
              policyDocument: {},
              lastUpdatedTime: {
                type: "long"
              }
            }
          }
        },
        GetDelivery: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              delivery: {
                shape: "Se"
              }
            }
          }
        },
        GetDeliveryDestination: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deliveryDestination: {
                shape: "S24"
              }
            }
          }
        },
        GetDeliveryDestinationPolicy: {
          input: {
            type: "structure",
            required: [
              "deliveryDestinationName"
            ],
            members: {
              deliveryDestinationName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              policy: {
                shape: "S53"
              }
            }
          }
        },
        GetDeliverySource: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deliverySource: {
                shape: "S2a"
              }
            }
          }
        },
        GetLogAnomalyDetector: {
          input: {
            type: "structure",
            required: [
              "anomalyDetectorArn"
            ],
            members: {
              anomalyDetectorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              detectorName: {},
              logGroupArnList: {
                shape: "Sp"
              },
              evaluationFrequency: {},
              filterPattern: {},
              anomalyDetectorStatus: {},
              kmsKeyId: {},
              creationTimeStamp: {
                type: "long"
              },
              lastModifiedTimeStamp: {
                type: "long"
              },
              anomalyVisibilityTime: {
                type: "long"
              }
            }
          }
        },
        GetLogEvents: {
          input: {
            type: "structure",
            required: [
              "logStreamName"
            ],
            members: {
              logGroupName: {},
              logGroupIdentifier: {},
              logStreamName: {},
              startTime: {
                type: "long"
              },
              endTime: {
                type: "long"
              },
              nextToken: {},
              limit: {
                type: "integer"
              },
              startFromHead: {
                type: "boolean"
              },
              unmask: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              events: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    timestamp: {
                      type: "long"
                    },
                    message: {},
                    ingestionTime: {
                      type: "long"
                    }
                  }
                }
              },
              nextForwardToken: {},
              nextBackwardToken: {}
            }
          }
        },
        GetLogGroupFields: {
          input: {
            type: "structure",
            members: {
              logGroupName: {},
              time: {
                type: "long"
              },
              logGroupIdentifier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              logGroupFields: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    percent: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        GetLogRecord: {
          input: {
            type: "structure",
            required: [
              "logRecordPointer"
            ],
            members: {
              logRecordPointer: {},
              unmask: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              logRecord: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        GetQueryResults: {
          input: {
            type: "structure",
            required: [
              "queryId"
            ],
            members: {
              queryId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              results: {
                type: "list",
                member: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      field: {},
                      value: {}
                    }
                  }
                }
              },
              statistics: {
                type: "structure",
                members: {
                  recordsMatched: {
                    type: "double"
                  },
                  recordsScanned: {
                    type: "double"
                  },
                  bytesScanned: {
                    type: "double"
                  }
                }
              },
              status: {},
              encryptionKey: {}
            }
          }
        },
        ListAnomalies: {
          input: {
            type: "structure",
            members: {
              anomalyDetectorArn: {},
              suppressionState: {},
              limit: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              anomalies: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "anomalyId",
                    "patternId",
                    "anomalyDetectorArn",
                    "patternString",
                    "firstSeen",
                    "lastSeen",
                    "description",
                    "active",
                    "state",
                    "histogram",
                    "logSamples",
                    "patternTokens",
                    "logGroupArnList"
                  ],
                  members: {
                    anomalyId: {},
                    patternId: {},
                    anomalyDetectorArn: {},
                    patternString: {},
                    patternRegex: {},
                    priority: {},
                    firstSeen: {
                      type: "long"
                    },
                    lastSeen: {
                      type: "long"
                    },
                    description: {},
                    active: {
                      type: "boolean"
                    },
                    state: {},
                    histogram: {
                      type: "map",
                      key: {},
                      value: {
                        type: "long"
                      }
                    },
                    logSamples: {
                      type: "list",
                      member: {}
                    },
                    patternTokens: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          dynamicTokenPosition: {
                            type: "integer"
                          },
                          isDynamic: {
                            type: "boolean"
                          },
                          tokenString: {},
                          enumerations: {
                            type: "map",
                            key: {},
                            value: {
                              type: "long"
                            }
                          }
                        }
                      }
                    },
                    logGroupArnList: {
                      shape: "Sp"
                    },
                    suppressed: {
                      type: "boolean"
                    },
                    suppressedDate: {
                      type: "long"
                    },
                    suppressedUntil: {
                      type: "long"
                    },
                    isPatternLevelSuppression: {
                      type: "boolean"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListLogAnomalyDetectors: {
          input: {
            type: "structure",
            members: {
              filterLogGroupArn: {},
              limit: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              anomalyDetectors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    anomalyDetectorArn: {},
                    detectorName: {},
                    logGroupArnList: {
                      shape: "Sp"
                    },
                    evaluationFrequency: {},
                    filterPattern: {},
                    anomalyDetectorStatus: {},
                    kmsKeyId: {},
                    creationTimeStamp: {
                      type: "long"
                    },
                    lastModifiedTimeStamp: {
                      type: "long"
                    },
                    anomalyVisibilityTime: {
                      type: "long"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sa"
              }
            }
          }
        },
        ListTagsLogGroup: {
          input: {
            type: "structure",
            required: [
              "logGroupName"
            ],
            members: {
              logGroupName: {}
            },
            deprecated: true,
            deprecatedMessage: "Please use the generic tagging API model ListTagsForResourceRequest and ListTagsForResourceResponse"
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sa"
              }
            },
            deprecated: true,
            deprecatedMessage: "Please use the generic tagging API model ListTagsForResourceRequest and ListTagsForResourceResponse"
          },
          deprecated: true,
          deprecatedMessage: "Please use the generic tagging API ListTagsForResource"
        },
        PutAccountPolicy: {
          input: {
            type: "structure",
            required: [
              "policyName",
              "policyDocument",
              "policyType"
            ],
            members: {
              policyName: {},
              policyDocument: {},
              policyType: {},
              scope: {}
            }
          },
          output: {
            type: "structure",
            members: {
              accountPolicy: {
                shape: "S1t"
              }
            }
          }
        },
        PutDataProtectionPolicy: {
          input: {
            type: "structure",
            required: [
              "logGroupIdentifier",
              "policyDocument"
            ],
            members: {
              logGroupIdentifier: {},
              policyDocument: {}
            }
          },
          output: {
            type: "structure",
            members: {
              logGroupIdentifier: {},
              policyDocument: {},
              lastUpdatedTime: {
                type: "long"
              }
            }
          }
        },
        PutDeliveryDestination: {
          input: {
            type: "structure",
            required: [
              "name",
              "deliveryDestinationConfiguration"
            ],
            members: {
              name: {},
              outputFormat: {},
              deliveryDestinationConfiguration: {
                shape: "S26"
              },
              tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              deliveryDestination: {
                shape: "S24"
              }
            }
          }
        },
        PutDeliveryDestinationPolicy: {
          input: {
            type: "structure",
            required: [
              "deliveryDestinationName",
              "deliveryDestinationPolicy"
            ],
            members: {
              deliveryDestinationName: {},
              deliveryDestinationPolicy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              policy: {
                shape: "S53"
              }
            }
          }
        },
        PutDeliverySource: {
          input: {
            type: "structure",
            required: [
              "name",
              "resourceArn",
              "logType"
            ],
            members: {
              name: {},
              resourceArn: {},
              logType: {},
              tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              deliverySource: {
                shape: "S2a"
              }
            }
          }
        },
        PutDestination: {
          input: {
            type: "structure",
            required: [
              "destinationName",
              "targetArn",
              "roleArn"
            ],
            members: {
              destinationName: {},
              targetArn: {},
              roleArn: {},
              tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              destination: {
                shape: "S2h"
              }
            }
          }
        },
        PutDestinationPolicy: {
          input: {
            type: "structure",
            required: [
              "destinationName",
              "accessPolicy"
            ],
            members: {
              destinationName: {},
              accessPolicy: {},
              forceUpdate: {
                type: "boolean"
              }
            }
          }
        },
        PutLogEvents: {
          input: {
            type: "structure",
            required: [
              "logGroupName",
              "logStreamName",
              "logEvents"
            ],
            members: {
              logGroupName: {},
              logStreamName: {},
              logEvents: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "timestamp",
                    "message"
                  ],
                  members: {
                    timestamp: {
                      type: "long"
                    },
                    message: {}
                  }
                }
              },
              sequenceToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              nextSequenceToken: {},
              rejectedLogEventsInfo: {
                type: "structure",
                members: {
                  tooNewLogEventStartIndex: {
                    type: "integer"
                  },
                  tooOldLogEventEndIndex: {
                    type: "integer"
                  },
                  expiredLogEventEndIndex: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        PutMetricFilter: {
          input: {
            type: "structure",
            required: [
              "logGroupName",
              "filterName",
              "filterPattern",
              "metricTransformations"
            ],
            members: {
              logGroupName: {},
              filterName: {},
              filterPattern: {},
              metricTransformations: {
                shape: "S3i"
              }
            }
          }
        },
        PutQueryDefinition: {
          input: {
            type: "structure",
            required: [
              "name",
              "queryString"
            ],
            members: {
              name: {},
              queryDefinitionId: {},
              logGroupNames: {
                shape: "S44"
              },
              queryString: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              queryDefinitionId: {}
            }
          }
        },
        PutResourcePolicy: {
          input: {
            type: "structure",
            members: {
              policyName: {},
              policyDocument: {}
            }
          },
          output: {
            type: "structure",
            members: {
              resourcePolicy: {
                shape: "S48"
              }
            }
          }
        },
        PutRetentionPolicy: {
          input: {
            type: "structure",
            required: [
              "logGroupName",
              "retentionInDays"
            ],
            members: {
              logGroupName: {},
              retentionInDays: {
                type: "integer"
              }
            }
          }
        },
        PutSubscriptionFilter: {
          input: {
            type: "structure",
            required: [
              "logGroupName",
              "filterName",
              "filterPattern",
              "destinationArn"
            ],
            members: {
              logGroupName: {},
              filterName: {},
              filterPattern: {},
              destinationArn: {},
              roleArn: {},
              distribution: {}
            }
          }
        },
        StartLiveTail: {
          input: {
            type: "structure",
            required: [
              "logGroupIdentifiers"
            ],
            members: {
              logGroupIdentifiers: {
                shape: "S7r"
              },
              logStreamNames: {
                shape: "S4i"
              },
              logStreamNamePrefixes: {
                shape: "S4i"
              },
              logEventFilterPattern: {}
            }
          },
          output: {
            type: "structure",
            members: {
              responseStream: {
                type: "structure",
                members: {
                  sessionStart: {
                    type: "structure",
                    members: {
                      requestId: {},
                      sessionId: {},
                      logGroupIdentifiers: {
                        shape: "S7r"
                      },
                      logStreamNames: {
                        shape: "S4i"
                      },
                      logStreamNamePrefixes: {
                        shape: "S4i"
                      },
                      logEventFilterPattern: {}
                    },
                    event: true
                  },
                  sessionUpdate: {
                    type: "structure",
                    members: {
                      sessionMetadata: {
                        type: "structure",
                        members: {
                          sampled: {
                            type: "boolean"
                          }
                        }
                      },
                      sessionResults: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            logStreamName: {},
                            logGroupIdentifier: {},
                            message: {},
                            timestamp: {
                              type: "long"
                            },
                            ingestionTime: {
                              type: "long"
                            }
                          }
                        }
                      }
                    },
                    event: true
                  },
                  SessionTimeoutException: {
                    type: "structure",
                    members: {
                      message: {}
                    },
                    exception: true
                  },
                  SessionStreamingException: {
                    type: "structure",
                    members: {
                      message: {}
                    },
                    exception: true
                  }
                },
                eventstream: true
              }
            }
          },
          endpoint: {
            hostPrefix: "streaming-"
          }
        },
        StartQuery: {
          input: {
            type: "structure",
            required: [
              "startTime",
              "endTime",
              "queryString"
            ],
            members: {
              logGroupName: {},
              logGroupNames: {
                shape: "S44"
              },
              logGroupIdentifiers: {
                type: "list",
                member: {}
              },
              startTime: {
                type: "long"
              },
              endTime: {
                type: "long"
              },
              queryString: {},
              limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              queryId: {}
            }
          }
        },
        StopQuery: {
          input: {
            type: "structure",
            required: [
              "queryId"
            ],
            members: {
              queryId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              success: {
                type: "boolean"
              }
            }
          }
        },
        TagLogGroup: {
          input: {
            type: "structure",
            required: [
              "logGroupName",
              "tags"
            ],
            members: {
              logGroupName: {},
              tags: {
                shape: "Sa"
              }
            },
            deprecated: true,
            deprecatedMessage: "Please use the generic tagging API model TagResourceRequest"
          },
          deprecated: true,
          deprecatedMessage: "Please use the generic tagging API TagResource"
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "Sa"
              }
            }
          }
        },
        TestMetricFilter: {
          input: {
            type: "structure",
            required: [
              "filterPattern",
              "logEventMessages"
            ],
            members: {
              filterPattern: {},
              logEventMessages: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              matches: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    eventNumber: {
                      type: "long"
                    },
                    eventMessage: {},
                    extractedValues: {
                      type: "map",
                      key: {},
                      value: {}
                    }
                  }
                }
              }
            }
          }
        },
        UntagLogGroup: {
          input: {
            type: "structure",
            required: [
              "logGroupName",
              "tags"
            ],
            members: {
              logGroupName: {},
              tags: {
                type: "list",
                member: {}
              }
            },
            deprecated: true,
            deprecatedMessage: "Please use the generic tagging API model UntagResourceRequest"
          },
          deprecated: true,
          deprecatedMessage: "Please use the generic tagging API UntagResource"
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        },
        UpdateAnomaly: {
          input: {
            type: "structure",
            required: [
              "anomalyDetectorArn"
            ],
            members: {
              anomalyId: {},
              patternId: {},
              anomalyDetectorArn: {},
              suppressionType: {},
              suppressionPeriod: {
                type: "structure",
                members: {
                  value: {
                    type: "integer"
                  },
                  suppressionUnit: {}
                }
              }
            }
          }
        },
        UpdateLogAnomalyDetector: {
          input: {
            type: "structure",
            required: [
              "anomalyDetectorArn",
              "enabled"
            ],
            members: {
              anomalyDetectorArn: {},
              evaluationFrequency: {},
              filterPattern: {},
              anomalyVisibilityTime: {
                type: "long"
              },
              enabled: {
                type: "boolean"
              }
            }
          }
        }
      },
      shapes: {
        Sa: {
          type: "map",
          key: {},
          value: {}
        },
        Se: {
          type: "structure",
          members: {
            id: {},
            arn: {},
            deliverySourceName: {},
            deliveryDestinationArn: {},
            deliveryDestinationType: {},
            tags: {
              shape: "Sa"
            }
          }
        },
        Sp: {
          type: "list",
          member: {}
        },
        S1p: {
          type: "list",
          member: {}
        },
        S1t: {
          type: "structure",
          members: {
            policyName: {},
            policyDocument: {},
            lastUpdatedTime: {
              type: "long"
            },
            policyType: {},
            scope: {},
            accountId: {}
          }
        },
        S24: {
          type: "structure",
          members: {
            name: {},
            arn: {},
            deliveryDestinationType: {},
            outputFormat: {},
            deliveryDestinationConfiguration: {
              shape: "S26"
            },
            tags: {
              shape: "Sa"
            }
          }
        },
        S26: {
          type: "structure",
          required: [
            "destinationResourceArn"
          ],
          members: {
            destinationResourceArn: {}
          }
        },
        S2a: {
          type: "structure",
          members: {
            name: {},
            arn: {},
            resourceArns: {
              type: "list",
              member: {}
            },
            service: {},
            logType: {},
            tags: {
              shape: "Sa"
            }
          }
        },
        S2h: {
          type: "structure",
          members: {
            destinationName: {},
            targetArn: {},
            roleArn: {},
            accessPolicy: {},
            arn: {},
            creationTime: {
              type: "long"
            }
          }
        },
        S3i: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "metricName",
              "metricNamespace",
              "metricValue"
            ],
            members: {
              metricName: {},
              metricNamespace: {},
              metricValue: {},
              defaultValue: {
                type: "double"
              },
              dimensions: {
                type: "map",
                key: {},
                value: {}
              },
              unit: {}
            }
          }
        },
        S44: {
          type: "list",
          member: {}
        },
        S48: {
          type: "structure",
          members: {
            policyName: {},
            policyDocument: {},
            lastUpdatedTime: {
              type: "long"
            }
          }
        },
        S4i: {
          type: "list",
          member: {}
        },
        S53: {
          type: "structure",
          members: {
            deliveryDestinationPolicy: {}
          }
        },
        S7r: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/logs-2014-03-28.paginators.json
var require_logs_2014_03_28_paginators = __commonJS({
  "node_modules/aws-sdk/apis/logs-2014-03-28.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeDeliveries: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextToken",
          result_key: "deliveries"
        },
        DescribeDeliveryDestinations: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextToken",
          result_key: "deliveryDestinations"
        },
        DescribeDeliverySources: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextToken",
          result_key: "deliverySources"
        },
        DescribeDestinations: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextToken",
          result_key: "destinations"
        },
        DescribeLogGroups: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextToken",
          result_key: "logGroups"
        },
        DescribeLogStreams: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextToken",
          result_key: "logStreams"
        },
        DescribeMetricFilters: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextToken",
          result_key: "metricFilters"
        },
        DescribeSubscriptionFilters: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextToken",
          result_key: "subscriptionFilters"
        },
        FilterLogEvents: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextToken",
          result_key: [
            "events",
            "searchedLogStreams"
          ]
        },
        GetLogEvents: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextForwardToken",
          result_key: "events"
        },
        ListAnomalies: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextToken",
          result_key: "anomalies"
        },
        ListLogAnomalyDetectors: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextToken",
          result_key: "anomalyDetectors"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/cloudwatchlogs.js
var require_cloudwatchlogs = __commonJS({
  "node_modules/aws-sdk/clients/cloudwatchlogs.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["cloudwatchlogs"] = {};
    AWS2.CloudWatchLogs = Service.defineService("cloudwatchlogs", ["2014-03-28"]);
    Object.defineProperty(apiLoader.services["cloudwatchlogs"], "2014-03-28", {
      get: function get() {
        var model = require_logs_2014_03_28_min();
        model.paginators = require_logs_2014_03_28_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CloudWatchLogs;
  }
});

// node_modules/aws-sdk/apis/codebuild-2016-10-06.min.json
var require_codebuild_2016_10_06_min = __commonJS({
  "node_modules/aws-sdk/apis/codebuild-2016-10-06.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-10-06",
        endpointPrefix: "codebuild",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS CodeBuild",
        serviceId: "CodeBuild",
        signatureVersion: "v4",
        targetPrefix: "CodeBuild_20161006",
        uid: "codebuild-2016-10-06"
      },
      operations: {
        BatchDeleteBuilds: {
          input: {
            type: "structure",
            required: [
              "ids"
            ],
            members: {
              ids: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              buildsDeleted: {
                shape: "S2"
              },
              buildsNotDeleted: {
                shape: "S5"
              }
            }
          }
        },
        BatchGetBuildBatches: {
          input: {
            type: "structure",
            required: [
              "ids"
            ],
            members: {
              ids: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              buildBatches: {
                type: "list",
                member: {
                  shape: "Sc"
                }
              },
              buildBatchesNotFound: {
                shape: "S9"
              }
            }
          }
        },
        BatchGetBuilds: {
          input: {
            type: "structure",
            required: [
              "ids"
            ],
            members: {
              ids: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              builds: {
                type: "list",
                member: {
                  shape: "S23"
                }
              },
              buildsNotFound: {
                shape: "S2"
              }
            }
          }
        },
        BatchGetProjects: {
          input: {
            type: "structure",
            required: [
              "names"
            ],
            members: {
              names: {
                shape: "S2e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              projects: {
                type: "list",
                member: {
                  shape: "S2h"
                }
              },
              projectsNotFound: {
                shape: "S2e"
              }
            }
          }
        },
        BatchGetReportGroups: {
          input: {
            type: "structure",
            required: [
              "reportGroupArns"
            ],
            members: {
              reportGroupArns: {
                shape: "S32"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              reportGroups: {
                type: "list",
                member: {
                  shape: "S35"
                }
              },
              reportGroupsNotFound: {
                shape: "S32"
              }
            }
          }
        },
        BatchGetReports: {
          input: {
            type: "structure",
            required: [
              "reportArns"
            ],
            members: {
              reportArns: {
                shape: "S3e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              reports: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    type: {},
                    name: {},
                    reportGroupArn: {},
                    executionId: {},
                    status: {},
                    created: {
                      type: "timestamp"
                    },
                    expired: {
                      type: "timestamp"
                    },
                    exportConfig: {
                      shape: "S38"
                    },
                    truncated: {
                      type: "boolean"
                    },
                    testSummary: {
                      type: "structure",
                      required: [
                        "total",
                        "statusCounts",
                        "durationInNanoSeconds"
                      ],
                      members: {
                        total: {
                          type: "integer"
                        },
                        statusCounts: {
                          type: "map",
                          key: {},
                          value: {
                            type: "integer"
                          }
                        },
                        durationInNanoSeconds: {
                          type: "long"
                        }
                      }
                    },
                    codeCoverageSummary: {
                      type: "structure",
                      members: {
                        lineCoveragePercentage: {
                          type: "double"
                        },
                        linesCovered: {
                          type: "integer"
                        },
                        linesMissed: {
                          type: "integer"
                        },
                        branchCoveragePercentage: {
                          type: "double"
                        },
                        branchesCovered: {
                          type: "integer"
                        },
                        branchesMissed: {
                          type: "integer"
                        }
                      }
                    }
                  }
                }
              },
              reportsNotFound: {
                shape: "S3e"
              }
            }
          }
        },
        CreateProject: {
          input: {
            type: "structure",
            required: [
              "name",
              "source",
              "artifacts",
              "environment",
              "serviceRole"
            ],
            members: {
              name: {},
              description: {},
              source: {
                shape: "Sl"
              },
              secondarySources: {
                shape: "St"
              },
              sourceVersion: {},
              secondarySourceVersions: {
                shape: "Su"
              },
              artifacts: {
                shape: "S2k"
              },
              secondaryArtifacts: {
                shape: "S2n"
              },
              cache: {
                shape: "Sz"
              },
              environment: {
                shape: "S13"
              },
              serviceRole: {},
              timeoutInMinutes: {
                type: "integer"
              },
              queuedTimeoutInMinutes: {
                type: "integer"
              },
              encryptionKey: {},
              tags: {
                shape: "S2p"
              },
              vpcConfig: {
                shape: "S1i"
              },
              badgeEnabled: {
                type: "boolean"
              },
              logsConfig: {
                shape: "S1c"
              },
              fileSystemLocations: {
                shape: "S1l"
              },
              buildBatchConfig: {
                shape: "S1o"
              },
              concurrentBuildLimit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              project: {
                shape: "S2h"
              }
            }
          }
        },
        CreateReportGroup: {
          input: {
            type: "structure",
            required: [
              "name",
              "type",
              "exportConfig"
            ],
            members: {
              name: {},
              type: {},
              exportConfig: {
                shape: "S38"
              },
              tags: {
                shape: "S2p"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              reportGroup: {
                shape: "S35"
              }
            }
          }
        },
        CreateWebhook: {
          input: {
            type: "structure",
            required: [
              "projectName"
            ],
            members: {
              projectName: {},
              branchFilter: {},
              filterGroups: {
                shape: "S2u"
              },
              buildType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              webhook: {
                shape: "S2t"
              }
            }
          }
        },
        DeleteBuildBatch: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              statusCode: {},
              buildsDeleted: {
                shape: "S2"
              },
              buildsNotDeleted: {
                shape: "S5"
              }
            }
          }
        },
        DeleteProject: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteReport: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteReportGroup: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              deleteReports: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSourceCredentials: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {}
            }
          }
        },
        DeleteWebhook: {
          input: {
            type: "structure",
            required: [
              "projectName"
            ],
            members: {
              projectName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeCodeCoverages: {
          input: {
            type: "structure",
            required: [
              "reportArn"
            ],
            members: {
              reportArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              sortOrder: {},
              sortBy: {},
              minLineCoveragePercentage: {
                type: "double"
              },
              maxLineCoveragePercentage: {
                type: "double"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              codeCoverages: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    reportARN: {},
                    filePath: {},
                    lineCoveragePercentage: {
                      type: "double"
                    },
                    linesCovered: {
                      type: "integer"
                    },
                    linesMissed: {
                      type: "integer"
                    },
                    branchCoveragePercentage: {
                      type: "double"
                    },
                    branchesCovered: {
                      type: "integer"
                    },
                    branchesMissed: {
                      type: "integer"
                    },
                    expired: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeTestCases: {
          input: {
            type: "structure",
            required: [
              "reportArn"
            ],
            members: {
              reportArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filter: {
                type: "structure",
                members: {
                  status: {},
                  keyword: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              testCases: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    reportArn: {},
                    testRawDataPath: {},
                    prefix: {},
                    name: {},
                    status: {},
                    durationInNanoSeconds: {
                      type: "long"
                    },
                    message: {},
                    expired: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        GetReportGroupTrend: {
          input: {
            type: "structure",
            required: [
              "reportGroupArn",
              "trendField"
            ],
            members: {
              reportGroupArn: {},
              numOfReports: {
                type: "integer"
              },
              trendField: {}
            }
          },
          output: {
            type: "structure",
            members: {
              stats: {
                type: "structure",
                members: {
                  average: {},
                  max: {},
                  min: {}
                }
              },
              rawData: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    reportArn: {},
                    data: {}
                  }
                }
              }
            }
          }
        },
        GetResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              policy: {}
            }
          }
        },
        ImportSourceCredentials: {
          input: {
            type: "structure",
            required: [
              "token",
              "serverType",
              "authType"
            ],
            members: {
              username: {},
              token: {
                type: "string",
                sensitive: true
              },
              serverType: {},
              authType: {},
              shouldOverwrite: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {}
            }
          }
        },
        InvalidateProjectCache: {
          input: {
            type: "structure",
            required: [
              "projectName"
            ],
            members: {
              projectName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ListBuildBatches: {
          input: {
            type: "structure",
            members: {
              filter: {
                shape: "S50"
              },
              maxResults: {
                type: "integer"
              },
              sortOrder: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ids: {
                shape: "S9"
              },
              nextToken: {}
            }
          }
        },
        ListBuildBatchesForProject: {
          input: {
            type: "structure",
            members: {
              projectName: {},
              filter: {
                shape: "S50"
              },
              maxResults: {
                type: "integer"
              },
              sortOrder: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ids: {
                shape: "S9"
              },
              nextToken: {}
            }
          }
        },
        ListBuilds: {
          input: {
            type: "structure",
            members: {
              sortOrder: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ids: {
                shape: "S2"
              },
              nextToken: {}
            }
          }
        },
        ListBuildsForProject: {
          input: {
            type: "structure",
            required: [
              "projectName"
            ],
            members: {
              projectName: {},
              sortOrder: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ids: {
                shape: "S2"
              },
              nextToken: {}
            }
          }
        },
        ListCuratedEnvironmentImages: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              platforms: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    platform: {},
                    languages: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          language: {},
                          images: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                name: {},
                                description: {},
                                versions: {
                                  type: "list",
                                  member: {}
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        ListProjects: {
          input: {
            type: "structure",
            members: {
              sortBy: {},
              sortOrder: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              projects: {
                shape: "S2e"
              }
            }
          }
        },
        ListReportGroups: {
          input: {
            type: "structure",
            members: {
              sortOrder: {},
              sortBy: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              reportGroups: {
                shape: "S32"
              }
            }
          }
        },
        ListReports: {
          input: {
            type: "structure",
            members: {
              sortOrder: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filter: {
                shape: "S5q"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              reports: {
                shape: "S3e"
              }
            }
          }
        },
        ListReportsForReportGroup: {
          input: {
            type: "structure",
            required: [
              "reportGroupArn"
            ],
            members: {
              reportGroupArn: {},
              nextToken: {},
              sortOrder: {},
              maxResults: {
                type: "integer"
              },
              filter: {
                shape: "S5q"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              reports: {
                shape: "S3e"
              }
            }
          }
        },
        ListSharedProjects: {
          input: {
            type: "structure",
            members: {
              sortBy: {},
              sortOrder: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              projects: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ListSharedReportGroups: {
          input: {
            type: "structure",
            members: {
              sortOrder: {},
              sortBy: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              reportGroups: {
                shape: "S32"
              }
            }
          }
        },
        ListSourceCredentials: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              sourceCredentialsInfos: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    serverType: {},
                    authType: {}
                  }
                }
              }
            }
          }
        },
        PutResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "policy",
              "resourceArn"
            ],
            members: {
              policy: {},
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              resourceArn: {}
            }
          }
        },
        RetryBuild: {
          input: {
            type: "structure",
            members: {
              id: {},
              idempotencyToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              build: {
                shape: "S23"
              }
            }
          }
        },
        RetryBuildBatch: {
          input: {
            type: "structure",
            members: {
              id: {},
              idempotencyToken: {},
              retryType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              buildBatch: {
                shape: "Sc"
              }
            }
          }
        },
        StartBuild: {
          input: {
            type: "structure",
            required: [
              "projectName"
            ],
            members: {
              projectName: {},
              secondarySourcesOverride: {
                shape: "St"
              },
              secondarySourcesVersionOverride: {
                shape: "Su"
              },
              sourceVersion: {},
              artifactsOverride: {
                shape: "S2k"
              },
              secondaryArtifactsOverride: {
                shape: "S2n"
              },
              environmentVariablesOverride: {
                shape: "S16"
              },
              sourceTypeOverride: {},
              sourceLocationOverride: {},
              sourceAuthOverride: {
                shape: "Sq"
              },
              gitCloneDepthOverride: {
                type: "integer"
              },
              gitSubmodulesConfigOverride: {
                shape: "So"
              },
              buildspecOverride: {},
              insecureSslOverride: {
                type: "boolean"
              },
              reportBuildStatusOverride: {
                type: "boolean"
              },
              buildStatusConfigOverride: {
                shape: "Ss"
              },
              environmentTypeOverride: {},
              imageOverride: {},
              computeTypeOverride: {},
              certificateOverride: {},
              cacheOverride: {
                shape: "Sz"
              },
              serviceRoleOverride: {},
              privilegedModeOverride: {
                type: "boolean"
              },
              timeoutInMinutesOverride: {
                type: "integer"
              },
              queuedTimeoutInMinutesOverride: {
                type: "integer"
              },
              encryptionKeyOverride: {},
              idempotencyToken: {},
              logsConfigOverride: {
                shape: "S1c"
              },
              registryCredentialOverride: {
                shape: "S19"
              },
              imagePullCredentialsTypeOverride: {},
              debugSessionEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              build: {
                shape: "S23"
              }
            }
          }
        },
        StartBuildBatch: {
          input: {
            type: "structure",
            required: [
              "projectName"
            ],
            members: {
              projectName: {},
              secondarySourcesOverride: {
                shape: "St"
              },
              secondarySourcesVersionOverride: {
                shape: "Su"
              },
              sourceVersion: {},
              artifactsOverride: {
                shape: "S2k"
              },
              secondaryArtifactsOverride: {
                shape: "S2n"
              },
              environmentVariablesOverride: {
                shape: "S16"
              },
              sourceTypeOverride: {},
              sourceLocationOverride: {},
              sourceAuthOverride: {
                shape: "Sq"
              },
              gitCloneDepthOverride: {
                type: "integer"
              },
              gitSubmodulesConfigOverride: {
                shape: "So"
              },
              buildspecOverride: {},
              insecureSslOverride: {
                type: "boolean"
              },
              reportBuildBatchStatusOverride: {
                type: "boolean"
              },
              environmentTypeOverride: {},
              imageOverride: {},
              computeTypeOverride: {},
              certificateOverride: {},
              cacheOverride: {
                shape: "Sz"
              },
              serviceRoleOverride: {},
              privilegedModeOverride: {
                type: "boolean"
              },
              buildTimeoutInMinutesOverride: {
                type: "integer"
              },
              queuedTimeoutInMinutesOverride: {
                type: "integer"
              },
              encryptionKeyOverride: {},
              idempotencyToken: {},
              logsConfigOverride: {
                shape: "S1c"
              },
              registryCredentialOverride: {
                shape: "S19"
              },
              imagePullCredentialsTypeOverride: {},
              buildBatchConfigOverride: {
                shape: "S1o"
              },
              debugSessionEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              buildBatch: {
                shape: "Sc"
              }
            }
          }
        },
        StopBuild: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              build: {
                shape: "S23"
              }
            }
          }
        },
        StopBuildBatch: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              buildBatch: {
                shape: "Sc"
              }
            }
          }
        },
        UpdateProject: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              description: {},
              source: {
                shape: "Sl"
              },
              secondarySources: {
                shape: "St"
              },
              sourceVersion: {},
              secondarySourceVersions: {
                shape: "Su"
              },
              artifacts: {
                shape: "S2k"
              },
              secondaryArtifacts: {
                shape: "S2n"
              },
              cache: {
                shape: "Sz"
              },
              environment: {
                shape: "S13"
              },
              serviceRole: {},
              timeoutInMinutes: {
                type: "integer"
              },
              queuedTimeoutInMinutes: {
                type: "integer"
              },
              encryptionKey: {},
              tags: {
                shape: "S2p"
              },
              vpcConfig: {
                shape: "S1i"
              },
              badgeEnabled: {
                type: "boolean"
              },
              logsConfig: {
                shape: "S1c"
              },
              fileSystemLocations: {
                shape: "S1l"
              },
              buildBatchConfig: {
                shape: "S1o"
              },
              concurrentBuildLimit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              project: {
                shape: "S2h"
              }
            }
          }
        },
        UpdateProjectVisibility: {
          input: {
            type: "structure",
            required: [
              "projectArn",
              "projectVisibility"
            ],
            members: {
              projectArn: {},
              projectVisibility: {},
              resourceAccessRole: {}
            }
          },
          output: {
            type: "structure",
            members: {
              projectArn: {},
              publicProjectAlias: {},
              projectVisibility: {}
            }
          }
        },
        UpdateReportGroup: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              exportConfig: {
                shape: "S38"
              },
              tags: {
                shape: "S2p"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              reportGroup: {
                shape: "S35"
              }
            }
          }
        },
        UpdateWebhook: {
          input: {
            type: "structure",
            required: [
              "projectName"
            ],
            members: {
              projectName: {},
              branchFilter: {},
              rotateSecret: {
                type: "boolean"
              },
              filterGroups: {
                shape: "S2u"
              },
              buildType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              webhook: {
                shape: "S2t"
              }
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "list",
          member: {}
        },
        S5: {
          type: "list",
          member: {
            type: "structure",
            members: {
              id: {},
              statusCode: {}
            }
          }
        },
        S9: {
          type: "list",
          member: {}
        },
        Sc: {
          type: "structure",
          members: {
            id: {},
            arn: {},
            startTime: {
              type: "timestamp"
            },
            endTime: {
              type: "timestamp"
            },
            currentPhase: {},
            buildBatchStatus: {},
            sourceVersion: {},
            resolvedSourceVersion: {},
            projectName: {},
            phases: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  phaseType: {},
                  phaseStatus: {},
                  startTime: {
                    type: "timestamp"
                  },
                  endTime: {
                    type: "timestamp"
                  },
                  durationInSeconds: {
                    type: "long"
                  },
                  contexts: {
                    shape: "Sj"
                  }
                }
              }
            },
            source: {
              shape: "Sl"
            },
            secondarySources: {
              shape: "St"
            },
            secondarySourceVersions: {
              shape: "Su"
            },
            artifacts: {
              shape: "Sw"
            },
            secondaryArtifacts: {
              shape: "Sy"
            },
            cache: {
              shape: "Sz"
            },
            environment: {
              shape: "S13"
            },
            serviceRole: {},
            logConfig: {
              shape: "S1c"
            },
            buildTimeoutInMinutes: {
              type: "integer"
            },
            queuedTimeoutInMinutes: {
              type: "integer"
            },
            complete: {
              type: "boolean"
            },
            initiator: {},
            vpcConfig: {
              shape: "S1i"
            },
            encryptionKey: {},
            buildBatchNumber: {
              type: "long"
            },
            fileSystemLocations: {
              shape: "S1l"
            },
            buildBatchConfig: {
              shape: "S1o"
            },
            buildGroups: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  identifier: {},
                  dependsOn: {
                    type: "list",
                    member: {}
                  },
                  ignoreFailure: {
                    type: "boolean"
                  },
                  currentBuildSummary: {
                    shape: "S1v"
                  },
                  priorBuildSummaryList: {
                    type: "list",
                    member: {
                      shape: "S1v"
                    }
                  }
                }
              }
            },
            debugSessionEnabled: {
              type: "boolean"
            }
          }
        },
        Sj: {
          type: "list",
          member: {
            type: "structure",
            members: {
              statusCode: {},
              message: {}
            }
          }
        },
        Sl: {
          type: "structure",
          required: [
            "type"
          ],
          members: {
            type: {},
            location: {},
            gitCloneDepth: {
              type: "integer"
            },
            gitSubmodulesConfig: {
              shape: "So"
            },
            buildspec: {},
            auth: {
              shape: "Sq"
            },
            reportBuildStatus: {
              type: "boolean"
            },
            buildStatusConfig: {
              shape: "Ss"
            },
            insecureSsl: {
              type: "boolean"
            },
            sourceIdentifier: {}
          }
        },
        So: {
          type: "structure",
          required: [
            "fetchSubmodules"
          ],
          members: {
            fetchSubmodules: {
              type: "boolean"
            }
          }
        },
        Sq: {
          type: "structure",
          required: [
            "type"
          ],
          members: {
            type: {},
            resource: {}
          }
        },
        Ss: {
          type: "structure",
          members: {
            context: {},
            targetUrl: {}
          }
        },
        St: {
          type: "list",
          member: {
            shape: "Sl"
          }
        },
        Su: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "sourceIdentifier",
              "sourceVersion"
            ],
            members: {
              sourceIdentifier: {},
              sourceVersion: {}
            }
          }
        },
        Sw: {
          type: "structure",
          members: {
            location: {},
            sha256sum: {},
            md5sum: {},
            overrideArtifactName: {
              type: "boolean"
            },
            encryptionDisabled: {
              type: "boolean"
            },
            artifactIdentifier: {},
            bucketOwnerAccess: {}
          }
        },
        Sy: {
          type: "list",
          member: {
            shape: "Sw"
          }
        },
        Sz: {
          type: "structure",
          required: [
            "type"
          ],
          members: {
            type: {},
            location: {},
            modes: {
              type: "list",
              member: {}
            }
          }
        },
        S13: {
          type: "structure",
          required: [
            "type",
            "image",
            "computeType"
          ],
          members: {
            type: {},
            image: {},
            computeType: {},
            environmentVariables: {
              shape: "S16"
            },
            privilegedMode: {
              type: "boolean"
            },
            certificate: {},
            registryCredential: {
              shape: "S19"
            },
            imagePullCredentialsType: {}
          }
        },
        S16: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "value"
            ],
            members: {
              name: {},
              value: {},
              type: {}
            }
          }
        },
        S19: {
          type: "structure",
          required: [
            "credential",
            "credentialProvider"
          ],
          members: {
            credential: {},
            credentialProvider: {}
          }
        },
        S1c: {
          type: "structure",
          members: {
            cloudWatchLogs: {
              shape: "S1d"
            },
            s3Logs: {
              shape: "S1f"
            }
          }
        },
        S1d: {
          type: "structure",
          required: [
            "status"
          ],
          members: {
            status: {},
            groupName: {},
            streamName: {}
          }
        },
        S1f: {
          type: "structure",
          required: [
            "status"
          ],
          members: {
            status: {},
            location: {},
            encryptionDisabled: {
              type: "boolean"
            },
            bucketOwnerAccess: {}
          }
        },
        S1i: {
          type: "structure",
          members: {
            vpcId: {},
            subnets: {
              type: "list",
              member: {}
            },
            securityGroupIds: {
              type: "list",
              member: {}
            }
          }
        },
        S1l: {
          type: "list",
          member: {
            type: "structure",
            members: {
              type: {},
              location: {},
              mountPoint: {},
              identifier: {},
              mountOptions: {}
            }
          }
        },
        S1o: {
          type: "structure",
          members: {
            serviceRole: {},
            combineArtifacts: {
              type: "boolean"
            },
            restrictions: {
              type: "structure",
              members: {
                maximumBuildsAllowed: {
                  type: "integer"
                },
                computeTypesAllowed: {
                  type: "list",
                  member: {}
                }
              }
            },
            timeoutInMins: {
              type: "integer"
            },
            batchReportMode: {}
          }
        },
        S1v: {
          type: "structure",
          members: {
            arn: {},
            requestedOn: {
              type: "timestamp"
            },
            buildStatus: {},
            primaryArtifact: {
              shape: "S1w"
            },
            secondaryArtifacts: {
              type: "list",
              member: {
                shape: "S1w"
              }
            }
          }
        },
        S1w: {
          type: "structure",
          members: {
            type: {},
            location: {},
            identifier: {}
          }
        },
        S23: {
          type: "structure",
          members: {
            id: {},
            arn: {},
            buildNumber: {
              type: "long"
            },
            startTime: {
              type: "timestamp"
            },
            endTime: {
              type: "timestamp"
            },
            currentPhase: {},
            buildStatus: {},
            sourceVersion: {},
            resolvedSourceVersion: {},
            projectName: {},
            phases: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  phaseType: {},
                  phaseStatus: {},
                  startTime: {
                    type: "timestamp"
                  },
                  endTime: {
                    type: "timestamp"
                  },
                  durationInSeconds: {
                    type: "long"
                  },
                  contexts: {
                    shape: "Sj"
                  }
                }
              }
            },
            source: {
              shape: "Sl"
            },
            secondarySources: {
              shape: "St"
            },
            secondarySourceVersions: {
              shape: "Su"
            },
            artifacts: {
              shape: "Sw"
            },
            secondaryArtifacts: {
              shape: "Sy"
            },
            cache: {
              shape: "Sz"
            },
            environment: {
              shape: "S13"
            },
            serviceRole: {},
            logs: {
              type: "structure",
              members: {
                groupName: {},
                streamName: {},
                deepLink: {},
                s3DeepLink: {},
                cloudWatchLogsArn: {},
                s3LogsArn: {},
                cloudWatchLogs: {
                  shape: "S1d"
                },
                s3Logs: {
                  shape: "S1f"
                }
              }
            },
            timeoutInMinutes: {
              type: "integer"
            },
            queuedTimeoutInMinutes: {
              type: "integer"
            },
            buildComplete: {
              type: "boolean"
            },
            initiator: {},
            vpcConfig: {
              shape: "S1i"
            },
            networkInterface: {
              type: "structure",
              members: {
                subnetId: {},
                networkInterfaceId: {}
              }
            },
            encryptionKey: {},
            exportedEnvironmentVariables: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  name: {},
                  value: {}
                }
              }
            },
            reportArns: {
              type: "list",
              member: {}
            },
            fileSystemLocations: {
              shape: "S1l"
            },
            debugSession: {
              type: "structure",
              members: {
                sessionEnabled: {
                  type: "boolean"
                },
                sessionTarget: {}
              }
            },
            buildBatchArn: {}
          }
        },
        S2e: {
          type: "list",
          member: {}
        },
        S2h: {
          type: "structure",
          members: {
            name: {},
            arn: {},
            description: {},
            source: {
              shape: "Sl"
            },
            secondarySources: {
              shape: "St"
            },
            sourceVersion: {},
            secondarySourceVersions: {
              shape: "Su"
            },
            artifacts: {
              shape: "S2k"
            },
            secondaryArtifacts: {
              shape: "S2n"
            },
            cache: {
              shape: "Sz"
            },
            environment: {
              shape: "S13"
            },
            serviceRole: {},
            timeoutInMinutes: {
              type: "integer"
            },
            queuedTimeoutInMinutes: {
              type: "integer"
            },
            encryptionKey: {},
            tags: {
              shape: "S2p"
            },
            created: {
              type: "timestamp"
            },
            lastModified: {
              type: "timestamp"
            },
            webhook: {
              shape: "S2t"
            },
            vpcConfig: {
              shape: "S1i"
            },
            badge: {
              type: "structure",
              members: {
                badgeEnabled: {
                  type: "boolean"
                },
                badgeRequestUrl: {}
              }
            },
            logsConfig: {
              shape: "S1c"
            },
            fileSystemLocations: {
              shape: "S1l"
            },
            buildBatchConfig: {
              shape: "S1o"
            },
            concurrentBuildLimit: {
              type: "integer"
            },
            projectVisibility: {},
            publicProjectAlias: {},
            resourceAccessRole: {}
          }
        },
        S2k: {
          type: "structure",
          required: [
            "type"
          ],
          members: {
            type: {},
            location: {},
            path: {},
            namespaceType: {},
            name: {},
            packaging: {},
            overrideArtifactName: {
              type: "boolean"
            },
            encryptionDisabled: {
              type: "boolean"
            },
            artifactIdentifier: {},
            bucketOwnerAccess: {}
          }
        },
        S2n: {
          type: "list",
          member: {
            shape: "S2k"
          }
        },
        S2p: {
          type: "list",
          member: {
            type: "structure",
            members: {
              key: {},
              value: {}
            }
          }
        },
        S2t: {
          type: "structure",
          members: {
            url: {},
            payloadUrl: {},
            secret: {},
            branchFilter: {},
            filterGroups: {
              shape: "S2u"
            },
            buildType: {},
            lastModifiedSecret: {
              type: "timestamp"
            }
          }
        },
        S2u: {
          type: "list",
          member: {
            type: "list",
            member: {
              type: "structure",
              required: [
                "type",
                "pattern"
              ],
              members: {
                type: {},
                pattern: {},
                excludeMatchedPattern: {
                  type: "boolean"
                }
              }
            }
          }
        },
        S32: {
          type: "list",
          member: {}
        },
        S35: {
          type: "structure",
          members: {
            arn: {},
            name: {},
            type: {},
            exportConfig: {
              shape: "S38"
            },
            created: {
              type: "timestamp"
            },
            lastModified: {
              type: "timestamp"
            },
            tags: {
              shape: "S2p"
            },
            status: {}
          }
        },
        S38: {
          type: "structure",
          members: {
            exportConfigType: {},
            s3Destination: {
              type: "structure",
              members: {
                bucket: {},
                bucketOwner: {},
                path: {},
                packaging: {},
                encryptionKey: {},
                encryptionDisabled: {
                  type: "boolean"
                }
              }
            }
          }
        },
        S3e: {
          type: "list",
          member: {}
        },
        S50: {
          type: "structure",
          members: {
            status: {}
          }
        },
        S5q: {
          type: "structure",
          members: {
            status: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/codebuild-2016-10-06.paginators.json
var require_codebuild_2016_10_06_paginators = __commonJS({
  "node_modules/aws-sdk/apis/codebuild-2016-10-06.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeCodeCoverages: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "codeCoverages"
        },
        DescribeTestCases: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "testCases"
        },
        ListBuildBatches: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "ids"
        },
        ListBuildBatchesForProject: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "ids"
        },
        ListBuilds: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "ids"
        },
        ListBuildsForProject: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "ids"
        },
        ListProjects: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "projects"
        },
        ListReportGroups: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "reportGroups"
        },
        ListReports: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "reports"
        },
        ListReportsForReportGroup: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "reports"
        },
        ListSharedProjects: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "projects"
        },
        ListSharedReportGroups: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "reportGroups"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/codebuild.js
var require_codebuild = __commonJS({
  "node_modules/aws-sdk/clients/codebuild.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["codebuild"] = {};
    AWS2.CodeBuild = Service.defineService("codebuild", ["2016-10-06"]);
    Object.defineProperty(apiLoader.services["codebuild"], "2016-10-06", {
      get: function get() {
        var model = require_codebuild_2016_10_06_min();
        model.paginators = require_codebuild_2016_10_06_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CodeBuild;
  }
});

// node_modules/aws-sdk/apis/codecommit-2015-04-13.min.json
var require_codecommit_2015_04_13_min = __commonJS({
  "node_modules/aws-sdk/apis/codecommit-2015-04-13.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-04-13",
        endpointPrefix: "codecommit",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "CodeCommit",
        serviceFullName: "AWS CodeCommit",
        serviceId: "CodeCommit",
        signatureVersion: "v4",
        targetPrefix: "CodeCommit_20150413",
        uid: "codecommit-2015-04-13"
      },
      operations: {
        AssociateApprovalRuleTemplateWithRepository: {
          input: {
            type: "structure",
            required: [
              "approvalRuleTemplateName",
              "repositoryName"
            ],
            members: {
              approvalRuleTemplateName: {},
              repositoryName: {}
            }
          }
        },
        BatchAssociateApprovalRuleTemplateWithRepositories: {
          input: {
            type: "structure",
            required: [
              "approvalRuleTemplateName",
              "repositoryNames"
            ],
            members: {
              approvalRuleTemplateName: {},
              repositoryNames: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "associatedRepositoryNames",
              "errors"
            ],
            members: {
              associatedRepositoryNames: {
                shape: "S5"
              },
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    repositoryName: {},
                    errorCode: {},
                    errorMessage: {}
                  }
                }
              }
            }
          }
        },
        BatchDescribeMergeConflicts: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "destinationCommitSpecifier",
              "sourceCommitSpecifier",
              "mergeOption"
            ],
            members: {
              repositoryName: {},
              destinationCommitSpecifier: {},
              sourceCommitSpecifier: {},
              mergeOption: {},
              maxMergeHunks: {
                type: "integer"
              },
              maxConflictFiles: {
                type: "integer"
              },
              filePaths: {
                type: "list",
                member: {}
              },
              conflictDetailLevel: {},
              conflictResolutionStrategy: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "conflicts",
              "destinationCommitId",
              "sourceCommitId"
            ],
            members: {
              conflicts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    conflictMetadata: {
                      shape: "Sn"
                    },
                    mergeHunks: {
                      shape: "S12"
                    }
                  }
                }
              },
              nextToken: {},
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "filePath",
                    "exceptionName",
                    "message"
                  ],
                  members: {
                    filePath: {},
                    exceptionName: {},
                    message: {}
                  }
                }
              },
              destinationCommitId: {},
              sourceCommitId: {},
              baseCommitId: {}
            }
          }
        },
        BatchDisassociateApprovalRuleTemplateFromRepositories: {
          input: {
            type: "structure",
            required: [
              "approvalRuleTemplateName",
              "repositoryNames"
            ],
            members: {
              approvalRuleTemplateName: {},
              repositoryNames: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "disassociatedRepositoryNames",
              "errors"
            ],
            members: {
              disassociatedRepositoryNames: {
                shape: "S5"
              },
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    repositoryName: {},
                    errorCode: {},
                    errorMessage: {}
                  }
                }
              }
            }
          }
        },
        BatchGetCommits: {
          input: {
            type: "structure",
            required: [
              "commitIds",
              "repositoryName"
            ],
            members: {
              commitIds: {
                type: "list",
                member: {}
              },
              repositoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              commits: {
                type: "list",
                member: {
                  shape: "S1l"
                }
              },
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    commitId: {},
                    errorCode: {},
                    errorMessage: {}
                  }
                }
              }
            }
          }
        },
        BatchGetRepositories: {
          input: {
            type: "structure",
            required: [
              "repositoryNames"
            ],
            members: {
              repositoryNames: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repositories: {
                type: "list",
                member: {
                  shape: "S1x"
                }
              },
              repositoriesNotFound: {
                type: "list",
                member: {}
              },
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    repositoryId: {},
                    repositoryName: {},
                    errorCode: {},
                    errorMessage: {}
                  }
                }
              }
            }
          }
        },
        CreateApprovalRuleTemplate: {
          input: {
            type: "structure",
            required: [
              "approvalRuleTemplateName",
              "approvalRuleTemplateContent"
            ],
            members: {
              approvalRuleTemplateName: {},
              approvalRuleTemplateContent: {},
              approvalRuleTemplateDescription: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "approvalRuleTemplate"
            ],
            members: {
              approvalRuleTemplate: {
                shape: "S2g"
              }
            }
          }
        },
        CreateBranch: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "branchName",
              "commitId"
            ],
            members: {
              repositoryName: {},
              branchName: {},
              commitId: {}
            }
          }
        },
        CreateCommit: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "branchName"
            ],
            members: {
              repositoryName: {},
              branchName: {},
              parentCommitId: {},
              authorName: {},
              email: {},
              commitMessage: {},
              keepEmptyFolders: {
                type: "boolean"
              },
              putFiles: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "filePath"
                  ],
                  members: {
                    filePath: {},
                    fileMode: {},
                    fileContent: {
                      type: "blob"
                    },
                    sourceFile: {
                      type: "structure",
                      required: [
                        "filePath"
                      ],
                      members: {
                        filePath: {},
                        isMove: {
                          type: "boolean"
                        }
                      }
                    }
                  }
                }
              },
              deleteFiles: {
                shape: "S2s"
              },
              setFileModes: {
                shape: "S2u"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              commitId: {},
              treeId: {},
              filesAdded: {
                shape: "S2x"
              },
              filesUpdated: {
                shape: "S2x"
              },
              filesDeleted: {
                shape: "S2x"
              }
            }
          }
        },
        CreatePullRequest: {
          input: {
            type: "structure",
            required: [
              "title",
              "targets"
            ],
            members: {
              title: {},
              description: {},
              targets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "repositoryName",
                    "sourceReference"
                  ],
                  members: {
                    repositoryName: {},
                    sourceReference: {},
                    destinationReference: {}
                  }
                }
              },
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "pullRequest"
            ],
            members: {
              pullRequest: {
                shape: "S37"
              }
            }
          }
        },
        CreatePullRequestApprovalRule: {
          input: {
            type: "structure",
            required: [
              "pullRequestId",
              "approvalRuleName",
              "approvalRuleContent"
            ],
            members: {
              pullRequestId: {},
              approvalRuleName: {},
              approvalRuleContent: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "approvalRule"
            ],
            members: {
              approvalRule: {
                shape: "S3g"
              }
            }
          }
        },
        CreateRepository: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              repositoryName: {},
              repositoryDescription: {},
              tags: {
                shape: "S3o"
              },
              kmsKeyId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              repositoryMetadata: {
                shape: "S1x"
              }
            }
          }
        },
        CreateUnreferencedMergeCommit: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "sourceCommitSpecifier",
              "destinationCommitSpecifier",
              "mergeOption"
            ],
            members: {
              repositoryName: {},
              sourceCommitSpecifier: {},
              destinationCommitSpecifier: {},
              mergeOption: {},
              conflictDetailLevel: {},
              conflictResolutionStrategy: {},
              authorName: {},
              email: {},
              commitMessage: {},
              keepEmptyFolders: {
                type: "boolean"
              },
              conflictResolution: {
                shape: "S3t"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              commitId: {},
              treeId: {}
            }
          }
        },
        DeleteApprovalRuleTemplate: {
          input: {
            type: "structure",
            required: [
              "approvalRuleTemplateName"
            ],
            members: {
              approvalRuleTemplateName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "approvalRuleTemplateId"
            ],
            members: {
              approvalRuleTemplateId: {}
            }
          }
        },
        DeleteBranch: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "branchName"
            ],
            members: {
              repositoryName: {},
              branchName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deletedBranch: {
                shape: "S42"
              }
            }
          }
        },
        DeleteCommentContent: {
          input: {
            type: "structure",
            required: [
              "commentId"
            ],
            members: {
              commentId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              comment: {
                shape: "S46"
              }
            }
          }
        },
        DeleteFile: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "branchName",
              "filePath",
              "parentCommitId"
            ],
            members: {
              repositoryName: {},
              branchName: {},
              filePath: {},
              parentCommitId: {},
              keepEmptyFolders: {
                type: "boolean"
              },
              commitMessage: {},
              name: {},
              email: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "commitId",
              "blobId",
              "treeId",
              "filePath"
            ],
            members: {
              commitId: {},
              blobId: {},
              treeId: {},
              filePath: {}
            }
          }
        },
        DeletePullRequestApprovalRule: {
          input: {
            type: "structure",
            required: [
              "pullRequestId",
              "approvalRuleName"
            ],
            members: {
              pullRequestId: {},
              approvalRuleName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "approvalRuleId"
            ],
            members: {
              approvalRuleId: {}
            }
          }
        },
        DeleteRepository: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              repositoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              repositoryId: {}
            }
          }
        },
        DescribeMergeConflicts: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "destinationCommitSpecifier",
              "sourceCommitSpecifier",
              "mergeOption",
              "filePath"
            ],
            members: {
              repositoryName: {},
              destinationCommitSpecifier: {},
              sourceCommitSpecifier: {},
              mergeOption: {},
              maxMergeHunks: {
                type: "integer"
              },
              filePath: {},
              conflictDetailLevel: {},
              conflictResolutionStrategy: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "conflictMetadata",
              "mergeHunks",
              "destinationCommitId",
              "sourceCommitId"
            ],
            members: {
              conflictMetadata: {
                shape: "Sn"
              },
              mergeHunks: {
                shape: "S12"
              },
              nextToken: {},
              destinationCommitId: {},
              sourceCommitId: {},
              baseCommitId: {}
            }
          }
        },
        DescribePullRequestEvents: {
          input: {
            type: "structure",
            required: [
              "pullRequestId"
            ],
            members: {
              pullRequestId: {},
              pullRequestEventType: {},
              actorArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "pullRequestEvents"
            ],
            members: {
              pullRequestEvents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    pullRequestId: {},
                    eventDate: {
                      type: "timestamp"
                    },
                    pullRequestEventType: {},
                    actorArn: {},
                    pullRequestCreatedEventMetadata: {
                      type: "structure",
                      members: {
                        repositoryName: {},
                        sourceCommitId: {},
                        destinationCommitId: {},
                        mergeBase: {}
                      }
                    },
                    pullRequestStatusChangedEventMetadata: {
                      type: "structure",
                      members: {
                        pullRequestStatus: {}
                      }
                    },
                    pullRequestSourceReferenceUpdatedEventMetadata: {
                      type: "structure",
                      members: {
                        repositoryName: {},
                        beforeCommitId: {},
                        afterCommitId: {},
                        mergeBase: {}
                      }
                    },
                    pullRequestMergedStateChangedEventMetadata: {
                      type: "structure",
                      members: {
                        repositoryName: {},
                        destinationReference: {},
                        mergeMetadata: {
                          shape: "S3c"
                        }
                      }
                    },
                    approvalRuleEventMetadata: {
                      type: "structure",
                      members: {
                        approvalRuleName: {},
                        approvalRuleId: {},
                        approvalRuleContent: {}
                      }
                    },
                    approvalStateChangedEventMetadata: {
                      type: "structure",
                      members: {
                        revisionId: {},
                        approvalStatus: {}
                      }
                    },
                    approvalRuleOverriddenEventMetadata: {
                      type: "structure",
                      members: {
                        revisionId: {},
                        overrideStatus: {}
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DisassociateApprovalRuleTemplateFromRepository: {
          input: {
            type: "structure",
            required: [
              "approvalRuleTemplateName",
              "repositoryName"
            ],
            members: {
              approvalRuleTemplateName: {},
              repositoryName: {}
            }
          }
        },
        EvaluatePullRequestApprovalRules: {
          input: {
            type: "structure",
            required: [
              "pullRequestId",
              "revisionId"
            ],
            members: {
              pullRequestId: {},
              revisionId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "evaluation"
            ],
            members: {
              evaluation: {
                type: "structure",
                members: {
                  approved: {
                    type: "boolean"
                  },
                  overridden: {
                    type: "boolean"
                  },
                  approvalRulesSatisfied: {
                    type: "list",
                    member: {}
                  },
                  approvalRulesNotSatisfied: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          }
        },
        GetApprovalRuleTemplate: {
          input: {
            type: "structure",
            required: [
              "approvalRuleTemplateName"
            ],
            members: {
              approvalRuleTemplateName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "approvalRuleTemplate"
            ],
            members: {
              approvalRuleTemplate: {
                shape: "S2g"
              }
            }
          }
        },
        GetBlob: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "blobId"
            ],
            members: {
              repositoryName: {},
              blobId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "content"
            ],
            members: {
              content: {
                type: "blob"
              }
            }
          }
        },
        GetBranch: {
          input: {
            type: "structure",
            members: {
              repositoryName: {},
              branchName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              branch: {
                shape: "S42"
              }
            }
          }
        },
        GetComment: {
          input: {
            type: "structure",
            required: [
              "commentId"
            ],
            members: {
              commentId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              comment: {
                shape: "S46"
              }
            }
          }
        },
        GetCommentReactions: {
          input: {
            type: "structure",
            required: [
              "commentId"
            ],
            members: {
              commentId: {},
              reactionUserArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "reactionsForComment"
            ],
            members: {
              reactionsForComment: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    reaction: {
                      type: "structure",
                      members: {
                        emoji: {},
                        shortCode: {},
                        unicode: {}
                      }
                    },
                    reactionUsers: {
                      type: "list",
                      member: {}
                    },
                    reactionsFromDeletedUsersCount: {
                      type: "integer"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetCommentsForComparedCommit: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "afterCommitId"
            ],
            members: {
              repositoryName: {},
              beforeCommitId: {},
              afterCommitId: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              commentsForComparedCommitData: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    repositoryName: {},
                    beforeCommitId: {},
                    afterCommitId: {},
                    beforeBlobId: {},
                    afterBlobId: {},
                    location: {
                      shape: "S5u"
                    },
                    comments: {
                      shape: "S5x"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetCommentsForPullRequest: {
          input: {
            type: "structure",
            required: [
              "pullRequestId"
            ],
            members: {
              pullRequestId: {},
              repositoryName: {},
              beforeCommitId: {},
              afterCommitId: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              commentsForPullRequestData: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    pullRequestId: {},
                    repositoryName: {},
                    beforeCommitId: {},
                    afterCommitId: {},
                    beforeBlobId: {},
                    afterBlobId: {},
                    location: {
                      shape: "S5u"
                    },
                    comments: {
                      shape: "S5x"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetCommit: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "commitId"
            ],
            members: {
              repositoryName: {},
              commitId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "commit"
            ],
            members: {
              commit: {
                shape: "S1l"
              }
            }
          }
        },
        GetDifferences: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "afterCommitSpecifier"
            ],
            members: {
              repositoryName: {},
              beforeCommitSpecifier: {},
              afterCommitSpecifier: {},
              beforePath: {},
              afterPath: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              differences: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    beforeBlob: {
                      shape: "S69"
                    },
                    afterBlob: {
                      shape: "S69"
                    },
                    changeType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetFile: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "filePath"
            ],
            members: {
              repositoryName: {},
              commitSpecifier: {},
              filePath: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "commitId",
              "blobId",
              "filePath",
              "fileMode",
              "fileSize",
              "fileContent"
            ],
            members: {
              commitId: {},
              blobId: {},
              filePath: {},
              fileMode: {},
              fileSize: {
                type: "long"
              },
              fileContent: {
                type: "blob"
              }
            }
          }
        },
        GetFolder: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "folderPath"
            ],
            members: {
              repositoryName: {},
              commitSpecifier: {},
              folderPath: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "commitId",
              "folderPath"
            ],
            members: {
              commitId: {},
              folderPath: {},
              treeId: {},
              subFolders: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    treeId: {},
                    absolutePath: {},
                    relativePath: {}
                  }
                }
              },
              files: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    blobId: {},
                    absolutePath: {},
                    relativePath: {},
                    fileMode: {}
                  }
                }
              },
              symbolicLinks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    blobId: {},
                    absolutePath: {},
                    relativePath: {},
                    fileMode: {}
                  }
                }
              },
              subModules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    commitId: {},
                    absolutePath: {},
                    relativePath: {}
                  }
                }
              }
            }
          }
        },
        GetMergeCommit: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "sourceCommitSpecifier",
              "destinationCommitSpecifier"
            ],
            members: {
              repositoryName: {},
              sourceCommitSpecifier: {},
              destinationCommitSpecifier: {},
              conflictDetailLevel: {},
              conflictResolutionStrategy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              sourceCommitId: {},
              destinationCommitId: {},
              baseCommitId: {},
              mergedCommitId: {}
            }
          }
        },
        GetMergeConflicts: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "destinationCommitSpecifier",
              "sourceCommitSpecifier",
              "mergeOption"
            ],
            members: {
              repositoryName: {},
              destinationCommitSpecifier: {},
              sourceCommitSpecifier: {},
              mergeOption: {},
              conflictDetailLevel: {},
              maxConflictFiles: {
                type: "integer"
              },
              conflictResolutionStrategy: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "mergeable",
              "destinationCommitId",
              "sourceCommitId",
              "conflictMetadataList"
            ],
            members: {
              mergeable: {
                type: "boolean"
              },
              destinationCommitId: {},
              sourceCommitId: {},
              baseCommitId: {},
              conflictMetadataList: {
                type: "list",
                member: {
                  shape: "Sn"
                }
              },
              nextToken: {}
            }
          }
        },
        GetMergeOptions: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "sourceCommitSpecifier",
              "destinationCommitSpecifier"
            ],
            members: {
              repositoryName: {},
              sourceCommitSpecifier: {},
              destinationCommitSpecifier: {},
              conflictDetailLevel: {},
              conflictResolutionStrategy: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "mergeOptions",
              "sourceCommitId",
              "destinationCommitId",
              "baseCommitId"
            ],
            members: {
              mergeOptions: {
                type: "list",
                member: {}
              },
              sourceCommitId: {},
              destinationCommitId: {},
              baseCommitId: {}
            }
          }
        },
        GetPullRequest: {
          input: {
            type: "structure",
            required: [
              "pullRequestId"
            ],
            members: {
              pullRequestId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "pullRequest"
            ],
            members: {
              pullRequest: {
                shape: "S37"
              }
            }
          }
        },
        GetPullRequestApprovalStates: {
          input: {
            type: "structure",
            required: [
              "pullRequestId",
              "revisionId"
            ],
            members: {
              pullRequestId: {},
              revisionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              approvals: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    userArn: {},
                    approvalState: {}
                  }
                }
              }
            }
          }
        },
        GetPullRequestOverrideState: {
          input: {
            type: "structure",
            required: [
              "pullRequestId",
              "revisionId"
            ],
            members: {
              pullRequestId: {},
              revisionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              overridden: {
                type: "boolean"
              },
              overrider: {}
            }
          }
        },
        GetRepository: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              repositoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              repositoryMetadata: {
                shape: "S1x"
              }
            }
          }
        },
        GetRepositoryTriggers: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              repositoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              configurationId: {},
              triggers: {
                shape: "S7a"
              }
            }
          }
        },
        ListApprovalRuleTemplates: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              approvalRuleTemplateNames: {
                shape: "S7j"
              },
              nextToken: {}
            }
          }
        },
        ListAssociatedApprovalRuleTemplatesForRepository: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              repositoryName: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              approvalRuleTemplateNames: {
                shape: "S7j"
              },
              nextToken: {}
            }
          }
        },
        ListBranches: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              repositoryName: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              branches: {
                shape: "S7e"
              },
              nextToken: {}
            }
          }
        },
        ListFileCommitHistory: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "filePath"
            ],
            members: {
              repositoryName: {},
              commitSpecifier: {},
              filePath: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "revisionDag"
            ],
            members: {
              revisionDag: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    commit: {
                      shape: "S1l"
                    },
                    blobId: {},
                    path: {},
                    revisionChildren: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListPullRequests: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              repositoryName: {},
              authorArn: {},
              pullRequestStatus: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "pullRequestIds"
            ],
            members: {
              pullRequestIds: {
                type: "list",
                member: {}
              },
              nextToken: {}
            }
          }
        },
        ListRepositories: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              sortBy: {},
              order: {}
            }
          },
          output: {
            type: "structure",
            members: {
              repositories: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    repositoryName: {},
                    repositoryId: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListRepositoriesForApprovalRuleTemplate: {
          input: {
            type: "structure",
            required: [
              "approvalRuleTemplateName"
            ],
            members: {
              approvalRuleTemplateName: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repositoryNames: {
                shape: "S5"
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S3o"
              },
              nextToken: {}
            }
          }
        },
        MergeBranchesByFastForward: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "sourceCommitSpecifier",
              "destinationCommitSpecifier"
            ],
            members: {
              repositoryName: {},
              sourceCommitSpecifier: {},
              destinationCommitSpecifier: {},
              targetBranch: {}
            }
          },
          output: {
            type: "structure",
            members: {
              commitId: {},
              treeId: {}
            }
          }
        },
        MergeBranchesBySquash: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "sourceCommitSpecifier",
              "destinationCommitSpecifier"
            ],
            members: {
              repositoryName: {},
              sourceCommitSpecifier: {},
              destinationCommitSpecifier: {},
              targetBranch: {},
              conflictDetailLevel: {},
              conflictResolutionStrategy: {},
              authorName: {},
              email: {},
              commitMessage: {},
              keepEmptyFolders: {
                type: "boolean"
              },
              conflictResolution: {
                shape: "S3t"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              commitId: {},
              treeId: {}
            }
          }
        },
        MergeBranchesByThreeWay: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "sourceCommitSpecifier",
              "destinationCommitSpecifier"
            ],
            members: {
              repositoryName: {},
              sourceCommitSpecifier: {},
              destinationCommitSpecifier: {},
              targetBranch: {},
              conflictDetailLevel: {},
              conflictResolutionStrategy: {},
              authorName: {},
              email: {},
              commitMessage: {},
              keepEmptyFolders: {
                type: "boolean"
              },
              conflictResolution: {
                shape: "S3t"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              commitId: {},
              treeId: {}
            }
          }
        },
        MergePullRequestByFastForward: {
          input: {
            type: "structure",
            required: [
              "pullRequestId",
              "repositoryName"
            ],
            members: {
              pullRequestId: {},
              repositoryName: {},
              sourceCommitId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              pullRequest: {
                shape: "S37"
              }
            }
          }
        },
        MergePullRequestBySquash: {
          input: {
            type: "structure",
            required: [
              "pullRequestId",
              "repositoryName"
            ],
            members: {
              pullRequestId: {},
              repositoryName: {},
              sourceCommitId: {},
              conflictDetailLevel: {},
              conflictResolutionStrategy: {},
              commitMessage: {},
              authorName: {},
              email: {},
              keepEmptyFolders: {
                type: "boolean"
              },
              conflictResolution: {
                shape: "S3t"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              pullRequest: {
                shape: "S37"
              }
            }
          }
        },
        MergePullRequestByThreeWay: {
          input: {
            type: "structure",
            required: [
              "pullRequestId",
              "repositoryName"
            ],
            members: {
              pullRequestId: {},
              repositoryName: {},
              sourceCommitId: {},
              conflictDetailLevel: {},
              conflictResolutionStrategy: {},
              commitMessage: {},
              authorName: {},
              email: {},
              keepEmptyFolders: {
                type: "boolean"
              },
              conflictResolution: {
                shape: "S3t"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              pullRequest: {
                shape: "S37"
              }
            }
          }
        },
        OverridePullRequestApprovalRules: {
          input: {
            type: "structure",
            required: [
              "pullRequestId",
              "revisionId",
              "overrideStatus"
            ],
            members: {
              pullRequestId: {},
              revisionId: {},
              overrideStatus: {}
            }
          }
        },
        PostCommentForComparedCommit: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "afterCommitId",
              "content"
            ],
            members: {
              repositoryName: {},
              beforeCommitId: {},
              afterCommitId: {},
              location: {
                shape: "S5u"
              },
              content: {},
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repositoryName: {},
              beforeCommitId: {},
              afterCommitId: {},
              beforeBlobId: {},
              afterBlobId: {},
              location: {
                shape: "S5u"
              },
              comment: {
                shape: "S46"
              }
            }
          },
          idempotent: true
        },
        PostCommentForPullRequest: {
          input: {
            type: "structure",
            required: [
              "pullRequestId",
              "repositoryName",
              "beforeCommitId",
              "afterCommitId",
              "content"
            ],
            members: {
              pullRequestId: {},
              repositoryName: {},
              beforeCommitId: {},
              afterCommitId: {},
              location: {
                shape: "S5u"
              },
              content: {},
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repositoryName: {},
              pullRequestId: {},
              beforeCommitId: {},
              afterCommitId: {},
              beforeBlobId: {},
              afterBlobId: {},
              location: {
                shape: "S5u"
              },
              comment: {
                shape: "S46"
              }
            }
          },
          idempotent: true
        },
        PostCommentReply: {
          input: {
            type: "structure",
            required: [
              "inReplyTo",
              "content"
            ],
            members: {
              inReplyTo: {},
              clientRequestToken: {
                idempotencyToken: true
              },
              content: {}
            }
          },
          output: {
            type: "structure",
            members: {
              comment: {
                shape: "S46"
              }
            }
          },
          idempotent: true
        },
        PutCommentReaction: {
          input: {
            type: "structure",
            required: [
              "commentId",
              "reactionValue"
            ],
            members: {
              commentId: {},
              reactionValue: {}
            }
          }
        },
        PutFile: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "branchName",
              "fileContent",
              "filePath"
            ],
            members: {
              repositoryName: {},
              branchName: {},
              fileContent: {
                type: "blob"
              },
              filePath: {},
              fileMode: {},
              parentCommitId: {},
              commitMessage: {},
              name: {},
              email: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "commitId",
              "blobId",
              "treeId"
            ],
            members: {
              commitId: {},
              blobId: {},
              treeId: {}
            }
          }
        },
        PutRepositoryTriggers: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "triggers"
            ],
            members: {
              repositoryName: {},
              triggers: {
                shape: "S7a"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              configurationId: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "S3o"
              }
            }
          }
        },
        TestRepositoryTriggers: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "triggers"
            ],
            members: {
              repositoryName: {},
              triggers: {
                shape: "S7a"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              successfulExecutions: {
                type: "list",
                member: {}
              },
              failedExecutions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    trigger: {},
                    failureMessage: {}
                  }
                }
              }
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        },
        UpdateApprovalRuleTemplateContent: {
          input: {
            type: "structure",
            required: [
              "approvalRuleTemplateName",
              "newRuleContent"
            ],
            members: {
              approvalRuleTemplateName: {},
              newRuleContent: {},
              existingRuleContentSha256: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "approvalRuleTemplate"
            ],
            members: {
              approvalRuleTemplate: {
                shape: "S2g"
              }
            }
          }
        },
        UpdateApprovalRuleTemplateDescription: {
          input: {
            type: "structure",
            required: [
              "approvalRuleTemplateName",
              "approvalRuleTemplateDescription"
            ],
            members: {
              approvalRuleTemplateName: {},
              approvalRuleTemplateDescription: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "approvalRuleTemplate"
            ],
            members: {
              approvalRuleTemplate: {
                shape: "S2g"
              }
            }
          }
        },
        UpdateApprovalRuleTemplateName: {
          input: {
            type: "structure",
            required: [
              "oldApprovalRuleTemplateName",
              "newApprovalRuleTemplateName"
            ],
            members: {
              oldApprovalRuleTemplateName: {},
              newApprovalRuleTemplateName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "approvalRuleTemplate"
            ],
            members: {
              approvalRuleTemplate: {
                shape: "S2g"
              }
            }
          }
        },
        UpdateComment: {
          input: {
            type: "structure",
            required: [
              "commentId",
              "content"
            ],
            members: {
              commentId: {},
              content: {}
            }
          },
          output: {
            type: "structure",
            members: {
              comment: {
                shape: "S46"
              }
            }
          }
        },
        UpdateDefaultBranch: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "defaultBranchName"
            ],
            members: {
              repositoryName: {},
              defaultBranchName: {}
            }
          }
        },
        UpdatePullRequestApprovalRuleContent: {
          input: {
            type: "structure",
            required: [
              "pullRequestId",
              "approvalRuleName",
              "newRuleContent"
            ],
            members: {
              pullRequestId: {},
              approvalRuleName: {},
              existingRuleContentSha256: {},
              newRuleContent: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "approvalRule"
            ],
            members: {
              approvalRule: {
                shape: "S3g"
              }
            }
          }
        },
        UpdatePullRequestApprovalState: {
          input: {
            type: "structure",
            required: [
              "pullRequestId",
              "revisionId",
              "approvalState"
            ],
            members: {
              pullRequestId: {},
              revisionId: {},
              approvalState: {}
            }
          }
        },
        UpdatePullRequestDescription: {
          input: {
            type: "structure",
            required: [
              "pullRequestId",
              "description"
            ],
            members: {
              pullRequestId: {},
              description: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "pullRequest"
            ],
            members: {
              pullRequest: {
                shape: "S37"
              }
            }
          }
        },
        UpdatePullRequestStatus: {
          input: {
            type: "structure",
            required: [
              "pullRequestId",
              "pullRequestStatus"
            ],
            members: {
              pullRequestId: {},
              pullRequestStatus: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "pullRequest"
            ],
            members: {
              pullRequest: {
                shape: "S37"
              }
            }
          }
        },
        UpdatePullRequestTitle: {
          input: {
            type: "structure",
            required: [
              "pullRequestId",
              "title"
            ],
            members: {
              pullRequestId: {},
              title: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "pullRequest"
            ],
            members: {
              pullRequest: {
                shape: "S37"
              }
            }
          }
        },
        UpdateRepositoryDescription: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              repositoryName: {},
              repositoryDescription: {}
            }
          }
        },
        UpdateRepositoryEncryptionKey: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "kmsKeyId"
            ],
            members: {
              repositoryName: {},
              kmsKeyId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              repositoryId: {},
              kmsKeyId: {},
              originalKmsKeyId: {}
            }
          }
        },
        UpdateRepositoryName: {
          input: {
            type: "structure",
            required: [
              "oldName",
              "newName"
            ],
            members: {
              oldName: {},
              newName: {}
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "list",
          member: {}
        },
        Sn: {
          type: "structure",
          members: {
            filePath: {},
            fileSizes: {
              type: "structure",
              members: {
                source: {
                  type: "long"
                },
                destination: {
                  type: "long"
                },
                base: {
                  type: "long"
                }
              }
            },
            fileModes: {
              type: "structure",
              members: {
                source: {},
                destination: {},
                base: {}
              }
            },
            objectTypes: {
              type: "structure",
              members: {
                source: {},
                destination: {},
                base: {}
              }
            },
            numberOfConflicts: {
              type: "integer"
            },
            isBinaryFile: {
              type: "structure",
              members: {
                source: {
                  type: "boolean"
                },
                destination: {
                  type: "boolean"
                },
                base: {
                  type: "boolean"
                }
              }
            },
            contentConflict: {
              type: "boolean"
            },
            fileModeConflict: {
              type: "boolean"
            },
            objectTypeConflict: {
              type: "boolean"
            },
            mergeOperations: {
              type: "structure",
              members: {
                source: {},
                destination: {}
              }
            }
          }
        },
        S12: {
          type: "list",
          member: {
            type: "structure",
            members: {
              isConflict: {
                type: "boolean"
              },
              source: {
                shape: "S15"
              },
              destination: {
                shape: "S15"
              },
              base: {
                shape: "S15"
              }
            }
          }
        },
        S15: {
          type: "structure",
          members: {
            startLine: {
              type: "integer"
            },
            endLine: {
              type: "integer"
            },
            hunkContent: {}
          }
        },
        S1l: {
          type: "structure",
          members: {
            commitId: {},
            treeId: {},
            parents: {
              type: "list",
              member: {}
            },
            message: {},
            author: {
              shape: "S1n"
            },
            committer: {
              shape: "S1n"
            },
            additionalData: {}
          }
        },
        S1n: {
          type: "structure",
          members: {
            name: {},
            email: {},
            date: {}
          }
        },
        S1x: {
          type: "structure",
          members: {
            accountId: {},
            repositoryId: {},
            repositoryName: {},
            repositoryDescription: {},
            defaultBranch: {},
            lastModifiedDate: {
              type: "timestamp"
            },
            creationDate: {
              type: "timestamp"
            },
            cloneUrlHttp: {},
            cloneUrlSsh: {},
            Arn: {},
            kmsKeyId: {}
          }
        },
        S2g: {
          type: "structure",
          members: {
            approvalRuleTemplateId: {},
            approvalRuleTemplateName: {},
            approvalRuleTemplateDescription: {},
            approvalRuleTemplateContent: {},
            ruleContentSha256: {},
            lastModifiedDate: {
              type: "timestamp"
            },
            creationDate: {
              type: "timestamp"
            },
            lastModifiedUser: {}
          }
        },
        S2s: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "filePath"
            ],
            members: {
              filePath: {}
            }
          }
        },
        S2u: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "filePath",
              "fileMode"
            ],
            members: {
              filePath: {},
              fileMode: {}
            }
          }
        },
        S2x: {
          type: "list",
          member: {
            type: "structure",
            members: {
              absolutePath: {},
              blobId: {},
              fileMode: {}
            }
          }
        },
        S37: {
          type: "structure",
          members: {
            pullRequestId: {},
            title: {},
            description: {},
            lastActivityDate: {
              type: "timestamp"
            },
            creationDate: {
              type: "timestamp"
            },
            pullRequestStatus: {},
            authorArn: {},
            pullRequestTargets: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  repositoryName: {},
                  sourceReference: {},
                  destinationReference: {},
                  destinationCommit: {},
                  sourceCommit: {},
                  mergeBase: {},
                  mergeMetadata: {
                    shape: "S3c"
                  }
                }
              }
            },
            clientRequestToken: {},
            revisionId: {},
            approvalRules: {
              type: "list",
              member: {
                shape: "S3g"
              }
            }
          }
        },
        S3c: {
          type: "structure",
          members: {
            isMerged: {
              type: "boolean"
            },
            mergedBy: {},
            mergeCommitId: {},
            mergeOption: {}
          }
        },
        S3g: {
          type: "structure",
          members: {
            approvalRuleId: {},
            approvalRuleName: {},
            approvalRuleContent: {},
            ruleContentSha256: {},
            lastModifiedDate: {
              type: "timestamp"
            },
            creationDate: {
              type: "timestamp"
            },
            lastModifiedUser: {},
            originApprovalRuleTemplate: {
              type: "structure",
              members: {
                approvalRuleTemplateId: {},
                approvalRuleTemplateName: {}
              }
            }
          }
        },
        S3o: {
          type: "map",
          key: {},
          value: {}
        },
        S3t: {
          type: "structure",
          members: {
            replaceContents: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "filePath",
                  "replacementType"
                ],
                members: {
                  filePath: {},
                  replacementType: {},
                  content: {
                    type: "blob"
                  },
                  fileMode: {}
                }
              }
            },
            deleteFiles: {
              shape: "S2s"
            },
            setFileModes: {
              shape: "S2u"
            }
          }
        },
        S42: {
          type: "structure",
          members: {
            branchName: {},
            commitId: {}
          }
        },
        S46: {
          type: "structure",
          members: {
            commentId: {},
            content: {},
            inReplyTo: {},
            creationDate: {
              type: "timestamp"
            },
            lastModifiedDate: {
              type: "timestamp"
            },
            authorArn: {},
            deleted: {
              type: "boolean"
            },
            clientRequestToken: {},
            callerReactions: {
              type: "list",
              member: {}
            },
            reactionCounts: {
              type: "map",
              key: {},
              value: {
                type: "integer"
              }
            }
          }
        },
        S5u: {
          type: "structure",
          members: {
            filePath: {},
            filePosition: {
              type: "long"
            },
            relativeFileVersion: {}
          }
        },
        S5x: {
          type: "list",
          member: {
            shape: "S46"
          }
        },
        S69: {
          type: "structure",
          members: {
            blobId: {},
            path: {},
            mode: {}
          }
        },
        S7a: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "destinationArn",
              "events"
            ],
            members: {
              name: {},
              destinationArn: {},
              customData: {},
              branches: {
                shape: "S7e"
              },
              events: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S7e: {
          type: "list",
          member: {}
        },
        S7j: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/codecommit-2015-04-13.paginators.json
var require_codecommit_2015_04_13_paginators = __commonJS({
  "node_modules/aws-sdk/apis/codecommit-2015-04-13.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeMergeConflicts: {
          input_token: "nextToken",
          limit_key: "maxMergeHunks",
          output_token: "nextToken"
        },
        DescribePullRequestEvents: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken"
        },
        GetCommentReactions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken"
        },
        GetCommentsForComparedCommit: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken"
        },
        GetCommentsForPullRequest: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken"
        },
        GetDifferences: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetMergeConflicts: {
          input_token: "nextToken",
          limit_key: "maxConflictFiles",
          output_token: "nextToken"
        },
        ListApprovalRuleTemplates: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken"
        },
        ListAssociatedApprovalRuleTemplatesForRepository: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken"
        },
        ListBranches: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "branches"
        },
        ListFileCommitHistory: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken"
        },
        ListPullRequests: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken"
        },
        ListRepositories: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "repositories"
        },
        ListRepositoriesForApprovalRuleTemplate: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/codecommit.js
var require_codecommit = __commonJS({
  "node_modules/aws-sdk/clients/codecommit.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["codecommit"] = {};
    AWS2.CodeCommit = Service.defineService("codecommit", ["2015-04-13"]);
    Object.defineProperty(apiLoader.services["codecommit"], "2015-04-13", {
      get: function get() {
        var model = require_codecommit_2015_04_13_min();
        model.paginators = require_codecommit_2015_04_13_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CodeCommit;
  }
});

// node_modules/aws-sdk/apis/codedeploy-2014-10-06.min.json
var require_codedeploy_2014_10_06_min = __commonJS({
  "node_modules/aws-sdk/apis/codedeploy-2014-10-06.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-10-06",
        endpointPrefix: "codedeploy",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "CodeDeploy",
        serviceFullName: "AWS CodeDeploy",
        serviceId: "CodeDeploy",
        signatureVersion: "v4",
        targetPrefix: "CodeDeploy_20141006",
        uid: "codedeploy-2014-10-06"
      },
      operations: {
        AddTagsToOnPremisesInstances: {
          input: {
            type: "structure",
            required: [
              "tags",
              "instanceNames"
            ],
            members: {
              tags: {
                shape: "S2"
              },
              instanceNames: {
                shape: "S6"
              }
            }
          }
        },
        BatchGetApplicationRevisions: {
          input: {
            type: "structure",
            required: [
              "applicationName",
              "revisions"
            ],
            members: {
              applicationName: {},
              revisions: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applicationName: {},
              errorMessage: {},
              revisions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    revisionLocation: {
                      shape: "Sb"
                    },
                    genericRevisionInfo: {
                      shape: "Su"
                    }
                  }
                }
              }
            }
          }
        },
        BatchGetApplications: {
          input: {
            type: "structure",
            required: [
              "applicationNames"
            ],
            members: {
              applicationNames: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applicationsInfo: {
                type: "list",
                member: {
                  shape: "S13"
                }
              }
            }
          }
        },
        BatchGetDeploymentGroups: {
          input: {
            type: "structure",
            required: [
              "applicationName",
              "deploymentGroupNames"
            ],
            members: {
              applicationName: {},
              deploymentGroupNames: {
                shape: "Sw"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              deploymentGroupsInfo: {
                type: "list",
                member: {
                  shape: "S1b"
                }
              },
              errorMessage: {}
            }
          }
        },
        BatchGetDeploymentInstances: {
          input: {
            type: "structure",
            required: [
              "deploymentId",
              "instanceIds"
            ],
            members: {
              deploymentId: {},
              instanceIds: {
                shape: "S32"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              instancesSummary: {
                type: "list",
                member: {
                  shape: "S36"
                }
              },
              errorMessage: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This operation is deprecated, use BatchGetDeploymentTargets instead."
        },
        BatchGetDeploymentTargets: {
          input: {
            type: "structure",
            required: [
              "deploymentId",
              "targetIds"
            ],
            members: {
              deploymentId: {},
              targetIds: {
                shape: "S3j"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              deploymentTargets: {
                type: "list",
                member: {
                  shape: "S3n"
                }
              }
            }
          }
        },
        BatchGetDeployments: {
          input: {
            type: "structure",
            required: [
              "deploymentIds"
            ],
            members: {
              deploymentIds: {
                shape: "S49"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              deploymentsInfo: {
                type: "list",
                member: {
                  shape: "S4c"
                }
              }
            }
          }
        },
        BatchGetOnPremisesInstances: {
          input: {
            type: "structure",
            required: [
              "instanceNames"
            ],
            members: {
              instanceNames: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              instanceInfos: {
                type: "list",
                member: {
                  shape: "S4t"
                }
              }
            }
          }
        },
        ContinueDeployment: {
          input: {
            type: "structure",
            members: {
              deploymentId: {},
              deploymentWaitType: {}
            }
          }
        },
        CreateApplication: {
          input: {
            type: "structure",
            required: [
              "applicationName"
            ],
            members: {
              applicationName: {},
              computePlatform: {},
              tags: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applicationId: {}
            }
          }
        },
        CreateDeployment: {
          input: {
            type: "structure",
            required: [
              "applicationName"
            ],
            members: {
              applicationName: {},
              deploymentGroupName: {},
              revision: {
                shape: "Sb"
              },
              deploymentConfigName: {},
              description: {},
              ignoreApplicationStopFailures: {
                type: "boolean"
              },
              targetInstances: {
                shape: "S4j"
              },
              autoRollbackConfiguration: {
                shape: "S1z"
              },
              updateOutdatedInstancesOnly: {
                type: "boolean"
              },
              fileExistsBehavior: {},
              overrideAlarmConfiguration: {
                shape: "S1v"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              deploymentId: {}
            }
          }
        },
        CreateDeploymentConfig: {
          input: {
            type: "structure",
            required: [
              "deploymentConfigName"
            ],
            members: {
              deploymentConfigName: {},
              minimumHealthyHosts: {
                shape: "S54"
              },
              trafficRoutingConfig: {
                shape: "S57"
              },
              computePlatform: {},
              zonalConfig: {
                shape: "S5d"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              deploymentConfigId: {}
            }
          }
        },
        CreateDeploymentGroup: {
          input: {
            type: "structure",
            required: [
              "applicationName",
              "deploymentGroupName",
              "serviceRoleArn"
            ],
            members: {
              applicationName: {},
              deploymentGroupName: {},
              deploymentConfigName: {},
              ec2TagFilters: {
                shape: "S1e"
              },
              onPremisesInstanceTagFilters: {
                shape: "S1h"
              },
              autoScalingGroups: {
                shape: "S4k"
              },
              serviceRoleArn: {},
              triggerConfigurations: {
                shape: "S1p"
              },
              alarmConfiguration: {
                shape: "S1v"
              },
              autoRollbackConfiguration: {
                shape: "S1z"
              },
              outdatedInstancesStrategy: {},
              deploymentStyle: {
                shape: "S22"
              },
              blueGreenDeploymentConfiguration: {
                shape: "S26"
              },
              loadBalancerInfo: {
                shape: "S2e"
              },
              ec2TagSet: {
                shape: "S2t"
              },
              ecsServices: {
                shape: "S2x"
              },
              onPremisesTagSet: {
                shape: "S2v"
              },
              tags: {
                shape: "S2"
              },
              terminationHookEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              deploymentGroupId: {}
            }
          }
        },
        DeleteApplication: {
          input: {
            type: "structure",
            required: [
              "applicationName"
            ],
            members: {
              applicationName: {}
            }
          }
        },
        DeleteDeploymentConfig: {
          input: {
            type: "structure",
            required: [
              "deploymentConfigName"
            ],
            members: {
              deploymentConfigName: {}
            }
          }
        },
        DeleteDeploymentGroup: {
          input: {
            type: "structure",
            required: [
              "applicationName",
              "deploymentGroupName"
            ],
            members: {
              applicationName: {},
              deploymentGroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              hooksNotCleanedUp: {
                shape: "S1k"
              }
            }
          }
        },
        DeleteGitHubAccountToken: {
          input: {
            type: "structure",
            members: {
              tokenName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tokenName: {}
            }
          }
        },
        DeleteResourcesByExternalId: {
          input: {
            type: "structure",
            members: {
              externalId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeregisterOnPremisesInstance: {
          input: {
            type: "structure",
            required: [
              "instanceName"
            ],
            members: {
              instanceName: {}
            }
          }
        },
        GetApplication: {
          input: {
            type: "structure",
            required: [
              "applicationName"
            ],
            members: {
              applicationName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              application: {
                shape: "S13"
              }
            }
          }
        },
        GetApplicationRevision: {
          input: {
            type: "structure",
            required: [
              "applicationName",
              "revision"
            ],
            members: {
              applicationName: {},
              revision: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applicationName: {},
              revision: {
                shape: "Sb"
              },
              revisionInfo: {
                shape: "Su"
              }
            }
          }
        },
        GetDeployment: {
          input: {
            type: "structure",
            required: [
              "deploymentId"
            ],
            members: {
              deploymentId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deploymentInfo: {
                shape: "S4c"
              }
            }
          }
        },
        GetDeploymentConfig: {
          input: {
            type: "structure",
            required: [
              "deploymentConfigName"
            ],
            members: {
              deploymentConfigName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deploymentConfigInfo: {
                type: "structure",
                members: {
                  deploymentConfigId: {},
                  deploymentConfigName: {},
                  minimumHealthyHosts: {
                    shape: "S54"
                  },
                  createTime: {
                    type: "timestamp"
                  },
                  computePlatform: {},
                  trafficRoutingConfig: {
                    shape: "S57"
                  },
                  zonalConfig: {
                    shape: "S5d"
                  }
                }
              }
            }
          }
        },
        GetDeploymentGroup: {
          input: {
            type: "structure",
            required: [
              "applicationName",
              "deploymentGroupName"
            ],
            members: {
              applicationName: {},
              deploymentGroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deploymentGroupInfo: {
                shape: "S1b"
              }
            }
          }
        },
        GetDeploymentInstance: {
          input: {
            type: "structure",
            required: [
              "deploymentId",
              "instanceId"
            ],
            members: {
              deploymentId: {},
              instanceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              instanceSummary: {
                shape: "S36"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "This operation is deprecated, use GetDeploymentTarget instead."
        },
        GetDeploymentTarget: {
          input: {
            type: "structure",
            required: [
              "deploymentId",
              "targetId"
            ],
            members: {
              deploymentId: {},
              targetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deploymentTarget: {
                shape: "S3n"
              }
            }
          }
        },
        GetOnPremisesInstance: {
          input: {
            type: "structure",
            required: [
              "instanceName"
            ],
            members: {
              instanceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              instanceInfo: {
                shape: "S4t"
              }
            }
          }
        },
        ListApplicationRevisions: {
          input: {
            type: "structure",
            required: [
              "applicationName"
            ],
            members: {
              applicationName: {},
              sortBy: {},
              sortOrder: {},
              s3Bucket: {},
              s3KeyPrefix: {},
              deployed: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              revisions: {
                shape: "Sa"
              },
              nextToken: {}
            }
          }
        },
        ListApplications: {
          input: {
            type: "structure",
            members: {
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              applications: {
                shape: "S10"
              },
              nextToken: {}
            }
          }
        },
        ListDeploymentConfigs: {
          input: {
            type: "structure",
            members: {
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deploymentConfigsList: {
                type: "list",
                member: {}
              },
              nextToken: {}
            }
          }
        },
        ListDeploymentGroups: {
          input: {
            type: "structure",
            required: [
              "applicationName"
            ],
            members: {
              applicationName: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              applicationName: {},
              deploymentGroups: {
                shape: "Sw"
              },
              nextToken: {}
            }
          }
        },
        ListDeploymentInstances: {
          input: {
            type: "structure",
            required: [
              "deploymentId"
            ],
            members: {
              deploymentId: {},
              nextToken: {},
              instanceStatusFilter: {
                type: "list",
                member: {
                  shape: "S37"
                }
              },
              instanceTypeFilter: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              instancesList: {
                shape: "S32"
              },
              nextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This operation is deprecated, use ListDeploymentTargets instead."
        },
        ListDeploymentTargets: {
          input: {
            type: "structure",
            required: [
              "deploymentId"
            ],
            members: {
              deploymentId: {},
              nextToken: {},
              targetFilters: {
                type: "map",
                key: {},
                value: {
                  type: "list",
                  member: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              targetIds: {
                shape: "S3j"
              },
              nextToken: {}
            }
          }
        },
        ListDeployments: {
          input: {
            type: "structure",
            members: {
              applicationName: {},
              deploymentGroupName: {},
              externalId: {},
              includeOnlyStatuses: {
                type: "list",
                member: {}
              },
              createTimeRange: {
                type: "structure",
                members: {
                  start: {
                    type: "timestamp"
                  },
                  end: {
                    type: "timestamp"
                  }
                }
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deployments: {
                shape: "S49"
              },
              nextToken: {}
            }
          }
        },
        ListGitHubAccountTokenNames: {
          input: {
            type: "structure",
            members: {
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tokenNameList: {
                type: "list",
                member: {}
              },
              nextToken: {}
            }
          }
        },
        ListOnPremisesInstances: {
          input: {
            type: "structure",
            members: {
              registrationStatus: {},
              tagFilters: {
                shape: "S1h"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              instanceNames: {
                shape: "S6"
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S2"
              },
              NextToken: {}
            }
          }
        },
        PutLifecycleEventHookExecutionStatus: {
          input: {
            type: "structure",
            members: {
              deploymentId: {},
              lifecycleEventHookExecutionId: {},
              status: {}
            }
          },
          output: {
            type: "structure",
            members: {
              lifecycleEventHookExecutionId: {}
            }
          }
        },
        RegisterApplicationRevision: {
          input: {
            type: "structure",
            required: [
              "applicationName",
              "revision"
            ],
            members: {
              applicationName: {},
              description: {},
              revision: {
                shape: "Sb"
              }
            }
          }
        },
        RegisterOnPremisesInstance: {
          input: {
            type: "structure",
            required: [
              "instanceName"
            ],
            members: {
              instanceName: {},
              iamSessionArn: {},
              iamUserArn: {}
            }
          }
        },
        RemoveTagsFromOnPremisesInstances: {
          input: {
            type: "structure",
            required: [
              "tags",
              "instanceNames"
            ],
            members: {
              tags: {
                shape: "S2"
              },
              instanceNames: {
                shape: "S6"
              }
            }
          }
        },
        SkipWaitTimeForInstanceTermination: {
          input: {
            type: "structure",
            members: {
              deploymentId: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This operation is deprecated, use ContinueDeployment with DeploymentWaitType instead."
        },
        StopDeployment: {
          input: {
            type: "structure",
            required: [
              "deploymentId"
            ],
            members: {
              deploymentId: {},
              autoRollbackEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              status: {},
              statusMessage: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateApplication: {
          input: {
            type: "structure",
            members: {
              applicationName: {},
              newApplicationName: {}
            }
          }
        },
        UpdateDeploymentGroup: {
          input: {
            type: "structure",
            required: [
              "applicationName",
              "currentDeploymentGroupName"
            ],
            members: {
              applicationName: {},
              currentDeploymentGroupName: {},
              newDeploymentGroupName: {},
              deploymentConfigName: {},
              ec2TagFilters: {
                shape: "S1e"
              },
              onPremisesInstanceTagFilters: {
                shape: "S1h"
              },
              autoScalingGroups: {
                shape: "S4k"
              },
              serviceRoleArn: {},
              triggerConfigurations: {
                shape: "S1p"
              },
              alarmConfiguration: {
                shape: "S1v"
              },
              autoRollbackConfiguration: {
                shape: "S1z"
              },
              outdatedInstancesStrategy: {},
              deploymentStyle: {
                shape: "S22"
              },
              blueGreenDeploymentConfiguration: {
                shape: "S26"
              },
              loadBalancerInfo: {
                shape: "S2e"
              },
              ec2TagSet: {
                shape: "S2t"
              },
              ecsServices: {
                shape: "S2x"
              },
              onPremisesTagSet: {
                shape: "S2v"
              },
              terminationHookEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              hooksNotCleanedUp: {
                shape: "S1k"
              }
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S6: {
          type: "list",
          member: {}
        },
        Sa: {
          type: "list",
          member: {
            shape: "Sb"
          }
        },
        Sb: {
          type: "structure",
          members: {
            revisionType: {},
            s3Location: {
              type: "structure",
              members: {
                bucket: {},
                key: {},
                bundleType: {},
                version: {},
                eTag: {}
              }
            },
            gitHubLocation: {
              type: "structure",
              members: {
                repository: {},
                commitId: {}
              }
            },
            string: {
              type: "structure",
              members: {
                content: {},
                sha256: {}
              },
              deprecated: true,
              deprecatedMessage: "RawString and String revision type are deprecated, use AppSpecContent type instead."
            },
            appSpecContent: {
              type: "structure",
              members: {
                content: {},
                sha256: {}
              }
            }
          }
        },
        Su: {
          type: "structure",
          members: {
            description: {},
            deploymentGroups: {
              shape: "Sw"
            },
            firstUsedTime: {
              type: "timestamp"
            },
            lastUsedTime: {
              type: "timestamp"
            },
            registerTime: {
              type: "timestamp"
            }
          }
        },
        Sw: {
          type: "list",
          member: {}
        },
        S10: {
          type: "list",
          member: {}
        },
        S13: {
          type: "structure",
          members: {
            applicationId: {},
            applicationName: {},
            createTime: {
              type: "timestamp"
            },
            linkedToGitHub: {
              type: "boolean"
            },
            gitHubAccountName: {},
            computePlatform: {}
          }
        },
        S1b: {
          type: "structure",
          members: {
            applicationName: {},
            deploymentGroupId: {},
            deploymentGroupName: {},
            deploymentConfigName: {},
            ec2TagFilters: {
              shape: "S1e"
            },
            onPremisesInstanceTagFilters: {
              shape: "S1h"
            },
            autoScalingGroups: {
              shape: "S1k"
            },
            serviceRoleArn: {},
            targetRevision: {
              shape: "Sb"
            },
            triggerConfigurations: {
              shape: "S1p"
            },
            alarmConfiguration: {
              shape: "S1v"
            },
            autoRollbackConfiguration: {
              shape: "S1z"
            },
            deploymentStyle: {
              shape: "S22"
            },
            outdatedInstancesStrategy: {},
            blueGreenDeploymentConfiguration: {
              shape: "S26"
            },
            loadBalancerInfo: {
              shape: "S2e"
            },
            lastSuccessfulDeployment: {
              shape: "S2q"
            },
            lastAttemptedDeployment: {
              shape: "S2q"
            },
            ec2TagSet: {
              shape: "S2t"
            },
            onPremisesTagSet: {
              shape: "S2v"
            },
            computePlatform: {},
            ecsServices: {
              shape: "S2x"
            },
            terminationHookEnabled: {
              type: "boolean"
            }
          }
        },
        S1e: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {},
              Type: {}
            }
          }
        },
        S1h: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {},
              Type: {}
            }
          }
        },
        S1k: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              hook: {},
              terminationHook: {}
            }
          }
        },
        S1p: {
          type: "list",
          member: {
            type: "structure",
            members: {
              triggerName: {},
              triggerTargetArn: {},
              triggerEvents: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S1v: {
          type: "structure",
          members: {
            enabled: {
              type: "boolean"
            },
            ignorePollAlarmFailure: {
              type: "boolean"
            },
            alarms: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  name: {}
                }
              }
            }
          }
        },
        S1z: {
          type: "structure",
          members: {
            enabled: {
              type: "boolean"
            },
            events: {
              type: "list",
              member: {}
            }
          }
        },
        S22: {
          type: "structure",
          members: {
            deploymentType: {},
            deploymentOption: {}
          }
        },
        S26: {
          type: "structure",
          members: {
            terminateBlueInstancesOnDeploymentSuccess: {
              type: "structure",
              members: {
                action: {},
                terminationWaitTimeInMinutes: {
                  type: "integer"
                }
              }
            },
            deploymentReadyOption: {
              type: "structure",
              members: {
                actionOnTimeout: {},
                waitTimeInMinutes: {
                  type: "integer"
                }
              }
            },
            greenFleetProvisioningOption: {
              type: "structure",
              members: {
                action: {}
              }
            }
          }
        },
        S2e: {
          type: "structure",
          members: {
            elbInfoList: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  name: {}
                }
              }
            },
            targetGroupInfoList: {
              shape: "S2i"
            },
            targetGroupPairInfoList: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  targetGroups: {
                    shape: "S2i"
                  },
                  prodTrafficRoute: {
                    shape: "S2n"
                  },
                  testTrafficRoute: {
                    shape: "S2n"
                  }
                }
              }
            }
          }
        },
        S2i: {
          type: "list",
          member: {
            shape: "S2j"
          }
        },
        S2j: {
          type: "structure",
          members: {
            name: {}
          }
        },
        S2n: {
          type: "structure",
          members: {
            listenerArns: {
              type: "list",
              member: {}
            }
          }
        },
        S2q: {
          type: "structure",
          members: {
            deploymentId: {},
            status: {},
            endTime: {
              type: "timestamp"
            },
            createTime: {
              type: "timestamp"
            }
          }
        },
        S2t: {
          type: "structure",
          members: {
            ec2TagSetList: {
              type: "list",
              member: {
                shape: "S1e"
              }
            }
          }
        },
        S2v: {
          type: "structure",
          members: {
            onPremisesTagSetList: {
              type: "list",
              member: {
                shape: "S1h"
              }
            }
          }
        },
        S2x: {
          type: "list",
          member: {
            type: "structure",
            members: {
              serviceName: {},
              clusterName: {}
            }
          }
        },
        S32: {
          type: "list",
          member: {}
        },
        S36: {
          type: "structure",
          members: {
            deploymentId: {},
            instanceId: {},
            status: {
              shape: "S37"
            },
            lastUpdatedAt: {
              type: "timestamp"
            },
            lifecycleEvents: {
              shape: "S38"
            },
            instanceType: {}
          },
          deprecated: true,
          deprecatedMessage: "InstanceSummary is deprecated, use DeploymentTarget instead."
        },
        S37: {
          type: "string",
          deprecated: true,
          deprecatedMessage: "InstanceStatus is deprecated, use TargetStatus instead."
        },
        S38: {
          type: "list",
          member: {
            type: "structure",
            members: {
              lifecycleEventName: {},
              diagnostics: {
                type: "structure",
                members: {
                  errorCode: {},
                  scriptName: {},
                  message: {},
                  logTail: {}
                }
              },
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              status: {}
            }
          }
        },
        S3j: {
          type: "list",
          member: {}
        },
        S3n: {
          type: "structure",
          members: {
            deploymentTargetType: {},
            instanceTarget: {
              type: "structure",
              members: {
                deploymentId: {},
                targetId: {},
                targetArn: {},
                status: {},
                lastUpdatedAt: {
                  type: "timestamp"
                },
                lifecycleEvents: {
                  shape: "S38"
                },
                instanceLabel: {}
              }
            },
            lambdaTarget: {
              type: "structure",
              members: {
                deploymentId: {},
                targetId: {},
                targetArn: {},
                status: {},
                lastUpdatedAt: {
                  type: "timestamp"
                },
                lifecycleEvents: {
                  shape: "S38"
                },
                lambdaFunctionInfo: {
                  type: "structure",
                  members: {
                    functionName: {},
                    functionAlias: {},
                    currentVersion: {},
                    targetVersion: {},
                    targetVersionWeight: {
                      type: "double"
                    }
                  }
                }
              }
            },
            ecsTarget: {
              type: "structure",
              members: {
                deploymentId: {},
                targetId: {},
                targetArn: {},
                lastUpdatedAt: {
                  type: "timestamp"
                },
                lifecycleEvents: {
                  shape: "S38"
                },
                status: {},
                taskSetsInfo: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      identifer: {},
                      desiredCount: {
                        type: "long"
                      },
                      pendingCount: {
                        type: "long"
                      },
                      runningCount: {
                        type: "long"
                      },
                      status: {},
                      trafficWeight: {
                        type: "double"
                      },
                      targetGroup: {
                        shape: "S2j"
                      },
                      taskSetLabel: {}
                    }
                  }
                }
              }
            },
            cloudFormationTarget: {
              type: "structure",
              members: {
                deploymentId: {},
                targetId: {},
                lastUpdatedAt: {
                  type: "timestamp"
                },
                lifecycleEvents: {
                  shape: "S38"
                },
                status: {},
                resourceType: {},
                targetVersionWeight: {
                  type: "double"
                }
              }
            }
          }
        },
        S49: {
          type: "list",
          member: {}
        },
        S4c: {
          type: "structure",
          members: {
            applicationName: {},
            deploymentGroupName: {},
            deploymentConfigName: {},
            deploymentId: {},
            previousRevision: {
              shape: "Sb"
            },
            revision: {
              shape: "Sb"
            },
            status: {},
            errorInformation: {
              type: "structure",
              members: {
                code: {},
                message: {}
              }
            },
            createTime: {
              type: "timestamp"
            },
            startTime: {
              type: "timestamp"
            },
            completeTime: {
              type: "timestamp"
            },
            deploymentOverview: {
              type: "structure",
              members: {
                Pending: {
                  type: "long"
                },
                InProgress: {
                  type: "long"
                },
                Succeeded: {
                  type: "long"
                },
                Failed: {
                  type: "long"
                },
                Skipped: {
                  type: "long"
                },
                Ready: {
                  type: "long"
                }
              }
            },
            description: {},
            creator: {},
            ignoreApplicationStopFailures: {
              type: "boolean"
            },
            autoRollbackConfiguration: {
              shape: "S1z"
            },
            updateOutdatedInstancesOnly: {
              type: "boolean"
            },
            rollbackInfo: {
              type: "structure",
              members: {
                rollbackDeploymentId: {},
                rollbackTriggeringDeploymentId: {},
                rollbackMessage: {}
              }
            },
            deploymentStyle: {
              shape: "S22"
            },
            targetInstances: {
              shape: "S4j"
            },
            instanceTerminationWaitTimeStarted: {
              type: "boolean"
            },
            blueGreenDeploymentConfiguration: {
              shape: "S26"
            },
            loadBalancerInfo: {
              shape: "S2e"
            },
            additionalDeploymentStatusInfo: {
              type: "string",
              deprecated: true,
              deprecatedMessage: "AdditionalDeploymentStatusInfo is deprecated, use DeploymentStatusMessageList instead."
            },
            fileExistsBehavior: {},
            deploymentStatusMessages: {
              type: "list",
              member: {}
            },
            computePlatform: {},
            externalId: {},
            relatedDeployments: {
              type: "structure",
              members: {
                autoUpdateOutdatedInstancesRootDeploymentId: {},
                autoUpdateOutdatedInstancesDeploymentIds: {
                  shape: "S49"
                }
              }
            },
            overrideAlarmConfiguration: {
              shape: "S1v"
            }
          }
        },
        S4j: {
          type: "structure",
          members: {
            tagFilters: {
              shape: "S1e"
            },
            autoScalingGroups: {
              shape: "S4k"
            },
            ec2TagSet: {
              shape: "S2t"
            }
          }
        },
        S4k: {
          type: "list",
          member: {}
        },
        S4t: {
          type: "structure",
          members: {
            instanceName: {},
            iamSessionArn: {},
            iamUserArn: {},
            instanceArn: {},
            registerTime: {
              type: "timestamp"
            },
            deregisterTime: {
              type: "timestamp"
            },
            tags: {
              shape: "S2"
            }
          }
        },
        S54: {
          type: "structure",
          members: {
            type: {},
            value: {
              type: "integer"
            }
          }
        },
        S57: {
          type: "structure",
          members: {
            type: {},
            timeBasedCanary: {
              type: "structure",
              members: {
                canaryPercentage: {
                  type: "integer"
                },
                canaryInterval: {
                  type: "integer"
                }
              }
            },
            timeBasedLinear: {
              type: "structure",
              members: {
                linearPercentage: {
                  type: "integer"
                },
                linearInterval: {
                  type: "integer"
                }
              }
            }
          }
        },
        S5d: {
          type: "structure",
          members: {
            firstZoneMonitorDurationInSeconds: {
              type: "long"
            },
            monitorDurationInSeconds: {
              type: "long"
            },
            minimumHealthyHostsPerZone: {
              type: "structure",
              members: {
                type: {},
                value: {
                  type: "integer"
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/codedeploy-2014-10-06.paginators.json
var require_codedeploy_2014_10_06_paginators = __commonJS({
  "node_modules/aws-sdk/apis/codedeploy-2014-10-06.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListApplicationRevisions: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "revisions"
        },
        ListApplications: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "applications"
        },
        ListDeploymentConfigs: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "deploymentConfigsList"
        },
        ListDeploymentGroups: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "deploymentGroups"
        },
        ListDeploymentInstances: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "instancesList"
        },
        ListDeployments: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "deployments"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/codedeploy-2014-10-06.waiters2.json
var require_codedeploy_2014_10_06_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/codedeploy-2014-10-06.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        DeploymentSuccessful: {
          delay: 15,
          operation: "GetDeployment",
          maxAttempts: 120,
          acceptors: [
            {
              expected: "Succeeded",
              matcher: "path",
              state: "success",
              argument: "deploymentInfo.status"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "deploymentInfo.status"
            },
            {
              expected: "Stopped",
              matcher: "path",
              state: "failure",
              argument: "deploymentInfo.status"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/codedeploy.js
var require_codedeploy = __commonJS({
  "node_modules/aws-sdk/clients/codedeploy.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["codedeploy"] = {};
    AWS2.CodeDeploy = Service.defineService("codedeploy", ["2014-10-06"]);
    Object.defineProperty(apiLoader.services["codedeploy"], "2014-10-06", {
      get: function get() {
        var model = require_codedeploy_2014_10_06_min();
        model.paginators = require_codedeploy_2014_10_06_paginators().pagination;
        model.waiters = require_codedeploy_2014_10_06_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CodeDeploy;
  }
});

// node_modules/aws-sdk/apis/codepipeline-2015-07-09.min.json
var require_codepipeline_2015_07_09_min = __commonJS({
  "node_modules/aws-sdk/apis/codepipeline-2015-07-09.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-07-09",
        endpointPrefix: "codepipeline",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "CodePipeline",
        serviceFullName: "AWS CodePipeline",
        serviceId: "CodePipeline",
        signatureVersion: "v4",
        targetPrefix: "CodePipeline_20150709",
        uid: "codepipeline-2015-07-09"
      },
      operations: {
        AcknowledgeJob: {
          input: {
            type: "structure",
            required: [
              "jobId",
              "nonce"
            ],
            members: {
              jobId: {},
              nonce: {}
            }
          },
          output: {
            type: "structure",
            members: {
              status: {}
            }
          }
        },
        AcknowledgeThirdPartyJob: {
          input: {
            type: "structure",
            required: [
              "jobId",
              "nonce",
              "clientToken"
            ],
            members: {
              jobId: {},
              nonce: {},
              clientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              status: {}
            }
          }
        },
        CreateCustomActionType: {
          input: {
            type: "structure",
            required: [
              "category",
              "provider",
              "version",
              "inputArtifactDetails",
              "outputArtifactDetails"
            ],
            members: {
              category: {},
              provider: {},
              version: {},
              settings: {
                shape: "Se"
              },
              configurationProperties: {
                shape: "Sh"
              },
              inputArtifactDetails: {
                shape: "Sn"
              },
              outputArtifactDetails: {
                shape: "Sn"
              },
              tags: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "actionType"
            ],
            members: {
              actionType: {
                shape: "Sv"
              },
              tags: {
                shape: "Sq"
              }
            }
          }
        },
        CreatePipeline: {
          input: {
            type: "structure",
            required: [
              "pipeline"
            ],
            members: {
              pipeline: {
                shape: "Sz"
              },
              tags: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              pipeline: {
                shape: "Sz"
              },
              tags: {
                shape: "Sq"
              }
            }
          }
        },
        DeleteCustomActionType: {
          input: {
            type: "structure",
            required: [
              "category",
              "provider",
              "version"
            ],
            members: {
              category: {},
              provider: {},
              version: {}
            }
          }
        },
        DeletePipeline: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          }
        },
        DeleteWebhook: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeregisterWebhookWithThirdParty: {
          input: {
            type: "structure",
            members: {
              webhookName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisableStageTransition: {
          input: {
            type: "structure",
            required: [
              "pipelineName",
              "stageName",
              "transitionType",
              "reason"
            ],
            members: {
              pipelineName: {},
              stageName: {},
              transitionType: {},
              reason: {}
            }
          }
        },
        EnableStageTransition: {
          input: {
            type: "structure",
            required: [
              "pipelineName",
              "stageName",
              "transitionType"
            ],
            members: {
              pipelineName: {},
              stageName: {},
              transitionType: {}
            }
          }
        },
        GetActionType: {
          input: {
            type: "structure",
            required: [
              "category",
              "owner",
              "provider",
              "version"
            ],
            members: {
              category: {},
              owner: {},
              provider: {},
              version: {}
            }
          },
          output: {
            type: "structure",
            members: {
              actionType: {
                shape: "S2o"
              }
            }
          }
        },
        GetJobDetails: {
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              jobDetails: {
                type: "structure",
                members: {
                  id: {},
                  data: {
                    shape: "S3g"
                  },
                  accountId: {}
                }
              }
            }
          }
        },
        GetPipeline: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              version: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              pipeline: {
                shape: "Sz"
              },
              metadata: {
                type: "structure",
                members: {
                  pipelineArn: {},
                  created: {
                    type: "timestamp"
                  },
                  updated: {
                    type: "timestamp"
                  },
                  pollingDisabledAt: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        GetPipelineExecution: {
          input: {
            type: "structure",
            required: [
              "pipelineName",
              "pipelineExecutionId"
            ],
            members: {
              pipelineName: {},
              pipelineExecutionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              pipelineExecution: {
                type: "structure",
                members: {
                  pipelineName: {},
                  pipelineVersion: {
                    type: "integer"
                  },
                  pipelineExecutionId: {},
                  status: {},
                  statusSummary: {},
                  artifactRevisions: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        name: {},
                        revisionId: {},
                        revisionChangeIdentifier: {},
                        revisionSummary: {},
                        created: {
                          type: "timestamp"
                        },
                        revisionUrl: {}
                      }
                    }
                  },
                  trigger: {
                    shape: "S4e"
                  },
                  variables: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        name: {},
                        resolvedValue: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetPipelineState: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              pipelineName: {},
              pipelineVersion: {
                type: "integer"
              },
              stageStates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    stageName: {},
                    inboundExecution: {
                      shape: "S4o"
                    },
                    inboundTransitionState: {
                      type: "structure",
                      members: {
                        enabled: {
                          type: "boolean"
                        },
                        lastChangedBy: {},
                        lastChangedAt: {
                          type: "timestamp"
                        },
                        disabledReason: {}
                      }
                    },
                    actionStates: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          actionName: {},
                          currentRevision: {
                            shape: "S4w"
                          },
                          latestExecution: {
                            type: "structure",
                            members: {
                              actionExecutionId: {},
                              status: {},
                              summary: {},
                              lastStatusChange: {
                                type: "timestamp"
                              },
                              token: {},
                              lastUpdatedBy: {},
                              externalExecutionId: {},
                              externalExecutionUrl: {},
                              percentComplete: {
                                type: "integer"
                              },
                              errorDetails: {
                                type: "structure",
                                members: {
                                  code: {},
                                  message: {}
                                }
                              }
                            }
                          },
                          entityUrl: {},
                          revisionUrl: {}
                        }
                      }
                    },
                    latestExecution: {
                      shape: "S4o"
                    }
                  }
                }
              },
              created: {
                type: "timestamp"
              },
              updated: {
                type: "timestamp"
              }
            }
          }
        },
        GetThirdPartyJobDetails: {
          input: {
            type: "structure",
            required: [
              "jobId",
              "clientToken"
            ],
            members: {
              jobId: {},
              clientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              jobDetails: {
                type: "structure",
                members: {
                  id: {},
                  data: {
                    type: "structure",
                    members: {
                      actionTypeId: {
                        shape: "Sw"
                      },
                      actionConfiguration: {
                        shape: "S3h"
                      },
                      pipelineContext: {
                        shape: "S3i"
                      },
                      inputArtifacts: {
                        shape: "S3o"
                      },
                      outputArtifacts: {
                        shape: "S3o"
                      },
                      artifactCredentials: {
                        shape: "S3w"
                      },
                      continuationToken: {},
                      encryptionKey: {
                        shape: "S15"
                      }
                    }
                  },
                  nonce: {}
                }
              }
            }
          }
        },
        ListActionExecutions: {
          input: {
            type: "structure",
            required: [
              "pipelineName"
            ],
            members: {
              pipelineName: {},
              filter: {
                type: "structure",
                members: {
                  pipelineExecutionId: {}
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              actionExecutionDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    pipelineExecutionId: {},
                    actionExecutionId: {},
                    pipelineVersion: {
                      type: "integer"
                    },
                    stageName: {},
                    actionName: {},
                    startTime: {
                      type: "timestamp"
                    },
                    lastUpdateTime: {
                      type: "timestamp"
                    },
                    status: {},
                    input: {
                      type: "structure",
                      members: {
                        actionTypeId: {
                          shape: "Sw"
                        },
                        configuration: {
                          shape: "S1l"
                        },
                        resolvedConfiguration: {
                          type: "map",
                          key: {},
                          value: {}
                        },
                        roleArn: {},
                        region: {},
                        inputArtifacts: {
                          shape: "S5k"
                        },
                        namespace: {}
                      }
                    },
                    output: {
                      type: "structure",
                      members: {
                        outputArtifacts: {
                          shape: "S5k"
                        },
                        executionResult: {
                          type: "structure",
                          members: {
                            externalExecutionId: {},
                            externalExecutionSummary: {},
                            externalExecutionUrl: {}
                          }
                        },
                        outputVariables: {
                          shape: "S5t"
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListActionTypes: {
          input: {
            type: "structure",
            members: {
              actionOwnerFilter: {},
              nextToken: {},
              regionFilter: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "actionTypes"
            ],
            members: {
              actionTypes: {
                type: "list",
                member: {
                  shape: "Sv"
                }
              },
              nextToken: {}
            }
          }
        },
        ListPipelineExecutions: {
          input: {
            type: "structure",
            required: [
              "pipelineName"
            ],
            members: {
              pipelineName: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              pipelineExecutionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    pipelineExecutionId: {},
                    status: {},
                    startTime: {
                      type: "timestamp"
                    },
                    lastUpdateTime: {
                      type: "timestamp"
                    },
                    sourceRevisions: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "actionName"
                        ],
                        members: {
                          actionName: {},
                          revisionId: {},
                          revisionSummary: {},
                          revisionUrl: {}
                        }
                      }
                    },
                    trigger: {
                      shape: "S4e"
                    },
                    stopTrigger: {
                      type: "structure",
                      members: {
                        reason: {}
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListPipelines: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              pipelines: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    version: {
                      type: "integer"
                    },
                    pipelineType: {},
                    created: {
                      type: "timestamp"
                    },
                    updated: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sq"
              },
              nextToken: {}
            }
          }
        },
        ListWebhooks: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              webhooks: {
                type: "list",
                member: {
                  shape: "S6i"
                }
              },
              NextToken: {}
            }
          }
        },
        PollForJobs: {
          input: {
            type: "structure",
            required: [
              "actionTypeId"
            ],
            members: {
              actionTypeId: {
                shape: "Sw"
              },
              maxBatchSize: {
                type: "integer"
              },
              queryParam: {
                type: "map",
                key: {},
                value: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    data: {
                      shape: "S3g"
                    },
                    nonce: {},
                    accountId: {}
                  }
                }
              }
            }
          }
        },
        PollForThirdPartyJobs: {
          input: {
            type: "structure",
            required: [
              "actionTypeId"
            ],
            members: {
              actionTypeId: {
                shape: "Sw"
              },
              maxBatchSize: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    clientId: {},
                    jobId: {}
                  }
                }
              }
            }
          }
        },
        PutActionRevision: {
          input: {
            type: "structure",
            required: [
              "pipelineName",
              "stageName",
              "actionName",
              "actionRevision"
            ],
            members: {
              pipelineName: {},
              stageName: {},
              actionName: {},
              actionRevision: {
                shape: "S4w"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              newRevision: {
                type: "boolean"
              },
              pipelineExecutionId: {}
            }
          }
        },
        PutApprovalResult: {
          input: {
            type: "structure",
            required: [
              "pipelineName",
              "stageName",
              "actionName",
              "result",
              "token"
            ],
            members: {
              pipelineName: {},
              stageName: {},
              actionName: {},
              result: {
                type: "structure",
                required: [
                  "summary",
                  "status"
                ],
                members: {
                  summary: {},
                  status: {}
                }
              },
              token: {}
            }
          },
          output: {
            type: "structure",
            members: {
              approvedAt: {
                type: "timestamp"
              }
            }
          }
        },
        PutJobFailureResult: {
          input: {
            type: "structure",
            required: [
              "jobId",
              "failureDetails"
            ],
            members: {
              jobId: {},
              failureDetails: {
                shape: "S7i"
              }
            }
          }
        },
        PutJobSuccessResult: {
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {},
              currentRevision: {
                shape: "S7l"
              },
              continuationToken: {},
              executionDetails: {
                shape: "S7n"
              },
              outputVariables: {
                shape: "S5t"
              }
            }
          }
        },
        PutThirdPartyJobFailureResult: {
          input: {
            type: "structure",
            required: [
              "jobId",
              "clientToken",
              "failureDetails"
            ],
            members: {
              jobId: {},
              clientToken: {},
              failureDetails: {
                shape: "S7i"
              }
            }
          }
        },
        PutThirdPartyJobSuccessResult: {
          input: {
            type: "structure",
            required: [
              "jobId",
              "clientToken"
            ],
            members: {
              jobId: {},
              clientToken: {},
              currentRevision: {
                shape: "S7l"
              },
              continuationToken: {},
              executionDetails: {
                shape: "S7n"
              }
            }
          }
        },
        PutWebhook: {
          input: {
            type: "structure",
            required: [
              "webhook"
            ],
            members: {
              webhook: {
                shape: "S6j"
              },
              tags: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              webhook: {
                shape: "S6i"
              }
            }
          }
        },
        RegisterWebhookWithThirdParty: {
          input: {
            type: "structure",
            members: {
              webhookName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RetryStageExecution: {
          input: {
            type: "structure",
            required: [
              "pipelineName",
              "stageName",
              "pipelineExecutionId",
              "retryMode"
            ],
            members: {
              pipelineName: {},
              stageName: {},
              pipelineExecutionId: {},
              retryMode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              pipelineExecutionId: {}
            }
          }
        },
        StartPipelineExecution: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              variables: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "value"
                  ],
                  members: {
                    name: {},
                    value: {}
                  }
                }
              },
              clientRequestToken: {
                idempotencyToken: true
              },
              sourceRevisions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "actionName",
                    "revisionType",
                    "revisionValue"
                  ],
                  members: {
                    actionName: {},
                    revisionType: {},
                    revisionValue: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              pipelineExecutionId: {}
            }
          }
        },
        StopPipelineExecution: {
          input: {
            type: "structure",
            required: [
              "pipelineName",
              "pipelineExecutionId"
            ],
            members: {
              pipelineName: {},
              pipelineExecutionId: {},
              abandon: {
                type: "boolean"
              },
              reason: {}
            }
          },
          output: {
            type: "structure",
            members: {
              pipelineExecutionId: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateActionType: {
          input: {
            type: "structure",
            required: [
              "actionType"
            ],
            members: {
              actionType: {
                shape: "S2o"
              }
            }
          }
        },
        UpdatePipeline: {
          input: {
            type: "structure",
            required: [
              "pipeline"
            ],
            members: {
              pipeline: {
                shape: "Sz"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              pipeline: {
                shape: "Sz"
              }
            }
          }
        }
      },
      shapes: {
        Se: {
          type: "structure",
          members: {
            thirdPartyConfigurationUrl: {},
            entityUrlTemplate: {},
            executionUrlTemplate: {},
            revisionUrlTemplate: {}
          }
        },
        Sh: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "required",
              "key",
              "secret"
            ],
            members: {
              name: {},
              required: {
                type: "boolean"
              },
              key: {
                type: "boolean"
              },
              secret: {
                type: "boolean"
              },
              queryable: {
                type: "boolean"
              },
              description: {},
              type: {}
            }
          }
        },
        Sn: {
          type: "structure",
          required: [
            "minimumCount",
            "maximumCount"
          ],
          members: {
            minimumCount: {
              type: "integer"
            },
            maximumCount: {
              type: "integer"
            }
          }
        },
        Sq: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        Sv: {
          type: "structure",
          required: [
            "id",
            "inputArtifactDetails",
            "outputArtifactDetails"
          ],
          members: {
            id: {
              shape: "Sw"
            },
            settings: {
              shape: "Se"
            },
            actionConfigurationProperties: {
              shape: "Sh"
            },
            inputArtifactDetails: {
              shape: "Sn"
            },
            outputArtifactDetails: {
              shape: "Sn"
            }
          }
        },
        Sw: {
          type: "structure",
          required: [
            "category",
            "owner",
            "provider",
            "version"
          ],
          members: {
            category: {},
            owner: {},
            provider: {},
            version: {}
          }
        },
        Sz: {
          type: "structure",
          required: [
            "name",
            "roleArn",
            "stages"
          ],
          members: {
            name: {},
            roleArn: {},
            artifactStore: {
              shape: "S12"
            },
            artifactStores: {
              type: "map",
              key: {},
              value: {
                shape: "S12"
              }
            },
            stages: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "name",
                  "actions"
                ],
                members: {
                  name: {},
                  blockers: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "name",
                        "type"
                      ],
                      members: {
                        name: {},
                        type: {}
                      }
                    }
                  },
                  actions: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "name",
                        "actionTypeId"
                      ],
                      members: {
                        name: {},
                        actionTypeId: {
                          shape: "Sw"
                        },
                        runOrder: {
                          type: "integer"
                        },
                        configuration: {
                          shape: "S1l"
                        },
                        outputArtifacts: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "name"
                            ],
                            members: {
                              name: {}
                            }
                          }
                        },
                        inputArtifacts: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "name"
                            ],
                            members: {
                              name: {}
                            }
                          }
                        },
                        roleArn: {},
                        region: {},
                        namespace: {}
                      }
                    }
                  }
                }
              }
            },
            version: {
              type: "integer"
            },
            pipelineType: {},
            triggers: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "providerType",
                  "gitConfiguration"
                ],
                members: {
                  providerType: {},
                  gitConfiguration: {
                    type: "structure",
                    required: [
                      "sourceActionName"
                    ],
                    members: {
                      sourceActionName: {},
                      push: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            tags: {
                              type: "structure",
                              members: {
                                includes: {
                                  shape: "S22"
                                },
                                excludes: {
                                  shape: "S22"
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            variables: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "name"
                ],
                members: {
                  name: {},
                  defaultValue: {},
                  description: {}
                }
              }
            }
          }
        },
        S12: {
          type: "structure",
          required: [
            "type",
            "location"
          ],
          members: {
            type: {},
            location: {},
            encryptionKey: {
              shape: "S15"
            }
          }
        },
        S15: {
          type: "structure",
          required: [
            "id",
            "type"
          ],
          members: {
            id: {},
            type: {}
          }
        },
        S1l: {
          type: "map",
          key: {},
          value: {}
        },
        S22: {
          type: "list",
          member: {}
        },
        S2o: {
          type: "structure",
          required: [
            "executor",
            "id",
            "inputArtifactDetails",
            "outputArtifactDetails"
          ],
          members: {
            description: {},
            executor: {
              type: "structure",
              required: [
                "configuration",
                "type"
              ],
              members: {
                configuration: {
                  type: "structure",
                  members: {
                    lambdaExecutorConfiguration: {
                      type: "structure",
                      required: [
                        "lambdaFunctionArn"
                      ],
                      members: {
                        lambdaFunctionArn: {}
                      }
                    },
                    jobWorkerExecutorConfiguration: {
                      type: "structure",
                      members: {
                        pollingAccounts: {
                          type: "list",
                          member: {}
                        },
                        pollingServicePrincipals: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  }
                },
                type: {},
                policyStatementsTemplate: {},
                jobTimeout: {
                  type: "integer"
                }
              }
            },
            id: {
              type: "structure",
              required: [
                "category",
                "owner",
                "provider",
                "version"
              ],
              members: {
                category: {},
                owner: {},
                provider: {},
                version: {}
              }
            },
            inputArtifactDetails: {
              shape: "S33"
            },
            outputArtifactDetails: {
              shape: "S33"
            },
            permissions: {
              type: "structure",
              required: [
                "allowedAccounts"
              ],
              members: {
                allowedAccounts: {
                  type: "list",
                  member: {}
                }
              }
            },
            properties: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "name",
                  "optional",
                  "key",
                  "noEcho"
                ],
                members: {
                  name: {},
                  optional: {
                    type: "boolean"
                  },
                  key: {
                    type: "boolean"
                  },
                  noEcho: {
                    type: "boolean"
                  },
                  queryable: {
                    type: "boolean"
                  },
                  description: {}
                }
              }
            },
            urls: {
              type: "structure",
              members: {
                configurationUrl: {},
                entityUrlTemplate: {},
                executionUrlTemplate: {},
                revisionUrlTemplate: {}
              }
            }
          }
        },
        S33: {
          type: "structure",
          required: [
            "minimumCount",
            "maximumCount"
          ],
          members: {
            minimumCount: {
              type: "integer"
            },
            maximumCount: {
              type: "integer"
            }
          }
        },
        S3g: {
          type: "structure",
          members: {
            actionTypeId: {
              shape: "Sw"
            },
            actionConfiguration: {
              shape: "S3h"
            },
            pipelineContext: {
              shape: "S3i"
            },
            inputArtifacts: {
              shape: "S3o"
            },
            outputArtifacts: {
              shape: "S3o"
            },
            artifactCredentials: {
              shape: "S3w"
            },
            continuationToken: {},
            encryptionKey: {
              shape: "S15"
            }
          }
        },
        S3h: {
          type: "structure",
          members: {
            configuration: {
              shape: "S1l"
            }
          }
        },
        S3i: {
          type: "structure",
          members: {
            pipelineName: {},
            stage: {
              type: "structure",
              members: {
                name: {}
              }
            },
            action: {
              type: "structure",
              members: {
                name: {},
                actionExecutionId: {}
              }
            },
            pipelineArn: {},
            pipelineExecutionId: {}
          }
        },
        S3o: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              revision: {},
              location: {
                type: "structure",
                members: {
                  type: {},
                  s3Location: {
                    type: "structure",
                    required: [
                      "bucketName",
                      "objectKey"
                    ],
                    members: {
                      bucketName: {},
                      objectKey: {}
                    }
                  }
                }
              }
            }
          }
        },
        S3w: {
          type: "structure",
          required: [
            "accessKeyId",
            "secretAccessKey",
            "sessionToken"
          ],
          members: {
            accessKeyId: {
              type: "string",
              sensitive: true
            },
            secretAccessKey: {
              type: "string",
              sensitive: true
            },
            sessionToken: {
              type: "string",
              sensitive: true
            }
          },
          sensitive: true
        },
        S4e: {
          type: "structure",
          members: {
            triggerType: {},
            triggerDetail: {}
          }
        },
        S4o: {
          type: "structure",
          required: [
            "pipelineExecutionId",
            "status"
          ],
          members: {
            pipelineExecutionId: {},
            status: {}
          }
        },
        S4w: {
          type: "structure",
          required: [
            "revisionId",
            "revisionChangeId",
            "created"
          ],
          members: {
            revisionId: {},
            revisionChangeId: {},
            created: {
              type: "timestamp"
            }
          }
        },
        S5k: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              s3location: {
                type: "structure",
                members: {
                  bucket: {},
                  key: {}
                }
              }
            }
          }
        },
        S5t: {
          type: "map",
          key: {},
          value: {}
        },
        S6i: {
          type: "structure",
          required: [
            "definition",
            "url"
          ],
          members: {
            definition: {
              shape: "S6j"
            },
            url: {},
            errorMessage: {},
            errorCode: {},
            lastTriggered: {
              type: "timestamp"
            },
            arn: {},
            tags: {
              shape: "Sq"
            }
          }
        },
        S6j: {
          type: "structure",
          required: [
            "name",
            "targetPipeline",
            "targetAction",
            "filters",
            "authentication",
            "authenticationConfiguration"
          ],
          members: {
            name: {},
            targetPipeline: {},
            targetAction: {},
            filters: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "jsonPath"
                ],
                members: {
                  jsonPath: {},
                  matchEquals: {}
                }
              }
            },
            authentication: {},
            authenticationConfiguration: {
              type: "structure",
              members: {
                AllowedIPRange: {},
                SecretToken: {}
              }
            }
          }
        },
        S7i: {
          type: "structure",
          required: [
            "type",
            "message"
          ],
          members: {
            type: {},
            message: {},
            externalExecutionId: {}
          }
        },
        S7l: {
          type: "structure",
          required: [
            "revision",
            "changeIdentifier"
          ],
          members: {
            revision: {},
            changeIdentifier: {},
            created: {
              type: "timestamp"
            },
            revisionSummary: {}
          }
        },
        S7n: {
          type: "structure",
          members: {
            summary: {},
            externalExecutionId: {},
            percentComplete: {
              type: "integer"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/codepipeline-2015-07-09.paginators.json
var require_codepipeline_2015_07_09_paginators = __commonJS({
  "node_modules/aws-sdk/apis/codepipeline-2015-07-09.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListActionExecutions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "actionExecutionDetails"
        },
        ListActionTypes: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "actionTypes"
        },
        ListPipelineExecutions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "pipelineExecutionSummaries"
        },
        ListPipelines: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "pipelines"
        },
        ListTagsForResource: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "tags"
        },
        ListWebhooks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "webhooks"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/codepipeline.js
var require_codepipeline = __commonJS({
  "node_modules/aws-sdk/clients/codepipeline.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["codepipeline"] = {};
    AWS2.CodePipeline = Service.defineService("codepipeline", ["2015-07-09"]);
    Object.defineProperty(apiLoader.services["codepipeline"], "2015-07-09", {
      get: function get() {
        var model = require_codepipeline_2015_07_09_min();
        model.paginators = require_codepipeline_2015_07_09_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CodePipeline;
  }
});

// node_modules/aws-sdk/apis/cognito-idp-2016-04-18.min.json
var require_cognito_idp_2016_04_18_min = __commonJS({
  "node_modules/aws-sdk/apis/cognito-idp-2016-04-18.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-04-18",
        endpointPrefix: "cognito-idp",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Cognito Identity Provider",
        serviceId: "Cognito Identity Provider",
        signatureVersion: "v4",
        targetPrefix: "AWSCognitoIdentityProviderService",
        uid: "cognito-idp-2016-04-18"
      },
      operations: {
        AddCustomAttributes: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "CustomAttributes"
            ],
            members: {
              UserPoolId: {},
              CustomAttributes: {
                type: "list",
                member: {
                  shape: "S4"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AdminAddUserToGroup: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username",
              "GroupName"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              },
              GroupName: {}
            }
          }
        },
        AdminConfirmSignUp: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              },
              ClientMetadata: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AdminCreateUser: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              },
              UserAttributes: {
                shape: "Sj"
              },
              ValidationData: {
                shape: "Sj"
              },
              TemporaryPassword: {
                shape: "Sn"
              },
              ForceAliasCreation: {
                type: "boolean"
              },
              MessageAction: {},
              DesiredDeliveryMediums: {
                type: "list",
                member: {}
              },
              ClientMetadata: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                shape: "St"
              }
            }
          }
        },
        AdminDeleteUser: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              }
            }
          }
        },
        AdminDeleteUserAttributes: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username",
              "UserAttributeNames"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              },
              UserAttributeNames: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AdminDisableProviderForUser: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "User"
            ],
            members: {
              UserPoolId: {},
              User: {
                shape: "S13"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AdminDisableUser: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AdminEnableUser: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AdminForgetDevice: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username",
              "DeviceKey"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              },
              DeviceKey: {}
            }
          }
        },
        AdminGetDevice: {
          input: {
            type: "structure",
            required: [
              "DeviceKey",
              "UserPoolId",
              "Username"
            ],
            members: {
              DeviceKey: {},
              UserPoolId: {},
              Username: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Device"
            ],
            members: {
              Device: {
                shape: "S1e"
              }
            }
          }
        },
        AdminGetUser: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Username"
            ],
            members: {
              Username: {
                shape: "Sd"
              },
              UserAttributes: {
                shape: "Sj"
              },
              UserCreateDate: {
                type: "timestamp"
              },
              UserLastModifiedDate: {
                type: "timestamp"
              },
              Enabled: {
                type: "boolean"
              },
              UserStatus: {},
              MFAOptions: {
                shape: "Sw"
              },
              PreferredMfaSetting: {},
              UserMFASettingList: {
                shape: "S1h"
              }
            }
          }
        },
        AdminInitiateAuth: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "ClientId",
              "AuthFlow"
            ],
            members: {
              UserPoolId: {},
              ClientId: {
                shape: "S1j"
              },
              AuthFlow: {},
              AuthParameters: {
                shape: "S1l"
              },
              ClientMetadata: {
                shape: "Sg"
              },
              AnalyticsMetadata: {
                shape: "S1m"
              },
              ContextData: {
                shape: "S1n"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChallengeName: {},
              Session: {
                shape: "S1s"
              },
              ChallengeParameters: {
                shape: "S1t"
              },
              AuthenticationResult: {
                shape: "S1u"
              }
            }
          }
        },
        AdminLinkProviderForUser: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "DestinationUser",
              "SourceUser"
            ],
            members: {
              UserPoolId: {},
              DestinationUser: {
                shape: "S13"
              },
              SourceUser: {
                shape: "S13"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AdminListDevices: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              },
              Limit: {
                type: "integer"
              },
              PaginationToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Devices: {
                shape: "S24"
              },
              PaginationToken: {}
            }
          }
        },
        AdminListGroupsForUser: {
          input: {
            type: "structure",
            required: [
              "Username",
              "UserPoolId"
            ],
            members: {
              Username: {
                shape: "Sd"
              },
              UserPoolId: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Groups: {
                shape: "S28"
              },
              NextToken: {}
            }
          }
        },
        AdminListUserAuthEvents: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AuthEvents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EventId: {},
                    EventType: {},
                    CreationDate: {
                      type: "timestamp"
                    },
                    EventResponse: {},
                    EventRisk: {
                      type: "structure",
                      members: {
                        RiskDecision: {},
                        RiskLevel: {},
                        CompromisedCredentialsDetected: {
                          type: "boolean"
                        }
                      }
                    },
                    ChallengeResponses: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ChallengeName: {},
                          ChallengeResponse: {}
                        }
                      }
                    },
                    EventContextData: {
                      type: "structure",
                      members: {
                        IpAddress: {},
                        DeviceName: {},
                        Timezone: {},
                        City: {},
                        Country: {}
                      }
                    },
                    EventFeedback: {
                      type: "structure",
                      required: [
                        "FeedbackValue",
                        "Provider"
                      ],
                      members: {
                        FeedbackValue: {},
                        Provider: {},
                        FeedbackDate: {
                          type: "timestamp"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        AdminRemoveUserFromGroup: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username",
              "GroupName"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              },
              GroupName: {}
            }
          }
        },
        AdminResetUserPassword: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              },
              ClientMetadata: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AdminRespondToAuthChallenge: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "ClientId",
              "ChallengeName"
            ],
            members: {
              UserPoolId: {},
              ClientId: {
                shape: "S1j"
              },
              ChallengeName: {},
              ChallengeResponses: {
                shape: "S2y"
              },
              Session: {
                shape: "S1s"
              },
              AnalyticsMetadata: {
                shape: "S1m"
              },
              ContextData: {
                shape: "S1n"
              },
              ClientMetadata: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChallengeName: {},
              Session: {
                shape: "S1s"
              },
              ChallengeParameters: {
                shape: "S1t"
              },
              AuthenticationResult: {
                shape: "S1u"
              }
            }
          }
        },
        AdminSetUserMFAPreference: {
          input: {
            type: "structure",
            required: [
              "Username",
              "UserPoolId"
            ],
            members: {
              SMSMfaSettings: {
                shape: "S31"
              },
              SoftwareTokenMfaSettings: {
                shape: "S32"
              },
              Username: {
                shape: "Sd"
              },
              UserPoolId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AdminSetUserPassword: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username",
              "Password"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              },
              Password: {
                shape: "Sn"
              },
              Permanent: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AdminSetUserSettings: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username",
              "MFAOptions"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              },
              MFAOptions: {
                shape: "Sw"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AdminUpdateAuthEventFeedback: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username",
              "EventId",
              "FeedbackValue"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              },
              EventId: {},
              FeedbackValue: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AdminUpdateDeviceStatus: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username",
              "DeviceKey"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              },
              DeviceKey: {},
              DeviceRememberedStatus: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AdminUpdateUserAttributes: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username",
              "UserAttributes"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              },
              UserAttributes: {
                shape: "Sj"
              },
              ClientMetadata: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AdminUserGlobalSignOut: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateSoftwareToken: {
          input: {
            type: "structure",
            members: {
              AccessToken: {
                shape: "S1v"
              },
              Session: {
                shape: "S1s"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SecretCode: {
                type: "string",
                sensitive: true
              },
              Session: {
                shape: "S1s"
              }
            }
          },
          authtype: "none"
        },
        ChangePassword: {
          input: {
            type: "structure",
            required: [
              "PreviousPassword",
              "ProposedPassword",
              "AccessToken"
            ],
            members: {
              PreviousPassword: {
                shape: "Sn"
              },
              ProposedPassword: {
                shape: "Sn"
              },
              AccessToken: {
                shape: "S1v"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          authtype: "none"
        },
        ConfirmDevice: {
          input: {
            type: "structure",
            required: [
              "AccessToken",
              "DeviceKey"
            ],
            members: {
              AccessToken: {
                shape: "S1v"
              },
              DeviceKey: {},
              DeviceSecretVerifierConfig: {
                type: "structure",
                members: {
                  PasswordVerifier: {},
                  Salt: {}
                }
              },
              DeviceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UserConfirmationNecessary: {
                type: "boolean"
              }
            }
          },
          authtype: "none"
        },
        ConfirmForgotPassword: {
          input: {
            type: "structure",
            required: [
              "ClientId",
              "Username",
              "ConfirmationCode",
              "Password"
            ],
            members: {
              ClientId: {
                shape: "S1j"
              },
              SecretHash: {
                shape: "S3s"
              },
              Username: {
                shape: "Sd"
              },
              ConfirmationCode: {},
              Password: {
                shape: "Sn"
              },
              AnalyticsMetadata: {
                shape: "S1m"
              },
              UserContextData: {
                shape: "S3u"
              },
              ClientMetadata: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          authtype: "none"
        },
        ConfirmSignUp: {
          input: {
            type: "structure",
            required: [
              "ClientId",
              "Username",
              "ConfirmationCode"
            ],
            members: {
              ClientId: {
                shape: "S1j"
              },
              SecretHash: {
                shape: "S3s"
              },
              Username: {
                shape: "Sd"
              },
              ConfirmationCode: {},
              ForceAliasCreation: {
                type: "boolean"
              },
              AnalyticsMetadata: {
                shape: "S1m"
              },
              UserContextData: {
                shape: "S3u"
              },
              ClientMetadata: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          authtype: "none"
        },
        CreateGroup: {
          input: {
            type: "structure",
            required: [
              "GroupName",
              "UserPoolId"
            ],
            members: {
              GroupName: {},
              UserPoolId: {},
              Description: {},
              RoleArn: {},
              Precedence: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Group: {
                shape: "S29"
              }
            }
          }
        },
        CreateIdentityProvider: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "ProviderName",
              "ProviderType",
              "ProviderDetails"
            ],
            members: {
              UserPoolId: {},
              ProviderName: {},
              ProviderType: {},
              ProviderDetails: {
                shape: "S43"
              },
              AttributeMapping: {
                shape: "S44"
              },
              IdpIdentifiers: {
                shape: "S46"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "IdentityProvider"
            ],
            members: {
              IdentityProvider: {
                shape: "S49"
              }
            }
          }
        },
        CreateResourceServer: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Identifier",
              "Name"
            ],
            members: {
              UserPoolId: {},
              Identifier: {},
              Name: {},
              Scopes: {
                shape: "S4d"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ResourceServer"
            ],
            members: {
              ResourceServer: {
                shape: "S4i"
              }
            }
          }
        },
        CreateUserImportJob: {
          input: {
            type: "structure",
            required: [
              "JobName",
              "UserPoolId",
              "CloudWatchLogsRoleArn"
            ],
            members: {
              JobName: {},
              UserPoolId: {},
              CloudWatchLogsRoleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UserImportJob: {
                shape: "S4m"
              }
            }
          }
        },
        CreateUserPool: {
          input: {
            type: "structure",
            required: [
              "PoolName"
            ],
            members: {
              PoolName: {},
              Policies: {
                shape: "S4u"
              },
              DeletionProtection: {},
              LambdaConfig: {
                shape: "S4z"
              },
              AutoVerifiedAttributes: {
                shape: "S56"
              },
              AliasAttributes: {
                shape: "S58"
              },
              UsernameAttributes: {
                shape: "S5a"
              },
              SmsVerificationMessage: {},
              EmailVerificationMessage: {},
              EmailVerificationSubject: {},
              VerificationMessageTemplate: {
                shape: "S5f"
              },
              SmsAuthenticationMessage: {},
              MfaConfiguration: {},
              UserAttributeUpdateSettings: {
                shape: "S5k"
              },
              DeviceConfiguration: {
                shape: "S5m"
              },
              EmailConfiguration: {
                shape: "S5n"
              },
              SmsConfiguration: {
                shape: "S5r"
              },
              UserPoolTags: {
                shape: "S5t"
              },
              AdminCreateUserConfig: {
                shape: "S5w"
              },
              Schema: {
                shape: "S5z"
              },
              UserPoolAddOns: {
                shape: "S60"
              },
              UsernameConfiguration: {
                shape: "S62"
              },
              AccountRecoverySetting: {
                shape: "S63"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserPool: {
                shape: "S69"
              }
            }
          }
        },
        CreateUserPoolClient: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "ClientName"
            ],
            members: {
              UserPoolId: {},
              ClientName: {},
              GenerateSecret: {
                type: "boolean"
              },
              RefreshTokenValidity: {
                type: "integer"
              },
              AccessTokenValidity: {
                type: "integer"
              },
              IdTokenValidity: {
                type: "integer"
              },
              TokenValidityUnits: {
                shape: "S6i"
              },
              ReadAttributes: {
                shape: "S6k"
              },
              WriteAttributes: {
                shape: "S6k"
              },
              ExplicitAuthFlows: {
                shape: "S6m"
              },
              SupportedIdentityProviders: {
                shape: "S6o"
              },
              CallbackURLs: {
                shape: "S6p"
              },
              LogoutURLs: {
                shape: "S6r"
              },
              DefaultRedirectURI: {},
              AllowedOAuthFlows: {
                shape: "S6s"
              },
              AllowedOAuthScopes: {
                shape: "S6u"
              },
              AllowedOAuthFlowsUserPoolClient: {
                type: "boolean"
              },
              AnalyticsConfiguration: {
                shape: "S6w"
              },
              PreventUserExistenceErrors: {},
              EnableTokenRevocation: {
                type: "boolean"
              },
              EnablePropagateAdditionalUserContextData: {
                type: "boolean"
              },
              AuthSessionValidity: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserPoolClient: {
                shape: "S71"
              }
            }
          }
        },
        CreateUserPoolDomain: {
          input: {
            type: "structure",
            required: [
              "Domain",
              "UserPoolId"
            ],
            members: {
              Domain: {},
              UserPoolId: {},
              CustomDomainConfig: {
                shape: "S74"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontDomain: {}
            }
          }
        },
        DeleteGroup: {
          input: {
            type: "structure",
            required: [
              "GroupName",
              "UserPoolId"
            ],
            members: {
              GroupName: {},
              UserPoolId: {}
            }
          }
        },
        DeleteIdentityProvider: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "ProviderName"
            ],
            members: {
              UserPoolId: {},
              ProviderName: {}
            }
          }
        },
        DeleteResourceServer: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Identifier"
            ],
            members: {
              UserPoolId: {},
              Identifier: {}
            }
          }
        },
        DeleteUser: {
          input: {
            type: "structure",
            required: [
              "AccessToken"
            ],
            members: {
              AccessToken: {
                shape: "S1v"
              }
            }
          },
          authtype: "none"
        },
        DeleteUserAttributes: {
          input: {
            type: "structure",
            required: [
              "UserAttributeNames",
              "AccessToken"
            ],
            members: {
              UserAttributeNames: {
                shape: "S10"
              },
              AccessToken: {
                shape: "S1v"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          authtype: "none"
        },
        DeleteUserPool: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {}
            }
          }
        },
        DeleteUserPoolClient: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "ClientId"
            ],
            members: {
              UserPoolId: {},
              ClientId: {
                shape: "S1j"
              }
            }
          }
        },
        DeleteUserPoolDomain: {
          input: {
            type: "structure",
            required: [
              "Domain",
              "UserPoolId"
            ],
            members: {
              Domain: {},
              UserPoolId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeIdentityProvider: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "ProviderName"
            ],
            members: {
              UserPoolId: {},
              ProviderName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "IdentityProvider"
            ],
            members: {
              IdentityProvider: {
                shape: "S49"
              }
            }
          }
        },
        DescribeResourceServer: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Identifier"
            ],
            members: {
              UserPoolId: {},
              Identifier: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ResourceServer"
            ],
            members: {
              ResourceServer: {
                shape: "S4i"
              }
            }
          }
        },
        DescribeRiskConfiguration: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {},
              ClientId: {
                shape: "S1j"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "RiskConfiguration"
            ],
            members: {
              RiskConfiguration: {
                shape: "S7m"
              }
            }
          }
        },
        DescribeUserImportJob: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "JobId"
            ],
            members: {
              UserPoolId: {},
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UserImportJob: {
                shape: "S4m"
              }
            }
          }
        },
        DescribeUserPool: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UserPool: {
                shape: "S69"
              }
            }
          }
        },
        DescribeUserPoolClient: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "ClientId"
            ],
            members: {
              UserPoolId: {},
              ClientId: {
                shape: "S1j"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserPoolClient: {
                shape: "S71"
              }
            }
          }
        },
        DescribeUserPoolDomain: {
          input: {
            type: "structure",
            required: [
              "Domain"
            ],
            members: {
              Domain: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DomainDescription: {
                type: "structure",
                members: {
                  UserPoolId: {},
                  AWSAccountId: {},
                  Domain: {},
                  S3Bucket: {},
                  CloudFrontDistribution: {},
                  Version: {},
                  Status: {},
                  CustomDomainConfig: {
                    shape: "S74"
                  }
                }
              }
            }
          }
        },
        ForgetDevice: {
          input: {
            type: "structure",
            required: [
              "DeviceKey"
            ],
            members: {
              AccessToken: {
                shape: "S1v"
              },
              DeviceKey: {}
            }
          },
          authtype: "none"
        },
        ForgotPassword: {
          input: {
            type: "structure",
            required: [
              "ClientId",
              "Username"
            ],
            members: {
              ClientId: {
                shape: "S1j"
              },
              SecretHash: {
                shape: "S3s"
              },
              UserContextData: {
                shape: "S3u"
              },
              Username: {
                shape: "Sd"
              },
              AnalyticsMetadata: {
                shape: "S1m"
              },
              ClientMetadata: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CodeDeliveryDetails: {
                shape: "S8k"
              }
            }
          },
          authtype: "none"
        },
        GetCSVHeader: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UserPoolId: {},
              CSVHeader: {
                type: "list",
                member: {}
              }
            }
          }
        },
        GetDevice: {
          input: {
            type: "structure",
            required: [
              "DeviceKey"
            ],
            members: {
              DeviceKey: {},
              AccessToken: {
                shape: "S1v"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Device"
            ],
            members: {
              Device: {
                shape: "S1e"
              }
            }
          },
          authtype: "none"
        },
        GetGroup: {
          input: {
            type: "structure",
            required: [
              "GroupName",
              "UserPoolId"
            ],
            members: {
              GroupName: {},
              UserPoolId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Group: {
                shape: "S29"
              }
            }
          }
        },
        GetIdentityProviderByIdentifier: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "IdpIdentifier"
            ],
            members: {
              UserPoolId: {},
              IdpIdentifier: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "IdentityProvider"
            ],
            members: {
              IdentityProvider: {
                shape: "S49"
              }
            }
          }
        },
        GetLogDeliveryConfiguration: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LogDeliveryConfiguration: {
                shape: "S8w"
              }
            }
          }
        },
        GetSigningCertificate: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Certificate: {}
            }
          }
        },
        GetUICustomization: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {},
              ClientId: {
                shape: "S1j"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UICustomization"
            ],
            members: {
              UICustomization: {
                shape: "S96"
              }
            }
          }
        },
        GetUser: {
          input: {
            type: "structure",
            required: [
              "AccessToken"
            ],
            members: {
              AccessToken: {
                shape: "S1v"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Username",
              "UserAttributes"
            ],
            members: {
              Username: {
                shape: "Sd"
              },
              UserAttributes: {
                shape: "Sj"
              },
              MFAOptions: {
                shape: "Sw"
              },
              PreferredMfaSetting: {},
              UserMFASettingList: {
                shape: "S1h"
              }
            }
          },
          authtype: "none"
        },
        GetUserAttributeVerificationCode: {
          input: {
            type: "structure",
            required: [
              "AccessToken",
              "AttributeName"
            ],
            members: {
              AccessToken: {
                shape: "S1v"
              },
              AttributeName: {},
              ClientMetadata: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CodeDeliveryDetails: {
                shape: "S8k"
              }
            }
          },
          authtype: "none"
        },
        GetUserPoolMfaConfig: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SmsMfaConfiguration: {
                shape: "S9g"
              },
              SoftwareTokenMfaConfiguration: {
                shape: "S9h"
              },
              MfaConfiguration: {}
            }
          }
        },
        GlobalSignOut: {
          input: {
            type: "structure",
            required: [
              "AccessToken"
            ],
            members: {
              AccessToken: {
                shape: "S1v"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          authtype: "none"
        },
        InitiateAuth: {
          input: {
            type: "structure",
            required: [
              "AuthFlow",
              "ClientId"
            ],
            members: {
              AuthFlow: {},
              AuthParameters: {
                shape: "S1l"
              },
              ClientMetadata: {
                shape: "Sg"
              },
              ClientId: {
                shape: "S1j"
              },
              AnalyticsMetadata: {
                shape: "S1m"
              },
              UserContextData: {
                shape: "S3u"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChallengeName: {},
              Session: {
                shape: "S1s"
              },
              ChallengeParameters: {
                shape: "S1t"
              },
              AuthenticationResult: {
                shape: "S1u"
              }
            }
          },
          authtype: "none"
        },
        ListDevices: {
          input: {
            type: "structure",
            required: [
              "AccessToken"
            ],
            members: {
              AccessToken: {
                shape: "S1v"
              },
              Limit: {
                type: "integer"
              },
              PaginationToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Devices: {
                shape: "S24"
              },
              PaginationToken: {}
            }
          },
          authtype: "none"
        },
        ListGroups: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Groups: {
                shape: "S28"
              },
              NextToken: {}
            }
          }
        },
        ListIdentityProviders: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Providers"
            ],
            members: {
              Providers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ProviderName: {},
                    ProviderType: {},
                    LastModifiedDate: {
                      type: "timestamp"
                    },
                    CreationDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListResourceServers: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ResourceServers"
            ],
            members: {
              ResourceServers: {
                type: "list",
                member: {
                  shape: "S4i"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S5t"
              }
            }
          }
        },
        ListUserImportJobs: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "MaxResults"
            ],
            members: {
              UserPoolId: {},
              MaxResults: {
                type: "integer"
              },
              PaginationToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UserImportJobs: {
                type: "list",
                member: {
                  shape: "S4m"
                }
              },
              PaginationToken: {}
            }
          }
        },
        ListUserPoolClients: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UserPoolClients: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ClientId: {
                      shape: "S1j"
                    },
                    UserPoolId: {},
                    ClientName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListUserPools: {
          input: {
            type: "structure",
            required: [
              "MaxResults"
            ],
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserPools: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Name: {},
                    LambdaConfig: {
                      shape: "S4z"
                    },
                    Status: {
                      deprecated: true,
                      deprecatedMessage: "This property is no longer available."
                    },
                    LastModifiedDate: {
                      type: "timestamp"
                    },
                    CreationDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListUsers: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {},
              AttributesToGet: {
                type: "list",
                member: {}
              },
              Limit: {
                type: "integer"
              },
              PaginationToken: {},
              Filter: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Users: {
                shape: "Saj"
              },
              PaginationToken: {}
            }
          }
        },
        ListUsersInGroup: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "GroupName"
            ],
            members: {
              UserPoolId: {},
              GroupName: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Users: {
                shape: "Saj"
              },
              NextToken: {}
            }
          }
        },
        ResendConfirmationCode: {
          input: {
            type: "structure",
            required: [
              "ClientId",
              "Username"
            ],
            members: {
              ClientId: {
                shape: "S1j"
              },
              SecretHash: {
                shape: "S3s"
              },
              UserContextData: {
                shape: "S3u"
              },
              Username: {
                shape: "Sd"
              },
              AnalyticsMetadata: {
                shape: "S1m"
              },
              ClientMetadata: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CodeDeliveryDetails: {
                shape: "S8k"
              }
            }
          },
          authtype: "none"
        },
        RespondToAuthChallenge: {
          input: {
            type: "structure",
            required: [
              "ClientId",
              "ChallengeName"
            ],
            members: {
              ClientId: {
                shape: "S1j"
              },
              ChallengeName: {},
              Session: {
                shape: "S1s"
              },
              ChallengeResponses: {
                shape: "S2y"
              },
              AnalyticsMetadata: {
                shape: "S1m"
              },
              UserContextData: {
                shape: "S3u"
              },
              ClientMetadata: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChallengeName: {},
              Session: {
                shape: "S1s"
              },
              ChallengeParameters: {
                shape: "S1t"
              },
              AuthenticationResult: {
                shape: "S1u"
              }
            }
          },
          authtype: "none"
        },
        RevokeToken: {
          input: {
            type: "structure",
            required: [
              "Token",
              "ClientId"
            ],
            members: {
              Token: {
                shape: "S1v"
              },
              ClientId: {
                shape: "S1j"
              },
              ClientSecret: {
                shape: "S72"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          authtype: "none"
        },
        SetLogDeliveryConfiguration: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "LogConfigurations"
            ],
            members: {
              UserPoolId: {},
              LogConfigurations: {
                shape: "S8x"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LogDeliveryConfiguration: {
                shape: "S8w"
              }
            }
          }
        },
        SetRiskConfiguration: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {},
              ClientId: {
                shape: "S1j"
              },
              CompromisedCredentialsRiskConfiguration: {
                shape: "S7n"
              },
              AccountTakeoverRiskConfiguration: {
                shape: "S7s"
              },
              RiskExceptionConfiguration: {
                shape: "S81"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "RiskConfiguration"
            ],
            members: {
              RiskConfiguration: {
                shape: "S7m"
              }
            }
          }
        },
        SetUICustomization: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {},
              ClientId: {
                shape: "S1j"
              },
              CSS: {},
              ImageFile: {
                type: "blob"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UICustomization"
            ],
            members: {
              UICustomization: {
                shape: "S96"
              }
            }
          }
        },
        SetUserMFAPreference: {
          input: {
            type: "structure",
            required: [
              "AccessToken"
            ],
            members: {
              SMSMfaSettings: {
                shape: "S31"
              },
              SoftwareTokenMfaSettings: {
                shape: "S32"
              },
              AccessToken: {
                shape: "S1v"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          authtype: "none"
        },
        SetUserPoolMfaConfig: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {},
              SmsMfaConfiguration: {
                shape: "S9g"
              },
              SoftwareTokenMfaConfiguration: {
                shape: "S9h"
              },
              MfaConfiguration: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SmsMfaConfiguration: {
                shape: "S9g"
              },
              SoftwareTokenMfaConfiguration: {
                shape: "S9h"
              },
              MfaConfiguration: {}
            }
          }
        },
        SetUserSettings: {
          input: {
            type: "structure",
            required: [
              "AccessToken",
              "MFAOptions"
            ],
            members: {
              AccessToken: {
                shape: "S1v"
              },
              MFAOptions: {
                shape: "Sw"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          authtype: "none"
        },
        SignUp: {
          input: {
            type: "structure",
            required: [
              "ClientId",
              "Username",
              "Password"
            ],
            members: {
              ClientId: {
                shape: "S1j"
              },
              SecretHash: {
                shape: "S3s"
              },
              Username: {
                shape: "Sd"
              },
              Password: {
                shape: "Sn"
              },
              UserAttributes: {
                shape: "Sj"
              },
              ValidationData: {
                shape: "Sj"
              },
              AnalyticsMetadata: {
                shape: "S1m"
              },
              UserContextData: {
                shape: "S3u"
              },
              ClientMetadata: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UserConfirmed",
              "UserSub"
            ],
            members: {
              UserConfirmed: {
                type: "boolean"
              },
              CodeDeliveryDetails: {
                shape: "S8k"
              },
              UserSub: {}
            }
          },
          authtype: "none"
        },
        StartUserImportJob: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "JobId"
            ],
            members: {
              UserPoolId: {},
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UserImportJob: {
                shape: "S4m"
              }
            }
          }
        },
        StopUserImportJob: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "JobId"
            ],
            members: {
              UserPoolId: {},
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UserImportJob: {
                shape: "S4m"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S5t"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAuthEventFeedback: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username",
              "EventId",
              "FeedbackToken",
              "FeedbackValue"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              },
              EventId: {},
              FeedbackToken: {
                shape: "S1v"
              },
              FeedbackValue: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          authtype: "none"
        },
        UpdateDeviceStatus: {
          input: {
            type: "structure",
            required: [
              "AccessToken",
              "DeviceKey"
            ],
            members: {
              AccessToken: {
                shape: "S1v"
              },
              DeviceKey: {},
              DeviceRememberedStatus: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          authtype: "none"
        },
        UpdateGroup: {
          input: {
            type: "structure",
            required: [
              "GroupName",
              "UserPoolId"
            ],
            members: {
              GroupName: {},
              UserPoolId: {},
              Description: {},
              RoleArn: {},
              Precedence: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Group: {
                shape: "S29"
              }
            }
          }
        },
        UpdateIdentityProvider: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "ProviderName"
            ],
            members: {
              UserPoolId: {},
              ProviderName: {},
              ProviderDetails: {
                shape: "S43"
              },
              AttributeMapping: {
                shape: "S44"
              },
              IdpIdentifiers: {
                shape: "S46"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "IdentityProvider"
            ],
            members: {
              IdentityProvider: {
                shape: "S49"
              }
            }
          }
        },
        UpdateResourceServer: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Identifier",
              "Name"
            ],
            members: {
              UserPoolId: {},
              Identifier: {},
              Name: {},
              Scopes: {
                shape: "S4d"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ResourceServer"
            ],
            members: {
              ResourceServer: {
                shape: "S4i"
              }
            }
          }
        },
        UpdateUserAttributes: {
          input: {
            type: "structure",
            required: [
              "UserAttributes",
              "AccessToken"
            ],
            members: {
              UserAttributes: {
                shape: "Sj"
              },
              AccessToken: {
                shape: "S1v"
              },
              ClientMetadata: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CodeDeliveryDetailsList: {
                type: "list",
                member: {
                  shape: "S8k"
                }
              }
            }
          },
          authtype: "none"
        },
        UpdateUserPool: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {},
              Policies: {
                shape: "S4u"
              },
              DeletionProtection: {},
              LambdaConfig: {
                shape: "S4z"
              },
              AutoVerifiedAttributes: {
                shape: "S56"
              },
              SmsVerificationMessage: {},
              EmailVerificationMessage: {},
              EmailVerificationSubject: {},
              VerificationMessageTemplate: {
                shape: "S5f"
              },
              SmsAuthenticationMessage: {},
              UserAttributeUpdateSettings: {
                shape: "S5k"
              },
              MfaConfiguration: {},
              DeviceConfiguration: {
                shape: "S5m"
              },
              EmailConfiguration: {
                shape: "S5n"
              },
              SmsConfiguration: {
                shape: "S5r"
              },
              UserPoolTags: {
                shape: "S5t"
              },
              AdminCreateUserConfig: {
                shape: "S5w"
              },
              UserPoolAddOns: {
                shape: "S60"
              },
              AccountRecoverySetting: {
                shape: "S63"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateUserPoolClient: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "ClientId"
            ],
            members: {
              UserPoolId: {},
              ClientId: {
                shape: "S1j"
              },
              ClientName: {},
              RefreshTokenValidity: {
                type: "integer"
              },
              AccessTokenValidity: {
                type: "integer"
              },
              IdTokenValidity: {
                type: "integer"
              },
              TokenValidityUnits: {
                shape: "S6i"
              },
              ReadAttributes: {
                shape: "S6k"
              },
              WriteAttributes: {
                shape: "S6k"
              },
              ExplicitAuthFlows: {
                shape: "S6m"
              },
              SupportedIdentityProviders: {
                shape: "S6o"
              },
              CallbackURLs: {
                shape: "S6p"
              },
              LogoutURLs: {
                shape: "S6r"
              },
              DefaultRedirectURI: {},
              AllowedOAuthFlows: {
                shape: "S6s"
              },
              AllowedOAuthScopes: {
                shape: "S6u"
              },
              AllowedOAuthFlowsUserPoolClient: {
                type: "boolean"
              },
              AnalyticsConfiguration: {
                shape: "S6w"
              },
              PreventUserExistenceErrors: {},
              EnableTokenRevocation: {
                type: "boolean"
              },
              EnablePropagateAdditionalUserContextData: {
                type: "boolean"
              },
              AuthSessionValidity: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserPoolClient: {
                shape: "S71"
              }
            }
          }
        },
        UpdateUserPoolDomain: {
          input: {
            type: "structure",
            required: [
              "Domain",
              "UserPoolId",
              "CustomDomainConfig"
            ],
            members: {
              Domain: {},
              UserPoolId: {},
              CustomDomainConfig: {
                shape: "S74"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontDomain: {}
            }
          }
        },
        VerifySoftwareToken: {
          input: {
            type: "structure",
            required: [
              "UserCode"
            ],
            members: {
              AccessToken: {
                shape: "S1v"
              },
              Session: {
                shape: "S1s"
              },
              UserCode: {
                type: "string",
                sensitive: true
              },
              FriendlyDeviceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {},
              Session: {
                shape: "S1s"
              }
            }
          },
          authtype: "none"
        },
        VerifyUserAttribute: {
          input: {
            type: "structure",
            required: [
              "AccessToken",
              "AttributeName",
              "Code"
            ],
            members: {
              AccessToken: {
                shape: "S1v"
              },
              AttributeName: {},
              Code: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          authtype: "none"
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            Name: {},
            AttributeDataType: {},
            DeveloperOnlyAttribute: {
              type: "boolean"
            },
            Mutable: {
              type: "boolean"
            },
            Required: {
              type: "boolean"
            },
            NumberAttributeConstraints: {
              type: "structure",
              members: {
                MinValue: {},
                MaxValue: {}
              }
            },
            StringAttributeConstraints: {
              type: "structure",
              members: {
                MinLength: {},
                MaxLength: {}
              }
            }
          }
        },
        Sd: {
          type: "string",
          sensitive: true
        },
        Sg: {
          type: "map",
          key: {},
          value: {}
        },
        Sj: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Value: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        Sn: {
          type: "string",
          sensitive: true
        },
        St: {
          type: "structure",
          members: {
            Username: {
              shape: "Sd"
            },
            Attributes: {
              shape: "Sj"
            },
            UserCreateDate: {
              type: "timestamp"
            },
            UserLastModifiedDate: {
              type: "timestamp"
            },
            Enabled: {
              type: "boolean"
            },
            UserStatus: {},
            MFAOptions: {
              shape: "Sw"
            }
          }
        },
        Sw: {
          type: "list",
          member: {
            type: "structure",
            members: {
              DeliveryMedium: {},
              AttributeName: {}
            }
          }
        },
        S10: {
          type: "list",
          member: {}
        },
        S13: {
          type: "structure",
          members: {
            ProviderName: {},
            ProviderAttributeName: {},
            ProviderAttributeValue: {}
          }
        },
        S1e: {
          type: "structure",
          members: {
            DeviceKey: {},
            DeviceAttributes: {
              shape: "Sj"
            },
            DeviceCreateDate: {
              type: "timestamp"
            },
            DeviceLastModifiedDate: {
              type: "timestamp"
            },
            DeviceLastAuthenticatedDate: {
              type: "timestamp"
            }
          }
        },
        S1h: {
          type: "list",
          member: {}
        },
        S1j: {
          type: "string",
          sensitive: true
        },
        S1l: {
          type: "map",
          key: {},
          value: {},
          sensitive: true
        },
        S1m: {
          type: "structure",
          members: {
            AnalyticsEndpointId: {}
          }
        },
        S1n: {
          type: "structure",
          required: [
            "IpAddress",
            "ServerName",
            "ServerPath",
            "HttpHeaders"
          ],
          members: {
            IpAddress: {},
            ServerName: {},
            ServerPath: {},
            HttpHeaders: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  headerName: {},
                  headerValue: {}
                }
              }
            },
            EncodedData: {}
          }
        },
        S1s: {
          type: "string",
          sensitive: true
        },
        S1t: {
          type: "map",
          key: {},
          value: {}
        },
        S1u: {
          type: "structure",
          members: {
            AccessToken: {
              shape: "S1v"
            },
            ExpiresIn: {
              type: "integer"
            },
            TokenType: {},
            RefreshToken: {
              shape: "S1v"
            },
            IdToken: {
              shape: "S1v"
            },
            NewDeviceMetadata: {
              type: "structure",
              members: {
                DeviceKey: {},
                DeviceGroupKey: {}
              }
            }
          }
        },
        S1v: {
          type: "string",
          sensitive: true
        },
        S24: {
          type: "list",
          member: {
            shape: "S1e"
          }
        },
        S28: {
          type: "list",
          member: {
            shape: "S29"
          }
        },
        S29: {
          type: "structure",
          members: {
            GroupName: {},
            UserPoolId: {},
            Description: {},
            RoleArn: {},
            Precedence: {
              type: "integer"
            },
            LastModifiedDate: {
              type: "timestamp"
            },
            CreationDate: {
              type: "timestamp"
            }
          }
        },
        S2y: {
          type: "map",
          key: {},
          value: {},
          sensitive: true
        },
        S31: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            PreferredMfa: {
              type: "boolean"
            }
          }
        },
        S32: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            PreferredMfa: {
              type: "boolean"
            }
          }
        },
        S3s: {
          type: "string",
          sensitive: true
        },
        S3u: {
          type: "structure",
          members: {
            IpAddress: {},
            EncodedData: {}
          },
          sensitive: true
        },
        S43: {
          type: "map",
          key: {},
          value: {}
        },
        S44: {
          type: "map",
          key: {},
          value: {}
        },
        S46: {
          type: "list",
          member: {}
        },
        S49: {
          type: "structure",
          members: {
            UserPoolId: {},
            ProviderName: {},
            ProviderType: {},
            ProviderDetails: {
              shape: "S43"
            },
            AttributeMapping: {
              shape: "S44"
            },
            IdpIdentifiers: {
              shape: "S46"
            },
            LastModifiedDate: {
              type: "timestamp"
            },
            CreationDate: {
              type: "timestamp"
            }
          }
        },
        S4d: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ScopeName",
              "ScopeDescription"
            ],
            members: {
              ScopeName: {},
              ScopeDescription: {}
            }
          }
        },
        S4i: {
          type: "structure",
          members: {
            UserPoolId: {},
            Identifier: {},
            Name: {},
            Scopes: {
              shape: "S4d"
            }
          }
        },
        S4m: {
          type: "structure",
          members: {
            JobName: {},
            JobId: {},
            UserPoolId: {},
            PreSignedUrl: {},
            CreationDate: {
              type: "timestamp"
            },
            StartDate: {
              type: "timestamp"
            },
            CompletionDate: {
              type: "timestamp"
            },
            Status: {},
            CloudWatchLogsRoleArn: {},
            ImportedUsers: {
              type: "long"
            },
            SkippedUsers: {
              type: "long"
            },
            FailedUsers: {
              type: "long"
            },
            CompletionMessage: {}
          }
        },
        S4u: {
          type: "structure",
          members: {
            PasswordPolicy: {
              type: "structure",
              members: {
                MinimumLength: {
                  type: "integer"
                },
                RequireUppercase: {
                  type: "boolean"
                },
                RequireLowercase: {
                  type: "boolean"
                },
                RequireNumbers: {
                  type: "boolean"
                },
                RequireSymbols: {
                  type: "boolean"
                },
                TemporaryPasswordValidityDays: {
                  type: "integer"
                }
              }
            }
          }
        },
        S4z: {
          type: "structure",
          members: {
            PreSignUp: {},
            CustomMessage: {},
            PostConfirmation: {},
            PreAuthentication: {},
            PostAuthentication: {},
            DefineAuthChallenge: {},
            CreateAuthChallenge: {},
            VerifyAuthChallengeResponse: {},
            PreTokenGeneration: {},
            PreTokenGenerationConfig: {
              type: "structure",
              required: [
                "LambdaVersion",
                "LambdaArn"
              ],
              members: {
                LambdaVersion: {},
                LambdaArn: {}
              }
            },
            UserMigration: {},
            CustomSMSSender: {
              type: "structure",
              required: [
                "LambdaVersion",
                "LambdaArn"
              ],
              members: {
                LambdaVersion: {},
                LambdaArn: {}
              }
            },
            CustomEmailSender: {
              type: "structure",
              required: [
                "LambdaVersion",
                "LambdaArn"
              ],
              members: {
                LambdaVersion: {},
                LambdaArn: {}
              }
            },
            KMSKeyID: {}
          }
        },
        S56: {
          type: "list",
          member: {}
        },
        S58: {
          type: "list",
          member: {}
        },
        S5a: {
          type: "list",
          member: {}
        },
        S5f: {
          type: "structure",
          members: {
            SmsMessage: {},
            EmailMessage: {},
            EmailSubject: {},
            EmailMessageByLink: {},
            EmailSubjectByLink: {},
            DefaultEmailOption: {}
          }
        },
        S5k: {
          type: "structure",
          members: {
            AttributesRequireVerificationBeforeUpdate: {
              type: "list",
              member: {}
            }
          }
        },
        S5m: {
          type: "structure",
          members: {
            ChallengeRequiredOnNewDevice: {
              type: "boolean"
            },
            DeviceOnlyRememberedOnUserPrompt: {
              type: "boolean"
            }
          }
        },
        S5n: {
          type: "structure",
          members: {
            SourceArn: {},
            ReplyToEmailAddress: {},
            EmailSendingAccount: {},
            From: {},
            ConfigurationSet: {}
          }
        },
        S5r: {
          type: "structure",
          required: [
            "SnsCallerArn"
          ],
          members: {
            SnsCallerArn: {},
            ExternalId: {},
            SnsRegion: {}
          }
        },
        S5t: {
          type: "map",
          key: {},
          value: {}
        },
        S5w: {
          type: "structure",
          members: {
            AllowAdminCreateUserOnly: {
              type: "boolean"
            },
            UnusedAccountValidityDays: {
              type: "integer"
            },
            InviteMessageTemplate: {
              type: "structure",
              members: {
                SMSMessage: {},
                EmailMessage: {},
                EmailSubject: {}
              }
            }
          }
        },
        S5z: {
          type: "list",
          member: {
            shape: "S4"
          }
        },
        S60: {
          type: "structure",
          required: [
            "AdvancedSecurityMode"
          ],
          members: {
            AdvancedSecurityMode: {}
          }
        },
        S62: {
          type: "structure",
          required: [
            "CaseSensitive"
          ],
          members: {
            CaseSensitive: {
              type: "boolean"
            }
          }
        },
        S63: {
          type: "structure",
          members: {
            RecoveryMechanisms: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Priority",
                  "Name"
                ],
                members: {
                  Priority: {
                    type: "integer"
                  },
                  Name: {}
                }
              }
            }
          }
        },
        S69: {
          type: "structure",
          members: {
            Id: {},
            Name: {},
            Policies: {
              shape: "S4u"
            },
            DeletionProtection: {},
            LambdaConfig: {
              shape: "S4z"
            },
            Status: {
              deprecated: true,
              deprecatedMessage: "This property is no longer available."
            },
            LastModifiedDate: {
              type: "timestamp"
            },
            CreationDate: {
              type: "timestamp"
            },
            SchemaAttributes: {
              shape: "S5z"
            },
            AutoVerifiedAttributes: {
              shape: "S56"
            },
            AliasAttributes: {
              shape: "S58"
            },
            UsernameAttributes: {
              shape: "S5a"
            },
            SmsVerificationMessage: {},
            EmailVerificationMessage: {},
            EmailVerificationSubject: {},
            VerificationMessageTemplate: {
              shape: "S5f"
            },
            SmsAuthenticationMessage: {},
            UserAttributeUpdateSettings: {
              shape: "S5k"
            },
            MfaConfiguration: {},
            DeviceConfiguration: {
              shape: "S5m"
            },
            EstimatedNumberOfUsers: {
              type: "integer"
            },
            EmailConfiguration: {
              shape: "S5n"
            },
            SmsConfiguration: {
              shape: "S5r"
            },
            UserPoolTags: {
              shape: "S5t"
            },
            SmsConfigurationFailure: {},
            EmailConfigurationFailure: {},
            Domain: {},
            CustomDomain: {},
            AdminCreateUserConfig: {
              shape: "S5w"
            },
            UserPoolAddOns: {
              shape: "S60"
            },
            UsernameConfiguration: {
              shape: "S62"
            },
            Arn: {},
            AccountRecoverySetting: {
              shape: "S63"
            }
          }
        },
        S6i: {
          type: "structure",
          members: {
            AccessToken: {},
            IdToken: {},
            RefreshToken: {}
          }
        },
        S6k: {
          type: "list",
          member: {}
        },
        S6m: {
          type: "list",
          member: {}
        },
        S6o: {
          type: "list",
          member: {}
        },
        S6p: {
          type: "list",
          member: {}
        },
        S6r: {
          type: "list",
          member: {}
        },
        S6s: {
          type: "list",
          member: {}
        },
        S6u: {
          type: "list",
          member: {}
        },
        S6w: {
          type: "structure",
          members: {
            ApplicationId: {},
            ApplicationArn: {},
            RoleArn: {},
            ExternalId: {},
            UserDataShared: {
              type: "boolean"
            }
          }
        },
        S71: {
          type: "structure",
          members: {
            UserPoolId: {},
            ClientName: {},
            ClientId: {
              shape: "S1j"
            },
            ClientSecret: {
              shape: "S72"
            },
            LastModifiedDate: {
              type: "timestamp"
            },
            CreationDate: {
              type: "timestamp"
            },
            RefreshTokenValidity: {
              type: "integer"
            },
            AccessTokenValidity: {
              type: "integer"
            },
            IdTokenValidity: {
              type: "integer"
            },
            TokenValidityUnits: {
              shape: "S6i"
            },
            ReadAttributes: {
              shape: "S6k"
            },
            WriteAttributes: {
              shape: "S6k"
            },
            ExplicitAuthFlows: {
              shape: "S6m"
            },
            SupportedIdentityProviders: {
              shape: "S6o"
            },
            CallbackURLs: {
              shape: "S6p"
            },
            LogoutURLs: {
              shape: "S6r"
            },
            DefaultRedirectURI: {},
            AllowedOAuthFlows: {
              shape: "S6s"
            },
            AllowedOAuthScopes: {
              shape: "S6u"
            },
            AllowedOAuthFlowsUserPoolClient: {
              type: "boolean"
            },
            AnalyticsConfiguration: {
              shape: "S6w"
            },
            PreventUserExistenceErrors: {},
            EnableTokenRevocation: {
              type: "boolean"
            },
            EnablePropagateAdditionalUserContextData: {
              type: "boolean"
            },
            AuthSessionValidity: {
              type: "integer"
            }
          }
        },
        S72: {
          type: "string",
          sensitive: true
        },
        S74: {
          type: "structure",
          required: [
            "CertificateArn"
          ],
          members: {
            CertificateArn: {}
          }
        },
        S7m: {
          type: "structure",
          members: {
            UserPoolId: {},
            ClientId: {
              shape: "S1j"
            },
            CompromisedCredentialsRiskConfiguration: {
              shape: "S7n"
            },
            AccountTakeoverRiskConfiguration: {
              shape: "S7s"
            },
            RiskExceptionConfiguration: {
              shape: "S81"
            },
            LastModifiedDate: {
              type: "timestamp"
            }
          }
        },
        S7n: {
          type: "structure",
          required: [
            "Actions"
          ],
          members: {
            EventFilter: {
              type: "list",
              member: {}
            },
            Actions: {
              type: "structure",
              required: [
                "EventAction"
              ],
              members: {
                EventAction: {}
              }
            }
          }
        },
        S7s: {
          type: "structure",
          required: [
            "Actions"
          ],
          members: {
            NotifyConfiguration: {
              type: "structure",
              required: [
                "SourceArn"
              ],
              members: {
                From: {},
                ReplyTo: {},
                SourceArn: {},
                BlockEmail: {
                  shape: "S7u"
                },
                NoActionEmail: {
                  shape: "S7u"
                },
                MfaEmail: {
                  shape: "S7u"
                }
              }
            },
            Actions: {
              type: "structure",
              members: {
                LowAction: {
                  shape: "S7y"
                },
                MediumAction: {
                  shape: "S7y"
                },
                HighAction: {
                  shape: "S7y"
                }
              }
            }
          }
        },
        S7u: {
          type: "structure",
          required: [
            "Subject"
          ],
          members: {
            Subject: {},
            HtmlBody: {},
            TextBody: {}
          }
        },
        S7y: {
          type: "structure",
          required: [
            "Notify",
            "EventAction"
          ],
          members: {
            Notify: {
              type: "boolean"
            },
            EventAction: {}
          }
        },
        S81: {
          type: "structure",
          members: {
            BlockedIPRangeList: {
              type: "list",
              member: {}
            },
            SkippedIPRangeList: {
              type: "list",
              member: {}
            }
          }
        },
        S8k: {
          type: "structure",
          members: {
            Destination: {},
            DeliveryMedium: {},
            AttributeName: {}
          }
        },
        S8w: {
          type: "structure",
          required: [
            "UserPoolId",
            "LogConfigurations"
          ],
          members: {
            UserPoolId: {},
            LogConfigurations: {
              shape: "S8x"
            }
          }
        },
        S8x: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "LogLevel",
              "EventSource"
            ],
            members: {
              LogLevel: {},
              EventSource: {},
              CloudWatchLogsConfiguration: {
                type: "structure",
                members: {
                  LogGroupArn: {}
                }
              }
            }
          }
        },
        S96: {
          type: "structure",
          members: {
            UserPoolId: {},
            ClientId: {
              shape: "S1j"
            },
            ImageUrl: {},
            CSS: {},
            CSSVersion: {},
            LastModifiedDate: {
              type: "timestamp"
            },
            CreationDate: {
              type: "timestamp"
            }
          }
        },
        S9g: {
          type: "structure",
          members: {
            SmsAuthenticationMessage: {},
            SmsConfiguration: {
              shape: "S5r"
            }
          }
        },
        S9h: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            }
          }
        },
        Saj: {
          type: "list",
          member: {
            shape: "St"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cognito-idp-2016-04-18.paginators.json
var require_cognito_idp_2016_04_18_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cognito-idp-2016-04-18.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        AdminListGroupsForUser: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "Groups"
        },
        AdminListUserAuthEvents: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "AuthEvents"
        },
        ListGroups: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "Groups"
        },
        ListIdentityProviders: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Providers"
        },
        ListResourceServers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ResourceServers"
        },
        ListUserPoolClients: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "UserPoolClients"
        },
        ListUserPools: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "UserPools"
        },
        ListUsers: {
          input_token: "PaginationToken",
          limit_key: "Limit",
          output_token: "PaginationToken",
          result_key: "Users"
        },
        ListUsersInGroup: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "Users"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/cognitoidentityserviceprovider.js
var require_cognitoidentityserviceprovider = __commonJS({
  "node_modules/aws-sdk/clients/cognitoidentityserviceprovider.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["cognitoidentityserviceprovider"] = {};
    AWS2.CognitoIdentityServiceProvider = Service.defineService("cognitoidentityserviceprovider", ["2016-04-18"]);
    Object.defineProperty(apiLoader.services["cognitoidentityserviceprovider"], "2016-04-18", {
      get: function get() {
        var model = require_cognito_idp_2016_04_18_min();
        model.paginators = require_cognito_idp_2016_04_18_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CognitoIdentityServiceProvider;
  }
});

// node_modules/aws-sdk/apis/cognito-sync-2014-06-30.min.json
var require_cognito_sync_2014_06_30_min = __commonJS({
  "node_modules/aws-sdk/apis/cognito-sync-2014-06-30.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-06-30",
        endpointPrefix: "cognito-sync",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Cognito Sync",
        serviceId: "Cognito Sync",
        signatureVersion: "v4",
        uid: "cognito-sync-2014-06-30"
      },
      operations: {
        BulkPublish: {
          http: {
            requestUri: "/identitypools/{IdentityPoolId}/bulkpublish",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityPoolId"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityPoolId: {}
            }
          }
        },
        DeleteDataset: {
          http: {
            method: "DELETE",
            requestUri: "/identitypools/{IdentityPoolId}/identities/{IdentityId}/datasets/{DatasetName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityPoolId",
              "IdentityId",
              "DatasetName"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              },
              IdentityId: {
                location: "uri",
                locationName: "IdentityId"
              },
              DatasetName: {
                location: "uri",
                locationName: "DatasetName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Dataset: {
                shape: "S8"
              }
            }
          }
        },
        DescribeDataset: {
          http: {
            method: "GET",
            requestUri: "/identitypools/{IdentityPoolId}/identities/{IdentityId}/datasets/{DatasetName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityPoolId",
              "IdentityId",
              "DatasetName"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              },
              IdentityId: {
                location: "uri",
                locationName: "IdentityId"
              },
              DatasetName: {
                location: "uri",
                locationName: "DatasetName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Dataset: {
                shape: "S8"
              }
            }
          }
        },
        DescribeIdentityPoolUsage: {
          http: {
            method: "GET",
            requestUri: "/identitypools/{IdentityPoolId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityPoolId"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityPoolUsage: {
                shape: "Sg"
              }
            }
          }
        },
        DescribeIdentityUsage: {
          http: {
            method: "GET",
            requestUri: "/identitypools/{IdentityPoolId}/identities/{IdentityId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityPoolId",
              "IdentityId"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              },
              IdentityId: {
                location: "uri",
                locationName: "IdentityId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityUsage: {
                type: "structure",
                members: {
                  IdentityId: {},
                  IdentityPoolId: {},
                  LastModifiedDate: {
                    type: "timestamp"
                  },
                  DatasetCount: {
                    type: "integer"
                  },
                  DataStorage: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        GetBulkPublishDetails: {
          http: {
            requestUri: "/identitypools/{IdentityPoolId}/getBulkPublishDetails",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityPoolId"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityPoolId: {},
              BulkPublishStartTime: {
                type: "timestamp"
              },
              BulkPublishCompleteTime: {
                type: "timestamp"
              },
              BulkPublishStatus: {},
              FailureMessage: {}
            }
          }
        },
        GetCognitoEvents: {
          http: {
            method: "GET",
            requestUri: "/identitypools/{IdentityPoolId}/events",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityPoolId"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Events: {
                shape: "Sq"
              }
            }
          }
        },
        GetIdentityPoolConfiguration: {
          http: {
            method: "GET",
            requestUri: "/identitypools/{IdentityPoolId}/configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityPoolId"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityPoolId: {},
              PushSync: {
                shape: "Sv"
              },
              CognitoStreams: {
                shape: "Sz"
              }
            }
          }
        },
        ListDatasets: {
          http: {
            method: "GET",
            requestUri: "/identitypools/{IdentityPoolId}/identities/{IdentityId}/datasets",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityId",
              "IdentityPoolId"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              },
              IdentityId: {
                location: "uri",
                locationName: "IdentityId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Datasets: {
                type: "list",
                member: {
                  shape: "S8"
                }
              },
              Count: {
                type: "integer"
              },
              NextToken: {}
            }
          }
        },
        ListIdentityPoolUsage: {
          http: {
            method: "GET",
            requestUri: "/identitypools",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityPoolUsages: {
                type: "list",
                member: {
                  shape: "Sg"
                }
              },
              MaxResults: {
                type: "integer"
              },
              Count: {
                type: "integer"
              },
              NextToken: {}
            }
          }
        },
        ListRecords: {
          http: {
            method: "GET",
            requestUri: "/identitypools/{IdentityPoolId}/identities/{IdentityId}/datasets/{DatasetName}/records",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityPoolId",
              "IdentityId",
              "DatasetName"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              },
              IdentityId: {
                location: "uri",
                locationName: "IdentityId"
              },
              DatasetName: {
                location: "uri",
                locationName: "DatasetName"
              },
              LastSyncCount: {
                location: "querystring",
                locationName: "lastSyncCount",
                type: "long"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              SyncSessionToken: {
                location: "querystring",
                locationName: "syncSessionToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Records: {
                shape: "S1c"
              },
              NextToken: {},
              Count: {
                type: "integer"
              },
              DatasetSyncCount: {
                type: "long"
              },
              LastModifiedBy: {},
              MergedDatasetNames: {
                type: "list",
                member: {}
              },
              DatasetExists: {
                type: "boolean"
              },
              DatasetDeletedAfterRequestedSyncCount: {
                type: "boolean"
              },
              SyncSessionToken: {}
            }
          }
        },
        RegisterDevice: {
          http: {
            requestUri: "/identitypools/{IdentityPoolId}/identity/{IdentityId}/device",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityPoolId",
              "IdentityId",
              "Platform",
              "Token"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              },
              IdentityId: {
                location: "uri",
                locationName: "IdentityId"
              },
              Platform: {},
              Token: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DeviceId: {}
            }
          }
        },
        SetCognitoEvents: {
          http: {
            requestUri: "/identitypools/{IdentityPoolId}/events",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityPoolId",
              "Events"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              },
              Events: {
                shape: "Sq"
              }
            }
          }
        },
        SetIdentityPoolConfiguration: {
          http: {
            requestUri: "/identitypools/{IdentityPoolId}/configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityPoolId"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              },
              PushSync: {
                shape: "Sv"
              },
              CognitoStreams: {
                shape: "Sz"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityPoolId: {},
              PushSync: {
                shape: "Sv"
              },
              CognitoStreams: {
                shape: "Sz"
              }
            }
          }
        },
        SubscribeToDataset: {
          http: {
            requestUri: "/identitypools/{IdentityPoolId}/identities/{IdentityId}/datasets/{DatasetName}/subscriptions/{DeviceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityPoolId",
              "IdentityId",
              "DatasetName",
              "DeviceId"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              },
              IdentityId: {
                location: "uri",
                locationName: "IdentityId"
              },
              DatasetName: {
                location: "uri",
                locationName: "DatasetName"
              },
              DeviceId: {
                location: "uri",
                locationName: "DeviceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UnsubscribeFromDataset: {
          http: {
            method: "DELETE",
            requestUri: "/identitypools/{IdentityPoolId}/identities/{IdentityId}/datasets/{DatasetName}/subscriptions/{DeviceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityPoolId",
              "IdentityId",
              "DatasetName",
              "DeviceId"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              },
              IdentityId: {
                location: "uri",
                locationName: "IdentityId"
              },
              DatasetName: {
                location: "uri",
                locationName: "DatasetName"
              },
              DeviceId: {
                location: "uri",
                locationName: "DeviceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateRecords: {
          http: {
            requestUri: "/identitypools/{IdentityPoolId}/identities/{IdentityId}/datasets/{DatasetName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityPoolId",
              "IdentityId",
              "DatasetName",
              "SyncSessionToken"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              },
              IdentityId: {
                location: "uri",
                locationName: "IdentityId"
              },
              DatasetName: {
                location: "uri",
                locationName: "DatasetName"
              },
              DeviceId: {},
              RecordPatches: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Op",
                    "Key",
                    "SyncCount"
                  ],
                  members: {
                    Op: {},
                    Key: {},
                    Value: {},
                    SyncCount: {
                      type: "long"
                    },
                    DeviceLastModifiedDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              SyncSessionToken: {},
              ClientContext: {
                location: "header",
                locationName: "x-amz-Client-Context"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Records: {
                shape: "S1c"
              }
            }
          }
        }
      },
      shapes: {
        S8: {
          type: "structure",
          members: {
            IdentityId: {},
            DatasetName: {},
            CreationDate: {
              type: "timestamp"
            },
            LastModifiedDate: {
              type: "timestamp"
            },
            LastModifiedBy: {},
            DataStorage: {
              type: "long"
            },
            NumRecords: {
              type: "long"
            }
          }
        },
        Sg: {
          type: "structure",
          members: {
            IdentityPoolId: {},
            SyncSessionsCount: {
              type: "long"
            },
            DataStorage: {
              type: "long"
            },
            LastModifiedDate: {
              type: "timestamp"
            }
          }
        },
        Sq: {
          type: "map",
          key: {},
          value: {}
        },
        Sv: {
          type: "structure",
          members: {
            ApplicationArns: {
              type: "list",
              member: {}
            },
            RoleArn: {}
          }
        },
        Sz: {
          type: "structure",
          members: {
            StreamName: {},
            RoleArn: {},
            StreamingStatus: {}
          }
        },
        S1c: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {},
              SyncCount: {
                type: "long"
              },
              LastModifiedDate: {
                type: "timestamp"
              },
              LastModifiedBy: {},
              DeviceLastModifiedDate: {
                type: "timestamp"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cognito-sync-2014-06-30.paginators.json
var require_cognito_sync_2014_06_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cognito-sync-2014-06-30.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/cognitosync.js
var require_cognitosync = __commonJS({
  "node_modules/aws-sdk/clients/cognitosync.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["cognitosync"] = {};
    AWS2.CognitoSync = Service.defineService("cognitosync", ["2014-06-30"]);
    Object.defineProperty(apiLoader.services["cognitosync"], "2014-06-30", {
      get: function get() {
        var model = require_cognito_sync_2014_06_30_min();
        model.paginators = require_cognito_sync_2014_06_30_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CognitoSync;
  }
});

// node_modules/aws-sdk/apis/config-2014-11-12.min.json
var require_config_2014_11_12_min = __commonJS({
  "node_modules/aws-sdk/apis/config-2014-11-12.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-11-12",
        endpointPrefix: "config",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Config Service",
        serviceFullName: "AWS Config",
        serviceId: "Config Service",
        signatureVersion: "v4",
        targetPrefix: "StarlingDoveService",
        uid: "config-2014-11-12"
      },
      operations: {
        BatchGetAggregateResourceConfig: {
          input: {
            type: "structure",
            required: [
              "ConfigurationAggregatorName",
              "ResourceIdentifiers"
            ],
            members: {
              ConfigurationAggregatorName: {},
              ResourceIdentifiers: {
                type: "list",
                member: {
                  shape: "S4"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BaseConfigurationItems: {
                shape: "Sb"
              },
              UnprocessedResourceIdentifiers: {
                type: "list",
                member: {
                  shape: "S4"
                }
              }
            }
          }
        },
        BatchGetResourceConfig: {
          input: {
            type: "structure",
            required: [
              "resourceKeys"
            ],
            members: {
              resourceKeys: {
                shape: "Ss"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              baseConfigurationItems: {
                shape: "Sb"
              },
              unprocessedResourceKeys: {
                shape: "Ss"
              }
            }
          }
        },
        DeleteAggregationAuthorization: {
          input: {
            type: "structure",
            required: [
              "AuthorizedAccountId",
              "AuthorizedAwsRegion"
            ],
            members: {
              AuthorizedAccountId: {},
              AuthorizedAwsRegion: {}
            }
          }
        },
        DeleteConfigRule: {
          input: {
            type: "structure",
            required: [
              "ConfigRuleName"
            ],
            members: {
              ConfigRuleName: {}
            }
          }
        },
        DeleteConfigurationAggregator: {
          input: {
            type: "structure",
            required: [
              "ConfigurationAggregatorName"
            ],
            members: {
              ConfigurationAggregatorName: {}
            }
          }
        },
        DeleteConfigurationRecorder: {
          input: {
            type: "structure",
            required: [
              "ConfigurationRecorderName"
            ],
            members: {
              ConfigurationRecorderName: {}
            }
          }
        },
        DeleteConformancePack: {
          input: {
            type: "structure",
            required: [
              "ConformancePackName"
            ],
            members: {
              ConformancePackName: {}
            }
          }
        },
        DeleteDeliveryChannel: {
          input: {
            type: "structure",
            required: [
              "DeliveryChannelName"
            ],
            members: {
              DeliveryChannelName: {}
            }
          }
        },
        DeleteEvaluationResults: {
          input: {
            type: "structure",
            required: [
              "ConfigRuleName"
            ],
            members: {
              ConfigRuleName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteOrganizationConfigRule: {
          input: {
            type: "structure",
            required: [
              "OrganizationConfigRuleName"
            ],
            members: {
              OrganizationConfigRuleName: {}
            }
          }
        },
        DeleteOrganizationConformancePack: {
          input: {
            type: "structure",
            required: [
              "OrganizationConformancePackName"
            ],
            members: {
              OrganizationConformancePackName: {}
            }
          }
        },
        DeletePendingAggregationRequest: {
          input: {
            type: "structure",
            required: [
              "RequesterAccountId",
              "RequesterAwsRegion"
            ],
            members: {
              RequesterAccountId: {},
              RequesterAwsRegion: {}
            }
          }
        },
        DeleteRemediationConfiguration: {
          input: {
            type: "structure",
            required: [
              "ConfigRuleName"
            ],
            members: {
              ConfigRuleName: {},
              ResourceType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRemediationExceptions: {
          input: {
            type: "structure",
            required: [
              "ConfigRuleName",
              "ResourceKeys"
            ],
            members: {
              ConfigRuleName: {},
              ResourceKeys: {
                shape: "S1h"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedBatches: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FailureMessage: {},
                    FailedItems: {
                      shape: "S1h"
                    }
                  }
                }
              }
            }
          }
        },
        DeleteResourceConfig: {
          input: {
            type: "structure",
            required: [
              "ResourceType",
              "ResourceId"
            ],
            members: {
              ResourceType: {},
              ResourceId: {}
            }
          }
        },
        DeleteRetentionConfiguration: {
          input: {
            type: "structure",
            required: [
              "RetentionConfigurationName"
            ],
            members: {
              RetentionConfigurationName: {}
            }
          }
        },
        DeleteStoredQuery: {
          input: {
            type: "structure",
            required: [
              "QueryName"
            ],
            members: {
              QueryName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeliverConfigSnapshot: {
          input: {
            type: "structure",
            required: [
              "deliveryChannelName"
            ],
            members: {
              deliveryChannelName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              configSnapshotId: {}
            }
          }
        },
        DescribeAggregateComplianceByConfigRules: {
          input: {
            type: "structure",
            required: [
              "ConfigurationAggregatorName"
            ],
            members: {
              ConfigurationAggregatorName: {},
              Filters: {
                type: "structure",
                members: {
                  ConfigRuleName: {},
                  ComplianceType: {},
                  AccountId: {},
                  AwsRegion: {}
                }
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AggregateComplianceByConfigRules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ConfigRuleName: {},
                    Compliance: {
                      shape: "S25"
                    },
                    AccountId: {},
                    AwsRegion: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeAggregateComplianceByConformancePacks: {
          input: {
            type: "structure",
            required: [
              "ConfigurationAggregatorName"
            ],
            members: {
              ConfigurationAggregatorName: {},
              Filters: {
                type: "structure",
                members: {
                  ConformancePackName: {},
                  ComplianceType: {},
                  AccountId: {},
                  AwsRegion: {}
                }
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AggregateComplianceByConformancePacks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ConformancePackName: {},
                    Compliance: {
                      type: "structure",
                      members: {
                        ComplianceType: {},
                        CompliantRuleCount: {
                          type: "integer"
                        },
                        NonCompliantRuleCount: {
                          type: "integer"
                        },
                        TotalRuleCount: {
                          type: "integer"
                        }
                      }
                    },
                    AccountId: {},
                    AwsRegion: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeAggregationAuthorizations: {
          input: {
            type: "structure",
            members: {
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AggregationAuthorizations: {
                type: "list",
                member: {
                  shape: "S2k"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeComplianceByConfigRule: {
          input: {
            type: "structure",
            members: {
              ConfigRuleNames: {
                shape: "S2n"
              },
              ComplianceTypes: {
                shape: "S2o"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ComplianceByConfigRules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ConfigRuleName: {},
                    Compliance: {
                      shape: "S25"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeComplianceByResource: {
          input: {
            type: "structure",
            members: {
              ResourceType: {},
              ResourceId: {},
              ComplianceTypes: {
                shape: "S2o"
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ComplianceByResources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceType: {},
                    ResourceId: {},
                    Compliance: {
                      shape: "S25"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeConfigRuleEvaluationStatus: {
          input: {
            type: "structure",
            members: {
              ConfigRuleNames: {
                shape: "S2n"
              },
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigRulesEvaluationStatus: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ConfigRuleName: {},
                    ConfigRuleArn: {},
                    ConfigRuleId: {},
                    LastSuccessfulInvocationTime: {
                      type: "timestamp"
                    },
                    LastFailedInvocationTime: {
                      type: "timestamp"
                    },
                    LastSuccessfulEvaluationTime: {
                      type: "timestamp"
                    },
                    LastFailedEvaluationTime: {
                      type: "timestamp"
                    },
                    FirstActivatedTime: {
                      type: "timestamp"
                    },
                    LastDeactivatedTime: {
                      type: "timestamp"
                    },
                    LastErrorCode: {},
                    LastErrorMessage: {},
                    FirstEvaluationStarted: {
                      type: "boolean"
                    },
                    LastDebugLogDeliveryStatus: {},
                    LastDebugLogDeliveryStatusReason: {},
                    LastDebugLogDeliveryTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeConfigRules: {
          input: {
            type: "structure",
            members: {
              ConfigRuleNames: {
                shape: "S2n"
              },
              NextToken: {},
              Filters: {
                type: "structure",
                members: {
                  EvaluationMode: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigRules: {
                type: "list",
                member: {
                  shape: "S37"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeConfigurationAggregatorSourcesStatus: {
          input: {
            type: "structure",
            required: [
              "ConfigurationAggregatorName"
            ],
            members: {
              ConfigurationAggregatorName: {},
              UpdateStatus: {
                type: "list",
                member: {}
              },
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AggregatedSourceStatusList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SourceId: {},
                    SourceType: {},
                    AwsRegion: {},
                    LastUpdateStatus: {},
                    LastUpdateTime: {
                      type: "timestamp"
                    },
                    LastErrorCode: {},
                    LastErrorMessage: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeConfigurationAggregators: {
          input: {
            type: "structure",
            members: {
              ConfigurationAggregatorNames: {
                type: "list",
                member: {}
              },
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationAggregators: {
                type: "list",
                member: {
                  shape: "S40"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeConfigurationRecorderStatus: {
          input: {
            type: "structure",
            members: {
              ConfigurationRecorderNames: {
                shape: "S48"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationRecordersStatus: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    lastStartTime: {
                      type: "timestamp"
                    },
                    lastStopTime: {
                      type: "timestamp"
                    },
                    recording: {
                      type: "boolean"
                    },
                    lastStatus: {},
                    lastErrorCode: {},
                    lastErrorMessage: {},
                    lastStatusChangeTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeConfigurationRecorders: {
          input: {
            type: "structure",
            members: {
              ConfigurationRecorderNames: {
                shape: "S48"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationRecorders: {
                type: "list",
                member: {
                  shape: "S4g"
                }
              }
            }
          }
        },
        DescribeConformancePackCompliance: {
          input: {
            type: "structure",
            required: [
              "ConformancePackName"
            ],
            members: {
              ConformancePackName: {},
              Filters: {
                type: "structure",
                members: {
                  ConfigRuleNames: {
                    shape: "S4v"
                  },
                  ComplianceType: {}
                }
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ConformancePackName",
              "ConformancePackRuleComplianceList"
            ],
            members: {
              ConformancePackName: {},
              ConformancePackRuleComplianceList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ConfigRuleName: {},
                    ComplianceType: {},
                    Controls: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeConformancePackStatus: {
          input: {
            type: "structure",
            members: {
              ConformancePackNames: {
                shape: "S52"
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConformancePackStatusDetails: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ConformancePackName",
                    "ConformancePackId",
                    "ConformancePackArn",
                    "ConformancePackState",
                    "StackArn",
                    "LastUpdateRequestedTime"
                  ],
                  members: {
                    ConformancePackName: {},
                    ConformancePackId: {},
                    ConformancePackArn: {},
                    ConformancePackState: {},
                    StackArn: {},
                    ConformancePackStatusReason: {},
                    LastUpdateRequestedTime: {
                      type: "timestamp"
                    },
                    LastUpdateCompletedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeConformancePacks: {
          input: {
            type: "structure",
            members: {
              ConformancePackNames: {
                shape: "S52"
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConformancePackDetails: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ConformancePackName",
                    "ConformancePackArn",
                    "ConformancePackId"
                  ],
                  members: {
                    ConformancePackName: {},
                    ConformancePackArn: {},
                    ConformancePackId: {},
                    DeliveryS3Bucket: {},
                    DeliveryS3KeyPrefix: {},
                    ConformancePackInputParameters: {
                      shape: "S5i"
                    },
                    LastUpdateRequestedTime: {
                      type: "timestamp"
                    },
                    CreatedBy: {},
                    TemplateSSMDocumentDetails: {
                      shape: "S5m"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeDeliveryChannelStatus: {
          input: {
            type: "structure",
            members: {
              DeliveryChannelNames: {
                shape: "S5q"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeliveryChannelsStatus: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    configSnapshotDeliveryInfo: {
                      shape: "S5u"
                    },
                    configHistoryDeliveryInfo: {
                      shape: "S5u"
                    },
                    configStreamDeliveryInfo: {
                      type: "structure",
                      members: {
                        lastStatus: {},
                        lastErrorCode: {},
                        lastErrorMessage: {},
                        lastStatusChangeTime: {
                          type: "timestamp"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeDeliveryChannels: {
          input: {
            type: "structure",
            members: {
              DeliveryChannelNames: {
                shape: "S5q"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeliveryChannels: {
                type: "list",
                member: {
                  shape: "S60"
                }
              }
            }
          }
        },
        DescribeOrganizationConfigRuleStatuses: {
          input: {
            type: "structure",
            members: {
              OrganizationConfigRuleNames: {
                shape: "S63"
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationConfigRuleStatuses: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "OrganizationConfigRuleName",
                    "OrganizationRuleStatus"
                  ],
                  members: {
                    OrganizationConfigRuleName: {},
                    OrganizationRuleStatus: {},
                    ErrorCode: {},
                    ErrorMessage: {},
                    LastUpdateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeOrganizationConfigRules: {
          input: {
            type: "structure",
            members: {
              OrganizationConfigRuleNames: {
                shape: "S63"
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationConfigRules: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "OrganizationConfigRuleName",
                    "OrganizationConfigRuleArn"
                  ],
                  members: {
                    OrganizationConfigRuleName: {},
                    OrganizationConfigRuleArn: {},
                    OrganizationManagedRuleMetadata: {
                      shape: "S6d"
                    },
                    OrganizationCustomRuleMetadata: {
                      shape: "S6i"
                    },
                    ExcludedAccounts: {
                      shape: "S6l"
                    },
                    LastUpdateTime: {
                      type: "timestamp"
                    },
                    OrganizationCustomPolicyRuleMetadata: {
                      type: "structure",
                      members: {
                        Description: {},
                        OrganizationConfigRuleTriggerTypes: {
                          shape: "S6n"
                        },
                        InputParameters: {},
                        MaximumExecutionFrequency: {},
                        ResourceTypesScope: {
                          shape: "S6g"
                        },
                        ResourceIdScope: {},
                        TagKeyScope: {},
                        TagValueScope: {},
                        PolicyRuntime: {},
                        DebugLogDeliveryAccounts: {
                          shape: "S6p"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeOrganizationConformancePackStatuses: {
          input: {
            type: "structure",
            members: {
              OrganizationConformancePackNames: {
                shape: "S6r"
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationConformancePackStatuses: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "OrganizationConformancePackName",
                    "Status"
                  ],
                  members: {
                    OrganizationConformancePackName: {},
                    Status: {},
                    ErrorCode: {},
                    ErrorMessage: {},
                    LastUpdateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeOrganizationConformancePacks: {
          input: {
            type: "structure",
            members: {
              OrganizationConformancePackNames: {
                shape: "S6r"
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationConformancePacks: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "OrganizationConformancePackName",
                    "OrganizationConformancePackArn",
                    "LastUpdateTime"
                  ],
                  members: {
                    OrganizationConformancePackName: {},
                    OrganizationConformancePackArn: {},
                    DeliveryS3Bucket: {},
                    DeliveryS3KeyPrefix: {},
                    ConformancePackInputParameters: {
                      shape: "S5i"
                    },
                    ExcludedAccounts: {
                      shape: "S6l"
                    },
                    LastUpdateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribePendingAggregationRequests: {
          input: {
            type: "structure",
            members: {
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PendingAggregationRequests: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RequesterAccountId: {},
                    RequesterAwsRegion: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeRemediationConfigurations: {
          input: {
            type: "structure",
            required: [
              "ConfigRuleNames"
            ],
            members: {
              ConfigRuleNames: {
                shape: "S2n"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RemediationConfigurations: {
                shape: "S77"
              }
            }
          }
        },
        DescribeRemediationExceptions: {
          input: {
            type: "structure",
            required: [
              "ConfigRuleName"
            ],
            members: {
              ConfigRuleName: {},
              ResourceKeys: {
                shape: "S1h"
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RemediationExceptions: {
                shape: "S7n"
              },
              NextToken: {}
            }
          }
        },
        DescribeRemediationExecutionStatus: {
          input: {
            type: "structure",
            required: [
              "ConfigRuleName"
            ],
            members: {
              ConfigRuleName: {},
              ResourceKeys: {
                shape: "Ss"
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RemediationExecutionStatuses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceKey: {
                      shape: "St"
                    },
                    State: {},
                    StepDetails: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Name: {},
                          State: {},
                          ErrorMessage: {},
                          StartTime: {
                            type: "timestamp"
                          },
                          StopTime: {
                            type: "timestamp"
                          }
                        }
                      }
                    },
                    InvocationTime: {
                      type: "timestamp"
                    },
                    LastUpdatedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeRetentionConfigurations: {
          input: {
            type: "structure",
            members: {
              RetentionConfigurationNames: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RetentionConfigurations: {
                type: "list",
                member: {
                  shape: "S81"
                }
              },
              NextToken: {}
            }
          }
        },
        GetAggregateComplianceDetailsByConfigRule: {
          input: {
            type: "structure",
            required: [
              "ConfigurationAggregatorName",
              "ConfigRuleName",
              "AccountId",
              "AwsRegion"
            ],
            members: {
              ConfigurationAggregatorName: {},
              ConfigRuleName: {},
              AccountId: {},
              AwsRegion: {},
              ComplianceType: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AggregateEvaluationResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EvaluationResultIdentifier: {
                      shape: "S87"
                    },
                    ComplianceType: {},
                    ResultRecordedTime: {
                      type: "timestamp"
                    },
                    ConfigRuleInvokedTime: {
                      type: "timestamp"
                    },
                    Annotation: {},
                    AccountId: {},
                    AwsRegion: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetAggregateConfigRuleComplianceSummary: {
          input: {
            type: "structure",
            required: [
              "ConfigurationAggregatorName"
            ],
            members: {
              ConfigurationAggregatorName: {},
              Filters: {
                type: "structure",
                members: {
                  AccountId: {},
                  AwsRegion: {}
                }
              },
              GroupByKey: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GroupByKey: {},
              AggregateComplianceCounts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    GroupName: {},
                    ComplianceSummary: {
                      shape: "S8g"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetAggregateConformancePackComplianceSummary: {
          input: {
            type: "structure",
            required: [
              "ConfigurationAggregatorName"
            ],
            members: {
              ConfigurationAggregatorName: {},
              Filters: {
                type: "structure",
                members: {
                  AccountId: {},
                  AwsRegion: {}
                }
              },
              GroupByKey: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AggregateConformancePackComplianceSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ComplianceSummary: {
                      type: "structure",
                      members: {
                        CompliantConformancePackCount: {
                          type: "integer"
                        },
                        NonCompliantConformancePackCount: {
                          type: "integer"
                        }
                      }
                    },
                    GroupName: {}
                  }
                }
              },
              GroupByKey: {},
              NextToken: {}
            }
          }
        },
        GetAggregateDiscoveredResourceCounts: {
          input: {
            type: "structure",
            required: [
              "ConfigurationAggregatorName"
            ],
            members: {
              ConfigurationAggregatorName: {},
              Filters: {
                type: "structure",
                members: {
                  ResourceType: {},
                  AccountId: {},
                  Region: {}
                }
              },
              GroupByKey: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "TotalDiscoveredResources"
            ],
            members: {
              TotalDiscoveredResources: {
                type: "long"
              },
              GroupByKey: {},
              GroupedResourceCounts: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "GroupName",
                    "ResourceCount"
                  ],
                  members: {
                    GroupName: {},
                    ResourceCount: {
                      type: "long"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetAggregateResourceConfig: {
          input: {
            type: "structure",
            required: [
              "ConfigurationAggregatorName",
              "ResourceIdentifier"
            ],
            members: {
              ConfigurationAggregatorName: {},
              ResourceIdentifier: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationItem: {
                shape: "S8x"
              }
            }
          }
        },
        GetComplianceDetailsByConfigRule: {
          input: {
            type: "structure",
            required: [
              "ConfigRuleName"
            ],
            members: {
              ConfigRuleName: {},
              ComplianceTypes: {
                shape: "S2o"
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EvaluationResults: {
                shape: "S99"
              },
              NextToken: {}
            }
          }
        },
        GetComplianceDetailsByResource: {
          input: {
            type: "structure",
            members: {
              ResourceType: {},
              ResourceId: {},
              ComplianceTypes: {
                shape: "S2o"
              },
              NextToken: {},
              ResourceEvaluationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EvaluationResults: {
                shape: "S99"
              },
              NextToken: {}
            }
          }
        },
        GetComplianceSummaryByConfigRule: {
          output: {
            type: "structure",
            members: {
              ComplianceSummary: {
                shape: "S8g"
              }
            }
          }
        },
        GetComplianceSummaryByResourceType: {
          input: {
            type: "structure",
            members: {
              ResourceTypes: {
                shape: "S9f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ComplianceSummariesByResourceType: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceType: {},
                    ComplianceSummary: {
                      shape: "S8g"
                    }
                  }
                }
              }
            }
          }
        },
        GetConformancePackComplianceDetails: {
          input: {
            type: "structure",
            required: [
              "ConformancePackName"
            ],
            members: {
              ConformancePackName: {},
              Filters: {
                type: "structure",
                members: {
                  ConfigRuleNames: {
                    shape: "S4v"
                  },
                  ComplianceType: {},
                  ResourceType: {},
                  ResourceIds: {
                    type: "list",
                    member: {}
                  }
                }
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ConformancePackName"
            ],
            members: {
              ConformancePackName: {},
              ConformancePackRuleEvaluationResults: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ComplianceType",
                    "EvaluationResultIdentifier",
                    "ConfigRuleInvokedTime",
                    "ResultRecordedTime"
                  ],
                  members: {
                    ComplianceType: {},
                    EvaluationResultIdentifier: {
                      shape: "S87"
                    },
                    ConfigRuleInvokedTime: {
                      type: "timestamp"
                    },
                    ResultRecordedTime: {
                      type: "timestamp"
                    },
                    Annotation: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetConformancePackComplianceSummary: {
          input: {
            type: "structure",
            required: [
              "ConformancePackNames"
            ],
            members: {
              ConformancePackNames: {
                type: "list",
                member: {}
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConformancePackComplianceSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ConformancePackName",
                    "ConformancePackComplianceStatus"
                  ],
                  members: {
                    ConformancePackName: {},
                    ConformancePackComplianceStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetCustomRulePolicy: {
          input: {
            type: "structure",
            members: {
              ConfigRuleName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyText: {}
            }
          }
        },
        GetDiscoveredResourceCounts: {
          input: {
            type: "structure",
            members: {
              resourceTypes: {
                shape: "S9f"
              },
              limit: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              totalDiscoveredResources: {
                type: "long"
              },
              resourceCounts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    resourceType: {},
                    count: {
                      type: "long"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetOrganizationConfigRuleDetailedStatus: {
          input: {
            type: "structure",
            required: [
              "OrganizationConfigRuleName"
            ],
            members: {
              OrganizationConfigRuleName: {},
              Filters: {
                type: "structure",
                members: {
                  AccountId: {},
                  MemberAccountRuleStatus: {}
                }
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationConfigRuleDetailedStatus: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AccountId",
                    "ConfigRuleName",
                    "MemberAccountRuleStatus"
                  ],
                  members: {
                    AccountId: {},
                    ConfigRuleName: {},
                    MemberAccountRuleStatus: {},
                    ErrorCode: {},
                    ErrorMessage: {},
                    LastUpdateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetOrganizationConformancePackDetailedStatus: {
          input: {
            type: "structure",
            required: [
              "OrganizationConformancePackName"
            ],
            members: {
              OrganizationConformancePackName: {},
              Filters: {
                type: "structure",
                members: {
                  AccountId: {},
                  Status: {}
                }
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationConformancePackDetailedStatuses: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AccountId",
                    "ConformancePackName",
                    "Status"
                  ],
                  members: {
                    AccountId: {},
                    ConformancePackName: {},
                    Status: {},
                    ErrorCode: {},
                    ErrorMessage: {},
                    LastUpdateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetOrganizationCustomRulePolicy: {
          input: {
            type: "structure",
            required: [
              "OrganizationConfigRuleName"
            ],
            members: {
              OrganizationConfigRuleName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyText: {}
            }
          }
        },
        GetResourceConfigHistory: {
          input: {
            type: "structure",
            required: [
              "resourceType",
              "resourceId"
            ],
            members: {
              resourceType: {},
              resourceId: {},
              laterTime: {
                type: "timestamp"
              },
              earlierTime: {
                type: "timestamp"
              },
              chronologicalOrder: {},
              limit: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              configurationItems: {
                type: "list",
                member: {
                  shape: "S8x"
                }
              },
              nextToken: {}
            }
          }
        },
        GetResourceEvaluationSummary: {
          input: {
            type: "structure",
            required: [
              "ResourceEvaluationId"
            ],
            members: {
              ResourceEvaluationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceEvaluationId: {},
              EvaluationMode: {},
              EvaluationStatus: {
                type: "structure",
                required: [
                  "Status"
                ],
                members: {
                  Status: {},
                  FailureReason: {}
                }
              },
              EvaluationStartTimestamp: {
                type: "timestamp"
              },
              Compliance: {},
              EvaluationContext: {
                shape: "Saq"
              },
              ResourceDetails: {
                shape: "Sas"
              }
            }
          }
        },
        GetStoredQuery: {
          input: {
            type: "structure",
            required: [
              "QueryName"
            ],
            members: {
              QueryName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StoredQuery: {
                shape: "Sax"
              }
            }
          }
        },
        ListAggregateDiscoveredResources: {
          input: {
            type: "structure",
            required: [
              "ConfigurationAggregatorName",
              "ResourceType"
            ],
            members: {
              ConfigurationAggregatorName: {},
              ResourceType: {},
              Filters: {
                type: "structure",
                members: {
                  AccountId: {},
                  ResourceId: {},
                  ResourceName: {},
                  Region: {}
                }
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceIdentifiers: {
                type: "list",
                member: {
                  shape: "S4"
                }
              },
              NextToken: {}
            }
          }
        },
        ListConformancePackComplianceScores: {
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "structure",
                required: [
                  "ConformancePackNames"
                ],
                members: {
                  ConformancePackNames: {
                    type: "list",
                    member: {}
                  }
                }
              },
              SortOrder: {},
              SortBy: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ConformancePackComplianceScores"
            ],
            members: {
              NextToken: {},
              ConformancePackComplianceScores: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Score: {},
                    ConformancePackName: {},
                    LastUpdatedTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListDiscoveredResources: {
          input: {
            type: "structure",
            required: [
              "resourceType"
            ],
            members: {
              resourceType: {},
              resourceIds: {
                type: "list",
                member: {}
              },
              resourceName: {},
              limit: {
                type: "integer"
              },
              includeDeletedResources: {
                type: "boolean"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              resourceIdentifiers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    resourceType: {},
                    resourceId: {},
                    resourceName: {},
                    resourceDeletionTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListResourceEvaluations: {
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "structure",
                members: {
                  EvaluationMode: {},
                  TimeWindow: {
                    type: "structure",
                    members: {
                      StartTime: {
                        type: "timestamp"
                      },
                      EndTime: {
                        type: "timestamp"
                      }
                    }
                  },
                  EvaluationContextIdentifier: {}
                }
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceEvaluations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceEvaluationId: {},
                    EvaluationMode: {},
                    EvaluationStartTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListStoredQueries: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StoredQueryMetadata: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "QueryId",
                    "QueryArn",
                    "QueryName"
                  ],
                  members: {
                    QueryId: {},
                    QueryArn: {},
                    QueryName: {},
                    Description: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sc0"
              },
              NextToken: {}
            }
          }
        },
        PutAggregationAuthorization: {
          input: {
            type: "structure",
            required: [
              "AuthorizedAccountId",
              "AuthorizedAwsRegion"
            ],
            members: {
              AuthorizedAccountId: {},
              AuthorizedAwsRegion: {},
              Tags: {
                shape: "Sc5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AggregationAuthorization: {
                shape: "S2k"
              }
            }
          }
        },
        PutConfigRule: {
          input: {
            type: "structure",
            required: [
              "ConfigRule"
            ],
            members: {
              ConfigRule: {
                shape: "S37"
              },
              Tags: {
                shape: "Sc5"
              }
            }
          }
        },
        PutConfigurationAggregator: {
          input: {
            type: "structure",
            required: [
              "ConfigurationAggregatorName"
            ],
            members: {
              ConfigurationAggregatorName: {},
              AccountAggregationSources: {
                shape: "S42"
              },
              OrganizationAggregationSource: {
                shape: "S46"
              },
              Tags: {
                shape: "Sc5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationAggregator: {
                shape: "S40"
              }
            }
          }
        },
        PutConfigurationRecorder: {
          input: {
            type: "structure",
            required: [
              "ConfigurationRecorder"
            ],
            members: {
              ConfigurationRecorder: {
                shape: "S4g"
              }
            }
          }
        },
        PutConformancePack: {
          input: {
            type: "structure",
            required: [
              "ConformancePackName"
            ],
            members: {
              ConformancePackName: {},
              TemplateS3Uri: {},
              TemplateBody: {},
              DeliveryS3Bucket: {},
              DeliveryS3KeyPrefix: {},
              ConformancePackInputParameters: {
                shape: "S5i"
              },
              TemplateSSMDocumentDetails: {
                shape: "S5m"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConformancePackArn: {}
            }
          }
        },
        PutDeliveryChannel: {
          input: {
            type: "structure",
            required: [
              "DeliveryChannel"
            ],
            members: {
              DeliveryChannel: {
                shape: "S60"
              }
            }
          }
        },
        PutEvaluations: {
          input: {
            type: "structure",
            required: [
              "ResultToken"
            ],
            members: {
              Evaluations: {
                shape: "Sch"
              },
              ResultToken: {},
              TestMode: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedEvaluations: {
                shape: "Sch"
              }
            }
          }
        },
        PutExternalEvaluation: {
          input: {
            type: "structure",
            required: [
              "ConfigRuleName",
              "ExternalEvaluation"
            ],
            members: {
              ConfigRuleName: {},
              ExternalEvaluation: {
                type: "structure",
                required: [
                  "ComplianceResourceType",
                  "ComplianceResourceId",
                  "ComplianceType",
                  "OrderingTimestamp"
                ],
                members: {
                  ComplianceResourceType: {},
                  ComplianceResourceId: {},
                  ComplianceType: {},
                  Annotation: {},
                  OrderingTimestamp: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutOrganizationConfigRule: {
          input: {
            type: "structure",
            required: [
              "OrganizationConfigRuleName"
            ],
            members: {
              OrganizationConfigRuleName: {},
              OrganizationManagedRuleMetadata: {
                shape: "S6d"
              },
              OrganizationCustomRuleMetadata: {
                shape: "S6i"
              },
              ExcludedAccounts: {
                shape: "S6l"
              },
              OrganizationCustomPolicyRuleMetadata: {
                type: "structure",
                required: [
                  "PolicyRuntime",
                  "PolicyText"
                ],
                members: {
                  Description: {},
                  OrganizationConfigRuleTriggerTypes: {
                    shape: "S6n"
                  },
                  InputParameters: {},
                  MaximumExecutionFrequency: {},
                  ResourceTypesScope: {
                    shape: "S6g"
                  },
                  ResourceIdScope: {},
                  TagKeyScope: {},
                  TagValueScope: {},
                  PolicyRuntime: {},
                  PolicyText: {},
                  DebugLogDeliveryAccounts: {
                    shape: "S6p"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationConfigRuleArn: {}
            }
          }
        },
        PutOrganizationConformancePack: {
          input: {
            type: "structure",
            required: [
              "OrganizationConformancePackName"
            ],
            members: {
              OrganizationConformancePackName: {},
              TemplateS3Uri: {},
              TemplateBody: {},
              DeliveryS3Bucket: {},
              DeliveryS3KeyPrefix: {},
              ConformancePackInputParameters: {
                shape: "S5i"
              },
              ExcludedAccounts: {
                shape: "S6l"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationConformancePackArn: {}
            }
          }
        },
        PutRemediationConfigurations: {
          input: {
            type: "structure",
            required: [
              "RemediationConfigurations"
            ],
            members: {
              RemediationConfigurations: {
                shape: "S77"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedBatches: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FailureMessage: {},
                    FailedItems: {
                      shape: "S77"
                    }
                  }
                }
              }
            }
          }
        },
        PutRemediationExceptions: {
          input: {
            type: "structure",
            required: [
              "ConfigRuleName",
              "ResourceKeys"
            ],
            members: {
              ConfigRuleName: {},
              ResourceKeys: {
                shape: "S1h"
              },
              Message: {},
              ExpirationTime: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedBatches: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FailureMessage: {},
                    FailedItems: {
                      shape: "S7n"
                    }
                  }
                }
              }
            }
          }
        },
        PutResourceConfig: {
          input: {
            type: "structure",
            required: [
              "ResourceType",
              "SchemaVersionId",
              "ResourceId",
              "Configuration"
            ],
            members: {
              ResourceType: {},
              SchemaVersionId: {},
              ResourceId: {},
              ResourceName: {},
              Configuration: {},
              Tags: {
                shape: "S8z"
              }
            }
          }
        },
        PutRetentionConfiguration: {
          input: {
            type: "structure",
            required: [
              "RetentionPeriodInDays"
            ],
            members: {
              RetentionPeriodInDays: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RetentionConfiguration: {
                shape: "S81"
              }
            }
          }
        },
        PutStoredQuery: {
          input: {
            type: "structure",
            required: [
              "StoredQuery"
            ],
            members: {
              StoredQuery: {
                shape: "Sax"
              },
              Tags: {
                shape: "Sc5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              QueryArn: {}
            }
          }
        },
        SelectAggregateResourceConfig: {
          input: {
            type: "structure",
            required: [
              "Expression",
              "ConfigurationAggregatorName"
            ],
            members: {
              Expression: {},
              ConfigurationAggregatorName: {},
              Limit: {
                type: "integer"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Results: {
                shape: "Sda"
              },
              QueryInfo: {
                shape: "Sdb"
              },
              NextToken: {}
            }
          }
        },
        SelectResourceConfig: {
          input: {
            type: "structure",
            required: [
              "Expression"
            ],
            members: {
              Expression: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Results: {
                shape: "Sda"
              },
              QueryInfo: {
                shape: "Sdb"
              },
              NextToken: {}
            }
          }
        },
        StartConfigRulesEvaluation: {
          input: {
            type: "structure",
            members: {
              ConfigRuleNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartConfigurationRecorder: {
          input: {
            type: "structure",
            required: [
              "ConfigurationRecorderName"
            ],
            members: {
              ConfigurationRecorderName: {}
            }
          }
        },
        StartRemediationExecution: {
          input: {
            type: "structure",
            required: [
              "ConfigRuleName",
              "ResourceKeys"
            ],
            members: {
              ConfigRuleName: {},
              ResourceKeys: {
                shape: "Ss"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailureMessage: {},
              FailedItems: {
                shape: "Ss"
              }
            }
          }
        },
        StartResourceEvaluation: {
          input: {
            type: "structure",
            required: [
              "ResourceDetails",
              "EvaluationMode"
            ],
            members: {
              ResourceDetails: {
                shape: "Sas"
              },
              EvaluationContext: {
                shape: "Saq"
              },
              EvaluationMode: {},
              EvaluationTimeout: {
                type: "integer"
              },
              ClientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceEvaluationId: {}
            }
          }
        },
        StopConfigurationRecorder: {
          input: {
            type: "structure",
            required: [
              "ConfigurationRecorderName"
            ],
            members: {
              ConfigurationRecorderName: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "Sc0"
              }
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          required: [
            "SourceAccountId",
            "SourceRegion",
            "ResourceId",
            "ResourceType"
          ],
          members: {
            SourceAccountId: {},
            SourceRegion: {},
            ResourceId: {},
            ResourceType: {},
            ResourceName: {}
          }
        },
        Sb: {
          type: "list",
          member: {
            type: "structure",
            members: {
              version: {},
              accountId: {},
              configurationItemCaptureTime: {
                type: "timestamp"
              },
              configurationItemStatus: {},
              configurationStateId: {},
              arn: {},
              resourceType: {},
              resourceId: {},
              resourceName: {},
              awsRegion: {},
              availabilityZone: {},
              resourceCreationTime: {
                type: "timestamp"
              },
              configuration: {},
              supplementaryConfiguration: {
                shape: "Sl"
              },
              recordingFrequency: {},
              configurationItemDeliveryTime: {
                type: "timestamp"
              }
            }
          }
        },
        Sl: {
          type: "map",
          key: {},
          value: {}
        },
        Ss: {
          type: "list",
          member: {
            shape: "St"
          }
        },
        St: {
          type: "structure",
          required: [
            "resourceType",
            "resourceId"
          ],
          members: {
            resourceType: {},
            resourceId: {}
          }
        },
        S1h: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ResourceType: {},
              ResourceId: {}
            }
          }
        },
        S25: {
          type: "structure",
          members: {
            ComplianceType: {},
            ComplianceContributorCount: {
              shape: "S26"
            }
          }
        },
        S26: {
          type: "structure",
          members: {
            CappedCount: {
              type: "integer"
            },
            CapExceeded: {
              type: "boolean"
            }
          }
        },
        S2k: {
          type: "structure",
          members: {
            AggregationAuthorizationArn: {},
            AuthorizedAccountId: {},
            AuthorizedAwsRegion: {},
            CreationTime: {
              type: "timestamp"
            }
          }
        },
        S2n: {
          type: "list",
          member: {}
        },
        S2o: {
          type: "list",
          member: {}
        },
        S37: {
          type: "structure",
          required: [
            "Source"
          ],
          members: {
            ConfigRuleName: {},
            ConfigRuleArn: {},
            ConfigRuleId: {},
            Description: {},
            Scope: {
              type: "structure",
              members: {
                ComplianceResourceTypes: {
                  type: "list",
                  member: {}
                },
                TagKey: {},
                TagValue: {},
                ComplianceResourceId: {}
              }
            },
            Source: {
              type: "structure",
              required: [
                "Owner"
              ],
              members: {
                Owner: {},
                SourceIdentifier: {},
                SourceDetails: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      EventSource: {},
                      MessageType: {},
                      MaximumExecutionFrequency: {}
                    }
                  }
                },
                CustomPolicyDetails: {
                  type: "structure",
                  required: [
                    "PolicyRuntime",
                    "PolicyText"
                  ],
                  members: {
                    PolicyRuntime: {},
                    PolicyText: {},
                    EnableDebugLogDelivery: {
                      type: "boolean"
                    }
                  }
                }
              }
            },
            InputParameters: {},
            MaximumExecutionFrequency: {},
            ConfigRuleState: {},
            CreatedBy: {},
            EvaluationModes: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Mode: {}
                }
              }
            }
          }
        },
        S40: {
          type: "structure",
          members: {
            ConfigurationAggregatorName: {},
            ConfigurationAggregatorArn: {},
            AccountAggregationSources: {
              shape: "S42"
            },
            OrganizationAggregationSource: {
              shape: "S46"
            },
            CreationTime: {
              type: "timestamp"
            },
            LastUpdatedTime: {
              type: "timestamp"
            },
            CreatedBy: {}
          }
        },
        S42: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AccountIds"
            ],
            members: {
              AccountIds: {
                type: "list",
                member: {}
              },
              AllAwsRegions: {
                type: "boolean"
              },
              AwsRegions: {
                shape: "S45"
              }
            }
          }
        },
        S45: {
          type: "list",
          member: {}
        },
        S46: {
          type: "structure",
          required: [
            "RoleArn"
          ],
          members: {
            RoleArn: {},
            AwsRegions: {
              shape: "S45"
            },
            AllAwsRegions: {
              type: "boolean"
            }
          }
        },
        S48: {
          type: "list",
          member: {}
        },
        S4g: {
          type: "structure",
          members: {
            name: {},
            roleARN: {},
            recordingGroup: {
              type: "structure",
              members: {
                allSupported: {
                  type: "boolean"
                },
                includeGlobalResourceTypes: {
                  type: "boolean"
                },
                resourceTypes: {
                  shape: "S4k"
                },
                exclusionByResourceTypes: {
                  type: "structure",
                  members: {
                    resourceTypes: {
                      shape: "S4k"
                    }
                  }
                },
                recordingStrategy: {
                  type: "structure",
                  members: {
                    useOnly: {}
                  }
                }
              }
            },
            recordingMode: {
              type: "structure",
              required: [
                "recordingFrequency"
              ],
              members: {
                recordingFrequency: {},
                recordingModeOverrides: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "resourceTypes",
                      "recordingFrequency"
                    ],
                    members: {
                      description: {},
                      resourceTypes: {
                        type: "list",
                        member: {}
                      },
                      recordingFrequency: {}
                    }
                  }
                }
              }
            }
          }
        },
        S4k: {
          type: "list",
          member: {}
        },
        S4v: {
          type: "list",
          member: {}
        },
        S52: {
          type: "list",
          member: {}
        },
        S5i: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ParameterName",
              "ParameterValue"
            ],
            members: {
              ParameterName: {},
              ParameterValue: {}
            }
          }
        },
        S5m: {
          type: "structure",
          required: [
            "DocumentName"
          ],
          members: {
            DocumentName: {},
            DocumentVersion: {}
          }
        },
        S5q: {
          type: "list",
          member: {}
        },
        S5u: {
          type: "structure",
          members: {
            lastStatus: {},
            lastErrorCode: {},
            lastErrorMessage: {},
            lastAttemptTime: {
              type: "timestamp"
            },
            lastSuccessfulTime: {
              type: "timestamp"
            },
            nextDeliveryTime: {
              type: "timestamp"
            }
          }
        },
        S60: {
          type: "structure",
          members: {
            name: {},
            s3BucketName: {},
            s3KeyPrefix: {},
            s3KmsKeyArn: {},
            snsTopicARN: {},
            configSnapshotDeliveryProperties: {
              type: "structure",
              members: {
                deliveryFrequency: {}
              }
            }
          }
        },
        S63: {
          type: "list",
          member: {}
        },
        S6d: {
          type: "structure",
          required: [
            "RuleIdentifier"
          ],
          members: {
            Description: {},
            RuleIdentifier: {},
            InputParameters: {},
            MaximumExecutionFrequency: {},
            ResourceTypesScope: {
              shape: "S6g"
            },
            ResourceIdScope: {},
            TagKeyScope: {},
            TagValueScope: {}
          }
        },
        S6g: {
          type: "list",
          member: {}
        },
        S6i: {
          type: "structure",
          required: [
            "LambdaFunctionArn",
            "OrganizationConfigRuleTriggerTypes"
          ],
          members: {
            Description: {},
            LambdaFunctionArn: {},
            OrganizationConfigRuleTriggerTypes: {
              type: "list",
              member: {}
            },
            InputParameters: {},
            MaximumExecutionFrequency: {},
            ResourceTypesScope: {
              shape: "S6g"
            },
            ResourceIdScope: {},
            TagKeyScope: {},
            TagValueScope: {}
          }
        },
        S6l: {
          type: "list",
          member: {}
        },
        S6n: {
          type: "list",
          member: {}
        },
        S6p: {
          type: "list",
          member: {}
        },
        S6r: {
          type: "list",
          member: {}
        },
        S77: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ConfigRuleName",
              "TargetType",
              "TargetId"
            ],
            members: {
              ConfigRuleName: {},
              TargetType: {},
              TargetId: {},
              TargetVersion: {},
              Parameters: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    ResourceValue: {
                      type: "structure",
                      required: [
                        "Value"
                      ],
                      members: {
                        Value: {}
                      }
                    },
                    StaticValue: {
                      type: "structure",
                      required: [
                        "Values"
                      ],
                      members: {
                        Values: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  }
                }
              },
              ResourceType: {},
              Automatic: {
                type: "boolean"
              },
              ExecutionControls: {
                type: "structure",
                members: {
                  SsmControls: {
                    type: "structure",
                    members: {
                      ConcurrentExecutionRatePercentage: {
                        type: "integer"
                      },
                      ErrorPercentage: {
                        type: "integer"
                      }
                    }
                  }
                }
              },
              MaximumAutomaticAttempts: {
                type: "integer"
              },
              RetryAttemptSeconds: {
                type: "long"
              },
              Arn: {},
              CreatedByService: {}
            }
          }
        },
        S7n: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ConfigRuleName",
              "ResourceType",
              "ResourceId"
            ],
            members: {
              ConfigRuleName: {},
              ResourceType: {},
              ResourceId: {},
              Message: {},
              ExpirationTime: {
                type: "timestamp"
              }
            }
          }
        },
        S81: {
          type: "structure",
          required: [
            "Name",
            "RetentionPeriodInDays"
          ],
          members: {
            Name: {},
            RetentionPeriodInDays: {
              type: "integer"
            }
          }
        },
        S87: {
          type: "structure",
          members: {
            EvaluationResultQualifier: {
              type: "structure",
              members: {
                ConfigRuleName: {},
                ResourceType: {},
                ResourceId: {},
                EvaluationMode: {}
              }
            },
            OrderingTimestamp: {
              type: "timestamp"
            },
            ResourceEvaluationId: {}
          }
        },
        S8g: {
          type: "structure",
          members: {
            CompliantResourceCount: {
              shape: "S26"
            },
            NonCompliantResourceCount: {
              shape: "S26"
            },
            ComplianceSummaryTimestamp: {
              type: "timestamp"
            }
          }
        },
        S8x: {
          type: "structure",
          members: {
            version: {},
            accountId: {},
            configurationItemCaptureTime: {
              type: "timestamp"
            },
            configurationItemStatus: {},
            configurationStateId: {},
            configurationItemMD5Hash: {},
            arn: {},
            resourceType: {},
            resourceId: {},
            resourceName: {},
            awsRegion: {},
            availabilityZone: {},
            resourceCreationTime: {
              type: "timestamp"
            },
            tags: {
              shape: "S8z"
            },
            relatedEvents: {
              type: "list",
              member: {}
            },
            relationships: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  resourceType: {},
                  resourceId: {},
                  resourceName: {},
                  relationshipName: {}
                }
              }
            },
            configuration: {},
            supplementaryConfiguration: {
              shape: "Sl"
            },
            recordingFrequency: {},
            configurationItemDeliveryTime: {
              type: "timestamp"
            }
          }
        },
        S8z: {
          type: "map",
          key: {},
          value: {}
        },
        S99: {
          type: "list",
          member: {
            type: "structure",
            members: {
              EvaluationResultIdentifier: {
                shape: "S87"
              },
              ComplianceType: {},
              ResultRecordedTime: {
                type: "timestamp"
              },
              ConfigRuleInvokedTime: {
                type: "timestamp"
              },
              Annotation: {},
              ResultToken: {}
            }
          }
        },
        S9f: {
          type: "list",
          member: {}
        },
        Saq: {
          type: "structure",
          members: {
            EvaluationContextIdentifier: {}
          }
        },
        Sas: {
          type: "structure",
          required: [
            "ResourceId",
            "ResourceType",
            "ResourceConfiguration"
          ],
          members: {
            ResourceId: {},
            ResourceType: {},
            ResourceConfiguration: {},
            ResourceConfigurationSchemaType: {}
          }
        },
        Sax: {
          type: "structure",
          required: [
            "QueryName"
          ],
          members: {
            QueryId: {},
            QueryArn: {},
            QueryName: {},
            Description: {},
            Expression: {}
          }
        },
        Sc0: {
          type: "list",
          member: {
            shape: "Sc1"
          }
        },
        Sc1: {
          type: "structure",
          members: {
            Key: {},
            Value: {}
          }
        },
        Sc5: {
          type: "list",
          member: {
            shape: "Sc1"
          }
        },
        Sch: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ComplianceResourceType",
              "ComplianceResourceId",
              "ComplianceType",
              "OrderingTimestamp"
            ],
            members: {
              ComplianceResourceType: {},
              ComplianceResourceId: {},
              ComplianceType: {},
              Annotation: {},
              OrderingTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        Sda: {
          type: "list",
          member: {}
        },
        Sdb: {
          type: "structure",
          members: {
            SelectFields: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Name: {}
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/config-2014-11-12.paginators.json
var require_config_2014_11_12_paginators = __commonJS({
  "node_modules/aws-sdk/apis/config-2014-11-12.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeAggregateComplianceByConfigRules: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken"
        },
        DescribeAggregateComplianceByConformancePacks: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "AggregateComplianceByConformancePacks"
        },
        DescribeAggregationAuthorizations: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "AggregationAuthorizations"
        },
        DescribeComplianceByConfigRule: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "ComplianceByConfigRules"
        },
        DescribeComplianceByResource: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "ComplianceByResources"
        },
        DescribeConfigRuleEvaluationStatus: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "ConfigRulesEvaluationStatus"
        },
        DescribeConfigRules: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "ConfigRules"
        },
        DescribeConfigurationAggregatorSourcesStatus: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "AggregatedSourceStatusList"
        },
        DescribeConfigurationAggregators: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "ConfigurationAggregators"
        },
        DescribeConformancePackCompliance: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken"
        },
        DescribeConformancePackStatus: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "ConformancePackStatusDetails"
        },
        DescribeConformancePacks: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "ConformancePackDetails"
        },
        DescribeOrganizationConfigRuleStatuses: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "OrganizationConfigRuleStatuses"
        },
        DescribeOrganizationConfigRules: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "OrganizationConfigRules"
        },
        DescribeOrganizationConformancePackStatuses: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "OrganizationConformancePackStatuses"
        },
        DescribeOrganizationConformancePacks: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "OrganizationConformancePacks"
        },
        DescribePendingAggregationRequests: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "PendingAggregationRequests"
        },
        DescribeRemediationExceptions: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken"
        },
        DescribeRemediationExecutionStatus: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "RemediationExecutionStatuses"
        },
        DescribeRetentionConfigurations: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "RetentionConfigurations"
        },
        GetAggregateComplianceDetailsByConfigRule: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "AggregateEvaluationResults"
        },
        GetAggregateConfigRuleComplianceSummary: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken"
        },
        GetAggregateConformancePackComplianceSummary: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken"
        },
        GetAggregateDiscoveredResourceCounts: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken"
        },
        GetComplianceDetailsByConfigRule: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "EvaluationResults"
        },
        GetComplianceDetailsByResource: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "EvaluationResults"
        },
        GetConformancePackComplianceDetails: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken"
        },
        GetConformancePackComplianceSummary: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "ConformancePackComplianceSummaryList"
        },
        GetDiscoveredResourceCounts: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextToken"
        },
        GetOrganizationConfigRuleDetailedStatus: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "OrganizationConfigRuleDetailedStatus"
        },
        GetOrganizationConformancePackDetailedStatus: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "OrganizationConformancePackDetailedStatuses"
        },
        GetResourceConfigHistory: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextToken",
          result_key: "configurationItems"
        },
        ListAggregateDiscoveredResources: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "ResourceIdentifiers"
        },
        ListConformancePackComplianceScores: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken"
        },
        ListDiscoveredResources: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextToken",
          result_key: "resourceIdentifiers"
        },
        ListResourceEvaluations: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "ResourceEvaluations"
        },
        ListStoredQueries: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListTagsForResource: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "Tags"
        },
        SelectAggregateResourceConfig: {
          input_token: "NextToken",
          limit_key: "Limit",
          non_aggregate_keys: [
            "QueryInfo"
          ],
          output_token: "NextToken",
          result_key: "Results"
        },
        SelectResourceConfig: {
          input_token: "NextToken",
          limit_key: "Limit",
          non_aggregate_keys: [
            "QueryInfo"
          ],
          output_token: "NextToken",
          result_key: "Results"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/configservice.js
var require_configservice = __commonJS({
  "node_modules/aws-sdk/clients/configservice.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["configservice"] = {};
    AWS2.ConfigService = Service.defineService("configservice", ["2014-11-12"]);
    Object.defineProperty(apiLoader.services["configservice"], "2014-11-12", {
      get: function get() {
        var model = require_config_2014_11_12_min();
        model.paginators = require_config_2014_11_12_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ConfigService;
  }
});

// node_modules/aws-sdk/apis/cur-2017-01-06.min.json
var require_cur_2017_01_06_min = __commonJS({
  "node_modules/aws-sdk/apis/cur-2017-01-06.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-01-06",
        endpointPrefix: "cur",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Cost and Usage Report Service",
        serviceId: "Cost and Usage Report Service",
        signatureVersion: "v4",
        signingName: "cur",
        targetPrefix: "AWSOrigamiServiceGatewayService",
        uid: "cur-2017-01-06"
      },
      operations: {
        DeleteReportDefinition: {
          input: {
            type: "structure",
            required: [
              "ReportName"
            ],
            members: {
              ReportName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResponseMessage: {}
            }
          }
        },
        DescribeReportDefinitions: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReportDefinitions: {
                type: "list",
                member: {
                  shape: "Sa"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ReportName"
            ],
            members: {
              ReportName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "St"
              }
            }
          }
        },
        ModifyReportDefinition: {
          input: {
            type: "structure",
            required: [
              "ReportName",
              "ReportDefinition"
            ],
            members: {
              ReportName: {},
              ReportDefinition: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutReportDefinition: {
          input: {
            type: "structure",
            required: [
              "ReportDefinition"
            ],
            members: {
              ReportDefinition: {
                shape: "Sa"
              },
              Tags: {
                shape: "St"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ReportName",
              "Tags"
            ],
            members: {
              ReportName: {},
              Tags: {
                shape: "St"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ReportName",
              "TagKeys"
            ],
            members: {
              ReportName: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        Sa: {
          type: "structure",
          required: [
            "ReportName",
            "TimeUnit",
            "Format",
            "Compression",
            "AdditionalSchemaElements",
            "S3Bucket",
            "S3Prefix",
            "S3Region"
          ],
          members: {
            ReportName: {},
            TimeUnit: {},
            Format: {},
            Compression: {},
            AdditionalSchemaElements: {
              type: "list",
              member: {}
            },
            S3Bucket: {},
            S3Prefix: {},
            S3Region: {},
            AdditionalArtifacts: {
              type: "list",
              member: {}
            },
            RefreshClosedReports: {
              type: "boolean"
            },
            ReportVersioning: {},
            BillingViewArn: {},
            ReportStatus: {
              type: "structure",
              members: {
                lastDelivery: {},
                lastStatus: {}
              }
            }
          }
        },
        St: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cur-2017-01-06.paginators.json
var require_cur_2017_01_06_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cur-2017-01-06.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeReportDefinitions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/cur.js
var require_cur = __commonJS({
  "node_modules/aws-sdk/clients/cur.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["cur"] = {};
    AWS2.CUR = Service.defineService("cur", ["2017-01-06"]);
    Object.defineProperty(apiLoader.services["cur"], "2017-01-06", {
      get: function get() {
        var model = require_cur_2017_01_06_min();
        model.paginators = require_cur_2017_01_06_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CUR;
  }
});

// node_modules/aws-sdk/apis/datapipeline-2012-10-29.min.json
var require_datapipeline_2012_10_29_min = __commonJS({
  "node_modules/aws-sdk/apis/datapipeline-2012-10-29.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2012-10-29",
        endpointPrefix: "datapipeline",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Data Pipeline",
        serviceId: "Data Pipeline",
        signatureVersion: "v4",
        targetPrefix: "DataPipeline",
        uid: "datapipeline-2012-10-29"
      },
      operations: {
        ActivatePipeline: {
          input: {
            type: "structure",
            required: [
              "pipelineId"
            ],
            members: {
              pipelineId: {},
              parameterValues: {
                shape: "S3"
              },
              startTimestamp: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AddTags: {
          input: {
            type: "structure",
            required: [
              "pipelineId",
              "tags"
            ],
            members: {
              pipelineId: {},
              tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreatePipeline: {
          input: {
            type: "structure",
            required: [
              "name",
              "uniqueId"
            ],
            members: {
              name: {},
              uniqueId: {},
              description: {},
              tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "pipelineId"
            ],
            members: {
              pipelineId: {}
            }
          }
        },
        DeactivatePipeline: {
          input: {
            type: "structure",
            required: [
              "pipelineId"
            ],
            members: {
              pipelineId: {},
              cancelActive: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeletePipeline: {
          input: {
            type: "structure",
            required: [
              "pipelineId"
            ],
            members: {
              pipelineId: {}
            }
          }
        },
        DescribeObjects: {
          input: {
            type: "structure",
            required: [
              "pipelineId",
              "objectIds"
            ],
            members: {
              pipelineId: {},
              objectIds: {
                shape: "Sn"
              },
              evaluateExpressions: {
                type: "boolean"
              },
              marker: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "pipelineObjects"
            ],
            members: {
              pipelineObjects: {
                shape: "Sq"
              },
              marker: {},
              hasMoreResults: {
                type: "boolean"
              }
            }
          }
        },
        DescribePipelines: {
          input: {
            type: "structure",
            required: [
              "pipelineIds"
            ],
            members: {
              pipelineIds: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "pipelineDescriptionList"
            ],
            members: {
              pipelineDescriptionList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "pipelineId",
                    "name",
                    "fields"
                  ],
                  members: {
                    pipelineId: {},
                    name: {},
                    fields: {
                      shape: "Ss"
                    },
                    description: {},
                    tags: {
                      shape: "Sa"
                    }
                  }
                }
              }
            }
          }
        },
        EvaluateExpression: {
          input: {
            type: "structure",
            required: [
              "pipelineId",
              "objectId",
              "expression"
            ],
            members: {
              pipelineId: {},
              objectId: {},
              expression: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "evaluatedExpression"
            ],
            members: {
              evaluatedExpression: {}
            }
          }
        },
        GetPipelineDefinition: {
          input: {
            type: "structure",
            required: [
              "pipelineId"
            ],
            members: {
              pipelineId: {},
              version: {}
            }
          },
          output: {
            type: "structure",
            members: {
              pipelineObjects: {
                shape: "Sq"
              },
              parameterObjects: {
                shape: "S13"
              },
              parameterValues: {
                shape: "S3"
              }
            }
          }
        },
        ListPipelines: {
          input: {
            type: "structure",
            members: {
              marker: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "pipelineIdList"
            ],
            members: {
              pipelineIdList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    name: {}
                  }
                }
              },
              marker: {},
              hasMoreResults: {
                type: "boolean"
              }
            }
          }
        },
        PollForTask: {
          input: {
            type: "structure",
            required: [
              "workerGroup"
            ],
            members: {
              workerGroup: {},
              hostname: {},
              instanceIdentity: {
                type: "structure",
                members: {
                  document: {},
                  signature: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskObject: {
                type: "structure",
                members: {
                  taskId: {},
                  pipelineId: {},
                  attemptId: {},
                  objects: {
                    type: "map",
                    key: {},
                    value: {
                      shape: "Sr"
                    }
                  }
                }
              }
            }
          }
        },
        PutPipelineDefinition: {
          input: {
            type: "structure",
            required: [
              "pipelineId",
              "pipelineObjects"
            ],
            members: {
              pipelineId: {},
              pipelineObjects: {
                shape: "Sq"
              },
              parameterObjects: {
                shape: "S13"
              },
              parameterValues: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "errored"
            ],
            members: {
              validationErrors: {
                shape: "S1l"
              },
              validationWarnings: {
                shape: "S1p"
              },
              errored: {
                type: "boolean"
              }
            }
          }
        },
        QueryObjects: {
          input: {
            type: "structure",
            required: [
              "pipelineId",
              "sphere"
            ],
            members: {
              pipelineId: {},
              query: {
                type: "structure",
                members: {
                  selectors: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        fieldName: {},
                        operator: {
                          type: "structure",
                          members: {
                            type: {},
                            values: {
                              shape: "S1x"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              sphere: {},
              marker: {},
              limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ids: {
                shape: "Sn"
              },
              marker: {},
              hasMoreResults: {
                type: "boolean"
              }
            }
          }
        },
        RemoveTags: {
          input: {
            type: "structure",
            required: [
              "pipelineId",
              "tagKeys"
            ],
            members: {
              pipelineId: {},
              tagKeys: {
                shape: "S1x"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ReportTaskProgress: {
          input: {
            type: "structure",
            required: [
              "taskId"
            ],
            members: {
              taskId: {},
              fields: {
                shape: "Ss"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "canceled"
            ],
            members: {
              canceled: {
                type: "boolean"
              }
            }
          }
        },
        ReportTaskRunnerHeartbeat: {
          input: {
            type: "structure",
            required: [
              "taskrunnerId"
            ],
            members: {
              taskrunnerId: {},
              workerGroup: {},
              hostname: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "terminate"
            ],
            members: {
              terminate: {
                type: "boolean"
              }
            }
          }
        },
        SetStatus: {
          input: {
            type: "structure",
            required: [
              "pipelineId",
              "objectIds",
              "status"
            ],
            members: {
              pipelineId: {},
              objectIds: {
                shape: "Sn"
              },
              status: {}
            }
          }
        },
        SetTaskStatus: {
          input: {
            type: "structure",
            required: [
              "taskId",
              "taskStatus"
            ],
            members: {
              taskId: {},
              taskStatus: {},
              errorId: {},
              errorMessage: {},
              errorStackTrace: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ValidatePipelineDefinition: {
          input: {
            type: "structure",
            required: [
              "pipelineId",
              "pipelineObjects"
            ],
            members: {
              pipelineId: {},
              pipelineObjects: {
                shape: "Sq"
              },
              parameterObjects: {
                shape: "S13"
              },
              parameterValues: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "errored"
            ],
            members: {
              validationErrors: {
                shape: "S1l"
              },
              validationWarnings: {
                shape: "S1p"
              },
              errored: {
                type: "boolean"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "id",
              "stringValue"
            ],
            members: {
              id: {},
              stringValue: {}
            }
          }
        },
        Sa: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        Sn: {
          type: "list",
          member: {}
        },
        Sq: {
          type: "list",
          member: {
            shape: "Sr"
          }
        },
        Sr: {
          type: "structure",
          required: [
            "id",
            "name",
            "fields"
          ],
          members: {
            id: {},
            name: {},
            fields: {
              shape: "Ss"
            }
          }
        },
        Ss: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key"
            ],
            members: {
              key: {},
              stringValue: {},
              refValue: {}
            }
          }
        },
        S13: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "id",
              "attributes"
            ],
            members: {
              id: {},
              attributes: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "key",
                    "stringValue"
                  ],
                  members: {
                    key: {},
                    stringValue: {}
                  }
                }
              }
            }
          }
        },
        S1l: {
          type: "list",
          member: {
            type: "structure",
            members: {
              id: {},
              errors: {
                shape: "S1n"
              }
            }
          }
        },
        S1n: {
          type: "list",
          member: {}
        },
        S1p: {
          type: "list",
          member: {
            type: "structure",
            members: {
              id: {},
              warnings: {
                shape: "S1n"
              }
            }
          }
        },
        S1x: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/datapipeline-2012-10-29.paginators.json
var require_datapipeline_2012_10_29_paginators = __commonJS({
  "node_modules/aws-sdk/apis/datapipeline-2012-10-29.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeObjects: {
          input_token: "marker",
          more_results: "hasMoreResults",
          output_token: "marker",
          result_key: "pipelineObjects"
        },
        DescribePipelines: {
          result_key: "pipelineDescriptionList"
        },
        ListPipelines: {
          input_token: "marker",
          more_results: "hasMoreResults",
          output_token: "marker",
          result_key: "pipelineIdList"
        },
        QueryObjects: {
          input_token: "marker",
          limit_key: "limit",
          more_results: "hasMoreResults",
          output_token: "marker",
          result_key: "ids"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/datapipeline.js
var require_datapipeline = __commonJS({
  "node_modules/aws-sdk/clients/datapipeline.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["datapipeline"] = {};
    AWS2.DataPipeline = Service.defineService("datapipeline", ["2012-10-29"]);
    Object.defineProperty(apiLoader.services["datapipeline"], "2012-10-29", {
      get: function get() {
        var model = require_datapipeline_2012_10_29_min();
        model.paginators = require_datapipeline_2012_10_29_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.DataPipeline;
  }
});

// node_modules/aws-sdk/apis/devicefarm-2015-06-23.min.json
var require_devicefarm_2015_06_23_min = __commonJS({
  "node_modules/aws-sdk/apis/devicefarm-2015-06-23.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-06-23",
        endpointPrefix: "devicefarm",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Device Farm",
        serviceId: "Device Farm",
        signatureVersion: "v4",
        targetPrefix: "DeviceFarm_20150623",
        uid: "devicefarm-2015-06-23"
      },
      operations: {
        CreateDevicePool: {
          input: {
            type: "structure",
            required: [
              "projectArn",
              "name",
              "rules"
            ],
            members: {
              projectArn: {},
              name: {},
              description: {},
              rules: {
                shape: "S5"
              },
              maxDevices: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              devicePool: {
                shape: "Sc"
              }
            }
          }
        },
        CreateInstanceProfile: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              description: {},
              packageCleanup: {
                type: "boolean"
              },
              excludeAppPackagesFromCleanup: {
                shape: "Sg"
              },
              rebootAfterUse: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              instanceProfile: {
                shape: "Si"
              }
            }
          }
        },
        CreateNetworkProfile: {
          input: {
            type: "structure",
            required: [
              "projectArn",
              "name"
            ],
            members: {
              projectArn: {},
              name: {},
              description: {},
              type: {},
              uplinkBandwidthBits: {
                type: "long"
              },
              downlinkBandwidthBits: {
                type: "long"
              },
              uplinkDelayMs: {
                type: "long"
              },
              downlinkDelayMs: {
                type: "long"
              },
              uplinkJitterMs: {
                type: "long"
              },
              downlinkJitterMs: {
                type: "long"
              },
              uplinkLossPercent: {
                type: "integer"
              },
              downlinkLossPercent: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              networkProfile: {
                shape: "So"
              }
            }
          }
        },
        CreateProject: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              defaultJobTimeoutMinutes: {
                type: "integer"
              },
              vpcConfig: {
                shape: "Sr"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              project: {
                shape: "Sy"
              }
            }
          }
        },
        CreateRemoteAccessSession: {
          input: {
            type: "structure",
            required: [
              "projectArn",
              "deviceArn"
            ],
            members: {
              projectArn: {},
              deviceArn: {},
              instanceArn: {},
              sshPublicKey: {},
              remoteDebugEnabled: {
                type: "boolean"
              },
              remoteRecordEnabled: {
                type: "boolean"
              },
              remoteRecordAppArn: {},
              name: {},
              clientId: {},
              configuration: {
                type: "structure",
                members: {
                  billingMethod: {},
                  vpceConfigurationArns: {
                    shape: "S15"
                  }
                }
              },
              interactionMode: {},
              skipAppResign: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              remoteAccessSession: {
                shape: "S18"
              }
            }
          }
        },
        CreateTestGridProject: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              description: {},
              vpcConfig: {
                shape: "S1s"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              testGridProject: {
                shape: "S1w"
              }
            }
          }
        },
        CreateTestGridUrl: {
          input: {
            type: "structure",
            required: [
              "projectArn",
              "expiresInSeconds"
            ],
            members: {
              projectArn: {},
              expiresInSeconds: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              url: {
                shape: "S21"
              },
              expires: {
                type: "timestamp"
              }
            }
          }
        },
        CreateUpload: {
          input: {
            type: "structure",
            required: [
              "projectArn",
              "name",
              "type"
            ],
            members: {
              projectArn: {},
              name: {},
              type: {},
              contentType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              upload: {
                shape: "S26"
              }
            }
          }
        },
        CreateVPCEConfiguration: {
          input: {
            type: "structure",
            required: [
              "vpceConfigurationName",
              "vpceServiceName",
              "serviceDnsName"
            ],
            members: {
              vpceConfigurationName: {},
              vpceServiceName: {},
              serviceDnsName: {},
              vpceConfigurationDescription: {}
            }
          },
          output: {
            type: "structure",
            members: {
              vpceConfiguration: {
                shape: "S2h"
              }
            }
          }
        },
        DeleteDevicePool: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteInstanceProfile: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteNetworkProfile: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteProject: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRemoteAccessSession: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRun: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteTestGridProject: {
          input: {
            type: "structure",
            required: [
              "projectArn"
            ],
            members: {
              projectArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteUpload: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteVPCEConfiguration: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetAccountSettings: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              accountSettings: {
                type: "structure",
                members: {
                  awsAccountNumber: {},
                  unmeteredDevices: {
                    shape: "S34"
                  },
                  unmeteredRemoteAccessDevices: {
                    shape: "S34"
                  },
                  maxJobTimeoutMinutes: {
                    type: "integer"
                  },
                  trialMinutes: {
                    type: "structure",
                    members: {
                      total: {
                        type: "double"
                      },
                      remaining: {
                        type: "double"
                      }
                    }
                  },
                  maxSlots: {
                    type: "map",
                    key: {},
                    value: {
                      type: "integer"
                    }
                  },
                  defaultJobTimeoutMinutes: {
                    type: "integer"
                  },
                  skipAppResign: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        GetDevice: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              device: {
                shape: "S1b"
              }
            }
          }
        },
        GetDeviceInstance: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deviceInstance: {
                shape: "S1i"
              }
            }
          }
        },
        GetDevicePool: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              devicePool: {
                shape: "Sc"
              }
            }
          }
        },
        GetDevicePoolCompatibility: {
          input: {
            type: "structure",
            required: [
              "devicePoolArn"
            ],
            members: {
              devicePoolArn: {},
              appArn: {},
              testType: {},
              test: {
                shape: "S3f"
              },
              configuration: {
                shape: "S3i"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              compatibleDevices: {
                shape: "S3q"
              },
              incompatibleDevices: {
                shape: "S3q"
              }
            }
          }
        },
        GetInstanceProfile: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              instanceProfile: {
                shape: "Si"
              }
            }
          }
        },
        GetJob: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              job: {
                shape: "S3y"
              }
            }
          }
        },
        GetNetworkProfile: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              networkProfile: {
                shape: "So"
              }
            }
          }
        },
        GetOfferingStatus: {
          input: {
            type: "structure",
            members: {
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              current: {
                shape: "S46"
              },
              nextPeriod: {
                shape: "S46"
              },
              nextToken: {}
            }
          }
        },
        GetProject: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              project: {
                shape: "Sy"
              }
            }
          }
        },
        GetRemoteAccessSession: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              remoteAccessSession: {
                shape: "S18"
              }
            }
          }
        },
        GetRun: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              run: {
                shape: "S4n"
              }
            }
          }
        },
        GetSuite: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              suite: {
                shape: "S4w"
              }
            }
          }
        },
        GetTest: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              test: {
                shape: "S4z"
              }
            }
          }
        },
        GetTestGridProject: {
          input: {
            type: "structure",
            required: [
              "projectArn"
            ],
            members: {
              projectArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              testGridProject: {
                shape: "S1w"
              }
            }
          }
        },
        GetTestGridSession: {
          input: {
            type: "structure",
            members: {
              projectArn: {},
              sessionId: {},
              sessionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              testGridSession: {
                shape: "S55"
              }
            }
          }
        },
        GetUpload: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              upload: {
                shape: "S26"
              }
            }
          }
        },
        GetVPCEConfiguration: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              vpceConfiguration: {
                shape: "S2h"
              }
            }
          }
        },
        InstallToRemoteAccessSession: {
          input: {
            type: "structure",
            required: [
              "remoteAccessSessionArn",
              "appArn"
            ],
            members: {
              remoteAccessSessionArn: {},
              appArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              appUpload: {
                shape: "S26"
              }
            }
          }
        },
        ListArtifacts: {
          input: {
            type: "structure",
            required: [
              "arn",
              "type"
            ],
            members: {
              arn: {},
              type: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              artifacts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    name: {},
                    type: {},
                    extension: {},
                    url: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDeviceInstances: {
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deviceInstances: {
                shape: "S1h"
              },
              nextToken: {}
            }
          }
        },
        ListDevicePools: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              type: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              devicePools: {
                type: "list",
                member: {
                  shape: "Sc"
                }
              },
              nextToken: {}
            }
          }
        },
        ListDevices: {
          input: {
            type: "structure",
            members: {
              arn: {},
              nextToken: {},
              filters: {
                shape: "S4q"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              devices: {
                type: "list",
                member: {
                  shape: "S1b"
                }
              },
              nextToken: {}
            }
          }
        },
        ListInstanceProfiles: {
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              instanceProfiles: {
                type: "list",
                member: {
                  shape: "Si"
                }
              },
              nextToken: {}
            }
          }
        },
        ListJobs: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              jobs: {
                type: "list",
                member: {
                  shape: "S3y"
                }
              },
              nextToken: {}
            }
          }
        },
        ListNetworkProfiles: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              type: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              networkProfiles: {
                type: "list",
                member: {
                  shape: "So"
                }
              },
              nextToken: {}
            }
          }
        },
        ListOfferingPromotions: {
          input: {
            type: "structure",
            members: {
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              offeringPromotions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    description: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListOfferingTransactions: {
          input: {
            type: "structure",
            members: {
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              offeringTransactions: {
                type: "list",
                member: {
                  shape: "S69"
                }
              },
              nextToken: {}
            }
          }
        },
        ListOfferings: {
          input: {
            type: "structure",
            members: {
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              offerings: {
                type: "list",
                member: {
                  shape: "S4a"
                }
              },
              nextToken: {}
            }
          }
        },
        ListProjects: {
          input: {
            type: "structure",
            members: {
              arn: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              projects: {
                type: "list",
                member: {
                  shape: "Sy"
                }
              },
              nextToken: {}
            }
          }
        },
        ListRemoteAccessSessions: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              remoteAccessSessions: {
                type: "list",
                member: {
                  shape: "S18"
                }
              },
              nextToken: {}
            }
          }
        },
        ListRuns: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              runs: {
                type: "list",
                member: {
                  shape: "S4n"
                }
              },
              nextToken: {}
            }
          }
        },
        ListSamples: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              samples: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    type: {},
                    url: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSuites: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              suites: {
                type: "list",
                member: {
                  shape: "S4w"
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S6x"
              }
            }
          }
        },
        ListTestGridProjects: {
          input: {
            type: "structure",
            members: {
              maxResult: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              testGridProjects: {
                type: "list",
                member: {
                  shape: "S1w"
                }
              },
              nextToken: {}
            }
          }
        },
        ListTestGridSessionActions: {
          input: {
            type: "structure",
            required: [
              "sessionArn"
            ],
            members: {
              sessionArn: {},
              maxResult: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              actions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    action: {},
                    started: {
                      type: "timestamp"
                    },
                    duration: {
                      type: "long"
                    },
                    statusCode: {},
                    requestMethod: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTestGridSessionArtifacts: {
          input: {
            type: "structure",
            required: [
              "sessionArn"
            ],
            members: {
              sessionArn: {},
              type: {},
              maxResult: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              artifacts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    filename: {},
                    type: {},
                    url: {
                      shape: "S21"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTestGridSessions: {
          input: {
            type: "structure",
            required: [
              "projectArn"
            ],
            members: {
              projectArn: {},
              status: {},
              creationTimeAfter: {
                type: "timestamp"
              },
              creationTimeBefore: {
                type: "timestamp"
              },
              endTimeAfter: {
                type: "timestamp"
              },
              endTimeBefore: {
                type: "timestamp"
              },
              maxResult: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              testGridSessions: {
                type: "list",
                member: {
                  shape: "S55"
                }
              },
              nextToken: {}
            }
          }
        },
        ListTests: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tests: {
                type: "list",
                member: {
                  shape: "S4z"
                }
              },
              nextToken: {}
            }
          }
        },
        ListUniqueProblems: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              uniqueProblems: {
                type: "map",
                key: {},
                value: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      message: {},
                      problems: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            run: {
                              shape: "S7s"
                            },
                            job: {
                              shape: "S7s"
                            },
                            suite: {
                              shape: "S7s"
                            },
                            test: {
                              shape: "S7s"
                            },
                            device: {
                              shape: "S1b"
                            },
                            result: {},
                            message: {}
                          }
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListUploads: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              type: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              uploads: {
                type: "list",
                member: {
                  shape: "S26"
                }
              },
              nextToken: {}
            }
          }
        },
        ListVPCEConfigurations: {
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              vpceConfigurations: {
                type: "list",
                member: {
                  shape: "S2h"
                }
              },
              nextToken: {}
            }
          }
        },
        PurchaseOffering: {
          input: {
            type: "structure",
            required: [
              "offeringId",
              "quantity"
            ],
            members: {
              offeringId: {},
              quantity: {
                type: "integer"
              },
              offeringPromotionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              offeringTransaction: {
                shape: "S69"
              }
            }
          }
        },
        RenewOffering: {
          input: {
            type: "structure",
            required: [
              "offeringId",
              "quantity"
            ],
            members: {
              offeringId: {},
              quantity: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              offeringTransaction: {
                shape: "S69"
              }
            }
          }
        },
        ScheduleRun: {
          input: {
            type: "structure",
            required: [
              "projectArn",
              "test"
            ],
            members: {
              projectArn: {},
              appArn: {},
              devicePoolArn: {},
              deviceSelectionConfiguration: {
                type: "structure",
                required: [
                  "filters",
                  "maxDevices"
                ],
                members: {
                  filters: {
                    shape: "S4q"
                  },
                  maxDevices: {
                    type: "integer"
                  }
                }
              },
              name: {},
              test: {
                shape: "S3f"
              },
              configuration: {
                shape: "S3i"
              },
              executionConfiguration: {
                type: "structure",
                members: {
                  jobTimeoutMinutes: {
                    type: "integer"
                  },
                  accountsCleanup: {
                    type: "boolean"
                  },
                  appPackagesCleanup: {
                    type: "boolean"
                  },
                  videoCapture: {
                    type: "boolean"
                  },
                  skipAppResign: {
                    type: "boolean"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              run: {
                shape: "S4n"
              }
            }
          }
        },
        StopJob: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              job: {
                shape: "S3y"
              }
            }
          }
        },
        StopRemoteAccessSession: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              remoteAccessSession: {
                shape: "S18"
              }
            }
          }
        },
        StopRun: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              run: {
                shape: "S4n"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S6x"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDeviceInstance: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              profileArn: {},
              labels: {
                shape: "S1j"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              deviceInstance: {
                shape: "S1i"
              }
            }
          }
        },
        UpdateDevicePool: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              name: {},
              description: {},
              rules: {
                shape: "S5"
              },
              maxDevices: {
                type: "integer"
              },
              clearMaxDevices: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              devicePool: {
                shape: "Sc"
              }
            }
          }
        },
        UpdateInstanceProfile: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              name: {},
              description: {},
              packageCleanup: {
                type: "boolean"
              },
              excludeAppPackagesFromCleanup: {
                shape: "Sg"
              },
              rebootAfterUse: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              instanceProfile: {
                shape: "Si"
              }
            }
          }
        },
        UpdateNetworkProfile: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              name: {},
              description: {},
              type: {},
              uplinkBandwidthBits: {
                type: "long"
              },
              downlinkBandwidthBits: {
                type: "long"
              },
              uplinkDelayMs: {
                type: "long"
              },
              downlinkDelayMs: {
                type: "long"
              },
              uplinkJitterMs: {
                type: "long"
              },
              downlinkJitterMs: {
                type: "long"
              },
              uplinkLossPercent: {
                type: "integer"
              },
              downlinkLossPercent: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              networkProfile: {
                shape: "So"
              }
            }
          }
        },
        UpdateProject: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              name: {},
              defaultJobTimeoutMinutes: {
                type: "integer"
              },
              vpcConfig: {
                shape: "Sr"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              project: {
                shape: "Sy"
              }
            }
          }
        },
        UpdateTestGridProject: {
          input: {
            type: "structure",
            required: [
              "projectArn"
            ],
            members: {
              projectArn: {},
              name: {},
              description: {},
              vpcConfig: {
                shape: "S1s"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              testGridProject: {
                shape: "S1w"
              }
            }
          }
        },
        UpdateUpload: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              name: {},
              contentType: {},
              editContent: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              upload: {
                shape: "S26"
              }
            }
          }
        },
        UpdateVPCEConfiguration: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              vpceConfigurationName: {},
              vpceServiceName: {},
              serviceDnsName: {},
              vpceConfigurationDescription: {}
            }
          },
          output: {
            type: "structure",
            members: {
              vpceConfiguration: {
                shape: "S2h"
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "list",
          member: {
            type: "structure",
            members: {
              attribute: {},
              operator: {},
              value: {}
            }
          }
        },
        Sc: {
          type: "structure",
          members: {
            arn: {},
            name: {},
            description: {},
            type: {},
            rules: {
              shape: "S5"
            },
            maxDevices: {
              type: "integer"
            }
          }
        },
        Sg: {
          type: "list",
          member: {}
        },
        Si: {
          type: "structure",
          members: {
            arn: {},
            packageCleanup: {
              type: "boolean"
            },
            excludeAppPackagesFromCleanup: {
              shape: "Sg"
            },
            rebootAfterUse: {
              type: "boolean"
            },
            name: {},
            description: {}
          }
        },
        So: {
          type: "structure",
          members: {
            arn: {},
            name: {},
            description: {},
            type: {},
            uplinkBandwidthBits: {
              type: "long"
            },
            downlinkBandwidthBits: {
              type: "long"
            },
            uplinkDelayMs: {
              type: "long"
            },
            downlinkDelayMs: {
              type: "long"
            },
            uplinkJitterMs: {
              type: "long"
            },
            downlinkJitterMs: {
              type: "long"
            },
            uplinkLossPercent: {
              type: "integer"
            },
            downlinkLossPercent: {
              type: "integer"
            }
          }
        },
        Sr: {
          type: "structure",
          required: [
            "securityGroupIds",
            "subnetIds",
            "vpcId"
          ],
          members: {
            securityGroupIds: {
              type: "list",
              member: {}
            },
            subnetIds: {
              type: "list",
              member: {}
            },
            vpcId: {}
          }
        },
        Sy: {
          type: "structure",
          members: {
            arn: {},
            name: {},
            defaultJobTimeoutMinutes: {
              type: "integer"
            },
            created: {
              type: "timestamp"
            },
            vpcConfig: {
              shape: "Sr"
            }
          }
        },
        S15: {
          type: "list",
          member: {}
        },
        S18: {
          type: "structure",
          members: {
            arn: {},
            name: {},
            created: {
              type: "timestamp"
            },
            status: {},
            result: {},
            message: {},
            started: {
              type: "timestamp"
            },
            stopped: {
              type: "timestamp"
            },
            device: {
              shape: "S1b"
            },
            instanceArn: {},
            remoteDebugEnabled: {
              type: "boolean"
            },
            remoteRecordEnabled: {
              type: "boolean"
            },
            remoteRecordAppArn: {},
            hostAddress: {},
            clientId: {},
            billingMethod: {},
            deviceMinutes: {
              shape: "S1n"
            },
            endpoint: {},
            deviceUdid: {},
            interactionMode: {},
            skipAppResign: {
              type: "boolean"
            },
            vpcConfig: {
              shape: "Sr"
            }
          }
        },
        S1b: {
          type: "structure",
          members: {
            arn: {},
            name: {},
            manufacturer: {},
            model: {},
            modelId: {},
            formFactor: {},
            platform: {},
            os: {},
            cpu: {
              type: "structure",
              members: {
                frequency: {},
                architecture: {},
                clock: {
                  type: "double"
                }
              }
            },
            resolution: {
              type: "structure",
              members: {
                width: {
                  type: "integer"
                },
                height: {
                  type: "integer"
                }
              }
            },
            heapSize: {
              type: "long"
            },
            memory: {
              type: "long"
            },
            image: {},
            carrier: {},
            radio: {},
            remoteAccessEnabled: {
              type: "boolean"
            },
            remoteDebugEnabled: {
              type: "boolean"
            },
            fleetType: {},
            fleetName: {},
            instances: {
              shape: "S1h"
            },
            availability: {}
          }
        },
        S1h: {
          type: "list",
          member: {
            shape: "S1i"
          }
        },
        S1i: {
          type: "structure",
          members: {
            arn: {},
            deviceArn: {},
            labels: {
              shape: "S1j"
            },
            status: {},
            udid: {},
            instanceProfile: {
              shape: "Si"
            }
          }
        },
        S1j: {
          type: "list",
          member: {}
        },
        S1n: {
          type: "structure",
          members: {
            total: {
              type: "double"
            },
            metered: {
              type: "double"
            },
            unmetered: {
              type: "double"
            }
          }
        },
        S1s: {
          type: "structure",
          required: [
            "securityGroupIds",
            "subnetIds",
            "vpcId"
          ],
          members: {
            securityGroupIds: {
              type: "list",
              member: {}
            },
            subnetIds: {
              type: "list",
              member: {}
            },
            vpcId: {}
          }
        },
        S1w: {
          type: "structure",
          members: {
            arn: {},
            name: {},
            description: {},
            vpcConfig: {
              shape: "S1s"
            },
            created: {
              type: "timestamp"
            }
          }
        },
        S21: {
          type: "string",
          sensitive: true
        },
        S26: {
          type: "structure",
          members: {
            arn: {},
            name: {},
            created: {
              type: "timestamp"
            },
            type: {},
            status: {},
            url: {
              type: "string",
              sensitive: true
            },
            metadata: {},
            contentType: {},
            message: {},
            category: {}
          }
        },
        S2h: {
          type: "structure",
          members: {
            arn: {},
            vpceConfigurationName: {},
            vpceServiceName: {},
            serviceDnsName: {},
            vpceConfigurationDescription: {}
          }
        },
        S34: {
          type: "map",
          key: {},
          value: {
            type: "integer"
          }
        },
        S3f: {
          type: "structure",
          required: [
            "type"
          ],
          members: {
            type: {},
            testPackageArn: {},
            testSpecArn: {},
            filter: {},
            parameters: {
              type: "map",
              key: {},
              value: {}
            }
          }
        },
        S3i: {
          type: "structure",
          members: {
            extraDataPackageArn: {},
            networkProfileArn: {},
            locale: {},
            location: {
              shape: "S3j"
            },
            vpceConfigurationArns: {
              shape: "S15"
            },
            customerArtifactPaths: {
              shape: "S3k"
            },
            radios: {
              shape: "S3o"
            },
            auxiliaryApps: {
              shape: "S15"
            },
            billingMethod: {}
          }
        },
        S3j: {
          type: "structure",
          required: [
            "latitude",
            "longitude"
          ],
          members: {
            latitude: {
              type: "double"
            },
            longitude: {
              type: "double"
            }
          }
        },
        S3k: {
          type: "structure",
          members: {
            iosPaths: {
              type: "list",
              member: {}
            },
            androidPaths: {
              type: "list",
              member: {}
            },
            deviceHostPaths: {
              type: "list",
              member: {}
            }
          }
        },
        S3o: {
          type: "structure",
          members: {
            wifi: {
              type: "boolean"
            },
            bluetooth: {
              type: "boolean"
            },
            nfc: {
              type: "boolean"
            },
            gps: {
              type: "boolean"
            }
          }
        },
        S3q: {
          type: "list",
          member: {
            type: "structure",
            members: {
              device: {
                shape: "S1b"
              },
              compatible: {
                type: "boolean"
              },
              incompatibilityMessages: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    message: {},
                    type: {}
                  }
                }
              }
            }
          }
        },
        S3y: {
          type: "structure",
          members: {
            arn: {},
            name: {},
            type: {},
            created: {
              type: "timestamp"
            },
            status: {},
            result: {},
            started: {
              type: "timestamp"
            },
            stopped: {
              type: "timestamp"
            },
            counters: {
              shape: "S3z"
            },
            message: {},
            device: {
              shape: "S1b"
            },
            instanceArn: {},
            deviceMinutes: {
              shape: "S1n"
            },
            videoEndpoint: {},
            videoCapture: {
              type: "boolean"
            }
          }
        },
        S3z: {
          type: "structure",
          members: {
            total: {
              type: "integer"
            },
            passed: {
              type: "integer"
            },
            failed: {
              type: "integer"
            },
            warned: {
              type: "integer"
            },
            errored: {
              type: "integer"
            },
            stopped: {
              type: "integer"
            },
            skipped: {
              type: "integer"
            }
          }
        },
        S46: {
          type: "map",
          key: {},
          value: {
            shape: "S48"
          }
        },
        S48: {
          type: "structure",
          members: {
            type: {},
            offering: {
              shape: "S4a"
            },
            quantity: {
              type: "integer"
            },
            effectiveOn: {
              type: "timestamp"
            }
          }
        },
        S4a: {
          type: "structure",
          members: {
            id: {},
            description: {},
            type: {},
            platform: {},
            recurringCharges: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  cost: {
                    shape: "S4e"
                  },
                  frequency: {}
                }
              }
            }
          }
        },
        S4e: {
          type: "structure",
          members: {
            amount: {
              type: "double"
            },
            currencyCode: {}
          }
        },
        S4n: {
          type: "structure",
          members: {
            arn: {},
            name: {},
            type: {},
            platform: {},
            created: {
              type: "timestamp"
            },
            status: {},
            result: {},
            started: {
              type: "timestamp"
            },
            stopped: {
              type: "timestamp"
            },
            counters: {
              shape: "S3z"
            },
            message: {},
            totalJobs: {
              type: "integer"
            },
            completedJobs: {
              type: "integer"
            },
            billingMethod: {},
            deviceMinutes: {
              shape: "S1n"
            },
            networkProfile: {
              shape: "So"
            },
            parsingResultUrl: {},
            resultCode: {},
            seed: {
              type: "integer"
            },
            appUpload: {},
            eventCount: {
              type: "integer"
            },
            jobTimeoutMinutes: {
              type: "integer"
            },
            devicePoolArn: {},
            locale: {},
            radios: {
              shape: "S3o"
            },
            location: {
              shape: "S3j"
            },
            customerArtifactPaths: {
              shape: "S3k"
            },
            webUrl: {},
            skipAppResign: {
              type: "boolean"
            },
            testSpecArn: {},
            deviceSelectionResult: {
              type: "structure",
              members: {
                filters: {
                  shape: "S4q"
                },
                matchedDevicesCount: {
                  type: "integer"
                },
                maxDevices: {
                  type: "integer"
                }
              }
            },
            vpcConfig: {
              shape: "Sr"
            }
          }
        },
        S4q: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "attribute",
              "operator",
              "values"
            ],
            members: {
              attribute: {},
              operator: {},
              values: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S4w: {
          type: "structure",
          members: {
            arn: {},
            name: {},
            type: {},
            created: {
              type: "timestamp"
            },
            status: {},
            result: {},
            started: {
              type: "timestamp"
            },
            stopped: {
              type: "timestamp"
            },
            counters: {
              shape: "S3z"
            },
            message: {},
            deviceMinutes: {
              shape: "S1n"
            }
          }
        },
        S4z: {
          type: "structure",
          members: {
            arn: {},
            name: {},
            type: {},
            created: {
              type: "timestamp"
            },
            status: {},
            result: {},
            started: {
              type: "timestamp"
            },
            stopped: {
              type: "timestamp"
            },
            counters: {
              shape: "S3z"
            },
            message: {},
            deviceMinutes: {
              shape: "S1n"
            }
          }
        },
        S55: {
          type: "structure",
          members: {
            arn: {},
            status: {},
            created: {
              type: "timestamp"
            },
            ended: {
              type: "timestamp"
            },
            billingMinutes: {
              type: "double"
            },
            seleniumProperties: {}
          }
        },
        S69: {
          type: "structure",
          members: {
            offeringStatus: {
              shape: "S48"
            },
            transactionId: {},
            offeringPromotionId: {},
            createdOn: {
              type: "timestamp"
            },
            cost: {
              shape: "S4e"
            }
          }
        },
        S6x: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S7s: {
          type: "structure",
          members: {
            arn: {},
            name: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/devicefarm-2015-06-23.paginators.json
var require_devicefarm_2015_06_23_paginators = __commonJS({
  "node_modules/aws-sdk/apis/devicefarm-2015-06-23.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetOfferingStatus: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: [
            "current",
            "nextPeriod"
          ]
        },
        ListArtifacts: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "artifacts"
        },
        ListDevicePools: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "devicePools"
        },
        ListDevices: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "devices"
        },
        ListJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "jobs"
        },
        ListOfferingTransactions: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "offeringTransactions"
        },
        ListOfferings: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "offerings"
        },
        ListProjects: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "projects"
        },
        ListRuns: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "runs"
        },
        ListSamples: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "samples"
        },
        ListSuites: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "suites"
        },
        ListTestGridProjects: {
          input_token: "nextToken",
          limit_key: "maxResult",
          output_token: "nextToken"
        },
        ListTestGridSessionActions: {
          input_token: "nextToken",
          limit_key: "maxResult",
          output_token: "nextToken"
        },
        ListTestGridSessionArtifacts: {
          input_token: "nextToken",
          limit_key: "maxResult",
          output_token: "nextToken"
        },
        ListTestGridSessions: {
          input_token: "nextToken",
          limit_key: "maxResult",
          output_token: "nextToken"
        },
        ListTests: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "tests"
        },
        ListUniqueProblems: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "uniqueProblems"
        },
        ListUploads: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "uploads"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/devicefarm.js
var require_devicefarm = __commonJS({
  "node_modules/aws-sdk/clients/devicefarm.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["devicefarm"] = {};
    AWS2.DeviceFarm = Service.defineService("devicefarm", ["2015-06-23"]);
    Object.defineProperty(apiLoader.services["devicefarm"], "2015-06-23", {
      get: function get() {
        var model = require_devicefarm_2015_06_23_min();
        model.paginators = require_devicefarm_2015_06_23_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.DeviceFarm;
  }
});

// node_modules/aws-sdk/apis/directconnect-2012-10-25.min.json
var require_directconnect_2012_10_25_min = __commonJS({
  "node_modules/aws-sdk/apis/directconnect-2012-10-25.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2012-10-25",
        endpointPrefix: "directconnect",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Direct Connect",
        serviceId: "Direct Connect",
        signatureVersion: "v4",
        targetPrefix: "OvertureService",
        uid: "directconnect-2012-10-25"
      },
      operations: {
        AcceptDirectConnectGatewayAssociationProposal: {
          input: {
            type: "structure",
            required: [
              "directConnectGatewayId",
              "proposalId",
              "associatedGatewayOwnerAccount"
            ],
            members: {
              directConnectGatewayId: {},
              proposalId: {},
              associatedGatewayOwnerAccount: {},
              overrideAllowedPrefixesToDirectConnectGateway: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              directConnectGatewayAssociation: {
                shape: "S9"
              }
            }
          }
        },
        AllocateConnectionOnInterconnect: {
          input: {
            type: "structure",
            required: [
              "bandwidth",
              "connectionName",
              "ownerAccount",
              "interconnectId",
              "vlan"
            ],
            members: {
              bandwidth: {},
              connectionName: {},
              ownerAccount: {},
              interconnectId: {},
              vlan: {
                type: "integer"
              }
            }
          },
          output: {
            shape: "So"
          },
          deprecated: true
        },
        AllocateHostedConnection: {
          input: {
            type: "structure",
            required: [
              "connectionId",
              "ownerAccount",
              "bandwidth",
              "connectionName",
              "vlan"
            ],
            members: {
              connectionId: {},
              ownerAccount: {},
              bandwidth: {},
              connectionName: {},
              vlan: {
                type: "integer"
              },
              tags: {
                shape: "S10"
              }
            }
          },
          output: {
            shape: "So"
          }
        },
        AllocatePrivateVirtualInterface: {
          input: {
            type: "structure",
            required: [
              "connectionId",
              "ownerAccount",
              "newPrivateVirtualInterfaceAllocation"
            ],
            members: {
              connectionId: {},
              ownerAccount: {},
              newPrivateVirtualInterfaceAllocation: {
                type: "structure",
                required: [
                  "virtualInterfaceName",
                  "vlan",
                  "asn"
                ],
                members: {
                  virtualInterfaceName: {},
                  vlan: {
                    type: "integer"
                  },
                  asn: {
                    type: "integer"
                  },
                  mtu: {
                    type: "integer"
                  },
                  authKey: {},
                  amazonAddress: {},
                  addressFamily: {},
                  customerAddress: {},
                  tags: {
                    shape: "S10"
                  }
                }
              }
            }
          },
          output: {
            shape: "S1o"
          }
        },
        AllocatePublicVirtualInterface: {
          input: {
            type: "structure",
            required: [
              "connectionId",
              "ownerAccount",
              "newPublicVirtualInterfaceAllocation"
            ],
            members: {
              connectionId: {},
              ownerAccount: {},
              newPublicVirtualInterfaceAllocation: {
                type: "structure",
                required: [
                  "virtualInterfaceName",
                  "vlan",
                  "asn"
                ],
                members: {
                  virtualInterfaceName: {},
                  vlan: {
                    type: "integer"
                  },
                  asn: {
                    type: "integer"
                  },
                  authKey: {},
                  amazonAddress: {},
                  customerAddress: {},
                  addressFamily: {},
                  routeFilterPrefixes: {
                    shape: "S5"
                  },
                  tags: {
                    shape: "S10"
                  }
                }
              }
            }
          },
          output: {
            shape: "S1o"
          }
        },
        AllocateTransitVirtualInterface: {
          input: {
            type: "structure",
            required: [
              "connectionId",
              "ownerAccount",
              "newTransitVirtualInterfaceAllocation"
            ],
            members: {
              connectionId: {},
              ownerAccount: {},
              newTransitVirtualInterfaceAllocation: {
                type: "structure",
                members: {
                  virtualInterfaceName: {},
                  vlan: {
                    type: "integer"
                  },
                  asn: {
                    type: "integer"
                  },
                  mtu: {
                    type: "integer"
                  },
                  authKey: {},
                  amazonAddress: {},
                  customerAddress: {},
                  addressFamily: {},
                  tags: {
                    shape: "S10"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              virtualInterface: {
                shape: "S1o"
              }
            }
          }
        },
        AssociateConnectionWithLag: {
          input: {
            type: "structure",
            required: [
              "connectionId",
              "lagId"
            ],
            members: {
              connectionId: {},
              lagId: {}
            }
          },
          output: {
            shape: "So"
          }
        },
        AssociateHostedConnection: {
          input: {
            type: "structure",
            required: [
              "connectionId",
              "parentConnectionId"
            ],
            members: {
              connectionId: {},
              parentConnectionId: {}
            }
          },
          output: {
            shape: "So"
          }
        },
        AssociateMacSecKey: {
          input: {
            type: "structure",
            required: [
              "connectionId"
            ],
            members: {
              connectionId: {},
              secretARN: {},
              ckn: {},
              cak: {}
            }
          },
          output: {
            type: "structure",
            members: {
              connectionId: {},
              macSecKeys: {
                shape: "S18"
              }
            }
          }
        },
        AssociateVirtualInterface: {
          input: {
            type: "structure",
            required: [
              "virtualInterfaceId",
              "connectionId"
            ],
            members: {
              virtualInterfaceId: {},
              connectionId: {}
            }
          },
          output: {
            shape: "S1o"
          }
        },
        ConfirmConnection: {
          input: {
            type: "structure",
            required: [
              "connectionId"
            ],
            members: {
              connectionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              connectionState: {}
            }
          }
        },
        ConfirmCustomerAgreement: {
          input: {
            type: "structure",
            members: {
              agreementName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              status: {}
            }
          }
        },
        ConfirmPrivateVirtualInterface: {
          input: {
            type: "structure",
            required: [
              "virtualInterfaceId"
            ],
            members: {
              virtualInterfaceId: {},
              virtualGatewayId: {},
              directConnectGatewayId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              virtualInterfaceState: {}
            }
          }
        },
        ConfirmPublicVirtualInterface: {
          input: {
            type: "structure",
            required: [
              "virtualInterfaceId"
            ],
            members: {
              virtualInterfaceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              virtualInterfaceState: {}
            }
          }
        },
        ConfirmTransitVirtualInterface: {
          input: {
            type: "structure",
            required: [
              "virtualInterfaceId",
              "directConnectGatewayId"
            ],
            members: {
              virtualInterfaceId: {},
              directConnectGatewayId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              virtualInterfaceState: {}
            }
          }
        },
        CreateBGPPeer: {
          input: {
            type: "structure",
            members: {
              virtualInterfaceId: {},
              newBGPPeer: {
                type: "structure",
                members: {
                  asn: {
                    type: "integer"
                  },
                  authKey: {},
                  addressFamily: {},
                  amazonAddress: {},
                  customerAddress: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              virtualInterface: {
                shape: "S1o"
              }
            }
          }
        },
        CreateConnection: {
          input: {
            type: "structure",
            required: [
              "location",
              "bandwidth",
              "connectionName"
            ],
            members: {
              location: {},
              bandwidth: {},
              connectionName: {},
              lagId: {},
              tags: {
                shape: "S10"
              },
              providerName: {},
              requestMACSec: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "So"
          }
        },
        CreateDirectConnectGateway: {
          input: {
            type: "structure",
            required: [
              "directConnectGatewayName"
            ],
            members: {
              directConnectGatewayName: {},
              amazonSideAsn: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              directConnectGateway: {
                shape: "S2v"
              }
            }
          }
        },
        CreateDirectConnectGatewayAssociation: {
          input: {
            type: "structure",
            required: [
              "directConnectGatewayId"
            ],
            members: {
              directConnectGatewayId: {},
              gatewayId: {},
              addAllowedPrefixesToDirectConnectGateway: {
                shape: "S5"
              },
              virtualGatewayId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              directConnectGatewayAssociation: {
                shape: "S9"
              }
            }
          }
        },
        CreateDirectConnectGatewayAssociationProposal: {
          input: {
            type: "structure",
            required: [
              "directConnectGatewayId",
              "directConnectGatewayOwnerAccount",
              "gatewayId"
            ],
            members: {
              directConnectGatewayId: {},
              directConnectGatewayOwnerAccount: {},
              gatewayId: {},
              addAllowedPrefixesToDirectConnectGateway: {
                shape: "S5"
              },
              removeAllowedPrefixesToDirectConnectGateway: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              directConnectGatewayAssociationProposal: {
                shape: "S32"
              }
            }
          }
        },
        CreateInterconnect: {
          input: {
            type: "structure",
            required: [
              "interconnectName",
              "bandwidth",
              "location"
            ],
            members: {
              interconnectName: {},
              bandwidth: {},
              location: {},
              lagId: {},
              tags: {
                shape: "S10"
              },
              providerName: {}
            }
          },
          output: {
            shape: "S36"
          }
        },
        CreateLag: {
          input: {
            type: "structure",
            required: [
              "numberOfConnections",
              "location",
              "connectionsBandwidth",
              "lagName"
            ],
            members: {
              numberOfConnections: {
                type: "integer"
              },
              location: {},
              connectionsBandwidth: {},
              lagName: {},
              connectionId: {},
              tags: {
                shape: "S10"
              },
              childConnectionTags: {
                shape: "S10"
              },
              providerName: {},
              requestMACSec: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S3b"
          }
        },
        CreatePrivateVirtualInterface: {
          input: {
            type: "structure",
            required: [
              "connectionId",
              "newPrivateVirtualInterface"
            ],
            members: {
              connectionId: {},
              newPrivateVirtualInterface: {
                type: "structure",
                required: [
                  "virtualInterfaceName",
                  "vlan",
                  "asn"
                ],
                members: {
                  virtualInterfaceName: {},
                  vlan: {
                    type: "integer"
                  },
                  asn: {
                    type: "integer"
                  },
                  mtu: {
                    type: "integer"
                  },
                  authKey: {},
                  amazonAddress: {},
                  customerAddress: {},
                  addressFamily: {},
                  virtualGatewayId: {},
                  directConnectGatewayId: {},
                  tags: {
                    shape: "S10"
                  },
                  enableSiteLink: {
                    type: "boolean"
                  }
                }
              }
            }
          },
          output: {
            shape: "S1o"
          }
        },
        CreatePublicVirtualInterface: {
          input: {
            type: "structure",
            required: [
              "connectionId",
              "newPublicVirtualInterface"
            ],
            members: {
              connectionId: {},
              newPublicVirtualInterface: {
                type: "structure",
                required: [
                  "virtualInterfaceName",
                  "vlan",
                  "asn"
                ],
                members: {
                  virtualInterfaceName: {},
                  vlan: {
                    type: "integer"
                  },
                  asn: {
                    type: "integer"
                  },
                  authKey: {},
                  amazonAddress: {},
                  customerAddress: {},
                  addressFamily: {},
                  routeFilterPrefixes: {
                    shape: "S5"
                  },
                  tags: {
                    shape: "S10"
                  }
                }
              }
            }
          },
          output: {
            shape: "S1o"
          }
        },
        CreateTransitVirtualInterface: {
          input: {
            type: "structure",
            required: [
              "connectionId",
              "newTransitVirtualInterface"
            ],
            members: {
              connectionId: {},
              newTransitVirtualInterface: {
                type: "structure",
                members: {
                  virtualInterfaceName: {},
                  vlan: {
                    type: "integer"
                  },
                  asn: {
                    type: "integer"
                  },
                  mtu: {
                    type: "integer"
                  },
                  authKey: {},
                  amazonAddress: {},
                  customerAddress: {},
                  addressFamily: {},
                  directConnectGatewayId: {},
                  tags: {
                    shape: "S10"
                  },
                  enableSiteLink: {
                    type: "boolean"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              virtualInterface: {
                shape: "S1o"
              }
            }
          }
        },
        DeleteBGPPeer: {
          input: {
            type: "structure",
            members: {
              virtualInterfaceId: {},
              asn: {
                type: "integer"
              },
              customerAddress: {},
              bgpPeerId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              virtualInterface: {
                shape: "S1o"
              }
            }
          }
        },
        DeleteConnection: {
          input: {
            type: "structure",
            required: [
              "connectionId"
            ],
            members: {
              connectionId: {}
            }
          },
          output: {
            shape: "So"
          }
        },
        DeleteDirectConnectGateway: {
          input: {
            type: "structure",
            required: [
              "directConnectGatewayId"
            ],
            members: {
              directConnectGatewayId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              directConnectGateway: {
                shape: "S2v"
              }
            }
          }
        },
        DeleteDirectConnectGatewayAssociation: {
          input: {
            type: "structure",
            members: {
              associationId: {},
              directConnectGatewayId: {},
              virtualGatewayId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              directConnectGatewayAssociation: {
                shape: "S9"
              }
            }
          }
        },
        DeleteDirectConnectGatewayAssociationProposal: {
          input: {
            type: "structure",
            required: [
              "proposalId"
            ],
            members: {
              proposalId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              directConnectGatewayAssociationProposal: {
                shape: "S32"
              }
            }
          }
        },
        DeleteInterconnect: {
          input: {
            type: "structure",
            required: [
              "interconnectId"
            ],
            members: {
              interconnectId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              interconnectState: {}
            }
          }
        },
        DeleteLag: {
          input: {
            type: "structure",
            required: [
              "lagId"
            ],
            members: {
              lagId: {}
            }
          },
          output: {
            shape: "S3b"
          }
        },
        DeleteVirtualInterface: {
          input: {
            type: "structure",
            required: [
              "virtualInterfaceId"
            ],
            members: {
              virtualInterfaceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              virtualInterfaceState: {}
            }
          }
        },
        DescribeConnectionLoa: {
          input: {
            type: "structure",
            required: [
              "connectionId"
            ],
            members: {
              connectionId: {},
              providerName: {},
              loaContentType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              loa: {
                shape: "S44"
              }
            }
          },
          deprecated: true
        },
        DescribeConnections: {
          input: {
            type: "structure",
            members: {
              connectionId: {}
            }
          },
          output: {
            shape: "S47"
          }
        },
        DescribeConnectionsOnInterconnect: {
          input: {
            type: "structure",
            required: [
              "interconnectId"
            ],
            members: {
              interconnectId: {}
            }
          },
          output: {
            shape: "S47"
          },
          deprecated: true
        },
        DescribeCustomerMetadata: {
          output: {
            type: "structure",
            members: {
              agreements: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    agreementName: {},
                    status: {}
                  }
                }
              },
              nniPartnerType: {}
            }
          }
        },
        DescribeDirectConnectGatewayAssociationProposals: {
          input: {
            type: "structure",
            members: {
              directConnectGatewayId: {},
              proposalId: {},
              associatedGatewayId: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              directConnectGatewayAssociationProposals: {
                type: "list",
                member: {
                  shape: "S32"
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeDirectConnectGatewayAssociations: {
          input: {
            type: "structure",
            members: {
              associationId: {},
              associatedGatewayId: {},
              directConnectGatewayId: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              virtualGatewayId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              directConnectGatewayAssociations: {
                type: "list",
                member: {
                  shape: "S9"
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeDirectConnectGatewayAttachments: {
          input: {
            type: "structure",
            members: {
              directConnectGatewayId: {},
              virtualInterfaceId: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              directConnectGatewayAttachments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    directConnectGatewayId: {},
                    virtualInterfaceId: {},
                    virtualInterfaceRegion: {},
                    virtualInterfaceOwnerAccount: {},
                    attachmentState: {},
                    attachmentType: {},
                    stateChangeError: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeDirectConnectGateways: {
          input: {
            type: "structure",
            members: {
              directConnectGatewayId: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              directConnectGateways: {
                type: "list",
                member: {
                  shape: "S2v"
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeHostedConnections: {
          input: {
            type: "structure",
            required: [
              "connectionId"
            ],
            members: {
              connectionId: {}
            }
          },
          output: {
            shape: "S47"
          }
        },
        DescribeInterconnectLoa: {
          input: {
            type: "structure",
            required: [
              "interconnectId"
            ],
            members: {
              interconnectId: {},
              providerName: {},
              loaContentType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              loa: {
                shape: "S44"
              }
            }
          },
          deprecated: true
        },
        DescribeInterconnects: {
          input: {
            type: "structure",
            members: {
              interconnectId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              interconnects: {
                type: "list",
                member: {
                  shape: "S36"
                }
              }
            }
          }
        },
        DescribeLags: {
          input: {
            type: "structure",
            members: {
              lagId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              lags: {
                type: "list",
                member: {
                  shape: "S3b"
                }
              }
            }
          }
        },
        DescribeLoa: {
          input: {
            type: "structure",
            required: [
              "connectionId"
            ],
            members: {
              connectionId: {},
              providerName: {},
              loaContentType: {}
            }
          },
          output: {
            shape: "S44"
          }
        },
        DescribeLocations: {
          output: {
            type: "structure",
            members: {
              locations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    locationCode: {},
                    locationName: {},
                    region: {},
                    availablePortSpeeds: {
                      type: "list",
                      member: {}
                    },
                    availableProviders: {
                      type: "list",
                      member: {}
                    },
                    availableMacSecPortSpeeds: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              }
            }
          }
        },
        DescribeRouterConfiguration: {
          input: {
            type: "structure",
            required: [
              "virtualInterfaceId"
            ],
            members: {
              virtualInterfaceId: {},
              routerTypeIdentifier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              customerRouterConfig: {},
              router: {
                type: "structure",
                members: {
                  vendor: {},
                  platform: {},
                  software: {},
                  xsltTemplateName: {},
                  xsltTemplateNameForMacSec: {},
                  routerTypeIdentifier: {}
                }
              },
              virtualInterfaceId: {},
              virtualInterfaceName: {}
            }
          }
        },
        DescribeTags: {
          input: {
            type: "structure",
            required: [
              "resourceArns"
            ],
            members: {
              resourceArns: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resourceTags: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    resourceArn: {},
                    tags: {
                      shape: "S10"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeVirtualGateways: {
          output: {
            type: "structure",
            members: {
              virtualGateways: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    virtualGatewayId: {},
                    virtualGatewayState: {}
                  }
                }
              }
            }
          }
        },
        DescribeVirtualInterfaces: {
          input: {
            type: "structure",
            members: {
              connectionId: {},
              virtualInterfaceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              virtualInterfaces: {
                type: "list",
                member: {
                  shape: "S1o"
                }
              }
            }
          }
        },
        DisassociateConnectionFromLag: {
          input: {
            type: "structure",
            required: [
              "connectionId",
              "lagId"
            ],
            members: {
              connectionId: {},
              lagId: {}
            }
          },
          output: {
            shape: "So"
          }
        },
        DisassociateMacSecKey: {
          input: {
            type: "structure",
            required: [
              "connectionId",
              "secretARN"
            ],
            members: {
              connectionId: {},
              secretARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              connectionId: {},
              macSecKeys: {
                shape: "S18"
              }
            }
          }
        },
        ListVirtualInterfaceTestHistory: {
          input: {
            type: "structure",
            members: {
              testId: {},
              virtualInterfaceId: {},
              bgpPeers: {
                shape: "S65"
              },
              status: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              virtualInterfaceTestHistory: {
                type: "list",
                member: {
                  shape: "S69"
                }
              },
              nextToken: {}
            }
          }
        },
        StartBgpFailoverTest: {
          input: {
            type: "structure",
            required: [
              "virtualInterfaceId"
            ],
            members: {
              virtualInterfaceId: {},
              bgpPeers: {
                shape: "S65"
              },
              testDurationInMinutes: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              virtualInterfaceTest: {
                shape: "S69"
              }
            }
          }
        },
        StopBgpFailoverTest: {
          input: {
            type: "structure",
            required: [
              "virtualInterfaceId"
            ],
            members: {
              virtualInterfaceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              virtualInterfaceTest: {
                shape: "S69"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateConnection: {
          input: {
            type: "structure",
            required: [
              "connectionId"
            ],
            members: {
              connectionId: {},
              connectionName: {},
              encryptionMode: {}
            }
          },
          output: {
            shape: "So"
          }
        },
        UpdateDirectConnectGateway: {
          input: {
            type: "structure",
            required: [
              "directConnectGatewayId",
              "newDirectConnectGatewayName"
            ],
            members: {
              directConnectGatewayId: {},
              newDirectConnectGatewayName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              directConnectGateway: {
                shape: "S2v"
              }
            }
          }
        },
        UpdateDirectConnectGatewayAssociation: {
          input: {
            type: "structure",
            members: {
              associationId: {},
              addAllowedPrefixesToDirectConnectGateway: {
                shape: "S5"
              },
              removeAllowedPrefixesToDirectConnectGateway: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              directConnectGatewayAssociation: {
                shape: "S9"
              }
            }
          }
        },
        UpdateLag: {
          input: {
            type: "structure",
            required: [
              "lagId"
            ],
            members: {
              lagId: {},
              lagName: {},
              minimumLinks: {
                type: "integer"
              },
              encryptionMode: {}
            }
          },
          output: {
            shape: "S3b"
          }
        },
        UpdateVirtualInterfaceAttributes: {
          input: {
            type: "structure",
            required: [
              "virtualInterfaceId"
            ],
            members: {
              virtualInterfaceId: {},
              mtu: {
                type: "integer"
              },
              enableSiteLink: {
                type: "boolean"
              },
              virtualInterfaceName: {}
            }
          },
          output: {
            shape: "S1o"
          }
        }
      },
      shapes: {
        S5: {
          type: "list",
          member: {
            type: "structure",
            members: {
              cidr: {}
            }
          }
        },
        S9: {
          type: "structure",
          members: {
            directConnectGatewayId: {},
            directConnectGatewayOwnerAccount: {},
            associationState: {},
            stateChangeError: {},
            associatedGateway: {
              shape: "Sc"
            },
            associationId: {},
            allowedPrefixesToDirectConnectGateway: {
              shape: "S5"
            },
            virtualGatewayId: {},
            virtualGatewayRegion: {
              type: "string",
              deprecated: true
            },
            virtualGatewayOwnerAccount: {}
          }
        },
        Sc: {
          type: "structure",
          members: {
            id: {},
            type: {},
            ownerAccount: {},
            region: {}
          }
        },
        So: {
          type: "structure",
          members: {
            ownerAccount: {},
            connectionId: {},
            connectionName: {},
            connectionState: {},
            region: {},
            location: {},
            bandwidth: {},
            vlan: {
              type: "integer"
            },
            partnerName: {},
            loaIssueTime: {
              type: "timestamp"
            },
            lagId: {},
            awsDevice: {
              shape: "Sv"
            },
            jumboFrameCapable: {
              type: "boolean"
            },
            awsDeviceV2: {},
            awsLogicalDeviceId: {},
            hasLogicalRedundancy: {},
            tags: {
              shape: "S10"
            },
            providerName: {},
            macSecCapable: {
              type: "boolean"
            },
            portEncryptionStatus: {},
            encryptionMode: {},
            macSecKeys: {
              shape: "S18"
            }
          }
        },
        Sv: {
          type: "string",
          deprecated: true
        },
        S10: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        S18: {
          type: "list",
          member: {
            type: "structure",
            members: {
              secretARN: {},
              ckn: {},
              state: {},
              startOn: {}
            }
          }
        },
        S1o: {
          type: "structure",
          members: {
            ownerAccount: {},
            virtualInterfaceId: {},
            location: {},
            connectionId: {},
            virtualInterfaceType: {},
            virtualInterfaceName: {},
            vlan: {
              type: "integer"
            },
            asn: {
              type: "integer"
            },
            amazonSideAsn: {
              type: "long"
            },
            authKey: {},
            amazonAddress: {},
            customerAddress: {},
            addressFamily: {},
            virtualInterfaceState: {},
            customerRouterConfig: {},
            mtu: {
              type: "integer"
            },
            jumboFrameCapable: {
              type: "boolean"
            },
            virtualGatewayId: {},
            directConnectGatewayId: {},
            routeFilterPrefixes: {
              shape: "S5"
            },
            bgpPeers: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  bgpPeerId: {},
                  asn: {
                    type: "integer"
                  },
                  authKey: {},
                  addressFamily: {},
                  amazonAddress: {},
                  customerAddress: {},
                  bgpPeerState: {},
                  bgpStatus: {},
                  awsDeviceV2: {},
                  awsLogicalDeviceId: {}
                }
              }
            },
            region: {},
            awsDeviceV2: {},
            awsLogicalDeviceId: {},
            tags: {
              shape: "S10"
            },
            siteLinkEnabled: {
              type: "boolean"
            }
          }
        },
        S2v: {
          type: "structure",
          members: {
            directConnectGatewayId: {},
            directConnectGatewayName: {},
            amazonSideAsn: {
              type: "long"
            },
            ownerAccount: {},
            directConnectGatewayState: {},
            stateChangeError: {}
          }
        },
        S32: {
          type: "structure",
          members: {
            proposalId: {},
            directConnectGatewayId: {},
            directConnectGatewayOwnerAccount: {},
            proposalState: {},
            associatedGateway: {
              shape: "Sc"
            },
            existingAllowedPrefixesToDirectConnectGateway: {
              shape: "S5"
            },
            requestedAllowedPrefixesToDirectConnectGateway: {
              shape: "S5"
            }
          }
        },
        S36: {
          type: "structure",
          members: {
            interconnectId: {},
            interconnectName: {},
            interconnectState: {},
            region: {},
            location: {},
            bandwidth: {},
            loaIssueTime: {
              type: "timestamp"
            },
            lagId: {},
            awsDevice: {
              shape: "Sv"
            },
            jumboFrameCapable: {
              type: "boolean"
            },
            awsDeviceV2: {},
            awsLogicalDeviceId: {},
            hasLogicalRedundancy: {},
            tags: {
              shape: "S10"
            },
            providerName: {}
          }
        },
        S3b: {
          type: "structure",
          members: {
            connectionsBandwidth: {},
            numberOfConnections: {
              type: "integer"
            },
            lagId: {},
            ownerAccount: {},
            lagName: {},
            lagState: {},
            location: {},
            region: {},
            minimumLinks: {
              type: "integer"
            },
            awsDevice: {
              shape: "Sv"
            },
            awsDeviceV2: {},
            awsLogicalDeviceId: {},
            connections: {
              shape: "S3d"
            },
            allowsHostedConnections: {
              type: "boolean"
            },
            jumboFrameCapable: {
              type: "boolean"
            },
            hasLogicalRedundancy: {},
            tags: {
              shape: "S10"
            },
            providerName: {},
            macSecCapable: {
              type: "boolean"
            },
            encryptionMode: {},
            macSecKeys: {
              shape: "S18"
            }
          }
        },
        S3d: {
          type: "list",
          member: {
            shape: "So"
          }
        },
        S44: {
          type: "structure",
          members: {
            loaContent: {
              type: "blob"
            },
            loaContentType: {}
          }
        },
        S47: {
          type: "structure",
          members: {
            connections: {
              shape: "S3d"
            }
          }
        },
        S65: {
          type: "list",
          member: {}
        },
        S69: {
          type: "structure",
          members: {
            testId: {},
            virtualInterfaceId: {},
            bgpPeers: {
              shape: "S65"
            },
            status: {},
            ownerAccount: {},
            testDurationInMinutes: {
              type: "integer"
            },
            startTime: {
              type: "timestamp"
            },
            endTime: {
              type: "timestamp"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/directconnect-2012-10-25.paginators.json
var require_directconnect_2012_10_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/directconnect-2012-10-25.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeConnections: {
          result_key: "connections"
        },
        DescribeConnectionsOnInterconnect: {
          result_key: "connections"
        },
        DescribeInterconnects: {
          result_key: "interconnects"
        },
        DescribeLocations: {
          result_key: "locations"
        },
        DescribeVirtualGateways: {
          result_key: "virtualGateways"
        },
        DescribeVirtualInterfaces: {
          result_key: "virtualInterfaces"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/directconnect.js
var require_directconnect = __commonJS({
  "node_modules/aws-sdk/clients/directconnect.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["directconnect"] = {};
    AWS2.DirectConnect = Service.defineService("directconnect", ["2012-10-25"]);
    Object.defineProperty(apiLoader.services["directconnect"], "2012-10-25", {
      get: function get() {
        var model = require_directconnect_2012_10_25_min();
        model.paginators = require_directconnect_2012_10_25_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.DirectConnect;
  }
});

// node_modules/aws-sdk/apis/ds-2015-04-16.min.json
var require_ds_2015_04_16_min = __commonJS({
  "node_modules/aws-sdk/apis/ds-2015-04-16.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-04-16",
        endpointPrefix: "ds",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Directory Service",
        serviceFullName: "AWS Directory Service",
        serviceId: "Directory Service",
        signatureVersion: "v4",
        targetPrefix: "DirectoryService_20150416",
        uid: "ds-2015-04-16"
      },
      operations: {
        AcceptSharedDirectory: {
          input: {
            type: "structure",
            required: [
              "SharedDirectoryId"
            ],
            members: {
              SharedDirectoryId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SharedDirectory: {
                shape: "S4"
              }
            }
          }
        },
        AddIpRoutes: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "IpRoutes"
            ],
            members: {
              DirectoryId: {},
              IpRoutes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CidrIp: {},
                    Description: {}
                  }
                }
              },
              UpdateSecurityGroupForDirectoryControllers: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AddRegion: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "RegionName",
              "VPCSettings"
            ],
            members: {
              DirectoryId: {},
              RegionName: {},
              VPCSettings: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AddTagsToResource: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "Tags"
            ],
            members: {
              ResourceId: {},
              Tags: {
                shape: "Sr"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CancelSchemaExtension: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "SchemaExtensionId"
            ],
            members: {
              DirectoryId: {},
              SchemaExtensionId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ConnectDirectory: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Password",
              "Size",
              "ConnectSettings"
            ],
            members: {
              Name: {},
              ShortName: {},
              Password: {
                shape: "S12"
              },
              Description: {},
              Size: {},
              ConnectSettings: {
                type: "structure",
                required: [
                  "VpcId",
                  "SubnetIds",
                  "CustomerDnsIps",
                  "CustomerUserName"
                ],
                members: {
                  VpcId: {},
                  SubnetIds: {
                    shape: "Sm"
                  },
                  CustomerDnsIps: {
                    shape: "S15"
                  },
                  CustomerUserName: {}
                }
              },
              Tags: {
                shape: "Sr"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DirectoryId: {}
            }
          }
        },
        CreateAlias: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "Alias"
            ],
            members: {
              DirectoryId: {},
              Alias: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DirectoryId: {},
              Alias: {}
            }
          }
        },
        CreateComputer: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "ComputerName",
              "Password"
            ],
            members: {
              DirectoryId: {},
              ComputerName: {},
              Password: {
                type: "string",
                sensitive: true
              },
              OrganizationalUnitDistinguishedName: {},
              ComputerAttributes: {
                shape: "S1g"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Computer: {
                type: "structure",
                members: {
                  ComputerId: {},
                  ComputerName: {},
                  ComputerAttributes: {
                    shape: "S1g"
                  }
                }
              }
            }
          }
        },
        CreateConditionalForwarder: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "RemoteDomainName",
              "DnsIpAddrs"
            ],
            members: {
              DirectoryId: {},
              RemoteDomainName: {},
              DnsIpAddrs: {
                shape: "S15"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateDirectory: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Password",
              "Size"
            ],
            members: {
              Name: {},
              ShortName: {},
              Password: {
                shape: "S1r"
              },
              Description: {},
              Size: {},
              VpcSettings: {
                shape: "Sk"
              },
              Tags: {
                shape: "Sr"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DirectoryId: {}
            }
          }
        },
        CreateLogSubscription: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "LogGroupName"
            ],
            members: {
              DirectoryId: {},
              LogGroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateMicrosoftAD: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Password",
              "VpcSettings"
            ],
            members: {
              Name: {},
              ShortName: {},
              Password: {
                shape: "S1r"
              },
              Description: {},
              VpcSettings: {
                shape: "Sk"
              },
              Edition: {},
              Tags: {
                shape: "Sr"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DirectoryId: {}
            }
          }
        },
        CreateSnapshot: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SnapshotId: {}
            }
          }
        },
        CreateTrust: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "RemoteDomainName",
              "TrustPassword",
              "TrustDirection"
            ],
            members: {
              DirectoryId: {},
              RemoteDomainName: {},
              TrustPassword: {
                type: "string",
                sensitive: true
              },
              TrustDirection: {},
              TrustType: {},
              ConditionalForwarderIpAddrs: {
                shape: "S15"
              },
              SelectiveAuth: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrustId: {}
            }
          }
        },
        DeleteConditionalForwarder: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "RemoteDomainName"
            ],
            members: {
              DirectoryId: {},
              RemoteDomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDirectory: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DirectoryId: {}
            }
          }
        },
        DeleteLogSubscription: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSnapshot: {
          input: {
            type: "structure",
            required: [
              "SnapshotId"
            ],
            members: {
              SnapshotId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SnapshotId: {}
            }
          }
        },
        DeleteTrust: {
          input: {
            type: "structure",
            required: [
              "TrustId"
            ],
            members: {
              TrustId: {},
              DeleteAssociatedConditionalForwarder: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrustId: {}
            }
          }
        },
        DeregisterCertificate: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "CertificateId"
            ],
            members: {
              DirectoryId: {},
              CertificateId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeregisterEventTopic: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "TopicName"
            ],
            members: {
              DirectoryId: {},
              TopicName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeCertificate: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "CertificateId"
            ],
            members: {
              DirectoryId: {},
              CertificateId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Certificate: {
                type: "structure",
                members: {
                  CertificateId: {},
                  State: {},
                  StateReason: {},
                  CommonName: {},
                  RegisteredDateTime: {
                    type: "timestamp"
                  },
                  ExpiryDateTime: {
                    type: "timestamp"
                  },
                  Type: {},
                  ClientCertAuthSettings: {
                    shape: "S30"
                  }
                }
              }
            }
          }
        },
        DescribeClientAuthenticationSettings: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {},
              Type: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ClientAuthenticationSettingsInfo: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    Status: {},
                    LastUpdatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeConditionalForwarders: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {},
              RemoteDomainNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConditionalForwarders: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RemoteDomainName: {},
                    DnsIpAddrs: {
                      shape: "S15"
                    },
                    ReplicationScope: {}
                  }
                }
              }
            }
          }
        },
        DescribeDirectories: {
          input: {
            type: "structure",
            members: {
              DirectoryIds: {
                shape: "S3h"
              },
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DirectoryDescriptions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DirectoryId: {},
                    Name: {},
                    ShortName: {},
                    Size: {},
                    Edition: {},
                    Alias: {},
                    AccessUrl: {},
                    Description: {},
                    DnsIpAddrs: {
                      shape: "S15"
                    },
                    Stage: {},
                    ShareStatus: {},
                    ShareMethod: {},
                    ShareNotes: {
                      shape: "S8"
                    },
                    LaunchTime: {
                      type: "timestamp"
                    },
                    StageLastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    Type: {},
                    VpcSettings: {
                      shape: "S3q"
                    },
                    ConnectSettings: {
                      type: "structure",
                      members: {
                        VpcId: {},
                        SubnetIds: {
                          shape: "Sm"
                        },
                        CustomerUserName: {},
                        SecurityGroupId: {},
                        AvailabilityZones: {
                          shape: "S3s"
                        },
                        ConnectIps: {
                          type: "list",
                          member: {}
                        }
                      }
                    },
                    RadiusSettings: {
                      shape: "S3w"
                    },
                    RadiusStatus: {},
                    StageReason: {},
                    SsoEnabled: {
                      type: "boolean"
                    },
                    DesiredNumberOfDomainControllers: {
                      type: "integer"
                    },
                    OwnerDirectoryDescription: {
                      type: "structure",
                      members: {
                        DirectoryId: {},
                        AccountId: {},
                        DnsIpAddrs: {
                          shape: "S15"
                        },
                        VpcSettings: {
                          shape: "S3q"
                        },
                        RadiusSettings: {
                          shape: "S3w"
                        },
                        RadiusStatus: {}
                      }
                    },
                    RegionsInfo: {
                      type: "structure",
                      members: {
                        PrimaryRegion: {},
                        AdditionalRegions: {
                          type: "list",
                          member: {}
                        }
                      }
                    },
                    OsVersion: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeDomainControllers: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {},
              DomainControllerIds: {
                type: "list",
                member: {}
              },
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainControllers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DirectoryId: {},
                    DomainControllerId: {},
                    DnsIpAddr: {},
                    VpcId: {},
                    SubnetId: {},
                    AvailabilityZone: {},
                    Status: {},
                    StatusReason: {},
                    LaunchTime: {
                      type: "timestamp"
                    },
                    StatusLastUpdatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeEventTopics: {
          input: {
            type: "structure",
            members: {
              DirectoryId: {},
              TopicNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventTopics: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DirectoryId: {},
                    TopicName: {},
                    TopicArn: {},
                    CreatedDateTime: {
                      type: "timestamp"
                    },
                    Status: {}
                  }
                }
              }
            }
          }
        },
        DescribeLDAPSSettings: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {},
              Type: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LDAPSSettingsInfo: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LDAPSStatus: {},
                    LDAPSStatusReason: {},
                    LastUpdatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeRegions: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {},
              RegionName: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RegionsDescription: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DirectoryId: {},
                    RegionName: {},
                    RegionType: {},
                    Status: {},
                    VpcSettings: {
                      shape: "Sk"
                    },
                    DesiredNumberOfDomainControllers: {
                      type: "integer"
                    },
                    LaunchTime: {
                      type: "timestamp"
                    },
                    StatusLastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    LastUpdatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeSettings: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {},
              Status: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DirectoryId: {},
              SettingEntries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    Name: {},
                    AllowedValues: {},
                    AppliedValue: {},
                    RequestedValue: {},
                    RequestStatus: {},
                    RequestDetailedStatus: {
                      type: "map",
                      key: {},
                      value: {}
                    },
                    RequestStatusMessage: {},
                    LastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    LastRequestedDateTime: {
                      type: "timestamp"
                    },
                    DataType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeSharedDirectories: {
          input: {
            type: "structure",
            required: [
              "OwnerDirectoryId"
            ],
            members: {
              OwnerDirectoryId: {},
              SharedDirectoryIds: {
                shape: "S3h"
              },
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SharedDirectories: {
                type: "list",
                member: {
                  shape: "S4"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeSnapshots: {
          input: {
            type: "structure",
            members: {
              DirectoryId: {},
              SnapshotIds: {
                type: "list",
                member: {}
              },
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Snapshots: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DirectoryId: {},
                    SnapshotId: {},
                    Type: {},
                    Name: {},
                    Status: {},
                    StartTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeTrusts: {
          input: {
            type: "structure",
            members: {
              DirectoryId: {},
              TrustIds: {
                type: "list",
                member: {}
              },
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Trusts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DirectoryId: {},
                    TrustId: {},
                    RemoteDomainName: {},
                    TrustType: {},
                    TrustDirection: {},
                    TrustState: {},
                    CreatedDateTime: {
                      type: "timestamp"
                    },
                    LastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    StateLastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    TrustStateReason: {},
                    SelectiveAuth: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeUpdateDirectory: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "UpdateType"
            ],
            members: {
              DirectoryId: {},
              UpdateType: {},
              RegionName: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UpdateActivities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Region: {},
                    Status: {},
                    StatusReason: {},
                    InitiatedBy: {},
                    NewValue: {
                      shape: "S6a"
                    },
                    PreviousValue: {
                      shape: "S6a"
                    },
                    StartTime: {
                      type: "timestamp"
                    },
                    LastUpdatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DisableClientAuthentication: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "Type"
            ],
            members: {
              DirectoryId: {},
              Type: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisableLDAPS: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "Type"
            ],
            members: {
              DirectoryId: {},
              Type: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisableRadius: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisableSso: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {},
              UserName: {},
              Password: {
                shape: "S12"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        EnableClientAuthentication: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "Type"
            ],
            members: {
              DirectoryId: {},
              Type: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        EnableLDAPS: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "Type"
            ],
            members: {
              DirectoryId: {},
              Type: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        EnableRadius: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "RadiusSettings"
            ],
            members: {
              DirectoryId: {},
              RadiusSettings: {
                shape: "S3w"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        EnableSso: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {},
              UserName: {},
              Password: {
                shape: "S12"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetDirectoryLimits: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              DirectoryLimits: {
                type: "structure",
                members: {
                  CloudOnlyDirectoriesLimit: {
                    type: "integer"
                  },
                  CloudOnlyDirectoriesCurrentCount: {
                    type: "integer"
                  },
                  CloudOnlyDirectoriesLimitReached: {
                    type: "boolean"
                  },
                  CloudOnlyMicrosoftADLimit: {
                    type: "integer"
                  },
                  CloudOnlyMicrosoftADCurrentCount: {
                    type: "integer"
                  },
                  CloudOnlyMicrosoftADLimitReached: {
                    type: "boolean"
                  },
                  ConnectedDirectoriesLimit: {
                    type: "integer"
                  },
                  ConnectedDirectoriesCurrentCount: {
                    type: "integer"
                  },
                  ConnectedDirectoriesLimitReached: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        GetSnapshotLimits: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SnapshotLimits: {
                type: "structure",
                members: {
                  ManualSnapshotsLimit: {
                    type: "integer"
                  },
                  ManualSnapshotsCurrentCount: {
                    type: "integer"
                  },
                  ManualSnapshotsLimitReached: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        ListCertificates: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              CertificatesInfo: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CertificateId: {},
                    CommonName: {},
                    State: {},
                    ExpiryDateTime: {
                      type: "timestamp"
                    },
                    Type: {}
                  }
                }
              }
            }
          }
        },
        ListIpRoutes: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IpRoutesInfo: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DirectoryId: {},
                    CidrIp: {},
                    IpRouteStatusMsg: {},
                    AddedDateTime: {
                      type: "timestamp"
                    },
                    IpRouteStatusReason: {},
                    Description: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListLogSubscriptions: {
          input: {
            type: "structure",
            members: {
              DirectoryId: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LogSubscriptions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DirectoryId: {},
                    LogGroupName: {},
                    SubscriptionCreatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSchemaExtensions: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaExtensionsInfo: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DirectoryId: {},
                    SchemaExtensionId: {},
                    Description: {},
                    SchemaExtensionStatus: {},
                    SchemaExtensionStatusReason: {},
                    StartDateTime: {
                      type: "timestamp"
                    },
                    EndDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              ResourceId: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sr"
              },
              NextToken: {}
            }
          }
        },
        RegisterCertificate: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "CertificateData"
            ],
            members: {
              DirectoryId: {},
              CertificateData: {},
              Type: {},
              ClientCertAuthSettings: {
                shape: "S30"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CertificateId: {}
            }
          }
        },
        RegisterEventTopic: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "TopicName"
            ],
            members: {
              DirectoryId: {},
              TopicName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RejectSharedDirectory: {
          input: {
            type: "structure",
            required: [
              "SharedDirectoryId"
            ],
            members: {
              SharedDirectoryId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SharedDirectoryId: {}
            }
          }
        },
        RemoveIpRoutes: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "CidrIps"
            ],
            members: {
              DirectoryId: {},
              CidrIps: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RemoveRegion: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RemoveTagsFromResource: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "TagKeys"
            ],
            members: {
              ResourceId: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ResetUserPassword: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "UserName",
              "NewPassword"
            ],
            members: {
              DirectoryId: {},
              UserName: {},
              NewPassword: {
                type: "string",
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RestoreFromSnapshot: {
          input: {
            type: "structure",
            required: [
              "SnapshotId"
            ],
            members: {
              SnapshotId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ShareDirectory: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "ShareTarget",
              "ShareMethod"
            ],
            members: {
              DirectoryId: {},
              ShareNotes: {
                shape: "S8"
              },
              ShareTarget: {
                type: "structure",
                required: [
                  "Id",
                  "Type"
                ],
                members: {
                  Id: {},
                  Type: {}
                }
              },
              ShareMethod: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SharedDirectoryId: {}
            }
          }
        },
        StartSchemaExtension: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "CreateSnapshotBeforeSchemaExtension",
              "LdifContent",
              "Description"
            ],
            members: {
              DirectoryId: {},
              CreateSnapshotBeforeSchemaExtension: {
                type: "boolean"
              },
              LdifContent: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaExtensionId: {}
            }
          }
        },
        UnshareDirectory: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "UnshareTarget"
            ],
            members: {
              DirectoryId: {},
              UnshareTarget: {
                type: "structure",
                required: [
                  "Id",
                  "Type"
                ],
                members: {
                  Id: {},
                  Type: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SharedDirectoryId: {}
            }
          }
        },
        UpdateConditionalForwarder: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "RemoteDomainName",
              "DnsIpAddrs"
            ],
            members: {
              DirectoryId: {},
              RemoteDomainName: {},
              DnsIpAddrs: {
                shape: "S15"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDirectorySetup: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "UpdateType"
            ],
            members: {
              DirectoryId: {},
              UpdateType: {},
              OSUpdateSettings: {
                shape: "S6b"
              },
              CreateSnapshotBeforeUpdate: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateNumberOfDomainControllers: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "DesiredNumber"
            ],
            members: {
              DirectoryId: {},
              DesiredNumber: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateRadius: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "RadiusSettings"
            ],
            members: {
              DirectoryId: {},
              RadiusSettings: {
                shape: "S3w"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateSettings: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "Settings"
            ],
            members: {
              DirectoryId: {},
              Settings: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Value"
                  ],
                  members: {
                    Name: {},
                    Value: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DirectoryId: {}
            }
          }
        },
        UpdateTrust: {
          input: {
            type: "structure",
            required: [
              "TrustId"
            ],
            members: {
              TrustId: {},
              SelectiveAuth: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              TrustId: {}
            }
          }
        },
        VerifyTrust: {
          input: {
            type: "structure",
            required: [
              "TrustId"
            ],
            members: {
              TrustId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrustId: {}
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            OwnerAccountId: {},
            OwnerDirectoryId: {},
            ShareMethod: {},
            SharedAccountId: {},
            SharedDirectoryId: {},
            ShareStatus: {},
            ShareNotes: {
              shape: "S8"
            },
            CreatedDateTime: {
              type: "timestamp"
            },
            LastUpdatedDateTime: {
              type: "timestamp"
            }
          }
        },
        S8: {
          type: "string",
          sensitive: true
        },
        Sk: {
          type: "structure",
          required: [
            "VpcId",
            "SubnetIds"
          ],
          members: {
            VpcId: {},
            SubnetIds: {
              shape: "Sm"
            }
          }
        },
        Sm: {
          type: "list",
          member: {}
        },
        Sr: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S12: {
          type: "string",
          sensitive: true
        },
        S15: {
          type: "list",
          member: {}
        },
        S1g: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Value: {}
            }
          }
        },
        S1r: {
          type: "string",
          sensitive: true
        },
        S30: {
          type: "structure",
          members: {
            OCSPUrl: {}
          }
        },
        S3h: {
          type: "list",
          member: {}
        },
        S3q: {
          type: "structure",
          members: {
            VpcId: {},
            SubnetIds: {
              shape: "Sm"
            },
            SecurityGroupId: {},
            AvailabilityZones: {
              shape: "S3s"
            }
          }
        },
        S3s: {
          type: "list",
          member: {}
        },
        S3w: {
          type: "structure",
          members: {
            RadiusServers: {
              type: "list",
              member: {}
            },
            RadiusPort: {
              type: "integer"
            },
            RadiusTimeout: {
              type: "integer"
            },
            RadiusRetries: {
              type: "integer"
            },
            SharedSecret: {
              type: "string",
              sensitive: true
            },
            AuthenticationProtocol: {},
            DisplayLabel: {},
            UseSameUsername: {
              type: "boolean"
            }
          }
        },
        S6a: {
          type: "structure",
          members: {
            OSUpdateSettings: {
              shape: "S6b"
            }
          }
        },
        S6b: {
          type: "structure",
          members: {
            OSVersion: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ds-2015-04-16.paginators.json
var require_ds_2015_04_16_paginators = __commonJS({
  "node_modules/aws-sdk/apis/ds-2015-04-16.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeClientAuthenticationSettings: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "ClientAuthenticationSettingsInfo"
        },
        DescribeDirectories: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "DirectoryDescriptions"
        },
        DescribeDomainControllers: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken"
        },
        DescribeLDAPSSettings: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "LDAPSSettingsInfo"
        },
        DescribeRegions: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "RegionsDescription"
        },
        DescribeSharedDirectories: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "SharedDirectories"
        },
        DescribeSnapshots: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "Snapshots"
        },
        DescribeTrusts: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "Trusts"
        },
        DescribeUpdateDirectory: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "UpdateActivities"
        },
        ListCertificates: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "CertificatesInfo"
        },
        ListIpRoutes: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "IpRoutesInfo"
        },
        ListLogSubscriptions: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "LogSubscriptions"
        },
        ListSchemaExtensions: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "SchemaExtensionsInfo"
        },
        ListTagsForResource: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "Tags"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/directoryservice.js
var require_directoryservice = __commonJS({
  "node_modules/aws-sdk/clients/directoryservice.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["directoryservice"] = {};
    AWS2.DirectoryService = Service.defineService("directoryservice", ["2015-04-16"]);
    Object.defineProperty(apiLoader.services["directoryservice"], "2015-04-16", {
      get: function get() {
        var model = require_ds_2015_04_16_min();
        model.paginators = require_ds_2015_04_16_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.DirectoryService;
  }
});

// node_modules/aws-sdk/apis/discovery-2015-11-01.min.json
var require_discovery_2015_11_01_min = __commonJS({
  "node_modules/aws-sdk/apis/discovery-2015-11-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-11-01",
        endpointPrefix: "discovery",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Application Discovery Service",
        serviceId: "Application Discovery Service",
        signatureVersion: "v4",
        targetPrefix: "AWSPoseidonService_V2015_11_01",
        uid: "discovery-2015-11-01"
      },
      operations: {
        AssociateConfigurationItemsToApplication: {
          input: {
            type: "structure",
            required: [
              "applicationConfigurationId",
              "configurationIds"
            ],
            members: {
              applicationConfigurationId: {},
              configurationIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        BatchDeleteAgents: {
          input: {
            type: "structure",
            required: [
              "deleteAgents"
            ],
            members: {
              deleteAgents: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "agentId"
                  ],
                  members: {
                    agentId: {},
                    force: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "agentId",
                    "errorMessage",
                    "errorCode"
                  ],
                  members: {
                    agentId: {},
                    errorMessage: {},
                    errorCode: {}
                  }
                }
              }
            }
          }
        },
        BatchDeleteImportData: {
          input: {
            type: "structure",
            required: [
              "importTaskIds"
            ],
            members: {
              importTaskIds: {
                type: "list",
                member: {}
              },
              deleteHistory: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    importTaskId: {},
                    errorCode: {},
                    errorDescription: {}
                  }
                }
              }
            }
          }
        },
        CreateApplication: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              configurationId: {}
            }
          }
        },
        CreateTags: {
          input: {
            type: "structure",
            required: [
              "configurationIds",
              "tags"
            ],
            members: {
              configurationIds: {
                shape: "S3"
              },
              tags: {
                shape: "St"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteApplications: {
          input: {
            type: "structure",
            required: [
              "configurationIds"
            ],
            members: {
              configurationIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteTags: {
          input: {
            type: "structure",
            required: [
              "configurationIds"
            ],
            members: {
              configurationIds: {
                shape: "S3"
              },
              tags: {
                shape: "St"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeAgents: {
          input: {
            type: "structure",
            members: {
              agentIds: {
                shape: "S14"
              },
              filters: {
                shape: "S15"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              agentsInfo: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    agentId: {},
                    hostName: {},
                    agentNetworkInfoList: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ipAddress: {},
                          macAddress: {}
                        },
                        sensitive: true
                      }
                    },
                    connectorId: {},
                    version: {},
                    health: {},
                    lastHealthPingTime: {},
                    collectionStatus: {},
                    agentType: {},
                    registeredTime: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeBatchDeleteConfigurationTask: {
          input: {
            type: "structure",
            required: [
              "taskId"
            ],
            members: {
              taskId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              task: {
                type: "structure",
                members: {
                  taskId: {},
                  status: {},
                  startTime: {
                    type: "timestamp"
                  },
                  endTime: {
                    type: "timestamp"
                  },
                  configurationType: {},
                  requestedConfigurations: {
                    shape: "S3"
                  },
                  deletedConfigurations: {
                    shape: "S3"
                  },
                  failedConfigurations: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        configurationId: {},
                        errorStatusCode: {
                          type: "integer"
                        },
                        errorMessage: {}
                      }
                    }
                  },
                  deletionWarnings: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        configurationId: {},
                        warningCode: {
                          type: "integer"
                        },
                        warningText: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeConfigurations: {
          input: {
            type: "structure",
            required: [
              "configurationIds"
            ],
            members: {
              configurationIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              configurations: {
                type: "list",
                member: {
                  type: "map",
                  key: {},
                  value: {}
                }
              }
            }
          }
        },
        DescribeContinuousExports: {
          input: {
            type: "structure",
            members: {
              exportIds: {
                type: "list",
                member: {}
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              descriptions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    exportId: {},
                    status: {},
                    statusDetail: {},
                    s3Bucket: {},
                    startTime: {
                      type: "timestamp"
                    },
                    stopTime: {
                      type: "timestamp"
                    },
                    dataSource: {},
                    schemaStorageConfig: {
                      shape: "S2c"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeExportConfigurations: {
          input: {
            type: "structure",
            members: {
              exportIds: {
                shape: "S2f"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              exportsInfo: {
                shape: "S2h"
              },
              nextToken: {}
            }
          },
          deprecated: true
        },
        DescribeExportTasks: {
          input: {
            type: "structure",
            members: {
              exportIds: {
                shape: "S2f"
              },
              filters: {
                shape: "S2o"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              exportsInfo: {
                shape: "S2h"
              },
              nextToken: {}
            }
          }
        },
        DescribeImportTasks: {
          input: {
            type: "structure",
            members: {
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              tasks: {
                type: "list",
                member: {
                  shape: "S31"
                }
              }
            }
          }
        },
        DescribeTags: {
          input: {
            type: "structure",
            members: {
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "values"
                  ],
                  members: {
                    name: {},
                    values: {
                      shape: "S17"
                    }
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    configurationType: {},
                    configurationId: {},
                    key: {},
                    value: {},
                    timeOfCreation: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DisassociateConfigurationItemsFromApplication: {
          input: {
            type: "structure",
            required: [
              "applicationConfigurationId",
              "configurationIds"
            ],
            members: {
              applicationConfigurationId: {},
              configurationIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ExportConfigurations: {
          output: {
            type: "structure",
            members: {
              exportId: {}
            }
          },
          deprecated: true
        },
        GetDiscoverySummary: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              servers: {
                type: "long"
              },
              applications: {
                type: "long"
              },
              serversMappedToApplications: {
                type: "long"
              },
              serversMappedtoTags: {
                type: "long"
              },
              agentSummary: {
                type: "structure",
                required: [
                  "activeAgents",
                  "healthyAgents",
                  "blackListedAgents",
                  "shutdownAgents",
                  "unhealthyAgents",
                  "totalAgents",
                  "unknownAgents"
                ],
                members: {
                  activeAgents: {
                    type: "integer"
                  },
                  healthyAgents: {
                    type: "integer"
                  },
                  blackListedAgents: {
                    type: "integer"
                  },
                  shutdownAgents: {
                    type: "integer"
                  },
                  unhealthyAgents: {
                    type: "integer"
                  },
                  totalAgents: {
                    type: "integer"
                  },
                  unknownAgents: {
                    type: "integer"
                  }
                }
              },
              connectorSummary: {
                type: "structure",
                required: [
                  "activeConnectors",
                  "healthyConnectors",
                  "blackListedConnectors",
                  "shutdownConnectors",
                  "unhealthyConnectors",
                  "totalConnectors",
                  "unknownConnectors"
                ],
                members: {
                  activeConnectors: {
                    type: "integer"
                  },
                  healthyConnectors: {
                    type: "integer"
                  },
                  blackListedConnectors: {
                    type: "integer"
                  },
                  shutdownConnectors: {
                    type: "integer"
                  },
                  unhealthyConnectors: {
                    type: "integer"
                  },
                  totalConnectors: {
                    type: "integer"
                  },
                  unknownConnectors: {
                    type: "integer"
                  }
                }
              },
              meCollectorSummary: {
                type: "structure",
                required: [
                  "activeMeCollectors",
                  "healthyMeCollectors",
                  "denyListedMeCollectors",
                  "shutdownMeCollectors",
                  "unhealthyMeCollectors",
                  "totalMeCollectors",
                  "unknownMeCollectors"
                ],
                members: {
                  activeMeCollectors: {
                    type: "integer"
                  },
                  healthyMeCollectors: {
                    type: "integer"
                  },
                  denyListedMeCollectors: {
                    type: "integer"
                  },
                  shutdownMeCollectors: {
                    type: "integer"
                  },
                  unhealthyMeCollectors: {
                    type: "integer"
                  },
                  totalMeCollectors: {
                    type: "integer"
                  },
                  unknownMeCollectors: {
                    type: "integer"
                  }
                }
              },
              agentlessCollectorSummary: {
                type: "structure",
                required: [
                  "activeAgentlessCollectors",
                  "healthyAgentlessCollectors",
                  "denyListedAgentlessCollectors",
                  "shutdownAgentlessCollectors",
                  "unhealthyAgentlessCollectors",
                  "totalAgentlessCollectors",
                  "unknownAgentlessCollectors"
                ],
                members: {
                  activeAgentlessCollectors: {
                    type: "integer"
                  },
                  healthyAgentlessCollectors: {
                    type: "integer"
                  },
                  denyListedAgentlessCollectors: {
                    type: "integer"
                  },
                  shutdownAgentlessCollectors: {
                    type: "integer"
                  },
                  unhealthyAgentlessCollectors: {
                    type: "integer"
                  },
                  totalAgentlessCollectors: {
                    type: "integer"
                  },
                  unknownAgentlessCollectors: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        ListConfigurations: {
          input: {
            type: "structure",
            required: [
              "configurationType"
            ],
            members: {
              configurationType: {},
              filters: {
                shape: "S15"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              orderBy: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "fieldName"
                  ],
                  members: {
                    fieldName: {},
                    sortOrder: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              configurations: {
                type: "list",
                member: {
                  type: "map",
                  key: {},
                  value: {}
                }
              },
              nextToken: {}
            }
          }
        },
        ListServerNeighbors: {
          input: {
            type: "structure",
            required: [
              "configurationId"
            ],
            members: {
              configurationId: {},
              portInformationNeeded: {
                type: "boolean"
              },
              neighborConfigurationIds: {
                shape: "S3"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "neighbors"
            ],
            members: {
              neighbors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "sourceServerId",
                    "destinationServerId",
                    "connectionsCount"
                  ],
                  members: {
                    sourceServerId: {},
                    destinationServerId: {},
                    destinationPort: {
                      type: "integer"
                    },
                    transportProtocol: {},
                    connectionsCount: {
                      type: "long"
                    }
                  }
                }
              },
              nextToken: {},
              knownDependencyCount: {
                type: "long"
              }
            }
          }
        },
        StartBatchDeleteConfigurationTask: {
          input: {
            type: "structure",
            required: [
              "configurationType",
              "configurationIds"
            ],
            members: {
              configurationType: {},
              configurationIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskId: {}
            }
          }
        },
        StartContinuousExport: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              exportId: {},
              s3Bucket: {},
              startTime: {
                type: "timestamp"
              },
              dataSource: {},
              schemaStorageConfig: {
                shape: "S2c"
              }
            }
          }
        },
        StartDataCollectionByAgentIds: {
          input: {
            type: "structure",
            required: [
              "agentIds"
            ],
            members: {
              agentIds: {
                shape: "S14"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              agentsConfigurationStatus: {
                shape: "S47"
              }
            }
          }
        },
        StartExportTask: {
          input: {
            type: "structure",
            members: {
              exportDataFormat: {
                type: "list",
                member: {}
              },
              filters: {
                shape: "S2o"
              },
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              preferences: {
                type: "structure",
                members: {
                  ec2RecommendationsPreferences: {
                    type: "structure",
                    members: {
                      enabled: {
                        type: "boolean"
                      },
                      cpuPerformanceMetricBasis: {
                        shape: "S4f"
                      },
                      ramPerformanceMetricBasis: {
                        shape: "S4f"
                      },
                      tenancy: {},
                      excludedInstanceTypes: {
                        type: "list",
                        member: {}
                      },
                      preferredRegion: {},
                      reservedInstanceOptions: {
                        type: "structure",
                        required: [
                          "purchasingOption",
                          "offeringClass",
                          "termLength"
                        ],
                        members: {
                          purchasingOption: {},
                          offeringClass: {},
                          termLength: {}
                        }
                      }
                    }
                  }
                },
                union: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              exportId: {}
            }
          }
        },
        StartImportTask: {
          input: {
            type: "structure",
            required: [
              "name",
              "importUrl"
            ],
            members: {
              clientRequestToken: {
                idempotencyToken: true
              },
              name: {},
              importUrl: {}
            }
          },
          output: {
            type: "structure",
            members: {
              task: {
                shape: "S31"
              }
            }
          }
        },
        StopContinuousExport: {
          input: {
            type: "structure",
            required: [
              "exportId"
            ],
            members: {
              exportId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              startTime: {
                type: "timestamp"
              },
              stopTime: {
                type: "timestamp"
              }
            }
          }
        },
        StopDataCollectionByAgentIds: {
          input: {
            type: "structure",
            required: [
              "agentIds"
            ],
            members: {
              agentIds: {
                shape: "S14"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              agentsConfigurationStatus: {
                shape: "S47"
              }
            }
          }
        },
        UpdateApplication: {
          input: {
            type: "structure",
            required: [
              "configurationId"
            ],
            members: {
              configurationId: {},
              name: {},
              description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {}
        },
        St: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        S14: {
          type: "list",
          member: {}
        },
        S15: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "values",
              "condition"
            ],
            members: {
              name: {},
              values: {
                shape: "S17"
              },
              condition: {}
            }
          }
        },
        S17: {
          type: "list",
          member: {}
        },
        S2c: {
          type: "map",
          key: {},
          value: {}
        },
        S2f: {
          type: "list",
          member: {}
        },
        S2h: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "exportId",
              "exportStatus",
              "statusMessage",
              "exportRequestTime"
            ],
            members: {
              exportId: {},
              exportStatus: {},
              statusMessage: {},
              configurationsDownloadUrl: {},
              exportRequestTime: {
                type: "timestamp"
              },
              isTruncated: {
                type: "boolean"
              },
              requestedStartTime: {
                type: "timestamp"
              },
              requestedEndTime: {
                type: "timestamp"
              }
            }
          }
        },
        S2o: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "values",
              "condition"
            ],
            members: {
              name: {},
              values: {
                shape: "S17"
              },
              condition: {}
            }
          }
        },
        S31: {
          type: "structure",
          members: {
            importTaskId: {},
            clientRequestToken: {},
            name: {},
            importUrl: {},
            status: {},
            importRequestTime: {
              type: "timestamp"
            },
            importCompletionTime: {
              type: "timestamp"
            },
            importDeletedTime: {
              type: "timestamp"
            },
            serverImportSuccess: {
              type: "integer"
            },
            serverImportFailure: {
              type: "integer"
            },
            applicationImportSuccess: {
              type: "integer"
            },
            applicationImportFailure: {
              type: "integer"
            },
            errorsAndFailedEntriesZip: {}
          }
        },
        S47: {
          type: "list",
          member: {
            type: "structure",
            members: {
              agentId: {},
              operationSucceeded: {
                type: "boolean"
              },
              description: {}
            }
          }
        },
        S4f: {
          type: "structure",
          members: {
            name: {},
            percentageAdjust: {
              type: "double"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/discovery-2015-11-01.paginators.json
var require_discovery_2015_11_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/discovery-2015-11-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeAgents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "agentsInfo"
        },
        DescribeContinuousExports: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "descriptions"
        },
        DescribeExportConfigurations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "exportsInfo"
        },
        DescribeExportTasks: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "exportsInfo"
        },
        DescribeImportTasks: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "tasks"
        },
        DescribeTags: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "tags"
        },
        ListConfigurations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "configurations"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/discovery.js
var require_discovery = __commonJS({
  "node_modules/aws-sdk/clients/discovery.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["discovery"] = {};
    AWS2.Discovery = Service.defineService("discovery", ["2015-11-01"]);
    Object.defineProperty(apiLoader.services["discovery"], "2015-11-01", {
      get: function get() {
        var model = require_discovery_2015_11_01_min();
        model.paginators = require_discovery_2015_11_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Discovery;
  }
});

// node_modules/aws-sdk/apis/dms-2016-01-01.min.json
var require_dms_2016_01_01_min = __commonJS({
  "node_modules/aws-sdk/apis/dms-2016-01-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-01-01",
        endpointPrefix: "dms",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Database Migration Service",
        serviceId: "Database Migration Service",
        signatureVersion: "v4",
        targetPrefix: "AmazonDMSv20160101",
        uid: "dms-2016-01-01"
      },
      operations: {
        AddTagsToResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ApplyPendingMaintenanceAction: {
          input: {
            type: "structure",
            required: [
              "ReplicationInstanceArn",
              "ApplyAction",
              "OptInType"
            ],
            members: {
              ReplicationInstanceArn: {},
              ApplyAction: {},
              OptInType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourcePendingMaintenanceActions: {
                shape: "S8"
              }
            }
          }
        },
        BatchStartRecommendations: {
          input: {
            type: "structure",
            members: {
              Data: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "DatabaseId",
                    "Settings"
                  ],
                  members: {
                    DatabaseId: {},
                    Settings: {
                      shape: "Sf"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ErrorEntries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DatabaseId: {},
                    Message: {},
                    Code: {}
                  }
                }
              }
            }
          }
        },
        CancelReplicationTaskAssessmentRun: {
          input: {
            type: "structure",
            required: [
              "ReplicationTaskAssessmentRunArn"
            ],
            members: {
              ReplicationTaskAssessmentRunArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationTaskAssessmentRun: {
                shape: "Sl"
              }
            }
          }
        },
        CreateDataProvider: {
          input: {
            type: "structure",
            required: [
              "Engine",
              "Settings"
            ],
            members: {
              DataProviderName: {},
              Description: {},
              Engine: {},
              Settings: {
                shape: "Sp"
              },
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataProvider: {
                shape: "S13"
              }
            }
          }
        },
        CreateEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointIdentifier",
              "EndpointType",
              "EngineName"
            ],
            members: {
              EndpointIdentifier: {},
              EndpointType: {},
              EngineName: {},
              Username: {},
              Password: {
                shape: "S17"
              },
              ServerName: {},
              Port: {
                type: "integer"
              },
              DatabaseName: {},
              ExtraConnectionAttributes: {},
              KmsKeyId: {},
              Tags: {
                shape: "S3"
              },
              CertificateArn: {},
              SslMode: {},
              ServiceAccessRoleArn: {},
              ExternalTableDefinition: {},
              DynamoDbSettings: {
                shape: "S18"
              },
              S3Settings: {
                shape: "S19"
              },
              DmsTransferSettings: {
                shape: "S1j"
              },
              MongoDbSettings: {
                shape: "S1k"
              },
              KinesisSettings: {
                shape: "S1m"
              },
              KafkaSettings: {
                shape: "S1o"
              },
              ElasticsearchSettings: {
                shape: "S1s"
              },
              NeptuneSettings: {
                shape: "S1t"
              },
              RedshiftSettings: {
                shape: "S1u"
              },
              PostgreSQLSettings: {
                shape: "S1v"
              },
              MySQLSettings: {
                shape: "S1z"
              },
              OracleSettings: {
                shape: "S21"
              },
              SybaseSettings: {
                shape: "S24"
              },
              MicrosoftSQLServerSettings: {
                shape: "S25"
              },
              IBMDb2Settings: {
                shape: "S28"
              },
              ResourceIdentifier: {},
              DocDbSettings: {
                shape: "S29"
              },
              RedisSettings: {
                shape: "S2a"
              },
              GcpMySQLSettings: {
                shape: "S2d"
              },
              TimestreamSettings: {
                shape: "S2e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Endpoint: {
                shape: "S2g"
              }
            }
          }
        },
        CreateEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SnsTopicArn"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S2i"
              },
              SourceIds: {
                shape: "S2j"
              },
              Enabled: {
                type: "boolean"
              },
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S2l"
              }
            }
          }
        },
        CreateFleetAdvisorCollector: {
          input: {
            type: "structure",
            required: [
              "CollectorName",
              "ServiceAccessRoleArn",
              "S3BucketName"
            ],
            members: {
              CollectorName: {},
              Description: {},
              ServiceAccessRoleArn: {},
              S3BucketName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CollectorReferencedId: {},
              CollectorName: {},
              Description: {},
              ServiceAccessRoleArn: {},
              S3BucketName: {}
            }
          }
        },
        CreateInstanceProfile: {
          input: {
            type: "structure",
            members: {
              AvailabilityZone: {},
              KmsKeyArn: {},
              PubliclyAccessible: {
                type: "boolean"
              },
              Tags: {
                shape: "S3"
              },
              NetworkType: {},
              InstanceProfileName: {},
              Description: {},
              SubnetGroupIdentifier: {},
              VpcSecurityGroups: {
                shape: "S2q"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceProfile: {
                shape: "S2s"
              }
            }
          }
        },
        CreateMigrationProject: {
          input: {
            type: "structure",
            required: [
              "SourceDataProviderDescriptors",
              "TargetDataProviderDescriptors",
              "InstanceProfileIdentifier"
            ],
            members: {
              MigrationProjectName: {},
              SourceDataProviderDescriptors: {
                shape: "S2u"
              },
              TargetDataProviderDescriptors: {
                shape: "S2u"
              },
              InstanceProfileIdentifier: {},
              TransformationRules: {},
              Description: {},
              Tags: {
                shape: "S3"
              },
              SchemaConversionApplicationAttributes: {
                shape: "S2w"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MigrationProject: {
                shape: "S2y"
              }
            }
          }
        },
        CreateReplicationConfig: {
          input: {
            type: "structure",
            required: [
              "ReplicationConfigIdentifier",
              "SourceEndpointArn",
              "TargetEndpointArn",
              "ComputeConfig",
              "ReplicationType",
              "TableMappings"
            ],
            members: {
              ReplicationConfigIdentifier: {},
              SourceEndpointArn: {},
              TargetEndpointArn: {},
              ComputeConfig: {
                shape: "S32"
              },
              ReplicationType: {},
              TableMappings: {},
              ReplicationSettings: {},
              SupplementalSettings: {},
              ResourceIdentifier: {},
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationConfig: {
                shape: "S35"
              }
            }
          }
        },
        CreateReplicationInstance: {
          input: {
            type: "structure",
            required: [
              "ReplicationInstanceIdentifier",
              "ReplicationInstanceClass"
            ],
            members: {
              ReplicationInstanceIdentifier: {},
              AllocatedStorage: {
                type: "integer"
              },
              ReplicationInstanceClass: {},
              VpcSecurityGroupIds: {
                shape: "S37"
              },
              AvailabilityZone: {},
              ReplicationSubnetGroupIdentifier: {},
              PreferredMaintenanceWindow: {},
              MultiAZ: {
                type: "boolean"
              },
              EngineVersion: {},
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              Tags: {
                shape: "S3"
              },
              KmsKeyId: {},
              PubliclyAccessible: {
                type: "boolean"
              },
              DnsNameServers: {},
              ResourceIdentifier: {},
              NetworkType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationInstance: {
                shape: "S39"
              }
            }
          }
        },
        CreateReplicationSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "ReplicationSubnetGroupIdentifier",
              "ReplicationSubnetGroupDescription",
              "SubnetIds"
            ],
            members: {
              ReplicationSubnetGroupIdentifier: {},
              ReplicationSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S3l"
              },
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationSubnetGroup: {
                shape: "S3c"
              }
            }
          }
        },
        CreateReplicationTask: {
          input: {
            type: "structure",
            required: [
              "ReplicationTaskIdentifier",
              "SourceEndpointArn",
              "TargetEndpointArn",
              "ReplicationInstanceArn",
              "MigrationType",
              "TableMappings"
            ],
            members: {
              ReplicationTaskIdentifier: {},
              SourceEndpointArn: {},
              TargetEndpointArn: {},
              ReplicationInstanceArn: {},
              MigrationType: {},
              TableMappings: {},
              ReplicationTaskSettings: {},
              CdcStartTime: {
                type: "timestamp"
              },
              CdcStartPosition: {},
              CdcStopPosition: {},
              Tags: {
                shape: "S3"
              },
              TaskData: {},
              ResourceIdentifier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationTask: {
                shape: "S3p"
              }
            }
          }
        },
        DeleteCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateArn"
            ],
            members: {
              CertificateArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Certificate: {
                shape: "S3u"
              }
            }
          }
        },
        DeleteConnection: {
          input: {
            type: "structure",
            required: [
              "EndpointArn",
              "ReplicationInstanceArn"
            ],
            members: {
              EndpointArn: {},
              ReplicationInstanceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Connection: {
                shape: "S3y"
              }
            }
          }
        },
        DeleteDataProvider: {
          input: {
            type: "structure",
            required: [
              "DataProviderIdentifier"
            ],
            members: {
              DataProviderIdentifier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DataProvider: {
                shape: "S13"
              }
            }
          }
        },
        DeleteEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointArn"
            ],
            members: {
              EndpointArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Endpoint: {
                shape: "S2g"
              }
            }
          }
        },
        DeleteEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S2l"
              }
            }
          }
        },
        DeleteFleetAdvisorCollector: {
          input: {
            type: "structure",
            required: [
              "CollectorReferencedId"
            ],
            members: {
              CollectorReferencedId: {}
            }
          }
        },
        DeleteFleetAdvisorDatabases: {
          input: {
            type: "structure",
            required: [
              "DatabaseIds"
            ],
            members: {
              DatabaseIds: {
                shape: "S2q"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DatabaseIds: {
                shape: "S2q"
              }
            }
          }
        },
        DeleteInstanceProfile: {
          input: {
            type: "structure",
            required: [
              "InstanceProfileIdentifier"
            ],
            members: {
              InstanceProfileIdentifier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceProfile: {
                shape: "S2s"
              }
            }
          }
        },
        DeleteMigrationProject: {
          input: {
            type: "structure",
            required: [
              "MigrationProjectIdentifier"
            ],
            members: {
              MigrationProjectIdentifier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MigrationProject: {
                shape: "S2y"
              }
            }
          }
        },
        DeleteReplicationConfig: {
          input: {
            type: "structure",
            required: [
              "ReplicationConfigArn"
            ],
            members: {
              ReplicationConfigArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationConfig: {
                shape: "S35"
              }
            }
          }
        },
        DeleteReplicationInstance: {
          input: {
            type: "structure",
            required: [
              "ReplicationInstanceArn"
            ],
            members: {
              ReplicationInstanceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationInstance: {
                shape: "S39"
              }
            }
          }
        },
        DeleteReplicationSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "ReplicationSubnetGroupIdentifier"
            ],
            members: {
              ReplicationSubnetGroupIdentifier: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteReplicationTask: {
          input: {
            type: "structure",
            required: [
              "ReplicationTaskArn"
            ],
            members: {
              ReplicationTaskArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationTask: {
                shape: "S3p"
              }
            }
          }
        },
        DeleteReplicationTaskAssessmentRun: {
          input: {
            type: "structure",
            required: [
              "ReplicationTaskAssessmentRunArn"
            ],
            members: {
              ReplicationTaskAssessmentRunArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationTaskAssessmentRun: {
                shape: "Sl"
              }
            }
          }
        },
        DescribeAccountAttributes: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              AccountQuotas: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AccountQuotaName: {},
                    Used: {
                      type: "long"
                    },
                    Max: {
                      type: "long"
                    }
                  }
                }
              },
              UniqueAccountIdentifier: {}
            }
          }
        },
        DescribeApplicableIndividualAssessments: {
          input: {
            type: "structure",
            members: {
              ReplicationTaskArn: {},
              ReplicationInstanceArn: {},
              SourceEngineName: {},
              TargetEngineName: {},
              MigrationType: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IndividualAssessmentNames: {
                type: "list",
                member: {}
              },
              Marker: {}
            }
          }
        },
        DescribeCertificates: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S4u"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              Certificates: {
                type: "list",
                member: {
                  shape: "S3u"
                }
              }
            }
          }
        },
        DescribeConnections: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S4u"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              Connections: {
                type: "list",
                member: {
                  shape: "S3y"
                }
              }
            }
          }
        },
        DescribeConversionConfiguration: {
          input: {
            type: "structure",
            required: [
              "MigrationProjectIdentifier"
            ],
            members: {
              MigrationProjectIdentifier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MigrationProjectIdentifier: {},
              ConversionConfiguration: {}
            }
          }
        },
        DescribeDataProviders: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S4u"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              DataProviders: {
                type: "list",
                member: {
                  shape: "S13"
                }
              }
            }
          }
        },
        DescribeEndpointSettings: {
          input: {
            type: "structure",
            required: [
              "EngineName"
            ],
            members: {
              EngineName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              EndpointSettings: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Type: {},
                    EnumValues: {
                      type: "list",
                      member: {}
                    },
                    Sensitive: {
                      type: "boolean"
                    },
                    Units: {},
                    Applicability: {},
                    IntValueMin: {
                      type: "integer"
                    },
                    IntValueMax: {
                      type: "integer"
                    },
                    DefaultValue: {}
                  }
                }
              }
            }
          }
        },
        DescribeEndpointTypes: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S4u"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              SupportedEndpointTypes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EngineName: {},
                    SupportsCDC: {
                      type: "boolean"
                    },
                    EndpointType: {},
                    ReplicationInstanceEngineMinimumVersion: {},
                    EngineDisplayName: {}
                  }
                }
              }
            }
          }
        },
        DescribeEndpoints: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S4u"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              Endpoints: {
                type: "list",
                member: {
                  shape: "S2g"
                }
              }
            }
          }
        },
        DescribeEngineVersions: {
          input: {
            type: "structure",
            members: {
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EngineVersions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Version: {},
                    Lifecycle: {},
                    ReleaseStatus: {},
                    LaunchDate: {
                      type: "timestamp"
                    },
                    AutoUpgradeDate: {
                      type: "timestamp"
                    },
                    DeprecationDate: {
                      type: "timestamp"
                    },
                    ForceUpgradeDate: {
                      type: "timestamp"
                    },
                    AvailableUpgrades: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeEventCategories: {
          input: {
            type: "structure",
            members: {
              SourceType: {},
              Filters: {
                shape: "S4u"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventCategoryGroupList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SourceType: {},
                    EventCategories: {
                      shape: "S2i"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeEventSubscriptions: {
          input: {
            type: "structure",
            members: {
              SubscriptionName: {},
              Filters: {
                shape: "S4u"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              EventSubscriptionsList: {
                type: "list",
                member: {
                  shape: "S2l"
                }
              }
            }
          }
        },
        DescribeEvents: {
          input: {
            type: "structure",
            members: {
              SourceIdentifier: {},
              SourceType: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Duration: {
                type: "integer"
              },
              EventCategories: {
                shape: "S2i"
              },
              Filters: {
                shape: "S4u"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              Events: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SourceIdentifier: {},
                    SourceType: {},
                    Message: {},
                    EventCategories: {
                      shape: "S2i"
                    },
                    Date: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeExtensionPackAssociations: {
          input: {
            type: "structure",
            required: [
              "MigrationProjectIdentifier"
            ],
            members: {
              MigrationProjectIdentifier: {},
              Filters: {
                shape: "S4u"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              Requests: {
                shape: "S64"
              }
            }
          }
        },
        DescribeFleetAdvisorCollectors: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S4u"
              },
              MaxRecords: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Collectors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CollectorReferencedId: {},
                    CollectorName: {},
                    CollectorVersion: {},
                    VersionStatus: {},
                    Description: {},
                    S3BucketName: {},
                    ServiceAccessRoleArn: {},
                    CollectorHealthCheck: {
                      type: "structure",
                      members: {
                        CollectorStatus: {},
                        LocalCollectorS3Access: {
                          type: "boolean"
                        },
                        WebCollectorS3Access: {
                          type: "boolean"
                        },
                        WebCollectorGrantedRoleBasedAccess: {
                          type: "boolean"
                        }
                      }
                    },
                    LastDataReceived: {},
                    RegisteredDate: {},
                    CreatedDate: {},
                    ModifiedDate: {},
                    InventoryData: {
                      type: "structure",
                      members: {
                        NumberOfDatabases: {
                          type: "integer"
                        },
                        NumberOfSchemas: {
                          type: "integer"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeFleetAdvisorDatabases: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S4u"
              },
              MaxRecords: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Databases: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DatabaseId: {},
                    DatabaseName: {},
                    IpAddress: {},
                    NumberOfSchemas: {
                      type: "long"
                    },
                    Server: {
                      shape: "S6m"
                    },
                    SoftwareDetails: {
                      type: "structure",
                      members: {
                        Engine: {},
                        EngineVersion: {},
                        EngineEdition: {},
                        ServicePack: {},
                        SupportLevel: {},
                        OsArchitecture: {
                          type: "integer"
                        },
                        Tooltip: {}
                      }
                    },
                    Collectors: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          CollectorReferencedId: {},
                          CollectorName: {}
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeFleetAdvisorLsaAnalysis: {
          input: {
            type: "structure",
            members: {
              MaxRecords: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Analysis: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LsaAnalysisId: {},
                    Status: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeFleetAdvisorSchemaObjectSummary: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S4u"
              },
              MaxRecords: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FleetAdvisorSchemaObjects: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SchemaId: {},
                    ObjectType: {},
                    NumberOfObjects: {
                      type: "long"
                    },
                    CodeLineCount: {
                      type: "long"
                    },
                    CodeSize: {
                      type: "long"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeFleetAdvisorSchemas: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S4u"
              },
              MaxRecords: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FleetAdvisorSchemas: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CodeLineCount: {
                      type: "long"
                    },
                    CodeSize: {
                      type: "long"
                    },
                    Complexity: {},
                    Server: {
                      shape: "S6m"
                    },
                    DatabaseInstance: {
                      type: "structure",
                      members: {
                        DatabaseId: {},
                        DatabaseName: {},
                        DatabaseIpAddress: {},
                        DatabaseEngine: {}
                      }
                    },
                    SchemaId: {},
                    SchemaName: {},
                    OriginalSchema: {
                      type: "structure",
                      members: {
                        SchemaId: {},
                        SchemaName: {},
                        DatabaseId: {},
                        DatabaseName: {},
                        DatabaseIpAddress: {}
                      }
                    },
                    Similarity: {
                      type: "double"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeInstanceProfiles: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S4u"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              InstanceProfiles: {
                type: "list",
                member: {
                  shape: "S2s"
                }
              }
            }
          }
        },
        DescribeMetadataModelAssessments: {
          input: {
            type: "structure",
            required: [
              "MigrationProjectIdentifier"
            ],
            members: {
              MigrationProjectIdentifier: {},
              Filters: {
                shape: "S4u"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              Requests: {
                shape: "S64"
              }
            }
          }
        },
        DescribeMetadataModelConversions: {
          input: {
            type: "structure",
            required: [
              "MigrationProjectIdentifier"
            ],
            members: {
              MigrationProjectIdentifier: {},
              Filters: {
                shape: "S4u"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              Requests: {
                shape: "S64"
              }
            }
          }
        },
        DescribeMetadataModelExportsAsScript: {
          input: {
            type: "structure",
            required: [
              "MigrationProjectIdentifier"
            ],
            members: {
              MigrationProjectIdentifier: {},
              Filters: {
                shape: "S4u"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              Requests: {
                shape: "S64"
              }
            }
          }
        },
        DescribeMetadataModelExportsToTarget: {
          input: {
            type: "structure",
            required: [
              "MigrationProjectIdentifier"
            ],
            members: {
              MigrationProjectIdentifier: {},
              Filters: {
                shape: "S4u"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              Requests: {
                shape: "S64"
              }
            }
          }
        },
        DescribeMetadataModelImports: {
          input: {
            type: "structure",
            required: [
              "MigrationProjectIdentifier"
            ],
            members: {
              MigrationProjectIdentifier: {},
              Filters: {
                shape: "S4u"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              Requests: {
                shape: "S64"
              }
            }
          }
        },
        DescribeMigrationProjects: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S4u"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              MigrationProjects: {
                type: "list",
                member: {
                  shape: "S2y"
                }
              }
            }
          }
        },
        DescribeOrderableReplicationInstances: {
          input: {
            type: "structure",
            members: {
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OrderableReplicationInstances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EngineVersion: {},
                    ReplicationInstanceClass: {},
                    StorageType: {},
                    MinAllocatedStorage: {
                      type: "integer"
                    },
                    MaxAllocatedStorage: {
                      type: "integer"
                    },
                    DefaultAllocatedStorage: {
                      type: "integer"
                    },
                    IncludedAllocatedStorage: {
                      type: "integer"
                    },
                    AvailabilityZones: {
                      type: "list",
                      member: {}
                    },
                    ReleaseStatus: {}
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribePendingMaintenanceActions: {
          input: {
            type: "structure",
            members: {
              ReplicationInstanceArn: {},
              Filters: {
                shape: "S4u"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PendingMaintenanceActions: {
                type: "list",
                member: {
                  shape: "S8"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeRecommendationLimitations: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S4u"
              },
              MaxRecords: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Limitations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DatabaseId: {},
                    EngineName: {},
                    Name: {},
                    Description: {},
                    Impact: {},
                    Type: {}
                  }
                }
              }
            }
          }
        },
        DescribeRecommendations: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S4u"
              },
              MaxRecords: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Recommendations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DatabaseId: {},
                    EngineName: {},
                    CreatedDate: {},
                    Status: {},
                    Preferred: {
                      type: "boolean"
                    },
                    Settings: {
                      shape: "Sf"
                    },
                    Data: {
                      type: "structure",
                      members: {
                        RdsEngine: {
                          type: "structure",
                          members: {
                            RequirementsToTarget: {
                              type: "structure",
                              members: {
                                EngineEdition: {},
                                InstanceVcpu: {
                                  type: "double"
                                },
                                InstanceMemory: {
                                  type: "double"
                                },
                                StorageSize: {
                                  type: "integer"
                                },
                                StorageIops: {
                                  type: "integer"
                                },
                                DeploymentOption: {},
                                EngineVersion: {}
                              }
                            },
                            TargetConfiguration: {
                              type: "structure",
                              members: {
                                EngineEdition: {},
                                InstanceType: {},
                                InstanceVcpu: {
                                  type: "double"
                                },
                                InstanceMemory: {
                                  type: "double"
                                },
                                StorageType: {},
                                StorageSize: {
                                  type: "integer"
                                },
                                StorageIops: {
                                  type: "integer"
                                },
                                DeploymentOption: {},
                                EngineVersion: {}
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeRefreshSchemasStatus: {
          input: {
            type: "structure",
            required: [
              "EndpointArn"
            ],
            members: {
              EndpointArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RefreshSchemasStatus: {
                shape: "S87"
              }
            }
          }
        },
        DescribeReplicationConfigs: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S4u"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              ReplicationConfigs: {
                type: "list",
                member: {
                  shape: "S35"
                }
              }
            }
          }
        },
        DescribeReplicationInstanceTaskLogs: {
          input: {
            type: "structure",
            required: [
              "ReplicationInstanceArn"
            ],
            members: {
              ReplicationInstanceArn: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationInstanceArn: {},
              ReplicationInstanceTaskLogs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ReplicationTaskName: {},
                    ReplicationTaskArn: {},
                    ReplicationInstanceTaskLogSize: {
                      type: "long"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeReplicationInstances: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S4u"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              ReplicationInstances: {
                type: "list",
                member: {
                  shape: "S39"
                }
              }
            }
          }
        },
        DescribeReplicationSubnetGroups: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S4u"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              ReplicationSubnetGroups: {
                type: "list",
                member: {
                  shape: "S3c"
                }
              }
            }
          }
        },
        DescribeReplicationTableStatistics: {
          input: {
            type: "structure",
            required: [
              "ReplicationConfigArn"
            ],
            members: {
              ReplicationConfigArn: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              Filters: {
                shape: "S4u"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationConfigArn: {},
              Marker: {},
              ReplicationTableStatistics: {
                type: "list",
                member: {
                  shape: "S8p"
                }
              }
            }
          }
        },
        DescribeReplicationTaskAssessmentResults: {
          input: {
            type: "structure",
            members: {
              ReplicationTaskArn: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              BucketName: {},
              ReplicationTaskAssessmentResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ReplicationTaskIdentifier: {},
                    ReplicationTaskArn: {},
                    ReplicationTaskLastAssessmentDate: {
                      type: "timestamp"
                    },
                    AssessmentStatus: {},
                    AssessmentResultsFile: {},
                    AssessmentResults: {},
                    S3ObjectUrl: {}
                  }
                }
              }
            }
          }
        },
        DescribeReplicationTaskAssessmentRuns: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S4u"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              ReplicationTaskAssessmentRuns: {
                type: "list",
                member: {
                  shape: "Sl"
                }
              }
            }
          }
        },
        DescribeReplicationTaskIndividualAssessments: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S4u"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              ReplicationTaskIndividualAssessments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ReplicationTaskIndividualAssessmentArn: {},
                    ReplicationTaskAssessmentRunArn: {},
                    IndividualAssessmentName: {},
                    Status: {},
                    ReplicationTaskIndividualAssessmentStartDate: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeReplicationTasks: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S4u"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              WithoutSettings: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              ReplicationTasks: {
                type: "list",
                member: {
                  shape: "S3p"
                }
              }
            }
          }
        },
        DescribeReplications: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S4u"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              Replications: {
                type: "list",
                member: {
                  shape: "S97"
                }
              }
            }
          }
        },
        DescribeSchemas: {
          input: {
            type: "structure",
            required: [
              "EndpointArn"
            ],
            members: {
              EndpointArn: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              Schemas: {
                type: "list",
                member: {}
              }
            }
          }
        },
        DescribeTableStatistics: {
          input: {
            type: "structure",
            required: [
              "ReplicationTaskArn"
            ],
            members: {
              ReplicationTaskArn: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              Filters: {
                shape: "S4u"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationTaskArn: {},
              TableStatistics: {
                type: "list",
                member: {
                  shape: "S8p"
                }
              },
              Marker: {}
            }
          }
        },
        ExportMetadataModelAssessment: {
          input: {
            type: "structure",
            required: [
              "MigrationProjectIdentifier",
              "SelectionRules"
            ],
            members: {
              MigrationProjectIdentifier: {},
              SelectionRules: {},
              FileName: {},
              AssessmentReportTypes: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PdfReport: {
                shape: "S9k"
              },
              CsvReport: {
                shape: "S9k"
              }
            }
          }
        },
        ImportCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateIdentifier"
            ],
            members: {
              CertificateIdentifier: {},
              CertificatePem: {
                shape: "S17"
              },
              CertificateWallet: {
                type: "blob"
              },
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Certificate: {
                shape: "S3u"
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            members: {
              ResourceArn: {},
              ResourceArnList: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TagList: {
                shape: "S3"
              }
            }
          }
        },
        ModifyConversionConfiguration: {
          input: {
            type: "structure",
            required: [
              "MigrationProjectIdentifier",
              "ConversionConfiguration"
            ],
            members: {
              MigrationProjectIdentifier: {},
              ConversionConfiguration: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MigrationProjectIdentifier: {}
            }
          }
        },
        ModifyDataProvider: {
          input: {
            type: "structure",
            required: [
              "DataProviderIdentifier"
            ],
            members: {
              DataProviderIdentifier: {},
              DataProviderName: {},
              Description: {},
              Engine: {},
              ExactSettings: {
                type: "boolean"
              },
              Settings: {
                shape: "Sp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataProvider: {
                shape: "S13"
              }
            }
          }
        },
        ModifyEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointArn"
            ],
            members: {
              EndpointArn: {},
              EndpointIdentifier: {},
              EndpointType: {},
              EngineName: {},
              Username: {},
              Password: {
                shape: "S17"
              },
              ServerName: {},
              Port: {
                type: "integer"
              },
              DatabaseName: {},
              ExtraConnectionAttributes: {},
              CertificateArn: {},
              SslMode: {},
              ServiceAccessRoleArn: {},
              ExternalTableDefinition: {},
              DynamoDbSettings: {
                shape: "S18"
              },
              S3Settings: {
                shape: "S19"
              },
              DmsTransferSettings: {
                shape: "S1j"
              },
              MongoDbSettings: {
                shape: "S1k"
              },
              KinesisSettings: {
                shape: "S1m"
              },
              KafkaSettings: {
                shape: "S1o"
              },
              ElasticsearchSettings: {
                shape: "S1s"
              },
              NeptuneSettings: {
                shape: "S1t"
              },
              RedshiftSettings: {
                shape: "S1u"
              },
              PostgreSQLSettings: {
                shape: "S1v"
              },
              MySQLSettings: {
                shape: "S1z"
              },
              OracleSettings: {
                shape: "S21"
              },
              SybaseSettings: {
                shape: "S24"
              },
              MicrosoftSQLServerSettings: {
                shape: "S25"
              },
              IBMDb2Settings: {
                shape: "S28"
              },
              DocDbSettings: {
                shape: "S29"
              },
              RedisSettings: {
                shape: "S2a"
              },
              ExactSettings: {
                type: "boolean"
              },
              GcpMySQLSettings: {
                shape: "S2d"
              },
              TimestreamSettings: {
                shape: "S2e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Endpoint: {
                shape: "S2g"
              }
            }
          }
        },
        ModifyEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S2i"
              },
              Enabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S2l"
              }
            }
          }
        },
        ModifyInstanceProfile: {
          input: {
            type: "structure",
            required: [
              "InstanceProfileIdentifier"
            ],
            members: {
              InstanceProfileIdentifier: {},
              AvailabilityZone: {},
              KmsKeyArn: {},
              PubliclyAccessible: {
                type: "boolean"
              },
              NetworkType: {},
              InstanceProfileName: {},
              Description: {},
              SubnetGroupIdentifier: {},
              VpcSecurityGroups: {
                shape: "S2q"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceProfile: {
                shape: "S2s"
              }
            }
          }
        },
        ModifyMigrationProject: {
          input: {
            type: "structure",
            required: [
              "MigrationProjectIdentifier"
            ],
            members: {
              MigrationProjectIdentifier: {},
              MigrationProjectName: {},
              SourceDataProviderDescriptors: {
                shape: "S2u"
              },
              TargetDataProviderDescriptors: {
                shape: "S2u"
              },
              InstanceProfileIdentifier: {},
              TransformationRules: {},
              Description: {},
              SchemaConversionApplicationAttributes: {
                shape: "S2w"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MigrationProject: {
                shape: "S2y"
              }
            }
          }
        },
        ModifyReplicationConfig: {
          input: {
            type: "structure",
            required: [
              "ReplicationConfigArn"
            ],
            members: {
              ReplicationConfigArn: {},
              ReplicationConfigIdentifier: {},
              ReplicationType: {},
              TableMappings: {},
              ReplicationSettings: {},
              SupplementalSettings: {},
              ComputeConfig: {
                shape: "S32"
              },
              SourceEndpointArn: {},
              TargetEndpointArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationConfig: {
                shape: "S35"
              }
            }
          }
        },
        ModifyReplicationInstance: {
          input: {
            type: "structure",
            required: [
              "ReplicationInstanceArn"
            ],
            members: {
              ReplicationInstanceArn: {},
              AllocatedStorage: {
                type: "integer"
              },
              ApplyImmediately: {
                type: "boolean"
              },
              ReplicationInstanceClass: {},
              VpcSecurityGroupIds: {
                shape: "S37"
              },
              PreferredMaintenanceWindow: {},
              MultiAZ: {
                type: "boolean"
              },
              EngineVersion: {},
              AllowMajorVersionUpgrade: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              ReplicationInstanceIdentifier: {},
              NetworkType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationInstance: {
                shape: "S39"
              }
            }
          }
        },
        ModifyReplicationSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "ReplicationSubnetGroupIdentifier",
              "SubnetIds"
            ],
            members: {
              ReplicationSubnetGroupIdentifier: {},
              ReplicationSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S3l"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationSubnetGroup: {
                shape: "S3c"
              }
            }
          }
        },
        ModifyReplicationTask: {
          input: {
            type: "structure",
            required: [
              "ReplicationTaskArn"
            ],
            members: {
              ReplicationTaskArn: {},
              ReplicationTaskIdentifier: {},
              MigrationType: {},
              TableMappings: {},
              ReplicationTaskSettings: {},
              CdcStartTime: {
                type: "timestamp"
              },
              CdcStartPosition: {},
              CdcStopPosition: {},
              TaskData: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationTask: {
                shape: "S3p"
              }
            }
          }
        },
        MoveReplicationTask: {
          input: {
            type: "structure",
            required: [
              "ReplicationTaskArn",
              "TargetReplicationInstanceArn"
            ],
            members: {
              ReplicationTaskArn: {},
              TargetReplicationInstanceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationTask: {
                shape: "S3p"
              }
            }
          }
        },
        RebootReplicationInstance: {
          input: {
            type: "structure",
            required: [
              "ReplicationInstanceArn"
            ],
            members: {
              ReplicationInstanceArn: {},
              ForceFailover: {
                type: "boolean"
              },
              ForcePlannedFailover: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationInstance: {
                shape: "S39"
              }
            }
          }
        },
        RefreshSchemas: {
          input: {
            type: "structure",
            required: [
              "EndpointArn",
              "ReplicationInstanceArn"
            ],
            members: {
              EndpointArn: {},
              ReplicationInstanceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RefreshSchemasStatus: {
                shape: "S87"
              }
            }
          }
        },
        ReloadReplicationTables: {
          input: {
            type: "structure",
            required: [
              "ReplicationConfigArn",
              "TablesToReload"
            ],
            members: {
              ReplicationConfigArn: {},
              TablesToReload: {
                shape: "Sah"
              },
              ReloadOption: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationConfigArn: {}
            }
          }
        },
        ReloadTables: {
          input: {
            type: "structure",
            required: [
              "ReplicationTaskArn",
              "TablesToReload"
            ],
            members: {
              ReplicationTaskArn: {},
              TablesToReload: {
                shape: "Sah"
              },
              ReloadOption: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationTaskArn: {}
            }
          }
        },
        RemoveTagsFromResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RunFleetAdvisorLsaAnalysis: {
          output: {
            type: "structure",
            members: {
              LsaAnalysisId: {},
              Status: {}
            }
          }
        },
        StartExtensionPackAssociation: {
          input: {
            type: "structure",
            required: [
              "MigrationProjectIdentifier"
            ],
            members: {
              MigrationProjectIdentifier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RequestIdentifier: {}
            }
          }
        },
        StartMetadataModelAssessment: {
          input: {
            type: "structure",
            required: [
              "MigrationProjectIdentifier",
              "SelectionRules"
            ],
            members: {
              MigrationProjectIdentifier: {},
              SelectionRules: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RequestIdentifier: {}
            }
          }
        },
        StartMetadataModelConversion: {
          input: {
            type: "structure",
            required: [
              "MigrationProjectIdentifier",
              "SelectionRules"
            ],
            members: {
              MigrationProjectIdentifier: {},
              SelectionRules: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RequestIdentifier: {}
            }
          }
        },
        StartMetadataModelExportAsScript: {
          input: {
            type: "structure",
            required: [
              "MigrationProjectIdentifier",
              "SelectionRules",
              "Origin"
            ],
            members: {
              MigrationProjectIdentifier: {},
              SelectionRules: {},
              Origin: {},
              FileName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RequestIdentifier: {}
            }
          }
        },
        StartMetadataModelExportToTarget: {
          input: {
            type: "structure",
            required: [
              "MigrationProjectIdentifier",
              "SelectionRules"
            ],
            members: {
              MigrationProjectIdentifier: {},
              SelectionRules: {},
              OverwriteExtensionPack: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestIdentifier: {}
            }
          }
        },
        StartMetadataModelImport: {
          input: {
            type: "structure",
            required: [
              "MigrationProjectIdentifier",
              "SelectionRules",
              "Origin"
            ],
            members: {
              MigrationProjectIdentifier: {},
              SelectionRules: {},
              Origin: {},
              Refresh: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestIdentifier: {}
            }
          }
        },
        StartRecommendations: {
          input: {
            type: "structure",
            required: [
              "DatabaseId",
              "Settings"
            ],
            members: {
              DatabaseId: {},
              Settings: {
                shape: "Sf"
              }
            }
          }
        },
        StartReplication: {
          input: {
            type: "structure",
            required: [
              "ReplicationConfigArn",
              "StartReplicationType"
            ],
            members: {
              ReplicationConfigArn: {},
              StartReplicationType: {},
              CdcStartTime: {
                type: "timestamp"
              },
              CdcStartPosition: {},
              CdcStopPosition: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Replication: {
                shape: "S97"
              }
            }
          }
        },
        StartReplicationTask: {
          input: {
            type: "structure",
            required: [
              "ReplicationTaskArn",
              "StartReplicationTaskType"
            ],
            members: {
              ReplicationTaskArn: {},
              StartReplicationTaskType: {},
              CdcStartTime: {
                type: "timestamp"
              },
              CdcStartPosition: {},
              CdcStopPosition: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationTask: {
                shape: "S3p"
              }
            }
          }
        },
        StartReplicationTaskAssessment: {
          input: {
            type: "structure",
            required: [
              "ReplicationTaskArn"
            ],
            members: {
              ReplicationTaskArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationTask: {
                shape: "S3p"
              }
            }
          }
        },
        StartReplicationTaskAssessmentRun: {
          input: {
            type: "structure",
            required: [
              "ReplicationTaskArn",
              "ServiceAccessRoleArn",
              "ResultLocationBucket",
              "AssessmentRunName"
            ],
            members: {
              ReplicationTaskArn: {},
              ServiceAccessRoleArn: {},
              ResultLocationBucket: {},
              ResultLocationFolder: {},
              ResultEncryptionMode: {},
              ResultKmsKeyArn: {},
              AssessmentRunName: {},
              IncludeOnly: {
                type: "list",
                member: {}
              },
              Exclude: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationTaskAssessmentRun: {
                shape: "Sl"
              }
            }
          }
        },
        StopReplication: {
          input: {
            type: "structure",
            required: [
              "ReplicationConfigArn"
            ],
            members: {
              ReplicationConfigArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Replication: {
                shape: "S97"
              }
            }
          }
        },
        StopReplicationTask: {
          input: {
            type: "structure",
            required: [
              "ReplicationTaskArn"
            ],
            members: {
              ReplicationTaskArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationTask: {
                shape: "S3p"
              }
            }
          }
        },
        TestConnection: {
          input: {
            type: "structure",
            required: [
              "ReplicationInstanceArn",
              "EndpointArn"
            ],
            members: {
              ReplicationInstanceArn: {},
              EndpointArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Connection: {
                shape: "S3y"
              }
            }
          }
        },
        UpdateSubscriptionsToEventBridge: {
          input: {
            type: "structure",
            members: {
              ForceMove: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Result: {}
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {},
              ResourceArn: {}
            }
          }
        },
        S8: {
          type: "structure",
          members: {
            ResourceIdentifier: {},
            PendingMaintenanceActionDetails: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Action: {},
                  AutoAppliedAfterDate: {
                    type: "timestamp"
                  },
                  ForcedApplyDate: {
                    type: "timestamp"
                  },
                  OptInStatus: {},
                  CurrentApplyDate: {
                    type: "timestamp"
                  },
                  Description: {}
                }
              }
            }
          }
        },
        Sf: {
          type: "structure",
          required: [
            "InstanceSizingType",
            "WorkloadType"
          ],
          members: {
            InstanceSizingType: {},
            WorkloadType: {}
          }
        },
        Sl: {
          type: "structure",
          members: {
            ReplicationTaskAssessmentRunArn: {},
            ReplicationTaskArn: {},
            Status: {},
            ReplicationTaskAssessmentRunCreationDate: {
              type: "timestamp"
            },
            AssessmentProgress: {
              type: "structure",
              members: {
                IndividualAssessmentCount: {
                  type: "integer"
                },
                IndividualAssessmentCompletedCount: {
                  type: "integer"
                }
              }
            },
            LastFailureMessage: {},
            ServiceAccessRoleArn: {},
            ResultLocationBucket: {},
            ResultLocationFolder: {},
            ResultEncryptionMode: {},
            ResultKmsKeyArn: {},
            AssessmentRunName: {}
          }
        },
        Sp: {
          type: "structure",
          members: {
            RedshiftSettings: {
              type: "structure",
              members: {
                ServerName: {},
                Port: {
                  type: "integer"
                },
                DatabaseName: {}
              }
            },
            PostgreSqlSettings: {
              type: "structure",
              members: {
                ServerName: {},
                Port: {
                  type: "integer"
                },
                DatabaseName: {},
                SslMode: {},
                CertificateArn: {}
              }
            },
            MySqlSettings: {
              type: "structure",
              members: {
                ServerName: {},
                Port: {
                  type: "integer"
                },
                SslMode: {},
                CertificateArn: {}
              }
            },
            OracleSettings: {
              type: "structure",
              members: {
                ServerName: {},
                Port: {
                  type: "integer"
                },
                DatabaseName: {},
                SslMode: {},
                CertificateArn: {},
                AsmServer: {},
                SecretsManagerOracleAsmSecretId: {},
                SecretsManagerOracleAsmAccessRoleArn: {},
                SecretsManagerSecurityDbEncryptionSecretId: {},
                SecretsManagerSecurityDbEncryptionAccessRoleArn: {}
              }
            },
            MicrosoftSqlServerSettings: {
              type: "structure",
              members: {
                ServerName: {},
                Port: {
                  type: "integer"
                },
                DatabaseName: {},
                SslMode: {},
                CertificateArn: {}
              }
            },
            DocDbSettings: {
              type: "structure",
              members: {
                ServerName: {},
                Port: {
                  type: "integer"
                },
                DatabaseName: {},
                SslMode: {},
                CertificateArn: {}
              }
            },
            MariaDbSettings: {
              type: "structure",
              members: {
                ServerName: {},
                Port: {
                  type: "integer"
                },
                SslMode: {},
                CertificateArn: {}
              }
            },
            MongoDbSettings: {
              type: "structure",
              members: {
                ServerName: {},
                Port: {
                  type: "integer"
                },
                DatabaseName: {},
                SslMode: {},
                CertificateArn: {},
                AuthType: {},
                AuthSource: {},
                AuthMechanism: {}
              }
            }
          },
          union: true
        },
        S13: {
          type: "structure",
          members: {
            DataProviderName: {},
            DataProviderArn: {},
            DataProviderCreationTime: {
              shape: "S14"
            },
            Description: {},
            Engine: {},
            Settings: {
              shape: "Sp"
            }
          }
        },
        S14: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S17: {
          type: "string",
          sensitive: true
        },
        S18: {
          type: "structure",
          required: [
            "ServiceAccessRoleArn"
          ],
          members: {
            ServiceAccessRoleArn: {}
          }
        },
        S19: {
          type: "structure",
          members: {
            ServiceAccessRoleArn: {},
            ExternalTableDefinition: {},
            CsvRowDelimiter: {},
            CsvDelimiter: {},
            BucketFolder: {},
            BucketName: {},
            CompressionType: {},
            EncryptionMode: {},
            ServerSideEncryptionKmsKeyId: {},
            DataFormat: {},
            EncodingType: {},
            DictPageSizeLimit: {
              type: "integer"
            },
            RowGroupLength: {
              type: "integer"
            },
            DataPageSize: {
              type: "integer"
            },
            ParquetVersion: {},
            EnableStatistics: {
              type: "boolean"
            },
            IncludeOpForFullLoad: {
              type: "boolean"
            },
            CdcInsertsOnly: {
              type: "boolean"
            },
            TimestampColumnName: {},
            ParquetTimestampInMillisecond: {
              type: "boolean"
            },
            CdcInsertsAndUpdates: {
              type: "boolean"
            },
            DatePartitionEnabled: {
              type: "boolean"
            },
            DatePartitionSequence: {},
            DatePartitionDelimiter: {},
            UseCsvNoSupValue: {
              type: "boolean"
            },
            CsvNoSupValue: {},
            PreserveTransactions: {
              type: "boolean"
            },
            CdcPath: {},
            UseTaskStartTimeForFullLoadTimestamp: {
              type: "boolean"
            },
            CannedAclForObjects: {},
            AddColumnName: {
              type: "boolean"
            },
            CdcMaxBatchInterval: {
              type: "integer"
            },
            CdcMinFileSize: {
              type: "integer"
            },
            CsvNullValue: {},
            IgnoreHeaderRows: {
              type: "integer"
            },
            MaxFileSize: {
              type: "integer"
            },
            Rfc4180: {
              type: "boolean"
            },
            DatePartitionTimezone: {},
            AddTrailingPaddingCharacter: {
              type: "boolean"
            },
            ExpectedBucketOwner: {},
            GlueCatalogGeneration: {
              type: "boolean"
            }
          }
        },
        S1j: {
          type: "structure",
          members: {
            ServiceAccessRoleArn: {},
            BucketName: {}
          }
        },
        S1k: {
          type: "structure",
          members: {
            Username: {},
            Password: {
              shape: "S17"
            },
            ServerName: {},
            Port: {
              type: "integer"
            },
            DatabaseName: {},
            AuthType: {},
            AuthMechanism: {},
            NestingLevel: {},
            ExtractDocId: {},
            DocsToInvestigate: {},
            AuthSource: {},
            KmsKeyId: {},
            SecretsManagerAccessRoleArn: {},
            SecretsManagerSecretId: {},
            UseUpdateLookUp: {
              type: "boolean"
            },
            ReplicateShardCollections: {
              type: "boolean"
            }
          }
        },
        S1m: {
          type: "structure",
          members: {
            StreamArn: {},
            MessageFormat: {},
            ServiceAccessRoleArn: {},
            IncludeTransactionDetails: {
              type: "boolean"
            },
            IncludePartitionValue: {
              type: "boolean"
            },
            PartitionIncludeSchemaTable: {
              type: "boolean"
            },
            IncludeTableAlterOperations: {
              type: "boolean"
            },
            IncludeControlDetails: {
              type: "boolean"
            },
            IncludeNullAndEmpty: {
              type: "boolean"
            },
            NoHexPrefix: {
              type: "boolean"
            }
          }
        },
        S1o: {
          type: "structure",
          members: {
            Broker: {},
            Topic: {},
            MessageFormat: {},
            IncludeTransactionDetails: {
              type: "boolean"
            },
            IncludePartitionValue: {
              type: "boolean"
            },
            PartitionIncludeSchemaTable: {
              type: "boolean"
            },
            IncludeTableAlterOperations: {
              type: "boolean"
            },
            IncludeControlDetails: {
              type: "boolean"
            },
            MessageMaxBytes: {
              type: "integer"
            },
            IncludeNullAndEmpty: {
              type: "boolean"
            },
            SecurityProtocol: {},
            SslClientCertificateArn: {},
            SslClientKeyArn: {},
            SslClientKeyPassword: {
              shape: "S17"
            },
            SslCaCertificateArn: {},
            SaslUsername: {},
            SaslPassword: {
              shape: "S17"
            },
            NoHexPrefix: {
              type: "boolean"
            },
            SaslMechanism: {},
            SslEndpointIdentificationAlgorithm: {}
          }
        },
        S1s: {
          type: "structure",
          required: [
            "ServiceAccessRoleArn",
            "EndpointUri"
          ],
          members: {
            ServiceAccessRoleArn: {},
            EndpointUri: {},
            FullLoadErrorPercentage: {
              type: "integer"
            },
            ErrorRetryDuration: {
              type: "integer"
            },
            UseNewMappingType: {
              type: "boolean"
            }
          }
        },
        S1t: {
          type: "structure",
          required: [
            "S3BucketName",
            "S3BucketFolder"
          ],
          members: {
            ServiceAccessRoleArn: {},
            S3BucketName: {},
            S3BucketFolder: {},
            ErrorRetryDuration: {
              type: "integer"
            },
            MaxFileSize: {
              type: "integer"
            },
            MaxRetryCount: {
              type: "integer"
            },
            IamAuthEnabled: {
              type: "boolean"
            }
          }
        },
        S1u: {
          type: "structure",
          members: {
            AcceptAnyDate: {
              type: "boolean"
            },
            AfterConnectScript: {},
            BucketFolder: {},
            BucketName: {},
            CaseSensitiveNames: {
              type: "boolean"
            },
            CompUpdate: {
              type: "boolean"
            },
            ConnectionTimeout: {
              type: "integer"
            },
            DatabaseName: {},
            DateFormat: {},
            EmptyAsNull: {
              type: "boolean"
            },
            EncryptionMode: {},
            ExplicitIds: {
              type: "boolean"
            },
            FileTransferUploadStreams: {
              type: "integer"
            },
            LoadTimeout: {
              type: "integer"
            },
            MaxFileSize: {
              type: "integer"
            },
            Password: {
              shape: "S17"
            },
            Port: {
              type: "integer"
            },
            RemoveQuotes: {
              type: "boolean"
            },
            ReplaceInvalidChars: {},
            ReplaceChars: {},
            ServerName: {},
            ServiceAccessRoleArn: {},
            ServerSideEncryptionKmsKeyId: {},
            TimeFormat: {},
            TrimBlanks: {
              type: "boolean"
            },
            TruncateColumns: {
              type: "boolean"
            },
            Username: {},
            WriteBufferSize: {
              type: "integer"
            },
            SecretsManagerAccessRoleArn: {},
            SecretsManagerSecretId: {},
            MapBooleanAsBoolean: {
              type: "boolean"
            }
          }
        },
        S1v: {
          type: "structure",
          members: {
            AfterConnectScript: {},
            CaptureDdls: {
              type: "boolean"
            },
            MaxFileSize: {
              type: "integer"
            },
            DatabaseName: {},
            DdlArtifactsSchema: {},
            ExecuteTimeout: {
              type: "integer"
            },
            FailTasksOnLobTruncation: {
              type: "boolean"
            },
            HeartbeatEnable: {
              type: "boolean"
            },
            HeartbeatSchema: {},
            HeartbeatFrequency: {
              type: "integer"
            },
            Password: {
              shape: "S17"
            },
            Port: {
              type: "integer"
            },
            ServerName: {},
            Username: {},
            SlotName: {},
            PluginName: {},
            SecretsManagerAccessRoleArn: {},
            SecretsManagerSecretId: {},
            TrimSpaceInChar: {
              type: "boolean"
            },
            MapBooleanAsBoolean: {
              type: "boolean"
            },
            MapJsonbAsClob: {
              type: "boolean"
            },
            MapLongVarcharAs: {},
            DatabaseMode: {},
            BabelfishDatabaseName: {}
          }
        },
        S1z: {
          type: "structure",
          members: {
            AfterConnectScript: {},
            CleanSourceMetadataOnMismatch: {
              type: "boolean"
            },
            DatabaseName: {},
            EventsPollInterval: {
              type: "integer"
            },
            TargetDbType: {},
            MaxFileSize: {
              type: "integer"
            },
            ParallelLoadThreads: {
              type: "integer"
            },
            Password: {
              shape: "S17"
            },
            Port: {
              type: "integer"
            },
            ServerName: {},
            ServerTimezone: {},
            Username: {},
            SecretsManagerAccessRoleArn: {},
            SecretsManagerSecretId: {},
            ExecuteTimeout: {
              type: "integer"
            }
          }
        },
        S21: {
          type: "structure",
          members: {
            AddSupplementalLogging: {
              type: "boolean"
            },
            ArchivedLogDestId: {
              type: "integer"
            },
            AdditionalArchivedLogDestId: {
              type: "integer"
            },
            ExtraArchivedLogDestIds: {
              type: "list",
              member: {
                type: "integer"
              }
            },
            AllowSelectNestedTables: {
              type: "boolean"
            },
            ParallelAsmReadThreads: {
              type: "integer"
            },
            ReadAheadBlocks: {
              type: "integer"
            },
            AccessAlternateDirectly: {
              type: "boolean"
            },
            UseAlternateFolderForOnline: {
              type: "boolean"
            },
            OraclePathPrefix: {},
            UsePathPrefix: {},
            ReplacePathPrefix: {
              type: "boolean"
            },
            EnableHomogenousTablespace: {
              type: "boolean"
            },
            DirectPathNoLog: {
              type: "boolean"
            },
            ArchivedLogsOnly: {
              type: "boolean"
            },
            AsmPassword: {
              shape: "S17"
            },
            AsmServer: {},
            AsmUser: {},
            CharLengthSemantics: {},
            DatabaseName: {},
            DirectPathParallelLoad: {
              type: "boolean"
            },
            FailTasksOnLobTruncation: {
              type: "boolean"
            },
            NumberDatatypeScale: {
              type: "integer"
            },
            Password: {
              shape: "S17"
            },
            Port: {
              type: "integer"
            },
            ReadTableSpaceName: {
              type: "boolean"
            },
            RetryInterval: {
              type: "integer"
            },
            SecurityDbEncryption: {
              shape: "S17"
            },
            SecurityDbEncryptionName: {},
            ServerName: {},
            SpatialDataOptionToGeoJsonFunctionName: {},
            StandbyDelayTime: {
              type: "integer"
            },
            Username: {},
            UseBFile: {
              type: "boolean"
            },
            UseDirectPathFullLoad: {
              type: "boolean"
            },
            UseLogminerReader: {
              type: "boolean"
            },
            SecretsManagerAccessRoleArn: {},
            SecretsManagerSecretId: {},
            SecretsManagerOracleAsmAccessRoleArn: {},
            SecretsManagerOracleAsmSecretId: {},
            TrimSpaceInChar: {
              type: "boolean"
            },
            ConvertTimestampWithZoneToUTC: {
              type: "boolean"
            },
            OpenTransactionWindow: {
              type: "integer"
            }
          }
        },
        S24: {
          type: "structure",
          members: {
            DatabaseName: {},
            Password: {
              shape: "S17"
            },
            Port: {
              type: "integer"
            },
            ServerName: {},
            Username: {},
            SecretsManagerAccessRoleArn: {},
            SecretsManagerSecretId: {}
          }
        },
        S25: {
          type: "structure",
          members: {
            Port: {
              type: "integer"
            },
            BcpPacketSize: {
              type: "integer"
            },
            DatabaseName: {},
            ControlTablesFileGroup: {},
            Password: {
              shape: "S17"
            },
            QuerySingleAlwaysOnNode: {
              type: "boolean"
            },
            ReadBackupOnly: {
              type: "boolean"
            },
            SafeguardPolicy: {},
            ServerName: {},
            Username: {},
            UseBcpFullLoad: {
              type: "boolean"
            },
            UseThirdPartyBackupDevice: {
              type: "boolean"
            },
            SecretsManagerAccessRoleArn: {},
            SecretsManagerSecretId: {},
            TrimSpaceInChar: {
              type: "boolean"
            },
            TlogAccessMode: {},
            ForceLobLookup: {
              type: "boolean"
            }
          }
        },
        S28: {
          type: "structure",
          members: {
            DatabaseName: {},
            Password: {
              shape: "S17"
            },
            Port: {
              type: "integer"
            },
            ServerName: {},
            SetDataCaptureChanges: {
              type: "boolean"
            },
            CurrentLsn: {},
            MaxKBytesPerRead: {
              type: "integer"
            },
            Username: {},
            SecretsManagerAccessRoleArn: {},
            SecretsManagerSecretId: {},
            LoadTimeout: {
              type: "integer"
            },
            WriteBufferSize: {
              type: "integer"
            },
            MaxFileSize: {
              type: "integer"
            },
            KeepCsvFiles: {
              type: "boolean"
            }
          }
        },
        S29: {
          type: "structure",
          members: {
            Username: {},
            Password: {
              shape: "S17"
            },
            ServerName: {},
            Port: {
              type: "integer"
            },
            DatabaseName: {},
            NestingLevel: {},
            ExtractDocId: {
              type: "boolean"
            },
            DocsToInvestigate: {
              type: "integer"
            },
            KmsKeyId: {},
            SecretsManagerAccessRoleArn: {},
            SecretsManagerSecretId: {},
            UseUpdateLookUp: {
              type: "boolean"
            },
            ReplicateShardCollections: {
              type: "boolean"
            }
          }
        },
        S2a: {
          type: "structure",
          required: [
            "ServerName",
            "Port"
          ],
          members: {
            ServerName: {},
            Port: {
              type: "integer"
            },
            SslSecurityProtocol: {},
            AuthType: {},
            AuthUserName: {},
            AuthPassword: {
              shape: "S17"
            },
            SslCaCertificateArn: {}
          }
        },
        S2d: {
          type: "structure",
          members: {
            AfterConnectScript: {},
            CleanSourceMetadataOnMismatch: {
              type: "boolean"
            },
            DatabaseName: {},
            EventsPollInterval: {
              type: "integer"
            },
            TargetDbType: {},
            MaxFileSize: {
              type: "integer"
            },
            ParallelLoadThreads: {
              type: "integer"
            },
            Password: {
              shape: "S17"
            },
            Port: {
              type: "integer"
            },
            ServerName: {},
            ServerTimezone: {},
            Username: {},
            SecretsManagerAccessRoleArn: {},
            SecretsManagerSecretId: {}
          }
        },
        S2e: {
          type: "structure",
          required: [
            "DatabaseName",
            "MemoryDuration",
            "MagneticDuration"
          ],
          members: {
            DatabaseName: {},
            MemoryDuration: {
              type: "integer"
            },
            MagneticDuration: {
              type: "integer"
            },
            CdcInsertsAndUpdates: {
              type: "boolean"
            },
            EnableMagneticStoreWrites: {
              type: "boolean"
            }
          }
        },
        S2g: {
          type: "structure",
          members: {
            EndpointIdentifier: {},
            EndpointType: {},
            EngineName: {},
            EngineDisplayName: {},
            Username: {},
            ServerName: {},
            Port: {
              type: "integer"
            },
            DatabaseName: {},
            ExtraConnectionAttributes: {},
            Status: {},
            KmsKeyId: {},
            EndpointArn: {},
            CertificateArn: {},
            SslMode: {},
            ServiceAccessRoleArn: {},
            ExternalTableDefinition: {},
            ExternalId: {},
            DynamoDbSettings: {
              shape: "S18"
            },
            S3Settings: {
              shape: "S19"
            },
            DmsTransferSettings: {
              shape: "S1j"
            },
            MongoDbSettings: {
              shape: "S1k"
            },
            KinesisSettings: {
              shape: "S1m"
            },
            KafkaSettings: {
              shape: "S1o"
            },
            ElasticsearchSettings: {
              shape: "S1s"
            },
            NeptuneSettings: {
              shape: "S1t"
            },
            RedshiftSettings: {
              shape: "S1u"
            },
            PostgreSQLSettings: {
              shape: "S1v"
            },
            MySQLSettings: {
              shape: "S1z"
            },
            OracleSettings: {
              shape: "S21"
            },
            SybaseSettings: {
              shape: "S24"
            },
            MicrosoftSQLServerSettings: {
              shape: "S25"
            },
            IBMDb2Settings: {
              shape: "S28"
            },
            DocDbSettings: {
              shape: "S29"
            },
            RedisSettings: {
              shape: "S2a"
            },
            GcpMySQLSettings: {
              shape: "S2d"
            },
            TimestreamSettings: {
              shape: "S2e"
            }
          }
        },
        S2i: {
          type: "list",
          member: {}
        },
        S2j: {
          type: "list",
          member: {}
        },
        S2l: {
          type: "structure",
          members: {
            CustomerAwsId: {},
            CustSubscriptionId: {},
            SnsTopicArn: {},
            Status: {},
            SubscriptionCreationTime: {},
            SourceType: {},
            SourceIdsList: {
              shape: "S2j"
            },
            EventCategoriesList: {
              shape: "S2i"
            },
            Enabled: {
              type: "boolean"
            }
          }
        },
        S2q: {
          type: "list",
          member: {}
        },
        S2s: {
          type: "structure",
          members: {
            InstanceProfileArn: {},
            AvailabilityZone: {},
            KmsKeyArn: {},
            PubliclyAccessible: {
              type: "boolean"
            },
            NetworkType: {},
            InstanceProfileName: {},
            Description: {},
            InstanceProfileCreationTime: {
              shape: "S14"
            },
            SubnetGroupIdentifier: {},
            VpcSecurityGroups: {
              shape: "S2q"
            }
          }
        },
        S2u: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "DataProviderIdentifier"
            ],
            members: {
              DataProviderIdentifier: {},
              SecretsManagerSecretId: {},
              SecretsManagerAccessRoleArn: {}
            }
          }
        },
        S2w: {
          type: "structure",
          members: {
            S3BucketPath: {},
            S3BucketRoleArn: {}
          }
        },
        S2y: {
          type: "structure",
          members: {
            MigrationProjectName: {},
            MigrationProjectArn: {},
            MigrationProjectCreationTime: {
              shape: "S14"
            },
            SourceDataProviderDescriptors: {
              shape: "S2z"
            },
            TargetDataProviderDescriptors: {
              shape: "S2z"
            },
            InstanceProfileArn: {},
            InstanceProfileName: {},
            TransformationRules: {},
            Description: {},
            SchemaConversionApplicationAttributes: {
              shape: "S2w"
            }
          }
        },
        S2z: {
          type: "list",
          member: {
            type: "structure",
            members: {
              SecretsManagerSecretId: {},
              SecretsManagerAccessRoleArn: {},
              DataProviderName: {},
              DataProviderArn: {}
            }
          }
        },
        S32: {
          type: "structure",
          members: {
            AvailabilityZone: {},
            DnsNameServers: {},
            KmsKeyId: {},
            MaxCapacityUnits: {
              type: "integer"
            },
            MinCapacityUnits: {
              type: "integer"
            },
            MultiAZ: {
              type: "boolean"
            },
            PreferredMaintenanceWindow: {},
            ReplicationSubnetGroupId: {},
            VpcSecurityGroupIds: {
              shape: "S2q"
            }
          }
        },
        S35: {
          type: "structure",
          members: {
            ReplicationConfigIdentifier: {},
            ReplicationConfigArn: {},
            SourceEndpointArn: {},
            TargetEndpointArn: {},
            ReplicationType: {},
            ComputeConfig: {
              shape: "S32"
            },
            ReplicationSettings: {},
            SupplementalSettings: {},
            TableMappings: {},
            ReplicationConfigCreateTime: {
              type: "timestamp"
            },
            ReplicationConfigUpdateTime: {
              type: "timestamp"
            }
          }
        },
        S37: {
          type: "list",
          member: {}
        },
        S39: {
          type: "structure",
          members: {
            ReplicationInstanceIdentifier: {},
            ReplicationInstanceClass: {},
            ReplicationInstanceStatus: {},
            AllocatedStorage: {
              type: "integer"
            },
            InstanceCreateTime: {
              type: "timestamp"
            },
            VpcSecurityGroups: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  VpcSecurityGroupId: {},
                  Status: {}
                }
              }
            },
            AvailabilityZone: {},
            ReplicationSubnetGroup: {
              shape: "S3c"
            },
            PreferredMaintenanceWindow: {},
            PendingModifiedValues: {
              type: "structure",
              members: {
                ReplicationInstanceClass: {},
                AllocatedStorage: {
                  type: "integer"
                },
                MultiAZ: {
                  type: "boolean"
                },
                EngineVersion: {},
                NetworkType: {}
              }
            },
            MultiAZ: {
              type: "boolean"
            },
            EngineVersion: {},
            AutoMinorVersionUpgrade: {
              type: "boolean"
            },
            KmsKeyId: {},
            ReplicationInstanceArn: {},
            ReplicationInstancePublicIpAddress: {
              deprecated: true
            },
            ReplicationInstancePrivateIpAddress: {
              deprecated: true
            },
            ReplicationInstancePublicIpAddresses: {
              type: "list",
              member: {}
            },
            ReplicationInstancePrivateIpAddresses: {
              type: "list",
              member: {}
            },
            ReplicationInstanceIpv6Addresses: {
              type: "list",
              member: {}
            },
            PubliclyAccessible: {
              type: "boolean"
            },
            SecondaryAvailabilityZone: {},
            FreeUntil: {
              type: "timestamp"
            },
            DnsNameServers: {},
            NetworkType: {}
          }
        },
        S3c: {
          type: "structure",
          members: {
            ReplicationSubnetGroupIdentifier: {},
            ReplicationSubnetGroupDescription: {},
            VpcId: {},
            SubnetGroupStatus: {},
            Subnets: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  SubnetIdentifier: {},
                  SubnetAvailabilityZone: {
                    type: "structure",
                    members: {
                      Name: {}
                    }
                  },
                  SubnetStatus: {}
                }
              }
            },
            SupportedNetworkTypes: {
              shape: "S2q"
            }
          }
        },
        S3l: {
          type: "list",
          member: {}
        },
        S3p: {
          type: "structure",
          members: {
            ReplicationTaskIdentifier: {},
            SourceEndpointArn: {},
            TargetEndpointArn: {},
            ReplicationInstanceArn: {},
            MigrationType: {},
            TableMappings: {},
            ReplicationTaskSettings: {},
            Status: {},
            LastFailureMessage: {},
            StopReason: {},
            ReplicationTaskCreationDate: {
              type: "timestamp"
            },
            ReplicationTaskStartDate: {
              type: "timestamp"
            },
            CdcStartPosition: {},
            CdcStopPosition: {},
            RecoveryCheckpoint: {},
            ReplicationTaskArn: {},
            ReplicationTaskStats: {
              type: "structure",
              members: {
                FullLoadProgressPercent: {
                  type: "integer"
                },
                ElapsedTimeMillis: {
                  type: "long"
                },
                TablesLoaded: {
                  type: "integer"
                },
                TablesLoading: {
                  type: "integer"
                },
                TablesQueued: {
                  type: "integer"
                },
                TablesErrored: {
                  type: "integer"
                },
                FreshStartDate: {
                  type: "timestamp"
                },
                StartDate: {
                  type: "timestamp"
                },
                StopDate: {
                  type: "timestamp"
                },
                FullLoadStartDate: {
                  type: "timestamp"
                },
                FullLoadFinishDate: {
                  type: "timestamp"
                }
              }
            },
            TaskData: {},
            TargetReplicationInstanceArn: {}
          }
        },
        S3u: {
          type: "structure",
          members: {
            CertificateIdentifier: {},
            CertificateCreationDate: {
              type: "timestamp"
            },
            CertificatePem: {},
            CertificateWallet: {
              type: "blob"
            },
            CertificateArn: {},
            CertificateOwner: {},
            ValidFromDate: {
              type: "timestamp"
            },
            ValidToDate: {
              type: "timestamp"
            },
            SigningAlgorithm: {},
            KeyLength: {
              type: "integer"
            }
          }
        },
        S3y: {
          type: "structure",
          members: {
            ReplicationInstanceArn: {},
            EndpointArn: {},
            Status: {},
            LastFailureMessage: {},
            EndpointIdentifier: {},
            ReplicationInstanceIdentifier: {}
          }
        },
        S4u: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Values"
            ],
            members: {
              Name: {},
              Values: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S64: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Status: {},
              RequestIdentifier: {},
              MigrationProjectArn: {},
              Error: {
                type: "structure",
                members: {
                  defaultErrorDetails: {
                    type: "structure",
                    members: {
                      Message: {}
                    }
                  }
                },
                union: true
              },
              ExportSqlDetails: {
                type: "structure",
                members: {
                  S3ObjectKey: {},
                  ObjectURL: {}
                }
              }
            }
          }
        },
        S6m: {
          type: "structure",
          members: {
            ServerId: {},
            IpAddress: {},
            ServerName: {}
          }
        },
        S87: {
          type: "structure",
          members: {
            EndpointArn: {},
            ReplicationInstanceArn: {},
            Status: {},
            LastRefreshDate: {
              type: "timestamp"
            },
            LastFailureMessage: {}
          }
        },
        S8p: {
          type: "structure",
          members: {
            SchemaName: {},
            TableName: {},
            Inserts: {
              type: "long"
            },
            Deletes: {
              type: "long"
            },
            Updates: {
              type: "long"
            },
            Ddls: {
              type: "long"
            },
            AppliedInserts: {
              type: "long"
            },
            AppliedDeletes: {
              type: "long"
            },
            AppliedUpdates: {
              type: "long"
            },
            AppliedDdls: {
              type: "long"
            },
            FullLoadRows: {
              type: "long"
            },
            FullLoadCondtnlChkFailedRows: {
              type: "long"
            },
            FullLoadErrorRows: {
              type: "long"
            },
            FullLoadStartTime: {
              type: "timestamp"
            },
            FullLoadEndTime: {
              type: "timestamp"
            },
            FullLoadReloaded: {
              type: "boolean"
            },
            LastUpdateTime: {
              type: "timestamp"
            },
            TableState: {},
            ValidationPendingRecords: {
              type: "long"
            },
            ValidationFailedRecords: {
              type: "long"
            },
            ValidationSuspendedRecords: {
              type: "long"
            },
            ValidationState: {},
            ValidationStateDetails: {}
          }
        },
        S97: {
          type: "structure",
          members: {
            ReplicationConfigIdentifier: {},
            ReplicationConfigArn: {},
            SourceEndpointArn: {},
            TargetEndpointArn: {},
            ReplicationType: {},
            Status: {},
            ProvisionData: {
              type: "structure",
              members: {
                ProvisionState: {},
                ProvisionedCapacityUnits: {
                  type: "integer"
                },
                DateProvisioned: {
                  type: "timestamp"
                },
                IsNewProvisioningAvailable: {
                  type: "boolean"
                },
                DateNewProvisioningDataAvailable: {
                  type: "timestamp"
                },
                ReasonForNewProvisioningData: {}
              }
            },
            StopReason: {},
            FailureMessages: {
              shape: "S2q"
            },
            ReplicationStats: {
              type: "structure",
              members: {
                FullLoadProgressPercent: {
                  type: "integer"
                },
                ElapsedTimeMillis: {
                  type: "long"
                },
                TablesLoaded: {
                  type: "integer"
                },
                TablesLoading: {
                  type: "integer"
                },
                TablesQueued: {
                  type: "integer"
                },
                TablesErrored: {
                  type: "integer"
                },
                FreshStartDate: {
                  type: "timestamp"
                },
                StartDate: {
                  type: "timestamp"
                },
                StopDate: {
                  type: "timestamp"
                },
                FullLoadStartDate: {
                  type: "timestamp"
                },
                FullLoadFinishDate: {
                  type: "timestamp"
                }
              }
            },
            StartReplicationType: {},
            CdcStartTime: {
              type: "timestamp"
            },
            CdcStartPosition: {},
            CdcStopPosition: {},
            RecoveryCheckpoint: {},
            ReplicationCreateTime: {
              type: "timestamp"
            },
            ReplicationUpdateTime: {
              type: "timestamp"
            },
            ReplicationLastStopTime: {
              type: "timestamp"
            },
            ReplicationDeprovisionTime: {
              type: "timestamp"
            }
          }
        },
        S9k: {
          type: "structure",
          members: {
            S3ObjectKey: {},
            ObjectURL: {}
          }
        },
        Sah: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "SchemaName",
              "TableName"
            ],
            members: {
              SchemaName: {},
              TableName: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/dms-2016-01-01.paginators.json
var require_dms_2016_01_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/dms-2016-01-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeApplicableIndividualAssessments: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeCertificates: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeConnections: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeDataProviders: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeEndpointSettings: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeEndpointTypes: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeEndpoints: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeEngineVersions: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeEventSubscriptions: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeEvents: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeExtensionPackAssociations: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeFleetAdvisorCollectors: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxRecords"
        },
        DescribeFleetAdvisorDatabases: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxRecords"
        },
        DescribeFleetAdvisorLsaAnalysis: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxRecords"
        },
        DescribeFleetAdvisorSchemaObjectSummary: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxRecords"
        },
        DescribeFleetAdvisorSchemas: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxRecords"
        },
        DescribeInstanceProfiles: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeMetadataModelAssessments: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeMetadataModelConversions: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeMetadataModelExportsAsScript: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeMetadataModelExportsToTarget: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeMetadataModelImports: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeMigrationProjects: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeOrderableReplicationInstances: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribePendingMaintenanceActions: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeRecommendationLimitations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxRecords"
        },
        DescribeRecommendations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxRecords"
        },
        DescribeReplicationConfigs: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeReplicationInstanceTaskLogs: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeReplicationInstances: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeReplicationSubnetGroups: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeReplicationTableStatistics: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeReplicationTaskAssessmentResults: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeReplicationTaskAssessmentRuns: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeReplicationTaskIndividualAssessments: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeReplicationTasks: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeReplications: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeSchemas: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeTableStatistics: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/dms-2016-01-01.waiters2.json
var require_dms_2016_01_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/dms-2016-01-01.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        TestConnectionSucceeds: {
          acceptors: [
            {
              argument: "Connections[].Status",
              expected: "successful",
              matcher: "pathAll",
              state: "success"
            },
            {
              argument: "Connections[].Status",
              expected: "failed",
              matcher: "pathAny",
              state: "failure"
            }
          ],
          delay: 5,
          description: "Wait until testing connection succeeds.",
          maxAttempts: 60,
          operation: "DescribeConnections"
        },
        EndpointDeleted: {
          acceptors: [
            {
              expected: "ResourceNotFoundFault",
              matcher: "error",
              state: "success"
            },
            {
              argument: "Endpoints[].Status",
              expected: "active",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "Endpoints[].Status",
              expected: "creating",
              matcher: "pathAny",
              state: "failure"
            }
          ],
          delay: 5,
          description: "Wait until testing endpoint is deleted.",
          maxAttempts: 60,
          operation: "DescribeEndpoints"
        },
        ReplicationInstanceAvailable: {
          acceptors: [
            {
              argument: "ReplicationInstances[].ReplicationInstanceStatus",
              expected: "available",
              matcher: "pathAll",
              state: "success"
            },
            {
              argument: "ReplicationInstances[].ReplicationInstanceStatus",
              expected: "deleting",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationInstances[].ReplicationInstanceStatus",
              expected: "incompatible-credentials",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationInstances[].ReplicationInstanceStatus",
              expected: "incompatible-network",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationInstances[].ReplicationInstanceStatus",
              expected: "inaccessible-encryption-credentials",
              matcher: "pathAny",
              state: "failure"
            }
          ],
          delay: 60,
          description: "Wait until DMS replication instance is available.",
          maxAttempts: 60,
          operation: "DescribeReplicationInstances"
        },
        ReplicationInstanceDeleted: {
          acceptors: [
            {
              argument: "ReplicationInstances[].ReplicationInstanceStatus",
              expected: "available",
              matcher: "pathAny",
              state: "failure"
            },
            {
              expected: "ResourceNotFoundFault",
              matcher: "error",
              state: "success"
            }
          ],
          delay: 15,
          description: "Wait until DMS replication instance is deleted.",
          maxAttempts: 60,
          operation: "DescribeReplicationInstances"
        },
        ReplicationTaskReady: {
          acceptors: [
            {
              argument: "ReplicationTasks[].Status",
              expected: "ready",
              matcher: "pathAll",
              state: "success"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "starting",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "running",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "stopping",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "stopped",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "failed",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "modifying",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "testing",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "deleting",
              matcher: "pathAny",
              state: "failure"
            }
          ],
          delay: 15,
          description: "Wait until DMS replication task is ready.",
          maxAttempts: 60,
          operation: "DescribeReplicationTasks"
        },
        ReplicationTaskStopped: {
          acceptors: [
            {
              argument: "ReplicationTasks[].Status",
              expected: "stopped",
              matcher: "pathAll",
              state: "success"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "ready",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "creating",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "starting",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "failed",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "modifying",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "testing",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "deleting",
              matcher: "pathAny",
              state: "failure"
            }
          ],
          delay: 15,
          description: "Wait until DMS replication task is stopped.",
          maxAttempts: 60,
          operation: "DescribeReplicationTasks"
        },
        ReplicationTaskRunning: {
          acceptors: [
            {
              argument: "ReplicationTasks[].Status",
              expected: "running",
              matcher: "pathAll",
              state: "success"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "ready",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "creating",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "stopping",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "stopped",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "failed",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "modifying",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "testing",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "deleting",
              matcher: "pathAny",
              state: "failure"
            }
          ],
          delay: 15,
          description: "Wait until DMS replication task is running.",
          maxAttempts: 60,
          operation: "DescribeReplicationTasks"
        },
        ReplicationTaskDeleted: {
          acceptors: [
            {
              argument: "ReplicationTasks[].Status",
              expected: "ready",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "creating",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "stopped",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "running",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "failed",
              matcher: "pathAny",
              state: "failure"
            },
            {
              expected: "ResourceNotFoundFault",
              matcher: "error",
              state: "success"
            }
          ],
          delay: 15,
          description: "Wait until DMS replication task is deleted.",
          maxAttempts: 60,
          operation: "DescribeReplicationTasks"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/dms.js
var require_dms = __commonJS({
  "node_modules/aws-sdk/clients/dms.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["dms"] = {};
    AWS2.DMS = Service.defineService("dms", ["2016-01-01"]);
    Object.defineProperty(apiLoader.services["dms"], "2016-01-01", {
      get: function get() {
        var model = require_dms_2016_01_01_min();
        model.paginators = require_dms_2016_01_01_paginators().pagination;
        model.waiters = require_dms_2016_01_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.DMS;
  }
});

// node_modules/aws-sdk/lib/dynamodb/types.js
var require_types = __commonJS({
  "node_modules/aws-sdk/lib/dynamodb/types.js"(exports2, module2) {
    "use strict";
    var util = require_core().util;
    function typeOf(data) {
      if (data === null && typeof data === "object") {
        return "null";
      } else if (data !== void 0 && isBinary(data)) {
        return "Binary";
      } else if (data !== void 0 && data.constructor) {
        return data.wrapperName || util.typeName(data.constructor);
      } else if (data !== void 0 && typeof data === "object") {
        return "Object";
      } else {
        return "undefined";
      }
    }
    function isBinary(data) {
      var types = [
        "Buffer",
        "File",
        "Blob",
        "ArrayBuffer",
        "DataView",
        "Int8Array",
        "Uint8Array",
        "Uint8ClampedArray",
        "Int16Array",
        "Uint16Array",
        "Int32Array",
        "Uint32Array",
        "Float32Array",
        "Float64Array"
      ];
      if (util.isNode()) {
        var Stream = util.stream.Stream;
        if (util.Buffer.isBuffer(data) || data instanceof Stream) {
          return true;
        }
      }
      for (var i = 0; i < types.length; i++) {
        if (data !== void 0 && data.constructor) {
          if (util.isType(data, types[i]))
            return true;
          if (util.typeName(data.constructor) === types[i])
            return true;
        }
      }
      return false;
    }
    module2.exports = {
      typeOf,
      isBinary
    };
  }
});

// node_modules/aws-sdk/lib/dynamodb/set.js
var require_set = __commonJS({
  "node_modules/aws-sdk/lib/dynamodb/set.js"(exports2, module2) {
    "use strict";
    var util = require_core().util;
    var typeOf = require_types().typeOf;
    var memberTypeToSetType = {
      "String": "String",
      "Number": "Number",
      "NumberValue": "Number",
      "Binary": "Binary"
    };
    var DynamoDBSet = util.inherit({
      constructor: function Set2(list, options) {
        options = options || {};
        this.wrapperName = "Set";
        this.initialize(list, options.validate);
      },
      initialize: function(list, validate) {
        var self2 = this;
        self2.values = [].concat(list);
        self2.detectType();
        if (validate) {
          self2.validate();
        }
      },
      detectType: function() {
        this.type = memberTypeToSetType[typeOf(this.values[0])];
        if (!this.type) {
          throw util.error(new Error(), {
            code: "InvalidSetType",
            message: "Sets can contain string, number, or binary values"
          });
        }
      },
      validate: function() {
        var self2 = this;
        var length = self2.values.length;
        var values = self2.values;
        for (var i = 0; i < length; i++) {
          if (memberTypeToSetType[typeOf(values[i])] !== self2.type) {
            throw util.error(new Error(), {
              code: "InvalidType",
              message: self2.type + " Set contains " + typeOf(values[i]) + " value"
            });
          }
        }
      },
      /**
       * Render the underlying values only when converting to JSON.
       */
      toJSON: function() {
        var self2 = this;
        return self2.values;
      }
    });
    module2.exports = DynamoDBSet;
  }
});

// node_modules/aws-sdk/lib/dynamodb/numberValue.js
var require_numberValue = __commonJS({
  "node_modules/aws-sdk/lib/dynamodb/numberValue.js"(exports2, module2) {
    "use strict";
    var util = require_core().util;
    var DynamoDBNumberValue = util.inherit({
      constructor: function NumberValue(value) {
        this.wrapperName = "NumberValue";
        this.value = value.toString();
      },
      /**
       * Render the underlying value as a number when converting to JSON.
       */
      toJSON: function() {
        return this.toNumber();
      },
      /**
       * Convert the underlying value to a JavaScript number.
       */
      toNumber: function() {
        return Number(this.value);
      },
      /**
       * Return a string representing the unaltered value provided to the
       * constructor.
       */
      toString: function() {
        return this.value;
      }
    });
    module2.exports = DynamoDBNumberValue;
  }
});

// node_modules/aws-sdk/lib/dynamodb/converter.js
var require_converter = __commonJS({
  "node_modules/aws-sdk/lib/dynamodb/converter.js"(exports2, module2) {
    "use strict";
    var AWS2 = require_core();
    var util = AWS2.util;
    var typeOf = require_types().typeOf;
    var DynamoDBSet = require_set();
    var NumberValue = require_numberValue();
    AWS2.DynamoDB.Converter = {
      /**
       * Convert a JavaScript value to its equivalent DynamoDB AttributeValue type
       *
       * @param data [any] The data to convert to a DynamoDB AttributeValue
       * @param options [map]
       * @option options convertEmptyValues [Boolean] Whether to automatically
       *                                              convert empty strings, blobs,
       *                                              and sets to `null`
       * @option options wrapNumbers [Boolean]  Whether to return numbers as a
       *                                        NumberValue object instead of
       *                                        converting them to native JavaScript
       *                                        numbers. This allows for the safe
       *                                        round-trip transport of numbers of
       *                                        arbitrary size.
       * @return [map] An object in the Amazon DynamoDB AttributeValue format
       *
       * @see AWS.DynamoDB.Converter.marshall AWS.DynamoDB.Converter.marshall to
       *    convert entire records (rather than individual attributes)
       */
      input: function convertInput(data, options) {
        options = options || {};
        var type = typeOf(data);
        if (type === "Object") {
          return formatMap(data, options);
        } else if (type === "Array") {
          return formatList(data, options);
        } else if (type === "Set") {
          return formatSet(data, options);
        } else if (type === "String") {
          if (data.length === 0 && options.convertEmptyValues) {
            return convertInput(null);
          }
          return { S: data };
        } else if (type === "Number" || type === "NumberValue") {
          return { N: data.toString() };
        } else if (type === "Binary") {
          if (data.length === 0 && options.convertEmptyValues) {
            return convertInput(null);
          }
          return { B: data };
        } else if (type === "Boolean") {
          return { BOOL: data };
        } else if (type === "null") {
          return { NULL: true };
        } else if (type !== "undefined" && type !== "Function") {
          return formatMap(data, options);
        }
      },
      /**
       * Convert a JavaScript object into a DynamoDB record.
       *
       * @param data [any] The data to convert to a DynamoDB record
       * @param options [map]
       * @option options convertEmptyValues [Boolean] Whether to automatically
       *                                              convert empty strings, blobs,
       *                                              and sets to `null`
       * @option options wrapNumbers [Boolean]  Whether to return numbers as a
       *                                        NumberValue object instead of
       *                                        converting them to native JavaScript
       *                                        numbers. This allows for the safe
       *                                        round-trip transport of numbers of
       *                                        arbitrary size.
       *
       * @return [map] An object in the DynamoDB record format.
       *
       * @example Convert a JavaScript object into a DynamoDB record
       *  var marshalled = AWS.DynamoDB.Converter.marshall({
       *    string: 'foo',
       *    list: ['fizz', 'buzz', 'pop'],
       *    map: {
       *      nestedMap: {
       *        key: 'value',
       *      }
       *    },
       *    number: 123,
       *    nullValue: null,
       *    boolValue: true,
       *    stringSet: new DynamoDBSet(['foo', 'bar', 'baz'])
       *  });
       */
      marshall: function marshallItem(data, options) {
        return AWS2.DynamoDB.Converter.input(data, options).M;
      },
      /**
       * Convert a DynamoDB AttributeValue object to its equivalent JavaScript type.
       *
       * @param data [map] An object in the Amazon DynamoDB AttributeValue format
       * @param options [map]
       * @option options convertEmptyValues [Boolean] Whether to automatically
       *                                              convert empty strings, blobs,
       *                                              and sets to `null`
       * @option options wrapNumbers [Boolean]  Whether to return numbers as a
       *                                        NumberValue object instead of
       *                                        converting them to native JavaScript
       *                                        numbers. This allows for the safe
       *                                        round-trip transport of numbers of
       *                                        arbitrary size.
       *
       * @return [Object|Array|String|Number|Boolean|null]
       *
       * @see AWS.DynamoDB.Converter.unmarshall AWS.DynamoDB.Converter.unmarshall to
       *    convert entire records (rather than individual attributes)
       */
      output: function convertOutput(data, options) {
        options = options || {};
        var list, map, i;
        for (var type in data) {
          var values = data[type];
          if (type === "M") {
            map = {};
            for (var key in values) {
              map[key] = convertOutput(values[key], options);
            }
            return map;
          } else if (type === "L") {
            list = [];
            for (i = 0; i < values.length; i++) {
              list.push(convertOutput(values[i], options));
            }
            return list;
          } else if (type === "SS") {
            list = [];
            for (i = 0; i < values.length; i++) {
              list.push(values[i] + "");
            }
            return new DynamoDBSet(list);
          } else if (type === "NS") {
            list = [];
            for (i = 0; i < values.length; i++) {
              list.push(convertNumber(values[i], options.wrapNumbers));
            }
            return new DynamoDBSet(list);
          } else if (type === "BS") {
            list = [];
            for (i = 0; i < values.length; i++) {
              list.push(AWS2.util.buffer.toBuffer(values[i]));
            }
            return new DynamoDBSet(list);
          } else if (type === "S") {
            return values + "";
          } else if (type === "N") {
            return convertNumber(values, options.wrapNumbers);
          } else if (type === "B") {
            return util.buffer.toBuffer(values);
          } else if (type === "BOOL") {
            return values === "true" || values === "TRUE" || values === true;
          } else if (type === "NULL") {
            return null;
          }
        }
      },
      /**
       * Convert a DynamoDB record into a JavaScript object.
       *
       * @param data [any] The DynamoDB record
       * @param options [map]
       * @option options convertEmptyValues [Boolean] Whether to automatically
       *                                              convert empty strings, blobs,
       *                                              and sets to `null`
       * @option options wrapNumbers [Boolean]  Whether to return numbers as a
       *                                        NumberValue object instead of
       *                                        converting them to native JavaScript
       *                                        numbers. This allows for the safe
       *                                        round-trip transport of numbers of
       *                                        arbitrary size.
       *
       * @return [map] An object whose properties have been converted from
       *    DynamoDB's AttributeValue format into their corresponding native
       *    JavaScript types.
       *
       * @example Convert a record received from a DynamoDB stream
       *  var unmarshalled = AWS.DynamoDB.Converter.unmarshall({
       *    string: {S: 'foo'},
       *    list: {L: [{S: 'fizz'}, {S: 'buzz'}, {S: 'pop'}]},
       *    map: {
       *      M: {
       *        nestedMap: {
       *          M: {
       *            key: {S: 'value'}
       *          }
       *        }
       *      }
       *    },
       *    number: {N: '123'},
       *    nullValue: {NULL: true},
       *    boolValue: {BOOL: true}
       *  });
       */
      unmarshall: function unmarshall(data, options) {
        return AWS2.DynamoDB.Converter.output({ M: data }, options);
      }
    };
    function formatList(data, options) {
      var list = { L: [] };
      for (var i = 0; i < data.length; i++) {
        list["L"].push(AWS2.DynamoDB.Converter.input(data[i], options));
      }
      return list;
    }
    function convertNumber(value, wrapNumbers) {
      return wrapNumbers ? new NumberValue(value) : Number(value);
    }
    function formatMap(data, options) {
      var map = { M: {} };
      for (var key in data) {
        var formatted = AWS2.DynamoDB.Converter.input(data[key], options);
        if (formatted !== void 0) {
          map["M"][key] = formatted;
        }
      }
      return map;
    }
    function formatSet(data, options) {
      options = options || {};
      var values = data.values;
      if (options.convertEmptyValues) {
        values = filterEmptySetValues(data);
        if (values.length === 0) {
          return AWS2.DynamoDB.Converter.input(null);
        }
      }
      var map = {};
      switch (data.type) {
        case "String":
          map["SS"] = values;
          break;
        case "Binary":
          map["BS"] = values;
          break;
        case "Number":
          map["NS"] = values.map(function(value) {
            return value.toString();
          });
      }
      return map;
    }
    function filterEmptySetValues(set) {
      var nonEmptyValues = [];
      var potentiallyEmptyTypes = {
        String: true,
        Binary: true,
        Number: false
      };
      if (potentiallyEmptyTypes[set.type]) {
        for (var i = 0; i < set.values.length; i++) {
          if (set.values[i].length === 0) {
            continue;
          }
          nonEmptyValues.push(set.values[i]);
        }
        return nonEmptyValues;
      }
      return set.values;
    }
    module2.exports = AWS2.DynamoDB.Converter;
  }
});

// node_modules/aws-sdk/lib/dynamodb/translator.js
var require_translator = __commonJS({
  "node_modules/aws-sdk/lib/dynamodb/translator.js"(exports2, module2) {
    "use strict";
    var util = require_core().util;
    var convert = require_converter();
    var Translator = function(options) {
      options = options || {};
      this.attrValue = options.attrValue;
      this.convertEmptyValues = Boolean(options.convertEmptyValues);
      this.wrapNumbers = Boolean(options.wrapNumbers);
    };
    Translator.prototype.translateInput = function(value, shape) {
      this.mode = "input";
      return this.translate(value, shape);
    };
    Translator.prototype.translateOutput = function(value, shape) {
      this.mode = "output";
      return this.translate(value, shape);
    };
    Translator.prototype.translate = function(value, shape) {
      var self2 = this;
      if (!shape || value === void 0)
        return void 0;
      if (shape.shape === self2.attrValue) {
        return convert[self2.mode](value, {
          convertEmptyValues: self2.convertEmptyValues,
          wrapNumbers: self2.wrapNumbers
        });
      }
      switch (shape.type) {
        case "structure":
          return self2.translateStructure(value, shape);
        case "map":
          return self2.translateMap(value, shape);
        case "list":
          return self2.translateList(value, shape);
        default:
          return self2.translateScalar(value, shape);
      }
    };
    Translator.prototype.translateStructure = function(structure, shape) {
      var self2 = this;
      if (structure == null)
        return void 0;
      var struct = {};
      util.each(structure, function(name, value) {
        var memberShape = shape.members[name];
        if (memberShape) {
          var result = self2.translate(value, memberShape);
          if (result !== void 0)
            struct[name] = result;
        }
      });
      return struct;
    };
    Translator.prototype.translateList = function(list, shape) {
      var self2 = this;
      if (list == null)
        return void 0;
      var out = [];
      util.arrayEach(list, function(value) {
        var result = self2.translate(value, shape.member);
        if (result === void 0)
          out.push(null);
        else
          out.push(result);
      });
      return out;
    };
    Translator.prototype.translateMap = function(map, shape) {
      var self2 = this;
      if (map == null)
        return void 0;
      var out = {};
      util.each(map, function(key, value) {
        var result = self2.translate(value, shape.value);
        if (result === void 0)
          out[key] = null;
        else
          out[key] = result;
      });
      return out;
    };
    Translator.prototype.translateScalar = function(value, shape) {
      return shape.toType(value);
    };
    module2.exports = Translator;
  }
});

// node_modules/aws-sdk/lib/dynamodb/document_client.js
var require_document_client = __commonJS({
  "node_modules/aws-sdk/lib/dynamodb/document_client.js"(exports2, module2) {
    "use strict";
    var AWS2 = require_core();
    var Translator = require_translator();
    var DynamoDBSet = require_set();
    AWS2.DynamoDB.DocumentClient = AWS2.util.inherit({
      /**
       * Creates a DynamoDB document client with a set of configuration options.
       *
       * @option options params [map] An optional map of parameters to bind to every
       *   request sent by this service object.
       * @option options service [AWS.DynamoDB] An optional pre-configured instance
       *  of the AWS.DynamoDB service object. This instance's config will be
       *  copied to a new instance used by this client. You should not need to
       *  retain a reference to the input object, and may destroy it or allow it
       *  to be garbage collected.
       * @option options convertEmptyValues [Boolean] set to true if you would like
       *  the document client to convert empty values (0-length strings, binary
       *  buffers, and sets) to be converted to NULL types when persisting to
       *  DynamoDB.
       * @option options wrapNumbers [Boolean] Set to true to return numbers as a
       *  NumberValue object instead of converting them to native JavaScript numbers.
       *  This allows for the safe round-trip transport of numbers of arbitrary size.
       * @see AWS.DynamoDB.constructor
       *
       */
      constructor: function DocumentClient(options) {
        var self2 = this;
        self2.options = options || {};
        self2.configure(self2.options);
      },
      /**
       * @api private
       */
      configure: function configure(options) {
        var self2 = this;
        self2.service = options.service;
        self2.bindServiceObject(options);
        self2.attrValue = options.attrValue = self2.service.api.operations.putItem.input.members.Item.value.shape;
      },
      /**
       * @api private
       */
      bindServiceObject: function bindServiceObject(options) {
        var self2 = this;
        options = options || {};
        if (!self2.service) {
          self2.service = new AWS2.DynamoDB(options);
        } else {
          var config = AWS2.util.copy(self2.service.config);
          self2.service = new self2.service.constructor.__super__(config);
          self2.service.config.params = AWS2.util.merge(self2.service.config.params || {}, options.params);
        }
      },
      /**
       * @api private
       */
      makeServiceRequest: function(operation, params, callback) {
        var self2 = this;
        var request = self2.service[operation](params);
        self2.setupRequest(request);
        self2.setupResponse(request);
        if (typeof callback === "function") {
          request.send(callback);
        }
        return request;
      },
      /**
       * @api private
       */
      serviceClientOperationsMap: {
        batchGet: "batchGetItem",
        batchWrite: "batchWriteItem",
        delete: "deleteItem",
        get: "getItem",
        put: "putItem",
        query: "query",
        scan: "scan",
        update: "updateItem",
        transactGet: "transactGetItems",
        transactWrite: "transactWriteItems"
      },
      /**
       * Returns the attributes of one or more items from one or more tables
       * by delegating to `AWS.DynamoDB.batchGetItem()`.
       *
       * Supply the same parameters as {AWS.DynamoDB.batchGetItem} with
       * `AttributeValue`s substituted by native JavaScript types.
       *
       * @see AWS.DynamoDB.batchGetItem
       * @example Get items from multiple tables
       *  var params = {
       *    RequestItems: {
       *      'Table-1': {
       *        Keys: [
       *          {
       *             HashKey: 'haskey',
       *             NumberRangeKey: 1
       *          }
       *        ]
       *      },
       *      'Table-2': {
       *        Keys: [
       *          { foo: 'bar' },
       *        ]
       *      }
       *    }
       *  };
       *
       *  var documentClient = new AWS.DynamoDB.DocumentClient();
       *
       *  documentClient.batchGet(params, function(err, data) {
       *    if (err) console.log(err);
       *    else console.log(data);
       *  });
       *
       */
      batchGet: function(params, callback) {
        var operation = this.serviceClientOperationsMap["batchGet"];
        return this.makeServiceRequest(operation, params, callback);
      },
      /**
       * Puts or deletes multiple items in one or more tables by delegating
       * to `AWS.DynamoDB.batchWriteItem()`.
       *
       * Supply the same parameters as {AWS.DynamoDB.batchWriteItem} with
       * `AttributeValue`s substituted by native JavaScript types.
       *
       * @see AWS.DynamoDB.batchWriteItem
       * @example Write to and delete from a table
       *  var params = {
       *    RequestItems: {
       *      'Table-1': [
       *        {
       *          DeleteRequest: {
       *            Key: { HashKey: 'someKey' }
       *          }
       *        },
       *        {
       *          PutRequest: {
       *            Item: {
       *              HashKey: 'anotherKey',
       *              NumAttribute: 1,
       *              BoolAttribute: true,
       *              ListAttribute: [1, 'two', false],
       *              MapAttribute: { foo: 'bar' }
       *            }
       *          }
       *        }
       *      ]
       *    }
       *  };
       *
       *  var documentClient = new AWS.DynamoDB.DocumentClient();
       *
       *  documentClient.batchWrite(params, function(err, data) {
       *    if (err) console.log(err);
       *    else console.log(data);
       *  });
       *
       */
      batchWrite: function(params, callback) {
        var operation = this.serviceClientOperationsMap["batchWrite"];
        return this.makeServiceRequest(operation, params, callback);
      },
      /**
       * Deletes a single item in a table by primary key by delegating to
       * `AWS.DynamoDB.deleteItem()`
       *
       * Supply the same parameters as {AWS.DynamoDB.deleteItem} with
       * `AttributeValue`s substituted by native JavaScript types.
       *
       * @see AWS.DynamoDB.deleteItem
       * @example Delete an item from a table
       *  var params = {
       *    TableName : 'Table',
       *    Key: {
       *      HashKey: 'hashkey',
       *      NumberRangeKey: 1
       *    }
       *  };
       *
       *  var documentClient = new AWS.DynamoDB.DocumentClient();
       *
       *  documentClient.delete(params, function(err, data) {
       *    if (err) console.log(err);
       *    else console.log(data);
       *  });
       *
       */
      delete: function(params, callback) {
        var operation = this.serviceClientOperationsMap["delete"];
        return this.makeServiceRequest(operation, params, callback);
      },
      /**
       * Returns a set of attributes for the item with the given primary key
       * by delegating to `AWS.DynamoDB.getItem()`.
       *
       * Supply the same parameters as {AWS.DynamoDB.getItem} with
       * `AttributeValue`s substituted by native JavaScript types.
       *
       * @see AWS.DynamoDB.getItem
       * @example Get an item from a table
       *  var params = {
       *    TableName : 'Table',
       *    Key: {
       *      HashKey: 'hashkey'
       *    }
       *  };
       *
       *  var documentClient = new AWS.DynamoDB.DocumentClient();
       *
       *  documentClient.get(params, function(err, data) {
       *    if (err) console.log(err);
       *    else console.log(data);
       *  });
       *
       */
      get: function(params, callback) {
        var operation = this.serviceClientOperationsMap["get"];
        return this.makeServiceRequest(operation, params, callback);
      },
      /**
       * Creates a new item, or replaces an old item with a new item by
       * delegating to `AWS.DynamoDB.putItem()`.
       *
       * Supply the same parameters as {AWS.DynamoDB.putItem} with
       * `AttributeValue`s substituted by native JavaScript types.
       *
       * @see AWS.DynamoDB.putItem
       * @example Create a new item in a table
       *  var params = {
       *    TableName : 'Table',
       *    Item: {
       *       HashKey: 'haskey',
       *       NumAttribute: 1,
       *       BoolAttribute: true,
       *       ListAttribute: [1, 'two', false],
       *       MapAttribute: { foo: 'bar'},
       *       NullAttribute: null
       *    }
       *  };
       *
       *  var documentClient = new AWS.DynamoDB.DocumentClient();
       *
       *  documentClient.put(params, function(err, data) {
       *    if (err) console.log(err);
       *    else console.log(data);
       *  });
       *
       */
      put: function(params, callback) {
        var operation = this.serviceClientOperationsMap["put"];
        return this.makeServiceRequest(operation, params, callback);
      },
      /**
       * Edits an existing item's attributes, or adds a new item to the table if
       * it does not already exist by delegating to `AWS.DynamoDB.updateItem()`.
       *
       * Supply the same parameters as {AWS.DynamoDB.updateItem} with
       * `AttributeValue`s substituted by native JavaScript types.
       *
       * @see AWS.DynamoDB.updateItem
       * @example Update an item with expressions
       *  var params = {
       *    TableName: 'Table',
       *    Key: { HashKey : 'hashkey' },
       *    UpdateExpression: 'set #a = :x + :y',
       *    ConditionExpression: '#a < :MAX',
       *    ExpressionAttributeNames: {'#a' : 'Sum'},
       *    ExpressionAttributeValues: {
       *      ':x' : 20,
       *      ':y' : 45,
       *      ':MAX' : 100,
       *    }
       *  };
       *
       *  var documentClient = new AWS.DynamoDB.DocumentClient();
       *
       *  documentClient.update(params, function(err, data) {
       *     if (err) console.log(err);
       *     else console.log(data);
       *  });
       *
       */
      update: function(params, callback) {
        var operation = this.serviceClientOperationsMap["update"];
        return this.makeServiceRequest(operation, params, callback);
      },
      /**
       * Returns one or more items and item attributes by accessing every item
       * in a table or a secondary index.
       *
       * Supply the same parameters as {AWS.DynamoDB.scan} with
       * `AttributeValue`s substituted by native JavaScript types.
       *
       * @see AWS.DynamoDB.scan
       * @example Scan the table with a filter expression
       *  var params = {
       *    TableName : 'Table',
       *    FilterExpression : 'Year = :this_year',
       *    ExpressionAttributeValues : {':this_year' : 2015}
       *  };
       *
       *  var documentClient = new AWS.DynamoDB.DocumentClient();
       *
       *  documentClient.scan(params, function(err, data) {
       *     if (err) console.log(err);
       *     else console.log(data);
       *  });
       *
       */
      scan: function(params, callback) {
        var operation = this.serviceClientOperationsMap["scan"];
        return this.makeServiceRequest(operation, params, callback);
      },
      /**
       * Directly access items from a table by primary key or a secondary index.
       *
       * Supply the same parameters as {AWS.DynamoDB.query} with
       * `AttributeValue`s substituted by native JavaScript types.
       *
       * @see AWS.DynamoDB.query
       * @example Query an index
       *  var params = {
       *    TableName: 'Table',
       *    IndexName: 'Index',
       *    KeyConditionExpression: 'HashKey = :hkey and RangeKey > :rkey',
       *    ExpressionAttributeValues: {
       *      ':hkey': 'key',
       *      ':rkey': 2015
       *    }
       *  };
       *
       *  var documentClient = new AWS.DynamoDB.DocumentClient();
       *
       *  documentClient.query(params, function(err, data) {
       *     if (err) console.log(err);
       *     else console.log(data);
       *  });
       *
       */
      query: function(params, callback) {
        var operation = this.serviceClientOperationsMap["query"];
        return this.makeServiceRequest(operation, params, callback);
      },
      /**
       * Synchronous write operation that groups up to 100 action requests.
       *
       * Supply the same parameters as {AWS.DynamoDB.transactWriteItems} with
       * `AttributeValue`s substituted by native JavaScript types.
       *
       * @see AWS.DynamoDB.transactWriteItems
       * @example Get items from multiple tables
       *  var params = {
       *    TransactItems: [{
       *      Put: {
       *        TableName : 'Table0',
       *        Item: {
       *          HashKey: 'haskey',
       *          NumAttribute: 1,
       *          BoolAttribute: true,
       *          ListAttribute: [1, 'two', false],
       *          MapAttribute: { foo: 'bar'},
       *          NullAttribute: null
       *        }
       *      }
       *    }, {
       *      Update: {
       *        TableName: 'Table1',
       *        Key: { HashKey : 'hashkey' },
       *        UpdateExpression: 'set #a = :x + :y',
       *        ConditionExpression: '#a < :MAX',
       *        ExpressionAttributeNames: {'#a' : 'Sum'},
       *        ExpressionAttributeValues: {
       *          ':x' : 20,
       *          ':y' : 45,
       *          ':MAX' : 100,
       *        }
       *      }
       *    }]
       *  };
       *
       *  documentClient.transactWrite(params, function(err, data) {
       *    if (err) console.log(err);
       *    else console.log(data);
       *  });
       */
      transactWrite: function(params, callback) {
        var operation = this.serviceClientOperationsMap["transactWrite"];
        return this.makeServiceRequest(operation, params, callback);
      },
      /**
       * Atomically retrieves multiple items from one or more tables (but not from indexes)
       * in a single account and region.
       *
       * Supply the same parameters as {AWS.DynamoDB.transactGetItems} with
       * `AttributeValue`s substituted by native JavaScript types.
       *
       * @see AWS.DynamoDB.transactGetItems
       * @example Get items from multiple tables
       *  var params = {
       *    TransactItems: [{
       *      Get: {
       *        TableName : 'Table0',
       *        Key: {
       *          HashKey: 'hashkey0'
       *        }
       *      }
       *    }, {
       *      Get: {
       *        TableName : 'Table1',
       *        Key: {
       *          HashKey: 'hashkey1'
       *        }
       *      }
       *    }]
       *  };
       *
       *  documentClient.transactGet(params, function(err, data) {
       *    if (err) console.log(err);
       *    else console.log(data);
       *  });
       */
      transactGet: function(params, callback) {
        var operation = this.serviceClientOperationsMap["transactGet"];
        return this.makeServiceRequest(operation, params, callback);
      },
      /**
       * Creates a set of elements inferring the type of set from
       * the type of the first element. Amazon DynamoDB currently supports
       * the number sets, string sets, and binary sets. For more information
       * about DynamoDB data types see the documentation on the
       * [Amazon DynamoDB Data Model](http://docs.aws.amazon.com/amazondynamodb/latest/developerguide/DataModel.html#DataModel.DataTypes).
       *
       * @param list [Array] Collection to represent your DynamoDB Set
       * @param options [map]
       *  * **validate** [Boolean] set to true if you want to validate the type
       *    of each element in the set. Defaults to `false`.
       * @example Creating a number set
       *  var documentClient = new AWS.DynamoDB.DocumentClient();
       *
       *  var params = {
       *    Item: {
       *      hashkey: 'hashkey'
       *      numbers: documentClient.createSet([1, 2, 3]);
       *    }
       *  };
       *
       *  documentClient.put(params, function(err, data) {
       *    if (err) console.log(err);
       *    else console.log(data);
       *  });
       *
       */
      createSet: function(list, options) {
        options = options || {};
        return new DynamoDBSet(list, options);
      },
      /**
       * @api private
       */
      getTranslator: function() {
        return new Translator(this.options);
      },
      /**
       * @api private
       */
      setupRequest: function setupRequest(request) {
        var self2 = this;
        var translator = self2.getTranslator();
        var operation = request.operation;
        var inputShape = request.service.api.operations[operation].input;
        request._events.validate.unshift(function(req) {
          req.rawParams = AWS2.util.copy(req.params);
          req.params = translator.translateInput(req.rawParams, inputShape);
        });
      },
      /**
       * @api private
       */
      setupResponse: function setupResponse(request) {
        var self2 = this;
        var translator = self2.getTranslator();
        var outputShape = self2.service.api.operations[request.operation].output;
        request.on("extractData", function(response2) {
          response2.data = translator.translateOutput(response2.data, outputShape);
        });
        var response = request.response;
        response.nextPage = function(cb) {
          var resp = this;
          var req = resp.request;
          var config;
          var service = req.service;
          var operation = req.operation;
          try {
            config = service.paginationConfig(operation, true);
          } catch (e) {
            resp.error = e;
          }
          if (!resp.hasNextPage()) {
            if (cb)
              cb(resp.error, null);
            else if (resp.error)
              throw resp.error;
            return null;
          }
          var params = AWS2.util.copy(req.rawParams);
          if (!resp.nextPageTokens) {
            return cb ? cb(null, null) : null;
          } else {
            var inputTokens = config.inputToken;
            if (typeof inputTokens === "string")
              inputTokens = [inputTokens];
            for (var i = 0; i < inputTokens.length; i++) {
              params[inputTokens[i]] = resp.nextPageTokens[i];
            }
            return self2[operation](params, cb);
          }
        };
      }
    });
    module2.exports = AWS2.DynamoDB.DocumentClient;
  }
});

// node_modules/aws-sdk/lib/services/dynamodb.js
var require_dynamodb = __commonJS({
  "node_modules/aws-sdk/lib/services/dynamodb.js"() {
    "use strict";
    var AWS2 = require_core();
    require_document_client();
    AWS2.util.update(AWS2.DynamoDB.prototype, {
      /**
       * @api private
       */
      setupRequestListeners: function setupRequestListeners(request) {
        if (request.service.config.dynamoDbCrc32) {
          request.removeListener("extractData", AWS2.EventListeners.Json.EXTRACT_DATA);
          request.addListener("extractData", this.checkCrc32);
          request.addListener("extractData", AWS2.EventListeners.Json.EXTRACT_DATA);
        }
      },
      /**
       * @api private
       */
      checkCrc32: function checkCrc32(resp) {
        if (!resp.httpResponse.streaming && !resp.request.service.crc32IsValid(resp)) {
          resp.data = null;
          resp.error = AWS2.util.error(new Error(), {
            code: "CRC32CheckFailed",
            message: "CRC32 integrity check failed",
            retryable: true
          });
          resp.request.haltHandlersOnError();
          throw resp.error;
        }
      },
      /**
       * @api private
       */
      crc32IsValid: function crc32IsValid(resp) {
        var crc = resp.httpResponse.headers["x-amz-crc32"];
        if (!crc)
          return true;
        return parseInt(crc, 10) === AWS2.util.crypto.crc32(resp.httpResponse.body);
      },
      /**
       * @api private
       */
      defaultRetryCount: 10,
      /**
       * @api private
       */
      retryDelays: function retryDelays(retryCount, err) {
        var retryDelayOptions = AWS2.util.copy(this.config.retryDelayOptions);
        if (typeof retryDelayOptions.base !== "number") {
          retryDelayOptions.base = 50;
        }
        var delay = AWS2.util.calculateRetryDelay(retryCount, retryDelayOptions, err);
        return delay;
      }
    });
  }
});

// node_modules/aws-sdk/apis/dynamodb-2011-12-05.min.json
var require_dynamodb_2011_12_05_min = __commonJS({
  "node_modules/aws-sdk/apis/dynamodb-2011-12-05.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2011-12-05",
        endpointPrefix: "dynamodb",
        jsonVersion: "1.0",
        protocol: "json",
        serviceAbbreviation: "DynamoDB",
        serviceFullName: "Amazon DynamoDB",
        serviceId: "DynamoDB",
        signatureVersion: "v4",
        targetPrefix: "DynamoDB_20111205",
        uid: "dynamodb-2011-12-05"
      },
      operations: {
        BatchGetItem: {
          input: {
            type: "structure",
            required: [
              "RequestItems"
            ],
            members: {
              RequestItems: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Responses: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    Items: {
                      shape: "Sk"
                    },
                    ConsumedCapacityUnits: {
                      type: "double"
                    }
                  }
                }
              },
              UnprocessedKeys: {
                shape: "S2"
              }
            }
          }
        },
        BatchWriteItem: {
          input: {
            type: "structure",
            required: [
              "RequestItems"
            ],
            members: {
              RequestItems: {
                shape: "So"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Responses: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    ConsumedCapacityUnits: {
                      type: "double"
                    }
                  }
                }
              },
              UnprocessedItems: {
                shape: "So"
              }
            }
          }
        },
        CreateTable: {
          input: {
            type: "structure",
            required: [
              "TableName",
              "KeySchema",
              "ProvisionedThroughput"
            ],
            members: {
              TableName: {},
              KeySchema: {
                shape: "Sy"
              },
              ProvisionedThroughput: {
                shape: "S12"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TableDescription: {
                shape: "S15"
              }
            }
          }
        },
        DeleteItem: {
          input: {
            type: "structure",
            required: [
              "TableName",
              "Key"
            ],
            members: {
              TableName: {},
              Key: {
                shape: "S6"
              },
              Expected: {
                shape: "S1b"
              },
              ReturnValues: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "Sl"
              },
              ConsumedCapacityUnits: {
                type: "double"
              }
            }
          }
        },
        DeleteTable: {
          input: {
            type: "structure",
            required: [
              "TableName"
            ],
            members: {
              TableName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TableDescription: {
                shape: "S15"
              }
            }
          }
        },
        DescribeTable: {
          input: {
            type: "structure",
            required: [
              "TableName"
            ],
            members: {
              TableName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Table: {
                shape: "S15"
              }
            }
          }
        },
        GetItem: {
          input: {
            type: "structure",
            required: [
              "TableName",
              "Key"
            ],
            members: {
              TableName: {},
              Key: {
                shape: "S6"
              },
              AttributesToGet: {
                shape: "Se"
              },
              ConsistentRead: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Item: {
                shape: "Sl"
              },
              ConsumedCapacityUnits: {
                type: "double"
              }
            }
          }
        },
        ListTables: {
          input: {
            type: "structure",
            members: {
              ExclusiveStartTableName: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TableNames: {
                type: "list",
                member: {}
              },
              LastEvaluatedTableName: {}
            }
          }
        },
        PutItem: {
          input: {
            type: "structure",
            required: [
              "TableName",
              "Item"
            ],
            members: {
              TableName: {},
              Item: {
                shape: "Ss"
              },
              Expected: {
                shape: "S1b"
              },
              ReturnValues: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "Sl"
              },
              ConsumedCapacityUnits: {
                type: "double"
              }
            }
          }
        },
        Query: {
          input: {
            type: "structure",
            required: [
              "TableName",
              "HashKeyValue"
            ],
            members: {
              TableName: {},
              AttributesToGet: {
                shape: "Se"
              },
              Limit: {
                type: "integer"
              },
              ConsistentRead: {
                type: "boolean"
              },
              Count: {
                type: "boolean"
              },
              HashKeyValue: {
                shape: "S7"
              },
              RangeKeyCondition: {
                shape: "S1u"
              },
              ScanIndexForward: {
                type: "boolean"
              },
              ExclusiveStartKey: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                shape: "Sk"
              },
              Count: {
                type: "integer"
              },
              LastEvaluatedKey: {
                shape: "S6"
              },
              ConsumedCapacityUnits: {
                type: "double"
              }
            }
          }
        },
        Scan: {
          input: {
            type: "structure",
            required: [
              "TableName"
            ],
            members: {
              TableName: {},
              AttributesToGet: {
                shape: "Se"
              },
              Limit: {
                type: "integer"
              },
              Count: {
                type: "boolean"
              },
              ScanFilter: {
                type: "map",
                key: {},
                value: {
                  shape: "S1u"
                }
              },
              ExclusiveStartKey: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                shape: "Sk"
              },
              Count: {
                type: "integer"
              },
              ScannedCount: {
                type: "integer"
              },
              LastEvaluatedKey: {
                shape: "S6"
              },
              ConsumedCapacityUnits: {
                type: "double"
              }
            }
          }
        },
        UpdateItem: {
          input: {
            type: "structure",
            required: [
              "TableName",
              "Key",
              "AttributeUpdates"
            ],
            members: {
              TableName: {},
              Key: {
                shape: "S6"
              },
              AttributeUpdates: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    Value: {
                      shape: "S7"
                    },
                    Action: {}
                  }
                }
              },
              Expected: {
                shape: "S1b"
              },
              ReturnValues: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "Sl"
              },
              ConsumedCapacityUnits: {
                type: "double"
              }
            }
          }
        },
        UpdateTable: {
          input: {
            type: "structure",
            required: [
              "TableName",
              "ProvisionedThroughput"
            ],
            members: {
              TableName: {},
              ProvisionedThroughput: {
                shape: "S12"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TableDescription: {
                shape: "S15"
              }
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "Keys"
            ],
            members: {
              Keys: {
                type: "list",
                member: {
                  shape: "S6"
                }
              },
              AttributesToGet: {
                shape: "Se"
              },
              ConsistentRead: {
                type: "boolean"
              }
            }
          }
        },
        S6: {
          type: "structure",
          required: [
            "HashKeyElement"
          ],
          members: {
            HashKeyElement: {
              shape: "S7"
            },
            RangeKeyElement: {
              shape: "S7"
            }
          }
        },
        S7: {
          type: "structure",
          members: {
            S: {},
            N: {},
            B: {
              type: "blob"
            },
            SS: {
              type: "list",
              member: {}
            },
            NS: {
              type: "list",
              member: {}
            },
            BS: {
              type: "list",
              member: {
                type: "blob"
              }
            }
          }
        },
        Se: {
          type: "list",
          member: {}
        },
        Sk: {
          type: "list",
          member: {
            shape: "Sl"
          }
        },
        Sl: {
          type: "map",
          key: {},
          value: {
            shape: "S7"
          }
        },
        So: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {
              type: "structure",
              members: {
                PutRequest: {
                  type: "structure",
                  required: [
                    "Item"
                  ],
                  members: {
                    Item: {
                      shape: "Ss"
                    }
                  }
                },
                DeleteRequest: {
                  type: "structure",
                  required: [
                    "Key"
                  ],
                  members: {
                    Key: {
                      shape: "S6"
                    }
                  }
                }
              }
            }
          }
        },
        Ss: {
          type: "map",
          key: {},
          value: {
            shape: "S7"
          }
        },
        Sy: {
          type: "structure",
          required: [
            "HashKeyElement"
          ],
          members: {
            HashKeyElement: {
              shape: "Sz"
            },
            RangeKeyElement: {
              shape: "Sz"
            }
          }
        },
        Sz: {
          type: "structure",
          required: [
            "AttributeName",
            "AttributeType"
          ],
          members: {
            AttributeName: {},
            AttributeType: {}
          }
        },
        S12: {
          type: "structure",
          required: [
            "ReadCapacityUnits",
            "WriteCapacityUnits"
          ],
          members: {
            ReadCapacityUnits: {
              type: "long"
            },
            WriteCapacityUnits: {
              type: "long"
            }
          }
        },
        S15: {
          type: "structure",
          members: {
            TableName: {},
            KeySchema: {
              shape: "Sy"
            },
            TableStatus: {},
            CreationDateTime: {
              type: "timestamp"
            },
            ProvisionedThroughput: {
              type: "structure",
              members: {
                LastIncreaseDateTime: {
                  type: "timestamp"
                },
                LastDecreaseDateTime: {
                  type: "timestamp"
                },
                NumberOfDecreasesToday: {
                  type: "long"
                },
                ReadCapacityUnits: {
                  type: "long"
                },
                WriteCapacityUnits: {
                  type: "long"
                }
              }
            },
            TableSizeBytes: {
              type: "long"
            },
            ItemCount: {
              type: "long"
            }
          }
        },
        S1b: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              Value: {
                shape: "S7"
              },
              Exists: {
                type: "boolean"
              }
            }
          }
        },
        S1u: {
          type: "structure",
          required: [
            "ComparisonOperator"
          ],
          members: {
            AttributeValueList: {
              type: "list",
              member: {
                shape: "S7"
              }
            },
            ComparisonOperator: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/dynamodb-2011-12-05.paginators.json
var require_dynamodb_2011_12_05_paginators = __commonJS({
  "node_modules/aws-sdk/apis/dynamodb-2011-12-05.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        BatchGetItem: {
          input_token: "RequestItems",
          output_token: "UnprocessedKeys"
        },
        ListTables: {
          input_token: "ExclusiveStartTableName",
          limit_key: "Limit",
          output_token: "LastEvaluatedTableName",
          result_key: "TableNames"
        },
        Query: {
          input_token: "ExclusiveStartKey",
          limit_key: "Limit",
          output_token: "LastEvaluatedKey",
          result_key: "Items"
        },
        Scan: {
          input_token: "ExclusiveStartKey",
          limit_key: "Limit",
          output_token: "LastEvaluatedKey",
          result_key: "Items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/dynamodb-2011-12-05.waiters2.json
var require_dynamodb_2011_12_05_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/dynamodb-2011-12-05.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        TableExists: {
          delay: 20,
          operation: "DescribeTable",
          maxAttempts: 25,
          acceptors: [
            {
              expected: "ACTIVE",
              matcher: "path",
              state: "success",
              argument: "Table.TableStatus"
            },
            {
              expected: "ResourceNotFoundException",
              matcher: "error",
              state: "retry"
            }
          ]
        },
        TableNotExists: {
          delay: 20,
          operation: "DescribeTable",
          maxAttempts: 25,
          acceptors: [
            {
              expected: "ResourceNotFoundException",
              matcher: "error",
              state: "success"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/dynamodb-2012-08-10.min.json
var require_dynamodb_2012_08_10_min = __commonJS({
  "node_modules/aws-sdk/apis/dynamodb-2012-08-10.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2012-08-10",
        endpointPrefix: "dynamodb",
        jsonVersion: "1.0",
        protocol: "json",
        serviceAbbreviation: "DynamoDB",
        serviceFullName: "Amazon DynamoDB",
        serviceId: "DynamoDB",
        signatureVersion: "v4",
        targetPrefix: "DynamoDB_20120810",
        uid: "dynamodb-2012-08-10"
      },
      operations: {
        BatchExecuteStatement: {
          input: {
            type: "structure",
            required: [
              "Statements"
            ],
            members: {
              Statements: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Statement"
                  ],
                  members: {
                    Statement: {},
                    Parameters: {
                      shape: "S5"
                    },
                    ConsistentRead: {
                      type: "boolean"
                    },
                    ReturnValuesOnConditionCheckFailure: {}
                  }
                }
              },
              ReturnConsumedCapacity: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Responses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Error: {
                      type: "structure",
                      members: {
                        Code: {},
                        Message: {},
                        Item: {
                          shape: "Sr"
                        }
                      }
                    },
                    TableName: {},
                    Item: {
                      shape: "Sr"
                    }
                  }
                }
              },
              ConsumedCapacity: {
                shape: "St"
              }
            }
          }
        },
        BatchGetItem: {
          input: {
            type: "structure",
            required: [
              "RequestItems"
            ],
            members: {
              RequestItems: {
                shape: "S10"
              },
              ReturnConsumedCapacity: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Responses: {
                type: "map",
                key: {},
                value: {
                  shape: "S1a"
                }
              },
              UnprocessedKeys: {
                shape: "S10"
              },
              ConsumedCapacity: {
                shape: "St"
              }
            }
          },
          endpointdiscovery: {}
        },
        BatchWriteItem: {
          input: {
            type: "structure",
            required: [
              "RequestItems"
            ],
            members: {
              RequestItems: {
                shape: "S1c"
              },
              ReturnConsumedCapacity: {},
              ReturnItemCollectionMetrics: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UnprocessedItems: {
                shape: "S1c"
              },
              ItemCollectionMetrics: {
                shape: "S1k"
              },
              ConsumedCapacity: {
                shape: "St"
              }
            }
          },
          endpointdiscovery: {}
        },
        CreateBackup: {
          input: {
            type: "structure",
            required: [
              "TableName",
              "BackupName"
            ],
            members: {
              TableName: {},
              BackupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BackupDetails: {
                shape: "S1t"
              }
            }
          },
          endpointdiscovery: {}
        },
        CreateGlobalTable: {
          input: {
            type: "structure",
            required: [
              "GlobalTableName",
              "ReplicationGroup"
            ],
            members: {
              GlobalTableName: {},
              ReplicationGroup: {
                shape: "S21"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GlobalTableDescription: {
                shape: "S25"
              }
            }
          },
          endpointdiscovery: {}
        },
        CreateTable: {
          input: {
            type: "structure",
            required: [
              "AttributeDefinitions",
              "TableName",
              "KeySchema"
            ],
            members: {
              AttributeDefinitions: {
                shape: "S2l"
              },
              TableName: {},
              KeySchema: {
                shape: "S2p"
              },
              LocalSecondaryIndexes: {
                shape: "S2s"
              },
              GlobalSecondaryIndexes: {
                shape: "S2y"
              },
              BillingMode: {},
              ProvisionedThroughput: {
                shape: "S30"
              },
              StreamSpecification: {
                shape: "S32"
              },
              SSESpecification: {
                shape: "S35"
              },
              Tags: {
                shape: "S38"
              },
              TableClass: {},
              DeletionProtectionEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TableDescription: {
                shape: "S3e"
              }
            }
          },
          endpointdiscovery: {}
        },
        DeleteBackup: {
          input: {
            type: "structure",
            required: [
              "BackupArn"
            ],
            members: {
              BackupArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BackupDescription: {
                shape: "S42"
              }
            }
          },
          endpointdiscovery: {}
        },
        DeleteItem: {
          input: {
            type: "structure",
            required: [
              "TableName",
              "Key"
            ],
            members: {
              TableName: {},
              Key: {
                shape: "S13"
              },
              Expected: {
                shape: "S4f"
              },
              ConditionalOperator: {},
              ReturnValues: {},
              ReturnConsumedCapacity: {},
              ReturnItemCollectionMetrics: {},
              ConditionExpression: {},
              ExpressionAttributeNames: {
                shape: "S16"
              },
              ExpressionAttributeValues: {
                shape: "S4n"
              },
              ReturnValuesOnConditionCheckFailure: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "Sr"
              },
              ConsumedCapacity: {
                shape: "Su"
              },
              ItemCollectionMetrics: {
                shape: "S1m"
              }
            }
          },
          endpointdiscovery: {}
        },
        DeleteTable: {
          input: {
            type: "structure",
            required: [
              "TableName"
            ],
            members: {
              TableName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TableDescription: {
                shape: "S3e"
              }
            }
          },
          endpointdiscovery: {}
        },
        DescribeBackup: {
          input: {
            type: "structure",
            required: [
              "BackupArn"
            ],
            members: {
              BackupArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BackupDescription: {
                shape: "S42"
              }
            }
          },
          endpointdiscovery: {}
        },
        DescribeContinuousBackups: {
          input: {
            type: "structure",
            required: [
              "TableName"
            ],
            members: {
              TableName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ContinuousBackupsDescription: {
                shape: "S4w"
              }
            }
          },
          endpointdiscovery: {}
        },
        DescribeContributorInsights: {
          input: {
            type: "structure",
            required: [
              "TableName"
            ],
            members: {
              TableName: {},
              IndexName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TableName: {},
              IndexName: {},
              ContributorInsightsRuleList: {
                type: "list",
                member: {}
              },
              ContributorInsightsStatus: {},
              LastUpdateDateTime: {
                type: "timestamp"
              },
              FailureException: {
                type: "structure",
                members: {
                  ExceptionName: {},
                  ExceptionDescription: {}
                }
              }
            }
          }
        },
        DescribeEndpoints: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "Endpoints"
            ],
            members: {
              Endpoints: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Address",
                    "CachePeriodInMinutes"
                  ],
                  members: {
                    Address: {},
                    CachePeriodInMinutes: {
                      type: "long"
                    }
                  }
                }
              }
            }
          },
          endpointoperation: true
        },
        DescribeExport: {
          input: {
            type: "structure",
            required: [
              "ExportArn"
            ],
            members: {
              ExportArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ExportDescription: {
                shape: "S5h"
              }
            }
          }
        },
        DescribeGlobalTable: {
          input: {
            type: "structure",
            required: [
              "GlobalTableName"
            ],
            members: {
              GlobalTableName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GlobalTableDescription: {
                shape: "S25"
              }
            }
          },
          endpointdiscovery: {}
        },
        DescribeGlobalTableSettings: {
          input: {
            type: "structure",
            required: [
              "GlobalTableName"
            ],
            members: {
              GlobalTableName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GlobalTableName: {},
              ReplicaSettings: {
                shape: "S66"
              }
            }
          },
          endpointdiscovery: {}
        },
        DescribeImport: {
          input: {
            type: "structure",
            required: [
              "ImportArn"
            ],
            members: {
              ImportArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ImportTableDescription"
            ],
            members: {
              ImportTableDescription: {
                shape: "S6k"
              }
            }
          }
        },
        DescribeKinesisStreamingDestination: {
          input: {
            type: "structure",
            required: [
              "TableName"
            ],
            members: {
              TableName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TableName: {},
              KinesisDataStreamDestinations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StreamArn: {},
                    DestinationStatus: {},
                    DestinationStatusDescription: {}
                  }
                }
              }
            }
          },
          endpointdiscovery: {}
        },
        DescribeLimits: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              AccountMaxReadCapacityUnits: {
                type: "long"
              },
              AccountMaxWriteCapacityUnits: {
                type: "long"
              },
              TableMaxReadCapacityUnits: {
                type: "long"
              },
              TableMaxWriteCapacityUnits: {
                type: "long"
              }
            }
          },
          endpointdiscovery: {}
        },
        DescribeTable: {
          input: {
            type: "structure",
            required: [
              "TableName"
            ],
            members: {
              TableName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Table: {
                shape: "S3e"
              }
            }
          },
          endpointdiscovery: {}
        },
        DescribeTableReplicaAutoScaling: {
          input: {
            type: "structure",
            required: [
              "TableName"
            ],
            members: {
              TableName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TableAutoScalingDescription: {
                shape: "S7c"
              }
            }
          }
        },
        DescribeTimeToLive: {
          input: {
            type: "structure",
            required: [
              "TableName"
            ],
            members: {
              TableName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TimeToLiveDescription: {
                shape: "S4b"
              }
            }
          },
          endpointdiscovery: {}
        },
        DisableKinesisStreamingDestination: {
          input: {
            shape: "S7j"
          },
          output: {
            shape: "S7k"
          },
          endpointdiscovery: {}
        },
        EnableKinesisStreamingDestination: {
          input: {
            shape: "S7j"
          },
          output: {
            shape: "S7k"
          },
          endpointdiscovery: {}
        },
        ExecuteStatement: {
          input: {
            type: "structure",
            required: [
              "Statement"
            ],
            members: {
              Statement: {},
              Parameters: {
                shape: "S5"
              },
              ConsistentRead: {
                type: "boolean"
              },
              NextToken: {},
              ReturnConsumedCapacity: {},
              Limit: {
                type: "integer"
              },
              ReturnValuesOnConditionCheckFailure: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                shape: "S1a"
              },
              NextToken: {},
              ConsumedCapacity: {
                shape: "Su"
              },
              LastEvaluatedKey: {
                shape: "S13"
              }
            }
          }
        },
        ExecuteTransaction: {
          input: {
            type: "structure",
            required: [
              "TransactStatements"
            ],
            members: {
              TransactStatements: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Statement"
                  ],
                  members: {
                    Statement: {},
                    Parameters: {
                      shape: "S5"
                    },
                    ReturnValuesOnConditionCheckFailure: {}
                  }
                }
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              ReturnConsumedCapacity: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Responses: {
                shape: "S7u"
              },
              ConsumedCapacity: {
                shape: "St"
              }
            }
          }
        },
        ExportTableToPointInTime: {
          input: {
            type: "structure",
            required: [
              "TableArn",
              "S3Bucket"
            ],
            members: {
              TableArn: {},
              ExportTime: {
                type: "timestamp"
              },
              ClientToken: {
                idempotencyToken: true
              },
              S3Bucket: {},
              S3BucketOwner: {},
              S3Prefix: {},
              S3SseAlgorithm: {},
              S3SseKmsKeyId: {},
              ExportFormat: {},
              ExportType: {},
              IncrementalExportSpecification: {
                shape: "S5y"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ExportDescription: {
                shape: "S5h"
              }
            }
          }
        },
        GetItem: {
          input: {
            type: "structure",
            required: [
              "TableName",
              "Key"
            ],
            members: {
              TableName: {},
              Key: {
                shape: "S13"
              },
              AttributesToGet: {
                shape: "S14"
              },
              ConsistentRead: {
                type: "boolean"
              },
              ReturnConsumedCapacity: {},
              ProjectionExpression: {},
              ExpressionAttributeNames: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Item: {
                shape: "Sr"
              },
              ConsumedCapacity: {
                shape: "Su"
              }
            }
          },
          endpointdiscovery: {}
        },
        ImportTable: {
          input: {
            type: "structure",
            required: [
              "S3BucketSource",
              "InputFormat",
              "TableCreationParameters"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              S3BucketSource: {
                shape: "S6m"
              },
              InputFormat: {},
              InputFormatOptions: {
                shape: "S6q"
              },
              InputCompressionType: {},
              TableCreationParameters: {
                shape: "S6w"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ImportTableDescription"
            ],
            members: {
              ImportTableDescription: {
                shape: "S6k"
              }
            }
          }
        },
        ListBackups: {
          input: {
            type: "structure",
            members: {
              TableName: {},
              Limit: {
                type: "integer"
              },
              TimeRangeLowerBound: {
                type: "timestamp"
              },
              TimeRangeUpperBound: {
                type: "timestamp"
              },
              ExclusiveStartBackupArn: {},
              BackupType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BackupSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TableName: {},
                    TableId: {},
                    TableArn: {},
                    BackupArn: {},
                    BackupName: {},
                    BackupCreationDateTime: {
                      type: "timestamp"
                    },
                    BackupExpiryDateTime: {
                      type: "timestamp"
                    },
                    BackupStatus: {},
                    BackupType: {},
                    BackupSizeBytes: {
                      type: "long"
                    }
                  }
                }
              },
              LastEvaluatedBackupArn: {}
            }
          },
          endpointdiscovery: {}
        },
        ListContributorInsights: {
          input: {
            type: "structure",
            members: {
              TableName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContributorInsightsSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TableName: {},
                    IndexName: {},
                    ContributorInsightsStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListExports: {
          input: {
            type: "structure",
            members: {
              TableArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ExportSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ExportArn: {},
                    ExportStatus: {},
                    ExportType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListGlobalTables: {
          input: {
            type: "structure",
            members: {
              ExclusiveStartGlobalTableName: {},
              Limit: {
                type: "integer"
              },
              RegionName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GlobalTables: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    GlobalTableName: {},
                    ReplicationGroup: {
                      shape: "S21"
                    }
                  }
                }
              },
              LastEvaluatedGlobalTableName: {}
            }
          },
          endpointdiscovery: {}
        },
        ListImports: {
          input: {
            type: "structure",
            members: {
              TableArn: {},
              PageSize: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ImportSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ImportArn: {},
                    ImportStatus: {},
                    TableArn: {},
                    S3BucketSource: {
                      shape: "S6m"
                    },
                    CloudWatchLogGroupArn: {},
                    InputFormat: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTables: {
          input: {
            type: "structure",
            members: {
              ExclusiveStartTableName: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TableNames: {
                type: "list",
                member: {}
              },
              LastEvaluatedTableName: {}
            }
          },
          endpointdiscovery: {}
        },
        ListTagsOfResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S38"
              },
              NextToken: {}
            }
          },
          endpointdiscovery: {}
        },
        PutItem: {
          input: {
            type: "structure",
            required: [
              "TableName",
              "Item"
            ],
            members: {
              TableName: {},
              Item: {
                shape: "S1g"
              },
              Expected: {
                shape: "S4f"
              },
              ReturnValues: {},
              ReturnConsumedCapacity: {},
              ReturnItemCollectionMetrics: {},
              ConditionalOperator: {},
              ConditionExpression: {},
              ExpressionAttributeNames: {
                shape: "S16"
              },
              ExpressionAttributeValues: {
                shape: "S4n"
              },
              ReturnValuesOnConditionCheckFailure: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "Sr"
              },
              ConsumedCapacity: {
                shape: "Su"
              },
              ItemCollectionMetrics: {
                shape: "S1m"
              }
            }
          },
          endpointdiscovery: {}
        },
        Query: {
          input: {
            type: "structure",
            required: [
              "TableName"
            ],
            members: {
              TableName: {},
              IndexName: {},
              Select: {},
              AttributesToGet: {
                shape: "S14"
              },
              Limit: {
                type: "integer"
              },
              ConsistentRead: {
                type: "boolean"
              },
              KeyConditions: {
                type: "map",
                key: {},
                value: {
                  shape: "S98"
                }
              },
              QueryFilter: {
                shape: "S99"
              },
              ConditionalOperator: {},
              ScanIndexForward: {
                type: "boolean"
              },
              ExclusiveStartKey: {
                shape: "S13"
              },
              ReturnConsumedCapacity: {},
              ProjectionExpression: {},
              FilterExpression: {},
              KeyConditionExpression: {},
              ExpressionAttributeNames: {
                shape: "S16"
              },
              ExpressionAttributeValues: {
                shape: "S4n"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                shape: "S1a"
              },
              Count: {
                type: "integer"
              },
              ScannedCount: {
                type: "integer"
              },
              LastEvaluatedKey: {
                shape: "S13"
              },
              ConsumedCapacity: {
                shape: "Su"
              }
            }
          },
          endpointdiscovery: {}
        },
        RestoreTableFromBackup: {
          input: {
            type: "structure",
            required: [
              "TargetTableName",
              "BackupArn"
            ],
            members: {
              TargetTableName: {},
              BackupArn: {},
              BillingModeOverride: {},
              GlobalSecondaryIndexOverride: {
                shape: "S2y"
              },
              LocalSecondaryIndexOverride: {
                shape: "S2s"
              },
              ProvisionedThroughputOverride: {
                shape: "S30"
              },
              SSESpecificationOverride: {
                shape: "S35"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TableDescription: {
                shape: "S3e"
              }
            }
          },
          endpointdiscovery: {}
        },
        RestoreTableToPointInTime: {
          input: {
            type: "structure",
            required: [
              "TargetTableName"
            ],
            members: {
              SourceTableArn: {},
              SourceTableName: {},
              TargetTableName: {},
              UseLatestRestorableTime: {
                type: "boolean"
              },
              RestoreDateTime: {
                type: "timestamp"
              },
              BillingModeOverride: {},
              GlobalSecondaryIndexOverride: {
                shape: "S2y"
              },
              LocalSecondaryIndexOverride: {
                shape: "S2s"
              },
              ProvisionedThroughputOverride: {
                shape: "S30"
              },
              SSESpecificationOverride: {
                shape: "S35"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TableDescription: {
                shape: "S3e"
              }
            }
          },
          endpointdiscovery: {}
        },
        Scan: {
          input: {
            type: "structure",
            required: [
              "TableName"
            ],
            members: {
              TableName: {},
              IndexName: {},
              AttributesToGet: {
                shape: "S14"
              },
              Limit: {
                type: "integer"
              },
              Select: {},
              ScanFilter: {
                shape: "S99"
              },
              ConditionalOperator: {},
              ExclusiveStartKey: {
                shape: "S13"
              },
              ReturnConsumedCapacity: {},
              TotalSegments: {
                type: "integer"
              },
              Segment: {
                type: "integer"
              },
              ProjectionExpression: {},
              FilterExpression: {},
              ExpressionAttributeNames: {
                shape: "S16"
              },
              ExpressionAttributeValues: {
                shape: "S4n"
              },
              ConsistentRead: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                shape: "S1a"
              },
              Count: {
                type: "integer"
              },
              ScannedCount: {
                type: "integer"
              },
              LastEvaluatedKey: {
                shape: "S13"
              },
              ConsumedCapacity: {
                shape: "Su"
              }
            }
          },
          endpointdiscovery: {}
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S38"
              }
            }
          },
          endpointdiscovery: {}
        },
        TransactGetItems: {
          input: {
            type: "structure",
            required: [
              "TransactItems"
            ],
            members: {
              TransactItems: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Get"
                  ],
                  members: {
                    Get: {
                      type: "structure",
                      required: [
                        "Key",
                        "TableName"
                      ],
                      members: {
                        Key: {
                          shape: "S13"
                        },
                        TableName: {},
                        ProjectionExpression: {},
                        ExpressionAttributeNames: {
                          shape: "S16"
                        }
                      }
                    }
                  }
                }
              },
              ReturnConsumedCapacity: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConsumedCapacity: {
                shape: "St"
              },
              Responses: {
                shape: "S7u"
              }
            }
          },
          endpointdiscovery: {}
        },
        TransactWriteItems: {
          input: {
            type: "structure",
            required: [
              "TransactItems"
            ],
            members: {
              TransactItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ConditionCheck: {
                      type: "structure",
                      required: [
                        "Key",
                        "TableName",
                        "ConditionExpression"
                      ],
                      members: {
                        Key: {
                          shape: "S13"
                        },
                        TableName: {},
                        ConditionExpression: {},
                        ExpressionAttributeNames: {
                          shape: "S16"
                        },
                        ExpressionAttributeValues: {
                          shape: "S4n"
                        },
                        ReturnValuesOnConditionCheckFailure: {}
                      }
                    },
                    Put: {
                      type: "structure",
                      required: [
                        "Item",
                        "TableName"
                      ],
                      members: {
                        Item: {
                          shape: "S1g"
                        },
                        TableName: {},
                        ConditionExpression: {},
                        ExpressionAttributeNames: {
                          shape: "S16"
                        },
                        ExpressionAttributeValues: {
                          shape: "S4n"
                        },
                        ReturnValuesOnConditionCheckFailure: {}
                      }
                    },
                    Delete: {
                      type: "structure",
                      required: [
                        "Key",
                        "TableName"
                      ],
                      members: {
                        Key: {
                          shape: "S13"
                        },
                        TableName: {},
                        ConditionExpression: {},
                        ExpressionAttributeNames: {
                          shape: "S16"
                        },
                        ExpressionAttributeValues: {
                          shape: "S4n"
                        },
                        ReturnValuesOnConditionCheckFailure: {}
                      }
                    },
                    Update: {
                      type: "structure",
                      required: [
                        "Key",
                        "UpdateExpression",
                        "TableName"
                      ],
                      members: {
                        Key: {
                          shape: "S13"
                        },
                        UpdateExpression: {},
                        TableName: {},
                        ConditionExpression: {},
                        ExpressionAttributeNames: {
                          shape: "S16"
                        },
                        ExpressionAttributeValues: {
                          shape: "S4n"
                        },
                        ReturnValuesOnConditionCheckFailure: {}
                      }
                    }
                  }
                }
              },
              ReturnConsumedCapacity: {},
              ReturnItemCollectionMetrics: {},
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConsumedCapacity: {
                shape: "St"
              },
              ItemCollectionMetrics: {
                shape: "S1k"
              }
            }
          },
          endpointdiscovery: {}
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          endpointdiscovery: {}
        },
        UpdateContinuousBackups: {
          input: {
            type: "structure",
            required: [
              "TableName",
              "PointInTimeRecoverySpecification"
            ],
            members: {
              TableName: {},
              PointInTimeRecoverySpecification: {
                type: "structure",
                required: [
                  "PointInTimeRecoveryEnabled"
                ],
                members: {
                  PointInTimeRecoveryEnabled: {
                    type: "boolean"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContinuousBackupsDescription: {
                shape: "S4w"
              }
            }
          },
          endpointdiscovery: {}
        },
        UpdateContributorInsights: {
          input: {
            type: "structure",
            required: [
              "TableName",
              "ContributorInsightsAction"
            ],
            members: {
              TableName: {},
              IndexName: {},
              ContributorInsightsAction: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TableName: {},
              IndexName: {},
              ContributorInsightsStatus: {}
            }
          }
        },
        UpdateGlobalTable: {
          input: {
            type: "structure",
            required: [
              "GlobalTableName",
              "ReplicaUpdates"
            ],
            members: {
              GlobalTableName: {},
              ReplicaUpdates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Create: {
                      type: "structure",
                      required: [
                        "RegionName"
                      ],
                      members: {
                        RegionName: {}
                      }
                    },
                    Delete: {
                      type: "structure",
                      required: [
                        "RegionName"
                      ],
                      members: {
                        RegionName: {}
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GlobalTableDescription: {
                shape: "S25"
              }
            }
          },
          endpointdiscovery: {}
        },
        UpdateGlobalTableSettings: {
          input: {
            type: "structure",
            required: [
              "GlobalTableName"
            ],
            members: {
              GlobalTableName: {},
              GlobalTableBillingMode: {},
              GlobalTableProvisionedWriteCapacityUnits: {
                type: "long"
              },
              GlobalTableProvisionedWriteCapacityAutoScalingSettingsUpdate: {
                shape: "Saf"
              },
              GlobalTableGlobalSecondaryIndexSettingsUpdate: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "IndexName"
                  ],
                  members: {
                    IndexName: {},
                    ProvisionedWriteCapacityUnits: {
                      type: "long"
                    },
                    ProvisionedWriteCapacityAutoScalingSettingsUpdate: {
                      shape: "Saf"
                    }
                  }
                }
              },
              ReplicaSettingsUpdate: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "RegionName"
                  ],
                  members: {
                    RegionName: {},
                    ReplicaProvisionedReadCapacityUnits: {
                      type: "long"
                    },
                    ReplicaProvisionedReadCapacityAutoScalingSettingsUpdate: {
                      shape: "Saf"
                    },
                    ReplicaGlobalSecondaryIndexSettingsUpdate: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "IndexName"
                        ],
                        members: {
                          IndexName: {},
                          ProvisionedReadCapacityUnits: {
                            type: "long"
                          },
                          ProvisionedReadCapacityAutoScalingSettingsUpdate: {
                            shape: "Saf"
                          }
                        }
                      }
                    },
                    ReplicaTableClass: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GlobalTableName: {},
              ReplicaSettings: {
                shape: "S66"
              }
            }
          },
          endpointdiscovery: {}
        },
        UpdateItem: {
          input: {
            type: "structure",
            required: [
              "TableName",
              "Key"
            ],
            members: {
              TableName: {},
              Key: {
                shape: "S13"
              },
              AttributeUpdates: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    Value: {
                      shape: "S6"
                    },
                    Action: {}
                  }
                }
              },
              Expected: {
                shape: "S4f"
              },
              ConditionalOperator: {},
              ReturnValues: {},
              ReturnConsumedCapacity: {},
              ReturnItemCollectionMetrics: {},
              UpdateExpression: {},
              ConditionExpression: {},
              ExpressionAttributeNames: {
                shape: "S16"
              },
              ExpressionAttributeValues: {
                shape: "S4n"
              },
              ReturnValuesOnConditionCheckFailure: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "Sr"
              },
              ConsumedCapacity: {
                shape: "Su"
              },
              ItemCollectionMetrics: {
                shape: "S1m"
              }
            }
          },
          endpointdiscovery: {}
        },
        UpdateTable: {
          input: {
            type: "structure",
            required: [
              "TableName"
            ],
            members: {
              AttributeDefinitions: {
                shape: "S2l"
              },
              TableName: {},
              BillingMode: {},
              ProvisionedThroughput: {
                shape: "S30"
              },
              GlobalSecondaryIndexUpdates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Update: {
                      type: "structure",
                      required: [
                        "IndexName",
                        "ProvisionedThroughput"
                      ],
                      members: {
                        IndexName: {},
                        ProvisionedThroughput: {
                          shape: "S30"
                        }
                      }
                    },
                    Create: {
                      type: "structure",
                      required: [
                        "IndexName",
                        "KeySchema",
                        "Projection"
                      ],
                      members: {
                        IndexName: {},
                        KeySchema: {
                          shape: "S2p"
                        },
                        Projection: {
                          shape: "S2u"
                        },
                        ProvisionedThroughput: {
                          shape: "S30"
                        }
                      }
                    },
                    Delete: {
                      type: "structure",
                      required: [
                        "IndexName"
                      ],
                      members: {
                        IndexName: {}
                      }
                    }
                  }
                }
              },
              StreamSpecification: {
                shape: "S32"
              },
              SSESpecification: {
                shape: "S35"
              },
              ReplicaUpdates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Create: {
                      type: "structure",
                      required: [
                        "RegionName"
                      ],
                      members: {
                        RegionName: {},
                        KMSMasterKeyId: {},
                        ProvisionedThroughputOverride: {
                          shape: "S2c"
                        },
                        GlobalSecondaryIndexes: {
                          shape: "Sb4"
                        },
                        TableClassOverride: {}
                      }
                    },
                    Update: {
                      type: "structure",
                      required: [
                        "RegionName"
                      ],
                      members: {
                        RegionName: {},
                        KMSMasterKeyId: {},
                        ProvisionedThroughputOverride: {
                          shape: "S2c"
                        },
                        GlobalSecondaryIndexes: {
                          shape: "Sb4"
                        },
                        TableClassOverride: {}
                      }
                    },
                    Delete: {
                      type: "structure",
                      required: [
                        "RegionName"
                      ],
                      members: {
                        RegionName: {}
                      }
                    }
                  }
                }
              },
              TableClass: {},
              DeletionProtectionEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TableDescription: {
                shape: "S3e"
              }
            }
          },
          endpointdiscovery: {}
        },
        UpdateTableReplicaAutoScaling: {
          input: {
            type: "structure",
            required: [
              "TableName"
            ],
            members: {
              GlobalSecondaryIndexUpdates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    IndexName: {},
                    ProvisionedWriteCapacityAutoScalingUpdate: {
                      shape: "Saf"
                    }
                  }
                }
              },
              TableName: {},
              ProvisionedWriteCapacityAutoScalingUpdate: {
                shape: "Saf"
              },
              ReplicaUpdates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "RegionName"
                  ],
                  members: {
                    RegionName: {},
                    ReplicaGlobalSecondaryIndexUpdates: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          IndexName: {},
                          ProvisionedReadCapacityAutoScalingUpdate: {
                            shape: "Saf"
                          }
                        }
                      }
                    },
                    ReplicaProvisionedReadCapacityAutoScalingUpdate: {
                      shape: "Saf"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TableAutoScalingDescription: {
                shape: "S7c"
              }
            }
          }
        },
        UpdateTimeToLive: {
          input: {
            type: "structure",
            required: [
              "TableName",
              "TimeToLiveSpecification"
            ],
            members: {
              TableName: {},
              TimeToLiveSpecification: {
                shape: "Sbi"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TimeToLiveSpecification: {
                shape: "Sbi"
              }
            }
          },
          endpointdiscovery: {}
        }
      },
      shapes: {
        S5: {
          type: "list",
          member: {
            shape: "S6"
          }
        },
        S6: {
          type: "structure",
          members: {
            S: {},
            N: {},
            B: {
              type: "blob"
            },
            SS: {
              type: "list",
              member: {}
            },
            NS: {
              type: "list",
              member: {}
            },
            BS: {
              type: "list",
              member: {
                type: "blob"
              }
            },
            M: {
              type: "map",
              key: {},
              value: {
                shape: "S6"
              }
            },
            L: {
              type: "list",
              member: {
                shape: "S6"
              }
            },
            NULL: {
              type: "boolean"
            },
            BOOL: {
              type: "boolean"
            }
          }
        },
        Sr: {
          type: "map",
          key: {},
          value: {
            shape: "S6"
          }
        },
        St: {
          type: "list",
          member: {
            shape: "Su"
          }
        },
        Su: {
          type: "structure",
          members: {
            TableName: {},
            CapacityUnits: {
              type: "double"
            },
            ReadCapacityUnits: {
              type: "double"
            },
            WriteCapacityUnits: {
              type: "double"
            },
            Table: {
              shape: "Sw"
            },
            LocalSecondaryIndexes: {
              shape: "Sx"
            },
            GlobalSecondaryIndexes: {
              shape: "Sx"
            }
          }
        },
        Sw: {
          type: "structure",
          members: {
            ReadCapacityUnits: {
              type: "double"
            },
            WriteCapacityUnits: {
              type: "double"
            },
            CapacityUnits: {
              type: "double"
            }
          }
        },
        Sx: {
          type: "map",
          key: {},
          value: {
            shape: "Sw"
          }
        },
        S10: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "Keys"
            ],
            members: {
              Keys: {
                type: "list",
                member: {
                  shape: "S13"
                }
              },
              AttributesToGet: {
                shape: "S14"
              },
              ConsistentRead: {
                type: "boolean"
              },
              ProjectionExpression: {},
              ExpressionAttributeNames: {
                shape: "S16"
              }
            }
          }
        },
        S13: {
          type: "map",
          key: {},
          value: {
            shape: "S6"
          }
        },
        S14: {
          type: "list",
          member: {}
        },
        S16: {
          type: "map",
          key: {},
          value: {}
        },
        S1a: {
          type: "list",
          member: {
            shape: "Sr"
          }
        },
        S1c: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {
              type: "structure",
              members: {
                PutRequest: {
                  type: "structure",
                  required: [
                    "Item"
                  ],
                  members: {
                    Item: {
                      shape: "S1g"
                    }
                  }
                },
                DeleteRequest: {
                  type: "structure",
                  required: [
                    "Key"
                  ],
                  members: {
                    Key: {
                      shape: "S13"
                    }
                  }
                }
              }
            }
          }
        },
        S1g: {
          type: "map",
          key: {},
          value: {
            shape: "S6"
          }
        },
        S1k: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {
              shape: "S1m"
            }
          }
        },
        S1m: {
          type: "structure",
          members: {
            ItemCollectionKey: {
              type: "map",
              key: {},
              value: {
                shape: "S6"
              }
            },
            SizeEstimateRangeGB: {
              type: "list",
              member: {
                type: "double"
              }
            }
          }
        },
        S1t: {
          type: "structure",
          required: [
            "BackupArn",
            "BackupName",
            "BackupStatus",
            "BackupType",
            "BackupCreationDateTime"
          ],
          members: {
            BackupArn: {},
            BackupName: {},
            BackupSizeBytes: {
              type: "long"
            },
            BackupStatus: {},
            BackupType: {},
            BackupCreationDateTime: {
              type: "timestamp"
            },
            BackupExpiryDateTime: {
              type: "timestamp"
            }
          }
        },
        S21: {
          type: "list",
          member: {
            type: "structure",
            members: {
              RegionName: {}
            }
          }
        },
        S25: {
          type: "structure",
          members: {
            ReplicationGroup: {
              shape: "S26"
            },
            GlobalTableArn: {},
            CreationDateTime: {
              type: "timestamp"
            },
            GlobalTableStatus: {},
            GlobalTableName: {}
          }
        },
        S26: {
          type: "list",
          member: {
            type: "structure",
            members: {
              RegionName: {},
              ReplicaStatus: {},
              ReplicaStatusDescription: {},
              ReplicaStatusPercentProgress: {},
              KMSMasterKeyId: {},
              ProvisionedThroughputOverride: {
                shape: "S2c"
              },
              GlobalSecondaryIndexes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    IndexName: {},
                    ProvisionedThroughputOverride: {
                      shape: "S2c"
                    }
                  }
                }
              },
              ReplicaInaccessibleDateTime: {
                type: "timestamp"
              },
              ReplicaTableClassSummary: {
                shape: "S2g"
              }
            }
          }
        },
        S2c: {
          type: "structure",
          members: {
            ReadCapacityUnits: {
              type: "long"
            }
          }
        },
        S2g: {
          type: "structure",
          members: {
            TableClass: {},
            LastUpdateDateTime: {
              type: "timestamp"
            }
          }
        },
        S2l: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AttributeName",
              "AttributeType"
            ],
            members: {
              AttributeName: {},
              AttributeType: {}
            }
          }
        },
        S2p: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AttributeName",
              "KeyType"
            ],
            members: {
              AttributeName: {},
              KeyType: {}
            }
          }
        },
        S2s: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "IndexName",
              "KeySchema",
              "Projection"
            ],
            members: {
              IndexName: {},
              KeySchema: {
                shape: "S2p"
              },
              Projection: {
                shape: "S2u"
              }
            }
          }
        },
        S2u: {
          type: "structure",
          members: {
            ProjectionType: {},
            NonKeyAttributes: {
              type: "list",
              member: {}
            }
          }
        },
        S2y: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "IndexName",
              "KeySchema",
              "Projection"
            ],
            members: {
              IndexName: {},
              KeySchema: {
                shape: "S2p"
              },
              Projection: {
                shape: "S2u"
              },
              ProvisionedThroughput: {
                shape: "S30"
              }
            }
          }
        },
        S30: {
          type: "structure",
          required: [
            "ReadCapacityUnits",
            "WriteCapacityUnits"
          ],
          members: {
            ReadCapacityUnits: {
              type: "long"
            },
            WriteCapacityUnits: {
              type: "long"
            }
          }
        },
        S32: {
          type: "structure",
          required: [
            "StreamEnabled"
          ],
          members: {
            StreamEnabled: {
              type: "boolean"
            },
            StreamViewType: {}
          }
        },
        S35: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            SSEType: {},
            KMSMasterKeyId: {}
          }
        },
        S38: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S3e: {
          type: "structure",
          members: {
            AttributeDefinitions: {
              shape: "S2l"
            },
            TableName: {},
            KeySchema: {
              shape: "S2p"
            },
            TableStatus: {},
            CreationDateTime: {
              type: "timestamp"
            },
            ProvisionedThroughput: {
              shape: "S3g"
            },
            TableSizeBytes: {
              type: "long"
            },
            ItemCount: {
              type: "long"
            },
            TableArn: {},
            TableId: {},
            BillingModeSummary: {
              shape: "S3k"
            },
            LocalSecondaryIndexes: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  IndexName: {},
                  KeySchema: {
                    shape: "S2p"
                  },
                  Projection: {
                    shape: "S2u"
                  },
                  IndexSizeBytes: {
                    type: "long"
                  },
                  ItemCount: {
                    type: "long"
                  },
                  IndexArn: {}
                }
              }
            },
            GlobalSecondaryIndexes: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  IndexName: {},
                  KeySchema: {
                    shape: "S2p"
                  },
                  Projection: {
                    shape: "S2u"
                  },
                  IndexStatus: {},
                  Backfilling: {
                    type: "boolean"
                  },
                  ProvisionedThroughput: {
                    shape: "S3g"
                  },
                  IndexSizeBytes: {
                    type: "long"
                  },
                  ItemCount: {
                    type: "long"
                  },
                  IndexArn: {}
                }
              }
            },
            StreamSpecification: {
              shape: "S32"
            },
            LatestStreamLabel: {},
            LatestStreamArn: {},
            GlobalTableVersion: {},
            Replicas: {
              shape: "S26"
            },
            RestoreSummary: {
              type: "structure",
              required: [
                "RestoreDateTime",
                "RestoreInProgress"
              ],
              members: {
                SourceBackupArn: {},
                SourceTableArn: {},
                RestoreDateTime: {
                  type: "timestamp"
                },
                RestoreInProgress: {
                  type: "boolean"
                }
              }
            },
            SSEDescription: {
              shape: "S3v"
            },
            ArchivalSummary: {
              type: "structure",
              members: {
                ArchivalDateTime: {
                  type: "timestamp"
                },
                ArchivalReason: {},
                ArchivalBackupArn: {}
              }
            },
            TableClassSummary: {
              shape: "S2g"
            },
            DeletionProtectionEnabled: {
              type: "boolean"
            }
          }
        },
        S3g: {
          type: "structure",
          members: {
            LastIncreaseDateTime: {
              type: "timestamp"
            },
            LastDecreaseDateTime: {
              type: "timestamp"
            },
            NumberOfDecreasesToday: {
              type: "long"
            },
            ReadCapacityUnits: {
              type: "long"
            },
            WriteCapacityUnits: {
              type: "long"
            }
          }
        },
        S3k: {
          type: "structure",
          members: {
            BillingMode: {},
            LastUpdateToPayPerRequestDateTime: {
              type: "timestamp"
            }
          }
        },
        S3v: {
          type: "structure",
          members: {
            Status: {},
            SSEType: {},
            KMSMasterKeyArn: {},
            InaccessibleEncryptionDateTime: {
              type: "timestamp"
            }
          }
        },
        S42: {
          type: "structure",
          members: {
            BackupDetails: {
              shape: "S1t"
            },
            SourceTableDetails: {
              type: "structure",
              required: [
                "TableName",
                "TableId",
                "KeySchema",
                "TableCreationDateTime",
                "ProvisionedThroughput"
              ],
              members: {
                TableName: {},
                TableId: {},
                TableArn: {},
                TableSizeBytes: {
                  type: "long"
                },
                KeySchema: {
                  shape: "S2p"
                },
                TableCreationDateTime: {
                  type: "timestamp"
                },
                ProvisionedThroughput: {
                  shape: "S30"
                },
                ItemCount: {
                  type: "long"
                },
                BillingMode: {}
              }
            },
            SourceTableFeatureDetails: {
              type: "structure",
              members: {
                LocalSecondaryIndexes: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      IndexName: {},
                      KeySchema: {
                        shape: "S2p"
                      },
                      Projection: {
                        shape: "S2u"
                      }
                    }
                  }
                },
                GlobalSecondaryIndexes: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      IndexName: {},
                      KeySchema: {
                        shape: "S2p"
                      },
                      Projection: {
                        shape: "S2u"
                      },
                      ProvisionedThroughput: {
                        shape: "S30"
                      }
                    }
                  }
                },
                StreamDescription: {
                  shape: "S32"
                },
                TimeToLiveDescription: {
                  shape: "S4b"
                },
                SSEDescription: {
                  shape: "S3v"
                }
              }
            }
          }
        },
        S4b: {
          type: "structure",
          members: {
            TimeToLiveStatus: {},
            AttributeName: {}
          }
        },
        S4f: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              Value: {
                shape: "S6"
              },
              Exists: {
                type: "boolean"
              },
              ComparisonOperator: {},
              AttributeValueList: {
                shape: "S4j"
              }
            }
          }
        },
        S4j: {
          type: "list",
          member: {
            shape: "S6"
          }
        },
        S4n: {
          type: "map",
          key: {},
          value: {
            shape: "S6"
          }
        },
        S4w: {
          type: "structure",
          required: [
            "ContinuousBackupsStatus"
          ],
          members: {
            ContinuousBackupsStatus: {},
            PointInTimeRecoveryDescription: {
              type: "structure",
              members: {
                PointInTimeRecoveryStatus: {},
                EarliestRestorableDateTime: {
                  type: "timestamp"
                },
                LatestRestorableDateTime: {
                  type: "timestamp"
                }
              }
            }
          }
        },
        S5h: {
          type: "structure",
          members: {
            ExportArn: {},
            ExportStatus: {},
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            ExportManifest: {},
            TableArn: {},
            TableId: {},
            ExportTime: {
              type: "timestamp"
            },
            ClientToken: {},
            S3Bucket: {},
            S3BucketOwner: {},
            S3Prefix: {},
            S3SseAlgorithm: {},
            S3SseKmsKeyId: {},
            FailureCode: {},
            FailureMessage: {},
            ExportFormat: {},
            BilledSizeBytes: {
              type: "long"
            },
            ItemCount: {
              type: "long"
            },
            ExportType: {},
            IncrementalExportSpecification: {
              shape: "S5y"
            }
          }
        },
        S5y: {
          type: "structure",
          members: {
            ExportFromTime: {
              type: "timestamp"
            },
            ExportToTime: {
              type: "timestamp"
            },
            ExportViewType: {}
          }
        },
        S66: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "RegionName"
            ],
            members: {
              RegionName: {},
              ReplicaStatus: {},
              ReplicaBillingModeSummary: {
                shape: "S3k"
              },
              ReplicaProvisionedReadCapacityUnits: {
                type: "long"
              },
              ReplicaProvisionedReadCapacityAutoScalingSettings: {
                shape: "S68"
              },
              ReplicaProvisionedWriteCapacityUnits: {
                type: "long"
              },
              ReplicaProvisionedWriteCapacityAutoScalingSettings: {
                shape: "S68"
              },
              ReplicaGlobalSecondaryIndexSettings: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "IndexName"
                  ],
                  members: {
                    IndexName: {},
                    IndexStatus: {},
                    ProvisionedReadCapacityUnits: {
                      type: "long"
                    },
                    ProvisionedReadCapacityAutoScalingSettings: {
                      shape: "S68"
                    },
                    ProvisionedWriteCapacityUnits: {
                      type: "long"
                    },
                    ProvisionedWriteCapacityAutoScalingSettings: {
                      shape: "S68"
                    }
                  }
                }
              },
              ReplicaTableClassSummary: {
                shape: "S2g"
              }
            }
          }
        },
        S68: {
          type: "structure",
          members: {
            MinimumUnits: {
              type: "long"
            },
            MaximumUnits: {
              type: "long"
            },
            AutoScalingDisabled: {
              type: "boolean"
            },
            AutoScalingRoleArn: {},
            ScalingPolicies: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  PolicyName: {},
                  TargetTrackingScalingPolicyConfiguration: {
                    type: "structure",
                    required: [
                      "TargetValue"
                    ],
                    members: {
                      DisableScaleIn: {
                        type: "boolean"
                      },
                      ScaleInCooldown: {
                        type: "integer"
                      },
                      ScaleOutCooldown: {
                        type: "integer"
                      },
                      TargetValue: {
                        type: "double"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S6k: {
          type: "structure",
          members: {
            ImportArn: {},
            ImportStatus: {},
            TableArn: {},
            TableId: {},
            ClientToken: {},
            S3BucketSource: {
              shape: "S6m"
            },
            ErrorCount: {
              type: "long"
            },
            CloudWatchLogGroupArn: {},
            InputFormat: {},
            InputFormatOptions: {
              shape: "S6q"
            },
            InputCompressionType: {},
            TableCreationParameters: {
              shape: "S6w"
            },
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            ProcessedSizeBytes: {
              type: "long"
            },
            ProcessedItemCount: {
              type: "long"
            },
            ImportedItemCount: {
              type: "long"
            },
            FailureCode: {},
            FailureMessage: {}
          }
        },
        S6m: {
          type: "structure",
          required: [
            "S3Bucket"
          ],
          members: {
            S3BucketOwner: {},
            S3Bucket: {},
            S3KeyPrefix: {}
          }
        },
        S6q: {
          type: "structure",
          members: {
            Csv: {
              type: "structure",
              members: {
                Delimiter: {},
                HeaderList: {
                  type: "list",
                  member: {}
                }
              }
            }
          }
        },
        S6w: {
          type: "structure",
          required: [
            "TableName",
            "AttributeDefinitions",
            "KeySchema"
          ],
          members: {
            TableName: {},
            AttributeDefinitions: {
              shape: "S2l"
            },
            KeySchema: {
              shape: "S2p"
            },
            BillingMode: {},
            ProvisionedThroughput: {
              shape: "S30"
            },
            SSESpecification: {
              shape: "S35"
            },
            GlobalSecondaryIndexes: {
              shape: "S2y"
            }
          }
        },
        S7c: {
          type: "structure",
          members: {
            TableName: {},
            TableStatus: {},
            Replicas: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  RegionName: {},
                  GlobalSecondaryIndexes: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        IndexName: {},
                        IndexStatus: {},
                        ProvisionedReadCapacityAutoScalingSettings: {
                          shape: "S68"
                        },
                        ProvisionedWriteCapacityAutoScalingSettings: {
                          shape: "S68"
                        }
                      }
                    }
                  },
                  ReplicaProvisionedReadCapacityAutoScalingSettings: {
                    shape: "S68"
                  },
                  ReplicaProvisionedWriteCapacityAutoScalingSettings: {
                    shape: "S68"
                  },
                  ReplicaStatus: {}
                }
              }
            }
          }
        },
        S7j: {
          type: "structure",
          required: [
            "TableName",
            "StreamArn"
          ],
          members: {
            TableName: {},
            StreamArn: {}
          }
        },
        S7k: {
          type: "structure",
          members: {
            TableName: {},
            StreamArn: {},
            DestinationStatus: {}
          }
        },
        S7u: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Item: {
                shape: "Sr"
              }
            }
          }
        },
        S98: {
          type: "structure",
          required: [
            "ComparisonOperator"
          ],
          members: {
            AttributeValueList: {
              shape: "S4j"
            },
            ComparisonOperator: {}
          }
        },
        S99: {
          type: "map",
          key: {},
          value: {
            shape: "S98"
          }
        },
        Saf: {
          type: "structure",
          members: {
            MinimumUnits: {
              type: "long"
            },
            MaximumUnits: {
              type: "long"
            },
            AutoScalingDisabled: {
              type: "boolean"
            },
            AutoScalingRoleArn: {},
            ScalingPolicyUpdate: {
              type: "structure",
              required: [
                "TargetTrackingScalingPolicyConfiguration"
              ],
              members: {
                PolicyName: {},
                TargetTrackingScalingPolicyConfiguration: {
                  type: "structure",
                  required: [
                    "TargetValue"
                  ],
                  members: {
                    DisableScaleIn: {
                      type: "boolean"
                    },
                    ScaleInCooldown: {
                      type: "integer"
                    },
                    ScaleOutCooldown: {
                      type: "integer"
                    },
                    TargetValue: {
                      type: "double"
                    }
                  }
                }
              }
            }
          }
        },
        Sb4: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "IndexName"
            ],
            members: {
              IndexName: {},
              ProvisionedThroughputOverride: {
                shape: "S2c"
              }
            }
          }
        },
        Sbi: {
          type: "structure",
          required: [
            "Enabled",
            "AttributeName"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            AttributeName: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/dynamodb-2012-08-10.paginators.json
var require_dynamodb_2012_08_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/dynamodb-2012-08-10.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        BatchGetItem: {
          input_token: "RequestItems",
          output_token: "UnprocessedKeys"
        },
        ListContributorInsights: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListExports: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListImports: {
          input_token: "NextToken",
          limit_key: "PageSize",
          output_token: "NextToken"
        },
        ListTables: {
          input_token: "ExclusiveStartTableName",
          limit_key: "Limit",
          output_token: "LastEvaluatedTableName",
          result_key: "TableNames"
        },
        Query: {
          input_token: "ExclusiveStartKey",
          limit_key: "Limit",
          output_token: "LastEvaluatedKey",
          result_key: "Items"
        },
        Scan: {
          input_token: "ExclusiveStartKey",
          limit_key: "Limit",
          output_token: "LastEvaluatedKey",
          result_key: "Items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/dynamodb-2012-08-10.waiters2.json
var require_dynamodb_2012_08_10_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/dynamodb-2012-08-10.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        TableExists: {
          delay: 20,
          operation: "DescribeTable",
          maxAttempts: 25,
          acceptors: [
            {
              expected: "ACTIVE",
              matcher: "path",
              state: "success",
              argument: "Table.TableStatus"
            },
            {
              expected: "ResourceNotFoundException",
              matcher: "error",
              state: "retry"
            }
          ]
        },
        TableNotExists: {
          delay: 20,
          operation: "DescribeTable",
          maxAttempts: 25,
          acceptors: [
            {
              expected: "ResourceNotFoundException",
              matcher: "error",
              state: "success"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/dynamodb.js
var require_dynamodb2 = __commonJS({
  "node_modules/aws-sdk/clients/dynamodb.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["dynamodb"] = {};
    AWS2.DynamoDB = Service.defineService("dynamodb", ["2011-12-05", "2012-08-10"]);
    require_dynamodb();
    Object.defineProperty(apiLoader.services["dynamodb"], "2011-12-05", {
      get: function get() {
        var model = require_dynamodb_2011_12_05_min();
        model.paginators = require_dynamodb_2011_12_05_paginators().pagination;
        model.waiters = require_dynamodb_2011_12_05_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(apiLoader.services["dynamodb"], "2012-08-10", {
      get: function get() {
        var model = require_dynamodb_2012_08_10_min();
        model.paginators = require_dynamodb_2012_08_10_paginators().pagination;
        model.waiters = require_dynamodb_2012_08_10_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.DynamoDB;
  }
});

// node_modules/aws-sdk/apis/streams.dynamodb-2012-08-10.min.json
var require_streams_dynamodb_2012_08_10_min = __commonJS({
  "node_modules/aws-sdk/apis/streams.dynamodb-2012-08-10.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2012-08-10",
        endpointPrefix: "streams.dynamodb",
        jsonVersion: "1.0",
        protocol: "json",
        serviceFullName: "Amazon DynamoDB Streams",
        serviceId: "DynamoDB Streams",
        signatureVersion: "v4",
        signingName: "dynamodb",
        targetPrefix: "DynamoDBStreams_20120810",
        uid: "streams-dynamodb-2012-08-10"
      },
      operations: {
        DescribeStream: {
          input: {
            type: "structure",
            required: [
              "StreamArn"
            ],
            members: {
              StreamArn: {},
              Limit: {
                type: "integer"
              },
              ExclusiveStartShardId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StreamDescription: {
                type: "structure",
                members: {
                  StreamArn: {},
                  StreamLabel: {},
                  StreamStatus: {},
                  StreamViewType: {},
                  CreationRequestDateTime: {
                    type: "timestamp"
                  },
                  TableName: {},
                  KeySchema: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "AttributeName",
                        "KeyType"
                      ],
                      members: {
                        AttributeName: {},
                        KeyType: {}
                      }
                    }
                  },
                  Shards: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        ShardId: {},
                        SequenceNumberRange: {
                          type: "structure",
                          members: {
                            StartingSequenceNumber: {},
                            EndingSequenceNumber: {}
                          }
                        },
                        ParentShardId: {}
                      }
                    }
                  },
                  LastEvaluatedShardId: {}
                }
              }
            }
          }
        },
        GetRecords: {
          input: {
            type: "structure",
            required: [
              "ShardIterator"
            ],
            members: {
              ShardIterator: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Records: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    eventID: {},
                    eventName: {},
                    eventVersion: {},
                    eventSource: {},
                    awsRegion: {},
                    dynamodb: {
                      type: "structure",
                      members: {
                        ApproximateCreationDateTime: {
                          type: "timestamp"
                        },
                        Keys: {
                          shape: "Sr"
                        },
                        NewImage: {
                          shape: "Sr"
                        },
                        OldImage: {
                          shape: "Sr"
                        },
                        SequenceNumber: {},
                        SizeBytes: {
                          type: "long"
                        },
                        StreamViewType: {}
                      }
                    },
                    userIdentity: {
                      type: "structure",
                      members: {
                        PrincipalId: {},
                        Type: {}
                      }
                    }
                  }
                }
              },
              NextShardIterator: {}
            }
          }
        },
        GetShardIterator: {
          input: {
            type: "structure",
            required: [
              "StreamArn",
              "ShardId",
              "ShardIteratorType"
            ],
            members: {
              StreamArn: {},
              ShardId: {},
              ShardIteratorType: {},
              SequenceNumber: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ShardIterator: {}
            }
          }
        },
        ListStreams: {
          input: {
            type: "structure",
            members: {
              TableName: {},
              Limit: {
                type: "integer"
              },
              ExclusiveStartStreamArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Streams: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StreamArn: {},
                    TableName: {},
                    StreamLabel: {}
                  }
                }
              },
              LastEvaluatedStreamArn: {}
            }
          }
        }
      },
      shapes: {
        Sr: {
          type: "map",
          key: {},
          value: {
            shape: "St"
          }
        },
        St: {
          type: "structure",
          members: {
            S: {},
            N: {},
            B: {
              type: "blob"
            },
            SS: {
              type: "list",
              member: {}
            },
            NS: {
              type: "list",
              member: {}
            },
            BS: {
              type: "list",
              member: {
                type: "blob"
              }
            },
            M: {
              type: "map",
              key: {},
              value: {
                shape: "St"
              }
            },
            L: {
              type: "list",
              member: {
                shape: "St"
              }
            },
            NULL: {
              type: "boolean"
            },
            BOOL: {
              type: "boolean"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/streams.dynamodb-2012-08-10.paginators.json
var require_streams_dynamodb_2012_08_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/streams.dynamodb-2012-08-10.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/dynamodbstreams.js
var require_dynamodbstreams = __commonJS({
  "node_modules/aws-sdk/clients/dynamodbstreams.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["dynamodbstreams"] = {};
    AWS2.DynamoDBStreams = Service.defineService("dynamodbstreams", ["2012-08-10"]);
    Object.defineProperty(apiLoader.services["dynamodbstreams"], "2012-08-10", {
      get: function get() {
        var model = require_streams_dynamodb_2012_08_10_min();
        model.paginators = require_streams_dynamodb_2012_08_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.DynamoDBStreams;
  }
});

// node_modules/aws-sdk/lib/services/ec2.js
var require_ec2 = __commonJS({
  "node_modules/aws-sdk/lib/services/ec2.js"() {
    "use strict";
    var AWS2 = require_core();
    AWS2.util.update(AWS2.EC2.prototype, {
      /**
       * @api private
       */
      setupRequestListeners: function setupRequestListeners(request) {
        request.removeListener("extractError", AWS2.EventListeners.Query.EXTRACT_ERROR);
        request.addListener("extractError", this.extractError);
        if (request.operation === "copySnapshot") {
          request.onAsync("validate", this.buildCopySnapshotPresignedUrl);
        }
      },
      /**
       * @api private
       */
      buildCopySnapshotPresignedUrl: function buildCopySnapshotPresignedUrl(req, done) {
        if (req.params.PresignedUrl || req._subRequest) {
          return done();
        }
        req.params = AWS2.util.copy(req.params);
        req.params.DestinationRegion = req.service.config.region;
        var config = AWS2.util.copy(req.service.config);
        delete config.endpoint;
        config.region = req.params.SourceRegion;
        var svc = new req.service.constructor(config);
        var newReq = svc[req.operation](req.params);
        newReq._subRequest = true;
        newReq.presign(function(err, url) {
          if (err)
            done(err);
          else {
            req.params.PresignedUrl = url;
            done();
          }
        });
      },
      /**
       * @api private
       */
      extractError: function extractError(resp) {
        var httpResponse = resp.httpResponse;
        var data = new AWS2.XML.Parser().parse(httpResponse.body.toString() || "");
        if (data.Errors) {
          resp.error = AWS2.util.error(new Error(), {
            code: data.Errors.Error.Code,
            message: data.Errors.Error.Message
          });
        } else {
          resp.error = AWS2.util.error(new Error(), {
            code: httpResponse.statusCode,
            message: null
          });
        }
        resp.error.requestId = data.RequestID || null;
      }
    });
  }
});

// node_modules/aws-sdk/apis/ec2-2016-11-15.min.json
var require_ec2_2016_11_15_min = __commonJS({
  "node_modules/aws-sdk/apis/ec2-2016-11-15.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-11-15",
        endpointPrefix: "ec2",
        protocol: "ec2",
        serviceAbbreviation: "Amazon EC2",
        serviceFullName: "Amazon Elastic Compute Cloud",
        serviceId: "EC2",
        signatureVersion: "v4",
        uid: "ec2-2016-11-15",
        xmlNamespace: "http://ec2.amazonaws.com/doc/2016-11-15"
      },
      operations: {
        AcceptAddressTransfer: {
          input: {
            type: "structure",
            required: [
              "Address"
            ],
            members: {
              Address: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AddressTransfer: {
                shape: "Sa",
                locationName: "addressTransfer"
              }
            }
          }
        },
        AcceptReservedInstancesExchangeQuote: {
          input: {
            type: "structure",
            required: [
              "ReservedInstanceIds"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ReservedInstanceIds: {
                shape: "Se",
                locationName: "ReservedInstanceId"
              },
              TargetConfigurations: {
                shape: "Sg",
                locationName: "TargetConfiguration"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ExchangeId: {
                locationName: "exchangeId"
              }
            }
          }
        },
        AcceptTransitGatewayMulticastDomainAssociations: {
          input: {
            type: "structure",
            members: {
              TransitGatewayMulticastDomainId: {},
              TransitGatewayAttachmentId: {},
              SubnetIds: {
                shape: "So"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Associations: {
                shape: "Sq",
                locationName: "associations"
              }
            }
          }
        },
        AcceptTransitGatewayPeeringAttachment: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayAttachmentId"
            ],
            members: {
              TransitGatewayAttachmentId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayPeeringAttachment: {
                shape: "Sx",
                locationName: "transitGatewayPeeringAttachment"
              }
            }
          }
        },
        AcceptTransitGatewayVpcAttachment: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayAttachmentId"
            ],
            members: {
              TransitGatewayAttachmentId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayVpcAttachment: {
                shape: "S16",
                locationName: "transitGatewayVpcAttachment"
              }
            }
          }
        },
        AcceptVpcEndpointConnections: {
          input: {
            type: "structure",
            required: [
              "ServiceId",
              "VpcEndpointIds"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ServiceId: {},
              VpcEndpointIds: {
                shape: "S1e",
                locationName: "VpcEndpointId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Unsuccessful: {
                shape: "S1h",
                locationName: "unsuccessful"
              }
            }
          }
        },
        AcceptVpcPeeringConnection: {
          input: {
            type: "structure",
            required: [
              "VpcPeeringConnectionId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              VpcPeeringConnectionId: {
                locationName: "vpcPeeringConnectionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpcPeeringConnection: {
                shape: "S1n",
                locationName: "vpcPeeringConnection"
              }
            }
          }
        },
        AdvertiseByoipCidr: {
          input: {
            type: "structure",
            required: [
              "Cidr"
            ],
            members: {
              Cidr: {},
              Asn: {},
              DryRun: {
                type: "boolean"
              },
              NetworkBorderGroup: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ByoipCidr: {
                shape: "S1y",
                locationName: "byoipCidr"
              }
            }
          }
        },
        AllocateAddress: {
          input: {
            type: "structure",
            members: {
              Domain: {},
              Address: {},
              PublicIpv4Pool: {},
              NetworkBorderGroup: {},
              CustomerOwnedIpv4Pool: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicIp: {
                locationName: "publicIp"
              },
              AllocationId: {
                locationName: "allocationId"
              },
              PublicIpv4Pool: {
                locationName: "publicIpv4Pool"
              },
              NetworkBorderGroup: {
                locationName: "networkBorderGroup"
              },
              Domain: {
                locationName: "domain"
              },
              CustomerOwnedIp: {
                locationName: "customerOwnedIp"
              },
              CustomerOwnedIpv4Pool: {
                locationName: "customerOwnedIpv4Pool"
              },
              CarrierIp: {
                locationName: "carrierIp"
              }
            }
          }
        },
        AllocateHosts: {
          input: {
            type: "structure",
            required: [
              "AvailabilityZone"
            ],
            members: {
              AutoPlacement: {
                locationName: "autoPlacement"
              },
              AvailabilityZone: {
                locationName: "availabilityZone"
              },
              ClientToken: {
                locationName: "clientToken"
              },
              InstanceType: {
                locationName: "instanceType"
              },
              InstanceFamily: {},
              Quantity: {
                locationName: "quantity",
                type: "integer"
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              HostRecovery: {},
              OutpostArn: {},
              HostMaintenance: {},
              AssetIds: {
                locationName: "AssetId",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HostIds: {
                shape: "S2f",
                locationName: "hostIdSet"
              }
            }
          }
        },
        AllocateIpamPoolCidr: {
          input: {
            type: "structure",
            required: [
              "IpamPoolId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              IpamPoolId: {},
              Cidr: {},
              NetmaskLength: {
                type: "integer"
              },
              ClientToken: {
                idempotencyToken: true
              },
              Description: {},
              PreviewNextCidr: {
                type: "boolean"
              },
              AllowedCidrs: {
                locationName: "AllowedCidr",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              DisallowedCidrs: {
                locationName: "DisallowedCidr",
                type: "list",
                member: {
                  locationName: "item"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IpamPoolAllocation: {
                shape: "S2l",
                locationName: "ipamPoolAllocation"
              }
            }
          }
        },
        ApplySecurityGroupsToClientVpnTargetNetwork: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId",
              "VpcId",
              "SecurityGroupIds"
            ],
            members: {
              ClientVpnEndpointId: {},
              VpcId: {},
              SecurityGroupIds: {
                shape: "S2r",
                locationName: "SecurityGroupId"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SecurityGroupIds: {
                shape: "S2r",
                locationName: "securityGroupIds"
              }
            }
          }
        },
        AssignIpv6Addresses: {
          input: {
            type: "structure",
            required: [
              "NetworkInterfaceId"
            ],
            members: {
              Ipv6AddressCount: {
                locationName: "ipv6AddressCount",
                type: "integer"
              },
              Ipv6Addresses: {
                shape: "S2v",
                locationName: "ipv6Addresses"
              },
              Ipv6PrefixCount: {
                type: "integer"
              },
              Ipv6Prefixes: {
                shape: "S2w",
                locationName: "Ipv6Prefix"
              },
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssignedIpv6Addresses: {
                shape: "S2v",
                locationName: "assignedIpv6Addresses"
              },
              AssignedIpv6Prefixes: {
                shape: "S2w",
                locationName: "assignedIpv6PrefixSet"
              },
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              }
            }
          }
        },
        AssignPrivateIpAddresses: {
          input: {
            type: "structure",
            required: [
              "NetworkInterfaceId"
            ],
            members: {
              AllowReassignment: {
                locationName: "allowReassignment",
                type: "boolean"
              },
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              },
              PrivateIpAddresses: {
                shape: "S30",
                locationName: "privateIpAddress"
              },
              SecondaryPrivateIpAddressCount: {
                locationName: "secondaryPrivateIpAddressCount",
                type: "integer"
              },
              Ipv4Prefixes: {
                shape: "S2w",
                locationName: "Ipv4Prefix"
              },
              Ipv4PrefixCount: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              },
              AssignedPrivateIpAddresses: {
                locationName: "assignedPrivateIpAddressesSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    PrivateIpAddress: {
                      locationName: "privateIpAddress"
                    }
                  }
                }
              },
              AssignedIpv4Prefixes: {
                shape: "S34",
                locationName: "assignedIpv4PrefixSet"
              }
            }
          }
        },
        AssignPrivateNatGatewayAddress: {
          input: {
            type: "structure",
            required: [
              "NatGatewayId"
            ],
            members: {
              NatGatewayId: {},
              PrivateIpAddresses: {
                shape: "S38",
                locationName: "PrivateIpAddress"
              },
              PrivateIpAddressCount: {
                type: "integer"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NatGatewayId: {
                locationName: "natGatewayId"
              },
              NatGatewayAddresses: {
                shape: "S3b",
                locationName: "natGatewayAddressSet"
              }
            }
          }
        },
        AssociateAddress: {
          input: {
            type: "structure",
            members: {
              AllocationId: {},
              InstanceId: {},
              PublicIp: {},
              AllowReassociation: {
                locationName: "allowReassociation",
                type: "boolean"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              },
              PrivateIpAddress: {
                locationName: "privateIpAddress"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssociationId: {
                locationName: "associationId"
              }
            }
          }
        },
        AssociateClientVpnTargetNetwork: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId",
              "SubnetId"
            ],
            members: {
              ClientVpnEndpointId: {},
              SubnetId: {},
              ClientToken: {
                idempotencyToken: true
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssociationId: {
                locationName: "associationId"
              },
              Status: {
                shape: "S3m",
                locationName: "status"
              }
            }
          }
        },
        AssociateDhcpOptions: {
          input: {
            type: "structure",
            required: [
              "DhcpOptionsId",
              "VpcId"
            ],
            members: {
              DhcpOptionsId: {},
              VpcId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        AssociateEnclaveCertificateIamRole: {
          input: {
            type: "structure",
            required: [
              "CertificateArn",
              "RoleArn"
            ],
            members: {
              CertificateArn: {},
              RoleArn: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CertificateS3BucketName: {
                locationName: "certificateS3BucketName"
              },
              CertificateS3ObjectKey: {
                locationName: "certificateS3ObjectKey"
              },
              EncryptionKmsKeyId: {
                locationName: "encryptionKmsKeyId"
              }
            }
          }
        },
        AssociateIamInstanceProfile: {
          input: {
            type: "structure",
            required: [
              "IamInstanceProfile",
              "InstanceId"
            ],
            members: {
              IamInstanceProfile: {
                shape: "S3v"
              },
              InstanceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IamInstanceProfileAssociation: {
                shape: "S3x",
                locationName: "iamInstanceProfileAssociation"
              }
            }
          }
        },
        AssociateInstanceEventWindow: {
          input: {
            type: "structure",
            required: [
              "InstanceEventWindowId",
              "AssociationTarget"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              InstanceEventWindowId: {},
              AssociationTarget: {
                type: "structure",
                members: {
                  InstanceIds: {
                    shape: "S43",
                    locationName: "InstanceId"
                  },
                  InstanceTags: {
                    shape: "S6",
                    locationName: "InstanceTag"
                  },
                  DedicatedHostIds: {
                    shape: "S44",
                    locationName: "DedicatedHostId"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceEventWindow: {
                shape: "S47",
                locationName: "instanceEventWindow"
              }
            }
          }
        },
        AssociateIpamByoasn: {
          input: {
            type: "structure",
            required: [
              "Asn",
              "Cidr"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              Asn: {},
              Cidr: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AsnAssociation: {
                shape: "S20",
                locationName: "asnAssociation"
              }
            }
          }
        },
        AssociateIpamResourceDiscovery: {
          input: {
            type: "structure",
            required: [
              "IpamId",
              "IpamResourceDiscoveryId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              IpamId: {},
              IpamResourceDiscoveryId: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IpamResourceDiscoveryAssociation: {
                shape: "S4l",
                locationName: "ipamResourceDiscoveryAssociation"
              }
            }
          }
        },
        AssociateNatGatewayAddress: {
          input: {
            type: "structure",
            required: [
              "NatGatewayId",
              "AllocationIds"
            ],
            members: {
              NatGatewayId: {},
              AllocationIds: {
                shape: "S4r",
                locationName: "AllocationId"
              },
              PrivateIpAddresses: {
                shape: "S38",
                locationName: "PrivateIpAddress"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NatGatewayId: {
                locationName: "natGatewayId"
              },
              NatGatewayAddresses: {
                shape: "S3b",
                locationName: "natGatewayAddressSet"
              }
            }
          }
        },
        AssociateRouteTable: {
          input: {
            type: "structure",
            required: [
              "RouteTableId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              RouteTableId: {
                locationName: "routeTableId"
              },
              SubnetId: {
                locationName: "subnetId"
              },
              GatewayId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AssociationId: {
                locationName: "associationId"
              },
              AssociationState: {
                shape: "S4x",
                locationName: "associationState"
              }
            }
          }
        },
        AssociateSubnetCidrBlock: {
          input: {
            type: "structure",
            required: [
              "SubnetId"
            ],
            members: {
              Ipv6CidrBlock: {
                locationName: "ipv6CidrBlock"
              },
              SubnetId: {
                locationName: "subnetId"
              },
              Ipv6IpamPoolId: {},
              Ipv6NetmaskLength: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Ipv6CidrBlockAssociation: {
                shape: "S52",
                locationName: "ipv6CidrBlockAssociation"
              },
              SubnetId: {
                locationName: "subnetId"
              }
            }
          }
        },
        AssociateTransitGatewayMulticastDomain: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayMulticastDomainId",
              "TransitGatewayAttachmentId",
              "SubnetIds"
            ],
            members: {
              TransitGatewayMulticastDomainId: {},
              TransitGatewayAttachmentId: {},
              SubnetIds: {
                shape: "S57"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Associations: {
                shape: "Sq",
                locationName: "associations"
              }
            }
          }
        },
        AssociateTransitGatewayPolicyTable: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayPolicyTableId",
              "TransitGatewayAttachmentId"
            ],
            members: {
              TransitGatewayPolicyTableId: {},
              TransitGatewayAttachmentId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Association: {
                shape: "S5c",
                locationName: "association"
              }
            }
          }
        },
        AssociateTransitGatewayRouteTable: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayRouteTableId",
              "TransitGatewayAttachmentId"
            ],
            members: {
              TransitGatewayRouteTableId: {},
              TransitGatewayAttachmentId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Association: {
                shape: "S5h",
                locationName: "association"
              }
            }
          }
        },
        AssociateTrunkInterface: {
          input: {
            type: "structure",
            required: [
              "BranchInterfaceId",
              "TrunkInterfaceId"
            ],
            members: {
              BranchInterfaceId: {},
              TrunkInterfaceId: {},
              VlanId: {
                type: "integer"
              },
              GreKey: {
                type: "integer"
              },
              ClientToken: {
                idempotencyToken: true
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InterfaceAssociation: {
                shape: "S5k",
                locationName: "interfaceAssociation"
              },
              ClientToken: {
                locationName: "clientToken"
              }
            }
          }
        },
        AssociateVpcCidrBlock: {
          input: {
            type: "structure",
            required: [
              "VpcId"
            ],
            members: {
              AmazonProvidedIpv6CidrBlock: {
                locationName: "amazonProvidedIpv6CidrBlock",
                type: "boolean"
              },
              CidrBlock: {},
              VpcId: {
                locationName: "vpcId"
              },
              Ipv6CidrBlockNetworkBorderGroup: {},
              Ipv6Pool: {},
              Ipv6CidrBlock: {},
              Ipv4IpamPoolId: {},
              Ipv4NetmaskLength: {
                type: "integer"
              },
              Ipv6IpamPoolId: {},
              Ipv6NetmaskLength: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Ipv6CidrBlockAssociation: {
                shape: "S5q",
                locationName: "ipv6CidrBlockAssociation"
              },
              CidrBlockAssociation: {
                shape: "S5t",
                locationName: "cidrBlockAssociation"
              },
              VpcId: {
                locationName: "vpcId"
              }
            }
          }
        },
        AttachClassicLinkVpc: {
          input: {
            type: "structure",
            required: [
              "Groups",
              "InstanceId",
              "VpcId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              Groups: {
                shape: "S5v",
                locationName: "SecurityGroupId"
              },
              InstanceId: {
                locationName: "instanceId"
              },
              VpcId: {
                locationName: "vpcId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        AttachInternetGateway: {
          input: {
            type: "structure",
            required: [
              "InternetGatewayId",
              "VpcId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              InternetGatewayId: {
                locationName: "internetGatewayId"
              },
              VpcId: {
                locationName: "vpcId"
              }
            }
          }
        },
        AttachNetworkInterface: {
          input: {
            type: "structure",
            required: [
              "DeviceIndex",
              "InstanceId",
              "NetworkInterfaceId"
            ],
            members: {
              DeviceIndex: {
                locationName: "deviceIndex",
                type: "integer"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              InstanceId: {
                locationName: "instanceId"
              },
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              },
              NetworkCardIndex: {
                type: "integer"
              },
              EnaSrdSpecification: {
                shape: "S60"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AttachmentId: {
                locationName: "attachmentId"
              },
              NetworkCardIndex: {
                locationName: "networkCardIndex",
                type: "integer"
              }
            }
          }
        },
        AttachVerifiedAccessTrustProvider: {
          input: {
            type: "structure",
            required: [
              "VerifiedAccessInstanceId",
              "VerifiedAccessTrustProviderId"
            ],
            members: {
              VerifiedAccessInstanceId: {},
              VerifiedAccessTrustProviderId: {},
              ClientToken: {
                idempotencyToken: true
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VerifiedAccessTrustProvider: {
                shape: "S67",
                locationName: "verifiedAccessTrustProvider"
              },
              VerifiedAccessInstance: {
                shape: "S6g",
                locationName: "verifiedAccessInstance"
              }
            }
          }
        },
        AttachVolume: {
          input: {
            type: "structure",
            required: [
              "Device",
              "InstanceId",
              "VolumeId"
            ],
            members: {
              Device: {},
              InstanceId: {},
              VolumeId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S6l"
          }
        },
        AttachVpnGateway: {
          input: {
            type: "structure",
            required: [
              "VpcId",
              "VpnGatewayId"
            ],
            members: {
              VpcId: {},
              VpnGatewayId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpcAttachment: {
                shape: "S6q",
                locationName: "attachment"
              }
            }
          }
        },
        AuthorizeClientVpnIngress: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId",
              "TargetNetworkCidr"
            ],
            members: {
              ClientVpnEndpointId: {},
              TargetNetworkCidr: {},
              AccessGroupId: {},
              AuthorizeAllGroups: {
                type: "boolean"
              },
              Description: {},
              ClientToken: {
                idempotencyToken: true
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                shape: "S6u",
                locationName: "status"
              }
            }
          }
        },
        AuthorizeSecurityGroupEgress: {
          input: {
            type: "structure",
            required: [
              "GroupId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              GroupId: {
                locationName: "groupId"
              },
              IpPermissions: {
                shape: "S6x",
                locationName: "ipPermissions"
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              CidrIp: {
                locationName: "cidrIp"
              },
              FromPort: {
                locationName: "fromPort",
                type: "integer"
              },
              IpProtocol: {
                locationName: "ipProtocol"
              },
              ToPort: {
                locationName: "toPort",
                type: "integer"
              },
              SourceSecurityGroupName: {
                locationName: "sourceSecurityGroupName"
              },
              SourceSecurityGroupOwnerId: {
                locationName: "sourceSecurityGroupOwnerId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              },
              SecurityGroupRules: {
                shape: "S78",
                locationName: "securityGroupRuleSet"
              }
            }
          }
        },
        AuthorizeSecurityGroupIngress: {
          input: {
            type: "structure",
            members: {
              CidrIp: {},
              FromPort: {
                type: "integer"
              },
              GroupId: {},
              GroupName: {},
              IpPermissions: {
                shape: "S6x"
              },
              IpProtocol: {},
              SourceSecurityGroupName: {},
              SourceSecurityGroupOwnerId: {},
              ToPort: {
                type: "integer"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              },
              SecurityGroupRules: {
                shape: "S78",
                locationName: "securityGroupRuleSet"
              }
            }
          }
        },
        BundleInstance: {
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Storage"
            ],
            members: {
              InstanceId: {},
              Storage: {
                shape: "S7h"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BundleTask: {
                shape: "S7m",
                locationName: "bundleInstanceTask"
              }
            }
          }
        },
        CancelBundleTask: {
          input: {
            type: "structure",
            required: [
              "BundleId"
            ],
            members: {
              BundleId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BundleTask: {
                shape: "S7m",
                locationName: "bundleInstanceTask"
              }
            }
          }
        },
        CancelCapacityReservation: {
          input: {
            type: "structure",
            required: [
              "CapacityReservationId"
            ],
            members: {
              CapacityReservationId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        CancelCapacityReservationFleets: {
          input: {
            type: "structure",
            required: [
              "CapacityReservationFleetIds"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              CapacityReservationFleetIds: {
                shape: "S7w",
                locationName: "CapacityReservationFleetId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SuccessfulFleetCancellations: {
                locationName: "successfulFleetCancellationSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    CurrentFleetState: {
                      locationName: "currentFleetState"
                    },
                    PreviousFleetState: {
                      locationName: "previousFleetState"
                    },
                    CapacityReservationFleetId: {
                      locationName: "capacityReservationFleetId"
                    }
                  }
                }
              },
              FailedFleetCancellations: {
                locationName: "failedFleetCancellationSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    CapacityReservationFleetId: {
                      locationName: "capacityReservationFleetId"
                    },
                    CancelCapacityReservationFleetError: {
                      locationName: "cancelCapacityReservationFleetError",
                      type: "structure",
                      members: {
                        Code: {
                          locationName: "code"
                        },
                        Message: {
                          locationName: "message"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        CancelConversionTask: {
          input: {
            type: "structure",
            required: [
              "ConversionTaskId"
            ],
            members: {
              ConversionTaskId: {
                locationName: "conversionTaskId"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              ReasonMessage: {
                locationName: "reasonMessage"
              }
            }
          }
        },
        CancelExportTask: {
          input: {
            type: "structure",
            required: [
              "ExportTaskId"
            ],
            members: {
              ExportTaskId: {
                locationName: "exportTaskId"
              }
            }
          }
        },
        CancelImageLaunchPermission: {
          input: {
            type: "structure",
            required: [
              "ImageId"
            ],
            members: {
              ImageId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        CancelImportTask: {
          input: {
            type: "structure",
            members: {
              CancelReason: {},
              DryRun: {
                type: "boolean"
              },
              ImportTaskId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ImportTaskId: {
                locationName: "importTaskId"
              },
              PreviousState: {
                locationName: "previousState"
              },
              State: {
                locationName: "state"
              }
            }
          }
        },
        CancelReservedInstancesListing: {
          input: {
            type: "structure",
            required: [
              "ReservedInstancesListingId"
            ],
            members: {
              ReservedInstancesListingId: {
                locationName: "reservedInstancesListingId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReservedInstancesListings: {
                shape: "S8k",
                locationName: "reservedInstancesListingsSet"
              }
            }
          }
        },
        CancelSpotFleetRequests: {
          input: {
            type: "structure",
            required: [
              "SpotFleetRequestIds",
              "TerminateInstances"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              SpotFleetRequestIds: {
                shape: "S8w",
                locationName: "spotFleetRequestId"
              },
              TerminateInstances: {
                locationName: "terminateInstances",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SuccessfulFleetRequests: {
                locationName: "successfulFleetRequestSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    CurrentSpotFleetRequestState: {
                      locationName: "currentSpotFleetRequestState"
                    },
                    PreviousSpotFleetRequestState: {
                      locationName: "previousSpotFleetRequestState"
                    },
                    SpotFleetRequestId: {
                      locationName: "spotFleetRequestId"
                    }
                  }
                }
              },
              UnsuccessfulFleetRequests: {
                locationName: "unsuccessfulFleetRequestSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Error: {
                      locationName: "error",
                      type: "structure",
                      members: {
                        Code: {
                          locationName: "code"
                        },
                        Message: {
                          locationName: "message"
                        }
                      }
                    },
                    SpotFleetRequestId: {
                      locationName: "spotFleetRequestId"
                    }
                  }
                }
              }
            }
          }
        },
        CancelSpotInstanceRequests: {
          input: {
            type: "structure",
            required: [
              "SpotInstanceRequestIds"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              SpotInstanceRequestIds: {
                shape: "S97",
                locationName: "SpotInstanceRequestId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CancelledSpotInstanceRequests: {
                locationName: "spotInstanceRequestSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    SpotInstanceRequestId: {
                      locationName: "spotInstanceRequestId"
                    },
                    State: {
                      locationName: "state"
                    }
                  }
                }
              }
            }
          }
        },
        ConfirmProductInstance: {
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ProductCode"
            ],
            members: {
              InstanceId: {},
              ProductCode: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OwnerId: {
                locationName: "ownerId"
              },
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        CopyFpgaImage: {
          input: {
            type: "structure",
            required: [
              "SourceFpgaImageId",
              "SourceRegion"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              SourceFpgaImageId: {},
              Description: {},
              Name: {},
              SourceRegion: {},
              ClientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FpgaImageId: {
                locationName: "fpgaImageId"
              }
            }
          }
        },
        CopyImage: {
          input: {
            type: "structure",
            required: [
              "Name",
              "SourceImageId",
              "SourceRegion"
            ],
            members: {
              ClientToken: {},
              Description: {},
              Encrypted: {
                locationName: "encrypted",
                type: "boolean"
              },
              KmsKeyId: {
                locationName: "kmsKeyId"
              },
              Name: {},
              SourceImageId: {},
              SourceRegion: {},
              DestinationOutpostArn: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              CopyImageTags: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ImageId: {
                locationName: "imageId"
              }
            }
          }
        },
        CopySnapshot: {
          input: {
            type: "structure",
            required: [
              "SourceRegion",
              "SourceSnapshotId"
            ],
            members: {
              Description: {},
              DestinationOutpostArn: {},
              DestinationRegion: {
                locationName: "destinationRegion"
              },
              Encrypted: {
                locationName: "encrypted",
                type: "boolean"
              },
              KmsKeyId: {
                locationName: "kmsKeyId"
              },
              PresignedUrl: {
                locationName: "presignedUrl",
                type: "string",
                sensitive: true
              },
              SourceRegion: {},
              SourceSnapshotId: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SnapshotId: {
                locationName: "snapshotId"
              },
              Tags: {
                shape: "S6",
                locationName: "tagSet"
              }
            }
          }
        },
        CreateCapacityReservation: {
          input: {
            type: "structure",
            required: [
              "InstanceType",
              "InstancePlatform",
              "InstanceCount"
            ],
            members: {
              ClientToken: {},
              InstanceType: {},
              InstancePlatform: {},
              AvailabilityZone: {},
              AvailabilityZoneId: {},
              Tenancy: {},
              InstanceCount: {
                type: "integer"
              },
              EbsOptimized: {
                type: "boolean"
              },
              EphemeralStorage: {
                type: "boolean"
              },
              EndDate: {
                type: "timestamp"
              },
              EndDateType: {},
              InstanceMatchCriteria: {},
              TagSpecifications: {
                shape: "S3"
              },
              DryRun: {
                type: "boolean"
              },
              OutpostArn: {},
              PlacementGroupArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CapacityReservation: {
                shape: "S9x",
                locationName: "capacityReservation"
              }
            }
          }
        },
        CreateCapacityReservationFleet: {
          input: {
            type: "structure",
            required: [
              "InstanceTypeSpecifications",
              "TotalTargetCapacity"
            ],
            members: {
              AllocationStrategy: {},
              ClientToken: {
                idempotencyToken: true
              },
              InstanceTypeSpecifications: {
                locationName: "InstanceTypeSpecification",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InstanceType: {},
                    InstancePlatform: {},
                    Weight: {
                      type: "double"
                    },
                    AvailabilityZone: {},
                    AvailabilityZoneId: {},
                    EbsOptimized: {
                      type: "boolean"
                    },
                    Priority: {
                      type: "integer"
                    }
                  }
                }
              },
              Tenancy: {},
              TotalTargetCapacity: {
                type: "integer"
              },
              EndDate: {
                type: "timestamp"
              },
              InstanceMatchCriteria: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CapacityReservationFleetId: {
                locationName: "capacityReservationFleetId"
              },
              State: {
                locationName: "state"
              },
              TotalTargetCapacity: {
                locationName: "totalTargetCapacity",
                type: "integer"
              },
              TotalFulfilledCapacity: {
                locationName: "totalFulfilledCapacity",
                type: "double"
              },
              InstanceMatchCriteria: {
                locationName: "instanceMatchCriteria"
              },
              AllocationStrategy: {
                locationName: "allocationStrategy"
              },
              CreateTime: {
                locationName: "createTime",
                type: "timestamp"
              },
              EndDate: {
                locationName: "endDate",
                type: "timestamp"
              },
              Tenancy: {
                locationName: "tenancy"
              },
              FleetCapacityReservations: {
                shape: "Sac",
                locationName: "fleetCapacityReservationSet"
              },
              Tags: {
                shape: "S6",
                locationName: "tagSet"
              }
            }
          }
        },
        CreateCarrierGateway: {
          input: {
            type: "structure",
            required: [
              "VpcId"
            ],
            members: {
              VpcId: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CarrierGateway: {
                shape: "Sag",
                locationName: "carrierGateway"
              }
            }
          }
        },
        CreateClientVpnEndpoint: {
          input: {
            type: "structure",
            required: [
              "ClientCidrBlock",
              "ServerCertificateArn",
              "AuthenticationOptions",
              "ConnectionLogOptions"
            ],
            members: {
              ClientCidrBlock: {},
              ServerCertificateArn: {},
              AuthenticationOptions: {
                locationName: "Authentication",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    ActiveDirectory: {
                      type: "structure",
                      members: {
                        DirectoryId: {}
                      }
                    },
                    MutualAuthentication: {
                      type: "structure",
                      members: {
                        ClientRootCertificateChainArn: {}
                      }
                    },
                    FederatedAuthentication: {
                      type: "structure",
                      members: {
                        SAMLProviderArn: {},
                        SelfServiceSAMLProviderArn: {}
                      }
                    }
                  }
                }
              },
              ConnectionLogOptions: {
                shape: "Saq"
              },
              DnsServers: {
                shape: "So"
              },
              TransportProtocol: {},
              VpnPort: {
                type: "integer"
              },
              Description: {},
              SplitTunnel: {
                type: "boolean"
              },
              DryRun: {
                type: "boolean"
              },
              ClientToken: {
                idempotencyToken: true
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              SecurityGroupIds: {
                shape: "S2r",
                locationName: "SecurityGroupId"
              },
              VpcId: {},
              SelfServicePortal: {},
              ClientConnectOptions: {
                shape: "Sat"
              },
              SessionTimeoutHours: {
                type: "integer"
              },
              ClientLoginBannerOptions: {
                shape: "Sau"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ClientVpnEndpointId: {
                locationName: "clientVpnEndpointId"
              },
              Status: {
                shape: "Saw",
                locationName: "status"
              },
              DnsName: {
                locationName: "dnsName"
              }
            }
          }
        },
        CreateClientVpnRoute: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId",
              "DestinationCidrBlock",
              "TargetVpcSubnetId"
            ],
            members: {
              ClientVpnEndpointId: {},
              DestinationCidrBlock: {},
              TargetVpcSubnetId: {},
              Description: {},
              ClientToken: {
                idempotencyToken: true
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                shape: "Sb0",
                locationName: "status"
              }
            }
          }
        },
        CreateCoipCidr: {
          input: {
            type: "structure",
            required: [
              "Cidr",
              "CoipPoolId"
            ],
            members: {
              Cidr: {},
              CoipPoolId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CoipCidr: {
                shape: "Sb5",
                locationName: "coipCidr"
              }
            }
          }
        },
        CreateCoipPool: {
          input: {
            type: "structure",
            required: [
              "LocalGatewayRouteTableId"
            ],
            members: {
              LocalGatewayRouteTableId: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CoipPool: {
                shape: "Sb9",
                locationName: "coipPool"
              }
            }
          }
        },
        CreateCustomerGateway: {
          input: {
            type: "structure",
            required: [
              "Type"
            ],
            members: {
              BgpAsn: {
                type: "integer"
              },
              PublicIp: {},
              CertificateArn: {},
              Type: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              DeviceName: {},
              IpAddress: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CustomerGateway: {
                shape: "Sbd",
                locationName: "customerGateway"
              }
            }
          }
        },
        CreateDefaultSubnet: {
          input: {
            type: "structure",
            required: [
              "AvailabilityZone"
            ],
            members: {
              AvailabilityZone: {},
              DryRun: {
                type: "boolean"
              },
              Ipv6Native: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Subnet: {
                shape: "Sbg",
                locationName: "subnet"
              }
            }
          }
        },
        CreateDefaultVpc: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Vpc: {
                shape: "Sbo",
                locationName: "vpc"
              }
            }
          }
        },
        CreateDhcpOptions: {
          input: {
            type: "structure",
            required: [
              "DhcpConfigurations"
            ],
            members: {
              DhcpConfigurations: {
                locationName: "dhcpConfiguration",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Key: {
                      locationName: "key"
                    },
                    Values: {
                      shape: "So",
                      locationName: "Value"
                    }
                  }
                }
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DhcpOptions: {
                shape: "Sbx",
                locationName: "dhcpOptions"
              }
            }
          }
        },
        CreateEgressOnlyInternetGateway: {
          input: {
            type: "structure",
            required: [
              "VpcId"
            ],
            members: {
              ClientToken: {},
              DryRun: {
                type: "boolean"
              },
              VpcId: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ClientToken: {
                locationName: "clientToken"
              },
              EgressOnlyInternetGateway: {
                shape: "Sc4",
                locationName: "egressOnlyInternetGateway"
              }
            }
          }
        },
        CreateFleet: {
          input: {
            type: "structure",
            required: [
              "LaunchTemplateConfigs",
              "TargetCapacitySpecification"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ClientToken: {},
              SpotOptions: {
                type: "structure",
                members: {
                  AllocationStrategy: {},
                  MaintenanceStrategies: {
                    type: "structure",
                    members: {
                      CapacityRebalance: {
                        type: "structure",
                        members: {
                          ReplacementStrategy: {},
                          TerminationDelay: {
                            type: "integer"
                          }
                        }
                      }
                    }
                  },
                  InstanceInterruptionBehavior: {},
                  InstancePoolsToUseCount: {
                    type: "integer"
                  },
                  SingleInstanceType: {
                    type: "boolean"
                  },
                  SingleAvailabilityZone: {
                    type: "boolean"
                  },
                  MinTargetCapacity: {
                    type: "integer"
                  },
                  MaxTotalPrice: {}
                }
              },
              OnDemandOptions: {
                type: "structure",
                members: {
                  AllocationStrategy: {},
                  CapacityReservationOptions: {
                    type: "structure",
                    members: {
                      UsageStrategy: {}
                    }
                  },
                  SingleInstanceType: {
                    type: "boolean"
                  },
                  SingleAvailabilityZone: {
                    type: "boolean"
                  },
                  MinTargetCapacity: {
                    type: "integer"
                  },
                  MaxTotalPrice: {}
                }
              },
              ExcessCapacityTerminationPolicy: {},
              LaunchTemplateConfigs: {
                shape: "Sck"
              },
              TargetCapacitySpecification: {
                shape: "Sdn"
              },
              TerminateInstancesWithExpiration: {
                type: "boolean"
              },
              Type: {},
              ValidFrom: {
                type: "timestamp"
              },
              ValidUntil: {
                type: "timestamp"
              },
              ReplaceUnhealthyInstances: {
                type: "boolean"
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              Context: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FleetId: {
                locationName: "fleetId"
              },
              Errors: {
                locationName: "errorSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    LaunchTemplateAndOverrides: {
                      shape: "Sdv",
                      locationName: "launchTemplateAndOverrides"
                    },
                    Lifecycle: {
                      locationName: "lifecycle"
                    },
                    ErrorCode: {
                      locationName: "errorCode"
                    },
                    ErrorMessage: {
                      locationName: "errorMessage"
                    }
                  }
                }
              },
              Instances: {
                locationName: "fleetInstanceSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    LaunchTemplateAndOverrides: {
                      shape: "Sdv",
                      locationName: "launchTemplateAndOverrides"
                    },
                    Lifecycle: {
                      locationName: "lifecycle"
                    },
                    InstanceIds: {
                      shape: "Sec",
                      locationName: "instanceIds"
                    },
                    InstanceType: {
                      locationName: "instanceType"
                    },
                    Platform: {
                      locationName: "platform"
                    }
                  }
                }
              }
            }
          }
        },
        CreateFlowLogs: {
          input: {
            type: "structure",
            required: [
              "ResourceIds",
              "ResourceType"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ClientToken: {},
              DeliverLogsPermissionArn: {},
              DeliverCrossAccountRole: {},
              LogGroupName: {},
              ResourceIds: {
                locationName: "ResourceId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              ResourceType: {},
              TrafficType: {},
              LogDestinationType: {},
              LogDestination: {},
              LogFormat: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              MaxAggregationInterval: {
                type: "integer"
              },
              DestinationOptions: {
                type: "structure",
                members: {
                  FileFormat: {},
                  HiveCompatiblePartitions: {
                    type: "boolean"
                  },
                  PerHourPartition: {
                    type: "boolean"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ClientToken: {
                locationName: "clientToken"
              },
              FlowLogIds: {
                shape: "So",
                locationName: "flowLogIdSet"
              },
              Unsuccessful: {
                shape: "S1h",
                locationName: "unsuccessful"
              }
            }
          }
        },
        CreateFpgaImage: {
          input: {
            type: "structure",
            required: [
              "InputStorageLocation"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              InputStorageLocation: {
                shape: "Seo"
              },
              LogsStorageLocation: {
                shape: "Seo"
              },
              Description: {},
              Name: {},
              ClientToken: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FpgaImageId: {
                locationName: "fpgaImageId"
              },
              FpgaImageGlobalId: {
                locationName: "fpgaImageGlobalId"
              }
            }
          }
        },
        CreateImage: {
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Name"
            ],
            members: {
              BlockDeviceMappings: {
                shape: "Ser",
                locationName: "blockDeviceMapping"
              },
              Description: {
                locationName: "description"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              InstanceId: {
                locationName: "instanceId"
              },
              Name: {
                locationName: "name"
              },
              NoReboot: {
                locationName: "noReboot",
                type: "boolean"
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ImageId: {
                locationName: "imageId"
              }
            }
          }
        },
        CreateInstanceConnectEndpoint: {
          input: {
            type: "structure",
            required: [
              "SubnetId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              SubnetId: {},
              SecurityGroupIds: {
                locationName: "SecurityGroupId",
                type: "list",
                member: {
                  locationName: "SecurityGroupId"
                }
              },
              PreserveClientIp: {
                type: "boolean"
              },
              ClientToken: {
                idempotencyToken: true
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceConnectEndpoint: {
                shape: "Sf0",
                locationName: "instanceConnectEndpoint"
              },
              ClientToken: {
                locationName: "clientToken"
              }
            }
          }
        },
        CreateInstanceEventWindow: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              Name: {},
              TimeRanges: {
                shape: "Sf6",
                locationName: "TimeRange"
              },
              CronExpression: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceEventWindow: {
                shape: "S47",
                locationName: "instanceEventWindow"
              }
            }
          }
        },
        CreateInstanceExportTask: {
          input: {
            type: "structure",
            required: [
              "ExportToS3Task",
              "InstanceId",
              "TargetEnvironment"
            ],
            members: {
              Description: {
                locationName: "description"
              },
              ExportToS3Task: {
                locationName: "exportToS3",
                type: "structure",
                members: {
                  ContainerFormat: {
                    locationName: "containerFormat"
                  },
                  DiskImageFormat: {
                    locationName: "diskImageFormat"
                  },
                  S3Bucket: {
                    locationName: "s3Bucket"
                  },
                  S3Prefix: {
                    locationName: "s3Prefix"
                  }
                }
              },
              InstanceId: {
                locationName: "instanceId"
              },
              TargetEnvironment: {
                locationName: "targetEnvironment"
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ExportTask: {
                shape: "Sff",
                locationName: "exportTask"
              }
            }
          }
        },
        CreateInternetGateway: {
          input: {
            type: "structure",
            members: {
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InternetGateway: {
                shape: "Sfl",
                locationName: "internetGateway"
              }
            }
          }
        },
        CreateIpam: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              Description: {},
              OperatingRegions: {
                shape: "Sfn",
                locationName: "OperatingRegion"
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              ClientToken: {
                idempotencyToken: true
              },
              Tier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Ipam: {
                shape: "Sfr",
                locationName: "ipam"
              }
            }
          }
        },
        CreateIpamPool: {
          input: {
            type: "structure",
            required: [
              "IpamScopeId",
              "AddressFamily"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              IpamScopeId: {},
              Locale: {},
              SourceIpamPoolId: {},
              Description: {},
              AddressFamily: {},
              AutoImport: {
                type: "boolean"
              },
              PubliclyAdvertisable: {
                type: "boolean"
              },
              AllocationMinNetmaskLength: {
                type: "integer"
              },
              AllocationMaxNetmaskLength: {
                type: "integer"
              },
              AllocationDefaultNetmaskLength: {
                type: "integer"
              },
              AllocationResourceTags: {
                shape: "Sfz",
                locationName: "AllocationResourceTag"
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              ClientToken: {
                idempotencyToken: true
              },
              AwsService: {},
              PublicIpSource: {},
              SourceResource: {
                type: "structure",
                members: {
                  ResourceId: {},
                  ResourceType: {},
                  ResourceRegion: {},
                  ResourceOwner: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IpamPool: {
                shape: "Sg6",
                locationName: "ipamPool"
              }
            }
          }
        },
        CreateIpamResourceDiscovery: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              Description: {},
              OperatingRegions: {
                shape: "Sfn",
                locationName: "OperatingRegion"
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IpamResourceDiscovery: {
                shape: "Sge",
                locationName: "ipamResourceDiscovery"
              }
            }
          }
        },
        CreateIpamScope: {
          input: {
            type: "structure",
            required: [
              "IpamId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              IpamId: {},
              Description: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IpamScope: {
                shape: "Sgi",
                locationName: "ipamScope"
              }
            }
          }
        },
        CreateKeyPair: {
          input: {
            type: "structure",
            required: [
              "KeyName"
            ],
            members: {
              KeyName: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              KeyType: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              KeyFormat: {}
            }
          },
          output: {
            type: "structure",
            members: {
              KeyFingerprint: {
                locationName: "keyFingerprint"
              },
              KeyMaterial: {
                shape: "Sgo",
                locationName: "keyMaterial"
              },
              KeyName: {
                locationName: "keyName"
              },
              KeyPairId: {
                locationName: "keyPairId"
              },
              Tags: {
                shape: "S6",
                locationName: "tagSet"
              }
            }
          }
        },
        CreateLaunchTemplate: {
          input: {
            type: "structure",
            required: [
              "LaunchTemplateName",
              "LaunchTemplateData"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ClientToken: {},
              LaunchTemplateName: {},
              VersionDescription: {},
              LaunchTemplateData: {
                shape: "Sgr"
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LaunchTemplate: {
                shape: "Sic",
                locationName: "launchTemplate"
              },
              Warning: {
                shape: "Sid",
                locationName: "warning"
              }
            }
          }
        },
        CreateLaunchTemplateVersion: {
          input: {
            type: "structure",
            required: [
              "LaunchTemplateData"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ClientToken: {},
              LaunchTemplateId: {},
              LaunchTemplateName: {},
              SourceVersion: {},
              VersionDescription: {},
              LaunchTemplateData: {
                shape: "Sgr"
              },
              ResolveAlias: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LaunchTemplateVersion: {
                shape: "Sii",
                locationName: "launchTemplateVersion"
              },
              Warning: {
                shape: "Sid",
                locationName: "warning"
              }
            }
          }
        },
        CreateLocalGatewayRoute: {
          input: {
            type: "structure",
            required: [
              "LocalGatewayRouteTableId"
            ],
            members: {
              DestinationCidrBlock: {},
              LocalGatewayRouteTableId: {},
              LocalGatewayVirtualInterfaceGroupId: {},
              DryRun: {
                type: "boolean"
              },
              NetworkInterfaceId: {},
              DestinationPrefixListId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Route: {
                shape: "Sjo",
                locationName: "route"
              }
            }
          }
        },
        CreateLocalGatewayRouteTable: {
          input: {
            type: "structure",
            required: [
              "LocalGatewayId"
            ],
            members: {
              LocalGatewayId: {},
              Mode: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocalGatewayRouteTable: {
                shape: "Sjv",
                locationName: "localGatewayRouteTable"
              }
            }
          }
        },
        CreateLocalGatewayRouteTableVirtualInterfaceGroupAssociation: {
          input: {
            type: "structure",
            required: [
              "LocalGatewayRouteTableId",
              "LocalGatewayVirtualInterfaceGroupId"
            ],
            members: {
              LocalGatewayRouteTableId: {},
              LocalGatewayVirtualInterfaceGroupId: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocalGatewayRouteTableVirtualInterfaceGroupAssociation: {
                shape: "Sjz",
                locationName: "localGatewayRouteTableVirtualInterfaceGroupAssociation"
              }
            }
          }
        },
        CreateLocalGatewayRouteTableVpcAssociation: {
          input: {
            type: "structure",
            required: [
              "LocalGatewayRouteTableId",
              "VpcId"
            ],
            members: {
              LocalGatewayRouteTableId: {},
              VpcId: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocalGatewayRouteTableVpcAssociation: {
                shape: "Sk3",
                locationName: "localGatewayRouteTableVpcAssociation"
              }
            }
          }
        },
        CreateManagedPrefixList: {
          input: {
            type: "structure",
            required: [
              "PrefixListName",
              "MaxEntries",
              "AddressFamily"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              PrefixListName: {},
              Entries: {
                shape: "Sk6",
                locationName: "Entry"
              },
              MaxEntries: {
                type: "integer"
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              AddressFamily: {},
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PrefixList: {
                shape: "Sk9",
                locationName: "prefixList"
              }
            }
          }
        },
        CreateNatGateway: {
          input: {
            type: "structure",
            required: [
              "SubnetId"
            ],
            members: {
              AllocationId: {},
              ClientToken: {
                idempotencyToken: true
              },
              DryRun: {
                type: "boolean"
              },
              SubnetId: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              ConnectivityType: {},
              PrivateIpAddress: {},
              SecondaryAllocationIds: {
                shape: "S4r",
                locationName: "SecondaryAllocationId"
              },
              SecondaryPrivateIpAddresses: {
                shape: "S38",
                locationName: "SecondaryPrivateIpAddress"
              },
              SecondaryPrivateIpAddressCount: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ClientToken: {
                locationName: "clientToken"
              },
              NatGateway: {
                shape: "Ske",
                locationName: "natGateway"
              }
            }
          }
        },
        CreateNetworkAcl: {
          input: {
            type: "structure",
            required: [
              "VpcId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              VpcId: {
                locationName: "vpcId"
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkAcl: {
                shape: "Skj",
                locationName: "networkAcl"
              }
            }
          }
        },
        CreateNetworkAclEntry: {
          input: {
            type: "structure",
            required: [
              "Egress",
              "NetworkAclId",
              "Protocol",
              "RuleAction",
              "RuleNumber"
            ],
            members: {
              CidrBlock: {
                locationName: "cidrBlock"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              Egress: {
                locationName: "egress",
                type: "boolean"
              },
              IcmpTypeCode: {
                shape: "Sko",
                locationName: "Icmp"
              },
              Ipv6CidrBlock: {
                locationName: "ipv6CidrBlock"
              },
              NetworkAclId: {
                locationName: "networkAclId"
              },
              PortRange: {
                shape: "Skp",
                locationName: "portRange"
              },
              Protocol: {
                locationName: "protocol"
              },
              RuleAction: {
                locationName: "ruleAction"
              },
              RuleNumber: {
                locationName: "ruleNumber",
                type: "integer"
              }
            }
          }
        },
        CreateNetworkInsightsAccessScope: {
          input: {
            type: "structure",
            required: [
              "ClientToken"
            ],
            members: {
              MatchPaths: {
                shape: "Sku",
                locationName: "MatchPath"
              },
              ExcludePaths: {
                shape: "Sku",
                locationName: "ExcludePath"
              },
              ClientToken: {
                idempotencyToken: true
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkInsightsAccessScope: {
                shape: "Sl4",
                locationName: "networkInsightsAccessScope"
              },
              NetworkInsightsAccessScopeContent: {
                shape: "Sl6",
                locationName: "networkInsightsAccessScopeContent"
              }
            }
          }
        },
        CreateNetworkInsightsPath: {
          input: {
            type: "structure",
            required: [
              "Source",
              "Protocol",
              "ClientToken"
            ],
            members: {
              SourceIp: {},
              DestinationIp: {},
              Source: {},
              Destination: {},
              Protocol: {},
              DestinationPort: {
                type: "integer"
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              },
              ClientToken: {
                idempotencyToken: true
              },
              FilterAtSource: {
                shape: "Sli"
              },
              FilterAtDestination: {
                shape: "Sli"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkInsightsPath: {
                shape: "Sll",
                locationName: "networkInsightsPath"
              }
            }
          }
        },
        CreateNetworkInterface: {
          input: {
            type: "structure",
            required: [
              "SubnetId"
            ],
            members: {
              Description: {
                locationName: "description"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              Groups: {
                shape: "Sgz",
                locationName: "SecurityGroupId"
              },
              Ipv6AddressCount: {
                locationName: "ipv6AddressCount",
                type: "integer"
              },
              Ipv6Addresses: {
                shape: "Siq",
                locationName: "ipv6Addresses"
              },
              PrivateIpAddress: {
                locationName: "privateIpAddress"
              },
              PrivateIpAddresses: {
                shape: "Sh2",
                locationName: "privateIpAddresses"
              },
              SecondaryPrivateIpAddressCount: {
                locationName: "secondaryPrivateIpAddressCount",
                type: "integer"
              },
              Ipv4Prefixes: {
                shape: "Sh4",
                locationName: "Ipv4Prefix"
              },
              Ipv4PrefixCount: {
                type: "integer"
              },
              Ipv6Prefixes: {
                shape: "Sh6",
                locationName: "Ipv6Prefix"
              },
              Ipv6PrefixCount: {
                type: "integer"
              },
              InterfaceType: {},
              SubnetId: {
                locationName: "subnetId"
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              ClientToken: {
                idempotencyToken: true
              },
              EnablePrimaryIpv6: {
                type: "boolean"
              },
              ConnectionTrackingSpecification: {
                shape: "Sha"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkInterface: {
                shape: "Sls",
                locationName: "networkInterface"
              },
              ClientToken: {
                locationName: "clientToken"
              }
            }
          }
        },
        CreateNetworkInterfacePermission: {
          input: {
            type: "structure",
            required: [
              "NetworkInterfaceId",
              "Permission"
            ],
            members: {
              NetworkInterfaceId: {},
              AwsAccountId: {},
              AwsService: {},
              Permission: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InterfacePermission: {
                shape: "Smb",
                locationName: "interfacePermission"
              }
            }
          }
        },
        CreatePlacementGroup: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              GroupName: {
                locationName: "groupName"
              },
              Strategy: {
                locationName: "strategy"
              },
              PartitionCount: {
                type: "integer"
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              SpreadLevel: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PlacementGroup: {
                shape: "Smi",
                locationName: "placementGroup"
              }
            }
          }
        },
        CreatePublicIpv4Pool: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PoolId: {
                locationName: "poolId"
              }
            }
          }
        },
        CreateReplaceRootVolumeTask: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              SnapshotId: {},
              ClientToken: {
                idempotencyToken: true
              },
              DryRun: {
                type: "boolean"
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              ImageId: {},
              DeleteReplacedRootVolume: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReplaceRootVolumeTask: {
                shape: "Smo",
                locationName: "replaceRootVolumeTask"
              }
            }
          }
        },
        CreateReservedInstancesListing: {
          input: {
            type: "structure",
            required: [
              "ClientToken",
              "InstanceCount",
              "PriceSchedules",
              "ReservedInstancesId"
            ],
            members: {
              ClientToken: {
                locationName: "clientToken"
              },
              InstanceCount: {
                locationName: "instanceCount",
                type: "integer"
              },
              PriceSchedules: {
                locationName: "priceSchedules",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    CurrencyCode: {
                      locationName: "currencyCode"
                    },
                    Price: {
                      locationName: "price",
                      type: "double"
                    },
                    Term: {
                      locationName: "term",
                      type: "long"
                    }
                  }
                }
              },
              ReservedInstancesId: {
                locationName: "reservedInstancesId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReservedInstancesListings: {
                shape: "S8k",
                locationName: "reservedInstancesListingsSet"
              }
            }
          }
        },
        CreateRestoreImageTask: {
          input: {
            type: "structure",
            required: [
              "Bucket",
              "ObjectKey"
            ],
            members: {
              Bucket: {},
              ObjectKey: {},
              Name: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ImageId: {
                locationName: "imageId"
              }
            }
          }
        },
        CreateRoute: {
          input: {
            type: "structure",
            required: [
              "RouteTableId"
            ],
            members: {
              DestinationCidrBlock: {
                locationName: "destinationCidrBlock"
              },
              DestinationIpv6CidrBlock: {
                locationName: "destinationIpv6CidrBlock"
              },
              DestinationPrefixListId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              VpcEndpointId: {},
              EgressOnlyInternetGatewayId: {
                locationName: "egressOnlyInternetGatewayId"
              },
              GatewayId: {
                locationName: "gatewayId"
              },
              InstanceId: {
                locationName: "instanceId"
              },
              NatGatewayId: {
                locationName: "natGatewayId"
              },
              TransitGatewayId: {},
              LocalGatewayId: {},
              CarrierGatewayId: {},
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              },
              RouteTableId: {
                locationName: "routeTableId"
              },
              VpcPeeringConnectionId: {
                locationName: "vpcPeeringConnectionId"
              },
              CoreNetworkArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        CreateRouteTable: {
          input: {
            type: "structure",
            required: [
              "VpcId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              VpcId: {
                locationName: "vpcId"
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RouteTable: {
                shape: "Sn4",
                locationName: "routeTable"
              }
            }
          }
        },
        CreateSecurityGroup: {
          input: {
            type: "structure",
            required: [
              "Description",
              "GroupName"
            ],
            members: {
              Description: {
                locationName: "GroupDescription"
              },
              GroupName: {},
              VpcId: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GroupId: {
                locationName: "groupId"
              },
              Tags: {
                shape: "S6",
                locationName: "tagSet"
              }
            }
          }
        },
        CreateSnapshot: {
          input: {
            type: "structure",
            required: [
              "VolumeId"
            ],
            members: {
              Description: {},
              OutpostArn: {},
              VolumeId: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            shape: "Sng"
          }
        },
        CreateSnapshots: {
          input: {
            type: "structure",
            required: [
              "InstanceSpecification"
            ],
            members: {
              Description: {},
              InstanceSpecification: {
                type: "structure",
                required: [
                  "InstanceId"
                ],
                members: {
                  InstanceId: {},
                  ExcludeBootVolume: {
                    type: "boolean"
                  },
                  ExcludeDataVolumeIds: {
                    shape: "Snn",
                    locationName: "ExcludeDataVolumeId"
                  }
                }
              },
              OutpostArn: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              },
              CopyTagsFromSource: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Snapshots: {
                locationName: "snapshotSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Description: {
                      locationName: "description"
                    },
                    Tags: {
                      shape: "S6",
                      locationName: "tagSet"
                    },
                    Encrypted: {
                      locationName: "encrypted",
                      type: "boolean"
                    },
                    VolumeId: {
                      locationName: "volumeId"
                    },
                    State: {
                      locationName: "state"
                    },
                    VolumeSize: {
                      locationName: "volumeSize",
                      type: "integer"
                    },
                    StartTime: {
                      locationName: "startTime",
                      type: "timestamp"
                    },
                    Progress: {
                      locationName: "progress"
                    },
                    OwnerId: {
                      locationName: "ownerId"
                    },
                    SnapshotId: {
                      locationName: "snapshotId"
                    },
                    OutpostArn: {
                      locationName: "outpostArn"
                    },
                    SseType: {
                      locationName: "sseType"
                    }
                  }
                }
              }
            }
          }
        },
        CreateSpotDatafeedSubscription: {
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                locationName: "bucket"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              Prefix: {
                locationName: "prefix"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SpotDatafeedSubscription: {
                shape: "Snu",
                locationName: "spotDatafeedSubscription"
              }
            }
          }
        },
        CreateStoreImageTask: {
          input: {
            type: "structure",
            required: [
              "ImageId",
              "Bucket"
            ],
            members: {
              ImageId: {},
              Bucket: {},
              S3ObjectTags: {
                locationName: "S3ObjectTag",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Key: {},
                    Value: {}
                  }
                }
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ObjectKey: {
                locationName: "objectKey"
              }
            }
          }
        },
        CreateSubnet: {
          input: {
            type: "structure",
            required: [
              "VpcId"
            ],
            members: {
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              AvailabilityZone: {},
              AvailabilityZoneId: {},
              CidrBlock: {},
              Ipv6CidrBlock: {},
              OutpostArn: {},
              VpcId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              Ipv6Native: {
                type: "boolean"
              },
              Ipv4IpamPoolId: {},
              Ipv4NetmaskLength: {
                type: "integer"
              },
              Ipv6IpamPoolId: {},
              Ipv6NetmaskLength: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Subnet: {
                shape: "Sbg",
                locationName: "subnet"
              }
            }
          }
        },
        CreateSubnetCidrReservation: {
          input: {
            type: "structure",
            required: [
              "SubnetId",
              "Cidr",
              "ReservationType"
            ],
            members: {
              SubnetId: {},
              Cidr: {},
              ReservationType: {},
              Description: {},
              DryRun: {
                type: "boolean"
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SubnetCidrReservation: {
                shape: "So6",
                locationName: "subnetCidrReservation"
              }
            }
          }
        },
        CreateTags: {
          input: {
            type: "structure",
            required: [
              "Resources",
              "Tags"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              Resources: {
                shape: "So9",
                locationName: "ResourceId"
              },
              Tags: {
                shape: "S6",
                locationName: "Tag"
              }
            }
          }
        },
        CreateTrafficMirrorFilter: {
          input: {
            type: "structure",
            members: {
              Description: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrafficMirrorFilter: {
                shape: "Sod",
                locationName: "trafficMirrorFilter"
              },
              ClientToken: {
                locationName: "clientToken"
              }
            }
          }
        },
        CreateTrafficMirrorFilterRule: {
          input: {
            type: "structure",
            required: [
              "TrafficMirrorFilterId",
              "TrafficDirection",
              "RuleNumber",
              "RuleAction",
              "DestinationCidrBlock",
              "SourceCidrBlock"
            ],
            members: {
              TrafficMirrorFilterId: {},
              TrafficDirection: {},
              RuleNumber: {
                type: "integer"
              },
              RuleAction: {},
              DestinationPortRange: {
                shape: "Son"
              },
              SourcePortRange: {
                shape: "Son"
              },
              Protocol: {
                type: "integer"
              },
              DestinationCidrBlock: {},
              SourceCidrBlock: {},
              Description: {},
              DryRun: {
                type: "boolean"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrafficMirrorFilterRule: {
                shape: "Sof",
                locationName: "trafficMirrorFilterRule"
              },
              ClientToken: {
                locationName: "clientToken"
              }
            }
          }
        },
        CreateTrafficMirrorSession: {
          input: {
            type: "structure",
            required: [
              "NetworkInterfaceId",
              "TrafficMirrorTargetId",
              "TrafficMirrorFilterId",
              "SessionNumber"
            ],
            members: {
              NetworkInterfaceId: {},
              TrafficMirrorTargetId: {},
              TrafficMirrorFilterId: {},
              PacketLength: {
                type: "integer"
              },
              SessionNumber: {
                type: "integer"
              },
              VirtualNetworkId: {
                type: "integer"
              },
              Description: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrafficMirrorSession: {
                shape: "Sos",
                locationName: "trafficMirrorSession"
              },
              ClientToken: {
                locationName: "clientToken"
              }
            }
          }
        },
        CreateTrafficMirrorTarget: {
          input: {
            type: "structure",
            members: {
              NetworkInterfaceId: {},
              NetworkLoadBalancerArn: {},
              Description: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              },
              ClientToken: {
                idempotencyToken: true
              },
              GatewayLoadBalancerEndpointId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrafficMirrorTarget: {
                shape: "Sov",
                locationName: "trafficMirrorTarget"
              },
              ClientToken: {
                locationName: "clientToken"
              }
            }
          }
        },
        CreateTransitGateway: {
          input: {
            type: "structure",
            members: {
              Description: {},
              Options: {
                type: "structure",
                members: {
                  AmazonSideAsn: {
                    type: "long"
                  },
                  AutoAcceptSharedAttachments: {},
                  DefaultRouteTableAssociation: {},
                  DefaultRouteTablePropagation: {},
                  VpnEcmpSupport: {},
                  DnsSupport: {},
                  SecurityGroupReferencingSupport: {},
                  MulticastSupport: {},
                  TransitGatewayCidrBlocks: {
                    shape: "Sp4"
                  }
                }
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGateway: {
                shape: "Sp6",
                locationName: "transitGateway"
              }
            }
          }
        },
        CreateTransitGatewayConnect: {
          input: {
            type: "structure",
            required: [
              "TransportTransitGatewayAttachmentId",
              "Options"
            ],
            members: {
              TransportTransitGatewayAttachmentId: {},
              Options: {
                type: "structure",
                required: [
                  "Protocol"
                ],
                members: {
                  Protocol: {}
                }
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayConnect: {
                shape: "Spd",
                locationName: "transitGatewayConnect"
              }
            }
          }
        },
        CreateTransitGatewayConnectPeer: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayAttachmentId",
              "PeerAddress",
              "InsideCidrBlocks"
            ],
            members: {
              TransitGatewayAttachmentId: {},
              TransitGatewayAddress: {},
              PeerAddress: {},
              BgpOptions: {
                type: "structure",
                members: {
                  PeerAsn: {
                    type: "long"
                  }
                }
              },
              InsideCidrBlocks: {
                shape: "Sph"
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayConnectPeer: {
                shape: "Spj",
                locationName: "transitGatewayConnectPeer"
              }
            }
          }
        },
        CreateTransitGatewayMulticastDomain: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayId"
            ],
            members: {
              TransitGatewayId: {},
              Options: {
                type: "structure",
                members: {
                  Igmpv2Support: {},
                  StaticSourcesSupport: {},
                  AutoAcceptSharedAssociations: {}
                }
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayMulticastDomain: {
                shape: "Spw",
                locationName: "transitGatewayMulticastDomain"
              }
            }
          }
        },
        CreateTransitGatewayPeeringAttachment: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayId",
              "PeerTransitGatewayId",
              "PeerAccountId",
              "PeerRegion"
            ],
            members: {
              TransitGatewayId: {},
              PeerTransitGatewayId: {},
              PeerAccountId: {},
              PeerRegion: {},
              Options: {
                type: "structure",
                members: {
                  DynamicRouting: {}
                }
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayPeeringAttachment: {
                shape: "Sx",
                locationName: "transitGatewayPeeringAttachment"
              }
            }
          }
        },
        CreateTransitGatewayPolicyTable: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayId"
            ],
            members: {
              TransitGatewayId: {},
              TagSpecifications: {
                shape: "S3"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayPolicyTable: {
                shape: "Sq5",
                locationName: "transitGatewayPolicyTable"
              }
            }
          }
        },
        CreateTransitGatewayPrefixListReference: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayRouteTableId",
              "PrefixListId"
            ],
            members: {
              TransitGatewayRouteTableId: {},
              PrefixListId: {},
              TransitGatewayAttachmentId: {},
              Blackhole: {
                type: "boolean"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayPrefixListReference: {
                shape: "Sq9",
                locationName: "transitGatewayPrefixListReference"
              }
            }
          }
        },
        CreateTransitGatewayRoute: {
          input: {
            type: "structure",
            required: [
              "DestinationCidrBlock",
              "TransitGatewayRouteTableId"
            ],
            members: {
              DestinationCidrBlock: {},
              TransitGatewayRouteTableId: {},
              TransitGatewayAttachmentId: {},
              Blackhole: {
                type: "boolean"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Route: {
                shape: "Sqe",
                locationName: "route"
              }
            }
          }
        },
        CreateTransitGatewayRouteTable: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayId"
            ],
            members: {
              TransitGatewayId: {},
              TagSpecifications: {
                shape: "S3"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayRouteTable: {
                shape: "Sqm",
                locationName: "transitGatewayRouteTable"
              }
            }
          }
        },
        CreateTransitGatewayRouteTableAnnouncement: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayRouteTableId",
              "PeeringAttachmentId"
            ],
            members: {
              TransitGatewayRouteTableId: {},
              PeeringAttachmentId: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayRouteTableAnnouncement: {
                shape: "Sqq",
                locationName: "transitGatewayRouteTableAnnouncement"
              }
            }
          }
        },
        CreateTransitGatewayVpcAttachment: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayId",
              "VpcId",
              "SubnetIds"
            ],
            members: {
              TransitGatewayId: {},
              VpcId: {},
              SubnetIds: {
                shape: "S57"
              },
              Options: {
                type: "structure",
                members: {
                  DnsSupport: {},
                  SecurityGroupReferencingSupport: {},
                  Ipv6Support: {},
                  ApplianceModeSupport: {}
                }
              },
              TagSpecifications: {
                shape: "S3"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayVpcAttachment: {
                shape: "S16",
                locationName: "transitGatewayVpcAttachment"
              }
            }
          }
        },
        CreateVerifiedAccessEndpoint: {
          input: {
            type: "structure",
            required: [
              "VerifiedAccessGroupId",
              "EndpointType",
              "AttachmentType",
              "DomainCertificateArn",
              "ApplicationDomain",
              "EndpointDomainPrefix"
            ],
            members: {
              VerifiedAccessGroupId: {},
              EndpointType: {},
              AttachmentType: {},
              DomainCertificateArn: {},
              ApplicationDomain: {},
              EndpointDomainPrefix: {},
              SecurityGroupIds: {
                shape: "Sr1",
                locationName: "SecurityGroupId"
              },
              LoadBalancerOptions: {
                type: "structure",
                members: {
                  Protocol: {},
                  Port: {
                    type: "integer"
                  },
                  LoadBalancerArn: {},
                  SubnetIds: {
                    locationName: "SubnetId",
                    type: "list",
                    member: {
                      locationName: "item"
                    }
                  }
                }
              },
              NetworkInterfaceOptions: {
                type: "structure",
                members: {
                  NetworkInterfaceId: {},
                  Protocol: {},
                  Port: {
                    type: "integer"
                  }
                }
              },
              Description: {},
              PolicyDocument: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              ClientToken: {
                idempotencyToken: true
              },
              DryRun: {
                type: "boolean"
              },
              SseSpecification: {
                shape: "Sr8"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VerifiedAccessEndpoint: {
                shape: "Sra",
                locationName: "verifiedAccessEndpoint"
              }
            }
          }
        },
        CreateVerifiedAccessGroup: {
          input: {
            type: "structure",
            required: [
              "VerifiedAccessInstanceId"
            ],
            members: {
              VerifiedAccessInstanceId: {},
              Description: {},
              PolicyDocument: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              ClientToken: {
                idempotencyToken: true
              },
              DryRun: {
                type: "boolean"
              },
              SseSpecification: {
                shape: "Sr8"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VerifiedAccessGroup: {
                shape: "Sri",
                locationName: "verifiedAccessGroup"
              }
            }
          }
        },
        CreateVerifiedAccessInstance: {
          input: {
            type: "structure",
            members: {
              Description: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              ClientToken: {
                idempotencyToken: true
              },
              DryRun: {
                type: "boolean"
              },
              FIPSEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VerifiedAccessInstance: {
                shape: "S6g",
                locationName: "verifiedAccessInstance"
              }
            }
          }
        },
        CreateVerifiedAccessTrustProvider: {
          input: {
            type: "structure",
            required: [
              "TrustProviderType",
              "PolicyReferenceName"
            ],
            members: {
              TrustProviderType: {},
              UserTrustProviderType: {},
              DeviceTrustProviderType: {},
              OidcOptions: {
                type: "structure",
                members: {
                  Issuer: {},
                  AuthorizationEndpoint: {},
                  TokenEndpoint: {},
                  UserInfoEndpoint: {},
                  ClientId: {},
                  ClientSecret: {
                    shape: "S6c"
                  },
                  Scope: {}
                }
              },
              DeviceOptions: {
                type: "structure",
                members: {
                  TenantId: {},
                  PublicSigningKeyUrl: {}
                }
              },
              PolicyReferenceName: {},
              Description: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              ClientToken: {
                idempotencyToken: true
              },
              DryRun: {
                type: "boolean"
              },
              SseSpecification: {
                shape: "Sr8"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VerifiedAccessTrustProvider: {
                shape: "S67",
                locationName: "verifiedAccessTrustProvider"
              }
            }
          }
        },
        CreateVolume: {
          input: {
            type: "structure",
            required: [
              "AvailabilityZone"
            ],
            members: {
              AvailabilityZone: {},
              Encrypted: {
                locationName: "encrypted",
                type: "boolean"
              },
              Iops: {
                type: "integer"
              },
              KmsKeyId: {},
              OutpostArn: {},
              Size: {
                type: "integer"
              },
              SnapshotId: {},
              VolumeType: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              MultiAttachEnabled: {
                type: "boolean"
              },
              Throughput: {
                type: "integer"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            shape: "Srq"
          }
        },
        CreateVpc: {
          input: {
            type: "structure",
            members: {
              CidrBlock: {},
              AmazonProvidedIpv6CidrBlock: {
                locationName: "amazonProvidedIpv6CidrBlock",
                type: "boolean"
              },
              Ipv6Pool: {},
              Ipv6CidrBlock: {},
              Ipv4IpamPoolId: {},
              Ipv4NetmaskLength: {
                type: "integer"
              },
              Ipv6IpamPoolId: {},
              Ipv6NetmaskLength: {
                type: "integer"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              InstanceTenancy: {
                locationName: "instanceTenancy"
              },
              Ipv6CidrBlockNetworkBorderGroup: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Vpc: {
                shape: "Sbo",
                locationName: "vpc"
              }
            }
          }
        },
        CreateVpcEndpoint: {
          input: {
            type: "structure",
            required: [
              "VpcId",
              "ServiceName"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              VpcEndpointType: {},
              VpcId: {},
              ServiceName: {},
              PolicyDocument: {},
              RouteTableIds: {
                shape: "Srx",
                locationName: "RouteTableId"
              },
              SubnetIds: {
                shape: "Sry",
                locationName: "SubnetId"
              },
              SecurityGroupIds: {
                shape: "Srz",
                locationName: "SecurityGroupId"
              },
              IpAddressType: {},
              DnsOptions: {
                shape: "Ss1"
              },
              ClientToken: {},
              PrivateDnsEnabled: {
                type: "boolean"
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              SubnetConfigurations: {
                shape: "Ss3",
                locationName: "SubnetConfiguration"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpcEndpoint: {
                shape: "Ss6",
                locationName: "vpcEndpoint"
              },
              ClientToken: {
                locationName: "clientToken"
              }
            }
          }
        },
        CreateVpcEndpointConnectionNotification: {
          input: {
            type: "structure",
            required: [
              "ConnectionNotificationArn",
              "ConnectionEvents"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ServiceId: {},
              VpcEndpointId: {},
              ConnectionNotificationArn: {},
              ConnectionEvents: {
                shape: "So"
              },
              ClientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionNotification: {
                shape: "Ssg",
                locationName: "connectionNotification"
              },
              ClientToken: {
                locationName: "clientToken"
              }
            }
          }
        },
        CreateVpcEndpointServiceConfiguration: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              AcceptanceRequired: {
                type: "boolean"
              },
              PrivateDnsName: {},
              NetworkLoadBalancerArns: {
                shape: "So",
                locationName: "NetworkLoadBalancerArn"
              },
              GatewayLoadBalancerArns: {
                shape: "So",
                locationName: "GatewayLoadBalancerArn"
              },
              SupportedIpAddressTypes: {
                shape: "So",
                locationName: "SupportedIpAddressType"
              },
              ClientToken: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceConfiguration: {
                shape: "Ssl",
                locationName: "serviceConfiguration"
              },
              ClientToken: {
                locationName: "clientToken"
              }
            }
          }
        },
        CreateVpcPeeringConnection: {
          input: {
            type: "structure",
            required: [
              "VpcId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              PeerOwnerId: {
                locationName: "peerOwnerId"
              },
              PeerVpcId: {
                locationName: "peerVpcId"
              },
              VpcId: {
                locationName: "vpcId"
              },
              PeerRegion: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpcPeeringConnection: {
                shape: "S1n",
                locationName: "vpcPeeringConnection"
              }
            }
          }
        },
        CreateVpnConnection: {
          input: {
            type: "structure",
            required: [
              "CustomerGatewayId",
              "Type"
            ],
            members: {
              CustomerGatewayId: {},
              Type: {},
              VpnGatewayId: {},
              TransitGatewayId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              Options: {
                locationName: "options",
                type: "structure",
                members: {
                  EnableAcceleration: {
                    type: "boolean"
                  },
                  StaticRoutesOnly: {
                    locationName: "staticRoutesOnly",
                    type: "boolean"
                  },
                  TunnelInsideIpVersion: {},
                  TunnelOptions: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        TunnelInsideCidr: {},
                        TunnelInsideIpv6Cidr: {},
                        PreSharedKey: {
                          shape: "St3"
                        },
                        Phase1LifetimeSeconds: {
                          type: "integer"
                        },
                        Phase2LifetimeSeconds: {
                          type: "integer"
                        },
                        RekeyMarginTimeSeconds: {
                          type: "integer"
                        },
                        RekeyFuzzPercentage: {
                          type: "integer"
                        },
                        ReplayWindowSize: {
                          type: "integer"
                        },
                        DPDTimeoutSeconds: {
                          type: "integer"
                        },
                        DPDTimeoutAction: {},
                        Phase1EncryptionAlgorithms: {
                          shape: "St4",
                          locationName: "Phase1EncryptionAlgorithm"
                        },
                        Phase2EncryptionAlgorithms: {
                          shape: "St6",
                          locationName: "Phase2EncryptionAlgorithm"
                        },
                        Phase1IntegrityAlgorithms: {
                          shape: "St8",
                          locationName: "Phase1IntegrityAlgorithm"
                        },
                        Phase2IntegrityAlgorithms: {
                          shape: "Sta",
                          locationName: "Phase2IntegrityAlgorithm"
                        },
                        Phase1DHGroupNumbers: {
                          shape: "Stc",
                          locationName: "Phase1DHGroupNumber"
                        },
                        Phase2DHGroupNumbers: {
                          shape: "Ste",
                          locationName: "Phase2DHGroupNumber"
                        },
                        IKEVersions: {
                          shape: "Stg",
                          locationName: "IKEVersion"
                        },
                        StartupAction: {},
                        LogOptions: {
                          shape: "Sti"
                        },
                        EnableTunnelLifecycleControl: {
                          type: "boolean"
                        }
                      }
                    }
                  },
                  LocalIpv4NetworkCidr: {},
                  RemoteIpv4NetworkCidr: {},
                  LocalIpv6NetworkCidr: {},
                  RemoteIpv6NetworkCidr: {},
                  OutsideIpAddressType: {},
                  TransportTransitGatewayAttachmentId: {}
                }
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpnConnection: {
                shape: "Stm",
                locationName: "vpnConnection"
              }
            }
          }
        },
        CreateVpnConnectionRoute: {
          input: {
            type: "structure",
            required: [
              "DestinationCidrBlock",
              "VpnConnectionId"
            ],
            members: {
              DestinationCidrBlock: {},
              VpnConnectionId: {}
            }
          }
        },
        CreateVpnGateway: {
          input: {
            type: "structure",
            required: [
              "Type"
            ],
            members: {
              AvailabilityZone: {},
              Type: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              AmazonSideAsn: {
                type: "long"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpnGateway: {
                shape: "Suj",
                locationName: "vpnGateway"
              }
            }
          }
        },
        DeleteCarrierGateway: {
          input: {
            type: "structure",
            required: [
              "CarrierGatewayId"
            ],
            members: {
              CarrierGatewayId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CarrierGateway: {
                shape: "Sag",
                locationName: "carrierGateway"
              }
            }
          }
        },
        DeleteClientVpnEndpoint: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId"
            ],
            members: {
              ClientVpnEndpointId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                shape: "Saw",
                locationName: "status"
              }
            }
          }
        },
        DeleteClientVpnRoute: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId",
              "DestinationCidrBlock"
            ],
            members: {
              ClientVpnEndpointId: {},
              TargetVpcSubnetId: {},
              DestinationCidrBlock: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                shape: "Sb0",
                locationName: "status"
              }
            }
          }
        },
        DeleteCoipCidr: {
          input: {
            type: "structure",
            required: [
              "Cidr",
              "CoipPoolId"
            ],
            members: {
              Cidr: {},
              CoipPoolId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CoipCidr: {
                shape: "Sb5",
                locationName: "coipCidr"
              }
            }
          }
        },
        DeleteCoipPool: {
          input: {
            type: "structure",
            required: [
              "CoipPoolId"
            ],
            members: {
              CoipPoolId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CoipPool: {
                shape: "Sb9",
                locationName: "coipPool"
              }
            }
          }
        },
        DeleteCustomerGateway: {
          input: {
            type: "structure",
            required: [
              "CustomerGatewayId"
            ],
            members: {
              CustomerGatewayId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        DeleteDhcpOptions: {
          input: {
            type: "structure",
            required: [
              "DhcpOptionsId"
            ],
            members: {
              DhcpOptionsId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        DeleteEgressOnlyInternetGateway: {
          input: {
            type: "structure",
            required: [
              "EgressOnlyInternetGatewayId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              EgressOnlyInternetGatewayId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReturnCode: {
                locationName: "returnCode",
                type: "boolean"
              }
            }
          }
        },
        DeleteFleets: {
          input: {
            type: "structure",
            required: [
              "FleetIds",
              "TerminateInstances"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              FleetIds: {
                shape: "Sv1",
                locationName: "FleetId"
              },
              TerminateInstances: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SuccessfulFleetDeletions: {
                locationName: "successfulFleetDeletionSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    CurrentFleetState: {
                      locationName: "currentFleetState"
                    },
                    PreviousFleetState: {
                      locationName: "previousFleetState"
                    },
                    FleetId: {
                      locationName: "fleetId"
                    }
                  }
                }
              },
              UnsuccessfulFleetDeletions: {
                locationName: "unsuccessfulFleetDeletionSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Error: {
                      locationName: "error",
                      type: "structure",
                      members: {
                        Code: {
                          locationName: "code"
                        },
                        Message: {
                          locationName: "message"
                        }
                      }
                    },
                    FleetId: {
                      locationName: "fleetId"
                    }
                  }
                }
              }
            }
          }
        },
        DeleteFlowLogs: {
          input: {
            type: "structure",
            required: [
              "FlowLogIds"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              FlowLogIds: {
                shape: "Svb",
                locationName: "FlowLogId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Unsuccessful: {
                shape: "S1h",
                locationName: "unsuccessful"
              }
            }
          }
        },
        DeleteFpgaImage: {
          input: {
            type: "structure",
            required: [
              "FpgaImageId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              FpgaImageId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        DeleteInstanceConnectEndpoint: {
          input: {
            type: "structure",
            required: [
              "InstanceConnectEndpointId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              InstanceConnectEndpointId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceConnectEndpoint: {
                shape: "Sf0",
                locationName: "instanceConnectEndpoint"
              }
            }
          }
        },
        DeleteInstanceEventWindow: {
          input: {
            type: "structure",
            required: [
              "InstanceEventWindowId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ForceDelete: {
                type: "boolean"
              },
              InstanceEventWindowId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceEventWindowState: {
                locationName: "instanceEventWindowState",
                type: "structure",
                members: {
                  InstanceEventWindowId: {
                    locationName: "instanceEventWindowId"
                  },
                  State: {
                    locationName: "state"
                  }
                }
              }
            }
          }
        },
        DeleteInternetGateway: {
          input: {
            type: "structure",
            required: [
              "InternetGatewayId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              InternetGatewayId: {
                locationName: "internetGatewayId"
              }
            }
          }
        },
        DeleteIpam: {
          input: {
            type: "structure",
            required: [
              "IpamId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              IpamId: {},
              Cascade: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Ipam: {
                shape: "Sfr",
                locationName: "ipam"
              }
            }
          }
        },
        DeleteIpamPool: {
          input: {
            type: "structure",
            required: [
              "IpamPoolId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              IpamPoolId: {},
              Cascade: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IpamPool: {
                shape: "Sg6",
                locationName: "ipamPool"
              }
            }
          }
        },
        DeleteIpamResourceDiscovery: {
          input: {
            type: "structure",
            required: [
              "IpamResourceDiscoveryId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              IpamResourceDiscoveryId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IpamResourceDiscovery: {
                shape: "Sge",
                locationName: "ipamResourceDiscovery"
              }
            }
          }
        },
        DeleteIpamScope: {
          input: {
            type: "structure",
            required: [
              "IpamScopeId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              IpamScopeId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IpamScope: {
                shape: "Sgi",
                locationName: "ipamScope"
              }
            }
          }
        },
        DeleteKeyPair: {
          input: {
            type: "structure",
            members: {
              KeyName: {},
              KeyPairId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              },
              KeyPairId: {
                locationName: "keyPairId"
              }
            }
          }
        },
        DeleteLaunchTemplate: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              LaunchTemplateId: {},
              LaunchTemplateName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LaunchTemplate: {
                shape: "Sic",
                locationName: "launchTemplate"
              }
            }
          }
        },
        DeleteLaunchTemplateVersions: {
          input: {
            type: "structure",
            required: [
              "Versions"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              LaunchTemplateId: {},
              LaunchTemplateName: {},
              Versions: {
                shape: "Sw1",
                locationName: "LaunchTemplateVersion"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SuccessfullyDeletedLaunchTemplateVersions: {
                locationName: "successfullyDeletedLaunchTemplateVersionSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    LaunchTemplateId: {
                      locationName: "launchTemplateId"
                    },
                    LaunchTemplateName: {
                      locationName: "launchTemplateName"
                    },
                    VersionNumber: {
                      locationName: "versionNumber",
                      type: "long"
                    }
                  }
                }
              },
              UnsuccessfullyDeletedLaunchTemplateVersions: {
                locationName: "unsuccessfullyDeletedLaunchTemplateVersionSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    LaunchTemplateId: {
                      locationName: "launchTemplateId"
                    },
                    LaunchTemplateName: {
                      locationName: "launchTemplateName"
                    },
                    VersionNumber: {
                      locationName: "versionNumber",
                      type: "long"
                    },
                    ResponseError: {
                      locationName: "responseError",
                      type: "structure",
                      members: {
                        Code: {
                          locationName: "code"
                        },
                        Message: {
                          locationName: "message"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DeleteLocalGatewayRoute: {
          input: {
            type: "structure",
            required: [
              "LocalGatewayRouteTableId"
            ],
            members: {
              DestinationCidrBlock: {},
              LocalGatewayRouteTableId: {},
              DryRun: {
                type: "boolean"
              },
              DestinationPrefixListId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Route: {
                shape: "Sjo",
                locationName: "route"
              }
            }
          }
        },
        DeleteLocalGatewayRouteTable: {
          input: {
            type: "structure",
            required: [
              "LocalGatewayRouteTableId"
            ],
            members: {
              LocalGatewayRouteTableId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocalGatewayRouteTable: {
                shape: "Sjv",
                locationName: "localGatewayRouteTable"
              }
            }
          }
        },
        DeleteLocalGatewayRouteTableVirtualInterfaceGroupAssociation: {
          input: {
            type: "structure",
            required: [
              "LocalGatewayRouteTableVirtualInterfaceGroupAssociationId"
            ],
            members: {
              LocalGatewayRouteTableVirtualInterfaceGroupAssociationId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocalGatewayRouteTableVirtualInterfaceGroupAssociation: {
                shape: "Sjz",
                locationName: "localGatewayRouteTableVirtualInterfaceGroupAssociation"
              }
            }
          }
        },
        DeleteLocalGatewayRouteTableVpcAssociation: {
          input: {
            type: "structure",
            required: [
              "LocalGatewayRouteTableVpcAssociationId"
            ],
            members: {
              LocalGatewayRouteTableVpcAssociationId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocalGatewayRouteTableVpcAssociation: {
                shape: "Sk3",
                locationName: "localGatewayRouteTableVpcAssociation"
              }
            }
          }
        },
        DeleteManagedPrefixList: {
          input: {
            type: "structure",
            required: [
              "PrefixListId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              PrefixListId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PrefixList: {
                shape: "Sk9",
                locationName: "prefixList"
              }
            }
          }
        },
        DeleteNatGateway: {
          input: {
            type: "structure",
            required: [
              "NatGatewayId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              NatGatewayId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NatGatewayId: {
                locationName: "natGatewayId"
              }
            }
          }
        },
        DeleteNetworkAcl: {
          input: {
            type: "structure",
            required: [
              "NetworkAclId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              NetworkAclId: {
                locationName: "networkAclId"
              }
            }
          }
        },
        DeleteNetworkAclEntry: {
          input: {
            type: "structure",
            required: [
              "Egress",
              "NetworkAclId",
              "RuleNumber"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              Egress: {
                locationName: "egress",
                type: "boolean"
              },
              NetworkAclId: {
                locationName: "networkAclId"
              },
              RuleNumber: {
                locationName: "ruleNumber",
                type: "integer"
              }
            }
          }
        },
        DeleteNetworkInsightsAccessScope: {
          input: {
            type: "structure",
            required: [
              "NetworkInsightsAccessScopeId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              NetworkInsightsAccessScopeId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkInsightsAccessScopeId: {
                locationName: "networkInsightsAccessScopeId"
              }
            }
          }
        },
        DeleteNetworkInsightsAccessScopeAnalysis: {
          input: {
            type: "structure",
            required: [
              "NetworkInsightsAccessScopeAnalysisId"
            ],
            members: {
              NetworkInsightsAccessScopeAnalysisId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkInsightsAccessScopeAnalysisId: {
                locationName: "networkInsightsAccessScopeAnalysisId"
              }
            }
          }
        },
        DeleteNetworkInsightsAnalysis: {
          input: {
            type: "structure",
            required: [
              "NetworkInsightsAnalysisId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              NetworkInsightsAnalysisId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkInsightsAnalysisId: {
                locationName: "networkInsightsAnalysisId"
              }
            }
          }
        },
        DeleteNetworkInsightsPath: {
          input: {
            type: "structure",
            required: [
              "NetworkInsightsPathId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              NetworkInsightsPathId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkInsightsPathId: {
                locationName: "networkInsightsPathId"
              }
            }
          }
        },
        DeleteNetworkInterface: {
          input: {
            type: "structure",
            required: [
              "NetworkInterfaceId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              }
            }
          }
        },
        DeleteNetworkInterfacePermission: {
          input: {
            type: "structure",
            required: [
              "NetworkInterfacePermissionId"
            ],
            members: {
              NetworkInterfacePermissionId: {},
              Force: {
                type: "boolean"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        DeletePlacementGroup: {
          input: {
            type: "structure",
            required: [
              "GroupName"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              GroupName: {
                locationName: "groupName"
              }
            }
          }
        },
        DeletePublicIpv4Pool: {
          input: {
            type: "structure",
            required: [
              "PoolId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              PoolId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReturnValue: {
                locationName: "returnValue",
                type: "boolean"
              }
            }
          }
        },
        DeleteQueuedReservedInstances: {
          input: {
            type: "structure",
            required: [
              "ReservedInstancesIds"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ReservedInstancesIds: {
                locationName: "ReservedInstancesId",
                type: "list",
                member: {
                  locationName: "item"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SuccessfulQueuedPurchaseDeletions: {
                locationName: "successfulQueuedPurchaseDeletionSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ReservedInstancesId: {
                      locationName: "reservedInstancesId"
                    }
                  }
                }
              },
              FailedQueuedPurchaseDeletions: {
                locationName: "failedQueuedPurchaseDeletionSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Error: {
                      locationName: "error",
                      type: "structure",
                      members: {
                        Code: {
                          locationName: "code"
                        },
                        Message: {
                          locationName: "message"
                        }
                      }
                    },
                    ReservedInstancesId: {
                      locationName: "reservedInstancesId"
                    }
                  }
                }
              }
            }
          }
        },
        DeleteRoute: {
          input: {
            type: "structure",
            required: [
              "RouteTableId"
            ],
            members: {
              DestinationCidrBlock: {
                locationName: "destinationCidrBlock"
              },
              DestinationIpv6CidrBlock: {
                locationName: "destinationIpv6CidrBlock"
              },
              DestinationPrefixListId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              RouteTableId: {
                locationName: "routeTableId"
              }
            }
          }
        },
        DeleteRouteTable: {
          input: {
            type: "structure",
            required: [
              "RouteTableId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              RouteTableId: {
                locationName: "routeTableId"
              }
            }
          }
        },
        DeleteSecurityGroup: {
          input: {
            type: "structure",
            members: {
              GroupId: {},
              GroupName: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        DeleteSnapshot: {
          input: {
            type: "structure",
            required: [
              "SnapshotId"
            ],
            members: {
              SnapshotId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        DeleteSpotDatafeedSubscription: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        DeleteSubnet: {
          input: {
            type: "structure",
            required: [
              "SubnetId"
            ],
            members: {
              SubnetId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        DeleteSubnetCidrReservation: {
          input: {
            type: "structure",
            required: [
              "SubnetCidrReservationId"
            ],
            members: {
              SubnetCidrReservationId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeletedSubnetCidrReservation: {
                shape: "So6",
                locationName: "deletedSubnetCidrReservation"
              }
            }
          }
        },
        DeleteTags: {
          input: {
            type: "structure",
            required: [
              "Resources"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              Resources: {
                shape: "So9",
                locationName: "resourceId"
              },
              Tags: {
                shape: "S6",
                locationName: "tag"
              }
            }
          }
        },
        DeleteTrafficMirrorFilter: {
          input: {
            type: "structure",
            required: [
              "TrafficMirrorFilterId"
            ],
            members: {
              TrafficMirrorFilterId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrafficMirrorFilterId: {
                locationName: "trafficMirrorFilterId"
              }
            }
          }
        },
        DeleteTrafficMirrorFilterRule: {
          input: {
            type: "structure",
            required: [
              "TrafficMirrorFilterRuleId"
            ],
            members: {
              TrafficMirrorFilterRuleId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrafficMirrorFilterRuleId: {
                locationName: "trafficMirrorFilterRuleId"
              }
            }
          }
        },
        DeleteTrafficMirrorSession: {
          input: {
            type: "structure",
            required: [
              "TrafficMirrorSessionId"
            ],
            members: {
              TrafficMirrorSessionId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrafficMirrorSessionId: {
                locationName: "trafficMirrorSessionId"
              }
            }
          }
        },
        DeleteTrafficMirrorTarget: {
          input: {
            type: "structure",
            required: [
              "TrafficMirrorTargetId"
            ],
            members: {
              TrafficMirrorTargetId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrafficMirrorTargetId: {
                locationName: "trafficMirrorTargetId"
              }
            }
          }
        },
        DeleteTransitGateway: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayId"
            ],
            members: {
              TransitGatewayId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGateway: {
                shape: "Sp6",
                locationName: "transitGateway"
              }
            }
          }
        },
        DeleteTransitGatewayConnect: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayAttachmentId"
            ],
            members: {
              TransitGatewayAttachmentId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayConnect: {
                shape: "Spd",
                locationName: "transitGatewayConnect"
              }
            }
          }
        },
        DeleteTransitGatewayConnectPeer: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayConnectPeerId"
            ],
            members: {
              TransitGatewayConnectPeerId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayConnectPeer: {
                shape: "Spj",
                locationName: "transitGatewayConnectPeer"
              }
            }
          }
        },
        DeleteTransitGatewayMulticastDomain: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayMulticastDomainId"
            ],
            members: {
              TransitGatewayMulticastDomainId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayMulticastDomain: {
                shape: "Spw",
                locationName: "transitGatewayMulticastDomain"
              }
            }
          }
        },
        DeleteTransitGatewayPeeringAttachment: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayAttachmentId"
            ],
            members: {
              TransitGatewayAttachmentId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayPeeringAttachment: {
                shape: "Sx",
                locationName: "transitGatewayPeeringAttachment"
              }
            }
          }
        },
        DeleteTransitGatewayPolicyTable: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayPolicyTableId"
            ],
            members: {
              TransitGatewayPolicyTableId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayPolicyTable: {
                shape: "Sq5",
                locationName: "transitGatewayPolicyTable"
              }
            }
          }
        },
        DeleteTransitGatewayPrefixListReference: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayRouteTableId",
              "PrefixListId"
            ],
            members: {
              TransitGatewayRouteTableId: {},
              PrefixListId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayPrefixListReference: {
                shape: "Sq9",
                locationName: "transitGatewayPrefixListReference"
              }
            }
          }
        },
        DeleteTransitGatewayRoute: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayRouteTableId",
              "DestinationCidrBlock"
            ],
            members: {
              TransitGatewayRouteTableId: {},
              DestinationCidrBlock: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Route: {
                shape: "Sqe",
                locationName: "route"
              }
            }
          }
        },
        DeleteTransitGatewayRouteTable: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayRouteTableId"
            ],
            members: {
              TransitGatewayRouteTableId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayRouteTable: {
                shape: "Sqm",
                locationName: "transitGatewayRouteTable"
              }
            }
          }
        },
        DeleteTransitGatewayRouteTableAnnouncement: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayRouteTableAnnouncementId"
            ],
            members: {
              TransitGatewayRouteTableAnnouncementId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayRouteTableAnnouncement: {
                shape: "Sqq",
                locationName: "transitGatewayRouteTableAnnouncement"
              }
            }
          }
        },
        DeleteTransitGatewayVpcAttachment: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayAttachmentId"
            ],
            members: {
              TransitGatewayAttachmentId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayVpcAttachment: {
                shape: "S16",
                locationName: "transitGatewayVpcAttachment"
              }
            }
          }
        },
        DeleteVerifiedAccessEndpoint: {
          input: {
            type: "structure",
            required: [
              "VerifiedAccessEndpointId"
            ],
            members: {
              VerifiedAccessEndpointId: {},
              ClientToken: {
                idempotencyToken: true
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VerifiedAccessEndpoint: {
                shape: "Sra",
                locationName: "verifiedAccessEndpoint"
              }
            }
          }
        },
        DeleteVerifiedAccessGroup: {
          input: {
            type: "structure",
            required: [
              "VerifiedAccessGroupId"
            ],
            members: {
              VerifiedAccessGroupId: {},
              ClientToken: {
                idempotencyToken: true
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VerifiedAccessGroup: {
                shape: "Sri",
                locationName: "verifiedAccessGroup"
              }
            }
          }
        },
        DeleteVerifiedAccessInstance: {
          input: {
            type: "structure",
            required: [
              "VerifiedAccessInstanceId"
            ],
            members: {
              VerifiedAccessInstanceId: {},
              DryRun: {
                type: "boolean"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VerifiedAccessInstance: {
                shape: "S6g",
                locationName: "verifiedAccessInstance"
              }
            }
          }
        },
        DeleteVerifiedAccessTrustProvider: {
          input: {
            type: "structure",
            required: [
              "VerifiedAccessTrustProviderId"
            ],
            members: {
              VerifiedAccessTrustProviderId: {},
              DryRun: {
                type: "boolean"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VerifiedAccessTrustProvider: {
                shape: "S67",
                locationName: "verifiedAccessTrustProvider"
              }
            }
          }
        },
        DeleteVolume: {
          input: {
            type: "structure",
            required: [
              "VolumeId"
            ],
            members: {
              VolumeId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        DeleteVpc: {
          input: {
            type: "structure",
            required: [
              "VpcId"
            ],
            members: {
              VpcId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        DeleteVpcEndpointConnectionNotifications: {
          input: {
            type: "structure",
            required: [
              "ConnectionNotificationIds"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ConnectionNotificationIds: {
                locationName: "ConnectionNotificationId",
                type: "list",
                member: {
                  locationName: "item"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Unsuccessful: {
                shape: "S1h",
                locationName: "unsuccessful"
              }
            }
          }
        },
        DeleteVpcEndpointServiceConfigurations: {
          input: {
            type: "structure",
            required: [
              "ServiceIds"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ServiceIds: {
                shape: "Syy",
                locationName: "ServiceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Unsuccessful: {
                shape: "S1h",
                locationName: "unsuccessful"
              }
            }
          }
        },
        DeleteVpcEndpoints: {
          input: {
            type: "structure",
            required: [
              "VpcEndpointIds"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              VpcEndpointIds: {
                shape: "S1e",
                locationName: "VpcEndpointId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Unsuccessful: {
                shape: "S1h",
                locationName: "unsuccessful"
              }
            }
          }
        },
        DeleteVpcPeeringConnection: {
          input: {
            type: "structure",
            required: [
              "VpcPeeringConnectionId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              VpcPeeringConnectionId: {
                locationName: "vpcPeeringConnectionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        DeleteVpnConnection: {
          input: {
            type: "structure",
            required: [
              "VpnConnectionId"
            ],
            members: {
              VpnConnectionId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        DeleteVpnConnectionRoute: {
          input: {
            type: "structure",
            required: [
              "DestinationCidrBlock",
              "VpnConnectionId"
            ],
            members: {
              DestinationCidrBlock: {},
              VpnConnectionId: {}
            }
          }
        },
        DeleteVpnGateway: {
          input: {
            type: "structure",
            required: [
              "VpnGatewayId"
            ],
            members: {
              VpnGatewayId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        DeprovisionByoipCidr: {
          input: {
            type: "structure",
            required: [
              "Cidr"
            ],
            members: {
              Cidr: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ByoipCidr: {
                shape: "S1y",
                locationName: "byoipCidr"
              }
            }
          }
        },
        DeprovisionIpamByoasn: {
          input: {
            type: "structure",
            required: [
              "IpamId",
              "Asn"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              IpamId: {},
              Asn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Byoasn: {
                shape: "Szb",
                locationName: "byoasn"
              }
            }
          }
        },
        DeprovisionIpamPoolCidr: {
          input: {
            type: "structure",
            required: [
              "IpamPoolId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              IpamPoolId: {},
              Cidr: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IpamPoolCidr: {
                shape: "Szf",
                locationName: "ipamPoolCidr"
              }
            }
          }
        },
        DeprovisionPublicIpv4PoolCidr: {
          input: {
            type: "structure",
            required: [
              "PoolId",
              "Cidr"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              PoolId: {},
              Cidr: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PoolId: {
                locationName: "poolId"
              },
              DeprovisionedAddresses: {
                locationName: "deprovisionedAddressSet",
                type: "list",
                member: {
                  locationName: "item"
                }
              }
            }
          }
        },
        DeregisterImage: {
          input: {
            type: "structure",
            required: [
              "ImageId"
            ],
            members: {
              ImageId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        DeregisterInstanceEventNotificationAttributes: {
          input: {
            type: "structure",
            required: [
              "InstanceTagAttribute"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              InstanceTagAttribute: {
                type: "structure",
                members: {
                  IncludeAllTagsOfInstance: {
                    type: "boolean"
                  },
                  InstanceTagKeys: {
                    shape: "Szq",
                    locationName: "InstanceTagKey"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceTagAttribute: {
                shape: "Szs",
                locationName: "instanceTagAttribute"
              }
            }
          }
        },
        DeregisterTransitGatewayMulticastGroupMembers: {
          input: {
            type: "structure",
            members: {
              TransitGatewayMulticastDomainId: {},
              GroupIpAddress: {},
              NetworkInterfaceIds: {
                shape: "Szu"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeregisteredMulticastGroupMembers: {
                locationName: "deregisteredMulticastGroupMembers",
                type: "structure",
                members: {
                  TransitGatewayMulticastDomainId: {
                    locationName: "transitGatewayMulticastDomainId"
                  },
                  DeregisteredNetworkInterfaceIds: {
                    shape: "So",
                    locationName: "deregisteredNetworkInterfaceIds"
                  },
                  GroupIpAddress: {
                    locationName: "groupIpAddress"
                  }
                }
              }
            }
          }
        },
        DeregisterTransitGatewayMulticastGroupSources: {
          input: {
            type: "structure",
            members: {
              TransitGatewayMulticastDomainId: {},
              GroupIpAddress: {},
              NetworkInterfaceIds: {
                shape: "Szu"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeregisteredMulticastGroupSources: {
                locationName: "deregisteredMulticastGroupSources",
                type: "structure",
                members: {
                  TransitGatewayMulticastDomainId: {
                    locationName: "transitGatewayMulticastDomainId"
                  },
                  DeregisteredNetworkInterfaceIds: {
                    shape: "So",
                    locationName: "deregisteredNetworkInterfaceIds"
                  },
                  GroupIpAddress: {
                    locationName: "groupIpAddress"
                  }
                }
              }
            }
          }
        },
        DescribeAccountAttributes: {
          input: {
            type: "structure",
            members: {
              AttributeNames: {
                locationName: "attributeName",
                type: "list",
                member: {
                  locationName: "attributeName"
                }
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccountAttributes: {
                locationName: "accountAttributeSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    AttributeName: {
                      locationName: "attributeName"
                    },
                    AttributeValues: {
                      locationName: "attributeValueSet",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          AttributeValue: {
                            locationName: "attributeValue"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeAddressTransfers: {
          input: {
            type: "structure",
            members: {
              AllocationIds: {
                shape: "S4r",
                locationName: "AllocationId"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AddressTransfers: {
                locationName: "addressTransferSet",
                type: "list",
                member: {
                  shape: "Sa",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeAddresses: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              PublicIps: {
                locationName: "PublicIp",
                type: "list",
                member: {
                  locationName: "PublicIp"
                }
              },
              AllocationIds: {
                shape: "S4r",
                locationName: "AllocationId"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Addresses: {
                locationName: "addressesSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    InstanceId: {
                      locationName: "instanceId"
                    },
                    PublicIp: {
                      locationName: "publicIp"
                    },
                    AllocationId: {
                      locationName: "allocationId"
                    },
                    AssociationId: {
                      locationName: "associationId"
                    },
                    Domain: {
                      locationName: "domain"
                    },
                    NetworkInterfaceId: {
                      locationName: "networkInterfaceId"
                    },
                    NetworkInterfaceOwnerId: {
                      locationName: "networkInterfaceOwnerId"
                    },
                    PrivateIpAddress: {
                      locationName: "privateIpAddress"
                    },
                    Tags: {
                      shape: "S6",
                      locationName: "tagSet"
                    },
                    PublicIpv4Pool: {
                      locationName: "publicIpv4Pool"
                    },
                    NetworkBorderGroup: {
                      locationName: "networkBorderGroup"
                    },
                    CustomerOwnedIp: {
                      locationName: "customerOwnedIp"
                    },
                    CustomerOwnedIpv4Pool: {
                      locationName: "customerOwnedIpv4Pool"
                    },
                    CarrierIp: {
                      locationName: "carrierIp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeAddressesAttribute: {
          input: {
            type: "structure",
            members: {
              AllocationIds: {
                locationName: "AllocationId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              Attribute: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Addresses: {
                locationName: "addressSet",
                type: "list",
                member: {
                  shape: "S10q",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeAggregateIdFormat: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UseLongIdsAggregated: {
                locationName: "useLongIdsAggregated",
                type: "boolean"
              },
              Statuses: {
                shape: "S10u",
                locationName: "statusSet"
              }
            }
          }
        },
        DescribeAvailabilityZones: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              ZoneNames: {
                locationName: "ZoneName",
                type: "list",
                member: {
                  locationName: "ZoneName"
                }
              },
              ZoneIds: {
                locationName: "ZoneId",
                type: "list",
                member: {
                  locationName: "ZoneId"
                }
              },
              AllAvailabilityZones: {
                type: "boolean"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AvailabilityZones: {
                locationName: "availabilityZoneInfo",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    State: {
                      locationName: "zoneState"
                    },
                    OptInStatus: {
                      locationName: "optInStatus"
                    },
                    Messages: {
                      locationName: "messageSet",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          Message: {
                            locationName: "message"
                          }
                        }
                      }
                    },
                    RegionName: {
                      locationName: "regionName"
                    },
                    ZoneName: {
                      locationName: "zoneName"
                    },
                    ZoneId: {
                      locationName: "zoneId"
                    },
                    GroupName: {
                      locationName: "groupName"
                    },
                    NetworkBorderGroup: {
                      locationName: "networkBorderGroup"
                    },
                    ZoneType: {
                      locationName: "zoneType"
                    },
                    ParentZoneName: {
                      locationName: "parentZoneName"
                    },
                    ParentZoneId: {
                      locationName: "parentZoneId"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeAwsNetworkPerformanceMetricSubscriptions: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Subscriptions: {
                locationName: "subscriptionSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Source: {
                      locationName: "source"
                    },
                    Destination: {
                      locationName: "destination"
                    },
                    Metric: {
                      locationName: "metric"
                    },
                    Statistic: {
                      locationName: "statistic"
                    },
                    Period: {
                      locationName: "period"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeBundleTasks: {
          input: {
            type: "structure",
            members: {
              BundleIds: {
                locationName: "BundleId",
                type: "list",
                member: {
                  locationName: "BundleId"
                }
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BundleTasks: {
                locationName: "bundleInstanceTasksSet",
                type: "list",
                member: {
                  shape: "S7m",
                  locationName: "item"
                }
              }
            }
          }
        },
        DescribeByoipCidrs: {
          input: {
            type: "structure",
            required: [
              "MaxResults"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ByoipCidrs: {
                locationName: "byoipCidrSet",
                type: "list",
                member: {
                  shape: "S1y",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeCapacityBlockOfferings: {
          input: {
            type: "structure",
            required: [
              "InstanceType",
              "InstanceCount",
              "CapacityDurationHours"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              InstanceType: {},
              InstanceCount: {
                type: "integer"
              },
              StartDateRange: {
                type: "timestamp"
              },
              EndDateRange: {
                type: "timestamp"
              },
              CapacityDurationHours: {
                type: "integer"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CapacityBlockOfferings: {
                locationName: "capacityBlockOfferingSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    CapacityBlockOfferingId: {
                      locationName: "capacityBlockOfferingId"
                    },
                    InstanceType: {
                      locationName: "instanceType"
                    },
                    AvailabilityZone: {
                      locationName: "availabilityZone"
                    },
                    InstanceCount: {
                      locationName: "instanceCount",
                      type: "integer"
                    },
                    StartDate: {
                      locationName: "startDate",
                      type: "timestamp"
                    },
                    EndDate: {
                      locationName: "endDate",
                      type: "timestamp"
                    },
                    CapacityBlockDurationHours: {
                      locationName: "capacityBlockDurationHours",
                      type: "integer"
                    },
                    UpfrontFee: {
                      locationName: "upfrontFee"
                    },
                    CurrencyCode: {
                      locationName: "currencyCode"
                    },
                    Tenancy: {
                      locationName: "tenancy"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeCapacityReservationFleets: {
          input: {
            type: "structure",
            members: {
              CapacityReservationFleetIds: {
                shape: "S7w",
                locationName: "CapacityReservationFleetId"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CapacityReservationFleets: {
                locationName: "capacityReservationFleetSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    CapacityReservationFleetId: {
                      locationName: "capacityReservationFleetId"
                    },
                    CapacityReservationFleetArn: {
                      locationName: "capacityReservationFleetArn"
                    },
                    State: {
                      locationName: "state"
                    },
                    TotalTargetCapacity: {
                      locationName: "totalTargetCapacity",
                      type: "integer"
                    },
                    TotalFulfilledCapacity: {
                      locationName: "totalFulfilledCapacity",
                      type: "double"
                    },
                    Tenancy: {
                      locationName: "tenancy"
                    },
                    EndDate: {
                      locationName: "endDate",
                      type: "timestamp"
                    },
                    CreateTime: {
                      locationName: "createTime",
                      type: "timestamp"
                    },
                    InstanceMatchCriteria: {
                      locationName: "instanceMatchCriteria"
                    },
                    AllocationStrategy: {
                      locationName: "allocationStrategy"
                    },
                    InstanceTypeSpecifications: {
                      shape: "Sac",
                      locationName: "instanceTypeSpecificationSet"
                    },
                    Tags: {
                      shape: "S6",
                      locationName: "tagSet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeCapacityReservations: {
          input: {
            type: "structure",
            members: {
              CapacityReservationIds: {
                locationName: "CapacityReservationId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              CapacityReservations: {
                locationName: "capacityReservationSet",
                type: "list",
                member: {
                  shape: "S9x",
                  locationName: "item"
                }
              }
            }
          }
        },
        DescribeCarrierGateways: {
          input: {
            type: "structure",
            members: {
              CarrierGatewayIds: {
                locationName: "CarrierGatewayId",
                type: "list",
                member: {}
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CarrierGateways: {
                locationName: "carrierGatewaySet",
                type: "list",
                member: {
                  shape: "Sag",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeClassicLinkInstances: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              InstanceIds: {
                shape: "S128",
                locationName: "InstanceId"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Instances: {
                locationName: "instancesSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Groups: {
                      shape: "Sly",
                      locationName: "groupSet"
                    },
                    InstanceId: {
                      locationName: "instanceId"
                    },
                    Tags: {
                      shape: "S6",
                      locationName: "tagSet"
                    },
                    VpcId: {
                      locationName: "vpcId"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeClientVpnAuthorizationRules: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId"
            ],
            members: {
              ClientVpnEndpointId: {},
              DryRun: {
                type: "boolean"
              },
              NextToken: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AuthorizationRules: {
                locationName: "authorizationRule",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ClientVpnEndpointId: {
                      locationName: "clientVpnEndpointId"
                    },
                    Description: {
                      locationName: "description"
                    },
                    GroupId: {
                      locationName: "groupId"
                    },
                    AccessAll: {
                      locationName: "accessAll",
                      type: "boolean"
                    },
                    DestinationCidr: {
                      locationName: "destinationCidr"
                    },
                    Status: {
                      shape: "S6u",
                      locationName: "status"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeClientVpnConnections: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId"
            ],
            members: {
              ClientVpnEndpointId: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Connections: {
                locationName: "connections",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ClientVpnEndpointId: {
                      locationName: "clientVpnEndpointId"
                    },
                    Timestamp: {
                      locationName: "timestamp"
                    },
                    ConnectionId: {
                      locationName: "connectionId"
                    },
                    Username: {
                      locationName: "username"
                    },
                    ConnectionEstablishedTime: {
                      locationName: "connectionEstablishedTime"
                    },
                    IngressBytes: {
                      locationName: "ingressBytes"
                    },
                    EgressBytes: {
                      locationName: "egressBytes"
                    },
                    IngressPackets: {
                      locationName: "ingressPackets"
                    },
                    EgressPackets: {
                      locationName: "egressPackets"
                    },
                    ClientIp: {
                      locationName: "clientIp"
                    },
                    CommonName: {
                      locationName: "commonName"
                    },
                    Status: {
                      shape: "S12n",
                      locationName: "status"
                    },
                    ConnectionEndTime: {
                      locationName: "connectionEndTime"
                    },
                    PostureComplianceStatuses: {
                      shape: "So",
                      locationName: "postureComplianceStatusSet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeClientVpnEndpoints: {
          input: {
            type: "structure",
            members: {
              ClientVpnEndpointIds: {
                locationName: "ClientVpnEndpointId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ClientVpnEndpoints: {
                locationName: "clientVpnEndpoint",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ClientVpnEndpointId: {
                      locationName: "clientVpnEndpointId"
                    },
                    Description: {
                      locationName: "description"
                    },
                    Status: {
                      shape: "Saw",
                      locationName: "status"
                    },
                    CreationTime: {
                      locationName: "creationTime"
                    },
                    DeletionTime: {
                      locationName: "deletionTime"
                    },
                    DnsName: {
                      locationName: "dnsName"
                    },
                    ClientCidrBlock: {
                      locationName: "clientCidrBlock"
                    },
                    DnsServers: {
                      shape: "So",
                      locationName: "dnsServer"
                    },
                    SplitTunnel: {
                      locationName: "splitTunnel",
                      type: "boolean"
                    },
                    VpnProtocol: {
                      locationName: "vpnProtocol"
                    },
                    TransportProtocol: {
                      locationName: "transportProtocol"
                    },
                    VpnPort: {
                      locationName: "vpnPort",
                      type: "integer"
                    },
                    AssociatedTargetNetworks: {
                      deprecated: true,
                      deprecatedMessage: "This property is deprecated. To view the target networks associated with a Client VPN endpoint, call DescribeClientVpnTargetNetworks and inspect the clientVpnTargetNetworks response element.",
                      locationName: "associatedTargetNetwork",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          NetworkId: {
                            locationName: "networkId"
                          },
                          NetworkType: {
                            locationName: "networkType"
                          }
                        }
                      }
                    },
                    ServerCertificateArn: {
                      locationName: "serverCertificateArn"
                    },
                    AuthenticationOptions: {
                      locationName: "authenticationOptions",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          Type: {
                            locationName: "type"
                          },
                          ActiveDirectory: {
                            locationName: "activeDirectory",
                            type: "structure",
                            members: {
                              DirectoryId: {
                                locationName: "directoryId"
                              }
                            }
                          },
                          MutualAuthentication: {
                            locationName: "mutualAuthentication",
                            type: "structure",
                            members: {
                              ClientRootCertificateChain: {
                                locationName: "clientRootCertificateChain"
                              }
                            }
                          },
                          FederatedAuthentication: {
                            locationName: "federatedAuthentication",
                            type: "structure",
                            members: {
                              SamlProviderArn: {
                                locationName: "samlProviderArn"
                              },
                              SelfServiceSamlProviderArn: {
                                locationName: "selfServiceSamlProviderArn"
                              }
                            }
                          }
                        }
                      }
                    },
                    ConnectionLogOptions: {
                      locationName: "connectionLogOptions",
                      type: "structure",
                      members: {
                        Enabled: {
                          type: "boolean"
                        },
                        CloudwatchLogGroup: {},
                        CloudwatchLogStream: {}
                      }
                    },
                    Tags: {
                      shape: "S6",
                      locationName: "tagSet"
                    },
                    SecurityGroupIds: {
                      shape: "S2r",
                      locationName: "securityGroupIdSet"
                    },
                    VpcId: {
                      locationName: "vpcId"
                    },
                    SelfServicePortalUrl: {
                      locationName: "selfServicePortalUrl"
                    },
                    ClientConnectOptions: {
                      locationName: "clientConnectOptions",
                      type: "structure",
                      members: {
                        Enabled: {
                          locationName: "enabled",
                          type: "boolean"
                        },
                        LambdaFunctionArn: {
                          locationName: "lambdaFunctionArn"
                        },
                        Status: {
                          locationName: "status",
                          type: "structure",
                          members: {
                            Code: {
                              locationName: "code"
                            },
                            Message: {
                              locationName: "message"
                            }
                          }
                        }
                      }
                    },
                    SessionTimeoutHours: {
                      locationName: "sessionTimeoutHours",
                      type: "integer"
                    },
                    ClientLoginBannerOptions: {
                      locationName: "clientLoginBannerOptions",
                      type: "structure",
                      members: {
                        Enabled: {
                          locationName: "enabled",
                          type: "boolean"
                        },
                        BannerText: {
                          locationName: "bannerText"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeClientVpnRoutes: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId"
            ],
            members: {
              ClientVpnEndpointId: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Routes: {
                locationName: "routes",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ClientVpnEndpointId: {
                      locationName: "clientVpnEndpointId"
                    },
                    DestinationCidr: {
                      locationName: "destinationCidr"
                    },
                    TargetSubnet: {
                      locationName: "targetSubnet"
                    },
                    Type: {
                      locationName: "type"
                    },
                    Origin: {
                      locationName: "origin"
                    },
                    Status: {
                      shape: "Sb0",
                      locationName: "status"
                    },
                    Description: {
                      locationName: "description"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeClientVpnTargetNetworks: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId"
            ],
            members: {
              ClientVpnEndpointId: {},
              AssociationIds: {
                shape: "So"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ClientVpnTargetNetworks: {
                locationName: "clientVpnTargetNetworks",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    AssociationId: {
                      locationName: "associationId"
                    },
                    VpcId: {
                      locationName: "vpcId"
                    },
                    TargetNetworkId: {
                      locationName: "targetNetworkId"
                    },
                    ClientVpnEndpointId: {
                      locationName: "clientVpnEndpointId"
                    },
                    Status: {
                      shape: "S3m",
                      locationName: "status"
                    },
                    SecurityGroups: {
                      shape: "So",
                      locationName: "securityGroups"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeCoipPools: {
          input: {
            type: "structure",
            members: {
              PoolIds: {
                locationName: "PoolId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CoipPools: {
                locationName: "coipPoolSet",
                type: "list",
                member: {
                  shape: "Sb9",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeConversionTasks: {
          input: {
            type: "structure",
            members: {
              ConversionTaskIds: {
                locationName: "conversionTaskId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConversionTasks: {
                locationName: "conversionTasks",
                type: "list",
                member: {
                  shape: "S13s",
                  locationName: "item"
                }
              }
            }
          }
        },
        DescribeCustomerGateways: {
          input: {
            type: "structure",
            members: {
              CustomerGatewayIds: {
                locationName: "CustomerGatewayId",
                type: "list",
                member: {
                  locationName: "CustomerGatewayId"
                }
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CustomerGateways: {
                locationName: "customerGatewaySet",
                type: "list",
                member: {
                  shape: "Sbd",
                  locationName: "item"
                }
              }
            }
          }
        },
        DescribeDhcpOptions: {
          input: {
            type: "structure",
            members: {
              DhcpOptionsIds: {
                locationName: "DhcpOptionsId",
                type: "list",
                member: {
                  locationName: "DhcpOptionsId"
                }
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DhcpOptions: {
                locationName: "dhcpOptionsSet",
                type: "list",
                member: {
                  shape: "Sbx",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeEgressOnlyInternetGateways: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              EgressOnlyInternetGatewayIds: {
                locationName: "EgressOnlyInternetGatewayId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EgressOnlyInternetGateways: {
                locationName: "egressOnlyInternetGatewaySet",
                type: "list",
                member: {
                  shape: "Sc4",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeElasticGpus: {
          input: {
            type: "structure",
            members: {
              ElasticGpuIds: {
                locationName: "ElasticGpuId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ElasticGpuSet: {
                locationName: "elasticGpuSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ElasticGpuId: {
                      locationName: "elasticGpuId"
                    },
                    AvailabilityZone: {
                      locationName: "availabilityZone"
                    },
                    ElasticGpuType: {
                      locationName: "elasticGpuType"
                    },
                    ElasticGpuHealth: {
                      locationName: "elasticGpuHealth",
                      type: "structure",
                      members: {
                        Status: {
                          locationName: "status"
                        }
                      }
                    },
                    ElasticGpuState: {
                      locationName: "elasticGpuState"
                    },
                    InstanceId: {
                      locationName: "instanceId"
                    },
                    Tags: {
                      shape: "S6",
                      locationName: "tagSet"
                    }
                  }
                }
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeExportImageTasks: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              ExportImageTaskIds: {
                locationName: "ExportImageTaskId",
                type: "list",
                member: {
                  locationName: "ExportImageTaskId"
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ExportImageTasks: {
                locationName: "exportImageTaskSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Description: {
                      locationName: "description"
                    },
                    ExportImageTaskId: {
                      locationName: "exportImageTaskId"
                    },
                    ImageId: {
                      locationName: "imageId"
                    },
                    Progress: {
                      locationName: "progress"
                    },
                    S3ExportLocation: {
                      shape: "S14w",
                      locationName: "s3ExportLocation"
                    },
                    Status: {
                      locationName: "status"
                    },
                    StatusMessage: {
                      locationName: "statusMessage"
                    },
                    Tags: {
                      shape: "S6",
                      locationName: "tagSet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeExportTasks: {
          input: {
            type: "structure",
            members: {
              ExportTaskIds: {
                locationName: "exportTaskId",
                type: "list",
                member: {
                  locationName: "ExportTaskId"
                }
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ExportTasks: {
                locationName: "exportTaskSet",
                type: "list",
                member: {
                  shape: "Sff",
                  locationName: "item"
                }
              }
            }
          }
        },
        DescribeFastLaunchImages: {
          input: {
            type: "structure",
            members: {
              ImageIds: {
                locationName: "ImageId",
                type: "list",
                member: {
                  locationName: "ImageId"
                }
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FastLaunchImages: {
                locationName: "fastLaunchImageSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ImageId: {
                      locationName: "imageId"
                    },
                    ResourceType: {
                      locationName: "resourceType"
                    },
                    SnapshotConfiguration: {
                      shape: "S159",
                      locationName: "snapshotConfiguration"
                    },
                    LaunchTemplate: {
                      shape: "S15a",
                      locationName: "launchTemplate"
                    },
                    MaxParallelLaunches: {
                      locationName: "maxParallelLaunches",
                      type: "integer"
                    },
                    OwnerId: {
                      locationName: "ownerId"
                    },
                    State: {
                      locationName: "state"
                    },
                    StateTransitionReason: {
                      locationName: "stateTransitionReason"
                    },
                    StateTransitionTime: {
                      locationName: "stateTransitionTime",
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeFastSnapshotRestores: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FastSnapshotRestores: {
                locationName: "fastSnapshotRestoreSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    SnapshotId: {
                      locationName: "snapshotId"
                    },
                    AvailabilityZone: {
                      locationName: "availabilityZone"
                    },
                    State: {
                      locationName: "state"
                    },
                    StateTransitionReason: {
                      locationName: "stateTransitionReason"
                    },
                    OwnerId: {
                      locationName: "ownerId"
                    },
                    OwnerAlias: {
                      locationName: "ownerAlias"
                    },
                    EnablingTime: {
                      locationName: "enablingTime",
                      type: "timestamp"
                    },
                    OptimizingTime: {
                      locationName: "optimizingTime",
                      type: "timestamp"
                    },
                    EnabledTime: {
                      locationName: "enabledTime",
                      type: "timestamp"
                    },
                    DisablingTime: {
                      locationName: "disablingTime",
                      type: "timestamp"
                    },
                    DisabledTime: {
                      locationName: "disabledTime",
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeFleetHistory: {
          input: {
            type: "structure",
            required: [
              "FleetId",
              "StartTime"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              EventType: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              FleetId: {},
              StartTime: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HistoryRecords: {
                locationName: "historyRecordSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    EventInformation: {
                      shape: "S15n",
                      locationName: "eventInformation"
                    },
                    EventType: {
                      locationName: "eventType"
                    },
                    Timestamp: {
                      locationName: "timestamp",
                      type: "timestamp"
                    }
                  }
                }
              },
              LastEvaluatedTime: {
                locationName: "lastEvaluatedTime",
                type: "timestamp"
              },
              NextToken: {
                locationName: "nextToken"
              },
              FleetId: {
                locationName: "fleetId"
              },
              StartTime: {
                locationName: "startTime",
                type: "timestamp"
              }
            }
          }
        },
        DescribeFleetInstances: {
          input: {
            type: "structure",
            required: [
              "FleetId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              FleetId: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ActiveInstances: {
                shape: "S15q",
                locationName: "activeInstanceSet"
              },
              NextToken: {
                locationName: "nextToken"
              },
              FleetId: {
                locationName: "fleetId"
              }
            }
          }
        },
        DescribeFleets: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              FleetIds: {
                shape: "Sv1",
                locationName: "FleetId"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Fleets: {
                locationName: "fleetSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ActivityStatus: {
                      locationName: "activityStatus"
                    },
                    CreateTime: {
                      locationName: "createTime",
                      type: "timestamp"
                    },
                    FleetId: {
                      locationName: "fleetId"
                    },
                    FleetState: {
                      locationName: "fleetState"
                    },
                    ClientToken: {
                      locationName: "clientToken"
                    },
                    ExcessCapacityTerminationPolicy: {
                      locationName: "excessCapacityTerminationPolicy"
                    },
                    FulfilledCapacity: {
                      locationName: "fulfilledCapacity",
                      type: "double"
                    },
                    FulfilledOnDemandCapacity: {
                      locationName: "fulfilledOnDemandCapacity",
                      type: "double"
                    },
                    LaunchTemplateConfigs: {
                      locationName: "launchTemplateConfigs",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          LaunchTemplateSpecification: {
                            shape: "Sdw",
                            locationName: "launchTemplateSpecification"
                          },
                          Overrides: {
                            locationName: "overrides",
                            type: "list",
                            member: {
                              shape: "Sdx",
                              locationName: "item"
                            }
                          }
                        }
                      }
                    },
                    TargetCapacitySpecification: {
                      locationName: "targetCapacitySpecification",
                      type: "structure",
                      members: {
                        TotalTargetCapacity: {
                          locationName: "totalTargetCapacity",
                          type: "integer"
                        },
                        OnDemandTargetCapacity: {
                          locationName: "onDemandTargetCapacity",
                          type: "integer"
                        },
                        SpotTargetCapacity: {
                          locationName: "spotTargetCapacity",
                          type: "integer"
                        },
                        DefaultTargetCapacityType: {
                          locationName: "defaultTargetCapacityType"
                        },
                        TargetCapacityUnitType: {
                          locationName: "targetCapacityUnitType"
                        }
                      }
                    },
                    TerminateInstancesWithExpiration: {
                      locationName: "terminateInstancesWithExpiration",
                      type: "boolean"
                    },
                    Type: {
                      locationName: "type"
                    },
                    ValidFrom: {
                      locationName: "validFrom",
                      type: "timestamp"
                    },
                    ValidUntil: {
                      locationName: "validUntil",
                      type: "timestamp"
                    },
                    ReplaceUnhealthyInstances: {
                      locationName: "replaceUnhealthyInstances",
                      type: "boolean"
                    },
                    SpotOptions: {
                      locationName: "spotOptions",
                      type: "structure",
                      members: {
                        AllocationStrategy: {
                          locationName: "allocationStrategy"
                        },
                        MaintenanceStrategies: {
                          locationName: "maintenanceStrategies",
                          type: "structure",
                          members: {
                            CapacityRebalance: {
                              locationName: "capacityRebalance",
                              type: "structure",
                              members: {
                                ReplacementStrategy: {
                                  locationName: "replacementStrategy"
                                },
                                TerminationDelay: {
                                  locationName: "terminationDelay",
                                  type: "integer"
                                }
                              }
                            }
                          }
                        },
                        InstanceInterruptionBehavior: {
                          locationName: "instanceInterruptionBehavior"
                        },
                        InstancePoolsToUseCount: {
                          locationName: "instancePoolsToUseCount",
                          type: "integer"
                        },
                        SingleInstanceType: {
                          locationName: "singleInstanceType",
                          type: "boolean"
                        },
                        SingleAvailabilityZone: {
                          locationName: "singleAvailabilityZone",
                          type: "boolean"
                        },
                        MinTargetCapacity: {
                          locationName: "minTargetCapacity",
                          type: "integer"
                        },
                        MaxTotalPrice: {
                          locationName: "maxTotalPrice"
                        }
                      }
                    },
                    OnDemandOptions: {
                      locationName: "onDemandOptions",
                      type: "structure",
                      members: {
                        AllocationStrategy: {
                          locationName: "allocationStrategy"
                        },
                        CapacityReservationOptions: {
                          locationName: "capacityReservationOptions",
                          type: "structure",
                          members: {
                            UsageStrategy: {
                              locationName: "usageStrategy"
                            }
                          }
                        },
                        SingleInstanceType: {
                          locationName: "singleInstanceType",
                          type: "boolean"
                        },
                        SingleAvailabilityZone: {
                          locationName: "singleAvailabilityZone",
                          type: "boolean"
                        },
                        MinTargetCapacity: {
                          locationName: "minTargetCapacity",
                          type: "integer"
                        },
                        MaxTotalPrice: {
                          locationName: "maxTotalPrice"
                        }
                      }
                    },
                    Tags: {
                      shape: "S6",
                      locationName: "tagSet"
                    },
                    Errors: {
                      locationName: "errorSet",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          LaunchTemplateAndOverrides: {
                            shape: "Sdv",
                            locationName: "launchTemplateAndOverrides"
                          },
                          Lifecycle: {
                            locationName: "lifecycle"
                          },
                          ErrorCode: {
                            locationName: "errorCode"
                          },
                          ErrorMessage: {
                            locationName: "errorMessage"
                          }
                        }
                      }
                    },
                    Instances: {
                      locationName: "fleetInstanceSet",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          LaunchTemplateAndOverrides: {
                            shape: "Sdv",
                            locationName: "launchTemplateAndOverrides"
                          },
                          Lifecycle: {
                            locationName: "lifecycle"
                          },
                          InstanceIds: {
                            shape: "Sec",
                            locationName: "instanceIds"
                          },
                          InstanceType: {
                            locationName: "instanceType"
                          },
                          Platform: {
                            locationName: "platform"
                          }
                        }
                      }
                    },
                    Context: {
                      locationName: "context"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeFlowLogs: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              Filter: {
                shape: "S10d"
              },
              FlowLogIds: {
                shape: "Svb",
                locationName: "FlowLogId"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FlowLogs: {
                locationName: "flowLogSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    CreationTime: {
                      locationName: "creationTime",
                      type: "timestamp"
                    },
                    DeliverLogsErrorMessage: {
                      locationName: "deliverLogsErrorMessage"
                    },
                    DeliverLogsPermissionArn: {
                      locationName: "deliverLogsPermissionArn"
                    },
                    DeliverCrossAccountRole: {
                      locationName: "deliverCrossAccountRole"
                    },
                    DeliverLogsStatus: {
                      locationName: "deliverLogsStatus"
                    },
                    FlowLogId: {
                      locationName: "flowLogId"
                    },
                    FlowLogStatus: {
                      locationName: "flowLogStatus"
                    },
                    LogGroupName: {
                      locationName: "logGroupName"
                    },
                    ResourceId: {
                      locationName: "resourceId"
                    },
                    TrafficType: {
                      locationName: "trafficType"
                    },
                    LogDestinationType: {
                      locationName: "logDestinationType"
                    },
                    LogDestination: {
                      locationName: "logDestination"
                    },
                    LogFormat: {
                      locationName: "logFormat"
                    },
                    Tags: {
                      shape: "S6",
                      locationName: "tagSet"
                    },
                    MaxAggregationInterval: {
                      locationName: "maxAggregationInterval",
                      type: "integer"
                    },
                    DestinationOptions: {
                      locationName: "destinationOptions",
                      type: "structure",
                      members: {
                        FileFormat: {
                          locationName: "fileFormat"
                        },
                        HiveCompatiblePartitions: {
                          locationName: "hiveCompatiblePartitions",
                          type: "boolean"
                        },
                        PerHourPartition: {
                          locationName: "perHourPartition",
                          type: "boolean"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeFpgaImageAttribute: {
          input: {
            type: "structure",
            required: [
              "FpgaImageId",
              "Attribute"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              FpgaImageId: {},
              Attribute: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FpgaImageAttribute: {
                shape: "S16j",
                locationName: "fpgaImageAttribute"
              }
            }
          }
        },
        DescribeFpgaImages: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              FpgaImageIds: {
                locationName: "FpgaImageId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              Owners: {
                shape: "S16s",
                locationName: "Owner"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FpgaImages: {
                locationName: "fpgaImageSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    FpgaImageId: {
                      locationName: "fpgaImageId"
                    },
                    FpgaImageGlobalId: {
                      locationName: "fpgaImageGlobalId"
                    },
                    Name: {
                      locationName: "name"
                    },
                    Description: {
                      locationName: "description"
                    },
                    ShellVersion: {
                      locationName: "shellVersion"
                    },
                    PciId: {
                      locationName: "pciId",
                      type: "structure",
                      members: {
                        DeviceId: {},
                        VendorId: {},
                        SubsystemId: {},
                        SubsystemVendorId: {}
                      }
                    },
                    State: {
                      locationName: "state",
                      type: "structure",
                      members: {
                        Code: {
                          locationName: "code"
                        },
                        Message: {
                          locationName: "message"
                        }
                      }
                    },
                    CreateTime: {
                      locationName: "createTime",
                      type: "timestamp"
                    },
                    UpdateTime: {
                      locationName: "updateTime",
                      type: "timestamp"
                    },
                    OwnerId: {
                      locationName: "ownerId"
                    },
                    OwnerAlias: {
                      locationName: "ownerAlias"
                    },
                    ProductCodes: {
                      shape: "S16n",
                      locationName: "productCodes"
                    },
                    Tags: {
                      shape: "S6",
                      locationName: "tags"
                    },
                    Public: {
                      locationName: "public",
                      type: "boolean"
                    },
                    DataRetentionSupport: {
                      locationName: "dataRetentionSupport",
                      type: "boolean"
                    },
                    InstanceTypes: {
                      locationName: "instanceTypes",
                      type: "list",
                      member: {
                        locationName: "item"
                      }
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeHostReservationOfferings: {
          input: {
            type: "structure",
            members: {
              Filter: {
                shape: "S10d"
              },
              MaxDuration: {
                type: "integer"
              },
              MaxResults: {
                type: "integer"
              },
              MinDuration: {
                type: "integer"
              },
              NextToken: {},
              OfferingId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              OfferingSet: {
                locationName: "offeringSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    CurrencyCode: {
                      locationName: "currencyCode"
                    },
                    Duration: {
                      locationName: "duration",
                      type: "integer"
                    },
                    HourlyPrice: {
                      locationName: "hourlyPrice"
                    },
                    InstanceFamily: {
                      locationName: "instanceFamily"
                    },
                    OfferingId: {
                      locationName: "offeringId"
                    },
                    PaymentOption: {
                      locationName: "paymentOption"
                    },
                    UpfrontPrice: {
                      locationName: "upfrontPrice"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeHostReservations: {
          input: {
            type: "structure",
            members: {
              Filter: {
                shape: "S10d"
              },
              HostReservationIdSet: {
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              HostReservationSet: {
                locationName: "hostReservationSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Count: {
                      locationName: "count",
                      type: "integer"
                    },
                    CurrencyCode: {
                      locationName: "currencyCode"
                    },
                    Duration: {
                      locationName: "duration",
                      type: "integer"
                    },
                    End: {
                      locationName: "end",
                      type: "timestamp"
                    },
                    HostIdSet: {
                      shape: "S17d",
                      locationName: "hostIdSet"
                    },
                    HostReservationId: {
                      locationName: "hostReservationId"
                    },
                    HourlyPrice: {
                      locationName: "hourlyPrice"
                    },
                    InstanceFamily: {
                      locationName: "instanceFamily"
                    },
                    OfferingId: {
                      locationName: "offeringId"
                    },
                    PaymentOption: {
                      locationName: "paymentOption"
                    },
                    Start: {
                      locationName: "start",
                      type: "timestamp"
                    },
                    State: {
                      locationName: "state"
                    },
                    UpfrontPrice: {
                      locationName: "upfrontPrice"
                    },
                    Tags: {
                      shape: "S6",
                      locationName: "tagSet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeHosts: {
          input: {
            type: "structure",
            members: {
              Filter: {
                shape: "S10d",
                locationName: "filter"
              },
              HostIds: {
                shape: "S17g",
                locationName: "hostId"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Hosts: {
                locationName: "hostSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    AutoPlacement: {
                      locationName: "autoPlacement"
                    },
                    AvailabilityZone: {
                      locationName: "availabilityZone"
                    },
                    AvailableCapacity: {
                      locationName: "availableCapacity",
                      type: "structure",
                      members: {
                        AvailableInstanceCapacity: {
                          locationName: "availableInstanceCapacity",
                          type: "list",
                          member: {
                            locationName: "item",
                            type: "structure",
                            members: {
                              AvailableCapacity: {
                                locationName: "availableCapacity",
                                type: "integer"
                              },
                              InstanceType: {
                                locationName: "instanceType"
                              },
                              TotalCapacity: {
                                locationName: "totalCapacity",
                                type: "integer"
                              }
                            }
                          }
                        },
                        AvailableVCpus: {
                          locationName: "availableVCpus",
                          type: "integer"
                        }
                      }
                    },
                    ClientToken: {
                      locationName: "clientToken"
                    },
                    HostId: {
                      locationName: "hostId"
                    },
                    HostProperties: {
                      locationName: "hostProperties",
                      type: "structure",
                      members: {
                        Cores: {
                          locationName: "cores",
                          type: "integer"
                        },
                        InstanceType: {
                          locationName: "instanceType"
                        },
                        InstanceFamily: {
                          locationName: "instanceFamily"
                        },
                        Sockets: {
                          locationName: "sockets",
                          type: "integer"
                        },
                        TotalVCpus: {
                          locationName: "totalVCpus",
                          type: "integer"
                        }
                      }
                    },
                    HostReservationId: {
                      locationName: "hostReservationId"
                    },
                    Instances: {
                      locationName: "instances",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          InstanceId: {
                            locationName: "instanceId"
                          },
                          InstanceType: {
                            locationName: "instanceType"
                          },
                          OwnerId: {
                            locationName: "ownerId"
                          }
                        }
                      }
                    },
                    State: {
                      locationName: "state"
                    },
                    AllocationTime: {
                      locationName: "allocationTime",
                      type: "timestamp"
                    },
                    ReleaseTime: {
                      locationName: "releaseTime",
                      type: "timestamp"
                    },
                    Tags: {
                      shape: "S6",
                      locationName: "tagSet"
                    },
                    HostRecovery: {
                      locationName: "hostRecovery"
                    },
                    AllowsMultipleInstanceTypes: {
                      locationName: "allowsMultipleInstanceTypes"
                    },
                    OwnerId: {
                      locationName: "ownerId"
                    },
                    AvailabilityZoneId: {
                      locationName: "availabilityZoneId"
                    },
                    MemberOfServiceLinkedResourceGroup: {
                      locationName: "memberOfServiceLinkedResourceGroup",
                      type: "boolean"
                    },
                    OutpostArn: {
                      locationName: "outpostArn"
                    },
                    HostMaintenance: {
                      locationName: "hostMaintenance"
                    },
                    AssetId: {
                      locationName: "assetId"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeIamInstanceProfileAssociations: {
          input: {
            type: "structure",
            members: {
              AssociationIds: {
                locationName: "AssociationId",
                type: "list",
                member: {
                  locationName: "AssociationId"
                }
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IamInstanceProfileAssociations: {
                locationName: "iamInstanceProfileAssociationSet",
                type: "list",
                member: {
                  shape: "S3x",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeIdFormat: {
          input: {
            type: "structure",
            members: {
              Resource: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Statuses: {
                shape: "S10u",
                locationName: "statusSet"
              }
            }
          }
        },
        DescribeIdentityIdFormat: {
          input: {
            type: "structure",
            required: [
              "PrincipalArn"
            ],
            members: {
              PrincipalArn: {
                locationName: "principalArn"
              },
              Resource: {
                locationName: "resource"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Statuses: {
                shape: "S10u",
                locationName: "statusSet"
              }
            }
          }
        },
        DescribeImageAttribute: {
          input: {
            type: "structure",
            required: [
              "Attribute",
              "ImageId"
            ],
            members: {
              Attribute: {},
              ImageId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BlockDeviceMappings: {
                shape: "S185",
                locationName: "blockDeviceMapping"
              },
              ImageId: {
                locationName: "imageId"
              },
              LaunchPermissions: {
                shape: "S186",
                locationName: "launchPermission"
              },
              ProductCodes: {
                shape: "S16n",
                locationName: "productCodes"
              },
              Description: {
                shape: "Sc1",
                locationName: "description"
              },
              KernelId: {
                shape: "Sc1",
                locationName: "kernel"
              },
              RamdiskId: {
                shape: "Sc1",
                locationName: "ramdisk"
              },
              SriovNetSupport: {
                shape: "Sc1",
                locationName: "sriovNetSupport"
              },
              BootMode: {
                shape: "Sc1",
                locationName: "bootMode"
              },
              TpmSupport: {
                shape: "Sc1",
                locationName: "tpmSupport"
              },
              UefiData: {
                shape: "Sc1",
                locationName: "uefiData"
              },
              LastLaunchedTime: {
                shape: "Sc1",
                locationName: "lastLaunchedTime"
              },
              ImdsSupport: {
                shape: "Sc1",
                locationName: "imdsSupport"
              }
            }
          }
        },
        DescribeImages: {
          input: {
            type: "structure",
            members: {
              ExecutableUsers: {
                locationName: "ExecutableBy",
                type: "list",
                member: {
                  locationName: "ExecutableBy"
                }
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              ImageIds: {
                shape: "S18a",
                locationName: "ImageId"
              },
              Owners: {
                shape: "S16s",
                locationName: "Owner"
              },
              IncludeDeprecated: {
                type: "boolean"
              },
              IncludeDisabled: {
                type: "boolean"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Images: {
                locationName: "imagesSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Architecture: {
                      locationName: "architecture"
                    },
                    CreationDate: {
                      locationName: "creationDate"
                    },
                    ImageId: {
                      locationName: "imageId"
                    },
                    ImageLocation: {
                      locationName: "imageLocation"
                    },
                    ImageType: {
                      locationName: "imageType"
                    },
                    Public: {
                      locationName: "isPublic",
                      type: "boolean"
                    },
                    KernelId: {
                      locationName: "kernelId"
                    },
                    OwnerId: {
                      locationName: "imageOwnerId"
                    },
                    Platform: {
                      locationName: "platform"
                    },
                    PlatformDetails: {
                      locationName: "platformDetails"
                    },
                    UsageOperation: {
                      locationName: "usageOperation"
                    },
                    ProductCodes: {
                      shape: "S16n",
                      locationName: "productCodes"
                    },
                    RamdiskId: {
                      locationName: "ramdiskId"
                    },
                    State: {
                      locationName: "imageState"
                    },
                    BlockDeviceMappings: {
                      shape: "S185",
                      locationName: "blockDeviceMapping"
                    },
                    Description: {
                      locationName: "description"
                    },
                    EnaSupport: {
                      locationName: "enaSupport",
                      type: "boolean"
                    },
                    Hypervisor: {
                      locationName: "hypervisor"
                    },
                    ImageOwnerAlias: {
                      locationName: "imageOwnerAlias"
                    },
                    Name: {
                      locationName: "name"
                    },
                    RootDeviceName: {
                      locationName: "rootDeviceName"
                    },
                    RootDeviceType: {
                      locationName: "rootDeviceType"
                    },
                    SriovNetSupport: {
                      locationName: "sriovNetSupport"
                    },
                    StateReason: {
                      shape: "Sjw",
                      locationName: "stateReason"
                    },
                    Tags: {
                      shape: "S6",
                      locationName: "tagSet"
                    },
                    VirtualizationType: {
                      locationName: "virtualizationType"
                    },
                    BootMode: {
                      locationName: "bootMode"
                    },
                    TpmSupport: {
                      locationName: "tpmSupport"
                    },
                    DeprecationTime: {
                      locationName: "deprecationTime"
                    },
                    ImdsSupport: {
                      locationName: "imdsSupport"
                    },
                    SourceInstanceId: {
                      locationName: "sourceInstanceId"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeImportImageTasks: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "S10d"
              },
              ImportTaskIds: {
                locationName: "ImportTaskId",
                type: "list",
                member: {
                  locationName: "ImportTaskId"
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ImportImageTasks: {
                locationName: "importImageTaskSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Architecture: {
                      locationName: "architecture"
                    },
                    Description: {
                      locationName: "description"
                    },
                    Encrypted: {
                      locationName: "encrypted",
                      type: "boolean"
                    },
                    Hypervisor: {
                      locationName: "hypervisor"
                    },
                    ImageId: {
                      locationName: "imageId"
                    },
                    ImportTaskId: {
                      locationName: "importTaskId"
                    },
                    KmsKeyId: {
                      locationName: "kmsKeyId"
                    },
                    LicenseType: {
                      locationName: "licenseType"
                    },
                    Platform: {
                      locationName: "platform"
                    },
                    Progress: {
                      locationName: "progress"
                    },
                    SnapshotDetails: {
                      shape: "S18t",
                      locationName: "snapshotDetailSet"
                    },
                    Status: {
                      locationName: "status"
                    },
                    StatusMessage: {
                      locationName: "statusMessage"
                    },
                    Tags: {
                      shape: "S6",
                      locationName: "tagSet"
                    },
                    LicenseSpecifications: {
                      shape: "S18x",
                      locationName: "licenseSpecifications"
                    },
                    UsageOperation: {
                      locationName: "usageOperation"
                    },
                    BootMode: {
                      locationName: "bootMode"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeImportSnapshotTasks: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "S10d"
              },
              ImportTaskIds: {
                locationName: "ImportTaskId",
                type: "list",
                member: {
                  locationName: "ImportTaskId"
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ImportSnapshotTasks: {
                locationName: "importSnapshotTaskSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Description: {
                      locationName: "description"
                    },
                    ImportTaskId: {
                      locationName: "importTaskId"
                    },
                    SnapshotTaskDetail: {
                      shape: "S195",
                      locationName: "snapshotTaskDetail"
                    },
                    Tags: {
                      shape: "S6",
                      locationName: "tagSet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeInstanceAttribute: {
          input: {
            type: "structure",
            required: [
              "Attribute",
              "InstanceId"
            ],
            members: {
              Attribute: {
                locationName: "attribute"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              InstanceId: {
                locationName: "instanceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Groups: {
                shape: "Sly",
                locationName: "groupSet"
              },
              BlockDeviceMappings: {
                shape: "S199",
                locationName: "blockDeviceMapping"
              },
              DisableApiTermination: {
                shape: "S19c",
                locationName: "disableApiTermination"
              },
              EnaSupport: {
                shape: "S19c",
                locationName: "enaSupport"
              },
              EnclaveOptions: {
                shape: "S19d",
                locationName: "enclaveOptions"
              },
              EbsOptimized: {
                shape: "S19c",
                locationName: "ebsOptimized"
              },
              InstanceId: {
                locationName: "instanceId"
              },
              InstanceInitiatedShutdownBehavior: {
                shape: "Sc1",
                locationName: "instanceInitiatedShutdownBehavior"
              },
              InstanceType: {
                shape: "Sc1",
                locationName: "instanceType"
              },
              KernelId: {
                shape: "Sc1",
                locationName: "kernel"
              },
              ProductCodes: {
                shape: "S16n",
                locationName: "productCodes"
              },
              RamdiskId: {
                shape: "Sc1",
                locationName: "ramdisk"
              },
              RootDeviceName: {
                shape: "Sc1",
                locationName: "rootDeviceName"
              },
              SourceDestCheck: {
                shape: "S19c",
                locationName: "sourceDestCheck"
              },
              SriovNetSupport: {
                shape: "Sc1",
                locationName: "sriovNetSupport"
              },
              UserData: {
                shape: "Sc1",
                locationName: "userData"
              },
              DisableApiStop: {
                shape: "S19c",
                locationName: "disableApiStop"
              }
            }
          }
        },
        DescribeInstanceConnectEndpoints: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              InstanceConnectEndpointIds: {
                shape: "So",
                locationName: "InstanceConnectEndpointId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceConnectEndpoints: {
                locationName: "instanceConnectEndpointSet",
                type: "list",
                member: {
                  shape: "Sf0",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeInstanceCreditSpecifications: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              InstanceIds: {
                shape: "S128",
                locationName: "InstanceId"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceCreditSpecifications: {
                locationName: "instanceCreditSpecificationSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    InstanceId: {
                      locationName: "instanceId"
                    },
                    CpuCredits: {
                      locationName: "cpuCredits"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeInstanceEventNotificationAttributes: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceTagAttribute: {
                shape: "Szs",
                locationName: "instanceTagAttribute"
              }
            }
          }
        },
        DescribeInstanceEventWindows: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              InstanceEventWindowIds: {
                locationName: "InstanceEventWindowId",
                type: "list",
                member: {
                  locationName: "InstanceEventWindowId"
                }
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceEventWindows: {
                locationName: "instanceEventWindowSet",
                type: "list",
                member: {
                  shape: "S47",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeInstanceStatus: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              InstanceIds: {
                shape: "S128",
                locationName: "InstanceId"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              IncludeAllInstances: {
                locationName: "includeAllInstances",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceStatuses: {
                locationName: "instanceStatusSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    AvailabilityZone: {
                      locationName: "availabilityZone"
                    },
                    OutpostArn: {
                      locationName: "outpostArn"
                    },
                    Events: {
                      locationName: "eventsSet",
                      type: "list",
                      member: {
                        shape: "S19z",
                        locationName: "item"
                      }
                    },
                    InstanceId: {
                      locationName: "instanceId"
                    },
                    InstanceState: {
                      shape: "S1a2",
                      locationName: "instanceState"
                    },
                    InstanceStatus: {
                      shape: "S1a4",
                      locationName: "instanceStatus"
                    },
                    SystemStatus: {
                      shape: "S1a4",
                      locationName: "systemStatus"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeInstanceTopology: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              InstanceIds: {
                locationName: "InstanceId",
                type: "list",
                member: {}
              },
              GroupNames: {
                locationName: "GroupName",
                type: "list",
                member: {}
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Instances: {
                locationName: "instanceSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    InstanceId: {
                      locationName: "instanceId"
                    },
                    InstanceType: {
                      locationName: "instanceType"
                    },
                    GroupName: {
                      locationName: "groupName"
                    },
                    NetworkNodes: {
                      locationName: "networkNodeSet",
                      type: "list",
                      member: {
                        locationName: "item"
                      }
                    },
                    AvailabilityZone: {
                      locationName: "availabilityZone"
                    },
                    ZoneId: {
                      locationName: "zoneId"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeInstanceTypeOfferings: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              LocationType: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceTypeOfferings: {
                locationName: "instanceTypeOfferingSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    InstanceType: {
                      locationName: "instanceType"
                    },
                    LocationType: {
                      locationName: "locationType"
                    },
                    Location: {
                      locationName: "location"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeInstanceTypes: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              InstanceTypes: {
                locationName: "InstanceType",
                type: "list",
                member: {}
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceTypes: {
                locationName: "instanceTypeSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    InstanceType: {
                      locationName: "instanceType"
                    },
                    CurrentGeneration: {
                      locationName: "currentGeneration",
                      type: "boolean"
                    },
                    FreeTierEligible: {
                      locationName: "freeTierEligible",
                      type: "boolean"
                    },
                    SupportedUsageClasses: {
                      locationName: "supportedUsageClasses",
                      type: "list",
                      member: {
                        locationName: "item"
                      }
                    },
                    SupportedRootDeviceTypes: {
                      locationName: "supportedRootDeviceTypes",
                      type: "list",
                      member: {
                        locationName: "item"
                      }
                    },
                    SupportedVirtualizationTypes: {
                      locationName: "supportedVirtualizationTypes",
                      type: "list",
                      member: {
                        locationName: "item"
                      }
                    },
                    BareMetal: {
                      locationName: "bareMetal",
                      type: "boolean"
                    },
                    Hypervisor: {
                      locationName: "hypervisor"
                    },
                    ProcessorInfo: {
                      locationName: "processorInfo",
                      type: "structure",
                      members: {
                        SupportedArchitectures: {
                          locationName: "supportedArchitectures",
                          type: "list",
                          member: {
                            locationName: "item"
                          }
                        },
                        SustainedClockSpeedInGhz: {
                          locationName: "sustainedClockSpeedInGhz",
                          type: "double"
                        },
                        SupportedFeatures: {
                          locationName: "supportedFeatures",
                          type: "list",
                          member: {
                            locationName: "item"
                          }
                        },
                        Manufacturer: {
                          locationName: "manufacturer"
                        }
                      }
                    },
                    VCpuInfo: {
                      locationName: "vCpuInfo",
                      type: "structure",
                      members: {
                        DefaultVCpus: {
                          locationName: "defaultVCpus",
                          type: "integer"
                        },
                        DefaultCores: {
                          locationName: "defaultCores",
                          type: "integer"
                        },
                        DefaultThreadsPerCore: {
                          locationName: "defaultThreadsPerCore",
                          type: "integer"
                        },
                        ValidCores: {
                          locationName: "validCores",
                          type: "list",
                          member: {
                            locationName: "item",
                            type: "integer"
                          }
                        },
                        ValidThreadsPerCore: {
                          locationName: "validThreadsPerCore",
                          type: "list",
                          member: {
                            locationName: "item",
                            type: "integer"
                          }
                        }
                      }
                    },
                    MemoryInfo: {
                      locationName: "memoryInfo",
                      type: "structure",
                      members: {
                        SizeInMiB: {
                          locationName: "sizeInMiB",
                          type: "long"
                        }
                      }
                    },
                    InstanceStorageSupported: {
                      locationName: "instanceStorageSupported",
                      type: "boolean"
                    },
                    InstanceStorageInfo: {
                      locationName: "instanceStorageInfo",
                      type: "structure",
                      members: {
                        TotalSizeInGB: {
                          locationName: "totalSizeInGB",
                          type: "long"
                        },
                        Disks: {
                          locationName: "disks",
                          type: "list",
                          member: {
                            locationName: "item",
                            type: "structure",
                            members: {
                              SizeInGB: {
                                locationName: "sizeInGB",
                                type: "long"
                              },
                              Count: {
                                locationName: "count",
                                type: "integer"
                              },
                              Type: {
                                locationName: "type"
                              }
                            }
                          }
                        },
                        NvmeSupport: {
                          locationName: "nvmeSupport"
                        },
                        EncryptionSupport: {
                          locationName: "encryptionSupport"
                        }
                      }
                    },
                    EbsInfo: {
                      locationName: "ebsInfo",
                      type: "structure",
                      members: {
                        EbsOptimizedSupport: {
                          locationName: "ebsOptimizedSupport"
                        },
                        EncryptionSupport: {
                          locationName: "encryptionSupport"
                        },
                        EbsOptimizedInfo: {
                          locationName: "ebsOptimizedInfo",
                          type: "structure",
                          members: {
                            BaselineBandwidthInMbps: {
                              locationName: "baselineBandwidthInMbps",
                              type: "integer"
                            },
                            BaselineThroughputInMBps: {
                              locationName: "baselineThroughputInMBps",
                              type: "double"
                            },
                            BaselineIops: {
                              locationName: "baselineIops",
                              type: "integer"
                            },
                            MaximumBandwidthInMbps: {
                              locationName: "maximumBandwidthInMbps",
                              type: "integer"
                            },
                            MaximumThroughputInMBps: {
                              locationName: "maximumThroughputInMBps",
                              type: "double"
                            },
                            MaximumIops: {
                              locationName: "maximumIops",
                              type: "integer"
                            }
                          }
                        },
                        NvmeSupport: {
                          locationName: "nvmeSupport"
                        }
                      }
                    },
                    NetworkInfo: {
                      locationName: "networkInfo",
                      type: "structure",
                      members: {
                        NetworkPerformance: {
                          locationName: "networkPerformance"
                        },
                        MaximumNetworkInterfaces: {
                          locationName: "maximumNetworkInterfaces",
                          type: "integer"
                        },
                        MaximumNetworkCards: {
                          locationName: "maximumNetworkCards",
                          type: "integer"
                        },
                        DefaultNetworkCardIndex: {
                          locationName: "defaultNetworkCardIndex",
                          type: "integer"
                        },
                        NetworkCards: {
                          locationName: "networkCards",
                          type: "list",
                          member: {
                            locationName: "item",
                            type: "structure",
                            members: {
                              NetworkCardIndex: {
                                locationName: "networkCardIndex",
                                type: "integer"
                              },
                              NetworkPerformance: {
                                locationName: "networkPerformance"
                              },
                              MaximumNetworkInterfaces: {
                                locationName: "maximumNetworkInterfaces",
                                type: "integer"
                              },
                              BaselineBandwidthInGbps: {
                                locationName: "baselineBandwidthInGbps",
                                type: "double"
                              },
                              PeakBandwidthInGbps: {
                                locationName: "peakBandwidthInGbps",
                                type: "double"
                              }
                            }
                          }
                        },
                        Ipv4AddressesPerInterface: {
                          locationName: "ipv4AddressesPerInterface",
                          type: "integer"
                        },
                        Ipv6AddressesPerInterface: {
                          locationName: "ipv6AddressesPerInterface",
                          type: "integer"
                        },
                        Ipv6Supported: {
                          locationName: "ipv6Supported",
                          type: "boolean"
                        },
                        EnaSupport: {
                          locationName: "enaSupport"
                        },
                        EfaSupported: {
                          locationName: "efaSupported",
                          type: "boolean"
                        },
                        EfaInfo: {
                          locationName: "efaInfo",
                          type: "structure",
                          members: {
                            MaximumEfaInterfaces: {
                              locationName: "maximumEfaInterfaces",
                              type: "integer"
                            }
                          }
                        },
                        EncryptionInTransitSupported: {
                          locationName: "encryptionInTransitSupported",
                          type: "boolean"
                        },
                        EnaSrdSupported: {
                          locationName: "enaSrdSupported",
                          type: "boolean"
                        }
                      }
                    },
                    GpuInfo: {
                      locationName: "gpuInfo",
                      type: "structure",
                      members: {
                        Gpus: {
                          locationName: "gpus",
                          type: "list",
                          member: {
                            locationName: "item",
                            type: "structure",
                            members: {
                              Name: {
                                locationName: "name"
                              },
                              Manufacturer: {
                                locationName: "manufacturer"
                              },
                              Count: {
                                locationName: "count",
                                type: "integer"
                              },
                              MemoryInfo: {
                                locationName: "memoryInfo",
                                type: "structure",
                                members: {
                                  SizeInMiB: {
                                    locationName: "sizeInMiB",
                                    type: "integer"
                                  }
                                }
                              }
                            }
                          }
                        },
                        TotalGpuMemoryInMiB: {
                          locationName: "totalGpuMemoryInMiB",
                          type: "integer"
                        }
                      }
                    },
                    FpgaInfo: {
                      locationName: "fpgaInfo",
                      type: "structure",
                      members: {
                        Fpgas: {
                          locationName: "fpgas",
                          type: "list",
                          member: {
                            locationName: "item",
                            type: "structure",
                            members: {
                              Name: {
                                locationName: "name"
                              },
                              Manufacturer: {
                                locationName: "manufacturer"
                              },
                              Count: {
                                locationName: "count",
                                type: "integer"
                              },
                              MemoryInfo: {
                                locationName: "memoryInfo",
                                type: "structure",
                                members: {
                                  SizeInMiB: {
                                    locationName: "sizeInMiB",
                                    type: "integer"
                                  }
                                }
                              }
                            }
                          }
                        },
                        TotalFpgaMemoryInMiB: {
                          locationName: "totalFpgaMemoryInMiB",
                          type: "integer"
                        }
                      }
                    },
                    PlacementGroupInfo: {
                      locationName: "placementGroupInfo",
                      type: "structure",
                      members: {
                        SupportedStrategies: {
                          locationName: "supportedStrategies",
                          type: "list",
                          member: {
                            locationName: "item"
                          }
                        }
                      }
                    },
                    InferenceAcceleratorInfo: {
                      locationName: "inferenceAcceleratorInfo",
                      type: "structure",
                      members: {
                        Accelerators: {
                          locationName: "item",
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              Count: {
                                locationName: "count",
                                type: "integer"
                              },
                              Name: {
                                locationName: "name"
                              },
                              Manufacturer: {
                                locationName: "manufacturer"
                              },
                              MemoryInfo: {
                                locationName: "memoryInfo",
                                type: "structure",
                                members: {
                                  SizeInMiB: {
                                    locationName: "sizeInMiB",
                                    type: "integer"
                                  }
                                }
                              }
                            }
                          }
                        },
                        TotalInferenceMemoryInMiB: {
                          locationName: "totalInferenceMemoryInMiB",
                          type: "integer"
                        }
                      }
                    },
                    HibernationSupported: {
                      locationName: "hibernationSupported",
                      type: "boolean"
                    },
                    BurstablePerformanceSupported: {
                      locationName: "burstablePerformanceSupported",
                      type: "boolean"
                    },
                    DedicatedHostsSupported: {
                      locationName: "dedicatedHostsSupported",
                      type: "boolean"
                    },
                    AutoRecoverySupported: {
                      locationName: "autoRecoverySupported",
                      type: "boolean"
                    },
                    SupportedBootModes: {
                      locationName: "supportedBootModes",
                      type: "list",
                      member: {
                        locationName: "item"
                      }
                    },
                    NitroEnclavesSupport: {
                      locationName: "nitroEnclavesSupport"
                    },
                    NitroTpmSupport: {
                      locationName: "nitroTpmSupport"
                    },
                    NitroTpmInfo: {
                      locationName: "nitroTpmInfo",
                      type: "structure",
                      members: {
                        SupportedVersions: {
                          locationName: "supportedVersions",
                          type: "list",
                          member: {
                            locationName: "item"
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeInstances: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              InstanceIds: {
                shape: "S128",
                locationName: "InstanceId"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Reservations: {
                locationName: "reservationSet",
                type: "list",
                member: {
                  shape: "S1du",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeInternetGateways: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              InternetGatewayIds: {
                locationName: "internetGatewayId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InternetGateways: {
                locationName: "internetGatewaySet",
                type: "list",
                member: {
                  shape: "Sfl",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeIpamByoasn: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Byoasns: {
                locationName: "byoasnSet",
                type: "list",
                member: {
                  shape: "Szb",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeIpamPools: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              IpamPoolIds: {
                shape: "So",
                locationName: "IpamPoolId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              IpamPools: {
                locationName: "ipamPoolSet",
                type: "list",
                member: {
                  shape: "Sg6",
                  locationName: "item"
                }
              }
            }
          }
        },
        DescribeIpamResourceDiscoveries: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              IpamResourceDiscoveryIds: {
                shape: "So",
                locationName: "IpamResourceDiscoveryId"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IpamResourceDiscoveries: {
                locationName: "ipamResourceDiscoverySet",
                type: "list",
                member: {
                  shape: "Sge",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeIpamResourceDiscoveryAssociations: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              IpamResourceDiscoveryAssociationIds: {
                shape: "So",
                locationName: "IpamResourceDiscoveryAssociationId"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IpamResourceDiscoveryAssociations: {
                locationName: "ipamResourceDiscoveryAssociationSet",
                type: "list",
                member: {
                  shape: "S4l",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeIpamScopes: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              IpamScopeIds: {
                shape: "So",
                locationName: "IpamScopeId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              IpamScopes: {
                locationName: "ipamScopeSet",
                type: "list",
                member: {
                  shape: "Sgi",
                  locationName: "item"
                }
              }
            }
          }
        },
        DescribeIpams: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              IpamIds: {
                shape: "So",
                locationName: "IpamId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Ipams: {
                locationName: "ipamSet",
                type: "list",
                member: {
                  shape: "Sfr",
                  locationName: "item"
                }
              }
            }
          }
        },
        DescribeIpv6Pools: {
          input: {
            type: "structure",
            members: {
              PoolIds: {
                locationName: "PoolId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Ipv6Pools: {
                locationName: "ipv6PoolSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    PoolId: {
                      locationName: "poolId"
                    },
                    Description: {
                      locationName: "description"
                    },
                    PoolCidrBlocks: {
                      locationName: "poolCidrBlockSet",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          Cidr: {
                            locationName: "poolCidrBlock"
                          }
                        }
                      }
                    },
                    Tags: {
                      shape: "S6",
                      locationName: "tagSet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeKeyPairs: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              KeyNames: {
                locationName: "KeyName",
                type: "list",
                member: {
                  locationName: "KeyName"
                }
              },
              KeyPairIds: {
                locationName: "KeyPairId",
                type: "list",
                member: {
                  locationName: "KeyPairId"
                }
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              IncludePublicKey: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KeyPairs: {
                locationName: "keySet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    KeyPairId: {
                      locationName: "keyPairId"
                    },
                    KeyFingerprint: {
                      locationName: "keyFingerprint"
                    },
                    KeyName: {
                      locationName: "keyName"
                    },
                    KeyType: {
                      locationName: "keyType"
                    },
                    Tags: {
                      shape: "S6",
                      locationName: "tagSet"
                    },
                    PublicKey: {
                      locationName: "publicKey"
                    },
                    CreateTime: {
                      locationName: "createTime",
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeLaunchTemplateVersions: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              LaunchTemplateId: {},
              LaunchTemplateName: {},
              Versions: {
                shape: "Sw1",
                locationName: "LaunchTemplateVersion"
              },
              MinVersion: {},
              MaxVersion: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              ResolveAlias: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LaunchTemplateVersions: {
                locationName: "launchTemplateVersionSet",
                type: "list",
                member: {
                  shape: "Sii",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeLaunchTemplates: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              LaunchTemplateIds: {
                locationName: "LaunchTemplateId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              LaunchTemplateNames: {
                locationName: "LaunchTemplateName",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LaunchTemplates: {
                locationName: "launchTemplates",
                type: "list",
                member: {
                  shape: "Sic",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociations: {
          input: {
            type: "structure",
            members: {
              LocalGatewayRouteTableVirtualInterfaceGroupAssociationIds: {
                locationName: "LocalGatewayRouteTableVirtualInterfaceGroupAssociationId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocalGatewayRouteTableVirtualInterfaceGroupAssociations: {
                locationName: "localGatewayRouteTableVirtualInterfaceGroupAssociationSet",
                type: "list",
                member: {
                  shape: "Sjz",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeLocalGatewayRouteTableVpcAssociations: {
          input: {
            type: "structure",
            members: {
              LocalGatewayRouteTableVpcAssociationIds: {
                locationName: "LocalGatewayRouteTableVpcAssociationId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocalGatewayRouteTableVpcAssociations: {
                locationName: "localGatewayRouteTableVpcAssociationSet",
                type: "list",
                member: {
                  shape: "Sk3",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeLocalGatewayRouteTables: {
          input: {
            type: "structure",
            members: {
              LocalGatewayRouteTableIds: {
                locationName: "LocalGatewayRouteTableId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocalGatewayRouteTables: {
                locationName: "localGatewayRouteTableSet",
                type: "list",
                member: {
                  shape: "Sjv",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeLocalGatewayVirtualInterfaceGroups: {
          input: {
            type: "structure",
            members: {
              LocalGatewayVirtualInterfaceGroupIds: {
                locationName: "LocalGatewayVirtualInterfaceGroupId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocalGatewayVirtualInterfaceGroups: {
                locationName: "localGatewayVirtualInterfaceGroupSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    LocalGatewayVirtualInterfaceGroupId: {
                      locationName: "localGatewayVirtualInterfaceGroupId"
                    },
                    LocalGatewayVirtualInterfaceIds: {
                      shape: "S1gq",
                      locationName: "localGatewayVirtualInterfaceIdSet"
                    },
                    LocalGatewayId: {
                      locationName: "localGatewayId"
                    },
                    OwnerId: {
                      locationName: "ownerId"
                    },
                    Tags: {
                      shape: "S6",
                      locationName: "tagSet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeLocalGatewayVirtualInterfaces: {
          input: {
            type: "structure",
            members: {
              LocalGatewayVirtualInterfaceIds: {
                shape: "S1gq",
                locationName: "LocalGatewayVirtualInterfaceId"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocalGatewayVirtualInterfaces: {
                locationName: "localGatewayVirtualInterfaceSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    LocalGatewayVirtualInterfaceId: {
                      locationName: "localGatewayVirtualInterfaceId"
                    },
                    LocalGatewayId: {
                      locationName: "localGatewayId"
                    },
                    Vlan: {
                      locationName: "vlan",
                      type: "integer"
                    },
                    LocalAddress: {
                      locationName: "localAddress"
                    },
                    PeerAddress: {
                      locationName: "peerAddress"
                    },
                    LocalBgpAsn: {
                      locationName: "localBgpAsn",
                      type: "integer"
                    },
                    PeerBgpAsn: {
                      locationName: "peerBgpAsn",
                      type: "integer"
                    },
                    OwnerId: {
                      locationName: "ownerId"
                    },
                    Tags: {
                      shape: "S6",
                      locationName: "tagSet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeLocalGateways: {
          input: {
            type: "structure",
            members: {
              LocalGatewayIds: {
                locationName: "LocalGatewayId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocalGateways: {
                locationName: "localGatewaySet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    LocalGatewayId: {
                      locationName: "localGatewayId"
                    },
                    OutpostArn: {
                      locationName: "outpostArn"
                    },
                    OwnerId: {
                      locationName: "ownerId"
                    },
                    State: {
                      locationName: "state"
                    },
                    Tags: {
                      shape: "S6",
                      locationName: "tagSet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeLockedSnapshots: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              SnapshotIds: {
                shape: "S1h3",
                locationName: "SnapshotId"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Snapshots: {
                locationName: "snapshotSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    OwnerId: {
                      locationName: "ownerId"
                    },
                    SnapshotId: {
                      locationName: "snapshotId"
                    },
                    LockState: {
                      locationName: "lockState"
                    },
                    LockDuration: {
                      locationName: "lockDuration",
                      type: "integer"
                    },
                    CoolOffPeriod: {
                      locationName: "coolOffPeriod",
                      type: "integer"
                    },
                    CoolOffPeriodExpiresOn: {
                      locationName: "coolOffPeriodExpiresOn",
                      type: "timestamp"
                    },
                    LockCreatedOn: {
                      locationName: "lockCreatedOn",
                      type: "timestamp"
                    },
                    LockDurationStartTime: {
                      locationName: "lockDurationStartTime",
                      type: "timestamp"
                    },
                    LockExpiresOn: {
                      locationName: "lockExpiresOn",
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeManagedPrefixLists: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              PrefixListIds: {
                shape: "So",
                locationName: "PrefixListId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              PrefixLists: {
                locationName: "prefixListSet",
                type: "list",
                member: {
                  shape: "Sk9",
                  locationName: "item"
                }
              }
            }
          }
        },
        DescribeMovingAddresses: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "filter"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              },
              PublicIps: {
                shape: "So",
                locationName: "publicIp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MovingAddressStatuses: {
                locationName: "movingAddressStatusSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    MoveStatus: {
                      locationName: "moveStatus"
                    },
                    PublicIp: {
                      locationName: "publicIp"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeNatGateways: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              Filter: {
                shape: "S10d"
              },
              MaxResults: {
                type: "integer"
              },
              NatGatewayIds: {
                locationName: "NatGatewayId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NatGateways: {
                locationName: "natGatewaySet",
                type: "list",
                member: {
                  shape: "Ske",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeNetworkAcls: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              NetworkAclIds: {
                locationName: "NetworkAclId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkAcls: {
                locationName: "networkAclSet",
                type: "list",
                member: {
                  shape: "Skj",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeNetworkInsightsAccessScopeAnalyses: {
          input: {
            type: "structure",
            members: {
              NetworkInsightsAccessScopeAnalysisIds: {
                locationName: "NetworkInsightsAccessScopeAnalysisId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              NetworkInsightsAccessScopeId: {},
              AnalysisStartTimeBegin: {
                type: "timestamp"
              },
              AnalysisStartTimeEnd: {
                type: "timestamp"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              DryRun: {
                type: "boolean"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkInsightsAccessScopeAnalyses: {
                locationName: "networkInsightsAccessScopeAnalysisSet",
                type: "list",
                member: {
                  shape: "S1hz",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeNetworkInsightsAccessScopes: {
          input: {
            type: "structure",
            members: {
              NetworkInsightsAccessScopeIds: {
                locationName: "NetworkInsightsAccessScopeId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              DryRun: {
                type: "boolean"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkInsightsAccessScopes: {
                locationName: "networkInsightsAccessScopeSet",
                type: "list",
                member: {
                  shape: "Sl4",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeNetworkInsightsAnalyses: {
          input: {
            type: "structure",
            members: {
              NetworkInsightsAnalysisIds: {
                locationName: "NetworkInsightsAnalysisId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              NetworkInsightsPathId: {},
              AnalysisStartTime: {
                type: "timestamp"
              },
              AnalysisEndTime: {
                type: "timestamp"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              DryRun: {
                type: "boolean"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkInsightsAnalyses: {
                locationName: "networkInsightsAnalysisSet",
                type: "list",
                member: {
                  shape: "S1ia",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeNetworkInsightsPaths: {
          input: {
            type: "structure",
            members: {
              NetworkInsightsPathIds: {
                locationName: "NetworkInsightsPathId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              DryRun: {
                type: "boolean"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkInsightsPaths: {
                locationName: "networkInsightsPathSet",
                type: "list",
                member: {
                  shape: "Sll",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeNetworkInterfaceAttribute: {
          input: {
            type: "structure",
            required: [
              "NetworkInterfaceId"
            ],
            members: {
              Attribute: {
                locationName: "attribute"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attachment: {
                shape: "Slu",
                locationName: "attachment"
              },
              Description: {
                shape: "Sc1",
                locationName: "description"
              },
              Groups: {
                shape: "Sly",
                locationName: "groupSet"
              },
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              },
              SourceDestCheck: {
                shape: "S19c",
                locationName: "sourceDestCheck"
              }
            }
          }
        },
        DescribeNetworkInterfacePermissions: {
          input: {
            type: "structure",
            members: {
              NetworkInterfacePermissionIds: {
                locationName: "NetworkInterfacePermissionId",
                type: "list",
                member: {}
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkInterfacePermissions: {
                locationName: "networkInterfacePermissions",
                type: "list",
                member: {
                  shape: "Smb",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeNetworkInterfaces: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "filter"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              NetworkInterfaceIds: {
                locationName: "NetworkInterfaceId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkInterfaces: {
                locationName: "networkInterfaceSet",
                type: "list",
                member: {
                  shape: "Sls",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribePlacementGroups: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              GroupNames: {
                locationName: "groupName",
                type: "list",
                member: {}
              },
              GroupIds: {
                locationName: "GroupId",
                type: "list",
                member: {
                  locationName: "GroupId"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PlacementGroups: {
                locationName: "placementGroupSet",
                type: "list",
                member: {
                  shape: "Smi",
                  locationName: "item"
                }
              }
            }
          }
        },
        DescribePrefixLists: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              PrefixListIds: {
                locationName: "PrefixListId",
                type: "list",
                member: {
                  locationName: "item"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              PrefixLists: {
                locationName: "prefixListSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Cidrs: {
                      shape: "So",
                      locationName: "cidrSet"
                    },
                    PrefixListId: {
                      locationName: "prefixListId"
                    },
                    PrefixListName: {
                      locationName: "prefixListName"
                    }
                  }
                }
              }
            }
          }
        },
        DescribePrincipalIdFormat: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              Resources: {
                locationName: "Resource",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Principals: {
                locationName: "principalSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Arn: {
                      locationName: "arn"
                    },
                    Statuses: {
                      shape: "S10u",
                      locationName: "statusSet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribePublicIpv4Pools: {
          input: {
            type: "structure",
            members: {
              PoolIds: {
                locationName: "PoolId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicIpv4Pools: {
                locationName: "publicIpv4PoolSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    PoolId: {
                      locationName: "poolId"
                    },
                    Description: {
                      locationName: "description"
                    },
                    PoolAddressRanges: {
                      locationName: "poolAddressRangeSet",
                      type: "list",
                      member: {
                        shape: "S1kd",
                        locationName: "item"
                      }
                    },
                    TotalAddressCount: {
                      locationName: "totalAddressCount",
                      type: "integer"
                    },
                    TotalAvailableAddressCount: {
                      locationName: "totalAvailableAddressCount",
                      type: "integer"
                    },
                    NetworkBorderGroup: {
                      locationName: "networkBorderGroup"
                    },
                    Tags: {
                      shape: "S6",
                      locationName: "tagSet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeRegions: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              RegionNames: {
                locationName: "RegionName",
                type: "list",
                member: {
                  locationName: "RegionName"
                }
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              AllRegions: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Regions: {
                locationName: "regionInfo",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Endpoint: {
                      locationName: "regionEndpoint"
                    },
                    RegionName: {
                      locationName: "regionName"
                    },
                    OptInStatus: {
                      locationName: "optInStatus"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeReplaceRootVolumeTasks: {
          input: {
            type: "structure",
            members: {
              ReplaceRootVolumeTaskIds: {
                locationName: "ReplaceRootVolumeTaskId",
                type: "list",
                member: {
                  locationName: "ReplaceRootVolumeTaskId"
                }
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReplaceRootVolumeTasks: {
                locationName: "replaceRootVolumeTaskSet",
                type: "list",
                member: {
                  shape: "Smo",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeReservedInstances: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              OfferingClass: {},
              ReservedInstancesIds: {
                shape: "S1kq",
                locationName: "ReservedInstancesId"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              OfferingType: {
                locationName: "offeringType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReservedInstances: {
                locationName: "reservedInstancesSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    AvailabilityZone: {
                      locationName: "availabilityZone"
                    },
                    Duration: {
                      locationName: "duration",
                      type: "long"
                    },
                    End: {
                      locationName: "end",
                      type: "timestamp"
                    },
                    FixedPrice: {
                      locationName: "fixedPrice",
                      type: "float"
                    },
                    InstanceCount: {
                      locationName: "instanceCount",
                      type: "integer"
                    },
                    InstanceType: {
                      locationName: "instanceType"
                    },
                    ProductDescription: {
                      locationName: "productDescription"
                    },
                    ReservedInstancesId: {
                      locationName: "reservedInstancesId"
                    },
                    Start: {
                      locationName: "start",
                      type: "timestamp"
                    },
                    State: {
                      locationName: "state"
                    },
                    UsagePrice: {
                      locationName: "usagePrice",
                      type: "float"
                    },
                    CurrencyCode: {
                      locationName: "currencyCode"
                    },
                    InstanceTenancy: {
                      locationName: "instanceTenancy"
                    },
                    OfferingClass: {
                      locationName: "offeringClass"
                    },
                    OfferingType: {
                      locationName: "offeringType"
                    },
                    RecurringCharges: {
                      shape: "S1ky",
                      locationName: "recurringCharges"
                    },
                    Scope: {
                      locationName: "scope"
                    },
                    Tags: {
                      shape: "S6",
                      locationName: "tagSet"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeReservedInstancesListings: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              ReservedInstancesId: {
                locationName: "reservedInstancesId"
              },
              ReservedInstancesListingId: {
                locationName: "reservedInstancesListingId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReservedInstancesListings: {
                shape: "S8k",
                locationName: "reservedInstancesListingsSet"
              }
            }
          }
        },
        DescribeReservedInstancesModifications: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              ReservedInstancesModificationIds: {
                locationName: "ReservedInstancesModificationId",
                type: "list",
                member: {
                  locationName: "ReservedInstancesModificationId"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              ReservedInstancesModifications: {
                locationName: "reservedInstancesModificationsSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ClientToken: {
                      locationName: "clientToken"
                    },
                    CreateDate: {
                      locationName: "createDate",
                      type: "timestamp"
                    },
                    EffectiveDate: {
                      locationName: "effectiveDate",
                      type: "timestamp"
                    },
                    ModificationResults: {
                      locationName: "modificationResultSet",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          ReservedInstancesId: {
                            locationName: "reservedInstancesId"
                          },
                          TargetConfiguration: {
                            shape: "S1lc",
                            locationName: "targetConfiguration"
                          }
                        }
                      }
                    },
                    ReservedInstancesIds: {
                      locationName: "reservedInstancesSet",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          ReservedInstancesId: {
                            locationName: "reservedInstancesId"
                          }
                        }
                      }
                    },
                    ReservedInstancesModificationId: {
                      locationName: "reservedInstancesModificationId"
                    },
                    Status: {
                      locationName: "status"
                    },
                    StatusMessage: {
                      locationName: "statusMessage"
                    },
                    UpdateDate: {
                      locationName: "updateDate",
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeReservedInstancesOfferings: {
          input: {
            type: "structure",
            members: {
              AvailabilityZone: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              IncludeMarketplace: {
                type: "boolean"
              },
              InstanceType: {},
              MaxDuration: {
                type: "long"
              },
              MaxInstanceCount: {
                type: "integer"
              },
              MinDuration: {
                type: "long"
              },
              OfferingClass: {},
              ProductDescription: {},
              ReservedInstancesOfferingIds: {
                locationName: "ReservedInstancesOfferingId",
                type: "list",
                member: {}
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              InstanceTenancy: {
                locationName: "instanceTenancy"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              },
              OfferingType: {
                locationName: "offeringType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReservedInstancesOfferings: {
                locationName: "reservedInstancesOfferingsSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    AvailabilityZone: {
                      locationName: "availabilityZone"
                    },
                    Duration: {
                      locationName: "duration",
                      type: "long"
                    },
                    FixedPrice: {
                      locationName: "fixedPrice",
                      type: "float"
                    },
                    InstanceType: {
                      locationName: "instanceType"
                    },
                    ProductDescription: {
                      locationName: "productDescription"
                    },
                    ReservedInstancesOfferingId: {
                      locationName: "reservedInstancesOfferingId"
                    },
                    UsagePrice: {
                      locationName: "usagePrice",
                      type: "float"
                    },
                    CurrencyCode: {
                      locationName: "currencyCode"
                    },
                    InstanceTenancy: {
                      locationName: "instanceTenancy"
                    },
                    Marketplace: {
                      locationName: "marketplace",
                      type: "boolean"
                    },
                    OfferingClass: {
                      locationName: "offeringClass"
                    },
                    OfferingType: {
                      locationName: "offeringType"
                    },
                    PricingDetails: {
                      locationName: "pricingDetailsSet",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          Count: {
                            locationName: "count",
                            type: "integer"
                          },
                          Price: {
                            locationName: "price",
                            type: "double"
                          }
                        }
                      }
                    },
                    RecurringCharges: {
                      shape: "S1ky",
                      locationName: "recurringCharges"
                    },
                    Scope: {
                      locationName: "scope"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeRouteTables: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              RouteTableIds: {
                locationName: "RouteTableId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RouteTables: {
                locationName: "routeTableSet",
                type: "list",
                member: {
                  shape: "Sn4",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeScheduledInstanceAvailability: {
          input: {
            type: "structure",
            required: [
              "FirstSlotStartTimeRange",
              "Recurrence"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              FirstSlotStartTimeRange: {
                type: "structure",
                required: [
                  "EarliestTime",
                  "LatestTime"
                ],
                members: {
                  EarliestTime: {
                    type: "timestamp"
                  },
                  LatestTime: {
                    type: "timestamp"
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              MaxSlotDurationInHours: {
                type: "integer"
              },
              MinSlotDurationInHours: {
                type: "integer"
              },
              NextToken: {},
              Recurrence: {
                type: "structure",
                members: {
                  Frequency: {},
                  Interval: {
                    type: "integer"
                  },
                  OccurrenceDays: {
                    locationName: "OccurrenceDay",
                    type: "list",
                    member: {
                      locationName: "OccurenceDay",
                      type: "integer"
                    }
                  },
                  OccurrenceRelativeToEnd: {
                    type: "boolean"
                  },
                  OccurrenceUnit: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              ScheduledInstanceAvailabilitySet: {
                locationName: "scheduledInstanceAvailabilitySet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    AvailabilityZone: {
                      locationName: "availabilityZone"
                    },
                    AvailableInstanceCount: {
                      locationName: "availableInstanceCount",
                      type: "integer"
                    },
                    FirstSlotStartTime: {
                      locationName: "firstSlotStartTime",
                      type: "timestamp"
                    },
                    HourlyPrice: {
                      locationName: "hourlyPrice"
                    },
                    InstanceType: {
                      locationName: "instanceType"
                    },
                    MaxTermDurationInDays: {
                      locationName: "maxTermDurationInDays",
                      type: "integer"
                    },
                    MinTermDurationInDays: {
                      locationName: "minTermDurationInDays",
                      type: "integer"
                    },
                    NetworkPlatform: {
                      locationName: "networkPlatform"
                    },
                    Platform: {
                      locationName: "platform"
                    },
                    PurchaseToken: {
                      locationName: "purchaseToken"
                    },
                    Recurrence: {
                      shape: "S1lz",
                      locationName: "recurrence"
                    },
                    SlotDurationInHours: {
                      locationName: "slotDurationInHours",
                      type: "integer"
                    },
                    TotalScheduledInstanceHours: {
                      locationName: "totalScheduledInstanceHours",
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeScheduledInstances: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              ScheduledInstanceIds: {
                locationName: "ScheduledInstanceId",
                type: "list",
                member: {
                  locationName: "ScheduledInstanceId"
                }
              },
              SlotStartTimeRange: {
                type: "structure",
                members: {
                  EarliestTime: {
                    type: "timestamp"
                  },
                  LatestTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              ScheduledInstanceSet: {
                locationName: "scheduledInstanceSet",
                type: "list",
                member: {
                  shape: "S1m7",
                  locationName: "item"
                }
              }
            }
          }
        },
        DescribeSecurityGroupReferences: {
          input: {
            type: "structure",
            required: [
              "GroupId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              GroupId: {
                type: "list",
                member: {
                  locationName: "item"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SecurityGroupReferenceSet: {
                locationName: "securityGroupReferenceSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    GroupId: {
                      locationName: "groupId"
                    },
                    ReferencingVpcId: {
                      locationName: "referencingVpcId"
                    },
                    VpcPeeringConnectionId: {
                      locationName: "vpcPeeringConnectionId"
                    },
                    TransitGatewayId: {
                      locationName: "transitGatewayId"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeSecurityGroupRules: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              SecurityGroupRuleIds: {
                shape: "S1me",
                locationName: "SecurityGroupRuleId"
              },
              DryRun: {
                type: "boolean"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SecurityGroupRules: {
                shape: "S78",
                locationName: "securityGroupRuleSet"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeSecurityGroups: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              GroupIds: {
                shape: "S5v",
                locationName: "GroupId"
              },
              GroupNames: {
                shape: "S1mi",
                locationName: "GroupName"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SecurityGroups: {
                locationName: "securityGroupInfo",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Description: {
                      locationName: "groupDescription"
                    },
                    GroupName: {
                      locationName: "groupName"
                    },
                    IpPermissions: {
                      shape: "S6x",
                      locationName: "ipPermissions"
                    },
                    OwnerId: {
                      locationName: "ownerId"
                    },
                    GroupId: {
                      locationName: "groupId"
                    },
                    IpPermissionsEgress: {
                      shape: "S6x",
                      locationName: "ipPermissionsEgress"
                    },
                    Tags: {
                      shape: "S6",
                      locationName: "tagSet"
                    },
                    VpcId: {
                      locationName: "vpcId"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeSnapshotAttribute: {
          input: {
            type: "structure",
            required: [
              "Attribute",
              "SnapshotId"
            ],
            members: {
              Attribute: {},
              SnapshotId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CreateVolumePermissions: {
                shape: "S1mq",
                locationName: "createVolumePermission"
              },
              ProductCodes: {
                shape: "S16n",
                locationName: "productCodes"
              },
              SnapshotId: {
                locationName: "snapshotId"
              }
            }
          }
        },
        DescribeSnapshotTierStatus: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              DryRun: {
                type: "boolean"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SnapshotTierStatuses: {
                locationName: "snapshotTierStatusSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    SnapshotId: {
                      locationName: "snapshotId"
                    },
                    VolumeId: {
                      locationName: "volumeId"
                    },
                    Status: {
                      locationName: "status"
                    },
                    OwnerId: {
                      locationName: "ownerId"
                    },
                    Tags: {
                      shape: "S6",
                      locationName: "tagSet"
                    },
                    StorageTier: {
                      locationName: "storageTier"
                    },
                    LastTieringStartTime: {
                      locationName: "lastTieringStartTime",
                      type: "timestamp"
                    },
                    LastTieringProgress: {
                      locationName: "lastTieringProgress",
                      type: "integer"
                    },
                    LastTieringOperationStatus: {
                      locationName: "lastTieringOperationStatus"
                    },
                    LastTieringOperationStatusDetail: {
                      locationName: "lastTieringOperationStatusDetail"
                    },
                    ArchivalCompleteTime: {
                      locationName: "archivalCompleteTime",
                      type: "timestamp"
                    },
                    RestoreExpiryTime: {
                      locationName: "restoreExpiryTime",
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeSnapshots: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              OwnerIds: {
                shape: "S16s",
                locationName: "Owner"
              },
              RestorableByUserIds: {
                locationName: "RestorableBy",
                type: "list",
                member: {}
              },
              SnapshotIds: {
                shape: "S1h3",
                locationName: "SnapshotId"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Snapshots: {
                locationName: "snapshotSet",
                type: "list",
                member: {
                  shape: "Sng",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeSpotDatafeedSubscription: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SpotDatafeedSubscription: {
                shape: "Snu",
                locationName: "spotDatafeedSubscription"
              }
            }
          }
        },
        DescribeSpotFleetInstances: {
          input: {
            type: "structure",
            required: [
              "SpotFleetRequestId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              },
              SpotFleetRequestId: {
                locationName: "spotFleetRequestId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ActiveInstances: {
                shape: "S15q",
                locationName: "activeInstanceSet"
              },
              NextToken: {
                locationName: "nextToken"
              },
              SpotFleetRequestId: {
                locationName: "spotFleetRequestId"
              }
            }
          }
        },
        DescribeSpotFleetRequestHistory: {
          input: {
            type: "structure",
            required: [
              "SpotFleetRequestId",
              "StartTime"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              EventType: {
                locationName: "eventType"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              },
              SpotFleetRequestId: {
                locationName: "spotFleetRequestId"
              },
              StartTime: {
                locationName: "startTime",
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HistoryRecords: {
                locationName: "historyRecordSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    EventInformation: {
                      shape: "S15n",
                      locationName: "eventInformation"
                    },
                    EventType: {
                      locationName: "eventType"
                    },
                    Timestamp: {
                      locationName: "timestamp",
                      type: "timestamp"
                    }
                  }
                }
              },
              LastEvaluatedTime: {
                locationName: "lastEvaluatedTime",
                type: "timestamp"
              },
              NextToken: {
                locationName: "nextToken"
              },
              SpotFleetRequestId: {
                locationName: "spotFleetRequestId"
              },
              StartTime: {
                locationName: "startTime",
                type: "timestamp"
              }
            }
          }
        },
        DescribeSpotFleetRequests: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              },
              SpotFleetRequestIds: {
                shape: "S8w",
                locationName: "spotFleetRequestId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              SpotFleetRequestConfigs: {
                locationName: "spotFleetRequestConfigSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ActivityStatus: {
                      locationName: "activityStatus"
                    },
                    CreateTime: {
                      locationName: "createTime",
                      type: "timestamp"
                    },
                    SpotFleetRequestConfig: {
                      shape: "S1ni",
                      locationName: "spotFleetRequestConfig"
                    },
                    SpotFleetRequestId: {
                      locationName: "spotFleetRequestId"
                    },
                    SpotFleetRequestState: {
                      locationName: "spotFleetRequestState"
                    },
                    Tags: {
                      shape: "S6",
                      locationName: "tagSet"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeSpotInstanceRequests: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              SpotInstanceRequestIds: {
                shape: "S97",
                locationName: "SpotInstanceRequestId"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SpotInstanceRequests: {
                shape: "S1oa",
                locationName: "spotInstanceRequestSet"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeSpotPriceHistory: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              AvailabilityZone: {
                locationName: "availabilityZone"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              EndTime: {
                locationName: "endTime",
                type: "timestamp"
              },
              InstanceTypes: {
                locationName: "InstanceType",
                type: "list",
                member: {}
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              },
              ProductDescriptions: {
                locationName: "ProductDescription",
                type: "list",
                member: {}
              },
              StartTime: {
                locationName: "startTime",
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              SpotPriceHistory: {
                locationName: "spotPriceHistorySet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    AvailabilityZone: {
                      locationName: "availabilityZone"
                    },
                    InstanceType: {
                      locationName: "instanceType"
                    },
                    ProductDescription: {
                      locationName: "productDescription"
                    },
                    SpotPrice: {
                      locationName: "spotPrice"
                    },
                    Timestamp: {
                      locationName: "timestamp",
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeStaleSecurityGroups: {
          input: {
            type: "structure",
            required: [
              "VpcId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              VpcId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              StaleSecurityGroupSet: {
                locationName: "staleSecurityGroupSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Description: {
                      locationName: "description"
                    },
                    GroupId: {
                      locationName: "groupId"
                    },
                    GroupName: {
                      locationName: "groupName"
                    },
                    StaleIpPermissions: {
                      shape: "S1os",
                      locationName: "staleIpPermissions"
                    },
                    StaleIpPermissionsEgress: {
                      shape: "S1os",
                      locationName: "staleIpPermissionsEgress"
                    },
                    VpcId: {
                      locationName: "vpcId"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeStoreImageTasks: {
          input: {
            type: "structure",
            members: {
              ImageIds: {
                locationName: "ImageId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StoreImageTaskResults: {
                locationName: "storeImageTaskResultSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    AmiId: {
                      locationName: "amiId"
                    },
                    TaskStartTime: {
                      locationName: "taskStartTime",
                      type: "timestamp"
                    },
                    Bucket: {
                      locationName: "bucket"
                    },
                    S3objectKey: {
                      locationName: "s3objectKey"
                    },
                    ProgressPercentage: {
                      locationName: "progressPercentage",
                      type: "integer"
                    },
                    StoreTaskState: {
                      locationName: "storeTaskState"
                    },
                    StoreTaskFailureReason: {
                      locationName: "storeTaskFailureReason"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeSubnets: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              SubnetIds: {
                locationName: "SubnetId",
                type: "list",
                member: {
                  locationName: "SubnetId"
                }
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Subnets: {
                locationName: "subnetSet",
                type: "list",
                member: {
                  shape: "Sbg",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeTags: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Tags: {
                locationName: "tagSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Key: {
                      locationName: "key"
                    },
                    ResourceId: {
                      locationName: "resourceId"
                    },
                    ResourceType: {
                      locationName: "resourceType"
                    },
                    Value: {
                      locationName: "value"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeTrafficMirrorFilters: {
          input: {
            type: "structure",
            members: {
              TrafficMirrorFilterIds: {
                locationName: "TrafficMirrorFilterId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrafficMirrorFilters: {
                locationName: "trafficMirrorFilterSet",
                type: "list",
                member: {
                  shape: "Sod",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeTrafficMirrorSessions: {
          input: {
            type: "structure",
            members: {
              TrafficMirrorSessionIds: {
                locationName: "TrafficMirrorSessionId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrafficMirrorSessions: {
                locationName: "trafficMirrorSessionSet",
                type: "list",
                member: {
                  shape: "Sos",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeTrafficMirrorTargets: {
          input: {
            type: "structure",
            members: {
              TrafficMirrorTargetIds: {
                locationName: "TrafficMirrorTargetId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrafficMirrorTargets: {
                locationName: "trafficMirrorTargetSet",
                type: "list",
                member: {
                  shape: "Sov",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeTransitGatewayAttachments: {
          input: {
            type: "structure",
            members: {
              TransitGatewayAttachmentIds: {
                shape: "S1pq"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayAttachments: {
                locationName: "transitGatewayAttachments",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    TransitGatewayAttachmentId: {
                      locationName: "transitGatewayAttachmentId"
                    },
                    TransitGatewayId: {
                      locationName: "transitGatewayId"
                    },
                    TransitGatewayOwnerId: {
                      locationName: "transitGatewayOwnerId"
                    },
                    ResourceOwnerId: {
                      locationName: "resourceOwnerId"
                    },
                    ResourceType: {
                      locationName: "resourceType"
                    },
                    ResourceId: {
                      locationName: "resourceId"
                    },
                    State: {
                      locationName: "state"
                    },
                    Association: {
                      locationName: "association",
                      type: "structure",
                      members: {
                        TransitGatewayRouteTableId: {
                          locationName: "transitGatewayRouteTableId"
                        },
                        State: {
                          locationName: "state"
                        }
                      }
                    },
                    CreationTime: {
                      locationName: "creationTime",
                      type: "timestamp"
                    },
                    Tags: {
                      shape: "S6",
                      locationName: "tagSet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeTransitGatewayConnectPeers: {
          input: {
            type: "structure",
            members: {
              TransitGatewayConnectPeerIds: {
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayConnectPeers: {
                locationName: "transitGatewayConnectPeerSet",
                type: "list",
                member: {
                  shape: "Spj",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeTransitGatewayConnects: {
          input: {
            type: "structure",
            members: {
              TransitGatewayAttachmentIds: {
                shape: "S1pq"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayConnects: {
                locationName: "transitGatewayConnectSet",
                type: "list",
                member: {
                  shape: "Spd",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeTransitGatewayMulticastDomains: {
          input: {
            type: "structure",
            members: {
              TransitGatewayMulticastDomainIds: {
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayMulticastDomains: {
                locationName: "transitGatewayMulticastDomains",
                type: "list",
                member: {
                  shape: "Spw",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeTransitGatewayPeeringAttachments: {
          input: {
            type: "structure",
            members: {
              TransitGatewayAttachmentIds: {
                shape: "S1pq"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayPeeringAttachments: {
                locationName: "transitGatewayPeeringAttachments",
                type: "list",
                member: {
                  shape: "Sx",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeTransitGatewayPolicyTables: {
          input: {
            type: "structure",
            members: {
              TransitGatewayPolicyTableIds: {
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayPolicyTables: {
                locationName: "transitGatewayPolicyTables",
                type: "list",
                member: {
                  shape: "Sq5",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeTransitGatewayRouteTableAnnouncements: {
          input: {
            type: "structure",
            members: {
              TransitGatewayRouteTableAnnouncementIds: {
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayRouteTableAnnouncements: {
                locationName: "transitGatewayRouteTableAnnouncements",
                type: "list",
                member: {
                  shape: "Sqq",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeTransitGatewayRouteTables: {
          input: {
            type: "structure",
            members: {
              TransitGatewayRouteTableIds: {
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayRouteTables: {
                locationName: "transitGatewayRouteTables",
                type: "list",
                member: {
                  shape: "Sqm",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeTransitGatewayVpcAttachments: {
          input: {
            type: "structure",
            members: {
              TransitGatewayAttachmentIds: {
                shape: "S1pq"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayVpcAttachments: {
                locationName: "transitGatewayVpcAttachments",
                type: "list",
                member: {
                  shape: "S16",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeTransitGateways: {
          input: {
            type: "structure",
            members: {
              TransitGatewayIds: {
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGateways: {
                locationName: "transitGatewaySet",
                type: "list",
                member: {
                  shape: "Sp6",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeTrunkInterfaceAssociations: {
          input: {
            type: "structure",
            members: {
              AssociationIds: {
                locationName: "AssociationId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InterfaceAssociations: {
                locationName: "interfaceAssociationSet",
                type: "list",
                member: {
                  shape: "S5k",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeVerifiedAccessEndpoints: {
          input: {
            type: "structure",
            members: {
              VerifiedAccessEndpointIds: {
                locationName: "VerifiedAccessEndpointId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              VerifiedAccessInstanceId: {},
              VerifiedAccessGroupId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VerifiedAccessEndpoints: {
                locationName: "verifiedAccessEndpointSet",
                type: "list",
                member: {
                  shape: "Sra",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeVerifiedAccessGroups: {
          input: {
            type: "structure",
            members: {
              VerifiedAccessGroupIds: {
                locationName: "VerifiedAccessGroupId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              VerifiedAccessInstanceId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VerifiedAccessGroups: {
                locationName: "verifiedAccessGroupSet",
                type: "list",
                member: {
                  shape: "Sri",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeVerifiedAccessInstanceLoggingConfigurations: {
          input: {
            type: "structure",
            members: {
              VerifiedAccessInstanceIds: {
                shape: "S1r9",
                locationName: "VerifiedAccessInstanceId"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LoggingConfigurations: {
                locationName: "loggingConfigurationSet",
                type: "list",
                member: {
                  shape: "S1rd",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeVerifiedAccessInstances: {
          input: {
            type: "structure",
            members: {
              VerifiedAccessInstanceIds: {
                shape: "S1r9",
                locationName: "VerifiedAccessInstanceId"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VerifiedAccessInstances: {
                locationName: "verifiedAccessInstanceSet",
                type: "list",
                member: {
                  shape: "S6g",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeVerifiedAccessTrustProviders: {
          input: {
            type: "structure",
            members: {
              VerifiedAccessTrustProviderIds: {
                locationName: "VerifiedAccessTrustProviderId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VerifiedAccessTrustProviders: {
                locationName: "verifiedAccessTrustProviderSet",
                type: "list",
                member: {
                  shape: "S67",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeVolumeAttribute: {
          input: {
            type: "structure",
            required: [
              "Attribute",
              "VolumeId"
            ],
            members: {
              Attribute: {},
              VolumeId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AutoEnableIO: {
                shape: "S19c",
                locationName: "autoEnableIO"
              },
              ProductCodes: {
                shape: "S16n",
                locationName: "productCodes"
              },
              VolumeId: {
                locationName: "volumeId"
              }
            }
          }
        },
        DescribeVolumeStatus: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              VolumeIds: {
                shape: "Snn",
                locationName: "VolumeId"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              VolumeStatuses: {
                locationName: "volumeStatusSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Actions: {
                      locationName: "actionsSet",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          Code: {
                            locationName: "code"
                          },
                          Description: {
                            locationName: "description"
                          },
                          EventId: {
                            locationName: "eventId"
                          },
                          EventType: {
                            locationName: "eventType"
                          }
                        }
                      }
                    },
                    AvailabilityZone: {
                      locationName: "availabilityZone"
                    },
                    OutpostArn: {
                      locationName: "outpostArn"
                    },
                    Events: {
                      locationName: "eventsSet",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          Description: {
                            locationName: "description"
                          },
                          EventId: {
                            locationName: "eventId"
                          },
                          EventType: {
                            locationName: "eventType"
                          },
                          NotAfter: {
                            locationName: "notAfter",
                            type: "timestamp"
                          },
                          NotBefore: {
                            locationName: "notBefore",
                            type: "timestamp"
                          },
                          InstanceId: {
                            locationName: "instanceId"
                          }
                        }
                      }
                    },
                    VolumeId: {
                      locationName: "volumeId"
                    },
                    VolumeStatus: {
                      locationName: "volumeStatus",
                      type: "structure",
                      members: {
                        Details: {
                          locationName: "details",
                          type: "list",
                          member: {
                            locationName: "item",
                            type: "structure",
                            members: {
                              Name: {
                                locationName: "name"
                              },
                              Status: {
                                locationName: "status"
                              }
                            }
                          }
                        },
                        Status: {
                          locationName: "status"
                        }
                      }
                    },
                    AttachmentStatuses: {
                      locationName: "attachmentStatuses",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          IoPerformance: {
                            locationName: "ioPerformance"
                          },
                          InstanceId: {
                            locationName: "instanceId"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeVolumes: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              VolumeIds: {
                shape: "Snn",
                locationName: "VolumeId"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Volumes: {
                locationName: "volumeSet",
                type: "list",
                member: {
                  shape: "Srq",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeVolumesModifications: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              VolumeIds: {
                shape: "Snn",
                locationName: "VolumeId"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VolumesModifications: {
                locationName: "volumeModificationSet",
                type: "list",
                member: {
                  shape: "S1sh",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeVpcAttribute: {
          input: {
            type: "structure",
            required: [
              "Attribute",
              "VpcId"
            ],
            members: {
              Attribute: {},
              VpcId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpcId: {
                locationName: "vpcId"
              },
              EnableDnsHostnames: {
                shape: "S19c",
                locationName: "enableDnsHostnames"
              },
              EnableDnsSupport: {
                shape: "S19c",
                locationName: "enableDnsSupport"
              },
              EnableNetworkAddressUsageMetrics: {
                shape: "S19c",
                locationName: "enableNetworkAddressUsageMetrics"
              }
            }
          }
        },
        DescribeVpcClassicLink: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              VpcIds: {
                shape: "S1sn",
                locationName: "VpcId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Vpcs: {
                locationName: "vpcSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ClassicLinkEnabled: {
                      locationName: "classicLinkEnabled",
                      type: "boolean"
                    },
                    Tags: {
                      shape: "S6",
                      locationName: "tagSet"
                    },
                    VpcId: {
                      locationName: "vpcId"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeVpcClassicLinkDnsSupport: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              },
              VpcIds: {
                shape: "S1sn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Vpcs: {
                locationName: "vpcs",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ClassicLinkDnsSupported: {
                      locationName: "classicLinkDnsSupported",
                      type: "boolean"
                    },
                    VpcId: {
                      locationName: "vpcId"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeVpcEndpointConnectionNotifications: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              ConnectionNotificationId: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionNotificationSet: {
                locationName: "connectionNotificationSet",
                type: "list",
                member: {
                  shape: "Ssg",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeVpcEndpointConnections: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VpcEndpointConnections: {
                locationName: "vpcEndpointConnectionSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ServiceId: {
                      locationName: "serviceId"
                    },
                    VpcEndpointId: {
                      locationName: "vpcEndpointId"
                    },
                    VpcEndpointOwner: {
                      locationName: "vpcEndpointOwner"
                    },
                    VpcEndpointState: {
                      locationName: "vpcEndpointState"
                    },
                    CreationTimestamp: {
                      locationName: "creationTimestamp",
                      type: "timestamp"
                    },
                    DnsEntries: {
                      shape: "Ssb",
                      locationName: "dnsEntrySet"
                    },
                    NetworkLoadBalancerArns: {
                      shape: "So",
                      locationName: "networkLoadBalancerArnSet"
                    },
                    GatewayLoadBalancerArns: {
                      shape: "So",
                      locationName: "gatewayLoadBalancerArnSet"
                    },
                    IpAddressType: {
                      locationName: "ipAddressType"
                    },
                    VpcEndpointConnectionId: {
                      locationName: "vpcEndpointConnectionId"
                    },
                    Tags: {
                      shape: "S6",
                      locationName: "tagSet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeVpcEndpointServiceConfigurations: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              ServiceIds: {
                shape: "Syy",
                locationName: "ServiceId"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceConfigurations: {
                locationName: "serviceConfigurationSet",
                type: "list",
                member: {
                  shape: "Ssl",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeVpcEndpointServicePermissions: {
          input: {
            type: "structure",
            required: [
              "ServiceId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ServiceId: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AllowedPrincipals: {
                locationName: "allowedPrincipals",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    PrincipalType: {
                      locationName: "principalType"
                    },
                    Principal: {
                      locationName: "principal"
                    },
                    ServicePermissionId: {
                      locationName: "servicePermissionId"
                    },
                    Tags: {
                      shape: "S6",
                      locationName: "tagSet"
                    },
                    ServiceId: {
                      locationName: "serviceId"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeVpcEndpointServices: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              ServiceNames: {
                shape: "So",
                locationName: "ServiceName"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceNames: {
                shape: "So",
                locationName: "serviceNameSet"
              },
              ServiceDetails: {
                locationName: "serviceDetailSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ServiceName: {
                      locationName: "serviceName"
                    },
                    ServiceId: {
                      locationName: "serviceId"
                    },
                    ServiceType: {
                      shape: "Ssm",
                      locationName: "serviceType"
                    },
                    AvailabilityZones: {
                      shape: "So",
                      locationName: "availabilityZoneSet"
                    },
                    Owner: {
                      locationName: "owner"
                    },
                    BaseEndpointDnsNames: {
                      shape: "So",
                      locationName: "baseEndpointDnsNameSet"
                    },
                    PrivateDnsName: {
                      locationName: "privateDnsName"
                    },
                    PrivateDnsNames: {
                      locationName: "privateDnsNameSet",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          PrivateDnsName: {
                            locationName: "privateDnsName"
                          }
                        }
                      }
                    },
                    VpcEndpointPolicySupported: {
                      locationName: "vpcEndpointPolicySupported",
                      type: "boolean"
                    },
                    AcceptanceRequired: {
                      locationName: "acceptanceRequired",
                      type: "boolean"
                    },
                    ManagesVpcEndpoints: {
                      locationName: "managesVpcEndpoints",
                      type: "boolean"
                    },
                    PayerResponsibility: {
                      locationName: "payerResponsibility"
                    },
                    Tags: {
                      shape: "S6",
                      locationName: "tagSet"
                    },
                    PrivateDnsNameVerificationState: {
                      locationName: "privateDnsNameVerificationState"
                    },
                    SupportedIpAddressTypes: {
                      shape: "Ssq",
                      locationName: "supportedIpAddressTypeSet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeVpcEndpoints: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              VpcEndpointIds: {
                shape: "S1e",
                locationName: "VpcEndpointId"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VpcEndpoints: {
                locationName: "vpcEndpointSet",
                type: "list",
                member: {
                  shape: "Ss6",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeVpcPeeringConnections: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              VpcPeeringConnectionIds: {
                locationName: "VpcPeeringConnectionId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpcPeeringConnections: {
                locationName: "vpcPeeringConnectionSet",
                type: "list",
                member: {
                  shape: "S1n",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeVpcs: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              VpcIds: {
                locationName: "VpcId",
                type: "list",
                member: {
                  locationName: "VpcId"
                }
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Vpcs: {
                locationName: "vpcSet",
                type: "list",
                member: {
                  shape: "Sbo",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeVpnConnections: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              VpnConnectionIds: {
                locationName: "VpnConnectionId",
                type: "list",
                member: {
                  locationName: "VpnConnectionId"
                }
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpnConnections: {
                locationName: "vpnConnectionSet",
                type: "list",
                member: {
                  shape: "Stm",
                  locationName: "item"
                }
              }
            }
          }
        },
        DescribeVpnGateways: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              VpnGatewayIds: {
                locationName: "VpnGatewayId",
                type: "list",
                member: {
                  locationName: "VpnGatewayId"
                }
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpnGateways: {
                locationName: "vpnGatewaySet",
                type: "list",
                member: {
                  shape: "Suj",
                  locationName: "item"
                }
              }
            }
          }
        },
        DetachClassicLinkVpc: {
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "VpcId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              InstanceId: {
                locationName: "instanceId"
              },
              VpcId: {
                locationName: "vpcId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        DetachInternetGateway: {
          input: {
            type: "structure",
            required: [
              "InternetGatewayId",
              "VpcId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              InternetGatewayId: {
                locationName: "internetGatewayId"
              },
              VpcId: {
                locationName: "vpcId"
              }
            }
          }
        },
        DetachNetworkInterface: {
          input: {
            type: "structure",
            required: [
              "AttachmentId"
            ],
            members: {
              AttachmentId: {
                locationName: "attachmentId"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              Force: {
                locationName: "force",
                type: "boolean"
              }
            }
          }
        },
        DetachVerifiedAccessTrustProvider: {
          input: {
            type: "structure",
            required: [
              "VerifiedAccessInstanceId",
              "VerifiedAccessTrustProviderId"
            ],
            members: {
              VerifiedAccessInstanceId: {},
              VerifiedAccessTrustProviderId: {},
              ClientToken: {
                idempotencyToken: true
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VerifiedAccessTrustProvider: {
                shape: "S67",
                locationName: "verifiedAccessTrustProvider"
              },
              VerifiedAccessInstance: {
                shape: "S6g",
                locationName: "verifiedAccessInstance"
              }
            }
          }
        },
        DetachVolume: {
          input: {
            type: "structure",
            required: [
              "VolumeId"
            ],
            members: {
              Device: {},
              Force: {
                type: "boolean"
              },
              InstanceId: {},
              VolumeId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S6l"
          }
        },
        DetachVpnGateway: {
          input: {
            type: "structure",
            required: [
              "VpcId",
              "VpnGatewayId"
            ],
            members: {
              VpcId: {},
              VpnGatewayId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        DisableAddressTransfer: {
          input: {
            type: "structure",
            required: [
              "AllocationId"
            ],
            members: {
              AllocationId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AddressTransfer: {
                shape: "Sa",
                locationName: "addressTransfer"
              }
            }
          }
        },
        DisableAwsNetworkPerformanceMetricSubscription: {
          input: {
            type: "structure",
            members: {
              Source: {},
              Destination: {},
              Metric: {},
              Statistic: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Output: {
                locationName: "output",
                type: "boolean"
              }
            }
          }
        },
        DisableEbsEncryptionByDefault: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EbsEncryptionByDefault: {
                locationName: "ebsEncryptionByDefault",
                type: "boolean"
              }
            }
          }
        },
        DisableFastLaunch: {
          input: {
            type: "structure",
            required: [
              "ImageId"
            ],
            members: {
              ImageId: {},
              Force: {
                type: "boolean"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ImageId: {
                locationName: "imageId"
              },
              ResourceType: {
                locationName: "resourceType"
              },
              SnapshotConfiguration: {
                shape: "S159",
                locationName: "snapshotConfiguration"
              },
              LaunchTemplate: {
                shape: "S15a",
                locationName: "launchTemplate"
              },
              MaxParallelLaunches: {
                locationName: "maxParallelLaunches",
                type: "integer"
              },
              OwnerId: {
                locationName: "ownerId"
              },
              State: {
                locationName: "state"
              },
              StateTransitionReason: {
                locationName: "stateTransitionReason"
              },
              StateTransitionTime: {
                locationName: "stateTransitionTime",
                type: "timestamp"
              }
            }
          }
        },
        DisableFastSnapshotRestores: {
          input: {
            type: "structure",
            required: [
              "AvailabilityZones",
              "SourceSnapshotIds"
            ],
            members: {
              AvailabilityZones: {
                shape: "S1un",
                locationName: "AvailabilityZone"
              },
              SourceSnapshotIds: {
                shape: "S1h3",
                locationName: "SourceSnapshotId"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Successful: {
                locationName: "successful",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    SnapshotId: {
                      locationName: "snapshotId"
                    },
                    AvailabilityZone: {
                      locationName: "availabilityZone"
                    },
                    State: {
                      locationName: "state"
                    },
                    StateTransitionReason: {
                      locationName: "stateTransitionReason"
                    },
                    OwnerId: {
                      locationName: "ownerId"
                    },
                    OwnerAlias: {
                      locationName: "ownerAlias"
                    },
                    EnablingTime: {
                      locationName: "enablingTime",
                      type: "timestamp"
                    },
                    OptimizingTime: {
                      locationName: "optimizingTime",
                      type: "timestamp"
                    },
                    EnabledTime: {
                      locationName: "enabledTime",
                      type: "timestamp"
                    },
                    DisablingTime: {
                      locationName: "disablingTime",
                      type: "timestamp"
                    },
                    DisabledTime: {
                      locationName: "disabledTime",
                      type: "timestamp"
                    }
                  }
                }
              },
              Unsuccessful: {
                locationName: "unsuccessful",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    SnapshotId: {
                      locationName: "snapshotId"
                    },
                    FastSnapshotRestoreStateErrors: {
                      locationName: "fastSnapshotRestoreStateErrorSet",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          AvailabilityZone: {
                            locationName: "availabilityZone"
                          },
                          Error: {
                            locationName: "error",
                            type: "structure",
                            members: {
                              Code: {
                                locationName: "code"
                              },
                              Message: {
                                locationName: "message"
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DisableImage: {
          input: {
            type: "structure",
            required: [
              "ImageId"
            ],
            members: {
              ImageId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        DisableImageBlockPublicAccess: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ImageBlockPublicAccessState: {
                locationName: "imageBlockPublicAccessState"
              }
            }
          }
        },
        DisableImageDeprecation: {
          input: {
            type: "structure",
            required: [
              "ImageId"
            ],
            members: {
              ImageId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        DisableIpamOrganizationAdminAccount: {
          input: {
            type: "structure",
            required: [
              "DelegatedAdminAccountId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              DelegatedAdminAccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Success: {
                locationName: "success",
                type: "boolean"
              }
            }
          }
        },
        DisableSerialConsoleAccess: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SerialConsoleAccessEnabled: {
                locationName: "serialConsoleAccessEnabled",
                type: "boolean"
              }
            }
          }
        },
        DisableSnapshotBlockPublicAccess: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              State: {
                locationName: "state"
              }
            }
          }
        },
        DisableTransitGatewayRouteTablePropagation: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayRouteTableId"
            ],
            members: {
              TransitGatewayRouteTableId: {},
              TransitGatewayAttachmentId: {},
              DryRun: {
                type: "boolean"
              },
              TransitGatewayRouteTableAnnouncementId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Propagation: {
                shape: "S1vc",
                locationName: "propagation"
              }
            }
          }
        },
        DisableVgwRoutePropagation: {
          input: {
            type: "structure",
            required: [
              "GatewayId",
              "RouteTableId"
            ],
            members: {
              GatewayId: {},
              RouteTableId: {},
              DryRun: {
                type: "boolean"
              }
            }
          }
        },
        DisableVpcClassicLink: {
          input: {
            type: "structure",
            required: [
              "VpcId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              VpcId: {
                locationName: "vpcId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        DisableVpcClassicLinkDnsSupport: {
          input: {
            type: "structure",
            members: {
              VpcId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        DisassociateAddress: {
          input: {
            type: "structure",
            members: {
              AssociationId: {},
              PublicIp: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        DisassociateClientVpnTargetNetwork: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId",
              "AssociationId"
            ],
            members: {
              ClientVpnEndpointId: {},
              AssociationId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssociationId: {
                locationName: "associationId"
              },
              Status: {
                shape: "S3m",
                locationName: "status"
              }
            }
          }
        },
        DisassociateEnclaveCertificateIamRole: {
          input: {
            type: "structure",
            required: [
              "CertificateArn",
              "RoleArn"
            ],
            members: {
              CertificateArn: {},
              RoleArn: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        DisassociateIamInstanceProfile: {
          input: {
            type: "structure",
            required: [
              "AssociationId"
            ],
            members: {
              AssociationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IamInstanceProfileAssociation: {
                shape: "S3x",
                locationName: "iamInstanceProfileAssociation"
              }
            }
          }
        },
        DisassociateInstanceEventWindow: {
          input: {
            type: "structure",
            required: [
              "InstanceEventWindowId",
              "AssociationTarget"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              InstanceEventWindowId: {},
              AssociationTarget: {
                type: "structure",
                members: {
                  InstanceIds: {
                    shape: "S43",
                    locationName: "InstanceId"
                  },
                  InstanceTags: {
                    shape: "S6",
                    locationName: "InstanceTag"
                  },
                  DedicatedHostIds: {
                    shape: "S44",
                    locationName: "DedicatedHostId"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceEventWindow: {
                shape: "S47",
                locationName: "instanceEventWindow"
              }
            }
          }
        },
        DisassociateIpamByoasn: {
          input: {
            type: "structure",
            required: [
              "Asn",
              "Cidr"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              Asn: {},
              Cidr: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AsnAssociation: {
                shape: "S20",
                locationName: "asnAssociation"
              }
            }
          }
        },
        DisassociateIpamResourceDiscovery: {
          input: {
            type: "structure",
            required: [
              "IpamResourceDiscoveryAssociationId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              IpamResourceDiscoveryAssociationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IpamResourceDiscoveryAssociation: {
                shape: "S4l",
                locationName: "ipamResourceDiscoveryAssociation"
              }
            }
          }
        },
        DisassociateNatGatewayAddress: {
          input: {
            type: "structure",
            required: [
              "NatGatewayId",
              "AssociationIds"
            ],
            members: {
              NatGatewayId: {},
              AssociationIds: {
                locationName: "AssociationId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              MaxDrainDurationSeconds: {
                type: "integer"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NatGatewayId: {
                locationName: "natGatewayId"
              },
              NatGatewayAddresses: {
                shape: "S3b",
                locationName: "natGatewayAddressSet"
              }
            }
          }
        },
        DisassociateRouteTable: {
          input: {
            type: "structure",
            required: [
              "AssociationId"
            ],
            members: {
              AssociationId: {
                locationName: "associationId"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        DisassociateSubnetCidrBlock: {
          input: {
            type: "structure",
            required: [
              "AssociationId"
            ],
            members: {
              AssociationId: {
                locationName: "associationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Ipv6CidrBlockAssociation: {
                shape: "S52",
                locationName: "ipv6CidrBlockAssociation"
              },
              SubnetId: {
                locationName: "subnetId"
              }
            }
          }
        },
        DisassociateTransitGatewayMulticastDomain: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayMulticastDomainId",
              "TransitGatewayAttachmentId",
              "SubnetIds"
            ],
            members: {
              TransitGatewayMulticastDomainId: {},
              TransitGatewayAttachmentId: {},
              SubnetIds: {
                shape: "S57"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Associations: {
                shape: "Sq",
                locationName: "associations"
              }
            }
          }
        },
        DisassociateTransitGatewayPolicyTable: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayPolicyTableId",
              "TransitGatewayAttachmentId"
            ],
            members: {
              TransitGatewayPolicyTableId: {},
              TransitGatewayAttachmentId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Association: {
                shape: "S5c",
                locationName: "association"
              }
            }
          }
        },
        DisassociateTransitGatewayRouteTable: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayRouteTableId",
              "TransitGatewayAttachmentId"
            ],
            members: {
              TransitGatewayRouteTableId: {},
              TransitGatewayAttachmentId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Association: {
                shape: "S5h",
                locationName: "association"
              }
            }
          }
        },
        DisassociateTrunkInterface: {
          input: {
            type: "structure",
            required: [
              "AssociationId"
            ],
            members: {
              AssociationId: {},
              ClientToken: {
                idempotencyToken: true
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              },
              ClientToken: {
                locationName: "clientToken"
              }
            }
          }
        },
        DisassociateVpcCidrBlock: {
          input: {
            type: "structure",
            required: [
              "AssociationId"
            ],
            members: {
              AssociationId: {
                locationName: "associationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Ipv6CidrBlockAssociation: {
                shape: "S5q",
                locationName: "ipv6CidrBlockAssociation"
              },
              CidrBlockAssociation: {
                shape: "S5t",
                locationName: "cidrBlockAssociation"
              },
              VpcId: {
                locationName: "vpcId"
              }
            }
          }
        },
        EnableAddressTransfer: {
          input: {
            type: "structure",
            required: [
              "AllocationId",
              "TransferAccountId"
            ],
            members: {
              AllocationId: {},
              TransferAccountId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AddressTransfer: {
                shape: "Sa",
                locationName: "addressTransfer"
              }
            }
          }
        },
        EnableAwsNetworkPerformanceMetricSubscription: {
          input: {
            type: "structure",
            members: {
              Source: {},
              Destination: {},
              Metric: {},
              Statistic: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Output: {
                locationName: "output",
                type: "boolean"
              }
            }
          }
        },
        EnableEbsEncryptionByDefault: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EbsEncryptionByDefault: {
                locationName: "ebsEncryptionByDefault",
                type: "boolean"
              }
            }
          }
        },
        EnableFastLaunch: {
          input: {
            type: "structure",
            required: [
              "ImageId"
            ],
            members: {
              ImageId: {},
              ResourceType: {},
              SnapshotConfiguration: {
                type: "structure",
                members: {
                  TargetResourceCount: {
                    type: "integer"
                  }
                }
              },
              LaunchTemplate: {
                type: "structure",
                required: [
                  "Version"
                ],
                members: {
                  LaunchTemplateId: {},
                  LaunchTemplateName: {},
                  Version: {}
                }
              },
              MaxParallelLaunches: {
                type: "integer"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ImageId: {
                locationName: "imageId"
              },
              ResourceType: {
                locationName: "resourceType"
              },
              SnapshotConfiguration: {
                shape: "S159",
                locationName: "snapshotConfiguration"
              },
              LaunchTemplate: {
                shape: "S15a",
                locationName: "launchTemplate"
              },
              MaxParallelLaunches: {
                locationName: "maxParallelLaunches",
                type: "integer"
              },
              OwnerId: {
                locationName: "ownerId"
              },
              State: {
                locationName: "state"
              },
              StateTransitionReason: {
                locationName: "stateTransitionReason"
              },
              StateTransitionTime: {
                locationName: "stateTransitionTime",
                type: "timestamp"
              }
            }
          }
        },
        EnableFastSnapshotRestores: {
          input: {
            type: "structure",
            required: [
              "AvailabilityZones",
              "SourceSnapshotIds"
            ],
            members: {
              AvailabilityZones: {
                shape: "S1un",
                locationName: "AvailabilityZone"
              },
              SourceSnapshotIds: {
                shape: "S1h3",
                locationName: "SourceSnapshotId"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Successful: {
                locationName: "successful",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    SnapshotId: {
                      locationName: "snapshotId"
                    },
                    AvailabilityZone: {
                      locationName: "availabilityZone"
                    },
                    State: {
                      locationName: "state"
                    },
                    StateTransitionReason: {
                      locationName: "stateTransitionReason"
                    },
                    OwnerId: {
                      locationName: "ownerId"
                    },
                    OwnerAlias: {
                      locationName: "ownerAlias"
                    },
                    EnablingTime: {
                      locationName: "enablingTime",
                      type: "timestamp"
                    },
                    OptimizingTime: {
                      locationName: "optimizingTime",
                      type: "timestamp"
                    },
                    EnabledTime: {
                      locationName: "enabledTime",
                      type: "timestamp"
                    },
                    DisablingTime: {
                      locationName: "disablingTime",
                      type: "timestamp"
                    },
                    DisabledTime: {
                      locationName: "disabledTime",
                      type: "timestamp"
                    }
                  }
                }
              },
              Unsuccessful: {
                locationName: "unsuccessful",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    SnapshotId: {
                      locationName: "snapshotId"
                    },
                    FastSnapshotRestoreStateErrors: {
                      locationName: "fastSnapshotRestoreStateErrorSet",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          AvailabilityZone: {
                            locationName: "availabilityZone"
                          },
                          Error: {
                            locationName: "error",
                            type: "structure",
                            members: {
                              Code: {
                                locationName: "code"
                              },
                              Message: {
                                locationName: "message"
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        EnableImage: {
          input: {
            type: "structure",
            required: [
              "ImageId"
            ],
            members: {
              ImageId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        EnableImageBlockPublicAccess: {
          input: {
            type: "structure",
            required: [
              "ImageBlockPublicAccessState"
            ],
            members: {
              ImageBlockPublicAccessState: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ImageBlockPublicAccessState: {
                locationName: "imageBlockPublicAccessState"
              }
            }
          }
        },
        EnableImageDeprecation: {
          input: {
            type: "structure",
            required: [
              "ImageId",
              "DeprecateAt"
            ],
            members: {
              ImageId: {},
              DeprecateAt: {
                type: "timestamp"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        EnableIpamOrganizationAdminAccount: {
          input: {
            type: "structure",
            required: [
              "DelegatedAdminAccountId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              DelegatedAdminAccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Success: {
                locationName: "success",
                type: "boolean"
              }
            }
          }
        },
        EnableReachabilityAnalyzerOrganizationSharing: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReturnValue: {
                locationName: "returnValue",
                type: "boolean"
              }
            }
          }
        },
        EnableSerialConsoleAccess: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SerialConsoleAccessEnabled: {
                locationName: "serialConsoleAccessEnabled",
                type: "boolean"
              }
            }
          }
        },
        EnableSnapshotBlockPublicAccess: {
          input: {
            type: "structure",
            required: [
              "State"
            ],
            members: {
              State: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              State: {
                locationName: "state"
              }
            }
          }
        },
        EnableTransitGatewayRouteTablePropagation: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayRouteTableId"
            ],
            members: {
              TransitGatewayRouteTableId: {},
              TransitGatewayAttachmentId: {},
              DryRun: {
                type: "boolean"
              },
              TransitGatewayRouteTableAnnouncementId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Propagation: {
                shape: "S1vc",
                locationName: "propagation"
              }
            }
          }
        },
        EnableVgwRoutePropagation: {
          input: {
            type: "structure",
            required: [
              "GatewayId",
              "RouteTableId"
            ],
            members: {
              GatewayId: {},
              RouteTableId: {},
              DryRun: {
                type: "boolean"
              }
            }
          }
        },
        EnableVolumeIO: {
          input: {
            type: "structure",
            required: [
              "VolumeId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              VolumeId: {
                locationName: "volumeId"
              }
            }
          }
        },
        EnableVpcClassicLink: {
          input: {
            type: "structure",
            required: [
              "VpcId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              VpcId: {
                locationName: "vpcId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        EnableVpcClassicLinkDnsSupport: {
          input: {
            type: "structure",
            members: {
              VpcId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ExportClientVpnClientCertificateRevocationList: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId"
            ],
            members: {
              ClientVpnEndpointId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CertificateRevocationList: {
                locationName: "certificateRevocationList"
              },
              Status: {
                locationName: "status",
                type: "structure",
                members: {
                  Code: {
                    locationName: "code"
                  },
                  Message: {
                    locationName: "message"
                  }
                }
              }
            }
          }
        },
        ExportClientVpnClientConfiguration: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId"
            ],
            members: {
              ClientVpnEndpointId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ClientConfiguration: {
                locationName: "clientConfiguration"
              }
            }
          }
        },
        ExportImage: {
          input: {
            type: "structure",
            required: [
              "DiskImageFormat",
              "ImageId",
              "S3ExportLocation"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              Description: {},
              DiskImageFormat: {},
              DryRun: {
                type: "boolean"
              },
              ImageId: {},
              S3ExportLocation: {
                type: "structure",
                required: [
                  "S3Bucket"
                ],
                members: {
                  S3Bucket: {},
                  S3Prefix: {}
                }
              },
              RoleName: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Description: {
                locationName: "description"
              },
              DiskImageFormat: {
                locationName: "diskImageFormat"
              },
              ExportImageTaskId: {
                locationName: "exportImageTaskId"
              },
              ImageId: {
                locationName: "imageId"
              },
              RoleName: {
                locationName: "roleName"
              },
              Progress: {
                locationName: "progress"
              },
              S3ExportLocation: {
                shape: "S14w",
                locationName: "s3ExportLocation"
              },
              Status: {
                locationName: "status"
              },
              StatusMessage: {
                locationName: "statusMessage"
              },
              Tags: {
                shape: "S6",
                locationName: "tagSet"
              }
            }
          }
        },
        ExportTransitGatewayRoutes: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayRouteTableId",
              "S3Bucket"
            ],
            members: {
              TransitGatewayRouteTableId: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              S3Bucket: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              S3Location: {
                locationName: "s3Location"
              }
            }
          }
        },
        GetAssociatedEnclaveCertificateIamRoles: {
          input: {
            type: "structure",
            required: [
              "CertificateArn"
            ],
            members: {
              CertificateArn: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssociatedRoles: {
                locationName: "associatedRoleSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    AssociatedRoleArn: {
                      locationName: "associatedRoleArn"
                    },
                    CertificateS3BucketName: {
                      locationName: "certificateS3BucketName"
                    },
                    CertificateS3ObjectKey: {
                      locationName: "certificateS3ObjectKey"
                    },
                    EncryptionKmsKeyId: {
                      locationName: "encryptionKmsKeyId"
                    }
                  }
                }
              }
            }
          }
        },
        GetAssociatedIpv6PoolCidrs: {
          input: {
            type: "structure",
            required: [
              "PoolId"
            ],
            members: {
              PoolId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Ipv6CidrAssociations: {
                locationName: "ipv6CidrAssociationSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Ipv6Cidr: {
                      locationName: "ipv6Cidr"
                    },
                    AssociatedResource: {
                      locationName: "associatedResource"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetAwsNetworkPerformanceData: {
          input: {
            type: "structure",
            members: {
              DataQueries: {
                locationName: "DataQuery",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Source: {},
                    Destination: {},
                    Metric: {},
                    Statistic: {},
                    Period: {}
                  }
                }
              },
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataResponses: {
                locationName: "dataResponseSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Id: {
                      locationName: "id"
                    },
                    Source: {
                      locationName: "source"
                    },
                    Destination: {
                      locationName: "destination"
                    },
                    Metric: {
                      locationName: "metric"
                    },
                    Statistic: {
                      locationName: "statistic"
                    },
                    Period: {
                      locationName: "period"
                    },
                    MetricPoints: {
                      locationName: "metricPointSet",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          StartDate: {
                            locationName: "startDate",
                            type: "timestamp"
                          },
                          EndDate: {
                            locationName: "endDate",
                            type: "timestamp"
                          },
                          Value: {
                            locationName: "value",
                            type: "float"
                          },
                          Status: {
                            locationName: "status"
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetCapacityReservationUsage: {
          input: {
            type: "structure",
            required: [
              "CapacityReservationId"
            ],
            members: {
              CapacityReservationId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              CapacityReservationId: {
                locationName: "capacityReservationId"
              },
              InstanceType: {
                locationName: "instanceType"
              },
              TotalInstanceCount: {
                locationName: "totalInstanceCount",
                type: "integer"
              },
              AvailableInstanceCount: {
                locationName: "availableInstanceCount",
                type: "integer"
              },
              State: {
                locationName: "state"
              },
              InstanceUsages: {
                locationName: "instanceUsageSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    AccountId: {
                      locationName: "accountId"
                    },
                    UsedInstanceCount: {
                      locationName: "usedInstanceCount",
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        GetCoipPoolUsage: {
          input: {
            type: "structure",
            required: [
              "PoolId"
            ],
            members: {
              PoolId: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CoipPoolId: {
                locationName: "coipPoolId"
              },
              CoipAddressUsages: {
                locationName: "coipAddressUsageSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    AllocationId: {
                      locationName: "allocationId"
                    },
                    AwsAccountId: {
                      locationName: "awsAccountId"
                    },
                    AwsService: {
                      locationName: "awsService"
                    },
                    CoIp: {
                      locationName: "coIp"
                    }
                  }
                }
              },
              LocalGatewayRouteTableId: {
                locationName: "localGatewayRouteTableId"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetConsoleOutput: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              Latest: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceId: {
                locationName: "instanceId"
              },
              Output: {
                locationName: "output"
              },
              Timestamp: {
                locationName: "timestamp",
                type: "timestamp"
              }
            }
          }
        },
        GetConsoleScreenshot: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              InstanceId: {},
              WakeUp: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ImageData: {
                locationName: "imageData"
              },
              InstanceId: {
                locationName: "instanceId"
              }
            }
          }
        },
        GetDefaultCreditSpecification: {
          input: {
            type: "structure",
            required: [
              "InstanceFamily"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              InstanceFamily: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceFamilyCreditSpecification: {
                shape: "S1yu",
                locationName: "instanceFamilyCreditSpecification"
              }
            }
          }
        },
        GetEbsDefaultKmsKeyId: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KmsKeyId: {
                locationName: "kmsKeyId"
              }
            }
          }
        },
        GetEbsEncryptionByDefault: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EbsEncryptionByDefault: {
                locationName: "ebsEncryptionByDefault",
                type: "boolean"
              },
              SseType: {
                locationName: "sseType"
              }
            }
          }
        },
        GetFlowLogsIntegrationTemplate: {
          input: {
            type: "structure",
            required: [
              "FlowLogId",
              "ConfigDeliveryS3DestinationArn",
              "IntegrateServices"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              FlowLogId: {},
              ConfigDeliveryS3DestinationArn: {},
              IntegrateServices: {
                locationName: "IntegrateService",
                type: "structure",
                members: {
                  AthenaIntegrations: {
                    locationName: "AthenaIntegration",
                    type: "list",
                    member: {
                      locationName: "item",
                      type: "structure",
                      required: [
                        "IntegrationResultS3DestinationArn",
                        "PartitionLoadFrequency"
                      ],
                      members: {
                        IntegrationResultS3DestinationArn: {},
                        PartitionLoadFrequency: {},
                        PartitionStartDate: {
                          type: "timestamp"
                        },
                        PartitionEndDate: {
                          type: "timestamp"
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Result: {
                locationName: "result"
              }
            }
          }
        },
        GetGroupsForCapacityReservation: {
          input: {
            type: "structure",
            required: [
              "CapacityReservationId"
            ],
            members: {
              CapacityReservationId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              CapacityReservationGroups: {
                locationName: "capacityReservationGroupSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    GroupArn: {
                      locationName: "groupArn"
                    },
                    OwnerId: {
                      locationName: "ownerId"
                    }
                  }
                }
              }
            }
          }
        },
        GetHostReservationPurchasePreview: {
          input: {
            type: "structure",
            required: [
              "HostIdSet",
              "OfferingId"
            ],
            members: {
              HostIdSet: {
                shape: "S1zb"
              },
              OfferingId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CurrencyCode: {
                locationName: "currencyCode"
              },
              Purchase: {
                shape: "S1zd",
                locationName: "purchase"
              },
              TotalHourlyPrice: {
                locationName: "totalHourlyPrice"
              },
              TotalUpfrontPrice: {
                locationName: "totalUpfrontPrice"
              }
            }
          }
        },
        GetImageBlockPublicAccessState: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ImageBlockPublicAccessState: {
                locationName: "imageBlockPublicAccessState"
              }
            }
          }
        },
        GetInstanceTypesFromInstanceRequirements: {
          input: {
            type: "structure",
            required: [
              "ArchitectureTypes",
              "VirtualizationTypes",
              "InstanceRequirements"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ArchitectureTypes: {
                shape: "S1zi",
                locationName: "ArchitectureType"
              },
              VirtualizationTypes: {
                shape: "S1zj",
                locationName: "VirtualizationType"
              },
              InstanceRequirements: {
                shape: "Scu"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceTypes: {
                locationName: "instanceTypeSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    InstanceType: {
                      locationName: "instanceType"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetInstanceUefiData: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceId: {
                locationName: "instanceId"
              },
              UefiData: {
                locationName: "uefiData"
              }
            }
          }
        },
        GetIpamAddressHistory: {
          input: {
            type: "structure",
            required: [
              "Cidr",
              "IpamScopeId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              Cidr: {},
              IpamScopeId: {},
              VpcId: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              HistoryRecords: {
                locationName: "historyRecordSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ResourceOwnerId: {
                      locationName: "resourceOwnerId"
                    },
                    ResourceRegion: {
                      locationName: "resourceRegion"
                    },
                    ResourceType: {
                      locationName: "resourceType"
                    },
                    ResourceId: {
                      locationName: "resourceId"
                    },
                    ResourceCidr: {
                      locationName: "resourceCidr"
                    },
                    ResourceName: {
                      locationName: "resourceName"
                    },
                    ResourceComplianceStatus: {
                      locationName: "resourceComplianceStatus"
                    },
                    ResourceOverlapStatus: {
                      locationName: "resourceOverlapStatus"
                    },
                    VpcId: {
                      locationName: "vpcId"
                    },
                    SampledStartTime: {
                      locationName: "sampledStartTime",
                      type: "timestamp"
                    },
                    SampledEndTime: {
                      locationName: "sampledEndTime",
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetIpamDiscoveredAccounts: {
          input: {
            type: "structure",
            required: [
              "IpamResourceDiscoveryId",
              "DiscoveryRegion"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              IpamResourceDiscoveryId: {},
              DiscoveryRegion: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IpamDiscoveredAccounts: {
                locationName: "ipamDiscoveredAccountSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    AccountId: {
                      locationName: "accountId"
                    },
                    DiscoveryRegion: {
                      locationName: "discoveryRegion"
                    },
                    FailureReason: {
                      locationName: "failureReason",
                      type: "structure",
                      members: {
                        Code: {
                          locationName: "code"
                        },
                        Message: {
                          locationName: "message"
                        }
                      }
                    },
                    LastAttemptedDiscoveryTime: {
                      locationName: "lastAttemptedDiscoveryTime",
                      type: "timestamp"
                    },
                    LastSuccessfulDiscoveryTime: {
                      locationName: "lastSuccessfulDiscoveryTime",
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetIpamDiscoveredPublicAddresses: {
          input: {
            type: "structure",
            required: [
              "IpamResourceDiscoveryId",
              "AddressRegion"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              IpamResourceDiscoveryId: {},
              AddressRegion: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IpamDiscoveredPublicAddresses: {
                locationName: "ipamDiscoveredPublicAddressSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    IpamResourceDiscoveryId: {
                      locationName: "ipamResourceDiscoveryId"
                    },
                    AddressRegion: {
                      locationName: "addressRegion"
                    },
                    Address: {
                      locationName: "address"
                    },
                    AddressOwnerId: {
                      locationName: "addressOwnerId"
                    },
                    AddressAllocationId: {
                      locationName: "addressAllocationId"
                    },
                    AssociationStatus: {
                      locationName: "associationStatus"
                    },
                    AddressType: {
                      locationName: "addressType"
                    },
                    Service: {
                      locationName: "service"
                    },
                    ServiceResource: {
                      locationName: "serviceResource"
                    },
                    VpcId: {
                      locationName: "vpcId"
                    },
                    SubnetId: {
                      locationName: "subnetId"
                    },
                    PublicIpv4PoolId: {
                      locationName: "publicIpv4PoolId"
                    },
                    NetworkInterfaceId: {
                      locationName: "networkInterfaceId"
                    },
                    NetworkInterfaceDescription: {
                      locationName: "networkInterfaceDescription"
                    },
                    InstanceId: {
                      locationName: "instanceId"
                    },
                    Tags: {
                      locationName: "tags",
                      type: "structure",
                      members: {
                        EipTags: {
                          locationName: "eipTagSet",
                          type: "list",
                          member: {
                            locationName: "item",
                            type: "structure",
                            members: {
                              Key: {
                                locationName: "key"
                              },
                              Value: {
                                locationName: "value"
                              }
                            }
                          }
                        }
                      }
                    },
                    NetworkBorderGroup: {
                      locationName: "networkBorderGroup"
                    },
                    SecurityGroups: {
                      locationName: "securityGroupSet",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          GroupName: {
                            locationName: "groupName"
                          },
                          GroupId: {
                            locationName: "groupId"
                          }
                        }
                      }
                    },
                    SampleTime: {
                      locationName: "sampleTime",
                      type: "timestamp"
                    }
                  }
                }
              },
              OldestSampleTime: {
                locationName: "oldestSampleTime",
                type: "timestamp"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetIpamDiscoveredResourceCidrs: {
          input: {
            type: "structure",
            required: [
              "IpamResourceDiscoveryId",
              "ResourceRegion"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              IpamResourceDiscoveryId: {},
              ResourceRegion: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IpamDiscoveredResourceCidrs: {
                locationName: "ipamDiscoveredResourceCidrSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    IpamResourceDiscoveryId: {
                      locationName: "ipamResourceDiscoveryId"
                    },
                    ResourceRegion: {
                      locationName: "resourceRegion"
                    },
                    ResourceId: {
                      locationName: "resourceId"
                    },
                    ResourceOwnerId: {
                      locationName: "resourceOwnerId"
                    },
                    ResourceCidr: {
                      locationName: "resourceCidr"
                    },
                    ResourceType: {
                      locationName: "resourceType"
                    },
                    ResourceTags: {
                      shape: "Sg9",
                      locationName: "resourceTagSet"
                    },
                    IpUsage: {
                      locationName: "ipUsage",
                      type: "double"
                    },
                    VpcId: {
                      locationName: "vpcId"
                    },
                    SampleTime: {
                      locationName: "sampleTime",
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetIpamPoolAllocations: {
          input: {
            type: "structure",
            required: [
              "IpamPoolId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              IpamPoolId: {},
              IpamPoolAllocationId: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IpamPoolAllocations: {
                locationName: "ipamPoolAllocationSet",
                type: "list",
                member: {
                  shape: "S2l",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetIpamPoolCidrs: {
          input: {
            type: "structure",
            required: [
              "IpamPoolId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              IpamPoolId: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IpamPoolCidrs: {
                locationName: "ipamPoolCidrSet",
                type: "list",
                member: {
                  shape: "Szf",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetIpamResourceCidrs: {
          input: {
            type: "structure",
            required: [
              "IpamScopeId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              IpamScopeId: {},
              IpamPoolId: {},
              ResourceId: {},
              ResourceType: {},
              ResourceTag: {
                shape: "Sg0"
              },
              ResourceOwner: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              IpamResourceCidrs: {
                locationName: "ipamResourceCidrSet",
                type: "list",
                member: {
                  shape: "S20v",
                  locationName: "item"
                }
              }
            }
          }
        },
        GetLaunchTemplateData: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              InstanceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LaunchTemplateData: {
                shape: "Sij",
                locationName: "launchTemplateData"
              }
            }
          }
        },
        GetManagedPrefixListAssociations: {
          input: {
            type: "structure",
            required: [
              "PrefixListId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              PrefixListId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PrefixListAssociations: {
                locationName: "prefixListAssociationSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ResourceId: {
                      locationName: "resourceId"
                    },
                    ResourceOwner: {
                      locationName: "resourceOwner"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetManagedPrefixListEntries: {
          input: {
            type: "structure",
            required: [
              "PrefixListId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              PrefixListId: {},
              TargetVersion: {
                type: "long"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Entries: {
                locationName: "entrySet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Cidr: {
                      locationName: "cidr"
                    },
                    Description: {
                      locationName: "description"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetNetworkInsightsAccessScopeAnalysisFindings: {
          input: {
            type: "structure",
            required: [
              "NetworkInsightsAccessScopeAnalysisId"
            ],
            members: {
              NetworkInsightsAccessScopeAnalysisId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkInsightsAccessScopeAnalysisId: {
                locationName: "networkInsightsAccessScopeAnalysisId"
              },
              AnalysisStatus: {
                locationName: "analysisStatus"
              },
              AnalysisFindings: {
                locationName: "analysisFindingSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    NetworkInsightsAccessScopeAnalysisId: {
                      locationName: "networkInsightsAccessScopeAnalysisId"
                    },
                    NetworkInsightsAccessScopeId: {
                      locationName: "networkInsightsAccessScopeId"
                    },
                    FindingId: {
                      locationName: "findingId"
                    },
                    FindingComponents: {
                      shape: "S1ic",
                      locationName: "findingComponentSet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetNetworkInsightsAccessScopeContent: {
          input: {
            type: "structure",
            required: [
              "NetworkInsightsAccessScopeId"
            ],
            members: {
              NetworkInsightsAccessScopeId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkInsightsAccessScopeContent: {
                shape: "Sl6",
                locationName: "networkInsightsAccessScopeContent"
              }
            }
          }
        },
        GetPasswordData: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceId: {
                locationName: "instanceId"
              },
              PasswordData: {
                locationName: "passwordData",
                type: "string",
                sensitive: true
              },
              Timestamp: {
                locationName: "timestamp",
                type: "timestamp"
              }
            }
          }
        },
        GetReservedInstancesExchangeQuote: {
          input: {
            type: "structure",
            required: [
              "ReservedInstanceIds"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ReservedInstanceIds: {
                shape: "Se",
                locationName: "ReservedInstanceId"
              },
              TargetConfigurations: {
                shape: "Sg",
                locationName: "TargetConfiguration"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CurrencyCode: {
                locationName: "currencyCode"
              },
              IsValidExchange: {
                locationName: "isValidExchange",
                type: "boolean"
              },
              OutputReservedInstancesWillExpireAt: {
                locationName: "outputReservedInstancesWillExpireAt",
                type: "timestamp"
              },
              PaymentDue: {
                locationName: "paymentDue"
              },
              ReservedInstanceValueRollup: {
                shape: "S21j",
                locationName: "reservedInstanceValueRollup"
              },
              ReservedInstanceValueSet: {
                locationName: "reservedInstanceValueSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ReservationValue: {
                      shape: "S21j",
                      locationName: "reservationValue"
                    },
                    ReservedInstanceId: {
                      locationName: "reservedInstanceId"
                    }
                  }
                }
              },
              TargetConfigurationValueRollup: {
                shape: "S21j",
                locationName: "targetConfigurationValueRollup"
              },
              TargetConfigurationValueSet: {
                locationName: "targetConfigurationValueSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ReservationValue: {
                      shape: "S21j",
                      locationName: "reservationValue"
                    },
                    TargetConfiguration: {
                      locationName: "targetConfiguration",
                      type: "structure",
                      members: {
                        InstanceCount: {
                          locationName: "instanceCount",
                          type: "integer"
                        },
                        OfferingId: {
                          locationName: "offeringId"
                        }
                      }
                    }
                  }
                }
              },
              ValidationFailureReason: {
                locationName: "validationFailureReason"
              }
            }
          }
        },
        GetSecurityGroupsForVpc: {
          input: {
            type: "structure",
            required: [
              "VpcId"
            ],
            members: {
              VpcId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              SecurityGroupForVpcs: {
                locationName: "securityGroupForVpcSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Description: {
                      locationName: "description"
                    },
                    GroupName: {
                      locationName: "groupName"
                    },
                    OwnerId: {
                      locationName: "ownerId"
                    },
                    GroupId: {
                      locationName: "groupId"
                    },
                    Tags: {
                      shape: "S6",
                      locationName: "tagSet"
                    },
                    PrimaryVpcId: {
                      locationName: "primaryVpcId"
                    }
                  }
                }
              }
            }
          }
        },
        GetSerialConsoleAccessStatus: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SerialConsoleAccessEnabled: {
                locationName: "serialConsoleAccessEnabled",
                type: "boolean"
              }
            }
          }
        },
        GetSnapshotBlockPublicAccessState: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              State: {
                locationName: "state"
              }
            }
          }
        },
        GetSpotPlacementScores: {
          input: {
            type: "structure",
            required: [
              "TargetCapacity"
            ],
            members: {
              InstanceTypes: {
                locationName: "InstanceType",
                type: "list",
                member: {}
              },
              TargetCapacity: {
                type: "integer"
              },
              TargetCapacityUnitType: {},
              SingleAvailabilityZone: {
                type: "boolean"
              },
              RegionNames: {
                locationName: "RegionName",
                type: "list",
                member: {}
              },
              InstanceRequirementsWithMetadata: {
                type: "structure",
                members: {
                  ArchitectureTypes: {
                    shape: "S1zi",
                    locationName: "ArchitectureType"
                  },
                  VirtualizationTypes: {
                    shape: "S1zj",
                    locationName: "VirtualizationType"
                  },
                  InstanceRequirements: {
                    shape: "Scu"
                  }
                }
              },
              DryRun: {
                type: "boolean"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SpotPlacementScores: {
                locationName: "spotPlacementScoreSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Region: {
                      locationName: "region"
                    },
                    AvailabilityZoneId: {
                      locationName: "availabilityZoneId"
                    },
                    Score: {
                      locationName: "score",
                      type: "integer"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetSubnetCidrReservations: {
          input: {
            type: "structure",
            required: [
              "SubnetId"
            ],
            members: {
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              SubnetId: {},
              DryRun: {
                type: "boolean"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SubnetIpv4CidrReservations: {
                shape: "S22a",
                locationName: "subnetIpv4CidrReservationSet"
              },
              SubnetIpv6CidrReservations: {
                shape: "S22a",
                locationName: "subnetIpv6CidrReservationSet"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetTransitGatewayAttachmentPropagations: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayAttachmentId"
            ],
            members: {
              TransitGatewayAttachmentId: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayAttachmentPropagations: {
                locationName: "transitGatewayAttachmentPropagations",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    TransitGatewayRouteTableId: {
                      locationName: "transitGatewayRouteTableId"
                    },
                    State: {
                      locationName: "state"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetTransitGatewayMulticastDomainAssociations: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayMulticastDomainId"
            ],
            members: {
              TransitGatewayMulticastDomainId: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MulticastDomainAssociations: {
                locationName: "multicastDomainAssociations",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    TransitGatewayAttachmentId: {
                      locationName: "transitGatewayAttachmentId"
                    },
                    ResourceId: {
                      locationName: "resourceId"
                    },
                    ResourceType: {
                      locationName: "resourceType"
                    },
                    ResourceOwnerId: {
                      locationName: "resourceOwnerId"
                    },
                    Subnet: {
                      shape: "St",
                      locationName: "subnet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetTransitGatewayPolicyTableAssociations: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayPolicyTableId"
            ],
            members: {
              TransitGatewayPolicyTableId: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Associations: {
                locationName: "associations",
                type: "list",
                member: {
                  shape: "S5c",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetTransitGatewayPolicyTableEntries: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayPolicyTableId"
            ],
            members: {
              TransitGatewayPolicyTableId: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayPolicyTableEntries: {
                locationName: "transitGatewayPolicyTableEntries",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    PolicyRuleNumber: {
                      locationName: "policyRuleNumber"
                    },
                    PolicyRule: {
                      locationName: "policyRule",
                      type: "structure",
                      members: {
                        SourceCidrBlock: {
                          locationName: "sourceCidrBlock"
                        },
                        SourcePortRange: {
                          locationName: "sourcePortRange"
                        },
                        DestinationCidrBlock: {
                          locationName: "destinationCidrBlock"
                        },
                        DestinationPortRange: {
                          locationName: "destinationPortRange"
                        },
                        Protocol: {
                          locationName: "protocol"
                        },
                        MetaData: {
                          locationName: "metaData",
                          type: "structure",
                          members: {
                            MetaDataKey: {
                              locationName: "metaDataKey"
                            },
                            MetaDataValue: {
                              locationName: "metaDataValue"
                            }
                          }
                        }
                      }
                    },
                    TargetRouteTableId: {
                      locationName: "targetRouteTableId"
                    }
                  }
                }
              }
            }
          }
        },
        GetTransitGatewayPrefixListReferences: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayRouteTableId"
            ],
            members: {
              TransitGatewayRouteTableId: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayPrefixListReferences: {
                locationName: "transitGatewayPrefixListReferenceSet",
                type: "list",
                member: {
                  shape: "Sq9",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetTransitGatewayRouteTableAssociations: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayRouteTableId"
            ],
            members: {
              TransitGatewayRouteTableId: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Associations: {
                locationName: "associations",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    TransitGatewayAttachmentId: {
                      locationName: "transitGatewayAttachmentId"
                    },
                    ResourceId: {
                      locationName: "resourceId"
                    },
                    ResourceType: {
                      locationName: "resourceType"
                    },
                    State: {
                      locationName: "state"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetTransitGatewayRouteTablePropagations: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayRouteTableId"
            ],
            members: {
              TransitGatewayRouteTableId: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayRouteTablePropagations: {
                locationName: "transitGatewayRouteTablePropagations",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    TransitGatewayAttachmentId: {
                      locationName: "transitGatewayAttachmentId"
                    },
                    ResourceId: {
                      locationName: "resourceId"
                    },
                    ResourceType: {
                      locationName: "resourceType"
                    },
                    State: {
                      locationName: "state"
                    },
                    TransitGatewayRouteTableAnnouncementId: {
                      locationName: "transitGatewayRouteTableAnnouncementId"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetVerifiedAccessEndpointPolicy: {
          input: {
            type: "structure",
            required: [
              "VerifiedAccessEndpointId"
            ],
            members: {
              VerifiedAccessEndpointId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyEnabled: {
                locationName: "policyEnabled",
                type: "boolean"
              },
              PolicyDocument: {
                locationName: "policyDocument"
              }
            }
          }
        },
        GetVerifiedAccessGroupPolicy: {
          input: {
            type: "structure",
            required: [
              "VerifiedAccessGroupId"
            ],
            members: {
              VerifiedAccessGroupId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyEnabled: {
                locationName: "policyEnabled",
                type: "boolean"
              },
              PolicyDocument: {
                locationName: "policyDocument"
              }
            }
          }
        },
        GetVpnConnectionDeviceSampleConfiguration: {
          input: {
            type: "structure",
            required: [
              "VpnConnectionId",
              "VpnConnectionDeviceTypeId"
            ],
            members: {
              VpnConnectionId: {},
              VpnConnectionDeviceTypeId: {},
              InternetKeyExchangeVersion: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpnConnectionDeviceSampleConfiguration: {
                locationName: "vpnConnectionDeviceSampleConfiguration",
                type: "string",
                sensitive: true
              }
            }
          }
        },
        GetVpnConnectionDeviceTypes: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpnConnectionDeviceTypes: {
                locationName: "vpnConnectionDeviceTypeSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    VpnConnectionDeviceTypeId: {
                      locationName: "vpnConnectionDeviceTypeId"
                    },
                    Vendor: {
                      locationName: "vendor"
                    },
                    Platform: {
                      locationName: "platform"
                    },
                    Software: {
                      locationName: "software"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetVpnTunnelReplacementStatus: {
          input: {
            type: "structure",
            required: [
              "VpnConnectionId",
              "VpnTunnelOutsideIpAddress"
            ],
            members: {
              VpnConnectionId: {},
              VpnTunnelOutsideIpAddress: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpnConnectionId: {
                locationName: "vpnConnectionId"
              },
              TransitGatewayId: {
                locationName: "transitGatewayId"
              },
              CustomerGatewayId: {
                locationName: "customerGatewayId"
              },
              VpnGatewayId: {
                locationName: "vpnGatewayId"
              },
              VpnTunnelOutsideIpAddress: {
                locationName: "vpnTunnelOutsideIpAddress"
              },
              MaintenanceDetails: {
                locationName: "maintenanceDetails",
                type: "structure",
                members: {
                  PendingMaintenance: {
                    locationName: "pendingMaintenance"
                  },
                  MaintenanceAutoAppliedAfter: {
                    locationName: "maintenanceAutoAppliedAfter",
                    type: "timestamp"
                  },
                  LastMaintenanceApplied: {
                    locationName: "lastMaintenanceApplied",
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        ImportClientVpnClientCertificateRevocationList: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId",
              "CertificateRevocationList"
            ],
            members: {
              ClientVpnEndpointId: {},
              CertificateRevocationList: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ImportImage: {
          input: {
            type: "structure",
            members: {
              Architecture: {},
              ClientData: {
                shape: "S23m"
              },
              ClientToken: {},
              Description: {},
              DiskContainers: {
                locationName: "DiskContainer",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Description: {},
                    DeviceName: {},
                    Format: {},
                    SnapshotId: {},
                    Url: {
                      shape: "S18v"
                    },
                    UserBucket: {
                      shape: "S23p"
                    }
                  }
                }
              },
              DryRun: {
                type: "boolean"
              },
              Encrypted: {
                type: "boolean"
              },
              Hypervisor: {},
              KmsKeyId: {},
              LicenseType: {},
              Platform: {},
              RoleName: {},
              LicenseSpecifications: {
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    LicenseConfigurationArn: {}
                  }
                }
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              UsageOperation: {},
              BootMode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Architecture: {
                locationName: "architecture"
              },
              Description: {
                locationName: "description"
              },
              Encrypted: {
                locationName: "encrypted",
                type: "boolean"
              },
              Hypervisor: {
                locationName: "hypervisor"
              },
              ImageId: {
                locationName: "imageId"
              },
              ImportTaskId: {
                locationName: "importTaskId"
              },
              KmsKeyId: {
                locationName: "kmsKeyId"
              },
              LicenseType: {
                locationName: "licenseType"
              },
              Platform: {
                locationName: "platform"
              },
              Progress: {
                locationName: "progress"
              },
              SnapshotDetails: {
                shape: "S18t",
                locationName: "snapshotDetailSet"
              },
              Status: {
                locationName: "status"
              },
              StatusMessage: {
                locationName: "statusMessage"
              },
              LicenseSpecifications: {
                shape: "S18x",
                locationName: "licenseSpecifications"
              },
              Tags: {
                shape: "S6",
                locationName: "tagSet"
              },
              UsageOperation: {
                locationName: "usageOperation"
              }
            }
          }
        },
        ImportInstance: {
          input: {
            type: "structure",
            required: [
              "Platform"
            ],
            members: {
              Description: {
                locationName: "description"
              },
              DiskImages: {
                locationName: "diskImage",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Description: {},
                    Image: {
                      shape: "S23w"
                    },
                    Volume: {
                      shape: "S23x"
                    }
                  }
                }
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              LaunchSpecification: {
                locationName: "launchSpecification",
                type: "structure",
                members: {
                  AdditionalInfo: {
                    locationName: "additionalInfo"
                  },
                  Architecture: {
                    locationName: "architecture"
                  },
                  GroupIds: {
                    shape: "Sgz",
                    locationName: "GroupId"
                  },
                  GroupNames: {
                    shape: "Shn",
                    locationName: "GroupName"
                  },
                  InstanceInitiatedShutdownBehavior: {
                    locationName: "instanceInitiatedShutdownBehavior"
                  },
                  InstanceType: {
                    locationName: "instanceType"
                  },
                  Monitoring: {
                    locationName: "monitoring",
                    type: "boolean"
                  },
                  Placement: {
                    shape: "Scr",
                    locationName: "placement"
                  },
                  PrivateIpAddress: {
                    locationName: "privateIpAddress"
                  },
                  SubnetId: {
                    locationName: "subnetId"
                  },
                  UserData: {
                    locationName: "userData",
                    type: "structure",
                    members: {
                      Data: {
                        locationName: "data"
                      }
                    },
                    sensitive: true
                  }
                }
              },
              Platform: {
                locationName: "platform"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConversionTask: {
                shape: "S13s",
                locationName: "conversionTask"
              }
            }
          }
        },
        ImportKeyPair: {
          input: {
            type: "structure",
            required: [
              "KeyName",
              "PublicKeyMaterial"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              KeyName: {
                locationName: "keyName"
              },
              PublicKeyMaterial: {
                locationName: "publicKeyMaterial",
                type: "blob"
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KeyFingerprint: {
                locationName: "keyFingerprint"
              },
              KeyName: {
                locationName: "keyName"
              },
              KeyPairId: {
                locationName: "keyPairId"
              },
              Tags: {
                shape: "S6",
                locationName: "tagSet"
              }
            }
          }
        },
        ImportSnapshot: {
          input: {
            type: "structure",
            members: {
              ClientData: {
                shape: "S23m"
              },
              ClientToken: {},
              Description: {},
              DiskContainer: {
                type: "structure",
                members: {
                  Description: {},
                  Format: {},
                  Url: {
                    shape: "S18v"
                  },
                  UserBucket: {
                    shape: "S23p"
                  }
                }
              },
              DryRun: {
                type: "boolean"
              },
              Encrypted: {
                type: "boolean"
              },
              KmsKeyId: {},
              RoleName: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Description: {
                locationName: "description"
              },
              ImportTaskId: {
                locationName: "importTaskId"
              },
              SnapshotTaskDetail: {
                shape: "S195",
                locationName: "snapshotTaskDetail"
              },
              Tags: {
                shape: "S6",
                locationName: "tagSet"
              }
            }
          }
        },
        ImportVolume: {
          input: {
            type: "structure",
            required: [
              "AvailabilityZone",
              "Image",
              "Volume"
            ],
            members: {
              AvailabilityZone: {
                locationName: "availabilityZone"
              },
              Description: {
                locationName: "description"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              Image: {
                shape: "S23w",
                locationName: "image"
              },
              Volume: {
                shape: "S23x",
                locationName: "volume"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConversionTask: {
                shape: "S13s",
                locationName: "conversionTask"
              }
            }
          }
        },
        ListImagesInRecycleBin: {
          input: {
            type: "structure",
            members: {
              ImageIds: {
                shape: "S18a",
                locationName: "ImageId"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Images: {
                locationName: "imageSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ImageId: {
                      locationName: "imageId"
                    },
                    Name: {
                      locationName: "name"
                    },
                    Description: {
                      locationName: "description"
                    },
                    RecycleBinEnterTime: {
                      locationName: "recycleBinEnterTime",
                      type: "timestamp"
                    },
                    RecycleBinExitTime: {
                      locationName: "recycleBinExitTime",
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListSnapshotsInRecycleBin: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              SnapshotIds: {
                shape: "S1h3",
                locationName: "SnapshotId"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Snapshots: {
                locationName: "snapshotSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    SnapshotId: {
                      locationName: "snapshotId"
                    },
                    RecycleBinEnterTime: {
                      locationName: "recycleBinEnterTime",
                      type: "timestamp"
                    },
                    RecycleBinExitTime: {
                      locationName: "recycleBinExitTime",
                      type: "timestamp"
                    },
                    Description: {
                      locationName: "description"
                    },
                    VolumeId: {
                      locationName: "volumeId"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        LockSnapshot: {
          input: {
            type: "structure",
            required: [
              "SnapshotId",
              "LockMode"
            ],
            members: {
              SnapshotId: {},
              DryRun: {
                type: "boolean"
              },
              LockMode: {},
              CoolOffPeriod: {
                type: "integer"
              },
              LockDuration: {
                type: "integer"
              },
              ExpirationDate: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SnapshotId: {
                locationName: "snapshotId"
              },
              LockState: {
                locationName: "lockState"
              },
              LockDuration: {
                locationName: "lockDuration",
                type: "integer"
              },
              CoolOffPeriod: {
                locationName: "coolOffPeriod",
                type: "integer"
              },
              CoolOffPeriodExpiresOn: {
                locationName: "coolOffPeriodExpiresOn",
                type: "timestamp"
              },
              LockCreatedOn: {
                locationName: "lockCreatedOn",
                type: "timestamp"
              },
              LockExpiresOn: {
                locationName: "lockExpiresOn",
                type: "timestamp"
              },
              LockDurationStartTime: {
                locationName: "lockDurationStartTime",
                type: "timestamp"
              }
            }
          }
        },
        ModifyAddressAttribute: {
          input: {
            type: "structure",
            required: [
              "AllocationId"
            ],
            members: {
              AllocationId: {},
              DomainName: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Address: {
                shape: "S10q",
                locationName: "address"
              }
            }
          }
        },
        ModifyAvailabilityZoneGroup: {
          input: {
            type: "structure",
            required: [
              "GroupName",
              "OptInStatus"
            ],
            members: {
              GroupName: {},
              OptInStatus: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ModifyCapacityReservation: {
          input: {
            type: "structure",
            required: [
              "CapacityReservationId"
            ],
            members: {
              CapacityReservationId: {},
              InstanceCount: {
                type: "integer"
              },
              EndDate: {
                type: "timestamp"
              },
              EndDateType: {},
              Accept: {
                type: "boolean"
              },
              DryRun: {
                type: "boolean"
              },
              AdditionalInfo: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ModifyCapacityReservationFleet: {
          input: {
            type: "structure",
            required: [
              "CapacityReservationFleetId"
            ],
            members: {
              CapacityReservationFleetId: {},
              TotalTargetCapacity: {
                type: "integer"
              },
              EndDate: {
                type: "timestamp"
              },
              DryRun: {
                type: "boolean"
              },
              RemoveEndDate: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ModifyClientVpnEndpoint: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId"
            ],
            members: {
              ClientVpnEndpointId: {},
              ServerCertificateArn: {},
              ConnectionLogOptions: {
                shape: "Saq"
              },
              DnsServers: {
                type: "structure",
                members: {
                  CustomDnsServers: {
                    shape: "So"
                  },
                  Enabled: {
                    type: "boolean"
                  }
                }
              },
              VpnPort: {
                type: "integer"
              },
              Description: {},
              SplitTunnel: {
                type: "boolean"
              },
              DryRun: {
                type: "boolean"
              },
              SecurityGroupIds: {
                shape: "S2r",
                locationName: "SecurityGroupId"
              },
              VpcId: {},
              SelfServicePortal: {},
              ClientConnectOptions: {
                shape: "Sat"
              },
              SessionTimeoutHours: {
                type: "integer"
              },
              ClientLoginBannerOptions: {
                shape: "Sau"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ModifyDefaultCreditSpecification: {
          input: {
            type: "structure",
            required: [
              "InstanceFamily",
              "CpuCredits"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              InstanceFamily: {},
              CpuCredits: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceFamilyCreditSpecification: {
                shape: "S1yu",
                locationName: "instanceFamilyCreditSpecification"
              }
            }
          }
        },
        ModifyEbsDefaultKmsKeyId: {
          input: {
            type: "structure",
            required: [
              "KmsKeyId"
            ],
            members: {
              KmsKeyId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KmsKeyId: {
                locationName: "kmsKeyId"
              }
            }
          }
        },
        ModifyFleet: {
          input: {
            type: "structure",
            required: [
              "FleetId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ExcessCapacityTerminationPolicy: {},
              LaunchTemplateConfigs: {
                shape: "Sck",
                locationName: "LaunchTemplateConfig"
              },
              FleetId: {},
              TargetCapacitySpecification: {
                shape: "Sdn"
              },
              Context: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ModifyFpgaImageAttribute: {
          input: {
            type: "structure",
            required: [
              "FpgaImageId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              FpgaImageId: {},
              Attribute: {},
              OperationType: {},
              UserIds: {
                shape: "S257",
                locationName: "UserId"
              },
              UserGroups: {
                shape: "S258",
                locationName: "UserGroup"
              },
              ProductCodes: {
                shape: "S259",
                locationName: "ProductCode"
              },
              LoadPermission: {
                type: "structure",
                members: {
                  Add: {
                    shape: "S25b"
                  },
                  Remove: {
                    shape: "S25b"
                  }
                }
              },
              Description: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FpgaImageAttribute: {
                shape: "S16j",
                locationName: "fpgaImageAttribute"
              }
            }
          }
        },
        ModifyHosts: {
          input: {
            type: "structure",
            required: [
              "HostIds"
            ],
            members: {
              AutoPlacement: {
                locationName: "autoPlacement"
              },
              HostIds: {
                shape: "S17g",
                locationName: "hostId"
              },
              HostRecovery: {},
              InstanceType: {},
              InstanceFamily: {},
              HostMaintenance: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Successful: {
                shape: "S2f",
                locationName: "successful"
              },
              Unsuccessful: {
                shape: "S25g",
                locationName: "unsuccessful"
              }
            }
          }
        },
        ModifyIdFormat: {
          input: {
            type: "structure",
            required: [
              "Resource",
              "UseLongIds"
            ],
            members: {
              Resource: {},
              UseLongIds: {
                type: "boolean"
              }
            }
          }
        },
        ModifyIdentityIdFormat: {
          input: {
            type: "structure",
            required: [
              "PrincipalArn",
              "Resource",
              "UseLongIds"
            ],
            members: {
              PrincipalArn: {
                locationName: "principalArn"
              },
              Resource: {
                locationName: "resource"
              },
              UseLongIds: {
                locationName: "useLongIds",
                type: "boolean"
              }
            }
          }
        },
        ModifyImageAttribute: {
          input: {
            type: "structure",
            required: [
              "ImageId"
            ],
            members: {
              Attribute: {},
              Description: {
                shape: "Sc1"
              },
              ImageId: {},
              LaunchPermission: {
                type: "structure",
                members: {
                  Add: {
                    shape: "S186"
                  },
                  Remove: {
                    shape: "S186"
                  }
                }
              },
              OperationType: {},
              ProductCodes: {
                shape: "S259",
                locationName: "ProductCode"
              },
              UserGroups: {
                shape: "S258",
                locationName: "UserGroup"
              },
              UserIds: {
                shape: "S257",
                locationName: "UserId"
              },
              Value: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              OrganizationArns: {
                locationName: "OrganizationArn",
                type: "list",
                member: {
                  locationName: "OrganizationArn"
                }
              },
              OrganizationalUnitArns: {
                locationName: "OrganizationalUnitArn",
                type: "list",
                member: {
                  locationName: "OrganizationalUnitArn"
                }
              },
              ImdsSupport: {
                shape: "Sc1"
              }
            }
          }
        },
        ModifyInstanceAttribute: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              SourceDestCheck: {
                shape: "S19c"
              },
              Attribute: {
                locationName: "attribute"
              },
              BlockDeviceMappings: {
                locationName: "blockDeviceMapping",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    DeviceName: {
                      locationName: "deviceName"
                    },
                    Ebs: {
                      locationName: "ebs",
                      type: "structure",
                      members: {
                        DeleteOnTermination: {
                          locationName: "deleteOnTermination",
                          type: "boolean"
                        },
                        VolumeId: {
                          locationName: "volumeId"
                        }
                      }
                    },
                    NoDevice: {
                      locationName: "noDevice"
                    },
                    VirtualName: {
                      locationName: "virtualName"
                    }
                  }
                }
              },
              DisableApiTermination: {
                shape: "S19c",
                locationName: "disableApiTermination"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              EbsOptimized: {
                shape: "S19c",
                locationName: "ebsOptimized"
              },
              EnaSupport: {
                shape: "S19c",
                locationName: "enaSupport"
              },
              Groups: {
                shape: "S5v",
                locationName: "GroupId"
              },
              InstanceId: {
                locationName: "instanceId"
              },
              InstanceInitiatedShutdownBehavior: {
                shape: "Sc1",
                locationName: "instanceInitiatedShutdownBehavior"
              },
              InstanceType: {
                shape: "Sc1",
                locationName: "instanceType"
              },
              Kernel: {
                shape: "Sc1",
                locationName: "kernel"
              },
              Ramdisk: {
                shape: "Sc1",
                locationName: "ramdisk"
              },
              SriovNetSupport: {
                shape: "Sc1",
                locationName: "sriovNetSupport"
              },
              UserData: {
                locationName: "userData",
                type: "structure",
                members: {
                  Value: {
                    locationName: "value",
                    type: "blob"
                  }
                }
              },
              Value: {
                locationName: "value"
              },
              DisableApiStop: {
                shape: "S19c"
              }
            }
          }
        },
        ModifyInstanceCapacityReservationAttributes: {
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "CapacityReservationSpecification"
            ],
            members: {
              InstanceId: {},
              CapacityReservationSpecification: {
                shape: "S25t"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ModifyInstanceCreditSpecification: {
          input: {
            type: "structure",
            required: [
              "InstanceCreditSpecifications"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ClientToken: {},
              InstanceCreditSpecifications: {
                locationName: "InstanceCreditSpecification",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  required: [
                    "InstanceId"
                  ],
                  members: {
                    InstanceId: {},
                    CpuCredits: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SuccessfulInstanceCreditSpecifications: {
                locationName: "successfulInstanceCreditSpecificationSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    InstanceId: {
                      locationName: "instanceId"
                    }
                  }
                }
              },
              UnsuccessfulInstanceCreditSpecifications: {
                locationName: "unsuccessfulInstanceCreditSpecificationSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    InstanceId: {
                      locationName: "instanceId"
                    },
                    Error: {
                      locationName: "error",
                      type: "structure",
                      members: {
                        Code: {
                          locationName: "code"
                        },
                        Message: {
                          locationName: "message"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        ModifyInstanceEventStartTime: {
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "InstanceEventId",
              "NotBefore"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              InstanceId: {},
              InstanceEventId: {},
              NotBefore: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Event: {
                shape: "S19z",
                locationName: "event"
              }
            }
          }
        },
        ModifyInstanceEventWindow: {
          input: {
            type: "structure",
            required: [
              "InstanceEventWindowId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              Name: {},
              InstanceEventWindowId: {},
              TimeRanges: {
                shape: "Sf6",
                locationName: "TimeRange"
              },
              CronExpression: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceEventWindow: {
                shape: "S47",
                locationName: "instanceEventWindow"
              }
            }
          }
        },
        ModifyInstanceMaintenanceOptions: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              AutoRecovery: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceId: {
                locationName: "instanceId"
              },
              AutoRecovery: {
                locationName: "autoRecovery"
              }
            }
          }
        },
        ModifyInstanceMetadataOptions: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              HttpTokens: {},
              HttpPutResponseHopLimit: {
                type: "integer"
              },
              HttpEndpoint: {},
              DryRun: {
                type: "boolean"
              },
              HttpProtocolIpv6: {},
              InstanceMetadataTags: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceId: {
                locationName: "instanceId"
              },
              InstanceMetadataOptions: {
                shape: "S1em",
                locationName: "instanceMetadataOptions"
              }
            }
          }
        },
        ModifyInstancePlacement: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              Affinity: {
                locationName: "affinity"
              },
              GroupName: {},
              HostId: {
                locationName: "hostId"
              },
              InstanceId: {
                locationName: "instanceId"
              },
              Tenancy: {
                locationName: "tenancy"
              },
              PartitionNumber: {
                type: "integer"
              },
              HostResourceGroupArn: {},
              GroupId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ModifyIpam: {
          input: {
            type: "structure",
            required: [
              "IpamId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              IpamId: {},
              Description: {},
              AddOperatingRegions: {
                shape: "Sfn",
                locationName: "AddOperatingRegion"
              },
              RemoveOperatingRegions: {
                shape: "S26i",
                locationName: "RemoveOperatingRegion"
              },
              Tier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Ipam: {
                shape: "Sfr",
                locationName: "ipam"
              }
            }
          }
        },
        ModifyIpamPool: {
          input: {
            type: "structure",
            required: [
              "IpamPoolId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              IpamPoolId: {},
              Description: {},
              AutoImport: {
                type: "boolean"
              },
              AllocationMinNetmaskLength: {
                type: "integer"
              },
              AllocationMaxNetmaskLength: {
                type: "integer"
              },
              AllocationDefaultNetmaskLength: {
                type: "integer"
              },
              ClearAllocationDefaultNetmaskLength: {
                type: "boolean"
              },
              AddAllocationResourceTags: {
                shape: "Sfz",
                locationName: "AddAllocationResourceTag"
              },
              RemoveAllocationResourceTags: {
                shape: "Sfz",
                locationName: "RemoveAllocationResourceTag"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IpamPool: {
                shape: "Sg6",
                locationName: "ipamPool"
              }
            }
          }
        },
        ModifyIpamResourceCidr: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "ResourceCidr",
              "ResourceRegion",
              "CurrentIpamScopeId",
              "Monitored"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ResourceId: {},
              ResourceCidr: {},
              ResourceRegion: {},
              CurrentIpamScopeId: {},
              DestinationIpamScopeId: {},
              Monitored: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IpamResourceCidr: {
                shape: "S20v",
                locationName: "ipamResourceCidr"
              }
            }
          }
        },
        ModifyIpamResourceDiscovery: {
          input: {
            type: "structure",
            required: [
              "IpamResourceDiscoveryId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              IpamResourceDiscoveryId: {},
              Description: {},
              AddOperatingRegions: {
                shape: "Sfn",
                locationName: "AddOperatingRegion"
              },
              RemoveOperatingRegions: {
                shape: "S26i",
                locationName: "RemoveOperatingRegion"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IpamResourceDiscovery: {
                shape: "Sge",
                locationName: "ipamResourceDiscovery"
              }
            }
          }
        },
        ModifyIpamScope: {
          input: {
            type: "structure",
            required: [
              "IpamScopeId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              IpamScopeId: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IpamScope: {
                shape: "Sgi",
                locationName: "ipamScope"
              }
            }
          }
        },
        ModifyLaunchTemplate: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              ClientToken: {},
              LaunchTemplateId: {},
              LaunchTemplateName: {},
              DefaultVersion: {
                locationName: "SetDefaultVersion"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LaunchTemplate: {
                shape: "Sic",
                locationName: "launchTemplate"
              }
            }
          }
        },
        ModifyLocalGatewayRoute: {
          input: {
            type: "structure",
            required: [
              "LocalGatewayRouteTableId"
            ],
            members: {
              DestinationCidrBlock: {},
              LocalGatewayRouteTableId: {},
              LocalGatewayVirtualInterfaceGroupId: {},
              NetworkInterfaceId: {},
              DryRun: {
                type: "boolean"
              },
              DestinationPrefixListId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Route: {
                shape: "Sjo",
                locationName: "route"
              }
            }
          }
        },
        ModifyManagedPrefixList: {
          input: {
            type: "structure",
            required: [
              "PrefixListId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              PrefixListId: {},
              CurrentVersion: {
                type: "long"
              },
              PrefixListName: {},
              AddEntries: {
                shape: "Sk6",
                locationName: "AddEntry"
              },
              RemoveEntries: {
                locationName: "RemoveEntry",
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Cidr"
                  ],
                  members: {
                    Cidr: {}
                  }
                }
              },
              MaxEntries: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PrefixList: {
                shape: "Sk9",
                locationName: "prefixList"
              }
            }
          }
        },
        ModifyNetworkInterfaceAttribute: {
          input: {
            type: "structure",
            required: [
              "NetworkInterfaceId"
            ],
            members: {
              Attachment: {
                locationName: "attachment",
                type: "structure",
                members: {
                  AttachmentId: {
                    locationName: "attachmentId"
                  },
                  DeleteOnTermination: {
                    locationName: "deleteOnTermination",
                    type: "boolean"
                  }
                }
              },
              Description: {
                shape: "Sc1",
                locationName: "description"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              Groups: {
                shape: "Sgz",
                locationName: "SecurityGroupId"
              },
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              },
              SourceDestCheck: {
                shape: "S19c",
                locationName: "sourceDestCheck"
              },
              EnaSrdSpecification: {
                shape: "S60"
              },
              EnablePrimaryIpv6: {
                type: "boolean"
              },
              ConnectionTrackingSpecification: {
                shape: "Sha"
              }
            }
          }
        },
        ModifyPrivateDnsNameOptions: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              InstanceId: {},
              PrivateDnsHostnameType: {},
              EnableResourceNameDnsARecord: {
                type: "boolean"
              },
              EnableResourceNameDnsAAAARecord: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ModifyReservedInstances: {
          input: {
            type: "structure",
            required: [
              "ReservedInstancesIds",
              "TargetConfigurations"
            ],
            members: {
              ReservedInstancesIds: {
                shape: "S1kq",
                locationName: "ReservedInstancesId"
              },
              ClientToken: {
                locationName: "clientToken"
              },
              TargetConfigurations: {
                locationName: "ReservedInstancesConfigurationSetItemType",
                type: "list",
                member: {
                  shape: "S1lc",
                  locationName: "item"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReservedInstancesModificationId: {
                locationName: "reservedInstancesModificationId"
              }
            }
          }
        },
        ModifySecurityGroupRules: {
          input: {
            type: "structure",
            required: [
              "GroupId",
              "SecurityGroupRules"
            ],
            members: {
              GroupId: {},
              SecurityGroupRules: {
                locationName: "SecurityGroupRule",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  required: [
                    "SecurityGroupRuleId"
                  ],
                  members: {
                    SecurityGroupRuleId: {},
                    SecurityGroupRule: {
                      type: "structure",
                      members: {
                        IpProtocol: {},
                        FromPort: {
                          type: "integer"
                        },
                        ToPort: {
                          type: "integer"
                        },
                        CidrIpv4: {},
                        CidrIpv6: {},
                        PrefixListId: {},
                        ReferencedGroupId: {},
                        Description: {}
                      }
                    }
                  }
                }
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ModifySnapshotAttribute: {
          input: {
            type: "structure",
            required: [
              "SnapshotId"
            ],
            members: {
              Attribute: {},
              CreateVolumePermission: {
                type: "structure",
                members: {
                  Add: {
                    shape: "S1mq"
                  },
                  Remove: {
                    shape: "S1mq"
                  }
                }
              },
              GroupNames: {
                shape: "S1mi",
                locationName: "UserGroup"
              },
              OperationType: {},
              SnapshotId: {},
              UserIds: {
                shape: "S257",
                locationName: "UserId"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        ModifySnapshotTier: {
          input: {
            type: "structure",
            required: [
              "SnapshotId"
            ],
            members: {
              SnapshotId: {},
              StorageTier: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SnapshotId: {
                locationName: "snapshotId"
              },
              TieringStartTime: {
                locationName: "tieringStartTime",
                type: "timestamp"
              }
            }
          }
        },
        ModifySpotFleetRequest: {
          input: {
            type: "structure",
            required: [
              "SpotFleetRequestId"
            ],
            members: {
              ExcessCapacityTerminationPolicy: {
                locationName: "excessCapacityTerminationPolicy"
              },
              LaunchTemplateConfigs: {
                shape: "S1nx",
                locationName: "LaunchTemplateConfig"
              },
              SpotFleetRequestId: {
                locationName: "spotFleetRequestId"
              },
              TargetCapacity: {
                locationName: "targetCapacity",
                type: "integer"
              },
              OnDemandTargetCapacity: {
                type: "integer"
              },
              Context: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ModifySubnetAttribute: {
          input: {
            type: "structure",
            required: [
              "SubnetId"
            ],
            members: {
              AssignIpv6AddressOnCreation: {
                shape: "S19c"
              },
              MapPublicIpOnLaunch: {
                shape: "S19c"
              },
              SubnetId: {
                locationName: "subnetId"
              },
              MapCustomerOwnedIpOnLaunch: {
                shape: "S19c"
              },
              CustomerOwnedIpv4Pool: {},
              EnableDns64: {
                shape: "S19c"
              },
              PrivateDnsHostnameTypeOnLaunch: {},
              EnableResourceNameDnsARecordOnLaunch: {
                shape: "S19c"
              },
              EnableResourceNameDnsAAAARecordOnLaunch: {
                shape: "S19c"
              },
              EnableLniAtDeviceIndex: {
                type: "integer"
              },
              DisableLniAtDeviceIndex: {
                shape: "S19c"
              }
            }
          }
        },
        ModifyTrafficMirrorFilterNetworkServices: {
          input: {
            type: "structure",
            required: [
              "TrafficMirrorFilterId"
            ],
            members: {
              TrafficMirrorFilterId: {},
              AddNetworkServices: {
                shape: "Soj",
                locationName: "AddNetworkService"
              },
              RemoveNetworkServices: {
                shape: "Soj",
                locationName: "RemoveNetworkService"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrafficMirrorFilter: {
                shape: "Sod",
                locationName: "trafficMirrorFilter"
              }
            }
          }
        },
        ModifyTrafficMirrorFilterRule: {
          input: {
            type: "structure",
            required: [
              "TrafficMirrorFilterRuleId"
            ],
            members: {
              TrafficMirrorFilterRuleId: {},
              TrafficDirection: {},
              RuleNumber: {
                type: "integer"
              },
              RuleAction: {},
              DestinationPortRange: {
                shape: "Son"
              },
              SourcePortRange: {
                shape: "Son"
              },
              Protocol: {
                type: "integer"
              },
              DestinationCidrBlock: {},
              SourceCidrBlock: {},
              Description: {},
              RemoveFields: {
                locationName: "RemoveField",
                type: "list",
                member: {}
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrafficMirrorFilterRule: {
                shape: "Sof",
                locationName: "trafficMirrorFilterRule"
              }
            }
          }
        },
        ModifyTrafficMirrorSession: {
          input: {
            type: "structure",
            required: [
              "TrafficMirrorSessionId"
            ],
            members: {
              TrafficMirrorSessionId: {},
              TrafficMirrorTargetId: {},
              TrafficMirrorFilterId: {},
              PacketLength: {
                type: "integer"
              },
              SessionNumber: {
                type: "integer"
              },
              VirtualNetworkId: {
                type: "integer"
              },
              Description: {},
              RemoveFields: {
                locationName: "RemoveField",
                type: "list",
                member: {}
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrafficMirrorSession: {
                shape: "Sos",
                locationName: "trafficMirrorSession"
              }
            }
          }
        },
        ModifyTransitGateway: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayId"
            ],
            members: {
              TransitGatewayId: {},
              Description: {},
              Options: {
                type: "structure",
                members: {
                  AddTransitGatewayCidrBlocks: {
                    shape: "Sp4"
                  },
                  RemoveTransitGatewayCidrBlocks: {
                    shape: "Sp4"
                  },
                  VpnEcmpSupport: {},
                  DnsSupport: {},
                  SecurityGroupReferencingSupport: {},
                  AutoAcceptSharedAttachments: {},
                  DefaultRouteTableAssociation: {},
                  AssociationDefaultRouteTableId: {},
                  DefaultRouteTablePropagation: {},
                  PropagationDefaultRouteTableId: {},
                  AmazonSideAsn: {
                    type: "long"
                  }
                }
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGateway: {
                shape: "Sp6",
                locationName: "transitGateway"
              }
            }
          }
        },
        ModifyTransitGatewayPrefixListReference: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayRouteTableId",
              "PrefixListId"
            ],
            members: {
              TransitGatewayRouteTableId: {},
              PrefixListId: {},
              TransitGatewayAttachmentId: {},
              Blackhole: {
                type: "boolean"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayPrefixListReference: {
                shape: "Sq9",
                locationName: "transitGatewayPrefixListReference"
              }
            }
          }
        },
        ModifyTransitGatewayVpcAttachment: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayAttachmentId"
            ],
            members: {
              TransitGatewayAttachmentId: {},
              AddSubnetIds: {
                shape: "S57"
              },
              RemoveSubnetIds: {
                shape: "S57"
              },
              Options: {
                type: "structure",
                members: {
                  DnsSupport: {},
                  SecurityGroupReferencingSupport: {},
                  Ipv6Support: {},
                  ApplianceModeSupport: {}
                }
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayVpcAttachment: {
                shape: "S16",
                locationName: "transitGatewayVpcAttachment"
              }
            }
          }
        },
        ModifyVerifiedAccessEndpoint: {
          input: {
            type: "structure",
            required: [
              "VerifiedAccessEndpointId"
            ],
            members: {
              VerifiedAccessEndpointId: {},
              VerifiedAccessGroupId: {},
              LoadBalancerOptions: {
                type: "structure",
                members: {
                  SubnetIds: {
                    locationName: "SubnetId",
                    type: "list",
                    member: {
                      locationName: "item"
                    }
                  },
                  Protocol: {},
                  Port: {
                    type: "integer"
                  }
                }
              },
              NetworkInterfaceOptions: {
                type: "structure",
                members: {
                  Protocol: {},
                  Port: {
                    type: "integer"
                  }
                }
              },
              Description: {},
              ClientToken: {
                idempotencyToken: true
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VerifiedAccessEndpoint: {
                shape: "Sra",
                locationName: "verifiedAccessEndpoint"
              }
            }
          }
        },
        ModifyVerifiedAccessEndpointPolicy: {
          input: {
            type: "structure",
            required: [
              "VerifiedAccessEndpointId"
            ],
            members: {
              VerifiedAccessEndpointId: {},
              PolicyEnabled: {
                type: "boolean"
              },
              PolicyDocument: {},
              ClientToken: {
                idempotencyToken: true
              },
              DryRun: {
                type: "boolean"
              },
              SseSpecification: {
                shape: "Sr8"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyEnabled: {
                locationName: "policyEnabled",
                type: "boolean"
              },
              PolicyDocument: {
                locationName: "policyDocument"
              },
              SseSpecification: {
                shape: "S6e",
                locationName: "sseSpecification"
              }
            }
          }
        },
        ModifyVerifiedAccessGroup: {
          input: {
            type: "structure",
            required: [
              "VerifiedAccessGroupId"
            ],
            members: {
              VerifiedAccessGroupId: {},
              VerifiedAccessInstanceId: {},
              Description: {},
              ClientToken: {
                idempotencyToken: true
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VerifiedAccessGroup: {
                shape: "Sri",
                locationName: "verifiedAccessGroup"
              }
            }
          }
        },
        ModifyVerifiedAccessGroupPolicy: {
          input: {
            type: "structure",
            required: [
              "VerifiedAccessGroupId"
            ],
            members: {
              VerifiedAccessGroupId: {},
              PolicyEnabled: {
                type: "boolean"
              },
              PolicyDocument: {},
              ClientToken: {
                idempotencyToken: true
              },
              DryRun: {
                type: "boolean"
              },
              SseSpecification: {
                shape: "Sr8"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyEnabled: {
                locationName: "policyEnabled",
                type: "boolean"
              },
              PolicyDocument: {
                locationName: "policyDocument"
              },
              SseSpecification: {
                shape: "S6e",
                locationName: "sseSpecification"
              }
            }
          }
        },
        ModifyVerifiedAccessInstance: {
          input: {
            type: "structure",
            required: [
              "VerifiedAccessInstanceId"
            ],
            members: {
              VerifiedAccessInstanceId: {},
              Description: {},
              DryRun: {
                type: "boolean"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VerifiedAccessInstance: {
                shape: "S6g",
                locationName: "verifiedAccessInstance"
              }
            }
          }
        },
        ModifyVerifiedAccessInstanceLoggingConfiguration: {
          input: {
            type: "structure",
            required: [
              "VerifiedAccessInstanceId",
              "AccessLogs"
            ],
            members: {
              VerifiedAccessInstanceId: {},
              AccessLogs: {
                type: "structure",
                members: {
                  S3: {
                    type: "structure",
                    required: [
                      "Enabled"
                    ],
                    members: {
                      Enabled: {
                        type: "boolean"
                      },
                      BucketName: {},
                      Prefix: {},
                      BucketOwner: {}
                    }
                  },
                  CloudWatchLogs: {
                    type: "structure",
                    required: [
                      "Enabled"
                    ],
                    members: {
                      Enabled: {
                        type: "boolean"
                      },
                      LogGroup: {}
                    }
                  },
                  KinesisDataFirehose: {
                    type: "structure",
                    required: [
                      "Enabled"
                    ],
                    members: {
                      Enabled: {
                        type: "boolean"
                      },
                      DeliveryStream: {}
                    }
                  },
                  LogVersion: {},
                  IncludeTrustContext: {
                    type: "boolean"
                  }
                }
              },
              DryRun: {
                type: "boolean"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LoggingConfiguration: {
                shape: "S1rd",
                locationName: "loggingConfiguration"
              }
            }
          }
        },
        ModifyVerifiedAccessTrustProvider: {
          input: {
            type: "structure",
            required: [
              "VerifiedAccessTrustProviderId"
            ],
            members: {
              VerifiedAccessTrustProviderId: {},
              OidcOptions: {
                type: "structure",
                members: {
                  Issuer: {},
                  AuthorizationEndpoint: {},
                  TokenEndpoint: {},
                  UserInfoEndpoint: {},
                  ClientId: {},
                  ClientSecret: {
                    shape: "S6c"
                  },
                  Scope: {}
                }
              },
              DeviceOptions: {
                type: "structure",
                members: {
                  PublicSigningKeyUrl: {}
                }
              },
              Description: {},
              DryRun: {
                type: "boolean"
              },
              ClientToken: {
                idempotencyToken: true
              },
              SseSpecification: {
                shape: "Sr8"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VerifiedAccessTrustProvider: {
                shape: "S67",
                locationName: "verifiedAccessTrustProvider"
              }
            }
          }
        },
        ModifyVolume: {
          input: {
            type: "structure",
            required: [
              "VolumeId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              VolumeId: {},
              Size: {
                type: "integer"
              },
              VolumeType: {},
              Iops: {
                type: "integer"
              },
              Throughput: {
                type: "integer"
              },
              MultiAttachEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VolumeModification: {
                shape: "S1sh",
                locationName: "volumeModification"
              }
            }
          }
        },
        ModifyVolumeAttribute: {
          input: {
            type: "structure",
            required: [
              "VolumeId"
            ],
            members: {
              AutoEnableIO: {
                shape: "S19c"
              },
              VolumeId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        ModifyVpcAttribute: {
          input: {
            type: "structure",
            required: [
              "VpcId"
            ],
            members: {
              EnableDnsHostnames: {
                shape: "S19c"
              },
              EnableDnsSupport: {
                shape: "S19c"
              },
              VpcId: {
                locationName: "vpcId"
              },
              EnableNetworkAddressUsageMetrics: {
                shape: "S19c"
              }
            }
          }
        },
        ModifyVpcEndpoint: {
          input: {
            type: "structure",
            required: [
              "VpcEndpointId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              VpcEndpointId: {},
              ResetPolicy: {
                type: "boolean"
              },
              PolicyDocument: {},
              AddRouteTableIds: {
                shape: "Srx",
                locationName: "AddRouteTableId"
              },
              RemoveRouteTableIds: {
                shape: "Srx",
                locationName: "RemoveRouteTableId"
              },
              AddSubnetIds: {
                shape: "Sry",
                locationName: "AddSubnetId"
              },
              RemoveSubnetIds: {
                shape: "Sry",
                locationName: "RemoveSubnetId"
              },
              AddSecurityGroupIds: {
                shape: "Srz",
                locationName: "AddSecurityGroupId"
              },
              RemoveSecurityGroupIds: {
                shape: "Srz",
                locationName: "RemoveSecurityGroupId"
              },
              IpAddressType: {},
              DnsOptions: {
                shape: "Ss1"
              },
              PrivateDnsEnabled: {
                type: "boolean"
              },
              SubnetConfigurations: {
                shape: "Ss3",
                locationName: "SubnetConfiguration"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ModifyVpcEndpointConnectionNotification: {
          input: {
            type: "structure",
            required: [
              "ConnectionNotificationId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ConnectionNotificationId: {},
              ConnectionNotificationArn: {},
              ConnectionEvents: {
                shape: "So"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReturnValue: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ModifyVpcEndpointServiceConfiguration: {
          input: {
            type: "structure",
            required: [
              "ServiceId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ServiceId: {},
              PrivateDnsName: {},
              RemovePrivateDnsName: {
                type: "boolean"
              },
              AcceptanceRequired: {
                type: "boolean"
              },
              AddNetworkLoadBalancerArns: {
                shape: "So",
                locationName: "AddNetworkLoadBalancerArn"
              },
              RemoveNetworkLoadBalancerArns: {
                shape: "So",
                locationName: "RemoveNetworkLoadBalancerArn"
              },
              AddGatewayLoadBalancerArns: {
                shape: "So",
                locationName: "AddGatewayLoadBalancerArn"
              },
              RemoveGatewayLoadBalancerArns: {
                shape: "So",
                locationName: "RemoveGatewayLoadBalancerArn"
              },
              AddSupportedIpAddressTypes: {
                shape: "So",
                locationName: "AddSupportedIpAddressType"
              },
              RemoveSupportedIpAddressTypes: {
                shape: "So",
                locationName: "RemoveSupportedIpAddressType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ModifyVpcEndpointServicePayerResponsibility: {
          input: {
            type: "structure",
            required: [
              "ServiceId",
              "PayerResponsibility"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ServiceId: {},
              PayerResponsibility: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReturnValue: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ModifyVpcEndpointServicePermissions: {
          input: {
            type: "structure",
            required: [
              "ServiceId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ServiceId: {},
              AddAllowedPrincipals: {
                shape: "So"
              },
              RemoveAllowedPrincipals: {
                shape: "So"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AddedPrincipals: {
                locationName: "addedPrincipalSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    PrincipalType: {
                      locationName: "principalType"
                    },
                    Principal: {
                      locationName: "principal"
                    },
                    ServicePermissionId: {
                      locationName: "servicePermissionId"
                    },
                    ServiceId: {
                      locationName: "serviceId"
                    }
                  }
                }
              },
              ReturnValue: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ModifyVpcPeeringConnectionOptions: {
          input: {
            type: "structure",
            required: [
              "VpcPeeringConnectionId"
            ],
            members: {
              AccepterPeeringConnectionOptions: {
                shape: "S297"
              },
              DryRun: {
                type: "boolean"
              },
              RequesterPeeringConnectionOptions: {
                shape: "S297"
              },
              VpcPeeringConnectionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AccepterPeeringConnectionOptions: {
                shape: "S299",
                locationName: "accepterPeeringConnectionOptions"
              },
              RequesterPeeringConnectionOptions: {
                shape: "S299",
                locationName: "requesterPeeringConnectionOptions"
              }
            }
          }
        },
        ModifyVpcTenancy: {
          input: {
            type: "structure",
            required: [
              "VpcId",
              "InstanceTenancy"
            ],
            members: {
              VpcId: {},
              InstanceTenancy: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReturnValue: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ModifyVpnConnection: {
          input: {
            type: "structure",
            required: [
              "VpnConnectionId"
            ],
            members: {
              VpnConnectionId: {},
              TransitGatewayId: {},
              CustomerGatewayId: {},
              VpnGatewayId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpnConnection: {
                shape: "Stm",
                locationName: "vpnConnection"
              }
            }
          }
        },
        ModifyVpnConnectionOptions: {
          input: {
            type: "structure",
            required: [
              "VpnConnectionId"
            ],
            members: {
              VpnConnectionId: {},
              LocalIpv4NetworkCidr: {},
              RemoteIpv4NetworkCidr: {},
              LocalIpv6NetworkCidr: {},
              RemoteIpv6NetworkCidr: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpnConnection: {
                shape: "Stm",
                locationName: "vpnConnection"
              }
            }
          }
        },
        ModifyVpnTunnelCertificate: {
          input: {
            type: "structure",
            required: [
              "VpnConnectionId",
              "VpnTunnelOutsideIpAddress"
            ],
            members: {
              VpnConnectionId: {},
              VpnTunnelOutsideIpAddress: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpnConnection: {
                shape: "Stm",
                locationName: "vpnConnection"
              }
            }
          }
        },
        ModifyVpnTunnelOptions: {
          input: {
            type: "structure",
            required: [
              "VpnConnectionId",
              "VpnTunnelOutsideIpAddress",
              "TunnelOptions"
            ],
            members: {
              VpnConnectionId: {},
              VpnTunnelOutsideIpAddress: {},
              TunnelOptions: {
                type: "structure",
                members: {
                  TunnelInsideCidr: {},
                  TunnelInsideIpv6Cidr: {},
                  PreSharedKey: {
                    shape: "St3"
                  },
                  Phase1LifetimeSeconds: {
                    type: "integer"
                  },
                  Phase2LifetimeSeconds: {
                    type: "integer"
                  },
                  RekeyMarginTimeSeconds: {
                    type: "integer"
                  },
                  RekeyFuzzPercentage: {
                    type: "integer"
                  },
                  ReplayWindowSize: {
                    type: "integer"
                  },
                  DPDTimeoutSeconds: {
                    type: "integer"
                  },
                  DPDTimeoutAction: {},
                  Phase1EncryptionAlgorithms: {
                    shape: "St4",
                    locationName: "Phase1EncryptionAlgorithm"
                  },
                  Phase2EncryptionAlgorithms: {
                    shape: "St6",
                    locationName: "Phase2EncryptionAlgorithm"
                  },
                  Phase1IntegrityAlgorithms: {
                    shape: "St8",
                    locationName: "Phase1IntegrityAlgorithm"
                  },
                  Phase2IntegrityAlgorithms: {
                    shape: "Sta",
                    locationName: "Phase2IntegrityAlgorithm"
                  },
                  Phase1DHGroupNumbers: {
                    shape: "Stc",
                    locationName: "Phase1DHGroupNumber"
                  },
                  Phase2DHGroupNumbers: {
                    shape: "Ste",
                    locationName: "Phase2DHGroupNumber"
                  },
                  IKEVersions: {
                    shape: "Stg",
                    locationName: "IKEVersion"
                  },
                  StartupAction: {},
                  LogOptions: {
                    shape: "Sti"
                  },
                  EnableTunnelLifecycleControl: {
                    type: "boolean"
                  }
                },
                sensitive: true
              },
              DryRun: {
                type: "boolean"
              },
              SkipTunnelReplacement: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpnConnection: {
                shape: "Stm",
                locationName: "vpnConnection"
              }
            }
          }
        },
        MonitorInstances: {
          input: {
            type: "structure",
            required: [
              "InstanceIds"
            ],
            members: {
              InstanceIds: {
                shape: "S128",
                locationName: "InstanceId"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceMonitorings: {
                shape: "S29o",
                locationName: "instancesSet"
              }
            }
          }
        },
        MoveAddressToVpc: {
          input: {
            type: "structure",
            required: [
              "PublicIp"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              PublicIp: {
                locationName: "publicIp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AllocationId: {
                locationName: "allocationId"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        MoveByoipCidrToIpam: {
          input: {
            type: "structure",
            required: [
              "Cidr",
              "IpamPoolId",
              "IpamPoolOwner"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              Cidr: {},
              IpamPoolId: {},
              IpamPoolOwner: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ByoipCidr: {
                shape: "S1y",
                locationName: "byoipCidr"
              }
            }
          }
        },
        ProvisionByoipCidr: {
          input: {
            type: "structure",
            required: [
              "Cidr"
            ],
            members: {
              Cidr: {},
              CidrAuthorizationContext: {
                type: "structure",
                required: [
                  "Message",
                  "Signature"
                ],
                members: {
                  Message: {},
                  Signature: {}
                }
              },
              PubliclyAdvertisable: {
                type: "boolean"
              },
              Description: {},
              DryRun: {
                type: "boolean"
              },
              PoolTagSpecifications: {
                shape: "S3",
                locationName: "PoolTagSpecification"
              },
              MultiRegion: {
                type: "boolean"
              },
              NetworkBorderGroup: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ByoipCidr: {
                shape: "S1y",
                locationName: "byoipCidr"
              }
            }
          }
        },
        ProvisionIpamByoasn: {
          input: {
            type: "structure",
            required: [
              "IpamId",
              "Asn",
              "AsnAuthorizationContext"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              IpamId: {},
              Asn: {},
              AsnAuthorizationContext: {
                type: "structure",
                required: [
                  "Message",
                  "Signature"
                ],
                members: {
                  Message: {},
                  Signature: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Byoasn: {
                shape: "Szb",
                locationName: "byoasn"
              }
            }
          }
        },
        ProvisionIpamPoolCidr: {
          input: {
            type: "structure",
            required: [
              "IpamPoolId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              IpamPoolId: {},
              Cidr: {},
              CidrAuthorizationContext: {
                type: "structure",
                members: {
                  Message: {},
                  Signature: {}
                }
              },
              NetmaskLength: {
                type: "integer"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IpamPoolCidr: {
                shape: "Szf",
                locationName: "ipamPoolCidr"
              }
            }
          }
        },
        ProvisionPublicIpv4PoolCidr: {
          input: {
            type: "structure",
            required: [
              "IpamPoolId",
              "PoolId",
              "NetmaskLength"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              IpamPoolId: {},
              PoolId: {},
              NetmaskLength: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PoolId: {
                locationName: "poolId"
              },
              PoolAddressRange: {
                shape: "S1kd",
                locationName: "poolAddressRange"
              }
            }
          }
        },
        PurchaseCapacityBlock: {
          input: {
            type: "structure",
            required: [
              "CapacityBlockOfferingId",
              "InstancePlatform"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              CapacityBlockOfferingId: {},
              InstancePlatform: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CapacityReservation: {
                shape: "S9x",
                locationName: "capacityReservation"
              }
            }
          }
        },
        PurchaseHostReservation: {
          input: {
            type: "structure",
            required: [
              "HostIdSet",
              "OfferingId"
            ],
            members: {
              ClientToken: {},
              CurrencyCode: {},
              HostIdSet: {
                shape: "S1zb"
              },
              LimitPrice: {},
              OfferingId: {},
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ClientToken: {
                locationName: "clientToken"
              },
              CurrencyCode: {
                locationName: "currencyCode"
              },
              Purchase: {
                shape: "S1zd",
                locationName: "purchase"
              },
              TotalHourlyPrice: {
                locationName: "totalHourlyPrice"
              },
              TotalUpfrontPrice: {
                locationName: "totalUpfrontPrice"
              }
            }
          }
        },
        PurchaseReservedInstancesOffering: {
          input: {
            type: "structure",
            required: [
              "InstanceCount",
              "ReservedInstancesOfferingId"
            ],
            members: {
              InstanceCount: {
                type: "integer"
              },
              ReservedInstancesOfferingId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              LimitPrice: {
                locationName: "limitPrice",
                type: "structure",
                members: {
                  Amount: {
                    locationName: "amount",
                    type: "double"
                  },
                  CurrencyCode: {
                    locationName: "currencyCode"
                  }
                }
              },
              PurchaseTime: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReservedInstancesId: {
                locationName: "reservedInstancesId"
              }
            }
          }
        },
        PurchaseScheduledInstances: {
          input: {
            type: "structure",
            required: [
              "PurchaseRequests"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              DryRun: {
                type: "boolean"
              },
              PurchaseRequests: {
                locationName: "PurchaseRequest",
                type: "list",
                member: {
                  locationName: "PurchaseRequest",
                  type: "structure",
                  required: [
                    "InstanceCount",
                    "PurchaseToken"
                  ],
                  members: {
                    InstanceCount: {
                      type: "integer"
                    },
                    PurchaseToken: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ScheduledInstanceSet: {
                locationName: "scheduledInstanceSet",
                type: "list",
                member: {
                  shape: "S1m7",
                  locationName: "item"
                }
              }
            }
          }
        },
        RebootInstances: {
          input: {
            type: "structure",
            required: [
              "InstanceIds"
            ],
            members: {
              InstanceIds: {
                shape: "S128",
                locationName: "InstanceId"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        RegisterImage: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              ImageLocation: {},
              Architecture: {
                locationName: "architecture"
              },
              BlockDeviceMappings: {
                shape: "Ser",
                locationName: "BlockDeviceMapping"
              },
              Description: {
                locationName: "description"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              EnaSupport: {
                locationName: "enaSupport",
                type: "boolean"
              },
              KernelId: {
                locationName: "kernelId"
              },
              Name: {
                locationName: "name"
              },
              BillingProducts: {
                locationName: "BillingProduct",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              RamdiskId: {
                locationName: "ramdiskId"
              },
              RootDeviceName: {
                locationName: "rootDeviceName"
              },
              SriovNetSupport: {
                locationName: "sriovNetSupport"
              },
              VirtualizationType: {
                locationName: "virtualizationType"
              },
              BootMode: {},
              TpmSupport: {},
              UefiData: {},
              ImdsSupport: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ImageId: {
                locationName: "imageId"
              }
            }
          }
        },
        RegisterInstanceEventNotificationAttributes: {
          input: {
            type: "structure",
            required: [
              "InstanceTagAttribute"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              InstanceTagAttribute: {
                type: "structure",
                members: {
                  IncludeAllTagsOfInstance: {
                    type: "boolean"
                  },
                  InstanceTagKeys: {
                    shape: "Szq",
                    locationName: "InstanceTagKey"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceTagAttribute: {
                shape: "Szs",
                locationName: "instanceTagAttribute"
              }
            }
          }
        },
        RegisterTransitGatewayMulticastGroupMembers: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayMulticastDomainId",
              "NetworkInterfaceIds"
            ],
            members: {
              TransitGatewayMulticastDomainId: {},
              GroupIpAddress: {},
              NetworkInterfaceIds: {
                shape: "Szu"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RegisteredMulticastGroupMembers: {
                locationName: "registeredMulticastGroupMembers",
                type: "structure",
                members: {
                  TransitGatewayMulticastDomainId: {
                    locationName: "transitGatewayMulticastDomainId"
                  },
                  RegisteredNetworkInterfaceIds: {
                    shape: "So",
                    locationName: "registeredNetworkInterfaceIds"
                  },
                  GroupIpAddress: {
                    locationName: "groupIpAddress"
                  }
                }
              }
            }
          }
        },
        RegisterTransitGatewayMulticastGroupSources: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayMulticastDomainId",
              "NetworkInterfaceIds"
            ],
            members: {
              TransitGatewayMulticastDomainId: {},
              GroupIpAddress: {},
              NetworkInterfaceIds: {
                shape: "Szu"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RegisteredMulticastGroupSources: {
                locationName: "registeredMulticastGroupSources",
                type: "structure",
                members: {
                  TransitGatewayMulticastDomainId: {
                    locationName: "transitGatewayMulticastDomainId"
                  },
                  RegisteredNetworkInterfaceIds: {
                    shape: "So",
                    locationName: "registeredNetworkInterfaceIds"
                  },
                  GroupIpAddress: {
                    locationName: "groupIpAddress"
                  }
                }
              }
            }
          }
        },
        RejectTransitGatewayMulticastDomainAssociations: {
          input: {
            type: "structure",
            members: {
              TransitGatewayMulticastDomainId: {},
              TransitGatewayAttachmentId: {},
              SubnetIds: {
                shape: "So"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Associations: {
                shape: "Sq",
                locationName: "associations"
              }
            }
          }
        },
        RejectTransitGatewayPeeringAttachment: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayAttachmentId"
            ],
            members: {
              TransitGatewayAttachmentId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayPeeringAttachment: {
                shape: "Sx",
                locationName: "transitGatewayPeeringAttachment"
              }
            }
          }
        },
        RejectTransitGatewayVpcAttachment: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayAttachmentId"
            ],
            members: {
              TransitGatewayAttachmentId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayVpcAttachment: {
                shape: "S16",
                locationName: "transitGatewayVpcAttachment"
              }
            }
          }
        },
        RejectVpcEndpointConnections: {
          input: {
            type: "structure",
            required: [
              "ServiceId",
              "VpcEndpointIds"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ServiceId: {},
              VpcEndpointIds: {
                shape: "S1e",
                locationName: "VpcEndpointId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Unsuccessful: {
                shape: "S1h",
                locationName: "unsuccessful"
              }
            }
          }
        },
        RejectVpcPeeringConnection: {
          input: {
            type: "structure",
            required: [
              "VpcPeeringConnectionId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              VpcPeeringConnectionId: {
                locationName: "vpcPeeringConnectionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ReleaseAddress: {
          input: {
            type: "structure",
            members: {
              AllocationId: {},
              PublicIp: {},
              NetworkBorderGroup: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        ReleaseHosts: {
          input: {
            type: "structure",
            required: [
              "HostIds"
            ],
            members: {
              HostIds: {
                shape: "S17g",
                locationName: "hostId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Successful: {
                shape: "S2f",
                locationName: "successful"
              },
              Unsuccessful: {
                shape: "S25g",
                locationName: "unsuccessful"
              }
            }
          }
        },
        ReleaseIpamPoolAllocation: {
          input: {
            type: "structure",
            required: [
              "IpamPoolId",
              "Cidr",
              "IpamPoolAllocationId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              IpamPoolId: {},
              Cidr: {},
              IpamPoolAllocationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Success: {
                locationName: "success",
                type: "boolean"
              }
            }
          }
        },
        ReplaceIamInstanceProfileAssociation: {
          input: {
            type: "structure",
            required: [
              "IamInstanceProfile",
              "AssociationId"
            ],
            members: {
              IamInstanceProfile: {
                shape: "S3v"
              },
              AssociationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IamInstanceProfileAssociation: {
                shape: "S3x",
                locationName: "iamInstanceProfileAssociation"
              }
            }
          }
        },
        ReplaceNetworkAclAssociation: {
          input: {
            type: "structure",
            required: [
              "AssociationId",
              "NetworkAclId"
            ],
            members: {
              AssociationId: {
                locationName: "associationId"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              NetworkAclId: {
                locationName: "networkAclId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NewAssociationId: {
                locationName: "newAssociationId"
              }
            }
          }
        },
        ReplaceNetworkAclEntry: {
          input: {
            type: "structure",
            required: [
              "Egress",
              "NetworkAclId",
              "Protocol",
              "RuleAction",
              "RuleNumber"
            ],
            members: {
              CidrBlock: {
                locationName: "cidrBlock"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              Egress: {
                locationName: "egress",
                type: "boolean"
              },
              IcmpTypeCode: {
                shape: "Sko",
                locationName: "Icmp"
              },
              Ipv6CidrBlock: {
                locationName: "ipv6CidrBlock"
              },
              NetworkAclId: {
                locationName: "networkAclId"
              },
              PortRange: {
                shape: "Skp",
                locationName: "portRange"
              },
              Protocol: {
                locationName: "protocol"
              },
              RuleAction: {
                locationName: "ruleAction"
              },
              RuleNumber: {
                locationName: "ruleNumber",
                type: "integer"
              }
            }
          }
        },
        ReplaceRoute: {
          input: {
            type: "structure",
            required: [
              "RouteTableId"
            ],
            members: {
              DestinationCidrBlock: {
                locationName: "destinationCidrBlock"
              },
              DestinationIpv6CidrBlock: {
                locationName: "destinationIpv6CidrBlock"
              },
              DestinationPrefixListId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              VpcEndpointId: {},
              EgressOnlyInternetGatewayId: {
                locationName: "egressOnlyInternetGatewayId"
              },
              GatewayId: {
                locationName: "gatewayId"
              },
              InstanceId: {
                locationName: "instanceId"
              },
              LocalTarget: {
                type: "boolean"
              },
              NatGatewayId: {
                locationName: "natGatewayId"
              },
              TransitGatewayId: {},
              LocalGatewayId: {},
              CarrierGatewayId: {},
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              },
              RouteTableId: {
                locationName: "routeTableId"
              },
              VpcPeeringConnectionId: {
                locationName: "vpcPeeringConnectionId"
              },
              CoreNetworkArn: {}
            }
          }
        },
        ReplaceRouteTableAssociation: {
          input: {
            type: "structure",
            required: [
              "AssociationId",
              "RouteTableId"
            ],
            members: {
              AssociationId: {
                locationName: "associationId"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              RouteTableId: {
                locationName: "routeTableId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NewAssociationId: {
                locationName: "newAssociationId"
              },
              AssociationState: {
                shape: "S4x",
                locationName: "associationState"
              }
            }
          }
        },
        ReplaceTransitGatewayRoute: {
          input: {
            type: "structure",
            required: [
              "DestinationCidrBlock",
              "TransitGatewayRouteTableId"
            ],
            members: {
              DestinationCidrBlock: {},
              TransitGatewayRouteTableId: {},
              TransitGatewayAttachmentId: {},
              Blackhole: {
                type: "boolean"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Route: {
                shape: "Sqe",
                locationName: "route"
              }
            }
          }
        },
        ReplaceVpnTunnel: {
          input: {
            type: "structure",
            required: [
              "VpnConnectionId",
              "VpnTunnelOutsideIpAddress"
            ],
            members: {
              VpnConnectionId: {},
              VpnTunnelOutsideIpAddress: {},
              ApplyPendingMaintenance: {
                type: "boolean"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ReportInstanceStatus: {
          input: {
            type: "structure",
            required: [
              "Instances",
              "ReasonCodes",
              "Status"
            ],
            members: {
              Description: {
                locationName: "description"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              EndTime: {
                locationName: "endTime",
                type: "timestamp"
              },
              Instances: {
                shape: "S128",
                locationName: "instanceId"
              },
              ReasonCodes: {
                locationName: "reasonCode",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              StartTime: {
                locationName: "startTime",
                type: "timestamp"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        RequestSpotFleet: {
          input: {
            type: "structure",
            required: [
              "SpotFleetRequestConfig"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              SpotFleetRequestConfig: {
                shape: "S1ni",
                locationName: "spotFleetRequestConfig"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SpotFleetRequestId: {
                locationName: "spotFleetRequestId"
              }
            }
          }
        },
        RequestSpotInstances: {
          input: {
            type: "structure",
            members: {
              AvailabilityZoneGroup: {
                locationName: "availabilityZoneGroup"
              },
              BlockDurationMinutes: {
                locationName: "blockDurationMinutes",
                type: "integer"
              },
              ClientToken: {
                locationName: "clientToken"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              InstanceCount: {
                locationName: "instanceCount",
                type: "integer"
              },
              LaunchGroup: {
                locationName: "launchGroup"
              },
              LaunchSpecification: {
                type: "structure",
                members: {
                  SecurityGroupIds: {
                    locationName: "SecurityGroupId",
                    type: "list",
                    member: {
                      locationName: "item"
                    }
                  },
                  SecurityGroups: {
                    locationName: "SecurityGroup",
                    type: "list",
                    member: {
                      locationName: "item"
                    }
                  },
                  AddressingType: {
                    locationName: "addressingType"
                  },
                  BlockDeviceMappings: {
                    shape: "S185",
                    locationName: "blockDeviceMapping"
                  },
                  EbsOptimized: {
                    locationName: "ebsOptimized",
                    type: "boolean"
                  },
                  IamInstanceProfile: {
                    shape: "S3v",
                    locationName: "iamInstanceProfile"
                  },
                  ImageId: {
                    locationName: "imageId"
                  },
                  InstanceType: {
                    locationName: "instanceType"
                  },
                  KernelId: {
                    locationName: "kernelId"
                  },
                  KeyName: {
                    locationName: "keyName"
                  },
                  Monitoring: {
                    shape: "S1od",
                    locationName: "monitoring"
                  },
                  NetworkInterfaces: {
                    shape: "S1ns",
                    locationName: "NetworkInterface"
                  },
                  Placement: {
                    shape: "S1nu",
                    locationName: "placement"
                  },
                  RamdiskId: {
                    locationName: "ramdiskId"
                  },
                  SubnetId: {
                    locationName: "subnetId"
                  },
                  UserData: {
                    shape: "Sgo",
                    locationName: "userData"
                  }
                }
              },
              SpotPrice: {
                locationName: "spotPrice"
              },
              Type: {
                locationName: "type"
              },
              ValidFrom: {
                locationName: "validFrom",
                type: "timestamp"
              },
              ValidUntil: {
                locationName: "validUntil",
                type: "timestamp"
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              InstanceInterruptionBehavior: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SpotInstanceRequests: {
                shape: "S1oa",
                locationName: "spotInstanceRequestSet"
              }
            }
          }
        },
        ResetAddressAttribute: {
          input: {
            type: "structure",
            required: [
              "AllocationId",
              "Attribute"
            ],
            members: {
              AllocationId: {},
              Attribute: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Address: {
                shape: "S10q",
                locationName: "address"
              }
            }
          }
        },
        ResetEbsDefaultKmsKeyId: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KmsKeyId: {
                locationName: "kmsKeyId"
              }
            }
          }
        },
        ResetFpgaImageAttribute: {
          input: {
            type: "structure",
            required: [
              "FpgaImageId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              FpgaImageId: {},
              Attribute: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ResetImageAttribute: {
          input: {
            type: "structure",
            required: [
              "Attribute",
              "ImageId"
            ],
            members: {
              Attribute: {},
              ImageId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        ResetInstanceAttribute: {
          input: {
            type: "structure",
            required: [
              "Attribute",
              "InstanceId"
            ],
            members: {
              Attribute: {
                locationName: "attribute"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              InstanceId: {
                locationName: "instanceId"
              }
            }
          }
        },
        ResetNetworkInterfaceAttribute: {
          input: {
            type: "structure",
            required: [
              "NetworkInterfaceId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              },
              SourceDestCheck: {
                locationName: "sourceDestCheck"
              }
            }
          }
        },
        ResetSnapshotAttribute: {
          input: {
            type: "structure",
            required: [
              "Attribute",
              "SnapshotId"
            ],
            members: {
              Attribute: {},
              SnapshotId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        RestoreAddressToClassic: {
          input: {
            type: "structure",
            required: [
              "PublicIp"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              PublicIp: {
                locationName: "publicIp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicIp: {
                locationName: "publicIp"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        RestoreImageFromRecycleBin: {
          input: {
            type: "structure",
            required: [
              "ImageId"
            ],
            members: {
              ImageId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        RestoreManagedPrefixListVersion: {
          input: {
            type: "structure",
            required: [
              "PrefixListId",
              "PreviousVersion",
              "CurrentVersion"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              PrefixListId: {},
              PreviousVersion: {
                type: "long"
              },
              CurrentVersion: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PrefixList: {
                shape: "Sk9",
                locationName: "prefixList"
              }
            }
          }
        },
        RestoreSnapshotFromRecycleBin: {
          input: {
            type: "structure",
            required: [
              "SnapshotId"
            ],
            members: {
              SnapshotId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SnapshotId: {
                locationName: "snapshotId"
              },
              OutpostArn: {
                locationName: "outpostArn"
              },
              Description: {
                locationName: "description"
              },
              Encrypted: {
                locationName: "encrypted",
                type: "boolean"
              },
              OwnerId: {
                locationName: "ownerId"
              },
              Progress: {
                locationName: "progress"
              },
              StartTime: {
                locationName: "startTime",
                type: "timestamp"
              },
              State: {
                locationName: "status"
              },
              VolumeId: {
                locationName: "volumeId"
              },
              VolumeSize: {
                locationName: "volumeSize",
                type: "integer"
              },
              SseType: {
                locationName: "sseType"
              }
            }
          }
        },
        RestoreSnapshotTier: {
          input: {
            type: "structure",
            required: [
              "SnapshotId"
            ],
            members: {
              SnapshotId: {},
              TemporaryRestoreDays: {
                type: "integer"
              },
              PermanentRestore: {
                type: "boolean"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SnapshotId: {
                locationName: "snapshotId"
              },
              RestoreStartTime: {
                locationName: "restoreStartTime",
                type: "timestamp"
              },
              RestoreDuration: {
                locationName: "restoreDuration",
                type: "integer"
              },
              IsPermanentRestore: {
                locationName: "isPermanentRestore",
                type: "boolean"
              }
            }
          }
        },
        RevokeClientVpnIngress: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId",
              "TargetNetworkCidr"
            ],
            members: {
              ClientVpnEndpointId: {},
              TargetNetworkCidr: {},
              AccessGroupId: {},
              RevokeAllGroups: {
                type: "boolean"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                shape: "S6u",
                locationName: "status"
              }
            }
          }
        },
        RevokeSecurityGroupEgress: {
          input: {
            type: "structure",
            required: [
              "GroupId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              GroupId: {
                locationName: "groupId"
              },
              IpPermissions: {
                shape: "S6x",
                locationName: "ipPermissions"
              },
              SecurityGroupRuleIds: {
                shape: "S1me",
                locationName: "SecurityGroupRuleId"
              },
              CidrIp: {
                locationName: "cidrIp"
              },
              FromPort: {
                locationName: "fromPort",
                type: "integer"
              },
              IpProtocol: {
                locationName: "ipProtocol"
              },
              ToPort: {
                locationName: "toPort",
                type: "integer"
              },
              SourceSecurityGroupName: {
                locationName: "sourceSecurityGroupName"
              },
              SourceSecurityGroupOwnerId: {
                locationName: "sourceSecurityGroupOwnerId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              },
              UnknownIpPermissions: {
                shape: "S6x",
                locationName: "unknownIpPermissionSet"
              }
            }
          }
        },
        RevokeSecurityGroupIngress: {
          input: {
            type: "structure",
            members: {
              CidrIp: {},
              FromPort: {
                type: "integer"
              },
              GroupId: {},
              GroupName: {},
              IpPermissions: {
                shape: "S6x"
              },
              IpProtocol: {},
              SourceSecurityGroupName: {},
              SourceSecurityGroupOwnerId: {},
              ToPort: {
                type: "integer"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              SecurityGroupRuleIds: {
                shape: "S1me",
                locationName: "SecurityGroupRuleId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              },
              UnknownIpPermissions: {
                shape: "S6x",
                locationName: "unknownIpPermissionSet"
              }
            }
          }
        },
        RunInstances: {
          input: {
            type: "structure",
            required: [
              "MaxCount",
              "MinCount"
            ],
            members: {
              BlockDeviceMappings: {
                shape: "Ser",
                locationName: "BlockDeviceMapping"
              },
              ImageId: {},
              InstanceType: {},
              Ipv6AddressCount: {
                type: "integer"
              },
              Ipv6Addresses: {
                shape: "Siq",
                locationName: "Ipv6Address"
              },
              KernelId: {},
              KeyName: {},
              MaxCount: {
                type: "integer"
              },
              MinCount: {
                type: "integer"
              },
              Monitoring: {
                shape: "S1od"
              },
              Placement: {
                shape: "Scr"
              },
              RamdiskId: {},
              SecurityGroupIds: {
                shape: "Sgz",
                locationName: "SecurityGroupId"
              },
              SecurityGroups: {
                shape: "Shn",
                locationName: "SecurityGroup"
              },
              SubnetId: {},
              UserData: {
                type: "string",
                sensitive: true
              },
              AdditionalInfo: {
                locationName: "additionalInfo"
              },
              ClientToken: {
                idempotencyToken: true,
                locationName: "clientToken"
              },
              DisableApiTermination: {
                locationName: "disableApiTermination",
                type: "boolean"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              EbsOptimized: {
                locationName: "ebsOptimized",
                type: "boolean"
              },
              IamInstanceProfile: {
                shape: "S3v",
                locationName: "iamInstanceProfile"
              },
              InstanceInitiatedShutdownBehavior: {
                locationName: "instanceInitiatedShutdownBehavior"
              },
              NetworkInterfaces: {
                shape: "S1ns",
                locationName: "networkInterface"
              },
              PrivateIpAddress: {
                locationName: "privateIpAddress"
              },
              ElasticGpuSpecification: {
                type: "list",
                member: {
                  shape: "Shj",
                  locationName: "item"
                }
              },
              ElasticInferenceAccelerators: {
                locationName: "ElasticInferenceAccelerator",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  required: [
                    "Type"
                  ],
                  members: {
                    Type: {},
                    Count: {
                      type: "integer"
                    }
                  }
                }
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              LaunchTemplate: {
                type: "structure",
                members: {
                  LaunchTemplateId: {},
                  LaunchTemplateName: {},
                  Version: {}
                }
              },
              InstanceMarketOptions: {
                type: "structure",
                members: {
                  MarketType: {},
                  SpotOptions: {
                    type: "structure",
                    members: {
                      MaxPrice: {},
                      SpotInstanceType: {},
                      BlockDurationMinutes: {
                        type: "integer"
                      },
                      ValidUntil: {
                        type: "timestamp"
                      },
                      InstanceInterruptionBehavior: {}
                    }
                  }
                }
              },
              CreditSpecification: {
                shape: "Sht"
              },
              CpuOptions: {
                type: "structure",
                members: {
                  CoreCount: {
                    type: "integer"
                  },
                  ThreadsPerCore: {
                    type: "integer"
                  },
                  AmdSevSnp: {}
                }
              },
              CapacityReservationSpecification: {
                shape: "S25t"
              },
              HibernationOptions: {
                type: "structure",
                members: {
                  Configured: {
                    type: "boolean"
                  }
                }
              },
              LicenseSpecifications: {
                locationName: "LicenseSpecification",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    LicenseConfigurationArn: {}
                  }
                }
              },
              MetadataOptions: {
                type: "structure",
                members: {
                  HttpTokens: {},
                  HttpPutResponseHopLimit: {
                    type: "integer"
                  },
                  HttpEndpoint: {},
                  HttpProtocolIpv6: {},
                  InstanceMetadataTags: {}
                }
              },
              EnclaveOptions: {
                type: "structure",
                members: {
                  Enabled: {
                    type: "boolean"
                  }
                }
              },
              PrivateDnsNameOptions: {
                type: "structure",
                members: {
                  HostnameType: {},
                  EnableResourceNameDnsARecord: {
                    type: "boolean"
                  },
                  EnableResourceNameDnsAAAARecord: {
                    type: "boolean"
                  }
                }
              },
              MaintenanceOptions: {
                type: "structure",
                members: {
                  AutoRecovery: {}
                }
              },
              DisableApiStop: {
                type: "boolean"
              },
              EnablePrimaryIpv6: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S1du"
          }
        },
        RunScheduledInstances: {
          input: {
            type: "structure",
            required: [
              "LaunchSpecification",
              "ScheduledInstanceId"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              DryRun: {
                type: "boolean"
              },
              InstanceCount: {
                type: "integer"
              },
              LaunchSpecification: {
                type: "structure",
                required: [
                  "ImageId"
                ],
                members: {
                  BlockDeviceMappings: {
                    locationName: "BlockDeviceMapping",
                    type: "list",
                    member: {
                      locationName: "BlockDeviceMapping",
                      type: "structure",
                      members: {
                        DeviceName: {},
                        Ebs: {
                          type: "structure",
                          members: {
                            DeleteOnTermination: {
                              type: "boolean"
                            },
                            Encrypted: {
                              type: "boolean"
                            },
                            Iops: {
                              type: "integer"
                            },
                            SnapshotId: {},
                            VolumeSize: {
                              type: "integer"
                            },
                            VolumeType: {}
                          }
                        },
                        NoDevice: {},
                        VirtualName: {}
                      }
                    }
                  },
                  EbsOptimized: {
                    type: "boolean"
                  },
                  IamInstanceProfile: {
                    type: "structure",
                    members: {
                      Arn: {},
                      Name: {}
                    }
                  },
                  ImageId: {},
                  InstanceType: {},
                  KernelId: {},
                  KeyName: {},
                  Monitoring: {
                    type: "structure",
                    members: {
                      Enabled: {
                        type: "boolean"
                      }
                    }
                  },
                  NetworkInterfaces: {
                    locationName: "NetworkInterface",
                    type: "list",
                    member: {
                      locationName: "NetworkInterface",
                      type: "structure",
                      members: {
                        AssociatePublicIpAddress: {
                          type: "boolean"
                        },
                        DeleteOnTermination: {
                          type: "boolean"
                        },
                        Description: {},
                        DeviceIndex: {
                          type: "integer"
                        },
                        Groups: {
                          shape: "S2di",
                          locationName: "Group"
                        },
                        Ipv6AddressCount: {
                          type: "integer"
                        },
                        Ipv6Addresses: {
                          locationName: "Ipv6Address",
                          type: "list",
                          member: {
                            locationName: "Ipv6Address",
                            type: "structure",
                            members: {
                              Ipv6Address: {}
                            }
                          }
                        },
                        NetworkInterfaceId: {},
                        PrivateIpAddress: {},
                        PrivateIpAddressConfigs: {
                          locationName: "PrivateIpAddressConfig",
                          type: "list",
                          member: {
                            locationName: "PrivateIpAddressConfigSet",
                            type: "structure",
                            members: {
                              Primary: {
                                type: "boolean"
                              },
                              PrivateIpAddress: {}
                            }
                          }
                        },
                        SecondaryPrivateIpAddressCount: {
                          type: "integer"
                        },
                        SubnetId: {}
                      }
                    }
                  },
                  Placement: {
                    type: "structure",
                    members: {
                      AvailabilityZone: {},
                      GroupName: {}
                    }
                  },
                  RamdiskId: {},
                  SecurityGroupIds: {
                    shape: "S2di",
                    locationName: "SecurityGroupId"
                  },
                  SubnetId: {},
                  UserData: {}
                },
                sensitive: true
              },
              ScheduledInstanceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceIdSet: {
                locationName: "instanceIdSet",
                type: "list",
                member: {
                  locationName: "item"
                }
              }
            }
          }
        },
        SearchLocalGatewayRoutes: {
          input: {
            type: "structure",
            required: [
              "LocalGatewayRouteTableId"
            ],
            members: {
              LocalGatewayRouteTableId: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Routes: {
                locationName: "routeSet",
                type: "list",
                member: {
                  shape: "Sjo",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        SearchTransitGatewayMulticastGroups: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayMulticastDomainId"
            ],
            members: {
              TransitGatewayMulticastDomainId: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MulticastGroups: {
                locationName: "multicastGroups",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    GroupIpAddress: {
                      locationName: "groupIpAddress"
                    },
                    TransitGatewayAttachmentId: {
                      locationName: "transitGatewayAttachmentId"
                    },
                    SubnetId: {
                      locationName: "subnetId"
                    },
                    ResourceId: {
                      locationName: "resourceId"
                    },
                    ResourceType: {
                      locationName: "resourceType"
                    },
                    ResourceOwnerId: {
                      locationName: "resourceOwnerId"
                    },
                    NetworkInterfaceId: {
                      locationName: "networkInterfaceId"
                    },
                    GroupMember: {
                      locationName: "groupMember",
                      type: "boolean"
                    },
                    GroupSource: {
                      locationName: "groupSource",
                      type: "boolean"
                    },
                    MemberType: {
                      locationName: "memberType"
                    },
                    SourceType: {
                      locationName: "sourceType"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        SearchTransitGatewayRoutes: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayRouteTableId",
              "Filters"
            ],
            members: {
              TransitGatewayRouteTableId: {},
              Filters: {
                shape: "S10d",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Routes: {
                locationName: "routeSet",
                type: "list",
                member: {
                  shape: "Sqe",
                  locationName: "item"
                }
              },
              AdditionalRoutesAvailable: {
                locationName: "additionalRoutesAvailable",
                type: "boolean"
              }
            }
          }
        },
        SendDiagnosticInterrupt: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              DryRun: {
                type: "boolean"
              }
            }
          }
        },
        StartInstances: {
          input: {
            type: "structure",
            required: [
              "InstanceIds"
            ],
            members: {
              InstanceIds: {
                shape: "S128",
                locationName: "InstanceId"
              },
              AdditionalInfo: {
                locationName: "additionalInfo"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StartingInstances: {
                shape: "S2e6",
                locationName: "instancesSet"
              }
            }
          }
        },
        StartNetworkInsightsAccessScopeAnalysis: {
          input: {
            type: "structure",
            required: [
              "NetworkInsightsAccessScopeId",
              "ClientToken"
            ],
            members: {
              NetworkInsightsAccessScopeId: {},
              DryRun: {
                type: "boolean"
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkInsightsAccessScopeAnalysis: {
                shape: "S1hz",
                locationName: "networkInsightsAccessScopeAnalysis"
              }
            }
          }
        },
        StartNetworkInsightsAnalysis: {
          input: {
            type: "structure",
            required: [
              "NetworkInsightsPathId",
              "ClientToken"
            ],
            members: {
              NetworkInsightsPathId: {},
              AdditionalAccounts: {
                shape: "So",
                locationName: "AdditionalAccount"
              },
              FilterInArns: {
                shape: "S1ib",
                locationName: "FilterInArn"
              },
              DryRun: {
                type: "boolean"
              },
              TagSpecifications: {
                shape: "S3",
                locationName: "TagSpecification"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkInsightsAnalysis: {
                shape: "S1ia",
                locationName: "networkInsightsAnalysis"
              }
            }
          }
        },
        StartVpcEndpointServicePrivateDnsVerification: {
          input: {
            type: "structure",
            required: [
              "ServiceId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ServiceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReturnValue: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        StopInstances: {
          input: {
            type: "structure",
            required: [
              "InstanceIds"
            ],
            members: {
              InstanceIds: {
                shape: "S128",
                locationName: "InstanceId"
              },
              Hibernate: {
                type: "boolean"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              Force: {
                locationName: "force",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StoppingInstances: {
                shape: "S2e6",
                locationName: "instancesSet"
              }
            }
          }
        },
        TerminateClientVpnConnections: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId"
            ],
            members: {
              ClientVpnEndpointId: {},
              ConnectionId: {},
              Username: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ClientVpnEndpointId: {
                locationName: "clientVpnEndpointId"
              },
              Username: {
                locationName: "username"
              },
              ConnectionStatuses: {
                locationName: "connectionStatuses",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ConnectionId: {
                      locationName: "connectionId"
                    },
                    PreviousStatus: {
                      shape: "S12n",
                      locationName: "previousStatus"
                    },
                    CurrentStatus: {
                      shape: "S12n",
                      locationName: "currentStatus"
                    }
                  }
                }
              }
            }
          }
        },
        TerminateInstances: {
          input: {
            type: "structure",
            required: [
              "InstanceIds"
            ],
            members: {
              InstanceIds: {
                shape: "S128",
                locationName: "InstanceId"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TerminatingInstances: {
                shape: "S2e6",
                locationName: "instancesSet"
              }
            }
          }
        },
        UnassignIpv6Addresses: {
          input: {
            type: "structure",
            required: [
              "NetworkInterfaceId"
            ],
            members: {
              Ipv6Addresses: {
                shape: "S2v",
                locationName: "ipv6Addresses"
              },
              Ipv6Prefixes: {
                shape: "S2w",
                locationName: "Ipv6Prefix"
              },
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              },
              UnassignedIpv6Addresses: {
                shape: "S2v",
                locationName: "unassignedIpv6Addresses"
              },
              UnassignedIpv6Prefixes: {
                shape: "S2w",
                locationName: "unassignedIpv6PrefixSet"
              }
            }
          }
        },
        UnassignPrivateIpAddresses: {
          input: {
            type: "structure",
            required: [
              "NetworkInterfaceId"
            ],
            members: {
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              },
              PrivateIpAddresses: {
                shape: "S30",
                locationName: "privateIpAddress"
              },
              Ipv4Prefixes: {
                shape: "S2w",
                locationName: "Ipv4Prefix"
              }
            }
          }
        },
        UnassignPrivateNatGatewayAddress: {
          input: {
            type: "structure",
            required: [
              "NatGatewayId",
              "PrivateIpAddresses"
            ],
            members: {
              NatGatewayId: {},
              PrivateIpAddresses: {
                shape: "S38",
                locationName: "PrivateIpAddress"
              },
              MaxDrainDurationSeconds: {
                type: "integer"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NatGatewayId: {
                locationName: "natGatewayId"
              },
              NatGatewayAddresses: {
                shape: "S3b",
                locationName: "natGatewayAddressSet"
              }
            }
          }
        },
        UnlockSnapshot: {
          input: {
            type: "structure",
            required: [
              "SnapshotId"
            ],
            members: {
              SnapshotId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SnapshotId: {
                locationName: "snapshotId"
              }
            }
          }
        },
        UnmonitorInstances: {
          input: {
            type: "structure",
            required: [
              "InstanceIds"
            ],
            members: {
              InstanceIds: {
                shape: "S128",
                locationName: "InstanceId"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceMonitorings: {
                shape: "S29o",
                locationName: "instancesSet"
              }
            }
          }
        },
        UpdateSecurityGroupRuleDescriptionsEgress: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              GroupId: {},
              GroupName: {},
              IpPermissions: {
                shape: "S6x"
              },
              SecurityGroupRuleDescriptions: {
                shape: "S2ew",
                locationName: "SecurityGroupRuleDescription"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        UpdateSecurityGroupRuleDescriptionsIngress: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              GroupId: {},
              GroupName: {},
              IpPermissions: {
                shape: "S6x"
              },
              SecurityGroupRuleDescriptions: {
                shape: "S2ew",
                locationName: "SecurityGroupRuleDescription"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        WithdrawByoipCidr: {
          input: {
            type: "structure",
            required: [
              "Cidr"
            ],
            members: {
              Cidr: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ByoipCidr: {
                shape: "S1y",
                locationName: "byoipCidr"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              ResourceType: {
                locationName: "resourceType"
              },
              Tags: {
                shape: "S6",
                locationName: "Tag"
              }
            }
          }
        },
        S6: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Key: {
                locationName: "key"
              },
              Value: {
                locationName: "value"
              }
            }
          }
        },
        Sa: {
          type: "structure",
          members: {
            PublicIp: {
              locationName: "publicIp"
            },
            AllocationId: {
              locationName: "allocationId"
            },
            TransferAccountId: {
              locationName: "transferAccountId"
            },
            TransferOfferExpirationTimestamp: {
              locationName: "transferOfferExpirationTimestamp",
              type: "timestamp"
            },
            TransferOfferAcceptedTimestamp: {
              locationName: "transferOfferAcceptedTimestamp",
              type: "timestamp"
            },
            AddressTransferStatus: {
              locationName: "addressTransferStatus"
            }
          }
        },
        Se: {
          type: "list",
          member: {
            locationName: "ReservedInstanceId"
          }
        },
        Sg: {
          type: "list",
          member: {
            locationName: "TargetConfigurationRequest",
            type: "structure",
            required: [
              "OfferingId"
            ],
            members: {
              InstanceCount: {
                type: "integer"
              },
              OfferingId: {}
            }
          }
        },
        So: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Sq: {
          type: "structure",
          members: {
            TransitGatewayMulticastDomainId: {
              locationName: "transitGatewayMulticastDomainId"
            },
            TransitGatewayAttachmentId: {
              locationName: "transitGatewayAttachmentId"
            },
            ResourceId: {
              locationName: "resourceId"
            },
            ResourceType: {
              locationName: "resourceType"
            },
            ResourceOwnerId: {
              locationName: "resourceOwnerId"
            },
            Subnets: {
              locationName: "subnets",
              type: "list",
              member: {
                shape: "St",
                locationName: "item"
              }
            }
          }
        },
        St: {
          type: "structure",
          members: {
            SubnetId: {
              locationName: "subnetId"
            },
            State: {
              locationName: "state"
            }
          }
        },
        Sx: {
          type: "structure",
          members: {
            TransitGatewayAttachmentId: {
              locationName: "transitGatewayAttachmentId"
            },
            AccepterTransitGatewayAttachmentId: {
              locationName: "accepterTransitGatewayAttachmentId"
            },
            RequesterTgwInfo: {
              shape: "Sy",
              locationName: "requesterTgwInfo"
            },
            AccepterTgwInfo: {
              shape: "Sy",
              locationName: "accepterTgwInfo"
            },
            Options: {
              locationName: "options",
              type: "structure",
              members: {
                DynamicRouting: {
                  locationName: "dynamicRouting"
                }
              }
            },
            Status: {
              locationName: "status",
              type: "structure",
              members: {
                Code: {
                  locationName: "code"
                },
                Message: {
                  locationName: "message"
                }
              }
            },
            State: {
              locationName: "state"
            },
            CreationTime: {
              locationName: "creationTime",
              type: "timestamp"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        Sy: {
          type: "structure",
          members: {
            TransitGatewayId: {
              locationName: "transitGatewayId"
            },
            CoreNetworkId: {
              locationName: "coreNetworkId"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            Region: {
              locationName: "region"
            }
          }
        },
        S16: {
          type: "structure",
          members: {
            TransitGatewayAttachmentId: {
              locationName: "transitGatewayAttachmentId"
            },
            TransitGatewayId: {
              locationName: "transitGatewayId"
            },
            VpcId: {
              locationName: "vpcId"
            },
            VpcOwnerId: {
              locationName: "vpcOwnerId"
            },
            State: {
              locationName: "state"
            },
            SubnetIds: {
              shape: "So",
              locationName: "subnetIds"
            },
            CreationTime: {
              locationName: "creationTime",
              type: "timestamp"
            },
            Options: {
              locationName: "options",
              type: "structure",
              members: {
                DnsSupport: {
                  locationName: "dnsSupport"
                },
                SecurityGroupReferencingSupport: {
                  locationName: "securityGroupReferencingSupport"
                },
                Ipv6Support: {
                  locationName: "ipv6Support"
                },
                ApplianceModeSupport: {
                  locationName: "applianceModeSupport"
                }
              }
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        S1e: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S1h: {
          type: "list",
          member: {
            shape: "S1i",
            locationName: "item"
          }
        },
        S1i: {
          type: "structure",
          members: {
            Error: {
              locationName: "error",
              type: "structure",
              members: {
                Code: {
                  locationName: "code"
                },
                Message: {
                  locationName: "message"
                }
              }
            },
            ResourceId: {
              locationName: "resourceId"
            }
          }
        },
        S1n: {
          type: "structure",
          members: {
            AccepterVpcInfo: {
              shape: "S1o",
              locationName: "accepterVpcInfo"
            },
            ExpirationTime: {
              locationName: "expirationTime",
              type: "timestamp"
            },
            RequesterVpcInfo: {
              shape: "S1o",
              locationName: "requesterVpcInfo"
            },
            Status: {
              locationName: "status",
              type: "structure",
              members: {
                Code: {
                  locationName: "code"
                },
                Message: {
                  locationName: "message"
                }
              }
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            },
            VpcPeeringConnectionId: {
              locationName: "vpcPeeringConnectionId"
            }
          }
        },
        S1o: {
          type: "structure",
          members: {
            CidrBlock: {
              locationName: "cidrBlock"
            },
            Ipv6CidrBlockSet: {
              locationName: "ipv6CidrBlockSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  Ipv6CidrBlock: {
                    locationName: "ipv6CidrBlock"
                  }
                }
              }
            },
            CidrBlockSet: {
              locationName: "cidrBlockSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  CidrBlock: {
                    locationName: "cidrBlock"
                  }
                }
              }
            },
            OwnerId: {
              locationName: "ownerId"
            },
            PeeringOptions: {
              locationName: "peeringOptions",
              type: "structure",
              members: {
                AllowDnsResolutionFromRemoteVpc: {
                  locationName: "allowDnsResolutionFromRemoteVpc",
                  type: "boolean"
                },
                AllowEgressFromLocalClassicLinkToRemoteVpc: {
                  locationName: "allowEgressFromLocalClassicLinkToRemoteVpc",
                  type: "boolean"
                },
                AllowEgressFromLocalVpcToRemoteClassicLink: {
                  locationName: "allowEgressFromLocalVpcToRemoteClassicLink",
                  type: "boolean"
                }
              }
            },
            VpcId: {
              locationName: "vpcId"
            },
            Region: {
              locationName: "region"
            }
          }
        },
        S1y: {
          type: "structure",
          members: {
            Cidr: {
              locationName: "cidr"
            },
            Description: {
              locationName: "description"
            },
            AsnAssociations: {
              locationName: "asnAssociationSet",
              type: "list",
              member: {
                shape: "S20",
                locationName: "item"
              }
            },
            StatusMessage: {
              locationName: "statusMessage"
            },
            State: {
              locationName: "state"
            },
            NetworkBorderGroup: {
              locationName: "networkBorderGroup"
            }
          }
        },
        S20: {
          type: "structure",
          members: {
            Asn: {
              locationName: "asn"
            },
            Cidr: {
              locationName: "cidr"
            },
            StatusMessage: {
              locationName: "statusMessage"
            },
            State: {
              locationName: "state"
            }
          }
        },
        S2f: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S2l: {
          type: "structure",
          members: {
            Cidr: {
              locationName: "cidr"
            },
            IpamPoolAllocationId: {
              locationName: "ipamPoolAllocationId"
            },
            Description: {
              locationName: "description"
            },
            ResourceId: {
              locationName: "resourceId"
            },
            ResourceType: {
              locationName: "resourceType"
            },
            ResourceRegion: {
              locationName: "resourceRegion"
            },
            ResourceOwner: {
              locationName: "resourceOwner"
            }
          }
        },
        S2r: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S2v: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S2w: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S30: {
          type: "list",
          member: {
            locationName: "PrivateIpAddress"
          }
        },
        S34: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Ipv4Prefix: {
                locationName: "ipv4Prefix"
              }
            }
          }
        },
        S38: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S3b: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              AllocationId: {
                locationName: "allocationId"
              },
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              },
              PrivateIp: {
                locationName: "privateIp"
              },
              PublicIp: {
                locationName: "publicIp"
              },
              AssociationId: {
                locationName: "associationId"
              },
              IsPrimary: {
                locationName: "isPrimary",
                type: "boolean"
              },
              FailureMessage: {
                locationName: "failureMessage"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        S3m: {
          type: "structure",
          members: {
            Code: {
              locationName: "code"
            },
            Message: {
              locationName: "message"
            }
          }
        },
        S3v: {
          type: "structure",
          members: {
            Arn: {
              locationName: "arn"
            },
            Name: {
              locationName: "name"
            }
          }
        },
        S3x: {
          type: "structure",
          members: {
            AssociationId: {
              locationName: "associationId"
            },
            InstanceId: {
              locationName: "instanceId"
            },
            IamInstanceProfile: {
              shape: "S3y",
              locationName: "iamInstanceProfile"
            },
            State: {
              locationName: "state"
            },
            Timestamp: {
              locationName: "timestamp",
              type: "timestamp"
            }
          }
        },
        S3y: {
          type: "structure",
          members: {
            Arn: {
              locationName: "arn"
            },
            Id: {
              locationName: "id"
            }
          }
        },
        S43: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S44: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S47: {
          type: "structure",
          members: {
            InstanceEventWindowId: {
              locationName: "instanceEventWindowId"
            },
            TimeRanges: {
              locationName: "timeRangeSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  StartWeekDay: {
                    locationName: "startWeekDay"
                  },
                  StartHour: {
                    locationName: "startHour",
                    type: "integer"
                  },
                  EndWeekDay: {
                    locationName: "endWeekDay"
                  },
                  EndHour: {
                    locationName: "endHour",
                    type: "integer"
                  }
                }
              }
            },
            Name: {
              locationName: "name"
            },
            CronExpression: {
              locationName: "cronExpression"
            },
            AssociationTarget: {
              locationName: "associationTarget",
              type: "structure",
              members: {
                InstanceIds: {
                  shape: "S43",
                  locationName: "instanceIdSet"
                },
                Tags: {
                  shape: "S6",
                  locationName: "tagSet"
                },
                DedicatedHostIds: {
                  shape: "S44",
                  locationName: "dedicatedHostIdSet"
                }
              }
            },
            State: {
              locationName: "state"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        S4l: {
          type: "structure",
          members: {
            OwnerId: {
              locationName: "ownerId"
            },
            IpamResourceDiscoveryAssociationId: {
              locationName: "ipamResourceDiscoveryAssociationId"
            },
            IpamResourceDiscoveryAssociationArn: {
              locationName: "ipamResourceDiscoveryAssociationArn"
            },
            IpamResourceDiscoveryId: {
              locationName: "ipamResourceDiscoveryId"
            },
            IpamId: {
              locationName: "ipamId"
            },
            IpamArn: {
              locationName: "ipamArn"
            },
            IpamRegion: {
              locationName: "ipamRegion"
            },
            IsDefault: {
              locationName: "isDefault",
              type: "boolean"
            },
            ResourceDiscoveryStatus: {
              locationName: "resourceDiscoveryStatus"
            },
            State: {
              locationName: "state"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        S4r: {
          type: "list",
          member: {
            locationName: "AllocationId"
          }
        },
        S4x: {
          type: "structure",
          members: {
            State: {
              locationName: "state"
            },
            StatusMessage: {
              locationName: "statusMessage"
            }
          }
        },
        S52: {
          type: "structure",
          members: {
            AssociationId: {
              locationName: "associationId"
            },
            Ipv6CidrBlock: {
              locationName: "ipv6CidrBlock"
            },
            Ipv6CidrBlockState: {
              locationName: "ipv6CidrBlockState",
              type: "structure",
              members: {
                State: {
                  locationName: "state"
                },
                StatusMessage: {
                  locationName: "statusMessage"
                }
              }
            }
          }
        },
        S57: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S5c: {
          type: "structure",
          members: {
            TransitGatewayPolicyTableId: {
              locationName: "transitGatewayPolicyTableId"
            },
            TransitGatewayAttachmentId: {
              locationName: "transitGatewayAttachmentId"
            },
            ResourceId: {
              locationName: "resourceId"
            },
            ResourceType: {
              locationName: "resourceType"
            },
            State: {
              locationName: "state"
            }
          }
        },
        S5h: {
          type: "structure",
          members: {
            TransitGatewayRouteTableId: {
              locationName: "transitGatewayRouteTableId"
            },
            TransitGatewayAttachmentId: {
              locationName: "transitGatewayAttachmentId"
            },
            ResourceId: {
              locationName: "resourceId"
            },
            ResourceType: {
              locationName: "resourceType"
            },
            State: {
              locationName: "state"
            }
          }
        },
        S5k: {
          type: "structure",
          members: {
            AssociationId: {
              locationName: "associationId"
            },
            BranchInterfaceId: {
              locationName: "branchInterfaceId"
            },
            TrunkInterfaceId: {
              locationName: "trunkInterfaceId"
            },
            InterfaceProtocol: {
              locationName: "interfaceProtocol"
            },
            VlanId: {
              locationName: "vlanId",
              type: "integer"
            },
            GreKey: {
              locationName: "greKey",
              type: "integer"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        S5q: {
          type: "structure",
          members: {
            AssociationId: {
              locationName: "associationId"
            },
            Ipv6CidrBlock: {
              locationName: "ipv6CidrBlock"
            },
            Ipv6CidrBlockState: {
              shape: "S5r",
              locationName: "ipv6CidrBlockState"
            },
            NetworkBorderGroup: {
              locationName: "networkBorderGroup"
            },
            Ipv6Pool: {
              locationName: "ipv6Pool"
            }
          }
        },
        S5r: {
          type: "structure",
          members: {
            State: {
              locationName: "state"
            },
            StatusMessage: {
              locationName: "statusMessage"
            }
          }
        },
        S5t: {
          type: "structure",
          members: {
            AssociationId: {
              locationName: "associationId"
            },
            CidrBlock: {
              locationName: "cidrBlock"
            },
            CidrBlockState: {
              shape: "S5r",
              locationName: "cidrBlockState"
            }
          }
        },
        S5v: {
          type: "list",
          member: {
            locationName: "groupId"
          }
        },
        S60: {
          type: "structure",
          members: {
            EnaSrdEnabled: {
              type: "boolean"
            },
            EnaSrdUdpSpecification: {
              type: "structure",
              members: {
                EnaSrdUdpEnabled: {
                  type: "boolean"
                }
              }
            }
          }
        },
        S67: {
          type: "structure",
          members: {
            VerifiedAccessTrustProviderId: {
              locationName: "verifiedAccessTrustProviderId"
            },
            Description: {
              locationName: "description"
            },
            TrustProviderType: {
              locationName: "trustProviderType"
            },
            UserTrustProviderType: {
              locationName: "userTrustProviderType"
            },
            DeviceTrustProviderType: {
              locationName: "deviceTrustProviderType"
            },
            OidcOptions: {
              locationName: "oidcOptions",
              type: "structure",
              members: {
                Issuer: {
                  locationName: "issuer"
                },
                AuthorizationEndpoint: {
                  locationName: "authorizationEndpoint"
                },
                TokenEndpoint: {
                  locationName: "tokenEndpoint"
                },
                UserInfoEndpoint: {
                  locationName: "userInfoEndpoint"
                },
                ClientId: {
                  locationName: "clientId"
                },
                ClientSecret: {
                  shape: "S6c",
                  locationName: "clientSecret"
                },
                Scope: {
                  locationName: "scope"
                }
              }
            },
            DeviceOptions: {
              locationName: "deviceOptions",
              type: "structure",
              members: {
                TenantId: {
                  locationName: "tenantId"
                },
                PublicSigningKeyUrl: {
                  locationName: "publicSigningKeyUrl"
                }
              }
            },
            PolicyReferenceName: {
              locationName: "policyReferenceName"
            },
            CreationTime: {
              locationName: "creationTime"
            },
            LastUpdatedTime: {
              locationName: "lastUpdatedTime"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            },
            SseSpecification: {
              shape: "S6e",
              locationName: "sseSpecification"
            }
          }
        },
        S6c: {
          type: "string",
          sensitive: true
        },
        S6e: {
          type: "structure",
          members: {
            CustomerManagedKeyEnabled: {
              locationName: "customerManagedKeyEnabled",
              type: "boolean"
            },
            KmsKeyArn: {
              locationName: "kmsKeyArn"
            }
          }
        },
        S6g: {
          type: "structure",
          members: {
            VerifiedAccessInstanceId: {
              locationName: "verifiedAccessInstanceId"
            },
            Description: {
              locationName: "description"
            },
            VerifiedAccessTrustProviders: {
              locationName: "verifiedAccessTrustProviderSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  VerifiedAccessTrustProviderId: {
                    locationName: "verifiedAccessTrustProviderId"
                  },
                  Description: {
                    locationName: "description"
                  },
                  TrustProviderType: {
                    locationName: "trustProviderType"
                  },
                  UserTrustProviderType: {
                    locationName: "userTrustProviderType"
                  },
                  DeviceTrustProviderType: {
                    locationName: "deviceTrustProviderType"
                  }
                }
              }
            },
            CreationTime: {
              locationName: "creationTime"
            },
            LastUpdatedTime: {
              locationName: "lastUpdatedTime"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            },
            FipsEnabled: {
              locationName: "fipsEnabled",
              type: "boolean"
            }
          }
        },
        S6l: {
          type: "structure",
          members: {
            AttachTime: {
              locationName: "attachTime",
              type: "timestamp"
            },
            Device: {
              locationName: "device"
            },
            InstanceId: {
              locationName: "instanceId"
            },
            State: {
              locationName: "status"
            },
            VolumeId: {
              locationName: "volumeId"
            },
            DeleteOnTermination: {
              locationName: "deleteOnTermination",
              type: "boolean"
            }
          }
        },
        S6q: {
          type: "structure",
          members: {
            State: {
              locationName: "state"
            },
            VpcId: {
              locationName: "vpcId"
            }
          }
        },
        S6u: {
          type: "structure",
          members: {
            Code: {
              locationName: "code"
            },
            Message: {
              locationName: "message"
            }
          }
        },
        S6x: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              FromPort: {
                locationName: "fromPort",
                type: "integer"
              },
              IpProtocol: {
                locationName: "ipProtocol"
              },
              IpRanges: {
                locationName: "ipRanges",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    CidrIp: {
                      locationName: "cidrIp"
                    },
                    Description: {
                      locationName: "description"
                    }
                  }
                }
              },
              Ipv6Ranges: {
                locationName: "ipv6Ranges",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    CidrIpv6: {
                      locationName: "cidrIpv6"
                    },
                    Description: {
                      locationName: "description"
                    }
                  }
                }
              },
              PrefixListIds: {
                locationName: "prefixListIds",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Description: {
                      locationName: "description"
                    },
                    PrefixListId: {
                      locationName: "prefixListId"
                    }
                  }
                }
              },
              ToPort: {
                locationName: "toPort",
                type: "integer"
              },
              UserIdGroupPairs: {
                locationName: "groups",
                type: "list",
                member: {
                  shape: "S76",
                  locationName: "item"
                }
              }
            }
          }
        },
        S76: {
          type: "structure",
          members: {
            Description: {
              locationName: "description"
            },
            GroupId: {
              locationName: "groupId"
            },
            GroupName: {
              locationName: "groupName"
            },
            PeeringStatus: {
              locationName: "peeringStatus"
            },
            UserId: {
              locationName: "userId"
            },
            VpcId: {
              locationName: "vpcId"
            },
            VpcPeeringConnectionId: {
              locationName: "vpcPeeringConnectionId"
            }
          }
        },
        S78: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              SecurityGroupRuleId: {
                locationName: "securityGroupRuleId"
              },
              GroupId: {
                locationName: "groupId"
              },
              GroupOwnerId: {
                locationName: "groupOwnerId"
              },
              IsEgress: {
                locationName: "isEgress",
                type: "boolean"
              },
              IpProtocol: {
                locationName: "ipProtocol"
              },
              FromPort: {
                locationName: "fromPort",
                type: "integer"
              },
              ToPort: {
                locationName: "toPort",
                type: "integer"
              },
              CidrIpv4: {
                locationName: "cidrIpv4"
              },
              CidrIpv6: {
                locationName: "cidrIpv6"
              },
              PrefixListId: {
                locationName: "prefixListId"
              },
              ReferencedGroupInfo: {
                locationName: "referencedGroupInfo",
                type: "structure",
                members: {
                  GroupId: {
                    locationName: "groupId"
                  },
                  PeeringStatus: {
                    locationName: "peeringStatus"
                  },
                  UserId: {
                    locationName: "userId"
                  },
                  VpcId: {
                    locationName: "vpcId"
                  },
                  VpcPeeringConnectionId: {
                    locationName: "vpcPeeringConnectionId"
                  }
                }
              },
              Description: {
                locationName: "description"
              },
              Tags: {
                shape: "S6",
                locationName: "tagSet"
              }
            }
          }
        },
        S7h: {
          type: "structure",
          members: {
            S3: {
              type: "structure",
              members: {
                AWSAccessKeyId: {},
                Bucket: {
                  locationName: "bucket"
                },
                Prefix: {
                  locationName: "prefix"
                },
                UploadPolicy: {
                  locationName: "uploadPolicy",
                  type: "blob"
                },
                UploadPolicySignature: {
                  locationName: "uploadPolicySignature",
                  type: "string",
                  sensitive: true
                }
              }
            }
          }
        },
        S7m: {
          type: "structure",
          members: {
            BundleId: {
              locationName: "bundleId"
            },
            BundleTaskError: {
              locationName: "error",
              type: "structure",
              members: {
                Code: {
                  locationName: "code"
                },
                Message: {
                  locationName: "message"
                }
              }
            },
            InstanceId: {
              locationName: "instanceId"
            },
            Progress: {
              locationName: "progress"
            },
            StartTime: {
              locationName: "startTime",
              type: "timestamp"
            },
            State: {
              locationName: "state"
            },
            Storage: {
              shape: "S7h",
              locationName: "storage"
            },
            UpdateTime: {
              locationName: "updateTime",
              type: "timestamp"
            }
          }
        },
        S7w: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S8k: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              ClientToken: {
                locationName: "clientToken"
              },
              CreateDate: {
                locationName: "createDate",
                type: "timestamp"
              },
              InstanceCounts: {
                locationName: "instanceCounts",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    InstanceCount: {
                      locationName: "instanceCount",
                      type: "integer"
                    },
                    State: {
                      locationName: "state"
                    }
                  }
                }
              },
              PriceSchedules: {
                locationName: "priceSchedules",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Active: {
                      locationName: "active",
                      type: "boolean"
                    },
                    CurrencyCode: {
                      locationName: "currencyCode"
                    },
                    Price: {
                      locationName: "price",
                      type: "double"
                    },
                    Term: {
                      locationName: "term",
                      type: "long"
                    }
                  }
                }
              },
              ReservedInstancesId: {
                locationName: "reservedInstancesId"
              },
              ReservedInstancesListingId: {
                locationName: "reservedInstancesListingId"
              },
              Status: {
                locationName: "status"
              },
              StatusMessage: {
                locationName: "statusMessage"
              },
              Tags: {
                shape: "S6",
                locationName: "tagSet"
              },
              UpdateDate: {
                locationName: "updateDate",
                type: "timestamp"
              }
            }
          }
        },
        S8w: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S97: {
          type: "list",
          member: {
            locationName: "SpotInstanceRequestId"
          }
        },
        S9x: {
          type: "structure",
          members: {
            CapacityReservationId: {
              locationName: "capacityReservationId"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            CapacityReservationArn: {
              locationName: "capacityReservationArn"
            },
            AvailabilityZoneId: {
              locationName: "availabilityZoneId"
            },
            InstanceType: {
              locationName: "instanceType"
            },
            InstancePlatform: {
              locationName: "instancePlatform"
            },
            AvailabilityZone: {
              locationName: "availabilityZone"
            },
            Tenancy: {
              locationName: "tenancy"
            },
            TotalInstanceCount: {
              locationName: "totalInstanceCount",
              type: "integer"
            },
            AvailableInstanceCount: {
              locationName: "availableInstanceCount",
              type: "integer"
            },
            EbsOptimized: {
              locationName: "ebsOptimized",
              type: "boolean"
            },
            EphemeralStorage: {
              locationName: "ephemeralStorage",
              type: "boolean"
            },
            State: {
              locationName: "state"
            },
            StartDate: {
              locationName: "startDate",
              type: "timestamp"
            },
            EndDate: {
              locationName: "endDate",
              type: "timestamp"
            },
            EndDateType: {
              locationName: "endDateType"
            },
            InstanceMatchCriteria: {
              locationName: "instanceMatchCriteria"
            },
            CreateDate: {
              locationName: "createDate",
              type: "timestamp"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            },
            OutpostArn: {
              locationName: "outpostArn"
            },
            CapacityReservationFleetId: {
              locationName: "capacityReservationFleetId"
            },
            PlacementGroupArn: {
              locationName: "placementGroupArn"
            },
            CapacityAllocations: {
              locationName: "capacityAllocationSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  AllocationType: {
                    locationName: "allocationType"
                  },
                  Count: {
                    locationName: "count",
                    type: "integer"
                  }
                }
              }
            },
            ReservationType: {
              locationName: "reservationType"
            }
          }
        },
        Sac: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              CapacityReservationId: {
                locationName: "capacityReservationId"
              },
              AvailabilityZoneId: {
                locationName: "availabilityZoneId"
              },
              InstanceType: {
                locationName: "instanceType"
              },
              InstancePlatform: {
                locationName: "instancePlatform"
              },
              AvailabilityZone: {
                locationName: "availabilityZone"
              },
              TotalInstanceCount: {
                locationName: "totalInstanceCount",
                type: "integer"
              },
              FulfilledCapacity: {
                locationName: "fulfilledCapacity",
                type: "double"
              },
              EbsOptimized: {
                locationName: "ebsOptimized",
                type: "boolean"
              },
              CreateDate: {
                locationName: "createDate",
                type: "timestamp"
              },
              Weight: {
                locationName: "weight",
                type: "double"
              },
              Priority: {
                locationName: "priority",
                type: "integer"
              }
            }
          }
        },
        Sag: {
          type: "structure",
          members: {
            CarrierGatewayId: {
              locationName: "carrierGatewayId"
            },
            VpcId: {
              locationName: "vpcId"
            },
            State: {
              locationName: "state"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        Saq: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            CloudwatchLogGroup: {},
            CloudwatchLogStream: {}
          }
        },
        Sat: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            LambdaFunctionArn: {}
          }
        },
        Sau: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            BannerText: {}
          }
        },
        Saw: {
          type: "structure",
          members: {
            Code: {
              locationName: "code"
            },
            Message: {
              locationName: "message"
            }
          }
        },
        Sb0: {
          type: "structure",
          members: {
            Code: {
              locationName: "code"
            },
            Message: {
              locationName: "message"
            }
          }
        },
        Sb5: {
          type: "structure",
          members: {
            Cidr: {
              locationName: "cidr"
            },
            CoipPoolId: {
              locationName: "coipPoolId"
            },
            LocalGatewayRouteTableId: {
              locationName: "localGatewayRouteTableId"
            }
          }
        },
        Sb9: {
          type: "structure",
          members: {
            PoolId: {
              locationName: "poolId"
            },
            PoolCidrs: {
              shape: "So",
              locationName: "poolCidrSet"
            },
            LocalGatewayRouteTableId: {
              locationName: "localGatewayRouteTableId"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            },
            PoolArn: {
              locationName: "poolArn"
            }
          }
        },
        Sbd: {
          type: "structure",
          members: {
            BgpAsn: {
              locationName: "bgpAsn"
            },
            CustomerGatewayId: {
              locationName: "customerGatewayId"
            },
            IpAddress: {
              locationName: "ipAddress"
            },
            CertificateArn: {
              locationName: "certificateArn"
            },
            State: {
              locationName: "state"
            },
            Type: {
              locationName: "type"
            },
            DeviceName: {
              locationName: "deviceName"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        Sbg: {
          type: "structure",
          members: {
            AvailabilityZone: {
              locationName: "availabilityZone"
            },
            AvailabilityZoneId: {
              locationName: "availabilityZoneId"
            },
            AvailableIpAddressCount: {
              locationName: "availableIpAddressCount",
              type: "integer"
            },
            CidrBlock: {
              locationName: "cidrBlock"
            },
            DefaultForAz: {
              locationName: "defaultForAz",
              type: "boolean"
            },
            EnableLniAtDeviceIndex: {
              locationName: "enableLniAtDeviceIndex",
              type: "integer"
            },
            MapPublicIpOnLaunch: {
              locationName: "mapPublicIpOnLaunch",
              type: "boolean"
            },
            MapCustomerOwnedIpOnLaunch: {
              locationName: "mapCustomerOwnedIpOnLaunch",
              type: "boolean"
            },
            CustomerOwnedIpv4Pool: {
              locationName: "customerOwnedIpv4Pool"
            },
            State: {
              locationName: "state"
            },
            SubnetId: {
              locationName: "subnetId"
            },
            VpcId: {
              locationName: "vpcId"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            AssignIpv6AddressOnCreation: {
              locationName: "assignIpv6AddressOnCreation",
              type: "boolean"
            },
            Ipv6CidrBlockAssociationSet: {
              locationName: "ipv6CidrBlockAssociationSet",
              type: "list",
              member: {
                shape: "S52",
                locationName: "item"
              }
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            },
            SubnetArn: {
              locationName: "subnetArn"
            },
            OutpostArn: {
              locationName: "outpostArn"
            },
            EnableDns64: {
              locationName: "enableDns64",
              type: "boolean"
            },
            Ipv6Native: {
              locationName: "ipv6Native",
              type: "boolean"
            },
            PrivateDnsNameOptionsOnLaunch: {
              locationName: "privateDnsNameOptionsOnLaunch",
              type: "structure",
              members: {
                HostnameType: {
                  locationName: "hostnameType"
                },
                EnableResourceNameDnsARecord: {
                  locationName: "enableResourceNameDnsARecord",
                  type: "boolean"
                },
                EnableResourceNameDnsAAAARecord: {
                  locationName: "enableResourceNameDnsAAAARecord",
                  type: "boolean"
                }
              }
            }
          }
        },
        Sbo: {
          type: "structure",
          members: {
            CidrBlock: {
              locationName: "cidrBlock"
            },
            DhcpOptionsId: {
              locationName: "dhcpOptionsId"
            },
            State: {
              locationName: "state"
            },
            VpcId: {
              locationName: "vpcId"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            InstanceTenancy: {
              locationName: "instanceTenancy"
            },
            Ipv6CidrBlockAssociationSet: {
              locationName: "ipv6CidrBlockAssociationSet",
              type: "list",
              member: {
                shape: "S5q",
                locationName: "item"
              }
            },
            CidrBlockAssociationSet: {
              locationName: "cidrBlockAssociationSet",
              type: "list",
              member: {
                shape: "S5t",
                locationName: "item"
              }
            },
            IsDefault: {
              locationName: "isDefault",
              type: "boolean"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        Sbx: {
          type: "structure",
          members: {
            DhcpConfigurations: {
              locationName: "dhcpConfigurationSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  Key: {
                    locationName: "key"
                  },
                  Values: {
                    locationName: "valueSet",
                    type: "list",
                    member: {
                      shape: "Sc1",
                      locationName: "item"
                    }
                  }
                }
              }
            },
            DhcpOptionsId: {
              locationName: "dhcpOptionsId"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        Sc1: {
          type: "structure",
          members: {
            Value: {
              locationName: "value"
            }
          }
        },
        Sc4: {
          type: "structure",
          members: {
            Attachments: {
              shape: "Sc5",
              locationName: "attachmentSet"
            },
            EgressOnlyInternetGatewayId: {
              locationName: "egressOnlyInternetGatewayId"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        Sc5: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              State: {
                locationName: "state"
              },
              VpcId: {
                locationName: "vpcId"
              }
            }
          }
        },
        Sck: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              LaunchTemplateSpecification: {
                type: "structure",
                members: {
                  LaunchTemplateId: {},
                  LaunchTemplateName: {},
                  Version: {}
                }
              },
              Overrides: {
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    InstanceType: {},
                    MaxPrice: {},
                    SubnetId: {},
                    AvailabilityZone: {},
                    WeightedCapacity: {
                      type: "double"
                    },
                    Priority: {
                      type: "double"
                    },
                    Placement: {
                      shape: "Scr"
                    },
                    InstanceRequirements: {
                      shape: "Scu"
                    },
                    ImageId: {}
                  }
                }
              }
            }
          }
        },
        Scr: {
          type: "structure",
          members: {
            AvailabilityZone: {
              locationName: "availabilityZone"
            },
            Affinity: {
              locationName: "affinity"
            },
            GroupName: {
              locationName: "groupName"
            },
            PartitionNumber: {
              locationName: "partitionNumber",
              type: "integer"
            },
            HostId: {
              locationName: "hostId"
            },
            Tenancy: {
              locationName: "tenancy"
            },
            SpreadDomain: {
              locationName: "spreadDomain"
            },
            HostResourceGroupArn: {
              locationName: "hostResourceGroupArn"
            },
            GroupId: {
              locationName: "groupId"
            }
          }
        },
        Scu: {
          type: "structure",
          required: [
            "VCpuCount",
            "MemoryMiB"
          ],
          members: {
            VCpuCount: {
              type: "structure",
              required: [
                "Min"
              ],
              members: {
                Min: {
                  type: "integer"
                },
                Max: {
                  type: "integer"
                }
              }
            },
            MemoryMiB: {
              type: "structure",
              required: [
                "Min"
              ],
              members: {
                Min: {
                  type: "integer"
                },
                Max: {
                  type: "integer"
                }
              }
            },
            CpuManufacturers: {
              shape: "Scx",
              locationName: "CpuManufacturer"
            },
            MemoryGiBPerVCpu: {
              type: "structure",
              members: {
                Min: {
                  type: "double"
                },
                Max: {
                  type: "double"
                }
              }
            },
            ExcludedInstanceTypes: {
              shape: "Sd0",
              locationName: "ExcludedInstanceType"
            },
            InstanceGenerations: {
              shape: "Sd2",
              locationName: "InstanceGeneration"
            },
            SpotMaxPricePercentageOverLowestPrice: {
              type: "integer"
            },
            OnDemandMaxPricePercentageOverLowestPrice: {
              type: "integer"
            },
            BareMetal: {},
            BurstablePerformance: {},
            RequireHibernateSupport: {
              type: "boolean"
            },
            NetworkInterfaceCount: {
              type: "structure",
              members: {
                Min: {
                  type: "integer"
                },
                Max: {
                  type: "integer"
                }
              }
            },
            LocalStorage: {},
            LocalStorageTypes: {
              shape: "Sd8",
              locationName: "LocalStorageType"
            },
            TotalLocalStorageGB: {
              type: "structure",
              members: {
                Min: {
                  type: "double"
                },
                Max: {
                  type: "double"
                }
              }
            },
            BaselineEbsBandwidthMbps: {
              type: "structure",
              members: {
                Min: {
                  type: "integer"
                },
                Max: {
                  type: "integer"
                }
              }
            },
            AcceleratorTypes: {
              shape: "Sdc",
              locationName: "AcceleratorType"
            },
            AcceleratorCount: {
              type: "structure",
              members: {
                Min: {
                  type: "integer"
                },
                Max: {
                  type: "integer"
                }
              }
            },
            AcceleratorManufacturers: {
              shape: "Sdf",
              locationName: "AcceleratorManufacturer"
            },
            AcceleratorNames: {
              shape: "Sdh",
              locationName: "AcceleratorName"
            },
            AcceleratorTotalMemoryMiB: {
              type: "structure",
              members: {
                Min: {
                  type: "integer"
                },
                Max: {
                  type: "integer"
                }
              }
            },
            NetworkBandwidthGbps: {
              type: "structure",
              members: {
                Min: {
                  type: "double"
                },
                Max: {
                  type: "double"
                }
              }
            },
            AllowedInstanceTypes: {
              shape: "Sdl",
              locationName: "AllowedInstanceType"
            }
          }
        },
        Scx: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Sd0: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Sd2: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Sd8: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Sdc: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Sdf: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Sdh: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Sdl: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Sdn: {
          type: "structure",
          required: [
            "TotalTargetCapacity"
          ],
          members: {
            TotalTargetCapacity: {
              type: "integer"
            },
            OnDemandTargetCapacity: {
              type: "integer"
            },
            SpotTargetCapacity: {
              type: "integer"
            },
            DefaultTargetCapacityType: {},
            TargetCapacityUnitType: {}
          }
        },
        Sdv: {
          type: "structure",
          members: {
            LaunchTemplateSpecification: {
              shape: "Sdw",
              locationName: "launchTemplateSpecification"
            },
            Overrides: {
              shape: "Sdx",
              locationName: "overrides"
            }
          }
        },
        Sdw: {
          type: "structure",
          members: {
            LaunchTemplateId: {
              locationName: "launchTemplateId"
            },
            LaunchTemplateName: {
              locationName: "launchTemplateName"
            },
            Version: {
              locationName: "version"
            }
          }
        },
        Sdx: {
          type: "structure",
          members: {
            InstanceType: {
              locationName: "instanceType"
            },
            MaxPrice: {
              locationName: "maxPrice"
            },
            SubnetId: {
              locationName: "subnetId"
            },
            AvailabilityZone: {
              locationName: "availabilityZone"
            },
            WeightedCapacity: {
              locationName: "weightedCapacity",
              type: "double"
            },
            Priority: {
              locationName: "priority",
              type: "double"
            },
            Placement: {
              locationName: "placement",
              type: "structure",
              members: {
                GroupName: {
                  locationName: "groupName"
                }
              }
            },
            InstanceRequirements: {
              shape: "Sdz",
              locationName: "instanceRequirements"
            },
            ImageId: {
              locationName: "imageId"
            }
          }
        },
        Sdz: {
          type: "structure",
          members: {
            VCpuCount: {
              locationName: "vCpuCount",
              type: "structure",
              members: {
                Min: {
                  locationName: "min",
                  type: "integer"
                },
                Max: {
                  locationName: "max",
                  type: "integer"
                }
              }
            },
            MemoryMiB: {
              locationName: "memoryMiB",
              type: "structure",
              members: {
                Min: {
                  locationName: "min",
                  type: "integer"
                },
                Max: {
                  locationName: "max",
                  type: "integer"
                }
              }
            },
            CpuManufacturers: {
              shape: "Scx",
              locationName: "cpuManufacturerSet"
            },
            MemoryGiBPerVCpu: {
              locationName: "memoryGiBPerVCpu",
              type: "structure",
              members: {
                Min: {
                  locationName: "min",
                  type: "double"
                },
                Max: {
                  locationName: "max",
                  type: "double"
                }
              }
            },
            ExcludedInstanceTypes: {
              shape: "Sd0",
              locationName: "excludedInstanceTypeSet"
            },
            InstanceGenerations: {
              shape: "Sd2",
              locationName: "instanceGenerationSet"
            },
            SpotMaxPricePercentageOverLowestPrice: {
              locationName: "spotMaxPricePercentageOverLowestPrice",
              type: "integer"
            },
            OnDemandMaxPricePercentageOverLowestPrice: {
              locationName: "onDemandMaxPricePercentageOverLowestPrice",
              type: "integer"
            },
            BareMetal: {
              locationName: "bareMetal"
            },
            BurstablePerformance: {
              locationName: "burstablePerformance"
            },
            RequireHibernateSupport: {
              locationName: "requireHibernateSupport",
              type: "boolean"
            },
            NetworkInterfaceCount: {
              locationName: "networkInterfaceCount",
              type: "structure",
              members: {
                Min: {
                  locationName: "min",
                  type: "integer"
                },
                Max: {
                  locationName: "max",
                  type: "integer"
                }
              }
            },
            LocalStorage: {
              locationName: "localStorage"
            },
            LocalStorageTypes: {
              shape: "Sd8",
              locationName: "localStorageTypeSet"
            },
            TotalLocalStorageGB: {
              locationName: "totalLocalStorageGB",
              type: "structure",
              members: {
                Min: {
                  locationName: "min",
                  type: "double"
                },
                Max: {
                  locationName: "max",
                  type: "double"
                }
              }
            },
            BaselineEbsBandwidthMbps: {
              locationName: "baselineEbsBandwidthMbps",
              type: "structure",
              members: {
                Min: {
                  locationName: "min",
                  type: "integer"
                },
                Max: {
                  locationName: "max",
                  type: "integer"
                }
              }
            },
            AcceleratorTypes: {
              shape: "Sdc",
              locationName: "acceleratorTypeSet"
            },
            AcceleratorCount: {
              locationName: "acceleratorCount",
              type: "structure",
              members: {
                Min: {
                  locationName: "min",
                  type: "integer"
                },
                Max: {
                  locationName: "max",
                  type: "integer"
                }
              }
            },
            AcceleratorManufacturers: {
              shape: "Sdf",
              locationName: "acceleratorManufacturerSet"
            },
            AcceleratorNames: {
              shape: "Sdh",
              locationName: "acceleratorNameSet"
            },
            AcceleratorTotalMemoryMiB: {
              locationName: "acceleratorTotalMemoryMiB",
              type: "structure",
              members: {
                Min: {
                  locationName: "min",
                  type: "integer"
                },
                Max: {
                  locationName: "max",
                  type: "integer"
                }
              }
            },
            NetworkBandwidthGbps: {
              locationName: "networkBandwidthGbps",
              type: "structure",
              members: {
                Min: {
                  locationName: "min",
                  type: "double"
                },
                Max: {
                  locationName: "max",
                  type: "double"
                }
              }
            },
            AllowedInstanceTypes: {
              shape: "Sdl",
              locationName: "allowedInstanceTypeSet"
            }
          }
        },
        Sec: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Seo: {
          type: "structure",
          members: {
            Bucket: {},
            Key: {}
          }
        },
        Ser: {
          type: "list",
          member: {
            shape: "Ses",
            locationName: "BlockDeviceMapping"
          }
        },
        Ses: {
          type: "structure",
          members: {
            DeviceName: {
              locationName: "deviceName"
            },
            VirtualName: {
              locationName: "virtualName"
            },
            Ebs: {
              locationName: "ebs",
              type: "structure",
              members: {
                DeleteOnTermination: {
                  locationName: "deleteOnTermination",
                  type: "boolean"
                },
                Iops: {
                  locationName: "iops",
                  type: "integer"
                },
                SnapshotId: {
                  locationName: "snapshotId"
                },
                VolumeSize: {
                  locationName: "volumeSize",
                  type: "integer"
                },
                VolumeType: {
                  locationName: "volumeType"
                },
                KmsKeyId: {
                  locationName: "kmsKeyId"
                },
                Throughput: {
                  locationName: "throughput",
                  type: "integer"
                },
                OutpostArn: {
                  locationName: "outpostArn"
                },
                Encrypted: {
                  locationName: "encrypted",
                  type: "boolean"
                }
              }
            },
            NoDevice: {
              locationName: "noDevice"
            }
          }
        },
        Sf0: {
          type: "structure",
          members: {
            OwnerId: {
              locationName: "ownerId"
            },
            InstanceConnectEndpointId: {
              locationName: "instanceConnectEndpointId"
            },
            InstanceConnectEndpointArn: {
              locationName: "instanceConnectEndpointArn"
            },
            State: {
              locationName: "state"
            },
            StateMessage: {
              locationName: "stateMessage"
            },
            DnsName: {
              locationName: "dnsName"
            },
            FipsDnsName: {
              locationName: "fipsDnsName"
            },
            NetworkInterfaceIds: {
              locationName: "networkInterfaceIdSet",
              type: "list",
              member: {
                locationName: "item"
              }
            },
            VpcId: {
              locationName: "vpcId"
            },
            AvailabilityZone: {
              locationName: "availabilityZone"
            },
            CreatedAt: {
              locationName: "createdAt",
              type: "timestamp"
            },
            SubnetId: {
              locationName: "subnetId"
            },
            PreserveClientIp: {
              locationName: "preserveClientIp",
              type: "boolean"
            },
            SecurityGroupIds: {
              locationName: "securityGroupIdSet",
              type: "list",
              member: {
                locationName: "item"
              }
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        Sf6: {
          type: "list",
          member: {
            type: "structure",
            members: {
              StartWeekDay: {},
              StartHour: {
                type: "integer"
              },
              EndWeekDay: {},
              EndHour: {
                type: "integer"
              }
            }
          }
        },
        Sff: {
          type: "structure",
          members: {
            Description: {
              locationName: "description"
            },
            ExportTaskId: {
              locationName: "exportTaskId"
            },
            ExportToS3Task: {
              locationName: "exportToS3",
              type: "structure",
              members: {
                ContainerFormat: {
                  locationName: "containerFormat"
                },
                DiskImageFormat: {
                  locationName: "diskImageFormat"
                },
                S3Bucket: {
                  locationName: "s3Bucket"
                },
                S3Key: {
                  locationName: "s3Key"
                }
              }
            },
            InstanceExportDetails: {
              locationName: "instanceExport",
              type: "structure",
              members: {
                InstanceId: {
                  locationName: "instanceId"
                },
                TargetEnvironment: {
                  locationName: "targetEnvironment"
                }
              }
            },
            State: {
              locationName: "state"
            },
            StatusMessage: {
              locationName: "statusMessage"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        Sfl: {
          type: "structure",
          members: {
            Attachments: {
              shape: "Sc5",
              locationName: "attachmentSet"
            },
            InternetGatewayId: {
              locationName: "internetGatewayId"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        Sfn: {
          type: "list",
          member: {
            type: "structure",
            members: {
              RegionName: {}
            }
          }
        },
        Sfr: {
          type: "structure",
          members: {
            OwnerId: {
              locationName: "ownerId"
            },
            IpamId: {
              locationName: "ipamId"
            },
            IpamArn: {
              locationName: "ipamArn"
            },
            IpamRegion: {
              locationName: "ipamRegion"
            },
            PublicDefaultScopeId: {
              locationName: "publicDefaultScopeId"
            },
            PrivateDefaultScopeId: {
              locationName: "privateDefaultScopeId"
            },
            ScopeCount: {
              locationName: "scopeCount",
              type: "integer"
            },
            Description: {
              locationName: "description"
            },
            OperatingRegions: {
              shape: "Sft",
              locationName: "operatingRegionSet"
            },
            State: {
              locationName: "state"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            },
            DefaultResourceDiscoveryId: {
              locationName: "defaultResourceDiscoveryId"
            },
            DefaultResourceDiscoveryAssociationId: {
              locationName: "defaultResourceDiscoveryAssociationId"
            },
            ResourceDiscoveryAssociationCount: {
              locationName: "resourceDiscoveryAssociationCount",
              type: "integer"
            },
            StateMessage: {
              locationName: "stateMessage"
            },
            Tier: {
              locationName: "tier"
            }
          }
        },
        Sft: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              RegionName: {
                locationName: "regionName"
              }
            }
          }
        },
        Sfz: {
          type: "list",
          member: {
            shape: "Sg0",
            locationName: "item"
          }
        },
        Sg0: {
          type: "structure",
          members: {
            Key: {},
            Value: {}
          }
        },
        Sg6: {
          type: "structure",
          members: {
            OwnerId: {
              locationName: "ownerId"
            },
            IpamPoolId: {
              locationName: "ipamPoolId"
            },
            SourceIpamPoolId: {
              locationName: "sourceIpamPoolId"
            },
            IpamPoolArn: {
              locationName: "ipamPoolArn"
            },
            IpamScopeArn: {
              locationName: "ipamScopeArn"
            },
            IpamScopeType: {
              locationName: "ipamScopeType"
            },
            IpamArn: {
              locationName: "ipamArn"
            },
            IpamRegion: {
              locationName: "ipamRegion"
            },
            Locale: {
              locationName: "locale"
            },
            PoolDepth: {
              locationName: "poolDepth",
              type: "integer"
            },
            State: {
              locationName: "state"
            },
            StateMessage: {
              locationName: "stateMessage"
            },
            Description: {
              locationName: "description"
            },
            AutoImport: {
              locationName: "autoImport",
              type: "boolean"
            },
            PubliclyAdvertisable: {
              locationName: "publiclyAdvertisable",
              type: "boolean"
            },
            AddressFamily: {
              locationName: "addressFamily"
            },
            AllocationMinNetmaskLength: {
              locationName: "allocationMinNetmaskLength",
              type: "integer"
            },
            AllocationMaxNetmaskLength: {
              locationName: "allocationMaxNetmaskLength",
              type: "integer"
            },
            AllocationDefaultNetmaskLength: {
              locationName: "allocationDefaultNetmaskLength",
              type: "integer"
            },
            AllocationResourceTags: {
              shape: "Sg9",
              locationName: "allocationResourceTagSet"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            },
            AwsService: {
              locationName: "awsService"
            },
            PublicIpSource: {
              locationName: "publicIpSource"
            },
            SourceResource: {
              locationName: "sourceResource",
              type: "structure",
              members: {
                ResourceId: {
                  locationName: "resourceId"
                },
                ResourceType: {
                  locationName: "resourceType"
                },
                ResourceRegion: {
                  locationName: "resourceRegion"
                },
                ResourceOwner: {
                  locationName: "resourceOwner"
                }
              }
            }
          }
        },
        Sg9: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Key: {
                locationName: "key"
              },
              Value: {
                locationName: "value"
              }
            }
          }
        },
        Sge: {
          type: "structure",
          members: {
            OwnerId: {
              locationName: "ownerId"
            },
            IpamResourceDiscoveryId: {
              locationName: "ipamResourceDiscoveryId"
            },
            IpamResourceDiscoveryArn: {
              locationName: "ipamResourceDiscoveryArn"
            },
            IpamResourceDiscoveryRegion: {
              locationName: "ipamResourceDiscoveryRegion"
            },
            Description: {
              locationName: "description"
            },
            OperatingRegions: {
              shape: "Sft",
              locationName: "operatingRegionSet"
            },
            IsDefault: {
              locationName: "isDefault",
              type: "boolean"
            },
            State: {
              locationName: "state"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        Sgi: {
          type: "structure",
          members: {
            OwnerId: {
              locationName: "ownerId"
            },
            IpamScopeId: {
              locationName: "ipamScopeId"
            },
            IpamScopeArn: {
              locationName: "ipamScopeArn"
            },
            IpamArn: {
              locationName: "ipamArn"
            },
            IpamRegion: {
              locationName: "ipamRegion"
            },
            IpamScopeType: {
              locationName: "ipamScopeType"
            },
            IsDefault: {
              locationName: "isDefault",
              type: "boolean"
            },
            Description: {
              locationName: "description"
            },
            PoolCount: {
              locationName: "poolCount",
              type: "integer"
            },
            State: {
              locationName: "state"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        Sgo: {
          type: "string",
          sensitive: true
        },
        Sgr: {
          type: "structure",
          members: {
            KernelId: {},
            EbsOptimized: {
              type: "boolean"
            },
            IamInstanceProfile: {
              type: "structure",
              members: {
                Arn: {},
                Name: {}
              }
            },
            BlockDeviceMappings: {
              locationName: "BlockDeviceMapping",
              type: "list",
              member: {
                locationName: "BlockDeviceMapping",
                type: "structure",
                members: {
                  DeviceName: {},
                  VirtualName: {},
                  Ebs: {
                    type: "structure",
                    members: {
                      Encrypted: {
                        type: "boolean"
                      },
                      DeleteOnTermination: {
                        type: "boolean"
                      },
                      Iops: {
                        type: "integer"
                      },
                      KmsKeyId: {},
                      SnapshotId: {},
                      VolumeSize: {
                        type: "integer"
                      },
                      VolumeType: {},
                      Throughput: {
                        type: "integer"
                      }
                    }
                  },
                  NoDevice: {}
                }
              }
            },
            NetworkInterfaces: {
              locationName: "NetworkInterface",
              type: "list",
              member: {
                locationName: "InstanceNetworkInterfaceSpecification",
                type: "structure",
                members: {
                  AssociateCarrierIpAddress: {
                    type: "boolean"
                  },
                  AssociatePublicIpAddress: {
                    type: "boolean"
                  },
                  DeleteOnTermination: {
                    type: "boolean"
                  },
                  Description: {},
                  DeviceIndex: {
                    type: "integer"
                  },
                  Groups: {
                    shape: "Sgz",
                    locationName: "SecurityGroupId"
                  },
                  InterfaceType: {},
                  Ipv6AddressCount: {
                    type: "integer"
                  },
                  Ipv6Addresses: {
                    type: "list",
                    member: {
                      locationName: "InstanceIpv6Address",
                      type: "structure",
                      members: {
                        Ipv6Address: {}
                      }
                    }
                  },
                  NetworkInterfaceId: {},
                  PrivateIpAddress: {},
                  PrivateIpAddresses: {
                    shape: "Sh2"
                  },
                  SecondaryPrivateIpAddressCount: {
                    type: "integer"
                  },
                  SubnetId: {},
                  NetworkCardIndex: {
                    type: "integer"
                  },
                  Ipv4Prefixes: {
                    shape: "Sh4",
                    locationName: "Ipv4Prefix"
                  },
                  Ipv4PrefixCount: {
                    type: "integer"
                  },
                  Ipv6Prefixes: {
                    shape: "Sh6",
                    locationName: "Ipv6Prefix"
                  },
                  Ipv6PrefixCount: {
                    type: "integer"
                  },
                  PrimaryIpv6: {
                    type: "boolean"
                  },
                  EnaSrdSpecification: {
                    shape: "Sh8"
                  },
                  ConnectionTrackingSpecification: {
                    shape: "Sha"
                  }
                }
              }
            },
            ImageId: {},
            InstanceType: {},
            KeyName: {},
            Monitoring: {
              type: "structure",
              members: {
                Enabled: {
                  type: "boolean"
                }
              }
            },
            Placement: {
              type: "structure",
              members: {
                AvailabilityZone: {},
                Affinity: {},
                GroupName: {},
                HostId: {},
                Tenancy: {},
                SpreadDomain: {},
                HostResourceGroupArn: {},
                PartitionNumber: {
                  type: "integer"
                },
                GroupId: {}
              }
            },
            RamDiskId: {},
            DisableApiTermination: {
              type: "boolean"
            },
            InstanceInitiatedShutdownBehavior: {},
            UserData: {
              shape: "Sgo"
            },
            TagSpecifications: {
              locationName: "TagSpecification",
              type: "list",
              member: {
                locationName: "LaunchTemplateTagSpecificationRequest",
                type: "structure",
                members: {
                  ResourceType: {},
                  Tags: {
                    shape: "S6",
                    locationName: "Tag"
                  }
                }
              }
            },
            ElasticGpuSpecifications: {
              locationName: "ElasticGpuSpecification",
              type: "list",
              member: {
                shape: "Shj",
                locationName: "ElasticGpuSpecification"
              }
            },
            ElasticInferenceAccelerators: {
              locationName: "ElasticInferenceAccelerator",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                required: [
                  "Type"
                ],
                members: {
                  Type: {},
                  Count: {
                    type: "integer"
                  }
                }
              }
            },
            SecurityGroupIds: {
              shape: "Sgz",
              locationName: "SecurityGroupId"
            },
            SecurityGroups: {
              shape: "Shn",
              locationName: "SecurityGroup"
            },
            InstanceMarketOptions: {
              type: "structure",
              members: {
                MarketType: {},
                SpotOptions: {
                  type: "structure",
                  members: {
                    MaxPrice: {},
                    SpotInstanceType: {},
                    BlockDurationMinutes: {
                      type: "integer"
                    },
                    ValidUntil: {
                      type: "timestamp"
                    },
                    InstanceInterruptionBehavior: {}
                  }
                }
              }
            },
            CreditSpecification: {
              shape: "Sht"
            },
            CpuOptions: {
              type: "structure",
              members: {
                CoreCount: {
                  type: "integer"
                },
                ThreadsPerCore: {
                  type: "integer"
                },
                AmdSevSnp: {}
              }
            },
            CapacityReservationSpecification: {
              type: "structure",
              members: {
                CapacityReservationPreference: {},
                CapacityReservationTarget: {
                  shape: "Shy"
                }
              }
            },
            LicenseSpecifications: {
              locationName: "LicenseSpecification",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  LicenseConfigurationArn: {}
                }
              }
            },
            HibernationOptions: {
              type: "structure",
              members: {
                Configured: {
                  type: "boolean"
                }
              }
            },
            MetadataOptions: {
              type: "structure",
              members: {
                HttpTokens: {},
                HttpPutResponseHopLimit: {
                  type: "integer"
                },
                HttpEndpoint: {},
                HttpProtocolIpv6: {},
                InstanceMetadataTags: {}
              }
            },
            EnclaveOptions: {
              type: "structure",
              members: {
                Enabled: {
                  type: "boolean"
                }
              }
            },
            InstanceRequirements: {
              shape: "Scu"
            },
            PrivateDnsNameOptions: {
              type: "structure",
              members: {
                HostnameType: {},
                EnableResourceNameDnsARecord: {
                  type: "boolean"
                },
                EnableResourceNameDnsAAAARecord: {
                  type: "boolean"
                }
              }
            },
            MaintenanceOptions: {
              type: "structure",
              members: {
                AutoRecovery: {}
              }
            },
            DisableApiStop: {
              type: "boolean"
            }
          }
        },
        Sgz: {
          type: "list",
          member: {
            locationName: "SecurityGroupId"
          }
        },
        Sh2: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Primary: {
                locationName: "primary",
                type: "boolean"
              },
              PrivateIpAddress: {
                locationName: "privateIpAddress"
              }
            }
          }
        },
        Sh4: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Ipv4Prefix: {}
            }
          }
        },
        Sh6: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Ipv6Prefix: {}
            }
          }
        },
        Sh8: {
          type: "structure",
          members: {
            EnaSrdEnabled: {
              type: "boolean"
            },
            EnaSrdUdpSpecification: {
              type: "structure",
              members: {
                EnaSrdUdpEnabled: {
                  type: "boolean"
                }
              }
            }
          }
        },
        Sha: {
          type: "structure",
          members: {
            TcpEstablishedTimeout: {
              type: "integer"
            },
            UdpStreamTimeout: {
              type: "integer"
            },
            UdpTimeout: {
              type: "integer"
            }
          }
        },
        Shj: {
          type: "structure",
          required: [
            "Type"
          ],
          members: {
            Type: {}
          }
        },
        Shn: {
          type: "list",
          member: {
            locationName: "SecurityGroup"
          }
        },
        Sht: {
          type: "structure",
          required: [
            "CpuCredits"
          ],
          members: {
            CpuCredits: {}
          }
        },
        Shy: {
          type: "structure",
          members: {
            CapacityReservationId: {},
            CapacityReservationResourceGroupArn: {}
          }
        },
        Sic: {
          type: "structure",
          members: {
            LaunchTemplateId: {
              locationName: "launchTemplateId"
            },
            LaunchTemplateName: {
              locationName: "launchTemplateName"
            },
            CreateTime: {
              locationName: "createTime",
              type: "timestamp"
            },
            CreatedBy: {
              locationName: "createdBy"
            },
            DefaultVersionNumber: {
              locationName: "defaultVersionNumber",
              type: "long"
            },
            LatestVersionNumber: {
              locationName: "latestVersionNumber",
              type: "long"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        Sid: {
          type: "structure",
          members: {
            Errors: {
              locationName: "errorSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  Code: {
                    locationName: "code"
                  },
                  Message: {
                    locationName: "message"
                  }
                }
              }
            }
          }
        },
        Sii: {
          type: "structure",
          members: {
            LaunchTemplateId: {
              locationName: "launchTemplateId"
            },
            LaunchTemplateName: {
              locationName: "launchTemplateName"
            },
            VersionNumber: {
              locationName: "versionNumber",
              type: "long"
            },
            VersionDescription: {
              locationName: "versionDescription"
            },
            CreateTime: {
              locationName: "createTime",
              type: "timestamp"
            },
            CreatedBy: {
              locationName: "createdBy"
            },
            DefaultVersion: {
              locationName: "defaultVersion",
              type: "boolean"
            },
            LaunchTemplateData: {
              shape: "Sij",
              locationName: "launchTemplateData"
            }
          }
        },
        Sij: {
          type: "structure",
          members: {
            KernelId: {
              locationName: "kernelId"
            },
            EbsOptimized: {
              locationName: "ebsOptimized",
              type: "boolean"
            },
            IamInstanceProfile: {
              locationName: "iamInstanceProfile",
              type: "structure",
              members: {
                Arn: {
                  locationName: "arn"
                },
                Name: {
                  locationName: "name"
                }
              }
            },
            BlockDeviceMappings: {
              locationName: "blockDeviceMappingSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  DeviceName: {
                    locationName: "deviceName"
                  },
                  VirtualName: {
                    locationName: "virtualName"
                  },
                  Ebs: {
                    locationName: "ebs",
                    type: "structure",
                    members: {
                      Encrypted: {
                        locationName: "encrypted",
                        type: "boolean"
                      },
                      DeleteOnTermination: {
                        locationName: "deleteOnTermination",
                        type: "boolean"
                      },
                      Iops: {
                        locationName: "iops",
                        type: "integer"
                      },
                      KmsKeyId: {
                        locationName: "kmsKeyId"
                      },
                      SnapshotId: {
                        locationName: "snapshotId"
                      },
                      VolumeSize: {
                        locationName: "volumeSize",
                        type: "integer"
                      },
                      VolumeType: {
                        locationName: "volumeType"
                      },
                      Throughput: {
                        locationName: "throughput",
                        type: "integer"
                      }
                    }
                  },
                  NoDevice: {
                    locationName: "noDevice"
                  }
                }
              }
            },
            NetworkInterfaces: {
              locationName: "networkInterfaceSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  AssociateCarrierIpAddress: {
                    locationName: "associateCarrierIpAddress",
                    type: "boolean"
                  },
                  AssociatePublicIpAddress: {
                    locationName: "associatePublicIpAddress",
                    type: "boolean"
                  },
                  DeleteOnTermination: {
                    locationName: "deleteOnTermination",
                    type: "boolean"
                  },
                  Description: {
                    locationName: "description"
                  },
                  DeviceIndex: {
                    locationName: "deviceIndex",
                    type: "integer"
                  },
                  Groups: {
                    shape: "S5v",
                    locationName: "groupSet"
                  },
                  InterfaceType: {
                    locationName: "interfaceType"
                  },
                  Ipv6AddressCount: {
                    locationName: "ipv6AddressCount",
                    type: "integer"
                  },
                  Ipv6Addresses: {
                    shape: "Siq",
                    locationName: "ipv6AddressesSet"
                  },
                  NetworkInterfaceId: {
                    locationName: "networkInterfaceId"
                  },
                  PrivateIpAddress: {
                    locationName: "privateIpAddress"
                  },
                  PrivateIpAddresses: {
                    shape: "Sh2",
                    locationName: "privateIpAddressesSet"
                  },
                  SecondaryPrivateIpAddressCount: {
                    locationName: "secondaryPrivateIpAddressCount",
                    type: "integer"
                  },
                  SubnetId: {
                    locationName: "subnetId"
                  },
                  NetworkCardIndex: {
                    locationName: "networkCardIndex",
                    type: "integer"
                  },
                  Ipv4Prefixes: {
                    locationName: "ipv4PrefixSet",
                    type: "list",
                    member: {
                      locationName: "item",
                      type: "structure",
                      members: {
                        Ipv4Prefix: {
                          locationName: "ipv4Prefix"
                        }
                      }
                    }
                  },
                  Ipv4PrefixCount: {
                    locationName: "ipv4PrefixCount",
                    type: "integer"
                  },
                  Ipv6Prefixes: {
                    locationName: "ipv6PrefixSet",
                    type: "list",
                    member: {
                      locationName: "item",
                      type: "structure",
                      members: {
                        Ipv6Prefix: {
                          locationName: "ipv6Prefix"
                        }
                      }
                    }
                  },
                  Ipv6PrefixCount: {
                    locationName: "ipv6PrefixCount",
                    type: "integer"
                  },
                  PrimaryIpv6: {
                    locationName: "primaryIpv6",
                    type: "boolean"
                  },
                  EnaSrdSpecification: {
                    locationName: "enaSrdSpecification",
                    type: "structure",
                    members: {
                      EnaSrdEnabled: {
                        locationName: "enaSrdEnabled",
                        type: "boolean"
                      },
                      EnaSrdUdpSpecification: {
                        locationName: "enaSrdUdpSpecification",
                        type: "structure",
                        members: {
                          EnaSrdUdpEnabled: {
                            locationName: "enaSrdUdpEnabled",
                            type: "boolean"
                          }
                        }
                      }
                    }
                  },
                  ConnectionTrackingSpecification: {
                    locationName: "connectionTrackingSpecification",
                    type: "structure",
                    members: {
                      TcpEstablishedTimeout: {
                        locationName: "tcpEstablishedTimeout",
                        type: "integer"
                      },
                      UdpTimeout: {
                        locationName: "udpTimeout",
                        type: "integer"
                      },
                      UdpStreamTimeout: {
                        locationName: "udpStreamTimeout",
                        type: "integer"
                      }
                    }
                  }
                }
              }
            },
            ImageId: {
              locationName: "imageId"
            },
            InstanceType: {
              locationName: "instanceType"
            },
            KeyName: {
              locationName: "keyName"
            },
            Monitoring: {
              locationName: "monitoring",
              type: "structure",
              members: {
                Enabled: {
                  locationName: "enabled",
                  type: "boolean"
                }
              }
            },
            Placement: {
              locationName: "placement",
              type: "structure",
              members: {
                AvailabilityZone: {
                  locationName: "availabilityZone"
                },
                Affinity: {
                  locationName: "affinity"
                },
                GroupName: {
                  locationName: "groupName"
                },
                HostId: {
                  locationName: "hostId"
                },
                Tenancy: {
                  locationName: "tenancy"
                },
                SpreadDomain: {
                  locationName: "spreadDomain"
                },
                HostResourceGroupArn: {
                  locationName: "hostResourceGroupArn"
                },
                PartitionNumber: {
                  locationName: "partitionNumber",
                  type: "integer"
                },
                GroupId: {
                  locationName: "groupId"
                }
              }
            },
            RamDiskId: {
              locationName: "ramDiskId"
            },
            DisableApiTermination: {
              locationName: "disableApiTermination",
              type: "boolean"
            },
            InstanceInitiatedShutdownBehavior: {
              locationName: "instanceInitiatedShutdownBehavior"
            },
            UserData: {
              shape: "Sgo",
              locationName: "userData"
            },
            TagSpecifications: {
              locationName: "tagSpecificationSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  ResourceType: {
                    locationName: "resourceType"
                  },
                  Tags: {
                    shape: "S6",
                    locationName: "tagSet"
                  }
                }
              }
            },
            ElasticGpuSpecifications: {
              locationName: "elasticGpuSpecificationSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  Type: {
                    locationName: "type"
                  }
                }
              }
            },
            ElasticInferenceAccelerators: {
              locationName: "elasticInferenceAcceleratorSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  Type: {
                    locationName: "type"
                  },
                  Count: {
                    locationName: "count",
                    type: "integer"
                  }
                }
              }
            },
            SecurityGroupIds: {
              shape: "So",
              locationName: "securityGroupIdSet"
            },
            SecurityGroups: {
              shape: "So",
              locationName: "securityGroupSet"
            },
            InstanceMarketOptions: {
              locationName: "instanceMarketOptions",
              type: "structure",
              members: {
                MarketType: {
                  locationName: "marketType"
                },
                SpotOptions: {
                  locationName: "spotOptions",
                  type: "structure",
                  members: {
                    MaxPrice: {
                      locationName: "maxPrice"
                    },
                    SpotInstanceType: {
                      locationName: "spotInstanceType"
                    },
                    BlockDurationMinutes: {
                      locationName: "blockDurationMinutes",
                      type: "integer"
                    },
                    ValidUntil: {
                      locationName: "validUntil",
                      type: "timestamp"
                    },
                    InstanceInterruptionBehavior: {
                      locationName: "instanceInterruptionBehavior"
                    }
                  }
                }
              }
            },
            CreditSpecification: {
              locationName: "creditSpecification",
              type: "structure",
              members: {
                CpuCredits: {
                  locationName: "cpuCredits"
                }
              }
            },
            CpuOptions: {
              locationName: "cpuOptions",
              type: "structure",
              members: {
                CoreCount: {
                  locationName: "coreCount",
                  type: "integer"
                },
                ThreadsPerCore: {
                  locationName: "threadsPerCore",
                  type: "integer"
                },
                AmdSevSnp: {
                  locationName: "amdSevSnp"
                }
              }
            },
            CapacityReservationSpecification: {
              locationName: "capacityReservationSpecification",
              type: "structure",
              members: {
                CapacityReservationPreference: {
                  locationName: "capacityReservationPreference"
                },
                CapacityReservationTarget: {
                  shape: "Sjc",
                  locationName: "capacityReservationTarget"
                }
              }
            },
            LicenseSpecifications: {
              locationName: "licenseSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  LicenseConfigurationArn: {
                    locationName: "licenseConfigurationArn"
                  }
                }
              }
            },
            HibernationOptions: {
              locationName: "hibernationOptions",
              type: "structure",
              members: {
                Configured: {
                  locationName: "configured",
                  type: "boolean"
                }
              }
            },
            MetadataOptions: {
              locationName: "metadataOptions",
              type: "structure",
              members: {
                State: {
                  locationName: "state"
                },
                HttpTokens: {
                  locationName: "httpTokens"
                },
                HttpPutResponseHopLimit: {
                  locationName: "httpPutResponseHopLimit",
                  type: "integer"
                },
                HttpEndpoint: {
                  locationName: "httpEndpoint"
                },
                HttpProtocolIpv6: {
                  locationName: "httpProtocolIpv6"
                },
                InstanceMetadataTags: {
                  locationName: "instanceMetadataTags"
                }
              }
            },
            EnclaveOptions: {
              locationName: "enclaveOptions",
              type: "structure",
              members: {
                Enabled: {
                  locationName: "enabled",
                  type: "boolean"
                }
              }
            },
            InstanceRequirements: {
              shape: "Sdz",
              locationName: "instanceRequirements"
            },
            PrivateDnsNameOptions: {
              locationName: "privateDnsNameOptions",
              type: "structure",
              members: {
                HostnameType: {
                  locationName: "hostnameType"
                },
                EnableResourceNameDnsARecord: {
                  locationName: "enableResourceNameDnsARecord",
                  type: "boolean"
                },
                EnableResourceNameDnsAAAARecord: {
                  locationName: "enableResourceNameDnsAAAARecord",
                  type: "boolean"
                }
              }
            },
            MaintenanceOptions: {
              locationName: "maintenanceOptions",
              type: "structure",
              members: {
                AutoRecovery: {
                  locationName: "autoRecovery"
                }
              }
            },
            DisableApiStop: {
              locationName: "disableApiStop",
              type: "boolean"
            }
          }
        },
        Siq: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Ipv6Address: {
                locationName: "ipv6Address"
              },
              IsPrimaryIpv6: {
                locationName: "isPrimaryIpv6",
                type: "boolean"
              }
            }
          }
        },
        Sjc: {
          type: "structure",
          members: {
            CapacityReservationId: {
              locationName: "capacityReservationId"
            },
            CapacityReservationResourceGroupArn: {
              locationName: "capacityReservationResourceGroupArn"
            }
          }
        },
        Sjo: {
          type: "structure",
          members: {
            DestinationCidrBlock: {
              locationName: "destinationCidrBlock"
            },
            LocalGatewayVirtualInterfaceGroupId: {
              locationName: "localGatewayVirtualInterfaceGroupId"
            },
            Type: {
              locationName: "type"
            },
            State: {
              locationName: "state"
            },
            LocalGatewayRouteTableId: {
              locationName: "localGatewayRouteTableId"
            },
            LocalGatewayRouteTableArn: {
              locationName: "localGatewayRouteTableArn"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            SubnetId: {
              locationName: "subnetId"
            },
            CoipPoolId: {
              locationName: "coipPoolId"
            },
            NetworkInterfaceId: {
              locationName: "networkInterfaceId"
            },
            DestinationPrefixListId: {
              locationName: "destinationPrefixListId"
            }
          }
        },
        Sjv: {
          type: "structure",
          members: {
            LocalGatewayRouteTableId: {
              locationName: "localGatewayRouteTableId"
            },
            LocalGatewayRouteTableArn: {
              locationName: "localGatewayRouteTableArn"
            },
            LocalGatewayId: {
              locationName: "localGatewayId"
            },
            OutpostArn: {
              locationName: "outpostArn"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            State: {
              locationName: "state"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            },
            Mode: {
              locationName: "mode"
            },
            StateReason: {
              shape: "Sjw",
              locationName: "stateReason"
            }
          }
        },
        Sjw: {
          type: "structure",
          members: {
            Code: {
              locationName: "code"
            },
            Message: {
              locationName: "message"
            }
          }
        },
        Sjz: {
          type: "structure",
          members: {
            LocalGatewayRouteTableVirtualInterfaceGroupAssociationId: {
              locationName: "localGatewayRouteTableVirtualInterfaceGroupAssociationId"
            },
            LocalGatewayVirtualInterfaceGroupId: {
              locationName: "localGatewayVirtualInterfaceGroupId"
            },
            LocalGatewayId: {
              locationName: "localGatewayId"
            },
            LocalGatewayRouteTableId: {
              locationName: "localGatewayRouteTableId"
            },
            LocalGatewayRouteTableArn: {
              locationName: "localGatewayRouteTableArn"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            State: {
              locationName: "state"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        Sk3: {
          type: "structure",
          members: {
            LocalGatewayRouteTableVpcAssociationId: {
              locationName: "localGatewayRouteTableVpcAssociationId"
            },
            LocalGatewayRouteTableId: {
              locationName: "localGatewayRouteTableId"
            },
            LocalGatewayRouteTableArn: {
              locationName: "localGatewayRouteTableArn"
            },
            LocalGatewayId: {
              locationName: "localGatewayId"
            },
            VpcId: {
              locationName: "vpcId"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            State: {
              locationName: "state"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        Sk6: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Cidr"
            ],
            members: {
              Cidr: {},
              Description: {}
            }
          }
        },
        Sk9: {
          type: "structure",
          members: {
            PrefixListId: {
              locationName: "prefixListId"
            },
            AddressFamily: {
              locationName: "addressFamily"
            },
            State: {
              locationName: "state"
            },
            StateMessage: {
              locationName: "stateMessage"
            },
            PrefixListArn: {
              locationName: "prefixListArn"
            },
            PrefixListName: {
              locationName: "prefixListName"
            },
            MaxEntries: {
              locationName: "maxEntries",
              type: "integer"
            },
            Version: {
              locationName: "version",
              type: "long"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            },
            OwnerId: {
              locationName: "ownerId"
            }
          }
        },
        Ske: {
          type: "structure",
          members: {
            CreateTime: {
              locationName: "createTime",
              type: "timestamp"
            },
            DeleteTime: {
              locationName: "deleteTime",
              type: "timestamp"
            },
            FailureCode: {
              locationName: "failureCode"
            },
            FailureMessage: {
              locationName: "failureMessage"
            },
            NatGatewayAddresses: {
              shape: "S3b",
              locationName: "natGatewayAddressSet"
            },
            NatGatewayId: {
              locationName: "natGatewayId"
            },
            ProvisionedBandwidth: {
              locationName: "provisionedBandwidth",
              type: "structure",
              members: {
                ProvisionTime: {
                  locationName: "provisionTime",
                  type: "timestamp"
                },
                Provisioned: {
                  locationName: "provisioned"
                },
                RequestTime: {
                  locationName: "requestTime",
                  type: "timestamp"
                },
                Requested: {
                  locationName: "requested"
                },
                Status: {
                  locationName: "status"
                }
              }
            },
            State: {
              locationName: "state"
            },
            SubnetId: {
              locationName: "subnetId"
            },
            VpcId: {
              locationName: "vpcId"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            },
            ConnectivityType: {
              locationName: "connectivityType"
            }
          }
        },
        Skj: {
          type: "structure",
          members: {
            Associations: {
              locationName: "associationSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  NetworkAclAssociationId: {
                    locationName: "networkAclAssociationId"
                  },
                  NetworkAclId: {
                    locationName: "networkAclId"
                  },
                  SubnetId: {
                    locationName: "subnetId"
                  }
                }
              }
            },
            Entries: {
              locationName: "entrySet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  CidrBlock: {
                    locationName: "cidrBlock"
                  },
                  Egress: {
                    locationName: "egress",
                    type: "boolean"
                  },
                  IcmpTypeCode: {
                    shape: "Sko",
                    locationName: "icmpTypeCode"
                  },
                  Ipv6CidrBlock: {
                    locationName: "ipv6CidrBlock"
                  },
                  PortRange: {
                    shape: "Skp",
                    locationName: "portRange"
                  },
                  Protocol: {
                    locationName: "protocol"
                  },
                  RuleAction: {
                    locationName: "ruleAction"
                  },
                  RuleNumber: {
                    locationName: "ruleNumber",
                    type: "integer"
                  }
                }
              }
            },
            IsDefault: {
              locationName: "default",
              type: "boolean"
            },
            NetworkAclId: {
              locationName: "networkAclId"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            },
            VpcId: {
              locationName: "vpcId"
            },
            OwnerId: {
              locationName: "ownerId"
            }
          }
        },
        Sko: {
          type: "structure",
          members: {
            Code: {
              locationName: "code",
              type: "integer"
            },
            Type: {
              locationName: "type",
              type: "integer"
            }
          }
        },
        Skp: {
          type: "structure",
          members: {
            From: {
              locationName: "from",
              type: "integer"
            },
            To: {
              locationName: "to",
              type: "integer"
            }
          }
        },
        Sku: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Source: {
                shape: "Skw"
              },
              Destination: {
                shape: "Skw"
              },
              ThroughResources: {
                locationName: "ThroughResource",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ResourceStatement: {
                      shape: "Sl0"
                    }
                  }
                }
              }
            }
          }
        },
        Skw: {
          type: "structure",
          members: {
            PacketHeaderStatement: {
              type: "structure",
              members: {
                SourceAddresses: {
                  shape: "So",
                  locationName: "SourceAddress"
                },
                DestinationAddresses: {
                  shape: "So",
                  locationName: "DestinationAddress"
                },
                SourcePorts: {
                  shape: "So",
                  locationName: "SourcePort"
                },
                DestinationPorts: {
                  shape: "So",
                  locationName: "DestinationPort"
                },
                SourcePrefixLists: {
                  shape: "So",
                  locationName: "SourcePrefixList"
                },
                DestinationPrefixLists: {
                  shape: "So",
                  locationName: "DestinationPrefixList"
                },
                Protocols: {
                  shape: "Sky",
                  locationName: "Protocol"
                }
              }
            },
            ResourceStatement: {
              shape: "Sl0"
            }
          }
        },
        Sky: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Sl0: {
          type: "structure",
          members: {
            Resources: {
              shape: "So",
              locationName: "Resource"
            },
            ResourceTypes: {
              shape: "So",
              locationName: "ResourceType"
            }
          }
        },
        Sl4: {
          type: "structure",
          members: {
            NetworkInsightsAccessScopeId: {
              locationName: "networkInsightsAccessScopeId"
            },
            NetworkInsightsAccessScopeArn: {
              locationName: "networkInsightsAccessScopeArn"
            },
            CreatedDate: {
              locationName: "createdDate",
              type: "timestamp"
            },
            UpdatedDate: {
              locationName: "updatedDate",
              type: "timestamp"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        Sl6: {
          type: "structure",
          members: {
            NetworkInsightsAccessScopeId: {
              locationName: "networkInsightsAccessScopeId"
            },
            MatchPaths: {
              shape: "Sl7",
              locationName: "matchPathSet"
            },
            ExcludePaths: {
              shape: "Sl7",
              locationName: "excludePathSet"
            }
          }
        },
        Sl7: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Source: {
                shape: "Sl9",
                locationName: "source"
              },
              Destination: {
                shape: "Sl9",
                locationName: "destination"
              },
              ThroughResources: {
                locationName: "throughResourceSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ResourceStatement: {
                      shape: "Slb",
                      locationName: "resourceStatement"
                    }
                  }
                }
              }
            }
          }
        },
        Sl9: {
          type: "structure",
          members: {
            PacketHeaderStatement: {
              locationName: "packetHeaderStatement",
              type: "structure",
              members: {
                SourceAddresses: {
                  shape: "So",
                  locationName: "sourceAddressSet"
                },
                DestinationAddresses: {
                  shape: "So",
                  locationName: "destinationAddressSet"
                },
                SourcePorts: {
                  shape: "So",
                  locationName: "sourcePortSet"
                },
                DestinationPorts: {
                  shape: "So",
                  locationName: "destinationPortSet"
                },
                SourcePrefixLists: {
                  shape: "So",
                  locationName: "sourcePrefixListSet"
                },
                DestinationPrefixLists: {
                  shape: "So",
                  locationName: "destinationPrefixListSet"
                },
                Protocols: {
                  shape: "Sky",
                  locationName: "protocolSet"
                }
              }
            },
            ResourceStatement: {
              shape: "Slb",
              locationName: "resourceStatement"
            }
          }
        },
        Slb: {
          type: "structure",
          members: {
            Resources: {
              shape: "So",
              locationName: "resourceSet"
            },
            ResourceTypes: {
              shape: "So",
              locationName: "resourceTypeSet"
            }
          }
        },
        Sli: {
          type: "structure",
          members: {
            SourceAddress: {},
            SourcePortRange: {
              shape: "Slj"
            },
            DestinationAddress: {},
            DestinationPortRange: {
              shape: "Slj"
            }
          }
        },
        Slj: {
          type: "structure",
          members: {
            FromPort: {
              type: "integer"
            },
            ToPort: {
              type: "integer"
            }
          }
        },
        Sll: {
          type: "structure",
          members: {
            NetworkInsightsPathId: {
              locationName: "networkInsightsPathId"
            },
            NetworkInsightsPathArn: {
              locationName: "networkInsightsPathArn"
            },
            CreatedDate: {
              locationName: "createdDate",
              type: "timestamp"
            },
            Source: {
              locationName: "source"
            },
            Destination: {
              locationName: "destination"
            },
            SourceArn: {
              locationName: "sourceArn"
            },
            DestinationArn: {
              locationName: "destinationArn"
            },
            SourceIp: {
              locationName: "sourceIp"
            },
            DestinationIp: {
              locationName: "destinationIp"
            },
            Protocol: {
              locationName: "protocol"
            },
            DestinationPort: {
              locationName: "destinationPort",
              type: "integer"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            },
            FilterAtSource: {
              shape: "Sln",
              locationName: "filterAtSource"
            },
            FilterAtDestination: {
              shape: "Sln",
              locationName: "filterAtDestination"
            }
          }
        },
        Sln: {
          type: "structure",
          members: {
            SourceAddress: {
              locationName: "sourceAddress"
            },
            SourcePortRange: {
              shape: "Slo",
              locationName: "sourcePortRange"
            },
            DestinationAddress: {
              locationName: "destinationAddress"
            },
            DestinationPortRange: {
              shape: "Slo",
              locationName: "destinationPortRange"
            }
          }
        },
        Slo: {
          type: "structure",
          members: {
            FromPort: {
              locationName: "fromPort",
              type: "integer"
            },
            ToPort: {
              locationName: "toPort",
              type: "integer"
            }
          }
        },
        Sls: {
          type: "structure",
          members: {
            Association: {
              shape: "Slt",
              locationName: "association"
            },
            Attachment: {
              shape: "Slu",
              locationName: "attachment"
            },
            AvailabilityZone: {
              locationName: "availabilityZone"
            },
            ConnectionTrackingConfiguration: {
              locationName: "connectionTrackingConfiguration",
              type: "structure",
              members: {
                TcpEstablishedTimeout: {
                  locationName: "tcpEstablishedTimeout",
                  type: "integer"
                },
                UdpStreamTimeout: {
                  locationName: "udpStreamTimeout",
                  type: "integer"
                },
                UdpTimeout: {
                  locationName: "udpTimeout",
                  type: "integer"
                }
              }
            },
            Description: {
              locationName: "description"
            },
            Groups: {
              shape: "Sly",
              locationName: "groupSet"
            },
            InterfaceType: {
              locationName: "interfaceType"
            },
            Ipv6Addresses: {
              locationName: "ipv6AddressesSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  Ipv6Address: {
                    locationName: "ipv6Address"
                  },
                  IsPrimaryIpv6: {
                    locationName: "isPrimaryIpv6",
                    type: "boolean"
                  }
                }
              }
            },
            MacAddress: {
              locationName: "macAddress"
            },
            NetworkInterfaceId: {
              locationName: "networkInterfaceId"
            },
            OutpostArn: {
              locationName: "outpostArn"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            PrivateDnsName: {
              locationName: "privateDnsName"
            },
            PrivateIpAddress: {
              locationName: "privateIpAddress"
            },
            PrivateIpAddresses: {
              locationName: "privateIpAddressesSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  Association: {
                    shape: "Slt",
                    locationName: "association"
                  },
                  Primary: {
                    locationName: "primary",
                    type: "boolean"
                  },
                  PrivateDnsName: {
                    locationName: "privateDnsName"
                  },
                  PrivateIpAddress: {
                    locationName: "privateIpAddress"
                  }
                }
              }
            },
            Ipv4Prefixes: {
              shape: "S34",
              locationName: "ipv4PrefixSet"
            },
            Ipv6Prefixes: {
              locationName: "ipv6PrefixSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  Ipv6Prefix: {
                    locationName: "ipv6Prefix"
                  }
                }
              }
            },
            RequesterId: {
              locationName: "requesterId"
            },
            RequesterManaged: {
              locationName: "requesterManaged",
              type: "boolean"
            },
            SourceDestCheck: {
              locationName: "sourceDestCheck",
              type: "boolean"
            },
            Status: {
              locationName: "status"
            },
            SubnetId: {
              locationName: "subnetId"
            },
            TagSet: {
              shape: "S6",
              locationName: "tagSet"
            },
            VpcId: {
              locationName: "vpcId"
            },
            DenyAllIgwTraffic: {
              locationName: "denyAllIgwTraffic",
              type: "boolean"
            },
            Ipv6Native: {
              locationName: "ipv6Native",
              type: "boolean"
            },
            Ipv6Address: {
              locationName: "ipv6Address"
            }
          }
        },
        Slt: {
          type: "structure",
          members: {
            AllocationId: {
              locationName: "allocationId"
            },
            AssociationId: {
              locationName: "associationId"
            },
            IpOwnerId: {
              locationName: "ipOwnerId"
            },
            PublicDnsName: {
              locationName: "publicDnsName"
            },
            PublicIp: {
              locationName: "publicIp"
            },
            CustomerOwnedIp: {
              locationName: "customerOwnedIp"
            },
            CarrierIp: {
              locationName: "carrierIp"
            }
          }
        },
        Slu: {
          type: "structure",
          members: {
            AttachTime: {
              locationName: "attachTime",
              type: "timestamp"
            },
            AttachmentId: {
              locationName: "attachmentId"
            },
            DeleteOnTermination: {
              locationName: "deleteOnTermination",
              type: "boolean"
            },
            DeviceIndex: {
              locationName: "deviceIndex",
              type: "integer"
            },
            NetworkCardIndex: {
              locationName: "networkCardIndex",
              type: "integer"
            },
            InstanceId: {
              locationName: "instanceId"
            },
            InstanceOwnerId: {
              locationName: "instanceOwnerId"
            },
            Status: {
              locationName: "status"
            },
            EnaSrdSpecification: {
              locationName: "enaSrdSpecification",
              type: "structure",
              members: {
                EnaSrdEnabled: {
                  locationName: "enaSrdEnabled",
                  type: "boolean"
                },
                EnaSrdUdpSpecification: {
                  locationName: "enaSrdUdpSpecification",
                  type: "structure",
                  members: {
                    EnaSrdUdpEnabled: {
                      locationName: "enaSrdUdpEnabled",
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        Sly: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              GroupName: {
                locationName: "groupName"
              },
              GroupId: {
                locationName: "groupId"
              }
            }
          }
        },
        Smb: {
          type: "structure",
          members: {
            NetworkInterfacePermissionId: {
              locationName: "networkInterfacePermissionId"
            },
            NetworkInterfaceId: {
              locationName: "networkInterfaceId"
            },
            AwsAccountId: {
              locationName: "awsAccountId"
            },
            AwsService: {
              locationName: "awsService"
            },
            Permission: {
              locationName: "permission"
            },
            PermissionState: {
              locationName: "permissionState",
              type: "structure",
              members: {
                State: {
                  locationName: "state"
                },
                StatusMessage: {
                  locationName: "statusMessage"
                }
              }
            }
          }
        },
        Smi: {
          type: "structure",
          members: {
            GroupName: {
              locationName: "groupName"
            },
            State: {
              locationName: "state"
            },
            Strategy: {
              locationName: "strategy"
            },
            PartitionCount: {
              locationName: "partitionCount",
              type: "integer"
            },
            GroupId: {
              locationName: "groupId"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            },
            GroupArn: {
              locationName: "groupArn"
            },
            SpreadLevel: {
              locationName: "spreadLevel"
            }
          }
        },
        Smo: {
          type: "structure",
          members: {
            ReplaceRootVolumeTaskId: {
              locationName: "replaceRootVolumeTaskId"
            },
            InstanceId: {
              locationName: "instanceId"
            },
            TaskState: {
              locationName: "taskState"
            },
            StartTime: {
              locationName: "startTime"
            },
            CompleteTime: {
              locationName: "completeTime"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            },
            ImageId: {
              locationName: "imageId"
            },
            SnapshotId: {
              locationName: "snapshotId"
            },
            DeleteReplacedRootVolume: {
              locationName: "deleteReplacedRootVolume",
              type: "boolean"
            }
          }
        },
        Sn4: {
          type: "structure",
          members: {
            Associations: {
              locationName: "associationSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  Main: {
                    locationName: "main",
                    type: "boolean"
                  },
                  RouteTableAssociationId: {
                    locationName: "routeTableAssociationId"
                  },
                  RouteTableId: {
                    locationName: "routeTableId"
                  },
                  SubnetId: {
                    locationName: "subnetId"
                  },
                  GatewayId: {
                    locationName: "gatewayId"
                  },
                  AssociationState: {
                    shape: "S4x",
                    locationName: "associationState"
                  }
                }
              }
            },
            PropagatingVgws: {
              locationName: "propagatingVgwSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  GatewayId: {
                    locationName: "gatewayId"
                  }
                }
              }
            },
            RouteTableId: {
              locationName: "routeTableId"
            },
            Routes: {
              locationName: "routeSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  DestinationCidrBlock: {
                    locationName: "destinationCidrBlock"
                  },
                  DestinationIpv6CidrBlock: {
                    locationName: "destinationIpv6CidrBlock"
                  },
                  DestinationPrefixListId: {
                    locationName: "destinationPrefixListId"
                  },
                  EgressOnlyInternetGatewayId: {
                    locationName: "egressOnlyInternetGatewayId"
                  },
                  GatewayId: {
                    locationName: "gatewayId"
                  },
                  InstanceId: {
                    locationName: "instanceId"
                  },
                  InstanceOwnerId: {
                    locationName: "instanceOwnerId"
                  },
                  NatGatewayId: {
                    locationName: "natGatewayId"
                  },
                  TransitGatewayId: {
                    locationName: "transitGatewayId"
                  },
                  LocalGatewayId: {
                    locationName: "localGatewayId"
                  },
                  CarrierGatewayId: {
                    locationName: "carrierGatewayId"
                  },
                  NetworkInterfaceId: {
                    locationName: "networkInterfaceId"
                  },
                  Origin: {
                    locationName: "origin"
                  },
                  State: {
                    locationName: "state"
                  },
                  VpcPeeringConnectionId: {
                    locationName: "vpcPeeringConnectionId"
                  },
                  CoreNetworkArn: {
                    locationName: "coreNetworkArn"
                  }
                }
              }
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            },
            VpcId: {
              locationName: "vpcId"
            },
            OwnerId: {
              locationName: "ownerId"
            }
          }
        },
        Sng: {
          type: "structure",
          members: {
            DataEncryptionKeyId: {
              locationName: "dataEncryptionKeyId"
            },
            Description: {
              locationName: "description"
            },
            Encrypted: {
              locationName: "encrypted",
              type: "boolean"
            },
            KmsKeyId: {
              locationName: "kmsKeyId"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            Progress: {
              locationName: "progress"
            },
            SnapshotId: {
              locationName: "snapshotId"
            },
            StartTime: {
              locationName: "startTime",
              type: "timestamp"
            },
            State: {
              locationName: "status"
            },
            StateMessage: {
              locationName: "statusMessage"
            },
            VolumeId: {
              locationName: "volumeId"
            },
            VolumeSize: {
              locationName: "volumeSize",
              type: "integer"
            },
            OwnerAlias: {
              locationName: "ownerAlias"
            },
            OutpostArn: {
              locationName: "outpostArn"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            },
            StorageTier: {
              locationName: "storageTier"
            },
            RestoreExpiryTime: {
              locationName: "restoreExpiryTime",
              type: "timestamp"
            },
            SseType: {
              locationName: "sseType"
            }
          }
        },
        Snn: {
          type: "list",
          member: {
            locationName: "VolumeId"
          }
        },
        Snu: {
          type: "structure",
          members: {
            Bucket: {
              locationName: "bucket"
            },
            Fault: {
              shape: "Snv",
              locationName: "fault"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            Prefix: {
              locationName: "prefix"
            },
            State: {
              locationName: "state"
            }
          }
        },
        Snv: {
          type: "structure",
          members: {
            Code: {
              locationName: "code"
            },
            Message: {
              locationName: "message"
            }
          }
        },
        So6: {
          type: "structure",
          members: {
            SubnetCidrReservationId: {
              locationName: "subnetCidrReservationId"
            },
            SubnetId: {
              locationName: "subnetId"
            },
            Cidr: {
              locationName: "cidr"
            },
            ReservationType: {
              locationName: "reservationType"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            Description: {
              locationName: "description"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        So9: {
          type: "list",
          member: {}
        },
        Sod: {
          type: "structure",
          members: {
            TrafficMirrorFilterId: {
              locationName: "trafficMirrorFilterId"
            },
            IngressFilterRules: {
              shape: "Soe",
              locationName: "ingressFilterRuleSet"
            },
            EgressFilterRules: {
              shape: "Soe",
              locationName: "egressFilterRuleSet"
            },
            NetworkServices: {
              shape: "Soj",
              locationName: "networkServiceSet"
            },
            Description: {
              locationName: "description"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        Soe: {
          type: "list",
          member: {
            shape: "Sof",
            locationName: "item"
          }
        },
        Sof: {
          type: "structure",
          members: {
            TrafficMirrorFilterRuleId: {
              locationName: "trafficMirrorFilterRuleId"
            },
            TrafficMirrorFilterId: {
              locationName: "trafficMirrorFilterId"
            },
            TrafficDirection: {
              locationName: "trafficDirection"
            },
            RuleNumber: {
              locationName: "ruleNumber",
              type: "integer"
            },
            RuleAction: {
              locationName: "ruleAction"
            },
            Protocol: {
              locationName: "protocol",
              type: "integer"
            },
            DestinationPortRange: {
              shape: "Soi",
              locationName: "destinationPortRange"
            },
            SourcePortRange: {
              shape: "Soi",
              locationName: "sourcePortRange"
            },
            DestinationCidrBlock: {
              locationName: "destinationCidrBlock"
            },
            SourceCidrBlock: {
              locationName: "sourceCidrBlock"
            },
            Description: {
              locationName: "description"
            }
          }
        },
        Soi: {
          type: "structure",
          members: {
            FromPort: {
              locationName: "fromPort",
              type: "integer"
            },
            ToPort: {
              locationName: "toPort",
              type: "integer"
            }
          }
        },
        Soj: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Son: {
          type: "structure",
          members: {
            FromPort: {
              type: "integer"
            },
            ToPort: {
              type: "integer"
            }
          }
        },
        Sos: {
          type: "structure",
          members: {
            TrafficMirrorSessionId: {
              locationName: "trafficMirrorSessionId"
            },
            TrafficMirrorTargetId: {
              locationName: "trafficMirrorTargetId"
            },
            TrafficMirrorFilterId: {
              locationName: "trafficMirrorFilterId"
            },
            NetworkInterfaceId: {
              locationName: "networkInterfaceId"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            PacketLength: {
              locationName: "packetLength",
              type: "integer"
            },
            SessionNumber: {
              locationName: "sessionNumber",
              type: "integer"
            },
            VirtualNetworkId: {
              locationName: "virtualNetworkId",
              type: "integer"
            },
            Description: {
              locationName: "description"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        Sov: {
          type: "structure",
          members: {
            TrafficMirrorTargetId: {
              locationName: "trafficMirrorTargetId"
            },
            NetworkInterfaceId: {
              locationName: "networkInterfaceId"
            },
            NetworkLoadBalancerArn: {
              locationName: "networkLoadBalancerArn"
            },
            Type: {
              locationName: "type"
            },
            Description: {
              locationName: "description"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            },
            GatewayLoadBalancerEndpointId: {
              locationName: "gatewayLoadBalancerEndpointId"
            }
          }
        },
        Sp4: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Sp6: {
          type: "structure",
          members: {
            TransitGatewayId: {
              locationName: "transitGatewayId"
            },
            TransitGatewayArn: {
              locationName: "transitGatewayArn"
            },
            State: {
              locationName: "state"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            Description: {
              locationName: "description"
            },
            CreationTime: {
              locationName: "creationTime",
              type: "timestamp"
            },
            Options: {
              locationName: "options",
              type: "structure",
              members: {
                AmazonSideAsn: {
                  locationName: "amazonSideAsn",
                  type: "long"
                },
                TransitGatewayCidrBlocks: {
                  shape: "So",
                  locationName: "transitGatewayCidrBlocks"
                },
                AutoAcceptSharedAttachments: {
                  locationName: "autoAcceptSharedAttachments"
                },
                DefaultRouteTableAssociation: {
                  locationName: "defaultRouteTableAssociation"
                },
                AssociationDefaultRouteTableId: {
                  locationName: "associationDefaultRouteTableId"
                },
                DefaultRouteTablePropagation: {
                  locationName: "defaultRouteTablePropagation"
                },
                PropagationDefaultRouteTableId: {
                  locationName: "propagationDefaultRouteTableId"
                },
                VpnEcmpSupport: {
                  locationName: "vpnEcmpSupport"
                },
                DnsSupport: {
                  locationName: "dnsSupport"
                },
                SecurityGroupReferencingSupport: {
                  locationName: "securityGroupReferencingSupport"
                },
                MulticastSupport: {
                  locationName: "multicastSupport"
                }
              }
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        Spd: {
          type: "structure",
          members: {
            TransitGatewayAttachmentId: {
              locationName: "transitGatewayAttachmentId"
            },
            TransportTransitGatewayAttachmentId: {
              locationName: "transportTransitGatewayAttachmentId"
            },
            TransitGatewayId: {
              locationName: "transitGatewayId"
            },
            State: {
              locationName: "state"
            },
            CreationTime: {
              locationName: "creationTime",
              type: "timestamp"
            },
            Options: {
              locationName: "options",
              type: "structure",
              members: {
                Protocol: {
                  locationName: "protocol"
                }
              }
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        Sph: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Spj: {
          type: "structure",
          members: {
            TransitGatewayAttachmentId: {
              locationName: "transitGatewayAttachmentId"
            },
            TransitGatewayConnectPeerId: {
              locationName: "transitGatewayConnectPeerId"
            },
            State: {
              locationName: "state"
            },
            CreationTime: {
              locationName: "creationTime",
              type: "timestamp"
            },
            ConnectPeerConfiguration: {
              locationName: "connectPeerConfiguration",
              type: "structure",
              members: {
                TransitGatewayAddress: {
                  locationName: "transitGatewayAddress"
                },
                PeerAddress: {
                  locationName: "peerAddress"
                },
                InsideCidrBlocks: {
                  shape: "Sph",
                  locationName: "insideCidrBlocks"
                },
                Protocol: {
                  locationName: "protocol"
                },
                BgpConfigurations: {
                  locationName: "bgpConfigurations",
                  type: "list",
                  member: {
                    locationName: "item",
                    type: "structure",
                    members: {
                      TransitGatewayAsn: {
                        locationName: "transitGatewayAsn",
                        type: "long"
                      },
                      PeerAsn: {
                        locationName: "peerAsn",
                        type: "long"
                      },
                      TransitGatewayAddress: {
                        locationName: "transitGatewayAddress"
                      },
                      PeerAddress: {
                        locationName: "peerAddress"
                      },
                      BgpStatus: {
                        locationName: "bgpStatus"
                      }
                    }
                  }
                }
              }
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        Spw: {
          type: "structure",
          members: {
            TransitGatewayMulticastDomainId: {
              locationName: "transitGatewayMulticastDomainId"
            },
            TransitGatewayId: {
              locationName: "transitGatewayId"
            },
            TransitGatewayMulticastDomainArn: {
              locationName: "transitGatewayMulticastDomainArn"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            Options: {
              locationName: "options",
              type: "structure",
              members: {
                Igmpv2Support: {
                  locationName: "igmpv2Support"
                },
                StaticSourcesSupport: {
                  locationName: "staticSourcesSupport"
                },
                AutoAcceptSharedAssociations: {
                  locationName: "autoAcceptSharedAssociations"
                }
              }
            },
            State: {
              locationName: "state"
            },
            CreationTime: {
              locationName: "creationTime",
              type: "timestamp"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        Sq5: {
          type: "structure",
          members: {
            TransitGatewayPolicyTableId: {
              locationName: "transitGatewayPolicyTableId"
            },
            TransitGatewayId: {
              locationName: "transitGatewayId"
            },
            State: {
              locationName: "state"
            },
            CreationTime: {
              locationName: "creationTime",
              type: "timestamp"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        Sq9: {
          type: "structure",
          members: {
            TransitGatewayRouteTableId: {
              locationName: "transitGatewayRouteTableId"
            },
            PrefixListId: {
              locationName: "prefixListId"
            },
            PrefixListOwnerId: {
              locationName: "prefixListOwnerId"
            },
            State: {
              locationName: "state"
            },
            Blackhole: {
              locationName: "blackhole",
              type: "boolean"
            },
            TransitGatewayAttachment: {
              locationName: "transitGatewayAttachment",
              type: "structure",
              members: {
                TransitGatewayAttachmentId: {
                  locationName: "transitGatewayAttachmentId"
                },
                ResourceType: {
                  locationName: "resourceType"
                },
                ResourceId: {
                  locationName: "resourceId"
                }
              }
            }
          }
        },
        Sqe: {
          type: "structure",
          members: {
            DestinationCidrBlock: {
              locationName: "destinationCidrBlock"
            },
            PrefixListId: {
              locationName: "prefixListId"
            },
            TransitGatewayRouteTableAnnouncementId: {
              locationName: "transitGatewayRouteTableAnnouncementId"
            },
            TransitGatewayAttachments: {
              locationName: "transitGatewayAttachments",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  ResourceId: {
                    locationName: "resourceId"
                  },
                  TransitGatewayAttachmentId: {
                    locationName: "transitGatewayAttachmentId"
                  },
                  ResourceType: {
                    locationName: "resourceType"
                  }
                }
              }
            },
            Type: {
              locationName: "type"
            },
            State: {
              locationName: "state"
            }
          }
        },
        Sqm: {
          type: "structure",
          members: {
            TransitGatewayRouteTableId: {
              locationName: "transitGatewayRouteTableId"
            },
            TransitGatewayId: {
              locationName: "transitGatewayId"
            },
            State: {
              locationName: "state"
            },
            DefaultAssociationRouteTable: {
              locationName: "defaultAssociationRouteTable",
              type: "boolean"
            },
            DefaultPropagationRouteTable: {
              locationName: "defaultPropagationRouteTable",
              type: "boolean"
            },
            CreationTime: {
              locationName: "creationTime",
              type: "timestamp"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        Sqq: {
          type: "structure",
          members: {
            TransitGatewayRouteTableAnnouncementId: {
              locationName: "transitGatewayRouteTableAnnouncementId"
            },
            TransitGatewayId: {
              locationName: "transitGatewayId"
            },
            CoreNetworkId: {
              locationName: "coreNetworkId"
            },
            PeerTransitGatewayId: {
              locationName: "peerTransitGatewayId"
            },
            PeerCoreNetworkId: {
              locationName: "peerCoreNetworkId"
            },
            PeeringAttachmentId: {
              locationName: "peeringAttachmentId"
            },
            AnnouncementDirection: {
              locationName: "announcementDirection"
            },
            TransitGatewayRouteTableId: {
              locationName: "transitGatewayRouteTableId"
            },
            State: {
              locationName: "state"
            },
            CreationTime: {
              locationName: "creationTime",
              type: "timestamp"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        Sr1: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Sr8: {
          type: "structure",
          members: {
            CustomerManagedKeyEnabled: {
              type: "boolean"
            },
            KmsKeyArn: {}
          }
        },
        Sra: {
          type: "structure",
          members: {
            VerifiedAccessInstanceId: {
              locationName: "verifiedAccessInstanceId"
            },
            VerifiedAccessGroupId: {
              locationName: "verifiedAccessGroupId"
            },
            VerifiedAccessEndpointId: {
              locationName: "verifiedAccessEndpointId"
            },
            ApplicationDomain: {
              locationName: "applicationDomain"
            },
            EndpointType: {
              locationName: "endpointType"
            },
            AttachmentType: {
              locationName: "attachmentType"
            },
            DomainCertificateArn: {
              locationName: "domainCertificateArn"
            },
            EndpointDomain: {
              locationName: "endpointDomain"
            },
            DeviceValidationDomain: {
              locationName: "deviceValidationDomain"
            },
            SecurityGroupIds: {
              shape: "Sr1",
              locationName: "securityGroupIdSet"
            },
            LoadBalancerOptions: {
              locationName: "loadBalancerOptions",
              type: "structure",
              members: {
                Protocol: {
                  locationName: "protocol"
                },
                Port: {
                  locationName: "port",
                  type: "integer"
                },
                LoadBalancerArn: {
                  locationName: "loadBalancerArn"
                },
                SubnetIds: {
                  locationName: "subnetIdSet",
                  type: "list",
                  member: {
                    locationName: "item"
                  }
                }
              }
            },
            NetworkInterfaceOptions: {
              locationName: "networkInterfaceOptions",
              type: "structure",
              members: {
                NetworkInterfaceId: {
                  locationName: "networkInterfaceId"
                },
                Protocol: {
                  locationName: "protocol"
                },
                Port: {
                  locationName: "port",
                  type: "integer"
                }
              }
            },
            Status: {
              locationName: "status",
              type: "structure",
              members: {
                Code: {
                  locationName: "code"
                },
                Message: {
                  locationName: "message"
                }
              }
            },
            Description: {
              locationName: "description"
            },
            CreationTime: {
              locationName: "creationTime"
            },
            LastUpdatedTime: {
              locationName: "lastUpdatedTime"
            },
            DeletionTime: {
              locationName: "deletionTime"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            },
            SseSpecification: {
              shape: "S6e",
              locationName: "sseSpecification"
            }
          }
        },
        Sri: {
          type: "structure",
          members: {
            VerifiedAccessGroupId: {
              locationName: "verifiedAccessGroupId"
            },
            VerifiedAccessInstanceId: {
              locationName: "verifiedAccessInstanceId"
            },
            Description: {
              locationName: "description"
            },
            Owner: {
              locationName: "owner"
            },
            VerifiedAccessGroupArn: {
              locationName: "verifiedAccessGroupArn"
            },
            CreationTime: {
              locationName: "creationTime"
            },
            LastUpdatedTime: {
              locationName: "lastUpdatedTime"
            },
            DeletionTime: {
              locationName: "deletionTime"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            },
            SseSpecification: {
              shape: "S6e",
              locationName: "sseSpecification"
            }
          }
        },
        Srq: {
          type: "structure",
          members: {
            Attachments: {
              locationName: "attachmentSet",
              type: "list",
              member: {
                shape: "S6l",
                locationName: "item"
              }
            },
            AvailabilityZone: {
              locationName: "availabilityZone"
            },
            CreateTime: {
              locationName: "createTime",
              type: "timestamp"
            },
            Encrypted: {
              locationName: "encrypted",
              type: "boolean"
            },
            KmsKeyId: {
              locationName: "kmsKeyId"
            },
            OutpostArn: {
              locationName: "outpostArn"
            },
            Size: {
              locationName: "size",
              type: "integer"
            },
            SnapshotId: {
              locationName: "snapshotId"
            },
            State: {
              locationName: "status"
            },
            VolumeId: {
              locationName: "volumeId"
            },
            Iops: {
              locationName: "iops",
              type: "integer"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            },
            VolumeType: {
              locationName: "volumeType"
            },
            FastRestored: {
              locationName: "fastRestored",
              type: "boolean"
            },
            MultiAttachEnabled: {
              locationName: "multiAttachEnabled",
              type: "boolean"
            },
            Throughput: {
              locationName: "throughput",
              type: "integer"
            },
            SseType: {
              locationName: "sseType"
            }
          }
        },
        Srx: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Sry: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Srz: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Ss1: {
          type: "structure",
          members: {
            DnsRecordIpType: {},
            PrivateDnsOnlyForInboundResolverEndpoint: {
              type: "boolean"
            }
          }
        },
        Ss3: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              SubnetId: {},
              Ipv4: {},
              Ipv6: {}
            }
          }
        },
        Ss6: {
          type: "structure",
          members: {
            VpcEndpointId: {
              locationName: "vpcEndpointId"
            },
            VpcEndpointType: {
              locationName: "vpcEndpointType"
            },
            VpcId: {
              locationName: "vpcId"
            },
            ServiceName: {
              locationName: "serviceName"
            },
            State: {
              locationName: "state"
            },
            PolicyDocument: {
              locationName: "policyDocument"
            },
            RouteTableIds: {
              shape: "So",
              locationName: "routeTableIdSet"
            },
            SubnetIds: {
              shape: "So",
              locationName: "subnetIdSet"
            },
            Groups: {
              locationName: "groupSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  GroupId: {
                    locationName: "groupId"
                  },
                  GroupName: {
                    locationName: "groupName"
                  }
                }
              }
            },
            IpAddressType: {
              locationName: "ipAddressType"
            },
            DnsOptions: {
              locationName: "dnsOptions",
              type: "structure",
              members: {
                DnsRecordIpType: {
                  locationName: "dnsRecordIpType"
                },
                PrivateDnsOnlyForInboundResolverEndpoint: {
                  locationName: "privateDnsOnlyForInboundResolverEndpoint",
                  type: "boolean"
                }
              }
            },
            PrivateDnsEnabled: {
              locationName: "privateDnsEnabled",
              type: "boolean"
            },
            RequesterManaged: {
              locationName: "requesterManaged",
              type: "boolean"
            },
            NetworkInterfaceIds: {
              shape: "So",
              locationName: "networkInterfaceIdSet"
            },
            DnsEntries: {
              shape: "Ssb",
              locationName: "dnsEntrySet"
            },
            CreationTimestamp: {
              locationName: "creationTimestamp",
              type: "timestamp"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            LastError: {
              locationName: "lastError",
              type: "structure",
              members: {
                Message: {
                  locationName: "message"
                },
                Code: {
                  locationName: "code"
                }
              }
            }
          }
        },
        Ssb: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              DnsName: {
                locationName: "dnsName"
              },
              HostedZoneId: {
                locationName: "hostedZoneId"
              }
            }
          }
        },
        Ssg: {
          type: "structure",
          members: {
            ConnectionNotificationId: {
              locationName: "connectionNotificationId"
            },
            ServiceId: {
              locationName: "serviceId"
            },
            VpcEndpointId: {
              locationName: "vpcEndpointId"
            },
            ConnectionNotificationType: {
              locationName: "connectionNotificationType"
            },
            ConnectionNotificationArn: {
              locationName: "connectionNotificationArn"
            },
            ConnectionEvents: {
              shape: "So",
              locationName: "connectionEvents"
            },
            ConnectionNotificationState: {
              locationName: "connectionNotificationState"
            }
          }
        },
        Ssl: {
          type: "structure",
          members: {
            ServiceType: {
              shape: "Ssm",
              locationName: "serviceType"
            },
            ServiceId: {
              locationName: "serviceId"
            },
            ServiceName: {
              locationName: "serviceName"
            },
            ServiceState: {
              locationName: "serviceState"
            },
            AvailabilityZones: {
              shape: "So",
              locationName: "availabilityZoneSet"
            },
            AcceptanceRequired: {
              locationName: "acceptanceRequired",
              type: "boolean"
            },
            ManagesVpcEndpoints: {
              locationName: "managesVpcEndpoints",
              type: "boolean"
            },
            NetworkLoadBalancerArns: {
              shape: "So",
              locationName: "networkLoadBalancerArnSet"
            },
            GatewayLoadBalancerArns: {
              shape: "So",
              locationName: "gatewayLoadBalancerArnSet"
            },
            SupportedIpAddressTypes: {
              shape: "Ssq",
              locationName: "supportedIpAddressTypeSet"
            },
            BaseEndpointDnsNames: {
              shape: "So",
              locationName: "baseEndpointDnsNameSet"
            },
            PrivateDnsName: {
              locationName: "privateDnsName"
            },
            PrivateDnsNameConfiguration: {
              locationName: "privateDnsNameConfiguration",
              type: "structure",
              members: {
                State: {
                  locationName: "state"
                },
                Type: {
                  locationName: "type"
                },
                Value: {
                  locationName: "value"
                },
                Name: {
                  locationName: "name"
                }
              }
            },
            PayerResponsibility: {
              locationName: "payerResponsibility"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        Ssm: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              ServiceType: {
                locationName: "serviceType"
              }
            }
          }
        },
        Ssq: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        St3: {
          type: "string",
          sensitive: true
        },
        St4: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Value: {}
            }
          }
        },
        St6: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Value: {}
            }
          }
        },
        St8: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Value: {}
            }
          }
        },
        Sta: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Value: {}
            }
          }
        },
        Stc: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Value: {
                type: "integer"
              }
            }
          }
        },
        Ste: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Value: {
                type: "integer"
              }
            }
          }
        },
        Stg: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Value: {}
            }
          }
        },
        Sti: {
          type: "structure",
          members: {
            CloudWatchLogOptions: {
              type: "structure",
              members: {
                LogEnabled: {
                  type: "boolean"
                },
                LogGroupArn: {},
                LogOutputFormat: {}
              }
            }
          }
        },
        Stm: {
          type: "structure",
          members: {
            CustomerGatewayConfiguration: {
              locationName: "customerGatewayConfiguration",
              type: "string",
              sensitive: true
            },
            CustomerGatewayId: {
              locationName: "customerGatewayId"
            },
            Category: {
              locationName: "category"
            },
            State: {
              locationName: "state"
            },
            Type: {
              locationName: "type"
            },
            VpnConnectionId: {
              locationName: "vpnConnectionId"
            },
            VpnGatewayId: {
              locationName: "vpnGatewayId"
            },
            TransitGatewayId: {
              locationName: "transitGatewayId"
            },
            CoreNetworkArn: {
              locationName: "coreNetworkArn"
            },
            CoreNetworkAttachmentArn: {
              locationName: "coreNetworkAttachmentArn"
            },
            GatewayAssociationState: {
              locationName: "gatewayAssociationState"
            },
            Options: {
              locationName: "options",
              type: "structure",
              members: {
                EnableAcceleration: {
                  locationName: "enableAcceleration",
                  type: "boolean"
                },
                StaticRoutesOnly: {
                  locationName: "staticRoutesOnly",
                  type: "boolean"
                },
                LocalIpv4NetworkCidr: {
                  locationName: "localIpv4NetworkCidr"
                },
                RemoteIpv4NetworkCidr: {
                  locationName: "remoteIpv4NetworkCidr"
                },
                LocalIpv6NetworkCidr: {
                  locationName: "localIpv6NetworkCidr"
                },
                RemoteIpv6NetworkCidr: {
                  locationName: "remoteIpv6NetworkCidr"
                },
                OutsideIpAddressType: {
                  locationName: "outsideIpAddressType"
                },
                TransportTransitGatewayAttachmentId: {
                  locationName: "transportTransitGatewayAttachmentId"
                },
                TunnelInsideIpVersion: {
                  locationName: "tunnelInsideIpVersion"
                },
                TunnelOptions: {
                  locationName: "tunnelOptionSet",
                  type: "list",
                  member: {
                    locationName: "item",
                    type: "structure",
                    members: {
                      OutsideIpAddress: {
                        locationName: "outsideIpAddress"
                      },
                      TunnelInsideCidr: {
                        locationName: "tunnelInsideCidr"
                      },
                      TunnelInsideIpv6Cidr: {
                        locationName: "tunnelInsideIpv6Cidr"
                      },
                      PreSharedKey: {
                        shape: "St3",
                        locationName: "preSharedKey"
                      },
                      Phase1LifetimeSeconds: {
                        locationName: "phase1LifetimeSeconds",
                        type: "integer"
                      },
                      Phase2LifetimeSeconds: {
                        locationName: "phase2LifetimeSeconds",
                        type: "integer"
                      },
                      RekeyMarginTimeSeconds: {
                        locationName: "rekeyMarginTimeSeconds",
                        type: "integer"
                      },
                      RekeyFuzzPercentage: {
                        locationName: "rekeyFuzzPercentage",
                        type: "integer"
                      },
                      ReplayWindowSize: {
                        locationName: "replayWindowSize",
                        type: "integer"
                      },
                      DpdTimeoutSeconds: {
                        locationName: "dpdTimeoutSeconds",
                        type: "integer"
                      },
                      DpdTimeoutAction: {
                        locationName: "dpdTimeoutAction"
                      },
                      Phase1EncryptionAlgorithms: {
                        locationName: "phase1EncryptionAlgorithmSet",
                        type: "list",
                        member: {
                          locationName: "item",
                          type: "structure",
                          members: {
                            Value: {
                              locationName: "value"
                            }
                          }
                        }
                      },
                      Phase2EncryptionAlgorithms: {
                        locationName: "phase2EncryptionAlgorithmSet",
                        type: "list",
                        member: {
                          locationName: "item",
                          type: "structure",
                          members: {
                            Value: {
                              locationName: "value"
                            }
                          }
                        }
                      },
                      Phase1IntegrityAlgorithms: {
                        locationName: "phase1IntegrityAlgorithmSet",
                        type: "list",
                        member: {
                          locationName: "item",
                          type: "structure",
                          members: {
                            Value: {
                              locationName: "value"
                            }
                          }
                        }
                      },
                      Phase2IntegrityAlgorithms: {
                        locationName: "phase2IntegrityAlgorithmSet",
                        type: "list",
                        member: {
                          locationName: "item",
                          type: "structure",
                          members: {
                            Value: {
                              locationName: "value"
                            }
                          }
                        }
                      },
                      Phase1DHGroupNumbers: {
                        locationName: "phase1DHGroupNumberSet",
                        type: "list",
                        member: {
                          locationName: "item",
                          type: "structure",
                          members: {
                            Value: {
                              locationName: "value",
                              type: "integer"
                            }
                          }
                        }
                      },
                      Phase2DHGroupNumbers: {
                        locationName: "phase2DHGroupNumberSet",
                        type: "list",
                        member: {
                          locationName: "item",
                          type: "structure",
                          members: {
                            Value: {
                              locationName: "value",
                              type: "integer"
                            }
                          }
                        }
                      },
                      IkeVersions: {
                        locationName: "ikeVersionSet",
                        type: "list",
                        member: {
                          locationName: "item",
                          type: "structure",
                          members: {
                            Value: {
                              locationName: "value"
                            }
                          }
                        }
                      },
                      StartupAction: {
                        locationName: "startupAction"
                      },
                      LogOptions: {
                        locationName: "logOptions",
                        type: "structure",
                        members: {
                          CloudWatchLogOptions: {
                            locationName: "cloudWatchLogOptions",
                            type: "structure",
                            members: {
                              LogEnabled: {
                                locationName: "logEnabled",
                                type: "boolean"
                              },
                              LogGroupArn: {
                                locationName: "logGroupArn"
                              },
                              LogOutputFormat: {
                                locationName: "logOutputFormat"
                              }
                            }
                          }
                        }
                      },
                      EnableTunnelLifecycleControl: {
                        locationName: "enableTunnelLifecycleControl",
                        type: "boolean"
                      }
                    }
                  }
                }
              }
            },
            Routes: {
              locationName: "routes",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  DestinationCidrBlock: {
                    locationName: "destinationCidrBlock"
                  },
                  Source: {
                    locationName: "source"
                  },
                  State: {
                    locationName: "state"
                  }
                }
              }
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            },
            VgwTelemetry: {
              locationName: "vgwTelemetry",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  AcceptedRouteCount: {
                    locationName: "acceptedRouteCount",
                    type: "integer"
                  },
                  LastStatusChange: {
                    locationName: "lastStatusChange",
                    type: "timestamp"
                  },
                  OutsideIpAddress: {
                    locationName: "outsideIpAddress"
                  },
                  Status: {
                    locationName: "status"
                  },
                  StatusMessage: {
                    locationName: "statusMessage"
                  },
                  CertificateArn: {
                    locationName: "certificateArn"
                  }
                }
              }
            }
          }
        },
        Suj: {
          type: "structure",
          members: {
            AvailabilityZone: {
              locationName: "availabilityZone"
            },
            State: {
              locationName: "state"
            },
            Type: {
              locationName: "type"
            },
            VpcAttachments: {
              locationName: "attachments",
              type: "list",
              member: {
                shape: "S6q",
                locationName: "item"
              }
            },
            VpnGatewayId: {
              locationName: "vpnGatewayId"
            },
            AmazonSideAsn: {
              locationName: "amazonSideAsn",
              type: "long"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        Sv1: {
          type: "list",
          member: {}
        },
        Svb: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Sw1: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Syy: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Szb: {
          type: "structure",
          members: {
            Asn: {
              locationName: "asn"
            },
            IpamId: {
              locationName: "ipamId"
            },
            StatusMessage: {
              locationName: "statusMessage"
            },
            State: {
              locationName: "state"
            }
          }
        },
        Szf: {
          type: "structure",
          members: {
            Cidr: {
              locationName: "cidr"
            },
            State: {
              locationName: "state"
            },
            FailureReason: {
              locationName: "failureReason",
              type: "structure",
              members: {
                Code: {
                  locationName: "code"
                },
                Message: {
                  locationName: "message"
                }
              }
            },
            IpamPoolCidrId: {
              locationName: "ipamPoolCidrId"
            },
            NetmaskLength: {
              locationName: "netmaskLength",
              type: "integer"
            }
          }
        },
        Szq: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Szs: {
          type: "structure",
          members: {
            InstanceTagKeys: {
              shape: "Szq",
              locationName: "instanceTagKeySet"
            },
            IncludeAllTagsOfInstance: {
              locationName: "includeAllTagsOfInstance",
              type: "boolean"
            }
          }
        },
        Szu: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S10d: {
          type: "list",
          member: {
            locationName: "Filter",
            type: "structure",
            members: {
              Name: {},
              Values: {
                shape: "So",
                locationName: "Value"
              }
            }
          }
        },
        S10q: {
          type: "structure",
          members: {
            PublicIp: {
              locationName: "publicIp"
            },
            AllocationId: {
              locationName: "allocationId"
            },
            PtrRecord: {
              locationName: "ptrRecord"
            },
            PtrRecordUpdate: {
              locationName: "ptrRecordUpdate",
              type: "structure",
              members: {
                Value: {
                  locationName: "value"
                },
                Status: {
                  locationName: "status"
                },
                Reason: {
                  locationName: "reason"
                }
              }
            }
          }
        },
        S10u: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Deadline: {
                locationName: "deadline",
                type: "timestamp"
              },
              Resource: {
                locationName: "resource"
              },
              UseLongIds: {
                locationName: "useLongIds",
                type: "boolean"
              }
            }
          }
        },
        S128: {
          type: "list",
          member: {
            locationName: "InstanceId"
          }
        },
        S12n: {
          type: "structure",
          members: {
            Code: {
              locationName: "code"
            },
            Message: {
              locationName: "message"
            }
          }
        },
        S13s: {
          type: "structure",
          members: {
            ConversionTaskId: {
              locationName: "conversionTaskId"
            },
            ExpirationTime: {
              locationName: "expirationTime"
            },
            ImportInstance: {
              locationName: "importInstance",
              type: "structure",
              members: {
                Description: {
                  locationName: "description"
                },
                InstanceId: {
                  locationName: "instanceId"
                },
                Platform: {
                  locationName: "platform"
                },
                Volumes: {
                  locationName: "volumes",
                  type: "list",
                  member: {
                    locationName: "item",
                    type: "structure",
                    members: {
                      AvailabilityZone: {
                        locationName: "availabilityZone"
                      },
                      BytesConverted: {
                        locationName: "bytesConverted",
                        type: "long"
                      },
                      Description: {
                        locationName: "description"
                      },
                      Image: {
                        shape: "S13w",
                        locationName: "image"
                      },
                      Status: {
                        locationName: "status"
                      },
                      StatusMessage: {
                        locationName: "statusMessage"
                      },
                      Volume: {
                        shape: "S13y",
                        locationName: "volume"
                      }
                    }
                  }
                }
              }
            },
            ImportVolume: {
              locationName: "importVolume",
              type: "structure",
              members: {
                AvailabilityZone: {
                  locationName: "availabilityZone"
                },
                BytesConverted: {
                  locationName: "bytesConverted",
                  type: "long"
                },
                Description: {
                  locationName: "description"
                },
                Image: {
                  shape: "S13w",
                  locationName: "image"
                },
                Volume: {
                  shape: "S13y",
                  locationName: "volume"
                }
              }
            },
            State: {
              locationName: "state"
            },
            StatusMessage: {
              locationName: "statusMessage"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        S13w: {
          type: "structure",
          members: {
            Checksum: {
              locationName: "checksum"
            },
            Format: {
              locationName: "format"
            },
            ImportManifestUrl: {
              shape: "S13x",
              locationName: "importManifestUrl"
            },
            Size: {
              locationName: "size",
              type: "long"
            }
          }
        },
        S13x: {
          type: "string",
          sensitive: true
        },
        S13y: {
          type: "structure",
          members: {
            Id: {
              locationName: "id"
            },
            Size: {
              locationName: "size",
              type: "long"
            }
          }
        },
        S14w: {
          type: "structure",
          members: {
            S3Bucket: {
              locationName: "s3Bucket"
            },
            S3Prefix: {
              locationName: "s3Prefix"
            }
          }
        },
        S159: {
          type: "structure",
          members: {
            TargetResourceCount: {
              locationName: "targetResourceCount",
              type: "integer"
            }
          }
        },
        S15a: {
          type: "structure",
          members: {
            LaunchTemplateId: {
              locationName: "launchTemplateId"
            },
            LaunchTemplateName: {
              locationName: "launchTemplateName"
            },
            Version: {
              locationName: "version"
            }
          }
        },
        S15n: {
          type: "structure",
          members: {
            EventDescription: {
              locationName: "eventDescription"
            },
            EventSubType: {
              locationName: "eventSubType"
            },
            InstanceId: {
              locationName: "instanceId"
            }
          }
        },
        S15q: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              InstanceId: {
                locationName: "instanceId"
              },
              InstanceType: {
                locationName: "instanceType"
              },
              SpotInstanceRequestId: {
                locationName: "spotInstanceRequestId"
              },
              InstanceHealth: {
                locationName: "instanceHealth"
              }
            }
          }
        },
        S16j: {
          type: "structure",
          members: {
            FpgaImageId: {
              locationName: "fpgaImageId"
            },
            Name: {
              locationName: "name"
            },
            Description: {
              locationName: "description"
            },
            LoadPermissions: {
              locationName: "loadPermissions",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  UserId: {
                    locationName: "userId"
                  },
                  Group: {
                    locationName: "group"
                  }
                }
              }
            },
            ProductCodes: {
              shape: "S16n",
              locationName: "productCodes"
            }
          }
        },
        S16n: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              ProductCodeId: {
                locationName: "productCode"
              },
              ProductCodeType: {
                locationName: "type"
              }
            }
          }
        },
        S16s: {
          type: "list",
          member: {
            locationName: "Owner"
          }
        },
        S17d: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S17g: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S185: {
          type: "list",
          member: {
            shape: "Ses",
            locationName: "item"
          }
        },
        S186: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Group: {
                locationName: "group"
              },
              UserId: {
                locationName: "userId"
              },
              OrganizationArn: {
                locationName: "organizationArn"
              },
              OrganizationalUnitArn: {
                locationName: "organizationalUnitArn"
              }
            }
          }
        },
        S18a: {
          type: "list",
          member: {
            locationName: "ImageId"
          }
        },
        S18t: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Description: {
                locationName: "description"
              },
              DeviceName: {
                locationName: "deviceName"
              },
              DiskImageSize: {
                locationName: "diskImageSize",
                type: "double"
              },
              Format: {
                locationName: "format"
              },
              Progress: {
                locationName: "progress"
              },
              SnapshotId: {
                locationName: "snapshotId"
              },
              Status: {
                locationName: "status"
              },
              StatusMessage: {
                locationName: "statusMessage"
              },
              Url: {
                shape: "S18v",
                locationName: "url"
              },
              UserBucket: {
                shape: "S18w",
                locationName: "userBucket"
              }
            }
          }
        },
        S18v: {
          type: "string",
          sensitive: true
        },
        S18w: {
          type: "structure",
          members: {
            S3Bucket: {
              locationName: "s3Bucket"
            },
            S3Key: {
              locationName: "s3Key"
            }
          }
        },
        S18x: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              LicenseConfigurationArn: {
                locationName: "licenseConfigurationArn"
              }
            }
          }
        },
        S195: {
          type: "structure",
          members: {
            Description: {
              locationName: "description"
            },
            DiskImageSize: {
              locationName: "diskImageSize",
              type: "double"
            },
            Encrypted: {
              locationName: "encrypted",
              type: "boolean"
            },
            Format: {
              locationName: "format"
            },
            KmsKeyId: {
              locationName: "kmsKeyId"
            },
            Progress: {
              locationName: "progress"
            },
            SnapshotId: {
              locationName: "snapshotId"
            },
            Status: {
              locationName: "status"
            },
            StatusMessage: {
              locationName: "statusMessage"
            },
            Url: {
              shape: "S18v",
              locationName: "url"
            },
            UserBucket: {
              shape: "S18w",
              locationName: "userBucket"
            }
          }
        },
        S199: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              DeviceName: {
                locationName: "deviceName"
              },
              Ebs: {
                locationName: "ebs",
                type: "structure",
                members: {
                  AttachTime: {
                    locationName: "attachTime",
                    type: "timestamp"
                  },
                  DeleteOnTermination: {
                    locationName: "deleteOnTermination",
                    type: "boolean"
                  },
                  Status: {
                    locationName: "status"
                  },
                  VolumeId: {
                    locationName: "volumeId"
                  }
                }
              }
            }
          }
        },
        S19c: {
          type: "structure",
          members: {
            Value: {
              locationName: "value",
              type: "boolean"
            }
          }
        },
        S19d: {
          type: "structure",
          members: {
            Enabled: {
              locationName: "enabled",
              type: "boolean"
            }
          }
        },
        S19z: {
          type: "structure",
          members: {
            InstanceEventId: {
              locationName: "instanceEventId"
            },
            Code: {
              locationName: "code"
            },
            Description: {
              locationName: "description"
            },
            NotAfter: {
              locationName: "notAfter",
              type: "timestamp"
            },
            NotBefore: {
              locationName: "notBefore",
              type: "timestamp"
            },
            NotBeforeDeadline: {
              locationName: "notBeforeDeadline",
              type: "timestamp"
            }
          }
        },
        S1a2: {
          type: "structure",
          members: {
            Code: {
              locationName: "code",
              type: "integer"
            },
            Name: {
              locationName: "name"
            }
          }
        },
        S1a4: {
          type: "structure",
          members: {
            Details: {
              locationName: "details",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  ImpairedSince: {
                    locationName: "impairedSince",
                    type: "timestamp"
                  },
                  Name: {
                    locationName: "name"
                  },
                  Status: {
                    locationName: "status"
                  }
                }
              }
            },
            Status: {
              locationName: "status"
            }
          }
        },
        S1du: {
          type: "structure",
          members: {
            Groups: {
              shape: "Sly",
              locationName: "groupSet"
            },
            Instances: {
              locationName: "instancesSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  AmiLaunchIndex: {
                    locationName: "amiLaunchIndex",
                    type: "integer"
                  },
                  ImageId: {
                    locationName: "imageId"
                  },
                  InstanceId: {
                    locationName: "instanceId"
                  },
                  InstanceType: {
                    locationName: "instanceType"
                  },
                  KernelId: {
                    locationName: "kernelId"
                  },
                  KeyName: {
                    locationName: "keyName"
                  },
                  LaunchTime: {
                    locationName: "launchTime",
                    type: "timestamp"
                  },
                  Monitoring: {
                    shape: "S1dx",
                    locationName: "monitoring"
                  },
                  Placement: {
                    shape: "Scr",
                    locationName: "placement"
                  },
                  Platform: {
                    locationName: "platform"
                  },
                  PrivateDnsName: {
                    locationName: "privateDnsName"
                  },
                  PrivateIpAddress: {
                    locationName: "privateIpAddress"
                  },
                  ProductCodes: {
                    shape: "S16n",
                    locationName: "productCodes"
                  },
                  PublicDnsName: {
                    locationName: "dnsName"
                  },
                  PublicIpAddress: {
                    locationName: "ipAddress"
                  },
                  RamdiskId: {
                    locationName: "ramdiskId"
                  },
                  State: {
                    shape: "S1a2",
                    locationName: "instanceState"
                  },
                  StateTransitionReason: {
                    locationName: "reason"
                  },
                  SubnetId: {
                    locationName: "subnetId"
                  },
                  VpcId: {
                    locationName: "vpcId"
                  },
                  Architecture: {
                    locationName: "architecture"
                  },
                  BlockDeviceMappings: {
                    shape: "S199",
                    locationName: "blockDeviceMapping"
                  },
                  ClientToken: {
                    locationName: "clientToken"
                  },
                  EbsOptimized: {
                    locationName: "ebsOptimized",
                    type: "boolean"
                  },
                  EnaSupport: {
                    locationName: "enaSupport",
                    type: "boolean"
                  },
                  Hypervisor: {
                    locationName: "hypervisor"
                  },
                  IamInstanceProfile: {
                    shape: "S3y",
                    locationName: "iamInstanceProfile"
                  },
                  InstanceLifecycle: {
                    locationName: "instanceLifecycle"
                  },
                  ElasticGpuAssociations: {
                    locationName: "elasticGpuAssociationSet",
                    type: "list",
                    member: {
                      locationName: "item",
                      type: "structure",
                      members: {
                        ElasticGpuId: {
                          locationName: "elasticGpuId"
                        },
                        ElasticGpuAssociationId: {
                          locationName: "elasticGpuAssociationId"
                        },
                        ElasticGpuAssociationState: {
                          locationName: "elasticGpuAssociationState"
                        },
                        ElasticGpuAssociationTime: {
                          locationName: "elasticGpuAssociationTime"
                        }
                      }
                    }
                  },
                  ElasticInferenceAcceleratorAssociations: {
                    locationName: "elasticInferenceAcceleratorAssociationSet",
                    type: "list",
                    member: {
                      locationName: "item",
                      type: "structure",
                      members: {
                        ElasticInferenceAcceleratorArn: {
                          locationName: "elasticInferenceAcceleratorArn"
                        },
                        ElasticInferenceAcceleratorAssociationId: {
                          locationName: "elasticInferenceAcceleratorAssociationId"
                        },
                        ElasticInferenceAcceleratorAssociationState: {
                          locationName: "elasticInferenceAcceleratorAssociationState"
                        },
                        ElasticInferenceAcceleratorAssociationTime: {
                          locationName: "elasticInferenceAcceleratorAssociationTime",
                          type: "timestamp"
                        }
                      }
                    }
                  },
                  NetworkInterfaces: {
                    locationName: "networkInterfaceSet",
                    type: "list",
                    member: {
                      locationName: "item",
                      type: "structure",
                      members: {
                        Association: {
                          shape: "S1e6",
                          locationName: "association"
                        },
                        Attachment: {
                          locationName: "attachment",
                          type: "structure",
                          members: {
                            AttachTime: {
                              locationName: "attachTime",
                              type: "timestamp"
                            },
                            AttachmentId: {
                              locationName: "attachmentId"
                            },
                            DeleteOnTermination: {
                              locationName: "deleteOnTermination",
                              type: "boolean"
                            },
                            DeviceIndex: {
                              locationName: "deviceIndex",
                              type: "integer"
                            },
                            Status: {
                              locationName: "status"
                            },
                            NetworkCardIndex: {
                              locationName: "networkCardIndex",
                              type: "integer"
                            },
                            EnaSrdSpecification: {
                              locationName: "enaSrdSpecification",
                              type: "structure",
                              members: {
                                EnaSrdEnabled: {
                                  locationName: "enaSrdEnabled",
                                  type: "boolean"
                                },
                                EnaSrdUdpSpecification: {
                                  locationName: "enaSrdUdpSpecification",
                                  type: "structure",
                                  members: {
                                    EnaSrdUdpEnabled: {
                                      locationName: "enaSrdUdpEnabled",
                                      type: "boolean"
                                    }
                                  }
                                }
                              }
                            }
                          }
                        },
                        Description: {
                          locationName: "description"
                        },
                        Groups: {
                          shape: "Sly",
                          locationName: "groupSet"
                        },
                        Ipv6Addresses: {
                          shape: "Siq",
                          locationName: "ipv6AddressesSet"
                        },
                        MacAddress: {
                          locationName: "macAddress"
                        },
                        NetworkInterfaceId: {
                          locationName: "networkInterfaceId"
                        },
                        OwnerId: {
                          locationName: "ownerId"
                        },
                        PrivateDnsName: {
                          locationName: "privateDnsName"
                        },
                        PrivateIpAddress: {
                          locationName: "privateIpAddress"
                        },
                        PrivateIpAddresses: {
                          locationName: "privateIpAddressesSet",
                          type: "list",
                          member: {
                            locationName: "item",
                            type: "structure",
                            members: {
                              Association: {
                                shape: "S1e6",
                                locationName: "association"
                              },
                              Primary: {
                                locationName: "primary",
                                type: "boolean"
                              },
                              PrivateDnsName: {
                                locationName: "privateDnsName"
                              },
                              PrivateIpAddress: {
                                locationName: "privateIpAddress"
                              }
                            }
                          }
                        },
                        SourceDestCheck: {
                          locationName: "sourceDestCheck",
                          type: "boolean"
                        },
                        Status: {
                          locationName: "status"
                        },
                        SubnetId: {
                          locationName: "subnetId"
                        },
                        VpcId: {
                          locationName: "vpcId"
                        },
                        InterfaceType: {
                          locationName: "interfaceType"
                        },
                        Ipv4Prefixes: {
                          locationName: "ipv4PrefixSet",
                          type: "list",
                          member: {
                            locationName: "item",
                            type: "structure",
                            members: {
                              Ipv4Prefix: {
                                locationName: "ipv4Prefix"
                              }
                            }
                          }
                        },
                        Ipv6Prefixes: {
                          locationName: "ipv6PrefixSet",
                          type: "list",
                          member: {
                            locationName: "item",
                            type: "structure",
                            members: {
                              Ipv6Prefix: {
                                locationName: "ipv6Prefix"
                              }
                            }
                          }
                        },
                        ConnectionTrackingConfiguration: {
                          locationName: "connectionTrackingConfiguration",
                          type: "structure",
                          members: {
                            TcpEstablishedTimeout: {
                              locationName: "tcpEstablishedTimeout",
                              type: "integer"
                            },
                            UdpStreamTimeout: {
                              locationName: "udpStreamTimeout",
                              type: "integer"
                            },
                            UdpTimeout: {
                              locationName: "udpTimeout",
                              type: "integer"
                            }
                          }
                        }
                      }
                    }
                  },
                  OutpostArn: {
                    locationName: "outpostArn"
                  },
                  RootDeviceName: {
                    locationName: "rootDeviceName"
                  },
                  RootDeviceType: {
                    locationName: "rootDeviceType"
                  },
                  SecurityGroups: {
                    shape: "Sly",
                    locationName: "groupSet"
                  },
                  SourceDestCheck: {
                    locationName: "sourceDestCheck",
                    type: "boolean"
                  },
                  SpotInstanceRequestId: {
                    locationName: "spotInstanceRequestId"
                  },
                  SriovNetSupport: {
                    locationName: "sriovNetSupport"
                  },
                  StateReason: {
                    shape: "Sjw",
                    locationName: "stateReason"
                  },
                  Tags: {
                    shape: "S6",
                    locationName: "tagSet"
                  },
                  VirtualizationType: {
                    locationName: "virtualizationType"
                  },
                  CpuOptions: {
                    locationName: "cpuOptions",
                    type: "structure",
                    members: {
                      CoreCount: {
                        locationName: "coreCount",
                        type: "integer"
                      },
                      ThreadsPerCore: {
                        locationName: "threadsPerCore",
                        type: "integer"
                      },
                      AmdSevSnp: {
                        locationName: "amdSevSnp"
                      }
                    }
                  },
                  CapacityReservationId: {
                    locationName: "capacityReservationId"
                  },
                  CapacityReservationSpecification: {
                    locationName: "capacityReservationSpecification",
                    type: "structure",
                    members: {
                      CapacityReservationPreference: {
                        locationName: "capacityReservationPreference"
                      },
                      CapacityReservationTarget: {
                        shape: "Sjc",
                        locationName: "capacityReservationTarget"
                      }
                    }
                  },
                  HibernationOptions: {
                    locationName: "hibernationOptions",
                    type: "structure",
                    members: {
                      Configured: {
                        locationName: "configured",
                        type: "boolean"
                      }
                    }
                  },
                  Licenses: {
                    locationName: "licenseSet",
                    type: "list",
                    member: {
                      locationName: "item",
                      type: "structure",
                      members: {
                        LicenseConfigurationArn: {
                          locationName: "licenseConfigurationArn"
                        }
                      }
                    }
                  },
                  MetadataOptions: {
                    shape: "S1em",
                    locationName: "metadataOptions"
                  },
                  EnclaveOptions: {
                    shape: "S19d",
                    locationName: "enclaveOptions"
                  },
                  BootMode: {
                    locationName: "bootMode"
                  },
                  PlatformDetails: {
                    locationName: "platformDetails"
                  },
                  UsageOperation: {
                    locationName: "usageOperation"
                  },
                  UsageOperationUpdateTime: {
                    locationName: "usageOperationUpdateTime",
                    type: "timestamp"
                  },
                  PrivateDnsNameOptions: {
                    locationName: "privateDnsNameOptions",
                    type: "structure",
                    members: {
                      HostnameType: {
                        locationName: "hostnameType"
                      },
                      EnableResourceNameDnsARecord: {
                        locationName: "enableResourceNameDnsARecord",
                        type: "boolean"
                      },
                      EnableResourceNameDnsAAAARecord: {
                        locationName: "enableResourceNameDnsAAAARecord",
                        type: "boolean"
                      }
                    }
                  },
                  Ipv6Address: {
                    locationName: "ipv6Address"
                  },
                  TpmSupport: {
                    locationName: "tpmSupport"
                  },
                  MaintenanceOptions: {
                    locationName: "maintenanceOptions",
                    type: "structure",
                    members: {
                      AutoRecovery: {
                        locationName: "autoRecovery"
                      }
                    }
                  },
                  CurrentInstanceBootMode: {
                    locationName: "currentInstanceBootMode"
                  }
                }
              }
            },
            OwnerId: {
              locationName: "ownerId"
            },
            RequesterId: {
              locationName: "requesterId"
            },
            ReservationId: {
              locationName: "reservationId"
            }
          }
        },
        S1dx: {
          type: "structure",
          members: {
            State: {
              locationName: "state"
            }
          }
        },
        S1e6: {
          type: "structure",
          members: {
            CarrierIp: {
              locationName: "carrierIp"
            },
            CustomerOwnedIp: {
              locationName: "customerOwnedIp"
            },
            IpOwnerId: {
              locationName: "ipOwnerId"
            },
            PublicDnsName: {
              locationName: "publicDnsName"
            },
            PublicIp: {
              locationName: "publicIp"
            }
          }
        },
        S1em: {
          type: "structure",
          members: {
            State: {
              locationName: "state"
            },
            HttpTokens: {
              locationName: "httpTokens"
            },
            HttpPutResponseHopLimit: {
              locationName: "httpPutResponseHopLimit",
              type: "integer"
            },
            HttpEndpoint: {
              locationName: "httpEndpoint"
            },
            HttpProtocolIpv6: {
              locationName: "httpProtocolIpv6"
            },
            InstanceMetadataTags: {
              locationName: "instanceMetadataTags"
            }
          }
        },
        S1gq: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S1h3: {
          type: "list",
          member: {
            locationName: "SnapshotId"
          }
        },
        S1hz: {
          type: "structure",
          members: {
            NetworkInsightsAccessScopeAnalysisId: {
              locationName: "networkInsightsAccessScopeAnalysisId"
            },
            NetworkInsightsAccessScopeAnalysisArn: {
              locationName: "networkInsightsAccessScopeAnalysisArn"
            },
            NetworkInsightsAccessScopeId: {
              locationName: "networkInsightsAccessScopeId"
            },
            Status: {
              locationName: "status"
            },
            StatusMessage: {
              locationName: "statusMessage"
            },
            WarningMessage: {
              locationName: "warningMessage"
            },
            StartDate: {
              locationName: "startDate",
              type: "timestamp"
            },
            EndDate: {
              locationName: "endDate",
              type: "timestamp"
            },
            FindingsFound: {
              locationName: "findingsFound"
            },
            AnalyzedEniCount: {
              locationName: "analyzedEniCount",
              type: "integer"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        S1ia: {
          type: "structure",
          members: {
            NetworkInsightsAnalysisId: {
              locationName: "networkInsightsAnalysisId"
            },
            NetworkInsightsAnalysisArn: {
              locationName: "networkInsightsAnalysisArn"
            },
            NetworkInsightsPathId: {
              locationName: "networkInsightsPathId"
            },
            AdditionalAccounts: {
              shape: "So",
              locationName: "additionalAccountSet"
            },
            FilterInArns: {
              shape: "S1ib",
              locationName: "filterInArnSet"
            },
            StartDate: {
              locationName: "startDate",
              type: "timestamp"
            },
            Status: {
              locationName: "status"
            },
            StatusMessage: {
              locationName: "statusMessage"
            },
            WarningMessage: {
              locationName: "warningMessage"
            },
            NetworkPathFound: {
              locationName: "networkPathFound",
              type: "boolean"
            },
            ForwardPathComponents: {
              shape: "S1ic",
              locationName: "forwardPathComponentSet"
            },
            ReturnPathComponents: {
              shape: "S1ic",
              locationName: "returnPathComponentSet"
            },
            Explanations: {
              shape: "S1iw",
              locationName: "explanationSet"
            },
            AlternatePathHints: {
              locationName: "alternatePathHintSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  ComponentId: {
                    locationName: "componentId"
                  },
                  ComponentArn: {
                    locationName: "componentArn"
                  }
                }
              }
            },
            SuggestedAccounts: {
              shape: "So",
              locationName: "suggestedAccountSet"
            },
            Tags: {
              shape: "S6",
              locationName: "tagSet"
            }
          }
        },
        S1ib: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S1ic: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              SequenceNumber: {
                locationName: "sequenceNumber",
                type: "integer"
              },
              AclRule: {
                shape: "S1ie",
                locationName: "aclRule"
              },
              AttachedTo: {
                shape: "S1if",
                locationName: "attachedTo"
              },
              Component: {
                shape: "S1if",
                locationName: "component"
              },
              DestinationVpc: {
                shape: "S1if",
                locationName: "destinationVpc"
              },
              OutboundHeader: {
                shape: "S1ig",
                locationName: "outboundHeader"
              },
              InboundHeader: {
                shape: "S1ig",
                locationName: "inboundHeader"
              },
              RouteTableRoute: {
                shape: "S1ij",
                locationName: "routeTableRoute"
              },
              SecurityGroupRule: {
                shape: "S1ik",
                locationName: "securityGroupRule"
              },
              SourceVpc: {
                shape: "S1if",
                locationName: "sourceVpc"
              },
              Subnet: {
                shape: "S1if",
                locationName: "subnet"
              },
              Vpc: {
                shape: "S1if",
                locationName: "vpc"
              },
              AdditionalDetails: {
                locationName: "additionalDetailSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    AdditionalDetailType: {
                      locationName: "additionalDetailType"
                    },
                    Component: {
                      shape: "S1if",
                      locationName: "component"
                    },
                    VpcEndpointService: {
                      shape: "S1if",
                      locationName: "vpcEndpointService"
                    },
                    RuleOptions: {
                      shape: "S1in",
                      locationName: "ruleOptionSet"
                    },
                    RuleGroupTypePairs: {
                      locationName: "ruleGroupTypePairSet",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          RuleGroupArn: {
                            locationName: "ruleGroupArn"
                          },
                          RuleGroupType: {
                            locationName: "ruleGroupType"
                          }
                        }
                      }
                    },
                    RuleGroupRuleOptionsPairs: {
                      locationName: "ruleGroupRuleOptionsPairSet",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          RuleGroupArn: {
                            locationName: "ruleGroupArn"
                          },
                          RuleOptions: {
                            shape: "S1in",
                            locationName: "ruleOptionSet"
                          }
                        }
                      }
                    },
                    ServiceName: {
                      locationName: "serviceName"
                    },
                    LoadBalancers: {
                      shape: "S1iu",
                      locationName: "loadBalancerSet"
                    }
                  }
                }
              },
              TransitGateway: {
                shape: "S1if",
                locationName: "transitGateway"
              },
              TransitGatewayRouteTableRoute: {
                shape: "S1iv",
                locationName: "transitGatewayRouteTableRoute"
              },
              Explanations: {
                shape: "S1iw",
                locationName: "explanationSet"
              },
              ElasticLoadBalancerListener: {
                shape: "S1if",
                locationName: "elasticLoadBalancerListener"
              },
              FirewallStatelessRule: {
                shape: "S1j2",
                locationName: "firewallStatelessRule"
              },
              FirewallStatefulRule: {
                shape: "S1j6",
                locationName: "firewallStatefulRule"
              },
              ServiceName: {
                locationName: "serviceName"
              }
            }
          }
        },
        S1ie: {
          type: "structure",
          members: {
            Cidr: {
              locationName: "cidr"
            },
            Egress: {
              locationName: "egress",
              type: "boolean"
            },
            PortRange: {
              shape: "Skp",
              locationName: "portRange"
            },
            Protocol: {
              locationName: "protocol"
            },
            RuleAction: {
              locationName: "ruleAction"
            },
            RuleNumber: {
              locationName: "ruleNumber",
              type: "integer"
            }
          }
        },
        S1if: {
          type: "structure",
          members: {
            Id: {
              locationName: "id"
            },
            Arn: {
              locationName: "arn"
            },
            Name: {
              locationName: "name"
            }
          }
        },
        S1ig: {
          type: "structure",
          members: {
            DestinationAddresses: {
              shape: "S1ih",
              locationName: "destinationAddressSet"
            },
            DestinationPortRanges: {
              shape: "S1ii",
              locationName: "destinationPortRangeSet"
            },
            Protocol: {
              locationName: "protocol"
            },
            SourceAddresses: {
              shape: "S1ih",
              locationName: "sourceAddressSet"
            },
            SourcePortRanges: {
              shape: "S1ii",
              locationName: "sourcePortRangeSet"
            }
          }
        },
        S1ih: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S1ii: {
          type: "list",
          member: {
            shape: "Skp",
            locationName: "item"
          }
        },
        S1ij: {
          type: "structure",
          members: {
            DestinationCidr: {
              locationName: "destinationCidr"
            },
            DestinationPrefixListId: {
              locationName: "destinationPrefixListId"
            },
            EgressOnlyInternetGatewayId: {
              locationName: "egressOnlyInternetGatewayId"
            },
            GatewayId: {
              locationName: "gatewayId"
            },
            InstanceId: {
              locationName: "instanceId"
            },
            NatGatewayId: {
              locationName: "natGatewayId"
            },
            NetworkInterfaceId: {
              locationName: "networkInterfaceId"
            },
            Origin: {
              locationName: "origin"
            },
            TransitGatewayId: {
              locationName: "transitGatewayId"
            },
            VpcPeeringConnectionId: {
              locationName: "vpcPeeringConnectionId"
            },
            State: {
              locationName: "state"
            },
            CarrierGatewayId: {
              locationName: "carrierGatewayId"
            },
            CoreNetworkArn: {
              locationName: "coreNetworkArn"
            },
            LocalGatewayId: {
              locationName: "localGatewayId"
            }
          }
        },
        S1ik: {
          type: "structure",
          members: {
            Cidr: {
              locationName: "cidr"
            },
            Direction: {
              locationName: "direction"
            },
            SecurityGroupId: {
              locationName: "securityGroupId"
            },
            PortRange: {
              shape: "Skp",
              locationName: "portRange"
            },
            PrefixListId: {
              locationName: "prefixListId"
            },
            Protocol: {
              locationName: "protocol"
            }
          }
        },
        S1in: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Keyword: {
                locationName: "keyword"
              },
              Settings: {
                shape: "S1ip",
                locationName: "settingSet"
              }
            }
          }
        },
        S1ip: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S1iu: {
          type: "list",
          member: {
            shape: "S1if",
            locationName: "item"
          }
        },
        S1iv: {
          type: "structure",
          members: {
            DestinationCidr: {
              locationName: "destinationCidr"
            },
            State: {
              locationName: "state"
            },
            RouteOrigin: {
              locationName: "routeOrigin"
            },
            PrefixListId: {
              locationName: "prefixListId"
            },
            AttachmentId: {
              locationName: "attachmentId"
            },
            ResourceId: {
              locationName: "resourceId"
            },
            ResourceType: {
              locationName: "resourceType"
            }
          }
        },
        S1iw: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Acl: {
                shape: "S1if",
                locationName: "acl"
              },
              AclRule: {
                shape: "S1ie",
                locationName: "aclRule"
              },
              Address: {
                locationName: "address"
              },
              Addresses: {
                shape: "S1ih",
                locationName: "addressSet"
              },
              AttachedTo: {
                shape: "S1if",
                locationName: "attachedTo"
              },
              AvailabilityZones: {
                shape: "So",
                locationName: "availabilityZoneSet"
              },
              Cidrs: {
                shape: "So",
                locationName: "cidrSet"
              },
              Component: {
                shape: "S1if",
                locationName: "component"
              },
              CustomerGateway: {
                shape: "S1if",
                locationName: "customerGateway"
              },
              Destination: {
                shape: "S1if",
                locationName: "destination"
              },
              DestinationVpc: {
                shape: "S1if",
                locationName: "destinationVpc"
              },
              Direction: {
                locationName: "direction"
              },
              ExplanationCode: {
                locationName: "explanationCode"
              },
              IngressRouteTable: {
                shape: "S1if",
                locationName: "ingressRouteTable"
              },
              InternetGateway: {
                shape: "S1if",
                locationName: "internetGateway"
              },
              LoadBalancerArn: {
                locationName: "loadBalancerArn"
              },
              ClassicLoadBalancerListener: {
                locationName: "classicLoadBalancerListener",
                type: "structure",
                members: {
                  LoadBalancerPort: {
                    locationName: "loadBalancerPort",
                    type: "integer"
                  },
                  InstancePort: {
                    locationName: "instancePort",
                    type: "integer"
                  }
                }
              },
              LoadBalancerListenerPort: {
                locationName: "loadBalancerListenerPort",
                type: "integer"
              },
              LoadBalancerTarget: {
                locationName: "loadBalancerTarget",
                type: "structure",
                members: {
                  Address: {
                    locationName: "address"
                  },
                  AvailabilityZone: {
                    locationName: "availabilityZone"
                  },
                  Instance: {
                    shape: "S1if",
                    locationName: "instance"
                  },
                  Port: {
                    locationName: "port",
                    type: "integer"
                  }
                }
              },
              LoadBalancerTargetGroup: {
                shape: "S1if",
                locationName: "loadBalancerTargetGroup"
              },
              LoadBalancerTargetGroups: {
                shape: "S1iu",
                locationName: "loadBalancerTargetGroupSet"
              },
              LoadBalancerTargetPort: {
                locationName: "loadBalancerTargetPort",
                type: "integer"
              },
              ElasticLoadBalancerListener: {
                shape: "S1if",
                locationName: "elasticLoadBalancerListener"
              },
              MissingComponent: {
                locationName: "missingComponent"
              },
              NatGateway: {
                shape: "S1if",
                locationName: "natGateway"
              },
              NetworkInterface: {
                shape: "S1if",
                locationName: "networkInterface"
              },
              PacketField: {
                locationName: "packetField"
              },
              VpcPeeringConnection: {
                shape: "S1if",
                locationName: "vpcPeeringConnection"
              },
              Port: {
                locationName: "port",
                type: "integer"
              },
              PortRanges: {
                shape: "S1ii",
                locationName: "portRangeSet"
              },
              PrefixList: {
                shape: "S1if",
                locationName: "prefixList"
              },
              Protocols: {
                shape: "S1ip",
                locationName: "protocolSet"
              },
              RouteTableRoute: {
                shape: "S1ij",
                locationName: "routeTableRoute"
              },
              RouteTable: {
                shape: "S1if",
                locationName: "routeTable"
              },
              SecurityGroup: {
                shape: "S1if",
                locationName: "securityGroup"
              },
              SecurityGroupRule: {
                shape: "S1ik",
                locationName: "securityGroupRule"
              },
              SecurityGroups: {
                shape: "S1iu",
                locationName: "securityGroupSet"
              },
              SourceVpc: {
                shape: "S1if",
                locationName: "sourceVpc"
              },
              State: {
                locationName: "state"
              },
              Subnet: {
                shape: "S1if",
                locationName: "subnet"
              },
              SubnetRouteTable: {
                shape: "S1if",
                locationName: "subnetRouteTable"
              },
              Vpc: {
                shape: "S1if",
                locationName: "vpc"
              },
              VpcEndpoint: {
                shape: "S1if",
                locationName: "vpcEndpoint"
              },
              VpnConnection: {
                shape: "S1if",
                locationName: "vpnConnection"
              },
              VpnGateway: {
                shape: "S1if",
                locationName: "vpnGateway"
              },
              TransitGateway: {
                shape: "S1if",
                locationName: "transitGateway"
              },
              TransitGatewayRouteTable: {
                shape: "S1if",
                locationName: "transitGatewayRouteTable"
              },
              TransitGatewayRouteTableRoute: {
                shape: "S1iv",
                locationName: "transitGatewayRouteTableRoute"
              },
              TransitGatewayAttachment: {
                shape: "S1if",
                locationName: "transitGatewayAttachment"
              },
              ComponentAccount: {
                locationName: "componentAccount"
              },
              ComponentRegion: {
                locationName: "componentRegion"
              },
              FirewallStatelessRule: {
                shape: "S1j2",
                locationName: "firewallStatelessRule"
              },
              FirewallStatefulRule: {
                shape: "S1j6",
                locationName: "firewallStatefulRule"
              }
            }
          }
        },
        S1j2: {
          type: "structure",
          members: {
            RuleGroupArn: {
              locationName: "ruleGroupArn"
            },
            Sources: {
              shape: "So",
              locationName: "sourceSet"
            },
            Destinations: {
              shape: "So",
              locationName: "destinationSet"
            },
            SourcePorts: {
              shape: "S1ii",
              locationName: "sourcePortSet"
            },
            DestinationPorts: {
              shape: "S1ii",
              locationName: "destinationPortSet"
            },
            Protocols: {
              locationName: "protocolSet",
              type: "list",
              member: {
                locationName: "item",
                type: "integer"
              }
            },
            RuleAction: {
              locationName: "ruleAction"
            },
            Priority: {
              locationName: "priority",
              type: "integer"
            }
          }
        },
        S1j6: {
          type: "structure",
          members: {
            RuleGroupArn: {
              locationName: "ruleGroupArn"
            },
            Sources: {
              shape: "So",
              locationName: "sourceSet"
            },
            Destinations: {
              shape: "So",
              locationName: "destinationSet"
            },
            SourcePorts: {
              shape: "S1ii",
              locationName: "sourcePortSet"
            },
            DestinationPorts: {
              shape: "S1ii",
              locationName: "destinationPortSet"
            },
            Protocol: {
              locationName: "protocol"
            },
            RuleAction: {
              locationName: "ruleAction"
            },
            Direction: {
              locationName: "direction"
            }
          }
        },
        S1kd: {
          type: "structure",
          members: {
            FirstAddress: {
              locationName: "firstAddress"
            },
            LastAddress: {
              locationName: "lastAddress"
            },
            AddressCount: {
              locationName: "addressCount",
              type: "integer"
            },
            AvailableAddressCount: {
              locationName: "availableAddressCount",
              type: "integer"
            }
          }
        },
        S1kq: {
          type: "list",
          member: {
            locationName: "ReservedInstancesId"
          }
        },
        S1ky: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Amount: {
                locationName: "amount",
                type: "double"
              },
              Frequency: {
                locationName: "frequency"
              }
            }
          }
        },
        S1lc: {
          type: "structure",
          members: {
            AvailabilityZone: {
              locationName: "availabilityZone"
            },
            InstanceCount: {
              locationName: "instanceCount",
              type: "integer"
            },
            InstanceType: {
              locationName: "instanceType"
            },
            Platform: {
              locationName: "platform"
            },
            Scope: {
              locationName: "scope"
            }
          }
        },
        S1lz: {
          type: "structure",
          members: {
            Frequency: {
              locationName: "frequency"
            },
            Interval: {
              locationName: "interval",
              type: "integer"
            },
            OccurrenceDaySet: {
              locationName: "occurrenceDaySet",
              type: "list",
              member: {
                locationName: "item",
                type: "integer"
              }
            },
            OccurrenceRelativeToEnd: {
              locationName: "occurrenceRelativeToEnd",
              type: "boolean"
            },
            OccurrenceUnit: {
              locationName: "occurrenceUnit"
            }
          }
        },
        S1m7: {
          type: "structure",
          members: {
            AvailabilityZone: {
              locationName: "availabilityZone"
            },
            CreateDate: {
              locationName: "createDate",
              type: "timestamp"
            },
            HourlyPrice: {
              locationName: "hourlyPrice"
            },
            InstanceCount: {
              locationName: "instanceCount",
              type: "integer"
            },
            InstanceType: {
              locationName: "instanceType"
            },
            NetworkPlatform: {
              locationName: "networkPlatform"
            },
            NextSlotStartTime: {
              locationName: "nextSlotStartTime",
              type: "timestamp"
            },
            Platform: {
              locationName: "platform"
            },
            PreviousSlotEndTime: {
              locationName: "previousSlotEndTime",
              type: "timestamp"
            },
            Recurrence: {
              shape: "S1lz",
              locationName: "recurrence"
            },
            ScheduledInstanceId: {
              locationName: "scheduledInstanceId"
            },
            SlotDurationInHours: {
              locationName: "slotDurationInHours",
              type: "integer"
            },
            TermEndDate: {
              locationName: "termEndDate",
              type: "timestamp"
            },
            TermStartDate: {
              locationName: "termStartDate",
              type: "timestamp"
            },
            TotalScheduledInstanceHours: {
              locationName: "totalScheduledInstanceHours",
              type: "integer"
            }
          }
        },
        S1me: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S1mi: {
          type: "list",
          member: {
            locationName: "GroupName"
          }
        },
        S1mq: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Group: {
                locationName: "group"
              },
              UserId: {
                locationName: "userId"
              }
            }
          }
        },
        S1ni: {
          type: "structure",
          required: [
            "IamFleetRole",
            "TargetCapacity"
          ],
          members: {
            AllocationStrategy: {
              locationName: "allocationStrategy"
            },
            OnDemandAllocationStrategy: {
              locationName: "onDemandAllocationStrategy"
            },
            SpotMaintenanceStrategies: {
              locationName: "spotMaintenanceStrategies",
              type: "structure",
              members: {
                CapacityRebalance: {
                  locationName: "capacityRebalance",
                  type: "structure",
                  members: {
                    ReplacementStrategy: {
                      locationName: "replacementStrategy"
                    },
                    TerminationDelay: {
                      locationName: "terminationDelay",
                      type: "integer"
                    }
                  }
                }
              }
            },
            ClientToken: {
              locationName: "clientToken"
            },
            ExcessCapacityTerminationPolicy: {
              locationName: "excessCapacityTerminationPolicy"
            },
            FulfilledCapacity: {
              locationName: "fulfilledCapacity",
              type: "double"
            },
            OnDemandFulfilledCapacity: {
              locationName: "onDemandFulfilledCapacity",
              type: "double"
            },
            IamFleetRole: {
              locationName: "iamFleetRole"
            },
            LaunchSpecifications: {
              locationName: "launchSpecifications",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  SecurityGroups: {
                    shape: "Sly",
                    locationName: "groupSet"
                  },
                  AddressingType: {
                    locationName: "addressingType"
                  },
                  BlockDeviceMappings: {
                    shape: "S185",
                    locationName: "blockDeviceMapping"
                  },
                  EbsOptimized: {
                    locationName: "ebsOptimized",
                    type: "boolean"
                  },
                  IamInstanceProfile: {
                    shape: "S3v",
                    locationName: "iamInstanceProfile"
                  },
                  ImageId: {
                    locationName: "imageId"
                  },
                  InstanceType: {
                    locationName: "instanceType"
                  },
                  KernelId: {
                    locationName: "kernelId"
                  },
                  KeyName: {
                    locationName: "keyName"
                  },
                  Monitoring: {
                    locationName: "monitoring",
                    type: "structure",
                    members: {
                      Enabled: {
                        locationName: "enabled",
                        type: "boolean"
                      }
                    }
                  },
                  NetworkInterfaces: {
                    shape: "S1ns",
                    locationName: "networkInterfaceSet"
                  },
                  Placement: {
                    shape: "S1nu",
                    locationName: "placement"
                  },
                  RamdiskId: {
                    locationName: "ramdiskId"
                  },
                  SpotPrice: {
                    locationName: "spotPrice"
                  },
                  SubnetId: {
                    locationName: "subnetId"
                  },
                  UserData: {
                    shape: "Sgo",
                    locationName: "userData"
                  },
                  WeightedCapacity: {
                    locationName: "weightedCapacity",
                    type: "double"
                  },
                  TagSpecifications: {
                    locationName: "tagSpecificationSet",
                    type: "list",
                    member: {
                      locationName: "item",
                      type: "structure",
                      members: {
                        ResourceType: {
                          locationName: "resourceType"
                        },
                        Tags: {
                          shape: "S6",
                          locationName: "tag"
                        }
                      }
                    }
                  },
                  InstanceRequirements: {
                    shape: "Sdz",
                    locationName: "instanceRequirements"
                  }
                }
              }
            },
            LaunchTemplateConfigs: {
              shape: "S1nx",
              locationName: "launchTemplateConfigs"
            },
            SpotPrice: {
              locationName: "spotPrice"
            },
            TargetCapacity: {
              locationName: "targetCapacity",
              type: "integer"
            },
            OnDemandTargetCapacity: {
              locationName: "onDemandTargetCapacity",
              type: "integer"
            },
            OnDemandMaxTotalPrice: {
              locationName: "onDemandMaxTotalPrice"
            },
            SpotMaxTotalPrice: {
              locationName: "spotMaxTotalPrice"
            },
            TerminateInstancesWithExpiration: {
              locationName: "terminateInstancesWithExpiration",
              type: "boolean"
            },
            Type: {
              locationName: "type"
            },
            ValidFrom: {
              locationName: "validFrom",
              type: "timestamp"
            },
            ValidUntil: {
              locationName: "validUntil",
              type: "timestamp"
            },
            ReplaceUnhealthyInstances: {
              locationName: "replaceUnhealthyInstances",
              type: "boolean"
            },
            InstanceInterruptionBehavior: {
              locationName: "instanceInterruptionBehavior"
            },
            LoadBalancersConfig: {
              locationName: "loadBalancersConfig",
              type: "structure",
              members: {
                ClassicLoadBalancersConfig: {
                  locationName: "classicLoadBalancersConfig",
                  type: "structure",
                  members: {
                    ClassicLoadBalancers: {
                      locationName: "classicLoadBalancers",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          Name: {
                            locationName: "name"
                          }
                        }
                      }
                    }
                  }
                },
                TargetGroupsConfig: {
                  locationName: "targetGroupsConfig",
                  type: "structure",
                  members: {
                    TargetGroups: {
                      locationName: "targetGroups",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          Arn: {
                            locationName: "arn"
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            InstancePoolsToUseCount: {
              locationName: "instancePoolsToUseCount",
              type: "integer"
            },
            Context: {
              locationName: "context"
            },
            TargetCapacityUnitType: {
              locationName: "targetCapacityUnitType"
            },
            TagSpecifications: {
              shape: "S3",
              locationName: "TagSpecification"
            }
          }
        },
        S1ns: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              AssociatePublicIpAddress: {
                locationName: "associatePublicIpAddress",
                type: "boolean"
              },
              DeleteOnTermination: {
                locationName: "deleteOnTermination",
                type: "boolean"
              },
              Description: {
                locationName: "description"
              },
              DeviceIndex: {
                locationName: "deviceIndex",
                type: "integer"
              },
              Groups: {
                shape: "Sgz",
                locationName: "SecurityGroupId"
              },
              Ipv6AddressCount: {
                locationName: "ipv6AddressCount",
                type: "integer"
              },
              Ipv6Addresses: {
                shape: "Siq",
                locationName: "ipv6AddressesSet",
                queryName: "Ipv6Addresses"
              },
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              },
              PrivateIpAddress: {
                locationName: "privateIpAddress"
              },
              PrivateIpAddresses: {
                shape: "Sh2",
                locationName: "privateIpAddressesSet",
                queryName: "PrivateIpAddresses"
              },
              SecondaryPrivateIpAddressCount: {
                locationName: "secondaryPrivateIpAddressCount",
                type: "integer"
              },
              SubnetId: {
                locationName: "subnetId"
              },
              AssociateCarrierIpAddress: {
                type: "boolean"
              },
              InterfaceType: {},
              NetworkCardIndex: {
                type: "integer"
              },
              Ipv4Prefixes: {
                shape: "Sh4",
                locationName: "Ipv4Prefix"
              },
              Ipv4PrefixCount: {
                type: "integer"
              },
              Ipv6Prefixes: {
                shape: "Sh6",
                locationName: "Ipv6Prefix"
              },
              Ipv6PrefixCount: {
                type: "integer"
              },
              PrimaryIpv6: {
                type: "boolean"
              },
              EnaSrdSpecification: {
                shape: "Sh8"
              },
              ConnectionTrackingSpecification: {
                shape: "Sha"
              }
            }
          }
        },
        S1nu: {
          type: "structure",
          members: {
            AvailabilityZone: {
              locationName: "availabilityZone"
            },
            GroupName: {
              locationName: "groupName"
            },
            Tenancy: {
              locationName: "tenancy"
            }
          }
        },
        S1nx: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              LaunchTemplateSpecification: {
                shape: "Sdw",
                locationName: "launchTemplateSpecification"
              },
              Overrides: {
                locationName: "overrides",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    InstanceType: {
                      locationName: "instanceType"
                    },
                    SpotPrice: {
                      locationName: "spotPrice"
                    },
                    SubnetId: {
                      locationName: "subnetId"
                    },
                    AvailabilityZone: {
                      locationName: "availabilityZone"
                    },
                    WeightedCapacity: {
                      locationName: "weightedCapacity",
                      type: "double"
                    },
                    Priority: {
                      locationName: "priority",
                      type: "double"
                    },
                    InstanceRequirements: {
                      shape: "Sdz",
                      locationName: "instanceRequirements"
                    }
                  }
                }
              }
            }
          }
        },
        S1oa: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              ActualBlockHourlyPrice: {
                locationName: "actualBlockHourlyPrice"
              },
              AvailabilityZoneGroup: {
                locationName: "availabilityZoneGroup"
              },
              BlockDurationMinutes: {
                locationName: "blockDurationMinutes",
                type: "integer"
              },
              CreateTime: {
                locationName: "createTime",
                type: "timestamp"
              },
              Fault: {
                shape: "Snv",
                locationName: "fault"
              },
              InstanceId: {
                locationName: "instanceId"
              },
              LaunchGroup: {
                locationName: "launchGroup"
              },
              LaunchSpecification: {
                locationName: "launchSpecification",
                type: "structure",
                members: {
                  UserData: {
                    shape: "Sgo",
                    locationName: "userData"
                  },
                  SecurityGroups: {
                    shape: "Sly",
                    locationName: "groupSet"
                  },
                  AddressingType: {
                    locationName: "addressingType"
                  },
                  BlockDeviceMappings: {
                    shape: "S185",
                    locationName: "blockDeviceMapping"
                  },
                  EbsOptimized: {
                    locationName: "ebsOptimized",
                    type: "boolean"
                  },
                  IamInstanceProfile: {
                    shape: "S3v",
                    locationName: "iamInstanceProfile"
                  },
                  ImageId: {
                    locationName: "imageId"
                  },
                  InstanceType: {
                    locationName: "instanceType"
                  },
                  KernelId: {
                    locationName: "kernelId"
                  },
                  KeyName: {
                    locationName: "keyName"
                  },
                  NetworkInterfaces: {
                    shape: "S1ns",
                    locationName: "networkInterfaceSet"
                  },
                  Placement: {
                    shape: "S1nu",
                    locationName: "placement"
                  },
                  RamdiskId: {
                    locationName: "ramdiskId"
                  },
                  SubnetId: {
                    locationName: "subnetId"
                  },
                  Monitoring: {
                    shape: "S1od",
                    locationName: "monitoring"
                  }
                }
              },
              LaunchedAvailabilityZone: {
                locationName: "launchedAvailabilityZone"
              },
              ProductDescription: {
                locationName: "productDescription"
              },
              SpotInstanceRequestId: {
                locationName: "spotInstanceRequestId"
              },
              SpotPrice: {
                locationName: "spotPrice"
              },
              State: {
                locationName: "state"
              },
              Status: {
                locationName: "status",
                type: "structure",
                members: {
                  Code: {
                    locationName: "code"
                  },
                  Message: {
                    locationName: "message"
                  },
                  UpdateTime: {
                    locationName: "updateTime",
                    type: "timestamp"
                  }
                }
              },
              Tags: {
                shape: "S6",
                locationName: "tagSet"
              },
              Type: {
                locationName: "type"
              },
              ValidFrom: {
                locationName: "validFrom",
                type: "timestamp"
              },
              ValidUntil: {
                locationName: "validUntil",
                type: "timestamp"
              },
              InstanceInterruptionBehavior: {
                locationName: "instanceInterruptionBehavior"
              }
            }
          }
        },
        S1od: {
          type: "structure",
          required: [
            "Enabled"
          ],
          members: {
            Enabled: {
              locationName: "enabled",
              type: "boolean"
            }
          }
        },
        S1os: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              FromPort: {
                locationName: "fromPort",
                type: "integer"
              },
              IpProtocol: {
                locationName: "ipProtocol"
              },
              IpRanges: {
                locationName: "ipRanges",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              PrefixListIds: {
                locationName: "prefixListIds",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              ToPort: {
                locationName: "toPort",
                type: "integer"
              },
              UserIdGroupPairs: {
                locationName: "groups",
                type: "list",
                member: {
                  shape: "S76",
                  locationName: "item"
                }
              }
            }
          }
        },
        S1pq: {
          type: "list",
          member: {}
        },
        S1r9: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S1rd: {
          type: "structure",
          members: {
            VerifiedAccessInstanceId: {
              locationName: "verifiedAccessInstanceId"
            },
            AccessLogs: {
              locationName: "accessLogs",
              type: "structure",
              members: {
                S3: {
                  locationName: "s3",
                  type: "structure",
                  members: {
                    Enabled: {
                      locationName: "enabled",
                      type: "boolean"
                    },
                    DeliveryStatus: {
                      shape: "S1rg",
                      locationName: "deliveryStatus"
                    },
                    BucketName: {
                      locationName: "bucketName"
                    },
                    Prefix: {
                      locationName: "prefix"
                    },
                    BucketOwner: {
                      locationName: "bucketOwner"
                    }
                  }
                },
                CloudWatchLogs: {
                  locationName: "cloudWatchLogs",
                  type: "structure",
                  members: {
                    Enabled: {
                      locationName: "enabled",
                      type: "boolean"
                    },
                    DeliveryStatus: {
                      shape: "S1rg",
                      locationName: "deliveryStatus"
                    },
                    LogGroup: {
                      locationName: "logGroup"
                    }
                  }
                },
                KinesisDataFirehose: {
                  locationName: "kinesisDataFirehose",
                  type: "structure",
                  members: {
                    Enabled: {
                      locationName: "enabled",
                      type: "boolean"
                    },
                    DeliveryStatus: {
                      shape: "S1rg",
                      locationName: "deliveryStatus"
                    },
                    DeliveryStream: {
                      locationName: "deliveryStream"
                    }
                  }
                },
                LogVersion: {
                  locationName: "logVersion"
                },
                IncludeTrustContext: {
                  locationName: "includeTrustContext",
                  type: "boolean"
                }
              }
            }
          }
        },
        S1rg: {
          type: "structure",
          members: {
            Code: {
              locationName: "code"
            },
            Message: {
              locationName: "message"
            }
          }
        },
        S1sh: {
          type: "structure",
          members: {
            VolumeId: {
              locationName: "volumeId"
            },
            ModificationState: {
              locationName: "modificationState"
            },
            StatusMessage: {
              locationName: "statusMessage"
            },
            TargetSize: {
              locationName: "targetSize",
              type: "integer"
            },
            TargetIops: {
              locationName: "targetIops",
              type: "integer"
            },
            TargetVolumeType: {
              locationName: "targetVolumeType"
            },
            TargetThroughput: {
              locationName: "targetThroughput",
              type: "integer"
            },
            TargetMultiAttachEnabled: {
              locationName: "targetMultiAttachEnabled",
              type: "boolean"
            },
            OriginalSize: {
              locationName: "originalSize",
              type: "integer"
            },
            OriginalIops: {
              locationName: "originalIops",
              type: "integer"
            },
            OriginalVolumeType: {
              locationName: "originalVolumeType"
            },
            OriginalThroughput: {
              locationName: "originalThroughput",
              type: "integer"
            },
            OriginalMultiAttachEnabled: {
              locationName: "originalMultiAttachEnabled",
              type: "boolean"
            },
            Progress: {
              locationName: "progress",
              type: "long"
            },
            StartTime: {
              locationName: "startTime",
              type: "timestamp"
            },
            EndTime: {
              locationName: "endTime",
              type: "timestamp"
            }
          }
        },
        S1sn: {
          type: "list",
          member: {
            locationName: "VpcId"
          }
        },
        S1un: {
          type: "list",
          member: {
            locationName: "AvailabilityZone"
          }
        },
        S1vc: {
          type: "structure",
          members: {
            TransitGatewayAttachmentId: {
              locationName: "transitGatewayAttachmentId"
            },
            ResourceId: {
              locationName: "resourceId"
            },
            ResourceType: {
              locationName: "resourceType"
            },
            TransitGatewayRouteTableId: {
              locationName: "transitGatewayRouteTableId"
            },
            State: {
              locationName: "state"
            },
            TransitGatewayRouteTableAnnouncementId: {
              locationName: "transitGatewayRouteTableAnnouncementId"
            }
          }
        },
        S1yu: {
          type: "structure",
          members: {
            InstanceFamily: {
              locationName: "instanceFamily"
            },
            CpuCredits: {
              locationName: "cpuCredits"
            }
          }
        },
        S1zb: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S1zd: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              CurrencyCode: {
                locationName: "currencyCode"
              },
              Duration: {
                locationName: "duration",
                type: "integer"
              },
              HostIdSet: {
                shape: "S17d",
                locationName: "hostIdSet"
              },
              HostReservationId: {
                locationName: "hostReservationId"
              },
              HourlyPrice: {
                locationName: "hourlyPrice"
              },
              InstanceFamily: {
                locationName: "instanceFamily"
              },
              PaymentOption: {
                locationName: "paymentOption"
              },
              UpfrontPrice: {
                locationName: "upfrontPrice"
              }
            }
          }
        },
        S1zi: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S1zj: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S20v: {
          type: "structure",
          members: {
            IpamId: {
              locationName: "ipamId"
            },
            IpamScopeId: {
              locationName: "ipamScopeId"
            },
            IpamPoolId: {
              locationName: "ipamPoolId"
            },
            ResourceRegion: {
              locationName: "resourceRegion"
            },
            ResourceOwnerId: {
              locationName: "resourceOwnerId"
            },
            ResourceId: {
              locationName: "resourceId"
            },
            ResourceName: {
              locationName: "resourceName"
            },
            ResourceCidr: {
              locationName: "resourceCidr"
            },
            ResourceType: {
              locationName: "resourceType"
            },
            ResourceTags: {
              shape: "Sg9",
              locationName: "resourceTagSet"
            },
            IpUsage: {
              locationName: "ipUsage",
              type: "double"
            },
            ComplianceStatus: {
              locationName: "complianceStatus"
            },
            ManagementState: {
              locationName: "managementState"
            },
            OverlapStatus: {
              locationName: "overlapStatus"
            },
            VpcId: {
              locationName: "vpcId"
            }
          }
        },
        S21j: {
          type: "structure",
          members: {
            HourlyPrice: {
              locationName: "hourlyPrice"
            },
            RemainingTotalValue: {
              locationName: "remainingTotalValue"
            },
            RemainingUpfrontValue: {
              locationName: "remainingUpfrontValue"
            }
          }
        },
        S22a: {
          type: "list",
          member: {
            shape: "So6",
            locationName: "item"
          }
        },
        S23m: {
          type: "structure",
          members: {
            Comment: {},
            UploadEnd: {
              type: "timestamp"
            },
            UploadSize: {
              type: "double"
            },
            UploadStart: {
              type: "timestamp"
            }
          }
        },
        S23p: {
          type: "structure",
          members: {
            S3Bucket: {},
            S3Key: {}
          }
        },
        S23w: {
          type: "structure",
          required: [
            "Bytes",
            "Format",
            "ImportManifestUrl"
          ],
          members: {
            Bytes: {
              locationName: "bytes",
              type: "long"
            },
            Format: {
              locationName: "format"
            },
            ImportManifestUrl: {
              shape: "S13x",
              locationName: "importManifestUrl"
            }
          }
        },
        S23x: {
          type: "structure",
          required: [
            "Size"
          ],
          members: {
            Size: {
              locationName: "size",
              type: "long"
            }
          }
        },
        S257: {
          type: "list",
          member: {
            locationName: "UserId"
          }
        },
        S258: {
          type: "list",
          member: {
            locationName: "UserGroup"
          }
        },
        S259: {
          type: "list",
          member: {
            locationName: "ProductCode"
          }
        },
        S25b: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Group: {},
              UserId: {}
            }
          }
        },
        S25g: {
          type: "list",
          member: {
            shape: "S1i",
            locationName: "item"
          }
        },
        S25t: {
          type: "structure",
          members: {
            CapacityReservationPreference: {},
            CapacityReservationTarget: {
              shape: "Shy"
            }
          }
        },
        S26i: {
          type: "list",
          member: {
            type: "structure",
            members: {
              RegionName: {}
            }
          }
        },
        S297: {
          type: "structure",
          members: {
            AllowDnsResolutionFromRemoteVpc: {
              type: "boolean"
            },
            AllowEgressFromLocalClassicLinkToRemoteVpc: {
              type: "boolean"
            },
            AllowEgressFromLocalVpcToRemoteClassicLink: {
              type: "boolean"
            }
          }
        },
        S299: {
          type: "structure",
          members: {
            AllowDnsResolutionFromRemoteVpc: {
              locationName: "allowDnsResolutionFromRemoteVpc",
              type: "boolean"
            },
            AllowEgressFromLocalClassicLinkToRemoteVpc: {
              locationName: "allowEgressFromLocalClassicLinkToRemoteVpc",
              type: "boolean"
            },
            AllowEgressFromLocalVpcToRemoteClassicLink: {
              locationName: "allowEgressFromLocalVpcToRemoteClassicLink",
              type: "boolean"
            }
          }
        },
        S29o: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              InstanceId: {
                locationName: "instanceId"
              },
              Monitoring: {
                shape: "S1dx",
                locationName: "monitoring"
              }
            }
          }
        },
        S2di: {
          type: "list",
          member: {
            locationName: "SecurityGroupId"
          }
        },
        S2e6: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              CurrentState: {
                shape: "S1a2",
                locationName: "currentState"
              },
              InstanceId: {
                locationName: "instanceId"
              },
              PreviousState: {
                shape: "S1a2",
                locationName: "previousState"
              }
            }
          }
        },
        S2ew: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              SecurityGroupRuleId: {},
              Description: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ec2-2016-11-15.paginators.json
var require_ec2_2016_11_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/ec2-2016-11-15.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeAccountAttributes: {
          result_key: "AccountAttributes"
        },
        DescribeAddressTransfers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "AddressTransfers"
        },
        DescribeAddresses: {
          result_key: "Addresses"
        },
        DescribeAddressesAttribute: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Addresses"
        },
        DescribeAvailabilityZones: {
          result_key: "AvailabilityZones"
        },
        DescribeAwsNetworkPerformanceMetricSubscriptions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Subscriptions"
        },
        DescribeBundleTasks: {
          result_key: "BundleTasks"
        },
        DescribeByoipCidrs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ByoipCidrs"
        },
        DescribeCapacityBlockOfferings: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "CapacityBlockOfferings"
        },
        DescribeCapacityReservationFleets: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "CapacityReservationFleets"
        },
        DescribeCapacityReservations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "CapacityReservations"
        },
        DescribeCarrierGateways: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "CarrierGateways"
        },
        DescribeClassicLinkInstances: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Instances"
        },
        DescribeClientVpnAuthorizationRules: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "AuthorizationRules"
        },
        DescribeClientVpnConnections: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Connections"
        },
        DescribeClientVpnEndpoints: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ClientVpnEndpoints"
        },
        DescribeClientVpnRoutes: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Routes"
        },
        DescribeClientVpnTargetNetworks: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ClientVpnTargetNetworks"
        },
        DescribeCoipPools: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "CoipPools"
        },
        DescribeConversionTasks: {
          result_key: "ConversionTasks"
        },
        DescribeCustomerGateways: {
          result_key: "CustomerGateways"
        },
        DescribeDhcpOptions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "DhcpOptions"
        },
        DescribeEgressOnlyInternetGateways: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "EgressOnlyInternetGateways"
        },
        DescribeExportImageTasks: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ExportImageTasks"
        },
        DescribeExportTasks: {
          result_key: "ExportTasks"
        },
        DescribeFastLaunchImages: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "FastLaunchImages"
        },
        DescribeFastSnapshotRestores: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "FastSnapshotRestores"
        },
        DescribeFleets: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Fleets"
        },
        DescribeFlowLogs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "FlowLogs"
        },
        DescribeFpgaImages: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "FpgaImages"
        },
        DescribeHostReservationOfferings: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "OfferingSet"
        },
        DescribeHostReservations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "HostReservationSet"
        },
        DescribeHosts: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Hosts"
        },
        DescribeIamInstanceProfileAssociations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "IamInstanceProfileAssociations"
        },
        DescribeImages: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Images"
        },
        DescribeImportImageTasks: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ImportImageTasks"
        },
        DescribeImportSnapshotTasks: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ImportSnapshotTasks"
        },
        DescribeInstanceConnectEndpoints: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "InstanceConnectEndpoints"
        },
        DescribeInstanceCreditSpecifications: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "InstanceCreditSpecifications"
        },
        DescribeInstanceEventWindows: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "InstanceEventWindows"
        },
        DescribeInstanceStatus: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "InstanceStatuses"
        },
        DescribeInstanceTopology: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Instances"
        },
        DescribeInstanceTypeOfferings: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "InstanceTypeOfferings"
        },
        DescribeInstanceTypes: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "InstanceTypes"
        },
        DescribeInstances: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Reservations"
        },
        DescribeInternetGateways: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "InternetGateways"
        },
        DescribeIpamPools: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "IpamPools"
        },
        DescribeIpamResourceDiscoveries: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "IpamResourceDiscoveries"
        },
        DescribeIpamResourceDiscoveryAssociations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "IpamResourceDiscoveryAssociations"
        },
        DescribeIpamScopes: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "IpamScopes"
        },
        DescribeIpams: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Ipams"
        },
        DescribeIpv6Pools: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Ipv6Pools"
        },
        DescribeKeyPairs: {
          result_key: "KeyPairs"
        },
        DescribeLaunchTemplateVersions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "LaunchTemplateVersions"
        },
        DescribeLaunchTemplates: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "LaunchTemplates"
        },
        DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "LocalGatewayRouteTableVirtualInterfaceGroupAssociations"
        },
        DescribeLocalGatewayRouteTableVpcAssociations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "LocalGatewayRouteTableVpcAssociations"
        },
        DescribeLocalGatewayRouteTables: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "LocalGatewayRouteTables"
        },
        DescribeLocalGatewayVirtualInterfaceGroups: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "LocalGatewayVirtualInterfaceGroups"
        },
        DescribeLocalGatewayVirtualInterfaces: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "LocalGatewayVirtualInterfaces"
        },
        DescribeLocalGateways: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "LocalGateways"
        },
        DescribeManagedPrefixLists: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PrefixLists"
        },
        DescribeMovingAddresses: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "MovingAddressStatuses"
        },
        DescribeNatGateways: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "NatGateways"
        },
        DescribeNetworkAcls: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "NetworkAcls"
        },
        DescribeNetworkInsightsAccessScopeAnalyses: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "NetworkInsightsAccessScopeAnalyses"
        },
        DescribeNetworkInsightsAccessScopes: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "NetworkInsightsAccessScopes"
        },
        DescribeNetworkInsightsAnalyses: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "NetworkInsightsAnalyses"
        },
        DescribeNetworkInsightsPaths: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "NetworkInsightsPaths"
        },
        DescribeNetworkInterfacePermissions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "NetworkInterfacePermissions"
        },
        DescribeNetworkInterfaces: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "NetworkInterfaces"
        },
        DescribePlacementGroups: {
          result_key: "PlacementGroups"
        },
        DescribePrefixLists: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PrefixLists"
        },
        DescribePrincipalIdFormat: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Principals"
        },
        DescribePublicIpv4Pools: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PublicIpv4Pools"
        },
        DescribeRegions: {
          result_key: "Regions"
        },
        DescribeReplaceRootVolumeTasks: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ReplaceRootVolumeTasks"
        },
        DescribeReservedInstances: {
          result_key: "ReservedInstances"
        },
        DescribeReservedInstancesListings: {
          result_key: "ReservedInstancesListings"
        },
        DescribeReservedInstancesModifications: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "ReservedInstancesModifications"
        },
        DescribeReservedInstancesOfferings: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ReservedInstancesOfferings"
        },
        DescribeRouteTables: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "RouteTables"
        },
        DescribeScheduledInstanceAvailability: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ScheduledInstanceAvailabilitySet"
        },
        DescribeScheduledInstances: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ScheduledInstanceSet"
        },
        DescribeSecurityGroupRules: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "SecurityGroupRules"
        },
        DescribeSecurityGroups: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "SecurityGroups"
        },
        DescribeSnapshotTierStatus: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "SnapshotTierStatuses"
        },
        DescribeSnapshots: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Snapshots"
        },
        DescribeSpotFleetRequests: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "SpotFleetRequestConfigs"
        },
        DescribeSpotInstanceRequests: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "SpotInstanceRequests"
        },
        DescribeSpotPriceHistory: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "SpotPriceHistory"
        },
        DescribeStaleSecurityGroups: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "StaleSecurityGroupSet"
        },
        DescribeStoreImageTasks: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "StoreImageTaskResults"
        },
        DescribeSubnets: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Subnets"
        },
        DescribeTags: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Tags"
        },
        DescribeTrafficMirrorFilters: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TrafficMirrorFilters"
        },
        DescribeTrafficMirrorSessions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TrafficMirrorSessions"
        },
        DescribeTrafficMirrorTargets: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TrafficMirrorTargets"
        },
        DescribeTransitGatewayAttachments: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TransitGatewayAttachments"
        },
        DescribeTransitGatewayConnectPeers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TransitGatewayConnectPeers"
        },
        DescribeTransitGatewayConnects: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TransitGatewayConnects"
        },
        DescribeTransitGatewayMulticastDomains: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TransitGatewayMulticastDomains"
        },
        DescribeTransitGatewayPeeringAttachments: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TransitGatewayPeeringAttachments"
        },
        DescribeTransitGatewayPolicyTables: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TransitGatewayPolicyTables"
        },
        DescribeTransitGatewayRouteTableAnnouncements: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TransitGatewayRouteTableAnnouncements"
        },
        DescribeTransitGatewayRouteTables: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TransitGatewayRouteTables"
        },
        DescribeTransitGatewayVpcAttachments: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TransitGatewayVpcAttachments"
        },
        DescribeTransitGateways: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TransitGateways"
        },
        DescribeTrunkInterfaceAssociations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "InterfaceAssociations"
        },
        DescribeVerifiedAccessEndpoints: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "VerifiedAccessEndpoints"
        },
        DescribeVerifiedAccessGroups: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "VerifiedAccessGroups"
        },
        DescribeVerifiedAccessInstanceLoggingConfigurations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "LoggingConfigurations"
        },
        DescribeVerifiedAccessInstances: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "VerifiedAccessInstances"
        },
        DescribeVerifiedAccessTrustProviders: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "VerifiedAccessTrustProviders"
        },
        DescribeVolumeStatus: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "VolumeStatuses"
        },
        DescribeVolumes: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Volumes"
        },
        DescribeVolumesModifications: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "VolumesModifications"
        },
        DescribeVpcClassicLinkDnsSupport: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Vpcs"
        },
        DescribeVpcEndpointConnectionNotifications: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ConnectionNotificationSet"
        },
        DescribeVpcEndpointConnections: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "VpcEndpointConnections"
        },
        DescribeVpcEndpointServiceConfigurations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ServiceConfigurations"
        },
        DescribeVpcEndpointServicePermissions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "AllowedPrincipals"
        },
        DescribeVpcEndpoints: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "VpcEndpoints"
        },
        DescribeVpcPeeringConnections: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "VpcPeeringConnections"
        },
        DescribeVpcs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Vpcs"
        },
        DescribeVpnConnections: {
          result_key: "VpnConnections"
        },
        DescribeVpnGateways: {
          result_key: "VpnGateways"
        },
        GetAssociatedIpv6PoolCidrs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Ipv6CidrAssociations"
        },
        GetAwsNetworkPerformanceData: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "DataResponses"
        },
        GetGroupsForCapacityReservation: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "CapacityReservationGroups"
        },
        GetInstanceTypesFromInstanceRequirements: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "InstanceTypes"
        },
        GetIpamAddressHistory: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "HistoryRecords"
        },
        GetIpamDiscoveredAccounts: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "IpamDiscoveredAccounts"
        },
        GetIpamDiscoveredResourceCidrs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "IpamDiscoveredResourceCidrs"
        },
        GetIpamPoolAllocations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "IpamPoolAllocations"
        },
        GetIpamPoolCidrs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "IpamPoolCidrs"
        },
        GetIpamResourceCidrs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "IpamResourceCidrs"
        },
        GetManagedPrefixListAssociations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PrefixListAssociations"
        },
        GetManagedPrefixListEntries: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Entries"
        },
        GetNetworkInsightsAccessScopeAnalysisFindings: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "AnalysisFindings"
        },
        GetSecurityGroupsForVpc: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "SecurityGroupForVpcs"
        },
        GetSpotPlacementScores: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "SpotPlacementScores"
        },
        GetTransitGatewayAttachmentPropagations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TransitGatewayAttachmentPropagations"
        },
        GetTransitGatewayMulticastDomainAssociations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "MulticastDomainAssociations"
        },
        GetTransitGatewayPolicyTableAssociations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Associations"
        },
        GetTransitGatewayPrefixListReferences: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TransitGatewayPrefixListReferences"
        },
        GetTransitGatewayRouteTableAssociations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Associations"
        },
        GetTransitGatewayRouteTablePropagations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TransitGatewayRouteTablePropagations"
        },
        GetVpnConnectionDeviceTypes: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "VpnConnectionDeviceTypes"
        },
        ListImagesInRecycleBin: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Images"
        },
        ListSnapshotsInRecycleBin: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Snapshots"
        },
        SearchLocalGatewayRoutes: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Routes"
        },
        SearchTransitGatewayMulticastGroups: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "MulticastGroups"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ec2-2016-11-15.waiters2.json
var require_ec2_2016_11_15_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/ec2-2016-11-15.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        InstanceExists: {
          delay: 5,
          maxAttempts: 40,
          operation: "DescribeInstances",
          acceptors: [
            {
              matcher: "path",
              expected: true,
              argument: "length(Reservations[]) > `0`",
              state: "success"
            },
            {
              matcher: "error",
              expected: "InvalidInstanceID.NotFound",
              state: "retry"
            }
          ]
        },
        BundleTaskComplete: {
          delay: 15,
          operation: "DescribeBundleTasks",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "complete",
              matcher: "pathAll",
              state: "success",
              argument: "BundleTasks[].State"
            },
            {
              expected: "failed",
              matcher: "pathAny",
              state: "failure",
              argument: "BundleTasks[].State"
            }
          ]
        },
        ConversionTaskCancelled: {
          delay: 15,
          operation: "DescribeConversionTasks",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "cancelled",
              matcher: "pathAll",
              state: "success",
              argument: "ConversionTasks[].State"
            }
          ]
        },
        ConversionTaskCompleted: {
          delay: 15,
          operation: "DescribeConversionTasks",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "completed",
              matcher: "pathAll",
              state: "success",
              argument: "ConversionTasks[].State"
            },
            {
              expected: "cancelled",
              matcher: "pathAny",
              state: "failure",
              argument: "ConversionTasks[].State"
            },
            {
              expected: "cancelling",
              matcher: "pathAny",
              state: "failure",
              argument: "ConversionTasks[].State"
            }
          ]
        },
        ConversionTaskDeleted: {
          delay: 15,
          operation: "DescribeConversionTasks",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "deleted",
              matcher: "pathAll",
              state: "success",
              argument: "ConversionTasks[].State"
            }
          ]
        },
        CustomerGatewayAvailable: {
          delay: 15,
          operation: "DescribeCustomerGateways",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "available",
              matcher: "pathAll",
              state: "success",
              argument: "CustomerGateways[].State"
            },
            {
              expected: "deleted",
              matcher: "pathAny",
              state: "failure",
              argument: "CustomerGateways[].State"
            },
            {
              expected: "deleting",
              matcher: "pathAny",
              state: "failure",
              argument: "CustomerGateways[].State"
            }
          ]
        },
        ExportTaskCancelled: {
          delay: 15,
          operation: "DescribeExportTasks",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "cancelled",
              matcher: "pathAll",
              state: "success",
              argument: "ExportTasks[].State"
            }
          ]
        },
        ExportTaskCompleted: {
          delay: 15,
          operation: "DescribeExportTasks",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "completed",
              matcher: "pathAll",
              state: "success",
              argument: "ExportTasks[].State"
            }
          ]
        },
        ImageExists: {
          operation: "DescribeImages",
          maxAttempts: 40,
          delay: 15,
          acceptors: [
            {
              matcher: "path",
              expected: true,
              argument: "length(Images[]) > `0`",
              state: "success"
            },
            {
              matcher: "error",
              expected: "InvalidAMIID.NotFound",
              state: "retry"
            }
          ]
        },
        ImageAvailable: {
          operation: "DescribeImages",
          maxAttempts: 40,
          delay: 15,
          acceptors: [
            {
              state: "success",
              matcher: "pathAll",
              argument: "Images[].State",
              expected: "available"
            },
            {
              state: "failure",
              matcher: "pathAny",
              argument: "Images[].State",
              expected: "failed"
            }
          ]
        },
        InstanceRunning: {
          delay: 15,
          operation: "DescribeInstances",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "running",
              matcher: "pathAll",
              state: "success",
              argument: "Reservations[].Instances[].State.Name"
            },
            {
              expected: "shutting-down",
              matcher: "pathAny",
              state: "failure",
              argument: "Reservations[].Instances[].State.Name"
            },
            {
              expected: "terminated",
              matcher: "pathAny",
              state: "failure",
              argument: "Reservations[].Instances[].State.Name"
            },
            {
              expected: "stopping",
              matcher: "pathAny",
              state: "failure",
              argument: "Reservations[].Instances[].State.Name"
            },
            {
              matcher: "error",
              expected: "InvalidInstanceID.NotFound",
              state: "retry"
            }
          ]
        },
        InstanceStatusOk: {
          operation: "DescribeInstanceStatus",
          maxAttempts: 40,
          delay: 15,
          acceptors: [
            {
              state: "success",
              matcher: "pathAll",
              argument: "InstanceStatuses[].InstanceStatus.Status",
              expected: "ok"
            },
            {
              matcher: "error",
              expected: "InvalidInstanceID.NotFound",
              state: "retry"
            }
          ]
        },
        InstanceStopped: {
          delay: 15,
          operation: "DescribeInstances",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "stopped",
              matcher: "pathAll",
              state: "success",
              argument: "Reservations[].Instances[].State.Name"
            },
            {
              expected: "pending",
              matcher: "pathAny",
              state: "failure",
              argument: "Reservations[].Instances[].State.Name"
            },
            {
              expected: "terminated",
              matcher: "pathAny",
              state: "failure",
              argument: "Reservations[].Instances[].State.Name"
            }
          ]
        },
        InstanceTerminated: {
          delay: 15,
          operation: "DescribeInstances",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "terminated",
              matcher: "pathAll",
              state: "success",
              argument: "Reservations[].Instances[].State.Name"
            },
            {
              expected: "pending",
              matcher: "pathAny",
              state: "failure",
              argument: "Reservations[].Instances[].State.Name"
            },
            {
              expected: "stopping",
              matcher: "pathAny",
              state: "failure",
              argument: "Reservations[].Instances[].State.Name"
            }
          ]
        },
        InternetGatewayExists: {
          operation: "DescribeInternetGateways",
          delay: 5,
          maxAttempts: 6,
          acceptors: [
            {
              expected: true,
              matcher: "path",
              state: "success",
              argument: "length(InternetGateways[].InternetGatewayId) > `0`"
            },
            {
              expected: "InvalidInternetGateway.NotFound",
              matcher: "error",
              state: "retry"
            }
          ]
        },
        KeyPairExists: {
          operation: "DescribeKeyPairs",
          delay: 5,
          maxAttempts: 6,
          acceptors: [
            {
              expected: true,
              matcher: "path",
              state: "success",
              argument: "length(KeyPairs[].KeyName) > `0`"
            },
            {
              expected: "InvalidKeyPair.NotFound",
              matcher: "error",
              state: "retry"
            }
          ]
        },
        NatGatewayAvailable: {
          operation: "DescribeNatGateways",
          delay: 15,
          maxAttempts: 40,
          acceptors: [
            {
              state: "success",
              matcher: "pathAll",
              argument: "NatGateways[].State",
              expected: "available"
            },
            {
              state: "failure",
              matcher: "pathAny",
              argument: "NatGateways[].State",
              expected: "failed"
            },
            {
              state: "failure",
              matcher: "pathAny",
              argument: "NatGateways[].State",
              expected: "deleting"
            },
            {
              state: "failure",
              matcher: "pathAny",
              argument: "NatGateways[].State",
              expected: "deleted"
            },
            {
              state: "retry",
              matcher: "error",
              expected: "NatGatewayNotFound"
            }
          ]
        },
        NatGatewayDeleted: {
          operation: "DescribeNatGateways",
          delay: 15,
          maxAttempts: 40,
          acceptors: [
            {
              state: "success",
              matcher: "pathAll",
              argument: "NatGateways[].State",
              expected: "deleted"
            },
            {
              state: "success",
              matcher: "error",
              expected: "NatGatewayNotFound"
            }
          ]
        },
        NetworkInterfaceAvailable: {
          operation: "DescribeNetworkInterfaces",
          delay: 20,
          maxAttempts: 10,
          acceptors: [
            {
              expected: "available",
              matcher: "pathAll",
              state: "success",
              argument: "NetworkInterfaces[].Status"
            },
            {
              expected: "InvalidNetworkInterfaceID.NotFound",
              matcher: "error",
              state: "failure"
            }
          ]
        },
        PasswordDataAvailable: {
          operation: "GetPasswordData",
          maxAttempts: 40,
          delay: 15,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "length(PasswordData) > `0`",
              expected: true
            }
          ]
        },
        SnapshotCompleted: {
          delay: 15,
          operation: "DescribeSnapshots",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "completed",
              matcher: "pathAll",
              state: "success",
              argument: "Snapshots[].State"
            },
            {
              expected: "error",
              matcher: "pathAny",
              state: "failure",
              argument: "Snapshots[].State"
            }
          ]
        },
        SnapshotImported: {
          delay: 15,
          operation: "DescribeImportSnapshotTasks",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "completed",
              matcher: "pathAll",
              state: "success",
              argument: "ImportSnapshotTasks[].SnapshotTaskDetail.Status"
            },
            {
              expected: "error",
              matcher: "pathAny",
              state: "failure",
              argument: "ImportSnapshotTasks[].SnapshotTaskDetail.Status"
            }
          ]
        },
        SecurityGroupExists: {
          operation: "DescribeSecurityGroups",
          delay: 5,
          maxAttempts: 6,
          acceptors: [
            {
              expected: true,
              matcher: "path",
              state: "success",
              argument: "length(SecurityGroups[].GroupId) > `0`"
            },
            {
              expected: "InvalidGroup.NotFound",
              matcher: "error",
              state: "retry"
            }
          ]
        },
        SpotInstanceRequestFulfilled: {
          operation: "DescribeSpotInstanceRequests",
          maxAttempts: 40,
          delay: 15,
          acceptors: [
            {
              state: "success",
              matcher: "pathAll",
              argument: "SpotInstanceRequests[].Status.Code",
              expected: "fulfilled"
            },
            {
              state: "success",
              matcher: "pathAll",
              argument: "SpotInstanceRequests[].Status.Code",
              expected: "request-canceled-and-instance-running"
            },
            {
              state: "failure",
              matcher: "pathAny",
              argument: "SpotInstanceRequests[].Status.Code",
              expected: "schedule-expired"
            },
            {
              state: "failure",
              matcher: "pathAny",
              argument: "SpotInstanceRequests[].Status.Code",
              expected: "canceled-before-fulfillment"
            },
            {
              state: "failure",
              matcher: "pathAny",
              argument: "SpotInstanceRequests[].Status.Code",
              expected: "bad-parameters"
            },
            {
              state: "failure",
              matcher: "pathAny",
              argument: "SpotInstanceRequests[].Status.Code",
              expected: "system-error"
            },
            {
              state: "retry",
              matcher: "error",
              expected: "InvalidSpotInstanceRequestID.NotFound"
            }
          ]
        },
        StoreImageTaskComplete: {
          delay: 5,
          operation: "DescribeStoreImageTasks",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "Completed",
              matcher: "pathAll",
              state: "success",
              argument: "StoreImageTaskResults[].StoreTaskState"
            },
            {
              expected: "Failed",
              matcher: "pathAny",
              state: "failure",
              argument: "StoreImageTaskResults[].StoreTaskState"
            },
            {
              expected: "InProgress",
              matcher: "pathAny",
              state: "retry",
              argument: "StoreImageTaskResults[].StoreTaskState"
            }
          ]
        },
        SubnetAvailable: {
          delay: 15,
          operation: "DescribeSubnets",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "available",
              matcher: "pathAll",
              state: "success",
              argument: "Subnets[].State"
            }
          ]
        },
        SystemStatusOk: {
          operation: "DescribeInstanceStatus",
          maxAttempts: 40,
          delay: 15,
          acceptors: [
            {
              state: "success",
              matcher: "pathAll",
              argument: "InstanceStatuses[].SystemStatus.Status",
              expected: "ok"
            }
          ]
        },
        VolumeAvailable: {
          delay: 15,
          operation: "DescribeVolumes",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "available",
              matcher: "pathAll",
              state: "success",
              argument: "Volumes[].State"
            },
            {
              expected: "deleted",
              matcher: "pathAny",
              state: "failure",
              argument: "Volumes[].State"
            }
          ]
        },
        VolumeDeleted: {
          delay: 15,
          operation: "DescribeVolumes",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "deleted",
              matcher: "pathAll",
              state: "success",
              argument: "Volumes[].State"
            },
            {
              matcher: "error",
              expected: "InvalidVolume.NotFound",
              state: "success"
            }
          ]
        },
        VolumeInUse: {
          delay: 15,
          operation: "DescribeVolumes",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "in-use",
              matcher: "pathAll",
              state: "success",
              argument: "Volumes[].State"
            },
            {
              expected: "deleted",
              matcher: "pathAny",
              state: "failure",
              argument: "Volumes[].State"
            }
          ]
        },
        VpcAvailable: {
          delay: 15,
          operation: "DescribeVpcs",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "available",
              matcher: "pathAll",
              state: "success",
              argument: "Vpcs[].State"
            }
          ]
        },
        VpcExists: {
          operation: "DescribeVpcs",
          delay: 1,
          maxAttempts: 5,
          acceptors: [
            {
              matcher: "status",
              expected: 200,
              state: "success"
            },
            {
              matcher: "error",
              expected: "InvalidVpcID.NotFound",
              state: "retry"
            }
          ]
        },
        VpnConnectionAvailable: {
          delay: 15,
          operation: "DescribeVpnConnections",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "available",
              matcher: "pathAll",
              state: "success",
              argument: "VpnConnections[].State"
            },
            {
              expected: "deleting",
              matcher: "pathAny",
              state: "failure",
              argument: "VpnConnections[].State"
            },
            {
              expected: "deleted",
              matcher: "pathAny",
              state: "failure",
              argument: "VpnConnections[].State"
            }
          ]
        },
        VpnConnectionDeleted: {
          delay: 15,
          operation: "DescribeVpnConnections",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "deleted",
              matcher: "pathAll",
              state: "success",
              argument: "VpnConnections[].State"
            },
            {
              expected: "pending",
              matcher: "pathAny",
              state: "failure",
              argument: "VpnConnections[].State"
            }
          ]
        },
        VpcPeeringConnectionExists: {
          delay: 15,
          operation: "DescribeVpcPeeringConnections",
          maxAttempts: 40,
          acceptors: [
            {
              matcher: "status",
              expected: 200,
              state: "success"
            },
            {
              matcher: "error",
              expected: "InvalidVpcPeeringConnectionID.NotFound",
              state: "retry"
            }
          ]
        },
        VpcPeeringConnectionDeleted: {
          delay: 15,
          operation: "DescribeVpcPeeringConnections",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "deleted",
              matcher: "pathAll",
              state: "success",
              argument: "VpcPeeringConnections[].Status.Code"
            },
            {
              matcher: "error",
              expected: "InvalidVpcPeeringConnectionID.NotFound",
              state: "success"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/ec2.js
var require_ec22 = __commonJS({
  "node_modules/aws-sdk/clients/ec2.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["ec2"] = {};
    AWS2.EC2 = Service.defineService("ec2", ["2013-06-15*", "2013-10-15*", "2014-02-01*", "2014-05-01*", "2014-06-15*", "2014-09-01*", "2014-10-01*", "2015-03-01*", "2015-04-15*", "2015-10-01*", "2016-04-01*", "2016-09-15*", "2016-11-15"]);
    require_ec2();
    Object.defineProperty(apiLoader.services["ec2"], "2016-11-15", {
      get: function get() {
        var model = require_ec2_2016_11_15_min();
        model.paginators = require_ec2_2016_11_15_paginators().pagination;
        model.waiters = require_ec2_2016_11_15_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.EC2;
  }
});

// node_modules/aws-sdk/apis/ecr-2015-09-21.min.json
var require_ecr_2015_09_21_min = __commonJS({
  "node_modules/aws-sdk/apis/ecr-2015-09-21.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-09-21",
        endpointPrefix: "api.ecr",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Amazon ECR",
        serviceFullName: "Amazon EC2 Container Registry",
        serviceId: "ECR",
        signatureVersion: "v4",
        signingName: "ecr",
        targetPrefix: "AmazonEC2ContainerRegistry_V20150921",
        uid: "ecr-2015-09-21"
      },
      operations: {
        BatchCheckLayerAvailability: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "layerDigests"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              layerDigests: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              layers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    layerDigest: {},
                    layerAvailability: {},
                    layerSize: {
                      type: "long"
                    },
                    mediaType: {}
                  }
                }
              },
              failures: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    layerDigest: {},
                    failureCode: {},
                    failureReason: {}
                  }
                }
              }
            }
          }
        },
        BatchDeleteImage: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "imageIds"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              imageIds: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              imageIds: {
                shape: "Si"
              },
              failures: {
                shape: "Sn"
              }
            }
          }
        },
        BatchGetImage: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "imageIds"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              imageIds: {
                shape: "Si"
              },
              acceptedMediaTypes: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              images: {
                type: "list",
                member: {
                  shape: "Sv"
                }
              },
              failures: {
                shape: "Sn"
              }
            }
          }
        },
        BatchGetRepositoryScanningConfiguration: {
          input: {
            type: "structure",
            required: [
              "repositoryNames"
            ],
            members: {
              repositoryNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              scanningConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    repositoryArn: {},
                    repositoryName: {},
                    scanOnPush: {
                      type: "boolean"
                    },
                    scanFrequency: {},
                    appliedScanFilters: {
                      shape: "S15"
                    }
                  }
                }
              },
              failures: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    repositoryName: {},
                    failureCode: {},
                    failureReason: {}
                  }
                }
              }
            }
          }
        },
        CompleteLayerUpload: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "uploadId",
              "layerDigests"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              uploadId: {},
              layerDigests: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              uploadId: {},
              layerDigest: {}
            }
          }
        },
        CreatePullThroughCacheRule: {
          input: {
            type: "structure",
            required: [
              "ecrRepositoryPrefix",
              "upstreamRegistryUrl"
            ],
            members: {
              ecrRepositoryPrefix: {},
              upstreamRegistryUrl: {},
              registryId: {},
              upstreamRegistry: {},
              credentialArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ecrRepositoryPrefix: {},
              upstreamRegistryUrl: {},
              createdAt: {
                type: "timestamp"
              },
              registryId: {},
              upstreamRegistry: {},
              credentialArn: {}
            }
          }
        },
        CreateRepository: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              tags: {
                shape: "S1p"
              },
              imageTagMutability: {},
              imageScanningConfiguration: {
                shape: "S1u"
              },
              encryptionConfiguration: {
                shape: "S1v"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repository: {
                shape: "S1z"
              }
            }
          }
        },
        DeleteLifecyclePolicy: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              lifecyclePolicyText: {},
              lastEvaluatedAt: {
                type: "timestamp"
              }
            }
          }
        },
        DeletePullThroughCacheRule: {
          input: {
            type: "structure",
            required: [
              "ecrRepositoryPrefix"
            ],
            members: {
              ecrRepositoryPrefix: {},
              registryId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ecrRepositoryPrefix: {},
              upstreamRegistryUrl: {},
              createdAt: {
                type: "timestamp"
              },
              registryId: {},
              credentialArn: {}
            }
          }
        },
        DeleteRegistryPolicy: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              policyText: {}
            }
          }
        },
        DeleteRepository: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              force: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repository: {
                shape: "S1z"
              }
            }
          }
        },
        DeleteRepositoryPolicy: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              policyText: {}
            }
          }
        },
        DescribeImageReplicationStatus: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "imageId"
            ],
            members: {
              repositoryName: {},
              imageId: {
                shape: "Sj"
              },
              registryId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              repositoryName: {},
              imageId: {
                shape: "Sj"
              },
              replicationStatuses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    region: {},
                    registryId: {},
                    status: {},
                    failureCode: {}
                  }
                }
              }
            }
          }
        },
        DescribeImageScanFindings: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "imageId"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              imageId: {
                shape: "Sj"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              imageId: {
                shape: "Sj"
              },
              imageScanStatus: {
                shape: "S2q"
              },
              imageScanFindings: {
                type: "structure",
                members: {
                  imageScanCompletedAt: {
                    type: "timestamp"
                  },
                  vulnerabilitySourceUpdatedAt: {
                    type: "timestamp"
                  },
                  findingSeverityCounts: {
                    shape: "S2w"
                  },
                  findings: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        name: {},
                        description: {},
                        uri: {},
                        severity: {},
                        attributes: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "key"
                            ],
                            members: {
                              key: {},
                              value: {}
                            }
                          }
                        }
                      }
                    }
                  },
                  enhancedFindings: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        awsAccountId: {},
                        description: {},
                        findingArn: {},
                        firstObservedAt: {
                          type: "timestamp"
                        },
                        lastObservedAt: {
                          type: "timestamp"
                        },
                        packageVulnerabilityDetails: {
                          type: "structure",
                          members: {
                            cvss: {
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  baseScore: {
                                    type: "double"
                                  },
                                  scoringVector: {},
                                  source: {},
                                  version: {}
                                }
                              }
                            },
                            referenceUrls: {
                              type: "list",
                              member: {}
                            },
                            relatedVulnerabilities: {
                              type: "list",
                              member: {}
                            },
                            source: {},
                            sourceUrl: {},
                            vendorCreatedAt: {
                              type: "timestamp"
                            },
                            vendorSeverity: {},
                            vendorUpdatedAt: {
                              type: "timestamp"
                            },
                            vulnerabilityId: {},
                            vulnerablePackages: {
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  arch: {},
                                  epoch: {
                                    type: "integer"
                                  },
                                  filePath: {},
                                  name: {},
                                  packageManager: {},
                                  release: {},
                                  sourceLayerHash: {},
                                  version: {}
                                }
                              }
                            }
                          }
                        },
                        remediation: {
                          type: "structure",
                          members: {
                            recommendation: {
                              type: "structure",
                              members: {
                                url: {},
                                text: {}
                              }
                            }
                          }
                        },
                        resources: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              details: {
                                type: "structure",
                                members: {
                                  awsEcrContainerImage: {
                                    type: "structure",
                                    members: {
                                      architecture: {},
                                      author: {},
                                      imageHash: {},
                                      imageTags: {
                                        type: "list",
                                        member: {}
                                      },
                                      platform: {},
                                      pushedAt: {
                                        type: "timestamp"
                                      },
                                      registry: {},
                                      repositoryName: {}
                                    }
                                  }
                                }
                              },
                              id: {},
                              tags: {
                                type: "map",
                                key: {},
                                value: {}
                              },
                              type: {}
                            }
                          }
                        },
                        score: {
                          type: "double"
                        },
                        scoreDetails: {
                          type: "structure",
                          members: {
                            cvss: {
                              type: "structure",
                              members: {
                                adjustments: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      metric: {},
                                      reason: {}
                                    }
                                  }
                                },
                                score: {
                                  type: "double"
                                },
                                scoreSource: {},
                                scoringVector: {},
                                version: {}
                              }
                            }
                          }
                        },
                        severity: {},
                        status: {},
                        title: {},
                        type: {},
                        updatedAt: {
                          type: "timestamp"
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeImages: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              imageIds: {
                shape: "Si"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filter: {
                type: "structure",
                members: {
                  tagStatus: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              imageDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    registryId: {},
                    repositoryName: {},
                    imageDigest: {},
                    imageTags: {
                      shape: "S4o"
                    },
                    imageSizeInBytes: {
                      type: "long"
                    },
                    imagePushedAt: {
                      type: "timestamp"
                    },
                    imageScanStatus: {
                      shape: "S2q"
                    },
                    imageScanFindingsSummary: {
                      type: "structure",
                      members: {
                        imageScanCompletedAt: {
                          type: "timestamp"
                        },
                        vulnerabilitySourceUpdatedAt: {
                          type: "timestamp"
                        },
                        findingSeverityCounts: {
                          shape: "S2w"
                        }
                      }
                    },
                    imageManifestMediaType: {},
                    artifactMediaType: {},
                    lastRecordedPullTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribePullThroughCacheRules: {
          input: {
            type: "structure",
            members: {
              registryId: {},
              ecrRepositoryPrefixes: {
                type: "list",
                member: {}
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              pullThroughCacheRules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ecrRepositoryPrefix: {},
                    upstreamRegistryUrl: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    registryId: {},
                    credentialArn: {},
                    upstreamRegistry: {},
                    updatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeRegistry: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              replicationConfiguration: {
                shape: "S51"
              }
            }
          }
        },
        DescribeRepositories: {
          input: {
            type: "structure",
            members: {
              registryId: {},
              repositoryNames: {
                type: "list",
                member: {}
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repositories: {
                type: "list",
                member: {
                  shape: "S1z"
                }
              },
              nextToken: {}
            }
          }
        },
        GetAuthorizationToken: {
          input: {
            type: "structure",
            members: {
              registryIds: {
                deprecated: true,
                deprecatedMessage: "This field is deprecated. The returned authorization token can be used to access any Amazon ECR registry that the IAM principal has access to, specifying a registry ID doesn't change the permissions scope of the authorization token.",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              authorizationData: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    authorizationToken: {},
                    expiresAt: {
                      type: "timestamp"
                    },
                    proxyEndpoint: {}
                  }
                }
              }
            }
          }
        },
        GetDownloadUrlForLayer: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "layerDigest"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              layerDigest: {}
            }
          },
          output: {
            type: "structure",
            members: {
              downloadUrl: {},
              layerDigest: {}
            }
          }
        },
        GetLifecyclePolicy: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              lifecyclePolicyText: {},
              lastEvaluatedAt: {
                type: "timestamp"
              }
            }
          }
        },
        GetLifecyclePolicyPreview: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              imageIds: {
                shape: "Si"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filter: {
                type: "structure",
                members: {
                  tagStatus: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              lifecyclePolicyText: {},
              status: {},
              nextToken: {},
              previewResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    imageTags: {
                      shape: "S4o"
                    },
                    imageDigest: {},
                    imagePushedAt: {
                      type: "timestamp"
                    },
                    action: {
                      type: "structure",
                      members: {
                        type: {}
                      }
                    },
                    appliedRulePriority: {
                      type: "integer"
                    }
                  }
                }
              },
              summary: {
                type: "structure",
                members: {
                  expiringImageTotalCount: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        GetRegistryPolicy: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              policyText: {}
            }
          }
        },
        GetRegistryScanningConfiguration: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              scanningConfiguration: {
                shape: "S66"
              }
            }
          }
        },
        GetRepositoryPolicy: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              policyText: {}
            }
          }
        },
        InitiateLayerUpload: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              uploadId: {},
              partSize: {
                type: "long"
              }
            }
          }
        },
        ListImages: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filter: {
                type: "structure",
                members: {
                  tagStatus: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              imageIds: {
                shape: "Si"
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S1p"
              }
            }
          }
        },
        PutImage: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "imageManifest"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              imageManifest: {},
              imageManifestMediaType: {},
              imageTag: {},
              imageDigest: {}
            }
          },
          output: {
            type: "structure",
            members: {
              image: {
                shape: "Sv"
              }
            }
          }
        },
        PutImageScanningConfiguration: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "imageScanningConfiguration"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              imageScanningConfiguration: {
                shape: "S1u"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              imageScanningConfiguration: {
                shape: "S1u"
              }
            }
          }
        },
        PutImageTagMutability: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "imageTagMutability"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              imageTagMutability: {}
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              imageTagMutability: {}
            }
          }
        },
        PutLifecyclePolicy: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "lifecyclePolicyText"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              lifecyclePolicyText: {}
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              lifecyclePolicyText: {}
            }
          }
        },
        PutRegistryPolicy: {
          input: {
            type: "structure",
            required: [
              "policyText"
            ],
            members: {
              policyText: {}
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              policyText: {}
            }
          }
        },
        PutRegistryScanningConfiguration: {
          input: {
            type: "structure",
            members: {
              scanType: {},
              rules: {
                shape: "S68"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              registryScanningConfiguration: {
                shape: "S66"
              }
            }
          }
        },
        PutReplicationConfiguration: {
          input: {
            type: "structure",
            required: [
              "replicationConfiguration"
            ],
            members: {
              replicationConfiguration: {
                shape: "S51"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              replicationConfiguration: {
                shape: "S51"
              }
            }
          }
        },
        SetRepositoryPolicy: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "policyText"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              policyText: {},
              force: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              policyText: {}
            }
          }
        },
        StartImageScan: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "imageId"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              imageId: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              imageId: {
                shape: "Sj"
              },
              imageScanStatus: {
                shape: "S2q"
              }
            }
          }
        },
        StartLifecyclePolicyPreview: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              lifecyclePolicyText: {}
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              lifecyclePolicyText: {},
              status: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "S1p"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdatePullThroughCacheRule: {
          input: {
            type: "structure",
            required: [
              "ecrRepositoryPrefix",
              "credentialArn"
            ],
            members: {
              registryId: {},
              ecrRepositoryPrefix: {},
              credentialArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ecrRepositoryPrefix: {},
              registryId: {},
              updatedAt: {
                type: "timestamp"
              },
              credentialArn: {}
            }
          }
        },
        UploadLayerPart: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "uploadId",
              "partFirstByte",
              "partLastByte",
              "layerPartBlob"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              uploadId: {},
              partFirstByte: {
                type: "long"
              },
              partLastByte: {
                type: "long"
              },
              layerPartBlob: {
                type: "blob"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              uploadId: {},
              lastByteReceived: {
                type: "long"
              }
            }
          }
        },
        ValidatePullThroughCacheRule: {
          input: {
            type: "structure",
            required: [
              "ecrRepositoryPrefix"
            ],
            members: {
              ecrRepositoryPrefix: {},
              registryId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ecrRepositoryPrefix: {},
              registryId: {},
              upstreamRegistryUrl: {},
              credentialArn: {},
              isValid: {
                type: "boolean"
              },
              failure: {}
            }
          }
        }
      },
      shapes: {
        Si: {
          type: "list",
          member: {
            shape: "Sj"
          }
        },
        Sj: {
          type: "structure",
          members: {
            imageDigest: {},
            imageTag: {}
          }
        },
        Sn: {
          type: "list",
          member: {
            type: "structure",
            members: {
              imageId: {
                shape: "Sj"
              },
              failureCode: {},
              failureReason: {}
            }
          }
        },
        Sv: {
          type: "structure",
          members: {
            registryId: {},
            repositoryName: {},
            imageId: {
              shape: "Sj"
            },
            imageManifest: {},
            imageManifestMediaType: {}
          }
        },
        S15: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "filter",
              "filterType"
            ],
            members: {
              filter: {},
              filterType: {}
            }
          }
        },
        S1p: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S1u: {
          type: "structure",
          members: {
            scanOnPush: {
              type: "boolean"
            }
          }
        },
        S1v: {
          type: "structure",
          required: [
            "encryptionType"
          ],
          members: {
            encryptionType: {},
            kmsKey: {}
          }
        },
        S1z: {
          type: "structure",
          members: {
            repositoryArn: {},
            registryId: {},
            repositoryName: {},
            repositoryUri: {},
            createdAt: {
              type: "timestamp"
            },
            imageTagMutability: {},
            imageScanningConfiguration: {
              shape: "S1u"
            },
            encryptionConfiguration: {
              shape: "S1v"
            }
          }
        },
        S2q: {
          type: "structure",
          members: {
            status: {},
            description: {}
          }
        },
        S2w: {
          type: "map",
          key: {},
          value: {
            type: "integer"
          }
        },
        S4o: {
          type: "list",
          member: {}
        },
        S51: {
          type: "structure",
          required: [
            "rules"
          ],
          members: {
            rules: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "destinations"
                ],
                members: {
                  destinations: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "region",
                        "registryId"
                      ],
                      members: {
                        region: {},
                        registryId: {}
                      }
                    }
                  },
                  repositoryFilters: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "filter",
                        "filterType"
                      ],
                      members: {
                        filter: {},
                        filterType: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S66: {
          type: "structure",
          members: {
            scanType: {},
            rules: {
              shape: "S68"
            }
          }
        },
        S68: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "scanFrequency",
              "repositoryFilters"
            ],
            members: {
              scanFrequency: {},
              repositoryFilters: {
                shape: "S15"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ecr-2015-09-21.paginators.json
var require_ecr_2015_09_21_paginators = __commonJS({
  "node_modules/aws-sdk/apis/ecr-2015-09-21.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeImageScanFindings: {
          input_token: "nextToken",
          limit_key: "maxResults",
          non_aggregate_keys: [
            "registryId",
            "repositoryName",
            "imageId",
            "imageScanStatus",
            "imageScanFindings"
          ],
          output_token: "nextToken",
          result_key: [
            "imageScanFindings.findings",
            "imageScanFindings.enhancedFindings"
          ]
        },
        DescribeImages: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "imageDetails"
        },
        DescribePullThroughCacheRules: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "pullThroughCacheRules"
        },
        DescribeRepositories: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "repositories"
        },
        GetLifecyclePolicyPreview: {
          input_token: "nextToken",
          limit_key: "maxResults",
          non_aggregate_keys: [
            "registryId",
            "repositoryName",
            "lifecyclePolicyText",
            "status",
            "summary"
          ],
          output_token: "nextToken",
          result_key: "previewResults"
        },
        ListImages: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "imageIds"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ecr-2015-09-21.waiters2.json
var require_ecr_2015_09_21_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/ecr-2015-09-21.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        ImageScanComplete: {
          description: "Wait until an image scan is complete and findings can be accessed",
          operation: "DescribeImageScanFindings",
          delay: 5,
          maxAttempts: 60,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "imageScanStatus.status",
              expected: "COMPLETE"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "imageScanStatus.status",
              expected: "FAILED"
            }
          ]
        },
        LifecyclePolicyPreviewComplete: {
          description: "Wait until a lifecycle policy preview request is complete and results can be accessed",
          operation: "GetLifecyclePolicyPreview",
          delay: 5,
          maxAttempts: 20,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "status",
              expected: "COMPLETE"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "status",
              expected: "FAILED"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/ecr.js
var require_ecr = __commonJS({
  "node_modules/aws-sdk/clients/ecr.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["ecr"] = {};
    AWS2.ECR = Service.defineService("ecr", ["2015-09-21"]);
    Object.defineProperty(apiLoader.services["ecr"], "2015-09-21", {
      get: function get() {
        var model = require_ecr_2015_09_21_min();
        model.paginators = require_ecr_2015_09_21_paginators().pagination;
        model.waiters = require_ecr_2015_09_21_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ECR;
  }
});

// node_modules/aws-sdk/apis/ecs-2014-11-13.min.json
var require_ecs_2014_11_13_min = __commonJS({
  "node_modules/aws-sdk/apis/ecs-2014-11-13.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-11-13",
        endpointPrefix: "ecs",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Amazon ECS",
        serviceFullName: "Amazon EC2 Container Service",
        serviceId: "ECS",
        signatureVersion: "v4",
        targetPrefix: "AmazonEC2ContainerServiceV20141113",
        uid: "ecs-2014-11-13"
      },
      operations: {
        CreateCapacityProvider: {
          input: {
            type: "structure",
            required: [
              "name",
              "autoScalingGroupProvider"
            ],
            members: {
              name: {},
              autoScalingGroupProvider: {
                shape: "S3"
              },
              tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              capacityProvider: {
                shape: "Sg"
              }
            }
          }
        },
        CreateCluster: {
          input: {
            type: "structure",
            members: {
              clusterName: {},
              tags: {
                shape: "Sb"
              },
              settings: {
                shape: "Sk"
              },
              configuration: {
                shape: "Sn"
              },
              capacityProviders: {
                shape: "Ss"
              },
              defaultCapacityProviderStrategy: {
                shape: "St"
              },
              serviceConnectDefaults: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              cluster: {
                shape: "Sz"
              }
            }
          }
        },
        CreateService: {
          input: {
            type: "structure",
            required: [
              "serviceName"
            ],
            members: {
              cluster: {},
              serviceName: {},
              taskDefinition: {},
              loadBalancers: {
                shape: "S18"
              },
              serviceRegistries: {
                shape: "S1b"
              },
              desiredCount: {
                type: "integer"
              },
              clientToken: {},
              launchType: {},
              capacityProviderStrategy: {
                shape: "St"
              },
              platformVersion: {},
              role: {},
              deploymentConfiguration: {
                shape: "S1e"
              },
              placementConstraints: {
                shape: "S1h"
              },
              placementStrategy: {
                shape: "S1k"
              },
              networkConfiguration: {
                shape: "S1n"
              },
              healthCheckGracePeriodSeconds: {
                type: "integer"
              },
              schedulingStrategy: {},
              deploymentController: {
                shape: "S1r"
              },
              tags: {
                shape: "Sb"
              },
              enableECSManagedTags: {
                type: "boolean"
              },
              propagateTags: {},
              enableExecuteCommand: {
                type: "boolean"
              },
              serviceConnectConfiguration: {
                shape: "S1u"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              service: {
                shape: "S26"
              }
            }
          }
        },
        CreateTaskSet: {
          input: {
            type: "structure",
            required: [
              "service",
              "cluster",
              "taskDefinition"
            ],
            members: {
              service: {},
              cluster: {},
              externalId: {},
              taskDefinition: {},
              networkConfiguration: {
                shape: "S1n"
              },
              loadBalancers: {
                shape: "S18"
              },
              serviceRegistries: {
                shape: "S1b"
              },
              launchType: {},
              capacityProviderStrategy: {
                shape: "St"
              },
              platformVersion: {},
              scale: {
                shape: "S2a"
              },
              clientToken: {},
              tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskSet: {
                shape: "S28"
              }
            }
          }
        },
        DeleteAccountSetting: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              principalArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              setting: {
                shape: "S2q"
              }
            }
          }
        },
        DeleteAttributes: {
          input: {
            type: "structure",
            required: [
              "attributes"
            ],
            members: {
              cluster: {},
              attributes: {
                shape: "S2t"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              attributes: {
                shape: "S2t"
              }
            }
          }
        },
        DeleteCapacityProvider: {
          input: {
            type: "structure",
            required: [
              "capacityProvider"
            ],
            members: {
              capacityProvider: {}
            }
          },
          output: {
            type: "structure",
            members: {
              capacityProvider: {
                shape: "Sg"
              }
            }
          }
        },
        DeleteCluster: {
          input: {
            type: "structure",
            required: [
              "cluster"
            ],
            members: {
              cluster: {}
            }
          },
          output: {
            type: "structure",
            members: {
              cluster: {
                shape: "Sz"
              }
            }
          }
        },
        DeleteService: {
          input: {
            type: "structure",
            required: [
              "service"
            ],
            members: {
              cluster: {},
              service: {},
              force: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              service: {
                shape: "S26"
              }
            }
          }
        },
        DeleteTaskDefinitions: {
          input: {
            type: "structure",
            required: [
              "taskDefinitions"
            ],
            members: {
              taskDefinitions: {
                shape: "Ss"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskDefinitions: {
                type: "list",
                member: {
                  shape: "S37"
                }
              },
              failures: {
                shape: "S58"
              }
            }
          }
        },
        DeleteTaskSet: {
          input: {
            type: "structure",
            required: [
              "cluster",
              "service",
              "taskSet"
            ],
            members: {
              cluster: {},
              service: {},
              taskSet: {},
              force: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskSet: {
                shape: "S28"
              }
            }
          }
        },
        DeregisterContainerInstance: {
          input: {
            type: "structure",
            required: [
              "containerInstance"
            ],
            members: {
              cluster: {},
              containerInstance: {},
              force: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              containerInstance: {
                shape: "S5e"
              }
            }
          }
        },
        DeregisterTaskDefinition: {
          input: {
            type: "structure",
            required: [
              "taskDefinition"
            ],
            members: {
              taskDefinition: {}
            }
          },
          output: {
            type: "structure",
            members: {
              taskDefinition: {
                shape: "S37"
              }
            }
          }
        },
        DescribeCapacityProviders: {
          input: {
            type: "structure",
            members: {
              capacityProviders: {
                shape: "Ss"
              },
              include: {
                type: "list",
                member: {}
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              capacityProviders: {
                type: "list",
                member: {
                  shape: "Sg"
                }
              },
              failures: {
                shape: "S58"
              },
              nextToken: {}
            }
          }
        },
        DescribeClusters: {
          input: {
            type: "structure",
            members: {
              clusters: {
                shape: "Ss"
              },
              include: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              clusters: {
                type: "list",
                member: {
                  shape: "Sz"
                }
              },
              failures: {
                shape: "S58"
              }
            }
          }
        },
        DescribeContainerInstances: {
          input: {
            type: "structure",
            required: [
              "containerInstances"
            ],
            members: {
              cluster: {},
              containerInstances: {
                shape: "Ss"
              },
              include: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              containerInstances: {
                shape: "S65"
              },
              failures: {
                shape: "S58"
              }
            }
          }
        },
        DescribeServices: {
          input: {
            type: "structure",
            required: [
              "services"
            ],
            members: {
              cluster: {},
              services: {
                shape: "Ss"
              },
              include: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              services: {
                type: "list",
                member: {
                  shape: "S26"
                }
              },
              failures: {
                shape: "S58"
              }
            }
          }
        },
        DescribeTaskDefinition: {
          input: {
            type: "structure",
            required: [
              "taskDefinition"
            ],
            members: {
              taskDefinition: {},
              include: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskDefinition: {
                shape: "S37"
              },
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        DescribeTaskSets: {
          input: {
            type: "structure",
            required: [
              "cluster",
              "service"
            ],
            members: {
              cluster: {},
              service: {},
              taskSets: {
                shape: "Ss"
              },
              include: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskSets: {
                shape: "S27"
              },
              failures: {
                shape: "S58"
              }
            }
          }
        },
        DescribeTasks: {
          input: {
            type: "structure",
            required: [
              "tasks"
            ],
            members: {
              cluster: {},
              tasks: {
                shape: "Ss"
              },
              include: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tasks: {
                shape: "S6n"
              },
              failures: {
                shape: "S58"
              }
            }
          }
        },
        DiscoverPollEndpoint: {
          input: {
            type: "structure",
            members: {
              containerInstance: {},
              cluster: {}
            }
          },
          output: {
            type: "structure",
            members: {
              endpoint: {},
              telemetryEndpoint: {},
              serviceConnectEndpoint: {}
            }
          }
        },
        ExecuteCommand: {
          input: {
            type: "structure",
            required: [
              "command",
              "interactive",
              "task"
            ],
            members: {
              cluster: {},
              container: {},
              command: {},
              interactive: {
                type: "boolean"
              },
              task: {}
            }
          },
          output: {
            type: "structure",
            members: {
              clusterArn: {},
              containerArn: {},
              containerName: {},
              interactive: {
                type: "boolean"
              },
              session: {
                type: "structure",
                members: {
                  sessionId: {},
                  streamUrl: {},
                  tokenValue: {
                    type: "string",
                    sensitive: true
                  }
                }
              },
              taskArn: {}
            }
          }
        },
        GetTaskProtection: {
          input: {
            type: "structure",
            required: [
              "cluster"
            ],
            members: {
              cluster: {},
              tasks: {
                shape: "Ss"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              protectedTasks: {
                shape: "S7f"
              },
              failures: {
                shape: "S58"
              }
            }
          }
        },
        ListAccountSettings: {
          input: {
            type: "structure",
            members: {
              name: {},
              value: {},
              principalArn: {},
              effectiveSettings: {
                type: "boolean"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              settings: {
                type: "list",
                member: {
                  shape: "S2q"
                }
              },
              nextToken: {}
            }
          }
        },
        ListAttributes: {
          input: {
            type: "structure",
            required: [
              "targetType"
            ],
            members: {
              cluster: {},
              targetType: {},
              attributeName: {},
              attributeValue: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              attributes: {
                shape: "S2t"
              },
              nextToken: {}
            }
          }
        },
        ListClusters: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              clusterArns: {
                shape: "Ss"
              },
              nextToken: {}
            }
          }
        },
        ListContainerInstances: {
          input: {
            type: "structure",
            members: {
              cluster: {},
              filter: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              status: {}
            }
          },
          output: {
            type: "structure",
            members: {
              containerInstanceArns: {
                shape: "Ss"
              },
              nextToken: {}
            }
          }
        },
        ListServices: {
          input: {
            type: "structure",
            members: {
              cluster: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              launchType: {},
              schedulingStrategy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              serviceArns: {
                shape: "Ss"
              },
              nextToken: {}
            }
          }
        },
        ListServicesByNamespace: {
          input: {
            type: "structure",
            required: [
              "namespace"
            ],
            members: {
              namespace: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              serviceArns: {
                shape: "Ss"
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        ListTaskDefinitionFamilies: {
          input: {
            type: "structure",
            members: {
              familyPrefix: {},
              status: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              families: {
                shape: "Ss"
              },
              nextToken: {}
            }
          }
        },
        ListTaskDefinitions: {
          input: {
            type: "structure",
            members: {
              familyPrefix: {},
              status: {},
              sort: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskDefinitionArns: {
                shape: "Ss"
              },
              nextToken: {}
            }
          }
        },
        ListTasks: {
          input: {
            type: "structure",
            members: {
              cluster: {},
              containerInstance: {},
              family: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              startedBy: {},
              serviceName: {},
              desiredStatus: {},
              launchType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              taskArns: {
                shape: "Ss"
              },
              nextToken: {}
            }
          }
        },
        PutAccountSetting: {
          input: {
            type: "structure",
            required: [
              "name",
              "value"
            ],
            members: {
              name: {},
              value: {},
              principalArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              setting: {
                shape: "S2q"
              }
            }
          }
        },
        PutAccountSettingDefault: {
          input: {
            type: "structure",
            required: [
              "name",
              "value"
            ],
            members: {
              name: {},
              value: {}
            }
          },
          output: {
            type: "structure",
            members: {
              setting: {
                shape: "S2q"
              }
            }
          }
        },
        PutAttributes: {
          input: {
            type: "structure",
            required: [
              "attributes"
            ],
            members: {
              cluster: {},
              attributes: {
                shape: "S2t"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              attributes: {
                shape: "S2t"
              }
            }
          }
        },
        PutClusterCapacityProviders: {
          input: {
            type: "structure",
            required: [
              "cluster",
              "capacityProviders",
              "defaultCapacityProviderStrategy"
            ],
            members: {
              cluster: {},
              capacityProviders: {
                shape: "Ss"
              },
              defaultCapacityProviderStrategy: {
                shape: "St"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              cluster: {
                shape: "Sz"
              }
            }
          }
        },
        RegisterContainerInstance: {
          input: {
            type: "structure",
            members: {
              cluster: {},
              instanceIdentityDocument: {},
              instanceIdentityDocumentSignature: {},
              totalResources: {
                shape: "S5h"
              },
              versionInfo: {
                shape: "S5g"
              },
              containerInstanceArn: {},
              attributes: {
                shape: "S2t"
              },
              platformDevices: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "type"
                  ],
                  members: {
                    id: {},
                    type: {}
                  }
                }
              },
              tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              containerInstance: {
                shape: "S5e"
              }
            }
          }
        },
        RegisterTaskDefinition: {
          input: {
            type: "structure",
            required: [
              "family",
              "containerDefinitions"
            ],
            members: {
              family: {},
              taskRoleArn: {},
              executionRoleArn: {},
              networkMode: {},
              containerDefinitions: {
                shape: "S38"
              },
              volumes: {
                shape: "S4e"
              },
              placementConstraints: {
                shape: "S4s"
              },
              requiresCompatibilities: {
                shape: "S4v"
              },
              cpu: {},
              memory: {},
              tags: {
                shape: "Sb"
              },
              pidMode: {},
              ipcMode: {},
              proxyConfiguration: {
                shape: "S54"
              },
              inferenceAccelerators: {
                shape: "S50"
              },
              ephemeralStorage: {
                shape: "S57"
              },
              runtimePlatform: {
                shape: "S4x"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskDefinition: {
                shape: "S37"
              },
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        RunTask: {
          input: {
            type: "structure",
            required: [
              "taskDefinition"
            ],
            members: {
              capacityProviderStrategy: {
                shape: "St"
              },
              cluster: {},
              count: {
                type: "integer"
              },
              enableECSManagedTags: {
                type: "boolean"
              },
              enableExecuteCommand: {
                type: "boolean"
              },
              group: {},
              launchType: {},
              networkConfiguration: {
                shape: "S1n"
              },
              overrides: {
                shape: "S71"
              },
              placementConstraints: {
                shape: "S1h"
              },
              placementStrategy: {
                shape: "S1k"
              },
              platformVersion: {},
              propagateTags: {},
              referenceId: {},
              startedBy: {},
              tags: {
                shape: "Sb"
              },
              taskDefinition: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tasks: {
                shape: "S6n"
              },
              failures: {
                shape: "S58"
              }
            }
          }
        },
        StartTask: {
          input: {
            type: "structure",
            required: [
              "containerInstances",
              "taskDefinition"
            ],
            members: {
              cluster: {},
              containerInstances: {
                shape: "Ss"
              },
              enableECSManagedTags: {
                type: "boolean"
              },
              enableExecuteCommand: {
                type: "boolean"
              },
              group: {},
              networkConfiguration: {
                shape: "S1n"
              },
              overrides: {
                shape: "S71"
              },
              propagateTags: {},
              referenceId: {},
              startedBy: {},
              tags: {
                shape: "Sb"
              },
              taskDefinition: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tasks: {
                shape: "S6n"
              },
              failures: {
                shape: "S58"
              }
            }
          }
        },
        StopTask: {
          input: {
            type: "structure",
            required: [
              "task"
            ],
            members: {
              cluster: {},
              task: {},
              reason: {}
            }
          },
          output: {
            type: "structure",
            members: {
              task: {
                shape: "S6o"
              }
            }
          }
        },
        SubmitAttachmentStateChanges: {
          input: {
            type: "structure",
            required: [
              "attachments"
            ],
            members: {
              cluster: {},
              attachments: {
                shape: "S8s"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              acknowledgment: {}
            }
          }
        },
        SubmitContainerStateChange: {
          input: {
            type: "structure",
            members: {
              cluster: {},
              task: {},
              containerName: {},
              runtimeId: {},
              status: {},
              exitCode: {
                type: "integer"
              },
              reason: {},
              networkBindings: {
                shape: "S6s"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              acknowledgment: {}
            }
          }
        },
        SubmitTaskStateChange: {
          input: {
            type: "structure",
            members: {
              cluster: {},
              task: {},
              status: {},
              reason: {},
              containers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    containerName: {},
                    imageDigest: {},
                    runtimeId: {},
                    exitCode: {
                      type: "integer"
                    },
                    networkBindings: {
                      shape: "S6s"
                    },
                    reason: {},
                    status: {}
                  }
                }
              },
              attachments: {
                shape: "S8s"
              },
              managedAgents: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "containerName",
                    "managedAgentName",
                    "status"
                  ],
                  members: {
                    containerName: {},
                    managedAgentName: {},
                    status: {},
                    reason: {}
                  }
                }
              },
              pullStartedAt: {
                type: "timestamp"
              },
              pullStoppedAt: {
                type: "timestamp"
              },
              executionStoppedAt: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              acknowledgment: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateCapacityProvider: {
          input: {
            type: "structure",
            required: [
              "name",
              "autoScalingGroupProvider"
            ],
            members: {
              name: {},
              autoScalingGroupProvider: {
                type: "structure",
                members: {
                  managedScaling: {
                    shape: "S4"
                  },
                  managedTerminationProtection: {},
                  managedDraining: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              capacityProvider: {
                shape: "Sg"
              }
            }
          }
        },
        UpdateCluster: {
          input: {
            type: "structure",
            required: [
              "cluster"
            ],
            members: {
              cluster: {},
              settings: {
                shape: "Sk"
              },
              configuration: {
                shape: "Sn"
              },
              serviceConnectDefaults: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              cluster: {
                shape: "Sz"
              }
            }
          }
        },
        UpdateClusterSettings: {
          input: {
            type: "structure",
            required: [
              "cluster",
              "settings"
            ],
            members: {
              cluster: {},
              settings: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              cluster: {
                shape: "Sz"
              }
            }
          }
        },
        UpdateContainerAgent: {
          input: {
            type: "structure",
            required: [
              "containerInstance"
            ],
            members: {
              cluster: {},
              containerInstance: {}
            }
          },
          output: {
            type: "structure",
            members: {
              containerInstance: {
                shape: "S5e"
              }
            }
          }
        },
        UpdateContainerInstancesState: {
          input: {
            type: "structure",
            required: [
              "containerInstances",
              "status"
            ],
            members: {
              cluster: {},
              containerInstances: {
                shape: "Ss"
              },
              status: {}
            }
          },
          output: {
            type: "structure",
            members: {
              containerInstances: {
                shape: "S65"
              },
              failures: {
                shape: "S58"
              }
            }
          }
        },
        UpdateService: {
          input: {
            type: "structure",
            required: [
              "service"
            ],
            members: {
              cluster: {},
              service: {},
              desiredCount: {
                type: "integer"
              },
              taskDefinition: {},
              capacityProviderStrategy: {
                shape: "St"
              },
              deploymentConfiguration: {
                shape: "S1e"
              },
              networkConfiguration: {
                shape: "S1n"
              },
              placementConstraints: {
                shape: "S1h"
              },
              placementStrategy: {
                shape: "S1k"
              },
              platformVersion: {},
              forceNewDeployment: {
                type: "boolean"
              },
              healthCheckGracePeriodSeconds: {
                type: "integer"
              },
              enableExecuteCommand: {
                type: "boolean"
              },
              enableECSManagedTags: {
                type: "boolean"
              },
              loadBalancers: {
                shape: "S18"
              },
              propagateTags: {},
              serviceRegistries: {
                shape: "S1b"
              },
              serviceConnectConfiguration: {
                shape: "S1u"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              service: {
                shape: "S26"
              }
            }
          }
        },
        UpdateServicePrimaryTaskSet: {
          input: {
            type: "structure",
            required: [
              "cluster",
              "service",
              "primaryTaskSet"
            ],
            members: {
              cluster: {},
              service: {},
              primaryTaskSet: {}
            }
          },
          output: {
            type: "structure",
            members: {
              taskSet: {
                shape: "S28"
              }
            }
          }
        },
        UpdateTaskProtection: {
          input: {
            type: "structure",
            required: [
              "cluster",
              "tasks",
              "protectionEnabled"
            ],
            members: {
              cluster: {},
              tasks: {
                shape: "Ss"
              },
              protectionEnabled: {
                type: "boolean"
              },
              expiresInMinutes: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              protectedTasks: {
                shape: "S7f"
              },
              failures: {
                shape: "S58"
              }
            }
          }
        },
        UpdateTaskSet: {
          input: {
            type: "structure",
            required: [
              "cluster",
              "service",
              "taskSet",
              "scale"
            ],
            members: {
              cluster: {},
              service: {},
              taskSet: {},
              scale: {
                shape: "S2a"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskSet: {
                shape: "S28"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          required: [
            "autoScalingGroupArn"
          ],
          members: {
            autoScalingGroupArn: {},
            managedScaling: {
              shape: "S4"
            },
            managedTerminationProtection: {},
            managedDraining: {}
          }
        },
        S4: {
          type: "structure",
          members: {
            status: {},
            targetCapacity: {
              type: "integer"
            },
            minimumScalingStepSize: {
              type: "integer"
            },
            maximumScalingStepSize: {
              type: "integer"
            },
            instanceWarmupPeriod: {
              type: "integer"
            }
          }
        },
        Sb: {
          type: "list",
          member: {
            type: "structure",
            members: {
              key: {},
              value: {}
            }
          }
        },
        Sg: {
          type: "structure",
          members: {
            capacityProviderArn: {},
            name: {},
            status: {},
            autoScalingGroupProvider: {
              shape: "S3"
            },
            updateStatus: {},
            updateStatusReason: {},
            tags: {
              shape: "Sb"
            }
          }
        },
        Sk: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              value: {}
            }
          }
        },
        Sn: {
          type: "structure",
          members: {
            executeCommandConfiguration: {
              type: "structure",
              members: {
                kmsKeyId: {},
                logging: {},
                logConfiguration: {
                  type: "structure",
                  members: {
                    cloudWatchLogGroupName: {},
                    cloudWatchEncryptionEnabled: {
                      type: "boolean"
                    },
                    s3BucketName: {},
                    s3EncryptionEnabled: {
                      type: "boolean"
                    },
                    s3KeyPrefix: {}
                  }
                }
              }
            }
          }
        },
        Ss: {
          type: "list",
          member: {}
        },
        St: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "capacityProvider"
            ],
            members: {
              capacityProvider: {},
              weight: {
                type: "integer"
              },
              base: {
                type: "integer"
              }
            }
          }
        },
        Sx: {
          type: "structure",
          required: [
            "namespace"
          ],
          members: {
            namespace: {}
          }
        },
        Sz: {
          type: "structure",
          members: {
            clusterArn: {},
            clusterName: {},
            configuration: {
              shape: "Sn"
            },
            status: {},
            registeredContainerInstancesCount: {
              type: "integer"
            },
            runningTasksCount: {
              type: "integer"
            },
            pendingTasksCount: {
              type: "integer"
            },
            activeServicesCount: {
              type: "integer"
            },
            statistics: {
              type: "list",
              member: {
                shape: "S12"
              }
            },
            tags: {
              shape: "Sb"
            },
            settings: {
              shape: "Sk"
            },
            capacityProviders: {
              shape: "Ss"
            },
            defaultCapacityProviderStrategy: {
              shape: "St"
            },
            attachments: {
              shape: "S13"
            },
            attachmentsStatus: {},
            serviceConnectDefaults: {
              type: "structure",
              members: {
                namespace: {}
              }
            }
          }
        },
        S12: {
          type: "structure",
          members: {
            name: {},
            value: {}
          }
        },
        S13: {
          type: "list",
          member: {
            type: "structure",
            members: {
              id: {},
              type: {},
              status: {},
              details: {
                type: "list",
                member: {
                  shape: "S12"
                }
              }
            }
          }
        },
        S18: {
          type: "list",
          member: {
            type: "structure",
            members: {
              targetGroupArn: {},
              loadBalancerName: {},
              containerName: {},
              containerPort: {
                type: "integer"
              }
            }
          }
        },
        S1b: {
          type: "list",
          member: {
            type: "structure",
            members: {
              registryArn: {},
              port: {
                type: "integer"
              },
              containerName: {},
              containerPort: {
                type: "integer"
              }
            }
          }
        },
        S1e: {
          type: "structure",
          members: {
            deploymentCircuitBreaker: {
              type: "structure",
              required: [
                "enable",
                "rollback"
              ],
              members: {
                enable: {
                  type: "boolean"
                },
                rollback: {
                  type: "boolean"
                }
              }
            },
            maximumPercent: {
              type: "integer"
            },
            minimumHealthyPercent: {
              type: "integer"
            },
            alarms: {
              type: "structure",
              required: [
                "alarmNames",
                "enable",
                "rollback"
              ],
              members: {
                alarmNames: {
                  shape: "Ss"
                },
                enable: {
                  type: "boolean"
                },
                rollback: {
                  type: "boolean"
                }
              }
            }
          }
        },
        S1h: {
          type: "list",
          member: {
            type: "structure",
            members: {
              type: {},
              expression: {}
            }
          }
        },
        S1k: {
          type: "list",
          member: {
            type: "structure",
            members: {
              type: {},
              field: {}
            }
          }
        },
        S1n: {
          type: "structure",
          members: {
            awsvpcConfiguration: {
              type: "structure",
              required: [
                "subnets"
              ],
              members: {
                subnets: {
                  shape: "Ss"
                },
                securityGroups: {
                  shape: "Ss"
                },
                assignPublicIp: {}
              }
            }
          }
        },
        S1r: {
          type: "structure",
          required: [
            "type"
          ],
          members: {
            type: {}
          }
        },
        S1u: {
          type: "structure",
          required: [
            "enabled"
          ],
          members: {
            enabled: {
              type: "boolean"
            },
            namespace: {},
            services: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "portName"
                ],
                members: {
                  portName: {},
                  discoveryName: {},
                  clientAliases: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "port"
                      ],
                      members: {
                        port: {
                          type: "integer"
                        },
                        dnsName: {}
                      }
                    }
                  },
                  ingressPortOverride: {
                    type: "integer"
                  }
                }
              }
            },
            logConfiguration: {
              shape: "S20"
            }
          }
        },
        S20: {
          type: "structure",
          required: [
            "logDriver"
          ],
          members: {
            logDriver: {},
            options: {
              type: "map",
              key: {},
              value: {}
            },
            secretOptions: {
              shape: "S23"
            }
          }
        },
        S23: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "valueFrom"
            ],
            members: {
              name: {},
              valueFrom: {}
            }
          }
        },
        S26: {
          type: "structure",
          members: {
            serviceArn: {},
            serviceName: {},
            clusterArn: {},
            loadBalancers: {
              shape: "S18"
            },
            serviceRegistries: {
              shape: "S1b"
            },
            status: {},
            desiredCount: {
              type: "integer"
            },
            runningCount: {
              type: "integer"
            },
            pendingCount: {
              type: "integer"
            },
            launchType: {},
            capacityProviderStrategy: {
              shape: "St"
            },
            platformVersion: {},
            platformFamily: {},
            taskDefinition: {},
            deploymentConfiguration: {
              shape: "S1e"
            },
            taskSets: {
              shape: "S27"
            },
            deployments: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  id: {},
                  status: {},
                  taskDefinition: {},
                  desiredCount: {
                    type: "integer"
                  },
                  pendingCount: {
                    type: "integer"
                  },
                  runningCount: {
                    type: "integer"
                  },
                  failedTasks: {
                    type: "integer"
                  },
                  createdAt: {
                    type: "timestamp"
                  },
                  updatedAt: {
                    type: "timestamp"
                  },
                  capacityProviderStrategy: {
                    shape: "St"
                  },
                  launchType: {},
                  platformVersion: {},
                  platformFamily: {},
                  networkConfiguration: {
                    shape: "S1n"
                  },
                  rolloutState: {},
                  rolloutStateReason: {},
                  serviceConnectConfiguration: {
                    shape: "S1u"
                  },
                  serviceConnectResources: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        discoveryName: {},
                        discoveryArn: {}
                      }
                    }
                  }
                }
              }
            },
            roleArn: {},
            events: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  id: {},
                  createdAt: {
                    type: "timestamp"
                  },
                  message: {}
                }
              }
            },
            createdAt: {
              type: "timestamp"
            },
            placementConstraints: {
              shape: "S1h"
            },
            placementStrategy: {
              shape: "S1k"
            },
            networkConfiguration: {
              shape: "S1n"
            },
            healthCheckGracePeriodSeconds: {
              type: "integer"
            },
            schedulingStrategy: {},
            deploymentController: {
              shape: "S1r"
            },
            tags: {
              shape: "Sb"
            },
            createdBy: {},
            enableECSManagedTags: {
              type: "boolean"
            },
            propagateTags: {},
            enableExecuteCommand: {
              type: "boolean"
            }
          }
        },
        S27: {
          type: "list",
          member: {
            shape: "S28"
          }
        },
        S28: {
          type: "structure",
          members: {
            id: {},
            taskSetArn: {},
            serviceArn: {},
            clusterArn: {},
            startedBy: {},
            externalId: {},
            status: {},
            taskDefinition: {},
            computedDesiredCount: {
              type: "integer"
            },
            pendingCount: {
              type: "integer"
            },
            runningCount: {
              type: "integer"
            },
            createdAt: {
              type: "timestamp"
            },
            updatedAt: {
              type: "timestamp"
            },
            launchType: {},
            capacityProviderStrategy: {
              shape: "St"
            },
            platformVersion: {},
            platformFamily: {},
            networkConfiguration: {
              shape: "S1n"
            },
            loadBalancers: {
              shape: "S18"
            },
            serviceRegistries: {
              shape: "S1b"
            },
            scale: {
              shape: "S2a"
            },
            stabilityStatus: {},
            stabilityStatusAt: {
              type: "timestamp"
            },
            tags: {
              shape: "Sb"
            }
          }
        },
        S2a: {
          type: "structure",
          members: {
            value: {
              type: "double"
            },
            unit: {}
          }
        },
        S2q: {
          type: "structure",
          members: {
            name: {},
            value: {},
            principalArn: {},
            type: {}
          }
        },
        S2t: {
          type: "list",
          member: {
            shape: "S2u"
          }
        },
        S2u: {
          type: "structure",
          required: [
            "name"
          ],
          members: {
            name: {},
            value: {},
            targetType: {},
            targetId: {}
          }
        },
        S37: {
          type: "structure",
          members: {
            taskDefinitionArn: {},
            containerDefinitions: {
              shape: "S38"
            },
            family: {},
            taskRoleArn: {},
            executionRoleArn: {},
            networkMode: {},
            revision: {
              type: "integer"
            },
            volumes: {
              shape: "S4e"
            },
            status: {},
            requiresAttributes: {
              type: "list",
              member: {
                shape: "S2u"
              }
            },
            placementConstraints: {
              shape: "S4s"
            },
            compatibilities: {
              shape: "S4v"
            },
            runtimePlatform: {
              shape: "S4x"
            },
            requiresCompatibilities: {
              shape: "S4v"
            },
            cpu: {},
            memory: {},
            inferenceAccelerators: {
              shape: "S50"
            },
            pidMode: {},
            ipcMode: {},
            proxyConfiguration: {
              shape: "S54"
            },
            registeredAt: {
              type: "timestamp"
            },
            deregisteredAt: {
              type: "timestamp"
            },
            registeredBy: {},
            ephemeralStorage: {
              shape: "S57"
            }
          }
        },
        S38: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              image: {},
              repositoryCredentials: {
                type: "structure",
                required: [
                  "credentialsParameter"
                ],
                members: {
                  credentialsParameter: {}
                }
              },
              cpu: {
                type: "integer"
              },
              memory: {
                type: "integer"
              },
              memoryReservation: {
                type: "integer"
              },
              links: {
                shape: "Ss"
              },
              portMappings: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    containerPort: {
                      type: "integer"
                    },
                    hostPort: {
                      type: "integer"
                    },
                    protocol: {},
                    name: {},
                    appProtocol: {},
                    containerPortRange: {}
                  }
                }
              },
              essential: {
                type: "boolean"
              },
              entryPoint: {
                shape: "Ss"
              },
              command: {
                shape: "Ss"
              },
              environment: {
                shape: "S3f"
              },
              environmentFiles: {
                shape: "S3g"
              },
              mountPoints: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    sourceVolume: {},
                    containerPath: {},
                    readOnly: {
                      type: "boolean"
                    }
                  }
                }
              },
              volumesFrom: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    sourceContainer: {},
                    readOnly: {
                      type: "boolean"
                    }
                  }
                }
              },
              linuxParameters: {
                type: "structure",
                members: {
                  capabilities: {
                    type: "structure",
                    members: {
                      add: {
                        shape: "Ss"
                      },
                      drop: {
                        shape: "Ss"
                      }
                    }
                  },
                  devices: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "hostPath"
                      ],
                      members: {
                        hostPath: {},
                        containerPath: {},
                        permissions: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  },
                  initProcessEnabled: {
                    type: "boolean"
                  },
                  sharedMemorySize: {
                    type: "integer"
                  },
                  tmpfs: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "containerPath",
                        "size"
                      ],
                      members: {
                        containerPath: {},
                        size: {
                          type: "integer"
                        },
                        mountOptions: {
                          shape: "Ss"
                        }
                      }
                    }
                  },
                  maxSwap: {
                    type: "integer"
                  },
                  swappiness: {
                    type: "integer"
                  }
                }
              },
              secrets: {
                shape: "S23"
              },
              dependsOn: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "containerName",
                    "condition"
                  ],
                  members: {
                    containerName: {},
                    condition: {}
                  }
                }
              },
              startTimeout: {
                type: "integer"
              },
              stopTimeout: {
                type: "integer"
              },
              hostname: {},
              user: {},
              workingDirectory: {},
              disableNetworking: {
                type: "boolean"
              },
              privileged: {
                type: "boolean"
              },
              readonlyRootFilesystem: {
                type: "boolean"
              },
              dnsServers: {
                shape: "Ss"
              },
              dnsSearchDomains: {
                shape: "Ss"
              },
              extraHosts: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "hostname",
                    "ipAddress"
                  ],
                  members: {
                    hostname: {},
                    ipAddress: {}
                  }
                }
              },
              dockerSecurityOptions: {
                shape: "Ss"
              },
              interactive: {
                type: "boolean"
              },
              pseudoTerminal: {
                type: "boolean"
              },
              dockerLabels: {
                type: "map",
                key: {},
                value: {}
              },
              ulimits: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "softLimit",
                    "hardLimit"
                  ],
                  members: {
                    name: {},
                    softLimit: {
                      type: "integer"
                    },
                    hardLimit: {
                      type: "integer"
                    }
                  }
                }
              },
              logConfiguration: {
                shape: "S20"
              },
              healthCheck: {
                type: "structure",
                required: [
                  "command"
                ],
                members: {
                  command: {
                    shape: "Ss"
                  },
                  interval: {
                    type: "integer"
                  },
                  timeout: {
                    type: "integer"
                  },
                  retries: {
                    type: "integer"
                  },
                  startPeriod: {
                    type: "integer"
                  }
                }
              },
              systemControls: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    namespace: {},
                    value: {}
                  }
                }
              },
              resourceRequirements: {
                shape: "S47"
              },
              firelensConfiguration: {
                type: "structure",
                required: [
                  "type"
                ],
                members: {
                  type: {},
                  options: {
                    type: "map",
                    key: {},
                    value: {}
                  }
                }
              },
              credentialSpecs: {
                shape: "Ss"
              }
            }
          }
        },
        S3f: {
          type: "list",
          member: {
            shape: "S12"
          }
        },
        S3g: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "value",
              "type"
            ],
            members: {
              value: {},
              type: {}
            }
          }
        },
        S47: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "value",
              "type"
            ],
            members: {
              value: {},
              type: {}
            }
          }
        },
        S4e: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              host: {
                type: "structure",
                members: {
                  sourcePath: {}
                }
              },
              dockerVolumeConfiguration: {
                type: "structure",
                members: {
                  scope: {},
                  autoprovision: {
                    type: "boolean"
                  },
                  driver: {},
                  driverOpts: {
                    shape: "S4j"
                  },
                  labels: {
                    shape: "S4j"
                  }
                }
              },
              efsVolumeConfiguration: {
                type: "structure",
                required: [
                  "fileSystemId"
                ],
                members: {
                  fileSystemId: {},
                  rootDirectory: {},
                  transitEncryption: {},
                  transitEncryptionPort: {
                    type: "integer"
                  },
                  authorizationConfig: {
                    type: "structure",
                    members: {
                      accessPointId: {},
                      iam: {}
                    }
                  }
                }
              },
              fsxWindowsFileServerVolumeConfiguration: {
                type: "structure",
                required: [
                  "fileSystemId",
                  "rootDirectory",
                  "authorizationConfig"
                ],
                members: {
                  fileSystemId: {},
                  rootDirectory: {},
                  authorizationConfig: {
                    type: "structure",
                    required: [
                      "credentialsParameter",
                      "domain"
                    ],
                    members: {
                      credentialsParameter: {},
                      domain: {}
                    }
                  }
                }
              }
            }
          }
        },
        S4j: {
          type: "map",
          key: {},
          value: {}
        },
        S4s: {
          type: "list",
          member: {
            type: "structure",
            members: {
              type: {},
              expression: {}
            }
          }
        },
        S4v: {
          type: "list",
          member: {}
        },
        S4x: {
          type: "structure",
          members: {
            cpuArchitecture: {},
            operatingSystemFamily: {}
          }
        },
        S50: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "deviceName",
              "deviceType"
            ],
            members: {
              deviceName: {},
              deviceType: {}
            }
          }
        },
        S54: {
          type: "structure",
          required: [
            "containerName"
          ],
          members: {
            type: {},
            containerName: {},
            properties: {
              type: "list",
              member: {
                shape: "S12"
              }
            }
          }
        },
        S57: {
          type: "structure",
          required: [
            "sizeInGiB"
          ],
          members: {
            sizeInGiB: {
              type: "integer"
            }
          }
        },
        S58: {
          type: "list",
          member: {
            type: "structure",
            members: {
              arn: {},
              reason: {},
              detail: {}
            }
          }
        },
        S5e: {
          type: "structure",
          members: {
            containerInstanceArn: {},
            ec2InstanceId: {},
            capacityProviderName: {},
            version: {
              type: "long"
            },
            versionInfo: {
              shape: "S5g"
            },
            remainingResources: {
              shape: "S5h"
            },
            registeredResources: {
              shape: "S5h"
            },
            status: {},
            statusReason: {},
            agentConnected: {
              type: "boolean"
            },
            runningTasksCount: {
              type: "integer"
            },
            pendingTasksCount: {
              type: "integer"
            },
            agentUpdateStatus: {},
            attributes: {
              shape: "S2t"
            },
            registeredAt: {
              type: "timestamp"
            },
            attachments: {
              shape: "S13"
            },
            tags: {
              shape: "Sb"
            },
            healthStatus: {
              type: "structure",
              members: {
                overallStatus: {},
                details: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      type: {},
                      status: {},
                      lastUpdated: {
                        type: "timestamp"
                      },
                      lastStatusChange: {
                        type: "timestamp"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S5g: {
          type: "structure",
          members: {
            agentVersion: {},
            agentHash: {},
            dockerVersion: {}
          }
        },
        S5h: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              type: {},
              doubleValue: {
                type: "double"
              },
              longValue: {
                type: "long"
              },
              integerValue: {
                type: "integer"
              },
              stringSetValue: {
                shape: "Ss"
              }
            }
          }
        },
        S65: {
          type: "list",
          member: {
            shape: "S5e"
          }
        },
        S6n: {
          type: "list",
          member: {
            shape: "S6o"
          }
        },
        S6o: {
          type: "structure",
          members: {
            attachments: {
              shape: "S13"
            },
            attributes: {
              shape: "S2t"
            },
            availabilityZone: {},
            capacityProviderName: {},
            clusterArn: {},
            connectivity: {},
            connectivityAt: {
              type: "timestamp"
            },
            containerInstanceArn: {},
            containers: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  containerArn: {},
                  taskArn: {},
                  name: {},
                  image: {},
                  imageDigest: {},
                  runtimeId: {},
                  lastStatus: {},
                  exitCode: {
                    type: "integer"
                  },
                  reason: {},
                  networkBindings: {
                    shape: "S6s"
                  },
                  networkInterfaces: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        attachmentId: {},
                        privateIpv4Address: {},
                        ipv6Address: {}
                      }
                    }
                  },
                  healthStatus: {},
                  managedAgents: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        lastStartedAt: {
                          type: "timestamp"
                        },
                        name: {},
                        reason: {},
                        lastStatus: {}
                      }
                    }
                  },
                  cpu: {},
                  memory: {},
                  memoryReservation: {},
                  gpuIds: {
                    type: "list",
                    member: {}
                  }
                }
              }
            },
            cpu: {},
            createdAt: {
              type: "timestamp"
            },
            desiredStatus: {},
            enableExecuteCommand: {
              type: "boolean"
            },
            executionStoppedAt: {
              type: "timestamp"
            },
            group: {},
            healthStatus: {},
            inferenceAccelerators: {
              shape: "S50"
            },
            lastStatus: {},
            launchType: {},
            memory: {},
            overrides: {
              shape: "S71"
            },
            platformVersion: {},
            platformFamily: {},
            pullStartedAt: {
              type: "timestamp"
            },
            pullStoppedAt: {
              type: "timestamp"
            },
            startedAt: {
              type: "timestamp"
            },
            startedBy: {},
            stopCode: {},
            stoppedAt: {
              type: "timestamp"
            },
            stoppedReason: {},
            stoppingAt: {
              type: "timestamp"
            },
            tags: {
              shape: "Sb"
            },
            taskArn: {},
            taskDefinitionArn: {},
            version: {
              type: "long"
            },
            ephemeralStorage: {
              shape: "S57"
            }
          }
        },
        S6s: {
          type: "list",
          member: {
            type: "structure",
            members: {
              bindIP: {},
              containerPort: {
                type: "integer"
              },
              hostPort: {
                type: "integer"
              },
              protocol: {},
              containerPortRange: {},
              hostPortRange: {}
            }
          }
        },
        S71: {
          type: "structure",
          members: {
            containerOverrides: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  name: {},
                  command: {
                    shape: "Ss"
                  },
                  environment: {
                    shape: "S3f"
                  },
                  environmentFiles: {
                    shape: "S3g"
                  },
                  cpu: {
                    type: "integer"
                  },
                  memory: {
                    type: "integer"
                  },
                  memoryReservation: {
                    type: "integer"
                  },
                  resourceRequirements: {
                    shape: "S47"
                  }
                }
              }
            },
            cpu: {},
            inferenceAcceleratorOverrides: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  deviceName: {},
                  deviceType: {}
                }
              }
            },
            executionRoleArn: {},
            memory: {},
            taskRoleArn: {},
            ephemeralStorage: {
              shape: "S57"
            }
          }
        },
        S7f: {
          type: "list",
          member: {
            type: "structure",
            members: {
              taskArn: {},
              protectionEnabled: {
                type: "boolean"
              },
              expirationDate: {
                type: "timestamp"
              }
            }
          }
        },
        S8s: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "attachmentArn",
              "status"
            ],
            members: {
              attachmentArn: {},
              status: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ecs-2014-11-13.paginators.json
var require_ecs_2014_11_13_paginators = __commonJS({
  "node_modules/aws-sdk/apis/ecs-2014-11-13.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAccountSettings: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "settings"
        },
        ListAttributes: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "attributes"
        },
        ListClusters: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "clusterArns"
        },
        ListContainerInstances: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "containerInstanceArns"
        },
        ListServices: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "serviceArns"
        },
        ListServicesByNamespace: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "serviceArns"
        },
        ListTaskDefinitionFamilies: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "families"
        },
        ListTaskDefinitions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "taskDefinitionArns"
        },
        ListTasks: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "taskArns"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ecs-2014-11-13.waiters2.json
var require_ecs_2014_11_13_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/ecs-2014-11-13.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        TasksRunning: {
          delay: 6,
          operation: "DescribeTasks",
          maxAttempts: 100,
          acceptors: [
            {
              expected: "STOPPED",
              matcher: "pathAny",
              state: "failure",
              argument: "tasks[].lastStatus"
            },
            {
              expected: "MISSING",
              matcher: "pathAny",
              state: "failure",
              argument: "failures[].reason"
            },
            {
              expected: "RUNNING",
              matcher: "pathAll",
              state: "success",
              argument: "tasks[].lastStatus"
            }
          ]
        },
        TasksStopped: {
          delay: 6,
          operation: "DescribeTasks",
          maxAttempts: 100,
          acceptors: [
            {
              expected: "STOPPED",
              matcher: "pathAll",
              state: "success",
              argument: "tasks[].lastStatus"
            }
          ]
        },
        ServicesStable: {
          delay: 15,
          operation: "DescribeServices",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "MISSING",
              matcher: "pathAny",
              state: "failure",
              argument: "failures[].reason"
            },
            {
              expected: "DRAINING",
              matcher: "pathAny",
              state: "failure",
              argument: "services[].status"
            },
            {
              expected: "INACTIVE",
              matcher: "pathAny",
              state: "failure",
              argument: "services[].status"
            },
            {
              expected: true,
              matcher: "path",
              state: "success",
              argument: "length(services[?!(length(deployments) == `1` && runningCount == desiredCount)]) == `0`"
            }
          ]
        },
        ServicesInactive: {
          delay: 15,
          operation: "DescribeServices",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "MISSING",
              matcher: "pathAny",
              state: "failure",
              argument: "failures[].reason"
            },
            {
              expected: "INACTIVE",
              matcher: "pathAny",
              state: "success",
              argument: "services[].status"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/ecs.js
var require_ecs = __commonJS({
  "node_modules/aws-sdk/clients/ecs.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["ecs"] = {};
    AWS2.ECS = Service.defineService("ecs", ["2014-11-13"]);
    Object.defineProperty(apiLoader.services["ecs"], "2014-11-13", {
      get: function get() {
        var model = require_ecs_2014_11_13_min();
        model.paginators = require_ecs_2014_11_13_paginators().pagination;
        model.waiters = require_ecs_2014_11_13_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ECS;
  }
});

// node_modules/aws-sdk/apis/elasticfilesystem-2015-02-01.min.json
var require_elasticfilesystem_2015_02_01_min = __commonJS({
  "node_modules/aws-sdk/apis/elasticfilesystem-2015-02-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-02-01",
        endpointPrefix: "elasticfilesystem",
        protocol: "rest-json",
        serviceAbbreviation: "EFS",
        serviceFullName: "Amazon Elastic File System",
        serviceId: "EFS",
        signatureVersion: "v4",
        uid: "elasticfilesystem-2015-02-01"
      },
      operations: {
        CreateAccessPoint: {
          http: {
            requestUri: "/2015-02-01/access-points",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ClientToken",
              "FileSystemId"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S3"
              },
              FileSystemId: {},
              PosixUser: {
                shape: "S8"
              },
              RootDirectory: {
                shape: "Sc"
              }
            }
          },
          output: {
            shape: "Si"
          }
        },
        CreateFileSystem: {
          http: {
            requestUri: "/2015-02-01/file-systems",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "CreationToken"
            ],
            members: {
              CreationToken: {
                idempotencyToken: true
              },
              PerformanceMode: {},
              Encrypted: {
                type: "boolean"
              },
              KmsKeyId: {},
              ThroughputMode: {},
              ProvisionedThroughputInMibps: {
                type: "double"
              },
              AvailabilityZoneName: {},
              Backup: {
                type: "boolean"
              },
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            shape: "Sx"
          }
        },
        CreateMountTarget: {
          http: {
            requestUri: "/2015-02-01/mount-targets",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FileSystemId",
              "SubnetId"
            ],
            members: {
              FileSystemId: {},
              SubnetId: {},
              IpAddress: {},
              SecurityGroups: {
                shape: "S1a"
              }
            }
          },
          output: {
            shape: "S1c"
          }
        },
        CreateReplicationConfiguration: {
          http: {
            requestUri: "/2015-02-01/file-systems/{SourceFileSystemId}/replication-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SourceFileSystemId",
              "Destinations"
            ],
            members: {
              SourceFileSystemId: {
                location: "uri",
                locationName: "SourceFileSystemId"
              },
              Destinations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Region: {},
                    AvailabilityZoneName: {},
                    KmsKeyId: {},
                    FileSystemId: {}
                  }
                }
              }
            }
          },
          output: {
            shape: "S1k"
          }
        },
        CreateTags: {
          http: {
            requestUri: "/2015-02-01/create-tags/{FileSystemId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "FileSystemId",
              "Tags"
            ],
            members: {
              FileSystemId: {
                location: "uri",
                locationName: "FileSystemId"
              },
              Tags: {
                shape: "S3"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Use TagResource."
        },
        DeleteAccessPoint: {
          http: {
            method: "DELETE",
            requestUri: "/2015-02-01/access-points/{AccessPointId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AccessPointId"
            ],
            members: {
              AccessPointId: {
                location: "uri",
                locationName: "AccessPointId"
              }
            }
          }
        },
        DeleteFileSystem: {
          http: {
            method: "DELETE",
            requestUri: "/2015-02-01/file-systems/{FileSystemId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "FileSystemId"
            ],
            members: {
              FileSystemId: {
                location: "uri",
                locationName: "FileSystemId"
              }
            }
          }
        },
        DeleteFileSystemPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/2015-02-01/file-systems/{FileSystemId}/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FileSystemId"
            ],
            members: {
              FileSystemId: {
                location: "uri",
                locationName: "FileSystemId"
              }
            }
          }
        },
        DeleteMountTarget: {
          http: {
            method: "DELETE",
            requestUri: "/2015-02-01/mount-targets/{MountTargetId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "MountTargetId"
            ],
            members: {
              MountTargetId: {
                location: "uri",
                locationName: "MountTargetId"
              }
            }
          }
        },
        DeleteReplicationConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/2015-02-01/file-systems/{SourceFileSystemId}/replication-configuration",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "SourceFileSystemId"
            ],
            members: {
              SourceFileSystemId: {
                location: "uri",
                locationName: "SourceFileSystemId"
              }
            }
          }
        },
        DeleteTags: {
          http: {
            requestUri: "/2015-02-01/delete-tags/{FileSystemId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "FileSystemId",
              "TagKeys"
            ],
            members: {
              FileSystemId: {
                location: "uri",
                locationName: "FileSystemId"
              },
              TagKeys: {
                shape: "S1v"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Use UntagResource."
        },
        DescribeAccessPoints: {
          http: {
            method: "GET",
            requestUri: "/2015-02-01/access-points",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              AccessPointId: {
                location: "querystring",
                locationName: "AccessPointId"
              },
              FileSystemId: {
                location: "querystring",
                locationName: "FileSystemId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccessPoints: {
                type: "list",
                member: {
                  shape: "Si"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeAccountPreferences: {
          http: {
            method: "GET",
            requestUri: "/2015-02-01/account-preferences",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceIdPreference: {
                shape: "S23"
              },
              NextToken: {}
            }
          }
        },
        DescribeBackupPolicy: {
          http: {
            method: "GET",
            requestUri: "/2015-02-01/file-systems/{FileSystemId}/backup-policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FileSystemId"
            ],
            members: {
              FileSystemId: {
                location: "uri",
                locationName: "FileSystemId"
              }
            }
          },
          output: {
            shape: "S28"
          }
        },
        DescribeFileSystemPolicy: {
          http: {
            method: "GET",
            requestUri: "/2015-02-01/file-systems/{FileSystemId}/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FileSystemId"
            ],
            members: {
              FileSystemId: {
                location: "uri",
                locationName: "FileSystemId"
              }
            }
          },
          output: {
            shape: "S2c"
          }
        },
        DescribeFileSystems: {
          http: {
            method: "GET",
            requestUri: "/2015-02-01/file-systems",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              CreationToken: {
                location: "querystring",
                locationName: "CreationToken"
              },
              FileSystemId: {
                location: "querystring",
                locationName: "FileSystemId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              FileSystems: {
                type: "list",
                member: {
                  shape: "Sx"
                }
              },
              NextMarker: {}
            }
          }
        },
        DescribeLifecycleConfiguration: {
          http: {
            method: "GET",
            requestUri: "/2015-02-01/file-systems/{FileSystemId}/lifecycle-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FileSystemId"
            ],
            members: {
              FileSystemId: {
                location: "uri",
                locationName: "FileSystemId"
              }
            }
          },
          output: {
            shape: "S2k"
          }
        },
        DescribeMountTargetSecurityGroups: {
          http: {
            method: "GET",
            requestUri: "/2015-02-01/mount-targets/{MountTargetId}/security-groups",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MountTargetId"
            ],
            members: {
              MountTargetId: {
                location: "uri",
                locationName: "MountTargetId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "SecurityGroups"
            ],
            members: {
              SecurityGroups: {
                shape: "S1a"
              }
            }
          }
        },
        DescribeMountTargets: {
          http: {
            method: "GET",
            requestUri: "/2015-02-01/mount-targets",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              FileSystemId: {
                location: "querystring",
                locationName: "FileSystemId"
              },
              MountTargetId: {
                location: "querystring",
                locationName: "MountTargetId"
              },
              AccessPointId: {
                location: "querystring",
                locationName: "AccessPointId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              MountTargets: {
                type: "list",
                member: {
                  shape: "S1c"
                }
              },
              NextMarker: {}
            }
          }
        },
        DescribeReplicationConfigurations: {
          http: {
            method: "GET",
            requestUri: "/2015-02-01/file-systems/replication-configurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              FileSystemId: {
                location: "querystring",
                locationName: "FileSystemId"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Replications: {
                type: "list",
                member: {
                  shape: "S1k"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeTags: {
          http: {
            method: "GET",
            requestUri: "/2015-02-01/tags/{FileSystemId}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FileSystemId"
            ],
            members: {
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              FileSystemId: {
                location: "uri",
                locationName: "FileSystemId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Marker: {},
              Tags: {
                shape: "S3"
              },
              NextMarker: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Use ListTagsForResource."
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/2015-02-01/resource-tags/{ResourceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              ResourceId: {
                location: "uri",
                locationName: "ResourceId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S3"
              },
              NextToken: {}
            }
          }
        },
        ModifyMountTargetSecurityGroups: {
          http: {
            method: "PUT",
            requestUri: "/2015-02-01/mount-targets/{MountTargetId}/security-groups",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "MountTargetId"
            ],
            members: {
              MountTargetId: {
                location: "uri",
                locationName: "MountTargetId"
              },
              SecurityGroups: {
                shape: "S1a"
              }
            }
          }
        },
        PutAccountPreferences: {
          http: {
            method: "PUT",
            requestUri: "/2015-02-01/account-preferences",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceIdType"
            ],
            members: {
              ResourceIdType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceIdPreference: {
                shape: "S23"
              }
            }
          }
        },
        PutBackupPolicy: {
          http: {
            method: "PUT",
            requestUri: "/2015-02-01/file-systems/{FileSystemId}/backup-policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FileSystemId",
              "BackupPolicy"
            ],
            members: {
              FileSystemId: {
                location: "uri",
                locationName: "FileSystemId"
              },
              BackupPolicy: {
                shape: "S29"
              }
            }
          },
          output: {
            shape: "S28"
          }
        },
        PutFileSystemPolicy: {
          http: {
            method: "PUT",
            requestUri: "/2015-02-01/file-systems/{FileSystemId}/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FileSystemId",
              "Policy"
            ],
            members: {
              FileSystemId: {
                location: "uri",
                locationName: "FileSystemId"
              },
              Policy: {},
              BypassPolicyLockoutSafetyCheck: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S2c"
          }
        },
        PutLifecycleConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/2015-02-01/file-systems/{FileSystemId}/lifecycle-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FileSystemId",
              "LifecyclePolicies"
            ],
            members: {
              FileSystemId: {
                location: "uri",
                locationName: "FileSystemId"
              },
              LifecyclePolicies: {
                shape: "S2l"
              }
            }
          },
          output: {
            shape: "S2k"
          }
        },
        TagResource: {
          http: {
            requestUri: "/2015-02-01/resource-tags/{ResourceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "Tags"
            ],
            members: {
              ResourceId: {
                location: "uri",
                locationName: "ResourceId"
              },
              Tags: {
                shape: "S3"
              }
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/2015-02-01/resource-tags/{ResourceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "TagKeys"
            ],
            members: {
              ResourceId: {
                location: "uri",
                locationName: "ResourceId"
              },
              TagKeys: {
                shape: "S1v",
                location: "querystring",
                locationName: "tagKeys"
              }
            }
          }
        },
        UpdateFileSystem: {
          http: {
            method: "PUT",
            requestUri: "/2015-02-01/file-systems/{FileSystemId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "FileSystemId"
            ],
            members: {
              FileSystemId: {
                location: "uri",
                locationName: "FileSystemId"
              },
              ThroughputMode: {},
              ProvisionedThroughputInMibps: {
                type: "double"
              }
            }
          },
          output: {
            shape: "Sx"
          }
        },
        UpdateFileSystemProtection: {
          http: {
            method: "PUT",
            requestUri: "/2015-02-01/file-systems/{FileSystemId}/protection",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FileSystemId"
            ],
            members: {
              FileSystemId: {
                location: "uri",
                locationName: "FileSystemId"
              },
              ReplicationOverwriteProtection: {}
            }
          },
          output: {
            shape: "S15"
          },
          idempotent: true
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S8: {
          type: "structure",
          required: [
            "Uid",
            "Gid"
          ],
          members: {
            Uid: {
              type: "long"
            },
            Gid: {
              type: "long"
            },
            SecondaryGids: {
              type: "list",
              member: {
                type: "long"
              }
            }
          }
        },
        Sc: {
          type: "structure",
          members: {
            Path: {},
            CreationInfo: {
              type: "structure",
              required: [
                "OwnerUid",
                "OwnerGid",
                "Permissions"
              ],
              members: {
                OwnerUid: {
                  type: "long"
                },
                OwnerGid: {
                  type: "long"
                },
                Permissions: {}
              }
            }
          }
        },
        Si: {
          type: "structure",
          members: {
            ClientToken: {},
            Name: {},
            Tags: {
              shape: "S3"
            },
            AccessPointId: {},
            AccessPointArn: {},
            FileSystemId: {},
            PosixUser: {
              shape: "S8"
            },
            RootDirectory: {
              shape: "Sc"
            },
            OwnerId: {},
            LifeCycleState: {}
          }
        },
        Sx: {
          type: "structure",
          required: [
            "OwnerId",
            "CreationToken",
            "FileSystemId",
            "CreationTime",
            "LifeCycleState",
            "NumberOfMountTargets",
            "SizeInBytes",
            "PerformanceMode",
            "Tags"
          ],
          members: {
            OwnerId: {},
            CreationToken: {},
            FileSystemId: {},
            FileSystemArn: {},
            CreationTime: {
              type: "timestamp"
            },
            LifeCycleState: {},
            Name: {},
            NumberOfMountTargets: {
              type: "integer"
            },
            SizeInBytes: {
              type: "structure",
              required: [
                "Value"
              ],
              members: {
                Value: {
                  type: "long"
                },
                Timestamp: {
                  type: "timestamp"
                },
                ValueInIA: {
                  type: "long"
                },
                ValueInStandard: {
                  type: "long"
                },
                ValueInArchive: {
                  type: "long"
                }
              }
            },
            PerformanceMode: {},
            Encrypted: {
              type: "boolean"
            },
            KmsKeyId: {},
            ThroughputMode: {},
            ProvisionedThroughputInMibps: {
              type: "double"
            },
            AvailabilityZoneName: {},
            AvailabilityZoneId: {},
            Tags: {
              shape: "S3"
            },
            FileSystemProtection: {
              shape: "S15"
            }
          }
        },
        S15: {
          type: "structure",
          members: {
            ReplicationOverwriteProtection: {}
          }
        },
        S1a: {
          type: "list",
          member: {}
        },
        S1c: {
          type: "structure",
          required: [
            "MountTargetId",
            "FileSystemId",
            "SubnetId",
            "LifeCycleState"
          ],
          members: {
            OwnerId: {},
            MountTargetId: {},
            FileSystemId: {},
            SubnetId: {},
            LifeCycleState: {},
            IpAddress: {},
            NetworkInterfaceId: {},
            AvailabilityZoneId: {},
            AvailabilityZoneName: {},
            VpcId: {}
          }
        },
        S1k: {
          type: "structure",
          required: [
            "SourceFileSystemId",
            "SourceFileSystemRegion",
            "SourceFileSystemArn",
            "OriginalSourceFileSystemArn",
            "CreationTime",
            "Destinations"
          ],
          members: {
            SourceFileSystemId: {},
            SourceFileSystemRegion: {},
            SourceFileSystemArn: {},
            OriginalSourceFileSystemArn: {},
            CreationTime: {
              type: "timestamp"
            },
            Destinations: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Status",
                  "FileSystemId",
                  "Region"
                ],
                members: {
                  Status: {},
                  FileSystemId: {},
                  Region: {},
                  LastReplicatedTimestamp: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        S1v: {
          type: "list",
          member: {}
        },
        S23: {
          type: "structure",
          members: {
            ResourceIdType: {},
            Resources: {
              type: "list",
              member: {}
            }
          }
        },
        S28: {
          type: "structure",
          members: {
            BackupPolicy: {
              shape: "S29"
            }
          }
        },
        S29: {
          type: "structure",
          required: [
            "Status"
          ],
          members: {
            Status: {}
          }
        },
        S2c: {
          type: "structure",
          members: {
            FileSystemId: {},
            Policy: {}
          }
        },
        S2k: {
          type: "structure",
          members: {
            LifecyclePolicies: {
              shape: "S2l"
            }
          }
        },
        S2l: {
          type: "list",
          member: {
            type: "structure",
            members: {
              TransitionToIA: {},
              TransitionToPrimaryStorageClass: {},
              TransitionToArchive: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/elasticfilesystem-2015-02-01.paginators.json
var require_elasticfilesystem_2015_02_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/elasticfilesystem-2015-02-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeAccessPoints: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AccessPoints"
        },
        DescribeFileSystems: {
          input_token: "Marker",
          output_token: "NextMarker",
          limit_key: "MaxItems",
          result_key: "FileSystems"
        },
        DescribeMountTargets: {
          input_token: "Marker",
          output_token: "NextMarker",
          limit_key: "MaxItems",
          result_key: "MountTargets"
        },
        DescribeReplicationConfigurations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Replications"
        },
        DescribeTags: {
          input_token: "Marker",
          output_token: "NextMarker",
          limit_key: "MaxItems",
          result_key: "Tags"
        },
        ListTagsForResource: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/efs.js
var require_efs = __commonJS({
  "node_modules/aws-sdk/clients/efs.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["efs"] = {};
    AWS2.EFS = Service.defineService("efs", ["2015-02-01"]);
    Object.defineProperty(apiLoader.services["efs"], "2015-02-01", {
      get: function get() {
        var model = require_elasticfilesystem_2015_02_01_min();
        model.paginators = require_elasticfilesystem_2015_02_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.EFS;
  }
});

// node_modules/aws-sdk/apis/elasticache-2015-02-02.min.json
var require_elasticache_2015_02_02_min = __commonJS({
  "node_modules/aws-sdk/apis/elasticache-2015-02-02.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-02-02",
        endpointPrefix: "elasticache",
        protocol: "query",
        serviceFullName: "Amazon ElastiCache",
        serviceId: "ElastiCache",
        signatureVersion: "v4",
        uid: "elasticache-2015-02-02",
        xmlNamespace: "http://elasticache.amazonaws.com/doc/2015-02-02/"
      },
      operations: {
        AddTagsToResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "Tags"
            ],
            members: {
              ResourceName: {},
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            shape: "S5",
            resultWrapper: "AddTagsToResourceResult"
          }
        },
        AuthorizeCacheSecurityGroupIngress: {
          input: {
            type: "structure",
            required: [
              "CacheSecurityGroupName",
              "EC2SecurityGroupName",
              "EC2SecurityGroupOwnerId"
            ],
            members: {
              CacheSecurityGroupName: {},
              EC2SecurityGroupName: {},
              EC2SecurityGroupOwnerId: {}
            }
          },
          output: {
            resultWrapper: "AuthorizeCacheSecurityGroupIngressResult",
            type: "structure",
            members: {
              CacheSecurityGroup: {
                shape: "S8"
              }
            }
          }
        },
        BatchApplyUpdateAction: {
          input: {
            type: "structure",
            required: [
              "ServiceUpdateName"
            ],
            members: {
              ReplicationGroupIds: {
                shape: "Sc"
              },
              CacheClusterIds: {
                shape: "Sd"
              },
              ServiceUpdateName: {}
            }
          },
          output: {
            shape: "Se",
            resultWrapper: "BatchApplyUpdateActionResult"
          }
        },
        BatchStopUpdateAction: {
          input: {
            type: "structure",
            required: [
              "ServiceUpdateName"
            ],
            members: {
              ReplicationGroupIds: {
                shape: "Sc"
              },
              CacheClusterIds: {
                shape: "Sd"
              },
              ServiceUpdateName: {}
            }
          },
          output: {
            shape: "Se",
            resultWrapper: "BatchStopUpdateActionResult"
          }
        },
        CompleteMigration: {
          input: {
            type: "structure",
            required: [
              "ReplicationGroupId"
            ],
            members: {
              ReplicationGroupId: {},
              Force: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CompleteMigrationResult",
            type: "structure",
            members: {
              ReplicationGroup: {
                shape: "So"
              }
            }
          }
        },
        CopyServerlessCacheSnapshot: {
          input: {
            type: "structure",
            required: [
              "SourceServerlessCacheSnapshotName",
              "TargetServerlessCacheSnapshotName"
            ],
            members: {
              SourceServerlessCacheSnapshotName: {},
              TargetServerlessCacheSnapshotName: {},
              KmsKeyId: {},
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            resultWrapper: "CopyServerlessCacheSnapshotResult",
            type: "structure",
            members: {
              ServerlessCacheSnapshot: {
                shape: "S1u"
              }
            }
          }
        },
        CopySnapshot: {
          input: {
            type: "structure",
            required: [
              "SourceSnapshotName",
              "TargetSnapshotName"
            ],
            members: {
              SourceSnapshotName: {},
              TargetSnapshotName: {},
              TargetBucket: {},
              KmsKeyId: {},
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            resultWrapper: "CopySnapshotResult",
            type: "structure",
            members: {
              Snapshot: {
                shape: "S1y"
              }
            }
          }
        },
        CreateCacheCluster: {
          input: {
            type: "structure",
            required: [
              "CacheClusterId"
            ],
            members: {
              CacheClusterId: {},
              ReplicationGroupId: {},
              AZMode: {},
              PreferredAvailabilityZone: {},
              PreferredAvailabilityZones: {
                shape: "S27"
              },
              NumCacheNodes: {
                type: "integer"
              },
              CacheNodeType: {},
              Engine: {},
              EngineVersion: {},
              CacheParameterGroupName: {},
              CacheSubnetGroupName: {},
              CacheSecurityGroupNames: {
                shape: "S28"
              },
              SecurityGroupIds: {
                shape: "S29"
              },
              Tags: {
                shape: "S3"
              },
              SnapshotArns: {
                shape: "S2a"
              },
              SnapshotName: {},
              PreferredMaintenanceWindow: {},
              Port: {
                type: "integer"
              },
              NotificationTopicArn: {},
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              SnapshotRetentionLimit: {
                type: "integer"
              },
              SnapshotWindow: {},
              AuthToken: {},
              OutpostMode: {},
              PreferredOutpostArn: {},
              PreferredOutpostArns: {
                shape: "S2c"
              },
              LogDeliveryConfigurations: {
                shape: "S2d"
              },
              TransitEncryptionEnabled: {
                type: "boolean"
              },
              NetworkType: {},
              IpDiscovery: {}
            }
          },
          output: {
            resultWrapper: "CreateCacheClusterResult",
            type: "structure",
            members: {
              CacheCluster: {
                shape: "S2g"
              }
            }
          }
        },
        CreateCacheParameterGroup: {
          input: {
            type: "structure",
            required: [
              "CacheParameterGroupName",
              "CacheParameterGroupFamily",
              "Description"
            ],
            members: {
              CacheParameterGroupName: {},
              CacheParameterGroupFamily: {},
              Description: {},
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            resultWrapper: "CreateCacheParameterGroupResult",
            type: "structure",
            members: {
              CacheParameterGroup: {
                shape: "S2t"
              }
            }
          }
        },
        CreateCacheSecurityGroup: {
          input: {
            type: "structure",
            required: [
              "CacheSecurityGroupName",
              "Description"
            ],
            members: {
              CacheSecurityGroupName: {},
              Description: {},
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            resultWrapper: "CreateCacheSecurityGroupResult",
            type: "structure",
            members: {
              CacheSecurityGroup: {
                shape: "S8"
              }
            }
          }
        },
        CreateCacheSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "CacheSubnetGroupName",
              "CacheSubnetGroupDescription",
              "SubnetIds"
            ],
            members: {
              CacheSubnetGroupName: {},
              CacheSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S2x"
              },
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            resultWrapper: "CreateCacheSubnetGroupResult",
            type: "structure",
            members: {
              CacheSubnetGroup: {
                shape: "S2z"
              }
            }
          }
        },
        CreateGlobalReplicationGroup: {
          input: {
            type: "structure",
            required: [
              "GlobalReplicationGroupIdSuffix",
              "PrimaryReplicationGroupId"
            ],
            members: {
              GlobalReplicationGroupIdSuffix: {},
              GlobalReplicationGroupDescription: {},
              PrimaryReplicationGroupId: {}
            }
          },
          output: {
            resultWrapper: "CreateGlobalReplicationGroupResult",
            type: "structure",
            members: {
              GlobalReplicationGroup: {
                shape: "S37"
              }
            }
          }
        },
        CreateReplicationGroup: {
          input: {
            type: "structure",
            required: [
              "ReplicationGroupId",
              "ReplicationGroupDescription"
            ],
            members: {
              ReplicationGroupId: {},
              ReplicationGroupDescription: {},
              GlobalReplicationGroupId: {},
              PrimaryClusterId: {},
              AutomaticFailoverEnabled: {
                type: "boolean"
              },
              MultiAZEnabled: {
                type: "boolean"
              },
              NumCacheClusters: {
                type: "integer"
              },
              PreferredCacheClusterAZs: {
                shape: "S23"
              },
              NumNodeGroups: {
                type: "integer"
              },
              ReplicasPerNodeGroup: {
                type: "integer"
              },
              NodeGroupConfiguration: {
                type: "list",
                member: {
                  shape: "S21",
                  locationName: "NodeGroupConfiguration"
                }
              },
              CacheNodeType: {},
              Engine: {},
              EngineVersion: {},
              CacheParameterGroupName: {},
              CacheSubnetGroupName: {},
              CacheSecurityGroupNames: {
                shape: "S28"
              },
              SecurityGroupIds: {
                shape: "S29"
              },
              Tags: {
                shape: "S3"
              },
              SnapshotArns: {
                shape: "S2a"
              },
              SnapshotName: {},
              PreferredMaintenanceWindow: {},
              Port: {
                type: "integer"
              },
              NotificationTopicArn: {},
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              SnapshotRetentionLimit: {
                type: "integer"
              },
              SnapshotWindow: {},
              AuthToken: {},
              TransitEncryptionEnabled: {
                type: "boolean"
              },
              AtRestEncryptionEnabled: {
                type: "boolean"
              },
              KmsKeyId: {},
              UserGroupIds: {
                type: "list",
                member: {}
              },
              LogDeliveryConfigurations: {
                shape: "S2d"
              },
              DataTieringEnabled: {
                type: "boolean"
              },
              NetworkType: {},
              IpDiscovery: {},
              TransitEncryptionMode: {},
              ClusterMode: {},
              ServerlessCacheSnapshotName: {}
            }
          },
          output: {
            resultWrapper: "CreateReplicationGroupResult",
            type: "structure",
            members: {
              ReplicationGroup: {
                shape: "So"
              }
            }
          }
        },
        CreateServerlessCache: {
          input: {
            type: "structure",
            required: [
              "ServerlessCacheName",
              "Engine"
            ],
            members: {
              ServerlessCacheName: {},
              Description: {},
              Engine: {},
              MajorEngineVersion: {},
              CacheUsageLimits: {
                shape: "S3h"
              },
              KmsKeyId: {},
              SecurityGroupIds: {
                shape: "S29"
              },
              SnapshotArnsToRestore: {
                shape: "S2a"
              },
              Tags: {
                shape: "S3"
              },
              UserGroupId: {},
              SubnetIds: {
                shape: "S3l"
              },
              SnapshotRetentionLimit: {
                type: "integer"
              },
              DailySnapshotTime: {}
            }
          },
          output: {
            resultWrapper: "CreateServerlessCacheResult",
            type: "structure",
            members: {
              ServerlessCache: {
                shape: "S3n"
              }
            }
          }
        },
        CreateServerlessCacheSnapshot: {
          input: {
            type: "structure",
            required: [
              "ServerlessCacheSnapshotName",
              "ServerlessCacheName"
            ],
            members: {
              ServerlessCacheSnapshotName: {},
              ServerlessCacheName: {},
              KmsKeyId: {},
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            resultWrapper: "CreateServerlessCacheSnapshotResult",
            type: "structure",
            members: {
              ServerlessCacheSnapshot: {
                shape: "S1u"
              }
            }
          }
        },
        CreateSnapshot: {
          input: {
            type: "structure",
            required: [
              "SnapshotName"
            ],
            members: {
              ReplicationGroupId: {},
              CacheClusterId: {},
              SnapshotName: {},
              KmsKeyId: {},
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            resultWrapper: "CreateSnapshotResult",
            type: "structure",
            members: {
              Snapshot: {
                shape: "S1y"
              }
            }
          }
        },
        CreateUser: {
          input: {
            type: "structure",
            required: [
              "UserId",
              "UserName",
              "Engine",
              "AccessString"
            ],
            members: {
              UserId: {},
              UserName: {},
              Engine: {},
              Passwords: {
                shape: "S3w"
              },
              AccessString: {},
              NoPasswordRequired: {
                type: "boolean"
              },
              Tags: {
                shape: "S3"
              },
              AuthenticationMode: {
                shape: "S3y"
              }
            }
          },
          output: {
            shape: "S40",
            resultWrapper: "CreateUserResult"
          }
        },
        CreateUserGroup: {
          input: {
            type: "structure",
            required: [
              "UserGroupId",
              "Engine"
            ],
            members: {
              UserGroupId: {},
              Engine: {},
              UserIds: {
                shape: "S44"
              },
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            shape: "S45",
            resultWrapper: "CreateUserGroupResult"
          }
        },
        DecreaseNodeGroupsInGlobalReplicationGroup: {
          input: {
            type: "structure",
            required: [
              "GlobalReplicationGroupId",
              "NodeGroupCount",
              "ApplyImmediately"
            ],
            members: {
              GlobalReplicationGroupId: {},
              NodeGroupCount: {
                type: "integer"
              },
              GlobalNodeGroupsToRemove: {
                shape: "S4b"
              },
              GlobalNodeGroupsToRetain: {
                shape: "S4b"
              },
              ApplyImmediately: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DecreaseNodeGroupsInGlobalReplicationGroupResult",
            type: "structure",
            members: {
              GlobalReplicationGroup: {
                shape: "S37"
              }
            }
          }
        },
        DecreaseReplicaCount: {
          input: {
            type: "structure",
            required: [
              "ReplicationGroupId",
              "ApplyImmediately"
            ],
            members: {
              ReplicationGroupId: {},
              NewReplicaCount: {
                type: "integer"
              },
              ReplicaConfiguration: {
                shape: "S4e"
              },
              ReplicasToRemove: {
                type: "list",
                member: {}
              },
              ApplyImmediately: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DecreaseReplicaCountResult",
            type: "structure",
            members: {
              ReplicationGroup: {
                shape: "So"
              }
            }
          }
        },
        DeleteCacheCluster: {
          input: {
            type: "structure",
            required: [
              "CacheClusterId"
            ],
            members: {
              CacheClusterId: {},
              FinalSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteCacheClusterResult",
            type: "structure",
            members: {
              CacheCluster: {
                shape: "S2g"
              }
            }
          }
        },
        DeleteCacheParameterGroup: {
          input: {
            type: "structure",
            required: [
              "CacheParameterGroupName"
            ],
            members: {
              CacheParameterGroupName: {}
            }
          }
        },
        DeleteCacheSecurityGroup: {
          input: {
            type: "structure",
            required: [
              "CacheSecurityGroupName"
            ],
            members: {
              CacheSecurityGroupName: {}
            }
          }
        },
        DeleteCacheSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "CacheSubnetGroupName"
            ],
            members: {
              CacheSubnetGroupName: {}
            }
          }
        },
        DeleteGlobalReplicationGroup: {
          input: {
            type: "structure",
            required: [
              "GlobalReplicationGroupId",
              "RetainPrimaryReplicationGroup"
            ],
            members: {
              GlobalReplicationGroupId: {},
              RetainPrimaryReplicationGroup: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DeleteGlobalReplicationGroupResult",
            type: "structure",
            members: {
              GlobalReplicationGroup: {
                shape: "S37"
              }
            }
          }
        },
        DeleteReplicationGroup: {
          input: {
            type: "structure",
            required: [
              "ReplicationGroupId"
            ],
            members: {
              ReplicationGroupId: {},
              RetainPrimaryCluster: {
                type: "boolean"
              },
              FinalSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteReplicationGroupResult",
            type: "structure",
            members: {
              ReplicationGroup: {
                shape: "So"
              }
            }
          }
        },
        DeleteServerlessCache: {
          input: {
            type: "structure",
            required: [
              "ServerlessCacheName"
            ],
            members: {
              ServerlessCacheName: {},
              FinalSnapshotName: {}
            }
          },
          output: {
            resultWrapper: "DeleteServerlessCacheResult",
            type: "structure",
            members: {
              ServerlessCache: {
                shape: "S3n"
              }
            }
          }
        },
        DeleteServerlessCacheSnapshot: {
          input: {
            type: "structure",
            required: [
              "ServerlessCacheSnapshotName"
            ],
            members: {
              ServerlessCacheSnapshotName: {}
            }
          },
          output: {
            resultWrapper: "DeleteServerlessCacheSnapshotResult",
            type: "structure",
            members: {
              ServerlessCacheSnapshot: {
                shape: "S1u"
              }
            }
          }
        },
        DeleteSnapshot: {
          input: {
            type: "structure",
            required: [
              "SnapshotName"
            ],
            members: {
              SnapshotName: {}
            }
          },
          output: {
            resultWrapper: "DeleteSnapshotResult",
            type: "structure",
            members: {
              Snapshot: {
                shape: "S1y"
              }
            }
          }
        },
        DeleteUser: {
          input: {
            type: "structure",
            required: [
              "UserId"
            ],
            members: {
              UserId: {}
            }
          },
          output: {
            shape: "S40",
            resultWrapper: "DeleteUserResult"
          }
        },
        DeleteUserGroup: {
          input: {
            type: "structure",
            required: [
              "UserGroupId"
            ],
            members: {
              UserGroupId: {}
            }
          },
          output: {
            shape: "S45",
            resultWrapper: "DeleteUserGroupResult"
          }
        },
        DescribeCacheClusters: {
          input: {
            type: "structure",
            members: {
              CacheClusterId: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              ShowCacheNodeInfo: {
                type: "boolean"
              },
              ShowCacheClustersNotInReplicationGroups: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeCacheClustersResult",
            type: "structure",
            members: {
              Marker: {},
              CacheClusters: {
                type: "list",
                member: {
                  shape: "S2g",
                  locationName: "CacheCluster"
                }
              }
            }
          }
        },
        DescribeCacheEngineVersions: {
          input: {
            type: "structure",
            members: {
              Engine: {},
              EngineVersion: {},
              CacheParameterGroupFamily: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              DefaultOnly: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeCacheEngineVersionsResult",
            type: "structure",
            members: {
              Marker: {},
              CacheEngineVersions: {
                type: "list",
                member: {
                  locationName: "CacheEngineVersion",
                  type: "structure",
                  members: {
                    Engine: {},
                    EngineVersion: {},
                    CacheParameterGroupFamily: {},
                    CacheEngineDescription: {},
                    CacheEngineVersionDescription: {}
                  }
                }
              }
            }
          }
        },
        DescribeCacheParameterGroups: {
          input: {
            type: "structure",
            members: {
              CacheParameterGroupName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeCacheParameterGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              CacheParameterGroups: {
                type: "list",
                member: {
                  shape: "S2t",
                  locationName: "CacheParameterGroup"
                }
              }
            }
          }
        },
        DescribeCacheParameters: {
          input: {
            type: "structure",
            required: [
              "CacheParameterGroupName"
            ],
            members: {
              CacheParameterGroupName: {},
              Source: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeCacheParametersResult",
            type: "structure",
            members: {
              Marker: {},
              Parameters: {
                shape: "S5b"
              },
              CacheNodeTypeSpecificParameters: {
                shape: "S5e"
              }
            }
          }
        },
        DescribeCacheSecurityGroups: {
          input: {
            type: "structure",
            members: {
              CacheSecurityGroupName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeCacheSecurityGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              CacheSecurityGroups: {
                type: "list",
                member: {
                  shape: "S8",
                  locationName: "CacheSecurityGroup"
                }
              }
            }
          }
        },
        DescribeCacheSubnetGroups: {
          input: {
            type: "structure",
            members: {
              CacheSubnetGroupName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeCacheSubnetGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              CacheSubnetGroups: {
                type: "list",
                member: {
                  shape: "S2z",
                  locationName: "CacheSubnetGroup"
                }
              }
            }
          }
        },
        DescribeEngineDefaultParameters: {
          input: {
            type: "structure",
            required: [
              "CacheParameterGroupFamily"
            ],
            members: {
              CacheParameterGroupFamily: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEngineDefaultParametersResult",
            type: "structure",
            members: {
              EngineDefaults: {
                type: "structure",
                members: {
                  CacheParameterGroupFamily: {},
                  Marker: {},
                  Parameters: {
                    shape: "S5b"
                  },
                  CacheNodeTypeSpecificParameters: {
                    shape: "S5e"
                  }
                },
                wrapper: true
              }
            }
          }
        },
        DescribeEvents: {
          input: {
            type: "structure",
            members: {
              SourceIdentifier: {},
              SourceType: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Duration: {
                type: "integer"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventsResult",
            type: "structure",
            members: {
              Marker: {},
              Events: {
                type: "list",
                member: {
                  locationName: "Event",
                  type: "structure",
                  members: {
                    SourceIdentifier: {},
                    SourceType: {},
                    Message: {},
                    Date: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeGlobalReplicationGroups: {
          input: {
            type: "structure",
            members: {
              GlobalReplicationGroupId: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              ShowMemberInfo: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeGlobalReplicationGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              GlobalReplicationGroups: {
                type: "list",
                member: {
                  shape: "S37",
                  locationName: "GlobalReplicationGroup"
                }
              }
            }
          }
        },
        DescribeReplicationGroups: {
          input: {
            type: "structure",
            members: {
              ReplicationGroupId: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeReplicationGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              ReplicationGroups: {
                type: "list",
                member: {
                  shape: "So",
                  locationName: "ReplicationGroup"
                }
              }
            }
          }
        },
        DescribeReservedCacheNodes: {
          input: {
            type: "structure",
            members: {
              ReservedCacheNodeId: {},
              ReservedCacheNodesOfferingId: {},
              CacheNodeType: {},
              Duration: {},
              ProductDescription: {},
              OfferingType: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeReservedCacheNodesResult",
            type: "structure",
            members: {
              Marker: {},
              ReservedCacheNodes: {
                type: "list",
                member: {
                  shape: "S65",
                  locationName: "ReservedCacheNode"
                }
              }
            }
          }
        },
        DescribeReservedCacheNodesOfferings: {
          input: {
            type: "structure",
            members: {
              ReservedCacheNodesOfferingId: {},
              CacheNodeType: {},
              Duration: {},
              ProductDescription: {},
              OfferingType: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeReservedCacheNodesOfferingsResult",
            type: "structure",
            members: {
              Marker: {},
              ReservedCacheNodesOfferings: {
                type: "list",
                member: {
                  locationName: "ReservedCacheNodesOffering",
                  type: "structure",
                  members: {
                    ReservedCacheNodesOfferingId: {},
                    CacheNodeType: {},
                    Duration: {
                      type: "integer"
                    },
                    FixedPrice: {
                      type: "double"
                    },
                    UsagePrice: {
                      type: "double"
                    },
                    ProductDescription: {},
                    OfferingType: {},
                    RecurringCharges: {
                      shape: "S66"
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        DescribeServerlessCacheSnapshots: {
          input: {
            type: "structure",
            members: {
              ServerlessCacheName: {},
              ServerlessCacheSnapshotName: {},
              SnapshotType: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeServerlessCacheSnapshotsResult",
            type: "structure",
            members: {
              NextToken: {},
              ServerlessCacheSnapshots: {
                type: "list",
                member: {
                  shape: "S1u",
                  locationName: "ServerlessCacheSnapshot"
                }
              }
            }
          }
        },
        DescribeServerlessCaches: {
          input: {
            type: "structure",
            members: {
              ServerlessCacheName: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "DescribeServerlessCachesResult",
            type: "structure",
            members: {
              NextToken: {},
              ServerlessCaches: {
                type: "list",
                member: {
                  shape: "S3n"
                }
              }
            }
          }
        },
        DescribeServiceUpdates: {
          input: {
            type: "structure",
            members: {
              ServiceUpdateName: {},
              ServiceUpdateStatus: {
                shape: "S6j"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeServiceUpdatesResult",
            type: "structure",
            members: {
              Marker: {},
              ServiceUpdates: {
                type: "list",
                member: {
                  locationName: "ServiceUpdate",
                  type: "structure",
                  members: {
                    ServiceUpdateName: {},
                    ServiceUpdateReleaseDate: {
                      type: "timestamp"
                    },
                    ServiceUpdateEndDate: {
                      type: "timestamp"
                    },
                    ServiceUpdateSeverity: {},
                    ServiceUpdateRecommendedApplyByDate: {
                      type: "timestamp"
                    },
                    ServiceUpdateStatus: {},
                    ServiceUpdateDescription: {},
                    ServiceUpdateType: {},
                    Engine: {},
                    EngineVersion: {},
                    AutoUpdateAfterRecommendedApplyByDate: {
                      type: "boolean"
                    },
                    EstimatedUpdateTime: {}
                  }
                }
              }
            }
          }
        },
        DescribeSnapshots: {
          input: {
            type: "structure",
            members: {
              ReplicationGroupId: {},
              CacheClusterId: {},
              SnapshotName: {},
              SnapshotSource: {},
              Marker: {},
              MaxRecords: {
                type: "integer"
              },
              ShowNodeGroupConfig: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeSnapshotsResult",
            type: "structure",
            members: {
              Marker: {},
              Snapshots: {
                type: "list",
                member: {
                  shape: "S1y",
                  locationName: "Snapshot"
                }
              }
            }
          }
        },
        DescribeUpdateActions: {
          input: {
            type: "structure",
            members: {
              ServiceUpdateName: {},
              ReplicationGroupIds: {
                shape: "Sc"
              },
              CacheClusterIds: {
                shape: "Sd"
              },
              Engine: {},
              ServiceUpdateStatus: {
                shape: "S6j"
              },
              ServiceUpdateTimeRange: {
                type: "structure",
                members: {
                  StartTime: {
                    type: "timestamp"
                  },
                  EndTime: {
                    type: "timestamp"
                  }
                }
              },
              UpdateActionStatus: {
                type: "list",
                member: {}
              },
              ShowNodeLevelUpdateStatus: {
                type: "boolean"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeUpdateActionsResult",
            type: "structure",
            members: {
              Marker: {},
              UpdateActions: {
                type: "list",
                member: {
                  locationName: "UpdateAction",
                  type: "structure",
                  members: {
                    ReplicationGroupId: {},
                    CacheClusterId: {},
                    ServiceUpdateName: {},
                    ServiceUpdateReleaseDate: {
                      type: "timestamp"
                    },
                    ServiceUpdateSeverity: {},
                    ServiceUpdateStatus: {},
                    ServiceUpdateRecommendedApplyByDate: {
                      type: "timestamp"
                    },
                    ServiceUpdateType: {},
                    UpdateActionAvailableDate: {
                      type: "timestamp"
                    },
                    UpdateActionStatus: {},
                    NodesUpdated: {},
                    UpdateActionStatusModifiedDate: {
                      type: "timestamp"
                    },
                    SlaMet: {},
                    NodeGroupUpdateStatus: {
                      type: "list",
                      member: {
                        locationName: "NodeGroupUpdateStatus",
                        type: "structure",
                        members: {
                          NodeGroupId: {},
                          NodeGroupMemberUpdateStatus: {
                            type: "list",
                            member: {
                              locationName: "NodeGroupMemberUpdateStatus",
                              type: "structure",
                              members: {
                                CacheClusterId: {},
                                CacheNodeId: {},
                                NodeUpdateStatus: {},
                                NodeDeletionDate: {
                                  type: "timestamp"
                                },
                                NodeUpdateStartDate: {
                                  type: "timestamp"
                                },
                                NodeUpdateEndDate: {
                                  type: "timestamp"
                                },
                                NodeUpdateInitiatedBy: {},
                                NodeUpdateInitiatedDate: {
                                  type: "timestamp"
                                },
                                NodeUpdateStatusModifiedDate: {
                                  type: "timestamp"
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    CacheNodeUpdateStatus: {
                      type: "list",
                      member: {
                        locationName: "CacheNodeUpdateStatus",
                        type: "structure",
                        members: {
                          CacheNodeId: {},
                          NodeUpdateStatus: {},
                          NodeDeletionDate: {
                            type: "timestamp"
                          },
                          NodeUpdateStartDate: {
                            type: "timestamp"
                          },
                          NodeUpdateEndDate: {
                            type: "timestamp"
                          },
                          NodeUpdateInitiatedBy: {},
                          NodeUpdateInitiatedDate: {
                            type: "timestamp"
                          },
                          NodeUpdateStatusModifiedDate: {
                            type: "timestamp"
                          }
                        }
                      }
                    },
                    EstimatedUpdateTime: {},
                    Engine: {}
                  }
                }
              }
            }
          }
        },
        DescribeUserGroups: {
          input: {
            type: "structure",
            members: {
              UserGroupId: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeUserGroupsResult",
            type: "structure",
            members: {
              UserGroups: {
                type: "list",
                member: {
                  shape: "S45"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeUsers: {
          input: {
            type: "structure",
            members: {
              Engine: {},
              UserId: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Values"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeUsersResult",
            type: "structure",
            members: {
              Users: {
                type: "list",
                member: {
                  shape: "S40"
                }
              },
              Marker: {}
            }
          }
        },
        DisassociateGlobalReplicationGroup: {
          input: {
            type: "structure",
            required: [
              "GlobalReplicationGroupId",
              "ReplicationGroupId",
              "ReplicationGroupRegion"
            ],
            members: {
              GlobalReplicationGroupId: {},
              ReplicationGroupId: {},
              ReplicationGroupRegion: {}
            }
          },
          output: {
            resultWrapper: "DisassociateGlobalReplicationGroupResult",
            type: "structure",
            members: {
              GlobalReplicationGroup: {
                shape: "S37"
              }
            }
          }
        },
        ExportServerlessCacheSnapshot: {
          input: {
            type: "structure",
            required: [
              "ServerlessCacheSnapshotName",
              "S3BucketName"
            ],
            members: {
              ServerlessCacheSnapshotName: {},
              S3BucketName: {}
            }
          },
          output: {
            resultWrapper: "ExportServerlessCacheSnapshotResult",
            type: "structure",
            members: {
              ServerlessCacheSnapshot: {
                shape: "S1u"
              }
            }
          }
        },
        FailoverGlobalReplicationGroup: {
          input: {
            type: "structure",
            required: [
              "GlobalReplicationGroupId",
              "PrimaryRegion",
              "PrimaryReplicationGroupId"
            ],
            members: {
              GlobalReplicationGroupId: {},
              PrimaryRegion: {},
              PrimaryReplicationGroupId: {}
            }
          },
          output: {
            resultWrapper: "FailoverGlobalReplicationGroupResult",
            type: "structure",
            members: {
              GlobalReplicationGroup: {
                shape: "S37"
              }
            }
          }
        },
        IncreaseNodeGroupsInGlobalReplicationGroup: {
          input: {
            type: "structure",
            required: [
              "GlobalReplicationGroupId",
              "NodeGroupCount",
              "ApplyImmediately"
            ],
            members: {
              GlobalReplicationGroupId: {},
              NodeGroupCount: {
                type: "integer"
              },
              RegionalConfigurations: {
                type: "list",
                member: {
                  locationName: "RegionalConfiguration",
                  type: "structure",
                  required: [
                    "ReplicationGroupId",
                    "ReplicationGroupRegion",
                    "ReshardingConfiguration"
                  ],
                  members: {
                    ReplicationGroupId: {},
                    ReplicationGroupRegion: {},
                    ReshardingConfiguration: {
                      shape: "S7s"
                    }
                  }
                }
              },
              ApplyImmediately: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "IncreaseNodeGroupsInGlobalReplicationGroupResult",
            type: "structure",
            members: {
              GlobalReplicationGroup: {
                shape: "S37"
              }
            }
          }
        },
        IncreaseReplicaCount: {
          input: {
            type: "structure",
            required: [
              "ReplicationGroupId",
              "ApplyImmediately"
            ],
            members: {
              ReplicationGroupId: {},
              NewReplicaCount: {
                type: "integer"
              },
              ReplicaConfiguration: {
                shape: "S4e"
              },
              ApplyImmediately: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "IncreaseReplicaCountResult",
            type: "structure",
            members: {
              ReplicationGroup: {
                shape: "So"
              }
            }
          }
        },
        ListAllowedNodeTypeModifications: {
          input: {
            type: "structure",
            members: {
              CacheClusterId: {},
              ReplicationGroupId: {}
            }
          },
          output: {
            resultWrapper: "ListAllowedNodeTypeModificationsResult",
            type: "structure",
            members: {
              ScaleUpModifications: {
                shape: "S7z"
              },
              ScaleDownModifications: {
                shape: "S7z"
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName"
            ],
            members: {
              ResourceName: {}
            }
          },
          output: {
            shape: "S5",
            resultWrapper: "ListTagsForResourceResult"
          }
        },
        ModifyCacheCluster: {
          input: {
            type: "structure",
            required: [
              "CacheClusterId"
            ],
            members: {
              CacheClusterId: {},
              NumCacheNodes: {
                type: "integer"
              },
              CacheNodeIdsToRemove: {
                shape: "S2i"
              },
              AZMode: {},
              NewAvailabilityZones: {
                shape: "S27"
              },
              CacheSecurityGroupNames: {
                shape: "S28"
              },
              SecurityGroupIds: {
                shape: "S29"
              },
              PreferredMaintenanceWindow: {},
              NotificationTopicArn: {},
              CacheParameterGroupName: {},
              NotificationTopicStatus: {},
              ApplyImmediately: {
                type: "boolean"
              },
              EngineVersion: {},
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              SnapshotRetentionLimit: {
                type: "integer"
              },
              SnapshotWindow: {},
              CacheNodeType: {},
              AuthToken: {},
              AuthTokenUpdateStrategy: {},
              LogDeliveryConfigurations: {
                shape: "S2d"
              },
              IpDiscovery: {}
            }
          },
          output: {
            resultWrapper: "ModifyCacheClusterResult",
            type: "structure",
            members: {
              CacheCluster: {
                shape: "S2g"
              }
            }
          }
        },
        ModifyCacheParameterGroup: {
          input: {
            type: "structure",
            required: [
              "CacheParameterGroupName",
              "ParameterNameValues"
            ],
            members: {
              CacheParameterGroupName: {},
              ParameterNameValues: {
                shape: "S85"
              }
            }
          },
          output: {
            shape: "S87",
            resultWrapper: "ModifyCacheParameterGroupResult"
          }
        },
        ModifyCacheSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "CacheSubnetGroupName"
            ],
            members: {
              CacheSubnetGroupName: {},
              CacheSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S2x"
              }
            }
          },
          output: {
            resultWrapper: "ModifyCacheSubnetGroupResult",
            type: "structure",
            members: {
              CacheSubnetGroup: {
                shape: "S2z"
              }
            }
          }
        },
        ModifyGlobalReplicationGroup: {
          input: {
            type: "structure",
            required: [
              "GlobalReplicationGroupId",
              "ApplyImmediately"
            ],
            members: {
              GlobalReplicationGroupId: {},
              ApplyImmediately: {
                type: "boolean"
              },
              CacheNodeType: {},
              EngineVersion: {},
              CacheParameterGroupName: {},
              GlobalReplicationGroupDescription: {},
              AutomaticFailoverEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyGlobalReplicationGroupResult",
            type: "structure",
            members: {
              GlobalReplicationGroup: {
                shape: "S37"
              }
            }
          }
        },
        ModifyReplicationGroup: {
          input: {
            type: "structure",
            required: [
              "ReplicationGroupId"
            ],
            members: {
              ReplicationGroupId: {},
              ReplicationGroupDescription: {},
              PrimaryClusterId: {},
              SnapshottingClusterId: {},
              AutomaticFailoverEnabled: {
                type: "boolean"
              },
              MultiAZEnabled: {
                type: "boolean"
              },
              NodeGroupId: {
                deprecated: true
              },
              CacheSecurityGroupNames: {
                shape: "S28"
              },
              SecurityGroupIds: {
                shape: "S29"
              },
              PreferredMaintenanceWindow: {},
              NotificationTopicArn: {},
              CacheParameterGroupName: {},
              NotificationTopicStatus: {},
              ApplyImmediately: {
                type: "boolean"
              },
              EngineVersion: {},
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              SnapshotRetentionLimit: {
                type: "integer"
              },
              SnapshotWindow: {},
              CacheNodeType: {},
              AuthToken: {},
              AuthTokenUpdateStrategy: {},
              UserGroupIdsToAdd: {
                shape: "Sx"
              },
              UserGroupIdsToRemove: {
                shape: "Sx"
              },
              RemoveUserGroups: {
                type: "boolean"
              },
              LogDeliveryConfigurations: {
                shape: "S2d"
              },
              IpDiscovery: {},
              TransitEncryptionEnabled: {
                type: "boolean"
              },
              TransitEncryptionMode: {},
              ClusterMode: {}
            }
          },
          output: {
            resultWrapper: "ModifyReplicationGroupResult",
            type: "structure",
            members: {
              ReplicationGroup: {
                shape: "So"
              }
            }
          }
        },
        ModifyReplicationGroupShardConfiguration: {
          input: {
            type: "structure",
            required: [
              "ReplicationGroupId",
              "NodeGroupCount",
              "ApplyImmediately"
            ],
            members: {
              ReplicationGroupId: {},
              NodeGroupCount: {
                type: "integer"
              },
              ApplyImmediately: {
                type: "boolean"
              },
              ReshardingConfiguration: {
                shape: "S7s"
              },
              NodeGroupsToRemove: {
                type: "list",
                member: {
                  locationName: "NodeGroupToRemove"
                }
              },
              NodeGroupsToRetain: {
                type: "list",
                member: {
                  locationName: "NodeGroupToRetain"
                }
              }
            }
          },
          output: {
            resultWrapper: "ModifyReplicationGroupShardConfigurationResult",
            type: "structure",
            members: {
              ReplicationGroup: {
                shape: "So"
              }
            }
          }
        },
        ModifyServerlessCache: {
          input: {
            type: "structure",
            required: [
              "ServerlessCacheName"
            ],
            members: {
              ServerlessCacheName: {},
              Description: {},
              CacheUsageLimits: {
                shape: "S3h"
              },
              RemoveUserGroup: {
                type: "boolean"
              },
              UserGroupId: {},
              SecurityGroupIds: {
                shape: "S29"
              },
              SnapshotRetentionLimit: {
                type: "integer"
              },
              DailySnapshotTime: {}
            }
          },
          output: {
            resultWrapper: "ModifyServerlessCacheResult",
            type: "structure",
            members: {
              ServerlessCache: {
                shape: "S3n"
              }
            }
          }
        },
        ModifyUser: {
          input: {
            type: "structure",
            required: [
              "UserId"
            ],
            members: {
              UserId: {},
              AccessString: {},
              AppendAccessString: {},
              Passwords: {
                shape: "S3w"
              },
              NoPasswordRequired: {
                type: "boolean"
              },
              AuthenticationMode: {
                shape: "S3y"
              }
            }
          },
          output: {
            shape: "S40",
            resultWrapper: "ModifyUserResult"
          }
        },
        ModifyUserGroup: {
          input: {
            type: "structure",
            required: [
              "UserGroupId"
            ],
            members: {
              UserGroupId: {},
              UserIdsToAdd: {
                shape: "S44"
              },
              UserIdsToRemove: {
                shape: "S44"
              }
            }
          },
          output: {
            shape: "S45",
            resultWrapper: "ModifyUserGroupResult"
          }
        },
        PurchaseReservedCacheNodesOffering: {
          input: {
            type: "structure",
            required: [
              "ReservedCacheNodesOfferingId"
            ],
            members: {
              ReservedCacheNodesOfferingId: {},
              ReservedCacheNodeId: {},
              CacheNodeCount: {
                type: "integer"
              },
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            resultWrapper: "PurchaseReservedCacheNodesOfferingResult",
            type: "structure",
            members: {
              ReservedCacheNode: {
                shape: "S65"
              }
            }
          }
        },
        RebalanceSlotsInGlobalReplicationGroup: {
          input: {
            type: "structure",
            required: [
              "GlobalReplicationGroupId",
              "ApplyImmediately"
            ],
            members: {
              GlobalReplicationGroupId: {},
              ApplyImmediately: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "RebalanceSlotsInGlobalReplicationGroupResult",
            type: "structure",
            members: {
              GlobalReplicationGroup: {
                shape: "S37"
              }
            }
          }
        },
        RebootCacheCluster: {
          input: {
            type: "structure",
            required: [
              "CacheClusterId",
              "CacheNodeIdsToReboot"
            ],
            members: {
              CacheClusterId: {},
              CacheNodeIdsToReboot: {
                shape: "S2i"
              }
            }
          },
          output: {
            resultWrapper: "RebootCacheClusterResult",
            type: "structure",
            members: {
              CacheCluster: {
                shape: "S2g"
              }
            }
          }
        },
        RemoveTagsFromResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "TagKeys"
            ],
            members: {
              ResourceName: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            shape: "S5",
            resultWrapper: "RemoveTagsFromResourceResult"
          }
        },
        ResetCacheParameterGroup: {
          input: {
            type: "structure",
            required: [
              "CacheParameterGroupName"
            ],
            members: {
              CacheParameterGroupName: {},
              ResetAllParameters: {
                type: "boolean"
              },
              ParameterNameValues: {
                shape: "S85"
              }
            }
          },
          output: {
            shape: "S87",
            resultWrapper: "ResetCacheParameterGroupResult"
          }
        },
        RevokeCacheSecurityGroupIngress: {
          input: {
            type: "structure",
            required: [
              "CacheSecurityGroupName",
              "EC2SecurityGroupName",
              "EC2SecurityGroupOwnerId"
            ],
            members: {
              CacheSecurityGroupName: {},
              EC2SecurityGroupName: {},
              EC2SecurityGroupOwnerId: {}
            }
          },
          output: {
            resultWrapper: "RevokeCacheSecurityGroupIngressResult",
            type: "structure",
            members: {
              CacheSecurityGroup: {
                shape: "S8"
              }
            }
          }
        },
        StartMigration: {
          input: {
            type: "structure",
            required: [
              "ReplicationGroupId",
              "CustomerNodeEndpointList"
            ],
            members: {
              ReplicationGroupId: {},
              CustomerNodeEndpointList: {
                shape: "S8y"
              }
            }
          },
          output: {
            resultWrapper: "StartMigrationResult",
            type: "structure",
            members: {
              ReplicationGroup: {
                shape: "So"
              }
            }
          }
        },
        TestFailover: {
          input: {
            type: "structure",
            required: [
              "ReplicationGroupId",
              "NodeGroupId"
            ],
            members: {
              ReplicationGroupId: {},
              NodeGroupId: {}
            }
          },
          output: {
            resultWrapper: "TestFailoverResult",
            type: "structure",
            members: {
              ReplicationGroup: {
                shape: "So"
              }
            }
          }
        },
        TestMigration: {
          input: {
            type: "structure",
            required: [
              "ReplicationGroupId",
              "CustomerNodeEndpointList"
            ],
            members: {
              ReplicationGroupId: {},
              CustomerNodeEndpointList: {
                shape: "S8y"
              }
            }
          },
          output: {
            resultWrapper: "TestMigrationResult",
            type: "structure",
            members: {
              ReplicationGroup: {
                shape: "So"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {
            locationName: "Tag",
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S5: {
          type: "structure",
          members: {
            TagList: {
              shape: "S3"
            }
          }
        },
        S8: {
          type: "structure",
          members: {
            OwnerId: {},
            CacheSecurityGroupName: {},
            Description: {},
            EC2SecurityGroups: {
              type: "list",
              member: {
                locationName: "EC2SecurityGroup",
                type: "structure",
                members: {
                  Status: {},
                  EC2SecurityGroupName: {},
                  EC2SecurityGroupOwnerId: {}
                }
              }
            },
            ARN: {}
          },
          wrapper: true
        },
        Sc: {
          type: "list",
          member: {}
        },
        Sd: {
          type: "list",
          member: {}
        },
        Se: {
          type: "structure",
          members: {
            ProcessedUpdateActions: {
              type: "list",
              member: {
                locationName: "ProcessedUpdateAction",
                type: "structure",
                members: {
                  ReplicationGroupId: {},
                  CacheClusterId: {},
                  ServiceUpdateName: {},
                  UpdateActionStatus: {}
                }
              }
            },
            UnprocessedUpdateActions: {
              type: "list",
              member: {
                locationName: "UnprocessedUpdateAction",
                type: "structure",
                members: {
                  ReplicationGroupId: {},
                  CacheClusterId: {},
                  ServiceUpdateName: {},
                  ErrorType: {},
                  ErrorMessage: {}
                }
              }
            }
          }
        },
        So: {
          type: "structure",
          members: {
            ReplicationGroupId: {},
            Description: {},
            GlobalReplicationGroupInfo: {
              type: "structure",
              members: {
                GlobalReplicationGroupId: {},
                GlobalReplicationGroupMemberRole: {}
              }
            },
            Status: {},
            PendingModifiedValues: {
              type: "structure",
              members: {
                PrimaryClusterId: {},
                AutomaticFailoverStatus: {},
                Resharding: {
                  type: "structure",
                  members: {
                    SlotMigration: {
                      type: "structure",
                      members: {
                        ProgressPercentage: {
                          type: "double"
                        }
                      }
                    }
                  }
                },
                AuthTokenStatus: {},
                UserGroups: {
                  type: "structure",
                  members: {
                    UserGroupIdsToAdd: {
                      shape: "Sx"
                    },
                    UserGroupIdsToRemove: {
                      shape: "Sx"
                    }
                  }
                },
                LogDeliveryConfigurations: {
                  shape: "Sz"
                },
                TransitEncryptionEnabled: {
                  type: "boolean"
                },
                TransitEncryptionMode: {},
                ClusterMode: {}
              }
            },
            MemberClusters: {
              type: "list",
              member: {
                locationName: "ClusterId"
              }
            },
            NodeGroups: {
              type: "list",
              member: {
                locationName: "NodeGroup",
                type: "structure",
                members: {
                  NodeGroupId: {},
                  Status: {},
                  PrimaryEndpoint: {
                    shape: "S1d"
                  },
                  ReaderEndpoint: {
                    shape: "S1d"
                  },
                  Slots: {},
                  NodeGroupMembers: {
                    type: "list",
                    member: {
                      locationName: "NodeGroupMember",
                      type: "structure",
                      members: {
                        CacheClusterId: {},
                        CacheNodeId: {},
                        ReadEndpoint: {
                          shape: "S1d"
                        },
                        PreferredAvailabilityZone: {},
                        PreferredOutpostArn: {},
                        CurrentRole: {}
                      }
                    }
                  }
                }
              }
            },
            SnapshottingClusterId: {},
            AutomaticFailover: {},
            MultiAZ: {},
            ConfigurationEndpoint: {
              shape: "S1d"
            },
            SnapshotRetentionLimit: {
              type: "integer"
            },
            SnapshotWindow: {},
            ClusterEnabled: {
              type: "boolean"
            },
            CacheNodeType: {},
            AuthTokenEnabled: {
              type: "boolean"
            },
            AuthTokenLastModifiedDate: {
              type: "timestamp"
            },
            TransitEncryptionEnabled: {
              type: "boolean"
            },
            AtRestEncryptionEnabled: {
              type: "boolean"
            },
            MemberClustersOutpostArns: {
              type: "list",
              member: {
                locationName: "ReplicationGroupOutpostArn"
              }
            },
            KmsKeyId: {},
            ARN: {},
            UserGroupIds: {
              shape: "Sx"
            },
            LogDeliveryConfigurations: {
              shape: "S1m"
            },
            ReplicationGroupCreateTime: {
              type: "timestamp"
            },
            DataTiering: {},
            AutoMinorVersionUpgrade: {
              type: "boolean"
            },
            NetworkType: {},
            IpDiscovery: {},
            TransitEncryptionMode: {},
            ClusterMode: {}
          },
          wrapper: true
        },
        Sx: {
          type: "list",
          member: {}
        },
        Sz: {
          type: "list",
          member: {
            type: "structure",
            members: {
              LogType: {},
              DestinationType: {},
              DestinationDetails: {
                shape: "S13"
              },
              LogFormat: {}
            }
          },
          locationName: "PendingLogDeliveryConfiguration"
        },
        S13: {
          type: "structure",
          members: {
            CloudWatchLogsDetails: {
              type: "structure",
              members: {
                LogGroup: {}
              }
            },
            KinesisFirehoseDetails: {
              type: "structure",
              members: {
                DeliveryStream: {}
              }
            }
          }
        },
        S1d: {
          type: "structure",
          members: {
            Address: {},
            Port: {
              type: "integer"
            }
          }
        },
        S1m: {
          type: "list",
          member: {
            locationName: "LogDeliveryConfiguration",
            type: "structure",
            members: {
              LogType: {},
              DestinationType: {},
              DestinationDetails: {
                shape: "S13"
              },
              LogFormat: {},
              Status: {},
              Message: {}
            }
          }
        },
        S1u: {
          type: "structure",
          members: {
            ServerlessCacheSnapshotName: {},
            ARN: {},
            KmsKeyId: {},
            SnapshotType: {},
            Status: {},
            CreateTime: {
              type: "timestamp"
            },
            ExpiryTime: {
              type: "timestamp"
            },
            BytesUsedForCache: {},
            ServerlessCacheConfiguration: {
              type: "structure",
              members: {
                ServerlessCacheName: {},
                Engine: {},
                MajorEngineVersion: {}
              }
            }
          }
        },
        S1y: {
          type: "structure",
          members: {
            SnapshotName: {},
            ReplicationGroupId: {},
            ReplicationGroupDescription: {},
            CacheClusterId: {},
            SnapshotStatus: {},
            SnapshotSource: {},
            CacheNodeType: {},
            Engine: {},
            EngineVersion: {},
            NumCacheNodes: {
              type: "integer"
            },
            PreferredAvailabilityZone: {},
            PreferredOutpostArn: {},
            CacheClusterCreateTime: {
              type: "timestamp"
            },
            PreferredMaintenanceWindow: {},
            TopicArn: {},
            Port: {
              type: "integer"
            },
            CacheParameterGroupName: {},
            CacheSubnetGroupName: {},
            VpcId: {},
            AutoMinorVersionUpgrade: {
              type: "boolean"
            },
            SnapshotRetentionLimit: {
              type: "integer"
            },
            SnapshotWindow: {},
            NumNodeGroups: {
              type: "integer"
            },
            AutomaticFailover: {},
            NodeSnapshots: {
              type: "list",
              member: {
                locationName: "NodeSnapshot",
                type: "structure",
                members: {
                  CacheClusterId: {},
                  NodeGroupId: {},
                  CacheNodeId: {},
                  NodeGroupConfiguration: {
                    shape: "S21"
                  },
                  CacheSize: {},
                  CacheNodeCreateTime: {
                    type: "timestamp"
                  },
                  SnapshotCreateTime: {
                    type: "timestamp"
                  }
                },
                wrapper: true
              }
            },
            KmsKeyId: {},
            ARN: {},
            DataTiering: {}
          },
          wrapper: true
        },
        S21: {
          type: "structure",
          members: {
            NodeGroupId: {},
            Slots: {},
            ReplicaCount: {
              type: "integer"
            },
            PrimaryAvailabilityZone: {},
            ReplicaAvailabilityZones: {
              shape: "S23"
            },
            PrimaryOutpostArn: {},
            ReplicaOutpostArns: {
              type: "list",
              member: {
                locationName: "OutpostArn"
              }
            }
          }
        },
        S23: {
          type: "list",
          member: {
            locationName: "AvailabilityZone"
          }
        },
        S27: {
          type: "list",
          member: {
            locationName: "PreferredAvailabilityZone"
          }
        },
        S28: {
          type: "list",
          member: {
            locationName: "CacheSecurityGroupName"
          }
        },
        S29: {
          type: "list",
          member: {
            locationName: "SecurityGroupId"
          }
        },
        S2a: {
          type: "list",
          member: {
            locationName: "SnapshotArn"
          }
        },
        S2c: {
          type: "list",
          member: {
            locationName: "PreferredOutpostArn"
          }
        },
        S2d: {
          type: "list",
          member: {
            locationName: "LogDeliveryConfigurationRequest",
            type: "structure",
            members: {
              LogType: {},
              DestinationType: {},
              DestinationDetails: {
                shape: "S13"
              },
              LogFormat: {},
              Enabled: {
                type: "boolean"
              }
            }
          }
        },
        S2g: {
          type: "structure",
          members: {
            CacheClusterId: {},
            ConfigurationEndpoint: {
              shape: "S1d"
            },
            ClientDownloadLandingPage: {},
            CacheNodeType: {},
            Engine: {},
            EngineVersion: {},
            CacheClusterStatus: {},
            NumCacheNodes: {
              type: "integer"
            },
            PreferredAvailabilityZone: {},
            PreferredOutpostArn: {},
            CacheClusterCreateTime: {
              type: "timestamp"
            },
            PreferredMaintenanceWindow: {},
            PendingModifiedValues: {
              type: "structure",
              members: {
                NumCacheNodes: {
                  type: "integer"
                },
                CacheNodeIdsToRemove: {
                  shape: "S2i"
                },
                EngineVersion: {},
                CacheNodeType: {},
                AuthTokenStatus: {},
                LogDeliveryConfigurations: {
                  shape: "Sz"
                },
                TransitEncryptionEnabled: {
                  type: "boolean"
                },
                TransitEncryptionMode: {}
              }
            },
            NotificationConfiguration: {
              type: "structure",
              members: {
                TopicArn: {},
                TopicStatus: {}
              }
            },
            CacheSecurityGroups: {
              type: "list",
              member: {
                locationName: "CacheSecurityGroup",
                type: "structure",
                members: {
                  CacheSecurityGroupName: {},
                  Status: {}
                }
              }
            },
            CacheParameterGroup: {
              type: "structure",
              members: {
                CacheParameterGroupName: {},
                ParameterApplyStatus: {},
                CacheNodeIdsToReboot: {
                  shape: "S2i"
                }
              }
            },
            CacheSubnetGroupName: {},
            CacheNodes: {
              type: "list",
              member: {
                locationName: "CacheNode",
                type: "structure",
                members: {
                  CacheNodeId: {},
                  CacheNodeStatus: {},
                  CacheNodeCreateTime: {
                    type: "timestamp"
                  },
                  Endpoint: {
                    shape: "S1d"
                  },
                  ParameterGroupStatus: {},
                  SourceCacheNodeId: {},
                  CustomerAvailabilityZone: {},
                  CustomerOutpostArn: {}
                }
              }
            },
            AutoMinorVersionUpgrade: {
              type: "boolean"
            },
            SecurityGroups: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  SecurityGroupId: {},
                  Status: {}
                }
              }
            },
            ReplicationGroupId: {},
            SnapshotRetentionLimit: {
              type: "integer"
            },
            SnapshotWindow: {},
            AuthTokenEnabled: {
              type: "boolean"
            },
            AuthTokenLastModifiedDate: {
              type: "timestamp"
            },
            TransitEncryptionEnabled: {
              type: "boolean"
            },
            AtRestEncryptionEnabled: {
              type: "boolean"
            },
            ARN: {},
            ReplicationGroupLogDeliveryEnabled: {
              type: "boolean"
            },
            LogDeliveryConfigurations: {
              shape: "S1m"
            },
            NetworkType: {},
            IpDiscovery: {},
            TransitEncryptionMode: {}
          },
          wrapper: true
        },
        S2i: {
          type: "list",
          member: {
            locationName: "CacheNodeId"
          }
        },
        S2t: {
          type: "structure",
          members: {
            CacheParameterGroupName: {},
            CacheParameterGroupFamily: {},
            Description: {},
            IsGlobal: {
              type: "boolean"
            },
            ARN: {}
          },
          wrapper: true
        },
        S2x: {
          type: "list",
          member: {
            locationName: "SubnetIdentifier"
          }
        },
        S2z: {
          type: "structure",
          members: {
            CacheSubnetGroupName: {},
            CacheSubnetGroupDescription: {},
            VpcId: {},
            Subnets: {
              type: "list",
              member: {
                locationName: "Subnet",
                type: "structure",
                members: {
                  SubnetIdentifier: {},
                  SubnetAvailabilityZone: {
                    type: "structure",
                    members: {
                      Name: {}
                    },
                    wrapper: true
                  },
                  SubnetOutpost: {
                    type: "structure",
                    members: {
                      SubnetOutpostArn: {}
                    }
                  },
                  SupportedNetworkTypes: {
                    shape: "S34"
                  }
                }
              }
            },
            ARN: {},
            SupportedNetworkTypes: {
              shape: "S34"
            }
          },
          wrapper: true
        },
        S34: {
          type: "list",
          member: {}
        },
        S37: {
          type: "structure",
          members: {
            GlobalReplicationGroupId: {},
            GlobalReplicationGroupDescription: {},
            Status: {},
            CacheNodeType: {},
            Engine: {},
            EngineVersion: {},
            Members: {
              type: "list",
              member: {
                locationName: "GlobalReplicationGroupMember",
                type: "structure",
                members: {
                  ReplicationGroupId: {},
                  ReplicationGroupRegion: {},
                  Role: {},
                  AutomaticFailover: {},
                  Status: {}
                },
                wrapper: true
              }
            },
            ClusterEnabled: {
              type: "boolean"
            },
            GlobalNodeGroups: {
              type: "list",
              member: {
                locationName: "GlobalNodeGroup",
                type: "structure",
                members: {
                  GlobalNodeGroupId: {},
                  Slots: {}
                }
              }
            },
            AuthTokenEnabled: {
              type: "boolean"
            },
            TransitEncryptionEnabled: {
              type: "boolean"
            },
            AtRestEncryptionEnabled: {
              type: "boolean"
            },
            ARN: {}
          },
          wrapper: true
        },
        S3h: {
          type: "structure",
          members: {
            DataStorage: {
              type: "structure",
              required: [
                "Maximum",
                "Unit"
              ],
              members: {
                Maximum: {
                  type: "integer"
                },
                Unit: {}
              }
            },
            ECPUPerSecond: {
              type: "structure",
              required: [
                "Maximum"
              ],
              members: {
                Maximum: {
                  type: "integer"
                }
              }
            }
          }
        },
        S3l: {
          type: "list",
          member: {
            locationName: "SubnetId"
          }
        },
        S3n: {
          type: "structure",
          members: {
            ServerlessCacheName: {},
            Description: {},
            CreateTime: {
              type: "timestamp"
            },
            Status: {},
            Engine: {},
            MajorEngineVersion: {},
            FullEngineVersion: {},
            CacheUsageLimits: {
              shape: "S3h"
            },
            KmsKeyId: {},
            SecurityGroupIds: {
              shape: "S29"
            },
            Endpoint: {
              shape: "S1d"
            },
            ReaderEndpoint: {
              shape: "S1d"
            },
            ARN: {},
            UserGroupId: {},
            SubnetIds: {
              shape: "S3l"
            },
            SnapshotRetentionLimit: {
              type: "integer"
            },
            DailySnapshotTime: {}
          }
        },
        S3w: {
          type: "list",
          member: {}
        },
        S3y: {
          type: "structure",
          members: {
            Type: {},
            Passwords: {
              shape: "S3w"
            }
          }
        },
        S40: {
          type: "structure",
          members: {
            UserId: {},
            UserName: {},
            Status: {},
            Engine: {},
            MinimumEngineVersion: {},
            AccessString: {},
            UserGroupIds: {
              shape: "Sx"
            },
            Authentication: {
              type: "structure",
              members: {
                Type: {},
                PasswordCount: {
                  type: "integer"
                }
              }
            },
            ARN: {}
          }
        },
        S44: {
          type: "list",
          member: {}
        },
        S45: {
          type: "structure",
          members: {
            UserGroupId: {},
            Status: {},
            Engine: {},
            UserIds: {
              shape: "S46"
            },
            MinimumEngineVersion: {},
            PendingChanges: {
              type: "structure",
              members: {
                UserIdsToRemove: {
                  shape: "S46"
                },
                UserIdsToAdd: {
                  shape: "S46"
                }
              }
            },
            ReplicationGroups: {
              type: "list",
              member: {}
            },
            ServerlessCaches: {
              type: "list",
              member: {}
            },
            ARN: {}
          }
        },
        S46: {
          type: "list",
          member: {}
        },
        S4b: {
          type: "list",
          member: {
            locationName: "GlobalNodeGroupId"
          }
        },
        S4e: {
          type: "list",
          member: {
            locationName: "ConfigureShard",
            type: "structure",
            required: [
              "NodeGroupId",
              "NewReplicaCount"
            ],
            members: {
              NodeGroupId: {},
              NewReplicaCount: {
                type: "integer"
              },
              PreferredAvailabilityZones: {
                shape: "S27"
              },
              PreferredOutpostArns: {
                shape: "S2c"
              }
            }
          }
        },
        S5b: {
          type: "list",
          member: {
            locationName: "Parameter",
            type: "structure",
            members: {
              ParameterName: {},
              ParameterValue: {},
              Description: {},
              Source: {},
              DataType: {},
              AllowedValues: {},
              IsModifiable: {
                type: "boolean"
              },
              MinimumEngineVersion: {},
              ChangeType: {}
            }
          }
        },
        S5e: {
          type: "list",
          member: {
            locationName: "CacheNodeTypeSpecificParameter",
            type: "structure",
            members: {
              ParameterName: {},
              Description: {},
              Source: {},
              DataType: {},
              AllowedValues: {},
              IsModifiable: {
                type: "boolean"
              },
              MinimumEngineVersion: {},
              CacheNodeTypeSpecificValues: {
                type: "list",
                member: {
                  locationName: "CacheNodeTypeSpecificValue",
                  type: "structure",
                  members: {
                    CacheNodeType: {},
                    Value: {}
                  }
                }
              },
              ChangeType: {}
            }
          }
        },
        S65: {
          type: "structure",
          members: {
            ReservedCacheNodeId: {},
            ReservedCacheNodesOfferingId: {},
            CacheNodeType: {},
            StartTime: {
              type: "timestamp"
            },
            Duration: {
              type: "integer"
            },
            FixedPrice: {
              type: "double"
            },
            UsagePrice: {
              type: "double"
            },
            CacheNodeCount: {
              type: "integer"
            },
            ProductDescription: {},
            OfferingType: {},
            State: {},
            RecurringCharges: {
              shape: "S66"
            },
            ReservationARN: {}
          },
          wrapper: true
        },
        S66: {
          type: "list",
          member: {
            locationName: "RecurringCharge",
            type: "structure",
            members: {
              RecurringChargeAmount: {
                type: "double"
              },
              RecurringChargeFrequency: {}
            },
            wrapper: true
          }
        },
        S6j: {
          type: "list",
          member: {}
        },
        S7s: {
          type: "list",
          member: {
            locationName: "ReshardingConfiguration",
            type: "structure",
            members: {
              NodeGroupId: {},
              PreferredAvailabilityZones: {
                shape: "S23"
              }
            }
          }
        },
        S7z: {
          type: "list",
          member: {}
        },
        S85: {
          type: "list",
          member: {
            locationName: "ParameterNameValue",
            type: "structure",
            members: {
              ParameterName: {},
              ParameterValue: {}
            }
          }
        },
        S87: {
          type: "structure",
          members: {
            CacheParameterGroupName: {}
          }
        },
        S8y: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Address: {},
              Port: {
                type: "integer"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/elasticache-2015-02-02.paginators.json
var require_elasticache_2015_02_02_paginators = __commonJS({
  "node_modules/aws-sdk/apis/elasticache-2015-02-02.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeCacheClusters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "CacheClusters"
        },
        DescribeCacheEngineVersions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "CacheEngineVersions"
        },
        DescribeCacheParameterGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "CacheParameterGroups"
        },
        DescribeCacheParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Parameters"
        },
        DescribeCacheSecurityGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "CacheSecurityGroups"
        },
        DescribeCacheSubnetGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "CacheSubnetGroups"
        },
        DescribeEngineDefaultParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "EngineDefaults.Marker",
          result_key: "EngineDefaults.Parameters"
        },
        DescribeEvents: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Events"
        },
        DescribeGlobalReplicationGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "GlobalReplicationGroups"
        },
        DescribeReplicationGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ReplicationGroups"
        },
        DescribeReservedCacheNodes: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ReservedCacheNodes"
        },
        DescribeReservedCacheNodesOfferings: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ReservedCacheNodesOfferings"
        },
        DescribeServerlessCacheSnapshots: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ServerlessCacheSnapshots"
        },
        DescribeServerlessCaches: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ServerlessCaches"
        },
        DescribeServiceUpdates: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ServiceUpdates"
        },
        DescribeSnapshots: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Snapshots"
        },
        DescribeUpdateActions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "UpdateActions"
        },
        DescribeUserGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "UserGroups"
        },
        DescribeUsers: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Users"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/elasticache-2015-02-02.waiters2.json
var require_elasticache_2015_02_02_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/elasticache-2015-02-02.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        CacheClusterAvailable: {
          acceptors: [
            {
              argument: "CacheClusters[].CacheClusterStatus",
              expected: "available",
              matcher: "pathAll",
              state: "success"
            },
            {
              argument: "CacheClusters[].CacheClusterStatus",
              expected: "deleted",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "CacheClusters[].CacheClusterStatus",
              expected: "deleting",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "CacheClusters[].CacheClusterStatus",
              expected: "incompatible-network",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "CacheClusters[].CacheClusterStatus",
              expected: "restore-failed",
              matcher: "pathAny",
              state: "failure"
            }
          ],
          delay: 15,
          description: "Wait until ElastiCache cluster is available.",
          maxAttempts: 40,
          operation: "DescribeCacheClusters"
        },
        CacheClusterDeleted: {
          acceptors: [
            {
              argument: "CacheClusters[].CacheClusterStatus",
              expected: "deleted",
              matcher: "pathAll",
              state: "success"
            },
            {
              expected: "CacheClusterNotFound",
              matcher: "error",
              state: "success"
            },
            {
              argument: "CacheClusters[].CacheClusterStatus",
              expected: "available",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "CacheClusters[].CacheClusterStatus",
              expected: "creating",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "CacheClusters[].CacheClusterStatus",
              expected: "incompatible-network",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "CacheClusters[].CacheClusterStatus",
              expected: "modifying",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "CacheClusters[].CacheClusterStatus",
              expected: "restore-failed",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "CacheClusters[].CacheClusterStatus",
              expected: "snapshotting",
              matcher: "pathAny",
              state: "failure"
            }
          ],
          delay: 15,
          description: "Wait until ElastiCache cluster is deleted.",
          maxAttempts: 40,
          operation: "DescribeCacheClusters"
        },
        ReplicationGroupAvailable: {
          acceptors: [
            {
              argument: "ReplicationGroups[].Status",
              expected: "available",
              matcher: "pathAll",
              state: "success"
            },
            {
              argument: "ReplicationGroups[].Status",
              expected: "deleted",
              matcher: "pathAny",
              state: "failure"
            }
          ],
          delay: 15,
          description: "Wait until ElastiCache replication group is available.",
          maxAttempts: 40,
          operation: "DescribeReplicationGroups"
        },
        ReplicationGroupDeleted: {
          acceptors: [
            {
              argument: "ReplicationGroups[].Status",
              expected: "deleted",
              matcher: "pathAll",
              state: "success"
            },
            {
              argument: "ReplicationGroups[].Status",
              expected: "available",
              matcher: "pathAny",
              state: "failure"
            },
            {
              expected: "ReplicationGroupNotFoundFault",
              matcher: "error",
              state: "success"
            }
          ],
          delay: 15,
          description: "Wait until ElastiCache replication group is deleted.",
          maxAttempts: 40,
          operation: "DescribeReplicationGroups"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/elasticache.js
var require_elasticache = __commonJS({
  "node_modules/aws-sdk/clients/elasticache.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["elasticache"] = {};
    AWS2.ElastiCache = Service.defineService("elasticache", ["2012-11-15*", "2014-03-24*", "2014-07-15*", "2014-09-30*", "2015-02-02"]);
    Object.defineProperty(apiLoader.services["elasticache"], "2015-02-02", {
      get: function get() {
        var model = require_elasticache_2015_02_02_min();
        model.paginators = require_elasticache_2015_02_02_paginators().pagination;
        model.waiters = require_elasticache_2015_02_02_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ElastiCache;
  }
});

// node_modules/aws-sdk/apis/elasticbeanstalk-2010-12-01.min.json
var require_elasticbeanstalk_2010_12_01_min = __commonJS({
  "node_modules/aws-sdk/apis/elasticbeanstalk-2010-12-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2010-12-01",
        endpointPrefix: "elasticbeanstalk",
        protocol: "query",
        serviceAbbreviation: "Elastic Beanstalk",
        serviceFullName: "AWS Elastic Beanstalk",
        serviceId: "Elastic Beanstalk",
        signatureVersion: "v4",
        uid: "elasticbeanstalk-2010-12-01",
        xmlNamespace: "http://elasticbeanstalk.amazonaws.com/docs/2010-12-01/"
      },
      operations: {
        AbortEnvironmentUpdate: {
          input: {
            type: "structure",
            members: {
              EnvironmentId: {},
              EnvironmentName: {}
            }
          }
        },
        ApplyEnvironmentManagedAction: {
          input: {
            type: "structure",
            required: [
              "ActionId"
            ],
            members: {
              EnvironmentName: {},
              EnvironmentId: {},
              ActionId: {}
            }
          },
          output: {
            resultWrapper: "ApplyEnvironmentManagedActionResult",
            type: "structure",
            members: {
              ActionId: {},
              ActionDescription: {},
              ActionType: {},
              Status: {}
            }
          }
        },
        AssociateEnvironmentOperationsRole: {
          input: {
            type: "structure",
            required: [
              "EnvironmentName",
              "OperationsRole"
            ],
            members: {
              EnvironmentName: {},
              OperationsRole: {}
            }
          }
        },
        CheckDNSAvailability: {
          input: {
            type: "structure",
            required: [
              "CNAMEPrefix"
            ],
            members: {
              CNAMEPrefix: {}
            }
          },
          output: {
            resultWrapper: "CheckDNSAvailabilityResult",
            type: "structure",
            members: {
              Available: {
                type: "boolean"
              },
              FullyQualifiedCNAME: {}
            }
          }
        },
        ComposeEnvironments: {
          input: {
            type: "structure",
            members: {
              ApplicationName: {},
              GroupName: {},
              VersionLabels: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            shape: "Sk",
            resultWrapper: "ComposeEnvironmentsResult"
          }
        },
        CreateApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName"
            ],
            members: {
              ApplicationName: {},
              Description: {},
              ResourceLifecycleConfig: {
                shape: "S19"
              },
              Tags: {
                shape: "S1f"
              }
            }
          },
          output: {
            shape: "S1j",
            resultWrapper: "CreateApplicationResult"
          }
        },
        CreateApplicationVersion: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "VersionLabel"
            ],
            members: {
              ApplicationName: {},
              VersionLabel: {},
              Description: {},
              SourceBuildInformation: {
                shape: "S1p"
              },
              SourceBundle: {
                shape: "S1t"
              },
              BuildConfiguration: {
                type: "structure",
                required: [
                  "CodeBuildServiceRole",
                  "Image"
                ],
                members: {
                  ArtifactName: {},
                  CodeBuildServiceRole: {},
                  ComputeType: {},
                  Image: {},
                  TimeoutInMinutes: {
                    type: "integer"
                  }
                }
              },
              AutoCreateApplication: {
                type: "boolean"
              },
              Process: {
                type: "boolean"
              },
              Tags: {
                shape: "S1f"
              }
            }
          },
          output: {
            shape: "S21",
            resultWrapper: "CreateApplicationVersionResult"
          }
        },
        CreateConfigurationTemplate: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "TemplateName"
            ],
            members: {
              ApplicationName: {},
              TemplateName: {},
              SolutionStackName: {},
              PlatformArn: {},
              SourceConfiguration: {
                type: "structure",
                members: {
                  ApplicationName: {},
                  TemplateName: {}
                }
              },
              EnvironmentId: {},
              Description: {},
              OptionSettings: {
                shape: "S27"
              },
              Tags: {
                shape: "S1f"
              }
            }
          },
          output: {
            shape: "S2d",
            resultWrapper: "CreateConfigurationTemplateResult"
          }
        },
        CreateEnvironment: {
          input: {
            type: "structure",
            required: [
              "ApplicationName"
            ],
            members: {
              ApplicationName: {},
              EnvironmentName: {},
              GroupName: {},
              Description: {},
              CNAMEPrefix: {},
              Tier: {
                shape: "S13"
              },
              Tags: {
                shape: "S1f"
              },
              VersionLabel: {},
              TemplateName: {},
              SolutionStackName: {},
              PlatformArn: {},
              OptionSettings: {
                shape: "S27"
              },
              OptionsToRemove: {
                shape: "S2g"
              },
              OperationsRole: {}
            }
          },
          output: {
            shape: "Sm",
            resultWrapper: "CreateEnvironmentResult"
          }
        },
        CreatePlatformVersion: {
          input: {
            type: "structure",
            required: [
              "PlatformName",
              "PlatformVersion",
              "PlatformDefinitionBundle"
            ],
            members: {
              PlatformName: {},
              PlatformVersion: {},
              PlatformDefinitionBundle: {
                shape: "S1t"
              },
              EnvironmentName: {},
              OptionSettings: {
                shape: "S27"
              },
              Tags: {
                shape: "S1f"
              }
            }
          },
          output: {
            resultWrapper: "CreatePlatformVersionResult",
            type: "structure",
            members: {
              PlatformSummary: {
                shape: "S2m"
              },
              Builder: {
                type: "structure",
                members: {
                  ARN: {}
                }
              }
            }
          }
        },
        CreateStorageLocation: {
          output: {
            resultWrapper: "CreateStorageLocationResult",
            type: "structure",
            members: {
              S3Bucket: {}
            }
          }
        },
        DeleteApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName"
            ],
            members: {
              ApplicationName: {},
              TerminateEnvByForce: {
                type: "boolean"
              }
            }
          }
        },
        DeleteApplicationVersion: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "VersionLabel"
            ],
            members: {
              ApplicationName: {},
              VersionLabel: {},
              DeleteSourceBundle: {
                type: "boolean"
              }
            }
          }
        },
        DeleteConfigurationTemplate: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "TemplateName"
            ],
            members: {
              ApplicationName: {},
              TemplateName: {}
            }
          }
        },
        DeleteEnvironmentConfiguration: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "EnvironmentName"
            ],
            members: {
              ApplicationName: {},
              EnvironmentName: {}
            }
          }
        },
        DeletePlatformVersion: {
          input: {
            type: "structure",
            members: {
              PlatformArn: {}
            }
          },
          output: {
            resultWrapper: "DeletePlatformVersionResult",
            type: "structure",
            members: {
              PlatformSummary: {
                shape: "S2m"
              }
            }
          }
        },
        DescribeAccountAttributes: {
          output: {
            resultWrapper: "DescribeAccountAttributesResult",
            type: "structure",
            members: {
              ResourceQuotas: {
                type: "structure",
                members: {
                  ApplicationQuota: {
                    shape: "S3c"
                  },
                  ApplicationVersionQuota: {
                    shape: "S3c"
                  },
                  EnvironmentQuota: {
                    shape: "S3c"
                  },
                  ConfigurationTemplateQuota: {
                    shape: "S3c"
                  },
                  CustomPlatformQuota: {
                    shape: "S3c"
                  }
                }
              }
            }
          }
        },
        DescribeApplicationVersions: {
          input: {
            type: "structure",
            members: {
              ApplicationName: {},
              VersionLabels: {
                shape: "S1m"
              },
              MaxRecords: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "DescribeApplicationVersionsResult",
            type: "structure",
            members: {
              ApplicationVersions: {
                type: "list",
                member: {
                  shape: "S22"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeApplications: {
          input: {
            type: "structure",
            members: {
              ApplicationNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "DescribeApplicationsResult",
            type: "structure",
            members: {
              Applications: {
                type: "list",
                member: {
                  shape: "S1k"
                }
              }
            }
          }
        },
        DescribeConfigurationOptions: {
          input: {
            type: "structure",
            members: {
              ApplicationName: {},
              TemplateName: {},
              EnvironmentName: {},
              SolutionStackName: {},
              PlatformArn: {},
              Options: {
                shape: "S2g"
              }
            }
          },
          output: {
            resultWrapper: "DescribeConfigurationOptionsResult",
            type: "structure",
            members: {
              SolutionStackName: {},
              PlatformArn: {},
              Options: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Namespace: {},
                    Name: {},
                    DefaultValue: {},
                    ChangeSeverity: {},
                    UserDefined: {
                      type: "boolean"
                    },
                    ValueType: {},
                    ValueOptions: {
                      type: "list",
                      member: {}
                    },
                    MinValue: {
                      type: "integer"
                    },
                    MaxValue: {
                      type: "integer"
                    },
                    MaxLength: {
                      type: "integer"
                    },
                    Regex: {
                      type: "structure",
                      members: {
                        Pattern: {},
                        Label: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeConfigurationSettings: {
          input: {
            type: "structure",
            required: [
              "ApplicationName"
            ],
            members: {
              ApplicationName: {},
              TemplateName: {},
              EnvironmentName: {}
            }
          },
          output: {
            resultWrapper: "DescribeConfigurationSettingsResult",
            type: "structure",
            members: {
              ConfigurationSettings: {
                type: "list",
                member: {
                  shape: "S2d"
                }
              }
            }
          }
        },
        DescribeEnvironmentHealth: {
          input: {
            type: "structure",
            members: {
              EnvironmentName: {},
              EnvironmentId: {},
              AttributeNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "DescribeEnvironmentHealthResult",
            type: "structure",
            members: {
              EnvironmentName: {},
              HealthStatus: {},
              Status: {},
              Color: {},
              Causes: {
                shape: "S48"
              },
              ApplicationMetrics: {
                shape: "S4a"
              },
              InstancesHealth: {
                type: "structure",
                members: {
                  NoData: {
                    type: "integer"
                  },
                  Unknown: {
                    type: "integer"
                  },
                  Pending: {
                    type: "integer"
                  },
                  Ok: {
                    type: "integer"
                  },
                  Info: {
                    type: "integer"
                  },
                  Warning: {
                    type: "integer"
                  },
                  Degraded: {
                    type: "integer"
                  },
                  Severe: {
                    type: "integer"
                  }
                }
              },
              RefreshedAt: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeEnvironmentManagedActionHistory: {
          input: {
            type: "structure",
            members: {
              EnvironmentId: {},
              EnvironmentName: {},
              NextToken: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeEnvironmentManagedActionHistoryResult",
            type: "structure",
            members: {
              ManagedActionHistoryItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ActionId: {},
                    ActionType: {},
                    ActionDescription: {},
                    FailureType: {},
                    Status: {},
                    FailureDescription: {},
                    ExecutedTime: {
                      type: "timestamp"
                    },
                    FinishedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeEnvironmentManagedActions: {
          input: {
            type: "structure",
            members: {
              EnvironmentName: {},
              EnvironmentId: {},
              Status: {}
            }
          },
          output: {
            resultWrapper: "DescribeEnvironmentManagedActionsResult",
            type: "structure",
            members: {
              ManagedActions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ActionId: {},
                    ActionDescription: {},
                    ActionType: {},
                    Status: {},
                    WindowStartTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeEnvironmentResources: {
          input: {
            type: "structure",
            members: {
              EnvironmentId: {},
              EnvironmentName: {}
            }
          },
          output: {
            resultWrapper: "DescribeEnvironmentResourcesResult",
            type: "structure",
            members: {
              EnvironmentResources: {
                type: "structure",
                members: {
                  EnvironmentName: {},
                  AutoScalingGroups: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {}
                      }
                    }
                  },
                  Instances: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Id: {}
                      }
                    }
                  },
                  LaunchConfigurations: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {}
                      }
                    }
                  },
                  LaunchTemplates: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Id: {}
                      }
                    }
                  },
                  LoadBalancers: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {}
                      }
                    }
                  },
                  Triggers: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {}
                      }
                    }
                  },
                  Queues: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {},
                        URL: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeEnvironments: {
          input: {
            type: "structure",
            members: {
              ApplicationName: {},
              VersionLabel: {},
              EnvironmentIds: {
                type: "list",
                member: {}
              },
              EnvironmentNames: {
                type: "list",
                member: {}
              },
              IncludeDeleted: {
                type: "boolean"
              },
              IncludedDeletedBackTo: {
                type: "timestamp"
              },
              MaxRecords: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            shape: "Sk",
            resultWrapper: "DescribeEnvironmentsResult"
          }
        },
        DescribeEvents: {
          input: {
            type: "structure",
            members: {
              ApplicationName: {},
              VersionLabel: {},
              TemplateName: {},
              EnvironmentId: {},
              EnvironmentName: {},
              PlatformArn: {},
              RequestId: {},
              Severity: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              MaxRecords: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventsResult",
            type: "structure",
            members: {
              Events: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EventDate: {
                      type: "timestamp"
                    },
                    Message: {},
                    ApplicationName: {},
                    VersionLabel: {},
                    TemplateName: {},
                    EnvironmentName: {},
                    PlatformArn: {},
                    RequestId: {},
                    Severity: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeInstancesHealth: {
          input: {
            type: "structure",
            members: {
              EnvironmentName: {},
              EnvironmentId: {},
              AttributeNames: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "DescribeInstancesHealthResult",
            type: "structure",
            members: {
              InstanceHealthList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InstanceId: {},
                    HealthStatus: {},
                    Color: {},
                    Causes: {
                      shape: "S48"
                    },
                    LaunchedAt: {
                      type: "timestamp"
                    },
                    ApplicationMetrics: {
                      shape: "S4a"
                    },
                    System: {
                      type: "structure",
                      members: {
                        CPUUtilization: {
                          type: "structure",
                          members: {
                            User: {
                              type: "double"
                            },
                            Nice: {
                              type: "double"
                            },
                            System: {
                              type: "double"
                            },
                            Idle: {
                              type: "double"
                            },
                            IOWait: {
                              type: "double"
                            },
                            IRQ: {
                              type: "double"
                            },
                            SoftIRQ: {
                              type: "double"
                            },
                            Privileged: {
                              type: "double"
                            }
                          }
                        },
                        LoadAverage: {
                          type: "list",
                          member: {
                            type: "double"
                          }
                        }
                      }
                    },
                    Deployment: {
                      type: "structure",
                      members: {
                        VersionLabel: {},
                        DeploymentId: {
                          type: "long"
                        },
                        Status: {},
                        DeploymentTime: {
                          type: "timestamp"
                        }
                      }
                    },
                    AvailabilityZone: {},
                    InstanceType: {}
                  }
                }
              },
              RefreshedAt: {
                type: "timestamp"
              },
              NextToken: {}
            }
          }
        },
        DescribePlatformVersion: {
          input: {
            type: "structure",
            members: {
              PlatformArn: {}
            }
          },
          output: {
            resultWrapper: "DescribePlatformVersionResult",
            type: "structure",
            members: {
              PlatformDescription: {
                type: "structure",
                members: {
                  PlatformArn: {},
                  PlatformOwner: {},
                  PlatformName: {},
                  PlatformVersion: {},
                  SolutionStackName: {},
                  PlatformStatus: {},
                  DateCreated: {
                    type: "timestamp"
                  },
                  DateUpdated: {
                    type: "timestamp"
                  },
                  PlatformCategory: {},
                  Description: {},
                  Maintainer: {},
                  OperatingSystemName: {},
                  OperatingSystemVersion: {},
                  ProgrammingLanguages: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {},
                        Version: {}
                      }
                    }
                  },
                  Frameworks: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {},
                        Version: {}
                      }
                    }
                  },
                  CustomAmiList: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        VirtualizationType: {},
                        ImageId: {}
                      }
                    }
                  },
                  SupportedTierList: {
                    shape: "S2s"
                  },
                  SupportedAddonList: {
                    shape: "S2u"
                  },
                  PlatformLifecycleState: {},
                  PlatformBranchName: {},
                  PlatformBranchLifecycleState: {}
                }
              }
            }
          }
        },
        DisassociateEnvironmentOperationsRole: {
          input: {
            type: "structure",
            required: [
              "EnvironmentName"
            ],
            members: {
              EnvironmentName: {}
            }
          }
        },
        ListAvailableSolutionStacks: {
          output: {
            resultWrapper: "ListAvailableSolutionStacksResult",
            type: "structure",
            members: {
              SolutionStacks: {
                type: "list",
                member: {}
              },
              SolutionStackDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SolutionStackName: {},
                    PermittedFileTypes: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              }
            }
          }
        },
        ListPlatformBranches: {
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Attribute: {},
                    Operator: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxRecords: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListPlatformBranchesResult",
            type: "structure",
            members: {
              PlatformBranchSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PlatformName: {},
                    BranchName: {},
                    LifecycleState: {},
                    BranchOrder: {
                      type: "integer"
                    },
                    SupportedTierList: {
                      shape: "S2s"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPlatformVersions: {
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    Operator: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxRecords: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListPlatformVersionsResult",
            type: "structure",
            members: {
              PlatformSummaryList: {
                type: "list",
                member: {
                  shape: "S2m"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            resultWrapper: "ListTagsForResourceResult",
            type: "structure",
            members: {
              ResourceArn: {},
              ResourceTags: {
                shape: "S7g"
              }
            }
          }
        },
        RebuildEnvironment: {
          input: {
            type: "structure",
            members: {
              EnvironmentId: {},
              EnvironmentName: {}
            }
          }
        },
        RequestEnvironmentInfo: {
          input: {
            type: "structure",
            required: [
              "InfoType"
            ],
            members: {
              EnvironmentId: {},
              EnvironmentName: {},
              InfoType: {}
            }
          }
        },
        RestartAppServer: {
          input: {
            type: "structure",
            members: {
              EnvironmentId: {},
              EnvironmentName: {}
            }
          }
        },
        RetrieveEnvironmentInfo: {
          input: {
            type: "structure",
            required: [
              "InfoType"
            ],
            members: {
              EnvironmentId: {},
              EnvironmentName: {},
              InfoType: {}
            }
          },
          output: {
            resultWrapper: "RetrieveEnvironmentInfoResult",
            type: "structure",
            members: {
              EnvironmentInfo: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InfoType: {},
                    Ec2InstanceId: {},
                    SampleTimestamp: {
                      type: "timestamp"
                    },
                    Message: {}
                  }
                }
              }
            }
          }
        },
        SwapEnvironmentCNAMEs: {
          input: {
            type: "structure",
            members: {
              SourceEnvironmentId: {},
              SourceEnvironmentName: {},
              DestinationEnvironmentId: {},
              DestinationEnvironmentName: {}
            }
          }
        },
        TerminateEnvironment: {
          input: {
            type: "structure",
            members: {
              EnvironmentId: {},
              EnvironmentName: {},
              TerminateResources: {
                type: "boolean"
              },
              ForceTerminate: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "Sm",
            resultWrapper: "TerminateEnvironmentResult"
          }
        },
        UpdateApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName"
            ],
            members: {
              ApplicationName: {},
              Description: {}
            }
          },
          output: {
            shape: "S1j",
            resultWrapper: "UpdateApplicationResult"
          }
        },
        UpdateApplicationResourceLifecycle: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "ResourceLifecycleConfig"
            ],
            members: {
              ApplicationName: {},
              ResourceLifecycleConfig: {
                shape: "S19"
              }
            }
          },
          output: {
            resultWrapper: "UpdateApplicationResourceLifecycleResult",
            type: "structure",
            members: {
              ApplicationName: {},
              ResourceLifecycleConfig: {
                shape: "S19"
              }
            }
          }
        },
        UpdateApplicationVersion: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "VersionLabel"
            ],
            members: {
              ApplicationName: {},
              VersionLabel: {},
              Description: {}
            }
          },
          output: {
            shape: "S21",
            resultWrapper: "UpdateApplicationVersionResult"
          }
        },
        UpdateConfigurationTemplate: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "TemplateName"
            ],
            members: {
              ApplicationName: {},
              TemplateName: {},
              Description: {},
              OptionSettings: {
                shape: "S27"
              },
              OptionsToRemove: {
                shape: "S2g"
              }
            }
          },
          output: {
            shape: "S2d",
            resultWrapper: "UpdateConfigurationTemplateResult"
          }
        },
        UpdateEnvironment: {
          input: {
            type: "structure",
            members: {
              ApplicationName: {},
              EnvironmentId: {},
              EnvironmentName: {},
              GroupName: {},
              Description: {},
              Tier: {
                shape: "S13"
              },
              VersionLabel: {},
              TemplateName: {},
              SolutionStackName: {},
              PlatformArn: {},
              OptionSettings: {
                shape: "S27"
              },
              OptionsToRemove: {
                shape: "S2g"
              }
            }
          },
          output: {
            shape: "Sm",
            resultWrapper: "UpdateEnvironmentResult"
          }
        },
        UpdateTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              TagsToAdd: {
                shape: "S7g"
              },
              TagsToRemove: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ValidateConfigurationSettings: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "OptionSettings"
            ],
            members: {
              ApplicationName: {},
              TemplateName: {},
              EnvironmentName: {},
              OptionSettings: {
                shape: "S27"
              }
            }
          },
          output: {
            resultWrapper: "ValidateConfigurationSettingsResult",
            type: "structure",
            members: {
              Messages: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Message: {},
                    Severity: {},
                    Namespace: {},
                    OptionName: {}
                  }
                }
              }
            }
          }
        }
      },
      shapes: {
        Sk: {
          type: "structure",
          members: {
            Environments: {
              type: "list",
              member: {
                shape: "Sm"
              }
            },
            NextToken: {}
          }
        },
        Sm: {
          type: "structure",
          members: {
            EnvironmentName: {},
            EnvironmentId: {},
            ApplicationName: {},
            VersionLabel: {},
            SolutionStackName: {},
            PlatformArn: {},
            TemplateName: {},
            Description: {},
            EndpointURL: {},
            CNAME: {},
            DateCreated: {
              type: "timestamp"
            },
            DateUpdated: {
              type: "timestamp"
            },
            Status: {},
            AbortableOperationInProgress: {
              type: "boolean"
            },
            Health: {},
            HealthStatus: {},
            Resources: {
              type: "structure",
              members: {
                LoadBalancer: {
                  type: "structure",
                  members: {
                    LoadBalancerName: {},
                    Domain: {},
                    Listeners: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Protocol: {},
                          Port: {
                            type: "integer"
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            Tier: {
              shape: "S13"
            },
            EnvironmentLinks: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  LinkName: {},
                  EnvironmentName: {}
                }
              }
            },
            EnvironmentArn: {},
            OperationsRole: {}
          }
        },
        S13: {
          type: "structure",
          members: {
            Name: {},
            Type: {},
            Version: {}
          }
        },
        S19: {
          type: "structure",
          members: {
            ServiceRole: {},
            VersionLifecycleConfig: {
              type: "structure",
              members: {
                MaxCountRule: {
                  type: "structure",
                  required: [
                    "Enabled"
                  ],
                  members: {
                    Enabled: {
                      type: "boolean"
                    },
                    MaxCount: {
                      type: "integer"
                    },
                    DeleteSourceFromS3: {
                      type: "boolean"
                    }
                  }
                },
                MaxAgeRule: {
                  type: "structure",
                  required: [
                    "Enabled"
                  ],
                  members: {
                    Enabled: {
                      type: "boolean"
                    },
                    MaxAgeInDays: {
                      type: "integer"
                    },
                    DeleteSourceFromS3: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        S1f: {
          type: "list",
          member: {
            shape: "S1g"
          }
        },
        S1g: {
          type: "structure",
          members: {
            Key: {},
            Value: {}
          }
        },
        S1j: {
          type: "structure",
          members: {
            Application: {
              shape: "S1k"
            }
          }
        },
        S1k: {
          type: "structure",
          members: {
            ApplicationArn: {},
            ApplicationName: {},
            Description: {},
            DateCreated: {
              type: "timestamp"
            },
            DateUpdated: {
              type: "timestamp"
            },
            Versions: {
              shape: "S1m"
            },
            ConfigurationTemplates: {
              type: "list",
              member: {}
            },
            ResourceLifecycleConfig: {
              shape: "S19"
            }
          }
        },
        S1m: {
          type: "list",
          member: {}
        },
        S1p: {
          type: "structure",
          required: [
            "SourceType",
            "SourceRepository",
            "SourceLocation"
          ],
          members: {
            SourceType: {},
            SourceRepository: {},
            SourceLocation: {}
          }
        },
        S1t: {
          type: "structure",
          members: {
            S3Bucket: {},
            S3Key: {}
          }
        },
        S21: {
          type: "structure",
          members: {
            ApplicationVersion: {
              shape: "S22"
            }
          }
        },
        S22: {
          type: "structure",
          members: {
            ApplicationVersionArn: {},
            ApplicationName: {},
            Description: {},
            VersionLabel: {},
            SourceBuildInformation: {
              shape: "S1p"
            },
            BuildArn: {},
            SourceBundle: {
              shape: "S1t"
            },
            DateCreated: {
              type: "timestamp"
            },
            DateUpdated: {
              type: "timestamp"
            },
            Status: {}
          }
        },
        S27: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ResourceName: {},
              Namespace: {},
              OptionName: {},
              Value: {}
            }
          }
        },
        S2d: {
          type: "structure",
          members: {
            SolutionStackName: {},
            PlatformArn: {},
            ApplicationName: {},
            TemplateName: {},
            Description: {},
            EnvironmentName: {},
            DeploymentStatus: {},
            DateCreated: {
              type: "timestamp"
            },
            DateUpdated: {
              type: "timestamp"
            },
            OptionSettings: {
              shape: "S27"
            }
          }
        },
        S2g: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ResourceName: {},
              Namespace: {},
              OptionName: {}
            }
          }
        },
        S2m: {
          type: "structure",
          members: {
            PlatformArn: {},
            PlatformOwner: {},
            PlatformStatus: {},
            PlatformCategory: {},
            OperatingSystemName: {},
            OperatingSystemVersion: {},
            SupportedTierList: {
              shape: "S2s"
            },
            SupportedAddonList: {
              shape: "S2u"
            },
            PlatformLifecycleState: {},
            PlatformVersion: {},
            PlatformBranchName: {},
            PlatformBranchLifecycleState: {}
          }
        },
        S2s: {
          type: "list",
          member: {}
        },
        S2u: {
          type: "list",
          member: {}
        },
        S3c: {
          type: "structure",
          members: {
            Maximum: {
              type: "integer"
            }
          }
        },
        S48: {
          type: "list",
          member: {}
        },
        S4a: {
          type: "structure",
          members: {
            Duration: {
              type: "integer"
            },
            RequestCount: {
              type: "integer"
            },
            StatusCodes: {
              type: "structure",
              members: {
                Status2xx: {
                  type: "integer"
                },
                Status3xx: {
                  type: "integer"
                },
                Status4xx: {
                  type: "integer"
                },
                Status5xx: {
                  type: "integer"
                }
              }
            },
            Latency: {
              type: "structure",
              members: {
                P999: {
                  type: "double"
                },
                P99: {
                  type: "double"
                },
                P95: {
                  type: "double"
                },
                P90: {
                  type: "double"
                },
                P85: {
                  type: "double"
                },
                P75: {
                  type: "double"
                },
                P50: {
                  type: "double"
                },
                P10: {
                  type: "double"
                }
              }
            }
          }
        },
        S7g: {
          type: "list",
          member: {
            shape: "S1g"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/elasticbeanstalk-2010-12-01.paginators.json
var require_elasticbeanstalk_2010_12_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/elasticbeanstalk-2010-12-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeApplicationVersions: {
          result_key: "ApplicationVersions"
        },
        DescribeApplications: {
          result_key: "Applications"
        },
        DescribeConfigurationOptions: {
          result_key: "Options"
        },
        DescribeEnvironmentManagedActionHistory: {
          input_token: "NextToken",
          limit_key: "MaxItems",
          output_token: "NextToken",
          result_key: "ManagedActionHistoryItems"
        },
        DescribeEnvironments: {
          result_key: "Environments"
        },
        DescribeEvents: {
          input_token: "NextToken",
          limit_key: "MaxRecords",
          output_token: "NextToken",
          result_key: "Events"
        },
        ListAvailableSolutionStacks: {
          result_key: "SolutionStacks"
        },
        ListPlatformBranches: {
          input_token: "NextToken",
          limit_key: "MaxRecords",
          output_token: "NextToken"
        },
        ListPlatformVersions: {
          input_token: "NextToken",
          limit_key: "MaxRecords",
          output_token: "NextToken",
          result_key: "PlatformSummaryList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/elasticbeanstalk-2010-12-01.waiters2.json
var require_elasticbeanstalk_2010_12_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/elasticbeanstalk-2010-12-01.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        EnvironmentExists: {
          delay: 20,
          maxAttempts: 20,
          operation: "DescribeEnvironments",
          acceptors: [
            {
              state: "success",
              matcher: "pathAll",
              argument: "Environments[].Status",
              expected: "Ready"
            },
            {
              state: "retry",
              matcher: "pathAll",
              argument: "Environments[].Status",
              expected: "Launching"
            }
          ]
        },
        EnvironmentUpdated: {
          delay: 20,
          maxAttempts: 20,
          operation: "DescribeEnvironments",
          acceptors: [
            {
              state: "success",
              matcher: "pathAll",
              argument: "Environments[].Status",
              expected: "Ready"
            },
            {
              state: "retry",
              matcher: "pathAll",
              argument: "Environments[].Status",
              expected: "Updating"
            }
          ]
        },
        EnvironmentTerminated: {
          delay: 20,
          maxAttempts: 20,
          operation: "DescribeEnvironments",
          acceptors: [
            {
              state: "success",
              matcher: "pathAll",
              argument: "Environments[].Status",
              expected: "Terminated"
            },
            {
              state: "retry",
              matcher: "pathAll",
              argument: "Environments[].Status",
              expected: "Terminating"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/elasticbeanstalk.js
var require_elasticbeanstalk = __commonJS({
  "node_modules/aws-sdk/clients/elasticbeanstalk.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["elasticbeanstalk"] = {};
    AWS2.ElasticBeanstalk = Service.defineService("elasticbeanstalk", ["2010-12-01"]);
    Object.defineProperty(apiLoader.services["elasticbeanstalk"], "2010-12-01", {
      get: function get() {
        var model = require_elasticbeanstalk_2010_12_01_min();
        model.paginators = require_elasticbeanstalk_2010_12_01_paginators().pagination;
        model.waiters = require_elasticbeanstalk_2010_12_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ElasticBeanstalk;
  }
});

// node_modules/aws-sdk/apis/elasticloadbalancing-2012-06-01.min.json
var require_elasticloadbalancing_2012_06_01_min = __commonJS({
  "node_modules/aws-sdk/apis/elasticloadbalancing-2012-06-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2012-06-01",
        endpointPrefix: "elasticloadbalancing",
        protocol: "query",
        serviceFullName: "Elastic Load Balancing",
        serviceId: "Elastic Load Balancing",
        signatureVersion: "v4",
        uid: "elasticloadbalancing-2012-06-01",
        xmlNamespace: "http://elasticloadbalancing.amazonaws.com/doc/2012-06-01/"
      },
      operations: {
        AddTags: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerNames",
              "Tags"
            ],
            members: {
              LoadBalancerNames: {
                shape: "S2"
              },
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            resultWrapper: "AddTagsResult",
            type: "structure",
            members: {}
          }
        },
        ApplySecurityGroupsToLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "SecurityGroups"
            ],
            members: {
              LoadBalancerName: {},
              SecurityGroups: {
                shape: "Sa"
              }
            }
          },
          output: {
            resultWrapper: "ApplySecurityGroupsToLoadBalancerResult",
            type: "structure",
            members: {
              SecurityGroups: {
                shape: "Sa"
              }
            }
          }
        },
        AttachLoadBalancerToSubnets: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "Subnets"
            ],
            members: {
              LoadBalancerName: {},
              Subnets: {
                shape: "Se"
              }
            }
          },
          output: {
            resultWrapper: "AttachLoadBalancerToSubnetsResult",
            type: "structure",
            members: {
              Subnets: {
                shape: "Se"
              }
            }
          }
        },
        ConfigureHealthCheck: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "HealthCheck"
            ],
            members: {
              LoadBalancerName: {},
              HealthCheck: {
                shape: "Si"
              }
            }
          },
          output: {
            resultWrapper: "ConfigureHealthCheckResult",
            type: "structure",
            members: {
              HealthCheck: {
                shape: "Si"
              }
            }
          }
        },
        CreateAppCookieStickinessPolicy: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "PolicyName",
              "CookieName"
            ],
            members: {
              LoadBalancerName: {},
              PolicyName: {},
              CookieName: {}
            }
          },
          output: {
            resultWrapper: "CreateAppCookieStickinessPolicyResult",
            type: "structure",
            members: {}
          }
        },
        CreateLBCookieStickinessPolicy: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "PolicyName"
            ],
            members: {
              LoadBalancerName: {},
              PolicyName: {},
              CookieExpirationPeriod: {
                type: "long"
              }
            }
          },
          output: {
            resultWrapper: "CreateLBCookieStickinessPolicyResult",
            type: "structure",
            members: {}
          }
        },
        CreateLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "Listeners"
            ],
            members: {
              LoadBalancerName: {},
              Listeners: {
                shape: "Sx"
              },
              AvailabilityZones: {
                shape: "S13"
              },
              Subnets: {
                shape: "Se"
              },
              SecurityGroups: {
                shape: "Sa"
              },
              Scheme: {},
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            resultWrapper: "CreateLoadBalancerResult",
            type: "structure",
            members: {
              DNSName: {}
            }
          }
        },
        CreateLoadBalancerListeners: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "Listeners"
            ],
            members: {
              LoadBalancerName: {},
              Listeners: {
                shape: "Sx"
              }
            }
          },
          output: {
            resultWrapper: "CreateLoadBalancerListenersResult",
            type: "structure",
            members: {}
          }
        },
        CreateLoadBalancerPolicy: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "PolicyName",
              "PolicyTypeName"
            ],
            members: {
              LoadBalancerName: {},
              PolicyName: {},
              PolicyTypeName: {},
              PolicyAttributes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AttributeName: {},
                    AttributeValue: {}
                  }
                }
              }
            }
          },
          output: {
            resultWrapper: "CreateLoadBalancerPolicyResult",
            type: "structure",
            members: {}
          }
        },
        DeleteLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName"
            ],
            members: {
              LoadBalancerName: {}
            }
          },
          output: {
            resultWrapper: "DeleteLoadBalancerResult",
            type: "structure",
            members: {}
          }
        },
        DeleteLoadBalancerListeners: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "LoadBalancerPorts"
            ],
            members: {
              LoadBalancerName: {},
              LoadBalancerPorts: {
                type: "list",
                member: {
                  type: "integer"
                }
              }
            }
          },
          output: {
            resultWrapper: "DeleteLoadBalancerListenersResult",
            type: "structure",
            members: {}
          }
        },
        DeleteLoadBalancerPolicy: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "PolicyName"
            ],
            members: {
              LoadBalancerName: {},
              PolicyName: {}
            }
          },
          output: {
            resultWrapper: "DeleteLoadBalancerPolicyResult",
            type: "structure",
            members: {}
          }
        },
        DeregisterInstancesFromLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "Instances"
            ],
            members: {
              LoadBalancerName: {},
              Instances: {
                shape: "S1p"
              }
            }
          },
          output: {
            resultWrapper: "DeregisterInstancesFromLoadBalancerResult",
            type: "structure",
            members: {
              Instances: {
                shape: "S1p"
              }
            }
          }
        },
        DescribeAccountLimits: {
          input: {
            type: "structure",
            members: {
              Marker: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeAccountLimitsResult",
            type: "structure",
            members: {
              Limits: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Max: {}
                  }
                }
              },
              NextMarker: {}
            }
          }
        },
        DescribeInstanceHealth: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName"
            ],
            members: {
              LoadBalancerName: {},
              Instances: {
                shape: "S1p"
              }
            }
          },
          output: {
            resultWrapper: "DescribeInstanceHealthResult",
            type: "structure",
            members: {
              InstanceStates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InstanceId: {},
                    State: {},
                    ReasonCode: {},
                    Description: {}
                  }
                }
              }
            }
          }
        },
        DescribeLoadBalancerAttributes: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName"
            ],
            members: {
              LoadBalancerName: {}
            }
          },
          output: {
            resultWrapper: "DescribeLoadBalancerAttributesResult",
            type: "structure",
            members: {
              LoadBalancerAttributes: {
                shape: "S2a"
              }
            }
          }
        },
        DescribeLoadBalancerPolicies: {
          input: {
            type: "structure",
            members: {
              LoadBalancerName: {},
              PolicyNames: {
                shape: "S2s"
              }
            }
          },
          output: {
            resultWrapper: "DescribeLoadBalancerPoliciesResult",
            type: "structure",
            members: {
              PolicyDescriptions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PolicyName: {},
                    PolicyTypeName: {},
                    PolicyAttributeDescriptions: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          AttributeName: {},
                          AttributeValue: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeLoadBalancerPolicyTypes: {
          input: {
            type: "structure",
            members: {
              PolicyTypeNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "DescribeLoadBalancerPolicyTypesResult",
            type: "structure",
            members: {
              PolicyTypeDescriptions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PolicyTypeName: {},
                    Description: {},
                    PolicyAttributeTypeDescriptions: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          AttributeName: {},
                          AttributeType: {},
                          Description: {},
                          DefaultValue: {},
                          Cardinality: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeLoadBalancers: {
          input: {
            type: "structure",
            members: {
              LoadBalancerNames: {
                shape: "S2"
              },
              Marker: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeLoadBalancersResult",
            type: "structure",
            members: {
              LoadBalancerDescriptions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LoadBalancerName: {},
                    DNSName: {},
                    CanonicalHostedZoneName: {},
                    CanonicalHostedZoneNameID: {},
                    ListenerDescriptions: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Listener: {
                            shape: "Sy"
                          },
                          PolicyNames: {
                            shape: "S2s"
                          }
                        }
                      }
                    },
                    Policies: {
                      type: "structure",
                      members: {
                        AppCookieStickinessPolicies: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              PolicyName: {},
                              CookieName: {}
                            }
                          }
                        },
                        LBCookieStickinessPolicies: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              PolicyName: {},
                              CookieExpirationPeriod: {
                                type: "long"
                              }
                            }
                          }
                        },
                        OtherPolicies: {
                          shape: "S2s"
                        }
                      }
                    },
                    BackendServerDescriptions: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          InstancePort: {
                            type: "integer"
                          },
                          PolicyNames: {
                            shape: "S2s"
                          }
                        }
                      }
                    },
                    AvailabilityZones: {
                      shape: "S13"
                    },
                    Subnets: {
                      shape: "Se"
                    },
                    VPCId: {},
                    Instances: {
                      shape: "S1p"
                    },
                    HealthCheck: {
                      shape: "Si"
                    },
                    SourceSecurityGroup: {
                      type: "structure",
                      members: {
                        OwnerAlias: {},
                        GroupName: {}
                      }
                    },
                    SecurityGroups: {
                      shape: "Sa"
                    },
                    CreatedTime: {
                      type: "timestamp"
                    },
                    Scheme: {}
                  }
                }
              },
              NextMarker: {}
            }
          }
        },
        DescribeTags: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerNames"
            ],
            members: {
              LoadBalancerNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "DescribeTagsResult",
            type: "structure",
            members: {
              TagDescriptions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LoadBalancerName: {},
                    Tags: {
                      shape: "S4"
                    }
                  }
                }
              }
            }
          }
        },
        DetachLoadBalancerFromSubnets: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "Subnets"
            ],
            members: {
              LoadBalancerName: {},
              Subnets: {
                shape: "Se"
              }
            }
          },
          output: {
            resultWrapper: "DetachLoadBalancerFromSubnetsResult",
            type: "structure",
            members: {
              Subnets: {
                shape: "Se"
              }
            }
          }
        },
        DisableAvailabilityZonesForLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "AvailabilityZones"
            ],
            members: {
              LoadBalancerName: {},
              AvailabilityZones: {
                shape: "S13"
              }
            }
          },
          output: {
            resultWrapper: "DisableAvailabilityZonesForLoadBalancerResult",
            type: "structure",
            members: {
              AvailabilityZones: {
                shape: "S13"
              }
            }
          }
        },
        EnableAvailabilityZonesForLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "AvailabilityZones"
            ],
            members: {
              LoadBalancerName: {},
              AvailabilityZones: {
                shape: "S13"
              }
            }
          },
          output: {
            resultWrapper: "EnableAvailabilityZonesForLoadBalancerResult",
            type: "structure",
            members: {
              AvailabilityZones: {
                shape: "S13"
              }
            }
          }
        },
        ModifyLoadBalancerAttributes: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "LoadBalancerAttributes"
            ],
            members: {
              LoadBalancerName: {},
              LoadBalancerAttributes: {
                shape: "S2a"
              }
            }
          },
          output: {
            resultWrapper: "ModifyLoadBalancerAttributesResult",
            type: "structure",
            members: {
              LoadBalancerName: {},
              LoadBalancerAttributes: {
                shape: "S2a"
              }
            }
          }
        },
        RegisterInstancesWithLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "Instances"
            ],
            members: {
              LoadBalancerName: {},
              Instances: {
                shape: "S1p"
              }
            }
          },
          output: {
            resultWrapper: "RegisterInstancesWithLoadBalancerResult",
            type: "structure",
            members: {
              Instances: {
                shape: "S1p"
              }
            }
          }
        },
        RemoveTags: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerNames",
              "Tags"
            ],
            members: {
              LoadBalancerNames: {
                shape: "S2"
              },
              Tags: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Key: {}
                  }
                }
              }
            }
          },
          output: {
            resultWrapper: "RemoveTagsResult",
            type: "structure",
            members: {}
          }
        },
        SetLoadBalancerListenerSSLCertificate: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "LoadBalancerPort",
              "SSLCertificateId"
            ],
            members: {
              LoadBalancerName: {},
              LoadBalancerPort: {
                type: "integer"
              },
              SSLCertificateId: {}
            }
          },
          output: {
            resultWrapper: "SetLoadBalancerListenerSSLCertificateResult",
            type: "structure",
            members: {}
          }
        },
        SetLoadBalancerPoliciesForBackendServer: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "InstancePort",
              "PolicyNames"
            ],
            members: {
              LoadBalancerName: {},
              InstancePort: {
                type: "integer"
              },
              PolicyNames: {
                shape: "S2s"
              }
            }
          },
          output: {
            resultWrapper: "SetLoadBalancerPoliciesForBackendServerResult",
            type: "structure",
            members: {}
          }
        },
        SetLoadBalancerPoliciesOfListener: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "LoadBalancerPort",
              "PolicyNames"
            ],
            members: {
              LoadBalancerName: {},
              LoadBalancerPort: {
                type: "integer"
              },
              PolicyNames: {
                shape: "S2s"
              }
            }
          },
          output: {
            resultWrapper: "SetLoadBalancerPoliciesOfListenerResult",
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S2: {
          type: "list",
          member: {}
        },
        S4: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sa: {
          type: "list",
          member: {}
        },
        Se: {
          type: "list",
          member: {}
        },
        Si: {
          type: "structure",
          required: [
            "Target",
            "Interval",
            "Timeout",
            "UnhealthyThreshold",
            "HealthyThreshold"
          ],
          members: {
            Target: {},
            Interval: {
              type: "integer"
            },
            Timeout: {
              type: "integer"
            },
            UnhealthyThreshold: {
              type: "integer"
            },
            HealthyThreshold: {
              type: "integer"
            }
          }
        },
        Sx: {
          type: "list",
          member: {
            shape: "Sy"
          }
        },
        Sy: {
          type: "structure",
          required: [
            "Protocol",
            "LoadBalancerPort",
            "InstancePort"
          ],
          members: {
            Protocol: {},
            LoadBalancerPort: {
              type: "integer"
            },
            InstanceProtocol: {},
            InstancePort: {
              type: "integer"
            },
            SSLCertificateId: {}
          }
        },
        S13: {
          type: "list",
          member: {}
        },
        S1p: {
          type: "list",
          member: {
            type: "structure",
            members: {
              InstanceId: {}
            }
          }
        },
        S2a: {
          type: "structure",
          members: {
            CrossZoneLoadBalancing: {
              type: "structure",
              required: [
                "Enabled"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                }
              }
            },
            AccessLog: {
              type: "structure",
              required: [
                "Enabled"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                S3BucketName: {},
                EmitInterval: {
                  type: "integer"
                },
                S3BucketPrefix: {}
              }
            },
            ConnectionDraining: {
              type: "structure",
              required: [
                "Enabled"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                Timeout: {
                  type: "integer"
                }
              }
            },
            ConnectionSettings: {
              type: "structure",
              required: [
                "IdleTimeout"
              ],
              members: {
                IdleTimeout: {
                  type: "integer"
                }
              }
            },
            AdditionalAttributes: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Key: {},
                  Value: {}
                }
              }
            }
          }
        },
        S2s: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/elasticloadbalancing-2012-06-01.paginators.json
var require_elasticloadbalancing_2012_06_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/elasticloadbalancing-2012-06-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeInstanceHealth: {
          result_key: "InstanceStates"
        },
        DescribeLoadBalancerPolicies: {
          result_key: "PolicyDescriptions"
        },
        DescribeLoadBalancerPolicyTypes: {
          result_key: "PolicyTypeDescriptions"
        },
        DescribeLoadBalancers: {
          input_token: "Marker",
          output_token: "NextMarker",
          result_key: "LoadBalancerDescriptions"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/elasticloadbalancing-2012-06-01.waiters2.json
var require_elasticloadbalancing_2012_06_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/elasticloadbalancing-2012-06-01.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        InstanceDeregistered: {
          delay: 15,
          operation: "DescribeInstanceHealth",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "OutOfService",
              matcher: "pathAll",
              state: "success",
              argument: "InstanceStates[].State"
            },
            {
              matcher: "error",
              expected: "InvalidInstance",
              state: "success"
            }
          ]
        },
        AnyInstanceInService: {
          acceptors: [
            {
              argument: "InstanceStates[].State",
              expected: "InService",
              matcher: "pathAny",
              state: "success"
            }
          ],
          delay: 15,
          maxAttempts: 40,
          operation: "DescribeInstanceHealth"
        },
        InstanceInService: {
          acceptors: [
            {
              argument: "InstanceStates[].State",
              expected: "InService",
              matcher: "pathAll",
              state: "success"
            },
            {
              matcher: "error",
              expected: "InvalidInstance",
              state: "retry"
            }
          ],
          delay: 15,
          maxAttempts: 40,
          operation: "DescribeInstanceHealth"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/elb.js
var require_elb = __commonJS({
  "node_modules/aws-sdk/clients/elb.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["elb"] = {};
    AWS2.ELB = Service.defineService("elb", ["2012-06-01"]);
    Object.defineProperty(apiLoader.services["elb"], "2012-06-01", {
      get: function get() {
        var model = require_elasticloadbalancing_2012_06_01_min();
        model.paginators = require_elasticloadbalancing_2012_06_01_paginators().pagination;
        model.waiters = require_elasticloadbalancing_2012_06_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ELB;
  }
});

// node_modules/aws-sdk/apis/elasticloadbalancingv2-2015-12-01.min.json
var require_elasticloadbalancingv2_2015_12_01_min = __commonJS({
  "node_modules/aws-sdk/apis/elasticloadbalancingv2-2015-12-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-12-01",
        endpointPrefix: "elasticloadbalancing",
        protocol: "query",
        serviceAbbreviation: "Elastic Load Balancing v2",
        serviceFullName: "Elastic Load Balancing",
        serviceId: "Elastic Load Balancing v2",
        signatureVersion: "v4",
        uid: "elasticloadbalancingv2-2015-12-01",
        xmlNamespace: "http://elasticloadbalancing.amazonaws.com/doc/2015-12-01/"
      },
      operations: {
        AddListenerCertificates: {
          input: {
            type: "structure",
            required: [
              "ListenerArn",
              "Certificates"
            ],
            members: {
              ListenerArn: {},
              Certificates: {
                shape: "S3"
              }
            }
          },
          output: {
            resultWrapper: "AddListenerCertificatesResult",
            type: "structure",
            members: {
              Certificates: {
                shape: "S3"
              }
            }
          }
        },
        AddTags: {
          input: {
            type: "structure",
            required: [
              "ResourceArns",
              "Tags"
            ],
            members: {
              ResourceArns: {
                shape: "S9"
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "AddTagsResult",
            type: "structure",
            members: {}
          }
        },
        AddTrustStoreRevocations: {
          input: {
            type: "structure",
            required: [
              "TrustStoreArn"
            ],
            members: {
              TrustStoreArn: {},
              RevocationContents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    S3Bucket: {},
                    S3Key: {},
                    S3ObjectVersion: {},
                    RevocationType: {}
                  }
                }
              }
            }
          },
          output: {
            resultWrapper: "AddTrustStoreRevocationsResult",
            type: "structure",
            members: {
              TrustStoreRevocations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TrustStoreArn: {},
                    RevocationId: {
                      type: "long"
                    },
                    RevocationType: {},
                    NumberOfRevokedEntries: {
                      type: "long"
                    }
                  }
                }
              }
            }
          }
        },
        CreateListener: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerArn",
              "DefaultActions"
            ],
            members: {
              LoadBalancerArn: {},
              Protocol: {},
              Port: {
                type: "integer"
              },
              SslPolicy: {},
              Certificates: {
                shape: "S3"
              },
              DefaultActions: {
                shape: "Sy"
              },
              AlpnPolicy: {
                shape: "S2b"
              },
              Tags: {
                shape: "Sb"
              },
              MutualAuthentication: {
                shape: "S2d"
              }
            }
          },
          output: {
            resultWrapper: "CreateListenerResult",
            type: "structure",
            members: {
              Listeners: {
                shape: "S2h"
              }
            }
          }
        },
        CreateLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Subnets: {
                shape: "S2l"
              },
              SubnetMappings: {
                shape: "S2n"
              },
              SecurityGroups: {
                shape: "S2s"
              },
              Scheme: {},
              Tags: {
                shape: "Sb"
              },
              Type: {},
              IpAddressType: {},
              CustomerOwnedIpv4Pool: {}
            }
          },
          output: {
            resultWrapper: "CreateLoadBalancerResult",
            type: "structure",
            members: {
              LoadBalancers: {
                shape: "S2z"
              }
            }
          }
        },
        CreateRule: {
          input: {
            type: "structure",
            required: [
              "ListenerArn",
              "Conditions",
              "Priority",
              "Actions"
            ],
            members: {
              ListenerArn: {},
              Conditions: {
                shape: "S3h"
              },
              Priority: {
                type: "integer"
              },
              Actions: {
                shape: "Sy"
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "CreateRuleResult",
            type: "structure",
            members: {
              Rules: {
                shape: "S3x"
              }
            }
          }
        },
        CreateTargetGroup: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Protocol: {},
              ProtocolVersion: {},
              Port: {
                type: "integer"
              },
              VpcId: {},
              HealthCheckProtocol: {},
              HealthCheckPort: {},
              HealthCheckEnabled: {
                type: "boolean"
              },
              HealthCheckPath: {},
              HealthCheckIntervalSeconds: {
                type: "integer"
              },
              HealthCheckTimeoutSeconds: {
                type: "integer"
              },
              HealthyThresholdCount: {
                type: "integer"
              },
              UnhealthyThresholdCount: {
                type: "integer"
              },
              Matcher: {
                shape: "S4b"
              },
              TargetType: {},
              Tags: {
                shape: "Sb"
              },
              IpAddressType: {}
            }
          },
          output: {
            resultWrapper: "CreateTargetGroupResult",
            type: "structure",
            members: {
              TargetGroups: {
                shape: "S4h"
              }
            }
          }
        },
        CreateTrustStore: {
          input: {
            type: "structure",
            required: [
              "Name",
              "CaCertificatesBundleS3Bucket",
              "CaCertificatesBundleS3Key"
            ],
            members: {
              Name: {},
              CaCertificatesBundleS3Bucket: {},
              CaCertificatesBundleS3Key: {},
              CaCertificatesBundleS3ObjectVersion: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "CreateTrustStoreResult",
            type: "structure",
            members: {
              TrustStores: {
                shape: "S4n"
              }
            }
          }
        },
        DeleteListener: {
          input: {
            type: "structure",
            required: [
              "ListenerArn"
            ],
            members: {
              ListenerArn: {}
            }
          },
          output: {
            resultWrapper: "DeleteListenerResult",
            type: "structure",
            members: {}
          }
        },
        DeleteLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerArn"
            ],
            members: {
              LoadBalancerArn: {}
            }
          },
          output: {
            resultWrapper: "DeleteLoadBalancerResult",
            type: "structure",
            members: {}
          }
        },
        DeleteRule: {
          input: {
            type: "structure",
            required: [
              "RuleArn"
            ],
            members: {
              RuleArn: {}
            }
          },
          output: {
            resultWrapper: "DeleteRuleResult",
            type: "structure",
            members: {}
          }
        },
        DeleteTargetGroup: {
          input: {
            type: "structure",
            required: [
              "TargetGroupArn"
            ],
            members: {
              TargetGroupArn: {}
            }
          },
          output: {
            resultWrapper: "DeleteTargetGroupResult",
            type: "structure",
            members: {}
          }
        },
        DeleteTrustStore: {
          input: {
            type: "structure",
            required: [
              "TrustStoreArn"
            ],
            members: {
              TrustStoreArn: {}
            }
          },
          output: {
            resultWrapper: "DeleteTrustStoreResult",
            type: "structure",
            members: {}
          }
        },
        DeregisterTargets: {
          input: {
            type: "structure",
            required: [
              "TargetGroupArn",
              "Targets"
            ],
            members: {
              TargetGroupArn: {},
              Targets: {
                shape: "S53"
              }
            }
          },
          output: {
            resultWrapper: "DeregisterTargetsResult",
            type: "structure",
            members: {}
          }
        },
        DescribeAccountLimits: {
          input: {
            type: "structure",
            members: {
              Marker: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeAccountLimitsResult",
            type: "structure",
            members: {
              Limits: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Max: {}
                  }
                }
              },
              NextMarker: {}
            }
          }
        },
        DescribeListenerCertificates: {
          input: {
            type: "structure",
            required: [
              "ListenerArn"
            ],
            members: {
              ListenerArn: {},
              Marker: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeListenerCertificatesResult",
            type: "structure",
            members: {
              Certificates: {
                shape: "S3"
              },
              NextMarker: {}
            }
          }
        },
        DescribeListeners: {
          input: {
            type: "structure",
            members: {
              LoadBalancerArn: {},
              ListenerArns: {
                type: "list",
                member: {}
              },
              Marker: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeListenersResult",
            type: "structure",
            members: {
              Listeners: {
                shape: "S2h"
              },
              NextMarker: {}
            }
          }
        },
        DescribeLoadBalancerAttributes: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerArn"
            ],
            members: {
              LoadBalancerArn: {}
            }
          },
          output: {
            resultWrapper: "DescribeLoadBalancerAttributesResult",
            type: "structure",
            members: {
              Attributes: {
                shape: "S5m"
              }
            }
          }
        },
        DescribeLoadBalancers: {
          input: {
            type: "structure",
            members: {
              LoadBalancerArns: {
                shape: "S4j"
              },
              Names: {
                type: "list",
                member: {}
              },
              Marker: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeLoadBalancersResult",
            type: "structure",
            members: {
              LoadBalancers: {
                shape: "S2z"
              },
              NextMarker: {}
            }
          }
        },
        DescribeRules: {
          input: {
            type: "structure",
            members: {
              ListenerArn: {},
              RuleArns: {
                type: "list",
                member: {}
              },
              Marker: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeRulesResult",
            type: "structure",
            members: {
              Rules: {
                shape: "S3x"
              },
              NextMarker: {}
            }
          }
        },
        DescribeSSLPolicies: {
          input: {
            type: "structure",
            members: {
              Names: {
                type: "list",
                member: {}
              },
              Marker: {},
              PageSize: {
                type: "integer"
              },
              LoadBalancerType: {}
            }
          },
          output: {
            resultWrapper: "DescribeSSLPoliciesResult",
            type: "structure",
            members: {
              SslPolicies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SslProtocols: {
                      type: "list",
                      member: {}
                    },
                    Ciphers: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Name: {},
                          Priority: {
                            type: "integer"
                          }
                        }
                      }
                    },
                    Name: {},
                    SupportedLoadBalancerTypes: {
                      shape: "S3k"
                    }
                  }
                }
              },
              NextMarker: {}
            }
          }
        },
        DescribeTags: {
          input: {
            type: "structure",
            required: [
              "ResourceArns"
            ],
            members: {
              ResourceArns: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "DescribeTagsResult",
            type: "structure",
            members: {
              TagDescriptions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceArn: {},
                    Tags: {
                      shape: "Sb"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeTargetGroupAttributes: {
          input: {
            type: "structure",
            required: [
              "TargetGroupArn"
            ],
            members: {
              TargetGroupArn: {}
            }
          },
          output: {
            resultWrapper: "DescribeTargetGroupAttributesResult",
            type: "structure",
            members: {
              Attributes: {
                shape: "S6d"
              }
            }
          }
        },
        DescribeTargetGroups: {
          input: {
            type: "structure",
            members: {
              LoadBalancerArn: {},
              TargetGroupArns: {
                type: "list",
                member: {}
              },
              Names: {
                type: "list",
                member: {}
              },
              Marker: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeTargetGroupsResult",
            type: "structure",
            members: {
              TargetGroups: {
                shape: "S4h"
              },
              NextMarker: {}
            }
          }
        },
        DescribeTargetHealth: {
          input: {
            type: "structure",
            required: [
              "TargetGroupArn"
            ],
            members: {
              TargetGroupArn: {},
              Targets: {
                shape: "S53"
              },
              Include: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "DescribeTargetHealthResult",
            type: "structure",
            members: {
              TargetHealthDescriptions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Target: {
                      shape: "S54"
                    },
                    HealthCheckPort: {},
                    TargetHealth: {
                      type: "structure",
                      members: {
                        State: {},
                        Reason: {},
                        Description: {}
                      }
                    },
                    AnomalyDetection: {
                      type: "structure",
                      members: {
                        Result: {},
                        MitigationInEffect: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeTrustStoreAssociations: {
          input: {
            type: "structure",
            required: [
              "TrustStoreArn"
            ],
            members: {
              TrustStoreArn: {},
              Marker: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeTrustStoreAssociationsResult",
            type: "structure",
            members: {
              TrustStoreAssociations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceArn: {}
                  }
                }
              },
              NextMarker: {}
            }
          }
        },
        DescribeTrustStoreRevocations: {
          input: {
            type: "structure",
            required: [
              "TrustStoreArn"
            ],
            members: {
              TrustStoreArn: {},
              RevocationIds: {
                shape: "S74"
              },
              Marker: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeTrustStoreRevocationsResult",
            type: "structure",
            members: {
              TrustStoreRevocations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TrustStoreArn: {},
                    RevocationId: {
                      type: "long"
                    },
                    RevocationType: {},
                    NumberOfRevokedEntries: {
                      type: "long"
                    }
                  }
                }
              },
              NextMarker: {}
            }
          }
        },
        DescribeTrustStores: {
          input: {
            type: "structure",
            members: {
              TrustStoreArns: {
                type: "list",
                member: {}
              },
              Names: {
                type: "list",
                member: {}
              },
              Marker: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeTrustStoresResult",
            type: "structure",
            members: {
              TrustStores: {
                shape: "S4n"
              },
              NextMarker: {}
            }
          }
        },
        GetTrustStoreCaCertificatesBundle: {
          input: {
            type: "structure",
            required: [
              "TrustStoreArn"
            ],
            members: {
              TrustStoreArn: {}
            }
          },
          output: {
            resultWrapper: "GetTrustStoreCaCertificatesBundleResult",
            type: "structure",
            members: {
              Location: {}
            }
          }
        },
        GetTrustStoreRevocationContent: {
          input: {
            type: "structure",
            required: [
              "TrustStoreArn",
              "RevocationId"
            ],
            members: {
              TrustStoreArn: {},
              RevocationId: {
                type: "long"
              }
            }
          },
          output: {
            resultWrapper: "GetTrustStoreRevocationContentResult",
            type: "structure",
            members: {
              Location: {}
            }
          }
        },
        ModifyListener: {
          input: {
            type: "structure",
            required: [
              "ListenerArn"
            ],
            members: {
              ListenerArn: {},
              Port: {
                type: "integer"
              },
              Protocol: {},
              SslPolicy: {},
              Certificates: {
                shape: "S3"
              },
              DefaultActions: {
                shape: "Sy"
              },
              AlpnPolicy: {
                shape: "S2b"
              },
              MutualAuthentication: {
                shape: "S2d"
              }
            }
          },
          output: {
            resultWrapper: "ModifyListenerResult",
            type: "structure",
            members: {
              Listeners: {
                shape: "S2h"
              }
            }
          }
        },
        ModifyLoadBalancerAttributes: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerArn",
              "Attributes"
            ],
            members: {
              LoadBalancerArn: {},
              Attributes: {
                shape: "S5m"
              }
            }
          },
          output: {
            resultWrapper: "ModifyLoadBalancerAttributesResult",
            type: "structure",
            members: {
              Attributes: {
                shape: "S5m"
              }
            }
          }
        },
        ModifyRule: {
          input: {
            type: "structure",
            required: [
              "RuleArn"
            ],
            members: {
              RuleArn: {},
              Conditions: {
                shape: "S3h"
              },
              Actions: {
                shape: "Sy"
              }
            }
          },
          output: {
            resultWrapper: "ModifyRuleResult",
            type: "structure",
            members: {
              Rules: {
                shape: "S3x"
              }
            }
          }
        },
        ModifyTargetGroup: {
          input: {
            type: "structure",
            required: [
              "TargetGroupArn"
            ],
            members: {
              TargetGroupArn: {},
              HealthCheckProtocol: {},
              HealthCheckPort: {},
              HealthCheckPath: {},
              HealthCheckEnabled: {
                type: "boolean"
              },
              HealthCheckIntervalSeconds: {
                type: "integer"
              },
              HealthCheckTimeoutSeconds: {
                type: "integer"
              },
              HealthyThresholdCount: {
                type: "integer"
              },
              UnhealthyThresholdCount: {
                type: "integer"
              },
              Matcher: {
                shape: "S4b"
              }
            }
          },
          output: {
            resultWrapper: "ModifyTargetGroupResult",
            type: "structure",
            members: {
              TargetGroups: {
                shape: "S4h"
              }
            }
          }
        },
        ModifyTargetGroupAttributes: {
          input: {
            type: "structure",
            required: [
              "TargetGroupArn",
              "Attributes"
            ],
            members: {
              TargetGroupArn: {},
              Attributes: {
                shape: "S6d"
              }
            }
          },
          output: {
            resultWrapper: "ModifyTargetGroupAttributesResult",
            type: "structure",
            members: {
              Attributes: {
                shape: "S6d"
              }
            }
          }
        },
        ModifyTrustStore: {
          input: {
            type: "structure",
            required: [
              "TrustStoreArn",
              "CaCertificatesBundleS3Bucket",
              "CaCertificatesBundleS3Key"
            ],
            members: {
              TrustStoreArn: {},
              CaCertificatesBundleS3Bucket: {},
              CaCertificatesBundleS3Key: {},
              CaCertificatesBundleS3ObjectVersion: {}
            }
          },
          output: {
            resultWrapper: "ModifyTrustStoreResult",
            type: "structure",
            members: {
              TrustStores: {
                shape: "S4n"
              }
            }
          }
        },
        RegisterTargets: {
          input: {
            type: "structure",
            required: [
              "TargetGroupArn",
              "Targets"
            ],
            members: {
              TargetGroupArn: {},
              Targets: {
                shape: "S53"
              }
            }
          },
          output: {
            resultWrapper: "RegisterTargetsResult",
            type: "structure",
            members: {}
          }
        },
        RemoveListenerCertificates: {
          input: {
            type: "structure",
            required: [
              "ListenerArn",
              "Certificates"
            ],
            members: {
              ListenerArn: {},
              Certificates: {
                shape: "S3"
              }
            }
          },
          output: {
            resultWrapper: "RemoveListenerCertificatesResult",
            type: "structure",
            members: {}
          }
        },
        RemoveTags: {
          input: {
            type: "structure",
            required: [
              "ResourceArns",
              "TagKeys"
            ],
            members: {
              ResourceArns: {
                shape: "S9"
              },
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "RemoveTagsResult",
            type: "structure",
            members: {}
          }
        },
        RemoveTrustStoreRevocations: {
          input: {
            type: "structure",
            required: [
              "TrustStoreArn",
              "RevocationIds"
            ],
            members: {
              TrustStoreArn: {},
              RevocationIds: {
                shape: "S74"
              }
            }
          },
          output: {
            resultWrapper: "RemoveTrustStoreRevocationsResult",
            type: "structure",
            members: {}
          }
        },
        SetIpAddressType: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerArn",
              "IpAddressType"
            ],
            members: {
              LoadBalancerArn: {},
              IpAddressType: {}
            }
          },
          output: {
            resultWrapper: "SetIpAddressTypeResult",
            type: "structure",
            members: {
              IpAddressType: {}
            }
          }
        },
        SetRulePriorities: {
          input: {
            type: "structure",
            required: [
              "RulePriorities"
            ],
            members: {
              RulePriorities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RuleArn: {},
                    Priority: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          },
          output: {
            resultWrapper: "SetRulePrioritiesResult",
            type: "structure",
            members: {
              Rules: {
                shape: "S3x"
              }
            }
          }
        },
        SetSecurityGroups: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerArn",
              "SecurityGroups"
            ],
            members: {
              LoadBalancerArn: {},
              SecurityGroups: {
                shape: "S2s"
              },
              EnforceSecurityGroupInboundRulesOnPrivateLinkTraffic: {}
            }
          },
          output: {
            resultWrapper: "SetSecurityGroupsResult",
            type: "structure",
            members: {
              SecurityGroupIds: {
                shape: "S2s"
              },
              EnforceSecurityGroupInboundRulesOnPrivateLinkTraffic: {}
            }
          }
        },
        SetSubnets: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerArn"
            ],
            members: {
              LoadBalancerArn: {},
              Subnets: {
                shape: "S2l"
              },
              SubnetMappings: {
                shape: "S2n"
              },
              IpAddressType: {}
            }
          },
          output: {
            resultWrapper: "SetSubnetsResult",
            type: "structure",
            members: {
              AvailabilityZones: {
                shape: "S38"
              },
              IpAddressType: {}
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {
            type: "structure",
            members: {
              CertificateArn: {},
              IsDefault: {
                type: "boolean"
              }
            }
          }
        },
        S9: {
          type: "list",
          member: {}
        },
        Sb: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sy: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Type"
            ],
            members: {
              Type: {},
              TargetGroupArn: {},
              AuthenticateOidcConfig: {
                type: "structure",
                required: [
                  "Issuer",
                  "AuthorizationEndpoint",
                  "TokenEndpoint",
                  "UserInfoEndpoint",
                  "ClientId"
                ],
                members: {
                  Issuer: {},
                  AuthorizationEndpoint: {},
                  TokenEndpoint: {},
                  UserInfoEndpoint: {},
                  ClientId: {},
                  ClientSecret: {},
                  SessionCookieName: {},
                  Scope: {},
                  SessionTimeout: {
                    type: "long"
                  },
                  AuthenticationRequestExtraParams: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  OnUnauthenticatedRequest: {},
                  UseExistingClientSecret: {
                    type: "boolean"
                  }
                }
              },
              AuthenticateCognitoConfig: {
                type: "structure",
                required: [
                  "UserPoolArn",
                  "UserPoolClientId",
                  "UserPoolDomain"
                ],
                members: {
                  UserPoolArn: {},
                  UserPoolClientId: {},
                  UserPoolDomain: {},
                  SessionCookieName: {},
                  Scope: {},
                  SessionTimeout: {
                    type: "long"
                  },
                  AuthenticationRequestExtraParams: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  OnUnauthenticatedRequest: {}
                }
              },
              Order: {
                type: "integer"
              },
              RedirectConfig: {
                type: "structure",
                required: [
                  "StatusCode"
                ],
                members: {
                  Protocol: {},
                  Port: {},
                  Host: {},
                  Path: {},
                  Query: {},
                  StatusCode: {}
                }
              },
              FixedResponseConfig: {
                type: "structure",
                required: [
                  "StatusCode"
                ],
                members: {
                  MessageBody: {},
                  StatusCode: {},
                  ContentType: {}
                }
              },
              ForwardConfig: {
                type: "structure",
                members: {
                  TargetGroups: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        TargetGroupArn: {},
                        Weight: {
                          type: "integer"
                        }
                      }
                    }
                  },
                  TargetGroupStickinessConfig: {
                    type: "structure",
                    members: {
                      Enabled: {
                        type: "boolean"
                      },
                      DurationSeconds: {
                        type: "integer"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S2b: {
          type: "list",
          member: {}
        },
        S2d: {
          type: "structure",
          members: {
            Mode: {},
            TrustStoreArn: {},
            IgnoreClientCertificateExpiry: {
              type: "boolean"
            }
          }
        },
        S2h: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ListenerArn: {},
              LoadBalancerArn: {},
              Port: {
                type: "integer"
              },
              Protocol: {},
              Certificates: {
                shape: "S3"
              },
              SslPolicy: {},
              DefaultActions: {
                shape: "Sy"
              },
              AlpnPolicy: {
                shape: "S2b"
              },
              MutualAuthentication: {
                shape: "S2d"
              }
            }
          }
        },
        S2l: {
          type: "list",
          member: {}
        },
        S2n: {
          type: "list",
          member: {
            type: "structure",
            members: {
              SubnetId: {},
              AllocationId: {},
              PrivateIPv4Address: {},
              IPv6Address: {}
            }
          }
        },
        S2s: {
          type: "list",
          member: {}
        },
        S2z: {
          type: "list",
          member: {
            type: "structure",
            members: {
              LoadBalancerArn: {},
              DNSName: {},
              CanonicalHostedZoneId: {},
              CreatedTime: {
                type: "timestamp"
              },
              LoadBalancerName: {},
              Scheme: {},
              VpcId: {},
              State: {
                type: "structure",
                members: {
                  Code: {},
                  Reason: {}
                }
              },
              Type: {},
              AvailabilityZones: {
                shape: "S38"
              },
              SecurityGroups: {
                shape: "S2s"
              },
              IpAddressType: {},
              CustomerOwnedIpv4Pool: {},
              EnforceSecurityGroupInboundRulesOnPrivateLinkTraffic: {}
            }
          }
        },
        S38: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ZoneName: {},
              SubnetId: {},
              OutpostId: {},
              LoadBalancerAddresses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    IpAddress: {},
                    AllocationId: {},
                    PrivateIPv4Address: {},
                    IPv6Address: {}
                  }
                }
              }
            }
          }
        },
        S3h: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Field: {},
              Values: {
                shape: "S3k"
              },
              HostHeaderConfig: {
                type: "structure",
                members: {
                  Values: {
                    shape: "S3k"
                  }
                }
              },
              PathPatternConfig: {
                type: "structure",
                members: {
                  Values: {
                    shape: "S3k"
                  }
                }
              },
              HttpHeaderConfig: {
                type: "structure",
                members: {
                  HttpHeaderName: {},
                  Values: {
                    shape: "S3k"
                  }
                }
              },
              QueryStringConfig: {
                type: "structure",
                members: {
                  Values: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Key: {},
                        Value: {}
                      }
                    }
                  }
                }
              },
              HttpRequestMethodConfig: {
                type: "structure",
                members: {
                  Values: {
                    shape: "S3k"
                  }
                }
              },
              SourceIpConfig: {
                type: "structure",
                members: {
                  Values: {
                    shape: "S3k"
                  }
                }
              }
            }
          }
        },
        S3k: {
          type: "list",
          member: {}
        },
        S3x: {
          type: "list",
          member: {
            type: "structure",
            members: {
              RuleArn: {},
              Priority: {},
              Conditions: {
                shape: "S3h"
              },
              Actions: {
                shape: "Sy"
              },
              IsDefault: {
                type: "boolean"
              }
            }
          }
        },
        S4b: {
          type: "structure",
          members: {
            HttpCode: {},
            GrpcCode: {}
          }
        },
        S4h: {
          type: "list",
          member: {
            type: "structure",
            members: {
              TargetGroupArn: {},
              TargetGroupName: {},
              Protocol: {},
              Port: {
                type: "integer"
              },
              VpcId: {},
              HealthCheckProtocol: {},
              HealthCheckPort: {},
              HealthCheckEnabled: {
                type: "boolean"
              },
              HealthCheckIntervalSeconds: {
                type: "integer"
              },
              HealthCheckTimeoutSeconds: {
                type: "integer"
              },
              HealthyThresholdCount: {
                type: "integer"
              },
              UnhealthyThresholdCount: {
                type: "integer"
              },
              HealthCheckPath: {},
              Matcher: {
                shape: "S4b"
              },
              LoadBalancerArns: {
                shape: "S4j"
              },
              TargetType: {},
              ProtocolVersion: {},
              IpAddressType: {}
            }
          }
        },
        S4j: {
          type: "list",
          member: {}
        },
        S4n: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              TrustStoreArn: {},
              Status: {},
              NumberOfCaCertificates: {
                type: "integer"
              },
              TotalRevokedEntries: {
                type: "long"
              }
            }
          }
        },
        S53: {
          type: "list",
          member: {
            shape: "S54"
          }
        },
        S54: {
          type: "structure",
          required: [
            "Id"
          ],
          members: {
            Id: {},
            Port: {
              type: "integer"
            },
            AvailabilityZone: {}
          }
        },
        S5m: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S6d: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S74: {
          type: "list",
          member: {
            type: "long"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/elasticloadbalancingv2-2015-12-01.paginators.json
var require_elasticloadbalancingv2_2015_12_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/elasticloadbalancingv2-2015-12-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeListeners: {
          input_token: "Marker",
          output_token: "NextMarker",
          result_key: "Listeners"
        },
        DescribeLoadBalancers: {
          input_token: "Marker",
          output_token: "NextMarker",
          result_key: "LoadBalancers"
        },
        DescribeTargetGroups: {
          input_token: "Marker",
          output_token: "NextMarker",
          result_key: "TargetGroups"
        },
        DescribeTrustStoreAssociations: {
          input_token: "Marker",
          limit_key: "PageSize",
          output_token: "NextMarker"
        },
        DescribeTrustStoreRevocations: {
          input_token: "Marker",
          limit_key: "PageSize",
          output_token: "NextMarker"
        },
        DescribeTrustStores: {
          input_token: "Marker",
          limit_key: "PageSize",
          output_token: "NextMarker"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/elasticloadbalancingv2-2015-12-01.waiters2.json
var require_elasticloadbalancingv2_2015_12_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/elasticloadbalancingv2-2015-12-01.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        LoadBalancerExists: {
          delay: 15,
          operation: "DescribeLoadBalancers",
          maxAttempts: 40,
          acceptors: [
            {
              matcher: "status",
              expected: 200,
              state: "success"
            },
            {
              matcher: "error",
              expected: "LoadBalancerNotFound",
              state: "retry"
            }
          ]
        },
        LoadBalancerAvailable: {
          delay: 15,
          operation: "DescribeLoadBalancers",
          maxAttempts: 40,
          acceptors: [
            {
              state: "success",
              matcher: "pathAll",
              argument: "LoadBalancers[].State.Code",
              expected: "active"
            },
            {
              state: "retry",
              matcher: "pathAny",
              argument: "LoadBalancers[].State.Code",
              expected: "provisioning"
            },
            {
              state: "retry",
              matcher: "error",
              expected: "LoadBalancerNotFound"
            }
          ]
        },
        LoadBalancersDeleted: {
          delay: 15,
          operation: "DescribeLoadBalancers",
          maxAttempts: 40,
          acceptors: [
            {
              state: "retry",
              matcher: "pathAll",
              argument: "LoadBalancers[].State.Code",
              expected: "active"
            },
            {
              matcher: "error",
              expected: "LoadBalancerNotFound",
              state: "success"
            }
          ]
        },
        TargetInService: {
          delay: 15,
          maxAttempts: 40,
          operation: "DescribeTargetHealth",
          acceptors: [
            {
              argument: "TargetHealthDescriptions[].TargetHealth.State",
              expected: "healthy",
              matcher: "pathAll",
              state: "success"
            },
            {
              matcher: "error",
              expected: "InvalidInstance",
              state: "retry"
            }
          ]
        },
        TargetDeregistered: {
          delay: 15,
          maxAttempts: 40,
          operation: "DescribeTargetHealth",
          acceptors: [
            {
              matcher: "error",
              expected: "InvalidTarget",
              state: "success"
            },
            {
              argument: "TargetHealthDescriptions[].TargetHealth.State",
              expected: "unused",
              matcher: "pathAll",
              state: "success"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/elbv2.js
var require_elbv2 = __commonJS({
  "node_modules/aws-sdk/clients/elbv2.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["elbv2"] = {};
    AWS2.ELBv2 = Service.defineService("elbv2", ["2015-12-01"]);
    Object.defineProperty(apiLoader.services["elbv2"], "2015-12-01", {
      get: function get() {
        var model = require_elasticloadbalancingv2_2015_12_01_min();
        model.paginators = require_elasticloadbalancingv2_2015_12_01_paginators().pagination;
        model.waiters = require_elasticloadbalancingv2_2015_12_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ELBv2;
  }
});

// node_modules/aws-sdk/apis/elasticmapreduce-2009-03-31.min.json
var require_elasticmapreduce_2009_03_31_min = __commonJS({
  "node_modules/aws-sdk/apis/elasticmapreduce-2009-03-31.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2009-03-31",
        endpointPrefix: "elasticmapreduce",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Amazon EMR",
        serviceFullName: "Amazon EMR",
        serviceId: "EMR",
        signatureVersion: "v4",
        targetPrefix: "ElasticMapReduce",
        uid: "elasticmapreduce-2009-03-31"
      },
      operations: {
        AddInstanceFleet: {
          input: {
            type: "structure",
            required: [
              "ClusterId",
              "InstanceFleet"
            ],
            members: {
              ClusterId: {},
              InstanceFleet: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ClusterId: {},
              InstanceFleetId: {},
              ClusterArn: {}
            }
          }
        },
        AddInstanceGroups: {
          input: {
            type: "structure",
            required: [
              "InstanceGroups",
              "JobFlowId"
            ],
            members: {
              InstanceGroups: {
                shape: "S11"
              },
              JobFlowId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobFlowId: {},
              InstanceGroupIds: {
                type: "list",
                member: {}
              },
              ClusterArn: {}
            }
          }
        },
        AddJobFlowSteps: {
          input: {
            type: "structure",
            required: [
              "JobFlowId",
              "Steps"
            ],
            members: {
              JobFlowId: {},
              Steps: {
                shape: "S1m"
              },
              ExecutionRoleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StepIds: {
                shape: "S1v"
              }
            }
          }
        },
        AddTags: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "Tags"
            ],
            members: {
              ResourceId: {},
              Tags: {
                shape: "S1y"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CancelSteps: {
          input: {
            type: "structure",
            required: [
              "ClusterId",
              "StepIds"
            ],
            members: {
              ClusterId: {},
              StepIds: {
                shape: "S1v"
              },
              StepCancellationOption: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CancelStepsInfoList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StepId: {},
                    Status: {},
                    Reason: {}
                  }
                }
              }
            }
          }
        },
        CreateSecurityConfiguration: {
          input: {
            type: "structure",
            required: [
              "Name",
              "SecurityConfiguration"
            ],
            members: {
              Name: {},
              SecurityConfiguration: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Name",
              "CreationDateTime"
            ],
            members: {
              Name: {},
              CreationDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        CreateStudio: {
          input: {
            type: "structure",
            required: [
              "Name",
              "AuthMode",
              "VpcId",
              "SubnetIds",
              "ServiceRole",
              "WorkspaceSecurityGroupId",
              "EngineSecurityGroupId",
              "DefaultS3Location"
            ],
            members: {
              Name: {},
              Description: {},
              AuthMode: {},
              VpcId: {},
              SubnetIds: {
                shape: "S2d"
              },
              ServiceRole: {},
              UserRole: {},
              WorkspaceSecurityGroupId: {},
              EngineSecurityGroupId: {},
              DefaultS3Location: {},
              IdpAuthUrl: {},
              IdpRelayStateParameterName: {},
              Tags: {
                shape: "S1y"
              },
              TrustedIdentityPropagationEnabled: {
                type: "boolean"
              },
              IdcUserAssignment: {},
              IdcInstanceArn: {},
              EncryptionKeyArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StudioId: {},
              Url: {}
            }
          }
        },
        CreateStudioSessionMapping: {
          input: {
            type: "structure",
            required: [
              "StudioId",
              "IdentityType",
              "SessionPolicyArn"
            ],
            members: {
              StudioId: {},
              IdentityId: {},
              IdentityName: {},
              IdentityType: {},
              SessionPolicyArn: {}
            }
          }
        },
        DeleteSecurityConfiguration: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteStudio: {
          input: {
            type: "structure",
            required: [
              "StudioId"
            ],
            members: {
              StudioId: {}
            }
          }
        },
        DeleteStudioSessionMapping: {
          input: {
            type: "structure",
            required: [
              "StudioId",
              "IdentityType"
            ],
            members: {
              StudioId: {},
              IdentityId: {},
              IdentityName: {},
              IdentityType: {}
            }
          }
        },
        DescribeCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                type: "structure",
                members: {
                  Id: {},
                  Name: {},
                  Status: {
                    shape: "S2q"
                  },
                  Ec2InstanceAttributes: {
                    type: "structure",
                    members: {
                      Ec2KeyName: {},
                      Ec2SubnetId: {},
                      RequestedEc2SubnetIds: {
                        shape: "S2z"
                      },
                      Ec2AvailabilityZone: {},
                      RequestedEc2AvailabilityZones: {
                        shape: "S2z"
                      },
                      IamInstanceProfile: {},
                      EmrManagedMasterSecurityGroup: {},
                      EmrManagedSlaveSecurityGroup: {},
                      ServiceAccessSecurityGroup: {},
                      AdditionalMasterSecurityGroups: {
                        shape: "S30"
                      },
                      AdditionalSlaveSecurityGroups: {
                        shape: "S30"
                      }
                    }
                  },
                  InstanceCollectionType: {},
                  LogUri: {},
                  LogEncryptionKmsKeyId: {},
                  RequestedAmiVersion: {},
                  RunningAmiVersion: {},
                  ReleaseLabel: {},
                  AutoTerminate: {
                    type: "boolean"
                  },
                  TerminationProtected: {
                    type: "boolean"
                  },
                  VisibleToAllUsers: {
                    type: "boolean"
                  },
                  Applications: {
                    shape: "S33"
                  },
                  Tags: {
                    shape: "S1y"
                  },
                  ServiceRole: {},
                  NormalizedInstanceHours: {
                    type: "integer"
                  },
                  MasterPublicDnsName: {},
                  Configurations: {
                    shape: "Si"
                  },
                  SecurityConfiguration: {},
                  AutoScalingRole: {},
                  ScaleDownBehavior: {},
                  CustomAmiId: {},
                  EbsRootVolumeSize: {
                    type: "integer"
                  },
                  RepoUpgradeOnBoot: {},
                  KerberosAttributes: {
                    shape: "S37"
                  },
                  ClusterArn: {},
                  OutpostArn: {},
                  StepConcurrencyLevel: {
                    type: "integer"
                  },
                  PlacementGroups: {
                    shape: "S39"
                  },
                  OSReleaseLabel: {},
                  EbsRootVolumeIops: {
                    type: "integer"
                  },
                  EbsRootVolumeThroughput: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        DescribeJobFlows: {
          input: {
            type: "structure",
            members: {
              CreatedAfter: {
                type: "timestamp"
              },
              CreatedBefore: {
                type: "timestamp"
              },
              JobFlowIds: {
                shape: "S1t"
              },
              JobFlowStates: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobFlows: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "JobFlowId",
                    "Name",
                    "ExecutionStatusDetail",
                    "Instances"
                  ],
                  members: {
                    JobFlowId: {},
                    Name: {},
                    LogUri: {},
                    LogEncryptionKmsKeyId: {},
                    AmiVersion: {},
                    ExecutionStatusDetail: {
                      type: "structure",
                      required: [
                        "State",
                        "CreationDateTime"
                      ],
                      members: {
                        State: {},
                        CreationDateTime: {
                          type: "timestamp"
                        },
                        StartDateTime: {
                          type: "timestamp"
                        },
                        ReadyDateTime: {
                          type: "timestamp"
                        },
                        EndDateTime: {
                          type: "timestamp"
                        },
                        LastStateChangeReason: {}
                      }
                    },
                    Instances: {
                      type: "structure",
                      required: [
                        "MasterInstanceType",
                        "SlaveInstanceType",
                        "InstanceCount"
                      ],
                      members: {
                        MasterInstanceType: {},
                        MasterPublicDnsName: {},
                        MasterInstanceId: {},
                        SlaveInstanceType: {},
                        InstanceCount: {
                          type: "integer"
                        },
                        InstanceGroups: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "Market",
                              "InstanceRole",
                              "InstanceType",
                              "InstanceRequestCount",
                              "InstanceRunningCount",
                              "State",
                              "CreationDateTime"
                            ],
                            members: {
                              InstanceGroupId: {},
                              Name: {},
                              Market: {},
                              InstanceRole: {},
                              BidPrice: {},
                              InstanceType: {},
                              InstanceRequestCount: {
                                type: "integer"
                              },
                              InstanceRunningCount: {
                                type: "integer"
                              },
                              State: {},
                              LastStateChangeReason: {},
                              CreationDateTime: {
                                type: "timestamp"
                              },
                              StartDateTime: {
                                type: "timestamp"
                              },
                              ReadyDateTime: {
                                type: "timestamp"
                              },
                              EndDateTime: {
                                type: "timestamp"
                              },
                              CustomAmiId: {}
                            }
                          }
                        },
                        NormalizedInstanceHours: {
                          type: "integer"
                        },
                        Ec2KeyName: {},
                        Ec2SubnetId: {},
                        Placement: {
                          shape: "S3n"
                        },
                        KeepJobFlowAliveWhenNoSteps: {
                          type: "boolean"
                        },
                        TerminationProtected: {
                          type: "boolean"
                        },
                        HadoopVersion: {}
                      }
                    },
                    Steps: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "StepConfig",
                          "ExecutionStatusDetail"
                        ],
                        members: {
                          StepConfig: {
                            shape: "S1n"
                          },
                          ExecutionStatusDetail: {
                            type: "structure",
                            required: [
                              "State",
                              "CreationDateTime"
                            ],
                            members: {
                              State: {},
                              CreationDateTime: {
                                type: "timestamp"
                              },
                              StartDateTime: {
                                type: "timestamp"
                              },
                              EndDateTime: {
                                type: "timestamp"
                              },
                              LastStateChangeReason: {}
                            }
                          }
                        }
                      }
                    },
                    BootstrapActions: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          BootstrapActionConfig: {
                            shape: "S3u"
                          }
                        }
                      }
                    },
                    SupportedProducts: {
                      shape: "S3w"
                    },
                    VisibleToAllUsers: {
                      type: "boolean"
                    },
                    JobFlowRole: {},
                    ServiceRole: {},
                    AutoScalingRole: {},
                    ScaleDownBehavior: {}
                  }
                }
              }
            }
          },
          deprecated: true
        },
        DescribeNotebookExecution: {
          input: {
            type: "structure",
            required: [
              "NotebookExecutionId"
            ],
            members: {
              NotebookExecutionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NotebookExecution: {
                type: "structure",
                members: {
                  NotebookExecutionId: {},
                  EditorId: {},
                  ExecutionEngine: {
                    shape: "S40"
                  },
                  NotebookExecutionName: {},
                  NotebookParams: {},
                  Status: {},
                  StartTime: {
                    type: "timestamp"
                  },
                  EndTime: {
                    type: "timestamp"
                  },
                  Arn: {},
                  OutputNotebookURI: {},
                  LastStateChangeReason: {},
                  NotebookInstanceSecurityGroupId: {},
                  Tags: {
                    shape: "S1y"
                  },
                  NotebookS3Location: {
                    shape: "S44"
                  },
                  OutputNotebookS3Location: {
                    type: "structure",
                    members: {
                      Bucket: {},
                      Key: {}
                    }
                  },
                  OutputNotebookFormat: {},
                  EnvironmentVariables: {
                    shape: "S48"
                  }
                }
              }
            }
          }
        },
        DescribeReleaseLabel: {
          input: {
            type: "structure",
            members: {
              ReleaseLabel: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReleaseLabel: {},
              Applications: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Version: {}
                  }
                }
              },
              NextToken: {},
              AvailableOSReleases: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Label: {}
                  }
                }
              }
            }
          }
        },
        DescribeSecurityConfiguration: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              SecurityConfiguration: {},
              CreationDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeStep: {
          input: {
            type: "structure",
            required: [
              "ClusterId",
              "StepId"
            ],
            members: {
              ClusterId: {},
              StepId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Step: {
                type: "structure",
                members: {
                  Id: {},
                  Name: {},
                  Config: {
                    shape: "S4l"
                  },
                  ActionOnFailure: {},
                  Status: {
                    shape: "S4m"
                  },
                  ExecutionRoleArn: {}
                }
              }
            }
          }
        },
        DescribeStudio: {
          input: {
            type: "structure",
            required: [
              "StudioId"
            ],
            members: {
              StudioId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Studio: {
                type: "structure",
                members: {
                  StudioId: {},
                  StudioArn: {},
                  Name: {},
                  Description: {},
                  AuthMode: {},
                  VpcId: {},
                  SubnetIds: {
                    shape: "S2d"
                  },
                  ServiceRole: {},
                  UserRole: {},
                  WorkspaceSecurityGroupId: {},
                  EngineSecurityGroupId: {},
                  Url: {},
                  CreationTime: {
                    type: "timestamp"
                  },
                  DefaultS3Location: {},
                  IdpAuthUrl: {},
                  IdpRelayStateParameterName: {},
                  Tags: {
                    shape: "S1y"
                  },
                  IdcInstanceArn: {},
                  TrustedIdentityPropagationEnabled: {
                    type: "boolean"
                  },
                  IdcUserAssignment: {},
                  EncryptionKeyArn: {}
                }
              }
            }
          }
        },
        GetAutoTerminationPolicy: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AutoTerminationPolicy: {
                shape: "S4x"
              }
            }
          }
        },
        GetBlockPublicAccessConfiguration: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "BlockPublicAccessConfiguration",
              "BlockPublicAccessConfigurationMetadata"
            ],
            members: {
              BlockPublicAccessConfiguration: {
                shape: "S51"
              },
              BlockPublicAccessConfigurationMetadata: {
                type: "structure",
                required: [
                  "CreationDateTime",
                  "CreatedByArn"
                ],
                members: {
                  CreationDateTime: {
                    type: "timestamp"
                  },
                  CreatedByArn: {}
                }
              }
            }
          }
        },
        GetClusterSessionCredentials: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {},
              ExecutionRoleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Credentials: {
                type: "structure",
                members: {
                  UsernamePassword: {
                    type: "structure",
                    members: {
                      Username: {},
                      Password: {}
                    },
                    sensitive: true
                  }
                },
                union: true
              },
              ExpiresAt: {
                type: "timestamp"
              }
            }
          }
        },
        GetManagedScalingPolicy: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ManagedScalingPolicy: {
                shape: "S5c"
              }
            }
          }
        },
        GetStudioSessionMapping: {
          input: {
            type: "structure",
            required: [
              "StudioId",
              "IdentityType"
            ],
            members: {
              StudioId: {},
              IdentityId: {},
              IdentityName: {},
              IdentityType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SessionMapping: {
                type: "structure",
                members: {
                  StudioId: {},
                  IdentityId: {},
                  IdentityName: {},
                  IdentityType: {},
                  SessionPolicyArn: {},
                  CreationTime: {
                    type: "timestamp"
                  },
                  LastModifiedTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        ListBootstrapActions: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {},
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BootstrapActions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    ScriptPath: {},
                    Args: {
                      shape: "S30"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ListClusters: {
          input: {
            type: "structure",
            members: {
              CreatedAfter: {
                type: "timestamp"
              },
              CreatedBefore: {
                type: "timestamp"
              },
              ClusterStates: {
                type: "list",
                member: {}
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Clusters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Name: {},
                    Status: {
                      shape: "S2q"
                    },
                    NormalizedInstanceHours: {
                      type: "integer"
                    },
                    ClusterArn: {},
                    OutpostArn: {}
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ListInstanceFleets: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {},
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceFleets: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Name: {},
                    Status: {
                      type: "structure",
                      members: {
                        State: {},
                        StateChangeReason: {
                          type: "structure",
                          members: {
                            Code: {},
                            Message: {}
                          }
                        },
                        Timeline: {
                          type: "structure",
                          members: {
                            CreationDateTime: {
                              type: "timestamp"
                            },
                            ReadyDateTime: {
                              type: "timestamp"
                            },
                            EndDateTime: {
                              type: "timestamp"
                            }
                          }
                        }
                      }
                    },
                    InstanceFleetType: {},
                    TargetOnDemandCapacity: {
                      type: "integer"
                    },
                    TargetSpotCapacity: {
                      type: "integer"
                    },
                    ProvisionedOnDemandCapacity: {
                      type: "integer"
                    },
                    ProvisionedSpotCapacity: {
                      type: "integer"
                    },
                    InstanceTypeSpecifications: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          InstanceType: {},
                          WeightedCapacity: {
                            type: "integer"
                          },
                          BidPrice: {},
                          BidPriceAsPercentageOfOnDemandPrice: {
                            type: "double"
                          },
                          Configurations: {
                            shape: "Si"
                          },
                          EbsBlockDevices: {
                            shape: "S63"
                          },
                          EbsOptimized: {
                            type: "boolean"
                          },
                          CustomAmiId: {}
                        }
                      }
                    },
                    LaunchSpecifications: {
                      shape: "Sl"
                    },
                    ResizeSpecifications: {
                      shape: "Su"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ListInstanceGroups: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {},
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Name: {},
                    Market: {},
                    InstanceGroupType: {},
                    BidPrice: {},
                    InstanceType: {},
                    RequestedInstanceCount: {
                      type: "integer"
                    },
                    RunningInstanceCount: {
                      type: "integer"
                    },
                    Status: {
                      type: "structure",
                      members: {
                        State: {},
                        StateChangeReason: {
                          type: "structure",
                          members: {
                            Code: {},
                            Message: {}
                          }
                        },
                        Timeline: {
                          type: "structure",
                          members: {
                            CreationDateTime: {
                              type: "timestamp"
                            },
                            ReadyDateTime: {
                              type: "timestamp"
                            },
                            EndDateTime: {
                              type: "timestamp"
                            }
                          }
                        }
                      }
                    },
                    Configurations: {
                      shape: "Si"
                    },
                    ConfigurationsVersion: {
                      type: "long"
                    },
                    LastSuccessfullyAppliedConfigurations: {
                      shape: "Si"
                    },
                    LastSuccessfullyAppliedConfigurationsVersion: {
                      type: "long"
                    },
                    EbsBlockDevices: {
                      shape: "S63"
                    },
                    EbsOptimized: {
                      type: "boolean"
                    },
                    ShrinkPolicy: {
                      shape: "S6f"
                    },
                    AutoScalingPolicy: {
                      shape: "S6j"
                    },
                    CustomAmiId: {}
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ListInstances: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {},
              InstanceGroupId: {},
              InstanceGroupTypes: {
                type: "list",
                member: {}
              },
              InstanceFleetId: {},
              InstanceFleetType: {},
              InstanceStates: {
                type: "list",
                member: {}
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Instances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Ec2InstanceId: {},
                    PublicDnsName: {},
                    PublicIpAddress: {},
                    PrivateDnsName: {},
                    PrivateIpAddress: {},
                    Status: {
                      type: "structure",
                      members: {
                        State: {},
                        StateChangeReason: {
                          type: "structure",
                          members: {
                            Code: {},
                            Message: {}
                          }
                        },
                        Timeline: {
                          type: "structure",
                          members: {
                            CreationDateTime: {
                              type: "timestamp"
                            },
                            ReadyDateTime: {
                              type: "timestamp"
                            },
                            EndDateTime: {
                              type: "timestamp"
                            }
                          }
                        }
                      }
                    },
                    InstanceGroupId: {},
                    InstanceFleetId: {},
                    Market: {},
                    InstanceType: {},
                    EbsVolumes: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Device: {},
                          VolumeId: {}
                        }
                      }
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ListNotebookExecutions: {
          input: {
            type: "structure",
            members: {
              EditorId: {},
              Status: {},
              From: {
                type: "timestamp"
              },
              To: {
                type: "timestamp"
              },
              Marker: {},
              ExecutionEngineId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NotebookExecutions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    NotebookExecutionId: {},
                    EditorId: {},
                    NotebookExecutionName: {},
                    Status: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    NotebookS3Location: {
                      shape: "S44"
                    },
                    ExecutionEngineId: {}
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ListReleaseLabels: {
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "structure",
                members: {
                  Prefix: {},
                  Application: {}
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReleaseLabels: {
                shape: "S30"
              },
              NextToken: {}
            }
          }
        },
        ListSecurityConfigurations: {
          input: {
            type: "structure",
            members: {
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SecurityConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    CreationDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ListSteps: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {},
              StepStates: {
                type: "list",
                member: {}
              },
              StepIds: {
                shape: "S1t"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Steps: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Name: {},
                    Config: {
                      shape: "S4l"
                    },
                    ActionOnFailure: {},
                    Status: {
                      shape: "S4m"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ListStudioSessionMappings: {
          input: {
            type: "structure",
            members: {
              StudioId: {},
              IdentityType: {},
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SessionMappings: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StudioId: {},
                    IdentityId: {},
                    IdentityName: {},
                    IdentityType: {},
                    SessionPolicyArn: {},
                    CreationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ListStudios: {
          input: {
            type: "structure",
            members: {
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Studios: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StudioId: {},
                    Name: {},
                    VpcId: {},
                    Description: {},
                    Url: {},
                    AuthMode: {},
                    CreationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ListSupportedInstanceTypes: {
          input: {
            type: "structure",
            required: [
              "ReleaseLabel"
            ],
            members: {
              ReleaseLabel: {},
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SupportedInstanceTypes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    MemoryGB: {
                      type: "float"
                    },
                    StorageGB: {
                      type: "integer"
                    },
                    VCPU: {
                      type: "integer"
                    },
                    Is64BitsOnly: {
                      type: "boolean"
                    },
                    InstanceFamilyId: {},
                    EbsOptimizedAvailable: {
                      type: "boolean"
                    },
                    EbsOptimizedByDefault: {
                      type: "boolean"
                    },
                    NumberOfDisks: {
                      type: "integer"
                    },
                    EbsStorageOnly: {
                      type: "boolean"
                    },
                    Architecture: {}
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ModifyCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {},
              StepConcurrencyLevel: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StepConcurrencyLevel: {
                type: "integer"
              }
            }
          }
        },
        ModifyInstanceFleet: {
          input: {
            type: "structure",
            required: [
              "ClusterId",
              "InstanceFleet"
            ],
            members: {
              ClusterId: {},
              InstanceFleet: {
                type: "structure",
                required: [
                  "InstanceFleetId"
                ],
                members: {
                  InstanceFleetId: {},
                  TargetOnDemandCapacity: {
                    type: "integer"
                  },
                  TargetSpotCapacity: {
                    type: "integer"
                  },
                  ResizeSpecifications: {
                    shape: "Su"
                  }
                }
              }
            }
          }
        },
        ModifyInstanceGroups: {
          input: {
            type: "structure",
            members: {
              ClusterId: {},
              InstanceGroups: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "InstanceGroupId"
                  ],
                  members: {
                    InstanceGroupId: {},
                    InstanceCount: {
                      type: "integer"
                    },
                    EC2InstanceIdsToTerminate: {
                      type: "list",
                      member: {}
                    },
                    ShrinkPolicy: {
                      shape: "S6f"
                    },
                    ReconfigurationType: {},
                    Configurations: {
                      shape: "Si"
                    }
                  }
                }
              }
            }
          }
        },
        PutAutoScalingPolicy: {
          input: {
            type: "structure",
            required: [
              "ClusterId",
              "InstanceGroupId",
              "AutoScalingPolicy"
            ],
            members: {
              ClusterId: {},
              InstanceGroupId: {},
              AutoScalingPolicy: {
                shape: "S15"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ClusterId: {},
              InstanceGroupId: {},
              AutoScalingPolicy: {
                shape: "S6j"
              },
              ClusterArn: {}
            }
          }
        },
        PutAutoTerminationPolicy: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {},
              AutoTerminationPolicy: {
                shape: "S4x"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutBlockPublicAccessConfiguration: {
          input: {
            type: "structure",
            required: [
              "BlockPublicAccessConfiguration"
            ],
            members: {
              BlockPublicAccessConfiguration: {
                shape: "S51"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutManagedScalingPolicy: {
          input: {
            type: "structure",
            required: [
              "ClusterId",
              "ManagedScalingPolicy"
            ],
            members: {
              ClusterId: {},
              ManagedScalingPolicy: {
                shape: "S5c"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RemoveAutoScalingPolicy: {
          input: {
            type: "structure",
            required: [
              "ClusterId",
              "InstanceGroupId"
            ],
            members: {
              ClusterId: {},
              InstanceGroupId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RemoveAutoTerminationPolicy: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RemoveManagedScalingPolicy: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RemoveTags: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "TagKeys"
            ],
            members: {
              ResourceId: {},
              TagKeys: {
                shape: "S30"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RunJobFlow: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Instances"
            ],
            members: {
              Name: {},
              LogUri: {},
              LogEncryptionKmsKeyId: {},
              AdditionalInfo: {},
              AmiVersion: {},
              ReleaseLabel: {},
              Instances: {
                type: "structure",
                members: {
                  MasterInstanceType: {},
                  SlaveInstanceType: {},
                  InstanceCount: {
                    type: "integer"
                  },
                  InstanceGroups: {
                    shape: "S11"
                  },
                  InstanceFleets: {
                    type: "list",
                    member: {
                      shape: "S3"
                    }
                  },
                  Ec2KeyName: {},
                  Placement: {
                    shape: "S3n"
                  },
                  KeepJobFlowAliveWhenNoSteps: {
                    type: "boolean"
                  },
                  TerminationProtected: {
                    type: "boolean"
                  },
                  HadoopVersion: {},
                  Ec2SubnetId: {},
                  Ec2SubnetIds: {
                    shape: "S2z"
                  },
                  EmrManagedMasterSecurityGroup: {},
                  EmrManagedSlaveSecurityGroup: {},
                  ServiceAccessSecurityGroup: {},
                  AdditionalMasterSecurityGroups: {
                    shape: "S8m"
                  },
                  AdditionalSlaveSecurityGroups: {
                    shape: "S8m"
                  }
                }
              },
              Steps: {
                shape: "S1m"
              },
              BootstrapActions: {
                type: "list",
                member: {
                  shape: "S3u"
                }
              },
              SupportedProducts: {
                shape: "S3w"
              },
              NewSupportedProducts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Args: {
                      shape: "S1t"
                    }
                  }
                }
              },
              Applications: {
                shape: "S33"
              },
              Configurations: {
                shape: "Si"
              },
              VisibleToAllUsers: {
                type: "boolean"
              },
              JobFlowRole: {},
              ServiceRole: {},
              Tags: {
                shape: "S1y"
              },
              SecurityConfiguration: {},
              AutoScalingRole: {},
              ScaleDownBehavior: {},
              CustomAmiId: {},
              EbsRootVolumeSize: {
                type: "integer"
              },
              RepoUpgradeOnBoot: {},
              KerberosAttributes: {
                shape: "S37"
              },
              StepConcurrencyLevel: {
                type: "integer"
              },
              ManagedScalingPolicy: {
                shape: "S5c"
              },
              PlacementGroupConfigs: {
                shape: "S39"
              },
              AutoTerminationPolicy: {
                shape: "S4x"
              },
              OSReleaseLabel: {},
              EbsRootVolumeIops: {
                type: "integer"
              },
              EbsRootVolumeThroughput: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobFlowId: {},
              ClusterArn: {}
            }
          }
        },
        SetKeepJobFlowAliveWhenNoSteps: {
          input: {
            type: "structure",
            required: [
              "JobFlowIds",
              "KeepJobFlowAliveWhenNoSteps"
            ],
            members: {
              JobFlowIds: {
                shape: "S1t"
              },
              KeepJobFlowAliveWhenNoSteps: {
                type: "boolean"
              }
            }
          }
        },
        SetTerminationProtection: {
          input: {
            type: "structure",
            required: [
              "JobFlowIds",
              "TerminationProtected"
            ],
            members: {
              JobFlowIds: {
                shape: "S1t"
              },
              TerminationProtected: {
                type: "boolean"
              }
            }
          }
        },
        SetVisibleToAllUsers: {
          input: {
            type: "structure",
            required: [
              "JobFlowIds",
              "VisibleToAllUsers"
            ],
            members: {
              JobFlowIds: {
                shape: "S1t"
              },
              VisibleToAllUsers: {
                type: "boolean"
              }
            }
          }
        },
        StartNotebookExecution: {
          input: {
            type: "structure",
            required: [
              "ExecutionEngine",
              "ServiceRole"
            ],
            members: {
              EditorId: {},
              RelativePath: {},
              NotebookExecutionName: {},
              NotebookParams: {},
              ExecutionEngine: {
                shape: "S40"
              },
              ServiceRole: {},
              NotebookInstanceSecurityGroupId: {},
              Tags: {
                shape: "S1y"
              },
              NotebookS3Location: {
                type: "structure",
                members: {
                  Bucket: {},
                  Key: {}
                }
              },
              OutputNotebookS3Location: {
                type: "structure",
                members: {
                  Bucket: {},
                  Key: {}
                }
              },
              OutputNotebookFormat: {},
              EnvironmentVariables: {
                shape: "S48"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NotebookExecutionId: {}
            }
          }
        },
        StopNotebookExecution: {
          input: {
            type: "structure",
            required: [
              "NotebookExecutionId"
            ],
            members: {
              NotebookExecutionId: {}
            }
          }
        },
        TerminateJobFlows: {
          input: {
            type: "structure",
            required: [
              "JobFlowIds"
            ],
            members: {
              JobFlowIds: {
                shape: "S1t"
              }
            }
          }
        },
        UpdateStudio: {
          input: {
            type: "structure",
            required: [
              "StudioId"
            ],
            members: {
              StudioId: {},
              Name: {},
              Description: {},
              SubnetIds: {
                shape: "S2d"
              },
              DefaultS3Location: {},
              EncryptionKeyArn: {}
            }
          }
        },
        UpdateStudioSessionMapping: {
          input: {
            type: "structure",
            required: [
              "StudioId",
              "IdentityType",
              "SessionPolicyArn"
            ],
            members: {
              StudioId: {},
              IdentityId: {},
              IdentityName: {},
              IdentityType: {},
              SessionPolicyArn: {}
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          required: [
            "InstanceFleetType"
          ],
          members: {
            Name: {},
            InstanceFleetType: {},
            TargetOnDemandCapacity: {
              type: "integer"
            },
            TargetSpotCapacity: {
              type: "integer"
            },
            InstanceTypeConfigs: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "InstanceType"
                ],
                members: {
                  InstanceType: {},
                  WeightedCapacity: {
                    type: "integer"
                  },
                  BidPrice: {},
                  BidPriceAsPercentageOfOnDemandPrice: {
                    type: "double"
                  },
                  EbsConfiguration: {
                    shape: "Sa"
                  },
                  Configurations: {
                    shape: "Si"
                  },
                  CustomAmiId: {}
                }
              }
            },
            LaunchSpecifications: {
              shape: "Sl"
            },
            ResizeSpecifications: {
              shape: "Su"
            }
          }
        },
        Sa: {
          type: "structure",
          members: {
            EbsBlockDeviceConfigs: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "VolumeSpecification"
                ],
                members: {
                  VolumeSpecification: {
                    shape: "Sd"
                  },
                  VolumesPerInstance: {
                    type: "integer"
                  }
                }
              }
            },
            EbsOptimized: {
              type: "boolean"
            }
          }
        },
        Sd: {
          type: "structure",
          required: [
            "VolumeType",
            "SizeInGB"
          ],
          members: {
            VolumeType: {},
            Iops: {
              type: "integer"
            },
            SizeInGB: {
              type: "integer"
            },
            Throughput: {
              type: "integer"
            }
          }
        },
        Si: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Classification: {},
              Configurations: {
                shape: "Si"
              },
              Properties: {
                shape: "Sk"
              }
            }
          }
        },
        Sk: {
          type: "map",
          key: {},
          value: {}
        },
        Sl: {
          type: "structure",
          members: {
            SpotSpecification: {
              type: "structure",
              required: [
                "TimeoutDurationMinutes",
                "TimeoutAction"
              ],
              members: {
                TimeoutDurationMinutes: {
                  type: "integer"
                },
                TimeoutAction: {},
                BlockDurationMinutes: {
                  type: "integer"
                },
                AllocationStrategy: {}
              }
            },
            OnDemandSpecification: {
              type: "structure",
              required: [
                "AllocationStrategy"
              ],
              members: {
                AllocationStrategy: {},
                CapacityReservationOptions: {
                  type: "structure",
                  members: {
                    UsageStrategy: {},
                    CapacityReservationPreference: {},
                    CapacityReservationResourceGroupArn: {}
                  }
                }
              }
            }
          }
        },
        Su: {
          type: "structure",
          members: {
            SpotResizeSpecification: {
              type: "structure",
              required: [
                "TimeoutDurationMinutes"
              ],
              members: {
                TimeoutDurationMinutes: {
                  type: "integer"
                }
              }
            },
            OnDemandResizeSpecification: {
              type: "structure",
              required: [
                "TimeoutDurationMinutes"
              ],
              members: {
                TimeoutDurationMinutes: {
                  type: "integer"
                }
              }
            }
          }
        },
        S11: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "InstanceRole",
              "InstanceType",
              "InstanceCount"
            ],
            members: {
              Name: {},
              Market: {},
              InstanceRole: {},
              BidPrice: {},
              InstanceType: {},
              InstanceCount: {
                type: "integer"
              },
              Configurations: {
                shape: "Si"
              },
              EbsConfiguration: {
                shape: "Sa"
              },
              AutoScalingPolicy: {
                shape: "S15"
              },
              CustomAmiId: {}
            }
          }
        },
        S15: {
          type: "structure",
          required: [
            "Constraints",
            "Rules"
          ],
          members: {
            Constraints: {
              shape: "S16"
            },
            Rules: {
              shape: "S17"
            }
          }
        },
        S16: {
          type: "structure",
          required: [
            "MinCapacity",
            "MaxCapacity"
          ],
          members: {
            MinCapacity: {
              type: "integer"
            },
            MaxCapacity: {
              type: "integer"
            }
          }
        },
        S17: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Action",
              "Trigger"
            ],
            members: {
              Name: {},
              Description: {},
              Action: {
                type: "structure",
                required: [
                  "SimpleScalingPolicyConfiguration"
                ],
                members: {
                  Market: {},
                  SimpleScalingPolicyConfiguration: {
                    type: "structure",
                    required: [
                      "ScalingAdjustment"
                    ],
                    members: {
                      AdjustmentType: {},
                      ScalingAdjustment: {
                        type: "integer"
                      },
                      CoolDown: {
                        type: "integer"
                      }
                    }
                  }
                }
              },
              Trigger: {
                type: "structure",
                required: [
                  "CloudWatchAlarmDefinition"
                ],
                members: {
                  CloudWatchAlarmDefinition: {
                    type: "structure",
                    required: [
                      "ComparisonOperator",
                      "MetricName",
                      "Period",
                      "Threshold"
                    ],
                    members: {
                      ComparisonOperator: {},
                      EvaluationPeriods: {
                        type: "integer"
                      },
                      MetricName: {},
                      Namespace: {},
                      Period: {
                        type: "integer"
                      },
                      Statistic: {},
                      Threshold: {
                        type: "double"
                      },
                      Unit: {},
                      Dimensions: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            Key: {},
                            Value: {}
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S1m: {
          type: "list",
          member: {
            shape: "S1n"
          }
        },
        S1n: {
          type: "structure",
          required: [
            "Name",
            "HadoopJarStep"
          ],
          members: {
            Name: {},
            ActionOnFailure: {},
            HadoopJarStep: {
              type: "structure",
              required: [
                "Jar"
              ],
              members: {
                Properties: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      Key: {},
                      Value: {}
                    }
                  }
                },
                Jar: {},
                MainClass: {},
                Args: {
                  shape: "S1t"
                }
              }
            }
          }
        },
        S1t: {
          type: "list",
          member: {}
        },
        S1v: {
          type: "list",
          member: {}
        },
        S1y: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S2d: {
          type: "list",
          member: {}
        },
        S2q: {
          type: "structure",
          members: {
            State: {},
            StateChangeReason: {
              type: "structure",
              members: {
                Code: {},
                Message: {}
              }
            },
            Timeline: {
              type: "structure",
              members: {
                CreationDateTime: {
                  type: "timestamp"
                },
                ReadyDateTime: {
                  type: "timestamp"
                },
                EndDateTime: {
                  type: "timestamp"
                }
              }
            },
            ErrorDetails: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  ErrorCode: {},
                  ErrorData: {
                    type: "list",
                    member: {
                      shape: "Sk"
                    }
                  },
                  ErrorMessage: {}
                }
              }
            }
          }
        },
        S2z: {
          type: "list",
          member: {}
        },
        S30: {
          type: "list",
          member: {}
        },
        S33: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Version: {},
              Args: {
                shape: "S30"
              },
              AdditionalInfo: {
                shape: "Sk"
              }
            }
          }
        },
        S37: {
          type: "structure",
          required: [
            "Realm",
            "KdcAdminPassword"
          ],
          members: {
            Realm: {},
            KdcAdminPassword: {},
            CrossRealmTrustPrincipalPassword: {},
            ADDomainJoinUser: {},
            ADDomainJoinPassword: {}
          }
        },
        S39: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "InstanceRole"
            ],
            members: {
              InstanceRole: {},
              PlacementStrategy: {}
            }
          }
        },
        S3n: {
          type: "structure",
          members: {
            AvailabilityZone: {},
            AvailabilityZones: {
              shape: "S2z"
            }
          }
        },
        S3u: {
          type: "structure",
          required: [
            "Name",
            "ScriptBootstrapAction"
          ],
          members: {
            Name: {},
            ScriptBootstrapAction: {
              type: "structure",
              required: [
                "Path"
              ],
              members: {
                Path: {},
                Args: {
                  shape: "S1t"
                }
              }
            }
          }
        },
        S3w: {
          type: "list",
          member: {}
        },
        S40: {
          type: "structure",
          required: [
            "Id"
          ],
          members: {
            Id: {},
            Type: {},
            MasterInstanceSecurityGroupId: {},
            ExecutionRoleArn: {}
          }
        },
        S44: {
          type: "structure",
          members: {
            Bucket: {},
            Key: {}
          }
        },
        S48: {
          type: "map",
          key: {},
          value: {}
        },
        S4l: {
          type: "structure",
          members: {
            Jar: {},
            Properties: {
              shape: "Sk"
            },
            MainClass: {},
            Args: {
              shape: "S30"
            }
          }
        },
        S4m: {
          type: "structure",
          members: {
            State: {},
            StateChangeReason: {
              type: "structure",
              members: {
                Code: {},
                Message: {}
              }
            },
            FailureDetails: {
              type: "structure",
              members: {
                Reason: {},
                Message: {},
                LogFile: {}
              }
            },
            Timeline: {
              type: "structure",
              members: {
                CreationDateTime: {
                  type: "timestamp"
                },
                StartDateTime: {
                  type: "timestamp"
                },
                EndDateTime: {
                  type: "timestamp"
                }
              }
            }
          }
        },
        S4x: {
          type: "structure",
          members: {
            IdleTimeout: {
              type: "long"
            }
          }
        },
        S51: {
          type: "structure",
          required: [
            "BlockPublicSecurityGroupRules"
          ],
          members: {
            BlockPublicSecurityGroupRules: {
              type: "boolean"
            },
            PermittedPublicSecurityGroupRuleRanges: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "MinRange"
                ],
                members: {
                  MinRange: {
                    type: "integer"
                  },
                  MaxRange: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        S5c: {
          type: "structure",
          members: {
            ComputeLimits: {
              type: "structure",
              required: [
                "UnitType",
                "MinimumCapacityUnits",
                "MaximumCapacityUnits"
              ],
              members: {
                UnitType: {},
                MinimumCapacityUnits: {
                  type: "integer"
                },
                MaximumCapacityUnits: {
                  type: "integer"
                },
                MaximumOnDemandCapacityUnits: {
                  type: "integer"
                },
                MaximumCoreCapacityUnits: {
                  type: "integer"
                }
              }
            }
          }
        },
        S63: {
          type: "list",
          member: {
            type: "structure",
            members: {
              VolumeSpecification: {
                shape: "Sd"
              },
              Device: {}
            }
          }
        },
        S6f: {
          type: "structure",
          members: {
            DecommissionTimeout: {
              type: "integer"
            },
            InstanceResizePolicy: {
              type: "structure",
              members: {
                InstancesToTerminate: {
                  shape: "S6h"
                },
                InstancesToProtect: {
                  shape: "S6h"
                },
                InstanceTerminationTimeout: {
                  type: "integer"
                }
              }
            }
          }
        },
        S6h: {
          type: "list",
          member: {}
        },
        S6j: {
          type: "structure",
          members: {
            Status: {
              type: "structure",
              members: {
                State: {},
                StateChangeReason: {
                  type: "structure",
                  members: {
                    Code: {},
                    Message: {}
                  }
                }
              }
            },
            Constraints: {
              shape: "S16"
            },
            Rules: {
              shape: "S17"
            }
          }
        },
        S8m: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/elasticmapreduce-2009-03-31.paginators.json
var require_elasticmapreduce_2009_03_31_paginators = __commonJS({
  "node_modules/aws-sdk/apis/elasticmapreduce-2009-03-31.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeJobFlows: {
          result_key: "JobFlows"
        },
        ListBootstrapActions: {
          input_token: "Marker",
          output_token: "Marker",
          result_key: "BootstrapActions"
        },
        ListClusters: {
          input_token: "Marker",
          output_token: "Marker",
          result_key: "Clusters"
        },
        ListInstanceFleets: {
          input_token: "Marker",
          output_token: "Marker",
          result_key: "InstanceFleets"
        },
        ListInstanceGroups: {
          input_token: "Marker",
          output_token: "Marker",
          result_key: "InstanceGroups"
        },
        ListInstances: {
          input_token: "Marker",
          output_token: "Marker",
          result_key: "Instances"
        },
        ListNotebookExecutions: {
          input_token: "Marker",
          output_token: "Marker",
          result_key: "NotebookExecutions"
        },
        ListReleaseLabels: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListSecurityConfigurations: {
          input_token: "Marker",
          output_token: "Marker",
          result_key: "SecurityConfigurations"
        },
        ListSteps: {
          input_token: "Marker",
          output_token: "Marker",
          result_key: "Steps"
        },
        ListStudioSessionMappings: {
          input_token: "Marker",
          output_token: "Marker",
          result_key: "SessionMappings"
        },
        ListStudios: {
          input_token: "Marker",
          output_token: "Marker",
          result_key: "Studios"
        },
        ListSupportedInstanceTypes: {
          input_token: "Marker",
          output_token: "Marker"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/elasticmapreduce-2009-03-31.waiters2.json
var require_elasticmapreduce_2009_03_31_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/elasticmapreduce-2009-03-31.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        ClusterRunning: {
          delay: 30,
          operation: "DescribeCluster",
          maxAttempts: 60,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "Cluster.Status.State",
              expected: "RUNNING"
            },
            {
              state: "success",
              matcher: "path",
              argument: "Cluster.Status.State",
              expected: "WAITING"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "Cluster.Status.State",
              expected: "TERMINATING"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "Cluster.Status.State",
              expected: "TERMINATED"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "Cluster.Status.State",
              expected: "TERMINATED_WITH_ERRORS"
            }
          ]
        },
        StepComplete: {
          delay: 30,
          operation: "DescribeStep",
          maxAttempts: 60,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "Step.Status.State",
              expected: "COMPLETED"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "Step.Status.State",
              expected: "FAILED"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "Step.Status.State",
              expected: "CANCELLED"
            }
          ]
        },
        ClusterTerminated: {
          delay: 30,
          operation: "DescribeCluster",
          maxAttempts: 60,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "Cluster.Status.State",
              expected: "TERMINATED"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "Cluster.Status.State",
              expected: "TERMINATED_WITH_ERRORS"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/emr.js
var require_emr = __commonJS({
  "node_modules/aws-sdk/clients/emr.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["emr"] = {};
    AWS2.EMR = Service.defineService("emr", ["2009-03-31"]);
    Object.defineProperty(apiLoader.services["emr"], "2009-03-31", {
      get: function get() {
        var model = require_elasticmapreduce_2009_03_31_min();
        model.paginators = require_elasticmapreduce_2009_03_31_paginators().pagination;
        model.waiters = require_elasticmapreduce_2009_03_31_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.EMR;
  }
});

// node_modules/aws-sdk/apis/es-2015-01-01.min.json
var require_es_2015_01_01_min = __commonJS({
  "node_modules/aws-sdk/apis/es-2015-01-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-01-01",
        endpointPrefix: "es",
        protocol: "rest-json",
        serviceFullName: "Amazon Elasticsearch Service",
        serviceId: "Elasticsearch Service",
        signatureVersion: "v4",
        uid: "es-2015-01-01"
      },
      operations: {
        AcceptInboundCrossClusterSearchConnection: {
          http: {
            method: "PUT",
            requestUri: "/2015-01-01/es/ccs/inboundConnection/{ConnectionId}/accept"
          },
          input: {
            type: "structure",
            required: [
              "CrossClusterSearchConnectionId"
            ],
            members: {
              CrossClusterSearchConnectionId: {
                location: "uri",
                locationName: "ConnectionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CrossClusterSearchConnection: {
                shape: "S4"
              }
            }
          }
        },
        AddTags: {
          http: {
            requestUri: "/2015-01-01/tags"
          },
          input: {
            type: "structure",
            required: [
              "ARN",
              "TagList"
            ],
            members: {
              ARN: {},
              TagList: {
                shape: "Se"
              }
            }
          }
        },
        AssociatePackage: {
          http: {
            requestUri: "/2015-01-01/packages/associate/{PackageID}/{DomainName}"
          },
          input: {
            type: "structure",
            required: [
              "PackageID",
              "DomainName"
            ],
            members: {
              PackageID: {
                location: "uri",
                locationName: "PackageID"
              },
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainPackageDetails: {
                shape: "Sl"
              }
            }
          }
        },
        AuthorizeVpcEndpointAccess: {
          http: {
            requestUri: "/2015-01-01/es/domain/{DomainName}/authorizeVpcEndpointAccess"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Account"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              Account: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "AuthorizedPrincipal"
            ],
            members: {
              AuthorizedPrincipal: {
                shape: "Sy"
              }
            }
          }
        },
        CancelElasticsearchServiceSoftwareUpdate: {
          http: {
            requestUri: "/2015-01-01/es/serviceSoftwareUpdate/cancel"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceSoftwareOptions: {
                shape: "S13"
              }
            }
          }
        },
        CreateElasticsearchDomain: {
          http: {
            requestUri: "/2015-01-01/es/domain"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              ElasticsearchVersion: {},
              ElasticsearchClusterConfig: {
                shape: "S19"
              },
              EBSOptions: {
                shape: "S1f"
              },
              AccessPolicies: {},
              SnapshotOptions: {
                shape: "S1i"
              },
              VPCOptions: {
                shape: "S1j"
              },
              CognitoOptions: {
                shape: "S1l"
              },
              EncryptionAtRestOptions: {
                shape: "S1p"
              },
              NodeToNodeEncryptionOptions: {
                shape: "S1r"
              },
              AdvancedOptions: {
                shape: "S1s"
              },
              LogPublishingOptions: {
                shape: "S1t"
              },
              DomainEndpointOptions: {
                shape: "S1x"
              },
              AdvancedSecurityOptions: {
                shape: "S20"
              },
              AutoTuneOptions: {
                type: "structure",
                members: {
                  DesiredState: {},
                  MaintenanceSchedules: {
                    shape: "S2b"
                  }
                }
              },
              TagList: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainStatus: {
                shape: "S2i"
              }
            }
          }
        },
        CreateOutboundCrossClusterSearchConnection: {
          http: {
            requestUri: "/2015-01-01/es/ccs/outboundConnection"
          },
          input: {
            type: "structure",
            required: [
              "SourceDomainInfo",
              "DestinationDomainInfo",
              "ConnectionAlias"
            ],
            members: {
              SourceDomainInfo: {
                shape: "S5"
              },
              DestinationDomainInfo: {
                shape: "S5"
              },
              ConnectionAlias: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SourceDomainInfo: {
                shape: "S5"
              },
              DestinationDomainInfo: {
                shape: "S5"
              },
              ConnectionAlias: {},
              ConnectionStatus: {
                shape: "S2y"
              },
              CrossClusterSearchConnectionId: {}
            }
          }
        },
        CreatePackage: {
          http: {
            requestUri: "/2015-01-01/packages"
          },
          input: {
            type: "structure",
            required: [
              "PackageName",
              "PackageType",
              "PackageSource"
            ],
            members: {
              PackageName: {},
              PackageType: {},
              PackageDescription: {},
              PackageSource: {
                shape: "S32"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PackageDetails: {
                shape: "S36"
              }
            }
          }
        },
        CreateVpcEndpoint: {
          http: {
            requestUri: "/2015-01-01/es/vpcEndpoints"
          },
          input: {
            type: "structure",
            required: [
              "DomainArn",
              "VpcOptions"
            ],
            members: {
              DomainArn: {},
              VpcOptions: {
                shape: "S1j"
              },
              ClientToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "VpcEndpoint"
            ],
            members: {
              VpcEndpoint: {
                shape: "S3d"
              }
            }
          }
        },
        DeleteElasticsearchDomain: {
          http: {
            method: "DELETE",
            requestUri: "/2015-01-01/es/domain/{DomainName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainStatus: {
                shape: "S2i"
              }
            }
          }
        },
        DeleteElasticsearchServiceRole: {
          http: {
            method: "DELETE",
            requestUri: "/2015-01-01/es/role"
          }
        },
        DeleteInboundCrossClusterSearchConnection: {
          http: {
            method: "DELETE",
            requestUri: "/2015-01-01/es/ccs/inboundConnection/{ConnectionId}"
          },
          input: {
            type: "structure",
            required: [
              "CrossClusterSearchConnectionId"
            ],
            members: {
              CrossClusterSearchConnectionId: {
                location: "uri",
                locationName: "ConnectionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CrossClusterSearchConnection: {
                shape: "S4"
              }
            }
          }
        },
        DeleteOutboundCrossClusterSearchConnection: {
          http: {
            method: "DELETE",
            requestUri: "/2015-01-01/es/ccs/outboundConnection/{ConnectionId}"
          },
          input: {
            type: "structure",
            required: [
              "CrossClusterSearchConnectionId"
            ],
            members: {
              CrossClusterSearchConnectionId: {
                location: "uri",
                locationName: "ConnectionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CrossClusterSearchConnection: {
                shape: "S3n"
              }
            }
          }
        },
        DeletePackage: {
          http: {
            method: "DELETE",
            requestUri: "/2015-01-01/packages/{PackageID}"
          },
          input: {
            type: "structure",
            required: [
              "PackageID"
            ],
            members: {
              PackageID: {
                location: "uri",
                locationName: "PackageID"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PackageDetails: {
                shape: "S36"
              }
            }
          }
        },
        DeleteVpcEndpoint: {
          http: {
            method: "DELETE",
            requestUri: "/2015-01-01/es/vpcEndpoints/{VpcEndpointId}"
          },
          input: {
            type: "structure",
            required: [
              "VpcEndpointId"
            ],
            members: {
              VpcEndpointId: {
                location: "uri",
                locationName: "VpcEndpointId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "VpcEndpointSummary"
            ],
            members: {
              VpcEndpointSummary: {
                shape: "S3s"
              }
            }
          }
        },
        DescribeDomainAutoTunes: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/es/domain/{DomainName}/autoTunes"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AutoTunes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AutoTuneType: {},
                    AutoTuneDetails: {
                      type: "structure",
                      members: {
                        ScheduledAutoTuneDetails: {
                          type: "structure",
                          members: {
                            Date: {
                              type: "timestamp"
                            },
                            ActionType: {},
                            Action: {},
                            Severity: {}
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeDomainChangeProgress: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/es/domain/{DomainName}/progress"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              ChangeId: {
                location: "querystring",
                locationName: "changeid"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeProgressStatus: {
                type: "structure",
                members: {
                  ChangeId: {},
                  StartTime: {
                    type: "timestamp"
                  },
                  Status: {},
                  PendingProperties: {
                    shape: "S1k"
                  },
                  CompletedProperties: {
                    shape: "S1k"
                  },
                  TotalNumberOfStages: {
                    type: "integer"
                  },
                  ChangeProgressStages: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {},
                        Status: {},
                        Description: {},
                        LastUpdated: {
                          type: "timestamp"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeElasticsearchDomain: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/es/domain/{DomainName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainStatus"
            ],
            members: {
              DomainStatus: {
                shape: "S2i"
              }
            }
          }
        },
        DescribeElasticsearchDomainConfig: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/es/domain/{DomainName}/config"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainConfig"
            ],
            members: {
              DomainConfig: {
                shape: "S4l"
              }
            }
          }
        },
        DescribeElasticsearchDomains: {
          http: {
            requestUri: "/2015-01-01/es/domain-info"
          },
          input: {
            type: "structure",
            required: [
              "DomainNames"
            ],
            members: {
              DomainNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainStatusList"
            ],
            members: {
              DomainStatusList: {
                type: "list",
                member: {
                  shape: "S2i"
                }
              }
            }
          }
        },
        DescribeElasticsearchInstanceTypeLimits: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/es/instanceTypeLimits/{ElasticsearchVersion}/{InstanceType}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceType",
              "ElasticsearchVersion"
            ],
            members: {
              DomainName: {
                location: "querystring",
                locationName: "domainName"
              },
              InstanceType: {
                location: "uri",
                locationName: "InstanceType"
              },
              ElasticsearchVersion: {
                location: "uri",
                locationName: "ElasticsearchVersion"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LimitsByRole: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    StorageTypes: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          StorageTypeName: {},
                          StorageSubTypeName: {},
                          StorageTypeLimits: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                LimitName: {},
                                LimitValues: {
                                  shape: "S5m"
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    InstanceLimits: {
                      type: "structure",
                      members: {
                        InstanceCountLimits: {
                          type: "structure",
                          members: {
                            MinimumInstanceCount: {
                              type: "integer"
                            },
                            MaximumInstanceCount: {
                              type: "integer"
                            }
                          }
                        }
                      }
                    },
                    AdditionalLimits: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          LimitName: {},
                          LimitValues: {
                            shape: "S5m"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeInboundCrossClusterSearchConnections: {
          http: {
            requestUri: "/2015-01-01/es/ccs/inboundConnection/search"
          },
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S5v"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CrossClusterSearchConnections: {
                type: "list",
                member: {
                  shape: "S4"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeOutboundCrossClusterSearchConnections: {
          http: {
            requestUri: "/2015-01-01/es/ccs/outboundConnection/search"
          },
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S5v"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CrossClusterSearchConnections: {
                type: "list",
                member: {
                  shape: "S3n"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribePackages: {
          http: {
            requestUri: "/2015-01-01/packages/describe"
          },
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Value: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PackageDetailsList: {
                type: "list",
                member: {
                  shape: "S36"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeReservedElasticsearchInstanceOfferings: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/es/reservedInstanceOfferings"
          },
          input: {
            type: "structure",
            members: {
              ReservedElasticsearchInstanceOfferingId: {
                location: "querystring",
                locationName: "offeringId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ReservedElasticsearchInstanceOfferings: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ReservedElasticsearchInstanceOfferingId: {},
                    ElasticsearchInstanceType: {},
                    Duration: {
                      type: "integer"
                    },
                    FixedPrice: {
                      type: "double"
                    },
                    UsagePrice: {
                      type: "double"
                    },
                    CurrencyCode: {},
                    PaymentOption: {},
                    RecurringCharges: {
                      shape: "S6j"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeReservedElasticsearchInstances: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/es/reservedInstances"
          },
          input: {
            type: "structure",
            members: {
              ReservedElasticsearchInstanceId: {
                location: "querystring",
                locationName: "reservationId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ReservedElasticsearchInstances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ReservationName: {},
                    ReservedElasticsearchInstanceId: {},
                    ReservedElasticsearchInstanceOfferingId: {},
                    ElasticsearchInstanceType: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    Duration: {
                      type: "integer"
                    },
                    FixedPrice: {
                      type: "double"
                    },
                    UsagePrice: {
                      type: "double"
                    },
                    CurrencyCode: {},
                    ElasticsearchInstanceCount: {
                      type: "integer"
                    },
                    State: {},
                    PaymentOption: {},
                    RecurringCharges: {
                      shape: "S6j"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeVpcEndpoints: {
          http: {
            requestUri: "/2015-01-01/es/vpcEndpoints/describe"
          },
          input: {
            type: "structure",
            required: [
              "VpcEndpointIds"
            ],
            members: {
              VpcEndpointIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "VpcEndpoints",
              "VpcEndpointErrors"
            ],
            members: {
              VpcEndpoints: {
                type: "list",
                member: {
                  shape: "S3d"
                }
              },
              VpcEndpointErrors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    VpcEndpointId: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        DissociatePackage: {
          http: {
            requestUri: "/2015-01-01/packages/dissociate/{PackageID}/{DomainName}"
          },
          input: {
            type: "structure",
            required: [
              "PackageID",
              "DomainName"
            ],
            members: {
              PackageID: {
                location: "uri",
                locationName: "PackageID"
              },
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainPackageDetails: {
                shape: "Sl"
              }
            }
          }
        },
        GetCompatibleElasticsearchVersions: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/es/compatibleVersions"
          },
          input: {
            type: "structure",
            members: {
              DomainName: {
                location: "querystring",
                locationName: "domainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CompatibleElasticsearchVersions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SourceVersion: {},
                    TargetVersions: {
                      shape: "S73"
                    }
                  }
                }
              }
            }
          }
        },
        GetPackageVersionHistory: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/packages/{PackageID}/history"
          },
          input: {
            type: "structure",
            required: [
              "PackageID"
            ],
            members: {
              PackageID: {
                location: "uri",
                locationName: "PackageID"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PackageID: {},
              PackageVersionHistoryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PackageVersion: {},
                    CommitMessage: {},
                    CreatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetUpgradeHistory: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/es/upgradeDomain/{DomainName}/history"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UpgradeHistories: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    UpgradeName: {},
                    StartTimestamp: {
                      type: "timestamp"
                    },
                    UpgradeStatus: {},
                    StepsList: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          UpgradeStep: {},
                          UpgradeStepStatus: {},
                          Issues: {
                            type: "list",
                            member: {}
                          },
                          ProgressPercent: {
                            type: "double"
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetUpgradeStatus: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/es/upgradeDomain/{DomainName}/status"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UpgradeStep: {},
              StepStatus: {},
              UpgradeName: {}
            }
          }
        },
        ListDomainNames: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/domain"
          },
          input: {
            type: "structure",
            members: {
              EngineType: {
                location: "querystring",
                locationName: "engineType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainNames: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DomainName: {},
                    EngineType: {}
                  }
                }
              }
            }
          }
        },
        ListDomainsForPackage: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/packages/{PackageID}/domains"
          },
          input: {
            type: "structure",
            required: [
              "PackageID"
            ],
            members: {
              PackageID: {
                location: "uri",
                locationName: "PackageID"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainPackageDetailsList: {
                shape: "S7u"
              },
              NextToken: {}
            }
          }
        },
        ListElasticsearchInstanceTypes: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/es/instanceTypes/{ElasticsearchVersion}"
          },
          input: {
            type: "structure",
            required: [
              "ElasticsearchVersion"
            ],
            members: {
              ElasticsearchVersion: {
                location: "uri",
                locationName: "ElasticsearchVersion"
              },
              DomainName: {
                location: "querystring",
                locationName: "domainName"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ElasticsearchInstanceTypes: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListElasticsearchVersions: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/es/versions"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ElasticsearchVersions: {
                shape: "S73"
              },
              NextToken: {}
            }
          }
        },
        ListPackagesForDomain: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/domain/{DomainName}/packages"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainPackageDetailsList: {
                shape: "S7u"
              },
              NextToken: {}
            }
          }
        },
        ListTags: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/tags/"
          },
          input: {
            type: "structure",
            required: [
              "ARN"
            ],
            members: {
              ARN: {
                location: "querystring",
                locationName: "arn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TagList: {
                shape: "Se"
              }
            }
          }
        },
        ListVpcEndpointAccess: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/es/domain/{DomainName}/listVpcEndpointAccess"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "AuthorizedPrincipalList",
              "NextToken"
            ],
            members: {
              AuthorizedPrincipalList: {
                type: "list",
                member: {
                  shape: "Sy"
                }
              },
              NextToken: {}
            }
          }
        },
        ListVpcEndpoints: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/es/vpcEndpoints"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "VpcEndpointSummaryList",
              "NextToken"
            ],
            members: {
              VpcEndpointSummaryList: {
                shape: "S89"
              },
              NextToken: {}
            }
          }
        },
        ListVpcEndpointsForDomain: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/es/domain/{DomainName}/vpcEndpoints"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "VpcEndpointSummaryList",
              "NextToken"
            ],
            members: {
              VpcEndpointSummaryList: {
                shape: "S89"
              },
              NextToken: {}
            }
          }
        },
        PurchaseReservedElasticsearchInstanceOffering: {
          http: {
            requestUri: "/2015-01-01/es/purchaseReservedInstanceOffering"
          },
          input: {
            type: "structure",
            required: [
              "ReservedElasticsearchInstanceOfferingId",
              "ReservationName"
            ],
            members: {
              ReservedElasticsearchInstanceOfferingId: {},
              ReservationName: {},
              InstanceCount: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReservedElasticsearchInstanceId: {},
              ReservationName: {}
            }
          }
        },
        RejectInboundCrossClusterSearchConnection: {
          http: {
            method: "PUT",
            requestUri: "/2015-01-01/es/ccs/inboundConnection/{ConnectionId}/reject"
          },
          input: {
            type: "structure",
            required: [
              "CrossClusterSearchConnectionId"
            ],
            members: {
              CrossClusterSearchConnectionId: {
                location: "uri",
                locationName: "ConnectionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CrossClusterSearchConnection: {
                shape: "S4"
              }
            }
          }
        },
        RemoveTags: {
          http: {
            requestUri: "/2015-01-01/tags-removal"
          },
          input: {
            type: "structure",
            required: [
              "ARN",
              "TagKeys"
            ],
            members: {
              ARN: {},
              TagKeys: {
                shape: "S1k"
              }
            }
          }
        },
        RevokeVpcEndpointAccess: {
          http: {
            requestUri: "/2015-01-01/es/domain/{DomainName}/revokeVpcEndpointAccess"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Account"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              Account: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartElasticsearchServiceSoftwareUpdate: {
          http: {
            requestUri: "/2015-01-01/es/serviceSoftwareUpdate/start"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceSoftwareOptions: {
                shape: "S13"
              }
            }
          }
        },
        UpdateElasticsearchDomainConfig: {
          http: {
            requestUri: "/2015-01-01/es/domain/{DomainName}/config"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              ElasticsearchClusterConfig: {
                shape: "S19"
              },
              EBSOptions: {
                shape: "S1f"
              },
              SnapshotOptions: {
                shape: "S1i"
              },
              VPCOptions: {
                shape: "S1j"
              },
              CognitoOptions: {
                shape: "S1l"
              },
              AdvancedOptions: {
                shape: "S1s"
              },
              AccessPolicies: {},
              LogPublishingOptions: {
                shape: "S1t"
              },
              DomainEndpointOptions: {
                shape: "S1x"
              },
              AdvancedSecurityOptions: {
                shape: "S20"
              },
              NodeToNodeEncryptionOptions: {
                shape: "S1r"
              },
              EncryptionAtRestOptions: {
                shape: "S1p"
              },
              AutoTuneOptions: {
                shape: "S53"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainConfig"
            ],
            members: {
              DomainConfig: {
                shape: "S4l"
              },
              DryRunResults: {
                type: "structure",
                members: {
                  DeploymentType: {},
                  Message: {}
                }
              }
            }
          }
        },
        UpdatePackage: {
          http: {
            requestUri: "/2015-01-01/packages/update"
          },
          input: {
            type: "structure",
            required: [
              "PackageID",
              "PackageSource"
            ],
            members: {
              PackageID: {},
              PackageSource: {
                shape: "S32"
              },
              PackageDescription: {},
              CommitMessage: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PackageDetails: {
                shape: "S36"
              }
            }
          }
        },
        UpdateVpcEndpoint: {
          http: {
            requestUri: "/2015-01-01/es/vpcEndpoints/update"
          },
          input: {
            type: "structure",
            required: [
              "VpcEndpointId",
              "VpcOptions"
            ],
            members: {
              VpcEndpointId: {},
              VpcOptions: {
                shape: "S1j"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "VpcEndpoint"
            ],
            members: {
              VpcEndpoint: {
                shape: "S3d"
              }
            }
          }
        },
        UpgradeElasticsearchDomain: {
          http: {
            requestUri: "/2015-01-01/es/upgradeDomain"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "TargetVersion"
            ],
            members: {
              DomainName: {},
              TargetVersion: {},
              PerformCheckOnly: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainName: {},
              TargetVersion: {},
              PerformCheckOnly: {
                type: "boolean"
              },
              ChangeProgressDetails: {
                shape: "S2s"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            SourceDomainInfo: {
              shape: "S5"
            },
            DestinationDomainInfo: {
              shape: "S5"
            },
            CrossClusterSearchConnectionId: {},
            ConnectionStatus: {
              type: "structure",
              members: {
                StatusCode: {},
                Message: {}
              }
            }
          }
        },
        S5: {
          type: "structure",
          required: [
            "DomainName"
          ],
          members: {
            OwnerId: {},
            DomainName: {},
            Region: {}
          }
        },
        Se: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sl: {
          type: "structure",
          members: {
            PackageID: {},
            PackageName: {},
            PackageType: {},
            LastUpdated: {
              type: "timestamp"
            },
            DomainName: {},
            DomainPackageStatus: {},
            PackageVersion: {},
            ReferencePath: {},
            ErrorDetails: {
              shape: "Ss"
            }
          }
        },
        Ss: {
          type: "structure",
          members: {
            ErrorType: {},
            ErrorMessage: {}
          }
        },
        Sy: {
          type: "structure",
          members: {
            PrincipalType: {},
            Principal: {}
          }
        },
        S13: {
          type: "structure",
          members: {
            CurrentVersion: {},
            NewVersion: {},
            UpdateAvailable: {
              type: "boolean"
            },
            Cancellable: {
              type: "boolean"
            },
            UpdateStatus: {},
            Description: {},
            AutomatedUpdateDate: {
              type: "timestamp"
            },
            OptionalDeployment: {
              type: "boolean"
            }
          }
        },
        S19: {
          type: "structure",
          members: {
            InstanceType: {},
            InstanceCount: {
              type: "integer"
            },
            DedicatedMasterEnabled: {
              type: "boolean"
            },
            ZoneAwarenessEnabled: {
              type: "boolean"
            },
            ZoneAwarenessConfig: {
              type: "structure",
              members: {
                AvailabilityZoneCount: {
                  type: "integer"
                }
              }
            },
            DedicatedMasterType: {},
            DedicatedMasterCount: {
              type: "integer"
            },
            WarmEnabled: {
              type: "boolean"
            },
            WarmType: {},
            WarmCount: {
              type: "integer"
            },
            ColdStorageOptions: {
              type: "structure",
              required: [
                "Enabled"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                }
              }
            }
          }
        },
        S1f: {
          type: "structure",
          members: {
            EBSEnabled: {
              type: "boolean"
            },
            VolumeType: {},
            VolumeSize: {
              type: "integer"
            },
            Iops: {
              type: "integer"
            },
            Throughput: {
              type: "integer"
            }
          }
        },
        S1i: {
          type: "structure",
          members: {
            AutomatedSnapshotStartHour: {
              type: "integer"
            }
          }
        },
        S1j: {
          type: "structure",
          members: {
            SubnetIds: {
              shape: "S1k"
            },
            SecurityGroupIds: {
              shape: "S1k"
            }
          }
        },
        S1k: {
          type: "list",
          member: {}
        },
        S1l: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            UserPoolId: {},
            IdentityPoolId: {},
            RoleArn: {}
          }
        },
        S1p: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            KmsKeyId: {}
          }
        },
        S1r: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            }
          }
        },
        S1s: {
          type: "map",
          key: {},
          value: {}
        },
        S1t: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              CloudWatchLogsLogGroupArn: {},
              Enabled: {
                type: "boolean"
              }
            }
          }
        },
        S1x: {
          type: "structure",
          members: {
            EnforceHTTPS: {
              type: "boolean"
            },
            TLSSecurityPolicy: {},
            CustomEndpointEnabled: {
              type: "boolean"
            },
            CustomEndpoint: {},
            CustomEndpointCertificateArn: {}
          }
        },
        S20: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            InternalUserDatabaseEnabled: {
              type: "boolean"
            },
            MasterUserOptions: {
              type: "structure",
              members: {
                MasterUserARN: {},
                MasterUserName: {
                  shape: "S22"
                },
                MasterUserPassword: {
                  type: "string",
                  sensitive: true
                }
              }
            },
            SAMLOptions: {
              type: "structure",
              members: {
                Enabled: {
                  type: "boolean"
                },
                Idp: {
                  shape: "S25"
                },
                MasterUserName: {
                  shape: "S22"
                },
                MasterBackendRole: {},
                SubjectKey: {},
                RolesKey: {},
                SessionTimeoutMinutes: {
                  type: "integer"
                }
              }
            },
            AnonymousAuthEnabled: {
              type: "boolean"
            }
          }
        },
        S22: {
          type: "string",
          sensitive: true
        },
        S25: {
          type: "structure",
          required: [
            "MetadataContent",
            "EntityId"
          ],
          members: {
            MetadataContent: {},
            EntityId: {}
          }
        },
        S2b: {
          type: "list",
          member: {
            type: "structure",
            members: {
              StartAt: {
                type: "timestamp"
              },
              Duration: {
                type: "structure",
                members: {
                  Value: {
                    type: "long"
                  },
                  Unit: {}
                }
              },
              CronExpressionForRecurrence: {}
            }
          }
        },
        S2i: {
          type: "structure",
          required: [
            "DomainId",
            "DomainName",
            "ARN",
            "ElasticsearchClusterConfig"
          ],
          members: {
            DomainId: {},
            DomainName: {},
            ARN: {},
            Created: {
              type: "boolean"
            },
            Deleted: {
              type: "boolean"
            },
            Endpoint: {},
            Endpoints: {
              type: "map",
              key: {},
              value: {}
            },
            Processing: {
              type: "boolean"
            },
            UpgradeProcessing: {
              type: "boolean"
            },
            ElasticsearchVersion: {},
            ElasticsearchClusterConfig: {
              shape: "S19"
            },
            EBSOptions: {
              shape: "S1f"
            },
            AccessPolicies: {},
            SnapshotOptions: {
              shape: "S1i"
            },
            VPCOptions: {
              shape: "S2m"
            },
            CognitoOptions: {
              shape: "S1l"
            },
            EncryptionAtRestOptions: {
              shape: "S1p"
            },
            NodeToNodeEncryptionOptions: {
              shape: "S1r"
            },
            AdvancedOptions: {
              shape: "S1s"
            },
            LogPublishingOptions: {
              shape: "S1t"
            },
            ServiceSoftwareOptions: {
              shape: "S13"
            },
            DomainEndpointOptions: {
              shape: "S1x"
            },
            AdvancedSecurityOptions: {
              shape: "S2n"
            },
            AutoTuneOptions: {
              type: "structure",
              members: {
                State: {},
                ErrorMessage: {}
              }
            },
            ChangeProgressDetails: {
              shape: "S2s"
            }
          }
        },
        S2m: {
          type: "structure",
          members: {
            VPCId: {},
            SubnetIds: {
              shape: "S1k"
            },
            AvailabilityZones: {
              shape: "S1k"
            },
            SecurityGroupIds: {
              shape: "S1k"
            }
          }
        },
        S2n: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            InternalUserDatabaseEnabled: {
              type: "boolean"
            },
            SAMLOptions: {
              type: "structure",
              members: {
                Enabled: {
                  type: "boolean"
                },
                Idp: {
                  shape: "S25"
                },
                SubjectKey: {},
                RolesKey: {},
                SessionTimeoutMinutes: {
                  type: "integer"
                }
              }
            },
            AnonymousAuthDisableDate: {
              type: "timestamp"
            },
            AnonymousAuthEnabled: {
              type: "boolean"
            }
          }
        },
        S2s: {
          type: "structure",
          members: {
            ChangeId: {},
            Message: {}
          }
        },
        S2y: {
          type: "structure",
          members: {
            StatusCode: {},
            Message: {}
          }
        },
        S32: {
          type: "structure",
          members: {
            S3BucketName: {},
            S3Key: {}
          }
        },
        S36: {
          type: "structure",
          members: {
            PackageID: {},
            PackageName: {},
            PackageType: {},
            PackageDescription: {},
            PackageStatus: {},
            CreatedAt: {
              type: "timestamp"
            },
            LastUpdatedAt: {
              type: "timestamp"
            },
            AvailablePackageVersion: {},
            ErrorDetails: {
              shape: "Ss"
            }
          }
        },
        S3d: {
          type: "structure",
          members: {
            VpcEndpointId: {},
            VpcEndpointOwner: {},
            DomainArn: {},
            VpcOptions: {
              shape: "S2m"
            },
            Status: {},
            Endpoint: {}
          }
        },
        S3n: {
          type: "structure",
          members: {
            SourceDomainInfo: {
              shape: "S5"
            },
            DestinationDomainInfo: {
              shape: "S5"
            },
            CrossClusterSearchConnectionId: {},
            ConnectionAlias: {},
            ConnectionStatus: {
              shape: "S2y"
            }
          }
        },
        S3s: {
          type: "structure",
          members: {
            VpcEndpointId: {},
            VpcEndpointOwner: {},
            DomainArn: {},
            Status: {}
          }
        },
        S4l: {
          type: "structure",
          members: {
            ElasticsearchVersion: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {},
                Status: {
                  shape: "S4n"
                }
              }
            },
            ElasticsearchClusterConfig: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S19"
                },
                Status: {
                  shape: "S4n"
                }
              }
            },
            EBSOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S1f"
                },
                Status: {
                  shape: "S4n"
                }
              }
            },
            AccessPolicies: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {},
                Status: {
                  shape: "S4n"
                }
              }
            },
            SnapshotOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S1i"
                },
                Status: {
                  shape: "S4n"
                }
              }
            },
            VPCOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S2m"
                },
                Status: {
                  shape: "S4n"
                }
              }
            },
            CognitoOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S1l"
                },
                Status: {
                  shape: "S4n"
                }
              }
            },
            EncryptionAtRestOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S1p"
                },
                Status: {
                  shape: "S4n"
                }
              }
            },
            NodeToNodeEncryptionOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S1r"
                },
                Status: {
                  shape: "S4n"
                }
              }
            },
            AdvancedOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S1s"
                },
                Status: {
                  shape: "S4n"
                }
              }
            },
            LogPublishingOptions: {
              type: "structure",
              members: {
                Options: {
                  shape: "S1t"
                },
                Status: {
                  shape: "S4n"
                }
              }
            },
            DomainEndpointOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S1x"
                },
                Status: {
                  shape: "S4n"
                }
              }
            },
            AdvancedSecurityOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S2n"
                },
                Status: {
                  shape: "S4n"
                }
              }
            },
            AutoTuneOptions: {
              type: "structure",
              members: {
                Options: {
                  shape: "S53"
                },
                Status: {
                  type: "structure",
                  required: [
                    "CreationDate",
                    "UpdateDate",
                    "State"
                  ],
                  members: {
                    CreationDate: {
                      type: "timestamp"
                    },
                    UpdateDate: {
                      type: "timestamp"
                    },
                    UpdateVersion: {
                      type: "integer"
                    },
                    State: {},
                    ErrorMessage: {},
                    PendingDeletion: {
                      type: "boolean"
                    }
                  }
                }
              }
            },
            ChangeProgressDetails: {
              shape: "S2s"
            }
          }
        },
        S4n: {
          type: "structure",
          required: [
            "CreationDate",
            "UpdateDate",
            "State"
          ],
          members: {
            CreationDate: {
              type: "timestamp"
            },
            UpdateDate: {
              type: "timestamp"
            },
            UpdateVersion: {
              type: "integer"
            },
            State: {},
            PendingDeletion: {
              type: "boolean"
            }
          }
        },
        S53: {
          type: "structure",
          members: {
            DesiredState: {},
            RollbackOnDisable: {},
            MaintenanceSchedules: {
              shape: "S2b"
            }
          }
        },
        S5m: {
          type: "list",
          member: {}
        },
        S5v: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Values: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S6j: {
          type: "list",
          member: {
            type: "structure",
            members: {
              RecurringChargeAmount: {
                type: "double"
              },
              RecurringChargeFrequency: {}
            }
          }
        },
        S73: {
          type: "list",
          member: {}
        },
        S7u: {
          type: "list",
          member: {
            shape: "Sl"
          }
        },
        S89: {
          type: "list",
          member: {
            shape: "S3s"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/es-2015-01-01.paginators.json
var require_es_2015_01_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/es-2015-01-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeDomainAutoTunes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeInboundCrossClusterSearchConnections: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeOutboundCrossClusterSearchConnections: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribePackages: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeReservedElasticsearchInstanceOfferings: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeReservedElasticsearchInstances: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        GetPackageVersionHistory: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        GetUpgradeHistory: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDomainsForPackage: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListElasticsearchInstanceTypes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListElasticsearchVersions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListPackagesForDomain: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/es.js
var require_es = __commonJS({
  "node_modules/aws-sdk/clients/es.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["es"] = {};
    AWS2.ES = Service.defineService("es", ["2015-01-01"]);
    Object.defineProperty(apiLoader.services["es"], "2015-01-01", {
      get: function get() {
        var model = require_es_2015_01_01_min();
        model.paginators = require_es_2015_01_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ES;
  }
});

// node_modules/aws-sdk/apis/elastictranscoder-2012-09-25.min.json
var require_elastictranscoder_2012_09_25_min = __commonJS({
  "node_modules/aws-sdk/apis/elastictranscoder-2012-09-25.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2012-09-25",
        endpointPrefix: "elastictranscoder",
        protocol: "rest-json",
        serviceFullName: "Amazon Elastic Transcoder",
        serviceId: "Elastic Transcoder",
        signatureVersion: "v4",
        uid: "elastictranscoder-2012-09-25"
      },
      operations: {
        CancelJob: {
          http: {
            method: "DELETE",
            requestUri: "/2012-09-25/jobs/{Id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateJob: {
          http: {
            requestUri: "/2012-09-25/jobs",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "PipelineId"
            ],
            members: {
              PipelineId: {},
              Input: {
                shape: "S5"
              },
              Inputs: {
                shape: "St"
              },
              Output: {
                shape: "Su"
              },
              Outputs: {
                type: "list",
                member: {
                  shape: "Su"
                }
              },
              OutputKeyPrefix: {},
              Playlists: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Format: {},
                    OutputKeys: {
                      shape: "S1l"
                    },
                    HlsContentProtection: {
                      shape: "S1m"
                    },
                    PlayReadyDrm: {
                      shape: "S1q"
                    }
                  }
                }
              },
              UserMetadata: {
                shape: "S1v"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Job: {
                shape: "S1y"
              }
            }
          }
        },
        CreatePipeline: {
          http: {
            requestUri: "/2012-09-25/pipelines",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "InputBucket",
              "Role"
            ],
            members: {
              Name: {},
              InputBucket: {},
              OutputBucket: {},
              Role: {},
              AwsKmsKeyArn: {},
              Notifications: {
                shape: "S2a"
              },
              ContentConfig: {
                shape: "S2c"
              },
              ThumbnailConfig: {
                shape: "S2c"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Pipeline: {
                shape: "S2l"
              },
              Warnings: {
                shape: "S2n"
              }
            }
          }
        },
        CreatePreset: {
          http: {
            requestUri: "/2012-09-25/presets",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "Container"
            ],
            members: {
              Name: {},
              Description: {},
              Container: {},
              Video: {
                shape: "S2r"
              },
              Audio: {
                shape: "S37"
              },
              Thumbnails: {
                shape: "S3i"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Preset: {
                shape: "S3m"
              },
              Warning: {}
            }
          }
        },
        DeletePipeline: {
          http: {
            method: "DELETE",
            requestUri: "/2012-09-25/pipelines/{Id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeletePreset: {
          http: {
            method: "DELETE",
            requestUri: "/2012-09-25/presets/{Id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ListJobsByPipeline: {
          http: {
            method: "GET",
            requestUri: "/2012-09-25/jobsByPipeline/{PipelineId}"
          },
          input: {
            type: "structure",
            required: [
              "PipelineId"
            ],
            members: {
              PipelineId: {
                location: "uri",
                locationName: "PipelineId"
              },
              Ascending: {
                location: "querystring",
                locationName: "Ascending"
              },
              PageToken: {
                location: "querystring",
                locationName: "PageToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Jobs: {
                shape: "S3v"
              },
              NextPageToken: {}
            }
          }
        },
        ListJobsByStatus: {
          http: {
            method: "GET",
            requestUri: "/2012-09-25/jobsByStatus/{Status}"
          },
          input: {
            type: "structure",
            required: [
              "Status"
            ],
            members: {
              Status: {
                location: "uri",
                locationName: "Status"
              },
              Ascending: {
                location: "querystring",
                locationName: "Ascending"
              },
              PageToken: {
                location: "querystring",
                locationName: "PageToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Jobs: {
                shape: "S3v"
              },
              NextPageToken: {}
            }
          }
        },
        ListPipelines: {
          http: {
            method: "GET",
            requestUri: "/2012-09-25/pipelines"
          },
          input: {
            type: "structure",
            members: {
              Ascending: {
                location: "querystring",
                locationName: "Ascending"
              },
              PageToken: {
                location: "querystring",
                locationName: "PageToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Pipelines: {
                type: "list",
                member: {
                  shape: "S2l"
                }
              },
              NextPageToken: {}
            }
          }
        },
        ListPresets: {
          http: {
            method: "GET",
            requestUri: "/2012-09-25/presets"
          },
          input: {
            type: "structure",
            members: {
              Ascending: {
                location: "querystring",
                locationName: "Ascending"
              },
              PageToken: {
                location: "querystring",
                locationName: "PageToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Presets: {
                type: "list",
                member: {
                  shape: "S3m"
                }
              },
              NextPageToken: {}
            }
          }
        },
        ReadJob: {
          http: {
            method: "GET",
            requestUri: "/2012-09-25/jobs/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Job: {
                shape: "S1y"
              }
            }
          }
        },
        ReadPipeline: {
          http: {
            method: "GET",
            requestUri: "/2012-09-25/pipelines/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Pipeline: {
                shape: "S2l"
              },
              Warnings: {
                shape: "S2n"
              }
            }
          }
        },
        ReadPreset: {
          http: {
            method: "GET",
            requestUri: "/2012-09-25/presets/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Preset: {
                shape: "S3m"
              }
            }
          }
        },
        TestRole: {
          http: {
            requestUri: "/2012-09-25/roleTests",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Role",
              "InputBucket",
              "OutputBucket",
              "Topics"
            ],
            members: {
              Role: {},
              InputBucket: {},
              OutputBucket: {},
              Topics: {
                type: "list",
                member: {}
              }
            },
            deprecated: true
          },
          output: {
            type: "structure",
            members: {
              Success: {},
              Messages: {
                type: "list",
                member: {}
              }
            },
            deprecated: true
          },
          deprecated: true
        },
        UpdatePipeline: {
          http: {
            method: "PUT",
            requestUri: "/2012-09-25/pipelines/{Id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              Name: {},
              InputBucket: {},
              Role: {},
              AwsKmsKeyArn: {},
              Notifications: {
                shape: "S2a"
              },
              ContentConfig: {
                shape: "S2c"
              },
              ThumbnailConfig: {
                shape: "S2c"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Pipeline: {
                shape: "S2l"
              },
              Warnings: {
                shape: "S2n"
              }
            }
          }
        },
        UpdatePipelineNotifications: {
          http: {
            requestUri: "/2012-09-25/pipelines/{Id}/notifications"
          },
          input: {
            type: "structure",
            required: [
              "Id",
              "Notifications"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              Notifications: {
                shape: "S2a"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Pipeline: {
                shape: "S2l"
              }
            }
          }
        },
        UpdatePipelineStatus: {
          http: {
            requestUri: "/2012-09-25/pipelines/{Id}/status"
          },
          input: {
            type: "structure",
            required: [
              "Id",
              "Status"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              Status: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Pipeline: {
                shape: "S2l"
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          members: {
            Key: {},
            FrameRate: {},
            Resolution: {},
            AspectRatio: {},
            Interlaced: {},
            Container: {},
            Encryption: {
              shape: "Sc"
            },
            TimeSpan: {
              shape: "Sg"
            },
            InputCaptions: {
              type: "structure",
              members: {
                MergePolicy: {},
                CaptionSources: {
                  shape: "Sk"
                }
              }
            },
            DetectedProperties: {
              type: "structure",
              members: {
                Width: {
                  type: "integer"
                },
                Height: {
                  type: "integer"
                },
                FrameRate: {},
                FileSize: {
                  type: "long"
                },
                DurationMillis: {
                  type: "long"
                }
              }
            }
          }
        },
        Sc: {
          type: "structure",
          members: {
            Mode: {},
            Key: {},
            KeyMd5: {},
            InitializationVector: {}
          }
        },
        Sg: {
          type: "structure",
          members: {
            StartTime: {},
            Duration: {}
          }
        },
        Sk: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Language: {},
              TimeOffset: {},
              Label: {},
              Encryption: {
                shape: "Sc"
              }
            }
          }
        },
        St: {
          type: "list",
          member: {
            shape: "S5"
          }
        },
        Su: {
          type: "structure",
          members: {
            Key: {},
            ThumbnailPattern: {},
            ThumbnailEncryption: {
              shape: "Sc"
            },
            Rotate: {},
            PresetId: {},
            SegmentDuration: {},
            Watermarks: {
              shape: "Sx"
            },
            AlbumArt: {
              shape: "S11"
            },
            Composition: {
              shape: "S19",
              deprecated: true
            },
            Captions: {
              shape: "S1b"
            },
            Encryption: {
              shape: "Sc"
            }
          }
        },
        Sx: {
          type: "list",
          member: {
            type: "structure",
            members: {
              PresetWatermarkId: {},
              InputKey: {},
              Encryption: {
                shape: "Sc"
              }
            }
          }
        },
        S11: {
          type: "structure",
          members: {
            MergePolicy: {},
            Artwork: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  InputKey: {},
                  MaxWidth: {},
                  MaxHeight: {},
                  SizingPolicy: {},
                  PaddingPolicy: {},
                  AlbumArtFormat: {},
                  Encryption: {
                    shape: "Sc"
                  }
                }
              }
            }
          }
        },
        S19: {
          type: "list",
          member: {
            type: "structure",
            members: {
              TimeSpan: {
                shape: "Sg"
              }
            },
            deprecated: true
          },
          deprecated: true
        },
        S1b: {
          type: "structure",
          members: {
            MergePolicy: {
              deprecated: true
            },
            CaptionSources: {
              shape: "Sk",
              deprecated: true
            },
            CaptionFormats: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Format: {},
                  Pattern: {},
                  Encryption: {
                    shape: "Sc"
                  }
                }
              }
            }
          }
        },
        S1l: {
          type: "list",
          member: {}
        },
        S1m: {
          type: "structure",
          members: {
            Method: {},
            Key: {},
            KeyMd5: {},
            InitializationVector: {},
            LicenseAcquisitionUrl: {},
            KeyStoragePolicy: {}
          }
        },
        S1q: {
          type: "structure",
          members: {
            Format: {},
            Key: {},
            KeyMd5: {},
            KeyId: {},
            InitializationVector: {},
            LicenseAcquisitionUrl: {}
          }
        },
        S1v: {
          type: "map",
          key: {},
          value: {}
        },
        S1y: {
          type: "structure",
          members: {
            Id: {},
            Arn: {},
            PipelineId: {},
            Input: {
              shape: "S5"
            },
            Inputs: {
              shape: "St"
            },
            Output: {
              shape: "S1z"
            },
            Outputs: {
              type: "list",
              member: {
                shape: "S1z"
              }
            },
            OutputKeyPrefix: {},
            Playlists: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Name: {},
                  Format: {},
                  OutputKeys: {
                    shape: "S1l"
                  },
                  HlsContentProtection: {
                    shape: "S1m"
                  },
                  PlayReadyDrm: {
                    shape: "S1q"
                  },
                  Status: {},
                  StatusDetail: {}
                }
              }
            },
            Status: {},
            UserMetadata: {
              shape: "S1v"
            },
            Timing: {
              type: "structure",
              members: {
                SubmitTimeMillis: {
                  type: "long"
                },
                StartTimeMillis: {
                  type: "long"
                },
                FinishTimeMillis: {
                  type: "long"
                }
              }
            }
          }
        },
        S1z: {
          type: "structure",
          members: {
            Id: {},
            Key: {},
            ThumbnailPattern: {},
            ThumbnailEncryption: {
              shape: "Sc"
            },
            Rotate: {},
            PresetId: {},
            SegmentDuration: {},
            Status: {},
            StatusDetail: {},
            Duration: {
              type: "long"
            },
            Width: {
              type: "integer"
            },
            Height: {
              type: "integer"
            },
            FrameRate: {},
            FileSize: {
              type: "long"
            },
            DurationMillis: {
              type: "long"
            },
            Watermarks: {
              shape: "Sx"
            },
            AlbumArt: {
              shape: "S11"
            },
            Composition: {
              shape: "S19",
              deprecated: true
            },
            Captions: {
              shape: "S1b"
            },
            Encryption: {
              shape: "Sc"
            },
            AppliedColorSpaceConversion: {}
          }
        },
        S2a: {
          type: "structure",
          members: {
            Progressing: {},
            Completed: {},
            Warning: {},
            Error: {}
          }
        },
        S2c: {
          type: "structure",
          members: {
            Bucket: {},
            StorageClass: {},
            Permissions: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  GranteeType: {},
                  Grantee: {},
                  Access: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          }
        },
        S2l: {
          type: "structure",
          members: {
            Id: {},
            Arn: {},
            Name: {},
            Status: {},
            InputBucket: {},
            OutputBucket: {},
            Role: {},
            AwsKmsKeyArn: {},
            Notifications: {
              shape: "S2a"
            },
            ContentConfig: {
              shape: "S2c"
            },
            ThumbnailConfig: {
              shape: "S2c"
            }
          }
        },
        S2n: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Code: {},
              Message: {}
            }
          }
        },
        S2r: {
          type: "structure",
          members: {
            Codec: {},
            CodecOptions: {
              type: "map",
              key: {},
              value: {}
            },
            KeyframesMaxDist: {},
            FixedGOP: {},
            BitRate: {},
            FrameRate: {},
            MaxFrameRate: {},
            Resolution: {},
            AspectRatio: {},
            MaxWidth: {},
            MaxHeight: {},
            DisplayAspectRatio: {},
            SizingPolicy: {},
            PaddingPolicy: {},
            Watermarks: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Id: {},
                  MaxWidth: {},
                  MaxHeight: {},
                  SizingPolicy: {},
                  HorizontalAlign: {},
                  HorizontalOffset: {},
                  VerticalAlign: {},
                  VerticalOffset: {},
                  Opacity: {},
                  Target: {}
                }
              }
            }
          }
        },
        S37: {
          type: "structure",
          members: {
            Codec: {},
            SampleRate: {},
            BitRate: {},
            Channels: {},
            AudioPackingMode: {},
            CodecOptions: {
              type: "structure",
              members: {
                Profile: {},
                BitDepth: {},
                BitOrder: {},
                Signed: {}
              }
            }
          }
        },
        S3i: {
          type: "structure",
          members: {
            Format: {},
            Interval: {},
            Resolution: {},
            AspectRatio: {},
            MaxWidth: {},
            MaxHeight: {},
            SizingPolicy: {},
            PaddingPolicy: {}
          }
        },
        S3m: {
          type: "structure",
          members: {
            Id: {},
            Arn: {},
            Name: {},
            Description: {},
            Container: {},
            Audio: {
              shape: "S37"
            },
            Video: {
              shape: "S2r"
            },
            Thumbnails: {
              shape: "S3i"
            },
            Type: {}
          }
        },
        S3v: {
          type: "list",
          member: {
            shape: "S1y"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/elastictranscoder-2012-09-25.paginators.json
var require_elastictranscoder_2012_09_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/elastictranscoder-2012-09-25.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListJobsByPipeline: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          result_key: "Jobs"
        },
        ListJobsByStatus: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          result_key: "Jobs"
        },
        ListPipelines: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          result_key: "Pipelines"
        },
        ListPresets: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          result_key: "Presets"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/elastictranscoder-2012-09-25.waiters2.json
var require_elastictranscoder_2012_09_25_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/elastictranscoder-2012-09-25.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        JobComplete: {
          delay: 30,
          operation: "ReadJob",
          maxAttempts: 120,
          acceptors: [
            {
              expected: "Complete",
              matcher: "path",
              state: "success",
              argument: "Job.Status"
            },
            {
              expected: "Canceled",
              matcher: "path",
              state: "failure",
              argument: "Job.Status"
            },
            {
              expected: "Error",
              matcher: "path",
              state: "failure",
              argument: "Job.Status"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/elastictranscoder.js
var require_elastictranscoder = __commonJS({
  "node_modules/aws-sdk/clients/elastictranscoder.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["elastictranscoder"] = {};
    AWS2.ElasticTranscoder = Service.defineService("elastictranscoder", ["2012-09-25"]);
    Object.defineProperty(apiLoader.services["elastictranscoder"], "2012-09-25", {
      get: function get() {
        var model = require_elastictranscoder_2012_09_25_min();
        model.paginators = require_elastictranscoder_2012_09_25_paginators().pagination;
        model.waiters = require_elastictranscoder_2012_09_25_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ElasticTranscoder;
  }
});

// node_modules/aws-sdk/apis/firehose-2015-08-04.min.json
var require_firehose_2015_08_04_min = __commonJS({
  "node_modules/aws-sdk/apis/firehose-2015-08-04.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-08-04",
        endpointPrefix: "firehose",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Firehose",
        serviceFullName: "Amazon Kinesis Firehose",
        serviceId: "Firehose",
        signatureVersion: "v4",
        targetPrefix: "Firehose_20150804",
        uid: "firehose-2015-08-04"
      },
      operations: {
        CreateDeliveryStream: {
          input: {
            type: "structure",
            required: [
              "DeliveryStreamName"
            ],
            members: {
              DeliveryStreamName: {},
              DeliveryStreamType: {},
              KinesisStreamSourceConfiguration: {
                type: "structure",
                required: [
                  "KinesisStreamARN",
                  "RoleARN"
                ],
                members: {
                  KinesisStreamARN: {},
                  RoleARN: {}
                }
              },
              DeliveryStreamEncryptionConfigurationInput: {
                shape: "S7"
              },
              S3DestinationConfiguration: {
                shape: "Sa",
                deprecated: true
              },
              ExtendedS3DestinationConfiguration: {
                type: "structure",
                required: [
                  "RoleARN",
                  "BucketARN"
                ],
                members: {
                  RoleARN: {},
                  BucketARN: {},
                  Prefix: {},
                  ErrorOutputPrefix: {},
                  BufferingHints: {
                    shape: "Se"
                  },
                  CompressionFormat: {},
                  EncryptionConfiguration: {
                    shape: "Si"
                  },
                  CloudWatchLoggingOptions: {
                    shape: "Sl"
                  },
                  ProcessingConfiguration: {
                    shape: "Sq"
                  },
                  S3BackupMode: {},
                  S3BackupConfiguration: {
                    shape: "Sa"
                  },
                  DataFormatConversionConfiguration: {
                    shape: "Sz"
                  },
                  DynamicPartitioningConfiguration: {
                    shape: "S1o"
                  }
                }
              },
              RedshiftDestinationConfiguration: {
                type: "structure",
                required: [
                  "RoleARN",
                  "ClusterJDBCURL",
                  "CopyCommand",
                  "Username",
                  "Password",
                  "S3Configuration"
                ],
                members: {
                  RoleARN: {},
                  ClusterJDBCURL: {},
                  CopyCommand: {
                    shape: "S1t"
                  },
                  Username: {
                    shape: "S1x"
                  },
                  Password: {
                    shape: "S1y"
                  },
                  RetryOptions: {
                    shape: "S1z"
                  },
                  S3Configuration: {
                    shape: "Sa"
                  },
                  ProcessingConfiguration: {
                    shape: "Sq"
                  },
                  S3BackupMode: {},
                  S3BackupConfiguration: {
                    shape: "Sa"
                  },
                  CloudWatchLoggingOptions: {
                    shape: "Sl"
                  }
                }
              },
              ElasticsearchDestinationConfiguration: {
                type: "structure",
                required: [
                  "RoleARN",
                  "IndexName",
                  "S3Configuration"
                ],
                members: {
                  RoleARN: {},
                  DomainARN: {},
                  ClusterEndpoint: {},
                  IndexName: {},
                  TypeName: {},
                  IndexRotationPeriod: {},
                  BufferingHints: {
                    shape: "S28"
                  },
                  RetryOptions: {
                    shape: "S2b"
                  },
                  S3BackupMode: {},
                  S3Configuration: {
                    shape: "Sa"
                  },
                  ProcessingConfiguration: {
                    shape: "Sq"
                  },
                  CloudWatchLoggingOptions: {
                    shape: "Sl"
                  },
                  VpcConfiguration: {
                    shape: "S2e"
                  },
                  DocumentIdOptions: {
                    shape: "S2h"
                  }
                }
              },
              AmazonopensearchserviceDestinationConfiguration: {
                type: "structure",
                required: [
                  "RoleARN",
                  "IndexName",
                  "S3Configuration"
                ],
                members: {
                  RoleARN: {},
                  DomainARN: {},
                  ClusterEndpoint: {},
                  IndexName: {},
                  TypeName: {},
                  IndexRotationPeriod: {},
                  BufferingHints: {
                    shape: "S2p"
                  },
                  RetryOptions: {
                    shape: "S2s"
                  },
                  S3BackupMode: {},
                  S3Configuration: {
                    shape: "Sa"
                  },
                  ProcessingConfiguration: {
                    shape: "Sq"
                  },
                  CloudWatchLoggingOptions: {
                    shape: "Sl"
                  },
                  VpcConfiguration: {
                    shape: "S2e"
                  },
                  DocumentIdOptions: {
                    shape: "S2h"
                  }
                }
              },
              SplunkDestinationConfiguration: {
                type: "structure",
                required: [
                  "HECEndpoint",
                  "HECEndpointType",
                  "HECToken",
                  "S3Configuration"
                ],
                members: {
                  HECEndpoint: {},
                  HECEndpointType: {},
                  HECToken: {},
                  HECAcknowledgmentTimeoutInSeconds: {
                    type: "integer"
                  },
                  RetryOptions: {
                    shape: "S30"
                  },
                  S3BackupMode: {},
                  S3Configuration: {
                    shape: "Sa"
                  },
                  ProcessingConfiguration: {
                    shape: "Sq"
                  },
                  CloudWatchLoggingOptions: {
                    shape: "Sl"
                  },
                  BufferingHints: {
                    shape: "S33"
                  }
                }
              },
              HttpEndpointDestinationConfiguration: {
                type: "structure",
                required: [
                  "EndpointConfiguration",
                  "S3Configuration"
                ],
                members: {
                  EndpointConfiguration: {
                    shape: "S37"
                  },
                  BufferingHints: {
                    shape: "S3b"
                  },
                  CloudWatchLoggingOptions: {
                    shape: "Sl"
                  },
                  RequestConfiguration: {
                    shape: "S3e"
                  },
                  ProcessingConfiguration: {
                    shape: "Sq"
                  },
                  RoleARN: {},
                  RetryOptions: {
                    shape: "S3k"
                  },
                  S3BackupMode: {},
                  S3Configuration: {
                    shape: "Sa"
                  }
                }
              },
              Tags: {
                shape: "S3n"
              },
              AmazonOpenSearchServerlessDestinationConfiguration: {
                type: "structure",
                required: [
                  "RoleARN",
                  "IndexName",
                  "S3Configuration"
                ],
                members: {
                  RoleARN: {},
                  CollectionEndpoint: {},
                  IndexName: {},
                  BufferingHints: {
                    shape: "S3u"
                  },
                  RetryOptions: {
                    shape: "S3x"
                  },
                  S3BackupMode: {},
                  S3Configuration: {
                    shape: "Sa"
                  },
                  ProcessingConfiguration: {
                    shape: "Sq"
                  },
                  CloudWatchLoggingOptions: {
                    shape: "Sl"
                  },
                  VpcConfiguration: {
                    shape: "S2e"
                  }
                }
              },
              MSKSourceConfiguration: {
                type: "structure",
                required: [
                  "MSKClusterARN",
                  "TopicName",
                  "AuthenticationConfiguration"
                ],
                members: {
                  MSKClusterARN: {},
                  TopicName: {},
                  AuthenticationConfiguration: {
                    shape: "S43"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeliveryStreamARN: {}
            }
          }
        },
        DeleteDeliveryStream: {
          input: {
            type: "structure",
            required: [
              "DeliveryStreamName"
            ],
            members: {
              DeliveryStreamName: {},
              AllowForceDelete: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeDeliveryStream: {
          input: {
            type: "structure",
            required: [
              "DeliveryStreamName"
            ],
            members: {
              DeliveryStreamName: {},
              Limit: {
                type: "integer"
              },
              ExclusiveStartDestinationId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "DeliveryStreamDescription"
            ],
            members: {
              DeliveryStreamDescription: {
                type: "structure",
                required: [
                  "DeliveryStreamName",
                  "DeliveryStreamARN",
                  "DeliveryStreamStatus",
                  "DeliveryStreamType",
                  "VersionId",
                  "Destinations",
                  "HasMoreDestinations"
                ],
                members: {
                  DeliveryStreamName: {},
                  DeliveryStreamARN: {},
                  DeliveryStreamStatus: {},
                  FailureDescription: {
                    shape: "S4f"
                  },
                  DeliveryStreamEncryptionConfiguration: {
                    type: "structure",
                    members: {
                      KeyARN: {},
                      KeyType: {},
                      Status: {},
                      FailureDescription: {
                        shape: "S4f"
                      }
                    }
                  },
                  DeliveryStreamType: {},
                  VersionId: {},
                  CreateTimestamp: {
                    type: "timestamp"
                  },
                  LastUpdateTimestamp: {
                    type: "timestamp"
                  },
                  Source: {
                    type: "structure",
                    members: {
                      KinesisStreamSourceDescription: {
                        type: "structure",
                        members: {
                          KinesisStreamARN: {},
                          RoleARN: {},
                          DeliveryStartTimestamp: {
                            type: "timestamp"
                          }
                        }
                      },
                      MSKSourceDescription: {
                        type: "structure",
                        members: {
                          MSKClusterARN: {},
                          TopicName: {},
                          AuthenticationConfiguration: {
                            shape: "S43"
                          },
                          DeliveryStartTimestamp: {
                            type: "timestamp"
                          }
                        }
                      }
                    }
                  },
                  Destinations: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "DestinationId"
                      ],
                      members: {
                        DestinationId: {},
                        S3DestinationDescription: {
                          shape: "S4r"
                        },
                        ExtendedS3DestinationDescription: {
                          type: "structure",
                          required: [
                            "RoleARN",
                            "BucketARN",
                            "BufferingHints",
                            "CompressionFormat",
                            "EncryptionConfiguration"
                          ],
                          members: {
                            RoleARN: {},
                            BucketARN: {},
                            Prefix: {},
                            ErrorOutputPrefix: {},
                            BufferingHints: {
                              shape: "Se"
                            },
                            CompressionFormat: {},
                            EncryptionConfiguration: {
                              shape: "Si"
                            },
                            CloudWatchLoggingOptions: {
                              shape: "Sl"
                            },
                            ProcessingConfiguration: {
                              shape: "Sq"
                            },
                            S3BackupMode: {},
                            S3BackupDescription: {
                              shape: "S4r"
                            },
                            DataFormatConversionConfiguration: {
                              shape: "Sz"
                            },
                            DynamicPartitioningConfiguration: {
                              shape: "S1o"
                            }
                          }
                        },
                        RedshiftDestinationDescription: {
                          type: "structure",
                          required: [
                            "RoleARN",
                            "ClusterJDBCURL",
                            "CopyCommand",
                            "Username",
                            "S3DestinationDescription"
                          ],
                          members: {
                            RoleARN: {},
                            ClusterJDBCURL: {},
                            CopyCommand: {
                              shape: "S1t"
                            },
                            Username: {
                              shape: "S1x"
                            },
                            RetryOptions: {
                              shape: "S1z"
                            },
                            S3DestinationDescription: {
                              shape: "S4r"
                            },
                            ProcessingConfiguration: {
                              shape: "Sq"
                            },
                            S3BackupMode: {},
                            S3BackupDescription: {
                              shape: "S4r"
                            },
                            CloudWatchLoggingOptions: {
                              shape: "Sl"
                            }
                          }
                        },
                        ElasticsearchDestinationDescription: {
                          type: "structure",
                          members: {
                            RoleARN: {},
                            DomainARN: {},
                            ClusterEndpoint: {},
                            IndexName: {},
                            TypeName: {},
                            IndexRotationPeriod: {},
                            BufferingHints: {
                              shape: "S28"
                            },
                            RetryOptions: {
                              shape: "S2b"
                            },
                            S3BackupMode: {},
                            S3DestinationDescription: {
                              shape: "S4r"
                            },
                            ProcessingConfiguration: {
                              shape: "Sq"
                            },
                            CloudWatchLoggingOptions: {
                              shape: "Sl"
                            },
                            VpcConfigurationDescription: {
                              shape: "S4v"
                            },
                            DocumentIdOptions: {
                              shape: "S2h"
                            }
                          }
                        },
                        AmazonopensearchserviceDestinationDescription: {
                          type: "structure",
                          members: {
                            RoleARN: {},
                            DomainARN: {},
                            ClusterEndpoint: {},
                            IndexName: {},
                            TypeName: {},
                            IndexRotationPeriod: {},
                            BufferingHints: {
                              shape: "S2p"
                            },
                            RetryOptions: {
                              shape: "S2s"
                            },
                            S3BackupMode: {},
                            S3DestinationDescription: {
                              shape: "S4r"
                            },
                            ProcessingConfiguration: {
                              shape: "Sq"
                            },
                            CloudWatchLoggingOptions: {
                              shape: "Sl"
                            },
                            VpcConfigurationDescription: {
                              shape: "S4v"
                            },
                            DocumentIdOptions: {
                              shape: "S2h"
                            }
                          }
                        },
                        SplunkDestinationDescription: {
                          type: "structure",
                          members: {
                            HECEndpoint: {},
                            HECEndpointType: {},
                            HECToken: {},
                            HECAcknowledgmentTimeoutInSeconds: {
                              type: "integer"
                            },
                            RetryOptions: {
                              shape: "S30"
                            },
                            S3BackupMode: {},
                            S3DestinationDescription: {
                              shape: "S4r"
                            },
                            ProcessingConfiguration: {
                              shape: "Sq"
                            },
                            CloudWatchLoggingOptions: {
                              shape: "Sl"
                            },
                            BufferingHints: {
                              shape: "S33"
                            }
                          }
                        },
                        HttpEndpointDestinationDescription: {
                          type: "structure",
                          members: {
                            EndpointConfiguration: {
                              type: "structure",
                              members: {
                                Url: {
                                  shape: "S38"
                                },
                                Name: {}
                              }
                            },
                            BufferingHints: {
                              shape: "S3b"
                            },
                            CloudWatchLoggingOptions: {
                              shape: "Sl"
                            },
                            RequestConfiguration: {
                              shape: "S3e"
                            },
                            ProcessingConfiguration: {
                              shape: "Sq"
                            },
                            RoleARN: {},
                            RetryOptions: {
                              shape: "S3k"
                            },
                            S3BackupMode: {},
                            S3DestinationDescription: {
                              shape: "S4r"
                            }
                          }
                        },
                        AmazonOpenSearchServerlessDestinationDescription: {
                          type: "structure",
                          members: {
                            RoleARN: {},
                            CollectionEndpoint: {},
                            IndexName: {},
                            BufferingHints: {
                              shape: "S3u"
                            },
                            RetryOptions: {
                              shape: "S3x"
                            },
                            S3BackupMode: {},
                            S3DestinationDescription: {
                              shape: "S4r"
                            },
                            ProcessingConfiguration: {
                              shape: "Sq"
                            },
                            CloudWatchLoggingOptions: {
                              shape: "Sl"
                            },
                            VpcConfigurationDescription: {
                              shape: "S4v"
                            }
                          }
                        }
                      }
                    }
                  },
                  HasMoreDestinations: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        ListDeliveryStreams: {
          input: {
            type: "structure",
            members: {
              Limit: {
                type: "integer"
              },
              DeliveryStreamType: {},
              ExclusiveStartDeliveryStreamName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "DeliveryStreamNames",
              "HasMoreDeliveryStreams"
            ],
            members: {
              DeliveryStreamNames: {
                type: "list",
                member: {}
              },
              HasMoreDeliveryStreams: {
                type: "boolean"
              }
            }
          }
        },
        ListTagsForDeliveryStream: {
          input: {
            type: "structure",
            required: [
              "DeliveryStreamName"
            ],
            members: {
              DeliveryStreamName: {},
              ExclusiveStartTagKey: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Tags",
              "HasMoreTags"
            ],
            members: {
              Tags: {
                type: "list",
                member: {
                  shape: "S3o"
                }
              },
              HasMoreTags: {
                type: "boolean"
              }
            }
          }
        },
        PutRecord: {
          input: {
            type: "structure",
            required: [
              "DeliveryStreamName",
              "Record"
            ],
            members: {
              DeliveryStreamName: {},
              Record: {
                shape: "S5a"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "RecordId"
            ],
            members: {
              RecordId: {},
              Encrypted: {
                type: "boolean"
              }
            }
          }
        },
        PutRecordBatch: {
          input: {
            type: "structure",
            required: [
              "DeliveryStreamName",
              "Records"
            ],
            members: {
              DeliveryStreamName: {},
              Records: {
                type: "list",
                member: {
                  shape: "S5a"
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "FailedPutCount",
              "RequestResponses"
            ],
            members: {
              FailedPutCount: {
                type: "integer"
              },
              Encrypted: {
                type: "boolean"
              },
              RequestResponses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RecordId: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        StartDeliveryStreamEncryption: {
          input: {
            type: "structure",
            required: [
              "DeliveryStreamName"
            ],
            members: {
              DeliveryStreamName: {},
              DeliveryStreamEncryptionConfigurationInput: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StopDeliveryStreamEncryption: {
          input: {
            type: "structure",
            required: [
              "DeliveryStreamName"
            ],
            members: {
              DeliveryStreamName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagDeliveryStream: {
          input: {
            type: "structure",
            required: [
              "DeliveryStreamName",
              "Tags"
            ],
            members: {
              DeliveryStreamName: {},
              Tags: {
                shape: "S3n"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagDeliveryStream: {
          input: {
            type: "structure",
            required: [
              "DeliveryStreamName",
              "TagKeys"
            ],
            members: {
              DeliveryStreamName: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDestination: {
          input: {
            type: "structure",
            required: [
              "DeliveryStreamName",
              "CurrentDeliveryStreamVersionId",
              "DestinationId"
            ],
            members: {
              DeliveryStreamName: {},
              CurrentDeliveryStreamVersionId: {},
              DestinationId: {},
              S3DestinationUpdate: {
                shape: "S5v",
                deprecated: true
              },
              ExtendedS3DestinationUpdate: {
                type: "structure",
                members: {
                  RoleARN: {},
                  BucketARN: {},
                  Prefix: {},
                  ErrorOutputPrefix: {},
                  BufferingHints: {
                    shape: "Se"
                  },
                  CompressionFormat: {},
                  EncryptionConfiguration: {
                    shape: "Si"
                  },
                  CloudWatchLoggingOptions: {
                    shape: "Sl"
                  },
                  ProcessingConfiguration: {
                    shape: "Sq"
                  },
                  S3BackupMode: {},
                  S3BackupUpdate: {
                    shape: "S5v"
                  },
                  DataFormatConversionConfiguration: {
                    shape: "Sz"
                  },
                  DynamicPartitioningConfiguration: {
                    shape: "S1o"
                  }
                }
              },
              RedshiftDestinationUpdate: {
                type: "structure",
                members: {
                  RoleARN: {},
                  ClusterJDBCURL: {},
                  CopyCommand: {
                    shape: "S1t"
                  },
                  Username: {
                    shape: "S1x"
                  },
                  Password: {
                    shape: "S1y"
                  },
                  RetryOptions: {
                    shape: "S1z"
                  },
                  S3Update: {
                    shape: "S5v"
                  },
                  ProcessingConfiguration: {
                    shape: "Sq"
                  },
                  S3BackupMode: {},
                  S3BackupUpdate: {
                    shape: "S5v"
                  },
                  CloudWatchLoggingOptions: {
                    shape: "Sl"
                  }
                }
              },
              ElasticsearchDestinationUpdate: {
                type: "structure",
                members: {
                  RoleARN: {},
                  DomainARN: {},
                  ClusterEndpoint: {},
                  IndexName: {},
                  TypeName: {},
                  IndexRotationPeriod: {},
                  BufferingHints: {
                    shape: "S28"
                  },
                  RetryOptions: {
                    shape: "S2b"
                  },
                  S3Update: {
                    shape: "S5v"
                  },
                  ProcessingConfiguration: {
                    shape: "Sq"
                  },
                  CloudWatchLoggingOptions: {
                    shape: "Sl"
                  },
                  DocumentIdOptions: {
                    shape: "S2h"
                  }
                }
              },
              AmazonopensearchserviceDestinationUpdate: {
                type: "structure",
                members: {
                  RoleARN: {},
                  DomainARN: {},
                  ClusterEndpoint: {},
                  IndexName: {},
                  TypeName: {},
                  IndexRotationPeriod: {},
                  BufferingHints: {
                    shape: "S2p"
                  },
                  RetryOptions: {
                    shape: "S2s"
                  },
                  S3Update: {
                    shape: "S5v"
                  },
                  ProcessingConfiguration: {
                    shape: "Sq"
                  },
                  CloudWatchLoggingOptions: {
                    shape: "Sl"
                  },
                  DocumentIdOptions: {
                    shape: "S2h"
                  }
                }
              },
              SplunkDestinationUpdate: {
                type: "structure",
                members: {
                  HECEndpoint: {},
                  HECEndpointType: {},
                  HECToken: {},
                  HECAcknowledgmentTimeoutInSeconds: {
                    type: "integer"
                  },
                  RetryOptions: {
                    shape: "S30"
                  },
                  S3BackupMode: {},
                  S3Update: {
                    shape: "S5v"
                  },
                  ProcessingConfiguration: {
                    shape: "Sq"
                  },
                  CloudWatchLoggingOptions: {
                    shape: "Sl"
                  },
                  BufferingHints: {
                    shape: "S33"
                  }
                }
              },
              HttpEndpointDestinationUpdate: {
                type: "structure",
                members: {
                  EndpointConfiguration: {
                    shape: "S37"
                  },
                  BufferingHints: {
                    shape: "S3b"
                  },
                  CloudWatchLoggingOptions: {
                    shape: "Sl"
                  },
                  RequestConfiguration: {
                    shape: "S3e"
                  },
                  ProcessingConfiguration: {
                    shape: "Sq"
                  },
                  RoleARN: {},
                  RetryOptions: {
                    shape: "S3k"
                  },
                  S3BackupMode: {},
                  S3Update: {
                    shape: "S5v"
                  }
                }
              },
              AmazonOpenSearchServerlessDestinationUpdate: {
                type: "structure",
                members: {
                  RoleARN: {},
                  CollectionEndpoint: {},
                  IndexName: {},
                  BufferingHints: {
                    shape: "S3u"
                  },
                  RetryOptions: {
                    shape: "S3x"
                  },
                  S3Update: {
                    shape: "S5v"
                  },
                  ProcessingConfiguration: {
                    shape: "Sq"
                  },
                  CloudWatchLoggingOptions: {
                    shape: "Sl"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S7: {
          type: "structure",
          required: [
            "KeyType"
          ],
          members: {
            KeyARN: {},
            KeyType: {}
          }
        },
        Sa: {
          type: "structure",
          required: [
            "RoleARN",
            "BucketARN"
          ],
          members: {
            RoleARN: {},
            BucketARN: {},
            Prefix: {},
            ErrorOutputPrefix: {},
            BufferingHints: {
              shape: "Se"
            },
            CompressionFormat: {},
            EncryptionConfiguration: {
              shape: "Si"
            },
            CloudWatchLoggingOptions: {
              shape: "Sl"
            }
          }
        },
        Se: {
          type: "structure",
          members: {
            SizeInMBs: {
              type: "integer"
            },
            IntervalInSeconds: {
              type: "integer"
            }
          }
        },
        Si: {
          type: "structure",
          members: {
            NoEncryptionConfig: {},
            KMSEncryptionConfig: {
              type: "structure",
              required: [
                "AWSKMSKeyARN"
              ],
              members: {
                AWSKMSKeyARN: {}
              }
            }
          }
        },
        Sl: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            LogGroupName: {},
            LogStreamName: {}
          }
        },
        Sq: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            Processors: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Type"
                ],
                members: {
                  Type: {},
                  Parameters: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "ParameterName",
                        "ParameterValue"
                      ],
                      members: {
                        ParameterName: {},
                        ParameterValue: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sz: {
          type: "structure",
          members: {
            SchemaConfiguration: {
              type: "structure",
              members: {
                RoleARN: {},
                CatalogId: {},
                DatabaseName: {},
                TableName: {},
                Region: {},
                VersionId: {}
              }
            },
            InputFormatConfiguration: {
              type: "structure",
              members: {
                Deserializer: {
                  type: "structure",
                  members: {
                    OpenXJsonSerDe: {
                      type: "structure",
                      members: {
                        ConvertDotsInJsonKeysToUnderscores: {
                          type: "boolean"
                        },
                        CaseInsensitive: {
                          type: "boolean"
                        },
                        ColumnToJsonKeyMappings: {
                          type: "map",
                          key: {},
                          value: {}
                        }
                      }
                    },
                    HiveJsonSerDe: {
                      type: "structure",
                      members: {
                        TimestampFormats: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  }
                }
              }
            },
            OutputFormatConfiguration: {
              type: "structure",
              members: {
                Serializer: {
                  type: "structure",
                  members: {
                    ParquetSerDe: {
                      type: "structure",
                      members: {
                        BlockSizeBytes: {
                          type: "integer"
                        },
                        PageSizeBytes: {
                          type: "integer"
                        },
                        Compression: {},
                        EnableDictionaryCompression: {
                          type: "boolean"
                        },
                        MaxPaddingBytes: {
                          type: "integer"
                        },
                        WriterVersion: {}
                      }
                    },
                    OrcSerDe: {
                      type: "structure",
                      members: {
                        StripeSizeBytes: {
                          type: "integer"
                        },
                        BlockSizeBytes: {
                          type: "integer"
                        },
                        RowIndexStride: {
                          type: "integer"
                        },
                        EnablePadding: {
                          type: "boolean"
                        },
                        PaddingTolerance: {
                          type: "double"
                        },
                        Compression: {},
                        BloomFilterColumns: {
                          type: "list",
                          member: {}
                        },
                        BloomFilterFalsePositiveProbability: {
                          type: "double"
                        },
                        DictionaryKeyThreshold: {
                          type: "double"
                        },
                        FormatVersion: {}
                      }
                    }
                  }
                }
              }
            },
            Enabled: {
              type: "boolean"
            }
          }
        },
        S1o: {
          type: "structure",
          members: {
            RetryOptions: {
              type: "structure",
              members: {
                DurationInSeconds: {
                  type: "integer"
                }
              }
            },
            Enabled: {
              type: "boolean"
            }
          }
        },
        S1t: {
          type: "structure",
          required: [
            "DataTableName"
          ],
          members: {
            DataTableName: {},
            DataTableColumns: {},
            CopyOptions: {}
          }
        },
        S1x: {
          type: "string",
          sensitive: true
        },
        S1y: {
          type: "string",
          sensitive: true
        },
        S1z: {
          type: "structure",
          members: {
            DurationInSeconds: {
              type: "integer"
            }
          }
        },
        S28: {
          type: "structure",
          members: {
            IntervalInSeconds: {
              type: "integer"
            },
            SizeInMBs: {
              type: "integer"
            }
          }
        },
        S2b: {
          type: "structure",
          members: {
            DurationInSeconds: {
              type: "integer"
            }
          }
        },
        S2e: {
          type: "structure",
          required: [
            "SubnetIds",
            "RoleARN",
            "SecurityGroupIds"
          ],
          members: {
            SubnetIds: {
              shape: "S2f"
            },
            RoleARN: {},
            SecurityGroupIds: {
              shape: "S2g"
            }
          }
        },
        S2f: {
          type: "list",
          member: {}
        },
        S2g: {
          type: "list",
          member: {}
        },
        S2h: {
          type: "structure",
          required: [
            "DefaultDocumentIdFormat"
          ],
          members: {
            DefaultDocumentIdFormat: {}
          }
        },
        S2p: {
          type: "structure",
          members: {
            IntervalInSeconds: {
              type: "integer"
            },
            SizeInMBs: {
              type: "integer"
            }
          }
        },
        S2s: {
          type: "structure",
          members: {
            DurationInSeconds: {
              type: "integer"
            }
          }
        },
        S30: {
          type: "structure",
          members: {
            DurationInSeconds: {
              type: "integer"
            }
          }
        },
        S33: {
          type: "structure",
          members: {
            IntervalInSeconds: {
              type: "integer"
            },
            SizeInMBs: {
              type: "integer"
            }
          }
        },
        S37: {
          type: "structure",
          required: [
            "Url"
          ],
          members: {
            Url: {
              shape: "S38"
            },
            Name: {},
            AccessKey: {
              type: "string",
              sensitive: true
            }
          }
        },
        S38: {
          type: "string",
          sensitive: true
        },
        S3b: {
          type: "structure",
          members: {
            SizeInMBs: {
              type: "integer"
            },
            IntervalInSeconds: {
              type: "integer"
            }
          }
        },
        S3e: {
          type: "structure",
          members: {
            ContentEncoding: {},
            CommonAttributes: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "AttributeName",
                  "AttributeValue"
                ],
                members: {
                  AttributeName: {
                    type: "string",
                    sensitive: true
                  },
                  AttributeValue: {
                    type: "string",
                    sensitive: true
                  }
                }
              }
            }
          }
        },
        S3k: {
          type: "structure",
          members: {
            DurationInSeconds: {
              type: "integer"
            }
          }
        },
        S3n: {
          type: "list",
          member: {
            shape: "S3o"
          }
        },
        S3o: {
          type: "structure",
          required: [
            "Key"
          ],
          members: {
            Key: {},
            Value: {}
          }
        },
        S3u: {
          type: "structure",
          members: {
            IntervalInSeconds: {
              type: "integer"
            },
            SizeInMBs: {
              type: "integer"
            }
          }
        },
        S3x: {
          type: "structure",
          members: {
            DurationInSeconds: {
              type: "integer"
            }
          }
        },
        S43: {
          type: "structure",
          required: [
            "RoleARN",
            "Connectivity"
          ],
          members: {
            RoleARN: {},
            Connectivity: {}
          }
        },
        S4f: {
          type: "structure",
          required: [
            "Type",
            "Details"
          ],
          members: {
            Type: {},
            Details: {}
          }
        },
        S4r: {
          type: "structure",
          required: [
            "RoleARN",
            "BucketARN",
            "BufferingHints",
            "CompressionFormat",
            "EncryptionConfiguration"
          ],
          members: {
            RoleARN: {},
            BucketARN: {},
            Prefix: {},
            ErrorOutputPrefix: {},
            BufferingHints: {
              shape: "Se"
            },
            CompressionFormat: {},
            EncryptionConfiguration: {
              shape: "Si"
            },
            CloudWatchLoggingOptions: {
              shape: "Sl"
            }
          }
        },
        S4v: {
          type: "structure",
          required: [
            "SubnetIds",
            "RoleARN",
            "SecurityGroupIds",
            "VpcId"
          ],
          members: {
            SubnetIds: {
              shape: "S2f"
            },
            RoleARN: {},
            SecurityGroupIds: {
              shape: "S2g"
            },
            VpcId: {}
          }
        },
        S5a: {
          type: "structure",
          required: [
            "Data"
          ],
          members: {
            Data: {
              type: "blob"
            }
          }
        },
        S5v: {
          type: "structure",
          members: {
            RoleARN: {},
            BucketARN: {},
            Prefix: {},
            ErrorOutputPrefix: {},
            BufferingHints: {
              shape: "Se"
            },
            CompressionFormat: {},
            EncryptionConfiguration: {
              shape: "Si"
            },
            CloudWatchLoggingOptions: {
              shape: "Sl"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/firehose-2015-08-04.paginators.json
var require_firehose_2015_08_04_paginators = __commonJS({
  "node_modules/aws-sdk/apis/firehose-2015-08-04.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/firehose.js
var require_firehose = __commonJS({
  "node_modules/aws-sdk/clients/firehose.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["firehose"] = {};
    AWS2.Firehose = Service.defineService("firehose", ["2015-08-04"]);
    Object.defineProperty(apiLoader.services["firehose"], "2015-08-04", {
      get: function get() {
        var model = require_firehose_2015_08_04_min();
        model.paginators = require_firehose_2015_08_04_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Firehose;
  }
});

// node_modules/aws-sdk/apis/gamelift-2015-10-01.min.json
var require_gamelift_2015_10_01_min = __commonJS({
  "node_modules/aws-sdk/apis/gamelift-2015-10-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-10-01",
        endpointPrefix: "gamelift",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon GameLift",
        serviceId: "GameLift",
        signatureVersion: "v4",
        targetPrefix: "GameLift",
        uid: "gamelift-2015-10-01"
      },
      operations: {
        AcceptMatch: {
          input: {
            type: "structure",
            required: [
              "TicketId",
              "PlayerIds",
              "AcceptanceType"
            ],
            members: {
              TicketId: {},
              PlayerIds: {
                type: "list",
                member: {
                  shape: "S4"
                },
                sensitive: true
              },
              AcceptanceType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ClaimGameServer: {
          input: {
            type: "structure",
            required: [
              "GameServerGroupName"
            ],
            members: {
              GameServerGroupName: {},
              GameServerId: {},
              GameServerData: {},
              FilterOption: {
                type: "structure",
                members: {
                  InstanceStatuses: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GameServer: {
                shape: "Sf"
              }
            }
          }
        },
        CreateAlias: {
          input: {
            type: "structure",
            required: [
              "Name",
              "RoutingStrategy"
            ],
            members: {
              Name: {},
              Description: {},
              RoutingStrategy: {
                shape: "Sq"
              },
              Tags: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Alias: {
                shape: "Sz"
              }
            }
          }
        },
        CreateBuild: {
          input: {
            type: "structure",
            members: {
              Name: {},
              Version: {},
              StorageLocation: {
                shape: "S13"
              },
              OperatingSystem: {},
              Tags: {
                shape: "Su"
              },
              ServerSdkVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Build: {
                shape: "S18"
              },
              UploadCredentials: {
                shape: "S1d"
              },
              StorageLocation: {
                shape: "S13"
              }
            }
          }
        },
        CreateFleet: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Description: {},
              BuildId: {},
              ScriptId: {},
              ServerLaunchPath: {},
              ServerLaunchParameters: {},
              LogPaths: {
                shape: "S1j"
              },
              EC2InstanceType: {},
              EC2InboundPermissions: {
                shape: "S1l"
              },
              NewGameSessionProtectionPolicy: {},
              RuntimeConfiguration: {
                shape: "S1r"
              },
              ResourceCreationLimitPolicy: {
                shape: "S1x"
              },
              MetricGroups: {
                shape: "S1z"
              },
              PeerVpcAwsAccountId: {},
              PeerVpcId: {},
              FleetType: {},
              InstanceRoleArn: {},
              CertificateConfiguration: {
                shape: "S22"
              },
              Locations: {
                shape: "S24"
              },
              Tags: {
                shape: "Su"
              },
              ComputeType: {},
              AnywhereConfiguration: {
                shape: "S28"
              },
              InstanceRoleCredentialsProvider: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FleetAttributes: {
                shape: "S2c"
              },
              LocationStates: {
                shape: "S2j"
              }
            }
          }
        },
        CreateFleetLocations: {
          input: {
            type: "structure",
            required: [
              "FleetId",
              "Locations"
            ],
            members: {
              FleetId: {},
              Locations: {
                shape: "S24"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FleetId: {},
              FleetArn: {},
              LocationStates: {
                shape: "S2j"
              }
            }
          }
        },
        CreateGameServerGroup: {
          input: {
            type: "structure",
            required: [
              "GameServerGroupName",
              "RoleArn",
              "MinSize",
              "MaxSize",
              "LaunchTemplate",
              "InstanceDefinitions"
            ],
            members: {
              GameServerGroupName: {},
              RoleArn: {},
              MinSize: {
                type: "integer"
              },
              MaxSize: {
                type: "integer"
              },
              LaunchTemplate: {
                type: "structure",
                members: {
                  LaunchTemplateId: {},
                  LaunchTemplateName: {},
                  Version: {}
                }
              },
              InstanceDefinitions: {
                shape: "S2u"
              },
              AutoScalingPolicy: {
                type: "structure",
                required: [
                  "TargetTrackingConfiguration"
                ],
                members: {
                  EstimatedInstanceWarmup: {
                    type: "integer"
                  },
                  TargetTrackingConfiguration: {
                    type: "structure",
                    required: [
                      "TargetValue"
                    ],
                    members: {
                      TargetValue: {
                        type: "double"
                      }
                    }
                  }
                }
              },
              BalancingStrategy: {},
              GameServerProtectionPolicy: {},
              VpcSubnets: {
                type: "list",
                member: {}
              },
              Tags: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GameServerGroup: {
                shape: "S36"
              }
            }
          }
        },
        CreateGameSession: {
          input: {
            type: "structure",
            required: [
              "MaximumPlayerSessionCount"
            ],
            members: {
              FleetId: {},
              AliasId: {},
              MaximumPlayerSessionCount: {
                type: "integer"
              },
              Name: {},
              GameProperties: {
                shape: "S3d"
              },
              CreatorId: {},
              GameSessionId: {},
              IdempotencyToken: {},
              GameSessionData: {},
              Location: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameSession: {
                shape: "S3k"
              }
            }
          }
        },
        CreateGameSessionQueue: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              TimeoutInSeconds: {
                type: "integer"
              },
              PlayerLatencyPolicies: {
                shape: "S3t"
              },
              Destinations: {
                shape: "S3v"
              },
              FilterConfiguration: {
                shape: "S3y"
              },
              PriorityConfiguration: {
                shape: "S40"
              },
              CustomEventData: {},
              NotificationTarget: {},
              Tags: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GameSessionQueue: {
                shape: "S46"
              }
            }
          }
        },
        CreateLocation: {
          input: {
            type: "structure",
            required: [
              "LocationName"
            ],
            members: {
              LocationName: {},
              Tags: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Location: {
                shape: "S4b"
              }
            }
          }
        },
        CreateMatchmakingConfiguration: {
          input: {
            type: "structure",
            required: [
              "Name",
              "RequestTimeoutSeconds",
              "AcceptanceRequired",
              "RuleSetName"
            ],
            members: {
              Name: {},
              Description: {},
              GameSessionQueueArns: {
                shape: "S4e"
              },
              RequestTimeoutSeconds: {
                type: "integer"
              },
              AcceptanceTimeoutSeconds: {
                type: "integer"
              },
              AcceptanceRequired: {
                type: "boolean"
              },
              RuleSetName: {},
              NotificationTarget: {},
              AdditionalPlayerCount: {
                type: "integer"
              },
              CustomEventData: {},
              GameProperties: {
                shape: "S3d"
              },
              GameSessionData: {},
              BackfillMode: {},
              FlexMatchMode: {},
              Tags: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Configuration: {
                shape: "S4p"
              }
            }
          }
        },
        CreateMatchmakingRuleSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "RuleSetBody"
            ],
            members: {
              Name: {},
              RuleSetBody: {},
              Tags: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "RuleSet"
            ],
            members: {
              RuleSet: {
                shape: "S4v"
              }
            }
          }
        },
        CreatePlayerSession: {
          input: {
            type: "structure",
            required: [
              "GameSessionId",
              "PlayerId"
            ],
            members: {
              GameSessionId: {},
              PlayerId: {
                shape: "S4"
              },
              PlayerData: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PlayerSession: {
                shape: "S4z"
              }
            }
          }
        },
        CreatePlayerSessions: {
          input: {
            type: "structure",
            required: [
              "GameSessionId",
              "PlayerIds"
            ],
            members: {
              GameSessionId: {},
              PlayerIds: {
                type: "list",
                member: {
                  shape: "S4"
                },
                sensitive: true
              },
              PlayerDataMap: {
                type: "map",
                key: {},
                value: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PlayerSessions: {
                shape: "S56"
              }
            }
          }
        },
        CreateScript: {
          input: {
            type: "structure",
            members: {
              Name: {},
              Version: {},
              StorageLocation: {
                shape: "S13"
              },
              ZipFile: {
                type: "blob"
              },
              Tags: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Script: {
                shape: "S5a"
              }
            }
          }
        },
        CreateVpcPeeringAuthorization: {
          input: {
            type: "structure",
            required: [
              "GameLiftAwsAccountId",
              "PeerVpcId"
            ],
            members: {
              GameLiftAwsAccountId: {},
              PeerVpcId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VpcPeeringAuthorization: {
                shape: "S5d"
              }
            }
          }
        },
        CreateVpcPeeringConnection: {
          input: {
            type: "structure",
            required: [
              "FleetId",
              "PeerVpcAwsAccountId",
              "PeerVpcId"
            ],
            members: {
              FleetId: {},
              PeerVpcAwsAccountId: {},
              PeerVpcId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAlias: {
          input: {
            type: "structure",
            required: [
              "AliasId"
            ],
            members: {
              AliasId: {}
            }
          }
        },
        DeleteBuild: {
          input: {
            type: "structure",
            required: [
              "BuildId"
            ],
            members: {
              BuildId: {}
            }
          }
        },
        DeleteFleet: {
          input: {
            type: "structure",
            required: [
              "FleetId"
            ],
            members: {
              FleetId: {}
            }
          }
        },
        DeleteFleetLocations: {
          input: {
            type: "structure",
            required: [
              "FleetId",
              "Locations"
            ],
            members: {
              FleetId: {},
              Locations: {
                shape: "S3z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FleetId: {},
              FleetArn: {},
              LocationStates: {
                shape: "S2j"
              }
            }
          }
        },
        DeleteGameServerGroup: {
          input: {
            type: "structure",
            required: [
              "GameServerGroupName"
            ],
            members: {
              GameServerGroupName: {},
              DeleteOption: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameServerGroup: {
                shape: "S36"
              }
            }
          }
        },
        DeleteGameSessionQueue: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteLocation: {
          input: {
            type: "structure",
            required: [
              "LocationName"
            ],
            members: {
              LocationName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteMatchmakingConfiguration: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteMatchmakingRuleSet: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteScalingPolicy: {
          input: {
            type: "structure",
            required: [
              "Name",
              "FleetId"
            ],
            members: {
              Name: {},
              FleetId: {}
            }
          }
        },
        DeleteScript: {
          input: {
            type: "structure",
            required: [
              "ScriptId"
            ],
            members: {
              ScriptId: {}
            }
          }
        },
        DeleteVpcPeeringAuthorization: {
          input: {
            type: "structure",
            required: [
              "GameLiftAwsAccountId",
              "PeerVpcId"
            ],
            members: {
              GameLiftAwsAccountId: {},
              PeerVpcId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteVpcPeeringConnection: {
          input: {
            type: "structure",
            required: [
              "FleetId",
              "VpcPeeringConnectionId"
            ],
            members: {
              FleetId: {},
              VpcPeeringConnectionId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeregisterCompute: {
          input: {
            type: "structure",
            required: [
              "FleetId",
              "ComputeName"
            ],
            members: {
              FleetId: {},
              ComputeName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeregisterGameServer: {
          input: {
            type: "structure",
            required: [
              "GameServerGroupName",
              "GameServerId"
            ],
            members: {
              GameServerGroupName: {},
              GameServerId: {}
            }
          }
        },
        DescribeAlias: {
          input: {
            type: "structure",
            required: [
              "AliasId"
            ],
            members: {
              AliasId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Alias: {
                shape: "Sz"
              }
            }
          }
        },
        DescribeBuild: {
          input: {
            type: "structure",
            required: [
              "BuildId"
            ],
            members: {
              BuildId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Build: {
                shape: "S18"
              }
            }
          }
        },
        DescribeCompute: {
          input: {
            type: "structure",
            required: [
              "FleetId",
              "ComputeName"
            ],
            members: {
              FleetId: {},
              ComputeName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Compute: {
                shape: "S6f"
              }
            }
          }
        },
        DescribeEC2InstanceLimits: {
          input: {
            type: "structure",
            members: {
              EC2InstanceType: {},
              Location: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EC2InstanceLimits: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EC2InstanceType: {},
                    CurrentInstances: {
                      type: "integer"
                    },
                    InstanceLimit: {
                      type: "integer"
                    },
                    Location: {}
                  }
                }
              }
            }
          }
        },
        DescribeFleetAttributes: {
          input: {
            type: "structure",
            members: {
              FleetIds: {
                shape: "S6p"
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FleetAttributes: {
                type: "list",
                member: {
                  shape: "S2c"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeFleetCapacity: {
          input: {
            type: "structure",
            members: {
              FleetIds: {
                shape: "S6p"
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FleetCapacity: {
                type: "list",
                member: {
                  shape: "S6v"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeFleetEvents: {
          input: {
            type: "structure",
            required: [
              "FleetId"
            ],
            members: {
              FleetId: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Events: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EventId: {},
                    ResourceId: {},
                    EventCode: {},
                    Message: {},
                    EventTime: {
                      type: "timestamp"
                    },
                    PreSignedLogUrl: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeFleetLocationAttributes: {
          input: {
            type: "structure",
            required: [
              "FleetId"
            ],
            members: {
              FleetId: {},
              Locations: {
                shape: "S3z"
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FleetId: {},
              FleetArn: {},
              LocationAttributes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LocationState: {
                      shape: "S2k"
                    },
                    StoppedActions: {
                      shape: "S2h"
                    },
                    UpdateStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeFleetLocationCapacity: {
          input: {
            type: "structure",
            required: [
              "FleetId",
              "Location"
            ],
            members: {
              FleetId: {},
              Location: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FleetCapacity: {
                shape: "S6v"
              }
            }
          }
        },
        DescribeFleetLocationUtilization: {
          input: {
            type: "structure",
            required: [
              "FleetId",
              "Location"
            ],
            members: {
              FleetId: {},
              Location: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FleetUtilization: {
                shape: "S7b"
              }
            }
          }
        },
        DescribeFleetPortSettings: {
          input: {
            type: "structure",
            required: [
              "FleetId"
            ],
            members: {
              FleetId: {},
              Location: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FleetId: {},
              FleetArn: {},
              InboundPermissions: {
                shape: "S1l"
              },
              UpdateStatus: {},
              Location: {}
            }
          }
        },
        DescribeFleetUtilization: {
          input: {
            type: "structure",
            members: {
              FleetIds: {
                shape: "S6p"
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FleetUtilization: {
                type: "list",
                member: {
                  shape: "S7b"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeGameServer: {
          input: {
            type: "structure",
            required: [
              "GameServerGroupName",
              "GameServerId"
            ],
            members: {
              GameServerGroupName: {},
              GameServerId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameServer: {
                shape: "Sf"
              }
            }
          }
        },
        DescribeGameServerGroup: {
          input: {
            type: "structure",
            required: [
              "GameServerGroupName"
            ],
            members: {
              GameServerGroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameServerGroup: {
                shape: "S36"
              }
            }
          }
        },
        DescribeGameServerInstances: {
          input: {
            type: "structure",
            required: [
              "GameServerGroupName"
            ],
            members: {
              GameServerGroupName: {},
              InstanceIds: {
                type: "list",
                member: {}
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameServerInstances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    GameServerGroupName: {},
                    GameServerGroupArn: {},
                    InstanceId: {},
                    InstanceStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeGameSessionDetails: {
          input: {
            type: "structure",
            members: {
              FleetId: {},
              GameSessionId: {},
              AliasId: {},
              Location: {},
              StatusFilter: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameSessionDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    GameSession: {
                      shape: "S3k"
                    },
                    ProtectionPolicy: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeGameSessionPlacement: {
          input: {
            type: "structure",
            required: [
              "PlacementId"
            ],
            members: {
              PlacementId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameSessionPlacement: {
                shape: "S7x"
              }
            }
          }
        },
        DescribeGameSessionQueues: {
          input: {
            type: "structure",
            members: {
              Names: {
                type: "list",
                member: {}
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameSessionQueues: {
                type: "list",
                member: {
                  shape: "S46"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeGameSessions: {
          input: {
            type: "structure",
            members: {
              FleetId: {},
              GameSessionId: {},
              AliasId: {},
              Location: {},
              StatusFilter: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameSessions: {
                shape: "S8a"
              },
              NextToken: {}
            }
          }
        },
        DescribeInstances: {
          input: {
            type: "structure",
            required: [
              "FleetId"
            ],
            members: {
              FleetId: {},
              InstanceId: {},
              Limit: {
                type: "integer"
              },
              NextToken: {},
              Location: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Instances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FleetId: {},
                    FleetArn: {},
                    InstanceId: {},
                    IpAddress: {
                      shape: "S3n"
                    },
                    DnsName: {},
                    OperatingSystem: {},
                    Type: {},
                    Status: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    Location: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeMatchmaking: {
          input: {
            type: "structure",
            required: [
              "TicketIds"
            ],
            members: {
              TicketIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TicketList: {
                type: "list",
                member: {
                  shape: "S8l"
                }
              }
            }
          }
        },
        DescribeMatchmakingConfigurations: {
          input: {
            type: "structure",
            members: {
              Names: {
                type: "list",
                member: {}
              },
              RuleSetName: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Configurations: {
                type: "list",
                member: {
                  shape: "S4p"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeMatchmakingRuleSets: {
          input: {
            type: "structure",
            members: {
              Names: {
                type: "list",
                member: {}
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "RuleSets"
            ],
            members: {
              RuleSets: {
                type: "list",
                member: {
                  shape: "S4v"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribePlayerSessions: {
          input: {
            type: "structure",
            members: {
              GameSessionId: {},
              PlayerId: {
                shape: "S4"
              },
              PlayerSessionId: {},
              PlayerSessionStatusFilter: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PlayerSessions: {
                shape: "S56"
              },
              NextToken: {}
            }
          }
        },
        DescribeRuntimeConfiguration: {
          input: {
            type: "structure",
            required: [
              "FleetId"
            ],
            members: {
              FleetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RuntimeConfiguration: {
                shape: "S1r"
              }
            }
          }
        },
        DescribeScalingPolicies: {
          input: {
            type: "structure",
            required: [
              "FleetId"
            ],
            members: {
              FleetId: {},
              StatusFilter: {},
              Limit: {
                type: "integer"
              },
              NextToken: {},
              Location: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ScalingPolicies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FleetId: {},
                    FleetArn: {},
                    Name: {},
                    Status: {},
                    ScalingAdjustment: {
                      type: "integer"
                    },
                    ScalingAdjustmentType: {},
                    ComparisonOperator: {},
                    Threshold: {
                      type: "double"
                    },
                    EvaluationPeriods: {
                      type: "integer"
                    },
                    MetricName: {},
                    PolicyType: {},
                    TargetConfiguration: {
                      shape: "S9o"
                    },
                    UpdateStatus: {},
                    Location: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeScript: {
          input: {
            type: "structure",
            required: [
              "ScriptId"
            ],
            members: {
              ScriptId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Script: {
                shape: "S5a"
              }
            }
          }
        },
        DescribeVpcPeeringAuthorizations: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              VpcPeeringAuthorizations: {
                type: "list",
                member: {
                  shape: "S5d"
                }
              }
            }
          }
        },
        DescribeVpcPeeringConnections: {
          input: {
            type: "structure",
            members: {
              FleetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VpcPeeringConnections: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FleetId: {},
                    FleetArn: {},
                    IpV4CidrBlock: {},
                    VpcPeeringConnectionId: {},
                    Status: {
                      type: "structure",
                      members: {
                        Code: {},
                        Message: {}
                      }
                    },
                    PeerVpcId: {},
                    GameLiftVpcId: {}
                  }
                }
              }
            }
          }
        },
        GetComputeAccess: {
          input: {
            type: "structure",
            required: [
              "FleetId",
              "ComputeName"
            ],
            members: {
              FleetId: {},
              ComputeName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FleetId: {},
              FleetArn: {},
              ComputeName: {},
              ComputeArn: {},
              Credentials: {
                shape: "S1d"
              }
            }
          }
        },
        GetComputeAuthToken: {
          input: {
            type: "structure",
            required: [
              "FleetId",
              "ComputeName"
            ],
            members: {
              FleetId: {},
              ComputeName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FleetId: {},
              FleetArn: {},
              ComputeName: {},
              ComputeArn: {},
              AuthToken: {},
              ExpirationTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        GetGameSessionLogUrl: {
          input: {
            type: "structure",
            required: [
              "GameSessionId"
            ],
            members: {
              GameSessionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PreSignedUrl: {}
            }
          }
        },
        GetInstanceAccess: {
          input: {
            type: "structure",
            required: [
              "FleetId",
              "InstanceId"
            ],
            members: {
              FleetId: {},
              InstanceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceAccess: {
                type: "structure",
                members: {
                  FleetId: {},
                  InstanceId: {},
                  IpAddress: {
                    shape: "S3n"
                  },
                  OperatingSystem: {},
                  Credentials: {
                    type: "structure",
                    members: {
                      UserName: {},
                      Secret: {}
                    },
                    sensitive: true
                  }
                }
              }
            }
          }
        },
        ListAliases: {
          input: {
            type: "structure",
            members: {
              RoutingStrategyType: {},
              Name: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Aliases: {
                type: "list",
                member: {
                  shape: "Sz"
                }
              },
              NextToken: {}
            }
          }
        },
        ListBuilds: {
          input: {
            type: "structure",
            members: {
              Status: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Builds: {
                type: "list",
                member: {
                  shape: "S18"
                }
              },
              NextToken: {}
            }
          }
        },
        ListCompute: {
          input: {
            type: "structure",
            required: [
              "FleetId"
            ],
            members: {
              FleetId: {},
              Location: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ComputeList: {
                type: "list",
                member: {
                  shape: "S6f"
                }
              },
              NextToken: {}
            }
          }
        },
        ListFleets: {
          input: {
            type: "structure",
            members: {
              BuildId: {},
              ScriptId: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FleetIds: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListGameServerGroups: {
          input: {
            type: "structure",
            members: {
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameServerGroups: {
                type: "list",
                member: {
                  shape: "S36"
                }
              },
              NextToken: {}
            }
          }
        },
        ListGameServers: {
          input: {
            type: "structure",
            required: [
              "GameServerGroupName"
            ],
            members: {
              GameServerGroupName: {},
              SortOrder: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameServers: {
                type: "list",
                member: {
                  shape: "Sf"
                }
              },
              NextToken: {}
            }
          }
        },
        ListLocations: {
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "list",
                member: {}
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Locations: {
                type: "list",
                member: {
                  shape: "S4b"
                }
              },
              NextToken: {}
            }
          }
        },
        ListScripts: {
          input: {
            type: "structure",
            members: {
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Scripts: {
                type: "list",
                member: {
                  shape: "S5a"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Su"
              }
            }
          }
        },
        PutScalingPolicy: {
          input: {
            type: "structure",
            required: [
              "Name",
              "FleetId",
              "MetricName"
            ],
            members: {
              Name: {},
              FleetId: {},
              ScalingAdjustment: {
                type: "integer"
              },
              ScalingAdjustmentType: {},
              Threshold: {
                type: "double"
              },
              ComparisonOperator: {},
              EvaluationPeriods: {
                type: "integer"
              },
              MetricName: {},
              PolicyType: {},
              TargetConfiguration: {
                shape: "S9o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {}
            }
          }
        },
        RegisterCompute: {
          input: {
            type: "structure",
            required: [
              "FleetId",
              "ComputeName"
            ],
            members: {
              FleetId: {},
              ComputeName: {},
              CertificatePath: {},
              DnsName: {},
              IpAddress: {
                shape: "S3n"
              },
              Location: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Compute: {
                shape: "S6f"
              }
            }
          }
        },
        RegisterGameServer: {
          input: {
            type: "structure",
            required: [
              "GameServerGroupName",
              "GameServerId",
              "InstanceId"
            ],
            members: {
              GameServerGroupName: {},
              GameServerId: {},
              InstanceId: {},
              ConnectionInfo: {},
              GameServerData: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameServer: {
                shape: "Sf"
              }
            }
          }
        },
        RequestUploadCredentials: {
          input: {
            type: "structure",
            required: [
              "BuildId"
            ],
            members: {
              BuildId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UploadCredentials: {
                shape: "S1d"
              },
              StorageLocation: {
                shape: "S13"
              }
            }
          }
        },
        ResolveAlias: {
          input: {
            type: "structure",
            required: [
              "AliasId"
            ],
            members: {
              AliasId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FleetId: {},
              FleetArn: {}
            }
          }
        },
        ResumeGameServerGroup: {
          input: {
            type: "structure",
            required: [
              "GameServerGroupName",
              "ResumeActions"
            ],
            members: {
              GameServerGroupName: {},
              ResumeActions: {
                shape: "S39"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GameServerGroup: {
                shape: "S36"
              }
            }
          }
        },
        SearchGameSessions: {
          input: {
            type: "structure",
            members: {
              FleetId: {},
              AliasId: {},
              Location: {},
              FilterExpression: {},
              SortExpression: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameSessions: {
                shape: "S8a"
              },
              NextToken: {}
            }
          }
        },
        StartFleetActions: {
          input: {
            type: "structure",
            required: [
              "FleetId",
              "Actions"
            ],
            members: {
              FleetId: {},
              Actions: {
                shape: "S2h"
              },
              Location: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FleetId: {},
              FleetArn: {}
            }
          }
        },
        StartGameSessionPlacement: {
          input: {
            type: "structure",
            required: [
              "PlacementId",
              "GameSessionQueueName",
              "MaximumPlayerSessionCount"
            ],
            members: {
              PlacementId: {},
              GameSessionQueueName: {},
              GameProperties: {
                shape: "S3d"
              },
              MaximumPlayerSessionCount: {
                type: "integer"
              },
              GameSessionName: {},
              PlayerLatencies: {
                shape: "S7z"
              },
              DesiredPlayerSessions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PlayerId: {
                      shape: "S4"
                    },
                    PlayerData: {}
                  }
                }
              },
              GameSessionData: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameSessionPlacement: {
                shape: "S7x"
              }
            }
          }
        },
        StartMatchBackfill: {
          input: {
            type: "structure",
            required: [
              "ConfigurationName",
              "Players"
            ],
            members: {
              TicketId: {},
              ConfigurationName: {},
              GameSessionArn: {},
              Players: {
                shape: "S8o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MatchmakingTicket: {
                shape: "S8l"
              }
            }
          }
        },
        StartMatchmaking: {
          input: {
            type: "structure",
            required: [
              "ConfigurationName",
              "Players"
            ],
            members: {
              TicketId: {},
              ConfigurationName: {},
              Players: {
                shape: "S8o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MatchmakingTicket: {
                shape: "S8l"
              }
            }
          }
        },
        StopFleetActions: {
          input: {
            type: "structure",
            required: [
              "FleetId",
              "Actions"
            ],
            members: {
              FleetId: {},
              Actions: {
                shape: "S2h"
              },
              Location: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FleetId: {},
              FleetArn: {}
            }
          }
        },
        StopGameSessionPlacement: {
          input: {
            type: "structure",
            required: [
              "PlacementId"
            ],
            members: {
              PlacementId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameSessionPlacement: {
                shape: "S7x"
              }
            }
          }
        },
        StopMatchmaking: {
          input: {
            type: "structure",
            required: [
              "TicketId"
            ],
            members: {
              TicketId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SuspendGameServerGroup: {
          input: {
            type: "structure",
            required: [
              "GameServerGroupName",
              "SuspendActions"
            ],
            members: {
              GameServerGroupName: {},
              SuspendActions: {
                shape: "S39"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GameServerGroup: {
                shape: "S36"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAlias: {
          input: {
            type: "structure",
            required: [
              "AliasId"
            ],
            members: {
              AliasId: {},
              Name: {},
              Description: {},
              RoutingStrategy: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Alias: {
                shape: "Sz"
              }
            }
          }
        },
        UpdateBuild: {
          input: {
            type: "structure",
            required: [
              "BuildId"
            ],
            members: {
              BuildId: {},
              Name: {},
              Version: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Build: {
                shape: "S18"
              }
            }
          }
        },
        UpdateFleetAttributes: {
          input: {
            type: "structure",
            required: [
              "FleetId"
            ],
            members: {
              FleetId: {},
              Name: {},
              Description: {},
              NewGameSessionProtectionPolicy: {},
              ResourceCreationLimitPolicy: {
                shape: "S1x"
              },
              MetricGroups: {
                shape: "S1z"
              },
              AnywhereConfiguration: {
                shape: "S28"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FleetId: {},
              FleetArn: {}
            }
          }
        },
        UpdateFleetCapacity: {
          input: {
            type: "structure",
            required: [
              "FleetId"
            ],
            members: {
              FleetId: {},
              DesiredInstances: {
                type: "integer"
              },
              MinSize: {
                type: "integer"
              },
              MaxSize: {
                type: "integer"
              },
              Location: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FleetId: {},
              FleetArn: {},
              Location: {}
            }
          }
        },
        UpdateFleetPortSettings: {
          input: {
            type: "structure",
            required: [
              "FleetId"
            ],
            members: {
              FleetId: {},
              InboundPermissionAuthorizations: {
                shape: "S1l"
              },
              InboundPermissionRevocations: {
                shape: "S1l"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FleetId: {},
              FleetArn: {}
            }
          }
        },
        UpdateGameServer: {
          input: {
            type: "structure",
            required: [
              "GameServerGroupName",
              "GameServerId"
            ],
            members: {
              GameServerGroupName: {},
              GameServerId: {},
              GameServerData: {},
              UtilizationStatus: {},
              HealthCheck: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameServer: {
                shape: "Sf"
              }
            }
          }
        },
        UpdateGameServerGroup: {
          input: {
            type: "structure",
            required: [
              "GameServerGroupName"
            ],
            members: {
              GameServerGroupName: {},
              RoleArn: {},
              InstanceDefinitions: {
                shape: "S2u"
              },
              GameServerProtectionPolicy: {},
              BalancingStrategy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameServerGroup: {
                shape: "S36"
              }
            }
          }
        },
        UpdateGameSession: {
          input: {
            type: "structure",
            required: [
              "GameSessionId"
            ],
            members: {
              GameSessionId: {},
              MaximumPlayerSessionCount: {
                type: "integer"
              },
              Name: {},
              PlayerSessionCreationPolicy: {},
              ProtectionPolicy: {},
              GameProperties: {
                shape: "S3d"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GameSession: {
                shape: "S3k"
              }
            }
          }
        },
        UpdateGameSessionQueue: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              TimeoutInSeconds: {
                type: "integer"
              },
              PlayerLatencyPolicies: {
                shape: "S3t"
              },
              Destinations: {
                shape: "S3v"
              },
              FilterConfiguration: {
                shape: "S3y"
              },
              PriorityConfiguration: {
                shape: "S40"
              },
              CustomEventData: {},
              NotificationTarget: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameSessionQueue: {
                shape: "S46"
              }
            }
          }
        },
        UpdateMatchmakingConfiguration: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Description: {},
              GameSessionQueueArns: {
                shape: "S4e"
              },
              RequestTimeoutSeconds: {
                type: "integer"
              },
              AcceptanceTimeoutSeconds: {
                type: "integer"
              },
              AcceptanceRequired: {
                type: "boolean"
              },
              RuleSetName: {},
              NotificationTarget: {},
              AdditionalPlayerCount: {
                type: "integer"
              },
              CustomEventData: {},
              GameProperties: {
                shape: "S3d"
              },
              GameSessionData: {},
              BackfillMode: {},
              FlexMatchMode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Configuration: {
                shape: "S4p"
              }
            }
          }
        },
        UpdateRuntimeConfiguration: {
          input: {
            type: "structure",
            required: [
              "FleetId",
              "RuntimeConfiguration"
            ],
            members: {
              FleetId: {},
              RuntimeConfiguration: {
                shape: "S1r"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RuntimeConfiguration: {
                shape: "S1r"
              }
            }
          }
        },
        UpdateScript: {
          input: {
            type: "structure",
            required: [
              "ScriptId"
            ],
            members: {
              ScriptId: {},
              Name: {},
              Version: {},
              StorageLocation: {
                shape: "S13"
              },
              ZipFile: {
                type: "blob"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Script: {
                shape: "S5a"
              }
            }
          }
        },
        ValidateMatchmakingRuleSet: {
          input: {
            type: "structure",
            required: [
              "RuleSetBody"
            ],
            members: {
              RuleSetBody: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Valid: {
                type: "boolean"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "string",
          sensitive: true
        },
        Sf: {
          type: "structure",
          members: {
            GameServerGroupName: {},
            GameServerGroupArn: {},
            GameServerId: {},
            InstanceId: {},
            ConnectionInfo: {},
            GameServerData: {},
            ClaimStatus: {},
            UtilizationStatus: {},
            RegistrationTime: {
              type: "timestamp"
            },
            LastClaimTime: {
              type: "timestamp"
            },
            LastHealthCheckTime: {
              type: "timestamp"
            }
          }
        },
        Sq: {
          type: "structure",
          members: {
            Type: {},
            FleetId: {},
            Message: {}
          }
        },
        Su: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sz: {
          type: "structure",
          members: {
            AliasId: {},
            Name: {},
            AliasArn: {},
            Description: {},
            RoutingStrategy: {
              shape: "Sq"
            },
            CreationTime: {
              type: "timestamp"
            },
            LastUpdatedTime: {
              type: "timestamp"
            }
          }
        },
        S13: {
          type: "structure",
          members: {
            Bucket: {},
            Key: {},
            RoleArn: {},
            ObjectVersion: {}
          }
        },
        S18: {
          type: "structure",
          members: {
            BuildId: {},
            BuildArn: {},
            Name: {},
            Version: {},
            Status: {},
            SizeOnDisk: {
              type: "long"
            },
            OperatingSystem: {},
            CreationTime: {
              type: "timestamp"
            },
            ServerSdkVersion: {}
          }
        },
        S1d: {
          type: "structure",
          members: {
            AccessKeyId: {},
            SecretAccessKey: {},
            SessionToken: {}
          },
          sensitive: true
        },
        S1j: {
          type: "list",
          member: {}
        },
        S1l: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "FromPort",
              "ToPort",
              "IpRange",
              "Protocol"
            ],
            members: {
              FromPort: {
                shape: "S1n"
              },
              ToPort: {
                shape: "S1n"
              },
              IpRange: {
                type: "string",
                sensitive: true
              },
              Protocol: {}
            }
          }
        },
        S1n: {
          type: "integer",
          sensitive: true
        },
        S1r: {
          type: "structure",
          members: {
            ServerProcesses: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "LaunchPath",
                  "ConcurrentExecutions"
                ],
                members: {
                  LaunchPath: {},
                  Parameters: {},
                  ConcurrentExecutions: {
                    type: "integer"
                  }
                }
              }
            },
            MaxConcurrentGameSessionActivations: {
              type: "integer"
            },
            GameSessionActivationTimeoutSeconds: {
              type: "integer"
            }
          }
        },
        S1x: {
          type: "structure",
          members: {
            NewGameSessionsPerCreator: {
              type: "integer"
            },
            PolicyPeriodInMinutes: {
              type: "integer"
            }
          }
        },
        S1z: {
          type: "list",
          member: {}
        },
        S22: {
          type: "structure",
          required: [
            "CertificateType"
          ],
          members: {
            CertificateType: {}
          }
        },
        S24: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Location"
            ],
            members: {
              Location: {}
            }
          }
        },
        S28: {
          type: "structure",
          required: [
            "Cost"
          ],
          members: {
            Cost: {}
          }
        },
        S2c: {
          type: "structure",
          members: {
            FleetId: {},
            FleetArn: {},
            FleetType: {},
            InstanceType: {},
            Description: {},
            Name: {},
            CreationTime: {
              type: "timestamp"
            },
            TerminationTime: {
              type: "timestamp"
            },
            Status: {},
            BuildId: {},
            BuildArn: {},
            ScriptId: {},
            ScriptArn: {},
            ServerLaunchPath: {},
            ServerLaunchParameters: {},
            LogPaths: {
              shape: "S1j"
            },
            NewGameSessionProtectionPolicy: {},
            OperatingSystem: {},
            ResourceCreationLimitPolicy: {
              shape: "S1x"
            },
            MetricGroups: {
              shape: "S1z"
            },
            StoppedActions: {
              shape: "S2h"
            },
            InstanceRoleArn: {},
            CertificateConfiguration: {
              shape: "S22"
            },
            ComputeType: {},
            AnywhereConfiguration: {
              shape: "S28"
            },
            InstanceRoleCredentialsProvider: {}
          }
        },
        S2h: {
          type: "list",
          member: {}
        },
        S2j: {
          type: "list",
          member: {
            shape: "S2k"
          }
        },
        S2k: {
          type: "structure",
          members: {
            Location: {},
            Status: {}
          }
        },
        S2u: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "InstanceType"
            ],
            members: {
              InstanceType: {},
              WeightedCapacity: {}
            }
          }
        },
        S36: {
          type: "structure",
          members: {
            GameServerGroupName: {},
            GameServerGroupArn: {},
            RoleArn: {},
            InstanceDefinitions: {
              shape: "S2u"
            },
            BalancingStrategy: {},
            GameServerProtectionPolicy: {},
            AutoScalingGroupArn: {},
            Status: {},
            StatusReason: {},
            SuspendedActions: {
              shape: "S39"
            },
            CreationTime: {
              type: "timestamp"
            },
            LastUpdatedTime: {
              type: "timestamp"
            }
          }
        },
        S39: {
          type: "list",
          member: {}
        },
        S3d: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S3k: {
          type: "structure",
          members: {
            GameSessionId: {},
            Name: {},
            FleetId: {},
            FleetArn: {},
            CreationTime: {
              type: "timestamp"
            },
            TerminationTime: {
              type: "timestamp"
            },
            CurrentPlayerSessionCount: {
              type: "integer"
            },
            MaximumPlayerSessionCount: {
              type: "integer"
            },
            Status: {},
            StatusReason: {},
            GameProperties: {
              shape: "S3d"
            },
            IpAddress: {
              shape: "S3n"
            },
            DnsName: {},
            Port: {
              shape: "S1n"
            },
            PlayerSessionCreationPolicy: {},
            CreatorId: {},
            GameSessionData: {},
            MatchmakerData: {},
            Location: {}
          }
        },
        S3n: {
          type: "string",
          sensitive: true
        },
        S3t: {
          type: "list",
          member: {
            type: "structure",
            members: {
              MaximumIndividualPlayerLatencyMilliseconds: {
                type: "integer"
              },
              PolicyDurationSeconds: {
                type: "integer"
              }
            }
          }
        },
        S3v: {
          type: "list",
          member: {
            type: "structure",
            members: {
              DestinationArn: {}
            }
          }
        },
        S3y: {
          type: "structure",
          members: {
            AllowedLocations: {
              shape: "S3z"
            }
          }
        },
        S3z: {
          type: "list",
          member: {}
        },
        S40: {
          type: "structure",
          members: {
            PriorityOrder: {
              type: "list",
              member: {}
            },
            LocationOrder: {
              shape: "S3z"
            }
          }
        },
        S46: {
          type: "structure",
          members: {
            Name: {},
            GameSessionQueueArn: {},
            TimeoutInSeconds: {
              type: "integer"
            },
            PlayerLatencyPolicies: {
              shape: "S3t"
            },
            Destinations: {
              shape: "S3v"
            },
            FilterConfiguration: {
              shape: "S3y"
            },
            PriorityConfiguration: {
              shape: "S40"
            },
            CustomEventData: {},
            NotificationTarget: {}
          }
        },
        S4b: {
          type: "structure",
          members: {
            LocationName: {},
            LocationArn: {}
          }
        },
        S4e: {
          type: "list",
          member: {}
        },
        S4p: {
          type: "structure",
          members: {
            Name: {},
            ConfigurationArn: {},
            Description: {},
            GameSessionQueueArns: {
              shape: "S4e"
            },
            RequestTimeoutSeconds: {
              type: "integer"
            },
            AcceptanceTimeoutSeconds: {
              type: "integer"
            },
            AcceptanceRequired: {
              type: "boolean"
            },
            RuleSetName: {},
            RuleSetArn: {},
            NotificationTarget: {},
            AdditionalPlayerCount: {
              type: "integer"
            },
            CustomEventData: {},
            CreationTime: {
              type: "timestamp"
            },
            GameProperties: {
              shape: "S3d"
            },
            GameSessionData: {},
            BackfillMode: {},
            FlexMatchMode: {}
          }
        },
        S4v: {
          type: "structure",
          required: [
            "RuleSetBody"
          ],
          members: {
            RuleSetName: {},
            RuleSetArn: {},
            RuleSetBody: {},
            CreationTime: {
              type: "timestamp"
            }
          }
        },
        S4z: {
          type: "structure",
          members: {
            PlayerSessionId: {},
            PlayerId: {
              shape: "S4"
            },
            GameSessionId: {},
            FleetId: {},
            FleetArn: {},
            CreationTime: {
              type: "timestamp"
            },
            TerminationTime: {
              type: "timestamp"
            },
            Status: {},
            IpAddress: {
              shape: "S3n"
            },
            DnsName: {},
            Port: {
              shape: "S1n"
            },
            PlayerData: {}
          }
        },
        S56: {
          type: "list",
          member: {
            shape: "S4z"
          }
        },
        S5a: {
          type: "structure",
          members: {
            ScriptId: {},
            ScriptArn: {},
            Name: {},
            Version: {},
            SizeOnDisk: {
              type: "long"
            },
            CreationTime: {
              type: "timestamp"
            },
            StorageLocation: {
              shape: "S13"
            }
          }
        },
        S5d: {
          type: "structure",
          members: {
            GameLiftAwsAccountId: {},
            PeerVpcAwsAccountId: {},
            PeerVpcId: {},
            CreationTime: {
              type: "timestamp"
            },
            ExpirationTime: {
              type: "timestamp"
            }
          }
        },
        S6f: {
          type: "structure",
          members: {
            FleetId: {},
            FleetArn: {},
            ComputeName: {},
            ComputeArn: {},
            IpAddress: {
              shape: "S3n"
            },
            DnsName: {},
            ComputeStatus: {},
            Location: {},
            CreationTime: {
              type: "timestamp"
            },
            OperatingSystem: {},
            Type: {},
            GameLiftServiceSdkEndpoint: {}
          }
        },
        S6p: {
          type: "list",
          member: {}
        },
        S6v: {
          type: "structure",
          members: {
            FleetId: {},
            FleetArn: {},
            InstanceType: {},
            InstanceCounts: {
              type: "structure",
              members: {
                DESIRED: {
                  type: "integer"
                },
                MINIMUM: {
                  type: "integer"
                },
                MAXIMUM: {
                  type: "integer"
                },
                PENDING: {
                  type: "integer"
                },
                ACTIVE: {
                  type: "integer"
                },
                IDLE: {
                  type: "integer"
                },
                TERMINATING: {
                  type: "integer"
                }
              }
            },
            Location: {}
          }
        },
        S7b: {
          type: "structure",
          members: {
            FleetId: {},
            FleetArn: {},
            ActiveServerProcessCount: {
              type: "integer"
            },
            ActiveGameSessionCount: {
              type: "integer"
            },
            CurrentPlayerSessionCount: {
              type: "integer"
            },
            MaximumPlayerSessionCount: {
              type: "integer"
            },
            Location: {}
          }
        },
        S7x: {
          type: "structure",
          members: {
            PlacementId: {},
            GameSessionQueueName: {},
            Status: {},
            GameProperties: {
              shape: "S3d"
            },
            MaximumPlayerSessionCount: {
              type: "integer"
            },
            GameSessionName: {},
            GameSessionId: {},
            GameSessionArn: {},
            GameSessionRegion: {},
            PlayerLatencies: {
              shape: "S7z"
            },
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            IpAddress: {
              shape: "S3n"
            },
            DnsName: {},
            Port: {
              shape: "S1n"
            },
            PlacedPlayerSessions: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  PlayerId: {
                    shape: "S4"
                  },
                  PlayerSessionId: {}
                }
              }
            },
            GameSessionData: {},
            MatchmakerData: {}
          }
        },
        S7z: {
          type: "list",
          member: {
            type: "structure",
            members: {
              PlayerId: {
                shape: "S4"
              },
              RegionIdentifier: {},
              LatencyInMilliseconds: {
                type: "float"
              }
            }
          }
        },
        S8a: {
          type: "list",
          member: {
            shape: "S3k"
          }
        },
        S8l: {
          type: "structure",
          members: {
            TicketId: {},
            ConfigurationName: {},
            ConfigurationArn: {},
            Status: {},
            StatusReason: {},
            StatusMessage: {},
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            Players: {
              shape: "S8o"
            },
            GameSessionConnectionInfo: {
              type: "structure",
              members: {
                GameSessionArn: {},
                IpAddress: {
                  shape: "S3n"
                },
                DnsName: {},
                Port: {
                  type: "integer"
                },
                MatchedPlayerSessions: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      PlayerId: {
                        shape: "S4"
                      },
                      PlayerSessionId: {}
                    }
                  }
                }
              }
            },
            EstimatedWaitTime: {
              type: "integer"
            }
          }
        },
        S8o: {
          type: "list",
          member: {
            type: "structure",
            members: {
              PlayerId: {
                shape: "S4"
              },
              PlayerAttributes: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    S: {},
                    N: {
                      type: "double"
                    },
                    SL: {
                      type: "list",
                      member: {}
                    },
                    SDM: {
                      type: "map",
                      key: {},
                      value: {
                        type: "double"
                      }
                    }
                  }
                }
              },
              Team: {},
              LatencyInMs: {
                type: "map",
                key: {},
                value: {
                  type: "integer"
                }
              }
            }
          }
        },
        S9o: {
          type: "structure",
          required: [
            "TargetValue"
          ],
          members: {
            TargetValue: {
              type: "double"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/gamelift-2015-10-01.paginators.json
var require_gamelift_2015_10_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/gamelift-2015-10-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeFleetAttributes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "FleetAttributes"
        },
        DescribeFleetCapacity: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "FleetCapacity"
        },
        DescribeFleetEvents: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "Events"
        },
        DescribeFleetLocationAttributes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit"
        },
        DescribeFleetUtilization: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "FleetUtilization"
        },
        DescribeGameServerInstances: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "GameServerInstances"
        },
        DescribeGameSessionDetails: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "GameSessionDetails"
        },
        DescribeGameSessionQueues: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "GameSessionQueues"
        },
        DescribeGameSessions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "GameSessions"
        },
        DescribeInstances: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "Instances"
        },
        DescribeMatchmakingConfigurations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "Configurations"
        },
        DescribeMatchmakingRuleSets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "RuleSets"
        },
        DescribePlayerSessions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "PlayerSessions"
        },
        DescribeScalingPolicies: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "ScalingPolicies"
        },
        ListAliases: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "Aliases"
        },
        ListBuilds: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "Builds"
        },
        ListCompute: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "ComputeList"
        },
        ListFleets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "FleetIds"
        },
        ListGameServerGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "GameServerGroups"
        },
        ListGameServers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "GameServers"
        },
        ListLocations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "Locations"
        },
        ListScripts: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "Scripts"
        },
        SearchGameSessions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "GameSessions"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/gamelift.js
var require_gamelift = __commonJS({
  "node_modules/aws-sdk/clients/gamelift.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["gamelift"] = {};
    AWS2.GameLift = Service.defineService("gamelift", ["2015-10-01"]);
    Object.defineProperty(apiLoader.services["gamelift"], "2015-10-01", {
      get: function get() {
        var model = require_gamelift_2015_10_01_min();
        model.paginators = require_gamelift_2015_10_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.GameLift;
  }
});

// node_modules/aws-sdk/lib/services/glacier.js
var require_glacier = __commonJS({
  "node_modules/aws-sdk/lib/services/glacier.js"() {
    "use strict";
    var AWS2 = require_core();
    AWS2.util.update(AWS2.Glacier.prototype, {
      /**
       * @api private
       */
      setupRequestListeners: function setupRequestListeners(request) {
        if (Array.isArray(request._events.validate)) {
          request._events.validate.unshift(this.validateAccountId);
        } else {
          request.on("validate", this.validateAccountId);
        }
        request.removeListener(
          "afterBuild",
          AWS2.EventListeners.Core.COMPUTE_SHA256
        );
        request.on("build", this.addGlacierApiVersion);
        request.on("build", this.addTreeHashHeaders);
      },
      /**
       * @api private
       */
      validateAccountId: function validateAccountId(request) {
        if (request.params.accountId !== void 0)
          return;
        request.params = AWS2.util.copy(request.params);
        request.params.accountId = "-";
      },
      /**
       * @api private
       */
      addGlacierApiVersion: function addGlacierApiVersion(request) {
        var version = request.service.api.apiVersion;
        request.httpRequest.headers["x-amz-glacier-version"] = version;
      },
      /**
       * @api private
       */
      addTreeHashHeaders: function addTreeHashHeaders(request) {
        if (request.params.body === void 0)
          return;
        var hashes = request.service.computeChecksums(request.params.body);
        request.httpRequest.headers["X-Amz-Content-Sha256"] = hashes.linearHash;
        if (!request.httpRequest.headers["x-amz-sha256-tree-hash"]) {
          request.httpRequest.headers["x-amz-sha256-tree-hash"] = hashes.treeHash;
        }
      },
      /**
       * @!group Computing Checksums
       */
      /**
       * Computes the SHA-256 linear and tree hash checksums for a given
       * block of Buffer data. Pass the tree hash of the computed checksums
       * as the checksum input to the {completeMultipartUpload} when performing
       * a multi-part upload.
       *
       * @example Calculate checksum of 5.5MB data chunk
       *   var glacier = new AWS.Glacier();
       *   var data = Buffer.alloc(5.5 * 1024 * 1024);
       *   data.fill('0'); // fill with zeros
       *   var results = glacier.computeChecksums(data);
       *   // Result: { linearHash: '68aff0c5a9...', treeHash: '154e26c78f...' }
       * @param data [Buffer, String] data to calculate the checksum for
       * @return [map<linearHash:String,treeHash:String>] a map containing
       *   the linearHash and treeHash properties representing hex based digests
       *   of the respective checksums.
       * @see completeMultipartUpload
       */
      computeChecksums: function computeChecksums(data) {
        if (!AWS2.util.Buffer.isBuffer(data))
          data = AWS2.util.buffer.toBuffer(data);
        var mb = 1024 * 1024;
        var hashes = [];
        var hash = AWS2.util.crypto.createHash("sha256");
        for (var i = 0; i < data.length; i += mb) {
          var chunk = data.slice(i, Math.min(i + mb, data.length));
          hash.update(chunk);
          hashes.push(AWS2.util.crypto.sha256(chunk));
        }
        return {
          linearHash: hash.digest("hex"),
          treeHash: this.buildHashTree(hashes)
        };
      },
      /**
       * @api private
       */
      buildHashTree: function buildHashTree(hashes) {
        while (hashes.length > 1) {
          var tmpHashes = [];
          for (var i = 0; i < hashes.length; i += 2) {
            if (hashes[i + 1]) {
              var tmpHash = AWS2.util.buffer.alloc(64);
              tmpHash.write(hashes[i], 0, 32, "binary");
              tmpHash.write(hashes[i + 1], 32, 32, "binary");
              tmpHashes.push(AWS2.util.crypto.sha256(tmpHash));
            } else {
              tmpHashes.push(hashes[i]);
            }
          }
          hashes = tmpHashes;
        }
        return AWS2.util.crypto.toHex(hashes[0]);
      }
    });
  }
});

// node_modules/aws-sdk/apis/glacier-2012-06-01.min.json
var require_glacier_2012_06_01_min = __commonJS({
  "node_modules/aws-sdk/apis/glacier-2012-06-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2012-06-01",
        checksumFormat: "sha256",
        endpointPrefix: "glacier",
        protocol: "rest-json",
        serviceFullName: "Amazon Glacier",
        serviceId: "Glacier",
        signatureVersion: "v4",
        uid: "glacier-2012-06-01"
      },
      operations: {
        AbortMultipartUpload: {
          http: {
            method: "DELETE",
            requestUri: "/{accountId}/vaults/{vaultName}/multipart-uploads/{uploadId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName",
              "uploadId"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              uploadId: {
                location: "uri",
                locationName: "uploadId"
              }
            }
          }
        },
        AbortVaultLock: {
          http: {
            method: "DELETE",
            requestUri: "/{accountId}/vaults/{vaultName}/lock-policy",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              }
            }
          }
        },
        AddTagsToVault: {
          http: {
            requestUri: "/{accountId}/vaults/{vaultName}/tags?operation=add",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              Tags: {
                shape: "S5"
              }
            }
          }
        },
        CompleteMultipartUpload: {
          http: {
            requestUri: "/{accountId}/vaults/{vaultName}/multipart-uploads/{uploadId}",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName",
              "uploadId"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              uploadId: {
                location: "uri",
                locationName: "uploadId"
              },
              archiveSize: {
                location: "header",
                locationName: "x-amz-archive-size"
              },
              checksum: {
                location: "header",
                locationName: "x-amz-sha256-tree-hash"
              }
            }
          },
          output: {
            shape: "S9"
          }
        },
        CompleteVaultLock: {
          http: {
            requestUri: "/{accountId}/vaults/{vaultName}/lock-policy/{lockId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName",
              "lockId"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              lockId: {
                location: "uri",
                locationName: "lockId"
              }
            }
          }
        },
        CreateVault: {
          http: {
            method: "PUT",
            requestUri: "/{accountId}/vaults/{vaultName}",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              location: {
                location: "header",
                locationName: "Location"
              }
            }
          }
        },
        DeleteArchive: {
          http: {
            method: "DELETE",
            requestUri: "/{accountId}/vaults/{vaultName}/archives/{archiveId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName",
              "archiveId"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              archiveId: {
                location: "uri",
                locationName: "archiveId"
              }
            }
          }
        },
        DeleteVault: {
          http: {
            method: "DELETE",
            requestUri: "/{accountId}/vaults/{vaultName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              }
            }
          }
        },
        DeleteVaultAccessPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/{accountId}/vaults/{vaultName}/access-policy",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              }
            }
          }
        },
        DeleteVaultNotifications: {
          http: {
            method: "DELETE",
            requestUri: "/{accountId}/vaults/{vaultName}/notification-configuration",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              }
            }
          }
        },
        DescribeJob: {
          http: {
            method: "GET",
            requestUri: "/{accountId}/vaults/{vaultName}/jobs/{jobId}"
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName",
              "jobId"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              jobId: {
                location: "uri",
                locationName: "jobId"
              }
            }
          },
          output: {
            shape: "Si"
          }
        },
        DescribeVault: {
          http: {
            method: "GET",
            requestUri: "/{accountId}/vaults/{vaultName}"
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              }
            }
          },
          output: {
            shape: "S1a"
          }
        },
        GetDataRetrievalPolicy: {
          http: {
            method: "GET",
            requestUri: "/{accountId}/policies/data-retrieval"
          },
          input: {
            type: "structure",
            required: [
              "accountId"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {
                shape: "S1e"
              }
            }
          }
        },
        GetJobOutput: {
          http: {
            method: "GET",
            requestUri: "/{accountId}/vaults/{vaultName}/jobs/{jobId}/output"
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName",
              "jobId"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              range: {
                location: "header",
                locationName: "Range"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              body: {
                shape: "S1k"
              },
              checksum: {
                location: "header",
                locationName: "x-amz-sha256-tree-hash"
              },
              status: {
                location: "statusCode",
                type: "integer"
              },
              contentRange: {
                location: "header",
                locationName: "Content-Range"
              },
              acceptRanges: {
                location: "header",
                locationName: "Accept-Ranges"
              },
              contentType: {
                location: "header",
                locationName: "Content-Type"
              },
              archiveDescription: {
                location: "header",
                locationName: "x-amz-archive-description"
              }
            },
            payload: "body"
          }
        },
        GetVaultAccessPolicy: {
          http: {
            method: "GET",
            requestUri: "/{accountId}/vaults/{vaultName}/access-policy"
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              policy: {
                shape: "S1o"
              }
            },
            payload: "policy"
          }
        },
        GetVaultLock: {
          http: {
            method: "GET",
            requestUri: "/{accountId}/vaults/{vaultName}/lock-policy"
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {},
              State: {},
              ExpirationDate: {},
              CreationDate: {}
            }
          }
        },
        GetVaultNotifications: {
          http: {
            method: "GET",
            requestUri: "/{accountId}/vaults/{vaultName}/notification-configuration"
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              vaultNotificationConfig: {
                shape: "S1t"
              }
            },
            payload: "vaultNotificationConfig"
          }
        },
        InitiateJob: {
          http: {
            requestUri: "/{accountId}/vaults/{vaultName}/jobs",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              jobParameters: {
                type: "structure",
                members: {
                  Format: {},
                  Type: {},
                  ArchiveId: {},
                  Description: {},
                  SNSTopic: {},
                  RetrievalByteRange: {},
                  Tier: {},
                  InventoryRetrievalParameters: {
                    type: "structure",
                    members: {
                      StartDate: {},
                      EndDate: {},
                      Limit: {},
                      Marker: {}
                    }
                  },
                  SelectParameters: {
                    shape: "Sp"
                  },
                  OutputLocation: {
                    shape: "Sx"
                  }
                }
              }
            },
            payload: "jobParameters"
          },
          output: {
            type: "structure",
            members: {
              location: {
                location: "header",
                locationName: "Location"
              },
              jobId: {
                location: "header",
                locationName: "x-amz-job-id"
              },
              jobOutputPath: {
                location: "header",
                locationName: "x-amz-job-output-path"
              }
            }
          }
        },
        InitiateMultipartUpload: {
          http: {
            requestUri: "/{accountId}/vaults/{vaultName}/multipart-uploads",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              archiveDescription: {
                location: "header",
                locationName: "x-amz-archive-description"
              },
              partSize: {
                location: "header",
                locationName: "x-amz-part-size"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              location: {
                location: "header",
                locationName: "Location"
              },
              uploadId: {
                location: "header",
                locationName: "x-amz-multipart-upload-id"
              }
            }
          }
        },
        InitiateVaultLock: {
          http: {
            requestUri: "/{accountId}/vaults/{vaultName}/lock-policy",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              policy: {
                type: "structure",
                members: {
                  Policy: {}
                }
              }
            },
            payload: "policy"
          },
          output: {
            type: "structure",
            members: {
              lockId: {
                location: "header",
                locationName: "x-amz-lock-id"
              }
            }
          }
        },
        ListJobs: {
          http: {
            method: "GET",
            requestUri: "/{accountId}/vaults/{vaultName}/jobs"
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              limit: {
                location: "querystring",
                locationName: "limit"
              },
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              statuscode: {
                location: "querystring",
                locationName: "statuscode"
              },
              completed: {
                location: "querystring",
                locationName: "completed"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobList: {
                type: "list",
                member: {
                  shape: "Si"
                }
              },
              Marker: {}
            }
          }
        },
        ListMultipartUploads: {
          http: {
            method: "GET",
            requestUri: "/{accountId}/vaults/{vaultName}/multipart-uploads"
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              limit: {
                location: "querystring",
                locationName: "limit"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UploadsList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MultipartUploadId: {},
                    VaultARN: {},
                    ArchiveDescription: {},
                    PartSizeInBytes: {
                      type: "long"
                    },
                    CreationDate: {}
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ListParts: {
          http: {
            method: "GET",
            requestUri: "/{accountId}/vaults/{vaultName}/multipart-uploads/{uploadId}"
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName",
              "uploadId"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              uploadId: {
                location: "uri",
                locationName: "uploadId"
              },
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              limit: {
                location: "querystring",
                locationName: "limit"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MultipartUploadId: {},
              VaultARN: {},
              ArchiveDescription: {},
              PartSizeInBytes: {
                type: "long"
              },
              CreationDate: {},
              Parts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RangeInBytes: {},
                    SHA256TreeHash: {}
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ListProvisionedCapacity: {
          http: {
            method: "GET",
            requestUri: "/{accountId}/provisioned-capacity"
          },
          input: {
            type: "structure",
            required: [
              "accountId"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProvisionedCapacityList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CapacityId: {},
                    StartDate: {},
                    ExpirationDate: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForVault: {
          http: {
            method: "GET",
            requestUri: "/{accountId}/vaults/{vaultName}/tags"
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S5"
              }
            }
          }
        },
        ListVaults: {
          http: {
            method: "GET",
            requestUri: "/{accountId}/vaults"
          },
          input: {
            type: "structure",
            required: [
              "accountId"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              limit: {
                location: "querystring",
                locationName: "limit"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VaultList: {
                type: "list",
                member: {
                  shape: "S1a"
                }
              },
              Marker: {}
            }
          }
        },
        PurchaseProvisionedCapacity: {
          http: {
            requestUri: "/{accountId}/provisioned-capacity",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "accountId"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              capacityId: {
                location: "header",
                locationName: "x-amz-capacity-id"
              }
            }
          }
        },
        RemoveTagsFromVault: {
          http: {
            requestUri: "/{accountId}/vaults/{vaultName}/tags?operation=remove",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        },
        SetDataRetrievalPolicy: {
          http: {
            method: "PUT",
            requestUri: "/{accountId}/policies/data-retrieval",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "accountId"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              Policy: {
                shape: "S1e"
              }
            }
          }
        },
        SetVaultAccessPolicy: {
          http: {
            method: "PUT",
            requestUri: "/{accountId}/vaults/{vaultName}/access-policy",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              policy: {
                shape: "S1o"
              }
            },
            payload: "policy"
          }
        },
        SetVaultNotifications: {
          http: {
            method: "PUT",
            requestUri: "/{accountId}/vaults/{vaultName}/notification-configuration",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              vaultNotificationConfig: {
                shape: "S1t"
              }
            },
            payload: "vaultNotificationConfig"
          }
        },
        UploadArchive: {
          http: {
            requestUri: "/{accountId}/vaults/{vaultName}/archives",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "vaultName",
              "accountId"
            ],
            members: {
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              archiveDescription: {
                location: "header",
                locationName: "x-amz-archive-description"
              },
              checksum: {
                location: "header",
                locationName: "x-amz-sha256-tree-hash"
              },
              body: {
                shape: "S1k"
              }
            },
            payload: "body"
          },
          output: {
            shape: "S9"
          }
        },
        UploadMultipartPart: {
          http: {
            method: "PUT",
            requestUri: "/{accountId}/vaults/{vaultName}/multipart-uploads/{uploadId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName",
              "uploadId"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              uploadId: {
                location: "uri",
                locationName: "uploadId"
              },
              checksum: {
                location: "header",
                locationName: "x-amz-sha256-tree-hash"
              },
              range: {
                location: "header",
                locationName: "Content-Range"
              },
              body: {
                shape: "S1k"
              }
            },
            payload: "body"
          },
          output: {
            type: "structure",
            members: {
              checksum: {
                location: "header",
                locationName: "x-amz-sha256-tree-hash"
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "map",
          key: {},
          value: {}
        },
        S9: {
          type: "structure",
          members: {
            location: {
              location: "header",
              locationName: "Location"
            },
            checksum: {
              location: "header",
              locationName: "x-amz-sha256-tree-hash"
            },
            archiveId: {
              location: "header",
              locationName: "x-amz-archive-id"
            }
          }
        },
        Si: {
          type: "structure",
          members: {
            JobId: {},
            JobDescription: {},
            Action: {},
            ArchiveId: {},
            VaultARN: {},
            CreationDate: {},
            Completed: {
              type: "boolean"
            },
            StatusCode: {},
            StatusMessage: {},
            ArchiveSizeInBytes: {
              type: "long"
            },
            InventorySizeInBytes: {
              type: "long"
            },
            SNSTopic: {},
            CompletionDate: {},
            SHA256TreeHash: {},
            ArchiveSHA256TreeHash: {},
            RetrievalByteRange: {},
            Tier: {},
            InventoryRetrievalParameters: {
              type: "structure",
              members: {
                Format: {},
                StartDate: {},
                EndDate: {},
                Limit: {},
                Marker: {}
              }
            },
            JobOutputPath: {},
            SelectParameters: {
              shape: "Sp"
            },
            OutputLocation: {
              shape: "Sx"
            }
          }
        },
        Sp: {
          type: "structure",
          members: {
            InputSerialization: {
              type: "structure",
              members: {
                csv: {
                  type: "structure",
                  members: {
                    FileHeaderInfo: {},
                    Comments: {},
                    QuoteEscapeCharacter: {},
                    RecordDelimiter: {},
                    FieldDelimiter: {},
                    QuoteCharacter: {}
                  }
                }
              }
            },
            ExpressionType: {},
            Expression: {},
            OutputSerialization: {
              type: "structure",
              members: {
                csv: {
                  type: "structure",
                  members: {
                    QuoteFields: {},
                    QuoteEscapeCharacter: {},
                    RecordDelimiter: {},
                    FieldDelimiter: {},
                    QuoteCharacter: {}
                  }
                }
              }
            }
          }
        },
        Sx: {
          type: "structure",
          members: {
            S3: {
              type: "structure",
              members: {
                BucketName: {},
                Prefix: {},
                Encryption: {
                  type: "structure",
                  members: {
                    EncryptionType: {},
                    KMSKeyId: {},
                    KMSContext: {}
                  }
                },
                CannedACL: {},
                AccessControlList: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      Grantee: {
                        type: "structure",
                        required: [
                          "Type"
                        ],
                        members: {
                          Type: {},
                          DisplayName: {},
                          URI: {},
                          ID: {},
                          EmailAddress: {}
                        }
                      },
                      Permission: {}
                    }
                  }
                },
                Tagging: {
                  shape: "S17"
                },
                UserMetadata: {
                  shape: "S17"
                },
                StorageClass: {}
              }
            }
          }
        },
        S17: {
          type: "map",
          key: {},
          value: {}
        },
        S1a: {
          type: "structure",
          members: {
            VaultARN: {},
            VaultName: {},
            CreationDate: {},
            LastInventoryDate: {},
            NumberOfArchives: {
              type: "long"
            },
            SizeInBytes: {
              type: "long"
            }
          }
        },
        S1e: {
          type: "structure",
          members: {
            Rules: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Strategy: {},
                  BytesPerHour: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        S1k: {
          type: "blob",
          streaming: true
        },
        S1o: {
          type: "structure",
          members: {
            Policy: {}
          }
        },
        S1t: {
          type: "structure",
          members: {
            SNSTopic: {},
            Events: {
              type: "list",
              member: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/glacier-2012-06-01.paginators.json
var require_glacier_2012_06_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/glacier-2012-06-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListJobs: {
          input_token: "marker",
          limit_key: "limit",
          output_token: "Marker",
          result_key: "JobList"
        },
        ListMultipartUploads: {
          input_token: "marker",
          limit_key: "limit",
          output_token: "Marker",
          result_key: "UploadsList"
        },
        ListParts: {
          input_token: "marker",
          limit_key: "limit",
          output_token: "Marker",
          result_key: "Parts"
        },
        ListVaults: {
          input_token: "marker",
          limit_key: "limit",
          output_token: "Marker",
          result_key: "VaultList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/glacier-2012-06-01.waiters2.json
var require_glacier_2012_06_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/glacier-2012-06-01.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        VaultExists: {
          operation: "DescribeVault",
          delay: 3,
          maxAttempts: 15,
          acceptors: [
            {
              state: "success",
              matcher: "status",
              expected: 200
            },
            {
              state: "retry",
              matcher: "error",
              expected: "ResourceNotFoundException"
            }
          ]
        },
        VaultNotExists: {
          operation: "DescribeVault",
          delay: 3,
          maxAttempts: 15,
          acceptors: [
            {
              state: "retry",
              matcher: "status",
              expected: 200
            },
            {
              state: "success",
              matcher: "error",
              expected: "ResourceNotFoundException"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/glacier.js
var require_glacier2 = __commonJS({
  "node_modules/aws-sdk/clients/glacier.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["glacier"] = {};
    AWS2.Glacier = Service.defineService("glacier", ["2012-06-01"]);
    require_glacier();
    Object.defineProperty(apiLoader.services["glacier"], "2012-06-01", {
      get: function get() {
        var model = require_glacier_2012_06_01_min();
        model.paginators = require_glacier_2012_06_01_paginators().pagination;
        model.waiters = require_glacier_2012_06_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Glacier;
  }
});

// node_modules/aws-sdk/apis/health-2016-08-04.min.json
var require_health_2016_08_04_min = __commonJS({
  "node_modules/aws-sdk/apis/health-2016-08-04.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-08-04",
        endpointPrefix: "health",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "AWSHealth",
        serviceFullName: "AWS Health APIs and Notifications",
        serviceId: "Health",
        signatureVersion: "v4",
        targetPrefix: "AWSHealth_20160804",
        uid: "health-2016-08-04"
      },
      operations: {
        DescribeAffectedAccountsForOrganization: {
          input: {
            type: "structure",
            required: [
              "eventArn"
            ],
            members: {
              eventArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              affectedAccounts: {
                type: "list",
                member: {}
              },
              eventScopeCode: {},
              nextToken: {}
            }
          },
          idempotent: true
        },
        DescribeAffectedEntities: {
          input: {
            type: "structure",
            required: [
              "filter"
            ],
            members: {
              filter: {
                type: "structure",
                required: [
                  "eventArns"
                ],
                members: {
                  eventArns: {
                    shape: "Sb"
                  },
                  entityArns: {
                    shape: "Sc"
                  },
                  entityValues: {
                    shape: "Se"
                  },
                  lastUpdatedTimes: {
                    shape: "Sg"
                  },
                  tags: {
                    shape: "Sj"
                  },
                  statusCodes: {
                    shape: "Sn"
                  }
                }
              },
              locale: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              entities: {
                shape: "Sr"
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        DescribeAffectedEntitiesForOrganization: {
          input: {
            type: "structure",
            members: {
              organizationEntityFilters: {
                deprecated: true,
                deprecatedMessage: "This property is deprecated, use organizationEntityAccountFilters instead.",
                type: "list",
                member: {
                  shape: "Sw"
                }
              },
              locale: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              organizationEntityAccountFilters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "eventArn"
                  ],
                  members: {
                    eventArn: {},
                    awsAccountId: {},
                    statusCodes: {
                      shape: "Sn"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              entities: {
                shape: "Sr"
              },
              failedSet: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    awsAccountId: {},
                    eventArn: {},
                    errorName: {},
                    errorMessage: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        DescribeEntityAggregates: {
          input: {
            type: "structure",
            members: {
              eventArns: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              entityAggregates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    eventArn: {},
                    count: {
                      type: "integer"
                    },
                    statuses: {
                      shape: "S1a"
                    }
                  }
                }
              }
            }
          },
          idempotent: true
        },
        DescribeEntityAggregatesForOrganization: {
          input: {
            type: "structure",
            required: [
              "eventArns"
            ],
            members: {
              eventArns: {
                type: "list",
                member: {}
              },
              awsAccountIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              organizationEntityAggregates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    eventArn: {},
                    count: {
                      type: "integer"
                    },
                    statuses: {
                      shape: "S1a"
                    },
                    accounts: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          accountId: {},
                          count: {
                            type: "integer"
                          },
                          statuses: {
                            shape: "S1a"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          idempotent: true
        },
        DescribeEventAggregates: {
          input: {
            type: "structure",
            required: [
              "aggregateField"
            ],
            members: {
              filter: {
                shape: "S1k"
              },
              aggregateField: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              eventAggregates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    aggregateValue: {},
                    count: {
                      type: "integer"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        DescribeEventDetails: {
          input: {
            type: "structure",
            required: [
              "eventArns"
            ],
            members: {
              eventArns: {
                shape: "Sb"
              },
              locale: {}
            }
          },
          output: {
            type: "structure",
            members: {
              successfulSet: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    event: {
                      shape: "S26"
                    },
                    eventDescription: {
                      shape: "S28"
                    },
                    eventMetadata: {
                      shape: "S2a"
                    }
                  }
                }
              },
              failedSet: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    eventArn: {},
                    errorName: {},
                    errorMessage: {}
                  }
                }
              }
            }
          },
          idempotent: true
        },
        DescribeEventDetailsForOrganization: {
          input: {
            type: "structure",
            required: [
              "organizationEventDetailFilters"
            ],
            members: {
              organizationEventDetailFilters: {
                type: "list",
                member: {
                  shape: "Sw"
                }
              },
              locale: {}
            }
          },
          output: {
            type: "structure",
            members: {
              successfulSet: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    awsAccountId: {},
                    event: {
                      shape: "S26"
                    },
                    eventDescription: {
                      shape: "S28"
                    },
                    eventMetadata: {
                      shape: "S2a"
                    }
                  }
                }
              },
              failedSet: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    awsAccountId: {},
                    eventArn: {},
                    errorName: {},
                    errorMessage: {}
                  }
                }
              }
            }
          },
          idempotent: true
        },
        DescribeEventTypes: {
          input: {
            type: "structure",
            members: {
              filter: {
                type: "structure",
                members: {
                  eventTypeCodes: {
                    type: "list",
                    member: {}
                  },
                  services: {
                    shape: "S1n"
                  },
                  eventTypeCategories: {
                    type: "list",
                    member: {}
                  }
                }
              },
              locale: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              eventTypes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    service: {},
                    code: {},
                    category: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        DescribeEvents: {
          input: {
            type: "structure",
            members: {
              filter: {
                shape: "S1k"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              locale: {}
            }
          },
          output: {
            type: "structure",
            members: {
              events: {
                type: "list",
                member: {
                  shape: "S26"
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        DescribeEventsForOrganization: {
          input: {
            type: "structure",
            members: {
              filter: {
                type: "structure",
                members: {
                  eventTypeCodes: {
                    shape: "S1l"
                  },
                  awsAccountIds: {
                    type: "list",
                    member: {}
                  },
                  services: {
                    shape: "S1n"
                  },
                  regions: {
                    shape: "S1p"
                  },
                  startTime: {
                    shape: "Sh"
                  },
                  endTime: {
                    shape: "Sh"
                  },
                  lastUpdatedTime: {
                    shape: "Sh"
                  },
                  entityArns: {
                    shape: "Sc"
                  },
                  entityValues: {
                    shape: "Se"
                  },
                  eventTypeCategories: {
                    shape: "S1t"
                  },
                  eventStatusCodes: {
                    shape: "S1v"
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              locale: {}
            }
          },
          output: {
            type: "structure",
            members: {
              events: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    service: {},
                    eventTypeCode: {},
                    eventTypeCategory: {},
                    eventScopeCode: {},
                    region: {},
                    startTime: {
                      type: "timestamp"
                    },
                    endTime: {
                      type: "timestamp"
                    },
                    lastUpdatedTime: {
                      type: "timestamp"
                    },
                    statusCode: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        DescribeHealthServiceStatusForOrganization: {
          output: {
            type: "structure",
            members: {
              healthServiceAccessStatusForOrganization: {}
            }
          },
          idempotent: true
        },
        DisableHealthServiceAccessForOrganization: {
          idempotent: true
        },
        EnableHealthServiceAccessForOrganization: {
          idempotent: true
        }
      },
      shapes: {
        Sb: {
          type: "list",
          member: {}
        },
        Sc: {
          type: "list",
          member: {}
        },
        Se: {
          type: "list",
          member: {}
        },
        Sg: {
          type: "list",
          member: {
            shape: "Sh"
          }
        },
        Sh: {
          type: "structure",
          members: {
            from: {
              type: "timestamp"
            },
            to: {
              type: "timestamp"
            }
          }
        },
        Sj: {
          type: "list",
          member: {
            shape: "Sk"
          }
        },
        Sk: {
          type: "map",
          key: {},
          value: {}
        },
        Sn: {
          type: "list",
          member: {}
        },
        Sr: {
          type: "list",
          member: {
            type: "structure",
            members: {
              entityArn: {},
              eventArn: {},
              entityValue: {},
              entityUrl: {},
              awsAccountId: {},
              lastUpdatedTime: {
                type: "timestamp"
              },
              statusCode: {},
              tags: {
                shape: "Sk"
              }
            }
          }
        },
        Sw: {
          type: "structure",
          required: [
            "eventArn"
          ],
          members: {
            eventArn: {},
            awsAccountId: {}
          }
        },
        S1a: {
          type: "map",
          key: {},
          value: {
            type: "integer"
          }
        },
        S1k: {
          type: "structure",
          members: {
            eventArns: {
              shape: "Sb"
            },
            eventTypeCodes: {
              shape: "S1l"
            },
            services: {
              shape: "S1n"
            },
            regions: {
              shape: "S1p"
            },
            availabilityZones: {
              type: "list",
              member: {}
            },
            startTimes: {
              shape: "Sg"
            },
            endTimes: {
              shape: "Sg"
            },
            lastUpdatedTimes: {
              shape: "Sg"
            },
            entityArns: {
              shape: "Sc"
            },
            entityValues: {
              shape: "Se"
            },
            eventTypeCategories: {
              shape: "S1t"
            },
            tags: {
              shape: "Sj"
            },
            eventStatusCodes: {
              shape: "S1v"
            }
          }
        },
        S1l: {
          type: "list",
          member: {}
        },
        S1n: {
          type: "list",
          member: {}
        },
        S1p: {
          type: "list",
          member: {}
        },
        S1t: {
          type: "list",
          member: {}
        },
        S1v: {
          type: "list",
          member: {}
        },
        S26: {
          type: "structure",
          members: {
            arn: {},
            service: {},
            eventTypeCode: {},
            eventTypeCategory: {},
            region: {},
            availabilityZone: {},
            startTime: {
              type: "timestamp"
            },
            endTime: {
              type: "timestamp"
            },
            lastUpdatedTime: {
              type: "timestamp"
            },
            statusCode: {},
            eventScopeCode: {}
          }
        },
        S28: {
          type: "structure",
          members: {
            latestDescription: {}
          }
        },
        S2a: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/health-2016-08-04.paginators.json
var require_health_2016_08_04_paginators = __commonJS({
  "node_modules/aws-sdk/apis/health-2016-08-04.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeAffectedAccountsForOrganization: {
          input_token: "nextToken",
          limit_key: "maxResults",
          non_aggregate_keys: [
            "eventScopeCode"
          ],
          output_token: "nextToken",
          result_key: "affectedAccounts"
        },
        DescribeAffectedEntities: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "entities"
        },
        DescribeAffectedEntitiesForOrganization: {
          input_token: "nextToken",
          limit_key: "maxResults",
          non_aggregate_keys: [
            "failedSet"
          ],
          output_token: "nextToken",
          result_key: "entities"
        },
        DescribeEntityAggregates: {
          result_key: "entityAggregates"
        },
        DescribeEventAggregates: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "eventAggregates"
        },
        DescribeEventTypes: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "eventTypes"
        },
        DescribeEvents: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "events"
        },
        DescribeEventsForOrganization: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "events"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/health.js
var require_health = __commonJS({
  "node_modules/aws-sdk/clients/health.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["health"] = {};
    AWS2.Health = Service.defineService("health", ["2016-08-04"]);
    Object.defineProperty(apiLoader.services["health"], "2016-08-04", {
      get: function get() {
        var model = require_health_2016_08_04_min();
        model.paginators = require_health_2016_08_04_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Health;
  }
});

// node_modules/aws-sdk/apis/iam-2010-05-08.min.json
var require_iam_2010_05_08_min = __commonJS({
  "node_modules/aws-sdk/apis/iam-2010-05-08.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2010-05-08",
        endpointPrefix: "iam",
        globalEndpoint: "iam.amazonaws.com",
        protocol: "query",
        serviceAbbreviation: "IAM",
        serviceFullName: "AWS Identity and Access Management",
        serviceId: "IAM",
        signatureVersion: "v4",
        uid: "iam-2010-05-08",
        xmlNamespace: "https://iam.amazonaws.com/doc/2010-05-08/"
      },
      operations: {
        AddClientIDToOpenIDConnectProvider: {
          input: {
            type: "structure",
            required: [
              "OpenIDConnectProviderArn",
              "ClientID"
            ],
            members: {
              OpenIDConnectProviderArn: {},
              ClientID: {}
            }
          }
        },
        AddRoleToInstanceProfile: {
          input: {
            type: "structure",
            required: [
              "InstanceProfileName",
              "RoleName"
            ],
            members: {
              InstanceProfileName: {},
              RoleName: {}
            }
          }
        },
        AddUserToGroup: {
          input: {
            type: "structure",
            required: [
              "GroupName",
              "UserName"
            ],
            members: {
              GroupName: {},
              UserName: {}
            }
          }
        },
        AttachGroupPolicy: {
          input: {
            type: "structure",
            required: [
              "GroupName",
              "PolicyArn"
            ],
            members: {
              GroupName: {},
              PolicyArn: {}
            }
          }
        },
        AttachRolePolicy: {
          input: {
            type: "structure",
            required: [
              "RoleName",
              "PolicyArn"
            ],
            members: {
              RoleName: {},
              PolicyArn: {}
            }
          }
        },
        AttachUserPolicy: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "PolicyArn"
            ],
            members: {
              UserName: {},
              PolicyArn: {}
            }
          }
        },
        ChangePassword: {
          input: {
            type: "structure",
            required: [
              "OldPassword",
              "NewPassword"
            ],
            members: {
              OldPassword: {
                shape: "Sf"
              },
              NewPassword: {
                shape: "Sf"
              }
            }
          }
        },
        CreateAccessKey: {
          input: {
            type: "structure",
            members: {
              UserName: {}
            }
          },
          output: {
            resultWrapper: "CreateAccessKeyResult",
            type: "structure",
            required: [
              "AccessKey"
            ],
            members: {
              AccessKey: {
                type: "structure",
                required: [
                  "UserName",
                  "AccessKeyId",
                  "Status",
                  "SecretAccessKey"
                ],
                members: {
                  UserName: {},
                  AccessKeyId: {},
                  Status: {},
                  SecretAccessKey: {
                    type: "string",
                    sensitive: true
                  },
                  CreateDate: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        CreateAccountAlias: {
          input: {
            type: "structure",
            required: [
              "AccountAlias"
            ],
            members: {
              AccountAlias: {}
            }
          }
        },
        CreateGroup: {
          input: {
            type: "structure",
            required: [
              "GroupName"
            ],
            members: {
              Path: {},
              GroupName: {}
            }
          },
          output: {
            resultWrapper: "CreateGroupResult",
            type: "structure",
            required: [
              "Group"
            ],
            members: {
              Group: {
                shape: "Ss"
              }
            }
          }
        },
        CreateInstanceProfile: {
          input: {
            type: "structure",
            required: [
              "InstanceProfileName"
            ],
            members: {
              InstanceProfileName: {},
              Path: {},
              Tags: {
                shape: "Sv"
              }
            }
          },
          output: {
            resultWrapper: "CreateInstanceProfileResult",
            type: "structure",
            required: [
              "InstanceProfile"
            ],
            members: {
              InstanceProfile: {
                shape: "S10"
              }
            }
          }
        },
        CreateLoginProfile: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "Password"
            ],
            members: {
              UserName: {},
              Password: {
                shape: "Sf"
              },
              PasswordResetRequired: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CreateLoginProfileResult",
            type: "structure",
            required: [
              "LoginProfile"
            ],
            members: {
              LoginProfile: {
                shape: "S1d"
              }
            }
          }
        },
        CreateOpenIDConnectProvider: {
          input: {
            type: "structure",
            required: [
              "Url",
              "ThumbprintList"
            ],
            members: {
              Url: {},
              ClientIDList: {
                shape: "S1g"
              },
              ThumbprintList: {
                shape: "S1h"
              },
              Tags: {
                shape: "Sv"
              }
            }
          },
          output: {
            resultWrapper: "CreateOpenIDConnectProviderResult",
            type: "structure",
            members: {
              OpenIDConnectProviderArn: {},
              Tags: {
                shape: "Sv"
              }
            }
          }
        },
        CreatePolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyName",
              "PolicyDocument"
            ],
            members: {
              PolicyName: {},
              Path: {},
              PolicyDocument: {},
              Description: {},
              Tags: {
                shape: "Sv"
              }
            }
          },
          output: {
            resultWrapper: "CreatePolicyResult",
            type: "structure",
            members: {
              Policy: {
                shape: "S1p"
              }
            }
          }
        },
        CreatePolicyVersion: {
          input: {
            type: "structure",
            required: [
              "PolicyArn",
              "PolicyDocument"
            ],
            members: {
              PolicyArn: {},
              PolicyDocument: {},
              SetAsDefault: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CreatePolicyVersionResult",
            type: "structure",
            members: {
              PolicyVersion: {
                shape: "S1u"
              }
            }
          }
        },
        CreateRole: {
          input: {
            type: "structure",
            required: [
              "RoleName",
              "AssumeRolePolicyDocument"
            ],
            members: {
              Path: {},
              RoleName: {},
              AssumeRolePolicyDocument: {},
              Description: {},
              MaxSessionDuration: {
                type: "integer"
              },
              PermissionsBoundary: {},
              Tags: {
                shape: "Sv"
              }
            }
          },
          output: {
            resultWrapper: "CreateRoleResult",
            type: "structure",
            required: [
              "Role"
            ],
            members: {
              Role: {
                shape: "S12"
              }
            }
          }
        },
        CreateSAMLProvider: {
          input: {
            type: "structure",
            required: [
              "SAMLMetadataDocument",
              "Name"
            ],
            members: {
              SAMLMetadataDocument: {},
              Name: {},
              Tags: {
                shape: "Sv"
              }
            }
          },
          output: {
            resultWrapper: "CreateSAMLProviderResult",
            type: "structure",
            members: {
              SAMLProviderArn: {},
              Tags: {
                shape: "Sv"
              }
            }
          }
        },
        CreateServiceLinkedRole: {
          input: {
            type: "structure",
            required: [
              "AWSServiceName"
            ],
            members: {
              AWSServiceName: {},
              Description: {},
              CustomSuffix: {}
            }
          },
          output: {
            resultWrapper: "CreateServiceLinkedRoleResult",
            type: "structure",
            members: {
              Role: {
                shape: "S12"
              }
            }
          }
        },
        CreateServiceSpecificCredential: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "ServiceName"
            ],
            members: {
              UserName: {},
              ServiceName: {}
            }
          },
          output: {
            resultWrapper: "CreateServiceSpecificCredentialResult",
            type: "structure",
            members: {
              ServiceSpecificCredential: {
                shape: "S27"
              }
            }
          }
        },
        CreateUser: {
          input: {
            type: "structure",
            required: [
              "UserName"
            ],
            members: {
              Path: {},
              UserName: {},
              PermissionsBoundary: {},
              Tags: {
                shape: "Sv"
              }
            }
          },
          output: {
            resultWrapper: "CreateUserResult",
            type: "structure",
            members: {
              User: {
                shape: "S2d"
              }
            }
          }
        },
        CreateVirtualMFADevice: {
          input: {
            type: "structure",
            required: [
              "VirtualMFADeviceName"
            ],
            members: {
              Path: {},
              VirtualMFADeviceName: {},
              Tags: {
                shape: "Sv"
              }
            }
          },
          output: {
            resultWrapper: "CreateVirtualMFADeviceResult",
            type: "structure",
            required: [
              "VirtualMFADevice"
            ],
            members: {
              VirtualMFADevice: {
                shape: "S2h"
              }
            }
          }
        },
        DeactivateMFADevice: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "SerialNumber"
            ],
            members: {
              UserName: {},
              SerialNumber: {}
            }
          }
        },
        DeleteAccessKey: {
          input: {
            type: "structure",
            required: [
              "AccessKeyId"
            ],
            members: {
              UserName: {},
              AccessKeyId: {}
            }
          }
        },
        DeleteAccountAlias: {
          input: {
            type: "structure",
            required: [
              "AccountAlias"
            ],
            members: {
              AccountAlias: {}
            }
          }
        },
        DeleteAccountPasswordPolicy: {},
        DeleteGroup: {
          input: {
            type: "structure",
            required: [
              "GroupName"
            ],
            members: {
              GroupName: {}
            }
          }
        },
        DeleteGroupPolicy: {
          input: {
            type: "structure",
            required: [
              "GroupName",
              "PolicyName"
            ],
            members: {
              GroupName: {},
              PolicyName: {}
            }
          }
        },
        DeleteInstanceProfile: {
          input: {
            type: "structure",
            required: [
              "InstanceProfileName"
            ],
            members: {
              InstanceProfileName: {}
            }
          }
        },
        DeleteLoginProfile: {
          input: {
            type: "structure",
            required: [
              "UserName"
            ],
            members: {
              UserName: {}
            }
          }
        },
        DeleteOpenIDConnectProvider: {
          input: {
            type: "structure",
            required: [
              "OpenIDConnectProviderArn"
            ],
            members: {
              OpenIDConnectProviderArn: {}
            }
          }
        },
        DeletePolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyArn"
            ],
            members: {
              PolicyArn: {}
            }
          }
        },
        DeletePolicyVersion: {
          input: {
            type: "structure",
            required: [
              "PolicyArn",
              "VersionId"
            ],
            members: {
              PolicyArn: {},
              VersionId: {}
            }
          }
        },
        DeleteRole: {
          input: {
            type: "structure",
            required: [
              "RoleName"
            ],
            members: {
              RoleName: {}
            }
          }
        },
        DeleteRolePermissionsBoundary: {
          input: {
            type: "structure",
            required: [
              "RoleName"
            ],
            members: {
              RoleName: {}
            }
          }
        },
        DeleteRolePolicy: {
          input: {
            type: "structure",
            required: [
              "RoleName",
              "PolicyName"
            ],
            members: {
              RoleName: {},
              PolicyName: {}
            }
          }
        },
        DeleteSAMLProvider: {
          input: {
            type: "structure",
            required: [
              "SAMLProviderArn"
            ],
            members: {
              SAMLProviderArn: {}
            }
          }
        },
        DeleteSSHPublicKey: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "SSHPublicKeyId"
            ],
            members: {
              UserName: {},
              SSHPublicKeyId: {}
            }
          }
        },
        DeleteServerCertificate: {
          input: {
            type: "structure",
            required: [
              "ServerCertificateName"
            ],
            members: {
              ServerCertificateName: {}
            }
          }
        },
        DeleteServiceLinkedRole: {
          input: {
            type: "structure",
            required: [
              "RoleName"
            ],
            members: {
              RoleName: {}
            }
          },
          output: {
            resultWrapper: "DeleteServiceLinkedRoleResult",
            type: "structure",
            required: [
              "DeletionTaskId"
            ],
            members: {
              DeletionTaskId: {}
            }
          }
        },
        DeleteServiceSpecificCredential: {
          input: {
            type: "structure",
            required: [
              "ServiceSpecificCredentialId"
            ],
            members: {
              UserName: {},
              ServiceSpecificCredentialId: {}
            }
          }
        },
        DeleteSigningCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateId"
            ],
            members: {
              UserName: {},
              CertificateId: {}
            }
          }
        },
        DeleteUser: {
          input: {
            type: "structure",
            required: [
              "UserName"
            ],
            members: {
              UserName: {}
            }
          }
        },
        DeleteUserPermissionsBoundary: {
          input: {
            type: "structure",
            required: [
              "UserName"
            ],
            members: {
              UserName: {}
            }
          }
        },
        DeleteUserPolicy: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "PolicyName"
            ],
            members: {
              UserName: {},
              PolicyName: {}
            }
          }
        },
        DeleteVirtualMFADevice: {
          input: {
            type: "structure",
            required: [
              "SerialNumber"
            ],
            members: {
              SerialNumber: {}
            }
          }
        },
        DetachGroupPolicy: {
          input: {
            type: "structure",
            required: [
              "GroupName",
              "PolicyArn"
            ],
            members: {
              GroupName: {},
              PolicyArn: {}
            }
          }
        },
        DetachRolePolicy: {
          input: {
            type: "structure",
            required: [
              "RoleName",
              "PolicyArn"
            ],
            members: {
              RoleName: {},
              PolicyArn: {}
            }
          }
        },
        DetachUserPolicy: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "PolicyArn"
            ],
            members: {
              UserName: {},
              PolicyArn: {}
            }
          }
        },
        EnableMFADevice: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "SerialNumber",
              "AuthenticationCode1",
              "AuthenticationCode2"
            ],
            members: {
              UserName: {},
              SerialNumber: {},
              AuthenticationCode1: {},
              AuthenticationCode2: {}
            }
          }
        },
        GenerateCredentialReport: {
          output: {
            resultWrapper: "GenerateCredentialReportResult",
            type: "structure",
            members: {
              State: {},
              Description: {}
            }
          }
        },
        GenerateOrganizationsAccessReport: {
          input: {
            type: "structure",
            required: [
              "EntityPath"
            ],
            members: {
              EntityPath: {},
              OrganizationsPolicyId: {}
            }
          },
          output: {
            resultWrapper: "GenerateOrganizationsAccessReportResult",
            type: "structure",
            members: {
              JobId: {}
            }
          }
        },
        GenerateServiceLastAccessedDetails: {
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {},
              Granularity: {}
            }
          },
          output: {
            resultWrapper: "GenerateServiceLastAccessedDetailsResult",
            type: "structure",
            members: {
              JobId: {}
            }
          }
        },
        GetAccessKeyLastUsed: {
          input: {
            type: "structure",
            required: [
              "AccessKeyId"
            ],
            members: {
              AccessKeyId: {}
            }
          },
          output: {
            resultWrapper: "GetAccessKeyLastUsedResult",
            type: "structure",
            members: {
              UserName: {},
              AccessKeyLastUsed: {
                type: "structure",
                required: [
                  "LastUsedDate",
                  "ServiceName",
                  "Region"
                ],
                members: {
                  LastUsedDate: {
                    type: "timestamp"
                  },
                  ServiceName: {},
                  Region: {}
                }
              }
            }
          }
        },
        GetAccountAuthorizationDetails: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "list",
                member: {}
              },
              MaxItems: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "GetAccountAuthorizationDetailsResult",
            type: "structure",
            members: {
              UserDetailList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Path: {},
                    UserName: {},
                    UserId: {},
                    Arn: {},
                    CreateDate: {
                      type: "timestamp"
                    },
                    UserPolicyList: {
                      shape: "S43"
                    },
                    GroupList: {
                      type: "list",
                      member: {}
                    },
                    AttachedManagedPolicies: {
                      shape: "S46"
                    },
                    PermissionsBoundary: {
                      shape: "S16"
                    },
                    Tags: {
                      shape: "Sv"
                    }
                  }
                }
              },
              GroupDetailList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Path: {},
                    GroupName: {},
                    GroupId: {},
                    Arn: {},
                    CreateDate: {
                      type: "timestamp"
                    },
                    GroupPolicyList: {
                      shape: "S43"
                    },
                    AttachedManagedPolicies: {
                      shape: "S46"
                    }
                  }
                }
              },
              RoleDetailList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Path: {},
                    RoleName: {},
                    RoleId: {},
                    Arn: {},
                    CreateDate: {
                      type: "timestamp"
                    },
                    AssumeRolePolicyDocument: {},
                    InstanceProfileList: {
                      shape: "S4c"
                    },
                    RolePolicyList: {
                      shape: "S43"
                    },
                    AttachedManagedPolicies: {
                      shape: "S46"
                    },
                    PermissionsBoundary: {
                      shape: "S16"
                    },
                    Tags: {
                      shape: "Sv"
                    },
                    RoleLastUsed: {
                      shape: "S18"
                    }
                  }
                }
              },
              Policies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PolicyName: {},
                    PolicyId: {},
                    Arn: {},
                    Path: {},
                    DefaultVersionId: {},
                    AttachmentCount: {
                      type: "integer"
                    },
                    PermissionsBoundaryUsageCount: {
                      type: "integer"
                    },
                    IsAttachable: {
                      type: "boolean"
                    },
                    Description: {},
                    CreateDate: {
                      type: "timestamp"
                    },
                    UpdateDate: {
                      type: "timestamp"
                    },
                    PolicyVersionList: {
                      shape: "S4f"
                    }
                  }
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        GetAccountPasswordPolicy: {
          output: {
            resultWrapper: "GetAccountPasswordPolicyResult",
            type: "structure",
            required: [
              "PasswordPolicy"
            ],
            members: {
              PasswordPolicy: {
                type: "structure",
                members: {
                  MinimumPasswordLength: {
                    type: "integer"
                  },
                  RequireSymbols: {
                    type: "boolean"
                  },
                  RequireNumbers: {
                    type: "boolean"
                  },
                  RequireUppercaseCharacters: {
                    type: "boolean"
                  },
                  RequireLowercaseCharacters: {
                    type: "boolean"
                  },
                  AllowUsersToChangePassword: {
                    type: "boolean"
                  },
                  ExpirePasswords: {
                    type: "boolean"
                  },
                  MaxPasswordAge: {
                    type: "integer"
                  },
                  PasswordReusePrevention: {
                    type: "integer"
                  },
                  HardExpiry: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        GetAccountSummary: {
          output: {
            resultWrapper: "GetAccountSummaryResult",
            type: "structure",
            members: {
              SummaryMap: {
                type: "map",
                key: {},
                value: {
                  type: "integer"
                }
              }
            }
          }
        },
        GetContextKeysForCustomPolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyInputList"
            ],
            members: {
              PolicyInputList: {
                shape: "S4s"
              }
            }
          },
          output: {
            shape: "S4t",
            resultWrapper: "GetContextKeysForCustomPolicyResult"
          }
        },
        GetContextKeysForPrincipalPolicy: {
          input: {
            type: "structure",
            required: [
              "PolicySourceArn"
            ],
            members: {
              PolicySourceArn: {},
              PolicyInputList: {
                shape: "S4s"
              }
            }
          },
          output: {
            shape: "S4t",
            resultWrapper: "GetContextKeysForPrincipalPolicyResult"
          }
        },
        GetCredentialReport: {
          output: {
            resultWrapper: "GetCredentialReportResult",
            type: "structure",
            members: {
              Content: {
                type: "blob"
              },
              ReportFormat: {},
              GeneratedTime: {
                type: "timestamp"
              }
            }
          }
        },
        GetGroup: {
          input: {
            type: "structure",
            required: [
              "GroupName"
            ],
            members: {
              GroupName: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "GetGroupResult",
            type: "structure",
            required: [
              "Group",
              "Users"
            ],
            members: {
              Group: {
                shape: "Ss"
              },
              Users: {
                shape: "S52"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        GetGroupPolicy: {
          input: {
            type: "structure",
            required: [
              "GroupName",
              "PolicyName"
            ],
            members: {
              GroupName: {},
              PolicyName: {}
            }
          },
          output: {
            resultWrapper: "GetGroupPolicyResult",
            type: "structure",
            required: [
              "GroupName",
              "PolicyName",
              "PolicyDocument"
            ],
            members: {
              GroupName: {},
              PolicyName: {},
              PolicyDocument: {}
            }
          }
        },
        GetInstanceProfile: {
          input: {
            type: "structure",
            required: [
              "InstanceProfileName"
            ],
            members: {
              InstanceProfileName: {}
            }
          },
          output: {
            resultWrapper: "GetInstanceProfileResult",
            type: "structure",
            required: [
              "InstanceProfile"
            ],
            members: {
              InstanceProfile: {
                shape: "S10"
              }
            }
          }
        },
        GetLoginProfile: {
          input: {
            type: "structure",
            required: [
              "UserName"
            ],
            members: {
              UserName: {}
            }
          },
          output: {
            resultWrapper: "GetLoginProfileResult",
            type: "structure",
            required: [
              "LoginProfile"
            ],
            members: {
              LoginProfile: {
                shape: "S1d"
              }
            }
          }
        },
        GetMFADevice: {
          input: {
            type: "structure",
            required: [
              "SerialNumber"
            ],
            members: {
              SerialNumber: {},
              UserName: {}
            }
          },
          output: {
            resultWrapper: "GetMFADeviceResult",
            type: "structure",
            required: [
              "SerialNumber"
            ],
            members: {
              UserName: {},
              SerialNumber: {},
              EnableDate: {
                type: "timestamp"
              },
              Certifications: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        GetOpenIDConnectProvider: {
          input: {
            type: "structure",
            required: [
              "OpenIDConnectProviderArn"
            ],
            members: {
              OpenIDConnectProviderArn: {}
            }
          },
          output: {
            resultWrapper: "GetOpenIDConnectProviderResult",
            type: "structure",
            members: {
              Url: {},
              ClientIDList: {
                shape: "S1g"
              },
              ThumbprintList: {
                shape: "S1h"
              },
              CreateDate: {
                type: "timestamp"
              },
              Tags: {
                shape: "Sv"
              }
            }
          }
        },
        GetOrganizationsAccessReport: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              MaxItems: {
                type: "integer"
              },
              Marker: {},
              SortKey: {}
            }
          },
          output: {
            resultWrapper: "GetOrganizationsAccessReportResult",
            type: "structure",
            required: [
              "JobStatus",
              "JobCreationDate"
            ],
            members: {
              JobStatus: {},
              JobCreationDate: {
                type: "timestamp"
              },
              JobCompletionDate: {
                type: "timestamp"
              },
              NumberOfServicesAccessible: {
                type: "integer"
              },
              NumberOfServicesNotAccessed: {
                type: "integer"
              },
              AccessDetails: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ServiceName",
                    "ServiceNamespace"
                  ],
                  members: {
                    ServiceName: {},
                    ServiceNamespace: {},
                    Region: {},
                    EntityPath: {},
                    LastAuthenticatedTime: {
                      type: "timestamp"
                    },
                    TotalAuthenticatedEntities: {
                      type: "integer"
                    }
                  }
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {},
              ErrorDetails: {
                shape: "S5p"
              }
            }
          }
        },
        GetPolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyArn"
            ],
            members: {
              PolicyArn: {}
            }
          },
          output: {
            resultWrapper: "GetPolicyResult",
            type: "structure",
            members: {
              Policy: {
                shape: "S1p"
              }
            }
          }
        },
        GetPolicyVersion: {
          input: {
            type: "structure",
            required: [
              "PolicyArn",
              "VersionId"
            ],
            members: {
              PolicyArn: {},
              VersionId: {}
            }
          },
          output: {
            resultWrapper: "GetPolicyVersionResult",
            type: "structure",
            members: {
              PolicyVersion: {
                shape: "S1u"
              }
            }
          }
        },
        GetRole: {
          input: {
            type: "structure",
            required: [
              "RoleName"
            ],
            members: {
              RoleName: {}
            }
          },
          output: {
            resultWrapper: "GetRoleResult",
            type: "structure",
            required: [
              "Role"
            ],
            members: {
              Role: {
                shape: "S12"
              }
            }
          }
        },
        GetRolePolicy: {
          input: {
            type: "structure",
            required: [
              "RoleName",
              "PolicyName"
            ],
            members: {
              RoleName: {},
              PolicyName: {}
            }
          },
          output: {
            resultWrapper: "GetRolePolicyResult",
            type: "structure",
            required: [
              "RoleName",
              "PolicyName",
              "PolicyDocument"
            ],
            members: {
              RoleName: {},
              PolicyName: {},
              PolicyDocument: {}
            }
          }
        },
        GetSAMLProvider: {
          input: {
            type: "structure",
            required: [
              "SAMLProviderArn"
            ],
            members: {
              SAMLProviderArn: {}
            }
          },
          output: {
            resultWrapper: "GetSAMLProviderResult",
            type: "structure",
            members: {
              SAMLMetadataDocument: {},
              CreateDate: {
                type: "timestamp"
              },
              ValidUntil: {
                type: "timestamp"
              },
              Tags: {
                shape: "Sv"
              }
            }
          }
        },
        GetSSHPublicKey: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "SSHPublicKeyId",
              "Encoding"
            ],
            members: {
              UserName: {},
              SSHPublicKeyId: {},
              Encoding: {}
            }
          },
          output: {
            resultWrapper: "GetSSHPublicKeyResult",
            type: "structure",
            members: {
              SSHPublicKey: {
                shape: "S63"
              }
            }
          }
        },
        GetServerCertificate: {
          input: {
            type: "structure",
            required: [
              "ServerCertificateName"
            ],
            members: {
              ServerCertificateName: {}
            }
          },
          output: {
            resultWrapper: "GetServerCertificateResult",
            type: "structure",
            required: [
              "ServerCertificate"
            ],
            members: {
              ServerCertificate: {
                type: "structure",
                required: [
                  "ServerCertificateMetadata",
                  "CertificateBody"
                ],
                members: {
                  ServerCertificateMetadata: {
                    shape: "S69"
                  },
                  CertificateBody: {},
                  CertificateChain: {},
                  Tags: {
                    shape: "Sv"
                  }
                }
              }
            }
          }
        },
        GetServiceLastAccessedDetails: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              MaxItems: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "GetServiceLastAccessedDetailsResult",
            type: "structure",
            required: [
              "JobStatus",
              "JobCreationDate",
              "ServicesLastAccessed",
              "JobCompletionDate"
            ],
            members: {
              JobStatus: {},
              JobType: {},
              JobCreationDate: {
                type: "timestamp"
              },
              ServicesLastAccessed: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ServiceName",
                    "ServiceNamespace"
                  ],
                  members: {
                    ServiceName: {},
                    LastAuthenticated: {
                      type: "timestamp"
                    },
                    ServiceNamespace: {},
                    LastAuthenticatedEntity: {},
                    LastAuthenticatedRegion: {},
                    TotalAuthenticatedEntities: {
                      type: "integer"
                    },
                    TrackedActionsLastAccessed: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ActionName: {},
                          LastAccessedEntity: {},
                          LastAccessedTime: {
                            type: "timestamp"
                          },
                          LastAccessedRegion: {}
                        }
                      }
                    }
                  }
                }
              },
              JobCompletionDate: {
                type: "timestamp"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {},
              Error: {
                shape: "S5p"
              }
            }
          }
        },
        GetServiceLastAccessedDetailsWithEntities: {
          input: {
            type: "structure",
            required: [
              "JobId",
              "ServiceNamespace"
            ],
            members: {
              JobId: {},
              ServiceNamespace: {},
              MaxItems: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "GetServiceLastAccessedDetailsWithEntitiesResult",
            type: "structure",
            required: [
              "JobStatus",
              "JobCreationDate",
              "JobCompletionDate",
              "EntityDetailsList"
            ],
            members: {
              JobStatus: {},
              JobCreationDate: {
                type: "timestamp"
              },
              JobCompletionDate: {
                type: "timestamp"
              },
              EntityDetailsList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "EntityInfo"
                  ],
                  members: {
                    EntityInfo: {
                      type: "structure",
                      required: [
                        "Arn",
                        "Name",
                        "Type",
                        "Id"
                      ],
                      members: {
                        Arn: {},
                        Name: {},
                        Type: {},
                        Id: {},
                        Path: {}
                      }
                    },
                    LastAuthenticated: {
                      type: "timestamp"
                    }
                  }
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {},
              Error: {
                shape: "S5p"
              }
            }
          }
        },
        GetServiceLinkedRoleDeletionStatus: {
          input: {
            type: "structure",
            required: [
              "DeletionTaskId"
            ],
            members: {
              DeletionTaskId: {}
            }
          },
          output: {
            resultWrapper: "GetServiceLinkedRoleDeletionStatusResult",
            type: "structure",
            required: [
              "Status"
            ],
            members: {
              Status: {},
              Reason: {
                type: "structure",
                members: {
                  Reason: {},
                  RoleUsageList: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Region: {},
                        Resources: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetUser: {
          input: {
            type: "structure",
            members: {
              UserName: {}
            }
          },
          output: {
            resultWrapper: "GetUserResult",
            type: "structure",
            required: [
              "User"
            ],
            members: {
              User: {
                shape: "S2d"
              }
            }
          }
        },
        GetUserPolicy: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "PolicyName"
            ],
            members: {
              UserName: {},
              PolicyName: {}
            }
          },
          output: {
            resultWrapper: "GetUserPolicyResult",
            type: "structure",
            required: [
              "UserName",
              "PolicyName",
              "PolicyDocument"
            ],
            members: {
              UserName: {},
              PolicyName: {},
              PolicyDocument: {}
            }
          }
        },
        ListAccessKeys: {
          input: {
            type: "structure",
            members: {
              UserName: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListAccessKeysResult",
            type: "structure",
            required: [
              "AccessKeyMetadata"
            ],
            members: {
              AccessKeyMetadata: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    UserName: {},
                    AccessKeyId: {},
                    Status: {},
                    CreateDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListAccountAliases: {
          input: {
            type: "structure",
            members: {
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListAccountAliasesResult",
            type: "structure",
            required: [
              "AccountAliases"
            ],
            members: {
              AccountAliases: {
                type: "list",
                member: {}
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListAttachedGroupPolicies: {
          input: {
            type: "structure",
            required: [
              "GroupName"
            ],
            members: {
              GroupName: {},
              PathPrefix: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListAttachedGroupPoliciesResult",
            type: "structure",
            members: {
              AttachedPolicies: {
                shape: "S46"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListAttachedRolePolicies: {
          input: {
            type: "structure",
            required: [
              "RoleName"
            ],
            members: {
              RoleName: {},
              PathPrefix: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListAttachedRolePoliciesResult",
            type: "structure",
            members: {
              AttachedPolicies: {
                shape: "S46"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListAttachedUserPolicies: {
          input: {
            type: "structure",
            required: [
              "UserName"
            ],
            members: {
              UserName: {},
              PathPrefix: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListAttachedUserPoliciesResult",
            type: "structure",
            members: {
              AttachedPolicies: {
                shape: "S46"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListEntitiesForPolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyArn"
            ],
            members: {
              PolicyArn: {},
              EntityFilter: {},
              PathPrefix: {},
              PolicyUsageFilter: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListEntitiesForPolicyResult",
            type: "structure",
            members: {
              PolicyGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    GroupName: {},
                    GroupId: {}
                  }
                }
              },
              PolicyUsers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    UserName: {},
                    UserId: {}
                  }
                }
              },
              PolicyRoles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RoleName: {},
                    RoleId: {}
                  }
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListGroupPolicies: {
          input: {
            type: "structure",
            required: [
              "GroupName"
            ],
            members: {
              GroupName: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListGroupPoliciesResult",
            type: "structure",
            required: [
              "PolicyNames"
            ],
            members: {
              PolicyNames: {
                shape: "S7p"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListGroups: {
          input: {
            type: "structure",
            members: {
              PathPrefix: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListGroupsResult",
            type: "structure",
            required: [
              "Groups"
            ],
            members: {
              Groups: {
                shape: "S7t"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListGroupsForUser: {
          input: {
            type: "structure",
            required: [
              "UserName"
            ],
            members: {
              UserName: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListGroupsForUserResult",
            type: "structure",
            required: [
              "Groups"
            ],
            members: {
              Groups: {
                shape: "S7t"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListInstanceProfileTags: {
          input: {
            type: "structure",
            required: [
              "InstanceProfileName"
            ],
            members: {
              InstanceProfileName: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListInstanceProfileTagsResult",
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "Sv"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListInstanceProfiles: {
          input: {
            type: "structure",
            members: {
              PathPrefix: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListInstanceProfilesResult",
            type: "structure",
            required: [
              "InstanceProfiles"
            ],
            members: {
              InstanceProfiles: {
                shape: "S4c"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListInstanceProfilesForRole: {
          input: {
            type: "structure",
            required: [
              "RoleName"
            ],
            members: {
              RoleName: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListInstanceProfilesForRoleResult",
            type: "structure",
            required: [
              "InstanceProfiles"
            ],
            members: {
              InstanceProfiles: {
                shape: "S4c"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListMFADeviceTags: {
          input: {
            type: "structure",
            required: [
              "SerialNumber"
            ],
            members: {
              SerialNumber: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListMFADeviceTagsResult",
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "Sv"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListMFADevices: {
          input: {
            type: "structure",
            members: {
              UserName: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListMFADevicesResult",
            type: "structure",
            required: [
              "MFADevices"
            ],
            members: {
              MFADevices: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "UserName",
                    "SerialNumber",
                    "EnableDate"
                  ],
                  members: {
                    UserName: {},
                    SerialNumber: {},
                    EnableDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListOpenIDConnectProviderTags: {
          input: {
            type: "structure",
            required: [
              "OpenIDConnectProviderArn"
            ],
            members: {
              OpenIDConnectProviderArn: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListOpenIDConnectProviderTagsResult",
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "Sv"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListOpenIDConnectProviders: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            resultWrapper: "ListOpenIDConnectProvidersResult",
            type: "structure",
            members: {
              OpenIDConnectProviderList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {}
                  }
                }
              }
            }
          }
        },
        ListPolicies: {
          input: {
            type: "structure",
            members: {
              Scope: {},
              OnlyAttached: {
                type: "boolean"
              },
              PathPrefix: {},
              PolicyUsageFilter: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListPoliciesResult",
            type: "structure",
            members: {
              Policies: {
                type: "list",
                member: {
                  shape: "S1p"
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListPoliciesGrantingServiceAccess: {
          input: {
            type: "structure",
            required: [
              "Arn",
              "ServiceNamespaces"
            ],
            members: {
              Marker: {},
              Arn: {},
              ServiceNamespaces: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "ListPoliciesGrantingServiceAccessResult",
            type: "structure",
            required: [
              "PoliciesGrantingServiceAccess"
            ],
            members: {
              PoliciesGrantingServiceAccess: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ServiceNamespace: {},
                    Policies: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "PolicyName",
                          "PolicyType"
                        ],
                        members: {
                          PolicyName: {},
                          PolicyType: {},
                          PolicyArn: {},
                          EntityType: {},
                          EntityName: {}
                        }
                      }
                    }
                  }
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListPolicyTags: {
          input: {
            type: "structure",
            required: [
              "PolicyArn"
            ],
            members: {
              PolicyArn: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListPolicyTagsResult",
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "Sv"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListPolicyVersions: {
          input: {
            type: "structure",
            required: [
              "PolicyArn"
            ],
            members: {
              PolicyArn: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListPolicyVersionsResult",
            type: "structure",
            members: {
              Versions: {
                shape: "S4f"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListRolePolicies: {
          input: {
            type: "structure",
            required: [
              "RoleName"
            ],
            members: {
              RoleName: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListRolePoliciesResult",
            type: "structure",
            required: [
              "PolicyNames"
            ],
            members: {
              PolicyNames: {
                shape: "S7p"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListRoleTags: {
          input: {
            type: "structure",
            required: [
              "RoleName"
            ],
            members: {
              RoleName: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListRoleTagsResult",
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "Sv"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListRoles: {
          input: {
            type: "structure",
            members: {
              PathPrefix: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListRolesResult",
            type: "structure",
            required: [
              "Roles"
            ],
            members: {
              Roles: {
                shape: "S11"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListSAMLProviderTags: {
          input: {
            type: "structure",
            required: [
              "SAMLProviderArn"
            ],
            members: {
              SAMLProviderArn: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListSAMLProviderTagsResult",
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "Sv"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListSAMLProviders: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            resultWrapper: "ListSAMLProvidersResult",
            type: "structure",
            members: {
              SAMLProviderList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    ValidUntil: {
                      type: "timestamp"
                    },
                    CreateDate: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListSSHPublicKeys: {
          input: {
            type: "structure",
            members: {
              UserName: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListSSHPublicKeysResult",
            type: "structure",
            members: {
              SSHPublicKeys: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "UserName",
                    "SSHPublicKeyId",
                    "Status",
                    "UploadDate"
                  ],
                  members: {
                    UserName: {},
                    SSHPublicKeyId: {},
                    Status: {},
                    UploadDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListServerCertificateTags: {
          input: {
            type: "structure",
            required: [
              "ServerCertificateName"
            ],
            members: {
              ServerCertificateName: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListServerCertificateTagsResult",
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "Sv"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListServerCertificates: {
          input: {
            type: "structure",
            members: {
              PathPrefix: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListServerCertificatesResult",
            type: "structure",
            required: [
              "ServerCertificateMetadataList"
            ],
            members: {
              ServerCertificateMetadataList: {
                type: "list",
                member: {
                  shape: "S69"
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListServiceSpecificCredentials: {
          input: {
            type: "structure",
            members: {
              UserName: {},
              ServiceName: {}
            }
          },
          output: {
            resultWrapper: "ListServiceSpecificCredentialsResult",
            type: "structure",
            members: {
              ServiceSpecificCredentials: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "UserName",
                    "Status",
                    "ServiceUserName",
                    "CreateDate",
                    "ServiceSpecificCredentialId",
                    "ServiceName"
                  ],
                  members: {
                    UserName: {},
                    Status: {},
                    ServiceUserName: {},
                    CreateDate: {
                      type: "timestamp"
                    },
                    ServiceSpecificCredentialId: {},
                    ServiceName: {}
                  }
                }
              }
            }
          }
        },
        ListSigningCertificates: {
          input: {
            type: "structure",
            members: {
              UserName: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListSigningCertificatesResult",
            type: "structure",
            required: [
              "Certificates"
            ],
            members: {
              Certificates: {
                type: "list",
                member: {
                  shape: "S9n"
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListUserPolicies: {
          input: {
            type: "structure",
            required: [
              "UserName"
            ],
            members: {
              UserName: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListUserPoliciesResult",
            type: "structure",
            required: [
              "PolicyNames"
            ],
            members: {
              PolicyNames: {
                shape: "S7p"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListUserTags: {
          input: {
            type: "structure",
            required: [
              "UserName"
            ],
            members: {
              UserName: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListUserTagsResult",
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "Sv"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListUsers: {
          input: {
            type: "structure",
            members: {
              PathPrefix: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListUsersResult",
            type: "structure",
            required: [
              "Users"
            ],
            members: {
              Users: {
                shape: "S52"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListVirtualMFADevices: {
          input: {
            type: "structure",
            members: {
              AssignmentStatus: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListVirtualMFADevicesResult",
            type: "structure",
            required: [
              "VirtualMFADevices"
            ],
            members: {
              VirtualMFADevices: {
                type: "list",
                member: {
                  shape: "S2h"
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        PutGroupPolicy: {
          input: {
            type: "structure",
            required: [
              "GroupName",
              "PolicyName",
              "PolicyDocument"
            ],
            members: {
              GroupName: {},
              PolicyName: {},
              PolicyDocument: {}
            }
          }
        },
        PutRolePermissionsBoundary: {
          input: {
            type: "structure",
            required: [
              "RoleName",
              "PermissionsBoundary"
            ],
            members: {
              RoleName: {},
              PermissionsBoundary: {}
            }
          }
        },
        PutRolePolicy: {
          input: {
            type: "structure",
            required: [
              "RoleName",
              "PolicyName",
              "PolicyDocument"
            ],
            members: {
              RoleName: {},
              PolicyName: {},
              PolicyDocument: {}
            }
          }
        },
        PutUserPermissionsBoundary: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "PermissionsBoundary"
            ],
            members: {
              UserName: {},
              PermissionsBoundary: {}
            }
          }
        },
        PutUserPolicy: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "PolicyName",
              "PolicyDocument"
            ],
            members: {
              UserName: {},
              PolicyName: {},
              PolicyDocument: {}
            }
          }
        },
        RemoveClientIDFromOpenIDConnectProvider: {
          input: {
            type: "structure",
            required: [
              "OpenIDConnectProviderArn",
              "ClientID"
            ],
            members: {
              OpenIDConnectProviderArn: {},
              ClientID: {}
            }
          }
        },
        RemoveRoleFromInstanceProfile: {
          input: {
            type: "structure",
            required: [
              "InstanceProfileName",
              "RoleName"
            ],
            members: {
              InstanceProfileName: {},
              RoleName: {}
            }
          }
        },
        RemoveUserFromGroup: {
          input: {
            type: "structure",
            required: [
              "GroupName",
              "UserName"
            ],
            members: {
              GroupName: {},
              UserName: {}
            }
          }
        },
        ResetServiceSpecificCredential: {
          input: {
            type: "structure",
            required: [
              "ServiceSpecificCredentialId"
            ],
            members: {
              UserName: {},
              ServiceSpecificCredentialId: {}
            }
          },
          output: {
            resultWrapper: "ResetServiceSpecificCredentialResult",
            type: "structure",
            members: {
              ServiceSpecificCredential: {
                shape: "S27"
              }
            }
          }
        },
        ResyncMFADevice: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "SerialNumber",
              "AuthenticationCode1",
              "AuthenticationCode2"
            ],
            members: {
              UserName: {},
              SerialNumber: {},
              AuthenticationCode1: {},
              AuthenticationCode2: {}
            }
          }
        },
        SetDefaultPolicyVersion: {
          input: {
            type: "structure",
            required: [
              "PolicyArn",
              "VersionId"
            ],
            members: {
              PolicyArn: {},
              VersionId: {}
            }
          }
        },
        SetSecurityTokenServicePreferences: {
          input: {
            type: "structure",
            required: [
              "GlobalEndpointTokenVersion"
            ],
            members: {
              GlobalEndpointTokenVersion: {}
            }
          }
        },
        SimulateCustomPolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyInputList",
              "ActionNames"
            ],
            members: {
              PolicyInputList: {
                shape: "S4s"
              },
              PermissionsBoundaryPolicyInputList: {
                shape: "S4s"
              },
              ActionNames: {
                shape: "Sad"
              },
              ResourceArns: {
                shape: "Saf"
              },
              ResourcePolicy: {},
              ResourceOwner: {},
              CallerArn: {},
              ContextEntries: {
                shape: "Sah"
              },
              ResourceHandlingOption: {},
              MaxItems: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            shape: "San",
            resultWrapper: "SimulateCustomPolicyResult"
          }
        },
        SimulatePrincipalPolicy: {
          input: {
            type: "structure",
            required: [
              "PolicySourceArn",
              "ActionNames"
            ],
            members: {
              PolicySourceArn: {},
              PolicyInputList: {
                shape: "S4s"
              },
              PermissionsBoundaryPolicyInputList: {
                shape: "S4s"
              },
              ActionNames: {
                shape: "Sad"
              },
              ResourceArns: {
                shape: "Saf"
              },
              ResourcePolicy: {},
              ResourceOwner: {},
              CallerArn: {},
              ContextEntries: {
                shape: "Sah"
              },
              ResourceHandlingOption: {},
              MaxItems: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            shape: "San",
            resultWrapper: "SimulatePrincipalPolicyResult"
          }
        },
        TagInstanceProfile: {
          input: {
            type: "structure",
            required: [
              "InstanceProfileName",
              "Tags"
            ],
            members: {
              InstanceProfileName: {},
              Tags: {
                shape: "Sv"
              }
            }
          }
        },
        TagMFADevice: {
          input: {
            type: "structure",
            required: [
              "SerialNumber",
              "Tags"
            ],
            members: {
              SerialNumber: {},
              Tags: {
                shape: "Sv"
              }
            }
          }
        },
        TagOpenIDConnectProvider: {
          input: {
            type: "structure",
            required: [
              "OpenIDConnectProviderArn",
              "Tags"
            ],
            members: {
              OpenIDConnectProviderArn: {},
              Tags: {
                shape: "Sv"
              }
            }
          }
        },
        TagPolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyArn",
              "Tags"
            ],
            members: {
              PolicyArn: {},
              Tags: {
                shape: "Sv"
              }
            }
          }
        },
        TagRole: {
          input: {
            type: "structure",
            required: [
              "RoleName",
              "Tags"
            ],
            members: {
              RoleName: {},
              Tags: {
                shape: "Sv"
              }
            }
          }
        },
        TagSAMLProvider: {
          input: {
            type: "structure",
            required: [
              "SAMLProviderArn",
              "Tags"
            ],
            members: {
              SAMLProviderArn: {},
              Tags: {
                shape: "Sv"
              }
            }
          }
        },
        TagServerCertificate: {
          input: {
            type: "structure",
            required: [
              "ServerCertificateName",
              "Tags"
            ],
            members: {
              ServerCertificateName: {},
              Tags: {
                shape: "Sv"
              }
            }
          }
        },
        TagUser: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "Tags"
            ],
            members: {
              UserName: {},
              Tags: {
                shape: "Sv"
              }
            }
          }
        },
        UntagInstanceProfile: {
          input: {
            type: "structure",
            required: [
              "InstanceProfileName",
              "TagKeys"
            ],
            members: {
              InstanceProfileName: {},
              TagKeys: {
                shape: "Sbe"
              }
            }
          }
        },
        UntagMFADevice: {
          input: {
            type: "structure",
            required: [
              "SerialNumber",
              "TagKeys"
            ],
            members: {
              SerialNumber: {},
              TagKeys: {
                shape: "Sbe"
              }
            }
          }
        },
        UntagOpenIDConnectProvider: {
          input: {
            type: "structure",
            required: [
              "OpenIDConnectProviderArn",
              "TagKeys"
            ],
            members: {
              OpenIDConnectProviderArn: {},
              TagKeys: {
                shape: "Sbe"
              }
            }
          }
        },
        UntagPolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyArn",
              "TagKeys"
            ],
            members: {
              PolicyArn: {},
              TagKeys: {
                shape: "Sbe"
              }
            }
          }
        },
        UntagRole: {
          input: {
            type: "structure",
            required: [
              "RoleName",
              "TagKeys"
            ],
            members: {
              RoleName: {},
              TagKeys: {
                shape: "Sbe"
              }
            }
          }
        },
        UntagSAMLProvider: {
          input: {
            type: "structure",
            required: [
              "SAMLProviderArn",
              "TagKeys"
            ],
            members: {
              SAMLProviderArn: {},
              TagKeys: {
                shape: "Sbe"
              }
            }
          }
        },
        UntagServerCertificate: {
          input: {
            type: "structure",
            required: [
              "ServerCertificateName",
              "TagKeys"
            ],
            members: {
              ServerCertificateName: {},
              TagKeys: {
                shape: "Sbe"
              }
            }
          }
        },
        UntagUser: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "TagKeys"
            ],
            members: {
              UserName: {},
              TagKeys: {
                shape: "Sbe"
              }
            }
          }
        },
        UpdateAccessKey: {
          input: {
            type: "structure",
            required: [
              "AccessKeyId",
              "Status"
            ],
            members: {
              UserName: {},
              AccessKeyId: {},
              Status: {}
            }
          }
        },
        UpdateAccountPasswordPolicy: {
          input: {
            type: "structure",
            members: {
              MinimumPasswordLength: {
                type: "integer"
              },
              RequireSymbols: {
                type: "boolean"
              },
              RequireNumbers: {
                type: "boolean"
              },
              RequireUppercaseCharacters: {
                type: "boolean"
              },
              RequireLowercaseCharacters: {
                type: "boolean"
              },
              AllowUsersToChangePassword: {
                type: "boolean"
              },
              MaxPasswordAge: {
                type: "integer"
              },
              PasswordReusePrevention: {
                type: "integer"
              },
              HardExpiry: {
                type: "boolean"
              }
            }
          }
        },
        UpdateAssumeRolePolicy: {
          input: {
            type: "structure",
            required: [
              "RoleName",
              "PolicyDocument"
            ],
            members: {
              RoleName: {},
              PolicyDocument: {}
            }
          }
        },
        UpdateGroup: {
          input: {
            type: "structure",
            required: [
              "GroupName"
            ],
            members: {
              GroupName: {},
              NewPath: {},
              NewGroupName: {}
            }
          }
        },
        UpdateLoginProfile: {
          input: {
            type: "structure",
            required: [
              "UserName"
            ],
            members: {
              UserName: {},
              Password: {
                shape: "Sf"
              },
              PasswordResetRequired: {
                type: "boolean"
              }
            }
          }
        },
        UpdateOpenIDConnectProviderThumbprint: {
          input: {
            type: "structure",
            required: [
              "OpenIDConnectProviderArn",
              "ThumbprintList"
            ],
            members: {
              OpenIDConnectProviderArn: {},
              ThumbprintList: {
                shape: "S1h"
              }
            }
          }
        },
        UpdateRole: {
          input: {
            type: "structure",
            required: [
              "RoleName"
            ],
            members: {
              RoleName: {},
              Description: {},
              MaxSessionDuration: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "UpdateRoleResult",
            type: "structure",
            members: {}
          }
        },
        UpdateRoleDescription: {
          input: {
            type: "structure",
            required: [
              "RoleName",
              "Description"
            ],
            members: {
              RoleName: {},
              Description: {}
            }
          },
          output: {
            resultWrapper: "UpdateRoleDescriptionResult",
            type: "structure",
            members: {
              Role: {
                shape: "S12"
              }
            }
          }
        },
        UpdateSAMLProvider: {
          input: {
            type: "structure",
            required: [
              "SAMLMetadataDocument",
              "SAMLProviderArn"
            ],
            members: {
              SAMLMetadataDocument: {},
              SAMLProviderArn: {}
            }
          },
          output: {
            resultWrapper: "UpdateSAMLProviderResult",
            type: "structure",
            members: {
              SAMLProviderArn: {}
            }
          }
        },
        UpdateSSHPublicKey: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "SSHPublicKeyId",
              "Status"
            ],
            members: {
              UserName: {},
              SSHPublicKeyId: {},
              Status: {}
            }
          }
        },
        UpdateServerCertificate: {
          input: {
            type: "structure",
            required: [
              "ServerCertificateName"
            ],
            members: {
              ServerCertificateName: {},
              NewPath: {},
              NewServerCertificateName: {}
            }
          }
        },
        UpdateServiceSpecificCredential: {
          input: {
            type: "structure",
            required: [
              "ServiceSpecificCredentialId",
              "Status"
            ],
            members: {
              UserName: {},
              ServiceSpecificCredentialId: {},
              Status: {}
            }
          }
        },
        UpdateSigningCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateId",
              "Status"
            ],
            members: {
              UserName: {},
              CertificateId: {},
              Status: {}
            }
          }
        },
        UpdateUser: {
          input: {
            type: "structure",
            required: [
              "UserName"
            ],
            members: {
              UserName: {},
              NewPath: {},
              NewUserName: {}
            }
          }
        },
        UploadSSHPublicKey: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "SSHPublicKeyBody"
            ],
            members: {
              UserName: {},
              SSHPublicKeyBody: {}
            }
          },
          output: {
            resultWrapper: "UploadSSHPublicKeyResult",
            type: "structure",
            members: {
              SSHPublicKey: {
                shape: "S63"
              }
            }
          }
        },
        UploadServerCertificate: {
          input: {
            type: "structure",
            required: [
              "ServerCertificateName",
              "CertificateBody",
              "PrivateKey"
            ],
            members: {
              Path: {},
              ServerCertificateName: {},
              CertificateBody: {},
              PrivateKey: {
                type: "string",
                sensitive: true
              },
              CertificateChain: {},
              Tags: {
                shape: "Sv"
              }
            }
          },
          output: {
            resultWrapper: "UploadServerCertificateResult",
            type: "structure",
            members: {
              ServerCertificateMetadata: {
                shape: "S69"
              },
              Tags: {
                shape: "Sv"
              }
            }
          }
        },
        UploadSigningCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateBody"
            ],
            members: {
              UserName: {},
              CertificateBody: {}
            }
          },
          output: {
            resultWrapper: "UploadSigningCertificateResult",
            type: "structure",
            required: [
              "Certificate"
            ],
            members: {
              Certificate: {
                shape: "S9n"
              }
            }
          }
        }
      },
      shapes: {
        Sf: {
          type: "string",
          sensitive: true
        },
        Ss: {
          type: "structure",
          required: [
            "Path",
            "GroupName",
            "GroupId",
            "Arn",
            "CreateDate"
          ],
          members: {
            Path: {},
            GroupName: {},
            GroupId: {},
            Arn: {},
            CreateDate: {
              type: "timestamp"
            }
          }
        },
        Sv: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S10: {
          type: "structure",
          required: [
            "Path",
            "InstanceProfileName",
            "InstanceProfileId",
            "Arn",
            "CreateDate",
            "Roles"
          ],
          members: {
            Path: {},
            InstanceProfileName: {},
            InstanceProfileId: {},
            Arn: {},
            CreateDate: {
              type: "timestamp"
            },
            Roles: {
              shape: "S11"
            },
            Tags: {
              shape: "Sv"
            }
          }
        },
        S11: {
          type: "list",
          member: {
            shape: "S12"
          }
        },
        S12: {
          type: "structure",
          required: [
            "Path",
            "RoleName",
            "RoleId",
            "Arn",
            "CreateDate"
          ],
          members: {
            Path: {},
            RoleName: {},
            RoleId: {},
            Arn: {},
            CreateDate: {
              type: "timestamp"
            },
            AssumeRolePolicyDocument: {},
            Description: {},
            MaxSessionDuration: {
              type: "integer"
            },
            PermissionsBoundary: {
              shape: "S16"
            },
            Tags: {
              shape: "Sv"
            },
            RoleLastUsed: {
              shape: "S18"
            }
          }
        },
        S16: {
          type: "structure",
          members: {
            PermissionsBoundaryType: {},
            PermissionsBoundaryArn: {}
          }
        },
        S18: {
          type: "structure",
          members: {
            LastUsedDate: {
              type: "timestamp"
            },
            Region: {}
          }
        },
        S1d: {
          type: "structure",
          required: [
            "UserName",
            "CreateDate"
          ],
          members: {
            UserName: {},
            CreateDate: {
              type: "timestamp"
            },
            PasswordResetRequired: {
              type: "boolean"
            }
          }
        },
        S1g: {
          type: "list",
          member: {}
        },
        S1h: {
          type: "list",
          member: {}
        },
        S1p: {
          type: "structure",
          members: {
            PolicyName: {},
            PolicyId: {},
            Arn: {},
            Path: {},
            DefaultVersionId: {},
            AttachmentCount: {
              type: "integer"
            },
            PermissionsBoundaryUsageCount: {
              type: "integer"
            },
            IsAttachable: {
              type: "boolean"
            },
            Description: {},
            CreateDate: {
              type: "timestamp"
            },
            UpdateDate: {
              type: "timestamp"
            },
            Tags: {
              shape: "Sv"
            }
          }
        },
        S1u: {
          type: "structure",
          members: {
            Document: {},
            VersionId: {},
            IsDefaultVersion: {
              type: "boolean"
            },
            CreateDate: {
              type: "timestamp"
            }
          }
        },
        S27: {
          type: "structure",
          required: [
            "CreateDate",
            "ServiceName",
            "ServiceUserName",
            "ServicePassword",
            "ServiceSpecificCredentialId",
            "UserName",
            "Status"
          ],
          members: {
            CreateDate: {
              type: "timestamp"
            },
            ServiceName: {},
            ServiceUserName: {},
            ServicePassword: {
              type: "string",
              sensitive: true
            },
            ServiceSpecificCredentialId: {},
            UserName: {},
            Status: {}
          }
        },
        S2d: {
          type: "structure",
          required: [
            "Path",
            "UserName",
            "UserId",
            "Arn",
            "CreateDate"
          ],
          members: {
            Path: {},
            UserName: {},
            UserId: {},
            Arn: {},
            CreateDate: {
              type: "timestamp"
            },
            PasswordLastUsed: {
              type: "timestamp"
            },
            PermissionsBoundary: {
              shape: "S16"
            },
            Tags: {
              shape: "Sv"
            }
          }
        },
        S2h: {
          type: "structure",
          required: [
            "SerialNumber"
          ],
          members: {
            SerialNumber: {},
            Base32StringSeed: {
              shape: "S2j"
            },
            QRCodePNG: {
              shape: "S2j"
            },
            User: {
              shape: "S2d"
            },
            EnableDate: {
              type: "timestamp"
            },
            Tags: {
              shape: "Sv"
            }
          }
        },
        S2j: {
          type: "blob",
          sensitive: true
        },
        S43: {
          type: "list",
          member: {
            type: "structure",
            members: {
              PolicyName: {},
              PolicyDocument: {}
            }
          }
        },
        S46: {
          type: "list",
          member: {
            type: "structure",
            members: {
              PolicyName: {},
              PolicyArn: {}
            }
          }
        },
        S4c: {
          type: "list",
          member: {
            shape: "S10"
          }
        },
        S4f: {
          type: "list",
          member: {
            shape: "S1u"
          }
        },
        S4s: {
          type: "list",
          member: {}
        },
        S4t: {
          type: "structure",
          members: {
            ContextKeyNames: {
              shape: "S4u"
            }
          }
        },
        S4u: {
          type: "list",
          member: {}
        },
        S52: {
          type: "list",
          member: {
            shape: "S2d"
          }
        },
        S5p: {
          type: "structure",
          required: [
            "Message",
            "Code"
          ],
          members: {
            Message: {},
            Code: {}
          }
        },
        S63: {
          type: "structure",
          required: [
            "UserName",
            "SSHPublicKeyId",
            "Fingerprint",
            "SSHPublicKeyBody",
            "Status"
          ],
          members: {
            UserName: {},
            SSHPublicKeyId: {},
            Fingerprint: {},
            SSHPublicKeyBody: {},
            Status: {},
            UploadDate: {
              type: "timestamp"
            }
          }
        },
        S69: {
          type: "structure",
          required: [
            "Path",
            "ServerCertificateName",
            "ServerCertificateId",
            "Arn"
          ],
          members: {
            Path: {},
            ServerCertificateName: {},
            ServerCertificateId: {},
            Arn: {},
            UploadDate: {
              type: "timestamp"
            },
            Expiration: {
              type: "timestamp"
            }
          }
        },
        S7p: {
          type: "list",
          member: {}
        },
        S7t: {
          type: "list",
          member: {
            shape: "Ss"
          }
        },
        S9n: {
          type: "structure",
          required: [
            "UserName",
            "CertificateId",
            "CertificateBody",
            "Status"
          ],
          members: {
            UserName: {},
            CertificateId: {},
            CertificateBody: {},
            Status: {},
            UploadDate: {
              type: "timestamp"
            }
          }
        },
        Sad: {
          type: "list",
          member: {}
        },
        Saf: {
          type: "list",
          member: {}
        },
        Sah: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ContextKeyName: {},
              ContextKeyValues: {
                type: "list",
                member: {}
              },
              ContextKeyType: {}
            }
          }
        },
        San: {
          type: "structure",
          members: {
            EvaluationResults: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "EvalActionName",
                  "EvalDecision"
                ],
                members: {
                  EvalActionName: {},
                  EvalResourceName: {},
                  EvalDecision: {},
                  MatchedStatements: {
                    shape: "Sar"
                  },
                  MissingContextValues: {
                    shape: "S4u"
                  },
                  OrganizationsDecisionDetail: {
                    type: "structure",
                    members: {
                      AllowedByOrganizations: {
                        type: "boolean"
                      }
                    }
                  },
                  PermissionsBoundaryDecisionDetail: {
                    shape: "Saz"
                  },
                  EvalDecisionDetails: {
                    shape: "Sb0"
                  },
                  ResourceSpecificResults: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "EvalResourceName",
                        "EvalResourceDecision"
                      ],
                      members: {
                        EvalResourceName: {},
                        EvalResourceDecision: {},
                        MatchedStatements: {
                          shape: "Sar"
                        },
                        MissingContextValues: {
                          shape: "S4u"
                        },
                        EvalDecisionDetails: {
                          shape: "Sb0"
                        },
                        PermissionsBoundaryDecisionDetail: {
                          shape: "Saz"
                        }
                      }
                    }
                  }
                }
              }
            },
            IsTruncated: {
              type: "boolean"
            },
            Marker: {}
          }
        },
        Sar: {
          type: "list",
          member: {
            type: "structure",
            members: {
              SourcePolicyId: {},
              SourcePolicyType: {},
              StartPosition: {
                shape: "Sav"
              },
              EndPosition: {
                shape: "Sav"
              }
            }
          }
        },
        Sav: {
          type: "structure",
          members: {
            Line: {
              type: "integer"
            },
            Column: {
              type: "integer"
            }
          }
        },
        Saz: {
          type: "structure",
          members: {
            AllowedByPermissionsBoundary: {
              type: "boolean"
            }
          }
        },
        Sb0: {
          type: "map",
          key: {},
          value: {}
        },
        Sbe: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iam-2010-05-08.paginators.json
var require_iam_2010_05_08_paginators = __commonJS({
  "node_modules/aws-sdk/apis/iam-2010-05-08.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetAccountAuthorizationDetails: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: [
            "UserDetailList",
            "GroupDetailList",
            "RoleDetailList",
            "Policies"
          ]
        },
        GetGroup: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "Users"
        },
        ListAccessKeys: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "AccessKeyMetadata"
        },
        ListAccountAliases: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "AccountAliases"
        },
        ListAttachedGroupPolicies: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "AttachedPolicies"
        },
        ListAttachedRolePolicies: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "AttachedPolicies"
        },
        ListAttachedUserPolicies: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "AttachedPolicies"
        },
        ListEntitiesForPolicy: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: [
            "PolicyGroups",
            "PolicyUsers",
            "PolicyRoles"
          ]
        },
        ListGroupPolicies: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "PolicyNames"
        },
        ListGroups: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "Groups"
        },
        ListGroupsForUser: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "Groups"
        },
        ListInstanceProfileTags: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "Tags"
        },
        ListInstanceProfiles: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "InstanceProfiles"
        },
        ListInstanceProfilesForRole: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "InstanceProfiles"
        },
        ListMFADeviceTags: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "Tags"
        },
        ListMFADevices: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "MFADevices"
        },
        ListOpenIDConnectProviderTags: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "Tags"
        },
        ListPolicies: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "Policies"
        },
        ListPolicyTags: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "Tags"
        },
        ListPolicyVersions: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "Versions"
        },
        ListRolePolicies: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "PolicyNames"
        },
        ListRoleTags: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "Tags"
        },
        ListRoles: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "Roles"
        },
        ListSAMLProviderTags: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "Tags"
        },
        ListSAMLProviders: {
          result_key: "SAMLProviderList"
        },
        ListSSHPublicKeys: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "SSHPublicKeys"
        },
        ListServerCertificateTags: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "Tags"
        },
        ListServerCertificates: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "ServerCertificateMetadataList"
        },
        ListSigningCertificates: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "Certificates"
        },
        ListUserPolicies: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "PolicyNames"
        },
        ListUserTags: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "Tags"
        },
        ListUsers: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "Users"
        },
        ListVirtualMFADevices: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "VirtualMFADevices"
        },
        SimulateCustomPolicy: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "EvaluationResults"
        },
        SimulatePrincipalPolicy: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "EvaluationResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iam-2010-05-08.waiters2.json
var require_iam_2010_05_08_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/iam-2010-05-08.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        InstanceProfileExists: {
          delay: 1,
          operation: "GetInstanceProfile",
          maxAttempts: 40,
          acceptors: [
            {
              expected: 200,
              matcher: "status",
              state: "success"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 404
            }
          ]
        },
        UserExists: {
          delay: 1,
          operation: "GetUser",
          maxAttempts: 20,
          acceptors: [
            {
              state: "success",
              matcher: "status",
              expected: 200
            },
            {
              state: "retry",
              matcher: "error",
              expected: "NoSuchEntity"
            }
          ]
        },
        RoleExists: {
          delay: 1,
          operation: "GetRole",
          maxAttempts: 20,
          acceptors: [
            {
              state: "success",
              matcher: "status",
              expected: 200
            },
            {
              state: "retry",
              matcher: "error",
              expected: "NoSuchEntity"
            }
          ]
        },
        PolicyExists: {
          delay: 1,
          operation: "GetPolicy",
          maxAttempts: 20,
          acceptors: [
            {
              state: "success",
              matcher: "status",
              expected: 200
            },
            {
              state: "retry",
              matcher: "error",
              expected: "NoSuchEntity"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/iam.js
var require_iam = __commonJS({
  "node_modules/aws-sdk/clients/iam.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["iam"] = {};
    AWS2.IAM = Service.defineService("iam", ["2010-05-08"]);
    Object.defineProperty(apiLoader.services["iam"], "2010-05-08", {
      get: function get() {
        var model = require_iam_2010_05_08_min();
        model.paginators = require_iam_2010_05_08_paginators().pagination;
        model.waiters = require_iam_2010_05_08_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.IAM;
  }
});

// node_modules/aws-sdk/apis/importexport-2010-06-01.min.json
var require_importexport_2010_06_01_min = __commonJS({
  "node_modules/aws-sdk/apis/importexport-2010-06-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        uid: "importexport-2010-06-01",
        apiVersion: "2010-06-01",
        endpointPrefix: "importexport",
        globalEndpoint: "importexport.amazonaws.com",
        serviceFullName: "AWS Import/Export",
        serviceId: "ImportExport",
        signatureVersion: "v2",
        xmlNamespace: "http://importexport.amazonaws.com/doc/2010-06-01/",
        protocol: "query"
      },
      operations: {
        CancelJob: {
          http: {
            requestUri: "/?Operation=CancelJob"
          },
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              APIVersion: {}
            }
          },
          output: {
            resultWrapper: "CancelJobResult",
            type: "structure",
            members: {
              Success: {
                type: "boolean"
              }
            }
          }
        },
        CreateJob: {
          http: {
            requestUri: "/?Operation=CreateJob"
          },
          input: {
            type: "structure",
            required: [
              "JobType",
              "Manifest",
              "ValidateOnly"
            ],
            members: {
              JobType: {},
              Manifest: {},
              ManifestAddendum: {},
              ValidateOnly: {
                type: "boolean"
              },
              APIVersion: {}
            }
          },
          output: {
            resultWrapper: "CreateJobResult",
            type: "structure",
            members: {
              JobId: {},
              JobType: {},
              Signature: {},
              SignatureFileContents: {},
              WarningMessage: {},
              ArtifactList: {
                shape: "Sf"
              }
            }
          }
        },
        GetShippingLabel: {
          http: {
            requestUri: "/?Operation=GetShippingLabel"
          },
          input: {
            type: "structure",
            required: [
              "jobIds"
            ],
            members: {
              jobIds: {
                type: "list",
                member: {}
              },
              name: {},
              company: {},
              phoneNumber: {},
              country: {},
              stateOrProvince: {},
              city: {},
              postalCode: {},
              street1: {},
              street2: {},
              street3: {},
              APIVersion: {}
            }
          },
          output: {
            resultWrapper: "GetShippingLabelResult",
            type: "structure",
            members: {
              ShippingLabelURL: {},
              Warning: {}
            }
          }
        },
        GetStatus: {
          http: {
            requestUri: "/?Operation=GetStatus"
          },
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              APIVersion: {}
            }
          },
          output: {
            resultWrapper: "GetStatusResult",
            type: "structure",
            members: {
              JobId: {},
              JobType: {},
              LocationCode: {},
              LocationMessage: {},
              ProgressCode: {},
              ProgressMessage: {},
              Carrier: {},
              TrackingNumber: {},
              LogBucket: {},
              LogKey: {},
              ErrorCount: {
                type: "integer"
              },
              Signature: {},
              SignatureFileContents: {},
              CurrentManifest: {},
              CreationDate: {
                type: "timestamp"
              },
              ArtifactList: {
                shape: "Sf"
              }
            }
          }
        },
        ListJobs: {
          http: {
            requestUri: "/?Operation=ListJobs"
          },
          input: {
            type: "structure",
            members: {
              MaxJobs: {
                type: "integer"
              },
              Marker: {},
              APIVersion: {}
            }
          },
          output: {
            resultWrapper: "ListJobsResult",
            type: "structure",
            members: {
              Jobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    JobId: {},
                    CreationDate: {
                      type: "timestamp"
                    },
                    IsCanceled: {
                      type: "boolean"
                    },
                    JobType: {}
                  }
                }
              },
              IsTruncated: {
                type: "boolean"
              }
            }
          }
        },
        UpdateJob: {
          http: {
            requestUri: "/?Operation=UpdateJob"
          },
          input: {
            type: "structure",
            required: [
              "JobId",
              "Manifest",
              "JobType",
              "ValidateOnly"
            ],
            members: {
              JobId: {},
              Manifest: {},
              JobType: {},
              ValidateOnly: {
                type: "boolean"
              },
              APIVersion: {}
            }
          },
          output: {
            resultWrapper: "UpdateJobResult",
            type: "structure",
            members: {
              Success: {
                type: "boolean"
              },
              WarningMessage: {},
              ArtifactList: {
                shape: "Sf"
              }
            }
          }
        }
      },
      shapes: {
        Sf: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Description: {},
              URL: {}
            }
          }
        }
      },
      examples: {}
    };
  }
});

// node_modules/aws-sdk/apis/importexport-2010-06-01.paginators.json
var require_importexport_2010_06_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/importexport-2010-06-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListJobs: {
          input_token: "Marker",
          output_token: "Jobs[-1].JobId",
          more_results: "IsTruncated",
          limit_key: "MaxJobs",
          result_key: "Jobs"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/importexport.js
var require_importexport = __commonJS({
  "node_modules/aws-sdk/clients/importexport.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["importexport"] = {};
    AWS2.ImportExport = Service.defineService("importexport", ["2010-06-01"]);
    Object.defineProperty(apiLoader.services["importexport"], "2010-06-01", {
      get: function get() {
        var model = require_importexport_2010_06_01_min();
        model.paginators = require_importexport_2010_06_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ImportExport;
  }
});

// node_modules/aws-sdk/apis/inspector-2016-02-16.min.json
var require_inspector_2016_02_16_min = __commonJS({
  "node_modules/aws-sdk/apis/inspector-2016-02-16.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-02-16",
        endpointPrefix: "inspector",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Inspector",
        serviceId: "Inspector",
        signatureVersion: "v4",
        targetPrefix: "InspectorService",
        uid: "inspector-2016-02-16"
      },
      operations: {
        AddAttributesToFindings: {
          input: {
            type: "structure",
            required: [
              "findingArns",
              "attributes"
            ],
            members: {
              findingArns: {
                shape: "S2"
              },
              attributes: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "failedItems"
            ],
            members: {
              failedItems: {
                shape: "S9"
              }
            }
          }
        },
        CreateAssessmentTarget: {
          input: {
            type: "structure",
            required: [
              "assessmentTargetName"
            ],
            members: {
              assessmentTargetName: {},
              resourceGroupArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "assessmentTargetArn"
            ],
            members: {
              assessmentTargetArn: {}
            }
          }
        },
        CreateAssessmentTemplate: {
          input: {
            type: "structure",
            required: [
              "assessmentTargetArn",
              "assessmentTemplateName",
              "durationInSeconds",
              "rulesPackageArns"
            ],
            members: {
              assessmentTargetArn: {},
              assessmentTemplateName: {},
              durationInSeconds: {
                type: "integer"
              },
              rulesPackageArns: {
                shape: "Sj"
              },
              userAttributesForFindings: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assessmentTemplateArn"
            ],
            members: {
              assessmentTemplateArn: {}
            }
          }
        },
        CreateExclusionsPreview: {
          input: {
            type: "structure",
            required: [
              "assessmentTemplateArn"
            ],
            members: {
              assessmentTemplateArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "previewToken"
            ],
            members: {
              previewToken: {}
            }
          }
        },
        CreateResourceGroup: {
          input: {
            type: "structure",
            required: [
              "resourceGroupTags"
            ],
            members: {
              resourceGroupTags: {
                shape: "Sp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "resourceGroupArn"
            ],
            members: {
              resourceGroupArn: {}
            }
          }
        },
        DeleteAssessmentRun: {
          input: {
            type: "structure",
            required: [
              "assessmentRunArn"
            ],
            members: {
              assessmentRunArn: {}
            }
          }
        },
        DeleteAssessmentTarget: {
          input: {
            type: "structure",
            required: [
              "assessmentTargetArn"
            ],
            members: {
              assessmentTargetArn: {}
            }
          }
        },
        DeleteAssessmentTemplate: {
          input: {
            type: "structure",
            required: [
              "assessmentTemplateArn"
            ],
            members: {
              assessmentTemplateArn: {}
            }
          }
        },
        DescribeAssessmentRuns: {
          input: {
            type: "structure",
            required: [
              "assessmentRunArns"
            ],
            members: {
              assessmentRunArns: {
                shape: "Sy"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assessmentRuns",
              "failedItems"
            ],
            members: {
              assessmentRuns: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "name",
                    "assessmentTemplateArn",
                    "state",
                    "durationInSeconds",
                    "rulesPackageArns",
                    "userAttributesForFindings",
                    "createdAt",
                    "stateChangedAt",
                    "dataCollected",
                    "stateChanges",
                    "notifications",
                    "findingCounts"
                  ],
                  members: {
                    arn: {},
                    name: {},
                    assessmentTemplateArn: {},
                    state: {},
                    durationInSeconds: {
                      type: "integer"
                    },
                    rulesPackageArns: {
                      type: "list",
                      member: {}
                    },
                    userAttributesForFindings: {
                      shape: "S4"
                    },
                    createdAt: {
                      type: "timestamp"
                    },
                    startedAt: {
                      type: "timestamp"
                    },
                    completedAt: {
                      type: "timestamp"
                    },
                    stateChangedAt: {
                      type: "timestamp"
                    },
                    dataCollected: {
                      type: "boolean"
                    },
                    stateChanges: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "stateChangedAt",
                          "state"
                        ],
                        members: {
                          stateChangedAt: {
                            type: "timestamp"
                          },
                          state: {}
                        }
                      }
                    },
                    notifications: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "date",
                          "event",
                          "error"
                        ],
                        members: {
                          date: {
                            type: "timestamp"
                          },
                          event: {},
                          message: {},
                          error: {
                            type: "boolean"
                          },
                          snsTopicArn: {},
                          snsPublishStatusCode: {}
                        }
                      }
                    },
                    findingCounts: {
                      type: "map",
                      key: {},
                      value: {
                        type: "integer"
                      }
                    }
                  }
                }
              },
              failedItems: {
                shape: "S9"
              }
            }
          }
        },
        DescribeAssessmentTargets: {
          input: {
            type: "structure",
            required: [
              "assessmentTargetArns"
            ],
            members: {
              assessmentTargetArns: {
                shape: "Sy"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assessmentTargets",
              "failedItems"
            ],
            members: {
              assessmentTargets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "name",
                    "createdAt",
                    "updatedAt"
                  ],
                  members: {
                    arn: {},
                    name: {},
                    resourceGroupArn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    updatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              failedItems: {
                shape: "S9"
              }
            }
          }
        },
        DescribeAssessmentTemplates: {
          input: {
            type: "structure",
            required: [
              "assessmentTemplateArns"
            ],
            members: {
              assessmentTemplateArns: {
                shape: "Sy"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assessmentTemplates",
              "failedItems"
            ],
            members: {
              assessmentTemplates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "name",
                    "assessmentTargetArn",
                    "durationInSeconds",
                    "rulesPackageArns",
                    "userAttributesForFindings",
                    "assessmentRunCount",
                    "createdAt"
                  ],
                  members: {
                    arn: {},
                    name: {},
                    assessmentTargetArn: {},
                    durationInSeconds: {
                      type: "integer"
                    },
                    rulesPackageArns: {
                      shape: "Sj"
                    },
                    userAttributesForFindings: {
                      shape: "S4"
                    },
                    lastAssessmentRunArn: {},
                    assessmentRunCount: {
                      type: "integer"
                    },
                    createdAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              failedItems: {
                shape: "S9"
              }
            }
          }
        },
        DescribeCrossAccountAccessRole: {
          output: {
            type: "structure",
            required: [
              "roleArn",
              "valid",
              "registeredAt"
            ],
            members: {
              roleArn: {},
              valid: {
                type: "boolean"
              },
              registeredAt: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeExclusions: {
          input: {
            type: "structure",
            required: [
              "exclusionArns"
            ],
            members: {
              exclusionArns: {
                type: "list",
                member: {}
              },
              locale: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "exclusions",
              "failedItems"
            ],
            members: {
              exclusions: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  required: [
                    "arn",
                    "title",
                    "description",
                    "recommendation",
                    "scopes"
                  ],
                  members: {
                    arn: {},
                    title: {},
                    description: {},
                    recommendation: {},
                    scopes: {
                      shape: "S1x"
                    },
                    attributes: {
                      shape: "S21"
                    }
                  }
                }
              },
              failedItems: {
                shape: "S9"
              }
            }
          }
        },
        DescribeFindings: {
          input: {
            type: "structure",
            required: [
              "findingArns"
            ],
            members: {
              findingArns: {
                shape: "Sy"
              },
              locale: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "findings",
              "failedItems"
            ],
            members: {
              findings: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "attributes",
                    "userAttributes",
                    "createdAt",
                    "updatedAt"
                  ],
                  members: {
                    arn: {},
                    schemaVersion: {
                      type: "integer"
                    },
                    service: {},
                    serviceAttributes: {
                      type: "structure",
                      required: [
                        "schemaVersion"
                      ],
                      members: {
                        schemaVersion: {
                          type: "integer"
                        },
                        assessmentRunArn: {},
                        rulesPackageArn: {}
                      }
                    },
                    assetType: {},
                    assetAttributes: {
                      type: "structure",
                      required: [
                        "schemaVersion"
                      ],
                      members: {
                        schemaVersion: {
                          type: "integer"
                        },
                        agentId: {},
                        autoScalingGroup: {},
                        amiId: {},
                        hostname: {},
                        ipv4Addresses: {
                          type: "list",
                          member: {}
                        },
                        tags: {
                          type: "list",
                          member: {
                            shape: "S2i"
                          }
                        },
                        networkInterfaces: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              networkInterfaceId: {},
                              subnetId: {},
                              vpcId: {},
                              privateDnsName: {},
                              privateIpAddress: {},
                              privateIpAddresses: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    privateDnsName: {},
                                    privateIpAddress: {}
                                  }
                                }
                              },
                              publicDnsName: {},
                              publicIp: {},
                              ipv6Addresses: {
                                type: "list",
                                member: {}
                              },
                              securityGroups: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    groupName: {},
                                    groupId: {}
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    id: {},
                    title: {},
                    description: {},
                    recommendation: {},
                    severity: {},
                    numericSeverity: {
                      type: "double"
                    },
                    confidence: {
                      type: "integer"
                    },
                    indicatorOfCompromise: {
                      type: "boolean"
                    },
                    attributes: {
                      shape: "S21"
                    },
                    userAttributes: {
                      shape: "S4"
                    },
                    createdAt: {
                      type: "timestamp"
                    },
                    updatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              failedItems: {
                shape: "S9"
              }
            }
          }
        },
        DescribeResourceGroups: {
          input: {
            type: "structure",
            required: [
              "resourceGroupArns"
            ],
            members: {
              resourceGroupArns: {
                shape: "Sy"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "resourceGroups",
              "failedItems"
            ],
            members: {
              resourceGroups: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "tags",
                    "createdAt"
                  ],
                  members: {
                    arn: {},
                    tags: {
                      shape: "Sp"
                    },
                    createdAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              failedItems: {
                shape: "S9"
              }
            }
          }
        },
        DescribeRulesPackages: {
          input: {
            type: "structure",
            required: [
              "rulesPackageArns"
            ],
            members: {
              rulesPackageArns: {
                shape: "Sy"
              },
              locale: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "rulesPackages",
              "failedItems"
            ],
            members: {
              rulesPackages: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "name",
                    "version",
                    "provider"
                  ],
                  members: {
                    arn: {},
                    name: {},
                    version: {},
                    provider: {},
                    description: {}
                  }
                }
              },
              failedItems: {
                shape: "S9"
              }
            }
          }
        },
        GetAssessmentReport: {
          input: {
            type: "structure",
            required: [
              "assessmentRunArn",
              "reportFileFormat",
              "reportType"
            ],
            members: {
              assessmentRunArn: {},
              reportFileFormat: {},
              reportType: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "status"
            ],
            members: {
              status: {},
              url: {}
            }
          }
        },
        GetExclusionsPreview: {
          input: {
            type: "structure",
            required: [
              "assessmentTemplateArn",
              "previewToken"
            ],
            members: {
              assessmentTemplateArn: {},
              previewToken: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              locale: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "previewStatus"
            ],
            members: {
              previewStatus: {},
              exclusionPreviews: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "title",
                    "description",
                    "recommendation",
                    "scopes"
                  ],
                  members: {
                    title: {},
                    description: {},
                    recommendation: {},
                    scopes: {
                      shape: "S1x"
                    },
                    attributes: {
                      shape: "S21"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetTelemetryMetadata: {
          input: {
            type: "structure",
            required: [
              "assessmentRunArn"
            ],
            members: {
              assessmentRunArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "telemetryMetadata"
            ],
            members: {
              telemetryMetadata: {
                shape: "S3j"
              }
            }
          }
        },
        ListAssessmentRunAgents: {
          input: {
            type: "structure",
            required: [
              "assessmentRunArn"
            ],
            members: {
              assessmentRunArn: {},
              filter: {
                type: "structure",
                required: [
                  "agentHealths",
                  "agentHealthCodes"
                ],
                members: {
                  agentHealths: {
                    type: "list",
                    member: {}
                  },
                  agentHealthCodes: {
                    type: "list",
                    member: {}
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assessmentRunAgents"
            ],
            members: {
              assessmentRunAgents: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "agentId",
                    "assessmentRunArn",
                    "agentHealth",
                    "agentHealthCode",
                    "telemetryMetadata"
                  ],
                  members: {
                    agentId: {},
                    assessmentRunArn: {},
                    agentHealth: {},
                    agentHealthCode: {},
                    agentHealthDetails: {},
                    autoScalingGroup: {},
                    telemetryMetadata: {
                      shape: "S3j"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAssessmentRuns: {
          input: {
            type: "structure",
            members: {
              assessmentTemplateArns: {
                shape: "S3x"
              },
              filter: {
                type: "structure",
                members: {
                  namePattern: {},
                  states: {
                    type: "list",
                    member: {}
                  },
                  durationRange: {
                    shape: "S41"
                  },
                  rulesPackageArns: {
                    shape: "S42"
                  },
                  startTimeRange: {
                    shape: "S43"
                  },
                  completionTimeRange: {
                    shape: "S43"
                  },
                  stateChangeTimeRange: {
                    shape: "S43"
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assessmentRunArns"
            ],
            members: {
              assessmentRunArns: {
                shape: "S45"
              },
              nextToken: {}
            }
          }
        },
        ListAssessmentTargets: {
          input: {
            type: "structure",
            members: {
              filter: {
                type: "structure",
                members: {
                  assessmentTargetNamePattern: {}
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assessmentTargetArns"
            ],
            members: {
              assessmentTargetArns: {
                shape: "S45"
              },
              nextToken: {}
            }
          }
        },
        ListAssessmentTemplates: {
          input: {
            type: "structure",
            members: {
              assessmentTargetArns: {
                shape: "S3x"
              },
              filter: {
                type: "structure",
                members: {
                  namePattern: {},
                  durationRange: {
                    shape: "S41"
                  },
                  rulesPackageArns: {
                    shape: "S42"
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assessmentTemplateArns"
            ],
            members: {
              assessmentTemplateArns: {
                shape: "S45"
              },
              nextToken: {}
            }
          }
        },
        ListEventSubscriptions: {
          input: {
            type: "structure",
            members: {
              resourceArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "subscriptions"
            ],
            members: {
              subscriptions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "resourceArn",
                    "topicArn",
                    "eventSubscriptions"
                  ],
                  members: {
                    resourceArn: {},
                    topicArn: {},
                    eventSubscriptions: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "event",
                          "subscribedAt"
                        ],
                        members: {
                          event: {},
                          subscribedAt: {
                            type: "timestamp"
                          }
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListExclusions: {
          input: {
            type: "structure",
            required: [
              "assessmentRunArn"
            ],
            members: {
              assessmentRunArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "exclusionArns"
            ],
            members: {
              exclusionArns: {
                shape: "S45"
              },
              nextToken: {}
            }
          }
        },
        ListFindings: {
          input: {
            type: "structure",
            members: {
              assessmentRunArns: {
                shape: "S3x"
              },
              filter: {
                type: "structure",
                members: {
                  agentIds: {
                    type: "list",
                    member: {}
                  },
                  autoScalingGroups: {
                    type: "list",
                    member: {}
                  },
                  ruleNames: {
                    type: "list",
                    member: {}
                  },
                  severities: {
                    type: "list",
                    member: {}
                  },
                  rulesPackageArns: {
                    shape: "S42"
                  },
                  attributes: {
                    shape: "S21"
                  },
                  userAttributes: {
                    shape: "S21"
                  },
                  creationTimeRange: {
                    shape: "S43"
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "findingArns"
            ],
            members: {
              findingArns: {
                shape: "S45"
              },
              nextToken: {}
            }
          }
        },
        ListRulesPackages: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "rulesPackageArns"
            ],
            members: {
              rulesPackageArns: {
                shape: "S45"
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "tags"
            ],
            members: {
              tags: {
                shape: "S4x"
              }
            }
          }
        },
        PreviewAgents: {
          input: {
            type: "structure",
            required: [
              "previewAgentsArn"
            ],
            members: {
              previewAgentsArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "agentPreviews"
            ],
            members: {
              agentPreviews: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "agentId"
                  ],
                  members: {
                    hostname: {},
                    agentId: {},
                    autoScalingGroup: {},
                    agentHealth: {},
                    agentVersion: {},
                    operatingSystem: {},
                    kernelVersion: {},
                    ipv4Address: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        RegisterCrossAccountAccessRole: {
          input: {
            type: "structure",
            required: [
              "roleArn"
            ],
            members: {
              roleArn: {}
            }
          }
        },
        RemoveAttributesFromFindings: {
          input: {
            type: "structure",
            required: [
              "findingArns",
              "attributeKeys"
            ],
            members: {
              findingArns: {
                shape: "S2"
              },
              attributeKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "failedItems"
            ],
            members: {
              failedItems: {
                shape: "S9"
              }
            }
          }
        },
        SetTagsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "S4x"
              }
            }
          }
        },
        StartAssessmentRun: {
          input: {
            type: "structure",
            required: [
              "assessmentTemplateArn"
            ],
            members: {
              assessmentTemplateArn: {},
              assessmentRunName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "assessmentRunArn"
            ],
            members: {
              assessmentRunArn: {}
            }
          }
        },
        StopAssessmentRun: {
          input: {
            type: "structure",
            required: [
              "assessmentRunArn"
            ],
            members: {
              assessmentRunArn: {},
              stopAction: {}
            }
          }
        },
        SubscribeToEvent: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "event",
              "topicArn"
            ],
            members: {
              resourceArn: {},
              event: {},
              topicArn: {}
            }
          }
        },
        UnsubscribeFromEvent: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "event",
              "topicArn"
            ],
            members: {
              resourceArn: {},
              event: {},
              topicArn: {}
            }
          }
        },
        UpdateAssessmentTarget: {
          input: {
            type: "structure",
            required: [
              "assessmentTargetArn",
              "assessmentTargetName"
            ],
            members: {
              assessmentTargetArn: {},
              assessmentTargetName: {},
              resourceGroupArn: {}
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "list",
          member: {}
        },
        S4: {
          type: "list",
          member: {
            shape: "S5"
          }
        },
        S5: {
          type: "structure",
          required: [
            "key"
          ],
          members: {
            key: {},
            value: {}
          }
        },
        S9: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "failureCode",
              "retryable"
            ],
            members: {
              failureCode: {},
              retryable: {
                type: "boolean"
              }
            }
          }
        },
        Sj: {
          type: "list",
          member: {}
        },
        Sp: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        Sy: {
          type: "list",
          member: {}
        },
        S1x: {
          type: "list",
          member: {
            type: "structure",
            members: {
              key: {},
              value: {}
            }
          }
        },
        S21: {
          type: "list",
          member: {
            shape: "S5"
          }
        },
        S2i: {
          type: "structure",
          required: [
            "key"
          ],
          members: {
            key: {},
            value: {}
          }
        },
        S3j: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "messageType",
              "count"
            ],
            members: {
              messageType: {},
              count: {
                type: "long"
              },
              dataSize: {
                type: "long"
              }
            }
          }
        },
        S3x: {
          type: "list",
          member: {}
        },
        S41: {
          type: "structure",
          members: {
            minSeconds: {
              type: "integer"
            },
            maxSeconds: {
              type: "integer"
            }
          }
        },
        S42: {
          type: "list",
          member: {}
        },
        S43: {
          type: "structure",
          members: {
            beginDate: {
              type: "timestamp"
            },
            endDate: {
              type: "timestamp"
            }
          }
        },
        S45: {
          type: "list",
          member: {}
        },
        S4x: {
          type: "list",
          member: {
            shape: "S2i"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/inspector-2016-02-16.paginators.json
var require_inspector_2016_02_16_paginators = __commonJS({
  "node_modules/aws-sdk/apis/inspector-2016-02-16.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetExclusionsPreview: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListAssessmentRunAgents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListAssessmentRuns: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListAssessmentTargets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListAssessmentTemplates: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListEventSubscriptions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListExclusions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListFindings: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListRulesPackages: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        PreviewAgents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/inspector.js
var require_inspector = __commonJS({
  "node_modules/aws-sdk/clients/inspector.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["inspector"] = {};
    AWS2.Inspector = Service.defineService("inspector", ["2015-08-18*", "2016-02-16"]);
    Object.defineProperty(apiLoader.services["inspector"], "2016-02-16", {
      get: function get() {
        var model = require_inspector_2016_02_16_min();
        model.paginators = require_inspector_2016_02_16_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Inspector;
  }
});

// node_modules/aws-sdk/apis/iot-2015-05-28.min.json
var require_iot_2015_05_28_min = __commonJS({
  "node_modules/aws-sdk/apis/iot-2015-05-28.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-05-28",
        endpointPrefix: "iot",
        protocol: "rest-json",
        serviceFullName: "AWS IoT",
        serviceId: "IoT",
        signatureVersion: "v4",
        signingName: "iot",
        uid: "iot-2015-05-28"
      },
      operations: {
        AcceptCertificateTransfer: {
          http: {
            method: "PATCH",
            requestUri: "/accept-certificate-transfer/{certificateId}"
          },
          input: {
            type: "structure",
            required: [
              "certificateId"
            ],
            members: {
              certificateId: {
                location: "uri",
                locationName: "certificateId"
              },
              setAsActive: {
                location: "querystring",
                locationName: "setAsActive",
                type: "boolean"
              }
            }
          }
        },
        AddThingToBillingGroup: {
          http: {
            method: "PUT",
            requestUri: "/billing-groups/addThingToBillingGroup"
          },
          input: {
            type: "structure",
            members: {
              billingGroupName: {},
              billingGroupArn: {},
              thingName: {},
              thingArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AddThingToThingGroup: {
          http: {
            method: "PUT",
            requestUri: "/thing-groups/addThingToThingGroup"
          },
          input: {
            type: "structure",
            members: {
              thingGroupName: {},
              thingGroupArn: {},
              thingName: {},
              thingArn: {},
              overrideDynamicGroups: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateTargetsWithJob: {
          http: {
            requestUri: "/jobs/{jobId}/targets"
          },
          input: {
            type: "structure",
            required: [
              "targets",
              "jobId"
            ],
            members: {
              targets: {
                shape: "Sg"
              },
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              comment: {},
              namespaceId: {
                location: "querystring",
                locationName: "namespaceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobArn: {},
              jobId: {},
              description: {}
            }
          }
        },
        AttachPolicy: {
          http: {
            method: "PUT",
            requestUri: "/target-policies/{policyName}"
          },
          input: {
            type: "structure",
            required: [
              "policyName",
              "target"
            ],
            members: {
              policyName: {
                location: "uri",
                locationName: "policyName"
              },
              target: {}
            }
          }
        },
        AttachPrincipalPolicy: {
          http: {
            method: "PUT",
            requestUri: "/principal-policies/{policyName}"
          },
          input: {
            type: "structure",
            required: [
              "policyName",
              "principal"
            ],
            members: {
              policyName: {
                location: "uri",
                locationName: "policyName"
              },
              principal: {
                location: "header",
                locationName: "x-amzn-iot-principal"
              }
            }
          },
          deprecated: true
        },
        AttachSecurityProfile: {
          http: {
            method: "PUT",
            requestUri: "/security-profiles/{securityProfileName}/targets"
          },
          input: {
            type: "structure",
            required: [
              "securityProfileName",
              "securityProfileTargetArn"
            ],
            members: {
              securityProfileName: {
                location: "uri",
                locationName: "securityProfileName"
              },
              securityProfileTargetArn: {
                location: "querystring",
                locationName: "securityProfileTargetArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AttachThingPrincipal: {
          http: {
            method: "PUT",
            requestUri: "/things/{thingName}/principals"
          },
          input: {
            type: "structure",
            required: [
              "thingName",
              "principal"
            ],
            members: {
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              principal: {
                location: "header",
                locationName: "x-amzn-principal"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CancelAuditMitigationActionsTask: {
          http: {
            method: "PUT",
            requestUri: "/audit/mitigationactions/tasks/{taskId}/cancel"
          },
          input: {
            type: "structure",
            required: [
              "taskId"
            ],
            members: {
              taskId: {
                location: "uri",
                locationName: "taskId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CancelAuditTask: {
          http: {
            method: "PUT",
            requestUri: "/audit/tasks/{taskId}/cancel"
          },
          input: {
            type: "structure",
            required: [
              "taskId"
            ],
            members: {
              taskId: {
                location: "uri",
                locationName: "taskId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CancelCertificateTransfer: {
          http: {
            method: "PATCH",
            requestUri: "/cancel-certificate-transfer/{certificateId}"
          },
          input: {
            type: "structure",
            required: [
              "certificateId"
            ],
            members: {
              certificateId: {
                location: "uri",
                locationName: "certificateId"
              }
            }
          }
        },
        CancelDetectMitigationActionsTask: {
          http: {
            method: "PUT",
            requestUri: "/detect/mitigationactions/tasks/{taskId}/cancel"
          },
          input: {
            type: "structure",
            required: [
              "taskId"
            ],
            members: {
              taskId: {
                location: "uri",
                locationName: "taskId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CancelJob: {
          http: {
            method: "PUT",
            requestUri: "/jobs/{jobId}/cancel"
          },
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              reasonCode: {},
              comment: {},
              force: {
                location: "querystring",
                locationName: "force",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobArn: {},
              jobId: {},
              description: {}
            }
          }
        },
        CancelJobExecution: {
          http: {
            method: "PUT",
            requestUri: "/things/{thingName}/jobs/{jobId}/cancel"
          },
          input: {
            type: "structure",
            required: [
              "jobId",
              "thingName"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              force: {
                location: "querystring",
                locationName: "force",
                type: "boolean"
              },
              expectedVersion: {
                type: "long"
              },
              statusDetails: {
                shape: "S1e"
              }
            }
          }
        },
        ClearDefaultAuthorizer: {
          http: {
            method: "DELETE",
            requestUri: "/default-authorizer"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ConfirmTopicRuleDestination: {
          http: {
            method: "GET",
            requestUri: "/confirmdestination/{confirmationToken+}"
          },
          input: {
            type: "structure",
            required: [
              "confirmationToken"
            ],
            members: {
              confirmationToken: {
                location: "uri",
                locationName: "confirmationToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateAuditSuppression: {
          http: {
            requestUri: "/audit/suppressions/create"
          },
          input: {
            type: "structure",
            required: [
              "checkName",
              "resourceIdentifier",
              "clientRequestToken"
            ],
            members: {
              checkName: {},
              resourceIdentifier: {
                shape: "S1o"
              },
              expirationDate: {
                type: "timestamp"
              },
              suppressIndefinitely: {
                type: "boolean"
              },
              description: {},
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateAuthorizer: {
          http: {
            requestUri: "/authorizer/{authorizerName}"
          },
          input: {
            type: "structure",
            required: [
              "authorizerName",
              "authorizerFunctionArn"
            ],
            members: {
              authorizerName: {
                location: "uri",
                locationName: "authorizerName"
              },
              authorizerFunctionArn: {},
              tokenKeyName: {},
              tokenSigningPublicKeys: {
                shape: "S2a"
              },
              status: {},
              tags: {
                shape: "S2e"
              },
              signingDisabled: {
                type: "boolean"
              },
              enableCachingForHttp: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              authorizerName: {},
              authorizerArn: {}
            }
          }
        },
        CreateBillingGroup: {
          http: {
            requestUri: "/billing-groups/{billingGroupName}"
          },
          input: {
            type: "structure",
            required: [
              "billingGroupName"
            ],
            members: {
              billingGroupName: {
                location: "uri",
                locationName: "billingGroupName"
              },
              billingGroupProperties: {
                shape: "S2n"
              },
              tags: {
                shape: "S2e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              billingGroupName: {},
              billingGroupArn: {},
              billingGroupId: {}
            }
          }
        },
        CreateCertificateFromCsr: {
          http: {
            requestUri: "/certificates"
          },
          input: {
            type: "structure",
            required: [
              "certificateSigningRequest"
            ],
            members: {
              certificateSigningRequest: {},
              setAsActive: {
                location: "querystring",
                locationName: "setAsActive",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              certificateArn: {},
              certificateId: {},
              certificatePem: {}
            }
          }
        },
        CreateCertificateProvider: {
          http: {
            requestUri: "/certificate-providers/{certificateProviderName}"
          },
          input: {
            type: "structure",
            required: [
              "certificateProviderName",
              "lambdaFunctionArn",
              "accountDefaultForOperations"
            ],
            members: {
              certificateProviderName: {
                location: "uri",
                locationName: "certificateProviderName"
              },
              lambdaFunctionArn: {},
              accountDefaultForOperations: {
                shape: "S2y"
              },
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "S2e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              certificateProviderName: {},
              certificateProviderArn: {}
            }
          }
        },
        CreateCustomMetric: {
          http: {
            requestUri: "/custom-metric/{metricName}"
          },
          input: {
            type: "structure",
            required: [
              "metricName",
              "metricType",
              "clientRequestToken"
            ],
            members: {
              metricName: {
                location: "uri",
                locationName: "metricName"
              },
              displayName: {},
              metricType: {},
              tags: {
                shape: "S2e"
              },
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              metricName: {},
              metricArn: {}
            }
          }
        },
        CreateDimension: {
          http: {
            requestUri: "/dimensions/{name}"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "type",
              "stringValues",
              "clientRequestToken"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              type: {},
              stringValues: {
                shape: "S3c"
              },
              tags: {
                shape: "S2e"
              },
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              arn: {}
            }
          }
        },
        CreateDomainConfiguration: {
          http: {
            requestUri: "/domainConfigurations/{domainConfigurationName}"
          },
          input: {
            type: "structure",
            required: [
              "domainConfigurationName"
            ],
            members: {
              domainConfigurationName: {
                location: "uri",
                locationName: "domainConfigurationName"
              },
              domainName: {},
              serverCertificateArns: {
                type: "list",
                member: {}
              },
              validationCertificateArn: {},
              authorizerConfig: {
                shape: "S3l"
              },
              serviceType: {},
              tags: {
                shape: "S2e"
              },
              tlsConfig: {
                shape: "S3o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              domainConfigurationName: {},
              domainConfigurationArn: {}
            }
          }
        },
        CreateDynamicThingGroup: {
          http: {
            requestUri: "/dynamic-thing-groups/{thingGroupName}"
          },
          input: {
            type: "structure",
            required: [
              "thingGroupName",
              "queryString"
            ],
            members: {
              thingGroupName: {
                location: "uri",
                locationName: "thingGroupName"
              },
              thingGroupProperties: {
                shape: "S3t"
              },
              indexName: {},
              queryString: {},
              queryVersion: {},
              tags: {
                shape: "S2e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              thingGroupName: {},
              thingGroupArn: {},
              thingGroupId: {},
              indexName: {},
              queryString: {},
              queryVersion: {}
            }
          }
        },
        CreateFleetMetric: {
          http: {
            method: "PUT",
            requestUri: "/fleet-metric/{metricName}"
          },
          input: {
            type: "structure",
            required: [
              "metricName",
              "queryString",
              "aggregationType",
              "period",
              "aggregationField"
            ],
            members: {
              metricName: {
                location: "uri",
                locationName: "metricName"
              },
              queryString: {},
              aggregationType: {
                shape: "S47"
              },
              period: {
                type: "integer"
              },
              aggregationField: {},
              description: {},
              queryVersion: {},
              indexName: {},
              unit: {},
              tags: {
                shape: "S2e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              metricName: {},
              metricArn: {}
            }
          }
        },
        CreateJob: {
          http: {
            method: "PUT",
            requestUri: "/jobs/{jobId}"
          },
          input: {
            type: "structure",
            required: [
              "jobId",
              "targets"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              targets: {
                shape: "Sg"
              },
              documentSource: {},
              document: {},
              description: {},
              presignedUrlConfig: {
                shape: "S4k"
              },
              targetSelection: {},
              jobExecutionsRolloutConfig: {
                shape: "S4n"
              },
              abortConfig: {
                shape: "S4u"
              },
              timeoutConfig: {
                shape: "S51"
              },
              tags: {
                shape: "S2e"
              },
              namespaceId: {},
              jobTemplateArn: {},
              jobExecutionsRetryConfig: {
                shape: "S54"
              },
              documentParameters: {
                shape: "S59"
              },
              schedulingConfig: {
                shape: "S5c"
              },
              destinationPackageVersions: {
                shape: "S5j"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobArn: {},
              jobId: {},
              description: {}
            }
          }
        },
        CreateJobTemplate: {
          http: {
            method: "PUT",
            requestUri: "/job-templates/{jobTemplateId}"
          },
          input: {
            type: "structure",
            required: [
              "jobTemplateId",
              "description"
            ],
            members: {
              jobTemplateId: {
                location: "uri",
                locationName: "jobTemplateId"
              },
              jobArn: {},
              documentSource: {},
              document: {},
              description: {},
              presignedUrlConfig: {
                shape: "S4k"
              },
              jobExecutionsRolloutConfig: {
                shape: "S4n"
              },
              abortConfig: {
                shape: "S4u"
              },
              timeoutConfig: {
                shape: "S51"
              },
              tags: {
                shape: "S2e"
              },
              jobExecutionsRetryConfig: {
                shape: "S54"
              },
              maintenanceWindows: {
                shape: "S5f"
              },
              destinationPackageVersions: {
                shape: "S5j"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobTemplateArn: {},
              jobTemplateId: {}
            }
          }
        },
        CreateKeysAndCertificate: {
          http: {
            requestUri: "/keys-and-certificate"
          },
          input: {
            type: "structure",
            members: {
              setAsActive: {
                location: "querystring",
                locationName: "setAsActive",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              certificateArn: {},
              certificateId: {},
              certificatePem: {},
              keyPair: {
                shape: "S5r"
              }
            }
          }
        },
        CreateMitigationAction: {
          http: {
            requestUri: "/mitigationactions/actions/{actionName}"
          },
          input: {
            type: "structure",
            required: [
              "actionName",
              "roleArn",
              "actionParams"
            ],
            members: {
              actionName: {
                location: "uri",
                locationName: "actionName"
              },
              roleArn: {},
              actionParams: {
                shape: "S5w"
              },
              tags: {
                shape: "S2e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              actionArn: {},
              actionId: {}
            }
          }
        },
        CreateOTAUpdate: {
          http: {
            requestUri: "/otaUpdates/{otaUpdateId}"
          },
          input: {
            type: "structure",
            required: [
              "otaUpdateId",
              "targets",
              "files",
              "roleArn"
            ],
            members: {
              otaUpdateId: {
                location: "uri",
                locationName: "otaUpdateId"
              },
              description: {},
              targets: {
                shape: "S6g"
              },
              protocols: {
                shape: "S6i"
              },
              targetSelection: {},
              awsJobExecutionsRolloutConfig: {
                shape: "S6k"
              },
              awsJobPresignedUrlConfig: {
                shape: "S6r"
              },
              awsJobAbortConfig: {
                type: "structure",
                required: [
                  "abortCriteriaList"
                ],
                members: {
                  abortCriteriaList: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "failureType",
                        "action",
                        "thresholdPercentage",
                        "minNumberOfExecutedThings"
                      ],
                      members: {
                        failureType: {},
                        action: {},
                        thresholdPercentage: {
                          type: "double"
                        },
                        minNumberOfExecutedThings: {
                          type: "integer"
                        }
                      }
                    }
                  }
                }
              },
              awsJobTimeoutConfig: {
                type: "structure",
                members: {
                  inProgressTimeoutInMinutes: {
                    type: "long"
                  }
                }
              },
              files: {
                shape: "S72"
              },
              roleArn: {},
              additionalParameters: {
                shape: "S80"
              },
              tags: {
                shape: "S2e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              otaUpdateId: {},
              awsIotJobId: {},
              otaUpdateArn: {},
              awsIotJobArn: {},
              otaUpdateStatus: {}
            }
          }
        },
        CreatePackage: {
          http: {
            method: "PUT",
            requestUri: "/packages/{packageName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "packageName"
            ],
            members: {
              packageName: {
                location: "uri",
                locationName: "packageName"
              },
              description: {
                shape: "S88"
              },
              tags: {
                shape: "S89"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              packageName: {},
              packageArn: {},
              description: {
                shape: "S88"
              }
            }
          },
          idempotent: true
        },
        CreatePackageVersion: {
          http: {
            method: "PUT",
            requestUri: "/packages/{packageName}/versions/{versionName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "packageName",
              "versionName"
            ],
            members: {
              packageName: {
                location: "uri",
                locationName: "packageName"
              },
              versionName: {
                location: "uri",
                locationName: "versionName"
              },
              description: {
                shape: "S88"
              },
              attributes: {
                shape: "S8e"
              },
              tags: {
                shape: "S89"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              packageVersionArn: {},
              packageName: {},
              versionName: {},
              description: {
                shape: "S88"
              },
              attributes: {
                shape: "S8e"
              },
              status: {},
              errorReason: {}
            }
          },
          idempotent: true
        },
        CreatePolicy: {
          http: {
            requestUri: "/policies/{policyName}"
          },
          input: {
            type: "structure",
            required: [
              "policyName",
              "policyDocument"
            ],
            members: {
              policyName: {
                location: "uri",
                locationName: "policyName"
              },
              policyDocument: {},
              tags: {
                shape: "S2e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              policyName: {},
              policyArn: {},
              policyDocument: {},
              policyVersionId: {}
            }
          }
        },
        CreatePolicyVersion: {
          http: {
            requestUri: "/policies/{policyName}/version"
          },
          input: {
            type: "structure",
            required: [
              "policyName",
              "policyDocument"
            ],
            members: {
              policyName: {
                location: "uri",
                locationName: "policyName"
              },
              policyDocument: {},
              setAsDefault: {
                location: "querystring",
                locationName: "setAsDefault",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              policyArn: {},
              policyDocument: {},
              policyVersionId: {},
              isDefaultVersion: {
                type: "boolean"
              }
            }
          }
        },
        CreateProvisioningClaim: {
          http: {
            requestUri: "/provisioning-templates/{templateName}/provisioning-claim"
          },
          input: {
            type: "structure",
            required: [
              "templateName"
            ],
            members: {
              templateName: {
                location: "uri",
                locationName: "templateName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              certificateId: {},
              certificatePem: {},
              keyPair: {
                shape: "S5r"
              },
              expiration: {
                type: "timestamp"
              }
            }
          }
        },
        CreateProvisioningTemplate: {
          http: {
            requestUri: "/provisioning-templates"
          },
          input: {
            type: "structure",
            required: [
              "templateName",
              "templateBody",
              "provisioningRoleArn"
            ],
            members: {
              templateName: {},
              description: {},
              templateBody: {},
              enabled: {
                type: "boolean"
              },
              provisioningRoleArn: {},
              preProvisioningHook: {
                shape: "S90"
              },
              tags: {
                shape: "S2e"
              },
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              templateArn: {},
              templateName: {},
              defaultVersionId: {
                type: "integer"
              }
            }
          }
        },
        CreateProvisioningTemplateVersion: {
          http: {
            requestUri: "/provisioning-templates/{templateName}/versions"
          },
          input: {
            type: "structure",
            required: [
              "templateName",
              "templateBody"
            ],
            members: {
              templateName: {
                location: "uri",
                locationName: "templateName"
              },
              templateBody: {},
              setAsDefault: {
                location: "querystring",
                locationName: "setAsDefault",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              templateArn: {},
              templateName: {},
              versionId: {
                type: "integer"
              },
              isDefaultVersion: {
                type: "boolean"
              }
            }
          }
        },
        CreateRoleAlias: {
          http: {
            requestUri: "/role-aliases/{roleAlias}"
          },
          input: {
            type: "structure",
            required: [
              "roleAlias",
              "roleArn"
            ],
            members: {
              roleAlias: {
                location: "uri",
                locationName: "roleAlias"
              },
              roleArn: {},
              credentialDurationSeconds: {
                type: "integer"
              },
              tags: {
                shape: "S2e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              roleAlias: {},
              roleAliasArn: {}
            }
          }
        },
        CreateScheduledAudit: {
          http: {
            requestUri: "/audit/scheduledaudits/{scheduledAuditName}"
          },
          input: {
            type: "structure",
            required: [
              "frequency",
              "targetCheckNames",
              "scheduledAuditName"
            ],
            members: {
              frequency: {},
              dayOfMonth: {},
              dayOfWeek: {},
              targetCheckNames: {
                shape: "S9g"
              },
              scheduledAuditName: {
                location: "uri",
                locationName: "scheduledAuditName"
              },
              tags: {
                shape: "S2e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              scheduledAuditArn: {}
            }
          }
        },
        CreateSecurityProfile: {
          http: {
            requestUri: "/security-profiles/{securityProfileName}"
          },
          input: {
            type: "structure",
            required: [
              "securityProfileName"
            ],
            members: {
              securityProfileName: {
                location: "uri",
                locationName: "securityProfileName"
              },
              securityProfileDescription: {},
              behaviors: {
                shape: "S9m"
              },
              alertTargets: {
                shape: "Sad"
              },
              additionalMetricsToRetain: {
                shape: "Sah",
                deprecated: true,
                deprecatedMessage: "Use additionalMetricsToRetainV2."
              },
              additionalMetricsToRetainV2: {
                shape: "Sai"
              },
              tags: {
                shape: "S2e"
              },
              metricsExportConfig: {
                shape: "Sak"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              securityProfileName: {},
              securityProfileArn: {}
            }
          }
        },
        CreateStream: {
          http: {
            requestUri: "/streams/{streamId}"
          },
          input: {
            type: "structure",
            required: [
              "streamId",
              "files",
              "roleArn"
            ],
            members: {
              streamId: {
                location: "uri",
                locationName: "streamId"
              },
              description: {},
              files: {
                shape: "Saq"
              },
              roleArn: {},
              tags: {
                shape: "S2e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              streamId: {},
              streamArn: {},
              description: {},
              streamVersion: {
                type: "integer"
              }
            }
          }
        },
        CreateThing: {
          http: {
            requestUri: "/things/{thingName}"
          },
          input: {
            type: "structure",
            required: [
              "thingName"
            ],
            members: {
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              thingTypeName: {},
              attributePayload: {
                shape: "S3v"
              },
              billingGroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              thingName: {},
              thingArn: {},
              thingId: {}
            }
          }
        },
        CreateThingGroup: {
          http: {
            requestUri: "/thing-groups/{thingGroupName}"
          },
          input: {
            type: "structure",
            required: [
              "thingGroupName"
            ],
            members: {
              thingGroupName: {
                location: "uri",
                locationName: "thingGroupName"
              },
              parentGroupName: {},
              thingGroupProperties: {
                shape: "S3t"
              },
              tags: {
                shape: "S2e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              thingGroupName: {},
              thingGroupArn: {},
              thingGroupId: {}
            }
          }
        },
        CreateThingType: {
          http: {
            requestUri: "/thing-types/{thingTypeName}"
          },
          input: {
            type: "structure",
            required: [
              "thingTypeName"
            ],
            members: {
              thingTypeName: {
                location: "uri",
                locationName: "thingTypeName"
              },
              thingTypeProperties: {
                shape: "Sb2"
              },
              tags: {
                shape: "S2e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              thingTypeName: {},
              thingTypeArn: {},
              thingTypeId: {}
            }
          }
        },
        CreateTopicRule: {
          http: {
            requestUri: "/rules/{ruleName}"
          },
          input: {
            type: "structure",
            required: [
              "ruleName",
              "topicRulePayload"
            ],
            members: {
              ruleName: {
                location: "uri",
                locationName: "ruleName"
              },
              topicRulePayload: {
                shape: "Sba"
              },
              tags: {
                location: "header",
                locationName: "x-amz-tagging"
              }
            },
            payload: "topicRulePayload"
          }
        },
        CreateTopicRuleDestination: {
          http: {
            requestUri: "/destinations"
          },
          input: {
            type: "structure",
            required: [
              "destinationConfiguration"
            ],
            members: {
              destinationConfiguration: {
                type: "structure",
                members: {
                  httpUrlConfiguration: {
                    type: "structure",
                    required: [
                      "confirmationUrl"
                    ],
                    members: {
                      confirmationUrl: {}
                    }
                  },
                  vpcConfiguration: {
                    type: "structure",
                    required: [
                      "subnetIds",
                      "vpcId",
                      "roleArn"
                    ],
                    members: {
                      subnetIds: {
                        shape: "Ser"
                      },
                      securityGroups: {
                        shape: "Set"
                      },
                      vpcId: {},
                      roleArn: {}
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              topicRuleDestination: {
                shape: "Sex"
              }
            }
          }
        },
        DeleteAccountAuditConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/audit/configuration"
          },
          input: {
            type: "structure",
            members: {
              deleteScheduledAudits: {
                location: "querystring",
                locationName: "deleteScheduledAudits",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAuditSuppression: {
          http: {
            requestUri: "/audit/suppressions/delete"
          },
          input: {
            type: "structure",
            required: [
              "checkName",
              "resourceIdentifier"
            ],
            members: {
              checkName: {},
              resourceIdentifier: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAuthorizer: {
          http: {
            method: "DELETE",
            requestUri: "/authorizer/{authorizerName}"
          },
          input: {
            type: "structure",
            required: [
              "authorizerName"
            ],
            members: {
              authorizerName: {
                location: "uri",
                locationName: "authorizerName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteBillingGroup: {
          http: {
            method: "DELETE",
            requestUri: "/billing-groups/{billingGroupName}"
          },
          input: {
            type: "structure",
            required: [
              "billingGroupName"
            ],
            members: {
              billingGroupName: {
                location: "uri",
                locationName: "billingGroupName"
              },
              expectedVersion: {
                location: "querystring",
                locationName: "expectedVersion",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteCACertificate: {
          http: {
            method: "DELETE",
            requestUri: "/cacertificate/{caCertificateId}"
          },
          input: {
            type: "structure",
            required: [
              "certificateId"
            ],
            members: {
              certificateId: {
                location: "uri",
                locationName: "caCertificateId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteCertificate: {
          http: {
            method: "DELETE",
            requestUri: "/certificates/{certificateId}"
          },
          input: {
            type: "structure",
            required: [
              "certificateId"
            ],
            members: {
              certificateId: {
                location: "uri",
                locationName: "certificateId"
              },
              forceDelete: {
                location: "querystring",
                locationName: "forceDelete",
                type: "boolean"
              }
            }
          }
        },
        DeleteCertificateProvider: {
          http: {
            method: "DELETE",
            requestUri: "/certificate-providers/{certificateProviderName}"
          },
          input: {
            type: "structure",
            required: [
              "certificateProviderName"
            ],
            members: {
              certificateProviderName: {
                location: "uri",
                locationName: "certificateProviderName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteCustomMetric: {
          http: {
            method: "DELETE",
            requestUri: "/custom-metric/{metricName}"
          },
          input: {
            type: "structure",
            required: [
              "metricName"
            ],
            members: {
              metricName: {
                location: "uri",
                locationName: "metricName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDimension: {
          http: {
            method: "DELETE",
            requestUri: "/dimensions/{name}"
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDomainConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/domainConfigurations/{domainConfigurationName}"
          },
          input: {
            type: "structure",
            required: [
              "domainConfigurationName"
            ],
            members: {
              domainConfigurationName: {
                location: "uri",
                locationName: "domainConfigurationName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDynamicThingGroup: {
          http: {
            method: "DELETE",
            requestUri: "/dynamic-thing-groups/{thingGroupName}"
          },
          input: {
            type: "structure",
            required: [
              "thingGroupName"
            ],
            members: {
              thingGroupName: {
                location: "uri",
                locationName: "thingGroupName"
              },
              expectedVersion: {
                location: "querystring",
                locationName: "expectedVersion",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteFleetMetric: {
          http: {
            method: "DELETE",
            requestUri: "/fleet-metric/{metricName}"
          },
          input: {
            type: "structure",
            required: [
              "metricName"
            ],
            members: {
              metricName: {
                location: "uri",
                locationName: "metricName"
              },
              expectedVersion: {
                location: "querystring",
                locationName: "expectedVersion",
                type: "long"
              }
            }
          }
        },
        DeleteJob: {
          http: {
            method: "DELETE",
            requestUri: "/jobs/{jobId}"
          },
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              force: {
                location: "querystring",
                locationName: "force",
                type: "boolean"
              },
              namespaceId: {
                location: "querystring",
                locationName: "namespaceId"
              }
            }
          }
        },
        DeleteJobExecution: {
          http: {
            method: "DELETE",
            requestUri: "/things/{thingName}/jobs/{jobId}/executionNumber/{executionNumber}"
          },
          input: {
            type: "structure",
            required: [
              "jobId",
              "thingName",
              "executionNumber"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              executionNumber: {
                location: "uri",
                locationName: "executionNumber",
                type: "long"
              },
              force: {
                location: "querystring",
                locationName: "force",
                type: "boolean"
              },
              namespaceId: {
                location: "querystring",
                locationName: "namespaceId"
              }
            }
          }
        },
        DeleteJobTemplate: {
          http: {
            method: "DELETE",
            requestUri: "/job-templates/{jobTemplateId}"
          },
          input: {
            type: "structure",
            required: [
              "jobTemplateId"
            ],
            members: {
              jobTemplateId: {
                location: "uri",
                locationName: "jobTemplateId"
              }
            }
          }
        },
        DeleteMitigationAction: {
          http: {
            method: "DELETE",
            requestUri: "/mitigationactions/actions/{actionName}"
          },
          input: {
            type: "structure",
            required: [
              "actionName"
            ],
            members: {
              actionName: {
                location: "uri",
                locationName: "actionName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteOTAUpdate: {
          http: {
            method: "DELETE",
            requestUri: "/otaUpdates/{otaUpdateId}"
          },
          input: {
            type: "structure",
            required: [
              "otaUpdateId"
            ],
            members: {
              otaUpdateId: {
                location: "uri",
                locationName: "otaUpdateId"
              },
              deleteStream: {
                location: "querystring",
                locationName: "deleteStream",
                type: "boolean"
              },
              forceDeleteAWSJob: {
                location: "querystring",
                locationName: "forceDeleteAWSJob",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeletePackage: {
          http: {
            method: "DELETE",
            requestUri: "/packages/{packageName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "packageName"
            ],
            members: {
              packageName: {
                location: "uri",
                locationName: "packageName"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeletePackageVersion: {
          http: {
            method: "DELETE",
            requestUri: "/packages/{packageName}/versions/{versionName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "packageName",
              "versionName"
            ],
            members: {
              packageName: {
                location: "uri",
                locationName: "packageName"
              },
              versionName: {
                location: "uri",
                locationName: "versionName"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeletePolicy: {
          http: {
            method: "DELETE",
            requestUri: "/policies/{policyName}"
          },
          input: {
            type: "structure",
            required: [
              "policyName"
            ],
            members: {
              policyName: {
                location: "uri",
                locationName: "policyName"
              }
            }
          }
        },
        DeletePolicyVersion: {
          http: {
            method: "DELETE",
            requestUri: "/policies/{policyName}/version/{policyVersionId}"
          },
          input: {
            type: "structure",
            required: [
              "policyName",
              "policyVersionId"
            ],
            members: {
              policyName: {
                location: "uri",
                locationName: "policyName"
              },
              policyVersionId: {
                location: "uri",
                locationName: "policyVersionId"
              }
            }
          }
        },
        DeleteProvisioningTemplate: {
          http: {
            method: "DELETE",
            requestUri: "/provisioning-templates/{templateName}"
          },
          input: {
            type: "structure",
            required: [
              "templateName"
            ],
            members: {
              templateName: {
                location: "uri",
                locationName: "templateName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteProvisioningTemplateVersion: {
          http: {
            method: "DELETE",
            requestUri: "/provisioning-templates/{templateName}/versions/{versionId}"
          },
          input: {
            type: "structure",
            required: [
              "templateName",
              "versionId"
            ],
            members: {
              templateName: {
                location: "uri",
                locationName: "templateName"
              },
              versionId: {
                location: "uri",
                locationName: "versionId",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRegistrationCode: {
          http: {
            method: "DELETE",
            requestUri: "/registrationcode"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRoleAlias: {
          http: {
            method: "DELETE",
            requestUri: "/role-aliases/{roleAlias}"
          },
          input: {
            type: "structure",
            required: [
              "roleAlias"
            ],
            members: {
              roleAlias: {
                location: "uri",
                locationName: "roleAlias"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteScheduledAudit: {
          http: {
            method: "DELETE",
            requestUri: "/audit/scheduledaudits/{scheduledAuditName}"
          },
          input: {
            type: "structure",
            required: [
              "scheduledAuditName"
            ],
            members: {
              scheduledAuditName: {
                location: "uri",
                locationName: "scheduledAuditName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSecurityProfile: {
          http: {
            method: "DELETE",
            requestUri: "/security-profiles/{securityProfileName}"
          },
          input: {
            type: "structure",
            required: [
              "securityProfileName"
            ],
            members: {
              securityProfileName: {
                location: "uri",
                locationName: "securityProfileName"
              },
              expectedVersion: {
                location: "querystring",
                locationName: "expectedVersion",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteStream: {
          http: {
            method: "DELETE",
            requestUri: "/streams/{streamId}"
          },
          input: {
            type: "structure",
            required: [
              "streamId"
            ],
            members: {
              streamId: {
                location: "uri",
                locationName: "streamId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteThing: {
          http: {
            method: "DELETE",
            requestUri: "/things/{thingName}"
          },
          input: {
            type: "structure",
            required: [
              "thingName"
            ],
            members: {
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              expectedVersion: {
                location: "querystring",
                locationName: "expectedVersion",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteThingGroup: {
          http: {
            method: "DELETE",
            requestUri: "/thing-groups/{thingGroupName}"
          },
          input: {
            type: "structure",
            required: [
              "thingGroupName"
            ],
            members: {
              thingGroupName: {
                location: "uri",
                locationName: "thingGroupName"
              },
              expectedVersion: {
                location: "querystring",
                locationName: "expectedVersion",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteThingType: {
          http: {
            method: "DELETE",
            requestUri: "/thing-types/{thingTypeName}"
          },
          input: {
            type: "structure",
            required: [
              "thingTypeName"
            ],
            members: {
              thingTypeName: {
                location: "uri",
                locationName: "thingTypeName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteTopicRule: {
          http: {
            method: "DELETE",
            requestUri: "/rules/{ruleName}"
          },
          input: {
            type: "structure",
            required: [
              "ruleName"
            ],
            members: {
              ruleName: {
                location: "uri",
                locationName: "ruleName"
              }
            }
          }
        },
        DeleteTopicRuleDestination: {
          http: {
            method: "DELETE",
            requestUri: "/destinations/{arn+}"
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {
                location: "uri",
                locationName: "arn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteV2LoggingLevel: {
          http: {
            method: "DELETE",
            requestUri: "/v2LoggingLevel"
          },
          input: {
            type: "structure",
            required: [
              "targetType",
              "targetName"
            ],
            members: {
              targetType: {
                location: "querystring",
                locationName: "targetType"
              },
              targetName: {
                location: "querystring",
                locationName: "targetName"
              }
            }
          }
        },
        DeprecateThingType: {
          http: {
            requestUri: "/thing-types/{thingTypeName}/deprecate"
          },
          input: {
            type: "structure",
            required: [
              "thingTypeName"
            ],
            members: {
              thingTypeName: {
                location: "uri",
                locationName: "thingTypeName"
              },
              undoDeprecate: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeAccountAuditConfiguration: {
          http: {
            method: "GET",
            requestUri: "/audit/configuration"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              roleArn: {},
              auditNotificationTargetConfigurations: {
                shape: "Sh3"
              },
              auditCheckConfigurations: {
                shape: "Sh6"
              }
            }
          }
        },
        DescribeAuditFinding: {
          http: {
            method: "GET",
            requestUri: "/audit/findings/{findingId}"
          },
          input: {
            type: "structure",
            required: [
              "findingId"
            ],
            members: {
              findingId: {
                location: "uri",
                locationName: "findingId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              finding: {
                shape: "Shb"
              }
            }
          }
        },
        DescribeAuditMitigationActionsTask: {
          http: {
            method: "GET",
            requestUri: "/audit/mitigationactions/tasks/{taskId}"
          },
          input: {
            type: "structure",
            required: [
              "taskId"
            ],
            members: {
              taskId: {
                location: "uri",
                locationName: "taskId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskStatus: {},
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              taskStatistics: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    totalFindingsCount: {
                      type: "long"
                    },
                    failedFindingsCount: {
                      type: "long"
                    },
                    succeededFindingsCount: {
                      type: "long"
                    },
                    skippedFindingsCount: {
                      type: "long"
                    },
                    canceledFindingsCount: {
                      type: "long"
                    }
                  }
                }
              },
              target: {
                shape: "Shv"
              },
              auditCheckToActionsMapping: {
                shape: "Shz"
              },
              actionsDefinition: {
                shape: "Si1"
              }
            }
          }
        },
        DescribeAuditSuppression: {
          http: {
            requestUri: "/audit/suppressions/describe"
          },
          input: {
            type: "structure",
            required: [
              "checkName",
              "resourceIdentifier"
            ],
            members: {
              checkName: {},
              resourceIdentifier: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              checkName: {},
              resourceIdentifier: {
                shape: "S1o"
              },
              expirationDate: {
                type: "timestamp"
              },
              suppressIndefinitely: {
                type: "boolean"
              },
              description: {}
            }
          }
        },
        DescribeAuditTask: {
          http: {
            method: "GET",
            requestUri: "/audit/tasks/{taskId}"
          },
          input: {
            type: "structure",
            required: [
              "taskId"
            ],
            members: {
              taskId: {
                location: "uri",
                locationName: "taskId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskStatus: {},
              taskType: {},
              taskStartTime: {
                type: "timestamp"
              },
              taskStatistics: {
                type: "structure",
                members: {
                  totalChecks: {
                    type: "integer"
                  },
                  inProgressChecks: {
                    type: "integer"
                  },
                  waitingForDataCollectionChecks: {
                    type: "integer"
                  },
                  compliantChecks: {
                    type: "integer"
                  },
                  nonCompliantChecks: {
                    type: "integer"
                  },
                  failedChecks: {
                    type: "integer"
                  },
                  canceledChecks: {
                    type: "integer"
                  }
                }
              },
              scheduledAuditName: {},
              auditDetails: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    checkRunStatus: {},
                    checkCompliant: {
                      type: "boolean"
                    },
                    totalResourcesCount: {
                      type: "long"
                    },
                    nonCompliantResourcesCount: {
                      type: "long"
                    },
                    suppressedNonCompliantResourcesCount: {
                      type: "long"
                    },
                    errorCode: {},
                    message: {}
                  }
                }
              }
            }
          }
        },
        DescribeAuthorizer: {
          http: {
            method: "GET",
            requestUri: "/authorizer/{authorizerName}"
          },
          input: {
            type: "structure",
            required: [
              "authorizerName"
            ],
            members: {
              authorizerName: {
                location: "uri",
                locationName: "authorizerName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              authorizerDescription: {
                shape: "Sis"
              }
            }
          }
        },
        DescribeBillingGroup: {
          http: {
            method: "GET",
            requestUri: "/billing-groups/{billingGroupName}"
          },
          input: {
            type: "structure",
            required: [
              "billingGroupName"
            ],
            members: {
              billingGroupName: {
                location: "uri",
                locationName: "billingGroupName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              billingGroupName: {},
              billingGroupId: {},
              billingGroupArn: {},
              version: {
                type: "long"
              },
              billingGroupProperties: {
                shape: "S2n"
              },
              billingGroupMetadata: {
                type: "structure",
                members: {
                  creationDate: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        DescribeCACertificate: {
          http: {
            method: "GET",
            requestUri: "/cacertificate/{caCertificateId}"
          },
          input: {
            type: "structure",
            required: [
              "certificateId"
            ],
            members: {
              certificateId: {
                location: "uri",
                locationName: "caCertificateId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              certificateDescription: {
                type: "structure",
                members: {
                  certificateArn: {},
                  certificateId: {},
                  status: {},
                  certificatePem: {},
                  ownedBy: {},
                  creationDate: {
                    type: "timestamp"
                  },
                  autoRegistrationStatus: {},
                  lastModifiedDate: {
                    type: "timestamp"
                  },
                  customerVersion: {
                    type: "integer"
                  },
                  generationId: {},
                  validity: {
                    shape: "Sj5"
                  },
                  certificateMode: {}
                }
              },
              registrationConfig: {
                shape: "Sj7"
              }
            }
          }
        },
        DescribeCertificate: {
          http: {
            method: "GET",
            requestUri: "/certificates/{certificateId}"
          },
          input: {
            type: "structure",
            required: [
              "certificateId"
            ],
            members: {
              certificateId: {
                location: "uri",
                locationName: "certificateId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              certificateDescription: {
                type: "structure",
                members: {
                  certificateArn: {},
                  certificateId: {},
                  caCertificateId: {},
                  status: {},
                  certificatePem: {},
                  ownedBy: {},
                  previousOwnedBy: {},
                  creationDate: {
                    type: "timestamp"
                  },
                  lastModifiedDate: {
                    type: "timestamp"
                  },
                  customerVersion: {
                    type: "integer"
                  },
                  transferData: {
                    type: "structure",
                    members: {
                      transferMessage: {},
                      rejectReason: {},
                      transferDate: {
                        type: "timestamp"
                      },
                      acceptDate: {
                        type: "timestamp"
                      },
                      rejectDate: {
                        type: "timestamp"
                      }
                    }
                  },
                  generationId: {},
                  validity: {
                    shape: "Sj5"
                  },
                  certificateMode: {}
                }
              }
            }
          }
        },
        DescribeCertificateProvider: {
          http: {
            method: "GET",
            requestUri: "/certificate-providers/{certificateProviderName}"
          },
          input: {
            type: "structure",
            required: [
              "certificateProviderName"
            ],
            members: {
              certificateProviderName: {
                location: "uri",
                locationName: "certificateProviderName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              certificateProviderName: {},
              certificateProviderArn: {},
              lambdaFunctionArn: {},
              accountDefaultForOperations: {
                shape: "S2y"
              },
              creationDate: {
                type: "timestamp"
              },
              lastModifiedDate: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeCustomMetric: {
          http: {
            method: "GET",
            requestUri: "/custom-metric/{metricName}"
          },
          input: {
            type: "structure",
            required: [
              "metricName"
            ],
            members: {
              metricName: {
                location: "uri",
                locationName: "metricName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              metricName: {},
              metricArn: {},
              metricType: {},
              displayName: {},
              creationDate: {
                type: "timestamp"
              },
              lastModifiedDate: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeDefaultAuthorizer: {
          http: {
            method: "GET",
            requestUri: "/default-authorizer"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              authorizerDescription: {
                shape: "Sis"
              }
            }
          }
        },
        DescribeDetectMitigationActionsTask: {
          http: {
            method: "GET",
            requestUri: "/detect/mitigationactions/tasks/{taskId}"
          },
          input: {
            type: "structure",
            required: [
              "taskId"
            ],
            members: {
              taskId: {
                location: "uri",
                locationName: "taskId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskSummary: {
                shape: "Sjm"
              }
            }
          }
        },
        DescribeDimension: {
          http: {
            method: "GET",
            requestUri: "/dimensions/{name}"
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              arn: {},
              type: {},
              stringValues: {
                shape: "S3c"
              },
              creationDate: {
                type: "timestamp"
              },
              lastModifiedDate: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeDomainConfiguration: {
          http: {
            method: "GET",
            requestUri: "/domainConfigurations/{domainConfigurationName}"
          },
          input: {
            type: "structure",
            required: [
              "domainConfigurationName"
            ],
            members: {
              domainConfigurationName: {
                location: "uri",
                locationName: "domainConfigurationName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              domainConfigurationName: {},
              domainConfigurationArn: {},
              domainName: {},
              serverCertificates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    serverCertificateArn: {},
                    serverCertificateStatus: {},
                    serverCertificateStatusDetail: {}
                  }
                }
              },
              authorizerConfig: {
                shape: "S3l"
              },
              domainConfigurationStatus: {},
              serviceType: {},
              domainType: {},
              lastStatusChangeDate: {
                type: "timestamp"
              },
              tlsConfig: {
                shape: "S3o"
              }
            }
          }
        },
        DescribeEndpoint: {
          http: {
            method: "GET",
            requestUri: "/endpoint"
          },
          input: {
            type: "structure",
            members: {
              endpointType: {
                location: "querystring",
                locationName: "endpointType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              endpointAddress: {}
            }
          }
        },
        DescribeEventConfigurations: {
          http: {
            method: "GET",
            requestUri: "/event-configurations"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              eventConfigurations: {
                shape: "Skc"
              },
              creationDate: {
                type: "timestamp"
              },
              lastModifiedDate: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeFleetMetric: {
          http: {
            method: "GET",
            requestUri: "/fleet-metric/{metricName}"
          },
          input: {
            type: "structure",
            required: [
              "metricName"
            ],
            members: {
              metricName: {
                location: "uri",
                locationName: "metricName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              metricName: {},
              queryString: {},
              aggregationType: {
                shape: "S47"
              },
              period: {
                type: "integer"
              },
              aggregationField: {},
              description: {},
              queryVersion: {},
              indexName: {},
              creationDate: {
                type: "timestamp"
              },
              lastModifiedDate: {
                type: "timestamp"
              },
              unit: {},
              version: {
                type: "long"
              },
              metricArn: {}
            }
          }
        },
        DescribeIndex: {
          http: {
            method: "GET",
            requestUri: "/indices/{indexName}"
          },
          input: {
            type: "structure",
            required: [
              "indexName"
            ],
            members: {
              indexName: {
                location: "uri",
                locationName: "indexName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              indexName: {},
              indexStatus: {},
              schema: {}
            }
          }
        },
        DescribeJob: {
          http: {
            method: "GET",
            requestUri: "/jobs/{jobId}"
          },
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              documentSource: {},
              job: {
                type: "structure",
                members: {
                  jobArn: {},
                  jobId: {},
                  targetSelection: {},
                  status: {},
                  forceCanceled: {
                    type: "boolean"
                  },
                  reasonCode: {},
                  comment: {},
                  targets: {
                    shape: "Sg"
                  },
                  description: {},
                  presignedUrlConfig: {
                    shape: "S4k"
                  },
                  jobExecutionsRolloutConfig: {
                    shape: "S4n"
                  },
                  abortConfig: {
                    shape: "S4u"
                  },
                  createdAt: {
                    type: "timestamp"
                  },
                  lastUpdatedAt: {
                    type: "timestamp"
                  },
                  completedAt: {
                    type: "timestamp"
                  },
                  jobProcessDetails: {
                    type: "structure",
                    members: {
                      processingTargets: {
                        type: "list",
                        member: {}
                      },
                      numberOfCanceledThings: {
                        type: "integer"
                      },
                      numberOfSucceededThings: {
                        type: "integer"
                      },
                      numberOfFailedThings: {
                        type: "integer"
                      },
                      numberOfRejectedThings: {
                        type: "integer"
                      },
                      numberOfQueuedThings: {
                        type: "integer"
                      },
                      numberOfInProgressThings: {
                        type: "integer"
                      },
                      numberOfRemovedThings: {
                        type: "integer"
                      },
                      numberOfTimedOutThings: {
                        type: "integer"
                      }
                    }
                  },
                  timeoutConfig: {
                    shape: "S51"
                  },
                  namespaceId: {},
                  jobTemplateArn: {},
                  jobExecutionsRetryConfig: {
                    shape: "S54"
                  },
                  documentParameters: {
                    shape: "S59"
                  },
                  isConcurrent: {
                    type: "boolean"
                  },
                  schedulingConfig: {
                    shape: "S5c"
                  },
                  scheduledJobRollouts: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        startTime: {}
                      }
                    }
                  },
                  destinationPackageVersions: {
                    shape: "S5j"
                  }
                }
              }
            }
          }
        },
        DescribeJobExecution: {
          http: {
            method: "GET",
            requestUri: "/things/{thingName}/jobs/{jobId}"
          },
          input: {
            type: "structure",
            required: [
              "jobId",
              "thingName"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              executionNumber: {
                location: "querystring",
                locationName: "executionNumber",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              execution: {
                type: "structure",
                members: {
                  jobId: {},
                  status: {},
                  forceCanceled: {
                    type: "boolean"
                  },
                  statusDetails: {
                    type: "structure",
                    members: {
                      detailsMap: {
                        shape: "S1e"
                      }
                    }
                  },
                  thingArn: {},
                  queuedAt: {
                    type: "timestamp"
                  },
                  startedAt: {
                    type: "timestamp"
                  },
                  lastUpdatedAt: {
                    type: "timestamp"
                  },
                  executionNumber: {
                    type: "long"
                  },
                  versionNumber: {
                    type: "long"
                  },
                  approximateSecondsBeforeTimedOut: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        DescribeJobTemplate: {
          http: {
            method: "GET",
            requestUri: "/job-templates/{jobTemplateId}"
          },
          input: {
            type: "structure",
            required: [
              "jobTemplateId"
            ],
            members: {
              jobTemplateId: {
                location: "uri",
                locationName: "jobTemplateId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobTemplateArn: {},
              jobTemplateId: {},
              description: {},
              documentSource: {},
              document: {},
              createdAt: {
                type: "timestamp"
              },
              presignedUrlConfig: {
                shape: "S4k"
              },
              jobExecutionsRolloutConfig: {
                shape: "S4n"
              },
              abortConfig: {
                shape: "S4u"
              },
              timeoutConfig: {
                shape: "S51"
              },
              jobExecutionsRetryConfig: {
                shape: "S54"
              },
              maintenanceWindows: {
                shape: "S5f"
              },
              destinationPackageVersions: {
                shape: "S5j"
              }
            }
          }
        },
        DescribeManagedJobTemplate: {
          http: {
            method: "GET",
            requestUri: "/managed-job-templates/{templateName}"
          },
          input: {
            type: "structure",
            required: [
              "templateName"
            ],
            members: {
              templateName: {
                location: "uri",
                locationName: "templateName"
              },
              templateVersion: {
                location: "querystring",
                locationName: "templateVersion"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              templateName: {},
              templateArn: {},
              description: {},
              templateVersion: {},
              environments: {
                shape: "Sli"
              },
              documentParameters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    key: {},
                    description: {},
                    regex: {},
                    example: {},
                    optional: {
                      type: "boolean"
                    }
                  }
                }
              },
              document: {}
            }
          }
        },
        DescribeMitigationAction: {
          http: {
            method: "GET",
            requestUri: "/mitigationactions/actions/{actionName}"
          },
          input: {
            type: "structure",
            required: [
              "actionName"
            ],
            members: {
              actionName: {
                location: "uri",
                locationName: "actionName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              actionName: {},
              actionType: {},
              actionArn: {},
              actionId: {},
              roleArn: {},
              actionParams: {
                shape: "S5w"
              },
              creationDate: {
                type: "timestamp"
              },
              lastModifiedDate: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeProvisioningTemplate: {
          http: {
            method: "GET",
            requestUri: "/provisioning-templates/{templateName}"
          },
          input: {
            type: "structure",
            required: [
              "templateName"
            ],
            members: {
              templateName: {
                location: "uri",
                locationName: "templateName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              templateArn: {},
              templateName: {},
              description: {},
              creationDate: {
                type: "timestamp"
              },
              lastModifiedDate: {
                type: "timestamp"
              },
              defaultVersionId: {
                type: "integer"
              },
              templateBody: {},
              enabled: {
                type: "boolean"
              },
              provisioningRoleArn: {},
              preProvisioningHook: {
                shape: "S90"
              },
              type: {}
            }
          }
        },
        DescribeProvisioningTemplateVersion: {
          http: {
            method: "GET",
            requestUri: "/provisioning-templates/{templateName}/versions/{versionId}"
          },
          input: {
            type: "structure",
            required: [
              "templateName",
              "versionId"
            ],
            members: {
              templateName: {
                location: "uri",
                locationName: "templateName"
              },
              versionId: {
                location: "uri",
                locationName: "versionId",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              versionId: {
                type: "integer"
              },
              creationDate: {
                type: "timestamp"
              },
              templateBody: {},
              isDefaultVersion: {
                type: "boolean"
              }
            }
          }
        },
        DescribeRoleAlias: {
          http: {
            method: "GET",
            requestUri: "/role-aliases/{roleAlias}"
          },
          input: {
            type: "structure",
            required: [
              "roleAlias"
            ],
            members: {
              roleAlias: {
                location: "uri",
                locationName: "roleAlias"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              roleAliasDescription: {
                type: "structure",
                members: {
                  roleAlias: {},
                  roleAliasArn: {},
                  roleArn: {},
                  owner: {},
                  credentialDurationSeconds: {
                    type: "integer"
                  },
                  creationDate: {
                    type: "timestamp"
                  },
                  lastModifiedDate: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        DescribeScheduledAudit: {
          http: {
            method: "GET",
            requestUri: "/audit/scheduledaudits/{scheduledAuditName}"
          },
          input: {
            type: "structure",
            required: [
              "scheduledAuditName"
            ],
            members: {
              scheduledAuditName: {
                location: "uri",
                locationName: "scheduledAuditName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              frequency: {},
              dayOfMonth: {},
              dayOfWeek: {},
              targetCheckNames: {
                shape: "S9g"
              },
              scheduledAuditName: {},
              scheduledAuditArn: {}
            }
          }
        },
        DescribeSecurityProfile: {
          http: {
            method: "GET",
            requestUri: "/security-profiles/{securityProfileName}"
          },
          input: {
            type: "structure",
            required: [
              "securityProfileName"
            ],
            members: {
              securityProfileName: {
                location: "uri",
                locationName: "securityProfileName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              securityProfileName: {},
              securityProfileArn: {},
              securityProfileDescription: {},
              behaviors: {
                shape: "S9m"
              },
              alertTargets: {
                shape: "Sad"
              },
              additionalMetricsToRetain: {
                shape: "Sah",
                deprecated: true,
                deprecatedMessage: "Use additionalMetricsToRetainV2."
              },
              additionalMetricsToRetainV2: {
                shape: "Sai"
              },
              version: {
                type: "long"
              },
              creationDate: {
                type: "timestamp"
              },
              lastModifiedDate: {
                type: "timestamp"
              },
              metricsExportConfig: {
                shape: "Sak"
              }
            }
          }
        },
        DescribeStream: {
          http: {
            method: "GET",
            requestUri: "/streams/{streamId}"
          },
          input: {
            type: "structure",
            required: [
              "streamId"
            ],
            members: {
              streamId: {
                location: "uri",
                locationName: "streamId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              streamInfo: {
                type: "structure",
                members: {
                  streamId: {},
                  streamArn: {},
                  streamVersion: {
                    type: "integer"
                  },
                  description: {},
                  files: {
                    shape: "Saq"
                  },
                  createdAt: {
                    type: "timestamp"
                  },
                  lastUpdatedAt: {
                    type: "timestamp"
                  },
                  roleArn: {}
                }
              }
            }
          }
        },
        DescribeThing: {
          http: {
            method: "GET",
            requestUri: "/things/{thingName}"
          },
          input: {
            type: "structure",
            required: [
              "thingName"
            ],
            members: {
              thingName: {
                location: "uri",
                locationName: "thingName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              defaultClientId: {},
              thingName: {},
              thingId: {},
              thingArn: {},
              thingTypeName: {},
              attributes: {
                shape: "S3w"
              },
              version: {
                type: "long"
              },
              billingGroupName: {}
            }
          }
        },
        DescribeThingGroup: {
          http: {
            method: "GET",
            requestUri: "/thing-groups/{thingGroupName}"
          },
          input: {
            type: "structure",
            required: [
              "thingGroupName"
            ],
            members: {
              thingGroupName: {
                location: "uri",
                locationName: "thingGroupName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              thingGroupName: {},
              thingGroupId: {},
              thingGroupArn: {},
              version: {
                type: "long"
              },
              thingGroupProperties: {
                shape: "S3t"
              },
              thingGroupMetadata: {
                type: "structure",
                members: {
                  parentGroupName: {},
                  rootToParentThingGroups: {
                    shape: "Smb"
                  },
                  creationDate: {
                    type: "timestamp"
                  }
                }
              },
              indexName: {},
              queryString: {},
              queryVersion: {},
              status: {}
            }
          }
        },
        DescribeThingRegistrationTask: {
          http: {
            method: "GET",
            requestUri: "/thing-registration-tasks/{taskId}"
          },
          input: {
            type: "structure",
            required: [
              "taskId"
            ],
            members: {
              taskId: {
                location: "uri",
                locationName: "taskId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskId: {},
              creationDate: {
                type: "timestamp"
              },
              lastModifiedDate: {
                type: "timestamp"
              },
              templateBody: {},
              inputFileBucket: {},
              inputFileKey: {},
              roleArn: {},
              status: {},
              message: {},
              successCount: {
                type: "integer"
              },
              failureCount: {
                type: "integer"
              },
              percentageProgress: {
                type: "integer"
              }
            }
          }
        },
        DescribeThingType: {
          http: {
            method: "GET",
            requestUri: "/thing-types/{thingTypeName}"
          },
          input: {
            type: "structure",
            required: [
              "thingTypeName"
            ],
            members: {
              thingTypeName: {
                location: "uri",
                locationName: "thingTypeName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              thingTypeName: {},
              thingTypeId: {},
              thingTypeArn: {},
              thingTypeProperties: {
                shape: "Sb2"
              },
              thingTypeMetadata: {
                shape: "Smo"
              }
            }
          }
        },
        DetachPolicy: {
          http: {
            requestUri: "/target-policies/{policyName}"
          },
          input: {
            type: "structure",
            required: [
              "policyName",
              "target"
            ],
            members: {
              policyName: {
                location: "uri",
                locationName: "policyName"
              },
              target: {}
            }
          }
        },
        DetachPrincipalPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/principal-policies/{policyName}"
          },
          input: {
            type: "structure",
            required: [
              "policyName",
              "principal"
            ],
            members: {
              policyName: {
                location: "uri",
                locationName: "policyName"
              },
              principal: {
                location: "header",
                locationName: "x-amzn-iot-principal"
              }
            }
          },
          deprecated: true
        },
        DetachSecurityProfile: {
          http: {
            method: "DELETE",
            requestUri: "/security-profiles/{securityProfileName}/targets"
          },
          input: {
            type: "structure",
            required: [
              "securityProfileName",
              "securityProfileTargetArn"
            ],
            members: {
              securityProfileName: {
                location: "uri",
                locationName: "securityProfileName"
              },
              securityProfileTargetArn: {
                location: "querystring",
                locationName: "securityProfileTargetArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DetachThingPrincipal: {
          http: {
            method: "DELETE",
            requestUri: "/things/{thingName}/principals"
          },
          input: {
            type: "structure",
            required: [
              "thingName",
              "principal"
            ],
            members: {
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              principal: {
                location: "header",
                locationName: "x-amzn-principal"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisableTopicRule: {
          http: {
            requestUri: "/rules/{ruleName}/disable"
          },
          input: {
            type: "structure",
            required: [
              "ruleName"
            ],
            members: {
              ruleName: {
                location: "uri",
                locationName: "ruleName"
              }
            }
          }
        },
        EnableTopicRule: {
          http: {
            requestUri: "/rules/{ruleName}/enable"
          },
          input: {
            type: "structure",
            required: [
              "ruleName"
            ],
            members: {
              ruleName: {
                location: "uri",
                locationName: "ruleName"
              }
            }
          }
        },
        GetBehaviorModelTrainingSummaries: {
          http: {
            method: "GET",
            requestUri: "/behavior-model-training/summaries"
          },
          input: {
            type: "structure",
            members: {
              securityProfileName: {
                location: "querystring",
                locationName: "securityProfileName"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              summaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    securityProfileName: {},
                    behaviorName: {},
                    trainingDataCollectionStartDate: {
                      type: "timestamp"
                    },
                    modelStatus: {},
                    datapointsCollectionPercentage: {
                      type: "double"
                    },
                    lastModelRefreshDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetBucketsAggregation: {
          http: {
            requestUri: "/indices/buckets"
          },
          input: {
            type: "structure",
            required: [
              "queryString",
              "aggregationField",
              "bucketsAggregationType"
            ],
            members: {
              indexName: {},
              queryString: {},
              aggregationField: {},
              queryVersion: {},
              bucketsAggregationType: {
                type: "structure",
                members: {
                  termsAggregation: {
                    type: "structure",
                    members: {
                      maxBuckets: {
                        type: "integer"
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              totalCount: {
                type: "integer"
              },
              buckets: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    keyValue: {},
                    count: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        GetCardinality: {
          http: {
            requestUri: "/indices/cardinality"
          },
          input: {
            type: "structure",
            required: [
              "queryString"
            ],
            members: {
              indexName: {},
              queryString: {},
              aggregationField: {},
              queryVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              cardinality: {
                type: "integer"
              }
            }
          }
        },
        GetEffectivePolicies: {
          http: {
            requestUri: "/effective-policies"
          },
          input: {
            type: "structure",
            members: {
              principal: {},
              cognitoIdentityPoolId: {},
              thingName: {
                location: "querystring",
                locationName: "thingName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              effectivePolicies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    policyName: {},
                    policyArn: {},
                    policyDocument: {}
                  }
                }
              }
            }
          }
        },
        GetIndexingConfiguration: {
          http: {
            method: "GET",
            requestUri: "/indexing/config"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              thingIndexingConfiguration: {
                shape: "Snn"
              },
              thingGroupIndexingConfiguration: {
                shape: "So3"
              }
            }
          }
        },
        GetJobDocument: {
          http: {
            method: "GET",
            requestUri: "/jobs/{jobId}/job-document"
          },
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              document: {}
            }
          }
        },
        GetLoggingOptions: {
          http: {
            method: "GET",
            requestUri: "/loggingOptions"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              roleArn: {},
              logLevel: {}
            }
          }
        },
        GetOTAUpdate: {
          http: {
            method: "GET",
            requestUri: "/otaUpdates/{otaUpdateId}"
          },
          input: {
            type: "structure",
            required: [
              "otaUpdateId"
            ],
            members: {
              otaUpdateId: {
                location: "uri",
                locationName: "otaUpdateId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              otaUpdateInfo: {
                type: "structure",
                members: {
                  otaUpdateId: {},
                  otaUpdateArn: {},
                  creationDate: {
                    type: "timestamp"
                  },
                  lastModifiedDate: {
                    type: "timestamp"
                  },
                  description: {},
                  targets: {
                    shape: "S6g"
                  },
                  protocols: {
                    shape: "S6i"
                  },
                  awsJobExecutionsRolloutConfig: {
                    shape: "S6k"
                  },
                  awsJobPresignedUrlConfig: {
                    shape: "S6r"
                  },
                  targetSelection: {},
                  otaUpdateFiles: {
                    shape: "S72"
                  },
                  otaUpdateStatus: {},
                  awsIotJobId: {},
                  awsIotJobArn: {},
                  errorInfo: {
                    type: "structure",
                    members: {
                      code: {},
                      message: {}
                    }
                  },
                  additionalParameters: {
                    shape: "S80"
                  }
                }
              }
            }
          }
        },
        GetPackage: {
          http: {
            method: "GET",
            requestUri: "/packages/{packageName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "packageName"
            ],
            members: {
              packageName: {
                location: "uri",
                locationName: "packageName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              packageName: {},
              packageArn: {},
              description: {
                shape: "S88"
              },
              defaultVersionName: {},
              creationDate: {
                type: "timestamp"
              },
              lastModifiedDate: {
                type: "timestamp"
              }
            }
          }
        },
        GetPackageConfiguration: {
          http: {
            method: "GET",
            requestUri: "/package-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              versionUpdateByJobsConfig: {
                shape: "Soj"
              }
            }
          }
        },
        GetPackageVersion: {
          http: {
            method: "GET",
            requestUri: "/packages/{packageName}/versions/{versionName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "packageName",
              "versionName"
            ],
            members: {
              packageName: {
                location: "uri",
                locationName: "packageName"
              },
              versionName: {
                location: "uri",
                locationName: "versionName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              packageVersionArn: {},
              packageName: {},
              versionName: {},
              description: {
                shape: "S88"
              },
              attributes: {
                shape: "S8e"
              },
              status: {},
              errorReason: {},
              creationDate: {
                type: "timestamp"
              },
              lastModifiedDate: {
                type: "timestamp"
              }
            }
          }
        },
        GetPercentiles: {
          http: {
            requestUri: "/indices/percentiles"
          },
          input: {
            type: "structure",
            required: [
              "queryString"
            ],
            members: {
              indexName: {},
              queryString: {},
              aggregationField: {},
              queryVersion: {},
              percents: {
                type: "list",
                member: {
                  type: "double"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              percentiles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    percent: {
                      type: "double"
                    },
                    value: {
                      type: "double"
                    }
                  }
                }
              }
            }
          }
        },
        GetPolicy: {
          http: {
            method: "GET",
            requestUri: "/policies/{policyName}"
          },
          input: {
            type: "structure",
            required: [
              "policyName"
            ],
            members: {
              policyName: {
                location: "uri",
                locationName: "policyName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              policyName: {},
              policyArn: {},
              policyDocument: {},
              defaultVersionId: {},
              creationDate: {
                type: "timestamp"
              },
              lastModifiedDate: {
                type: "timestamp"
              },
              generationId: {}
            }
          }
        },
        GetPolicyVersion: {
          http: {
            method: "GET",
            requestUri: "/policies/{policyName}/version/{policyVersionId}"
          },
          input: {
            type: "structure",
            required: [
              "policyName",
              "policyVersionId"
            ],
            members: {
              policyName: {
                location: "uri",
                locationName: "policyName"
              },
              policyVersionId: {
                location: "uri",
                locationName: "policyVersionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              policyArn: {},
              policyName: {},
              policyDocument: {},
              policyVersionId: {},
              isDefaultVersion: {
                type: "boolean"
              },
              creationDate: {
                type: "timestamp"
              },
              lastModifiedDate: {
                type: "timestamp"
              },
              generationId: {}
            }
          }
        },
        GetRegistrationCode: {
          http: {
            method: "GET",
            requestUri: "/registrationcode"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              registrationCode: {}
            }
          }
        },
        GetStatistics: {
          http: {
            requestUri: "/indices/statistics"
          },
          input: {
            type: "structure",
            required: [
              "queryString"
            ],
            members: {
              indexName: {},
              queryString: {},
              aggregationField: {},
              queryVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              statistics: {
                type: "structure",
                members: {
                  count: {
                    type: "integer"
                  },
                  average: {
                    type: "double"
                  },
                  sum: {
                    type: "double"
                  },
                  minimum: {
                    type: "double"
                  },
                  maximum: {
                    type: "double"
                  },
                  sumOfSquares: {
                    type: "double"
                  },
                  variance: {
                    type: "double"
                  },
                  stdDeviation: {
                    type: "double"
                  }
                }
              }
            }
          }
        },
        GetTopicRule: {
          http: {
            method: "GET",
            requestUri: "/rules/{ruleName}"
          },
          input: {
            type: "structure",
            required: [
              "ruleName"
            ],
            members: {
              ruleName: {
                location: "uri",
                locationName: "ruleName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ruleArn: {},
              rule: {
                type: "structure",
                members: {
                  ruleName: {},
                  sql: {},
                  description: {},
                  createdAt: {
                    type: "timestamp"
                  },
                  actions: {
                    shape: "Sbd"
                  },
                  ruleDisabled: {
                    type: "boolean"
                  },
                  awsIotSqlVersion: {},
                  errorAction: {
                    shape: "Sbe"
                  }
                }
              }
            }
          }
        },
        GetTopicRuleDestination: {
          http: {
            method: "GET",
            requestUri: "/destinations/{arn+}"
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {
                location: "uri",
                locationName: "arn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              topicRuleDestination: {
                shape: "Sex"
              }
            }
          }
        },
        GetV2LoggingOptions: {
          http: {
            method: "GET",
            requestUri: "/v2LoggingOptions"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              roleArn: {},
              defaultLogLevel: {},
              disableAllLogs: {
                type: "boolean"
              }
            }
          }
        },
        ListActiveViolations: {
          http: {
            method: "GET",
            requestUri: "/active-violations"
          },
          input: {
            type: "structure",
            members: {
              thingName: {
                location: "querystring",
                locationName: "thingName"
              },
              securityProfileName: {
                location: "querystring",
                locationName: "securityProfileName"
              },
              behaviorCriteriaType: {
                location: "querystring",
                locationName: "behaviorCriteriaType"
              },
              listSuppressedAlerts: {
                location: "querystring",
                locationName: "listSuppressedAlerts",
                type: "boolean"
              },
              verificationState: {
                location: "querystring",
                locationName: "verificationState"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              activeViolations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    violationId: {},
                    thingName: {},
                    securityProfileName: {},
                    behavior: {
                      shape: "S9n"
                    },
                    lastViolationValue: {
                      shape: "S9u"
                    },
                    violationEventAdditionalInfo: {
                      shape: "Spt"
                    },
                    verificationState: {},
                    verificationStateDescription: {},
                    lastViolationTime: {
                      type: "timestamp"
                    },
                    violationStartTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAttachedPolicies: {
          http: {
            requestUri: "/attached-policies/{target}"
          },
          input: {
            type: "structure",
            required: [
              "target"
            ],
            members: {
              target: {
                location: "uri",
                locationName: "target"
              },
              recursive: {
                location: "querystring",
                locationName: "recursive",
                type: "boolean"
              },
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              pageSize: {
                location: "querystring",
                locationName: "pageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              policies: {
                shape: "Sq0"
              },
              nextMarker: {}
            }
          }
        },
        ListAuditFindings: {
          http: {
            requestUri: "/audit/findings"
          },
          input: {
            type: "structure",
            members: {
              taskId: {},
              checkName: {},
              resourceIdentifier: {
                shape: "S1o"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              listSuppressedFindings: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              findings: {
                type: "list",
                member: {
                  shape: "Shb"
                }
              },
              nextToken: {}
            }
          }
        },
        ListAuditMitigationActionsExecutions: {
          http: {
            method: "GET",
            requestUri: "/audit/mitigationactions/executions"
          },
          input: {
            type: "structure",
            required: [
              "taskId",
              "findingId"
            ],
            members: {
              taskId: {
                location: "querystring",
                locationName: "taskId"
              },
              actionStatus: {
                location: "querystring",
                locationName: "actionStatus"
              },
              findingId: {
                location: "querystring",
                locationName: "findingId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              actionsExecutions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    taskId: {},
                    findingId: {},
                    actionName: {},
                    actionId: {},
                    status: {},
                    startTime: {
                      type: "timestamp"
                    },
                    endTime: {
                      type: "timestamp"
                    },
                    errorCode: {},
                    message: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAuditMitigationActionsTasks: {
          http: {
            method: "GET",
            requestUri: "/audit/mitigationactions/tasks"
          },
          input: {
            type: "structure",
            required: [
              "startTime",
              "endTime"
            ],
            members: {
              auditTaskId: {
                location: "querystring",
                locationName: "auditTaskId"
              },
              findingId: {
                location: "querystring",
                locationName: "findingId"
              },
              taskStatus: {
                location: "querystring",
                locationName: "taskStatus"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              startTime: {
                location: "querystring",
                locationName: "startTime",
                type: "timestamp"
              },
              endTime: {
                location: "querystring",
                locationName: "endTime",
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tasks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    taskId: {},
                    startTime: {
                      type: "timestamp"
                    },
                    taskStatus: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAuditSuppressions: {
          http: {
            requestUri: "/audit/suppressions/list"
          },
          input: {
            type: "structure",
            members: {
              checkName: {},
              resourceIdentifier: {
                shape: "S1o"
              },
              ascendingOrder: {
                type: "boolean"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              suppressions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "checkName",
                    "resourceIdentifier"
                  ],
                  members: {
                    checkName: {},
                    resourceIdentifier: {
                      shape: "S1o"
                    },
                    expirationDate: {
                      type: "timestamp"
                    },
                    suppressIndefinitely: {
                      type: "boolean"
                    },
                    description: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAuditTasks: {
          http: {
            method: "GET",
            requestUri: "/audit/tasks"
          },
          input: {
            type: "structure",
            required: [
              "startTime",
              "endTime"
            ],
            members: {
              startTime: {
                location: "querystring",
                locationName: "startTime",
                type: "timestamp"
              },
              endTime: {
                location: "querystring",
                locationName: "endTime",
                type: "timestamp"
              },
              taskType: {
                location: "querystring",
                locationName: "taskType"
              },
              taskStatus: {
                location: "querystring",
                locationName: "taskStatus"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tasks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    taskId: {},
                    taskStatus: {},
                    taskType: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAuthorizers: {
          http: {
            method: "GET",
            requestUri: "/authorizers/"
          },
          input: {
            type: "structure",
            members: {
              pageSize: {
                location: "querystring",
                locationName: "pageSize",
                type: "integer"
              },
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              ascendingOrder: {
                location: "querystring",
                locationName: "isAscendingOrder",
                type: "boolean"
              },
              status: {
                location: "querystring",
                locationName: "status"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              authorizers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    authorizerName: {},
                    authorizerArn: {}
                  }
                }
              },
              nextMarker: {}
            }
          }
        },
        ListBillingGroups: {
          http: {
            method: "GET",
            requestUri: "/billing-groups"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              namePrefixFilter: {
                location: "querystring",
                locationName: "namePrefixFilter"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              billingGroups: {
                type: "list",
                member: {
                  shape: "Smc"
                }
              },
              nextToken: {}
            }
          }
        },
        ListCACertificates: {
          http: {
            method: "GET",
            requestUri: "/cacertificates"
          },
          input: {
            type: "structure",
            members: {
              pageSize: {
                location: "querystring",
                locationName: "pageSize",
                type: "integer"
              },
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              ascendingOrder: {
                location: "querystring",
                locationName: "isAscendingOrder",
                type: "boolean"
              },
              templateName: {
                location: "querystring",
                locationName: "templateName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              certificates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    certificateArn: {},
                    certificateId: {},
                    status: {},
                    creationDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextMarker: {}
            }
          }
        },
        ListCertificateProviders: {
          http: {
            method: "GET",
            requestUri: "/certificate-providers/"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              ascendingOrder: {
                location: "querystring",
                locationName: "isAscendingOrder",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              certificateProviders: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    certificateProviderName: {},
                    certificateProviderArn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListCertificates: {
          http: {
            method: "GET",
            requestUri: "/certificates"
          },
          input: {
            type: "structure",
            members: {
              pageSize: {
                location: "querystring",
                locationName: "pageSize",
                type: "integer"
              },
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              ascendingOrder: {
                location: "querystring",
                locationName: "isAscendingOrder",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              certificates: {
                shape: "Sr6"
              },
              nextMarker: {}
            }
          }
        },
        ListCertificatesByCA: {
          http: {
            method: "GET",
            requestUri: "/certificates-by-ca/{caCertificateId}"
          },
          input: {
            type: "structure",
            required: [
              "caCertificateId"
            ],
            members: {
              caCertificateId: {
                location: "uri",
                locationName: "caCertificateId"
              },
              pageSize: {
                location: "querystring",
                locationName: "pageSize",
                type: "integer"
              },
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              ascendingOrder: {
                location: "querystring",
                locationName: "isAscendingOrder",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              certificates: {
                shape: "Sr6"
              },
              nextMarker: {}
            }
          }
        },
        ListCustomMetrics: {
          http: {
            method: "GET",
            requestUri: "/custom-metrics"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              metricNames: {
                type: "list",
                member: {}
              },
              nextToken: {}
            }
          }
        },
        ListDetectMitigationActionsExecutions: {
          http: {
            method: "GET",
            requestUri: "/detect/mitigationactions/executions"
          },
          input: {
            type: "structure",
            members: {
              taskId: {
                location: "querystring",
                locationName: "taskId"
              },
              violationId: {
                location: "querystring",
                locationName: "violationId"
              },
              thingName: {
                location: "querystring",
                locationName: "thingName"
              },
              startTime: {
                location: "querystring",
                locationName: "startTime",
                type: "timestamp"
              },
              endTime: {
                location: "querystring",
                locationName: "endTime",
                type: "timestamp"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              actionsExecutions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    taskId: {},
                    violationId: {},
                    actionName: {},
                    thingName: {},
                    executionStartDate: {
                      type: "timestamp"
                    },
                    executionEndDate: {
                      type: "timestamp"
                    },
                    status: {},
                    errorCode: {},
                    message: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDetectMitigationActionsTasks: {
          http: {
            method: "GET",
            requestUri: "/detect/mitigationactions/tasks"
          },
          input: {
            type: "structure",
            required: [
              "startTime",
              "endTime"
            ],
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              startTime: {
                location: "querystring",
                locationName: "startTime",
                type: "timestamp"
              },
              endTime: {
                location: "querystring",
                locationName: "endTime",
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tasks: {
                type: "list",
                member: {
                  shape: "Sjm"
                }
              },
              nextToken: {}
            }
          }
        },
        ListDimensions: {
          http: {
            method: "GET",
            requestUri: "/dimensions"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              dimensionNames: {
                type: "list",
                member: {}
              },
              nextToken: {}
            }
          }
        },
        ListDomainConfigurations: {
          http: {
            method: "GET",
            requestUri: "/domainConfigurations"
          },
          input: {
            type: "structure",
            members: {
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              pageSize: {
                location: "querystring",
                locationName: "pageSize",
                type: "integer"
              },
              serviceType: {
                location: "querystring",
                locationName: "serviceType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              domainConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    domainConfigurationName: {},
                    domainConfigurationArn: {},
                    serviceType: {}
                  }
                }
              },
              nextMarker: {}
            }
          }
        },
        ListFleetMetrics: {
          http: {
            method: "GET",
            requestUri: "/fleet-metrics"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              fleetMetrics: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    metricName: {},
                    metricArn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListIndices: {
          http: {
            method: "GET",
            requestUri: "/indices"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              indexNames: {
                type: "list",
                member: {}
              },
              nextToken: {}
            }
          }
        },
        ListJobExecutionsForJob: {
          http: {
            method: "GET",
            requestUri: "/jobs/{jobId}/things"
          },
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              status: {
                location: "querystring",
                locationName: "status"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              executionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    thingArn: {},
                    jobExecutionSummary: {
                      shape: "Ss6"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListJobExecutionsForThing: {
          http: {
            method: "GET",
            requestUri: "/things/{thingName}/jobs"
          },
          input: {
            type: "structure",
            required: [
              "thingName"
            ],
            members: {
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              status: {
                location: "querystring",
                locationName: "status"
              },
              namespaceId: {
                location: "querystring",
                locationName: "namespaceId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              jobId: {
                location: "querystring",
                locationName: "jobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              executionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    jobId: {},
                    jobExecutionSummary: {
                      shape: "Ss6"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListJobTemplates: {
          http: {
            method: "GET",
            requestUri: "/job-templates"
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobTemplates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    jobTemplateArn: {},
                    jobTemplateId: {},
                    description: {},
                    createdAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListJobs: {
          http: {
            method: "GET",
            requestUri: "/jobs"
          },
          input: {
            type: "structure",
            members: {
              status: {
                location: "querystring",
                locationName: "status"
              },
              targetSelection: {
                location: "querystring",
                locationName: "targetSelection"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              thingGroupName: {
                location: "querystring",
                locationName: "thingGroupName"
              },
              thingGroupId: {
                location: "querystring",
                locationName: "thingGroupId"
              },
              namespaceId: {
                location: "querystring",
                locationName: "namespaceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    jobArn: {},
                    jobId: {},
                    thingGroupId: {},
                    targetSelection: {},
                    status: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    completedAt: {
                      type: "timestamp"
                    },
                    isConcurrent: {
                      type: "boolean"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListManagedJobTemplates: {
          http: {
            method: "GET",
            requestUri: "/managed-job-templates"
          },
          input: {
            type: "structure",
            members: {
              templateName: {
                location: "querystring",
                locationName: "templateName"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              managedJobTemplates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    templateArn: {},
                    templateName: {},
                    description: {},
                    environments: {
                      shape: "Sli"
                    },
                    templateVersion: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListMetricValues: {
          http: {
            method: "GET",
            requestUri: "/metric-values"
          },
          input: {
            type: "structure",
            required: [
              "thingName",
              "metricName",
              "startTime",
              "endTime"
            ],
            members: {
              thingName: {
                location: "querystring",
                locationName: "thingName"
              },
              metricName: {
                location: "querystring",
                locationName: "metricName"
              },
              dimensionName: {
                location: "querystring",
                locationName: "dimensionName"
              },
              dimensionValueOperator: {
                location: "querystring",
                locationName: "dimensionValueOperator"
              },
              startTime: {
                location: "querystring",
                locationName: "startTime",
                type: "timestamp"
              },
              endTime: {
                location: "querystring",
                locationName: "endTime",
                type: "timestamp"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              metricDatumList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    timestamp: {
                      type: "timestamp"
                    },
                    value: {
                      shape: "S9u"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListMitigationActions: {
          http: {
            method: "GET",
            requestUri: "/mitigationactions/actions"
          },
          input: {
            type: "structure",
            members: {
              actionType: {
                location: "querystring",
                locationName: "actionType"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              actionIdentifiers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    actionName: {},
                    actionArn: {},
                    creationDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListOTAUpdates: {
          http: {
            method: "GET",
            requestUri: "/otaUpdates"
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              otaUpdateStatus: {
                location: "querystring",
                locationName: "otaUpdateStatus"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              otaUpdates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    otaUpdateId: {},
                    otaUpdateArn: {},
                    creationDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListOutgoingCertificates: {
          http: {
            method: "GET",
            requestUri: "/certificates-out-going"
          },
          input: {
            type: "structure",
            members: {
              pageSize: {
                location: "querystring",
                locationName: "pageSize",
                type: "integer"
              },
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              ascendingOrder: {
                location: "querystring",
                locationName: "isAscendingOrder",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              outgoingCertificates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    certificateArn: {},
                    certificateId: {},
                    transferredTo: {},
                    transferDate: {
                      type: "timestamp"
                    },
                    transferMessage: {},
                    creationDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextMarker: {}
            }
          }
        },
        ListPackageVersions: {
          http: {
            method: "GET",
            requestUri: "/packages/{packageName}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "packageName"
            ],
            members: {
              packageName: {
                location: "uri",
                locationName: "packageName"
              },
              status: {
                location: "querystring",
                locationName: "status"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              packageVersionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    packageName: {},
                    versionName: {},
                    status: {},
                    creationDate: {
                      type: "timestamp"
                    },
                    lastModifiedDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListPackages: {
          http: {
            method: "GET",
            requestUri: "/packages",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              packageSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    packageName: {},
                    defaultVersionName: {},
                    creationDate: {
                      type: "timestamp"
                    },
                    lastModifiedDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListPolicies: {
          http: {
            method: "GET",
            requestUri: "/policies"
          },
          input: {
            type: "structure",
            members: {
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              pageSize: {
                location: "querystring",
                locationName: "pageSize",
                type: "integer"
              },
              ascendingOrder: {
                location: "querystring",
                locationName: "isAscendingOrder",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              policies: {
                shape: "Sq0"
              },
              nextMarker: {}
            }
          }
        },
        ListPolicyPrincipals: {
          http: {
            method: "GET",
            requestUri: "/policy-principals"
          },
          input: {
            type: "structure",
            required: [
              "policyName"
            ],
            members: {
              policyName: {
                location: "header",
                locationName: "x-amzn-iot-policy"
              },
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              pageSize: {
                location: "querystring",
                locationName: "pageSize",
                type: "integer"
              },
              ascendingOrder: {
                location: "querystring",
                locationName: "isAscendingOrder",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              principals: {
                shape: "Sth"
              },
              nextMarker: {}
            }
          },
          deprecated: true
        },
        ListPolicyVersions: {
          http: {
            method: "GET",
            requestUri: "/policies/{policyName}/version"
          },
          input: {
            type: "structure",
            required: [
              "policyName"
            ],
            members: {
              policyName: {
                location: "uri",
                locationName: "policyName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              policyVersions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    versionId: {},
                    isDefaultVersion: {
                      type: "boolean"
                    },
                    createDate: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListPrincipalPolicies: {
          http: {
            method: "GET",
            requestUri: "/principal-policies"
          },
          input: {
            type: "structure",
            required: [
              "principal"
            ],
            members: {
              principal: {
                location: "header",
                locationName: "x-amzn-iot-principal"
              },
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              pageSize: {
                location: "querystring",
                locationName: "pageSize",
                type: "integer"
              },
              ascendingOrder: {
                location: "querystring",
                locationName: "isAscendingOrder",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              policies: {
                shape: "Sq0"
              },
              nextMarker: {}
            }
          },
          deprecated: true
        },
        ListPrincipalThings: {
          http: {
            method: "GET",
            requestUri: "/principals/things"
          },
          input: {
            type: "structure",
            required: [
              "principal"
            ],
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              principal: {
                location: "header",
                locationName: "x-amzn-principal"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              things: {
                shape: "Str"
              },
              nextToken: {}
            }
          }
        },
        ListProvisioningTemplateVersions: {
          http: {
            method: "GET",
            requestUri: "/provisioning-templates/{templateName}/versions"
          },
          input: {
            type: "structure",
            required: [
              "templateName"
            ],
            members: {
              templateName: {
                location: "uri",
                locationName: "templateName"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              versions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    versionId: {
                      type: "integer"
                    },
                    creationDate: {
                      type: "timestamp"
                    },
                    isDefaultVersion: {
                      type: "boolean"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListProvisioningTemplates: {
          http: {
            method: "GET",
            requestUri: "/provisioning-templates"
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              templates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    templateArn: {},
                    templateName: {},
                    description: {},
                    creationDate: {
                      type: "timestamp"
                    },
                    lastModifiedDate: {
                      type: "timestamp"
                    },
                    enabled: {
                      type: "boolean"
                    },
                    type: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListRelatedResourcesForAuditFinding: {
          http: {
            method: "GET",
            requestUri: "/audit/relatedResources"
          },
          input: {
            type: "structure",
            required: [
              "findingId"
            ],
            members: {
              findingId: {
                location: "querystring",
                locationName: "findingId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              relatedResources: {
                shape: "Shg"
              },
              nextToken: {}
            }
          }
        },
        ListRoleAliases: {
          http: {
            method: "GET",
            requestUri: "/role-aliases"
          },
          input: {
            type: "structure",
            members: {
              pageSize: {
                location: "querystring",
                locationName: "pageSize",
                type: "integer"
              },
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              ascendingOrder: {
                location: "querystring",
                locationName: "isAscendingOrder",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              roleAliases: {
                type: "list",
                member: {}
              },
              nextMarker: {}
            }
          }
        },
        ListScheduledAudits: {
          http: {
            method: "GET",
            requestUri: "/audit/scheduledaudits"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              scheduledAudits: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    scheduledAuditName: {},
                    scheduledAuditArn: {},
                    frequency: {},
                    dayOfMonth: {},
                    dayOfWeek: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSecurityProfiles: {
          http: {
            method: "GET",
            requestUri: "/security-profiles"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              dimensionName: {
                location: "querystring",
                locationName: "dimensionName"
              },
              metricName: {
                location: "querystring",
                locationName: "metricName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              securityProfileIdentifiers: {
                type: "list",
                member: {
                  shape: "Suc"
                }
              },
              nextToken: {}
            }
          }
        },
        ListSecurityProfilesForTarget: {
          http: {
            method: "GET",
            requestUri: "/security-profiles-for-target"
          },
          input: {
            type: "structure",
            required: [
              "securityProfileTargetArn"
            ],
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              recursive: {
                location: "querystring",
                locationName: "recursive",
                type: "boolean"
              },
              securityProfileTargetArn: {
                location: "querystring",
                locationName: "securityProfileTargetArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              securityProfileTargetMappings: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    securityProfileIdentifier: {
                      shape: "Suc"
                    },
                    target: {
                      shape: "Suh"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListStreams: {
          http: {
            method: "GET",
            requestUri: "/streams"
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              ascendingOrder: {
                location: "querystring",
                locationName: "isAscendingOrder",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              streams: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    streamId: {},
                    streamArn: {},
                    streamVersion: {
                      type: "integer"
                    },
                    description: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S2e"
              },
              nextToken: {}
            }
          }
        },
        ListTargetsForPolicy: {
          http: {
            requestUri: "/policy-targets/{policyName}"
          },
          input: {
            type: "structure",
            required: [
              "policyName"
            ],
            members: {
              policyName: {
                location: "uri",
                locationName: "policyName"
              },
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              pageSize: {
                location: "querystring",
                locationName: "pageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              targets: {
                type: "list",
                member: {}
              },
              nextMarker: {}
            }
          }
        },
        ListTargetsForSecurityProfile: {
          http: {
            method: "GET",
            requestUri: "/security-profiles/{securityProfileName}/targets"
          },
          input: {
            type: "structure",
            required: [
              "securityProfileName"
            ],
            members: {
              securityProfileName: {
                location: "uri",
                locationName: "securityProfileName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              securityProfileTargets: {
                type: "list",
                member: {
                  shape: "Suh"
                }
              },
              nextToken: {}
            }
          }
        },
        ListThingGroups: {
          http: {
            method: "GET",
            requestUri: "/thing-groups"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              parentGroup: {
                location: "querystring",
                locationName: "parentGroup"
              },
              namePrefixFilter: {
                location: "querystring",
                locationName: "namePrefixFilter"
              },
              recursive: {
                location: "querystring",
                locationName: "recursive",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              thingGroups: {
                shape: "Smb"
              },
              nextToken: {}
            }
          }
        },
        ListThingGroupsForThing: {
          http: {
            method: "GET",
            requestUri: "/things/{thingName}/thing-groups"
          },
          input: {
            type: "structure",
            required: [
              "thingName"
            ],
            members: {
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              thingGroups: {
                shape: "Smb"
              },
              nextToken: {}
            }
          }
        },
        ListThingPrincipals: {
          http: {
            method: "GET",
            requestUri: "/things/{thingName}/principals"
          },
          input: {
            type: "structure",
            required: [
              "thingName"
            ],
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              thingName: {
                location: "uri",
                locationName: "thingName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              principals: {
                shape: "Sth"
              },
              nextToken: {}
            }
          }
        },
        ListThingRegistrationTaskReports: {
          http: {
            method: "GET",
            requestUri: "/thing-registration-tasks/{taskId}/reports"
          },
          input: {
            type: "structure",
            required: [
              "taskId",
              "reportType"
            ],
            members: {
              taskId: {
                location: "uri",
                locationName: "taskId"
              },
              reportType: {
                location: "querystring",
                locationName: "reportType"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resourceLinks: {
                type: "list",
                member: {}
              },
              reportType: {},
              nextToken: {}
            }
          }
        },
        ListThingRegistrationTasks: {
          http: {
            method: "GET",
            requestUri: "/thing-registration-tasks"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              status: {
                location: "querystring",
                locationName: "status"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskIds: {
                type: "list",
                member: {}
              },
              nextToken: {}
            }
          }
        },
        ListThingTypes: {
          http: {
            method: "GET",
            requestUri: "/thing-types"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              thingTypeName: {
                location: "querystring",
                locationName: "thingTypeName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              thingTypes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    thingTypeName: {},
                    thingTypeArn: {},
                    thingTypeProperties: {
                      shape: "Sb2"
                    },
                    thingTypeMetadata: {
                      shape: "Smo"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListThings: {
          http: {
            method: "GET",
            requestUri: "/things"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              attributeName: {
                location: "querystring",
                locationName: "attributeName"
              },
              attributeValue: {
                location: "querystring",
                locationName: "attributeValue"
              },
              thingTypeName: {
                location: "querystring",
                locationName: "thingTypeName"
              },
              usePrefixAttributeValue: {
                location: "querystring",
                locationName: "usePrefixAttributeValue",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              things: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    thingName: {},
                    thingTypeName: {},
                    thingArn: {},
                    attributes: {
                      shape: "S3w"
                    },
                    version: {
                      type: "long"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListThingsInBillingGroup: {
          http: {
            method: "GET",
            requestUri: "/billing-groups/{billingGroupName}/things"
          },
          input: {
            type: "structure",
            required: [
              "billingGroupName"
            ],
            members: {
              billingGroupName: {
                location: "uri",
                locationName: "billingGroupName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              things: {
                shape: "Str"
              },
              nextToken: {}
            }
          }
        },
        ListThingsInThingGroup: {
          http: {
            method: "GET",
            requestUri: "/thing-groups/{thingGroupName}/things"
          },
          input: {
            type: "structure",
            required: [
              "thingGroupName"
            ],
            members: {
              thingGroupName: {
                location: "uri",
                locationName: "thingGroupName"
              },
              recursive: {
                location: "querystring",
                locationName: "recursive",
                type: "boolean"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              things: {
                shape: "Str"
              },
              nextToken: {}
            }
          }
        },
        ListTopicRuleDestinations: {
          http: {
            method: "GET",
            requestUri: "/destinations"
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              destinationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    status: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    statusReason: {},
                    httpUrlSummary: {
                      type: "structure",
                      members: {
                        confirmationUrl: {}
                      }
                    },
                    vpcDestinationSummary: {
                      type: "structure",
                      members: {
                        subnetIds: {
                          shape: "Ser"
                        },
                        securityGroups: {
                          shape: "Set"
                        },
                        vpcId: {},
                        roleArn: {}
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTopicRules: {
          http: {
            method: "GET",
            requestUri: "/rules"
          },
          input: {
            type: "structure",
            members: {
              topic: {
                location: "querystring",
                locationName: "topic"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              ruleDisabled: {
                location: "querystring",
                locationName: "ruleDisabled",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              rules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ruleArn: {},
                    ruleName: {},
                    topicPattern: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    ruleDisabled: {
                      type: "boolean"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListV2LoggingLevels: {
          http: {
            method: "GET",
            requestUri: "/v2LoggingLevel"
          },
          input: {
            type: "structure",
            members: {
              targetType: {
                location: "querystring",
                locationName: "targetType"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              logTargetConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    logTarget: {
                      shape: "Sw5"
                    },
                    logLevel: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListViolationEvents: {
          http: {
            method: "GET",
            requestUri: "/violation-events"
          },
          input: {
            type: "structure",
            required: [
              "startTime",
              "endTime"
            ],
            members: {
              startTime: {
                location: "querystring",
                locationName: "startTime",
                type: "timestamp"
              },
              endTime: {
                location: "querystring",
                locationName: "endTime",
                type: "timestamp"
              },
              thingName: {
                location: "querystring",
                locationName: "thingName"
              },
              securityProfileName: {
                location: "querystring",
                locationName: "securityProfileName"
              },
              behaviorCriteriaType: {
                location: "querystring",
                locationName: "behaviorCriteriaType"
              },
              listSuppressedAlerts: {
                location: "querystring",
                locationName: "listSuppressedAlerts",
                type: "boolean"
              },
              verificationState: {
                location: "querystring",
                locationName: "verificationState"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              violationEvents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    violationId: {},
                    thingName: {},
                    securityProfileName: {},
                    behavior: {
                      shape: "S9n"
                    },
                    metricValue: {
                      shape: "S9u"
                    },
                    violationEventAdditionalInfo: {
                      shape: "Spt"
                    },
                    violationEventType: {},
                    verificationState: {},
                    verificationStateDescription: {},
                    violationEventTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        PutVerificationStateOnViolation: {
          http: {
            requestUri: "/violations/verification-state/{violationId}"
          },
          input: {
            type: "structure",
            required: [
              "violationId",
              "verificationState"
            ],
            members: {
              violationId: {
                location: "uri",
                locationName: "violationId"
              },
              verificationState: {},
              verificationStateDescription: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RegisterCACertificate: {
          http: {
            requestUri: "/cacertificate"
          },
          input: {
            type: "structure",
            required: [
              "caCertificate"
            ],
            members: {
              caCertificate: {},
              verificationCertificate: {},
              setAsActive: {
                location: "querystring",
                locationName: "setAsActive",
                type: "boolean"
              },
              allowAutoRegistration: {
                location: "querystring",
                locationName: "allowAutoRegistration",
                type: "boolean"
              },
              registrationConfig: {
                shape: "Sj7"
              },
              tags: {
                shape: "S2e"
              },
              certificateMode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              certificateArn: {},
              certificateId: {}
            }
          }
        },
        RegisterCertificate: {
          http: {
            requestUri: "/certificate/register"
          },
          input: {
            type: "structure",
            required: [
              "certificatePem"
            ],
            members: {
              certificatePem: {},
              caCertificatePem: {},
              setAsActive: {
                deprecated: true,
                location: "querystring",
                locationName: "setAsActive",
                type: "boolean"
              },
              status: {}
            }
          },
          output: {
            type: "structure",
            members: {
              certificateArn: {},
              certificateId: {}
            }
          }
        },
        RegisterCertificateWithoutCA: {
          http: {
            requestUri: "/certificate/register-no-ca"
          },
          input: {
            type: "structure",
            required: [
              "certificatePem"
            ],
            members: {
              certificatePem: {},
              status: {}
            }
          },
          output: {
            type: "structure",
            members: {
              certificateArn: {},
              certificateId: {}
            }
          }
        },
        RegisterThing: {
          http: {
            requestUri: "/things"
          },
          input: {
            type: "structure",
            required: [
              "templateBody"
            ],
            members: {
              templateBody: {},
              parameters: {
                type: "map",
                key: {},
                value: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              certificatePem: {},
              resourceArns: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        RejectCertificateTransfer: {
          http: {
            method: "PATCH",
            requestUri: "/reject-certificate-transfer/{certificateId}"
          },
          input: {
            type: "structure",
            required: [
              "certificateId"
            ],
            members: {
              certificateId: {
                location: "uri",
                locationName: "certificateId"
              },
              rejectReason: {}
            }
          }
        },
        RemoveThingFromBillingGroup: {
          http: {
            method: "PUT",
            requestUri: "/billing-groups/removeThingFromBillingGroup"
          },
          input: {
            type: "structure",
            members: {
              billingGroupName: {},
              billingGroupArn: {},
              thingName: {},
              thingArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RemoveThingFromThingGroup: {
          http: {
            method: "PUT",
            requestUri: "/thing-groups/removeThingFromThingGroup"
          },
          input: {
            type: "structure",
            members: {
              thingGroupName: {},
              thingGroupArn: {},
              thingName: {},
              thingArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ReplaceTopicRule: {
          http: {
            method: "PATCH",
            requestUri: "/rules/{ruleName}"
          },
          input: {
            type: "structure",
            required: [
              "ruleName",
              "topicRulePayload"
            ],
            members: {
              ruleName: {
                location: "uri",
                locationName: "ruleName"
              },
              topicRulePayload: {
                shape: "Sba"
              }
            },
            payload: "topicRulePayload"
          }
        },
        SearchIndex: {
          http: {
            requestUri: "/indices/search"
          },
          input: {
            type: "structure",
            required: [
              "queryString"
            ],
            members: {
              indexName: {},
              queryString: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              queryVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              things: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    thingName: {},
                    thingId: {},
                    thingTypeName: {},
                    thingGroupNames: {
                      shape: "Sx1"
                    },
                    attributes: {
                      shape: "S3w"
                    },
                    shadow: {},
                    deviceDefender: {},
                    connectivity: {
                      type: "structure",
                      members: {
                        connected: {
                          type: "boolean"
                        },
                        timestamp: {
                          type: "long"
                        },
                        disconnectReason: {}
                      }
                    }
                  }
                }
              },
              thingGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    thingGroupName: {},
                    thingGroupId: {},
                    thingGroupDescription: {},
                    attributes: {
                      shape: "S3w"
                    },
                    parentGroupNames: {
                      shape: "Sx1"
                    }
                  }
                }
              }
            }
          }
        },
        SetDefaultAuthorizer: {
          http: {
            requestUri: "/default-authorizer"
          },
          input: {
            type: "structure",
            required: [
              "authorizerName"
            ],
            members: {
              authorizerName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              authorizerName: {},
              authorizerArn: {}
            }
          }
        },
        SetDefaultPolicyVersion: {
          http: {
            method: "PATCH",
            requestUri: "/policies/{policyName}/version/{policyVersionId}"
          },
          input: {
            type: "structure",
            required: [
              "policyName",
              "policyVersionId"
            ],
            members: {
              policyName: {
                location: "uri",
                locationName: "policyName"
              },
              policyVersionId: {
                location: "uri",
                locationName: "policyVersionId"
              }
            }
          }
        },
        SetLoggingOptions: {
          http: {
            requestUri: "/loggingOptions"
          },
          input: {
            type: "structure",
            required: [
              "loggingOptionsPayload"
            ],
            members: {
              loggingOptionsPayload: {
                type: "structure",
                required: [
                  "roleArn"
                ],
                members: {
                  roleArn: {},
                  logLevel: {}
                }
              }
            },
            payload: "loggingOptionsPayload"
          }
        },
        SetV2LoggingLevel: {
          http: {
            requestUri: "/v2LoggingLevel"
          },
          input: {
            type: "structure",
            required: [
              "logTarget",
              "logLevel"
            ],
            members: {
              logTarget: {
                shape: "Sw5"
              },
              logLevel: {}
            }
          }
        },
        SetV2LoggingOptions: {
          http: {
            requestUri: "/v2LoggingOptions"
          },
          input: {
            type: "structure",
            members: {
              roleArn: {},
              defaultLogLevel: {},
              disableAllLogs: {
                type: "boolean"
              }
            }
          }
        },
        StartAuditMitigationActionsTask: {
          http: {
            requestUri: "/audit/mitigationactions/tasks/{taskId}"
          },
          input: {
            type: "structure",
            required: [
              "taskId",
              "target",
              "auditCheckToActionsMapping",
              "clientRequestToken"
            ],
            members: {
              taskId: {
                location: "uri",
                locationName: "taskId"
              },
              target: {
                shape: "Shv"
              },
              auditCheckToActionsMapping: {
                shape: "Shz"
              },
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskId: {}
            }
          }
        },
        StartDetectMitigationActionsTask: {
          http: {
            method: "PUT",
            requestUri: "/detect/mitigationactions/tasks/{taskId}"
          },
          input: {
            type: "structure",
            required: [
              "taskId",
              "target",
              "actions",
              "clientRequestToken"
            ],
            members: {
              taskId: {
                location: "uri",
                locationName: "taskId"
              },
              target: {
                shape: "Sjo"
              },
              actions: {
                type: "list",
                member: {}
              },
              violationEventOccurrenceRange: {
                shape: "Sjr"
              },
              includeOnlyActiveViolations: {
                type: "boolean"
              },
              includeSuppressedAlerts: {
                type: "boolean"
              },
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskId: {}
            }
          }
        },
        StartOnDemandAuditTask: {
          http: {
            requestUri: "/audit/tasks"
          },
          input: {
            type: "structure",
            required: [
              "targetCheckNames"
            ],
            members: {
              targetCheckNames: {
                shape: "S9g"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskId: {}
            }
          }
        },
        StartThingRegistrationTask: {
          http: {
            requestUri: "/thing-registration-tasks"
          },
          input: {
            type: "structure",
            required: [
              "templateBody",
              "inputFileBucket",
              "inputFileKey",
              "roleArn"
            ],
            members: {
              templateBody: {},
              inputFileBucket: {},
              inputFileKey: {},
              roleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              taskId: {}
            }
          }
        },
        StopThingRegistrationTask: {
          http: {
            method: "PUT",
            requestUri: "/thing-registration-tasks/{taskId}/cancel"
          },
          input: {
            type: "structure",
            required: [
              "taskId"
            ],
            members: {
              taskId: {
                location: "uri",
                locationName: "taskId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "S2e"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TestAuthorization: {
          http: {
            requestUri: "/test-authorization"
          },
          input: {
            type: "structure",
            required: [
              "authInfos"
            ],
            members: {
              principal: {},
              cognitoIdentityPoolId: {},
              authInfos: {
                type: "list",
                member: {
                  shape: "Sxu"
                }
              },
              clientId: {
                location: "querystring",
                locationName: "clientId"
              },
              policyNamesToAdd: {
                shape: "Sxy"
              },
              policyNamesToSkip: {
                shape: "Sxy"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              authResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    authInfo: {
                      shape: "Sxu"
                    },
                    allowed: {
                      type: "structure",
                      members: {
                        policies: {
                          shape: "Sq0"
                        }
                      }
                    },
                    denied: {
                      type: "structure",
                      members: {
                        implicitDeny: {
                          type: "structure",
                          members: {
                            policies: {
                              shape: "Sq0"
                            }
                          }
                        },
                        explicitDeny: {
                          type: "structure",
                          members: {
                            policies: {
                              shape: "Sq0"
                            }
                          }
                        }
                      }
                    },
                    authDecision: {},
                    missingContextValues: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              }
            }
          }
        },
        TestInvokeAuthorizer: {
          http: {
            requestUri: "/authorizer/{authorizerName}/test"
          },
          input: {
            type: "structure",
            required: [
              "authorizerName"
            ],
            members: {
              authorizerName: {
                location: "uri",
                locationName: "authorizerName"
              },
              token: {},
              tokenSignature: {},
              httpContext: {
                type: "structure",
                members: {
                  headers: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  queryString: {}
                }
              },
              mqttContext: {
                type: "structure",
                members: {
                  username: {},
                  password: {
                    type: "blob"
                  },
                  clientId: {}
                }
              },
              tlsContext: {
                type: "structure",
                members: {
                  serverName: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              isAuthenticated: {
                type: "boolean"
              },
              principalId: {},
              policyDocuments: {
                type: "list",
                member: {}
              },
              refreshAfterInSeconds: {
                type: "integer"
              },
              disconnectAfterInSeconds: {
                type: "integer"
              }
            }
          }
        },
        TransferCertificate: {
          http: {
            method: "PATCH",
            requestUri: "/transfer-certificate/{certificateId}"
          },
          input: {
            type: "structure",
            required: [
              "certificateId",
              "targetAwsAccount"
            ],
            members: {
              certificateId: {
                location: "uri",
                locationName: "certificateId"
              },
              targetAwsAccount: {
                location: "querystring",
                locationName: "targetAwsAccount"
              },
              transferMessage: {}
            }
          },
          output: {
            type: "structure",
            members: {
              transferredCertificateArn: {}
            }
          }
        },
        UntagResource: {
          http: {
            requestUri: "/untag"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAccountAuditConfiguration: {
          http: {
            method: "PATCH",
            requestUri: "/audit/configuration"
          },
          input: {
            type: "structure",
            members: {
              roleArn: {},
              auditNotificationTargetConfigurations: {
                shape: "Sh3"
              },
              auditCheckConfigurations: {
                shape: "Sh6"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAuditSuppression: {
          http: {
            method: "PATCH",
            requestUri: "/audit/suppressions/update"
          },
          input: {
            type: "structure",
            required: [
              "checkName",
              "resourceIdentifier"
            ],
            members: {
              checkName: {},
              resourceIdentifier: {
                shape: "S1o"
              },
              expirationDate: {
                type: "timestamp"
              },
              suppressIndefinitely: {
                type: "boolean"
              },
              description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAuthorizer: {
          http: {
            method: "PUT",
            requestUri: "/authorizer/{authorizerName}"
          },
          input: {
            type: "structure",
            required: [
              "authorizerName"
            ],
            members: {
              authorizerName: {
                location: "uri",
                locationName: "authorizerName"
              },
              authorizerFunctionArn: {},
              tokenKeyName: {},
              tokenSigningPublicKeys: {
                shape: "S2a"
              },
              status: {},
              enableCachingForHttp: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              authorizerName: {},
              authorizerArn: {}
            }
          }
        },
        UpdateBillingGroup: {
          http: {
            method: "PATCH",
            requestUri: "/billing-groups/{billingGroupName}"
          },
          input: {
            type: "structure",
            required: [
              "billingGroupName",
              "billingGroupProperties"
            ],
            members: {
              billingGroupName: {
                location: "uri",
                locationName: "billingGroupName"
              },
              billingGroupProperties: {
                shape: "S2n"
              },
              expectedVersion: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              version: {
                type: "long"
              }
            }
          }
        },
        UpdateCACertificate: {
          http: {
            method: "PUT",
            requestUri: "/cacertificate/{caCertificateId}"
          },
          input: {
            type: "structure",
            required: [
              "certificateId"
            ],
            members: {
              certificateId: {
                location: "uri",
                locationName: "caCertificateId"
              },
              newStatus: {
                location: "querystring",
                locationName: "newStatus"
              },
              newAutoRegistrationStatus: {
                location: "querystring",
                locationName: "newAutoRegistrationStatus"
              },
              registrationConfig: {
                shape: "Sj7"
              },
              removeAutoRegistration: {
                type: "boolean"
              }
            }
          }
        },
        UpdateCertificate: {
          http: {
            method: "PUT",
            requestUri: "/certificates/{certificateId}"
          },
          input: {
            type: "structure",
            required: [
              "certificateId",
              "newStatus"
            ],
            members: {
              certificateId: {
                location: "uri",
                locationName: "certificateId"
              },
              newStatus: {
                location: "querystring",
                locationName: "newStatus"
              }
            }
          }
        },
        UpdateCertificateProvider: {
          http: {
            method: "PUT",
            requestUri: "/certificate-providers/{certificateProviderName}"
          },
          input: {
            type: "structure",
            required: [
              "certificateProviderName"
            ],
            members: {
              certificateProviderName: {
                location: "uri",
                locationName: "certificateProviderName"
              },
              lambdaFunctionArn: {},
              accountDefaultForOperations: {
                shape: "S2y"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              certificateProviderName: {},
              certificateProviderArn: {}
            }
          }
        },
        UpdateCustomMetric: {
          http: {
            method: "PATCH",
            requestUri: "/custom-metric/{metricName}"
          },
          input: {
            type: "structure",
            required: [
              "metricName",
              "displayName"
            ],
            members: {
              metricName: {
                location: "uri",
                locationName: "metricName"
              },
              displayName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              metricName: {},
              metricArn: {},
              metricType: {},
              displayName: {},
              creationDate: {
                type: "timestamp"
              },
              lastModifiedDate: {
                type: "timestamp"
              }
            }
          }
        },
        UpdateDimension: {
          http: {
            method: "PATCH",
            requestUri: "/dimensions/{name}"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "stringValues"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              stringValues: {
                shape: "S3c"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              arn: {},
              type: {},
              stringValues: {
                shape: "S3c"
              },
              creationDate: {
                type: "timestamp"
              },
              lastModifiedDate: {
                type: "timestamp"
              }
            }
          }
        },
        UpdateDomainConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/domainConfigurations/{domainConfigurationName}"
          },
          input: {
            type: "structure",
            required: [
              "domainConfigurationName"
            ],
            members: {
              domainConfigurationName: {
                location: "uri",
                locationName: "domainConfigurationName"
              },
              authorizerConfig: {
                shape: "S3l"
              },
              domainConfigurationStatus: {},
              removeAuthorizerConfig: {
                type: "boolean"
              },
              tlsConfig: {
                shape: "S3o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              domainConfigurationName: {},
              domainConfigurationArn: {}
            }
          }
        },
        UpdateDynamicThingGroup: {
          http: {
            method: "PATCH",
            requestUri: "/dynamic-thing-groups/{thingGroupName}"
          },
          input: {
            type: "structure",
            required: [
              "thingGroupName",
              "thingGroupProperties"
            ],
            members: {
              thingGroupName: {
                location: "uri",
                locationName: "thingGroupName"
              },
              thingGroupProperties: {
                shape: "S3t"
              },
              expectedVersion: {
                type: "long"
              },
              indexName: {},
              queryString: {},
              queryVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              version: {
                type: "long"
              }
            }
          }
        },
        UpdateEventConfigurations: {
          http: {
            method: "PATCH",
            requestUri: "/event-configurations"
          },
          input: {
            type: "structure",
            members: {
              eventConfigurations: {
                shape: "Skc"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateFleetMetric: {
          http: {
            method: "PATCH",
            requestUri: "/fleet-metric/{metricName}"
          },
          input: {
            type: "structure",
            required: [
              "metricName",
              "indexName"
            ],
            members: {
              metricName: {
                location: "uri",
                locationName: "metricName"
              },
              queryString: {},
              aggregationType: {
                shape: "S47"
              },
              period: {
                type: "integer"
              },
              aggregationField: {},
              description: {},
              queryVersion: {},
              indexName: {},
              unit: {},
              expectedVersion: {
                type: "long"
              }
            }
          }
        },
        UpdateIndexingConfiguration: {
          http: {
            requestUri: "/indexing/config"
          },
          input: {
            type: "structure",
            members: {
              thingIndexingConfiguration: {
                shape: "Snn"
              },
              thingGroupIndexingConfiguration: {
                shape: "So3"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateJob: {
          http: {
            method: "PATCH",
            requestUri: "/jobs/{jobId}"
          },
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              description: {},
              presignedUrlConfig: {
                shape: "S4k"
              },
              jobExecutionsRolloutConfig: {
                shape: "S4n"
              },
              abortConfig: {
                shape: "S4u"
              },
              timeoutConfig: {
                shape: "S51"
              },
              namespaceId: {
                location: "querystring",
                locationName: "namespaceId"
              },
              jobExecutionsRetryConfig: {
                shape: "S54"
              }
            }
          }
        },
        UpdateMitigationAction: {
          http: {
            method: "PATCH",
            requestUri: "/mitigationactions/actions/{actionName}"
          },
          input: {
            type: "structure",
            required: [
              "actionName"
            ],
            members: {
              actionName: {
                location: "uri",
                locationName: "actionName"
              },
              roleArn: {},
              actionParams: {
                shape: "S5w"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              actionArn: {},
              actionId: {}
            }
          }
        },
        UpdatePackage: {
          http: {
            method: "PATCH",
            requestUri: "/packages/{packageName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "packageName"
            ],
            members: {
              packageName: {
                location: "uri",
                locationName: "packageName"
              },
              description: {
                shape: "S88"
              },
              defaultVersionName: {},
              unsetDefaultVersion: {
                type: "boolean"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdatePackageConfiguration: {
          http: {
            method: "PATCH",
            requestUri: "/package-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              versionUpdateByJobsConfig: {
                shape: "Soj"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdatePackageVersion: {
          http: {
            method: "PATCH",
            requestUri: "/packages/{packageName}/versions/{versionName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "packageName",
              "versionName"
            ],
            members: {
              packageName: {
                location: "uri",
                locationName: "packageName"
              },
              versionName: {
                location: "uri",
                locationName: "versionName"
              },
              description: {
                shape: "S88"
              },
              attributes: {
                shape: "S8e"
              },
              action: {},
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateProvisioningTemplate: {
          http: {
            method: "PATCH",
            requestUri: "/provisioning-templates/{templateName}"
          },
          input: {
            type: "structure",
            required: [
              "templateName"
            ],
            members: {
              templateName: {
                location: "uri",
                locationName: "templateName"
              },
              description: {},
              enabled: {
                type: "boolean"
              },
              defaultVersionId: {
                type: "integer"
              },
              provisioningRoleArn: {},
              preProvisioningHook: {
                shape: "S90"
              },
              removePreProvisioningHook: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateRoleAlias: {
          http: {
            method: "PUT",
            requestUri: "/role-aliases/{roleAlias}"
          },
          input: {
            type: "structure",
            required: [
              "roleAlias"
            ],
            members: {
              roleAlias: {
                location: "uri",
                locationName: "roleAlias"
              },
              roleArn: {},
              credentialDurationSeconds: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              roleAlias: {},
              roleAliasArn: {}
            }
          }
        },
        UpdateScheduledAudit: {
          http: {
            method: "PATCH",
            requestUri: "/audit/scheduledaudits/{scheduledAuditName}"
          },
          input: {
            type: "structure",
            required: [
              "scheduledAuditName"
            ],
            members: {
              frequency: {},
              dayOfMonth: {},
              dayOfWeek: {},
              targetCheckNames: {
                shape: "S9g"
              },
              scheduledAuditName: {
                location: "uri",
                locationName: "scheduledAuditName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              scheduledAuditArn: {}
            }
          }
        },
        UpdateSecurityProfile: {
          http: {
            method: "PATCH",
            requestUri: "/security-profiles/{securityProfileName}"
          },
          input: {
            type: "structure",
            required: [
              "securityProfileName"
            ],
            members: {
              securityProfileName: {
                location: "uri",
                locationName: "securityProfileName"
              },
              securityProfileDescription: {},
              behaviors: {
                shape: "S9m"
              },
              alertTargets: {
                shape: "Sad"
              },
              additionalMetricsToRetain: {
                shape: "Sah",
                deprecated: true,
                deprecatedMessage: "Use additionalMetricsToRetainV2."
              },
              additionalMetricsToRetainV2: {
                shape: "Sai"
              },
              deleteBehaviors: {
                type: "boolean"
              },
              deleteAlertTargets: {
                type: "boolean"
              },
              deleteAdditionalMetricsToRetain: {
                type: "boolean"
              },
              expectedVersion: {
                location: "querystring",
                locationName: "expectedVersion",
                type: "long"
              },
              metricsExportConfig: {
                shape: "Sak"
              },
              deleteMetricsExportConfig: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              securityProfileName: {},
              securityProfileArn: {},
              securityProfileDescription: {},
              behaviors: {
                shape: "S9m"
              },
              alertTargets: {
                shape: "Sad"
              },
              additionalMetricsToRetain: {
                shape: "Sah",
                deprecated: true,
                deprecatedMessage: "Use additionalMetricsToRetainV2."
              },
              additionalMetricsToRetainV2: {
                shape: "Sai"
              },
              version: {
                type: "long"
              },
              creationDate: {
                type: "timestamp"
              },
              lastModifiedDate: {
                type: "timestamp"
              },
              metricsExportConfig: {
                shape: "Sak"
              }
            }
          }
        },
        UpdateStream: {
          http: {
            method: "PUT",
            requestUri: "/streams/{streamId}"
          },
          input: {
            type: "structure",
            required: [
              "streamId"
            ],
            members: {
              streamId: {
                location: "uri",
                locationName: "streamId"
              },
              description: {},
              files: {
                shape: "Saq"
              },
              roleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              streamId: {},
              streamArn: {},
              description: {},
              streamVersion: {
                type: "integer"
              }
            }
          }
        },
        UpdateThing: {
          http: {
            method: "PATCH",
            requestUri: "/things/{thingName}"
          },
          input: {
            type: "structure",
            required: [
              "thingName"
            ],
            members: {
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              thingTypeName: {},
              attributePayload: {
                shape: "S3v"
              },
              expectedVersion: {
                type: "long"
              },
              removeThingType: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateThingGroup: {
          http: {
            method: "PATCH",
            requestUri: "/thing-groups/{thingGroupName}"
          },
          input: {
            type: "structure",
            required: [
              "thingGroupName",
              "thingGroupProperties"
            ],
            members: {
              thingGroupName: {
                location: "uri",
                locationName: "thingGroupName"
              },
              thingGroupProperties: {
                shape: "S3t"
              },
              expectedVersion: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              version: {
                type: "long"
              }
            }
          }
        },
        UpdateThingGroupsForThing: {
          http: {
            method: "PUT",
            requestUri: "/thing-groups/updateThingGroupsForThing"
          },
          input: {
            type: "structure",
            members: {
              thingName: {},
              thingGroupsToAdd: {
                shape: "S10k"
              },
              thingGroupsToRemove: {
                shape: "S10k"
              },
              overrideDynamicGroups: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateTopicRuleDestination: {
          http: {
            method: "PATCH",
            requestUri: "/destinations"
          },
          input: {
            type: "structure",
            required: [
              "arn",
              "status"
            ],
            members: {
              arn: {},
              status: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ValidateSecurityProfileBehaviors: {
          http: {
            requestUri: "/security-profile-behaviors/validate"
          },
          input: {
            type: "structure",
            required: [
              "behaviors"
            ],
            members: {
              behaviors: {
                shape: "S9m"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              valid: {
                type: "boolean"
              },
              validationErrors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    errorMessage: {}
                  }
                }
              }
            }
          }
        }
      },
      shapes: {
        Sg: {
          type: "list",
          member: {}
        },
        S1e: {
          type: "map",
          key: {},
          value: {}
        },
        S1o: {
          type: "structure",
          members: {
            deviceCertificateId: {},
            caCertificateId: {},
            cognitoIdentityPoolId: {},
            clientId: {},
            policyVersionIdentifier: {
              type: "structure",
              members: {
                policyName: {},
                policyVersionId: {}
              }
            },
            account: {},
            iamRoleArn: {},
            roleAliasArn: {},
            issuerCertificateIdentifier: {
              type: "structure",
              members: {
                issuerCertificateSubject: {},
                issuerId: {},
                issuerCertificateSerialNumber: {}
              }
            },
            deviceCertificateArn: {}
          }
        },
        S2a: {
          type: "map",
          key: {},
          value: {}
        },
        S2e: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S2n: {
          type: "structure",
          members: {
            billingGroupDescription: {}
          }
        },
        S2y: {
          type: "list",
          member: {}
        },
        S3c: {
          type: "list",
          member: {}
        },
        S3l: {
          type: "structure",
          members: {
            defaultAuthorizerName: {},
            allowAuthorizerOverride: {
              type: "boolean"
            }
          }
        },
        S3o: {
          type: "structure",
          members: {
            securityPolicy: {}
          }
        },
        S3t: {
          type: "structure",
          members: {
            thingGroupDescription: {},
            attributePayload: {
              shape: "S3v"
            }
          }
        },
        S3v: {
          type: "structure",
          members: {
            attributes: {
              shape: "S3w"
            },
            merge: {
              type: "boolean"
            }
          }
        },
        S3w: {
          type: "map",
          key: {},
          value: {}
        },
        S47: {
          type: "structure",
          required: [
            "name"
          ],
          members: {
            name: {},
            values: {
              type: "list",
              member: {}
            }
          }
        },
        S4k: {
          type: "structure",
          members: {
            roleArn: {},
            expiresInSec: {
              type: "long"
            }
          }
        },
        S4n: {
          type: "structure",
          members: {
            maximumPerMinute: {
              type: "integer"
            },
            exponentialRate: {
              type: "structure",
              required: [
                "baseRatePerMinute",
                "incrementFactor",
                "rateIncreaseCriteria"
              ],
              members: {
                baseRatePerMinute: {
                  type: "integer"
                },
                incrementFactor: {
                  type: "double"
                },
                rateIncreaseCriteria: {
                  type: "structure",
                  members: {
                    numberOfNotifiedThings: {
                      type: "integer"
                    },
                    numberOfSucceededThings: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        S4u: {
          type: "structure",
          required: [
            "criteriaList"
          ],
          members: {
            criteriaList: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "failureType",
                  "action",
                  "thresholdPercentage",
                  "minNumberOfExecutedThings"
                ],
                members: {
                  failureType: {},
                  action: {},
                  thresholdPercentage: {
                    type: "double"
                  },
                  minNumberOfExecutedThings: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        S51: {
          type: "structure",
          members: {
            inProgressTimeoutInMinutes: {
              type: "long"
            }
          }
        },
        S54: {
          type: "structure",
          required: [
            "criteriaList"
          ],
          members: {
            criteriaList: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "failureType",
                  "numberOfRetries"
                ],
                members: {
                  failureType: {},
                  numberOfRetries: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        S59: {
          type: "map",
          key: {},
          value: {}
        },
        S5c: {
          type: "structure",
          members: {
            startTime: {},
            endTime: {},
            endBehavior: {},
            maintenanceWindows: {
              shape: "S5f"
            }
          }
        },
        S5f: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "startTime",
              "durationInMinutes"
            ],
            members: {
              startTime: {},
              durationInMinutes: {
                type: "integer"
              }
            }
          }
        },
        S5j: {
          type: "list",
          member: {}
        },
        S5r: {
          type: "structure",
          members: {
            PublicKey: {},
            PrivateKey: {
              type: "string",
              sensitive: true
            }
          }
        },
        S5w: {
          type: "structure",
          members: {
            updateDeviceCertificateParams: {
              type: "structure",
              required: [
                "action"
              ],
              members: {
                action: {}
              }
            },
            updateCACertificateParams: {
              type: "structure",
              required: [
                "action"
              ],
              members: {
                action: {}
              }
            },
            addThingsToThingGroupParams: {
              type: "structure",
              required: [
                "thingGroupNames"
              ],
              members: {
                thingGroupNames: {
                  type: "list",
                  member: {}
                },
                overrideDynamicGroups: {
                  type: "boolean"
                }
              }
            },
            replaceDefaultPolicyVersionParams: {
              type: "structure",
              required: [
                "templateName"
              ],
              members: {
                templateName: {}
              }
            },
            enableIoTLoggingParams: {
              type: "structure",
              required: [
                "roleArnForLogging",
                "logLevel"
              ],
              members: {
                roleArnForLogging: {},
                logLevel: {}
              }
            },
            publishFindingToSnsParams: {
              type: "structure",
              required: [
                "topicArn"
              ],
              members: {
                topicArn: {}
              }
            }
          }
        },
        S6g: {
          type: "list",
          member: {}
        },
        S6i: {
          type: "list",
          member: {}
        },
        S6k: {
          type: "structure",
          members: {
            maximumPerMinute: {
              type: "integer"
            },
            exponentialRate: {
              type: "structure",
              required: [
                "baseRatePerMinute",
                "incrementFactor",
                "rateIncreaseCriteria"
              ],
              members: {
                baseRatePerMinute: {
                  type: "integer"
                },
                incrementFactor: {
                  type: "double"
                },
                rateIncreaseCriteria: {
                  type: "structure",
                  members: {
                    numberOfNotifiedThings: {
                      type: "integer"
                    },
                    numberOfSucceededThings: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        S6r: {
          type: "structure",
          members: {
            expiresInSec: {
              type: "long"
            }
          }
        },
        S72: {
          type: "list",
          member: {
            type: "structure",
            members: {
              fileName: {},
              fileType: {
                type: "integer"
              },
              fileVersion: {},
              fileLocation: {
                type: "structure",
                members: {
                  stream: {
                    type: "structure",
                    members: {
                      streamId: {},
                      fileId: {
                        type: "integer"
                      }
                    }
                  },
                  s3Location: {
                    shape: "S7b"
                  }
                }
              },
              codeSigning: {
                type: "structure",
                members: {
                  awsSignerJobId: {},
                  startSigningJobParameter: {
                    type: "structure",
                    members: {
                      signingProfileParameter: {
                        type: "structure",
                        members: {
                          certificateArn: {},
                          platform: {},
                          certificatePathOnDevice: {}
                        }
                      },
                      signingProfileName: {},
                      destination: {
                        type: "structure",
                        members: {
                          s3Destination: {
                            type: "structure",
                            members: {
                              bucket: {},
                              prefix: {}
                            }
                          }
                        }
                      }
                    }
                  },
                  customCodeSigning: {
                    type: "structure",
                    members: {
                      signature: {
                        type: "structure",
                        members: {
                          inlineDocument: {
                            type: "blob"
                          }
                        }
                      },
                      certificateChain: {
                        type: "structure",
                        members: {
                          certificateName: {},
                          inlineDocument: {}
                        }
                      },
                      hashAlgorithm: {},
                      signatureAlgorithm: {}
                    }
                  }
                }
              },
              attributes: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        S7b: {
          type: "structure",
          members: {
            bucket: {},
            key: {},
            version: {}
          }
        },
        S80: {
          type: "map",
          key: {},
          value: {}
        },
        S88: {
          type: "string",
          sensitive: true
        },
        S89: {
          type: "map",
          key: {},
          value: {}
        },
        S8e: {
          type: "map",
          key: {},
          value: {},
          sensitive: true
        },
        S90: {
          type: "structure",
          required: [
            "targetArn"
          ],
          members: {
            payloadVersion: {},
            targetArn: {}
          }
        },
        S9g: {
          type: "list",
          member: {}
        },
        S9m: {
          type: "list",
          member: {
            shape: "S9n"
          }
        },
        S9n: {
          type: "structure",
          required: [
            "name"
          ],
          members: {
            name: {},
            metric: {},
            metricDimension: {
              shape: "S9q"
            },
            criteria: {
              type: "structure",
              members: {
                comparisonOperator: {},
                value: {
                  shape: "S9u"
                },
                durationSeconds: {
                  type: "integer"
                },
                consecutiveDatapointsToAlarm: {
                  type: "integer"
                },
                consecutiveDatapointsToClear: {
                  type: "integer"
                },
                statisticalThreshold: {
                  type: "structure",
                  members: {
                    statistic: {}
                  }
                },
                mlDetectionConfig: {
                  type: "structure",
                  required: [
                    "confidenceLevel"
                  ],
                  members: {
                    confidenceLevel: {}
                  }
                }
              }
            },
            suppressAlerts: {
              type: "boolean"
            },
            exportMetric: {
              type: "boolean"
            }
          }
        },
        S9q: {
          type: "structure",
          required: [
            "dimensionName"
          ],
          members: {
            dimensionName: {},
            operator: {}
          }
        },
        S9u: {
          type: "structure",
          members: {
            count: {
              type: "long"
            },
            cidrs: {
              type: "list",
              member: {}
            },
            ports: {
              type: "list",
              member: {
                type: "integer"
              }
            },
            number: {
              type: "double"
            },
            numbers: {
              type: "list",
              member: {
                type: "double"
              }
            },
            strings: {
              type: "list",
              member: {}
            }
          }
        },
        Sad: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "alertTargetArn",
              "roleArn"
            ],
            members: {
              alertTargetArn: {},
              roleArn: {}
            }
          }
        },
        Sah: {
          type: "list",
          member: {}
        },
        Sai: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "metric"
            ],
            members: {
              metric: {},
              metricDimension: {
                shape: "S9q"
              },
              exportMetric: {
                type: "boolean"
              }
            }
          }
        },
        Sak: {
          type: "structure",
          required: [
            "mqttTopic",
            "roleArn"
          ],
          members: {
            mqttTopic: {},
            roleArn: {}
          }
        },
        Saq: {
          type: "list",
          member: {
            type: "structure",
            members: {
              fileId: {
                type: "integer"
              },
              s3Location: {
                shape: "S7b"
              }
            }
          }
        },
        Sb2: {
          type: "structure",
          members: {
            thingTypeDescription: {},
            searchableAttributes: {
              type: "list",
              member: {}
            }
          }
        },
        Sba: {
          type: "structure",
          required: [
            "sql",
            "actions"
          ],
          members: {
            sql: {},
            description: {},
            actions: {
              shape: "Sbd"
            },
            ruleDisabled: {
              type: "boolean"
            },
            awsIotSqlVersion: {},
            errorAction: {
              shape: "Sbe"
            }
          }
        },
        Sbd: {
          type: "list",
          member: {
            shape: "Sbe"
          }
        },
        Sbe: {
          type: "structure",
          members: {
            dynamoDB: {
              type: "structure",
              required: [
                "tableName",
                "roleArn",
                "hashKeyField",
                "hashKeyValue"
              ],
              members: {
                tableName: {},
                roleArn: {},
                operation: {},
                hashKeyField: {},
                hashKeyValue: {},
                hashKeyType: {},
                rangeKeyField: {},
                rangeKeyValue: {},
                rangeKeyType: {},
                payloadField: {}
              }
            },
            dynamoDBv2: {
              type: "structure",
              required: [
                "roleArn",
                "putItem"
              ],
              members: {
                roleArn: {},
                putItem: {
                  type: "structure",
                  required: [
                    "tableName"
                  ],
                  members: {
                    tableName: {}
                  }
                }
              }
            },
            lambda: {
              type: "structure",
              required: [
                "functionArn"
              ],
              members: {
                functionArn: {}
              }
            },
            sns: {
              type: "structure",
              required: [
                "targetArn",
                "roleArn"
              ],
              members: {
                targetArn: {},
                roleArn: {},
                messageFormat: {}
              }
            },
            sqs: {
              type: "structure",
              required: [
                "roleArn",
                "queueUrl"
              ],
              members: {
                roleArn: {},
                queueUrl: {},
                useBase64: {
                  type: "boolean"
                }
              }
            },
            kinesis: {
              type: "structure",
              required: [
                "roleArn",
                "streamName"
              ],
              members: {
                roleArn: {},
                streamName: {},
                partitionKey: {}
              }
            },
            republish: {
              type: "structure",
              required: [
                "roleArn",
                "topic"
              ],
              members: {
                roleArn: {},
                topic: {},
                qos: {
                  type: "integer"
                },
                headers: {
                  type: "structure",
                  members: {
                    payloadFormatIndicator: {},
                    contentType: {},
                    responseTopic: {},
                    correlationData: {},
                    messageExpiry: {},
                    userProperties: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "key",
                          "value"
                        ],
                        members: {
                          key: {},
                          value: {}
                        }
                      }
                    }
                  }
                }
              }
            },
            s3: {
              type: "structure",
              required: [
                "roleArn",
                "bucketName",
                "key"
              ],
              members: {
                roleArn: {},
                bucketName: {},
                key: {},
                cannedAcl: {}
              }
            },
            firehose: {
              type: "structure",
              required: [
                "roleArn",
                "deliveryStreamName"
              ],
              members: {
                roleArn: {},
                deliveryStreamName: {},
                separator: {},
                batchMode: {
                  type: "boolean"
                }
              }
            },
            cloudwatchMetric: {
              type: "structure",
              required: [
                "roleArn",
                "metricNamespace",
                "metricName",
                "metricValue",
                "metricUnit"
              ],
              members: {
                roleArn: {},
                metricNamespace: {},
                metricName: {},
                metricValue: {},
                metricUnit: {},
                metricTimestamp: {}
              }
            },
            cloudwatchAlarm: {
              type: "structure",
              required: [
                "roleArn",
                "alarmName",
                "stateReason",
                "stateValue"
              ],
              members: {
                roleArn: {},
                alarmName: {},
                stateReason: {},
                stateValue: {}
              }
            },
            cloudwatchLogs: {
              type: "structure",
              required: [
                "roleArn",
                "logGroupName"
              ],
              members: {
                roleArn: {},
                logGroupName: {},
                batchMode: {
                  type: "boolean"
                }
              }
            },
            elasticsearch: {
              type: "structure",
              required: [
                "roleArn",
                "endpoint",
                "index",
                "type",
                "id"
              ],
              members: {
                roleArn: {},
                endpoint: {},
                index: {},
                type: {},
                id: {}
              }
            },
            salesforce: {
              type: "structure",
              required: [
                "token",
                "url"
              ],
              members: {
                token: {},
                url: {}
              }
            },
            iotAnalytics: {
              type: "structure",
              members: {
                channelArn: {},
                channelName: {},
                batchMode: {
                  type: "boolean"
                },
                roleArn: {}
              }
            },
            iotEvents: {
              type: "structure",
              required: [
                "inputName",
                "roleArn"
              ],
              members: {
                inputName: {},
                messageId: {},
                batchMode: {
                  type: "boolean"
                },
                roleArn: {}
              }
            },
            iotSiteWise: {
              type: "structure",
              required: [
                "putAssetPropertyValueEntries",
                "roleArn"
              ],
              members: {
                putAssetPropertyValueEntries: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "propertyValues"
                    ],
                    members: {
                      entryId: {},
                      assetId: {},
                      propertyId: {},
                      propertyAlias: {},
                      propertyValues: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "value",
                            "timestamp"
                          ],
                          members: {
                            value: {
                              type: "structure",
                              members: {
                                stringValue: {},
                                integerValue: {},
                                doubleValue: {},
                                booleanValue: {}
                              }
                            },
                            timestamp: {
                              type: "structure",
                              required: [
                                "timeInSeconds"
                              ],
                              members: {
                                timeInSeconds: {},
                                offsetInNanos: {}
                              }
                            },
                            quality: {}
                          }
                        }
                      }
                    }
                  }
                },
                roleArn: {}
              }
            },
            stepFunctions: {
              type: "structure",
              required: [
                "stateMachineName",
                "roleArn"
              ],
              members: {
                executionNamePrefix: {},
                stateMachineName: {},
                roleArn: {}
              }
            },
            timestream: {
              type: "structure",
              required: [
                "roleArn",
                "databaseName",
                "tableName",
                "dimensions"
              ],
              members: {
                roleArn: {},
                databaseName: {},
                tableName: {},
                dimensions: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "name",
                      "value"
                    ],
                    members: {
                      name: {},
                      value: {}
                    }
                  }
                },
                timestamp: {
                  type: "structure",
                  required: [
                    "value",
                    "unit"
                  ],
                  members: {
                    value: {},
                    unit: {}
                  }
                }
              }
            },
            http: {
              type: "structure",
              required: [
                "url"
              ],
              members: {
                url: {},
                confirmationUrl: {},
                headers: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "key",
                      "value"
                    ],
                    members: {
                      key: {},
                      value: {}
                    }
                  }
                },
                auth: {
                  type: "structure",
                  members: {
                    sigv4: {
                      type: "structure",
                      required: [
                        "signingRegion",
                        "serviceName",
                        "roleArn"
                      ],
                      members: {
                        signingRegion: {},
                        serviceName: {},
                        roleArn: {}
                      }
                    }
                  }
                }
              }
            },
            kafka: {
              type: "structure",
              required: [
                "destinationArn",
                "topic",
                "clientProperties"
              ],
              members: {
                destinationArn: {},
                topic: {},
                key: {},
                partition: {},
                clientProperties: {
                  type: "map",
                  key: {},
                  value: {}
                },
                headers: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "key",
                      "value"
                    ],
                    members: {
                      key: {},
                      value: {}
                    }
                  }
                }
              }
            },
            openSearch: {
              type: "structure",
              required: [
                "roleArn",
                "endpoint",
                "index",
                "type",
                "id"
              ],
              members: {
                roleArn: {},
                endpoint: {},
                index: {},
                type: {},
                id: {}
              }
            },
            location: {
              type: "structure",
              required: [
                "roleArn",
                "trackerName",
                "deviceId",
                "latitude",
                "longitude"
              ],
              members: {
                roleArn: {},
                trackerName: {},
                deviceId: {},
                timestamp: {
                  type: "structure",
                  required: [
                    "value"
                  ],
                  members: {
                    value: {},
                    unit: {}
                  }
                },
                latitude: {},
                longitude: {}
              }
            }
          }
        },
        Ser: {
          type: "list",
          member: {}
        },
        Set: {
          type: "list",
          member: {}
        },
        Sex: {
          type: "structure",
          members: {
            arn: {},
            status: {},
            createdAt: {
              type: "timestamp"
            },
            lastUpdatedAt: {
              type: "timestamp"
            },
            statusReason: {},
            httpUrlProperties: {
              type: "structure",
              members: {
                confirmationUrl: {}
              }
            },
            vpcProperties: {
              type: "structure",
              members: {
                subnetIds: {
                  shape: "Ser"
                },
                securityGroups: {
                  shape: "Set"
                },
                vpcId: {},
                roleArn: {}
              }
            }
          }
        },
        Sh3: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              targetArn: {},
              roleArn: {},
              enabled: {
                type: "boolean"
              }
            }
          }
        },
        Sh6: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              enabled: {
                type: "boolean"
              }
            }
          }
        },
        Shb: {
          type: "structure",
          members: {
            findingId: {},
            taskId: {},
            checkName: {},
            taskStartTime: {
              type: "timestamp"
            },
            findingTime: {
              type: "timestamp"
            },
            severity: {},
            nonCompliantResource: {
              type: "structure",
              members: {
                resourceType: {},
                resourceIdentifier: {
                  shape: "S1o"
                },
                additionalInfo: {
                  shape: "Shf"
                }
              }
            },
            relatedResources: {
              shape: "Shg"
            },
            reasonForNonCompliance: {},
            reasonForNonComplianceCode: {},
            isSuppressed: {
              type: "boolean"
            }
          }
        },
        Shf: {
          type: "map",
          key: {},
          value: {}
        },
        Shg: {
          type: "list",
          member: {
            type: "structure",
            members: {
              resourceType: {},
              resourceIdentifier: {
                shape: "S1o"
              },
              additionalInfo: {
                shape: "Shf"
              }
            }
          }
        },
        Shv: {
          type: "structure",
          members: {
            auditTaskId: {},
            findingIds: {
              type: "list",
              member: {}
            },
            auditCheckToReasonCodeFilter: {
              type: "map",
              key: {},
              value: {
                type: "list",
                member: {}
              }
            }
          }
        },
        Shz: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {}
          }
        },
        Si1: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              id: {},
              roleArn: {},
              actionParams: {
                shape: "S5w"
              }
            }
          }
        },
        Sis: {
          type: "structure",
          members: {
            authorizerName: {},
            authorizerArn: {},
            authorizerFunctionArn: {},
            tokenKeyName: {},
            tokenSigningPublicKeys: {
              shape: "S2a"
            },
            status: {},
            creationDate: {
              type: "timestamp"
            },
            lastModifiedDate: {
              type: "timestamp"
            },
            signingDisabled: {
              type: "boolean"
            },
            enableCachingForHttp: {
              type: "boolean"
            }
          }
        },
        Sj5: {
          type: "structure",
          members: {
            notBefore: {
              type: "timestamp"
            },
            notAfter: {
              type: "timestamp"
            }
          }
        },
        Sj7: {
          type: "structure",
          members: {
            templateBody: {},
            roleArn: {},
            templateName: {}
          }
        },
        Sjm: {
          type: "structure",
          members: {
            taskId: {},
            taskStatus: {},
            taskStartTime: {
              type: "timestamp"
            },
            taskEndTime: {
              type: "timestamp"
            },
            target: {
              shape: "Sjo"
            },
            violationEventOccurrenceRange: {
              shape: "Sjr"
            },
            onlyActiveViolationsIncluded: {
              type: "boolean"
            },
            suppressedAlertsIncluded: {
              type: "boolean"
            },
            actionsDefinition: {
              shape: "Si1"
            },
            taskStatistics: {
              type: "structure",
              members: {
                actionsExecuted: {
                  type: "long"
                },
                actionsSkipped: {
                  type: "long"
                },
                actionsFailed: {
                  type: "long"
                }
              }
            }
          }
        },
        Sjo: {
          type: "structure",
          members: {
            violationIds: {
              type: "list",
              member: {}
            },
            securityProfileName: {},
            behaviorName: {}
          }
        },
        Sjr: {
          type: "structure",
          required: [
            "startTime",
            "endTime"
          ],
          members: {
            startTime: {
              type: "timestamp"
            },
            endTime: {
              type: "timestamp"
            }
          }
        },
        Skc: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              Enabled: {
                type: "boolean"
              }
            }
          }
        },
        Sli: {
          type: "list",
          member: {}
        },
        Smb: {
          type: "list",
          member: {
            shape: "Smc"
          }
        },
        Smc: {
          type: "structure",
          members: {
            groupName: {},
            groupArn: {}
          }
        },
        Smo: {
          type: "structure",
          members: {
            deprecated: {
              type: "boolean"
            },
            deprecationDate: {
              type: "timestamp"
            },
            creationDate: {
              type: "timestamp"
            }
          }
        },
        Snn: {
          type: "structure",
          required: [
            "thingIndexingMode"
          ],
          members: {
            thingIndexingMode: {},
            thingConnectivityIndexingMode: {},
            deviceDefenderIndexingMode: {},
            namedShadowIndexingMode: {},
            managedFields: {
              shape: "Sns"
            },
            customFields: {
              shape: "Sns"
            },
            filter: {
              type: "structure",
              members: {
                namedShadowNames: {
                  type: "list",
                  member: {}
                },
                geoLocations: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      name: {},
                      order: {}
                    }
                  }
                }
              }
            }
          }
        },
        Sns: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              type: {}
            }
          }
        },
        So3: {
          type: "structure",
          required: [
            "thingGroupIndexingMode"
          ],
          members: {
            thingGroupIndexingMode: {},
            managedFields: {
              shape: "Sns"
            },
            customFields: {
              shape: "Sns"
            }
          }
        },
        Soj: {
          type: "structure",
          members: {
            enabled: {
              type: "boolean"
            },
            roleArn: {}
          }
        },
        Spt: {
          type: "structure",
          members: {
            confidenceLevel: {}
          }
        },
        Sq0: {
          type: "list",
          member: {
            type: "structure",
            members: {
              policyName: {},
              policyArn: {}
            }
          }
        },
        Sr6: {
          type: "list",
          member: {
            type: "structure",
            members: {
              certificateArn: {},
              certificateId: {},
              status: {},
              certificateMode: {},
              creationDate: {
                type: "timestamp"
              }
            }
          }
        },
        Ss6: {
          type: "structure",
          members: {
            status: {},
            queuedAt: {
              type: "timestamp"
            },
            startedAt: {
              type: "timestamp"
            },
            lastUpdatedAt: {
              type: "timestamp"
            },
            executionNumber: {
              type: "long"
            },
            retryAttempt: {
              type: "integer"
            }
          }
        },
        Sth: {
          type: "list",
          member: {}
        },
        Str: {
          type: "list",
          member: {}
        },
        Suc: {
          type: "structure",
          required: [
            "name",
            "arn"
          ],
          members: {
            name: {},
            arn: {}
          }
        },
        Suh: {
          type: "structure",
          required: [
            "arn"
          ],
          members: {
            arn: {}
          }
        },
        Sw5: {
          type: "structure",
          required: [
            "targetType"
          ],
          members: {
            targetType: {},
            targetName: {}
          }
        },
        Sx1: {
          type: "list",
          member: {}
        },
        Sxu: {
          type: "structure",
          required: [
            "resources"
          ],
          members: {
            actionType: {},
            resources: {
              type: "list",
              member: {}
            }
          }
        },
        Sxy: {
          type: "list",
          member: {}
        },
        S10k: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iot-2015-05-28.paginators.json
var require_iot_2015_05_28_paginators = __commonJS({
  "node_modules/aws-sdk/apis/iot-2015-05-28.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetBehaviorModelTrainingSummaries: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "summaries"
        },
        ListActiveViolations: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "activeViolations"
        },
        ListAttachedPolicies: {
          input_token: "marker",
          limit_key: "pageSize",
          output_token: "nextMarker",
          result_key: "policies"
        },
        ListAuditFindings: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "findings"
        },
        ListAuditMitigationActionsExecutions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "actionsExecutions"
        },
        ListAuditMitigationActionsTasks: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "tasks"
        },
        ListAuditSuppressions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "suppressions"
        },
        ListAuditTasks: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "tasks"
        },
        ListAuthorizers: {
          input_token: "marker",
          limit_key: "pageSize",
          output_token: "nextMarker",
          result_key: "authorizers"
        },
        ListBillingGroups: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "billingGroups"
        },
        ListCACertificates: {
          input_token: "marker",
          limit_key: "pageSize",
          output_token: "nextMarker",
          result_key: "certificates"
        },
        ListCertificates: {
          input_token: "marker",
          limit_key: "pageSize",
          output_token: "nextMarker",
          result_key: "certificates"
        },
        ListCertificatesByCA: {
          input_token: "marker",
          limit_key: "pageSize",
          output_token: "nextMarker",
          result_key: "certificates"
        },
        ListCustomMetrics: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "metricNames"
        },
        ListDetectMitigationActionsExecutions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "actionsExecutions"
        },
        ListDetectMitigationActionsTasks: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "tasks"
        },
        ListDimensions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "dimensionNames"
        },
        ListDomainConfigurations: {
          input_token: "marker",
          limit_key: "pageSize",
          output_token: "nextMarker",
          result_key: "domainConfigurations"
        },
        ListFleetMetrics: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "fleetMetrics"
        },
        ListIndices: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "indexNames"
        },
        ListJobExecutionsForJob: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "executionSummaries"
        },
        ListJobExecutionsForThing: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "executionSummaries"
        },
        ListJobTemplates: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "jobTemplates"
        },
        ListJobs: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "jobs"
        },
        ListManagedJobTemplates: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "managedJobTemplates"
        },
        ListMetricValues: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "metricDatumList"
        },
        ListMitigationActions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "actionIdentifiers"
        },
        ListOTAUpdates: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "otaUpdates"
        },
        ListOutgoingCertificates: {
          input_token: "marker",
          limit_key: "pageSize",
          output_token: "nextMarker",
          result_key: "outgoingCertificates"
        },
        ListPackageVersions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "packageVersionSummaries"
        },
        ListPackages: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "packageSummaries"
        },
        ListPolicies: {
          input_token: "marker",
          limit_key: "pageSize",
          output_token: "nextMarker",
          result_key: "policies"
        },
        ListPolicyPrincipals: {
          input_token: "marker",
          limit_key: "pageSize",
          output_token: "nextMarker",
          result_key: "principals"
        },
        ListPrincipalPolicies: {
          input_token: "marker",
          limit_key: "pageSize",
          output_token: "nextMarker",
          result_key: "policies"
        },
        ListPrincipalThings: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "things"
        },
        ListProvisioningTemplateVersions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "versions"
        },
        ListProvisioningTemplates: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "templates"
        },
        ListRelatedResourcesForAuditFinding: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "relatedResources"
        },
        ListRoleAliases: {
          input_token: "marker",
          limit_key: "pageSize",
          output_token: "nextMarker",
          result_key: "roleAliases"
        },
        ListScheduledAudits: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "scheduledAudits"
        },
        ListSecurityProfiles: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "securityProfileIdentifiers"
        },
        ListSecurityProfilesForTarget: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "securityProfileTargetMappings"
        },
        ListStreams: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "streams"
        },
        ListTagsForResource: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "tags"
        },
        ListTargetsForPolicy: {
          input_token: "marker",
          limit_key: "pageSize",
          output_token: "nextMarker",
          result_key: "targets"
        },
        ListTargetsForSecurityProfile: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "securityProfileTargets"
        },
        ListThingGroups: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "thingGroups"
        },
        ListThingGroupsForThing: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "thingGroups"
        },
        ListThingPrincipals: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "principals"
        },
        ListThingRegistrationTaskReports: {
          input_token: "nextToken",
          limit_key: "maxResults",
          non_aggregate_keys: [
            "reportType"
          ],
          output_token: "nextToken",
          result_key: "resourceLinks"
        },
        ListThingRegistrationTasks: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "taskIds"
        },
        ListThingTypes: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "thingTypes"
        },
        ListThings: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "things"
        },
        ListThingsInBillingGroup: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "things"
        },
        ListThingsInThingGroup: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "things"
        },
        ListTopicRuleDestinations: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "destinationSummaries"
        },
        ListTopicRules: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "rules"
        },
        ListV2LoggingLevels: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "logTargetConfigurations"
        },
        ListViolationEvents: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "violationEvents"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/iot.js
var require_iot = __commonJS({
  "node_modules/aws-sdk/clients/iot.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["iot"] = {};
    AWS2.Iot = Service.defineService("iot", ["2015-05-28"]);
    Object.defineProperty(apiLoader.services["iot"], "2015-05-28", {
      get: function get() {
        var model = require_iot_2015_05_28_min();
        model.paginators = require_iot_2015_05_28_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Iot;
  }
});

// node_modules/aws-sdk/lib/services/iotdata.js
var require_iotdata = __commonJS({
  "node_modules/aws-sdk/lib/services/iotdata.js"() {
    "use strict";
    var AWS2 = require_core();
    var blobPayloadOutputOps = [
      "deleteThingShadow",
      "getThingShadow",
      "updateThingShadow"
    ];
    AWS2.util.update(AWS2.IotData.prototype, {
      /**
       * @api private
       */
      validateService: function validateService() {
        if (!this.config.endpoint || this.config.endpoint.indexOf("{") >= 0) {
          var msg = "AWS.IotData requires an explicit `endpoint' configuration option.";
          throw AWS2.util.error(
            new Error(),
            { name: "InvalidEndpoint", message: msg }
          );
        }
      },
      /**
       * @api private
       */
      setupRequestListeners: function setupRequestListeners(request) {
        request.addListener("validateResponse", this.validateResponseBody);
        if (blobPayloadOutputOps.indexOf(request.operation) > -1) {
          request.addListener("extractData", AWS2.util.convertPayloadToString);
        }
      },
      /**
       * @api private
       */
      validateResponseBody: function validateResponseBody(resp) {
        var body = resp.httpResponse.body.toString() || "{}";
        var bodyCheck = body.trim();
        if (!bodyCheck || bodyCheck.charAt(0) !== "{") {
          resp.httpResponse.body = "";
        }
      }
    });
  }
});

// node_modules/aws-sdk/apis/iot-data-2015-05-28.min.json
var require_iot_data_2015_05_28_min = __commonJS({
  "node_modules/aws-sdk/apis/iot-data-2015-05-28.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-05-28",
        endpointPrefix: "data-ats.iot",
        protocol: "rest-json",
        serviceFullName: "AWS IoT Data Plane",
        serviceId: "IoT Data Plane",
        signatureVersion: "v4",
        signingName: "iotdata",
        uid: "iot-data-2015-05-28"
      },
      operations: {
        DeleteThingShadow: {
          http: {
            method: "DELETE",
            requestUri: "/things/{thingName}/shadow"
          },
          input: {
            type: "structure",
            required: [
              "thingName"
            ],
            members: {
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              shadowName: {
                location: "querystring",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "payload"
            ],
            members: {
              payload: {
                type: "blob"
              }
            },
            payload: "payload"
          }
        },
        GetRetainedMessage: {
          http: {
            method: "GET",
            requestUri: "/retainedMessage/{topic}"
          },
          input: {
            type: "structure",
            required: [
              "topic"
            ],
            members: {
              topic: {
                location: "uri",
                locationName: "topic"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              topic: {},
              payload: {
                type: "blob"
              },
              qos: {
                type: "integer"
              },
              lastModifiedTime: {
                type: "long"
              },
              userProperties: {
                type: "blob"
              }
            }
          }
        },
        GetThingShadow: {
          http: {
            method: "GET",
            requestUri: "/things/{thingName}/shadow"
          },
          input: {
            type: "structure",
            required: [
              "thingName"
            ],
            members: {
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              shadowName: {
                location: "querystring",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              payload: {
                type: "blob"
              }
            },
            payload: "payload"
          }
        },
        ListNamedShadowsForThing: {
          http: {
            method: "GET",
            requestUri: "/api/things/shadow/ListNamedShadowsForThing/{thingName}"
          },
          input: {
            type: "structure",
            required: [
              "thingName"
            ],
            members: {
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              pageSize: {
                location: "querystring",
                locationName: "pageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              results: {
                type: "list",
                member: {}
              },
              nextToken: {},
              timestamp: {
                type: "long"
              }
            }
          }
        },
        ListRetainedMessages: {
          http: {
            method: "GET",
            requestUri: "/retainedMessage"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              retainedTopics: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    topic: {},
                    payloadSize: {
                      type: "long"
                    },
                    qos: {
                      type: "integer"
                    },
                    lastModifiedTime: {
                      type: "long"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        Publish: {
          http: {
            requestUri: "/topics/{topic}"
          },
          input: {
            type: "structure",
            required: [
              "topic"
            ],
            members: {
              topic: {
                location: "uri",
                locationName: "topic"
              },
              qos: {
                location: "querystring",
                locationName: "qos",
                type: "integer"
              },
              retain: {
                location: "querystring",
                locationName: "retain",
                type: "boolean"
              },
              payload: {
                type: "blob"
              },
              userProperties: {
                jsonvalue: true,
                location: "header",
                locationName: "x-amz-mqtt5-user-properties"
              },
              payloadFormatIndicator: {
                location: "header",
                locationName: "x-amz-mqtt5-payload-format-indicator"
              },
              contentType: {
                location: "querystring",
                locationName: "contentType"
              },
              responseTopic: {
                location: "querystring",
                locationName: "responseTopic"
              },
              correlationData: {
                location: "header",
                locationName: "x-amz-mqtt5-correlation-data"
              },
              messageExpiry: {
                location: "querystring",
                locationName: "messageExpiry",
                type: "long"
              }
            },
            payload: "payload"
          }
        },
        UpdateThingShadow: {
          http: {
            requestUri: "/things/{thingName}/shadow"
          },
          input: {
            type: "structure",
            required: [
              "thingName",
              "payload"
            ],
            members: {
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              shadowName: {
                location: "querystring",
                locationName: "name"
              },
              payload: {
                type: "blob"
              }
            },
            payload: "payload"
          },
          output: {
            type: "structure",
            members: {
              payload: {
                type: "blob"
              }
            },
            payload: "payload"
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/apis/iot-data-2015-05-28.paginators.json
var require_iot_data_2015_05_28_paginators = __commonJS({
  "node_modules/aws-sdk/apis/iot-data-2015-05-28.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListRetainedMessages: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "retainedTopics"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/iotdata.js
var require_iotdata2 = __commonJS({
  "node_modules/aws-sdk/clients/iotdata.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["iotdata"] = {};
    AWS2.IotData = Service.defineService("iotdata", ["2015-05-28"]);
    require_iotdata();
    Object.defineProperty(apiLoader.services["iotdata"], "2015-05-28", {
      get: function get() {
        var model = require_iot_data_2015_05_28_min();
        model.paginators = require_iot_data_2015_05_28_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.IotData;
  }
});

// node_modules/aws-sdk/apis/kinesis-2013-12-02.min.json
var require_kinesis_2013_12_02_min = __commonJS({
  "node_modules/aws-sdk/apis/kinesis-2013-12-02.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2013-12-02",
        endpointPrefix: "kinesis",
        jsonVersion: "1.1",
        protocol: "json",
        protocolSettings: {
          h2: "eventstream"
        },
        serviceAbbreviation: "Kinesis",
        serviceFullName: "Amazon Kinesis",
        serviceId: "Kinesis",
        signatureVersion: "v4",
        targetPrefix: "Kinesis_20131202",
        uid: "kinesis-2013-12-02"
      },
      operations: {
        AddTagsToStream: {
          input: {
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              StreamName: {},
              Tags: {
                type: "map",
                key: {},
                value: {}
              },
              StreamARN: {
                contextParam: {
                  name: "StreamARN"
                }
              }
            }
          },
          staticContextParams: {
            OperationType: {
              value: "control"
            }
          }
        },
        CreateStream: {
          input: {
            type: "structure",
            required: [
              "StreamName"
            ],
            members: {
              StreamName: {},
              ShardCount: {
                type: "integer"
              },
              StreamModeDetails: {
                shape: "S9"
              }
            }
          }
        },
        DecreaseStreamRetentionPeriod: {
          input: {
            type: "structure",
            required: [
              "RetentionPeriodHours"
            ],
            members: {
              StreamName: {},
              RetentionPeriodHours: {
                type: "integer"
              },
              StreamARN: {
                contextParam: {
                  name: "StreamARN"
                }
              }
            }
          },
          staticContextParams: {
            OperationType: {
              value: "control"
            }
          }
        },
        DeleteResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {
                contextParam: {
                  name: "ResourceARN"
                }
              }
            }
          },
          staticContextParams: {
            OperationType: {
              value: "control"
            }
          }
        },
        DeleteStream: {
          input: {
            type: "structure",
            members: {
              StreamName: {},
              EnforceConsumerDeletion: {
                type: "boolean"
              },
              StreamARN: {
                contextParam: {
                  name: "StreamARN"
                }
              }
            }
          },
          staticContextParams: {
            OperationType: {
              value: "control"
            }
          }
        },
        DeregisterStreamConsumer: {
          input: {
            type: "structure",
            members: {
              StreamARN: {
                contextParam: {
                  name: "StreamARN"
                }
              },
              ConsumerName: {},
              ConsumerARN: {
                contextParam: {
                  name: "ConsumerARN"
                }
              }
            }
          },
          staticContextParams: {
            OperationType: {
              value: "control"
            }
          }
        },
        DescribeLimits: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "ShardLimit",
              "OpenShardCount",
              "OnDemandStreamCount",
              "OnDemandStreamCountLimit"
            ],
            members: {
              ShardLimit: {
                type: "integer"
              },
              OpenShardCount: {
                type: "integer"
              },
              OnDemandStreamCount: {
                type: "integer"
              },
              OnDemandStreamCountLimit: {
                type: "integer"
              }
            }
          }
        },
        DescribeStream: {
          input: {
            type: "structure",
            members: {
              StreamName: {},
              Limit: {
                type: "integer"
              },
              ExclusiveStartShardId: {},
              StreamARN: {
                contextParam: {
                  name: "StreamARN"
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "StreamDescription"
            ],
            members: {
              StreamDescription: {
                type: "structure",
                required: [
                  "StreamName",
                  "StreamARN",
                  "StreamStatus",
                  "Shards",
                  "HasMoreShards",
                  "RetentionPeriodHours",
                  "StreamCreationTimestamp",
                  "EnhancedMonitoring"
                ],
                members: {
                  StreamName: {},
                  StreamARN: {},
                  StreamStatus: {},
                  StreamModeDetails: {
                    shape: "S9"
                  },
                  Shards: {
                    shape: "Sv"
                  },
                  HasMoreShards: {
                    type: "boolean"
                  },
                  RetentionPeriodHours: {
                    type: "integer"
                  },
                  StreamCreationTimestamp: {
                    type: "timestamp"
                  },
                  EnhancedMonitoring: {
                    shape: "S12"
                  },
                  EncryptionType: {},
                  KeyId: {}
                }
              }
            }
          },
          staticContextParams: {
            OperationType: {
              value: "control"
            }
          }
        },
        DescribeStreamConsumer: {
          input: {
            type: "structure",
            members: {
              StreamARN: {
                contextParam: {
                  name: "StreamARN"
                }
              },
              ConsumerName: {},
              ConsumerARN: {
                contextParam: {
                  name: "ConsumerARN"
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ConsumerDescription"
            ],
            members: {
              ConsumerDescription: {
                type: "structure",
                required: [
                  "ConsumerName",
                  "ConsumerARN",
                  "ConsumerStatus",
                  "ConsumerCreationTimestamp",
                  "StreamARN"
                ],
                members: {
                  ConsumerName: {},
                  ConsumerARN: {},
                  ConsumerStatus: {},
                  ConsumerCreationTimestamp: {
                    type: "timestamp"
                  },
                  StreamARN: {}
                }
              }
            }
          },
          staticContextParams: {
            OperationType: {
              value: "control"
            }
          }
        },
        DescribeStreamSummary: {
          input: {
            type: "structure",
            members: {
              StreamName: {},
              StreamARN: {
                contextParam: {
                  name: "StreamARN"
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "StreamDescriptionSummary"
            ],
            members: {
              StreamDescriptionSummary: {
                type: "structure",
                required: [
                  "StreamName",
                  "StreamARN",
                  "StreamStatus",
                  "RetentionPeriodHours",
                  "StreamCreationTimestamp",
                  "EnhancedMonitoring",
                  "OpenShardCount"
                ],
                members: {
                  StreamName: {},
                  StreamARN: {},
                  StreamStatus: {},
                  StreamModeDetails: {
                    shape: "S9"
                  },
                  RetentionPeriodHours: {
                    type: "integer"
                  },
                  StreamCreationTimestamp: {
                    type: "timestamp"
                  },
                  EnhancedMonitoring: {
                    shape: "S12"
                  },
                  EncryptionType: {},
                  KeyId: {},
                  OpenShardCount: {
                    type: "integer"
                  },
                  ConsumerCount: {
                    type: "integer"
                  }
                }
              }
            }
          },
          staticContextParams: {
            OperationType: {
              value: "control"
            }
          }
        },
        DisableEnhancedMonitoring: {
          input: {
            type: "structure",
            required: [
              "ShardLevelMetrics"
            ],
            members: {
              StreamName: {},
              ShardLevelMetrics: {
                shape: "S14"
              },
              StreamARN: {
                contextParam: {
                  name: "StreamARN"
                }
              }
            }
          },
          output: {
            shape: "S1h"
          },
          staticContextParams: {
            OperationType: {
              value: "control"
            }
          }
        },
        EnableEnhancedMonitoring: {
          input: {
            type: "structure",
            required: [
              "ShardLevelMetrics"
            ],
            members: {
              StreamName: {},
              ShardLevelMetrics: {
                shape: "S14"
              },
              StreamARN: {
                contextParam: {
                  name: "StreamARN"
                }
              }
            }
          },
          output: {
            shape: "S1h"
          },
          staticContextParams: {
            OperationType: {
              value: "control"
            }
          }
        },
        GetRecords: {
          input: {
            type: "structure",
            required: [
              "ShardIterator"
            ],
            members: {
              ShardIterator: {},
              Limit: {
                type: "integer"
              },
              StreamARN: {
                contextParam: {
                  name: "StreamARN"
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Records"
            ],
            members: {
              Records: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "SequenceNumber",
                    "Data",
                    "PartitionKey"
                  ],
                  members: {
                    SequenceNumber: {},
                    ApproximateArrivalTimestamp: {
                      type: "timestamp"
                    },
                    Data: {
                      type: "blob"
                    },
                    PartitionKey: {},
                    EncryptionType: {}
                  }
                }
              },
              NextShardIterator: {},
              MillisBehindLatest: {
                type: "long"
              },
              ChildShards: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ShardId",
                    "ParentShards",
                    "HashKeyRange"
                  ],
                  members: {
                    ShardId: {},
                    ParentShards: {
                      type: "list",
                      member: {}
                    },
                    HashKeyRange: {
                      shape: "Sx"
                    }
                  }
                }
              }
            }
          },
          staticContextParams: {
            OperationType: {
              value: "data"
            }
          }
        },
        GetResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {
                contextParam: {
                  name: "ResourceARN"
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Policy"
            ],
            members: {
              Policy: {}
            }
          },
          staticContextParams: {
            OperationType: {
              value: "control"
            }
          }
        },
        GetShardIterator: {
          input: {
            type: "structure",
            required: [
              "ShardId",
              "ShardIteratorType"
            ],
            members: {
              StreamName: {},
              ShardId: {},
              ShardIteratorType: {},
              StartingSequenceNumber: {},
              Timestamp: {
                type: "timestamp"
              },
              StreamARN: {
                contextParam: {
                  name: "StreamARN"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ShardIterator: {}
            }
          },
          staticContextParams: {
            OperationType: {
              value: "data"
            }
          }
        },
        IncreaseStreamRetentionPeriod: {
          input: {
            type: "structure",
            required: [
              "RetentionPeriodHours"
            ],
            members: {
              StreamName: {},
              RetentionPeriodHours: {
                type: "integer"
              },
              StreamARN: {
                contextParam: {
                  name: "StreamARN"
                }
              }
            }
          },
          staticContextParams: {
            OperationType: {
              value: "control"
            }
          }
        },
        ListShards: {
          input: {
            type: "structure",
            members: {
              StreamName: {},
              NextToken: {},
              ExclusiveStartShardId: {},
              MaxResults: {
                type: "integer"
              },
              StreamCreationTimestamp: {
                type: "timestamp"
              },
              ShardFilter: {
                type: "structure",
                required: [
                  "Type"
                ],
                members: {
                  Type: {},
                  ShardId: {},
                  Timestamp: {
                    type: "timestamp"
                  }
                }
              },
              StreamARN: {
                contextParam: {
                  name: "StreamARN"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Shards: {
                shape: "Sv"
              },
              NextToken: {}
            }
          },
          staticContextParams: {
            OperationType: {
              value: "control"
            }
          }
        },
        ListStreamConsumers: {
          input: {
            type: "structure",
            required: [
              "StreamARN"
            ],
            members: {
              StreamARN: {
                contextParam: {
                  name: "StreamARN"
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              StreamCreationTimestamp: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Consumers: {
                type: "list",
                member: {
                  shape: "S2c"
                }
              },
              NextToken: {}
            }
          },
          staticContextParams: {
            OperationType: {
              value: "control"
            }
          }
        },
        ListStreams: {
          input: {
            type: "structure",
            members: {
              Limit: {
                type: "integer"
              },
              ExclusiveStartStreamName: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "StreamNames",
              "HasMoreStreams"
            ],
            members: {
              StreamNames: {
                type: "list",
                member: {}
              },
              HasMoreStreams: {
                type: "boolean"
              },
              NextToken: {},
              StreamSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "StreamName",
                    "StreamARN",
                    "StreamStatus"
                  ],
                  members: {
                    StreamName: {},
                    StreamARN: {},
                    StreamStatus: {},
                    StreamModeDetails: {
                      shape: "S9"
                    },
                    StreamCreationTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForStream: {
          input: {
            type: "structure",
            members: {
              StreamName: {},
              ExclusiveStartTagKey: {},
              Limit: {
                type: "integer"
              },
              StreamARN: {
                contextParam: {
                  name: "StreamARN"
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Tags",
              "HasMoreTags"
            ],
            members: {
              Tags: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key"
                  ],
                  members: {
                    Key: {},
                    Value: {}
                  }
                }
              },
              HasMoreTags: {
                type: "boolean"
              }
            }
          },
          staticContextParams: {
            OperationType: {
              value: "control"
            }
          }
        },
        MergeShards: {
          input: {
            type: "structure",
            required: [
              "ShardToMerge",
              "AdjacentShardToMerge"
            ],
            members: {
              StreamName: {},
              ShardToMerge: {},
              AdjacentShardToMerge: {},
              StreamARN: {
                contextParam: {
                  name: "StreamARN"
                }
              }
            }
          },
          staticContextParams: {
            OperationType: {
              value: "control"
            }
          }
        },
        PutRecord: {
          input: {
            type: "structure",
            required: [
              "Data",
              "PartitionKey"
            ],
            members: {
              StreamName: {},
              Data: {
                type: "blob"
              },
              PartitionKey: {},
              ExplicitHashKey: {},
              SequenceNumberForOrdering: {},
              StreamARN: {
                contextParam: {
                  name: "StreamARN"
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ShardId",
              "SequenceNumber"
            ],
            members: {
              ShardId: {},
              SequenceNumber: {},
              EncryptionType: {}
            }
          },
          staticContextParams: {
            OperationType: {
              value: "data"
            }
          }
        },
        PutRecords: {
          input: {
            type: "structure",
            required: [
              "Records"
            ],
            members: {
              Records: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Data",
                    "PartitionKey"
                  ],
                  members: {
                    Data: {
                      type: "blob"
                    },
                    ExplicitHashKey: {},
                    PartitionKey: {}
                  }
                }
              },
              StreamName: {},
              StreamARN: {
                contextParam: {
                  name: "StreamARN"
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Records"
            ],
            members: {
              FailedRecordCount: {
                type: "integer"
              },
              Records: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SequenceNumber: {},
                    ShardId: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              },
              EncryptionType: {}
            }
          },
          staticContextParams: {
            OperationType: {
              value: "data"
            }
          }
        },
        PutResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Policy"
            ],
            members: {
              ResourceARN: {
                contextParam: {
                  name: "ResourceARN"
                }
              },
              Policy: {}
            }
          },
          staticContextParams: {
            OperationType: {
              value: "control"
            }
          }
        },
        RegisterStreamConsumer: {
          input: {
            type: "structure",
            required: [
              "StreamARN",
              "ConsumerName"
            ],
            members: {
              StreamARN: {
                contextParam: {
                  name: "StreamARN"
                }
              },
              ConsumerName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Consumer"
            ],
            members: {
              Consumer: {
                shape: "S2c"
              }
            }
          },
          staticContextParams: {
            OperationType: {
              value: "control"
            }
          }
        },
        RemoveTagsFromStream: {
          input: {
            type: "structure",
            required: [
              "TagKeys"
            ],
            members: {
              StreamName: {},
              TagKeys: {
                type: "list",
                member: {}
              },
              StreamARN: {
                contextParam: {
                  name: "StreamARN"
                }
              }
            }
          },
          staticContextParams: {
            OperationType: {
              value: "control"
            }
          }
        },
        SplitShard: {
          input: {
            type: "structure",
            required: [
              "ShardToSplit",
              "NewStartingHashKey"
            ],
            members: {
              StreamName: {},
              ShardToSplit: {},
              NewStartingHashKey: {},
              StreamARN: {
                contextParam: {
                  name: "StreamARN"
                }
              }
            }
          },
          staticContextParams: {
            OperationType: {
              value: "control"
            }
          }
        },
        StartStreamEncryption: {
          input: {
            type: "structure",
            required: [
              "EncryptionType",
              "KeyId"
            ],
            members: {
              StreamName: {},
              EncryptionType: {},
              KeyId: {},
              StreamARN: {
                contextParam: {
                  name: "StreamARN"
                }
              }
            }
          },
          staticContextParams: {
            OperationType: {
              value: "control"
            }
          }
        },
        StopStreamEncryption: {
          input: {
            type: "structure",
            required: [
              "EncryptionType",
              "KeyId"
            ],
            members: {
              StreamName: {},
              EncryptionType: {},
              KeyId: {},
              StreamARN: {
                contextParam: {
                  name: "StreamARN"
                }
              }
            }
          },
          staticContextParams: {
            OperationType: {
              value: "control"
            }
          }
        },
        UpdateShardCount: {
          input: {
            type: "structure",
            required: [
              "TargetShardCount",
              "ScalingType"
            ],
            members: {
              StreamName: {},
              TargetShardCount: {
                type: "integer"
              },
              ScalingType: {},
              StreamARN: {
                contextParam: {
                  name: "StreamARN"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamName: {},
              CurrentShardCount: {
                type: "integer"
              },
              TargetShardCount: {
                type: "integer"
              },
              StreamARN: {}
            }
          },
          staticContextParams: {
            OperationType: {
              value: "control"
            }
          }
        },
        UpdateStreamMode: {
          input: {
            type: "structure",
            required: [
              "StreamARN",
              "StreamModeDetails"
            ],
            members: {
              StreamARN: {
                contextParam: {
                  name: "StreamARN"
                }
              },
              StreamModeDetails: {
                shape: "S9"
              }
            }
          },
          staticContextParams: {
            OperationType: {
              value: "control"
            }
          }
        }
      },
      shapes: {
        S9: {
          type: "structure",
          required: [
            "StreamMode"
          ],
          members: {
            StreamMode: {}
          }
        },
        Sv: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ShardId",
              "HashKeyRange",
              "SequenceNumberRange"
            ],
            members: {
              ShardId: {},
              ParentShardId: {},
              AdjacentParentShardId: {},
              HashKeyRange: {
                shape: "Sx"
              },
              SequenceNumberRange: {
                type: "structure",
                required: [
                  "StartingSequenceNumber"
                ],
                members: {
                  StartingSequenceNumber: {},
                  EndingSequenceNumber: {}
                }
              }
            }
          }
        },
        Sx: {
          type: "structure",
          required: [
            "StartingHashKey",
            "EndingHashKey"
          ],
          members: {
            StartingHashKey: {},
            EndingHashKey: {}
          }
        },
        S12: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ShardLevelMetrics: {
                shape: "S14"
              }
            }
          }
        },
        S14: {
          type: "list",
          member: {}
        },
        S1h: {
          type: "structure",
          members: {
            StreamName: {},
            CurrentShardLevelMetrics: {
              shape: "S14"
            },
            DesiredShardLevelMetrics: {
              shape: "S14"
            },
            StreamARN: {}
          }
        },
        S2c: {
          type: "structure",
          required: [
            "ConsumerName",
            "ConsumerARN",
            "ConsumerStatus",
            "ConsumerCreationTimestamp"
          ],
          members: {
            ConsumerName: {},
            ConsumerARN: {},
            ConsumerStatus: {},
            ConsumerCreationTimestamp: {
              type: "timestamp"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/kinesis-2013-12-02.paginators.json
var require_kinesis_2013_12_02_paginators = __commonJS({
  "node_modules/aws-sdk/apis/kinesis-2013-12-02.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeStream: {
          input_token: "ExclusiveStartShardId",
          limit_key: "Limit",
          more_results: "StreamDescription.HasMoreShards",
          output_token: "StreamDescription.Shards[-1].ShardId",
          result_key: "StreamDescription.Shards"
        },
        ListStreamConsumers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListStreams: {
          input_token: "NextToken",
          limit_key: "Limit",
          more_results: "HasMoreStreams",
          output_token: "NextToken",
          result_key: [
            "StreamNames",
            "StreamSummaries"
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/kinesis-2013-12-02.waiters2.json
var require_kinesis_2013_12_02_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/kinesis-2013-12-02.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        StreamExists: {
          delay: 10,
          operation: "DescribeStream",
          maxAttempts: 18,
          acceptors: [
            {
              expected: "ACTIVE",
              matcher: "path",
              state: "success",
              argument: "StreamDescription.StreamStatus"
            }
          ]
        },
        StreamNotExists: {
          delay: 10,
          operation: "DescribeStream",
          maxAttempts: 18,
          acceptors: [
            {
              expected: "ResourceNotFoundException",
              matcher: "error",
              state: "success"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/kinesis.js
var require_kinesis = __commonJS({
  "node_modules/aws-sdk/clients/kinesis.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["kinesis"] = {};
    AWS2.Kinesis = Service.defineService("kinesis", ["2013-12-02"]);
    Object.defineProperty(apiLoader.services["kinesis"], "2013-12-02", {
      get: function get() {
        var model = require_kinesis_2013_12_02_min();
        model.paginators = require_kinesis_2013_12_02_paginators().pagination;
        model.waiters = require_kinesis_2013_12_02_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Kinesis;
  }
});

// node_modules/aws-sdk/apis/kinesisanalytics-2015-08-14.min.json
var require_kinesisanalytics_2015_08_14_min = __commonJS({
  "node_modules/aws-sdk/apis/kinesisanalytics-2015-08-14.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-08-14",
        endpointPrefix: "kinesisanalytics",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Kinesis Analytics",
        serviceFullName: "Amazon Kinesis Analytics",
        serviceId: "Kinesis Analytics",
        signatureVersion: "v4",
        targetPrefix: "KinesisAnalytics_20150814",
        uid: "kinesisanalytics-2015-08-14"
      },
      operations: {
        AddApplicationCloudWatchLoggingOption: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "CloudWatchLoggingOption"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              CloudWatchLoggingOption: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AddApplicationInput: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "Input"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              Input: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AddApplicationInputProcessingConfiguration: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "InputId",
              "InputProcessingConfiguration"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              InputId: {},
              InputProcessingConfiguration: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AddApplicationOutput: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "Output"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              Output: {
                shape: "S12"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AddApplicationReferenceDataSource: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "ReferenceDataSource"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              ReferenceDataSource: {
                type: "structure",
                required: [
                  "TableName",
                  "ReferenceSchema"
                ],
                members: {
                  TableName: {},
                  S3ReferenceDataSource: {
                    type: "structure",
                    required: [
                      "BucketARN",
                      "FileKey",
                      "ReferenceRoleARN"
                    ],
                    members: {
                      BucketARN: {},
                      FileKey: {},
                      ReferenceRoleARN: {}
                    }
                  },
                  ReferenceSchema: {
                    shape: "Si"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName"
            ],
            members: {
              ApplicationName: {},
              ApplicationDescription: {},
              Inputs: {
                type: "list",
                member: {
                  shape: "S9"
                }
              },
              Outputs: {
                type: "list",
                member: {
                  shape: "S12"
                }
              },
              CloudWatchLoggingOptions: {
                type: "list",
                member: {
                  shape: "S4"
                }
              },
              ApplicationCode: {},
              Tags: {
                shape: "S1l"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ApplicationSummary"
            ],
            members: {
              ApplicationSummary: {
                shape: "S1q"
              }
            }
          }
        },
        DeleteApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CreateTimestamp"
            ],
            members: {
              ApplicationName: {},
              CreateTimestamp: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteApplicationCloudWatchLoggingOption: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "CloudWatchLoggingOptionId"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              CloudWatchLoggingOptionId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteApplicationInputProcessingConfiguration: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "InputId"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              InputId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteApplicationOutput: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "OutputId"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              OutputId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteApplicationReferenceDataSource: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "ReferenceId"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              ReferenceId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName"
            ],
            members: {
              ApplicationName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ApplicationDetail"
            ],
            members: {
              ApplicationDetail: {
                type: "structure",
                required: [
                  "ApplicationName",
                  "ApplicationARN",
                  "ApplicationStatus",
                  "ApplicationVersionId"
                ],
                members: {
                  ApplicationName: {},
                  ApplicationDescription: {},
                  ApplicationARN: {},
                  ApplicationStatus: {},
                  CreateTimestamp: {
                    type: "timestamp"
                  },
                  LastUpdateTimestamp: {
                    type: "timestamp"
                  },
                  InputDescriptions: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        InputId: {},
                        NamePrefix: {},
                        InAppStreamNames: {
                          type: "list",
                          member: {}
                        },
                        InputProcessingConfigurationDescription: {
                          type: "structure",
                          members: {
                            InputLambdaProcessorDescription: {
                              type: "structure",
                              members: {
                                ResourceARN: {},
                                RoleARN: {}
                              }
                            }
                          }
                        },
                        KinesisStreamsInputDescription: {
                          type: "structure",
                          members: {
                            ResourceARN: {},
                            RoleARN: {}
                          }
                        },
                        KinesisFirehoseInputDescription: {
                          type: "structure",
                          members: {
                            ResourceARN: {},
                            RoleARN: {}
                          }
                        },
                        InputSchema: {
                          shape: "Si"
                        },
                        InputParallelism: {
                          shape: "Sg"
                        },
                        InputStartingPositionConfiguration: {
                          shape: "S2d"
                        }
                      }
                    }
                  },
                  OutputDescriptions: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        OutputId: {},
                        Name: {},
                        KinesisStreamsOutputDescription: {
                          type: "structure",
                          members: {
                            ResourceARN: {},
                            RoleARN: {}
                          }
                        },
                        KinesisFirehoseOutputDescription: {
                          type: "structure",
                          members: {
                            ResourceARN: {},
                            RoleARN: {}
                          }
                        },
                        LambdaOutputDescription: {
                          type: "structure",
                          members: {
                            ResourceARN: {},
                            RoleARN: {}
                          }
                        },
                        DestinationSchema: {
                          shape: "S16"
                        }
                      }
                    }
                  },
                  ReferenceDataSourceDescriptions: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "ReferenceId",
                        "TableName",
                        "S3ReferenceDataSourceDescription"
                      ],
                      members: {
                        ReferenceId: {},
                        TableName: {},
                        S3ReferenceDataSourceDescription: {
                          type: "structure",
                          required: [
                            "BucketARN",
                            "FileKey",
                            "ReferenceRoleARN"
                          ],
                          members: {
                            BucketARN: {},
                            FileKey: {},
                            ReferenceRoleARN: {}
                          }
                        },
                        ReferenceSchema: {
                          shape: "Si"
                        }
                      }
                    }
                  },
                  CloudWatchLoggingOptionDescriptions: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "LogStreamARN",
                        "RoleARN"
                      ],
                      members: {
                        CloudWatchLoggingOptionId: {},
                        LogStreamARN: {},
                        RoleARN: {}
                      }
                    }
                  },
                  ApplicationCode: {},
                  ApplicationVersionId: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        DiscoverInputSchema: {
          input: {
            type: "structure",
            members: {
              ResourceARN: {},
              RoleARN: {},
              InputStartingPositionConfiguration: {
                shape: "S2d"
              },
              S3Configuration: {
                type: "structure",
                required: [
                  "RoleARN",
                  "BucketARN",
                  "FileKey"
                ],
                members: {
                  RoleARN: {},
                  BucketARN: {},
                  FileKey: {}
                }
              },
              InputProcessingConfiguration: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InputSchema: {
                shape: "Si"
              },
              ParsedInputRecords: {
                type: "list",
                member: {
                  type: "list",
                  member: {}
                }
              },
              ProcessedInputRecords: {
                type: "list",
                member: {}
              },
              RawInputRecords: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ListApplications: {
          input: {
            type: "structure",
            members: {
              Limit: {
                type: "integer"
              },
              ExclusiveStartApplicationName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ApplicationSummaries",
              "HasMoreApplications"
            ],
            members: {
              ApplicationSummaries: {
                type: "list",
                member: {
                  shape: "S1q"
                }
              },
              HasMoreApplications: {
                type: "boolean"
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S1l"
              }
            }
          }
        },
        StartApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "InputConfigurations"
            ],
            members: {
              ApplicationName: {},
              InputConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Id",
                    "InputStartingPositionConfiguration"
                  ],
                  members: {
                    Id: {},
                    InputStartingPositionConfiguration: {
                      shape: "S2d"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StopApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName"
            ],
            members: {
              ApplicationName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S1l"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "ApplicationUpdate"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              ApplicationUpdate: {
                type: "structure",
                members: {
                  InputUpdates: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "InputId"
                      ],
                      members: {
                        InputId: {},
                        NamePrefixUpdate: {},
                        InputProcessingConfigurationUpdate: {
                          type: "structure",
                          required: [
                            "InputLambdaProcessorUpdate"
                          ],
                          members: {
                            InputLambdaProcessorUpdate: {
                              type: "structure",
                              members: {
                                ResourceARNUpdate: {},
                                RoleARNUpdate: {}
                              }
                            }
                          }
                        },
                        KinesisStreamsInputUpdate: {
                          type: "structure",
                          members: {
                            ResourceARNUpdate: {},
                            RoleARNUpdate: {}
                          }
                        },
                        KinesisFirehoseInputUpdate: {
                          type: "structure",
                          members: {
                            ResourceARNUpdate: {},
                            RoleARNUpdate: {}
                          }
                        },
                        InputSchemaUpdate: {
                          type: "structure",
                          members: {
                            RecordFormatUpdate: {
                              shape: "Sj"
                            },
                            RecordEncodingUpdate: {},
                            RecordColumnUpdates: {
                              shape: "Ss"
                            }
                          }
                        },
                        InputParallelismUpdate: {
                          type: "structure",
                          members: {
                            CountUpdate: {
                              type: "integer"
                            }
                          }
                        }
                      }
                    }
                  },
                  ApplicationCodeUpdate: {},
                  OutputUpdates: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "OutputId"
                      ],
                      members: {
                        OutputId: {},
                        NameUpdate: {},
                        KinesisStreamsOutputUpdate: {
                          type: "structure",
                          members: {
                            ResourceARNUpdate: {},
                            RoleARNUpdate: {}
                          }
                        },
                        KinesisFirehoseOutputUpdate: {
                          type: "structure",
                          members: {
                            ResourceARNUpdate: {},
                            RoleARNUpdate: {}
                          }
                        },
                        LambdaOutputUpdate: {
                          type: "structure",
                          members: {
                            ResourceARNUpdate: {},
                            RoleARNUpdate: {}
                          }
                        },
                        DestinationSchemaUpdate: {
                          shape: "S16"
                        }
                      }
                    }
                  },
                  ReferenceDataSourceUpdates: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "ReferenceId"
                      ],
                      members: {
                        ReferenceId: {},
                        TableNameUpdate: {},
                        S3ReferenceDataSourceUpdate: {
                          type: "structure",
                          members: {
                            BucketARNUpdate: {},
                            FileKeyUpdate: {},
                            ReferenceRoleARNUpdate: {}
                          }
                        },
                        ReferenceSchemaUpdate: {
                          shape: "Si"
                        }
                      }
                    }
                  },
                  CloudWatchLoggingOptionUpdates: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "CloudWatchLoggingOptionId"
                      ],
                      members: {
                        CloudWatchLoggingOptionId: {},
                        LogStreamARNUpdate: {},
                        RoleARNUpdate: {}
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          required: [
            "LogStreamARN",
            "RoleARN"
          ],
          members: {
            LogStreamARN: {},
            RoleARN: {}
          }
        },
        S9: {
          type: "structure",
          required: [
            "NamePrefix",
            "InputSchema"
          ],
          members: {
            NamePrefix: {},
            InputProcessingConfiguration: {
              shape: "Sb"
            },
            KinesisStreamsInput: {
              type: "structure",
              required: [
                "ResourceARN",
                "RoleARN"
              ],
              members: {
                ResourceARN: {},
                RoleARN: {}
              }
            },
            KinesisFirehoseInput: {
              type: "structure",
              required: [
                "ResourceARN",
                "RoleARN"
              ],
              members: {
                ResourceARN: {},
                RoleARN: {}
              }
            },
            InputParallelism: {
              shape: "Sg"
            },
            InputSchema: {
              shape: "Si"
            }
          }
        },
        Sb: {
          type: "structure",
          required: [
            "InputLambdaProcessor"
          ],
          members: {
            InputLambdaProcessor: {
              type: "structure",
              required: [
                "ResourceARN",
                "RoleARN"
              ],
              members: {
                ResourceARN: {},
                RoleARN: {}
              }
            }
          }
        },
        Sg: {
          type: "structure",
          members: {
            Count: {
              type: "integer"
            }
          }
        },
        Si: {
          type: "structure",
          required: [
            "RecordFormat",
            "RecordColumns"
          ],
          members: {
            RecordFormat: {
              shape: "Sj"
            },
            RecordEncoding: {},
            RecordColumns: {
              shape: "Ss"
            }
          }
        },
        Sj: {
          type: "structure",
          required: [
            "RecordFormatType"
          ],
          members: {
            RecordFormatType: {},
            MappingParameters: {
              type: "structure",
              members: {
                JSONMappingParameters: {
                  type: "structure",
                  required: [
                    "RecordRowPath"
                  ],
                  members: {
                    RecordRowPath: {}
                  }
                },
                CSVMappingParameters: {
                  type: "structure",
                  required: [
                    "RecordRowDelimiter",
                    "RecordColumnDelimiter"
                  ],
                  members: {
                    RecordRowDelimiter: {},
                    RecordColumnDelimiter: {}
                  }
                }
              }
            }
          }
        },
        Ss: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "SqlType"
            ],
            members: {
              Name: {},
              Mapping: {},
              SqlType: {}
            }
          }
        },
        S12: {
          type: "structure",
          required: [
            "Name",
            "DestinationSchema"
          ],
          members: {
            Name: {},
            KinesisStreamsOutput: {
              type: "structure",
              required: [
                "ResourceARN",
                "RoleARN"
              ],
              members: {
                ResourceARN: {},
                RoleARN: {}
              }
            },
            KinesisFirehoseOutput: {
              type: "structure",
              required: [
                "ResourceARN",
                "RoleARN"
              ],
              members: {
                ResourceARN: {},
                RoleARN: {}
              }
            },
            LambdaOutput: {
              type: "structure",
              required: [
                "ResourceARN",
                "RoleARN"
              ],
              members: {
                ResourceARN: {},
                RoleARN: {}
              }
            },
            DestinationSchema: {
              shape: "S16"
            }
          }
        },
        S16: {
          type: "structure",
          required: [
            "RecordFormatType"
          ],
          members: {
            RecordFormatType: {}
          }
        },
        S1l: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S1q: {
          type: "structure",
          required: [
            "ApplicationName",
            "ApplicationARN",
            "ApplicationStatus"
          ],
          members: {
            ApplicationName: {},
            ApplicationARN: {},
            ApplicationStatus: {}
          }
        },
        S2d: {
          type: "structure",
          members: {
            InputStartingPosition: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/kinesisanalytics-2015-08-14.paginators.json
var require_kinesisanalytics_2015_08_14_paginators = __commonJS({
  "node_modules/aws-sdk/apis/kinesisanalytics-2015-08-14.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/kinesisanalytics.js
var require_kinesisanalytics = __commonJS({
  "node_modules/aws-sdk/clients/kinesisanalytics.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["kinesisanalytics"] = {};
    AWS2.KinesisAnalytics = Service.defineService("kinesisanalytics", ["2015-08-14"]);
    Object.defineProperty(apiLoader.services["kinesisanalytics"], "2015-08-14", {
      get: function get() {
        var model = require_kinesisanalytics_2015_08_14_min();
        model.paginators = require_kinesisanalytics_2015_08_14_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.KinesisAnalytics;
  }
});

// node_modules/aws-sdk/apis/kms-2014-11-01.min.json
var require_kms_2014_11_01_min = __commonJS({
  "node_modules/aws-sdk/apis/kms-2014-11-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-11-01",
        endpointPrefix: "kms",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "KMS",
        serviceFullName: "AWS Key Management Service",
        serviceId: "KMS",
        signatureVersion: "v4",
        targetPrefix: "TrentService",
        uid: "kms-2014-11-01"
      },
      operations: {
        CancelKeyDeletion: {
          input: {
            type: "structure",
            required: [
              "KeyId"
            ],
            members: {
              KeyId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              KeyId: {}
            }
          }
        },
        ConnectCustomKeyStore: {
          input: {
            type: "structure",
            required: [
              "CustomKeyStoreId"
            ],
            members: {
              CustomKeyStoreId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateAlias: {
          input: {
            type: "structure",
            required: [
              "AliasName",
              "TargetKeyId"
            ],
            members: {
              AliasName: {},
              TargetKeyId: {}
            }
          }
        },
        CreateCustomKeyStore: {
          input: {
            type: "structure",
            required: [
              "CustomKeyStoreName"
            ],
            members: {
              CustomKeyStoreName: {},
              CloudHsmClusterId: {},
              TrustAnchorCertificate: {},
              KeyStorePassword: {
                shape: "Sd"
              },
              CustomKeyStoreType: {},
              XksProxyUriEndpoint: {},
              XksProxyUriPath: {},
              XksProxyVpcEndpointServiceName: {},
              XksProxyAuthenticationCredential: {
                shape: "Si"
              },
              XksProxyConnectivity: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CustomKeyStoreId: {}
            }
          }
        },
        CreateGrant: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "GranteePrincipal",
              "Operations"
            ],
            members: {
              KeyId: {},
              GranteePrincipal: {},
              RetiringPrincipal: {},
              Operations: {
                shape: "Sp"
              },
              Constraints: {
                shape: "Sr"
              },
              GrantTokens: {
                shape: "Sv"
              },
              Name: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GrantToken: {},
              GrantId: {}
            }
          }
        },
        CreateKey: {
          input: {
            type: "structure",
            members: {
              Policy: {},
              Description: {},
              KeyUsage: {},
              CustomerMasterKeySpec: {
                shape: "S15",
                deprecated: true,
                deprecatedMessage: "This parameter has been deprecated. Instead, use the KeySpec parameter."
              },
              KeySpec: {},
              Origin: {},
              CustomKeyStoreId: {},
              BypassPolicyLockoutSafetyCheck: {
                type: "boolean"
              },
              Tags: {
                shape: "S19"
              },
              MultiRegion: {
                type: "boolean"
              },
              XksKeyId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              KeyMetadata: {
                shape: "S1f"
              }
            }
          }
        },
        Decrypt: {
          input: {
            type: "structure",
            required: [
              "CiphertextBlob"
            ],
            members: {
              CiphertextBlob: {
                type: "blob"
              },
              EncryptionContext: {
                shape: "Ss"
              },
              GrantTokens: {
                shape: "Sv"
              },
              KeyId: {},
              EncryptionAlgorithm: {},
              Recipient: {
                shape: "S21"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KeyId: {},
              Plaintext: {
                shape: "S25"
              },
              EncryptionAlgorithm: {},
              CiphertextForRecipient: {
                type: "blob"
              }
            }
          }
        },
        DeleteAlias: {
          input: {
            type: "structure",
            required: [
              "AliasName"
            ],
            members: {
              AliasName: {}
            }
          }
        },
        DeleteCustomKeyStore: {
          input: {
            type: "structure",
            required: [
              "CustomKeyStoreId"
            ],
            members: {
              CustomKeyStoreId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteImportedKeyMaterial: {
          input: {
            type: "structure",
            required: [
              "KeyId"
            ],
            members: {
              KeyId: {}
            }
          }
        },
        DescribeCustomKeyStores: {
          input: {
            type: "structure",
            members: {
              CustomKeyStoreId: {},
              CustomKeyStoreName: {},
              Limit: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CustomKeyStores: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CustomKeyStoreId: {},
                    CustomKeyStoreName: {},
                    CloudHsmClusterId: {},
                    TrustAnchorCertificate: {},
                    ConnectionState: {},
                    ConnectionErrorCode: {},
                    CreationDate: {
                      type: "timestamp"
                    },
                    CustomKeyStoreType: {},
                    XksProxyConfiguration: {
                      type: "structure",
                      members: {
                        Connectivity: {},
                        AccessKeyId: {
                          shape: "Sj"
                        },
                        UriEndpoint: {},
                        UriPath: {},
                        VpcEndpointServiceName: {}
                      }
                    }
                  }
                }
              },
              NextMarker: {},
              Truncated: {
                type: "boolean"
              }
            }
          }
        },
        DescribeKey: {
          input: {
            type: "structure",
            required: [
              "KeyId"
            ],
            members: {
              KeyId: {},
              GrantTokens: {
                shape: "Sv"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KeyMetadata: {
                shape: "S1f"
              }
            }
          }
        },
        DisableKey: {
          input: {
            type: "structure",
            required: [
              "KeyId"
            ],
            members: {
              KeyId: {}
            }
          }
        },
        DisableKeyRotation: {
          input: {
            type: "structure",
            required: [
              "KeyId"
            ],
            members: {
              KeyId: {}
            }
          }
        },
        DisconnectCustomKeyStore: {
          input: {
            type: "structure",
            required: [
              "CustomKeyStoreId"
            ],
            members: {
              CustomKeyStoreId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        EnableKey: {
          input: {
            type: "structure",
            required: [
              "KeyId"
            ],
            members: {
              KeyId: {}
            }
          }
        },
        EnableKeyRotation: {
          input: {
            type: "structure",
            required: [
              "KeyId"
            ],
            members: {
              KeyId: {}
            }
          }
        },
        Encrypt: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "Plaintext"
            ],
            members: {
              KeyId: {},
              Plaintext: {
                shape: "S25"
              },
              EncryptionContext: {
                shape: "Ss"
              },
              GrantTokens: {
                shape: "Sv"
              },
              EncryptionAlgorithm: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CiphertextBlob: {
                type: "blob"
              },
              KeyId: {},
              EncryptionAlgorithm: {}
            }
          }
        },
        GenerateDataKey: {
          input: {
            type: "structure",
            required: [
              "KeyId"
            ],
            members: {
              KeyId: {},
              EncryptionContext: {
                shape: "Ss"
              },
              NumberOfBytes: {
                type: "integer"
              },
              KeySpec: {},
              GrantTokens: {
                shape: "Sv"
              },
              Recipient: {
                shape: "S21"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CiphertextBlob: {
                type: "blob"
              },
              Plaintext: {
                shape: "S25"
              },
              KeyId: {},
              CiphertextForRecipient: {
                type: "blob"
              }
            }
          }
        },
        GenerateDataKeyPair: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "KeyPairSpec"
            ],
            members: {
              EncryptionContext: {
                shape: "Ss"
              },
              KeyId: {},
              KeyPairSpec: {},
              GrantTokens: {
                shape: "Sv"
              },
              Recipient: {
                shape: "S21"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PrivateKeyCiphertextBlob: {
                type: "blob"
              },
              PrivateKeyPlaintext: {
                shape: "S25"
              },
              PublicKey: {
                type: "blob"
              },
              KeyId: {},
              KeyPairSpec: {},
              CiphertextForRecipient: {
                type: "blob"
              }
            }
          }
        },
        GenerateDataKeyPairWithoutPlaintext: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "KeyPairSpec"
            ],
            members: {
              EncryptionContext: {
                shape: "Ss"
              },
              KeyId: {},
              KeyPairSpec: {},
              GrantTokens: {
                shape: "Sv"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PrivateKeyCiphertextBlob: {
                type: "blob"
              },
              PublicKey: {
                type: "blob"
              },
              KeyId: {},
              KeyPairSpec: {}
            }
          }
        },
        GenerateDataKeyWithoutPlaintext: {
          input: {
            type: "structure",
            required: [
              "KeyId"
            ],
            members: {
              KeyId: {},
              EncryptionContext: {
                shape: "Ss"
              },
              KeySpec: {},
              NumberOfBytes: {
                type: "integer"
              },
              GrantTokens: {
                shape: "Sv"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CiphertextBlob: {
                type: "blob"
              },
              KeyId: {}
            }
          }
        },
        GenerateMac: {
          input: {
            type: "structure",
            required: [
              "Message",
              "KeyId",
              "MacAlgorithm"
            ],
            members: {
              Message: {
                shape: "S25"
              },
              KeyId: {},
              MacAlgorithm: {},
              GrantTokens: {
                shape: "Sv"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Mac: {
                type: "blob"
              },
              MacAlgorithm: {},
              KeyId: {}
            }
          }
        },
        GenerateRandom: {
          input: {
            type: "structure",
            members: {
              NumberOfBytes: {
                type: "integer"
              },
              CustomKeyStoreId: {},
              Recipient: {
                shape: "S21"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Plaintext: {
                shape: "S25"
              },
              CiphertextForRecipient: {
                type: "blob"
              }
            }
          }
        },
        GetKeyPolicy: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "PolicyName"
            ],
            members: {
              KeyId: {},
              PolicyName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {}
            }
          }
        },
        GetKeyRotationStatus: {
          input: {
            type: "structure",
            required: [
              "KeyId"
            ],
            members: {
              KeyId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              KeyRotationEnabled: {
                type: "boolean"
              }
            }
          }
        },
        GetParametersForImport: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "WrappingAlgorithm",
              "WrappingKeySpec"
            ],
            members: {
              KeyId: {},
              WrappingAlgorithm: {},
              WrappingKeySpec: {}
            }
          },
          output: {
            type: "structure",
            members: {
              KeyId: {},
              ImportToken: {
                type: "blob"
              },
              PublicKey: {
                shape: "S25"
              },
              ParametersValidTo: {
                type: "timestamp"
              }
            }
          }
        },
        GetPublicKey: {
          input: {
            type: "structure",
            required: [
              "KeyId"
            ],
            members: {
              KeyId: {},
              GrantTokens: {
                shape: "Sv"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KeyId: {},
              PublicKey: {
                type: "blob"
              },
              CustomerMasterKeySpec: {
                shape: "S15",
                deprecated: true,
                deprecatedMessage: "This field has been deprecated. Instead, use the KeySpec field."
              },
              KeySpec: {},
              KeyUsage: {},
              EncryptionAlgorithms: {
                shape: "S1m"
              },
              SigningAlgorithms: {
                shape: "S1o"
              }
            }
          }
        },
        ImportKeyMaterial: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "ImportToken",
              "EncryptedKeyMaterial"
            ],
            members: {
              KeyId: {},
              ImportToken: {
                type: "blob"
              },
              EncryptedKeyMaterial: {
                type: "blob"
              },
              ValidTo: {
                type: "timestamp"
              },
              ExpirationModel: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ListAliases: {
          input: {
            type: "structure",
            members: {
              KeyId: {},
              Limit: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Aliases: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AliasName: {},
                    AliasArn: {},
                    TargetKeyId: {},
                    CreationDate: {
                      type: "timestamp"
                    },
                    LastUpdatedDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextMarker: {},
              Truncated: {
                type: "boolean"
              }
            }
          }
        },
        ListGrants: {
          input: {
            type: "structure",
            required: [
              "KeyId"
            ],
            members: {
              Limit: {
                type: "integer"
              },
              Marker: {},
              KeyId: {},
              GrantId: {},
              GranteePrincipal: {}
            }
          },
          output: {
            shape: "S3r"
          }
        },
        ListKeyPolicies: {
          input: {
            type: "structure",
            required: [
              "KeyId"
            ],
            members: {
              KeyId: {},
              Limit: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyNames: {
                type: "list",
                member: {}
              },
              NextMarker: {},
              Truncated: {
                type: "boolean"
              }
            }
          }
        },
        ListKeys: {
          input: {
            type: "structure",
            members: {
              Limit: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Keys: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    KeyId: {},
                    KeyArn: {}
                  }
                }
              },
              NextMarker: {},
              Truncated: {
                type: "boolean"
              }
            }
          }
        },
        ListResourceTags: {
          input: {
            type: "structure",
            required: [
              "KeyId"
            ],
            members: {
              KeyId: {},
              Limit: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S19"
              },
              NextMarker: {},
              Truncated: {
                type: "boolean"
              }
            }
          }
        },
        ListRetirableGrants: {
          input: {
            type: "structure",
            required: [
              "RetiringPrincipal"
            ],
            members: {
              Limit: {
                type: "integer"
              },
              Marker: {},
              RetiringPrincipal: {}
            }
          },
          output: {
            shape: "S3r"
          }
        },
        PutKeyPolicy: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "PolicyName",
              "Policy"
            ],
            members: {
              KeyId: {},
              PolicyName: {},
              Policy: {},
              BypassPolicyLockoutSafetyCheck: {
                type: "boolean"
              }
            }
          }
        },
        ReEncrypt: {
          input: {
            type: "structure",
            required: [
              "CiphertextBlob",
              "DestinationKeyId"
            ],
            members: {
              CiphertextBlob: {
                type: "blob"
              },
              SourceEncryptionContext: {
                shape: "Ss"
              },
              SourceKeyId: {},
              DestinationKeyId: {},
              DestinationEncryptionContext: {
                shape: "Ss"
              },
              SourceEncryptionAlgorithm: {},
              DestinationEncryptionAlgorithm: {},
              GrantTokens: {
                shape: "Sv"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CiphertextBlob: {
                type: "blob"
              },
              SourceKeyId: {},
              KeyId: {},
              SourceEncryptionAlgorithm: {},
              DestinationEncryptionAlgorithm: {}
            }
          }
        },
        ReplicateKey: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "ReplicaRegion"
            ],
            members: {
              KeyId: {},
              ReplicaRegion: {},
              Policy: {},
              BypassPolicyLockoutSafetyCheck: {
                type: "boolean"
              },
              Description: {},
              Tags: {
                shape: "S19"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicaKeyMetadata: {
                shape: "S1f"
              },
              ReplicaPolicy: {},
              ReplicaTags: {
                shape: "S19"
              }
            }
          }
        },
        RetireGrant: {
          input: {
            type: "structure",
            members: {
              GrantToken: {},
              KeyId: {},
              GrantId: {},
              DryRun: {
                type: "boolean"
              }
            }
          }
        },
        RevokeGrant: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "GrantId"
            ],
            members: {
              KeyId: {},
              GrantId: {},
              DryRun: {
                type: "boolean"
              }
            }
          }
        },
        ScheduleKeyDeletion: {
          input: {
            type: "structure",
            required: [
              "KeyId"
            ],
            members: {
              KeyId: {},
              PendingWindowInDays: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KeyId: {},
              DeletionDate: {
                type: "timestamp"
              },
              KeyState: {},
              PendingWindowInDays: {
                type: "integer"
              }
            }
          }
        },
        Sign: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "Message",
              "SigningAlgorithm"
            ],
            members: {
              KeyId: {},
              Message: {
                shape: "S25"
              },
              MessageType: {},
              GrantTokens: {
                shape: "Sv"
              },
              SigningAlgorithm: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KeyId: {},
              Signature: {
                type: "blob"
              },
              SigningAlgorithm: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "Tags"
            ],
            members: {
              KeyId: {},
              Tags: {
                shape: "S19"
              }
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "TagKeys"
            ],
            members: {
              KeyId: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        },
        UpdateAlias: {
          input: {
            type: "structure",
            required: [
              "AliasName",
              "TargetKeyId"
            ],
            members: {
              AliasName: {},
              TargetKeyId: {}
            }
          }
        },
        UpdateCustomKeyStore: {
          input: {
            type: "structure",
            required: [
              "CustomKeyStoreId"
            ],
            members: {
              CustomKeyStoreId: {},
              NewCustomKeyStoreName: {},
              KeyStorePassword: {
                shape: "Sd"
              },
              CloudHsmClusterId: {},
              XksProxyUriEndpoint: {},
              XksProxyUriPath: {},
              XksProxyVpcEndpointServiceName: {},
              XksProxyAuthenticationCredential: {
                shape: "Si"
              },
              XksProxyConnectivity: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateKeyDescription: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "Description"
            ],
            members: {
              KeyId: {},
              Description: {}
            }
          }
        },
        UpdatePrimaryRegion: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "PrimaryRegion"
            ],
            members: {
              KeyId: {},
              PrimaryRegion: {}
            }
          }
        },
        Verify: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "Message",
              "Signature",
              "SigningAlgorithm"
            ],
            members: {
              KeyId: {},
              Message: {
                shape: "S25"
              },
              MessageType: {},
              Signature: {
                type: "blob"
              },
              SigningAlgorithm: {},
              GrantTokens: {
                shape: "Sv"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KeyId: {},
              SignatureValid: {
                type: "boolean"
              },
              SigningAlgorithm: {}
            }
          }
        },
        VerifyMac: {
          input: {
            type: "structure",
            required: [
              "Message",
              "KeyId",
              "MacAlgorithm",
              "Mac"
            ],
            members: {
              Message: {
                shape: "S25"
              },
              KeyId: {},
              MacAlgorithm: {},
              Mac: {
                type: "blob"
              },
              GrantTokens: {
                shape: "Sv"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KeyId: {},
              MacValid: {
                type: "boolean"
              },
              MacAlgorithm: {}
            }
          }
        }
      },
      shapes: {
        Sd: {
          type: "string",
          sensitive: true
        },
        Si: {
          type: "structure",
          required: [
            "AccessKeyId",
            "RawSecretAccessKey"
          ],
          members: {
            AccessKeyId: {
              shape: "Sj"
            },
            RawSecretAccessKey: {
              type: "string",
              sensitive: true
            }
          }
        },
        Sj: {
          type: "string",
          sensitive: true
        },
        Sp: {
          type: "list",
          member: {}
        },
        Sr: {
          type: "structure",
          members: {
            EncryptionContextSubset: {
              shape: "Ss"
            },
            EncryptionContextEquals: {
              shape: "Ss"
            }
          }
        },
        Ss: {
          type: "map",
          key: {},
          value: {}
        },
        Sv: {
          type: "list",
          member: {}
        },
        S15: {
          type: "string",
          deprecated: true,
          deprecatedMessage: "This enum has been deprecated. Instead, use the KeySpec enum."
        },
        S19: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "TagKey",
              "TagValue"
            ],
            members: {
              TagKey: {},
              TagValue: {}
            }
          }
        },
        S1f: {
          type: "structure",
          required: [
            "KeyId"
          ],
          members: {
            AWSAccountId: {},
            KeyId: {},
            Arn: {},
            CreationDate: {
              type: "timestamp"
            },
            Enabled: {
              type: "boolean"
            },
            Description: {},
            KeyUsage: {},
            KeyState: {},
            DeletionDate: {
              type: "timestamp"
            },
            ValidTo: {
              type: "timestamp"
            },
            Origin: {},
            CustomKeyStoreId: {},
            CloudHsmClusterId: {},
            ExpirationModel: {},
            KeyManager: {},
            CustomerMasterKeySpec: {
              shape: "S15",
              deprecated: true,
              deprecatedMessage: "This field has been deprecated. Instead, use the KeySpec field."
            },
            KeySpec: {},
            EncryptionAlgorithms: {
              shape: "S1m"
            },
            SigningAlgorithms: {
              shape: "S1o"
            },
            MultiRegion: {
              type: "boolean"
            },
            MultiRegionConfiguration: {
              type: "structure",
              members: {
                MultiRegionKeyType: {},
                PrimaryKey: {
                  shape: "S1s"
                },
                ReplicaKeys: {
                  type: "list",
                  member: {
                    shape: "S1s"
                  }
                }
              }
            },
            PendingDeletionWindowInDays: {
              type: "integer"
            },
            MacAlgorithms: {
              type: "list",
              member: {}
            },
            XksKeyConfiguration: {
              type: "structure",
              members: {
                Id: {}
              }
            }
          }
        },
        S1m: {
          type: "list",
          member: {}
        },
        S1o: {
          type: "list",
          member: {}
        },
        S1s: {
          type: "structure",
          members: {
            Arn: {},
            Region: {}
          }
        },
        S21: {
          type: "structure",
          members: {
            KeyEncryptionAlgorithm: {},
            AttestationDocument: {
              type: "blob"
            }
          }
        },
        S25: {
          type: "blob",
          sensitive: true
        },
        S3r: {
          type: "structure",
          members: {
            Grants: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  KeyId: {},
                  GrantId: {},
                  Name: {},
                  CreationDate: {
                    type: "timestamp"
                  },
                  GranteePrincipal: {},
                  RetiringPrincipal: {},
                  IssuingAccount: {},
                  Operations: {
                    shape: "Sp"
                  },
                  Constraints: {
                    shape: "Sr"
                  }
                }
              }
            },
            NextMarker: {},
            Truncated: {
              type: "boolean"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/kms-2014-11-01.paginators.json
var require_kms_2014_11_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/kms-2014-11-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeCustomKeyStores: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "NextMarker",
          result_key: "CustomKeyStores"
        },
        ListAliases: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "NextMarker",
          result_key: "Aliases"
        },
        ListGrants: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "NextMarker",
          result_key: "Grants"
        },
        ListKeyPolicies: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "NextMarker",
          result_key: "PolicyNames"
        },
        ListKeys: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "NextMarker",
          result_key: "Keys"
        },
        ListResourceTags: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "NextMarker",
          result_key: "Tags"
        },
        ListRetirableGrants: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "NextMarker",
          result_key: "Grants"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/kms.js
var require_kms = __commonJS({
  "node_modules/aws-sdk/clients/kms.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["kms"] = {};
    AWS2.KMS = Service.defineService("kms", ["2014-11-01"]);
    Object.defineProperty(apiLoader.services["kms"], "2014-11-01", {
      get: function get() {
        var model = require_kms_2014_11_01_min();
        model.paginators = require_kms_2014_11_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.KMS;
  }
});

// node_modules/aws-sdk/lib/services/lambda.js
var require_lambda = __commonJS({
  "node_modules/aws-sdk/lib/services/lambda.js"() {
    "use strict";
    var AWS2 = require_core();
    AWS2.util.update(AWS2.Lambda.prototype, {
      /**
       * @api private
       */
      setupRequestListeners: function setupRequestListeners(request) {
        if (request.operation === "invoke") {
          request.addListener("extractData", AWS2.util.convertPayloadToString);
        }
      }
    });
  }
});

// node_modules/aws-sdk/apis/lambda-2014-11-11.min.json
var require_lambda_2014_11_11_min = __commonJS({
  "node_modules/aws-sdk/apis/lambda-2014-11-11.min.json"(exports2, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2014-11-11",
        endpointPrefix: "lambda",
        serviceFullName: "AWS Lambda",
        serviceId: "Lambda",
        signatureVersion: "v4",
        protocol: "rest-json"
      },
      operations: {
        AddEventSource: {
          http: {
            requestUri: "/2014-11-13/event-source-mappings/"
          },
          input: {
            type: "structure",
            required: [
              "EventSource",
              "FunctionName",
              "Role"
            ],
            members: {
              EventSource: {},
              FunctionName: {},
              Role: {},
              BatchSize: {
                type: "integer"
              },
              Parameters: {
                shape: "S6"
              }
            }
          },
          output: {
            shape: "S7"
          }
        },
        DeleteFunction: {
          http: {
            method: "DELETE",
            requestUri: "/2014-11-13/functions/{FunctionName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              }
            }
          }
        },
        GetEventSource: {
          http: {
            method: "GET",
            requestUri: "/2014-11-13/event-source-mappings/{UUID}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "UUID"
            ],
            members: {
              UUID: {
                location: "uri",
                locationName: "UUID"
              }
            }
          },
          output: {
            shape: "S7"
          }
        },
        GetFunction: {
          http: {
            method: "GET",
            requestUri: "/2014-11-13/functions/{FunctionName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Configuration: {
                shape: "Se"
              },
              Code: {
                type: "structure",
                members: {
                  RepositoryType: {},
                  Location: {}
                }
              }
            }
          }
        },
        GetFunctionConfiguration: {
          http: {
            method: "GET",
            requestUri: "/2014-11-13/functions/{FunctionName}/configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              }
            }
          },
          output: {
            shape: "Se"
          }
        },
        InvokeAsync: {
          http: {
            requestUri: "/2014-11-13/functions/{FunctionName}/invoke-async/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "FunctionName",
              "InvokeArgs"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              InvokeArgs: {
                shape: "Sq"
              }
            },
            payload: "InvokeArgs"
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        ListEventSources: {
          http: {
            method: "GET",
            requestUri: "/2014-11-13/event-source-mappings/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              EventSourceArn: {
                location: "querystring",
                locationName: "EventSource"
              },
              FunctionName: {
                location: "querystring",
                locationName: "FunctionName"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              EventSources: {
                type: "list",
                member: {
                  shape: "S7"
                }
              }
            }
          }
        },
        ListFunctions: {
          http: {
            method: "GET",
            requestUri: "/2014-11-13/functions/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              Functions: {
                type: "list",
                member: {
                  shape: "Se"
                }
              }
            }
          }
        },
        RemoveEventSource: {
          http: {
            method: "DELETE",
            requestUri: "/2014-11-13/event-source-mappings/{UUID}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "UUID"
            ],
            members: {
              UUID: {
                location: "uri",
                locationName: "UUID"
              }
            }
          }
        },
        UpdateFunctionConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/2014-11-13/functions/{FunctionName}/configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Role: {
                location: "querystring",
                locationName: "Role"
              },
              Handler: {
                location: "querystring",
                locationName: "Handler"
              },
              Description: {
                location: "querystring",
                locationName: "Description"
              },
              Timeout: {
                location: "querystring",
                locationName: "Timeout",
                type: "integer"
              },
              MemorySize: {
                location: "querystring",
                locationName: "MemorySize",
                type: "integer"
              }
            }
          },
          output: {
            shape: "Se"
          }
        },
        UploadFunction: {
          http: {
            method: "PUT",
            requestUri: "/2014-11-13/functions/{FunctionName}",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FunctionName",
              "FunctionZip",
              "Runtime",
              "Role",
              "Handler",
              "Mode"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              FunctionZip: {
                shape: "Sq"
              },
              Runtime: {
                location: "querystring",
                locationName: "Runtime"
              },
              Role: {
                location: "querystring",
                locationName: "Role"
              },
              Handler: {
                location: "querystring",
                locationName: "Handler"
              },
              Mode: {
                location: "querystring",
                locationName: "Mode"
              },
              Description: {
                location: "querystring",
                locationName: "Description"
              },
              Timeout: {
                location: "querystring",
                locationName: "Timeout",
                type: "integer"
              },
              MemorySize: {
                location: "querystring",
                locationName: "MemorySize",
                type: "integer"
              }
            },
            payload: "FunctionZip"
          },
          output: {
            shape: "Se"
          }
        }
      },
      shapes: {
        S6: {
          type: "map",
          key: {},
          value: {}
        },
        S7: {
          type: "structure",
          members: {
            UUID: {},
            BatchSize: {
              type: "integer"
            },
            EventSource: {},
            FunctionName: {},
            Parameters: {
              shape: "S6"
            },
            Role: {},
            LastModified: {
              type: "timestamp"
            },
            IsActive: {
              type: "boolean"
            },
            Status: {}
          }
        },
        Se: {
          type: "structure",
          members: {
            FunctionName: {},
            FunctionARN: {},
            ConfigurationId: {},
            Runtime: {},
            Role: {},
            Handler: {},
            Mode: {},
            CodeSize: {
              type: "long"
            },
            Description: {},
            Timeout: {
              type: "integer"
            },
            MemorySize: {
              type: "integer"
            },
            LastModified: {
              type: "timestamp"
            }
          }
        },
        Sq: {
          type: "blob",
          streaming: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/lambda-2014-11-11.paginators.json
var require_lambda_2014_11_11_paginators = __commonJS({
  "node_modules/aws-sdk/apis/lambda-2014-11-11.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListEventSources: {
          input_token: "Marker",
          output_token: "NextMarker",
          limit_key: "MaxItems",
          result_key: "EventSources"
        },
        ListFunctions: {
          input_token: "Marker",
          output_token: "NextMarker",
          limit_key: "MaxItems",
          result_key: "Functions"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/lambda-2015-03-31.min.json
var require_lambda_2015_03_31_min = __commonJS({
  "node_modules/aws-sdk/apis/lambda-2015-03-31.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-03-31",
        endpointPrefix: "lambda",
        protocol: "rest-json",
        serviceFullName: "AWS Lambda",
        serviceId: "Lambda",
        signatureVersion: "v4",
        uid: "lambda-2015-03-31"
      },
      operations: {
        AddLayerVersionPermission: {
          http: {
            requestUri: "/2018-10-31/layers/{LayerName}/versions/{VersionNumber}/policy",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "LayerName",
              "VersionNumber",
              "StatementId",
              "Action",
              "Principal"
            ],
            members: {
              LayerName: {
                location: "uri",
                locationName: "LayerName"
              },
              VersionNumber: {
                location: "uri",
                locationName: "VersionNumber",
                type: "long"
              },
              StatementId: {},
              Action: {},
              Principal: {},
              OrganizationId: {},
              RevisionId: {
                location: "querystring",
                locationName: "RevisionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Statement: {},
              RevisionId: {}
            }
          }
        },
        AddPermission: {
          http: {
            requestUri: "/2015-03-31/functions/{FunctionName}/policy",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FunctionName",
              "StatementId",
              "Action",
              "Principal"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              StatementId: {},
              Action: {},
              Principal: {},
              SourceArn: {},
              SourceAccount: {},
              EventSourceToken: {},
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              },
              RevisionId: {},
              PrincipalOrgID: {},
              FunctionUrlAuthType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Statement: {}
            }
          }
        },
        CreateAlias: {
          http: {
            requestUri: "/2015-03-31/functions/{FunctionName}/aliases",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FunctionName",
              "Name",
              "FunctionVersion"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Name: {},
              FunctionVersion: {},
              Description: {},
              RoutingConfig: {
                shape: "Sp"
              }
            }
          },
          output: {
            shape: "St"
          }
        },
        CreateCodeSigningConfig: {
          http: {
            requestUri: "/2020-04-22/code-signing-configs/",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AllowedPublishers"
            ],
            members: {
              Description: {},
              AllowedPublishers: {
                shape: "Sw"
              },
              CodeSigningPolicies: {
                shape: "Sy"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CodeSigningConfig"
            ],
            members: {
              CodeSigningConfig: {
                shape: "S11"
              }
            }
          }
        },
        CreateEventSourceMapping: {
          http: {
            requestUri: "/2015-03-31/event-source-mappings/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              EventSourceArn: {},
              FunctionName: {},
              Enabled: {
                type: "boolean"
              },
              BatchSize: {
                type: "integer"
              },
              FilterCriteria: {
                shape: "S18"
              },
              MaximumBatchingWindowInSeconds: {
                type: "integer"
              },
              ParallelizationFactor: {
                type: "integer"
              },
              StartingPosition: {},
              StartingPositionTimestamp: {
                type: "timestamp"
              },
              DestinationConfig: {
                shape: "S1g"
              },
              MaximumRecordAgeInSeconds: {
                type: "integer"
              },
              BisectBatchOnFunctionError: {
                type: "boolean"
              },
              MaximumRetryAttempts: {
                type: "integer"
              },
              TumblingWindowInSeconds: {
                type: "integer"
              },
              Topics: {
                shape: "S1o"
              },
              Queues: {
                shape: "S1q"
              },
              SourceAccessConfigurations: {
                shape: "S1s"
              },
              SelfManagedEventSource: {
                shape: "S1w"
              },
              FunctionResponseTypes: {
                shape: "S21"
              },
              AmazonManagedKafkaEventSourceConfig: {
                shape: "S23"
              },
              SelfManagedKafkaEventSourceConfig: {
                shape: "S24"
              },
              ScalingConfig: {
                shape: "S25"
              },
              DocumentDBEventSourceConfig: {
                shape: "S27"
              }
            }
          },
          output: {
            shape: "S2b"
          }
        },
        CreateFunction: {
          http: {
            requestUri: "/2015-03-31/functions",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FunctionName",
              "Role",
              "Code"
            ],
            members: {
              FunctionName: {},
              Runtime: {},
              Role: {},
              Handler: {},
              Code: {
                type: "structure",
                members: {
                  ZipFile: {
                    shape: "S2h"
                  },
                  S3Bucket: {},
                  S3Key: {},
                  S3ObjectVersion: {},
                  ImageUri: {}
                }
              },
              Description: {},
              Timeout: {
                type: "integer"
              },
              MemorySize: {
                type: "integer"
              },
              Publish: {
                type: "boolean"
              },
              VpcConfig: {
                shape: "S2o"
              },
              PackageType: {},
              DeadLetterConfig: {
                shape: "S2v"
              },
              Environment: {
                shape: "S2x"
              },
              KMSKeyArn: {},
              TracingConfig: {
                shape: "S32"
              },
              Tags: {
                shape: "S34"
              },
              Layers: {
                shape: "S37"
              },
              FileSystemConfigs: {
                shape: "S39"
              },
              ImageConfig: {
                shape: "S3d"
              },
              CodeSigningConfigArn: {},
              Architectures: {
                shape: "S3g"
              },
              EphemeralStorage: {
                shape: "S3i"
              },
              SnapStart: {
                shape: "S3k"
              },
              LoggingConfig: {
                shape: "S3m"
              }
            }
          },
          output: {
            shape: "S3r"
          }
        },
        CreateFunctionUrlConfig: {
          http: {
            requestUri: "/2021-10-31/functions/{FunctionName}/url",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FunctionName",
              "AuthType"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              },
              AuthType: {},
              Cors: {
                shape: "S4i"
              },
              InvokeMode: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "FunctionUrl",
              "FunctionArn",
              "AuthType",
              "CreationTime"
            ],
            members: {
              FunctionUrl: {},
              FunctionArn: {},
              AuthType: {},
              Cors: {
                shape: "S4i"
              },
              CreationTime: {},
              InvokeMode: {}
            }
          }
        },
        DeleteAlias: {
          http: {
            method: "DELETE",
            requestUri: "/2015-03-31/functions/{FunctionName}/aliases/{Name}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "FunctionName",
              "Name"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          }
        },
        DeleteCodeSigningConfig: {
          http: {
            method: "DELETE",
            requestUri: "/2020-04-22/code-signing-configs/{CodeSigningConfigArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "CodeSigningConfigArn"
            ],
            members: {
              CodeSigningConfigArn: {
                location: "uri",
                locationName: "CodeSigningConfigArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteEventSourceMapping: {
          http: {
            method: "DELETE",
            requestUri: "/2015-03-31/event-source-mappings/{UUID}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "UUID"
            ],
            members: {
              UUID: {
                location: "uri",
                locationName: "UUID"
              }
            }
          },
          output: {
            shape: "S2b"
          }
        },
        DeleteFunction: {
          http: {
            method: "DELETE",
            requestUri: "/2015-03-31/functions/{FunctionName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              }
            }
          }
        },
        DeleteFunctionCodeSigningConfig: {
          http: {
            method: "DELETE",
            requestUri: "/2020-06-30/functions/{FunctionName}/code-signing-config",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              }
            }
          }
        },
        DeleteFunctionConcurrency: {
          http: {
            method: "DELETE",
            requestUri: "/2017-10-31/functions/{FunctionName}/concurrency",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              }
            }
          }
        },
        DeleteFunctionEventInvokeConfig: {
          http: {
            method: "DELETE",
            requestUri: "/2019-09-25/functions/{FunctionName}/event-invoke-config",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              }
            }
          }
        },
        DeleteFunctionUrlConfig: {
          http: {
            method: "DELETE",
            requestUri: "/2021-10-31/functions/{FunctionName}/url",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              }
            }
          }
        },
        DeleteLayerVersion: {
          http: {
            method: "DELETE",
            requestUri: "/2018-10-31/layers/{LayerName}/versions/{VersionNumber}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "LayerName",
              "VersionNumber"
            ],
            members: {
              LayerName: {
                location: "uri",
                locationName: "LayerName"
              },
              VersionNumber: {
                location: "uri",
                locationName: "VersionNumber",
                type: "long"
              }
            }
          }
        },
        DeleteProvisionedConcurrencyConfig: {
          http: {
            method: "DELETE",
            requestUri: "/2019-09-30/functions/{FunctionName}/provisioned-concurrency",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "FunctionName",
              "Qualifier"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              }
            }
          }
        },
        GetAccountSettings: {
          http: {
            method: "GET",
            requestUri: "/2016-08-19/account-settings/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              AccountLimit: {
                type: "structure",
                members: {
                  TotalCodeSize: {
                    type: "long"
                  },
                  CodeSizeUnzipped: {
                    type: "long"
                  },
                  CodeSizeZipped: {
                    type: "long"
                  },
                  ConcurrentExecutions: {
                    type: "integer"
                  },
                  UnreservedConcurrentExecutions: {
                    type: "integer"
                  }
                }
              },
              AccountUsage: {
                type: "structure",
                members: {
                  TotalCodeSize: {
                    type: "long"
                  },
                  FunctionCount: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        GetAlias: {
          http: {
            method: "GET",
            requestUri: "/2015-03-31/functions/{FunctionName}/aliases/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName",
              "Name"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            shape: "St"
          }
        },
        GetCodeSigningConfig: {
          http: {
            method: "GET",
            requestUri: "/2020-04-22/code-signing-configs/{CodeSigningConfigArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CodeSigningConfigArn"
            ],
            members: {
              CodeSigningConfigArn: {
                location: "uri",
                locationName: "CodeSigningConfigArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CodeSigningConfig"
            ],
            members: {
              CodeSigningConfig: {
                shape: "S11"
              }
            }
          }
        },
        GetEventSourceMapping: {
          http: {
            method: "GET",
            requestUri: "/2015-03-31/event-source-mappings/{UUID}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "UUID"
            ],
            members: {
              UUID: {
                location: "uri",
                locationName: "UUID"
              }
            }
          },
          output: {
            shape: "S2b"
          }
        },
        GetFunction: {
          http: {
            method: "GET",
            requestUri: "/2015-03-31/functions/{FunctionName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Configuration: {
                shape: "S3r"
              },
              Code: {
                type: "structure",
                members: {
                  RepositoryType: {},
                  Location: {},
                  ImageUri: {},
                  ResolvedImageUri: {}
                }
              },
              Tags: {
                shape: "S34"
              },
              Concurrency: {
                shape: "S5i"
              }
            }
          }
        },
        GetFunctionCodeSigningConfig: {
          http: {
            method: "GET",
            requestUri: "/2020-06-30/functions/{FunctionName}/code-signing-config",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CodeSigningConfigArn",
              "FunctionName"
            ],
            members: {
              CodeSigningConfigArn: {},
              FunctionName: {}
            }
          }
        },
        GetFunctionConcurrency: {
          http: {
            method: "GET",
            requestUri: "/2019-09-30/functions/{FunctionName}/concurrency",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReservedConcurrentExecutions: {
                type: "integer"
              }
            }
          }
        },
        GetFunctionConfiguration: {
          http: {
            method: "GET",
            requestUri: "/2015-03-31/functions/{FunctionName}/configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              }
            }
          },
          output: {
            shape: "S3r"
          }
        },
        GetFunctionEventInvokeConfig: {
          http: {
            method: "GET",
            requestUri: "/2019-09-25/functions/{FunctionName}/event-invoke-config",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              }
            }
          },
          output: {
            shape: "S5q"
          }
        },
        GetFunctionUrlConfig: {
          http: {
            method: "GET",
            requestUri: "/2021-10-31/functions/{FunctionName}/url",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "FunctionUrl",
              "FunctionArn",
              "AuthType",
              "CreationTime",
              "LastModifiedTime"
            ],
            members: {
              FunctionUrl: {},
              FunctionArn: {},
              AuthType: {},
              Cors: {
                shape: "S4i"
              },
              CreationTime: {},
              LastModifiedTime: {},
              InvokeMode: {}
            }
          }
        },
        GetLayerVersion: {
          http: {
            method: "GET",
            requestUri: "/2018-10-31/layers/{LayerName}/versions/{VersionNumber}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "LayerName",
              "VersionNumber"
            ],
            members: {
              LayerName: {
                location: "uri",
                locationName: "LayerName"
              },
              VersionNumber: {
                location: "uri",
                locationName: "VersionNumber",
                type: "long"
              }
            }
          },
          output: {
            shape: "S5w"
          }
        },
        GetLayerVersionByArn: {
          http: {
            method: "GET",
            requestUri: "/2018-10-31/layers?find=LayerVersion",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {
                location: "querystring",
                locationName: "Arn"
              }
            }
          },
          output: {
            shape: "S5w"
          }
        },
        GetLayerVersionPolicy: {
          http: {
            method: "GET",
            requestUri: "/2018-10-31/layers/{LayerName}/versions/{VersionNumber}/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "LayerName",
              "VersionNumber"
            ],
            members: {
              LayerName: {
                location: "uri",
                locationName: "LayerName"
              },
              VersionNumber: {
                location: "uri",
                locationName: "VersionNumber",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {},
              RevisionId: {}
            }
          }
        },
        GetPolicy: {
          http: {
            method: "GET",
            requestUri: "/2015-03-31/functions/{FunctionName}/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {},
              RevisionId: {}
            }
          }
        },
        GetProvisionedConcurrencyConfig: {
          http: {
            method: "GET",
            requestUri: "/2019-09-30/functions/{FunctionName}/provisioned-concurrency",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName",
              "Qualifier"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestedProvisionedConcurrentExecutions: {
                type: "integer"
              },
              AvailableProvisionedConcurrentExecutions: {
                type: "integer"
              },
              AllocatedProvisionedConcurrentExecutions: {
                type: "integer"
              },
              Status: {},
              StatusReason: {},
              LastModified: {}
            }
          }
        },
        GetRuntimeManagementConfig: {
          http: {
            method: "GET",
            requestUri: "/2021-07-20/functions/{FunctionName}/runtime-management-config",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UpdateRuntimeOn: {},
              RuntimeVersionArn: {},
              FunctionArn: {}
            }
          }
        },
        Invoke: {
          http: {
            requestUri: "/2015-03-31/functions/{FunctionName}/invocations"
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              InvocationType: {
                location: "header",
                locationName: "X-Amz-Invocation-Type"
              },
              LogType: {
                location: "header",
                locationName: "X-Amz-Log-Type"
              },
              ClientContext: {
                location: "header",
                locationName: "X-Amz-Client-Context"
              },
              Payload: {
                shape: "S2h"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              }
            },
            payload: "Payload"
          },
          output: {
            type: "structure",
            members: {
              StatusCode: {
                location: "statusCode",
                type: "integer"
              },
              FunctionError: {
                location: "header",
                locationName: "X-Amz-Function-Error"
              },
              LogResult: {
                location: "header",
                locationName: "X-Amz-Log-Result"
              },
              Payload: {
                shape: "S2h"
              },
              ExecutedVersion: {
                location: "header",
                locationName: "X-Amz-Executed-Version"
              }
            },
            payload: "Payload"
          }
        },
        InvokeAsync: {
          http: {
            requestUri: "/2014-11-13/functions/{FunctionName}/invoke-async/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "FunctionName",
              "InvokeArgs"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              InvokeArgs: {
                type: "blob",
                streaming: true
              }
            },
            deprecated: true,
            payload: "InvokeArgs"
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              }
            },
            deprecated: true
          },
          deprecated: true
        },
        InvokeWithResponseStream: {
          http: {
            requestUri: "/2021-11-15/functions/{FunctionName}/response-streaming-invocations"
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              InvocationType: {
                location: "header",
                locationName: "X-Amz-Invocation-Type"
              },
              LogType: {
                location: "header",
                locationName: "X-Amz-Log-Type"
              },
              ClientContext: {
                location: "header",
                locationName: "X-Amz-Client-Context"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              },
              Payload: {
                shape: "S2h"
              }
            },
            payload: "Payload"
          },
          output: {
            type: "structure",
            members: {
              StatusCode: {
                location: "statusCode",
                type: "integer"
              },
              ExecutedVersion: {
                location: "header",
                locationName: "X-Amz-Executed-Version"
              },
              EventStream: {
                type: "structure",
                members: {
                  PayloadChunk: {
                    type: "structure",
                    members: {
                      Payload: {
                        shape: "S2h",
                        eventpayload: true
                      }
                    },
                    event: true
                  },
                  InvokeComplete: {
                    type: "structure",
                    members: {
                      ErrorCode: {},
                      ErrorDetails: {},
                      LogResult: {}
                    },
                    event: true
                  }
                },
                eventstream: true
              },
              ResponseStreamContentType: {
                location: "header",
                locationName: "Content-Type"
              }
            },
            payload: "EventStream"
          }
        },
        ListAliases: {
          http: {
            method: "GET",
            requestUri: "/2015-03-31/functions/{FunctionName}/aliases",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              FunctionVersion: {
                location: "querystring",
                locationName: "FunctionVersion"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              Aliases: {
                type: "list",
                member: {
                  shape: "St"
                }
              }
            }
          }
        },
        ListCodeSigningConfigs: {
          http: {
            method: "GET",
            requestUri: "/2020-04-22/code-signing-configs/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              CodeSigningConfigs: {
                type: "list",
                member: {
                  shape: "S11"
                }
              }
            }
          }
        },
        ListEventSourceMappings: {
          http: {
            method: "GET",
            requestUri: "/2015-03-31/event-source-mappings/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              EventSourceArn: {
                location: "querystring",
                locationName: "EventSourceArn"
              },
              FunctionName: {
                location: "querystring",
                locationName: "FunctionName"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              EventSourceMappings: {
                type: "list",
                member: {
                  shape: "S2b"
                }
              }
            }
          }
        },
        ListFunctionEventInvokeConfigs: {
          http: {
            method: "GET",
            requestUri: "/2019-09-25/functions/{FunctionName}/event-invoke-config/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FunctionEventInvokeConfigs: {
                type: "list",
                member: {
                  shape: "S5q"
                }
              },
              NextMarker: {}
            }
          }
        },
        ListFunctionUrlConfigs: {
          http: {
            method: "GET",
            requestUri: "/2021-10-31/functions/{FunctionName}/urls",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "FunctionUrlConfigs"
            ],
            members: {
              FunctionUrlConfigs: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "FunctionUrl",
                    "FunctionArn",
                    "CreationTime",
                    "LastModifiedTime",
                    "AuthType"
                  ],
                  members: {
                    FunctionUrl: {},
                    FunctionArn: {},
                    CreationTime: {},
                    LastModifiedTime: {},
                    Cors: {
                      shape: "S4i"
                    },
                    AuthType: {},
                    InvokeMode: {}
                  }
                }
              },
              NextMarker: {}
            }
          }
        },
        ListFunctions: {
          http: {
            method: "GET",
            requestUri: "/2015-03-31/functions/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MasterRegion: {
                location: "querystring",
                locationName: "MasterRegion"
              },
              FunctionVersion: {
                location: "querystring",
                locationName: "FunctionVersion"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              Functions: {
                shape: "S7g"
              }
            }
          }
        },
        ListFunctionsByCodeSigningConfig: {
          http: {
            method: "GET",
            requestUri: "/2020-04-22/code-signing-configs/{CodeSigningConfigArn}/functions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CodeSigningConfigArn"
            ],
            members: {
              CodeSigningConfigArn: {
                location: "uri",
                locationName: "CodeSigningConfigArn"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              FunctionArns: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ListLayerVersions: {
          http: {
            method: "GET",
            requestUri: "/2018-10-31/layers/{LayerName}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "LayerName"
            ],
            members: {
              CompatibleRuntime: {
                location: "querystring",
                locationName: "CompatibleRuntime"
              },
              LayerName: {
                location: "uri",
                locationName: "LayerName"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              },
              CompatibleArchitecture: {
                location: "querystring",
                locationName: "CompatibleArchitecture"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              LayerVersions: {
                type: "list",
                member: {
                  shape: "S7o"
                }
              }
            }
          }
        },
        ListLayers: {
          http: {
            method: "GET",
            requestUri: "/2018-10-31/layers",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CompatibleRuntime: {
                location: "querystring",
                locationName: "CompatibleRuntime"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              },
              CompatibleArchitecture: {
                location: "querystring",
                locationName: "CompatibleArchitecture"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              Layers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LayerName: {},
                    LayerArn: {},
                    LatestMatchingVersion: {
                      shape: "S7o"
                    }
                  }
                }
              }
            }
          }
        },
        ListProvisionedConcurrencyConfigs: {
          http: {
            method: "GET",
            requestUri: "/2019-09-30/functions/{FunctionName}/provisioned-concurrency?List=ALL",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProvisionedConcurrencyConfigs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FunctionArn: {},
                    RequestedProvisionedConcurrentExecutions: {
                      type: "integer"
                    },
                    AvailableProvisionedConcurrentExecutions: {
                      type: "integer"
                    },
                    AllocatedProvisionedConcurrentExecutions: {
                      type: "integer"
                    },
                    Status: {},
                    StatusReason: {},
                    LastModified: {}
                  }
                }
              },
              NextMarker: {}
            }
          }
        },
        ListTags: {
          http: {
            method: "GET",
            requestUri: "/2017-03-31/tags/{ARN}"
          },
          input: {
            type: "structure",
            required: [
              "Resource"
            ],
            members: {
              Resource: {
                location: "uri",
                locationName: "ARN"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S34"
              }
            }
          }
        },
        ListVersionsByFunction: {
          http: {
            method: "GET",
            requestUri: "/2015-03-31/functions/{FunctionName}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              Versions: {
                shape: "S7g"
              }
            }
          }
        },
        PublishLayerVersion: {
          http: {
            requestUri: "/2018-10-31/layers/{LayerName}/versions",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "LayerName",
              "Content"
            ],
            members: {
              LayerName: {
                location: "uri",
                locationName: "LayerName"
              },
              Description: {},
              Content: {
                type: "structure",
                members: {
                  S3Bucket: {},
                  S3Key: {},
                  S3ObjectVersion: {},
                  ZipFile: {
                    shape: "S2h"
                  }
                }
              },
              CompatibleRuntimes: {
                shape: "S5z"
              },
              LicenseInfo: {},
              CompatibleArchitectures: {
                shape: "S61"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Content: {
                shape: "S5x"
              },
              LayerArn: {},
              LayerVersionArn: {},
              Description: {},
              CreatedDate: {},
              Version: {
                type: "long"
              },
              CompatibleRuntimes: {
                shape: "S5z"
              },
              LicenseInfo: {},
              CompatibleArchitectures: {
                shape: "S61"
              }
            }
          }
        },
        PublishVersion: {
          http: {
            requestUri: "/2015-03-31/functions/{FunctionName}/versions",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              CodeSha256: {},
              Description: {},
              RevisionId: {}
            }
          },
          output: {
            shape: "S3r"
          }
        },
        PutFunctionCodeSigningConfig: {
          http: {
            method: "PUT",
            requestUri: "/2020-06-30/functions/{FunctionName}/code-signing-config",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CodeSigningConfigArn",
              "FunctionName"
            ],
            members: {
              CodeSigningConfigArn: {},
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CodeSigningConfigArn",
              "FunctionName"
            ],
            members: {
              CodeSigningConfigArn: {},
              FunctionName: {}
            }
          }
        },
        PutFunctionConcurrency: {
          http: {
            method: "PUT",
            requestUri: "/2017-10-31/functions/{FunctionName}/concurrency",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName",
              "ReservedConcurrentExecutions"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              ReservedConcurrentExecutions: {
                type: "integer"
              }
            }
          },
          output: {
            shape: "S5i"
          }
        },
        PutFunctionEventInvokeConfig: {
          http: {
            method: "PUT",
            requestUri: "/2019-09-25/functions/{FunctionName}/event-invoke-config",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              },
              MaximumRetryAttempts: {
                type: "integer"
              },
              MaximumEventAgeInSeconds: {
                type: "integer"
              },
              DestinationConfig: {
                shape: "S1g"
              }
            }
          },
          output: {
            shape: "S5q"
          }
        },
        PutProvisionedConcurrencyConfig: {
          http: {
            method: "PUT",
            requestUri: "/2019-09-30/functions/{FunctionName}/provisioned-concurrency",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "FunctionName",
              "Qualifier",
              "ProvisionedConcurrentExecutions"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              },
              ProvisionedConcurrentExecutions: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestedProvisionedConcurrentExecutions: {
                type: "integer"
              },
              AvailableProvisionedConcurrentExecutions: {
                type: "integer"
              },
              AllocatedProvisionedConcurrentExecutions: {
                type: "integer"
              },
              Status: {},
              StatusReason: {},
              LastModified: {}
            }
          }
        },
        PutRuntimeManagementConfig: {
          http: {
            method: "PUT",
            requestUri: "/2021-07-20/functions/{FunctionName}/runtime-management-config",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName",
              "UpdateRuntimeOn"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              },
              UpdateRuntimeOn: {},
              RuntimeVersionArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "UpdateRuntimeOn",
              "FunctionArn"
            ],
            members: {
              UpdateRuntimeOn: {},
              FunctionArn: {},
              RuntimeVersionArn: {}
            }
          }
        },
        RemoveLayerVersionPermission: {
          http: {
            method: "DELETE",
            requestUri: "/2018-10-31/layers/{LayerName}/versions/{VersionNumber}/policy/{StatementId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "LayerName",
              "VersionNumber",
              "StatementId"
            ],
            members: {
              LayerName: {
                location: "uri",
                locationName: "LayerName"
              },
              VersionNumber: {
                location: "uri",
                locationName: "VersionNumber",
                type: "long"
              },
              StatementId: {
                location: "uri",
                locationName: "StatementId"
              },
              RevisionId: {
                location: "querystring",
                locationName: "RevisionId"
              }
            }
          }
        },
        RemovePermission: {
          http: {
            method: "DELETE",
            requestUri: "/2015-03-31/functions/{FunctionName}/policy/{StatementId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "FunctionName",
              "StatementId"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              StatementId: {
                location: "uri",
                locationName: "StatementId"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              },
              RevisionId: {
                location: "querystring",
                locationName: "RevisionId"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/2017-03-31/tags/{ARN}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "Tags"
            ],
            members: {
              Resource: {
                location: "uri",
                locationName: "ARN"
              },
              Tags: {
                shape: "S34"
              }
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/2017-03-31/tags/{ARN}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "TagKeys"
            ],
            members: {
              Resource: {
                location: "uri",
                locationName: "ARN"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          }
        },
        UpdateAlias: {
          http: {
            method: "PUT",
            requestUri: "/2015-03-31/functions/{FunctionName}/aliases/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName",
              "Name"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Name: {
                location: "uri",
                locationName: "Name"
              },
              FunctionVersion: {},
              Description: {},
              RoutingConfig: {
                shape: "Sp"
              },
              RevisionId: {}
            }
          },
          output: {
            shape: "St"
          }
        },
        UpdateCodeSigningConfig: {
          http: {
            method: "PUT",
            requestUri: "/2020-04-22/code-signing-configs/{CodeSigningConfigArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CodeSigningConfigArn"
            ],
            members: {
              CodeSigningConfigArn: {
                location: "uri",
                locationName: "CodeSigningConfigArn"
              },
              Description: {},
              AllowedPublishers: {
                shape: "Sw"
              },
              CodeSigningPolicies: {
                shape: "Sy"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CodeSigningConfig"
            ],
            members: {
              CodeSigningConfig: {
                shape: "S11"
              }
            }
          }
        },
        UpdateEventSourceMapping: {
          http: {
            method: "PUT",
            requestUri: "/2015-03-31/event-source-mappings/{UUID}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "UUID"
            ],
            members: {
              UUID: {
                location: "uri",
                locationName: "UUID"
              },
              FunctionName: {},
              Enabled: {
                type: "boolean"
              },
              BatchSize: {
                type: "integer"
              },
              FilterCriteria: {
                shape: "S18"
              },
              MaximumBatchingWindowInSeconds: {
                type: "integer"
              },
              DestinationConfig: {
                shape: "S1g"
              },
              MaximumRecordAgeInSeconds: {
                type: "integer"
              },
              BisectBatchOnFunctionError: {
                type: "boolean"
              },
              MaximumRetryAttempts: {
                type: "integer"
              },
              ParallelizationFactor: {
                type: "integer"
              },
              SourceAccessConfigurations: {
                shape: "S1s"
              },
              TumblingWindowInSeconds: {
                type: "integer"
              },
              FunctionResponseTypes: {
                shape: "S21"
              },
              ScalingConfig: {
                shape: "S25"
              },
              DocumentDBEventSourceConfig: {
                shape: "S27"
              }
            }
          },
          output: {
            shape: "S2b"
          }
        },
        UpdateFunctionCode: {
          http: {
            method: "PUT",
            requestUri: "/2015-03-31/functions/{FunctionName}/code",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              ZipFile: {
                shape: "S2h"
              },
              S3Bucket: {},
              S3Key: {},
              S3ObjectVersion: {},
              ImageUri: {},
              Publish: {
                type: "boolean"
              },
              DryRun: {
                type: "boolean"
              },
              RevisionId: {},
              Architectures: {
                shape: "S3g"
              }
            }
          },
          output: {
            shape: "S3r"
          }
        },
        UpdateFunctionConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/2015-03-31/functions/{FunctionName}/configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Role: {},
              Handler: {},
              Description: {},
              Timeout: {
                type: "integer"
              },
              MemorySize: {
                type: "integer"
              },
              VpcConfig: {
                shape: "S2o"
              },
              Environment: {
                shape: "S2x"
              },
              Runtime: {},
              DeadLetterConfig: {
                shape: "S2v"
              },
              KMSKeyArn: {},
              TracingConfig: {
                shape: "S32"
              },
              RevisionId: {},
              Layers: {
                shape: "S37"
              },
              FileSystemConfigs: {
                shape: "S39"
              },
              ImageConfig: {
                shape: "S3d"
              },
              EphemeralStorage: {
                shape: "S3i"
              },
              SnapStart: {
                shape: "S3k"
              },
              LoggingConfig: {
                shape: "S3m"
              }
            }
          },
          output: {
            shape: "S3r"
          }
        },
        UpdateFunctionEventInvokeConfig: {
          http: {
            requestUri: "/2019-09-25/functions/{FunctionName}/event-invoke-config",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              },
              MaximumRetryAttempts: {
                type: "integer"
              },
              MaximumEventAgeInSeconds: {
                type: "integer"
              },
              DestinationConfig: {
                shape: "S1g"
              }
            }
          },
          output: {
            shape: "S5q"
          }
        },
        UpdateFunctionUrlConfig: {
          http: {
            method: "PUT",
            requestUri: "/2021-10-31/functions/{FunctionName}/url",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              },
              AuthType: {},
              Cors: {
                shape: "S4i"
              },
              InvokeMode: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "FunctionUrl",
              "FunctionArn",
              "AuthType",
              "CreationTime",
              "LastModifiedTime"
            ],
            members: {
              FunctionUrl: {},
              FunctionArn: {},
              AuthType: {},
              Cors: {
                shape: "S4i"
              },
              CreationTime: {},
              LastModifiedTime: {},
              InvokeMode: {}
            }
          }
        }
      },
      shapes: {
        Sp: {
          type: "structure",
          members: {
            AdditionalVersionWeights: {
              type: "map",
              key: {},
              value: {
                type: "double"
              }
            }
          }
        },
        St: {
          type: "structure",
          members: {
            AliasArn: {},
            Name: {},
            FunctionVersion: {},
            Description: {},
            RoutingConfig: {
              shape: "Sp"
            },
            RevisionId: {}
          }
        },
        Sw: {
          type: "structure",
          required: [
            "SigningProfileVersionArns"
          ],
          members: {
            SigningProfileVersionArns: {
              type: "list",
              member: {}
            }
          }
        },
        Sy: {
          type: "structure",
          members: {
            UntrustedArtifactOnDeployment: {}
          }
        },
        S11: {
          type: "structure",
          required: [
            "CodeSigningConfigId",
            "CodeSigningConfigArn",
            "AllowedPublishers",
            "CodeSigningPolicies",
            "LastModified"
          ],
          members: {
            CodeSigningConfigId: {},
            CodeSigningConfigArn: {},
            Description: {},
            AllowedPublishers: {
              shape: "Sw"
            },
            CodeSigningPolicies: {
              shape: "Sy"
            },
            LastModified: {}
          }
        },
        S18: {
          type: "structure",
          members: {
            Filters: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Pattern: {}
                }
              }
            }
          }
        },
        S1g: {
          type: "structure",
          members: {
            OnSuccess: {
              type: "structure",
              members: {
                Destination: {}
              }
            },
            OnFailure: {
              type: "structure",
              members: {
                Destination: {}
              }
            }
          }
        },
        S1o: {
          type: "list",
          member: {}
        },
        S1q: {
          type: "list",
          member: {}
        },
        S1s: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Type: {},
              URI: {}
            }
          }
        },
        S1w: {
          type: "structure",
          members: {
            Endpoints: {
              type: "map",
              key: {},
              value: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S21: {
          type: "list",
          member: {}
        },
        S23: {
          type: "structure",
          members: {
            ConsumerGroupId: {}
          }
        },
        S24: {
          type: "structure",
          members: {
            ConsumerGroupId: {}
          }
        },
        S25: {
          type: "structure",
          members: {
            MaximumConcurrency: {
              type: "integer"
            }
          }
        },
        S27: {
          type: "structure",
          members: {
            DatabaseName: {},
            CollectionName: {},
            FullDocument: {}
          }
        },
        S2b: {
          type: "structure",
          members: {
            UUID: {},
            StartingPosition: {},
            StartingPositionTimestamp: {
              type: "timestamp"
            },
            BatchSize: {
              type: "integer"
            },
            MaximumBatchingWindowInSeconds: {
              type: "integer"
            },
            ParallelizationFactor: {
              type: "integer"
            },
            EventSourceArn: {},
            FilterCriteria: {
              shape: "S18"
            },
            FunctionArn: {},
            LastModified: {
              type: "timestamp"
            },
            LastProcessingResult: {},
            State: {},
            StateTransitionReason: {},
            DestinationConfig: {
              shape: "S1g"
            },
            Topics: {
              shape: "S1o"
            },
            Queues: {
              shape: "S1q"
            },
            SourceAccessConfigurations: {
              shape: "S1s"
            },
            SelfManagedEventSource: {
              shape: "S1w"
            },
            MaximumRecordAgeInSeconds: {
              type: "integer"
            },
            BisectBatchOnFunctionError: {
              type: "boolean"
            },
            MaximumRetryAttempts: {
              type: "integer"
            },
            TumblingWindowInSeconds: {
              type: "integer"
            },
            FunctionResponseTypes: {
              shape: "S21"
            },
            AmazonManagedKafkaEventSourceConfig: {
              shape: "S23"
            },
            SelfManagedKafkaEventSourceConfig: {
              shape: "S24"
            },
            ScalingConfig: {
              shape: "S25"
            },
            DocumentDBEventSourceConfig: {
              shape: "S27"
            }
          }
        },
        S2h: {
          type: "blob",
          sensitive: true
        },
        S2o: {
          type: "structure",
          members: {
            SubnetIds: {
              shape: "S2p"
            },
            SecurityGroupIds: {
              shape: "S2r"
            },
            Ipv6AllowedForDualStack: {
              type: "boolean"
            }
          }
        },
        S2p: {
          type: "list",
          member: {}
        },
        S2r: {
          type: "list",
          member: {}
        },
        S2v: {
          type: "structure",
          members: {
            TargetArn: {}
          }
        },
        S2x: {
          type: "structure",
          members: {
            Variables: {
              shape: "S2y"
            }
          }
        },
        S2y: {
          type: "map",
          key: {
            type: "string",
            sensitive: true
          },
          value: {
            type: "string",
            sensitive: true
          },
          sensitive: true
        },
        S32: {
          type: "structure",
          members: {
            Mode: {}
          }
        },
        S34: {
          type: "map",
          key: {},
          value: {}
        },
        S37: {
          type: "list",
          member: {}
        },
        S39: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Arn",
              "LocalMountPath"
            ],
            members: {
              Arn: {},
              LocalMountPath: {}
            }
          }
        },
        S3d: {
          type: "structure",
          members: {
            EntryPoint: {
              shape: "S3e"
            },
            Command: {
              shape: "S3e"
            },
            WorkingDirectory: {}
          }
        },
        S3e: {
          type: "list",
          member: {}
        },
        S3g: {
          type: "list",
          member: {}
        },
        S3i: {
          type: "structure",
          required: [
            "Size"
          ],
          members: {
            Size: {
              type: "integer"
            }
          }
        },
        S3k: {
          type: "structure",
          members: {
            ApplyOn: {}
          }
        },
        S3m: {
          type: "structure",
          members: {
            LogFormat: {},
            ApplicationLogLevel: {},
            SystemLogLevel: {},
            LogGroup: {}
          }
        },
        S3r: {
          type: "structure",
          members: {
            FunctionName: {},
            FunctionArn: {},
            Runtime: {},
            Role: {},
            Handler: {},
            CodeSize: {
              type: "long"
            },
            Description: {},
            Timeout: {
              type: "integer"
            },
            MemorySize: {
              type: "integer"
            },
            LastModified: {},
            CodeSha256: {},
            Version: {},
            VpcConfig: {
              type: "structure",
              members: {
                SubnetIds: {
                  shape: "S2p"
                },
                SecurityGroupIds: {
                  shape: "S2r"
                },
                VpcId: {},
                Ipv6AllowedForDualStack: {
                  type: "boolean"
                }
              }
            },
            DeadLetterConfig: {
              shape: "S2v"
            },
            Environment: {
              type: "structure",
              members: {
                Variables: {
                  shape: "S2y"
                },
                Error: {
                  type: "structure",
                  members: {
                    ErrorCode: {},
                    Message: {
                      shape: "S3z"
                    }
                  }
                }
              }
            },
            KMSKeyArn: {},
            TracingConfig: {
              type: "structure",
              members: {
                Mode: {}
              }
            },
            MasterArn: {},
            RevisionId: {},
            Layers: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Arn: {},
                  CodeSize: {
                    type: "long"
                  },
                  SigningProfileVersionArn: {},
                  SigningJobArn: {}
                }
              }
            },
            State: {},
            StateReason: {},
            StateReasonCode: {},
            LastUpdateStatus: {},
            LastUpdateStatusReason: {},
            LastUpdateStatusReasonCode: {},
            FileSystemConfigs: {
              shape: "S39"
            },
            PackageType: {},
            ImageConfigResponse: {
              type: "structure",
              members: {
                ImageConfig: {
                  shape: "S3d"
                },
                Error: {
                  type: "structure",
                  members: {
                    ErrorCode: {},
                    Message: {
                      shape: "S3z"
                    }
                  }
                }
              }
            },
            SigningProfileVersionArn: {},
            SigningJobArn: {},
            Architectures: {
              shape: "S3g"
            },
            EphemeralStorage: {
              shape: "S3i"
            },
            SnapStart: {
              type: "structure",
              members: {
                ApplyOn: {},
                OptimizationStatus: {}
              }
            },
            RuntimeVersionConfig: {
              type: "structure",
              members: {
                RuntimeVersionArn: {},
                Error: {
                  type: "structure",
                  members: {
                    ErrorCode: {},
                    Message: {
                      shape: "S3z"
                    }
                  }
                }
              }
            },
            LoggingConfig: {
              shape: "S3m"
            }
          }
        },
        S3z: {
          type: "string",
          sensitive: true
        },
        S4i: {
          type: "structure",
          members: {
            AllowCredentials: {
              type: "boolean"
            },
            AllowHeaders: {
              shape: "S4k"
            },
            AllowMethods: {
              type: "list",
              member: {}
            },
            AllowOrigins: {
              type: "list",
              member: {}
            },
            ExposeHeaders: {
              shape: "S4k"
            },
            MaxAge: {
              type: "integer"
            }
          }
        },
        S4k: {
          type: "list",
          member: {}
        },
        S5i: {
          type: "structure",
          members: {
            ReservedConcurrentExecutions: {
              type: "integer"
            }
          }
        },
        S5q: {
          type: "structure",
          members: {
            LastModified: {
              type: "timestamp"
            },
            FunctionArn: {},
            MaximumRetryAttempts: {
              type: "integer"
            },
            MaximumEventAgeInSeconds: {
              type: "integer"
            },
            DestinationConfig: {
              shape: "S1g"
            }
          }
        },
        S5w: {
          type: "structure",
          members: {
            Content: {
              shape: "S5x"
            },
            LayerArn: {},
            LayerVersionArn: {},
            Description: {},
            CreatedDate: {},
            Version: {
              type: "long"
            },
            CompatibleRuntimes: {
              shape: "S5z"
            },
            LicenseInfo: {},
            CompatibleArchitectures: {
              shape: "S61"
            }
          }
        },
        S5x: {
          type: "structure",
          members: {
            Location: {},
            CodeSha256: {},
            CodeSize: {
              type: "long"
            },
            SigningProfileVersionArn: {},
            SigningJobArn: {}
          }
        },
        S5z: {
          type: "list",
          member: {}
        },
        S61: {
          type: "list",
          member: {}
        },
        S7g: {
          type: "list",
          member: {
            shape: "S3r"
          }
        },
        S7o: {
          type: "structure",
          members: {
            LayerVersionArn: {},
            Version: {
              type: "long"
            },
            Description: {},
            CreatedDate: {},
            CompatibleRuntimes: {
              shape: "S5z"
            },
            LicenseInfo: {},
            CompatibleArchitectures: {
              shape: "S61"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/lambda-2015-03-31.paginators.json
var require_lambda_2015_03_31_paginators = __commonJS({
  "node_modules/aws-sdk/apis/lambda-2015-03-31.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAliases: {
          input_token: "Marker",
          limit_key: "MaxItems",
          output_token: "NextMarker",
          result_key: "Aliases"
        },
        ListCodeSigningConfigs: {
          input_token: "Marker",
          limit_key: "MaxItems",
          output_token: "NextMarker",
          result_key: "CodeSigningConfigs"
        },
        ListEventSourceMappings: {
          input_token: "Marker",
          limit_key: "MaxItems",
          output_token: "NextMarker",
          result_key: "EventSourceMappings"
        },
        ListFunctionEventInvokeConfigs: {
          input_token: "Marker",
          limit_key: "MaxItems",
          output_token: "NextMarker",
          result_key: "FunctionEventInvokeConfigs"
        },
        ListFunctionUrlConfigs: {
          input_token: "Marker",
          limit_key: "MaxItems",
          output_token: "NextMarker",
          result_key: "FunctionUrlConfigs"
        },
        ListFunctions: {
          input_token: "Marker",
          limit_key: "MaxItems",
          output_token: "NextMarker",
          result_key: "Functions"
        },
        ListFunctionsByCodeSigningConfig: {
          input_token: "Marker",
          limit_key: "MaxItems",
          output_token: "NextMarker",
          result_key: "FunctionArns"
        },
        ListLayerVersions: {
          input_token: "Marker",
          limit_key: "MaxItems",
          output_token: "NextMarker",
          result_key: "LayerVersions"
        },
        ListLayers: {
          input_token: "Marker",
          limit_key: "MaxItems",
          output_token: "NextMarker",
          result_key: "Layers"
        },
        ListProvisionedConcurrencyConfigs: {
          input_token: "Marker",
          limit_key: "MaxItems",
          output_token: "NextMarker",
          result_key: "ProvisionedConcurrencyConfigs"
        },
        ListVersionsByFunction: {
          input_token: "Marker",
          limit_key: "MaxItems",
          output_token: "NextMarker",
          result_key: "Versions"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/lambda-2015-03-31.waiters2.json
var require_lambda_2015_03_31_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/lambda-2015-03-31.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        FunctionExists: {
          delay: 1,
          operation: "GetFunction",
          maxAttempts: 20,
          acceptors: [
            {
              state: "success",
              matcher: "status",
              expected: 200
            },
            {
              state: "retry",
              matcher: "error",
              expected: "ResourceNotFoundException"
            }
          ]
        },
        FunctionActive: {
          delay: 5,
          maxAttempts: 60,
          operation: "GetFunctionConfiguration",
          description: "Waits for the function's State to be Active. This waiter uses GetFunctionConfiguration API. This should be used after new function creation.",
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "State",
              expected: "Active"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "State",
              expected: "Failed"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "State",
              expected: "Pending"
            }
          ]
        },
        FunctionUpdated: {
          delay: 5,
          maxAttempts: 60,
          operation: "GetFunctionConfiguration",
          description: "Waits for the function's LastUpdateStatus to be Successful. This waiter uses GetFunctionConfiguration API. This should be used after function updates.",
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "LastUpdateStatus",
              expected: "Successful"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "LastUpdateStatus",
              expected: "Failed"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "LastUpdateStatus",
              expected: "InProgress"
            }
          ]
        },
        FunctionActiveV2: {
          delay: 1,
          maxAttempts: 300,
          operation: "GetFunction",
          description: "Waits for the function's State to be Active. This waiter uses GetFunction API. This should be used after new function creation.",
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "Configuration.State",
              expected: "Active"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "Configuration.State",
              expected: "Failed"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "Configuration.State",
              expected: "Pending"
            }
          ]
        },
        FunctionUpdatedV2: {
          delay: 1,
          maxAttempts: 300,
          operation: "GetFunction",
          description: "Waits for the function's LastUpdateStatus to be Successful. This waiter uses GetFunction API. This should be used after function updates.",
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "Configuration.LastUpdateStatus",
              expected: "Successful"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "Configuration.LastUpdateStatus",
              expected: "Failed"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "Configuration.LastUpdateStatus",
              expected: "InProgress"
            }
          ]
        },
        PublishedVersionActive: {
          delay: 5,
          maxAttempts: 312,
          operation: "GetFunctionConfiguration",
          description: "Waits for the published version's State to be Active. This waiter uses GetFunctionConfiguration API. This should be used after new version is published.",
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "State",
              expected: "Active"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "State",
              expected: "Failed"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "State",
              expected: "Pending"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/lambda.js
var require_lambda2 = __commonJS({
  "node_modules/aws-sdk/clients/lambda.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["lambda"] = {};
    AWS2.Lambda = Service.defineService("lambda", ["2014-11-11", "2015-03-31"]);
    require_lambda();
    Object.defineProperty(apiLoader.services["lambda"], "2014-11-11", {
      get: function get() {
        var model = require_lambda_2014_11_11_min();
        model.paginators = require_lambda_2014_11_11_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(apiLoader.services["lambda"], "2015-03-31", {
      get: function get() {
        var model = require_lambda_2015_03_31_min();
        model.paginators = require_lambda_2015_03_31_paginators().pagination;
        model.waiters = require_lambda_2015_03_31_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Lambda;
  }
});

// node_modules/aws-sdk/apis/runtime.lex-2016-11-28.min.json
var require_runtime_lex_2016_11_28_min = __commonJS({
  "node_modules/aws-sdk/apis/runtime.lex-2016-11-28.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-11-28",
        endpointPrefix: "runtime.lex",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Lex Runtime Service",
        serviceId: "Lex Runtime Service",
        signatureVersion: "v4",
        signingName: "lex",
        uid: "runtime.lex-2016-11-28"
      },
      operations: {
        DeleteSession: {
          http: {
            method: "DELETE",
            requestUri: "/bot/{botName}/alias/{botAlias}/user/{userId}/session"
          },
          input: {
            type: "structure",
            required: [
              "botName",
              "botAlias",
              "userId"
            ],
            members: {
              botName: {
                location: "uri",
                locationName: "botName"
              },
              botAlias: {
                location: "uri",
                locationName: "botAlias"
              },
              userId: {
                location: "uri",
                locationName: "userId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botName: {},
              botAlias: {},
              userId: {},
              sessionId: {}
            }
          }
        },
        GetSession: {
          http: {
            method: "GET",
            requestUri: "/bot/{botName}/alias/{botAlias}/user/{userId}/session/"
          },
          input: {
            type: "structure",
            required: [
              "botName",
              "botAlias",
              "userId"
            ],
            members: {
              botName: {
                location: "uri",
                locationName: "botName"
              },
              botAlias: {
                location: "uri",
                locationName: "botAlias"
              },
              userId: {
                location: "uri",
                locationName: "userId"
              },
              checkpointLabelFilter: {
                location: "querystring",
                locationName: "checkpointLabelFilter"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              recentIntentSummaryView: {
                shape: "Sa"
              },
              sessionAttributes: {
                shape: "Sd"
              },
              sessionId: {},
              dialogAction: {
                shape: "Sh"
              },
              activeContexts: {
                shape: "Sk"
              }
            }
          }
        },
        PostContent: {
          http: {
            requestUri: "/bot/{botName}/alias/{botAlias}/user/{userId}/content"
          },
          input: {
            type: "structure",
            required: [
              "botName",
              "botAlias",
              "userId",
              "contentType",
              "inputStream"
            ],
            members: {
              botName: {
                location: "uri",
                locationName: "botName"
              },
              botAlias: {
                location: "uri",
                locationName: "botAlias"
              },
              userId: {
                location: "uri",
                locationName: "userId"
              },
              sessionAttributes: {
                shape: "St",
                jsonvalue: true,
                location: "header",
                locationName: "x-amz-lex-session-attributes"
              },
              requestAttributes: {
                shape: "St",
                jsonvalue: true,
                location: "header",
                locationName: "x-amz-lex-request-attributes"
              },
              contentType: {
                location: "header",
                locationName: "Content-Type"
              },
              accept: {
                location: "header",
                locationName: "Accept"
              },
              inputStream: {
                shape: "Sw"
              },
              activeContexts: {
                shape: "Sx",
                jsonvalue: true,
                location: "header",
                locationName: "x-amz-lex-active-contexts"
              }
            },
            payload: "inputStream"
          },
          output: {
            type: "structure",
            members: {
              contentType: {
                location: "header",
                locationName: "Content-Type"
              },
              intentName: {
                location: "header",
                locationName: "x-amz-lex-intent-name"
              },
              nluIntentConfidence: {
                jsonvalue: true,
                location: "header",
                locationName: "x-amz-lex-nlu-intent-confidence"
              },
              alternativeIntents: {
                jsonvalue: true,
                location: "header",
                locationName: "x-amz-lex-alternative-intents"
              },
              slots: {
                jsonvalue: true,
                location: "header",
                locationName: "x-amz-lex-slots"
              },
              sessionAttributes: {
                jsonvalue: true,
                location: "header",
                locationName: "x-amz-lex-session-attributes"
              },
              sentimentResponse: {
                location: "header",
                locationName: "x-amz-lex-sentiment"
              },
              message: {
                shape: "Si",
                deprecated: true,
                deprecatedMessage: "The message field is deprecated, use the encodedMessage field instead. The message field is available only in the de-DE, en-AU, en-GB, en-US, es-419, es-ES, es-US, fr-CA, fr-FR and it-IT locales.",
                location: "header",
                locationName: "x-amz-lex-message"
              },
              encodedMessage: {
                shape: "Sz",
                location: "header",
                locationName: "x-amz-lex-encoded-message"
              },
              messageFormat: {
                location: "header",
                locationName: "x-amz-lex-message-format"
              },
              dialogState: {
                location: "header",
                locationName: "x-amz-lex-dialog-state"
              },
              slotToElicit: {
                location: "header",
                locationName: "x-amz-lex-slot-to-elicit"
              },
              inputTranscript: {
                deprecated: true,
                deprecatedMessage: "The inputTranscript field is deprecated, use the encodedInputTranscript field instead. The inputTranscript field is available only in the de-DE, en-AU, en-GB, en-US, es-419, es-ES, es-US, fr-CA, fr-FR and it-IT locales.",
                location: "header",
                locationName: "x-amz-lex-input-transcript"
              },
              encodedInputTranscript: {
                location: "header",
                locationName: "x-amz-lex-encoded-input-transcript",
                type: "string",
                sensitive: true
              },
              audioStream: {
                shape: "Sw"
              },
              botVersion: {
                location: "header",
                locationName: "x-amz-lex-bot-version"
              },
              sessionId: {
                location: "header",
                locationName: "x-amz-lex-session-id"
              },
              activeContexts: {
                shape: "Sx",
                jsonvalue: true,
                location: "header",
                locationName: "x-amz-lex-active-contexts"
              }
            },
            payload: "audioStream"
          },
          authtype: "v4-unsigned-body"
        },
        PostText: {
          http: {
            requestUri: "/bot/{botName}/alias/{botAlias}/user/{userId}/text"
          },
          input: {
            type: "structure",
            required: [
              "botName",
              "botAlias",
              "userId",
              "inputText"
            ],
            members: {
              botName: {
                location: "uri",
                locationName: "botName"
              },
              botAlias: {
                location: "uri",
                locationName: "botAlias"
              },
              userId: {
                location: "uri",
                locationName: "userId"
              },
              sessionAttributes: {
                shape: "Sd"
              },
              requestAttributes: {
                shape: "Sd"
              },
              inputText: {
                shape: "Si"
              },
              activeContexts: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              intentName: {},
              nluIntentConfidence: {
                shape: "S15"
              },
              alternativeIntents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    intentName: {},
                    nluIntentConfidence: {
                      shape: "S15"
                    },
                    slots: {
                      shape: "Sd"
                    }
                  }
                }
              },
              slots: {
                shape: "Sd"
              },
              sessionAttributes: {
                shape: "Sd"
              },
              message: {
                shape: "Si"
              },
              sentimentResponse: {
                type: "structure",
                members: {
                  sentimentLabel: {},
                  sentimentScore: {}
                }
              },
              messageFormat: {},
              dialogState: {},
              slotToElicit: {},
              responseCard: {
                type: "structure",
                members: {
                  version: {},
                  contentType: {},
                  genericAttachments: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        title: {},
                        subTitle: {},
                        attachmentLinkUrl: {},
                        imageUrl: {},
                        buttons: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "text",
                              "value"
                            ],
                            members: {
                              text: {},
                              value: {}
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              sessionId: {},
              botVersion: {},
              activeContexts: {
                shape: "Sk"
              }
            }
          }
        },
        PutSession: {
          http: {
            requestUri: "/bot/{botName}/alias/{botAlias}/user/{userId}/session"
          },
          input: {
            type: "structure",
            required: [
              "botName",
              "botAlias",
              "userId"
            ],
            members: {
              botName: {
                location: "uri",
                locationName: "botName"
              },
              botAlias: {
                location: "uri",
                locationName: "botAlias"
              },
              userId: {
                location: "uri",
                locationName: "userId"
              },
              sessionAttributes: {
                shape: "Sd"
              },
              dialogAction: {
                shape: "Sh"
              },
              recentIntentSummaryView: {
                shape: "Sa"
              },
              accept: {
                location: "header",
                locationName: "Accept"
              },
              activeContexts: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              contentType: {
                location: "header",
                locationName: "Content-Type"
              },
              intentName: {
                location: "header",
                locationName: "x-amz-lex-intent-name"
              },
              slots: {
                jsonvalue: true,
                location: "header",
                locationName: "x-amz-lex-slots"
              },
              sessionAttributes: {
                jsonvalue: true,
                location: "header",
                locationName: "x-amz-lex-session-attributes"
              },
              message: {
                shape: "Si",
                deprecated: true,
                deprecatedMessage: "The message field is deprecated, use the encodedMessage field instead. The message field is available only in the de-DE, en-AU, en-GB, en-US, es-419, es-ES, es-US, fr-CA, fr-FR and it-IT locales.",
                location: "header",
                locationName: "x-amz-lex-message"
              },
              encodedMessage: {
                shape: "Sz",
                location: "header",
                locationName: "x-amz-lex-encoded-message"
              },
              messageFormat: {
                location: "header",
                locationName: "x-amz-lex-message-format"
              },
              dialogState: {
                location: "header",
                locationName: "x-amz-lex-dialog-state"
              },
              slotToElicit: {
                location: "header",
                locationName: "x-amz-lex-slot-to-elicit"
              },
              audioStream: {
                shape: "Sw"
              },
              sessionId: {
                location: "header",
                locationName: "x-amz-lex-session-id"
              },
              activeContexts: {
                shape: "Sx",
                jsonvalue: true,
                location: "header",
                locationName: "x-amz-lex-active-contexts"
              }
            },
            payload: "audioStream"
          }
        }
      },
      shapes: {
        Sa: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "dialogActionType"
            ],
            members: {
              intentName: {},
              checkpointLabel: {},
              slots: {
                shape: "Sd"
              },
              confirmationStatus: {},
              dialogActionType: {},
              fulfillmentState: {},
              slotToElicit: {}
            }
          }
        },
        Sd: {
          type: "map",
          key: {},
          value: {},
          sensitive: true
        },
        Sh: {
          type: "structure",
          required: [
            "type"
          ],
          members: {
            type: {},
            intentName: {},
            slots: {
              shape: "Sd"
            },
            slotToElicit: {},
            fulfillmentState: {},
            message: {
              shape: "Si"
            },
            messageFormat: {}
          }
        },
        Si: {
          type: "string",
          sensitive: true
        },
        Sk: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "timeToLive",
              "parameters"
            ],
            members: {
              name: {},
              timeToLive: {
                type: "structure",
                members: {
                  timeToLiveInSeconds: {
                    type: "integer"
                  },
                  turnsToLive: {
                    type: "integer"
                  }
                }
              },
              parameters: {
                type: "map",
                key: {},
                value: {
                  shape: "Si"
                }
              }
            }
          },
          sensitive: true
        },
        St: {
          type: "string",
          sensitive: true
        },
        Sw: {
          type: "blob",
          streaming: true
        },
        Sx: {
          type: "string",
          sensitive: true
        },
        Sz: {
          type: "string",
          sensitive: true
        },
        S15: {
          type: "structure",
          members: {
            score: {
              type: "double"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/runtime.lex-2016-11-28.paginators.json
var require_runtime_lex_2016_11_28_paginators = __commonJS({
  "node_modules/aws-sdk/apis/runtime.lex-2016-11-28.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/lexruntime.js
var require_lexruntime = __commonJS({
  "node_modules/aws-sdk/clients/lexruntime.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["lexruntime"] = {};
    AWS2.LexRuntime = Service.defineService("lexruntime", ["2016-11-28"]);
    Object.defineProperty(apiLoader.services["lexruntime"], "2016-11-28", {
      get: function get() {
        var model = require_runtime_lex_2016_11_28_min();
        model.paginators = require_runtime_lex_2016_11_28_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.LexRuntime;
  }
});

// node_modules/aws-sdk/apis/lightsail-2016-11-28.min.json
var require_lightsail_2016_11_28_min = __commonJS({
  "node_modules/aws-sdk/apis/lightsail-2016-11-28.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-11-28",
        endpointPrefix: "lightsail",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Lightsail",
        serviceId: "Lightsail",
        signatureVersion: "v4",
        targetPrefix: "Lightsail_20161128",
        uid: "lightsail-2016-11-28"
      },
      operations: {
        AllocateStaticIp: {
          input: {
            type: "structure",
            required: [
              "staticIpName"
            ],
            members: {
              staticIpName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        AttachCertificateToDistribution: {
          input: {
            type: "structure",
            required: [
              "distributionName",
              "certificateName"
            ],
            members: {
              distributionName: {},
              certificateName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        AttachDisk: {
          input: {
            type: "structure",
            required: [
              "diskName",
              "instanceName",
              "diskPath"
            ],
            members: {
              diskName: {},
              instanceName: {},
              diskPath: {},
              autoMounting: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        AttachInstancesToLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "loadBalancerName",
              "instanceNames"
            ],
            members: {
              loadBalancerName: {},
              instanceNames: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        AttachLoadBalancerTlsCertificate: {
          input: {
            type: "structure",
            required: [
              "loadBalancerName",
              "certificateName"
            ],
            members: {
              loadBalancerName: {},
              certificateName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        AttachStaticIp: {
          input: {
            type: "structure",
            required: [
              "staticIpName",
              "instanceName"
            ],
            members: {
              staticIpName: {},
              instanceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CloseInstancePublicPorts: {
          input: {
            type: "structure",
            required: [
              "portInfo",
              "instanceName"
            ],
            members: {
              portInfo: {
                shape: "Sr"
              },
              instanceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        CopySnapshot: {
          input: {
            type: "structure",
            required: [
              "targetSnapshotName",
              "sourceRegion"
            ],
            members: {
              sourceSnapshotName: {},
              sourceResourceName: {},
              restoreDate: {},
              useLatestRestorableAutoSnapshot: {
                type: "boolean"
              },
              targetSnapshotName: {},
              sourceRegion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateBucket: {
          input: {
            type: "structure",
            required: [
              "bucketName",
              "bundleId"
            ],
            members: {
              bucketName: {},
              bundleId: {},
              tags: {
                shape: "S10"
              },
              enableObjectVersioning: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              bucket: {
                shape: "S15"
              },
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateBucketAccessKey: {
          input: {
            type: "structure",
            required: [
              "bucketName"
            ],
            members: {
              bucketName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              accessKey: {
                shape: "S1g"
              },
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateCertificate: {
          input: {
            type: "structure",
            required: [
              "certificateName",
              "domainName"
            ],
            members: {
              certificateName: {},
              domainName: {},
              subjectAlternativeNames: {
                shape: "S1n"
              },
              tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              certificate: {
                shape: "S1p"
              },
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateCloudFormationStack: {
          input: {
            type: "structure",
            required: [
              "instances"
            ],
            members: {
              instances: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "sourceName",
                    "instanceType",
                    "portInfoSource",
                    "availabilityZone"
                  ],
                  members: {
                    sourceName: {},
                    instanceType: {},
                    portInfoSource: {},
                    userData: {},
                    availabilityZone: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateContactMethod: {
          input: {
            type: "structure",
            required: [
              "protocol",
              "contactEndpoint"
            ],
            members: {
              protocol: {},
              contactEndpoint: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateContainerService: {
          input: {
            type: "structure",
            required: [
              "serviceName",
              "power",
              "scale"
            ],
            members: {
              serviceName: {},
              power: {},
              scale: {
                type: "integer"
              },
              tags: {
                shape: "S10"
              },
              publicDomainNames: {
                shape: "S2l"
              },
              deployment: {
                type: "structure",
                members: {
                  containers: {
                    shape: "S2o"
                  },
                  publicEndpoint: {
                    shape: "S2u"
                  }
                }
              },
              privateRegistryAccess: {
                shape: "S2x"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              containerService: {
                shape: "S30"
              }
            }
          }
        },
        CreateContainerServiceDeployment: {
          input: {
            type: "structure",
            required: [
              "serviceName"
            ],
            members: {
              serviceName: {},
              containers: {
                shape: "S2o"
              },
              publicEndpoint: {
                shape: "S2u"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              containerService: {
                shape: "S30"
              }
            }
          }
        },
        CreateContainerServiceRegistryLogin: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              registryLogin: {
                type: "structure",
                members: {
                  username: {},
                  password: {},
                  expiresAt: {
                    type: "timestamp"
                  },
                  registry: {}
                }
              }
            }
          }
        },
        CreateDisk: {
          input: {
            type: "structure",
            required: [
              "diskName",
              "availabilityZone",
              "sizeInGb"
            ],
            members: {
              diskName: {},
              availabilityZone: {},
              sizeInGb: {
                type: "integer"
              },
              tags: {
                shape: "S10"
              },
              addOns: {
                shape: "S3f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateDiskFromSnapshot: {
          input: {
            type: "structure",
            required: [
              "diskName",
              "availabilityZone",
              "sizeInGb"
            ],
            members: {
              diskName: {},
              diskSnapshotName: {},
              availabilityZone: {},
              sizeInGb: {
                type: "integer"
              },
              tags: {
                shape: "S10"
              },
              addOns: {
                shape: "S3f"
              },
              sourceDiskName: {},
              restoreDate: {},
              useLatestRestorableAutoSnapshot: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateDiskSnapshot: {
          input: {
            type: "structure",
            required: [
              "diskSnapshotName"
            ],
            members: {
              diskName: {},
              diskSnapshotName: {},
              instanceName: {},
              tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateDistribution: {
          input: {
            type: "structure",
            required: [
              "distributionName",
              "origin",
              "defaultCacheBehavior",
              "bundleId"
            ],
            members: {
              distributionName: {},
              origin: {
                shape: "S3r"
              },
              defaultCacheBehavior: {
                shape: "S3t"
              },
              cacheBehaviorSettings: {
                shape: "S3v"
              },
              cacheBehaviors: {
                shape: "S43"
              },
              bundleId: {},
              ipAddressType: {},
              tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              distribution: {
                shape: "S47"
              },
              operation: {
                shape: "S5"
              }
            }
          }
        },
        CreateDomain: {
          input: {
            type: "structure",
            required: [
              "domainName"
            ],
            members: {
              domainName: {},
              tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        CreateDomainEntry: {
          input: {
            type: "structure",
            required: [
              "domainName",
              "domainEntry"
            ],
            members: {
              domainName: {},
              domainEntry: {
                shape: "S4c"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        CreateGUISessionAccessDetails: {
          input: {
            type: "structure",
            required: [
              "resourceName"
            ],
            members: {
              resourceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              resourceName: {},
              status: {},
              percentageComplete: {
                type: "integer"
              },
              failureReason: {},
              sessions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    url: {
                      type: "string",
                      sensitive: true
                    },
                    isPrimary: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        CreateInstanceSnapshot: {
          input: {
            type: "structure",
            required: [
              "instanceSnapshotName",
              "instanceName"
            ],
            members: {
              instanceSnapshotName: {},
              instanceName: {},
              tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateInstances: {
          input: {
            type: "structure",
            required: [
              "instanceNames",
              "availabilityZone",
              "blueprintId",
              "bundleId"
            ],
            members: {
              instanceNames: {
                shape: "Su"
              },
              availabilityZone: {},
              customImageName: {
                deprecated: true
              },
              blueprintId: {},
              bundleId: {},
              userData: {},
              keyPairName: {},
              tags: {
                shape: "S10"
              },
              addOns: {
                shape: "S3f"
              },
              ipAddressType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateInstancesFromSnapshot: {
          input: {
            type: "structure",
            required: [
              "instanceNames",
              "availabilityZone",
              "bundleId"
            ],
            members: {
              instanceNames: {
                shape: "Su"
              },
              attachedDiskMapping: {
                type: "map",
                key: {},
                value: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      originalDiskPath: {},
                      newDiskName: {}
                    }
                  }
                }
              },
              availabilityZone: {},
              instanceSnapshotName: {},
              bundleId: {},
              userData: {},
              keyPairName: {},
              tags: {
                shape: "S10"
              },
              addOns: {
                shape: "S3f"
              },
              ipAddressType: {},
              sourceInstanceName: {},
              restoreDate: {},
              useLatestRestorableAutoSnapshot: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateKeyPair: {
          input: {
            type: "structure",
            required: [
              "keyPairName"
            ],
            members: {
              keyPairName: {},
              tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              keyPair: {
                shape: "S4y"
              },
              publicKeyBase64: {},
              privateKeyBase64: {},
              operation: {
                shape: "S5"
              }
            }
          }
        },
        CreateLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "loadBalancerName",
              "instancePort"
            ],
            members: {
              loadBalancerName: {},
              instancePort: {
                type: "integer"
              },
              healthCheckPath: {},
              certificateName: {},
              certificateDomainName: {},
              certificateAlternativeNames: {
                shape: "S51"
              },
              tags: {
                shape: "S10"
              },
              ipAddressType: {},
              tlsPolicyName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateLoadBalancerTlsCertificate: {
          input: {
            type: "structure",
            required: [
              "loadBalancerName",
              "certificateName",
              "certificateDomainName"
            ],
            members: {
              loadBalancerName: {},
              certificateName: {},
              certificateDomainName: {},
              certificateAlternativeNames: {
                shape: "S51"
              },
              tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateRelationalDatabase: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName",
              "relationalDatabaseBlueprintId",
              "relationalDatabaseBundleId",
              "masterDatabaseName",
              "masterUsername"
            ],
            members: {
              relationalDatabaseName: {},
              availabilityZone: {},
              relationalDatabaseBlueprintId: {},
              relationalDatabaseBundleId: {},
              masterDatabaseName: {},
              masterUsername: {},
              masterUserPassword: {
                shape: "S56"
              },
              preferredBackupWindow: {},
              preferredMaintenanceWindow: {},
              publiclyAccessible: {
                type: "boolean"
              },
              tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateRelationalDatabaseFromSnapshot: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName"
            ],
            members: {
              relationalDatabaseName: {},
              availabilityZone: {},
              publiclyAccessible: {
                type: "boolean"
              },
              relationalDatabaseSnapshotName: {},
              relationalDatabaseBundleId: {},
              sourceRelationalDatabaseName: {},
              restoreTime: {
                type: "timestamp"
              },
              useLatestRestorableTime: {
                type: "boolean"
              },
              tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateRelationalDatabaseSnapshot: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName",
              "relationalDatabaseSnapshotName"
            ],
            members: {
              relationalDatabaseName: {},
              relationalDatabaseSnapshotName: {},
              tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DeleteAlarm: {
          input: {
            type: "structure",
            required: [
              "alarmName"
            ],
            members: {
              alarmName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DeleteAutoSnapshot: {
          input: {
            type: "structure",
            required: [
              "resourceName",
              "date"
            ],
            members: {
              resourceName: {},
              date: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DeleteBucket: {
          input: {
            type: "structure",
            required: [
              "bucketName"
            ],
            members: {
              bucketName: {},
              forceDelete: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DeleteBucketAccessKey: {
          input: {
            type: "structure",
            required: [
              "bucketName",
              "accessKeyId"
            ],
            members: {
              bucketName: {},
              accessKeyId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DeleteCertificate: {
          input: {
            type: "structure",
            required: [
              "certificateName"
            ],
            members: {
              certificateName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DeleteContactMethod: {
          input: {
            type: "structure",
            required: [
              "protocol"
            ],
            members: {
              protocol: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DeleteContainerImage: {
          input: {
            type: "structure",
            required: [
              "serviceName",
              "image"
            ],
            members: {
              serviceName: {},
              image: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteContainerService: {
          input: {
            type: "structure",
            required: [
              "serviceName"
            ],
            members: {
              serviceName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDisk: {
          input: {
            type: "structure",
            required: [
              "diskName"
            ],
            members: {
              diskName: {},
              forceDeleteAddOns: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DeleteDiskSnapshot: {
          input: {
            type: "structure",
            required: [
              "diskSnapshotName"
            ],
            members: {
              diskSnapshotName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DeleteDistribution: {
          input: {
            type: "structure",
            members: {
              distributionName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        DeleteDomain: {
          input: {
            type: "structure",
            required: [
              "domainName"
            ],
            members: {
              domainName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        DeleteDomainEntry: {
          input: {
            type: "structure",
            required: [
              "domainName",
              "domainEntry"
            ],
            members: {
              domainName: {},
              domainEntry: {
                shape: "S4c"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        DeleteInstance: {
          input: {
            type: "structure",
            required: [
              "instanceName"
            ],
            members: {
              instanceName: {},
              forceDeleteAddOns: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DeleteInstanceSnapshot: {
          input: {
            type: "structure",
            required: [
              "instanceSnapshotName"
            ],
            members: {
              instanceSnapshotName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DeleteKeyPair: {
          input: {
            type: "structure",
            required: [
              "keyPairName"
            ],
            members: {
              keyPairName: {},
              expectedFingerprint: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        DeleteKnownHostKeys: {
          input: {
            type: "structure",
            required: [
              "instanceName"
            ],
            members: {
              instanceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DeleteLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "loadBalancerName"
            ],
            members: {
              loadBalancerName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DeleteLoadBalancerTlsCertificate: {
          input: {
            type: "structure",
            required: [
              "loadBalancerName",
              "certificateName"
            ],
            members: {
              loadBalancerName: {},
              certificateName: {},
              force: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DeleteRelationalDatabase: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName"
            ],
            members: {
              relationalDatabaseName: {},
              skipFinalSnapshot: {
                type: "boolean"
              },
              finalRelationalDatabaseSnapshotName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DeleteRelationalDatabaseSnapshot: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseSnapshotName"
            ],
            members: {
              relationalDatabaseSnapshotName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DetachCertificateFromDistribution: {
          input: {
            type: "structure",
            required: [
              "distributionName"
            ],
            members: {
              distributionName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        DetachDisk: {
          input: {
            type: "structure",
            required: [
              "diskName"
            ],
            members: {
              diskName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DetachInstancesFromLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "loadBalancerName",
              "instanceNames"
            ],
            members: {
              loadBalancerName: {},
              instanceNames: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DetachStaticIp: {
          input: {
            type: "structure",
            required: [
              "staticIpName"
            ],
            members: {
              staticIpName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DisableAddOn: {
          input: {
            type: "structure",
            required: [
              "addOnType",
              "resourceName"
            ],
            members: {
              addOnType: {},
              resourceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DownloadDefaultKeyPair: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              publicKeyBase64: {},
              privateKeyBase64: {},
              createdAt: {
                type: "timestamp"
              }
            }
          }
        },
        EnableAddOn: {
          input: {
            type: "structure",
            required: [
              "resourceName",
              "addOnRequest"
            ],
            members: {
              resourceName: {},
              addOnRequest: {
                shape: "S3g"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        ExportSnapshot: {
          input: {
            type: "structure",
            required: [
              "sourceSnapshotName"
            ],
            members: {
              sourceSnapshotName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        GetActiveNames: {
          input: {
            type: "structure",
            members: {
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              activeNames: {
                shape: "Su"
              },
              nextPageToken: {}
            }
          }
        },
        GetAlarms: {
          input: {
            type: "structure",
            members: {
              alarmName: {},
              pageToken: {},
              monitoredResourceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              alarms: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    location: {
                      shape: "S9"
                    },
                    resourceType: {},
                    supportCode: {},
                    monitoredResourceInfo: {
                      type: "structure",
                      members: {
                        arn: {},
                        name: {},
                        resourceType: {}
                      }
                    },
                    comparisonOperator: {},
                    evaluationPeriods: {
                      type: "integer"
                    },
                    period: {
                      type: "integer"
                    },
                    threshold: {
                      type: "double"
                    },
                    datapointsToAlarm: {
                      type: "integer"
                    },
                    treatMissingData: {},
                    statistic: {},
                    metricName: {},
                    state: {},
                    unit: {},
                    contactProtocols: {
                      shape: "S7f"
                    },
                    notificationTriggers: {
                      shape: "S7g"
                    },
                    notificationEnabled: {
                      type: "boolean"
                    }
                  }
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetAutoSnapshots: {
          input: {
            type: "structure",
            required: [
              "resourceName"
            ],
            members: {
              resourceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              resourceName: {},
              resourceType: {},
              autoSnapshots: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    date: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    status: {},
                    fromAttachedDisks: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          path: {},
                          sizeInGb: {
                            type: "integer"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetBlueprints: {
          input: {
            type: "structure",
            members: {
              includeInactive: {
                type: "boolean"
              },
              pageToken: {},
              appCategory: {}
            }
          },
          output: {
            type: "structure",
            members: {
              blueprints: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    blueprintId: {},
                    name: {},
                    group: {},
                    type: {},
                    description: {},
                    isActive: {
                      type: "boolean"
                    },
                    minPower: {
                      type: "integer"
                    },
                    version: {},
                    versionCode: {},
                    productUrl: {},
                    licenseUrl: {},
                    platform: {},
                    appCategory: {}
                  }
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetBucketAccessKeys: {
          input: {
            type: "structure",
            required: [
              "bucketName"
            ],
            members: {
              bucketName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              accessKeys: {
                type: "list",
                member: {
                  shape: "S1g"
                }
              }
            }
          }
        },
        GetBucketBundles: {
          input: {
            type: "structure",
            members: {
              includeInactive: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              bundles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    bundleId: {},
                    name: {},
                    price: {
                      type: "float"
                    },
                    storagePerMonthInGb: {
                      type: "integer"
                    },
                    transferPerMonthInGb: {
                      type: "integer"
                    },
                    isActive: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        GetBucketMetricData: {
          input: {
            type: "structure",
            required: [
              "bucketName",
              "metricName",
              "startTime",
              "endTime",
              "period",
              "statistics",
              "unit"
            ],
            members: {
              bucketName: {},
              metricName: {},
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              period: {
                type: "integer"
              },
              statistics: {
                shape: "S85"
              },
              unit: {}
            }
          },
          output: {
            type: "structure",
            members: {
              metricName: {},
              metricData: {
                shape: "S87"
              }
            }
          }
        },
        GetBuckets: {
          input: {
            type: "structure",
            members: {
              bucketName: {},
              pageToken: {},
              includeConnectedResources: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              buckets: {
                type: "list",
                member: {
                  shape: "S15"
                }
              },
              nextPageToken: {},
              accountLevelBpaSync: {
                type: "structure",
                members: {
                  status: {},
                  lastSyncedAt: {
                    type: "timestamp"
                  },
                  message: {},
                  bpaImpactsLightsail: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        GetBundles: {
          input: {
            type: "structure",
            members: {
              includeInactive: {
                type: "boolean"
              },
              pageToken: {},
              appCategory: {}
            }
          },
          output: {
            type: "structure",
            members: {
              bundles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    price: {
                      type: "float"
                    },
                    cpuCount: {
                      type: "integer"
                    },
                    diskSizeInGb: {
                      type: "integer"
                    },
                    bundleId: {},
                    instanceType: {},
                    isActive: {
                      type: "boolean"
                    },
                    name: {},
                    power: {
                      type: "integer"
                    },
                    ramSizeInGb: {
                      type: "float"
                    },
                    transferPerMonthInGb: {
                      type: "integer"
                    },
                    supportedPlatforms: {
                      type: "list",
                      member: {}
                    },
                    supportedAppCategories: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetCertificates: {
          input: {
            type: "structure",
            members: {
              certificateStatuses: {
                type: "list",
                member: {}
              },
              includeCertificateDetails: {
                type: "boolean"
              },
              certificateName: {},
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              certificates: {
                type: "list",
                member: {
                  shape: "S1p"
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetCloudFormationStackRecords: {
          input: {
            type: "structure",
            members: {
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              cloudFormationStackRecords: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    location: {
                      shape: "S9"
                    },
                    resourceType: {},
                    state: {},
                    sourceInfo: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          resourceType: {},
                          name: {},
                          arn: {}
                        }
                      }
                    },
                    destinationInfo: {
                      shape: "S8z"
                    }
                  }
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetContactMethods: {
          input: {
            type: "structure",
            members: {
              protocols: {
                shape: "S7f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              contactMethods: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    contactEndpoint: {},
                    status: {},
                    protocol: {},
                    name: {},
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    location: {
                      shape: "S9"
                    },
                    resourceType: {},
                    supportCode: {}
                  }
                }
              }
            }
          }
        },
        GetContainerAPIMetadata: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              metadata: {
                type: "list",
                member: {
                  type: "map",
                  key: {},
                  value: {}
                }
              }
            }
          }
        },
        GetContainerImages: {
          input: {
            type: "structure",
            required: [
              "serviceName"
            ],
            members: {
              serviceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              containerImages: {
                type: "list",
                member: {
                  shape: "S9c"
                }
              }
            }
          }
        },
        GetContainerLog: {
          input: {
            type: "structure",
            required: [
              "serviceName",
              "containerName"
            ],
            members: {
              serviceName: {},
              containerName: {},
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              filterPattern: {},
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              logEvents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    createdAt: {
                      type: "timestamp"
                    },
                    message: {}
                  }
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetContainerServiceDeployments: {
          input: {
            type: "structure",
            required: [
              "serviceName"
            ],
            members: {
              serviceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deployments: {
                type: "list",
                member: {
                  shape: "S34"
                }
              }
            }
          }
        },
        GetContainerServiceMetricData: {
          input: {
            type: "structure",
            required: [
              "serviceName",
              "metricName",
              "startTime",
              "endTime",
              "period",
              "statistics"
            ],
            members: {
              serviceName: {},
              metricName: {},
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              period: {
                type: "integer"
              },
              statistics: {
                shape: "S85"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              metricName: {},
              metricData: {
                shape: "S87"
              }
            }
          }
        },
        GetContainerServicePowers: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              powers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    powerId: {},
                    price: {
                      type: "float"
                    },
                    cpuCount: {
                      type: "float"
                    },
                    ramSizeInGb: {
                      type: "float"
                    },
                    name: {},
                    isActive: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        GetContainerServices: {
          input: {
            type: "structure",
            members: {
              serviceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              containerServices: {
                type: "list",
                member: {
                  shape: "S30"
                }
              }
            }
          }
        },
        GetCostEstimate: {
          input: {
            type: "structure",
            required: [
              "resourceName",
              "startTime",
              "endTime"
            ],
            members: {
              resourceName: {},
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resourcesBudgetEstimate: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    resourceName: {},
                    resourceType: {},
                    costEstimates: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          usageType: {},
                          resultsByTime: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                usageCost: {
                                  type: "double"
                                },
                                pricingUnit: {},
                                unit: {
                                  type: "double"
                                },
                                currency: {},
                                timePeriod: {
                                  type: "structure",
                                  members: {
                                    start: {
                                      type: "timestamp"
                                    },
                                    end: {
                                      type: "timestamp"
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    startTime: {
                      type: "timestamp"
                    },
                    endTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        GetDisk: {
          input: {
            type: "structure",
            required: [
              "diskName"
            ],
            members: {
              diskName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              disk: {
                shape: "Sa7"
              }
            }
          }
        },
        GetDiskSnapshot: {
          input: {
            type: "structure",
            required: [
              "diskSnapshotName"
            ],
            members: {
              diskSnapshotName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              diskSnapshot: {
                shape: "Sae"
              }
            }
          }
        },
        GetDiskSnapshots: {
          input: {
            type: "structure",
            members: {
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              diskSnapshots: {
                type: "list",
                member: {
                  shape: "Sae"
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetDisks: {
          input: {
            type: "structure",
            members: {
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              disks: {
                shape: "Sal"
              },
              nextPageToken: {}
            }
          }
        },
        GetDistributionBundles: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              bundles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    bundleId: {},
                    name: {},
                    price: {
                      type: "float"
                    },
                    transferPerMonthInGb: {
                      type: "integer"
                    },
                    isActive: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        GetDistributionLatestCacheReset: {
          input: {
            type: "structure",
            members: {
              distributionName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              status: {},
              createTime: {
                type: "timestamp"
              }
            }
          }
        },
        GetDistributionMetricData: {
          input: {
            type: "structure",
            required: [
              "distributionName",
              "metricName",
              "startTime",
              "endTime",
              "period",
              "unit",
              "statistics"
            ],
            members: {
              distributionName: {},
              metricName: {},
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              period: {
                type: "integer"
              },
              unit: {},
              statistics: {
                shape: "S85"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              metricName: {},
              metricData: {
                shape: "S87"
              }
            }
          }
        },
        GetDistributions: {
          input: {
            type: "structure",
            members: {
              distributionName: {},
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              distributions: {
                type: "list",
                member: {
                  shape: "S47"
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetDomain: {
          input: {
            type: "structure",
            required: [
              "domainName"
            ],
            members: {
              domainName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              domain: {
                shape: "Sb0"
              }
            }
          }
        },
        GetDomains: {
          input: {
            type: "structure",
            members: {
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              domains: {
                type: "list",
                member: {
                  shape: "Sb0"
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetExportSnapshotRecords: {
          input: {
            type: "structure",
            members: {
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              exportSnapshotRecords: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    location: {
                      shape: "S9"
                    },
                    resourceType: {},
                    state: {},
                    sourceInfo: {
                      type: "structure",
                      members: {
                        resourceType: {},
                        createdAt: {
                          type: "timestamp"
                        },
                        name: {},
                        arn: {},
                        fromResourceName: {},
                        fromResourceArn: {},
                        instanceSnapshotInfo: {
                          type: "structure",
                          members: {
                            fromBundleId: {},
                            fromBlueprintId: {},
                            fromDiskInfo: {
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  name: {},
                                  path: {},
                                  sizeInGb: {
                                    type: "integer"
                                  },
                                  isSystemDisk: {
                                    type: "boolean"
                                  }
                                }
                              }
                            }
                          }
                        },
                        diskSnapshotInfo: {
                          type: "structure",
                          members: {
                            sizeInGb: {
                              type: "integer"
                            }
                          }
                        }
                      }
                    },
                    destinationInfo: {
                      shape: "S8z"
                    }
                  }
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetInstance: {
          input: {
            type: "structure",
            required: [
              "instanceName"
            ],
            members: {
              instanceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              instance: {
                shape: "Sbm"
              }
            }
          }
        },
        GetInstanceAccessDetails: {
          input: {
            type: "structure",
            required: [
              "instanceName"
            ],
            members: {
              instanceName: {},
              protocol: {}
            }
          },
          output: {
            type: "structure",
            members: {
              accessDetails: {
                type: "structure",
                members: {
                  certKey: {},
                  expiresAt: {
                    type: "timestamp"
                  },
                  ipAddress: {},
                  password: {},
                  passwordData: {
                    type: "structure",
                    members: {
                      ciphertext: {},
                      keyPairName: {}
                    }
                  },
                  privateKey: {},
                  protocol: {},
                  instanceName: {},
                  username: {},
                  hostKeys: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        algorithm: {},
                        publicKey: {},
                        witnessedAt: {
                          type: "timestamp"
                        },
                        fingerprintSHA1: {},
                        fingerprintSHA256: {},
                        notValidBefore: {
                          type: "timestamp"
                        },
                        notValidAfter: {
                          type: "timestamp"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetInstanceMetricData: {
          input: {
            type: "structure",
            required: [
              "instanceName",
              "metricName",
              "period",
              "startTime",
              "endTime",
              "unit",
              "statistics"
            ],
            members: {
              instanceName: {},
              metricName: {},
              period: {
                type: "integer"
              },
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              unit: {},
              statistics: {
                shape: "S85"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              metricName: {},
              metricData: {
                shape: "S87"
              }
            }
          }
        },
        GetInstancePortStates: {
          input: {
            type: "structure",
            required: [
              "instanceName"
            ],
            members: {
              instanceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              portStates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    fromPort: {
                      type: "integer"
                    },
                    toPort: {
                      type: "integer"
                    },
                    protocol: {},
                    state: {},
                    cidrs: {
                      shape: "Su"
                    },
                    ipv6Cidrs: {
                      shape: "Su"
                    },
                    cidrListAliases: {
                      shape: "Su"
                    }
                  }
                }
              }
            }
          }
        },
        GetInstanceSnapshot: {
          input: {
            type: "structure",
            required: [
              "instanceSnapshotName"
            ],
            members: {
              instanceSnapshotName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              instanceSnapshot: {
                shape: "Sck"
              }
            }
          }
        },
        GetInstanceSnapshots: {
          input: {
            type: "structure",
            members: {
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              instanceSnapshots: {
                type: "list",
                member: {
                  shape: "Sck"
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetInstanceState: {
          input: {
            type: "structure",
            required: [
              "instanceName"
            ],
            members: {
              instanceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              state: {
                shape: "Sbx"
              }
            }
          }
        },
        GetInstances: {
          input: {
            type: "structure",
            members: {
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              instances: {
                type: "list",
                member: {
                  shape: "Sbm"
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetKeyPair: {
          input: {
            type: "structure",
            required: [
              "keyPairName"
            ],
            members: {
              keyPairName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              keyPair: {
                shape: "S4y"
              }
            }
          }
        },
        GetKeyPairs: {
          input: {
            type: "structure",
            members: {
              pageToken: {},
              includeDefaultKeyPair: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              keyPairs: {
                type: "list",
                member: {
                  shape: "S4y"
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "loadBalancerName"
            ],
            members: {
              loadBalancerName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              loadBalancer: {
                shape: "Sd1"
              }
            }
          }
        },
        GetLoadBalancerMetricData: {
          input: {
            type: "structure",
            required: [
              "loadBalancerName",
              "metricName",
              "period",
              "startTime",
              "endTime",
              "unit",
              "statistics"
            ],
            members: {
              loadBalancerName: {},
              metricName: {},
              period: {
                type: "integer"
              },
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              unit: {},
              statistics: {
                shape: "S85"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              metricName: {},
              metricData: {
                shape: "S87"
              }
            }
          }
        },
        GetLoadBalancerTlsCertificates: {
          input: {
            type: "structure",
            required: [
              "loadBalancerName"
            ],
            members: {
              loadBalancerName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tlsCertificates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    arn: {},
                    supportCode: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    location: {
                      shape: "S9"
                    },
                    resourceType: {},
                    tags: {
                      shape: "S10"
                    },
                    loadBalancerName: {},
                    isAttached: {
                      type: "boolean"
                    },
                    status: {},
                    domainName: {},
                    domainValidationRecords: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          type: {},
                          value: {},
                          validationStatus: {},
                          domainName: {},
                          dnsRecordCreationState: {
                            type: "structure",
                            members: {
                              code: {},
                              message: {}
                            }
                          }
                        }
                      }
                    },
                    failureReason: {},
                    issuedAt: {
                      type: "timestamp"
                    },
                    issuer: {},
                    keyAlgorithm: {},
                    notAfter: {
                      type: "timestamp"
                    },
                    notBefore: {
                      type: "timestamp"
                    },
                    renewalSummary: {
                      type: "structure",
                      members: {
                        renewalStatus: {},
                        domainValidationOptions: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              domainName: {},
                              validationStatus: {}
                            }
                          }
                        }
                      }
                    },
                    revocationReason: {},
                    revokedAt: {
                      type: "timestamp"
                    },
                    serial: {},
                    signatureAlgorithm: {},
                    subject: {},
                    subjectAlternativeNames: {
                      shape: "Su"
                    }
                  }
                }
              }
            }
          }
        },
        GetLoadBalancerTlsPolicies: {
          input: {
            type: "structure",
            members: {
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tlsPolicies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    isDefault: {
                      type: "boolean"
                    },
                    description: {},
                    protocols: {
                      shape: "Su"
                    },
                    ciphers: {
                      shape: "Su"
                    }
                  }
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetLoadBalancers: {
          input: {
            type: "structure",
            members: {
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              loadBalancers: {
                type: "list",
                member: {
                  shape: "Sd1"
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetOperation: {
          input: {
            type: "structure",
            required: [
              "operationId"
            ],
            members: {
              operationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        GetOperations: {
          input: {
            type: "structure",
            members: {
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              },
              nextPageToken: {}
            }
          }
        },
        GetOperationsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceName"
            ],
            members: {
              resourceName: {},
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              },
              nextPageCount: {
                deprecated: true
              },
              nextPageToken: {}
            }
          }
        },
        GetRegions: {
          input: {
            type: "structure",
            members: {
              includeAvailabilityZones: {
                type: "boolean"
              },
              includeRelationalDatabaseAvailabilityZones: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              regions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    continentCode: {},
                    description: {},
                    displayName: {},
                    name: {},
                    availabilityZones: {
                      shape: "Sed"
                    },
                    relationalDatabaseAvailabilityZones: {
                      shape: "Sed"
                    }
                  }
                }
              }
            }
          }
        },
        GetRelationalDatabase: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName"
            ],
            members: {
              relationalDatabaseName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              relationalDatabase: {
                shape: "Seh"
              }
            }
          }
        },
        GetRelationalDatabaseBlueprints: {
          input: {
            type: "structure",
            members: {
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              blueprints: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    blueprintId: {},
                    engine: {},
                    engineVersion: {},
                    engineDescription: {},
                    engineVersionDescription: {},
                    isEngineDefault: {
                      type: "boolean"
                    }
                  }
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetRelationalDatabaseBundles: {
          input: {
            type: "structure",
            members: {
              pageToken: {},
              includeInactive: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              bundles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    bundleId: {},
                    name: {},
                    price: {
                      type: "float"
                    },
                    ramSizeInGb: {
                      type: "float"
                    },
                    diskSizeInGb: {
                      type: "integer"
                    },
                    transferPerMonthInGb: {
                      type: "integer"
                    },
                    cpuCount: {
                      type: "integer"
                    },
                    isEncrypted: {
                      type: "boolean"
                    },
                    isActive: {
                      type: "boolean"
                    }
                  }
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetRelationalDatabaseEvents: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName"
            ],
            members: {
              relationalDatabaseName: {},
              durationInMinutes: {
                type: "integer"
              },
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              relationalDatabaseEvents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    resource: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    message: {},
                    eventCategories: {
                      shape: "Su"
                    }
                  }
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetRelationalDatabaseLogEvents: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName",
              "logStreamName"
            ],
            members: {
              relationalDatabaseName: {},
              logStreamName: {},
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              startFromHead: {
                type: "boolean"
              },
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              resourceLogEvents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    createdAt: {
                      type: "timestamp"
                    },
                    message: {}
                  }
                }
              },
              nextBackwardToken: {},
              nextForwardToken: {}
            }
          }
        },
        GetRelationalDatabaseLogStreams: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName"
            ],
            members: {
              relationalDatabaseName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              logStreams: {
                shape: "Su"
              }
            }
          }
        },
        GetRelationalDatabaseMasterUserPassword: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName"
            ],
            members: {
              relationalDatabaseName: {},
              passwordVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              masterUserPassword: {
                shape: "S56"
              },
              createdAt: {
                type: "timestamp"
              }
            }
          }
        },
        GetRelationalDatabaseMetricData: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName",
              "metricName",
              "period",
              "startTime",
              "endTime",
              "unit",
              "statistics"
            ],
            members: {
              relationalDatabaseName: {},
              metricName: {},
              period: {
                type: "integer"
              },
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              unit: {},
              statistics: {
                shape: "S85"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              metricName: {},
              metricData: {
                shape: "S87"
              }
            }
          }
        },
        GetRelationalDatabaseParameters: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName"
            ],
            members: {
              relationalDatabaseName: {},
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              parameters: {
                shape: "Sfe"
              },
              nextPageToken: {}
            }
          }
        },
        GetRelationalDatabaseSnapshot: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseSnapshotName"
            ],
            members: {
              relationalDatabaseSnapshotName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              relationalDatabaseSnapshot: {
                shape: "Sfi"
              }
            }
          }
        },
        GetRelationalDatabaseSnapshots: {
          input: {
            type: "structure",
            members: {
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              relationalDatabaseSnapshots: {
                type: "list",
                member: {
                  shape: "Sfi"
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetRelationalDatabases: {
          input: {
            type: "structure",
            members: {
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              relationalDatabases: {
                type: "list",
                member: {
                  shape: "Seh"
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetSetupHistory: {
          input: {
            type: "structure",
            required: [
              "resourceName"
            ],
            members: {
              resourceName: {},
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              setupHistory: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    operationId: {},
                    request: {
                      type: "structure",
                      members: {
                        instanceName: {},
                        domainNames: {
                          shape: "Sfv"
                        },
                        certificateProvider: {}
                      }
                    },
                    resource: {
                      type: "structure",
                      members: {
                        name: {},
                        arn: {},
                        createdAt: {
                          type: "timestamp"
                        },
                        location: {
                          shape: "S9"
                        },
                        resourceType: {}
                      }
                    },
                    executionDetails: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          command: {},
                          dateTime: {
                            type: "timestamp"
                          },
                          name: {},
                          status: {},
                          standardError: {},
                          standardOutput: {},
                          version: {}
                        }
                      }
                    },
                    status: {}
                  }
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetStaticIp: {
          input: {
            type: "structure",
            required: [
              "staticIpName"
            ],
            members: {
              staticIpName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              staticIp: {
                shape: "Sg4"
              }
            }
          }
        },
        GetStaticIps: {
          input: {
            type: "structure",
            members: {
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              staticIps: {
                type: "list",
                member: {
                  shape: "Sg4"
                }
              },
              nextPageToken: {}
            }
          }
        },
        ImportKeyPair: {
          input: {
            type: "structure",
            required: [
              "keyPairName",
              "publicKeyBase64"
            ],
            members: {
              keyPairName: {},
              publicKeyBase64: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        IsVpcPeered: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              isPeered: {
                type: "boolean"
              }
            }
          }
        },
        OpenInstancePublicPorts: {
          input: {
            type: "structure",
            required: [
              "portInfo",
              "instanceName"
            ],
            members: {
              portInfo: {
                shape: "Sr"
              },
              instanceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        PeerVpc: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        PutAlarm: {
          input: {
            type: "structure",
            required: [
              "alarmName",
              "metricName",
              "monitoredResourceName",
              "comparisonOperator",
              "threshold",
              "evaluationPeriods"
            ],
            members: {
              alarmName: {},
              metricName: {},
              monitoredResourceName: {},
              comparisonOperator: {},
              threshold: {
                type: "double"
              },
              evaluationPeriods: {
                type: "integer"
              },
              datapointsToAlarm: {
                type: "integer"
              },
              treatMissingData: {},
              contactProtocols: {
                shape: "S7f"
              },
              notificationTriggers: {
                shape: "S7g"
              },
              notificationEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        PutInstancePublicPorts: {
          input: {
            type: "structure",
            required: [
              "portInfos",
              "instanceName"
            ],
            members: {
              portInfos: {
                type: "list",
                member: {
                  shape: "Sr"
                }
              },
              instanceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        RebootInstance: {
          input: {
            type: "structure",
            required: [
              "instanceName"
            ],
            members: {
              instanceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        RebootRelationalDatabase: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName"
            ],
            members: {
              relationalDatabaseName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        RegisterContainerImage: {
          input: {
            type: "structure",
            required: [
              "serviceName",
              "label",
              "digest"
            ],
            members: {
              serviceName: {},
              label: {},
              digest: {}
            }
          },
          output: {
            type: "structure",
            members: {
              containerImage: {
                shape: "S9c"
              }
            }
          }
        },
        ReleaseStaticIp: {
          input: {
            type: "structure",
            required: [
              "staticIpName"
            ],
            members: {
              staticIpName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        ResetDistributionCache: {
          input: {
            type: "structure",
            members: {
              distributionName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              status: {},
              createTime: {
                type: "timestamp"
              },
              operation: {
                shape: "S5"
              }
            }
          }
        },
        SendContactMethodVerification: {
          input: {
            type: "structure",
            required: [
              "protocol"
            ],
            members: {
              protocol: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        SetIpAddressType: {
          input: {
            type: "structure",
            required: [
              "resourceType",
              "resourceName",
              "ipAddressType"
            ],
            members: {
              resourceType: {},
              resourceName: {},
              ipAddressType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        SetResourceAccessForBucket: {
          input: {
            type: "structure",
            required: [
              "resourceName",
              "bucketName",
              "access"
            ],
            members: {
              resourceName: {},
              bucketName: {},
              access: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        SetupInstanceHttps: {
          input: {
            type: "structure",
            required: [
              "instanceName",
              "emailAddress",
              "domainNames",
              "certificateProvider"
            ],
            members: {
              instanceName: {},
              emailAddress: {
                type: "string",
                sensitive: true
              },
              domainNames: {
                shape: "Sfv"
              },
              certificateProvider: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        StartGUISession: {
          input: {
            type: "structure",
            required: [
              "resourceName"
            ],
            members: {
              resourceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        StartInstance: {
          input: {
            type: "structure",
            required: [
              "instanceName"
            ],
            members: {
              instanceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        StartRelationalDatabase: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName"
            ],
            members: {
              relationalDatabaseName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        StopGUISession: {
          input: {
            type: "structure",
            required: [
              "resourceName"
            ],
            members: {
              resourceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        StopInstance: {
          input: {
            type: "structure",
            required: [
              "instanceName"
            ],
            members: {
              instanceName: {},
              force: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        StopRelationalDatabase: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName"
            ],
            members: {
              relationalDatabaseName: {},
              relationalDatabaseSnapshotName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "resourceName",
              "tags"
            ],
            members: {
              resourceName: {},
              resourceArn: {},
              tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        TestAlarm: {
          input: {
            type: "structure",
            required: [
              "alarmName",
              "state"
            ],
            members: {
              alarmName: {},
              state: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        UnpeerVpc: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "resourceName",
              "tagKeys"
            ],
            members: {
              resourceName: {},
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        UpdateBucket: {
          input: {
            type: "structure",
            required: [
              "bucketName"
            ],
            members: {
              bucketName: {},
              accessRules: {
                shape: "S16"
              },
              versioning: {},
              readonlyAccessAccounts: {
                shape: "S18"
              },
              accessLogConfig: {
                shape: "S1c"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              bucket: {
                shape: "S15"
              },
              operations: {
                shape: "S4"
              }
            }
          }
        },
        UpdateBucketBundle: {
          input: {
            type: "structure",
            required: [
              "bucketName",
              "bundleId"
            ],
            members: {
              bucketName: {},
              bundleId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        UpdateContainerService: {
          input: {
            type: "structure",
            required: [
              "serviceName"
            ],
            members: {
              serviceName: {},
              power: {},
              scale: {
                type: "integer"
              },
              isDisabled: {
                type: "boolean"
              },
              publicDomainNames: {
                shape: "S2l"
              },
              privateRegistryAccess: {
                shape: "S2x"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              containerService: {
                shape: "S30"
              }
            }
          }
        },
        UpdateDistribution: {
          input: {
            type: "structure",
            required: [
              "distributionName"
            ],
            members: {
              distributionName: {},
              origin: {
                shape: "S3r"
              },
              defaultCacheBehavior: {
                shape: "S3t"
              },
              cacheBehaviorSettings: {
                shape: "S3v"
              },
              cacheBehaviors: {
                shape: "S43"
              },
              isEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        UpdateDistributionBundle: {
          input: {
            type: "structure",
            members: {
              distributionName: {},
              bundleId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        UpdateDomainEntry: {
          input: {
            type: "structure",
            required: [
              "domainName",
              "domainEntry"
            ],
            members: {
              domainName: {},
              domainEntry: {
                shape: "S4c"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        UpdateInstanceMetadataOptions: {
          input: {
            type: "structure",
            required: [
              "instanceName"
            ],
            members: {
              instanceName: {},
              httpTokens: {},
              httpEndpoint: {},
              httpPutResponseHopLimit: {
                type: "integer"
              },
              httpProtocolIpv6: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        UpdateLoadBalancerAttribute: {
          input: {
            type: "structure",
            required: [
              "loadBalancerName",
              "attributeName",
              "attributeValue"
            ],
            members: {
              loadBalancerName: {},
              attributeName: {},
              attributeValue: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        UpdateRelationalDatabase: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName"
            ],
            members: {
              relationalDatabaseName: {},
              masterUserPassword: {
                shape: "S56"
              },
              rotateMasterUserPassword: {
                type: "boolean"
              },
              preferredBackupWindow: {},
              preferredMaintenanceWindow: {},
              enableBackupRetention: {
                type: "boolean"
              },
              disableBackupRetention: {
                type: "boolean"
              },
              publiclyAccessible: {
                type: "boolean"
              },
              applyImmediately: {
                type: "boolean"
              },
              caCertificateIdentifier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        UpdateRelationalDatabaseParameters: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName",
              "parameters"
            ],
            members: {
              relationalDatabaseName: {},
              parameters: {
                shape: "Sfe"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "list",
          member: {
            shape: "S5"
          }
        },
        S5: {
          type: "structure",
          members: {
            id: {},
            resourceName: {},
            resourceType: {},
            createdAt: {
              type: "timestamp"
            },
            location: {
              shape: "S9"
            },
            isTerminal: {
              type: "boolean"
            },
            operationDetails: {},
            operationType: {},
            status: {},
            statusChangedAt: {
              type: "timestamp"
            },
            errorCode: {},
            errorDetails: {}
          }
        },
        S9: {
          type: "structure",
          members: {
            availabilityZone: {},
            regionName: {}
          }
        },
        Sk: {
          type: "list",
          member: {}
        },
        Sr: {
          type: "structure",
          members: {
            fromPort: {
              type: "integer"
            },
            toPort: {
              type: "integer"
            },
            protocol: {},
            cidrs: {
              shape: "Su"
            },
            ipv6Cidrs: {
              shape: "Su"
            },
            cidrListAliases: {
              shape: "Su"
            }
          }
        },
        Su: {
          type: "list",
          member: {}
        },
        S10: {
          type: "list",
          member: {
            type: "structure",
            members: {
              key: {},
              value: {}
            }
          }
        },
        S15: {
          type: "structure",
          members: {
            resourceType: {},
            accessRules: {
              shape: "S16"
            },
            arn: {},
            bundleId: {},
            createdAt: {
              type: "timestamp"
            },
            url: {},
            location: {
              shape: "S9"
            },
            name: {},
            supportCode: {},
            tags: {
              shape: "S10"
            },
            objectVersioning: {},
            ableToUpdateBundle: {
              type: "boolean"
            },
            readonlyAccessAccounts: {
              shape: "S18"
            },
            resourcesReceivingAccess: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  name: {},
                  resourceType: {}
                }
              }
            },
            state: {
              type: "structure",
              members: {
                code: {},
                message: {}
              }
            },
            accessLogConfig: {
              shape: "S1c"
            }
          }
        },
        S16: {
          type: "structure",
          members: {
            getObject: {},
            allowPublicOverrides: {
              type: "boolean"
            }
          }
        },
        S18: {
          type: "list",
          member: {}
        },
        S1c: {
          type: "structure",
          required: [
            "enabled"
          ],
          members: {
            enabled: {
              type: "boolean"
            },
            destination: {},
            prefix: {}
          }
        },
        S1g: {
          type: "structure",
          members: {
            accessKeyId: {
              type: "string",
              sensitive: true
            },
            secretAccessKey: {},
            status: {},
            createdAt: {
              type: "timestamp"
            },
            lastUsed: {
              type: "structure",
              members: {
                lastUsedDate: {
                  type: "timestamp"
                },
                region: {},
                serviceName: {}
              }
            }
          }
        },
        S1n: {
          type: "list",
          member: {}
        },
        S1p: {
          type: "structure",
          members: {
            certificateArn: {},
            certificateName: {},
            domainName: {},
            certificateDetail: {
              type: "structure",
              members: {
                arn: {},
                name: {},
                domainName: {},
                status: {},
                serialNumber: {},
                subjectAlternativeNames: {
                  shape: "S1n"
                },
                domainValidationRecords: {
                  shape: "S1t"
                },
                requestFailureReason: {},
                inUseResourceCount: {
                  type: "integer"
                },
                keyAlgorithm: {},
                createdAt: {
                  type: "timestamp"
                },
                issuedAt: {
                  type: "timestamp"
                },
                issuerCA: {},
                notBefore: {
                  type: "timestamp"
                },
                notAfter: {
                  type: "timestamp"
                },
                eligibleToRenew: {},
                renewalSummary: {
                  type: "structure",
                  members: {
                    domainValidationRecords: {
                      shape: "S1t"
                    },
                    renewalStatus: {},
                    renewalStatusReason: {},
                    updatedAt: {
                      type: "timestamp"
                    }
                  }
                },
                revokedAt: {
                  type: "timestamp"
                },
                revocationReason: {},
                tags: {
                  shape: "S10"
                },
                supportCode: {}
              }
            },
            tags: {
              shape: "S10"
            }
          }
        },
        S1t: {
          type: "list",
          member: {
            type: "structure",
            members: {
              domainName: {},
              resourceRecord: {
                type: "structure",
                members: {
                  name: {},
                  type: {},
                  value: {}
                }
              },
              dnsRecordCreationState: {
                type: "structure",
                members: {
                  code: {},
                  message: {}
                }
              },
              validationStatus: {}
            }
          }
        },
        S2l: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {}
          }
        },
        S2o: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              image: {},
              command: {
                shape: "Su"
              },
              environment: {
                type: "map",
                key: {},
                value: {}
              },
              ports: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        S2u: {
          type: "structure",
          required: [
            "containerName",
            "containerPort"
          ],
          members: {
            containerName: {},
            containerPort: {
              type: "integer"
            },
            healthCheck: {
              shape: "S2w"
            }
          }
        },
        S2w: {
          type: "structure",
          members: {
            healthyThreshold: {
              type: "integer"
            },
            unhealthyThreshold: {
              type: "integer"
            },
            timeoutSeconds: {
              type: "integer"
            },
            intervalSeconds: {
              type: "integer"
            },
            path: {},
            successCodes: {}
          }
        },
        S2x: {
          type: "structure",
          members: {
            ecrImagePullerRole: {
              type: "structure",
              members: {
                isActive: {
                  type: "boolean"
                }
              }
            }
          }
        },
        S30: {
          type: "structure",
          members: {
            containerServiceName: {},
            arn: {},
            createdAt: {
              type: "timestamp"
            },
            location: {
              shape: "S9"
            },
            resourceType: {},
            tags: {
              shape: "S10"
            },
            power: {},
            powerId: {},
            state: {},
            stateDetail: {
              type: "structure",
              members: {
                code: {},
                message: {}
              }
            },
            scale: {
              type: "integer"
            },
            currentDeployment: {
              shape: "S34"
            },
            nextDeployment: {
              shape: "S34"
            },
            isDisabled: {
              type: "boolean"
            },
            principalArn: {},
            privateDomainName: {},
            publicDomainNames: {
              shape: "S2l"
            },
            url: {},
            privateRegistryAccess: {
              type: "structure",
              members: {
                ecrImagePullerRole: {
                  type: "structure",
                  members: {
                    isActive: {
                      type: "boolean"
                    },
                    principalArn: {}
                  }
                }
              }
            }
          }
        },
        S34: {
          type: "structure",
          members: {
            version: {
              type: "integer"
            },
            state: {},
            containers: {
              shape: "S2o"
            },
            publicEndpoint: {
              type: "structure",
              members: {
                containerName: {},
                containerPort: {
                  type: "integer"
                },
                healthCheck: {
                  shape: "S2w"
                }
              }
            },
            createdAt: {
              type: "timestamp"
            }
          }
        },
        S3f: {
          type: "list",
          member: {
            shape: "S3g"
          }
        },
        S3g: {
          type: "structure",
          required: [
            "addOnType"
          ],
          members: {
            addOnType: {},
            autoSnapshotAddOnRequest: {
              type: "structure",
              members: {
                snapshotTimeOfDay: {}
              }
            },
            stopInstanceOnIdleRequest: {
              type: "structure",
              members: {
                threshold: {},
                duration: {}
              }
            }
          }
        },
        S3r: {
          type: "structure",
          members: {
            name: {},
            regionName: {},
            protocolPolicy: {}
          }
        },
        S3t: {
          type: "structure",
          members: {
            behavior: {}
          }
        },
        S3v: {
          type: "structure",
          members: {
            defaultTTL: {
              type: "long"
            },
            minimumTTL: {
              type: "long"
            },
            maximumTTL: {
              type: "long"
            },
            allowedHTTPMethods: {},
            cachedHTTPMethods: {},
            forwardedCookies: {
              type: "structure",
              members: {
                option: {},
                cookiesAllowList: {
                  shape: "Su"
                }
              }
            },
            forwardedHeaders: {
              type: "structure",
              members: {
                option: {},
                headersAllowList: {
                  type: "list",
                  member: {}
                }
              }
            },
            forwardedQueryStrings: {
              type: "structure",
              members: {
                option: {
                  type: "boolean"
                },
                queryStringsAllowList: {
                  shape: "Su"
                }
              }
            }
          }
        },
        S43: {
          type: "list",
          member: {
            type: "structure",
            members: {
              path: {},
              behavior: {}
            }
          }
        },
        S47: {
          type: "structure",
          members: {
            name: {},
            arn: {},
            supportCode: {},
            createdAt: {
              type: "timestamp"
            },
            location: {
              shape: "S9"
            },
            resourceType: {},
            alternativeDomainNames: {
              shape: "Su"
            },
            status: {},
            isEnabled: {
              type: "boolean"
            },
            domainName: {},
            bundleId: {},
            certificateName: {},
            origin: {
              type: "structure",
              members: {
                name: {},
                resourceType: {},
                regionName: {},
                protocolPolicy: {}
              }
            },
            originPublicDNS: {},
            defaultCacheBehavior: {
              shape: "S3t"
            },
            cacheBehaviorSettings: {
              shape: "S3v"
            },
            cacheBehaviors: {
              shape: "S43"
            },
            ableToUpdateBundle: {
              type: "boolean"
            },
            ipAddressType: {},
            tags: {
              shape: "S10"
            }
          }
        },
        S4c: {
          type: "structure",
          members: {
            id: {},
            name: {},
            target: {},
            isAlias: {
              type: "boolean"
            },
            type: {},
            options: {
              deprecated: true,
              type: "map",
              key: {},
              value: {}
            }
          }
        },
        S4y: {
          type: "structure",
          members: {
            name: {},
            arn: {},
            supportCode: {},
            createdAt: {
              type: "timestamp"
            },
            location: {
              shape: "S9"
            },
            resourceType: {},
            tags: {
              shape: "S10"
            },
            fingerprint: {}
          }
        },
        S51: {
          type: "list",
          member: {}
        },
        S56: {
          type: "string",
          sensitive: true
        },
        S7f: {
          type: "list",
          member: {}
        },
        S7g: {
          type: "list",
          member: {}
        },
        S85: {
          type: "list",
          member: {}
        },
        S87: {
          type: "list",
          member: {
            type: "structure",
            members: {
              average: {
                type: "double"
              },
              maximum: {
                type: "double"
              },
              minimum: {
                type: "double"
              },
              sampleCount: {
                type: "double"
              },
              sum: {
                type: "double"
              },
              timestamp: {
                type: "timestamp"
              },
              unit: {}
            }
          }
        },
        S8z: {
          type: "structure",
          members: {
            id: {},
            service: {}
          }
        },
        S9c: {
          type: "structure",
          members: {
            image: {},
            digest: {},
            createdAt: {
              type: "timestamp"
            }
          }
        },
        Sa7: {
          type: "structure",
          members: {
            name: {},
            arn: {},
            supportCode: {},
            createdAt: {
              type: "timestamp"
            },
            location: {
              shape: "S9"
            },
            resourceType: {},
            tags: {
              shape: "S10"
            },
            addOns: {
              shape: "Sa8"
            },
            sizeInGb: {
              type: "integer"
            },
            isSystemDisk: {
              type: "boolean"
            },
            iops: {
              type: "integer"
            },
            path: {},
            state: {},
            attachedTo: {},
            isAttached: {
              type: "boolean"
            },
            attachmentState: {
              deprecated: true
            },
            gbInUse: {
              deprecated: true,
              type: "integer"
            },
            autoMountStatus: {}
          }
        },
        Sa8: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              status: {},
              snapshotTimeOfDay: {},
              nextSnapshotTimeOfDay: {},
              threshold: {},
              duration: {}
            }
          }
        },
        Sae: {
          type: "structure",
          members: {
            name: {},
            arn: {},
            supportCode: {},
            createdAt: {
              type: "timestamp"
            },
            location: {
              shape: "S9"
            },
            resourceType: {},
            tags: {
              shape: "S10"
            },
            sizeInGb: {
              type: "integer"
            },
            state: {},
            progress: {},
            fromDiskName: {},
            fromDiskArn: {},
            fromInstanceName: {},
            fromInstanceArn: {},
            isFromAutoSnapshot: {
              type: "boolean"
            }
          }
        },
        Sal: {
          type: "list",
          member: {
            shape: "Sa7"
          }
        },
        Sb0: {
          type: "structure",
          members: {
            name: {},
            arn: {},
            supportCode: {},
            createdAt: {
              type: "timestamp"
            },
            location: {
              shape: "S9"
            },
            resourceType: {},
            tags: {
              shape: "S10"
            },
            domainEntries: {
              type: "list",
              member: {
                shape: "S4c"
              }
            },
            registeredDomainDelegationInfo: {
              type: "structure",
              members: {
                nameServersUpdateState: {
                  type: "structure",
                  members: {
                    code: {},
                    message: {}
                  }
                },
                r53HostedZoneDeletionState: {
                  type: "structure",
                  members: {
                    code: {},
                    message: {}
                  }
                }
              }
            }
          }
        },
        Sbm: {
          type: "structure",
          members: {
            name: {},
            arn: {},
            supportCode: {},
            createdAt: {
              type: "timestamp"
            },
            location: {
              shape: "S9"
            },
            resourceType: {},
            tags: {
              shape: "S10"
            },
            blueprintId: {},
            blueprintName: {},
            bundleId: {},
            addOns: {
              shape: "Sa8"
            },
            isStaticIp: {
              type: "boolean"
            },
            privateIpAddress: {},
            publicIpAddress: {},
            ipv6Addresses: {
              type: "list",
              member: {}
            },
            ipAddressType: {},
            hardware: {
              type: "structure",
              members: {
                cpuCount: {
                  type: "integer"
                },
                disks: {
                  shape: "Sal"
                },
                ramSizeInGb: {
                  type: "float"
                }
              }
            },
            networking: {
              type: "structure",
              members: {
                monthlyTransfer: {
                  type: "structure",
                  members: {
                    gbPerMonthAllocated: {
                      type: "integer"
                    }
                  }
                },
                ports: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      fromPort: {
                        type: "integer"
                      },
                      toPort: {
                        type: "integer"
                      },
                      protocol: {},
                      accessFrom: {},
                      accessType: {},
                      commonName: {},
                      accessDirection: {},
                      cidrs: {
                        shape: "Su"
                      },
                      ipv6Cidrs: {
                        shape: "Su"
                      },
                      cidrListAliases: {
                        shape: "Su"
                      }
                    }
                  }
                }
              }
            },
            state: {
              shape: "Sbx"
            },
            username: {},
            sshKeyName: {},
            metadataOptions: {
              type: "structure",
              members: {
                state: {},
                httpTokens: {},
                httpEndpoint: {},
                httpPutResponseHopLimit: {
                  type: "integer"
                },
                httpProtocolIpv6: {}
              }
            }
          }
        },
        Sbx: {
          type: "structure",
          members: {
            code: {
              type: "integer"
            },
            name: {}
          }
        },
        Sck: {
          type: "structure",
          members: {
            name: {},
            arn: {},
            supportCode: {},
            createdAt: {
              type: "timestamp"
            },
            location: {
              shape: "S9"
            },
            resourceType: {},
            tags: {
              shape: "S10"
            },
            state: {},
            progress: {},
            fromAttachedDisks: {
              shape: "Sal"
            },
            fromInstanceName: {},
            fromInstanceArn: {},
            fromBlueprintId: {},
            fromBundleId: {},
            isFromAutoSnapshot: {
              type: "boolean"
            },
            sizeInGb: {
              type: "integer"
            }
          }
        },
        Sd1: {
          type: "structure",
          members: {
            name: {},
            arn: {},
            supportCode: {},
            createdAt: {
              type: "timestamp"
            },
            location: {
              shape: "S9"
            },
            resourceType: {},
            tags: {
              shape: "S10"
            },
            dnsName: {},
            state: {},
            protocol: {},
            publicPorts: {
              type: "list",
              member: {
                type: "integer"
              }
            },
            healthCheckPath: {},
            instancePort: {
              type: "integer"
            },
            instanceHealthSummary: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  instanceName: {},
                  instanceHealth: {},
                  instanceHealthReason: {}
                }
              }
            },
            tlsCertificateSummaries: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  name: {},
                  isAttached: {
                    type: "boolean"
                  }
                }
              }
            },
            configurationOptions: {
              type: "map",
              key: {},
              value: {}
            },
            ipAddressType: {},
            httpsRedirectionEnabled: {
              type: "boolean"
            },
            tlsPolicyName: {}
          }
        },
        Sed: {
          type: "list",
          member: {
            type: "structure",
            members: {
              zoneName: {},
              state: {}
            }
          }
        },
        Seh: {
          type: "structure",
          members: {
            name: {},
            arn: {},
            supportCode: {},
            createdAt: {
              type: "timestamp"
            },
            location: {
              shape: "S9"
            },
            resourceType: {},
            tags: {
              shape: "S10"
            },
            relationalDatabaseBlueprintId: {},
            relationalDatabaseBundleId: {},
            masterDatabaseName: {},
            hardware: {
              type: "structure",
              members: {
                cpuCount: {
                  type: "integer"
                },
                diskSizeInGb: {
                  type: "integer"
                },
                ramSizeInGb: {
                  type: "float"
                }
              }
            },
            state: {},
            secondaryAvailabilityZone: {},
            backupRetentionEnabled: {
              type: "boolean"
            },
            pendingModifiedValues: {
              type: "structure",
              members: {
                masterUserPassword: {},
                engineVersion: {},
                backupRetentionEnabled: {
                  type: "boolean"
                }
              }
            },
            engine: {},
            engineVersion: {},
            latestRestorableTime: {
              type: "timestamp"
            },
            masterUsername: {},
            parameterApplyStatus: {},
            preferredBackupWindow: {},
            preferredMaintenanceWindow: {},
            publiclyAccessible: {
              type: "boolean"
            },
            masterEndpoint: {
              type: "structure",
              members: {
                port: {
                  type: "integer"
                },
                address: {}
              }
            },
            pendingMaintenanceActions: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  action: {},
                  description: {},
                  currentApplyDate: {
                    type: "timestamp"
                  }
                }
              }
            },
            caCertificateIdentifier: {}
          }
        },
        Sfe: {
          type: "list",
          member: {
            type: "structure",
            members: {
              allowedValues: {},
              applyMethod: {},
              applyType: {},
              dataType: {},
              description: {},
              isModifiable: {
                type: "boolean"
              },
              parameterName: {},
              parameterValue: {}
            }
          }
        },
        Sfi: {
          type: "structure",
          members: {
            name: {},
            arn: {},
            supportCode: {},
            createdAt: {
              type: "timestamp"
            },
            location: {
              shape: "S9"
            },
            resourceType: {},
            tags: {
              shape: "S10"
            },
            engine: {},
            engineVersion: {},
            sizeInGb: {
              type: "integer"
            },
            state: {},
            fromRelationalDatabaseName: {},
            fromRelationalDatabaseArn: {},
            fromRelationalDatabaseBundleId: {},
            fromRelationalDatabaseBlueprintId: {}
          }
        },
        Sfv: {
          type: "list",
          member: {}
        },
        Sg4: {
          type: "structure",
          members: {
            name: {},
            arn: {},
            supportCode: {},
            createdAt: {
              type: "timestamp"
            },
            location: {
              shape: "S9"
            },
            resourceType: {},
            ipAddress: {},
            attachedTo: {},
            isAttached: {
              type: "boolean"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/lightsail-2016-11-28.paginators.json
var require_lightsail_2016_11_28_paginators = __commonJS({
  "node_modules/aws-sdk/apis/lightsail-2016-11-28.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/lightsail.js
var require_lightsail = __commonJS({
  "node_modules/aws-sdk/clients/lightsail.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["lightsail"] = {};
    AWS2.Lightsail = Service.defineService("lightsail", ["2016-11-28"]);
    Object.defineProperty(apiLoader.services["lightsail"], "2016-11-28", {
      get: function get() {
        var model = require_lightsail_2016_11_28_min();
        model.paginators = require_lightsail_2016_11_28_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Lightsail;
  }
});

// node_modules/aws-sdk/lib/services/machinelearning.js
var require_machinelearning = __commonJS({
  "node_modules/aws-sdk/lib/services/machinelearning.js"() {
    "use strict";
    var AWS2 = require_core();
    AWS2.util.update(AWS2.MachineLearning.prototype, {
      /**
       * @api private
       */
      setupRequestListeners: function setupRequestListeners(request) {
        if (request.operation === "predict") {
          request.addListener("build", this.buildEndpoint);
        }
      },
      /**
       * Updates request endpoint from PredictEndpoint
       * @api private
       */
      buildEndpoint: function buildEndpoint(request) {
        var url = request.params.PredictEndpoint;
        if (url) {
          request.httpRequest.endpoint = new AWS2.Endpoint(url);
        }
      }
    });
  }
});

// node_modules/aws-sdk/apis/machinelearning-2014-12-12.min.json
var require_machinelearning_2014_12_12_min = __commonJS({
  "node_modules/aws-sdk/apis/machinelearning-2014-12-12.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-12-12",
        endpointPrefix: "machinelearning",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Machine Learning",
        serviceId: "Machine Learning",
        signatureVersion: "v4",
        targetPrefix: "AmazonML_20141212",
        uid: "machinelearning-2014-12-12"
      },
      operations: {
        AddTags: {
          input: {
            type: "structure",
            required: [
              "Tags",
              "ResourceId",
              "ResourceType"
            ],
            members: {
              Tags: {
                shape: "S2"
              },
              ResourceId: {},
              ResourceType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceId: {},
              ResourceType: {}
            }
          }
        },
        CreateBatchPrediction: {
          input: {
            type: "structure",
            required: [
              "BatchPredictionId",
              "MLModelId",
              "BatchPredictionDataSourceId",
              "OutputUri"
            ],
            members: {
              BatchPredictionId: {},
              BatchPredictionName: {},
              MLModelId: {},
              BatchPredictionDataSourceId: {},
              OutputUri: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BatchPredictionId: {}
            }
          }
        },
        CreateDataSourceFromRDS: {
          input: {
            type: "structure",
            required: [
              "DataSourceId",
              "RDSData",
              "RoleARN"
            ],
            members: {
              DataSourceId: {},
              DataSourceName: {},
              RDSData: {
                type: "structure",
                required: [
                  "DatabaseInformation",
                  "SelectSqlQuery",
                  "DatabaseCredentials",
                  "S3StagingLocation",
                  "ResourceRole",
                  "ServiceRole",
                  "SubnetId",
                  "SecurityGroupIds"
                ],
                members: {
                  DatabaseInformation: {
                    shape: "Sf"
                  },
                  SelectSqlQuery: {},
                  DatabaseCredentials: {
                    type: "structure",
                    required: [
                      "Username",
                      "Password"
                    ],
                    members: {
                      Username: {},
                      Password: {
                        type: "string",
                        sensitive: true
                      }
                    }
                  },
                  S3StagingLocation: {},
                  DataRearrangement: {},
                  DataSchema: {},
                  DataSchemaUri: {},
                  ResourceRole: {},
                  ServiceRole: {},
                  SubnetId: {},
                  SecurityGroupIds: {
                    type: "list",
                    member: {}
                  }
                }
              },
              RoleARN: {},
              ComputeStatistics: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataSourceId: {}
            }
          }
        },
        CreateDataSourceFromRedshift: {
          input: {
            type: "structure",
            required: [
              "DataSourceId",
              "DataSpec",
              "RoleARN"
            ],
            members: {
              DataSourceId: {},
              DataSourceName: {},
              DataSpec: {
                type: "structure",
                required: [
                  "DatabaseInformation",
                  "SelectSqlQuery",
                  "DatabaseCredentials",
                  "S3StagingLocation"
                ],
                members: {
                  DatabaseInformation: {
                    shape: "Sy"
                  },
                  SelectSqlQuery: {},
                  DatabaseCredentials: {
                    type: "structure",
                    required: [
                      "Username",
                      "Password"
                    ],
                    members: {
                      Username: {},
                      Password: {
                        type: "string",
                        sensitive: true
                      }
                    }
                  },
                  S3StagingLocation: {},
                  DataRearrangement: {},
                  DataSchema: {},
                  DataSchemaUri: {}
                }
              },
              RoleARN: {},
              ComputeStatistics: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataSourceId: {}
            }
          }
        },
        CreateDataSourceFromS3: {
          input: {
            type: "structure",
            required: [
              "DataSourceId",
              "DataSpec"
            ],
            members: {
              DataSourceId: {},
              DataSourceName: {},
              DataSpec: {
                type: "structure",
                required: [
                  "DataLocationS3"
                ],
                members: {
                  DataLocationS3: {},
                  DataRearrangement: {},
                  DataSchema: {},
                  DataSchemaLocationS3: {}
                }
              },
              ComputeStatistics: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataSourceId: {}
            }
          }
        },
        CreateEvaluation: {
          input: {
            type: "structure",
            required: [
              "EvaluationId",
              "MLModelId",
              "EvaluationDataSourceId"
            ],
            members: {
              EvaluationId: {},
              EvaluationName: {},
              MLModelId: {},
              EvaluationDataSourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EvaluationId: {}
            }
          }
        },
        CreateMLModel: {
          input: {
            type: "structure",
            required: [
              "MLModelId",
              "MLModelType",
              "TrainingDataSourceId"
            ],
            members: {
              MLModelId: {},
              MLModelName: {},
              MLModelType: {},
              Parameters: {
                shape: "S1d"
              },
              TrainingDataSourceId: {},
              Recipe: {},
              RecipeUri: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MLModelId: {}
            }
          }
        },
        CreateRealtimeEndpoint: {
          input: {
            type: "structure",
            required: [
              "MLModelId"
            ],
            members: {
              MLModelId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MLModelId: {},
              RealtimeEndpointInfo: {
                shape: "S1j"
              }
            }
          }
        },
        DeleteBatchPrediction: {
          input: {
            type: "structure",
            required: [
              "BatchPredictionId"
            ],
            members: {
              BatchPredictionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BatchPredictionId: {}
            }
          }
        },
        DeleteDataSource: {
          input: {
            type: "structure",
            required: [
              "DataSourceId"
            ],
            members: {
              DataSourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DataSourceId: {}
            }
          }
        },
        DeleteEvaluation: {
          input: {
            type: "structure",
            required: [
              "EvaluationId"
            ],
            members: {
              EvaluationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EvaluationId: {}
            }
          }
        },
        DeleteMLModel: {
          input: {
            type: "structure",
            required: [
              "MLModelId"
            ],
            members: {
              MLModelId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MLModelId: {}
            }
          }
        },
        DeleteRealtimeEndpoint: {
          input: {
            type: "structure",
            required: [
              "MLModelId"
            ],
            members: {
              MLModelId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MLModelId: {},
              RealtimeEndpointInfo: {
                shape: "S1j"
              }
            }
          }
        },
        DeleteTags: {
          input: {
            type: "structure",
            required: [
              "TagKeys",
              "ResourceId",
              "ResourceType"
            ],
            members: {
              TagKeys: {
                type: "list",
                member: {}
              },
              ResourceId: {},
              ResourceType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceId: {},
              ResourceType: {}
            }
          }
        },
        DescribeBatchPredictions: {
          input: {
            type: "structure",
            members: {
              FilterVariable: {},
              EQ: {},
              GT: {},
              LT: {},
              GE: {},
              LE: {},
              NE: {},
              Prefix: {},
              SortOrder: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Results: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    BatchPredictionId: {},
                    MLModelId: {},
                    BatchPredictionDataSourceId: {},
                    InputDataLocationS3: {},
                    CreatedByIamUser: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    LastUpdatedAt: {
                      type: "timestamp"
                    },
                    Name: {},
                    Status: {},
                    OutputUri: {},
                    Message: {},
                    ComputeTime: {
                      type: "long"
                    },
                    FinishedAt: {
                      type: "timestamp"
                    },
                    StartedAt: {
                      type: "timestamp"
                    },
                    TotalRecordCount: {
                      type: "long"
                    },
                    InvalidRecordCount: {
                      type: "long"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeDataSources: {
          input: {
            type: "structure",
            members: {
              FilterVariable: {},
              EQ: {},
              GT: {},
              LT: {},
              GE: {},
              LE: {},
              NE: {},
              Prefix: {},
              SortOrder: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Results: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DataSourceId: {},
                    DataLocationS3: {},
                    DataRearrangement: {},
                    CreatedByIamUser: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    LastUpdatedAt: {
                      type: "timestamp"
                    },
                    DataSizeInBytes: {
                      type: "long"
                    },
                    NumberOfFiles: {
                      type: "long"
                    },
                    Name: {},
                    Status: {},
                    Message: {},
                    RedshiftMetadata: {
                      shape: "S2i"
                    },
                    RDSMetadata: {
                      shape: "S2j"
                    },
                    RoleARN: {},
                    ComputeStatistics: {
                      type: "boolean"
                    },
                    ComputeTime: {
                      type: "long"
                    },
                    FinishedAt: {
                      type: "timestamp"
                    },
                    StartedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeEvaluations: {
          input: {
            type: "structure",
            members: {
              FilterVariable: {},
              EQ: {},
              GT: {},
              LT: {},
              GE: {},
              LE: {},
              NE: {},
              Prefix: {},
              SortOrder: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Results: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EvaluationId: {},
                    MLModelId: {},
                    EvaluationDataSourceId: {},
                    InputDataLocationS3: {},
                    CreatedByIamUser: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    LastUpdatedAt: {
                      type: "timestamp"
                    },
                    Name: {},
                    Status: {},
                    PerformanceMetrics: {
                      shape: "S2q"
                    },
                    Message: {},
                    ComputeTime: {
                      type: "long"
                    },
                    FinishedAt: {
                      type: "timestamp"
                    },
                    StartedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeMLModels: {
          input: {
            type: "structure",
            members: {
              FilterVariable: {},
              EQ: {},
              GT: {},
              LT: {},
              GE: {},
              LE: {},
              NE: {},
              Prefix: {},
              SortOrder: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Results: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MLModelId: {},
                    TrainingDataSourceId: {},
                    CreatedByIamUser: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    LastUpdatedAt: {
                      type: "timestamp"
                    },
                    Name: {},
                    Status: {},
                    SizeInBytes: {
                      type: "long"
                    },
                    EndpointInfo: {
                      shape: "S1j"
                    },
                    TrainingParameters: {
                      shape: "S1d"
                    },
                    InputDataLocationS3: {},
                    Algorithm: {},
                    MLModelType: {},
                    ScoreThreshold: {
                      type: "float"
                    },
                    ScoreThresholdLastUpdatedAt: {
                      type: "timestamp"
                    },
                    Message: {},
                    ComputeTime: {
                      type: "long"
                    },
                    FinishedAt: {
                      type: "timestamp"
                    },
                    StartedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeTags: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "ResourceType"
            ],
            members: {
              ResourceId: {},
              ResourceType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceId: {},
              ResourceType: {},
              Tags: {
                shape: "S2"
              }
            }
          }
        },
        GetBatchPrediction: {
          input: {
            type: "structure",
            required: [
              "BatchPredictionId"
            ],
            members: {
              BatchPredictionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BatchPredictionId: {},
              MLModelId: {},
              BatchPredictionDataSourceId: {},
              InputDataLocationS3: {},
              CreatedByIamUser: {},
              CreatedAt: {
                type: "timestamp"
              },
              LastUpdatedAt: {
                type: "timestamp"
              },
              Name: {},
              Status: {},
              OutputUri: {},
              LogUri: {},
              Message: {},
              ComputeTime: {
                type: "long"
              },
              FinishedAt: {
                type: "timestamp"
              },
              StartedAt: {
                type: "timestamp"
              },
              TotalRecordCount: {
                type: "long"
              },
              InvalidRecordCount: {
                type: "long"
              }
            }
          }
        },
        GetDataSource: {
          input: {
            type: "structure",
            required: [
              "DataSourceId"
            ],
            members: {
              DataSourceId: {},
              Verbose: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataSourceId: {},
              DataLocationS3: {},
              DataRearrangement: {},
              CreatedByIamUser: {},
              CreatedAt: {
                type: "timestamp"
              },
              LastUpdatedAt: {
                type: "timestamp"
              },
              DataSizeInBytes: {
                type: "long"
              },
              NumberOfFiles: {
                type: "long"
              },
              Name: {},
              Status: {},
              LogUri: {},
              Message: {},
              RedshiftMetadata: {
                shape: "S2i"
              },
              RDSMetadata: {
                shape: "S2j"
              },
              RoleARN: {},
              ComputeStatistics: {
                type: "boolean"
              },
              ComputeTime: {
                type: "long"
              },
              FinishedAt: {
                type: "timestamp"
              },
              StartedAt: {
                type: "timestamp"
              },
              DataSourceSchema: {}
            }
          }
        },
        GetEvaluation: {
          input: {
            type: "structure",
            required: [
              "EvaluationId"
            ],
            members: {
              EvaluationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EvaluationId: {},
              MLModelId: {},
              EvaluationDataSourceId: {},
              InputDataLocationS3: {},
              CreatedByIamUser: {},
              CreatedAt: {
                type: "timestamp"
              },
              LastUpdatedAt: {
                type: "timestamp"
              },
              Name: {},
              Status: {},
              PerformanceMetrics: {
                shape: "S2q"
              },
              LogUri: {},
              Message: {},
              ComputeTime: {
                type: "long"
              },
              FinishedAt: {
                type: "timestamp"
              },
              StartedAt: {
                type: "timestamp"
              }
            }
          }
        },
        GetMLModel: {
          input: {
            type: "structure",
            required: [
              "MLModelId"
            ],
            members: {
              MLModelId: {},
              Verbose: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MLModelId: {},
              TrainingDataSourceId: {},
              CreatedByIamUser: {},
              CreatedAt: {
                type: "timestamp"
              },
              LastUpdatedAt: {
                type: "timestamp"
              },
              Name: {},
              Status: {},
              SizeInBytes: {
                type: "long"
              },
              EndpointInfo: {
                shape: "S1j"
              },
              TrainingParameters: {
                shape: "S1d"
              },
              InputDataLocationS3: {},
              MLModelType: {},
              ScoreThreshold: {
                type: "float"
              },
              ScoreThresholdLastUpdatedAt: {
                type: "timestamp"
              },
              LogUri: {},
              Message: {},
              ComputeTime: {
                type: "long"
              },
              FinishedAt: {
                type: "timestamp"
              },
              StartedAt: {
                type: "timestamp"
              },
              Recipe: {},
              Schema: {}
            }
          }
        },
        Predict: {
          input: {
            type: "structure",
            required: [
              "MLModelId",
              "Record",
              "PredictEndpoint"
            ],
            members: {
              MLModelId: {},
              Record: {
                type: "map",
                key: {},
                value: {}
              },
              PredictEndpoint: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Prediction: {
                type: "structure",
                members: {
                  predictedLabel: {},
                  predictedValue: {
                    type: "float"
                  },
                  predictedScores: {
                    type: "map",
                    key: {},
                    value: {
                      type: "float"
                    }
                  },
                  details: {
                    type: "map",
                    key: {},
                    value: {}
                  }
                }
              }
            }
          }
        },
        UpdateBatchPrediction: {
          input: {
            type: "structure",
            required: [
              "BatchPredictionId",
              "BatchPredictionName"
            ],
            members: {
              BatchPredictionId: {},
              BatchPredictionName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BatchPredictionId: {}
            }
          }
        },
        UpdateDataSource: {
          input: {
            type: "structure",
            required: [
              "DataSourceId",
              "DataSourceName"
            ],
            members: {
              DataSourceId: {},
              DataSourceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DataSourceId: {}
            }
          }
        },
        UpdateEvaluation: {
          input: {
            type: "structure",
            required: [
              "EvaluationId",
              "EvaluationName"
            ],
            members: {
              EvaluationId: {},
              EvaluationName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EvaluationId: {}
            }
          }
        },
        UpdateMLModel: {
          input: {
            type: "structure",
            required: [
              "MLModelId"
            ],
            members: {
              MLModelId: {},
              MLModelName: {},
              ScoreThreshold: {
                type: "float"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MLModelId: {}
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sf: {
          type: "structure",
          required: [
            "InstanceIdentifier",
            "DatabaseName"
          ],
          members: {
            InstanceIdentifier: {},
            DatabaseName: {}
          }
        },
        Sy: {
          type: "structure",
          required: [
            "DatabaseName",
            "ClusterIdentifier"
          ],
          members: {
            DatabaseName: {},
            ClusterIdentifier: {}
          }
        },
        S1d: {
          type: "map",
          key: {},
          value: {}
        },
        S1j: {
          type: "structure",
          members: {
            PeakRequestsPerSecond: {
              type: "integer"
            },
            CreatedAt: {
              type: "timestamp"
            },
            EndpointUrl: {},
            EndpointStatus: {}
          }
        },
        S2i: {
          type: "structure",
          members: {
            RedshiftDatabase: {
              shape: "Sy"
            },
            DatabaseUserName: {},
            SelectSqlQuery: {}
          }
        },
        S2j: {
          type: "structure",
          members: {
            Database: {
              shape: "Sf"
            },
            DatabaseUserName: {},
            SelectSqlQuery: {},
            ResourceRole: {},
            ServiceRole: {},
            DataPipelineId: {}
          }
        },
        S2q: {
          type: "structure",
          members: {
            Properties: {
              type: "map",
              key: {},
              value: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/machinelearning-2014-12-12.paginators.json
var require_machinelearning_2014_12_12_paginators = __commonJS({
  "node_modules/aws-sdk/apis/machinelearning-2014-12-12.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeBatchPredictions: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "Results"
        },
        DescribeDataSources: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "Results"
        },
        DescribeEvaluations: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "Results"
        },
        DescribeMLModels: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "Results"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/machinelearning-2014-12-12.waiters2.json
var require_machinelearning_2014_12_12_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/machinelearning-2014-12-12.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        DataSourceAvailable: {
          delay: 30,
          operation: "DescribeDataSources",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "COMPLETED",
              matcher: "pathAll",
              state: "success",
              argument: "Results[].Status"
            },
            {
              expected: "FAILED",
              matcher: "pathAny",
              state: "failure",
              argument: "Results[].Status"
            }
          ]
        },
        MLModelAvailable: {
          delay: 30,
          operation: "DescribeMLModels",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "COMPLETED",
              matcher: "pathAll",
              state: "success",
              argument: "Results[].Status"
            },
            {
              expected: "FAILED",
              matcher: "pathAny",
              state: "failure",
              argument: "Results[].Status"
            }
          ]
        },
        EvaluationAvailable: {
          delay: 30,
          operation: "DescribeEvaluations",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "COMPLETED",
              matcher: "pathAll",
              state: "success",
              argument: "Results[].Status"
            },
            {
              expected: "FAILED",
              matcher: "pathAny",
              state: "failure",
              argument: "Results[].Status"
            }
          ]
        },
        BatchPredictionAvailable: {
          delay: 30,
          operation: "DescribeBatchPredictions",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "COMPLETED",
              matcher: "pathAll",
              state: "success",
              argument: "Results[].Status"
            },
            {
              expected: "FAILED",
              matcher: "pathAny",
              state: "failure",
              argument: "Results[].Status"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/machinelearning.js
var require_machinelearning2 = __commonJS({
  "node_modules/aws-sdk/clients/machinelearning.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["machinelearning"] = {};
    AWS2.MachineLearning = Service.defineService("machinelearning", ["2014-12-12"]);
    require_machinelearning();
    Object.defineProperty(apiLoader.services["machinelearning"], "2014-12-12", {
      get: function get() {
        var model = require_machinelearning_2014_12_12_min();
        model.paginators = require_machinelearning_2014_12_12_paginators().pagination;
        model.waiters = require_machinelearning_2014_12_12_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.MachineLearning;
  }
});

// node_modules/aws-sdk/apis/marketplacecommerceanalytics-2015-07-01.min.json
var require_marketplacecommerceanalytics_2015_07_01_min = __commonJS({
  "node_modules/aws-sdk/apis/marketplacecommerceanalytics-2015-07-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-07-01",
        endpointPrefix: "marketplacecommerceanalytics",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Marketplace Commerce Analytics",
        serviceId: "Marketplace Commerce Analytics",
        signatureVersion: "v4",
        signingName: "marketplacecommerceanalytics",
        targetPrefix: "MarketplaceCommerceAnalytics20150701",
        uid: "marketplacecommerceanalytics-2015-07-01"
      },
      operations: {
        GenerateDataSet: {
          input: {
            type: "structure",
            required: [
              "dataSetType",
              "dataSetPublicationDate",
              "roleNameArn",
              "destinationS3BucketName",
              "snsTopicArn"
            ],
            members: {
              dataSetType: {},
              dataSetPublicationDate: {
                type: "timestamp"
              },
              roleNameArn: {},
              destinationS3BucketName: {},
              destinationS3Prefix: {},
              snsTopicArn: {},
              customerDefinedValues: {
                shape: "S8"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              dataSetRequestId: {}
            }
          }
        },
        StartSupportDataExport: {
          input: {
            type: "structure",
            required: [
              "dataSetType",
              "fromDate",
              "roleNameArn",
              "destinationS3BucketName",
              "snsTopicArn"
            ],
            members: {
              dataSetType: {},
              fromDate: {
                type: "timestamp"
              },
              roleNameArn: {},
              destinationS3BucketName: {},
              destinationS3Prefix: {},
              snsTopicArn: {},
              customerDefinedValues: {
                shape: "S8"
              }
            },
            deprecated: true,
            deprecatedMessage: "This target has been deprecated. As of December 2022 Product Support Connection is no longer supported."
          },
          output: {
            type: "structure",
            members: {
              dataSetRequestId: {}
            },
            deprecated: true,
            deprecatedMessage: "This target has been deprecated. As of December 2022 Product Support Connection is no longer supported."
          },
          deprecated: true,
          deprecatedMessage: "This target has been deprecated. As of December 2022 Product Support Connection is no longer supported."
        }
      },
      shapes: {
        S8: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/marketplacecommerceanalytics-2015-07-01.paginators.json
var require_marketplacecommerceanalytics_2015_07_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/marketplacecommerceanalytics-2015-07-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/marketplacecommerceanalytics.js
var require_marketplacecommerceanalytics = __commonJS({
  "node_modules/aws-sdk/clients/marketplacecommerceanalytics.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["marketplacecommerceanalytics"] = {};
    AWS2.MarketplaceCommerceAnalytics = Service.defineService("marketplacecommerceanalytics", ["2015-07-01"]);
    Object.defineProperty(apiLoader.services["marketplacecommerceanalytics"], "2015-07-01", {
      get: function get() {
        var model = require_marketplacecommerceanalytics_2015_07_01_min();
        model.paginators = require_marketplacecommerceanalytics_2015_07_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.MarketplaceCommerceAnalytics;
  }
});

// node_modules/aws-sdk/apis/meteringmarketplace-2016-01-14.min.json
var require_meteringmarketplace_2016_01_14_min = __commonJS({
  "node_modules/aws-sdk/apis/meteringmarketplace-2016-01-14.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-01-14",
        endpointPrefix: "metering.marketplace",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWSMarketplace Metering",
        serviceId: "Marketplace Metering",
        signatureVersion: "v4",
        signingName: "aws-marketplace",
        targetPrefix: "AWSMPMeteringService",
        uid: "meteringmarketplace-2016-01-14"
      },
      operations: {
        BatchMeterUsage: {
          input: {
            type: "structure",
            required: [
              "UsageRecords",
              "ProductCode"
            ],
            members: {
              UsageRecords: {
                shape: "S2"
              },
              ProductCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Results: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    UsageRecord: {
                      shape: "S3"
                    },
                    MeteringRecordId: {},
                    Status: {}
                  }
                }
              },
              UnprocessedRecords: {
                shape: "S2"
              }
            }
          }
        },
        MeterUsage: {
          input: {
            type: "structure",
            required: [
              "ProductCode",
              "Timestamp",
              "UsageDimension"
            ],
            members: {
              ProductCode: {},
              Timestamp: {
                type: "timestamp"
              },
              UsageDimension: {},
              UsageQuantity: {
                type: "integer"
              },
              DryRun: {
                type: "boolean"
              },
              UsageAllocations: {
                shape: "S8"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MeteringRecordId: {}
            }
          }
        },
        RegisterUsage: {
          input: {
            type: "structure",
            required: [
              "ProductCode",
              "PublicKeyVersion"
            ],
            members: {
              ProductCode: {},
              PublicKeyVersion: {
                type: "integer"
              },
              Nonce: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKeyRotationTimestamp: {
                type: "timestamp"
              },
              Signature: {}
            }
          }
        },
        ResolveCustomer: {
          input: {
            type: "structure",
            required: [
              "RegistrationToken"
            ],
            members: {
              RegistrationToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CustomerIdentifier: {},
              ProductCode: {},
              CustomerAWSAccountId: {}
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "list",
          member: {
            shape: "S3"
          }
        },
        S3: {
          type: "structure",
          required: [
            "Timestamp",
            "CustomerIdentifier",
            "Dimension"
          ],
          members: {
            Timestamp: {
              type: "timestamp"
            },
            CustomerIdentifier: {},
            Dimension: {},
            Quantity: {
              type: "integer"
            },
            UsageAllocations: {
              shape: "S8"
            }
          }
        },
        S8: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AllocatedUsageQuantity"
            ],
            members: {
              AllocatedUsageQuantity: {
                type: "integer"
              },
              Tags: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key",
                    "Value"
                  ],
                  members: {
                    Key: {},
                    Value: {}
                  }
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/meteringmarketplace-2016-01-14.paginators.json
var require_meteringmarketplace_2016_01_14_paginators = __commonJS({
  "node_modules/aws-sdk/apis/meteringmarketplace-2016-01-14.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/marketplacemetering.js
var require_marketplacemetering = __commonJS({
  "node_modules/aws-sdk/clients/marketplacemetering.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["marketplacemetering"] = {};
    AWS2.MarketplaceMetering = Service.defineService("marketplacemetering", ["2016-01-14"]);
    Object.defineProperty(apiLoader.services["marketplacemetering"], "2016-01-14", {
      get: function get() {
        var model = require_meteringmarketplace_2016_01_14_min();
        model.paginators = require_meteringmarketplace_2016_01_14_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.MarketplaceMetering;
  }
});

// node_modules/aws-sdk/apis/mturk-requester-2017-01-17.min.json
var require_mturk_requester_2017_01_17_min = __commonJS({
  "node_modules/aws-sdk/apis/mturk-requester-2017-01-17.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-01-17",
        endpointPrefix: "mturk-requester",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Amazon MTurk",
        serviceFullName: "Amazon Mechanical Turk",
        serviceId: "MTurk",
        signatureVersion: "v4",
        targetPrefix: "MTurkRequesterServiceV20170117",
        uid: "mturk-requester-2017-01-17"
      },
      operations: {
        AcceptQualificationRequest: {
          input: {
            type: "structure",
            required: [
              "QualificationRequestId"
            ],
            members: {
              QualificationRequestId: {},
              IntegerValue: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ApproveAssignment: {
          input: {
            type: "structure",
            required: [
              "AssignmentId"
            ],
            members: {
              AssignmentId: {},
              RequesterFeedback: {},
              OverrideRejection: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        AssociateQualificationWithWorker: {
          input: {
            type: "structure",
            required: [
              "QualificationTypeId",
              "WorkerId"
            ],
            members: {
              QualificationTypeId: {},
              WorkerId: {},
              IntegerValue: {
                type: "integer"
              },
              SendNotification: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateAdditionalAssignmentsForHIT: {
          input: {
            type: "structure",
            required: [
              "HITId",
              "NumberOfAdditionalAssignments"
            ],
            members: {
              HITId: {},
              NumberOfAdditionalAssignments: {
                type: "integer"
              },
              UniqueRequestToken: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateHIT: {
          input: {
            type: "structure",
            required: [
              "LifetimeInSeconds",
              "AssignmentDurationInSeconds",
              "Reward",
              "Title",
              "Description"
            ],
            members: {
              MaxAssignments: {
                type: "integer"
              },
              AutoApprovalDelayInSeconds: {
                type: "long"
              },
              LifetimeInSeconds: {
                type: "long"
              },
              AssignmentDurationInSeconds: {
                type: "long"
              },
              Reward: {},
              Title: {},
              Keywords: {},
              Description: {},
              Question: {},
              RequesterAnnotation: {},
              QualificationRequirements: {
                shape: "Si"
              },
              UniqueRequestToken: {},
              AssignmentReviewPolicy: {
                shape: "Sq"
              },
              HITReviewPolicy: {
                shape: "Sq"
              },
              HITLayoutId: {},
              HITLayoutParameters: {
                shape: "Sw"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HIT: {
                shape: "Sz"
              }
            }
          }
        },
        CreateHITType: {
          input: {
            type: "structure",
            required: [
              "AssignmentDurationInSeconds",
              "Reward",
              "Title",
              "Description"
            ],
            members: {
              AutoApprovalDelayInSeconds: {
                type: "long"
              },
              AssignmentDurationInSeconds: {
                type: "long"
              },
              Reward: {},
              Title: {},
              Keywords: {},
              Description: {},
              QualificationRequirements: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HITTypeId: {}
            }
          },
          idempotent: true
        },
        CreateHITWithHITType: {
          input: {
            type: "structure",
            required: [
              "HITTypeId",
              "LifetimeInSeconds"
            ],
            members: {
              HITTypeId: {},
              MaxAssignments: {
                type: "integer"
              },
              LifetimeInSeconds: {
                type: "long"
              },
              Question: {},
              RequesterAnnotation: {},
              UniqueRequestToken: {},
              AssignmentReviewPolicy: {
                shape: "Sq"
              },
              HITReviewPolicy: {
                shape: "Sq"
              },
              HITLayoutId: {},
              HITLayoutParameters: {
                shape: "Sw"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HIT: {
                shape: "Sz"
              }
            }
          }
        },
        CreateQualificationType: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Description",
              "QualificationTypeStatus"
            ],
            members: {
              Name: {},
              Keywords: {},
              Description: {},
              QualificationTypeStatus: {},
              RetryDelayInSeconds: {
                type: "long"
              },
              Test: {},
              AnswerKey: {},
              TestDurationInSeconds: {
                type: "long"
              },
              AutoGranted: {
                type: "boolean"
              },
              AutoGrantedValue: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              QualificationType: {
                shape: "S1a"
              }
            }
          }
        },
        CreateWorkerBlock: {
          input: {
            type: "structure",
            required: [
              "WorkerId",
              "Reason"
            ],
            members: {
              WorkerId: {},
              Reason: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteHIT: {
          input: {
            type: "structure",
            required: [
              "HITId"
            ],
            members: {
              HITId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteQualificationType: {
          input: {
            type: "structure",
            required: [
              "QualificationTypeId"
            ],
            members: {
              QualificationTypeId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteWorkerBlock: {
          input: {
            type: "structure",
            required: [
              "WorkerId"
            ],
            members: {
              WorkerId: {},
              Reason: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DisassociateQualificationFromWorker: {
          input: {
            type: "structure",
            required: [
              "WorkerId",
              "QualificationTypeId"
            ],
            members: {
              WorkerId: {},
              QualificationTypeId: {},
              Reason: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetAccountBalance: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              AvailableBalance: {},
              OnHoldBalance: {}
            }
          },
          idempotent: true
        },
        GetAssignment: {
          input: {
            type: "structure",
            required: [
              "AssignmentId"
            ],
            members: {
              AssignmentId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Assignment: {
                shape: "S1p"
              },
              HIT: {
                shape: "Sz"
              }
            }
          },
          idempotent: true
        },
        GetFileUploadURL: {
          input: {
            type: "structure",
            required: [
              "AssignmentId",
              "QuestionIdentifier"
            ],
            members: {
              AssignmentId: {},
              QuestionIdentifier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FileUploadURL: {}
            }
          },
          idempotent: true
        },
        GetHIT: {
          input: {
            type: "structure",
            required: [
              "HITId"
            ],
            members: {
              HITId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              HIT: {
                shape: "Sz"
              }
            }
          },
          idempotent: true
        },
        GetQualificationScore: {
          input: {
            type: "structure",
            required: [
              "QualificationTypeId",
              "WorkerId"
            ],
            members: {
              QualificationTypeId: {},
              WorkerId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Qualification: {
                shape: "S1x"
              }
            }
          },
          idempotent: true
        },
        GetQualificationType: {
          input: {
            type: "structure",
            required: [
              "QualificationTypeId"
            ],
            members: {
              QualificationTypeId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              QualificationType: {
                shape: "S1a"
              }
            }
          },
          idempotent: true
        },
        ListAssignmentsForHIT: {
          input: {
            type: "structure",
            required: [
              "HITId"
            ],
            members: {
              HITId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              AssignmentStatuses: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              NumResults: {
                type: "integer"
              },
              Assignments: {
                type: "list",
                member: {
                  shape: "S1p"
                }
              }
            }
          },
          idempotent: true
        },
        ListBonusPayments: {
          input: {
            type: "structure",
            members: {
              HITId: {},
              AssignmentId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NumResults: {
                type: "integer"
              },
              NextToken: {},
              BonusPayments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WorkerId: {},
                    BonusAmount: {},
                    AssignmentId: {},
                    Reason: {},
                    GrantTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          },
          idempotent: true
        },
        ListHITs: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              NumResults: {
                type: "integer"
              },
              HITs: {
                shape: "S2d"
              }
            }
          },
          idempotent: true
        },
        ListHITsForQualificationType: {
          input: {
            type: "structure",
            required: [
              "QualificationTypeId"
            ],
            members: {
              QualificationTypeId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              NumResults: {
                type: "integer"
              },
              HITs: {
                shape: "S2d"
              }
            }
          },
          idempotent: true
        },
        ListQualificationRequests: {
          input: {
            type: "structure",
            members: {
              QualificationTypeId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NumResults: {
                type: "integer"
              },
              NextToken: {},
              QualificationRequests: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    QualificationRequestId: {},
                    QualificationTypeId: {},
                    WorkerId: {},
                    Test: {},
                    Answer: {},
                    SubmitTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          },
          idempotent: true
        },
        ListQualificationTypes: {
          input: {
            type: "structure",
            required: [
              "MustBeRequestable"
            ],
            members: {
              Query: {},
              MustBeRequestable: {
                type: "boolean"
              },
              MustBeOwnedByCaller: {
                type: "boolean"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NumResults: {
                type: "integer"
              },
              NextToken: {},
              QualificationTypes: {
                type: "list",
                member: {
                  shape: "S1a"
                }
              }
            }
          },
          idempotent: true
        },
        ListReviewPolicyResultsForHIT: {
          input: {
            type: "structure",
            required: [
              "HITId"
            ],
            members: {
              HITId: {},
              PolicyLevels: {
                type: "list",
                member: {}
              },
              RetrieveActions: {
                type: "boolean"
              },
              RetrieveResults: {
                type: "boolean"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HITId: {},
              AssignmentReviewPolicy: {
                shape: "Sq"
              },
              HITReviewPolicy: {
                shape: "Sq"
              },
              AssignmentReviewReport: {
                shape: "S2r"
              },
              HITReviewReport: {
                shape: "S2r"
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListReviewableHITs: {
          input: {
            type: "structure",
            members: {
              HITTypeId: {},
              Status: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              NumResults: {
                type: "integer"
              },
              HITs: {
                shape: "S2d"
              }
            }
          },
          idempotent: true
        },
        ListWorkerBlocks: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              NumResults: {
                type: "integer"
              },
              WorkerBlocks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WorkerId: {},
                    Reason: {}
                  }
                }
              }
            }
          },
          idempotent: true
        },
        ListWorkersWithQualificationType: {
          input: {
            type: "structure",
            required: [
              "QualificationTypeId"
            ],
            members: {
              QualificationTypeId: {},
              Status: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              NumResults: {
                type: "integer"
              },
              Qualifications: {
                type: "list",
                member: {
                  shape: "S1x"
                }
              }
            }
          },
          idempotent: true
        },
        NotifyWorkers: {
          input: {
            type: "structure",
            required: [
              "Subject",
              "MessageText",
              "WorkerIds"
            ],
            members: {
              Subject: {},
              MessageText: {},
              WorkerIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NotifyWorkersFailureStatuses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    NotifyWorkersFailureCode: {},
                    NotifyWorkersFailureMessage: {},
                    WorkerId: {}
                  }
                }
              }
            }
          }
        },
        RejectAssignment: {
          input: {
            type: "structure",
            required: [
              "AssignmentId",
              "RequesterFeedback"
            ],
            members: {
              AssignmentId: {},
              RequesterFeedback: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        RejectQualificationRequest: {
          input: {
            type: "structure",
            required: [
              "QualificationRequestId"
            ],
            members: {
              QualificationRequestId: {},
              Reason: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SendBonus: {
          input: {
            type: "structure",
            required: [
              "WorkerId",
              "BonusAmount",
              "AssignmentId",
              "Reason"
            ],
            members: {
              WorkerId: {},
              BonusAmount: {},
              AssignmentId: {},
              Reason: {},
              UniqueRequestToken: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SendTestEventNotification: {
          input: {
            type: "structure",
            required: [
              "Notification",
              "TestEventType"
            ],
            members: {
              Notification: {
                shape: "S3k"
              },
              TestEventType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateExpirationForHIT: {
          input: {
            type: "structure",
            required: [
              "HITId",
              "ExpireAt"
            ],
            members: {
              HITId: {},
              ExpireAt: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateHITReviewStatus: {
          input: {
            type: "structure",
            required: [
              "HITId"
            ],
            members: {
              HITId: {},
              Revert: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateHITTypeOfHIT: {
          input: {
            type: "structure",
            required: [
              "HITId",
              "HITTypeId"
            ],
            members: {
              HITId: {},
              HITTypeId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateNotificationSettings: {
          input: {
            type: "structure",
            required: [
              "HITTypeId"
            ],
            members: {
              HITTypeId: {},
              Notification: {
                shape: "S3k"
              },
              Active: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateQualificationType: {
          input: {
            type: "structure",
            required: [
              "QualificationTypeId"
            ],
            members: {
              QualificationTypeId: {},
              Description: {},
              QualificationTypeStatus: {},
              Test: {},
              AnswerKey: {},
              TestDurationInSeconds: {
                type: "long"
              },
              RetryDelayInSeconds: {
                type: "long"
              },
              AutoGranted: {
                type: "boolean"
              },
              AutoGrantedValue: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              QualificationType: {
                shape: "S1a"
              }
            }
          }
        }
      },
      shapes: {
        Si: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "QualificationTypeId",
              "Comparator"
            ],
            members: {
              QualificationTypeId: {},
              Comparator: {},
              IntegerValues: {
                type: "list",
                member: {
                  type: "integer"
                }
              },
              LocaleValues: {
                type: "list",
                member: {
                  shape: "Sn"
                }
              },
              RequiredToPreview: {
                deprecated: true,
                type: "boolean"
              },
              ActionsGuarded: {}
            }
          }
        },
        Sn: {
          type: "structure",
          required: [
            "Country"
          ],
          members: {
            Country: {},
            Subdivision: {}
          }
        },
        Sq: {
          type: "structure",
          required: [
            "PolicyName"
          ],
          members: {
            PolicyName: {},
            Parameters: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Key: {},
                  Values: {
                    shape: "St"
                  },
                  MapEntries: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Key: {},
                        Values: {
                          shape: "St"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        St: {
          type: "list",
          member: {}
        },
        Sw: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Value"
            ],
            members: {
              Name: {},
              Value: {}
            }
          }
        },
        Sz: {
          type: "structure",
          members: {
            HITId: {},
            HITTypeId: {},
            HITGroupId: {},
            HITLayoutId: {},
            CreationTime: {
              type: "timestamp"
            },
            Title: {},
            Description: {},
            Question: {},
            Keywords: {},
            HITStatus: {},
            MaxAssignments: {
              type: "integer"
            },
            Reward: {},
            AutoApprovalDelayInSeconds: {
              type: "long"
            },
            Expiration: {
              type: "timestamp"
            },
            AssignmentDurationInSeconds: {
              type: "long"
            },
            RequesterAnnotation: {},
            QualificationRequirements: {
              shape: "Si"
            },
            HITReviewStatus: {},
            NumberOfAssignmentsPending: {
              type: "integer"
            },
            NumberOfAssignmentsAvailable: {
              type: "integer"
            },
            NumberOfAssignmentsCompleted: {
              type: "integer"
            }
          }
        },
        S1a: {
          type: "structure",
          members: {
            QualificationTypeId: {},
            CreationTime: {
              type: "timestamp"
            },
            Name: {},
            Description: {},
            Keywords: {},
            QualificationTypeStatus: {},
            Test: {},
            TestDurationInSeconds: {
              type: "long"
            },
            AnswerKey: {},
            RetryDelayInSeconds: {
              type: "long"
            },
            IsRequestable: {
              type: "boolean"
            },
            AutoGranted: {
              type: "boolean"
            },
            AutoGrantedValue: {
              type: "integer"
            }
          }
        },
        S1p: {
          type: "structure",
          members: {
            AssignmentId: {},
            WorkerId: {},
            HITId: {},
            AssignmentStatus: {},
            AutoApprovalTime: {
              type: "timestamp"
            },
            AcceptTime: {
              type: "timestamp"
            },
            SubmitTime: {
              type: "timestamp"
            },
            ApprovalTime: {
              type: "timestamp"
            },
            RejectionTime: {
              type: "timestamp"
            },
            Deadline: {
              type: "timestamp"
            },
            Answer: {},
            RequesterFeedback: {}
          }
        },
        S1x: {
          type: "structure",
          members: {
            QualificationTypeId: {},
            WorkerId: {},
            GrantTime: {
              type: "timestamp"
            },
            IntegerValue: {
              type: "integer"
            },
            LocaleValue: {
              shape: "Sn"
            },
            Status: {}
          }
        },
        S2d: {
          type: "list",
          member: {
            shape: "Sz"
          }
        },
        S2r: {
          type: "structure",
          members: {
            ReviewResults: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  ActionId: {},
                  SubjectId: {},
                  SubjectType: {},
                  QuestionId: {},
                  Key: {},
                  Value: {}
                }
              }
            },
            ReviewActions: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  ActionId: {},
                  ActionName: {},
                  TargetId: {},
                  TargetType: {},
                  Status: {},
                  CompleteTime: {
                    type: "timestamp"
                  },
                  Result: {},
                  ErrorCode: {}
                }
              }
            }
          }
        },
        S3k: {
          type: "structure",
          required: [
            "Destination",
            "Transport",
            "Version",
            "EventTypes"
          ],
          members: {
            Destination: {},
            Transport: {},
            Version: {},
            EventTypes: {
              type: "list",
              member: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/mturk-requester-2017-01-17.paginators.json
var require_mturk_requester_2017_01_17_paginators = __commonJS({
  "node_modules/aws-sdk/apis/mturk-requester-2017-01-17.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAssignmentsForHIT: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListBonusPayments: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListHITs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListHITsForQualificationType: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListQualificationRequests: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListQualificationTypes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListReviewPolicyResultsForHIT: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListReviewableHITs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListWorkerBlocks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListWorkersWithQualificationType: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/mturk.js
var require_mturk = __commonJS({
  "node_modules/aws-sdk/clients/mturk.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["mturk"] = {};
    AWS2.MTurk = Service.defineService("mturk", ["2017-01-17"]);
    Object.defineProperty(apiLoader.services["mturk"], "2017-01-17", {
      get: function get() {
        var model = require_mturk_requester_2017_01_17_min();
        model.paginators = require_mturk_requester_2017_01_17_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.MTurk;
  }
});

// node_modules/aws-sdk/apis/mobileanalytics-2014-06-05.min.json
var require_mobileanalytics_2014_06_05_min = __commonJS({
  "node_modules/aws-sdk/apis/mobileanalytics-2014-06-05.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-06-05",
        endpointPrefix: "mobileanalytics",
        serviceFullName: "Amazon Mobile Analytics",
        serviceId: "Mobile Analytics",
        signatureVersion: "v4",
        protocol: "rest-json"
      },
      operations: {
        PutEvents: {
          http: {
            requestUri: "/2014-06-05/events",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "events",
              "clientContext"
            ],
            members: {
              events: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "eventType",
                    "timestamp"
                  ],
                  members: {
                    eventType: {},
                    timestamp: {},
                    session: {
                      type: "structure",
                      members: {
                        id: {},
                        duration: {
                          type: "long"
                        },
                        startTimestamp: {},
                        stopTimestamp: {}
                      }
                    },
                    version: {},
                    attributes: {
                      type: "map",
                      key: {},
                      value: {}
                    },
                    metrics: {
                      type: "map",
                      key: {},
                      value: {
                        type: "double"
                      }
                    }
                  }
                }
              },
              clientContext: {
                location: "header",
                locationName: "x-amz-Client-Context"
              },
              clientContextEncoding: {
                location: "header",
                locationName: "x-amz-Client-Context-Encoding"
              }
            }
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/clients/mobileanalytics.js
var require_mobileanalytics = __commonJS({
  "node_modules/aws-sdk/clients/mobileanalytics.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["mobileanalytics"] = {};
    AWS2.MobileAnalytics = Service.defineService("mobileanalytics", ["2014-06-05"]);
    Object.defineProperty(apiLoader.services["mobileanalytics"], "2014-06-05", {
      get: function get() {
        var model = require_mobileanalytics_2014_06_05_min();
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.MobileAnalytics;
  }
});

// node_modules/aws-sdk/apis/opsworks-2013-02-18.min.json
var require_opsworks_2013_02_18_min = __commonJS({
  "node_modules/aws-sdk/apis/opsworks-2013-02-18.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2013-02-18",
        endpointPrefix: "opsworks",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS OpsWorks",
        serviceId: "OpsWorks",
        signatureVersion: "v4",
        targetPrefix: "OpsWorks_20130218",
        uid: "opsworks-2013-02-18"
      },
      operations: {
        AssignInstance: {
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "LayerIds"
            ],
            members: {
              InstanceId: {},
              LayerIds: {
                shape: "S3"
              }
            }
          }
        },
        AssignVolume: {
          input: {
            type: "structure",
            required: [
              "VolumeId"
            ],
            members: {
              VolumeId: {},
              InstanceId: {}
            }
          }
        },
        AssociateElasticIp: {
          input: {
            type: "structure",
            required: [
              "ElasticIp"
            ],
            members: {
              ElasticIp: {},
              InstanceId: {}
            }
          }
        },
        AttachElasticLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "ElasticLoadBalancerName",
              "LayerId"
            ],
            members: {
              ElasticLoadBalancerName: {},
              LayerId: {}
            }
          }
        },
        CloneStack: {
          input: {
            type: "structure",
            required: [
              "SourceStackId",
              "ServiceRoleArn"
            ],
            members: {
              SourceStackId: {},
              Name: {},
              Region: {},
              VpcId: {},
              Attributes: {
                shape: "S8"
              },
              ServiceRoleArn: {},
              DefaultInstanceProfileArn: {},
              DefaultOs: {},
              HostnameTheme: {},
              DefaultAvailabilityZone: {},
              DefaultSubnetId: {},
              CustomJson: {},
              ConfigurationManager: {
                shape: "Sa"
              },
              ChefConfiguration: {
                shape: "Sb"
              },
              UseCustomCookbooks: {
                type: "boolean"
              },
              UseOpsworksSecurityGroups: {
                type: "boolean"
              },
              CustomCookbooksSource: {
                shape: "Sd"
              },
              DefaultSshKeyName: {},
              ClonePermissions: {
                type: "boolean"
              },
              CloneAppIds: {
                shape: "S3"
              },
              DefaultRootDeviceType: {},
              AgentVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StackId: {}
            }
          }
        },
        CreateApp: {
          input: {
            type: "structure",
            required: [
              "StackId",
              "Name",
              "Type"
            ],
            members: {
              StackId: {},
              Shortname: {},
              Name: {},
              Description: {},
              DataSources: {
                shape: "Si"
              },
              Type: {},
              AppSource: {
                shape: "Sd"
              },
              Domains: {
                shape: "S3"
              },
              EnableSsl: {
                type: "boolean"
              },
              SslConfiguration: {
                shape: "Sl"
              },
              Attributes: {
                shape: "Sm"
              },
              Environment: {
                shape: "So"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppId: {}
            }
          }
        },
        CreateDeployment: {
          input: {
            type: "structure",
            required: [
              "StackId",
              "Command"
            ],
            members: {
              StackId: {},
              AppId: {},
              InstanceIds: {
                shape: "S3"
              },
              LayerIds: {
                shape: "S3"
              },
              Command: {
                shape: "Ss"
              },
              Comment: {},
              CustomJson: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DeploymentId: {}
            }
          }
        },
        CreateInstance: {
          input: {
            type: "structure",
            required: [
              "StackId",
              "LayerIds",
              "InstanceType"
            ],
            members: {
              StackId: {},
              LayerIds: {
                shape: "S3"
              },
              InstanceType: {},
              AutoScalingType: {},
              Hostname: {},
              Os: {},
              AmiId: {},
              SshKeyName: {},
              AvailabilityZone: {},
              VirtualizationType: {},
              SubnetId: {},
              Architecture: {},
              RootDeviceType: {},
              BlockDeviceMappings: {
                shape: "Sz"
              },
              InstallUpdatesOnBoot: {
                type: "boolean"
              },
              EbsOptimized: {
                type: "boolean"
              },
              AgentVersion: {},
              Tenancy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceId: {}
            }
          }
        },
        CreateLayer: {
          input: {
            type: "structure",
            required: [
              "StackId",
              "Type",
              "Name",
              "Shortname"
            ],
            members: {
              StackId: {},
              Type: {},
              Name: {},
              Shortname: {},
              Attributes: {
                shape: "S17"
              },
              CloudWatchLogsConfiguration: {
                shape: "S19"
              },
              CustomInstanceProfileArn: {},
              CustomJson: {},
              CustomSecurityGroupIds: {
                shape: "S3"
              },
              Packages: {
                shape: "S3"
              },
              VolumeConfigurations: {
                shape: "S1f"
              },
              EnableAutoHealing: {
                type: "boolean"
              },
              AutoAssignElasticIps: {
                type: "boolean"
              },
              AutoAssignPublicIps: {
                type: "boolean"
              },
              CustomRecipes: {
                shape: "S1h"
              },
              InstallUpdatesOnBoot: {
                type: "boolean"
              },
              UseEbsOptimizedInstances: {
                type: "boolean"
              },
              LifecycleEventConfiguration: {
                shape: "S1i"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LayerId: {}
            }
          }
        },
        CreateStack: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Region",
              "ServiceRoleArn",
              "DefaultInstanceProfileArn"
            ],
            members: {
              Name: {},
              Region: {},
              VpcId: {},
              Attributes: {
                shape: "S8"
              },
              ServiceRoleArn: {},
              DefaultInstanceProfileArn: {},
              DefaultOs: {},
              HostnameTheme: {},
              DefaultAvailabilityZone: {},
              DefaultSubnetId: {},
              CustomJson: {},
              ConfigurationManager: {
                shape: "Sa"
              },
              ChefConfiguration: {
                shape: "Sb"
              },
              UseCustomCookbooks: {
                type: "boolean"
              },
              UseOpsworksSecurityGroups: {
                type: "boolean"
              },
              CustomCookbooksSource: {
                shape: "Sd"
              },
              DefaultSshKeyName: {},
              DefaultRootDeviceType: {},
              AgentVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StackId: {}
            }
          }
        },
        CreateUserProfile: {
          input: {
            type: "structure",
            required: [
              "IamUserArn"
            ],
            members: {
              IamUserArn: {},
              SshUsername: {},
              SshPublicKey: {},
              AllowSelfManagement: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IamUserArn: {}
            }
          }
        },
        DeleteApp: {
          input: {
            type: "structure",
            required: [
              "AppId"
            ],
            members: {
              AppId: {}
            }
          }
        },
        DeleteInstance: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              DeleteElasticIp: {
                type: "boolean"
              },
              DeleteVolumes: {
                type: "boolean"
              }
            }
          }
        },
        DeleteLayer: {
          input: {
            type: "structure",
            required: [
              "LayerId"
            ],
            members: {
              LayerId: {}
            }
          }
        },
        DeleteStack: {
          input: {
            type: "structure",
            required: [
              "StackId"
            ],
            members: {
              StackId: {}
            }
          }
        },
        DeleteUserProfile: {
          input: {
            type: "structure",
            required: [
              "IamUserArn"
            ],
            members: {
              IamUserArn: {}
            }
          }
        },
        DeregisterEcsCluster: {
          input: {
            type: "structure",
            required: [
              "EcsClusterArn"
            ],
            members: {
              EcsClusterArn: {}
            }
          }
        },
        DeregisterElasticIp: {
          input: {
            type: "structure",
            required: [
              "ElasticIp"
            ],
            members: {
              ElasticIp: {}
            }
          }
        },
        DeregisterInstance: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {}
            }
          }
        },
        DeregisterRdsDbInstance: {
          input: {
            type: "structure",
            required: [
              "RdsDbInstanceArn"
            ],
            members: {
              RdsDbInstanceArn: {}
            }
          }
        },
        DeregisterVolume: {
          input: {
            type: "structure",
            required: [
              "VolumeId"
            ],
            members: {
              VolumeId: {}
            }
          }
        },
        DescribeAgentVersions: {
          input: {
            type: "structure",
            members: {
              StackId: {},
              ConfigurationManager: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AgentVersions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Version: {},
                    ConfigurationManager: {
                      shape: "Sa"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeApps: {
          input: {
            type: "structure",
            members: {
              StackId: {},
              AppIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Apps: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AppId: {},
                    StackId: {},
                    Shortname: {},
                    Name: {},
                    Description: {},
                    DataSources: {
                      shape: "Si"
                    },
                    Type: {},
                    AppSource: {
                      shape: "Sd"
                    },
                    Domains: {
                      shape: "S3"
                    },
                    EnableSsl: {
                      type: "boolean"
                    },
                    SslConfiguration: {
                      shape: "Sl"
                    },
                    Attributes: {
                      shape: "Sm"
                    },
                    CreatedAt: {},
                    Environment: {
                      shape: "So"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeCommands: {
          input: {
            type: "structure",
            members: {
              DeploymentId: {},
              InstanceId: {},
              CommandIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Commands: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CommandId: {},
                    InstanceId: {},
                    DeploymentId: {},
                    CreatedAt: {},
                    AcknowledgedAt: {},
                    CompletedAt: {},
                    Status: {},
                    ExitCode: {
                      type: "integer"
                    },
                    LogUrl: {},
                    Type: {}
                  }
                }
              }
            }
          }
        },
        DescribeDeployments: {
          input: {
            type: "structure",
            members: {
              StackId: {},
              AppId: {},
              DeploymentIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Deployments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DeploymentId: {},
                    StackId: {},
                    AppId: {},
                    CreatedAt: {},
                    CompletedAt: {},
                    Duration: {
                      type: "integer"
                    },
                    IamUserArn: {},
                    Comment: {},
                    Command: {
                      shape: "Ss"
                    },
                    Status: {},
                    CustomJson: {},
                    InstanceIds: {
                      shape: "S3"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeEcsClusters: {
          input: {
            type: "structure",
            members: {
              EcsClusterArns: {
                shape: "S3"
              },
              StackId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EcsClusters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EcsClusterArn: {},
                    EcsClusterName: {},
                    StackId: {},
                    RegisteredAt: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeElasticIps: {
          input: {
            type: "structure",
            members: {
              InstanceId: {},
              StackId: {},
              Ips: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ElasticIps: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Ip: {},
                    Name: {},
                    Domain: {},
                    Region: {},
                    InstanceId: {}
                  }
                }
              }
            }
          }
        },
        DescribeElasticLoadBalancers: {
          input: {
            type: "structure",
            members: {
              StackId: {},
              LayerIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ElasticLoadBalancers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ElasticLoadBalancerName: {},
                    Region: {},
                    DnsName: {},
                    StackId: {},
                    LayerId: {},
                    VpcId: {},
                    AvailabilityZones: {
                      shape: "S3"
                    },
                    SubnetIds: {
                      shape: "S3"
                    },
                    Ec2InstanceIds: {
                      shape: "S3"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeInstances: {
          input: {
            type: "structure",
            members: {
              StackId: {},
              LayerId: {},
              InstanceIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Instances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AgentVersion: {},
                    AmiId: {},
                    Architecture: {},
                    Arn: {},
                    AutoScalingType: {},
                    AvailabilityZone: {},
                    BlockDeviceMappings: {
                      shape: "Sz"
                    },
                    CreatedAt: {},
                    EbsOptimized: {
                      type: "boolean"
                    },
                    Ec2InstanceId: {},
                    EcsClusterArn: {},
                    EcsContainerInstanceArn: {},
                    ElasticIp: {},
                    Hostname: {},
                    InfrastructureClass: {},
                    InstallUpdatesOnBoot: {
                      type: "boolean"
                    },
                    InstanceId: {},
                    InstanceProfileArn: {},
                    InstanceType: {},
                    LastServiceErrorId: {},
                    LayerIds: {
                      shape: "S3"
                    },
                    Os: {},
                    Platform: {},
                    PrivateDns: {},
                    PrivateIp: {},
                    PublicDns: {},
                    PublicIp: {},
                    RegisteredBy: {},
                    ReportedAgentVersion: {},
                    ReportedOs: {
                      type: "structure",
                      members: {
                        Family: {},
                        Name: {},
                        Version: {}
                      }
                    },
                    RootDeviceType: {},
                    RootDeviceVolumeId: {},
                    SecurityGroupIds: {
                      shape: "S3"
                    },
                    SshHostDsaKeyFingerprint: {},
                    SshHostRsaKeyFingerprint: {},
                    SshKeyName: {},
                    StackId: {},
                    Status: {},
                    SubnetId: {},
                    Tenancy: {},
                    VirtualizationType: {}
                  }
                }
              }
            }
          }
        },
        DescribeLayers: {
          input: {
            type: "structure",
            members: {
              StackId: {},
              LayerIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Layers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    StackId: {},
                    LayerId: {},
                    Type: {},
                    Name: {},
                    Shortname: {},
                    Attributes: {
                      shape: "S17"
                    },
                    CloudWatchLogsConfiguration: {
                      shape: "S19"
                    },
                    CustomInstanceProfileArn: {},
                    CustomJson: {},
                    CustomSecurityGroupIds: {
                      shape: "S3"
                    },
                    DefaultSecurityGroupNames: {
                      shape: "S3"
                    },
                    Packages: {
                      shape: "S3"
                    },
                    VolumeConfigurations: {
                      shape: "S1f"
                    },
                    EnableAutoHealing: {
                      type: "boolean"
                    },
                    AutoAssignElasticIps: {
                      type: "boolean"
                    },
                    AutoAssignPublicIps: {
                      type: "boolean"
                    },
                    DefaultRecipes: {
                      shape: "S1h"
                    },
                    CustomRecipes: {
                      shape: "S1h"
                    },
                    CreatedAt: {},
                    InstallUpdatesOnBoot: {
                      type: "boolean"
                    },
                    UseEbsOptimizedInstances: {
                      type: "boolean"
                    },
                    LifecycleEventConfiguration: {
                      shape: "S1i"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeLoadBasedAutoScaling: {
          input: {
            type: "structure",
            required: [
              "LayerIds"
            ],
            members: {
              LayerIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LoadBasedAutoScalingConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LayerId: {},
                    Enable: {
                      type: "boolean"
                    },
                    UpScaling: {
                      shape: "S36"
                    },
                    DownScaling: {
                      shape: "S36"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeMyUserProfile: {
          output: {
            type: "structure",
            members: {
              UserProfile: {
                type: "structure",
                members: {
                  IamUserArn: {},
                  Name: {},
                  SshUsername: {},
                  SshPublicKey: {}
                }
              }
            }
          }
        },
        DescribeOperatingSystems: {
          output: {
            type: "structure",
            members: {
              OperatingSystems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Id: {},
                    Type: {},
                    ConfigurationManagers: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Name: {},
                          Version: {}
                        }
                      }
                    },
                    ReportedName: {},
                    ReportedVersion: {},
                    Supported: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        DescribePermissions: {
          input: {
            type: "structure",
            members: {
              IamUserArn: {},
              StackId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Permissions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StackId: {},
                    IamUserArn: {},
                    AllowSsh: {
                      type: "boolean"
                    },
                    AllowSudo: {
                      type: "boolean"
                    },
                    Level: {}
                  }
                }
              }
            }
          }
        },
        DescribeRaidArrays: {
          input: {
            type: "structure",
            members: {
              InstanceId: {},
              StackId: {},
              RaidArrayIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RaidArrays: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RaidArrayId: {},
                    InstanceId: {},
                    Name: {},
                    RaidLevel: {
                      type: "integer"
                    },
                    NumberOfDisks: {
                      type: "integer"
                    },
                    Size: {
                      type: "integer"
                    },
                    Device: {},
                    MountPoint: {},
                    AvailabilityZone: {},
                    CreatedAt: {},
                    StackId: {},
                    VolumeType: {},
                    Iops: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeRdsDbInstances: {
          input: {
            type: "structure",
            required: [
              "StackId"
            ],
            members: {
              StackId: {},
              RdsDbInstanceArns: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RdsDbInstances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RdsDbInstanceArn: {},
                    DbInstanceIdentifier: {},
                    DbUser: {},
                    DbPassword: {},
                    Region: {},
                    Address: {},
                    Engine: {},
                    StackId: {},
                    MissingOnRds: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeServiceErrors: {
          input: {
            type: "structure",
            members: {
              StackId: {},
              InstanceId: {},
              ServiceErrorIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceErrors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ServiceErrorId: {},
                    StackId: {},
                    InstanceId: {},
                    Type: {},
                    Message: {},
                    CreatedAt: {}
                  }
                }
              }
            }
          }
        },
        DescribeStackProvisioningParameters: {
          input: {
            type: "structure",
            required: [
              "StackId"
            ],
            members: {
              StackId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AgentInstallerUrl: {},
              Parameters: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        DescribeStackSummary: {
          input: {
            type: "structure",
            required: [
              "StackId"
            ],
            members: {
              StackId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StackSummary: {
                type: "structure",
                members: {
                  StackId: {},
                  Name: {},
                  Arn: {},
                  LayersCount: {
                    type: "integer"
                  },
                  AppsCount: {
                    type: "integer"
                  },
                  InstancesCount: {
                    type: "structure",
                    members: {
                      Assigning: {
                        type: "integer"
                      },
                      Booting: {
                        type: "integer"
                      },
                      ConnectionLost: {
                        type: "integer"
                      },
                      Deregistering: {
                        type: "integer"
                      },
                      Online: {
                        type: "integer"
                      },
                      Pending: {
                        type: "integer"
                      },
                      Rebooting: {
                        type: "integer"
                      },
                      Registered: {
                        type: "integer"
                      },
                      Registering: {
                        type: "integer"
                      },
                      Requested: {
                        type: "integer"
                      },
                      RunningSetup: {
                        type: "integer"
                      },
                      SetupFailed: {
                        type: "integer"
                      },
                      ShuttingDown: {
                        type: "integer"
                      },
                      StartFailed: {
                        type: "integer"
                      },
                      StopFailed: {
                        type: "integer"
                      },
                      Stopped: {
                        type: "integer"
                      },
                      Stopping: {
                        type: "integer"
                      },
                      Terminated: {
                        type: "integer"
                      },
                      Terminating: {
                        type: "integer"
                      },
                      Unassigning: {
                        type: "integer"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeStacks: {
          input: {
            type: "structure",
            members: {
              StackIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Stacks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StackId: {},
                    Name: {},
                    Arn: {},
                    Region: {},
                    VpcId: {},
                    Attributes: {
                      shape: "S8"
                    },
                    ServiceRoleArn: {},
                    DefaultInstanceProfileArn: {},
                    DefaultOs: {},
                    HostnameTheme: {},
                    DefaultAvailabilityZone: {},
                    DefaultSubnetId: {},
                    CustomJson: {},
                    ConfigurationManager: {
                      shape: "Sa"
                    },
                    ChefConfiguration: {
                      shape: "Sb"
                    },
                    UseCustomCookbooks: {
                      type: "boolean"
                    },
                    UseOpsworksSecurityGroups: {
                      type: "boolean"
                    },
                    CustomCookbooksSource: {
                      shape: "Sd"
                    },
                    DefaultSshKeyName: {},
                    CreatedAt: {},
                    DefaultRootDeviceType: {},
                    AgentVersion: {}
                  }
                }
              }
            }
          }
        },
        DescribeTimeBasedAutoScaling: {
          input: {
            type: "structure",
            required: [
              "InstanceIds"
            ],
            members: {
              InstanceIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TimeBasedAutoScalingConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InstanceId: {},
                    AutoScalingSchedule: {
                      shape: "S4b"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeUserProfiles: {
          input: {
            type: "structure",
            members: {
              IamUserArns: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserProfiles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    IamUserArn: {},
                    Name: {},
                    SshUsername: {},
                    SshPublicKey: {},
                    AllowSelfManagement: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeVolumes: {
          input: {
            type: "structure",
            members: {
              InstanceId: {},
              StackId: {},
              RaidArrayId: {},
              VolumeIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Volumes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    VolumeId: {},
                    Ec2VolumeId: {},
                    Name: {},
                    RaidArrayId: {},
                    InstanceId: {},
                    Status: {},
                    Size: {
                      type: "integer"
                    },
                    Device: {},
                    MountPoint: {},
                    Region: {},
                    AvailabilityZone: {},
                    VolumeType: {},
                    Iops: {
                      type: "integer"
                    },
                    Encrypted: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        DetachElasticLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "ElasticLoadBalancerName",
              "LayerId"
            ],
            members: {
              ElasticLoadBalancerName: {},
              LayerId: {}
            }
          }
        },
        DisassociateElasticIp: {
          input: {
            type: "structure",
            required: [
              "ElasticIp"
            ],
            members: {
              ElasticIp: {}
            }
          }
        },
        GetHostnameSuggestion: {
          input: {
            type: "structure",
            required: [
              "LayerId"
            ],
            members: {
              LayerId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LayerId: {},
              Hostname: {}
            }
          }
        },
        GrantAccess: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              ValidForInMinutes: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemporaryCredential: {
                type: "structure",
                members: {
                  Username: {},
                  Password: {},
                  ValidForInMinutes: {
                    type: "integer"
                  },
                  InstanceId: {}
                }
              }
            }
          }
        },
        ListTags: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S50"
              },
              NextToken: {}
            }
          }
        },
        RebootInstance: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {}
            }
          }
        },
        RegisterEcsCluster: {
          input: {
            type: "structure",
            required: [
              "EcsClusterArn",
              "StackId"
            ],
            members: {
              EcsClusterArn: {},
              StackId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EcsClusterArn: {}
            }
          }
        },
        RegisterElasticIp: {
          input: {
            type: "structure",
            required: [
              "ElasticIp",
              "StackId"
            ],
            members: {
              ElasticIp: {},
              StackId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ElasticIp: {}
            }
          }
        },
        RegisterInstance: {
          input: {
            type: "structure",
            required: [
              "StackId"
            ],
            members: {
              StackId: {},
              Hostname: {},
              PublicIp: {},
              PrivateIp: {},
              RsaPublicKey: {},
              RsaPublicKeyFingerprint: {},
              InstanceIdentity: {
                type: "structure",
                members: {
                  Document: {},
                  Signature: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceId: {}
            }
          }
        },
        RegisterRdsDbInstance: {
          input: {
            type: "structure",
            required: [
              "StackId",
              "RdsDbInstanceArn",
              "DbUser",
              "DbPassword"
            ],
            members: {
              StackId: {},
              RdsDbInstanceArn: {},
              DbUser: {},
              DbPassword: {}
            }
          }
        },
        RegisterVolume: {
          input: {
            type: "structure",
            required: [
              "StackId"
            ],
            members: {
              Ec2VolumeId: {},
              StackId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VolumeId: {}
            }
          }
        },
        SetLoadBasedAutoScaling: {
          input: {
            type: "structure",
            required: [
              "LayerId"
            ],
            members: {
              LayerId: {},
              Enable: {
                type: "boolean"
              },
              UpScaling: {
                shape: "S36"
              },
              DownScaling: {
                shape: "S36"
              }
            }
          }
        },
        SetPermission: {
          input: {
            type: "structure",
            required: [
              "StackId",
              "IamUserArn"
            ],
            members: {
              StackId: {},
              IamUserArn: {},
              AllowSsh: {
                type: "boolean"
              },
              AllowSudo: {
                type: "boolean"
              },
              Level: {}
            }
          }
        },
        SetTimeBasedAutoScaling: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              AutoScalingSchedule: {
                shape: "S4b"
              }
            }
          }
        },
        StartInstance: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {}
            }
          }
        },
        StartStack: {
          input: {
            type: "structure",
            required: [
              "StackId"
            ],
            members: {
              StackId: {}
            }
          }
        },
        StopInstance: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              Force: {
                type: "boolean"
              }
            }
          }
        },
        StopStack: {
          input: {
            type: "structure",
            required: [
              "StackId"
            ],
            members: {
              StackId: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S50"
              }
            }
          }
        },
        UnassignInstance: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {}
            }
          }
        },
        UnassignVolume: {
          input: {
            type: "structure",
            required: [
              "VolumeId"
            ],
            members: {
              VolumeId: {}
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        },
        UpdateApp: {
          input: {
            type: "structure",
            required: [
              "AppId"
            ],
            members: {
              AppId: {},
              Name: {},
              Description: {},
              DataSources: {
                shape: "Si"
              },
              Type: {},
              AppSource: {
                shape: "Sd"
              },
              Domains: {
                shape: "S3"
              },
              EnableSsl: {
                type: "boolean"
              },
              SslConfiguration: {
                shape: "Sl"
              },
              Attributes: {
                shape: "Sm"
              },
              Environment: {
                shape: "So"
              }
            }
          }
        },
        UpdateElasticIp: {
          input: {
            type: "structure",
            required: [
              "ElasticIp"
            ],
            members: {
              ElasticIp: {},
              Name: {}
            }
          }
        },
        UpdateInstance: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              LayerIds: {
                shape: "S3"
              },
              InstanceType: {},
              AutoScalingType: {},
              Hostname: {},
              Os: {},
              AmiId: {},
              SshKeyName: {},
              Architecture: {},
              InstallUpdatesOnBoot: {
                type: "boolean"
              },
              EbsOptimized: {
                type: "boolean"
              },
              AgentVersion: {}
            }
          }
        },
        UpdateLayer: {
          input: {
            type: "structure",
            required: [
              "LayerId"
            ],
            members: {
              LayerId: {},
              Name: {},
              Shortname: {},
              Attributes: {
                shape: "S17"
              },
              CloudWatchLogsConfiguration: {
                shape: "S19"
              },
              CustomInstanceProfileArn: {},
              CustomJson: {},
              CustomSecurityGroupIds: {
                shape: "S3"
              },
              Packages: {
                shape: "S3"
              },
              VolumeConfigurations: {
                shape: "S1f"
              },
              EnableAutoHealing: {
                type: "boolean"
              },
              AutoAssignElasticIps: {
                type: "boolean"
              },
              AutoAssignPublicIps: {
                type: "boolean"
              },
              CustomRecipes: {
                shape: "S1h"
              },
              InstallUpdatesOnBoot: {
                type: "boolean"
              },
              UseEbsOptimizedInstances: {
                type: "boolean"
              },
              LifecycleEventConfiguration: {
                shape: "S1i"
              }
            }
          }
        },
        UpdateMyUserProfile: {
          input: {
            type: "structure",
            members: {
              SshPublicKey: {}
            }
          }
        },
        UpdateRdsDbInstance: {
          input: {
            type: "structure",
            required: [
              "RdsDbInstanceArn"
            ],
            members: {
              RdsDbInstanceArn: {},
              DbUser: {},
              DbPassword: {}
            }
          }
        },
        UpdateStack: {
          input: {
            type: "structure",
            required: [
              "StackId"
            ],
            members: {
              StackId: {},
              Name: {},
              Attributes: {
                shape: "S8"
              },
              ServiceRoleArn: {},
              DefaultInstanceProfileArn: {},
              DefaultOs: {},
              HostnameTheme: {},
              DefaultAvailabilityZone: {},
              DefaultSubnetId: {},
              CustomJson: {},
              ConfigurationManager: {
                shape: "Sa"
              },
              ChefConfiguration: {
                shape: "Sb"
              },
              UseCustomCookbooks: {
                type: "boolean"
              },
              CustomCookbooksSource: {
                shape: "Sd"
              },
              DefaultSshKeyName: {},
              DefaultRootDeviceType: {},
              UseOpsworksSecurityGroups: {
                type: "boolean"
              },
              AgentVersion: {}
            }
          }
        },
        UpdateUserProfile: {
          input: {
            type: "structure",
            required: [
              "IamUserArn"
            ],
            members: {
              IamUserArn: {},
              SshUsername: {},
              SshPublicKey: {},
              AllowSelfManagement: {
                type: "boolean"
              }
            }
          }
        },
        UpdateVolume: {
          input: {
            type: "structure",
            required: [
              "VolumeId"
            ],
            members: {
              VolumeId: {},
              Name: {},
              MountPoint: {}
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {}
        },
        S8: {
          type: "map",
          key: {},
          value: {}
        },
        Sa: {
          type: "structure",
          members: {
            Name: {},
            Version: {}
          }
        },
        Sb: {
          type: "structure",
          members: {
            ManageBerkshelf: {
              type: "boolean"
            },
            BerkshelfVersion: {}
          }
        },
        Sd: {
          type: "structure",
          members: {
            Type: {},
            Url: {},
            Username: {},
            Password: {},
            SshKey: {},
            Revision: {}
          }
        },
        Si: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Type: {},
              Arn: {},
              DatabaseName: {}
            }
          }
        },
        Sl: {
          type: "structure",
          required: [
            "Certificate",
            "PrivateKey"
          ],
          members: {
            Certificate: {},
            PrivateKey: {},
            Chain: {}
          }
        },
        Sm: {
          type: "map",
          key: {},
          value: {}
        },
        So: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {},
              Secure: {
                type: "boolean"
              }
            }
          }
        },
        Ss: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            Args: {
              type: "map",
              key: {},
              value: {
                shape: "S3"
              }
            }
          }
        },
        Sz: {
          type: "list",
          member: {
            type: "structure",
            members: {
              DeviceName: {},
              NoDevice: {},
              VirtualName: {},
              Ebs: {
                type: "structure",
                members: {
                  SnapshotId: {},
                  Iops: {
                    type: "integer"
                  },
                  VolumeSize: {
                    type: "integer"
                  },
                  VolumeType: {},
                  DeleteOnTermination: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        S17: {
          type: "map",
          key: {},
          value: {}
        },
        S19: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            LogStreams: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  LogGroupName: {},
                  DatetimeFormat: {},
                  TimeZone: {},
                  File: {},
                  FileFingerprintLines: {},
                  MultiLineStartPattern: {},
                  InitialPosition: {},
                  Encoding: {},
                  BufferDuration: {
                    type: "integer"
                  },
                  BatchCount: {
                    type: "integer"
                  },
                  BatchSize: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        S1f: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "MountPoint",
              "NumberOfDisks",
              "Size"
            ],
            members: {
              MountPoint: {},
              RaidLevel: {
                type: "integer"
              },
              NumberOfDisks: {
                type: "integer"
              },
              Size: {
                type: "integer"
              },
              VolumeType: {},
              Iops: {
                type: "integer"
              },
              Encrypted: {
                type: "boolean"
              }
            }
          }
        },
        S1h: {
          type: "structure",
          members: {
            Setup: {
              shape: "S3"
            },
            Configure: {
              shape: "S3"
            },
            Deploy: {
              shape: "S3"
            },
            Undeploy: {
              shape: "S3"
            },
            Shutdown: {
              shape: "S3"
            }
          }
        },
        S1i: {
          type: "structure",
          members: {
            Shutdown: {
              type: "structure",
              members: {
                ExecutionTimeout: {
                  type: "integer"
                },
                DelayUntilElbConnectionsDrained: {
                  type: "boolean"
                }
              }
            }
          }
        },
        S36: {
          type: "structure",
          members: {
            InstanceCount: {
              type: "integer"
            },
            ThresholdsWaitTime: {
              type: "integer"
            },
            IgnoreMetricsTime: {
              type: "integer"
            },
            CpuThreshold: {
              type: "double"
            },
            MemoryThreshold: {
              type: "double"
            },
            LoadThreshold: {
              type: "double"
            },
            Alarms: {
              shape: "S3"
            }
          }
        },
        S4b: {
          type: "structure",
          members: {
            Monday: {
              shape: "S4c"
            },
            Tuesday: {
              shape: "S4c"
            },
            Wednesday: {
              shape: "S4c"
            },
            Thursday: {
              shape: "S4c"
            },
            Friday: {
              shape: "S4c"
            },
            Saturday: {
              shape: "S4c"
            },
            Sunday: {
              shape: "S4c"
            }
          }
        },
        S4c: {
          type: "map",
          key: {},
          value: {}
        },
        S50: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/opsworks-2013-02-18.paginators.json
var require_opsworks_2013_02_18_paginators = __commonJS({
  "node_modules/aws-sdk/apis/opsworks-2013-02-18.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeApps: {
          result_key: "Apps"
        },
        DescribeCommands: {
          result_key: "Commands"
        },
        DescribeDeployments: {
          result_key: "Deployments"
        },
        DescribeEcsClusters: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "EcsClusters"
        },
        DescribeElasticIps: {
          result_key: "ElasticIps"
        },
        DescribeElasticLoadBalancers: {
          result_key: "ElasticLoadBalancers"
        },
        DescribeInstances: {
          result_key: "Instances"
        },
        DescribeLayers: {
          result_key: "Layers"
        },
        DescribeLoadBasedAutoScaling: {
          result_key: "LoadBasedAutoScalingConfigurations"
        },
        DescribePermissions: {
          result_key: "Permissions"
        },
        DescribeRaidArrays: {
          result_key: "RaidArrays"
        },
        DescribeServiceErrors: {
          result_key: "ServiceErrors"
        },
        DescribeStacks: {
          result_key: "Stacks"
        },
        DescribeTimeBasedAutoScaling: {
          result_key: "TimeBasedAutoScalingConfigurations"
        },
        DescribeUserProfiles: {
          result_key: "UserProfiles"
        },
        DescribeVolumes: {
          result_key: "Volumes"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/opsworks-2013-02-18.waiters2.json
var require_opsworks_2013_02_18_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/opsworks-2013-02-18.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        AppExists: {
          delay: 1,
          operation: "DescribeApps",
          maxAttempts: 40,
          acceptors: [
            {
              expected: 200,
              matcher: "status",
              state: "success"
            },
            {
              matcher: "status",
              expected: 400,
              state: "failure"
            }
          ]
        },
        DeploymentSuccessful: {
          delay: 15,
          operation: "DescribeDeployments",
          maxAttempts: 40,
          description: "Wait until a deployment has completed successfully.",
          acceptors: [
            {
              expected: "successful",
              matcher: "pathAll",
              state: "success",
              argument: "Deployments[].Status"
            },
            {
              expected: "failed",
              matcher: "pathAny",
              state: "failure",
              argument: "Deployments[].Status"
            }
          ]
        },
        InstanceOnline: {
          delay: 15,
          operation: "DescribeInstances",
          maxAttempts: 40,
          description: "Wait until OpsWorks instance is online.",
          acceptors: [
            {
              expected: "online",
              matcher: "pathAll",
              state: "success",
              argument: "Instances[].Status"
            },
            {
              expected: "setup_failed",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "shutting_down",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "start_failed",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "stopped",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "stopping",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "terminating",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "terminated",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "stop_failed",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            }
          ]
        },
        InstanceRegistered: {
          delay: 15,
          operation: "DescribeInstances",
          maxAttempts: 40,
          description: "Wait until OpsWorks instance is registered.",
          acceptors: [
            {
              expected: "registered",
              matcher: "pathAll",
              state: "success",
              argument: "Instances[].Status"
            },
            {
              expected: "setup_failed",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "shutting_down",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "stopped",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "stopping",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "terminating",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "terminated",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "stop_failed",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            }
          ]
        },
        InstanceStopped: {
          delay: 15,
          operation: "DescribeInstances",
          maxAttempts: 40,
          description: "Wait until OpsWorks instance is stopped.",
          acceptors: [
            {
              expected: "stopped",
              matcher: "pathAll",
              state: "success",
              argument: "Instances[].Status"
            },
            {
              expected: "booting",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "pending",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "rebooting",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "requested",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "running_setup",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "setup_failed",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "start_failed",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "stop_failed",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            }
          ]
        },
        InstanceTerminated: {
          delay: 15,
          operation: "DescribeInstances",
          maxAttempts: 40,
          description: "Wait until OpsWorks instance is terminated.",
          acceptors: [
            {
              expected: "terminated",
              matcher: "pathAll",
              state: "success",
              argument: "Instances[].Status"
            },
            {
              expected: "ResourceNotFoundException",
              matcher: "error",
              state: "success"
            },
            {
              expected: "booting",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "online",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "pending",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "rebooting",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "requested",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "running_setup",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "setup_failed",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "start_failed",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/opsworks.js
var require_opsworks = __commonJS({
  "node_modules/aws-sdk/clients/opsworks.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["opsworks"] = {};
    AWS2.OpsWorks = Service.defineService("opsworks", ["2013-02-18"]);
    Object.defineProperty(apiLoader.services["opsworks"], "2013-02-18", {
      get: function get() {
        var model = require_opsworks_2013_02_18_min();
        model.paginators = require_opsworks_2013_02_18_paginators().pagination;
        model.waiters = require_opsworks_2013_02_18_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.OpsWorks;
  }
});

// node_modules/aws-sdk/apis/opsworkscm-2016-11-01.min.json
var require_opsworkscm_2016_11_01_min = __commonJS({
  "node_modules/aws-sdk/apis/opsworkscm-2016-11-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-11-01",
        endpointPrefix: "opsworks-cm",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "OpsWorksCM",
        serviceFullName: "AWS OpsWorks CM",
        serviceId: "OpsWorksCM",
        signatureVersion: "v4",
        signingName: "opsworks-cm",
        targetPrefix: "OpsWorksCM_V2016_11_01",
        uid: "opsworkscm-2016-11-01"
      },
      operations: {
        AssociateNode: {
          input: {
            type: "structure",
            required: [
              "ServerName",
              "NodeName",
              "EngineAttributes"
            ],
            members: {
              ServerName: {},
              NodeName: {},
              EngineAttributes: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NodeAssociationStatusToken: {}
            }
          }
        },
        CreateBackup: {
          input: {
            type: "structure",
            required: [
              "ServerName"
            ],
            members: {
              ServerName: {},
              Description: {},
              Tags: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Backup: {
                shape: "Sh"
              }
            }
          }
        },
        CreateServer: {
          input: {
            type: "structure",
            required: [
              "Engine",
              "ServerName",
              "InstanceProfileArn",
              "InstanceType",
              "ServiceRoleArn"
            ],
            members: {
              AssociatePublicIpAddress: {
                type: "boolean"
              },
              CustomDomain: {},
              CustomCertificate: {},
              CustomPrivateKey: {
                type: "string",
                sensitive: true
              },
              DisableAutomatedBackup: {
                type: "boolean"
              },
              Engine: {},
              EngineModel: {},
              EngineVersion: {},
              EngineAttributes: {
                shape: "S4"
              },
              BackupRetentionCount: {
                type: "integer"
              },
              ServerName: {},
              InstanceProfileArn: {},
              InstanceType: {},
              KeyPair: {},
              PreferredMaintenanceWindow: {},
              PreferredBackupWindow: {},
              SecurityGroupIds: {
                shape: "Sn"
              },
              ServiceRoleArn: {},
              SubnetIds: {
                shape: "Sn"
              },
              Tags: {
                shape: "Sc"
              },
              BackupId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Server: {
                shape: "Sz"
              }
            }
          }
        },
        DeleteBackup: {
          input: {
            type: "structure",
            required: [
              "BackupId"
            ],
            members: {
              BackupId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteServer: {
          input: {
            type: "structure",
            required: [
              "ServerName"
            ],
            members: {
              ServerName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeAccountAttributes: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Maximum: {
                      type: "integer"
                    },
                    Used: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeBackups: {
          input: {
            type: "structure",
            members: {
              BackupId: {},
              ServerName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Backups: {
                type: "list",
                member: {
                  shape: "Sh"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeEvents: {
          input: {
            type: "structure",
            required: [
              "ServerName"
            ],
            members: {
              ServerName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ServerEvents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreatedAt: {
                      type: "timestamp"
                    },
                    ServerName: {},
                    Message: {},
                    LogUrl: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeNodeAssociationStatus: {
          input: {
            type: "structure",
            required: [
              "NodeAssociationStatusToken",
              "ServerName"
            ],
            members: {
              NodeAssociationStatusToken: {},
              ServerName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NodeAssociationStatus: {},
              EngineAttributes: {
                shape: "S4"
              }
            }
          }
        },
        DescribeServers: {
          input: {
            type: "structure",
            members: {
              ServerName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Servers: {
                type: "list",
                member: {
                  shape: "Sz"
                }
              },
              NextToken: {}
            }
          }
        },
        DisassociateNode: {
          input: {
            type: "structure",
            required: [
              "ServerName",
              "NodeName"
            ],
            members: {
              ServerName: {},
              NodeName: {},
              EngineAttributes: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NodeAssociationStatusToken: {}
            }
          }
        },
        ExportServerEngineAttribute: {
          input: {
            type: "structure",
            required: [
              "ExportAttributeName",
              "ServerName"
            ],
            members: {
              ExportAttributeName: {},
              ServerName: {},
              InputAttributes: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EngineAttribute: {
                shape: "S5"
              },
              ServerName: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sc"
              },
              NextToken: {}
            }
          }
        },
        RestoreServer: {
          input: {
            type: "structure",
            required: [
              "BackupId",
              "ServerName"
            ],
            members: {
              BackupId: {},
              ServerName: {},
              InstanceType: {},
              KeyPair: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Server: {
                shape: "Sz"
              }
            }
          }
        },
        StartMaintenance: {
          input: {
            type: "structure",
            required: [
              "ServerName"
            ],
            members: {
              ServerName: {},
              EngineAttributes: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Server: {
                shape: "Sz"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateServer: {
          input: {
            type: "structure",
            required: [
              "ServerName"
            ],
            members: {
              DisableAutomatedBackup: {
                type: "boolean"
              },
              BackupRetentionCount: {
                type: "integer"
              },
              ServerName: {},
              PreferredMaintenanceWindow: {},
              PreferredBackupWindow: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Server: {
                shape: "Sz"
              }
            }
          }
        },
        UpdateServerEngineAttributes: {
          input: {
            type: "structure",
            required: [
              "ServerName",
              "AttributeName"
            ],
            members: {
              ServerName: {},
              AttributeName: {},
              AttributeValue: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Server: {
                shape: "Sz"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "list",
          member: {
            shape: "S5"
          }
        },
        S5: {
          type: "structure",
          members: {
            Name: {},
            Value: {
              type: "string",
              sensitive: true
            }
          }
        },
        Sc: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sh: {
          type: "structure",
          members: {
            BackupArn: {},
            BackupId: {},
            BackupType: {},
            CreatedAt: {
              type: "timestamp"
            },
            Description: {},
            Engine: {},
            EngineModel: {},
            EngineVersion: {},
            InstanceProfileArn: {},
            InstanceType: {},
            KeyPair: {},
            PreferredBackupWindow: {},
            PreferredMaintenanceWindow: {},
            S3DataSize: {
              deprecated: true,
              type: "integer"
            },
            S3DataUrl: {
              deprecated: true
            },
            S3LogUrl: {},
            SecurityGroupIds: {
              shape: "Sn"
            },
            ServerName: {},
            ServiceRoleArn: {},
            Status: {},
            StatusDescription: {},
            SubnetIds: {
              shape: "Sn"
            },
            ToolsVersion: {},
            UserArn: {}
          }
        },
        Sn: {
          type: "list",
          member: {}
        },
        Sz: {
          type: "structure",
          members: {
            AssociatePublicIpAddress: {
              type: "boolean"
            },
            BackupRetentionCount: {
              type: "integer"
            },
            ServerName: {},
            CreatedAt: {
              type: "timestamp"
            },
            CloudFormationStackArn: {},
            CustomDomain: {},
            DisableAutomatedBackup: {
              type: "boolean"
            },
            Endpoint: {},
            Engine: {},
            EngineModel: {},
            EngineAttributes: {
              shape: "S4"
            },
            EngineVersion: {},
            InstanceProfileArn: {},
            InstanceType: {},
            KeyPair: {},
            MaintenanceStatus: {},
            PreferredMaintenanceWindow: {},
            PreferredBackupWindow: {},
            SecurityGroupIds: {
              shape: "Sn"
            },
            ServiceRoleArn: {},
            Status: {},
            StatusReason: {},
            SubnetIds: {
              shape: "Sn"
            },
            ServerArn: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/opsworkscm-2016-11-01.paginators.json
var require_opsworkscm_2016_11_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/opsworkscm-2016-11-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeBackups: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Backups"
        },
        DescribeEvents: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ServerEvents"
        },
        DescribeServers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Servers"
        },
        ListTagsForResource: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Tags"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/opsworkscm-2016-11-01.waiters2.json
var require_opsworkscm_2016_11_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/opsworkscm-2016-11-01.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        NodeAssociated: {
          delay: 15,
          maxAttempts: 15,
          operation: "DescribeNodeAssociationStatus",
          description: "Wait until node is associated or disassociated.",
          acceptors: [
            {
              expected: "SUCCESS",
              state: "success",
              matcher: "path",
              argument: "NodeAssociationStatus"
            },
            {
              expected: "FAILED",
              state: "failure",
              matcher: "path",
              argument: "NodeAssociationStatus"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/opsworkscm.js
var require_opsworkscm = __commonJS({
  "node_modules/aws-sdk/clients/opsworkscm.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["opsworkscm"] = {};
    AWS2.OpsWorksCM = Service.defineService("opsworkscm", ["2016-11-01"]);
    Object.defineProperty(apiLoader.services["opsworkscm"], "2016-11-01", {
      get: function get() {
        var model = require_opsworkscm_2016_11_01_min();
        model.paginators = require_opsworkscm_2016_11_01_paginators().pagination;
        model.waiters = require_opsworkscm_2016_11_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.OpsWorksCM;
  }
});

// node_modules/aws-sdk/apis/organizations-2016-11-28.min.json
var require_organizations_2016_11_28_min = __commonJS({
  "node_modules/aws-sdk/apis/organizations-2016-11-28.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-11-28",
        endpointPrefix: "organizations",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Organizations",
        serviceFullName: "AWS Organizations",
        serviceId: "Organizations",
        signatureVersion: "v4",
        targetPrefix: "AWSOrganizationsV20161128",
        uid: "organizations-2016-11-28"
      },
      operations: {
        AcceptHandshake: {
          input: {
            type: "structure",
            required: [
              "HandshakeId"
            ],
            members: {
              HandshakeId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Handshake: {
                shape: "S4"
              }
            }
          }
        },
        AttachPolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyId",
              "TargetId"
            ],
            members: {
              PolicyId: {},
              TargetId: {}
            }
          }
        },
        CancelHandshake: {
          input: {
            type: "structure",
            required: [
              "HandshakeId"
            ],
            members: {
              HandshakeId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Handshake: {
                shape: "S4"
              }
            }
          }
        },
        CloseAccount: {
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {}
            }
          }
        },
        CreateAccount: {
          input: {
            type: "structure",
            required: [
              "Email",
              "AccountName"
            ],
            members: {
              Email: {
                shape: "Sp"
              },
              AccountName: {
                shape: "Sq"
              },
              RoleName: {},
              IamUserAccessToBilling: {},
              Tags: {
                shape: "St"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CreateAccountStatus: {
                shape: "Sy"
              }
            }
          }
        },
        CreateGovCloudAccount: {
          input: {
            type: "structure",
            required: [
              "Email",
              "AccountName"
            ],
            members: {
              Email: {
                shape: "Sp"
              },
              AccountName: {
                shape: "Sq"
              },
              RoleName: {},
              IamUserAccessToBilling: {},
              Tags: {
                shape: "St"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CreateAccountStatus: {
                shape: "Sy"
              }
            }
          }
        },
        CreateOrganization: {
          input: {
            type: "structure",
            members: {
              FeatureSet: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Organization: {
                shape: "S17"
              }
            }
          }
        },
        CreateOrganizationalUnit: {
          input: {
            type: "structure",
            required: [
              "ParentId",
              "Name"
            ],
            members: {
              ParentId: {},
              Name: {},
              Tags: {
                shape: "St"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationalUnit: {
                shape: "S1j"
              }
            }
          }
        },
        CreatePolicy: {
          input: {
            type: "structure",
            required: [
              "Content",
              "Description",
              "Name",
              "Type"
            ],
            members: {
              Content: {},
              Description: {},
              Name: {},
              Type: {},
              Tags: {
                shape: "St"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {
                shape: "S1r"
              }
            }
          }
        },
        DeclineHandshake: {
          input: {
            type: "structure",
            required: [
              "HandshakeId"
            ],
            members: {
              HandshakeId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Handshake: {
                shape: "S4"
              }
            }
          }
        },
        DeleteOrganization: {},
        DeleteOrganizationalUnit: {
          input: {
            type: "structure",
            required: [
              "OrganizationalUnitId"
            ],
            members: {
              OrganizationalUnitId: {}
            }
          }
        },
        DeletePolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyId"
            ],
            members: {
              PolicyId: {}
            }
          }
        },
        DeleteResourcePolicy: {},
        DeregisterDelegatedAdministrator: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "ServicePrincipal"
            ],
            members: {
              AccountId: {},
              ServicePrincipal: {}
            }
          }
        },
        DescribeAccount: {
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Account: {
                shape: "S23"
              }
            }
          }
        },
        DescribeCreateAccountStatus: {
          input: {
            type: "structure",
            required: [
              "CreateAccountRequestId"
            ],
            members: {
              CreateAccountRequestId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CreateAccountStatus: {
                shape: "Sy"
              }
            }
          }
        },
        DescribeEffectivePolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyType"
            ],
            members: {
              PolicyType: {},
              TargetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EffectivePolicy: {
                type: "structure",
                members: {
                  PolicyContent: {},
                  LastUpdatedTimestamp: {
                    type: "timestamp"
                  },
                  TargetId: {},
                  PolicyType: {}
                }
              }
            }
          }
        },
        DescribeHandshake: {
          input: {
            type: "structure",
            required: [
              "HandshakeId"
            ],
            members: {
              HandshakeId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Handshake: {
                shape: "S4"
              }
            }
          }
        },
        DescribeOrganization: {
          output: {
            type: "structure",
            members: {
              Organization: {
                shape: "S17"
              }
            }
          }
        },
        DescribeOrganizationalUnit: {
          input: {
            type: "structure",
            required: [
              "OrganizationalUnitId"
            ],
            members: {
              OrganizationalUnitId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationalUnit: {
                shape: "S1j"
              }
            }
          }
        },
        DescribePolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyId"
            ],
            members: {
              PolicyId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {
                shape: "S1r"
              }
            }
          }
        },
        DescribeResourcePolicy: {
          output: {
            type: "structure",
            members: {
              ResourcePolicy: {
                shape: "S2l"
              }
            }
          }
        },
        DetachPolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyId",
              "TargetId"
            ],
            members: {
              PolicyId: {},
              TargetId: {}
            }
          }
        },
        DisableAWSServiceAccess: {
          input: {
            type: "structure",
            required: [
              "ServicePrincipal"
            ],
            members: {
              ServicePrincipal: {}
            }
          }
        },
        DisablePolicyType: {
          input: {
            type: "structure",
            required: [
              "RootId",
              "PolicyType"
            ],
            members: {
              RootId: {},
              PolicyType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Root: {
                shape: "S2v"
              }
            }
          }
        },
        EnableAWSServiceAccess: {
          input: {
            type: "structure",
            required: [
              "ServicePrincipal"
            ],
            members: {
              ServicePrincipal: {}
            }
          }
        },
        EnableAllFeatures: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              Handshake: {
                shape: "S4"
              }
            }
          }
        },
        EnablePolicyType: {
          input: {
            type: "structure",
            required: [
              "RootId",
              "PolicyType"
            ],
            members: {
              RootId: {},
              PolicyType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Root: {
                shape: "S2v"
              }
            }
          }
        },
        InviteAccountToOrganization: {
          input: {
            type: "structure",
            required: [
              "Target"
            ],
            members: {
              Target: {
                shape: "S7"
              },
              Notes: {
                type: "string",
                sensitive: true
              },
              Tags: {
                shape: "St"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Handshake: {
                shape: "S4"
              }
            }
          }
        },
        LeaveOrganization: {},
        ListAWSServiceAccessForOrganization: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EnabledServicePrincipals: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ServicePrincipal: {},
                    DateEnabled: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListAccounts: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Accounts: {
                shape: "S3e"
              },
              NextToken: {}
            }
          }
        },
        ListAccountsForParent: {
          input: {
            type: "structure",
            required: [
              "ParentId"
            ],
            members: {
              ParentId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Accounts: {
                shape: "S3e"
              },
              NextToken: {}
            }
          }
        },
        ListChildren: {
          input: {
            type: "structure",
            required: [
              "ParentId",
              "ChildType"
            ],
            members: {
              ParentId: {},
              ChildType: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Children: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Type: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListCreateAccountStatus: {
          input: {
            type: "structure",
            members: {
              States: {
                type: "list",
                member: {}
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CreateAccountStatuses: {
                type: "list",
                member: {
                  shape: "Sy"
                }
              },
              NextToken: {}
            }
          }
        },
        ListDelegatedAdministrators: {
          input: {
            type: "structure",
            members: {
              ServicePrincipal: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DelegatedAdministrators: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Email: {
                      shape: "Sp"
                    },
                    Name: {
                      shape: "S24"
                    },
                    Status: {},
                    JoinedMethod: {},
                    JoinedTimestamp: {
                      type: "timestamp"
                    },
                    DelegationEnabledDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDelegatedServicesForAccount: {
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DelegatedServices: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ServicePrincipal: {},
                    DelegationEnabledDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListHandshakesForAccount: {
          input: {
            type: "structure",
            members: {
              Filter: {
                shape: "S40"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Handshakes: {
                shape: "S42"
              },
              NextToken: {}
            }
          }
        },
        ListHandshakesForOrganization: {
          input: {
            type: "structure",
            members: {
              Filter: {
                shape: "S40"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Handshakes: {
                shape: "S42"
              },
              NextToken: {}
            }
          }
        },
        ListOrganizationalUnitsForParent: {
          input: {
            type: "structure",
            required: [
              "ParentId"
            ],
            members: {
              ParentId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationalUnits: {
                type: "list",
                member: {
                  shape: "S1j"
                }
              },
              NextToken: {}
            }
          }
        },
        ListParents: {
          input: {
            type: "structure",
            required: [
              "ChildId"
            ],
            members: {
              ChildId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Parents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Type: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPolicies: {
          input: {
            type: "structure",
            required: [
              "Filter"
            ],
            members: {
              Filter: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policies: {
                shape: "S4f"
              },
              NextToken: {}
            }
          }
        },
        ListPoliciesForTarget: {
          input: {
            type: "structure",
            required: [
              "TargetId",
              "Filter"
            ],
            members: {
              TargetId: {},
              Filter: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policies: {
                shape: "S4f"
              },
              NextToken: {}
            }
          }
        },
        ListRoots: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Roots: {
                type: "list",
                member: {
                  shape: "S2v"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              ResourceId: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "St"
              },
              NextToken: {}
            }
          }
        },
        ListTargetsForPolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyId"
            ],
            members: {
              PolicyId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Targets: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TargetId: {},
                    Arn: {},
                    Name: {},
                    Type: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        MoveAccount: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "SourceParentId",
              "DestinationParentId"
            ],
            members: {
              AccountId: {},
              SourceParentId: {},
              DestinationParentId: {}
            }
          }
        },
        PutResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "Content"
            ],
            members: {
              Content: {},
              Tags: {
                shape: "St"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourcePolicy: {
                shape: "S2l"
              }
            }
          }
        },
        RegisterDelegatedAdministrator: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "ServicePrincipal"
            ],
            members: {
              AccountId: {},
              ServicePrincipal: {}
            }
          }
        },
        RemoveAccountFromOrganization: {
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "Tags"
            ],
            members: {
              ResourceId: {},
              Tags: {
                shape: "St"
              }
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "TagKeys"
            ],
            members: {
              ResourceId: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        },
        UpdateOrganizationalUnit: {
          input: {
            type: "structure",
            required: [
              "OrganizationalUnitId"
            ],
            members: {
              OrganizationalUnitId: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationalUnit: {
                shape: "S1j"
              }
            }
          }
        },
        UpdatePolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyId"
            ],
            members: {
              PolicyId: {},
              Name: {},
              Description: {},
              Content: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {
                shape: "S1r"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            Id: {},
            Arn: {},
            Parties: {
              type: "list",
              member: {
                shape: "S7"
              }
            },
            State: {},
            RequestedTimestamp: {
              type: "timestamp"
            },
            ExpirationTimestamp: {
              type: "timestamp"
            },
            Action: {},
            Resources: {
              shape: "Sd"
            }
          }
        },
        S7: {
          type: "structure",
          required: [
            "Id",
            "Type"
          ],
          members: {
            Id: {
              type: "string",
              sensitive: true
            },
            Type: {}
          }
        },
        Sd: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Value: {
                type: "string",
                sensitive: true
              },
              Type: {},
              Resources: {
                shape: "Sd"
              }
            }
          }
        },
        Sp: {
          type: "string",
          sensitive: true
        },
        Sq: {
          type: "string",
          sensitive: true
        },
        St: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sy: {
          type: "structure",
          members: {
            Id: {},
            AccountName: {
              shape: "Sq"
            },
            State: {},
            RequestedTimestamp: {
              type: "timestamp"
            },
            CompletedTimestamp: {
              type: "timestamp"
            },
            AccountId: {},
            GovCloudAccountId: {},
            FailureReason: {}
          }
        },
        S17: {
          type: "structure",
          members: {
            Id: {},
            Arn: {},
            FeatureSet: {},
            MasterAccountArn: {},
            MasterAccountId: {},
            MasterAccountEmail: {
              shape: "Sp"
            },
            AvailablePolicyTypes: {
              shape: "S1b"
            }
          }
        },
        S1b: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Type: {},
              Status: {}
            }
          }
        },
        S1j: {
          type: "structure",
          members: {
            Id: {},
            Arn: {},
            Name: {}
          }
        },
        S1r: {
          type: "structure",
          members: {
            PolicySummary: {
              shape: "S1s"
            },
            Content: {}
          }
        },
        S1s: {
          type: "structure",
          members: {
            Id: {},
            Arn: {},
            Name: {},
            Description: {},
            Type: {},
            AwsManaged: {
              type: "boolean"
            }
          }
        },
        S23: {
          type: "structure",
          members: {
            Id: {},
            Arn: {},
            Email: {
              shape: "Sp"
            },
            Name: {
              shape: "S24"
            },
            Status: {},
            JoinedMethod: {},
            JoinedTimestamp: {
              type: "timestamp"
            }
          }
        },
        S24: {
          type: "string",
          sensitive: true
        },
        S2l: {
          type: "structure",
          members: {
            ResourcePolicySummary: {
              type: "structure",
              members: {
                Id: {},
                Arn: {}
              }
            },
            Content: {}
          }
        },
        S2v: {
          type: "structure",
          members: {
            Id: {},
            Arn: {},
            Name: {},
            PolicyTypes: {
              shape: "S1b"
            }
          }
        },
        S3e: {
          type: "list",
          member: {
            shape: "S23"
          }
        },
        S40: {
          type: "structure",
          members: {
            ActionType: {},
            ParentHandshakeId: {}
          }
        },
        S42: {
          type: "list",
          member: {
            shape: "S4"
          }
        },
        S4f: {
          type: "list",
          member: {
            shape: "S1s"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/organizations-2016-11-28.paginators.json
var require_organizations_2016_11_28_paginators = __commonJS({
  "node_modules/aws-sdk/apis/organizations-2016-11-28.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAWSServiceAccessForOrganization: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListAccounts: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListAccountsForParent: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListChildren: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListCreateAccountStatus: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListDelegatedAdministrators: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "DelegatedAdministrators"
        },
        ListDelegatedServicesForAccount: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "DelegatedServices"
        },
        ListHandshakesForAccount: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListHandshakesForOrganization: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListOrganizationalUnitsForParent: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListParents: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListPolicies: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListPoliciesForTarget: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListRoots: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListTagsForResource: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Tags"
        },
        ListTargetsForPolicy: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/organizations.js
var require_organizations = __commonJS({
  "node_modules/aws-sdk/clients/organizations.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["organizations"] = {};
    AWS2.Organizations = Service.defineService("organizations", ["2016-11-28"]);
    Object.defineProperty(apiLoader.services["organizations"], "2016-11-28", {
      get: function get() {
        var model = require_organizations_2016_11_28_min();
        model.paginators = require_organizations_2016_11_28_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Organizations;
  }
});

// node_modules/aws-sdk/apis/pinpoint-2016-12-01.min.json
var require_pinpoint_2016_12_01_min = __commonJS({
  "node_modules/aws-sdk/apis/pinpoint-2016-12-01.min.json"(exports2, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2016-12-01",
        endpointPrefix: "pinpoint",
        signingName: "mobiletargeting",
        serviceFullName: "Amazon Pinpoint",
        serviceId: "Pinpoint",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "pinpoint-2016-12-01",
        signatureVersion: "v4"
      },
      operations: {
        CreateApp: {
          http: {
            requestUri: "/v1/apps",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              CreateApplicationRequest: {
                type: "structure",
                members: {
                  Name: {},
                  tags: {
                    shape: "S4",
                    locationName: "tags"
                  }
                },
                required: [
                  "Name"
                ]
              }
            },
            required: [
              "CreateApplicationRequest"
            ],
            payload: "CreateApplicationRequest"
          },
          output: {
            type: "structure",
            members: {
              ApplicationResponse: {
                shape: "S6"
              }
            },
            required: [
              "ApplicationResponse"
            ],
            payload: "ApplicationResponse"
          }
        },
        CreateCampaign: {
          http: {
            requestUri: "/v1/apps/{application-id}/campaigns",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              WriteCampaignRequest: {
                shape: "S8"
              }
            },
            required: [
              "ApplicationId",
              "WriteCampaignRequest"
            ],
            payload: "WriteCampaignRequest"
          },
          output: {
            type: "structure",
            members: {
              CampaignResponse: {
                shape: "S1j"
              }
            },
            required: [
              "CampaignResponse"
            ],
            payload: "CampaignResponse"
          }
        },
        CreateEmailTemplate: {
          http: {
            requestUri: "/v1/templates/{template-name}/email",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              EmailTemplateRequest: {
                shape: "S1p"
              },
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              }
            },
            required: [
              "TemplateName",
              "EmailTemplateRequest"
            ],
            payload: "EmailTemplateRequest"
          },
          output: {
            type: "structure",
            members: {
              CreateTemplateMessageBody: {
                shape: "S1r"
              }
            },
            required: [
              "CreateTemplateMessageBody"
            ],
            payload: "CreateTemplateMessageBody"
          }
        },
        CreateExportJob: {
          http: {
            requestUri: "/v1/apps/{application-id}/jobs/export",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              ExportJobRequest: {
                type: "structure",
                members: {
                  RoleArn: {},
                  S3UrlPrefix: {},
                  SegmentId: {},
                  SegmentVersion: {
                    type: "integer"
                  }
                },
                required: [
                  "S3UrlPrefix",
                  "RoleArn"
                ]
              }
            },
            required: [
              "ApplicationId",
              "ExportJobRequest"
            ],
            payload: "ExportJobRequest"
          },
          output: {
            type: "structure",
            members: {
              ExportJobResponse: {
                shape: "S1v"
              }
            },
            required: [
              "ExportJobResponse"
            ],
            payload: "ExportJobResponse"
          }
        },
        CreateImportJob: {
          http: {
            requestUri: "/v1/apps/{application-id}/jobs/import",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              ImportJobRequest: {
                type: "structure",
                members: {
                  DefineSegment: {
                    type: "boolean"
                  },
                  ExternalId: {},
                  Format: {},
                  RegisterEndpoints: {
                    type: "boolean"
                  },
                  RoleArn: {},
                  S3Url: {},
                  SegmentId: {},
                  SegmentName: {}
                },
                required: [
                  "Format",
                  "S3Url",
                  "RoleArn"
                ]
              }
            },
            required: [
              "ApplicationId",
              "ImportJobRequest"
            ],
            payload: "ImportJobRequest"
          },
          output: {
            type: "structure",
            members: {
              ImportJobResponse: {
                shape: "S22"
              }
            },
            required: [
              "ImportJobResponse"
            ],
            payload: "ImportJobResponse"
          }
        },
        CreateInAppTemplate: {
          http: {
            requestUri: "/v1/templates/{template-name}/inapp",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              InAppTemplateRequest: {
                shape: "S25"
              },
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              }
            },
            required: [
              "TemplateName",
              "InAppTemplateRequest"
            ],
            payload: "InAppTemplateRequest"
          },
          output: {
            type: "structure",
            members: {
              TemplateCreateMessageBody: {
                type: "structure",
                members: {
                  Arn: {},
                  Message: {},
                  RequestID: {}
                }
              }
            },
            required: [
              "TemplateCreateMessageBody"
            ],
            payload: "TemplateCreateMessageBody"
          }
        },
        CreateJourney: {
          http: {
            requestUri: "/v1/apps/{application-id}/journeys",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              WriteJourneyRequest: {
                shape: "S29"
              }
            },
            required: [
              "ApplicationId",
              "WriteJourneyRequest"
            ],
            payload: "WriteJourneyRequest"
          },
          output: {
            type: "structure",
            members: {
              JourneyResponse: {
                shape: "S3u"
              }
            },
            required: [
              "JourneyResponse"
            ],
            payload: "JourneyResponse"
          }
        },
        CreatePushTemplate: {
          http: {
            requestUri: "/v1/templates/{template-name}/push",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              PushNotificationTemplateRequest: {
                shape: "S3w"
              },
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              }
            },
            required: [
              "TemplateName",
              "PushNotificationTemplateRequest"
            ],
            payload: "PushNotificationTemplateRequest"
          },
          output: {
            type: "structure",
            members: {
              CreateTemplateMessageBody: {
                shape: "S1r"
              }
            },
            required: [
              "CreateTemplateMessageBody"
            ],
            payload: "CreateTemplateMessageBody"
          }
        },
        CreateRecommenderConfiguration: {
          http: {
            requestUri: "/v1/recommenders",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              CreateRecommenderConfiguration: {
                type: "structure",
                members: {
                  Attributes: {
                    shape: "S4"
                  },
                  Description: {},
                  Name: {},
                  RecommendationProviderIdType: {},
                  RecommendationProviderRoleArn: {},
                  RecommendationProviderUri: {},
                  RecommendationTransformerUri: {},
                  RecommendationsDisplayName: {},
                  RecommendationsPerMessage: {
                    type: "integer"
                  }
                },
                required: [
                  "RecommendationProviderUri",
                  "RecommendationProviderRoleArn"
                ]
              }
            },
            required: [
              "CreateRecommenderConfiguration"
            ],
            payload: "CreateRecommenderConfiguration"
          },
          output: {
            type: "structure",
            members: {
              RecommenderConfigurationResponse: {
                shape: "S44"
              }
            },
            required: [
              "RecommenderConfigurationResponse"
            ],
            payload: "RecommenderConfigurationResponse"
          }
        },
        CreateSegment: {
          http: {
            requestUri: "/v1/apps/{application-id}/segments",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              WriteSegmentRequest: {
                shape: "S46"
              }
            },
            required: [
              "ApplicationId",
              "WriteSegmentRequest"
            ],
            payload: "WriteSegmentRequest"
          },
          output: {
            type: "structure",
            members: {
              SegmentResponse: {
                shape: "S4h"
              }
            },
            required: [
              "SegmentResponse"
            ],
            payload: "SegmentResponse"
          }
        },
        CreateSmsTemplate: {
          http: {
            requestUri: "/v1/templates/{template-name}/sms",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              SMSTemplateRequest: {
                shape: "S4m"
              },
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              }
            },
            required: [
              "TemplateName",
              "SMSTemplateRequest"
            ],
            payload: "SMSTemplateRequest"
          },
          output: {
            type: "structure",
            members: {
              CreateTemplateMessageBody: {
                shape: "S1r"
              }
            },
            required: [
              "CreateTemplateMessageBody"
            ],
            payload: "CreateTemplateMessageBody"
          }
        },
        CreateVoiceTemplate: {
          http: {
            requestUri: "/v1/templates/{template-name}/voice",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              VoiceTemplateRequest: {
                shape: "S4p"
              }
            },
            required: [
              "TemplateName",
              "VoiceTemplateRequest"
            ],
            payload: "VoiceTemplateRequest"
          },
          output: {
            type: "structure",
            members: {
              CreateTemplateMessageBody: {
                shape: "S1r"
              }
            },
            required: [
              "CreateTemplateMessageBody"
            ],
            payload: "CreateTemplateMessageBody"
          }
        },
        DeleteAdmChannel: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/channels/adm",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ADMChannelResponse: {
                shape: "S4t"
              }
            },
            required: [
              "ADMChannelResponse"
            ],
            payload: "ADMChannelResponse"
          }
        },
        DeleteApnsChannel: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/channels/apns",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              APNSChannelResponse: {
                shape: "S4w"
              }
            },
            required: [
              "APNSChannelResponse"
            ],
            payload: "APNSChannelResponse"
          }
        },
        DeleteApnsSandboxChannel: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/channels/apns_sandbox",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              APNSSandboxChannelResponse: {
                shape: "S4z"
              }
            },
            required: [
              "APNSSandboxChannelResponse"
            ],
            payload: "APNSSandboxChannelResponse"
          }
        },
        DeleteApnsVoipChannel: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/channels/apns_voip",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              APNSVoipChannelResponse: {
                shape: "S52"
              }
            },
            required: [
              "APNSVoipChannelResponse"
            ],
            payload: "APNSVoipChannelResponse"
          }
        },
        DeleteApnsVoipSandboxChannel: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/channels/apns_voip_sandbox",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              APNSVoipSandboxChannelResponse: {
                shape: "S55"
              }
            },
            required: [
              "APNSVoipSandboxChannelResponse"
            ],
            payload: "APNSVoipSandboxChannelResponse"
          }
        },
        DeleteApp: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApplicationResponse: {
                shape: "S6"
              }
            },
            required: [
              "ApplicationResponse"
            ],
            payload: "ApplicationResponse"
          }
        },
        DeleteBaiduChannel: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/channels/baidu",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              BaiduChannelResponse: {
                shape: "S5a"
              }
            },
            required: [
              "BaiduChannelResponse"
            ],
            payload: "BaiduChannelResponse"
          }
        },
        DeleteCampaign: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/campaigns/{campaign-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              CampaignId: {
                location: "uri",
                locationName: "campaign-id"
              }
            },
            required: [
              "CampaignId",
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              CampaignResponse: {
                shape: "S1j"
              }
            },
            required: [
              "CampaignResponse"
            ],
            payload: "CampaignResponse"
          }
        },
        DeleteEmailChannel: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/channels/email",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              EmailChannelResponse: {
                shape: "S5f"
              }
            },
            required: [
              "EmailChannelResponse"
            ],
            payload: "EmailChannelResponse"
          }
        },
        DeleteEmailTemplate: {
          http: {
            method: "DELETE",
            requestUri: "/v1/templates/{template-name}/email",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              Version: {
                location: "querystring",
                locationName: "version"
              }
            },
            required: [
              "TemplateName"
            ]
          },
          output: {
            type: "structure",
            members: {
              MessageBody: {
                shape: "S5i"
              }
            },
            required: [
              "MessageBody"
            ],
            payload: "MessageBody"
          }
        },
        DeleteEndpoint: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/endpoints/{endpoint-id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              EndpointId: {
                location: "uri",
                locationName: "endpoint-id"
              }
            },
            required: [
              "ApplicationId",
              "EndpointId"
            ]
          },
          output: {
            type: "structure",
            members: {
              EndpointResponse: {
                shape: "S5l"
              }
            },
            required: [
              "EndpointResponse"
            ],
            payload: "EndpointResponse"
          }
        },
        DeleteEventStream: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/eventstream",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              EventStream: {
                shape: "S5u"
              }
            },
            required: [
              "EventStream"
            ],
            payload: "EventStream"
          }
        },
        DeleteGcmChannel: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/channels/gcm",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              GCMChannelResponse: {
                shape: "S5x"
              }
            },
            required: [
              "GCMChannelResponse"
            ],
            payload: "GCMChannelResponse"
          }
        },
        DeleteInAppTemplate: {
          http: {
            method: "DELETE",
            requestUri: "/v1/templates/{template-name}/inapp",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              Version: {
                location: "querystring",
                locationName: "version"
              }
            },
            required: [
              "TemplateName"
            ]
          },
          output: {
            type: "structure",
            members: {
              MessageBody: {
                shape: "S5i"
              }
            },
            required: [
              "MessageBody"
            ],
            payload: "MessageBody"
          }
        },
        DeleteJourney: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/journeys/{journey-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              JourneyId: {
                location: "uri",
                locationName: "journey-id"
              }
            },
            required: [
              "JourneyId",
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              JourneyResponse: {
                shape: "S3u"
              }
            },
            required: [
              "JourneyResponse"
            ],
            payload: "JourneyResponse"
          }
        },
        DeletePushTemplate: {
          http: {
            method: "DELETE",
            requestUri: "/v1/templates/{template-name}/push",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              Version: {
                location: "querystring",
                locationName: "version"
              }
            },
            required: [
              "TemplateName"
            ]
          },
          output: {
            type: "structure",
            members: {
              MessageBody: {
                shape: "S5i"
              }
            },
            required: [
              "MessageBody"
            ],
            payload: "MessageBody"
          }
        },
        DeleteRecommenderConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/v1/recommenders/{recommender-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              RecommenderId: {
                location: "uri",
                locationName: "recommender-id"
              }
            },
            required: [
              "RecommenderId"
            ]
          },
          output: {
            type: "structure",
            members: {
              RecommenderConfigurationResponse: {
                shape: "S44"
              }
            },
            required: [
              "RecommenderConfigurationResponse"
            ],
            payload: "RecommenderConfigurationResponse"
          }
        },
        DeleteSegment: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/segments/{segment-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              SegmentId: {
                location: "uri",
                locationName: "segment-id"
              }
            },
            required: [
              "SegmentId",
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              SegmentResponse: {
                shape: "S4h"
              }
            },
            required: [
              "SegmentResponse"
            ],
            payload: "SegmentResponse"
          }
        },
        DeleteSmsChannel: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/channels/sms",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              SMSChannelResponse: {
                shape: "S6a"
              }
            },
            required: [
              "SMSChannelResponse"
            ],
            payload: "SMSChannelResponse"
          }
        },
        DeleteSmsTemplate: {
          http: {
            method: "DELETE",
            requestUri: "/v1/templates/{template-name}/sms",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              Version: {
                location: "querystring",
                locationName: "version"
              }
            },
            required: [
              "TemplateName"
            ]
          },
          output: {
            type: "structure",
            members: {
              MessageBody: {
                shape: "S5i"
              }
            },
            required: [
              "MessageBody"
            ],
            payload: "MessageBody"
          }
        },
        DeleteUserEndpoints: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/users/{user-id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              UserId: {
                location: "uri",
                locationName: "user-id"
              }
            },
            required: [
              "ApplicationId",
              "UserId"
            ]
          },
          output: {
            type: "structure",
            members: {
              EndpointsResponse: {
                shape: "S6f"
              }
            },
            required: [
              "EndpointsResponse"
            ],
            payload: "EndpointsResponse"
          }
        },
        DeleteVoiceChannel: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/channels/voice",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              VoiceChannelResponse: {
                shape: "S6j"
              }
            },
            required: [
              "VoiceChannelResponse"
            ],
            payload: "VoiceChannelResponse"
          }
        },
        DeleteVoiceTemplate: {
          http: {
            method: "DELETE",
            requestUri: "/v1/templates/{template-name}/voice",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              Version: {
                location: "querystring",
                locationName: "version"
              }
            },
            required: [
              "TemplateName"
            ]
          },
          output: {
            type: "structure",
            members: {
              MessageBody: {
                shape: "S5i"
              }
            },
            required: [
              "MessageBody"
            ],
            payload: "MessageBody"
          }
        },
        GetAdmChannel: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/channels/adm",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ADMChannelResponse: {
                shape: "S4t"
              }
            },
            required: [
              "ADMChannelResponse"
            ],
            payload: "ADMChannelResponse"
          }
        },
        GetApnsChannel: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/channels/apns",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              APNSChannelResponse: {
                shape: "S4w"
              }
            },
            required: [
              "APNSChannelResponse"
            ],
            payload: "APNSChannelResponse"
          }
        },
        GetApnsSandboxChannel: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/channels/apns_sandbox",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              APNSSandboxChannelResponse: {
                shape: "S4z"
              }
            },
            required: [
              "APNSSandboxChannelResponse"
            ],
            payload: "APNSSandboxChannelResponse"
          }
        },
        GetApnsVoipChannel: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/channels/apns_voip",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              APNSVoipChannelResponse: {
                shape: "S52"
              }
            },
            required: [
              "APNSVoipChannelResponse"
            ],
            payload: "APNSVoipChannelResponse"
          }
        },
        GetApnsVoipSandboxChannel: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/channels/apns_voip_sandbox",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              APNSVoipSandboxChannelResponse: {
                shape: "S55"
              }
            },
            required: [
              "APNSVoipSandboxChannelResponse"
            ],
            payload: "APNSVoipSandboxChannelResponse"
          }
        },
        GetApp: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApplicationResponse: {
                shape: "S6"
              }
            },
            required: [
              "ApplicationResponse"
            ],
            payload: "ApplicationResponse"
          }
        },
        GetApplicationDateRangeKpi: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/kpis/daterange/{kpi-name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              EndTime: {
                shape: "S3d",
                location: "querystring",
                locationName: "end-time"
              },
              KpiName: {
                location: "uri",
                locationName: "kpi-name"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              StartTime: {
                shape: "S3d",
                location: "querystring",
                locationName: "start-time"
              }
            },
            required: [
              "ApplicationId",
              "KpiName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApplicationDateRangeKpiResponse: {
                type: "structure",
                members: {
                  ApplicationId: {},
                  EndTime: {
                    shape: "S3d"
                  },
                  KpiName: {},
                  KpiResult: {
                    shape: "S71"
                  },
                  NextToken: {},
                  StartTime: {
                    shape: "S3d"
                  }
                },
                required: [
                  "KpiResult",
                  "KpiName",
                  "EndTime",
                  "StartTime",
                  "ApplicationId"
                ]
              }
            },
            required: [
              "ApplicationDateRangeKpiResponse"
            ],
            payload: "ApplicationDateRangeKpiResponse"
          }
        },
        GetApplicationSettings: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/settings",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApplicationSettingsResource: {
                shape: "S78"
              }
            },
            required: [
              "ApplicationSettingsResource"
            ],
            payload: "ApplicationSettingsResource"
          }
        },
        GetApps: {
          http: {
            method: "GET",
            requestUri: "/v1/apps",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              Token: {
                location: "querystring",
                locationName: "token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationsResponse: {
                type: "structure",
                members: {
                  Item: {
                    type: "list",
                    member: {
                      shape: "S6"
                    }
                  },
                  NextToken: {}
                }
              }
            },
            required: [
              "ApplicationsResponse"
            ],
            payload: "ApplicationsResponse"
          }
        },
        GetBaiduChannel: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/channels/baidu",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              BaiduChannelResponse: {
                shape: "S5a"
              }
            },
            required: [
              "BaiduChannelResponse"
            ],
            payload: "BaiduChannelResponse"
          }
        },
        GetCampaign: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/campaigns/{campaign-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              CampaignId: {
                location: "uri",
                locationName: "campaign-id"
              }
            },
            required: [
              "CampaignId",
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              CampaignResponse: {
                shape: "S1j"
              }
            },
            required: [
              "CampaignResponse"
            ],
            payload: "CampaignResponse"
          }
        },
        GetCampaignActivities: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/campaigns/{campaign-id}/activities",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              CampaignId: {
                location: "uri",
                locationName: "campaign-id"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              Token: {
                location: "querystring",
                locationName: "token"
              }
            },
            required: [
              "ApplicationId",
              "CampaignId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ActivitiesResponse: {
                type: "structure",
                members: {
                  Item: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        ApplicationId: {},
                        CampaignId: {},
                        End: {},
                        Id: {},
                        Result: {},
                        ScheduledStart: {},
                        Start: {},
                        State: {},
                        SuccessfulEndpointCount: {
                          type: "integer"
                        },
                        TimezonesCompletedCount: {
                          type: "integer"
                        },
                        TimezonesTotalCount: {
                          type: "integer"
                        },
                        TotalEndpointCount: {
                          type: "integer"
                        },
                        TreatmentId: {},
                        ExecutionMetrics: {
                          shape: "S4"
                        }
                      },
                      required: [
                        "CampaignId",
                        "Id",
                        "ApplicationId"
                      ]
                    }
                  },
                  NextToken: {}
                },
                required: [
                  "Item"
                ]
              }
            },
            required: [
              "ActivitiesResponse"
            ],
            payload: "ActivitiesResponse"
          }
        },
        GetCampaignDateRangeKpi: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/campaigns/{campaign-id}/kpis/daterange/{kpi-name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              CampaignId: {
                location: "uri",
                locationName: "campaign-id"
              },
              EndTime: {
                shape: "S3d",
                location: "querystring",
                locationName: "end-time"
              },
              KpiName: {
                location: "uri",
                locationName: "kpi-name"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              StartTime: {
                shape: "S3d",
                location: "querystring",
                locationName: "start-time"
              }
            },
            required: [
              "ApplicationId",
              "KpiName",
              "CampaignId"
            ]
          },
          output: {
            type: "structure",
            members: {
              CampaignDateRangeKpiResponse: {
                type: "structure",
                members: {
                  ApplicationId: {},
                  CampaignId: {},
                  EndTime: {
                    shape: "S3d"
                  },
                  KpiName: {},
                  KpiResult: {
                    shape: "S71"
                  },
                  NextToken: {},
                  StartTime: {
                    shape: "S3d"
                  }
                },
                required: [
                  "KpiResult",
                  "KpiName",
                  "EndTime",
                  "CampaignId",
                  "StartTime",
                  "ApplicationId"
                ]
              }
            },
            required: [
              "CampaignDateRangeKpiResponse"
            ],
            payload: "CampaignDateRangeKpiResponse"
          }
        },
        GetCampaignVersion: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/campaigns/{campaign-id}/versions/{version}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              CampaignId: {
                location: "uri",
                locationName: "campaign-id"
              },
              Version: {
                location: "uri",
                locationName: "version"
              }
            },
            required: [
              "Version",
              "ApplicationId",
              "CampaignId"
            ]
          },
          output: {
            type: "structure",
            members: {
              CampaignResponse: {
                shape: "S1j"
              }
            },
            required: [
              "CampaignResponse"
            ],
            payload: "CampaignResponse"
          }
        },
        GetCampaignVersions: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/campaigns/{campaign-id}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              CampaignId: {
                location: "uri",
                locationName: "campaign-id"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              Token: {
                location: "querystring",
                locationName: "token"
              }
            },
            required: [
              "ApplicationId",
              "CampaignId"
            ]
          },
          output: {
            type: "structure",
            members: {
              CampaignsResponse: {
                shape: "S7u"
              }
            },
            required: [
              "CampaignsResponse"
            ],
            payload: "CampaignsResponse"
          }
        },
        GetCampaigns: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/campaigns",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              Token: {
                location: "querystring",
                locationName: "token"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              CampaignsResponse: {
                shape: "S7u"
              }
            },
            required: [
              "CampaignsResponse"
            ],
            payload: "CampaignsResponse"
          }
        },
        GetChannels: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/channels",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ChannelsResponse: {
                type: "structure",
                members: {
                  Channels: {
                    type: "map",
                    key: {},
                    value: {
                      type: "structure",
                      members: {
                        ApplicationId: {},
                        CreationDate: {},
                        Enabled: {
                          type: "boolean"
                        },
                        HasCredential: {
                          type: "boolean"
                        },
                        Id: {},
                        IsArchived: {
                          type: "boolean"
                        },
                        LastModifiedBy: {},
                        LastModifiedDate: {},
                        Version: {
                          type: "integer"
                        }
                      }
                    }
                  }
                },
                required: [
                  "Channels"
                ]
              }
            },
            required: [
              "ChannelsResponse"
            ],
            payload: "ChannelsResponse"
          }
        },
        GetEmailChannel: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/channels/email",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              EmailChannelResponse: {
                shape: "S5f"
              }
            },
            required: [
              "EmailChannelResponse"
            ],
            payload: "EmailChannelResponse"
          }
        },
        GetEmailTemplate: {
          http: {
            method: "GET",
            requestUri: "/v1/templates/{template-name}/email",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              Version: {
                location: "querystring",
                locationName: "version"
              }
            },
            required: [
              "TemplateName"
            ]
          },
          output: {
            type: "structure",
            members: {
              EmailTemplateResponse: {
                type: "structure",
                members: {
                  Arn: {},
                  CreationDate: {},
                  DefaultSubstitutions: {},
                  HtmlPart: {},
                  LastModifiedDate: {},
                  RecommenderId: {},
                  Subject: {},
                  tags: {
                    shape: "S4",
                    locationName: "tags"
                  },
                  TemplateDescription: {},
                  TemplateName: {},
                  TemplateType: {},
                  TextPart: {},
                  Version: {}
                },
                required: [
                  "LastModifiedDate",
                  "CreationDate",
                  "TemplateName",
                  "TemplateType"
                ]
              }
            },
            required: [
              "EmailTemplateResponse"
            ],
            payload: "EmailTemplateResponse"
          }
        },
        GetEndpoint: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/endpoints/{endpoint-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              EndpointId: {
                location: "uri",
                locationName: "endpoint-id"
              }
            },
            required: [
              "ApplicationId",
              "EndpointId"
            ]
          },
          output: {
            type: "structure",
            members: {
              EndpointResponse: {
                shape: "S5l"
              }
            },
            required: [
              "EndpointResponse"
            ],
            payload: "EndpointResponse"
          }
        },
        GetEventStream: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/eventstream",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              EventStream: {
                shape: "S5u"
              }
            },
            required: [
              "EventStream"
            ],
            payload: "EventStream"
          }
        },
        GetExportJob: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/jobs/export/{job-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              JobId: {
                location: "uri",
                locationName: "job-id"
              }
            },
            required: [
              "ApplicationId",
              "JobId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ExportJobResponse: {
                shape: "S1v"
              }
            },
            required: [
              "ExportJobResponse"
            ],
            payload: "ExportJobResponse"
          }
        },
        GetExportJobs: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/jobs/export",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              Token: {
                location: "querystring",
                locationName: "token"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ExportJobsResponse: {
                shape: "S8h"
              }
            },
            required: [
              "ExportJobsResponse"
            ],
            payload: "ExportJobsResponse"
          }
        },
        GetGcmChannel: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/channels/gcm",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              GCMChannelResponse: {
                shape: "S5x"
              }
            },
            required: [
              "GCMChannelResponse"
            ],
            payload: "GCMChannelResponse"
          }
        },
        GetImportJob: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/jobs/import/{job-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              JobId: {
                location: "uri",
                locationName: "job-id"
              }
            },
            required: [
              "ApplicationId",
              "JobId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ImportJobResponse: {
                shape: "S22"
              }
            },
            required: [
              "ImportJobResponse"
            ],
            payload: "ImportJobResponse"
          }
        },
        GetImportJobs: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/jobs/import",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              Token: {
                location: "querystring",
                locationName: "token"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ImportJobsResponse: {
                shape: "S8p"
              }
            },
            required: [
              "ImportJobsResponse"
            ],
            payload: "ImportJobsResponse"
          }
        },
        GetInAppMessages: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/endpoints/{endpoint-id}/inappmessages",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              EndpointId: {
                location: "uri",
                locationName: "endpoint-id"
              }
            },
            required: [
              "ApplicationId",
              "EndpointId"
            ]
          },
          output: {
            type: "structure",
            members: {
              InAppMessagesResponse: {
                type: "structure",
                members: {
                  InAppMessageCampaigns: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        CampaignId: {},
                        DailyCap: {
                          type: "integer"
                        },
                        InAppMessage: {
                          type: "structure",
                          members: {
                            Content: {
                              shape: "So"
                            },
                            CustomConfig: {
                              shape: "S4"
                            },
                            Layout: {}
                          }
                        },
                        Priority: {
                          type: "integer"
                        },
                        Schedule: {
                          type: "structure",
                          members: {
                            EndDate: {},
                            EventFilter: {
                              shape: "Sz"
                            },
                            QuietTime: {
                              shape: "S1c"
                            }
                          }
                        },
                        SessionCap: {
                          type: "integer"
                        },
                        TotalCap: {
                          type: "integer"
                        },
                        TreatmentId: {}
                      }
                    }
                  }
                }
              }
            },
            required: [
              "InAppMessagesResponse"
            ],
            payload: "InAppMessagesResponse"
          }
        },
        GetInAppTemplate: {
          http: {
            method: "GET",
            requestUri: "/v1/templates/{template-name}/inapp",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              Version: {
                location: "querystring",
                locationName: "version"
              }
            },
            required: [
              "TemplateName"
            ]
          },
          output: {
            type: "structure",
            members: {
              InAppTemplateResponse: {
                type: "structure",
                members: {
                  Arn: {},
                  Content: {
                    shape: "So"
                  },
                  CreationDate: {},
                  CustomConfig: {
                    shape: "S4"
                  },
                  LastModifiedDate: {},
                  Layout: {},
                  tags: {
                    shape: "S4",
                    locationName: "tags"
                  },
                  TemplateDescription: {},
                  TemplateName: {},
                  TemplateType: {},
                  Version: {}
                },
                required: [
                  "LastModifiedDate",
                  "CreationDate",
                  "TemplateName",
                  "TemplateType"
                ]
              }
            },
            required: [
              "InAppTemplateResponse"
            ],
            payload: "InAppTemplateResponse"
          }
        },
        GetJourney: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/journeys/{journey-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              JourneyId: {
                location: "uri",
                locationName: "journey-id"
              }
            },
            required: [
              "JourneyId",
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              JourneyResponse: {
                shape: "S3u"
              }
            },
            required: [
              "JourneyResponse"
            ],
            payload: "JourneyResponse"
          }
        },
        GetJourneyDateRangeKpi: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/journeys/{journey-id}/kpis/daterange/{kpi-name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              EndTime: {
                shape: "S3d",
                location: "querystring",
                locationName: "end-time"
              },
              JourneyId: {
                location: "uri",
                locationName: "journey-id"
              },
              KpiName: {
                location: "uri",
                locationName: "kpi-name"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              StartTime: {
                shape: "S3d",
                location: "querystring",
                locationName: "start-time"
              }
            },
            required: [
              "JourneyId",
              "ApplicationId",
              "KpiName"
            ]
          },
          output: {
            type: "structure",
            members: {
              JourneyDateRangeKpiResponse: {
                type: "structure",
                members: {
                  ApplicationId: {},
                  EndTime: {
                    shape: "S3d"
                  },
                  JourneyId: {},
                  KpiName: {},
                  KpiResult: {
                    shape: "S71"
                  },
                  NextToken: {},
                  StartTime: {
                    shape: "S3d"
                  }
                },
                required: [
                  "KpiResult",
                  "KpiName",
                  "JourneyId",
                  "EndTime",
                  "StartTime",
                  "ApplicationId"
                ]
              }
            },
            required: [
              "JourneyDateRangeKpiResponse"
            ],
            payload: "JourneyDateRangeKpiResponse"
          }
        },
        GetJourneyExecutionActivityMetrics: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/journeys/{journey-id}/activities/{journey-activity-id}/execution-metrics",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              JourneyActivityId: {
                location: "uri",
                locationName: "journey-activity-id"
              },
              JourneyId: {
                location: "uri",
                locationName: "journey-id"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              }
            },
            required: [
              "JourneyActivityId",
              "ApplicationId",
              "JourneyId"
            ]
          },
          output: {
            type: "structure",
            members: {
              JourneyExecutionActivityMetricsResponse: {
                type: "structure",
                members: {
                  ActivityType: {},
                  ApplicationId: {},
                  JourneyActivityId: {},
                  JourneyId: {},
                  LastEvaluatedTime: {},
                  Metrics: {
                    shape: "S4"
                  }
                },
                required: [
                  "Metrics",
                  "JourneyId",
                  "LastEvaluatedTime",
                  "JourneyActivityId",
                  "ActivityType",
                  "ApplicationId"
                ]
              }
            },
            required: [
              "JourneyExecutionActivityMetricsResponse"
            ],
            payload: "JourneyExecutionActivityMetricsResponse"
          }
        },
        GetJourneyExecutionMetrics: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/journeys/{journey-id}/execution-metrics",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              JourneyId: {
                location: "uri",
                locationName: "journey-id"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              }
            },
            required: [
              "ApplicationId",
              "JourneyId"
            ]
          },
          output: {
            type: "structure",
            members: {
              JourneyExecutionMetricsResponse: {
                type: "structure",
                members: {
                  ApplicationId: {},
                  JourneyId: {},
                  LastEvaluatedTime: {},
                  Metrics: {
                    shape: "S4"
                  }
                },
                required: [
                  "Metrics",
                  "JourneyId",
                  "LastEvaluatedTime",
                  "ApplicationId"
                ]
              }
            },
            required: [
              "JourneyExecutionMetricsResponse"
            ],
            payload: "JourneyExecutionMetricsResponse"
          }
        },
        GetJourneyRunExecutionActivityMetrics: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/journeys/{journey-id}/runs/{run-id}/activities/{journey-activity-id}/execution-metrics",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              JourneyActivityId: {
                location: "uri",
                locationName: "journey-activity-id"
              },
              JourneyId: {
                location: "uri",
                locationName: "journey-id"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              RunId: {
                location: "uri",
                locationName: "run-id"
              }
            },
            required: [
              "RunId",
              "JourneyActivityId",
              "JourneyId",
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              JourneyRunExecutionActivityMetricsResponse: {
                type: "structure",
                members: {
                  ActivityType: {},
                  ApplicationId: {},
                  JourneyActivityId: {},
                  JourneyId: {},
                  LastEvaluatedTime: {},
                  Metrics: {
                    shape: "S4"
                  },
                  RunId: {}
                },
                required: [
                  "Metrics",
                  "JourneyId",
                  "LastEvaluatedTime",
                  "JourneyActivityId",
                  "ActivityType",
                  "RunId",
                  "ApplicationId"
                ]
              }
            },
            required: [
              "JourneyRunExecutionActivityMetricsResponse"
            ],
            payload: "JourneyRunExecutionActivityMetricsResponse"
          }
        },
        GetJourneyRunExecutionMetrics: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/journeys/{journey-id}/runs/{run-id}/execution-metrics",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              JourneyId: {
                location: "uri",
                locationName: "journey-id"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              RunId: {
                location: "uri",
                locationName: "run-id"
              }
            },
            required: [
              "RunId",
              "ApplicationId",
              "JourneyId"
            ]
          },
          output: {
            type: "structure",
            members: {
              JourneyRunExecutionMetricsResponse: {
                type: "structure",
                members: {
                  ApplicationId: {},
                  JourneyId: {},
                  LastEvaluatedTime: {},
                  Metrics: {
                    shape: "S4"
                  },
                  RunId: {}
                },
                required: [
                  "Metrics",
                  "JourneyId",
                  "LastEvaluatedTime",
                  "RunId",
                  "ApplicationId"
                ]
              }
            },
            required: [
              "JourneyRunExecutionMetricsResponse"
            ],
            payload: "JourneyRunExecutionMetricsResponse"
          }
        },
        GetJourneyRuns: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/journeys/{journey-id}/runs",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              JourneyId: {
                location: "uri",
                locationName: "journey-id"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              Token: {
                location: "querystring",
                locationName: "token"
              }
            },
            required: [
              "ApplicationId",
              "JourneyId"
            ]
          },
          output: {
            type: "structure",
            members: {
              JourneyRunsResponse: {
                type: "structure",
                members: {
                  Item: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        CreationTime: {},
                        LastUpdateTime: {},
                        RunId: {},
                        Status: {}
                      },
                      required: [
                        "Status",
                        "LastUpdateTime",
                        "CreationTime",
                        "RunId"
                      ]
                    }
                  },
                  NextToken: {}
                },
                required: [
                  "Item"
                ]
              }
            },
            required: [
              "JourneyRunsResponse"
            ],
            payload: "JourneyRunsResponse"
          }
        },
        GetPushTemplate: {
          http: {
            method: "GET",
            requestUri: "/v1/templates/{template-name}/push",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              Version: {
                location: "querystring",
                locationName: "version"
              }
            },
            required: [
              "TemplateName"
            ]
          },
          output: {
            type: "structure",
            members: {
              PushNotificationTemplateResponse: {
                type: "structure",
                members: {
                  ADM: {
                    shape: "S3x"
                  },
                  APNS: {
                    shape: "S3y"
                  },
                  Arn: {},
                  Baidu: {
                    shape: "S3x"
                  },
                  CreationDate: {},
                  Default: {
                    shape: "S3z"
                  },
                  DefaultSubstitutions: {},
                  GCM: {
                    shape: "S3x"
                  },
                  LastModifiedDate: {},
                  RecommenderId: {},
                  tags: {
                    shape: "S4",
                    locationName: "tags"
                  },
                  TemplateDescription: {},
                  TemplateName: {},
                  TemplateType: {},
                  Version: {}
                },
                required: [
                  "LastModifiedDate",
                  "CreationDate",
                  "TemplateType",
                  "TemplateName"
                ]
              }
            },
            required: [
              "PushNotificationTemplateResponse"
            ],
            payload: "PushNotificationTemplateResponse"
          }
        },
        GetRecommenderConfiguration: {
          http: {
            method: "GET",
            requestUri: "/v1/recommenders/{recommender-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              RecommenderId: {
                location: "uri",
                locationName: "recommender-id"
              }
            },
            required: [
              "RecommenderId"
            ]
          },
          output: {
            type: "structure",
            members: {
              RecommenderConfigurationResponse: {
                shape: "S44"
              }
            },
            required: [
              "RecommenderConfigurationResponse"
            ],
            payload: "RecommenderConfigurationResponse"
          }
        },
        GetRecommenderConfigurations: {
          http: {
            method: "GET",
            requestUri: "/v1/recommenders",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              Token: {
                location: "querystring",
                locationName: "token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ListRecommenderConfigurationsResponse: {
                type: "structure",
                members: {
                  Item: {
                    type: "list",
                    member: {
                      shape: "S44"
                    }
                  },
                  NextToken: {}
                },
                required: [
                  "Item"
                ]
              }
            },
            required: [
              "ListRecommenderConfigurationsResponse"
            ],
            payload: "ListRecommenderConfigurationsResponse"
          }
        },
        GetSegment: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/segments/{segment-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              SegmentId: {
                location: "uri",
                locationName: "segment-id"
              }
            },
            required: [
              "SegmentId",
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              SegmentResponse: {
                shape: "S4h"
              }
            },
            required: [
              "SegmentResponse"
            ],
            payload: "SegmentResponse"
          }
        },
        GetSegmentExportJobs: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/segments/{segment-id}/jobs/export",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              SegmentId: {
                location: "uri",
                locationName: "segment-id"
              },
              Token: {
                location: "querystring",
                locationName: "token"
              }
            },
            required: [
              "SegmentId",
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ExportJobsResponse: {
                shape: "S8h"
              }
            },
            required: [
              "ExportJobsResponse"
            ],
            payload: "ExportJobsResponse"
          }
        },
        GetSegmentImportJobs: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/segments/{segment-id}/jobs/import",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              SegmentId: {
                location: "uri",
                locationName: "segment-id"
              },
              Token: {
                location: "querystring",
                locationName: "token"
              }
            },
            required: [
              "SegmentId",
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ImportJobsResponse: {
                shape: "S8p"
              }
            },
            required: [
              "ImportJobsResponse"
            ],
            payload: "ImportJobsResponse"
          }
        },
        GetSegmentVersion: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/segments/{segment-id}/versions/{version}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              SegmentId: {
                location: "uri",
                locationName: "segment-id"
              },
              Version: {
                location: "uri",
                locationName: "version"
              }
            },
            required: [
              "SegmentId",
              "Version",
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              SegmentResponse: {
                shape: "S4h"
              }
            },
            required: [
              "SegmentResponse"
            ],
            payload: "SegmentResponse"
          }
        },
        GetSegmentVersions: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/segments/{segment-id}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              SegmentId: {
                location: "uri",
                locationName: "segment-id"
              },
              Token: {
                location: "querystring",
                locationName: "token"
              }
            },
            required: [
              "SegmentId",
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              SegmentsResponse: {
                shape: "Sa7"
              }
            },
            required: [
              "SegmentsResponse"
            ],
            payload: "SegmentsResponse"
          }
        },
        GetSegments: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/segments",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              Token: {
                location: "querystring",
                locationName: "token"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              SegmentsResponse: {
                shape: "Sa7"
              }
            },
            required: [
              "SegmentsResponse"
            ],
            payload: "SegmentsResponse"
          }
        },
        GetSmsChannel: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/channels/sms",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              SMSChannelResponse: {
                shape: "S6a"
              }
            },
            required: [
              "SMSChannelResponse"
            ],
            payload: "SMSChannelResponse"
          }
        },
        GetSmsTemplate: {
          http: {
            method: "GET",
            requestUri: "/v1/templates/{template-name}/sms",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              Version: {
                location: "querystring",
                locationName: "version"
              }
            },
            required: [
              "TemplateName"
            ]
          },
          output: {
            type: "structure",
            members: {
              SMSTemplateResponse: {
                type: "structure",
                members: {
                  Arn: {},
                  Body: {},
                  CreationDate: {},
                  DefaultSubstitutions: {},
                  LastModifiedDate: {},
                  RecommenderId: {},
                  tags: {
                    shape: "S4",
                    locationName: "tags"
                  },
                  TemplateDescription: {},
                  TemplateName: {},
                  TemplateType: {},
                  Version: {}
                },
                required: [
                  "LastModifiedDate",
                  "CreationDate",
                  "TemplateName",
                  "TemplateType"
                ]
              }
            },
            required: [
              "SMSTemplateResponse"
            ],
            payload: "SMSTemplateResponse"
          }
        },
        GetUserEndpoints: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/users/{user-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              UserId: {
                location: "uri",
                locationName: "user-id"
              }
            },
            required: [
              "ApplicationId",
              "UserId"
            ]
          },
          output: {
            type: "structure",
            members: {
              EndpointsResponse: {
                shape: "S6f"
              }
            },
            required: [
              "EndpointsResponse"
            ],
            payload: "EndpointsResponse"
          }
        },
        GetVoiceChannel: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/channels/voice",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              VoiceChannelResponse: {
                shape: "S6j"
              }
            },
            required: [
              "VoiceChannelResponse"
            ],
            payload: "VoiceChannelResponse"
          }
        },
        GetVoiceTemplate: {
          http: {
            method: "GET",
            requestUri: "/v1/templates/{template-name}/voice",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              Version: {
                location: "querystring",
                locationName: "version"
              }
            },
            required: [
              "TemplateName"
            ]
          },
          output: {
            type: "structure",
            members: {
              VoiceTemplateResponse: {
                type: "structure",
                members: {
                  Arn: {},
                  Body: {},
                  CreationDate: {},
                  DefaultSubstitutions: {},
                  LanguageCode: {},
                  LastModifiedDate: {},
                  tags: {
                    shape: "S4",
                    locationName: "tags"
                  },
                  TemplateDescription: {},
                  TemplateName: {},
                  TemplateType: {},
                  Version: {},
                  VoiceId: {}
                },
                required: [
                  "LastModifiedDate",
                  "CreationDate",
                  "TemplateName",
                  "TemplateType"
                ]
              }
            },
            required: [
              "VoiceTemplateResponse"
            ],
            payload: "VoiceTemplateResponse"
          }
        },
        ListJourneys: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/journeys",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              Token: {
                location: "querystring",
                locationName: "token"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              JourneysResponse: {
                type: "structure",
                members: {
                  Item: {
                    type: "list",
                    member: {
                      shape: "S3u"
                    }
                  },
                  NextToken: {}
                },
                required: [
                  "Item"
                ]
              }
            },
            required: [
              "JourneysResponse"
            ],
            payload: "JourneysResponse"
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/v1/tags/{resource-arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              }
            },
            required: [
              "ResourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              TagsModel: {
                shape: "Sat"
              }
            },
            required: [
              "TagsModel"
            ],
            payload: "TagsModel"
          }
        },
        ListTemplateVersions: {
          http: {
            method: "GET",
            requestUri: "/v1/templates/{template-name}/{template-type}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              TemplateType: {
                location: "uri",
                locationName: "template-type"
              }
            },
            required: [
              "TemplateName",
              "TemplateType"
            ]
          },
          output: {
            type: "structure",
            members: {
              TemplateVersionsResponse: {
                type: "structure",
                members: {
                  Item: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        CreationDate: {},
                        DefaultSubstitutions: {},
                        LastModifiedDate: {},
                        TemplateDescription: {},
                        TemplateName: {},
                        TemplateType: {},
                        Version: {}
                      },
                      required: [
                        "LastModifiedDate",
                        "CreationDate",
                        "TemplateName",
                        "TemplateType"
                      ]
                    }
                  },
                  Message: {},
                  NextToken: {},
                  RequestID: {}
                },
                required: [
                  "Item"
                ]
              }
            },
            required: [
              "TemplateVersionsResponse"
            ],
            payload: "TemplateVersionsResponse"
          }
        },
        ListTemplates: {
          http: {
            method: "GET",
            requestUri: "/v1/templates",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              Prefix: {
                location: "querystring",
                locationName: "prefix"
              },
              TemplateType: {
                location: "querystring",
                locationName: "template-type"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplatesResponse: {
                type: "structure",
                members: {
                  Item: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Arn: {},
                        CreationDate: {},
                        DefaultSubstitutions: {},
                        LastModifiedDate: {},
                        tags: {
                          shape: "S4",
                          locationName: "tags"
                        },
                        TemplateDescription: {},
                        TemplateName: {},
                        TemplateType: {},
                        Version: {}
                      },
                      required: [
                        "LastModifiedDate",
                        "CreationDate",
                        "TemplateName",
                        "TemplateType"
                      ]
                    }
                  },
                  NextToken: {}
                },
                required: [
                  "Item"
                ]
              }
            },
            required: [
              "TemplatesResponse"
            ],
            payload: "TemplatesResponse"
          }
        },
        PhoneNumberValidate: {
          http: {
            requestUri: "/v1/phone/number/validate",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NumberValidateRequest: {
                type: "structure",
                members: {
                  IsoCountryCode: {},
                  PhoneNumber: {}
                }
              }
            },
            required: [
              "NumberValidateRequest"
            ],
            payload: "NumberValidateRequest"
          },
          output: {
            type: "structure",
            members: {
              NumberValidateResponse: {
                type: "structure",
                members: {
                  Carrier: {},
                  City: {},
                  CleansedPhoneNumberE164: {},
                  CleansedPhoneNumberNational: {},
                  Country: {},
                  CountryCodeIso2: {},
                  CountryCodeNumeric: {},
                  County: {},
                  OriginalCountryCodeIso2: {},
                  OriginalPhoneNumber: {},
                  PhoneType: {},
                  PhoneTypeCode: {
                    type: "integer"
                  },
                  Timezone: {},
                  ZipCode: {}
                }
              }
            },
            required: [
              "NumberValidateResponse"
            ],
            payload: "NumberValidateResponse"
          }
        },
        PutEventStream: {
          http: {
            requestUri: "/v1/apps/{application-id}/eventstream",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              WriteEventStream: {
                type: "structure",
                members: {
                  DestinationStreamArn: {},
                  RoleArn: {}
                },
                required: [
                  "RoleArn",
                  "DestinationStreamArn"
                ]
              }
            },
            required: [
              "ApplicationId",
              "WriteEventStream"
            ],
            payload: "WriteEventStream"
          },
          output: {
            type: "structure",
            members: {
              EventStream: {
                shape: "S5u"
              }
            },
            required: [
              "EventStream"
            ],
            payload: "EventStream"
          }
        },
        PutEvents: {
          http: {
            requestUri: "/v1/apps/{application-id}/events",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              EventsRequest: {
                type: "structure",
                members: {
                  BatchItem: {
                    type: "map",
                    key: {},
                    value: {
                      type: "structure",
                      members: {
                        Endpoint: {
                          type: "structure",
                          members: {
                            Address: {},
                            Attributes: {
                              shape: "S5m"
                            },
                            ChannelType: {},
                            Demographic: {
                              shape: "S5o"
                            },
                            EffectiveDate: {},
                            EndpointStatus: {},
                            Location: {
                              shape: "S5p"
                            },
                            Metrics: {
                              shape: "S5q"
                            },
                            OptOut: {},
                            RequestId: {},
                            User: {
                              shape: "S5r"
                            }
                          }
                        },
                        Events: {
                          type: "map",
                          key: {},
                          value: {
                            type: "structure",
                            members: {
                              AppPackageName: {},
                              AppTitle: {},
                              AppVersionCode: {},
                              Attributes: {
                                shape: "S4"
                              },
                              ClientSdkVersion: {},
                              EventType: {},
                              Metrics: {
                                shape: "S5q"
                              },
                              SdkName: {},
                              Session: {
                                type: "structure",
                                members: {
                                  Duration: {
                                    type: "integer"
                                  },
                                  Id: {},
                                  StartTimestamp: {},
                                  StopTimestamp: {}
                                },
                                required: [
                                  "StartTimestamp",
                                  "Id"
                                ]
                              },
                              Timestamp: {}
                            },
                            required: [
                              "EventType",
                              "Timestamp"
                            ]
                          }
                        }
                      },
                      required: [
                        "Endpoint",
                        "Events"
                      ]
                    }
                  }
                },
                required: [
                  "BatchItem"
                ]
              }
            },
            required: [
              "ApplicationId",
              "EventsRequest"
            ],
            payload: "EventsRequest"
          },
          output: {
            type: "structure",
            members: {
              EventsResponse: {
                type: "structure",
                members: {
                  Results: {
                    type: "map",
                    key: {},
                    value: {
                      type: "structure",
                      members: {
                        EndpointItemResponse: {
                          type: "structure",
                          members: {
                            Message: {},
                            StatusCode: {
                              type: "integer"
                            }
                          }
                        },
                        EventsItemResponse: {
                          type: "map",
                          key: {},
                          value: {
                            type: "structure",
                            members: {
                              Message: {},
                              StatusCode: {
                                type: "integer"
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            required: [
              "EventsResponse"
            ],
            payload: "EventsResponse"
          }
        },
        RemoveAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/attributes/{attribute-type}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              AttributeType: {
                location: "uri",
                locationName: "attribute-type"
              },
              UpdateAttributesRequest: {
                type: "structure",
                members: {
                  Blacklist: {
                    shape: "S14"
                  }
                }
              }
            },
            required: [
              "AttributeType",
              "ApplicationId",
              "UpdateAttributesRequest"
            ],
            payload: "UpdateAttributesRequest"
          },
          output: {
            type: "structure",
            members: {
              AttributesResource: {
                type: "structure",
                members: {
                  ApplicationId: {},
                  AttributeType: {},
                  Attributes: {
                    shape: "S14"
                  }
                },
                required: [
                  "AttributeType",
                  "ApplicationId"
                ]
              }
            },
            required: [
              "AttributesResource"
            ],
            payload: "AttributesResource"
          }
        },
        SendMessages: {
          http: {
            requestUri: "/v1/apps/{application-id}/messages",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              MessageRequest: {
                type: "structure",
                members: {
                  Addresses: {
                    type: "map",
                    key: {},
                    value: {
                      type: "structure",
                      members: {
                        BodyOverride: {},
                        ChannelType: {},
                        Context: {
                          shape: "S4"
                        },
                        RawContent: {},
                        Substitutions: {
                          shape: "S5m"
                        },
                        TitleOverride: {}
                      }
                    }
                  },
                  Context: {
                    shape: "S4"
                  },
                  Endpoints: {
                    shape: "Sby"
                  },
                  MessageConfiguration: {
                    shape: "Sc0"
                  },
                  TemplateConfiguration: {
                    shape: "S1d"
                  },
                  TraceId: {}
                },
                required: [
                  "MessageConfiguration"
                ]
              }
            },
            required: [
              "ApplicationId",
              "MessageRequest"
            ],
            payload: "MessageRequest"
          },
          output: {
            type: "structure",
            members: {
              MessageResponse: {
                shape: "Scf"
              }
            },
            required: [
              "MessageResponse"
            ],
            payload: "MessageResponse"
          }
        },
        SendOTPMessage: {
          http: {
            requestUri: "/v1/apps/{application-id}/otp",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              SendOTPMessageRequestParameters: {
                type: "structure",
                members: {
                  AllowedAttempts: {
                    type: "integer"
                  },
                  BrandName: {},
                  Channel: {},
                  CodeLength: {
                    type: "integer"
                  },
                  DestinationIdentity: {},
                  EntityId: {},
                  Language: {},
                  OriginationIdentity: {},
                  ReferenceId: {},
                  TemplateId: {},
                  ValidityPeriod: {
                    type: "integer"
                  }
                },
                required: [
                  "BrandName",
                  "ReferenceId",
                  "Channel",
                  "DestinationIdentity",
                  "OriginationIdentity"
                ]
              }
            },
            required: [
              "ApplicationId",
              "SendOTPMessageRequestParameters"
            ],
            payload: "SendOTPMessageRequestParameters"
          },
          output: {
            type: "structure",
            members: {
              MessageResponse: {
                shape: "Scf"
              }
            },
            required: [
              "MessageResponse"
            ],
            payload: "MessageResponse"
          }
        },
        SendUsersMessages: {
          http: {
            requestUri: "/v1/apps/{application-id}/users-messages",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              SendUsersMessageRequest: {
                type: "structure",
                members: {
                  Context: {
                    shape: "S4"
                  },
                  MessageConfiguration: {
                    shape: "Sc0"
                  },
                  TemplateConfiguration: {
                    shape: "S1d"
                  },
                  TraceId: {},
                  Users: {
                    shape: "Sby"
                  }
                },
                required: [
                  "MessageConfiguration",
                  "Users"
                ]
              }
            },
            required: [
              "ApplicationId",
              "SendUsersMessageRequest"
            ],
            payload: "SendUsersMessageRequest"
          },
          output: {
            type: "structure",
            members: {
              SendUsersMessageResponse: {
                type: "structure",
                members: {
                  ApplicationId: {},
                  RequestId: {},
                  Result: {
                    type: "map",
                    key: {},
                    value: {
                      shape: "Scg"
                    }
                  }
                },
                required: [
                  "ApplicationId"
                ]
              }
            },
            required: [
              "SendUsersMessageResponse"
            ],
            payload: "SendUsersMessageResponse"
          }
        },
        TagResource: {
          http: {
            requestUri: "/v1/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              TagsModel: {
                shape: "Sat"
              }
            },
            required: [
              "ResourceArn",
              "TagsModel"
            ],
            payload: "TagsModel"
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/v1/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              TagKeys: {
                shape: "S14",
                location: "querystring",
                locationName: "tagKeys"
              }
            },
            required: [
              "TagKeys",
              "ResourceArn"
            ]
          }
        },
        UpdateAdmChannel: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/channels/adm",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ADMChannelRequest: {
                type: "structure",
                members: {
                  ClientId: {},
                  ClientSecret: {},
                  Enabled: {
                    type: "boolean"
                  }
                },
                required: [
                  "ClientSecret",
                  "ClientId"
                ]
              },
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId",
              "ADMChannelRequest"
            ],
            payload: "ADMChannelRequest"
          },
          output: {
            type: "structure",
            members: {
              ADMChannelResponse: {
                shape: "S4t"
              }
            },
            required: [
              "ADMChannelResponse"
            ],
            payload: "ADMChannelResponse"
          }
        },
        UpdateApnsChannel: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/channels/apns",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              APNSChannelRequest: {
                type: "structure",
                members: {
                  BundleId: {},
                  Certificate: {},
                  DefaultAuthenticationMethod: {},
                  Enabled: {
                    type: "boolean"
                  },
                  PrivateKey: {},
                  TeamId: {},
                  TokenKey: {},
                  TokenKeyId: {}
                }
              },
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId",
              "APNSChannelRequest"
            ],
            payload: "APNSChannelRequest"
          },
          output: {
            type: "structure",
            members: {
              APNSChannelResponse: {
                shape: "S4w"
              }
            },
            required: [
              "APNSChannelResponse"
            ],
            payload: "APNSChannelResponse"
          }
        },
        UpdateApnsSandboxChannel: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/channels/apns_sandbox",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              APNSSandboxChannelRequest: {
                type: "structure",
                members: {
                  BundleId: {},
                  Certificate: {},
                  DefaultAuthenticationMethod: {},
                  Enabled: {
                    type: "boolean"
                  },
                  PrivateKey: {},
                  TeamId: {},
                  TokenKey: {},
                  TokenKeyId: {}
                }
              },
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId",
              "APNSSandboxChannelRequest"
            ],
            payload: "APNSSandboxChannelRequest"
          },
          output: {
            type: "structure",
            members: {
              APNSSandboxChannelResponse: {
                shape: "S4z"
              }
            },
            required: [
              "APNSSandboxChannelResponse"
            ],
            payload: "APNSSandboxChannelResponse"
          }
        },
        UpdateApnsVoipChannel: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/channels/apns_voip",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              APNSVoipChannelRequest: {
                type: "structure",
                members: {
                  BundleId: {},
                  Certificate: {},
                  DefaultAuthenticationMethod: {},
                  Enabled: {
                    type: "boolean"
                  },
                  PrivateKey: {},
                  TeamId: {},
                  TokenKey: {},
                  TokenKeyId: {}
                }
              },
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId",
              "APNSVoipChannelRequest"
            ],
            payload: "APNSVoipChannelRequest"
          },
          output: {
            type: "structure",
            members: {
              APNSVoipChannelResponse: {
                shape: "S52"
              }
            },
            required: [
              "APNSVoipChannelResponse"
            ],
            payload: "APNSVoipChannelResponse"
          }
        },
        UpdateApnsVoipSandboxChannel: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/channels/apns_voip_sandbox",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              APNSVoipSandboxChannelRequest: {
                type: "structure",
                members: {
                  BundleId: {},
                  Certificate: {},
                  DefaultAuthenticationMethod: {},
                  Enabled: {
                    type: "boolean"
                  },
                  PrivateKey: {},
                  TeamId: {},
                  TokenKey: {},
                  TokenKeyId: {}
                }
              },
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId",
              "APNSVoipSandboxChannelRequest"
            ],
            payload: "APNSVoipSandboxChannelRequest"
          },
          output: {
            type: "structure",
            members: {
              APNSVoipSandboxChannelResponse: {
                shape: "S55"
              }
            },
            required: [
              "APNSVoipSandboxChannelResponse"
            ],
            payload: "APNSVoipSandboxChannelResponse"
          }
        },
        UpdateApplicationSettings: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/settings",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              WriteApplicationSettingsRequest: {
                type: "structure",
                members: {
                  CampaignHook: {
                    shape: "S1f"
                  },
                  CloudWatchMetricsEnabled: {
                    type: "boolean"
                  },
                  EventTaggingEnabled: {
                    type: "boolean"
                  },
                  Limits: {
                    shape: "S1h"
                  },
                  QuietTime: {
                    shape: "S1c"
                  },
                  JourneyLimits: {
                    shape: "S79"
                  }
                }
              }
            },
            required: [
              "ApplicationId",
              "WriteApplicationSettingsRequest"
            ],
            payload: "WriteApplicationSettingsRequest"
          },
          output: {
            type: "structure",
            members: {
              ApplicationSettingsResource: {
                shape: "S78"
              }
            },
            required: [
              "ApplicationSettingsResource"
            ],
            payload: "ApplicationSettingsResource"
          }
        },
        UpdateBaiduChannel: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/channels/baidu",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              BaiduChannelRequest: {
                type: "structure",
                members: {
                  ApiKey: {},
                  Enabled: {
                    type: "boolean"
                  },
                  SecretKey: {}
                },
                required: [
                  "SecretKey",
                  "ApiKey"
                ]
              }
            },
            required: [
              "ApplicationId",
              "BaiduChannelRequest"
            ],
            payload: "BaiduChannelRequest"
          },
          output: {
            type: "structure",
            members: {
              BaiduChannelResponse: {
                shape: "S5a"
              }
            },
            required: [
              "BaiduChannelResponse"
            ],
            payload: "BaiduChannelResponse"
          }
        },
        UpdateCampaign: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/campaigns/{campaign-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              CampaignId: {
                location: "uri",
                locationName: "campaign-id"
              },
              WriteCampaignRequest: {
                shape: "S8"
              }
            },
            required: [
              "CampaignId",
              "ApplicationId",
              "WriteCampaignRequest"
            ],
            payload: "WriteCampaignRequest"
          },
          output: {
            type: "structure",
            members: {
              CampaignResponse: {
                shape: "S1j"
              }
            },
            required: [
              "CampaignResponse"
            ],
            payload: "CampaignResponse"
          }
        },
        UpdateEmailChannel: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/channels/email",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              EmailChannelRequest: {
                type: "structure",
                members: {
                  ConfigurationSet: {},
                  Enabled: {
                    type: "boolean"
                  },
                  FromAddress: {},
                  Identity: {},
                  RoleArn: {}
                },
                required: [
                  "FromAddress",
                  "Identity"
                ]
              }
            },
            required: [
              "ApplicationId",
              "EmailChannelRequest"
            ],
            payload: "EmailChannelRequest"
          },
          output: {
            type: "structure",
            members: {
              EmailChannelResponse: {
                shape: "S5f"
              }
            },
            required: [
              "EmailChannelResponse"
            ],
            payload: "EmailChannelResponse"
          }
        },
        UpdateEmailTemplate: {
          http: {
            method: "PUT",
            requestUri: "/v1/templates/{template-name}/email",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              CreateNewVersion: {
                location: "querystring",
                locationName: "create-new-version",
                type: "boolean"
              },
              EmailTemplateRequest: {
                shape: "S1p"
              },
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              Version: {
                location: "querystring",
                locationName: "version"
              }
            },
            required: [
              "TemplateName",
              "EmailTemplateRequest"
            ],
            payload: "EmailTemplateRequest"
          },
          output: {
            type: "structure",
            members: {
              MessageBody: {
                shape: "S5i"
              }
            },
            required: [
              "MessageBody"
            ],
            payload: "MessageBody"
          }
        },
        UpdateEndpoint: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/endpoints/{endpoint-id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              EndpointId: {
                location: "uri",
                locationName: "endpoint-id"
              },
              EndpointRequest: {
                type: "structure",
                members: {
                  Address: {},
                  Attributes: {
                    shape: "S5m"
                  },
                  ChannelType: {},
                  Demographic: {
                    shape: "S5o"
                  },
                  EffectiveDate: {},
                  EndpointStatus: {},
                  Location: {
                    shape: "S5p"
                  },
                  Metrics: {
                    shape: "S5q"
                  },
                  OptOut: {},
                  RequestId: {},
                  User: {
                    shape: "S5r"
                  }
                }
              }
            },
            required: [
              "ApplicationId",
              "EndpointId",
              "EndpointRequest"
            ],
            payload: "EndpointRequest"
          },
          output: {
            type: "structure",
            members: {
              MessageBody: {
                shape: "S5i"
              }
            },
            required: [
              "MessageBody"
            ],
            payload: "MessageBody"
          }
        },
        UpdateEndpointsBatch: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/endpoints",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              EndpointBatchRequest: {
                type: "structure",
                members: {
                  Item: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Address: {},
                        Attributes: {
                          shape: "S5m"
                        },
                        ChannelType: {},
                        Demographic: {
                          shape: "S5o"
                        },
                        EffectiveDate: {},
                        EndpointStatus: {},
                        Id: {},
                        Location: {
                          shape: "S5p"
                        },
                        Metrics: {
                          shape: "S5q"
                        },
                        OptOut: {},
                        RequestId: {},
                        User: {
                          shape: "S5r"
                        }
                      }
                    }
                  }
                },
                required: [
                  "Item"
                ]
              }
            },
            required: [
              "ApplicationId",
              "EndpointBatchRequest"
            ],
            payload: "EndpointBatchRequest"
          },
          output: {
            type: "structure",
            members: {
              MessageBody: {
                shape: "S5i"
              }
            },
            required: [
              "MessageBody"
            ],
            payload: "MessageBody"
          }
        },
        UpdateGcmChannel: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/channels/gcm",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              GCMChannelRequest: {
                type: "structure",
                members: {
                  ApiKey: {},
                  DefaultAuthenticationMethod: {},
                  Enabled: {
                    type: "boolean"
                  },
                  ServiceJson: {}
                }
              }
            },
            required: [
              "ApplicationId",
              "GCMChannelRequest"
            ],
            payload: "GCMChannelRequest"
          },
          output: {
            type: "structure",
            members: {
              GCMChannelResponse: {
                shape: "S5x"
              }
            },
            required: [
              "GCMChannelResponse"
            ],
            payload: "GCMChannelResponse"
          }
        },
        UpdateInAppTemplate: {
          http: {
            method: "PUT",
            requestUri: "/v1/templates/{template-name}/inapp",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              CreateNewVersion: {
                location: "querystring",
                locationName: "create-new-version",
                type: "boolean"
              },
              InAppTemplateRequest: {
                shape: "S25"
              },
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              Version: {
                location: "querystring",
                locationName: "version"
              }
            },
            required: [
              "TemplateName",
              "InAppTemplateRequest"
            ],
            payload: "InAppTemplateRequest"
          },
          output: {
            type: "structure",
            members: {
              MessageBody: {
                shape: "S5i"
              }
            },
            required: [
              "MessageBody"
            ],
            payload: "MessageBody"
          }
        },
        UpdateJourney: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/journeys/{journey-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              JourneyId: {
                location: "uri",
                locationName: "journey-id"
              },
              WriteJourneyRequest: {
                shape: "S29"
              }
            },
            required: [
              "JourneyId",
              "ApplicationId",
              "WriteJourneyRequest"
            ],
            payload: "WriteJourneyRequest"
          },
          output: {
            type: "structure",
            members: {
              JourneyResponse: {
                shape: "S3u"
              }
            },
            required: [
              "JourneyResponse"
            ],
            payload: "JourneyResponse"
          }
        },
        UpdateJourneyState: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/journeys/{journey-id}/state",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              JourneyId: {
                location: "uri",
                locationName: "journey-id"
              },
              JourneyStateRequest: {
                type: "structure",
                members: {
                  State: {}
                }
              }
            },
            required: [
              "JourneyId",
              "ApplicationId",
              "JourneyStateRequest"
            ],
            payload: "JourneyStateRequest"
          },
          output: {
            type: "structure",
            members: {
              JourneyResponse: {
                shape: "S3u"
              }
            },
            required: [
              "JourneyResponse"
            ],
            payload: "JourneyResponse"
          }
        },
        UpdatePushTemplate: {
          http: {
            method: "PUT",
            requestUri: "/v1/templates/{template-name}/push",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              CreateNewVersion: {
                location: "querystring",
                locationName: "create-new-version",
                type: "boolean"
              },
              PushNotificationTemplateRequest: {
                shape: "S3w"
              },
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              Version: {
                location: "querystring",
                locationName: "version"
              }
            },
            required: [
              "TemplateName",
              "PushNotificationTemplateRequest"
            ],
            payload: "PushNotificationTemplateRequest"
          },
          output: {
            type: "structure",
            members: {
              MessageBody: {
                shape: "S5i"
              }
            },
            required: [
              "MessageBody"
            ],
            payload: "MessageBody"
          }
        },
        UpdateRecommenderConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/v1/recommenders/{recommender-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              RecommenderId: {
                location: "uri",
                locationName: "recommender-id"
              },
              UpdateRecommenderConfiguration: {
                type: "structure",
                members: {
                  Attributes: {
                    shape: "S4"
                  },
                  Description: {},
                  Name: {},
                  RecommendationProviderIdType: {},
                  RecommendationProviderRoleArn: {},
                  RecommendationProviderUri: {},
                  RecommendationTransformerUri: {},
                  RecommendationsDisplayName: {},
                  RecommendationsPerMessage: {
                    type: "integer"
                  }
                },
                required: [
                  "RecommendationProviderUri",
                  "RecommendationProviderRoleArn"
                ]
              }
            },
            required: [
              "RecommenderId",
              "UpdateRecommenderConfiguration"
            ],
            payload: "UpdateRecommenderConfiguration"
          },
          output: {
            type: "structure",
            members: {
              RecommenderConfigurationResponse: {
                shape: "S44"
              }
            },
            required: [
              "RecommenderConfigurationResponse"
            ],
            payload: "RecommenderConfigurationResponse"
          }
        },
        UpdateSegment: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/segments/{segment-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              SegmentId: {
                location: "uri",
                locationName: "segment-id"
              },
              WriteSegmentRequest: {
                shape: "S46"
              }
            },
            required: [
              "SegmentId",
              "ApplicationId",
              "WriteSegmentRequest"
            ],
            payload: "WriteSegmentRequest"
          },
          output: {
            type: "structure",
            members: {
              SegmentResponse: {
                shape: "S4h"
              }
            },
            required: [
              "SegmentResponse"
            ],
            payload: "SegmentResponse"
          }
        },
        UpdateSmsChannel: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/channels/sms",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              SMSChannelRequest: {
                type: "structure",
                members: {
                  Enabled: {
                    type: "boolean"
                  },
                  SenderId: {},
                  ShortCode: {}
                }
              }
            },
            required: [
              "ApplicationId",
              "SMSChannelRequest"
            ],
            payload: "SMSChannelRequest"
          },
          output: {
            type: "structure",
            members: {
              SMSChannelResponse: {
                shape: "S6a"
              }
            },
            required: [
              "SMSChannelResponse"
            ],
            payload: "SMSChannelResponse"
          }
        },
        UpdateSmsTemplate: {
          http: {
            method: "PUT",
            requestUri: "/v1/templates/{template-name}/sms",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              CreateNewVersion: {
                location: "querystring",
                locationName: "create-new-version",
                type: "boolean"
              },
              SMSTemplateRequest: {
                shape: "S4m"
              },
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              Version: {
                location: "querystring",
                locationName: "version"
              }
            },
            required: [
              "TemplateName",
              "SMSTemplateRequest"
            ],
            payload: "SMSTemplateRequest"
          },
          output: {
            type: "structure",
            members: {
              MessageBody: {
                shape: "S5i"
              }
            },
            required: [
              "MessageBody"
            ],
            payload: "MessageBody"
          }
        },
        UpdateTemplateActiveVersion: {
          http: {
            method: "PUT",
            requestUri: "/v1/templates/{template-name}/{template-type}/active-version",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              TemplateActiveVersionRequest: {
                type: "structure",
                members: {
                  Version: {}
                }
              },
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              TemplateType: {
                location: "uri",
                locationName: "template-type"
              }
            },
            required: [
              "TemplateName",
              "TemplateType",
              "TemplateActiveVersionRequest"
            ],
            payload: "TemplateActiveVersionRequest"
          },
          output: {
            type: "structure",
            members: {
              MessageBody: {
                shape: "S5i"
              }
            },
            required: [
              "MessageBody"
            ],
            payload: "MessageBody"
          }
        },
        UpdateVoiceChannel: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/channels/voice",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              VoiceChannelRequest: {
                type: "structure",
                members: {
                  Enabled: {
                    type: "boolean"
                  }
                }
              }
            },
            required: [
              "ApplicationId",
              "VoiceChannelRequest"
            ],
            payload: "VoiceChannelRequest"
          },
          output: {
            type: "structure",
            members: {
              VoiceChannelResponse: {
                shape: "S6j"
              }
            },
            required: [
              "VoiceChannelResponse"
            ],
            payload: "VoiceChannelResponse"
          }
        },
        UpdateVoiceTemplate: {
          http: {
            method: "PUT",
            requestUri: "/v1/templates/{template-name}/voice",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              CreateNewVersion: {
                location: "querystring",
                locationName: "create-new-version",
                type: "boolean"
              },
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              Version: {
                location: "querystring",
                locationName: "version"
              },
              VoiceTemplateRequest: {
                shape: "S4p"
              }
            },
            required: [
              "TemplateName",
              "VoiceTemplateRequest"
            ],
            payload: "VoiceTemplateRequest"
          },
          output: {
            type: "structure",
            members: {
              MessageBody: {
                shape: "S5i"
              }
            },
            required: [
              "MessageBody"
            ],
            payload: "MessageBody"
          }
        },
        VerifyOTPMessage: {
          http: {
            requestUri: "/v1/apps/{application-id}/verify-otp",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              VerifyOTPMessageRequestParameters: {
                type: "structure",
                members: {
                  DestinationIdentity: {},
                  Otp: {},
                  ReferenceId: {}
                },
                required: [
                  "ReferenceId",
                  "Otp",
                  "DestinationIdentity"
                ]
              }
            },
            required: [
              "ApplicationId",
              "VerifyOTPMessageRequestParameters"
            ],
            payload: "VerifyOTPMessageRequestParameters"
          },
          output: {
            type: "structure",
            members: {
              VerificationResponse: {
                type: "structure",
                members: {
                  Valid: {
                    type: "boolean"
                  }
                }
              }
            },
            required: [
              "VerificationResponse"
            ],
            payload: "VerificationResponse"
          }
        }
      },
      shapes: {
        S4: {
          type: "map",
          key: {},
          value: {}
        },
        S6: {
          type: "structure",
          members: {
            Arn: {},
            Id: {},
            Name: {},
            tags: {
              shape: "S4",
              locationName: "tags"
            },
            CreationDate: {}
          },
          required: [
            "Id",
            "Arn",
            "Name"
          ]
        },
        S8: {
          type: "structure",
          members: {
            AdditionalTreatments: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  CustomDeliveryConfiguration: {
                    shape: "Sb"
                  },
                  MessageConfiguration: {
                    shape: "Se"
                  },
                  Schedule: {
                    shape: "Sy"
                  },
                  SizePercent: {
                    type: "integer"
                  },
                  TemplateConfiguration: {
                    shape: "S1d"
                  },
                  TreatmentDescription: {},
                  TreatmentName: {}
                },
                required: [
                  "SizePercent"
                ]
              }
            },
            CustomDeliveryConfiguration: {
              shape: "Sb"
            },
            Description: {},
            HoldoutPercent: {
              type: "integer"
            },
            Hook: {
              shape: "S1f"
            },
            IsPaused: {
              type: "boolean"
            },
            Limits: {
              shape: "S1h"
            },
            MessageConfiguration: {
              shape: "Se"
            },
            Name: {},
            Schedule: {
              shape: "Sy"
            },
            SegmentId: {},
            SegmentVersion: {
              type: "integer"
            },
            tags: {
              shape: "S4",
              locationName: "tags"
            },
            TemplateConfiguration: {
              shape: "S1d"
            },
            TreatmentDescription: {},
            TreatmentName: {},
            Priority: {
              type: "integer"
            }
          }
        },
        Sb: {
          type: "structure",
          members: {
            DeliveryUri: {},
            EndpointTypes: {
              shape: "Sc"
            }
          },
          required: [
            "DeliveryUri"
          ]
        },
        Sc: {
          type: "list",
          member: {}
        },
        Se: {
          type: "structure",
          members: {
            ADMMessage: {
              shape: "Sf"
            },
            APNSMessage: {
              shape: "Sf"
            },
            BaiduMessage: {
              shape: "Sf"
            },
            CustomMessage: {
              type: "structure",
              members: {
                Data: {}
              }
            },
            DefaultMessage: {
              shape: "Sf"
            },
            EmailMessage: {
              type: "structure",
              members: {
                Body: {},
                FromAddress: {},
                HtmlBody: {},
                Title: {}
              }
            },
            GCMMessage: {
              shape: "Sf"
            },
            SMSMessage: {
              type: "structure",
              members: {
                Body: {},
                MessageType: {},
                OriginationNumber: {},
                SenderId: {},
                EntityId: {},
                TemplateId: {}
              }
            },
            InAppMessage: {
              type: "structure",
              members: {
                Body: {},
                Content: {
                  shape: "So"
                },
                CustomConfig: {
                  shape: "S4"
                },
                Layout: {}
              }
            }
          }
        },
        Sf: {
          type: "structure",
          members: {
            Action: {},
            Body: {},
            ImageIconUrl: {},
            ImageSmallIconUrl: {},
            ImageUrl: {},
            JsonBody: {},
            MediaUrl: {},
            RawContent: {},
            SilentPush: {
              type: "boolean"
            },
            TimeToLive: {
              type: "integer"
            },
            Title: {},
            Url: {}
          }
        },
        So: {
          type: "list",
          member: {
            type: "structure",
            members: {
              BackgroundColor: {},
              BodyConfig: {
                type: "structure",
                members: {
                  Alignment: {},
                  Body: {},
                  TextColor: {}
                },
                required: [
                  "Alignment",
                  "TextColor",
                  "Body"
                ]
              },
              HeaderConfig: {
                type: "structure",
                members: {
                  Alignment: {},
                  Header: {},
                  TextColor: {}
                },
                required: [
                  "Alignment",
                  "Header",
                  "TextColor"
                ]
              },
              ImageUrl: {},
              PrimaryBtn: {
                shape: "St"
              },
              SecondaryBtn: {
                shape: "St"
              }
            }
          }
        },
        St: {
          type: "structure",
          members: {
            Android: {
              shape: "Su"
            },
            DefaultConfig: {
              type: "structure",
              members: {
                BackgroundColor: {},
                BorderRadius: {
                  type: "integer"
                },
                ButtonAction: {},
                Link: {},
                Text: {},
                TextColor: {}
              },
              required: [
                "ButtonAction",
                "Text"
              ]
            },
            IOS: {
              shape: "Su"
            },
            Web: {
              shape: "Su"
            }
          }
        },
        Su: {
          type: "structure",
          members: {
            ButtonAction: {},
            Link: {}
          },
          required: [
            "ButtonAction"
          ]
        },
        Sy: {
          type: "structure",
          members: {
            EndTime: {},
            EventFilter: {
              shape: "Sz"
            },
            Frequency: {},
            IsLocalTime: {
              type: "boolean"
            },
            QuietTime: {
              shape: "S1c"
            },
            StartTime: {},
            Timezone: {}
          },
          required: [
            "StartTime"
          ]
        },
        Sz: {
          type: "structure",
          members: {
            Dimensions: {
              shape: "S10"
            },
            FilterType: {}
          },
          required: [
            "FilterType",
            "Dimensions"
          ]
        },
        S10: {
          type: "structure",
          members: {
            Attributes: {
              shape: "S11"
            },
            EventType: {
              shape: "S15"
            },
            Metrics: {
              shape: "S17"
            }
          }
        },
        S11: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              AttributeType: {},
              Values: {
                shape: "S14"
              }
            },
            required: [
              "Values"
            ]
          }
        },
        S14: {
          type: "list",
          member: {}
        },
        S15: {
          type: "structure",
          members: {
            DimensionType: {},
            Values: {
              shape: "S14"
            }
          },
          required: [
            "Values"
          ]
        },
        S17: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              ComparisonOperator: {},
              Value: {
                type: "double"
              }
            },
            required: [
              "ComparisonOperator",
              "Value"
            ]
          }
        },
        S1c: {
          type: "structure",
          members: {
            End: {},
            Start: {}
          }
        },
        S1d: {
          type: "structure",
          members: {
            EmailTemplate: {
              shape: "S1e"
            },
            PushTemplate: {
              shape: "S1e"
            },
            SMSTemplate: {
              shape: "S1e"
            },
            VoiceTemplate: {
              shape: "S1e"
            },
            InAppTemplate: {
              shape: "S1e"
            }
          }
        },
        S1e: {
          type: "structure",
          members: {
            Name: {},
            Version: {}
          }
        },
        S1f: {
          type: "structure",
          members: {
            LambdaFunctionName: {},
            Mode: {},
            WebUrl: {}
          }
        },
        S1h: {
          type: "structure",
          members: {
            Daily: {
              type: "integer"
            },
            MaximumDuration: {
              type: "integer"
            },
            MessagesPerSecond: {
              type: "integer"
            },
            Total: {
              type: "integer"
            },
            Session: {
              type: "integer"
            }
          }
        },
        S1j: {
          type: "structure",
          members: {
            AdditionalTreatments: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  CustomDeliveryConfiguration: {
                    shape: "Sb"
                  },
                  Id: {},
                  MessageConfiguration: {
                    shape: "Se"
                  },
                  Schedule: {
                    shape: "Sy"
                  },
                  SizePercent: {
                    type: "integer"
                  },
                  State: {
                    shape: "S1m"
                  },
                  TemplateConfiguration: {
                    shape: "S1d"
                  },
                  TreatmentDescription: {},
                  TreatmentName: {}
                },
                required: [
                  "Id",
                  "SizePercent"
                ]
              }
            },
            ApplicationId: {},
            Arn: {},
            CreationDate: {},
            CustomDeliveryConfiguration: {
              shape: "Sb"
            },
            DefaultState: {
              shape: "S1m"
            },
            Description: {},
            HoldoutPercent: {
              type: "integer"
            },
            Hook: {
              shape: "S1f"
            },
            Id: {},
            IsPaused: {
              type: "boolean"
            },
            LastModifiedDate: {},
            Limits: {
              shape: "S1h"
            },
            MessageConfiguration: {
              shape: "Se"
            },
            Name: {},
            Schedule: {
              shape: "Sy"
            },
            SegmentId: {},
            SegmentVersion: {
              type: "integer"
            },
            State: {
              shape: "S1m"
            },
            tags: {
              shape: "S4",
              locationName: "tags"
            },
            TemplateConfiguration: {
              shape: "S1d"
            },
            TreatmentDescription: {},
            TreatmentName: {},
            Version: {
              type: "integer"
            },
            Priority: {
              type: "integer"
            }
          },
          required: [
            "LastModifiedDate",
            "CreationDate",
            "SegmentId",
            "SegmentVersion",
            "Id",
            "Arn",
            "ApplicationId"
          ]
        },
        S1m: {
          type: "structure",
          members: {
            CampaignStatus: {}
          }
        },
        S1p: {
          type: "structure",
          members: {
            DefaultSubstitutions: {},
            HtmlPart: {},
            RecommenderId: {},
            Subject: {},
            tags: {
              shape: "S4",
              locationName: "tags"
            },
            TemplateDescription: {},
            TextPart: {}
          }
        },
        S1r: {
          type: "structure",
          members: {
            Arn: {},
            Message: {},
            RequestID: {}
          }
        },
        S1v: {
          type: "structure",
          members: {
            ApplicationId: {},
            CompletedPieces: {
              type: "integer"
            },
            CompletionDate: {},
            CreationDate: {},
            Definition: {
              type: "structure",
              members: {
                RoleArn: {},
                S3UrlPrefix: {},
                SegmentId: {},
                SegmentVersion: {
                  type: "integer"
                }
              },
              required: [
                "S3UrlPrefix",
                "RoleArn"
              ]
            },
            FailedPieces: {
              type: "integer"
            },
            Failures: {
              shape: "S14"
            },
            Id: {},
            JobStatus: {},
            TotalFailures: {
              type: "integer"
            },
            TotalPieces: {
              type: "integer"
            },
            TotalProcessed: {
              type: "integer"
            },
            Type: {}
          },
          required: [
            "JobStatus",
            "CreationDate",
            "Type",
            "Definition",
            "Id",
            "ApplicationId"
          ]
        },
        S22: {
          type: "structure",
          members: {
            ApplicationId: {},
            CompletedPieces: {
              type: "integer"
            },
            CompletionDate: {},
            CreationDate: {},
            Definition: {
              type: "structure",
              members: {
                DefineSegment: {
                  type: "boolean"
                },
                ExternalId: {},
                Format: {},
                RegisterEndpoints: {
                  type: "boolean"
                },
                RoleArn: {},
                S3Url: {},
                SegmentId: {},
                SegmentName: {}
              },
              required: [
                "Format",
                "S3Url",
                "RoleArn"
              ]
            },
            FailedPieces: {
              type: "integer"
            },
            Failures: {
              shape: "S14"
            },
            Id: {},
            JobStatus: {},
            TotalFailures: {
              type: "integer"
            },
            TotalPieces: {
              type: "integer"
            },
            TotalProcessed: {
              type: "integer"
            },
            Type: {}
          },
          required: [
            "JobStatus",
            "CreationDate",
            "Type",
            "Definition",
            "Id",
            "ApplicationId"
          ]
        },
        S25: {
          type: "structure",
          members: {
            Content: {
              shape: "So"
            },
            CustomConfig: {
              shape: "S4"
            },
            Layout: {},
            tags: {
              shape: "S4",
              locationName: "tags"
            },
            TemplateDescription: {}
          }
        },
        S29: {
          type: "structure",
          members: {
            Activities: {
              shape: "S2a"
            },
            CreationDate: {},
            LastModifiedDate: {},
            Limits: {
              shape: "S3a"
            },
            LocalTime: {
              type: "boolean"
            },
            Name: {},
            QuietTime: {
              shape: "S1c"
            },
            RefreshFrequency: {},
            Schedule: {
              shape: "S3c"
            },
            StartActivity: {},
            StartCondition: {
              shape: "S3e"
            },
            State: {},
            WaitForQuietTime: {
              type: "boolean"
            },
            RefreshOnSegmentUpdate: {
              type: "boolean"
            },
            JourneyChannelSettings: {
              shape: "S3i"
            },
            SendingSchedule: {
              type: "boolean"
            },
            OpenHours: {
              shape: "S3j"
            },
            ClosedDays: {
              shape: "S3o"
            },
            TimezoneEstimationMethods: {
              shape: "S3r"
            }
          },
          required: [
            "Name"
          ]
        },
        S2a: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              CUSTOM: {
                type: "structure",
                members: {
                  DeliveryUri: {},
                  EndpointTypes: {
                    shape: "Sc"
                  },
                  MessageConfig: {
                    type: "structure",
                    members: {
                      Data: {}
                    }
                  },
                  NextActivity: {},
                  TemplateName: {},
                  TemplateVersion: {}
                }
              },
              ConditionalSplit: {
                type: "structure",
                members: {
                  Condition: {
                    type: "structure",
                    members: {
                      Conditions: {
                        type: "list",
                        member: {
                          shape: "S2h"
                        }
                      },
                      Operator: {}
                    }
                  },
                  EvaluationWaitTime: {
                    shape: "S2u"
                  },
                  FalseActivity: {},
                  TrueActivity: {}
                }
              },
              Description: {},
              EMAIL: {
                type: "structure",
                members: {
                  MessageConfig: {
                    type: "structure",
                    members: {
                      FromAddress: {}
                    }
                  },
                  NextActivity: {},
                  TemplateName: {},
                  TemplateVersion: {}
                }
              },
              Holdout: {
                type: "structure",
                members: {
                  NextActivity: {},
                  Percentage: {
                    type: "integer"
                  }
                },
                required: [
                  "Percentage"
                ]
              },
              MultiCondition: {
                type: "structure",
                members: {
                  Branches: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Condition: {
                          shape: "S2h"
                        },
                        NextActivity: {}
                      }
                    }
                  },
                  DefaultActivity: {},
                  EvaluationWaitTime: {
                    shape: "S2u"
                  }
                }
              },
              PUSH: {
                type: "structure",
                members: {
                  MessageConfig: {
                    type: "structure",
                    members: {
                      TimeToLive: {}
                    }
                  },
                  NextActivity: {},
                  TemplateName: {},
                  TemplateVersion: {}
                }
              },
              RandomSplit: {
                type: "structure",
                members: {
                  Branches: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        NextActivity: {},
                        Percentage: {
                          type: "integer"
                        }
                      }
                    }
                  }
                }
              },
              SMS: {
                type: "structure",
                members: {
                  MessageConfig: {
                    type: "structure",
                    members: {
                      MessageType: {},
                      OriginationNumber: {},
                      SenderId: {},
                      EntityId: {},
                      TemplateId: {}
                    }
                  },
                  NextActivity: {},
                  TemplateName: {},
                  TemplateVersion: {}
                }
              },
              Wait: {
                type: "structure",
                members: {
                  NextActivity: {},
                  WaitTime: {
                    shape: "S2u"
                  }
                }
              },
              ContactCenter: {
                type: "structure",
                members: {
                  NextActivity: {}
                }
              }
            }
          }
        },
        S2h: {
          type: "structure",
          members: {
            EventCondition: {
              type: "structure",
              members: {
                Dimensions: {
                  shape: "S10"
                },
                MessageActivity: {}
              }
            },
            SegmentCondition: {
              shape: "S2j"
            },
            SegmentDimensions: {
              shape: "S2k",
              locationName: "segmentDimensions"
            }
          }
        },
        S2j: {
          type: "structure",
          members: {
            SegmentId: {}
          },
          required: [
            "SegmentId"
          ]
        },
        S2k: {
          type: "structure",
          members: {
            Attributes: {
              shape: "S11"
            },
            Behavior: {
              type: "structure",
              members: {
                Recency: {
                  type: "structure",
                  members: {
                    Duration: {},
                    RecencyType: {}
                  },
                  required: [
                    "Duration",
                    "RecencyType"
                  ]
                }
              }
            },
            Demographic: {
              type: "structure",
              members: {
                AppVersion: {
                  shape: "S15"
                },
                Channel: {
                  shape: "S15"
                },
                DeviceType: {
                  shape: "S15"
                },
                Make: {
                  shape: "S15"
                },
                Model: {
                  shape: "S15"
                },
                Platform: {
                  shape: "S15"
                }
              }
            },
            Location: {
              type: "structure",
              members: {
                Country: {
                  shape: "S15"
                },
                GPSPoint: {
                  type: "structure",
                  members: {
                    Coordinates: {
                      type: "structure",
                      members: {
                        Latitude: {
                          type: "double"
                        },
                        Longitude: {
                          type: "double"
                        }
                      },
                      required: [
                        "Latitude",
                        "Longitude"
                      ]
                    },
                    RangeInKilometers: {
                      type: "double"
                    }
                  },
                  required: [
                    "Coordinates"
                  ]
                }
              }
            },
            Metrics: {
              shape: "S17"
            },
            UserAttributes: {
              shape: "S11"
            }
          }
        },
        S2u: {
          type: "structure",
          members: {
            WaitFor: {},
            WaitUntil: {}
          }
        },
        S3a: {
          type: "structure",
          members: {
            DailyCap: {
              type: "integer"
            },
            EndpointReentryCap: {
              type: "integer"
            },
            MessagesPerSecond: {
              type: "integer"
            },
            EndpointReentryInterval: {},
            TimeframeCap: {
              shape: "S3b"
            },
            TotalCap: {
              type: "integer"
            }
          }
        },
        S3b: {
          type: "structure",
          members: {
            Cap: {
              type: "integer"
            },
            Days: {
              type: "integer"
            }
          }
        },
        S3c: {
          type: "structure",
          members: {
            EndTime: {
              shape: "S3d"
            },
            StartTime: {
              shape: "S3d"
            },
            Timezone: {}
          }
        },
        S3d: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S3e: {
          type: "structure",
          members: {
            Description: {},
            EventStartCondition: {
              type: "structure",
              members: {
                EventFilter: {
                  type: "structure",
                  members: {
                    Dimensions: {
                      shape: "S10"
                    },
                    FilterType: {}
                  },
                  required: [
                    "FilterType",
                    "Dimensions"
                  ]
                },
                SegmentId: {}
              }
            },
            SegmentStartCondition: {
              shape: "S2j"
            }
          }
        },
        S3i: {
          type: "structure",
          members: {
            ConnectCampaignArn: {},
            ConnectCampaignExecutionRoleArn: {}
          }
        },
        S3j: {
          type: "structure",
          members: {
            EMAIL: {
              shape: "S3k"
            },
            SMS: {
              shape: "S3k"
            },
            PUSH: {
              shape: "S3k"
            },
            VOICE: {
              shape: "S3k"
            },
            CUSTOM: {
              shape: "S3k"
            }
          }
        },
        S3k: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {
              type: "structure",
              members: {
                StartTime: {},
                EndTime: {}
              }
            }
          }
        },
        S3o: {
          type: "structure",
          members: {
            EMAIL: {
              shape: "S3p"
            },
            SMS: {
              shape: "S3p"
            },
            PUSH: {
              shape: "S3p"
            },
            VOICE: {
              shape: "S3p"
            },
            CUSTOM: {
              shape: "S3p"
            }
          }
        },
        S3p: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              StartDateTime: {},
              EndDateTime: {}
            }
          }
        },
        S3r: {
          type: "list",
          member: {}
        },
        S3u: {
          type: "structure",
          members: {
            Activities: {
              shape: "S2a"
            },
            ApplicationId: {},
            CreationDate: {},
            Id: {},
            LastModifiedDate: {},
            Limits: {
              shape: "S3a"
            },
            LocalTime: {
              type: "boolean"
            },
            Name: {},
            QuietTime: {
              shape: "S1c"
            },
            RefreshFrequency: {},
            Schedule: {
              shape: "S3c"
            },
            StartActivity: {},
            StartCondition: {
              shape: "S3e"
            },
            State: {},
            tags: {
              shape: "S4",
              locationName: "tags"
            },
            WaitForQuietTime: {
              type: "boolean"
            },
            RefreshOnSegmentUpdate: {
              type: "boolean"
            },
            JourneyChannelSettings: {
              shape: "S3i"
            },
            SendingSchedule: {
              type: "boolean"
            },
            OpenHours: {
              shape: "S3j"
            },
            ClosedDays: {
              shape: "S3o"
            },
            TimezoneEstimationMethods: {
              shape: "S3r"
            }
          },
          required: [
            "Name",
            "Id",
            "ApplicationId"
          ]
        },
        S3w: {
          type: "structure",
          members: {
            ADM: {
              shape: "S3x"
            },
            APNS: {
              shape: "S3y"
            },
            Baidu: {
              shape: "S3x"
            },
            Default: {
              shape: "S3z"
            },
            DefaultSubstitutions: {},
            GCM: {
              shape: "S3x"
            },
            RecommenderId: {},
            tags: {
              shape: "S4",
              locationName: "tags"
            },
            TemplateDescription: {}
          }
        },
        S3x: {
          type: "structure",
          members: {
            Action: {},
            Body: {},
            ImageIconUrl: {},
            ImageUrl: {},
            RawContent: {},
            SmallImageIconUrl: {},
            Sound: {},
            Title: {},
            Url: {}
          }
        },
        S3y: {
          type: "structure",
          members: {
            Action: {},
            Body: {},
            MediaUrl: {},
            RawContent: {},
            Sound: {},
            Title: {},
            Url: {}
          }
        },
        S3z: {
          type: "structure",
          members: {
            Action: {},
            Body: {},
            Sound: {},
            Title: {},
            Url: {}
          }
        },
        S44: {
          type: "structure",
          members: {
            Attributes: {
              shape: "S4"
            },
            CreationDate: {},
            Description: {},
            Id: {},
            LastModifiedDate: {},
            Name: {},
            RecommendationProviderIdType: {},
            RecommendationProviderRoleArn: {},
            RecommendationProviderUri: {},
            RecommendationTransformerUri: {},
            RecommendationsDisplayName: {},
            RecommendationsPerMessage: {
              type: "integer"
            }
          },
          required: [
            "RecommendationProviderUri",
            "LastModifiedDate",
            "CreationDate",
            "RecommendationProviderRoleArn",
            "Id"
          ]
        },
        S46: {
          type: "structure",
          members: {
            Dimensions: {
              shape: "S2k"
            },
            Name: {},
            SegmentGroups: {
              shape: "S47"
            },
            tags: {
              shape: "S4",
              locationName: "tags"
            }
          }
        },
        S47: {
          type: "structure",
          members: {
            Groups: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Dimensions: {
                    type: "list",
                    member: {
                      shape: "S2k"
                    }
                  },
                  SourceSegments: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Id: {},
                        Version: {
                          type: "integer"
                        }
                      },
                      required: [
                        "Id"
                      ]
                    }
                  },
                  SourceType: {},
                  Type: {}
                }
              }
            },
            Include: {}
          }
        },
        S4h: {
          type: "structure",
          members: {
            ApplicationId: {},
            Arn: {},
            CreationDate: {},
            Dimensions: {
              shape: "S2k"
            },
            Id: {},
            ImportDefinition: {
              type: "structure",
              members: {
                ChannelCounts: {
                  type: "map",
                  key: {},
                  value: {
                    type: "integer"
                  }
                },
                ExternalId: {},
                Format: {},
                RoleArn: {},
                S3Url: {},
                Size: {
                  type: "integer"
                }
              },
              required: [
                "Format",
                "S3Url",
                "Size",
                "ExternalId",
                "RoleArn"
              ]
            },
            LastModifiedDate: {},
            Name: {},
            SegmentGroups: {
              shape: "S47"
            },
            SegmentType: {},
            tags: {
              shape: "S4",
              locationName: "tags"
            },
            Version: {
              type: "integer"
            }
          },
          required: [
            "SegmentType",
            "CreationDate",
            "Id",
            "Arn",
            "ApplicationId"
          ]
        },
        S4m: {
          type: "structure",
          members: {
            Body: {},
            DefaultSubstitutions: {},
            RecommenderId: {},
            tags: {
              shape: "S4",
              locationName: "tags"
            },
            TemplateDescription: {}
          }
        },
        S4p: {
          type: "structure",
          members: {
            Body: {},
            DefaultSubstitutions: {},
            LanguageCode: {},
            tags: {
              shape: "S4",
              locationName: "tags"
            },
            TemplateDescription: {},
            VoiceId: {}
          }
        },
        S4t: {
          type: "structure",
          members: {
            ApplicationId: {},
            CreationDate: {},
            Enabled: {
              type: "boolean"
            },
            HasCredential: {
              type: "boolean"
            },
            Id: {},
            IsArchived: {
              type: "boolean"
            },
            LastModifiedBy: {},
            LastModifiedDate: {},
            Platform: {},
            Version: {
              type: "integer"
            }
          },
          required: [
            "Platform"
          ]
        },
        S4w: {
          type: "structure",
          members: {
            ApplicationId: {},
            CreationDate: {},
            DefaultAuthenticationMethod: {},
            Enabled: {
              type: "boolean"
            },
            HasCredential: {
              type: "boolean"
            },
            HasTokenKey: {
              type: "boolean"
            },
            Id: {},
            IsArchived: {
              type: "boolean"
            },
            LastModifiedBy: {},
            LastModifiedDate: {},
            Platform: {},
            Version: {
              type: "integer"
            }
          },
          required: [
            "Platform"
          ]
        },
        S4z: {
          type: "structure",
          members: {
            ApplicationId: {},
            CreationDate: {},
            DefaultAuthenticationMethod: {},
            Enabled: {
              type: "boolean"
            },
            HasCredential: {
              type: "boolean"
            },
            HasTokenKey: {
              type: "boolean"
            },
            Id: {},
            IsArchived: {
              type: "boolean"
            },
            LastModifiedBy: {},
            LastModifiedDate: {},
            Platform: {},
            Version: {
              type: "integer"
            }
          },
          required: [
            "Platform"
          ]
        },
        S52: {
          type: "structure",
          members: {
            ApplicationId: {},
            CreationDate: {},
            DefaultAuthenticationMethod: {},
            Enabled: {
              type: "boolean"
            },
            HasCredential: {
              type: "boolean"
            },
            HasTokenKey: {
              type: "boolean"
            },
            Id: {},
            IsArchived: {
              type: "boolean"
            },
            LastModifiedBy: {},
            LastModifiedDate: {},
            Platform: {},
            Version: {
              type: "integer"
            }
          },
          required: [
            "Platform"
          ]
        },
        S55: {
          type: "structure",
          members: {
            ApplicationId: {},
            CreationDate: {},
            DefaultAuthenticationMethod: {},
            Enabled: {
              type: "boolean"
            },
            HasCredential: {
              type: "boolean"
            },
            HasTokenKey: {
              type: "boolean"
            },
            Id: {},
            IsArchived: {
              type: "boolean"
            },
            LastModifiedBy: {},
            LastModifiedDate: {},
            Platform: {},
            Version: {
              type: "integer"
            }
          },
          required: [
            "Platform"
          ]
        },
        S5a: {
          type: "structure",
          members: {
            ApplicationId: {},
            CreationDate: {},
            Credential: {},
            Enabled: {
              type: "boolean"
            },
            HasCredential: {
              type: "boolean"
            },
            Id: {},
            IsArchived: {
              type: "boolean"
            },
            LastModifiedBy: {},
            LastModifiedDate: {},
            Platform: {},
            Version: {
              type: "integer"
            }
          },
          required: [
            "Credential",
            "Platform"
          ]
        },
        S5f: {
          type: "structure",
          members: {
            ApplicationId: {},
            ConfigurationSet: {},
            CreationDate: {},
            Enabled: {
              type: "boolean"
            },
            FromAddress: {},
            HasCredential: {
              type: "boolean"
            },
            Id: {},
            Identity: {},
            IsArchived: {
              type: "boolean"
            },
            LastModifiedBy: {},
            LastModifiedDate: {},
            MessagesPerSecond: {
              type: "integer"
            },
            Platform: {},
            RoleArn: {},
            Version: {
              type: "integer"
            }
          },
          required: [
            "Platform"
          ]
        },
        S5i: {
          type: "structure",
          members: {
            Message: {},
            RequestID: {}
          }
        },
        S5l: {
          type: "structure",
          members: {
            Address: {},
            ApplicationId: {},
            Attributes: {
              shape: "S5m"
            },
            ChannelType: {},
            CohortId: {},
            CreationDate: {},
            Demographic: {
              shape: "S5o"
            },
            EffectiveDate: {},
            EndpointStatus: {},
            Id: {},
            Location: {
              shape: "S5p"
            },
            Metrics: {
              shape: "S5q"
            },
            OptOut: {},
            RequestId: {},
            User: {
              shape: "S5r"
            }
          }
        },
        S5m: {
          type: "map",
          key: {},
          value: {
            shape: "S14"
          }
        },
        S5o: {
          type: "structure",
          members: {
            AppVersion: {},
            Locale: {},
            Make: {},
            Model: {},
            ModelVersion: {},
            Platform: {},
            PlatformVersion: {},
            Timezone: {}
          }
        },
        S5p: {
          type: "structure",
          members: {
            City: {},
            Country: {},
            Latitude: {
              type: "double"
            },
            Longitude: {
              type: "double"
            },
            PostalCode: {},
            Region: {}
          }
        },
        S5q: {
          type: "map",
          key: {},
          value: {
            type: "double"
          }
        },
        S5r: {
          type: "structure",
          members: {
            UserAttributes: {
              shape: "S5m"
            },
            UserId: {}
          }
        },
        S5u: {
          type: "structure",
          members: {
            ApplicationId: {},
            DestinationStreamArn: {},
            ExternalId: {},
            LastModifiedDate: {},
            LastUpdatedBy: {},
            RoleArn: {}
          },
          required: [
            "ApplicationId",
            "RoleArn",
            "DestinationStreamArn"
          ]
        },
        S5x: {
          type: "structure",
          members: {
            ApplicationId: {},
            CreationDate: {},
            Credential: {},
            DefaultAuthenticationMethod: {},
            Enabled: {
              type: "boolean"
            },
            HasCredential: {
              type: "boolean"
            },
            HasFcmServiceCredentials: {
              type: "boolean"
            },
            Id: {},
            IsArchived: {
              type: "boolean"
            },
            LastModifiedBy: {},
            LastModifiedDate: {},
            Platform: {},
            Version: {
              type: "integer"
            }
          },
          required: [
            "Platform"
          ]
        },
        S6a: {
          type: "structure",
          members: {
            ApplicationId: {},
            CreationDate: {},
            Enabled: {
              type: "boolean"
            },
            HasCredential: {
              type: "boolean"
            },
            Id: {},
            IsArchived: {
              type: "boolean"
            },
            LastModifiedBy: {},
            LastModifiedDate: {},
            Platform: {},
            PromotionalMessagesPerSecond: {
              type: "integer"
            },
            SenderId: {},
            ShortCode: {},
            TransactionalMessagesPerSecond: {
              type: "integer"
            },
            Version: {
              type: "integer"
            }
          },
          required: [
            "Platform"
          ]
        },
        S6f: {
          type: "structure",
          members: {
            Item: {
              type: "list",
              member: {
                shape: "S5l"
              }
            }
          },
          required: [
            "Item"
          ]
        },
        S6j: {
          type: "structure",
          members: {
            ApplicationId: {},
            CreationDate: {},
            Enabled: {
              type: "boolean"
            },
            HasCredential: {
              type: "boolean"
            },
            Id: {},
            IsArchived: {
              type: "boolean"
            },
            LastModifiedBy: {},
            LastModifiedDate: {},
            Platform: {},
            Version: {
              type: "integer"
            }
          },
          required: [
            "Platform"
          ]
        },
        S71: {
          type: "structure",
          members: {
            Rows: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  GroupedBys: {
                    shape: "S74"
                  },
                  Values: {
                    shape: "S74"
                  }
                },
                required: [
                  "GroupedBys",
                  "Values"
                ]
              }
            }
          },
          required: [
            "Rows"
          ]
        },
        S74: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Type: {},
              Value: {}
            },
            required: [
              "Type",
              "Value",
              "Key"
            ]
          }
        },
        S78: {
          type: "structure",
          members: {
            ApplicationId: {},
            CampaignHook: {
              shape: "S1f"
            },
            LastModifiedDate: {},
            Limits: {
              shape: "S1h"
            },
            QuietTime: {
              shape: "S1c"
            },
            JourneyLimits: {
              shape: "S79"
            }
          },
          required: [
            "ApplicationId"
          ]
        },
        S79: {
          type: "structure",
          members: {
            DailyCap: {
              type: "integer"
            },
            TimeframeCap: {
              shape: "S3b"
            },
            TotalCap: {
              type: "integer"
            }
          }
        },
        S7u: {
          type: "structure",
          members: {
            Item: {
              type: "list",
              member: {
                shape: "S1j"
              }
            },
            NextToken: {}
          },
          required: [
            "Item"
          ]
        },
        S8h: {
          type: "structure",
          members: {
            Item: {
              type: "list",
              member: {
                shape: "S1v"
              }
            },
            NextToken: {}
          },
          required: [
            "Item"
          ]
        },
        S8p: {
          type: "structure",
          members: {
            Item: {
              type: "list",
              member: {
                shape: "S22"
              }
            },
            NextToken: {}
          },
          required: [
            "Item"
          ]
        },
        Sa7: {
          type: "structure",
          members: {
            Item: {
              type: "list",
              member: {
                shape: "S4h"
              }
            },
            NextToken: {}
          },
          required: [
            "Item"
          ]
        },
        Sat: {
          type: "structure",
          members: {
            tags: {
              shape: "S4",
              locationName: "tags"
            }
          },
          required: [
            "tags"
          ]
        },
        Sby: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              BodyOverride: {},
              Context: {
                shape: "S4"
              },
              RawContent: {},
              Substitutions: {
                shape: "S5m"
              },
              TitleOverride: {}
            }
          }
        },
        Sc0: {
          type: "structure",
          members: {
            ADMMessage: {
              type: "structure",
              members: {
                Action: {},
                Body: {},
                ConsolidationKey: {},
                Data: {
                  shape: "S4"
                },
                ExpiresAfter: {},
                IconReference: {},
                ImageIconUrl: {},
                ImageUrl: {},
                MD5: {},
                RawContent: {},
                SilentPush: {
                  type: "boolean"
                },
                SmallImageIconUrl: {},
                Sound: {},
                Substitutions: {
                  shape: "S5m"
                },
                Title: {},
                Url: {}
              }
            },
            APNSMessage: {
              type: "structure",
              members: {
                APNSPushType: {},
                Action: {},
                Badge: {
                  type: "integer"
                },
                Body: {},
                Category: {},
                CollapseId: {},
                Data: {
                  shape: "S4"
                },
                MediaUrl: {},
                PreferredAuthenticationMethod: {},
                Priority: {},
                RawContent: {},
                SilentPush: {
                  type: "boolean"
                },
                Sound: {},
                Substitutions: {
                  shape: "S5m"
                },
                ThreadId: {},
                TimeToLive: {
                  type: "integer"
                },
                Title: {},
                Url: {}
              }
            },
            BaiduMessage: {
              type: "structure",
              members: {
                Action: {},
                Body: {},
                Data: {
                  shape: "S4"
                },
                IconReference: {},
                ImageIconUrl: {},
                ImageUrl: {},
                RawContent: {},
                SilentPush: {
                  type: "boolean"
                },
                SmallImageIconUrl: {},
                Sound: {},
                Substitutions: {
                  shape: "S5m"
                },
                TimeToLive: {
                  type: "integer"
                },
                Title: {},
                Url: {}
              }
            },
            DefaultMessage: {
              type: "structure",
              members: {
                Body: {},
                Substitutions: {
                  shape: "S5m"
                }
              }
            },
            DefaultPushNotificationMessage: {
              type: "structure",
              members: {
                Action: {},
                Body: {},
                Data: {
                  shape: "S4"
                },
                SilentPush: {
                  type: "boolean"
                },
                Substitutions: {
                  shape: "S5m"
                },
                Title: {},
                Url: {}
              }
            },
            EmailMessage: {
              type: "structure",
              members: {
                Body: {},
                FeedbackForwardingAddress: {},
                FromAddress: {},
                RawEmail: {
                  type: "structure",
                  members: {
                    Data: {
                      type: "blob"
                    }
                  }
                },
                ReplyToAddresses: {
                  shape: "S14"
                },
                SimpleEmail: {
                  type: "structure",
                  members: {
                    HtmlPart: {
                      shape: "Sca"
                    },
                    Subject: {
                      shape: "Sca"
                    },
                    TextPart: {
                      shape: "Sca"
                    }
                  }
                },
                Substitutions: {
                  shape: "S5m"
                }
              }
            },
            GCMMessage: {
              type: "structure",
              members: {
                Action: {},
                Body: {},
                CollapseKey: {},
                Data: {
                  shape: "S4"
                },
                IconReference: {},
                ImageIconUrl: {},
                ImageUrl: {},
                PreferredAuthenticationMethod: {},
                Priority: {},
                RawContent: {},
                RestrictedPackageName: {},
                SilentPush: {
                  type: "boolean"
                },
                SmallImageIconUrl: {},
                Sound: {},
                Substitutions: {
                  shape: "S5m"
                },
                TimeToLive: {
                  type: "integer"
                },
                Title: {},
                Url: {}
              }
            },
            SMSMessage: {
              type: "structure",
              members: {
                Body: {},
                Keyword: {},
                MediaUrl: {},
                MessageType: {},
                OriginationNumber: {},
                SenderId: {},
                Substitutions: {
                  shape: "S5m"
                },
                EntityId: {},
                TemplateId: {}
              }
            },
            VoiceMessage: {
              type: "structure",
              members: {
                Body: {},
                LanguageCode: {},
                OriginationNumber: {},
                Substitutions: {
                  shape: "S5m"
                },
                VoiceId: {}
              }
            }
          }
        },
        Sca: {
          type: "structure",
          members: {
            Charset: {},
            Data: {}
          }
        },
        Scf: {
          type: "structure",
          members: {
            ApplicationId: {},
            EndpointResult: {
              shape: "Scg"
            },
            RequestId: {},
            Result: {
              type: "map",
              key: {},
              value: {
                type: "structure",
                members: {
                  DeliveryStatus: {},
                  MessageId: {},
                  StatusCode: {
                    type: "integer"
                  },
                  StatusMessage: {},
                  UpdatedToken: {}
                },
                required: [
                  "DeliveryStatus",
                  "StatusCode"
                ]
              }
            }
          },
          required: [
            "ApplicationId"
          ]
        },
        Scg: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              Address: {},
              DeliveryStatus: {},
              MessageId: {},
              StatusCode: {
                type: "integer"
              },
              StatusMessage: {},
              UpdatedToken: {}
            },
            required: [
              "DeliveryStatus",
              "StatusCode"
            ]
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/pinpoint.js
var require_pinpoint = __commonJS({
  "node_modules/aws-sdk/clients/pinpoint.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["pinpoint"] = {};
    AWS2.Pinpoint = Service.defineService("pinpoint", ["2016-12-01"]);
    Object.defineProperty(apiLoader.services["pinpoint"], "2016-12-01", {
      get: function get() {
        var model = require_pinpoint_2016_12_01_min();
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Pinpoint;
  }
});

// node_modules/aws-sdk/lib/polly/presigner.js
var require_presigner = __commonJS({
  "node_modules/aws-sdk/lib/polly/presigner.js"() {
    "use strict";
    var AWS2 = require_core();
    var rest = AWS2.Protocol.Rest;
    AWS2.Polly.Presigner = AWS2.util.inherit({
      /**
       * Creates a presigner object with a set of configuration options.
       *
       * @option options params [map] An optional map of parameters to bind to every
       *   request sent by this service object.
       * @option options service [AWS.Polly] An optional pre-configured instance
       *  of the AWS.Polly service object to use for requests. The object may
       *  bound parameters used by the presigner.
       * @see AWS.Polly.constructor
       */
      constructor: function Signer(options) {
        options = options || {};
        this.options = options;
        this.service = options.service;
        this.bindServiceObject(options);
        this._operations = {};
      },
      /**
       * @api private
       */
      bindServiceObject: function bindServiceObject(options) {
        options = options || {};
        if (!this.service) {
          this.service = new AWS2.Polly(options);
        } else {
          var config = AWS2.util.copy(this.service.config);
          this.service = new this.service.constructor.__super__(config);
          this.service.config.params = AWS2.util.merge(this.service.config.params || {}, options.params);
        }
      },
      /**
       * @api private
       */
      modifyInputMembers: function modifyInputMembers(input) {
        var modifiedInput = AWS2.util.copy(input);
        modifiedInput.members = AWS2.util.copy(input.members);
        AWS2.util.each(input.members, function(name, member) {
          modifiedInput.members[name] = AWS2.util.copy(member);
          if (!member.location || member.location === "body") {
            modifiedInput.members[name].location = "querystring";
            modifiedInput.members[name].locationName = name;
          }
        });
        return modifiedInput;
      },
      /**
       * @api private
       */
      convertPostToGet: function convertPostToGet(req) {
        req.httpRequest.method = "GET";
        var operation = req.service.api.operations[req.operation];
        var input = this._operations[req.operation];
        if (!input) {
          this._operations[req.operation] = input = this.modifyInputMembers(operation.input);
        }
        var uri = rest.generateURI(req.httpRequest.endpoint.path, operation.httpPath, input, req.params);
        req.httpRequest.path = uri;
        req.httpRequest.body = "";
        delete req.httpRequest.headers["Content-Length"];
        delete req.httpRequest.headers["Content-Type"];
      },
      /**
       * @overload getSynthesizeSpeechUrl(params = {}, [expires = 3600], [callback])
       *   Generate a presigned url for {AWS.Polly.synthesizeSpeech}.
       *   @note You must ensure that you have static or previously resolved
       *     credentials if you call this method synchronously (with no callback),
       *     otherwise it may not properly sign the request. If you cannot guarantee
       *     this (you are using an asynchronous credential provider, i.e., EC2
       *     IAM roles), you should always call this method with an asynchronous
       *     callback.
       *   @param params [map] parameters to pass to the operation. See the {AWS.Polly.synthesizeSpeech}
       *     operation for the expected operation parameters.
       *   @param expires [Integer] (3600) the number of seconds to expire the pre-signed URL operation in.
       *     Defaults to 1 hour.
       *   @return [string] if called synchronously (with no callback), returns the signed URL.
       *   @return [null] nothing is returned if a callback is provided.
       *   @callback callback function (err, url)
       *     If a callback is supplied, it is called when a signed URL has been generated.
       *     @param err [Error] the error object returned from the presigner.
       *     @param url [String] the signed URL.
       *   @see AWS.Polly.synthesizeSpeech
       */
      getSynthesizeSpeechUrl: function getSynthesizeSpeechUrl(params, expires, callback) {
        var self2 = this;
        var request = this.service.makeRequest("synthesizeSpeech", params);
        request.removeAllListeners("build");
        request.on("build", function(req) {
          self2.convertPostToGet(req);
        });
        return request.presign(expires, callback);
      }
    });
  }
});

// node_modules/aws-sdk/lib/services/polly.js
var require_polly = __commonJS({
  "node_modules/aws-sdk/lib/services/polly.js"() {
    "use strict";
    require_presigner();
  }
});

// node_modules/aws-sdk/apis/polly-2016-06-10.min.json
var require_polly_2016_06_10_min = __commonJS({
  "node_modules/aws-sdk/apis/polly-2016-06-10.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-06-10",
        endpointPrefix: "polly",
        protocol: "rest-json",
        serviceFullName: "Amazon Polly",
        serviceId: "Polly",
        signatureVersion: "v4",
        uid: "polly-2016-06-10"
      },
      operations: {
        DeleteLexicon: {
          http: {
            method: "DELETE",
            requestUri: "/v1/lexicons/{LexiconName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "LexiconName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeVoices: {
          http: {
            method: "GET",
            requestUri: "/v1/voices",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Engine: {
                location: "querystring",
                locationName: "Engine"
              },
              LanguageCode: {
                location: "querystring",
                locationName: "LanguageCode"
              },
              IncludeAdditionalLanguageCodes: {
                location: "querystring",
                locationName: "IncludeAdditionalLanguageCodes",
                type: "boolean"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Voices: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Gender: {},
                    Id: {},
                    LanguageCode: {},
                    LanguageName: {},
                    Name: {},
                    AdditionalLanguageCodes: {
                      type: "list",
                      member: {}
                    },
                    SupportedEngines: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetLexicon: {
          http: {
            method: "GET",
            requestUri: "/v1/lexicons/{LexiconName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "LexiconName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Lexicon: {
                type: "structure",
                members: {
                  Content: {
                    shape: "Sl"
                  },
                  Name: {}
                }
              },
              LexiconAttributes: {
                shape: "Sm"
              }
            }
          }
        },
        GetSpeechSynthesisTask: {
          http: {
            method: "GET",
            requestUri: "/v1/synthesisTasks/{TaskId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "TaskId"
            ],
            members: {
              TaskId: {
                location: "uri",
                locationName: "TaskId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SynthesisTask: {
                shape: "Sv"
              }
            }
          }
        },
        ListLexicons: {
          http: {
            method: "GET",
            requestUri: "/v1/lexicons",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Lexicons: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Attributes: {
                      shape: "Sm"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSpeechSynthesisTasks: {
          http: {
            method: "GET",
            requestUri: "/v1/synthesisTasks",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              Status: {
                location: "querystring",
                locationName: "Status"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              SynthesisTasks: {
                type: "list",
                member: {
                  shape: "Sv"
                }
              }
            }
          }
        },
        PutLexicon: {
          http: {
            method: "PUT",
            requestUri: "/v1/lexicons/{LexiconName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "Content"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "LexiconName"
              },
              Content: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartSpeechSynthesisTask: {
          http: {
            requestUri: "/v1/synthesisTasks",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "OutputFormat",
              "OutputS3BucketName",
              "Text",
              "VoiceId"
            ],
            members: {
              Engine: {},
              LanguageCode: {},
              LexiconNames: {
                shape: "S12"
              },
              OutputFormat: {},
              OutputS3BucketName: {},
              OutputS3KeyPrefix: {},
              SampleRate: {},
              SnsTopicArn: {},
              SpeechMarkTypes: {
                shape: "S15"
              },
              Text: {},
              TextType: {},
              VoiceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SynthesisTask: {
                shape: "Sv"
              }
            }
          }
        },
        SynthesizeSpeech: {
          http: {
            requestUri: "/v1/speech",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "OutputFormat",
              "Text",
              "VoiceId"
            ],
            members: {
              Engine: {},
              LanguageCode: {},
              LexiconNames: {
                shape: "S12"
              },
              OutputFormat: {},
              SampleRate: {},
              SpeechMarkTypes: {
                shape: "S15"
              },
              Text: {},
              TextType: {},
              VoiceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AudioStream: {
                type: "blob",
                streaming: true
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              RequestCharacters: {
                location: "header",
                locationName: "x-amzn-RequestCharacters",
                type: "integer"
              }
            },
            payload: "AudioStream"
          }
        }
      },
      shapes: {
        Sl: {
          type: "string",
          sensitive: true
        },
        Sm: {
          type: "structure",
          members: {
            Alphabet: {},
            LanguageCode: {},
            LastModified: {
              type: "timestamp"
            },
            LexiconArn: {},
            LexemesCount: {
              type: "integer"
            },
            Size: {
              type: "integer"
            }
          }
        },
        Sv: {
          type: "structure",
          members: {
            Engine: {},
            TaskId: {},
            TaskStatus: {},
            TaskStatusReason: {},
            OutputUri: {},
            CreationTime: {
              type: "timestamp"
            },
            RequestCharacters: {
              type: "integer"
            },
            SnsTopicArn: {},
            LexiconNames: {
              shape: "S12"
            },
            OutputFormat: {},
            SampleRate: {},
            SpeechMarkTypes: {
              shape: "S15"
            },
            TextType: {},
            VoiceId: {},
            LanguageCode: {}
          }
        },
        S12: {
          type: "list",
          member: {}
        },
        S15: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/polly-2016-06-10.paginators.json
var require_polly_2016_06_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/polly-2016-06-10.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListSpeechSynthesisTasks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/polly.js
var require_polly2 = __commonJS({
  "node_modules/aws-sdk/clients/polly.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["polly"] = {};
    AWS2.Polly = Service.defineService("polly", ["2016-06-10"]);
    require_polly();
    Object.defineProperty(apiLoader.services["polly"], "2016-06-10", {
      get: function get() {
        var model = require_polly_2016_06_10_min();
        model.paginators = require_polly_2016_06_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Polly;
  }
});

// node_modules/aws-sdk/lib/services/rdsutil.js
var require_rdsutil = __commonJS({
  "node_modules/aws-sdk/lib/services/rdsutil.js"(exports2, module2) {
    "use strict";
    var AWS2 = require_core();
    var rdsutil = {
      /**
        * @api private
        */
      setupRequestListeners: function setupRequestListeners(service, request, crossRegionOperations) {
        if (crossRegionOperations.indexOf(request.operation) !== -1 && request.params.SourceRegion) {
          request.params = AWS2.util.copy(request.params);
          if (request.params.PreSignedUrl || request.params.SourceRegion === service.config.region) {
            delete request.params.SourceRegion;
          } else {
            var doesParamValidation = !!service.config.paramValidation;
            if (doesParamValidation) {
              request.removeListener("validate", AWS2.EventListeners.Core.VALIDATE_PARAMETERS);
            }
            request.onAsync("validate", rdsutil.buildCrossRegionPresignedUrl);
            if (doesParamValidation) {
              request.addListener("validate", AWS2.EventListeners.Core.VALIDATE_PARAMETERS);
            }
          }
        }
      },
      /**
       * @api private
       */
      buildCrossRegionPresignedUrl: function buildCrossRegionPresignedUrl(req, done) {
        var config = AWS2.util.copy(req.service.config);
        config.region = req.params.SourceRegion;
        delete req.params.SourceRegion;
        delete config.endpoint;
        delete config.params;
        config.signatureVersion = "v4";
        var destinationRegion = req.service.config.region;
        var svc = new req.service.constructor(config);
        var newReq = svc[req.operation](AWS2.util.copy(req.params));
        newReq.on("build", function addDestinationRegionParam(request) {
          var httpRequest = request.httpRequest;
          httpRequest.params.DestinationRegion = destinationRegion;
          httpRequest.body = AWS2.util.queryParamsToString(httpRequest.params);
        });
        newReq.presign(function(err, url) {
          if (err)
            done(err);
          else {
            req.params.PreSignedUrl = url;
            done();
          }
        });
      }
    };
    module2.exports = rdsutil;
  }
});

// node_modules/aws-sdk/lib/rds/signer.js
var require_signer2 = __commonJS({
  "node_modules/aws-sdk/lib/rds/signer.js"() {
    "use strict";
    var AWS2 = require_core();
    var service = null;
    var api = {
      signatureVersion: "v4",
      signingName: "rds-db",
      operations: {}
    };
    var requiredAuthTokenOptions = {
      region: "string",
      hostname: "string",
      port: "number",
      username: "string"
    };
    AWS2.RDS.Signer = AWS2.util.inherit({
      /**
       * Creates a signer object can be used to generate an auth token.
       *
       * @option options credentials [AWS.Credentials] the AWS credentials
       *   to sign requests with. Uses the default credential provider chain
       *   if not specified.
       * @option options hostname [String] the hostname of the database to connect to.
       * @option options port [Number] the port number the database is listening on.
       * @option options region [String] the region the database is located in.
       * @option options username [String] the username to login as.
       * @example Passing in options to constructor
       *   var signer = new AWS.RDS.Signer({
       *     credentials: new AWS.SharedIniFileCredentials({profile: 'default'}),
       *     region: 'us-east-1',
       *     hostname: 'db.us-east-1.rds.amazonaws.com',
       *     port: 8000,
       *     username: 'name'
       *   });
       */
      constructor: function Signer(options) {
        this.options = options || {};
      },
      /**
       * @api private
       * Strips the protocol from a url.
       */
      convertUrlToAuthToken: function convertUrlToAuthToken(url) {
        var protocol = "https://";
        if (url.indexOf(protocol) === 0) {
          return url.substring(protocol.length);
        }
      },
      /**
       * @overload getAuthToken(options = {}, [callback])
       *   Generate an auth token to a database.
       *   @note You must ensure that you have static or previously resolved
       *     credentials if you call this method synchronously (with no callback),
       *     otherwise it may not properly sign the request. If you cannot guarantee
       *     this (you are using an asynchronous credential provider, i.e., EC2
       *     IAM roles), you should always call this method with an asynchronous
       *     callback.
       *
       *   @param options [map] The fields to use when generating an auth token.
       *     Any options specified here will be merged on top of any options passed
       *     to AWS.RDS.Signer:
       *
       *     * **credentials** (AWS.Credentials) &mdash; the AWS credentials
       *         to sign requests with. Uses the default credential provider chain
       *         if not specified.
       *     * **hostname** (String) &mdash; the hostname of the database to connect to.
       *     * **port** (Number) &mdash; the port number the database is listening on.
       *     * **region** (String) &mdash; the region the database is located in.
       *     * **username** (String) &mdash; the username to login as.
       *   @return [String] if called synchronously (with no callback), returns the
       *     auth token.
       *   @return [null] nothing is returned if a callback is provided.
       *   @callback callback function (err, token)
       *     If a callback is supplied, it is called when an auth token has been generated.
       *     @param err [Error] the error object returned from the signer.
       *     @param token [String] the auth token.
       *
       *   @example Generating an auth token synchronously
       *     var signer = new AWS.RDS.Signer({
       *       // configure options
       *       region: 'us-east-1',
       *       username: 'default',
       *       hostname: 'db.us-east-1.amazonaws.com',
       *       port: 8000
       *     });
       *     var token = signer.getAuthToken({
       *       // these options are merged with those defined when creating the signer, overriding in the case of a duplicate option
       *       // credentials are not specified here or when creating the signer, so default credential provider will be used
       *       username: 'test' // overriding username
       *     });
       *   @example Generating an auth token asynchronously
       *     var signer = new AWS.RDS.Signer({
       *       // configure options
       *       region: 'us-east-1',
       *       username: 'default',
       *       hostname: 'db.us-east-1.amazonaws.com',
       *       port: 8000
       *     });
       *     signer.getAuthToken({
       *       // these options are merged with those defined when creating the signer, overriding in the case of a duplicate option
       *       // credentials are not specified here or when creating the signer, so default credential provider will be used
       *       username: 'test' // overriding username
       *     }, function(err, token) {
       *       if (err) {
       *         // handle error
       *       } else {
       *         // use token
       *       }
       *     });
       *
       */
      getAuthToken: function getAuthToken(options, callback) {
        if (typeof options === "function" && callback === void 0) {
          callback = options;
          options = {};
        }
        var self2 = this;
        var hasCallback = typeof callback === "function";
        options = AWS2.util.merge(this.options, options);
        var optionsValidation = this.validateAuthTokenOptions(options);
        if (optionsValidation !== true) {
          if (hasCallback) {
            return callback(optionsValidation, null);
          }
          throw optionsValidation;
        }
        var expires = 900;
        var serviceOptions = {
          region: options.region,
          endpoint: new AWS2.Endpoint(options.hostname + ":" + options.port),
          paramValidation: false,
          signatureVersion: "v4"
        };
        if (options.credentials) {
          serviceOptions.credentials = options.credentials;
        }
        service = new AWS2.Service(serviceOptions);
        service.api = api;
        var request = service.makeRequest();
        this.modifyRequestForAuthToken(request, options);
        if (hasCallback) {
          request.presign(expires, function(err, url2) {
            if (url2) {
              url2 = self2.convertUrlToAuthToken(url2);
            }
            callback(err, url2);
          });
        } else {
          var url = request.presign(expires);
          return this.convertUrlToAuthToken(url);
        }
      },
      /**
       * @api private
       * Modifies a request to allow the presigner to generate an auth token.
       */
      modifyRequestForAuthToken: function modifyRequestForAuthToken(request, options) {
        request.on("build", request.buildAsGet);
        var httpRequest = request.httpRequest;
        httpRequest.body = AWS2.util.queryParamsToString({
          Action: "connect",
          DBUser: options.username
        });
      },
      /**
       * @api private
       * Validates that the options passed in contain all the keys with values of the correct type that
       *   are needed to generate an auth token.
       */
      validateAuthTokenOptions: function validateAuthTokenOptions(options) {
        var message = "";
        options = options || {};
        for (var key in requiredAuthTokenOptions) {
          if (!Object.prototype.hasOwnProperty.call(requiredAuthTokenOptions, key)) {
            continue;
          }
          if (typeof options[key] !== requiredAuthTokenOptions[key]) {
            message += "option '" + key + "' should have been type '" + requiredAuthTokenOptions[key] + "', was '" + typeof options[key] + "'.\n";
          }
        }
        if (message.length) {
          return AWS2.util.error(new Error(), {
            code: "InvalidParameter",
            message
          });
        }
        return true;
      }
    });
  }
});

// node_modules/aws-sdk/lib/services/rds.js
var require_rds = __commonJS({
  "node_modules/aws-sdk/lib/services/rds.js"() {
    "use strict";
    var AWS2 = require_core();
    var rdsutil = require_rdsutil();
    require_signer2();
    var crossRegionOperations = ["copyDBSnapshot", "createDBInstanceReadReplica", "createDBCluster", "copyDBClusterSnapshot", "startDBInstanceAutomatedBackupsReplication"];
    AWS2.util.update(AWS2.RDS.prototype, {
      /**
       * @api private
       */
      setupRequestListeners: function setupRequestListeners(request) {
        rdsutil.setupRequestListeners(this, request, crossRegionOperations);
      }
    });
  }
});

// node_modules/aws-sdk/apis/rds-2013-01-10.min.json
var require_rds_2013_01_10_min = __commonJS({
  "node_modules/aws-sdk/apis/rds-2013-01-10.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2013-01-10",
        endpointPrefix: "rds",
        protocol: "query",
        serviceAbbreviation: "Amazon RDS",
        serviceFullName: "Amazon Relational Database Service",
        serviceId: "RDS",
        signatureVersion: "v4",
        uid: "rds-2013-01-10",
        xmlNamespace: "http://rds.amazonaws.com/doc/2013-01-10/"
      },
      operations: {
        AddSourceIdentifierToSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SourceIdentifier"
            ],
            members: {
              SubscriptionName: {},
              SourceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "AddSourceIdentifierToSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        AddTagsToResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "Tags"
            ],
            members: {
              ResourceName: {},
              Tags: {
                shape: "S9"
              }
            }
          }
        },
        AuthorizeDBSecurityGroupIngress: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName"
            ],
            members: {
              DBSecurityGroupName: {},
              CIDRIP: {},
              EC2SecurityGroupName: {},
              EC2SecurityGroupId: {},
              EC2SecurityGroupOwnerId: {}
            }
          },
          output: {
            resultWrapper: "AuthorizeDBSecurityGroupIngressResult",
            type: "structure",
            members: {
              DBSecurityGroup: {
                shape: "Sd"
              }
            }
          }
        },
        CopyDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "SourceDBSnapshotIdentifier",
              "TargetDBSnapshotIdentifier"
            ],
            members: {
              SourceDBSnapshotIdentifier: {},
              TargetDBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "CopyDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "Sk"
              }
            }
          }
        },
        CreateDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "AllocatedStorage",
              "DBInstanceClass",
              "Engine",
              "MasterUsername",
              "MasterUserPassword"
            ],
            members: {
              DBName: {},
              DBInstanceIdentifier: {},
              AllocatedStorage: {
                type: "integer"
              },
              DBInstanceClass: {},
              Engine: {},
              MasterUsername: {},
              MasterUserPassword: {},
              DBSecurityGroups: {
                shape: "Sp"
              },
              VpcSecurityGroupIds: {
                shape: "Sq"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              PreferredMaintenanceWindow: {},
              DBParameterGroupName: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {},
              Port: {
                type: "integer"
              },
              MultiAZ: {
                type: "boolean"
              },
              EngineVersion: {},
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              CharacterSetName: {},
              PubliclyAccessible: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        CreateDBInstanceReadReplica: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "SourceDBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              SourceDBInstanceIdentifier: {},
              DBInstanceClass: {},
              AvailabilityZone: {},
              Port: {
                type: "integer"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              PubliclyAccessible: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBInstanceReadReplicaResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        CreateDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName",
              "DBParameterGroupFamily",
              "Description"
            ],
            members: {
              DBParameterGroupName: {},
              DBParameterGroupFamily: {},
              Description: {}
            }
          },
          output: {
            resultWrapper: "CreateDBParameterGroupResult",
            type: "structure",
            members: {
              DBParameterGroup: {
                shape: "S1c"
              }
            }
          }
        },
        CreateDBSecurityGroup: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName",
              "DBSecurityGroupDescription"
            ],
            members: {
              DBSecurityGroupName: {},
              DBSecurityGroupDescription: {}
            }
          },
          output: {
            resultWrapper: "CreateDBSecurityGroupResult",
            type: "structure",
            members: {
              DBSecurityGroup: {
                shape: "Sd"
              }
            }
          }
        },
        CreateDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBSnapshotIdentifier",
              "DBInstanceIdentifier"
            ],
            members: {
              DBSnapshotIdentifier: {},
              DBInstanceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "CreateDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "Sk"
              }
            }
          }
        },
        CreateDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName",
              "DBSubnetGroupDescription",
              "SubnetIds"
            ],
            members: {
              DBSubnetGroupName: {},
              DBSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S1i"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBSubnetGroupResult",
            type: "structure",
            members: {
              DBSubnetGroup: {
                shape: "S11"
              }
            }
          }
        },
        CreateEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SnsTopicArn"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S6"
              },
              SourceIds: {
                shape: "S5"
              },
              Enabled: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CreateEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        CreateOptionGroup: {
          input: {
            type: "structure",
            required: [
              "OptionGroupName",
              "EngineName",
              "MajorEngineVersion",
              "OptionGroupDescription"
            ],
            members: {
              OptionGroupName: {},
              EngineName: {},
              MajorEngineVersion: {},
              OptionGroupDescription: {}
            }
          },
          output: {
            resultWrapper: "CreateOptionGroupResult",
            type: "structure",
            members: {
              OptionGroup: {
                shape: "S1o"
              }
            }
          }
        },
        DeleteDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              SkipFinalSnapshot: {
                type: "boolean"
              },
              FinalDBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        DeleteDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {}
            }
          }
        },
        DeleteDBSecurityGroup: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName"
            ],
            members: {
              DBSecurityGroupName: {}
            }
          }
        },
        DeleteDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBSnapshotIdentifier"
            ],
            members: {
              DBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "Sk"
              }
            }
          }
        },
        DeleteDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName"
            ],
            members: {
              DBSubnetGroupName: {}
            }
          }
        },
        DeleteEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {}
            }
          },
          output: {
            resultWrapper: "DeleteEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        DeleteOptionGroup: {
          input: {
            type: "structure",
            required: [
              "OptionGroupName"
            ],
            members: {
              OptionGroupName: {}
            }
          }
        },
        DescribeDBEngineVersions: {
          input: {
            type: "structure",
            members: {
              Engine: {},
              EngineVersion: {},
              DBParameterGroupFamily: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              DefaultOnly: {
                type: "boolean"
              },
              ListSupportedCharacterSets: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeDBEngineVersionsResult",
            type: "structure",
            members: {
              Marker: {},
              DBEngineVersions: {
                type: "list",
                member: {
                  locationName: "DBEngineVersion",
                  type: "structure",
                  members: {
                    Engine: {},
                    EngineVersion: {},
                    DBParameterGroupFamily: {},
                    DBEngineDescription: {},
                    DBEngineVersionDescription: {},
                    DefaultCharacterSet: {
                      shape: "S25"
                    },
                    SupportedCharacterSets: {
                      type: "list",
                      member: {
                        shape: "S25",
                        locationName: "CharacterSet"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeDBInstances: {
          input: {
            type: "structure",
            members: {
              DBInstanceIdentifier: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBInstancesResult",
            type: "structure",
            members: {
              Marker: {},
              DBInstances: {
                type: "list",
                member: {
                  shape: "St",
                  locationName: "DBInstance"
                }
              }
            }
          }
        },
        DescribeDBParameterGroups: {
          input: {
            type: "structure",
            members: {
              DBParameterGroupName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBParameterGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBParameterGroups: {
                type: "list",
                member: {
                  shape: "S1c",
                  locationName: "DBParameterGroup"
                }
              }
            }
          }
        },
        DescribeDBParameters: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {},
              Source: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBParametersResult",
            type: "structure",
            members: {
              Parameters: {
                shape: "S2f"
              },
              Marker: {}
            }
          }
        },
        DescribeDBSecurityGroups: {
          input: {
            type: "structure",
            members: {
              DBSecurityGroupName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSecurityGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSecurityGroups: {
                type: "list",
                member: {
                  shape: "Sd",
                  locationName: "DBSecurityGroup"
                }
              }
            }
          }
        },
        DescribeDBSnapshots: {
          input: {
            type: "structure",
            members: {
              DBInstanceIdentifier: {},
              DBSnapshotIdentifier: {},
              SnapshotType: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSnapshotsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSnapshots: {
                type: "list",
                member: {
                  shape: "Sk",
                  locationName: "DBSnapshot"
                }
              }
            }
          }
        },
        DescribeDBSubnetGroups: {
          input: {
            type: "structure",
            members: {
              DBSubnetGroupName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSubnetGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSubnetGroups: {
                type: "list",
                member: {
                  shape: "S11",
                  locationName: "DBSubnetGroup"
                }
              }
            }
          }
        },
        DescribeEngineDefaultParameters: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupFamily"
            ],
            members: {
              DBParameterGroupFamily: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEngineDefaultParametersResult",
            type: "structure",
            members: {
              EngineDefaults: {
                type: "structure",
                members: {
                  DBParameterGroupFamily: {},
                  Marker: {},
                  Parameters: {
                    shape: "S2f"
                  }
                },
                wrapper: true
              }
            }
          }
        },
        DescribeEventCategories: {
          input: {
            type: "structure",
            members: {
              SourceType: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventCategoriesResult",
            type: "structure",
            members: {
              EventCategoriesMapList: {
                type: "list",
                member: {
                  locationName: "EventCategoriesMap",
                  type: "structure",
                  members: {
                    SourceType: {},
                    EventCategories: {
                      shape: "S6"
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        DescribeEventSubscriptions: {
          input: {
            type: "structure",
            members: {
              SubscriptionName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventSubscriptionsResult",
            type: "structure",
            members: {
              Marker: {},
              EventSubscriptionsList: {
                type: "list",
                member: {
                  shape: "S4",
                  locationName: "EventSubscription"
                }
              }
            }
          }
        },
        DescribeEvents: {
          input: {
            type: "structure",
            members: {
              SourceIdentifier: {},
              SourceType: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Duration: {
                type: "integer"
              },
              EventCategories: {
                shape: "S6"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventsResult",
            type: "structure",
            members: {
              Marker: {},
              Events: {
                type: "list",
                member: {
                  locationName: "Event",
                  type: "structure",
                  members: {
                    SourceIdentifier: {},
                    SourceType: {},
                    Message: {},
                    EventCategories: {
                      shape: "S6"
                    },
                    Date: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeOptionGroupOptions: {
          input: {
            type: "structure",
            required: [
              "EngineName"
            ],
            members: {
              EngineName: {},
              MajorEngineVersion: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeOptionGroupOptionsResult",
            type: "structure",
            members: {
              OptionGroupOptions: {
                type: "list",
                member: {
                  locationName: "OptionGroupOption",
                  type: "structure",
                  members: {
                    Name: {},
                    Description: {},
                    EngineName: {},
                    MajorEngineVersion: {},
                    MinimumRequiredMinorEngineVersion: {},
                    PortRequired: {
                      type: "boolean"
                    },
                    DefaultPort: {
                      type: "integer"
                    },
                    OptionsDependedOn: {
                      type: "list",
                      member: {
                        locationName: "OptionName"
                      }
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeOptionGroups: {
          input: {
            type: "structure",
            members: {
              OptionGroupName: {},
              Marker: {},
              MaxRecords: {
                type: "integer"
              },
              EngineName: {},
              MajorEngineVersion: {}
            }
          },
          output: {
            resultWrapper: "DescribeOptionGroupsResult",
            type: "structure",
            members: {
              OptionGroupsList: {
                type: "list",
                member: {
                  shape: "S1o",
                  locationName: "OptionGroup"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeOrderableDBInstanceOptions: {
          input: {
            type: "structure",
            required: [
              "Engine"
            ],
            members: {
              Engine: {},
              EngineVersion: {},
              DBInstanceClass: {},
              LicenseModel: {},
              Vpc: {
                type: "boolean"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeOrderableDBInstanceOptionsResult",
            type: "structure",
            members: {
              OrderableDBInstanceOptions: {
                type: "list",
                member: {
                  locationName: "OrderableDBInstanceOption",
                  type: "structure",
                  members: {
                    Engine: {},
                    EngineVersion: {},
                    DBInstanceClass: {},
                    LicenseModel: {},
                    AvailabilityZones: {
                      type: "list",
                      member: {
                        shape: "S14",
                        locationName: "AvailabilityZone"
                      }
                    },
                    MultiAZCapable: {
                      type: "boolean"
                    },
                    ReadReplicaCapable: {
                      type: "boolean"
                    },
                    Vpc: {
                      type: "boolean"
                    }
                  },
                  wrapper: true
                }
              },
              Marker: {}
            }
          }
        },
        DescribeReservedDBInstances: {
          input: {
            type: "structure",
            members: {
              ReservedDBInstanceId: {},
              ReservedDBInstancesOfferingId: {},
              DBInstanceClass: {},
              Duration: {},
              ProductDescription: {},
              OfferingType: {},
              MultiAZ: {
                type: "boolean"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeReservedDBInstancesResult",
            type: "structure",
            members: {
              Marker: {},
              ReservedDBInstances: {
                type: "list",
                member: {
                  shape: "S3m",
                  locationName: "ReservedDBInstance"
                }
              }
            }
          }
        },
        DescribeReservedDBInstancesOfferings: {
          input: {
            type: "structure",
            members: {
              ReservedDBInstancesOfferingId: {},
              DBInstanceClass: {},
              Duration: {},
              ProductDescription: {},
              OfferingType: {},
              MultiAZ: {
                type: "boolean"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeReservedDBInstancesOfferingsResult",
            type: "structure",
            members: {
              Marker: {},
              ReservedDBInstancesOfferings: {
                type: "list",
                member: {
                  locationName: "ReservedDBInstancesOffering",
                  type: "structure",
                  members: {
                    ReservedDBInstancesOfferingId: {},
                    DBInstanceClass: {},
                    Duration: {
                      type: "integer"
                    },
                    FixedPrice: {
                      type: "double"
                    },
                    UsagePrice: {
                      type: "double"
                    },
                    CurrencyCode: {},
                    ProductDescription: {},
                    OfferingType: {},
                    MultiAZ: {
                      type: "boolean"
                    },
                    RecurringCharges: {
                      shape: "S3o"
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName"
            ],
            members: {
              ResourceName: {}
            }
          },
          output: {
            resultWrapper: "ListTagsForResourceResult",
            type: "structure",
            members: {
              TagList: {
                shape: "S9"
              }
            }
          }
        },
        ModifyDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              AllocatedStorage: {
                type: "integer"
              },
              DBInstanceClass: {},
              DBSecurityGroups: {
                shape: "Sp"
              },
              VpcSecurityGroupIds: {
                shape: "Sq"
              },
              ApplyImmediately: {
                type: "boolean"
              },
              MasterUserPassword: {},
              DBParameterGroupName: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {},
              PreferredMaintenanceWindow: {},
              MultiAZ: {
                type: "boolean"
              },
              EngineVersion: {},
              AllowMajorVersionUpgrade: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              NewDBInstanceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "ModifyDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        ModifyDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName",
              "Parameters"
            ],
            members: {
              DBParameterGroupName: {},
              Parameters: {
                shape: "S2f"
              }
            }
          },
          output: {
            shape: "S3z",
            resultWrapper: "ModifyDBParameterGroupResult"
          }
        },
        ModifyDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName",
              "SubnetIds"
            ],
            members: {
              DBSubnetGroupName: {},
              DBSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S1i"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBSubnetGroupResult",
            type: "structure",
            members: {
              DBSubnetGroup: {
                shape: "S11"
              }
            }
          }
        },
        ModifyEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S6"
              },
              Enabled: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        ModifyOptionGroup: {
          input: {
            type: "structure",
            required: [
              "OptionGroupName"
            ],
            members: {
              OptionGroupName: {},
              OptionsToInclude: {
                type: "list",
                member: {
                  locationName: "OptionConfiguration",
                  type: "structure",
                  required: [
                    "OptionName"
                  ],
                  members: {
                    OptionName: {},
                    Port: {
                      type: "integer"
                    },
                    DBSecurityGroupMemberships: {
                      shape: "Sp"
                    },
                    VpcSecurityGroupMemberships: {
                      shape: "Sq"
                    }
                  }
                }
              },
              OptionsToRemove: {
                type: "list",
                member: {}
              },
              ApplyImmediately: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyOptionGroupResult",
            type: "structure",
            members: {
              OptionGroup: {
                shape: "S1o"
              }
            }
          }
        },
        PromoteReadReplica: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {}
            }
          },
          output: {
            resultWrapper: "PromoteReadReplicaResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        PurchaseReservedDBInstancesOffering: {
          input: {
            type: "structure",
            required: [
              "ReservedDBInstancesOfferingId"
            ],
            members: {
              ReservedDBInstancesOfferingId: {},
              ReservedDBInstanceId: {},
              DBInstanceCount: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "PurchaseReservedDBInstancesOfferingResult",
            type: "structure",
            members: {
              ReservedDBInstance: {
                shape: "S3m"
              }
            }
          }
        },
        RebootDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              ForceFailover: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "RebootDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        RemoveSourceIdentifierFromSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SourceIdentifier"
            ],
            members: {
              SubscriptionName: {},
              SourceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "RemoveSourceIdentifierFromSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        RemoveTagsFromResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "TagKeys"
            ],
            members: {
              ResourceName: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ResetDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {},
              ResetAllParameters: {
                type: "boolean"
              },
              Parameters: {
                shape: "S2f"
              }
            }
          },
          output: {
            shape: "S3z",
            resultWrapper: "ResetDBParameterGroupResult"
          }
        },
        RestoreDBInstanceFromDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "DBSnapshotIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              DBSnapshotIdentifier: {},
              DBInstanceClass: {},
              Port: {
                type: "integer"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              MultiAZ: {
                type: "boolean"
              },
              PubliclyAccessible: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              DBName: {},
              Engine: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {}
            }
          },
          output: {
            resultWrapper: "RestoreDBInstanceFromDBSnapshotResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        RestoreDBInstanceToPointInTime: {
          input: {
            type: "structure",
            required: [
              "SourceDBInstanceIdentifier",
              "TargetDBInstanceIdentifier"
            ],
            members: {
              SourceDBInstanceIdentifier: {},
              TargetDBInstanceIdentifier: {},
              RestoreTime: {
                type: "timestamp"
              },
              UseLatestRestorableTime: {
                type: "boolean"
              },
              DBInstanceClass: {},
              Port: {
                type: "integer"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              MultiAZ: {
                type: "boolean"
              },
              PubliclyAccessible: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              DBName: {},
              Engine: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {}
            }
          },
          output: {
            resultWrapper: "RestoreDBInstanceToPointInTimeResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        RevokeDBSecurityGroupIngress: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName"
            ],
            members: {
              DBSecurityGroupName: {},
              CIDRIP: {},
              EC2SecurityGroupName: {},
              EC2SecurityGroupId: {},
              EC2SecurityGroupOwnerId: {}
            }
          },
          output: {
            resultWrapper: "RevokeDBSecurityGroupIngressResult",
            type: "structure",
            members: {
              DBSecurityGroup: {
                shape: "Sd"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            Id: {},
            CustomerAwsId: {},
            CustSubscriptionId: {},
            SnsTopicArn: {},
            Status: {},
            SubscriptionCreationTime: {},
            SourceType: {},
            SourceIdsList: {
              shape: "S5"
            },
            EventCategoriesList: {
              shape: "S6"
            },
            Enabled: {
              type: "boolean"
            }
          },
          wrapper: true
        },
        S5: {
          type: "list",
          member: {
            locationName: "SourceId"
          }
        },
        S6: {
          type: "list",
          member: {
            locationName: "EventCategory"
          }
        },
        S9: {
          type: "list",
          member: {
            locationName: "Tag",
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sd: {
          type: "structure",
          members: {
            OwnerId: {},
            DBSecurityGroupName: {},
            DBSecurityGroupDescription: {},
            VpcId: {},
            EC2SecurityGroups: {
              type: "list",
              member: {
                locationName: "EC2SecurityGroup",
                type: "structure",
                members: {
                  Status: {},
                  EC2SecurityGroupName: {},
                  EC2SecurityGroupId: {},
                  EC2SecurityGroupOwnerId: {}
                }
              }
            },
            IPRanges: {
              type: "list",
              member: {
                locationName: "IPRange",
                type: "structure",
                members: {
                  Status: {},
                  CIDRIP: {}
                }
              }
            }
          },
          wrapper: true
        },
        Sk: {
          type: "structure",
          members: {
            DBSnapshotIdentifier: {},
            DBInstanceIdentifier: {},
            SnapshotCreateTime: {
              type: "timestamp"
            },
            Engine: {},
            AllocatedStorage: {
              type: "integer"
            },
            Status: {},
            Port: {
              type: "integer"
            },
            AvailabilityZone: {},
            VpcId: {},
            InstanceCreateTime: {
              type: "timestamp"
            },
            MasterUsername: {},
            EngineVersion: {},
            LicenseModel: {},
            SnapshotType: {},
            Iops: {
              type: "integer"
            }
          },
          wrapper: true
        },
        Sp: {
          type: "list",
          member: {
            locationName: "DBSecurityGroupName"
          }
        },
        Sq: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroupId"
          }
        },
        St: {
          type: "structure",
          members: {
            DBInstanceIdentifier: {},
            DBInstanceClass: {},
            Engine: {},
            DBInstanceStatus: {},
            MasterUsername: {},
            DBName: {},
            Endpoint: {
              type: "structure",
              members: {
                Address: {},
                Port: {
                  type: "integer"
                }
              }
            },
            AllocatedStorage: {
              type: "integer"
            },
            InstanceCreateTime: {
              type: "timestamp"
            },
            PreferredBackupWindow: {},
            BackupRetentionPeriod: {
              type: "integer"
            },
            DBSecurityGroups: {
              shape: "Sv"
            },
            VpcSecurityGroups: {
              shape: "Sx"
            },
            DBParameterGroups: {
              type: "list",
              member: {
                locationName: "DBParameterGroup",
                type: "structure",
                members: {
                  DBParameterGroupName: {},
                  ParameterApplyStatus: {}
                }
              }
            },
            AvailabilityZone: {},
            DBSubnetGroup: {
              shape: "S11"
            },
            PreferredMaintenanceWindow: {},
            PendingModifiedValues: {
              type: "structure",
              members: {
                DBInstanceClass: {},
                AllocatedStorage: {
                  type: "integer"
                },
                MasterUserPassword: {},
                Port: {
                  type: "integer"
                },
                BackupRetentionPeriod: {
                  type: "integer"
                },
                MultiAZ: {
                  type: "boolean"
                },
                EngineVersion: {},
                Iops: {
                  type: "integer"
                },
                DBInstanceIdentifier: {}
              }
            },
            LatestRestorableTime: {
              type: "timestamp"
            },
            MultiAZ: {
              type: "boolean"
            },
            EngineVersion: {},
            AutoMinorVersionUpgrade: {
              type: "boolean"
            },
            ReadReplicaSourceDBInstanceIdentifier: {},
            ReadReplicaDBInstanceIdentifiers: {
              type: "list",
              member: {
                locationName: "ReadReplicaDBInstanceIdentifier"
              }
            },
            LicenseModel: {},
            Iops: {
              type: "integer"
            },
            OptionGroupMembership: {
              type: "structure",
              members: {
                OptionGroupName: {},
                Status: {}
              }
            },
            CharacterSetName: {},
            SecondaryAvailabilityZone: {},
            PubliclyAccessible: {
              type: "boolean"
            }
          },
          wrapper: true
        },
        Sv: {
          type: "list",
          member: {
            locationName: "DBSecurityGroup",
            type: "structure",
            members: {
              DBSecurityGroupName: {},
              Status: {}
            }
          }
        },
        Sx: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroupMembership",
            type: "structure",
            members: {
              VpcSecurityGroupId: {},
              Status: {}
            }
          }
        },
        S11: {
          type: "structure",
          members: {
            DBSubnetGroupName: {},
            DBSubnetGroupDescription: {},
            VpcId: {},
            SubnetGroupStatus: {},
            Subnets: {
              type: "list",
              member: {
                locationName: "Subnet",
                type: "structure",
                members: {
                  SubnetIdentifier: {},
                  SubnetAvailabilityZone: {
                    shape: "S14"
                  },
                  SubnetStatus: {}
                }
              }
            }
          },
          wrapper: true
        },
        S14: {
          type: "structure",
          members: {
            Name: {},
            ProvisionedIopsCapable: {
              type: "boolean"
            }
          },
          wrapper: true
        },
        S1c: {
          type: "structure",
          members: {
            DBParameterGroupName: {},
            DBParameterGroupFamily: {},
            Description: {}
          },
          wrapper: true
        },
        S1i: {
          type: "list",
          member: {
            locationName: "SubnetIdentifier"
          }
        },
        S1o: {
          type: "structure",
          members: {
            OptionGroupName: {},
            OptionGroupDescription: {},
            EngineName: {},
            MajorEngineVersion: {},
            Options: {
              type: "list",
              member: {
                locationName: "Option",
                type: "structure",
                members: {
                  OptionName: {},
                  OptionDescription: {},
                  Port: {
                    type: "integer"
                  },
                  DBSecurityGroupMemberships: {
                    shape: "Sv"
                  },
                  VpcSecurityGroupMemberships: {
                    shape: "Sx"
                  }
                }
              }
            },
            AllowsVpcAndNonVpcInstanceMemberships: {
              type: "boolean"
            },
            VpcId: {}
          },
          wrapper: true
        },
        S25: {
          type: "structure",
          members: {
            CharacterSetName: {},
            CharacterSetDescription: {}
          }
        },
        S2f: {
          type: "list",
          member: {
            locationName: "Parameter",
            type: "structure",
            members: {
              ParameterName: {},
              ParameterValue: {},
              Description: {},
              Source: {},
              ApplyType: {},
              DataType: {},
              AllowedValues: {},
              IsModifiable: {
                type: "boolean"
              },
              MinimumEngineVersion: {},
              ApplyMethod: {}
            }
          }
        },
        S3m: {
          type: "structure",
          members: {
            ReservedDBInstanceId: {},
            ReservedDBInstancesOfferingId: {},
            DBInstanceClass: {},
            StartTime: {
              type: "timestamp"
            },
            Duration: {
              type: "integer"
            },
            FixedPrice: {
              type: "double"
            },
            UsagePrice: {
              type: "double"
            },
            CurrencyCode: {},
            DBInstanceCount: {
              type: "integer"
            },
            ProductDescription: {},
            OfferingType: {},
            MultiAZ: {
              type: "boolean"
            },
            State: {},
            RecurringCharges: {
              shape: "S3o"
            }
          },
          wrapper: true
        },
        S3o: {
          type: "list",
          member: {
            locationName: "RecurringCharge",
            type: "structure",
            members: {
              RecurringChargeAmount: {
                type: "double"
              },
              RecurringChargeFrequency: {}
            },
            wrapper: true
          }
        },
        S3z: {
          type: "structure",
          members: {
            DBParameterGroupName: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/rds-2013-01-10.paginators.json
var require_rds_2013_01_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/rds-2013-01-10.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeDBEngineVersions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBEngineVersions"
        },
        DescribeDBInstances: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBInstances"
        },
        DescribeDBParameterGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBParameterGroups"
        },
        DescribeDBParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Parameters"
        },
        DescribeDBSecurityGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBSecurityGroups"
        },
        DescribeDBSnapshots: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBSnapshots"
        },
        DescribeDBSubnetGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBSubnetGroups"
        },
        DescribeEngineDefaultParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "EngineDefaults.Marker",
          result_key: "EngineDefaults.Parameters"
        },
        DescribeEventSubscriptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "EventSubscriptionsList"
        },
        DescribeEvents: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Events"
        },
        DescribeOptionGroupOptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "OptionGroupOptions"
        },
        DescribeOptionGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "OptionGroupsList"
        },
        DescribeOrderableDBInstanceOptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "OrderableDBInstanceOptions"
        },
        DescribeReservedDBInstances: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ReservedDBInstances"
        },
        DescribeReservedDBInstancesOfferings: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ReservedDBInstancesOfferings"
        },
        ListTagsForResource: {
          result_key: "TagList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/rds-2013-02-12.min.json
var require_rds_2013_02_12_min = __commonJS({
  "node_modules/aws-sdk/apis/rds-2013-02-12.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2013-02-12",
        endpointPrefix: "rds",
        protocol: "query",
        serviceAbbreviation: "Amazon RDS",
        serviceFullName: "Amazon Relational Database Service",
        serviceId: "RDS",
        signatureVersion: "v4",
        uid: "rds-2013-02-12",
        xmlNamespace: "http://rds.amazonaws.com/doc/2013-02-12/"
      },
      operations: {
        AddSourceIdentifierToSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SourceIdentifier"
            ],
            members: {
              SubscriptionName: {},
              SourceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "AddSourceIdentifierToSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        AddTagsToResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "Tags"
            ],
            members: {
              ResourceName: {},
              Tags: {
                shape: "S9"
              }
            }
          }
        },
        AuthorizeDBSecurityGroupIngress: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName"
            ],
            members: {
              DBSecurityGroupName: {},
              CIDRIP: {},
              EC2SecurityGroupName: {},
              EC2SecurityGroupId: {},
              EC2SecurityGroupOwnerId: {}
            }
          },
          output: {
            resultWrapper: "AuthorizeDBSecurityGroupIngressResult",
            type: "structure",
            members: {
              DBSecurityGroup: {
                shape: "Sd"
              }
            }
          }
        },
        CopyDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "SourceDBSnapshotIdentifier",
              "TargetDBSnapshotIdentifier"
            ],
            members: {
              SourceDBSnapshotIdentifier: {},
              TargetDBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "CopyDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "Sk"
              }
            }
          }
        },
        CreateDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "AllocatedStorage",
              "DBInstanceClass",
              "Engine",
              "MasterUsername",
              "MasterUserPassword"
            ],
            members: {
              DBName: {},
              DBInstanceIdentifier: {},
              AllocatedStorage: {
                type: "integer"
              },
              DBInstanceClass: {},
              Engine: {},
              MasterUsername: {},
              MasterUserPassword: {},
              DBSecurityGroups: {
                shape: "Sp"
              },
              VpcSecurityGroupIds: {
                shape: "Sq"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              PreferredMaintenanceWindow: {},
              DBParameterGroupName: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {},
              Port: {
                type: "integer"
              },
              MultiAZ: {
                type: "boolean"
              },
              EngineVersion: {},
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              CharacterSetName: {},
              PubliclyAccessible: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        CreateDBInstanceReadReplica: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "SourceDBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              SourceDBInstanceIdentifier: {},
              DBInstanceClass: {},
              AvailabilityZone: {},
              Port: {
                type: "integer"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              PubliclyAccessible: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBInstanceReadReplicaResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        CreateDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName",
              "DBParameterGroupFamily",
              "Description"
            ],
            members: {
              DBParameterGroupName: {},
              DBParameterGroupFamily: {},
              Description: {}
            }
          },
          output: {
            resultWrapper: "CreateDBParameterGroupResult",
            type: "structure",
            members: {
              DBParameterGroup: {
                shape: "S1d"
              }
            }
          }
        },
        CreateDBSecurityGroup: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName",
              "DBSecurityGroupDescription"
            ],
            members: {
              DBSecurityGroupName: {},
              DBSecurityGroupDescription: {}
            }
          },
          output: {
            resultWrapper: "CreateDBSecurityGroupResult",
            type: "structure",
            members: {
              DBSecurityGroup: {
                shape: "Sd"
              }
            }
          }
        },
        CreateDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBSnapshotIdentifier",
              "DBInstanceIdentifier"
            ],
            members: {
              DBSnapshotIdentifier: {},
              DBInstanceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "CreateDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "Sk"
              }
            }
          }
        },
        CreateDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName",
              "DBSubnetGroupDescription",
              "SubnetIds"
            ],
            members: {
              DBSubnetGroupName: {},
              DBSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S1j"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBSubnetGroupResult",
            type: "structure",
            members: {
              DBSubnetGroup: {
                shape: "S11"
              }
            }
          }
        },
        CreateEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SnsTopicArn"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S6"
              },
              SourceIds: {
                shape: "S5"
              },
              Enabled: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CreateEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        CreateOptionGroup: {
          input: {
            type: "structure",
            required: [
              "OptionGroupName",
              "EngineName",
              "MajorEngineVersion",
              "OptionGroupDescription"
            ],
            members: {
              OptionGroupName: {},
              EngineName: {},
              MajorEngineVersion: {},
              OptionGroupDescription: {}
            }
          },
          output: {
            resultWrapper: "CreateOptionGroupResult",
            type: "structure",
            members: {
              OptionGroup: {
                shape: "S1p"
              }
            }
          }
        },
        DeleteDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              SkipFinalSnapshot: {
                type: "boolean"
              },
              FinalDBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        DeleteDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {}
            }
          }
        },
        DeleteDBSecurityGroup: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName"
            ],
            members: {
              DBSecurityGroupName: {}
            }
          }
        },
        DeleteDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBSnapshotIdentifier"
            ],
            members: {
              DBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "Sk"
              }
            }
          }
        },
        DeleteDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName"
            ],
            members: {
              DBSubnetGroupName: {}
            }
          }
        },
        DeleteEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {}
            }
          },
          output: {
            resultWrapper: "DeleteEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        DeleteOptionGroup: {
          input: {
            type: "structure",
            required: [
              "OptionGroupName"
            ],
            members: {
              OptionGroupName: {}
            }
          }
        },
        DescribeDBEngineVersions: {
          input: {
            type: "structure",
            members: {
              Engine: {},
              EngineVersion: {},
              DBParameterGroupFamily: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              DefaultOnly: {
                type: "boolean"
              },
              ListSupportedCharacterSets: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeDBEngineVersionsResult",
            type: "structure",
            members: {
              Marker: {},
              DBEngineVersions: {
                type: "list",
                member: {
                  locationName: "DBEngineVersion",
                  type: "structure",
                  members: {
                    Engine: {},
                    EngineVersion: {},
                    DBParameterGroupFamily: {},
                    DBEngineDescription: {},
                    DBEngineVersionDescription: {},
                    DefaultCharacterSet: {
                      shape: "S28"
                    },
                    SupportedCharacterSets: {
                      type: "list",
                      member: {
                        shape: "S28",
                        locationName: "CharacterSet"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeDBInstances: {
          input: {
            type: "structure",
            members: {
              DBInstanceIdentifier: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBInstancesResult",
            type: "structure",
            members: {
              Marker: {},
              DBInstances: {
                type: "list",
                member: {
                  shape: "St",
                  locationName: "DBInstance"
                }
              }
            }
          }
        },
        DescribeDBLogFiles: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              FilenameContains: {},
              FileLastWritten: {
                type: "long"
              },
              FileSize: {
                type: "long"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBLogFilesResult",
            type: "structure",
            members: {
              DescribeDBLogFiles: {
                type: "list",
                member: {
                  locationName: "DescribeDBLogFilesDetails",
                  type: "structure",
                  members: {
                    LogFileName: {},
                    LastWritten: {
                      type: "long"
                    },
                    Size: {
                      type: "long"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeDBParameterGroups: {
          input: {
            type: "structure",
            members: {
              DBParameterGroupName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBParameterGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBParameterGroups: {
                type: "list",
                member: {
                  shape: "S1d",
                  locationName: "DBParameterGroup"
                }
              }
            }
          }
        },
        DescribeDBParameters: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {},
              Source: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBParametersResult",
            type: "structure",
            members: {
              Parameters: {
                shape: "S2n"
              },
              Marker: {}
            }
          }
        },
        DescribeDBSecurityGroups: {
          input: {
            type: "structure",
            members: {
              DBSecurityGroupName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSecurityGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSecurityGroups: {
                type: "list",
                member: {
                  shape: "Sd",
                  locationName: "DBSecurityGroup"
                }
              }
            }
          }
        },
        DescribeDBSnapshots: {
          input: {
            type: "structure",
            members: {
              DBInstanceIdentifier: {},
              DBSnapshotIdentifier: {},
              SnapshotType: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSnapshotsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSnapshots: {
                type: "list",
                member: {
                  shape: "Sk",
                  locationName: "DBSnapshot"
                }
              }
            }
          }
        },
        DescribeDBSubnetGroups: {
          input: {
            type: "structure",
            members: {
              DBSubnetGroupName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSubnetGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSubnetGroups: {
                type: "list",
                member: {
                  shape: "S11",
                  locationName: "DBSubnetGroup"
                }
              }
            }
          }
        },
        DescribeEngineDefaultParameters: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupFamily"
            ],
            members: {
              DBParameterGroupFamily: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEngineDefaultParametersResult",
            type: "structure",
            members: {
              EngineDefaults: {
                type: "structure",
                members: {
                  DBParameterGroupFamily: {},
                  Marker: {},
                  Parameters: {
                    shape: "S2n"
                  }
                },
                wrapper: true
              }
            }
          }
        },
        DescribeEventCategories: {
          input: {
            type: "structure",
            members: {
              SourceType: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventCategoriesResult",
            type: "structure",
            members: {
              EventCategoriesMapList: {
                type: "list",
                member: {
                  locationName: "EventCategoriesMap",
                  type: "structure",
                  members: {
                    SourceType: {},
                    EventCategories: {
                      shape: "S6"
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        DescribeEventSubscriptions: {
          input: {
            type: "structure",
            members: {
              SubscriptionName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventSubscriptionsResult",
            type: "structure",
            members: {
              Marker: {},
              EventSubscriptionsList: {
                type: "list",
                member: {
                  shape: "S4",
                  locationName: "EventSubscription"
                }
              }
            }
          }
        },
        DescribeEvents: {
          input: {
            type: "structure",
            members: {
              SourceIdentifier: {},
              SourceType: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Duration: {
                type: "integer"
              },
              EventCategories: {
                shape: "S6"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventsResult",
            type: "structure",
            members: {
              Marker: {},
              Events: {
                type: "list",
                member: {
                  locationName: "Event",
                  type: "structure",
                  members: {
                    SourceIdentifier: {},
                    SourceType: {},
                    Message: {},
                    EventCategories: {
                      shape: "S6"
                    },
                    Date: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeOptionGroupOptions: {
          input: {
            type: "structure",
            required: [
              "EngineName"
            ],
            members: {
              EngineName: {},
              MajorEngineVersion: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeOptionGroupOptionsResult",
            type: "structure",
            members: {
              OptionGroupOptions: {
                type: "list",
                member: {
                  locationName: "OptionGroupOption",
                  type: "structure",
                  members: {
                    Name: {},
                    Description: {},
                    EngineName: {},
                    MajorEngineVersion: {},
                    MinimumRequiredMinorEngineVersion: {},
                    PortRequired: {
                      type: "boolean"
                    },
                    DefaultPort: {
                      type: "integer"
                    },
                    OptionsDependedOn: {
                      type: "list",
                      member: {
                        locationName: "OptionName"
                      }
                    },
                    Persistent: {
                      type: "boolean"
                    },
                    OptionGroupOptionSettings: {
                      type: "list",
                      member: {
                        locationName: "OptionGroupOptionSetting",
                        type: "structure",
                        members: {
                          SettingName: {},
                          SettingDescription: {},
                          DefaultValue: {},
                          ApplyType: {},
                          AllowedValues: {},
                          IsModifiable: {
                            type: "boolean"
                          }
                        }
                      }
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeOptionGroups: {
          input: {
            type: "structure",
            members: {
              OptionGroupName: {},
              Marker: {},
              MaxRecords: {
                type: "integer"
              },
              EngineName: {},
              MajorEngineVersion: {}
            }
          },
          output: {
            resultWrapper: "DescribeOptionGroupsResult",
            type: "structure",
            members: {
              OptionGroupsList: {
                type: "list",
                member: {
                  shape: "S1p",
                  locationName: "OptionGroup"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeOrderableDBInstanceOptions: {
          input: {
            type: "structure",
            required: [
              "Engine"
            ],
            members: {
              Engine: {},
              EngineVersion: {},
              DBInstanceClass: {},
              LicenseModel: {},
              Vpc: {
                type: "boolean"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeOrderableDBInstanceOptionsResult",
            type: "structure",
            members: {
              OrderableDBInstanceOptions: {
                type: "list",
                member: {
                  locationName: "OrderableDBInstanceOption",
                  type: "structure",
                  members: {
                    Engine: {},
                    EngineVersion: {},
                    DBInstanceClass: {},
                    LicenseModel: {},
                    AvailabilityZones: {
                      type: "list",
                      member: {
                        shape: "S14",
                        locationName: "AvailabilityZone"
                      }
                    },
                    MultiAZCapable: {
                      type: "boolean"
                    },
                    ReadReplicaCapable: {
                      type: "boolean"
                    },
                    Vpc: {
                      type: "boolean"
                    }
                  },
                  wrapper: true
                }
              },
              Marker: {}
            }
          }
        },
        DescribeReservedDBInstances: {
          input: {
            type: "structure",
            members: {
              ReservedDBInstanceId: {},
              ReservedDBInstancesOfferingId: {},
              DBInstanceClass: {},
              Duration: {},
              ProductDescription: {},
              OfferingType: {},
              MultiAZ: {
                type: "boolean"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeReservedDBInstancesResult",
            type: "structure",
            members: {
              Marker: {},
              ReservedDBInstances: {
                type: "list",
                member: {
                  shape: "S3w",
                  locationName: "ReservedDBInstance"
                }
              }
            }
          }
        },
        DescribeReservedDBInstancesOfferings: {
          input: {
            type: "structure",
            members: {
              ReservedDBInstancesOfferingId: {},
              DBInstanceClass: {},
              Duration: {},
              ProductDescription: {},
              OfferingType: {},
              MultiAZ: {
                type: "boolean"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeReservedDBInstancesOfferingsResult",
            type: "structure",
            members: {
              Marker: {},
              ReservedDBInstancesOfferings: {
                type: "list",
                member: {
                  locationName: "ReservedDBInstancesOffering",
                  type: "structure",
                  members: {
                    ReservedDBInstancesOfferingId: {},
                    DBInstanceClass: {},
                    Duration: {
                      type: "integer"
                    },
                    FixedPrice: {
                      type: "double"
                    },
                    UsagePrice: {
                      type: "double"
                    },
                    CurrencyCode: {},
                    ProductDescription: {},
                    OfferingType: {},
                    MultiAZ: {
                      type: "boolean"
                    },
                    RecurringCharges: {
                      shape: "S3y"
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        DownloadDBLogFilePortion: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "LogFileName"
            ],
            members: {
              DBInstanceIdentifier: {},
              LogFileName: {},
              Marker: {},
              NumberOfLines: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DownloadDBLogFilePortionResult",
            type: "structure",
            members: {
              LogFileData: {},
              Marker: {},
              AdditionalDataPending: {
                type: "boolean"
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName"
            ],
            members: {
              ResourceName: {}
            }
          },
          output: {
            resultWrapper: "ListTagsForResourceResult",
            type: "structure",
            members: {
              TagList: {
                shape: "S9"
              }
            }
          }
        },
        ModifyDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              AllocatedStorage: {
                type: "integer"
              },
              DBInstanceClass: {},
              DBSecurityGroups: {
                shape: "Sp"
              },
              VpcSecurityGroupIds: {
                shape: "Sq"
              },
              ApplyImmediately: {
                type: "boolean"
              },
              MasterUserPassword: {},
              DBParameterGroupName: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {},
              PreferredMaintenanceWindow: {},
              MultiAZ: {
                type: "boolean"
              },
              EngineVersion: {},
              AllowMajorVersionUpgrade: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              NewDBInstanceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "ModifyDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        ModifyDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName",
              "Parameters"
            ],
            members: {
              DBParameterGroupName: {},
              Parameters: {
                shape: "S2n"
              }
            }
          },
          output: {
            shape: "S4b",
            resultWrapper: "ModifyDBParameterGroupResult"
          }
        },
        ModifyDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName",
              "SubnetIds"
            ],
            members: {
              DBSubnetGroupName: {},
              DBSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S1j"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBSubnetGroupResult",
            type: "structure",
            members: {
              DBSubnetGroup: {
                shape: "S11"
              }
            }
          }
        },
        ModifyEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S6"
              },
              Enabled: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        ModifyOptionGroup: {
          input: {
            type: "structure",
            required: [
              "OptionGroupName"
            ],
            members: {
              OptionGroupName: {},
              OptionsToInclude: {
                type: "list",
                member: {
                  locationName: "OptionConfiguration",
                  type: "structure",
                  required: [
                    "OptionName"
                  ],
                  members: {
                    OptionName: {},
                    Port: {
                      type: "integer"
                    },
                    DBSecurityGroupMemberships: {
                      shape: "Sp"
                    },
                    VpcSecurityGroupMemberships: {
                      shape: "Sq"
                    },
                    OptionSettings: {
                      type: "list",
                      member: {
                        shape: "S1t",
                        locationName: "OptionSetting"
                      }
                    }
                  }
                }
              },
              OptionsToRemove: {
                type: "list",
                member: {}
              },
              ApplyImmediately: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyOptionGroupResult",
            type: "structure",
            members: {
              OptionGroup: {
                shape: "S1p"
              }
            }
          }
        },
        PromoteReadReplica: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {}
            }
          },
          output: {
            resultWrapper: "PromoteReadReplicaResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        PurchaseReservedDBInstancesOffering: {
          input: {
            type: "structure",
            required: [
              "ReservedDBInstancesOfferingId"
            ],
            members: {
              ReservedDBInstancesOfferingId: {},
              ReservedDBInstanceId: {},
              DBInstanceCount: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "PurchaseReservedDBInstancesOfferingResult",
            type: "structure",
            members: {
              ReservedDBInstance: {
                shape: "S3w"
              }
            }
          }
        },
        RebootDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              ForceFailover: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "RebootDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        RemoveSourceIdentifierFromSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SourceIdentifier"
            ],
            members: {
              SubscriptionName: {},
              SourceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "RemoveSourceIdentifierFromSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        RemoveTagsFromResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "TagKeys"
            ],
            members: {
              ResourceName: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ResetDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {},
              ResetAllParameters: {
                type: "boolean"
              },
              Parameters: {
                shape: "S2n"
              }
            }
          },
          output: {
            shape: "S4b",
            resultWrapper: "ResetDBParameterGroupResult"
          }
        },
        RestoreDBInstanceFromDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "DBSnapshotIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              DBSnapshotIdentifier: {},
              DBInstanceClass: {},
              Port: {
                type: "integer"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              MultiAZ: {
                type: "boolean"
              },
              PubliclyAccessible: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              DBName: {},
              Engine: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {}
            }
          },
          output: {
            resultWrapper: "RestoreDBInstanceFromDBSnapshotResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        RestoreDBInstanceToPointInTime: {
          input: {
            type: "structure",
            required: [
              "SourceDBInstanceIdentifier",
              "TargetDBInstanceIdentifier"
            ],
            members: {
              SourceDBInstanceIdentifier: {},
              TargetDBInstanceIdentifier: {},
              RestoreTime: {
                type: "timestamp"
              },
              UseLatestRestorableTime: {
                type: "boolean"
              },
              DBInstanceClass: {},
              Port: {
                type: "integer"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              MultiAZ: {
                type: "boolean"
              },
              PubliclyAccessible: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              DBName: {},
              Engine: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {}
            }
          },
          output: {
            resultWrapper: "RestoreDBInstanceToPointInTimeResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        RevokeDBSecurityGroupIngress: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName"
            ],
            members: {
              DBSecurityGroupName: {},
              CIDRIP: {},
              EC2SecurityGroupName: {},
              EC2SecurityGroupId: {},
              EC2SecurityGroupOwnerId: {}
            }
          },
          output: {
            resultWrapper: "RevokeDBSecurityGroupIngressResult",
            type: "structure",
            members: {
              DBSecurityGroup: {
                shape: "Sd"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            CustomerAwsId: {},
            CustSubscriptionId: {},
            SnsTopicArn: {},
            Status: {},
            SubscriptionCreationTime: {},
            SourceType: {},
            SourceIdsList: {
              shape: "S5"
            },
            EventCategoriesList: {
              shape: "S6"
            },
            Enabled: {
              type: "boolean"
            }
          },
          wrapper: true
        },
        S5: {
          type: "list",
          member: {
            locationName: "SourceId"
          }
        },
        S6: {
          type: "list",
          member: {
            locationName: "EventCategory"
          }
        },
        S9: {
          type: "list",
          member: {
            locationName: "Tag",
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sd: {
          type: "structure",
          members: {
            OwnerId: {},
            DBSecurityGroupName: {},
            DBSecurityGroupDescription: {},
            VpcId: {},
            EC2SecurityGroups: {
              type: "list",
              member: {
                locationName: "EC2SecurityGroup",
                type: "structure",
                members: {
                  Status: {},
                  EC2SecurityGroupName: {},
                  EC2SecurityGroupId: {},
                  EC2SecurityGroupOwnerId: {}
                }
              }
            },
            IPRanges: {
              type: "list",
              member: {
                locationName: "IPRange",
                type: "structure",
                members: {
                  Status: {},
                  CIDRIP: {}
                }
              }
            }
          },
          wrapper: true
        },
        Sk: {
          type: "structure",
          members: {
            DBSnapshotIdentifier: {},
            DBInstanceIdentifier: {},
            SnapshotCreateTime: {
              type: "timestamp"
            },
            Engine: {},
            AllocatedStorage: {
              type: "integer"
            },
            Status: {},
            Port: {
              type: "integer"
            },
            AvailabilityZone: {},
            VpcId: {},
            InstanceCreateTime: {
              type: "timestamp"
            },
            MasterUsername: {},
            EngineVersion: {},
            LicenseModel: {},
            SnapshotType: {},
            Iops: {
              type: "integer"
            },
            OptionGroupName: {}
          },
          wrapper: true
        },
        Sp: {
          type: "list",
          member: {
            locationName: "DBSecurityGroupName"
          }
        },
        Sq: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroupId"
          }
        },
        St: {
          type: "structure",
          members: {
            DBInstanceIdentifier: {},
            DBInstanceClass: {},
            Engine: {},
            DBInstanceStatus: {},
            MasterUsername: {},
            DBName: {},
            Endpoint: {
              type: "structure",
              members: {
                Address: {},
                Port: {
                  type: "integer"
                }
              }
            },
            AllocatedStorage: {
              type: "integer"
            },
            InstanceCreateTime: {
              type: "timestamp"
            },
            PreferredBackupWindow: {},
            BackupRetentionPeriod: {
              type: "integer"
            },
            DBSecurityGroups: {
              shape: "Sv"
            },
            VpcSecurityGroups: {
              shape: "Sx"
            },
            DBParameterGroups: {
              type: "list",
              member: {
                locationName: "DBParameterGroup",
                type: "structure",
                members: {
                  DBParameterGroupName: {},
                  ParameterApplyStatus: {}
                }
              }
            },
            AvailabilityZone: {},
            DBSubnetGroup: {
              shape: "S11"
            },
            PreferredMaintenanceWindow: {},
            PendingModifiedValues: {
              type: "structure",
              members: {
                DBInstanceClass: {},
                AllocatedStorage: {
                  type: "integer"
                },
                MasterUserPassword: {},
                Port: {
                  type: "integer"
                },
                BackupRetentionPeriod: {
                  type: "integer"
                },
                MultiAZ: {
                  type: "boolean"
                },
                EngineVersion: {},
                Iops: {
                  type: "integer"
                },
                DBInstanceIdentifier: {}
              }
            },
            LatestRestorableTime: {
              type: "timestamp"
            },
            MultiAZ: {
              type: "boolean"
            },
            EngineVersion: {},
            AutoMinorVersionUpgrade: {
              type: "boolean"
            },
            ReadReplicaSourceDBInstanceIdentifier: {},
            ReadReplicaDBInstanceIdentifiers: {
              type: "list",
              member: {
                locationName: "ReadReplicaDBInstanceIdentifier"
              }
            },
            LicenseModel: {},
            Iops: {
              type: "integer"
            },
            OptionGroupMemberships: {
              type: "list",
              member: {
                locationName: "OptionGroupMembership",
                type: "structure",
                members: {
                  OptionGroupName: {},
                  Status: {}
                }
              }
            },
            CharacterSetName: {},
            SecondaryAvailabilityZone: {},
            PubliclyAccessible: {
              type: "boolean"
            }
          },
          wrapper: true
        },
        Sv: {
          type: "list",
          member: {
            locationName: "DBSecurityGroup",
            type: "structure",
            members: {
              DBSecurityGroupName: {},
              Status: {}
            }
          }
        },
        Sx: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroupMembership",
            type: "structure",
            members: {
              VpcSecurityGroupId: {},
              Status: {}
            }
          }
        },
        S11: {
          type: "structure",
          members: {
            DBSubnetGroupName: {},
            DBSubnetGroupDescription: {},
            VpcId: {},
            SubnetGroupStatus: {},
            Subnets: {
              type: "list",
              member: {
                locationName: "Subnet",
                type: "structure",
                members: {
                  SubnetIdentifier: {},
                  SubnetAvailabilityZone: {
                    shape: "S14"
                  },
                  SubnetStatus: {}
                }
              }
            }
          },
          wrapper: true
        },
        S14: {
          type: "structure",
          members: {
            Name: {},
            ProvisionedIopsCapable: {
              type: "boolean"
            }
          },
          wrapper: true
        },
        S1d: {
          type: "structure",
          members: {
            DBParameterGroupName: {},
            DBParameterGroupFamily: {},
            Description: {}
          },
          wrapper: true
        },
        S1j: {
          type: "list",
          member: {
            locationName: "SubnetIdentifier"
          }
        },
        S1p: {
          type: "structure",
          members: {
            OptionGroupName: {},
            OptionGroupDescription: {},
            EngineName: {},
            MajorEngineVersion: {},
            Options: {
              type: "list",
              member: {
                locationName: "Option",
                type: "structure",
                members: {
                  OptionName: {},
                  OptionDescription: {},
                  Persistent: {
                    type: "boolean"
                  },
                  Port: {
                    type: "integer"
                  },
                  OptionSettings: {
                    type: "list",
                    member: {
                      shape: "S1t",
                      locationName: "OptionSetting"
                    }
                  },
                  DBSecurityGroupMemberships: {
                    shape: "Sv"
                  },
                  VpcSecurityGroupMemberships: {
                    shape: "Sx"
                  }
                }
              }
            },
            AllowsVpcAndNonVpcInstanceMemberships: {
              type: "boolean"
            },
            VpcId: {}
          },
          wrapper: true
        },
        S1t: {
          type: "structure",
          members: {
            Name: {},
            Value: {},
            DefaultValue: {},
            Description: {},
            ApplyType: {},
            DataType: {},
            AllowedValues: {},
            IsModifiable: {
              type: "boolean"
            },
            IsCollection: {
              type: "boolean"
            }
          }
        },
        S28: {
          type: "structure",
          members: {
            CharacterSetName: {},
            CharacterSetDescription: {}
          }
        },
        S2n: {
          type: "list",
          member: {
            locationName: "Parameter",
            type: "structure",
            members: {
              ParameterName: {},
              ParameterValue: {},
              Description: {},
              Source: {},
              ApplyType: {},
              DataType: {},
              AllowedValues: {},
              IsModifiable: {
                type: "boolean"
              },
              MinimumEngineVersion: {},
              ApplyMethod: {}
            }
          }
        },
        S3w: {
          type: "structure",
          members: {
            ReservedDBInstanceId: {},
            ReservedDBInstancesOfferingId: {},
            DBInstanceClass: {},
            StartTime: {
              type: "timestamp"
            },
            Duration: {
              type: "integer"
            },
            FixedPrice: {
              type: "double"
            },
            UsagePrice: {
              type: "double"
            },
            CurrencyCode: {},
            DBInstanceCount: {
              type: "integer"
            },
            ProductDescription: {},
            OfferingType: {},
            MultiAZ: {
              type: "boolean"
            },
            State: {},
            RecurringCharges: {
              shape: "S3y"
            }
          },
          wrapper: true
        },
        S3y: {
          type: "list",
          member: {
            locationName: "RecurringCharge",
            type: "structure",
            members: {
              RecurringChargeAmount: {
                type: "double"
              },
              RecurringChargeFrequency: {}
            },
            wrapper: true
          }
        },
        S4b: {
          type: "structure",
          members: {
            DBParameterGroupName: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/rds-2013-02-12.paginators.json
var require_rds_2013_02_12_paginators = __commonJS({
  "node_modules/aws-sdk/apis/rds-2013-02-12.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeDBEngineVersions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBEngineVersions"
        },
        DescribeDBInstances: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBInstances"
        },
        DescribeDBLogFiles: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DescribeDBLogFiles"
        },
        DescribeDBParameterGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBParameterGroups"
        },
        DescribeDBParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Parameters"
        },
        DescribeDBSecurityGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBSecurityGroups"
        },
        DescribeDBSnapshots: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBSnapshots"
        },
        DescribeDBSubnetGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBSubnetGroups"
        },
        DescribeEngineDefaultParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "EngineDefaults.Marker",
          result_key: "EngineDefaults.Parameters"
        },
        DescribeEventSubscriptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "EventSubscriptionsList"
        },
        DescribeEvents: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Events"
        },
        DescribeOptionGroupOptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "OptionGroupOptions"
        },
        DescribeOptionGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "OptionGroupsList"
        },
        DescribeOrderableDBInstanceOptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "OrderableDBInstanceOptions"
        },
        DescribeReservedDBInstances: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ReservedDBInstances"
        },
        DescribeReservedDBInstancesOfferings: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ReservedDBInstancesOfferings"
        },
        DownloadDBLogFilePortion: {
          input_token: "Marker",
          limit_key: "NumberOfLines",
          more_results: "AdditionalDataPending",
          output_token: "Marker",
          result_key: "LogFileData"
        },
        ListTagsForResource: {
          result_key: "TagList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/rds-2013-09-09.min.json
var require_rds_2013_09_09_min = __commonJS({
  "node_modules/aws-sdk/apis/rds-2013-09-09.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2013-09-09",
        endpointPrefix: "rds",
        protocol: "query",
        serviceAbbreviation: "Amazon RDS",
        serviceFullName: "Amazon Relational Database Service",
        serviceId: "RDS",
        signatureVersion: "v4",
        uid: "rds-2013-09-09",
        xmlNamespace: "http://rds.amazonaws.com/doc/2013-09-09/"
      },
      operations: {
        AddSourceIdentifierToSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SourceIdentifier"
            ],
            members: {
              SubscriptionName: {},
              SourceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "AddSourceIdentifierToSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        AddTagsToResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "Tags"
            ],
            members: {
              ResourceName: {},
              Tags: {
                shape: "S9"
              }
            }
          }
        },
        AuthorizeDBSecurityGroupIngress: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName"
            ],
            members: {
              DBSecurityGroupName: {},
              CIDRIP: {},
              EC2SecurityGroupName: {},
              EC2SecurityGroupId: {},
              EC2SecurityGroupOwnerId: {}
            }
          },
          output: {
            resultWrapper: "AuthorizeDBSecurityGroupIngressResult",
            type: "structure",
            members: {
              DBSecurityGroup: {
                shape: "Sd"
              }
            }
          }
        },
        CopyDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "SourceDBSnapshotIdentifier",
              "TargetDBSnapshotIdentifier"
            ],
            members: {
              SourceDBSnapshotIdentifier: {},
              TargetDBSnapshotIdentifier: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CopyDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "Sk"
              }
            }
          }
        },
        CreateDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "AllocatedStorage",
              "DBInstanceClass",
              "Engine",
              "MasterUsername",
              "MasterUserPassword"
            ],
            members: {
              DBName: {},
              DBInstanceIdentifier: {},
              AllocatedStorage: {
                type: "integer"
              },
              DBInstanceClass: {},
              Engine: {},
              MasterUsername: {},
              MasterUserPassword: {},
              DBSecurityGroups: {
                shape: "Sp"
              },
              VpcSecurityGroupIds: {
                shape: "Sq"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              PreferredMaintenanceWindow: {},
              DBParameterGroupName: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {},
              Port: {
                type: "integer"
              },
              MultiAZ: {
                type: "boolean"
              },
              EngineVersion: {},
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              CharacterSetName: {},
              PubliclyAccessible: {
                type: "boolean"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        CreateDBInstanceReadReplica: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "SourceDBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              SourceDBInstanceIdentifier: {},
              DBInstanceClass: {},
              AvailabilityZone: {},
              Port: {
                type: "integer"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              PubliclyAccessible: {
                type: "boolean"
              },
              Tags: {
                shape: "S9"
              },
              DBSubnetGroupName: {}
            }
          },
          output: {
            resultWrapper: "CreateDBInstanceReadReplicaResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        CreateDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName",
              "DBParameterGroupFamily",
              "Description"
            ],
            members: {
              DBParameterGroupName: {},
              DBParameterGroupFamily: {},
              Description: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBParameterGroupResult",
            type: "structure",
            members: {
              DBParameterGroup: {
                shape: "S1f"
              }
            }
          }
        },
        CreateDBSecurityGroup: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName",
              "DBSecurityGroupDescription"
            ],
            members: {
              DBSecurityGroupName: {},
              DBSecurityGroupDescription: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBSecurityGroupResult",
            type: "structure",
            members: {
              DBSecurityGroup: {
                shape: "Sd"
              }
            }
          }
        },
        CreateDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBSnapshotIdentifier",
              "DBInstanceIdentifier"
            ],
            members: {
              DBSnapshotIdentifier: {},
              DBInstanceIdentifier: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "Sk"
              }
            }
          }
        },
        CreateDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName",
              "DBSubnetGroupDescription",
              "SubnetIds"
            ],
            members: {
              DBSubnetGroupName: {},
              DBSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S1l"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBSubnetGroupResult",
            type: "structure",
            members: {
              DBSubnetGroup: {
                shape: "S11"
              }
            }
          }
        },
        CreateEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SnsTopicArn"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S6"
              },
              SourceIds: {
                shape: "S5"
              },
              Enabled: {
                type: "boolean"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        CreateOptionGroup: {
          input: {
            type: "structure",
            required: [
              "OptionGroupName",
              "EngineName",
              "MajorEngineVersion",
              "OptionGroupDescription"
            ],
            members: {
              OptionGroupName: {},
              EngineName: {},
              MajorEngineVersion: {},
              OptionGroupDescription: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateOptionGroupResult",
            type: "structure",
            members: {
              OptionGroup: {
                shape: "S1r"
              }
            }
          }
        },
        DeleteDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              SkipFinalSnapshot: {
                type: "boolean"
              },
              FinalDBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        DeleteDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {}
            }
          }
        },
        DeleteDBSecurityGroup: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName"
            ],
            members: {
              DBSecurityGroupName: {}
            }
          }
        },
        DeleteDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBSnapshotIdentifier"
            ],
            members: {
              DBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "Sk"
              }
            }
          }
        },
        DeleteDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName"
            ],
            members: {
              DBSubnetGroupName: {}
            }
          }
        },
        DeleteEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {}
            }
          },
          output: {
            resultWrapper: "DeleteEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        DeleteOptionGroup: {
          input: {
            type: "structure",
            required: [
              "OptionGroupName"
            ],
            members: {
              OptionGroupName: {}
            }
          }
        },
        DescribeDBEngineVersions: {
          input: {
            type: "structure",
            members: {
              Engine: {},
              EngineVersion: {},
              DBParameterGroupFamily: {},
              Filters: {
                shape: "S27"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              DefaultOnly: {
                type: "boolean"
              },
              ListSupportedCharacterSets: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeDBEngineVersionsResult",
            type: "structure",
            members: {
              Marker: {},
              DBEngineVersions: {
                type: "list",
                member: {
                  locationName: "DBEngineVersion",
                  type: "structure",
                  members: {
                    Engine: {},
                    EngineVersion: {},
                    DBParameterGroupFamily: {},
                    DBEngineDescription: {},
                    DBEngineVersionDescription: {},
                    DefaultCharacterSet: {
                      shape: "S2d"
                    },
                    SupportedCharacterSets: {
                      type: "list",
                      member: {
                        shape: "S2d",
                        locationName: "CharacterSet"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeDBInstances: {
          input: {
            type: "structure",
            members: {
              DBInstanceIdentifier: {},
              Filters: {
                shape: "S27"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBInstancesResult",
            type: "structure",
            members: {
              Marker: {},
              DBInstances: {
                type: "list",
                member: {
                  shape: "St",
                  locationName: "DBInstance"
                }
              }
            }
          }
        },
        DescribeDBLogFiles: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              FilenameContains: {},
              FileLastWritten: {
                type: "long"
              },
              FileSize: {
                type: "long"
              },
              Filters: {
                shape: "S27"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBLogFilesResult",
            type: "structure",
            members: {
              DescribeDBLogFiles: {
                type: "list",
                member: {
                  locationName: "DescribeDBLogFilesDetails",
                  type: "structure",
                  members: {
                    LogFileName: {},
                    LastWritten: {
                      type: "long"
                    },
                    Size: {
                      type: "long"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeDBParameterGroups: {
          input: {
            type: "structure",
            members: {
              DBParameterGroupName: {},
              Filters: {
                shape: "S27"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBParameterGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBParameterGroups: {
                type: "list",
                member: {
                  shape: "S1f",
                  locationName: "DBParameterGroup"
                }
              }
            }
          }
        },
        DescribeDBParameters: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {},
              Source: {},
              Filters: {
                shape: "S27"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBParametersResult",
            type: "structure",
            members: {
              Parameters: {
                shape: "S2s"
              },
              Marker: {}
            }
          }
        },
        DescribeDBSecurityGroups: {
          input: {
            type: "structure",
            members: {
              DBSecurityGroupName: {},
              Filters: {
                shape: "S27"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSecurityGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSecurityGroups: {
                type: "list",
                member: {
                  shape: "Sd",
                  locationName: "DBSecurityGroup"
                }
              }
            }
          }
        },
        DescribeDBSnapshots: {
          input: {
            type: "structure",
            members: {
              DBInstanceIdentifier: {},
              DBSnapshotIdentifier: {},
              SnapshotType: {},
              Filters: {
                shape: "S27"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSnapshotsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSnapshots: {
                type: "list",
                member: {
                  shape: "Sk",
                  locationName: "DBSnapshot"
                }
              }
            }
          }
        },
        DescribeDBSubnetGroups: {
          input: {
            type: "structure",
            members: {
              DBSubnetGroupName: {},
              Filters: {
                shape: "S27"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSubnetGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSubnetGroups: {
                type: "list",
                member: {
                  shape: "S11",
                  locationName: "DBSubnetGroup"
                }
              }
            }
          }
        },
        DescribeEngineDefaultParameters: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupFamily"
            ],
            members: {
              DBParameterGroupFamily: {},
              Filters: {
                shape: "S27"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEngineDefaultParametersResult",
            type: "structure",
            members: {
              EngineDefaults: {
                type: "structure",
                members: {
                  DBParameterGroupFamily: {},
                  Marker: {},
                  Parameters: {
                    shape: "S2s"
                  }
                },
                wrapper: true
              }
            }
          }
        },
        DescribeEventCategories: {
          input: {
            type: "structure",
            members: {
              SourceType: {},
              Filters: {
                shape: "S27"
              }
            }
          },
          output: {
            resultWrapper: "DescribeEventCategoriesResult",
            type: "structure",
            members: {
              EventCategoriesMapList: {
                type: "list",
                member: {
                  locationName: "EventCategoriesMap",
                  type: "structure",
                  members: {
                    SourceType: {},
                    EventCategories: {
                      shape: "S6"
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        DescribeEventSubscriptions: {
          input: {
            type: "structure",
            members: {
              SubscriptionName: {},
              Filters: {
                shape: "S27"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventSubscriptionsResult",
            type: "structure",
            members: {
              Marker: {},
              EventSubscriptionsList: {
                type: "list",
                member: {
                  shape: "S4",
                  locationName: "EventSubscription"
                }
              }
            }
          }
        },
        DescribeEvents: {
          input: {
            type: "structure",
            members: {
              SourceIdentifier: {},
              SourceType: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Duration: {
                type: "integer"
              },
              EventCategories: {
                shape: "S6"
              },
              Filters: {
                shape: "S27"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventsResult",
            type: "structure",
            members: {
              Marker: {},
              Events: {
                type: "list",
                member: {
                  locationName: "Event",
                  type: "structure",
                  members: {
                    SourceIdentifier: {},
                    SourceType: {},
                    Message: {},
                    EventCategories: {
                      shape: "S6"
                    },
                    Date: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeOptionGroupOptions: {
          input: {
            type: "structure",
            required: [
              "EngineName"
            ],
            members: {
              EngineName: {},
              MajorEngineVersion: {},
              Filters: {
                shape: "S27"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeOptionGroupOptionsResult",
            type: "structure",
            members: {
              OptionGroupOptions: {
                type: "list",
                member: {
                  locationName: "OptionGroupOption",
                  type: "structure",
                  members: {
                    Name: {},
                    Description: {},
                    EngineName: {},
                    MajorEngineVersion: {},
                    MinimumRequiredMinorEngineVersion: {},
                    PortRequired: {
                      type: "boolean"
                    },
                    DefaultPort: {
                      type: "integer"
                    },
                    OptionsDependedOn: {
                      type: "list",
                      member: {
                        locationName: "OptionName"
                      }
                    },
                    Persistent: {
                      type: "boolean"
                    },
                    Permanent: {
                      type: "boolean"
                    },
                    OptionGroupOptionSettings: {
                      type: "list",
                      member: {
                        locationName: "OptionGroupOptionSetting",
                        type: "structure",
                        members: {
                          SettingName: {},
                          SettingDescription: {},
                          DefaultValue: {},
                          ApplyType: {},
                          AllowedValues: {},
                          IsModifiable: {
                            type: "boolean"
                          }
                        }
                      }
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeOptionGroups: {
          input: {
            type: "structure",
            members: {
              OptionGroupName: {},
              Filters: {
                shape: "S27"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              },
              EngineName: {},
              MajorEngineVersion: {}
            }
          },
          output: {
            resultWrapper: "DescribeOptionGroupsResult",
            type: "structure",
            members: {
              OptionGroupsList: {
                type: "list",
                member: {
                  shape: "S1r",
                  locationName: "OptionGroup"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeOrderableDBInstanceOptions: {
          input: {
            type: "structure",
            required: [
              "Engine"
            ],
            members: {
              Engine: {},
              EngineVersion: {},
              DBInstanceClass: {},
              LicenseModel: {},
              Vpc: {
                type: "boolean"
              },
              Filters: {
                shape: "S27"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeOrderableDBInstanceOptionsResult",
            type: "structure",
            members: {
              OrderableDBInstanceOptions: {
                type: "list",
                member: {
                  locationName: "OrderableDBInstanceOption",
                  type: "structure",
                  members: {
                    Engine: {},
                    EngineVersion: {},
                    DBInstanceClass: {},
                    LicenseModel: {},
                    AvailabilityZones: {
                      type: "list",
                      member: {
                        shape: "S14",
                        locationName: "AvailabilityZone"
                      }
                    },
                    MultiAZCapable: {
                      type: "boolean"
                    },
                    ReadReplicaCapable: {
                      type: "boolean"
                    },
                    Vpc: {
                      type: "boolean"
                    }
                  },
                  wrapper: true
                }
              },
              Marker: {}
            }
          }
        },
        DescribeReservedDBInstances: {
          input: {
            type: "structure",
            members: {
              ReservedDBInstanceId: {},
              ReservedDBInstancesOfferingId: {},
              DBInstanceClass: {},
              Duration: {},
              ProductDescription: {},
              OfferingType: {},
              MultiAZ: {
                type: "boolean"
              },
              Filters: {
                shape: "S27"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeReservedDBInstancesResult",
            type: "structure",
            members: {
              Marker: {},
              ReservedDBInstances: {
                type: "list",
                member: {
                  shape: "S41",
                  locationName: "ReservedDBInstance"
                }
              }
            }
          }
        },
        DescribeReservedDBInstancesOfferings: {
          input: {
            type: "structure",
            members: {
              ReservedDBInstancesOfferingId: {},
              DBInstanceClass: {},
              Duration: {},
              ProductDescription: {},
              OfferingType: {},
              MultiAZ: {
                type: "boolean"
              },
              Filters: {
                shape: "S27"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeReservedDBInstancesOfferingsResult",
            type: "structure",
            members: {
              Marker: {},
              ReservedDBInstancesOfferings: {
                type: "list",
                member: {
                  locationName: "ReservedDBInstancesOffering",
                  type: "structure",
                  members: {
                    ReservedDBInstancesOfferingId: {},
                    DBInstanceClass: {},
                    Duration: {
                      type: "integer"
                    },
                    FixedPrice: {
                      type: "double"
                    },
                    UsagePrice: {
                      type: "double"
                    },
                    CurrencyCode: {},
                    ProductDescription: {},
                    OfferingType: {},
                    MultiAZ: {
                      type: "boolean"
                    },
                    RecurringCharges: {
                      shape: "S43"
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        DownloadDBLogFilePortion: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "LogFileName"
            ],
            members: {
              DBInstanceIdentifier: {},
              LogFileName: {},
              Marker: {},
              NumberOfLines: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DownloadDBLogFilePortionResult",
            type: "structure",
            members: {
              LogFileData: {},
              Marker: {},
              AdditionalDataPending: {
                type: "boolean"
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName"
            ],
            members: {
              ResourceName: {},
              Filters: {
                shape: "S27"
              }
            }
          },
          output: {
            resultWrapper: "ListTagsForResourceResult",
            type: "structure",
            members: {
              TagList: {
                shape: "S9"
              }
            }
          }
        },
        ModifyDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              AllocatedStorage: {
                type: "integer"
              },
              DBInstanceClass: {},
              DBSecurityGroups: {
                shape: "Sp"
              },
              VpcSecurityGroupIds: {
                shape: "Sq"
              },
              ApplyImmediately: {
                type: "boolean"
              },
              MasterUserPassword: {},
              DBParameterGroupName: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {},
              PreferredMaintenanceWindow: {},
              MultiAZ: {
                type: "boolean"
              },
              EngineVersion: {},
              AllowMajorVersionUpgrade: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              NewDBInstanceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "ModifyDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        ModifyDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName",
              "Parameters"
            ],
            members: {
              DBParameterGroupName: {},
              Parameters: {
                shape: "S2s"
              }
            }
          },
          output: {
            shape: "S4g",
            resultWrapper: "ModifyDBParameterGroupResult"
          }
        },
        ModifyDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName",
              "SubnetIds"
            ],
            members: {
              DBSubnetGroupName: {},
              DBSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S1l"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBSubnetGroupResult",
            type: "structure",
            members: {
              DBSubnetGroup: {
                shape: "S11"
              }
            }
          }
        },
        ModifyEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S6"
              },
              Enabled: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        ModifyOptionGroup: {
          input: {
            type: "structure",
            required: [
              "OptionGroupName"
            ],
            members: {
              OptionGroupName: {},
              OptionsToInclude: {
                type: "list",
                member: {
                  locationName: "OptionConfiguration",
                  type: "structure",
                  required: [
                    "OptionName"
                  ],
                  members: {
                    OptionName: {},
                    Port: {
                      type: "integer"
                    },
                    DBSecurityGroupMemberships: {
                      shape: "Sp"
                    },
                    VpcSecurityGroupMemberships: {
                      shape: "Sq"
                    },
                    OptionSettings: {
                      type: "list",
                      member: {
                        shape: "S1v",
                        locationName: "OptionSetting"
                      }
                    }
                  }
                }
              },
              OptionsToRemove: {
                type: "list",
                member: {}
              },
              ApplyImmediately: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyOptionGroupResult",
            type: "structure",
            members: {
              OptionGroup: {
                shape: "S1r"
              }
            }
          }
        },
        PromoteReadReplica: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {}
            }
          },
          output: {
            resultWrapper: "PromoteReadReplicaResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        PurchaseReservedDBInstancesOffering: {
          input: {
            type: "structure",
            required: [
              "ReservedDBInstancesOfferingId"
            ],
            members: {
              ReservedDBInstancesOfferingId: {},
              ReservedDBInstanceId: {},
              DBInstanceCount: {
                type: "integer"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "PurchaseReservedDBInstancesOfferingResult",
            type: "structure",
            members: {
              ReservedDBInstance: {
                shape: "S41"
              }
            }
          }
        },
        RebootDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              ForceFailover: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "RebootDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        RemoveSourceIdentifierFromSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SourceIdentifier"
            ],
            members: {
              SubscriptionName: {},
              SourceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "RemoveSourceIdentifierFromSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        RemoveTagsFromResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "TagKeys"
            ],
            members: {
              ResourceName: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ResetDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {},
              ResetAllParameters: {
                type: "boolean"
              },
              Parameters: {
                shape: "S2s"
              }
            }
          },
          output: {
            shape: "S4g",
            resultWrapper: "ResetDBParameterGroupResult"
          }
        },
        RestoreDBInstanceFromDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "DBSnapshotIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              DBSnapshotIdentifier: {},
              DBInstanceClass: {},
              Port: {
                type: "integer"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              MultiAZ: {
                type: "boolean"
              },
              PubliclyAccessible: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              DBName: {},
              Engine: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "RestoreDBInstanceFromDBSnapshotResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        RestoreDBInstanceToPointInTime: {
          input: {
            type: "structure",
            required: [
              "SourceDBInstanceIdentifier",
              "TargetDBInstanceIdentifier"
            ],
            members: {
              SourceDBInstanceIdentifier: {},
              TargetDBInstanceIdentifier: {},
              RestoreTime: {
                type: "timestamp"
              },
              UseLatestRestorableTime: {
                type: "boolean"
              },
              DBInstanceClass: {},
              Port: {
                type: "integer"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              MultiAZ: {
                type: "boolean"
              },
              PubliclyAccessible: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              DBName: {},
              Engine: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "RestoreDBInstanceToPointInTimeResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        RevokeDBSecurityGroupIngress: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName"
            ],
            members: {
              DBSecurityGroupName: {},
              CIDRIP: {},
              EC2SecurityGroupName: {},
              EC2SecurityGroupId: {},
              EC2SecurityGroupOwnerId: {}
            }
          },
          output: {
            resultWrapper: "RevokeDBSecurityGroupIngressResult",
            type: "structure",
            members: {
              DBSecurityGroup: {
                shape: "Sd"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            CustomerAwsId: {},
            CustSubscriptionId: {},
            SnsTopicArn: {},
            Status: {},
            SubscriptionCreationTime: {},
            SourceType: {},
            SourceIdsList: {
              shape: "S5"
            },
            EventCategoriesList: {
              shape: "S6"
            },
            Enabled: {
              type: "boolean"
            }
          },
          wrapper: true
        },
        S5: {
          type: "list",
          member: {
            locationName: "SourceId"
          }
        },
        S6: {
          type: "list",
          member: {
            locationName: "EventCategory"
          }
        },
        S9: {
          type: "list",
          member: {
            locationName: "Tag",
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sd: {
          type: "structure",
          members: {
            OwnerId: {},
            DBSecurityGroupName: {},
            DBSecurityGroupDescription: {},
            VpcId: {},
            EC2SecurityGroups: {
              type: "list",
              member: {
                locationName: "EC2SecurityGroup",
                type: "structure",
                members: {
                  Status: {},
                  EC2SecurityGroupName: {},
                  EC2SecurityGroupId: {},
                  EC2SecurityGroupOwnerId: {}
                }
              }
            },
            IPRanges: {
              type: "list",
              member: {
                locationName: "IPRange",
                type: "structure",
                members: {
                  Status: {},
                  CIDRIP: {}
                }
              }
            }
          },
          wrapper: true
        },
        Sk: {
          type: "structure",
          members: {
            DBSnapshotIdentifier: {},
            DBInstanceIdentifier: {},
            SnapshotCreateTime: {
              type: "timestamp"
            },
            Engine: {},
            AllocatedStorage: {
              type: "integer"
            },
            Status: {},
            Port: {
              type: "integer"
            },
            AvailabilityZone: {},
            VpcId: {},
            InstanceCreateTime: {
              type: "timestamp"
            },
            MasterUsername: {},
            EngineVersion: {},
            LicenseModel: {},
            SnapshotType: {},
            Iops: {
              type: "integer"
            },
            OptionGroupName: {},
            PercentProgress: {
              type: "integer"
            },
            SourceRegion: {}
          },
          wrapper: true
        },
        Sp: {
          type: "list",
          member: {
            locationName: "DBSecurityGroupName"
          }
        },
        Sq: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroupId"
          }
        },
        St: {
          type: "structure",
          members: {
            DBInstanceIdentifier: {},
            DBInstanceClass: {},
            Engine: {},
            DBInstanceStatus: {},
            MasterUsername: {},
            DBName: {},
            Endpoint: {
              type: "structure",
              members: {
                Address: {},
                Port: {
                  type: "integer"
                }
              }
            },
            AllocatedStorage: {
              type: "integer"
            },
            InstanceCreateTime: {
              type: "timestamp"
            },
            PreferredBackupWindow: {},
            BackupRetentionPeriod: {
              type: "integer"
            },
            DBSecurityGroups: {
              shape: "Sv"
            },
            VpcSecurityGroups: {
              shape: "Sx"
            },
            DBParameterGroups: {
              type: "list",
              member: {
                locationName: "DBParameterGroup",
                type: "structure",
                members: {
                  DBParameterGroupName: {},
                  ParameterApplyStatus: {}
                }
              }
            },
            AvailabilityZone: {},
            DBSubnetGroup: {
              shape: "S11"
            },
            PreferredMaintenanceWindow: {},
            PendingModifiedValues: {
              type: "structure",
              members: {
                DBInstanceClass: {},
                AllocatedStorage: {
                  type: "integer"
                },
                MasterUserPassword: {},
                Port: {
                  type: "integer"
                },
                BackupRetentionPeriod: {
                  type: "integer"
                },
                MultiAZ: {
                  type: "boolean"
                },
                EngineVersion: {},
                Iops: {
                  type: "integer"
                },
                DBInstanceIdentifier: {}
              }
            },
            LatestRestorableTime: {
              type: "timestamp"
            },
            MultiAZ: {
              type: "boolean"
            },
            EngineVersion: {},
            AutoMinorVersionUpgrade: {
              type: "boolean"
            },
            ReadReplicaSourceDBInstanceIdentifier: {},
            ReadReplicaDBInstanceIdentifiers: {
              type: "list",
              member: {
                locationName: "ReadReplicaDBInstanceIdentifier"
              }
            },
            LicenseModel: {},
            Iops: {
              type: "integer"
            },
            OptionGroupMemberships: {
              type: "list",
              member: {
                locationName: "OptionGroupMembership",
                type: "structure",
                members: {
                  OptionGroupName: {},
                  Status: {}
                }
              }
            },
            CharacterSetName: {},
            SecondaryAvailabilityZone: {},
            PubliclyAccessible: {
              type: "boolean"
            },
            StatusInfos: {
              type: "list",
              member: {
                locationName: "DBInstanceStatusInfo",
                type: "structure",
                members: {
                  StatusType: {},
                  Normal: {
                    type: "boolean"
                  },
                  Status: {},
                  Message: {}
                }
              }
            }
          },
          wrapper: true
        },
        Sv: {
          type: "list",
          member: {
            locationName: "DBSecurityGroup",
            type: "structure",
            members: {
              DBSecurityGroupName: {},
              Status: {}
            }
          }
        },
        Sx: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroupMembership",
            type: "structure",
            members: {
              VpcSecurityGroupId: {},
              Status: {}
            }
          }
        },
        S11: {
          type: "structure",
          members: {
            DBSubnetGroupName: {},
            DBSubnetGroupDescription: {},
            VpcId: {},
            SubnetGroupStatus: {},
            Subnets: {
              type: "list",
              member: {
                locationName: "Subnet",
                type: "structure",
                members: {
                  SubnetIdentifier: {},
                  SubnetAvailabilityZone: {
                    shape: "S14"
                  },
                  SubnetStatus: {}
                }
              }
            }
          },
          wrapper: true
        },
        S14: {
          type: "structure",
          members: {
            Name: {},
            ProvisionedIopsCapable: {
              type: "boolean"
            }
          },
          wrapper: true
        },
        S1f: {
          type: "structure",
          members: {
            DBParameterGroupName: {},
            DBParameterGroupFamily: {},
            Description: {}
          },
          wrapper: true
        },
        S1l: {
          type: "list",
          member: {
            locationName: "SubnetIdentifier"
          }
        },
        S1r: {
          type: "structure",
          members: {
            OptionGroupName: {},
            OptionGroupDescription: {},
            EngineName: {},
            MajorEngineVersion: {},
            Options: {
              type: "list",
              member: {
                locationName: "Option",
                type: "structure",
                members: {
                  OptionName: {},
                  OptionDescription: {},
                  Persistent: {
                    type: "boolean"
                  },
                  Permanent: {
                    type: "boolean"
                  },
                  Port: {
                    type: "integer"
                  },
                  OptionSettings: {
                    type: "list",
                    member: {
                      shape: "S1v",
                      locationName: "OptionSetting"
                    }
                  },
                  DBSecurityGroupMemberships: {
                    shape: "Sv"
                  },
                  VpcSecurityGroupMemberships: {
                    shape: "Sx"
                  }
                }
              }
            },
            AllowsVpcAndNonVpcInstanceMemberships: {
              type: "boolean"
            },
            VpcId: {}
          },
          wrapper: true
        },
        S1v: {
          type: "structure",
          members: {
            Name: {},
            Value: {},
            DefaultValue: {},
            Description: {},
            ApplyType: {},
            DataType: {},
            AllowedValues: {},
            IsModifiable: {
              type: "boolean"
            },
            IsCollection: {
              type: "boolean"
            }
          }
        },
        S27: {
          type: "list",
          member: {
            locationName: "Filter",
            type: "structure",
            required: [
              "Name",
              "Values"
            ],
            members: {
              Name: {},
              Values: {
                type: "list",
                member: {
                  locationName: "Value"
                }
              }
            }
          }
        },
        S2d: {
          type: "structure",
          members: {
            CharacterSetName: {},
            CharacterSetDescription: {}
          }
        },
        S2s: {
          type: "list",
          member: {
            locationName: "Parameter",
            type: "structure",
            members: {
              ParameterName: {},
              ParameterValue: {},
              Description: {},
              Source: {},
              ApplyType: {},
              DataType: {},
              AllowedValues: {},
              IsModifiable: {
                type: "boolean"
              },
              MinimumEngineVersion: {},
              ApplyMethod: {}
            }
          }
        },
        S41: {
          type: "structure",
          members: {
            ReservedDBInstanceId: {},
            ReservedDBInstancesOfferingId: {},
            DBInstanceClass: {},
            StartTime: {
              type: "timestamp"
            },
            Duration: {
              type: "integer"
            },
            FixedPrice: {
              type: "double"
            },
            UsagePrice: {
              type: "double"
            },
            CurrencyCode: {},
            DBInstanceCount: {
              type: "integer"
            },
            ProductDescription: {},
            OfferingType: {},
            MultiAZ: {
              type: "boolean"
            },
            State: {},
            RecurringCharges: {
              shape: "S43"
            }
          },
          wrapper: true
        },
        S43: {
          type: "list",
          member: {
            locationName: "RecurringCharge",
            type: "structure",
            members: {
              RecurringChargeAmount: {
                type: "double"
              },
              RecurringChargeFrequency: {}
            },
            wrapper: true
          }
        },
        S4g: {
          type: "structure",
          members: {
            DBParameterGroupName: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/rds-2013-09-09.paginators.json
var require_rds_2013_09_09_paginators = __commonJS({
  "node_modules/aws-sdk/apis/rds-2013-09-09.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeDBEngineVersions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBEngineVersions"
        },
        DescribeDBInstances: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBInstances"
        },
        DescribeDBLogFiles: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DescribeDBLogFiles"
        },
        DescribeDBParameterGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBParameterGroups"
        },
        DescribeDBParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Parameters"
        },
        DescribeDBSecurityGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBSecurityGroups"
        },
        DescribeDBSnapshots: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBSnapshots"
        },
        DescribeDBSubnetGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBSubnetGroups"
        },
        DescribeEngineDefaultParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "EngineDefaults.Marker",
          result_key: "EngineDefaults.Parameters"
        },
        DescribeEventSubscriptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "EventSubscriptionsList"
        },
        DescribeEvents: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Events"
        },
        DescribeOptionGroupOptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "OptionGroupOptions"
        },
        DescribeOptionGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "OptionGroupsList"
        },
        DescribeOrderableDBInstanceOptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "OrderableDBInstanceOptions"
        },
        DescribeReservedDBInstances: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ReservedDBInstances"
        },
        DescribeReservedDBInstancesOfferings: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ReservedDBInstancesOfferings"
        },
        DownloadDBLogFilePortion: {
          input_token: "Marker",
          limit_key: "NumberOfLines",
          more_results: "AdditionalDataPending",
          output_token: "Marker",
          result_key: "LogFileData"
        },
        ListTagsForResource: {
          result_key: "TagList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/rds-2013-09-09.waiters2.json
var require_rds_2013_09_09_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/rds-2013-09-09.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        DBInstanceAvailable: {
          delay: 30,
          operation: "DescribeDBInstances",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "available",
              matcher: "pathAll",
              state: "success",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "deleted",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "deleting",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "failed",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "incompatible-restore",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "incompatible-parameters",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "incompatible-parameters",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "incompatible-restore",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            }
          ]
        },
        DBInstanceDeleted: {
          delay: 30,
          operation: "DescribeDBInstances",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "deleted",
              matcher: "pathAll",
              state: "success",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "creating",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "modifying",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "rebooting",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "resetting-master-credentials",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/rds-2014-09-01.min.json
var require_rds_2014_09_01_min = __commonJS({
  "node_modules/aws-sdk/apis/rds-2014-09-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-09-01",
        endpointPrefix: "rds",
        protocol: "query",
        serviceAbbreviation: "Amazon RDS",
        serviceFullName: "Amazon Relational Database Service",
        serviceId: "RDS",
        signatureVersion: "v4",
        uid: "rds-2014-09-01",
        xmlNamespace: "http://rds.amazonaws.com/doc/2014-09-01/"
      },
      operations: {
        AddSourceIdentifierToSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SourceIdentifier"
            ],
            members: {
              SubscriptionName: {},
              SourceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "AddSourceIdentifierToSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        AddTagsToResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "Tags"
            ],
            members: {
              ResourceName: {},
              Tags: {
                shape: "S9"
              }
            }
          }
        },
        AuthorizeDBSecurityGroupIngress: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName"
            ],
            members: {
              DBSecurityGroupName: {},
              CIDRIP: {},
              EC2SecurityGroupName: {},
              EC2SecurityGroupId: {},
              EC2SecurityGroupOwnerId: {}
            }
          },
          output: {
            resultWrapper: "AuthorizeDBSecurityGroupIngressResult",
            type: "structure",
            members: {
              DBSecurityGroup: {
                shape: "Sd"
              }
            }
          }
        },
        CopyDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "SourceDBParameterGroupIdentifier",
              "TargetDBParameterGroupIdentifier",
              "TargetDBParameterGroupDescription"
            ],
            members: {
              SourceDBParameterGroupIdentifier: {},
              TargetDBParameterGroupIdentifier: {},
              TargetDBParameterGroupDescription: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CopyDBParameterGroupResult",
            type: "structure",
            members: {
              DBParameterGroup: {
                shape: "Sk"
              }
            }
          }
        },
        CopyDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "SourceDBSnapshotIdentifier",
              "TargetDBSnapshotIdentifier"
            ],
            members: {
              SourceDBSnapshotIdentifier: {},
              TargetDBSnapshotIdentifier: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CopyDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "Sn"
              }
            }
          }
        },
        CopyOptionGroup: {
          input: {
            type: "structure",
            required: [
              "SourceOptionGroupIdentifier",
              "TargetOptionGroupIdentifier",
              "TargetOptionGroupDescription"
            ],
            members: {
              SourceOptionGroupIdentifier: {},
              TargetOptionGroupIdentifier: {},
              TargetOptionGroupDescription: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CopyOptionGroupResult",
            type: "structure",
            members: {
              OptionGroup: {
                shape: "St"
              }
            }
          }
        },
        CreateDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "AllocatedStorage",
              "DBInstanceClass",
              "Engine",
              "MasterUsername",
              "MasterUserPassword"
            ],
            members: {
              DBName: {},
              DBInstanceIdentifier: {},
              AllocatedStorage: {
                type: "integer"
              },
              DBInstanceClass: {},
              Engine: {},
              MasterUsername: {},
              MasterUserPassword: {},
              DBSecurityGroups: {
                shape: "S13"
              },
              VpcSecurityGroupIds: {
                shape: "S14"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              PreferredMaintenanceWindow: {},
              DBParameterGroupName: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {},
              Port: {
                type: "integer"
              },
              MultiAZ: {
                type: "boolean"
              },
              EngineVersion: {},
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              CharacterSetName: {},
              PubliclyAccessible: {
                type: "boolean"
              },
              Tags: {
                shape: "S9"
              },
              StorageType: {},
              TdeCredentialArn: {},
              TdeCredentialPassword: {}
            }
          },
          output: {
            resultWrapper: "CreateDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S17"
              }
            }
          }
        },
        CreateDBInstanceReadReplica: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "SourceDBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              SourceDBInstanceIdentifier: {},
              DBInstanceClass: {},
              AvailabilityZone: {},
              Port: {
                type: "integer"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              PubliclyAccessible: {
                type: "boolean"
              },
              Tags: {
                shape: "S9"
              },
              DBSubnetGroupName: {},
              StorageType: {}
            }
          },
          output: {
            resultWrapper: "CreateDBInstanceReadReplicaResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S17"
              }
            }
          }
        },
        CreateDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName",
              "DBParameterGroupFamily",
              "Description"
            ],
            members: {
              DBParameterGroupName: {},
              DBParameterGroupFamily: {},
              Description: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBParameterGroupResult",
            type: "structure",
            members: {
              DBParameterGroup: {
                shape: "Sk"
              }
            }
          }
        },
        CreateDBSecurityGroup: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName",
              "DBSecurityGroupDescription"
            ],
            members: {
              DBSecurityGroupName: {},
              DBSecurityGroupDescription: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBSecurityGroupResult",
            type: "structure",
            members: {
              DBSecurityGroup: {
                shape: "Sd"
              }
            }
          }
        },
        CreateDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBSnapshotIdentifier",
              "DBInstanceIdentifier"
            ],
            members: {
              DBSnapshotIdentifier: {},
              DBInstanceIdentifier: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "Sn"
              }
            }
          }
        },
        CreateDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName",
              "DBSubnetGroupDescription",
              "SubnetIds"
            ],
            members: {
              DBSubnetGroupName: {},
              DBSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S1u"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBSubnetGroupResult",
            type: "structure",
            members: {
              DBSubnetGroup: {
                shape: "S1b"
              }
            }
          }
        },
        CreateEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SnsTopicArn"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S6"
              },
              SourceIds: {
                shape: "S5"
              },
              Enabled: {
                type: "boolean"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        CreateOptionGroup: {
          input: {
            type: "structure",
            required: [
              "OptionGroupName",
              "EngineName",
              "MajorEngineVersion",
              "OptionGroupDescription"
            ],
            members: {
              OptionGroupName: {},
              EngineName: {},
              MajorEngineVersion: {},
              OptionGroupDescription: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateOptionGroupResult",
            type: "structure",
            members: {
              OptionGroup: {
                shape: "St"
              }
            }
          }
        },
        DeleteDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              SkipFinalSnapshot: {
                type: "boolean"
              },
              FinalDBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S17"
              }
            }
          }
        },
        DeleteDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {}
            }
          }
        },
        DeleteDBSecurityGroup: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName"
            ],
            members: {
              DBSecurityGroupName: {}
            }
          }
        },
        DeleteDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBSnapshotIdentifier"
            ],
            members: {
              DBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "Sn"
              }
            }
          }
        },
        DeleteDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName"
            ],
            members: {
              DBSubnetGroupName: {}
            }
          }
        },
        DeleteEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {}
            }
          },
          output: {
            resultWrapper: "DeleteEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        DeleteOptionGroup: {
          input: {
            type: "structure",
            required: [
              "OptionGroupName"
            ],
            members: {
              OptionGroupName: {}
            }
          }
        },
        DescribeDBEngineVersions: {
          input: {
            type: "structure",
            members: {
              Engine: {},
              EngineVersion: {},
              DBParameterGroupFamily: {},
              Filters: {
                shape: "S2b"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              DefaultOnly: {
                type: "boolean"
              },
              ListSupportedCharacterSets: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeDBEngineVersionsResult",
            type: "structure",
            members: {
              Marker: {},
              DBEngineVersions: {
                type: "list",
                member: {
                  locationName: "DBEngineVersion",
                  type: "structure",
                  members: {
                    Engine: {},
                    EngineVersion: {},
                    DBParameterGroupFamily: {},
                    DBEngineDescription: {},
                    DBEngineVersionDescription: {},
                    DefaultCharacterSet: {
                      shape: "S2h"
                    },
                    SupportedCharacterSets: {
                      type: "list",
                      member: {
                        shape: "S2h",
                        locationName: "CharacterSet"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeDBInstances: {
          input: {
            type: "structure",
            members: {
              DBInstanceIdentifier: {},
              Filters: {
                shape: "S2b"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBInstancesResult",
            type: "structure",
            members: {
              Marker: {},
              DBInstances: {
                type: "list",
                member: {
                  shape: "S17",
                  locationName: "DBInstance"
                }
              }
            }
          }
        },
        DescribeDBLogFiles: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              FilenameContains: {},
              FileLastWritten: {
                type: "long"
              },
              FileSize: {
                type: "long"
              },
              Filters: {
                shape: "S2b"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBLogFilesResult",
            type: "structure",
            members: {
              DescribeDBLogFiles: {
                type: "list",
                member: {
                  locationName: "DescribeDBLogFilesDetails",
                  type: "structure",
                  members: {
                    LogFileName: {},
                    LastWritten: {
                      type: "long"
                    },
                    Size: {
                      type: "long"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeDBParameterGroups: {
          input: {
            type: "structure",
            members: {
              DBParameterGroupName: {},
              Filters: {
                shape: "S2b"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBParameterGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBParameterGroups: {
                type: "list",
                member: {
                  shape: "Sk",
                  locationName: "DBParameterGroup"
                }
              }
            }
          }
        },
        DescribeDBParameters: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {},
              Source: {},
              Filters: {
                shape: "S2b"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBParametersResult",
            type: "structure",
            members: {
              Parameters: {
                shape: "S2w"
              },
              Marker: {}
            }
          }
        },
        DescribeDBSecurityGroups: {
          input: {
            type: "structure",
            members: {
              DBSecurityGroupName: {},
              Filters: {
                shape: "S2b"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSecurityGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSecurityGroups: {
                type: "list",
                member: {
                  shape: "Sd",
                  locationName: "DBSecurityGroup"
                }
              }
            }
          }
        },
        DescribeDBSnapshots: {
          input: {
            type: "structure",
            members: {
              DBInstanceIdentifier: {},
              DBSnapshotIdentifier: {},
              SnapshotType: {},
              Filters: {
                shape: "S2b"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSnapshotsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSnapshots: {
                type: "list",
                member: {
                  shape: "Sn",
                  locationName: "DBSnapshot"
                }
              }
            }
          }
        },
        DescribeDBSubnetGroups: {
          input: {
            type: "structure",
            members: {
              DBSubnetGroupName: {},
              Filters: {
                shape: "S2b"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSubnetGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSubnetGroups: {
                type: "list",
                member: {
                  shape: "S1b",
                  locationName: "DBSubnetGroup"
                }
              }
            }
          }
        },
        DescribeEngineDefaultParameters: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupFamily"
            ],
            members: {
              DBParameterGroupFamily: {},
              Filters: {
                shape: "S2b"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEngineDefaultParametersResult",
            type: "structure",
            members: {
              EngineDefaults: {
                type: "structure",
                members: {
                  DBParameterGroupFamily: {},
                  Marker: {},
                  Parameters: {
                    shape: "S2w"
                  }
                },
                wrapper: true
              }
            }
          }
        },
        DescribeEventCategories: {
          input: {
            type: "structure",
            members: {
              SourceType: {},
              Filters: {
                shape: "S2b"
              }
            }
          },
          output: {
            resultWrapper: "DescribeEventCategoriesResult",
            type: "structure",
            members: {
              EventCategoriesMapList: {
                type: "list",
                member: {
                  locationName: "EventCategoriesMap",
                  type: "structure",
                  members: {
                    SourceType: {},
                    EventCategories: {
                      shape: "S6"
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        DescribeEventSubscriptions: {
          input: {
            type: "structure",
            members: {
              SubscriptionName: {},
              Filters: {
                shape: "S2b"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventSubscriptionsResult",
            type: "structure",
            members: {
              Marker: {},
              EventSubscriptionsList: {
                type: "list",
                member: {
                  shape: "S4",
                  locationName: "EventSubscription"
                }
              }
            }
          }
        },
        DescribeEvents: {
          input: {
            type: "structure",
            members: {
              SourceIdentifier: {},
              SourceType: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Duration: {
                type: "integer"
              },
              EventCategories: {
                shape: "S6"
              },
              Filters: {
                shape: "S2b"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventsResult",
            type: "structure",
            members: {
              Marker: {},
              Events: {
                type: "list",
                member: {
                  locationName: "Event",
                  type: "structure",
                  members: {
                    SourceIdentifier: {},
                    SourceType: {},
                    Message: {},
                    EventCategories: {
                      shape: "S6"
                    },
                    Date: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeOptionGroupOptions: {
          input: {
            type: "structure",
            required: [
              "EngineName"
            ],
            members: {
              EngineName: {},
              MajorEngineVersion: {},
              Filters: {
                shape: "S2b"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeOptionGroupOptionsResult",
            type: "structure",
            members: {
              OptionGroupOptions: {
                type: "list",
                member: {
                  locationName: "OptionGroupOption",
                  type: "structure",
                  members: {
                    Name: {},
                    Description: {},
                    EngineName: {},
                    MajorEngineVersion: {},
                    MinimumRequiredMinorEngineVersion: {},
                    PortRequired: {
                      type: "boolean"
                    },
                    DefaultPort: {
                      type: "integer"
                    },
                    OptionsDependedOn: {
                      type: "list",
                      member: {
                        locationName: "OptionName"
                      }
                    },
                    Persistent: {
                      type: "boolean"
                    },
                    Permanent: {
                      type: "boolean"
                    },
                    OptionGroupOptionSettings: {
                      type: "list",
                      member: {
                        locationName: "OptionGroupOptionSetting",
                        type: "structure",
                        members: {
                          SettingName: {},
                          SettingDescription: {},
                          DefaultValue: {},
                          ApplyType: {},
                          AllowedValues: {},
                          IsModifiable: {
                            type: "boolean"
                          }
                        }
                      }
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeOptionGroups: {
          input: {
            type: "structure",
            members: {
              OptionGroupName: {},
              Filters: {
                shape: "S2b"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              },
              EngineName: {},
              MajorEngineVersion: {}
            }
          },
          output: {
            resultWrapper: "DescribeOptionGroupsResult",
            type: "structure",
            members: {
              OptionGroupsList: {
                type: "list",
                member: {
                  shape: "St",
                  locationName: "OptionGroup"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeOrderableDBInstanceOptions: {
          input: {
            type: "structure",
            required: [
              "Engine"
            ],
            members: {
              Engine: {},
              EngineVersion: {},
              DBInstanceClass: {},
              LicenseModel: {},
              Vpc: {
                type: "boolean"
              },
              Filters: {
                shape: "S2b"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeOrderableDBInstanceOptionsResult",
            type: "structure",
            members: {
              OrderableDBInstanceOptions: {
                type: "list",
                member: {
                  locationName: "OrderableDBInstanceOption",
                  type: "structure",
                  members: {
                    Engine: {},
                    EngineVersion: {},
                    DBInstanceClass: {},
                    LicenseModel: {},
                    AvailabilityZones: {
                      type: "list",
                      member: {
                        shape: "S1e",
                        locationName: "AvailabilityZone"
                      }
                    },
                    MultiAZCapable: {
                      type: "boolean"
                    },
                    ReadReplicaCapable: {
                      type: "boolean"
                    },
                    Vpc: {
                      type: "boolean"
                    },
                    StorageType: {},
                    SupportsIops: {
                      type: "boolean"
                    }
                  },
                  wrapper: true
                }
              },
              Marker: {}
            }
          }
        },
        DescribeReservedDBInstances: {
          input: {
            type: "structure",
            members: {
              ReservedDBInstanceId: {},
              ReservedDBInstancesOfferingId: {},
              DBInstanceClass: {},
              Duration: {},
              ProductDescription: {},
              OfferingType: {},
              MultiAZ: {
                type: "boolean"
              },
              Filters: {
                shape: "S2b"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeReservedDBInstancesResult",
            type: "structure",
            members: {
              Marker: {},
              ReservedDBInstances: {
                type: "list",
                member: {
                  shape: "S45",
                  locationName: "ReservedDBInstance"
                }
              }
            }
          }
        },
        DescribeReservedDBInstancesOfferings: {
          input: {
            type: "structure",
            members: {
              ReservedDBInstancesOfferingId: {},
              DBInstanceClass: {},
              Duration: {},
              ProductDescription: {},
              OfferingType: {},
              MultiAZ: {
                type: "boolean"
              },
              Filters: {
                shape: "S2b"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeReservedDBInstancesOfferingsResult",
            type: "structure",
            members: {
              Marker: {},
              ReservedDBInstancesOfferings: {
                type: "list",
                member: {
                  locationName: "ReservedDBInstancesOffering",
                  type: "structure",
                  members: {
                    ReservedDBInstancesOfferingId: {},
                    DBInstanceClass: {},
                    Duration: {
                      type: "integer"
                    },
                    FixedPrice: {
                      type: "double"
                    },
                    UsagePrice: {
                      type: "double"
                    },
                    CurrencyCode: {},
                    ProductDescription: {},
                    OfferingType: {},
                    MultiAZ: {
                      type: "boolean"
                    },
                    RecurringCharges: {
                      shape: "S47"
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        DownloadDBLogFilePortion: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "LogFileName"
            ],
            members: {
              DBInstanceIdentifier: {},
              LogFileName: {},
              Marker: {},
              NumberOfLines: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DownloadDBLogFilePortionResult",
            type: "structure",
            members: {
              LogFileData: {},
              Marker: {},
              AdditionalDataPending: {
                type: "boolean"
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName"
            ],
            members: {
              ResourceName: {},
              Filters: {
                shape: "S2b"
              }
            }
          },
          output: {
            resultWrapper: "ListTagsForResourceResult",
            type: "structure",
            members: {
              TagList: {
                shape: "S9"
              }
            }
          }
        },
        ModifyDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              AllocatedStorage: {
                type: "integer"
              },
              DBInstanceClass: {},
              DBSecurityGroups: {
                shape: "S13"
              },
              VpcSecurityGroupIds: {
                shape: "S14"
              },
              ApplyImmediately: {
                type: "boolean"
              },
              MasterUserPassword: {},
              DBParameterGroupName: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {},
              PreferredMaintenanceWindow: {},
              MultiAZ: {
                type: "boolean"
              },
              EngineVersion: {},
              AllowMajorVersionUpgrade: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              NewDBInstanceIdentifier: {},
              StorageType: {},
              TdeCredentialArn: {},
              TdeCredentialPassword: {}
            }
          },
          output: {
            resultWrapper: "ModifyDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S17"
              }
            }
          }
        },
        ModifyDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName",
              "Parameters"
            ],
            members: {
              DBParameterGroupName: {},
              Parameters: {
                shape: "S2w"
              }
            }
          },
          output: {
            shape: "S4k",
            resultWrapper: "ModifyDBParameterGroupResult"
          }
        },
        ModifyDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName",
              "SubnetIds"
            ],
            members: {
              DBSubnetGroupName: {},
              DBSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S1u"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBSubnetGroupResult",
            type: "structure",
            members: {
              DBSubnetGroup: {
                shape: "S1b"
              }
            }
          }
        },
        ModifyEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S6"
              },
              Enabled: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        ModifyOptionGroup: {
          input: {
            type: "structure",
            required: [
              "OptionGroupName"
            ],
            members: {
              OptionGroupName: {},
              OptionsToInclude: {
                type: "list",
                member: {
                  locationName: "OptionConfiguration",
                  type: "structure",
                  required: [
                    "OptionName"
                  ],
                  members: {
                    OptionName: {},
                    Port: {
                      type: "integer"
                    },
                    DBSecurityGroupMemberships: {
                      shape: "S13"
                    },
                    VpcSecurityGroupMemberships: {
                      shape: "S14"
                    },
                    OptionSettings: {
                      type: "list",
                      member: {
                        shape: "Sx",
                        locationName: "OptionSetting"
                      }
                    }
                  }
                }
              },
              OptionsToRemove: {
                type: "list",
                member: {}
              },
              ApplyImmediately: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyOptionGroupResult",
            type: "structure",
            members: {
              OptionGroup: {
                shape: "St"
              }
            }
          }
        },
        PromoteReadReplica: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {}
            }
          },
          output: {
            resultWrapper: "PromoteReadReplicaResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S17"
              }
            }
          }
        },
        PurchaseReservedDBInstancesOffering: {
          input: {
            type: "structure",
            required: [
              "ReservedDBInstancesOfferingId"
            ],
            members: {
              ReservedDBInstancesOfferingId: {},
              ReservedDBInstanceId: {},
              DBInstanceCount: {
                type: "integer"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "PurchaseReservedDBInstancesOfferingResult",
            type: "structure",
            members: {
              ReservedDBInstance: {
                shape: "S45"
              }
            }
          }
        },
        RebootDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              ForceFailover: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "RebootDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S17"
              }
            }
          }
        },
        RemoveSourceIdentifierFromSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SourceIdentifier"
            ],
            members: {
              SubscriptionName: {},
              SourceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "RemoveSourceIdentifierFromSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        RemoveTagsFromResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "TagKeys"
            ],
            members: {
              ResourceName: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ResetDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {},
              ResetAllParameters: {
                type: "boolean"
              },
              Parameters: {
                shape: "S2w"
              }
            }
          },
          output: {
            shape: "S4k",
            resultWrapper: "ResetDBParameterGroupResult"
          }
        },
        RestoreDBInstanceFromDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "DBSnapshotIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              DBSnapshotIdentifier: {},
              DBInstanceClass: {},
              Port: {
                type: "integer"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              MultiAZ: {
                type: "boolean"
              },
              PubliclyAccessible: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              DBName: {},
              Engine: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              Tags: {
                shape: "S9"
              },
              StorageType: {},
              TdeCredentialArn: {},
              TdeCredentialPassword: {}
            }
          },
          output: {
            resultWrapper: "RestoreDBInstanceFromDBSnapshotResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S17"
              }
            }
          }
        },
        RestoreDBInstanceToPointInTime: {
          input: {
            type: "structure",
            required: [
              "SourceDBInstanceIdentifier",
              "TargetDBInstanceIdentifier"
            ],
            members: {
              SourceDBInstanceIdentifier: {},
              TargetDBInstanceIdentifier: {},
              RestoreTime: {
                type: "timestamp"
              },
              UseLatestRestorableTime: {
                type: "boolean"
              },
              DBInstanceClass: {},
              Port: {
                type: "integer"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              MultiAZ: {
                type: "boolean"
              },
              PubliclyAccessible: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              DBName: {},
              Engine: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              Tags: {
                shape: "S9"
              },
              StorageType: {},
              TdeCredentialArn: {},
              TdeCredentialPassword: {}
            }
          },
          output: {
            resultWrapper: "RestoreDBInstanceToPointInTimeResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S17"
              }
            }
          }
        },
        RevokeDBSecurityGroupIngress: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName"
            ],
            members: {
              DBSecurityGroupName: {},
              CIDRIP: {},
              EC2SecurityGroupName: {},
              EC2SecurityGroupId: {},
              EC2SecurityGroupOwnerId: {}
            }
          },
          output: {
            resultWrapper: "RevokeDBSecurityGroupIngressResult",
            type: "structure",
            members: {
              DBSecurityGroup: {
                shape: "Sd"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            CustomerAwsId: {},
            CustSubscriptionId: {},
            SnsTopicArn: {},
            Status: {},
            SubscriptionCreationTime: {},
            SourceType: {},
            SourceIdsList: {
              shape: "S5"
            },
            EventCategoriesList: {
              shape: "S6"
            },
            Enabled: {
              type: "boolean"
            }
          },
          wrapper: true
        },
        S5: {
          type: "list",
          member: {
            locationName: "SourceId"
          }
        },
        S6: {
          type: "list",
          member: {
            locationName: "EventCategory"
          }
        },
        S9: {
          type: "list",
          member: {
            locationName: "Tag",
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sd: {
          type: "structure",
          members: {
            OwnerId: {},
            DBSecurityGroupName: {},
            DBSecurityGroupDescription: {},
            VpcId: {},
            EC2SecurityGroups: {
              type: "list",
              member: {
                locationName: "EC2SecurityGroup",
                type: "structure",
                members: {
                  Status: {},
                  EC2SecurityGroupName: {},
                  EC2SecurityGroupId: {},
                  EC2SecurityGroupOwnerId: {}
                }
              }
            },
            IPRanges: {
              type: "list",
              member: {
                locationName: "IPRange",
                type: "structure",
                members: {
                  Status: {},
                  CIDRIP: {}
                }
              }
            }
          },
          wrapper: true
        },
        Sk: {
          type: "structure",
          members: {
            DBParameterGroupName: {},
            DBParameterGroupFamily: {},
            Description: {}
          },
          wrapper: true
        },
        Sn: {
          type: "structure",
          members: {
            DBSnapshotIdentifier: {},
            DBInstanceIdentifier: {},
            SnapshotCreateTime: {
              type: "timestamp"
            },
            Engine: {},
            AllocatedStorage: {
              type: "integer"
            },
            Status: {},
            Port: {
              type: "integer"
            },
            AvailabilityZone: {},
            VpcId: {},
            InstanceCreateTime: {
              type: "timestamp"
            },
            MasterUsername: {},
            EngineVersion: {},
            LicenseModel: {},
            SnapshotType: {},
            Iops: {
              type: "integer"
            },
            OptionGroupName: {},
            PercentProgress: {
              type: "integer"
            },
            SourceRegion: {},
            StorageType: {},
            TdeCredentialArn: {}
          },
          wrapper: true
        },
        St: {
          type: "structure",
          members: {
            OptionGroupName: {},
            OptionGroupDescription: {},
            EngineName: {},
            MajorEngineVersion: {},
            Options: {
              type: "list",
              member: {
                locationName: "Option",
                type: "structure",
                members: {
                  OptionName: {},
                  OptionDescription: {},
                  Persistent: {
                    type: "boolean"
                  },
                  Permanent: {
                    type: "boolean"
                  },
                  Port: {
                    type: "integer"
                  },
                  OptionSettings: {
                    type: "list",
                    member: {
                      shape: "Sx",
                      locationName: "OptionSetting"
                    }
                  },
                  DBSecurityGroupMemberships: {
                    shape: "Sy"
                  },
                  VpcSecurityGroupMemberships: {
                    shape: "S10"
                  }
                }
              }
            },
            AllowsVpcAndNonVpcInstanceMemberships: {
              type: "boolean"
            },
            VpcId: {}
          },
          wrapper: true
        },
        Sx: {
          type: "structure",
          members: {
            Name: {},
            Value: {},
            DefaultValue: {},
            Description: {},
            ApplyType: {},
            DataType: {},
            AllowedValues: {},
            IsModifiable: {
              type: "boolean"
            },
            IsCollection: {
              type: "boolean"
            }
          }
        },
        Sy: {
          type: "list",
          member: {
            locationName: "DBSecurityGroup",
            type: "structure",
            members: {
              DBSecurityGroupName: {},
              Status: {}
            }
          }
        },
        S10: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroupMembership",
            type: "structure",
            members: {
              VpcSecurityGroupId: {},
              Status: {}
            }
          }
        },
        S13: {
          type: "list",
          member: {
            locationName: "DBSecurityGroupName"
          }
        },
        S14: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroupId"
          }
        },
        S17: {
          type: "structure",
          members: {
            DBInstanceIdentifier: {},
            DBInstanceClass: {},
            Engine: {},
            DBInstanceStatus: {},
            MasterUsername: {},
            DBName: {},
            Endpoint: {
              type: "structure",
              members: {
                Address: {},
                Port: {
                  type: "integer"
                }
              }
            },
            AllocatedStorage: {
              type: "integer"
            },
            InstanceCreateTime: {
              type: "timestamp"
            },
            PreferredBackupWindow: {},
            BackupRetentionPeriod: {
              type: "integer"
            },
            DBSecurityGroups: {
              shape: "Sy"
            },
            VpcSecurityGroups: {
              shape: "S10"
            },
            DBParameterGroups: {
              type: "list",
              member: {
                locationName: "DBParameterGroup",
                type: "structure",
                members: {
                  DBParameterGroupName: {},
                  ParameterApplyStatus: {}
                }
              }
            },
            AvailabilityZone: {},
            DBSubnetGroup: {
              shape: "S1b"
            },
            PreferredMaintenanceWindow: {},
            PendingModifiedValues: {
              type: "structure",
              members: {
                DBInstanceClass: {},
                AllocatedStorage: {
                  type: "integer"
                },
                MasterUserPassword: {},
                Port: {
                  type: "integer"
                },
                BackupRetentionPeriod: {
                  type: "integer"
                },
                MultiAZ: {
                  type: "boolean"
                },
                EngineVersion: {},
                Iops: {
                  type: "integer"
                },
                DBInstanceIdentifier: {},
                StorageType: {}
              }
            },
            LatestRestorableTime: {
              type: "timestamp"
            },
            MultiAZ: {
              type: "boolean"
            },
            EngineVersion: {},
            AutoMinorVersionUpgrade: {
              type: "boolean"
            },
            ReadReplicaSourceDBInstanceIdentifier: {},
            ReadReplicaDBInstanceIdentifiers: {
              type: "list",
              member: {
                locationName: "ReadReplicaDBInstanceIdentifier"
              }
            },
            LicenseModel: {},
            Iops: {
              type: "integer"
            },
            OptionGroupMemberships: {
              type: "list",
              member: {
                locationName: "OptionGroupMembership",
                type: "structure",
                members: {
                  OptionGroupName: {},
                  Status: {}
                }
              }
            },
            CharacterSetName: {},
            SecondaryAvailabilityZone: {},
            PubliclyAccessible: {
              type: "boolean"
            },
            StatusInfos: {
              type: "list",
              member: {
                locationName: "DBInstanceStatusInfo",
                type: "structure",
                members: {
                  StatusType: {},
                  Normal: {
                    type: "boolean"
                  },
                  Status: {},
                  Message: {}
                }
              }
            },
            StorageType: {},
            TdeCredentialArn: {}
          },
          wrapper: true
        },
        S1b: {
          type: "structure",
          members: {
            DBSubnetGroupName: {},
            DBSubnetGroupDescription: {},
            VpcId: {},
            SubnetGroupStatus: {},
            Subnets: {
              type: "list",
              member: {
                locationName: "Subnet",
                type: "structure",
                members: {
                  SubnetIdentifier: {},
                  SubnetAvailabilityZone: {
                    shape: "S1e"
                  },
                  SubnetStatus: {}
                }
              }
            }
          },
          wrapper: true
        },
        S1e: {
          type: "structure",
          members: {
            Name: {}
          },
          wrapper: true
        },
        S1u: {
          type: "list",
          member: {
            locationName: "SubnetIdentifier"
          }
        },
        S2b: {
          type: "list",
          member: {
            locationName: "Filter",
            type: "structure",
            required: [
              "Name",
              "Values"
            ],
            members: {
              Name: {},
              Values: {
                type: "list",
                member: {
                  locationName: "Value"
                }
              }
            }
          }
        },
        S2h: {
          type: "structure",
          members: {
            CharacterSetName: {},
            CharacterSetDescription: {}
          }
        },
        S2w: {
          type: "list",
          member: {
            locationName: "Parameter",
            type: "structure",
            members: {
              ParameterName: {},
              ParameterValue: {},
              Description: {},
              Source: {},
              ApplyType: {},
              DataType: {},
              AllowedValues: {},
              IsModifiable: {
                type: "boolean"
              },
              MinimumEngineVersion: {},
              ApplyMethod: {}
            }
          }
        },
        S45: {
          type: "structure",
          members: {
            ReservedDBInstanceId: {},
            ReservedDBInstancesOfferingId: {},
            DBInstanceClass: {},
            StartTime: {
              type: "timestamp"
            },
            Duration: {
              type: "integer"
            },
            FixedPrice: {
              type: "double"
            },
            UsagePrice: {
              type: "double"
            },
            CurrencyCode: {},
            DBInstanceCount: {
              type: "integer"
            },
            ProductDescription: {},
            OfferingType: {},
            MultiAZ: {
              type: "boolean"
            },
            State: {},
            RecurringCharges: {
              shape: "S47"
            }
          },
          wrapper: true
        },
        S47: {
          type: "list",
          member: {
            locationName: "RecurringCharge",
            type: "structure",
            members: {
              RecurringChargeAmount: {
                type: "double"
              },
              RecurringChargeFrequency: {}
            },
            wrapper: true
          }
        },
        S4k: {
          type: "structure",
          members: {
            DBParameterGroupName: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/rds-2014-09-01.paginators.json
var require_rds_2014_09_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/rds-2014-09-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/apis/rds-2014-10-31.min.json
var require_rds_2014_10_31_min = __commonJS({
  "node_modules/aws-sdk/apis/rds-2014-10-31.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-10-31",
        endpointPrefix: "rds",
        protocol: "query",
        serviceAbbreviation: "Amazon RDS",
        serviceFullName: "Amazon Relational Database Service",
        serviceId: "RDS",
        signatureVersion: "v4",
        uid: "rds-2014-10-31",
        xmlNamespace: "http://rds.amazonaws.com/doc/2014-10-31/"
      },
      operations: {
        AddRoleToDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "RoleArn"
            ],
            members: {
              DBClusterIdentifier: {},
              RoleArn: {},
              FeatureName: {}
            }
          }
        },
        AddRoleToDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "RoleArn",
              "FeatureName"
            ],
            members: {
              DBInstanceIdentifier: {},
              RoleArn: {},
              FeatureName: {}
            }
          }
        },
        AddSourceIdentifierToSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SourceIdentifier"
            ],
            members: {
              SubscriptionName: {},
              SourceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "AddSourceIdentifierToSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S6"
              }
            }
          }
        },
        AddTagsToResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "Tags"
            ],
            members: {
              ResourceName: {},
              Tags: {
                shape: "Sb"
              }
            }
          }
        },
        ApplyPendingMaintenanceAction: {
          input: {
            type: "structure",
            required: [
              "ResourceIdentifier",
              "ApplyAction",
              "OptInType"
            ],
            members: {
              ResourceIdentifier: {},
              ApplyAction: {},
              OptInType: {}
            }
          },
          output: {
            resultWrapper: "ApplyPendingMaintenanceActionResult",
            type: "structure",
            members: {
              ResourcePendingMaintenanceActions: {
                shape: "Sf"
              }
            }
          }
        },
        AuthorizeDBSecurityGroupIngress: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName"
            ],
            members: {
              DBSecurityGroupName: {},
              CIDRIP: {},
              EC2SecurityGroupName: {},
              EC2SecurityGroupId: {},
              EC2SecurityGroupOwnerId: {}
            }
          },
          output: {
            resultWrapper: "AuthorizeDBSecurityGroupIngressResult",
            type: "structure",
            members: {
              DBSecurityGroup: {
                shape: "Sl"
              }
            }
          }
        },
        BacktrackDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "BacktrackTo"
            ],
            members: {
              DBClusterIdentifier: {},
              BacktrackTo: {
                type: "timestamp"
              },
              Force: {
                type: "boolean"
              },
              UseEarliestTimeOnPointInTimeUnavailable: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "Ss",
            resultWrapper: "BacktrackDBClusterResult"
          }
        },
        CancelExportTask: {
          input: {
            type: "structure",
            required: [
              "ExportTaskIdentifier"
            ],
            members: {
              ExportTaskIdentifier: {}
            }
          },
          output: {
            shape: "Su",
            resultWrapper: "CancelExportTaskResult"
          }
        },
        CopyDBClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "SourceDBClusterParameterGroupIdentifier",
              "TargetDBClusterParameterGroupIdentifier",
              "TargetDBClusterParameterGroupDescription"
            ],
            members: {
              SourceDBClusterParameterGroupIdentifier: {},
              TargetDBClusterParameterGroupIdentifier: {},
              TargetDBClusterParameterGroupDescription: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "CopyDBClusterParameterGroupResult",
            type: "structure",
            members: {
              DBClusterParameterGroup: {
                shape: "S10"
              }
            }
          }
        },
        CopyDBClusterSnapshot: {
          input: {
            type: "structure",
            required: [
              "SourceDBClusterSnapshotIdentifier",
              "TargetDBClusterSnapshotIdentifier"
            ],
            members: {
              SourceDBClusterSnapshotIdentifier: {},
              TargetDBClusterSnapshotIdentifier: {},
              KmsKeyId: {},
              PreSignedUrl: {},
              CopyTags: {
                type: "boolean"
              },
              Tags: {
                shape: "Sb"
              },
              SourceRegion: {}
            }
          },
          output: {
            resultWrapper: "CopyDBClusterSnapshotResult",
            type: "structure",
            members: {
              DBClusterSnapshot: {
                shape: "S13"
              }
            }
          }
        },
        CopyDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "SourceDBParameterGroupIdentifier",
              "TargetDBParameterGroupIdentifier",
              "TargetDBParameterGroupDescription"
            ],
            members: {
              SourceDBParameterGroupIdentifier: {},
              TargetDBParameterGroupIdentifier: {},
              TargetDBParameterGroupDescription: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "CopyDBParameterGroupResult",
            type: "structure",
            members: {
              DBParameterGroup: {
                shape: "S17"
              }
            }
          }
        },
        CopyDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "SourceDBSnapshotIdentifier",
              "TargetDBSnapshotIdentifier"
            ],
            members: {
              SourceDBSnapshotIdentifier: {},
              TargetDBSnapshotIdentifier: {},
              KmsKeyId: {},
              Tags: {
                shape: "Sb"
              },
              CopyTags: {
                type: "boolean"
              },
              PreSignedUrl: {},
              OptionGroupName: {},
              TargetCustomAvailabilityZone: {},
              CopyOptionGroup: {
                type: "boolean"
              },
              SourceRegion: {}
            }
          },
          output: {
            resultWrapper: "CopyDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "S1a"
              }
            }
          }
        },
        CopyOptionGroup: {
          input: {
            type: "structure",
            required: [
              "SourceOptionGroupIdentifier",
              "TargetOptionGroupIdentifier",
              "TargetOptionGroupDescription"
            ],
            members: {
              SourceOptionGroupIdentifier: {},
              TargetOptionGroupIdentifier: {},
              TargetOptionGroupDescription: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "CopyOptionGroupResult",
            type: "structure",
            members: {
              OptionGroup: {
                shape: "S1g"
              }
            }
          }
        },
        CreateBlueGreenDeployment: {
          input: {
            type: "structure",
            required: [
              "BlueGreenDeploymentName",
              "Source"
            ],
            members: {
              BlueGreenDeploymentName: {},
              Source: {},
              TargetEngineVersion: {},
              TargetDBParameterGroupName: {},
              TargetDBClusterParameterGroupName: {},
              Tags: {
                shape: "Sb"
              },
              TargetDBInstanceClass: {},
              UpgradeTargetStorageConfig: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CreateBlueGreenDeploymentResult",
            type: "structure",
            members: {
              BlueGreenDeployment: {
                shape: "S1x"
              }
            }
          }
        },
        CreateCustomDBEngineVersion: {
          input: {
            type: "structure",
            required: [
              "Engine",
              "EngineVersion"
            ],
            members: {
              Engine: {},
              EngineVersion: {},
              DatabaseInstallationFilesS3BucketName: {},
              DatabaseInstallationFilesS3Prefix: {},
              ImageId: {},
              KMSKeyId: {},
              Description: {},
              Manifest: {},
              Tags: {
                shape: "Sb"
              },
              SourceCustomDbEngineVersionIdentifier: {},
              UseAwsProvidedLatestImage: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S2g",
            resultWrapper: "CreateCustomDBEngineVersionResult"
          }
        },
        CreateDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "Engine"
            ],
            members: {
              AvailabilityZones: {
                shape: "S14"
              },
              BackupRetentionPeriod: {
                type: "integer"
              },
              CharacterSetName: {},
              DatabaseName: {},
              DBClusterIdentifier: {},
              DBClusterParameterGroupName: {},
              VpcSecurityGroupIds: {
                shape: "S2t"
              },
              DBSubnetGroupName: {},
              Engine: {},
              EngineVersion: {},
              Port: {
                type: "integer"
              },
              MasterUsername: {},
              MasterUserPassword: {},
              OptionGroupName: {},
              PreferredBackupWindow: {},
              PreferredMaintenanceWindow: {},
              ReplicationSourceIdentifier: {},
              Tags: {
                shape: "Sb"
              },
              StorageEncrypted: {
                type: "boolean"
              },
              KmsKeyId: {},
              PreSignedUrl: {},
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              BacktrackWindow: {
                type: "long"
              },
              EnableCloudwatchLogsExports: {
                shape: "S2p"
              },
              EngineMode: {},
              ScalingConfiguration: {
                shape: "S2v"
              },
              RdsCustomClusterConfiguration: {
                shape: "S2w"
              },
              DeletionProtection: {
                type: "boolean"
              },
              GlobalClusterIdentifier: {},
              EnableHttpEndpoint: {
                type: "boolean"
              },
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              Domain: {},
              DomainIAMRoleName: {},
              EnableGlobalWriteForwarding: {
                type: "boolean"
              },
              DBClusterInstanceClass: {},
              AllocatedStorage: {
                type: "integer"
              },
              StorageType: {},
              Iops: {
                type: "integer"
              },
              PubliclyAccessible: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              MonitoringInterval: {
                type: "integer"
              },
              MonitoringRoleArn: {},
              EnablePerformanceInsights: {
                type: "boolean"
              },
              PerformanceInsightsKMSKeyId: {},
              PerformanceInsightsRetentionPeriod: {
                type: "integer"
              },
              ServerlessV2ScalingConfiguration: {
                shape: "S2y"
              },
              NetworkType: {},
              DBSystemId: {},
              ManageMasterUserPassword: {
                type: "boolean"
              },
              MasterUserSecretKmsKeyId: {},
              EnableLocalWriteForwarding: {
                type: "boolean"
              },
              SourceRegion: {}
            }
          },
          output: {
            resultWrapper: "CreateDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "S31"
              }
            }
          }
        },
        CreateDBClusterEndpoint: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "DBClusterEndpointIdentifier",
              "EndpointType"
            ],
            members: {
              DBClusterIdentifier: {},
              DBClusterEndpointIdentifier: {},
              EndpointType: {},
              StaticMembers: {
                shape: "Sv"
              },
              ExcludedMembers: {
                shape: "Sv"
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            shape: "S3n",
            resultWrapper: "CreateDBClusterEndpointResult"
          }
        },
        CreateDBClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBClusterParameterGroupName",
              "DBParameterGroupFamily",
              "Description"
            ],
            members: {
              DBClusterParameterGroupName: {},
              DBParameterGroupFamily: {},
              Description: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBClusterParameterGroupResult",
            type: "structure",
            members: {
              DBClusterParameterGroup: {
                shape: "S10"
              }
            }
          }
        },
        CreateDBClusterSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBClusterSnapshotIdentifier",
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterSnapshotIdentifier: {},
              DBClusterIdentifier: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBClusterSnapshotResult",
            type: "structure",
            members: {
              DBClusterSnapshot: {
                shape: "S13"
              }
            }
          }
        },
        CreateDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "DBInstanceClass",
              "Engine"
            ],
            members: {
              DBName: {},
              DBInstanceIdentifier: {},
              AllocatedStorage: {
                type: "integer"
              },
              DBInstanceClass: {},
              Engine: {},
              MasterUsername: {},
              MasterUserPassword: {},
              DBSecurityGroups: {
                shape: "S3t"
              },
              VpcSecurityGroupIds: {
                shape: "S2t"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              PreferredMaintenanceWindow: {},
              DBParameterGroupName: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {},
              Port: {
                type: "integer"
              },
              MultiAZ: {
                type: "boolean"
              },
              EngineVersion: {},
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              CharacterSetName: {},
              NcharCharacterSetName: {},
              PubliclyAccessible: {
                type: "boolean"
              },
              Tags: {
                shape: "Sb"
              },
              DBClusterIdentifier: {},
              StorageType: {},
              TdeCredentialArn: {},
              TdeCredentialPassword: {},
              StorageEncrypted: {
                type: "boolean"
              },
              KmsKeyId: {},
              Domain: {},
              DomainFqdn: {},
              DomainOu: {},
              DomainAuthSecretArn: {},
              DomainDnsIps: {
                shape: "Sv"
              },
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              MonitoringInterval: {
                type: "integer"
              },
              MonitoringRoleArn: {},
              DomainIAMRoleName: {},
              PromotionTier: {
                type: "integer"
              },
              Timezone: {},
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              EnablePerformanceInsights: {
                type: "boolean"
              },
              PerformanceInsightsKMSKeyId: {},
              PerformanceInsightsRetentionPeriod: {
                type: "integer"
              },
              EnableCloudwatchLogsExports: {
                shape: "S2p"
              },
              ProcessorFeatures: {
                shape: "S1c"
              },
              DeletionProtection: {
                type: "boolean"
              },
              MaxAllocatedStorage: {
                type: "integer"
              },
              EnableCustomerOwnedIp: {
                type: "boolean"
              },
              CustomIamInstanceProfile: {},
              BackupTarget: {},
              NetworkType: {},
              StorageThroughput: {
                type: "integer"
              },
              ManageMasterUserPassword: {
                type: "boolean"
              },
              MasterUserSecretKmsKeyId: {},
              CACertificateIdentifier: {},
              DBSystemId: {},
              DedicatedLogVolume: {
                type: "boolean"
              },
              MultiTenant: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S3v"
              }
            }
          }
        },
        CreateDBInstanceReadReplica: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              SourceDBInstanceIdentifier: {},
              DBInstanceClass: {},
              AvailabilityZone: {},
              Port: {
                type: "integer"
              },
              MultiAZ: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              DBParameterGroupName: {},
              PubliclyAccessible: {
                type: "boolean"
              },
              Tags: {
                shape: "Sb"
              },
              DBSubnetGroupName: {},
              VpcSecurityGroupIds: {
                shape: "S2t"
              },
              StorageType: {},
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              MonitoringInterval: {
                type: "integer"
              },
              MonitoringRoleArn: {},
              KmsKeyId: {},
              PreSignedUrl: {},
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              EnablePerformanceInsights: {
                type: "boolean"
              },
              PerformanceInsightsKMSKeyId: {},
              PerformanceInsightsRetentionPeriod: {
                type: "integer"
              },
              EnableCloudwatchLogsExports: {
                shape: "S2p"
              },
              ProcessorFeatures: {
                shape: "S1c"
              },
              UseDefaultProcessorFeatures: {
                type: "boolean"
              },
              DeletionProtection: {
                type: "boolean"
              },
              Domain: {},
              DomainIAMRoleName: {},
              DomainFqdn: {},
              DomainOu: {},
              DomainAuthSecretArn: {},
              DomainDnsIps: {
                shape: "Sv"
              },
              ReplicaMode: {},
              MaxAllocatedStorage: {
                type: "integer"
              },
              CustomIamInstanceProfile: {},
              NetworkType: {},
              StorageThroughput: {
                type: "integer"
              },
              EnableCustomerOwnedIp: {
                type: "boolean"
              },
              AllocatedStorage: {
                type: "integer"
              },
              SourceDBClusterIdentifier: {},
              DedicatedLogVolume: {
                type: "boolean"
              },
              UpgradeStorageConfig: {
                type: "boolean"
              },
              SourceRegion: {}
            }
          },
          output: {
            resultWrapper: "CreateDBInstanceReadReplicaResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S3v"
              }
            }
          }
        },
        CreateDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName",
              "DBParameterGroupFamily",
              "Description"
            ],
            members: {
              DBParameterGroupName: {},
              DBParameterGroupFamily: {},
              Description: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBParameterGroupResult",
            type: "structure",
            members: {
              DBParameterGroup: {
                shape: "S17"
              }
            }
          }
        },
        CreateDBProxy: {
          input: {
            type: "structure",
            required: [
              "DBProxyName",
              "EngineFamily",
              "Auth",
              "RoleArn",
              "VpcSubnetIds"
            ],
            members: {
              DBProxyName: {},
              EngineFamily: {},
              Auth: {
                shape: "S4o"
              },
              RoleArn: {},
              VpcSubnetIds: {
                shape: "Sv"
              },
              VpcSecurityGroupIds: {
                shape: "Sv"
              },
              RequireTLS: {
                type: "boolean"
              },
              IdleClientTimeout: {
                type: "integer"
              },
              DebugLogging: {
                type: "boolean"
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBProxyResult",
            type: "structure",
            members: {
              DBProxy: {
                shape: "S4u"
              }
            }
          }
        },
        CreateDBProxyEndpoint: {
          input: {
            type: "structure",
            required: [
              "DBProxyName",
              "DBProxyEndpointName",
              "VpcSubnetIds"
            ],
            members: {
              DBProxyName: {},
              DBProxyEndpointName: {},
              VpcSubnetIds: {
                shape: "Sv"
              },
              VpcSecurityGroupIds: {
                shape: "Sv"
              },
              TargetRole: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBProxyEndpointResult",
            type: "structure",
            members: {
              DBProxyEndpoint: {
                shape: "S53"
              }
            }
          }
        },
        CreateDBSecurityGroup: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName",
              "DBSecurityGroupDescription"
            ],
            members: {
              DBSecurityGroupName: {},
              DBSecurityGroupDescription: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBSecurityGroupResult",
            type: "structure",
            members: {
              DBSecurityGroup: {
                shape: "Sl"
              }
            }
          }
        },
        CreateDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBSnapshotIdentifier",
              "DBInstanceIdentifier"
            ],
            members: {
              DBSnapshotIdentifier: {},
              DBInstanceIdentifier: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "S1a"
              }
            }
          }
        },
        CreateDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName",
              "DBSubnetGroupDescription",
              "SubnetIds"
            ],
            members: {
              DBSubnetGroupName: {},
              DBSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S5a"
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBSubnetGroupResult",
            type: "structure",
            members: {
              DBSubnetGroup: {
                shape: "S3z"
              }
            }
          }
        },
        CreateEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SnsTopicArn"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S8"
              },
              SourceIds: {
                shape: "S7"
              },
              Enabled: {
                type: "boolean"
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "CreateEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S6"
              }
            }
          }
        },
        CreateGlobalCluster: {
          input: {
            type: "structure",
            members: {
              GlobalClusterIdentifier: {},
              SourceDBClusterIdentifier: {},
              Engine: {},
              EngineVersion: {},
              DeletionProtection: {
                type: "boolean"
              },
              DatabaseName: {},
              StorageEncrypted: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CreateGlobalClusterResult",
            type: "structure",
            members: {
              GlobalCluster: {
                shape: "S5g"
              }
            }
          }
        },
        CreateIntegration: {
          input: {
            type: "structure",
            required: [
              "SourceArn",
              "TargetArn",
              "IntegrationName"
            ],
            members: {
              SourceArn: {},
              TargetArn: {},
              IntegrationName: {},
              KMSKeyId: {},
              AdditionalEncryptionContext: {
                shape: "S5r"
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            shape: "S5s",
            resultWrapper: "CreateIntegrationResult"
          }
        },
        CreateOptionGroup: {
          input: {
            type: "structure",
            required: [
              "OptionGroupName",
              "EngineName",
              "MajorEngineVersion",
              "OptionGroupDescription"
            ],
            members: {
              OptionGroupName: {},
              EngineName: {},
              MajorEngineVersion: {},
              OptionGroupDescription: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "CreateOptionGroupResult",
            type: "structure",
            members: {
              OptionGroup: {
                shape: "S1g"
              }
            }
          }
        },
        CreateTenantDatabase: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "TenantDBName",
              "MasterUsername",
              "MasterUserPassword"
            ],
            members: {
              DBInstanceIdentifier: {},
              TenantDBName: {},
              MasterUsername: {},
              MasterUserPassword: {
                shape: "S60"
              },
              CharacterSetName: {},
              NcharCharacterSetName: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "CreateTenantDatabaseResult",
            type: "structure",
            members: {
              TenantDatabase: {
                shape: "S62"
              }
            }
          }
        },
        DeleteBlueGreenDeployment: {
          input: {
            type: "structure",
            required: [
              "BlueGreenDeploymentIdentifier"
            ],
            members: {
              BlueGreenDeploymentIdentifier: {},
              DeleteTarget: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DeleteBlueGreenDeploymentResult",
            type: "structure",
            members: {
              BlueGreenDeployment: {
                shape: "S1x"
              }
            }
          }
        },
        DeleteCustomDBEngineVersion: {
          input: {
            type: "structure",
            required: [
              "Engine",
              "EngineVersion"
            ],
            members: {
              Engine: {},
              EngineVersion: {}
            }
          },
          output: {
            shape: "S2g",
            resultWrapper: "DeleteCustomDBEngineVersionResult"
          }
        },
        DeleteDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {},
              SkipFinalSnapshot: {
                type: "boolean"
              },
              FinalDBSnapshotIdentifier: {},
              DeleteAutomatedBackups: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DeleteDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "S31"
              }
            }
          }
        },
        DeleteDBClusterAutomatedBackup: {
          input: {
            type: "structure",
            required: [
              "DbClusterResourceId"
            ],
            members: {
              DbClusterResourceId: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBClusterAutomatedBackupResult",
            type: "structure",
            members: {
              DBClusterAutomatedBackup: {
                shape: "S6b"
              }
            }
          }
        },
        DeleteDBClusterEndpoint: {
          input: {
            type: "structure",
            required: [
              "DBClusterEndpointIdentifier"
            ],
            members: {
              DBClusterEndpointIdentifier: {}
            }
          },
          output: {
            shape: "S3n",
            resultWrapper: "DeleteDBClusterEndpointResult"
          }
        },
        DeleteDBClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBClusterParameterGroupName"
            ],
            members: {
              DBClusterParameterGroupName: {}
            }
          }
        },
        DeleteDBClusterSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBClusterSnapshotIdentifier"
            ],
            members: {
              DBClusterSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBClusterSnapshotResult",
            type: "structure",
            members: {
              DBClusterSnapshot: {
                shape: "S13"
              }
            }
          }
        },
        DeleteDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              SkipFinalSnapshot: {
                type: "boolean"
              },
              FinalDBSnapshotIdentifier: {},
              DeleteAutomatedBackups: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DeleteDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S3v"
              }
            }
          }
        },
        DeleteDBInstanceAutomatedBackup: {
          input: {
            type: "structure",
            members: {
              DbiResourceId: {},
              DBInstanceAutomatedBackupsArn: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBInstanceAutomatedBackupResult",
            type: "structure",
            members: {
              DBInstanceAutomatedBackup: {
                shape: "S6l"
              }
            }
          }
        },
        DeleteDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {}
            }
          }
        },
        DeleteDBProxy: {
          input: {
            type: "structure",
            required: [
              "DBProxyName"
            ],
            members: {
              DBProxyName: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBProxyResult",
            type: "structure",
            members: {
              DBProxy: {
                shape: "S4u"
              }
            }
          }
        },
        DeleteDBProxyEndpoint: {
          input: {
            type: "structure",
            required: [
              "DBProxyEndpointName"
            ],
            members: {
              DBProxyEndpointName: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBProxyEndpointResult",
            type: "structure",
            members: {
              DBProxyEndpoint: {
                shape: "S53"
              }
            }
          }
        },
        DeleteDBSecurityGroup: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName"
            ],
            members: {
              DBSecurityGroupName: {}
            }
          }
        },
        DeleteDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBSnapshotIdentifier"
            ],
            members: {
              DBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "S1a"
              }
            }
          }
        },
        DeleteDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName"
            ],
            members: {
              DBSubnetGroupName: {}
            }
          }
        },
        DeleteEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {}
            }
          },
          output: {
            resultWrapper: "DeleteEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S6"
              }
            }
          }
        },
        DeleteGlobalCluster: {
          input: {
            type: "structure",
            required: [
              "GlobalClusterIdentifier"
            ],
            members: {
              GlobalClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteGlobalClusterResult",
            type: "structure",
            members: {
              GlobalCluster: {
                shape: "S5g"
              }
            }
          }
        },
        DeleteIntegration: {
          input: {
            type: "structure",
            required: [
              "IntegrationIdentifier"
            ],
            members: {
              IntegrationIdentifier: {}
            }
          },
          output: {
            shape: "S5s",
            resultWrapper: "DeleteIntegrationResult"
          }
        },
        DeleteOptionGroup: {
          input: {
            type: "structure",
            required: [
              "OptionGroupName"
            ],
            members: {
              OptionGroupName: {}
            }
          }
        },
        DeleteTenantDatabase: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "TenantDBName"
            ],
            members: {
              DBInstanceIdentifier: {},
              TenantDBName: {},
              SkipFinalSnapshot: {
                type: "boolean"
              },
              FinalDBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteTenantDatabaseResult",
            type: "structure",
            members: {
              TenantDatabase: {
                shape: "S62"
              }
            }
          }
        },
        DeregisterDBProxyTargets: {
          input: {
            type: "structure",
            required: [
              "DBProxyName"
            ],
            members: {
              DBProxyName: {},
              TargetGroupName: {},
              DBInstanceIdentifiers: {
                shape: "Sv"
              },
              DBClusterIdentifiers: {
                shape: "Sv"
              }
            }
          },
          output: {
            resultWrapper: "DeregisterDBProxyTargetsResult",
            type: "structure",
            members: {}
          }
        },
        DescribeAccountAttributes: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            resultWrapper: "DescribeAccountAttributesResult",
            type: "structure",
            members: {
              AccountQuotas: {
                type: "list",
                member: {
                  locationName: "AccountQuota",
                  type: "structure",
                  members: {
                    AccountQuotaName: {},
                    Used: {
                      type: "long"
                    },
                    Max: {
                      type: "long"
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        DescribeBlueGreenDeployments: {
          input: {
            type: "structure",
            members: {
              BlueGreenDeploymentIdentifier: {},
              Filters: {
                shape: "S7c"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeBlueGreenDeploymentsResult",
            type: "structure",
            members: {
              BlueGreenDeployments: {
                type: "list",
                member: {
                  shape: "S1x"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeCertificates: {
          input: {
            type: "structure",
            members: {
              CertificateIdentifier: {},
              Filters: {
                shape: "S7c"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeCertificatesResult",
            type: "structure",
            members: {
              DefaultCertificateForNewLaunches: {},
              Certificates: {
                type: "list",
                member: {
                  shape: "S7l",
                  locationName: "Certificate"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeDBClusterAutomatedBackups: {
          input: {
            type: "structure",
            members: {
              DbClusterResourceId: {},
              DBClusterIdentifier: {},
              Filters: {
                shape: "S7c"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBClusterAutomatedBackupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBClusterAutomatedBackups: {
                type: "list",
                member: {
                  shape: "S6b",
                  locationName: "DBClusterAutomatedBackup"
                }
              }
            }
          }
        },
        DescribeDBClusterBacktracks: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {},
              BacktrackIdentifier: {},
              Filters: {
                shape: "S7c"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBClusterBacktracksResult",
            type: "structure",
            members: {
              Marker: {},
              DBClusterBacktracks: {
                type: "list",
                member: {
                  shape: "Ss",
                  locationName: "DBClusterBacktrack"
                }
              }
            }
          }
        },
        DescribeDBClusterEndpoints: {
          input: {
            type: "structure",
            members: {
              DBClusterIdentifier: {},
              DBClusterEndpointIdentifier: {},
              Filters: {
                shape: "S7c"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBClusterEndpointsResult",
            type: "structure",
            members: {
              Marker: {},
              DBClusterEndpoints: {
                type: "list",
                member: {
                  shape: "S3n",
                  locationName: "DBClusterEndpointList"
                }
              }
            }
          }
        },
        DescribeDBClusterParameterGroups: {
          input: {
            type: "structure",
            members: {
              DBClusterParameterGroupName: {},
              Filters: {
                shape: "S7c"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBClusterParameterGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBClusterParameterGroups: {
                type: "list",
                member: {
                  shape: "S10",
                  locationName: "DBClusterParameterGroup"
                }
              }
            }
          }
        },
        DescribeDBClusterParameters: {
          input: {
            type: "structure",
            required: [
              "DBClusterParameterGroupName"
            ],
            members: {
              DBClusterParameterGroupName: {},
              Source: {},
              Filters: {
                shape: "S7c"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBClusterParametersResult",
            type: "structure",
            members: {
              Parameters: {
                shape: "S80"
              },
              Marker: {}
            }
          }
        },
        DescribeDBClusterSnapshotAttributes: {
          input: {
            type: "structure",
            required: [
              "DBClusterSnapshotIdentifier"
            ],
            members: {
              DBClusterSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBClusterSnapshotAttributesResult",
            type: "structure",
            members: {
              DBClusterSnapshotAttributesResult: {
                shape: "S85"
              }
            }
          }
        },
        DescribeDBClusterSnapshots: {
          input: {
            type: "structure",
            members: {
              DBClusterIdentifier: {},
              DBClusterSnapshotIdentifier: {},
              SnapshotType: {},
              Filters: {
                shape: "S7c"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              IncludeShared: {
                type: "boolean"
              },
              IncludePublic: {
                type: "boolean"
              },
              DbClusterResourceId: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBClusterSnapshotsResult",
            type: "structure",
            members: {
              Marker: {},
              DBClusterSnapshots: {
                type: "list",
                member: {
                  shape: "S13",
                  locationName: "DBClusterSnapshot"
                }
              }
            }
          }
        },
        DescribeDBClusters: {
          input: {
            type: "structure",
            members: {
              DBClusterIdentifier: {},
              Filters: {
                shape: "S7c"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              IncludeShared: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeDBClustersResult",
            type: "structure",
            members: {
              Marker: {},
              DBClusters: {
                type: "list",
                member: {
                  shape: "S31",
                  locationName: "DBCluster"
                }
              }
            }
          }
        },
        DescribeDBEngineVersions: {
          input: {
            type: "structure",
            members: {
              Engine: {},
              EngineVersion: {},
              DBParameterGroupFamily: {},
              Filters: {
                shape: "S7c"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              DefaultOnly: {
                type: "boolean"
              },
              ListSupportedCharacterSets: {
                type: "boolean"
              },
              ListSupportedTimezones: {
                type: "boolean"
              },
              IncludeAll: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeDBEngineVersionsResult",
            type: "structure",
            members: {
              Marker: {},
              DBEngineVersions: {
                type: "list",
                member: {
                  shape: "S2g",
                  locationName: "DBEngineVersion"
                }
              }
            }
          }
        },
        DescribeDBInstanceAutomatedBackups: {
          input: {
            type: "structure",
            members: {
              DbiResourceId: {},
              DBInstanceIdentifier: {},
              Filters: {
                shape: "S7c"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              DBInstanceAutomatedBackupsArn: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBInstanceAutomatedBackupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBInstanceAutomatedBackups: {
                type: "list",
                member: {
                  shape: "S6l",
                  locationName: "DBInstanceAutomatedBackup"
                }
              }
            }
          }
        },
        DescribeDBInstances: {
          input: {
            type: "structure",
            members: {
              DBInstanceIdentifier: {},
              Filters: {
                shape: "S7c"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBInstancesResult",
            type: "structure",
            members: {
              Marker: {},
              DBInstances: {
                type: "list",
                member: {
                  shape: "S3v",
                  locationName: "DBInstance"
                }
              }
            }
          }
        },
        DescribeDBLogFiles: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              FilenameContains: {},
              FileLastWritten: {
                type: "long"
              },
              FileSize: {
                type: "long"
              },
              Filters: {
                shape: "S7c"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBLogFilesResult",
            type: "structure",
            members: {
              DescribeDBLogFiles: {
                type: "list",
                member: {
                  locationName: "DescribeDBLogFilesDetails",
                  type: "structure",
                  members: {
                    LogFileName: {},
                    LastWritten: {
                      type: "long"
                    },
                    Size: {
                      type: "long"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeDBParameterGroups: {
          input: {
            type: "structure",
            members: {
              DBParameterGroupName: {},
              Filters: {
                shape: "S7c"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBParameterGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBParameterGroups: {
                type: "list",
                member: {
                  shape: "S17",
                  locationName: "DBParameterGroup"
                }
              }
            }
          }
        },
        DescribeDBParameters: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {},
              Source: {},
              Filters: {
                shape: "S7c"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBParametersResult",
            type: "structure",
            members: {
              Parameters: {
                shape: "S80"
              },
              Marker: {}
            }
          }
        },
        DescribeDBProxies: {
          input: {
            type: "structure",
            members: {
              DBProxyName: {},
              Filters: {
                shape: "S7c"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeDBProxiesResult",
            type: "structure",
            members: {
              DBProxies: {
                type: "list",
                member: {
                  shape: "S4u"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeDBProxyEndpoints: {
          input: {
            type: "structure",
            members: {
              DBProxyName: {},
              DBProxyEndpointName: {},
              Filters: {
                shape: "S7c"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeDBProxyEndpointsResult",
            type: "structure",
            members: {
              DBProxyEndpoints: {
                type: "list",
                member: {
                  shape: "S53"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeDBProxyTargetGroups: {
          input: {
            type: "structure",
            required: [
              "DBProxyName"
            ],
            members: {
              DBProxyName: {},
              TargetGroupName: {},
              Filters: {
                shape: "S7c"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeDBProxyTargetGroupsResult",
            type: "structure",
            members: {
              TargetGroups: {
                type: "list",
                member: {
                  shape: "S96"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeDBProxyTargets: {
          input: {
            type: "structure",
            required: [
              "DBProxyName"
            ],
            members: {
              DBProxyName: {},
              TargetGroupName: {},
              Filters: {
                shape: "S7c"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeDBProxyTargetsResult",
            type: "structure",
            members: {
              Targets: {
                shape: "S9a"
              },
              Marker: {}
            }
          }
        },
        DescribeDBRecommendations: {
          input: {
            type: "structure",
            members: {
              LastUpdatedAfter: {
                type: "timestamp"
              },
              LastUpdatedBefore: {
                type: "timestamp"
              },
              Locale: {},
              Filters: {
                shape: "S7c"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBRecommendationsResult",
            type: "structure",
            members: {
              DBRecommendations: {
                type: "list",
                member: {
                  shape: "S9k"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeDBSecurityGroups: {
          input: {
            type: "structure",
            members: {
              DBSecurityGroupName: {},
              Filters: {
                shape: "S7c"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSecurityGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSecurityGroups: {
                type: "list",
                member: {
                  shape: "Sl",
                  locationName: "DBSecurityGroup"
                }
              }
            }
          }
        },
        DescribeDBSnapshotAttributes: {
          input: {
            type: "structure",
            required: [
              "DBSnapshotIdentifier"
            ],
            members: {
              DBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSnapshotAttributesResult",
            type: "structure",
            members: {
              DBSnapshotAttributesResult: {
                shape: "Saa"
              }
            }
          }
        },
        DescribeDBSnapshotTenantDatabases: {
          input: {
            type: "structure",
            members: {
              DBInstanceIdentifier: {},
              DBSnapshotIdentifier: {},
              SnapshotType: {},
              Filters: {
                shape: "S7c"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              DbiResourceId: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSnapshotTenantDatabasesResult",
            type: "structure",
            members: {
              Marker: {},
              DBSnapshotTenantDatabases: {
                type: "list",
                member: {
                  locationName: "DBSnapshotTenantDatabase",
                  type: "structure",
                  members: {
                    DBSnapshotIdentifier: {},
                    DBInstanceIdentifier: {},
                    DbiResourceId: {},
                    EngineName: {},
                    SnapshotType: {},
                    TenantDatabaseCreateTime: {
                      type: "timestamp"
                    },
                    TenantDBName: {},
                    MasterUsername: {},
                    TenantDatabaseResourceId: {},
                    CharacterSetName: {},
                    DBSnapshotTenantDatabaseARN: {},
                    NcharCharacterSetName: {},
                    TagList: {
                      shape: "Sb"
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        DescribeDBSnapshots: {
          input: {
            type: "structure",
            members: {
              DBInstanceIdentifier: {},
              DBSnapshotIdentifier: {},
              SnapshotType: {},
              Filters: {
                shape: "S7c"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              IncludeShared: {
                type: "boolean"
              },
              IncludePublic: {
                type: "boolean"
              },
              DbiResourceId: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSnapshotsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSnapshots: {
                type: "list",
                member: {
                  shape: "S1a",
                  locationName: "DBSnapshot"
                }
              }
            }
          }
        },
        DescribeDBSubnetGroups: {
          input: {
            type: "structure",
            members: {
              DBSubnetGroupName: {},
              Filters: {
                shape: "S7c"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSubnetGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSubnetGroups: {
                type: "list",
                member: {
                  shape: "S3z",
                  locationName: "DBSubnetGroup"
                }
              }
            }
          }
        },
        DescribeEngineDefaultClusterParameters: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupFamily"
            ],
            members: {
              DBParameterGroupFamily: {},
              Filters: {
                shape: "S7c"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEngineDefaultClusterParametersResult",
            type: "structure",
            members: {
              EngineDefaults: {
                shape: "Sap"
              }
            }
          }
        },
        DescribeEngineDefaultParameters: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupFamily"
            ],
            members: {
              DBParameterGroupFamily: {},
              Filters: {
                shape: "S7c"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEngineDefaultParametersResult",
            type: "structure",
            members: {
              EngineDefaults: {
                shape: "Sap"
              }
            }
          }
        },
        DescribeEventCategories: {
          input: {
            type: "structure",
            members: {
              SourceType: {},
              Filters: {
                shape: "S7c"
              }
            }
          },
          output: {
            resultWrapper: "DescribeEventCategoriesResult",
            type: "structure",
            members: {
              EventCategoriesMapList: {
                type: "list",
                member: {
                  locationName: "EventCategoriesMap",
                  type: "structure",
                  members: {
                    SourceType: {},
                    EventCategories: {
                      shape: "S8"
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        DescribeEventSubscriptions: {
          input: {
            type: "structure",
            members: {
              SubscriptionName: {},
              Filters: {
                shape: "S7c"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventSubscriptionsResult",
            type: "structure",
            members: {
              Marker: {},
              EventSubscriptionsList: {
                type: "list",
                member: {
                  shape: "S6",
                  locationName: "EventSubscription"
                }
              }
            }
          }
        },
        DescribeEvents: {
          input: {
            type: "structure",
            members: {
              SourceIdentifier: {},
              SourceType: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Duration: {
                type: "integer"
              },
              EventCategories: {
                shape: "S8"
              },
              Filters: {
                shape: "S7c"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventsResult",
            type: "structure",
            members: {
              Marker: {},
              Events: {
                type: "list",
                member: {
                  locationName: "Event",
                  type: "structure",
                  members: {
                    SourceIdentifier: {},
                    SourceType: {},
                    Message: {},
                    EventCategories: {
                      shape: "S8"
                    },
                    Date: {
                      type: "timestamp"
                    },
                    SourceArn: {}
                  }
                }
              }
            }
          }
        },
        DescribeExportTasks: {
          input: {
            type: "structure",
            members: {
              ExportTaskIdentifier: {},
              SourceArn: {},
              Filters: {
                shape: "S7c"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              },
              SourceType: {}
            }
          },
          output: {
            resultWrapper: "DescribeExportTasksResult",
            type: "structure",
            members: {
              Marker: {},
              ExportTasks: {
                type: "list",
                member: {
                  shape: "Su",
                  locationName: "ExportTask"
                }
              }
            }
          }
        },
        DescribeGlobalClusters: {
          input: {
            type: "structure",
            members: {
              GlobalClusterIdentifier: {},
              Filters: {
                shape: "S7c"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeGlobalClustersResult",
            type: "structure",
            members: {
              Marker: {},
              GlobalClusters: {
                type: "list",
                member: {
                  shape: "S5g",
                  locationName: "GlobalClusterMember"
                }
              }
            }
          }
        },
        DescribeIntegrations: {
          input: {
            type: "structure",
            members: {
              IntegrationIdentifier: {},
              Filters: {
                shape: "S7c"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeIntegrationsResult",
            type: "structure",
            members: {
              Marker: {},
              Integrations: {
                type: "list",
                member: {
                  shape: "S5s",
                  locationName: "Integration"
                }
              }
            }
          }
        },
        DescribeOptionGroupOptions: {
          input: {
            type: "structure",
            required: [
              "EngineName"
            ],
            members: {
              EngineName: {},
              MajorEngineVersion: {},
              Filters: {
                shape: "S7c"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeOptionGroupOptionsResult",
            type: "structure",
            members: {
              OptionGroupOptions: {
                type: "list",
                member: {
                  locationName: "OptionGroupOption",
                  type: "structure",
                  members: {
                    Name: {},
                    Description: {},
                    EngineName: {},
                    MajorEngineVersion: {},
                    MinimumRequiredMinorEngineVersion: {},
                    PortRequired: {
                      type: "boolean"
                    },
                    DefaultPort: {
                      type: "integer"
                    },
                    OptionsDependedOn: {
                      type: "list",
                      member: {
                        locationName: "OptionName"
                      }
                    },
                    OptionsConflictsWith: {
                      type: "list",
                      member: {
                        locationName: "OptionConflictName"
                      }
                    },
                    Persistent: {
                      type: "boolean"
                    },
                    Permanent: {
                      type: "boolean"
                    },
                    RequiresAutoMinorEngineVersionUpgrade: {
                      type: "boolean"
                    },
                    VpcOnly: {
                      type: "boolean"
                    },
                    SupportsOptionVersionDowngrade: {
                      type: "boolean"
                    },
                    OptionGroupOptionSettings: {
                      type: "list",
                      member: {
                        locationName: "OptionGroupOptionSetting",
                        type: "structure",
                        members: {
                          SettingName: {},
                          SettingDescription: {},
                          DefaultValue: {},
                          ApplyType: {},
                          AllowedValues: {},
                          IsModifiable: {
                            type: "boolean"
                          },
                          IsRequired: {
                            type: "boolean"
                          },
                          MinimumEngineVersionPerAllowedValue: {
                            type: "list",
                            member: {
                              locationName: "MinimumEngineVersionPerAllowedValue",
                              type: "structure",
                              members: {
                                AllowedValue: {},
                                MinimumEngineVersion: {}
                              }
                            }
                          }
                        }
                      }
                    },
                    OptionGroupOptionVersions: {
                      type: "list",
                      member: {
                        locationName: "OptionVersion",
                        type: "structure",
                        members: {
                          Version: {},
                          IsDefault: {
                            type: "boolean"
                          }
                        }
                      }
                    },
                    CopyableCrossAccount: {
                      type: "boolean"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeOptionGroups: {
          input: {
            type: "structure",
            members: {
              OptionGroupName: {},
              Filters: {
                shape: "S7c"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              },
              EngineName: {},
              MajorEngineVersion: {}
            }
          },
          output: {
            resultWrapper: "DescribeOptionGroupsResult",
            type: "structure",
            members: {
              OptionGroupsList: {
                type: "list",
                member: {
                  shape: "S1g",
                  locationName: "OptionGroup"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeOrderableDBInstanceOptions: {
          input: {
            type: "structure",
            required: [
              "Engine"
            ],
            members: {
              Engine: {},
              EngineVersion: {},
              DBInstanceClass: {},
              LicenseModel: {},
              AvailabilityZoneGroup: {},
              Vpc: {
                type: "boolean"
              },
              Filters: {
                shape: "S7c"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeOrderableDBInstanceOptionsResult",
            type: "structure",
            members: {
              OrderableDBInstanceOptions: {
                type: "list",
                member: {
                  locationName: "OrderableDBInstanceOption",
                  type: "structure",
                  members: {
                    Engine: {},
                    EngineVersion: {},
                    DBInstanceClass: {},
                    LicenseModel: {},
                    AvailabilityZoneGroup: {},
                    AvailabilityZones: {
                      type: "list",
                      member: {
                        shape: "S42",
                        locationName: "AvailabilityZone"
                      }
                    },
                    MultiAZCapable: {
                      type: "boolean"
                    },
                    ReadReplicaCapable: {
                      type: "boolean"
                    },
                    Vpc: {
                      type: "boolean"
                    },
                    SupportsStorageEncryption: {
                      type: "boolean"
                    },
                    StorageType: {},
                    SupportsIops: {
                      type: "boolean"
                    },
                    SupportsEnhancedMonitoring: {
                      type: "boolean"
                    },
                    SupportsIAMDatabaseAuthentication: {
                      type: "boolean"
                    },
                    SupportsPerformanceInsights: {
                      type: "boolean"
                    },
                    MinStorageSize: {
                      type: "integer"
                    },
                    MaxStorageSize: {
                      type: "integer"
                    },
                    MinIopsPerDbInstance: {
                      type: "integer"
                    },
                    MaxIopsPerDbInstance: {
                      type: "integer"
                    },
                    MinIopsPerGib: {
                      type: "double"
                    },
                    MaxIopsPerGib: {
                      type: "double"
                    },
                    AvailableProcessorFeatures: {
                      shape: "Sby"
                    },
                    SupportedEngineModes: {
                      shape: "S2m"
                    },
                    SupportsStorageAutoscaling: {
                      type: "boolean"
                    },
                    SupportsKerberosAuthentication: {
                      type: "boolean"
                    },
                    OutpostCapable: {
                      type: "boolean"
                    },
                    SupportedActivityStreamModes: {
                      type: "list",
                      member: {}
                    },
                    SupportsGlobalDatabases: {
                      type: "boolean"
                    },
                    SupportsClusters: {
                      type: "boolean"
                    },
                    SupportedNetworkTypes: {
                      shape: "Sv"
                    },
                    SupportsStorageThroughput: {
                      type: "boolean"
                    },
                    MinStorageThroughputPerDbInstance: {
                      type: "integer"
                    },
                    MaxStorageThroughputPerDbInstance: {
                      type: "integer"
                    },
                    MinStorageThroughputPerIops: {
                      type: "double"
                    },
                    MaxStorageThroughputPerIops: {
                      type: "double"
                    },
                    SupportsDedicatedLogVolume: {
                      type: "boolean"
                    }
                  },
                  wrapper: true
                }
              },
              Marker: {}
            }
          }
        },
        DescribePendingMaintenanceActions: {
          input: {
            type: "structure",
            members: {
              ResourceIdentifier: {},
              Filters: {
                shape: "S7c"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribePendingMaintenanceActionsResult",
            type: "structure",
            members: {
              PendingMaintenanceActions: {
                type: "list",
                member: {
                  shape: "Sf",
                  locationName: "ResourcePendingMaintenanceActions"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeReservedDBInstances: {
          input: {
            type: "structure",
            members: {
              ReservedDBInstanceId: {},
              ReservedDBInstancesOfferingId: {},
              DBInstanceClass: {},
              Duration: {},
              ProductDescription: {},
              OfferingType: {},
              MultiAZ: {
                type: "boolean"
              },
              LeaseId: {},
              Filters: {
                shape: "S7c"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeReservedDBInstancesResult",
            type: "structure",
            members: {
              Marker: {},
              ReservedDBInstances: {
                type: "list",
                member: {
                  shape: "Sc7",
                  locationName: "ReservedDBInstance"
                }
              }
            }
          }
        },
        DescribeReservedDBInstancesOfferings: {
          input: {
            type: "structure",
            members: {
              ReservedDBInstancesOfferingId: {},
              DBInstanceClass: {},
              Duration: {},
              ProductDescription: {},
              OfferingType: {},
              MultiAZ: {
                type: "boolean"
              },
              Filters: {
                shape: "S7c"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeReservedDBInstancesOfferingsResult",
            type: "structure",
            members: {
              Marker: {},
              ReservedDBInstancesOfferings: {
                type: "list",
                member: {
                  locationName: "ReservedDBInstancesOffering",
                  type: "structure",
                  members: {
                    ReservedDBInstancesOfferingId: {},
                    DBInstanceClass: {},
                    Duration: {
                      type: "integer"
                    },
                    FixedPrice: {
                      type: "double"
                    },
                    UsagePrice: {
                      type: "double"
                    },
                    CurrencyCode: {},
                    ProductDescription: {},
                    OfferingType: {},
                    MultiAZ: {
                      type: "boolean"
                    },
                    RecurringCharges: {
                      shape: "Sc8"
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        DescribeSourceRegions: {
          input: {
            type: "structure",
            members: {
              RegionName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              Filters: {
                shape: "S7c"
              }
            }
          },
          output: {
            resultWrapper: "DescribeSourceRegionsResult",
            type: "structure",
            members: {
              Marker: {},
              SourceRegions: {
                type: "list",
                member: {
                  locationName: "SourceRegion",
                  type: "structure",
                  members: {
                    RegionName: {},
                    Endpoint: {},
                    Status: {},
                    SupportsDBInstanceAutomatedBackupsReplication: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeTenantDatabases: {
          input: {
            type: "structure",
            members: {
              DBInstanceIdentifier: {},
              TenantDBName: {},
              Filters: {
                shape: "S7c"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeTenantDatabasesResult",
            type: "structure",
            members: {
              Marker: {},
              TenantDatabases: {
                type: "list",
                member: {
                  shape: "S62",
                  locationName: "TenantDatabase"
                }
              }
            }
          }
        },
        DescribeValidDBInstanceModifications: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DescribeValidDBInstanceModificationsResult",
            type: "structure",
            members: {
              ValidDBInstanceModificationsMessage: {
                type: "structure",
                members: {
                  Storage: {
                    type: "list",
                    member: {
                      locationName: "ValidStorageOptions",
                      type: "structure",
                      members: {
                        StorageType: {},
                        StorageSize: {
                          shape: "Scq"
                        },
                        ProvisionedIops: {
                          shape: "Scq"
                        },
                        IopsToStorageRatio: {
                          shape: "Scs"
                        },
                        SupportsStorageAutoscaling: {
                          type: "boolean"
                        },
                        ProvisionedStorageThroughput: {
                          shape: "Scq"
                        },
                        StorageThroughputToIopsRatio: {
                          shape: "Scs"
                        }
                      }
                    }
                  },
                  ValidProcessorFeatures: {
                    shape: "Sby"
                  },
                  SupportsDedicatedLogVolume: {
                    type: "boolean"
                  }
                },
                wrapper: true
              }
            }
          }
        },
        DisableHttpEndpoint: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            resultWrapper: "DisableHttpEndpointResult",
            type: "structure",
            members: {
              ResourceArn: {},
              HttpEndpointEnabled: {
                type: "boolean"
              }
            }
          }
        },
        DownloadDBLogFilePortion: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "LogFileName"
            ],
            members: {
              DBInstanceIdentifier: {},
              LogFileName: {},
              Marker: {},
              NumberOfLines: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DownloadDBLogFilePortionResult",
            type: "structure",
            members: {
              LogFileData: {},
              Marker: {},
              AdditionalDataPending: {
                type: "boolean"
              }
            }
          }
        },
        EnableHttpEndpoint: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            resultWrapper: "EnableHttpEndpointResult",
            type: "structure",
            members: {
              ResourceArn: {},
              HttpEndpointEnabled: {
                type: "boolean"
              }
            }
          }
        },
        FailoverDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {},
              TargetDBInstanceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "FailoverDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "S31"
              }
            }
          }
        },
        FailoverGlobalCluster: {
          input: {
            type: "structure",
            required: [
              "GlobalClusterIdentifier",
              "TargetDbClusterIdentifier"
            ],
            members: {
              GlobalClusterIdentifier: {},
              TargetDbClusterIdentifier: {},
              AllowDataLoss: {
                type: "boolean"
              },
              Switchover: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "FailoverGlobalClusterResult",
            type: "structure",
            members: {
              GlobalCluster: {
                shape: "S5g"
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName"
            ],
            members: {
              ResourceName: {},
              Filters: {
                shape: "S7c"
              }
            }
          },
          output: {
            resultWrapper: "ListTagsForResourceResult",
            type: "structure",
            members: {
              TagList: {
                shape: "Sb"
              }
            }
          }
        },
        ModifyActivityStream: {
          input: {
            type: "structure",
            members: {
              ResourceArn: {},
              AuditPolicyState: {}
            }
          },
          output: {
            resultWrapper: "ModifyActivityStreamResult",
            type: "structure",
            members: {
              KmsKeyId: {},
              KinesisStreamName: {},
              Status: {},
              Mode: {},
              EngineNativeAuditFieldsIncluded: {
                type: "boolean"
              },
              PolicyStatus: {}
            }
          }
        },
        ModifyCertificates: {
          input: {
            type: "structure",
            members: {
              CertificateIdentifier: {},
              RemoveCustomerOverride: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyCertificatesResult",
            type: "structure",
            members: {
              Certificate: {
                shape: "S7l"
              }
            }
          }
        },
        ModifyCurrentDBClusterCapacity: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {},
              Capacity: {
                type: "integer"
              },
              SecondsBeforeTimeout: {
                type: "integer"
              },
              TimeoutAction: {}
            }
          },
          output: {
            resultWrapper: "ModifyCurrentDBClusterCapacityResult",
            type: "structure",
            members: {
              DBClusterIdentifier: {},
              PendingCapacity: {
                type: "integer"
              },
              CurrentCapacity: {
                type: "integer"
              },
              SecondsBeforeTimeout: {
                type: "integer"
              },
              TimeoutAction: {}
            }
          }
        },
        ModifyCustomDBEngineVersion: {
          input: {
            type: "structure",
            required: [
              "Engine",
              "EngineVersion"
            ],
            members: {
              Engine: {},
              EngineVersion: {},
              Description: {},
              Status: {}
            }
          },
          output: {
            shape: "S2g",
            resultWrapper: "ModifyCustomDBEngineVersionResult"
          }
        },
        ModifyDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {},
              NewDBClusterIdentifier: {},
              ApplyImmediately: {
                type: "boolean"
              },
              BackupRetentionPeriod: {
                type: "integer"
              },
              DBClusterParameterGroupName: {},
              VpcSecurityGroupIds: {
                shape: "S2t"
              },
              Port: {
                type: "integer"
              },
              MasterUserPassword: {},
              OptionGroupName: {},
              PreferredBackupWindow: {},
              PreferredMaintenanceWindow: {},
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              BacktrackWindow: {
                type: "long"
              },
              CloudwatchLogsExportConfiguration: {
                shape: "Sdi"
              },
              EngineVersion: {},
              AllowMajorVersionUpgrade: {
                type: "boolean"
              },
              DBInstanceParameterGroupName: {},
              Domain: {},
              DomainIAMRoleName: {},
              ScalingConfiguration: {
                shape: "S2v"
              },
              DeletionProtection: {
                type: "boolean"
              },
              EnableHttpEndpoint: {
                type: "boolean"
              },
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              EnableGlobalWriteForwarding: {
                type: "boolean"
              },
              DBClusterInstanceClass: {},
              AllocatedStorage: {
                type: "integer"
              },
              StorageType: {},
              Iops: {
                type: "integer"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              MonitoringInterval: {
                type: "integer"
              },
              MonitoringRoleArn: {},
              EnablePerformanceInsights: {
                type: "boolean"
              },
              PerformanceInsightsKMSKeyId: {},
              PerformanceInsightsRetentionPeriod: {
                type: "integer"
              },
              ServerlessV2ScalingConfiguration: {
                shape: "S2y"
              },
              NetworkType: {},
              ManageMasterUserPassword: {
                type: "boolean"
              },
              RotateMasterUserPassword: {
                type: "boolean"
              },
              MasterUserSecretKmsKeyId: {},
              EngineMode: {},
              AllowEngineModeChange: {
                type: "boolean"
              },
              EnableLocalWriteForwarding: {
                type: "boolean"
              },
              AwsBackupRecoveryPointArn: {}
            }
          },
          output: {
            resultWrapper: "ModifyDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "S31"
              }
            }
          }
        },
        ModifyDBClusterEndpoint: {
          input: {
            type: "structure",
            required: [
              "DBClusterEndpointIdentifier"
            ],
            members: {
              DBClusterEndpointIdentifier: {},
              EndpointType: {},
              StaticMembers: {
                shape: "Sv"
              },
              ExcludedMembers: {
                shape: "Sv"
              }
            }
          },
          output: {
            shape: "S3n",
            resultWrapper: "ModifyDBClusterEndpointResult"
          }
        },
        ModifyDBClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBClusterParameterGroupName",
              "Parameters"
            ],
            members: {
              DBClusterParameterGroupName: {},
              Parameters: {
                shape: "S80"
              }
            }
          },
          output: {
            shape: "Sdn",
            resultWrapper: "ModifyDBClusterParameterGroupResult"
          }
        },
        ModifyDBClusterSnapshotAttribute: {
          input: {
            type: "structure",
            required: [
              "DBClusterSnapshotIdentifier",
              "AttributeName"
            ],
            members: {
              DBClusterSnapshotIdentifier: {},
              AttributeName: {},
              ValuesToAdd: {
                shape: "S88"
              },
              ValuesToRemove: {
                shape: "S88"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBClusterSnapshotAttributeResult",
            type: "structure",
            members: {
              DBClusterSnapshotAttributesResult: {
                shape: "S85"
              }
            }
          }
        },
        ModifyDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              AllocatedStorage: {
                type: "integer"
              },
              DBInstanceClass: {},
              DBSubnetGroupName: {},
              DBSecurityGroups: {
                shape: "S3t"
              },
              VpcSecurityGroupIds: {
                shape: "S2t"
              },
              ApplyImmediately: {
                type: "boolean"
              },
              MasterUserPassword: {},
              DBParameterGroupName: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {},
              PreferredMaintenanceWindow: {},
              MultiAZ: {
                type: "boolean"
              },
              EngineVersion: {},
              AllowMajorVersionUpgrade: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              NewDBInstanceIdentifier: {},
              StorageType: {},
              TdeCredentialArn: {},
              TdeCredentialPassword: {},
              CACertificateIdentifier: {},
              Domain: {},
              DomainFqdn: {},
              DomainOu: {},
              DomainAuthSecretArn: {},
              DomainDnsIps: {
                shape: "Sv"
              },
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              MonitoringInterval: {
                type: "integer"
              },
              DBPortNumber: {
                type: "integer"
              },
              PubliclyAccessible: {
                type: "boolean"
              },
              MonitoringRoleArn: {},
              DomainIAMRoleName: {},
              DisableDomain: {
                type: "boolean"
              },
              PromotionTier: {
                type: "integer"
              },
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              EnablePerformanceInsights: {
                type: "boolean"
              },
              PerformanceInsightsKMSKeyId: {},
              PerformanceInsightsRetentionPeriod: {
                type: "integer"
              },
              CloudwatchLogsExportConfiguration: {
                shape: "Sdi"
              },
              ProcessorFeatures: {
                shape: "S1c"
              },
              UseDefaultProcessorFeatures: {
                type: "boolean"
              },
              DeletionProtection: {
                type: "boolean"
              },
              MaxAllocatedStorage: {
                type: "integer"
              },
              CertificateRotationRestart: {
                type: "boolean"
              },
              ReplicaMode: {},
              EnableCustomerOwnedIp: {
                type: "boolean"
              },
              AwsBackupRecoveryPointArn: {},
              AutomationMode: {},
              ResumeFullAutomationModeMinutes: {
                type: "integer"
              },
              NetworkType: {},
              StorageThroughput: {
                type: "integer"
              },
              ManageMasterUserPassword: {
                type: "boolean"
              },
              RotateMasterUserPassword: {
                type: "boolean"
              },
              MasterUserSecretKmsKeyId: {},
              Engine: {},
              DedicatedLogVolume: {
                type: "boolean"
              },
              MultiTenant: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S3v"
              }
            }
          }
        },
        ModifyDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName",
              "Parameters"
            ],
            members: {
              DBParameterGroupName: {},
              Parameters: {
                shape: "S80"
              }
            }
          },
          output: {
            shape: "Sdt",
            resultWrapper: "ModifyDBParameterGroupResult"
          }
        },
        ModifyDBProxy: {
          input: {
            type: "structure",
            required: [
              "DBProxyName"
            ],
            members: {
              DBProxyName: {},
              NewDBProxyName: {},
              Auth: {
                shape: "S4o"
              },
              RequireTLS: {
                type: "boolean"
              },
              IdleClientTimeout: {
                type: "integer"
              },
              DebugLogging: {
                type: "boolean"
              },
              RoleArn: {},
              SecurityGroups: {
                shape: "Sv"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBProxyResult",
            type: "structure",
            members: {
              DBProxy: {
                shape: "S4u"
              }
            }
          }
        },
        ModifyDBProxyEndpoint: {
          input: {
            type: "structure",
            required: [
              "DBProxyEndpointName"
            ],
            members: {
              DBProxyEndpointName: {},
              NewDBProxyEndpointName: {},
              VpcSecurityGroupIds: {
                shape: "Sv"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBProxyEndpointResult",
            type: "structure",
            members: {
              DBProxyEndpoint: {
                shape: "S53"
              }
            }
          }
        },
        ModifyDBProxyTargetGroup: {
          input: {
            type: "structure",
            required: [
              "TargetGroupName",
              "DBProxyName"
            ],
            members: {
              TargetGroupName: {},
              DBProxyName: {},
              ConnectionPoolConfig: {
                type: "structure",
                members: {
                  MaxConnectionsPercent: {
                    type: "integer"
                  },
                  MaxIdleConnectionsPercent: {
                    type: "integer"
                  },
                  ConnectionBorrowTimeout: {
                    type: "integer"
                  },
                  SessionPinningFilters: {
                    shape: "Sv"
                  },
                  InitQuery: {}
                }
              },
              NewName: {}
            }
          },
          output: {
            resultWrapper: "ModifyDBProxyTargetGroupResult",
            type: "structure",
            members: {
              DBProxyTargetGroup: {
                shape: "S96"
              }
            }
          }
        },
        ModifyDBRecommendation: {
          input: {
            type: "structure",
            required: [
              "RecommendationId"
            ],
            members: {
              RecommendationId: {},
              Locale: {},
              Status: {},
              RecommendedActionUpdates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ActionId",
                    "Status"
                  ],
                  members: {
                    ActionId: {},
                    Status: {}
                  }
                }
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBRecommendationResult",
            type: "structure",
            members: {
              DBRecommendation: {
                shape: "S9k"
              }
            }
          }
        },
        ModifyDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBSnapshotIdentifier"
            ],
            members: {
              DBSnapshotIdentifier: {},
              EngineVersion: {},
              OptionGroupName: {}
            }
          },
          output: {
            resultWrapper: "ModifyDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "S1a"
              }
            }
          }
        },
        ModifyDBSnapshotAttribute: {
          input: {
            type: "structure",
            required: [
              "DBSnapshotIdentifier",
              "AttributeName"
            ],
            members: {
              DBSnapshotIdentifier: {},
              AttributeName: {},
              ValuesToAdd: {
                shape: "S88"
              },
              ValuesToRemove: {
                shape: "S88"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBSnapshotAttributeResult",
            type: "structure",
            members: {
              DBSnapshotAttributesResult: {
                shape: "Saa"
              }
            }
          }
        },
        ModifyDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName",
              "SubnetIds"
            ],
            members: {
              DBSubnetGroupName: {},
              DBSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S5a"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBSubnetGroupResult",
            type: "structure",
            members: {
              DBSubnetGroup: {
                shape: "S3z"
              }
            }
          }
        },
        ModifyEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S8"
              },
              Enabled: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S6"
              }
            }
          }
        },
        ModifyGlobalCluster: {
          input: {
            type: "structure",
            members: {
              GlobalClusterIdentifier: {},
              NewGlobalClusterIdentifier: {},
              DeletionProtection: {
                type: "boolean"
              },
              EngineVersion: {},
              AllowMajorVersionUpgrade: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyGlobalClusterResult",
            type: "structure",
            members: {
              GlobalCluster: {
                shape: "S5g"
              }
            }
          }
        },
        ModifyOptionGroup: {
          input: {
            type: "structure",
            required: [
              "OptionGroupName"
            ],
            members: {
              OptionGroupName: {},
              OptionsToInclude: {
                type: "list",
                member: {
                  locationName: "OptionConfiguration",
                  type: "structure",
                  required: [
                    "OptionName"
                  ],
                  members: {
                    OptionName: {},
                    Port: {
                      type: "integer"
                    },
                    OptionVersion: {},
                    DBSecurityGroupMemberships: {
                      shape: "S3t"
                    },
                    VpcSecurityGroupMemberships: {
                      shape: "S2t"
                    },
                    OptionSettings: {
                      type: "list",
                      member: {
                        shape: "S1k",
                        locationName: "OptionSetting"
                      }
                    }
                  }
                }
              },
              OptionsToRemove: {
                type: "list",
                member: {}
              },
              ApplyImmediately: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyOptionGroupResult",
            type: "structure",
            members: {
              OptionGroup: {
                shape: "S1g"
              }
            }
          }
        },
        ModifyTenantDatabase: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "TenantDBName"
            ],
            members: {
              DBInstanceIdentifier: {},
              TenantDBName: {},
              MasterUserPassword: {
                shape: "S60"
              },
              NewTenantDBName: {}
            }
          },
          output: {
            resultWrapper: "ModifyTenantDatabaseResult",
            type: "structure",
            members: {
              TenantDatabase: {
                shape: "S62"
              }
            }
          }
        },
        PromoteReadReplica: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {}
            }
          },
          output: {
            resultWrapper: "PromoteReadReplicaResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S3v"
              }
            }
          }
        },
        PromoteReadReplicaDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "PromoteReadReplicaDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "S31"
              }
            }
          }
        },
        PurchaseReservedDBInstancesOffering: {
          input: {
            type: "structure",
            required: [
              "ReservedDBInstancesOfferingId"
            ],
            members: {
              ReservedDBInstancesOfferingId: {},
              ReservedDBInstanceId: {},
              DBInstanceCount: {
                type: "integer"
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "PurchaseReservedDBInstancesOfferingResult",
            type: "structure",
            members: {
              ReservedDBInstance: {
                shape: "Sc7"
              }
            }
          }
        },
        RebootDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "RebootDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "S31"
              }
            }
          }
        },
        RebootDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              ForceFailover: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "RebootDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S3v"
              }
            }
          }
        },
        RegisterDBProxyTargets: {
          input: {
            type: "structure",
            required: [
              "DBProxyName"
            ],
            members: {
              DBProxyName: {},
              TargetGroupName: {},
              DBInstanceIdentifiers: {
                shape: "Sv"
              },
              DBClusterIdentifiers: {
                shape: "Sv"
              }
            }
          },
          output: {
            resultWrapper: "RegisterDBProxyTargetsResult",
            type: "structure",
            members: {
              DBProxyTargets: {
                shape: "S9a"
              }
            }
          }
        },
        RemoveFromGlobalCluster: {
          input: {
            type: "structure",
            members: {
              GlobalClusterIdentifier: {},
              DbClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "RemoveFromGlobalClusterResult",
            type: "structure",
            members: {
              GlobalCluster: {
                shape: "S5g"
              }
            }
          }
        },
        RemoveRoleFromDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "RoleArn"
            ],
            members: {
              DBClusterIdentifier: {},
              RoleArn: {},
              FeatureName: {}
            }
          }
        },
        RemoveRoleFromDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "RoleArn",
              "FeatureName"
            ],
            members: {
              DBInstanceIdentifier: {},
              RoleArn: {},
              FeatureName: {}
            }
          }
        },
        RemoveSourceIdentifierFromSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SourceIdentifier"
            ],
            members: {
              SubscriptionName: {},
              SourceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "RemoveSourceIdentifierFromSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S6"
              }
            }
          }
        },
        RemoveTagsFromResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "TagKeys"
            ],
            members: {
              ResourceName: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ResetDBClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBClusterParameterGroupName"
            ],
            members: {
              DBClusterParameterGroupName: {},
              ResetAllParameters: {
                type: "boolean"
              },
              Parameters: {
                shape: "S80"
              }
            }
          },
          output: {
            shape: "Sdn",
            resultWrapper: "ResetDBClusterParameterGroupResult"
          }
        },
        ResetDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {},
              ResetAllParameters: {
                type: "boolean"
              },
              Parameters: {
                shape: "S80"
              }
            }
          },
          output: {
            shape: "Sdt",
            resultWrapper: "ResetDBParameterGroupResult"
          }
        },
        RestoreDBClusterFromS3: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "Engine",
              "MasterUsername",
              "SourceEngine",
              "SourceEngineVersion",
              "S3BucketName",
              "S3IngestionRoleArn"
            ],
            members: {
              AvailabilityZones: {
                shape: "S14"
              },
              BackupRetentionPeriod: {
                type: "integer"
              },
              CharacterSetName: {},
              DatabaseName: {},
              DBClusterIdentifier: {},
              DBClusterParameterGroupName: {},
              VpcSecurityGroupIds: {
                shape: "S2t"
              },
              DBSubnetGroupName: {},
              Engine: {},
              EngineVersion: {},
              Port: {
                type: "integer"
              },
              MasterUsername: {},
              MasterUserPassword: {},
              OptionGroupName: {},
              PreferredBackupWindow: {},
              PreferredMaintenanceWindow: {},
              Tags: {
                shape: "Sb"
              },
              StorageEncrypted: {
                type: "boolean"
              },
              KmsKeyId: {},
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              SourceEngine: {},
              SourceEngineVersion: {},
              S3BucketName: {},
              S3Prefix: {},
              S3IngestionRoleArn: {},
              BacktrackWindow: {
                type: "long"
              },
              EnableCloudwatchLogsExports: {
                shape: "S2p"
              },
              DeletionProtection: {
                type: "boolean"
              },
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              Domain: {},
              DomainIAMRoleName: {},
              ServerlessV2ScalingConfiguration: {
                shape: "S2y"
              },
              NetworkType: {},
              ManageMasterUserPassword: {
                type: "boolean"
              },
              MasterUserSecretKmsKeyId: {},
              StorageType: {}
            }
          },
          output: {
            resultWrapper: "RestoreDBClusterFromS3Result",
            type: "structure",
            members: {
              DBCluster: {
                shape: "S31"
              }
            }
          }
        },
        RestoreDBClusterFromSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "SnapshotIdentifier",
              "Engine"
            ],
            members: {
              AvailabilityZones: {
                shape: "S14"
              },
              DBClusterIdentifier: {},
              SnapshotIdentifier: {},
              Engine: {},
              EngineVersion: {},
              Port: {
                type: "integer"
              },
              DBSubnetGroupName: {},
              DatabaseName: {},
              OptionGroupName: {},
              VpcSecurityGroupIds: {
                shape: "S2t"
              },
              Tags: {
                shape: "Sb"
              },
              KmsKeyId: {},
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              BacktrackWindow: {
                type: "long"
              },
              EnableCloudwatchLogsExports: {
                shape: "S2p"
              },
              EngineMode: {},
              ScalingConfiguration: {
                shape: "S2v"
              },
              DBClusterParameterGroupName: {},
              DeletionProtection: {
                type: "boolean"
              },
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              Domain: {},
              DomainIAMRoleName: {},
              DBClusterInstanceClass: {},
              StorageType: {},
              Iops: {
                type: "integer"
              },
              PubliclyAccessible: {
                type: "boolean"
              },
              ServerlessV2ScalingConfiguration: {
                shape: "S2y"
              },
              NetworkType: {},
              RdsCustomClusterConfiguration: {
                shape: "S2w"
              }
            }
          },
          output: {
            resultWrapper: "RestoreDBClusterFromSnapshotResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "S31"
              }
            }
          }
        },
        RestoreDBClusterToPointInTime: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {},
              RestoreType: {},
              SourceDBClusterIdentifier: {},
              RestoreToTime: {
                type: "timestamp"
              },
              UseLatestRestorableTime: {
                type: "boolean"
              },
              Port: {
                type: "integer"
              },
              DBSubnetGroupName: {},
              OptionGroupName: {},
              VpcSecurityGroupIds: {
                shape: "S2t"
              },
              Tags: {
                shape: "Sb"
              },
              KmsKeyId: {},
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              BacktrackWindow: {
                type: "long"
              },
              EnableCloudwatchLogsExports: {
                shape: "S2p"
              },
              DBClusterParameterGroupName: {},
              DeletionProtection: {
                type: "boolean"
              },
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              Domain: {},
              DomainIAMRoleName: {},
              ScalingConfiguration: {
                shape: "S2v"
              },
              EngineMode: {},
              DBClusterInstanceClass: {},
              StorageType: {},
              PubliclyAccessible: {
                type: "boolean"
              },
              Iops: {
                type: "integer"
              },
              ServerlessV2ScalingConfiguration: {
                shape: "S2y"
              },
              NetworkType: {},
              SourceDbClusterResourceId: {},
              RdsCustomClusterConfiguration: {
                shape: "S2w"
              }
            }
          },
          output: {
            resultWrapper: "RestoreDBClusterToPointInTimeResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "S31"
              }
            }
          }
        },
        RestoreDBInstanceFromDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              DBSnapshotIdentifier: {},
              DBInstanceClass: {},
              Port: {
                type: "integer"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              MultiAZ: {
                type: "boolean"
              },
              PubliclyAccessible: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              DBName: {},
              Engine: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              Tags: {
                shape: "Sb"
              },
              StorageType: {},
              TdeCredentialArn: {},
              TdeCredentialPassword: {},
              VpcSecurityGroupIds: {
                shape: "S2t"
              },
              Domain: {},
              DomainFqdn: {},
              DomainOu: {},
              DomainAuthSecretArn: {},
              DomainDnsIps: {
                shape: "Sv"
              },
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              DomainIAMRoleName: {},
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              EnableCloudwatchLogsExports: {
                shape: "S2p"
              },
              ProcessorFeatures: {
                shape: "S1c"
              },
              UseDefaultProcessorFeatures: {
                type: "boolean"
              },
              DBParameterGroupName: {},
              DeletionProtection: {
                type: "boolean"
              },
              EnableCustomerOwnedIp: {
                type: "boolean"
              },
              CustomIamInstanceProfile: {},
              BackupTarget: {},
              NetworkType: {},
              StorageThroughput: {
                type: "integer"
              },
              DBClusterSnapshotIdentifier: {},
              AllocatedStorage: {
                type: "integer"
              },
              DedicatedLogVolume: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "RestoreDBInstanceFromDBSnapshotResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S3v"
              }
            }
          }
        },
        RestoreDBInstanceFromS3: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "DBInstanceClass",
              "Engine",
              "SourceEngine",
              "SourceEngineVersion",
              "S3BucketName",
              "S3IngestionRoleArn"
            ],
            members: {
              DBName: {},
              DBInstanceIdentifier: {},
              AllocatedStorage: {
                type: "integer"
              },
              DBInstanceClass: {},
              Engine: {},
              MasterUsername: {},
              MasterUserPassword: {},
              DBSecurityGroups: {
                shape: "S3t"
              },
              VpcSecurityGroupIds: {
                shape: "S2t"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              PreferredMaintenanceWindow: {},
              DBParameterGroupName: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {},
              Port: {
                type: "integer"
              },
              MultiAZ: {
                type: "boolean"
              },
              EngineVersion: {},
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              PubliclyAccessible: {
                type: "boolean"
              },
              Tags: {
                shape: "Sb"
              },
              StorageType: {},
              StorageEncrypted: {
                type: "boolean"
              },
              KmsKeyId: {},
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              MonitoringInterval: {
                type: "integer"
              },
              MonitoringRoleArn: {},
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              SourceEngine: {},
              SourceEngineVersion: {},
              S3BucketName: {},
              S3Prefix: {},
              S3IngestionRoleArn: {},
              EnablePerformanceInsights: {
                type: "boolean"
              },
              PerformanceInsightsKMSKeyId: {},
              PerformanceInsightsRetentionPeriod: {
                type: "integer"
              },
              EnableCloudwatchLogsExports: {
                shape: "S2p"
              },
              ProcessorFeatures: {
                shape: "S1c"
              },
              UseDefaultProcessorFeatures: {
                type: "boolean"
              },
              DeletionProtection: {
                type: "boolean"
              },
              MaxAllocatedStorage: {
                type: "integer"
              },
              NetworkType: {},
              StorageThroughput: {
                type: "integer"
              },
              ManageMasterUserPassword: {
                type: "boolean"
              },
              MasterUserSecretKmsKeyId: {},
              DedicatedLogVolume: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "RestoreDBInstanceFromS3Result",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S3v"
              }
            }
          }
        },
        RestoreDBInstanceToPointInTime: {
          input: {
            type: "structure",
            required: [
              "TargetDBInstanceIdentifier"
            ],
            members: {
              SourceDBInstanceIdentifier: {},
              TargetDBInstanceIdentifier: {},
              RestoreTime: {
                type: "timestamp"
              },
              UseLatestRestorableTime: {
                type: "boolean"
              },
              DBInstanceClass: {},
              Port: {
                type: "integer"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              MultiAZ: {
                type: "boolean"
              },
              PubliclyAccessible: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              DBName: {},
              Engine: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              Tags: {
                shape: "Sb"
              },
              StorageType: {},
              TdeCredentialArn: {},
              TdeCredentialPassword: {},
              VpcSecurityGroupIds: {
                shape: "S2t"
              },
              Domain: {},
              DomainIAMRoleName: {},
              DomainFqdn: {},
              DomainOu: {},
              DomainAuthSecretArn: {},
              DomainDnsIps: {
                shape: "Sv"
              },
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              EnableCloudwatchLogsExports: {
                shape: "S2p"
              },
              ProcessorFeatures: {
                shape: "S1c"
              },
              UseDefaultProcessorFeatures: {
                type: "boolean"
              },
              DBParameterGroupName: {},
              DeletionProtection: {
                type: "boolean"
              },
              SourceDbiResourceId: {},
              MaxAllocatedStorage: {
                type: "integer"
              },
              SourceDBInstanceAutomatedBackupsArn: {},
              EnableCustomerOwnedIp: {
                type: "boolean"
              },
              CustomIamInstanceProfile: {},
              BackupTarget: {},
              NetworkType: {},
              StorageThroughput: {
                type: "integer"
              },
              AllocatedStorage: {
                type: "integer"
              },
              DedicatedLogVolume: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "RestoreDBInstanceToPointInTimeResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S3v"
              }
            }
          }
        },
        RevokeDBSecurityGroupIngress: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName"
            ],
            members: {
              DBSecurityGroupName: {},
              CIDRIP: {},
              EC2SecurityGroupName: {},
              EC2SecurityGroupId: {},
              EC2SecurityGroupOwnerId: {}
            }
          },
          output: {
            resultWrapper: "RevokeDBSecurityGroupIngressResult",
            type: "structure",
            members: {
              DBSecurityGroup: {
                shape: "Sl"
              }
            }
          }
        },
        StartActivityStream: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Mode",
              "KmsKeyId"
            ],
            members: {
              ResourceArn: {},
              Mode: {},
              KmsKeyId: {},
              ApplyImmediately: {
                type: "boolean"
              },
              EngineNativeAuditFieldsIncluded: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "StartActivityStreamResult",
            type: "structure",
            members: {
              KmsKeyId: {},
              KinesisStreamName: {},
              Status: {},
              Mode: {},
              ApplyImmediately: {
                type: "boolean"
              },
              EngineNativeAuditFieldsIncluded: {
                type: "boolean"
              }
            }
          }
        },
        StartDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "StartDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "S31"
              }
            }
          }
        },
        StartDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "StartDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S3v"
              }
            }
          }
        },
        StartDBInstanceAutomatedBackupsReplication: {
          input: {
            type: "structure",
            required: [
              "SourceDBInstanceArn"
            ],
            members: {
              SourceDBInstanceArn: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              KmsKeyId: {},
              PreSignedUrl: {}
            }
          },
          output: {
            resultWrapper: "StartDBInstanceAutomatedBackupsReplicationResult",
            type: "structure",
            members: {
              DBInstanceAutomatedBackup: {
                shape: "S6l"
              }
            }
          }
        },
        StartExportTask: {
          input: {
            type: "structure",
            required: [
              "ExportTaskIdentifier",
              "SourceArn",
              "S3BucketName",
              "IamRoleArn",
              "KmsKeyId"
            ],
            members: {
              ExportTaskIdentifier: {},
              SourceArn: {},
              S3BucketName: {},
              IamRoleArn: {},
              KmsKeyId: {},
              S3Prefix: {},
              ExportOnly: {
                shape: "Sv"
              }
            }
          },
          output: {
            shape: "Su",
            resultWrapper: "StartExportTaskResult"
          }
        },
        StopActivityStream: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              ApplyImmediately: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "StopActivityStreamResult",
            type: "structure",
            members: {
              KmsKeyId: {},
              KinesisStreamName: {},
              Status: {}
            }
          }
        },
        StopDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "StopDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "S31"
              }
            }
          }
        },
        StopDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              DBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "StopDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S3v"
              }
            }
          }
        },
        StopDBInstanceAutomatedBackupsReplication: {
          input: {
            type: "structure",
            required: [
              "SourceDBInstanceArn"
            ],
            members: {
              SourceDBInstanceArn: {}
            }
          },
          output: {
            resultWrapper: "StopDBInstanceAutomatedBackupsReplicationResult",
            type: "structure",
            members: {
              DBInstanceAutomatedBackup: {
                shape: "S6l"
              }
            }
          }
        },
        SwitchoverBlueGreenDeployment: {
          input: {
            type: "structure",
            required: [
              "BlueGreenDeploymentIdentifier"
            ],
            members: {
              BlueGreenDeploymentIdentifier: {},
              SwitchoverTimeout: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "SwitchoverBlueGreenDeploymentResult",
            type: "structure",
            members: {
              BlueGreenDeployment: {
                shape: "S1x"
              }
            }
          }
        },
        SwitchoverGlobalCluster: {
          input: {
            type: "structure",
            required: [
              "GlobalClusterIdentifier",
              "TargetDbClusterIdentifier"
            ],
            members: {
              GlobalClusterIdentifier: {},
              TargetDbClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "SwitchoverGlobalClusterResult",
            type: "structure",
            members: {
              GlobalCluster: {
                shape: "S5g"
              }
            }
          }
        },
        SwitchoverReadReplica: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "SwitchoverReadReplicaResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S3v"
              }
            }
          }
        }
      },
      shapes: {
        S6: {
          type: "structure",
          members: {
            CustomerAwsId: {},
            CustSubscriptionId: {},
            SnsTopicArn: {},
            Status: {},
            SubscriptionCreationTime: {},
            SourceType: {},
            SourceIdsList: {
              shape: "S7"
            },
            EventCategoriesList: {
              shape: "S8"
            },
            Enabled: {
              type: "boolean"
            },
            EventSubscriptionArn: {}
          },
          wrapper: true
        },
        S7: {
          type: "list",
          member: {
            locationName: "SourceId"
          }
        },
        S8: {
          type: "list",
          member: {
            locationName: "EventCategory"
          }
        },
        Sb: {
          type: "list",
          member: {
            locationName: "Tag",
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sf: {
          type: "structure",
          members: {
            ResourceIdentifier: {},
            PendingMaintenanceActionDetails: {
              type: "list",
              member: {
                locationName: "PendingMaintenanceAction",
                type: "structure",
                members: {
                  Action: {},
                  AutoAppliedAfterDate: {
                    type: "timestamp"
                  },
                  ForcedApplyDate: {
                    type: "timestamp"
                  },
                  OptInStatus: {},
                  CurrentApplyDate: {
                    type: "timestamp"
                  },
                  Description: {}
                }
              }
            }
          },
          wrapper: true
        },
        Sl: {
          type: "structure",
          members: {
            OwnerId: {},
            DBSecurityGroupName: {},
            DBSecurityGroupDescription: {},
            VpcId: {},
            EC2SecurityGroups: {
              type: "list",
              member: {
                locationName: "EC2SecurityGroup",
                type: "structure",
                members: {
                  Status: {},
                  EC2SecurityGroupName: {},
                  EC2SecurityGroupId: {},
                  EC2SecurityGroupOwnerId: {}
                }
              }
            },
            IPRanges: {
              type: "list",
              member: {
                locationName: "IPRange",
                type: "structure",
                members: {
                  Status: {},
                  CIDRIP: {}
                }
              }
            },
            DBSecurityGroupArn: {}
          },
          wrapper: true
        },
        Ss: {
          type: "structure",
          members: {
            DBClusterIdentifier: {},
            BacktrackIdentifier: {},
            BacktrackTo: {
              type: "timestamp"
            },
            BacktrackedFrom: {
              type: "timestamp"
            },
            BacktrackRequestCreationTime: {
              type: "timestamp"
            },
            Status: {}
          }
        },
        Su: {
          type: "structure",
          members: {
            ExportTaskIdentifier: {},
            SourceArn: {},
            ExportOnly: {
              shape: "Sv"
            },
            SnapshotTime: {
              type: "timestamp"
            },
            TaskStartTime: {
              type: "timestamp"
            },
            TaskEndTime: {
              type: "timestamp"
            },
            S3Bucket: {},
            S3Prefix: {},
            IamRoleArn: {},
            KmsKeyId: {},
            Status: {},
            PercentProgress: {
              type: "integer"
            },
            TotalExtractedDataInGB: {
              type: "integer"
            },
            FailureCause: {},
            WarningMessage: {},
            SourceType: {}
          }
        },
        Sv: {
          type: "list",
          member: {}
        },
        S10: {
          type: "structure",
          members: {
            DBClusterParameterGroupName: {},
            DBParameterGroupFamily: {},
            Description: {},
            DBClusterParameterGroupArn: {}
          },
          wrapper: true
        },
        S13: {
          type: "structure",
          members: {
            AvailabilityZones: {
              shape: "S14"
            },
            DBClusterSnapshotIdentifier: {},
            DBClusterIdentifier: {},
            SnapshotCreateTime: {
              type: "timestamp"
            },
            Engine: {},
            EngineMode: {},
            AllocatedStorage: {
              type: "integer"
            },
            Status: {},
            Port: {
              type: "integer"
            },
            VpcId: {},
            ClusterCreateTime: {
              type: "timestamp"
            },
            MasterUsername: {},
            EngineVersion: {},
            LicenseModel: {},
            SnapshotType: {},
            PercentProgress: {
              type: "integer"
            },
            StorageEncrypted: {
              type: "boolean"
            },
            KmsKeyId: {},
            DBClusterSnapshotArn: {},
            SourceDBClusterSnapshotArn: {},
            IAMDatabaseAuthenticationEnabled: {
              type: "boolean"
            },
            TagList: {
              shape: "Sb"
            },
            DBSystemId: {},
            StorageType: {},
            DbClusterResourceId: {}
          },
          wrapper: true
        },
        S14: {
          type: "list",
          member: {
            locationName: "AvailabilityZone"
          }
        },
        S17: {
          type: "structure",
          members: {
            DBParameterGroupName: {},
            DBParameterGroupFamily: {},
            Description: {},
            DBParameterGroupArn: {}
          },
          wrapper: true
        },
        S1a: {
          type: "structure",
          members: {
            DBSnapshotIdentifier: {},
            DBInstanceIdentifier: {},
            SnapshotCreateTime: {
              type: "timestamp"
            },
            Engine: {},
            AllocatedStorage: {
              type: "integer"
            },
            Status: {},
            Port: {
              type: "integer"
            },
            AvailabilityZone: {},
            VpcId: {},
            InstanceCreateTime: {
              type: "timestamp"
            },
            MasterUsername: {},
            EngineVersion: {},
            LicenseModel: {},
            SnapshotType: {},
            Iops: {
              type: "integer"
            },
            OptionGroupName: {},
            PercentProgress: {
              type: "integer"
            },
            SourceRegion: {},
            SourceDBSnapshotIdentifier: {},
            StorageType: {},
            TdeCredentialArn: {},
            Encrypted: {
              type: "boolean"
            },
            KmsKeyId: {},
            DBSnapshotArn: {},
            Timezone: {},
            IAMDatabaseAuthenticationEnabled: {
              type: "boolean"
            },
            ProcessorFeatures: {
              shape: "S1c"
            },
            DbiResourceId: {},
            TagList: {
              shape: "Sb"
            },
            OriginalSnapshotCreateTime: {
              type: "timestamp"
            },
            SnapshotDatabaseTime: {
              type: "timestamp"
            },
            SnapshotTarget: {},
            StorageThroughput: {
              type: "integer"
            },
            DBSystemId: {},
            DedicatedLogVolume: {
              type: "boolean"
            },
            MultiTenant: {
              type: "boolean"
            }
          },
          wrapper: true
        },
        S1c: {
          type: "list",
          member: {
            locationName: "ProcessorFeature",
            type: "structure",
            members: {
              Name: {},
              Value: {}
            }
          }
        },
        S1g: {
          type: "structure",
          members: {
            OptionGroupName: {},
            OptionGroupDescription: {},
            EngineName: {},
            MajorEngineVersion: {},
            Options: {
              type: "list",
              member: {
                locationName: "Option",
                type: "structure",
                members: {
                  OptionName: {},
                  OptionDescription: {},
                  Persistent: {
                    type: "boolean"
                  },
                  Permanent: {
                    type: "boolean"
                  },
                  Port: {
                    type: "integer"
                  },
                  OptionVersion: {},
                  OptionSettings: {
                    type: "list",
                    member: {
                      shape: "S1k",
                      locationName: "OptionSetting"
                    }
                  },
                  DBSecurityGroupMemberships: {
                    shape: "S1l"
                  },
                  VpcSecurityGroupMemberships: {
                    shape: "S1n"
                  }
                }
              }
            },
            AllowsVpcAndNonVpcInstanceMemberships: {
              type: "boolean"
            },
            VpcId: {},
            OptionGroupArn: {},
            SourceOptionGroup: {},
            SourceAccountId: {},
            CopyTimestamp: {
              type: "timestamp"
            }
          },
          wrapper: true
        },
        S1k: {
          type: "structure",
          members: {
            Name: {},
            Value: {},
            DefaultValue: {},
            Description: {},
            ApplyType: {},
            DataType: {},
            AllowedValues: {},
            IsModifiable: {
              type: "boolean"
            },
            IsCollection: {
              type: "boolean"
            }
          }
        },
        S1l: {
          type: "list",
          member: {
            locationName: "DBSecurityGroup",
            type: "structure",
            members: {
              DBSecurityGroupName: {},
              Status: {}
            }
          }
        },
        S1n: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroupMembership",
            type: "structure",
            members: {
              VpcSecurityGroupId: {},
              Status: {}
            }
          }
        },
        S1x: {
          type: "structure",
          members: {
            BlueGreenDeploymentIdentifier: {},
            BlueGreenDeploymentName: {},
            Source: {},
            Target: {},
            SwitchoverDetails: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  SourceMember: {},
                  TargetMember: {},
                  Status: {}
                }
              }
            },
            Tasks: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Name: {},
                  Status: {}
                }
              }
            },
            Status: {},
            StatusDetails: {},
            CreateTime: {
              type: "timestamp"
            },
            DeleteTime: {
              type: "timestamp"
            },
            TagList: {
              shape: "Sb"
            }
          }
        },
        S2g: {
          type: "structure",
          members: {
            Engine: {},
            EngineVersion: {},
            DBParameterGroupFamily: {},
            DBEngineDescription: {},
            DBEngineVersionDescription: {},
            DefaultCharacterSet: {
              shape: "S2h"
            },
            Image: {
              type: "structure",
              members: {
                ImageId: {},
                Status: {}
              }
            },
            DBEngineMediaType: {},
            SupportedCharacterSets: {
              shape: "S2j"
            },
            SupportedNcharCharacterSets: {
              shape: "S2j"
            },
            ValidUpgradeTarget: {
              type: "list",
              member: {
                locationName: "UpgradeTarget",
                type: "structure",
                members: {
                  Engine: {},
                  EngineVersion: {},
                  Description: {},
                  AutoUpgrade: {
                    type: "boolean"
                  },
                  IsMajorVersionUpgrade: {
                    type: "boolean"
                  },
                  SupportedEngineModes: {
                    shape: "S2m"
                  },
                  SupportsParallelQuery: {
                    type: "boolean"
                  },
                  SupportsGlobalDatabases: {
                    type: "boolean"
                  },
                  SupportsBabelfish: {
                    type: "boolean"
                  },
                  SupportsLocalWriteForwarding: {
                    type: "boolean"
                  },
                  SupportsIntegrations: {
                    type: "boolean"
                  }
                }
              }
            },
            SupportedTimezones: {
              type: "list",
              member: {
                locationName: "Timezone",
                type: "structure",
                members: {
                  TimezoneName: {}
                }
              }
            },
            ExportableLogTypes: {
              shape: "S2p"
            },
            SupportsLogExportsToCloudwatchLogs: {
              type: "boolean"
            },
            SupportsReadReplica: {
              type: "boolean"
            },
            SupportedEngineModes: {
              shape: "S2m"
            },
            SupportedFeatureNames: {
              type: "list",
              member: {}
            },
            Status: {},
            SupportsParallelQuery: {
              type: "boolean"
            },
            SupportsGlobalDatabases: {
              type: "boolean"
            },
            MajorEngineVersion: {},
            DatabaseInstallationFilesS3BucketName: {},
            DatabaseInstallationFilesS3Prefix: {},
            DBEngineVersionArn: {},
            KMSKeyId: {},
            CreateTime: {
              type: "timestamp"
            },
            TagList: {
              shape: "Sb"
            },
            SupportsBabelfish: {
              type: "boolean"
            },
            CustomDBEngineVersionManifest: {},
            SupportsCertificateRotationWithoutRestart: {
              type: "boolean"
            },
            SupportedCACertificateIdentifiers: {
              type: "list",
              member: {}
            },
            SupportsLocalWriteForwarding: {
              type: "boolean"
            },
            SupportsIntegrations: {
              type: "boolean"
            }
          }
        },
        S2h: {
          type: "structure",
          members: {
            CharacterSetName: {},
            CharacterSetDescription: {}
          }
        },
        S2j: {
          type: "list",
          member: {
            shape: "S2h",
            locationName: "CharacterSet"
          }
        },
        S2m: {
          type: "list",
          member: {}
        },
        S2p: {
          type: "list",
          member: {}
        },
        S2t: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroupId"
          }
        },
        S2v: {
          type: "structure",
          members: {
            MinCapacity: {
              type: "integer"
            },
            MaxCapacity: {
              type: "integer"
            },
            AutoPause: {
              type: "boolean"
            },
            SecondsUntilAutoPause: {
              type: "integer"
            },
            TimeoutAction: {},
            SecondsBeforeTimeout: {
              type: "integer"
            }
          }
        },
        S2w: {
          type: "structure",
          members: {
            InterconnectSubnetId: {},
            TransitGatewayMulticastDomainId: {},
            ReplicaMode: {}
          }
        },
        S2y: {
          type: "structure",
          members: {
            MinCapacity: {
              type: "double"
            },
            MaxCapacity: {
              type: "double"
            }
          }
        },
        S31: {
          type: "structure",
          members: {
            AllocatedStorage: {
              type: "integer"
            },
            AvailabilityZones: {
              shape: "S14"
            },
            BackupRetentionPeriod: {
              type: "integer"
            },
            CharacterSetName: {},
            DatabaseName: {},
            DBClusterIdentifier: {},
            DBClusterParameterGroup: {},
            DBSubnetGroup: {},
            Status: {},
            AutomaticRestartTime: {
              type: "timestamp"
            },
            PercentProgress: {},
            EarliestRestorableTime: {
              type: "timestamp"
            },
            Endpoint: {},
            ReaderEndpoint: {},
            CustomEndpoints: {
              shape: "Sv"
            },
            MultiAZ: {
              type: "boolean"
            },
            Engine: {},
            EngineVersion: {},
            LatestRestorableTime: {
              type: "timestamp"
            },
            Port: {
              type: "integer"
            },
            MasterUsername: {},
            DBClusterOptionGroupMemberships: {
              type: "list",
              member: {
                locationName: "DBClusterOptionGroup",
                type: "structure",
                members: {
                  DBClusterOptionGroupName: {},
                  Status: {}
                }
              }
            },
            PreferredBackupWindow: {},
            PreferredMaintenanceWindow: {},
            ReplicationSourceIdentifier: {},
            ReadReplicaIdentifiers: {
              type: "list",
              member: {
                locationName: "ReadReplicaIdentifier"
              }
            },
            StatusInfos: {
              type: "list",
              member: {
                locationName: "DBClusterStatusInfo",
                type: "structure",
                members: {
                  StatusType: {},
                  Normal: {
                    type: "boolean"
                  },
                  Status: {},
                  Message: {}
                }
              }
            },
            DBClusterMembers: {
              type: "list",
              member: {
                locationName: "DBClusterMember",
                type: "structure",
                members: {
                  DBInstanceIdentifier: {},
                  IsClusterWriter: {
                    type: "boolean"
                  },
                  DBClusterParameterGroupStatus: {},
                  PromotionTier: {
                    type: "integer"
                  }
                },
                wrapper: true
              }
            },
            VpcSecurityGroups: {
              shape: "S1n"
            },
            HostedZoneId: {},
            StorageEncrypted: {
              type: "boolean"
            },
            KmsKeyId: {},
            DbClusterResourceId: {},
            DBClusterArn: {},
            AssociatedRoles: {
              type: "list",
              member: {
                locationName: "DBClusterRole",
                type: "structure",
                members: {
                  RoleArn: {},
                  Status: {},
                  FeatureName: {}
                }
              }
            },
            IAMDatabaseAuthenticationEnabled: {
              type: "boolean"
            },
            CloneGroupId: {},
            ClusterCreateTime: {
              type: "timestamp"
            },
            EarliestBacktrackTime: {
              type: "timestamp"
            },
            BacktrackWindow: {
              type: "long"
            },
            BacktrackConsumedChangeRecords: {
              type: "long"
            },
            EnabledCloudwatchLogsExports: {
              shape: "S2p"
            },
            Capacity: {
              type: "integer"
            },
            EngineMode: {},
            ScalingConfigurationInfo: {
              type: "structure",
              members: {
                MinCapacity: {
                  type: "integer"
                },
                MaxCapacity: {
                  type: "integer"
                },
                AutoPause: {
                  type: "boolean"
                },
                SecondsUntilAutoPause: {
                  type: "integer"
                },
                TimeoutAction: {},
                SecondsBeforeTimeout: {
                  type: "integer"
                }
              }
            },
            RdsCustomClusterConfiguration: {
              shape: "S2w"
            },
            DeletionProtection: {
              type: "boolean"
            },
            HttpEndpointEnabled: {
              type: "boolean"
            },
            ActivityStreamMode: {},
            ActivityStreamStatus: {},
            ActivityStreamKmsKeyId: {},
            ActivityStreamKinesisStreamName: {},
            CopyTagsToSnapshot: {
              type: "boolean"
            },
            CrossAccountClone: {
              type: "boolean"
            },
            DomainMemberships: {
              shape: "S3e"
            },
            TagList: {
              shape: "Sb"
            },
            GlobalWriteForwardingStatus: {},
            GlobalWriteForwardingRequested: {
              type: "boolean"
            },
            PendingModifiedValues: {
              type: "structure",
              members: {
                PendingCloudwatchLogsExports: {
                  shape: "S3i"
                },
                DBClusterIdentifier: {},
                MasterUserPassword: {},
                IAMDatabaseAuthenticationEnabled: {
                  type: "boolean"
                },
                EngineVersion: {},
                BackupRetentionPeriod: {
                  type: "integer"
                },
                AllocatedStorage: {
                  type: "integer"
                },
                RdsCustomClusterConfiguration: {
                  shape: "S2w"
                },
                Iops: {
                  type: "integer"
                },
                StorageType: {}
              }
            },
            DBClusterInstanceClass: {},
            StorageType: {},
            Iops: {
              type: "integer"
            },
            PubliclyAccessible: {
              type: "boolean"
            },
            AutoMinorVersionUpgrade: {
              type: "boolean"
            },
            MonitoringInterval: {
              type: "integer"
            },
            MonitoringRoleArn: {},
            PerformanceInsightsEnabled: {
              type: "boolean"
            },
            PerformanceInsightsKMSKeyId: {},
            PerformanceInsightsRetentionPeriod: {
              type: "integer"
            },
            ServerlessV2ScalingConfiguration: {
              type: "structure",
              members: {
                MinCapacity: {
                  type: "double"
                },
                MaxCapacity: {
                  type: "double"
                }
              }
            },
            NetworkType: {},
            DBSystemId: {},
            MasterUserSecret: {
              shape: "S3k"
            },
            IOOptimizedNextAllowedModificationTime: {
              type: "timestamp"
            },
            LocalWriteForwardingStatus: {},
            AwsBackupRecoveryPointArn: {}
          },
          wrapper: true
        },
        S3e: {
          type: "list",
          member: {
            locationName: "DomainMembership",
            type: "structure",
            members: {
              Domain: {},
              Status: {},
              FQDN: {},
              IAMRoleName: {},
              OU: {},
              AuthSecretArn: {},
              DnsIps: {
                shape: "Sv"
              }
            }
          }
        },
        S3i: {
          type: "structure",
          members: {
            LogTypesToEnable: {
              shape: "S2p"
            },
            LogTypesToDisable: {
              shape: "S2p"
            }
          }
        },
        S3k: {
          type: "structure",
          members: {
            SecretArn: {},
            SecretStatus: {},
            KmsKeyId: {}
          }
        },
        S3n: {
          type: "structure",
          members: {
            DBClusterEndpointIdentifier: {},
            DBClusterIdentifier: {},
            DBClusterEndpointResourceIdentifier: {},
            Endpoint: {},
            Status: {},
            EndpointType: {},
            CustomEndpointType: {},
            StaticMembers: {
              shape: "Sv"
            },
            ExcludedMembers: {
              shape: "Sv"
            },
            DBClusterEndpointArn: {}
          }
        },
        S3t: {
          type: "list",
          member: {
            locationName: "DBSecurityGroupName"
          }
        },
        S3v: {
          type: "structure",
          members: {
            DBInstanceIdentifier: {},
            DBInstanceClass: {},
            Engine: {},
            DBInstanceStatus: {},
            AutomaticRestartTime: {
              type: "timestamp"
            },
            MasterUsername: {},
            DBName: {},
            Endpoint: {
              shape: "S3w"
            },
            AllocatedStorage: {
              type: "integer"
            },
            InstanceCreateTime: {
              type: "timestamp"
            },
            PreferredBackupWindow: {},
            BackupRetentionPeriod: {
              type: "integer"
            },
            DBSecurityGroups: {
              shape: "S1l"
            },
            VpcSecurityGroups: {
              shape: "S1n"
            },
            DBParameterGroups: {
              type: "list",
              member: {
                locationName: "DBParameterGroup",
                type: "structure",
                members: {
                  DBParameterGroupName: {},
                  ParameterApplyStatus: {}
                }
              }
            },
            AvailabilityZone: {},
            DBSubnetGroup: {
              shape: "S3z"
            },
            PreferredMaintenanceWindow: {},
            PendingModifiedValues: {
              type: "structure",
              members: {
                DBInstanceClass: {},
                AllocatedStorage: {
                  type: "integer"
                },
                MasterUserPassword: {},
                Port: {
                  type: "integer"
                },
                BackupRetentionPeriod: {
                  type: "integer"
                },
                MultiAZ: {
                  type: "boolean"
                },
                EngineVersion: {},
                LicenseModel: {},
                Iops: {
                  type: "integer"
                },
                DBInstanceIdentifier: {},
                StorageType: {},
                CACertificateIdentifier: {},
                DBSubnetGroupName: {},
                PendingCloudwatchLogsExports: {
                  shape: "S3i"
                },
                ProcessorFeatures: {
                  shape: "S1c"
                },
                IAMDatabaseAuthenticationEnabled: {
                  type: "boolean"
                },
                AutomationMode: {},
                ResumeFullAutomationModeTime: {
                  type: "timestamp"
                },
                StorageThroughput: {
                  type: "integer"
                },
                Engine: {},
                DedicatedLogVolume: {
                  type: "boolean"
                },
                MultiTenant: {
                  type: "boolean"
                }
              }
            },
            LatestRestorableTime: {
              type: "timestamp"
            },
            MultiAZ: {
              type: "boolean"
            },
            EngineVersion: {},
            AutoMinorVersionUpgrade: {
              type: "boolean"
            },
            ReadReplicaSourceDBInstanceIdentifier: {},
            ReadReplicaDBInstanceIdentifiers: {
              type: "list",
              member: {
                locationName: "ReadReplicaDBInstanceIdentifier"
              }
            },
            ReadReplicaDBClusterIdentifiers: {
              type: "list",
              member: {
                locationName: "ReadReplicaDBClusterIdentifier"
              }
            },
            ReplicaMode: {},
            LicenseModel: {},
            Iops: {
              type: "integer"
            },
            OptionGroupMemberships: {
              type: "list",
              member: {
                locationName: "OptionGroupMembership",
                type: "structure",
                members: {
                  OptionGroupName: {},
                  Status: {}
                }
              }
            },
            CharacterSetName: {},
            NcharCharacterSetName: {},
            SecondaryAvailabilityZone: {},
            PubliclyAccessible: {
              type: "boolean"
            },
            StatusInfos: {
              type: "list",
              member: {
                locationName: "DBInstanceStatusInfo",
                type: "structure",
                members: {
                  StatusType: {},
                  Normal: {
                    type: "boolean"
                  },
                  Status: {},
                  Message: {}
                }
              }
            },
            StorageType: {},
            TdeCredentialArn: {},
            DbInstancePort: {
              type: "integer"
            },
            DBClusterIdentifier: {},
            StorageEncrypted: {
              type: "boolean"
            },
            KmsKeyId: {},
            DbiResourceId: {},
            CACertificateIdentifier: {},
            DomainMemberships: {
              shape: "S3e"
            },
            CopyTagsToSnapshot: {
              type: "boolean"
            },
            MonitoringInterval: {
              type: "integer"
            },
            EnhancedMonitoringResourceArn: {},
            MonitoringRoleArn: {},
            PromotionTier: {
              type: "integer"
            },
            DBInstanceArn: {},
            Timezone: {},
            IAMDatabaseAuthenticationEnabled: {
              type: "boolean"
            },
            PerformanceInsightsEnabled: {
              type: "boolean"
            },
            PerformanceInsightsKMSKeyId: {},
            PerformanceInsightsRetentionPeriod: {
              type: "integer"
            },
            EnabledCloudwatchLogsExports: {
              shape: "S2p"
            },
            ProcessorFeatures: {
              shape: "S1c"
            },
            DeletionProtection: {
              type: "boolean"
            },
            AssociatedRoles: {
              type: "list",
              member: {
                locationName: "DBInstanceRole",
                type: "structure",
                members: {
                  RoleArn: {},
                  FeatureName: {},
                  Status: {}
                }
              }
            },
            ListenerEndpoint: {
              shape: "S3w"
            },
            MaxAllocatedStorage: {
              type: "integer"
            },
            TagList: {
              shape: "Sb"
            },
            DBInstanceAutomatedBackupsReplications: {
              shape: "S4e"
            },
            CustomerOwnedIpEnabled: {
              type: "boolean"
            },
            AwsBackupRecoveryPointArn: {},
            ActivityStreamStatus: {},
            ActivityStreamKmsKeyId: {},
            ActivityStreamKinesisStreamName: {},
            ActivityStreamMode: {},
            ActivityStreamEngineNativeAuditFieldsIncluded: {
              type: "boolean"
            },
            AutomationMode: {},
            ResumeFullAutomationModeTime: {
              type: "timestamp"
            },
            CustomIamInstanceProfile: {},
            BackupTarget: {},
            NetworkType: {},
            ActivityStreamPolicyStatus: {},
            StorageThroughput: {
              type: "integer"
            },
            DBSystemId: {},
            MasterUserSecret: {
              shape: "S3k"
            },
            CertificateDetails: {
              type: "structure",
              members: {
                CAIdentifier: {},
                ValidTill: {
                  type: "timestamp"
                }
              }
            },
            ReadReplicaSourceDBClusterIdentifier: {},
            PercentProgress: {},
            DedicatedLogVolume: {
              type: "boolean"
            },
            IsStorageConfigUpgradeAvailable: {
              type: "boolean"
            },
            MultiTenant: {
              type: "boolean"
            }
          },
          wrapper: true
        },
        S3w: {
          type: "structure",
          members: {
            Address: {},
            Port: {
              type: "integer"
            },
            HostedZoneId: {}
          }
        },
        S3z: {
          type: "structure",
          members: {
            DBSubnetGroupName: {},
            DBSubnetGroupDescription: {},
            VpcId: {},
            SubnetGroupStatus: {},
            Subnets: {
              type: "list",
              member: {
                locationName: "Subnet",
                type: "structure",
                members: {
                  SubnetIdentifier: {},
                  SubnetAvailabilityZone: {
                    shape: "S42"
                  },
                  SubnetOutpost: {
                    type: "structure",
                    members: {
                      Arn: {}
                    }
                  },
                  SubnetStatus: {}
                }
              }
            },
            DBSubnetGroupArn: {},
            SupportedNetworkTypes: {
              shape: "Sv"
            }
          },
          wrapper: true
        },
        S42: {
          type: "structure",
          members: {
            Name: {}
          },
          wrapper: true
        },
        S4e: {
          type: "list",
          member: {
            locationName: "DBInstanceAutomatedBackupsReplication",
            type: "structure",
            members: {
              DBInstanceAutomatedBackupsArn: {}
            }
          }
        },
        S4o: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Description: {},
              UserName: {},
              AuthScheme: {},
              SecretArn: {},
              IAMAuth: {},
              ClientPasswordAuthType: {}
            }
          }
        },
        S4u: {
          type: "structure",
          members: {
            DBProxyName: {},
            DBProxyArn: {},
            Status: {},
            EngineFamily: {},
            VpcId: {},
            VpcSecurityGroupIds: {
              shape: "Sv"
            },
            VpcSubnetIds: {
              shape: "Sv"
            },
            Auth: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Description: {},
                  UserName: {},
                  AuthScheme: {},
                  SecretArn: {},
                  IAMAuth: {},
                  ClientPasswordAuthType: {}
                }
              }
            },
            RoleArn: {},
            Endpoint: {},
            RequireTLS: {
              type: "boolean"
            },
            IdleClientTimeout: {
              type: "integer"
            },
            DebugLogging: {
              type: "boolean"
            },
            CreatedDate: {
              type: "timestamp"
            },
            UpdatedDate: {
              type: "timestamp"
            }
          }
        },
        S53: {
          type: "structure",
          members: {
            DBProxyEndpointName: {},
            DBProxyEndpointArn: {},
            DBProxyName: {},
            Status: {},
            VpcId: {},
            VpcSecurityGroupIds: {
              shape: "Sv"
            },
            VpcSubnetIds: {
              shape: "Sv"
            },
            Endpoint: {},
            CreatedDate: {
              type: "timestamp"
            },
            TargetRole: {},
            IsDefault: {
              type: "boolean"
            }
          }
        },
        S5a: {
          type: "list",
          member: {
            locationName: "SubnetIdentifier"
          }
        },
        S5g: {
          type: "structure",
          members: {
            GlobalClusterIdentifier: {},
            GlobalClusterResourceId: {},
            GlobalClusterArn: {},
            Status: {},
            Engine: {},
            EngineVersion: {},
            DatabaseName: {},
            StorageEncrypted: {
              type: "boolean"
            },
            DeletionProtection: {
              type: "boolean"
            },
            GlobalClusterMembers: {
              type: "list",
              member: {
                locationName: "GlobalClusterMember",
                type: "structure",
                members: {
                  DBClusterArn: {},
                  Readers: {
                    type: "list",
                    member: {}
                  },
                  IsWriter: {
                    type: "boolean"
                  },
                  GlobalWriteForwardingStatus: {},
                  SynchronizationStatus: {}
                },
                wrapper: true
              }
            },
            FailoverState: {
              type: "structure",
              members: {
                Status: {},
                FromDbClusterArn: {},
                ToDbClusterArn: {},
                IsDataLossAllowed: {
                  type: "boolean"
                }
              },
              wrapper: true
            }
          },
          wrapper: true
        },
        S5r: {
          type: "map",
          key: {},
          value: {}
        },
        S5s: {
          type: "structure",
          members: {
            SourceArn: {},
            TargetArn: {},
            IntegrationName: {},
            IntegrationArn: {},
            KMSKeyId: {},
            AdditionalEncryptionContext: {
              shape: "S5r"
            },
            Status: {},
            Tags: {
              shape: "Sb"
            },
            CreateTime: {
              type: "timestamp"
            },
            Errors: {
              type: "list",
              member: {
                locationName: "IntegrationError",
                type: "structure",
                required: [
                  "ErrorCode"
                ],
                members: {
                  ErrorCode: {},
                  ErrorMessage: {}
                }
              }
            }
          }
        },
        S60: {
          type: "string",
          sensitive: true
        },
        S62: {
          type: "structure",
          members: {
            TenantDatabaseCreateTime: {
              type: "timestamp"
            },
            DBInstanceIdentifier: {},
            TenantDBName: {},
            Status: {},
            MasterUsername: {},
            DbiResourceId: {},
            TenantDatabaseResourceId: {},
            TenantDatabaseARN: {},
            CharacterSetName: {},
            NcharCharacterSetName: {},
            DeletionProtection: {
              type: "boolean"
            },
            PendingModifiedValues: {
              type: "structure",
              members: {
                MasterUserPassword: {
                  shape: "S60"
                },
                TenantDBName: {}
              }
            },
            TagList: {
              shape: "Sb"
            }
          },
          wrapper: true
        },
        S6b: {
          type: "structure",
          members: {
            Engine: {},
            VpcId: {},
            DBClusterAutomatedBackupsArn: {},
            DBClusterIdentifier: {},
            RestoreWindow: {
              shape: "S6c"
            },
            MasterUsername: {},
            DbClusterResourceId: {},
            Region: {},
            LicenseModel: {},
            Status: {},
            IAMDatabaseAuthenticationEnabled: {
              type: "boolean"
            },
            ClusterCreateTime: {
              type: "timestamp"
            },
            StorageEncrypted: {
              type: "boolean"
            },
            AllocatedStorage: {
              type: "integer"
            },
            EngineVersion: {},
            DBClusterArn: {},
            BackupRetentionPeriod: {
              type: "integer"
            },
            EngineMode: {},
            AvailabilityZones: {
              shape: "S14"
            },
            Port: {
              type: "integer"
            },
            KmsKeyId: {},
            StorageType: {},
            Iops: {
              type: "integer"
            },
            AwsBackupRecoveryPointArn: {}
          },
          wrapper: true
        },
        S6c: {
          type: "structure",
          members: {
            EarliestTime: {
              type: "timestamp"
            },
            LatestTime: {
              type: "timestamp"
            }
          }
        },
        S6l: {
          type: "structure",
          members: {
            DBInstanceArn: {},
            DbiResourceId: {},
            Region: {},
            DBInstanceIdentifier: {},
            RestoreWindow: {
              shape: "S6c"
            },
            AllocatedStorage: {
              type: "integer"
            },
            Status: {},
            Port: {
              type: "integer"
            },
            AvailabilityZone: {},
            VpcId: {},
            InstanceCreateTime: {
              type: "timestamp"
            },
            MasterUsername: {},
            Engine: {},
            EngineVersion: {},
            LicenseModel: {},
            Iops: {
              type: "integer"
            },
            OptionGroupName: {},
            TdeCredentialArn: {},
            Encrypted: {
              type: "boolean"
            },
            StorageType: {},
            KmsKeyId: {},
            Timezone: {},
            IAMDatabaseAuthenticationEnabled: {
              type: "boolean"
            },
            BackupRetentionPeriod: {
              type: "integer"
            },
            DBInstanceAutomatedBackupsArn: {},
            DBInstanceAutomatedBackupsReplications: {
              shape: "S4e"
            },
            BackupTarget: {},
            StorageThroughput: {
              type: "integer"
            },
            AwsBackupRecoveryPointArn: {},
            DedicatedLogVolume: {
              type: "boolean"
            },
            MultiTenant: {
              type: "boolean"
            }
          },
          wrapper: true
        },
        S7c: {
          type: "list",
          member: {
            locationName: "Filter",
            type: "structure",
            required: [
              "Name",
              "Values"
            ],
            members: {
              Name: {},
              Values: {
                type: "list",
                member: {
                  locationName: "Value"
                }
              }
            }
          }
        },
        S7l: {
          type: "structure",
          members: {
            CertificateIdentifier: {},
            CertificateType: {},
            Thumbprint: {},
            ValidFrom: {
              type: "timestamp"
            },
            ValidTill: {
              type: "timestamp"
            },
            CertificateArn: {},
            CustomerOverride: {
              type: "boolean"
            },
            CustomerOverrideValidTill: {
              type: "timestamp"
            }
          },
          wrapper: true
        },
        S80: {
          type: "list",
          member: {
            locationName: "Parameter",
            type: "structure",
            members: {
              ParameterName: {},
              ParameterValue: {},
              Description: {},
              Source: {},
              ApplyType: {},
              DataType: {},
              AllowedValues: {},
              IsModifiable: {
                type: "boolean"
              },
              MinimumEngineVersion: {},
              ApplyMethod: {},
              SupportedEngineModes: {
                shape: "S2m"
              }
            }
          }
        },
        S85: {
          type: "structure",
          members: {
            DBClusterSnapshotIdentifier: {},
            DBClusterSnapshotAttributes: {
              type: "list",
              member: {
                locationName: "DBClusterSnapshotAttribute",
                type: "structure",
                members: {
                  AttributeName: {},
                  AttributeValues: {
                    shape: "S88"
                  }
                }
              }
            }
          },
          wrapper: true
        },
        S88: {
          type: "list",
          member: {
            locationName: "AttributeValue"
          }
        },
        S96: {
          type: "structure",
          members: {
            DBProxyName: {},
            TargetGroupName: {},
            TargetGroupArn: {},
            IsDefault: {
              type: "boolean"
            },
            Status: {},
            ConnectionPoolConfig: {
              type: "structure",
              members: {
                MaxConnectionsPercent: {
                  type: "integer"
                },
                MaxIdleConnectionsPercent: {
                  type: "integer"
                },
                ConnectionBorrowTimeout: {
                  type: "integer"
                },
                SessionPinningFilters: {
                  shape: "Sv"
                },
                InitQuery: {}
              }
            },
            CreatedDate: {
              type: "timestamp"
            },
            UpdatedDate: {
              type: "timestamp"
            }
          }
        },
        S9a: {
          type: "list",
          member: {
            type: "structure",
            members: {
              TargetArn: {},
              Endpoint: {},
              TrackedClusterId: {},
              RdsResourceId: {},
              Port: {
                type: "integer"
              },
              Type: {},
              Role: {},
              TargetHealth: {
                type: "structure",
                members: {
                  State: {},
                  Reason: {},
                  Description: {}
                }
              }
            }
          }
        },
        S9k: {
          type: "structure",
          members: {
            RecommendationId: {},
            TypeId: {},
            Severity: {},
            ResourceArn: {},
            Status: {},
            CreatedTime: {
              type: "timestamp"
            },
            UpdatedTime: {
              type: "timestamp"
            },
            Detection: {},
            Recommendation: {},
            Description: {},
            Reason: {},
            RecommendedActions: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  ActionId: {},
                  Title: {},
                  Description: {},
                  Operation: {},
                  Parameters: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Key: {},
                        Value: {}
                      }
                    }
                  },
                  ApplyModes: {
                    shape: "Sv"
                  },
                  Status: {},
                  IssueDetails: {
                    shape: "S9p"
                  },
                  ContextAttributes: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Key: {},
                        Value: {}
                      }
                    }
                  }
                }
              }
            },
            Category: {},
            Source: {},
            TypeDetection: {},
            TypeRecommendation: {},
            Impact: {},
            AdditionalInfo: {},
            Links: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Text: {},
                  Url: {}
                }
              }
            },
            IssueDetails: {
              shape: "S9p"
            }
          }
        },
        S9p: {
          type: "structure",
          members: {
            PerformanceIssueDetails: {
              type: "structure",
              members: {
                StartTime: {
                  type: "timestamp"
                },
                EndTime: {
                  type: "timestamp"
                },
                Metrics: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      Name: {},
                      References: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            Name: {},
                            ReferenceDetails: {
                              type: "structure",
                              members: {
                                ScalarReferenceDetails: {
                                  type: "structure",
                                  members: {
                                    Value: {
                                      type: "double"
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      },
                      StatisticsDetails: {},
                      MetricQuery: {
                        type: "structure",
                        members: {
                          PerformanceInsightsMetricQuery: {
                            type: "structure",
                            members: {
                              GroupBy: {
                                type: "structure",
                                members: {
                                  Dimensions: {
                                    shape: "Sv"
                                  },
                                  Group: {},
                                  Limit: {
                                    type: "integer"
                                  }
                                }
                              },
                              Metric: {}
                            }
                          }
                        }
                      }
                    }
                  }
                },
                Analysis: {}
              }
            }
          }
        },
        Saa: {
          type: "structure",
          members: {
            DBSnapshotIdentifier: {},
            DBSnapshotAttributes: {
              type: "list",
              member: {
                locationName: "DBSnapshotAttribute",
                type: "structure",
                members: {
                  AttributeName: {},
                  AttributeValues: {
                    shape: "S88"
                  }
                },
                wrapper: true
              }
            }
          },
          wrapper: true
        },
        Sap: {
          type: "structure",
          members: {
            DBParameterGroupFamily: {},
            Marker: {},
            Parameters: {
              shape: "S80"
            }
          },
          wrapper: true
        },
        Sby: {
          type: "list",
          member: {
            locationName: "AvailableProcessorFeature",
            type: "structure",
            members: {
              Name: {},
              DefaultValue: {},
              AllowedValues: {}
            }
          }
        },
        Sc7: {
          type: "structure",
          members: {
            ReservedDBInstanceId: {},
            ReservedDBInstancesOfferingId: {},
            DBInstanceClass: {},
            StartTime: {
              type: "timestamp"
            },
            Duration: {
              type: "integer"
            },
            FixedPrice: {
              type: "double"
            },
            UsagePrice: {
              type: "double"
            },
            CurrencyCode: {},
            DBInstanceCount: {
              type: "integer"
            },
            ProductDescription: {},
            OfferingType: {},
            MultiAZ: {
              type: "boolean"
            },
            State: {},
            RecurringCharges: {
              shape: "Sc8"
            },
            ReservedDBInstanceArn: {},
            LeaseId: {}
          },
          wrapper: true
        },
        Sc8: {
          type: "list",
          member: {
            locationName: "RecurringCharge",
            type: "structure",
            members: {
              RecurringChargeAmount: {
                type: "double"
              },
              RecurringChargeFrequency: {}
            },
            wrapper: true
          }
        },
        Scq: {
          type: "list",
          member: {
            locationName: "Range",
            type: "structure",
            members: {
              From: {
                type: "integer"
              },
              To: {
                type: "integer"
              },
              Step: {
                type: "integer"
              }
            }
          }
        },
        Scs: {
          type: "list",
          member: {
            locationName: "DoubleRange",
            type: "structure",
            members: {
              From: {
                type: "double"
              },
              To: {
                type: "double"
              }
            }
          }
        },
        Sdi: {
          type: "structure",
          members: {
            EnableLogTypes: {
              shape: "S2p"
            },
            DisableLogTypes: {
              shape: "S2p"
            }
          }
        },
        Sdn: {
          type: "structure",
          members: {
            DBClusterParameterGroupName: {}
          }
        },
        Sdt: {
          type: "structure",
          members: {
            DBParameterGroupName: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/rds-2014-10-31.paginators.json
var require_rds_2014_10_31_paginators = __commonJS({
  "node_modules/aws-sdk/apis/rds-2014-10-31.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeBlueGreenDeployments: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "BlueGreenDeployments"
        },
        DescribeCertificates: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Certificates"
        },
        DescribeDBClusterAutomatedBackups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBClusterAutomatedBackups"
        },
        DescribeDBClusterBacktracks: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBClusterBacktracks"
        },
        DescribeDBClusterEndpoints: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBClusterEndpoints"
        },
        DescribeDBClusterParameterGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBClusterParameterGroups"
        },
        DescribeDBClusterParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Parameters"
        },
        DescribeDBClusterSnapshots: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBClusterSnapshots"
        },
        DescribeDBClusters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBClusters"
        },
        DescribeDBEngineVersions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBEngineVersions"
        },
        DescribeDBInstanceAutomatedBackups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBInstanceAutomatedBackups"
        },
        DescribeDBInstances: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBInstances"
        },
        DescribeDBLogFiles: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DescribeDBLogFiles"
        },
        DescribeDBParameterGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBParameterGroups"
        },
        DescribeDBParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Parameters"
        },
        DescribeDBProxies: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBProxies"
        },
        DescribeDBProxyEndpoints: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBProxyEndpoints"
        },
        DescribeDBProxyTargetGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "TargetGroups"
        },
        DescribeDBProxyTargets: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Targets"
        },
        DescribeDBRecommendations: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBRecommendations"
        },
        DescribeDBSecurityGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBSecurityGroups"
        },
        DescribeDBSnapshotTenantDatabases: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBSnapshotTenantDatabases"
        },
        DescribeDBSnapshots: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBSnapshots"
        },
        DescribeDBSubnetGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBSubnetGroups"
        },
        DescribeEngineDefaultParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "EngineDefaults.Marker",
          result_key: "EngineDefaults.Parameters"
        },
        DescribeEventSubscriptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "EventSubscriptionsList"
        },
        DescribeEvents: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Events"
        },
        DescribeExportTasks: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ExportTasks"
        },
        DescribeGlobalClusters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "GlobalClusters"
        },
        DescribeIntegrations: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Integrations"
        },
        DescribeOptionGroupOptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "OptionGroupOptions"
        },
        DescribeOptionGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "OptionGroupsList"
        },
        DescribeOrderableDBInstanceOptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "OrderableDBInstanceOptions"
        },
        DescribePendingMaintenanceActions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "PendingMaintenanceActions"
        },
        DescribeReservedDBInstances: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ReservedDBInstances"
        },
        DescribeReservedDBInstancesOfferings: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ReservedDBInstancesOfferings"
        },
        DescribeSourceRegions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "SourceRegions"
        },
        DescribeTenantDatabases: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "TenantDatabases"
        },
        DownloadDBLogFilePortion: {
          input_token: "Marker",
          limit_key: "NumberOfLines",
          more_results: "AdditionalDataPending",
          output_token: "Marker",
          result_key: "LogFileData"
        },
        ListTagsForResource: {
          result_key: "TagList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/rds-2014-10-31.waiters2.json
var require_rds_2014_10_31_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/rds-2014-10-31.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        DBInstanceAvailable: {
          delay: 30,
          operation: "DescribeDBInstances",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "available",
              matcher: "pathAll",
              state: "success",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "deleted",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "deleting",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "failed",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "incompatible-restore",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "incompatible-parameters",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            }
          ]
        },
        DBInstanceDeleted: {
          delay: 30,
          operation: "DescribeDBInstances",
          maxAttempts: 60,
          acceptors: [
            {
              expected: true,
              matcher: "path",
              state: "success",
              argument: "length(DBInstances) == `0`"
            },
            {
              expected: "DBInstanceNotFound",
              matcher: "error",
              state: "success"
            },
            {
              expected: "creating",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "modifying",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "rebooting",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "resetting-master-credentials",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            }
          ]
        },
        DBSnapshotAvailable: {
          delay: 30,
          operation: "DescribeDBSnapshots",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "available",
              matcher: "pathAll",
              state: "success",
              argument: "DBSnapshots[].Status"
            },
            {
              expected: "deleted",
              matcher: "pathAny",
              state: "failure",
              argument: "DBSnapshots[].Status"
            },
            {
              expected: "deleting",
              matcher: "pathAny",
              state: "failure",
              argument: "DBSnapshots[].Status"
            },
            {
              expected: "failed",
              matcher: "pathAny",
              state: "failure",
              argument: "DBSnapshots[].Status"
            },
            {
              expected: "incompatible-restore",
              matcher: "pathAny",
              state: "failure",
              argument: "DBSnapshots[].Status"
            },
            {
              expected: "incompatible-parameters",
              matcher: "pathAny",
              state: "failure",
              argument: "DBSnapshots[].Status"
            }
          ]
        },
        DBSnapshotDeleted: {
          delay: 30,
          operation: "DescribeDBSnapshots",
          maxAttempts: 60,
          acceptors: [
            {
              expected: true,
              matcher: "path",
              state: "success",
              argument: "length(DBSnapshots) == `0`"
            },
            {
              expected: "DBSnapshotNotFound",
              matcher: "error",
              state: "success"
            },
            {
              expected: "creating",
              matcher: "pathAny",
              state: "failure",
              argument: "DBSnapshots[].Status"
            },
            {
              expected: "modifying",
              matcher: "pathAny",
              state: "failure",
              argument: "DBSnapshots[].Status"
            },
            {
              expected: "rebooting",
              matcher: "pathAny",
              state: "failure",
              argument: "DBSnapshots[].Status"
            },
            {
              expected: "resetting-master-credentials",
              matcher: "pathAny",
              state: "failure",
              argument: "DBSnapshots[].Status"
            }
          ]
        },
        DBClusterSnapshotAvailable: {
          delay: 30,
          operation: "DescribeDBClusterSnapshots",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "available",
              matcher: "pathAll",
              state: "success",
              argument: "DBClusterSnapshots[].Status"
            },
            {
              expected: "deleted",
              matcher: "pathAny",
              state: "failure",
              argument: "DBClusterSnapshots[].Status"
            },
            {
              expected: "deleting",
              matcher: "pathAny",
              state: "failure",
              argument: "DBClusterSnapshots[].Status"
            },
            {
              expected: "failed",
              matcher: "pathAny",
              state: "failure",
              argument: "DBClusterSnapshots[].Status"
            },
            {
              expected: "incompatible-restore",
              matcher: "pathAny",
              state: "failure",
              argument: "DBClusterSnapshots[].Status"
            },
            {
              expected: "incompatible-parameters",
              matcher: "pathAny",
              state: "failure",
              argument: "DBClusterSnapshots[].Status"
            }
          ]
        },
        DBClusterSnapshotDeleted: {
          delay: 30,
          operation: "DescribeDBClusterSnapshots",
          maxAttempts: 60,
          acceptors: [
            {
              expected: true,
              matcher: "path",
              state: "success",
              argument: "length(DBClusterSnapshots) == `0`"
            },
            {
              expected: "DBClusterSnapshotNotFoundFault",
              matcher: "error",
              state: "success"
            },
            {
              expected: "creating",
              matcher: "pathAny",
              state: "failure",
              argument: "DBClusterSnapshots[].Status"
            },
            {
              expected: "modifying",
              matcher: "pathAny",
              state: "failure",
              argument: "DBClusterSnapshots[].Status"
            },
            {
              expected: "rebooting",
              matcher: "pathAny",
              state: "failure",
              argument: "DBClusterSnapshots[].Status"
            },
            {
              expected: "resetting-master-credentials",
              matcher: "pathAny",
              state: "failure",
              argument: "DBClusterSnapshots[].Status"
            }
          ]
        },
        DBClusterAvailable: {
          delay: 30,
          operation: "DescribeDBClusters",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "available",
              matcher: "pathAll",
              state: "success",
              argument: "DBClusters[].Status"
            },
            {
              expected: "deleted",
              matcher: "pathAny",
              state: "failure",
              argument: "DBClusters[].Status"
            },
            {
              expected: "deleting",
              matcher: "pathAny",
              state: "failure",
              argument: "DBClusters[].Status"
            },
            {
              expected: "failed",
              matcher: "pathAny",
              state: "failure",
              argument: "DBClusters[].Status"
            },
            {
              expected: "incompatible-restore",
              matcher: "pathAny",
              state: "failure",
              argument: "DBClusters[].Status"
            },
            {
              expected: "incompatible-parameters",
              matcher: "pathAny",
              state: "failure",
              argument: "DBClusters[].Status"
            }
          ]
        },
        DBClusterDeleted: {
          delay: 30,
          operation: "DescribeDBClusters",
          maxAttempts: 60,
          acceptors: [
            {
              expected: true,
              matcher: "path",
              state: "success",
              argument: "length(DBClusters) == `0`"
            },
            {
              expected: "DBClusterNotFoundFault",
              matcher: "error",
              state: "success"
            },
            {
              expected: "creating",
              matcher: "pathAny",
              state: "failure",
              argument: "DBClusters[].Status"
            },
            {
              expected: "modifying",
              matcher: "pathAny",
              state: "failure",
              argument: "DBClusters[].Status"
            },
            {
              expected: "rebooting",
              matcher: "pathAny",
              state: "failure",
              argument: "DBClusters[].Status"
            },
            {
              expected: "resetting-master-credentials",
              matcher: "pathAny",
              state: "failure",
              argument: "DBClusters[].Status"
            }
          ]
        },
        TenantDatabaseAvailable: {
          delay: 30,
          operation: "DescribeTenantDatabases",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "available",
              matcher: "pathAll",
              state: "success",
              argument: "TenantDatabases[].Status"
            },
            {
              expected: "deleted",
              matcher: "pathAny",
              state: "failure",
              argument: "TenantDatabases[].Status"
            },
            {
              expected: "incompatible-parameters",
              matcher: "pathAny",
              state: "failure",
              argument: "TenantDatabases[].Status"
            },
            {
              expected: "incompatible-restore",
              matcher: "pathAny",
              state: "failure",
              argument: "TenantDatabases[].Status"
            }
          ]
        },
        TenantDatabaseDeleted: {
          delay: 30,
          operation: "DescribeTenantDatabases",
          maxAttempts: 60,
          acceptors: [
            {
              expected: true,
              matcher: "path",
              state: "success",
              argument: "length(TenantDatabases) == `0`"
            },
            {
              expected: "DBInstanceNotFoundFault",
              matcher: "error",
              state: "success"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/rds.js
var require_rds2 = __commonJS({
  "node_modules/aws-sdk/clients/rds.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["rds"] = {};
    AWS2.RDS = Service.defineService("rds", ["2013-01-10", "2013-02-12", "2013-09-09", "2014-09-01", "2014-09-01*", "2014-10-31"]);
    require_rds();
    Object.defineProperty(apiLoader.services["rds"], "2013-01-10", {
      get: function get() {
        var model = require_rds_2013_01_10_min();
        model.paginators = require_rds_2013_01_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(apiLoader.services["rds"], "2013-02-12", {
      get: function get() {
        var model = require_rds_2013_02_12_min();
        model.paginators = require_rds_2013_02_12_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(apiLoader.services["rds"], "2013-09-09", {
      get: function get() {
        var model = require_rds_2013_09_09_min();
        model.paginators = require_rds_2013_09_09_paginators().pagination;
        model.waiters = require_rds_2013_09_09_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(apiLoader.services["rds"], "2014-09-01", {
      get: function get() {
        var model = require_rds_2014_09_01_min();
        model.paginators = require_rds_2014_09_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(apiLoader.services["rds"], "2014-10-31", {
      get: function get() {
        var model = require_rds_2014_10_31_min();
        model.paginators = require_rds_2014_10_31_paginators().pagination;
        model.waiters = require_rds_2014_10_31_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.RDS;
  }
});

// node_modules/aws-sdk/apis/redshift-2012-12-01.min.json
var require_redshift_2012_12_01_min = __commonJS({
  "node_modules/aws-sdk/apis/redshift-2012-12-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2012-12-01",
        endpointPrefix: "redshift",
        protocol: "query",
        serviceFullName: "Amazon Redshift",
        serviceId: "Redshift",
        signatureVersion: "v4",
        uid: "redshift-2012-12-01",
        xmlNamespace: "http://redshift.amazonaws.com/doc/2012-12-01/"
      },
      operations: {
        AcceptReservedNodeExchange: {
          input: {
            type: "structure",
            required: [
              "ReservedNodeId",
              "TargetReservedNodeOfferingId"
            ],
            members: {
              ReservedNodeId: {},
              TargetReservedNodeOfferingId: {}
            }
          },
          output: {
            resultWrapper: "AcceptReservedNodeExchangeResult",
            type: "structure",
            members: {
              ExchangedReservedNode: {
                shape: "S4"
              }
            }
          }
        },
        AddPartner: {
          input: {
            shape: "Sb"
          },
          output: {
            shape: "Sg",
            resultWrapper: "AddPartnerResult"
          }
        },
        AssociateDataShareConsumer: {
          input: {
            type: "structure",
            required: [
              "DataShareArn"
            ],
            members: {
              DataShareArn: {},
              AssociateEntireAccount: {
                type: "boolean"
              },
              ConsumerArn: {},
              ConsumerRegion: {},
              AllowWrites: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "Sj",
            resultWrapper: "AssociateDataShareConsumerResult"
          }
        },
        AuthorizeClusterSecurityGroupIngress: {
          input: {
            type: "structure",
            required: [
              "ClusterSecurityGroupName"
            ],
            members: {
              ClusterSecurityGroupName: {},
              CIDRIP: {},
              EC2SecurityGroupName: {},
              EC2SecurityGroupOwnerId: {}
            }
          },
          output: {
            resultWrapper: "AuthorizeClusterSecurityGroupIngressResult",
            type: "structure",
            members: {
              ClusterSecurityGroup: {
                shape: "Sq"
              }
            }
          }
        },
        AuthorizeDataShare: {
          input: {
            type: "structure",
            required: [
              "DataShareArn",
              "ConsumerIdentifier"
            ],
            members: {
              DataShareArn: {},
              ConsumerIdentifier: {},
              AllowWrites: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "Sj",
            resultWrapper: "AuthorizeDataShareResult"
          }
        },
        AuthorizeEndpointAccess: {
          input: {
            type: "structure",
            required: [
              "Account"
            ],
            members: {
              ClusterIdentifier: {},
              Account: {},
              VpcIds: {
                shape: "Sz"
              }
            }
          },
          output: {
            shape: "S10",
            resultWrapper: "AuthorizeEndpointAccessResult"
          }
        },
        AuthorizeSnapshotAccess: {
          input: {
            type: "structure",
            required: [
              "AccountWithRestoreAccess"
            ],
            members: {
              SnapshotIdentifier: {},
              SnapshotArn: {},
              SnapshotClusterIdentifier: {},
              AccountWithRestoreAccess: {}
            }
          },
          output: {
            resultWrapper: "AuthorizeSnapshotAccessResult",
            type: "structure",
            members: {
              Snapshot: {
                shape: "S14"
              }
            }
          }
        },
        BatchDeleteClusterSnapshots: {
          input: {
            type: "structure",
            required: [
              "Identifiers"
            ],
            members: {
              Identifiers: {
                type: "list",
                member: {
                  shape: "S1c",
                  locationName: "DeleteClusterSnapshotMessage"
                }
              }
            }
          },
          output: {
            resultWrapper: "BatchDeleteClusterSnapshotsResult",
            type: "structure",
            members: {
              Resources: {
                shape: "S1e"
              },
              Errors: {
                type: "list",
                member: {
                  shape: "S1g",
                  locationName: "SnapshotErrorMessage"
                }
              }
            }
          }
        },
        BatchModifyClusterSnapshots: {
          input: {
            type: "structure",
            required: [
              "SnapshotIdentifierList"
            ],
            members: {
              SnapshotIdentifierList: {
                shape: "S1e"
              },
              ManualSnapshotRetentionPeriod: {
                type: "integer"
              },
              Force: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "BatchModifyClusterSnapshotsResult",
            type: "structure",
            members: {
              Resources: {
                shape: "S1e"
              },
              Errors: {
                type: "list",
                member: {
                  shape: "S1g",
                  locationName: "SnapshotErrorMessage"
                }
              }
            }
          }
        },
        CancelResize: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier"
            ],
            members: {
              ClusterIdentifier: {}
            }
          },
          output: {
            shape: "S1l",
            resultWrapper: "CancelResizeResult"
          }
        },
        CopyClusterSnapshot: {
          input: {
            type: "structure",
            required: [
              "SourceSnapshotIdentifier",
              "TargetSnapshotIdentifier"
            ],
            members: {
              SourceSnapshotIdentifier: {},
              SourceSnapshotClusterIdentifier: {},
              TargetSnapshotIdentifier: {},
              ManualSnapshotRetentionPeriod: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "CopyClusterSnapshotResult",
            type: "structure",
            members: {
              Snapshot: {
                shape: "S14"
              }
            }
          }
        },
        CreateAuthenticationProfile: {
          input: {
            type: "structure",
            required: [
              "AuthenticationProfileName",
              "AuthenticationProfileContent"
            ],
            members: {
              AuthenticationProfileName: {},
              AuthenticationProfileContent: {}
            }
          },
          output: {
            resultWrapper: "CreateAuthenticationProfileResult",
            type: "structure",
            members: {
              AuthenticationProfileName: {},
              AuthenticationProfileContent: {}
            }
          }
        },
        CreateCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier",
              "NodeType",
              "MasterUsername"
            ],
            members: {
              DBName: {},
              ClusterIdentifier: {},
              ClusterType: {},
              NodeType: {},
              MasterUsername: {},
              MasterUserPassword: {
                shape: "S1x"
              },
              ClusterSecurityGroups: {
                shape: "S1y"
              },
              VpcSecurityGroupIds: {
                shape: "S1z"
              },
              ClusterSubnetGroupName: {},
              AvailabilityZone: {},
              PreferredMaintenanceWindow: {},
              ClusterParameterGroupName: {},
              AutomatedSnapshotRetentionPeriod: {
                type: "integer"
              },
              ManualSnapshotRetentionPeriod: {
                type: "integer"
              },
              Port: {
                type: "integer"
              },
              ClusterVersion: {},
              AllowVersionUpgrade: {
                type: "boolean"
              },
              NumberOfNodes: {
                type: "integer"
              },
              PubliclyAccessible: {
                type: "boolean"
              },
              Encrypted: {
                type: "boolean"
              },
              HsmClientCertificateIdentifier: {},
              HsmConfigurationIdentifier: {},
              ElasticIp: {},
              Tags: {
                shape: "St"
              },
              KmsKeyId: {},
              EnhancedVpcRouting: {
                type: "boolean"
              },
              AdditionalInfo: {},
              IamRoles: {
                shape: "S20"
              },
              MaintenanceTrackName: {},
              SnapshotScheduleIdentifier: {},
              AvailabilityZoneRelocation: {
                type: "boolean"
              },
              AquaConfigurationStatus: {},
              DefaultIamRoleArn: {},
              LoadSampleData: {},
              ManageMasterPassword: {
                type: "boolean"
              },
              MasterPasswordSecretKmsKeyId: {},
              IpAddressType: {},
              MultiAZ: {
                type: "boolean"
              },
              RedshiftIdcApplicationArn: {}
            }
          },
          output: {
            resultWrapper: "CreateClusterResult",
            type: "structure",
            members: {
              Cluster: {
                shape: "S23"
              }
            }
          }
        },
        CreateClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "ParameterGroupName",
              "ParameterGroupFamily",
              "Description"
            ],
            members: {
              ParameterGroupName: {},
              ParameterGroupFamily: {},
              Description: {},
              Tags: {
                shape: "St"
              }
            }
          },
          output: {
            resultWrapper: "CreateClusterParameterGroupResult",
            type: "structure",
            members: {
              ClusterParameterGroup: {
                shape: "S33"
              }
            }
          }
        },
        CreateClusterSecurityGroup: {
          input: {
            type: "structure",
            required: [
              "ClusterSecurityGroupName",
              "Description"
            ],
            members: {
              ClusterSecurityGroupName: {},
              Description: {},
              Tags: {
                shape: "St"
              }
            }
          },
          output: {
            resultWrapper: "CreateClusterSecurityGroupResult",
            type: "structure",
            members: {
              ClusterSecurityGroup: {
                shape: "Sq"
              }
            }
          }
        },
        CreateClusterSnapshot: {
          input: {
            type: "structure",
            required: [
              "SnapshotIdentifier",
              "ClusterIdentifier"
            ],
            members: {
              SnapshotIdentifier: {},
              ClusterIdentifier: {},
              ManualSnapshotRetentionPeriod: {
                type: "integer"
              },
              Tags: {
                shape: "St"
              }
            }
          },
          output: {
            resultWrapper: "CreateClusterSnapshotResult",
            type: "structure",
            members: {
              Snapshot: {
                shape: "S14"
              }
            }
          }
        },
        CreateClusterSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "ClusterSubnetGroupName",
              "Description",
              "SubnetIds"
            ],
            members: {
              ClusterSubnetGroupName: {},
              Description: {},
              SubnetIds: {
                shape: "S39"
              },
              Tags: {
                shape: "St"
              }
            }
          },
          output: {
            resultWrapper: "CreateClusterSubnetGroupResult",
            type: "structure",
            members: {
              ClusterSubnetGroup: {
                shape: "S3b"
              }
            }
          }
        },
        CreateCustomDomainAssociation: {
          input: {
            type: "structure",
            required: [
              "CustomDomainName",
              "CustomDomainCertificateArn",
              "ClusterIdentifier"
            ],
            members: {
              CustomDomainName: {},
              CustomDomainCertificateArn: {},
              ClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "CreateCustomDomainAssociationResult",
            type: "structure",
            members: {
              CustomDomainName: {},
              CustomDomainCertificateArn: {},
              ClusterIdentifier: {},
              CustomDomainCertExpiryTime: {}
            }
          }
        },
        CreateEndpointAccess: {
          input: {
            type: "structure",
            required: [
              "EndpointName",
              "SubnetGroupName"
            ],
            members: {
              ClusterIdentifier: {},
              ResourceOwner: {},
              EndpointName: {},
              SubnetGroupName: {},
              VpcSecurityGroupIds: {
                shape: "S1z"
              }
            }
          },
          output: {
            shape: "S3n",
            resultWrapper: "CreateEndpointAccessResult"
          }
        },
        CreateEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SnsTopicArn"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              SourceIds: {
                shape: "S3p"
              },
              EventCategories: {
                shape: "S3q"
              },
              Severity: {},
              Enabled: {
                type: "boolean"
              },
              Tags: {
                shape: "St"
              }
            }
          },
          output: {
            resultWrapper: "CreateEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S3s"
              }
            }
          }
        },
        CreateHsmClientCertificate: {
          input: {
            type: "structure",
            required: [
              "HsmClientCertificateIdentifier"
            ],
            members: {
              HsmClientCertificateIdentifier: {},
              Tags: {
                shape: "St"
              }
            }
          },
          output: {
            resultWrapper: "CreateHsmClientCertificateResult",
            type: "structure",
            members: {
              HsmClientCertificate: {
                shape: "S3v"
              }
            }
          }
        },
        CreateHsmConfiguration: {
          input: {
            type: "structure",
            required: [
              "HsmConfigurationIdentifier",
              "Description",
              "HsmIpAddress",
              "HsmPartitionName",
              "HsmPartitionPassword",
              "HsmServerPublicCertificate"
            ],
            members: {
              HsmConfigurationIdentifier: {},
              Description: {},
              HsmIpAddress: {},
              HsmPartitionName: {},
              HsmPartitionPassword: {},
              HsmServerPublicCertificate: {},
              Tags: {
                shape: "St"
              }
            }
          },
          output: {
            resultWrapper: "CreateHsmConfigurationResult",
            type: "structure",
            members: {
              HsmConfiguration: {
                shape: "S3y"
              }
            }
          }
        },
        CreateRedshiftIdcApplication: {
          input: {
            type: "structure",
            required: [
              "IdcInstanceArn",
              "RedshiftIdcApplicationName",
              "IdcDisplayName",
              "IamRoleArn"
            ],
            members: {
              IdcInstanceArn: {},
              RedshiftIdcApplicationName: {},
              IdentityNamespace: {},
              IdcDisplayName: {},
              IamRoleArn: {},
              AuthorizedTokenIssuerList: {
                shape: "S43"
              },
              ServiceIntegrations: {
                shape: "S46"
              }
            }
          },
          output: {
            resultWrapper: "CreateRedshiftIdcApplicationResult",
            type: "structure",
            members: {
              RedshiftIdcApplication: {
                shape: "S4d"
              }
            }
          }
        },
        CreateScheduledAction: {
          input: {
            type: "structure",
            required: [
              "ScheduledActionName",
              "TargetAction",
              "Schedule",
              "IamRole"
            ],
            members: {
              ScheduledActionName: {},
              TargetAction: {
                shape: "S4f"
              },
              Schedule: {},
              IamRole: {},
              ScheduledActionDescription: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Enable: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S4j",
            resultWrapper: "CreateScheduledActionResult"
          }
        },
        CreateSnapshotCopyGrant: {
          input: {
            type: "structure",
            required: [
              "SnapshotCopyGrantName"
            ],
            members: {
              SnapshotCopyGrantName: {},
              KmsKeyId: {},
              Tags: {
                shape: "St"
              }
            }
          },
          output: {
            resultWrapper: "CreateSnapshotCopyGrantResult",
            type: "structure",
            members: {
              SnapshotCopyGrant: {
                shape: "S4o"
              }
            }
          }
        },
        CreateSnapshotSchedule: {
          input: {
            type: "structure",
            members: {
              ScheduleDefinitions: {
                shape: "S4q"
              },
              ScheduleIdentifier: {},
              ScheduleDescription: {},
              Tags: {
                shape: "St"
              },
              DryRun: {
                type: "boolean"
              },
              NextInvocations: {
                type: "integer"
              }
            }
          },
          output: {
            shape: "S4r",
            resultWrapper: "CreateSnapshotScheduleResult"
          }
        },
        CreateTags: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "Tags"
            ],
            members: {
              ResourceName: {},
              Tags: {
                shape: "St"
              }
            }
          }
        },
        CreateUsageLimit: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier",
              "FeatureType",
              "LimitType",
              "Amount"
            ],
            members: {
              ClusterIdentifier: {},
              FeatureType: {},
              LimitType: {},
              Amount: {
                type: "long"
              },
              Period: {},
              BreachAction: {},
              Tags: {
                shape: "St"
              }
            }
          },
          output: {
            shape: "S51",
            resultWrapper: "CreateUsageLimitResult"
          }
        },
        DeauthorizeDataShare: {
          input: {
            type: "structure",
            required: [
              "DataShareArn",
              "ConsumerIdentifier"
            ],
            members: {
              DataShareArn: {},
              ConsumerIdentifier: {}
            }
          },
          output: {
            shape: "Sj",
            resultWrapper: "DeauthorizeDataShareResult"
          }
        },
        DeleteAuthenticationProfile: {
          input: {
            type: "structure",
            required: [
              "AuthenticationProfileName"
            ],
            members: {
              AuthenticationProfileName: {}
            }
          },
          output: {
            resultWrapper: "DeleteAuthenticationProfileResult",
            type: "structure",
            members: {
              AuthenticationProfileName: {}
            }
          }
        },
        DeleteCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier"
            ],
            members: {
              ClusterIdentifier: {},
              SkipFinalClusterSnapshot: {
                type: "boolean"
              },
              FinalClusterSnapshotIdentifier: {},
              FinalClusterSnapshotRetentionPeriod: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DeleteClusterResult",
            type: "structure",
            members: {
              Cluster: {
                shape: "S23"
              }
            }
          }
        },
        DeleteClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "ParameterGroupName"
            ],
            members: {
              ParameterGroupName: {}
            }
          }
        },
        DeleteClusterSecurityGroup: {
          input: {
            type: "structure",
            required: [
              "ClusterSecurityGroupName"
            ],
            members: {
              ClusterSecurityGroupName: {}
            }
          }
        },
        DeleteClusterSnapshot: {
          input: {
            shape: "S1c"
          },
          output: {
            resultWrapper: "DeleteClusterSnapshotResult",
            type: "structure",
            members: {
              Snapshot: {
                shape: "S14"
              }
            }
          }
        },
        DeleteClusterSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "ClusterSubnetGroupName"
            ],
            members: {
              ClusterSubnetGroupName: {}
            }
          }
        },
        DeleteCustomDomainAssociation: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier",
              "CustomDomainName"
            ],
            members: {
              ClusterIdentifier: {},
              CustomDomainName: {}
            }
          }
        },
        DeleteEndpointAccess: {
          input: {
            type: "structure",
            required: [
              "EndpointName"
            ],
            members: {
              EndpointName: {}
            }
          },
          output: {
            shape: "S3n",
            resultWrapper: "DeleteEndpointAccessResult"
          }
        },
        DeleteEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {}
            }
          }
        },
        DeleteHsmClientCertificate: {
          input: {
            type: "structure",
            required: [
              "HsmClientCertificateIdentifier"
            ],
            members: {
              HsmClientCertificateIdentifier: {}
            }
          }
        },
        DeleteHsmConfiguration: {
          input: {
            type: "structure",
            required: [
              "HsmConfigurationIdentifier"
            ],
            members: {
              HsmConfigurationIdentifier: {}
            }
          }
        },
        DeletePartner: {
          input: {
            shape: "Sb"
          },
          output: {
            shape: "Sg",
            resultWrapper: "DeletePartnerResult"
          }
        },
        DeleteRedshiftIdcApplication: {
          input: {
            type: "structure",
            required: [
              "RedshiftIdcApplicationArn"
            ],
            members: {
              RedshiftIdcApplicationArn: {}
            }
          }
        },
        DeleteResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          }
        },
        DeleteScheduledAction: {
          input: {
            type: "structure",
            required: [
              "ScheduledActionName"
            ],
            members: {
              ScheduledActionName: {}
            }
          }
        },
        DeleteSnapshotCopyGrant: {
          input: {
            type: "structure",
            required: [
              "SnapshotCopyGrantName"
            ],
            members: {
              SnapshotCopyGrantName: {}
            }
          }
        },
        DeleteSnapshotSchedule: {
          input: {
            type: "structure",
            required: [
              "ScheduleIdentifier"
            ],
            members: {
              ScheduleIdentifier: {}
            }
          }
        },
        DeleteTags: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "TagKeys"
            ],
            members: {
              ResourceName: {},
              TagKeys: {
                shape: "S5m"
              }
            }
          }
        },
        DeleteUsageLimit: {
          input: {
            type: "structure",
            required: [
              "UsageLimitId"
            ],
            members: {
              UsageLimitId: {}
            }
          }
        },
        DescribeAccountAttributes: {
          input: {
            type: "structure",
            members: {
              AttributeNames: {
                type: "list",
                member: {
                  locationName: "AttributeName"
                }
              }
            }
          },
          output: {
            resultWrapper: "DescribeAccountAttributesResult",
            type: "structure",
            members: {
              AccountAttributes: {
                type: "list",
                member: {
                  locationName: "AccountAttribute",
                  type: "structure",
                  members: {
                    AttributeName: {},
                    AttributeValues: {
                      type: "list",
                      member: {
                        locationName: "AttributeValueTarget",
                        type: "structure",
                        members: {
                          AttributeValue: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeAuthenticationProfiles: {
          input: {
            type: "structure",
            members: {
              AuthenticationProfileName: {}
            }
          },
          output: {
            resultWrapper: "DescribeAuthenticationProfilesResult",
            type: "structure",
            members: {
              AuthenticationProfiles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AuthenticationProfileName: {},
                    AuthenticationProfileContent: {}
                  }
                }
              }
            }
          }
        },
        DescribeClusterDbRevisions: {
          input: {
            type: "structure",
            members: {
              ClusterIdentifier: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeClusterDbRevisionsResult",
            type: "structure",
            members: {
              Marker: {},
              ClusterDbRevisions: {
                type: "list",
                member: {
                  locationName: "ClusterDbRevision",
                  type: "structure",
                  members: {
                    ClusterIdentifier: {},
                    CurrentDatabaseRevision: {},
                    DatabaseRevisionReleaseDate: {
                      type: "timestamp"
                    },
                    RevisionTargets: {
                      type: "list",
                      member: {
                        locationName: "RevisionTarget",
                        type: "structure",
                        members: {
                          DatabaseRevision: {},
                          Description: {},
                          DatabaseRevisionReleaseDate: {
                            type: "timestamp"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeClusterParameterGroups: {
          input: {
            type: "structure",
            members: {
              ParameterGroupName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              TagKeys: {
                shape: "S5m"
              },
              TagValues: {
                shape: "S66"
              }
            }
          },
          output: {
            resultWrapper: "DescribeClusterParameterGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              ParameterGroups: {
                type: "list",
                member: {
                  shape: "S33",
                  locationName: "ClusterParameterGroup"
                }
              }
            }
          }
        },
        DescribeClusterParameters: {
          input: {
            type: "structure",
            required: [
              "ParameterGroupName"
            ],
            members: {
              ParameterGroupName: {},
              Source: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeClusterParametersResult",
            type: "structure",
            members: {
              Parameters: {
                shape: "S6b"
              },
              Marker: {}
            }
          }
        },
        DescribeClusterSecurityGroups: {
          input: {
            type: "structure",
            members: {
              ClusterSecurityGroupName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              TagKeys: {
                shape: "S5m"
              },
              TagValues: {
                shape: "S66"
              }
            }
          },
          output: {
            resultWrapper: "DescribeClusterSecurityGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              ClusterSecurityGroups: {
                type: "list",
                member: {
                  shape: "Sq",
                  locationName: "ClusterSecurityGroup"
                }
              }
            }
          }
        },
        DescribeClusterSnapshots: {
          input: {
            type: "structure",
            members: {
              ClusterIdentifier: {},
              SnapshotIdentifier: {},
              SnapshotArn: {},
              SnapshotType: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              OwnerAccount: {},
              TagKeys: {
                shape: "S5m"
              },
              TagValues: {
                shape: "S66"
              },
              ClusterExists: {
                type: "boolean"
              },
              SortingEntities: {
                type: "list",
                member: {
                  locationName: "SnapshotSortingEntity",
                  type: "structure",
                  required: [
                    "Attribute"
                  ],
                  members: {
                    Attribute: {},
                    SortOrder: {}
                  }
                }
              }
            }
          },
          output: {
            resultWrapper: "DescribeClusterSnapshotsResult",
            type: "structure",
            members: {
              Marker: {},
              Snapshots: {
                type: "list",
                member: {
                  shape: "S14",
                  locationName: "Snapshot"
                }
              }
            }
          }
        },
        DescribeClusterSubnetGroups: {
          input: {
            type: "structure",
            members: {
              ClusterSubnetGroupName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              TagKeys: {
                shape: "S5m"
              },
              TagValues: {
                shape: "S66"
              }
            }
          },
          output: {
            resultWrapper: "DescribeClusterSubnetGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              ClusterSubnetGroups: {
                type: "list",
                member: {
                  shape: "S3b",
                  locationName: "ClusterSubnetGroup"
                }
              }
            }
          }
        },
        DescribeClusterTracks: {
          input: {
            type: "structure",
            members: {
              MaintenanceTrackName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeClusterTracksResult",
            type: "structure",
            members: {
              MaintenanceTracks: {
                type: "list",
                member: {
                  locationName: "MaintenanceTrack",
                  type: "structure",
                  members: {
                    MaintenanceTrackName: {},
                    DatabaseVersion: {},
                    UpdateTargets: {
                      type: "list",
                      member: {
                        locationName: "UpdateTarget",
                        type: "structure",
                        members: {
                          MaintenanceTrackName: {},
                          DatabaseVersion: {},
                          SupportedOperations: {
                            type: "list",
                            member: {
                              locationName: "SupportedOperation",
                              type: "structure",
                              members: {
                                OperationName: {}
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeClusterVersions: {
          input: {
            type: "structure",
            members: {
              ClusterVersion: {},
              ClusterParameterGroupFamily: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeClusterVersionsResult",
            type: "structure",
            members: {
              Marker: {},
              ClusterVersions: {
                type: "list",
                member: {
                  locationName: "ClusterVersion",
                  type: "structure",
                  members: {
                    ClusterVersion: {},
                    ClusterParameterGroupFamily: {},
                    Description: {}
                  }
                }
              }
            }
          }
        },
        DescribeClusters: {
          input: {
            type: "structure",
            members: {
              ClusterIdentifier: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              TagKeys: {
                shape: "S5m"
              },
              TagValues: {
                shape: "S66"
              }
            }
          },
          output: {
            resultWrapper: "DescribeClustersResult",
            type: "structure",
            members: {
              Marker: {},
              Clusters: {
                type: "list",
                member: {
                  shape: "S23",
                  locationName: "Cluster"
                }
              }
            }
          }
        },
        DescribeCustomDomainAssociations: {
          input: {
            type: "structure",
            members: {
              CustomDomainName: {},
              CustomDomainCertificateArn: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeCustomDomainAssociationsResult",
            type: "structure",
            members: {
              Marker: {},
              Associations: {
                type: "list",
                member: {
                  locationName: "Association",
                  type: "structure",
                  members: {
                    CustomDomainCertificateArn: {},
                    CustomDomainCertificateExpiryDate: {
                      type: "timestamp"
                    },
                    CertificateAssociations: {
                      type: "list",
                      member: {
                        locationName: "CertificateAssociation",
                        type: "structure",
                        members: {
                          CustomDomainName: {},
                          ClusterIdentifier: {}
                        }
                      }
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        DescribeDataShares: {
          input: {
            type: "structure",
            members: {
              DataShareArn: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDataSharesResult",
            type: "structure",
            members: {
              DataShares: {
                shape: "S7e"
              },
              Marker: {}
            }
          }
        },
        DescribeDataSharesForConsumer: {
          input: {
            type: "structure",
            members: {
              ConsumerArn: {},
              Status: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDataSharesForConsumerResult",
            type: "structure",
            members: {
              DataShares: {
                shape: "S7e"
              },
              Marker: {}
            }
          }
        },
        DescribeDataSharesForProducer: {
          input: {
            type: "structure",
            members: {
              ProducerArn: {},
              Status: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDataSharesForProducerResult",
            type: "structure",
            members: {
              DataShares: {
                shape: "S7e"
              },
              Marker: {}
            }
          }
        },
        DescribeDefaultClusterParameters: {
          input: {
            type: "structure",
            required: [
              "ParameterGroupFamily"
            ],
            members: {
              ParameterGroupFamily: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDefaultClusterParametersResult",
            type: "structure",
            members: {
              DefaultClusterParameters: {
                type: "structure",
                members: {
                  ParameterGroupFamily: {},
                  Marker: {},
                  Parameters: {
                    shape: "S6b"
                  }
                },
                wrapper: true
              }
            }
          }
        },
        DescribeEndpointAccess: {
          input: {
            type: "structure",
            members: {
              ClusterIdentifier: {},
              ResourceOwner: {},
              EndpointName: {},
              VpcId: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEndpointAccessResult",
            type: "structure",
            members: {
              EndpointAccessList: {
                type: "list",
                member: {
                  shape: "S3n"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeEndpointAuthorization: {
          input: {
            type: "structure",
            members: {
              ClusterIdentifier: {},
              Account: {},
              Grantee: {
                type: "boolean"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEndpointAuthorizationResult",
            type: "structure",
            members: {
              EndpointAuthorizationList: {
                type: "list",
                member: {
                  shape: "S10"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeEventCategories: {
          input: {
            type: "structure",
            members: {
              SourceType: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventCategoriesResult",
            type: "structure",
            members: {
              EventCategoriesMapList: {
                type: "list",
                member: {
                  locationName: "EventCategoriesMap",
                  type: "structure",
                  members: {
                    SourceType: {},
                    Events: {
                      type: "list",
                      member: {
                        locationName: "EventInfoMap",
                        type: "structure",
                        members: {
                          EventId: {},
                          EventCategories: {
                            shape: "S3q"
                          },
                          EventDescription: {},
                          Severity: {}
                        },
                        wrapper: true
                      }
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        DescribeEventSubscriptions: {
          input: {
            type: "structure",
            members: {
              SubscriptionName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              TagKeys: {
                shape: "S5m"
              },
              TagValues: {
                shape: "S66"
              }
            }
          },
          output: {
            resultWrapper: "DescribeEventSubscriptionsResult",
            type: "structure",
            members: {
              Marker: {},
              EventSubscriptionsList: {
                type: "list",
                member: {
                  shape: "S3s",
                  locationName: "EventSubscription"
                }
              }
            }
          }
        },
        DescribeEvents: {
          input: {
            type: "structure",
            members: {
              SourceIdentifier: {},
              SourceType: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Duration: {
                type: "integer"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventsResult",
            type: "structure",
            members: {
              Marker: {},
              Events: {
                type: "list",
                member: {
                  locationName: "Event",
                  type: "structure",
                  members: {
                    SourceIdentifier: {},
                    SourceType: {},
                    Message: {},
                    EventCategories: {
                      shape: "S3q"
                    },
                    Severity: {},
                    Date: {
                      type: "timestamp"
                    },
                    EventId: {}
                  }
                }
              }
            }
          }
        },
        DescribeHsmClientCertificates: {
          input: {
            type: "structure",
            members: {
              HsmClientCertificateIdentifier: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              TagKeys: {
                shape: "S5m"
              },
              TagValues: {
                shape: "S66"
              }
            }
          },
          output: {
            resultWrapper: "DescribeHsmClientCertificatesResult",
            type: "structure",
            members: {
              Marker: {},
              HsmClientCertificates: {
                type: "list",
                member: {
                  shape: "S3v",
                  locationName: "HsmClientCertificate"
                }
              }
            }
          }
        },
        DescribeHsmConfigurations: {
          input: {
            type: "structure",
            members: {
              HsmConfigurationIdentifier: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              TagKeys: {
                shape: "S5m"
              },
              TagValues: {
                shape: "S66"
              }
            }
          },
          output: {
            resultWrapper: "DescribeHsmConfigurationsResult",
            type: "structure",
            members: {
              Marker: {},
              HsmConfigurations: {
                type: "list",
                member: {
                  shape: "S3y",
                  locationName: "HsmConfiguration"
                }
              }
            }
          }
        },
        DescribeInboundIntegrations: {
          input: {
            type: "structure",
            members: {
              IntegrationArn: {},
              TargetArn: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeInboundIntegrationsResult",
            type: "structure",
            members: {
              Marker: {},
              InboundIntegrations: {
                type: "list",
                member: {
                  locationName: "InboundIntegration",
                  type: "structure",
                  members: {
                    IntegrationArn: {},
                    SourceArn: {},
                    TargetArn: {},
                    Status: {},
                    Errors: {
                      type: "list",
                      member: {
                        locationName: "IntegrationError",
                        type: "structure",
                        required: [
                          "ErrorCode"
                        ],
                        members: {
                          ErrorCode: {},
                          ErrorMessage: {}
                        }
                      }
                    },
                    CreateTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeLoggingStatus: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier"
            ],
            members: {
              ClusterIdentifier: {}
            }
          },
          output: {
            shape: "S8m",
            resultWrapper: "DescribeLoggingStatusResult"
          }
        },
        DescribeNodeConfigurationOptions: {
          input: {
            type: "structure",
            required: [
              "ActionType"
            ],
            members: {
              ActionType: {},
              ClusterIdentifier: {},
              SnapshotIdentifier: {},
              SnapshotArn: {},
              OwnerAccount: {},
              Filters: {
                locationName: "Filter",
                type: "list",
                member: {
                  locationName: "NodeConfigurationOptionsFilter",
                  type: "structure",
                  members: {
                    Name: {},
                    Operator: {},
                    Values: {
                      shape: "S3h",
                      locationName: "Value"
                    }
                  }
                }
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeNodeConfigurationOptionsResult",
            type: "structure",
            members: {
              NodeConfigurationOptionList: {
                type: "list",
                member: {
                  locationName: "NodeConfigurationOption",
                  type: "structure",
                  members: {
                    NodeType: {},
                    NumberOfNodes: {
                      type: "integer"
                    },
                    EstimatedDiskUtilizationPercent: {
                      type: "double"
                    },
                    Mode: {}
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeOrderableClusterOptions: {
          input: {
            type: "structure",
            members: {
              ClusterVersion: {},
              NodeType: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeOrderableClusterOptionsResult",
            type: "structure",
            members: {
              OrderableClusterOptions: {
                type: "list",
                member: {
                  locationName: "OrderableClusterOption",
                  type: "structure",
                  members: {
                    ClusterVersion: {},
                    ClusterType: {},
                    NodeType: {},
                    AvailabilityZones: {
                      type: "list",
                      member: {
                        shape: "S3e",
                        locationName: "AvailabilityZone"
                      }
                    }
                  },
                  wrapper: true
                }
              },
              Marker: {}
            }
          }
        },
        DescribePartners: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "ClusterIdentifier"
            ],
            members: {
              AccountId: {},
              ClusterIdentifier: {},
              DatabaseName: {},
              PartnerName: {}
            }
          },
          output: {
            resultWrapper: "DescribePartnersResult",
            type: "structure",
            members: {
              PartnerIntegrationInfoList: {
                type: "list",
                member: {
                  locationName: "PartnerIntegrationInfo",
                  type: "structure",
                  members: {
                    DatabaseName: {},
                    PartnerName: {},
                    Status: {},
                    StatusMessage: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    UpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeRedshiftIdcApplications: {
          input: {
            type: "structure",
            members: {
              RedshiftIdcApplicationArn: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeRedshiftIdcApplicationsResult",
            type: "structure",
            members: {
              RedshiftIdcApplications: {
                type: "list",
                member: {
                  shape: "S4d"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeReservedNodeExchangeStatus: {
          input: {
            type: "structure",
            members: {
              ReservedNodeId: {},
              ReservedNodeExchangeRequestId: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeReservedNodeExchangeStatusResult",
            type: "structure",
            members: {
              ReservedNodeExchangeStatusDetails: {
                type: "list",
                member: {
                  shape: "S2y",
                  locationName: "ReservedNodeExchangeStatus"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeReservedNodeOfferings: {
          input: {
            type: "structure",
            members: {
              ReservedNodeOfferingId: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeReservedNodeOfferingsResult",
            type: "structure",
            members: {
              Marker: {},
              ReservedNodeOfferings: {
                shape: "S9i"
              }
            }
          }
        },
        DescribeReservedNodes: {
          input: {
            type: "structure",
            members: {
              ReservedNodeId: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeReservedNodesResult",
            type: "structure",
            members: {
              Marker: {},
              ReservedNodes: {
                type: "list",
                member: {
                  shape: "S4",
                  locationName: "ReservedNode"
                }
              }
            }
          }
        },
        DescribeResize: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier"
            ],
            members: {
              ClusterIdentifier: {}
            }
          },
          output: {
            shape: "S1l",
            resultWrapper: "DescribeResizeResult"
          }
        },
        DescribeScheduledActions: {
          input: {
            type: "structure",
            members: {
              ScheduledActionName: {},
              TargetActionType: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Active: {
                type: "boolean"
              },
              Filters: {
                type: "list",
                member: {
                  locationName: "ScheduledActionFilter",
                  type: "structure",
                  required: [
                    "Name",
                    "Values"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      shape: "S3h"
                    }
                  }
                }
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeScheduledActionsResult",
            type: "structure",
            members: {
              Marker: {},
              ScheduledActions: {
                type: "list",
                member: {
                  shape: "S4j",
                  locationName: "ScheduledAction"
                }
              }
            }
          }
        },
        DescribeSnapshotCopyGrants: {
          input: {
            type: "structure",
            members: {
              SnapshotCopyGrantName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              TagKeys: {
                shape: "S5m"
              },
              TagValues: {
                shape: "S66"
              }
            }
          },
          output: {
            resultWrapper: "DescribeSnapshotCopyGrantsResult",
            type: "structure",
            members: {
              Marker: {},
              SnapshotCopyGrants: {
                type: "list",
                member: {
                  shape: "S4o",
                  locationName: "SnapshotCopyGrant"
                }
              }
            }
          }
        },
        DescribeSnapshotSchedules: {
          input: {
            type: "structure",
            members: {
              ClusterIdentifier: {},
              ScheduleIdentifier: {},
              TagKeys: {
                shape: "S5m"
              },
              TagValues: {
                shape: "S66"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeSnapshotSchedulesResult",
            type: "structure",
            members: {
              SnapshotSchedules: {
                type: "list",
                member: {
                  shape: "S4r",
                  locationName: "SnapshotSchedule"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeStorage: {
          output: {
            resultWrapper: "DescribeStorageResult",
            type: "structure",
            members: {
              TotalBackupSizeInMegaBytes: {
                type: "double"
              },
              TotalProvisionedStorageInMegaBytes: {
                type: "double"
              }
            }
          }
        },
        DescribeTableRestoreStatus: {
          input: {
            type: "structure",
            members: {
              ClusterIdentifier: {},
              TableRestoreRequestId: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeTableRestoreStatusResult",
            type: "structure",
            members: {
              TableRestoreStatusDetails: {
                type: "list",
                member: {
                  shape: "Sa5",
                  locationName: "TableRestoreStatus"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeTags: {
          input: {
            type: "structure",
            members: {
              ResourceName: {},
              ResourceType: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              TagKeys: {
                shape: "S5m"
              },
              TagValues: {
                shape: "S66"
              }
            }
          },
          output: {
            resultWrapper: "DescribeTagsResult",
            type: "structure",
            members: {
              TaggedResources: {
                type: "list",
                member: {
                  locationName: "TaggedResource",
                  type: "structure",
                  members: {
                    Tag: {
                      shape: "Su"
                    },
                    ResourceName: {},
                    ResourceType: {}
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeUsageLimits: {
          input: {
            type: "structure",
            members: {
              UsageLimitId: {},
              ClusterIdentifier: {},
              FeatureType: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              TagKeys: {
                shape: "S5m"
              },
              TagValues: {
                shape: "S66"
              }
            }
          },
          output: {
            resultWrapper: "DescribeUsageLimitsResult",
            type: "structure",
            members: {
              UsageLimits: {
                type: "list",
                member: {
                  shape: "S51"
                }
              },
              Marker: {}
            }
          }
        },
        DisableLogging: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier"
            ],
            members: {
              ClusterIdentifier: {}
            }
          },
          output: {
            shape: "S8m",
            resultWrapper: "DisableLoggingResult"
          }
        },
        DisableSnapshotCopy: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier"
            ],
            members: {
              ClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DisableSnapshotCopyResult",
            type: "structure",
            members: {
              Cluster: {
                shape: "S23"
              }
            }
          }
        },
        DisassociateDataShareConsumer: {
          input: {
            type: "structure",
            required: [
              "DataShareArn"
            ],
            members: {
              DataShareArn: {},
              DisassociateEntireAccount: {
                type: "boolean"
              },
              ConsumerArn: {},
              ConsumerRegion: {}
            }
          },
          output: {
            shape: "Sj",
            resultWrapper: "DisassociateDataShareConsumerResult"
          }
        },
        EnableLogging: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier"
            ],
            members: {
              ClusterIdentifier: {},
              BucketName: {},
              S3KeyPrefix: {},
              LogDestinationType: {},
              LogExports: {
                shape: "S8o"
              }
            }
          },
          output: {
            shape: "S8m",
            resultWrapper: "EnableLoggingResult"
          }
        },
        EnableSnapshotCopy: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier",
              "DestinationRegion"
            ],
            members: {
              ClusterIdentifier: {},
              DestinationRegion: {},
              RetentionPeriod: {
                type: "integer"
              },
              SnapshotCopyGrantName: {},
              ManualSnapshotRetentionPeriod: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "EnableSnapshotCopyResult",
            type: "structure",
            members: {
              Cluster: {
                shape: "S23"
              }
            }
          }
        },
        FailoverPrimaryCompute: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier"
            ],
            members: {
              ClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "FailoverPrimaryComputeResult",
            type: "structure",
            members: {
              Cluster: {
                shape: "S23"
              }
            }
          }
        },
        GetClusterCredentials: {
          input: {
            type: "structure",
            required: [
              "DbUser"
            ],
            members: {
              DbUser: {},
              DbName: {},
              ClusterIdentifier: {},
              DurationSeconds: {
                type: "integer"
              },
              AutoCreate: {
                type: "boolean"
              },
              DbGroups: {
                type: "list",
                member: {
                  locationName: "DbGroup"
                }
              },
              CustomDomainName: {}
            }
          },
          output: {
            resultWrapper: "GetClusterCredentialsResult",
            type: "structure",
            members: {
              DbUser: {},
              DbPassword: {
                shape: "S1x"
              },
              Expiration: {
                type: "timestamp"
              }
            }
          }
        },
        GetClusterCredentialsWithIAM: {
          input: {
            type: "structure",
            members: {
              DbName: {},
              ClusterIdentifier: {},
              DurationSeconds: {
                type: "integer"
              },
              CustomDomainName: {}
            }
          },
          output: {
            resultWrapper: "GetClusterCredentialsWithIAMResult",
            type: "structure",
            members: {
              DbUser: {},
              DbPassword: {
                shape: "S1x"
              },
              Expiration: {
                type: "timestamp"
              },
              NextRefreshTime: {
                type: "timestamp"
              }
            }
          }
        },
        GetReservedNodeExchangeConfigurationOptions: {
          input: {
            type: "structure",
            required: [
              "ActionType"
            ],
            members: {
              ActionType: {},
              ClusterIdentifier: {},
              SnapshotIdentifier: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "GetReservedNodeExchangeConfigurationOptionsResult",
            type: "structure",
            members: {
              Marker: {},
              ReservedNodeConfigurationOptionList: {
                type: "list",
                member: {
                  locationName: "ReservedNodeConfigurationOption",
                  type: "structure",
                  members: {
                    SourceReservedNode: {
                      shape: "S4"
                    },
                    TargetReservedNodeCount: {
                      type: "integer"
                    },
                    TargetReservedNodeOffering: {
                      shape: "S9j"
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        GetReservedNodeExchangeOfferings: {
          input: {
            type: "structure",
            required: [
              "ReservedNodeId"
            ],
            members: {
              ReservedNodeId: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "GetReservedNodeExchangeOfferingsResult",
            type: "structure",
            members: {
              Marker: {},
              ReservedNodeOfferings: {
                shape: "S9i"
              }
            }
          }
        },
        GetResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            resultWrapper: "GetResourcePolicyResult",
            type: "structure",
            members: {
              ResourcePolicy: {
                shape: "Sb1"
              }
            }
          }
        },
        ModifyAquaConfiguration: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier"
            ],
            members: {
              ClusterIdentifier: {},
              AquaConfigurationStatus: {}
            }
          },
          output: {
            resultWrapper: "ModifyAquaConfigurationResult",
            type: "structure",
            members: {
              AquaConfiguration: {
                shape: "S2w"
              }
            }
          }
        },
        ModifyAuthenticationProfile: {
          input: {
            type: "structure",
            required: [
              "AuthenticationProfileName",
              "AuthenticationProfileContent"
            ],
            members: {
              AuthenticationProfileName: {},
              AuthenticationProfileContent: {}
            }
          },
          output: {
            resultWrapper: "ModifyAuthenticationProfileResult",
            type: "structure",
            members: {
              AuthenticationProfileName: {},
              AuthenticationProfileContent: {}
            }
          }
        },
        ModifyCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier"
            ],
            members: {
              ClusterIdentifier: {},
              ClusterType: {},
              NodeType: {},
              NumberOfNodes: {
                type: "integer"
              },
              ClusterSecurityGroups: {
                shape: "S1y"
              },
              VpcSecurityGroupIds: {
                shape: "S1z"
              },
              MasterUserPassword: {
                shape: "S1x"
              },
              ClusterParameterGroupName: {},
              AutomatedSnapshotRetentionPeriod: {
                type: "integer"
              },
              ManualSnapshotRetentionPeriod: {
                type: "integer"
              },
              PreferredMaintenanceWindow: {},
              ClusterVersion: {},
              AllowVersionUpgrade: {
                type: "boolean"
              },
              HsmClientCertificateIdentifier: {},
              HsmConfigurationIdentifier: {},
              NewClusterIdentifier: {},
              PubliclyAccessible: {
                type: "boolean"
              },
              ElasticIp: {},
              EnhancedVpcRouting: {
                type: "boolean"
              },
              MaintenanceTrackName: {},
              Encrypted: {
                type: "boolean"
              },
              KmsKeyId: {},
              AvailabilityZoneRelocation: {
                type: "boolean"
              },
              AvailabilityZone: {},
              Port: {
                type: "integer"
              },
              ManageMasterPassword: {
                type: "boolean"
              },
              MasterPasswordSecretKmsKeyId: {},
              IpAddressType: {},
              MultiAZ: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyClusterResult",
            type: "structure",
            members: {
              Cluster: {
                shape: "S23"
              }
            }
          }
        },
        ModifyClusterDbRevision: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier",
              "RevisionTarget"
            ],
            members: {
              ClusterIdentifier: {},
              RevisionTarget: {}
            }
          },
          output: {
            resultWrapper: "ModifyClusterDbRevisionResult",
            type: "structure",
            members: {
              Cluster: {
                shape: "S23"
              }
            }
          }
        },
        ModifyClusterIamRoles: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier"
            ],
            members: {
              ClusterIdentifier: {},
              AddIamRoles: {
                shape: "S20"
              },
              RemoveIamRoles: {
                shape: "S20"
              },
              DefaultIamRoleArn: {}
            }
          },
          output: {
            resultWrapper: "ModifyClusterIamRolesResult",
            type: "structure",
            members: {
              Cluster: {
                shape: "S23"
              }
            }
          }
        },
        ModifyClusterMaintenance: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier"
            ],
            members: {
              ClusterIdentifier: {},
              DeferMaintenance: {
                type: "boolean"
              },
              DeferMaintenanceIdentifier: {},
              DeferMaintenanceStartTime: {
                type: "timestamp"
              },
              DeferMaintenanceEndTime: {
                type: "timestamp"
              },
              DeferMaintenanceDuration: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ModifyClusterMaintenanceResult",
            type: "structure",
            members: {
              Cluster: {
                shape: "S23"
              }
            }
          }
        },
        ModifyClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "ParameterGroupName",
              "Parameters"
            ],
            members: {
              ParameterGroupName: {},
              Parameters: {
                shape: "S6b"
              }
            }
          },
          output: {
            shape: "Sbf",
            resultWrapper: "ModifyClusterParameterGroupResult"
          }
        },
        ModifyClusterSnapshot: {
          input: {
            type: "structure",
            required: [
              "SnapshotIdentifier"
            ],
            members: {
              SnapshotIdentifier: {},
              ManualSnapshotRetentionPeriod: {
                type: "integer"
              },
              Force: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyClusterSnapshotResult",
            type: "structure",
            members: {
              Snapshot: {
                shape: "S14"
              }
            }
          }
        },
        ModifyClusterSnapshotSchedule: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier"
            ],
            members: {
              ClusterIdentifier: {},
              ScheduleIdentifier: {},
              DisassociateSchedule: {
                type: "boolean"
              }
            }
          }
        },
        ModifyClusterSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "ClusterSubnetGroupName",
              "SubnetIds"
            ],
            members: {
              ClusterSubnetGroupName: {},
              Description: {},
              SubnetIds: {
                shape: "S39"
              }
            }
          },
          output: {
            resultWrapper: "ModifyClusterSubnetGroupResult",
            type: "structure",
            members: {
              ClusterSubnetGroup: {
                shape: "S3b"
              }
            }
          }
        },
        ModifyCustomDomainAssociation: {
          input: {
            type: "structure",
            required: [
              "CustomDomainName",
              "CustomDomainCertificateArn",
              "ClusterIdentifier"
            ],
            members: {
              CustomDomainName: {},
              CustomDomainCertificateArn: {},
              ClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "ModifyCustomDomainAssociationResult",
            type: "structure",
            members: {
              CustomDomainName: {},
              CustomDomainCertificateArn: {},
              ClusterIdentifier: {},
              CustomDomainCertExpiryTime: {}
            }
          }
        },
        ModifyEndpointAccess: {
          input: {
            type: "structure",
            required: [
              "EndpointName"
            ],
            members: {
              EndpointName: {},
              VpcSecurityGroupIds: {
                shape: "S1z"
              }
            }
          },
          output: {
            shape: "S3n",
            resultWrapper: "ModifyEndpointAccessResult"
          }
        },
        ModifyEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              SourceIds: {
                shape: "S3p"
              },
              EventCategories: {
                shape: "S3q"
              },
              Severity: {},
              Enabled: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S3s"
              }
            }
          }
        },
        ModifyRedshiftIdcApplication: {
          input: {
            type: "structure",
            required: [
              "RedshiftIdcApplicationArn"
            ],
            members: {
              RedshiftIdcApplicationArn: {},
              IdentityNamespace: {},
              IamRoleArn: {},
              IdcDisplayName: {},
              AuthorizedTokenIssuerList: {
                shape: "S43"
              },
              ServiceIntegrations: {
                shape: "S46"
              }
            }
          },
          output: {
            resultWrapper: "ModifyRedshiftIdcApplicationResult",
            type: "structure",
            members: {
              RedshiftIdcApplication: {
                shape: "S4d"
              }
            }
          }
        },
        ModifyScheduledAction: {
          input: {
            type: "structure",
            required: [
              "ScheduledActionName"
            ],
            members: {
              ScheduledActionName: {},
              TargetAction: {
                shape: "S4f"
              },
              Schedule: {},
              IamRole: {},
              ScheduledActionDescription: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Enable: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S4j",
            resultWrapper: "ModifyScheduledActionResult"
          }
        },
        ModifySnapshotCopyRetentionPeriod: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier",
              "RetentionPeriod"
            ],
            members: {
              ClusterIdentifier: {},
              RetentionPeriod: {
                type: "integer"
              },
              Manual: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifySnapshotCopyRetentionPeriodResult",
            type: "structure",
            members: {
              Cluster: {
                shape: "S23"
              }
            }
          }
        },
        ModifySnapshotSchedule: {
          input: {
            type: "structure",
            required: [
              "ScheduleIdentifier",
              "ScheduleDefinitions"
            ],
            members: {
              ScheduleIdentifier: {},
              ScheduleDefinitions: {
                shape: "S4q"
              }
            }
          },
          output: {
            shape: "S4r",
            resultWrapper: "ModifySnapshotScheduleResult"
          }
        },
        ModifyUsageLimit: {
          input: {
            type: "structure",
            required: [
              "UsageLimitId"
            ],
            members: {
              UsageLimitId: {},
              Amount: {
                type: "long"
              },
              BreachAction: {}
            }
          },
          output: {
            shape: "S51",
            resultWrapper: "ModifyUsageLimitResult"
          }
        },
        PauseCluster: {
          input: {
            shape: "S4h"
          },
          output: {
            resultWrapper: "PauseClusterResult",
            type: "structure",
            members: {
              Cluster: {
                shape: "S23"
              }
            }
          }
        },
        PurchaseReservedNodeOffering: {
          input: {
            type: "structure",
            required: [
              "ReservedNodeOfferingId"
            ],
            members: {
              ReservedNodeOfferingId: {},
              NodeCount: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "PurchaseReservedNodeOfferingResult",
            type: "structure",
            members: {
              ReservedNode: {
                shape: "S4"
              }
            }
          }
        },
        PutResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Policy"
            ],
            members: {
              ResourceArn: {},
              Policy: {}
            }
          },
          output: {
            resultWrapper: "PutResourcePolicyResult",
            type: "structure",
            members: {
              ResourcePolicy: {
                shape: "Sb1"
              }
            }
          }
        },
        RebootCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier"
            ],
            members: {
              ClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "RebootClusterResult",
            type: "structure",
            members: {
              Cluster: {
                shape: "S23"
              }
            }
          }
        },
        RejectDataShare: {
          input: {
            type: "structure",
            required: [
              "DataShareArn"
            ],
            members: {
              DataShareArn: {}
            }
          },
          output: {
            shape: "Sj",
            resultWrapper: "RejectDataShareResult"
          }
        },
        ResetClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "ParameterGroupName"
            ],
            members: {
              ParameterGroupName: {},
              ResetAllParameters: {
                type: "boolean"
              },
              Parameters: {
                shape: "S6b"
              }
            }
          },
          output: {
            shape: "Sbf",
            resultWrapper: "ResetClusterParameterGroupResult"
          }
        },
        ResizeCluster: {
          input: {
            shape: "S4g"
          },
          output: {
            resultWrapper: "ResizeClusterResult",
            type: "structure",
            members: {
              Cluster: {
                shape: "S23"
              }
            }
          }
        },
        RestoreFromClusterSnapshot: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier"
            ],
            members: {
              ClusterIdentifier: {},
              SnapshotIdentifier: {},
              SnapshotArn: {},
              SnapshotClusterIdentifier: {},
              Port: {
                type: "integer"
              },
              AvailabilityZone: {},
              AllowVersionUpgrade: {
                type: "boolean"
              },
              ClusterSubnetGroupName: {},
              PubliclyAccessible: {
                type: "boolean"
              },
              OwnerAccount: {},
              HsmClientCertificateIdentifier: {},
              HsmConfigurationIdentifier: {},
              ElasticIp: {},
              ClusterParameterGroupName: {},
              ClusterSecurityGroups: {
                shape: "S1y"
              },
              VpcSecurityGroupIds: {
                shape: "S1z"
              },
              PreferredMaintenanceWindow: {},
              AutomatedSnapshotRetentionPeriod: {
                type: "integer"
              },
              ManualSnapshotRetentionPeriod: {
                type: "integer"
              },
              KmsKeyId: {},
              NodeType: {},
              EnhancedVpcRouting: {
                type: "boolean"
              },
              AdditionalInfo: {},
              IamRoles: {
                shape: "S20"
              },
              MaintenanceTrackName: {},
              SnapshotScheduleIdentifier: {},
              NumberOfNodes: {
                type: "integer"
              },
              AvailabilityZoneRelocation: {
                type: "boolean"
              },
              AquaConfigurationStatus: {},
              DefaultIamRoleArn: {},
              ReservedNodeId: {},
              TargetReservedNodeOfferingId: {},
              Encrypted: {
                type: "boolean"
              },
              ManageMasterPassword: {
                type: "boolean"
              },
              MasterPasswordSecretKmsKeyId: {},
              IpAddressType: {},
              MultiAZ: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "RestoreFromClusterSnapshotResult",
            type: "structure",
            members: {
              Cluster: {
                shape: "S23"
              }
            }
          }
        },
        RestoreTableFromClusterSnapshot: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier",
              "SnapshotIdentifier",
              "SourceDatabaseName",
              "SourceTableName",
              "NewTableName"
            ],
            members: {
              ClusterIdentifier: {},
              SnapshotIdentifier: {},
              SourceDatabaseName: {},
              SourceSchemaName: {},
              SourceTableName: {},
              TargetDatabaseName: {},
              TargetSchemaName: {},
              NewTableName: {},
              EnableCaseSensitiveIdentifier: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "RestoreTableFromClusterSnapshotResult",
            type: "structure",
            members: {
              TableRestoreStatus: {
                shape: "Sa5"
              }
            }
          }
        },
        ResumeCluster: {
          input: {
            shape: "S4i"
          },
          output: {
            resultWrapper: "ResumeClusterResult",
            type: "structure",
            members: {
              Cluster: {
                shape: "S23"
              }
            }
          }
        },
        RevokeClusterSecurityGroupIngress: {
          input: {
            type: "structure",
            required: [
              "ClusterSecurityGroupName"
            ],
            members: {
              ClusterSecurityGroupName: {},
              CIDRIP: {},
              EC2SecurityGroupName: {},
              EC2SecurityGroupOwnerId: {}
            }
          },
          output: {
            resultWrapper: "RevokeClusterSecurityGroupIngressResult",
            type: "structure",
            members: {
              ClusterSecurityGroup: {
                shape: "Sq"
              }
            }
          }
        },
        RevokeEndpointAccess: {
          input: {
            type: "structure",
            members: {
              ClusterIdentifier: {},
              Account: {},
              VpcIds: {
                shape: "Sz"
              },
              Force: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S10",
            resultWrapper: "RevokeEndpointAccessResult"
          }
        },
        RevokeSnapshotAccess: {
          input: {
            type: "structure",
            required: [
              "AccountWithRestoreAccess"
            ],
            members: {
              SnapshotIdentifier: {},
              SnapshotArn: {},
              SnapshotClusterIdentifier: {},
              AccountWithRestoreAccess: {}
            }
          },
          output: {
            resultWrapper: "RevokeSnapshotAccessResult",
            type: "structure",
            members: {
              Snapshot: {
                shape: "S14"
              }
            }
          }
        },
        RotateEncryptionKey: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier"
            ],
            members: {
              ClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "RotateEncryptionKeyResult",
            type: "structure",
            members: {
              Cluster: {
                shape: "S23"
              }
            }
          }
        },
        UpdatePartnerStatus: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "ClusterIdentifier",
              "DatabaseName",
              "PartnerName",
              "Status"
            ],
            members: {
              AccountId: {},
              ClusterIdentifier: {},
              DatabaseName: {},
              PartnerName: {},
              Status: {},
              StatusMessage: {}
            }
          },
          output: {
            shape: "Sg",
            resultWrapper: "UpdatePartnerStatusResult"
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            ReservedNodeId: {},
            ReservedNodeOfferingId: {},
            NodeType: {},
            StartTime: {
              type: "timestamp"
            },
            Duration: {
              type: "integer"
            },
            FixedPrice: {
              type: "double"
            },
            UsagePrice: {
              type: "double"
            },
            CurrencyCode: {},
            NodeCount: {
              type: "integer"
            },
            State: {},
            OfferingType: {},
            RecurringCharges: {
              shape: "S8"
            },
            ReservedNodeOfferingType: {}
          },
          wrapper: true
        },
        S8: {
          type: "list",
          member: {
            locationName: "RecurringCharge",
            type: "structure",
            members: {
              RecurringChargeAmount: {
                type: "double"
              },
              RecurringChargeFrequency: {}
            },
            wrapper: true
          }
        },
        Sb: {
          type: "structure",
          required: [
            "AccountId",
            "ClusterIdentifier",
            "DatabaseName",
            "PartnerName"
          ],
          members: {
            AccountId: {},
            ClusterIdentifier: {},
            DatabaseName: {},
            PartnerName: {}
          }
        },
        Sg: {
          type: "structure",
          members: {
            DatabaseName: {},
            PartnerName: {}
          }
        },
        Sj: {
          type: "structure",
          members: {
            DataShareArn: {},
            ProducerArn: {},
            AllowPubliclyAccessibleConsumers: {
              type: "boolean"
            },
            DataShareAssociations: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  ConsumerIdentifier: {},
                  Status: {},
                  ConsumerRegion: {},
                  CreatedDate: {
                    type: "timestamp"
                  },
                  StatusChangeDate: {
                    type: "timestamp"
                  },
                  ProducerAllowedWrites: {
                    type: "boolean"
                  },
                  ConsumerAcceptedWrites: {
                    type: "boolean"
                  }
                }
              }
            },
            ManagedBy: {}
          }
        },
        Sq: {
          type: "structure",
          members: {
            ClusterSecurityGroupName: {},
            Description: {},
            EC2SecurityGroups: {
              type: "list",
              member: {
                locationName: "EC2SecurityGroup",
                type: "structure",
                members: {
                  Status: {},
                  EC2SecurityGroupName: {},
                  EC2SecurityGroupOwnerId: {},
                  Tags: {
                    shape: "St"
                  }
                }
              }
            },
            IPRanges: {
              type: "list",
              member: {
                locationName: "IPRange",
                type: "structure",
                members: {
                  Status: {},
                  CIDRIP: {},
                  Tags: {
                    shape: "St"
                  }
                }
              }
            },
            Tags: {
              shape: "St"
            }
          },
          wrapper: true
        },
        St: {
          type: "list",
          member: {
            shape: "Su",
            locationName: "Tag"
          }
        },
        Su: {
          type: "structure",
          members: {
            Key: {},
            Value: {}
          }
        },
        Sz: {
          type: "list",
          member: {
            locationName: "VpcIdentifier"
          }
        },
        S10: {
          type: "structure",
          members: {
            Grantor: {},
            Grantee: {},
            ClusterIdentifier: {},
            AuthorizeTime: {
              type: "timestamp"
            },
            ClusterStatus: {},
            Status: {},
            AllowedAllVPCs: {
              type: "boolean"
            },
            AllowedVPCs: {
              shape: "Sz"
            },
            EndpointCount: {
              type: "integer"
            }
          }
        },
        S14: {
          type: "structure",
          members: {
            SnapshotIdentifier: {},
            ClusterIdentifier: {},
            SnapshotCreateTime: {
              type: "timestamp"
            },
            Status: {},
            Port: {
              type: "integer"
            },
            AvailabilityZone: {},
            ClusterCreateTime: {
              type: "timestamp"
            },
            MasterUsername: {},
            ClusterVersion: {},
            EngineFullVersion: {},
            SnapshotType: {},
            NodeType: {},
            NumberOfNodes: {
              type: "integer"
            },
            DBName: {},
            VpcId: {},
            Encrypted: {
              type: "boolean"
            },
            KmsKeyId: {},
            EncryptedWithHSM: {
              type: "boolean"
            },
            AccountsWithRestoreAccess: {
              type: "list",
              member: {
                locationName: "AccountWithRestoreAccess",
                type: "structure",
                members: {
                  AccountId: {},
                  AccountAlias: {}
                }
              }
            },
            OwnerAccount: {},
            TotalBackupSizeInMegaBytes: {
              type: "double"
            },
            ActualIncrementalBackupSizeInMegaBytes: {
              type: "double"
            },
            BackupProgressInMegaBytes: {
              type: "double"
            },
            CurrentBackupRateInMegaBytesPerSecond: {
              type: "double"
            },
            EstimatedSecondsToCompletion: {
              type: "long"
            },
            ElapsedTimeInSeconds: {
              type: "long"
            },
            SourceRegion: {},
            Tags: {
              shape: "St"
            },
            RestorableNodeTypes: {
              type: "list",
              member: {
                locationName: "NodeType"
              }
            },
            EnhancedVpcRouting: {
              type: "boolean"
            },
            MaintenanceTrackName: {},
            ManualSnapshotRetentionPeriod: {
              type: "integer"
            },
            ManualSnapshotRemainingDays: {
              type: "integer"
            },
            SnapshotRetentionStartTime: {
              type: "timestamp"
            },
            MasterPasswordSecretArn: {},
            MasterPasswordSecretKmsKeyId: {}
          },
          wrapper: true
        },
        S1c: {
          type: "structure",
          required: [
            "SnapshotIdentifier"
          ],
          members: {
            SnapshotIdentifier: {},
            SnapshotClusterIdentifier: {}
          }
        },
        S1e: {
          type: "list",
          member: {
            locationName: "String"
          }
        },
        S1g: {
          type: "structure",
          members: {
            SnapshotIdentifier: {},
            SnapshotClusterIdentifier: {},
            FailureCode: {},
            FailureReason: {}
          }
        },
        S1l: {
          type: "structure",
          members: {
            TargetNodeType: {},
            TargetNumberOfNodes: {
              type: "integer"
            },
            TargetClusterType: {},
            Status: {},
            ImportTablesCompleted: {
              type: "list",
              member: {}
            },
            ImportTablesInProgress: {
              type: "list",
              member: {}
            },
            ImportTablesNotStarted: {
              type: "list",
              member: {}
            },
            AvgResizeRateInMegaBytesPerSecond: {
              type: "double"
            },
            TotalResizeDataInMegaBytes: {
              type: "long"
            },
            ProgressInMegaBytes: {
              type: "long"
            },
            ElapsedTimeInSeconds: {
              type: "long"
            },
            EstimatedTimeToCompletionInSeconds: {
              type: "long"
            },
            ResizeType: {},
            Message: {},
            TargetEncryptionType: {},
            DataTransferProgressPercent: {
              type: "double"
            }
          }
        },
        S1x: {
          type: "string",
          sensitive: true
        },
        S1y: {
          type: "list",
          member: {
            locationName: "ClusterSecurityGroupName"
          }
        },
        S1z: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroupId"
          }
        },
        S20: {
          type: "list",
          member: {
            locationName: "IamRoleArn"
          }
        },
        S23: {
          type: "structure",
          members: {
            ClusterIdentifier: {},
            NodeType: {},
            ClusterStatus: {},
            ClusterAvailabilityStatus: {},
            ModifyStatus: {},
            MasterUsername: {},
            DBName: {},
            Endpoint: {
              type: "structure",
              members: {
                Address: {},
                Port: {
                  type: "integer"
                },
                VpcEndpoints: {
                  type: "list",
                  member: {
                    shape: "S26",
                    locationName: "VpcEndpoint"
                  }
                }
              }
            },
            ClusterCreateTime: {
              type: "timestamp"
            },
            AutomatedSnapshotRetentionPeriod: {
              type: "integer"
            },
            ManualSnapshotRetentionPeriod: {
              type: "integer"
            },
            ClusterSecurityGroups: {
              type: "list",
              member: {
                locationName: "ClusterSecurityGroup",
                type: "structure",
                members: {
                  ClusterSecurityGroupName: {},
                  Status: {}
                }
              }
            },
            VpcSecurityGroups: {
              shape: "S2b"
            },
            ClusterParameterGroups: {
              type: "list",
              member: {
                locationName: "ClusterParameterGroup",
                type: "structure",
                members: {
                  ParameterGroupName: {},
                  ParameterApplyStatus: {},
                  ClusterParameterStatusList: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        ParameterName: {},
                        ParameterApplyStatus: {},
                        ParameterApplyErrorDescription: {}
                      }
                    }
                  }
                }
              }
            },
            ClusterSubnetGroupName: {},
            VpcId: {},
            AvailabilityZone: {},
            PreferredMaintenanceWindow: {},
            PendingModifiedValues: {
              type: "structure",
              members: {
                MasterUserPassword: {
                  shape: "S1x"
                },
                NodeType: {},
                NumberOfNodes: {
                  type: "integer"
                },
                ClusterType: {},
                ClusterVersion: {},
                AutomatedSnapshotRetentionPeriod: {
                  type: "integer"
                },
                ClusterIdentifier: {},
                PubliclyAccessible: {
                  type: "boolean"
                },
                EnhancedVpcRouting: {
                  type: "boolean"
                },
                MaintenanceTrackName: {},
                EncryptionType: {}
              }
            },
            ClusterVersion: {},
            AllowVersionUpgrade: {
              type: "boolean"
            },
            NumberOfNodes: {
              type: "integer"
            },
            PubliclyAccessible: {
              type: "boolean"
            },
            Encrypted: {
              type: "boolean"
            },
            RestoreStatus: {
              type: "structure",
              members: {
                Status: {},
                CurrentRestoreRateInMegaBytesPerSecond: {
                  type: "double"
                },
                SnapshotSizeInMegaBytes: {
                  type: "long"
                },
                ProgressInMegaBytes: {
                  type: "long"
                },
                ElapsedTimeInSeconds: {
                  type: "long"
                },
                EstimatedTimeToCompletionInSeconds: {
                  type: "long"
                }
              }
            },
            DataTransferProgress: {
              type: "structure",
              members: {
                Status: {},
                CurrentRateInMegaBytesPerSecond: {
                  type: "double"
                },
                TotalDataInMegaBytes: {
                  type: "long"
                },
                DataTransferredInMegaBytes: {
                  type: "long"
                },
                EstimatedTimeToCompletionInSeconds: {
                  type: "long"
                },
                ElapsedTimeInSeconds: {
                  type: "long"
                }
              }
            },
            HsmStatus: {
              type: "structure",
              members: {
                HsmClientCertificateIdentifier: {},
                HsmConfigurationIdentifier: {},
                Status: {}
              }
            },
            ClusterSnapshotCopyStatus: {
              type: "structure",
              members: {
                DestinationRegion: {},
                RetentionPeriod: {
                  type: "long"
                },
                ManualSnapshotRetentionPeriod: {
                  type: "integer"
                },
                SnapshotCopyGrantName: {}
              }
            },
            ClusterPublicKey: {},
            ClusterNodes: {
              shape: "S2m"
            },
            ElasticIpStatus: {
              type: "structure",
              members: {
                ElasticIp: {},
                Status: {}
              }
            },
            ClusterRevisionNumber: {},
            Tags: {
              shape: "St"
            },
            KmsKeyId: {},
            EnhancedVpcRouting: {
              type: "boolean"
            },
            IamRoles: {
              type: "list",
              member: {
                locationName: "ClusterIamRole",
                type: "structure",
                members: {
                  IamRoleArn: {},
                  ApplyStatus: {}
                }
              }
            },
            PendingActions: {
              type: "list",
              member: {}
            },
            MaintenanceTrackName: {},
            ElasticResizeNumberOfNodeOptions: {},
            DeferredMaintenanceWindows: {
              type: "list",
              member: {
                locationName: "DeferredMaintenanceWindow",
                type: "structure",
                members: {
                  DeferMaintenanceIdentifier: {},
                  DeferMaintenanceStartTime: {
                    type: "timestamp"
                  },
                  DeferMaintenanceEndTime: {
                    type: "timestamp"
                  }
                }
              }
            },
            SnapshotScheduleIdentifier: {},
            SnapshotScheduleState: {},
            ExpectedNextSnapshotScheduleTime: {
              type: "timestamp"
            },
            ExpectedNextSnapshotScheduleTimeStatus: {},
            NextMaintenanceWindowStartTime: {
              type: "timestamp"
            },
            ResizeInfo: {
              type: "structure",
              members: {
                ResizeType: {},
                AllowCancelResize: {
                  type: "boolean"
                }
              }
            },
            AvailabilityZoneRelocationStatus: {},
            ClusterNamespaceArn: {},
            TotalStorageCapacityInMegaBytes: {
              type: "long"
            },
            AquaConfiguration: {
              shape: "S2w"
            },
            DefaultIamRoleArn: {},
            ReservedNodeExchangeStatus: {
              shape: "S2y"
            },
            CustomDomainName: {},
            CustomDomainCertificateArn: {},
            CustomDomainCertificateExpiryDate: {
              type: "timestamp"
            },
            MasterPasswordSecretArn: {},
            MasterPasswordSecretKmsKeyId: {},
            IpAddressType: {},
            MultiAZ: {},
            MultiAZSecondary: {
              type: "structure",
              members: {
                AvailabilityZone: {},
                ClusterNodes: {
                  shape: "S2m"
                }
              }
            }
          },
          wrapper: true
        },
        S26: {
          type: "structure",
          members: {
            VpcEndpointId: {},
            VpcId: {},
            NetworkInterfaces: {
              type: "list",
              member: {
                locationName: "NetworkInterface",
                type: "structure",
                members: {
                  NetworkInterfaceId: {},
                  SubnetId: {},
                  PrivateIpAddress: {},
                  AvailabilityZone: {},
                  Ipv6Address: {}
                }
              }
            }
          }
        },
        S2b: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroup",
            type: "structure",
            members: {
              VpcSecurityGroupId: {},
              Status: {}
            }
          }
        },
        S2m: {
          type: "list",
          member: {
            type: "structure",
            members: {
              NodeRole: {},
              PrivateIPAddress: {},
              PublicIPAddress: {}
            }
          }
        },
        S2w: {
          type: "structure",
          members: {
            AquaStatus: {},
            AquaConfigurationStatus: {}
          }
        },
        S2y: {
          type: "structure",
          members: {
            ReservedNodeExchangeRequestId: {},
            Status: {},
            RequestTime: {
              type: "timestamp"
            },
            SourceReservedNodeId: {},
            SourceReservedNodeType: {},
            SourceReservedNodeCount: {
              type: "integer"
            },
            TargetReservedNodeOfferingId: {},
            TargetReservedNodeType: {},
            TargetReservedNodeCount: {
              type: "integer"
            }
          },
          wrapper: true
        },
        S33: {
          type: "structure",
          members: {
            ParameterGroupName: {},
            ParameterGroupFamily: {},
            Description: {},
            Tags: {
              shape: "St"
            }
          },
          wrapper: true
        },
        S39: {
          type: "list",
          member: {
            locationName: "SubnetIdentifier"
          }
        },
        S3b: {
          type: "structure",
          members: {
            ClusterSubnetGroupName: {},
            Description: {},
            VpcId: {},
            SubnetGroupStatus: {},
            Subnets: {
              type: "list",
              member: {
                locationName: "Subnet",
                type: "structure",
                members: {
                  SubnetIdentifier: {},
                  SubnetAvailabilityZone: {
                    shape: "S3e"
                  },
                  SubnetStatus: {}
                }
              }
            },
            Tags: {
              shape: "St"
            },
            SupportedClusterIpAddressTypes: {
              shape: "S3h"
            }
          },
          wrapper: true
        },
        S3e: {
          type: "structure",
          members: {
            Name: {},
            SupportedPlatforms: {
              type: "list",
              member: {
                locationName: "SupportedPlatform",
                type: "structure",
                members: {
                  Name: {}
                },
                wrapper: true
              }
            }
          },
          wrapper: true
        },
        S3h: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S3n: {
          type: "structure",
          members: {
            ClusterIdentifier: {},
            ResourceOwner: {},
            SubnetGroupName: {},
            EndpointStatus: {},
            EndpointName: {},
            EndpointCreateTime: {
              type: "timestamp"
            },
            Port: {
              type: "integer"
            },
            Address: {},
            VpcSecurityGroups: {
              shape: "S2b"
            },
            VpcEndpoint: {
              shape: "S26"
            }
          }
        },
        S3p: {
          type: "list",
          member: {
            locationName: "SourceId"
          }
        },
        S3q: {
          type: "list",
          member: {
            locationName: "EventCategory"
          }
        },
        S3s: {
          type: "structure",
          members: {
            CustomerAwsId: {},
            CustSubscriptionId: {},
            SnsTopicArn: {},
            Status: {},
            SubscriptionCreationTime: {
              type: "timestamp"
            },
            SourceType: {},
            SourceIdsList: {
              shape: "S3p"
            },
            EventCategoriesList: {
              shape: "S3q"
            },
            Severity: {},
            Enabled: {
              type: "boolean"
            },
            Tags: {
              shape: "St"
            }
          },
          wrapper: true
        },
        S3v: {
          type: "structure",
          members: {
            HsmClientCertificateIdentifier: {},
            HsmClientCertificatePublicKey: {},
            Tags: {
              shape: "St"
            }
          },
          wrapper: true
        },
        S3y: {
          type: "structure",
          members: {
            HsmConfigurationIdentifier: {},
            Description: {},
            HsmIpAddress: {},
            HsmPartitionName: {},
            Tags: {
              shape: "St"
            }
          },
          wrapper: true
        },
        S43: {
          type: "list",
          member: {
            type: "structure",
            members: {
              TrustedTokenIssuerArn: {},
              AuthorizedAudiencesList: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S46: {
          type: "list",
          member: {
            type: "structure",
            members: {
              LakeFormation: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LakeFormationQuery: {
                      type: "structure",
                      required: [
                        "Authorization"
                      ],
                      members: {
                        Authorization: {}
                      }
                    }
                  },
                  union: true
                }
              }
            },
            union: true
          }
        },
        S4d: {
          type: "structure",
          members: {
            IdcInstanceArn: {},
            RedshiftIdcApplicationName: {},
            RedshiftIdcApplicationArn: {},
            IdentityNamespace: {},
            IdcDisplayName: {},
            IamRoleArn: {},
            IdcManagedApplicationArn: {},
            IdcOnboardStatus: {},
            AuthorizedTokenIssuerList: {
              shape: "S43"
            },
            ServiceIntegrations: {
              shape: "S46"
            }
          },
          wrapper: true
        },
        S4f: {
          type: "structure",
          members: {
            ResizeCluster: {
              shape: "S4g"
            },
            PauseCluster: {
              shape: "S4h"
            },
            ResumeCluster: {
              shape: "S4i"
            }
          }
        },
        S4g: {
          type: "structure",
          required: [
            "ClusterIdentifier"
          ],
          members: {
            ClusterIdentifier: {},
            ClusterType: {},
            NodeType: {},
            NumberOfNodes: {
              type: "integer"
            },
            Classic: {
              type: "boolean"
            },
            ReservedNodeId: {},
            TargetReservedNodeOfferingId: {}
          }
        },
        S4h: {
          type: "structure",
          required: [
            "ClusterIdentifier"
          ],
          members: {
            ClusterIdentifier: {}
          }
        },
        S4i: {
          type: "structure",
          required: [
            "ClusterIdentifier"
          ],
          members: {
            ClusterIdentifier: {}
          }
        },
        S4j: {
          type: "structure",
          members: {
            ScheduledActionName: {},
            TargetAction: {
              shape: "S4f"
            },
            Schedule: {},
            IamRole: {},
            ScheduledActionDescription: {},
            State: {},
            NextInvocations: {
              type: "list",
              member: {
                locationName: "ScheduledActionTime",
                type: "timestamp"
              }
            },
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            }
          }
        },
        S4o: {
          type: "structure",
          members: {
            SnapshotCopyGrantName: {},
            KmsKeyId: {},
            Tags: {
              shape: "St"
            }
          },
          wrapper: true
        },
        S4q: {
          type: "list",
          member: {
            locationName: "ScheduleDefinition"
          }
        },
        S4r: {
          type: "structure",
          members: {
            ScheduleDefinitions: {
              shape: "S4q"
            },
            ScheduleIdentifier: {},
            ScheduleDescription: {},
            Tags: {
              shape: "St"
            },
            NextInvocations: {
              type: "list",
              member: {
                locationName: "SnapshotTime",
                type: "timestamp"
              }
            },
            AssociatedClusterCount: {
              type: "integer"
            },
            AssociatedClusters: {
              type: "list",
              member: {
                locationName: "ClusterAssociatedToSchedule",
                type: "structure",
                members: {
                  ClusterIdentifier: {},
                  ScheduleAssociationState: {}
                }
              }
            }
          }
        },
        S51: {
          type: "structure",
          members: {
            UsageLimitId: {},
            ClusterIdentifier: {},
            FeatureType: {},
            LimitType: {},
            Amount: {
              type: "long"
            },
            Period: {},
            BreachAction: {},
            Tags: {
              shape: "St"
            }
          }
        },
        S5m: {
          type: "list",
          member: {
            locationName: "TagKey"
          }
        },
        S66: {
          type: "list",
          member: {
            locationName: "TagValue"
          }
        },
        S6b: {
          type: "list",
          member: {
            locationName: "Parameter",
            type: "structure",
            members: {
              ParameterName: {},
              ParameterValue: {},
              Description: {},
              Source: {},
              DataType: {},
              AllowedValues: {},
              ApplyType: {},
              IsModifiable: {
                type: "boolean"
              },
              MinimumEngineVersion: {}
            }
          }
        },
        S7e: {
          type: "list",
          member: {
            shape: "Sj"
          }
        },
        S8m: {
          type: "structure",
          members: {
            LoggingEnabled: {
              type: "boolean"
            },
            BucketName: {},
            S3KeyPrefix: {},
            LastSuccessfulDeliveryTime: {
              type: "timestamp"
            },
            LastFailureTime: {
              type: "timestamp"
            },
            LastFailureMessage: {},
            LogDestinationType: {},
            LogExports: {
              shape: "S8o"
            }
          }
        },
        S8o: {
          type: "list",
          member: {}
        },
        S9i: {
          type: "list",
          member: {
            shape: "S9j",
            locationName: "ReservedNodeOffering"
          }
        },
        S9j: {
          type: "structure",
          members: {
            ReservedNodeOfferingId: {},
            NodeType: {},
            Duration: {
              type: "integer"
            },
            FixedPrice: {
              type: "double"
            },
            UsagePrice: {
              type: "double"
            },
            CurrencyCode: {},
            OfferingType: {},
            RecurringCharges: {
              shape: "S8"
            },
            ReservedNodeOfferingType: {}
          },
          wrapper: true
        },
        Sa5: {
          type: "structure",
          members: {
            TableRestoreRequestId: {},
            Status: {},
            Message: {},
            RequestTime: {
              type: "timestamp"
            },
            ProgressInMegaBytes: {
              type: "long"
            },
            TotalDataInMegaBytes: {
              type: "long"
            },
            ClusterIdentifier: {},
            SnapshotIdentifier: {},
            SourceDatabaseName: {},
            SourceSchemaName: {},
            SourceTableName: {},
            TargetDatabaseName: {},
            TargetSchemaName: {},
            NewTableName: {}
          },
          wrapper: true
        },
        Sb1: {
          type: "structure",
          members: {
            ResourceArn: {},
            Policy: {}
          }
        },
        Sbf: {
          type: "structure",
          members: {
            ParameterGroupName: {},
            ParameterGroupStatus: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/redshift-2012-12-01.paginators.json
var require_redshift_2012_12_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/redshift-2012-12-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeClusterDbRevisions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ClusterDbRevisions"
        },
        DescribeClusterParameterGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ParameterGroups"
        },
        DescribeClusterParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Parameters"
        },
        DescribeClusterSecurityGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ClusterSecurityGroups"
        },
        DescribeClusterSnapshots: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Snapshots"
        },
        DescribeClusterSubnetGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ClusterSubnetGroups"
        },
        DescribeClusterTracks: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "MaintenanceTracks"
        },
        DescribeClusterVersions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ClusterVersions"
        },
        DescribeClusters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Clusters"
        },
        DescribeCustomDomainAssociations: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Associations"
        },
        DescribeDataShares: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DataShares"
        },
        DescribeDataSharesForConsumer: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DataShares"
        },
        DescribeDataSharesForProducer: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DataShares"
        },
        DescribeDefaultClusterParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "DefaultClusterParameters.Marker",
          result_key: "DefaultClusterParameters.Parameters"
        },
        DescribeEndpointAccess: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "EndpointAccessList"
        },
        DescribeEndpointAuthorization: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "EndpointAuthorizationList"
        },
        DescribeEventSubscriptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "EventSubscriptionsList"
        },
        DescribeEvents: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Events"
        },
        DescribeHsmClientCertificates: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "HsmClientCertificates"
        },
        DescribeHsmConfigurations: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "HsmConfigurations"
        },
        DescribeInboundIntegrations: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "InboundIntegrations"
        },
        DescribeNodeConfigurationOptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "NodeConfigurationOptionList"
        },
        DescribeOrderableClusterOptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "OrderableClusterOptions"
        },
        DescribeRedshiftIdcApplications: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "RedshiftIdcApplications"
        },
        DescribeReservedNodeExchangeStatus: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ReservedNodeExchangeStatusDetails"
        },
        DescribeReservedNodeOfferings: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ReservedNodeOfferings"
        },
        DescribeReservedNodes: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ReservedNodes"
        },
        DescribeScheduledActions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ScheduledActions"
        },
        DescribeSnapshotCopyGrants: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "SnapshotCopyGrants"
        },
        DescribeSnapshotSchedules: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "SnapshotSchedules"
        },
        DescribeTableRestoreStatus: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "TableRestoreStatusDetails"
        },
        DescribeTags: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "TaggedResources"
        },
        DescribeUsageLimits: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "UsageLimits"
        },
        GetReservedNodeExchangeConfigurationOptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ReservedNodeConfigurationOptionList"
        },
        GetReservedNodeExchangeOfferings: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ReservedNodeOfferings"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/redshift-2012-12-01.waiters2.json
var require_redshift_2012_12_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/redshift-2012-12-01.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        ClusterAvailable: {
          delay: 60,
          operation: "DescribeClusters",
          maxAttempts: 30,
          acceptors: [
            {
              expected: "available",
              matcher: "pathAll",
              state: "success",
              argument: "Clusters[].ClusterStatus"
            },
            {
              expected: "deleting",
              matcher: "pathAny",
              state: "failure",
              argument: "Clusters[].ClusterStatus"
            },
            {
              expected: "ClusterNotFound",
              matcher: "error",
              state: "retry"
            }
          ]
        },
        ClusterDeleted: {
          delay: 60,
          operation: "DescribeClusters",
          maxAttempts: 30,
          acceptors: [
            {
              expected: "ClusterNotFound",
              matcher: "error",
              state: "success"
            },
            {
              expected: "creating",
              matcher: "pathAny",
              state: "failure",
              argument: "Clusters[].ClusterStatus"
            },
            {
              expected: "modifying",
              matcher: "pathAny",
              state: "failure",
              argument: "Clusters[].ClusterStatus"
            }
          ]
        },
        ClusterRestored: {
          operation: "DescribeClusters",
          maxAttempts: 30,
          delay: 60,
          acceptors: [
            {
              state: "success",
              matcher: "pathAll",
              argument: "Clusters[].RestoreStatus.Status",
              expected: "completed"
            },
            {
              state: "failure",
              matcher: "pathAny",
              argument: "Clusters[].ClusterStatus",
              expected: "deleting"
            }
          ]
        },
        SnapshotAvailable: {
          delay: 15,
          operation: "DescribeClusterSnapshots",
          maxAttempts: 20,
          acceptors: [
            {
              expected: "available",
              matcher: "pathAll",
              state: "success",
              argument: "Snapshots[].Status"
            },
            {
              expected: "failed",
              matcher: "pathAny",
              state: "failure",
              argument: "Snapshots[].Status"
            },
            {
              expected: "deleted",
              matcher: "pathAny",
              state: "failure",
              argument: "Snapshots[].Status"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/redshift.js
var require_redshift = __commonJS({
  "node_modules/aws-sdk/clients/redshift.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["redshift"] = {};
    AWS2.Redshift = Service.defineService("redshift", ["2012-12-01"]);
    Object.defineProperty(apiLoader.services["redshift"], "2012-12-01", {
      get: function get() {
        var model = require_redshift_2012_12_01_min();
        model.paginators = require_redshift_2012_12_01_paginators().pagination;
        model.waiters = require_redshift_2012_12_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Redshift;
  }
});

// node_modules/aws-sdk/apis/rekognition-2016-06-27.min.json
var require_rekognition_2016_06_27_min = __commonJS({
  "node_modules/aws-sdk/apis/rekognition-2016-06-27.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-06-27",
        endpointPrefix: "rekognition",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Rekognition",
        serviceId: "Rekognition",
        signatureVersion: "v4",
        targetPrefix: "RekognitionService",
        uid: "rekognition-2016-06-27"
      },
      operations: {
        AssociateFaces: {
          input: {
            type: "structure",
            required: [
              "CollectionId",
              "UserId",
              "FaceIds"
            ],
            members: {
              CollectionId: {},
              UserId: {},
              FaceIds: {
                shape: "S4"
              },
              UserMatchThreshold: {
                type: "float"
              },
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssociatedFaces: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FaceId: {}
                  }
                }
              },
              UnsuccessfulFaceAssociations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FaceId: {},
                    UserId: {},
                    Confidence: {
                      type: "float"
                    },
                    Reasons: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              UserStatus: {}
            }
          }
        },
        CompareFaces: {
          input: {
            type: "structure",
            required: [
              "SourceImage",
              "TargetImage"
            ],
            members: {
              SourceImage: {
                shape: "Sh"
              },
              TargetImage: {
                shape: "Sh"
              },
              SimilarityThreshold: {
                type: "float"
              },
              QualityFilter: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SourceImageFace: {
                type: "structure",
                members: {
                  BoundingBox: {
                    shape: "Sq"
                  },
                  Confidence: {
                    type: "float"
                  }
                }
              },
              FaceMatches: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Similarity: {
                      type: "float"
                    },
                    Face: {
                      shape: "Su"
                    }
                  }
                }
              },
              UnmatchedFaces: {
                type: "list",
                member: {
                  shape: "Su"
                }
              },
              SourceImageOrientationCorrection: {},
              TargetImageOrientationCorrection: {}
            }
          }
        },
        CopyProjectVersion: {
          input: {
            type: "structure",
            required: [
              "SourceProjectArn",
              "SourceProjectVersionArn",
              "DestinationProjectArn",
              "VersionName",
              "OutputConfig"
            ],
            members: {
              SourceProjectArn: {},
              SourceProjectVersionArn: {},
              DestinationProjectArn: {},
              VersionName: {},
              OutputConfig: {
                shape: "S1c"
              },
              Tags: {
                shape: "S1e"
              },
              KmsKeyId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProjectVersionArn: {}
            }
          }
        },
        CreateCollection: {
          input: {
            type: "structure",
            required: [
              "CollectionId"
            ],
            members: {
              CollectionId: {},
              Tags: {
                shape: "S1e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StatusCode: {
                type: "integer"
              },
              CollectionArn: {},
              FaceModelVersion: {}
            }
          }
        },
        CreateDataset: {
          input: {
            type: "structure",
            required: [
              "DatasetType",
              "ProjectArn"
            ],
            members: {
              DatasetSource: {
                type: "structure",
                members: {
                  GroundTruthManifest: {
                    shape: "S1p"
                  },
                  DatasetArn: {}
                }
              },
              DatasetType: {},
              ProjectArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetArn: {}
            }
          }
        },
        CreateFaceLivenessSession: {
          input: {
            type: "structure",
            members: {
              KmsKeyId: {},
              Settings: {
                type: "structure",
                members: {
                  OutputConfig: {
                    type: "structure",
                    required: [
                      "S3Bucket"
                    ],
                    members: {
                      S3Bucket: {},
                      S3KeyPrefix: {}
                    }
                  },
                  AuditImagesLimit: {
                    type: "integer"
                  }
                }
              },
              ClientRequestToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "SessionId"
            ],
            members: {
              SessionId: {}
            }
          },
          idempotent: true
        },
        CreateProject: {
          input: {
            type: "structure",
            required: [
              "ProjectName"
            ],
            members: {
              ProjectName: {},
              Feature: {},
              AutoUpdate: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProjectArn: {}
            }
          }
        },
        CreateProjectVersion: {
          input: {
            type: "structure",
            required: [
              "ProjectArn",
              "VersionName",
              "OutputConfig"
            ],
            members: {
              ProjectArn: {},
              VersionName: {},
              OutputConfig: {
                shape: "S1c"
              },
              TrainingData: {
                shape: "S26"
              },
              TestingData: {
                shape: "S29"
              },
              Tags: {
                shape: "S1e"
              },
              KmsKeyId: {},
              VersionDescription: {},
              FeatureConfig: {
                shape: "S2b"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProjectVersionArn: {}
            }
          }
        },
        CreateStreamProcessor: {
          input: {
            type: "structure",
            required: [
              "Input",
              "Output",
              "Name",
              "Settings",
              "RoleArn"
            ],
            members: {
              Input: {
                shape: "S2f"
              },
              Output: {
                shape: "S2i"
              },
              Name: {},
              Settings: {
                shape: "S2n"
              },
              RoleArn: {},
              Tags: {
                shape: "S1e"
              },
              NotificationChannel: {
                shape: "S2t"
              },
              KmsKeyId: {},
              RegionsOfInterest: {
                shape: "S2v"
              },
              DataSharingPreference: {
                shape: "S2z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamProcessorArn: {}
            }
          }
        },
        CreateUser: {
          input: {
            type: "structure",
            required: [
              "CollectionId",
              "UserId"
            ],
            members: {
              CollectionId: {},
              UserId: {},
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteCollection: {
          input: {
            type: "structure",
            required: [
              "CollectionId"
            ],
            members: {
              CollectionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StatusCode: {
                type: "integer"
              }
            }
          }
        },
        DeleteDataset: {
          input: {
            type: "structure",
            required: [
              "DatasetArn"
            ],
            members: {
              DatasetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteFaces: {
          input: {
            type: "structure",
            required: [
              "CollectionId",
              "FaceIds"
            ],
            members: {
              CollectionId: {},
              FaceIds: {
                shape: "S39"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeletedFaces: {
                shape: "S39"
              },
              UnsuccessfulFaceDeletions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FaceId: {},
                    UserId: {},
                    Reasons: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              }
            }
          }
        },
        DeleteProject: {
          input: {
            type: "structure",
            required: [
              "ProjectArn"
            ],
            members: {
              ProjectArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {}
            }
          }
        },
        DeleteProjectPolicy: {
          input: {
            type: "structure",
            required: [
              "ProjectArn",
              "PolicyName"
            ],
            members: {
              ProjectArn: {},
              PolicyName: {},
              PolicyRevisionId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteProjectVersion: {
          input: {
            type: "structure",
            required: [
              "ProjectVersionArn"
            ],
            members: {
              ProjectVersionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {}
            }
          }
        },
        DeleteStreamProcessor: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteUser: {
          input: {
            type: "structure",
            required: [
              "CollectionId",
              "UserId"
            ],
            members: {
              CollectionId: {},
              UserId: {},
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeCollection: {
          input: {
            type: "structure",
            required: [
              "CollectionId"
            ],
            members: {
              CollectionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FaceCount: {
                type: "long"
              },
              FaceModelVersion: {},
              CollectionARN: {},
              CreationTimestamp: {
                type: "timestamp"
              },
              UserCount: {
                type: "long"
              }
            }
          }
        },
        DescribeDataset: {
          input: {
            type: "structure",
            required: [
              "DatasetArn"
            ],
            members: {
              DatasetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetDescription: {
                type: "structure",
                members: {
                  CreationTimestamp: {
                    type: "timestamp"
                  },
                  LastUpdatedTimestamp: {
                    type: "timestamp"
                  },
                  Status: {},
                  StatusMessage: {},
                  StatusMessageCode: {},
                  DatasetStats: {
                    type: "structure",
                    members: {
                      LabeledEntries: {
                        type: "integer"
                      },
                      TotalEntries: {
                        type: "integer"
                      },
                      TotalLabels: {
                        type: "integer"
                      },
                      ErrorEntries: {
                        type: "integer"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeProjectVersions: {
          input: {
            type: "structure",
            required: [
              "ProjectArn"
            ],
            members: {
              ProjectArn: {},
              VersionNames: {
                type: "list",
                member: {}
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProjectVersionDescriptions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ProjectVersionArn: {},
                    CreationTimestamp: {
                      type: "timestamp"
                    },
                    MinInferenceUnits: {
                      type: "integer"
                    },
                    Status: {},
                    StatusMessage: {},
                    BillableTrainingTimeInSeconds: {
                      type: "long"
                    },
                    TrainingEndTimestamp: {
                      type: "timestamp"
                    },
                    OutputConfig: {
                      shape: "S1c"
                    },
                    TrainingDataResult: {
                      type: "structure",
                      members: {
                        Input: {
                          shape: "S26"
                        },
                        Output: {
                          shape: "S26"
                        },
                        Validation: {
                          shape: "S4d"
                        }
                      }
                    },
                    TestingDataResult: {
                      type: "structure",
                      members: {
                        Input: {
                          shape: "S29"
                        },
                        Output: {
                          shape: "S29"
                        },
                        Validation: {
                          shape: "S4d"
                        }
                      }
                    },
                    EvaluationResult: {
                      type: "structure",
                      members: {
                        F1Score: {
                          type: "float"
                        },
                        Summary: {
                          type: "structure",
                          members: {
                            S3Object: {
                              shape: "Sj"
                            }
                          }
                        }
                      }
                    },
                    ManifestSummary: {
                      shape: "S1p"
                    },
                    KmsKeyId: {},
                    MaxInferenceUnits: {
                      type: "integer"
                    },
                    SourceProjectVersionArn: {},
                    VersionDescription: {},
                    Feature: {},
                    BaseModelVersion: {},
                    FeatureConfig: {
                      shape: "S2b"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeProjects: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ProjectNames: {
                type: "list",
                member: {}
              },
              Features: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProjectDescriptions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ProjectArn: {},
                    CreationTimestamp: {
                      type: "timestamp"
                    },
                    Status: {},
                    Datasets: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          CreationTimestamp: {
                            type: "timestamp"
                          },
                          DatasetType: {},
                          DatasetArn: {},
                          Status: {},
                          StatusMessage: {},
                          StatusMessageCode: {}
                        }
                      }
                    },
                    Feature: {},
                    AutoUpdate: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeStreamProcessor: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              StreamProcessorArn: {},
              Status: {},
              StatusMessage: {},
              CreationTimestamp: {
                type: "timestamp"
              },
              LastUpdateTimestamp: {
                type: "timestamp"
              },
              Input: {
                shape: "S2f"
              },
              Output: {
                shape: "S2i"
              },
              RoleArn: {},
              Settings: {
                shape: "S2n"
              },
              NotificationChannel: {
                shape: "S2t"
              },
              KmsKeyId: {},
              RegionsOfInterest: {
                shape: "S2v"
              },
              DataSharingPreference: {
                shape: "S2z"
              }
            }
          }
        },
        DetectCustomLabels: {
          input: {
            type: "structure",
            required: [
              "ProjectVersionArn",
              "Image"
            ],
            members: {
              ProjectVersionArn: {},
              Image: {
                shape: "Sh"
              },
              MaxResults: {
                type: "integer"
              },
              MinConfidence: {
                type: "float"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CustomLabels: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Confidence: {
                      type: "float"
                    },
                    Geometry: {
                      shape: "S4x"
                    }
                  }
                }
              }
            }
          }
        },
        DetectFaces: {
          input: {
            type: "structure",
            required: [
              "Image"
            ],
            members: {
              Image: {
                shape: "Sh"
              },
              Attributes: {
                shape: "S4z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FaceDetails: {
                type: "list",
                member: {
                  shape: "S53"
                }
              },
              OrientationCorrection: {}
            }
          }
        },
        DetectLabels: {
          input: {
            type: "structure",
            required: [
              "Image"
            ],
            members: {
              Image: {
                shape: "Sh"
              },
              MaxLabels: {
                type: "integer"
              },
              MinConfidence: {
                type: "float"
              },
              Features: {
                type: "list",
                member: {}
              },
              Settings: {
                type: "structure",
                members: {
                  GeneralLabels: {
                    shape: "S5j"
                  },
                  ImageProperties: {
                    type: "structure",
                    members: {
                      MaxDominantColors: {
                        type: "integer"
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Labels: {
                type: "list",
                member: {
                  shape: "S5q"
                }
              },
              OrientationCorrection: {},
              LabelModelVersion: {},
              ImageProperties: {
                type: "structure",
                members: {
                  Quality: {
                    shape: "S62"
                  },
                  DominantColors: {
                    shape: "S5t"
                  },
                  Foreground: {
                    type: "structure",
                    members: {
                      Quality: {
                        shape: "S62"
                      },
                      DominantColors: {
                        shape: "S5t"
                      }
                    }
                  },
                  Background: {
                    type: "structure",
                    members: {
                      Quality: {
                        shape: "S62"
                      },
                      DominantColors: {
                        shape: "S5t"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DetectModerationLabels: {
          input: {
            type: "structure",
            required: [
              "Image"
            ],
            members: {
              Image: {
                shape: "Sh"
              },
              MinConfidence: {
                type: "float"
              },
              HumanLoopConfig: {
                type: "structure",
                required: [
                  "HumanLoopName",
                  "FlowDefinitionArn"
                ],
                members: {
                  HumanLoopName: {},
                  FlowDefinitionArn: {},
                  DataAttributes: {
                    type: "structure",
                    members: {
                      ContentClassifiers: {
                        type: "list",
                        member: {}
                      }
                    }
                  }
                }
              },
              ProjectVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ModerationLabels: {
                type: "list",
                member: {
                  shape: "S6f"
                }
              },
              ModerationModelVersion: {},
              HumanLoopActivationOutput: {
                type: "structure",
                members: {
                  HumanLoopArn: {},
                  HumanLoopActivationReasons: {
                    type: "list",
                    member: {}
                  },
                  HumanLoopActivationConditionsEvaluationResults: {
                    jsonvalue: true
                  }
                }
              },
              ProjectVersion: {}
            }
          }
        },
        DetectProtectiveEquipment: {
          input: {
            type: "structure",
            required: [
              "Image"
            ],
            members: {
              Image: {
                shape: "Sh"
              },
              SummarizationAttributes: {
                type: "structure",
                required: [
                  "MinConfidence",
                  "RequiredEquipmentTypes"
                ],
                members: {
                  MinConfidence: {
                    type: "float"
                  },
                  RequiredEquipmentTypes: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProtectiveEquipmentModelVersion: {},
              Persons: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    BodyParts: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Name: {},
                          Confidence: {
                            type: "float"
                          },
                          EquipmentDetections: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                BoundingBox: {
                                  shape: "Sq"
                                },
                                Confidence: {
                                  type: "float"
                                },
                                Type: {},
                                CoversBodyPart: {
                                  type: "structure",
                                  members: {
                                    Confidence: {
                                      type: "float"
                                    },
                                    Value: {
                                      type: "boolean"
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    BoundingBox: {
                      shape: "Sq"
                    },
                    Confidence: {
                      type: "float"
                    },
                    Id: {
                      type: "integer"
                    }
                  }
                }
              },
              Summary: {
                type: "structure",
                members: {
                  PersonsWithRequiredEquipment: {
                    shape: "S6z"
                  },
                  PersonsWithoutRequiredEquipment: {
                    shape: "S6z"
                  },
                  PersonsIndeterminate: {
                    shape: "S6z"
                  }
                }
              }
            }
          }
        },
        DetectText: {
          input: {
            type: "structure",
            required: [
              "Image"
            ],
            members: {
              Image: {
                shape: "Sh"
              },
              Filters: {
                type: "structure",
                members: {
                  WordFilter: {
                    shape: "S72"
                  },
                  RegionsOfInterest: {
                    shape: "S2v"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TextDetections: {
                type: "list",
                member: {
                  shape: "S77"
                }
              },
              TextModelVersion: {}
            }
          }
        },
        DisassociateFaces: {
          input: {
            type: "structure",
            required: [
              "CollectionId",
              "UserId",
              "FaceIds"
            ],
            members: {
              CollectionId: {},
              UserId: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              FaceIds: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DisassociatedFaces: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FaceId: {}
                  }
                }
              },
              UnsuccessfulFaceDisassociations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FaceId: {},
                    UserId: {},
                    Reasons: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              UserStatus: {}
            }
          }
        },
        DistributeDatasetEntries: {
          input: {
            type: "structure",
            required: [
              "Datasets"
            ],
            members: {
              Datasets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Arn"
                  ],
                  members: {
                    Arn: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetCelebrityInfo: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Urls: {
                shape: "S7o"
              },
              Name: {},
              KnownGender: {
                shape: "S7q"
              }
            }
          }
        },
        GetCelebrityRecognition: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              SortBy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobStatus: {},
              StatusMessage: {},
              VideoMetadata: {
                shape: "S7z"
              },
              NextToken: {},
              Celebrities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Timestamp: {
                      type: "long"
                    },
                    Celebrity: {
                      type: "structure",
                      members: {
                        Urls: {
                          shape: "S7o"
                        },
                        Name: {},
                        Id: {},
                        Confidence: {
                          type: "float"
                        },
                        BoundingBox: {
                          shape: "Sq"
                        },
                        Face: {
                          shape: "S53"
                        },
                        KnownGender: {
                          shape: "S7q"
                        }
                      }
                    }
                  }
                }
              },
              JobId: {},
              Video: {
                shape: "S85"
              },
              JobTag: {}
            }
          }
        },
        GetContentModeration: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              SortBy: {},
              AggregateBy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobStatus: {},
              StatusMessage: {},
              VideoMetadata: {
                shape: "S7z"
              },
              ModerationLabels: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Timestamp: {
                      type: "long"
                    },
                    ModerationLabel: {
                      shape: "S6f"
                    },
                    StartTimestampMillis: {
                      type: "long"
                    },
                    EndTimestampMillis: {
                      type: "long"
                    },
                    DurationMillis: {
                      type: "long"
                    }
                  }
                }
              },
              NextToken: {},
              ModerationModelVersion: {},
              JobId: {},
              Video: {
                shape: "S85"
              },
              JobTag: {},
              GetRequestMetadata: {
                type: "structure",
                members: {
                  SortBy: {},
                  AggregateBy: {}
                }
              }
            }
          }
        },
        GetFaceDetection: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobStatus: {},
              StatusMessage: {},
              VideoMetadata: {
                shape: "S7z"
              },
              NextToken: {},
              Faces: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Timestamp: {
                      type: "long"
                    },
                    Face: {
                      shape: "S53"
                    }
                  }
                }
              },
              JobId: {},
              Video: {
                shape: "S85"
              },
              JobTag: {}
            }
          }
        },
        GetFaceLivenessSessionResults: {
          input: {
            type: "structure",
            required: [
              "SessionId"
            ],
            members: {
              SessionId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "SessionId",
              "Status"
            ],
            members: {
              SessionId: {},
              Status: {},
              Confidence: {
                type: "float"
              },
              ReferenceImage: {
                shape: "S8l"
              },
              AuditImages: {
                type: "list",
                member: {
                  shape: "S8l"
                }
              }
            }
          }
        },
        GetFaceSearch: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              SortBy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobStatus: {},
              StatusMessage: {},
              NextToken: {},
              VideoMetadata: {
                shape: "S7z"
              },
              Persons: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Timestamp: {
                      type: "long"
                    },
                    Person: {
                      shape: "S8t"
                    },
                    FaceMatches: {
                      shape: "S8v"
                    }
                  }
                }
              },
              JobId: {},
              Video: {
                shape: "S85"
              },
              JobTag: {}
            }
          }
        },
        GetLabelDetection: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              SortBy: {},
              AggregateBy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobStatus: {},
              StatusMessage: {},
              VideoMetadata: {
                shape: "S7z"
              },
              NextToken: {},
              Labels: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Timestamp: {
                      type: "long"
                    },
                    Label: {
                      shape: "S5q"
                    },
                    StartTimestampMillis: {
                      type: "long"
                    },
                    EndTimestampMillis: {
                      type: "long"
                    },
                    DurationMillis: {
                      type: "long"
                    }
                  }
                }
              },
              LabelModelVersion: {},
              JobId: {},
              Video: {
                shape: "S85"
              },
              JobTag: {},
              GetRequestMetadata: {
                type: "structure",
                members: {
                  SortBy: {},
                  AggregateBy: {}
                }
              }
            }
          }
        },
        GetMediaAnalysisJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "JobId",
              "OperationsConfig",
              "Status",
              "CreationTimestamp",
              "Input",
              "OutputConfig"
            ],
            members: {
              JobId: {},
              JobName: {},
              OperationsConfig: {
                shape: "S9c"
              },
              Status: {},
              FailureDetails: {
                shape: "S9f"
              },
              CreationTimestamp: {
                type: "timestamp"
              },
              CompletionTimestamp: {
                type: "timestamp"
              },
              Input: {
                shape: "S9h"
              },
              OutputConfig: {
                shape: "S9i"
              },
              KmsKeyId: {},
              Results: {
                shape: "S9k"
              },
              ManifestSummary: {
                shape: "S9l"
              }
            }
          }
        },
        GetPersonTracking: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              SortBy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobStatus: {},
              StatusMessage: {},
              VideoMetadata: {
                shape: "S7z"
              },
              NextToken: {},
              Persons: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Timestamp: {
                      type: "long"
                    },
                    Person: {
                      shape: "S8t"
                    }
                  }
                }
              },
              JobId: {},
              Video: {
                shape: "S85"
              },
              JobTag: {}
            }
          }
        },
        GetSegmentDetection: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobStatus: {},
              StatusMessage: {},
              VideoMetadata: {
                type: "list",
                member: {
                  shape: "S7z"
                }
              },
              AudioMetadata: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Codec: {},
                    DurationMillis: {
                      type: "long"
                    },
                    SampleRate: {
                      type: "long"
                    },
                    NumberOfChannels: {
                      type: "long"
                    }
                  }
                }
              },
              NextToken: {},
              Segments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    StartTimestampMillis: {
                      type: "long"
                    },
                    EndTimestampMillis: {
                      type: "long"
                    },
                    DurationMillis: {
                      type: "long"
                    },
                    StartTimecodeSMPTE: {},
                    EndTimecodeSMPTE: {},
                    DurationSMPTE: {},
                    TechnicalCueSegment: {
                      type: "structure",
                      members: {
                        Type: {},
                        Confidence: {
                          type: "float"
                        }
                      }
                    },
                    ShotSegment: {
                      type: "structure",
                      members: {
                        Index: {
                          type: "long"
                        },
                        Confidence: {
                          type: "float"
                        }
                      }
                    },
                    StartFrameNumber: {
                      type: "long"
                    },
                    EndFrameNumber: {
                      type: "long"
                    },
                    DurationFrames: {
                      type: "long"
                    }
                  }
                }
              },
              SelectedSegmentTypes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    ModelVersion: {}
                  }
                }
              },
              JobId: {},
              Video: {
                shape: "S85"
              },
              JobTag: {}
            }
          }
        },
        GetTextDetection: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobStatus: {},
              StatusMessage: {},
              VideoMetadata: {
                shape: "S7z"
              },
              TextDetections: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Timestamp: {
                      type: "long"
                    },
                    TextDetection: {
                      shape: "S77"
                    }
                  }
                }
              },
              NextToken: {},
              TextModelVersion: {},
              JobId: {},
              Video: {
                shape: "S85"
              },
              JobTag: {}
            }
          }
        },
        IndexFaces: {
          input: {
            type: "structure",
            required: [
              "CollectionId",
              "Image"
            ],
            members: {
              CollectionId: {},
              Image: {
                shape: "Sh"
              },
              ExternalImageId: {},
              DetectionAttributes: {
                shape: "S4z"
              },
              MaxFaces: {
                type: "integer"
              },
              QualityFilter: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FaceRecords: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Face: {
                      shape: "S8x"
                    },
                    FaceDetail: {
                      shape: "S53"
                    }
                  }
                }
              },
              OrientationCorrection: {},
              FaceModelVersion: {},
              UnindexedFaces: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Reasons: {
                      type: "list",
                      member: {}
                    },
                    FaceDetail: {
                      shape: "S53"
                    }
                  }
                }
              }
            }
          }
        },
        ListCollections: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CollectionIds: {
                type: "list",
                member: {}
              },
              NextToken: {},
              FaceModelVersions: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ListDatasetEntries: {
          input: {
            type: "structure",
            required: [
              "DatasetArn"
            ],
            members: {
              DatasetArn: {},
              ContainsLabels: {
                type: "list",
                member: {}
              },
              Labeled: {
                type: "boolean"
              },
              SourceRefContains: {},
              HasErrors: {
                type: "boolean"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetEntries: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListDatasetLabels: {
          input: {
            type: "structure",
            required: [
              "DatasetArn"
            ],
            members: {
              DatasetArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetLabelDescriptions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LabelName: {},
                    LabelStats: {
                      type: "structure",
                      members: {
                        EntryCount: {
                          type: "integer"
                        },
                        BoundingBoxCount: {
                          type: "integer"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListFaces: {
          input: {
            type: "structure",
            required: [
              "CollectionId"
            ],
            members: {
              CollectionId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              UserId: {},
              FaceIds: {
                shape: "S39"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Faces: {
                type: "list",
                member: {
                  shape: "S8x"
                }
              },
              NextToken: {},
              FaceModelVersion: {}
            }
          }
        },
        ListMediaAnalysisJobs: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "MediaAnalysisJobs"
            ],
            members: {
              NextToken: {},
              MediaAnalysisJobs: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "JobId",
                    "OperationsConfig",
                    "Status",
                    "CreationTimestamp",
                    "Input",
                    "OutputConfig"
                  ],
                  members: {
                    JobId: {},
                    JobName: {},
                    OperationsConfig: {
                      shape: "S9c"
                    },
                    Status: {},
                    FailureDetails: {
                      shape: "S9f"
                    },
                    CreationTimestamp: {
                      type: "timestamp"
                    },
                    CompletionTimestamp: {
                      type: "timestamp"
                    },
                    Input: {
                      shape: "S9h"
                    },
                    OutputConfig: {
                      shape: "S9i"
                    },
                    KmsKeyId: {},
                    Results: {
                      shape: "S9k"
                    },
                    ManifestSummary: {
                      shape: "S9l"
                    }
                  }
                }
              }
            }
          }
        },
        ListProjectPolicies: {
          input: {
            type: "structure",
            required: [
              "ProjectArn"
            ],
            members: {
              ProjectArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProjectPolicies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ProjectArn: {},
                    PolicyName: {},
                    PolicyRevisionId: {},
                    PolicyDocument: {},
                    CreationTimestamp: {
                      type: "timestamp"
                    },
                    LastUpdatedTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListStreamProcessors: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              StreamProcessors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Status: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S1e"
              }
            }
          }
        },
        ListUsers: {
          input: {
            type: "structure",
            required: [
              "CollectionId"
            ],
            members: {
              CollectionId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Users: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    UserId: {},
                    UserStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        PutProjectPolicy: {
          input: {
            type: "structure",
            required: [
              "ProjectArn",
              "PolicyName",
              "PolicyDocument"
            ],
            members: {
              ProjectArn: {},
              PolicyName: {},
              PolicyRevisionId: {},
              PolicyDocument: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyRevisionId: {}
            }
          }
        },
        RecognizeCelebrities: {
          input: {
            type: "structure",
            required: [
              "Image"
            ],
            members: {
              Image: {
                shape: "Sh"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CelebrityFaces: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Urls: {
                      shape: "S7o"
                    },
                    Name: {},
                    Id: {},
                    Face: {
                      shape: "Su"
                    },
                    MatchConfidence: {
                      type: "float"
                    },
                    KnownGender: {
                      shape: "S7q"
                    }
                  }
                }
              },
              UnrecognizedFaces: {
                type: "list",
                member: {
                  shape: "Su"
                }
              },
              OrientationCorrection: {}
            }
          }
        },
        SearchFaces: {
          input: {
            type: "structure",
            required: [
              "CollectionId",
              "FaceId"
            ],
            members: {
              CollectionId: {},
              FaceId: {},
              MaxFaces: {
                type: "integer"
              },
              FaceMatchThreshold: {
                type: "float"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SearchedFaceId: {},
              FaceMatches: {
                shape: "S8v"
              },
              FaceModelVersion: {}
            }
          }
        },
        SearchFacesByImage: {
          input: {
            type: "structure",
            required: [
              "CollectionId",
              "Image"
            ],
            members: {
              CollectionId: {},
              Image: {
                shape: "Sh"
              },
              MaxFaces: {
                type: "integer"
              },
              FaceMatchThreshold: {
                type: "float"
              },
              QualityFilter: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SearchedFaceBoundingBox: {
                shape: "Sq"
              },
              SearchedFaceConfidence: {
                type: "float"
              },
              FaceMatches: {
                shape: "S8v"
              },
              FaceModelVersion: {}
            }
          }
        },
        SearchUsers: {
          input: {
            type: "structure",
            required: [
              "CollectionId"
            ],
            members: {
              CollectionId: {},
              UserId: {},
              FaceId: {},
              UserMatchThreshold: {
                type: "float"
              },
              MaxUsers: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserMatches: {
                shape: "Sc8"
              },
              FaceModelVersion: {},
              SearchedFace: {
                type: "structure",
                members: {
                  FaceId: {}
                }
              },
              SearchedUser: {
                type: "structure",
                members: {
                  UserId: {}
                }
              }
            }
          }
        },
        SearchUsersByImage: {
          input: {
            type: "structure",
            required: [
              "CollectionId",
              "Image"
            ],
            members: {
              CollectionId: {},
              Image: {
                shape: "Sh"
              },
              UserMatchThreshold: {
                type: "float"
              },
              MaxUsers: {
                type: "integer"
              },
              QualityFilter: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UserMatches: {
                shape: "Sc8"
              },
              FaceModelVersion: {},
              SearchedFace: {
                type: "structure",
                members: {
                  FaceDetail: {
                    shape: "S53"
                  }
                }
              },
              UnsearchedFaces: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FaceDetails: {
                      shape: "S53"
                    },
                    Reasons: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              }
            }
          }
        },
        StartCelebrityRecognition: {
          input: {
            type: "structure",
            required: [
              "Video"
            ],
            members: {
              Video: {
                shape: "S85"
              },
              ClientRequestToken: {},
              NotificationChannel: {
                shape: "Scl"
              },
              JobTag: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          },
          idempotent: true
        },
        StartContentModeration: {
          input: {
            type: "structure",
            required: [
              "Video"
            ],
            members: {
              Video: {
                shape: "S85"
              },
              MinConfidence: {
                type: "float"
              },
              ClientRequestToken: {},
              NotificationChannel: {
                shape: "Scl"
              },
              JobTag: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          },
          idempotent: true
        },
        StartFaceDetection: {
          input: {
            type: "structure",
            required: [
              "Video"
            ],
            members: {
              Video: {
                shape: "S85"
              },
              ClientRequestToken: {},
              NotificationChannel: {
                shape: "Scl"
              },
              FaceAttributes: {},
              JobTag: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          },
          idempotent: true
        },
        StartFaceSearch: {
          input: {
            type: "structure",
            required: [
              "Video",
              "CollectionId"
            ],
            members: {
              Video: {
                shape: "S85"
              },
              ClientRequestToken: {},
              FaceMatchThreshold: {
                type: "float"
              },
              CollectionId: {},
              NotificationChannel: {
                shape: "Scl"
              },
              JobTag: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          },
          idempotent: true
        },
        StartLabelDetection: {
          input: {
            type: "structure",
            required: [
              "Video"
            ],
            members: {
              Video: {
                shape: "S85"
              },
              ClientRequestToken: {},
              MinConfidence: {
                type: "float"
              },
              NotificationChannel: {
                shape: "Scl"
              },
              JobTag: {},
              Features: {
                type: "list",
                member: {}
              },
              Settings: {
                type: "structure",
                members: {
                  GeneralLabels: {
                    shape: "S5j"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          },
          idempotent: true
        },
        StartMediaAnalysisJob: {
          input: {
            type: "structure",
            required: [
              "OperationsConfig",
              "Input",
              "OutputConfig"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              JobName: {},
              OperationsConfig: {
                shape: "S9c"
              },
              Input: {
                shape: "S9h"
              },
              OutputConfig: {
                shape: "S9i"
              },
              KmsKeyId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          idempotent: true
        },
        StartPersonTracking: {
          input: {
            type: "structure",
            required: [
              "Video"
            ],
            members: {
              Video: {
                shape: "S85"
              },
              ClientRequestToken: {},
              NotificationChannel: {
                shape: "Scl"
              },
              JobTag: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          },
          idempotent: true
        },
        StartProjectVersion: {
          input: {
            type: "structure",
            required: [
              "ProjectVersionArn",
              "MinInferenceUnits"
            ],
            members: {
              ProjectVersionArn: {},
              MinInferenceUnits: {
                type: "integer"
              },
              MaxInferenceUnits: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {}
            }
          }
        },
        StartSegmentDetection: {
          input: {
            type: "structure",
            required: [
              "Video",
              "SegmentTypes"
            ],
            members: {
              Video: {
                shape: "S85"
              },
              ClientRequestToken: {},
              NotificationChannel: {
                shape: "Scl"
              },
              JobTag: {},
              Filters: {
                type: "structure",
                members: {
                  TechnicalCueFilter: {
                    type: "structure",
                    members: {
                      MinSegmentConfidence: {
                        type: "float"
                      },
                      BlackFrame: {
                        type: "structure",
                        members: {
                          MaxPixelThreshold: {
                            type: "float"
                          },
                          MinCoveragePercentage: {
                            type: "float"
                          }
                        }
                      }
                    }
                  },
                  ShotFilter: {
                    type: "structure",
                    members: {
                      MinSegmentConfidence: {
                        type: "float"
                      }
                    }
                  }
                }
              },
              SegmentTypes: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          },
          idempotent: true
        },
        StartStreamProcessor: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              StartSelector: {
                type: "structure",
                members: {
                  KVSStreamStartSelector: {
                    type: "structure",
                    members: {
                      ProducerTimestamp: {
                        type: "long"
                      },
                      FragmentNumber: {}
                    }
                  }
                }
              },
              StopSelector: {
                type: "structure",
                members: {
                  MaxDurationInSeconds: {
                    type: "long"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SessionId: {}
            }
          }
        },
        StartTextDetection: {
          input: {
            type: "structure",
            required: [
              "Video"
            ],
            members: {
              Video: {
                shape: "S85"
              },
              ClientRequestToken: {},
              NotificationChannel: {
                shape: "Scl"
              },
              JobTag: {},
              Filters: {
                type: "structure",
                members: {
                  WordFilter: {
                    shape: "S72"
                  },
                  RegionsOfInterest: {
                    shape: "S2v"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          },
          idempotent: true
        },
        StopProjectVersion: {
          input: {
            type: "structure",
            required: [
              "ProjectVersionArn"
            ],
            members: {
              ProjectVersionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {}
            }
          }
        },
        StopStreamProcessor: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S1e"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDatasetEntries: {
          input: {
            type: "structure",
            required: [
              "DatasetArn",
              "Changes"
            ],
            members: {
              DatasetArn: {},
              Changes: {
                type: "structure",
                required: [
                  "GroundTruth"
                ],
                members: {
                  GroundTruth: {
                    type: "blob"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateStreamProcessor: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              SettingsForUpdate: {
                type: "structure",
                members: {
                  ConnectedHomeForUpdate: {
                    type: "structure",
                    members: {
                      Labels: {
                        shape: "S2q"
                      },
                      MinConfidence: {
                        type: "float"
                      }
                    }
                  }
                }
              },
              RegionsOfInterestForUpdate: {
                shape: "S2v"
              },
              DataSharingPreferenceForUpdate: {
                shape: "S2z"
              },
              ParametersToDelete: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S4: {
          type: "list",
          member: {}
        },
        Sh: {
          type: "structure",
          members: {
            Bytes: {
              type: "blob"
            },
            S3Object: {
              shape: "Sj"
            }
          }
        },
        Sj: {
          type: "structure",
          members: {
            Bucket: {},
            Name: {},
            Version: {}
          }
        },
        Sq: {
          type: "structure",
          members: {
            Width: {
              type: "float"
            },
            Height: {
              type: "float"
            },
            Left: {
              type: "float"
            },
            Top: {
              type: "float"
            }
          }
        },
        Su: {
          type: "structure",
          members: {
            BoundingBox: {
              shape: "Sq"
            },
            Confidence: {
              type: "float"
            },
            Landmarks: {
              shape: "Sv"
            },
            Pose: {
              shape: "Sy"
            },
            Quality: {
              shape: "S10"
            },
            Emotions: {
              shape: "S11"
            },
            Smile: {
              shape: "S14"
            }
          }
        },
        Sv: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Type: {},
              X: {
                type: "float"
              },
              Y: {
                type: "float"
              }
            }
          }
        },
        Sy: {
          type: "structure",
          members: {
            Roll: {
              type: "float"
            },
            Yaw: {
              type: "float"
            },
            Pitch: {
              type: "float"
            }
          }
        },
        S10: {
          type: "structure",
          members: {
            Brightness: {
              type: "float"
            },
            Sharpness: {
              type: "float"
            }
          }
        },
        S11: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Type: {},
              Confidence: {
                type: "float"
              }
            }
          }
        },
        S14: {
          type: "structure",
          members: {
            Value: {
              type: "boolean"
            },
            Confidence: {
              type: "float"
            }
          }
        },
        S1c: {
          type: "structure",
          members: {
            S3Bucket: {},
            S3KeyPrefix: {}
          }
        },
        S1e: {
          type: "map",
          key: {},
          value: {}
        },
        S1p: {
          type: "structure",
          members: {
            S3Object: {
              shape: "Sj"
            }
          }
        },
        S26: {
          type: "structure",
          members: {
            Assets: {
              shape: "S27"
            }
          }
        },
        S27: {
          type: "list",
          member: {
            type: "structure",
            members: {
              GroundTruthManifest: {
                shape: "S1p"
              }
            }
          }
        },
        S29: {
          type: "structure",
          members: {
            Assets: {
              shape: "S27"
            },
            AutoCreate: {
              type: "boolean"
            }
          }
        },
        S2b: {
          type: "structure",
          members: {
            ContentModeration: {
              type: "structure",
              members: {
                ConfidenceThreshold: {
                  type: "float"
                }
              }
            }
          }
        },
        S2f: {
          type: "structure",
          members: {
            KinesisVideoStream: {
              type: "structure",
              members: {
                Arn: {}
              }
            }
          }
        },
        S2i: {
          type: "structure",
          members: {
            KinesisDataStream: {
              type: "structure",
              members: {
                Arn: {}
              }
            },
            S3Destination: {
              type: "structure",
              members: {
                Bucket: {},
                KeyPrefix: {}
              }
            }
          }
        },
        S2n: {
          type: "structure",
          members: {
            FaceSearch: {
              type: "structure",
              members: {
                CollectionId: {},
                FaceMatchThreshold: {
                  type: "float"
                }
              }
            },
            ConnectedHome: {
              type: "structure",
              required: [
                "Labels"
              ],
              members: {
                Labels: {
                  shape: "S2q"
                },
                MinConfidence: {
                  type: "float"
                }
              }
            }
          }
        },
        S2q: {
          type: "list",
          member: {}
        },
        S2t: {
          type: "structure",
          required: [
            "SNSTopicArn"
          ],
          members: {
            SNSTopicArn: {}
          }
        },
        S2v: {
          type: "list",
          member: {
            type: "structure",
            members: {
              BoundingBox: {
                shape: "Sq"
              },
              Polygon: {
                shape: "S2x"
              }
            }
          }
        },
        S2x: {
          type: "list",
          member: {
            type: "structure",
            members: {
              X: {
                type: "float"
              },
              Y: {
                type: "float"
              }
            }
          }
        },
        S2z: {
          type: "structure",
          required: [
            "OptIn"
          ],
          members: {
            OptIn: {
              type: "boolean"
            }
          }
        },
        S39: {
          type: "list",
          member: {}
        },
        S4d: {
          type: "structure",
          members: {
            Assets: {
              shape: "S27"
            }
          }
        },
        S4x: {
          type: "structure",
          members: {
            BoundingBox: {
              shape: "Sq"
            },
            Polygon: {
              shape: "S2x"
            }
          }
        },
        S4z: {
          type: "list",
          member: {}
        },
        S53: {
          type: "structure",
          members: {
            BoundingBox: {
              shape: "Sq"
            },
            AgeRange: {
              type: "structure",
              members: {
                Low: {
                  type: "integer"
                },
                High: {
                  type: "integer"
                }
              }
            },
            Smile: {
              shape: "S14"
            },
            Eyeglasses: {
              type: "structure",
              members: {
                Value: {
                  type: "boolean"
                },
                Confidence: {
                  type: "float"
                }
              }
            },
            Sunglasses: {
              type: "structure",
              members: {
                Value: {
                  type: "boolean"
                },
                Confidence: {
                  type: "float"
                }
              }
            },
            Gender: {
              type: "structure",
              members: {
                Value: {},
                Confidence: {
                  type: "float"
                }
              }
            },
            Beard: {
              type: "structure",
              members: {
                Value: {
                  type: "boolean"
                },
                Confidence: {
                  type: "float"
                }
              }
            },
            Mustache: {
              type: "structure",
              members: {
                Value: {
                  type: "boolean"
                },
                Confidence: {
                  type: "float"
                }
              }
            },
            EyesOpen: {
              type: "structure",
              members: {
                Value: {
                  type: "boolean"
                },
                Confidence: {
                  type: "float"
                }
              }
            },
            MouthOpen: {
              type: "structure",
              members: {
                Value: {
                  type: "boolean"
                },
                Confidence: {
                  type: "float"
                }
              }
            },
            Emotions: {
              shape: "S11"
            },
            Landmarks: {
              shape: "Sv"
            },
            Pose: {
              shape: "Sy"
            },
            Quality: {
              shape: "S10"
            },
            Confidence: {
              type: "float"
            },
            FaceOccluded: {
              type: "structure",
              members: {
                Value: {
                  type: "boolean"
                },
                Confidence: {
                  type: "float"
                }
              }
            },
            EyeDirection: {
              type: "structure",
              members: {
                Yaw: {
                  type: "float"
                },
                Pitch: {
                  type: "float"
                },
                Confidence: {
                  type: "float"
                }
              }
            }
          }
        },
        S5j: {
          type: "structure",
          members: {
            LabelInclusionFilters: {
              shape: "S5k"
            },
            LabelExclusionFilters: {
              shape: "S5k"
            },
            LabelCategoryInclusionFilters: {
              shape: "S5k"
            },
            LabelCategoryExclusionFilters: {
              shape: "S5k"
            }
          }
        },
        S5k: {
          type: "list",
          member: {}
        },
        S5q: {
          type: "structure",
          members: {
            Name: {},
            Confidence: {
              type: "float"
            },
            Instances: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  BoundingBox: {
                    shape: "Sq"
                  },
                  Confidence: {
                    type: "float"
                  },
                  DominantColors: {
                    shape: "S5t"
                  }
                }
              }
            },
            Parents: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Name: {}
                }
              }
            },
            Aliases: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Name: {}
                }
              }
            },
            Categories: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Name: {}
                }
              }
            }
          }
        },
        S5t: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Red: {
                type: "integer"
              },
              Blue: {
                type: "integer"
              },
              Green: {
                type: "integer"
              },
              HexCode: {},
              CSSColor: {},
              SimplifiedColor: {},
              PixelPercent: {
                type: "float"
              }
            }
          }
        },
        S62: {
          type: "structure",
          members: {
            Brightness: {
              type: "float"
            },
            Sharpness: {
              type: "float"
            },
            Contrast: {
              type: "float"
            }
          }
        },
        S6f: {
          type: "structure",
          members: {
            Confidence: {
              type: "float"
            },
            Name: {},
            ParentName: {}
          }
        },
        S6z: {
          type: "list",
          member: {
            type: "integer"
          }
        },
        S72: {
          type: "structure",
          members: {
            MinConfidence: {
              type: "float"
            },
            MinBoundingBoxHeight: {
              type: "float"
            },
            MinBoundingBoxWidth: {
              type: "float"
            }
          }
        },
        S77: {
          type: "structure",
          members: {
            DetectedText: {},
            Type: {},
            Id: {
              type: "integer"
            },
            ParentId: {
              type: "integer"
            },
            Confidence: {
              type: "float"
            },
            Geometry: {
              shape: "S4x"
            }
          }
        },
        S7o: {
          type: "list",
          member: {}
        },
        S7q: {
          type: "structure",
          members: {
            Type: {}
          }
        },
        S7z: {
          type: "structure",
          members: {
            Codec: {},
            DurationMillis: {
              type: "long"
            },
            Format: {},
            FrameRate: {
              type: "float"
            },
            FrameHeight: {
              type: "long"
            },
            FrameWidth: {
              type: "long"
            },
            ColorRange: {}
          }
        },
        S85: {
          type: "structure",
          members: {
            S3Object: {
              shape: "Sj"
            }
          }
        },
        S8l: {
          type: "structure",
          members: {
            Bytes: {
              type: "blob",
              sensitive: true
            },
            S3Object: {
              shape: "Sj"
            },
            BoundingBox: {
              shape: "Sq"
            }
          }
        },
        S8t: {
          type: "structure",
          members: {
            Index: {
              type: "long"
            },
            BoundingBox: {
              shape: "Sq"
            },
            Face: {
              shape: "S53"
            }
          }
        },
        S8v: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Similarity: {
                type: "float"
              },
              Face: {
                shape: "S8x"
              }
            }
          }
        },
        S8x: {
          type: "structure",
          members: {
            FaceId: {},
            BoundingBox: {
              shape: "Sq"
            },
            ImageId: {},
            ExternalImageId: {},
            Confidence: {
              type: "float"
            },
            IndexFacesModelVersion: {},
            UserId: {}
          }
        },
        S9c: {
          type: "structure",
          members: {
            DetectModerationLabels: {
              type: "structure",
              members: {
                MinConfidence: {
                  type: "float"
                },
                ProjectVersion: {}
              }
            }
          }
        },
        S9f: {
          type: "structure",
          members: {
            Code: {},
            Message: {}
          }
        },
        S9h: {
          type: "structure",
          required: [
            "S3Object"
          ],
          members: {
            S3Object: {
              shape: "Sj"
            }
          }
        },
        S9i: {
          type: "structure",
          required: [
            "S3Bucket"
          ],
          members: {
            S3Bucket: {},
            S3KeyPrefix: {}
          }
        },
        S9k: {
          type: "structure",
          members: {
            S3Object: {
              shape: "Sj"
            }
          }
        },
        S9l: {
          type: "structure",
          members: {
            S3Object: {
              shape: "Sj"
            }
          }
        },
        Sc8: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Similarity: {
                type: "float"
              },
              User: {
                type: "structure",
                members: {
                  UserId: {},
                  UserStatus: {}
                }
              }
            }
          }
        },
        Scl: {
          type: "structure",
          required: [
            "SNSTopicArn",
            "RoleArn"
          ],
          members: {
            SNSTopicArn: {},
            RoleArn: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/rekognition-2016-06-27.paginators.json
var require_rekognition_2016_06_27_paginators = __commonJS({
  "node_modules/aws-sdk/apis/rekognition-2016-06-27.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeProjectVersions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ProjectVersionDescriptions"
        },
        DescribeProjects: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ProjectDescriptions"
        },
        GetCelebrityRecognition: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetContentModeration: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetFaceDetection: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetFaceSearch: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetLabelDetection: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetPersonTracking: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetSegmentDetection: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetTextDetection: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListCollections: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "CollectionIds"
        },
        ListDatasetEntries: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "DatasetEntries"
        },
        ListDatasetLabels: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "DatasetLabelDescriptions"
        },
        ListFaces: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Faces"
        },
        ListMediaAnalysisJobs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListProjectPolicies: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ProjectPolicies"
        },
        ListStreamProcessors: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListUsers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Users"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/rekognition-2016-06-27.waiters2.json
var require_rekognition_2016_06_27_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/rekognition-2016-06-27.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        ProjectVersionTrainingCompleted: {
          description: "Wait until the ProjectVersion training completes.",
          operation: "DescribeProjectVersions",
          delay: 120,
          maxAttempts: 360,
          acceptors: [
            {
              state: "success",
              matcher: "pathAll",
              argument: "ProjectVersionDescriptions[].Status",
              expected: "TRAINING_COMPLETED"
            },
            {
              state: "failure",
              matcher: "pathAny",
              argument: "ProjectVersionDescriptions[].Status",
              expected: "TRAINING_FAILED"
            }
          ]
        },
        ProjectVersionRunning: {
          description: "Wait until the ProjectVersion is running.",
          delay: 30,
          maxAttempts: 40,
          operation: "DescribeProjectVersions",
          acceptors: [
            {
              state: "success",
              matcher: "pathAll",
              argument: "ProjectVersionDescriptions[].Status",
              expected: "RUNNING"
            },
            {
              state: "failure",
              matcher: "pathAny",
              argument: "ProjectVersionDescriptions[].Status",
              expected: "FAILED"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/rekognition.js
var require_rekognition = __commonJS({
  "node_modules/aws-sdk/clients/rekognition.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["rekognition"] = {};
    AWS2.Rekognition = Service.defineService("rekognition", ["2016-06-27"]);
    Object.defineProperty(apiLoader.services["rekognition"], "2016-06-27", {
      get: function get() {
        var model = require_rekognition_2016_06_27_min();
        model.paginators = require_rekognition_2016_06_27_paginators().pagination;
        model.waiters = require_rekognition_2016_06_27_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Rekognition;
  }
});

// node_modules/aws-sdk/apis/resourcegroupstaggingapi-2017-01-26.min.json
var require_resourcegroupstaggingapi_2017_01_26_min = __commonJS({
  "node_modules/aws-sdk/apis/resourcegroupstaggingapi-2017-01-26.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-01-26",
        endpointPrefix: "tagging",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Resource Groups Tagging API",
        serviceId: "Resource Groups Tagging API",
        signatureVersion: "v4",
        targetPrefix: "ResourceGroupsTaggingAPI_20170126",
        uid: "resourcegroupstaggingapi-2017-01-26"
      },
      operations: {
        DescribeReportCreation: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              Status: {},
              S3Location: {},
              ErrorMessage: {}
            }
          }
        },
        GetComplianceSummary: {
          input: {
            type: "structure",
            members: {
              TargetIdFilters: {
                type: "list",
                member: {}
              },
              RegionFilters: {
                type: "list",
                member: {}
              },
              ResourceTypeFilters: {
                shape: "Sb"
              },
              TagKeyFilters: {
                type: "list",
                member: {}
              },
              GroupBy: {
                type: "list",
                member: {}
              },
              MaxResults: {
                type: "integer"
              },
              PaginationToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LastUpdated: {},
                    TargetId: {},
                    TargetIdType: {},
                    Region: {},
                    ResourceType: {},
                    NonCompliantResources: {
                      type: "long"
                    }
                  }
                }
              },
              PaginationToken: {}
            }
          }
        },
        GetResources: {
          input: {
            type: "structure",
            members: {
              PaginationToken: {},
              TagFilters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Key: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              ResourcesPerPage: {
                type: "integer"
              },
              TagsPerPage: {
                type: "integer"
              },
              ResourceTypeFilters: {
                shape: "Sb"
              },
              IncludeComplianceDetails: {
                type: "boolean"
              },
              ExcludeCompliantResources: {
                type: "boolean"
              },
              ResourceARNList: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PaginationToken: {},
              ResourceTagMappingList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceARN: {},
                    Tags: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "Key",
                          "Value"
                        ],
                        members: {
                          Key: {},
                          Value: {}
                        }
                      }
                    },
                    ComplianceDetails: {
                      type: "structure",
                      members: {
                        NoncompliantKeys: {
                          shape: "S16"
                        },
                        KeysWithNoncompliantValues: {
                          shape: "S16"
                        },
                        ComplianceStatus: {
                          type: "boolean"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetTagKeys: {
          input: {
            type: "structure",
            members: {
              PaginationToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PaginationToken: {},
              TagKeys: {
                shape: "S16"
              }
            }
          }
        },
        GetTagValues: {
          input: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              PaginationToken: {},
              Key: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PaginationToken: {},
              TagValues: {
                type: "list",
                member: {}
              }
            }
          }
        },
        StartReportCreation: {
          input: {
            type: "structure",
            required: [
              "S3Bucket"
            ],
            members: {
              S3Bucket: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResources: {
          input: {
            type: "structure",
            required: [
              "ResourceARNList",
              "Tags"
            ],
            members: {
              ResourceARNList: {
                shape: "S1h"
              },
              Tags: {
                type: "map",
                key: {},
                value: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedResourcesMap: {
                shape: "S1k"
              }
            }
          }
        },
        UntagResources: {
          input: {
            type: "structure",
            required: [
              "ResourceARNList",
              "TagKeys"
            ],
            members: {
              ResourceARNList: {
                shape: "S1h"
              },
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedResourcesMap: {
                shape: "S1k"
              }
            }
          }
        }
      },
      shapes: {
        Sb: {
          type: "list",
          member: {}
        },
        S16: {
          type: "list",
          member: {}
        },
        S1h: {
          type: "list",
          member: {}
        },
        S1k: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              StatusCode: {
                type: "integer"
              },
              ErrorCode: {},
              ErrorMessage: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/resourcegroupstaggingapi-2017-01-26.paginators.json
var require_resourcegroupstaggingapi_2017_01_26_paginators = __commonJS({
  "node_modules/aws-sdk/apis/resourcegroupstaggingapi-2017-01-26.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetComplianceSummary: {
          input_token: "PaginationToken",
          limit_key: "MaxResults",
          output_token: "PaginationToken",
          result_key: "SummaryList"
        },
        GetResources: {
          input_token: "PaginationToken",
          limit_key: "ResourcesPerPage",
          output_token: "PaginationToken",
          result_key: "ResourceTagMappingList"
        },
        GetTagKeys: {
          input_token: "PaginationToken",
          output_token: "PaginationToken",
          result_key: "TagKeys"
        },
        GetTagValues: {
          input_token: "PaginationToken",
          output_token: "PaginationToken",
          result_key: "TagValues"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/resourcegroupstaggingapi.js
var require_resourcegroupstaggingapi = __commonJS({
  "node_modules/aws-sdk/clients/resourcegroupstaggingapi.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["resourcegroupstaggingapi"] = {};
    AWS2.ResourceGroupsTaggingAPI = Service.defineService("resourcegroupstaggingapi", ["2017-01-26"]);
    Object.defineProperty(apiLoader.services["resourcegroupstaggingapi"], "2017-01-26", {
      get: function get() {
        var model = require_resourcegroupstaggingapi_2017_01_26_min();
        model.paginators = require_resourcegroupstaggingapi_2017_01_26_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ResourceGroupsTaggingAPI;
  }
});

// node_modules/aws-sdk/lib/services/route53.js
var require_route53 = __commonJS({
  "node_modules/aws-sdk/lib/services/route53.js"() {
    "use strict";
    var AWS2 = require_core();
    AWS2.util.update(AWS2.Route53.prototype, {
      /**
       * @api private
       */
      setupRequestListeners: function setupRequestListeners(request) {
        request.on("build", this.sanitizeUrl);
      },
      /**
       * @api private
       */
      sanitizeUrl: function sanitizeUrl(request) {
        var path = request.httpRequest.path;
        request.httpRequest.path = path.replace(/\/%2F\w+%2F/, "/");
      },
      /**
       * @return [Boolean] whether the error can be retried
       * @api private
       */
      retryableError: function retryableError(error) {
        if (error.code === "PriorRequestNotComplete" && error.statusCode === 400) {
          return true;
        } else {
          var _super = AWS2.Service.prototype.retryableError;
          return _super.call(this, error);
        }
      }
    });
  }
});

// node_modules/aws-sdk/apis/route53-2013-04-01.min.json
var require_route53_2013_04_01_min = __commonJS({
  "node_modules/aws-sdk/apis/route53-2013-04-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2013-04-01",
        endpointPrefix: "route53",
        globalEndpoint: "route53.amazonaws.com",
        protocol: "rest-xml",
        serviceAbbreviation: "Route 53",
        serviceFullName: "Amazon Route 53",
        serviceId: "Route 53",
        signatureVersion: "v4",
        uid: "route53-2013-04-01"
      },
      operations: {
        ActivateKeySigningKey: {
          http: {
            requestUri: "/2013-04-01/keysigningkey/{HostedZoneId}/{Name}/activate"
          },
          input: {
            type: "structure",
            required: [
              "HostedZoneId",
              "Name"
            ],
            members: {
              HostedZoneId: {
                location: "uri",
                locationName: "HostedZoneId"
              },
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ChangeInfo"
            ],
            members: {
              ChangeInfo: {
                shape: "S5"
              }
            }
          }
        },
        AssociateVPCWithHostedZone: {
          http: {
            requestUri: "/2013-04-01/hostedzone/{Id}/associatevpc"
          },
          input: {
            locationName: "AssociateVPCWithHostedZoneRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "HostedZoneId",
              "VPC"
            ],
            members: {
              HostedZoneId: {
                location: "uri",
                locationName: "Id"
              },
              VPC: {
                shape: "Sa"
              },
              Comment: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ChangeInfo"
            ],
            members: {
              ChangeInfo: {
                shape: "S5"
              }
            }
          }
        },
        ChangeCidrCollection: {
          http: {
            requestUri: "/2013-04-01/cidrcollection/{CidrCollectionId}"
          },
          input: {
            locationName: "ChangeCidrCollectionRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "Id",
              "Changes"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "CidrCollectionId"
              },
              CollectionVersion: {
                type: "long"
              },
              Changes: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "LocationName",
                    "Action",
                    "CidrList"
                  ],
                  members: {
                    LocationName: {},
                    Action: {},
                    CidrList: {
                      type: "list",
                      member: {
                        locationName: "Cidr"
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          }
        },
        ChangeResourceRecordSets: {
          http: {
            requestUri: "/2013-04-01/hostedzone/{Id}/rrset/"
          },
          input: {
            locationName: "ChangeResourceRecordSetsRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "HostedZoneId",
              "ChangeBatch"
            ],
            members: {
              HostedZoneId: {
                location: "uri",
                locationName: "Id"
              },
              ChangeBatch: {
                type: "structure",
                required: [
                  "Changes"
                ],
                members: {
                  Comment: {},
                  Changes: {
                    type: "list",
                    member: {
                      locationName: "Change",
                      type: "structure",
                      required: [
                        "Action",
                        "ResourceRecordSet"
                      ],
                      members: {
                        Action: {},
                        ResourceRecordSet: {
                          shape: "Sv"
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ChangeInfo"
            ],
            members: {
              ChangeInfo: {
                shape: "S5"
              }
            }
          }
        },
        ChangeTagsForResource: {
          http: {
            requestUri: "/2013-04-01/tags/{ResourceType}/{ResourceId}"
          },
          input: {
            locationName: "ChangeTagsForResourceRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "ResourceType",
              "ResourceId"
            ],
            members: {
              ResourceType: {
                location: "uri",
                locationName: "ResourceType"
              },
              ResourceId: {
                location: "uri",
                locationName: "ResourceId"
              },
              AddTags: {
                shape: "S1l"
              },
              RemoveTagKeys: {
                type: "list",
                member: {
                  locationName: "Key"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateCidrCollection: {
          http: {
            requestUri: "/2013-04-01/cidrcollection",
            responseCode: 201
          },
          input: {
            locationName: "CreateCidrCollectionRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "Name",
              "CallerReference"
            ],
            members: {
              Name: {},
              CallerReference: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Collection: {
                type: "structure",
                members: {
                  Arn: {},
                  Id: {},
                  Name: {},
                  Version: {
                    type: "long"
                  }
                }
              },
              Location: {
                location: "header",
                locationName: "Location"
              }
            }
          }
        },
        CreateHealthCheck: {
          http: {
            requestUri: "/2013-04-01/healthcheck",
            responseCode: 201
          },
          input: {
            locationName: "CreateHealthCheckRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "CallerReference",
              "HealthCheckConfig"
            ],
            members: {
              CallerReference: {},
              HealthCheckConfig: {
                shape: "S20"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HealthCheck",
              "Location"
            ],
            members: {
              HealthCheck: {
                shape: "S2n"
              },
              Location: {
                location: "header",
                locationName: "Location"
              }
            }
          }
        },
        CreateHostedZone: {
          http: {
            requestUri: "/2013-04-01/hostedzone",
            responseCode: 201
          },
          input: {
            locationName: "CreateHostedZoneRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "Name",
              "CallerReference"
            ],
            members: {
              Name: {},
              VPC: {
                shape: "Sa"
              },
              CallerReference: {},
              HostedZoneConfig: {
                shape: "S34"
              },
              DelegationSetId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "HostedZone",
              "ChangeInfo",
              "DelegationSet",
              "Location"
            ],
            members: {
              HostedZone: {
                shape: "S37"
              },
              ChangeInfo: {
                shape: "S5"
              },
              DelegationSet: {
                shape: "S39"
              },
              VPC: {
                shape: "Sa"
              },
              Location: {
                location: "header",
                locationName: "Location"
              }
            }
          }
        },
        CreateKeySigningKey: {
          http: {
            requestUri: "/2013-04-01/keysigningkey",
            responseCode: 201
          },
          input: {
            locationName: "CreateKeySigningKeyRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "CallerReference",
              "HostedZoneId",
              "KeyManagementServiceArn",
              "Name",
              "Status"
            ],
            members: {
              CallerReference: {},
              HostedZoneId: {},
              KeyManagementServiceArn: {},
              Name: {},
              Status: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ChangeInfo",
              "KeySigningKey",
              "Location"
            ],
            members: {
              ChangeInfo: {
                shape: "S5"
              },
              KeySigningKey: {
                shape: "S3f"
              },
              Location: {
                location: "header",
                locationName: "Location"
              }
            }
          }
        },
        CreateQueryLoggingConfig: {
          http: {
            requestUri: "/2013-04-01/queryloggingconfig",
            responseCode: 201
          },
          input: {
            locationName: "CreateQueryLoggingConfigRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "HostedZoneId",
              "CloudWatchLogsLogGroupArn"
            ],
            members: {
              HostedZoneId: {},
              CloudWatchLogsLogGroupArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "QueryLoggingConfig",
              "Location"
            ],
            members: {
              QueryLoggingConfig: {
                shape: "S3m"
              },
              Location: {
                location: "header",
                locationName: "Location"
              }
            }
          }
        },
        CreateReusableDelegationSet: {
          http: {
            requestUri: "/2013-04-01/delegationset",
            responseCode: 201
          },
          input: {
            locationName: "CreateReusableDelegationSetRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "CallerReference"
            ],
            members: {
              CallerReference: {},
              HostedZoneId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "DelegationSet",
              "Location"
            ],
            members: {
              DelegationSet: {
                shape: "S39"
              },
              Location: {
                location: "header",
                locationName: "Location"
              }
            }
          }
        },
        CreateTrafficPolicy: {
          http: {
            requestUri: "/2013-04-01/trafficpolicy",
            responseCode: 201
          },
          input: {
            locationName: "CreateTrafficPolicyRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "Name",
              "Document"
            ],
            members: {
              Name: {},
              Document: {},
              Comment: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "TrafficPolicy",
              "Location"
            ],
            members: {
              TrafficPolicy: {
                shape: "S3v"
              },
              Location: {
                location: "header",
                locationName: "Location"
              }
            }
          }
        },
        CreateTrafficPolicyInstance: {
          http: {
            requestUri: "/2013-04-01/trafficpolicyinstance",
            responseCode: 201
          },
          input: {
            locationName: "CreateTrafficPolicyInstanceRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "HostedZoneId",
              "Name",
              "TTL",
              "TrafficPolicyId",
              "TrafficPolicyVersion"
            ],
            members: {
              HostedZoneId: {},
              Name: {},
              TTL: {
                type: "long"
              },
              TrafficPolicyId: {},
              TrafficPolicyVersion: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TrafficPolicyInstance",
              "Location"
            ],
            members: {
              TrafficPolicyInstance: {
                shape: "S40"
              },
              Location: {
                location: "header",
                locationName: "Location"
              }
            }
          }
        },
        CreateTrafficPolicyVersion: {
          http: {
            requestUri: "/2013-04-01/trafficpolicy/{Id}",
            responseCode: 201
          },
          input: {
            locationName: "CreateTrafficPolicyVersionRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "Id",
              "Document"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              Document: {},
              Comment: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "TrafficPolicy",
              "Location"
            ],
            members: {
              TrafficPolicy: {
                shape: "S3v"
              },
              Location: {
                location: "header",
                locationName: "Location"
              }
            }
          }
        },
        CreateVPCAssociationAuthorization: {
          http: {
            requestUri: "/2013-04-01/hostedzone/{Id}/authorizevpcassociation"
          },
          input: {
            locationName: "CreateVPCAssociationAuthorizationRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "HostedZoneId",
              "VPC"
            ],
            members: {
              HostedZoneId: {
                location: "uri",
                locationName: "Id"
              },
              VPC: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HostedZoneId",
              "VPC"
            ],
            members: {
              HostedZoneId: {},
              VPC: {
                shape: "Sa"
              }
            }
          }
        },
        DeactivateKeySigningKey: {
          http: {
            requestUri: "/2013-04-01/keysigningkey/{HostedZoneId}/{Name}/deactivate"
          },
          input: {
            type: "structure",
            required: [
              "HostedZoneId",
              "Name"
            ],
            members: {
              HostedZoneId: {
                location: "uri",
                locationName: "HostedZoneId"
              },
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ChangeInfo"
            ],
            members: {
              ChangeInfo: {
                shape: "S5"
              }
            }
          }
        },
        DeleteCidrCollection: {
          http: {
            method: "DELETE",
            requestUri: "/2013-04-01/cidrcollection/{CidrCollectionId}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "CidrCollectionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteHealthCheck: {
          http: {
            method: "DELETE",
            requestUri: "/2013-04-01/healthcheck/{HealthCheckId}"
          },
          input: {
            type: "structure",
            required: [
              "HealthCheckId"
            ],
            members: {
              HealthCheckId: {
                location: "uri",
                locationName: "HealthCheckId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteHostedZone: {
          http: {
            method: "DELETE",
            requestUri: "/2013-04-01/hostedzone/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ChangeInfo"
            ],
            members: {
              ChangeInfo: {
                shape: "S5"
              }
            }
          }
        },
        DeleteKeySigningKey: {
          http: {
            method: "DELETE",
            requestUri: "/2013-04-01/keysigningkey/{HostedZoneId}/{Name}"
          },
          input: {
            type: "structure",
            required: [
              "HostedZoneId",
              "Name"
            ],
            members: {
              HostedZoneId: {
                location: "uri",
                locationName: "HostedZoneId"
              },
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ChangeInfo"
            ],
            members: {
              ChangeInfo: {
                shape: "S5"
              }
            }
          }
        },
        DeleteQueryLoggingConfig: {
          http: {
            method: "DELETE",
            requestUri: "/2013-04-01/queryloggingconfig/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteReusableDelegationSet: {
          http: {
            method: "DELETE",
            requestUri: "/2013-04-01/delegationset/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteTrafficPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/2013-04-01/trafficpolicy/{Id}/{Version}"
          },
          input: {
            type: "structure",
            required: [
              "Id",
              "Version"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              Version: {
                location: "uri",
                locationName: "Version",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteTrafficPolicyInstance: {
          http: {
            method: "DELETE",
            requestUri: "/2013-04-01/trafficpolicyinstance/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteVPCAssociationAuthorization: {
          http: {
            requestUri: "/2013-04-01/hostedzone/{Id}/deauthorizevpcassociation"
          },
          input: {
            locationName: "DeleteVPCAssociationAuthorizationRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "HostedZoneId",
              "VPC"
            ],
            members: {
              HostedZoneId: {
                location: "uri",
                locationName: "Id"
              },
              VPC: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisableHostedZoneDNSSEC: {
          http: {
            requestUri: "/2013-04-01/hostedzone/{Id}/disable-dnssec"
          },
          input: {
            type: "structure",
            required: [
              "HostedZoneId"
            ],
            members: {
              HostedZoneId: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ChangeInfo"
            ],
            members: {
              ChangeInfo: {
                shape: "S5"
              }
            }
          }
        },
        DisassociateVPCFromHostedZone: {
          http: {
            requestUri: "/2013-04-01/hostedzone/{Id}/disassociatevpc"
          },
          input: {
            locationName: "DisassociateVPCFromHostedZoneRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "HostedZoneId",
              "VPC"
            ],
            members: {
              HostedZoneId: {
                location: "uri",
                locationName: "Id"
              },
              VPC: {
                shape: "Sa"
              },
              Comment: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ChangeInfo"
            ],
            members: {
              ChangeInfo: {
                shape: "S5"
              }
            }
          }
        },
        EnableHostedZoneDNSSEC: {
          http: {
            requestUri: "/2013-04-01/hostedzone/{Id}/enable-dnssec"
          },
          input: {
            type: "structure",
            required: [
              "HostedZoneId"
            ],
            members: {
              HostedZoneId: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ChangeInfo"
            ],
            members: {
              ChangeInfo: {
                shape: "S5"
              }
            }
          }
        },
        GetAccountLimit: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/accountlimit/{Type}"
          },
          input: {
            type: "structure",
            required: [
              "Type"
            ],
            members: {
              Type: {
                location: "uri",
                locationName: "Type"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Limit",
              "Count"
            ],
            members: {
              Limit: {
                type: "structure",
                required: [
                  "Type",
                  "Value"
                ],
                members: {
                  Type: {},
                  Value: {
                    type: "long"
                  }
                }
              },
              Count: {
                type: "long"
              }
            }
          }
        },
        GetChange: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/change/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ChangeInfo"
            ],
            members: {
              ChangeInfo: {
                shape: "S5"
              }
            }
          }
        },
        GetCheckerIpRanges: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/checkeripranges"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "CheckerIpRanges"
            ],
            members: {
              CheckerIpRanges: {
                type: "list",
                member: {}
              }
            }
          }
        },
        GetDNSSEC: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/hostedzone/{Id}/dnssec"
          },
          input: {
            type: "structure",
            required: [
              "HostedZoneId"
            ],
            members: {
              HostedZoneId: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Status",
              "KeySigningKeys"
            ],
            members: {
              Status: {
                type: "structure",
                members: {
                  ServeSignature: {},
                  StatusMessage: {}
                }
              },
              KeySigningKeys: {
                type: "list",
                member: {
                  shape: "S3f"
                }
              }
            }
          }
        },
        GetGeoLocation: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/geolocation"
          },
          input: {
            type: "structure",
            members: {
              ContinentCode: {
                location: "querystring",
                locationName: "continentcode"
              },
              CountryCode: {
                location: "querystring",
                locationName: "countrycode"
              },
              SubdivisionCode: {
                location: "querystring",
                locationName: "subdivisioncode"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "GeoLocationDetails"
            ],
            members: {
              GeoLocationDetails: {
                shape: "S5h"
              }
            }
          }
        },
        GetHealthCheck: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/healthcheck/{HealthCheckId}"
          },
          input: {
            type: "structure",
            required: [
              "HealthCheckId"
            ],
            members: {
              HealthCheckId: {
                location: "uri",
                locationName: "HealthCheckId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HealthCheck"
            ],
            members: {
              HealthCheck: {
                shape: "S2n"
              }
            }
          }
        },
        GetHealthCheckCount: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/healthcheckcount"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "HealthCheckCount"
            ],
            members: {
              HealthCheckCount: {
                type: "long"
              }
            }
          }
        },
        GetHealthCheckLastFailureReason: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/healthcheck/{HealthCheckId}/lastfailurereason"
          },
          input: {
            type: "structure",
            required: [
              "HealthCheckId"
            ],
            members: {
              HealthCheckId: {
                location: "uri",
                locationName: "HealthCheckId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HealthCheckObservations"
            ],
            members: {
              HealthCheckObservations: {
                shape: "S5s"
              }
            }
          }
        },
        GetHealthCheckStatus: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/healthcheck/{HealthCheckId}/status"
          },
          input: {
            type: "structure",
            required: [
              "HealthCheckId"
            ],
            members: {
              HealthCheckId: {
                location: "uri",
                locationName: "HealthCheckId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HealthCheckObservations"
            ],
            members: {
              HealthCheckObservations: {
                shape: "S5s"
              }
            }
          }
        },
        GetHostedZone: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/hostedzone/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HostedZone"
            ],
            members: {
              HostedZone: {
                shape: "S37"
              },
              DelegationSet: {
                shape: "S39"
              },
              VPCs: {
                shape: "S60"
              }
            }
          }
        },
        GetHostedZoneCount: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/hostedzonecount"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "HostedZoneCount"
            ],
            members: {
              HostedZoneCount: {
                type: "long"
              }
            }
          }
        },
        GetHostedZoneLimit: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/hostedzonelimit/{Id}/{Type}"
          },
          input: {
            type: "structure",
            required: [
              "Type",
              "HostedZoneId"
            ],
            members: {
              Type: {
                location: "uri",
                locationName: "Type"
              },
              HostedZoneId: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Limit",
              "Count"
            ],
            members: {
              Limit: {
                type: "structure",
                required: [
                  "Type",
                  "Value"
                ],
                members: {
                  Type: {},
                  Value: {
                    type: "long"
                  }
                }
              },
              Count: {
                type: "long"
              }
            }
          }
        },
        GetQueryLoggingConfig: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/queryloggingconfig/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "QueryLoggingConfig"
            ],
            members: {
              QueryLoggingConfig: {
                shape: "S3m"
              }
            }
          }
        },
        GetReusableDelegationSet: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/delegationset/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DelegationSet"
            ],
            members: {
              DelegationSet: {
                shape: "S39"
              }
            }
          }
        },
        GetReusableDelegationSetLimit: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/reusabledelegationsetlimit/{Id}/{Type}"
          },
          input: {
            type: "structure",
            required: [
              "Type",
              "DelegationSetId"
            ],
            members: {
              Type: {
                location: "uri",
                locationName: "Type"
              },
              DelegationSetId: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Limit",
              "Count"
            ],
            members: {
              Limit: {
                type: "structure",
                required: [
                  "Type",
                  "Value"
                ],
                members: {
                  Type: {},
                  Value: {
                    type: "long"
                  }
                }
              },
              Count: {
                type: "long"
              }
            }
          }
        },
        GetTrafficPolicy: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/trafficpolicy/{Id}/{Version}"
          },
          input: {
            type: "structure",
            required: [
              "Id",
              "Version"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              Version: {
                location: "uri",
                locationName: "Version",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TrafficPolicy"
            ],
            members: {
              TrafficPolicy: {
                shape: "S3v"
              }
            }
          }
        },
        GetTrafficPolicyInstance: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/trafficpolicyinstance/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TrafficPolicyInstance"
            ],
            members: {
              TrafficPolicyInstance: {
                shape: "S40"
              }
            }
          }
        },
        GetTrafficPolicyInstanceCount: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/trafficpolicyinstancecount"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "TrafficPolicyInstanceCount"
            ],
            members: {
              TrafficPolicyInstanceCount: {
                type: "integer"
              }
            }
          }
        },
        ListCidrBlocks: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/cidrcollection/{CidrCollectionId}/cidrblocks"
          },
          input: {
            type: "structure",
            required: [
              "CollectionId"
            ],
            members: {
              CollectionId: {
                location: "uri",
                locationName: "CidrCollectionId"
              },
              LocationName: {
                location: "querystring",
                locationName: "location"
              },
              NextToken: {
                location: "querystring",
                locationName: "nexttoken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxresults"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              CidrBlocks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CidrBlock: {},
                    LocationName: {}
                  }
                }
              }
            }
          }
        },
        ListCidrCollections: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/cidrcollection"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nexttoken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxresults"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              CidrCollections: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Id: {},
                    Name: {},
                    Version: {
                      type: "long"
                    }
                  }
                }
              }
            }
          }
        },
        ListCidrLocations: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/cidrcollection/{CidrCollectionId}"
          },
          input: {
            type: "structure",
            required: [
              "CollectionId"
            ],
            members: {
              CollectionId: {
                location: "uri",
                locationName: "CidrCollectionId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nexttoken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxresults"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              CidrLocations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LocationName: {}
                  }
                }
              }
            }
          }
        },
        ListGeoLocations: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/geolocations"
          },
          input: {
            type: "structure",
            members: {
              StartContinentCode: {
                location: "querystring",
                locationName: "startcontinentcode"
              },
              StartCountryCode: {
                location: "querystring",
                locationName: "startcountrycode"
              },
              StartSubdivisionCode: {
                location: "querystring",
                locationName: "startsubdivisioncode"
              },
              MaxItems: {
                location: "querystring",
                locationName: "maxitems"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "GeoLocationDetailsList",
              "IsTruncated",
              "MaxItems"
            ],
            members: {
              GeoLocationDetailsList: {
                type: "list",
                member: {
                  shape: "S5h",
                  locationName: "GeoLocationDetails"
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              NextContinentCode: {},
              NextCountryCode: {},
              NextSubdivisionCode: {},
              MaxItems: {}
            }
          }
        },
        ListHealthChecks: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/healthcheck"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "maxitems"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HealthChecks",
              "Marker",
              "IsTruncated",
              "MaxItems"
            ],
            members: {
              HealthChecks: {
                type: "list",
                member: {
                  shape: "S2n",
                  locationName: "HealthCheck"
                }
              },
              Marker: {},
              IsTruncated: {
                type: "boolean"
              },
              NextMarker: {},
              MaxItems: {}
            }
          }
        },
        ListHostedZones: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/hostedzone"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "maxitems"
              },
              DelegationSetId: {
                location: "querystring",
                locationName: "delegationsetid"
              },
              HostedZoneType: {
                location: "querystring",
                locationName: "hostedzonetype"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HostedZones",
              "Marker",
              "IsTruncated",
              "MaxItems"
            ],
            members: {
              HostedZones: {
                shape: "S7d"
              },
              Marker: {},
              IsTruncated: {
                type: "boolean"
              },
              NextMarker: {},
              MaxItems: {}
            }
          }
        },
        ListHostedZonesByName: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/hostedzonesbyname"
          },
          input: {
            type: "structure",
            members: {
              DNSName: {
                location: "querystring",
                locationName: "dnsname"
              },
              HostedZoneId: {
                location: "querystring",
                locationName: "hostedzoneid"
              },
              MaxItems: {
                location: "querystring",
                locationName: "maxitems"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HostedZones",
              "IsTruncated",
              "MaxItems"
            ],
            members: {
              HostedZones: {
                shape: "S7d"
              },
              DNSName: {},
              HostedZoneId: {},
              IsTruncated: {
                type: "boolean"
              },
              NextDNSName: {},
              NextHostedZoneId: {},
              MaxItems: {}
            }
          }
        },
        ListHostedZonesByVPC: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/hostedzonesbyvpc"
          },
          input: {
            type: "structure",
            required: [
              "VPCId",
              "VPCRegion"
            ],
            members: {
              VPCId: {
                location: "querystring",
                locationName: "vpcid"
              },
              VPCRegion: {
                location: "querystring",
                locationName: "vpcregion"
              },
              MaxItems: {
                location: "querystring",
                locationName: "maxitems"
              },
              NextToken: {
                location: "querystring",
                locationName: "nexttoken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HostedZoneSummaries",
              "MaxItems"
            ],
            members: {
              HostedZoneSummaries: {
                type: "list",
                member: {
                  locationName: "HostedZoneSummary",
                  type: "structure",
                  required: [
                    "HostedZoneId",
                    "Name",
                    "Owner"
                  ],
                  members: {
                    HostedZoneId: {},
                    Name: {},
                    Owner: {
                      type: "structure",
                      members: {
                        OwningAccount: {},
                        OwningService: {}
                      }
                    }
                  }
                }
              },
              MaxItems: {},
              NextToken: {}
            }
          }
        },
        ListQueryLoggingConfigs: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/queryloggingconfig"
          },
          input: {
            type: "structure",
            members: {
              HostedZoneId: {
                location: "querystring",
                locationName: "hostedzoneid"
              },
              NextToken: {
                location: "querystring",
                locationName: "nexttoken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxresults"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "QueryLoggingConfigs"
            ],
            members: {
              QueryLoggingConfigs: {
                type: "list",
                member: {
                  shape: "S3m",
                  locationName: "QueryLoggingConfig"
                }
              },
              NextToken: {}
            }
          }
        },
        ListResourceRecordSets: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/hostedzone/{Id}/rrset"
          },
          input: {
            type: "structure",
            required: [
              "HostedZoneId"
            ],
            members: {
              HostedZoneId: {
                location: "uri",
                locationName: "Id"
              },
              StartRecordName: {
                location: "querystring",
                locationName: "name"
              },
              StartRecordType: {
                location: "querystring",
                locationName: "type"
              },
              StartRecordIdentifier: {
                location: "querystring",
                locationName: "identifier"
              },
              MaxItems: {
                location: "querystring",
                locationName: "maxitems"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ResourceRecordSets",
              "IsTruncated",
              "MaxItems"
            ],
            members: {
              ResourceRecordSets: {
                type: "list",
                member: {
                  shape: "Sv",
                  locationName: "ResourceRecordSet"
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              NextRecordName: {},
              NextRecordType: {},
              NextRecordIdentifier: {},
              MaxItems: {}
            }
          }
        },
        ListReusableDelegationSets: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/delegationset"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "maxitems"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DelegationSets",
              "Marker",
              "IsTruncated",
              "MaxItems"
            ],
            members: {
              DelegationSets: {
                type: "list",
                member: {
                  shape: "S39",
                  locationName: "DelegationSet"
                }
              },
              Marker: {},
              IsTruncated: {
                type: "boolean"
              },
              NextMarker: {},
              MaxItems: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/tags/{ResourceType}/{ResourceId}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceType",
              "ResourceId"
            ],
            members: {
              ResourceType: {
                location: "uri",
                locationName: "ResourceType"
              },
              ResourceId: {
                location: "uri",
                locationName: "ResourceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ResourceTagSet"
            ],
            members: {
              ResourceTagSet: {
                shape: "S7y"
              }
            }
          }
        },
        ListTagsForResources: {
          http: {
            requestUri: "/2013-04-01/tags/{ResourceType}"
          },
          input: {
            locationName: "ListTagsForResourcesRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "ResourceType",
              "ResourceIds"
            ],
            members: {
              ResourceType: {
                location: "uri",
                locationName: "ResourceType"
              },
              ResourceIds: {
                type: "list",
                member: {
                  locationName: "ResourceId"
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ResourceTagSets"
            ],
            members: {
              ResourceTagSets: {
                type: "list",
                member: {
                  shape: "S7y",
                  locationName: "ResourceTagSet"
                }
              }
            }
          }
        },
        ListTrafficPolicies: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/trafficpolicies"
          },
          input: {
            type: "structure",
            members: {
              TrafficPolicyIdMarker: {
                location: "querystring",
                locationName: "trafficpolicyid"
              },
              MaxItems: {
                location: "querystring",
                locationName: "maxitems"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TrafficPolicySummaries",
              "IsTruncated",
              "TrafficPolicyIdMarker",
              "MaxItems"
            ],
            members: {
              TrafficPolicySummaries: {
                type: "list",
                member: {
                  locationName: "TrafficPolicySummary",
                  type: "structure",
                  required: [
                    "Id",
                    "Name",
                    "Type",
                    "LatestVersion",
                    "TrafficPolicyCount"
                  ],
                  members: {
                    Id: {},
                    Name: {},
                    Type: {},
                    LatestVersion: {
                      type: "integer"
                    },
                    TrafficPolicyCount: {
                      type: "integer"
                    }
                  }
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              TrafficPolicyIdMarker: {},
              MaxItems: {}
            }
          }
        },
        ListTrafficPolicyInstances: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/trafficpolicyinstances"
          },
          input: {
            type: "structure",
            members: {
              HostedZoneIdMarker: {
                location: "querystring",
                locationName: "hostedzoneid"
              },
              TrafficPolicyInstanceNameMarker: {
                location: "querystring",
                locationName: "trafficpolicyinstancename"
              },
              TrafficPolicyInstanceTypeMarker: {
                location: "querystring",
                locationName: "trafficpolicyinstancetype"
              },
              MaxItems: {
                location: "querystring",
                locationName: "maxitems"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TrafficPolicyInstances",
              "IsTruncated",
              "MaxItems"
            ],
            members: {
              TrafficPolicyInstances: {
                shape: "S89"
              },
              HostedZoneIdMarker: {},
              TrafficPolicyInstanceNameMarker: {},
              TrafficPolicyInstanceTypeMarker: {},
              IsTruncated: {
                type: "boolean"
              },
              MaxItems: {}
            }
          }
        },
        ListTrafficPolicyInstancesByHostedZone: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/trafficpolicyinstances/hostedzone"
          },
          input: {
            type: "structure",
            required: [
              "HostedZoneId"
            ],
            members: {
              HostedZoneId: {
                location: "querystring",
                locationName: "id"
              },
              TrafficPolicyInstanceNameMarker: {
                location: "querystring",
                locationName: "trafficpolicyinstancename"
              },
              TrafficPolicyInstanceTypeMarker: {
                location: "querystring",
                locationName: "trafficpolicyinstancetype"
              },
              MaxItems: {
                location: "querystring",
                locationName: "maxitems"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TrafficPolicyInstances",
              "IsTruncated",
              "MaxItems"
            ],
            members: {
              TrafficPolicyInstances: {
                shape: "S89"
              },
              TrafficPolicyInstanceNameMarker: {},
              TrafficPolicyInstanceTypeMarker: {},
              IsTruncated: {
                type: "boolean"
              },
              MaxItems: {}
            }
          }
        },
        ListTrafficPolicyInstancesByPolicy: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/trafficpolicyinstances/trafficpolicy"
          },
          input: {
            type: "structure",
            required: [
              "TrafficPolicyId",
              "TrafficPolicyVersion"
            ],
            members: {
              TrafficPolicyId: {
                location: "querystring",
                locationName: "id"
              },
              TrafficPolicyVersion: {
                location: "querystring",
                locationName: "version",
                type: "integer"
              },
              HostedZoneIdMarker: {
                location: "querystring",
                locationName: "hostedzoneid"
              },
              TrafficPolicyInstanceNameMarker: {
                location: "querystring",
                locationName: "trafficpolicyinstancename"
              },
              TrafficPolicyInstanceTypeMarker: {
                location: "querystring",
                locationName: "trafficpolicyinstancetype"
              },
              MaxItems: {
                location: "querystring",
                locationName: "maxitems"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TrafficPolicyInstances",
              "IsTruncated",
              "MaxItems"
            ],
            members: {
              TrafficPolicyInstances: {
                shape: "S89"
              },
              HostedZoneIdMarker: {},
              TrafficPolicyInstanceNameMarker: {},
              TrafficPolicyInstanceTypeMarker: {},
              IsTruncated: {
                type: "boolean"
              },
              MaxItems: {}
            }
          }
        },
        ListTrafficPolicyVersions: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/trafficpolicies/{Id}/versions"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              TrafficPolicyVersionMarker: {
                location: "querystring",
                locationName: "trafficpolicyversion"
              },
              MaxItems: {
                location: "querystring",
                locationName: "maxitems"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TrafficPolicies",
              "IsTruncated",
              "TrafficPolicyVersionMarker",
              "MaxItems"
            ],
            members: {
              TrafficPolicies: {
                type: "list",
                member: {
                  shape: "S3v",
                  locationName: "TrafficPolicy"
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              TrafficPolicyVersionMarker: {},
              MaxItems: {}
            }
          }
        },
        ListVPCAssociationAuthorizations: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/hostedzone/{Id}/authorizevpcassociation"
          },
          input: {
            type: "structure",
            required: [
              "HostedZoneId"
            ],
            members: {
              HostedZoneId: {
                location: "uri",
                locationName: "Id"
              },
              NextToken: {
                location: "querystring",
                locationName: "nexttoken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxresults"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HostedZoneId",
              "VPCs"
            ],
            members: {
              HostedZoneId: {},
              NextToken: {},
              VPCs: {
                shape: "S60"
              }
            }
          }
        },
        TestDNSAnswer: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/testdnsanswer"
          },
          input: {
            type: "structure",
            required: [
              "HostedZoneId",
              "RecordName",
              "RecordType"
            ],
            members: {
              HostedZoneId: {
                location: "querystring",
                locationName: "hostedzoneid"
              },
              RecordName: {
                location: "querystring",
                locationName: "recordname"
              },
              RecordType: {
                location: "querystring",
                locationName: "recordtype"
              },
              ResolverIP: {
                location: "querystring",
                locationName: "resolverip"
              },
              EDNS0ClientSubnetIP: {
                location: "querystring",
                locationName: "edns0clientsubnetip"
              },
              EDNS0ClientSubnetMask: {
                location: "querystring",
                locationName: "edns0clientsubnetmask"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Nameserver",
              "RecordName",
              "RecordType",
              "RecordData",
              "ResponseCode",
              "Protocol"
            ],
            members: {
              Nameserver: {},
              RecordName: {},
              RecordType: {},
              RecordData: {
                type: "list",
                member: {
                  locationName: "RecordDataEntry"
                }
              },
              ResponseCode: {},
              Protocol: {}
            }
          }
        },
        UpdateHealthCheck: {
          http: {
            requestUri: "/2013-04-01/healthcheck/{HealthCheckId}"
          },
          input: {
            locationName: "UpdateHealthCheckRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "HealthCheckId"
            ],
            members: {
              HealthCheckId: {
                location: "uri",
                locationName: "HealthCheckId"
              },
              HealthCheckVersion: {
                type: "long"
              },
              IPAddress: {},
              Port: {
                type: "integer"
              },
              ResourcePath: {},
              FullyQualifiedDomainName: {},
              SearchString: {},
              FailureThreshold: {
                type: "integer"
              },
              Inverted: {
                type: "boolean"
              },
              Disabled: {
                type: "boolean"
              },
              HealthThreshold: {
                type: "integer"
              },
              ChildHealthChecks: {
                shape: "S2d"
              },
              EnableSNI: {
                type: "boolean"
              },
              Regions: {
                shape: "S2f"
              },
              AlarmIdentifier: {
                shape: "S2h"
              },
              InsufficientDataHealthStatus: {},
              ResetElements: {
                type: "list",
                member: {
                  locationName: "ResettableElementName"
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HealthCheck"
            ],
            members: {
              HealthCheck: {
                shape: "S2n"
              }
            }
          }
        },
        UpdateHostedZoneComment: {
          http: {
            requestUri: "/2013-04-01/hostedzone/{Id}"
          },
          input: {
            locationName: "UpdateHostedZoneCommentRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              Comment: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "HostedZone"
            ],
            members: {
              HostedZone: {
                shape: "S37"
              }
            }
          }
        },
        UpdateTrafficPolicyComment: {
          http: {
            requestUri: "/2013-04-01/trafficpolicy/{Id}/{Version}"
          },
          input: {
            locationName: "UpdateTrafficPolicyCommentRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "Id",
              "Version",
              "Comment"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              Version: {
                location: "uri",
                locationName: "Version",
                type: "integer"
              },
              Comment: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "TrafficPolicy"
            ],
            members: {
              TrafficPolicy: {
                shape: "S3v"
              }
            }
          }
        },
        UpdateTrafficPolicyInstance: {
          http: {
            requestUri: "/2013-04-01/trafficpolicyinstance/{Id}"
          },
          input: {
            locationName: "UpdateTrafficPolicyInstanceRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "Id",
              "TTL",
              "TrafficPolicyId",
              "TrafficPolicyVersion"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              TTL: {
                type: "long"
              },
              TrafficPolicyId: {},
              TrafficPolicyVersion: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TrafficPolicyInstance"
            ],
            members: {
              TrafficPolicyInstance: {
                shape: "S40"
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          required: [
            "Id",
            "Status",
            "SubmittedAt"
          ],
          members: {
            Id: {},
            Status: {},
            SubmittedAt: {
              type: "timestamp"
            },
            Comment: {}
          }
        },
        Sa: {
          type: "structure",
          members: {
            VPCRegion: {},
            VPCId: {}
          }
        },
        Sv: {
          type: "structure",
          required: [
            "Name",
            "Type"
          ],
          members: {
            Name: {},
            Type: {},
            SetIdentifier: {},
            Weight: {
              type: "long"
            },
            Region: {},
            GeoLocation: {
              type: "structure",
              members: {
                ContinentCode: {},
                CountryCode: {},
                SubdivisionCode: {}
              }
            },
            Failover: {},
            MultiValueAnswer: {
              type: "boolean"
            },
            TTL: {
              type: "long"
            },
            ResourceRecords: {
              type: "list",
              member: {
                locationName: "ResourceRecord",
                type: "structure",
                required: [
                  "Value"
                ],
                members: {
                  Value: {}
                }
              }
            },
            AliasTarget: {
              type: "structure",
              required: [
                "HostedZoneId",
                "DNSName",
                "EvaluateTargetHealth"
              ],
              members: {
                HostedZoneId: {},
                DNSName: {},
                EvaluateTargetHealth: {
                  type: "boolean"
                }
              }
            },
            HealthCheckId: {},
            TrafficPolicyInstanceId: {},
            CidrRoutingConfig: {
              type: "structure",
              required: [
                "CollectionId",
                "LocationName"
              ],
              members: {
                CollectionId: {},
                LocationName: {}
              }
            }
          }
        },
        S1l: {
          type: "list",
          member: {
            locationName: "Tag",
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S20: {
          type: "structure",
          required: [
            "Type"
          ],
          members: {
            IPAddress: {},
            Port: {
              type: "integer"
            },
            Type: {},
            ResourcePath: {},
            FullyQualifiedDomainName: {},
            SearchString: {},
            RequestInterval: {
              type: "integer"
            },
            FailureThreshold: {
              type: "integer"
            },
            MeasureLatency: {
              type: "boolean"
            },
            Inverted: {
              type: "boolean"
            },
            Disabled: {
              type: "boolean"
            },
            HealthThreshold: {
              type: "integer"
            },
            ChildHealthChecks: {
              shape: "S2d"
            },
            EnableSNI: {
              type: "boolean"
            },
            Regions: {
              shape: "S2f"
            },
            AlarmIdentifier: {
              shape: "S2h"
            },
            InsufficientDataHealthStatus: {},
            RoutingControlArn: {}
          }
        },
        S2d: {
          type: "list",
          member: {
            locationName: "ChildHealthCheck"
          }
        },
        S2f: {
          type: "list",
          member: {
            locationName: "Region"
          }
        },
        S2h: {
          type: "structure",
          required: [
            "Region",
            "Name"
          ],
          members: {
            Region: {},
            Name: {}
          }
        },
        S2n: {
          type: "structure",
          required: [
            "Id",
            "CallerReference",
            "HealthCheckConfig",
            "HealthCheckVersion"
          ],
          members: {
            Id: {},
            CallerReference: {},
            LinkedService: {
              shape: "S2o"
            },
            HealthCheckConfig: {
              shape: "S20"
            },
            HealthCheckVersion: {
              type: "long"
            },
            CloudWatchAlarmConfiguration: {
              type: "structure",
              required: [
                "EvaluationPeriods",
                "Threshold",
                "ComparisonOperator",
                "Period",
                "MetricName",
                "Namespace",
                "Statistic"
              ],
              members: {
                EvaluationPeriods: {
                  type: "integer"
                },
                Threshold: {
                  type: "double"
                },
                ComparisonOperator: {},
                Period: {
                  type: "integer"
                },
                MetricName: {},
                Namespace: {},
                Statistic: {},
                Dimensions: {
                  type: "list",
                  member: {
                    locationName: "Dimension",
                    type: "structure",
                    required: [
                      "Name",
                      "Value"
                    ],
                    members: {
                      Name: {},
                      Value: {}
                    }
                  }
                }
              }
            }
          }
        },
        S2o: {
          type: "structure",
          members: {
            ServicePrincipal: {},
            Description: {}
          }
        },
        S34: {
          type: "structure",
          members: {
            Comment: {},
            PrivateZone: {
              type: "boolean"
            }
          }
        },
        S37: {
          type: "structure",
          required: [
            "Id",
            "Name",
            "CallerReference"
          ],
          members: {
            Id: {},
            Name: {},
            CallerReference: {},
            Config: {
              shape: "S34"
            },
            ResourceRecordSetCount: {
              type: "long"
            },
            LinkedService: {
              shape: "S2o"
            }
          }
        },
        S39: {
          type: "structure",
          required: [
            "NameServers"
          ],
          members: {
            Id: {},
            CallerReference: {},
            NameServers: {
              type: "list",
              member: {
                locationName: "NameServer"
              }
            }
          }
        },
        S3f: {
          type: "structure",
          members: {
            Name: {},
            KmsArn: {},
            Flag: {
              type: "integer"
            },
            SigningAlgorithmMnemonic: {},
            SigningAlgorithmType: {
              type: "integer"
            },
            DigestAlgorithmMnemonic: {},
            DigestAlgorithmType: {
              type: "integer"
            },
            KeyTag: {
              type: "integer"
            },
            DigestValue: {},
            PublicKey: {},
            DSRecord: {},
            DNSKEYRecord: {},
            Status: {},
            StatusMessage: {},
            CreatedDate: {
              type: "timestamp"
            },
            LastModifiedDate: {
              type: "timestamp"
            }
          }
        },
        S3m: {
          type: "structure",
          required: [
            "Id",
            "HostedZoneId",
            "CloudWatchLogsLogGroupArn"
          ],
          members: {
            Id: {},
            HostedZoneId: {},
            CloudWatchLogsLogGroupArn: {}
          }
        },
        S3v: {
          type: "structure",
          required: [
            "Id",
            "Version",
            "Name",
            "Type",
            "Document"
          ],
          members: {
            Id: {},
            Version: {
              type: "integer"
            },
            Name: {},
            Type: {},
            Document: {},
            Comment: {}
          }
        },
        S40: {
          type: "structure",
          required: [
            "Id",
            "HostedZoneId",
            "Name",
            "TTL",
            "State",
            "Message",
            "TrafficPolicyId",
            "TrafficPolicyVersion",
            "TrafficPolicyType"
          ],
          members: {
            Id: {},
            HostedZoneId: {},
            Name: {},
            TTL: {
              type: "long"
            },
            State: {},
            Message: {},
            TrafficPolicyId: {},
            TrafficPolicyVersion: {
              type: "integer"
            },
            TrafficPolicyType: {}
          }
        },
        S5h: {
          type: "structure",
          members: {
            ContinentCode: {},
            ContinentName: {},
            CountryCode: {},
            CountryName: {},
            SubdivisionCode: {},
            SubdivisionName: {}
          }
        },
        S5s: {
          type: "list",
          member: {
            locationName: "HealthCheckObservation",
            type: "structure",
            members: {
              Region: {},
              IPAddress: {},
              StatusReport: {
                type: "structure",
                members: {
                  Status: {},
                  CheckedTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        S60: {
          type: "list",
          member: {
            shape: "Sa",
            locationName: "VPC"
          }
        },
        S7d: {
          type: "list",
          member: {
            shape: "S37",
            locationName: "HostedZone"
          }
        },
        S7y: {
          type: "structure",
          members: {
            ResourceType: {},
            ResourceId: {},
            Tags: {
              shape: "S1l"
            }
          }
        },
        S89: {
          type: "list",
          member: {
            shape: "S40",
            locationName: "TrafficPolicyInstance"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/route53-2013-04-01.paginators.json
var require_route53_2013_04_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/route53-2013-04-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListCidrBlocks: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "CidrBlocks"
        },
        ListCidrCollections: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "CidrCollections"
        },
        ListCidrLocations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "CidrLocations"
        },
        ListHealthChecks: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "NextMarker",
          result_key: "HealthChecks"
        },
        ListHostedZones: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "NextMarker",
          result_key: "HostedZones"
        },
        ListQueryLoggingConfigs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "QueryLoggingConfigs"
        },
        ListResourceRecordSets: {
          input_token: [
            "StartRecordName",
            "StartRecordType",
            "StartRecordIdentifier"
          ],
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: [
            "NextRecordName",
            "NextRecordType",
            "NextRecordIdentifier"
          ],
          result_key: "ResourceRecordSets"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/route53-2013-04-01.waiters2.json
var require_route53_2013_04_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/route53-2013-04-01.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        ResourceRecordSetsChanged: {
          delay: 30,
          maxAttempts: 60,
          operation: "GetChange",
          acceptors: [
            {
              matcher: "path",
              expected: "INSYNC",
              argument: "ChangeInfo.Status",
              state: "success"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/route53.js
var require_route532 = __commonJS({
  "node_modules/aws-sdk/clients/route53.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["route53"] = {};
    AWS2.Route53 = Service.defineService("route53", ["2013-04-01"]);
    require_route53();
    Object.defineProperty(apiLoader.services["route53"], "2013-04-01", {
      get: function get() {
        var model = require_route53_2013_04_01_min();
        model.paginators = require_route53_2013_04_01_paginators().pagination;
        model.waiters = require_route53_2013_04_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Route53;
  }
});

// node_modules/aws-sdk/apis/route53domains-2014-05-15.min.json
var require_route53domains_2014_05_15_min = __commonJS({
  "node_modules/aws-sdk/apis/route53domains-2014-05-15.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-05-15",
        endpointPrefix: "route53domains",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Route 53 Domains",
        serviceId: "Route 53 Domains",
        signatureVersion: "v4",
        targetPrefix: "Route53Domains_v20140515",
        uid: "route53domains-2014-05-15"
      },
      operations: {
        AcceptDomainTransferFromAnotherAwsAccount: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Password"
            ],
            members: {
              DomainName: {},
              Password: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        AssociateDelegationSignerToDomain: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "SigningAttributes"
            ],
            members: {
              DomainName: {},
              SigningAttributes: {
                type: "structure",
                members: {
                  Algorithm: {
                    type: "integer"
                  },
                  Flags: {
                    type: "integer"
                  },
                  PublicKey: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        CancelDomainTransferToAnotherAwsAccount: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        CheckDomainAvailability: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              IdnLangCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Availability: {}
            }
          }
        },
        CheckDomainTransferability: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              AuthCode: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Transferability: {
                type: "structure",
                members: {
                  Transferable: {}
                }
              },
              Message: {}
            }
          }
        },
        DeleteDomain: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        DeleteTagsForDomain: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "TagsToDelete"
            ],
            members: {
              DomainName: {},
              TagsToDelete: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisableDomainAutoRenew: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisableDomainTransferLock: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        DisassociateDelegationSignerFromDomain: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Id"
            ],
            members: {
              DomainName: {},
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        EnableDomainAutoRenew: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        EnableDomainTransferLock: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        GetContactReachabilityStatus: {
          input: {
            type: "structure",
            members: {
              domainName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              domainName: {},
              status: {}
            }
          }
        },
        GetDomainDetail: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DomainName: {},
              Nameservers: {
                shape: "S19"
              },
              AutoRenew: {
                type: "boolean"
              },
              AdminContact: {
                shape: "S1f"
              },
              RegistrantContact: {
                shape: "S1f"
              },
              TechContact: {
                shape: "S1f"
              },
              AdminPrivacy: {
                type: "boolean"
              },
              RegistrantPrivacy: {
                type: "boolean"
              },
              TechPrivacy: {
                type: "boolean"
              },
              RegistrarName: {},
              WhoIsServer: {},
              RegistrarUrl: {},
              AbuseContactEmail: {
                shape: "S1o"
              },
              AbuseContactPhone: {
                shape: "S1n"
              },
              RegistryDomainId: {},
              CreationDate: {
                type: "timestamp"
              },
              UpdatedDate: {
                type: "timestamp"
              },
              ExpirationDate: {
                type: "timestamp"
              },
              Reseller: {},
              DnsSec: {},
              StatusList: {
                type: "list",
                member: {}
              },
              DnssecKeys: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Algorithm: {
                      type: "integer"
                    },
                    Flags: {
                      type: "integer"
                    },
                    PublicKey: {},
                    DigestType: {
                      type: "integer"
                    },
                    Digest: {},
                    KeyTag: {
                      type: "integer"
                    },
                    Id: {}
                  }
                }
              }
            }
          }
        },
        GetDomainSuggestions: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "SuggestionCount",
              "OnlyAvailable"
            ],
            members: {
              DomainName: {},
              SuggestionCount: {
                type: "integer"
              },
              OnlyAvailable: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SuggestionsList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DomainName: {},
                    Availability: {}
                  }
                }
              }
            }
          }
        },
        GetOperationDetail: {
          input: {
            type: "structure",
            required: [
              "OperationId"
            ],
            members: {
              OperationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {},
              Status: {},
              Message: {},
              DomainName: {},
              Type: {},
              SubmittedDate: {
                type: "timestamp"
              },
              LastUpdatedDate: {
                type: "timestamp"
              },
              StatusFlag: {}
            }
          }
        },
        ListDomains: {
          input: {
            type: "structure",
            members: {
              FilterConditions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Operator",
                    "Values"
                  ],
                  members: {
                    Name: {},
                    Operator: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              SortCondition: {
                type: "structure",
                required: [
                  "Name",
                  "SortOrder"
                ],
                members: {
                  Name: {},
                  SortOrder: {}
                }
              },
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Domains: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DomainName: {},
                    AutoRenew: {
                      type: "boolean"
                    },
                    TransferLock: {
                      type: "boolean"
                    },
                    Expiry: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextPageMarker: {}
            }
          }
        },
        ListOperations: {
          input: {
            type: "structure",
            members: {
              SubmittedSince: {
                type: "timestamp"
              },
              Marker: {},
              MaxItems: {
                type: "integer"
              },
              Status: {
                type: "list",
                member: {}
              },
              Type: {
                type: "list",
                member: {}
              },
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Operations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    OperationId: {},
                    Status: {},
                    Type: {},
                    SubmittedDate: {
                      type: "timestamp"
                    },
                    DomainName: {},
                    Message: {},
                    StatusFlag: {},
                    LastUpdatedDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextPageMarker: {}
            }
          }
        },
        ListPrices: {
          input: {
            type: "structure",
            members: {
              Tld: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Prices: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    RegistrationPrice: {
                      shape: "S37"
                    },
                    TransferPrice: {
                      shape: "S37"
                    },
                    RenewalPrice: {
                      shape: "S37"
                    },
                    ChangeOwnershipPrice: {
                      shape: "S37"
                    },
                    RestorationPrice: {
                      shape: "S37"
                    }
                  }
                }
              },
              NextPageMarker: {}
            }
          }
        },
        ListTagsForDomain: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TagList: {
                shape: "S3c"
              }
            }
          }
        },
        PushDomain: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Target"
            ],
            members: {
              DomainName: {},
              Target: {}
            }
          }
        },
        RegisterDomain: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "DurationInYears",
              "AdminContact",
              "RegistrantContact",
              "TechContact"
            ],
            members: {
              DomainName: {},
              IdnLangCode: {},
              DurationInYears: {
                type: "integer"
              },
              AutoRenew: {
                type: "boolean"
              },
              AdminContact: {
                shape: "S1f"
              },
              RegistrantContact: {
                shape: "S1f"
              },
              TechContact: {
                shape: "S1f"
              },
              PrivacyProtectAdminContact: {
                type: "boolean"
              },
              PrivacyProtectRegistrantContact: {
                type: "boolean"
              },
              PrivacyProtectTechContact: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        RejectDomainTransferFromAnotherAwsAccount: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        RenewDomain: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "CurrentExpiryYear"
            ],
            members: {
              DomainName: {},
              DurationInYears: {
                type: "integer"
              },
              CurrentExpiryYear: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        ResendContactReachabilityEmail: {
          input: {
            type: "structure",
            members: {
              domainName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              domainName: {},
              emailAddress: {
                shape: "S1o"
              },
              isAlreadyVerified: {
                type: "boolean"
              }
            }
          }
        },
        ResendOperationAuthorization: {
          input: {
            type: "structure",
            required: [
              "OperationId"
            ],
            members: {
              OperationId: {}
            }
          }
        },
        RetrieveDomainAuthCode: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AuthCode: {
                shape: "Si"
              }
            }
          }
        },
        TransferDomain: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "DurationInYears",
              "AdminContact",
              "RegistrantContact",
              "TechContact"
            ],
            members: {
              DomainName: {},
              IdnLangCode: {},
              DurationInYears: {
                type: "integer"
              },
              Nameservers: {
                shape: "S19"
              },
              AuthCode: {
                shape: "Si"
              },
              AutoRenew: {
                type: "boolean"
              },
              AdminContact: {
                shape: "S1f"
              },
              RegistrantContact: {
                shape: "S1f"
              },
              TechContact: {
                shape: "S1f"
              },
              PrivacyProtectAdminContact: {
                type: "boolean"
              },
              PrivacyProtectRegistrantContact: {
                type: "boolean"
              },
              PrivacyProtectTechContact: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        TransferDomainToAnotherAwsAccount: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "AccountId"
            ],
            members: {
              DomainName: {},
              AccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {},
              Password: {
                shape: "S3"
              }
            }
          }
        },
        UpdateDomainContact: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              AdminContact: {
                shape: "S1f"
              },
              RegistrantContact: {
                shape: "S1f"
              },
              TechContact: {
                shape: "S1f"
              },
              Consent: {
                type: "structure",
                required: [
                  "MaxPrice",
                  "Currency"
                ],
                members: {
                  MaxPrice: {
                    type: "double"
                  },
                  Currency: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        UpdateDomainContactPrivacy: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              AdminPrivacy: {
                type: "boolean"
              },
              RegistrantPrivacy: {
                type: "boolean"
              },
              TechPrivacy: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        UpdateDomainNameservers: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Nameservers"
            ],
            members: {
              DomainName: {},
              FIAuthKey: {
                deprecated: true,
                type: "string",
                sensitive: true
              },
              Nameservers: {
                shape: "S19"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        UpdateTagsForDomain: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              TagsToUpdate: {
                shape: "S3c"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ViewBilling: {
          input: {
            type: "structure",
            members: {
              Start: {
                type: "timestamp"
              },
              End: {
                type: "timestamp"
              },
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextPageMarker: {},
              BillingRecords: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DomainName: {},
                    Operation: {},
                    InvoiceId: {},
                    BillDate: {
                      type: "timestamp"
                    },
                    Price: {
                      type: "double"
                    }
                  }
                }
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "string",
          sensitive: true
        },
        Si: {
          type: "string",
          sensitive: true
        },
        S19: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              GlueIps: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S1f: {
          type: "structure",
          members: {
            FirstName: {
              shape: "S1g"
            },
            LastName: {
              shape: "S1g"
            },
            ContactType: {},
            OrganizationName: {
              shape: "S1g"
            },
            AddressLine1: {
              shape: "S1i"
            },
            AddressLine2: {
              shape: "S1i"
            },
            City: {
              type: "string",
              sensitive: true
            },
            State: {
              type: "string",
              sensitive: true
            },
            CountryCode: {
              type: "string",
              sensitive: true
            },
            ZipCode: {
              type: "string",
              sensitive: true
            },
            PhoneNumber: {
              shape: "S1n"
            },
            Email: {
              shape: "S1o"
            },
            Fax: {
              shape: "S1n"
            },
            ExtraParams: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name",
                  "Value"
                ],
                members: {
                  Name: {},
                  Value: {
                    type: "string",
                    sensitive: true
                  }
                }
              }
            }
          },
          sensitive: true
        },
        S1g: {
          type: "string",
          sensitive: true
        },
        S1i: {
          type: "string",
          sensitive: true
        },
        S1n: {
          type: "string",
          sensitive: true
        },
        S1o: {
          type: "string",
          sensitive: true
        },
        S37: {
          type: "structure",
          required: [
            "Price",
            "Currency"
          ],
          members: {
            Price: {
              type: "double"
            },
            Currency: {}
          }
        },
        S3c: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/route53domains-2014-05-15.paginators.json
var require_route53domains_2014_05_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/route53domains-2014-05-15.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListDomains: {
          input_token: "Marker",
          limit_key: "MaxItems",
          output_token: "NextPageMarker",
          result_key: "Domains"
        },
        ListOperations: {
          input_token: "Marker",
          limit_key: "MaxItems",
          output_token: "NextPageMarker",
          result_key: "Operations"
        },
        ListPrices: {
          input_token: "Marker",
          limit_key: "MaxItems",
          output_token: "NextPageMarker",
          result_key: "Prices"
        },
        ViewBilling: {
          input_token: "Marker",
          limit_key: "MaxItems",
          output_token: "NextPageMarker",
          result_key: "BillingRecords"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/route53domains.js
var require_route53domains = __commonJS({
  "node_modules/aws-sdk/clients/route53domains.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["route53domains"] = {};
    AWS2.Route53Domains = Service.defineService("route53domains", ["2014-05-15"]);
    Object.defineProperty(apiLoader.services["route53domains"], "2014-05-15", {
      get: function get() {
        var model = require_route53domains_2014_05_15_min();
        model.paginators = require_route53domains_2014_05_15_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Route53Domains;
  }
});

// node_modules/aws-sdk/lib/services/s3util.js
var require_s3util = __commonJS({
  "node_modules/aws-sdk/lib/services/s3util.js"(exports2, module2) {
    "use strict";
    var AWS2 = require_core();
    var regionUtil = require_region_config();
    var s3util = {
      /**
       * @api private
       */
      isArnInParam: function isArnInParam(req, paramName) {
        var inputShape = (req.service.api.operations[req.operation] || {}).input || {};
        var inputMembers = inputShape.members || {};
        if (!req.params[paramName] || !inputMembers[paramName])
          return false;
        return AWS2.util.ARN.validate(req.params[paramName]);
      },
      /**
       * Validate service component from ARN supplied in Bucket parameter
       */
      validateArnService: function validateArnService(req) {
        var parsedArn = req._parsedArn;
        if (parsedArn.service !== "s3" && parsedArn.service !== "s3-outposts" && parsedArn.service !== "s3-object-lambda") {
          throw AWS2.util.error(new Error(), {
            code: "InvalidARN",
            message: "expect 's3' or 's3-outposts' or 's3-object-lambda' in ARN service component"
          });
        }
      },
      /**
       * Validate account ID from ARN supplied in Bucket parameter is a valid account
       */
      validateArnAccount: function validateArnAccount(req) {
        var parsedArn = req._parsedArn;
        if (!/[0-9]{12}/.exec(parsedArn.accountId)) {
          throw AWS2.util.error(new Error(), {
            code: "InvalidARN",
            message: 'ARN accountID does not match regex "[0-9]{12}"'
          });
        }
      },
      /**
       * Validate ARN supplied in Bucket parameter is a valid access point ARN
       */
      validateS3AccessPointArn: function validateS3AccessPointArn(req) {
        var parsedArn = req._parsedArn;
        var delimiter = parsedArn.resource["accesspoint".length];
        if (parsedArn.resource.split(delimiter).length !== 2) {
          throw AWS2.util.error(new Error(), {
            code: "InvalidARN",
            message: "Access Point ARN should have one resource accesspoint/{accesspointName}"
          });
        }
        var accessPoint = parsedArn.resource.split(delimiter)[1];
        var accessPointPrefix = accessPoint + "-" + parsedArn.accountId;
        if (!s3util.dnsCompatibleBucketName(accessPointPrefix) || accessPointPrefix.match(/\./)) {
          throw AWS2.util.error(new Error(), {
            code: "InvalidARN",
            message: "Access point resource in ARN is not DNS compatible. Got " + accessPoint
          });
        }
        req._parsedArn.accessPoint = accessPoint;
      },
      /**
       * Validate Outposts ARN supplied in Bucket parameter is a valid outposts ARN
       */
      validateOutpostsArn: function validateOutpostsArn(req) {
        var parsedArn = req._parsedArn;
        if (parsedArn.resource.indexOf("outpost:") !== 0 && parsedArn.resource.indexOf("outpost/") !== 0) {
          throw AWS2.util.error(new Error(), {
            code: "InvalidARN",
            message: "ARN resource should begin with 'outpost/'"
          });
        }
        var delimiter = parsedArn.resource["outpost".length];
        var outpostId = parsedArn.resource.split(delimiter)[1];
        var dnsHostRegex = new RegExp(/^([a-zA-Z0-9]|[a-zA-Z0-9][a-zA-Z0-9-]{0,61}[a-zA-Z0-9])$/);
        if (!dnsHostRegex.test(outpostId)) {
          throw AWS2.util.error(new Error(), {
            code: "InvalidARN",
            message: "Outpost resource in ARN is not DNS compatible. Got " + outpostId
          });
        }
        req._parsedArn.outpostId = outpostId;
      },
      /**
       * Validate Outposts ARN supplied in Bucket parameter is a valid outposts ARN
       */
      validateOutpostsAccessPointArn: function validateOutpostsAccessPointArn(req) {
        var parsedArn = req._parsedArn;
        var delimiter = parsedArn.resource["outpost".length];
        if (parsedArn.resource.split(delimiter).length !== 4) {
          throw AWS2.util.error(new Error(), {
            code: "InvalidARN",
            message: "Outposts ARN should have two resources outpost/{outpostId}/accesspoint/{accesspointName}"
          });
        }
        var accessPoint = parsedArn.resource.split(delimiter)[3];
        var accessPointPrefix = accessPoint + "-" + parsedArn.accountId;
        if (!s3util.dnsCompatibleBucketName(accessPointPrefix) || accessPointPrefix.match(/\./)) {
          throw AWS2.util.error(new Error(), {
            code: "InvalidARN",
            message: "Access point resource in ARN is not DNS compatible. Got " + accessPoint
          });
        }
        req._parsedArn.accessPoint = accessPoint;
      },
      /**
       * Validate region field in ARN supplied in Bucket parameter is a valid region
       */
      validateArnRegion: function validateArnRegion(req, options) {
        if (options === void 0) {
          options = {};
        }
        var useArnRegion = s3util.loadUseArnRegionConfig(req);
        var regionFromArn = req._parsedArn.region;
        var clientRegion = req.service.config.region;
        var useFipsEndpoint = req.service.config.useFipsEndpoint;
        var allowFipsEndpoint = options.allowFipsEndpoint || false;
        if (!regionFromArn) {
          var message = "ARN region is empty";
          if (req._parsedArn.service === "s3") {
            message = message + "\nYou may want to use multi-regional ARN. The feature is not supported in current SDK. You should consider switching to V3(https://github.com/aws/aws-sdk-js-v3).";
          }
          throw AWS2.util.error(new Error(), {
            code: "InvalidARN",
            message
          });
        }
        if (useFipsEndpoint && !allowFipsEndpoint) {
          throw AWS2.util.error(new Error(), {
            code: "InvalidConfiguration",
            message: "ARN endpoint is not compatible with FIPS region"
          });
        }
        if (regionFromArn.indexOf("fips") >= 0) {
          throw AWS2.util.error(new Error(), {
            code: "InvalidConfiguration",
            message: "FIPS region not allowed in ARN"
          });
        }
        if (!useArnRegion && regionFromArn !== clientRegion) {
          throw AWS2.util.error(new Error(), {
            code: "InvalidConfiguration",
            message: "Configured region conflicts with access point region"
          });
        } else if (useArnRegion && regionUtil.getEndpointSuffix(regionFromArn) !== regionUtil.getEndpointSuffix(clientRegion)) {
          throw AWS2.util.error(new Error(), {
            code: "InvalidConfiguration",
            message: "Configured region and access point region not in same partition"
          });
        }
        if (req.service.config.useAccelerateEndpoint) {
          throw AWS2.util.error(new Error(), {
            code: "InvalidConfiguration",
            message: "useAccelerateEndpoint config is not supported with access point ARN"
          });
        }
        if (req._parsedArn.service === "s3-outposts" && req.service.config.useDualstackEndpoint) {
          throw AWS2.util.error(new Error(), {
            code: "InvalidConfiguration",
            message: "Dualstack is not supported with outposts access point ARN"
          });
        }
      },
      loadUseArnRegionConfig: function loadUseArnRegionConfig(req) {
        var envName = "AWS_S3_USE_ARN_REGION";
        var configName = "s3_use_arn_region";
        var useArnRegion = true;
        var originalConfig = req.service._originalConfig || {};
        if (req.service.config.s3UseArnRegion !== void 0) {
          return req.service.config.s3UseArnRegion;
        } else if (originalConfig.s3UseArnRegion !== void 0) {
          useArnRegion = originalConfig.s3UseArnRegion === true;
        } else if (AWS2.util.isNode()) {
          if (process.env[envName]) {
            var value = process.env[envName].trim().toLowerCase();
            if (["false", "true"].indexOf(value) < 0) {
              throw AWS2.util.error(new Error(), {
                code: "InvalidConfiguration",
                message: envName + " only accepts true or false. Got " + process.env[envName],
                retryable: false
              });
            }
            useArnRegion = value === "true";
          } else {
            var profiles = {};
            var profile = {};
            try {
              profiles = AWS2.util.getProfilesFromSharedConfig(AWS2.util.iniLoader);
              profile = profiles[process.env.AWS_PROFILE || AWS2.util.defaultProfile];
            } catch (e) {
            }
            if (profile[configName]) {
              if (["false", "true"].indexOf(profile[configName].trim().toLowerCase()) < 0) {
                throw AWS2.util.error(new Error(), {
                  code: "InvalidConfiguration",
                  message: configName + " only accepts true or false. Got " + profile[configName],
                  retryable: false
                });
              }
              useArnRegion = profile[configName].trim().toLowerCase() === "true";
            }
          }
        }
        req.service.config.s3UseArnRegion = useArnRegion;
        return useArnRegion;
      },
      /**
       * Validations before URI can be populated
       */
      validatePopulateUriFromArn: function validatePopulateUriFromArn(req) {
        if (req.service._originalConfig && req.service._originalConfig.endpoint) {
          throw AWS2.util.error(new Error(), {
            code: "InvalidConfiguration",
            message: "Custom endpoint is not compatible with access point ARN"
          });
        }
        if (req.service.config.s3ForcePathStyle) {
          throw AWS2.util.error(new Error(), {
            code: "InvalidConfiguration",
            message: "Cannot construct path-style endpoint with access point"
          });
        }
      },
      /**
       * Returns true if the bucket name is DNS compatible.  Buckets created
       * outside of the classic region MUST be DNS compatible.
       *
       * @api private
       */
      dnsCompatibleBucketName: function dnsCompatibleBucketName(bucketName) {
        var b = bucketName;
        var domain = new RegExp(/^[a-z0-9][a-z0-9\.\-]{1,61}[a-z0-9]$/);
        var ipAddress = new RegExp(/(\d+\.){3}\d+/);
        var dots = new RegExp(/\.\./);
        return b.match(domain) && !b.match(ipAddress) && !b.match(dots) ? true : false;
      }
    };
    module2.exports = s3util;
  }
});

// node_modules/aws-sdk/lib/s3/managed_upload.js
var require_managed_upload = __commonJS({
  "node_modules/aws-sdk/lib/s3/managed_upload.js"(exports2, module2) {
    "use strict";
    var AWS2 = require_core();
    var byteLength = AWS2.util.string.byteLength;
    var Buffer2 = AWS2.util.Buffer;
    AWS2.S3.ManagedUpload = AWS2.util.inherit({
      /**
       * Creates a managed upload object with a set of configuration options.
       *
       * @note A "Body" parameter is required to be set prior to calling {send}.
       * @note In Node.js, sending "Body" as {https://nodejs.org/dist/latest/docs/api/stream.html#stream_object_mode object-mode stream}
       *   may result in upload hangs. Using buffer stream is preferable.
       * @option options params [map] a map of parameters to pass to the upload
       *   requests. The "Body" parameter is required to be specified either on
       *   the service or in the params option.
       * @note ContentMD5 should not be provided when using the managed upload object.
       *   Instead, setting "computeChecksums" to true will enable automatic ContentMD5 generation
       *   by the managed upload object.
       * @option options queueSize [Number] (4) the size of the concurrent queue
       *   manager to upload parts in parallel. Set to 1 for synchronous uploading
       *   of parts. Note that the uploader will buffer at most queueSize * partSize
       *   bytes into memory at any given time.
       * @option options partSize [Number] (5mb) the size in bytes for each
       *   individual part to be uploaded. Adjust the part size to ensure the number
       *   of parts does not exceed {maxTotalParts}. See {minPartSize} for the
       *   minimum allowed part size.
       * @option options leavePartsOnError [Boolean] (false) whether to abort the
       *   multipart upload if an error occurs. Set to true if you want to handle
       *   failures manually.
       * @option options service [AWS.S3] an optional S3 service object to use for
       *   requests. This object might have bound parameters used by the uploader.
       * @option options tags [Array<map>] The tags to apply to the uploaded object.
       *   Each tag should have a `Key` and `Value` keys.
       * @example Creating a default uploader for a stream object
       *   var upload = new AWS.S3.ManagedUpload({
       *     params: {Bucket: 'bucket', Key: 'key', Body: stream}
       *   });
       * @example Creating an uploader with concurrency of 1 and partSize of 10mb
       *   var upload = new AWS.S3.ManagedUpload({
       *     partSize: 10 * 1024 * 1024, queueSize: 1,
       *     params: {Bucket: 'bucket', Key: 'key', Body: stream}
       *   });
       * @example Creating an uploader with tags
       *   var upload = new AWS.S3.ManagedUpload({
       *     params: {Bucket: 'bucket', Key: 'key', Body: stream},
       *     tags: [{Key: 'tag1', Value: 'value1'}, {Key: 'tag2', Value: 'value2'}]
       *   });
       * @see send
       */
      constructor: function ManagedUpload(options) {
        var self2 = this;
        AWS2.SequentialExecutor.call(self2);
        self2.body = null;
        self2.sliceFn = null;
        self2.callback = null;
        self2.parts = {};
        self2.completeInfo = [];
        self2.fillQueue = function() {
          self2.callback(new Error("Unsupported body payload " + typeof self2.body));
        };
        self2.configure(options);
      },
      /**
       * @api private
       */
      configure: function configure(options) {
        options = options || {};
        this.partSize = this.minPartSize;
        if (options.queueSize)
          this.queueSize = options.queueSize;
        if (options.partSize)
          this.partSize = options.partSize;
        if (options.leavePartsOnError)
          this.leavePartsOnError = true;
        if (options.tags) {
          if (!Array.isArray(options.tags)) {
            throw new Error("Tags must be specified as an array; " + typeof options.tags + " provided.");
          }
          this.tags = options.tags;
        }
        if (this.partSize < this.minPartSize) {
          throw new Error("partSize must be greater than " + this.minPartSize);
        }
        this.service = options.service;
        this.bindServiceObject(options.params);
        this.validateBody();
        this.adjustTotalBytes();
      },
      /**
       * @api private
       */
      leavePartsOnError: false,
      /**
       * @api private
       */
      queueSize: 4,
      /**
       * @api private
       */
      partSize: null,
      /**
       * @readonly
       * @return [Number] the minimum number of bytes for an individual part
       *   upload.
       */
      minPartSize: 1024 * 1024 * 5,
      /**
       * @readonly
       * @return [Number] the maximum allowed number of parts in a multipart upload.
       */
      maxTotalParts: 1e4,
      /**
       * Initiates the managed upload for the payload.
       *
       * @callback callback function(err, data)
       *   @param err [Error] an error or null if no error occurred.
       *   @param data [map] The response data from the successful upload:
       *     * `Location` (String) the URL of the uploaded object
       *     * `ETag` (String) the ETag of the uploaded object
       *     * `Bucket` (String) the bucket to which the object was uploaded
       *     * `Key` (String) the key to which the object was uploaded
       * @example Sending a managed upload object
       *   var params = {Bucket: 'bucket', Key: 'key', Body: stream};
       *   var upload = new AWS.S3.ManagedUpload({params: params});
       *   upload.send(function(err, data) {
       *     console.log(err, data);
       *   });
       */
      send: function(callback) {
        var self2 = this;
        self2.failed = false;
        self2.callback = callback || function(err) {
          if (err)
            throw err;
        };
        var runFill = true;
        if (self2.sliceFn) {
          self2.fillQueue = self2.fillBuffer;
        } else if (AWS2.util.isNode()) {
          var Stream = AWS2.util.stream.Stream;
          if (self2.body instanceof Stream) {
            runFill = false;
            self2.fillQueue = self2.fillStream;
            self2.partBuffers = [];
            self2.body.on("error", function(err) {
              self2.cleanup(err);
            }).on("readable", function() {
              self2.fillQueue();
            }).on("end", function() {
              self2.isDoneChunking = true;
              self2.numParts = self2.totalPartNumbers;
              self2.fillQueue.call(self2);
              if (self2.isDoneChunking && self2.totalPartNumbers >= 1 && self2.doneParts === self2.numParts) {
                self2.finishMultiPart();
              }
            });
          }
        }
        if (runFill)
          self2.fillQueue.call(self2);
      },
      /**
       * @!method  promise()
       *   Returns a 'thenable' promise.
       *
       *   Two callbacks can be provided to the `then` method on the returned promise.
       *   The first callback will be called if the promise is fulfilled, and the second
       *   callback will be called if the promise is rejected.
       *   @callback fulfilledCallback function(data)
       *     Called if the promise is fulfilled.
       *     @param data [map] The response data from the successful upload:
       *       `Location` (String) the URL of the uploaded object
       *       `ETag` (String) the ETag of the uploaded object
       *       `Bucket` (String) the bucket to which the object was uploaded
       *       `Key` (String) the key to which the object was uploaded
       *   @callback rejectedCallback function(err)
       *     Called if the promise is rejected.
       *     @param err [Error] an error or null if no error occurred.
       *   @return [Promise] A promise that represents the state of the upload request.
       *   @example Sending an upload request using promises.
       *     var upload = s3.upload({Bucket: 'bucket', Key: 'key', Body: stream});
       *     var promise = upload.promise();
       *     promise.then(function(data) { ... }, function(err) { ... });
       */
      /**
       * Aborts a managed upload, including all concurrent upload requests.
       * @note By default, calling this function will cleanup a multipart upload
       *   if one was created. To leave the multipart upload around after aborting
       *   a request, configure `leavePartsOnError` to `true` in the {constructor}.
       * @note Calling {abort} in the browser environment will not abort any requests
       *   that are already in flight. If a multipart upload was created, any parts
       *   not yet uploaded will not be sent, and the multipart upload will be cleaned up.
       * @example Aborting an upload
       *   var params = {
       *     Bucket: 'bucket', Key: 'key',
       *     Body: Buffer.alloc(1024 * 1024 * 25) // 25MB payload
       *   };
       *   var upload = s3.upload(params);
       *   upload.send(function (err, data) {
       *     if (err) console.log("Error:", err.code, err.message);
       *     else console.log(data);
       *   });
       *
       *   // abort request in 1 second
       *   setTimeout(upload.abort.bind(upload), 1000);
       */
      abort: function() {
        var self2 = this;
        if (self2.isDoneChunking === true && self2.totalPartNumbers === 1 && self2.singlePart) {
          self2.singlePart.abort();
        } else {
          self2.cleanup(AWS2.util.error(new Error("Request aborted by user"), {
            code: "RequestAbortedError",
            retryable: false
          }));
        }
      },
      /**
       * @api private
       */
      validateBody: function validateBody() {
        var self2 = this;
        self2.body = self2.service.config.params.Body;
        if (typeof self2.body === "string") {
          self2.body = AWS2.util.buffer.toBuffer(self2.body);
        } else if (!self2.body) {
          throw new Error("params.Body is required");
        }
        self2.sliceFn = AWS2.util.arraySliceFn(self2.body);
      },
      /**
       * @api private
       */
      bindServiceObject: function bindServiceObject(params) {
        params = params || {};
        var self2 = this;
        if (!self2.service) {
          self2.service = new AWS2.S3({ params });
        } else {
          var service = self2.service;
          var config = AWS2.util.copy(service.config);
          config.signatureVersion = service.getSignatureVersion();
          self2.service = new service.constructor.__super__(config);
          self2.service.config.params = AWS2.util.merge(self2.service.config.params || {}, params);
          Object.defineProperty(self2.service, "_originalConfig", {
            get: function() {
              return service._originalConfig;
            },
            enumerable: false,
            configurable: true
          });
        }
      },
      /**
       * @api private
       */
      adjustTotalBytes: function adjustTotalBytes() {
        var self2 = this;
        try {
          self2.totalBytes = byteLength(self2.body);
        } catch (e) {
        }
        if (self2.totalBytes) {
          var newPartSize = Math.ceil(self2.totalBytes / self2.maxTotalParts);
          if (newPartSize > self2.partSize)
            self2.partSize = newPartSize;
        } else {
          self2.totalBytes = void 0;
        }
      },
      /**
       * @api private
       */
      isDoneChunking: false,
      /**
       * @api private
       */
      partPos: 0,
      /**
       * @api private
       */
      totalChunkedBytes: 0,
      /**
       * @api private
       */
      totalUploadedBytes: 0,
      /**
       * @api private
       */
      totalBytes: void 0,
      /**
       * @api private
       */
      numParts: 0,
      /**
       * @api private
       */
      totalPartNumbers: 0,
      /**
       * @api private
       */
      activeParts: 0,
      /**
       * @api private
       */
      doneParts: 0,
      /**
       * @api private
       */
      parts: null,
      /**
       * @api private
       */
      completeInfo: null,
      /**
       * @api private
       */
      failed: false,
      /**
       * @api private
       */
      multipartReq: null,
      /**
       * @api private
       */
      partBuffers: null,
      /**
       * @api private
       */
      partBufferLength: 0,
      /**
       * @api private
       */
      fillBuffer: function fillBuffer() {
        var self2 = this;
        var bodyLen = byteLength(self2.body);
        if (bodyLen === 0) {
          self2.isDoneChunking = true;
          self2.numParts = 1;
          self2.nextChunk(self2.body);
          return;
        }
        while (self2.activeParts < self2.queueSize && self2.partPos < bodyLen) {
          var endPos = Math.min(self2.partPos + self2.partSize, bodyLen);
          var buf = self2.sliceFn.call(self2.body, self2.partPos, endPos);
          self2.partPos += self2.partSize;
          if (byteLength(buf) < self2.partSize || self2.partPos === bodyLen) {
            self2.isDoneChunking = true;
            self2.numParts = self2.totalPartNumbers + 1;
          }
          self2.nextChunk(buf);
        }
      },
      /**
       * @api private
       */
      fillStream: function fillStream() {
        var self2 = this;
        if (self2.activeParts >= self2.queueSize)
          return;
        var buf = self2.body.read(self2.partSize - self2.partBufferLength) || self2.body.read();
        if (buf) {
          self2.partBuffers.push(buf);
          self2.partBufferLength += buf.length;
          self2.totalChunkedBytes += buf.length;
        }
        if (self2.partBufferLength >= self2.partSize) {
          var pbuf = self2.partBuffers.length === 1 ? self2.partBuffers[0] : Buffer2.concat(self2.partBuffers);
          self2.partBuffers = [];
          self2.partBufferLength = 0;
          if (pbuf.length > self2.partSize) {
            var rest = pbuf.slice(self2.partSize);
            self2.partBuffers.push(rest);
            self2.partBufferLength += rest.length;
            pbuf = pbuf.slice(0, self2.partSize);
          }
          self2.nextChunk(pbuf);
        }
        if (self2.isDoneChunking && !self2.isDoneSending) {
          pbuf = self2.partBuffers.length === 1 ? self2.partBuffers[0] : Buffer2.concat(self2.partBuffers);
          self2.partBuffers = [];
          self2.partBufferLength = 0;
          self2.totalBytes = self2.totalChunkedBytes;
          self2.isDoneSending = true;
          if (self2.numParts === 0 || pbuf.length > 0) {
            self2.numParts++;
            self2.nextChunk(pbuf);
          }
        }
        self2.body.read(0);
      },
      /**
       * @api private
       */
      nextChunk: function nextChunk(chunk) {
        var self2 = this;
        if (self2.failed)
          return null;
        var partNumber = ++self2.totalPartNumbers;
        if (self2.isDoneChunking && partNumber === 1) {
          var params = { Body: chunk };
          if (this.tags) {
            params.Tagging = this.getTaggingHeader();
          }
          var req = self2.service.putObject(params);
          req._managedUpload = self2;
          req.on("httpUploadProgress", self2.progress).send(self2.finishSinglePart);
          self2.singlePart = req;
          return null;
        } else if (self2.service.config.params.ContentMD5) {
          var err = AWS2.util.error(new Error("The Content-MD5 you specified is invalid for multi-part uploads."), {
            code: "InvalidDigest",
            retryable: false
          });
          self2.cleanup(err);
          return null;
        }
        if (self2.completeInfo[partNumber] && self2.completeInfo[partNumber].ETag !== null) {
          return null;
        }
        self2.activeParts++;
        if (!self2.service.config.params.UploadId) {
          if (!self2.multipartReq) {
            self2.multipartReq = self2.service.createMultipartUpload();
            self2.multipartReq.on("success", function(resp) {
              self2.service.config.params.UploadId = resp.data.UploadId;
              self2.multipartReq = null;
            });
            self2.queueChunks(chunk, partNumber);
            self2.multipartReq.on("error", function(err2) {
              self2.cleanup(err2);
            });
            self2.multipartReq.send();
          } else {
            self2.queueChunks(chunk, partNumber);
          }
        } else {
          self2.uploadPart(chunk, partNumber);
        }
      },
      /**
       * @api private
       */
      getTaggingHeader: function getTaggingHeader() {
        var kvPairStrings = [];
        for (var i = 0; i < this.tags.length; i++) {
          kvPairStrings.push(AWS2.util.uriEscape(this.tags[i].Key) + "=" + AWS2.util.uriEscape(this.tags[i].Value));
        }
        return kvPairStrings.join("&");
      },
      /**
       * @api private
       */
      uploadPart: function uploadPart(chunk, partNumber) {
        var self2 = this;
        var partParams = {
          Body: chunk,
          ContentLength: AWS2.util.string.byteLength(chunk),
          PartNumber: partNumber
        };
        var partInfo = { ETag: null, PartNumber: partNumber };
        self2.completeInfo[partNumber] = partInfo;
        var req = self2.service.uploadPart(partParams);
        self2.parts[partNumber] = req;
        req._lastUploadedBytes = 0;
        req._managedUpload = self2;
        req.on("httpUploadProgress", self2.progress);
        req.send(function(err, data) {
          delete self2.parts[partParams.PartNumber];
          self2.activeParts--;
          if (!err && (!data || !data.ETag)) {
            var message = "No access to ETag property on response.";
            if (AWS2.util.isBrowser()) {
              message += " Check CORS configuration to expose ETag header.";
            }
            err = AWS2.util.error(new Error(message), {
              code: "ETagMissing",
              retryable: false
            });
          }
          if (err)
            return self2.cleanup(err);
          if (self2.completeInfo[partNumber] && self2.completeInfo[partNumber].ETag !== null)
            return null;
          partInfo.ETag = data.ETag;
          self2.doneParts++;
          if (self2.isDoneChunking && self2.doneParts === self2.totalPartNumbers) {
            self2.finishMultiPart();
          } else {
            self2.fillQueue.call(self2);
          }
        });
      },
      /**
       * @api private
       */
      queueChunks: function queueChunks(chunk, partNumber) {
        var self2 = this;
        self2.multipartReq.on("success", function() {
          self2.uploadPart(chunk, partNumber);
        });
      },
      /**
       * @api private
       */
      cleanup: function cleanup(err) {
        var self2 = this;
        if (self2.failed)
          return;
        if (typeof self2.body.removeAllListeners === "function" && typeof self2.body.resume === "function") {
          self2.body.removeAllListeners("readable");
          self2.body.removeAllListeners("end");
          self2.body.resume();
        }
        if (self2.multipartReq) {
          self2.multipartReq.removeAllListeners("success");
          self2.multipartReq.removeAllListeners("error");
          self2.multipartReq.removeAllListeners("complete");
          delete self2.multipartReq;
        }
        if (self2.service.config.params.UploadId && !self2.leavePartsOnError) {
          self2.service.abortMultipartUpload().send();
        } else if (self2.leavePartsOnError) {
          self2.isDoneChunking = false;
        }
        AWS2.util.each(self2.parts, function(partNumber, part) {
          part.removeAllListeners("complete");
          part.abort();
        });
        self2.activeParts = 0;
        self2.partPos = 0;
        self2.numParts = 0;
        self2.totalPartNumbers = 0;
        self2.parts = {};
        self2.failed = true;
        self2.callback(err);
      },
      /**
       * @api private
       */
      finishMultiPart: function finishMultiPart() {
        var self2 = this;
        var completeParams = { MultipartUpload: { Parts: self2.completeInfo.slice(1) } };
        self2.service.completeMultipartUpload(completeParams, function(err, data) {
          if (err) {
            return self2.cleanup(err);
          }
          if (data && typeof data.Location === "string") {
            data.Location = data.Location.replace(/%2F/g, "/");
          }
          if (Array.isArray(self2.tags)) {
            for (var i = 0; i < self2.tags.length; i++) {
              self2.tags[i].Value = String(self2.tags[i].Value);
            }
            self2.service.putObjectTagging(
              { Tagging: { TagSet: self2.tags } },
              function(e, d) {
                if (e) {
                  self2.callback(e);
                } else {
                  self2.callback(e, data);
                }
              }
            );
          } else {
            self2.callback(err, data);
          }
        });
      },
      /**
       * @api private
       */
      finishSinglePart: function finishSinglePart(err, data) {
        var upload = this.request._managedUpload;
        var httpReq = this.request.httpRequest;
        var endpoint = httpReq.endpoint;
        if (err)
          return upload.callback(err);
        data.Location = [endpoint.protocol, "//", endpoint.host, httpReq.path].join("");
        data.key = this.request.params.Key;
        data.Key = this.request.params.Key;
        data.Bucket = this.request.params.Bucket;
        upload.callback(err, data);
      },
      /**
       * @api private
       */
      progress: function progress(info) {
        var upload = this._managedUpload;
        if (this.operation === "putObject") {
          info.part = 1;
          info.key = this.params.Key;
        } else {
          upload.totalUploadedBytes += info.loaded - this._lastUploadedBytes;
          this._lastUploadedBytes = info.loaded;
          info = {
            loaded: upload.totalUploadedBytes,
            total: upload.totalBytes,
            part: this.params.PartNumber,
            key: this.params.Key
          };
        }
        upload.emit("httpUploadProgress", [info]);
      }
    });
    AWS2.util.mixin(AWS2.S3.ManagedUpload, AWS2.SequentialExecutor);
    AWS2.S3.ManagedUpload.addPromisesToClass = function addPromisesToClass(PromiseDependency) {
      this.prototype.promise = AWS2.util.promisifyMethod("send", PromiseDependency);
    };
    AWS2.S3.ManagedUpload.deletePromisesFromClass = function deletePromisesFromClass() {
      delete this.prototype.promise;
    };
    AWS2.util.addPromises(AWS2.S3.ManagedUpload);
    module2.exports = AWS2.S3.ManagedUpload;
  }
});

// node_modules/aws-sdk/lib/services/s3.js
var require_s32 = __commonJS({
  "node_modules/aws-sdk/lib/services/s3.js"() {
    "use strict";
    var AWS2 = require_core();
    var v4Credentials = require_v4_credentials();
    var resolveRegionalEndpointsFlag = require_config_regional_endpoint();
    var s3util = require_s3util();
    var regionUtil = require_region_config();
    require_managed_upload();
    var operationsWith200StatusCodeError = {
      "completeMultipartUpload": true,
      "copyObject": true,
      "uploadPartCopy": true
    };
    var regionRedirectErrorCodes = [
      "AuthorizationHeaderMalformed",
      // non-head operations on virtual-hosted global bucket endpoints
      "BadRequest",
      // head operations on virtual-hosted global bucket endpoints
      "PermanentRedirect",
      // non-head operations on path-style or regional endpoints
      301
      // head operations on path-style or regional endpoints
    ];
    var OBJECT_LAMBDA_SERVICE = "s3-object-lambda";
    AWS2.util.update(AWS2.S3.prototype, {
      /**
       * @api private
       */
      getSignatureVersion: function getSignatureVersion(request) {
        var defaultApiVersion = this.api.signatureVersion;
        var userDefinedVersion = this._originalConfig ? this._originalConfig.signatureVersion : null;
        var regionDefinedVersion = this.config.signatureVersion;
        var isPresigned = request ? request.isPresigned() : false;
        if (userDefinedVersion) {
          userDefinedVersion = userDefinedVersion === "v2" ? "s3" : userDefinedVersion;
          return userDefinedVersion;
        }
        if (isPresigned !== true) {
          defaultApiVersion = "v4";
        } else if (regionDefinedVersion) {
          defaultApiVersion = regionDefinedVersion;
        }
        return defaultApiVersion;
      },
      /**
       * @api private
       */
      getSigningName: function getSigningName(req) {
        if (req && req.operation === "writeGetObjectResponse") {
          return OBJECT_LAMBDA_SERVICE;
        }
        var _super = AWS2.Service.prototype.getSigningName;
        return req && req._parsedArn && req._parsedArn.service ? req._parsedArn.service : _super.call(this);
      },
      /**
       * @api private
       */
      getSignerClass: function getSignerClass(request) {
        var signatureVersion = this.getSignatureVersion(request);
        return AWS2.Signers.RequestSigner.getVersion(signatureVersion);
      },
      /**
       * @api private
       */
      validateService: function validateService() {
        var msg;
        var messages = [];
        if (!this.config.region)
          this.config.region = "us-east-1";
        if (!this.config.endpoint && this.config.s3BucketEndpoint) {
          messages.push("An endpoint must be provided when configuring `s3BucketEndpoint` to true.");
        }
        if (messages.length === 1) {
          msg = messages[0];
        } else if (messages.length > 1) {
          msg = "Multiple configuration errors:\n" + messages.join("\n");
        }
        if (msg) {
          throw AWS2.util.error(
            new Error(),
            { name: "InvalidEndpoint", message: msg }
          );
        }
      },
      /**
       * @api private
       */
      shouldDisableBodySigning: function shouldDisableBodySigning(request) {
        var signerClass = this.getSignerClass();
        if (this.config.s3DisableBodySigning === true && signerClass === AWS2.Signers.V4 && request.httpRequest.endpoint.protocol === "https:") {
          return true;
        }
        return false;
      },
      /**
       * @api private
       */
      setupRequestListeners: function setupRequestListeners(request) {
        var prependListener = true;
        request.addListener("validate", this.validateScheme);
        request.addListener("validate", this.validateBucketName, prependListener);
        request.addListener("validate", this.optInUsEast1RegionalEndpoint, prependListener);
        request.removeListener(
          "validate",
          AWS2.EventListeners.Core.VALIDATE_REGION
        );
        request.addListener("build", this.addContentType);
        request.addListener("build", this.computeContentMd5);
        request.addListener("build", this.computeSseCustomerKeyMd5);
        request.addListener("build", this.populateURI);
        request.addListener("afterBuild", this.addExpect100Continue);
        request.addListener("extractError", this.extractError);
        request.addListener("extractData", AWS2.util.hoistPayloadMember);
        request.addListener("extractData", this.extractData);
        request.addListener("extractData", this.extractErrorFrom200Response);
        request.addListener("beforePresign", this.prepareSignedUrl);
        if (this.shouldDisableBodySigning(request)) {
          request.removeListener("afterBuild", AWS2.EventListeners.Core.COMPUTE_SHA256);
          request.addListener("afterBuild", this.disableBodySigning);
        }
        if (request.operation !== "createBucket" && s3util.isArnInParam(request, "Bucket")) {
          request._parsedArn = AWS2.util.ARN.parse(request.params.Bucket);
          request.removeListener("validate", this.validateBucketName);
          request.removeListener("build", this.populateURI);
          if (request._parsedArn.service === "s3") {
            request.addListener("validate", s3util.validateS3AccessPointArn);
            request.addListener("validate", this.validateArnResourceType);
            request.addListener("validate", this.validateArnRegion);
          } else if (request._parsedArn.service === "s3-outposts") {
            request.addListener("validate", s3util.validateOutpostsAccessPointArn);
            request.addListener("validate", s3util.validateOutpostsArn);
            request.addListener("validate", s3util.validateArnRegion);
          }
          request.addListener("validate", s3util.validateArnAccount);
          request.addListener("validate", s3util.validateArnService);
          request.addListener("build", this.populateUriFromAccessPointArn);
          request.addListener("build", s3util.validatePopulateUriFromArn);
          return;
        }
        request.addListener("validate", this.validateBucketEndpoint);
        request.addListener("validate", this.correctBucketRegionFromCache);
        request.onAsync("extractError", this.requestBucketRegion);
        if (AWS2.util.isBrowser()) {
          request.onAsync("retry", this.reqRegionForNetworkingError);
        }
      },
      /**
       * @api private
       */
      validateScheme: function(req) {
        var params = req.params, scheme = req.httpRequest.endpoint.protocol, sensitive = params.SSECustomerKey || params.CopySourceSSECustomerKey;
        if (sensitive && scheme !== "https:") {
          var msg = "Cannot send SSE keys over HTTP. Set 'sslEnabled'to 'true' in your configuration";
          throw AWS2.util.error(
            new Error(),
            { code: "ConfigError", message: msg }
          );
        }
      },
      /**
       * @api private
       */
      validateBucketEndpoint: function(req) {
        if (!req.params.Bucket && req.service.config.s3BucketEndpoint) {
          var msg = "Cannot send requests to root API with `s3BucketEndpoint` set.";
          throw AWS2.util.error(
            new Error(),
            { code: "ConfigError", message: msg }
          );
        }
      },
      /**
       * @api private
       */
      validateArnRegion: function validateArnRegion(req) {
        s3util.validateArnRegion(req, { allowFipsEndpoint: true });
      },
      /**
       * Validate resource-type supplied in S3 ARN
       */
      validateArnResourceType: function validateArnResourceType(req) {
        var resource = req._parsedArn.resource;
        if (resource.indexOf("accesspoint:") !== 0 && resource.indexOf("accesspoint/") !== 0) {
          throw AWS2.util.error(new Error(), {
            code: "InvalidARN",
            message: "ARN resource should begin with 'accesspoint/'"
          });
        }
      },
      /**
       * @api private
       */
      validateBucketName: function validateBucketName(req) {
        var service = req.service;
        var signatureVersion = service.getSignatureVersion(req);
        var bucket = req.params && req.params.Bucket;
        var key = req.params && req.params.Key;
        var slashIndex = bucket && bucket.indexOf("/");
        if (bucket && slashIndex >= 0) {
          if (typeof key === "string" && slashIndex > 0) {
            req.params = AWS2.util.copy(req.params);
            var prefix = bucket.substr(slashIndex + 1) || "";
            req.params.Key = prefix + "/" + key;
            req.params.Bucket = bucket.substr(0, slashIndex);
          } else if (signatureVersion === "v4") {
            var msg = "Bucket names cannot contain forward slashes. Bucket: " + bucket;
            throw AWS2.util.error(
              new Error(),
              { code: "InvalidBucket", message: msg }
            );
          }
        }
      },
      /**
       * @api private
       */
      isValidAccelerateOperation: function isValidAccelerateOperation(operation) {
        var invalidOperations = [
          "createBucket",
          "deleteBucket",
          "listBuckets"
        ];
        return invalidOperations.indexOf(operation) === -1;
      },
      /**
       * When us-east-1 region endpoint configuration is set, in stead of sending request to
       * global endpoint(e.g. 's3.amazonaws.com'), we will send request to
       * 's3.us-east-1.amazonaws.com'.
       * @api private
       */
      optInUsEast1RegionalEndpoint: function optInUsEast1RegionalEndpoint(req) {
        var service = req.service;
        var config = service.config;
        config.s3UsEast1RegionalEndpoint = resolveRegionalEndpointsFlag(service._originalConfig, {
          env: "AWS_S3_US_EAST_1_REGIONAL_ENDPOINT",
          sharedConfig: "s3_us_east_1_regional_endpoint",
          clientConfig: "s3UsEast1RegionalEndpoint"
        });
        if (!(service._originalConfig || {}).endpoint && req.httpRequest.region === "us-east-1" && config.s3UsEast1RegionalEndpoint === "regional" && req.httpRequest.endpoint.hostname.indexOf("s3.amazonaws.com") >= 0) {
          var insertPoint = config.endpoint.indexOf(".amazonaws.com");
          var regionalEndpoint = config.endpoint.substring(0, insertPoint) + ".us-east-1" + config.endpoint.substring(insertPoint);
          req.httpRequest.updateEndpoint(regionalEndpoint);
        }
      },
      /**
       * S3 prefers dns-compatible bucket names to be moved from the uri path
       * to the hostname as a sub-domain.  This is not possible, even for dns-compat
       * buckets when using SSL and the bucket name contains a dot ('.').  The
       * ssl wildcard certificate is only 1-level deep.
       *
       * @api private
       */
      populateURI: function populateURI(req) {
        var httpRequest = req.httpRequest;
        var b = req.params.Bucket;
        var service = req.service;
        var endpoint = httpRequest.endpoint;
        if (b) {
          if (!service.pathStyleBucketName(b)) {
            if (service.config.useAccelerateEndpoint && service.isValidAccelerateOperation(req.operation)) {
              if (service.config.useDualstackEndpoint) {
                endpoint.hostname = b + ".s3-accelerate.dualstack.amazonaws.com";
              } else {
                endpoint.hostname = b + ".s3-accelerate.amazonaws.com";
              }
            } else if (!service.config.s3BucketEndpoint) {
              endpoint.hostname = b + "." + endpoint.hostname;
            }
            var port = endpoint.port;
            if (port !== 80 && port !== 443) {
              endpoint.host = endpoint.hostname + ":" + endpoint.port;
            } else {
              endpoint.host = endpoint.hostname;
            }
            httpRequest.virtualHostedBucket = b;
            service.removeVirtualHostedBucketFromPath(req);
          }
        }
      },
      /**
       * Takes the bucket name out of the path if bucket is virtual-hosted
       *
       * @api private
       */
      removeVirtualHostedBucketFromPath: function removeVirtualHostedBucketFromPath(req) {
        var httpRequest = req.httpRequest;
        var bucket = httpRequest.virtualHostedBucket;
        if (bucket && httpRequest.path) {
          if (req.params && req.params.Key) {
            var encodedS3Key = "/" + AWS2.util.uriEscapePath(req.params.Key);
            if (httpRequest.path.indexOf(encodedS3Key) === 0 && (httpRequest.path.length === encodedS3Key.length || httpRequest.path[encodedS3Key.length] === "?")) {
              return;
            }
          }
          httpRequest.path = httpRequest.path.replace(new RegExp("/" + bucket), "");
          if (httpRequest.path[0] !== "/") {
            httpRequest.path = "/" + httpRequest.path;
          }
        }
      },
      /**
       * When user supply an access point ARN in the Bucket parameter, we need to
       * populate the URI according to the ARN.
       */
      populateUriFromAccessPointArn: function populateUriFromAccessPointArn(req) {
        var accessPointArn = req._parsedArn;
        var isOutpostArn = accessPointArn.service === "s3-outposts";
        var isObjectLambdaArn = accessPointArn.service === "s3-object-lambda";
        var outpostsSuffix = isOutpostArn ? "." + accessPointArn.outpostId : "";
        var serviceName = isOutpostArn ? "s3-outposts" : "s3-accesspoint";
        var fipsSuffix = !isOutpostArn && req.service.config.useFipsEndpoint ? "-fips" : "";
        var dualStackSuffix = !isOutpostArn && req.service.config.useDualstackEndpoint ? ".dualstack" : "";
        var endpoint = req.httpRequest.endpoint;
        var dnsSuffix = regionUtil.getEndpointSuffix(accessPointArn.region);
        var useArnRegion = req.service.config.s3UseArnRegion;
        endpoint.hostname = [
          accessPointArn.accessPoint + "-" + accessPointArn.accountId + outpostsSuffix,
          serviceName + fipsSuffix + dualStackSuffix,
          useArnRegion ? accessPointArn.region : req.service.config.region,
          dnsSuffix
        ].join(".");
        if (isObjectLambdaArn) {
          var serviceName = "s3-object-lambda";
          var accesspointName = accessPointArn.resource.split("/")[1];
          var fipsSuffix = req.service.config.useFipsEndpoint ? "-fips" : "";
          endpoint.hostname = [
            accesspointName + "-" + accessPointArn.accountId,
            serviceName + fipsSuffix,
            useArnRegion ? accessPointArn.region : req.service.config.region,
            dnsSuffix
          ].join(".");
        }
        endpoint.host = endpoint.hostname;
        var encodedArn = AWS2.util.uriEscape(req.params.Bucket);
        var path = req.httpRequest.path;
        req.httpRequest.path = path.replace(new RegExp("/" + encodedArn), "");
        if (req.httpRequest.path[0] !== "/") {
          req.httpRequest.path = "/" + req.httpRequest.path;
        }
        req.httpRequest.region = accessPointArn.region;
      },
      /**
       * Adds Expect: 100-continue header if payload is greater-or-equal 1MB
       * @api private
       */
      addExpect100Continue: function addExpect100Continue(req) {
        var len = req.httpRequest.headers["Content-Length"];
        if (AWS2.util.isNode() && (len >= 1024 * 1024 || req.params.Body instanceof AWS2.util.stream.Stream)) {
          req.httpRequest.headers["Expect"] = "100-continue";
        }
      },
      /**
       * Adds a default content type if none is supplied.
       *
       * @api private
       */
      addContentType: function addContentType(req) {
        var httpRequest = req.httpRequest;
        if (httpRequest.method === "GET" || httpRequest.method === "HEAD") {
          delete httpRequest.headers["Content-Type"];
          return;
        }
        if (!httpRequest.headers["Content-Type"]) {
          httpRequest.headers["Content-Type"] = "application/octet-stream";
        }
        var contentType = httpRequest.headers["Content-Type"];
        if (AWS2.util.isBrowser()) {
          if (typeof httpRequest.body === "string" && !contentType.match(/;\s*charset=/)) {
            var charset = "; charset=UTF-8";
            httpRequest.headers["Content-Type"] += charset;
          } else {
            var replaceFn = function(_, prefix, charsetName) {
              return prefix + charsetName.toUpperCase();
            };
            httpRequest.headers["Content-Type"] = contentType.replace(/(;\s*charset=)(.+)$/, replaceFn);
          }
        }
      },
      /**
       * Checks whether checksums should be computed for the request if it's not
       * already set by {AWS.EventListeners.Core.COMPUTE_CHECKSUM}. It depends on
       * whether {AWS.Config.computeChecksums} is set.
       *
       * @param req [AWS.Request] the request to check against
       * @return [Boolean] whether to compute checksums for a request.
       * @api private
       */
      willComputeChecksums: function willComputeChecksums(req) {
        var rules = req.service.api.operations[req.operation].input.members;
        var body = req.httpRequest.body;
        var needsContentMD5 = req.service.config.computeChecksums && rules.ContentMD5 && !req.params.ContentMD5 && body && (AWS2.util.Buffer.isBuffer(req.httpRequest.body) || typeof req.httpRequest.body === "string");
        if (needsContentMD5 && req.service.shouldDisableBodySigning(req) && !req.isPresigned()) {
          return true;
        }
        if (needsContentMD5 && this.getSignatureVersion(req) === "s3" && req.isPresigned()) {
          return true;
        }
        return false;
      },
      /**
       * A listener that computes the Content-MD5 and sets it in the header.
       * This listener is to support S3-specific features like
       * s3DisableBodySigning and SigV2 presign. Content MD5 logic for SigV4 is
       * handled in AWS.EventListeners.Core.COMPUTE_CHECKSUM
       *
       * @api private
       */
      computeContentMd5: function computeContentMd5(req) {
        if (req.service.willComputeChecksums(req)) {
          var md5 = AWS2.util.crypto.md5(req.httpRequest.body, "base64");
          req.httpRequest.headers["Content-MD5"] = md5;
        }
      },
      /**
       * @api private
       */
      computeSseCustomerKeyMd5: function computeSseCustomerKeyMd5(req) {
        var keys = {
          SSECustomerKey: "x-amz-server-side-encryption-customer-key-MD5",
          CopySourceSSECustomerKey: "x-amz-copy-source-server-side-encryption-customer-key-MD5"
        };
        AWS2.util.each(keys, function(key, header) {
          if (req.params[key]) {
            var value = AWS2.util.crypto.md5(req.params[key], "base64");
            req.httpRequest.headers[header] = value;
          }
        });
      },
      /**
       * Returns true if the bucket name should be left in the URI path for
       * a request to S3.  This function takes into account the current
       * endpoint protocol (e.g. http or https).
       *
       * @api private
       */
      pathStyleBucketName: function pathStyleBucketName(bucketName) {
        if (this.config.s3ForcePathStyle)
          return true;
        if (this.config.s3BucketEndpoint)
          return false;
        if (s3util.dnsCompatibleBucketName(bucketName)) {
          return this.config.sslEnabled && bucketName.match(/\./) ? true : false;
        } else {
          return true;
        }
      },
      /**
       * For COPY operations, some can be error even with status code 200.
       * SDK treats the response as exception when response body indicates
       * an exception or body is empty.
       *
       * @api private
       */
      extractErrorFrom200Response: function extractErrorFrom200Response(resp) {
        if (!operationsWith200StatusCodeError[resp.request.operation])
          return;
        var httpResponse = resp.httpResponse;
        if (httpResponse.body && httpResponse.body.toString().match("<Error>")) {
          resp.data = null;
          var service = this.service ? this.service : this;
          service.extractError(resp);
          throw resp.error;
        } else if (!httpResponse.body || !httpResponse.body.toString().match(/<[\w_]/)) {
          resp.data = null;
          throw AWS2.util.error(new Error(), {
            code: "InternalError",
            message: "S3 aborted request"
          });
        }
      },
      /**
       * @return [Boolean] whether the error can be retried
       * @api private
       */
      retryableError: function retryableError(error, request) {
        if (operationsWith200StatusCodeError[request.operation] && error.statusCode === 200) {
          return true;
        } else if (request._requestRegionForBucket && request.service.bucketRegionCache[request._requestRegionForBucket]) {
          return false;
        } else if (error && error.code === "RequestTimeout") {
          return true;
        } else if (error && regionRedirectErrorCodes.indexOf(error.code) != -1 && error.region && error.region != request.httpRequest.region) {
          request.httpRequest.region = error.region;
          if (error.statusCode === 301) {
            request.service.updateReqBucketRegion(request);
          }
          return true;
        } else {
          var _super = AWS2.Service.prototype.retryableError;
          return _super.call(this, error, request);
        }
      },
      /**
       * Updates httpRequest with region. If region is not provided, then
       * the httpRequest will be updated based on httpRequest.region
       *
       * @api private
       */
      updateReqBucketRegion: function updateReqBucketRegion(request, region) {
        var httpRequest = request.httpRequest;
        if (typeof region === "string" && region.length) {
          httpRequest.region = region;
        }
        if (!httpRequest.endpoint.host.match(/s3(?!-accelerate).*\.amazonaws\.com$/)) {
          return;
        }
        var service = request.service;
        var s3Config = service.config;
        var s3BucketEndpoint = s3Config.s3BucketEndpoint;
        if (s3BucketEndpoint) {
          delete s3Config.s3BucketEndpoint;
        }
        var newConfig = AWS2.util.copy(s3Config);
        delete newConfig.endpoint;
        newConfig.region = httpRequest.region;
        httpRequest.endpoint = new AWS2.S3(newConfig).endpoint;
        service.populateURI(request);
        s3Config.s3BucketEndpoint = s3BucketEndpoint;
        httpRequest.headers.Host = httpRequest.endpoint.host;
        if (request._asm.currentState === "validate") {
          request.removeListener("build", service.populateURI);
          request.addListener("build", service.removeVirtualHostedBucketFromPath);
        }
      },
      /**
       * Provides a specialized parser for getBucketLocation -- all other
       * operations are parsed by the super class.
       *
       * @api private
       */
      extractData: function extractData(resp) {
        var req = resp.request;
        if (req.operation === "getBucketLocation") {
          var match = resp.httpResponse.body.toString().match(/>(.+)<\/Location/);
          delete resp.data["_"];
          if (match) {
            resp.data.LocationConstraint = match[1];
          } else {
            resp.data.LocationConstraint = "";
          }
        }
        var bucket = req.params.Bucket || null;
        if (req.operation === "deleteBucket" && typeof bucket === "string" && !resp.error) {
          req.service.clearBucketRegionCache(bucket);
        } else {
          var headers = resp.httpResponse.headers || {};
          var region = headers["x-amz-bucket-region"] || null;
          if (!region && req.operation === "createBucket" && !resp.error) {
            var createBucketConfiguration = req.params.CreateBucketConfiguration;
            if (!createBucketConfiguration) {
              region = "us-east-1";
            } else if (createBucketConfiguration.LocationConstraint === "EU") {
              region = "eu-west-1";
            } else {
              region = createBucketConfiguration.LocationConstraint;
            }
          }
          if (region) {
            if (bucket && region !== req.service.bucketRegionCache[bucket]) {
              req.service.bucketRegionCache[bucket] = region;
            }
          }
        }
        req.service.extractRequestIds(resp);
      },
      /**
       * Extracts an error object from the http response.
       *
       * @api private
       */
      extractError: function extractError(resp) {
        var codes = {
          304: "NotModified",
          403: "Forbidden",
          400: "BadRequest",
          404: "NotFound"
        };
        var req = resp.request;
        var code = resp.httpResponse.statusCode;
        var body = resp.httpResponse.body || "";
        var headers = resp.httpResponse.headers || {};
        var region = headers["x-amz-bucket-region"] || null;
        var bucket = req.params.Bucket || null;
        var bucketRegionCache = req.service.bucketRegionCache;
        if (region && bucket && region !== bucketRegionCache[bucket]) {
          bucketRegionCache[bucket] = region;
        }
        var cachedRegion;
        if (codes[code] && body.length === 0) {
          if (bucket && !region) {
            cachedRegion = bucketRegionCache[bucket] || null;
            if (cachedRegion !== req.httpRequest.region) {
              region = cachedRegion;
            }
          }
          resp.error = AWS2.util.error(new Error(), {
            code: codes[code],
            message: null,
            region
          });
        } else {
          var data = new AWS2.XML.Parser().parse(body.toString());
          if (data.Region && !region) {
            region = data.Region;
            if (bucket && region !== bucketRegionCache[bucket]) {
              bucketRegionCache[bucket] = region;
            }
          } else if (bucket && !region && !data.Region) {
            cachedRegion = bucketRegionCache[bucket] || null;
            if (cachedRegion !== req.httpRequest.region) {
              region = cachedRegion;
            }
          }
          resp.error = AWS2.util.error(new Error(), {
            code: data.Code || code,
            message: data.Message || null,
            region
          });
        }
        req.service.extractRequestIds(resp);
      },
      /**
       * If region was not obtained synchronously, then send async request
       * to get bucket region for errors resulting from wrong region.
       *
       * @api private
       */
      requestBucketRegion: function requestBucketRegion(resp, done) {
        var error = resp.error;
        var req = resp.request;
        var bucket = req.params.Bucket || null;
        if (!error || !bucket || error.region || req.operation === "listObjects" || AWS2.util.isNode() && req.operation === "headBucket" || error.statusCode === 400 && req.operation !== "headObject" || regionRedirectErrorCodes.indexOf(error.code) === -1) {
          return done();
        }
        var reqOperation = AWS2.util.isNode() ? "headBucket" : "listObjects";
        var reqParams = { Bucket: bucket };
        if (reqOperation === "listObjects")
          reqParams.MaxKeys = 0;
        var regionReq = req.service[reqOperation](reqParams);
        regionReq._requestRegionForBucket = bucket;
        regionReq.send(function() {
          var region = req.service.bucketRegionCache[bucket] || null;
          error.region = region;
          done();
        });
      },
      /**
      * For browser only. If NetworkingError received, will attempt to obtain
      * the bucket region.
      *
      * @api private
      */
      reqRegionForNetworkingError: function reqRegionForNetworkingError(resp, done) {
        if (!AWS2.util.isBrowser()) {
          return done();
        }
        var error = resp.error;
        var request = resp.request;
        var bucket = request.params.Bucket;
        if (!error || error.code !== "NetworkingError" || !bucket || request.httpRequest.region === "us-east-1") {
          return done();
        }
        var service = request.service;
        var bucketRegionCache = service.bucketRegionCache;
        var cachedRegion = bucketRegionCache[bucket] || null;
        if (cachedRegion && cachedRegion !== request.httpRequest.region) {
          service.updateReqBucketRegion(request, cachedRegion);
          done();
        } else if (!s3util.dnsCompatibleBucketName(bucket)) {
          service.updateReqBucketRegion(request, "us-east-1");
          if (bucketRegionCache[bucket] !== "us-east-1") {
            bucketRegionCache[bucket] = "us-east-1";
          }
          done();
        } else if (request.httpRequest.virtualHostedBucket) {
          var getRegionReq = service.listObjects({ Bucket: bucket, MaxKeys: 0 });
          service.updateReqBucketRegion(getRegionReq, "us-east-1");
          getRegionReq._requestRegionForBucket = bucket;
          getRegionReq.send(function() {
            var region = service.bucketRegionCache[bucket] || null;
            if (region && region !== request.httpRequest.region) {
              service.updateReqBucketRegion(request, region);
            }
            done();
          });
        } else {
          done();
        }
      },
      /**
       * Cache for bucket region.
       *
       * @api private
       */
      bucketRegionCache: {},
      /**
       * Clears bucket region cache.
       *
       * @api private
       */
      clearBucketRegionCache: function(buckets) {
        var bucketRegionCache = this.bucketRegionCache;
        if (!buckets) {
          buckets = Object.keys(bucketRegionCache);
        } else if (typeof buckets === "string") {
          buckets = [buckets];
        }
        for (var i = 0; i < buckets.length; i++) {
          delete bucketRegionCache[buckets[i]];
        }
        return bucketRegionCache;
      },
      /**
       * Corrects request region if bucket's cached region is different
       *
       * @api private
       */
      correctBucketRegionFromCache: function correctBucketRegionFromCache(req) {
        var bucket = req.params.Bucket || null;
        if (bucket) {
          var service = req.service;
          var requestRegion = req.httpRequest.region;
          var cachedRegion = service.bucketRegionCache[bucket];
          if (cachedRegion && cachedRegion !== requestRegion) {
            service.updateReqBucketRegion(req, cachedRegion);
          }
        }
      },
      /**
       * Extracts S3 specific request ids from the http response.
       *
       * @api private
       */
      extractRequestIds: function extractRequestIds(resp) {
        var extendedRequestId = resp.httpResponse.headers ? resp.httpResponse.headers["x-amz-id-2"] : null;
        var cfId = resp.httpResponse.headers ? resp.httpResponse.headers["x-amz-cf-id"] : null;
        resp.extendedRequestId = extendedRequestId;
        resp.cfId = cfId;
        if (resp.error) {
          resp.error.requestId = resp.requestId || null;
          resp.error.extendedRequestId = extendedRequestId;
          resp.error.cfId = cfId;
        }
      },
      /**
       * Get a pre-signed URL for a given operation name.
       *
       * @note You must ensure that you have static or previously resolved
       *   credentials if you call this method synchronously (with no callback),
       *   otherwise it may not properly sign the request. If you cannot guarantee
       *   this (you are using an asynchronous credential provider, i.e., EC2
       *   IAM roles), you should always call this method with an asynchronous
       *   callback.
       * @note Not all operation parameters are supported when using pre-signed
       *   URLs. Certain parameters, such as `SSECustomerKey`, `ACL`, `Expires`,
       *   `ContentLength`, or `Tagging` must be provided as headers when sending a
       *   request. If you are using pre-signed URLs to upload from a browser and
       *   need to use these fields, see {createPresignedPost}.
       * @note The default signer allows altering the request by adding corresponding
       *   headers to set some parameters (e.g. Range) and these added parameters
       *   won't be signed. You must use signatureVersion v4 to to include these
       *   parameters in the signed portion of the URL and enforce exact matching
       *   between headers and signed params in the URL.
       * @note This operation cannot be used with a promise. See note above regarding
       *   asynchronous credentials and use with a callback.
       * @param operation [String] the name of the operation to call
       * @param params [map] parameters to pass to the operation. See the given
       *   operation for the expected operation parameters. In addition, you can
       *   also pass the "Expires" parameter to inform S3 how long the URL should
       *   work for.
       * @option params Expires [Integer] (900) the number of seconds to expire
       *   the pre-signed URL operation in. Defaults to 15 minutes.
       * @param callback [Function] if a callback is provided, this function will
       *   pass the URL as the second parameter (after the error parameter) to
       *   the callback function.
       * @return [String] if called synchronously (with no callback), returns the
       *   signed URL.
       * @return [null] nothing is returned if a callback is provided.
       * @example Pre-signing a getObject operation (synchronously)
       *   var params = {Bucket: 'bucket', Key: 'key'};
       *   var url = s3.getSignedUrl('getObject', params);
       *   console.log('The URL is', url);
       * @example Pre-signing a putObject (asynchronously)
       *   var params = {Bucket: 'bucket', Key: 'key'};
       *   s3.getSignedUrl('putObject', params, function (err, url) {
       *     console.log('The URL is', url);
       *   });
       * @example Pre-signing a putObject operation with a specific payload
       *   var params = {Bucket: 'bucket', Key: 'key', Body: 'body'};
       *   var url = s3.getSignedUrl('putObject', params);
       *   console.log('The URL is', url);
       * @example Passing in a 1-minute expiry time for a pre-signed URL
       *   var params = {Bucket: 'bucket', Key: 'key', Expires: 60};
       *   var url = s3.getSignedUrl('getObject', params);
       *   console.log('The URL is', url); // expires in 60 seconds
       */
      getSignedUrl: function getSignedUrl(operation, params, callback) {
        params = AWS2.util.copy(params || {});
        var expires = params.Expires || 900;
        if (typeof expires !== "number") {
          throw AWS2.util.error(
            new Error(),
            { code: "InvalidParameterException", message: "The expiration must be a number, received " + typeof expires }
          );
        }
        delete params.Expires;
        var request = this.makeRequest(operation, params);
        if (callback) {
          AWS2.util.defer(function() {
            request.presign(expires, callback);
          });
        } else {
          return request.presign(expires, callback);
        }
      },
      /**
       * @!method  getSignedUrlPromise()
       *   Returns a 'thenable' promise that will be resolved with a pre-signed URL
       *   for a given operation name.
       *
       *   Two callbacks can be provided to the `then` method on the returned promise.
       *   The first callback will be called if the promise is fulfilled, and the second
       *   callback will be called if the promise is rejected.
       *   @note Not all operation parameters are supported when using pre-signed
       *      URLs. Certain parameters, such as `SSECustomerKey`, `ACL`, `Expires`,
       *      `ContentLength`, or `Tagging` must be provided as headers when sending a
       *      request. If you are using pre-signed URLs to upload from a browser and
       *      need to use these fields, see {createPresignedPost}.
       *   @param operation [String] the name of the operation to call
       *   @param params [map] parameters to pass to the operation. See the given
       *      operation for the expected operation parameters. In addition, you can
       *      also pass the "Expires" parameter to inform S3 how long the URL should
       *      work for.
       *   @option params Expires [Integer] (900) the number of seconds to expire
       *      the pre-signed URL operation in. Defaults to 15 minutes.
       *   @callback fulfilledCallback function(url)
       *     Called if the promise is fulfilled.
       *     @param url [String] the signed url
       *   @callback rejectedCallback function(err)
       *     Called if the promise is rejected.
       *     @param err [Error] if an error occurred, this value will be filled
       *   @return [Promise] A promise that represents the state of the `refresh` call.
       *   @example Pre-signing a getObject operation
       *      var params = {Bucket: 'bucket', Key: 'key'};
       *      var promise = s3.getSignedUrlPromise('getObject', params);
       *      promise.then(function(url) {
       *        console.log('The URL is', url);
       *      }, function(err) { ... });
       *   @example Pre-signing a putObject operation with a specific payload
       *      var params = {Bucket: 'bucket', Key: 'key', Body: 'body'};
       *      var promise = s3.getSignedUrlPromise('putObject', params);
       *      promise.then(function(url) {
       *        console.log('The URL is', url);
       *      }, function(err) { ... });
       *   @example Passing in a 1-minute expiry time for a pre-signed URL
       *      var params = {Bucket: 'bucket', Key: 'key', Expires: 60};
       *      var promise = s3.getSignedUrlPromise('getObject', params);
       *      promise.then(function(url) {
       *        console.log('The URL is', url);
       *      }, function(err) { ... });
       */
      /**
       * Get a pre-signed POST policy to support uploading to S3 directly from an
       * HTML form.
       *
       * @param params [map]
       * @option params Bucket [String]     The bucket to which the post should be
       *                                    uploaded
       * @option params Expires [Integer]   (3600) The number of seconds for which
       *                                    the presigned policy should be valid.
       * @option params Conditions [Array]  An array of conditions that must be met
       *                                    for the presigned policy to allow the
       *                                    upload. This can include required tags,
       *                                    the accepted range for content lengths,
       *                                    etc.
       * @see http://docs.aws.amazon.com/AmazonS3/latest/API/sigv4-HTTPPOSTConstructPolicy.html
       * @option params Fields [map]        Fields to include in the form. All
       *                                    values passed in as fields will be
       *                                    signed as exact match conditions.
       * @param callback [Function]
       *
       * @note All fields passed in when creating presigned post data will be signed
       *   as exact match conditions. Any fields that will be interpolated by S3
       *   must be added to the fields hash after signing, and an appropriate
       *   condition for such fields must be explicitly added to the Conditions
       *   array passed to this function before signing.
       *
       * @example Presiging post data with a known key
       *   var params = {
       *     Bucket: 'bucket',
       *     Fields: {
       *       key: 'key'
       *     }
       *   };
       *   s3.createPresignedPost(params, function(err, data) {
       *     if (err) {
       *       console.error('Presigning post data encountered an error', err);
       *     } else {
       *       console.log('The post data is', data);
       *     }
       *   });
       *
       * @example Presigning post data with an interpolated key
       *   var params = {
       *     Bucket: 'bucket',
       *     Conditions: [
       *       ['starts-with', '$key', 'path/to/uploads/']
       *     ]
       *   };
       *   s3.createPresignedPost(params, function(err, data) {
       *     if (err) {
       *       console.error('Presigning post data encountered an error', err);
       *     } else {
       *       data.Fields.key = 'path/to/uploads/${filename}';
       *       console.log('The post data is', data);
       *     }
       *   });
       *
       * @note You must ensure that you have static or previously resolved
       *   credentials if you call this method synchronously (with no callback),
       *   otherwise it may not properly sign the request. If you cannot guarantee
       *   this (you are using an asynchronous credential provider, i.e., EC2
       *   IAM roles), you should always call this method with an asynchronous
       *   callback.
       *
       * @return [map]  If called synchronously (with no callback), returns a hash
       *                with the url to set as the form action and a hash of fields
       *                to include in the form.
       * @return [null] Nothing is returned if a callback is provided.
       *
       * @callback callback function (err, data)
       *  @param err [Error] the error object returned from the policy signer
       *  @param data [map] The data necessary to construct an HTML form
       *  @param data.url [String] The URL to use as the action of the form
       *  @param data.fields [map] A hash of fields that must be included in the
       *                           form for the upload to succeed. This hash will
       *                           include the signed POST policy, your access key
       *                           ID and security token (if present), etc. These
       *                           may be safely included as input elements of type
       *                           'hidden.'
       */
      createPresignedPost: function createPresignedPost(params, callback) {
        if (typeof params === "function" && callback === void 0) {
          callback = params;
          params = null;
        }
        params = AWS2.util.copy(params || {});
        var boundParams = this.config.params || {};
        var bucket = params.Bucket || boundParams.Bucket, self2 = this, config = this.config, endpoint = AWS2.util.copy(this.endpoint);
        if (!config.s3BucketEndpoint) {
          endpoint.pathname = "/" + bucket;
        }
        function finalizePost() {
          return {
            url: AWS2.util.urlFormat(endpoint),
            fields: self2.preparePostFields(
              config.credentials,
              config.region,
              bucket,
              params.Fields,
              params.Conditions,
              params.Expires
            )
          };
        }
        if (callback) {
          config.getCredentials(function(err) {
            if (err) {
              callback(err);
            } else {
              try {
                callback(null, finalizePost());
              } catch (err2) {
                callback(err2);
              }
            }
          });
        } else {
          return finalizePost();
        }
      },
      /**
       * @api private
       */
      preparePostFields: function preparePostFields(credentials, region, bucket, fields, conditions, expiresInSeconds) {
        var now = this.getSkewCorrectedDate();
        if (!credentials || !region || !bucket) {
          throw new Error("Unable to create a POST object policy without a bucket, region, and credentials");
        }
        fields = AWS2.util.copy(fields || {});
        conditions = (conditions || []).slice(0);
        expiresInSeconds = expiresInSeconds || 3600;
        var signingDate = AWS2.util.date.iso8601(now).replace(/[:\-]|\.\d{3}/g, "");
        var shortDate = signingDate.substr(0, 8);
        var scope = v4Credentials.createScope(shortDate, region, "s3");
        var credential = credentials.accessKeyId + "/" + scope;
        fields["bucket"] = bucket;
        fields["X-Amz-Algorithm"] = "AWS4-HMAC-SHA256";
        fields["X-Amz-Credential"] = credential;
        fields["X-Amz-Date"] = signingDate;
        if (credentials.sessionToken) {
          fields["X-Amz-Security-Token"] = credentials.sessionToken;
        }
        for (var field in fields) {
          if (fields.hasOwnProperty(field)) {
            var condition = {};
            condition[field] = fields[field];
            conditions.push(condition);
          }
        }
        fields.Policy = this.preparePostPolicy(
          new Date(now.valueOf() + expiresInSeconds * 1e3),
          conditions
        );
        fields["X-Amz-Signature"] = AWS2.util.crypto.hmac(
          v4Credentials.getSigningKey(credentials, shortDate, region, "s3", true),
          fields.Policy,
          "hex"
        );
        return fields;
      },
      /**
       * @api private
       */
      preparePostPolicy: function preparePostPolicy(expiration, conditions) {
        return AWS2.util.base64.encode(JSON.stringify({
          expiration: AWS2.util.date.iso8601(expiration),
          conditions
        }));
      },
      /**
       * @api private
       */
      prepareSignedUrl: function prepareSignedUrl(request) {
        request.addListener("validate", request.service.noPresignedContentLength);
        request.removeListener("build", request.service.addContentType);
        if (!request.params.Body) {
          request.removeListener("build", request.service.computeContentMd5);
        } else {
          request.addListener("afterBuild", AWS2.EventListeners.Core.COMPUTE_SHA256);
        }
      },
      /**
       * @api private
       * @param request
       */
      disableBodySigning: function disableBodySigning(request) {
        var headers = request.httpRequest.headers;
        if (!Object.prototype.hasOwnProperty.call(headers, "presigned-expires")) {
          headers["X-Amz-Content-Sha256"] = "UNSIGNED-PAYLOAD";
        }
      },
      /**
       * @api private
       */
      noPresignedContentLength: function noPresignedContentLength(request) {
        if (request.params.ContentLength !== void 0) {
          throw AWS2.util.error(new Error(), {
            code: "UnexpectedParameter",
            message: "ContentLength is not supported in pre-signed URLs."
          });
        }
      },
      createBucket: function createBucket(params, callback) {
        if (typeof params === "function" || !params) {
          callback = callback || params;
          params = {};
        }
        var hostname = this.endpoint.hostname;
        var copiedParams = AWS2.util.copy(params);
        if (hostname !== this.api.globalEndpoint && !params.CreateBucketConfiguration) {
          copiedParams.CreateBucketConfiguration = { LocationConstraint: this.config.region };
        }
        return this.makeRequest("createBucket", copiedParams, callback);
      },
      writeGetObjectResponse: function writeGetObjectResponse(params, callback) {
        var request = this.makeRequest("writeGetObjectResponse", AWS2.util.copy(params), callback);
        var hostname = this.endpoint.hostname;
        if (hostname.indexOf(this.config.region) !== -1) {
          hostname = hostname.replace("s3.", OBJECT_LAMBDA_SERVICE + ".");
        } else {
          hostname = hostname.replace("s3.", OBJECT_LAMBDA_SERVICE + "." + this.config.region + ".");
        }
        request.httpRequest.endpoint = new AWS2.Endpoint(hostname, this.config);
        return request;
      },
      /**
       * @see AWS.S3.ManagedUpload
       * @overload upload(params = {}, [options], [callback])
       *   Uploads an arbitrarily sized buffer, blob, or stream, using intelligent
       *   concurrent handling of parts if the payload is large enough. You can
       *   configure the concurrent queue size by setting `options`. Note that this
       *   is the only operation for which the SDK can retry requests with stream
       *   bodies.
       *
       *   @param (see AWS.S3.putObject)
       *   @option (see AWS.S3.ManagedUpload.constructor)
       *   @return [AWS.S3.ManagedUpload] the managed upload object that can call
       *     `send()` or track progress.
       *   @example Uploading a stream object
       *     var params = {Bucket: 'bucket', Key: 'key', Body: stream};
       *     s3.upload(params, function(err, data) {
       *       console.log(err, data);
       *     });
       *   @example Uploading a stream with concurrency of 1 and partSize of 10mb
       *     var params = {Bucket: 'bucket', Key: 'key', Body: stream};
       *     var options = {partSize: 10 * 1024 * 1024, queueSize: 1};
       *     s3.upload(params, options, function(err, data) {
       *       console.log(err, data);
       *     });
       * @callback callback function(err, data)
       *   @param err [Error] an error or null if no error occurred.
       *   @param data [map] The response data from the successful upload:
       *   @param data.Location [String] the URL of the uploaded object
       *   @param data.ETag [String] the ETag of the uploaded object
       *   @param data.Bucket [String]  the bucket to which the object was uploaded
       *   @param data.Key [String] the key to which the object was uploaded
       */
      upload: function upload(params, options, callback) {
        if (typeof options === "function" && callback === void 0) {
          callback = options;
          options = null;
        }
        options = options || {};
        options = AWS2.util.merge(options || {}, { service: this, params });
        var uploader = new AWS2.S3.ManagedUpload(options);
        if (typeof callback === "function")
          uploader.send(callback);
        return uploader;
      }
    });
    AWS2.S3.addPromisesToClass = function addPromisesToClass(PromiseDependency) {
      this.prototype.getSignedUrlPromise = AWS2.util.promisifyMethod("getSignedUrl", PromiseDependency);
    };
    AWS2.S3.deletePromisesFromClass = function deletePromisesFromClass() {
      delete this.prototype.getSignedUrlPromise;
    };
    AWS2.util.addPromises(AWS2.S3);
  }
});

// node_modules/aws-sdk/apis/s3-2006-03-01.min.json
var require_s3_2006_03_01_min = __commonJS({
  "node_modules/aws-sdk/apis/s3-2006-03-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2006-03-01",
        checksumFormat: "md5",
        endpointPrefix: "s3",
        globalEndpoint: "s3.amazonaws.com",
        protocol: "rest-xml",
        serviceAbbreviation: "Amazon S3",
        serviceFullName: "Amazon Simple Storage Service",
        serviceId: "S3",
        signatureVersion: "s3",
        uid: "s3-2006-03-01"
      },
      operations: {
        AbortMultipartUpload: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}/{Key+}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key",
              "UploadId"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Key: {
                contextParam: {
                  name: "Key"
                },
                location: "uri",
                locationName: "Key"
              },
              UploadId: {
                location: "querystring",
                locationName: "uploadId"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            }
          }
        },
        CompleteMultipartUpload: {
          http: {
            requestUri: "/{Bucket}/{Key+}"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key",
              "UploadId"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Key: {
                contextParam: {
                  name: "Key"
                },
                location: "uri",
                locationName: "Key"
              },
              MultipartUpload: {
                locationName: "CompleteMultipartUpload",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                },
                type: "structure",
                members: {
                  Parts: {
                    locationName: "Part",
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        ETag: {},
                        ChecksumCRC32: {},
                        ChecksumCRC32C: {},
                        ChecksumSHA1: {},
                        ChecksumSHA256: {},
                        PartNumber: {
                          type: "integer"
                        }
                      }
                    },
                    flattened: true
                  }
                }
              },
              UploadId: {
                location: "querystring",
                locationName: "uploadId"
              },
              ChecksumCRC32: {
                location: "header",
                locationName: "x-amz-checksum-crc32"
              },
              ChecksumCRC32C: {
                location: "header",
                locationName: "x-amz-checksum-crc32c"
              },
              ChecksumSHA1: {
                location: "header",
                locationName: "x-amz-checksum-sha1"
              },
              ChecksumSHA256: {
                location: "header",
                locationName: "x-amz-checksum-sha256"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKey: {
                shape: "Sk",
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              }
            },
            payload: "MultipartUpload"
          },
          output: {
            type: "structure",
            members: {
              Location: {},
              Bucket: {},
              Key: {},
              Expiration: {
                location: "header",
                locationName: "x-amz-expiration"
              },
              ETag: {},
              ChecksumCRC32: {},
              ChecksumCRC32C: {},
              ChecksumSHA1: {},
              ChecksumSHA256: {},
              ServerSideEncryption: {
                location: "header",
                locationName: "x-amz-server-side-encryption"
              },
              VersionId: {
                location: "header",
                locationName: "x-amz-version-id"
              },
              SSEKMSKeyId: {
                shape: "Sr",
                location: "header",
                locationName: "x-amz-server-side-encryption-aws-kms-key-id"
              },
              BucketKeyEnabled: {
                location: "header",
                locationName: "x-amz-server-side-encryption-bucket-key-enabled",
                type: "boolean"
              },
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            }
          }
        },
        CopyObject: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}/{Key+}"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "CopySource",
              "Key"
            ],
            members: {
              ACL: {
                location: "header",
                locationName: "x-amz-acl"
              },
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              CacheControl: {
                location: "header",
                locationName: "Cache-Control"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-checksum-algorithm"
              },
              ContentDisposition: {
                location: "header",
                locationName: "Content-Disposition"
              },
              ContentEncoding: {
                location: "header",
                locationName: "Content-Encoding"
              },
              ContentLanguage: {
                location: "header",
                locationName: "Content-Language"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              CopySource: {
                location: "header",
                locationName: "x-amz-copy-source"
              },
              CopySourceIfMatch: {
                location: "header",
                locationName: "x-amz-copy-source-if-match"
              },
              CopySourceIfModifiedSince: {
                location: "header",
                locationName: "x-amz-copy-source-if-modified-since",
                type: "timestamp"
              },
              CopySourceIfNoneMatch: {
                location: "header",
                locationName: "x-amz-copy-source-if-none-match"
              },
              CopySourceIfUnmodifiedSince: {
                location: "header",
                locationName: "x-amz-copy-source-if-unmodified-since",
                type: "timestamp"
              },
              Expires: {
                location: "header",
                locationName: "Expires",
                type: "timestamp"
              },
              GrantFullControl: {
                location: "header",
                locationName: "x-amz-grant-full-control"
              },
              GrantRead: {
                location: "header",
                locationName: "x-amz-grant-read"
              },
              GrantReadACP: {
                location: "header",
                locationName: "x-amz-grant-read-acp"
              },
              GrantWriteACP: {
                location: "header",
                locationName: "x-amz-grant-write-acp"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              Metadata: {
                shape: "S1b",
                location: "headers",
                locationName: "x-amz-meta-"
              },
              MetadataDirective: {
                location: "header",
                locationName: "x-amz-metadata-directive"
              },
              TaggingDirective: {
                location: "header",
                locationName: "x-amz-tagging-directive"
              },
              ServerSideEncryption: {
                location: "header",
                locationName: "x-amz-server-side-encryption"
              },
              StorageClass: {
                location: "header",
                locationName: "x-amz-storage-class"
              },
              WebsiteRedirectLocation: {
                location: "header",
                locationName: "x-amz-website-redirect-location"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKey: {
                shape: "Sk",
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              },
              SSEKMSKeyId: {
                shape: "Sr",
                location: "header",
                locationName: "x-amz-server-side-encryption-aws-kms-key-id"
              },
              SSEKMSEncryptionContext: {
                shape: "S1i",
                location: "header",
                locationName: "x-amz-server-side-encryption-context"
              },
              BucketKeyEnabled: {
                location: "header",
                locationName: "x-amz-server-side-encryption-bucket-key-enabled",
                type: "boolean"
              },
              CopySourceSSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-copy-source-server-side-encryption-customer-algorithm"
              },
              CopySourceSSECustomerKey: {
                shape: "S1k",
                location: "header",
                locationName: "x-amz-copy-source-server-side-encryption-customer-key"
              },
              CopySourceSSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-copy-source-server-side-encryption-customer-key-MD5"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              Tagging: {
                location: "header",
                locationName: "x-amz-tagging"
              },
              ObjectLockMode: {
                location: "header",
                locationName: "x-amz-object-lock-mode"
              },
              ObjectLockRetainUntilDate: {
                shape: "S1o",
                location: "header",
                locationName: "x-amz-object-lock-retain-until-date"
              },
              ObjectLockLegalHoldStatus: {
                location: "header",
                locationName: "x-amz-object-lock-legal-hold"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              },
              ExpectedSourceBucketOwner: {
                location: "header",
                locationName: "x-amz-source-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CopyObjectResult: {
                type: "structure",
                members: {
                  ETag: {},
                  LastModified: {
                    type: "timestamp"
                  },
                  ChecksumCRC32: {},
                  ChecksumCRC32C: {},
                  ChecksumSHA1: {},
                  ChecksumSHA256: {}
                }
              },
              Expiration: {
                location: "header",
                locationName: "x-amz-expiration"
              },
              CopySourceVersionId: {
                location: "header",
                locationName: "x-amz-copy-source-version-id"
              },
              VersionId: {
                location: "header",
                locationName: "x-amz-version-id"
              },
              ServerSideEncryption: {
                location: "header",
                locationName: "x-amz-server-side-encryption"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              },
              SSEKMSKeyId: {
                shape: "Sr",
                location: "header",
                locationName: "x-amz-server-side-encryption-aws-kms-key-id"
              },
              SSEKMSEncryptionContext: {
                shape: "S1i",
                location: "header",
                locationName: "x-amz-server-side-encryption-context"
              },
              BucketKeyEnabled: {
                location: "header",
                locationName: "x-amz-server-side-encryption-bucket-key-enabled",
                type: "boolean"
              },
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            },
            payload: "CopyObjectResult"
          },
          alias: "PutObjectCopy",
          staticContextParams: {
            DisableS3ExpressSessionAuth: {
              value: true
            }
          }
        },
        CreateBucket: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              ACL: {
                location: "header",
                locationName: "x-amz-acl"
              },
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              CreateBucketConfiguration: {
                locationName: "CreateBucketConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                },
                type: "structure",
                members: {
                  LocationConstraint: {},
                  Location: {
                    type: "structure",
                    members: {
                      Type: {},
                      Name: {}
                    }
                  },
                  Bucket: {
                    type: "structure",
                    members: {
                      DataRedundancy: {},
                      Type: {}
                    }
                  }
                }
              },
              GrantFullControl: {
                location: "header",
                locationName: "x-amz-grant-full-control"
              },
              GrantRead: {
                location: "header",
                locationName: "x-amz-grant-read"
              },
              GrantReadACP: {
                location: "header",
                locationName: "x-amz-grant-read-acp"
              },
              GrantWrite: {
                location: "header",
                locationName: "x-amz-grant-write"
              },
              GrantWriteACP: {
                location: "header",
                locationName: "x-amz-grant-write-acp"
              },
              ObjectLockEnabledForBucket: {
                location: "header",
                locationName: "x-amz-bucket-object-lock-enabled",
                type: "boolean"
              },
              ObjectOwnership: {
                location: "header",
                locationName: "x-amz-object-ownership"
              }
            },
            payload: "CreateBucketConfiguration"
          },
          output: {
            type: "structure",
            members: {
              Location: {
                location: "header",
                locationName: "Location"
              }
            }
          },
          alias: "PutBucket",
          staticContextParams: {
            DisableAccessPoints: {
              value: true
            },
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        CreateMultipartUpload: {
          http: {
            requestUri: "/{Bucket}/{Key+}?uploads"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key"
            ],
            members: {
              ACL: {
                location: "header",
                locationName: "x-amz-acl"
              },
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              CacheControl: {
                location: "header",
                locationName: "Cache-Control"
              },
              ContentDisposition: {
                location: "header",
                locationName: "Content-Disposition"
              },
              ContentEncoding: {
                location: "header",
                locationName: "Content-Encoding"
              },
              ContentLanguage: {
                location: "header",
                locationName: "Content-Language"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              Expires: {
                location: "header",
                locationName: "Expires",
                type: "timestamp"
              },
              GrantFullControl: {
                location: "header",
                locationName: "x-amz-grant-full-control"
              },
              GrantRead: {
                location: "header",
                locationName: "x-amz-grant-read"
              },
              GrantReadACP: {
                location: "header",
                locationName: "x-amz-grant-read-acp"
              },
              GrantWriteACP: {
                location: "header",
                locationName: "x-amz-grant-write-acp"
              },
              Key: {
                contextParam: {
                  name: "Key"
                },
                location: "uri",
                locationName: "Key"
              },
              Metadata: {
                shape: "S1b",
                location: "headers",
                locationName: "x-amz-meta-"
              },
              ServerSideEncryption: {
                location: "header",
                locationName: "x-amz-server-side-encryption"
              },
              StorageClass: {
                location: "header",
                locationName: "x-amz-storage-class"
              },
              WebsiteRedirectLocation: {
                location: "header",
                locationName: "x-amz-website-redirect-location"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKey: {
                shape: "Sk",
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              },
              SSEKMSKeyId: {
                shape: "Sr",
                location: "header",
                locationName: "x-amz-server-side-encryption-aws-kms-key-id"
              },
              SSEKMSEncryptionContext: {
                shape: "S1i",
                location: "header",
                locationName: "x-amz-server-side-encryption-context"
              },
              BucketKeyEnabled: {
                location: "header",
                locationName: "x-amz-server-side-encryption-bucket-key-enabled",
                type: "boolean"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              Tagging: {
                location: "header",
                locationName: "x-amz-tagging"
              },
              ObjectLockMode: {
                location: "header",
                locationName: "x-amz-object-lock-mode"
              },
              ObjectLockRetainUntilDate: {
                shape: "S1o",
                location: "header",
                locationName: "x-amz-object-lock-retain-until-date"
              },
              ObjectLockLegalHoldStatus: {
                location: "header",
                locationName: "x-amz-object-lock-legal-hold"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-checksum-algorithm"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AbortDate: {
                location: "header",
                locationName: "x-amz-abort-date",
                type: "timestamp"
              },
              AbortRuleId: {
                location: "header",
                locationName: "x-amz-abort-rule-id"
              },
              Bucket: {
                locationName: "Bucket"
              },
              Key: {},
              UploadId: {},
              ServerSideEncryption: {
                location: "header",
                locationName: "x-amz-server-side-encryption"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              },
              SSEKMSKeyId: {
                shape: "Sr",
                location: "header",
                locationName: "x-amz-server-side-encryption-aws-kms-key-id"
              },
              SSEKMSEncryptionContext: {
                shape: "S1i",
                location: "header",
                locationName: "x-amz-server-side-encryption-context"
              },
              BucketKeyEnabled: {
                location: "header",
                locationName: "x-amz-server-side-encryption-bucket-key-enabled",
                type: "boolean"
              },
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-checksum-algorithm"
              }
            }
          },
          alias: "InitiateMultipartUpload"
        },
        CreateSession: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?session"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              SessionMode: {
                location: "header",
                locationName: "x-amz-create-session-mode"
              },
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Credentials"
            ],
            members: {
              Credentials: {
                locationName: "Credentials",
                type: "structure",
                required: [
                  "AccessKeyId",
                  "SecretAccessKey",
                  "SessionToken",
                  "Expiration"
                ],
                members: {
                  AccessKeyId: {
                    locationName: "AccessKeyId"
                  },
                  SecretAccessKey: {
                    shape: "S2h",
                    locationName: "SecretAccessKey"
                  },
                  SessionToken: {
                    shape: "S2h",
                    locationName: "SessionToken"
                  },
                  Expiration: {
                    locationName: "Expiration",
                    type: "timestamp"
                  }
                }
              }
            }
          },
          staticContextParams: {
            DisableS3ExpressSessionAuth: {
              value: true
            }
          }
        },
        DeleteBucket: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        DeleteBucketAnalyticsConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}?analytics",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Id"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Id: {
                location: "querystring",
                locationName: "id"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        DeleteBucketCors: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}?cors",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        DeleteBucketEncryption: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}?encryption",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        DeleteBucketIntelligentTieringConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}?intelligent-tiering",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Id"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Id: {
                location: "querystring",
                locationName: "id"
              }
            }
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        DeleteBucketInventoryConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}?inventory",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Id"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Id: {
                location: "querystring",
                locationName: "id"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        DeleteBucketLifecycle: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}?lifecycle",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        DeleteBucketMetricsConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}?metrics",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Id"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Id: {
                location: "querystring",
                locationName: "id"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        DeleteBucketOwnershipControls: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}?ownershipControls",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        DeleteBucketPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}?policy",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        DeleteBucketReplication: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}?replication",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        DeleteBucketTagging: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}?tagging",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        DeleteBucketWebsite: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}?website",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        DeleteObject: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}/{Key+}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Key: {
                contextParam: {
                  name: "Key"
                },
                location: "uri",
                locationName: "Key"
              },
              MFA: {
                location: "header",
                locationName: "x-amz-mfa"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionId"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              BypassGovernanceRetention: {
                location: "header",
                locationName: "x-amz-bypass-governance-retention",
                type: "boolean"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeleteMarker: {
                location: "header",
                locationName: "x-amz-delete-marker",
                type: "boolean"
              },
              VersionId: {
                location: "header",
                locationName: "x-amz-version-id"
              },
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            }
          }
        },
        DeleteObjectTagging: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}/{Key+}?tagging",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionId"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VersionId: {
                location: "header",
                locationName: "x-amz-version-id"
              }
            }
          }
        },
        DeleteObjects: {
          http: {
            requestUri: "/{Bucket}?delete"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Delete"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Delete: {
                locationName: "Delete",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                },
                type: "structure",
                required: [
                  "Objects"
                ],
                members: {
                  Objects: {
                    locationName: "Object",
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Key"
                      ],
                      members: {
                        Key: {},
                        VersionId: {}
                      }
                    },
                    flattened: true
                  },
                  Quiet: {
                    type: "boolean"
                  }
                }
              },
              MFA: {
                location: "header",
                locationName: "x-amz-mfa"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              BypassGovernanceRetention: {
                location: "header",
                locationName: "x-amz-bypass-governance-retention",
                type: "boolean"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-sdk-checksum-algorithm"
              }
            },
            payload: "Delete"
          },
          output: {
            type: "structure",
            members: {
              Deleted: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Key: {},
                    VersionId: {},
                    DeleteMarker: {
                      type: "boolean"
                    },
                    DeleteMarkerVersionId: {}
                  }
                },
                flattened: true
              },
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              },
              Errors: {
                locationName: "Error",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Key: {},
                    VersionId: {},
                    Code: {},
                    Message: {}
                  }
                },
                flattened: true
              }
            }
          },
          alias: "DeleteMultipleObjects",
          httpChecksum: {
            requestAlgorithmMember: "ChecksumAlgorithm",
            requestChecksumRequired: true
          }
        },
        DeletePublicAccessBlock: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}?publicAccessBlock",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        GetBucketAccelerateConfiguration: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?accelerate"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {},
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            }
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        GetBucketAcl: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?acl"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Owner: {
                shape: "S3q"
              },
              Grants: {
                shape: "S3t",
                locationName: "AccessControlList"
              }
            }
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        GetBucketAnalyticsConfiguration: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?analytics"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Id"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Id: {
                location: "querystring",
                locationName: "id"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AnalyticsConfiguration: {
                shape: "S42"
              }
            },
            payload: "AnalyticsConfiguration"
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        GetBucketCors: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?cors"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CORSRules: {
                shape: "S4h",
                locationName: "CORSRule"
              }
            }
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        GetBucketEncryption: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?encryption"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ServerSideEncryptionConfiguration: {
                shape: "S4u"
              }
            },
            payload: "ServerSideEncryptionConfiguration"
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        GetBucketIntelligentTieringConfiguration: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?intelligent-tiering"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Id"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Id: {
                location: "querystring",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IntelligentTieringConfiguration: {
                shape: "S50"
              }
            },
            payload: "IntelligentTieringConfiguration"
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        GetBucketInventoryConfiguration: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?inventory"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Id"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Id: {
                location: "querystring",
                locationName: "id"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InventoryConfiguration: {
                shape: "S5a"
              }
            },
            payload: "InventoryConfiguration"
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        GetBucketLifecycle: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?lifecycle"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Rules: {
                shape: "S5q",
                locationName: "Rule"
              }
            }
          },
          deprecated: true,
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        GetBucketLifecycleConfiguration: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?lifecycle"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Rules: {
                shape: "S66",
                locationName: "Rule"
              }
            }
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        GetBucketLocation: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?location"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocationConstraint: {}
            }
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        GetBucketLogging: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?logging"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LoggingEnabled: {
                shape: "S6i"
              }
            }
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        GetBucketMetricsConfiguration: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?metrics"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Id"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Id: {
                location: "querystring",
                locationName: "id"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MetricsConfiguration: {
                shape: "S6u"
              }
            },
            payload: "MetricsConfiguration"
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        GetBucketNotification: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?notification"
          },
          input: {
            shape: "S6y"
          },
          output: {
            shape: "S6z"
          },
          deprecated: true,
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        GetBucketNotificationConfiguration: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?notification"
          },
          input: {
            shape: "S6y"
          },
          output: {
            shape: "S7a"
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        GetBucketOwnershipControls: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?ownershipControls"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OwnershipControls: {
                shape: "S7r"
              }
            },
            payload: "OwnershipControls"
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        GetBucketPolicy: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?policy"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {}
            },
            payload: "Policy"
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        GetBucketPolicyStatus: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?policyStatus"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyStatus: {
                type: "structure",
                members: {
                  IsPublic: {
                    locationName: "IsPublic",
                    type: "boolean"
                  }
                }
              }
            },
            payload: "PolicyStatus"
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        GetBucketReplication: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?replication"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationConfiguration: {
                shape: "S83"
              }
            },
            payload: "ReplicationConfiguration"
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        GetBucketRequestPayment: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?requestPayment"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Payer: {}
            }
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        GetBucketTagging: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?tagging"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TagSet"
            ],
            members: {
              TagSet: {
                shape: "S48"
              }
            }
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        GetBucketVersioning: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?versioning"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {},
              MFADelete: {
                locationName: "MfaDelete"
              }
            }
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        GetBucketWebsite: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?website"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RedirectAllRequestsTo: {
                shape: "S96"
              },
              IndexDocument: {
                shape: "S99"
              },
              ErrorDocument: {
                shape: "S9b"
              },
              RoutingRules: {
                shape: "S9c"
              }
            }
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        GetObject: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}/{Key+}"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              },
              IfModifiedSince: {
                location: "header",
                locationName: "If-Modified-Since",
                type: "timestamp"
              },
              IfNoneMatch: {
                location: "header",
                locationName: "If-None-Match"
              },
              IfUnmodifiedSince: {
                location: "header",
                locationName: "If-Unmodified-Since",
                type: "timestamp"
              },
              Key: {
                contextParam: {
                  name: "Key"
                },
                location: "uri",
                locationName: "Key"
              },
              Range: {
                location: "header",
                locationName: "Range"
              },
              ResponseCacheControl: {
                location: "querystring",
                locationName: "response-cache-control"
              },
              ResponseContentDisposition: {
                location: "querystring",
                locationName: "response-content-disposition"
              },
              ResponseContentEncoding: {
                location: "querystring",
                locationName: "response-content-encoding"
              },
              ResponseContentLanguage: {
                location: "querystring",
                locationName: "response-content-language"
              },
              ResponseContentType: {
                location: "querystring",
                locationName: "response-content-type"
              },
              ResponseExpires: {
                location: "querystring",
                locationName: "response-expires",
                type: "timestamp",
                timestampFormat: "rfc822"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionId"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKey: {
                shape: "Sk",
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              PartNumber: {
                location: "querystring",
                locationName: "partNumber",
                type: "integer"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              },
              ChecksumMode: {
                location: "header",
                locationName: "x-amz-checksum-mode"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Body: {
                streaming: true,
                type: "blob"
              },
              DeleteMarker: {
                location: "header",
                locationName: "x-amz-delete-marker",
                type: "boolean"
              },
              AcceptRanges: {
                location: "header",
                locationName: "accept-ranges"
              },
              Expiration: {
                location: "header",
                locationName: "x-amz-expiration"
              },
              Restore: {
                location: "header",
                locationName: "x-amz-restore"
              },
              LastModified: {
                location: "header",
                locationName: "Last-Modified",
                type: "timestamp"
              },
              ContentLength: {
                location: "header",
                locationName: "Content-Length",
                type: "long"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              },
              ChecksumCRC32: {
                location: "header",
                locationName: "x-amz-checksum-crc32"
              },
              ChecksumCRC32C: {
                location: "header",
                locationName: "x-amz-checksum-crc32c"
              },
              ChecksumSHA1: {
                location: "header",
                locationName: "x-amz-checksum-sha1"
              },
              ChecksumSHA256: {
                location: "header",
                locationName: "x-amz-checksum-sha256"
              },
              MissingMeta: {
                location: "header",
                locationName: "x-amz-missing-meta",
                type: "integer"
              },
              VersionId: {
                location: "header",
                locationName: "x-amz-version-id"
              },
              CacheControl: {
                location: "header",
                locationName: "Cache-Control"
              },
              ContentDisposition: {
                location: "header",
                locationName: "Content-Disposition"
              },
              ContentEncoding: {
                location: "header",
                locationName: "Content-Encoding"
              },
              ContentLanguage: {
                location: "header",
                locationName: "Content-Language"
              },
              ContentRange: {
                location: "header",
                locationName: "Content-Range"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              Expires: {
                location: "header",
                locationName: "Expires",
                type: "timestamp"
              },
              WebsiteRedirectLocation: {
                location: "header",
                locationName: "x-amz-website-redirect-location"
              },
              ServerSideEncryption: {
                location: "header",
                locationName: "x-amz-server-side-encryption"
              },
              Metadata: {
                shape: "S1b",
                location: "headers",
                locationName: "x-amz-meta-"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              },
              SSEKMSKeyId: {
                shape: "Sr",
                location: "header",
                locationName: "x-amz-server-side-encryption-aws-kms-key-id"
              },
              BucketKeyEnabled: {
                location: "header",
                locationName: "x-amz-server-side-encryption-bucket-key-enabled",
                type: "boolean"
              },
              StorageClass: {
                location: "header",
                locationName: "x-amz-storage-class"
              },
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              },
              ReplicationStatus: {
                location: "header",
                locationName: "x-amz-replication-status"
              },
              PartsCount: {
                location: "header",
                locationName: "x-amz-mp-parts-count",
                type: "integer"
              },
              TagCount: {
                location: "header",
                locationName: "x-amz-tagging-count",
                type: "integer"
              },
              ObjectLockMode: {
                location: "header",
                locationName: "x-amz-object-lock-mode"
              },
              ObjectLockRetainUntilDate: {
                shape: "S1o",
                location: "header",
                locationName: "x-amz-object-lock-retain-until-date"
              },
              ObjectLockLegalHoldStatus: {
                location: "header",
                locationName: "x-amz-object-lock-legal-hold"
              }
            },
            payload: "Body"
          },
          httpChecksum: {
            requestValidationModeMember: "ChecksumMode",
            responseAlgorithms: [
              "CRC32",
              "CRC32C",
              "SHA256",
              "SHA1"
            ]
          }
        },
        GetObjectAcl: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}/{Key+}?acl"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Key: {
                contextParam: {
                  name: "Key"
                },
                location: "uri",
                locationName: "Key"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionId"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Owner: {
                shape: "S3q"
              },
              Grants: {
                shape: "S3t",
                locationName: "AccessControlList"
              },
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            }
          }
        },
        GetObjectAttributes: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}/{Key+}?attributes"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key",
              "ObjectAttributes"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionId"
              },
              MaxParts: {
                location: "header",
                locationName: "x-amz-max-parts",
                type: "integer"
              },
              PartNumberMarker: {
                location: "header",
                locationName: "x-amz-part-number-marker",
                type: "integer"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKey: {
                shape: "Sk",
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              },
              ObjectAttributes: {
                location: "header",
                locationName: "x-amz-object-attributes",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeleteMarker: {
                location: "header",
                locationName: "x-amz-delete-marker",
                type: "boolean"
              },
              LastModified: {
                location: "header",
                locationName: "Last-Modified",
                type: "timestamp"
              },
              VersionId: {
                location: "header",
                locationName: "x-amz-version-id"
              },
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              },
              ETag: {},
              Checksum: {
                type: "structure",
                members: {
                  ChecksumCRC32: {},
                  ChecksumCRC32C: {},
                  ChecksumSHA1: {},
                  ChecksumSHA256: {}
                }
              },
              ObjectParts: {
                type: "structure",
                members: {
                  TotalPartsCount: {
                    locationName: "PartsCount",
                    type: "integer"
                  },
                  PartNumberMarker: {
                    type: "integer"
                  },
                  NextPartNumberMarker: {
                    type: "integer"
                  },
                  MaxParts: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Parts: {
                    locationName: "Part",
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        PartNumber: {
                          type: "integer"
                        },
                        Size: {
                          type: "long"
                        },
                        ChecksumCRC32: {},
                        ChecksumCRC32C: {},
                        ChecksumSHA1: {},
                        ChecksumSHA256: {}
                      }
                    },
                    flattened: true
                  }
                }
              },
              StorageClass: {},
              ObjectSize: {
                type: "long"
              }
            }
          }
        },
        GetObjectLegalHold: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}/{Key+}?legal-hold"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionId"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LegalHold: {
                shape: "Saq"
              }
            },
            payload: "LegalHold"
          }
        },
        GetObjectLockConfiguration: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?object-lock"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ObjectLockConfiguration: {
                shape: "Sat"
              }
            },
            payload: "ObjectLockConfiguration"
          }
        },
        GetObjectRetention: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}/{Key+}?retention"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionId"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Retention: {
                shape: "Sb1"
              }
            },
            payload: "Retention"
          }
        },
        GetObjectTagging: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}/{Key+}?tagging"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionId"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TagSet"
            ],
            members: {
              VersionId: {
                location: "header",
                locationName: "x-amz-version-id"
              },
              TagSet: {
                shape: "S48"
              }
            }
          }
        },
        GetObjectTorrent: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}/{Key+}?torrent"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Body: {
                streaming: true,
                type: "blob"
              },
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            },
            payload: "Body"
          }
        },
        GetPublicAccessBlock: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?publicAccessBlock"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicAccessBlockConfiguration: {
                shape: "Sb8"
              }
            },
            payload: "PublicAccessBlockConfiguration"
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        HeadBucket: {
          http: {
            method: "HEAD",
            requestUri: "/{Bucket}"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BucketLocationType: {
                location: "header",
                locationName: "x-amz-bucket-location-type"
              },
              BucketLocationName: {
                location: "header",
                locationName: "x-amz-bucket-location-name"
              },
              BucketRegion: {
                location: "header",
                locationName: "x-amz-bucket-region"
              },
              AccessPointAlias: {
                location: "header",
                locationName: "x-amz-access-point-alias",
                type: "boolean"
              }
            }
          }
        },
        HeadObject: {
          http: {
            method: "HEAD",
            requestUri: "/{Bucket}/{Key+}"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              },
              IfModifiedSince: {
                location: "header",
                locationName: "If-Modified-Since",
                type: "timestamp"
              },
              IfNoneMatch: {
                location: "header",
                locationName: "If-None-Match"
              },
              IfUnmodifiedSince: {
                location: "header",
                locationName: "If-Unmodified-Since",
                type: "timestamp"
              },
              Key: {
                contextParam: {
                  name: "Key"
                },
                location: "uri",
                locationName: "Key"
              },
              Range: {
                location: "header",
                locationName: "Range"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionId"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKey: {
                shape: "Sk",
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              PartNumber: {
                location: "querystring",
                locationName: "partNumber",
                type: "integer"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              },
              ChecksumMode: {
                location: "header",
                locationName: "x-amz-checksum-mode"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeleteMarker: {
                location: "header",
                locationName: "x-amz-delete-marker",
                type: "boolean"
              },
              AcceptRanges: {
                location: "header",
                locationName: "accept-ranges"
              },
              Expiration: {
                location: "header",
                locationName: "x-amz-expiration"
              },
              Restore: {
                location: "header",
                locationName: "x-amz-restore"
              },
              ArchiveStatus: {
                location: "header",
                locationName: "x-amz-archive-status"
              },
              LastModified: {
                location: "header",
                locationName: "Last-Modified",
                type: "timestamp"
              },
              ContentLength: {
                location: "header",
                locationName: "Content-Length",
                type: "long"
              },
              ChecksumCRC32: {
                location: "header",
                locationName: "x-amz-checksum-crc32"
              },
              ChecksumCRC32C: {
                location: "header",
                locationName: "x-amz-checksum-crc32c"
              },
              ChecksumSHA1: {
                location: "header",
                locationName: "x-amz-checksum-sha1"
              },
              ChecksumSHA256: {
                location: "header",
                locationName: "x-amz-checksum-sha256"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              },
              MissingMeta: {
                location: "header",
                locationName: "x-amz-missing-meta",
                type: "integer"
              },
              VersionId: {
                location: "header",
                locationName: "x-amz-version-id"
              },
              CacheControl: {
                location: "header",
                locationName: "Cache-Control"
              },
              ContentDisposition: {
                location: "header",
                locationName: "Content-Disposition"
              },
              ContentEncoding: {
                location: "header",
                locationName: "Content-Encoding"
              },
              ContentLanguage: {
                location: "header",
                locationName: "Content-Language"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              Expires: {
                location: "header",
                locationName: "Expires",
                type: "timestamp"
              },
              WebsiteRedirectLocation: {
                location: "header",
                locationName: "x-amz-website-redirect-location"
              },
              ServerSideEncryption: {
                location: "header",
                locationName: "x-amz-server-side-encryption"
              },
              Metadata: {
                shape: "S1b",
                location: "headers",
                locationName: "x-amz-meta-"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              },
              SSEKMSKeyId: {
                shape: "Sr",
                location: "header",
                locationName: "x-amz-server-side-encryption-aws-kms-key-id"
              },
              BucketKeyEnabled: {
                location: "header",
                locationName: "x-amz-server-side-encryption-bucket-key-enabled",
                type: "boolean"
              },
              StorageClass: {
                location: "header",
                locationName: "x-amz-storage-class"
              },
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              },
              ReplicationStatus: {
                location: "header",
                locationName: "x-amz-replication-status"
              },
              PartsCount: {
                location: "header",
                locationName: "x-amz-mp-parts-count",
                type: "integer"
              },
              ObjectLockMode: {
                location: "header",
                locationName: "x-amz-object-lock-mode"
              },
              ObjectLockRetainUntilDate: {
                shape: "S1o",
                location: "header",
                locationName: "x-amz-object-lock-retain-until-date"
              },
              ObjectLockLegalHoldStatus: {
                location: "header",
                locationName: "x-amz-object-lock-legal-hold"
              }
            }
          }
        },
        ListBucketAnalyticsConfigurations: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?analytics"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ContinuationToken: {
                location: "querystring",
                locationName: "continuation-token"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IsTruncated: {
                type: "boolean"
              },
              ContinuationToken: {},
              NextContinuationToken: {},
              AnalyticsConfigurationList: {
                locationName: "AnalyticsConfiguration",
                type: "list",
                member: {
                  shape: "S42"
                },
                flattened: true
              }
            }
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        ListBucketIntelligentTieringConfigurations: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?intelligent-tiering"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ContinuationToken: {
                location: "querystring",
                locationName: "continuation-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IsTruncated: {
                type: "boolean"
              },
              ContinuationToken: {},
              NextContinuationToken: {},
              IntelligentTieringConfigurationList: {
                locationName: "IntelligentTieringConfiguration",
                type: "list",
                member: {
                  shape: "S50"
                },
                flattened: true
              }
            }
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        ListBucketInventoryConfigurations: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?inventory"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ContinuationToken: {
                location: "querystring",
                locationName: "continuation-token"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContinuationToken: {},
              InventoryConfigurationList: {
                locationName: "InventoryConfiguration",
                type: "list",
                member: {
                  shape: "S5a"
                },
                flattened: true
              },
              IsTruncated: {
                type: "boolean"
              },
              NextContinuationToken: {}
            }
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        ListBucketMetricsConfigurations: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?metrics"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ContinuationToken: {
                location: "querystring",
                locationName: "continuation-token"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IsTruncated: {
                type: "boolean"
              },
              ContinuationToken: {},
              NextContinuationToken: {},
              MetricsConfigurationList: {
                locationName: "MetricsConfiguration",
                type: "list",
                member: {
                  shape: "S6u"
                },
                flattened: true
              }
            }
          }
        },
        ListBuckets: {
          http: {
            method: "GET"
          },
          output: {
            type: "structure",
            members: {
              Buckets: {
                shape: "Sbx"
              },
              Owner: {
                shape: "S3q"
              }
            }
          },
          alias: "GetService"
        },
        ListDirectoryBuckets: {
          http: {
            method: "GET"
          },
          input: {
            type: "structure",
            members: {
              ContinuationToken: {
                location: "querystring",
                locationName: "continuation-token"
              },
              MaxDirectoryBuckets: {
                location: "querystring",
                locationName: "max-directory-buckets",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Buckets: {
                shape: "Sbx"
              },
              ContinuationToken: {}
            }
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        ListMultipartUploads: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?uploads"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Delimiter: {
                location: "querystring",
                locationName: "delimiter"
              },
              EncodingType: {
                location: "querystring",
                locationName: "encoding-type"
              },
              KeyMarker: {
                location: "querystring",
                locationName: "key-marker"
              },
              MaxUploads: {
                location: "querystring",
                locationName: "max-uploads",
                type: "integer"
              },
              Prefix: {
                contextParam: {
                  name: "Prefix"
                },
                location: "querystring",
                locationName: "prefix"
              },
              UploadIdMarker: {
                location: "querystring",
                locationName: "upload-id-marker"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Bucket: {},
              KeyMarker: {},
              UploadIdMarker: {},
              NextKeyMarker: {},
              Prefix: {},
              Delimiter: {},
              NextUploadIdMarker: {},
              MaxUploads: {
                type: "integer"
              },
              IsTruncated: {
                type: "boolean"
              },
              Uploads: {
                locationName: "Upload",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    UploadId: {},
                    Key: {},
                    Initiated: {
                      type: "timestamp"
                    },
                    StorageClass: {},
                    Owner: {
                      shape: "S3q"
                    },
                    Initiator: {
                      shape: "Scg"
                    },
                    ChecksumAlgorithm: {}
                  }
                },
                flattened: true
              },
              CommonPrefixes: {
                shape: "Sch"
              },
              EncodingType: {},
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            }
          }
        },
        ListObjectVersions: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?versions"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Delimiter: {
                location: "querystring",
                locationName: "delimiter"
              },
              EncodingType: {
                location: "querystring",
                locationName: "encoding-type"
              },
              KeyMarker: {
                location: "querystring",
                locationName: "key-marker"
              },
              MaxKeys: {
                location: "querystring",
                locationName: "max-keys",
                type: "integer"
              },
              Prefix: {
                contextParam: {
                  name: "Prefix"
                },
                location: "querystring",
                locationName: "prefix"
              },
              VersionIdMarker: {
                location: "querystring",
                locationName: "version-id-marker"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              OptionalObjectAttributes: {
                shape: "Scm",
                location: "header",
                locationName: "x-amz-optional-object-attributes"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IsTruncated: {
                type: "boolean"
              },
              KeyMarker: {},
              VersionIdMarker: {},
              NextKeyMarker: {},
              NextVersionIdMarker: {},
              Versions: {
                locationName: "Version",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ETag: {},
                    ChecksumAlgorithm: {
                      shape: "Scs"
                    },
                    Size: {
                      type: "long"
                    },
                    StorageClass: {},
                    Key: {},
                    VersionId: {},
                    IsLatest: {
                      type: "boolean"
                    },
                    LastModified: {
                      type: "timestamp"
                    },
                    Owner: {
                      shape: "S3q"
                    },
                    RestoreStatus: {
                      shape: "Scv"
                    }
                  }
                },
                flattened: true
              },
              DeleteMarkers: {
                locationName: "DeleteMarker",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Owner: {
                      shape: "S3q"
                    },
                    Key: {},
                    VersionId: {},
                    IsLatest: {
                      type: "boolean"
                    },
                    LastModified: {
                      type: "timestamp"
                    }
                  }
                },
                flattened: true
              },
              Name: {},
              Prefix: {},
              Delimiter: {},
              MaxKeys: {
                type: "integer"
              },
              CommonPrefixes: {
                shape: "Sch"
              },
              EncodingType: {},
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            }
          },
          alias: "GetBucketObjectVersions"
        },
        ListObjects: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Delimiter: {
                location: "querystring",
                locationName: "delimiter"
              },
              EncodingType: {
                location: "querystring",
                locationName: "encoding-type"
              },
              Marker: {
                location: "querystring",
                locationName: "marker"
              },
              MaxKeys: {
                location: "querystring",
                locationName: "max-keys",
                type: "integer"
              },
              Prefix: {
                contextParam: {
                  name: "Prefix"
                },
                location: "querystring",
                locationName: "prefix"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              },
              OptionalObjectAttributes: {
                shape: "Scm",
                location: "header",
                locationName: "x-amz-optional-object-attributes"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IsTruncated: {
                type: "boolean"
              },
              Marker: {},
              NextMarker: {},
              Contents: {
                shape: "Sd4"
              },
              Name: {},
              Prefix: {},
              Delimiter: {},
              MaxKeys: {
                type: "integer"
              },
              CommonPrefixes: {
                shape: "Sch"
              },
              EncodingType: {},
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            }
          },
          alias: "GetBucket"
        },
        ListObjectsV2: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?list-type=2"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Delimiter: {
                location: "querystring",
                locationName: "delimiter"
              },
              EncodingType: {
                location: "querystring",
                locationName: "encoding-type"
              },
              MaxKeys: {
                location: "querystring",
                locationName: "max-keys",
                type: "integer"
              },
              Prefix: {
                contextParam: {
                  name: "Prefix"
                },
                location: "querystring",
                locationName: "prefix"
              },
              ContinuationToken: {
                location: "querystring",
                locationName: "continuation-token"
              },
              FetchOwner: {
                location: "querystring",
                locationName: "fetch-owner",
                type: "boolean"
              },
              StartAfter: {
                location: "querystring",
                locationName: "start-after"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              },
              OptionalObjectAttributes: {
                shape: "Scm",
                location: "header",
                locationName: "x-amz-optional-object-attributes"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IsTruncated: {
                type: "boolean"
              },
              Contents: {
                shape: "Sd4"
              },
              Name: {},
              Prefix: {},
              Delimiter: {},
              MaxKeys: {
                type: "integer"
              },
              CommonPrefixes: {
                shape: "Sch"
              },
              EncodingType: {},
              KeyCount: {
                type: "integer"
              },
              ContinuationToken: {},
              NextContinuationToken: {},
              StartAfter: {},
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            }
          }
        },
        ListParts: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}/{Key+}"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key",
              "UploadId"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Key: {
                contextParam: {
                  name: "Key"
                },
                location: "uri",
                locationName: "Key"
              },
              MaxParts: {
                location: "querystring",
                locationName: "max-parts",
                type: "integer"
              },
              PartNumberMarker: {
                location: "querystring",
                locationName: "part-number-marker",
                type: "integer"
              },
              UploadId: {
                location: "querystring",
                locationName: "uploadId"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKey: {
                shape: "Sk",
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AbortDate: {
                location: "header",
                locationName: "x-amz-abort-date",
                type: "timestamp"
              },
              AbortRuleId: {
                location: "header",
                locationName: "x-amz-abort-rule-id"
              },
              Bucket: {},
              Key: {},
              UploadId: {},
              PartNumberMarker: {
                type: "integer"
              },
              NextPartNumberMarker: {
                type: "integer"
              },
              MaxParts: {
                type: "integer"
              },
              IsTruncated: {
                type: "boolean"
              },
              Parts: {
                locationName: "Part",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PartNumber: {
                      type: "integer"
                    },
                    LastModified: {
                      type: "timestamp"
                    },
                    ETag: {},
                    Size: {
                      type: "long"
                    },
                    ChecksumCRC32: {},
                    ChecksumCRC32C: {},
                    ChecksumSHA1: {},
                    ChecksumSHA256: {}
                  }
                },
                flattened: true
              },
              Initiator: {
                shape: "Scg"
              },
              Owner: {
                shape: "S3q"
              },
              StorageClass: {},
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              },
              ChecksumAlgorithm: {}
            }
          }
        },
        PutBucketAccelerateConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?accelerate"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "AccelerateConfiguration"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              AccelerateConfiguration: {
                locationName: "AccelerateConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                },
                type: "structure",
                members: {
                  Status: {}
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-sdk-checksum-algorithm"
              }
            },
            payload: "AccelerateConfiguration"
          },
          httpChecksum: {
            requestAlgorithmMember: "ChecksumAlgorithm",
            requestChecksumRequired: false
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        PutBucketAcl: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?acl"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              ACL: {
                location: "header",
                locationName: "x-amz-acl"
              },
              AccessControlPolicy: {
                shape: "Sdj",
                locationName: "AccessControlPolicy",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              },
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-sdk-checksum-algorithm"
              },
              GrantFullControl: {
                location: "header",
                locationName: "x-amz-grant-full-control"
              },
              GrantRead: {
                location: "header",
                locationName: "x-amz-grant-read"
              },
              GrantReadACP: {
                location: "header",
                locationName: "x-amz-grant-read-acp"
              },
              GrantWrite: {
                location: "header",
                locationName: "x-amz-grant-write"
              },
              GrantWriteACP: {
                location: "header",
                locationName: "x-amz-grant-write-acp"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "AccessControlPolicy"
          },
          httpChecksum: {
            requestAlgorithmMember: "ChecksumAlgorithm",
            requestChecksumRequired: true
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        PutBucketAnalyticsConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?analytics"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Id",
              "AnalyticsConfiguration"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Id: {
                location: "querystring",
                locationName: "id"
              },
              AnalyticsConfiguration: {
                shape: "S42",
                locationName: "AnalyticsConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "AnalyticsConfiguration"
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        PutBucketCors: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?cors"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "CORSConfiguration"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              CORSConfiguration: {
                locationName: "CORSConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                },
                type: "structure",
                required: [
                  "CORSRules"
                ],
                members: {
                  CORSRules: {
                    shape: "S4h",
                    locationName: "CORSRule"
                  }
                }
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-sdk-checksum-algorithm"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "CORSConfiguration"
          },
          httpChecksum: {
            requestAlgorithmMember: "ChecksumAlgorithm",
            requestChecksumRequired: true
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        PutBucketEncryption: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?encryption"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "ServerSideEncryptionConfiguration"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-sdk-checksum-algorithm"
              },
              ServerSideEncryptionConfiguration: {
                shape: "S4u",
                locationName: "ServerSideEncryptionConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "ServerSideEncryptionConfiguration"
          },
          httpChecksum: {
            requestAlgorithmMember: "ChecksumAlgorithm",
            requestChecksumRequired: true
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        PutBucketIntelligentTieringConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?intelligent-tiering"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Id",
              "IntelligentTieringConfiguration"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Id: {
                location: "querystring",
                locationName: "id"
              },
              IntelligentTieringConfiguration: {
                shape: "S50",
                locationName: "IntelligentTieringConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              }
            },
            payload: "IntelligentTieringConfiguration"
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        PutBucketInventoryConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?inventory"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Id",
              "InventoryConfiguration"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Id: {
                location: "querystring",
                locationName: "id"
              },
              InventoryConfiguration: {
                shape: "S5a",
                locationName: "InventoryConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "InventoryConfiguration"
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        PutBucketLifecycle: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?lifecycle"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-sdk-checksum-algorithm"
              },
              LifecycleConfiguration: {
                locationName: "LifecycleConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                },
                type: "structure",
                required: [
                  "Rules"
                ],
                members: {
                  Rules: {
                    shape: "S5q",
                    locationName: "Rule"
                  }
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "LifecycleConfiguration"
          },
          deprecated: true,
          httpChecksum: {
            requestAlgorithmMember: "ChecksumAlgorithm",
            requestChecksumRequired: true
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        PutBucketLifecycleConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?lifecycle"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-sdk-checksum-algorithm"
              },
              LifecycleConfiguration: {
                locationName: "LifecycleConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                },
                type: "structure",
                required: [
                  "Rules"
                ],
                members: {
                  Rules: {
                    shape: "S66",
                    locationName: "Rule"
                  }
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "LifecycleConfiguration"
          },
          httpChecksum: {
            requestAlgorithmMember: "ChecksumAlgorithm",
            requestChecksumRequired: true
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        PutBucketLogging: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?logging"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "BucketLoggingStatus"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              BucketLoggingStatus: {
                locationName: "BucketLoggingStatus",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                },
                type: "structure",
                members: {
                  LoggingEnabled: {
                    shape: "S6i"
                  }
                }
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-sdk-checksum-algorithm"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "BucketLoggingStatus"
          },
          httpChecksum: {
            requestAlgorithmMember: "ChecksumAlgorithm",
            requestChecksumRequired: true
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        PutBucketMetricsConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?metrics"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Id",
              "MetricsConfiguration"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Id: {
                location: "querystring",
                locationName: "id"
              },
              MetricsConfiguration: {
                shape: "S6u",
                locationName: "MetricsConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "MetricsConfiguration"
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        PutBucketNotification: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?notification"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "NotificationConfiguration"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-sdk-checksum-algorithm"
              },
              NotificationConfiguration: {
                shape: "S6z",
                locationName: "NotificationConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "NotificationConfiguration"
          },
          deprecated: true,
          httpChecksum: {
            requestAlgorithmMember: "ChecksumAlgorithm",
            requestChecksumRequired: true
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        PutBucketNotificationConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?notification"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "NotificationConfiguration"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              NotificationConfiguration: {
                shape: "S7a",
                locationName: "NotificationConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              },
              SkipDestinationValidation: {
                location: "header",
                locationName: "x-amz-skip-destination-validation",
                type: "boolean"
              }
            },
            payload: "NotificationConfiguration"
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        PutBucketOwnershipControls: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?ownershipControls"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "OwnershipControls"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              },
              OwnershipControls: {
                shape: "S7r",
                locationName: "OwnershipControls",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              }
            },
            payload: "OwnershipControls"
          },
          httpChecksum: {
            requestChecksumRequired: true
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        PutBucketPolicy: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?policy"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Policy"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-sdk-checksum-algorithm"
              },
              ConfirmRemoveSelfBucketAccess: {
                location: "header",
                locationName: "x-amz-confirm-remove-self-bucket-access",
                type: "boolean"
              },
              Policy: {},
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "Policy"
          },
          httpChecksum: {
            requestAlgorithmMember: "ChecksumAlgorithm",
            requestChecksumRequired: true
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        PutBucketReplication: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?replication"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "ReplicationConfiguration"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-sdk-checksum-algorithm"
              },
              ReplicationConfiguration: {
                shape: "S83",
                locationName: "ReplicationConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              },
              Token: {
                location: "header",
                locationName: "x-amz-bucket-object-lock-token"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "ReplicationConfiguration"
          },
          httpChecksum: {
            requestAlgorithmMember: "ChecksumAlgorithm",
            requestChecksumRequired: true
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        PutBucketRequestPayment: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?requestPayment"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "RequestPaymentConfiguration"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-sdk-checksum-algorithm"
              },
              RequestPaymentConfiguration: {
                locationName: "RequestPaymentConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                },
                type: "structure",
                required: [
                  "Payer"
                ],
                members: {
                  Payer: {}
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "RequestPaymentConfiguration"
          },
          httpChecksum: {
            requestAlgorithmMember: "ChecksumAlgorithm",
            requestChecksumRequired: true
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        PutBucketTagging: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?tagging"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Tagging"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-sdk-checksum-algorithm"
              },
              Tagging: {
                shape: "Se9",
                locationName: "Tagging",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "Tagging"
          },
          httpChecksum: {
            requestAlgorithmMember: "ChecksumAlgorithm",
            requestChecksumRequired: true
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        PutBucketVersioning: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?versioning"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "VersioningConfiguration"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-sdk-checksum-algorithm"
              },
              MFA: {
                location: "header",
                locationName: "x-amz-mfa"
              },
              VersioningConfiguration: {
                locationName: "VersioningConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                },
                type: "structure",
                members: {
                  MFADelete: {
                    locationName: "MfaDelete"
                  },
                  Status: {}
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "VersioningConfiguration"
          },
          httpChecksum: {
            requestAlgorithmMember: "ChecksumAlgorithm",
            requestChecksumRequired: true
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        PutBucketWebsite: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?website"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "WebsiteConfiguration"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-sdk-checksum-algorithm"
              },
              WebsiteConfiguration: {
                locationName: "WebsiteConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                },
                type: "structure",
                members: {
                  ErrorDocument: {
                    shape: "S9b"
                  },
                  IndexDocument: {
                    shape: "S99"
                  },
                  RedirectAllRequestsTo: {
                    shape: "S96"
                  },
                  RoutingRules: {
                    shape: "S9c"
                  }
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "WebsiteConfiguration"
          },
          httpChecksum: {
            requestAlgorithmMember: "ChecksumAlgorithm",
            requestChecksumRequired: true
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        PutObject: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}/{Key+}"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key"
            ],
            members: {
              ACL: {
                location: "header",
                locationName: "x-amz-acl"
              },
              Body: {
                streaming: true,
                type: "blob"
              },
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              CacheControl: {
                location: "header",
                locationName: "Cache-Control"
              },
              ContentDisposition: {
                location: "header",
                locationName: "Content-Disposition"
              },
              ContentEncoding: {
                location: "header",
                locationName: "Content-Encoding"
              },
              ContentLanguage: {
                location: "header",
                locationName: "Content-Language"
              },
              ContentLength: {
                location: "header",
                locationName: "Content-Length",
                type: "long"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-sdk-checksum-algorithm"
              },
              ChecksumCRC32: {
                location: "header",
                locationName: "x-amz-checksum-crc32"
              },
              ChecksumCRC32C: {
                location: "header",
                locationName: "x-amz-checksum-crc32c"
              },
              ChecksumSHA1: {
                location: "header",
                locationName: "x-amz-checksum-sha1"
              },
              ChecksumSHA256: {
                location: "header",
                locationName: "x-amz-checksum-sha256"
              },
              Expires: {
                location: "header",
                locationName: "Expires",
                type: "timestamp"
              },
              GrantFullControl: {
                location: "header",
                locationName: "x-amz-grant-full-control"
              },
              GrantRead: {
                location: "header",
                locationName: "x-amz-grant-read"
              },
              GrantReadACP: {
                location: "header",
                locationName: "x-amz-grant-read-acp"
              },
              GrantWriteACP: {
                location: "header",
                locationName: "x-amz-grant-write-acp"
              },
              Key: {
                contextParam: {
                  name: "Key"
                },
                location: "uri",
                locationName: "Key"
              },
              Metadata: {
                shape: "S1b",
                location: "headers",
                locationName: "x-amz-meta-"
              },
              ServerSideEncryption: {
                location: "header",
                locationName: "x-amz-server-side-encryption"
              },
              StorageClass: {
                location: "header",
                locationName: "x-amz-storage-class"
              },
              WebsiteRedirectLocation: {
                location: "header",
                locationName: "x-amz-website-redirect-location"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKey: {
                shape: "Sk",
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              },
              SSEKMSKeyId: {
                shape: "Sr",
                location: "header",
                locationName: "x-amz-server-side-encryption-aws-kms-key-id"
              },
              SSEKMSEncryptionContext: {
                shape: "S1i",
                location: "header",
                locationName: "x-amz-server-side-encryption-context"
              },
              BucketKeyEnabled: {
                location: "header",
                locationName: "x-amz-server-side-encryption-bucket-key-enabled",
                type: "boolean"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              Tagging: {
                location: "header",
                locationName: "x-amz-tagging"
              },
              ObjectLockMode: {
                location: "header",
                locationName: "x-amz-object-lock-mode"
              },
              ObjectLockRetainUntilDate: {
                shape: "S1o",
                location: "header",
                locationName: "x-amz-object-lock-retain-until-date"
              },
              ObjectLockLegalHoldStatus: {
                location: "header",
                locationName: "x-amz-object-lock-legal-hold"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "Body"
          },
          output: {
            type: "structure",
            members: {
              Expiration: {
                location: "header",
                locationName: "x-amz-expiration"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              },
              ChecksumCRC32: {
                location: "header",
                locationName: "x-amz-checksum-crc32"
              },
              ChecksumCRC32C: {
                location: "header",
                locationName: "x-amz-checksum-crc32c"
              },
              ChecksumSHA1: {
                location: "header",
                locationName: "x-amz-checksum-sha1"
              },
              ChecksumSHA256: {
                location: "header",
                locationName: "x-amz-checksum-sha256"
              },
              ServerSideEncryption: {
                location: "header",
                locationName: "x-amz-server-side-encryption"
              },
              VersionId: {
                location: "header",
                locationName: "x-amz-version-id"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              },
              SSEKMSKeyId: {
                shape: "Sr",
                location: "header",
                locationName: "x-amz-server-side-encryption-aws-kms-key-id"
              },
              SSEKMSEncryptionContext: {
                shape: "S1i",
                location: "header",
                locationName: "x-amz-server-side-encryption-context"
              },
              BucketKeyEnabled: {
                location: "header",
                locationName: "x-amz-server-side-encryption-bucket-key-enabled",
                type: "boolean"
              },
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            }
          },
          httpChecksum: {
            requestAlgorithmMember: "ChecksumAlgorithm",
            requestChecksumRequired: false
          }
        },
        PutObjectAcl: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}/{Key+}?acl"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key"
            ],
            members: {
              ACL: {
                location: "header",
                locationName: "x-amz-acl"
              },
              AccessControlPolicy: {
                shape: "Sdj",
                locationName: "AccessControlPolicy",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              },
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-sdk-checksum-algorithm"
              },
              GrantFullControl: {
                location: "header",
                locationName: "x-amz-grant-full-control"
              },
              GrantRead: {
                location: "header",
                locationName: "x-amz-grant-read"
              },
              GrantReadACP: {
                location: "header",
                locationName: "x-amz-grant-read-acp"
              },
              GrantWrite: {
                location: "header",
                locationName: "x-amz-grant-write"
              },
              GrantWriteACP: {
                location: "header",
                locationName: "x-amz-grant-write-acp"
              },
              Key: {
                contextParam: {
                  name: "Key"
                },
                location: "uri",
                locationName: "Key"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionId"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "AccessControlPolicy"
          },
          output: {
            type: "structure",
            members: {
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            }
          },
          httpChecksum: {
            requestAlgorithmMember: "ChecksumAlgorithm",
            requestChecksumRequired: true
          }
        },
        PutObjectLegalHold: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}/{Key+}?legal-hold"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              LegalHold: {
                shape: "Saq",
                locationName: "LegalHold",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionId"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-sdk-checksum-algorithm"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "LegalHold"
          },
          output: {
            type: "structure",
            members: {
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            }
          },
          httpChecksum: {
            requestAlgorithmMember: "ChecksumAlgorithm",
            requestChecksumRequired: true
          }
        },
        PutObjectLockConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?object-lock"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ObjectLockConfiguration: {
                shape: "Sat",
                locationName: "ObjectLockConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              Token: {
                location: "header",
                locationName: "x-amz-bucket-object-lock-token"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-sdk-checksum-algorithm"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "ObjectLockConfiguration"
          },
          output: {
            type: "structure",
            members: {
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            }
          },
          httpChecksum: {
            requestAlgorithmMember: "ChecksumAlgorithm",
            requestChecksumRequired: true
          }
        },
        PutObjectRetention: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}/{Key+}?retention"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              Retention: {
                shape: "Sb1",
                locationName: "Retention",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionId"
              },
              BypassGovernanceRetention: {
                location: "header",
                locationName: "x-amz-bypass-governance-retention",
                type: "boolean"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-sdk-checksum-algorithm"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "Retention"
          },
          output: {
            type: "structure",
            members: {
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            }
          },
          httpChecksum: {
            requestAlgorithmMember: "ChecksumAlgorithm",
            requestChecksumRequired: true
          }
        },
        PutObjectTagging: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}/{Key+}?tagging"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key",
              "Tagging"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionId"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-sdk-checksum-algorithm"
              },
              Tagging: {
                shape: "Se9",
                locationName: "Tagging",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              }
            },
            payload: "Tagging"
          },
          output: {
            type: "structure",
            members: {
              VersionId: {
                location: "header",
                locationName: "x-amz-version-id"
              }
            }
          },
          httpChecksum: {
            requestAlgorithmMember: "ChecksumAlgorithm",
            requestChecksumRequired: true
          }
        },
        PutPublicAccessBlock: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?publicAccessBlock"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "PublicAccessBlockConfiguration"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-sdk-checksum-algorithm"
              },
              PublicAccessBlockConfiguration: {
                shape: "Sb8",
                locationName: "PublicAccessBlockConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "PublicAccessBlockConfiguration"
          },
          httpChecksum: {
            requestAlgorithmMember: "ChecksumAlgorithm",
            requestChecksumRequired: true
          },
          staticContextParams: {
            UseS3ExpressControlEndpoint: {
              value: true
            }
          }
        },
        RestoreObject: {
          http: {
            requestUri: "/{Bucket}/{Key+}?restore"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionId"
              },
              RestoreRequest: {
                locationName: "RestoreRequest",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                },
                type: "structure",
                members: {
                  Days: {
                    type: "integer"
                  },
                  GlacierJobParameters: {
                    type: "structure",
                    required: [
                      "Tier"
                    ],
                    members: {
                      Tier: {}
                    }
                  },
                  Type: {},
                  Tier: {},
                  Description: {},
                  SelectParameters: {
                    type: "structure",
                    required: [
                      "InputSerialization",
                      "ExpressionType",
                      "Expression",
                      "OutputSerialization"
                    ],
                    members: {
                      InputSerialization: {
                        shape: "Sez"
                      },
                      ExpressionType: {},
                      Expression: {},
                      OutputSerialization: {
                        shape: "Sfe"
                      }
                    }
                  },
                  OutputLocation: {
                    type: "structure",
                    members: {
                      S3: {
                        type: "structure",
                        required: [
                          "BucketName",
                          "Prefix"
                        ],
                        members: {
                          BucketName: {},
                          Prefix: {},
                          Encryption: {
                            type: "structure",
                            required: [
                              "EncryptionType"
                            ],
                            members: {
                              EncryptionType: {},
                              KMSKeyId: {
                                shape: "Sr"
                              },
                              KMSContext: {}
                            }
                          },
                          CannedACL: {},
                          AccessControlList: {
                            shape: "S3t"
                          },
                          Tagging: {
                            shape: "Se9"
                          },
                          UserMetadata: {
                            type: "list",
                            member: {
                              locationName: "MetadataEntry",
                              type: "structure",
                              members: {
                                Name: {},
                                Value: {}
                              }
                            }
                          },
                          StorageClass: {}
                        }
                      }
                    }
                  }
                }
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-sdk-checksum-algorithm"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "RestoreRequest"
          },
          output: {
            type: "structure",
            members: {
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              },
              RestoreOutputPath: {
                location: "header",
                locationName: "x-amz-restore-output-path"
              }
            }
          },
          alias: "PostObjectRestore",
          httpChecksum: {
            requestAlgorithmMember: "ChecksumAlgorithm",
            requestChecksumRequired: false
          }
        },
        SelectObjectContent: {
          http: {
            requestUri: "/{Bucket}/{Key+}?select&select-type=2"
          },
          input: {
            locationName: "SelectObjectContentRequest",
            xmlNamespace: {
              uri: "http://s3.amazonaws.com/doc/2006-03-01/"
            },
            type: "structure",
            required: [
              "Bucket",
              "Key",
              "Expression",
              "ExpressionType",
              "InputSerialization",
              "OutputSerialization"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKey: {
                shape: "Sk",
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              },
              Expression: {},
              ExpressionType: {},
              RequestProgress: {
                type: "structure",
                members: {
                  Enabled: {
                    type: "boolean"
                  }
                }
              },
              InputSerialization: {
                shape: "Sez"
              },
              OutputSerialization: {
                shape: "Sfe"
              },
              ScanRange: {
                type: "structure",
                members: {
                  Start: {
                    type: "long"
                  },
                  End: {
                    type: "long"
                  }
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Payload: {
                type: "structure",
                members: {
                  Records: {
                    type: "structure",
                    members: {
                      Payload: {
                        eventpayload: true,
                        type: "blob"
                      }
                    },
                    event: true
                  },
                  Stats: {
                    type: "structure",
                    members: {
                      Details: {
                        eventpayload: true,
                        type: "structure",
                        members: {
                          BytesScanned: {
                            type: "long"
                          },
                          BytesProcessed: {
                            type: "long"
                          },
                          BytesReturned: {
                            type: "long"
                          }
                        }
                      }
                    },
                    event: true
                  },
                  Progress: {
                    type: "structure",
                    members: {
                      Details: {
                        eventpayload: true,
                        type: "structure",
                        members: {
                          BytesScanned: {
                            type: "long"
                          },
                          BytesProcessed: {
                            type: "long"
                          },
                          BytesReturned: {
                            type: "long"
                          }
                        }
                      }
                    },
                    event: true
                  },
                  Cont: {
                    type: "structure",
                    members: {},
                    event: true
                  },
                  End: {
                    type: "structure",
                    members: {},
                    event: true
                  }
                },
                eventstream: true
              }
            },
            payload: "Payload"
          }
        },
        UploadPart: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}/{Key+}"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key",
              "PartNumber",
              "UploadId"
            ],
            members: {
              Body: {
                streaming: true,
                type: "blob"
              },
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              ContentLength: {
                location: "header",
                locationName: "Content-Length",
                type: "long"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-sdk-checksum-algorithm"
              },
              ChecksumCRC32: {
                location: "header",
                locationName: "x-amz-checksum-crc32"
              },
              ChecksumCRC32C: {
                location: "header",
                locationName: "x-amz-checksum-crc32c"
              },
              ChecksumSHA1: {
                location: "header",
                locationName: "x-amz-checksum-sha1"
              },
              ChecksumSHA256: {
                location: "header",
                locationName: "x-amz-checksum-sha256"
              },
              Key: {
                contextParam: {
                  name: "Key"
                },
                location: "uri",
                locationName: "Key"
              },
              PartNumber: {
                location: "querystring",
                locationName: "partNumber",
                type: "integer"
              },
              UploadId: {
                location: "querystring",
                locationName: "uploadId"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKey: {
                shape: "Sk",
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "Body"
          },
          output: {
            type: "structure",
            members: {
              ServerSideEncryption: {
                location: "header",
                locationName: "x-amz-server-side-encryption"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              },
              ChecksumCRC32: {
                location: "header",
                locationName: "x-amz-checksum-crc32"
              },
              ChecksumCRC32C: {
                location: "header",
                locationName: "x-amz-checksum-crc32c"
              },
              ChecksumSHA1: {
                location: "header",
                locationName: "x-amz-checksum-sha1"
              },
              ChecksumSHA256: {
                location: "header",
                locationName: "x-amz-checksum-sha256"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              },
              SSEKMSKeyId: {
                shape: "Sr",
                location: "header",
                locationName: "x-amz-server-side-encryption-aws-kms-key-id"
              },
              BucketKeyEnabled: {
                location: "header",
                locationName: "x-amz-server-side-encryption-bucket-key-enabled",
                type: "boolean"
              },
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            }
          },
          httpChecksum: {
            requestAlgorithmMember: "ChecksumAlgorithm",
            requestChecksumRequired: false
          }
        },
        UploadPartCopy: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}/{Key+}"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "CopySource",
              "Key",
              "PartNumber",
              "UploadId"
            ],
            members: {
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "Bucket"
              },
              CopySource: {
                location: "header",
                locationName: "x-amz-copy-source"
              },
              CopySourceIfMatch: {
                location: "header",
                locationName: "x-amz-copy-source-if-match"
              },
              CopySourceIfModifiedSince: {
                location: "header",
                locationName: "x-amz-copy-source-if-modified-since",
                type: "timestamp"
              },
              CopySourceIfNoneMatch: {
                location: "header",
                locationName: "x-amz-copy-source-if-none-match"
              },
              CopySourceIfUnmodifiedSince: {
                location: "header",
                locationName: "x-amz-copy-source-if-unmodified-since",
                type: "timestamp"
              },
              CopySourceRange: {
                location: "header",
                locationName: "x-amz-copy-source-range"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              PartNumber: {
                location: "querystring",
                locationName: "partNumber",
                type: "integer"
              },
              UploadId: {
                location: "querystring",
                locationName: "uploadId"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKey: {
                shape: "Sk",
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              },
              CopySourceSSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-copy-source-server-side-encryption-customer-algorithm"
              },
              CopySourceSSECustomerKey: {
                shape: "S1k",
                location: "header",
                locationName: "x-amz-copy-source-server-side-encryption-customer-key"
              },
              CopySourceSSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-copy-source-server-side-encryption-customer-key-MD5"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              },
              ExpectedSourceBucketOwner: {
                location: "header",
                locationName: "x-amz-source-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CopySourceVersionId: {
                location: "header",
                locationName: "x-amz-copy-source-version-id"
              },
              CopyPartResult: {
                type: "structure",
                members: {
                  ETag: {},
                  LastModified: {
                    type: "timestamp"
                  },
                  ChecksumCRC32: {},
                  ChecksumCRC32C: {},
                  ChecksumSHA1: {},
                  ChecksumSHA256: {}
                }
              },
              ServerSideEncryption: {
                location: "header",
                locationName: "x-amz-server-side-encryption"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              },
              SSEKMSKeyId: {
                shape: "Sr",
                location: "header",
                locationName: "x-amz-server-side-encryption-aws-kms-key-id"
              },
              BucketKeyEnabled: {
                location: "header",
                locationName: "x-amz-server-side-encryption-bucket-key-enabled",
                type: "boolean"
              },
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            },
            payload: "CopyPartResult"
          },
          staticContextParams: {
            DisableS3ExpressSessionAuth: {
              value: true
            }
          }
        },
        WriteGetObjectResponse: {
          http: {
            requestUri: "/WriteGetObjectResponse"
          },
          input: {
            type: "structure",
            required: [
              "RequestRoute",
              "RequestToken"
            ],
            members: {
              RequestRoute: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-request-route"
              },
              RequestToken: {
                location: "header",
                locationName: "x-amz-request-token"
              },
              Body: {
                streaming: true,
                type: "blob"
              },
              StatusCode: {
                location: "header",
                locationName: "x-amz-fwd-status",
                type: "integer"
              },
              ErrorCode: {
                location: "header",
                locationName: "x-amz-fwd-error-code"
              },
              ErrorMessage: {
                location: "header",
                locationName: "x-amz-fwd-error-message"
              },
              AcceptRanges: {
                location: "header",
                locationName: "x-amz-fwd-header-accept-ranges"
              },
              CacheControl: {
                location: "header",
                locationName: "x-amz-fwd-header-Cache-Control"
              },
              ContentDisposition: {
                location: "header",
                locationName: "x-amz-fwd-header-Content-Disposition"
              },
              ContentEncoding: {
                location: "header",
                locationName: "x-amz-fwd-header-Content-Encoding"
              },
              ContentLanguage: {
                location: "header",
                locationName: "x-amz-fwd-header-Content-Language"
              },
              ContentLength: {
                location: "header",
                locationName: "Content-Length",
                type: "long"
              },
              ContentRange: {
                location: "header",
                locationName: "x-amz-fwd-header-Content-Range"
              },
              ContentType: {
                location: "header",
                locationName: "x-amz-fwd-header-Content-Type"
              },
              ChecksumCRC32: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-checksum-crc32"
              },
              ChecksumCRC32C: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-checksum-crc32c"
              },
              ChecksumSHA1: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-checksum-sha1"
              },
              ChecksumSHA256: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-checksum-sha256"
              },
              DeleteMarker: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-delete-marker",
                type: "boolean"
              },
              ETag: {
                location: "header",
                locationName: "x-amz-fwd-header-ETag"
              },
              Expires: {
                location: "header",
                locationName: "x-amz-fwd-header-Expires",
                type: "timestamp"
              },
              Expiration: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-expiration"
              },
              LastModified: {
                location: "header",
                locationName: "x-amz-fwd-header-Last-Modified",
                type: "timestamp"
              },
              MissingMeta: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-missing-meta",
                type: "integer"
              },
              Metadata: {
                shape: "S1b",
                location: "headers",
                locationName: "x-amz-meta-"
              },
              ObjectLockMode: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-object-lock-mode"
              },
              ObjectLockLegalHoldStatus: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-object-lock-legal-hold"
              },
              ObjectLockRetainUntilDate: {
                shape: "S1o",
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-object-lock-retain-until-date"
              },
              PartsCount: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-mp-parts-count",
                type: "integer"
              },
              ReplicationStatus: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-replication-status"
              },
              RequestCharged: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-request-charged"
              },
              Restore: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-restore"
              },
              ServerSideEncryption: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-server-side-encryption"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-server-side-encryption-customer-algorithm"
              },
              SSEKMSKeyId: {
                shape: "Sr",
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-server-side-encryption-aws-kms-key-id"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-server-side-encryption-customer-key-MD5"
              },
              StorageClass: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-storage-class"
              },
              TagCount: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-tagging-count",
                type: "integer"
              },
              VersionId: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-version-id"
              },
              BucketKeyEnabled: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-server-side-encryption-bucket-key-enabled",
                type: "boolean"
              }
            },
            payload: "Body"
          },
          authtype: "v4-unsigned-body",
          endpoint: {
            hostPrefix: "{RequestRoute}."
          },
          staticContextParams: {
            UseObjectLambdaEndpoint: {
              value: true
            }
          }
        }
      },
      shapes: {
        Sk: {
          type: "blob",
          sensitive: true
        },
        Sr: {
          type: "string",
          sensitive: true
        },
        S1b: {
          type: "map",
          key: {},
          value: {}
        },
        S1i: {
          type: "string",
          sensitive: true
        },
        S1k: {
          type: "blob",
          sensitive: true
        },
        S1o: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S2h: {
          type: "string",
          sensitive: true
        },
        S3q: {
          type: "structure",
          members: {
            DisplayName: {},
            ID: {}
          }
        },
        S3t: {
          type: "list",
          member: {
            locationName: "Grant",
            type: "structure",
            members: {
              Grantee: {
                shape: "S3v"
              },
              Permission: {}
            }
          }
        },
        S3v: {
          type: "structure",
          required: [
            "Type"
          ],
          members: {
            DisplayName: {},
            EmailAddress: {},
            ID: {},
            Type: {
              locationName: "xsi:type",
              xmlAttribute: true
            },
            URI: {}
          },
          xmlNamespace: {
            prefix: "xsi",
            uri: "http://www.w3.org/2001/XMLSchema-instance"
          }
        },
        S42: {
          type: "structure",
          required: [
            "Id",
            "StorageClassAnalysis"
          ],
          members: {
            Id: {},
            Filter: {
              type: "structure",
              members: {
                Prefix: {},
                Tag: {
                  shape: "S45"
                },
                And: {
                  type: "structure",
                  members: {
                    Prefix: {},
                    Tags: {
                      shape: "S48",
                      flattened: true,
                      locationName: "Tag"
                    }
                  }
                }
              }
            },
            StorageClassAnalysis: {
              type: "structure",
              members: {
                DataExport: {
                  type: "structure",
                  required: [
                    "OutputSchemaVersion",
                    "Destination"
                  ],
                  members: {
                    OutputSchemaVersion: {},
                    Destination: {
                      type: "structure",
                      required: [
                        "S3BucketDestination"
                      ],
                      members: {
                        S3BucketDestination: {
                          type: "structure",
                          required: [
                            "Format",
                            "Bucket"
                          ],
                          members: {
                            Format: {},
                            BucketAccountId: {},
                            Bucket: {},
                            Prefix: {}
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S45: {
          type: "structure",
          required: [
            "Key",
            "Value"
          ],
          members: {
            Key: {},
            Value: {}
          }
        },
        S48: {
          type: "list",
          member: {
            shape: "S45",
            locationName: "Tag"
          }
        },
        S4h: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AllowedMethods",
              "AllowedOrigins"
            ],
            members: {
              ID: {},
              AllowedHeaders: {
                locationName: "AllowedHeader",
                type: "list",
                member: {},
                flattened: true
              },
              AllowedMethods: {
                locationName: "AllowedMethod",
                type: "list",
                member: {},
                flattened: true
              },
              AllowedOrigins: {
                locationName: "AllowedOrigin",
                type: "list",
                member: {},
                flattened: true
              },
              ExposeHeaders: {
                locationName: "ExposeHeader",
                type: "list",
                member: {},
                flattened: true
              },
              MaxAgeSeconds: {
                type: "integer"
              }
            }
          },
          flattened: true
        },
        S4u: {
          type: "structure",
          required: [
            "Rules"
          ],
          members: {
            Rules: {
              locationName: "Rule",
              type: "list",
              member: {
                type: "structure",
                members: {
                  ApplyServerSideEncryptionByDefault: {
                    type: "structure",
                    required: [
                      "SSEAlgorithm"
                    ],
                    members: {
                      SSEAlgorithm: {},
                      KMSMasterKeyID: {
                        shape: "Sr"
                      }
                    }
                  },
                  BucketKeyEnabled: {
                    type: "boolean"
                  }
                }
              },
              flattened: true
            }
          }
        },
        S50: {
          type: "structure",
          required: [
            "Id",
            "Status",
            "Tierings"
          ],
          members: {
            Id: {},
            Filter: {
              type: "structure",
              members: {
                Prefix: {},
                Tag: {
                  shape: "S45"
                },
                And: {
                  type: "structure",
                  members: {
                    Prefix: {},
                    Tags: {
                      shape: "S48",
                      flattened: true,
                      locationName: "Tag"
                    }
                  }
                }
              }
            },
            Status: {},
            Tierings: {
              locationName: "Tiering",
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Days",
                  "AccessTier"
                ],
                members: {
                  Days: {
                    type: "integer"
                  },
                  AccessTier: {}
                }
              },
              flattened: true
            }
          }
        },
        S5a: {
          type: "structure",
          required: [
            "Destination",
            "IsEnabled",
            "Id",
            "IncludedObjectVersions",
            "Schedule"
          ],
          members: {
            Destination: {
              type: "structure",
              required: [
                "S3BucketDestination"
              ],
              members: {
                S3BucketDestination: {
                  type: "structure",
                  required: [
                    "Bucket",
                    "Format"
                  ],
                  members: {
                    AccountId: {},
                    Bucket: {},
                    Format: {},
                    Prefix: {},
                    Encryption: {
                      type: "structure",
                      members: {
                        SSES3: {
                          locationName: "SSE-S3",
                          type: "structure",
                          members: {}
                        },
                        SSEKMS: {
                          locationName: "SSE-KMS",
                          type: "structure",
                          required: [
                            "KeyId"
                          ],
                          members: {
                            KeyId: {
                              shape: "Sr"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            IsEnabled: {
              type: "boolean"
            },
            Filter: {
              type: "structure",
              required: [
                "Prefix"
              ],
              members: {
                Prefix: {}
              }
            },
            Id: {},
            IncludedObjectVersions: {},
            OptionalFields: {
              type: "list",
              member: {
                locationName: "Field"
              }
            },
            Schedule: {
              type: "structure",
              required: [
                "Frequency"
              ],
              members: {
                Frequency: {}
              }
            }
          }
        },
        S5q: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Prefix",
              "Status"
            ],
            members: {
              Expiration: {
                shape: "S5s"
              },
              ID: {},
              Prefix: {},
              Status: {},
              Transition: {
                shape: "S5x"
              },
              NoncurrentVersionTransition: {
                shape: "S5z"
              },
              NoncurrentVersionExpiration: {
                shape: "S61"
              },
              AbortIncompleteMultipartUpload: {
                shape: "S62"
              }
            }
          },
          flattened: true
        },
        S5s: {
          type: "structure",
          members: {
            Date: {
              shape: "S5t"
            },
            Days: {
              type: "integer"
            },
            ExpiredObjectDeleteMarker: {
              type: "boolean"
            }
          }
        },
        S5t: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S5x: {
          type: "structure",
          members: {
            Date: {
              shape: "S5t"
            },
            Days: {
              type: "integer"
            },
            StorageClass: {}
          }
        },
        S5z: {
          type: "structure",
          members: {
            NoncurrentDays: {
              type: "integer"
            },
            StorageClass: {},
            NewerNoncurrentVersions: {
              type: "integer"
            }
          }
        },
        S61: {
          type: "structure",
          members: {
            NoncurrentDays: {
              type: "integer"
            },
            NewerNoncurrentVersions: {
              type: "integer"
            }
          }
        },
        S62: {
          type: "structure",
          members: {
            DaysAfterInitiation: {
              type: "integer"
            }
          }
        },
        S66: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Status"
            ],
            members: {
              Expiration: {
                shape: "S5s"
              },
              ID: {},
              Prefix: {
                deprecated: true
              },
              Filter: {
                type: "structure",
                members: {
                  Prefix: {},
                  Tag: {
                    shape: "S45"
                  },
                  ObjectSizeGreaterThan: {
                    type: "long"
                  },
                  ObjectSizeLessThan: {
                    type: "long"
                  },
                  And: {
                    type: "structure",
                    members: {
                      Prefix: {},
                      Tags: {
                        shape: "S48",
                        flattened: true,
                        locationName: "Tag"
                      },
                      ObjectSizeGreaterThan: {
                        type: "long"
                      },
                      ObjectSizeLessThan: {
                        type: "long"
                      }
                    }
                  }
                }
              },
              Status: {},
              Transitions: {
                locationName: "Transition",
                type: "list",
                member: {
                  shape: "S5x"
                },
                flattened: true
              },
              NoncurrentVersionTransitions: {
                locationName: "NoncurrentVersionTransition",
                type: "list",
                member: {
                  shape: "S5z"
                },
                flattened: true
              },
              NoncurrentVersionExpiration: {
                shape: "S61"
              },
              AbortIncompleteMultipartUpload: {
                shape: "S62"
              }
            }
          },
          flattened: true
        },
        S6i: {
          type: "structure",
          required: [
            "TargetBucket",
            "TargetPrefix"
          ],
          members: {
            TargetBucket: {},
            TargetGrants: {
              type: "list",
              member: {
                locationName: "Grant",
                type: "structure",
                members: {
                  Grantee: {
                    shape: "S3v"
                  },
                  Permission: {}
                }
              }
            },
            TargetPrefix: {},
            TargetObjectKeyFormat: {
              type: "structure",
              members: {
                SimplePrefix: {
                  locationName: "SimplePrefix",
                  type: "structure",
                  members: {}
                },
                PartitionedPrefix: {
                  locationName: "PartitionedPrefix",
                  type: "structure",
                  members: {
                    PartitionDateSource: {}
                  }
                }
              }
            }
          }
        },
        S6u: {
          type: "structure",
          required: [
            "Id"
          ],
          members: {
            Id: {},
            Filter: {
              type: "structure",
              members: {
                Prefix: {},
                Tag: {
                  shape: "S45"
                },
                AccessPointArn: {},
                And: {
                  type: "structure",
                  members: {
                    Prefix: {},
                    Tags: {
                      shape: "S48",
                      flattened: true,
                      locationName: "Tag"
                    },
                    AccessPointArn: {}
                  }
                }
              }
            }
          }
        },
        S6y: {
          type: "structure",
          required: [
            "Bucket"
          ],
          members: {
            Bucket: {
              contextParam: {
                name: "Bucket"
              },
              location: "uri",
              locationName: "Bucket"
            },
            ExpectedBucketOwner: {
              location: "header",
              locationName: "x-amz-expected-bucket-owner"
            }
          }
        },
        S6z: {
          type: "structure",
          members: {
            TopicConfiguration: {
              type: "structure",
              members: {
                Id: {},
                Events: {
                  shape: "S72",
                  locationName: "Event"
                },
                Event: {
                  deprecated: true
                },
                Topic: {}
              }
            },
            QueueConfiguration: {
              type: "structure",
              members: {
                Id: {},
                Event: {
                  deprecated: true
                },
                Events: {
                  shape: "S72",
                  locationName: "Event"
                },
                Queue: {}
              }
            },
            CloudFunctionConfiguration: {
              type: "structure",
              members: {
                Id: {},
                Event: {
                  deprecated: true
                },
                Events: {
                  shape: "S72",
                  locationName: "Event"
                },
                CloudFunction: {},
                InvocationRole: {}
              }
            }
          }
        },
        S72: {
          type: "list",
          member: {},
          flattened: true
        },
        S7a: {
          type: "structure",
          members: {
            TopicConfigurations: {
              locationName: "TopicConfiguration",
              type: "list",
              member: {
                type: "structure",
                required: [
                  "TopicArn",
                  "Events"
                ],
                members: {
                  Id: {},
                  TopicArn: {
                    locationName: "Topic"
                  },
                  Events: {
                    shape: "S72",
                    locationName: "Event"
                  },
                  Filter: {
                    shape: "S7d"
                  }
                }
              },
              flattened: true
            },
            QueueConfigurations: {
              locationName: "QueueConfiguration",
              type: "list",
              member: {
                type: "structure",
                required: [
                  "QueueArn",
                  "Events"
                ],
                members: {
                  Id: {},
                  QueueArn: {
                    locationName: "Queue"
                  },
                  Events: {
                    shape: "S72",
                    locationName: "Event"
                  },
                  Filter: {
                    shape: "S7d"
                  }
                }
              },
              flattened: true
            },
            LambdaFunctionConfigurations: {
              locationName: "CloudFunctionConfiguration",
              type: "list",
              member: {
                type: "structure",
                required: [
                  "LambdaFunctionArn",
                  "Events"
                ],
                members: {
                  Id: {},
                  LambdaFunctionArn: {
                    locationName: "CloudFunction"
                  },
                  Events: {
                    shape: "S72",
                    locationName: "Event"
                  },
                  Filter: {
                    shape: "S7d"
                  }
                }
              },
              flattened: true
            },
            EventBridgeConfiguration: {
              type: "structure",
              members: {}
            }
          }
        },
        S7d: {
          type: "structure",
          members: {
            Key: {
              locationName: "S3Key",
              type: "structure",
              members: {
                FilterRules: {
                  locationName: "FilterRule",
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      Name: {},
                      Value: {}
                    }
                  },
                  flattened: true
                }
              }
            }
          }
        },
        S7r: {
          type: "structure",
          required: [
            "Rules"
          ],
          members: {
            Rules: {
              locationName: "Rule",
              type: "list",
              member: {
                type: "structure",
                required: [
                  "ObjectOwnership"
                ],
                members: {
                  ObjectOwnership: {}
                }
              },
              flattened: true
            }
          }
        },
        S83: {
          type: "structure",
          required: [
            "Role",
            "Rules"
          ],
          members: {
            Role: {},
            Rules: {
              locationName: "Rule",
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Status",
                  "Destination"
                ],
                members: {
                  ID: {},
                  Priority: {
                    type: "integer"
                  },
                  Prefix: {
                    deprecated: true
                  },
                  Filter: {
                    type: "structure",
                    members: {
                      Prefix: {},
                      Tag: {
                        shape: "S45"
                      },
                      And: {
                        type: "structure",
                        members: {
                          Prefix: {},
                          Tags: {
                            shape: "S48",
                            flattened: true,
                            locationName: "Tag"
                          }
                        }
                      }
                    }
                  },
                  Status: {},
                  SourceSelectionCriteria: {
                    type: "structure",
                    members: {
                      SseKmsEncryptedObjects: {
                        type: "structure",
                        required: [
                          "Status"
                        ],
                        members: {
                          Status: {}
                        }
                      },
                      ReplicaModifications: {
                        type: "structure",
                        required: [
                          "Status"
                        ],
                        members: {
                          Status: {}
                        }
                      }
                    }
                  },
                  ExistingObjectReplication: {
                    type: "structure",
                    required: [
                      "Status"
                    ],
                    members: {
                      Status: {}
                    }
                  },
                  Destination: {
                    type: "structure",
                    required: [
                      "Bucket"
                    ],
                    members: {
                      Bucket: {},
                      Account: {},
                      StorageClass: {},
                      AccessControlTranslation: {
                        type: "structure",
                        required: [
                          "Owner"
                        ],
                        members: {
                          Owner: {}
                        }
                      },
                      EncryptionConfiguration: {
                        type: "structure",
                        members: {
                          ReplicaKmsKeyID: {}
                        }
                      },
                      ReplicationTime: {
                        type: "structure",
                        required: [
                          "Status",
                          "Time"
                        ],
                        members: {
                          Status: {},
                          Time: {
                            shape: "S8p"
                          }
                        }
                      },
                      Metrics: {
                        type: "structure",
                        required: [
                          "Status"
                        ],
                        members: {
                          Status: {},
                          EventThreshold: {
                            shape: "S8p"
                          }
                        }
                      }
                    }
                  },
                  DeleteMarkerReplication: {
                    type: "structure",
                    members: {
                      Status: {}
                    }
                  }
                }
              },
              flattened: true
            }
          }
        },
        S8p: {
          type: "structure",
          members: {
            Minutes: {
              type: "integer"
            }
          }
        },
        S96: {
          type: "structure",
          required: [
            "HostName"
          ],
          members: {
            HostName: {},
            Protocol: {}
          }
        },
        S99: {
          type: "structure",
          required: [
            "Suffix"
          ],
          members: {
            Suffix: {}
          }
        },
        S9b: {
          type: "structure",
          required: [
            "Key"
          ],
          members: {
            Key: {}
          }
        },
        S9c: {
          type: "list",
          member: {
            locationName: "RoutingRule",
            type: "structure",
            required: [
              "Redirect"
            ],
            members: {
              Condition: {
                type: "structure",
                members: {
                  HttpErrorCodeReturnedEquals: {},
                  KeyPrefixEquals: {}
                }
              },
              Redirect: {
                type: "structure",
                members: {
                  HostName: {},
                  HttpRedirectCode: {},
                  Protocol: {},
                  ReplaceKeyPrefixWith: {},
                  ReplaceKeyWith: {}
                }
              }
            }
          }
        },
        Saq: {
          type: "structure",
          members: {
            Status: {}
          }
        },
        Sat: {
          type: "structure",
          members: {
            ObjectLockEnabled: {},
            Rule: {
              type: "structure",
              members: {
                DefaultRetention: {
                  type: "structure",
                  members: {
                    Mode: {},
                    Days: {
                      type: "integer"
                    },
                    Years: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        Sb1: {
          type: "structure",
          members: {
            Mode: {},
            RetainUntilDate: {
              shape: "S5t"
            }
          }
        },
        Sb8: {
          type: "structure",
          members: {
            BlockPublicAcls: {
              locationName: "BlockPublicAcls",
              type: "boolean"
            },
            IgnorePublicAcls: {
              locationName: "IgnorePublicAcls",
              type: "boolean"
            },
            BlockPublicPolicy: {
              locationName: "BlockPublicPolicy",
              type: "boolean"
            },
            RestrictPublicBuckets: {
              locationName: "RestrictPublicBuckets",
              type: "boolean"
            }
          }
        },
        Sbx: {
          type: "list",
          member: {
            locationName: "Bucket",
            type: "structure",
            members: {
              Name: {},
              CreationDate: {
                type: "timestamp"
              }
            }
          }
        },
        Scg: {
          type: "structure",
          members: {
            ID: {},
            DisplayName: {}
          }
        },
        Sch: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Prefix: {}
            }
          },
          flattened: true
        },
        Scm: {
          type: "list",
          member: {}
        },
        Scs: {
          type: "list",
          member: {},
          flattened: true
        },
        Scv: {
          type: "structure",
          members: {
            IsRestoreInProgress: {
              type: "boolean"
            },
            RestoreExpiryDate: {
              type: "timestamp"
            }
          }
        },
        Sd4: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              LastModified: {
                type: "timestamp"
              },
              ETag: {},
              ChecksumAlgorithm: {
                shape: "Scs"
              },
              Size: {
                type: "long"
              },
              StorageClass: {},
              Owner: {
                shape: "S3q"
              },
              RestoreStatus: {
                shape: "Scv"
              }
            }
          },
          flattened: true
        },
        Sdj: {
          type: "structure",
          members: {
            Grants: {
              shape: "S3t",
              locationName: "AccessControlList"
            },
            Owner: {
              shape: "S3q"
            }
          }
        },
        Se9: {
          type: "structure",
          required: [
            "TagSet"
          ],
          members: {
            TagSet: {
              shape: "S48"
            }
          }
        },
        Sez: {
          type: "structure",
          members: {
            CSV: {
              type: "structure",
              members: {
                FileHeaderInfo: {},
                Comments: {},
                QuoteEscapeCharacter: {},
                RecordDelimiter: {},
                FieldDelimiter: {},
                QuoteCharacter: {},
                AllowQuotedRecordDelimiter: {
                  type: "boolean"
                }
              }
            },
            CompressionType: {},
            JSON: {
              type: "structure",
              members: {
                Type: {}
              }
            },
            Parquet: {
              type: "structure",
              members: {}
            }
          }
        },
        Sfe: {
          type: "structure",
          members: {
            CSV: {
              type: "structure",
              members: {
                QuoteFields: {},
                QuoteEscapeCharacter: {},
                RecordDelimiter: {},
                FieldDelimiter: {},
                QuoteCharacter: {}
              }
            },
            JSON: {
              type: "structure",
              members: {
                RecordDelimiter: {}
              }
            }
          }
        }
      },
      clientContextParams: {
        Accelerate: {
          documentation: "Enables this client to use S3 Transfer Acceleration endpoints.",
          type: "boolean"
        },
        DisableMultiRegionAccessPoints: {
          documentation: "Disables this client's usage of Multi-Region Access Points.",
          type: "boolean"
        },
        DisableS3ExpressSessionAuth: {
          documentation: "Disables this client's usage of Session Auth for S3Express\n      buckets and reverts to using conventional SigV4 for those.",
          type: "boolean"
        },
        ForcePathStyle: {
          documentation: "Forces this client to use path-style addressing for buckets.",
          type: "boolean"
        },
        UseArnRegion: {
          documentation: "Enables this client to use an ARN's region when constructing an endpoint instead of the client's configured region.",
          type: "boolean"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/s3-2006-03-01.paginators.json
var require_s3_2006_03_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/s3-2006-03-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListBuckets: {
          result_key: "Buckets"
        },
        ListDirectoryBuckets: {
          input_token: "ContinuationToken",
          limit_key: "MaxDirectoryBuckets",
          output_token: "ContinuationToken",
          result_key: "Buckets"
        },
        ListMultipartUploads: {
          input_token: [
            "KeyMarker",
            "UploadIdMarker"
          ],
          limit_key: "MaxUploads",
          more_results: "IsTruncated",
          output_token: [
            "NextKeyMarker",
            "NextUploadIdMarker"
          ],
          result_key: [
            "Uploads",
            "CommonPrefixes"
          ]
        },
        ListObjectVersions: {
          input_token: [
            "KeyMarker",
            "VersionIdMarker"
          ],
          limit_key: "MaxKeys",
          more_results: "IsTruncated",
          output_token: [
            "NextKeyMarker",
            "NextVersionIdMarker"
          ],
          result_key: [
            "Versions",
            "DeleteMarkers",
            "CommonPrefixes"
          ]
        },
        ListObjects: {
          input_token: "Marker",
          limit_key: "MaxKeys",
          more_results: "IsTruncated",
          output_token: "NextMarker || Contents[-1].Key",
          result_key: [
            "Contents",
            "CommonPrefixes"
          ]
        },
        ListObjectsV2: {
          input_token: "ContinuationToken",
          limit_key: "MaxKeys",
          output_token: "NextContinuationToken",
          result_key: [
            "Contents",
            "CommonPrefixes"
          ]
        },
        ListParts: {
          input_token: "PartNumberMarker",
          limit_key: "MaxParts",
          more_results: "IsTruncated",
          output_token: "NextPartNumberMarker",
          result_key: "Parts"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/s3-2006-03-01.waiters2.json
var require_s3_2006_03_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/s3-2006-03-01.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        BucketExists: {
          delay: 5,
          operation: "HeadBucket",
          maxAttempts: 20,
          acceptors: [
            {
              expected: 200,
              matcher: "status",
              state: "success"
            },
            {
              expected: 301,
              matcher: "status",
              state: "success"
            },
            {
              expected: 403,
              matcher: "status",
              state: "success"
            },
            {
              expected: 404,
              matcher: "status",
              state: "retry"
            }
          ]
        },
        BucketNotExists: {
          delay: 5,
          operation: "HeadBucket",
          maxAttempts: 20,
          acceptors: [
            {
              expected: 404,
              matcher: "status",
              state: "success"
            }
          ]
        },
        ObjectExists: {
          delay: 5,
          operation: "HeadObject",
          maxAttempts: 20,
          acceptors: [
            {
              expected: 200,
              matcher: "status",
              state: "success"
            },
            {
              expected: 404,
              matcher: "status",
              state: "retry"
            }
          ]
        },
        ObjectNotExists: {
          delay: 5,
          operation: "HeadObject",
          maxAttempts: 20,
          acceptors: [
            {
              expected: 404,
              matcher: "status",
              state: "success"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/s3.js
var require_s33 = __commonJS({
  "node_modules/aws-sdk/clients/s3.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["s3"] = {};
    AWS2.S3 = Service.defineService("s3", ["2006-03-01"]);
    require_s32();
    Object.defineProperty(apiLoader.services["s3"], "2006-03-01", {
      get: function get() {
        var model = require_s3_2006_03_01_min();
        model.paginators = require_s3_2006_03_01_paginators().pagination;
        model.waiters = require_s3_2006_03_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.S3;
  }
});

// node_modules/aws-sdk/lib/services/s3control.js
var require_s3control = __commonJS({
  "node_modules/aws-sdk/lib/services/s3control.js"() {
    "use strict";
    var AWS2 = require_core();
    var s3util = require_s3util();
    var regionUtil = require_region_config();
    AWS2.util.update(AWS2.S3Control.prototype, {
      /**
       * @api private
       */
      setupRequestListeners: function setupRequestListeners(request) {
        request.addListener("extractError", this.extractHostId);
        request.addListener("extractData", this.extractHostId);
        request.addListener("validate", this.validateAccountId);
        var isArnInBucket = s3util.isArnInParam(request, "Bucket");
        var isArnInName = s3util.isArnInParam(request, "Name");
        if (isArnInBucket) {
          request._parsedArn = AWS2.util.ARN.parse(request.params["Bucket"]);
          request.addListener("validate", this.validateOutpostsBucketArn);
          request.addListener("validate", s3util.validateOutpostsArn);
          request.addListener("afterBuild", this.addOutpostIdHeader);
        } else if (isArnInName) {
          request._parsedArn = AWS2.util.ARN.parse(request.params["Name"]);
          request.addListener("validate", s3util.validateOutpostsAccessPointArn);
          request.addListener("validate", s3util.validateOutpostsArn);
          request.addListener("afterBuild", this.addOutpostIdHeader);
        }
        if (isArnInBucket || isArnInName) {
          request.addListener("validate", this.validateArnRegion);
          request.addListener("validate", this.validateArnAccountWithParams, true);
          request.addListener("validate", s3util.validateArnAccount);
          request.addListener("validate", s3util.validateArnService);
          request.addListener("build", this.populateParamFromArn, true);
          request.addListener("build", this.populateUriFromArn);
          request.addListener("build", s3util.validatePopulateUriFromArn);
        }
        if (request.params.OutpostId && (request.operation === "createBucket" || request.operation === "listRegionalBuckets")) {
          request.addListener("build", this.populateEndpointForOutpostId);
        }
      },
      /**
       * Adds outpostId header
       */
      addOutpostIdHeader: function addOutpostIdHeader(req) {
        req.httpRequest.headers["x-amz-outpost-id"] = req._parsedArn.outpostId;
      },
      /**
       * Validate Outposts ARN supplied in Bucket parameter is a valid bucket name
       */
      validateOutpostsBucketArn: function validateOutpostsBucketArn(req) {
        var parsedArn = req._parsedArn;
        var delimiter = parsedArn.resource["outpost".length];
        if (parsedArn.resource.split(delimiter).length !== 4) {
          throw AWS2.util.error(new Error(), {
            code: "InvalidARN",
            message: "Bucket ARN should have two resources outpost/{outpostId}/bucket/{accesspointName}"
          });
        }
        var bucket = parsedArn.resource.split(delimiter)[3];
        if (!s3util.dnsCompatibleBucketName(bucket) || bucket.match(/\./)) {
          throw AWS2.util.error(new Error(), {
            code: "InvalidARN",
            message: "Bucket ARN is not DNS compatible. Got " + bucket
          });
        }
        req._parsedArn.bucket = bucket;
      },
      /**
       * @api private
       */
      populateParamFromArn: function populateParamFromArn(req) {
        var parsedArn = req._parsedArn;
        if (s3util.isArnInParam(req, "Bucket")) {
          req.params.Bucket = parsedArn.bucket;
        } else if (s3util.isArnInParam(req, "Name")) {
          req.params.Name = parsedArn.accessPoint;
        }
      },
      /**
       * Populate URI according to the ARN
       */
      populateUriFromArn: function populateUriFromArn(req) {
        var parsedArn = req._parsedArn;
        var endpoint = req.httpRequest.endpoint;
        var useArnRegion = req.service.config.s3UseArnRegion;
        var useFipsEndpoint = req.service.config.useFipsEndpoint;
        endpoint.hostname = [
          "s3-outposts" + (useFipsEndpoint ? "-fips" : ""),
          useArnRegion ? parsedArn.region : req.service.config.region,
          "amazonaws.com"
        ].join(".");
        endpoint.host = endpoint.hostname;
      },
      /**
       * @api private
       */
      populateEndpointForOutpostId: function populateEndpointForOutpostId(req) {
        var endpoint = req.httpRequest.endpoint;
        var useFipsEndpoint = req.service.config.useFipsEndpoint;
        endpoint.hostname = [
          "s3-outposts" + (useFipsEndpoint ? "-fips" : ""),
          req.service.config.region,
          "amazonaws.com"
        ].join(".");
        endpoint.host = endpoint.hostname;
      },
      /**
       * @api private
       */
      extractHostId: function(response) {
        var hostId = response.httpResponse.headers ? response.httpResponse.headers["x-amz-id-2"] : null;
        response.extendedRequestId = hostId;
        if (response.error) {
          response.error.extendedRequestId = hostId;
        }
      },
      /**
       * @api private
       */
      validateArnRegion: function validateArnRegion(req) {
        s3util.validateArnRegion(req, { allowFipsEndpoint: true });
      },
      /**
       * @api private
       */
      validateArnAccountWithParams: function validateArnAccountWithParams(req) {
        var params = req.params;
        var inputModel = req.service.api.operations[req.operation].input;
        if (inputModel.members.AccountId) {
          var parsedArn = req._parsedArn;
          if (parsedArn.accountId) {
            if (params.AccountId) {
              if (params.AccountId !== parsedArn.accountId) {
                throw AWS2.util.error(
                  new Error(),
                  { code: "ValidationError", message: "AccountId in ARN and request params should be same." }
                );
              }
            } else {
              params.AccountId = parsedArn.accountId;
            }
          }
        }
      },
      /**
       * @api private
       */
      validateAccountId: function(request) {
        var params = request.params;
        if (!Object.prototype.hasOwnProperty.call(params, "AccountId"))
          return;
        var accountId = params.AccountId;
        if (typeof accountId !== "string") {
          throw AWS2.util.error(
            new Error(),
            { code: "ValidationError", message: "AccountId must be a string." }
          );
        }
        if (accountId.length < 1 || accountId.length > 63) {
          throw AWS2.util.error(
            new Error(),
            { code: "ValidationError", message: "AccountId length should be between 1 to 63 characters, inclusive." }
          );
        }
        var hostPattern = /^[a-zA-Z0-9]{1}$|^[a-zA-Z0-9][a-zA-Z0-9\-]*[a-zA-Z0-9]$/;
        if (!hostPattern.test(accountId)) {
          throw AWS2.util.error(
            new Error(),
            { code: "ValidationError", message: "AccountId should be hostname compatible. AccountId: " + accountId }
          );
        }
      },
      /**
       * @api private
       */
      getSigningName: function getSigningName(req) {
        var _super = AWS2.Service.prototype.getSigningName;
        if (req && req._parsedArn && req._parsedArn.service) {
          return req._parsedArn.service;
        } else if (req.params.OutpostId && (req.operation === "createBucket" || req.operation === "listRegionalBuckets")) {
          return "s3-outposts";
        } else {
          return _super.call(this, req);
        }
      }
    });
  }
});

// node_modules/aws-sdk/apis/s3control-2018-08-20.min.json
var require_s3control_2018_08_20_min = __commonJS({
  "node_modules/aws-sdk/apis/s3control-2018-08-20.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-08-20",
        endpointPrefix: "s3-control",
        protocol: "rest-xml",
        serviceFullName: "AWS S3 Control",
        serviceId: "S3 Control",
        signatureVersion: "s3v4",
        signingName: "s3",
        uid: "s3control-2018-08-20"
      },
      operations: {
        AssociateAccessGrantsIdentityCenter: {
          http: {
            requestUri: "/v20180820/accessgrantsinstance/identitycenter"
          },
          input: {
            locationName: "AssociateAccessGrantsIdentityCenterRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "AccountId",
              "IdentityCenterArn"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              IdentityCenterArn: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        CreateAccessGrant: {
          http: {
            requestUri: "/v20180820/accessgrantsinstance/grant"
          },
          input: {
            locationName: "CreateAccessGrantRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "AccountId",
              "AccessGrantsLocationId",
              "Grantee",
              "Permission"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              AccessGrantsLocationId: {},
              AccessGrantsLocationConfiguration: {
                shape: "S6"
              },
              Grantee: {
                shape: "S8"
              },
              Permission: {},
              ApplicationArn: {},
              S3PrefixType: {},
              Tags: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CreatedAt: {
                type: "timestamp"
              },
              AccessGrantId: {},
              AccessGrantArn: {},
              Grantee: {
                shape: "S8"
              },
              AccessGrantsLocationId: {},
              AccessGrantsLocationConfiguration: {
                shape: "S6"
              },
              Permission: {},
              ApplicationArn: {},
              GrantScope: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        CreateAccessGrantsInstance: {
          http: {
            requestUri: "/v20180820/accessgrantsinstance"
          },
          input: {
            locationName: "CreateAccessGrantsInstanceRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              IdentityCenterArn: {},
              Tags: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CreatedAt: {
                type: "timestamp"
              },
              AccessGrantsInstanceId: {},
              AccessGrantsInstanceArn: {},
              IdentityCenterArn: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        CreateAccessGrantsLocation: {
          http: {
            requestUri: "/v20180820/accessgrantsinstance/location"
          },
          input: {
            locationName: "CreateAccessGrantsLocationRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "AccountId",
              "LocationScope",
              "IAMRoleArn"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              LocationScope: {},
              IAMRoleArn: {},
              Tags: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CreatedAt: {
                type: "timestamp"
              },
              AccessGrantsLocationId: {},
              AccessGrantsLocationArn: {},
              LocationScope: {},
              IAMRoleArn: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        CreateAccessPoint: {
          http: {
            method: "PUT",
            requestUri: "/v20180820/accesspoint/{name}"
          },
          input: {
            locationName: "CreateAccessPointRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "AccountId",
              "Name",
              "Bucket"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              },
              Bucket: {
                contextParam: {
                  name: "Bucket"
                }
              },
              VpcConfiguration: {
                shape: "Sx"
              },
              PublicAccessBlockConfiguration: {
                shape: "Sz"
              },
              BucketAccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AccessPointArn: {},
              Alias: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        CreateAccessPointForObjectLambda: {
          http: {
            method: "PUT",
            requestUri: "/v20180820/accesspointforobjectlambda/{name}"
          },
          input: {
            locationName: "CreateAccessPointForObjectLambdaRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "AccountId",
              "Name",
              "Configuration"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              },
              Configuration: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ObjectLambdaAccessPointArn: {},
              Alias: {
                shape: "S1l"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        CreateBucket: {
          http: {
            method: "PUT",
            requestUri: "/v20180820/bucket/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              ACL: {
                location: "header",
                locationName: "x-amz-acl"
              },
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "name"
              },
              CreateBucketConfiguration: {
                locationName: "CreateBucketConfiguration",
                xmlNamespace: {
                  uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
                },
                type: "structure",
                members: {
                  LocationConstraint: {}
                }
              },
              GrantFullControl: {
                location: "header",
                locationName: "x-amz-grant-full-control"
              },
              GrantRead: {
                location: "header",
                locationName: "x-amz-grant-read"
              },
              GrantReadACP: {
                location: "header",
                locationName: "x-amz-grant-read-acp"
              },
              GrantWrite: {
                location: "header",
                locationName: "x-amz-grant-write"
              },
              GrantWriteACP: {
                location: "header",
                locationName: "x-amz-grant-write-acp"
              },
              ObjectLockEnabledForBucket: {
                location: "header",
                locationName: "x-amz-bucket-object-lock-enabled",
                type: "boolean"
              },
              OutpostId: {
                contextParam: {
                  name: "OutpostId"
                },
                location: "header",
                locationName: "x-amz-outpost-id"
              }
            },
            payload: "CreateBucketConfiguration"
          },
          output: {
            type: "structure",
            members: {
              Location: {
                location: "header",
                locationName: "Location"
              },
              BucketArn: {}
            }
          },
          httpChecksumRequired: true
        },
        CreateJob: {
          http: {
            requestUri: "/v20180820/jobs"
          },
          input: {
            locationName: "CreateJobRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "AccountId",
              "Operation",
              "Report",
              "ClientRequestToken",
              "Priority",
              "RoleArn"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              ConfirmationRequired: {
                type: "boolean"
              },
              Operation: {
                shape: "S24"
              },
              Report: {
                shape: "S3a"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              Manifest: {
                shape: "S3f"
              },
              Description: {},
              Priority: {
                type: "integer"
              },
              RoleArn: {},
              Tags: {
                shape: "S2n"
              },
              ManifestGenerator: {
                shape: "S3p"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        CreateMultiRegionAccessPoint: {
          http: {
            requestUri: "/v20180820/async-requests/mrap/create"
          },
          input: {
            locationName: "CreateMultiRegionAccessPointRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "AccountId",
              "ClientToken",
              "Details"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              ClientToken: {
                idempotencyToken: true
              },
              Details: {
                shape: "S4a"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestTokenARN: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        CreateStorageLensGroup: {
          http: {
            requestUri: "/v20180820/storagelensgroup",
            responseCode: 204
          },
          input: {
            locationName: "CreateStorageLensGroupRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "AccountId",
              "StorageLensGroup"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              StorageLensGroup: {
                shape: "S4h"
              },
              Tags: {
                shape: "Se"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        DeleteAccessGrant: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/accessgrantsinstance/grant/{id}"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "AccessGrantId"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              AccessGrantId: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        DeleteAccessGrantsInstance: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/accessgrantsinstance"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        DeleteAccessGrantsInstanceResourcePolicy: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/accessgrantsinstance/resourcepolicy"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        DeleteAccessGrantsLocation: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/accessgrantsinstance/location/{id}"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "AccessGrantsLocationId"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              AccessGrantsLocationId: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        DeleteAccessPoint: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/accesspoint/{name}"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Name"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                contextParam: {
                  name: "AccessPointName"
                },
                location: "uri",
                locationName: "name"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        DeleteAccessPointForObjectLambda: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/accesspointforobjectlambda/{name}"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Name"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        DeleteAccessPointPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/accesspoint/{name}/policy"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Name"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                contextParam: {
                  name: "AccessPointName"
                },
                location: "uri",
                locationName: "name"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        DeleteAccessPointPolicyForObjectLambda: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/accesspointforobjectlambda/{name}/policy"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Name"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        DeleteBucket: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/bucket/{name}"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Bucket"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "name"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        DeleteBucketLifecycleConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/bucket/{name}/lifecycleconfiguration"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Bucket"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "name"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        DeleteBucketPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/bucket/{name}/policy"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Bucket"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "name"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        DeleteBucketReplication: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/bucket/{name}/replication"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Bucket"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "name"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        DeleteBucketTagging: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/bucket/{name}/tagging",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Bucket"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "name"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        DeleteJobTagging: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/jobs/{id}/tagging"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "JobId"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              JobId: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        DeleteMultiRegionAccessPoint: {
          http: {
            requestUri: "/v20180820/async-requests/mrap/delete"
          },
          input: {
            locationName: "DeleteMultiRegionAccessPointRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "AccountId",
              "ClientToken",
              "Details"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              ClientToken: {
                idempotencyToken: true
              },
              Details: {
                shape: "S5c"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestTokenARN: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        DeletePublicAccessBlock: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/configuration/publicAccessBlock"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        DeleteStorageLensConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/storagelens/{storagelensid}"
          },
          input: {
            type: "structure",
            required: [
              "ConfigId",
              "AccountId"
            ],
            members: {
              ConfigId: {
                location: "uri",
                locationName: "storagelensid"
              },
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        DeleteStorageLensConfigurationTagging: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/storagelens/{storagelensid}/tagging"
          },
          input: {
            type: "structure",
            required: [
              "ConfigId",
              "AccountId"
            ],
            members: {
              ConfigId: {
                location: "uri",
                locationName: "storagelensid"
              },
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        DeleteStorageLensGroup: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/storagelensgroup/{name}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "AccountId"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        DescribeJob: {
          http: {
            method: "GET",
            requestUri: "/v20180820/jobs/{id}"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "JobId"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              JobId: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Job: {
                type: "structure",
                members: {
                  JobId: {},
                  ConfirmationRequired: {
                    type: "boolean"
                  },
                  Description: {},
                  JobArn: {},
                  Status: {},
                  Manifest: {
                    shape: "S3f"
                  },
                  Operation: {
                    shape: "S24"
                  },
                  Priority: {
                    type: "integer"
                  },
                  ProgressSummary: {
                    shape: "S5p"
                  },
                  StatusUpdateReason: {},
                  FailureReasons: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        FailureCode: {},
                        FailureReason: {}
                      }
                    }
                  },
                  Report: {
                    shape: "S3a"
                  },
                  CreationTime: {
                    type: "timestamp"
                  },
                  TerminationDate: {
                    type: "timestamp"
                  },
                  RoleArn: {},
                  SuspendedDate: {
                    type: "timestamp"
                  },
                  SuspendedCause: {},
                  ManifestGenerator: {
                    shape: "S3p"
                  },
                  GeneratedManifestDescriptor: {
                    type: "structure",
                    members: {
                      Format: {},
                      Location: {
                        shape: "S3k"
                      }
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        DescribeMultiRegionAccessPointOperation: {
          http: {
            method: "GET",
            requestUri: "/v20180820/async-requests/mrap/{request_token+}"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "RequestTokenARN"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              RequestTokenARN: {
                location: "uri",
                locationName: "request_token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AsyncOperation: {
                type: "structure",
                members: {
                  CreationTime: {
                    type: "timestamp"
                  },
                  Operation: {},
                  RequestTokenARN: {},
                  RequestParameters: {
                    type: "structure",
                    members: {
                      CreateMultiRegionAccessPointRequest: {
                        shape: "S4a"
                      },
                      DeleteMultiRegionAccessPointRequest: {
                        shape: "S5c"
                      },
                      PutMultiRegionAccessPointPolicyRequest: {
                        shape: "S6b"
                      }
                    }
                  },
                  RequestStatus: {},
                  ResponseDetails: {
                    type: "structure",
                    members: {
                      MultiRegionAccessPointDetails: {
                        type: "structure",
                        members: {
                          Regions: {
                            type: "list",
                            member: {
                              locationName: "Region",
                              type: "structure",
                              members: {
                                Name: {},
                                RequestStatus: {}
                              }
                            }
                          }
                        }
                      },
                      ErrorDetails: {
                        type: "structure",
                        members: {
                          Code: {},
                          Message: {},
                          Resource: {},
                          RequestId: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        DissociateAccessGrantsIdentityCenter: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/accessgrantsinstance/identitycenter"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        GetAccessGrant: {
          http: {
            method: "GET",
            requestUri: "/v20180820/accessgrantsinstance/grant/{id}"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "AccessGrantId"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              AccessGrantId: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CreatedAt: {
                type: "timestamp"
              },
              AccessGrantId: {},
              AccessGrantArn: {},
              Grantee: {
                shape: "S8"
              },
              Permission: {},
              AccessGrantsLocationId: {},
              AccessGrantsLocationConfiguration: {
                shape: "S6"
              },
              GrantScope: {},
              ApplicationArn: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        GetAccessGrantsInstance: {
          http: {
            method: "GET",
            requestUri: "/v20180820/accessgrantsinstance"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccessGrantsInstanceArn: {},
              AccessGrantsInstanceId: {},
              IdentityCenterArn: {},
              CreatedAt: {
                type: "timestamp"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        GetAccessGrantsInstanceForPrefix: {
          http: {
            method: "GET",
            requestUri: "/v20180820/accessgrantsinstance/prefix"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "S3Prefix"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              S3Prefix: {
                location: "querystring",
                locationName: "s3prefix"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccessGrantsInstanceArn: {},
              AccessGrantsInstanceId: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        GetAccessGrantsInstanceResourcePolicy: {
          http: {
            method: "GET",
            requestUri: "/v20180820/accessgrantsinstance/resourcepolicy"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {},
              Organization: {},
              CreatedAt: {
                type: "timestamp"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        GetAccessGrantsLocation: {
          http: {
            method: "GET",
            requestUri: "/v20180820/accessgrantsinstance/location/{id}"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "AccessGrantsLocationId"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              AccessGrantsLocationId: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CreatedAt: {
                type: "timestamp"
              },
              AccessGrantsLocationId: {},
              AccessGrantsLocationArn: {},
              LocationScope: {},
              IAMRoleArn: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        GetAccessPoint: {
          http: {
            method: "GET",
            requestUri: "/v20180820/accesspoint/{name}"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Name"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                contextParam: {
                  name: "AccessPointName"
                },
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Bucket: {},
              NetworkOrigin: {},
              VpcConfiguration: {
                shape: "Sx"
              },
              PublicAccessBlockConfiguration: {
                shape: "Sz"
              },
              CreationDate: {
                type: "timestamp"
              },
              Alias: {},
              AccessPointArn: {},
              Endpoints: {
                type: "map",
                key: {},
                value: {}
              },
              BucketAccountId: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        GetAccessPointConfigurationForObjectLambda: {
          http: {
            method: "GET",
            requestUri: "/v20180820/accesspointforobjectlambda/{name}/configuration"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Name"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Configuration: {
                shape: "S16"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        GetAccessPointForObjectLambda: {
          http: {
            method: "GET",
            requestUri: "/v20180820/accesspointforobjectlambda/{name}"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Name"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              PublicAccessBlockConfiguration: {
                shape: "Sz"
              },
              CreationDate: {
                type: "timestamp"
              },
              Alias: {
                shape: "S1l"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        GetAccessPointPolicy: {
          http: {
            method: "GET",
            requestUri: "/v20180820/accesspoint/{name}/policy"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Name"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                contextParam: {
                  name: "AccessPointName"
                },
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        GetAccessPointPolicyForObjectLambda: {
          http: {
            method: "GET",
            requestUri: "/v20180820/accesspointforobjectlambda/{name}/policy"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Name"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        GetAccessPointPolicyStatus: {
          http: {
            method: "GET",
            requestUri: "/v20180820/accesspoint/{name}/policyStatus"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Name"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                contextParam: {
                  name: "AccessPointName"
                },
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyStatus: {
                shape: "S7d"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        GetAccessPointPolicyStatusForObjectLambda: {
          http: {
            method: "GET",
            requestUri: "/v20180820/accesspointforobjectlambda/{name}/policyStatus"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Name"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyStatus: {
                shape: "S7d"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        GetBucket: {
          http: {
            method: "GET",
            requestUri: "/v20180820/bucket/{name}"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Bucket"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Bucket: {},
              PublicAccessBlockEnabled: {
                type: "boolean"
              },
              CreationDate: {
                type: "timestamp"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        GetBucketLifecycleConfiguration: {
          http: {
            method: "GET",
            requestUri: "/v20180820/bucket/{name}/lifecycleconfiguration"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Bucket"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Rules: {
                shape: "S7m"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        GetBucketPolicy: {
          http: {
            method: "GET",
            requestUri: "/v20180820/bucket/{name}/policy"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Bucket"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        GetBucketReplication: {
          http: {
            method: "GET",
            requestUri: "/v20180820/bucket/{name}/replication"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Bucket"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationConfiguration: {
                shape: "S89"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        GetBucketTagging: {
          http: {
            method: "GET",
            requestUri: "/v20180820/bucket/{name}/tagging"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Bucket"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TagSet"
            ],
            members: {
              TagSet: {
                shape: "S2n"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        GetBucketVersioning: {
          http: {
            method: "GET",
            requestUri: "/v20180820/bucket/{name}/versioning"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Bucket"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {},
              MFADelete: {
                locationName: "MfaDelete"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        GetDataAccess: {
          http: {
            method: "GET",
            requestUri: "/v20180820/accessgrantsinstance/dataaccess"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Target",
              "Permission"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Target: {
                location: "querystring",
                locationName: "target"
              },
              Permission: {
                location: "querystring",
                locationName: "permission"
              },
              DurationSeconds: {
                location: "querystring",
                locationName: "durationSeconds",
                type: "integer"
              },
              Privilege: {
                location: "querystring",
                locationName: "privilege"
              },
              TargetType: {
                location: "querystring",
                locationName: "targetType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Credentials: {
                type: "structure",
                members: {
                  AccessKeyId: {
                    type: "string",
                    sensitive: true
                  },
                  SecretAccessKey: {
                    type: "string",
                    sensitive: true
                  },
                  SessionToken: {
                    type: "string",
                    sensitive: true
                  },
                  Expiration: {
                    type: "timestamp"
                  }
                },
                sensitive: true
              },
              MatchedGrantTarget: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        GetJobTagging: {
          http: {
            method: "GET",
            requestUri: "/v20180820/jobs/{id}/tagging"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "JobId"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              JobId: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S2n"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        GetMultiRegionAccessPoint: {
          http: {
            method: "GET",
            requestUri: "/v20180820/mrap/instances/{name+}"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Name"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccessPoint: {
                shape: "S9m"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        GetMultiRegionAccessPointPolicy: {
          http: {
            method: "GET",
            requestUri: "/v20180820/mrap/instances/{name+}/policy"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Name"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {
                type: "structure",
                members: {
                  Established: {
                    type: "structure",
                    members: {
                      Policy: {}
                    }
                  },
                  Proposed: {
                    type: "structure",
                    members: {
                      Policy: {}
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        GetMultiRegionAccessPointPolicyStatus: {
          http: {
            method: "GET",
            requestUri: "/v20180820/mrap/instances/{name+}/policystatus"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Name"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Established: {
                shape: "S7d"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        GetMultiRegionAccessPointRoutes: {
          http: {
            method: "GET",
            requestUri: "/v20180820/mrap/instances/{mrap+}/routes"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Mrap"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Mrap: {
                location: "uri",
                locationName: "mrap"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Mrap: {},
              Routes: {
                shape: "Sa1"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        GetPublicAccessBlock: {
          http: {
            method: "GET",
            requestUri: "/v20180820/configuration/publicAccessBlock"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicAccessBlockConfiguration: {
                shape: "Sz"
              }
            },
            payload: "PublicAccessBlockConfiguration"
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        GetStorageLensConfiguration: {
          http: {
            method: "GET",
            requestUri: "/v20180820/storagelens/{storagelensid}"
          },
          input: {
            type: "structure",
            required: [
              "ConfigId",
              "AccountId"
            ],
            members: {
              ConfigId: {
                location: "uri",
                locationName: "storagelensid"
              },
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StorageLensConfiguration: {
                shape: "Sa8"
              }
            },
            payload: "StorageLensConfiguration"
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        GetStorageLensConfigurationTagging: {
          http: {
            method: "GET",
            requestUri: "/v20180820/storagelens/{storagelensid}/tagging"
          },
          input: {
            type: "structure",
            required: [
              "ConfigId",
              "AccountId"
            ],
            members: {
              ConfigId: {
                location: "uri",
                locationName: "storagelensid"
              },
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sb9"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        GetStorageLensGroup: {
          http: {
            method: "GET",
            requestUri: "/v20180820/storagelensgroup/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "AccountId"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StorageLensGroup: {
                shape: "S4h"
              }
            },
            payload: "StorageLensGroup"
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        ListAccessGrants: {
          http: {
            method: "GET",
            requestUri: "/v20180820/accessgrantsinstance/grants"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              GranteeType: {
                location: "querystring",
                locationName: "granteetype"
              },
              GranteeIdentifier: {
                location: "querystring",
                locationName: "granteeidentifier"
              },
              Permission: {
                location: "querystring",
                locationName: "permission"
              },
              GrantScope: {
                location: "querystring",
                locationName: "grantscope"
              },
              ApplicationArn: {
                location: "querystring",
                locationName: "application_arn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              AccessGrantsList: {
                type: "list",
                member: {
                  locationName: "AccessGrant",
                  type: "structure",
                  members: {
                    CreatedAt: {
                      type: "timestamp"
                    },
                    AccessGrantId: {},
                    AccessGrantArn: {},
                    Grantee: {
                      shape: "S8"
                    },
                    Permission: {},
                    AccessGrantsLocationId: {},
                    AccessGrantsLocationConfiguration: {
                      shape: "S6"
                    },
                    GrantScope: {},
                    ApplicationArn: {}
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        ListAccessGrantsInstances: {
          http: {
            method: "GET",
            requestUri: "/v20180820/accessgrantsinstances"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              AccessGrantsInstancesList: {
                type: "list",
                member: {
                  locationName: "AccessGrantsInstance",
                  type: "structure",
                  members: {
                    AccessGrantsInstanceId: {},
                    AccessGrantsInstanceArn: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    IdentityCenterArn: {}
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        ListAccessGrantsLocations: {
          http: {
            method: "GET",
            requestUri: "/v20180820/accessgrantsinstance/locations"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              LocationScope: {
                location: "querystring",
                locationName: "locationscope"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              AccessGrantsLocationsList: {
                type: "list",
                member: {
                  locationName: "AccessGrantsLocation",
                  type: "structure",
                  members: {
                    CreatedAt: {
                      type: "timestamp"
                    },
                    AccessGrantsLocationId: {},
                    AccessGrantsLocationArn: {},
                    LocationScope: {},
                    IAMRoleArn: {}
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        ListAccessPoints: {
          http: {
            method: "GET",
            requestUri: "/v20180820/accesspoint"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "querystring",
                locationName: "bucket"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccessPointList: {
                type: "list",
                member: {
                  locationName: "AccessPoint",
                  type: "structure",
                  required: [
                    "Name",
                    "NetworkOrigin",
                    "Bucket"
                  ],
                  members: {
                    Name: {},
                    NetworkOrigin: {},
                    VpcConfiguration: {
                      shape: "Sx"
                    },
                    Bucket: {},
                    AccessPointArn: {},
                    Alias: {},
                    BucketAccountId: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        ListAccessPointsForObjectLambda: {
          http: {
            method: "GET",
            requestUri: "/v20180820/accesspointforobjectlambda"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ObjectLambdaAccessPointList: {
                type: "list",
                member: {
                  locationName: "ObjectLambdaAccessPoint",
                  type: "structure",
                  required: [
                    "Name"
                  ],
                  members: {
                    Name: {},
                    ObjectLambdaAccessPointArn: {},
                    Alias: {
                      shape: "S1l"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        ListJobs: {
          http: {
            method: "GET",
            requestUri: "/v20180820/jobs"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              JobStatuses: {
                location: "querystring",
                locationName: "jobStatuses",
                type: "list",
                member: {}
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Jobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    JobId: {},
                    Description: {},
                    Operation: {},
                    Priority: {
                      type: "integer"
                    },
                    Status: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    TerminationDate: {
                      type: "timestamp"
                    },
                    ProgressSummary: {
                      shape: "S5p"
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        ListMultiRegionAccessPoints: {
          http: {
            method: "GET",
            requestUri: "/v20180820/mrap/instances"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccessPoints: {
                type: "list",
                member: {
                  shape: "S9m",
                  locationName: "AccessPoint"
                }
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        ListRegionalBuckets: {
          http: {
            method: "GET",
            requestUri: "/v20180820/bucket"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              OutpostId: {
                contextParam: {
                  name: "OutpostId"
                },
                location: "header",
                locationName: "x-amz-outpost-id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RegionalBucketList: {
                type: "list",
                member: {
                  locationName: "RegionalBucket",
                  type: "structure",
                  required: [
                    "Bucket",
                    "PublicAccessBlockEnabled",
                    "CreationDate"
                  ],
                  members: {
                    Bucket: {},
                    BucketArn: {},
                    PublicAccessBlockEnabled: {
                      type: "boolean"
                    },
                    CreationDate: {
                      type: "timestamp"
                    },
                    OutpostId: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        ListStorageLensConfigurations: {
          http: {
            method: "GET",
            requestUri: "/v20180820/storagelens"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              StorageLensConfigurationList: {
                type: "list",
                member: {
                  locationName: "StorageLensConfiguration",
                  type: "structure",
                  required: [
                    "Id",
                    "StorageLensArn",
                    "HomeRegion"
                  ],
                  members: {
                    Id: {},
                    StorageLensArn: {},
                    HomeRegion: {},
                    IsEnabled: {
                      type: "boolean"
                    }
                  }
                },
                flattened: true
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        ListStorageLensGroups: {
          http: {
            method: "GET",
            requestUri: "/v20180820/storagelensgroup"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              StorageLensGroupList: {
                type: "list",
                member: {
                  locationName: "StorageLensGroup",
                  type: "structure",
                  required: [
                    "Name",
                    "StorageLensGroupArn",
                    "HomeRegion"
                  ],
                  members: {
                    Name: {},
                    StorageLensGroupArn: {},
                    HomeRegion: {}
                  }
                },
                flattened: true
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/v20180820/tags/{resourceArn+}"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "ResourceArn"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Se"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        PutAccessGrantsInstanceResourcePolicy: {
          http: {
            method: "PUT",
            requestUri: "/v20180820/accessgrantsinstance/resourcepolicy"
          },
          input: {
            locationName: "PutAccessGrantsInstanceResourcePolicyRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "AccountId",
              "Policy"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Policy: {},
              Organization: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {},
              Organization: {},
              CreatedAt: {
                type: "timestamp"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        PutAccessPointConfigurationForObjectLambda: {
          http: {
            method: "PUT",
            requestUri: "/v20180820/accesspointforobjectlambda/{name}/configuration"
          },
          input: {
            locationName: "PutAccessPointConfigurationForObjectLambdaRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "AccountId",
              "Name",
              "Configuration"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              },
              Configuration: {
                shape: "S16"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        PutAccessPointPolicy: {
          http: {
            method: "PUT",
            requestUri: "/v20180820/accesspoint/{name}/policy"
          },
          input: {
            locationName: "PutAccessPointPolicyRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "AccountId",
              "Name",
              "Policy"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                contextParam: {
                  name: "AccessPointName"
                },
                location: "uri",
                locationName: "name"
              },
              Policy: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        PutAccessPointPolicyForObjectLambda: {
          http: {
            method: "PUT",
            requestUri: "/v20180820/accesspointforobjectlambda/{name}/policy"
          },
          input: {
            locationName: "PutAccessPointPolicyForObjectLambdaRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "AccountId",
              "Name",
              "Policy"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              },
              Policy: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        PutBucketLifecycleConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/v20180820/bucket/{name}/lifecycleconfiguration"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Bucket"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "name"
              },
              LifecycleConfiguration: {
                locationName: "LifecycleConfiguration",
                xmlNamespace: {
                  uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
                },
                type: "structure",
                members: {
                  Rules: {
                    shape: "S7m"
                  }
                }
              }
            },
            payload: "LifecycleConfiguration"
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        PutBucketPolicy: {
          http: {
            method: "PUT",
            requestUri: "/v20180820/bucket/{name}/policy"
          },
          input: {
            locationName: "PutBucketPolicyRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "AccountId",
              "Bucket",
              "Policy"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "name"
              },
              ConfirmRemoveSelfBucketAccess: {
                location: "header",
                locationName: "x-amz-confirm-remove-self-bucket-access",
                type: "boolean"
              },
              Policy: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        PutBucketReplication: {
          http: {
            method: "PUT",
            requestUri: "/v20180820/bucket/{name}/replication"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Bucket",
              "ReplicationConfiguration"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "name"
              },
              ReplicationConfiguration: {
                shape: "S89",
                locationName: "ReplicationConfiguration",
                xmlNamespace: {
                  uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
                }
              }
            },
            payload: "ReplicationConfiguration"
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        PutBucketTagging: {
          http: {
            method: "PUT",
            requestUri: "/v20180820/bucket/{name}/tagging"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Bucket",
              "Tagging"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "name"
              },
              Tagging: {
                locationName: "Tagging",
                xmlNamespace: {
                  uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
                },
                type: "structure",
                required: [
                  "TagSet"
                ],
                members: {
                  TagSet: {
                    shape: "S2n"
                  }
                }
              }
            },
            payload: "Tagging"
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        PutBucketVersioning: {
          http: {
            method: "PUT",
            requestUri: "/v20180820/bucket/{name}/versioning"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Bucket",
              "VersioningConfiguration"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Bucket: {
                contextParam: {
                  name: "Bucket"
                },
                location: "uri",
                locationName: "name"
              },
              MFA: {
                location: "header",
                locationName: "x-amz-mfa"
              },
              VersioningConfiguration: {
                locationName: "VersioningConfiguration",
                xmlNamespace: {
                  uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
                },
                type: "structure",
                members: {
                  MFADelete: {
                    locationName: "MfaDelete"
                  },
                  Status: {}
                }
              }
            },
            payload: "VersioningConfiguration"
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        PutJobTagging: {
          http: {
            method: "PUT",
            requestUri: "/v20180820/jobs/{id}/tagging"
          },
          input: {
            locationName: "PutJobTaggingRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "AccountId",
              "JobId",
              "Tags"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              JobId: {
                location: "uri",
                locationName: "id"
              },
              Tags: {
                shape: "S2n"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        PutMultiRegionAccessPointPolicy: {
          http: {
            requestUri: "/v20180820/async-requests/mrap/put-policy"
          },
          input: {
            locationName: "PutMultiRegionAccessPointPolicyRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "AccountId",
              "ClientToken",
              "Details"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              ClientToken: {
                idempotencyToken: true
              },
              Details: {
                shape: "S6b"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestTokenARN: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        PutPublicAccessBlock: {
          http: {
            method: "PUT",
            requestUri: "/v20180820/configuration/publicAccessBlock"
          },
          input: {
            type: "structure",
            required: [
              "PublicAccessBlockConfiguration",
              "AccountId"
            ],
            members: {
              PublicAccessBlockConfiguration: {
                shape: "Sz",
                locationName: "PublicAccessBlockConfiguration",
                xmlNamespace: {
                  uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
                }
              },
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              }
            },
            payload: "PublicAccessBlockConfiguration"
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        PutStorageLensConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/v20180820/storagelens/{storagelensid}"
          },
          input: {
            locationName: "PutStorageLensConfigurationRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "ConfigId",
              "AccountId",
              "StorageLensConfiguration"
            ],
            members: {
              ConfigId: {
                location: "uri",
                locationName: "storagelensid"
              },
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              StorageLensConfiguration: {
                shape: "Sa8"
              },
              Tags: {
                shape: "Sb9"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        PutStorageLensConfigurationTagging: {
          http: {
            method: "PUT",
            requestUri: "/v20180820/storagelens/{storagelensid}/tagging"
          },
          input: {
            locationName: "PutStorageLensConfigurationTaggingRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "ConfigId",
              "AccountId",
              "Tags"
            ],
            members: {
              ConfigId: {
                location: "uri",
                locationName: "storagelensid"
              },
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Tags: {
                shape: "Sb9"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        SubmitMultiRegionAccessPointRoutes: {
          http: {
            method: "PATCH",
            requestUri: "/v20180820/mrap/instances/{mrap+}/routes"
          },
          input: {
            locationName: "SubmitMultiRegionAccessPointRoutesRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "AccountId",
              "Mrap",
              "RouteUpdates"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Mrap: {
                location: "uri",
                locationName: "mrap"
              },
              RouteUpdates: {
                shape: "Sa1"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/v20180820/tags/{resourceArn+}",
            responseCode: 204
          },
          input: {
            locationName: "TagResourceRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "AccountId",
              "ResourceArn",
              "Tags"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              Tags: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/tags/{resourceArn+}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        UpdateAccessGrantsLocation: {
          http: {
            method: "PUT",
            requestUri: "/v20180820/accessgrantsinstance/location/{id}"
          },
          input: {
            locationName: "UpdateAccessGrantsLocationRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "AccountId",
              "AccessGrantsLocationId",
              "IAMRoleArn"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              AccessGrantsLocationId: {
                location: "uri",
                locationName: "id"
              },
              IAMRoleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CreatedAt: {
                type: "timestamp"
              },
              AccessGrantsLocationId: {},
              AccessGrantsLocationArn: {},
              LocationScope: {},
              IAMRoleArn: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true,
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        UpdateJobPriority: {
          http: {
            requestUri: "/v20180820/jobs/{id}/priority"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "JobId",
              "Priority"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              JobId: {
                location: "uri",
                locationName: "id"
              },
              Priority: {
                location: "querystring",
                locationName: "priority",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "JobId",
              "Priority"
            ],
            members: {
              JobId: {},
              Priority: {
                type: "integer"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        UpdateJobStatus: {
          http: {
            requestUri: "/v20180820/jobs/{id}/status"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "JobId",
              "RequestedJobStatus"
            ],
            members: {
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              JobId: {
                location: "uri",
                locationName: "id"
              },
              RequestedJobStatus: {
                location: "querystring",
                locationName: "requestedJobStatus"
              },
              StatusUpdateReason: {
                location: "querystring",
                locationName: "statusUpdateReason"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              Status: {},
              StatusUpdateReason: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        },
        UpdateStorageLensGroup: {
          http: {
            method: "PUT",
            requestUri: "/v20180820/storagelensgroup/{name}",
            responseCode: 204
          },
          input: {
            locationName: "UpdateStorageLensGroupRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "Name",
              "AccountId",
              "StorageLensGroup"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              AccountId: {
                contextParam: {
                  name: "AccountId"
                },
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              StorageLensGroup: {
                shape: "S4h"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          staticContextParams: {
            RequiresAccountId: {
              value: true
            }
          }
        }
      },
      shapes: {
        S6: {
          type: "structure",
          members: {
            S3SubPrefix: {}
          }
        },
        S8: {
          type: "structure",
          members: {
            GranteeType: {},
            GranteeIdentifier: {}
          }
        },
        Se: {
          type: "list",
          member: {
            locationName: "Tag",
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sx: {
          type: "structure",
          required: [
            "VpcId"
          ],
          members: {
            VpcId: {}
          }
        },
        Sz: {
          type: "structure",
          members: {
            BlockPublicAcls: {
              locationName: "BlockPublicAcls",
              type: "boolean"
            },
            IgnorePublicAcls: {
              locationName: "IgnorePublicAcls",
              type: "boolean"
            },
            BlockPublicPolicy: {
              locationName: "BlockPublicPolicy",
              type: "boolean"
            },
            RestrictPublicBuckets: {
              locationName: "RestrictPublicBuckets",
              type: "boolean"
            }
          }
        },
        S16: {
          type: "structure",
          required: [
            "SupportingAccessPoint",
            "TransformationConfigurations"
          ],
          members: {
            SupportingAccessPoint: {},
            CloudWatchMetricsEnabled: {
              type: "boolean"
            },
            AllowedFeatures: {
              type: "list",
              member: {
                locationName: "AllowedFeature"
              }
            },
            TransformationConfigurations: {
              type: "list",
              member: {
                locationName: "TransformationConfiguration",
                type: "structure",
                required: [
                  "Actions",
                  "ContentTransformation"
                ],
                members: {
                  Actions: {
                    type: "list",
                    member: {
                      locationName: "Action"
                    }
                  },
                  ContentTransformation: {
                    type: "structure",
                    members: {
                      AwsLambda: {
                        type: "structure",
                        required: [
                          "FunctionArn"
                        ],
                        members: {
                          FunctionArn: {},
                          FunctionPayload: {}
                        }
                      }
                    },
                    union: true
                  }
                }
              }
            }
          }
        },
        S1l: {
          type: "structure",
          members: {
            Value: {},
            Status: {}
          }
        },
        S24: {
          type: "structure",
          members: {
            LambdaInvoke: {
              type: "structure",
              members: {
                FunctionArn: {},
                InvocationSchemaVersion: {},
                UserArguments: {
                  type: "map",
                  key: {},
                  value: {}
                }
              }
            },
            S3PutObjectCopy: {
              type: "structure",
              members: {
                TargetResource: {},
                CannedAccessControlList: {},
                AccessControlGrants: {
                  shape: "S2b"
                },
                MetadataDirective: {},
                ModifiedSinceConstraint: {
                  type: "timestamp"
                },
                NewObjectMetadata: {
                  type: "structure",
                  members: {
                    CacheControl: {},
                    ContentDisposition: {},
                    ContentEncoding: {},
                    ContentLanguage: {},
                    UserMetadata: {
                      type: "map",
                      key: {},
                      value: {}
                    },
                    ContentLength: {
                      type: "long"
                    },
                    ContentMD5: {},
                    ContentType: {},
                    HttpExpiresDate: {
                      type: "timestamp"
                    },
                    RequesterCharged: {
                      type: "boolean"
                    },
                    SSEAlgorithm: {}
                  }
                },
                NewObjectTagging: {
                  shape: "S2n"
                },
                RedirectLocation: {},
                RequesterPays: {
                  type: "boolean"
                },
                StorageClass: {},
                UnModifiedSinceConstraint: {
                  type: "timestamp"
                },
                SSEAwsKmsKeyId: {},
                TargetKeyPrefix: {},
                ObjectLockLegalHoldStatus: {},
                ObjectLockMode: {},
                ObjectLockRetainUntilDate: {
                  type: "timestamp"
                },
                BucketKeyEnabled: {
                  type: "boolean"
                },
                ChecksumAlgorithm: {}
              }
            },
            S3PutObjectAcl: {
              type: "structure",
              members: {
                AccessControlPolicy: {
                  type: "structure",
                  members: {
                    AccessControlList: {
                      type: "structure",
                      required: [
                        "Owner"
                      ],
                      members: {
                        Owner: {
                          type: "structure",
                          members: {
                            ID: {},
                            DisplayName: {}
                          }
                        },
                        Grants: {
                          shape: "S2b"
                        }
                      }
                    },
                    CannedAccessControlList: {}
                  }
                }
              }
            },
            S3PutObjectTagging: {
              type: "structure",
              members: {
                TagSet: {
                  shape: "S2n"
                }
              }
            },
            S3DeleteObjectTagging: {
              type: "structure",
              members: {}
            },
            S3InitiateRestoreObject: {
              type: "structure",
              members: {
                ExpirationInDays: {
                  type: "integer"
                },
                GlacierJobTier: {}
              }
            },
            S3PutObjectLegalHold: {
              type: "structure",
              required: [
                "LegalHold"
              ],
              members: {
                LegalHold: {
                  type: "structure",
                  required: [
                    "Status"
                  ],
                  members: {
                    Status: {}
                  }
                }
              }
            },
            S3PutObjectRetention: {
              type: "structure",
              required: [
                "Retention"
              ],
              members: {
                BypassGovernanceRetention: {
                  type: "boolean"
                },
                Retention: {
                  type: "structure",
                  members: {
                    RetainUntilDate: {
                      type: "timestamp"
                    },
                    Mode: {}
                  }
                }
              }
            },
            S3ReplicateObject: {
              type: "structure",
              members: {}
            }
          }
        },
        S2b: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Grantee: {
                type: "structure",
                members: {
                  TypeIdentifier: {},
                  Identifier: {},
                  DisplayName: {}
                }
              },
              Permission: {}
            }
          }
        },
        S2n: {
          type: "list",
          member: {
            shape: "S2o"
          }
        },
        S2o: {
          type: "structure",
          required: [
            "Key",
            "Value"
          ],
          members: {
            Key: {},
            Value: {}
          }
        },
        S3a: {
          type: "structure",
          required: [
            "Enabled"
          ],
          members: {
            Bucket: {},
            Format: {},
            Enabled: {
              type: "boolean"
            },
            Prefix: {},
            ReportScope: {}
          }
        },
        S3f: {
          type: "structure",
          required: [
            "Spec",
            "Location"
          ],
          members: {
            Spec: {
              type: "structure",
              required: [
                "Format"
              ],
              members: {
                Format: {},
                Fields: {
                  type: "list",
                  member: {}
                }
              }
            },
            Location: {
              shape: "S3k"
            }
          }
        },
        S3k: {
          type: "structure",
          required: [
            "ObjectArn",
            "ETag"
          ],
          members: {
            ObjectArn: {},
            ObjectVersionId: {},
            ETag: {}
          }
        },
        S3p: {
          type: "structure",
          members: {
            S3JobManifestGenerator: {
              type: "structure",
              required: [
                "SourceBucket",
                "EnableManifestOutput"
              ],
              members: {
                ExpectedBucketOwner: {},
                SourceBucket: {},
                ManifestOutputLocation: {
                  type: "structure",
                  required: [
                    "Bucket",
                    "ManifestFormat"
                  ],
                  members: {
                    ExpectedManifestBucketOwner: {},
                    Bucket: {},
                    ManifestPrefix: {},
                    ManifestEncryption: {
                      type: "structure",
                      members: {
                        SSES3: {
                          locationName: "SSE-S3",
                          type: "structure",
                          members: {}
                        },
                        SSEKMS: {
                          locationName: "SSE-KMS",
                          type: "structure",
                          required: [
                            "KeyId"
                          ],
                          members: {
                            KeyId: {}
                          }
                        }
                      }
                    },
                    ManifestFormat: {}
                  }
                },
                Filter: {
                  type: "structure",
                  members: {
                    EligibleForReplication: {
                      type: "boolean"
                    },
                    CreatedAfter: {
                      type: "timestamp"
                    },
                    CreatedBefore: {
                      type: "timestamp"
                    },
                    ObjectReplicationStatuses: {
                      type: "list",
                      member: {}
                    },
                    KeyNameConstraint: {
                      type: "structure",
                      members: {
                        MatchAnyPrefix: {
                          shape: "S42"
                        },
                        MatchAnySuffix: {
                          shape: "S42"
                        },
                        MatchAnySubstring: {
                          shape: "S42"
                        }
                      }
                    },
                    ObjectSizeGreaterThanBytes: {
                      type: "long"
                    },
                    ObjectSizeLessThanBytes: {
                      type: "long"
                    },
                    MatchAnyStorageClass: {
                      type: "list",
                      member: {}
                    }
                  }
                },
                EnableManifestOutput: {
                  type: "boolean"
                }
              }
            }
          },
          union: true
        },
        S42: {
          type: "list",
          member: {}
        },
        S4a: {
          type: "structure",
          required: [
            "Name",
            "Regions"
          ],
          members: {
            Name: {},
            PublicAccessBlock: {
              shape: "Sz"
            },
            Regions: {
              type: "list",
              member: {
                locationName: "Region",
                type: "structure",
                required: [
                  "Bucket"
                ],
                members: {
                  Bucket: {},
                  BucketAccountId: {}
                }
              }
            }
          }
        },
        S4h: {
          type: "structure",
          required: [
            "Name",
            "Filter"
          ],
          members: {
            Name: {},
            Filter: {
              type: "structure",
              members: {
                MatchAnyPrefix: {
                  shape: "S4k"
                },
                MatchAnySuffix: {
                  shape: "S4m"
                },
                MatchAnyTag: {
                  shape: "S4o"
                },
                MatchObjectAge: {
                  shape: "S4p"
                },
                MatchObjectSize: {
                  shape: "S4r"
                },
                And: {
                  type: "structure",
                  members: {
                    MatchAnyPrefix: {
                      shape: "S4k"
                    },
                    MatchAnySuffix: {
                      shape: "S4m"
                    },
                    MatchAnyTag: {
                      shape: "S4o"
                    },
                    MatchObjectAge: {
                      shape: "S4p"
                    },
                    MatchObjectSize: {
                      shape: "S4r"
                    }
                  }
                },
                Or: {
                  type: "structure",
                  members: {
                    MatchAnyPrefix: {
                      shape: "S4k"
                    },
                    MatchAnySuffix: {
                      shape: "S4m"
                    },
                    MatchAnyTag: {
                      shape: "S4o"
                    },
                    MatchObjectAge: {
                      shape: "S4p"
                    },
                    MatchObjectSize: {
                      shape: "S4r"
                    }
                  }
                }
              }
            },
            StorageLensGroupArn: {}
          }
        },
        S4k: {
          type: "list",
          member: {
            locationName: "Prefix"
          }
        },
        S4m: {
          type: "list",
          member: {
            locationName: "Suffix"
          }
        },
        S4o: {
          type: "list",
          member: {
            shape: "S2o",
            locationName: "Tag"
          }
        },
        S4p: {
          type: "structure",
          members: {
            DaysGreaterThan: {
              type: "integer"
            },
            DaysLessThan: {
              type: "integer"
            }
          }
        },
        S4r: {
          type: "structure",
          members: {
            BytesGreaterThan: {
              type: "long"
            },
            BytesLessThan: {
              type: "long"
            }
          }
        },
        S5c: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {}
          }
        },
        S5p: {
          type: "structure",
          members: {
            TotalNumberOfTasks: {
              type: "long"
            },
            NumberOfTasksSucceeded: {
              type: "long"
            },
            NumberOfTasksFailed: {
              type: "long"
            },
            Timers: {
              type: "structure",
              members: {
                ElapsedTimeInActiveSeconds: {
                  type: "long"
                }
              }
            }
          }
        },
        S6b: {
          type: "structure",
          required: [
            "Name",
            "Policy"
          ],
          members: {
            Name: {},
            Policy: {}
          }
        },
        S7d: {
          type: "structure",
          members: {
            IsPublic: {
              locationName: "IsPublic",
              type: "boolean"
            }
          }
        },
        S7m: {
          type: "list",
          member: {
            locationName: "Rule",
            type: "structure",
            required: [
              "Status"
            ],
            members: {
              Expiration: {
                type: "structure",
                members: {
                  Date: {
                    type: "timestamp"
                  },
                  Days: {
                    type: "integer"
                  },
                  ExpiredObjectDeleteMarker: {
                    type: "boolean"
                  }
                }
              },
              ID: {},
              Filter: {
                type: "structure",
                members: {
                  Prefix: {},
                  Tag: {
                    shape: "S2o"
                  },
                  And: {
                    type: "structure",
                    members: {
                      Prefix: {},
                      Tags: {
                        shape: "S2n"
                      },
                      ObjectSizeGreaterThan: {
                        type: "long"
                      },
                      ObjectSizeLessThan: {
                        type: "long"
                      }
                    }
                  },
                  ObjectSizeGreaterThan: {
                    type: "long"
                  },
                  ObjectSizeLessThan: {
                    type: "long"
                  }
                }
              },
              Status: {},
              Transitions: {
                type: "list",
                member: {
                  locationName: "Transition",
                  type: "structure",
                  members: {
                    Date: {
                      type: "timestamp"
                    },
                    Days: {
                      type: "integer"
                    },
                    StorageClass: {}
                  }
                }
              },
              NoncurrentVersionTransitions: {
                type: "list",
                member: {
                  locationName: "NoncurrentVersionTransition",
                  type: "structure",
                  members: {
                    NoncurrentDays: {
                      type: "integer"
                    },
                    StorageClass: {}
                  }
                }
              },
              NoncurrentVersionExpiration: {
                type: "structure",
                members: {
                  NoncurrentDays: {
                    type: "integer"
                  },
                  NewerNoncurrentVersions: {
                    type: "integer"
                  }
                }
              },
              AbortIncompleteMultipartUpload: {
                type: "structure",
                members: {
                  DaysAfterInitiation: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        S89: {
          type: "structure",
          required: [
            "Role",
            "Rules"
          ],
          members: {
            Role: {},
            Rules: {
              type: "list",
              member: {
                locationName: "Rule",
                type: "structure",
                required: [
                  "Status",
                  "Destination",
                  "Bucket"
                ],
                members: {
                  ID: {},
                  Priority: {
                    type: "integer"
                  },
                  Prefix: {
                    deprecated: true,
                    deprecatedMessage: "Prefix has been deprecated"
                  },
                  Filter: {
                    type: "structure",
                    members: {
                      Prefix: {},
                      Tag: {
                        shape: "S2o"
                      },
                      And: {
                        type: "structure",
                        members: {
                          Prefix: {},
                          Tags: {
                            shape: "S2n"
                          }
                        }
                      }
                    }
                  },
                  Status: {},
                  SourceSelectionCriteria: {
                    type: "structure",
                    members: {
                      SseKmsEncryptedObjects: {
                        type: "structure",
                        required: [
                          "Status"
                        ],
                        members: {
                          Status: {}
                        }
                      },
                      ReplicaModifications: {
                        type: "structure",
                        required: [
                          "Status"
                        ],
                        members: {
                          Status: {}
                        }
                      }
                    }
                  },
                  ExistingObjectReplication: {
                    type: "structure",
                    required: [
                      "Status"
                    ],
                    members: {
                      Status: {}
                    }
                  },
                  Destination: {
                    type: "structure",
                    required: [
                      "Bucket"
                    ],
                    members: {
                      Account: {},
                      Bucket: {},
                      ReplicationTime: {
                        type: "structure",
                        required: [
                          "Status",
                          "Time"
                        ],
                        members: {
                          Status: {},
                          Time: {
                            shape: "S8s"
                          }
                        }
                      },
                      AccessControlTranslation: {
                        type: "structure",
                        required: [
                          "Owner"
                        ],
                        members: {
                          Owner: {}
                        }
                      },
                      EncryptionConfiguration: {
                        type: "structure",
                        members: {
                          ReplicaKmsKeyID: {}
                        }
                      },
                      Metrics: {
                        type: "structure",
                        required: [
                          "Status"
                        ],
                        members: {
                          Status: {},
                          EventThreshold: {
                            shape: "S8s"
                          }
                        }
                      },
                      StorageClass: {}
                    }
                  },
                  DeleteMarkerReplication: {
                    type: "structure",
                    required: [
                      "Status"
                    ],
                    members: {
                      Status: {}
                    }
                  },
                  Bucket: {}
                }
              }
            }
          }
        },
        S8s: {
          type: "structure",
          members: {
            Minutes: {
              type: "integer"
            }
          }
        },
        S9m: {
          type: "structure",
          members: {
            Name: {},
            Alias: {},
            CreatedAt: {
              type: "timestamp"
            },
            PublicAccessBlock: {
              shape: "Sz"
            },
            Status: {},
            Regions: {
              type: "list",
              member: {
                locationName: "Region",
                type: "structure",
                members: {
                  Bucket: {},
                  Region: {},
                  BucketAccountId: {}
                }
              }
            }
          }
        },
        Sa1: {
          type: "list",
          member: {
            locationName: "Route",
            type: "structure",
            required: [
              "TrafficDialPercentage"
            ],
            members: {
              Bucket: {},
              Region: {},
              TrafficDialPercentage: {
                type: "integer"
              }
            }
          }
        },
        Sa8: {
          type: "structure",
          required: [
            "Id",
            "AccountLevel",
            "IsEnabled"
          ],
          members: {
            Id: {},
            AccountLevel: {
              type: "structure",
              required: [
                "BucketLevel"
              ],
              members: {
                ActivityMetrics: {
                  shape: "Saa"
                },
                BucketLevel: {
                  type: "structure",
                  members: {
                    ActivityMetrics: {
                      shape: "Saa"
                    },
                    PrefixLevel: {
                      type: "structure",
                      required: [
                        "StorageMetrics"
                      ],
                      members: {
                        StorageMetrics: {
                          type: "structure",
                          members: {
                            IsEnabled: {
                              type: "boolean"
                            },
                            SelectionCriteria: {
                              type: "structure",
                              members: {
                                Delimiter: {},
                                MaxDepth: {
                                  type: "integer"
                                },
                                MinStorageBytesPercentage: {
                                  type: "double"
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    AdvancedCostOptimizationMetrics: {
                      shape: "Saj"
                    },
                    AdvancedDataProtectionMetrics: {
                      shape: "Sak"
                    },
                    DetailedStatusCodesMetrics: {
                      shape: "Sal"
                    }
                  }
                },
                AdvancedCostOptimizationMetrics: {
                  shape: "Saj"
                },
                AdvancedDataProtectionMetrics: {
                  shape: "Sak"
                },
                DetailedStatusCodesMetrics: {
                  shape: "Sal"
                },
                StorageLensGroupLevel: {
                  type: "structure",
                  members: {
                    SelectionCriteria: {
                      type: "structure",
                      members: {
                        Include: {
                          type: "list",
                          member: {
                            locationName: "Arn"
                          }
                        },
                        Exclude: {
                          type: "list",
                          member: {
                            locationName: "Arn"
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            Include: {
              type: "structure",
              members: {
                Buckets: {
                  shape: "Sar"
                },
                Regions: {
                  shape: "Sas"
                }
              }
            },
            Exclude: {
              type: "structure",
              members: {
                Buckets: {
                  shape: "Sar"
                },
                Regions: {
                  shape: "Sas"
                }
              }
            },
            DataExport: {
              type: "structure",
              members: {
                S3BucketDestination: {
                  type: "structure",
                  required: [
                    "Format",
                    "OutputSchemaVersion",
                    "AccountId",
                    "Arn"
                  ],
                  members: {
                    Format: {},
                    OutputSchemaVersion: {},
                    AccountId: {},
                    Arn: {},
                    Prefix: {},
                    Encryption: {
                      type: "structure",
                      members: {
                        SSES3: {
                          locationName: "SSE-S3",
                          type: "structure",
                          members: {}
                        },
                        SSEKMS: {
                          locationName: "SSE-KMS",
                          type: "structure",
                          required: [
                            "KeyId"
                          ],
                          members: {
                            KeyId: {}
                          }
                        }
                      }
                    }
                  }
                },
                CloudWatchMetrics: {
                  type: "structure",
                  required: [
                    "IsEnabled"
                  ],
                  members: {
                    IsEnabled: {
                      type: "boolean"
                    }
                  }
                }
              }
            },
            IsEnabled: {
              type: "boolean"
            },
            AwsOrg: {
              type: "structure",
              required: [
                "Arn"
              ],
              members: {
                Arn: {}
              }
            },
            StorageLensArn: {}
          }
        },
        Saa: {
          type: "structure",
          members: {
            IsEnabled: {
              type: "boolean"
            }
          }
        },
        Saj: {
          type: "structure",
          members: {
            IsEnabled: {
              type: "boolean"
            }
          }
        },
        Sak: {
          type: "structure",
          members: {
            IsEnabled: {
              type: "boolean"
            }
          }
        },
        Sal: {
          type: "structure",
          members: {
            IsEnabled: {
              type: "boolean"
            }
          }
        },
        Sar: {
          type: "list",
          member: {
            locationName: "Arn"
          }
        },
        Sas: {
          type: "list",
          member: {
            locationName: "Region"
          }
        },
        Sb9: {
          type: "list",
          member: {
            locationName: "Tag",
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        }
      },
      clientContextParams: {
        UseArnRegion: {
          documentation: "Enables this client to use an ARN's region when constructing an endpoint instead of the client's configured region.",
          type: "boolean"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/s3control-2018-08-20.paginators.json
var require_s3control_2018_08_20_paginators = __commonJS({
  "node_modules/aws-sdk/apis/s3control-2018-08-20.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAccessGrants: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAccessGrantsInstances: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAccessGrantsLocations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAccessPoints: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAccessPointsForObjectLambda: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ObjectLambdaAccessPointList"
        },
        ListJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMultiRegionAccessPoints: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListRegionalBuckets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListStorageLensConfigurations: {
          input_token: "NextToken",
          output_token: "NextToken"
        },
        ListStorageLensGroups: {
          input_token: "NextToken",
          output_token: "NextToken"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/s3control.js
var require_s3control2 = __commonJS({
  "node_modules/aws-sdk/clients/s3control.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["s3control"] = {};
    AWS2.S3Control = Service.defineService("s3control", ["2018-08-20"]);
    require_s3control();
    Object.defineProperty(apiLoader.services["s3control"], "2018-08-20", {
      get: function get() {
        var model = require_s3control_2018_08_20_min();
        model.paginators = require_s3control_2018_08_20_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.S3Control;
  }
});

// node_modules/aws-sdk/apis/servicecatalog-2015-12-10.min.json
var require_servicecatalog_2015_12_10_min = __commonJS({
  "node_modules/aws-sdk/apis/servicecatalog-2015-12-10.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-12-10",
        endpointPrefix: "servicecatalog",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Service Catalog",
        serviceId: "Service Catalog",
        signatureVersion: "v4",
        targetPrefix: "AWS242ServiceCatalogService",
        uid: "servicecatalog-2015-12-10"
      },
      operations: {
        AcceptPortfolioShare: {
          input: {
            type: "structure",
            required: [
              "PortfolioId"
            ],
            members: {
              AcceptLanguage: {},
              PortfolioId: {},
              PortfolioShareType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateBudgetWithResource: {
          input: {
            type: "structure",
            required: [
              "BudgetName",
              "ResourceId"
            ],
            members: {
              BudgetName: {},
              ResourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociatePrincipalWithPortfolio: {
          input: {
            type: "structure",
            required: [
              "PortfolioId",
              "PrincipalARN",
              "PrincipalType"
            ],
            members: {
              AcceptLanguage: {},
              PortfolioId: {},
              PrincipalARN: {},
              PrincipalType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateProductWithPortfolio: {
          input: {
            type: "structure",
            required: [
              "ProductId",
              "PortfolioId"
            ],
            members: {
              AcceptLanguage: {},
              ProductId: {},
              PortfolioId: {},
              SourcePortfolioId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateServiceActionWithProvisioningArtifact: {
          input: {
            type: "structure",
            required: [
              "ProductId",
              "ProvisioningArtifactId",
              "ServiceActionId"
            ],
            members: {
              ProductId: {},
              ProvisioningArtifactId: {},
              ServiceActionId: {},
              AcceptLanguage: {},
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateTagOptionWithResource: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "TagOptionId"
            ],
            members: {
              ResourceId: {},
              TagOptionId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        BatchAssociateServiceActionWithProvisioningArtifact: {
          input: {
            type: "structure",
            required: [
              "ServiceActionAssociations"
            ],
            members: {
              ServiceActionAssociations: {
                shape: "Sn"
              },
              AcceptLanguage: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FailedServiceActionAssociations: {
                shape: "Sq"
              }
            }
          }
        },
        BatchDisassociateServiceActionFromProvisioningArtifact: {
          input: {
            type: "structure",
            required: [
              "ServiceActionAssociations"
            ],
            members: {
              ServiceActionAssociations: {
                shape: "Sn"
              },
              AcceptLanguage: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FailedServiceActionAssociations: {
                shape: "Sq"
              }
            }
          }
        },
        CopyProduct: {
          input: {
            type: "structure",
            required: [
              "SourceProductArn",
              "IdempotencyToken"
            ],
            members: {
              AcceptLanguage: {},
              SourceProductArn: {},
              TargetProductId: {},
              TargetProductName: {},
              SourceProvisioningArtifactIdentifiers: {
                type: "list",
                member: {
                  type: "map",
                  key: {},
                  value: {}
                }
              },
              CopyOptions: {
                type: "list",
                member: {}
              },
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CopyProductToken: {}
            }
          }
        },
        CreateConstraint: {
          input: {
            type: "structure",
            required: [
              "PortfolioId",
              "ProductId",
              "Parameters",
              "Type",
              "IdempotencyToken"
            ],
            members: {
              AcceptLanguage: {},
              PortfolioId: {},
              ProductId: {},
              Parameters: {},
              Type: {},
              Description: {},
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConstraintDetail: {
                shape: "S1b"
              },
              ConstraintParameters: {},
              Status: {}
            }
          }
        },
        CreatePortfolio: {
          input: {
            type: "structure",
            required: [
              "DisplayName",
              "ProviderName",
              "IdempotencyToken"
            ],
            members: {
              AcceptLanguage: {},
              DisplayName: {},
              Description: {},
              ProviderName: {},
              Tags: {
                shape: "S1i"
              },
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PortfolioDetail: {
                shape: "S1n"
              },
              Tags: {
                shape: "S1q"
              }
            }
          }
        },
        CreatePortfolioShare: {
          input: {
            type: "structure",
            required: [
              "PortfolioId"
            ],
            members: {
              AcceptLanguage: {},
              PortfolioId: {},
              AccountId: {},
              OrganizationNode: {
                shape: "S1s"
              },
              ShareTagOptions: {
                type: "boolean"
              },
              SharePrincipals: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PortfolioShareToken: {}
            }
          }
        },
        CreateProduct: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Owner",
              "ProductType",
              "IdempotencyToken"
            ],
            members: {
              AcceptLanguage: {},
              Name: {},
              Owner: {},
              Description: {},
              Distributor: {},
              SupportDescription: {},
              SupportEmail: {},
              SupportUrl: {},
              ProductType: {},
              Tags: {
                shape: "S1i"
              },
              ProvisioningArtifactParameters: {
                shape: "S24"
              },
              IdempotencyToken: {
                idempotencyToken: true
              },
              SourceConnection: {
                shape: "S2c"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProductViewDetail: {
                shape: "S2l"
              },
              ProvisioningArtifactDetail: {
                shape: "S2w"
              },
              Tags: {
                shape: "S1q"
              }
            }
          }
        },
        CreateProvisionedProductPlan: {
          input: {
            type: "structure",
            required: [
              "PlanName",
              "PlanType",
              "ProductId",
              "ProvisionedProductName",
              "ProvisioningArtifactId",
              "IdempotencyToken"
            ],
            members: {
              AcceptLanguage: {},
              PlanName: {},
              PlanType: {},
              NotificationArns: {
                shape: "S33"
              },
              PathId: {},
              ProductId: {},
              ProvisionedProductName: {},
              ProvisioningArtifactId: {},
              ProvisioningParameters: {
                shape: "S36"
              },
              IdempotencyToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S1q"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PlanName: {},
              PlanId: {},
              ProvisionProductId: {},
              ProvisionedProductName: {},
              ProvisioningArtifactId: {}
            }
          }
        },
        CreateProvisioningArtifact: {
          input: {
            type: "structure",
            required: [
              "ProductId",
              "Parameters",
              "IdempotencyToken"
            ],
            members: {
              AcceptLanguage: {},
              ProductId: {},
              Parameters: {
                shape: "S24"
              },
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProvisioningArtifactDetail: {
                shape: "S2w"
              },
              Info: {
                shape: "S27"
              },
              Status: {}
            }
          }
        },
        CreateServiceAction: {
          input: {
            type: "structure",
            required: [
              "Name",
              "DefinitionType",
              "Definition",
              "IdempotencyToken"
            ],
            members: {
              Name: {},
              DefinitionType: {},
              Definition: {
                shape: "S3h"
              },
              Description: {},
              AcceptLanguage: {},
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceActionDetail: {
                shape: "S3m"
              }
            }
          }
        },
        CreateTagOption: {
          input: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TagOptionDetail: {
                shape: "S3s"
              }
            }
          }
        },
        DeleteConstraint: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              AcceptLanguage: {},
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeletePortfolio: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              AcceptLanguage: {},
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeletePortfolioShare: {
          input: {
            type: "structure",
            required: [
              "PortfolioId"
            ],
            members: {
              AcceptLanguage: {},
              PortfolioId: {},
              AccountId: {},
              OrganizationNode: {
                shape: "S1s"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PortfolioShareToken: {}
            }
          }
        },
        DeleteProduct: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              AcceptLanguage: {},
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteProvisionedProductPlan: {
          input: {
            type: "structure",
            required: [
              "PlanId"
            ],
            members: {
              AcceptLanguage: {},
              PlanId: {},
              IgnoreErrors: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteProvisioningArtifact: {
          input: {
            type: "structure",
            required: [
              "ProductId",
              "ProvisioningArtifactId"
            ],
            members: {
              AcceptLanguage: {},
              ProductId: {},
              ProvisioningArtifactId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteServiceAction: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {},
              AcceptLanguage: {},
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteTagOption: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeConstraint: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              AcceptLanguage: {},
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConstraintDetail: {
                shape: "S1b"
              },
              ConstraintParameters: {},
              Status: {}
            }
          }
        },
        DescribeCopyProductStatus: {
          input: {
            type: "structure",
            required: [
              "CopyProductToken"
            ],
            members: {
              AcceptLanguage: {},
              CopyProductToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CopyProductStatus: {},
              TargetProductId: {},
              StatusDetail: {}
            }
          }
        },
        DescribePortfolio: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              AcceptLanguage: {},
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PortfolioDetail: {
                shape: "S1n"
              },
              Tags: {
                shape: "S1q"
              },
              TagOptions: {
                shape: "S4k"
              },
              Budgets: {
                shape: "S4l"
              }
            }
          }
        },
        DescribePortfolioShareStatus: {
          input: {
            type: "structure",
            required: [
              "PortfolioShareToken"
            ],
            members: {
              PortfolioShareToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PortfolioShareToken: {},
              PortfolioId: {},
              OrganizationNodeValue: {},
              Status: {},
              ShareDetails: {
                type: "structure",
                members: {
                  SuccessfulShares: {
                    type: "list",
                    member: {}
                  },
                  ShareErrors: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Accounts: {
                          type: "list",
                          member: {}
                        },
                        Message: {},
                        Error: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribePortfolioShares: {
          input: {
            type: "structure",
            required: [
              "PortfolioId",
              "Type"
            ],
            members: {
              PortfolioId: {},
              Type: {},
              PageToken: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextPageToken: {},
              PortfolioShareDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PrincipalId: {},
                    Type: {},
                    Accepted: {
                      type: "boolean"
                    },
                    ShareTagOptions: {
                      type: "boolean"
                    },
                    SharePrincipals: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeProduct: {
          input: {
            type: "structure",
            members: {
              AcceptLanguage: {},
              Id: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProductViewSummary: {
                shape: "S2m"
              },
              ProvisioningArtifacts: {
                shape: "S56"
              },
              Budgets: {
                shape: "S4l"
              },
              LaunchPaths: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        DescribeProductAsAdmin: {
          input: {
            type: "structure",
            members: {
              AcceptLanguage: {},
              Id: {},
              Name: {},
              SourcePortfolioId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProductViewDetail: {
                shape: "S2l"
              },
              ProvisioningArtifactSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Name: {},
                    Description: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    ProvisioningArtifactMetadata: {
                      shape: "S27"
                    }
                  }
                }
              },
              Tags: {
                shape: "S1q"
              },
              TagOptions: {
                shape: "S4k"
              },
              Budgets: {
                shape: "S4l"
              }
            }
          }
        },
        DescribeProductView: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              AcceptLanguage: {},
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProductViewSummary: {
                shape: "S2m"
              },
              ProvisioningArtifacts: {
                shape: "S56"
              }
            }
          }
        },
        DescribeProvisionedProduct: {
          input: {
            type: "structure",
            members: {
              AcceptLanguage: {},
              Id: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProvisionedProductDetail: {
                shape: "S5k"
              },
              CloudWatchDashboards: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {}
                  }
                }
              }
            }
          }
        },
        DescribeProvisionedProductPlan: {
          input: {
            type: "structure",
            required: [
              "PlanId"
            ],
            members: {
              AcceptLanguage: {},
              PlanId: {},
              PageSize: {
                type: "integer"
              },
              PageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProvisionedProductPlanDetails: {
                type: "structure",
                members: {
                  CreatedTime: {
                    type: "timestamp"
                  },
                  PathId: {},
                  ProductId: {},
                  PlanName: {},
                  PlanId: {},
                  ProvisionProductId: {},
                  ProvisionProductName: {},
                  PlanType: {},
                  ProvisioningArtifactId: {},
                  Status: {},
                  UpdatedTime: {
                    type: "timestamp"
                  },
                  NotificationArns: {
                    shape: "S33"
                  },
                  ProvisioningParameters: {
                    shape: "S36"
                  },
                  Tags: {
                    shape: "S1q"
                  },
                  StatusMessage: {}
                }
              },
              ResourceChanges: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Action: {},
                    LogicalResourceId: {},
                    PhysicalResourceId: {},
                    ResourceType: {},
                    Replacement: {},
                    Scope: {
                      type: "list",
                      member: {}
                    },
                    Details: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Target: {
                            type: "structure",
                            members: {
                              Attribute: {},
                              Name: {},
                              RequiresRecreation: {}
                            }
                          },
                          Evaluation: {},
                          CausingEntity: {}
                        }
                      }
                    }
                  }
                }
              },
              NextPageToken: {}
            }
          }
        },
        DescribeProvisioningArtifact: {
          input: {
            type: "structure",
            members: {
              AcceptLanguage: {},
              ProvisioningArtifactId: {},
              ProductId: {},
              ProvisioningArtifactName: {},
              ProductName: {},
              Verbose: {
                type: "boolean"
              },
              IncludeProvisioningArtifactParameters: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProvisioningArtifactDetail: {
                shape: "S2w"
              },
              Info: {
                shape: "S27"
              },
              Status: {},
              ProvisioningArtifactParameters: {
                shape: "S6l"
              }
            }
          }
        },
        DescribeProvisioningParameters: {
          input: {
            type: "structure",
            members: {
              AcceptLanguage: {},
              ProductId: {},
              ProductName: {},
              ProvisioningArtifactId: {},
              ProvisioningArtifactName: {},
              PathId: {},
              PathName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProvisioningArtifactParameters: {
                shape: "S6l"
              },
              ConstraintSummaries: {
                shape: "S6w"
              },
              UsageInstructions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    Value: {}
                  }
                }
              },
              TagOptions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Key: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              ProvisioningArtifactPreferences: {
                type: "structure",
                members: {
                  StackSetAccounts: {
                    shape: "S76"
                  },
                  StackSetRegions: {
                    shape: "S77"
                  }
                }
              },
              ProvisioningArtifactOutputs: {
                shape: "S79",
                deprecated: true,
                deprecatedMessage: "This property is deprecated and returns the Id and Description of the Provisioning Artifact. Use ProvisioningArtifactOutputKeys instead to get the Keys and Descriptions of the outputs."
              },
              ProvisioningArtifactOutputKeys: {
                shape: "S79"
              }
            }
          }
        },
        DescribeRecord: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              AcceptLanguage: {},
              Id: {},
              PageToken: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RecordDetail: {
                shape: "S7f"
              },
              RecordOutputs: {
                shape: "S7q"
              },
              NextPageToken: {}
            }
          }
        },
        DescribeServiceAction: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {},
              AcceptLanguage: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceActionDetail: {
                shape: "S3m"
              }
            }
          }
        },
        DescribeServiceActionExecutionParameters: {
          input: {
            type: "structure",
            required: [
              "ProvisionedProductId",
              "ServiceActionId"
            ],
            members: {
              ProvisionedProductId: {},
              ServiceActionId: {},
              AcceptLanguage: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceActionParameters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Type: {},
                    DefaultValues: {
                      shape: "S82"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeTagOption: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TagOptionDetail: {
                shape: "S3s"
              }
            }
          }
        },
        DisableAWSOrganizationsAccess: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateBudgetFromResource: {
          input: {
            type: "structure",
            required: [
              "BudgetName",
              "ResourceId"
            ],
            members: {
              BudgetName: {},
              ResourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociatePrincipalFromPortfolio: {
          input: {
            type: "structure",
            required: [
              "PortfolioId",
              "PrincipalARN"
            ],
            members: {
              AcceptLanguage: {},
              PortfolioId: {},
              PrincipalARN: {},
              PrincipalType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateProductFromPortfolio: {
          input: {
            type: "structure",
            required: [
              "ProductId",
              "PortfolioId"
            ],
            members: {
              AcceptLanguage: {},
              ProductId: {},
              PortfolioId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateServiceActionFromProvisioningArtifact: {
          input: {
            type: "structure",
            required: [
              "ProductId",
              "ProvisioningArtifactId",
              "ServiceActionId"
            ],
            members: {
              ProductId: {},
              ProvisioningArtifactId: {},
              ServiceActionId: {},
              AcceptLanguage: {},
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateTagOptionFromResource: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "TagOptionId"
            ],
            members: {
              ResourceId: {},
              TagOptionId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        EnableAWSOrganizationsAccess: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ExecuteProvisionedProductPlan: {
          input: {
            type: "structure",
            required: [
              "PlanId",
              "IdempotencyToken"
            ],
            members: {
              AcceptLanguage: {},
              PlanId: {},
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RecordDetail: {
                shape: "S7f"
              }
            }
          }
        },
        ExecuteProvisionedProductServiceAction: {
          input: {
            type: "structure",
            required: [
              "ProvisionedProductId",
              "ServiceActionId",
              "ExecuteToken"
            ],
            members: {
              ProvisionedProductId: {},
              ServiceActionId: {},
              ExecuteToken: {
                idempotencyToken: true
              },
              AcceptLanguage: {},
              Parameters: {
                type: "map",
                key: {},
                value: {
                  shape: "S82"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RecordDetail: {
                shape: "S7f"
              }
            }
          }
        },
        GetAWSOrganizationsAccessStatus: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              AccessStatus: {}
            }
          }
        },
        GetProvisionedProductOutputs: {
          input: {
            type: "structure",
            members: {
              AcceptLanguage: {},
              ProvisionedProductId: {},
              ProvisionedProductName: {},
              OutputKeys: {
                type: "list",
                member: {}
              },
              PageSize: {
                type: "integer"
              },
              PageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Outputs: {
                shape: "S7q"
              },
              NextPageToken: {}
            }
          }
        },
        ImportAsProvisionedProduct: {
          input: {
            type: "structure",
            required: [
              "ProductId",
              "ProvisioningArtifactId",
              "ProvisionedProductName",
              "PhysicalId",
              "IdempotencyToken"
            ],
            members: {
              AcceptLanguage: {},
              ProductId: {},
              ProvisioningArtifactId: {},
              ProvisionedProductName: {},
              PhysicalId: {},
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RecordDetail: {
                shape: "S7f"
              }
            }
          }
        },
        ListAcceptedPortfolioShares: {
          input: {
            type: "structure",
            members: {
              AcceptLanguage: {},
              PageToken: {},
              PageSize: {
                type: "integer"
              },
              PortfolioShareType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PortfolioDetails: {
                shape: "S90"
              },
              NextPageToken: {}
            }
          }
        },
        ListBudgetsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              AcceptLanguage: {},
              ResourceId: {},
              PageSize: {
                type: "integer"
              },
              PageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Budgets: {
                shape: "S4l"
              },
              NextPageToken: {}
            }
          }
        },
        ListConstraintsForPortfolio: {
          input: {
            type: "structure",
            required: [
              "PortfolioId"
            ],
            members: {
              AcceptLanguage: {},
              PortfolioId: {},
              ProductId: {},
              PageSize: {
                type: "integer"
              },
              PageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConstraintDetails: {
                type: "list",
                member: {
                  shape: "S1b"
                }
              },
              NextPageToken: {}
            }
          }
        },
        ListLaunchPaths: {
          input: {
            type: "structure",
            required: [
              "ProductId"
            ],
            members: {
              AcceptLanguage: {},
              ProductId: {},
              PageSize: {
                type: "integer"
              },
              PageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LaunchPathSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    ConstraintSummaries: {
                      shape: "S6w"
                    },
                    Tags: {
                      shape: "S1q"
                    },
                    Name: {}
                  }
                }
              },
              NextPageToken: {}
            }
          }
        },
        ListOrganizationPortfolioAccess: {
          input: {
            type: "structure",
            required: [
              "PortfolioId",
              "OrganizationNodeType"
            ],
            members: {
              AcceptLanguage: {},
              PortfolioId: {},
              OrganizationNodeType: {},
              PageToken: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationNodes: {
                type: "list",
                member: {
                  shape: "S1s"
                }
              },
              NextPageToken: {}
            }
          }
        },
        ListPortfolioAccess: {
          input: {
            type: "structure",
            required: [
              "PortfolioId"
            ],
            members: {
              AcceptLanguage: {},
              PortfolioId: {},
              OrganizationParentId: {},
              PageToken: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccountIds: {
                type: "list",
                member: {}
              },
              NextPageToken: {}
            }
          }
        },
        ListPortfolios: {
          input: {
            type: "structure",
            members: {
              AcceptLanguage: {},
              PageToken: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PortfolioDetails: {
                shape: "S90"
              },
              NextPageToken: {}
            }
          }
        },
        ListPortfoliosForProduct: {
          input: {
            type: "structure",
            required: [
              "ProductId"
            ],
            members: {
              AcceptLanguage: {},
              ProductId: {},
              PageToken: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PortfolioDetails: {
                shape: "S90"
              },
              NextPageToken: {}
            }
          }
        },
        ListPrincipalsForPortfolio: {
          input: {
            type: "structure",
            required: [
              "PortfolioId"
            ],
            members: {
              AcceptLanguage: {},
              PortfolioId: {},
              PageSize: {
                type: "integer"
              },
              PageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Principals: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PrincipalARN: {},
                    PrincipalType: {}
                  }
                }
              },
              NextPageToken: {}
            }
          }
        },
        ListProvisionedProductPlans: {
          input: {
            type: "structure",
            members: {
              AcceptLanguage: {},
              ProvisionProductId: {},
              PageSize: {
                type: "integer"
              },
              PageToken: {},
              AccessLevelFilter: {
                shape: "S9p"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProvisionedProductPlans: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PlanName: {},
                    PlanId: {},
                    ProvisionProductId: {},
                    ProvisionProductName: {},
                    PlanType: {},
                    ProvisioningArtifactId: {}
                  }
                }
              },
              NextPageToken: {}
            }
          }
        },
        ListProvisioningArtifacts: {
          input: {
            type: "structure",
            required: [
              "ProductId"
            ],
            members: {
              AcceptLanguage: {},
              ProductId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProvisioningArtifactDetails: {
                type: "list",
                member: {
                  shape: "S2w"
                }
              },
              NextPageToken: {}
            }
          }
        },
        ListProvisioningArtifactsForServiceAction: {
          input: {
            type: "structure",
            required: [
              "ServiceActionId"
            ],
            members: {
              ServiceActionId: {},
              PageSize: {
                type: "integer"
              },
              PageToken: {},
              AcceptLanguage: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProvisioningArtifactViews: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ProductViewSummary: {
                      shape: "S2m"
                    },
                    ProvisioningArtifact: {
                      shape: "S57"
                    }
                  }
                }
              },
              NextPageToken: {}
            }
          }
        },
        ListRecordHistory: {
          input: {
            type: "structure",
            members: {
              AcceptLanguage: {},
              AccessLevelFilter: {
                shape: "S9p"
              },
              SearchFilter: {
                type: "structure",
                members: {
                  Key: {},
                  Value: {}
                }
              },
              PageSize: {
                type: "integer"
              },
              PageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RecordDetails: {
                type: "list",
                member: {
                  shape: "S7f"
                }
              },
              NextPageToken: {}
            }
          }
        },
        ListResourcesForTagOption: {
          input: {
            type: "structure",
            required: [
              "TagOptionId"
            ],
            members: {
              TagOptionId: {},
              ResourceType: {},
              PageSize: {
                type: "integer"
              },
              PageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    ARN: {},
                    Name: {},
                    Description: {},
                    CreatedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              PageToken: {}
            }
          }
        },
        ListServiceActions: {
          input: {
            type: "structure",
            members: {
              AcceptLanguage: {},
              PageSize: {
                type: "integer"
              },
              PageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceActionSummaries: {
                shape: "Sak"
              },
              NextPageToken: {}
            }
          }
        },
        ListServiceActionsForProvisioningArtifact: {
          input: {
            type: "structure",
            required: [
              "ProductId",
              "ProvisioningArtifactId"
            ],
            members: {
              ProductId: {},
              ProvisioningArtifactId: {},
              PageSize: {
                type: "integer"
              },
              PageToken: {},
              AcceptLanguage: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceActionSummaries: {
                shape: "Sak"
              },
              NextPageToken: {}
            }
          }
        },
        ListStackInstancesForProvisionedProduct: {
          input: {
            type: "structure",
            required: [
              "ProvisionedProductId"
            ],
            members: {
              AcceptLanguage: {},
              ProvisionedProductId: {},
              PageToken: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StackInstances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Account: {},
                    Region: {},
                    StackInstanceStatus: {}
                  }
                }
              },
              NextPageToken: {}
            }
          }
        },
        ListTagOptions: {
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "structure",
                members: {
                  Key: {},
                  Value: {},
                  Active: {
                    type: "boolean"
                  }
                }
              },
              PageSize: {
                type: "integer"
              },
              PageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TagOptionDetails: {
                shape: "S4k"
              },
              PageToken: {}
            }
          }
        },
        NotifyProvisionProductEngineWorkflowResult: {
          input: {
            type: "structure",
            required: [
              "WorkflowToken",
              "RecordId",
              "Status",
              "IdempotencyToken"
            ],
            members: {
              WorkflowToken: {},
              RecordId: {},
              Status: {},
              FailureReason: {},
              ResourceIdentifier: {
                type: "structure",
                members: {
                  UniqueTag: {
                    type: "structure",
                    members: {
                      Key: {},
                      Value: {}
                    }
                  }
                }
              },
              Outputs: {
                shape: "S7q"
              },
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        NotifyTerminateProvisionedProductEngineWorkflowResult: {
          input: {
            type: "structure",
            required: [
              "WorkflowToken",
              "RecordId",
              "Status",
              "IdempotencyToken"
            ],
            members: {
              WorkflowToken: {},
              RecordId: {},
              Status: {},
              FailureReason: {},
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        NotifyUpdateProvisionedProductEngineWorkflowResult: {
          input: {
            type: "structure",
            required: [
              "WorkflowToken",
              "RecordId",
              "Status",
              "IdempotencyToken"
            ],
            members: {
              WorkflowToken: {},
              RecordId: {},
              Status: {},
              FailureReason: {},
              Outputs: {
                shape: "S7q"
              },
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ProvisionProduct: {
          input: {
            type: "structure",
            required: [
              "ProvisionedProductName",
              "ProvisionToken"
            ],
            members: {
              AcceptLanguage: {},
              ProductId: {},
              ProductName: {},
              ProvisioningArtifactId: {},
              ProvisioningArtifactName: {},
              PathId: {},
              PathName: {},
              ProvisionedProductName: {},
              ProvisioningParameters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Key: {},
                    Value: {}
                  }
                }
              },
              ProvisioningPreferences: {
                type: "structure",
                members: {
                  StackSetAccounts: {
                    shape: "S76"
                  },
                  StackSetRegions: {
                    shape: "S77"
                  },
                  StackSetFailureToleranceCount: {
                    type: "integer"
                  },
                  StackSetFailureTolerancePercentage: {
                    type: "integer"
                  },
                  StackSetMaxConcurrencyCount: {
                    type: "integer"
                  },
                  StackSetMaxConcurrencyPercentage: {
                    type: "integer"
                  }
                }
              },
              Tags: {
                shape: "S1q"
              },
              NotificationArns: {
                shape: "S33"
              },
              ProvisionToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RecordDetail: {
                shape: "S7f"
              }
            }
          }
        },
        RejectPortfolioShare: {
          input: {
            type: "structure",
            required: [
              "PortfolioId"
            ],
            members: {
              AcceptLanguage: {},
              PortfolioId: {},
              PortfolioShareType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ScanProvisionedProducts: {
          input: {
            type: "structure",
            members: {
              AcceptLanguage: {},
              AccessLevelFilter: {
                shape: "S9p"
              },
              PageSize: {
                type: "integer"
              },
              PageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProvisionedProducts: {
                type: "list",
                member: {
                  shape: "S5k"
                }
              },
              NextPageToken: {}
            }
          }
        },
        SearchProducts: {
          input: {
            type: "structure",
            members: {
              AcceptLanguage: {},
              Filters: {
                shape: "Sbn"
              },
              PageSize: {
                type: "integer"
              },
              SortBy: {},
              SortOrder: {},
              PageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProductViewSummaries: {
                type: "list",
                member: {
                  shape: "S2m"
                }
              },
              ProductViewAggregations: {
                type: "map",
                key: {},
                value: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      Value: {},
                      ApproximateCount: {
                        type: "integer"
                      }
                    }
                  }
                }
              },
              NextPageToken: {}
            }
          }
        },
        SearchProductsAsAdmin: {
          input: {
            type: "structure",
            members: {
              AcceptLanguage: {},
              PortfolioId: {},
              Filters: {
                shape: "Sbn"
              },
              SortBy: {},
              SortOrder: {},
              PageToken: {},
              PageSize: {
                type: "integer"
              },
              ProductSource: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProductViewDetails: {
                type: "list",
                member: {
                  shape: "S2l"
                }
              },
              NextPageToken: {}
            }
          }
        },
        SearchProvisionedProducts: {
          input: {
            type: "structure",
            members: {
              AcceptLanguage: {},
              AccessLevelFilter: {
                shape: "S9p"
              },
              Filters: {
                type: "map",
                key: {},
                value: {
                  type: "list",
                  member: {}
                }
              },
              SortBy: {},
              SortOrder: {},
              PageSize: {
                type: "integer"
              },
              PageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProvisionedProducts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Arn: {},
                    Type: {},
                    Id: {},
                    Status: {},
                    StatusMessage: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    IdempotencyToken: {},
                    LastRecordId: {},
                    LastProvisioningRecordId: {},
                    LastSuccessfulProvisioningRecordId: {},
                    Tags: {
                      shape: "S1q"
                    },
                    PhysicalId: {},
                    ProductId: {},
                    ProductName: {},
                    ProvisioningArtifactId: {},
                    ProvisioningArtifactName: {},
                    UserArn: {},
                    UserArnSession: {}
                  }
                }
              },
              TotalResultsCount: {
                type: "integer"
              },
              NextPageToken: {}
            }
          }
        },
        TerminateProvisionedProduct: {
          input: {
            type: "structure",
            required: [
              "TerminateToken"
            ],
            members: {
              ProvisionedProductName: {},
              ProvisionedProductId: {},
              TerminateToken: {
                idempotencyToken: true
              },
              IgnoreErrors: {
                type: "boolean"
              },
              AcceptLanguage: {},
              RetainPhysicalResources: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RecordDetail: {
                shape: "S7f"
              }
            }
          }
        },
        UpdateConstraint: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              AcceptLanguage: {},
              Id: {},
              Description: {},
              Parameters: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConstraintDetail: {
                shape: "S1b"
              },
              ConstraintParameters: {},
              Status: {}
            }
          }
        },
        UpdatePortfolio: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              AcceptLanguage: {},
              Id: {},
              DisplayName: {},
              Description: {},
              ProviderName: {},
              AddTags: {
                shape: "S1i"
              },
              RemoveTags: {
                shape: "Sco"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PortfolioDetail: {
                shape: "S1n"
              },
              Tags: {
                shape: "S1q"
              }
            }
          }
        },
        UpdatePortfolioShare: {
          input: {
            type: "structure",
            required: [
              "PortfolioId"
            ],
            members: {
              AcceptLanguage: {},
              PortfolioId: {},
              AccountId: {},
              OrganizationNode: {
                shape: "S1s"
              },
              ShareTagOptions: {
                type: "boolean"
              },
              SharePrincipals: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PortfolioShareToken: {},
              Status: {}
            }
          }
        },
        UpdateProduct: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              AcceptLanguage: {},
              Id: {},
              Name: {},
              Owner: {},
              Description: {},
              Distributor: {},
              SupportDescription: {},
              SupportEmail: {},
              SupportUrl: {},
              AddTags: {
                shape: "S1i"
              },
              RemoveTags: {
                shape: "Sco"
              },
              SourceConnection: {
                shape: "S2c"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProductViewDetail: {
                shape: "S2l"
              },
              Tags: {
                shape: "S1q"
              }
            }
          }
        },
        UpdateProvisionedProduct: {
          input: {
            type: "structure",
            required: [
              "UpdateToken"
            ],
            members: {
              AcceptLanguage: {},
              ProvisionedProductName: {},
              ProvisionedProductId: {},
              ProductId: {},
              ProductName: {},
              ProvisioningArtifactId: {},
              ProvisioningArtifactName: {},
              PathId: {},
              PathName: {},
              ProvisioningParameters: {
                shape: "S36"
              },
              ProvisioningPreferences: {
                type: "structure",
                members: {
                  StackSetAccounts: {
                    shape: "S76"
                  },
                  StackSetRegions: {
                    shape: "S77"
                  },
                  StackSetFailureToleranceCount: {
                    type: "integer"
                  },
                  StackSetFailureTolerancePercentage: {
                    type: "integer"
                  },
                  StackSetMaxConcurrencyCount: {
                    type: "integer"
                  },
                  StackSetMaxConcurrencyPercentage: {
                    type: "integer"
                  },
                  StackSetOperationType: {}
                }
              },
              Tags: {
                shape: "S1q"
              },
              UpdateToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RecordDetail: {
                shape: "S7f"
              }
            }
          }
        },
        UpdateProvisionedProductProperties: {
          input: {
            type: "structure",
            required: [
              "ProvisionedProductId",
              "ProvisionedProductProperties",
              "IdempotencyToken"
            ],
            members: {
              AcceptLanguage: {},
              ProvisionedProductId: {},
              ProvisionedProductProperties: {
                shape: "Sd0"
              },
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProvisionedProductId: {},
              ProvisionedProductProperties: {
                shape: "Sd0"
              },
              RecordId: {},
              Status: {}
            }
          }
        },
        UpdateProvisioningArtifact: {
          input: {
            type: "structure",
            required: [
              "ProductId",
              "ProvisioningArtifactId"
            ],
            members: {
              AcceptLanguage: {},
              ProductId: {},
              ProvisioningArtifactId: {},
              Name: {},
              Description: {},
              Active: {
                type: "boolean"
              },
              Guidance: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProvisioningArtifactDetail: {
                shape: "S2w"
              },
              Info: {
                shape: "S27"
              },
              Status: {}
            }
          }
        },
        UpdateServiceAction: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {},
              Name: {},
              Definition: {
                shape: "S3h"
              },
              Description: {},
              AcceptLanguage: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceActionDetail: {
                shape: "S3m"
              }
            }
          }
        },
        UpdateTagOption: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {},
              Value: {},
              Active: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TagOptionDetail: {
                shape: "S3s"
              }
            }
          }
        }
      },
      shapes: {
        Sn: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ServiceActionId",
              "ProductId",
              "ProvisioningArtifactId"
            ],
            members: {
              ServiceActionId: {},
              ProductId: {},
              ProvisioningArtifactId: {}
            }
          }
        },
        Sq: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ServiceActionId: {},
              ProductId: {},
              ProvisioningArtifactId: {},
              ErrorCode: {},
              ErrorMessage: {}
            }
          }
        },
        S1b: {
          type: "structure",
          members: {
            ConstraintId: {},
            Type: {},
            Description: {},
            Owner: {},
            ProductId: {},
            PortfolioId: {}
          }
        },
        S1i: {
          type: "list",
          member: {
            shape: "S1j"
          }
        },
        S1j: {
          type: "structure",
          required: [
            "Key",
            "Value"
          ],
          members: {
            Key: {},
            Value: {}
          }
        },
        S1n: {
          type: "structure",
          members: {
            Id: {},
            ARN: {},
            DisplayName: {},
            Description: {},
            CreatedTime: {
              type: "timestamp"
            },
            ProviderName: {}
          }
        },
        S1q: {
          type: "list",
          member: {
            shape: "S1j"
          }
        },
        S1s: {
          type: "structure",
          members: {
            Type: {},
            Value: {}
          }
        },
        S24: {
          type: "structure",
          members: {
            Name: {},
            Description: {},
            Info: {
              shape: "S27"
            },
            Type: {},
            DisableTemplateValidation: {
              type: "boolean"
            }
          }
        },
        S27: {
          type: "map",
          key: {},
          value: {}
        },
        S2c: {
          type: "structure",
          required: [
            "ConnectionParameters"
          ],
          members: {
            Type: {},
            ConnectionParameters: {
              shape: "S2e"
            }
          }
        },
        S2e: {
          type: "structure",
          members: {
            CodeStar: {
              type: "structure",
              required: [
                "ConnectionArn",
                "Repository",
                "Branch",
                "ArtifactPath"
              ],
              members: {
                ConnectionArn: {},
                Repository: {},
                Branch: {},
                ArtifactPath: {}
              }
            }
          }
        },
        S2l: {
          type: "structure",
          members: {
            ProductViewSummary: {
              shape: "S2m"
            },
            Status: {},
            ProductARN: {},
            CreatedTime: {
              type: "timestamp"
            },
            SourceConnection: {
              type: "structure",
              members: {
                Type: {},
                ConnectionParameters: {
                  shape: "S2e"
                },
                LastSync: {
                  type: "structure",
                  members: {
                    LastSyncTime: {
                      type: "timestamp"
                    },
                    LastSyncStatus: {},
                    LastSyncStatusMessage: {},
                    LastSuccessfulSyncTime: {
                      type: "timestamp"
                    },
                    LastSuccessfulSyncProvisioningArtifactId: {}
                  }
                }
              }
            }
          }
        },
        S2m: {
          type: "structure",
          members: {
            Id: {},
            ProductId: {},
            Name: {},
            Owner: {},
            ShortDescription: {},
            Type: {},
            Distributor: {},
            HasDefaultPath: {
              type: "boolean"
            },
            SupportEmail: {},
            SupportDescription: {},
            SupportUrl: {}
          }
        },
        S2w: {
          type: "structure",
          members: {
            Id: {},
            Name: {},
            Description: {},
            Type: {},
            CreatedTime: {
              type: "timestamp"
            },
            Active: {
              type: "boolean"
            },
            Guidance: {},
            SourceRevision: {}
          }
        },
        S33: {
          type: "list",
          member: {}
        },
        S36: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {},
              UsePreviousValue: {
                type: "boolean"
              }
            }
          }
        },
        S3h: {
          type: "map",
          key: {},
          value: {}
        },
        S3m: {
          type: "structure",
          members: {
            ServiceActionSummary: {
              shape: "S3n"
            },
            Definition: {
              shape: "S3h"
            }
          }
        },
        S3n: {
          type: "structure",
          members: {
            Id: {},
            Name: {},
            Description: {},
            DefinitionType: {}
          }
        },
        S3s: {
          type: "structure",
          members: {
            Key: {},
            Value: {},
            Active: {
              type: "boolean"
            },
            Id: {},
            Owner: {}
          }
        },
        S4k: {
          type: "list",
          member: {
            shape: "S3s"
          }
        },
        S4l: {
          type: "list",
          member: {
            type: "structure",
            members: {
              BudgetName: {}
            }
          }
        },
        S56: {
          type: "list",
          member: {
            shape: "S57"
          }
        },
        S57: {
          type: "structure",
          members: {
            Id: {},
            Name: {},
            Description: {},
            CreatedTime: {
              type: "timestamp"
            },
            Guidance: {}
          }
        },
        S5k: {
          type: "structure",
          members: {
            Name: {},
            Arn: {},
            Type: {},
            Id: {},
            Status: {},
            StatusMessage: {},
            CreatedTime: {
              type: "timestamp"
            },
            IdempotencyToken: {},
            LastRecordId: {},
            LastProvisioningRecordId: {},
            LastSuccessfulProvisioningRecordId: {},
            ProductId: {},
            ProvisioningArtifactId: {},
            LaunchRoleArn: {}
          }
        },
        S6l: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ParameterKey: {},
              DefaultValue: {},
              ParameterType: {},
              IsNoEcho: {
                type: "boolean"
              },
              Description: {},
              ParameterConstraints: {
                type: "structure",
                members: {
                  AllowedValues: {
                    type: "list",
                    member: {}
                  },
                  AllowedPattern: {},
                  ConstraintDescription: {},
                  MaxLength: {},
                  MinLength: {},
                  MaxValue: {},
                  MinValue: {}
                }
              }
            }
          }
        },
        S6w: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Type: {},
              Description: {}
            }
          }
        },
        S76: {
          type: "list",
          member: {}
        },
        S77: {
          type: "list",
          member: {}
        },
        S79: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Description: {}
            }
          }
        },
        S7f: {
          type: "structure",
          members: {
            RecordId: {},
            ProvisionedProductName: {},
            Status: {},
            CreatedTime: {
              type: "timestamp"
            },
            UpdatedTime: {
              type: "timestamp"
            },
            ProvisionedProductType: {},
            RecordType: {},
            ProvisionedProductId: {},
            ProductId: {},
            ProvisioningArtifactId: {},
            PathId: {},
            RecordErrors: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Code: {},
                  Description: {}
                }
              }
            },
            RecordTags: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Key: {},
                  Value: {}
                }
              }
            },
            LaunchRoleArn: {}
          }
        },
        S7q: {
          type: "list",
          member: {
            type: "structure",
            members: {
              OutputKey: {},
              OutputValue: {},
              Description: {}
            }
          }
        },
        S82: {
          type: "list",
          member: {}
        },
        S90: {
          type: "list",
          member: {
            shape: "S1n"
          }
        },
        S9p: {
          type: "structure",
          members: {
            Key: {},
            Value: {}
          }
        },
        Sak: {
          type: "list",
          member: {
            shape: "S3n"
          }
        },
        Sbn: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {}
          }
        },
        Sco: {
          type: "list",
          member: {}
        },
        Sd0: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/servicecatalog-2015-12-10.paginators.json
var require_servicecatalog_2015_12_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/servicecatalog-2015-12-10.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribePortfolioShares: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        GetProvisionedProductOutputs: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        ListAcceptedPortfolioShares: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        ListBudgetsForResource: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        ListConstraintsForPortfolio: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        ListLaunchPaths: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        ListOrganizationPortfolioAccess: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        ListPortfolioAccess: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        ListPortfolios: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        ListPortfoliosForProduct: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        ListPrincipalsForPortfolio: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        ListProvisioningArtifactsForServiceAction: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        ListResourcesForTagOption: {
          input_token: "PageToken",
          output_token: "PageToken",
          limit_key: "PageSize"
        },
        ListServiceActions: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        ListServiceActionsForProvisioningArtifact: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        ListTagOptions: {
          input_token: "PageToken",
          output_token: "PageToken",
          limit_key: "PageSize"
        },
        SearchProducts: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        SearchProductsAsAdmin: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        SearchProvisionedProducts: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/servicecatalog.js
var require_servicecatalog = __commonJS({
  "node_modules/aws-sdk/clients/servicecatalog.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["servicecatalog"] = {};
    AWS2.ServiceCatalog = Service.defineService("servicecatalog", ["2015-12-10"]);
    Object.defineProperty(apiLoader.services["servicecatalog"], "2015-12-10", {
      get: function get() {
        var model = require_servicecatalog_2015_12_10_min();
        model.paginators = require_servicecatalog_2015_12_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ServiceCatalog;
  }
});

// node_modules/aws-sdk/apis/email-2010-12-01.min.json
var require_email_2010_12_01_min = __commonJS({
  "node_modules/aws-sdk/apis/email-2010-12-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2010-12-01",
        endpointPrefix: "email",
        protocol: "query",
        serviceAbbreviation: "Amazon SES",
        serviceFullName: "Amazon Simple Email Service",
        serviceId: "SES",
        signatureVersion: "v4",
        signingName: "ses",
        uid: "email-2010-12-01",
        xmlNamespace: "http://ses.amazonaws.com/doc/2010-12-01/"
      },
      operations: {
        CloneReceiptRuleSet: {
          input: {
            type: "structure",
            required: [
              "RuleSetName",
              "OriginalRuleSetName"
            ],
            members: {
              RuleSetName: {},
              OriginalRuleSetName: {}
            }
          },
          output: {
            resultWrapper: "CloneReceiptRuleSetResult",
            type: "structure",
            members: {}
          }
        },
        CreateConfigurationSet: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSet"
            ],
            members: {
              ConfigurationSet: {
                shape: "S5"
              }
            }
          },
          output: {
            resultWrapper: "CreateConfigurationSetResult",
            type: "structure",
            members: {}
          }
        },
        CreateConfigurationSetEventDestination: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName",
              "EventDestination"
            ],
            members: {
              ConfigurationSetName: {},
              EventDestination: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateConfigurationSetEventDestinationResult",
            type: "structure",
            members: {}
          }
        },
        CreateConfigurationSetTrackingOptions: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName",
              "TrackingOptions"
            ],
            members: {
              ConfigurationSetName: {},
              TrackingOptions: {
                shape: "Sp"
              }
            }
          },
          output: {
            resultWrapper: "CreateConfigurationSetTrackingOptionsResult",
            type: "structure",
            members: {}
          }
        },
        CreateCustomVerificationEmailTemplate: {
          input: {
            type: "structure",
            required: [
              "TemplateName",
              "FromEmailAddress",
              "TemplateSubject",
              "TemplateContent",
              "SuccessRedirectionURL",
              "FailureRedirectionURL"
            ],
            members: {
              TemplateName: {},
              FromEmailAddress: {},
              TemplateSubject: {},
              TemplateContent: {},
              SuccessRedirectionURL: {},
              FailureRedirectionURL: {}
            }
          }
        },
        CreateReceiptFilter: {
          input: {
            type: "structure",
            required: [
              "Filter"
            ],
            members: {
              Filter: {
                shape: "S10"
              }
            }
          },
          output: {
            resultWrapper: "CreateReceiptFilterResult",
            type: "structure",
            members: {}
          }
        },
        CreateReceiptRule: {
          input: {
            type: "structure",
            required: [
              "RuleSetName",
              "Rule"
            ],
            members: {
              RuleSetName: {},
              After: {},
              Rule: {
                shape: "S18"
              }
            }
          },
          output: {
            resultWrapper: "CreateReceiptRuleResult",
            type: "structure",
            members: {}
          }
        },
        CreateReceiptRuleSet: {
          input: {
            type: "structure",
            required: [
              "RuleSetName"
            ],
            members: {
              RuleSetName: {}
            }
          },
          output: {
            resultWrapper: "CreateReceiptRuleSetResult",
            type: "structure",
            members: {}
          }
        },
        CreateTemplate: {
          input: {
            type: "structure",
            required: [
              "Template"
            ],
            members: {
              Template: {
                shape: "S20"
              }
            }
          },
          output: {
            resultWrapper: "CreateTemplateResult",
            type: "structure",
            members: {}
          }
        },
        DeleteConfigurationSet: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {}
            }
          },
          output: {
            resultWrapper: "DeleteConfigurationSetResult",
            type: "structure",
            members: {}
          }
        },
        DeleteConfigurationSetEventDestination: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName",
              "EventDestinationName"
            ],
            members: {
              ConfigurationSetName: {},
              EventDestinationName: {}
            }
          },
          output: {
            resultWrapper: "DeleteConfigurationSetEventDestinationResult",
            type: "structure",
            members: {}
          }
        },
        DeleteConfigurationSetTrackingOptions: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {}
            }
          },
          output: {
            resultWrapper: "DeleteConfigurationSetTrackingOptionsResult",
            type: "structure",
            members: {}
          }
        },
        DeleteCustomVerificationEmailTemplate: {
          input: {
            type: "structure",
            required: [
              "TemplateName"
            ],
            members: {
              TemplateName: {}
            }
          }
        },
        DeleteIdentity: {
          input: {
            type: "structure",
            required: [
              "Identity"
            ],
            members: {
              Identity: {}
            }
          },
          output: {
            resultWrapper: "DeleteIdentityResult",
            type: "structure",
            members: {}
          }
        },
        DeleteIdentityPolicy: {
          input: {
            type: "structure",
            required: [
              "Identity",
              "PolicyName"
            ],
            members: {
              Identity: {},
              PolicyName: {}
            }
          },
          output: {
            resultWrapper: "DeleteIdentityPolicyResult",
            type: "structure",
            members: {}
          }
        },
        DeleteReceiptFilter: {
          input: {
            type: "structure",
            required: [
              "FilterName"
            ],
            members: {
              FilterName: {}
            }
          },
          output: {
            resultWrapper: "DeleteReceiptFilterResult",
            type: "structure",
            members: {}
          }
        },
        DeleteReceiptRule: {
          input: {
            type: "structure",
            required: [
              "RuleSetName",
              "RuleName"
            ],
            members: {
              RuleSetName: {},
              RuleName: {}
            }
          },
          output: {
            resultWrapper: "DeleteReceiptRuleResult",
            type: "structure",
            members: {}
          }
        },
        DeleteReceiptRuleSet: {
          input: {
            type: "structure",
            required: [
              "RuleSetName"
            ],
            members: {
              RuleSetName: {}
            }
          },
          output: {
            resultWrapper: "DeleteReceiptRuleSetResult",
            type: "structure",
            members: {}
          }
        },
        DeleteTemplate: {
          input: {
            type: "structure",
            required: [
              "TemplateName"
            ],
            members: {
              TemplateName: {}
            }
          },
          output: {
            resultWrapper: "DeleteTemplateResult",
            type: "structure",
            members: {}
          }
        },
        DeleteVerifiedEmailAddress: {
          input: {
            type: "structure",
            required: [
              "EmailAddress"
            ],
            members: {
              EmailAddress: {}
            }
          }
        },
        DescribeActiveReceiptRuleSet: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            resultWrapper: "DescribeActiveReceiptRuleSetResult",
            type: "structure",
            members: {
              Metadata: {
                shape: "S2t"
              },
              Rules: {
                shape: "S2v"
              }
            }
          }
        },
        DescribeConfigurationSet: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {},
              ConfigurationSetAttributeNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "DescribeConfigurationSetResult",
            type: "structure",
            members: {
              ConfigurationSet: {
                shape: "S5"
              },
              EventDestinations: {
                type: "list",
                member: {
                  shape: "S9"
                }
              },
              TrackingOptions: {
                shape: "Sp"
              },
              DeliveryOptions: {
                shape: "S31"
              },
              ReputationOptions: {
                type: "structure",
                members: {
                  SendingEnabled: {
                    type: "boolean"
                  },
                  ReputationMetricsEnabled: {
                    type: "boolean"
                  },
                  LastFreshStart: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        DescribeReceiptRule: {
          input: {
            type: "structure",
            required: [
              "RuleSetName",
              "RuleName"
            ],
            members: {
              RuleSetName: {},
              RuleName: {}
            }
          },
          output: {
            resultWrapper: "DescribeReceiptRuleResult",
            type: "structure",
            members: {
              Rule: {
                shape: "S18"
              }
            }
          }
        },
        DescribeReceiptRuleSet: {
          input: {
            type: "structure",
            required: [
              "RuleSetName"
            ],
            members: {
              RuleSetName: {}
            }
          },
          output: {
            resultWrapper: "DescribeReceiptRuleSetResult",
            type: "structure",
            members: {
              Metadata: {
                shape: "S2t"
              },
              Rules: {
                shape: "S2v"
              }
            }
          }
        },
        GetAccountSendingEnabled: {
          output: {
            resultWrapper: "GetAccountSendingEnabledResult",
            type: "structure",
            members: {
              Enabled: {
                type: "boolean"
              }
            }
          }
        },
        GetCustomVerificationEmailTemplate: {
          input: {
            type: "structure",
            required: [
              "TemplateName"
            ],
            members: {
              TemplateName: {}
            }
          },
          output: {
            resultWrapper: "GetCustomVerificationEmailTemplateResult",
            type: "structure",
            members: {
              TemplateName: {},
              FromEmailAddress: {},
              TemplateSubject: {},
              TemplateContent: {},
              SuccessRedirectionURL: {},
              FailureRedirectionURL: {}
            }
          }
        },
        GetIdentityDkimAttributes: {
          input: {
            type: "structure",
            required: [
              "Identities"
            ],
            members: {
              Identities: {
                shape: "S3c"
              }
            }
          },
          output: {
            resultWrapper: "GetIdentityDkimAttributesResult",
            type: "structure",
            required: [
              "DkimAttributes"
            ],
            members: {
              DkimAttributes: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  required: [
                    "DkimEnabled",
                    "DkimVerificationStatus"
                  ],
                  members: {
                    DkimEnabled: {
                      type: "boolean"
                    },
                    DkimVerificationStatus: {},
                    DkimTokens: {
                      shape: "S3h"
                    }
                  }
                }
              }
            }
          }
        },
        GetIdentityMailFromDomainAttributes: {
          input: {
            type: "structure",
            required: [
              "Identities"
            ],
            members: {
              Identities: {
                shape: "S3c"
              }
            }
          },
          output: {
            resultWrapper: "GetIdentityMailFromDomainAttributesResult",
            type: "structure",
            required: [
              "MailFromDomainAttributes"
            ],
            members: {
              MailFromDomainAttributes: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  required: [
                    "MailFromDomain",
                    "MailFromDomainStatus",
                    "BehaviorOnMXFailure"
                  ],
                  members: {
                    MailFromDomain: {},
                    MailFromDomainStatus: {},
                    BehaviorOnMXFailure: {}
                  }
                }
              }
            }
          }
        },
        GetIdentityNotificationAttributes: {
          input: {
            type: "structure",
            required: [
              "Identities"
            ],
            members: {
              Identities: {
                shape: "S3c"
              }
            }
          },
          output: {
            resultWrapper: "GetIdentityNotificationAttributesResult",
            type: "structure",
            required: [
              "NotificationAttributes"
            ],
            members: {
              NotificationAttributes: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  required: [
                    "BounceTopic",
                    "ComplaintTopic",
                    "DeliveryTopic",
                    "ForwardingEnabled"
                  ],
                  members: {
                    BounceTopic: {},
                    ComplaintTopic: {},
                    DeliveryTopic: {},
                    ForwardingEnabled: {
                      type: "boolean"
                    },
                    HeadersInBounceNotificationsEnabled: {
                      type: "boolean"
                    },
                    HeadersInComplaintNotificationsEnabled: {
                      type: "boolean"
                    },
                    HeadersInDeliveryNotificationsEnabled: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        GetIdentityPolicies: {
          input: {
            type: "structure",
            required: [
              "Identity",
              "PolicyNames"
            ],
            members: {
              Identity: {},
              PolicyNames: {
                shape: "S3w"
              }
            }
          },
          output: {
            resultWrapper: "GetIdentityPoliciesResult",
            type: "structure",
            required: [
              "Policies"
            ],
            members: {
              Policies: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        GetIdentityVerificationAttributes: {
          input: {
            type: "structure",
            required: [
              "Identities"
            ],
            members: {
              Identities: {
                shape: "S3c"
              }
            }
          },
          output: {
            resultWrapper: "GetIdentityVerificationAttributesResult",
            type: "structure",
            required: [
              "VerificationAttributes"
            ],
            members: {
              VerificationAttributes: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  required: [
                    "VerificationStatus"
                  ],
                  members: {
                    VerificationStatus: {},
                    VerificationToken: {}
                  }
                }
              }
            }
          }
        },
        GetSendQuota: {
          output: {
            resultWrapper: "GetSendQuotaResult",
            type: "structure",
            members: {
              Max24HourSend: {
                type: "double"
              },
              MaxSendRate: {
                type: "double"
              },
              SentLast24Hours: {
                type: "double"
              }
            }
          }
        },
        GetSendStatistics: {
          output: {
            resultWrapper: "GetSendStatisticsResult",
            type: "structure",
            members: {
              SendDataPoints: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Timestamp: {
                      type: "timestamp"
                    },
                    DeliveryAttempts: {
                      type: "long"
                    },
                    Bounces: {
                      type: "long"
                    },
                    Complaints: {
                      type: "long"
                    },
                    Rejects: {
                      type: "long"
                    }
                  }
                }
              }
            }
          }
        },
        GetTemplate: {
          input: {
            type: "structure",
            required: [
              "TemplateName"
            ],
            members: {
              TemplateName: {}
            }
          },
          output: {
            resultWrapper: "GetTemplateResult",
            type: "structure",
            members: {
              Template: {
                shape: "S20"
              }
            }
          }
        },
        ListConfigurationSets: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListConfigurationSetsResult",
            type: "structure",
            members: {
              ConfigurationSets: {
                type: "list",
                member: {
                  shape: "S5"
                }
              },
              NextToken: {}
            }
          }
        },
        ListCustomVerificationEmailTemplates: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListCustomVerificationEmailTemplatesResult",
            type: "structure",
            members: {
              CustomVerificationEmailTemplates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TemplateName: {},
                    FromEmailAddress: {},
                    TemplateSubject: {},
                    SuccessRedirectionURL: {},
                    FailureRedirectionURL: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListIdentities: {
          input: {
            type: "structure",
            members: {
              IdentityType: {},
              NextToken: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListIdentitiesResult",
            type: "structure",
            required: [
              "Identities"
            ],
            members: {
              Identities: {
                shape: "S3c"
              },
              NextToken: {}
            }
          }
        },
        ListIdentityPolicies: {
          input: {
            type: "structure",
            required: [
              "Identity"
            ],
            members: {
              Identity: {}
            }
          },
          output: {
            resultWrapper: "ListIdentityPoliciesResult",
            type: "structure",
            required: [
              "PolicyNames"
            ],
            members: {
              PolicyNames: {
                shape: "S3w"
              }
            }
          }
        },
        ListReceiptFilters: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            resultWrapper: "ListReceiptFiltersResult",
            type: "structure",
            members: {
              Filters: {
                type: "list",
                member: {
                  shape: "S10"
                }
              }
            }
          }
        },
        ListReceiptRuleSets: {
          input: {
            type: "structure",
            members: {
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListReceiptRuleSetsResult",
            type: "structure",
            members: {
              RuleSets: {
                type: "list",
                member: {
                  shape: "S2t"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTemplates: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListTemplatesResult",
            type: "structure",
            members: {
              TemplatesMetadata: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    CreatedTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListVerifiedEmailAddresses: {
          output: {
            resultWrapper: "ListVerifiedEmailAddressesResult",
            type: "structure",
            members: {
              VerifiedEmailAddresses: {
                shape: "S54"
              }
            }
          }
        },
        PutConfigurationSetDeliveryOptions: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {},
              DeliveryOptions: {
                shape: "S31"
              }
            }
          },
          output: {
            resultWrapper: "PutConfigurationSetDeliveryOptionsResult",
            type: "structure",
            members: {}
          }
        },
        PutIdentityPolicy: {
          input: {
            type: "structure",
            required: [
              "Identity",
              "PolicyName",
              "Policy"
            ],
            members: {
              Identity: {},
              PolicyName: {},
              Policy: {}
            }
          },
          output: {
            resultWrapper: "PutIdentityPolicyResult",
            type: "structure",
            members: {}
          }
        },
        ReorderReceiptRuleSet: {
          input: {
            type: "structure",
            required: [
              "RuleSetName",
              "RuleNames"
            ],
            members: {
              RuleSetName: {},
              RuleNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "ReorderReceiptRuleSetResult",
            type: "structure",
            members: {}
          }
        },
        SendBounce: {
          input: {
            type: "structure",
            required: [
              "OriginalMessageId",
              "BounceSender",
              "BouncedRecipientInfoList"
            ],
            members: {
              OriginalMessageId: {},
              BounceSender: {},
              Explanation: {},
              MessageDsn: {
                type: "structure",
                required: [
                  "ReportingMta"
                ],
                members: {
                  ReportingMta: {},
                  ArrivalDate: {
                    type: "timestamp"
                  },
                  ExtensionFields: {
                    shape: "S5i"
                  }
                }
              },
              BouncedRecipientInfoList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Recipient"
                  ],
                  members: {
                    Recipient: {},
                    RecipientArn: {},
                    BounceType: {},
                    RecipientDsnFields: {
                      type: "structure",
                      required: [
                        "Action",
                        "Status"
                      ],
                      members: {
                        FinalRecipient: {},
                        Action: {},
                        RemoteMta: {},
                        Status: {},
                        DiagnosticCode: {},
                        LastAttemptDate: {
                          type: "timestamp"
                        },
                        ExtensionFields: {
                          shape: "S5i"
                        }
                      }
                    }
                  }
                }
              },
              BounceSenderArn: {}
            }
          },
          output: {
            resultWrapper: "SendBounceResult",
            type: "structure",
            members: {
              MessageId: {}
            }
          }
        },
        SendBulkTemplatedEmail: {
          input: {
            type: "structure",
            required: [
              "Source",
              "Template",
              "Destinations"
            ],
            members: {
              Source: {},
              SourceArn: {},
              ReplyToAddresses: {
                shape: "S54"
              },
              ReturnPath: {},
              ReturnPathArn: {},
              ConfigurationSetName: {},
              DefaultTags: {
                shape: "S5x"
              },
              Template: {},
              TemplateArn: {},
              DefaultTemplateData: {},
              Destinations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Destination"
                  ],
                  members: {
                    Destination: {
                      shape: "S64"
                    },
                    ReplacementTags: {
                      shape: "S5x"
                    },
                    ReplacementTemplateData: {}
                  }
                }
              }
            }
          },
          output: {
            resultWrapper: "SendBulkTemplatedEmailResult",
            type: "structure",
            required: [
              "Status"
            ],
            members: {
              Status: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Status: {},
                    Error: {},
                    MessageId: {}
                  }
                }
              }
            }
          }
        },
        SendCustomVerificationEmail: {
          input: {
            type: "structure",
            required: [
              "EmailAddress",
              "TemplateName"
            ],
            members: {
              EmailAddress: {},
              TemplateName: {},
              ConfigurationSetName: {}
            }
          },
          output: {
            resultWrapper: "SendCustomVerificationEmailResult",
            type: "structure",
            members: {
              MessageId: {}
            }
          }
        },
        SendEmail: {
          input: {
            type: "structure",
            required: [
              "Source",
              "Destination",
              "Message"
            ],
            members: {
              Source: {},
              Destination: {
                shape: "S64"
              },
              Message: {
                type: "structure",
                required: [
                  "Subject",
                  "Body"
                ],
                members: {
                  Subject: {
                    shape: "S6e"
                  },
                  Body: {
                    type: "structure",
                    members: {
                      Text: {
                        shape: "S6e"
                      },
                      Html: {
                        shape: "S6e"
                      }
                    }
                  }
                }
              },
              ReplyToAddresses: {
                shape: "S54"
              },
              ReturnPath: {},
              SourceArn: {},
              ReturnPathArn: {},
              Tags: {
                shape: "S5x"
              },
              ConfigurationSetName: {}
            }
          },
          output: {
            resultWrapper: "SendEmailResult",
            type: "structure",
            required: [
              "MessageId"
            ],
            members: {
              MessageId: {}
            }
          }
        },
        SendRawEmail: {
          input: {
            type: "structure",
            required: [
              "RawMessage"
            ],
            members: {
              Source: {},
              Destinations: {
                shape: "S54"
              },
              RawMessage: {
                type: "structure",
                required: [
                  "Data"
                ],
                members: {
                  Data: {
                    type: "blob"
                  }
                }
              },
              FromArn: {},
              SourceArn: {},
              ReturnPathArn: {},
              Tags: {
                shape: "S5x"
              },
              ConfigurationSetName: {}
            }
          },
          output: {
            resultWrapper: "SendRawEmailResult",
            type: "structure",
            required: [
              "MessageId"
            ],
            members: {
              MessageId: {}
            }
          }
        },
        SendTemplatedEmail: {
          input: {
            type: "structure",
            required: [
              "Source",
              "Destination",
              "Template",
              "TemplateData"
            ],
            members: {
              Source: {},
              Destination: {
                shape: "S64"
              },
              ReplyToAddresses: {
                shape: "S54"
              },
              ReturnPath: {},
              SourceArn: {},
              ReturnPathArn: {},
              Tags: {
                shape: "S5x"
              },
              ConfigurationSetName: {},
              Template: {},
              TemplateArn: {},
              TemplateData: {}
            }
          },
          output: {
            resultWrapper: "SendTemplatedEmailResult",
            type: "structure",
            required: [
              "MessageId"
            ],
            members: {
              MessageId: {}
            }
          }
        },
        SetActiveReceiptRuleSet: {
          input: {
            type: "structure",
            members: {
              RuleSetName: {}
            }
          },
          output: {
            resultWrapper: "SetActiveReceiptRuleSetResult",
            type: "structure",
            members: {}
          }
        },
        SetIdentityDkimEnabled: {
          input: {
            type: "structure",
            required: [
              "Identity",
              "DkimEnabled"
            ],
            members: {
              Identity: {},
              DkimEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "SetIdentityDkimEnabledResult",
            type: "structure",
            members: {}
          }
        },
        SetIdentityFeedbackForwardingEnabled: {
          input: {
            type: "structure",
            required: [
              "Identity",
              "ForwardingEnabled"
            ],
            members: {
              Identity: {},
              ForwardingEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "SetIdentityFeedbackForwardingEnabledResult",
            type: "structure",
            members: {}
          }
        },
        SetIdentityHeadersInNotificationsEnabled: {
          input: {
            type: "structure",
            required: [
              "Identity",
              "NotificationType",
              "Enabled"
            ],
            members: {
              Identity: {},
              NotificationType: {},
              Enabled: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "SetIdentityHeadersInNotificationsEnabledResult",
            type: "structure",
            members: {}
          }
        },
        SetIdentityMailFromDomain: {
          input: {
            type: "structure",
            required: [
              "Identity"
            ],
            members: {
              Identity: {},
              MailFromDomain: {},
              BehaviorOnMXFailure: {}
            }
          },
          output: {
            resultWrapper: "SetIdentityMailFromDomainResult",
            type: "structure",
            members: {}
          }
        },
        SetIdentityNotificationTopic: {
          input: {
            type: "structure",
            required: [
              "Identity",
              "NotificationType"
            ],
            members: {
              Identity: {},
              NotificationType: {},
              SnsTopic: {}
            }
          },
          output: {
            resultWrapper: "SetIdentityNotificationTopicResult",
            type: "structure",
            members: {}
          }
        },
        SetReceiptRulePosition: {
          input: {
            type: "structure",
            required: [
              "RuleSetName",
              "RuleName"
            ],
            members: {
              RuleSetName: {},
              RuleName: {},
              After: {}
            }
          },
          output: {
            resultWrapper: "SetReceiptRulePositionResult",
            type: "structure",
            members: {}
          }
        },
        TestRenderTemplate: {
          input: {
            type: "structure",
            required: [
              "TemplateName",
              "TemplateData"
            ],
            members: {
              TemplateName: {},
              TemplateData: {}
            }
          },
          output: {
            resultWrapper: "TestRenderTemplateResult",
            type: "structure",
            members: {
              RenderedTemplate: {}
            }
          }
        },
        UpdateAccountSendingEnabled: {
          input: {
            type: "structure",
            members: {
              Enabled: {
                type: "boolean"
              }
            }
          }
        },
        UpdateConfigurationSetEventDestination: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName",
              "EventDestination"
            ],
            members: {
              ConfigurationSetName: {},
              EventDestination: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "UpdateConfigurationSetEventDestinationResult",
            type: "structure",
            members: {}
          }
        },
        UpdateConfigurationSetReputationMetricsEnabled: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName",
              "Enabled"
            ],
            members: {
              ConfigurationSetName: {},
              Enabled: {
                type: "boolean"
              }
            }
          }
        },
        UpdateConfigurationSetSendingEnabled: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName",
              "Enabled"
            ],
            members: {
              ConfigurationSetName: {},
              Enabled: {
                type: "boolean"
              }
            }
          }
        },
        UpdateConfigurationSetTrackingOptions: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName",
              "TrackingOptions"
            ],
            members: {
              ConfigurationSetName: {},
              TrackingOptions: {
                shape: "Sp"
              }
            }
          },
          output: {
            resultWrapper: "UpdateConfigurationSetTrackingOptionsResult",
            type: "structure",
            members: {}
          }
        },
        UpdateCustomVerificationEmailTemplate: {
          input: {
            type: "structure",
            required: [
              "TemplateName"
            ],
            members: {
              TemplateName: {},
              FromEmailAddress: {},
              TemplateSubject: {},
              TemplateContent: {},
              SuccessRedirectionURL: {},
              FailureRedirectionURL: {}
            }
          }
        },
        UpdateReceiptRule: {
          input: {
            type: "structure",
            required: [
              "RuleSetName",
              "Rule"
            ],
            members: {
              RuleSetName: {},
              Rule: {
                shape: "S18"
              }
            }
          },
          output: {
            resultWrapper: "UpdateReceiptRuleResult",
            type: "structure",
            members: {}
          }
        },
        UpdateTemplate: {
          input: {
            type: "structure",
            required: [
              "Template"
            ],
            members: {
              Template: {
                shape: "S20"
              }
            }
          },
          output: {
            resultWrapper: "UpdateTemplateResult",
            type: "structure",
            members: {}
          }
        },
        VerifyDomainDkim: {
          input: {
            type: "structure",
            required: [
              "Domain"
            ],
            members: {
              Domain: {}
            }
          },
          output: {
            resultWrapper: "VerifyDomainDkimResult",
            type: "structure",
            required: [
              "DkimTokens"
            ],
            members: {
              DkimTokens: {
                shape: "S3h"
              }
            }
          }
        },
        VerifyDomainIdentity: {
          input: {
            type: "structure",
            required: [
              "Domain"
            ],
            members: {
              Domain: {}
            }
          },
          output: {
            resultWrapper: "VerifyDomainIdentityResult",
            type: "structure",
            required: [
              "VerificationToken"
            ],
            members: {
              VerificationToken: {}
            }
          }
        },
        VerifyEmailAddress: {
          input: {
            type: "structure",
            required: [
              "EmailAddress"
            ],
            members: {
              EmailAddress: {}
            }
          }
        },
        VerifyEmailIdentity: {
          input: {
            type: "structure",
            required: [
              "EmailAddress"
            ],
            members: {
              EmailAddress: {}
            }
          },
          output: {
            resultWrapper: "VerifyEmailIdentityResult",
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {}
          }
        },
        S9: {
          type: "structure",
          required: [
            "Name",
            "MatchingEventTypes"
          ],
          members: {
            Name: {},
            Enabled: {
              type: "boolean"
            },
            MatchingEventTypes: {
              type: "list",
              member: {}
            },
            KinesisFirehoseDestination: {
              type: "structure",
              required: [
                "IAMRoleARN",
                "DeliveryStreamARN"
              ],
              members: {
                IAMRoleARN: {},
                DeliveryStreamARN: {}
              }
            },
            CloudWatchDestination: {
              type: "structure",
              required: [
                "DimensionConfigurations"
              ],
              members: {
                DimensionConfigurations: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "DimensionName",
                      "DimensionValueSource",
                      "DefaultDimensionValue"
                    ],
                    members: {
                      DimensionName: {},
                      DimensionValueSource: {},
                      DefaultDimensionValue: {}
                    }
                  }
                }
              }
            },
            SNSDestination: {
              type: "structure",
              required: [
                "TopicARN"
              ],
              members: {
                TopicARN: {}
              }
            }
          }
        },
        Sp: {
          type: "structure",
          members: {
            CustomRedirectDomain: {}
          }
        },
        S10: {
          type: "structure",
          required: [
            "Name",
            "IpFilter"
          ],
          members: {
            Name: {},
            IpFilter: {
              type: "structure",
              required: [
                "Policy",
                "Cidr"
              ],
              members: {
                Policy: {},
                Cidr: {}
              }
            }
          }
        },
        S18: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            Enabled: {
              type: "boolean"
            },
            TlsPolicy: {},
            Recipients: {
              type: "list",
              member: {}
            },
            Actions: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  S3Action: {
                    type: "structure",
                    required: [
                      "BucketName"
                    ],
                    members: {
                      TopicArn: {},
                      BucketName: {},
                      ObjectKeyPrefix: {},
                      KmsKeyArn: {}
                    }
                  },
                  BounceAction: {
                    type: "structure",
                    required: [
                      "SmtpReplyCode",
                      "Message",
                      "Sender"
                    ],
                    members: {
                      TopicArn: {},
                      SmtpReplyCode: {},
                      StatusCode: {},
                      Message: {},
                      Sender: {}
                    }
                  },
                  WorkmailAction: {
                    type: "structure",
                    required: [
                      "OrganizationArn"
                    ],
                    members: {
                      TopicArn: {},
                      OrganizationArn: {}
                    }
                  },
                  LambdaAction: {
                    type: "structure",
                    required: [
                      "FunctionArn"
                    ],
                    members: {
                      TopicArn: {},
                      FunctionArn: {},
                      InvocationType: {}
                    }
                  },
                  StopAction: {
                    type: "structure",
                    required: [
                      "Scope"
                    ],
                    members: {
                      Scope: {},
                      TopicArn: {}
                    }
                  },
                  AddHeaderAction: {
                    type: "structure",
                    required: [
                      "HeaderName",
                      "HeaderValue"
                    ],
                    members: {
                      HeaderName: {},
                      HeaderValue: {}
                    }
                  },
                  SNSAction: {
                    type: "structure",
                    required: [
                      "TopicArn"
                    ],
                    members: {
                      TopicArn: {},
                      Encoding: {}
                    }
                  }
                }
              }
            },
            ScanEnabled: {
              type: "boolean"
            }
          }
        },
        S20: {
          type: "structure",
          required: [
            "TemplateName"
          ],
          members: {
            TemplateName: {},
            SubjectPart: {},
            TextPart: {},
            HtmlPart: {}
          }
        },
        S2t: {
          type: "structure",
          members: {
            Name: {},
            CreatedTimestamp: {
              type: "timestamp"
            }
          }
        },
        S2v: {
          type: "list",
          member: {
            shape: "S18"
          }
        },
        S31: {
          type: "structure",
          members: {
            TlsPolicy: {}
          }
        },
        S3c: {
          type: "list",
          member: {}
        },
        S3h: {
          type: "list",
          member: {}
        },
        S3w: {
          type: "list",
          member: {}
        },
        S54: {
          type: "list",
          member: {}
        },
        S5i: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Value"
            ],
            members: {
              Name: {},
              Value: {}
            }
          }
        },
        S5x: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Value"
            ],
            members: {
              Name: {},
              Value: {}
            }
          }
        },
        S64: {
          type: "structure",
          members: {
            ToAddresses: {
              shape: "S54"
            },
            CcAddresses: {
              shape: "S54"
            },
            BccAddresses: {
              shape: "S54"
            }
          }
        },
        S6e: {
          type: "structure",
          required: [
            "Data"
          ],
          members: {
            Data: {},
            Charset: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/email-2010-12-01.paginators.json
var require_email_2010_12_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/email-2010-12-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListCustomVerificationEmailTemplates: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListIdentities: {
          input_token: "NextToken",
          limit_key: "MaxItems",
          output_token: "NextToken",
          result_key: "Identities"
        },
        ListVerifiedEmailAddresses: {
          result_key: "VerifiedEmailAddresses"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/email-2010-12-01.waiters2.json
var require_email_2010_12_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/email-2010-12-01.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        IdentityExists: {
          delay: 3,
          operation: "GetIdentityVerificationAttributes",
          maxAttempts: 20,
          acceptors: [
            {
              expected: "Success",
              matcher: "pathAll",
              state: "success",
              argument: "VerificationAttributes.*.VerificationStatus"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/ses.js
var require_ses = __commonJS({
  "node_modules/aws-sdk/clients/ses.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["ses"] = {};
    AWS2.SES = Service.defineService("ses", ["2010-12-01"]);
    Object.defineProperty(apiLoader.services["ses"], "2010-12-01", {
      get: function get() {
        var model = require_email_2010_12_01_min();
        model.paginators = require_email_2010_12_01_paginators().pagination;
        model.waiters = require_email_2010_12_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.SES;
  }
});

// node_modules/aws-sdk/apis/shield-2016-06-02.min.json
var require_shield_2016_06_02_min = __commonJS({
  "node_modules/aws-sdk/apis/shield-2016-06-02.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-06-02",
        endpointPrefix: "shield",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "AWS Shield",
        serviceFullName: "AWS Shield",
        serviceId: "Shield",
        signatureVersion: "v4",
        targetPrefix: "AWSShield_20160616",
        uid: "shield-2016-06-02"
      },
      operations: {
        AssociateDRTLogBucket: {
          input: {
            type: "structure",
            required: [
              "LogBucket"
            ],
            members: {
              LogBucket: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateDRTRole: {
          input: {
            type: "structure",
            required: [
              "RoleArn"
            ],
            members: {
              RoleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateHealthCheck: {
          input: {
            type: "structure",
            required: [
              "ProtectionId",
              "HealthCheckArn"
            ],
            members: {
              ProtectionId: {},
              HealthCheckArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateProactiveEngagementDetails: {
          input: {
            type: "structure",
            required: [
              "EmergencyContactList"
            ],
            members: {
              EmergencyContactList: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateProtection: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ResourceArn"
            ],
            members: {
              Name: {},
              ResourceArn: {},
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProtectionId: {}
            }
          }
        },
        CreateProtectionGroup: {
          input: {
            type: "structure",
            required: [
              "ProtectionGroupId",
              "Aggregation",
              "Pattern"
            ],
            members: {
              ProtectionGroupId: {},
              Aggregation: {},
              Pattern: {},
              ResourceType: {},
              Members: {
                shape: "Sv"
              },
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateSubscription: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteProtection: {
          input: {
            type: "structure",
            required: [
              "ProtectionId"
            ],
            members: {
              ProtectionId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteProtectionGroup: {
          input: {
            type: "structure",
            required: [
              "ProtectionGroupId"
            ],
            members: {
              ProtectionGroupId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSubscription: {
          input: {
            type: "structure",
            members: {},
            deprecated: true
          },
          output: {
            type: "structure",
            members: {},
            deprecated: true
          },
          deprecated: true
        },
        DescribeAttack: {
          input: {
            type: "structure",
            required: [
              "AttackId"
            ],
            members: {
              AttackId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Attack: {
                type: "structure",
                members: {
                  AttackId: {},
                  ResourceArn: {},
                  SubResources: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Type: {},
                        Id: {},
                        AttackVectors: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "VectorType"
                            ],
                            members: {
                              VectorType: {},
                              VectorCounters: {
                                shape: "S1f"
                              }
                            }
                          }
                        },
                        Counters: {
                          shape: "S1f"
                        }
                      }
                    }
                  },
                  StartTime: {
                    type: "timestamp"
                  },
                  EndTime: {
                    type: "timestamp"
                  },
                  AttackCounters: {
                    shape: "S1f"
                  },
                  AttackProperties: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        AttackLayer: {},
                        AttackPropertyIdentifier: {},
                        TopContributors: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              Name: {},
                              Value: {
                                type: "long"
                              }
                            }
                          }
                        },
                        Unit: {},
                        Total: {
                          type: "long"
                        }
                      }
                    }
                  },
                  Mitigations: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        MitigationName: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeAttackStatistics: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "TimeRange",
              "DataItems"
            ],
            members: {
              TimeRange: {
                shape: "S1w"
              },
              DataItems: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AttackCount"
                  ],
                  members: {
                    AttackVolume: {
                      type: "structure",
                      members: {
                        BitsPerSecond: {
                          shape: "S21"
                        },
                        PacketsPerSecond: {
                          shape: "S21"
                        },
                        RequestsPerSecond: {
                          shape: "S21"
                        }
                      }
                    },
                    AttackCount: {
                      type: "long"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeDRTAccess: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              RoleArn: {},
              LogBucketList: {
                type: "list",
                member: {}
              }
            }
          }
        },
        DescribeEmergencyContactSettings: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              EmergencyContactList: {
                shape: "Sc"
              }
            }
          }
        },
        DescribeProtection: {
          input: {
            type: "structure",
            members: {
              ProtectionId: {},
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Protection: {
                shape: "S29"
              }
            }
          }
        },
        DescribeProtectionGroup: {
          input: {
            type: "structure",
            required: [
              "ProtectionGroupId"
            ],
            members: {
              ProtectionGroupId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ProtectionGroup"
            ],
            members: {
              ProtectionGroup: {
                shape: "S2j"
              }
            }
          }
        },
        DescribeSubscription: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              Subscription: {
                type: "structure",
                required: [
                  "SubscriptionLimits"
                ],
                members: {
                  StartTime: {
                    type: "timestamp"
                  },
                  EndTime: {
                    type: "timestamp"
                  },
                  TimeCommitmentInSeconds: {
                    type: "long"
                  },
                  AutoRenew: {},
                  Limits: {
                    shape: "S2p"
                  },
                  ProactiveEngagementStatus: {},
                  SubscriptionLimits: {
                    type: "structure",
                    required: [
                      "ProtectionLimits",
                      "ProtectionGroupLimits"
                    ],
                    members: {
                      ProtectionLimits: {
                        type: "structure",
                        required: [
                          "ProtectedResourceTypeLimits"
                        ],
                        members: {
                          ProtectedResourceTypeLimits: {
                            shape: "S2p"
                          }
                        }
                      },
                      ProtectionGroupLimits: {
                        type: "structure",
                        required: [
                          "MaxProtectionGroups",
                          "PatternTypeLimits"
                        ],
                        members: {
                          MaxProtectionGroups: {
                            type: "long"
                          },
                          PatternTypeLimits: {
                            type: "structure",
                            required: [
                              "ArbitraryPatternLimits"
                            ],
                            members: {
                              ArbitraryPatternLimits: {
                                type: "structure",
                                required: [
                                  "MaxMembers"
                                ],
                                members: {
                                  MaxMembers: {
                                    type: "long"
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  },
                  SubscriptionArn: {}
                }
              }
            }
          }
        },
        DisableApplicationLayerAutomaticResponse: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisableProactiveEngagement: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateDRTLogBucket: {
          input: {
            type: "structure",
            required: [
              "LogBucket"
            ],
            members: {
              LogBucket: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateDRTRole: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateHealthCheck: {
          input: {
            type: "structure",
            required: [
              "ProtectionId",
              "HealthCheckArn"
            ],
            members: {
              ProtectionId: {},
              HealthCheckArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        EnableApplicationLayerAutomaticResponse: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Action"
            ],
            members: {
              ResourceArn: {},
              Action: {
                shape: "S2e"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        EnableProactiveEngagement: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetSubscriptionState: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "SubscriptionState"
            ],
            members: {
              SubscriptionState: {}
            }
          }
        },
        ListAttacks: {
          input: {
            type: "structure",
            members: {
              ResourceArns: {
                type: "list",
                member: {}
              },
              StartTime: {
                shape: "S1w"
              },
              EndTime: {
                shape: "S1w"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AttackSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AttackId: {},
                    ResourceArn: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    AttackVectors: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "VectorType"
                        ],
                        members: {
                          VectorType: {}
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListProtectionGroups: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              InclusionFilters: {
                type: "structure",
                members: {
                  ProtectionGroupIds: {
                    type: "list",
                    member: {}
                  },
                  Patterns: {
                    type: "list",
                    member: {}
                  },
                  ResourceTypes: {
                    shape: "S3r"
                  },
                  Aggregations: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ProtectionGroups"
            ],
            members: {
              ProtectionGroups: {
                type: "list",
                member: {
                  shape: "S2j"
                }
              },
              NextToken: {}
            }
          }
        },
        ListProtections: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              InclusionFilters: {
                type: "structure",
                members: {
                  ResourceArns: {
                    type: "list",
                    member: {}
                  },
                  ProtectionNames: {
                    type: "list",
                    member: {}
                  },
                  ResourceTypes: {
                    shape: "S3r"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Protections: {
                type: "list",
                member: {
                  shape: "S29"
                }
              },
              NextToken: {}
            }
          }
        },
        ListResourcesInProtectionGroup: {
          input: {
            type: "structure",
            required: [
              "ProtectionGroupId"
            ],
            members: {
              ProtectionGroupId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ResourceArns"
            ],
            members: {
              ResourceArns: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sl"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateApplicationLayerAutomaticResponse: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Action"
            ],
            members: {
              ResourceArn: {},
              Action: {
                shape: "S2e"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateEmergencyContactSettings: {
          input: {
            type: "structure",
            members: {
              EmergencyContactList: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateProtectionGroup: {
          input: {
            type: "structure",
            required: [
              "ProtectionGroupId",
              "Aggregation",
              "Pattern"
            ],
            members: {
              ProtectionGroupId: {},
              Aggregation: {},
              Pattern: {},
              ResourceType: {},
              Members: {
                shape: "Sv"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateSubscription: {
          input: {
            type: "structure",
            members: {
              AutoRenew: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        Sc: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "EmailAddress"
            ],
            members: {
              EmailAddress: {},
              PhoneNumber: {},
              ContactNotes: {}
            }
          }
        },
        Sl: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sv: {
          type: "list",
          member: {}
        },
        S1f: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Max: {
                type: "double"
              },
              Average: {
                type: "double"
              },
              Sum: {
                type: "double"
              },
              N: {
                type: "integer"
              },
              Unit: {}
            }
          }
        },
        S1w: {
          type: "structure",
          members: {
            FromInclusive: {
              type: "timestamp"
            },
            ToExclusive: {
              type: "timestamp"
            }
          }
        },
        S21: {
          type: "structure",
          required: [
            "Max"
          ],
          members: {
            Max: {
              type: "double"
            }
          }
        },
        S29: {
          type: "structure",
          members: {
            Id: {},
            Name: {},
            ResourceArn: {},
            HealthCheckIds: {
              type: "list",
              member: {}
            },
            ProtectionArn: {},
            ApplicationLayerAutomaticResponseConfiguration: {
              type: "structure",
              required: [
                "Status",
                "Action"
              ],
              members: {
                Status: {},
                Action: {
                  shape: "S2e"
                }
              }
            }
          }
        },
        S2e: {
          type: "structure",
          members: {
            Block: {
              type: "structure",
              members: {}
            },
            Count: {
              type: "structure",
              members: {}
            }
          }
        },
        S2j: {
          type: "structure",
          required: [
            "ProtectionGroupId",
            "Aggregation",
            "Pattern",
            "Members"
          ],
          members: {
            ProtectionGroupId: {},
            Aggregation: {},
            Pattern: {},
            ResourceType: {},
            Members: {
              shape: "Sv"
            },
            ProtectionGroupArn: {}
          }
        },
        S2p: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Type: {},
              Max: {
                type: "long"
              }
            }
          }
        },
        S3r: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/shield-2016-06-02.paginators.json
var require_shield_2016_06_02_paginators = __commonJS({
  "node_modules/aws-sdk/apis/shield-2016-06-02.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAttacks: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "AttackSummaries"
        },
        ListProtectionGroups: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListProtections: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Protections"
        },
        ListResourcesInProtectionGroup: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/shield.js
var require_shield = __commonJS({
  "node_modules/aws-sdk/clients/shield.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["shield"] = {};
    AWS2.Shield = Service.defineService("shield", ["2016-06-02"]);
    Object.defineProperty(apiLoader.services["shield"], "2016-06-02", {
      get: function get() {
        var model = require_shield_2016_06_02_min();
        model.paginators = require_shield_2016_06_02_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Shield;
  }
});

// node_modules/aws-sdk/apis/sdb-2009-04-15.min.json
var require_sdb_2009_04_15_min = __commonJS({
  "node_modules/aws-sdk/apis/sdb-2009-04-15.min.json"(exports2, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2009-04-15",
        endpointPrefix: "sdb",
        serviceFullName: "Amazon SimpleDB",
        serviceId: "SimpleDB",
        signatureVersion: "v2",
        xmlNamespace: "http://sdb.amazonaws.com/doc/2009-04-15/",
        protocol: "query"
      },
      operations: {
        BatchDeleteAttributes: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Items"
            ],
            members: {
              DomainName: {},
              Items: {
                type: "list",
                member: {
                  locationName: "Item",
                  type: "structure",
                  required: [
                    "Name"
                  ],
                  members: {
                    Name: {
                      locationName: "ItemName"
                    },
                    Attributes: {
                      shape: "S5"
                    }
                  }
                },
                flattened: true
              }
            }
          }
        },
        BatchPutAttributes: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Items"
            ],
            members: {
              DomainName: {},
              Items: {
                type: "list",
                member: {
                  locationName: "Item",
                  type: "structure",
                  required: [
                    "Name",
                    "Attributes"
                  ],
                  members: {
                    Name: {
                      locationName: "ItemName"
                    },
                    Attributes: {
                      shape: "Sa"
                    }
                  }
                },
                flattened: true
              }
            }
          }
        },
        CreateDomain: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          }
        },
        DeleteAttributes: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "ItemName"
            ],
            members: {
              DomainName: {},
              ItemName: {},
              Attributes: {
                shape: "S5"
              },
              Expected: {
                shape: "Sf"
              }
            }
          }
        },
        DeleteDomain: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          }
        },
        DomainMetadata: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            resultWrapper: "DomainMetadataResult",
            type: "structure",
            members: {
              ItemCount: {
                type: "integer"
              },
              ItemNamesSizeBytes: {
                type: "long"
              },
              AttributeNameCount: {
                type: "integer"
              },
              AttributeNamesSizeBytes: {
                type: "long"
              },
              AttributeValueCount: {
                type: "integer"
              },
              AttributeValuesSizeBytes: {
                type: "long"
              },
              Timestamp: {
                type: "integer"
              }
            }
          }
        },
        GetAttributes: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "ItemName"
            ],
            members: {
              DomainName: {},
              ItemName: {},
              AttributeNames: {
                type: "list",
                member: {
                  locationName: "AttributeName"
                },
                flattened: true
              },
              ConsistentRead: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "GetAttributesResult",
            type: "structure",
            members: {
              Attributes: {
                shape: "So"
              }
            }
          }
        },
        ListDomains: {
          input: {
            type: "structure",
            members: {
              MaxNumberOfDomains: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListDomainsResult",
            type: "structure",
            members: {
              DomainNames: {
                type: "list",
                member: {
                  locationName: "DomainName"
                },
                flattened: true
              },
              NextToken: {}
            }
          }
        },
        PutAttributes: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "ItemName",
              "Attributes"
            ],
            members: {
              DomainName: {},
              ItemName: {},
              Attributes: {
                shape: "Sa"
              },
              Expected: {
                shape: "Sf"
              }
            }
          }
        },
        Select: {
          input: {
            type: "structure",
            required: [
              "SelectExpression"
            ],
            members: {
              SelectExpression: {},
              NextToken: {},
              ConsistentRead: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "SelectResult",
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  locationName: "Item",
                  type: "structure",
                  required: [
                    "Name",
                    "Attributes"
                  ],
                  members: {
                    Name: {},
                    AlternateNameEncoding: {},
                    Attributes: {
                      shape: "So"
                    }
                  }
                },
                flattened: true
              },
              NextToken: {}
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "list",
          member: {
            locationName: "Attribute",
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Value: {}
            }
          },
          flattened: true
        },
        Sa: {
          type: "list",
          member: {
            locationName: "Attribute",
            type: "structure",
            required: [
              "Name",
              "Value"
            ],
            members: {
              Name: {},
              Value: {},
              Replace: {
                type: "boolean"
              }
            }
          },
          flattened: true
        },
        Sf: {
          type: "structure",
          members: {
            Name: {},
            Value: {},
            Exists: {
              type: "boolean"
            }
          }
        },
        So: {
          type: "list",
          member: {
            locationName: "Attribute",
            type: "structure",
            required: [
              "Name",
              "Value"
            ],
            members: {
              Name: {},
              AlternateNameEncoding: {},
              Value: {},
              AlternateValueEncoding: {}
            }
          },
          flattened: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/sdb-2009-04-15.paginators.json
var require_sdb_2009_04_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/sdb-2009-04-15.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListDomains: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxNumberOfDomains",
          result_key: "DomainNames"
        },
        Select: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/simpledb.js
var require_simpledb = __commonJS({
  "node_modules/aws-sdk/clients/simpledb.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["simpledb"] = {};
    AWS2.SimpleDB = Service.defineService("simpledb", ["2009-04-15"]);
    Object.defineProperty(apiLoader.services["simpledb"], "2009-04-15", {
      get: function get() {
        var model = require_sdb_2009_04_15_min();
        model.paginators = require_sdb_2009_04_15_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.SimpleDB;
  }
});

// node_modules/aws-sdk/apis/sms-2016-10-24.min.json
var require_sms_2016_10_24_min = __commonJS({
  "node_modules/aws-sdk/apis/sms-2016-10-24.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-10-24",
        endpointPrefix: "sms",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "SMS",
        serviceFullName: "AWS Server Migration Service",
        serviceId: "SMS",
        signatureVersion: "v4",
        targetPrefix: "AWSServerMigrationService_V2016_10_24",
        uid: "sms-2016-10-24"
      },
      operations: {
        CreateApp: {
          input: {
            type: "structure",
            members: {
              name: {},
              description: {},
              roleName: {},
              clientToken: {},
              serverGroups: {
                shape: "S6"
              },
              tags: {
                shape: "So"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              appSummary: {
                shape: "St"
              },
              serverGroups: {
                shape: "S6"
              },
              tags: {
                shape: "So"
              }
            }
          }
        },
        CreateReplicationJob: {
          input: {
            type: "structure",
            required: [
              "serverId",
              "seedReplicationTime"
            ],
            members: {
              serverId: {},
              seedReplicationTime: {
                type: "timestamp"
              },
              frequency: {
                type: "integer"
              },
              runOnce: {
                type: "boolean"
              },
              licenseType: {},
              roleName: {},
              description: {},
              numberOfRecentAmisToKeep: {
                type: "integer"
              },
              encrypted: {
                type: "boolean"
              },
              kmsKeyId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              replicationJobId: {}
            }
          }
        },
        DeleteApp: {
          input: {
            type: "structure",
            members: {
              appId: {},
              forceStopAppReplication: {
                type: "boolean"
              },
              forceTerminateApp: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAppLaunchConfiguration: {
          input: {
            type: "structure",
            members: {
              appId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAppReplicationConfiguration: {
          input: {
            type: "structure",
            members: {
              appId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAppValidationConfiguration: {
          input: {
            type: "structure",
            required: [
              "appId"
            ],
            members: {
              appId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteReplicationJob: {
          input: {
            type: "structure",
            required: [
              "replicationJobId"
            ],
            members: {
              replicationJobId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteServerCatalog: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateConnector: {
          input: {
            type: "structure",
            required: [
              "connectorId"
            ],
            members: {
              connectorId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GenerateChangeSet: {
          input: {
            type: "structure",
            members: {
              appId: {},
              changesetFormat: {}
            }
          },
          output: {
            type: "structure",
            members: {
              s3Location: {
                shape: "S24"
              }
            }
          }
        },
        GenerateTemplate: {
          input: {
            type: "structure",
            members: {
              appId: {},
              templateFormat: {}
            }
          },
          output: {
            type: "structure",
            members: {
              s3Location: {
                shape: "S24"
              }
            }
          }
        },
        GetApp: {
          input: {
            type: "structure",
            members: {
              appId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              appSummary: {
                shape: "St"
              },
              serverGroups: {
                shape: "S6"
              },
              tags: {
                shape: "So"
              }
            }
          }
        },
        GetAppLaunchConfiguration: {
          input: {
            type: "structure",
            members: {
              appId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              appId: {},
              roleName: {},
              autoLaunch: {
                type: "boolean"
              },
              serverGroupLaunchConfigurations: {
                shape: "S2e"
              }
            }
          }
        },
        GetAppReplicationConfiguration: {
          input: {
            type: "structure",
            members: {
              appId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              serverGroupReplicationConfigurations: {
                shape: "S2u"
              }
            }
          }
        },
        GetAppValidationConfiguration: {
          input: {
            type: "structure",
            required: [
              "appId"
            ],
            members: {
              appId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              appValidationConfigurations: {
                shape: "S31"
              },
              serverGroupValidationConfigurations: {
                shape: "S3c"
              }
            }
          }
        },
        GetAppValidationOutput: {
          input: {
            type: "structure",
            required: [
              "appId"
            ],
            members: {
              appId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              validationOutputList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    validationId: {},
                    name: {},
                    status: {},
                    statusMessage: {},
                    latestValidationTime: {
                      type: "timestamp"
                    },
                    appValidationOutput: {
                      type: "structure",
                      members: {
                        ssmOutput: {
                          type: "structure",
                          members: {
                            s3Location: {
                              shape: "S24"
                            }
                          }
                        }
                      }
                    },
                    serverValidationOutput: {
                      type: "structure",
                      members: {
                        server: {
                          shape: "Sb"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetConnectors: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              connectorList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    connectorId: {},
                    version: {},
                    status: {},
                    capabilityList: {
                      type: "list",
                      member: {}
                    },
                    vmManagerName: {},
                    vmManagerType: {},
                    vmManagerId: {},
                    ipAddress: {},
                    macAddress: {},
                    associatedOn: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetReplicationJobs: {
          input: {
            type: "structure",
            members: {
              replicationJobId: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              replicationJobList: {
                type: "list",
                member: {
                  shape: "S46"
                }
              },
              nextToken: {}
            }
          }
        },
        GetReplicationRuns: {
          input: {
            type: "structure",
            required: [
              "replicationJobId"
            ],
            members: {
              replicationJobId: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              replicationJob: {
                shape: "S46"
              },
              replicationRunList: {
                shape: "S4a"
              },
              nextToken: {}
            }
          }
        },
        GetServers: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              vmServerAddressList: {
                type: "list",
                member: {
                  shape: "Sf"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              lastModifiedOn: {
                type: "timestamp"
              },
              serverCatalogStatus: {},
              serverList: {
                shape: "Sa"
              },
              nextToken: {}
            }
          }
        },
        ImportAppCatalog: {
          input: {
            type: "structure",
            members: {
              roleName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ImportServerCatalog: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        LaunchApp: {
          input: {
            type: "structure",
            members: {
              appId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ListApps: {
          input: {
            type: "structure",
            members: {
              appIds: {
                type: "list",
                member: {}
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              apps: {
                type: "list",
                member: {
                  shape: "St"
                }
              },
              nextToken: {}
            }
          }
        },
        NotifyAppValidationOutput: {
          input: {
            type: "structure",
            required: [
              "appId"
            ],
            members: {
              appId: {},
              notificationContext: {
                type: "structure",
                members: {
                  validationId: {},
                  status: {},
                  statusMessage: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutAppLaunchConfiguration: {
          input: {
            type: "structure",
            members: {
              appId: {},
              roleName: {},
              autoLaunch: {
                type: "boolean"
              },
              serverGroupLaunchConfigurations: {
                shape: "S2e"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutAppReplicationConfiguration: {
          input: {
            type: "structure",
            members: {
              appId: {},
              serverGroupReplicationConfigurations: {
                shape: "S2u"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutAppValidationConfiguration: {
          input: {
            type: "structure",
            required: [
              "appId"
            ],
            members: {
              appId: {},
              appValidationConfigurations: {
                shape: "S31"
              },
              serverGroupValidationConfigurations: {
                shape: "S3c"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartAppReplication: {
          input: {
            type: "structure",
            members: {
              appId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartOnDemandAppReplication: {
          input: {
            type: "structure",
            required: [
              "appId"
            ],
            members: {
              appId: {},
              description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartOnDemandReplicationRun: {
          input: {
            type: "structure",
            required: [
              "replicationJobId"
            ],
            members: {
              replicationJobId: {},
              description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              replicationRunId: {}
            }
          }
        },
        StopAppReplication: {
          input: {
            type: "structure",
            members: {
              appId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TerminateApp: {
          input: {
            type: "structure",
            members: {
              appId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateApp: {
          input: {
            type: "structure",
            members: {
              appId: {},
              name: {},
              description: {},
              roleName: {},
              serverGroups: {
                shape: "S6"
              },
              tags: {
                shape: "So"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              appSummary: {
                shape: "St"
              },
              serverGroups: {
                shape: "S6"
              },
              tags: {
                shape: "So"
              }
            }
          }
        },
        UpdateReplicationJob: {
          input: {
            type: "structure",
            required: [
              "replicationJobId"
            ],
            members: {
              replicationJobId: {},
              frequency: {
                type: "integer"
              },
              nextReplicationRunStartTime: {
                type: "timestamp"
              },
              licenseType: {},
              roleName: {},
              description: {},
              numberOfRecentAmisToKeep: {
                type: "integer"
              },
              encrypted: {
                type: "boolean"
              },
              kmsKeyId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S6: {
          type: "list",
          member: {
            type: "structure",
            members: {
              serverGroupId: {},
              name: {},
              serverList: {
                shape: "Sa"
              }
            }
          }
        },
        Sa: {
          type: "list",
          member: {
            shape: "Sb"
          }
        },
        Sb: {
          type: "structure",
          members: {
            serverId: {},
            serverType: {},
            vmServer: {
              shape: "Se"
            },
            replicationJobId: {},
            replicationJobTerminated: {
              type: "boolean"
            }
          }
        },
        Se: {
          type: "structure",
          members: {
            vmServerAddress: {
              shape: "Sf"
            },
            vmName: {},
            vmManagerName: {},
            vmManagerType: {},
            vmPath: {}
          }
        },
        Sf: {
          type: "structure",
          members: {
            vmManagerId: {},
            vmId: {}
          }
        },
        So: {
          type: "list",
          member: {
            type: "structure",
            members: {
              key: {},
              value: {}
            }
          }
        },
        St: {
          type: "structure",
          members: {
            appId: {},
            importedAppId: {},
            name: {},
            description: {},
            status: {},
            statusMessage: {},
            replicationConfigurationStatus: {},
            replicationStatus: {},
            replicationStatusMessage: {},
            latestReplicationTime: {
              type: "timestamp"
            },
            launchConfigurationStatus: {},
            launchStatus: {},
            launchStatusMessage: {},
            launchDetails: {
              type: "structure",
              members: {
                latestLaunchTime: {
                  type: "timestamp"
                },
                stackName: {},
                stackId: {}
              }
            },
            creationTime: {
              type: "timestamp"
            },
            lastModified: {
              type: "timestamp"
            },
            roleName: {},
            totalServerGroups: {
              type: "integer"
            },
            totalServers: {
              type: "integer"
            }
          }
        },
        S24: {
          type: "structure",
          members: {
            bucket: {},
            key: {}
          }
        },
        S2e: {
          type: "list",
          member: {
            type: "structure",
            members: {
              serverGroupId: {},
              launchOrder: {
                type: "integer"
              },
              serverLaunchConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    server: {
                      shape: "Sb"
                    },
                    logicalId: {},
                    vpc: {},
                    subnet: {},
                    securityGroup: {},
                    ec2KeyName: {},
                    userData: {
                      type: "structure",
                      members: {
                        s3Location: {
                          shape: "S24"
                        }
                      }
                    },
                    instanceType: {},
                    associatePublicIpAddress: {
                      type: "boolean"
                    },
                    iamInstanceProfileName: {},
                    configureScript: {
                      shape: "S24"
                    },
                    configureScriptType: {}
                  }
                }
              }
            }
          }
        },
        S2u: {
          type: "list",
          member: {
            type: "structure",
            members: {
              serverGroupId: {},
              serverReplicationConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    server: {
                      shape: "Sb"
                    },
                    serverReplicationParameters: {
                      type: "structure",
                      members: {
                        seedTime: {
                          type: "timestamp"
                        },
                        frequency: {
                          type: "integer"
                        },
                        runOnce: {
                          type: "boolean"
                        },
                        licenseType: {},
                        numberOfRecentAmisToKeep: {
                          type: "integer"
                        },
                        encrypted: {
                          type: "boolean"
                        },
                        kmsKeyId: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S31: {
          type: "list",
          member: {
            type: "structure",
            members: {
              validationId: {},
              name: {},
              appValidationStrategy: {},
              ssmValidationParameters: {
                type: "structure",
                members: {
                  source: {
                    shape: "S37"
                  },
                  instanceId: {},
                  scriptType: {},
                  command: {},
                  executionTimeoutSeconds: {
                    type: "integer"
                  },
                  outputS3BucketName: {}
                }
              }
            }
          }
        },
        S37: {
          type: "structure",
          members: {
            s3Location: {
              shape: "S24"
            }
          }
        },
        S3c: {
          type: "list",
          member: {
            type: "structure",
            members: {
              serverGroupId: {},
              serverValidationConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    server: {
                      shape: "Sb"
                    },
                    validationId: {},
                    name: {},
                    serverValidationStrategy: {},
                    userDataValidationParameters: {
                      type: "structure",
                      members: {
                        source: {
                          shape: "S37"
                        },
                        scriptType: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S46: {
          type: "structure",
          members: {
            replicationJobId: {},
            serverId: {},
            serverType: {},
            vmServer: {
              shape: "Se"
            },
            seedReplicationTime: {
              type: "timestamp"
            },
            frequency: {
              type: "integer"
            },
            runOnce: {
              type: "boolean"
            },
            nextReplicationRunStartTime: {
              type: "timestamp"
            },
            licenseType: {},
            roleName: {},
            latestAmiId: {},
            state: {},
            statusMessage: {},
            description: {},
            numberOfRecentAmisToKeep: {
              type: "integer"
            },
            encrypted: {
              type: "boolean"
            },
            kmsKeyId: {},
            replicationRunList: {
              shape: "S4a"
            }
          }
        },
        S4a: {
          type: "list",
          member: {
            type: "structure",
            members: {
              replicationRunId: {},
              state: {},
              type: {},
              stageDetails: {
                type: "structure",
                members: {
                  stage: {},
                  stageProgress: {}
                }
              },
              statusMessage: {},
              amiId: {},
              scheduledStartTime: {
                type: "timestamp"
              },
              completedTime: {
                type: "timestamp"
              },
              description: {},
              encrypted: {
                type: "boolean"
              },
              kmsKeyId: {}
            }
          }
        }
      },
      deprecated: true,
      deprecatedMessage: "AWS Server Migration Service is Deprecated."
    };
  }
});

// node_modules/aws-sdk/apis/sms-2016-10-24.paginators.json
var require_sms_2016_10_24_paginators = __commonJS({
  "node_modules/aws-sdk/apis/sms-2016-10-24.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetConnectors: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "connectorList"
        },
        GetReplicationJobs: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "replicationJobList"
        },
        GetReplicationRuns: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "replicationRunList"
        },
        GetServers: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "serverList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/sms.js
var require_sms = __commonJS({
  "node_modules/aws-sdk/clients/sms.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["sms"] = {};
    AWS2.SMS = Service.defineService("sms", ["2016-10-24"]);
    Object.defineProperty(apiLoader.services["sms"], "2016-10-24", {
      get: function get() {
        var model = require_sms_2016_10_24_min();
        model.paginators = require_sms_2016_10_24_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.SMS;
  }
});

// node_modules/aws-sdk/apis/snowball-2016-06-30.min.json
var require_snowball_2016_06_30_min = __commonJS({
  "node_modules/aws-sdk/apis/snowball-2016-06-30.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-06-30",
        endpointPrefix: "snowball",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Amazon Snowball",
        serviceFullName: "Amazon Import/Export Snowball",
        serviceId: "Snowball",
        signatureVersion: "v4",
        targetPrefix: "AWSIESnowballJobManagementService",
        uid: "snowball-2016-06-30"
      },
      operations: {
        CancelCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CancelJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateAddress: {
          input: {
            type: "structure",
            required: [
              "Address"
            ],
            members: {
              Address: {
                shape: "S8"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AddressId: {}
            }
          }
        },
        CreateCluster: {
          input: {
            type: "structure",
            required: [
              "JobType",
              "AddressId",
              "SnowballType",
              "ShippingOption"
            ],
            members: {
              JobType: {},
              Resources: {
                shape: "Sg"
              },
              OnDeviceServiceConfiguration: {
                shape: "Sw"
              },
              Description: {},
              AddressId: {},
              KmsKeyARN: {},
              RoleARN: {},
              SnowballType: {},
              ShippingOption: {},
              Notification: {
                shape: "S1a"
              },
              ForwardingAddressId: {},
              TaxDocuments: {
                shape: "S1e"
              },
              RemoteManagement: {},
              InitialClusterSize: {
                type: "integer"
              },
              ForceCreateJobs: {
                type: "boolean"
              },
              LongTermPricingIds: {
                type: "list",
                member: {}
              },
              SnowballCapacityPreference: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ClusterId: {},
              JobListEntries: {
                shape: "S1n"
              }
            }
          }
        },
        CreateJob: {
          input: {
            type: "structure",
            members: {
              JobType: {},
              Resources: {
                shape: "Sg"
              },
              OnDeviceServiceConfiguration: {
                shape: "Sw"
              },
              Description: {},
              AddressId: {},
              KmsKeyARN: {},
              RoleARN: {},
              SnowballCapacityPreference: {},
              ShippingOption: {},
              Notification: {
                shape: "S1a"
              },
              ClusterId: {},
              SnowballType: {},
              ForwardingAddressId: {},
              TaxDocuments: {
                shape: "S1e"
              },
              DeviceConfiguration: {
                shape: "S1r"
              },
              RemoteManagement: {},
              LongTermPricingId: {},
              ImpactLevel: {},
              PickupDetails: {
                shape: "S1v"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          }
        },
        CreateLongTermPricing: {
          input: {
            type: "structure",
            required: [
              "LongTermPricingType",
              "SnowballType"
            ],
            members: {
              LongTermPricingType: {},
              IsLongTermPricingAutoRenew: {
                type: "boolean"
              },
              SnowballType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LongTermPricingId: {}
            }
          }
        },
        CreateReturnShippingLabel: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              ShippingOption: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {}
            }
          }
        },
        DescribeAddress: {
          input: {
            type: "structure",
            required: [
              "AddressId"
            ],
            members: {
              AddressId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Address: {
                shape: "S8"
              }
            }
          }
        },
        DescribeAddresses: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Addresses: {
                shape: "S2c"
              },
              NextToken: {}
            }
          }
        },
        DescribeCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ClusterMetadata: {
                type: "structure",
                members: {
                  ClusterId: {},
                  Description: {},
                  KmsKeyARN: {},
                  RoleARN: {},
                  ClusterState: {},
                  JobType: {},
                  SnowballType: {},
                  CreationDate: {
                    type: "timestamp"
                  },
                  Resources: {
                    shape: "Sg"
                  },
                  AddressId: {},
                  ShippingOption: {},
                  Notification: {
                    shape: "S1a"
                  },
                  ForwardingAddressId: {},
                  TaxDocuments: {
                    shape: "S1e"
                  },
                  OnDeviceServiceConfiguration: {
                    shape: "Sw"
                  }
                }
              }
            }
          }
        },
        DescribeJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobMetadata: {
                shape: "S2j"
              },
              SubJobMetadata: {
                type: "list",
                member: {
                  shape: "S2j"
                }
              }
            }
          }
        },
        DescribeReturnShippingLabel: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {},
              ExpirationDate: {
                type: "timestamp"
              },
              ReturnShippingLabelURI: {}
            }
          }
        },
        GetJobManifest: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ManifestURI: {}
            }
          }
        },
        GetJobUnlockCode: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UnlockCode: {}
            }
          }
        },
        GetSnowballUsage: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              SnowballLimit: {
                type: "integer"
              },
              SnowballsInUse: {
                type: "integer"
              }
            }
          }
        },
        GetSoftwareUpdates: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UpdatesURI: {}
            }
          }
        },
        ListClusterJobs: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobListEntries: {
                shape: "S1n"
              },
              NextToken: {}
            }
          }
        },
        ListClusters: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ClusterListEntries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ClusterId: {},
                    ClusterState: {},
                    CreationDate: {
                      type: "timestamp"
                    },
                    Description: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListCompatibleImages: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CompatibleImages: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AmiId: {},
                    Name: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListJobs: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobListEntries: {
                shape: "S1n"
              },
              NextToken: {}
            }
          }
        },
        ListLongTermPricing: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LongTermPricingEntries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LongTermPricingId: {},
                    LongTermPricingEndDate: {
                      type: "timestamp"
                    },
                    LongTermPricingStartDate: {
                      type: "timestamp"
                    },
                    LongTermPricingType: {},
                    CurrentActiveJob: {},
                    ReplacementJob: {},
                    IsLongTermPricingAutoRenew: {
                      type: "boolean"
                    },
                    LongTermPricingStatus: {},
                    SnowballType: {},
                    JobIds: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPickupLocations: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Addresses: {
                shape: "S2c"
              },
              NextToken: {}
            }
          }
        },
        ListServiceVersions: {
          input: {
            type: "structure",
            required: [
              "ServiceName"
            ],
            members: {
              ServiceName: {},
              DependentServices: {
                shape: "S3m"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ServiceVersions",
              "ServiceName"
            ],
            members: {
              ServiceVersions: {
                type: "list",
                member: {
                  shape: "S3o"
                }
              },
              ServiceName: {},
              DependentServices: {
                shape: "S3m"
              },
              NextToken: {}
            }
          }
        },
        UpdateCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {},
              RoleARN: {},
              Description: {},
              Resources: {
                shape: "Sg"
              },
              OnDeviceServiceConfiguration: {
                shape: "Sw"
              },
              AddressId: {},
              ShippingOption: {},
              Notification: {
                shape: "S1a"
              },
              ForwardingAddressId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              RoleARN: {},
              Notification: {
                shape: "S1a"
              },
              Resources: {
                shape: "Sg"
              },
              OnDeviceServiceConfiguration: {
                shape: "Sw"
              },
              AddressId: {},
              ShippingOption: {},
              Description: {},
              SnowballCapacityPreference: {},
              ForwardingAddressId: {},
              PickupDetails: {
                shape: "S1v"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateJobShipmentState: {
          input: {
            type: "structure",
            required: [
              "JobId",
              "ShipmentState"
            ],
            members: {
              JobId: {},
              ShipmentState: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateLongTermPricing: {
          input: {
            type: "structure",
            required: [
              "LongTermPricingId"
            ],
            members: {
              LongTermPricingId: {},
              ReplacementJob: {},
              IsLongTermPricingAutoRenew: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S8: {
          type: "structure",
          members: {
            AddressId: {},
            Name: {},
            Company: {},
            Street1: {},
            Street2: {},
            Street3: {},
            City: {},
            StateOrProvince: {},
            PrefectureOrDistrict: {},
            Landmark: {},
            Country: {},
            PostalCode: {},
            PhoneNumber: {},
            IsRestricted: {
              type: "boolean"
            },
            Type: {}
          }
        },
        Sg: {
          type: "structure",
          members: {
            S3Resources: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  BucketArn: {},
                  KeyRange: {
                    type: "structure",
                    members: {
                      BeginMarker: {},
                      EndMarker: {}
                    }
                  },
                  TargetOnDeviceServices: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        ServiceName: {},
                        TransferOption: {}
                      }
                    }
                  }
                }
              }
            },
            LambdaResources: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  LambdaArn: {},
                  EventTriggers: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        EventResourceARN: {}
                      }
                    }
                  }
                }
              }
            },
            Ec2AmiResources: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "AmiId"
                ],
                members: {
                  AmiId: {},
                  SnowballAmiId: {}
                }
              }
            }
          }
        },
        Sw: {
          type: "structure",
          members: {
            NFSOnDeviceService: {
              type: "structure",
              members: {
                StorageLimit: {
                  type: "integer"
                },
                StorageUnit: {}
              }
            },
            TGWOnDeviceService: {
              type: "structure",
              members: {
                StorageLimit: {
                  type: "integer"
                },
                StorageUnit: {}
              }
            },
            EKSOnDeviceService: {
              type: "structure",
              members: {
                KubernetesVersion: {},
                EKSAnywhereVersion: {}
              }
            },
            S3OnDeviceService: {
              type: "structure",
              members: {
                StorageLimit: {
                  type: "double"
                },
                StorageUnit: {},
                ServiceSize: {
                  type: "integer"
                },
                FaultTolerance: {
                  type: "integer"
                }
              }
            }
          }
        },
        S1a: {
          type: "structure",
          members: {
            SnsTopicARN: {},
            JobStatesToNotify: {
              type: "list",
              member: {}
            },
            NotifyAll: {
              type: "boolean"
            },
            DevicePickupSnsTopicARN: {}
          }
        },
        S1e: {
          type: "structure",
          members: {
            IND: {
              type: "structure",
              members: {
                GSTIN: {}
              }
            }
          }
        },
        S1n: {
          type: "list",
          member: {
            type: "structure",
            members: {
              JobId: {},
              JobState: {},
              IsMaster: {
                type: "boolean"
              },
              JobType: {},
              SnowballType: {},
              CreationDate: {
                type: "timestamp"
              },
              Description: {}
            }
          }
        },
        S1r: {
          type: "structure",
          members: {
            SnowconeDeviceConfiguration: {
              type: "structure",
              members: {
                WirelessConnection: {
                  type: "structure",
                  members: {
                    IsWifiEnabled: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        S1v: {
          type: "structure",
          members: {
            Name: {},
            PhoneNumber: {
              type: "string",
              sensitive: true
            },
            Email: {
              type: "string",
              sensitive: true
            },
            IdentificationNumber: {},
            IdentificationExpirationDate: {
              type: "timestamp"
            },
            IdentificationIssuingOrg: {},
            DevicePickupId: {}
          }
        },
        S2c: {
          type: "list",
          member: {
            shape: "S8"
          }
        },
        S2j: {
          type: "structure",
          members: {
            JobId: {},
            JobState: {},
            JobType: {},
            SnowballType: {},
            CreationDate: {
              type: "timestamp"
            },
            Resources: {
              shape: "Sg"
            },
            Description: {},
            KmsKeyARN: {},
            RoleARN: {},
            AddressId: {},
            ShippingDetails: {
              type: "structure",
              members: {
                ShippingOption: {},
                InboundShipment: {
                  shape: "S2l"
                },
                OutboundShipment: {
                  shape: "S2l"
                }
              }
            },
            SnowballCapacityPreference: {},
            Notification: {
              shape: "S1a"
            },
            DataTransferProgress: {
              type: "structure",
              members: {
                BytesTransferred: {
                  type: "long"
                },
                ObjectsTransferred: {
                  type: "long"
                },
                TotalBytes: {
                  type: "long"
                },
                TotalObjects: {
                  type: "long"
                }
              }
            },
            JobLogInfo: {
              type: "structure",
              members: {
                JobCompletionReportURI: {},
                JobSuccessLogURI: {},
                JobFailureLogURI: {}
              }
            },
            ClusterId: {},
            ForwardingAddressId: {},
            TaxDocuments: {
              shape: "S1e"
            },
            DeviceConfiguration: {
              shape: "S1r"
            },
            RemoteManagement: {},
            LongTermPricingId: {},
            OnDeviceServiceConfiguration: {
              shape: "Sw"
            },
            ImpactLevel: {},
            PickupDetails: {
              shape: "S1v"
            },
            SnowballId: {}
          }
        },
        S2l: {
          type: "structure",
          members: {
            Status: {},
            TrackingNumber: {}
          }
        },
        S3m: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ServiceName: {},
              ServiceVersion: {
                shape: "S3o"
              }
            }
          }
        },
        S3o: {
          type: "structure",
          members: {
            Version: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/snowball-2016-06-30.paginators.json
var require_snowball_2016_06_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/snowball-2016-06-30.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeAddresses: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Addresses"
        },
        ListClusterJobs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "JobListEntries"
        },
        ListClusters: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ClusterListEntries"
        },
        ListCompatibleImages: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "CompatibleImages"
        },
        ListJobs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "JobListEntries"
        },
        ListLongTermPricing: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "LongTermPricingEntries"
        },
        ListPickupLocations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/snowball.js
var require_snowball = __commonJS({
  "node_modules/aws-sdk/clients/snowball.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["snowball"] = {};
    AWS2.Snowball = Service.defineService("snowball", ["2016-06-30"]);
    Object.defineProperty(apiLoader.services["snowball"], "2016-06-30", {
      get: function get() {
        var model = require_snowball_2016_06_30_min();
        model.paginators = require_snowball_2016_06_30_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Snowball;
  }
});

// node_modules/aws-sdk/apis/sns-2010-03-31.min.json
var require_sns_2010_03_31_min = __commonJS({
  "node_modules/aws-sdk/apis/sns-2010-03-31.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2010-03-31",
        endpointPrefix: "sns",
        protocol: "query",
        serviceAbbreviation: "Amazon SNS",
        serviceFullName: "Amazon Simple Notification Service",
        serviceId: "SNS",
        signatureVersion: "v4",
        uid: "sns-2010-03-31",
        xmlNamespace: "http://sns.amazonaws.com/doc/2010-03-31/"
      },
      operations: {
        AddPermission: {
          input: {
            type: "structure",
            required: [
              "TopicArn",
              "Label",
              "AWSAccountId",
              "ActionName"
            ],
            members: {
              TopicArn: {},
              Label: {},
              AWSAccountId: {
                type: "list",
                member: {}
              },
              ActionName: {
                type: "list",
                member: {}
              }
            }
          }
        },
        CheckIfPhoneNumberIsOptedOut: {
          input: {
            type: "structure",
            required: [
              "phoneNumber"
            ],
            members: {
              phoneNumber: {}
            }
          },
          output: {
            resultWrapper: "CheckIfPhoneNumberIsOptedOutResult",
            type: "structure",
            members: {
              isOptedOut: {
                type: "boolean"
              }
            }
          }
        },
        ConfirmSubscription: {
          input: {
            type: "structure",
            required: [
              "TopicArn",
              "Token"
            ],
            members: {
              TopicArn: {},
              Token: {},
              AuthenticateOnUnsubscribe: {}
            }
          },
          output: {
            resultWrapper: "ConfirmSubscriptionResult",
            type: "structure",
            members: {
              SubscriptionArn: {}
            }
          }
        },
        CreatePlatformApplication: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Platform",
              "Attributes"
            ],
            members: {
              Name: {},
              Platform: {},
              Attributes: {
                shape: "Sj"
              }
            }
          },
          output: {
            resultWrapper: "CreatePlatformApplicationResult",
            type: "structure",
            members: {
              PlatformApplicationArn: {}
            }
          }
        },
        CreatePlatformEndpoint: {
          input: {
            type: "structure",
            required: [
              "PlatformApplicationArn",
              "Token"
            ],
            members: {
              PlatformApplicationArn: {},
              Token: {},
              CustomUserData: {},
              Attributes: {
                shape: "Sj"
              }
            }
          },
          output: {
            resultWrapper: "CreatePlatformEndpointResult",
            type: "structure",
            members: {
              EndpointArn: {}
            }
          }
        },
        CreateSMSSandboxPhoneNumber: {
          input: {
            type: "structure",
            required: [
              "PhoneNumber"
            ],
            members: {
              PhoneNumber: {},
              LanguageCode: {}
            }
          },
          output: {
            resultWrapper: "CreateSMSSandboxPhoneNumberResult",
            type: "structure",
            members: {}
          }
        },
        CreateTopic: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Attributes: {
                shape: "St"
              },
              Tags: {
                shape: "Sw"
              },
              DataProtectionPolicy: {}
            }
          },
          output: {
            resultWrapper: "CreateTopicResult",
            type: "structure",
            members: {
              TopicArn: {}
            }
          }
        },
        DeleteEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointArn"
            ],
            members: {
              EndpointArn: {}
            }
          }
        },
        DeletePlatformApplication: {
          input: {
            type: "structure",
            required: [
              "PlatformApplicationArn"
            ],
            members: {
              PlatformApplicationArn: {}
            }
          }
        },
        DeleteSMSSandboxPhoneNumber: {
          input: {
            type: "structure",
            required: [
              "PhoneNumber"
            ],
            members: {
              PhoneNumber: {}
            }
          },
          output: {
            resultWrapper: "DeleteSMSSandboxPhoneNumberResult",
            type: "structure",
            members: {}
          }
        },
        DeleteTopic: {
          input: {
            type: "structure",
            required: [
              "TopicArn"
            ],
            members: {
              TopicArn: {}
            }
          }
        },
        GetDataProtectionPolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            resultWrapper: "GetDataProtectionPolicyResult",
            type: "structure",
            members: {
              DataProtectionPolicy: {}
            }
          }
        },
        GetEndpointAttributes: {
          input: {
            type: "structure",
            required: [
              "EndpointArn"
            ],
            members: {
              EndpointArn: {}
            }
          },
          output: {
            resultWrapper: "GetEndpointAttributesResult",
            type: "structure",
            members: {
              Attributes: {
                shape: "Sj"
              }
            }
          }
        },
        GetPlatformApplicationAttributes: {
          input: {
            type: "structure",
            required: [
              "PlatformApplicationArn"
            ],
            members: {
              PlatformApplicationArn: {}
            }
          },
          output: {
            resultWrapper: "GetPlatformApplicationAttributesResult",
            type: "structure",
            members: {
              Attributes: {
                shape: "Sj"
              }
            }
          }
        },
        GetSMSAttributes: {
          input: {
            type: "structure",
            members: {
              attributes: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "GetSMSAttributesResult",
            type: "structure",
            members: {
              attributes: {
                shape: "Sj"
              }
            }
          }
        },
        GetSMSSandboxAccountStatus: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            resultWrapper: "GetSMSSandboxAccountStatusResult",
            type: "structure",
            required: [
              "IsInSandbox"
            ],
            members: {
              IsInSandbox: {
                type: "boolean"
              }
            }
          }
        },
        GetSubscriptionAttributes: {
          input: {
            type: "structure",
            required: [
              "SubscriptionArn"
            ],
            members: {
              SubscriptionArn: {}
            }
          },
          output: {
            resultWrapper: "GetSubscriptionAttributesResult",
            type: "structure",
            members: {
              Attributes: {
                shape: "S1j"
              }
            }
          }
        },
        GetTopicAttributes: {
          input: {
            type: "structure",
            required: [
              "TopicArn"
            ],
            members: {
              TopicArn: {}
            }
          },
          output: {
            resultWrapper: "GetTopicAttributesResult",
            type: "structure",
            members: {
              Attributes: {
                shape: "St"
              }
            }
          }
        },
        ListEndpointsByPlatformApplication: {
          input: {
            type: "structure",
            required: [
              "PlatformApplicationArn"
            ],
            members: {
              PlatformApplicationArn: {},
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListEndpointsByPlatformApplicationResult",
            type: "structure",
            members: {
              Endpoints: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EndpointArn: {},
                    Attributes: {
                      shape: "Sj"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListOriginationNumbers: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListOriginationNumbersResult",
            type: "structure",
            members: {
              NextToken: {},
              PhoneNumbers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreatedAt: {
                      type: "timestamp"
                    },
                    PhoneNumber: {},
                    Status: {},
                    Iso2CountryCode: {},
                    RouteType: {},
                    NumberCapabilities: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              }
            }
          }
        },
        ListPhoneNumbersOptedOut: {
          input: {
            type: "structure",
            members: {
              nextToken: {}
            }
          },
          output: {
            resultWrapper: "ListPhoneNumbersOptedOutResult",
            type: "structure",
            members: {
              phoneNumbers: {
                type: "list",
                member: {}
              },
              nextToken: {}
            }
          }
        },
        ListPlatformApplications: {
          input: {
            type: "structure",
            members: {
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListPlatformApplicationsResult",
            type: "structure",
            members: {
              PlatformApplications: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PlatformApplicationArn: {},
                    Attributes: {
                      shape: "Sj"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSMSSandboxPhoneNumbers: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListSMSSandboxPhoneNumbersResult",
            type: "structure",
            required: [
              "PhoneNumbers"
            ],
            members: {
              PhoneNumbers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PhoneNumber: {},
                    Status: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSubscriptions: {
          input: {
            type: "structure",
            members: {
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListSubscriptionsResult",
            type: "structure",
            members: {
              Subscriptions: {
                shape: "S2h"
              },
              NextToken: {}
            }
          }
        },
        ListSubscriptionsByTopic: {
          input: {
            type: "structure",
            required: [
              "TopicArn"
            ],
            members: {
              TopicArn: {},
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListSubscriptionsByTopicResult",
            type: "structure",
            members: {
              Subscriptions: {
                shape: "S2h"
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            resultWrapper: "ListTagsForResourceResult",
            type: "structure",
            members: {
              Tags: {
                shape: "Sw"
              }
            }
          }
        },
        ListTopics: {
          input: {
            type: "structure",
            members: {
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListTopicsResult",
            type: "structure",
            members: {
              Topics: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TopicArn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        OptInPhoneNumber: {
          input: {
            type: "structure",
            required: [
              "phoneNumber"
            ],
            members: {
              phoneNumber: {}
            }
          },
          output: {
            resultWrapper: "OptInPhoneNumberResult",
            type: "structure",
            members: {}
          }
        },
        Publish: {
          input: {
            type: "structure",
            required: [
              "Message"
            ],
            members: {
              TopicArn: {},
              TargetArn: {},
              PhoneNumber: {},
              Message: {},
              Subject: {},
              MessageStructure: {},
              MessageAttributes: {
                shape: "S31"
              },
              MessageDeduplicationId: {},
              MessageGroupId: {}
            }
          },
          output: {
            resultWrapper: "PublishResult",
            type: "structure",
            members: {
              MessageId: {},
              SequenceNumber: {}
            }
          }
        },
        PublishBatch: {
          input: {
            type: "structure",
            required: [
              "TopicArn",
              "PublishBatchRequestEntries"
            ],
            members: {
              TopicArn: {},
              PublishBatchRequestEntries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Id",
                    "Message"
                  ],
                  members: {
                    Id: {},
                    Message: {},
                    Subject: {},
                    MessageStructure: {},
                    MessageAttributes: {
                      shape: "S31"
                    },
                    MessageDeduplicationId: {},
                    MessageGroupId: {}
                  }
                }
              }
            }
          },
          output: {
            resultWrapper: "PublishBatchResult",
            type: "structure",
            members: {
              Successful: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    MessageId: {},
                    SequenceNumber: {}
                  }
                }
              },
              Failed: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Id",
                    "Code",
                    "SenderFault"
                  ],
                  members: {
                    Id: {},
                    Code: {},
                    Message: {},
                    SenderFault: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        PutDataProtectionPolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "DataProtectionPolicy"
            ],
            members: {
              ResourceArn: {},
              DataProtectionPolicy: {}
            }
          }
        },
        RemovePermission: {
          input: {
            type: "structure",
            required: [
              "TopicArn",
              "Label"
            ],
            members: {
              TopicArn: {},
              Label: {}
            }
          }
        },
        SetEndpointAttributes: {
          input: {
            type: "structure",
            required: [
              "EndpointArn",
              "Attributes"
            ],
            members: {
              EndpointArn: {},
              Attributes: {
                shape: "Sj"
              }
            }
          }
        },
        SetPlatformApplicationAttributes: {
          input: {
            type: "structure",
            required: [
              "PlatformApplicationArn",
              "Attributes"
            ],
            members: {
              PlatformApplicationArn: {},
              Attributes: {
                shape: "Sj"
              }
            }
          }
        },
        SetSMSAttributes: {
          input: {
            type: "structure",
            required: [
              "attributes"
            ],
            members: {
              attributes: {
                shape: "Sj"
              }
            }
          },
          output: {
            resultWrapper: "SetSMSAttributesResult",
            type: "structure",
            members: {}
          }
        },
        SetSubscriptionAttributes: {
          input: {
            type: "structure",
            required: [
              "SubscriptionArn",
              "AttributeName"
            ],
            members: {
              SubscriptionArn: {},
              AttributeName: {},
              AttributeValue: {}
            }
          }
        },
        SetTopicAttributes: {
          input: {
            type: "structure",
            required: [
              "TopicArn",
              "AttributeName"
            ],
            members: {
              TopicArn: {},
              AttributeName: {},
              AttributeValue: {}
            }
          }
        },
        Subscribe: {
          input: {
            type: "structure",
            required: [
              "TopicArn",
              "Protocol"
            ],
            members: {
              TopicArn: {},
              Protocol: {},
              Endpoint: {},
              Attributes: {
                shape: "S1j"
              },
              ReturnSubscriptionArn: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "SubscribeResult",
            type: "structure",
            members: {
              SubscriptionArn: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "Sw"
              }
            }
          },
          output: {
            resultWrapper: "TagResourceResult",
            type: "structure",
            members: {}
          }
        },
        Unsubscribe: {
          input: {
            type: "structure",
            required: [
              "SubscriptionArn"
            ],
            members: {
              SubscriptionArn: {}
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "UntagResourceResult",
            type: "structure",
            members: {}
          }
        },
        VerifySMSSandboxPhoneNumber: {
          input: {
            type: "structure",
            required: [
              "PhoneNumber",
              "OneTimePassword"
            ],
            members: {
              PhoneNumber: {},
              OneTimePassword: {}
            }
          },
          output: {
            resultWrapper: "VerifySMSSandboxPhoneNumberResult",
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        Sj: {
          type: "map",
          key: {},
          value: {}
        },
        St: {
          type: "map",
          key: {},
          value: {}
        },
        Sw: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S1j: {
          type: "map",
          key: {},
          value: {}
        },
        S2h: {
          type: "list",
          member: {
            type: "structure",
            members: {
              SubscriptionArn: {},
              Owner: {},
              Protocol: {},
              Endpoint: {},
              TopicArn: {}
            }
          }
        },
        S31: {
          type: "map",
          key: {
            locationName: "Name"
          },
          value: {
            locationName: "Value",
            type: "structure",
            required: [
              "DataType"
            ],
            members: {
              DataType: {},
              StringValue: {},
              BinaryValue: {
                type: "blob"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/sns-2010-03-31.paginators.json
var require_sns_2010_03_31_paginators = __commonJS({
  "node_modules/aws-sdk/apis/sns-2010-03-31.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListEndpointsByPlatformApplication: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Endpoints"
        },
        ListOriginationNumbers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PhoneNumbers"
        },
        ListPhoneNumbersOptedOut: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "phoneNumbers"
        },
        ListPlatformApplications: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "PlatformApplications"
        },
        ListSMSSandboxPhoneNumbers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PhoneNumbers"
        },
        ListSubscriptions: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Subscriptions"
        },
        ListSubscriptionsByTopic: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Subscriptions"
        },
        ListTopics: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Topics"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/sns.js
var require_sns = __commonJS({
  "node_modules/aws-sdk/clients/sns.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["sns"] = {};
    AWS2.SNS = Service.defineService("sns", ["2010-03-31"]);
    Object.defineProperty(apiLoader.services["sns"], "2010-03-31", {
      get: function get() {
        var model = require_sns_2010_03_31_min();
        model.paginators = require_sns_2010_03_31_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.SNS;
  }
});

// node_modules/aws-sdk/lib/services/sqs.js
var require_sqs = __commonJS({
  "node_modules/aws-sdk/lib/services/sqs.js"() {
    "use strict";
    var AWS2 = require_core();
    AWS2.util.update(AWS2.SQS.prototype, {
      /**
       * @api private
       */
      setupRequestListeners: function setupRequestListeners(request) {
        request.addListener("build", this.buildEndpoint);
        if (request.service.config.computeChecksums) {
          if (request.operation === "sendMessage") {
            request.addListener("extractData", this.verifySendMessageChecksum);
          } else if (request.operation === "sendMessageBatch") {
            request.addListener("extractData", this.verifySendMessageBatchChecksum);
          } else if (request.operation === "receiveMessage") {
            request.addListener("extractData", this.verifyReceiveMessageChecksum);
          }
        }
      },
      /**
       * @api private
       */
      verifySendMessageChecksum: function verifySendMessageChecksum(response) {
        if (!response.data)
          return;
        var md5 = response.data.MD5OfMessageBody;
        var body = this.params.MessageBody;
        var calculatedMd5 = this.service.calculateChecksum(body);
        if (calculatedMd5 !== md5) {
          var msg = 'Got "' + response.data.MD5OfMessageBody + '", expecting "' + calculatedMd5 + '".';
          this.service.throwInvalidChecksumError(
            response,
            [response.data.MessageId],
            msg
          );
        }
      },
      /**
       * @api private
       */
      verifySendMessageBatchChecksum: function verifySendMessageBatchChecksum(response) {
        if (!response.data)
          return;
        var service = this.service;
        var entries = {};
        var errors = [];
        var messageIds = [];
        AWS2.util.arrayEach(response.data.Successful, function(entry) {
          entries[entry.Id] = entry;
        });
        AWS2.util.arrayEach(this.params.Entries, function(entry) {
          if (entries[entry.Id]) {
            var md5 = entries[entry.Id].MD5OfMessageBody;
            var body = entry.MessageBody;
            if (!service.isChecksumValid(md5, body)) {
              errors.push(entry.Id);
              messageIds.push(entries[entry.Id].MessageId);
            }
          }
        });
        if (errors.length > 0) {
          service.throwInvalidChecksumError(
            response,
            messageIds,
            "Invalid messages: " + errors.join(", ")
          );
        }
      },
      /**
       * @api private
       */
      verifyReceiveMessageChecksum: function verifyReceiveMessageChecksum(response) {
        if (!response.data)
          return;
        var service = this.service;
        var messageIds = [];
        AWS2.util.arrayEach(response.data.Messages, function(message) {
          var md5 = message.MD5OfBody;
          var body = message.Body;
          if (!service.isChecksumValid(md5, body)) {
            messageIds.push(message.MessageId);
          }
        });
        if (messageIds.length > 0) {
          service.throwInvalidChecksumError(
            response,
            messageIds,
            "Invalid messages: " + messageIds.join(", ")
          );
        }
      },
      /**
       * @api private
       */
      throwInvalidChecksumError: function throwInvalidChecksumError(response, ids, message) {
        response.error = AWS2.util.error(new Error(), {
          retryable: true,
          code: "InvalidChecksum",
          messageIds: ids,
          message: response.request.operation + " returned an invalid MD5 response. " + message
        });
      },
      /**
       * @api private
       */
      isChecksumValid: function isChecksumValid(checksum, data) {
        return this.calculateChecksum(data) === checksum;
      },
      /**
       * @api private
       */
      calculateChecksum: function calculateChecksum(data) {
        return AWS2.util.crypto.md5(data, "hex");
      },
      /**
       * @api private
       */
      buildEndpoint: function buildEndpoint(request) {
        var url = request.httpRequest.params.QueueUrl;
        if (url) {
          request.httpRequest.endpoint = new AWS2.Endpoint(url);
          var matches = request.httpRequest.endpoint.host.match(/^sqs\.(.+?)\./);
          if (matches)
            request.httpRequest.region = matches[1];
        }
      }
    });
  }
});

// node_modules/aws-sdk/apis/sqs-2012-11-05.min.json
var require_sqs_2012_11_05_min = __commonJS({
  "node_modules/aws-sdk/apis/sqs-2012-11-05.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2012-11-05",
        awsQueryCompatible: {},
        endpointPrefix: "sqs",
        jsonVersion: "1.0",
        protocol: "json",
        serviceAbbreviation: "Amazon SQS",
        serviceFullName: "Amazon Simple Queue Service",
        serviceId: "SQS",
        signatureVersion: "v4",
        targetPrefix: "AmazonSQS",
        uid: "sqs-2012-11-05"
      },
      operations: {
        AddPermission: {
          input: {
            type: "structure",
            required: [
              "QueueUrl",
              "Label",
              "AWSAccountIds",
              "Actions"
            ],
            members: {
              QueueUrl: {},
              Label: {},
              AWSAccountIds: {
                type: "list",
                member: {},
                flattened: true
              },
              Actions: {
                type: "list",
                member: {},
                flattened: true
              }
            }
          }
        },
        CancelMessageMoveTask: {
          input: {
            type: "structure",
            required: [
              "TaskHandle"
            ],
            members: {
              TaskHandle: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApproximateNumberOfMessagesMoved: {
                type: "long"
              }
            }
          }
        },
        ChangeMessageVisibility: {
          input: {
            type: "structure",
            required: [
              "QueueUrl",
              "ReceiptHandle",
              "VisibilityTimeout"
            ],
            members: {
              QueueUrl: {},
              ReceiptHandle: {},
              VisibilityTimeout: {
                type: "integer"
              }
            }
          }
        },
        ChangeMessageVisibilityBatch: {
          input: {
            type: "structure",
            required: [
              "QueueUrl",
              "Entries"
            ],
            members: {
              QueueUrl: {},
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Id",
                    "ReceiptHandle"
                  ],
                  members: {
                    Id: {},
                    ReceiptHandle: {},
                    VisibilityTimeout: {
                      type: "integer"
                    }
                  }
                },
                flattened: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Successful",
              "Failed"
            ],
            members: {
              Successful: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Id"
                  ],
                  members: {
                    Id: {}
                  }
                },
                flattened: true
              },
              Failed: {
                shape: "Sg"
              }
            }
          }
        },
        CreateQueue: {
          input: {
            type: "structure",
            required: [
              "QueueName"
            ],
            members: {
              QueueName: {},
              Attributes: {
                shape: "Sk"
              },
              tags: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              QueueUrl: {}
            }
          }
        },
        DeleteMessage: {
          input: {
            type: "structure",
            required: [
              "QueueUrl",
              "ReceiptHandle"
            ],
            members: {
              QueueUrl: {},
              ReceiptHandle: {}
            }
          }
        },
        DeleteMessageBatch: {
          input: {
            type: "structure",
            required: [
              "QueueUrl",
              "Entries"
            ],
            members: {
              QueueUrl: {},
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Id",
                    "ReceiptHandle"
                  ],
                  members: {
                    Id: {},
                    ReceiptHandle: {}
                  }
                },
                flattened: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Successful",
              "Failed"
            ],
            members: {
              Successful: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Id"
                  ],
                  members: {
                    Id: {}
                  }
                },
                flattened: true
              },
              Failed: {
                shape: "Sg"
              }
            }
          }
        },
        DeleteQueue: {
          input: {
            type: "structure",
            required: [
              "QueueUrl"
            ],
            members: {
              QueueUrl: {}
            }
          }
        },
        GetQueueAttributes: {
          input: {
            type: "structure",
            required: [
              "QueueUrl"
            ],
            members: {
              QueueUrl: {},
              AttributeNames: {
                shape: "Sz"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "Sk"
              }
            }
          }
        },
        GetQueueUrl: {
          input: {
            type: "structure",
            required: [
              "QueueName"
            ],
            members: {
              QueueName: {},
              QueueOwnerAWSAccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              QueueUrl: {}
            }
          }
        },
        ListDeadLetterSourceQueues: {
          input: {
            type: "structure",
            required: [
              "QueueUrl"
            ],
            members: {
              QueueUrl: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "queueUrls"
            ],
            members: {
              queueUrls: {
                shape: "S17"
              },
              NextToken: {}
            }
          }
        },
        ListMessageMoveTasks: {
          input: {
            type: "structure",
            required: [
              "SourceArn"
            ],
            members: {
              SourceArn: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Results: {
                flattened: true,
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TaskHandle: {},
                    Status: {},
                    SourceArn: {},
                    DestinationArn: {},
                    MaxNumberOfMessagesPerSecond: {
                      type: "integer"
                    },
                    ApproximateNumberOfMessagesMoved: {
                      type: "long"
                    },
                    ApproximateNumberOfMessagesToMove: {
                      type: "long"
                    },
                    FailureReason: {},
                    StartedTimestamp: {
                      type: "long"
                    }
                  }
                }
              }
            }
          }
        },
        ListQueueTags: {
          input: {
            type: "structure",
            required: [
              "QueueUrl"
            ],
            members: {
              QueueUrl: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sm"
              }
            }
          }
        },
        ListQueues: {
          input: {
            type: "structure",
            members: {
              QueueNamePrefix: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              QueueUrls: {
                shape: "S17"
              },
              NextToken: {}
            }
          }
        },
        PurgeQueue: {
          input: {
            type: "structure",
            required: [
              "QueueUrl"
            ],
            members: {
              QueueUrl: {}
            }
          }
        },
        ReceiveMessage: {
          input: {
            type: "structure",
            required: [
              "QueueUrl"
            ],
            members: {
              QueueUrl: {},
              AttributeNames: {
                shape: "Sz"
              },
              MessageAttributeNames: {
                type: "list",
                member: {},
                flattened: true
              },
              MaxNumberOfMessages: {
                type: "integer"
              },
              VisibilityTimeout: {
                type: "integer"
              },
              WaitTimeSeconds: {
                type: "integer"
              },
              ReceiveRequestAttemptId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Messages: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MessageId: {},
                    ReceiptHandle: {},
                    MD5OfBody: {},
                    Body: {},
                    Attributes: {
                      type: "map",
                      key: {},
                      value: {},
                      flattened: true
                    },
                    MD5OfMessageAttributes: {},
                    MessageAttributes: {
                      shape: "S1q"
                    }
                  }
                },
                flattened: true
              }
            }
          }
        },
        RemovePermission: {
          input: {
            type: "structure",
            required: [
              "QueueUrl",
              "Label"
            ],
            members: {
              QueueUrl: {},
              Label: {}
            }
          }
        },
        SendMessage: {
          input: {
            type: "structure",
            required: [
              "QueueUrl",
              "MessageBody"
            ],
            members: {
              QueueUrl: {},
              MessageBody: {},
              DelaySeconds: {
                type: "integer"
              },
              MessageAttributes: {
                shape: "S1q"
              },
              MessageSystemAttributes: {
                shape: "S1x"
              },
              MessageDeduplicationId: {},
              MessageGroupId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MD5OfMessageBody: {},
              MD5OfMessageAttributes: {},
              MD5OfMessageSystemAttributes: {},
              MessageId: {},
              SequenceNumber: {}
            }
          }
        },
        SendMessageBatch: {
          input: {
            type: "structure",
            required: [
              "QueueUrl",
              "Entries"
            ],
            members: {
              QueueUrl: {},
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Id",
                    "MessageBody"
                  ],
                  members: {
                    Id: {},
                    MessageBody: {},
                    DelaySeconds: {
                      type: "integer"
                    },
                    MessageAttributes: {
                      shape: "S1q"
                    },
                    MessageSystemAttributes: {
                      shape: "S1x"
                    },
                    MessageDeduplicationId: {},
                    MessageGroupId: {}
                  }
                },
                flattened: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Successful",
              "Failed"
            ],
            members: {
              Successful: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Id",
                    "MessageId",
                    "MD5OfMessageBody"
                  ],
                  members: {
                    Id: {},
                    MessageId: {},
                    MD5OfMessageBody: {},
                    MD5OfMessageAttributes: {},
                    MD5OfMessageSystemAttributes: {},
                    SequenceNumber: {}
                  }
                },
                flattened: true
              },
              Failed: {
                shape: "Sg"
              }
            }
          }
        },
        SetQueueAttributes: {
          input: {
            type: "structure",
            required: [
              "QueueUrl",
              "Attributes"
            ],
            members: {
              QueueUrl: {},
              Attributes: {
                shape: "Sk"
              }
            }
          }
        },
        StartMessageMoveTask: {
          input: {
            type: "structure",
            required: [
              "SourceArn"
            ],
            members: {
              SourceArn: {},
              DestinationArn: {},
              MaxNumberOfMessagesPerSecond: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TaskHandle: {}
            }
          }
        },
        TagQueue: {
          input: {
            type: "structure",
            required: [
              "QueueUrl",
              "Tags"
            ],
            members: {
              QueueUrl: {},
              Tags: {
                shape: "Sm"
              }
            }
          }
        },
        UntagQueue: {
          input: {
            type: "structure",
            required: [
              "QueueUrl",
              "TagKeys"
            ],
            members: {
              QueueUrl: {},
              TagKeys: {
                type: "list",
                member: {},
                flattened: true
              }
            }
          }
        }
      },
      shapes: {
        Sg: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Id",
              "SenderFault",
              "Code"
            ],
            members: {
              Id: {},
              SenderFault: {
                type: "boolean"
              },
              Code: {},
              Message: {}
            }
          },
          flattened: true
        },
        Sk: {
          type: "map",
          key: {},
          value: {},
          flattened: true
        },
        Sm: {
          type: "map",
          key: {},
          value: {},
          flattened: true
        },
        Sz: {
          type: "list",
          member: {},
          flattened: true
        },
        S17: {
          type: "list",
          member: {},
          flattened: true
        },
        S1q: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "DataType"
            ],
            members: {
              StringValue: {},
              BinaryValue: {
                type: "blob"
              },
              StringListValues: {
                shape: "S1t",
                flattened: true
              },
              BinaryListValues: {
                shape: "S1u",
                flattened: true
              },
              DataType: {}
            }
          },
          flattened: true
        },
        S1t: {
          type: "list",
          member: {}
        },
        S1u: {
          type: "list",
          member: {
            type: "blob"
          }
        },
        S1x: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "DataType"
            ],
            members: {
              StringValue: {},
              BinaryValue: {
                type: "blob"
              },
              StringListValues: {
                shape: "S1t",
                flattened: true
              },
              BinaryListValues: {
                shape: "S1u",
                flattened: true
              },
              DataType: {}
            }
          },
          flattened: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/sqs-2012-11-05.paginators.json
var require_sqs_2012_11_05_paginators = __commonJS({
  "node_modules/aws-sdk/apis/sqs-2012-11-05.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListDeadLetterSourceQueues: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "queueUrls"
        },
        ListQueues: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "QueueUrls"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/sqs.js
var require_sqs2 = __commonJS({
  "node_modules/aws-sdk/clients/sqs.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["sqs"] = {};
    AWS2.SQS = Service.defineService("sqs", ["2012-11-05"]);
    require_sqs();
    Object.defineProperty(apiLoader.services["sqs"], "2012-11-05", {
      get: function get() {
        var model = require_sqs_2012_11_05_min();
        model.paginators = require_sqs_2012_11_05_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.SQS;
  }
});

// node_modules/aws-sdk/apis/ssm-2014-11-06.min.json
var require_ssm_2014_11_06_min = __commonJS({
  "node_modules/aws-sdk/apis/ssm-2014-11-06.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-11-06",
        endpointPrefix: "ssm",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Amazon SSM",
        serviceFullName: "Amazon Simple Systems Manager (SSM)",
        serviceId: "SSM",
        signatureVersion: "v4",
        targetPrefix: "AmazonSSM",
        uid: "ssm-2014-11-06"
      },
      operations: {
        AddTagsToResource: {
          input: {
            type: "structure",
            required: [
              "ResourceType",
              "ResourceId",
              "Tags"
            ],
            members: {
              ResourceType: {},
              ResourceId: {},
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateOpsItemRelatedItem: {
          input: {
            type: "structure",
            required: [
              "OpsItemId",
              "AssociationType",
              "ResourceType",
              "ResourceUri"
            ],
            members: {
              OpsItemId: {},
              AssociationType: {},
              ResourceType: {},
              ResourceUri: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AssociationId: {}
            }
          }
        },
        CancelCommand: {
          input: {
            type: "structure",
            required: [
              "CommandId"
            ],
            members: {
              CommandId: {},
              InstanceIds: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CancelMaintenanceWindowExecution: {
          input: {
            type: "structure",
            required: [
              "WindowExecutionId"
            ],
            members: {
              WindowExecutionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WindowExecutionId: {}
            }
          }
        },
        CreateActivation: {
          input: {
            type: "structure",
            required: [
              "IamRole"
            ],
            members: {
              Description: {},
              DefaultInstanceName: {},
              IamRole: {},
              RegistrationLimit: {
                type: "integer"
              },
              ExpirationDate: {
                type: "timestamp"
              },
              Tags: {
                shape: "S4"
              },
              RegistrationMetadata: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key",
                    "Value"
                  ],
                  members: {
                    Key: {},
                    Value: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ActivationId: {},
              ActivationCode: {}
            }
          }
        },
        CreateAssociation: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              DocumentVersion: {},
              InstanceId: {},
              Parameters: {
                shape: "S14"
              },
              Targets: {
                shape: "S18"
              },
              ScheduleExpression: {},
              OutputLocation: {
                shape: "S1e"
              },
              AssociationName: {},
              AutomationTargetParameterName: {},
              MaxErrors: {},
              MaxConcurrency: {},
              ComplianceSeverity: {},
              SyncCompliance: {},
              ApplyOnlyAtCronInterval: {
                type: "boolean"
              },
              CalendarNames: {
                shape: "S1q"
              },
              TargetLocations: {
                shape: "S1s"
              },
              ScheduleOffset: {
                type: "integer"
              },
              TargetMaps: {
                shape: "S25"
              },
              Tags: {
                shape: "S4"
              },
              AlarmConfiguration: {
                shape: "S1z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssociationDescription: {
                shape: "S2b"
              }
            }
          }
        },
        CreateAssociationBatch: {
          input: {
            type: "structure",
            required: [
              "Entries"
            ],
            members: {
              Entries: {
                type: "list",
                member: {
                  shape: "S2s"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Successful: {
                type: "list",
                member: {
                  shape: "S2b"
                }
              },
              Failed: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Entry: {
                      shape: "S2s"
                    },
                    Message: {},
                    Fault: {}
                  }
                }
              }
            }
          }
        },
        CreateDocument: {
          input: {
            type: "structure",
            required: [
              "Content",
              "Name"
            ],
            members: {
              Content: {},
              Requires: {
                shape: "S31"
              },
              Attachments: {
                shape: "S35"
              },
              Name: {},
              DisplayName: {},
              VersionName: {},
              DocumentType: {},
              DocumentFormat: {},
              TargetType: {},
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentDescription: {
                shape: "S3h"
              }
            }
          }
        },
        CreateMaintenanceWindow: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Schedule",
              "Duration",
              "Cutoff",
              "AllowUnassociatedTargets"
            ],
            members: {
              Name: {},
              Description: {
                shape: "S4b"
              },
              StartDate: {},
              EndDate: {},
              Schedule: {},
              ScheduleTimezone: {},
              ScheduleOffset: {
                type: "integer"
              },
              Duration: {
                type: "integer"
              },
              Cutoff: {
                type: "integer"
              },
              AllowUnassociatedTargets: {
                type: "boolean"
              },
              ClientToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WindowId: {}
            }
          }
        },
        CreateOpsItem: {
          input: {
            type: "structure",
            required: [
              "Description",
              "Source",
              "Title"
            ],
            members: {
              Description: {},
              OpsItemType: {},
              OperationalData: {
                shape: "S4p"
              },
              Notifications: {
                shape: "S4u"
              },
              Priority: {
                type: "integer"
              },
              RelatedOpsItems: {
                shape: "S4y"
              },
              Source: {},
              Title: {},
              Tags: {
                shape: "S4"
              },
              Category: {},
              Severity: {},
              ActualStartTime: {
                type: "timestamp"
              },
              ActualEndTime: {
                type: "timestamp"
              },
              PlannedStartTime: {
                type: "timestamp"
              },
              PlannedEndTime: {
                type: "timestamp"
              },
              AccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OpsItemId: {},
              OpsItemArn: {}
            }
          }
        },
        CreateOpsMetadata: {
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              ResourceId: {},
              Metadata: {
                shape: "S59"
              },
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OpsMetadataArn: {}
            }
          }
        },
        CreatePatchBaseline: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              OperatingSystem: {},
              Name: {},
              GlobalFilters: {
                shape: "S5i"
              },
              ApprovalRules: {
                shape: "S5o"
              },
              ApprovedPatches: {
                shape: "S5u"
              },
              ApprovedPatchesComplianceLevel: {},
              ApprovedPatchesEnableNonSecurity: {
                type: "boolean"
              },
              RejectedPatches: {
                shape: "S5u"
              },
              RejectedPatchesAction: {},
              Description: {},
              Sources: {
                shape: "S5y"
              },
              ClientToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BaselineId: {}
            }
          }
        },
        CreateResourceDataSync: {
          input: {
            type: "structure",
            required: [
              "SyncName"
            ],
            members: {
              SyncName: {},
              S3Destination: {
                shape: "S68"
              },
              SyncType: {},
              SyncSource: {
                shape: "S6h"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteActivation: {
          input: {
            type: "structure",
            required: [
              "ActivationId"
            ],
            members: {
              ActivationId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAssociation: {
          input: {
            type: "structure",
            members: {
              Name: {},
              InstanceId: {},
              AssociationId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDocument: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              DocumentVersion: {},
              VersionName: {},
              Force: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteInventory: {
          input: {
            type: "structure",
            required: [
              "TypeName"
            ],
            members: {
              TypeName: {},
              SchemaDeleteOption: {},
              DryRun: {
                type: "boolean"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeletionId: {},
              TypeName: {},
              DeletionSummary: {
                shape: "S75"
              }
            }
          }
        },
        DeleteMaintenanceWindow: {
          input: {
            type: "structure",
            required: [
              "WindowId"
            ],
            members: {
              WindowId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WindowId: {}
            }
          }
        },
        DeleteOpsItem: {
          input: {
            type: "structure",
            required: [
              "OpsItemId"
            ],
            members: {
              OpsItemId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteOpsMetadata: {
          input: {
            type: "structure",
            required: [
              "OpsMetadataArn"
            ],
            members: {
              OpsMetadataArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteParameter: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteParameters: {
          input: {
            type: "structure",
            required: [
              "Names"
            ],
            members: {
              Names: {
                shape: "S7m"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeletedParameters: {
                shape: "S7m"
              },
              InvalidParameters: {
                shape: "S7m"
              }
            }
          }
        },
        DeletePatchBaseline: {
          input: {
            type: "structure",
            required: [
              "BaselineId"
            ],
            members: {
              BaselineId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BaselineId: {}
            }
          }
        },
        DeleteResourceDataSync: {
          input: {
            type: "structure",
            required: [
              "SyncName"
            ],
            members: {
              SyncName: {},
              SyncType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "PolicyId",
              "PolicyHash"
            ],
            members: {
              ResourceArn: {},
              PolicyId: {},
              PolicyHash: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeregisterManagedInstance: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeregisterPatchBaselineForPatchGroup: {
          input: {
            type: "structure",
            required: [
              "BaselineId",
              "PatchGroup"
            ],
            members: {
              BaselineId: {},
              PatchGroup: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BaselineId: {},
              PatchGroup: {}
            }
          }
        },
        DeregisterTargetFromMaintenanceWindow: {
          input: {
            type: "structure",
            required: [
              "WindowId",
              "WindowTargetId"
            ],
            members: {
              WindowId: {},
              WindowTargetId: {},
              Safe: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WindowId: {},
              WindowTargetId: {}
            }
          }
        },
        DeregisterTaskFromMaintenanceWindow: {
          input: {
            type: "structure",
            required: [
              "WindowId",
              "WindowTaskId"
            ],
            members: {
              WindowId: {},
              WindowTaskId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WindowId: {},
              WindowTaskId: {}
            }
          }
        },
        DescribeActivations: {
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FilterKey: {},
                    FilterValues: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ActivationList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ActivationId: {},
                    Description: {},
                    DefaultInstanceName: {},
                    IamRole: {},
                    RegistrationLimit: {
                      type: "integer"
                    },
                    RegistrationsCount: {
                      type: "integer"
                    },
                    ExpirationDate: {
                      type: "timestamp"
                    },
                    Expired: {
                      type: "boolean"
                    },
                    CreatedDate: {
                      type: "timestamp"
                    },
                    Tags: {
                      shape: "S4"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeAssociation: {
          input: {
            type: "structure",
            members: {
              Name: {},
              InstanceId: {},
              AssociationId: {},
              AssociationVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AssociationDescription: {
                shape: "S2b"
              }
            }
          }
        },
        DescribeAssociationExecutionTargets: {
          input: {
            type: "structure",
            required: [
              "AssociationId",
              "ExecutionId"
            ],
            members: {
              AssociationId: {},
              ExecutionId: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key",
                    "Value"
                  ],
                  members: {
                    Key: {},
                    Value: {}
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AssociationExecutionTargets: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AssociationId: {},
                    AssociationVersion: {},
                    ExecutionId: {},
                    ResourceId: {},
                    ResourceType: {},
                    Status: {},
                    DetailedStatus: {},
                    LastExecutionDate: {
                      type: "timestamp"
                    },
                    OutputSource: {
                      type: "structure",
                      members: {
                        OutputSourceId: {},
                        OutputSourceType: {}
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeAssociationExecutions: {
          input: {
            type: "structure",
            required: [
              "AssociationId"
            ],
            members: {
              AssociationId: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key",
                    "Value",
                    "Type"
                  ],
                  members: {
                    Key: {},
                    Value: {},
                    Type: {}
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AssociationExecutions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AssociationId: {},
                    AssociationVersion: {},
                    ExecutionId: {},
                    Status: {},
                    DetailedStatus: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    LastExecutionDate: {
                      type: "timestamp"
                    },
                    ResourceCountByStatus: {},
                    AlarmConfiguration: {
                      shape: "S1z"
                    },
                    TriggeredAlarms: {
                      shape: "S2n"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeAutomationExecutions: {
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key",
                    "Values"
                  ],
                  members: {
                    Key: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AutomationExecutionMetadataList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AutomationExecutionId: {},
                    DocumentName: {},
                    DocumentVersion: {},
                    AutomationExecutionStatus: {},
                    ExecutionStartTime: {
                      type: "timestamp"
                    },
                    ExecutionEndTime: {
                      type: "timestamp"
                    },
                    ExecutedBy: {},
                    LogFile: {},
                    Outputs: {
                      shape: "S9m"
                    },
                    Mode: {},
                    ParentAutomationExecutionId: {},
                    CurrentStepName: {},
                    CurrentAction: {},
                    FailureMessage: {},
                    TargetParameterName: {},
                    Targets: {
                      shape: "S18"
                    },
                    TargetMaps: {
                      shape: "S25"
                    },
                    ResolvedTargets: {
                      shape: "S9r"
                    },
                    MaxConcurrency: {},
                    MaxErrors: {},
                    Target: {},
                    AutomationType: {},
                    AlarmConfiguration: {
                      shape: "S1z"
                    },
                    TriggeredAlarms: {
                      shape: "S2n"
                    },
                    AutomationSubtype: {},
                    ScheduledTime: {
                      type: "timestamp"
                    },
                    Runbooks: {
                      shape: "S9v"
                    },
                    OpsItemId: {},
                    AssociationId: {},
                    ChangeRequestName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeAutomationStepExecutions: {
          input: {
            type: "structure",
            required: [
              "AutomationExecutionId"
            ],
            members: {
              AutomationExecutionId: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key",
                    "Values"
                  ],
                  members: {
                    Key: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ReverseOrder: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StepExecutions: {
                shape: "Sa5"
              },
              NextToken: {}
            }
          }
        },
        DescribeAvailablePatches: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Sag"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Patches: {
                type: "list",
                member: {
                  shape: "Sao"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeDocument: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              DocumentVersion: {},
              VersionName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Document: {
                shape: "S3h"
              }
            }
          }
        },
        DescribeDocumentPermission: {
          input: {
            type: "structure",
            required: [
              "Name",
              "PermissionType"
            ],
            members: {
              Name: {},
              PermissionType: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AccountIds: {
                shape: "Sbj"
              },
              AccountSharingInfoList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AccountId: {},
                    SharedDocumentVersion: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeEffectiveInstanceAssociations: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Associations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AssociationId: {},
                    InstanceId: {},
                    Content: {},
                    AssociationVersion: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeEffectivePatchesForPatchBaseline: {
          input: {
            type: "structure",
            required: [
              "BaselineId"
            ],
            members: {
              BaselineId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EffectivePatches: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Patch: {
                      shape: "Sao"
                    },
                    PatchStatus: {
                      type: "structure",
                      members: {
                        DeploymentStatus: {},
                        ComplianceLevel: {},
                        ApprovalDate: {
                          type: "timestamp"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeInstanceAssociationsStatus: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceAssociationStatusInfos: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AssociationId: {},
                    Name: {},
                    DocumentVersion: {},
                    AssociationVersion: {},
                    InstanceId: {},
                    ExecutionDate: {
                      type: "timestamp"
                    },
                    Status: {},
                    DetailedStatus: {},
                    ExecutionSummary: {},
                    ErrorCode: {},
                    OutputUrl: {
                      type: "structure",
                      members: {
                        S3OutputUrl: {
                          type: "structure",
                          members: {
                            OutputUrl: {}
                          }
                        }
                      }
                    },
                    AssociationName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeInstanceInformation: {
          input: {
            type: "structure",
            members: {
              InstanceInformationFilterList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "key",
                    "valueSet"
                  ],
                  members: {
                    key: {},
                    valueSet: {
                      shape: "Scc"
                    }
                  }
                }
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key",
                    "Values"
                  ],
                  members: {
                    Key: {},
                    Values: {
                      shape: "Scc"
                    }
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceInformationList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InstanceId: {},
                    PingStatus: {},
                    LastPingDateTime: {
                      type: "timestamp"
                    },
                    AgentVersion: {},
                    IsLatestVersion: {
                      type: "boolean"
                    },
                    PlatformType: {},
                    PlatformName: {},
                    PlatformVersion: {},
                    ActivationId: {},
                    IamRole: {},
                    RegistrationDate: {
                      type: "timestamp"
                    },
                    ResourceType: {},
                    Name: {},
                    IPAddress: {},
                    ComputerName: {},
                    AssociationStatus: {},
                    LastAssociationExecutionDate: {
                      type: "timestamp"
                    },
                    LastSuccessfulAssociationExecutionDate: {
                      type: "timestamp"
                    },
                    AssociationOverview: {
                      type: "structure",
                      members: {
                        DetailedStatus: {},
                        InstanceAssociationStatusAggregatedCount: {
                          type: "map",
                          key: {},
                          value: {
                            type: "integer"
                          }
                        }
                      }
                    },
                    SourceId: {},
                    SourceType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeInstancePatchStates: {
          input: {
            type: "structure",
            required: [
              "InstanceIds"
            ],
            members: {
              InstanceIds: {
                shape: "Si"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstancePatchStates: {
                type: "list",
                member: {
                  shape: "Scy"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeInstancePatchStatesForPatchGroup: {
          input: {
            type: "structure",
            required: [
              "PatchGroup"
            ],
            members: {
              PatchGroup: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key",
                    "Values",
                    "Type"
                  ],
                  members: {
                    Key: {},
                    Values: {
                      type: "list",
                      member: {}
                    },
                    Type: {}
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstancePatchStates: {
                type: "list",
                member: {
                  shape: "Scy"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeInstancePatches: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              Filters: {
                shape: "Sag"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Patches: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Title",
                    "KBId",
                    "Classification",
                    "Severity",
                    "State",
                    "InstalledTime"
                  ],
                  members: {
                    Title: {},
                    KBId: {},
                    Classification: {},
                    Severity: {},
                    State: {},
                    InstalledTime: {
                      type: "timestamp"
                    },
                    CVEIds: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeInventoryDeletions: {
          input: {
            type: "structure",
            members: {
              DeletionId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InventoryDeletions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DeletionId: {},
                    TypeName: {},
                    DeletionStartTime: {
                      type: "timestamp"
                    },
                    LastStatus: {},
                    LastStatusMessage: {},
                    DeletionSummary: {
                      shape: "S75"
                    },
                    LastStatusUpdateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeMaintenanceWindowExecutionTaskInvocations: {
          input: {
            type: "structure",
            required: [
              "WindowExecutionId",
              "TaskId"
            ],
            members: {
              WindowExecutionId: {},
              TaskId: {},
              Filters: {
                shape: "Se4"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WindowExecutionTaskInvocationIdentities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WindowExecutionId: {},
                    TaskExecutionId: {},
                    InvocationId: {},
                    ExecutionId: {},
                    TaskType: {},
                    Parameters: {
                      shape: "Seg"
                    },
                    Status: {},
                    StatusDetails: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    OwnerInformation: {
                      shape: "Sd1"
                    },
                    WindowTargetId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeMaintenanceWindowExecutionTasks: {
          input: {
            type: "structure",
            required: [
              "WindowExecutionId"
            ],
            members: {
              WindowExecutionId: {},
              Filters: {
                shape: "Se4"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WindowExecutionTaskIdentities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WindowExecutionId: {},
                    TaskExecutionId: {},
                    Status: {},
                    StatusDetails: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    TaskArn: {},
                    TaskType: {},
                    AlarmConfiguration: {
                      shape: "S1z"
                    },
                    TriggeredAlarms: {
                      shape: "S2n"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeMaintenanceWindowExecutions: {
          input: {
            type: "structure",
            required: [
              "WindowId"
            ],
            members: {
              WindowId: {},
              Filters: {
                shape: "Se4"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WindowExecutions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WindowId: {},
                    WindowExecutionId: {},
                    Status: {},
                    StatusDetails: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeMaintenanceWindowSchedule: {
          input: {
            type: "structure",
            members: {
              WindowId: {},
              Targets: {
                shape: "S18"
              },
              ResourceType: {},
              Filters: {
                shape: "Sag"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ScheduledWindowExecutions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WindowId: {},
                    Name: {},
                    ExecutionTime: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeMaintenanceWindowTargets: {
          input: {
            type: "structure",
            required: [
              "WindowId"
            ],
            members: {
              WindowId: {},
              Filters: {
                shape: "Se4"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Targets: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WindowId: {},
                    WindowTargetId: {},
                    ResourceType: {},
                    Targets: {
                      shape: "S18"
                    },
                    OwnerInformation: {
                      shape: "Sd1"
                    },
                    Name: {},
                    Description: {
                      shape: "S4b"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeMaintenanceWindowTasks: {
          input: {
            type: "structure",
            required: [
              "WindowId"
            ],
            members: {
              WindowId: {},
              Filters: {
                shape: "Se4"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tasks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WindowId: {},
                    WindowTaskId: {},
                    TaskArn: {},
                    Type: {},
                    Targets: {
                      shape: "S18"
                    },
                    TaskParameters: {
                      shape: "Sf7"
                    },
                    Priority: {
                      type: "integer"
                    },
                    LoggingInfo: {
                      shape: "Sfd"
                    },
                    ServiceRoleArn: {},
                    MaxConcurrency: {},
                    MaxErrors: {},
                    Name: {},
                    Description: {
                      shape: "S4b"
                    },
                    CutoffBehavior: {},
                    AlarmConfiguration: {
                      shape: "S1z"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeMaintenanceWindows: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Se4"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WindowIdentities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WindowId: {},
                    Name: {},
                    Description: {
                      shape: "S4b"
                    },
                    Enabled: {
                      type: "boolean"
                    },
                    Duration: {
                      type: "integer"
                    },
                    Cutoff: {
                      type: "integer"
                    },
                    Schedule: {},
                    ScheduleTimezone: {},
                    ScheduleOffset: {
                      type: "integer"
                    },
                    EndDate: {},
                    StartDate: {},
                    NextExecutionTime: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeMaintenanceWindowsForTarget: {
          input: {
            type: "structure",
            required: [
              "Targets",
              "ResourceType"
            ],
            members: {
              Targets: {
                shape: "S18"
              },
              ResourceType: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WindowIdentities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WindowId: {},
                    Name: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeOpsItems: {
          input: {
            type: "structure",
            members: {
              OpsItemFilters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key",
                    "Values",
                    "Operator"
                  ],
                  members: {
                    Key: {},
                    Values: {
                      type: "list",
                      member: {}
                    },
                    Operator: {}
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              OpsItemSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreatedBy: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    LastModifiedBy: {},
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    Priority: {
                      type: "integer"
                    },
                    Source: {},
                    Status: {},
                    OpsItemId: {},
                    Title: {},
                    OperationalData: {
                      shape: "S4p"
                    },
                    Category: {},
                    Severity: {},
                    OpsItemType: {},
                    ActualStartTime: {
                      type: "timestamp"
                    },
                    ActualEndTime: {
                      type: "timestamp"
                    },
                    PlannedStartTime: {
                      type: "timestamp"
                    },
                    PlannedEndTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeParameters: {
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key",
                    "Values"
                  ],
                  members: {
                    Key: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              ParameterFilters: {
                shape: "Sg7"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Parameters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Type: {},
                    KeyId: {},
                    LastModifiedDate: {
                      type: "timestamp"
                    },
                    LastModifiedUser: {},
                    Description: {},
                    AllowedPattern: {},
                    Version: {
                      type: "long"
                    },
                    Tier: {},
                    Policies: {
                      shape: "Sgm"
                    },
                    DataType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribePatchBaselines: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Sag"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BaselineIdentities: {
                type: "list",
                member: {
                  shape: "Sgs"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribePatchGroupState: {
          input: {
            type: "structure",
            required: [
              "PatchGroup"
            ],
            members: {
              PatchGroup: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Instances: {
                type: "integer"
              },
              InstancesWithInstalledPatches: {
                type: "integer"
              },
              InstancesWithInstalledOtherPatches: {
                type: "integer"
              },
              InstancesWithInstalledPendingRebootPatches: {
                type: "integer"
              },
              InstancesWithInstalledRejectedPatches: {
                type: "integer"
              },
              InstancesWithMissingPatches: {
                type: "integer"
              },
              InstancesWithFailedPatches: {
                type: "integer"
              },
              InstancesWithNotApplicablePatches: {
                type: "integer"
              },
              InstancesWithUnreportedNotApplicablePatches: {
                type: "integer"
              },
              InstancesWithCriticalNonCompliantPatches: {
                type: "integer"
              },
              InstancesWithSecurityNonCompliantPatches: {
                type: "integer"
              },
              InstancesWithOtherNonCompliantPatches: {
                type: "integer"
              }
            }
          }
        },
        DescribePatchGroups: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "Sag"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Mappings: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PatchGroup: {},
                    BaselineIdentity: {
                      shape: "Sgs"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribePatchProperties: {
          input: {
            type: "structure",
            required: [
              "OperatingSystem",
              "Property"
            ],
            members: {
              OperatingSystem: {},
              Property: {},
              PatchSet: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Properties: {
                type: "list",
                member: {
                  type: "map",
                  key: {},
                  value: {}
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeSessions: {
          input: {
            type: "structure",
            required: [
              "State"
            ],
            members: {
              State: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "key",
                    "value"
                  ],
                  members: {
                    key: {},
                    value: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Sessions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SessionId: {},
                    Target: {},
                    Status: {},
                    StartDate: {
                      type: "timestamp"
                    },
                    EndDate: {
                      type: "timestamp"
                    },
                    DocumentName: {},
                    Owner: {},
                    Reason: {},
                    Details: {},
                    OutputUrl: {
                      type: "structure",
                      members: {
                        S3OutputUrl: {},
                        CloudWatchOutputUrl: {}
                      }
                    },
                    MaxSessionDuration: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DisassociateOpsItemRelatedItem: {
          input: {
            type: "structure",
            required: [
              "OpsItemId",
              "AssociationId"
            ],
            members: {
              OpsItemId: {},
              AssociationId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetAutomationExecution: {
          input: {
            type: "structure",
            required: [
              "AutomationExecutionId"
            ],
            members: {
              AutomationExecutionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AutomationExecution: {
                type: "structure",
                members: {
                  AutomationExecutionId: {},
                  DocumentName: {},
                  DocumentVersion: {},
                  ExecutionStartTime: {
                    type: "timestamp"
                  },
                  ExecutionEndTime: {
                    type: "timestamp"
                  },
                  AutomationExecutionStatus: {},
                  StepExecutions: {
                    shape: "Sa5"
                  },
                  StepExecutionsTruncated: {
                    type: "boolean"
                  },
                  Parameters: {
                    shape: "S9m"
                  },
                  Outputs: {
                    shape: "S9m"
                  },
                  FailureMessage: {},
                  Mode: {},
                  ParentAutomationExecutionId: {},
                  ExecutedBy: {},
                  CurrentStepName: {},
                  CurrentAction: {},
                  TargetParameterName: {},
                  Targets: {
                    shape: "S18"
                  },
                  TargetMaps: {
                    shape: "S25"
                  },
                  ResolvedTargets: {
                    shape: "S9r"
                  },
                  MaxConcurrency: {},
                  MaxErrors: {},
                  Target: {},
                  TargetLocations: {
                    shape: "S1s"
                  },
                  ProgressCounters: {
                    type: "structure",
                    members: {
                      TotalSteps: {
                        type: "integer"
                      },
                      SuccessSteps: {
                        type: "integer"
                      },
                      FailedSteps: {
                        type: "integer"
                      },
                      CancelledSteps: {
                        type: "integer"
                      },
                      TimedOutSteps: {
                        type: "integer"
                      }
                    }
                  },
                  AlarmConfiguration: {
                    shape: "S1z"
                  },
                  TriggeredAlarms: {
                    shape: "S2n"
                  },
                  AutomationSubtype: {},
                  ScheduledTime: {
                    type: "timestamp"
                  },
                  Runbooks: {
                    shape: "S9v"
                  },
                  OpsItemId: {},
                  AssociationId: {},
                  ChangeRequestName: {},
                  Variables: {
                    shape: "S9m"
                  }
                }
              }
            }
          }
        },
        GetCalendarState: {
          input: {
            type: "structure",
            required: [
              "CalendarNames"
            ],
            members: {
              CalendarNames: {
                shape: "S1q"
              },
              AtTime: {}
            }
          },
          output: {
            type: "structure",
            members: {
              State: {},
              AtTime: {},
              NextTransitionTime: {}
            }
          }
        },
        GetCommandInvocation: {
          input: {
            type: "structure",
            required: [
              "CommandId",
              "InstanceId"
            ],
            members: {
              CommandId: {},
              InstanceId: {},
              PluginName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CommandId: {},
              InstanceId: {},
              Comment: {},
              DocumentName: {},
              DocumentVersion: {},
              PluginName: {},
              ResponseCode: {
                type: "integer"
              },
              ExecutionStartDateTime: {},
              ExecutionElapsedTime: {},
              ExecutionEndDateTime: {},
              Status: {},
              StatusDetails: {},
              StandardOutputContent: {},
              StandardOutputUrl: {},
              StandardErrorContent: {},
              StandardErrorUrl: {},
              CloudWatchOutputConfig: {
                shape: "Sid"
              }
            }
          }
        },
        GetConnectionStatus: {
          input: {
            type: "structure",
            required: [
              "Target"
            ],
            members: {
              Target: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Target: {},
              Status: {}
            }
          }
        },
        GetDefaultPatchBaseline: {
          input: {
            type: "structure",
            members: {
              OperatingSystem: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BaselineId: {},
              OperatingSystem: {}
            }
          }
        },
        GetDeployablePatchSnapshotForInstance: {
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "SnapshotId"
            ],
            members: {
              InstanceId: {},
              SnapshotId: {},
              BaselineOverride: {
                type: "structure",
                members: {
                  OperatingSystem: {},
                  GlobalFilters: {
                    shape: "S5i"
                  },
                  ApprovalRules: {
                    shape: "S5o"
                  },
                  ApprovedPatches: {
                    shape: "S5u"
                  },
                  ApprovedPatchesComplianceLevel: {},
                  RejectedPatches: {
                    shape: "S5u"
                  },
                  RejectedPatchesAction: {},
                  ApprovedPatchesEnableNonSecurity: {
                    type: "boolean"
                  },
                  Sources: {
                    shape: "S5y"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceId: {},
              SnapshotId: {},
              SnapshotDownloadUrl: {},
              Product: {}
            }
          }
        },
        GetDocument: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              VersionName: {},
              DocumentVersion: {},
              DocumentFormat: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              CreatedDate: {
                type: "timestamp"
              },
              DisplayName: {},
              VersionName: {},
              DocumentVersion: {},
              Status: {},
              StatusInformation: {},
              Content: {},
              DocumentType: {},
              DocumentFormat: {},
              Requires: {
                shape: "S31"
              },
              AttachmentsContent: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Size: {
                      type: "long"
                    },
                    Hash: {},
                    HashType: {},
                    Url: {}
                  }
                }
              },
              ReviewStatus: {}
            }
          }
        },
        GetInventory: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Siz"
              },
              Aggregators: {
                shape: "Sj5"
              },
              ResultAttributes: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "TypeName"
                  ],
                  members: {
                    TypeName: {}
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Entities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Data: {
                      type: "map",
                      key: {},
                      value: {
                        type: "structure",
                        required: [
                          "TypeName",
                          "SchemaVersion",
                          "Content"
                        ],
                        members: {
                          TypeName: {},
                          SchemaVersion: {},
                          CaptureTime: {},
                          ContentHash: {},
                          Content: {
                            shape: "Sjm"
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetInventorySchema: {
          input: {
            type: "structure",
            members: {
              TypeName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Aggregator: {
                type: "boolean"
              },
              SubType: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Schemas: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "TypeName",
                    "Attributes"
                  ],
                  members: {
                    TypeName: {},
                    Version: {},
                    Attributes: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "Name",
                          "DataType"
                        ],
                        members: {
                          Name: {},
                          DataType: {}
                        }
                      }
                    },
                    DisplayName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetMaintenanceWindow: {
          input: {
            type: "structure",
            required: [
              "WindowId"
            ],
            members: {
              WindowId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WindowId: {},
              Name: {},
              Description: {
                shape: "S4b"
              },
              StartDate: {},
              EndDate: {},
              Schedule: {},
              ScheduleTimezone: {},
              ScheduleOffset: {
                type: "integer"
              },
              NextExecutionTime: {},
              Duration: {
                type: "integer"
              },
              Cutoff: {
                type: "integer"
              },
              AllowUnassociatedTargets: {
                type: "boolean"
              },
              Enabled: {
                type: "boolean"
              },
              CreatedDate: {
                type: "timestamp"
              },
              ModifiedDate: {
                type: "timestamp"
              }
            }
          }
        },
        GetMaintenanceWindowExecution: {
          input: {
            type: "structure",
            required: [
              "WindowExecutionId"
            ],
            members: {
              WindowExecutionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WindowExecutionId: {},
              TaskIds: {
                type: "list",
                member: {}
              },
              Status: {},
              StatusDetails: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              }
            }
          }
        },
        GetMaintenanceWindowExecutionTask: {
          input: {
            type: "structure",
            required: [
              "WindowExecutionId",
              "TaskId"
            ],
            members: {
              WindowExecutionId: {},
              TaskId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WindowExecutionId: {},
              TaskExecutionId: {},
              TaskArn: {},
              ServiceRole: {},
              Type: {},
              TaskParameters: {
                type: "list",
                member: {
                  shape: "Sf7"
                },
                sensitive: true
              },
              Priority: {
                type: "integer"
              },
              MaxConcurrency: {},
              MaxErrors: {},
              Status: {},
              StatusDetails: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              AlarmConfiguration: {
                shape: "S1z"
              },
              TriggeredAlarms: {
                shape: "S2n"
              }
            }
          }
        },
        GetMaintenanceWindowExecutionTaskInvocation: {
          input: {
            type: "structure",
            required: [
              "WindowExecutionId",
              "TaskId",
              "InvocationId"
            ],
            members: {
              WindowExecutionId: {},
              TaskId: {},
              InvocationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WindowExecutionId: {},
              TaskExecutionId: {},
              InvocationId: {},
              ExecutionId: {},
              TaskType: {},
              Parameters: {
                shape: "Seg"
              },
              Status: {},
              StatusDetails: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              OwnerInformation: {
                shape: "Sd1"
              },
              WindowTargetId: {}
            }
          }
        },
        GetMaintenanceWindowTask: {
          input: {
            type: "structure",
            required: [
              "WindowId",
              "WindowTaskId"
            ],
            members: {
              WindowId: {},
              WindowTaskId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WindowId: {},
              WindowTaskId: {},
              Targets: {
                shape: "S18"
              },
              TaskArn: {},
              ServiceRoleArn: {},
              TaskType: {},
              TaskParameters: {
                shape: "Sf7"
              },
              TaskInvocationParameters: {
                shape: "Skd"
              },
              Priority: {
                type: "integer"
              },
              MaxConcurrency: {},
              MaxErrors: {},
              LoggingInfo: {
                shape: "Sfd"
              },
              Name: {},
              Description: {
                shape: "S4b"
              },
              CutoffBehavior: {},
              AlarmConfiguration: {
                shape: "S1z"
              }
            }
          }
        },
        GetOpsItem: {
          input: {
            type: "structure",
            required: [
              "OpsItemId"
            ],
            members: {
              OpsItemId: {},
              OpsItemArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OpsItem: {
                type: "structure",
                members: {
                  CreatedBy: {},
                  OpsItemType: {},
                  CreatedTime: {
                    type: "timestamp"
                  },
                  Description: {},
                  LastModifiedBy: {},
                  LastModifiedTime: {
                    type: "timestamp"
                  },
                  Notifications: {
                    shape: "S4u"
                  },
                  Priority: {
                    type: "integer"
                  },
                  RelatedOpsItems: {
                    shape: "S4y"
                  },
                  Status: {},
                  OpsItemId: {},
                  Version: {},
                  Title: {},
                  Source: {},
                  OperationalData: {
                    shape: "S4p"
                  },
                  Category: {},
                  Severity: {},
                  ActualStartTime: {
                    type: "timestamp"
                  },
                  ActualEndTime: {
                    type: "timestamp"
                  },
                  PlannedStartTime: {
                    type: "timestamp"
                  },
                  PlannedEndTime: {
                    type: "timestamp"
                  },
                  OpsItemArn: {}
                }
              }
            }
          }
        },
        GetOpsMetadata: {
          input: {
            type: "structure",
            required: [
              "OpsMetadataArn"
            ],
            members: {
              OpsMetadataArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceId: {},
              Metadata: {
                shape: "S59"
              },
              NextToken: {}
            }
          }
        },
        GetOpsSummary: {
          input: {
            type: "structure",
            members: {
              SyncName: {},
              Filters: {
                shape: "Sl0"
              },
              Aggregators: {
                shape: "Sl6"
              },
              ResultAttributes: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "TypeName"
                  ],
                  members: {
                    TypeName: {}
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Entities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Data: {
                      type: "map",
                      key: {},
                      value: {
                        type: "structure",
                        members: {
                          CaptureTime: {},
                          Content: {
                            type: "list",
                            member: {
                              type: "map",
                              key: {},
                              value: {}
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetParameter: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              WithDecryption: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Parameter: {
                shape: "Sls"
              }
            }
          }
        },
        GetParameterHistory: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              WithDecryption: {
                type: "boolean"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Parameters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Type: {},
                    KeyId: {},
                    LastModifiedDate: {
                      type: "timestamp"
                    },
                    LastModifiedUser: {},
                    Description: {},
                    Value: {
                      shape: "Slt"
                    },
                    AllowedPattern: {},
                    Version: {
                      type: "long"
                    },
                    Labels: {
                      shape: "Slz"
                    },
                    Tier: {},
                    Policies: {
                      shape: "Sgm"
                    },
                    DataType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetParameters: {
          input: {
            type: "structure",
            required: [
              "Names"
            ],
            members: {
              Names: {
                shape: "S7m"
              },
              WithDecryption: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Parameters: {
                shape: "Sm3"
              },
              InvalidParameters: {
                shape: "S7m"
              }
            }
          }
        },
        GetParametersByPath: {
          input: {
            type: "structure",
            required: [
              "Path"
            ],
            members: {
              Path: {},
              Recursive: {
                type: "boolean"
              },
              ParameterFilters: {
                shape: "Sg7"
              },
              WithDecryption: {
                type: "boolean"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Parameters: {
                shape: "Sm3"
              },
              NextToken: {}
            }
          }
        },
        GetPatchBaseline: {
          input: {
            type: "structure",
            required: [
              "BaselineId"
            ],
            members: {
              BaselineId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BaselineId: {},
              Name: {},
              OperatingSystem: {},
              GlobalFilters: {
                shape: "S5i"
              },
              ApprovalRules: {
                shape: "S5o"
              },
              ApprovedPatches: {
                shape: "S5u"
              },
              ApprovedPatchesComplianceLevel: {},
              ApprovedPatchesEnableNonSecurity: {
                type: "boolean"
              },
              RejectedPatches: {
                shape: "S5u"
              },
              RejectedPatchesAction: {},
              PatchGroups: {
                type: "list",
                member: {}
              },
              CreatedDate: {
                type: "timestamp"
              },
              ModifiedDate: {
                type: "timestamp"
              },
              Description: {},
              Sources: {
                shape: "S5y"
              }
            }
          }
        },
        GetPatchBaselineForPatchGroup: {
          input: {
            type: "structure",
            required: [
              "PatchGroup"
            ],
            members: {
              PatchGroup: {},
              OperatingSystem: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BaselineId: {},
              PatchGroup: {},
              OperatingSystem: {}
            }
          }
        },
        GetResourcePolicies: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Policies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PolicyId: {},
                    PolicyHash: {},
                    Policy: {}
                  }
                }
              }
            }
          }
        },
        GetServiceSetting: {
          input: {
            type: "structure",
            required: [
              "SettingId"
            ],
            members: {
              SettingId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceSetting: {
                shape: "Sml"
              }
            }
          }
        },
        LabelParameterVersion: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Labels"
            ],
            members: {
              Name: {},
              ParameterVersion: {
                type: "long"
              },
              Labels: {
                shape: "Slz"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InvalidLabels: {
                shape: "Slz"
              },
              ParameterVersion: {
                type: "long"
              }
            }
          }
        },
        ListAssociationVersions: {
          input: {
            type: "structure",
            required: [
              "AssociationId"
            ],
            members: {
              AssociationId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AssociationVersions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AssociationId: {},
                    AssociationVersion: {},
                    CreatedDate: {
                      type: "timestamp"
                    },
                    Name: {},
                    DocumentVersion: {},
                    Parameters: {
                      shape: "S14"
                    },
                    Targets: {
                      shape: "S18"
                    },
                    ScheduleExpression: {},
                    OutputLocation: {
                      shape: "S1e"
                    },
                    AssociationName: {},
                    MaxErrors: {},
                    MaxConcurrency: {},
                    ComplianceSeverity: {},
                    SyncCompliance: {},
                    ApplyOnlyAtCronInterval: {
                      type: "boolean"
                    },
                    CalendarNames: {
                      shape: "S1q"
                    },
                    TargetLocations: {
                      shape: "S1s"
                    },
                    ScheduleOffset: {
                      type: "integer"
                    },
                    TargetMaps: {
                      shape: "S25"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListAssociations: {
          input: {
            type: "structure",
            members: {
              AssociationFilterList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "key",
                    "value"
                  ],
                  members: {
                    key: {},
                    value: {}
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Associations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    InstanceId: {},
                    AssociationId: {},
                    AssociationVersion: {},
                    DocumentVersion: {},
                    Targets: {
                      shape: "S18"
                    },
                    LastExecutionDate: {
                      type: "timestamp"
                    },
                    Overview: {
                      shape: "S2i"
                    },
                    ScheduleExpression: {},
                    AssociationName: {},
                    ScheduleOffset: {
                      type: "integer"
                    },
                    TargetMaps: {
                      shape: "S25"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListCommandInvocations: {
          input: {
            type: "structure",
            members: {
              CommandId: {},
              InstanceId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "Sn3"
              },
              Details: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CommandInvocations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CommandId: {},
                    InstanceId: {},
                    InstanceName: {},
                    Comment: {},
                    DocumentName: {},
                    DocumentVersion: {},
                    RequestedDateTime: {
                      type: "timestamp"
                    },
                    Status: {},
                    StatusDetails: {},
                    TraceOutput: {},
                    StandardOutputUrl: {},
                    StandardErrorUrl: {},
                    CommandPlugins: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Name: {},
                          Status: {},
                          StatusDetails: {},
                          ResponseCode: {
                            type: "integer"
                          },
                          ResponseStartDateTime: {
                            type: "timestamp"
                          },
                          ResponseFinishDateTime: {
                            type: "timestamp"
                          },
                          Output: {},
                          StandardOutputUrl: {},
                          StandardErrorUrl: {},
                          OutputS3Region: {},
                          OutputS3BucketName: {},
                          OutputS3KeyPrefix: {}
                        }
                      }
                    },
                    ServiceRole: {},
                    NotificationConfig: {
                      shape: "Skf"
                    },
                    CloudWatchOutputConfig: {
                      shape: "Sid"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListCommands: {
          input: {
            type: "structure",
            members: {
              CommandId: {},
              InstanceId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "Sn3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Commands: {
                type: "list",
                member: {
                  shape: "Snj"
                }
              },
              NextToken: {}
            }
          }
        },
        ListComplianceItems: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Snq"
              },
              ResourceIds: {
                type: "list",
                member: {}
              },
              ResourceTypes: {
                type: "list",
                member: {}
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ComplianceItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ComplianceType: {},
                    ResourceType: {},
                    ResourceId: {},
                    Id: {},
                    Title: {},
                    Status: {},
                    Severity: {},
                    ExecutionSummary: {
                      shape: "So8"
                    },
                    Details: {
                      shape: "Sob"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListComplianceSummaries: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Snq"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ComplianceSummaryItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ComplianceType: {},
                    CompliantSummary: {
                      shape: "Sog"
                    },
                    NonCompliantSummary: {
                      shape: "Soj"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDocumentMetadataHistory: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Metadata"
            ],
            members: {
              Name: {},
              DocumentVersion: {},
              Metadata: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              DocumentVersion: {},
              Author: {},
              Metadata: {
                type: "structure",
                members: {
                  ReviewerResponse: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        CreateTime: {
                          type: "timestamp"
                        },
                        UpdatedTime: {
                          type: "timestamp"
                        },
                        ReviewStatus: {},
                        Comment: {
                          shape: "Soq"
                        },
                        Reviewer: {}
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDocumentVersions: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentVersions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    DisplayName: {},
                    DocumentVersion: {},
                    VersionName: {},
                    CreatedDate: {
                      type: "timestamp"
                    },
                    IsDefaultVersion: {
                      type: "boolean"
                    },
                    DocumentFormat: {},
                    Status: {},
                    StatusInformation: {},
                    ReviewStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDocuments: {
          input: {
            type: "structure",
            members: {
              DocumentFilterList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "key",
                    "value"
                  ],
                  members: {
                    key: {},
                    value: {}
                  }
                }
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Key: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentIdentifiers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    CreatedDate: {
                      type: "timestamp"
                    },
                    DisplayName: {},
                    Owner: {},
                    VersionName: {},
                    PlatformTypes: {
                      shape: "S3v"
                    },
                    DocumentVersion: {},
                    DocumentType: {},
                    SchemaVersion: {},
                    DocumentFormat: {},
                    TargetType: {},
                    Tags: {
                      shape: "S4"
                    },
                    Requires: {
                      shape: "S31"
                    },
                    ReviewStatus: {},
                    Author: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListInventoryEntries: {
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "TypeName"
            ],
            members: {
              InstanceId: {},
              TypeName: {},
              Filters: {
                shape: "Siz"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TypeName: {},
              InstanceId: {},
              SchemaVersion: {},
              CaptureTime: {},
              Entries: {
                shape: "Sjm"
              },
              NextToken: {}
            }
          }
        },
        ListOpsItemEvents: {
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key",
                    "Values",
                    "Operator"
                  ],
                  members: {
                    Key: {},
                    Values: {
                      type: "list",
                      member: {}
                    },
                    Operator: {}
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Summaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    OpsItemId: {},
                    EventId: {},
                    Source: {},
                    DetailType: {},
                    Detail: {},
                    CreatedBy: {
                      shape: "Spo"
                    },
                    CreatedTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListOpsItemRelatedItems: {
          input: {
            type: "structure",
            members: {
              OpsItemId: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key",
                    "Values",
                    "Operator"
                  ],
                  members: {
                    Key: {},
                    Values: {
                      type: "list",
                      member: {}
                    },
                    Operator: {}
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Summaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    OpsItemId: {},
                    AssociationId: {},
                    ResourceType: {},
                    AssociationType: {},
                    ResourceUri: {},
                    CreatedBy: {
                      shape: "Spo"
                    },
                    CreatedTime: {
                      type: "timestamp"
                    },
                    LastModifiedBy: {
                      shape: "Spo"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListOpsMetadata: {
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key",
                    "Values"
                  ],
                  members: {
                    Key: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OpsMetadataList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceId: {},
                    OpsMetadataArn: {},
                    LastModifiedDate: {
                      type: "timestamp"
                    },
                    LastModifiedUser: {},
                    CreationDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListResourceComplianceSummaries: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Snq"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceComplianceSummaryItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ComplianceType: {},
                    ResourceType: {},
                    ResourceId: {},
                    Status: {},
                    OverallSeverity: {},
                    ExecutionSummary: {
                      shape: "So8"
                    },
                    CompliantSummary: {
                      shape: "Sog"
                    },
                    NonCompliantSummary: {
                      shape: "Soj"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListResourceDataSync: {
          input: {
            type: "structure",
            members: {
              SyncType: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceDataSyncItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SyncName: {},
                    SyncType: {},
                    SyncSource: {
                      type: "structure",
                      members: {
                        SourceType: {},
                        AwsOrganizationsSource: {
                          shape: "S6j"
                        },
                        SourceRegions: {
                          shape: "S6o"
                        },
                        IncludeFutureRegions: {
                          type: "boolean"
                        },
                        State: {},
                        EnableAllOpsDataSources: {
                          type: "boolean"
                        }
                      }
                    },
                    S3Destination: {
                      shape: "S68"
                    },
                    LastSyncTime: {
                      type: "timestamp"
                    },
                    LastSuccessfulSyncTime: {
                      type: "timestamp"
                    },
                    SyncLastModifiedTime: {
                      type: "timestamp"
                    },
                    LastStatus: {},
                    SyncCreatedTime: {
                      type: "timestamp"
                    },
                    LastSyncStatusMessage: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceType",
              "ResourceId"
            ],
            members: {
              ResourceType: {},
              ResourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TagList: {
                shape: "S4"
              }
            }
          }
        },
        ModifyDocumentPermission: {
          input: {
            type: "structure",
            required: [
              "Name",
              "PermissionType"
            ],
            members: {
              Name: {},
              PermissionType: {},
              AccountIdsToAdd: {
                shape: "Sbj"
              },
              AccountIdsToRemove: {
                shape: "Sbj"
              },
              SharedDocumentVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutComplianceItems: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "ResourceType",
              "ComplianceType",
              "ExecutionSummary",
              "Items"
            ],
            members: {
              ResourceId: {},
              ResourceType: {},
              ComplianceType: {},
              ExecutionSummary: {
                shape: "So8"
              },
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Severity",
                    "Status"
                  ],
                  members: {
                    Id: {},
                    Title: {},
                    Severity: {},
                    Status: {},
                    Details: {
                      shape: "Sob"
                    }
                  }
                }
              },
              ItemContentHash: {},
              UploadType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutInventory: {
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Items"
            ],
            members: {
              InstanceId: {},
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "TypeName",
                    "SchemaVersion",
                    "CaptureTime"
                  ],
                  members: {
                    TypeName: {},
                    SchemaVersion: {},
                    CaptureTime: {},
                    ContentHash: {},
                    Content: {
                      shape: "Sjm"
                    },
                    Context: {
                      type: "map",
                      key: {},
                      value: {}
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Message: {}
            }
          }
        },
        PutParameter: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Value"
            ],
            members: {
              Name: {},
              Description: {},
              Value: {
                shape: "Slt"
              },
              Type: {},
              KeyId: {},
              Overwrite: {
                type: "boolean"
              },
              AllowedPattern: {},
              Tags: {
                shape: "S4"
              },
              Tier: {},
              Policies: {},
              DataType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Version: {
                type: "long"
              },
              Tier: {}
            }
          }
        },
        PutResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Policy"
            ],
            members: {
              ResourceArn: {},
              Policy: {},
              PolicyId: {},
              PolicyHash: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyId: {},
              PolicyHash: {}
            }
          }
        },
        RegisterDefaultPatchBaseline: {
          input: {
            type: "structure",
            required: [
              "BaselineId"
            ],
            members: {
              BaselineId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BaselineId: {}
            }
          }
        },
        RegisterPatchBaselineForPatchGroup: {
          input: {
            type: "structure",
            required: [
              "BaselineId",
              "PatchGroup"
            ],
            members: {
              BaselineId: {},
              PatchGroup: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BaselineId: {},
              PatchGroup: {}
            }
          }
        },
        RegisterTargetWithMaintenanceWindow: {
          input: {
            type: "structure",
            required: [
              "WindowId",
              "ResourceType",
              "Targets"
            ],
            members: {
              WindowId: {},
              ResourceType: {},
              Targets: {
                shape: "S18"
              },
              OwnerInformation: {
                shape: "Sd1"
              },
              Name: {},
              Description: {
                shape: "S4b"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WindowTargetId: {}
            }
          }
        },
        RegisterTaskWithMaintenanceWindow: {
          input: {
            type: "structure",
            required: [
              "WindowId",
              "TaskArn",
              "TaskType"
            ],
            members: {
              WindowId: {},
              Targets: {
                shape: "S18"
              },
              TaskArn: {},
              ServiceRoleArn: {},
              TaskType: {},
              TaskParameters: {
                shape: "Sf7"
              },
              TaskInvocationParameters: {
                shape: "Skd"
              },
              Priority: {
                type: "integer"
              },
              MaxConcurrency: {},
              MaxErrors: {},
              LoggingInfo: {
                shape: "Sfd"
              },
              Name: {},
              Description: {
                shape: "S4b"
              },
              ClientToken: {
                idempotencyToken: true
              },
              CutoffBehavior: {},
              AlarmConfiguration: {
                shape: "S1z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WindowTaskId: {}
            }
          }
        },
        RemoveTagsFromResource: {
          input: {
            type: "structure",
            required: [
              "ResourceType",
              "ResourceId",
              "TagKeys"
            ],
            members: {
              ResourceType: {},
              ResourceId: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ResetServiceSetting: {
          input: {
            type: "structure",
            required: [
              "SettingId"
            ],
            members: {
              SettingId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceSetting: {
                shape: "Sml"
              }
            }
          }
        },
        ResumeSession: {
          input: {
            type: "structure",
            required: [
              "SessionId"
            ],
            members: {
              SessionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SessionId: {},
              TokenValue: {},
              StreamUrl: {}
            }
          }
        },
        SendAutomationSignal: {
          input: {
            type: "structure",
            required: [
              "AutomationExecutionId",
              "SignalType"
            ],
            members: {
              AutomationExecutionId: {},
              SignalType: {},
              Payload: {
                shape: "S9m"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SendCommand: {
          input: {
            type: "structure",
            required: [
              "DocumentName"
            ],
            members: {
              InstanceIds: {
                shape: "Si"
              },
              Targets: {
                shape: "S18"
              },
              DocumentName: {},
              DocumentVersion: {},
              DocumentHash: {},
              DocumentHashType: {},
              TimeoutSeconds: {
                type: "integer"
              },
              Comment: {},
              Parameters: {
                shape: "S14"
              },
              OutputS3Region: {},
              OutputS3BucketName: {},
              OutputS3KeyPrefix: {},
              MaxConcurrency: {},
              MaxErrors: {},
              ServiceRoleArn: {},
              NotificationConfig: {
                shape: "Skf"
              },
              CloudWatchOutputConfig: {
                shape: "Sid"
              },
              AlarmConfiguration: {
                shape: "S1z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Command: {
                shape: "Snj"
              }
            }
          }
        },
        StartAssociationsOnce: {
          input: {
            type: "structure",
            required: [
              "AssociationIds"
            ],
            members: {
              AssociationIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartAutomationExecution: {
          input: {
            type: "structure",
            required: [
              "DocumentName"
            ],
            members: {
              DocumentName: {},
              DocumentVersion: {},
              Parameters: {
                shape: "S9m"
              },
              ClientToken: {},
              Mode: {},
              TargetParameterName: {},
              Targets: {
                shape: "S18"
              },
              TargetMaps: {
                shape: "S25"
              },
              MaxConcurrency: {},
              MaxErrors: {},
              TargetLocations: {
                shape: "S1s"
              },
              Tags: {
                shape: "S4"
              },
              AlarmConfiguration: {
                shape: "S1z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AutomationExecutionId: {}
            }
          }
        },
        StartChangeRequestExecution: {
          input: {
            type: "structure",
            required: [
              "DocumentName",
              "Runbooks"
            ],
            members: {
              ScheduledTime: {
                type: "timestamp"
              },
              DocumentName: {},
              DocumentVersion: {},
              Parameters: {
                shape: "S9m"
              },
              ChangeRequestName: {},
              ClientToken: {},
              AutoApprove: {
                type: "boolean"
              },
              Runbooks: {
                shape: "S9v"
              },
              Tags: {
                shape: "S4"
              },
              ScheduledEndTime: {
                type: "timestamp"
              },
              ChangeDetails: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AutomationExecutionId: {}
            }
          }
        },
        StartSession: {
          input: {
            type: "structure",
            required: [
              "Target"
            ],
            members: {
              Target: {},
              DocumentName: {},
              Reason: {},
              Parameters: {
                type: "map",
                key: {},
                value: {
                  type: "list",
                  member: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SessionId: {},
              TokenValue: {},
              StreamUrl: {}
            }
          }
        },
        StopAutomationExecution: {
          input: {
            type: "structure",
            required: [
              "AutomationExecutionId"
            ],
            members: {
              AutomationExecutionId: {},
              Type: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TerminateSession: {
          input: {
            type: "structure",
            required: [
              "SessionId"
            ],
            members: {
              SessionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SessionId: {}
            }
          }
        },
        UnlabelParameterVersion: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ParameterVersion",
              "Labels"
            ],
            members: {
              Name: {},
              ParameterVersion: {
                type: "long"
              },
              Labels: {
                shape: "Slz"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RemovedLabels: {
                shape: "Slz"
              },
              InvalidLabels: {
                shape: "Slz"
              }
            }
          }
        },
        UpdateAssociation: {
          input: {
            type: "structure",
            required: [
              "AssociationId"
            ],
            members: {
              AssociationId: {},
              Parameters: {
                shape: "S14"
              },
              DocumentVersion: {},
              ScheduleExpression: {},
              OutputLocation: {
                shape: "S1e"
              },
              Name: {},
              Targets: {
                shape: "S18"
              },
              AssociationName: {},
              AssociationVersion: {},
              AutomationTargetParameterName: {},
              MaxErrors: {},
              MaxConcurrency: {},
              ComplianceSeverity: {},
              SyncCompliance: {},
              ApplyOnlyAtCronInterval: {
                type: "boolean"
              },
              CalendarNames: {
                shape: "S1q"
              },
              TargetLocations: {
                shape: "S1s"
              },
              ScheduleOffset: {
                type: "integer"
              },
              TargetMaps: {
                shape: "S25"
              },
              AlarmConfiguration: {
                shape: "S1z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssociationDescription: {
                shape: "S2b"
              }
            }
          }
        },
        UpdateAssociationStatus: {
          input: {
            type: "structure",
            required: [
              "Name",
              "InstanceId",
              "AssociationStatus"
            ],
            members: {
              Name: {},
              InstanceId: {},
              AssociationStatus: {
                shape: "S2e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssociationDescription: {
                shape: "S2b"
              }
            }
          }
        },
        UpdateDocument: {
          input: {
            type: "structure",
            required: [
              "Content",
              "Name"
            ],
            members: {
              Content: {},
              Attachments: {
                shape: "S35"
              },
              Name: {},
              DisplayName: {},
              VersionName: {},
              DocumentVersion: {},
              DocumentFormat: {},
              TargetType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentDescription: {
                shape: "S3h"
              }
            }
          }
        },
        UpdateDocumentDefaultVersion: {
          input: {
            type: "structure",
            required: [
              "Name",
              "DocumentVersion"
            ],
            members: {
              Name: {},
              DocumentVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Description: {
                type: "structure",
                members: {
                  Name: {},
                  DefaultVersion: {},
                  DefaultVersionName: {}
                }
              }
            }
          }
        },
        UpdateDocumentMetadata: {
          input: {
            type: "structure",
            required: [
              "Name",
              "DocumentReviews"
            ],
            members: {
              Name: {},
              DocumentVersion: {},
              DocumentReviews: {
                type: "structure",
                required: [
                  "Action"
                ],
                members: {
                  Action: {},
                  Comment: {
                    shape: "Soq"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateMaintenanceWindow: {
          input: {
            type: "structure",
            required: [
              "WindowId"
            ],
            members: {
              WindowId: {},
              Name: {},
              Description: {
                shape: "S4b"
              },
              StartDate: {},
              EndDate: {},
              Schedule: {},
              ScheduleTimezone: {},
              ScheduleOffset: {
                type: "integer"
              },
              Duration: {
                type: "integer"
              },
              Cutoff: {
                type: "integer"
              },
              AllowUnassociatedTargets: {
                type: "boolean"
              },
              Enabled: {
                type: "boolean"
              },
              Replace: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WindowId: {},
              Name: {},
              Description: {
                shape: "S4b"
              },
              StartDate: {},
              EndDate: {},
              Schedule: {},
              ScheduleTimezone: {},
              ScheduleOffset: {
                type: "integer"
              },
              Duration: {
                type: "integer"
              },
              Cutoff: {
                type: "integer"
              },
              AllowUnassociatedTargets: {
                type: "boolean"
              },
              Enabled: {
                type: "boolean"
              }
            }
          }
        },
        UpdateMaintenanceWindowTarget: {
          input: {
            type: "structure",
            required: [
              "WindowId",
              "WindowTargetId"
            ],
            members: {
              WindowId: {},
              WindowTargetId: {},
              Targets: {
                shape: "S18"
              },
              OwnerInformation: {
                shape: "Sd1"
              },
              Name: {},
              Description: {
                shape: "S4b"
              },
              Replace: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WindowId: {},
              WindowTargetId: {},
              Targets: {
                shape: "S18"
              },
              OwnerInformation: {
                shape: "Sd1"
              },
              Name: {},
              Description: {
                shape: "S4b"
              }
            }
          }
        },
        UpdateMaintenanceWindowTask: {
          input: {
            type: "structure",
            required: [
              "WindowId",
              "WindowTaskId"
            ],
            members: {
              WindowId: {},
              WindowTaskId: {},
              Targets: {
                shape: "S18"
              },
              TaskArn: {},
              ServiceRoleArn: {},
              TaskParameters: {
                shape: "Sf7"
              },
              TaskInvocationParameters: {
                shape: "Skd"
              },
              Priority: {
                type: "integer"
              },
              MaxConcurrency: {},
              MaxErrors: {},
              LoggingInfo: {
                shape: "Sfd"
              },
              Name: {},
              Description: {
                shape: "S4b"
              },
              Replace: {
                type: "boolean"
              },
              CutoffBehavior: {},
              AlarmConfiguration: {
                shape: "S1z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WindowId: {},
              WindowTaskId: {},
              Targets: {
                shape: "S18"
              },
              TaskArn: {},
              ServiceRoleArn: {},
              TaskParameters: {
                shape: "Sf7"
              },
              TaskInvocationParameters: {
                shape: "Skd"
              },
              Priority: {
                type: "integer"
              },
              MaxConcurrency: {},
              MaxErrors: {},
              LoggingInfo: {
                shape: "Sfd"
              },
              Name: {},
              Description: {
                shape: "S4b"
              },
              CutoffBehavior: {},
              AlarmConfiguration: {
                shape: "S1z"
              }
            }
          }
        },
        UpdateManagedInstanceRole: {
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "IamRole"
            ],
            members: {
              InstanceId: {},
              IamRole: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateOpsItem: {
          input: {
            type: "structure",
            required: [
              "OpsItemId"
            ],
            members: {
              Description: {},
              OperationalData: {
                shape: "S4p"
              },
              OperationalDataToDelete: {
                type: "list",
                member: {}
              },
              Notifications: {
                shape: "S4u"
              },
              Priority: {
                type: "integer"
              },
              RelatedOpsItems: {
                shape: "S4y"
              },
              Status: {},
              OpsItemId: {},
              Title: {},
              Category: {},
              Severity: {},
              ActualStartTime: {
                type: "timestamp"
              },
              ActualEndTime: {
                type: "timestamp"
              },
              PlannedStartTime: {
                type: "timestamp"
              },
              PlannedEndTime: {
                type: "timestamp"
              },
              OpsItemArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateOpsMetadata: {
          input: {
            type: "structure",
            required: [
              "OpsMetadataArn"
            ],
            members: {
              OpsMetadataArn: {},
              MetadataToUpdate: {
                shape: "S59"
              },
              KeysToDelete: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OpsMetadataArn: {}
            }
          }
        },
        UpdatePatchBaseline: {
          input: {
            type: "structure",
            required: [
              "BaselineId"
            ],
            members: {
              BaselineId: {},
              Name: {},
              GlobalFilters: {
                shape: "S5i"
              },
              ApprovalRules: {
                shape: "S5o"
              },
              ApprovedPatches: {
                shape: "S5u"
              },
              ApprovedPatchesComplianceLevel: {},
              ApprovedPatchesEnableNonSecurity: {
                type: "boolean"
              },
              RejectedPatches: {
                shape: "S5u"
              },
              RejectedPatchesAction: {},
              Description: {},
              Sources: {
                shape: "S5y"
              },
              Replace: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BaselineId: {},
              Name: {},
              OperatingSystem: {},
              GlobalFilters: {
                shape: "S5i"
              },
              ApprovalRules: {
                shape: "S5o"
              },
              ApprovedPatches: {
                shape: "S5u"
              },
              ApprovedPatchesComplianceLevel: {},
              ApprovedPatchesEnableNonSecurity: {
                type: "boolean"
              },
              RejectedPatches: {
                shape: "S5u"
              },
              RejectedPatchesAction: {},
              CreatedDate: {
                type: "timestamp"
              },
              ModifiedDate: {
                type: "timestamp"
              },
              Description: {},
              Sources: {
                shape: "S5y"
              }
            }
          }
        },
        UpdateResourceDataSync: {
          input: {
            type: "structure",
            required: [
              "SyncName",
              "SyncType",
              "SyncSource"
            ],
            members: {
              SyncName: {},
              SyncType: {},
              SyncSource: {
                shape: "S6h"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateServiceSetting: {
          input: {
            type: "structure",
            required: [
              "SettingId",
              "SettingValue"
            ],
            members: {
              SettingId: {},
              SettingValue: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S4: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Si: {
          type: "list",
          member: {}
        },
        S14: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {}
          },
          sensitive: true
        },
        S18: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Values: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S1e: {
          type: "structure",
          members: {
            S3Location: {
              type: "structure",
              members: {
                OutputS3Region: {},
                OutputS3BucketName: {},
                OutputS3KeyPrefix: {}
              }
            }
          }
        },
        S1q: {
          type: "list",
          member: {}
        },
        S1s: {
          type: "list",
          member: {
            shape: "S1t"
          }
        },
        S1t: {
          type: "structure",
          members: {
            Accounts: {
              type: "list",
              member: {}
            },
            Regions: {
              type: "list",
              member: {}
            },
            TargetLocationMaxConcurrency: {},
            TargetLocationMaxErrors: {},
            ExecutionRoleName: {},
            TargetLocationAlarmConfiguration: {
              shape: "S1z"
            }
          }
        },
        S1z: {
          type: "structure",
          required: [
            "Alarms"
          ],
          members: {
            IgnorePollAlarmFailure: {
              type: "boolean"
            },
            Alarms: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name"
                ],
                members: {
                  Name: {}
                }
              }
            }
          }
        },
        S25: {
          type: "list",
          member: {
            type: "map",
            key: {},
            value: {
              type: "list",
              member: {}
            }
          }
        },
        S2b: {
          type: "structure",
          members: {
            Name: {},
            InstanceId: {},
            AssociationVersion: {},
            Date: {
              type: "timestamp"
            },
            LastUpdateAssociationDate: {
              type: "timestamp"
            },
            Status: {
              shape: "S2e"
            },
            Overview: {
              shape: "S2i"
            },
            DocumentVersion: {},
            AutomationTargetParameterName: {},
            Parameters: {
              shape: "S14"
            },
            AssociationId: {},
            Targets: {
              shape: "S18"
            },
            ScheduleExpression: {},
            OutputLocation: {
              shape: "S1e"
            },
            LastExecutionDate: {
              type: "timestamp"
            },
            LastSuccessfulExecutionDate: {
              type: "timestamp"
            },
            AssociationName: {},
            MaxErrors: {},
            MaxConcurrency: {},
            ComplianceSeverity: {},
            SyncCompliance: {},
            ApplyOnlyAtCronInterval: {
              type: "boolean"
            },
            CalendarNames: {
              shape: "S1q"
            },
            TargetLocations: {
              shape: "S1s"
            },
            ScheduleOffset: {
              type: "integer"
            },
            TargetMaps: {
              shape: "S25"
            },
            AlarmConfiguration: {
              shape: "S1z"
            },
            TriggeredAlarms: {
              shape: "S2n"
            }
          }
        },
        S2e: {
          type: "structure",
          required: [
            "Date",
            "Name",
            "Message"
          ],
          members: {
            Date: {
              type: "timestamp"
            },
            Name: {},
            Message: {},
            AdditionalInfo: {}
          }
        },
        S2i: {
          type: "structure",
          members: {
            Status: {},
            DetailedStatus: {},
            AssociationStatusAggregatedCount: {
              type: "map",
              key: {},
              value: {
                type: "integer"
              }
            }
          }
        },
        S2n: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "State"
            ],
            members: {
              Name: {},
              State: {}
            }
          }
        },
        S2s: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            InstanceId: {},
            Parameters: {
              shape: "S14"
            },
            AutomationTargetParameterName: {},
            DocumentVersion: {},
            Targets: {
              shape: "S18"
            },
            ScheduleExpression: {},
            OutputLocation: {
              shape: "S1e"
            },
            AssociationName: {},
            MaxErrors: {},
            MaxConcurrency: {},
            ComplianceSeverity: {},
            SyncCompliance: {},
            ApplyOnlyAtCronInterval: {
              type: "boolean"
            },
            CalendarNames: {
              shape: "S1q"
            },
            TargetLocations: {
              shape: "S1s"
            },
            ScheduleOffset: {
              type: "integer"
            },
            TargetMaps: {
              shape: "S25"
            },
            AlarmConfiguration: {
              shape: "S1z"
            }
          }
        },
        S31: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Version: {},
              RequireType: {},
              VersionName: {}
            }
          }
        },
        S35: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Values: {
                type: "list",
                member: {}
              },
              Name: {}
            }
          }
        },
        S3h: {
          type: "structure",
          members: {
            Sha1: {},
            Hash: {},
            HashType: {},
            Name: {},
            DisplayName: {},
            VersionName: {},
            Owner: {},
            CreatedDate: {
              type: "timestamp"
            },
            Status: {},
            StatusInformation: {},
            DocumentVersion: {},
            Description: {},
            Parameters: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Name: {},
                  Type: {},
                  Description: {},
                  DefaultValue: {}
                }
              }
            },
            PlatformTypes: {
              shape: "S3v"
            },
            DocumentType: {},
            SchemaVersion: {},
            LatestVersion: {},
            DefaultVersion: {},
            DocumentFormat: {},
            TargetType: {},
            Tags: {
              shape: "S4"
            },
            AttachmentsInformation: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Name: {}
                }
              }
            },
            Requires: {
              shape: "S31"
            },
            Author: {},
            ReviewInformation: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  ReviewedTime: {
                    type: "timestamp"
                  },
                  Status: {},
                  Reviewer: {}
                }
              }
            },
            ApprovedVersion: {},
            PendingReviewVersion: {},
            ReviewStatus: {},
            Category: {
              type: "list",
              member: {}
            },
            CategoryEnum: {
              type: "list",
              member: {}
            }
          }
        },
        S3v: {
          type: "list",
          member: {}
        },
        S4b: {
          type: "string",
          sensitive: true
        },
        S4p: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              Value: {},
              Type: {}
            }
          }
        },
        S4u: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Arn: {}
            }
          }
        },
        S4y: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "OpsItemId"
            ],
            members: {
              OpsItemId: {}
            }
          }
        },
        S59: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              Value: {}
            }
          }
        },
        S5i: {
          type: "structure",
          required: [
            "PatchFilters"
          ],
          members: {
            PatchFilters: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Key",
                  "Values"
                ],
                members: {
                  Key: {},
                  Values: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          }
        },
        S5o: {
          type: "structure",
          required: [
            "PatchRules"
          ],
          members: {
            PatchRules: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "PatchFilterGroup"
                ],
                members: {
                  PatchFilterGroup: {
                    shape: "S5i"
                  },
                  ComplianceLevel: {},
                  ApproveAfterDays: {
                    type: "integer"
                  },
                  ApproveUntilDate: {},
                  EnableNonSecurity: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        S5u: {
          type: "list",
          member: {}
        },
        S5y: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Products",
              "Configuration"
            ],
            members: {
              Name: {},
              Products: {
                type: "list",
                member: {}
              },
              Configuration: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        S68: {
          type: "structure",
          required: [
            "BucketName",
            "SyncFormat",
            "Region"
          ],
          members: {
            BucketName: {},
            Prefix: {},
            SyncFormat: {},
            Region: {},
            AWSKMSKeyARN: {},
            DestinationDataSharing: {
              type: "structure",
              members: {
                DestinationDataSharingType: {}
              }
            }
          }
        },
        S6h: {
          type: "structure",
          required: [
            "SourceType",
            "SourceRegions"
          ],
          members: {
            SourceType: {},
            AwsOrganizationsSource: {
              shape: "S6j"
            },
            SourceRegions: {
              shape: "S6o"
            },
            IncludeFutureRegions: {
              type: "boolean"
            },
            EnableAllOpsDataSources: {
              type: "boolean"
            }
          }
        },
        S6j: {
          type: "structure",
          required: [
            "OrganizationSourceType"
          ],
          members: {
            OrganizationSourceType: {},
            OrganizationalUnits: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  OrganizationalUnitId: {}
                }
              }
            }
          }
        },
        S6o: {
          type: "list",
          member: {}
        },
        S75: {
          type: "structure",
          members: {
            TotalCount: {
              type: "integer"
            },
            RemainingCount: {
              type: "integer"
            },
            SummaryItems: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Version: {},
                  Count: {
                    type: "integer"
                  },
                  RemainingCount: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        S7m: {
          type: "list",
          member: {}
        },
        S9m: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {}
          }
        },
        S9r: {
          type: "structure",
          members: {
            ParameterValues: {
              type: "list",
              member: {}
            },
            Truncated: {
              type: "boolean"
            }
          }
        },
        S9v: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "DocumentName"
            ],
            members: {
              DocumentName: {},
              DocumentVersion: {},
              Parameters: {
                shape: "S9m"
              },
              TargetParameterName: {},
              Targets: {
                shape: "S18"
              },
              TargetMaps: {
                shape: "S25"
              },
              MaxConcurrency: {},
              MaxErrors: {},
              TargetLocations: {
                shape: "S1s"
              }
            }
          }
        },
        Sa5: {
          type: "list",
          member: {
            type: "structure",
            members: {
              StepName: {},
              Action: {},
              TimeoutSeconds: {
                type: "long"
              },
              OnFailure: {},
              MaxAttempts: {
                type: "integer"
              },
              ExecutionStartTime: {
                type: "timestamp"
              },
              ExecutionEndTime: {
                type: "timestamp"
              },
              StepStatus: {},
              ResponseCode: {},
              Inputs: {
                type: "map",
                key: {},
                value: {}
              },
              Outputs: {
                shape: "S9m"
              },
              Response: {},
              FailureMessage: {},
              FailureDetails: {
                type: "structure",
                members: {
                  FailureStage: {},
                  FailureType: {},
                  Details: {
                    shape: "S9m"
                  }
                }
              },
              StepExecutionId: {},
              OverriddenParameters: {
                shape: "S9m"
              },
              IsEnd: {
                type: "boolean"
              },
              NextStep: {},
              IsCritical: {
                type: "boolean"
              },
              ValidNextSteps: {
                type: "list",
                member: {}
              },
              Targets: {
                shape: "S18"
              },
              TargetLocation: {
                shape: "S1t"
              },
              TriggeredAlarms: {
                shape: "S2n"
              },
              ParentStepDetails: {
                type: "structure",
                members: {
                  StepExecutionId: {},
                  StepName: {},
                  Action: {},
                  Iteration: {
                    type: "integer"
                  },
                  IteratorValue: {}
                }
              }
            }
          }
        },
        Sag: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Values: {
                type: "list",
                member: {}
              }
            }
          }
        },
        Sao: {
          type: "structure",
          members: {
            Id: {},
            ReleaseDate: {
              type: "timestamp"
            },
            Title: {},
            Description: {},
            ContentUrl: {},
            Vendor: {},
            ProductFamily: {},
            Product: {},
            Classification: {},
            MsrcSeverity: {},
            KbNumber: {},
            MsrcNumber: {},
            Language: {},
            AdvisoryIds: {
              type: "list",
              member: {}
            },
            BugzillaIds: {
              type: "list",
              member: {}
            },
            CVEIds: {
              type: "list",
              member: {}
            },
            Name: {},
            Epoch: {
              type: "integer"
            },
            Version: {},
            Release: {},
            Arch: {},
            Severity: {},
            Repository: {}
          }
        },
        Sbj: {
          type: "list",
          member: {}
        },
        Scc: {
          type: "list",
          member: {}
        },
        Scy: {
          type: "structure",
          required: [
            "InstanceId",
            "PatchGroup",
            "BaselineId",
            "OperationStartTime",
            "OperationEndTime",
            "Operation"
          ],
          members: {
            InstanceId: {},
            PatchGroup: {},
            BaselineId: {},
            SnapshotId: {},
            InstallOverrideList: {},
            OwnerInformation: {
              shape: "Sd1"
            },
            InstalledCount: {
              type: "integer"
            },
            InstalledOtherCount: {
              type: "integer"
            },
            InstalledPendingRebootCount: {
              type: "integer"
            },
            InstalledRejectedCount: {
              type: "integer"
            },
            MissingCount: {
              type: "integer"
            },
            FailedCount: {
              type: "integer"
            },
            UnreportedNotApplicableCount: {
              type: "integer"
            },
            NotApplicableCount: {
              type: "integer"
            },
            OperationStartTime: {
              type: "timestamp"
            },
            OperationEndTime: {
              type: "timestamp"
            },
            Operation: {},
            LastNoRebootInstallOperationTime: {
              type: "timestamp"
            },
            RebootOption: {},
            CriticalNonCompliantCount: {
              type: "integer"
            },
            SecurityNonCompliantCount: {
              type: "integer"
            },
            OtherNonCompliantCount: {
              type: "integer"
            }
          }
        },
        Sd1: {
          type: "string",
          sensitive: true
        },
        Se4: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Values: {
                type: "list",
                member: {}
              }
            }
          }
        },
        Seg: {
          type: "string",
          sensitive: true
        },
        Sf7: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              Values: {
                type: "list",
                member: {
                  type: "string",
                  sensitive: true
                },
                sensitive: true
              }
            },
            sensitive: true
          },
          sensitive: true
        },
        Sfd: {
          type: "structure",
          required: [
            "S3BucketName",
            "S3Region"
          ],
          members: {
            S3BucketName: {},
            S3KeyPrefix: {},
            S3Region: {}
          }
        },
        Sg7: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {},
              Option: {},
              Values: {
                type: "list",
                member: {}
              }
            }
          }
        },
        Sgm: {
          type: "list",
          member: {
            type: "structure",
            members: {
              PolicyText: {},
              PolicyType: {},
              PolicyStatus: {}
            }
          }
        },
        Sgs: {
          type: "structure",
          members: {
            BaselineId: {},
            BaselineName: {},
            OperatingSystem: {},
            BaselineDescription: {},
            DefaultBaseline: {
              type: "boolean"
            }
          }
        },
        Sid: {
          type: "structure",
          members: {
            CloudWatchLogGroupName: {},
            CloudWatchOutputEnabled: {
              type: "boolean"
            }
          }
        },
        Siz: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Values"
            ],
            members: {
              Key: {},
              Values: {
                type: "list",
                member: {}
              },
              Type: {}
            }
          }
        },
        Sj5: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Expression: {},
              Aggregators: {
                shape: "Sj5"
              },
              Groups: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Filters"
                  ],
                  members: {
                    Name: {},
                    Filters: {
                      shape: "Siz"
                    }
                  }
                }
              }
            }
          }
        },
        Sjm: {
          type: "list",
          member: {
            type: "map",
            key: {},
            value: {}
          }
        },
        Skd: {
          type: "structure",
          members: {
            RunCommand: {
              type: "structure",
              members: {
                Comment: {},
                CloudWatchOutputConfig: {
                  shape: "Sid"
                },
                DocumentHash: {},
                DocumentHashType: {},
                DocumentVersion: {},
                NotificationConfig: {
                  shape: "Skf"
                },
                OutputS3BucketName: {},
                OutputS3KeyPrefix: {},
                Parameters: {
                  shape: "S14"
                },
                ServiceRoleArn: {},
                TimeoutSeconds: {
                  type: "integer"
                }
              }
            },
            Automation: {
              type: "structure",
              members: {
                DocumentVersion: {},
                Parameters: {
                  shape: "S9m"
                }
              }
            },
            StepFunctions: {
              type: "structure",
              members: {
                Input: {
                  type: "string",
                  sensitive: true
                },
                Name: {}
              }
            },
            Lambda: {
              type: "structure",
              members: {
                ClientContext: {},
                Qualifier: {},
                Payload: {
                  type: "blob",
                  sensitive: true
                }
              }
            }
          }
        },
        Skf: {
          type: "structure",
          members: {
            NotificationArn: {},
            NotificationEvents: {
              type: "list",
              member: {}
            },
            NotificationType: {}
          }
        },
        Sl0: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Values"
            ],
            members: {
              Key: {},
              Values: {
                type: "list",
                member: {}
              },
              Type: {}
            }
          }
        },
        Sl6: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AggregatorType: {},
              TypeName: {},
              AttributeName: {},
              Values: {
                type: "map",
                key: {},
                value: {}
              },
              Filters: {
                shape: "Sl0"
              },
              Aggregators: {
                shape: "Sl6"
              }
            }
          }
        },
        Sls: {
          type: "structure",
          members: {
            Name: {},
            Type: {},
            Value: {
              shape: "Slt"
            },
            Version: {
              type: "long"
            },
            Selector: {},
            SourceResult: {},
            LastModifiedDate: {
              type: "timestamp"
            },
            ARN: {},
            DataType: {}
          }
        },
        Slt: {
          type: "string",
          sensitive: true
        },
        Slz: {
          type: "list",
          member: {}
        },
        Sm3: {
          type: "list",
          member: {
            shape: "Sls"
          }
        },
        Sml: {
          type: "structure",
          members: {
            SettingId: {},
            SettingValue: {},
            LastModifiedDate: {
              type: "timestamp"
            },
            LastModifiedUser: {},
            ARN: {},
            Status: {}
          }
        },
        Sn3: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        Snj: {
          type: "structure",
          members: {
            CommandId: {},
            DocumentName: {},
            DocumentVersion: {},
            Comment: {},
            ExpiresAfter: {
              type: "timestamp"
            },
            Parameters: {
              shape: "S14"
            },
            InstanceIds: {
              shape: "Si"
            },
            Targets: {
              shape: "S18"
            },
            RequestedDateTime: {
              type: "timestamp"
            },
            Status: {},
            StatusDetails: {},
            OutputS3Region: {},
            OutputS3BucketName: {},
            OutputS3KeyPrefix: {},
            MaxConcurrency: {},
            MaxErrors: {},
            TargetCount: {
              type: "integer"
            },
            CompletedCount: {
              type: "integer"
            },
            ErrorCount: {
              type: "integer"
            },
            DeliveryTimedOutCount: {
              type: "integer"
            },
            ServiceRole: {},
            NotificationConfig: {
              shape: "Skf"
            },
            CloudWatchOutputConfig: {
              shape: "Sid"
            },
            TimeoutSeconds: {
              type: "integer"
            },
            AlarmConfiguration: {
              shape: "S1z"
            },
            TriggeredAlarms: {
              shape: "S2n"
            }
          }
        },
        Snq: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Values: {
                type: "list",
                member: {}
              },
              Type: {}
            }
          }
        },
        So8: {
          type: "structure",
          required: [
            "ExecutionTime"
          ],
          members: {
            ExecutionTime: {
              type: "timestamp"
            },
            ExecutionId: {},
            ExecutionType: {}
          }
        },
        Sob: {
          type: "map",
          key: {},
          value: {}
        },
        Sog: {
          type: "structure",
          members: {
            CompliantCount: {
              type: "integer"
            },
            SeveritySummary: {
              shape: "Soi"
            }
          }
        },
        Soi: {
          type: "structure",
          members: {
            CriticalCount: {
              type: "integer"
            },
            HighCount: {
              type: "integer"
            },
            MediumCount: {
              type: "integer"
            },
            LowCount: {
              type: "integer"
            },
            InformationalCount: {
              type: "integer"
            },
            UnspecifiedCount: {
              type: "integer"
            }
          }
        },
        Soj: {
          type: "structure",
          members: {
            NonCompliantCount: {
              type: "integer"
            },
            SeveritySummary: {
              shape: "Soi"
            }
          }
        },
        Soq: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Type: {},
              Content: {}
            }
          }
        },
        Spo: {
          type: "structure",
          members: {
            Arn: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ssm-2014-11-06.paginators.json
var require_ssm_2014_11_06_paginators = __commonJS({
  "node_modules/aws-sdk/apis/ssm-2014-11-06.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeActivations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ActivationList"
        },
        DescribeAssociationExecutionTargets: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "AssociationExecutionTargets"
        },
        DescribeAssociationExecutions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "AssociationExecutions"
        },
        DescribeAutomationExecutions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "AutomationExecutionMetadataList"
        },
        DescribeAutomationStepExecutions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "StepExecutions"
        },
        DescribeAvailablePatches: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Patches"
        },
        DescribeEffectiveInstanceAssociations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Associations"
        },
        DescribeEffectivePatchesForPatchBaseline: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "EffectivePatches"
        },
        DescribeInstanceAssociationsStatus: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "InstanceAssociationStatusInfos"
        },
        DescribeInstanceInformation: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "InstanceInformationList"
        },
        DescribeInstancePatchStates: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "InstancePatchStates"
        },
        DescribeInstancePatchStatesForPatchGroup: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "InstancePatchStates"
        },
        DescribeInstancePatches: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Patches"
        },
        DescribeInventoryDeletions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "InventoryDeletions"
        },
        DescribeMaintenanceWindowExecutionTaskInvocations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "WindowExecutionTaskInvocationIdentities"
        },
        DescribeMaintenanceWindowExecutionTasks: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "WindowExecutionTaskIdentities"
        },
        DescribeMaintenanceWindowExecutions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "WindowExecutions"
        },
        DescribeMaintenanceWindowSchedule: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ScheduledWindowExecutions"
        },
        DescribeMaintenanceWindowTargets: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Targets"
        },
        DescribeMaintenanceWindowTasks: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Tasks"
        },
        DescribeMaintenanceWindows: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "WindowIdentities"
        },
        DescribeMaintenanceWindowsForTarget: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "WindowIdentities"
        },
        DescribeOpsItems: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "OpsItemSummaries"
        },
        DescribeParameters: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        DescribePatchBaselines: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "BaselineIdentities"
        },
        DescribePatchGroups: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Mappings"
        },
        DescribePatchProperties: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Properties"
        },
        DescribeSessions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Sessions"
        },
        GetInventory: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Entities"
        },
        GetInventorySchema: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Schemas"
        },
        GetOpsSummary: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Entities"
        },
        GetParameterHistory: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetParametersByPath: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetResourcePolicies: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Policies"
        },
        ListAssociationVersions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "AssociationVersions"
        },
        ListAssociations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Associations"
        },
        ListCommandInvocations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "CommandInvocations"
        },
        ListCommands: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Commands"
        },
        ListComplianceItems: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ComplianceItems"
        },
        ListComplianceSummaries: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ComplianceSummaryItems"
        },
        ListDocumentVersions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "DocumentVersions"
        },
        ListDocuments: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "DocumentIdentifiers"
        },
        ListOpsItemEvents: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Summaries"
        },
        ListOpsItemRelatedItems: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Summaries"
        },
        ListOpsMetadata: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "OpsMetadataList"
        },
        ListResourceComplianceSummaries: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ResourceComplianceSummaryItems"
        },
        ListResourceDataSync: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ResourceDataSyncItems"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ssm-2014-11-06.waiters2.json
var require_ssm_2014_11_06_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/ssm-2014-11-06.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        CommandExecuted: {
          delay: 5,
          operation: "GetCommandInvocation",
          maxAttempts: 20,
          acceptors: [
            {
              expected: "Pending",
              matcher: "path",
              state: "retry",
              argument: "Status"
            },
            {
              expected: "InProgress",
              matcher: "path",
              state: "retry",
              argument: "Status"
            },
            {
              expected: "Delayed",
              matcher: "path",
              state: "retry",
              argument: "Status"
            },
            {
              expected: "Success",
              matcher: "path",
              state: "success",
              argument: "Status"
            },
            {
              expected: "Cancelled",
              matcher: "path",
              state: "failure",
              argument: "Status"
            },
            {
              expected: "TimedOut",
              matcher: "path",
              state: "failure",
              argument: "Status"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "Status"
            },
            {
              expected: "Cancelling",
              matcher: "path",
              state: "failure",
              argument: "Status"
            },
            {
              state: "retry",
              matcher: "error",
              expected: "InvocationDoesNotExist"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/ssm.js
var require_ssm = __commonJS({
  "node_modules/aws-sdk/clients/ssm.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["ssm"] = {};
    AWS2.SSM = Service.defineService("ssm", ["2014-11-06"]);
    Object.defineProperty(apiLoader.services["ssm"], "2014-11-06", {
      get: function get() {
        var model = require_ssm_2014_11_06_min();
        model.paginators = require_ssm_2014_11_06_paginators().pagination;
        model.waiters = require_ssm_2014_11_06_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.SSM;
  }
});

// node_modules/aws-sdk/apis/storagegateway-2013-06-30.min.json
var require_storagegateway_2013_06_30_min = __commonJS({
  "node_modules/aws-sdk/apis/storagegateway-2013-06-30.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2013-06-30",
        endpointPrefix: "storagegateway",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Storage Gateway",
        serviceId: "Storage Gateway",
        signatureVersion: "v4",
        targetPrefix: "StorageGateway_20130630",
        uid: "storagegateway-2013-06-30"
      },
      operations: {
        ActivateGateway: {
          input: {
            type: "structure",
            required: [
              "ActivationKey",
              "GatewayName",
              "GatewayTimezone",
              "GatewayRegion"
            ],
            members: {
              ActivationKey: {},
              GatewayName: {},
              GatewayTimezone: {},
              GatewayRegion: {},
              GatewayType: {},
              TapeDriveType: {},
              MediumChangerType: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        AddCache: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "DiskIds"
            ],
            members: {
              GatewayARN: {},
              DiskIds: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        AddTagsToResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceARN: {}
            }
          }
        },
        AddUploadBuffer: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "DiskIds"
            ],
            members: {
              GatewayARN: {},
              DiskIds: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        AddWorkingStorage: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "DiskIds"
            ],
            members: {
              GatewayARN: {},
              DiskIds: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        AssignTapePool: {
          input: {
            type: "structure",
            required: [
              "TapeARN",
              "PoolId"
            ],
            members: {
              TapeARN: {},
              PoolId: {},
              BypassGovernanceRetention: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TapeARN: {}
            }
          }
        },
        AssociateFileSystem: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "Password",
              "ClientToken",
              "GatewayARN",
              "LocationARN"
            ],
            members: {
              UserName: {},
              Password: {
                shape: "Sx"
              },
              ClientToken: {},
              GatewayARN: {},
              LocationARN: {},
              Tags: {
                shape: "S9"
              },
              AuditDestinationARN: {},
              CacheAttributes: {
                shape: "S11"
              },
              EndpointNetworkConfiguration: {
                shape: "S13"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FileSystemAssociationARN: {}
            }
          }
        },
        AttachVolume: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "VolumeARN",
              "NetworkInterfaceId"
            ],
            members: {
              GatewayARN: {},
              TargetName: {},
              VolumeARN: {},
              NetworkInterfaceId: {},
              DiskId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VolumeARN: {},
              TargetARN: {}
            }
          }
        },
        CancelArchival: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "TapeARN"
            ],
            members: {
              GatewayARN: {},
              TapeARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TapeARN: {}
            }
          }
        },
        CancelRetrieval: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "TapeARN"
            ],
            members: {
              GatewayARN: {},
              TapeARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TapeARN: {}
            }
          }
        },
        CreateCachediSCSIVolume: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "VolumeSizeInBytes",
              "TargetName",
              "NetworkInterfaceId",
              "ClientToken"
            ],
            members: {
              GatewayARN: {},
              VolumeSizeInBytes: {
                type: "long"
              },
              SnapshotId: {},
              TargetName: {},
              SourceVolumeARN: {},
              NetworkInterfaceId: {},
              ClientToken: {},
              KMSEncrypted: {
                type: "boolean"
              },
              KMSKey: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VolumeARN: {},
              TargetARN: {}
            }
          }
        },
        CreateNFSFileShare: {
          input: {
            type: "structure",
            required: [
              "ClientToken",
              "GatewayARN",
              "Role",
              "LocationARN"
            ],
            members: {
              ClientToken: {},
              NFSFileShareDefaults: {
                shape: "S1p"
              },
              GatewayARN: {},
              KMSEncrypted: {
                type: "boolean"
              },
              KMSKey: {},
              Role: {},
              LocationARN: {},
              DefaultStorageClass: {},
              ObjectACL: {},
              ClientList: {
                shape: "S1w"
              },
              Squash: {},
              ReadOnly: {
                type: "boolean"
              },
              GuessMIMETypeEnabled: {
                type: "boolean"
              },
              RequesterPays: {
                type: "boolean"
              },
              Tags: {
                shape: "S9"
              },
              FileShareName: {},
              CacheAttributes: {
                shape: "S11"
              },
              NotificationPolicy: {},
              VPCEndpointDNSName: {},
              BucketRegion: {},
              AuditDestinationARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FileShareARN: {}
            }
          }
        },
        CreateSMBFileShare: {
          input: {
            type: "structure",
            required: [
              "ClientToken",
              "GatewayARN",
              "Role",
              "LocationARN"
            ],
            members: {
              ClientToken: {},
              GatewayARN: {},
              KMSEncrypted: {
                type: "boolean"
              },
              KMSKey: {},
              Role: {},
              LocationARN: {},
              DefaultStorageClass: {},
              ObjectACL: {},
              ReadOnly: {
                type: "boolean"
              },
              GuessMIMETypeEnabled: {
                type: "boolean"
              },
              RequesterPays: {
                type: "boolean"
              },
              SMBACLEnabled: {
                type: "boolean"
              },
              AccessBasedEnumeration: {
                type: "boolean"
              },
              AdminUserList: {
                shape: "S25"
              },
              ValidUserList: {
                shape: "S25"
              },
              InvalidUserList: {
                shape: "S25"
              },
              AuditDestinationARN: {},
              Authentication: {},
              CaseSensitivity: {},
              Tags: {
                shape: "S9"
              },
              FileShareName: {},
              CacheAttributes: {
                shape: "S11"
              },
              NotificationPolicy: {},
              VPCEndpointDNSName: {},
              BucketRegion: {},
              OplocksEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FileShareARN: {}
            }
          }
        },
        CreateSnapshot: {
          input: {
            type: "structure",
            required: [
              "VolumeARN",
              "SnapshotDescription"
            ],
            members: {
              VolumeARN: {},
              SnapshotDescription: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VolumeARN: {},
              SnapshotId: {}
            }
          }
        },
        CreateSnapshotFromVolumeRecoveryPoint: {
          input: {
            type: "structure",
            required: [
              "VolumeARN",
              "SnapshotDescription"
            ],
            members: {
              VolumeARN: {},
              SnapshotDescription: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SnapshotId: {},
              VolumeARN: {},
              VolumeRecoveryPointTime: {}
            }
          }
        },
        CreateStorediSCSIVolume: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "DiskId",
              "PreserveExistingData",
              "TargetName",
              "NetworkInterfaceId"
            ],
            members: {
              GatewayARN: {},
              DiskId: {},
              SnapshotId: {},
              PreserveExistingData: {
                type: "boolean"
              },
              TargetName: {},
              NetworkInterfaceId: {},
              KMSEncrypted: {
                type: "boolean"
              },
              KMSKey: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VolumeARN: {},
              VolumeSizeInBytes: {
                type: "long"
              },
              TargetARN: {}
            }
          }
        },
        CreateTapePool: {
          input: {
            type: "structure",
            required: [
              "PoolName",
              "StorageClass"
            ],
            members: {
              PoolName: {},
              StorageClass: {},
              RetentionLockType: {},
              RetentionLockTimeInDays: {
                type: "integer"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PoolARN: {}
            }
          }
        },
        CreateTapeWithBarcode: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "TapeSizeInBytes",
              "TapeBarcode"
            ],
            members: {
              GatewayARN: {},
              TapeSizeInBytes: {
                type: "long"
              },
              TapeBarcode: {},
              KMSEncrypted: {
                type: "boolean"
              },
              KMSKey: {},
              PoolId: {},
              Worm: {
                type: "boolean"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TapeARN: {}
            }
          }
        },
        CreateTapes: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "TapeSizeInBytes",
              "ClientToken",
              "NumTapesToCreate",
              "TapeBarcodePrefix"
            ],
            members: {
              GatewayARN: {},
              TapeSizeInBytes: {
                type: "long"
              },
              ClientToken: {},
              NumTapesToCreate: {
                type: "integer"
              },
              TapeBarcodePrefix: {},
              KMSEncrypted: {
                type: "boolean"
              },
              KMSKey: {},
              PoolId: {},
              Worm: {
                type: "boolean"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TapeARNs: {
                shape: "S2x"
              }
            }
          }
        },
        DeleteAutomaticTapeCreationPolicy: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        DeleteBandwidthRateLimit: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "BandwidthType"
            ],
            members: {
              GatewayARN: {},
              BandwidthType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        DeleteChapCredentials: {
          input: {
            type: "structure",
            required: [
              "TargetARN",
              "InitiatorName"
            ],
            members: {
              TargetARN: {},
              InitiatorName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TargetARN: {},
              InitiatorName: {}
            }
          }
        },
        DeleteFileShare: {
          input: {
            type: "structure",
            required: [
              "FileShareARN"
            ],
            members: {
              FileShareARN: {},
              ForceDelete: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FileShareARN: {}
            }
          }
        },
        DeleteGateway: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        DeleteSnapshotSchedule: {
          input: {
            type: "structure",
            required: [
              "VolumeARN"
            ],
            members: {
              VolumeARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VolumeARN: {}
            }
          }
        },
        DeleteTape: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "TapeARN"
            ],
            members: {
              GatewayARN: {},
              TapeARN: {},
              BypassGovernanceRetention: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TapeARN: {}
            }
          }
        },
        DeleteTapeArchive: {
          input: {
            type: "structure",
            required: [
              "TapeARN"
            ],
            members: {
              TapeARN: {},
              BypassGovernanceRetention: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TapeARN: {}
            }
          }
        },
        DeleteTapePool: {
          input: {
            type: "structure",
            required: [
              "PoolARN"
            ],
            members: {
              PoolARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PoolARN: {}
            }
          }
        },
        DeleteVolume: {
          input: {
            type: "structure",
            required: [
              "VolumeARN"
            ],
            members: {
              VolumeARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VolumeARN: {}
            }
          }
        },
        DescribeAvailabilityMonitorTest: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              Status: {},
              StartTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeBandwidthRateLimit: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              AverageUploadRateLimitInBitsPerSec: {
                type: "long"
              },
              AverageDownloadRateLimitInBitsPerSec: {
                type: "long"
              }
            }
          }
        },
        DescribeBandwidthRateLimitSchedule: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              BandwidthRateLimitIntervals: {
                shape: "S3u"
              }
            }
          }
        },
        DescribeCache: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              DiskIds: {
                shape: "Sg"
              },
              CacheAllocatedInBytes: {
                type: "long"
              },
              CacheUsedPercentage: {
                type: "double"
              },
              CacheDirtyPercentage: {
                type: "double"
              },
              CacheHitPercentage: {
                type: "double"
              },
              CacheMissPercentage: {
                type: "double"
              }
            }
          }
        },
        DescribeCachediSCSIVolumes: {
          input: {
            type: "structure",
            required: [
              "VolumeARNs"
            ],
            members: {
              VolumeARNs: {
                shape: "S44"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CachediSCSIVolumes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    VolumeARN: {},
                    VolumeId: {},
                    VolumeType: {},
                    VolumeStatus: {},
                    VolumeAttachmentStatus: {},
                    VolumeSizeInBytes: {
                      type: "long"
                    },
                    VolumeProgress: {
                      type: "double"
                    },
                    SourceSnapshotId: {},
                    VolumeiSCSIAttributes: {
                      shape: "S4d"
                    },
                    CreatedDate: {
                      type: "timestamp"
                    },
                    VolumeUsedInBytes: {
                      type: "long"
                    },
                    KMSKey: {},
                    TargetName: {}
                  }
                }
              }
            }
          }
        },
        DescribeChapCredentials: {
          input: {
            type: "structure",
            required: [
              "TargetARN"
            ],
            members: {
              TargetARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChapCredentials: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TargetARN: {},
                    SecretToAuthenticateInitiator: {
                      shape: "S4m"
                    },
                    InitiatorName: {},
                    SecretToAuthenticateTarget: {
                      shape: "S4m"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeFileSystemAssociations: {
          input: {
            type: "structure",
            required: [
              "FileSystemAssociationARNList"
            ],
            members: {
              FileSystemAssociationARNList: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FileSystemAssociationInfoList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FileSystemAssociationARN: {},
                    LocationARN: {},
                    FileSystemAssociationStatus: {},
                    AuditDestinationARN: {},
                    GatewayARN: {},
                    Tags: {
                      shape: "S9"
                    },
                    CacheAttributes: {
                      shape: "S11"
                    },
                    EndpointNetworkConfiguration: {
                      shape: "S13"
                    },
                    FileSystemAssociationStatusDetails: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ErrorCode: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeGatewayInformation: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              GatewayId: {},
              GatewayName: {},
              GatewayTimezone: {},
              GatewayState: {},
              GatewayNetworkInterfaces: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Ipv4Address: {},
                    MacAddress: {},
                    Ipv6Address: {}
                  },
                  sensitive: true
                }
              },
              GatewayType: {},
              NextUpdateAvailabilityDate: {},
              LastSoftwareUpdate: {},
              Ec2InstanceId: {},
              Ec2InstanceRegion: {},
              Tags: {
                shape: "S9"
              },
              VPCEndpoint: {},
              CloudWatchLogGroupARN: {},
              HostEnvironment: {},
              EndpointType: {},
              SoftwareUpdatesEndDate: {},
              DeprecationDate: {},
              GatewayCapacity: {},
              SupportedGatewayCapacities: {
                type: "list",
                member: {}
              },
              HostEnvironmentId: {},
              SoftwareVersion: {}
            }
          }
        },
        DescribeMaintenanceStartTime: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              HourOfDay: {
                type: "integer"
              },
              MinuteOfHour: {
                type: "integer"
              },
              DayOfWeek: {
                type: "integer"
              },
              DayOfMonth: {
                type: "integer"
              },
              Timezone: {}
            }
          }
        },
        DescribeNFSFileShares: {
          input: {
            type: "structure",
            required: [
              "FileShareARNList"
            ],
            members: {
              FileShareARNList: {
                shape: "S5j"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NFSFileShareInfoList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    NFSFileShareDefaults: {
                      shape: "S1p"
                    },
                    FileShareARN: {},
                    FileShareId: {},
                    FileShareStatus: {},
                    GatewayARN: {},
                    KMSEncrypted: {
                      type: "boolean"
                    },
                    KMSKey: {},
                    Path: {},
                    Role: {},
                    LocationARN: {},
                    DefaultStorageClass: {},
                    ObjectACL: {},
                    ClientList: {
                      shape: "S1w"
                    },
                    Squash: {},
                    ReadOnly: {
                      type: "boolean"
                    },
                    GuessMIMETypeEnabled: {
                      type: "boolean"
                    },
                    RequesterPays: {
                      type: "boolean"
                    },
                    Tags: {
                      shape: "S9"
                    },
                    FileShareName: {},
                    CacheAttributes: {
                      shape: "S11"
                    },
                    NotificationPolicy: {},
                    VPCEndpointDNSName: {},
                    BucketRegion: {},
                    AuditDestinationARN: {}
                  }
                }
              }
            }
          }
        },
        DescribeSMBFileShares: {
          input: {
            type: "structure",
            required: [
              "FileShareARNList"
            ],
            members: {
              FileShareARNList: {
                shape: "S5j"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SMBFileShareInfoList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FileShareARN: {},
                    FileShareId: {},
                    FileShareStatus: {},
                    GatewayARN: {},
                    KMSEncrypted: {
                      type: "boolean"
                    },
                    KMSKey: {},
                    Path: {},
                    Role: {},
                    LocationARN: {},
                    DefaultStorageClass: {},
                    ObjectACL: {},
                    ReadOnly: {
                      type: "boolean"
                    },
                    GuessMIMETypeEnabled: {
                      type: "boolean"
                    },
                    RequesterPays: {
                      type: "boolean"
                    },
                    SMBACLEnabled: {
                      type: "boolean"
                    },
                    AccessBasedEnumeration: {
                      type: "boolean"
                    },
                    AdminUserList: {
                      shape: "S25"
                    },
                    ValidUserList: {
                      shape: "S25"
                    },
                    InvalidUserList: {
                      shape: "S25"
                    },
                    AuditDestinationARN: {},
                    Authentication: {},
                    CaseSensitivity: {},
                    Tags: {
                      shape: "S9"
                    },
                    FileShareName: {},
                    CacheAttributes: {
                      shape: "S11"
                    },
                    NotificationPolicy: {},
                    VPCEndpointDNSName: {},
                    BucketRegion: {},
                    OplocksEnabled: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeSMBSettings: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              DomainName: {},
              ActiveDirectoryStatus: {},
              SMBGuestPasswordSet: {
                type: "boolean"
              },
              SMBSecurityStrategy: {},
              FileSharesVisible: {
                type: "boolean"
              },
              SMBLocalGroups: {
                shape: "S5z"
              }
            }
          }
        },
        DescribeSnapshotSchedule: {
          input: {
            type: "structure",
            required: [
              "VolumeARN"
            ],
            members: {
              VolumeARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VolumeARN: {},
              StartAt: {
                type: "integer"
              },
              RecurrenceInHours: {
                type: "integer"
              },
              Description: {},
              Timezone: {},
              Tags: {
                shape: "S9"
              }
            }
          }
        },
        DescribeStorediSCSIVolumes: {
          input: {
            type: "structure",
            required: [
              "VolumeARNs"
            ],
            members: {
              VolumeARNs: {
                shape: "S44"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StorediSCSIVolumes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    VolumeARN: {},
                    VolumeId: {},
                    VolumeType: {},
                    VolumeStatus: {},
                    VolumeAttachmentStatus: {},
                    VolumeSizeInBytes: {
                      type: "long"
                    },
                    VolumeProgress: {
                      type: "double"
                    },
                    VolumeDiskId: {},
                    SourceSnapshotId: {},
                    PreservedExistingData: {
                      type: "boolean"
                    },
                    VolumeiSCSIAttributes: {
                      shape: "S4d"
                    },
                    CreatedDate: {
                      type: "timestamp"
                    },
                    VolumeUsedInBytes: {
                      type: "long"
                    },
                    KMSKey: {},
                    TargetName: {}
                  }
                }
              }
            }
          }
        },
        DescribeTapeArchives: {
          input: {
            type: "structure",
            members: {
              TapeARNs: {
                shape: "S2x"
              },
              Marker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TapeArchives: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TapeARN: {},
                    TapeBarcode: {},
                    TapeCreatedDate: {
                      type: "timestamp"
                    },
                    TapeSizeInBytes: {
                      type: "long"
                    },
                    CompletionTime: {
                      type: "timestamp"
                    },
                    RetrievedTo: {},
                    TapeStatus: {},
                    TapeUsedInBytes: {
                      type: "long"
                    },
                    KMSKey: {},
                    PoolId: {},
                    Worm: {
                      type: "boolean"
                    },
                    RetentionStartDate: {
                      type: "timestamp"
                    },
                    PoolEntryDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeTapeRecoveryPoints: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {},
              Marker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              TapeRecoveryPointInfos: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TapeARN: {},
                    TapeRecoveryPointTime: {
                      type: "timestamp"
                    },
                    TapeSizeInBytes: {
                      type: "long"
                    },
                    TapeStatus: {}
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeTapes: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {},
              TapeARNs: {
                shape: "S2x"
              },
              Marker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tapes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TapeARN: {},
                    TapeBarcode: {},
                    TapeCreatedDate: {
                      type: "timestamp"
                    },
                    TapeSizeInBytes: {
                      type: "long"
                    },
                    TapeStatus: {},
                    VTLDevice: {},
                    Progress: {
                      type: "double"
                    },
                    TapeUsedInBytes: {
                      type: "long"
                    },
                    KMSKey: {},
                    PoolId: {},
                    Worm: {
                      type: "boolean"
                    },
                    RetentionStartDate: {
                      type: "timestamp"
                    },
                    PoolEntryDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeUploadBuffer: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              DiskIds: {
                shape: "Sg"
              },
              UploadBufferUsedInBytes: {
                type: "long"
              },
              UploadBufferAllocatedInBytes: {
                type: "long"
              }
            }
          }
        },
        DescribeVTLDevices: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {},
              VTLDeviceARNs: {
                type: "list",
                member: {}
              },
              Marker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              VTLDevices: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    VTLDeviceARN: {},
                    VTLDeviceType: {},
                    VTLDeviceVendor: {},
                    VTLDeviceProductIdentifier: {},
                    DeviceiSCSIAttributes: {
                      type: "structure",
                      members: {
                        TargetARN: {},
                        NetworkInterfaceId: {},
                        NetworkInterfacePort: {
                          type: "integer"
                        },
                        ChapEnabled: {
                          type: "boolean"
                        }
                      }
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeWorkingStorage: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              DiskIds: {
                shape: "Sg"
              },
              WorkingStorageUsedInBytes: {
                type: "long"
              },
              WorkingStorageAllocatedInBytes: {
                type: "long"
              }
            }
          }
        },
        DetachVolume: {
          input: {
            type: "structure",
            required: [
              "VolumeARN"
            ],
            members: {
              VolumeARN: {},
              ForceDetach: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VolumeARN: {}
            }
          }
        },
        DisableGateway: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        DisassociateFileSystem: {
          input: {
            type: "structure",
            required: [
              "FileSystemAssociationARN"
            ],
            members: {
              FileSystemAssociationARN: {},
              ForceDelete: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FileSystemAssociationARN: {}
            }
          }
        },
        JoinDomain: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "DomainName",
              "UserName",
              "Password"
            ],
            members: {
              GatewayARN: {},
              DomainName: {},
              OrganizationalUnit: {},
              DomainControllers: {
                type: "list",
                member: {}
              },
              TimeoutInSeconds: {
                type: "integer"
              },
              UserName: {},
              Password: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              ActiveDirectoryStatus: {}
            }
          }
        },
        ListAutomaticTapeCreationPolicies: {
          input: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AutomaticTapeCreationPolicyInfos: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AutomaticTapeCreationRules: {
                      shape: "S7j"
                    },
                    GatewayARN: {}
                  }
                }
              }
            }
          }
        },
        ListFileShares: {
          input: {
            type: "structure",
            members: {
              GatewayARN: {},
              Limit: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              NextMarker: {},
              FileShareInfoList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FileShareType: {},
                    FileShareARN: {},
                    FileShareId: {},
                    FileShareStatus: {},
                    GatewayARN: {}
                  }
                }
              }
            }
          }
        },
        ListFileSystemAssociations: {
          input: {
            type: "structure",
            members: {
              GatewayARN: {},
              Limit: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              NextMarker: {},
              FileSystemAssociationSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FileSystemAssociationId: {},
                    FileSystemAssociationARN: {},
                    FileSystemAssociationStatus: {},
                    GatewayARN: {}
                  }
                }
              }
            }
          }
        },
        ListGateways: {
          input: {
            type: "structure",
            members: {
              Marker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Gateways: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    GatewayId: {},
                    GatewayARN: {},
                    GatewayType: {},
                    GatewayOperationalState: {},
                    GatewayName: {},
                    Ec2InstanceId: {},
                    Ec2InstanceRegion: {},
                    HostEnvironment: {},
                    HostEnvironmentId: {}
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ListLocalDisks: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              Disks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DiskId: {},
                    DiskPath: {},
                    DiskNode: {},
                    DiskStatus: {},
                    DiskSizeInBytes: {
                      type: "long"
                    },
                    DiskAllocationType: {},
                    DiskAllocationResource: {},
                    DiskAttributeList: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {},
              Marker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceARN: {},
              Marker: {},
              Tags: {
                shape: "S9"
              }
            }
          }
        },
        ListTapePools: {
          input: {
            type: "structure",
            members: {
              PoolARNs: {
                type: "list",
                member: {}
              },
              Marker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PoolInfos: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PoolARN: {},
                    PoolName: {},
                    StorageClass: {},
                    RetentionLockType: {},
                    RetentionLockTimeInDays: {
                      type: "integer"
                    },
                    PoolStatus: {}
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ListTapes: {
          input: {
            type: "structure",
            members: {
              TapeARNs: {
                shape: "S2x"
              },
              Marker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TapeInfos: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TapeARN: {},
                    TapeBarcode: {},
                    TapeSizeInBytes: {
                      type: "long"
                    },
                    TapeStatus: {},
                    GatewayARN: {},
                    PoolId: {},
                    RetentionStartDate: {
                      type: "timestamp"
                    },
                    PoolEntryDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ListVolumeInitiators: {
          input: {
            type: "structure",
            required: [
              "VolumeARN"
            ],
            members: {
              VolumeARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Initiators: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ListVolumeRecoveryPoints: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              VolumeRecoveryPointInfos: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    VolumeARN: {},
                    VolumeSizeInBytes: {
                      type: "long"
                    },
                    VolumeUsageInBytes: {
                      type: "long"
                    },
                    VolumeRecoveryPointTime: {}
                  }
                }
              }
            }
          }
        },
        ListVolumes: {
          input: {
            type: "structure",
            members: {
              GatewayARN: {},
              Marker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              Marker: {},
              VolumeInfos: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    VolumeARN: {},
                    VolumeId: {},
                    GatewayARN: {},
                    GatewayId: {},
                    VolumeType: {},
                    VolumeSizeInBytes: {
                      type: "long"
                    },
                    VolumeAttachmentStatus: {}
                  }
                }
              }
            }
          }
        },
        NotifyWhenUploaded: {
          input: {
            type: "structure",
            required: [
              "FileShareARN"
            ],
            members: {
              FileShareARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FileShareARN: {},
              NotificationId: {}
            }
          }
        },
        RefreshCache: {
          input: {
            type: "structure",
            required: [
              "FileShareARN"
            ],
            members: {
              FileShareARN: {},
              FolderList: {
                type: "list",
                member: {}
              },
              Recursive: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FileShareARN: {},
              NotificationId: {}
            }
          }
        },
        RemoveTagsFromResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceARN: {}
            }
          }
        },
        ResetCache: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        RetrieveTapeArchive: {
          input: {
            type: "structure",
            required: [
              "TapeARN",
              "GatewayARN"
            ],
            members: {
              TapeARN: {},
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TapeARN: {}
            }
          }
        },
        RetrieveTapeRecoveryPoint: {
          input: {
            type: "structure",
            required: [
              "TapeARN",
              "GatewayARN"
            ],
            members: {
              TapeARN: {},
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TapeARN: {}
            }
          }
        },
        SetLocalConsolePassword: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "LocalConsolePassword"
            ],
            members: {
              GatewayARN: {},
              LocalConsolePassword: {
                type: "string",
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        SetSMBGuestPassword: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "Password"
            ],
            members: {
              GatewayARN: {},
              Password: {
                type: "string",
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        ShutdownGateway: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        StartAvailabilityMonitorTest: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        StartGateway: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        UpdateAutomaticTapeCreationPolicy: {
          input: {
            type: "structure",
            required: [
              "AutomaticTapeCreationRules",
              "GatewayARN"
            ],
            members: {
              AutomaticTapeCreationRules: {
                shape: "S7j"
              },
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        UpdateBandwidthRateLimit: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {},
              AverageUploadRateLimitInBitsPerSec: {
                type: "long"
              },
              AverageDownloadRateLimitInBitsPerSec: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        UpdateBandwidthRateLimitSchedule: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "BandwidthRateLimitIntervals"
            ],
            members: {
              GatewayARN: {},
              BandwidthRateLimitIntervals: {
                shape: "S3u"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        UpdateChapCredentials: {
          input: {
            type: "structure",
            required: [
              "TargetARN",
              "SecretToAuthenticateInitiator",
              "InitiatorName"
            ],
            members: {
              TargetARN: {},
              SecretToAuthenticateInitiator: {
                shape: "S4m"
              },
              InitiatorName: {},
              SecretToAuthenticateTarget: {
                shape: "S4m"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TargetARN: {},
              InitiatorName: {}
            }
          }
        },
        UpdateFileSystemAssociation: {
          input: {
            type: "structure",
            required: [
              "FileSystemAssociationARN"
            ],
            members: {
              FileSystemAssociationARN: {},
              UserName: {},
              Password: {
                shape: "Sx"
              },
              AuditDestinationARN: {},
              CacheAttributes: {
                shape: "S11"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FileSystemAssociationARN: {}
            }
          }
        },
        UpdateGatewayInformation: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {},
              GatewayName: {},
              GatewayTimezone: {},
              CloudWatchLogGroupARN: {},
              GatewayCapacity: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              GatewayName: {}
            }
          }
        },
        UpdateGatewaySoftwareNow: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        UpdateMaintenanceStartTime: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "HourOfDay",
              "MinuteOfHour"
            ],
            members: {
              GatewayARN: {},
              HourOfDay: {
                type: "integer"
              },
              MinuteOfHour: {
                type: "integer"
              },
              DayOfWeek: {
                type: "integer"
              },
              DayOfMonth: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        UpdateNFSFileShare: {
          input: {
            type: "structure",
            required: [
              "FileShareARN"
            ],
            members: {
              FileShareARN: {},
              KMSEncrypted: {
                type: "boolean"
              },
              KMSKey: {},
              NFSFileShareDefaults: {
                shape: "S1p"
              },
              DefaultStorageClass: {},
              ObjectACL: {},
              ClientList: {
                shape: "S1w"
              },
              Squash: {},
              ReadOnly: {
                type: "boolean"
              },
              GuessMIMETypeEnabled: {
                type: "boolean"
              },
              RequesterPays: {
                type: "boolean"
              },
              FileShareName: {},
              CacheAttributes: {
                shape: "S11"
              },
              NotificationPolicy: {},
              AuditDestinationARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FileShareARN: {}
            }
          }
        },
        UpdateSMBFileShare: {
          input: {
            type: "structure",
            required: [
              "FileShareARN"
            ],
            members: {
              FileShareARN: {},
              KMSEncrypted: {
                type: "boolean"
              },
              KMSKey: {},
              DefaultStorageClass: {},
              ObjectACL: {},
              ReadOnly: {
                type: "boolean"
              },
              GuessMIMETypeEnabled: {
                type: "boolean"
              },
              RequesterPays: {
                type: "boolean"
              },
              SMBACLEnabled: {
                type: "boolean"
              },
              AccessBasedEnumeration: {
                type: "boolean"
              },
              AdminUserList: {
                shape: "S25"
              },
              ValidUserList: {
                shape: "S25"
              },
              InvalidUserList: {
                shape: "S25"
              },
              AuditDestinationARN: {},
              CaseSensitivity: {},
              FileShareName: {},
              CacheAttributes: {
                shape: "S11"
              },
              NotificationPolicy: {},
              OplocksEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FileShareARN: {}
            }
          }
        },
        UpdateSMBFileShareVisibility: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "FileSharesVisible"
            ],
            members: {
              GatewayARN: {},
              FileSharesVisible: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        UpdateSMBLocalGroups: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "SMBLocalGroups"
            ],
            members: {
              GatewayARN: {},
              SMBLocalGroups: {
                shape: "S5z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        UpdateSMBSecurityStrategy: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "SMBSecurityStrategy"
            ],
            members: {
              GatewayARN: {},
              SMBSecurityStrategy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        UpdateSnapshotSchedule: {
          input: {
            type: "structure",
            required: [
              "VolumeARN",
              "StartAt",
              "RecurrenceInHours"
            ],
            members: {
              VolumeARN: {},
              StartAt: {
                type: "integer"
              },
              RecurrenceInHours: {
                type: "integer"
              },
              Description: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VolumeARN: {}
            }
          }
        },
        UpdateVTLDeviceType: {
          input: {
            type: "structure",
            required: [
              "VTLDeviceARN",
              "DeviceType"
            ],
            members: {
              VTLDeviceARN: {},
              DeviceType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VTLDeviceARN: {}
            }
          }
        }
      },
      shapes: {
        S9: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sg: {
          type: "list",
          member: {}
        },
        Sx: {
          type: "string",
          sensitive: true
        },
        S11: {
          type: "structure",
          members: {
            CacheStaleTimeoutInSeconds: {
              type: "integer"
            }
          }
        },
        S13: {
          type: "structure",
          members: {
            IpAddresses: {
              type: "list",
              member: {}
            }
          }
        },
        S1p: {
          type: "structure",
          members: {
            FileMode: {},
            DirectoryMode: {},
            GroupId: {
              type: "long"
            },
            OwnerId: {
              type: "long"
            }
          }
        },
        S1w: {
          type: "list",
          member: {}
        },
        S25: {
          type: "list",
          member: {}
        },
        S2x: {
          type: "list",
          member: {}
        },
        S3u: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "StartHourOfDay",
              "StartMinuteOfHour",
              "EndHourOfDay",
              "EndMinuteOfHour",
              "DaysOfWeek"
            ],
            members: {
              StartHourOfDay: {
                type: "integer"
              },
              StartMinuteOfHour: {
                type: "integer"
              },
              EndHourOfDay: {
                type: "integer"
              },
              EndMinuteOfHour: {
                type: "integer"
              },
              DaysOfWeek: {
                type: "list",
                member: {
                  type: "integer"
                }
              },
              AverageUploadRateLimitInBitsPerSec: {
                type: "long"
              },
              AverageDownloadRateLimitInBitsPerSec: {
                type: "long"
              }
            }
          }
        },
        S44: {
          type: "list",
          member: {}
        },
        S4d: {
          type: "structure",
          members: {
            TargetARN: {},
            NetworkInterfaceId: {},
            NetworkInterfacePort: {
              type: "integer"
            },
            LunNumber: {
              type: "integer"
            },
            ChapEnabled: {
              type: "boolean"
            }
          }
        },
        S4m: {
          type: "string",
          sensitive: true
        },
        S5j: {
          type: "list",
          member: {}
        },
        S5z: {
          type: "structure",
          members: {
            GatewayAdmins: {
              shape: "S25"
            }
          }
        },
        S7j: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "TapeBarcodePrefix",
              "PoolId",
              "TapeSizeInBytes",
              "MinimumNumTapes"
            ],
            members: {
              TapeBarcodePrefix: {},
              PoolId: {},
              TapeSizeInBytes: {
                type: "long"
              },
              MinimumNumTapes: {
                type: "integer"
              },
              Worm: {
                type: "boolean"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/storagegateway-2013-06-30.paginators.json
var require_storagegateway_2013_06_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/storagegateway-2013-06-30.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeCachediSCSIVolumes: {
          result_key: "CachediSCSIVolumes"
        },
        DescribeStorediSCSIVolumes: {
          result_key: "StorediSCSIVolumes"
        },
        DescribeTapeArchives: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "Marker",
          result_key: "TapeArchives"
        },
        DescribeTapeRecoveryPoints: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "Marker",
          result_key: "TapeRecoveryPointInfos"
        },
        DescribeTapes: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "Marker",
          result_key: "Tapes"
        },
        DescribeVTLDevices: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "Marker",
          result_key: "VTLDevices"
        },
        ListFileShares: {
          input_token: "Marker",
          limit_key: "Limit",
          non_aggregate_keys: [
            "Marker"
          ],
          output_token: "NextMarker",
          result_key: "FileShareInfoList"
        },
        ListFileSystemAssociations: {
          input_token: "Marker",
          limit_key: "Limit",
          non_aggregate_keys: [
            "Marker"
          ],
          output_token: "NextMarker",
          result_key: "FileSystemAssociationSummaryList"
        },
        ListGateways: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "Marker",
          result_key: "Gateways"
        },
        ListLocalDisks: {
          result_key: "Disks"
        },
        ListTagsForResource: {
          input_token: "Marker",
          limit_key: "Limit",
          non_aggregate_keys: [
            "ResourceARN"
          ],
          output_token: "Marker",
          result_key: "Tags"
        },
        ListTapePools: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "Marker",
          result_key: "PoolInfos"
        },
        ListTapes: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "Marker",
          result_key: "TapeInfos"
        },
        ListVolumeRecoveryPoints: {
          result_key: "VolumeRecoveryPointInfos"
        },
        ListVolumes: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "Marker",
          result_key: "VolumeInfos"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/storagegateway.js
var require_storagegateway = __commonJS({
  "node_modules/aws-sdk/clients/storagegateway.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["storagegateway"] = {};
    AWS2.StorageGateway = Service.defineService("storagegateway", ["2013-06-30"]);
    Object.defineProperty(apiLoader.services["storagegateway"], "2013-06-30", {
      get: function get() {
        var model = require_storagegateway_2013_06_30_min();
        model.paginators = require_storagegateway_2013_06_30_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.StorageGateway;
  }
});

// node_modules/aws-sdk/apis/states-2016-11-23.min.json
var require_states_2016_11_23_min = __commonJS({
  "node_modules/aws-sdk/apis/states-2016-11-23.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-11-23",
        endpointPrefix: "states",
        jsonVersion: "1.0",
        protocol: "json",
        serviceAbbreviation: "AWS SFN",
        serviceFullName: "AWS Step Functions",
        serviceId: "SFN",
        signatureVersion: "v4",
        targetPrefix: "AWSStepFunctions",
        uid: "states-2016-11-23"
      },
      operations: {
        CreateActivity: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              tags: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "activityArn",
              "creationDate"
            ],
            members: {
              activityArn: {},
              creationDate: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        CreateStateMachine: {
          input: {
            type: "structure",
            required: [
              "name",
              "definition",
              "roleArn"
            ],
            members: {
              name: {},
              definition: {
                shape: "Sb"
              },
              roleArn: {},
              type: {},
              loggingConfiguration: {
                shape: "Sd"
              },
              tags: {
                shape: "S3"
              },
              tracingConfiguration: {
                shape: "Sj"
              },
              publish: {
                type: "boolean"
              },
              versionDescription: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "stateMachineArn",
              "creationDate"
            ],
            members: {
              stateMachineArn: {},
              creationDate: {
                type: "timestamp"
              },
              stateMachineVersionArn: {}
            }
          },
          idempotent: true
        },
        CreateStateMachineAlias: {
          input: {
            type: "structure",
            required: [
              "name",
              "routingConfiguration"
            ],
            members: {
              description: {
                shape: "Sp"
              },
              name: {},
              routingConfiguration: {
                shape: "Sr"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "stateMachineAliasArn",
              "creationDate"
            ],
            members: {
              stateMachineAliasArn: {},
              creationDate: {
                type: "timestamp"
              }
            }
          }
        },
        DeleteActivity: {
          input: {
            type: "structure",
            required: [
              "activityArn"
            ],
            members: {
              activityArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteStateMachine: {
          input: {
            type: "structure",
            required: [
              "stateMachineArn"
            ],
            members: {
              stateMachineArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteStateMachineAlias: {
          input: {
            type: "structure",
            required: [
              "stateMachineAliasArn"
            ],
            members: {
              stateMachineAliasArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteStateMachineVersion: {
          input: {
            type: "structure",
            required: [
              "stateMachineVersionArn"
            ],
            members: {
              stateMachineVersionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeActivity: {
          input: {
            type: "structure",
            required: [
              "activityArn"
            ],
            members: {
              activityArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "activityArn",
              "name",
              "creationDate"
            ],
            members: {
              activityArn: {},
              name: {},
              creationDate: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeExecution: {
          input: {
            type: "structure",
            required: [
              "executionArn"
            ],
            members: {
              executionArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "executionArn",
              "stateMachineArn",
              "status",
              "startDate"
            ],
            members: {
              executionArn: {},
              stateMachineArn: {},
              name: {},
              status: {},
              startDate: {
                type: "timestamp"
              },
              stopDate: {
                type: "timestamp"
              },
              input: {
                shape: "S19"
              },
              inputDetails: {
                shape: "S1a"
              },
              output: {
                shape: "S19"
              },
              outputDetails: {
                shape: "S1a"
              },
              traceHeader: {},
              mapRunArn: {},
              error: {
                shape: "S1d"
              },
              cause: {
                shape: "S1e"
              },
              stateMachineVersionArn: {},
              stateMachineAliasArn: {},
              redriveCount: {
                type: "integer"
              },
              redriveDate: {
                type: "timestamp"
              },
              redriveStatus: {},
              redriveStatusReason: {
                shape: "S19"
              }
            }
          }
        },
        DescribeMapRun: {
          input: {
            type: "structure",
            required: [
              "mapRunArn"
            ],
            members: {
              mapRunArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "mapRunArn",
              "executionArn",
              "status",
              "startDate",
              "maxConcurrency",
              "toleratedFailurePercentage",
              "toleratedFailureCount",
              "itemCounts",
              "executionCounts"
            ],
            members: {
              mapRunArn: {},
              executionArn: {},
              status: {},
              startDate: {
                type: "timestamp"
              },
              stopDate: {
                type: "timestamp"
              },
              maxConcurrency: {
                type: "integer"
              },
              toleratedFailurePercentage: {
                type: "float"
              },
              toleratedFailureCount: {
                type: "long"
              },
              itemCounts: {
                type: "structure",
                required: [
                  "pending",
                  "running",
                  "succeeded",
                  "failed",
                  "timedOut",
                  "aborted",
                  "total",
                  "resultsWritten"
                ],
                members: {
                  pending: {
                    type: "long"
                  },
                  running: {
                    type: "long"
                  },
                  succeeded: {
                    type: "long"
                  },
                  failed: {
                    type: "long"
                  },
                  timedOut: {
                    type: "long"
                  },
                  aborted: {
                    type: "long"
                  },
                  total: {
                    type: "long"
                  },
                  resultsWritten: {
                    type: "long"
                  },
                  failuresNotRedrivable: {
                    type: "long"
                  },
                  pendingRedrive: {
                    type: "long"
                  }
                }
              },
              executionCounts: {
                type: "structure",
                required: [
                  "pending",
                  "running",
                  "succeeded",
                  "failed",
                  "timedOut",
                  "aborted",
                  "total",
                  "resultsWritten"
                ],
                members: {
                  pending: {
                    type: "long"
                  },
                  running: {
                    type: "long"
                  },
                  succeeded: {
                    type: "long"
                  },
                  failed: {
                    type: "long"
                  },
                  timedOut: {
                    type: "long"
                  },
                  aborted: {
                    type: "long"
                  },
                  total: {
                    type: "long"
                  },
                  resultsWritten: {
                    type: "long"
                  },
                  failuresNotRedrivable: {
                    type: "long"
                  },
                  pendingRedrive: {
                    type: "long"
                  }
                }
              },
              redriveCount: {
                type: "integer"
              },
              redriveDate: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeStateMachine: {
          input: {
            type: "structure",
            required: [
              "stateMachineArn"
            ],
            members: {
              stateMachineArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "stateMachineArn",
              "name",
              "definition",
              "roleArn",
              "type",
              "creationDate"
            ],
            members: {
              stateMachineArn: {},
              name: {},
              status: {},
              definition: {
                shape: "Sb"
              },
              roleArn: {},
              type: {},
              creationDate: {
                type: "timestamp"
              },
              loggingConfiguration: {
                shape: "Sd"
              },
              tracingConfiguration: {
                shape: "Sj"
              },
              label: {},
              revisionId: {},
              description: {
                shape: "Sm"
              }
            }
          }
        },
        DescribeStateMachineAlias: {
          input: {
            type: "structure",
            required: [
              "stateMachineAliasArn"
            ],
            members: {
              stateMachineAliasArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              stateMachineAliasArn: {},
              name: {},
              description: {
                shape: "Sp"
              },
              routingConfiguration: {
                shape: "Sr"
              },
              creationDate: {
                type: "timestamp"
              },
              updateDate: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeStateMachineForExecution: {
          input: {
            type: "structure",
            required: [
              "executionArn"
            ],
            members: {
              executionArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "stateMachineArn",
              "name",
              "definition",
              "roleArn",
              "updateDate"
            ],
            members: {
              stateMachineArn: {},
              name: {},
              definition: {
                shape: "Sb"
              },
              roleArn: {},
              updateDate: {
                type: "timestamp"
              },
              loggingConfiguration: {
                shape: "Sd"
              },
              tracingConfiguration: {
                shape: "Sj"
              },
              mapRunArn: {},
              label: {},
              revisionId: {}
            }
          }
        },
        GetActivityTask: {
          input: {
            type: "structure",
            required: [
              "activityArn"
            ],
            members: {
              activityArn: {},
              workerName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              taskToken: {},
              input: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        GetExecutionHistory: {
          input: {
            type: "structure",
            required: [
              "executionArn"
            ],
            members: {
              executionArn: {},
              maxResults: {
                type: "integer"
              },
              reverseOrder: {
                type: "boolean"
              },
              nextToken: {},
              includeExecutionData: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "events"
            ],
            members: {
              events: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "timestamp",
                    "type",
                    "id"
                  ],
                  members: {
                    timestamp: {
                      type: "timestamp"
                    },
                    type: {},
                    id: {
                      type: "long"
                    },
                    previousEventId: {
                      type: "long"
                    },
                    activityFailedEventDetails: {
                      type: "structure",
                      members: {
                        error: {
                          shape: "S1d"
                        },
                        cause: {
                          shape: "S1e"
                        }
                      }
                    },
                    activityScheduleFailedEventDetails: {
                      type: "structure",
                      members: {
                        error: {
                          shape: "S1d"
                        },
                        cause: {
                          shape: "S1e"
                        }
                      }
                    },
                    activityScheduledEventDetails: {
                      type: "structure",
                      required: [
                        "resource"
                      ],
                      members: {
                        resource: {},
                        input: {
                          shape: "S19"
                        },
                        inputDetails: {
                          shape: "S2h"
                        },
                        timeoutInSeconds: {
                          type: "long"
                        },
                        heartbeatInSeconds: {
                          type: "long"
                        }
                      }
                    },
                    activityStartedEventDetails: {
                      type: "structure",
                      members: {
                        workerName: {}
                      }
                    },
                    activitySucceededEventDetails: {
                      type: "structure",
                      members: {
                        output: {
                          shape: "S19"
                        },
                        outputDetails: {
                          shape: "S2h"
                        }
                      }
                    },
                    activityTimedOutEventDetails: {
                      type: "structure",
                      members: {
                        error: {
                          shape: "S1d"
                        },
                        cause: {
                          shape: "S1e"
                        }
                      }
                    },
                    taskFailedEventDetails: {
                      type: "structure",
                      required: [
                        "resourceType",
                        "resource"
                      ],
                      members: {
                        resourceType: {},
                        resource: {},
                        error: {
                          shape: "S1d"
                        },
                        cause: {
                          shape: "S1e"
                        }
                      }
                    },
                    taskScheduledEventDetails: {
                      type: "structure",
                      required: [
                        "resourceType",
                        "resource",
                        "region",
                        "parameters"
                      ],
                      members: {
                        resourceType: {},
                        resource: {},
                        region: {},
                        parameters: {
                          type: "string",
                          sensitive: true
                        },
                        timeoutInSeconds: {
                          type: "long"
                        },
                        heartbeatInSeconds: {
                          type: "long"
                        },
                        taskCredentials: {
                          shape: "S2r"
                        }
                      }
                    },
                    taskStartFailedEventDetails: {
                      type: "structure",
                      required: [
                        "resourceType",
                        "resource"
                      ],
                      members: {
                        resourceType: {},
                        resource: {},
                        error: {
                          shape: "S1d"
                        },
                        cause: {
                          shape: "S1e"
                        }
                      }
                    },
                    taskStartedEventDetails: {
                      type: "structure",
                      required: [
                        "resourceType",
                        "resource"
                      ],
                      members: {
                        resourceType: {},
                        resource: {}
                      }
                    },
                    taskSubmitFailedEventDetails: {
                      type: "structure",
                      required: [
                        "resourceType",
                        "resource"
                      ],
                      members: {
                        resourceType: {},
                        resource: {},
                        error: {
                          shape: "S1d"
                        },
                        cause: {
                          shape: "S1e"
                        }
                      }
                    },
                    taskSubmittedEventDetails: {
                      type: "structure",
                      required: [
                        "resourceType",
                        "resource"
                      ],
                      members: {
                        resourceType: {},
                        resource: {},
                        output: {
                          shape: "S19"
                        },
                        outputDetails: {
                          shape: "S2h"
                        }
                      }
                    },
                    taskSucceededEventDetails: {
                      type: "structure",
                      required: [
                        "resourceType",
                        "resource"
                      ],
                      members: {
                        resourceType: {},
                        resource: {},
                        output: {
                          shape: "S19"
                        },
                        outputDetails: {
                          shape: "S2h"
                        }
                      }
                    },
                    taskTimedOutEventDetails: {
                      type: "structure",
                      required: [
                        "resourceType",
                        "resource"
                      ],
                      members: {
                        resourceType: {},
                        resource: {},
                        error: {
                          shape: "S1d"
                        },
                        cause: {
                          shape: "S1e"
                        }
                      }
                    },
                    executionFailedEventDetails: {
                      type: "structure",
                      members: {
                        error: {
                          shape: "S1d"
                        },
                        cause: {
                          shape: "S1e"
                        }
                      }
                    },
                    executionStartedEventDetails: {
                      type: "structure",
                      members: {
                        input: {
                          shape: "S19"
                        },
                        inputDetails: {
                          shape: "S2h"
                        },
                        roleArn: {},
                        stateMachineAliasArn: {},
                        stateMachineVersionArn: {}
                      }
                    },
                    executionSucceededEventDetails: {
                      type: "structure",
                      members: {
                        output: {
                          shape: "S19"
                        },
                        outputDetails: {
                          shape: "S2h"
                        }
                      }
                    },
                    executionAbortedEventDetails: {
                      type: "structure",
                      members: {
                        error: {
                          shape: "S1d"
                        },
                        cause: {
                          shape: "S1e"
                        }
                      }
                    },
                    executionTimedOutEventDetails: {
                      type: "structure",
                      members: {
                        error: {
                          shape: "S1d"
                        },
                        cause: {
                          shape: "S1e"
                        }
                      }
                    },
                    executionRedrivenEventDetails: {
                      type: "structure",
                      members: {
                        redriveCount: {
                          type: "integer"
                        }
                      }
                    },
                    mapStateStartedEventDetails: {
                      type: "structure",
                      members: {
                        length: {
                          type: "integer"
                        }
                      }
                    },
                    mapIterationStartedEventDetails: {
                      shape: "S36"
                    },
                    mapIterationSucceededEventDetails: {
                      shape: "S36"
                    },
                    mapIterationFailedEventDetails: {
                      shape: "S36"
                    },
                    mapIterationAbortedEventDetails: {
                      shape: "S36"
                    },
                    lambdaFunctionFailedEventDetails: {
                      type: "structure",
                      members: {
                        error: {
                          shape: "S1d"
                        },
                        cause: {
                          shape: "S1e"
                        }
                      }
                    },
                    lambdaFunctionScheduleFailedEventDetails: {
                      type: "structure",
                      members: {
                        error: {
                          shape: "S1d"
                        },
                        cause: {
                          shape: "S1e"
                        }
                      }
                    },
                    lambdaFunctionScheduledEventDetails: {
                      type: "structure",
                      required: [
                        "resource"
                      ],
                      members: {
                        resource: {},
                        input: {
                          shape: "S19"
                        },
                        inputDetails: {
                          shape: "S2h"
                        },
                        timeoutInSeconds: {
                          type: "long"
                        },
                        taskCredentials: {
                          shape: "S2r"
                        }
                      }
                    },
                    lambdaFunctionStartFailedEventDetails: {
                      type: "structure",
                      members: {
                        error: {
                          shape: "S1d"
                        },
                        cause: {
                          shape: "S1e"
                        }
                      }
                    },
                    lambdaFunctionSucceededEventDetails: {
                      type: "structure",
                      members: {
                        output: {
                          shape: "S19"
                        },
                        outputDetails: {
                          shape: "S2h"
                        }
                      }
                    },
                    lambdaFunctionTimedOutEventDetails: {
                      type: "structure",
                      members: {
                        error: {
                          shape: "S1d"
                        },
                        cause: {
                          shape: "S1e"
                        }
                      }
                    },
                    stateEnteredEventDetails: {
                      type: "structure",
                      required: [
                        "name"
                      ],
                      members: {
                        name: {},
                        input: {
                          shape: "S19"
                        },
                        inputDetails: {
                          shape: "S2h"
                        }
                      }
                    },
                    stateExitedEventDetails: {
                      type: "structure",
                      required: [
                        "name"
                      ],
                      members: {
                        name: {},
                        output: {
                          shape: "S19"
                        },
                        outputDetails: {
                          shape: "S2h"
                        }
                      }
                    },
                    mapRunStartedEventDetails: {
                      type: "structure",
                      members: {
                        mapRunArn: {}
                      }
                    },
                    mapRunFailedEventDetails: {
                      type: "structure",
                      members: {
                        error: {
                          shape: "S1d"
                        },
                        cause: {
                          shape: "S1e"
                        }
                      }
                    },
                    mapRunRedrivenEventDetails: {
                      type: "structure",
                      members: {
                        mapRunArn: {},
                        redriveCount: {
                          type: "integer"
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListActivities: {
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "activities"
            ],
            members: {
              activities: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "activityArn",
                    "name",
                    "creationDate"
                  ],
                  members: {
                    activityArn: {},
                    name: {},
                    creationDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListExecutions: {
          input: {
            type: "structure",
            members: {
              stateMachineArn: {},
              statusFilter: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              mapRunArn: {},
              redriveFilter: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "executions"
            ],
            members: {
              executions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "executionArn",
                    "stateMachineArn",
                    "name",
                    "status",
                    "startDate"
                  ],
                  members: {
                    executionArn: {},
                    stateMachineArn: {},
                    name: {},
                    status: {},
                    startDate: {
                      type: "timestamp"
                    },
                    stopDate: {
                      type: "timestamp"
                    },
                    mapRunArn: {},
                    itemCount: {
                      type: "integer"
                    },
                    stateMachineVersionArn: {},
                    stateMachineAliasArn: {},
                    redriveCount: {
                      type: "integer"
                    },
                    redriveDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListMapRuns: {
          input: {
            type: "structure",
            required: [
              "executionArn"
            ],
            members: {
              executionArn: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "mapRuns"
            ],
            members: {
              mapRuns: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "executionArn",
                    "mapRunArn",
                    "stateMachineArn",
                    "startDate"
                  ],
                  members: {
                    executionArn: {},
                    mapRunArn: {},
                    stateMachineArn: {},
                    startDate: {
                      type: "timestamp"
                    },
                    stopDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListStateMachineAliases: {
          input: {
            type: "structure",
            required: [
              "stateMachineArn"
            ],
            members: {
              stateMachineArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "stateMachineAliases"
            ],
            members: {
              stateMachineAliases: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "stateMachineAliasArn",
                    "creationDate"
                  ],
                  members: {
                    stateMachineAliasArn: {},
                    creationDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListStateMachineVersions: {
          input: {
            type: "structure",
            required: [
              "stateMachineArn"
            ],
            members: {
              stateMachineArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "stateMachineVersions"
            ],
            members: {
              stateMachineVersions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "stateMachineVersionArn",
                    "creationDate"
                  ],
                  members: {
                    stateMachineVersionArn: {},
                    creationDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListStateMachines: {
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "stateMachines"
            ],
            members: {
              stateMachines: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "stateMachineArn",
                    "name",
                    "type",
                    "creationDate"
                  ],
                  members: {
                    stateMachineArn: {},
                    name: {},
                    type: {},
                    creationDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S3"
              }
            }
          }
        },
        PublishStateMachineVersion: {
          input: {
            type: "structure",
            required: [
              "stateMachineArn"
            ],
            members: {
              stateMachineArn: {},
              revisionId: {},
              description: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "creationDate",
              "stateMachineVersionArn"
            ],
            members: {
              creationDate: {
                type: "timestamp"
              },
              stateMachineVersionArn: {}
            }
          },
          idempotent: true
        },
        RedriveExecution: {
          input: {
            type: "structure",
            required: [
              "executionArn"
            ],
            members: {
              executionArn: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "redriveDate"
            ],
            members: {
              redriveDate: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        SendTaskFailure: {
          input: {
            type: "structure",
            required: [
              "taskToken"
            ],
            members: {
              taskToken: {},
              error: {
                shape: "S1d"
              },
              cause: {
                shape: "S1e"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SendTaskHeartbeat: {
          input: {
            type: "structure",
            required: [
              "taskToken"
            ],
            members: {
              taskToken: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SendTaskSuccess: {
          input: {
            type: "structure",
            required: [
              "taskToken",
              "output"
            ],
            members: {
              taskToken: {},
              output: {
                shape: "S19"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartExecution: {
          input: {
            type: "structure",
            required: [
              "stateMachineArn"
            ],
            members: {
              stateMachineArn: {},
              name: {},
              input: {
                shape: "S19"
              },
              traceHeader: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "executionArn",
              "startDate"
            ],
            members: {
              executionArn: {},
              startDate: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        StartSyncExecution: {
          input: {
            type: "structure",
            required: [
              "stateMachineArn"
            ],
            members: {
              stateMachineArn: {},
              name: {},
              input: {
                shape: "S19"
              },
              traceHeader: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "executionArn",
              "startDate",
              "stopDate",
              "status"
            ],
            members: {
              executionArn: {},
              stateMachineArn: {},
              name: {},
              startDate: {
                type: "timestamp"
              },
              stopDate: {
                type: "timestamp"
              },
              status: {},
              error: {
                shape: "S1d"
              },
              cause: {
                shape: "S1e"
              },
              input: {
                shape: "S19"
              },
              inputDetails: {
                shape: "S1a"
              },
              output: {
                shape: "S19"
              },
              outputDetails: {
                shape: "S1a"
              },
              traceHeader: {},
              billingDetails: {
                type: "structure",
                members: {
                  billedMemoryUsedInMB: {
                    type: "long"
                  },
                  billedDurationInMilliseconds: {
                    type: "long"
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "sync-"
          }
        },
        StopExecution: {
          input: {
            type: "structure",
            required: [
              "executionArn"
            ],
            members: {
              executionArn: {},
              error: {
                shape: "S1d"
              },
              cause: {
                shape: "S1e"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "stopDate"
            ],
            members: {
              stopDate: {
                type: "timestamp"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TestState: {
          input: {
            type: "structure",
            required: [
              "definition",
              "roleArn"
            ],
            members: {
              definition: {
                shape: "Sb"
              },
              roleArn: {},
              input: {
                shape: "S19"
              },
              inspectionLevel: {},
              revealSecrets: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              output: {
                shape: "S19"
              },
              error: {
                shape: "S1d"
              },
              cause: {
                shape: "S1e"
              },
              inspectionData: {
                type: "structure",
                members: {
                  input: {
                    shape: "S19"
                  },
                  afterInputPath: {
                    shape: "S19"
                  },
                  afterParameters: {
                    shape: "S19"
                  },
                  result: {
                    shape: "S19"
                  },
                  afterResultSelector: {
                    shape: "S19"
                  },
                  afterResultPath: {
                    shape: "S19"
                  },
                  request: {
                    type: "structure",
                    members: {
                      protocol: {},
                      method: {},
                      url: {},
                      headers: {},
                      body: {}
                    }
                  },
                  response: {
                    type: "structure",
                    members: {
                      protocol: {},
                      statusCode: {},
                      statusMessage: {},
                      headers: {},
                      body: {}
                    }
                  }
                },
                sensitive: true
              },
              nextState: {},
              status: {}
            }
          },
          endpoint: {
            hostPrefix: "sync-"
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateMapRun: {
          input: {
            type: "structure",
            required: [
              "mapRunArn"
            ],
            members: {
              mapRunArn: {},
              maxConcurrency: {
                type: "integer"
              },
              toleratedFailurePercentage: {
                type: "float"
              },
              toleratedFailureCount: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateStateMachine: {
          input: {
            type: "structure",
            required: [
              "stateMachineArn"
            ],
            members: {
              stateMachineArn: {},
              definition: {
                shape: "Sb"
              },
              roleArn: {},
              loggingConfiguration: {
                shape: "Sd"
              },
              tracingConfiguration: {
                shape: "Sj"
              },
              publish: {
                type: "boolean"
              },
              versionDescription: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "updateDate"
            ],
            members: {
              updateDate: {
                type: "timestamp"
              },
              revisionId: {},
              stateMachineVersionArn: {}
            }
          },
          idempotent: true
        },
        UpdateStateMachineAlias: {
          input: {
            type: "structure",
            required: [
              "stateMachineAliasArn"
            ],
            members: {
              stateMachineAliasArn: {},
              description: {
                shape: "Sp"
              },
              routingConfiguration: {
                shape: "Sr"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "updateDate"
            ],
            members: {
              updateDate: {
                type: "timestamp"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {
            type: "structure",
            members: {
              key: {},
              value: {}
            }
          }
        },
        Sb: {
          type: "string",
          sensitive: true
        },
        Sd: {
          type: "structure",
          members: {
            level: {},
            includeExecutionData: {
              type: "boolean"
            },
            destinations: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  cloudWatchLogsLogGroup: {
                    type: "structure",
                    members: {
                      logGroupArn: {}
                    }
                  }
                }
              }
            }
          }
        },
        Sj: {
          type: "structure",
          members: {
            enabled: {
              type: "boolean"
            }
          }
        },
        Sm: {
          type: "string",
          sensitive: true
        },
        Sp: {
          type: "string",
          sensitive: true
        },
        Sr: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "stateMachineVersionArn",
              "weight"
            ],
            members: {
              stateMachineVersionArn: {},
              weight: {
                type: "integer"
              }
            }
          }
        },
        S19: {
          type: "string",
          sensitive: true
        },
        S1a: {
          type: "structure",
          members: {
            included: {
              type: "boolean"
            }
          }
        },
        S1d: {
          type: "string",
          sensitive: true
        },
        S1e: {
          type: "string",
          sensitive: true
        },
        S2h: {
          type: "structure",
          members: {
            truncated: {
              type: "boolean"
            }
          }
        },
        S2r: {
          type: "structure",
          members: {
            roleArn: {}
          }
        },
        S36: {
          type: "structure",
          members: {
            name: {},
            index: {
              type: "integer"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/states-2016-11-23.paginators.json
var require_states_2016_11_23_paginators = __commonJS({
  "node_modules/aws-sdk/apis/states-2016-11-23.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetExecutionHistory: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "events"
        },
        ListActivities: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "activities"
        },
        ListExecutions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "executions"
        },
        ListMapRuns: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "mapRuns"
        },
        ListStateMachines: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "stateMachines"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/stepfunctions.js
var require_stepfunctions = __commonJS({
  "node_modules/aws-sdk/clients/stepfunctions.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["stepfunctions"] = {};
    AWS2.StepFunctions = Service.defineService("stepfunctions", ["2016-11-23"]);
    Object.defineProperty(apiLoader.services["stepfunctions"], "2016-11-23", {
      get: function get() {
        var model = require_states_2016_11_23_min();
        model.paginators = require_states_2016_11_23_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.StepFunctions;
  }
});

// node_modules/aws-sdk/apis/support-2013-04-15.min.json
var require_support_2013_04_15_min = __commonJS({
  "node_modules/aws-sdk/apis/support-2013-04-15.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2013-04-15",
        endpointPrefix: "support",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Support",
        serviceId: "Support",
        signatureVersion: "v4",
        targetPrefix: "AWSSupport_20130415",
        uid: "support-2013-04-15"
      },
      operations: {
        AddAttachmentsToSet: {
          input: {
            type: "structure",
            required: [
              "attachments"
            ],
            members: {
              attachmentSetId: {},
              attachments: {
                type: "list",
                member: {
                  shape: "S4"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              attachmentSetId: {},
              expiryTime: {}
            }
          }
        },
        AddCommunicationToCase: {
          input: {
            type: "structure",
            required: [
              "communicationBody"
            ],
            members: {
              caseId: {},
              communicationBody: {},
              ccEmailAddresses: {
                shape: "Sc"
              },
              attachmentSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              result: {
                type: "boolean"
              }
            }
          }
        },
        CreateCase: {
          input: {
            type: "structure",
            required: [
              "subject",
              "communicationBody"
            ],
            members: {
              subject: {},
              serviceCode: {},
              severityCode: {},
              categoryCode: {},
              communicationBody: {},
              ccEmailAddresses: {
                shape: "Sc"
              },
              language: {},
              issueType: {},
              attachmentSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              caseId: {}
            }
          }
        },
        DescribeAttachment: {
          input: {
            type: "structure",
            required: [
              "attachmentId"
            ],
            members: {
              attachmentId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              attachment: {
                shape: "S4"
              }
            }
          }
        },
        DescribeCases: {
          input: {
            type: "structure",
            members: {
              caseIdList: {
                type: "list",
                member: {}
              },
              displayId: {},
              afterTime: {},
              beforeTime: {},
              includeResolvedCases: {
                type: "boolean"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              language: {},
              includeCommunications: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              cases: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    caseId: {},
                    displayId: {},
                    subject: {},
                    status: {},
                    serviceCode: {},
                    categoryCode: {},
                    severityCode: {},
                    submittedBy: {},
                    timeCreated: {},
                    recentCommunications: {
                      type: "structure",
                      members: {
                        communications: {
                          shape: "S17"
                        },
                        nextToken: {}
                      }
                    },
                    ccEmailAddresses: {
                      shape: "Sc"
                    },
                    language: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeCommunications: {
          input: {
            type: "structure",
            required: [
              "caseId"
            ],
            members: {
              caseId: {},
              beforeTime: {},
              afterTime: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              communications: {
                shape: "S17"
              },
              nextToken: {}
            }
          }
        },
        DescribeCreateCaseOptions: {
          input: {
            type: "structure",
            required: [
              "issueType",
              "serviceCode",
              "language",
              "categoryCode"
            ],
            members: {
              issueType: {},
              serviceCode: {},
              language: {},
              categoryCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              languageAvailability: {},
              communicationTypes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    type: {},
                    supportedHours: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          startTime: {},
                          endTime: {}
                        }
                      }
                    },
                    datesWithoutSupport: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          startDateTime: {},
                          endDateTime: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeServices: {
          input: {
            type: "structure",
            members: {
              serviceCodeList: {
                type: "list",
                member: {}
              },
              language: {}
            }
          },
          output: {
            type: "structure",
            members: {
              services: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    code: {},
                    name: {},
                    categories: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          code: {},
                          name: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeSeverityLevels: {
          input: {
            type: "structure",
            members: {
              language: {}
            }
          },
          output: {
            type: "structure",
            members: {
              severityLevels: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    code: {},
                    name: {}
                  }
                }
              }
            }
          }
        },
        DescribeSupportedLanguages: {
          input: {
            type: "structure",
            required: [
              "issueType",
              "serviceCode",
              "categoryCode"
            ],
            members: {
              issueType: {},
              serviceCode: {},
              categoryCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              supportedLanguages: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    code: {},
                    language: {},
                    display: {}
                  }
                }
              }
            }
          }
        },
        DescribeTrustedAdvisorCheckRefreshStatuses: {
          input: {
            type: "structure",
            required: [
              "checkIds"
            ],
            members: {
              checkIds: {
                shape: "S2g"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "statuses"
            ],
            members: {
              statuses: {
                type: "list",
                member: {
                  shape: "S2k"
                }
              }
            }
          }
        },
        DescribeTrustedAdvisorCheckResult: {
          input: {
            type: "structure",
            required: [
              "checkId"
            ],
            members: {
              checkId: {},
              language: {}
            }
          },
          output: {
            type: "structure",
            members: {
              result: {
                type: "structure",
                required: [
                  "checkId",
                  "timestamp",
                  "status",
                  "resourcesSummary",
                  "categorySpecificSummary",
                  "flaggedResources"
                ],
                members: {
                  checkId: {},
                  timestamp: {},
                  status: {},
                  resourcesSummary: {
                    shape: "S2p"
                  },
                  categorySpecificSummary: {
                    shape: "S2q"
                  },
                  flaggedResources: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "status",
                        "resourceId",
                        "metadata"
                      ],
                      members: {
                        status: {},
                        region: {},
                        resourceId: {},
                        isSuppressed: {
                          type: "boolean"
                        },
                        metadata: {
                          shape: "S2g"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeTrustedAdvisorCheckSummaries: {
          input: {
            type: "structure",
            required: [
              "checkIds"
            ],
            members: {
              checkIds: {
                shape: "S2g"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "summaries"
            ],
            members: {
              summaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "checkId",
                    "timestamp",
                    "status",
                    "resourcesSummary",
                    "categorySpecificSummary"
                  ],
                  members: {
                    checkId: {},
                    timestamp: {},
                    status: {},
                    hasFlaggedResources: {
                      type: "boolean"
                    },
                    resourcesSummary: {
                      shape: "S2p"
                    },
                    categorySpecificSummary: {
                      shape: "S2q"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeTrustedAdvisorChecks: {
          input: {
            type: "structure",
            required: [
              "language"
            ],
            members: {
              language: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "checks"
            ],
            members: {
              checks: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "name",
                    "description",
                    "category",
                    "metadata"
                  ],
                  members: {
                    id: {},
                    name: {},
                    description: {},
                    category: {},
                    metadata: {
                      shape: "S2g"
                    }
                  }
                }
              }
            }
          }
        },
        RefreshTrustedAdvisorCheck: {
          input: {
            type: "structure",
            required: [
              "checkId"
            ],
            members: {
              checkId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "status"
            ],
            members: {
              status: {
                shape: "S2k"
              }
            }
          }
        },
        ResolveCase: {
          input: {
            type: "structure",
            members: {
              caseId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              initialCaseStatus: {},
              finalCaseStatus: {}
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            fileName: {},
            data: {
              type: "blob"
            }
          }
        },
        Sc: {
          type: "list",
          member: {}
        },
        S17: {
          type: "list",
          member: {
            type: "structure",
            members: {
              caseId: {},
              body: {},
              submittedBy: {},
              timeCreated: {},
              attachmentSet: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    attachmentId: {},
                    fileName: {}
                  }
                }
              }
            }
          }
        },
        S2g: {
          type: "list",
          member: {}
        },
        S2k: {
          type: "structure",
          required: [
            "checkId",
            "status",
            "millisUntilNextRefreshable"
          ],
          members: {
            checkId: {},
            status: {},
            millisUntilNextRefreshable: {
              type: "long"
            }
          }
        },
        S2p: {
          type: "structure",
          required: [
            "resourcesProcessed",
            "resourcesFlagged",
            "resourcesIgnored",
            "resourcesSuppressed"
          ],
          members: {
            resourcesProcessed: {
              type: "long"
            },
            resourcesFlagged: {
              type: "long"
            },
            resourcesIgnored: {
              type: "long"
            },
            resourcesSuppressed: {
              type: "long"
            }
          }
        },
        S2q: {
          type: "structure",
          members: {
            costOptimizing: {
              type: "structure",
              required: [
                "estimatedMonthlySavings",
                "estimatedPercentMonthlySavings"
              ],
              members: {
                estimatedMonthlySavings: {
                  type: "double"
                },
                estimatedPercentMonthlySavings: {
                  type: "double"
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/support-2013-04-15.paginators.json
var require_support_2013_04_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/support-2013-04-15.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeCases: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "cases"
        },
        DescribeCommunications: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "communications"
        },
        DescribeServices: {
          result_key: "services"
        },
        DescribeTrustedAdvisorCheckRefreshStatuses: {
          result_key: "statuses"
        },
        DescribeTrustedAdvisorCheckSummaries: {
          result_key: "summaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/support.js
var require_support = __commonJS({
  "node_modules/aws-sdk/clients/support.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["support"] = {};
    AWS2.Support = Service.defineService("support", ["2013-04-15"]);
    Object.defineProperty(apiLoader.services["support"], "2013-04-15", {
      get: function get() {
        var model = require_support_2013_04_15_min();
        model.paginators = require_support_2013_04_15_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Support;
  }
});

// node_modules/aws-sdk/lib/services/swf.js
var require_swf = __commonJS({
  "node_modules/aws-sdk/lib/services/swf.js"() {
    "use strict";
    var AWS2 = require_core();
    AWS2.util.hideProperties(AWS2, ["SimpleWorkflow"]);
    AWS2.SimpleWorkflow = AWS2.SWF;
  }
});

// node_modules/aws-sdk/apis/swf-2012-01-25.min.json
var require_swf_2012_01_25_min = __commonJS({
  "node_modules/aws-sdk/apis/swf-2012-01-25.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2012-01-25",
        endpointPrefix: "swf",
        jsonVersion: "1.0",
        protocol: "json",
        serviceAbbreviation: "Amazon SWF",
        serviceFullName: "Amazon Simple Workflow Service",
        serviceId: "SWF",
        signatureVersion: "v4",
        targetPrefix: "SimpleWorkflowService",
        uid: "swf-2012-01-25"
      },
      operations: {
        CountClosedWorkflowExecutions: {
          input: {
            type: "structure",
            required: [
              "domain"
            ],
            members: {
              domain: {},
              startTimeFilter: {
                shape: "S3"
              },
              closeTimeFilter: {
                shape: "S3"
              },
              executionFilter: {
                shape: "S5"
              },
              typeFilter: {
                shape: "S7"
              },
              tagFilter: {
                shape: "Sa"
              },
              closeStatusFilter: {
                shape: "Sc"
              }
            }
          },
          output: {
            shape: "Se"
          }
        },
        CountOpenWorkflowExecutions: {
          input: {
            type: "structure",
            required: [
              "domain",
              "startTimeFilter"
            ],
            members: {
              domain: {},
              startTimeFilter: {
                shape: "S3"
              },
              typeFilter: {
                shape: "S7"
              },
              tagFilter: {
                shape: "Sa"
              },
              executionFilter: {
                shape: "S5"
              }
            }
          },
          output: {
            shape: "Se"
          }
        },
        CountPendingActivityTasks: {
          input: {
            type: "structure",
            required: [
              "domain",
              "taskList"
            ],
            members: {
              domain: {},
              taskList: {
                shape: "Sj"
              }
            }
          },
          output: {
            shape: "Sk"
          }
        },
        CountPendingDecisionTasks: {
          input: {
            type: "structure",
            required: [
              "domain",
              "taskList"
            ],
            members: {
              domain: {},
              taskList: {
                shape: "Sj"
              }
            }
          },
          output: {
            shape: "Sk"
          }
        },
        DeprecateActivityType: {
          input: {
            type: "structure",
            required: [
              "domain",
              "activityType"
            ],
            members: {
              domain: {},
              activityType: {
                shape: "Sn"
              }
            }
          }
        },
        DeprecateDomain: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          }
        },
        DeprecateWorkflowType: {
          input: {
            type: "structure",
            required: [
              "domain",
              "workflowType"
            ],
            members: {
              domain: {},
              workflowType: {
                shape: "Sr"
              }
            }
          }
        },
        DescribeActivityType: {
          input: {
            type: "structure",
            required: [
              "domain",
              "activityType"
            ],
            members: {
              domain: {},
              activityType: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "typeInfo",
              "configuration"
            ],
            members: {
              typeInfo: {
                shape: "Su"
              },
              configuration: {
                type: "structure",
                members: {
                  defaultTaskStartToCloseTimeout: {},
                  defaultTaskHeartbeatTimeout: {},
                  defaultTaskList: {
                    shape: "Sj"
                  },
                  defaultTaskPriority: {},
                  defaultTaskScheduleToStartTimeout: {},
                  defaultTaskScheduleToCloseTimeout: {}
                }
              }
            }
          }
        },
        DescribeDomain: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "domainInfo",
              "configuration"
            ],
            members: {
              domainInfo: {
                shape: "S12"
              },
              configuration: {
                type: "structure",
                required: [
                  "workflowExecutionRetentionPeriodInDays"
                ],
                members: {
                  workflowExecutionRetentionPeriodInDays: {}
                }
              }
            }
          }
        },
        DescribeWorkflowExecution: {
          input: {
            type: "structure",
            required: [
              "domain",
              "execution"
            ],
            members: {
              domain: {},
              execution: {
                shape: "S17"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "executionInfo",
              "executionConfiguration",
              "openCounts"
            ],
            members: {
              executionInfo: {
                shape: "S1a"
              },
              executionConfiguration: {
                type: "structure",
                required: [
                  "taskStartToCloseTimeout",
                  "executionStartToCloseTimeout",
                  "taskList",
                  "childPolicy"
                ],
                members: {
                  taskStartToCloseTimeout: {},
                  executionStartToCloseTimeout: {},
                  taskList: {
                    shape: "Sj"
                  },
                  taskPriority: {},
                  childPolicy: {},
                  lambdaRole: {}
                }
              },
              openCounts: {
                type: "structure",
                required: [
                  "openActivityTasks",
                  "openDecisionTasks",
                  "openTimers",
                  "openChildWorkflowExecutions"
                ],
                members: {
                  openActivityTasks: {
                    type: "integer"
                  },
                  openDecisionTasks: {
                    type: "integer"
                  },
                  openTimers: {
                    type: "integer"
                  },
                  openChildWorkflowExecutions: {
                    type: "integer"
                  },
                  openLambdaFunctions: {
                    type: "integer"
                  }
                }
              },
              latestActivityTaskTimestamp: {
                type: "timestamp"
              },
              latestExecutionContext: {}
            }
          }
        },
        DescribeWorkflowType: {
          input: {
            type: "structure",
            required: [
              "domain",
              "workflowType"
            ],
            members: {
              domain: {},
              workflowType: {
                shape: "Sr"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "typeInfo",
              "configuration"
            ],
            members: {
              typeInfo: {
                shape: "S1m"
              },
              configuration: {
                type: "structure",
                members: {
                  defaultTaskStartToCloseTimeout: {},
                  defaultExecutionStartToCloseTimeout: {},
                  defaultTaskList: {
                    shape: "Sj"
                  },
                  defaultTaskPriority: {},
                  defaultChildPolicy: {},
                  defaultLambdaRole: {}
                }
              }
            }
          }
        },
        GetWorkflowExecutionHistory: {
          input: {
            type: "structure",
            required: [
              "domain",
              "execution"
            ],
            members: {
              domain: {},
              execution: {
                shape: "S17"
              },
              nextPageToken: {},
              maximumPageSize: {
                type: "integer"
              },
              reverseOrder: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "events"
            ],
            members: {
              events: {
                shape: "S1t"
              },
              nextPageToken: {}
            }
          }
        },
        ListActivityTypes: {
          input: {
            type: "structure",
            required: [
              "domain",
              "registrationStatus"
            ],
            members: {
              domain: {},
              name: {},
              registrationStatus: {},
              nextPageToken: {},
              maximumPageSize: {
                type: "integer"
              },
              reverseOrder: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "typeInfos"
            ],
            members: {
              typeInfos: {
                type: "list",
                member: {
                  shape: "Su"
                }
              },
              nextPageToken: {}
            }
          }
        },
        ListClosedWorkflowExecutions: {
          input: {
            type: "structure",
            required: [
              "domain"
            ],
            members: {
              domain: {},
              startTimeFilter: {
                shape: "S3"
              },
              closeTimeFilter: {
                shape: "S3"
              },
              executionFilter: {
                shape: "S5"
              },
              closeStatusFilter: {
                shape: "Sc"
              },
              typeFilter: {
                shape: "S7"
              },
              tagFilter: {
                shape: "Sa"
              },
              nextPageToken: {},
              maximumPageSize: {
                type: "integer"
              },
              reverseOrder: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S4g"
          }
        },
        ListDomains: {
          input: {
            type: "structure",
            required: [
              "registrationStatus"
            ],
            members: {
              nextPageToken: {},
              registrationStatus: {},
              maximumPageSize: {
                type: "integer"
              },
              reverseOrder: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "domainInfos"
            ],
            members: {
              domainInfos: {
                type: "list",
                member: {
                  shape: "S12"
                }
              },
              nextPageToken: {}
            }
          }
        },
        ListOpenWorkflowExecutions: {
          input: {
            type: "structure",
            required: [
              "domain",
              "startTimeFilter"
            ],
            members: {
              domain: {},
              startTimeFilter: {
                shape: "S3"
              },
              typeFilter: {
                shape: "S7"
              },
              tagFilter: {
                shape: "Sa"
              },
              nextPageToken: {},
              maximumPageSize: {
                type: "integer"
              },
              reverseOrder: {
                type: "boolean"
              },
              executionFilter: {
                shape: "S5"
              }
            }
          },
          output: {
            shape: "S4g"
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S4o"
              }
            }
          }
        },
        ListWorkflowTypes: {
          input: {
            type: "structure",
            required: [
              "domain",
              "registrationStatus"
            ],
            members: {
              domain: {},
              name: {},
              registrationStatus: {},
              nextPageToken: {},
              maximumPageSize: {
                type: "integer"
              },
              reverseOrder: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "typeInfos"
            ],
            members: {
              typeInfos: {
                type: "list",
                member: {
                  shape: "S1m"
                }
              },
              nextPageToken: {}
            }
          }
        },
        PollForActivityTask: {
          input: {
            type: "structure",
            required: [
              "domain",
              "taskList"
            ],
            members: {
              domain: {},
              taskList: {
                shape: "Sj"
              },
              identity: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "taskToken",
              "activityId",
              "startedEventId",
              "workflowExecution",
              "activityType"
            ],
            members: {
              taskToken: {},
              activityId: {},
              startedEventId: {
                type: "long"
              },
              workflowExecution: {
                shape: "S17"
              },
              activityType: {
                shape: "Sn"
              },
              input: {}
            }
          }
        },
        PollForDecisionTask: {
          input: {
            type: "structure",
            required: [
              "domain",
              "taskList"
            ],
            members: {
              domain: {},
              taskList: {
                shape: "Sj"
              },
              identity: {},
              nextPageToken: {},
              maximumPageSize: {
                type: "integer"
              },
              reverseOrder: {
                type: "boolean"
              },
              startAtPreviousStartedEvent: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "taskToken",
              "startedEventId",
              "workflowExecution",
              "workflowType",
              "events"
            ],
            members: {
              taskToken: {},
              startedEventId: {
                type: "long"
              },
              workflowExecution: {
                shape: "S17"
              },
              workflowType: {
                shape: "Sr"
              },
              events: {
                shape: "S1t"
              },
              nextPageToken: {},
              previousStartedEventId: {
                type: "long"
              }
            }
          }
        },
        RecordActivityTaskHeartbeat: {
          input: {
            type: "structure",
            required: [
              "taskToken"
            ],
            members: {
              taskToken: {},
              details: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "cancelRequested"
            ],
            members: {
              cancelRequested: {
                type: "boolean"
              }
            }
          }
        },
        RegisterActivityType: {
          input: {
            type: "structure",
            required: [
              "domain",
              "name",
              "version"
            ],
            members: {
              domain: {},
              name: {},
              version: {},
              description: {},
              defaultTaskStartToCloseTimeout: {},
              defaultTaskHeartbeatTimeout: {},
              defaultTaskList: {
                shape: "Sj"
              },
              defaultTaskPriority: {},
              defaultTaskScheduleToStartTimeout: {},
              defaultTaskScheduleToCloseTimeout: {}
            }
          }
        },
        RegisterDomain: {
          input: {
            type: "structure",
            required: [
              "name",
              "workflowExecutionRetentionPeriodInDays"
            ],
            members: {
              name: {},
              description: {},
              workflowExecutionRetentionPeriodInDays: {},
              tags: {
                shape: "S4o"
              }
            }
          }
        },
        RegisterWorkflowType: {
          input: {
            type: "structure",
            required: [
              "domain",
              "name",
              "version"
            ],
            members: {
              domain: {},
              name: {},
              version: {},
              description: {},
              defaultTaskStartToCloseTimeout: {},
              defaultExecutionStartToCloseTimeout: {},
              defaultTaskList: {
                shape: "Sj"
              },
              defaultTaskPriority: {},
              defaultChildPolicy: {},
              defaultLambdaRole: {}
            }
          }
        },
        RequestCancelWorkflowExecution: {
          input: {
            type: "structure",
            required: [
              "domain",
              "workflowId"
            ],
            members: {
              domain: {},
              workflowId: {},
              runId: {}
            }
          }
        },
        RespondActivityTaskCanceled: {
          input: {
            type: "structure",
            required: [
              "taskToken"
            ],
            members: {
              taskToken: {},
              details: {}
            }
          }
        },
        RespondActivityTaskCompleted: {
          input: {
            type: "structure",
            required: [
              "taskToken"
            ],
            members: {
              taskToken: {},
              result: {}
            }
          }
        },
        RespondActivityTaskFailed: {
          input: {
            type: "structure",
            required: [
              "taskToken"
            ],
            members: {
              taskToken: {},
              reason: {},
              details: {}
            }
          }
        },
        RespondDecisionTaskCompleted: {
          input: {
            type: "structure",
            required: [
              "taskToken"
            ],
            members: {
              taskToken: {},
              decisions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "decisionType"
                  ],
                  members: {
                    decisionType: {},
                    scheduleActivityTaskDecisionAttributes: {
                      type: "structure",
                      required: [
                        "activityType",
                        "activityId"
                      ],
                      members: {
                        activityType: {
                          shape: "Sn"
                        },
                        activityId: {},
                        control: {},
                        input: {},
                        scheduleToCloseTimeout: {},
                        taskList: {
                          shape: "Sj"
                        },
                        taskPriority: {},
                        scheduleToStartTimeout: {},
                        startToCloseTimeout: {},
                        heartbeatTimeout: {}
                      }
                    },
                    requestCancelActivityTaskDecisionAttributes: {
                      type: "structure",
                      required: [
                        "activityId"
                      ],
                      members: {
                        activityId: {}
                      }
                    },
                    completeWorkflowExecutionDecisionAttributes: {
                      type: "structure",
                      members: {
                        result: {}
                      }
                    },
                    failWorkflowExecutionDecisionAttributes: {
                      type: "structure",
                      members: {
                        reason: {},
                        details: {}
                      }
                    },
                    cancelWorkflowExecutionDecisionAttributes: {
                      type: "structure",
                      members: {
                        details: {}
                      }
                    },
                    continueAsNewWorkflowExecutionDecisionAttributes: {
                      type: "structure",
                      members: {
                        input: {},
                        executionStartToCloseTimeout: {},
                        taskList: {
                          shape: "Sj"
                        },
                        taskPriority: {},
                        taskStartToCloseTimeout: {},
                        childPolicy: {},
                        tagList: {
                          shape: "S1c"
                        },
                        workflowTypeVersion: {},
                        lambdaRole: {}
                      }
                    },
                    recordMarkerDecisionAttributes: {
                      type: "structure",
                      required: [
                        "markerName"
                      ],
                      members: {
                        markerName: {},
                        details: {}
                      }
                    },
                    startTimerDecisionAttributes: {
                      type: "structure",
                      required: [
                        "timerId",
                        "startToFireTimeout"
                      ],
                      members: {
                        timerId: {},
                        control: {},
                        startToFireTimeout: {}
                      }
                    },
                    cancelTimerDecisionAttributes: {
                      type: "structure",
                      required: [
                        "timerId"
                      ],
                      members: {
                        timerId: {}
                      }
                    },
                    signalExternalWorkflowExecutionDecisionAttributes: {
                      type: "structure",
                      required: [
                        "workflowId",
                        "signalName"
                      ],
                      members: {
                        workflowId: {},
                        runId: {},
                        signalName: {},
                        input: {},
                        control: {}
                      }
                    },
                    requestCancelExternalWorkflowExecutionDecisionAttributes: {
                      type: "structure",
                      required: [
                        "workflowId"
                      ],
                      members: {
                        workflowId: {},
                        runId: {},
                        control: {}
                      }
                    },
                    startChildWorkflowExecutionDecisionAttributes: {
                      type: "structure",
                      required: [
                        "workflowType",
                        "workflowId"
                      ],
                      members: {
                        workflowType: {
                          shape: "Sr"
                        },
                        workflowId: {},
                        control: {},
                        input: {},
                        executionStartToCloseTimeout: {},
                        taskList: {
                          shape: "Sj"
                        },
                        taskPriority: {},
                        taskStartToCloseTimeout: {},
                        childPolicy: {},
                        tagList: {
                          shape: "S1c"
                        },
                        lambdaRole: {}
                      }
                    },
                    scheduleLambdaFunctionDecisionAttributes: {
                      type: "structure",
                      required: [
                        "id",
                        "name"
                      ],
                      members: {
                        id: {},
                        name: {},
                        control: {},
                        input: {},
                        startToCloseTimeout: {}
                      }
                    }
                  }
                }
              },
              executionContext: {},
              taskList: {
                shape: "Sj"
              },
              taskListScheduleToStartTimeout: {}
            }
          }
        },
        SignalWorkflowExecution: {
          input: {
            type: "structure",
            required: [
              "domain",
              "workflowId",
              "signalName"
            ],
            members: {
              domain: {},
              workflowId: {},
              runId: {},
              signalName: {},
              input: {}
            }
          }
        },
        StartWorkflowExecution: {
          input: {
            type: "structure",
            required: [
              "domain",
              "workflowId",
              "workflowType"
            ],
            members: {
              domain: {},
              workflowId: {},
              workflowType: {
                shape: "Sr"
              },
              taskList: {
                shape: "Sj"
              },
              taskPriority: {},
              input: {},
              executionStartToCloseTimeout: {},
              tagList: {
                shape: "S1c"
              },
              taskStartToCloseTimeout: {},
              childPolicy: {},
              lambdaRole: {}
            }
          },
          output: {
            type: "structure",
            members: {
              runId: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "S4o"
              }
            }
          }
        },
        TerminateWorkflowExecution: {
          input: {
            type: "structure",
            required: [
              "domain",
              "workflowId"
            ],
            members: {
              domain: {},
              workflowId: {},
              runId: {},
              reason: {},
              details: {},
              childPolicy: {}
            }
          }
        },
        UndeprecateActivityType: {
          input: {
            type: "structure",
            required: [
              "domain",
              "activityType"
            ],
            members: {
              domain: {},
              activityType: {
                shape: "Sn"
              }
            }
          }
        },
        UndeprecateDomain: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          }
        },
        UndeprecateWorkflowType: {
          input: {
            type: "structure",
            required: [
              "domain",
              "workflowType"
            ],
            members: {
              domain: {},
              workflowType: {
                shape: "Sr"
              }
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          required: [
            "oldestDate"
          ],
          members: {
            oldestDate: {
              type: "timestamp"
            },
            latestDate: {
              type: "timestamp"
            }
          }
        },
        S5: {
          type: "structure",
          required: [
            "workflowId"
          ],
          members: {
            workflowId: {}
          }
        },
        S7: {
          type: "structure",
          required: [
            "name"
          ],
          members: {
            name: {},
            version: {}
          }
        },
        Sa: {
          type: "structure",
          required: [
            "tag"
          ],
          members: {
            tag: {}
          }
        },
        Sc: {
          type: "structure",
          required: [
            "status"
          ],
          members: {
            status: {}
          }
        },
        Se: {
          type: "structure",
          required: [
            "count"
          ],
          members: {
            count: {
              type: "integer"
            },
            truncated: {
              type: "boolean"
            }
          }
        },
        Sj: {
          type: "structure",
          required: [
            "name"
          ],
          members: {
            name: {}
          }
        },
        Sk: {
          type: "structure",
          required: [
            "count"
          ],
          members: {
            count: {
              type: "integer"
            },
            truncated: {
              type: "boolean"
            }
          }
        },
        Sn: {
          type: "structure",
          required: [
            "name",
            "version"
          ],
          members: {
            name: {},
            version: {}
          }
        },
        Sr: {
          type: "structure",
          required: [
            "name",
            "version"
          ],
          members: {
            name: {},
            version: {}
          }
        },
        Su: {
          type: "structure",
          required: [
            "activityType",
            "status",
            "creationDate"
          ],
          members: {
            activityType: {
              shape: "Sn"
            },
            status: {},
            description: {},
            creationDate: {
              type: "timestamp"
            },
            deprecationDate: {
              type: "timestamp"
            }
          }
        },
        S12: {
          type: "structure",
          required: [
            "name",
            "status"
          ],
          members: {
            name: {},
            status: {},
            description: {},
            arn: {}
          }
        },
        S17: {
          type: "structure",
          required: [
            "workflowId",
            "runId"
          ],
          members: {
            workflowId: {},
            runId: {}
          }
        },
        S1a: {
          type: "structure",
          required: [
            "execution",
            "workflowType",
            "startTimestamp",
            "executionStatus"
          ],
          members: {
            execution: {
              shape: "S17"
            },
            workflowType: {
              shape: "Sr"
            },
            startTimestamp: {
              type: "timestamp"
            },
            closeTimestamp: {
              type: "timestamp"
            },
            executionStatus: {},
            closeStatus: {},
            parent: {
              shape: "S17"
            },
            tagList: {
              shape: "S1c"
            },
            cancelRequested: {
              type: "boolean"
            }
          }
        },
        S1c: {
          type: "list",
          member: {}
        },
        S1m: {
          type: "structure",
          required: [
            "workflowType",
            "status",
            "creationDate"
          ],
          members: {
            workflowType: {
              shape: "Sr"
            },
            status: {},
            description: {},
            creationDate: {
              type: "timestamp"
            },
            deprecationDate: {
              type: "timestamp"
            }
          }
        },
        S1t: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "eventTimestamp",
              "eventType",
              "eventId"
            ],
            members: {
              eventTimestamp: {
                type: "timestamp"
              },
              eventType: {},
              eventId: {
                type: "long"
              },
              workflowExecutionStartedEventAttributes: {
                type: "structure",
                required: [
                  "childPolicy",
                  "taskList",
                  "workflowType"
                ],
                members: {
                  input: {},
                  executionStartToCloseTimeout: {},
                  taskStartToCloseTimeout: {},
                  childPolicy: {},
                  taskList: {
                    shape: "Sj"
                  },
                  taskPriority: {},
                  workflowType: {
                    shape: "Sr"
                  },
                  tagList: {
                    shape: "S1c"
                  },
                  continuedExecutionRunId: {},
                  parentWorkflowExecution: {
                    shape: "S17"
                  },
                  parentInitiatedEventId: {
                    type: "long"
                  },
                  lambdaRole: {}
                }
              },
              workflowExecutionCompletedEventAttributes: {
                type: "structure",
                required: [
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  result: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              completeWorkflowExecutionFailedEventAttributes: {
                type: "structure",
                required: [
                  "cause",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  cause: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              workflowExecutionFailedEventAttributes: {
                type: "structure",
                required: [
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  reason: {},
                  details: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              failWorkflowExecutionFailedEventAttributes: {
                type: "structure",
                required: [
                  "cause",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  cause: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              workflowExecutionTimedOutEventAttributes: {
                type: "structure",
                required: [
                  "timeoutType",
                  "childPolicy"
                ],
                members: {
                  timeoutType: {},
                  childPolicy: {}
                }
              },
              workflowExecutionCanceledEventAttributes: {
                type: "structure",
                required: [
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  details: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              cancelWorkflowExecutionFailedEventAttributes: {
                type: "structure",
                required: [
                  "cause",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  cause: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              workflowExecutionContinuedAsNewEventAttributes: {
                type: "structure",
                required: [
                  "decisionTaskCompletedEventId",
                  "newExecutionRunId",
                  "taskList",
                  "childPolicy",
                  "workflowType"
                ],
                members: {
                  input: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  },
                  newExecutionRunId: {},
                  executionStartToCloseTimeout: {},
                  taskList: {
                    shape: "Sj"
                  },
                  taskPriority: {},
                  taskStartToCloseTimeout: {},
                  childPolicy: {},
                  tagList: {
                    shape: "S1c"
                  },
                  workflowType: {
                    shape: "Sr"
                  },
                  lambdaRole: {}
                }
              },
              continueAsNewWorkflowExecutionFailedEventAttributes: {
                type: "structure",
                required: [
                  "cause",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  cause: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              workflowExecutionTerminatedEventAttributes: {
                type: "structure",
                required: [
                  "childPolicy"
                ],
                members: {
                  reason: {},
                  details: {},
                  childPolicy: {},
                  cause: {}
                }
              },
              workflowExecutionCancelRequestedEventAttributes: {
                type: "structure",
                members: {
                  externalWorkflowExecution: {
                    shape: "S17"
                  },
                  externalInitiatedEventId: {
                    type: "long"
                  },
                  cause: {}
                }
              },
              decisionTaskScheduledEventAttributes: {
                type: "structure",
                required: [
                  "taskList"
                ],
                members: {
                  taskList: {
                    shape: "Sj"
                  },
                  taskPriority: {},
                  startToCloseTimeout: {},
                  scheduleToStartTimeout: {}
                }
              },
              decisionTaskStartedEventAttributes: {
                type: "structure",
                required: [
                  "scheduledEventId"
                ],
                members: {
                  identity: {},
                  scheduledEventId: {
                    type: "long"
                  }
                }
              },
              decisionTaskCompletedEventAttributes: {
                type: "structure",
                required: [
                  "scheduledEventId",
                  "startedEventId"
                ],
                members: {
                  executionContext: {},
                  scheduledEventId: {
                    type: "long"
                  },
                  startedEventId: {
                    type: "long"
                  },
                  taskList: {
                    shape: "Sj"
                  },
                  taskListScheduleToStartTimeout: {}
                }
              },
              decisionTaskTimedOutEventAttributes: {
                type: "structure",
                required: [
                  "timeoutType",
                  "scheduledEventId",
                  "startedEventId"
                ],
                members: {
                  timeoutType: {},
                  scheduledEventId: {
                    type: "long"
                  },
                  startedEventId: {
                    type: "long"
                  }
                }
              },
              activityTaskScheduledEventAttributes: {
                type: "structure",
                required: [
                  "activityType",
                  "activityId",
                  "taskList",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  activityType: {
                    shape: "Sn"
                  },
                  activityId: {},
                  input: {},
                  control: {},
                  scheduleToStartTimeout: {},
                  scheduleToCloseTimeout: {},
                  startToCloseTimeout: {},
                  taskList: {
                    shape: "Sj"
                  },
                  taskPriority: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  },
                  heartbeatTimeout: {}
                }
              },
              activityTaskStartedEventAttributes: {
                type: "structure",
                required: [
                  "scheduledEventId"
                ],
                members: {
                  identity: {},
                  scheduledEventId: {
                    type: "long"
                  }
                }
              },
              activityTaskCompletedEventAttributes: {
                type: "structure",
                required: [
                  "scheduledEventId",
                  "startedEventId"
                ],
                members: {
                  result: {},
                  scheduledEventId: {
                    type: "long"
                  },
                  startedEventId: {
                    type: "long"
                  }
                }
              },
              activityTaskFailedEventAttributes: {
                type: "structure",
                required: [
                  "scheduledEventId",
                  "startedEventId"
                ],
                members: {
                  reason: {},
                  details: {},
                  scheduledEventId: {
                    type: "long"
                  },
                  startedEventId: {
                    type: "long"
                  }
                }
              },
              activityTaskTimedOutEventAttributes: {
                type: "structure",
                required: [
                  "timeoutType",
                  "scheduledEventId",
                  "startedEventId"
                ],
                members: {
                  timeoutType: {},
                  scheduledEventId: {
                    type: "long"
                  },
                  startedEventId: {
                    type: "long"
                  },
                  details: {}
                }
              },
              activityTaskCanceledEventAttributes: {
                type: "structure",
                required: [
                  "scheduledEventId",
                  "startedEventId"
                ],
                members: {
                  details: {},
                  scheduledEventId: {
                    type: "long"
                  },
                  startedEventId: {
                    type: "long"
                  },
                  latestCancelRequestedEventId: {
                    type: "long"
                  }
                }
              },
              activityTaskCancelRequestedEventAttributes: {
                type: "structure",
                required: [
                  "decisionTaskCompletedEventId",
                  "activityId"
                ],
                members: {
                  decisionTaskCompletedEventId: {
                    type: "long"
                  },
                  activityId: {}
                }
              },
              workflowExecutionSignaledEventAttributes: {
                type: "structure",
                required: [
                  "signalName"
                ],
                members: {
                  signalName: {},
                  input: {},
                  externalWorkflowExecution: {
                    shape: "S17"
                  },
                  externalInitiatedEventId: {
                    type: "long"
                  }
                }
              },
              markerRecordedEventAttributes: {
                type: "structure",
                required: [
                  "markerName",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  markerName: {},
                  details: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              recordMarkerFailedEventAttributes: {
                type: "structure",
                required: [
                  "markerName",
                  "cause",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  markerName: {},
                  cause: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              timerStartedEventAttributes: {
                type: "structure",
                required: [
                  "timerId",
                  "startToFireTimeout",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  timerId: {},
                  control: {},
                  startToFireTimeout: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              timerFiredEventAttributes: {
                type: "structure",
                required: [
                  "timerId",
                  "startedEventId"
                ],
                members: {
                  timerId: {},
                  startedEventId: {
                    type: "long"
                  }
                }
              },
              timerCanceledEventAttributes: {
                type: "structure",
                required: [
                  "timerId",
                  "startedEventId",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  timerId: {},
                  startedEventId: {
                    type: "long"
                  },
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              startChildWorkflowExecutionInitiatedEventAttributes: {
                type: "structure",
                required: [
                  "workflowId",
                  "workflowType",
                  "taskList",
                  "decisionTaskCompletedEventId",
                  "childPolicy"
                ],
                members: {
                  workflowId: {},
                  workflowType: {
                    shape: "Sr"
                  },
                  control: {},
                  input: {},
                  executionStartToCloseTimeout: {},
                  taskList: {
                    shape: "Sj"
                  },
                  taskPriority: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  },
                  childPolicy: {},
                  taskStartToCloseTimeout: {},
                  tagList: {
                    shape: "S1c"
                  },
                  lambdaRole: {}
                }
              },
              childWorkflowExecutionStartedEventAttributes: {
                type: "structure",
                required: [
                  "workflowExecution",
                  "workflowType",
                  "initiatedEventId"
                ],
                members: {
                  workflowExecution: {
                    shape: "S17"
                  },
                  workflowType: {
                    shape: "Sr"
                  },
                  initiatedEventId: {
                    type: "long"
                  }
                }
              },
              childWorkflowExecutionCompletedEventAttributes: {
                type: "structure",
                required: [
                  "workflowExecution",
                  "workflowType",
                  "initiatedEventId",
                  "startedEventId"
                ],
                members: {
                  workflowExecution: {
                    shape: "S17"
                  },
                  workflowType: {
                    shape: "Sr"
                  },
                  result: {},
                  initiatedEventId: {
                    type: "long"
                  },
                  startedEventId: {
                    type: "long"
                  }
                }
              },
              childWorkflowExecutionFailedEventAttributes: {
                type: "structure",
                required: [
                  "workflowExecution",
                  "workflowType",
                  "initiatedEventId",
                  "startedEventId"
                ],
                members: {
                  workflowExecution: {
                    shape: "S17"
                  },
                  workflowType: {
                    shape: "Sr"
                  },
                  reason: {},
                  details: {},
                  initiatedEventId: {
                    type: "long"
                  },
                  startedEventId: {
                    type: "long"
                  }
                }
              },
              childWorkflowExecutionTimedOutEventAttributes: {
                type: "structure",
                required: [
                  "workflowExecution",
                  "workflowType",
                  "timeoutType",
                  "initiatedEventId",
                  "startedEventId"
                ],
                members: {
                  workflowExecution: {
                    shape: "S17"
                  },
                  workflowType: {
                    shape: "Sr"
                  },
                  timeoutType: {},
                  initiatedEventId: {
                    type: "long"
                  },
                  startedEventId: {
                    type: "long"
                  }
                }
              },
              childWorkflowExecutionCanceledEventAttributes: {
                type: "structure",
                required: [
                  "workflowExecution",
                  "workflowType",
                  "initiatedEventId",
                  "startedEventId"
                ],
                members: {
                  workflowExecution: {
                    shape: "S17"
                  },
                  workflowType: {
                    shape: "Sr"
                  },
                  details: {},
                  initiatedEventId: {
                    type: "long"
                  },
                  startedEventId: {
                    type: "long"
                  }
                }
              },
              childWorkflowExecutionTerminatedEventAttributes: {
                type: "structure",
                required: [
                  "workflowExecution",
                  "workflowType",
                  "initiatedEventId",
                  "startedEventId"
                ],
                members: {
                  workflowExecution: {
                    shape: "S17"
                  },
                  workflowType: {
                    shape: "Sr"
                  },
                  initiatedEventId: {
                    type: "long"
                  },
                  startedEventId: {
                    type: "long"
                  }
                }
              },
              signalExternalWorkflowExecutionInitiatedEventAttributes: {
                type: "structure",
                required: [
                  "workflowId",
                  "signalName",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  workflowId: {},
                  runId: {},
                  signalName: {},
                  input: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  },
                  control: {}
                }
              },
              externalWorkflowExecutionSignaledEventAttributes: {
                type: "structure",
                required: [
                  "workflowExecution",
                  "initiatedEventId"
                ],
                members: {
                  workflowExecution: {
                    shape: "S17"
                  },
                  initiatedEventId: {
                    type: "long"
                  }
                }
              },
              signalExternalWorkflowExecutionFailedEventAttributes: {
                type: "structure",
                required: [
                  "workflowId",
                  "cause",
                  "initiatedEventId",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  workflowId: {},
                  runId: {},
                  cause: {},
                  initiatedEventId: {
                    type: "long"
                  },
                  decisionTaskCompletedEventId: {
                    type: "long"
                  },
                  control: {}
                }
              },
              externalWorkflowExecutionCancelRequestedEventAttributes: {
                type: "structure",
                required: [
                  "workflowExecution",
                  "initiatedEventId"
                ],
                members: {
                  workflowExecution: {
                    shape: "S17"
                  },
                  initiatedEventId: {
                    type: "long"
                  }
                }
              },
              requestCancelExternalWorkflowExecutionInitiatedEventAttributes: {
                type: "structure",
                required: [
                  "workflowId",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  workflowId: {},
                  runId: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  },
                  control: {}
                }
              },
              requestCancelExternalWorkflowExecutionFailedEventAttributes: {
                type: "structure",
                required: [
                  "workflowId",
                  "cause",
                  "initiatedEventId",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  workflowId: {},
                  runId: {},
                  cause: {},
                  initiatedEventId: {
                    type: "long"
                  },
                  decisionTaskCompletedEventId: {
                    type: "long"
                  },
                  control: {}
                }
              },
              scheduleActivityTaskFailedEventAttributes: {
                type: "structure",
                required: [
                  "activityType",
                  "activityId",
                  "cause",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  activityType: {
                    shape: "Sn"
                  },
                  activityId: {},
                  cause: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              requestCancelActivityTaskFailedEventAttributes: {
                type: "structure",
                required: [
                  "activityId",
                  "cause",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  activityId: {},
                  cause: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              startTimerFailedEventAttributes: {
                type: "structure",
                required: [
                  "timerId",
                  "cause",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  timerId: {},
                  cause: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              cancelTimerFailedEventAttributes: {
                type: "structure",
                required: [
                  "timerId",
                  "cause",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  timerId: {},
                  cause: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              startChildWorkflowExecutionFailedEventAttributes: {
                type: "structure",
                required: [
                  "workflowType",
                  "cause",
                  "workflowId",
                  "initiatedEventId",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  workflowType: {
                    shape: "Sr"
                  },
                  cause: {},
                  workflowId: {},
                  initiatedEventId: {
                    type: "long"
                  },
                  decisionTaskCompletedEventId: {
                    type: "long"
                  },
                  control: {}
                }
              },
              lambdaFunctionScheduledEventAttributes: {
                type: "structure",
                required: [
                  "id",
                  "name",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  id: {},
                  name: {},
                  control: {},
                  input: {},
                  startToCloseTimeout: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              lambdaFunctionStartedEventAttributes: {
                type: "structure",
                required: [
                  "scheduledEventId"
                ],
                members: {
                  scheduledEventId: {
                    type: "long"
                  }
                }
              },
              lambdaFunctionCompletedEventAttributes: {
                type: "structure",
                required: [
                  "scheduledEventId",
                  "startedEventId"
                ],
                members: {
                  scheduledEventId: {
                    type: "long"
                  },
                  startedEventId: {
                    type: "long"
                  },
                  result: {}
                }
              },
              lambdaFunctionFailedEventAttributes: {
                type: "structure",
                required: [
                  "scheduledEventId",
                  "startedEventId"
                ],
                members: {
                  scheduledEventId: {
                    type: "long"
                  },
                  startedEventId: {
                    type: "long"
                  },
                  reason: {},
                  details: {}
                }
              },
              lambdaFunctionTimedOutEventAttributes: {
                type: "structure",
                required: [
                  "scheduledEventId",
                  "startedEventId"
                ],
                members: {
                  scheduledEventId: {
                    type: "long"
                  },
                  startedEventId: {
                    type: "long"
                  },
                  timeoutType: {}
                }
              },
              scheduleLambdaFunctionFailedEventAttributes: {
                type: "structure",
                required: [
                  "id",
                  "name",
                  "cause",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  id: {},
                  name: {},
                  cause: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              startLambdaFunctionFailedEventAttributes: {
                type: "structure",
                members: {
                  scheduledEventId: {
                    type: "long"
                  },
                  cause: {},
                  message: {}
                }
              }
            }
          }
        },
        S4g: {
          type: "structure",
          required: [
            "executionInfos"
          ],
          members: {
            executionInfos: {
              type: "list",
              member: {
                shape: "S1a"
              }
            },
            nextPageToken: {}
          }
        },
        S4o: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/swf-2012-01-25.paginators.json
var require_swf_2012_01_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/swf-2012-01-25.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetWorkflowExecutionHistory: {
          input_token: "nextPageToken",
          limit_key: "maximumPageSize",
          output_token: "nextPageToken",
          result_key: "events"
        },
        ListActivityTypes: {
          input_token: "nextPageToken",
          limit_key: "maximumPageSize",
          output_token: "nextPageToken",
          result_key: "typeInfos"
        },
        ListClosedWorkflowExecutions: {
          input_token: "nextPageToken",
          limit_key: "maximumPageSize",
          output_token: "nextPageToken",
          result_key: "executionInfos"
        },
        ListDomains: {
          input_token: "nextPageToken",
          limit_key: "maximumPageSize",
          output_token: "nextPageToken",
          result_key: "domainInfos"
        },
        ListOpenWorkflowExecutions: {
          input_token: "nextPageToken",
          limit_key: "maximumPageSize",
          output_token: "nextPageToken",
          result_key: "executionInfos"
        },
        ListWorkflowTypes: {
          input_token: "nextPageToken",
          limit_key: "maximumPageSize",
          output_token: "nextPageToken",
          result_key: "typeInfos"
        },
        PollForDecisionTask: {
          input_token: "nextPageToken",
          limit_key: "maximumPageSize",
          output_token: "nextPageToken",
          result_key: "events"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/swf.js
var require_swf2 = __commonJS({
  "node_modules/aws-sdk/clients/swf.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["swf"] = {};
    AWS2.SWF = Service.defineService("swf", ["2012-01-25"]);
    require_swf();
    Object.defineProperty(apiLoader.services["swf"], "2012-01-25", {
      get: function get() {
        var model = require_swf_2012_01_25_min();
        model.paginators = require_swf_2012_01_25_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.SWF;
  }
});

// node_modules/aws-sdk/apis/xray-2016-04-12.min.json
var require_xray_2016_04_12_min = __commonJS({
  "node_modules/aws-sdk/apis/xray-2016-04-12.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-04-12",
        endpointPrefix: "xray",
        protocol: "rest-json",
        serviceFullName: "AWS X-Ray",
        serviceId: "XRay",
        signatureVersion: "v4",
        uid: "xray-2016-04-12"
      },
      operations: {
        BatchGetTraces: {
          http: {
            requestUri: "/Traces"
          },
          input: {
            type: "structure",
            required: [
              "TraceIds"
            ],
            members: {
              TraceIds: {
                shape: "S2"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Traces: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Duration: {
                      type: "double"
                    },
                    LimitExceeded: {
                      type: "boolean"
                    },
                    Segments: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Id: {},
                          Document: {}
                        }
                      }
                    }
                  }
                }
              },
              UnprocessedTraceIds: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        CreateGroup: {
          http: {
            requestUri: "/CreateGroup"
          },
          input: {
            type: "structure",
            required: [
              "GroupName"
            ],
            members: {
              GroupName: {},
              FilterExpression: {},
              InsightsConfiguration: {
                shape: "Si"
              },
              Tags: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Group: {
                shape: "So"
              }
            }
          }
        },
        CreateSamplingRule: {
          http: {
            requestUri: "/CreateSamplingRule"
          },
          input: {
            type: "structure",
            required: [
              "SamplingRule"
            ],
            members: {
              SamplingRule: {
                shape: "Sq"
              },
              Tags: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SamplingRuleRecord: {
                shape: "S16"
              }
            }
          }
        },
        DeleteGroup: {
          http: {
            requestUri: "/DeleteGroup"
          },
          input: {
            type: "structure",
            members: {
              GroupName: {},
              GroupARN: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteResourcePolicy: {
          http: {
            requestUri: "/DeleteResourcePolicy"
          },
          input: {
            type: "structure",
            required: [
              "PolicyName"
            ],
            members: {
              PolicyName: {},
              PolicyRevisionId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSamplingRule: {
          http: {
            requestUri: "/DeleteSamplingRule"
          },
          input: {
            type: "structure",
            members: {
              RuleName: {},
              RuleARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SamplingRuleRecord: {
                shape: "S16"
              }
            }
          }
        },
        GetEncryptionConfig: {
          http: {
            requestUri: "/EncryptionConfig"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              EncryptionConfig: {
                shape: "S1j"
              }
            }
          }
        },
        GetGroup: {
          http: {
            requestUri: "/GetGroup"
          },
          input: {
            type: "structure",
            members: {
              GroupName: {},
              GroupARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Group: {
                shape: "So"
              }
            }
          }
        },
        GetGroups: {
          http: {
            requestUri: "/Groups"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Groups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    GroupName: {},
                    GroupARN: {},
                    FilterExpression: {},
                    InsightsConfiguration: {
                      shape: "Si"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetInsight: {
          http: {
            requestUri: "/Insight"
          },
          input: {
            type: "structure",
            required: [
              "InsightId"
            ],
            members: {
              InsightId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Insight: {
                type: "structure",
                members: {
                  InsightId: {},
                  GroupARN: {},
                  GroupName: {},
                  RootCauseServiceId: {
                    shape: "S1x"
                  },
                  Categories: {
                    shape: "S1z"
                  },
                  State: {},
                  StartTime: {
                    type: "timestamp"
                  },
                  EndTime: {
                    type: "timestamp"
                  },
                  Summary: {},
                  ClientRequestImpactStatistics: {
                    shape: "S23"
                  },
                  RootCauseServiceRequestImpactStatistics: {
                    shape: "S23"
                  },
                  TopAnomalousServices: {
                    shape: "S25"
                  }
                }
              }
            }
          }
        },
        GetInsightEvents: {
          http: {
            requestUri: "/InsightEvents"
          },
          input: {
            type: "structure",
            required: [
              "InsightId"
            ],
            members: {
              InsightId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InsightEvents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Summary: {},
                    EventTime: {
                      type: "timestamp"
                    },
                    ClientRequestImpactStatistics: {
                      shape: "S23"
                    },
                    RootCauseServiceRequestImpactStatistics: {
                      shape: "S23"
                    },
                    TopAnomalousServices: {
                      shape: "S25"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetInsightImpactGraph: {
          http: {
            requestUri: "/InsightImpactGraph"
          },
          input: {
            type: "structure",
            required: [
              "InsightId",
              "StartTime",
              "EndTime"
            ],
            members: {
              InsightId: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InsightId: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              ServiceGraphStartTime: {
                type: "timestamp"
              },
              ServiceGraphEndTime: {
                type: "timestamp"
              },
              Services: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ReferenceId: {
                      type: "integer"
                    },
                    Type: {},
                    Name: {},
                    Names: {
                      shape: "S1y"
                    },
                    AccountId: {},
                    Edges: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ReferenceId: {
                            type: "integer"
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetInsightSummaries: {
          http: {
            requestUri: "/InsightSummaries"
          },
          input: {
            type: "structure",
            required: [
              "StartTime",
              "EndTime"
            ],
            members: {
              States: {
                type: "list",
                member: {}
              },
              GroupARN: {},
              GroupName: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InsightSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InsightId: {},
                    GroupARN: {},
                    GroupName: {},
                    RootCauseServiceId: {
                      shape: "S1x"
                    },
                    Categories: {
                      shape: "S1z"
                    },
                    State: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    Summary: {},
                    ClientRequestImpactStatistics: {
                      shape: "S23"
                    },
                    RootCauseServiceRequestImpactStatistics: {
                      shape: "S23"
                    },
                    TopAnomalousServices: {
                      shape: "S25"
                    },
                    LastUpdateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetSamplingRules: {
          http: {
            requestUri: "/GetSamplingRules"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SamplingRuleRecords: {
                type: "list",
                member: {
                  shape: "S16"
                }
              },
              NextToken: {}
            }
          }
        },
        GetSamplingStatisticSummaries: {
          http: {
            requestUri: "/SamplingStatisticSummaries"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SamplingStatisticSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RuleName: {},
                    Timestamp: {
                      type: "timestamp"
                    },
                    RequestCount: {
                      type: "integer"
                    },
                    BorrowCount: {
                      type: "integer"
                    },
                    SampledCount: {
                      type: "integer"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetSamplingTargets: {
          http: {
            requestUri: "/SamplingTargets"
          },
          input: {
            type: "structure",
            required: [
              "SamplingStatisticsDocuments"
            ],
            members: {
              SamplingStatisticsDocuments: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "RuleName",
                    "ClientID",
                    "Timestamp",
                    "RequestCount",
                    "SampledCount"
                  ],
                  members: {
                    RuleName: {},
                    ClientID: {},
                    Timestamp: {
                      type: "timestamp"
                    },
                    RequestCount: {
                      type: "integer"
                    },
                    SampledCount: {
                      type: "integer"
                    },
                    BorrowCount: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SamplingTargetDocuments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RuleName: {},
                    FixedRate: {
                      type: "double"
                    },
                    ReservoirQuota: {
                      type: "integer"
                    },
                    ReservoirQuotaTTL: {
                      type: "timestamp"
                    },
                    Interval: {
                      type: "integer"
                    }
                  }
                }
              },
              LastRuleModification: {
                type: "timestamp"
              },
              UnprocessedStatistics: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RuleName: {},
                    ErrorCode: {},
                    Message: {}
                  }
                }
              }
            }
          }
        },
        GetServiceGraph: {
          http: {
            requestUri: "/ServiceGraph"
          },
          input: {
            type: "structure",
            required: [
              "StartTime",
              "EndTime"
            ],
            members: {
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              GroupName: {},
              GroupARN: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Services: {
                shape: "S3e"
              },
              ContainsOldGroupVersions: {
                type: "boolean"
              },
              NextToken: {}
            }
          }
        },
        GetTimeSeriesServiceStatistics: {
          http: {
            requestUri: "/TimeSeriesServiceStatistics"
          },
          input: {
            type: "structure",
            required: [
              "StartTime",
              "EndTime"
            ],
            members: {
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              GroupName: {},
              GroupARN: {},
              EntitySelectorExpression: {},
              Period: {
                type: "integer"
              },
              ForecastStatistics: {
                type: "boolean"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TimeSeriesServiceStatistics: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Timestamp: {
                      type: "timestamp"
                    },
                    EdgeSummaryStatistics: {
                      shape: "S3i"
                    },
                    ServiceSummaryStatistics: {
                      shape: "S3q"
                    },
                    ServiceForecastStatistics: {
                      type: "structure",
                      members: {
                        FaultCountHigh: {
                          type: "long"
                        },
                        FaultCountLow: {
                          type: "long"
                        }
                      }
                    },
                    ResponseTimeHistogram: {
                      shape: "S3l"
                    }
                  }
                }
              },
              ContainsOldGroupVersions: {
                type: "boolean"
              },
              NextToken: {}
            }
          }
        },
        GetTraceGraph: {
          http: {
            requestUri: "/TraceGraph"
          },
          input: {
            type: "structure",
            required: [
              "TraceIds"
            ],
            members: {
              TraceIds: {
                shape: "S2"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Services: {
                shape: "S3e"
              },
              NextToken: {}
            }
          }
        },
        GetTraceSummaries: {
          http: {
            requestUri: "/TraceSummaries"
          },
          input: {
            type: "structure",
            required: [
              "StartTime",
              "EndTime"
            ],
            members: {
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              TimeRangeType: {},
              Sampling: {
                type: "boolean"
              },
              SamplingStrategy: {
                type: "structure",
                members: {
                  Name: {},
                  Value: {
                    type: "double"
                  }
                }
              },
              FilterExpression: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TraceSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    Duration: {
                      type: "double"
                    },
                    ResponseTime: {
                      type: "double"
                    },
                    HasFault: {
                      type: "boolean"
                    },
                    HasError: {
                      type: "boolean"
                    },
                    HasThrottle: {
                      type: "boolean"
                    },
                    IsPartial: {
                      type: "boolean"
                    },
                    Http: {
                      type: "structure",
                      members: {
                        HttpURL: {},
                        HttpStatus: {
                          type: "integer"
                        },
                        HttpMethod: {},
                        UserAgent: {},
                        ClientIp: {}
                      }
                    },
                    Annotations: {
                      type: "map",
                      key: {},
                      value: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            AnnotationValue: {
                              type: "structure",
                              members: {
                                NumberValue: {
                                  type: "double"
                                },
                                BooleanValue: {
                                  type: "boolean"
                                },
                                StringValue: {}
                              }
                            },
                            ServiceIds: {
                              shape: "S4d"
                            }
                          }
                        }
                      }
                    },
                    Users: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          UserName: {},
                          ServiceIds: {
                            shape: "S4d"
                          }
                        }
                      }
                    },
                    ServiceIds: {
                      shape: "S4d"
                    },
                    ResourceARNs: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ARN: {}
                        }
                      }
                    },
                    InstanceIds: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Id: {}
                        }
                      }
                    },
                    AvailabilityZones: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Name: {}
                        }
                      }
                    },
                    EntryPoint: {
                      shape: "S1x"
                    },
                    FaultRootCauses: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Services: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Name: {},
                                Names: {
                                  shape: "S1y"
                                },
                                Type: {},
                                AccountId: {},
                                EntityPath: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      Name: {},
                                      Exceptions: {
                                        shape: "S4s"
                                      },
                                      Remote: {
                                        type: "boolean"
                                      }
                                    }
                                  }
                                },
                                Inferred: {
                                  type: "boolean"
                                }
                              }
                            }
                          },
                          ClientImpacting: {
                            type: "boolean"
                          }
                        }
                      }
                    },
                    ErrorRootCauses: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Services: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Name: {},
                                Names: {
                                  shape: "S1y"
                                },
                                Type: {},
                                AccountId: {},
                                EntityPath: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      Name: {},
                                      Exceptions: {
                                        shape: "S4s"
                                      },
                                      Remote: {
                                        type: "boolean"
                                      }
                                    }
                                  }
                                },
                                Inferred: {
                                  type: "boolean"
                                }
                              }
                            }
                          },
                          ClientImpacting: {
                            type: "boolean"
                          }
                        }
                      }
                    },
                    ResponseTimeRootCauses: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Services: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Name: {},
                                Names: {
                                  shape: "S1y"
                                },
                                Type: {},
                                AccountId: {},
                                EntityPath: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      Name: {},
                                      Coverage: {
                                        type: "double"
                                      },
                                      Remote: {
                                        type: "boolean"
                                      }
                                    }
                                  }
                                },
                                Inferred: {
                                  type: "boolean"
                                }
                              }
                            }
                          },
                          ClientImpacting: {
                            type: "boolean"
                          }
                        }
                      }
                    },
                    Revision: {
                      type: "integer"
                    },
                    MatchedEventTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              ApproximateTime: {
                type: "timestamp"
              },
              TracesProcessedCount: {
                type: "long"
              },
              NextToken: {}
            }
          }
        },
        ListResourcePolicies: {
          http: {
            requestUri: "/ListResourcePolicies"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourcePolicies: {
                type: "list",
                member: {
                  shape: "S5a"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            requestUri: "/ListTagsForResource"
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sj"
              },
              NextToken: {}
            }
          }
        },
        PutEncryptionConfig: {
          http: {
            requestUri: "/PutEncryptionConfig"
          },
          input: {
            type: "structure",
            required: [
              "Type"
            ],
            members: {
              KeyId: {},
              Type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EncryptionConfig: {
                shape: "S1j"
              }
            }
          }
        },
        PutResourcePolicy: {
          http: {
            requestUri: "/PutResourcePolicy"
          },
          input: {
            type: "structure",
            required: [
              "PolicyName",
              "PolicyDocument"
            ],
            members: {
              PolicyName: {},
              PolicyDocument: {},
              PolicyRevisionId: {},
              BypassPolicyLockoutCheck: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourcePolicy: {
                shape: "S5a"
              }
            }
          }
        },
        PutTelemetryRecords: {
          http: {
            requestUri: "/TelemetryRecords"
          },
          input: {
            type: "structure",
            required: [
              "TelemetryRecords"
            ],
            members: {
              TelemetryRecords: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Timestamp"
                  ],
                  members: {
                    Timestamp: {
                      type: "timestamp"
                    },
                    SegmentsReceivedCount: {
                      type: "integer"
                    },
                    SegmentsSentCount: {
                      type: "integer"
                    },
                    SegmentsSpilloverCount: {
                      type: "integer"
                    },
                    SegmentsRejectedCount: {
                      type: "integer"
                    },
                    BackendConnectionErrors: {
                      type: "structure",
                      members: {
                        TimeoutCount: {
                          type: "integer"
                        },
                        ConnectionRefusedCount: {
                          type: "integer"
                        },
                        HTTPCode4XXCount: {
                          type: "integer"
                        },
                        HTTPCode5XXCount: {
                          type: "integer"
                        },
                        UnknownHostCount: {
                          type: "integer"
                        },
                        OtherCount: {
                          type: "integer"
                        }
                      }
                    }
                  }
                }
              },
              EC2InstanceId: {},
              Hostname: {},
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutTraceSegments: {
          http: {
            requestUri: "/TraceSegments"
          },
          input: {
            type: "structure",
            required: [
              "TraceSegmentDocuments"
            ],
            members: {
              TraceSegmentDocuments: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UnprocessedTraceSegments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    ErrorCode: {},
                    Message: {}
                  }
                }
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/TagResource"
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            requestUri: "/UntagResource"
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateGroup: {
          http: {
            requestUri: "/UpdateGroup"
          },
          input: {
            type: "structure",
            members: {
              GroupName: {},
              GroupARN: {},
              FilterExpression: {},
              InsightsConfiguration: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Group: {
                shape: "So"
              }
            }
          }
        },
        UpdateSamplingRule: {
          http: {
            requestUri: "/UpdateSamplingRule"
          },
          input: {
            type: "structure",
            required: [
              "SamplingRuleUpdate"
            ],
            members: {
              SamplingRuleUpdate: {
                type: "structure",
                members: {
                  RuleName: {},
                  RuleARN: {},
                  ResourceARN: {},
                  Priority: {
                    type: "integer"
                  },
                  FixedRate: {
                    type: "double"
                  },
                  ReservoirSize: {
                    type: "integer"
                  },
                  Host: {},
                  ServiceName: {},
                  ServiceType: {},
                  HTTPMethod: {},
                  URLPath: {},
                  Attributes: {
                    shape: "S12"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SamplingRuleRecord: {
                shape: "S16"
              }
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "list",
          member: {}
        },
        Si: {
          type: "structure",
          members: {
            InsightsEnabled: {
              type: "boolean"
            },
            NotificationsEnabled: {
              type: "boolean"
            }
          }
        },
        Sj: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        So: {
          type: "structure",
          members: {
            GroupName: {},
            GroupARN: {},
            FilterExpression: {},
            InsightsConfiguration: {
              shape: "Si"
            }
          }
        },
        Sq: {
          type: "structure",
          required: [
            "ResourceARN",
            "Priority",
            "FixedRate",
            "ReservoirSize",
            "ServiceName",
            "ServiceType",
            "Host",
            "HTTPMethod",
            "URLPath",
            "Version"
          ],
          members: {
            RuleName: {},
            RuleARN: {},
            ResourceARN: {},
            Priority: {
              type: "integer"
            },
            FixedRate: {
              type: "double"
            },
            ReservoirSize: {
              type: "integer"
            },
            ServiceName: {},
            ServiceType: {},
            Host: {},
            HTTPMethod: {},
            URLPath: {},
            Version: {
              type: "integer"
            },
            Attributes: {
              shape: "S12"
            }
          }
        },
        S12: {
          type: "map",
          key: {},
          value: {}
        },
        S16: {
          type: "structure",
          members: {
            SamplingRule: {
              shape: "Sq"
            },
            CreatedAt: {
              type: "timestamp"
            },
            ModifiedAt: {
              type: "timestamp"
            }
          }
        },
        S1j: {
          type: "structure",
          members: {
            KeyId: {},
            Status: {},
            Type: {}
          }
        },
        S1x: {
          type: "structure",
          members: {
            Name: {},
            Names: {
              shape: "S1y"
            },
            AccountId: {},
            Type: {}
          }
        },
        S1y: {
          type: "list",
          member: {}
        },
        S1z: {
          type: "list",
          member: {}
        },
        S23: {
          type: "structure",
          members: {
            FaultCount: {
              type: "long"
            },
            OkCount: {
              type: "long"
            },
            TotalCount: {
              type: "long"
            }
          }
        },
        S25: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ServiceId: {
                shape: "S1x"
              }
            }
          }
        },
        S3e: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ReferenceId: {
                type: "integer"
              },
              Name: {},
              Names: {
                shape: "S1y"
              },
              Root: {
                type: "boolean"
              },
              AccountId: {},
              Type: {},
              State: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Edges: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ReferenceId: {
                      type: "integer"
                    },
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    SummaryStatistics: {
                      shape: "S3i"
                    },
                    ResponseTimeHistogram: {
                      shape: "S3l"
                    },
                    Aliases: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Name: {},
                          Names: {
                            type: "list",
                            member: {}
                          },
                          Type: {}
                        }
                      }
                    },
                    EdgeType: {},
                    ReceivedEventAgeHistogram: {
                      shape: "S3l"
                    }
                  }
                }
              },
              SummaryStatistics: {
                shape: "S3q"
              },
              DurationHistogram: {
                shape: "S3l"
              },
              ResponseTimeHistogram: {
                shape: "S3l"
              }
            }
          }
        },
        S3i: {
          type: "structure",
          members: {
            OkCount: {
              type: "long"
            },
            ErrorStatistics: {
              shape: "S3j"
            },
            FaultStatistics: {
              shape: "S3k"
            },
            TotalCount: {
              type: "long"
            },
            TotalResponseTime: {
              type: "double"
            }
          }
        },
        S3j: {
          type: "structure",
          members: {
            ThrottleCount: {
              type: "long"
            },
            OtherCount: {
              type: "long"
            },
            TotalCount: {
              type: "long"
            }
          }
        },
        S3k: {
          type: "structure",
          members: {
            OtherCount: {
              type: "long"
            },
            TotalCount: {
              type: "long"
            }
          }
        },
        S3l: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Value: {
                type: "double"
              },
              Count: {
                type: "integer"
              }
            }
          }
        },
        S3q: {
          type: "structure",
          members: {
            OkCount: {
              type: "long"
            },
            ErrorStatistics: {
              shape: "S3j"
            },
            FaultStatistics: {
              shape: "S3k"
            },
            TotalCount: {
              type: "long"
            },
            TotalResponseTime: {
              type: "double"
            }
          }
        },
        S4d: {
          type: "list",
          member: {
            shape: "S1x"
          }
        },
        S4s: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Message: {}
            }
          }
        },
        S5a: {
          type: "structure",
          members: {
            PolicyName: {},
            PolicyDocument: {},
            PolicyRevisionId: {},
            LastUpdatedTime: {
              type: "timestamp"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/xray-2016-04-12.paginators.json
var require_xray_2016_04_12_paginators = __commonJS({
  "node_modules/aws-sdk/apis/xray-2016-04-12.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        BatchGetTraces: {
          input_token: "NextToken",
          non_aggregate_keys: [
            "UnprocessedTraceIds"
          ],
          output_token: "NextToken",
          result_key: "Traces"
        },
        GetGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Groups"
        },
        GetInsightEvents: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetInsightSummaries: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetSamplingRules: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "SamplingRuleRecords"
        },
        GetSamplingStatisticSummaries: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "SamplingStatisticSummaries"
        },
        GetServiceGraph: {
          input_token: "NextToken",
          non_aggregate_keys: [
            "StartTime",
            "EndTime",
            "ContainsOldGroupVersions"
          ],
          output_token: "NextToken",
          result_key: "Services"
        },
        GetTimeSeriesServiceStatistics: {
          input_token: "NextToken",
          non_aggregate_keys: [
            "ContainsOldGroupVersions"
          ],
          output_token: "NextToken",
          result_key: "TimeSeriesServiceStatistics"
        },
        GetTraceGraph: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Services"
        },
        GetTraceSummaries: {
          input_token: "NextToken",
          non_aggregate_keys: [
            "TracesProcessedCount",
            "ApproximateTime"
          ],
          output_token: "NextToken",
          result_key: "TraceSummaries"
        },
        ListResourcePolicies: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "ResourcePolicies"
        },
        ListTagsForResource: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Tags"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/xray.js
var require_xray = __commonJS({
  "node_modules/aws-sdk/clients/xray.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["xray"] = {};
    AWS2.XRay = Service.defineService("xray", ["2016-04-12"]);
    Object.defineProperty(apiLoader.services["xray"], "2016-04-12", {
      get: function get() {
        var model = require_xray_2016_04_12_min();
        model.paginators = require_xray_2016_04_12_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.XRay;
  }
});

// node_modules/aws-sdk/apis/waf-2015-08-24.min.json
var require_waf_2015_08_24_min = __commonJS({
  "node_modules/aws-sdk/apis/waf-2015-08-24.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-08-24",
        endpointPrefix: "waf",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "WAF",
        serviceFullName: "AWS WAF",
        serviceId: "WAF",
        signatureVersion: "v4",
        targetPrefix: "AWSWAF_20150824",
        uid: "waf-2015-08-24"
      },
      operations: {
        CreateByteMatchSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ByteMatchSet: {
                shape: "S5"
              },
              ChangeToken: {}
            }
          }
        },
        CreateGeoMatchSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GeoMatchSet: {
                shape: "Sh"
              },
              ChangeToken: {}
            }
          }
        },
        CreateIPSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IPSet: {
                shape: "So"
              },
              ChangeToken: {}
            }
          }
        },
        CreateRateBasedRule: {
          input: {
            type: "structure",
            required: [
              "Name",
              "MetricName",
              "RateKey",
              "RateLimit",
              "ChangeToken"
            ],
            members: {
              Name: {},
              MetricName: {},
              RateKey: {},
              RateLimit: {
                type: "long"
              },
              ChangeToken: {},
              Tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Rule: {
                shape: "S12"
              },
              ChangeToken: {}
            }
          }
        },
        CreateRegexMatchSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RegexMatchSet: {
                shape: "S19"
              },
              ChangeToken: {}
            }
          }
        },
        CreateRegexPatternSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RegexPatternSet: {
                shape: "S1e"
              },
              ChangeToken: {}
            }
          }
        },
        CreateRule: {
          input: {
            type: "structure",
            required: [
              "Name",
              "MetricName",
              "ChangeToken"
            ],
            members: {
              Name: {},
              MetricName: {},
              ChangeToken: {},
              Tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Rule: {
                shape: "S1j"
              },
              ChangeToken: {}
            }
          }
        },
        CreateRuleGroup: {
          input: {
            type: "structure",
            required: [
              "Name",
              "MetricName",
              "ChangeToken"
            ],
            members: {
              Name: {},
              MetricName: {},
              ChangeToken: {},
              Tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RuleGroup: {
                shape: "S1m"
              },
              ChangeToken: {}
            }
          }
        },
        CreateSizeConstraintSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SizeConstraintSet: {
                shape: "S1p"
              },
              ChangeToken: {}
            }
          }
        },
        CreateSqlInjectionMatchSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SqlInjectionMatchSet: {
                shape: "S1w"
              },
              ChangeToken: {}
            }
          }
        },
        CreateWebACL: {
          input: {
            type: "structure",
            required: [
              "Name",
              "MetricName",
              "DefaultAction",
              "ChangeToken"
            ],
            members: {
              Name: {},
              MetricName: {},
              DefaultAction: {
                shape: "S20"
              },
              ChangeToken: {},
              Tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WebACL: {
                shape: "S23"
              },
              ChangeToken: {}
            }
          }
        },
        CreateWebACLMigrationStack: {
          input: {
            type: "structure",
            required: [
              "WebACLId",
              "S3BucketName",
              "IgnoreUnsupportedType"
            ],
            members: {
              WebACLId: {},
              S3BucketName: {},
              IgnoreUnsupportedType: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "S3ObjectUrl"
            ],
            members: {
              S3ObjectUrl: {}
            }
          }
        },
        CreateXssMatchSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              XssMatchSet: {
                shape: "S2k"
              },
              ChangeToken: {}
            }
          }
        },
        DeleteByteMatchSet: {
          input: {
            type: "structure",
            required: [
              "ByteMatchSetId",
              "ChangeToken"
            ],
            members: {
              ByteMatchSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteGeoMatchSet: {
          input: {
            type: "structure",
            required: [
              "GeoMatchSetId",
              "ChangeToken"
            ],
            members: {
              GeoMatchSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteIPSet: {
          input: {
            type: "structure",
            required: [
              "IPSetId",
              "ChangeToken"
            ],
            members: {
              IPSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteLoggingConfiguration: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeletePermissionPolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRateBasedRule: {
          input: {
            type: "structure",
            required: [
              "RuleId",
              "ChangeToken"
            ],
            members: {
              RuleId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteRegexMatchSet: {
          input: {
            type: "structure",
            required: [
              "RegexMatchSetId",
              "ChangeToken"
            ],
            members: {
              RegexMatchSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteRegexPatternSet: {
          input: {
            type: "structure",
            required: [
              "RegexPatternSetId",
              "ChangeToken"
            ],
            members: {
              RegexPatternSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteRule: {
          input: {
            type: "structure",
            required: [
              "RuleId",
              "ChangeToken"
            ],
            members: {
              RuleId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteRuleGroup: {
          input: {
            type: "structure",
            required: [
              "RuleGroupId",
              "ChangeToken"
            ],
            members: {
              RuleGroupId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteSizeConstraintSet: {
          input: {
            type: "structure",
            required: [
              "SizeConstraintSetId",
              "ChangeToken"
            ],
            members: {
              SizeConstraintSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteSqlInjectionMatchSet: {
          input: {
            type: "structure",
            required: [
              "SqlInjectionMatchSetId",
              "ChangeToken"
            ],
            members: {
              SqlInjectionMatchSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteWebACL: {
          input: {
            type: "structure",
            required: [
              "WebACLId",
              "ChangeToken"
            ],
            members: {
              WebACLId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteXssMatchSet: {
          input: {
            type: "structure",
            required: [
              "XssMatchSetId",
              "ChangeToken"
            ],
            members: {
              XssMatchSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        GetByteMatchSet: {
          input: {
            type: "structure",
            required: [
              "ByteMatchSetId"
            ],
            members: {
              ByteMatchSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ByteMatchSet: {
                shape: "S5"
              }
            }
          }
        },
        GetChangeToken: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        GetChangeTokenStatus: {
          input: {
            type: "structure",
            required: [
              "ChangeToken"
            ],
            members: {
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeTokenStatus: {}
            }
          }
        },
        GetGeoMatchSet: {
          input: {
            type: "structure",
            required: [
              "GeoMatchSetId"
            ],
            members: {
              GeoMatchSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GeoMatchSet: {
                shape: "Sh"
              }
            }
          }
        },
        GetIPSet: {
          input: {
            type: "structure",
            required: [
              "IPSetId"
            ],
            members: {
              IPSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IPSet: {
                shape: "So"
              }
            }
          }
        },
        GetLoggingConfiguration: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LoggingConfiguration: {
                shape: "S3s"
              }
            }
          }
        },
        GetPermissionPolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {}
            }
          }
        },
        GetRateBasedRule: {
          input: {
            type: "structure",
            required: [
              "RuleId"
            ],
            members: {
              RuleId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Rule: {
                shape: "S12"
              }
            }
          }
        },
        GetRateBasedRuleManagedKeys: {
          input: {
            type: "structure",
            required: [
              "RuleId"
            ],
            members: {
              RuleId: {},
              NextMarker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ManagedKeys: {
                type: "list",
                member: {}
              },
              NextMarker: {}
            }
          }
        },
        GetRegexMatchSet: {
          input: {
            type: "structure",
            required: [
              "RegexMatchSetId"
            ],
            members: {
              RegexMatchSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RegexMatchSet: {
                shape: "S19"
              }
            }
          }
        },
        GetRegexPatternSet: {
          input: {
            type: "structure",
            required: [
              "RegexPatternSetId"
            ],
            members: {
              RegexPatternSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RegexPatternSet: {
                shape: "S1e"
              }
            }
          }
        },
        GetRule: {
          input: {
            type: "structure",
            required: [
              "RuleId"
            ],
            members: {
              RuleId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Rule: {
                shape: "S1j"
              }
            }
          }
        },
        GetRuleGroup: {
          input: {
            type: "structure",
            required: [
              "RuleGroupId"
            ],
            members: {
              RuleGroupId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RuleGroup: {
                shape: "S1m"
              }
            }
          }
        },
        GetSampledRequests: {
          input: {
            type: "structure",
            required: [
              "WebAclId",
              "RuleId",
              "TimeWindow",
              "MaxItems"
            ],
            members: {
              WebAclId: {},
              RuleId: {},
              TimeWindow: {
                shape: "S4e"
              },
              MaxItems: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SampledRequests: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Request",
                    "Weight"
                  ],
                  members: {
                    Request: {
                      type: "structure",
                      members: {
                        ClientIP: {},
                        Country: {},
                        URI: {},
                        Method: {},
                        HTTPVersion: {},
                        Headers: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              Name: {},
                              Value: {}
                            }
                          }
                        }
                      }
                    },
                    Weight: {
                      type: "long"
                    },
                    Timestamp: {
                      type: "timestamp"
                    },
                    Action: {},
                    RuleWithinRuleGroup: {}
                  }
                }
              },
              PopulationSize: {
                type: "long"
              },
              TimeWindow: {
                shape: "S4e"
              }
            }
          }
        },
        GetSizeConstraintSet: {
          input: {
            type: "structure",
            required: [
              "SizeConstraintSetId"
            ],
            members: {
              SizeConstraintSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SizeConstraintSet: {
                shape: "S1p"
              }
            }
          }
        },
        GetSqlInjectionMatchSet: {
          input: {
            type: "structure",
            required: [
              "SqlInjectionMatchSetId"
            ],
            members: {
              SqlInjectionMatchSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SqlInjectionMatchSet: {
                shape: "S1w"
              }
            }
          }
        },
        GetWebACL: {
          input: {
            type: "structure",
            required: [
              "WebACLId"
            ],
            members: {
              WebACLId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WebACL: {
                shape: "S23"
              }
            }
          }
        },
        GetXssMatchSet: {
          input: {
            type: "structure",
            required: [
              "XssMatchSetId"
            ],
            members: {
              XssMatchSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              XssMatchSet: {
                shape: "S2k"
              }
            }
          }
        },
        ListActivatedRulesInRuleGroup: {
          input: {
            type: "structure",
            members: {
              RuleGroupId: {},
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              ActivatedRules: {
                shape: "S24"
              }
            }
          }
        },
        ListByteMatchSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              ByteMatchSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ByteMatchSetId",
                    "Name"
                  ],
                  members: {
                    ByteMatchSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListGeoMatchSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              GeoMatchSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "GeoMatchSetId",
                    "Name"
                  ],
                  members: {
                    GeoMatchSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListIPSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              IPSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "IPSetId",
                    "Name"
                  ],
                  members: {
                    IPSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListLoggingConfigurations: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LoggingConfigurations: {
                type: "list",
                member: {
                  shape: "S3s"
                }
              },
              NextMarker: {}
            }
          }
        },
        ListRateBasedRules: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              Rules: {
                shape: "S5p"
              }
            }
          }
        },
        ListRegexMatchSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              RegexMatchSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "RegexMatchSetId",
                    "Name"
                  ],
                  members: {
                    RegexMatchSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListRegexPatternSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              RegexPatternSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "RegexPatternSetId",
                    "Name"
                  ],
                  members: {
                    RegexPatternSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListRuleGroups: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              RuleGroups: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "RuleGroupId",
                    "Name"
                  ],
                  members: {
                    RuleGroupId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListRules: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              Rules: {
                shape: "S5p"
              }
            }
          }
        },
        ListSizeConstraintSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              SizeConstraintSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "SizeConstraintSetId",
                    "Name"
                  ],
                  members: {
                    SizeConstraintSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListSqlInjectionMatchSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              SqlInjectionMatchSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "SqlInjectionMatchSetId",
                    "Name"
                  ],
                  members: {
                    SqlInjectionMatchSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListSubscribedRuleGroups: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              RuleGroups: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "RuleGroupId",
                    "Name",
                    "MetricName"
                  ],
                  members: {
                    RuleGroupId: {},
                    Name: {},
                    MetricName: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              },
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              TagInfoForResource: {
                type: "structure",
                members: {
                  ResourceARN: {},
                  TagList: {
                    shape: "Sx"
                  }
                }
              }
            }
          }
        },
        ListWebACLs: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              WebACLs: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "WebACLId",
                    "Name"
                  ],
                  members: {
                    WebACLId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListXssMatchSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              XssMatchSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "XssMatchSetId",
                    "Name"
                  ],
                  members: {
                    XssMatchSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        PutLoggingConfiguration: {
          input: {
            type: "structure",
            required: [
              "LoggingConfiguration"
            ],
            members: {
              LoggingConfiguration: {
                shape: "S3s"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LoggingConfiguration: {
                shape: "S3s"
              }
            }
          }
        },
        PutPermissionPolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Policy"
            ],
            members: {
              ResourceArn: {},
              Policy: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateByteMatchSet: {
          input: {
            type: "structure",
            required: [
              "ByteMatchSetId",
              "ChangeToken",
              "Updates"
            ],
            members: {
              ByteMatchSetId: {},
              ChangeToken: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "ByteMatchTuple"
                  ],
                  members: {
                    Action: {},
                    ByteMatchTuple: {
                      shape: "S8"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateGeoMatchSet: {
          input: {
            type: "structure",
            required: [
              "GeoMatchSetId",
              "ChangeToken",
              "Updates"
            ],
            members: {
              GeoMatchSetId: {},
              ChangeToken: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "GeoMatchConstraint"
                  ],
                  members: {
                    Action: {},
                    GeoMatchConstraint: {
                      shape: "Sj"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateIPSet: {
          input: {
            type: "structure",
            required: [
              "IPSetId",
              "ChangeToken",
              "Updates"
            ],
            members: {
              IPSetId: {},
              ChangeToken: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "IPSetDescriptor"
                  ],
                  members: {
                    Action: {},
                    IPSetDescriptor: {
                      shape: "Sq"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateRateBasedRule: {
          input: {
            type: "structure",
            required: [
              "RuleId",
              "ChangeToken",
              "Updates",
              "RateLimit"
            ],
            members: {
              RuleId: {},
              ChangeToken: {},
              Updates: {
                shape: "S7f"
              },
              RateLimit: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateRegexMatchSet: {
          input: {
            type: "structure",
            required: [
              "RegexMatchSetId",
              "Updates",
              "ChangeToken"
            ],
            members: {
              RegexMatchSetId: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "RegexMatchTuple"
                  ],
                  members: {
                    Action: {},
                    RegexMatchTuple: {
                      shape: "S1b"
                    }
                  }
                }
              },
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateRegexPatternSet: {
          input: {
            type: "structure",
            required: [
              "RegexPatternSetId",
              "Updates",
              "ChangeToken"
            ],
            members: {
              RegexPatternSetId: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "RegexPatternString"
                  ],
                  members: {
                    Action: {},
                    RegexPatternString: {}
                  }
                }
              },
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateRule: {
          input: {
            type: "structure",
            required: [
              "RuleId",
              "ChangeToken",
              "Updates"
            ],
            members: {
              RuleId: {},
              ChangeToken: {},
              Updates: {
                shape: "S7f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateRuleGroup: {
          input: {
            type: "structure",
            required: [
              "RuleGroupId",
              "Updates",
              "ChangeToken"
            ],
            members: {
              RuleGroupId: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "ActivatedRule"
                  ],
                  members: {
                    Action: {},
                    ActivatedRule: {
                      shape: "S25"
                    }
                  }
                }
              },
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateSizeConstraintSet: {
          input: {
            type: "structure",
            required: [
              "SizeConstraintSetId",
              "ChangeToken",
              "Updates"
            ],
            members: {
              SizeConstraintSetId: {},
              ChangeToken: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "SizeConstraint"
                  ],
                  members: {
                    Action: {},
                    SizeConstraint: {
                      shape: "S1r"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateSqlInjectionMatchSet: {
          input: {
            type: "structure",
            required: [
              "SqlInjectionMatchSetId",
              "ChangeToken",
              "Updates"
            ],
            members: {
              SqlInjectionMatchSetId: {},
              ChangeToken: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "SqlInjectionMatchTuple"
                  ],
                  members: {
                    Action: {},
                    SqlInjectionMatchTuple: {
                      shape: "S1y"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateWebACL: {
          input: {
            type: "structure",
            required: [
              "WebACLId",
              "ChangeToken"
            ],
            members: {
              WebACLId: {},
              ChangeToken: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "ActivatedRule"
                  ],
                  members: {
                    Action: {},
                    ActivatedRule: {
                      shape: "S25"
                    }
                  }
                }
              },
              DefaultAction: {
                shape: "S20"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateXssMatchSet: {
          input: {
            type: "structure",
            required: [
              "XssMatchSetId",
              "ChangeToken",
              "Updates"
            ],
            members: {
              XssMatchSetId: {},
              ChangeToken: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "XssMatchTuple"
                  ],
                  members: {
                    Action: {},
                    XssMatchTuple: {
                      shape: "S2m"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          required: [
            "ByteMatchSetId",
            "ByteMatchTuples"
          ],
          members: {
            ByteMatchSetId: {},
            Name: {},
            ByteMatchTuples: {
              type: "list",
              member: {
                shape: "S8"
              }
            }
          }
        },
        S8: {
          type: "structure",
          required: [
            "FieldToMatch",
            "TargetString",
            "TextTransformation",
            "PositionalConstraint"
          ],
          members: {
            FieldToMatch: {
              shape: "S9"
            },
            TargetString: {
              type: "blob"
            },
            TextTransformation: {},
            PositionalConstraint: {}
          }
        },
        S9: {
          type: "structure",
          required: [
            "Type"
          ],
          members: {
            Type: {},
            Data: {}
          }
        },
        Sh: {
          type: "structure",
          required: [
            "GeoMatchSetId",
            "GeoMatchConstraints"
          ],
          members: {
            GeoMatchSetId: {},
            Name: {},
            GeoMatchConstraints: {
              type: "list",
              member: {
                shape: "Sj"
              }
            }
          }
        },
        Sj: {
          type: "structure",
          required: [
            "Type",
            "Value"
          ],
          members: {
            Type: {},
            Value: {}
          }
        },
        So: {
          type: "structure",
          required: [
            "IPSetId",
            "IPSetDescriptors"
          ],
          members: {
            IPSetId: {},
            Name: {},
            IPSetDescriptors: {
              type: "list",
              member: {
                shape: "Sq"
              }
            }
          }
        },
        Sq: {
          type: "structure",
          required: [
            "Type",
            "Value"
          ],
          members: {
            Type: {},
            Value: {}
          }
        },
        Sx: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S12: {
          type: "structure",
          required: [
            "RuleId",
            "MatchPredicates",
            "RateKey",
            "RateLimit"
          ],
          members: {
            RuleId: {},
            Name: {},
            MetricName: {},
            MatchPredicates: {
              shape: "S13"
            },
            RateKey: {},
            RateLimit: {
              type: "long"
            }
          }
        },
        S13: {
          type: "list",
          member: {
            shape: "S14"
          }
        },
        S14: {
          type: "structure",
          required: [
            "Negated",
            "Type",
            "DataId"
          ],
          members: {
            Negated: {
              type: "boolean"
            },
            Type: {},
            DataId: {}
          }
        },
        S19: {
          type: "structure",
          members: {
            RegexMatchSetId: {},
            Name: {},
            RegexMatchTuples: {
              type: "list",
              member: {
                shape: "S1b"
              }
            }
          }
        },
        S1b: {
          type: "structure",
          required: [
            "FieldToMatch",
            "TextTransformation",
            "RegexPatternSetId"
          ],
          members: {
            FieldToMatch: {
              shape: "S9"
            },
            TextTransformation: {},
            RegexPatternSetId: {}
          }
        },
        S1e: {
          type: "structure",
          required: [
            "RegexPatternSetId",
            "RegexPatternStrings"
          ],
          members: {
            RegexPatternSetId: {},
            Name: {},
            RegexPatternStrings: {
              type: "list",
              member: {}
            }
          }
        },
        S1j: {
          type: "structure",
          required: [
            "RuleId",
            "Predicates"
          ],
          members: {
            RuleId: {},
            Name: {},
            MetricName: {},
            Predicates: {
              shape: "S13"
            }
          }
        },
        S1m: {
          type: "structure",
          required: [
            "RuleGroupId"
          ],
          members: {
            RuleGroupId: {},
            Name: {},
            MetricName: {}
          }
        },
        S1p: {
          type: "structure",
          required: [
            "SizeConstraintSetId",
            "SizeConstraints"
          ],
          members: {
            SizeConstraintSetId: {},
            Name: {},
            SizeConstraints: {
              type: "list",
              member: {
                shape: "S1r"
              }
            }
          }
        },
        S1r: {
          type: "structure",
          required: [
            "FieldToMatch",
            "TextTransformation",
            "ComparisonOperator",
            "Size"
          ],
          members: {
            FieldToMatch: {
              shape: "S9"
            },
            TextTransformation: {},
            ComparisonOperator: {},
            Size: {
              type: "long"
            }
          }
        },
        S1w: {
          type: "structure",
          required: [
            "SqlInjectionMatchSetId",
            "SqlInjectionMatchTuples"
          ],
          members: {
            SqlInjectionMatchSetId: {},
            Name: {},
            SqlInjectionMatchTuples: {
              type: "list",
              member: {
                shape: "S1y"
              }
            }
          }
        },
        S1y: {
          type: "structure",
          required: [
            "FieldToMatch",
            "TextTransformation"
          ],
          members: {
            FieldToMatch: {
              shape: "S9"
            },
            TextTransformation: {}
          }
        },
        S20: {
          type: "structure",
          required: [
            "Type"
          ],
          members: {
            Type: {}
          }
        },
        S23: {
          type: "structure",
          required: [
            "WebACLId",
            "DefaultAction",
            "Rules"
          ],
          members: {
            WebACLId: {},
            Name: {},
            MetricName: {},
            DefaultAction: {
              shape: "S20"
            },
            Rules: {
              shape: "S24"
            },
            WebACLArn: {}
          }
        },
        S24: {
          type: "list",
          member: {
            shape: "S25"
          }
        },
        S25: {
          type: "structure",
          required: [
            "Priority",
            "RuleId"
          ],
          members: {
            Priority: {
              type: "integer"
            },
            RuleId: {},
            Action: {
              shape: "S20"
            },
            OverrideAction: {
              type: "structure",
              required: [
                "Type"
              ],
              members: {
                Type: {}
              }
            },
            Type: {},
            ExcludedRules: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "RuleId"
                ],
                members: {
                  RuleId: {}
                }
              }
            }
          }
        },
        S2k: {
          type: "structure",
          required: [
            "XssMatchSetId",
            "XssMatchTuples"
          ],
          members: {
            XssMatchSetId: {},
            Name: {},
            XssMatchTuples: {
              type: "list",
              member: {
                shape: "S2m"
              }
            }
          }
        },
        S2m: {
          type: "structure",
          required: [
            "FieldToMatch",
            "TextTransformation"
          ],
          members: {
            FieldToMatch: {
              shape: "S9"
            },
            TextTransformation: {}
          }
        },
        S3s: {
          type: "structure",
          required: [
            "ResourceArn",
            "LogDestinationConfigs"
          ],
          members: {
            ResourceArn: {},
            LogDestinationConfigs: {
              type: "list",
              member: {}
            },
            RedactedFields: {
              type: "list",
              member: {
                shape: "S9"
              }
            }
          }
        },
        S4e: {
          type: "structure",
          required: [
            "StartTime",
            "EndTime"
          ],
          members: {
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            }
          }
        },
        S5p: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "RuleId",
              "Name"
            ],
            members: {
              RuleId: {},
              Name: {}
            }
          }
        },
        S7f: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Action",
              "Predicate"
            ],
            members: {
              Action: {},
              Predicate: {
                shape: "S14"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/waf-2015-08-24.paginators.json
var require_waf_2015_08_24_paginators = __commonJS({
  "node_modules/aws-sdk/apis/waf-2015-08-24.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/waf.js
var require_waf = __commonJS({
  "node_modules/aws-sdk/clients/waf.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["waf"] = {};
    AWS2.WAF = Service.defineService("waf", ["2015-08-24"]);
    Object.defineProperty(apiLoader.services["waf"], "2015-08-24", {
      get: function get() {
        var model = require_waf_2015_08_24_min();
        model.paginators = require_waf_2015_08_24_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.WAF;
  }
});

// node_modules/aws-sdk/apis/waf-regional-2016-11-28.min.json
var require_waf_regional_2016_11_28_min = __commonJS({
  "node_modules/aws-sdk/apis/waf-regional-2016-11-28.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-11-28",
        endpointPrefix: "waf-regional",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "WAF Regional",
        serviceFullName: "AWS WAF Regional",
        serviceId: "WAF Regional",
        signatureVersion: "v4",
        targetPrefix: "AWSWAF_Regional_20161128",
        uid: "waf-regional-2016-11-28"
      },
      operations: {
        AssociateWebACL: {
          input: {
            type: "structure",
            required: [
              "WebACLId",
              "ResourceArn"
            ],
            members: {
              WebACLId: {},
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateByteMatchSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ByteMatchSet: {
                shape: "S9"
              },
              ChangeToken: {}
            }
          }
        },
        CreateGeoMatchSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GeoMatchSet: {
                shape: "Sk"
              },
              ChangeToken: {}
            }
          }
        },
        CreateIPSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IPSet: {
                shape: "Sr"
              },
              ChangeToken: {}
            }
          }
        },
        CreateRateBasedRule: {
          input: {
            type: "structure",
            required: [
              "Name",
              "MetricName",
              "RateKey",
              "RateLimit",
              "ChangeToken"
            ],
            members: {
              Name: {},
              MetricName: {},
              RateKey: {},
              RateLimit: {
                type: "long"
              },
              ChangeToken: {},
              Tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Rule: {
                shape: "S15"
              },
              ChangeToken: {}
            }
          }
        },
        CreateRegexMatchSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RegexMatchSet: {
                shape: "S1c"
              },
              ChangeToken: {}
            }
          }
        },
        CreateRegexPatternSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RegexPatternSet: {
                shape: "S1h"
              },
              ChangeToken: {}
            }
          }
        },
        CreateRule: {
          input: {
            type: "structure",
            required: [
              "Name",
              "MetricName",
              "ChangeToken"
            ],
            members: {
              Name: {},
              MetricName: {},
              ChangeToken: {},
              Tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Rule: {
                shape: "S1m"
              },
              ChangeToken: {}
            }
          }
        },
        CreateRuleGroup: {
          input: {
            type: "structure",
            required: [
              "Name",
              "MetricName",
              "ChangeToken"
            ],
            members: {
              Name: {},
              MetricName: {},
              ChangeToken: {},
              Tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RuleGroup: {
                shape: "S1p"
              },
              ChangeToken: {}
            }
          }
        },
        CreateSizeConstraintSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SizeConstraintSet: {
                shape: "S1s"
              },
              ChangeToken: {}
            }
          }
        },
        CreateSqlInjectionMatchSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SqlInjectionMatchSet: {
                shape: "S1z"
              },
              ChangeToken: {}
            }
          }
        },
        CreateWebACL: {
          input: {
            type: "structure",
            required: [
              "Name",
              "MetricName",
              "DefaultAction",
              "ChangeToken"
            ],
            members: {
              Name: {},
              MetricName: {},
              DefaultAction: {
                shape: "S23"
              },
              ChangeToken: {},
              Tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WebACL: {
                shape: "S26"
              },
              ChangeToken: {}
            }
          }
        },
        CreateWebACLMigrationStack: {
          input: {
            type: "structure",
            required: [
              "WebACLId",
              "S3BucketName",
              "IgnoreUnsupportedType"
            ],
            members: {
              WebACLId: {},
              S3BucketName: {},
              IgnoreUnsupportedType: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "S3ObjectUrl"
            ],
            members: {
              S3ObjectUrl: {}
            }
          }
        },
        CreateXssMatchSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              XssMatchSet: {
                shape: "S2m"
              },
              ChangeToken: {}
            }
          }
        },
        DeleteByteMatchSet: {
          input: {
            type: "structure",
            required: [
              "ByteMatchSetId",
              "ChangeToken"
            ],
            members: {
              ByteMatchSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteGeoMatchSet: {
          input: {
            type: "structure",
            required: [
              "GeoMatchSetId",
              "ChangeToken"
            ],
            members: {
              GeoMatchSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteIPSet: {
          input: {
            type: "structure",
            required: [
              "IPSetId",
              "ChangeToken"
            ],
            members: {
              IPSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteLoggingConfiguration: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeletePermissionPolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRateBasedRule: {
          input: {
            type: "structure",
            required: [
              "RuleId",
              "ChangeToken"
            ],
            members: {
              RuleId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteRegexMatchSet: {
          input: {
            type: "structure",
            required: [
              "RegexMatchSetId",
              "ChangeToken"
            ],
            members: {
              RegexMatchSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteRegexPatternSet: {
          input: {
            type: "structure",
            required: [
              "RegexPatternSetId",
              "ChangeToken"
            ],
            members: {
              RegexPatternSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteRule: {
          input: {
            type: "structure",
            required: [
              "RuleId",
              "ChangeToken"
            ],
            members: {
              RuleId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteRuleGroup: {
          input: {
            type: "structure",
            required: [
              "RuleGroupId",
              "ChangeToken"
            ],
            members: {
              RuleGroupId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteSizeConstraintSet: {
          input: {
            type: "structure",
            required: [
              "SizeConstraintSetId",
              "ChangeToken"
            ],
            members: {
              SizeConstraintSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteSqlInjectionMatchSet: {
          input: {
            type: "structure",
            required: [
              "SqlInjectionMatchSetId",
              "ChangeToken"
            ],
            members: {
              SqlInjectionMatchSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteWebACL: {
          input: {
            type: "structure",
            required: [
              "WebACLId",
              "ChangeToken"
            ],
            members: {
              WebACLId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteXssMatchSet: {
          input: {
            type: "structure",
            required: [
              "XssMatchSetId",
              "ChangeToken"
            ],
            members: {
              XssMatchSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DisassociateWebACL: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetByteMatchSet: {
          input: {
            type: "structure",
            required: [
              "ByteMatchSetId"
            ],
            members: {
              ByteMatchSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ByteMatchSet: {
                shape: "S9"
              }
            }
          }
        },
        GetChangeToken: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        GetChangeTokenStatus: {
          input: {
            type: "structure",
            required: [
              "ChangeToken"
            ],
            members: {
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeTokenStatus: {}
            }
          }
        },
        GetGeoMatchSet: {
          input: {
            type: "structure",
            required: [
              "GeoMatchSetId"
            ],
            members: {
              GeoMatchSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GeoMatchSet: {
                shape: "Sk"
              }
            }
          }
        },
        GetIPSet: {
          input: {
            type: "structure",
            required: [
              "IPSetId"
            ],
            members: {
              IPSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IPSet: {
                shape: "Sr"
              }
            }
          }
        },
        GetLoggingConfiguration: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LoggingConfiguration: {
                shape: "S3w"
              }
            }
          }
        },
        GetPermissionPolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {}
            }
          }
        },
        GetRateBasedRule: {
          input: {
            type: "structure",
            required: [
              "RuleId"
            ],
            members: {
              RuleId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Rule: {
                shape: "S15"
              }
            }
          }
        },
        GetRateBasedRuleManagedKeys: {
          input: {
            type: "structure",
            required: [
              "RuleId"
            ],
            members: {
              RuleId: {},
              NextMarker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ManagedKeys: {
                type: "list",
                member: {}
              },
              NextMarker: {}
            }
          }
        },
        GetRegexMatchSet: {
          input: {
            type: "structure",
            required: [
              "RegexMatchSetId"
            ],
            members: {
              RegexMatchSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RegexMatchSet: {
                shape: "S1c"
              }
            }
          }
        },
        GetRegexPatternSet: {
          input: {
            type: "structure",
            required: [
              "RegexPatternSetId"
            ],
            members: {
              RegexPatternSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RegexPatternSet: {
                shape: "S1h"
              }
            }
          }
        },
        GetRule: {
          input: {
            type: "structure",
            required: [
              "RuleId"
            ],
            members: {
              RuleId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Rule: {
                shape: "S1m"
              }
            }
          }
        },
        GetRuleGroup: {
          input: {
            type: "structure",
            required: [
              "RuleGroupId"
            ],
            members: {
              RuleGroupId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RuleGroup: {
                shape: "S1p"
              }
            }
          }
        },
        GetSampledRequests: {
          input: {
            type: "structure",
            required: [
              "WebAclId",
              "RuleId",
              "TimeWindow",
              "MaxItems"
            ],
            members: {
              WebAclId: {},
              RuleId: {},
              TimeWindow: {
                shape: "S4i"
              },
              MaxItems: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SampledRequests: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Request",
                    "Weight"
                  ],
                  members: {
                    Request: {
                      type: "structure",
                      members: {
                        ClientIP: {},
                        Country: {},
                        URI: {},
                        Method: {},
                        HTTPVersion: {},
                        Headers: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              Name: {},
                              Value: {}
                            }
                          }
                        }
                      }
                    },
                    Weight: {
                      type: "long"
                    },
                    Timestamp: {
                      type: "timestamp"
                    },
                    Action: {},
                    RuleWithinRuleGroup: {}
                  }
                }
              },
              PopulationSize: {
                type: "long"
              },
              TimeWindow: {
                shape: "S4i"
              }
            }
          }
        },
        GetSizeConstraintSet: {
          input: {
            type: "structure",
            required: [
              "SizeConstraintSetId"
            ],
            members: {
              SizeConstraintSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SizeConstraintSet: {
                shape: "S1s"
              }
            }
          }
        },
        GetSqlInjectionMatchSet: {
          input: {
            type: "structure",
            required: [
              "SqlInjectionMatchSetId"
            ],
            members: {
              SqlInjectionMatchSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SqlInjectionMatchSet: {
                shape: "S1z"
              }
            }
          }
        },
        GetWebACL: {
          input: {
            type: "structure",
            required: [
              "WebACLId"
            ],
            members: {
              WebACLId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WebACL: {
                shape: "S26"
              }
            }
          }
        },
        GetWebACLForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WebACLSummary: {
                shape: "S59"
              }
            }
          }
        },
        GetXssMatchSet: {
          input: {
            type: "structure",
            required: [
              "XssMatchSetId"
            ],
            members: {
              XssMatchSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              XssMatchSet: {
                shape: "S2m"
              }
            }
          }
        },
        ListActivatedRulesInRuleGroup: {
          input: {
            type: "structure",
            members: {
              RuleGroupId: {},
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              ActivatedRules: {
                shape: "S27"
              }
            }
          }
        },
        ListByteMatchSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              ByteMatchSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ByteMatchSetId",
                    "Name"
                  ],
                  members: {
                    ByteMatchSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListGeoMatchSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              GeoMatchSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "GeoMatchSetId",
                    "Name"
                  ],
                  members: {
                    GeoMatchSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListIPSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              IPSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "IPSetId",
                    "Name"
                  ],
                  members: {
                    IPSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListLoggingConfigurations: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LoggingConfigurations: {
                type: "list",
                member: {
                  shape: "S3w"
                }
              },
              NextMarker: {}
            }
          }
        },
        ListRateBasedRules: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              Rules: {
                shape: "S5w"
              }
            }
          }
        },
        ListRegexMatchSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              RegexMatchSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "RegexMatchSetId",
                    "Name"
                  ],
                  members: {
                    RegexMatchSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListRegexPatternSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              RegexPatternSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "RegexPatternSetId",
                    "Name"
                  ],
                  members: {
                    RegexPatternSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListResourcesForWebACL: {
          input: {
            type: "structure",
            required: [
              "WebACLId"
            ],
            members: {
              WebACLId: {},
              ResourceType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceArns: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ListRuleGroups: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              RuleGroups: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "RuleGroupId",
                    "Name"
                  ],
                  members: {
                    RuleGroupId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListRules: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              Rules: {
                shape: "S5w"
              }
            }
          }
        },
        ListSizeConstraintSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              SizeConstraintSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "SizeConstraintSetId",
                    "Name"
                  ],
                  members: {
                    SizeConstraintSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListSqlInjectionMatchSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              SqlInjectionMatchSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "SqlInjectionMatchSetId",
                    "Name"
                  ],
                  members: {
                    SqlInjectionMatchSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListSubscribedRuleGroups: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              RuleGroups: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "RuleGroupId",
                    "Name",
                    "MetricName"
                  ],
                  members: {
                    RuleGroupId: {},
                    Name: {},
                    MetricName: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              },
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              TagInfoForResource: {
                type: "structure",
                members: {
                  ResourceARN: {},
                  TagList: {
                    shape: "S10"
                  }
                }
              }
            }
          }
        },
        ListWebACLs: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              WebACLs: {
                type: "list",
                member: {
                  shape: "S59"
                }
              }
            }
          }
        },
        ListXssMatchSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              XssMatchSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "XssMatchSetId",
                    "Name"
                  ],
                  members: {
                    XssMatchSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        PutLoggingConfiguration: {
          input: {
            type: "structure",
            required: [
              "LoggingConfiguration"
            ],
            members: {
              LoggingConfiguration: {
                shape: "S3w"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LoggingConfiguration: {
                shape: "S3w"
              }
            }
          }
        },
        PutPermissionPolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Policy"
            ],
            members: {
              ResourceArn: {},
              Policy: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateByteMatchSet: {
          input: {
            type: "structure",
            required: [
              "ByteMatchSetId",
              "ChangeToken",
              "Updates"
            ],
            members: {
              ByteMatchSetId: {},
              ChangeToken: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "ByteMatchTuple"
                  ],
                  members: {
                    Action: {},
                    ByteMatchTuple: {
                      shape: "Sb"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateGeoMatchSet: {
          input: {
            type: "structure",
            required: [
              "GeoMatchSetId",
              "ChangeToken",
              "Updates"
            ],
            members: {
              GeoMatchSetId: {},
              ChangeToken: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "GeoMatchConstraint"
                  ],
                  members: {
                    Action: {},
                    GeoMatchConstraint: {
                      shape: "Sm"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateIPSet: {
          input: {
            type: "structure",
            required: [
              "IPSetId",
              "ChangeToken",
              "Updates"
            ],
            members: {
              IPSetId: {},
              ChangeToken: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "IPSetDescriptor"
                  ],
                  members: {
                    Action: {},
                    IPSetDescriptor: {
                      shape: "St"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateRateBasedRule: {
          input: {
            type: "structure",
            required: [
              "RuleId",
              "ChangeToken",
              "Updates",
              "RateLimit"
            ],
            members: {
              RuleId: {},
              ChangeToken: {},
              Updates: {
                shape: "S7p"
              },
              RateLimit: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateRegexMatchSet: {
          input: {
            type: "structure",
            required: [
              "RegexMatchSetId",
              "Updates",
              "ChangeToken"
            ],
            members: {
              RegexMatchSetId: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "RegexMatchTuple"
                  ],
                  members: {
                    Action: {},
                    RegexMatchTuple: {
                      shape: "S1e"
                    }
                  }
                }
              },
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateRegexPatternSet: {
          input: {
            type: "structure",
            required: [
              "RegexPatternSetId",
              "Updates",
              "ChangeToken"
            ],
            members: {
              RegexPatternSetId: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "RegexPatternString"
                  ],
                  members: {
                    Action: {},
                    RegexPatternString: {}
                  }
                }
              },
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateRule: {
          input: {
            type: "structure",
            required: [
              "RuleId",
              "ChangeToken",
              "Updates"
            ],
            members: {
              RuleId: {},
              ChangeToken: {},
              Updates: {
                shape: "S7p"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateRuleGroup: {
          input: {
            type: "structure",
            required: [
              "RuleGroupId",
              "Updates",
              "ChangeToken"
            ],
            members: {
              RuleGroupId: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "ActivatedRule"
                  ],
                  members: {
                    Action: {},
                    ActivatedRule: {
                      shape: "S28"
                    }
                  }
                }
              },
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateSizeConstraintSet: {
          input: {
            type: "structure",
            required: [
              "SizeConstraintSetId",
              "ChangeToken",
              "Updates"
            ],
            members: {
              SizeConstraintSetId: {},
              ChangeToken: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "SizeConstraint"
                  ],
                  members: {
                    Action: {},
                    SizeConstraint: {
                      shape: "S1u"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateSqlInjectionMatchSet: {
          input: {
            type: "structure",
            required: [
              "SqlInjectionMatchSetId",
              "ChangeToken",
              "Updates"
            ],
            members: {
              SqlInjectionMatchSetId: {},
              ChangeToken: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "SqlInjectionMatchTuple"
                  ],
                  members: {
                    Action: {},
                    SqlInjectionMatchTuple: {
                      shape: "S21"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateWebACL: {
          input: {
            type: "structure",
            required: [
              "WebACLId",
              "ChangeToken"
            ],
            members: {
              WebACLId: {},
              ChangeToken: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "ActivatedRule"
                  ],
                  members: {
                    Action: {},
                    ActivatedRule: {
                      shape: "S28"
                    }
                  }
                }
              },
              DefaultAction: {
                shape: "S23"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateXssMatchSet: {
          input: {
            type: "structure",
            required: [
              "XssMatchSetId",
              "ChangeToken",
              "Updates"
            ],
            members: {
              XssMatchSetId: {},
              ChangeToken: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "XssMatchTuple"
                  ],
                  members: {
                    Action: {},
                    XssMatchTuple: {
                      shape: "S2o"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        }
      },
      shapes: {
        S9: {
          type: "structure",
          required: [
            "ByteMatchSetId",
            "ByteMatchTuples"
          ],
          members: {
            ByteMatchSetId: {},
            Name: {},
            ByteMatchTuples: {
              type: "list",
              member: {
                shape: "Sb"
              }
            }
          }
        },
        Sb: {
          type: "structure",
          required: [
            "FieldToMatch",
            "TargetString",
            "TextTransformation",
            "PositionalConstraint"
          ],
          members: {
            FieldToMatch: {
              shape: "Sc"
            },
            TargetString: {
              type: "blob"
            },
            TextTransformation: {},
            PositionalConstraint: {}
          }
        },
        Sc: {
          type: "structure",
          required: [
            "Type"
          ],
          members: {
            Type: {},
            Data: {}
          }
        },
        Sk: {
          type: "structure",
          required: [
            "GeoMatchSetId",
            "GeoMatchConstraints"
          ],
          members: {
            GeoMatchSetId: {},
            Name: {},
            GeoMatchConstraints: {
              type: "list",
              member: {
                shape: "Sm"
              }
            }
          }
        },
        Sm: {
          type: "structure",
          required: [
            "Type",
            "Value"
          ],
          members: {
            Type: {},
            Value: {}
          }
        },
        Sr: {
          type: "structure",
          required: [
            "IPSetId",
            "IPSetDescriptors"
          ],
          members: {
            IPSetId: {},
            Name: {},
            IPSetDescriptors: {
              type: "list",
              member: {
                shape: "St"
              }
            }
          }
        },
        St: {
          type: "structure",
          required: [
            "Type",
            "Value"
          ],
          members: {
            Type: {},
            Value: {}
          }
        },
        S10: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S15: {
          type: "structure",
          required: [
            "RuleId",
            "MatchPredicates",
            "RateKey",
            "RateLimit"
          ],
          members: {
            RuleId: {},
            Name: {},
            MetricName: {},
            MatchPredicates: {
              shape: "S16"
            },
            RateKey: {},
            RateLimit: {
              type: "long"
            }
          }
        },
        S16: {
          type: "list",
          member: {
            shape: "S17"
          }
        },
        S17: {
          type: "structure",
          required: [
            "Negated",
            "Type",
            "DataId"
          ],
          members: {
            Negated: {
              type: "boolean"
            },
            Type: {},
            DataId: {}
          }
        },
        S1c: {
          type: "structure",
          members: {
            RegexMatchSetId: {},
            Name: {},
            RegexMatchTuples: {
              type: "list",
              member: {
                shape: "S1e"
              }
            }
          }
        },
        S1e: {
          type: "structure",
          required: [
            "FieldToMatch",
            "TextTransformation",
            "RegexPatternSetId"
          ],
          members: {
            FieldToMatch: {
              shape: "Sc"
            },
            TextTransformation: {},
            RegexPatternSetId: {}
          }
        },
        S1h: {
          type: "structure",
          required: [
            "RegexPatternSetId",
            "RegexPatternStrings"
          ],
          members: {
            RegexPatternSetId: {},
            Name: {},
            RegexPatternStrings: {
              type: "list",
              member: {}
            }
          }
        },
        S1m: {
          type: "structure",
          required: [
            "RuleId",
            "Predicates"
          ],
          members: {
            RuleId: {},
            Name: {},
            MetricName: {},
            Predicates: {
              shape: "S16"
            }
          }
        },
        S1p: {
          type: "structure",
          required: [
            "RuleGroupId"
          ],
          members: {
            RuleGroupId: {},
            Name: {},
            MetricName: {}
          }
        },
        S1s: {
          type: "structure",
          required: [
            "SizeConstraintSetId",
            "SizeConstraints"
          ],
          members: {
            SizeConstraintSetId: {},
            Name: {},
            SizeConstraints: {
              type: "list",
              member: {
                shape: "S1u"
              }
            }
          }
        },
        S1u: {
          type: "structure",
          required: [
            "FieldToMatch",
            "TextTransformation",
            "ComparisonOperator",
            "Size"
          ],
          members: {
            FieldToMatch: {
              shape: "Sc"
            },
            TextTransformation: {},
            ComparisonOperator: {},
            Size: {
              type: "long"
            }
          }
        },
        S1z: {
          type: "structure",
          required: [
            "SqlInjectionMatchSetId",
            "SqlInjectionMatchTuples"
          ],
          members: {
            SqlInjectionMatchSetId: {},
            Name: {},
            SqlInjectionMatchTuples: {
              type: "list",
              member: {
                shape: "S21"
              }
            }
          }
        },
        S21: {
          type: "structure",
          required: [
            "FieldToMatch",
            "TextTransformation"
          ],
          members: {
            FieldToMatch: {
              shape: "Sc"
            },
            TextTransformation: {}
          }
        },
        S23: {
          type: "structure",
          required: [
            "Type"
          ],
          members: {
            Type: {}
          }
        },
        S26: {
          type: "structure",
          required: [
            "WebACLId",
            "DefaultAction",
            "Rules"
          ],
          members: {
            WebACLId: {},
            Name: {},
            MetricName: {},
            DefaultAction: {
              shape: "S23"
            },
            Rules: {
              shape: "S27"
            },
            WebACLArn: {}
          }
        },
        S27: {
          type: "list",
          member: {
            shape: "S28"
          }
        },
        S28: {
          type: "structure",
          required: [
            "Priority",
            "RuleId"
          ],
          members: {
            Priority: {
              type: "integer"
            },
            RuleId: {},
            Action: {
              shape: "S23"
            },
            OverrideAction: {
              type: "structure",
              required: [
                "Type"
              ],
              members: {
                Type: {}
              }
            },
            Type: {},
            ExcludedRules: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "RuleId"
                ],
                members: {
                  RuleId: {}
                }
              }
            }
          }
        },
        S2m: {
          type: "structure",
          required: [
            "XssMatchSetId",
            "XssMatchTuples"
          ],
          members: {
            XssMatchSetId: {},
            Name: {},
            XssMatchTuples: {
              type: "list",
              member: {
                shape: "S2o"
              }
            }
          }
        },
        S2o: {
          type: "structure",
          required: [
            "FieldToMatch",
            "TextTransformation"
          ],
          members: {
            FieldToMatch: {
              shape: "Sc"
            },
            TextTransformation: {}
          }
        },
        S3w: {
          type: "structure",
          required: [
            "ResourceArn",
            "LogDestinationConfigs"
          ],
          members: {
            ResourceArn: {},
            LogDestinationConfigs: {
              type: "list",
              member: {}
            },
            RedactedFields: {
              type: "list",
              member: {
                shape: "Sc"
              }
            }
          }
        },
        S4i: {
          type: "structure",
          required: [
            "StartTime",
            "EndTime"
          ],
          members: {
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            }
          }
        },
        S59: {
          type: "structure",
          required: [
            "WebACLId",
            "Name"
          ],
          members: {
            WebACLId: {},
            Name: {}
          }
        },
        S5w: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "RuleId",
              "Name"
            ],
            members: {
              RuleId: {},
              Name: {}
            }
          }
        },
        S7p: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Action",
              "Predicate"
            ],
            members: {
              Action: {},
              Predicate: {
                shape: "S17"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/waf-regional-2016-11-28.paginators.json
var require_waf_regional_2016_11_28_paginators = __commonJS({
  "node_modules/aws-sdk/apis/waf-regional-2016-11-28.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/wafregional.js
var require_wafregional = __commonJS({
  "node_modules/aws-sdk/clients/wafregional.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["wafregional"] = {};
    AWS2.WAFRegional = Service.defineService("wafregional", ["2016-11-28"]);
    Object.defineProperty(apiLoader.services["wafregional"], "2016-11-28", {
      get: function get() {
        var model = require_waf_regional_2016_11_28_min();
        model.paginators = require_waf_regional_2016_11_28_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.WAFRegional;
  }
});

// node_modules/aws-sdk/apis/workdocs-2016-05-01.min.json
var require_workdocs_2016_05_01_min = __commonJS({
  "node_modules/aws-sdk/apis/workdocs-2016-05-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-05-01",
        endpointPrefix: "workdocs",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon WorkDocs",
        serviceId: "WorkDocs",
        signatureVersion: "v4",
        uid: "workdocs-2016-05-01"
      },
      operations: {
        AbortDocumentVersionUpload: {
          http: {
            method: "DELETE",
            requestUri: "/api/v1/documents/{DocumentId}/versions/{VersionId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "DocumentId",
              "VersionId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              DocumentId: {
                location: "uri",
                locationName: "DocumentId"
              },
              VersionId: {
                location: "uri",
                locationName: "VersionId"
              }
            }
          }
        },
        ActivateUser: {
          http: {
            requestUri: "/api/v1/users/{UserId}/activation",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "UserId"
            ],
            members: {
              UserId: {
                location: "uri",
                locationName: "UserId"
              },
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                shape: "S8"
              }
            }
          }
        },
        AddResourcePermissions: {
          http: {
            requestUri: "/api/v1/resources/{ResourceId}/permissions",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "Principals"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              ResourceId: {
                location: "uri",
                locationName: "ResourceId"
              },
              Principals: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Id",
                    "Type",
                    "Role"
                  ],
                  members: {
                    Id: {},
                    Type: {},
                    Role: {}
                  }
                }
              },
              NotificationOptions: {
                type: "structure",
                members: {
                  SendEmail: {
                    type: "boolean"
                  },
                  EmailMessage: {
                    shape: "St"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ShareResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PrincipalId: {},
                    InviteePrincipalId: {},
                    Role: {},
                    Status: {},
                    ShareId: {},
                    StatusMessage: {
                      shape: "St"
                    }
                  }
                }
              }
            }
          }
        },
        CreateComment: {
          http: {
            requestUri: "/api/v1/documents/{DocumentId}/versions/{VersionId}/comment",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DocumentId",
              "VersionId",
              "Text"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              DocumentId: {
                location: "uri",
                locationName: "DocumentId"
              },
              VersionId: {
                location: "uri",
                locationName: "VersionId"
              },
              ParentId: {},
              ThreadId: {},
              Text: {
                shape: "S10"
              },
              Visibility: {},
              NotifyCollaborators: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Comment: {
                shape: "S13"
              }
            }
          }
        },
        CreateCustomMetadata: {
          http: {
            method: "PUT",
            requestUri: "/api/v1/resources/{ResourceId}/customMetadata",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "CustomMetadata"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              ResourceId: {
                location: "uri",
                locationName: "ResourceId"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionid"
              },
              CustomMetadata: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateFolder: {
          http: {
            requestUri: "/api/v1/folders",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ParentFolderId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              Name: {
                shape: "S1b"
              },
              ParentFolderId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Metadata: {
                shape: "S1d"
              }
            }
          }
        },
        CreateLabels: {
          http: {
            method: "PUT",
            requestUri: "/api/v1/resources/{ResourceId}/labels",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "Labels"
            ],
            members: {
              ResourceId: {
                location: "uri",
                locationName: "ResourceId"
              },
              Labels: {
                shape: "S1g"
              },
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateNotificationSubscription: {
          http: {
            requestUri: "/api/v1/organizations/{OrganizationId}/subscriptions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "Endpoint",
              "Protocol",
              "SubscriptionType"
            ],
            members: {
              OrganizationId: {
                location: "uri",
                locationName: "OrganizationId"
              },
              Endpoint: {},
              Protocol: {},
              SubscriptionType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Subscription: {
                shape: "S1p"
              }
            }
          }
        },
        CreateUser: {
          http: {
            requestUri: "/api/v1/users",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Username",
              "GivenName",
              "Surname",
              "Password"
            ],
            members: {
              OrganizationId: {},
              Username: {
                shape: "S9"
              },
              EmailAddress: {
                shape: "Sa"
              },
              GivenName: {
                shape: "Sb"
              },
              Surname: {
                shape: "Sb"
              },
              Password: {
                type: "string",
                sensitive: true
              },
              TimeZoneId: {},
              StorageRule: {
                shape: "Sj"
              },
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                shape: "S8"
              }
            }
          }
        },
        DeactivateUser: {
          http: {
            method: "DELETE",
            requestUri: "/api/v1/users/{UserId}/activation",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "UserId"
            ],
            members: {
              UserId: {
                location: "uri",
                locationName: "UserId"
              },
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              }
            }
          }
        },
        DeleteComment: {
          http: {
            method: "DELETE",
            requestUri: "/api/v1/documents/{DocumentId}/versions/{VersionId}/comment/{CommentId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "DocumentId",
              "VersionId",
              "CommentId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              DocumentId: {
                location: "uri",
                locationName: "DocumentId"
              },
              VersionId: {
                location: "uri",
                locationName: "VersionId"
              },
              CommentId: {
                location: "uri",
                locationName: "CommentId"
              }
            }
          }
        },
        DeleteCustomMetadata: {
          http: {
            method: "DELETE",
            requestUri: "/api/v1/resources/{ResourceId}/customMetadata",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              ResourceId: {
                location: "uri",
                locationName: "ResourceId"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionId"
              },
              Keys: {
                location: "querystring",
                locationName: "keys",
                type: "list",
                member: {}
              },
              DeleteAll: {
                location: "querystring",
                locationName: "deleteAll",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDocument: {
          http: {
            method: "DELETE",
            requestUri: "/api/v1/documents/{DocumentId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "DocumentId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              DocumentId: {
                location: "uri",
                locationName: "DocumentId"
              }
            }
          }
        },
        DeleteDocumentVersion: {
          http: {
            method: "DELETE",
            requestUri: "/api/v1/documentVersions/{DocumentId}/versions/{VersionId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "DocumentId",
              "VersionId",
              "DeletePriorVersions"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              DocumentId: {
                location: "uri",
                locationName: "DocumentId"
              },
              VersionId: {
                location: "uri",
                locationName: "VersionId"
              },
              DeletePriorVersions: {
                location: "querystring",
                locationName: "deletePriorVersions",
                type: "boolean"
              }
            }
          }
        },
        DeleteFolder: {
          http: {
            method: "DELETE",
            requestUri: "/api/v1/folders/{FolderId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "FolderId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              }
            }
          }
        },
        DeleteFolderContents: {
          http: {
            method: "DELETE",
            requestUri: "/api/v1/folders/{FolderId}/contents",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "FolderId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              }
            }
          }
        },
        DeleteLabels: {
          http: {
            method: "DELETE",
            requestUri: "/api/v1/resources/{ResourceId}/labels",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              ResourceId: {
                location: "uri",
                locationName: "ResourceId"
              },
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              Labels: {
                shape: "S1g",
                location: "querystring",
                locationName: "labels"
              },
              DeleteAll: {
                location: "querystring",
                locationName: "deleteAll",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteNotificationSubscription: {
          http: {
            method: "DELETE",
            requestUri: "/api/v1/organizations/{OrganizationId}/subscriptions/{SubscriptionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SubscriptionId",
              "OrganizationId"
            ],
            members: {
              SubscriptionId: {
                location: "uri",
                locationName: "SubscriptionId"
              },
              OrganizationId: {
                location: "uri",
                locationName: "OrganizationId"
              }
            }
          }
        },
        DeleteUser: {
          http: {
            method: "DELETE",
            requestUri: "/api/v1/users/{UserId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "UserId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              UserId: {
                location: "uri",
                locationName: "UserId"
              }
            }
          }
        },
        DescribeActivities: {
          http: {
            method: "GET",
            requestUri: "/api/v1/activities",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              StartTime: {
                location: "querystring",
                locationName: "startTime",
                type: "timestamp"
              },
              EndTime: {
                location: "querystring",
                locationName: "endTime",
                type: "timestamp"
              },
              OrganizationId: {
                location: "querystring",
                locationName: "organizationId"
              },
              ActivityTypes: {
                location: "querystring",
                locationName: "activityTypes"
              },
              ResourceId: {
                location: "querystring",
                locationName: "resourceId"
              },
              UserId: {
                location: "querystring",
                locationName: "userId"
              },
              IncludeIndirectActivities: {
                location: "querystring",
                locationName: "includeIndirectActivities",
                type: "boolean"
              },
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              Marker: {
                location: "querystring",
                locationName: "marker"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserActivities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    TimeStamp: {
                      type: "timestamp"
                    },
                    IsIndirectActivity: {
                      type: "boolean"
                    },
                    OrganizationId: {},
                    Initiator: {
                      shape: "S2e"
                    },
                    Participants: {
                      type: "structure",
                      members: {
                        Users: {
                          type: "list",
                          member: {
                            shape: "S2e"
                          }
                        },
                        Groups: {
                          shape: "S2h"
                        }
                      }
                    },
                    ResourceMetadata: {
                      shape: "S2k"
                    },
                    OriginalParent: {
                      shape: "S2k"
                    },
                    CommentMetadata: {
                      shape: "S2m"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeComments: {
          http: {
            method: "GET",
            requestUri: "/api/v1/documents/{DocumentId}/versions/{VersionId}/comments",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DocumentId",
              "VersionId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              DocumentId: {
                location: "uri",
                locationName: "DocumentId"
              },
              VersionId: {
                location: "uri",
                locationName: "VersionId"
              },
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              Marker: {
                location: "querystring",
                locationName: "marker"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Comments: {
                type: "list",
                member: {
                  shape: "S13"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeDocumentVersions: {
          http: {
            method: "GET",
            requestUri: "/api/v1/documents/{DocumentId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DocumentId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              DocumentId: {
                location: "uri",
                locationName: "DocumentId"
              },
              Marker: {
                location: "querystring",
                locationName: "marker"
              },
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              Include: {
                location: "querystring",
                locationName: "include"
              },
              Fields: {
                location: "querystring",
                locationName: "fields"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentVersions: {
                type: "list",
                member: {
                  shape: "S2w"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeFolderContents: {
          http: {
            method: "GET",
            requestUri: "/api/v1/folders/{FolderId}/contents",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FolderId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              },
              Sort: {
                location: "querystring",
                locationName: "sort"
              },
              Order: {
                location: "querystring",
                locationName: "order"
              },
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              Marker: {
                location: "querystring",
                locationName: "marker"
              },
              Type: {
                location: "querystring",
                locationName: "type"
              },
              Include: {
                location: "querystring",
                locationName: "include"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Folders: {
                shape: "S39"
              },
              Documents: {
                shape: "S3a"
              },
              Marker: {}
            }
          }
        },
        DescribeGroups: {
          http: {
            method: "GET",
            requestUri: "/api/v1/groups",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SearchQuery"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              SearchQuery: {
                shape: "S3d",
                location: "querystring",
                locationName: "searchQuery"
              },
              OrganizationId: {
                location: "querystring",
                locationName: "organizationId"
              },
              Marker: {
                location: "querystring",
                locationName: "marker"
              },
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Groups: {
                shape: "S2h"
              },
              Marker: {}
            }
          }
        },
        DescribeNotificationSubscriptions: {
          http: {
            method: "GET",
            requestUri: "/api/v1/organizations/{OrganizationId}/subscriptions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "OrganizationId"
            ],
            members: {
              OrganizationId: {
                location: "uri",
                locationName: "OrganizationId"
              },
              Marker: {
                location: "querystring",
                locationName: "marker"
              },
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Subscriptions: {
                type: "list",
                member: {
                  shape: "S1p"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeResourcePermissions: {
          http: {
            method: "GET",
            requestUri: "/api/v1/resources/{ResourceId}/permissions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              ResourceId: {
                location: "uri",
                locationName: "ResourceId"
              },
              PrincipalId: {
                location: "querystring",
                locationName: "principalId"
              },
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              Marker: {
                location: "querystring",
                locationName: "marker"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Principals: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Type: {},
                    Roles: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Role: {},
                          Type: {}
                        }
                      }
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeRootFolders: {
          http: {
            method: "GET",
            requestUri: "/api/v1/me/root",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AuthenticationToken"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              Marker: {
                location: "querystring",
                locationName: "marker"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Folders: {
                shape: "S39"
              },
              Marker: {}
            }
          }
        },
        DescribeUsers: {
          http: {
            method: "GET",
            requestUri: "/api/v1/users",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              OrganizationId: {
                location: "querystring",
                locationName: "organizationId"
              },
              UserIds: {
                location: "querystring",
                locationName: "userIds"
              },
              Query: {
                shape: "S3d",
                location: "querystring",
                locationName: "query"
              },
              Include: {
                location: "querystring",
                locationName: "include"
              },
              Order: {
                location: "querystring",
                locationName: "order"
              },
              Sort: {
                location: "querystring",
                locationName: "sort"
              },
              Marker: {
                location: "querystring",
                locationName: "marker"
              },
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              Fields: {
                location: "querystring",
                locationName: "fields"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Users: {
                type: "list",
                member: {
                  shape: "S8"
                }
              },
              TotalNumberOfUsers: {
                deprecated: true,
                type: "long"
              },
              Marker: {}
            }
          }
        },
        GetCurrentUser: {
          http: {
            method: "GET",
            requestUri: "/api/v1/me",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AuthenticationToken"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                shape: "S8"
              }
            }
          }
        },
        GetDocument: {
          http: {
            method: "GET",
            requestUri: "/api/v1/documents/{DocumentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DocumentId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              DocumentId: {
                location: "uri",
                locationName: "DocumentId"
              },
              IncludeCustomMetadata: {
                location: "querystring",
                locationName: "includeCustomMetadata",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Metadata: {
                shape: "S3b"
              },
              CustomMetadata: {
                shape: "S16"
              }
            }
          }
        },
        GetDocumentPath: {
          http: {
            method: "GET",
            requestUri: "/api/v1/documents/{DocumentId}/path",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DocumentId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              DocumentId: {
                location: "uri",
                locationName: "DocumentId"
              },
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              Fields: {
                location: "querystring",
                locationName: "fields"
              },
              Marker: {
                location: "querystring",
                locationName: "marker"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Path: {
                shape: "S44"
              }
            }
          }
        },
        GetDocumentVersion: {
          http: {
            method: "GET",
            requestUri: "/api/v1/documents/{DocumentId}/versions/{VersionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DocumentId",
              "VersionId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              DocumentId: {
                location: "uri",
                locationName: "DocumentId"
              },
              VersionId: {
                location: "uri",
                locationName: "VersionId"
              },
              Fields: {
                location: "querystring",
                locationName: "fields"
              },
              IncludeCustomMetadata: {
                location: "querystring",
                locationName: "includeCustomMetadata",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Metadata: {
                shape: "S2w"
              },
              CustomMetadata: {
                shape: "S16"
              }
            }
          }
        },
        GetFolder: {
          http: {
            method: "GET",
            requestUri: "/api/v1/folders/{FolderId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FolderId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              },
              IncludeCustomMetadata: {
                location: "querystring",
                locationName: "includeCustomMetadata",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Metadata: {
                shape: "S1d"
              },
              CustomMetadata: {
                shape: "S16"
              }
            }
          }
        },
        GetFolderPath: {
          http: {
            method: "GET",
            requestUri: "/api/v1/folders/{FolderId}/path",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FolderId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              },
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              Fields: {
                location: "querystring",
                locationName: "fields"
              },
              Marker: {
                location: "querystring",
                locationName: "marker"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Path: {
                shape: "S44"
              }
            }
          }
        },
        GetResources: {
          http: {
            method: "GET",
            requestUri: "/api/v1/resources",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              UserId: {
                location: "querystring",
                locationName: "userId"
              },
              CollectionType: {
                location: "querystring",
                locationName: "collectionType"
              },
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              Marker: {
                location: "querystring",
                locationName: "marker"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Folders: {
                shape: "S39"
              },
              Documents: {
                shape: "S3a"
              },
              Marker: {}
            }
          }
        },
        InitiateDocumentVersionUpload: {
          http: {
            requestUri: "/api/v1/documents",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              Id: {},
              Name: {
                shape: "S1b"
              },
              ContentCreatedTimestamp: {
                type: "timestamp"
              },
              ContentModifiedTimestamp: {
                type: "timestamp"
              },
              ContentType: {},
              DocumentSizeInBytes: {
                type: "long"
              },
              ParentFolderId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Metadata: {
                shape: "S3b"
              },
              UploadMetadata: {
                type: "structure",
                members: {
                  UploadUrl: {
                    shape: "S31"
                  },
                  SignedHeaders: {
                    type: "map",
                    key: {},
                    value: {}
                  }
                }
              }
            }
          }
        },
        RemoveAllResourcePermissions: {
          http: {
            method: "DELETE",
            requestUri: "/api/v1/resources/{ResourceId}/permissions",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              ResourceId: {
                location: "uri",
                locationName: "ResourceId"
              }
            }
          }
        },
        RemoveResourcePermission: {
          http: {
            method: "DELETE",
            requestUri: "/api/v1/resources/{ResourceId}/permissions/{PrincipalId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "PrincipalId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              ResourceId: {
                location: "uri",
                locationName: "ResourceId"
              },
              PrincipalId: {
                location: "uri",
                locationName: "PrincipalId"
              },
              PrincipalType: {
                location: "querystring",
                locationName: "type"
              }
            }
          }
        },
        RestoreDocumentVersions: {
          http: {
            requestUri: "/api/v1/documentVersions/restore/{DocumentId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "DocumentId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              DocumentId: {
                location: "uri",
                locationName: "DocumentId"
              }
            }
          }
        },
        SearchResources: {
          http: {
            requestUri: "/api/v1/search",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              QueryText: {
                shape: "S3d"
              },
              QueryScopes: {
                type: "list",
                member: {}
              },
              OrganizationId: {},
              AdditionalResponseFields: {
                type: "list",
                member: {}
              },
              Filters: {
                type: "structure",
                members: {
                  TextLocales: {
                    type: "list",
                    member: {}
                  },
                  ContentCategories: {
                    type: "list",
                    member: {}
                  },
                  ResourceTypes: {
                    type: "list",
                    member: {}
                  },
                  Labels: {
                    type: "list",
                    member: {}
                  },
                  Principals: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Id"
                      ],
                      members: {
                        Id: {},
                        Roles: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  },
                  AncestorIds: {
                    type: "list",
                    member: {}
                  },
                  SearchCollectionTypes: {
                    type: "list",
                    member: {}
                  },
                  SizeRange: {
                    type: "structure",
                    members: {
                      StartValue: {
                        type: "long"
                      },
                      EndValue: {
                        type: "long"
                      }
                    }
                  },
                  CreatedRange: {
                    shape: "S5d"
                  },
                  ModifiedRange: {
                    shape: "S5d"
                  }
                }
              },
              OrderBy: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Field: {},
                    Order: {}
                  }
                }
              },
              Limit: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceType: {},
                    WebUrl: {
                      type: "string",
                      sensitive: true
                    },
                    DocumentMetadata: {
                      shape: "S3b"
                    },
                    FolderMetadata: {
                      shape: "S1d"
                    },
                    CommentMetadata: {
                      shape: "S2m"
                    },
                    DocumentVersionMetadata: {
                      shape: "S2w"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        UpdateDocument: {
          http: {
            method: "PATCH",
            requestUri: "/api/v1/documents/{DocumentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DocumentId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              DocumentId: {
                location: "uri",
                locationName: "DocumentId"
              },
              Name: {
                shape: "S1b"
              },
              ParentFolderId: {},
              ResourceState: {}
            }
          }
        },
        UpdateDocumentVersion: {
          http: {
            method: "PATCH",
            requestUri: "/api/v1/documents/{DocumentId}/versions/{VersionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DocumentId",
              "VersionId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              DocumentId: {
                location: "uri",
                locationName: "DocumentId"
              },
              VersionId: {
                location: "uri",
                locationName: "VersionId"
              },
              VersionStatus: {}
            }
          }
        },
        UpdateFolder: {
          http: {
            method: "PATCH",
            requestUri: "/api/v1/folders/{FolderId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FolderId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              },
              Name: {
                shape: "S1b"
              },
              ParentFolderId: {},
              ResourceState: {}
            }
          }
        },
        UpdateUser: {
          http: {
            method: "PATCH",
            requestUri: "/api/v1/users/{UserId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "UserId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              UserId: {
                location: "uri",
                locationName: "UserId"
              },
              GivenName: {
                shape: "Sb"
              },
              Surname: {
                shape: "Sb"
              },
              Type: {},
              StorageRule: {
                shape: "Sj"
              },
              TimeZoneId: {},
              Locale: {},
              GrantPoweruserPrivileges: {}
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                shape: "S8"
              }
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "string",
          sensitive: true
        },
        S8: {
          type: "structure",
          members: {
            Id: {},
            Username: {
              shape: "S9"
            },
            EmailAddress: {
              shape: "Sa"
            },
            GivenName: {
              shape: "Sb"
            },
            Surname: {
              shape: "Sb"
            },
            OrganizationId: {},
            RootFolderId: {},
            RecycleBinFolderId: {},
            Status: {},
            Type: {},
            CreatedTimestamp: {
              type: "timestamp"
            },
            ModifiedTimestamp: {
              type: "timestamp"
            },
            TimeZoneId: {},
            Locale: {},
            Storage: {
              type: "structure",
              members: {
                StorageUtilizedInBytes: {
                  type: "long"
                },
                StorageRule: {
                  shape: "Sj"
                }
              }
            }
          }
        },
        S9: {
          type: "string",
          sensitive: true
        },
        Sa: {
          type: "string",
          sensitive: true
        },
        Sb: {
          type: "string",
          sensitive: true
        },
        Sj: {
          type: "structure",
          members: {
            StorageAllocatedInBytes: {
              type: "long"
            },
            StorageType: {}
          }
        },
        St: {
          type: "string",
          sensitive: true
        },
        S10: {
          type: "string",
          sensitive: true
        },
        S13: {
          type: "structure",
          required: [
            "CommentId"
          ],
          members: {
            CommentId: {},
            ParentId: {},
            ThreadId: {},
            Text: {
              shape: "S10"
            },
            Contributor: {
              shape: "S8"
            },
            CreatedTimestamp: {
              type: "timestamp"
            },
            Status: {},
            Visibility: {},
            RecipientId: {}
          }
        },
        S16: {
          type: "map",
          key: {},
          value: {}
        },
        S1b: {
          type: "string",
          sensitive: true
        },
        S1d: {
          type: "structure",
          members: {
            Id: {},
            Name: {
              shape: "S1b"
            },
            CreatorId: {},
            ParentFolderId: {},
            CreatedTimestamp: {
              type: "timestamp"
            },
            ModifiedTimestamp: {
              type: "timestamp"
            },
            ResourceState: {},
            Signature: {},
            Labels: {
              shape: "S1g"
            },
            Size: {
              type: "long"
            },
            LatestVersionSize: {
              type: "long"
            }
          }
        },
        S1g: {
          type: "list",
          member: {}
        },
        S1p: {
          type: "structure",
          members: {
            SubscriptionId: {},
            EndPoint: {},
            Protocol: {}
          }
        },
        S2e: {
          type: "structure",
          members: {
            Id: {},
            Username: {
              shape: "S9"
            },
            GivenName: {
              shape: "Sb"
            },
            Surname: {
              shape: "Sb"
            },
            EmailAddress: {
              shape: "Sa"
            }
          }
        },
        S2h: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Id: {},
              Name: {}
            }
          }
        },
        S2k: {
          type: "structure",
          members: {
            Type: {},
            Name: {
              shape: "S1b"
            },
            OriginalName: {
              shape: "S1b"
            },
            Id: {},
            VersionId: {},
            Owner: {
              shape: "S2e"
            },
            ParentId: {}
          }
        },
        S2m: {
          type: "structure",
          members: {
            CommentId: {},
            Contributor: {
              shape: "S8"
            },
            CreatedTimestamp: {
              type: "timestamp"
            },
            CommentStatus: {},
            RecipientId: {},
            ContributorId: {}
          }
        },
        S2w: {
          type: "structure",
          members: {
            Id: {},
            Name: {
              shape: "S1b"
            },
            ContentType: {},
            Size: {
              type: "long"
            },
            Signature: {},
            Status: {},
            CreatedTimestamp: {
              type: "timestamp"
            },
            ModifiedTimestamp: {
              type: "timestamp"
            },
            ContentCreatedTimestamp: {
              type: "timestamp"
            },
            ContentModifiedTimestamp: {
              type: "timestamp"
            },
            CreatorId: {},
            Thumbnail: {
              type: "map",
              key: {},
              value: {
                shape: "S31"
              }
            },
            Source: {
              type: "map",
              key: {},
              value: {
                shape: "S31"
              }
            }
          }
        },
        S31: {
          type: "string",
          sensitive: true
        },
        S39: {
          type: "list",
          member: {
            shape: "S1d"
          }
        },
        S3a: {
          type: "list",
          member: {
            shape: "S3b"
          }
        },
        S3b: {
          type: "structure",
          members: {
            Id: {},
            CreatorId: {},
            ParentFolderId: {},
            CreatedTimestamp: {
              type: "timestamp"
            },
            ModifiedTimestamp: {
              type: "timestamp"
            },
            LatestVersionMetadata: {
              shape: "S2w"
            },
            ResourceState: {},
            Labels: {
              shape: "S1g"
            }
          }
        },
        S3d: {
          type: "string",
          sensitive: true
        },
        S44: {
          type: "structure",
          members: {
            Components: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Id: {},
                  Name: {
                    shape: "S1b"
                  }
                }
              }
            }
          }
        },
        S5d: {
          type: "structure",
          members: {
            StartValue: {
              type: "timestamp"
            },
            EndValue: {
              type: "timestamp"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/workdocs-2016-05-01.paginators.json
var require_workdocs_2016_05_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/workdocs-2016-05-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeActivities: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "Marker",
          result_key: "UserActivities"
        },
        DescribeComments: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "Marker",
          result_key: "Comments"
        },
        DescribeDocumentVersions: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "Marker",
          result_key: "DocumentVersions"
        },
        DescribeFolderContents: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "Marker",
          result_key: [
            "Folders",
            "Documents"
          ]
        },
        DescribeGroups: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "Marker",
          result_key: "Groups"
        },
        DescribeNotificationSubscriptions: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "Marker",
          result_key: "Subscriptions"
        },
        DescribeResourcePermissions: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "Marker",
          result_key: "Principals"
        },
        DescribeRootFolders: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "Marker",
          result_key: "Folders"
        },
        DescribeUsers: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "Marker",
          result_key: "Users"
        },
        SearchResources: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "Marker",
          result_key: "Items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/workdocs.js
var require_workdocs = __commonJS({
  "node_modules/aws-sdk/clients/workdocs.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["workdocs"] = {};
    AWS2.WorkDocs = Service.defineService("workdocs", ["2016-05-01"]);
    Object.defineProperty(apiLoader.services["workdocs"], "2016-05-01", {
      get: function get() {
        var model = require_workdocs_2016_05_01_min();
        model.paginators = require_workdocs_2016_05_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.WorkDocs;
  }
});

// node_modules/aws-sdk/apis/workspaces-2015-04-08.min.json
var require_workspaces_2015_04_08_min = __commonJS({
  "node_modules/aws-sdk/apis/workspaces-2015-04-08.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-04-08",
        endpointPrefix: "workspaces",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon WorkSpaces",
        serviceId: "WorkSpaces",
        signatureVersion: "v4",
        targetPrefix: "WorkspacesService",
        uid: "workspaces-2015-04-08"
      },
      operations: {
        AssociateConnectionAlias: {
          input: {
            type: "structure",
            required: [
              "AliasId",
              "ResourceId"
            ],
            members: {
              AliasId: {},
              ResourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionIdentifier: {}
            }
          }
        },
        AssociateIpGroups: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "GroupIds"
            ],
            members: {
              DirectoryId: {},
              GroupIds: {
                shape: "S8"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateWorkspaceApplication: {
          input: {
            type: "structure",
            required: [
              "WorkspaceId",
              "ApplicationId"
            ],
            members: {
              WorkspaceId: {},
              ApplicationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Association: {
                shape: "Sf"
              }
            }
          }
        },
        AuthorizeIpRules: {
          input: {
            type: "structure",
            required: [
              "GroupId",
              "UserRules"
            ],
            members: {
              GroupId: {},
              UserRules: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CopyWorkspaceImage: {
          input: {
            type: "structure",
            required: [
              "Name",
              "SourceImageId",
              "SourceRegion"
            ],
            members: {
              Name: {},
              Description: {},
              SourceImageId: {},
              SourceRegion: {},
              Tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ImageId: {}
            }
          }
        },
        CreateConnectClientAddIn: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "Name",
              "URL"
            ],
            members: {
              ResourceId: {},
              Name: {},
              URL: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AddInId: {}
            }
          }
        },
        CreateConnectionAlias: {
          input: {
            type: "structure",
            required: [
              "ConnectionString"
            ],
            members: {
              ConnectionString: {},
              Tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AliasId: {}
            }
          }
        },
        CreateIpGroup: {
          input: {
            type: "structure",
            required: [
              "GroupName"
            ],
            members: {
              GroupName: {},
              GroupDesc: {},
              UserRules: {
                shape: "Sn"
              },
              Tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GroupId: {}
            }
          }
        },
        CreateStandbyWorkspaces: {
          input: {
            type: "structure",
            required: [
              "PrimaryRegion",
              "StandbyWorkspaces"
            ],
            members: {
              PrimaryRegion: {},
              StandbyWorkspaces: {
                type: "list",
                member: {
                  shape: "S1g"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedStandbyRequests: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StandbyWorkspaceRequest: {
                      shape: "S1g"
                    },
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              },
              PendingStandbyRequests: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    UserName: {},
                    DirectoryId: {},
                    State: {},
                    WorkspaceId: {}
                  }
                }
              }
            }
          }
        },
        CreateTags: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "Tags"
            ],
            members: {
              ResourceId: {},
              Tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateUpdatedWorkspaceImage: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Description",
              "SourceImageId"
            ],
            members: {
              Name: {},
              Description: {},
              SourceImageId: {},
              Tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ImageId: {}
            }
          }
        },
        CreateWorkspaceBundle: {
          input: {
            type: "structure",
            required: [
              "BundleName",
              "BundleDescription",
              "ImageId",
              "ComputeType",
              "UserStorage"
            ],
            members: {
              BundleName: {},
              BundleDescription: {},
              ImageId: {},
              ComputeType: {
                shape: "S1z"
              },
              UserStorage: {
                shape: "S21"
              },
              RootStorage: {
                shape: "S22"
              },
              Tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkspaceBundle: {
                shape: "S24"
              }
            }
          }
        },
        CreateWorkspaceImage: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Description",
              "WorkspaceId"
            ],
            members: {
              Name: {},
              Description: {},
              WorkspaceId: {},
              Tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ImageId: {},
              Name: {},
              Description: {},
              OperatingSystem: {
                shape: "S2b"
              },
              State: {},
              RequiredTenancy: {},
              Created: {
                type: "timestamp"
              },
              OwnerAccountId: {}
            }
          }
        },
        CreateWorkspaces: {
          input: {
            type: "structure",
            required: [
              "Workspaces"
            ],
            members: {
              Workspaces: {
                type: "list",
                member: {
                  shape: "S2i"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedRequests: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WorkspaceRequest: {
                      shape: "S2i"
                    },
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              },
              PendingRequests: {
                shape: "S2w"
              }
            }
          }
        },
        DeleteClientBranding: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "Platforms"
            ],
            members: {
              ResourceId: {},
              Platforms: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteConnectClientAddIn: {
          input: {
            type: "structure",
            required: [
              "AddInId",
              "ResourceId"
            ],
            members: {
              AddInId: {},
              ResourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteConnectionAlias: {
          input: {
            type: "structure",
            required: [
              "AliasId"
            ],
            members: {
              AliasId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteIpGroup: {
          input: {
            type: "structure",
            required: [
              "GroupId"
            ],
            members: {
              GroupId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteTags: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "TagKeys"
            ],
            members: {
              ResourceId: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteWorkspaceBundle: {
          input: {
            type: "structure",
            members: {
              BundleId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteWorkspaceImage: {
          input: {
            type: "structure",
            required: [
              "ImageId"
            ],
            members: {
              ImageId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeployWorkspaceApplications: {
          input: {
            type: "structure",
            required: [
              "WorkspaceId"
            ],
            members: {
              WorkspaceId: {},
              Force: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Deployment: {
                type: "structure",
                members: {
                  Associations: {
                    shape: "S3v"
                  }
                }
              }
            }
          }
        },
        DeregisterWorkspaceDirectory: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeAccount: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              DedicatedTenancySupport: {},
              DedicatedTenancyManagementCidrRange: {}
            }
          }
        },
        DescribeAccountModifications: {
          input: {
            type: "structure",
            members: {
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AccountModifications: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ModificationState: {},
                    DedicatedTenancySupport: {},
                    DedicatedTenancyManagementCidrRange: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeApplicationAssociations: {
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "AssociatedResourceTypes"
            ],
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              ApplicationId: {},
              AssociatedResourceTypes: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Associations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApplicationId: {},
                    AssociatedResourceId: {},
                    AssociatedResourceType: {},
                    Created: {
                      type: "timestamp"
                    },
                    LastUpdatedTime: {
                      type: "timestamp"
                    },
                    State: {},
                    StateReason: {
                      shape: "Sj"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeApplications: {
          input: {
            type: "structure",
            members: {
              ApplicationIds: {
                type: "list",
                member: {}
              },
              ComputeTypeNames: {
                shape: "S4h"
              },
              LicenseType: {},
              OperatingSystemNames: {
                shape: "S4j"
              },
              Owner: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Applications: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApplicationId: {},
                    Created: {
                      type: "timestamp"
                    },
                    Description: {},
                    LicenseType: {},
                    Name: {},
                    Owner: {},
                    State: {},
                    SupportedComputeTypeNames: {
                      shape: "S4h"
                    },
                    SupportedOperatingSystemNames: {
                      shape: "S4j"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeBundleAssociations: {
          input: {
            type: "structure",
            required: [
              "BundleId",
              "AssociatedResourceTypes"
            ],
            members: {
              BundleId: {},
              AssociatedResourceTypes: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Associations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AssociatedResourceId: {},
                    AssociatedResourceType: {},
                    BundleId: {},
                    Created: {
                      type: "timestamp"
                    },
                    LastUpdatedTime: {
                      type: "timestamp"
                    },
                    State: {},
                    StateReason: {
                      shape: "Sj"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeClientBranding: {
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              ResourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DeviceTypeWindows: {
                shape: "S4x"
              },
              DeviceTypeOsx: {
                shape: "S4x"
              },
              DeviceTypeAndroid: {
                shape: "S4x"
              },
              DeviceTypeIos: {
                shape: "S53"
              },
              DeviceTypeLinux: {
                shape: "S4x"
              },
              DeviceTypeWeb: {
                shape: "S4x"
              }
            }
          }
        },
        DescribeClientProperties: {
          input: {
            type: "structure",
            required: [
              "ResourceIds"
            ],
            members: {
              ResourceIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ClientPropertiesList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceId: {},
                    ClientProperties: {
                      shape: "S59"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeConnectClientAddIns: {
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              ResourceId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AddIns: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AddInId: {},
                    ResourceId: {},
                    Name: {},
                    URL: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeConnectionAliasPermissions: {
          input: {
            type: "structure",
            required: [
              "AliasId"
            ],
            members: {
              AliasId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AliasId: {},
              ConnectionAliasPermissions: {
                type: "list",
                member: {
                  shape: "S5j"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeConnectionAliases: {
          input: {
            type: "structure",
            members: {
              AliasIds: {
                type: "list",
                member: {}
              },
              ResourceId: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionAliases: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ConnectionString: {},
                    AliasId: {},
                    State: {},
                    OwnerAccountId: {},
                    Associations: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          AssociationStatus: {},
                          AssociatedAccountId: {},
                          ResourceId: {},
                          ConnectionIdentifier: {}
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeImageAssociations: {
          input: {
            type: "structure",
            required: [
              "ImageId",
              "AssociatedResourceTypes"
            ],
            members: {
              ImageId: {},
              AssociatedResourceTypes: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Associations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AssociatedResourceId: {},
                    AssociatedResourceType: {},
                    Created: {
                      type: "timestamp"
                    },
                    LastUpdatedTime: {
                      type: "timestamp"
                    },
                    ImageId: {},
                    State: {},
                    StateReason: {
                      shape: "Sj"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeIpGroups: {
          input: {
            type: "structure",
            members: {
              GroupIds: {
                shape: "S8"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Result: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    groupId: {},
                    groupName: {},
                    groupDesc: {},
                    userRules: {
                      shape: "Sn"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeTags: {
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              ResourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TagList: {
                shape: "Sx"
              }
            }
          }
        },
        DescribeWorkspaceAssociations: {
          input: {
            type: "structure",
            required: [
              "WorkspaceId",
              "AssociatedResourceTypes"
            ],
            members: {
              WorkspaceId: {},
              AssociatedResourceTypes: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Associations: {
                shape: "S3v"
              }
            }
          }
        },
        DescribeWorkspaceBundles: {
          input: {
            type: "structure",
            members: {
              BundleIds: {
                type: "list",
                member: {}
              },
              Owner: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Bundles: {
                type: "list",
                member: {
                  shape: "S24"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeWorkspaceDirectories: {
          input: {
            type: "structure",
            members: {
              DirectoryIds: {
                type: "list",
                member: {}
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Directories: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DirectoryId: {},
                    Alias: {},
                    DirectoryName: {},
                    RegistrationCode: {},
                    SubnetIds: {
                      shape: "S6k"
                    },
                    DnsIpAddresses: {
                      type: "list",
                      member: {}
                    },
                    CustomerUserName: {},
                    IamRoleId: {},
                    DirectoryType: {},
                    WorkspaceSecurityGroupId: {},
                    State: {},
                    WorkspaceCreationProperties: {
                      type: "structure",
                      members: {
                        EnableWorkDocs: {
                          type: "boolean"
                        },
                        EnableInternetAccess: {
                          type: "boolean"
                        },
                        DefaultOu: {},
                        CustomSecurityGroupId: {},
                        UserEnabledAsLocalAdministrator: {
                          type: "boolean"
                        },
                        EnableMaintenanceMode: {
                          type: "boolean"
                        }
                      }
                    },
                    ipGroupIds: {
                      shape: "S8"
                    },
                    WorkspaceAccessProperties: {
                      shape: "S6s"
                    },
                    Tenancy: {},
                    SelfservicePermissions: {
                      shape: "S6v"
                    },
                    SamlProperties: {
                      shape: "S6w"
                    },
                    CertificateBasedAuthProperties: {
                      shape: "S6z"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeWorkspaceImagePermissions: {
          input: {
            type: "structure",
            required: [
              "ImageId"
            ],
            members: {
              ImageId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ImageId: {},
              ImagePermissions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SharedAccountId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeWorkspaceImages: {
          input: {
            type: "structure",
            members: {
              ImageIds: {
                type: "list",
                member: {}
              },
              ImageType: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Images: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ImageId: {},
                    Name: {},
                    Description: {},
                    OperatingSystem: {
                      shape: "S2b"
                    },
                    State: {},
                    RequiredTenancy: {},
                    ErrorCode: {},
                    ErrorMessage: {},
                    Created: {
                      type: "timestamp"
                    },
                    OwnerAccountId: {},
                    Updates: {
                      type: "structure",
                      members: {
                        UpdateAvailable: {
                          type: "boolean"
                        },
                        Description: {}
                      }
                    },
                    ErrorDetails: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ErrorCode: {},
                          ErrorMessage: {}
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeWorkspaceSnapshots: {
          input: {
            type: "structure",
            required: [
              "WorkspaceId"
            ],
            members: {
              WorkspaceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RebuildSnapshots: {
                shape: "S7k"
              },
              RestoreSnapshots: {
                shape: "S7k"
              }
            }
          }
        },
        DescribeWorkspaces: {
          input: {
            type: "structure",
            members: {
              WorkspaceIds: {
                shape: "S7n"
              },
              DirectoryId: {},
              UserName: {},
              BundleId: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Workspaces: {
                shape: "S2w"
              },
              NextToken: {}
            }
          }
        },
        DescribeWorkspacesConnectionStatus: {
          input: {
            type: "structure",
            members: {
              WorkspaceIds: {
                shape: "S7n"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WorkspacesConnectionStatus: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WorkspaceId: {},
                    ConnectionState: {},
                    ConnectionStateCheckTimestamp: {
                      type: "timestamp"
                    },
                    LastKnownUserConnectionTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DisassociateConnectionAlias: {
          input: {
            type: "structure",
            required: [
              "AliasId"
            ],
            members: {
              AliasId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateIpGroups: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "GroupIds"
            ],
            members: {
              DirectoryId: {},
              GroupIds: {
                shape: "S8"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateWorkspaceApplication: {
          input: {
            type: "structure",
            required: [
              "WorkspaceId",
              "ApplicationId"
            ],
            members: {
              WorkspaceId: {},
              ApplicationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Association: {
                shape: "Sf"
              }
            }
          }
        },
        ImportClientBranding: {
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              ResourceId: {},
              DeviceTypeWindows: {
                shape: "S81"
              },
              DeviceTypeOsx: {
                shape: "S81"
              },
              DeviceTypeAndroid: {
                shape: "S81"
              },
              DeviceTypeIos: {
                type: "structure",
                members: {
                  Logo: {
                    type: "blob"
                  },
                  Logo2x: {
                    type: "blob"
                  },
                  Logo3x: {
                    type: "blob"
                  },
                  SupportEmail: {},
                  SupportLink: {},
                  ForgotPasswordLink: {},
                  LoginMessage: {
                    shape: "S50"
                  }
                }
              },
              DeviceTypeLinux: {
                shape: "S81"
              },
              DeviceTypeWeb: {
                shape: "S81"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeviceTypeWindows: {
                shape: "S4x"
              },
              DeviceTypeOsx: {
                shape: "S4x"
              },
              DeviceTypeAndroid: {
                shape: "S4x"
              },
              DeviceTypeIos: {
                shape: "S53"
              },
              DeviceTypeLinux: {
                shape: "S4x"
              },
              DeviceTypeWeb: {
                shape: "S4x"
              }
            }
          }
        },
        ImportWorkspaceImage: {
          input: {
            type: "structure",
            required: [
              "Ec2ImageId",
              "IngestionProcess",
              "ImageName",
              "ImageDescription"
            ],
            members: {
              Ec2ImageId: {},
              IngestionProcess: {},
              ImageName: {},
              ImageDescription: {},
              Tags: {
                shape: "Sx"
              },
              Applications: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ImageId: {}
            }
          }
        },
        ListAvailableManagementCidrRanges: {
          input: {
            type: "structure",
            required: [
              "ManagementCidrRangeConstraint"
            ],
            members: {
              ManagementCidrRangeConstraint: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ManagementCidrRanges: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        MigrateWorkspace: {
          input: {
            type: "structure",
            required: [
              "SourceWorkspaceId",
              "BundleId"
            ],
            members: {
              SourceWorkspaceId: {},
              BundleId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SourceWorkspaceId: {},
              TargetWorkspaceId: {}
            }
          }
        },
        ModifyAccount: {
          input: {
            type: "structure",
            members: {
              DedicatedTenancySupport: {},
              DedicatedTenancyManagementCidrRange: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ModifyCertificateBasedAuthProperties: {
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              ResourceId: {},
              CertificateBasedAuthProperties: {
                shape: "S6z"
              },
              PropertiesToDelete: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ModifyClientProperties: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "ClientProperties"
            ],
            members: {
              ResourceId: {},
              ClientProperties: {
                shape: "S59"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ModifySamlProperties: {
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              ResourceId: {},
              SamlProperties: {
                shape: "S6w"
              },
              PropertiesToDelete: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ModifySelfservicePermissions: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "SelfservicePermissions"
            ],
            members: {
              ResourceId: {},
              SelfservicePermissions: {
                shape: "S6v"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ModifyWorkspaceAccessProperties: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "WorkspaceAccessProperties"
            ],
            members: {
              ResourceId: {},
              WorkspaceAccessProperties: {
                shape: "S6s"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ModifyWorkspaceCreationProperties: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "WorkspaceCreationProperties"
            ],
            members: {
              ResourceId: {},
              WorkspaceCreationProperties: {
                type: "structure",
                members: {
                  EnableWorkDocs: {
                    type: "boolean"
                  },
                  EnableInternetAccess: {
                    type: "boolean"
                  },
                  DefaultOu: {},
                  CustomSecurityGroupId: {},
                  UserEnabledAsLocalAdministrator: {
                    type: "boolean"
                  },
                  EnableMaintenanceMode: {
                    type: "boolean"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ModifyWorkspaceProperties: {
          input: {
            type: "structure",
            required: [
              "WorkspaceId"
            ],
            members: {
              WorkspaceId: {},
              WorkspaceProperties: {
                shape: "S2k"
              },
              DataReplication: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ModifyWorkspaceState: {
          input: {
            type: "structure",
            required: [
              "WorkspaceId",
              "WorkspaceState"
            ],
            members: {
              WorkspaceId: {},
              WorkspaceState: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RebootWorkspaces: {
          input: {
            type: "structure",
            required: [
              "RebootWorkspaceRequests"
            ],
            members: {
              RebootWorkspaceRequests: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "WorkspaceId"
                  ],
                  members: {
                    WorkspaceId: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedRequests: {
                type: "list",
                member: {
                  shape: "S9f"
                }
              }
            }
          }
        },
        RebuildWorkspaces: {
          input: {
            type: "structure",
            required: [
              "RebuildWorkspaceRequests"
            ],
            members: {
              RebuildWorkspaceRequests: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "WorkspaceId"
                  ],
                  members: {
                    WorkspaceId: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedRequests: {
                type: "list",
                member: {
                  shape: "S9f"
                }
              }
            }
          }
        },
        RegisterWorkspaceDirectory: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "EnableWorkDocs"
            ],
            members: {
              DirectoryId: {},
              SubnetIds: {
                shape: "S6k"
              },
              EnableWorkDocs: {
                type: "boolean"
              },
              EnableSelfService: {
                type: "boolean"
              },
              Tenancy: {},
              Tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RestoreWorkspace: {
          input: {
            type: "structure",
            required: [
              "WorkspaceId"
            ],
            members: {
              WorkspaceId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RevokeIpRules: {
          input: {
            type: "structure",
            required: [
              "GroupId",
              "UserRules"
            ],
            members: {
              GroupId: {},
              UserRules: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartWorkspaces: {
          input: {
            type: "structure",
            required: [
              "StartWorkspaceRequests"
            ],
            members: {
              StartWorkspaceRequests: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WorkspaceId: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedRequests: {
                type: "list",
                member: {
                  shape: "S9f"
                }
              }
            }
          }
        },
        StopWorkspaces: {
          input: {
            type: "structure",
            required: [
              "StopWorkspaceRequests"
            ],
            members: {
              StopWorkspaceRequests: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WorkspaceId: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedRequests: {
                type: "list",
                member: {
                  shape: "S9f"
                }
              }
            }
          }
        },
        TerminateWorkspaces: {
          input: {
            type: "structure",
            required: [
              "TerminateWorkspaceRequests"
            ],
            members: {
              TerminateWorkspaceRequests: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "WorkspaceId"
                  ],
                  members: {
                    WorkspaceId: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedRequests: {
                type: "list",
                member: {
                  shape: "S9f"
                }
              }
            }
          }
        },
        UpdateConnectClientAddIn: {
          input: {
            type: "structure",
            required: [
              "AddInId",
              "ResourceId"
            ],
            members: {
              AddInId: {},
              ResourceId: {},
              Name: {},
              URL: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateConnectionAliasPermission: {
          input: {
            type: "structure",
            required: [
              "AliasId",
              "ConnectionAliasPermission"
            ],
            members: {
              AliasId: {},
              ConnectionAliasPermission: {
                shape: "S5j"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateRulesOfIpGroup: {
          input: {
            type: "structure",
            required: [
              "GroupId",
              "UserRules"
            ],
            members: {
              GroupId: {},
              UserRules: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateWorkspaceBundle: {
          input: {
            type: "structure",
            members: {
              BundleId: {},
              ImageId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateWorkspaceImagePermission: {
          input: {
            type: "structure",
            required: [
              "ImageId",
              "AllowCopyImage",
              "SharedAccountId"
            ],
            members: {
              ImageId: {},
              AllowCopyImage: {
                type: "boolean"
              },
              SharedAccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S8: {
          type: "list",
          member: {}
        },
        Sf: {
          type: "structure",
          members: {
            AssociatedResourceId: {},
            AssociatedResourceType: {},
            Created: {
              type: "timestamp"
            },
            LastUpdatedTime: {
              type: "timestamp"
            },
            State: {},
            StateReason: {
              shape: "Sj"
            },
            WorkspaceId: {}
          }
        },
        Sj: {
          type: "structure",
          members: {
            ErrorCode: {},
            ErrorMessage: {}
          }
        },
        Sn: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ipRule: {},
              ruleDesc: {}
            }
          }
        },
        Sx: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S1g: {
          type: "structure",
          required: [
            "PrimaryWorkspaceId",
            "DirectoryId"
          ],
          members: {
            PrimaryWorkspaceId: {},
            VolumeEncryptionKey: {},
            DirectoryId: {},
            Tags: {
              shape: "Sx"
            },
            DataReplication: {}
          }
        },
        S1z: {
          type: "structure",
          members: {
            Name: {}
          }
        },
        S21: {
          type: "structure",
          members: {
            Capacity: {}
          }
        },
        S22: {
          type: "structure",
          members: {
            Capacity: {}
          }
        },
        S24: {
          type: "structure",
          members: {
            BundleId: {},
            Name: {},
            Owner: {},
            Description: {},
            ImageId: {},
            RootStorage: {
              shape: "S22"
            },
            UserStorage: {
              shape: "S21"
            },
            ComputeType: {
              shape: "S1z"
            },
            LastUpdatedTime: {
              type: "timestamp"
            },
            CreationTime: {
              type: "timestamp"
            },
            State: {},
            BundleType: {}
          }
        },
        S2b: {
          type: "structure",
          members: {
            Type: {}
          }
        },
        S2i: {
          type: "structure",
          required: [
            "DirectoryId",
            "UserName",
            "BundleId"
          ],
          members: {
            DirectoryId: {},
            UserName: {},
            BundleId: {},
            VolumeEncryptionKey: {},
            UserVolumeEncryptionEnabled: {
              type: "boolean"
            },
            RootVolumeEncryptionEnabled: {
              type: "boolean"
            },
            WorkspaceProperties: {
              shape: "S2k"
            },
            Tags: {
              shape: "Sx"
            }
          }
        },
        S2k: {
          type: "structure",
          members: {
            RunningMode: {},
            RunningModeAutoStopTimeoutInMinutes: {
              type: "integer"
            },
            RootVolumeSizeGib: {
              type: "integer"
            },
            UserVolumeSizeGib: {
              type: "integer"
            },
            ComputeTypeName: {},
            Protocols: {
              type: "list",
              member: {}
            },
            OperatingSystemName: {}
          }
        },
        S2w: {
          type: "list",
          member: {
            type: "structure",
            members: {
              WorkspaceId: {},
              DirectoryId: {},
              UserName: {},
              IpAddress: {},
              State: {},
              BundleId: {},
              SubnetId: {},
              ErrorMessage: {},
              ErrorCode: {},
              ComputerName: {},
              VolumeEncryptionKey: {},
              UserVolumeEncryptionEnabled: {
                type: "boolean"
              },
              RootVolumeEncryptionEnabled: {
                type: "boolean"
              },
              WorkspaceProperties: {
                shape: "S2k"
              },
              ModificationStates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Resource: {},
                    State: {}
                  }
                }
              },
              RelatedWorkspaces: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WorkspaceId: {},
                    Region: {},
                    State: {},
                    Type: {}
                  }
                }
              },
              DataReplicationSettings: {
                type: "structure",
                members: {
                  DataReplication: {},
                  RecoverySnapshotTime: {
                    type: "timestamp"
                  }
                }
              },
              StandbyWorkspacesProperties: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StandbyWorkspaceId: {},
                    DataReplication: {},
                    RecoverySnapshotTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        S3v: {
          type: "list",
          member: {
            shape: "Sf"
          }
        },
        S4h: {
          type: "list",
          member: {}
        },
        S4j: {
          type: "list",
          member: {}
        },
        S4x: {
          type: "structure",
          members: {
            LogoUrl: {},
            SupportEmail: {},
            SupportLink: {},
            ForgotPasswordLink: {},
            LoginMessage: {
              shape: "S50"
            }
          }
        },
        S50: {
          type: "map",
          key: {},
          value: {}
        },
        S53: {
          type: "structure",
          members: {
            LogoUrl: {},
            Logo2xUrl: {},
            Logo3xUrl: {},
            SupportEmail: {},
            SupportLink: {},
            ForgotPasswordLink: {},
            LoginMessage: {
              shape: "S50"
            }
          }
        },
        S59: {
          type: "structure",
          members: {
            ReconnectEnabled: {},
            LogUploadEnabled: {}
          }
        },
        S5j: {
          type: "structure",
          required: [
            "SharedAccountId",
            "AllowAssociation"
          ],
          members: {
            SharedAccountId: {},
            AllowAssociation: {
              type: "boolean"
            }
          }
        },
        S6k: {
          type: "list",
          member: {}
        },
        S6s: {
          type: "structure",
          members: {
            DeviceTypeWindows: {},
            DeviceTypeOsx: {},
            DeviceTypeWeb: {},
            DeviceTypeIos: {},
            DeviceTypeAndroid: {},
            DeviceTypeChromeOs: {},
            DeviceTypeZeroClient: {},
            DeviceTypeLinux: {}
          }
        },
        S6v: {
          type: "structure",
          members: {
            RestartWorkspace: {},
            IncreaseVolumeSize: {},
            ChangeComputeType: {},
            SwitchRunningMode: {},
            RebuildWorkspace: {}
          }
        },
        S6w: {
          type: "structure",
          members: {
            Status: {},
            UserAccessUrl: {},
            RelayStateParameterName: {}
          }
        },
        S6z: {
          type: "structure",
          members: {
            Status: {},
            CertificateAuthorityArn: {}
          }
        },
        S7k: {
          type: "list",
          member: {
            type: "structure",
            members: {
              SnapshotTime: {
                type: "timestamp"
              }
            }
          }
        },
        S7n: {
          type: "list",
          member: {}
        },
        S81: {
          type: "structure",
          members: {
            Logo: {
              type: "blob"
            },
            SupportEmail: {},
            SupportLink: {},
            ForgotPasswordLink: {},
            LoginMessage: {
              shape: "S50"
            }
          }
        },
        S9f: {
          type: "structure",
          members: {
            WorkspaceId: {},
            ErrorCode: {},
            ErrorMessage: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/workspaces-2015-04-08.paginators.json
var require_workspaces_2015_04_08_paginators = __commonJS({
  "node_modules/aws-sdk/apis/workspaces-2015-04-08.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeApplicationAssociations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        DescribeApplications: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        DescribeWorkspaceBundles: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Bundles"
        },
        DescribeWorkspaceDirectories: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Directories"
        },
        DescribeWorkspaces: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "Workspaces"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/workspaces.js
var require_workspaces = __commonJS({
  "node_modules/aws-sdk/clients/workspaces.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["workspaces"] = {};
    AWS2.WorkSpaces = Service.defineService("workspaces", ["2015-04-08"]);
    Object.defineProperty(apiLoader.services["workspaces"], "2015-04-08", {
      get: function get() {
        var model = require_workspaces_2015_04_08_min();
        model.paginators = require_workspaces_2015_04_08_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.WorkSpaces;
  }
});

// node_modules/aws-sdk/apis/codestar-2017-04-19.min.json
var require_codestar_2017_04_19_min = __commonJS({
  "node_modules/aws-sdk/apis/codestar-2017-04-19.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-04-19",
        endpointPrefix: "codestar",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "CodeStar",
        serviceFullName: "AWS CodeStar",
        serviceId: "CodeStar",
        signatureVersion: "v4",
        targetPrefix: "CodeStar_20170419",
        uid: "codestar-2017-04-19"
      },
      operations: {
        AssociateTeamMember: {
          input: {
            type: "structure",
            required: [
              "projectId",
              "userArn",
              "projectRole"
            ],
            members: {
              projectId: {},
              clientRequestToken: {},
              userArn: {},
              projectRole: {},
              remoteAccessAllowed: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              clientRequestToken: {}
            }
          }
        },
        CreateProject: {
          input: {
            type: "structure",
            required: [
              "name",
              "id"
            ],
            members: {
              name: {
                shape: "S9"
              },
              id: {},
              description: {
                shape: "Sa"
              },
              clientRequestToken: {},
              sourceCode: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "source",
                    "destination"
                  ],
                  members: {
                    source: {
                      type: "structure",
                      required: [
                        "s3"
                      ],
                      members: {
                        s3: {
                          shape: "Se"
                        }
                      }
                    },
                    destination: {
                      type: "structure",
                      members: {
                        codeCommit: {
                          type: "structure",
                          required: [
                            "name"
                          ],
                          members: {
                            name: {}
                          }
                        },
                        gitHub: {
                          type: "structure",
                          required: [
                            "name",
                            "type",
                            "owner",
                            "privateRepository",
                            "issuesEnabled",
                            "token"
                          ],
                          members: {
                            name: {},
                            description: {},
                            type: {},
                            owner: {},
                            privateRepository: {
                              type: "boolean"
                            },
                            issuesEnabled: {
                              type: "boolean"
                            },
                            token: {
                              type: "string",
                              sensitive: true
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              toolchain: {
                type: "structure",
                required: [
                  "source"
                ],
                members: {
                  source: {
                    type: "structure",
                    required: [
                      "s3"
                    ],
                    members: {
                      s3: {
                        shape: "Se"
                      }
                    }
                  },
                  roleArn: {},
                  stackParameters: {
                    type: "map",
                    key: {},
                    value: {
                      type: "string",
                      sensitive: true
                    }
                  }
                }
              },
              tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "arn"
            ],
            members: {
              id: {},
              arn: {},
              clientRequestToken: {},
              projectTemplateId: {}
            }
          }
        },
        CreateUserProfile: {
          input: {
            type: "structure",
            required: [
              "userArn",
              "displayName",
              "emailAddress"
            ],
            members: {
              userArn: {},
              displayName: {
                shape: "S14"
              },
              emailAddress: {
                shape: "S15"
              },
              sshPublicKey: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "userArn"
            ],
            members: {
              userArn: {},
              displayName: {
                shape: "S14"
              },
              emailAddress: {
                shape: "S15"
              },
              sshPublicKey: {},
              createdTimestamp: {
                type: "timestamp"
              },
              lastModifiedTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        DeleteProject: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {},
              clientRequestToken: {},
              deleteStack: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              stackId: {},
              projectArn: {}
            }
          }
        },
        DeleteUserProfile: {
          input: {
            type: "structure",
            required: [
              "userArn"
            ],
            members: {
              userArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "userArn"
            ],
            members: {
              userArn: {}
            }
          }
        },
        DescribeProject: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              name: {
                shape: "S9"
              },
              id: {},
              arn: {},
              description: {
                shape: "Sa"
              },
              clientRequestToken: {},
              createdTimeStamp: {
                type: "timestamp"
              },
              stackId: {},
              projectTemplateId: {},
              status: {
                type: "structure",
                required: [
                  "state"
                ],
                members: {
                  state: {},
                  reason: {}
                }
              }
            }
          }
        },
        DescribeUserProfile: {
          input: {
            type: "structure",
            required: [
              "userArn"
            ],
            members: {
              userArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "userArn",
              "createdTimestamp",
              "lastModifiedTimestamp"
            ],
            members: {
              userArn: {},
              displayName: {
                shape: "S14"
              },
              emailAddress: {
                shape: "S15"
              },
              sshPublicKey: {},
              createdTimestamp: {
                type: "timestamp"
              },
              lastModifiedTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        DisassociateTeamMember: {
          input: {
            type: "structure",
            required: [
              "projectId",
              "userArn"
            ],
            members: {
              projectId: {},
              userArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ListProjects: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "projects"
            ],
            members: {
              projects: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    projectId: {},
                    projectArn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListResources: {
          input: {
            type: "structure",
            required: [
              "projectId"
            ],
            members: {
              projectId: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resources: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id"
                  ],
                  members: {
                    id: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForProject: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sx"
              },
              nextToken: {}
            }
          }
        },
        ListTeamMembers: {
          input: {
            type: "structure",
            required: [
              "projectId"
            ],
            members: {
              projectId: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "teamMembers"
            ],
            members: {
              teamMembers: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "userArn",
                    "projectRole"
                  ],
                  members: {
                    userArn: {},
                    projectRole: {},
                    remoteAccessAllowed: {
                      type: "boolean"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListUserProfiles: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "userProfiles"
            ],
            members: {
              userProfiles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    userArn: {},
                    displayName: {
                      shape: "S14"
                    },
                    emailAddress: {
                      shape: "S15"
                    },
                    sshPublicKey: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        TagProject: {
          input: {
            type: "structure",
            required: [
              "id",
              "tags"
            ],
            members: {
              id: {},
              tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sx"
              }
            }
          }
        },
        UntagProject: {
          input: {
            type: "structure",
            required: [
              "id",
              "tags"
            ],
            members: {
              id: {},
              tags: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateProject: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {},
              name: {
                shape: "S9"
              },
              description: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateTeamMember: {
          input: {
            type: "structure",
            required: [
              "projectId",
              "userArn"
            ],
            members: {
              projectId: {},
              userArn: {},
              projectRole: {},
              remoteAccessAllowed: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              userArn: {},
              projectRole: {},
              remoteAccessAllowed: {
                type: "boolean"
              }
            }
          }
        },
        UpdateUserProfile: {
          input: {
            type: "structure",
            required: [
              "userArn"
            ],
            members: {
              userArn: {},
              displayName: {
                shape: "S14"
              },
              emailAddress: {
                shape: "S15"
              },
              sshPublicKey: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "userArn"
            ],
            members: {
              userArn: {},
              displayName: {
                shape: "S14"
              },
              emailAddress: {
                shape: "S15"
              },
              sshPublicKey: {},
              createdTimestamp: {
                type: "timestamp"
              },
              lastModifiedTimestamp: {
                type: "timestamp"
              }
            }
          }
        }
      },
      shapes: {
        S9: {
          type: "string",
          sensitive: true
        },
        Sa: {
          type: "string",
          sensitive: true
        },
        Se: {
          type: "structure",
          members: {
            bucketName: {},
            bucketKey: {}
          }
        },
        Sx: {
          type: "map",
          key: {},
          value: {}
        },
        S14: {
          type: "string",
          sensitive: true
        },
        S15: {
          type: "string",
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/codestar-2017-04-19.paginators.json
var require_codestar_2017_04_19_paginators = __commonJS({
  "node_modules/aws-sdk/apis/codestar-2017-04-19.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/codestar.js
var require_codestar = __commonJS({
  "node_modules/aws-sdk/clients/codestar.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["codestar"] = {};
    AWS2.CodeStar = Service.defineService("codestar", ["2017-04-19"]);
    Object.defineProperty(apiLoader.services["codestar"], "2017-04-19", {
      get: function get() {
        var model = require_codestar_2017_04_19_min();
        model.paginators = require_codestar_2017_04_19_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CodeStar;
  }
});

// node_modules/aws-sdk/apis/lex-models-2017-04-19.min.json
var require_lex_models_2017_04_19_min = __commonJS({
  "node_modules/aws-sdk/apis/lex-models-2017-04-19.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-04-19",
        endpointPrefix: "models.lex",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Lex Model Building Service",
        serviceId: "Lex Model Building Service",
        signatureVersion: "v4",
        signingName: "lex",
        uid: "lex-models-2017-04-19"
      },
      operations: {
        CreateBotVersion: {
          http: {
            requestUri: "/bots/{name}/versions",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              checksum: {}
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              description: {},
              intents: {
                shape: "S6"
              },
              clarificationPrompt: {
                shape: "Sa"
              },
              abortStatement: {
                shape: "Si"
              },
              status: {},
              failureReason: {},
              lastUpdatedDate: {
                type: "timestamp"
              },
              createdDate: {
                type: "timestamp"
              },
              idleSessionTTLInSeconds: {
                type: "integer"
              },
              voiceId: {},
              checksum: {},
              version: {},
              locale: {},
              childDirected: {
                type: "boolean"
              },
              enableModelImprovements: {
                type: "boolean"
              },
              detectSentiment: {
                type: "boolean"
              }
            }
          }
        },
        CreateIntentVersion: {
          http: {
            requestUri: "/intents/{name}/versions",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              checksum: {}
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              description: {},
              slots: {
                shape: "Sq"
              },
              sampleUtterances: {
                shape: "S13"
              },
              confirmationPrompt: {
                shape: "Sa"
              },
              rejectionStatement: {
                shape: "Si"
              },
              followUpPrompt: {
                shape: "S14"
              },
              conclusionStatement: {
                shape: "Si"
              },
              dialogCodeHook: {
                shape: "S15"
              },
              fulfillmentActivity: {
                shape: "S18"
              },
              parentIntentSignature: {},
              lastUpdatedDate: {
                type: "timestamp"
              },
              createdDate: {
                type: "timestamp"
              },
              version: {},
              checksum: {},
              kendraConfiguration: {
                shape: "S1b"
              },
              inputContexts: {
                shape: "S1f"
              },
              outputContexts: {
                shape: "S1i"
              }
            }
          }
        },
        CreateSlotTypeVersion: {
          http: {
            requestUri: "/slottypes/{name}/versions",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              checksum: {}
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              description: {},
              enumerationValues: {
                shape: "S1q"
              },
              lastUpdatedDate: {
                type: "timestamp"
              },
              createdDate: {
                type: "timestamp"
              },
              version: {},
              checksum: {},
              valueSelectionStrategy: {},
              parentSlotTypeSignature: {},
              slotTypeConfigurations: {
                shape: "S1v"
              }
            }
          }
        },
        DeleteBot: {
          http: {
            method: "DELETE",
            requestUri: "/bots/{name}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              }
            }
          }
        },
        DeleteBotAlias: {
          http: {
            method: "DELETE",
            requestUri: "/bots/{botName}/aliases/{name}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "name",
              "botName"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              botName: {
                location: "uri",
                locationName: "botName"
              }
            }
          }
        },
        DeleteBotChannelAssociation: {
          http: {
            method: "DELETE",
            requestUri: "/bots/{botName}/aliases/{aliasName}/channels/{name}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "name",
              "botName",
              "botAlias"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              botName: {
                location: "uri",
                locationName: "botName"
              },
              botAlias: {
                location: "uri",
                locationName: "aliasName"
              }
            }
          }
        },
        DeleteBotVersion: {
          http: {
            method: "DELETE",
            requestUri: "/bots/{name}/versions/{version}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "name",
              "version"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              version: {
                location: "uri",
                locationName: "version"
              }
            }
          }
        },
        DeleteIntent: {
          http: {
            method: "DELETE",
            requestUri: "/intents/{name}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              }
            }
          }
        },
        DeleteIntentVersion: {
          http: {
            method: "DELETE",
            requestUri: "/intents/{name}/versions/{version}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "name",
              "version"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              version: {
                location: "uri",
                locationName: "version"
              }
            }
          }
        },
        DeleteSlotType: {
          http: {
            method: "DELETE",
            requestUri: "/slottypes/{name}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              }
            }
          }
        },
        DeleteSlotTypeVersion: {
          http: {
            method: "DELETE",
            requestUri: "/slottypes/{name}/version/{version}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "name",
              "version"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              version: {
                location: "uri",
                locationName: "version"
              }
            }
          }
        },
        DeleteUtterances: {
          http: {
            method: "DELETE",
            requestUri: "/bots/{botName}/utterances/{userId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "botName",
              "userId"
            ],
            members: {
              botName: {
                location: "uri",
                locationName: "botName"
              },
              userId: {
                location: "uri",
                locationName: "userId"
              }
            }
          }
        },
        GetBot: {
          http: {
            method: "GET",
            requestUri: "/bots/{name}/versions/{versionoralias}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "versionOrAlias"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              versionOrAlias: {
                location: "uri",
                locationName: "versionoralias"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              description: {},
              intents: {
                shape: "S6"
              },
              enableModelImprovements: {
                type: "boolean"
              },
              nluIntentConfidenceThreshold: {
                type: "double"
              },
              clarificationPrompt: {
                shape: "Sa"
              },
              abortStatement: {
                shape: "Si"
              },
              status: {},
              failureReason: {},
              lastUpdatedDate: {
                type: "timestamp"
              },
              createdDate: {
                type: "timestamp"
              },
              idleSessionTTLInSeconds: {
                type: "integer"
              },
              voiceId: {},
              checksum: {},
              version: {},
              locale: {},
              childDirected: {
                type: "boolean"
              },
              detectSentiment: {
                type: "boolean"
              }
            }
          }
        },
        GetBotAlias: {
          http: {
            method: "GET",
            requestUri: "/bots/{botName}/aliases/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "botName"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              botName: {
                location: "uri",
                locationName: "botName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              description: {},
              botVersion: {},
              botName: {},
              lastUpdatedDate: {
                type: "timestamp"
              },
              createdDate: {
                type: "timestamp"
              },
              checksum: {},
              conversationLogs: {
                shape: "S2h"
              }
            }
          }
        },
        GetBotAliases: {
          http: {
            method: "GET",
            requestUri: "/bots/{botName}/aliases/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botName"
            ],
            members: {
              botName: {
                location: "uri",
                locationName: "botName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nameContains: {
                location: "querystring",
                locationName: "nameContains"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BotAliases: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    description: {},
                    botVersion: {},
                    botName: {},
                    lastUpdatedDate: {
                      type: "timestamp"
                    },
                    createdDate: {
                      type: "timestamp"
                    },
                    checksum: {},
                    conversationLogs: {
                      shape: "S2h"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetBotChannelAssociation: {
          http: {
            method: "GET",
            requestUri: "/bots/{botName}/aliases/{aliasName}/channels/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "botName",
              "botAlias"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              botName: {
                location: "uri",
                locationName: "botName"
              },
              botAlias: {
                location: "uri",
                locationName: "aliasName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              description: {},
              botAlias: {},
              botName: {},
              createdDate: {
                type: "timestamp"
              },
              type: {},
              botConfiguration: {
                shape: "S2z"
              },
              status: {},
              failureReason: {}
            }
          }
        },
        GetBotChannelAssociations: {
          http: {
            method: "GET",
            requestUri: "/bots/{botName}/aliases/{aliasName}/channels/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botName",
              "botAlias"
            ],
            members: {
              botName: {
                location: "uri",
                locationName: "botName"
              },
              botAlias: {
                location: "uri",
                locationName: "aliasName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nameContains: {
                location: "querystring",
                locationName: "nameContains"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botChannelAssociations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    description: {},
                    botAlias: {},
                    botName: {},
                    createdDate: {
                      type: "timestamp"
                    },
                    type: {},
                    botConfiguration: {
                      shape: "S2z"
                    },
                    status: {},
                    failureReason: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetBotVersions: {
          http: {
            method: "GET",
            requestUri: "/bots/{name}/versions/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              bots: {
                shape: "S38"
              },
              nextToken: {}
            }
          }
        },
        GetBots: {
          http: {
            method: "GET",
            requestUri: "/bots/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nameContains: {
                location: "querystring",
                locationName: "nameContains"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              bots: {
                shape: "S38"
              },
              nextToken: {}
            }
          }
        },
        GetBuiltinIntent: {
          http: {
            method: "GET",
            requestUri: "/builtins/intents/{signature}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "signature"
            ],
            members: {
              signature: {
                location: "uri",
                locationName: "signature"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              signature: {},
              supportedLocales: {
                shape: "S3e"
              },
              slots: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {}
                  }
                }
              }
            }
          }
        },
        GetBuiltinIntents: {
          http: {
            method: "GET",
            requestUri: "/builtins/intents/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              locale: {
                location: "querystring",
                locationName: "locale"
              },
              signatureContains: {
                location: "querystring",
                locationName: "signatureContains"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              intents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    signature: {},
                    supportedLocales: {
                      shape: "S3e"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetBuiltinSlotTypes: {
          http: {
            method: "GET",
            requestUri: "/builtins/slottypes/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              locale: {
                location: "querystring",
                locationName: "locale"
              },
              signatureContains: {
                location: "querystring",
                locationName: "signatureContains"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              slotTypes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    signature: {},
                    supportedLocales: {
                      shape: "S3e"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetExport: {
          http: {
            method: "GET",
            requestUri: "/exports/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "version",
              "resourceType",
              "exportType"
            ],
            members: {
              name: {
                location: "querystring",
                locationName: "name"
              },
              version: {
                location: "querystring",
                locationName: "version"
              },
              resourceType: {
                location: "querystring",
                locationName: "resourceType"
              },
              exportType: {
                location: "querystring",
                locationName: "exportType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              version: {},
              resourceType: {},
              exportType: {},
              exportStatus: {},
              failureReason: {},
              url: {}
            }
          }
        },
        GetImport: {
          http: {
            method: "GET",
            requestUri: "/imports/{importId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "importId"
            ],
            members: {
              importId: {
                location: "uri",
                locationName: "importId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              resourceType: {},
              mergeStrategy: {},
              importId: {},
              importStatus: {},
              failureReason: {
                type: "list",
                member: {}
              },
              createdDate: {
                type: "timestamp"
              }
            }
          }
        },
        GetIntent: {
          http: {
            method: "GET",
            requestUri: "/intents/{name}/versions/{version}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "version"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              version: {
                location: "uri",
                locationName: "version"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              description: {},
              slots: {
                shape: "Sq"
              },
              sampleUtterances: {
                shape: "S13"
              },
              confirmationPrompt: {
                shape: "Sa"
              },
              rejectionStatement: {
                shape: "Si"
              },
              followUpPrompt: {
                shape: "S14"
              },
              conclusionStatement: {
                shape: "Si"
              },
              dialogCodeHook: {
                shape: "S15"
              },
              fulfillmentActivity: {
                shape: "S18"
              },
              parentIntentSignature: {},
              lastUpdatedDate: {
                type: "timestamp"
              },
              createdDate: {
                type: "timestamp"
              },
              version: {},
              checksum: {},
              kendraConfiguration: {
                shape: "S1b"
              },
              inputContexts: {
                shape: "S1f"
              },
              outputContexts: {
                shape: "S1i"
              }
            }
          }
        },
        GetIntentVersions: {
          http: {
            method: "GET",
            requestUri: "/intents/{name}/versions/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              intents: {
                shape: "S45"
              },
              nextToken: {}
            }
          }
        },
        GetIntents: {
          http: {
            method: "GET",
            requestUri: "/intents/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nameContains: {
                location: "querystring",
                locationName: "nameContains"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              intents: {
                shape: "S45"
              },
              nextToken: {}
            }
          }
        },
        GetMigration: {
          http: {
            method: "GET",
            requestUri: "/migrations/{migrationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "migrationId"
            ],
            members: {
              migrationId: {
                location: "uri",
                locationName: "migrationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              migrationId: {},
              v1BotName: {},
              v1BotVersion: {},
              v1BotLocale: {},
              v2BotId: {},
              v2BotRole: {},
              migrationStatus: {},
              migrationStrategy: {},
              migrationTimestamp: {
                type: "timestamp"
              },
              alerts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    type: {},
                    message: {},
                    details: {
                      type: "list",
                      member: {}
                    },
                    referenceURLs: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              }
            }
          }
        },
        GetMigrations: {
          http: {
            method: "GET",
            requestUri: "/migrations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              sortByAttribute: {
                location: "querystring",
                locationName: "sortByAttribute"
              },
              sortByOrder: {
                location: "querystring",
                locationName: "sortByOrder"
              },
              v1BotNameContains: {
                location: "querystring",
                locationName: "v1BotNameContains"
              },
              migrationStatusEquals: {
                location: "querystring",
                locationName: "migrationStatusEquals"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              migrationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    migrationId: {},
                    v1BotName: {},
                    v1BotVersion: {},
                    v1BotLocale: {},
                    v2BotId: {},
                    v2BotRole: {},
                    migrationStatus: {},
                    migrationStrategy: {},
                    migrationTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetSlotType: {
          http: {
            method: "GET",
            requestUri: "/slottypes/{name}/versions/{version}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "version"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              version: {
                location: "uri",
                locationName: "version"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              description: {},
              enumerationValues: {
                shape: "S1q"
              },
              lastUpdatedDate: {
                type: "timestamp"
              },
              createdDate: {
                type: "timestamp"
              },
              version: {},
              checksum: {},
              valueSelectionStrategy: {},
              parentSlotTypeSignature: {},
              slotTypeConfigurations: {
                shape: "S1v"
              }
            }
          }
        },
        GetSlotTypeVersions: {
          http: {
            method: "GET",
            requestUri: "/slottypes/{name}/versions/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              slotTypes: {
                shape: "S4x"
              },
              nextToken: {}
            }
          }
        },
        GetSlotTypes: {
          http: {
            method: "GET",
            requestUri: "/slottypes/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nameContains: {
                location: "querystring",
                locationName: "nameContains"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              slotTypes: {
                shape: "S4x"
              },
              nextToken: {}
            }
          }
        },
        GetUtterancesView: {
          http: {
            method: "GET",
            requestUri: "/bots/{botname}/utterances?view=aggregation",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botName",
              "botVersions",
              "statusType"
            ],
            members: {
              botName: {
                location: "uri",
                locationName: "botname"
              },
              botVersions: {
                location: "querystring",
                locationName: "bot_versions",
                type: "list",
                member: {}
              },
              statusType: {
                location: "querystring",
                locationName: "status_type"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botName: {},
              utterances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    botVersion: {},
                    utterances: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          utteranceString: {},
                          count: {
                            type: "integer"
                          },
                          distinctUsers: {
                            type: "integer"
                          },
                          firstUtteredDate: {
                            type: "timestamp"
                          },
                          lastUtteredDate: {
                            type: "timestamp"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S5e"
              }
            }
          }
        },
        PutBot: {
          http: {
            method: "PUT",
            requestUri: "/bots/{name}/versions/$LATEST",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "locale",
              "childDirected"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              description: {},
              intents: {
                shape: "S6"
              },
              enableModelImprovements: {
                type: "boolean"
              },
              nluIntentConfidenceThreshold: {
                type: "double"
              },
              clarificationPrompt: {
                shape: "Sa"
              },
              abortStatement: {
                shape: "Si"
              },
              idleSessionTTLInSeconds: {
                type: "integer"
              },
              voiceId: {},
              checksum: {},
              processBehavior: {},
              locale: {},
              childDirected: {
                type: "boolean"
              },
              detectSentiment: {
                type: "boolean"
              },
              createVersion: {
                type: "boolean"
              },
              tags: {
                shape: "S5e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              description: {},
              intents: {
                shape: "S6"
              },
              enableModelImprovements: {
                type: "boolean"
              },
              nluIntentConfidenceThreshold: {
                type: "double"
              },
              clarificationPrompt: {
                shape: "Sa"
              },
              abortStatement: {
                shape: "Si"
              },
              status: {},
              failureReason: {},
              lastUpdatedDate: {
                type: "timestamp"
              },
              createdDate: {
                type: "timestamp"
              },
              idleSessionTTLInSeconds: {
                type: "integer"
              },
              voiceId: {},
              checksum: {},
              version: {},
              locale: {},
              childDirected: {
                type: "boolean"
              },
              createVersion: {
                type: "boolean"
              },
              detectSentiment: {
                type: "boolean"
              },
              tags: {
                shape: "S5e"
              }
            }
          }
        },
        PutBotAlias: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botName}/aliases/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "botVersion",
              "botName"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              description: {},
              botVersion: {},
              botName: {
                location: "uri",
                locationName: "botName"
              },
              checksum: {},
              conversationLogs: {
                type: "structure",
                required: [
                  "logSettings",
                  "iamRoleArn"
                ],
                members: {
                  logSettings: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "logType",
                        "destination",
                        "resourceArn"
                      ],
                      members: {
                        logType: {},
                        destination: {},
                        kmsKeyArn: {},
                        resourceArn: {}
                      }
                    }
                  },
                  iamRoleArn: {}
                }
              },
              tags: {
                shape: "S5e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              description: {},
              botVersion: {},
              botName: {},
              lastUpdatedDate: {
                type: "timestamp"
              },
              createdDate: {
                type: "timestamp"
              },
              checksum: {},
              conversationLogs: {
                shape: "S2h"
              },
              tags: {
                shape: "S5e"
              }
            }
          }
        },
        PutIntent: {
          http: {
            method: "PUT",
            requestUri: "/intents/{name}/versions/$LATEST",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              description: {},
              slots: {
                shape: "Sq"
              },
              sampleUtterances: {
                shape: "S13"
              },
              confirmationPrompt: {
                shape: "Sa"
              },
              rejectionStatement: {
                shape: "Si"
              },
              followUpPrompt: {
                shape: "S14"
              },
              conclusionStatement: {
                shape: "Si"
              },
              dialogCodeHook: {
                shape: "S15"
              },
              fulfillmentActivity: {
                shape: "S18"
              },
              parentIntentSignature: {},
              checksum: {},
              createVersion: {
                type: "boolean"
              },
              kendraConfiguration: {
                shape: "S1b"
              },
              inputContexts: {
                shape: "S1f"
              },
              outputContexts: {
                shape: "S1i"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              description: {},
              slots: {
                shape: "Sq"
              },
              sampleUtterances: {
                shape: "S13"
              },
              confirmationPrompt: {
                shape: "Sa"
              },
              rejectionStatement: {
                shape: "Si"
              },
              followUpPrompt: {
                shape: "S14"
              },
              conclusionStatement: {
                shape: "Si"
              },
              dialogCodeHook: {
                shape: "S15"
              },
              fulfillmentActivity: {
                shape: "S18"
              },
              parentIntentSignature: {},
              lastUpdatedDate: {
                type: "timestamp"
              },
              createdDate: {
                type: "timestamp"
              },
              version: {},
              checksum: {},
              createVersion: {
                type: "boolean"
              },
              kendraConfiguration: {
                shape: "S1b"
              },
              inputContexts: {
                shape: "S1f"
              },
              outputContexts: {
                shape: "S1i"
              }
            }
          }
        },
        PutSlotType: {
          http: {
            method: "PUT",
            requestUri: "/slottypes/{name}/versions/$LATEST",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              description: {},
              enumerationValues: {
                shape: "S1q"
              },
              checksum: {},
              valueSelectionStrategy: {},
              createVersion: {
                type: "boolean"
              },
              parentSlotTypeSignature: {},
              slotTypeConfigurations: {
                shape: "S1v"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              description: {},
              enumerationValues: {
                shape: "S1q"
              },
              lastUpdatedDate: {
                type: "timestamp"
              },
              createdDate: {
                type: "timestamp"
              },
              version: {},
              checksum: {},
              valueSelectionStrategy: {},
              createVersion: {
                type: "boolean"
              },
              parentSlotTypeSignature: {},
              slotTypeConfigurations: {
                shape: "S1v"
              }
            }
          }
        },
        StartImport: {
          http: {
            requestUri: "/imports/",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "payload",
              "resourceType",
              "mergeStrategy"
            ],
            members: {
              payload: {
                type: "blob"
              },
              resourceType: {},
              mergeStrategy: {},
              tags: {
                shape: "S5e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              resourceType: {},
              mergeStrategy: {},
              importId: {},
              importStatus: {},
              tags: {
                shape: "S5e"
              },
              createdDate: {
                type: "timestamp"
              }
            }
          }
        },
        StartMigration: {
          http: {
            requestUri: "/migrations",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "v1BotName",
              "v1BotVersion",
              "v2BotName",
              "v2BotRole",
              "migrationStrategy"
            ],
            members: {
              v1BotName: {},
              v1BotVersion: {},
              v2BotName: {},
              v2BotRole: {},
              migrationStrategy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              v1BotName: {},
              v1BotVersion: {},
              v1BotLocale: {},
              v2BotId: {},
              v2BotRole: {},
              migrationId: {},
              migrationStrategy: {},
              migrationTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S5e"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S6: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "intentName",
              "intentVersion"
            ],
            members: {
              intentName: {},
              intentVersion: {}
            }
          }
        },
        Sa: {
          type: "structure",
          required: [
            "messages",
            "maxAttempts"
          ],
          members: {
            messages: {
              shape: "Sb"
            },
            maxAttempts: {
              type: "integer"
            },
            responseCard: {}
          }
        },
        Sb: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "contentType",
              "content"
            ],
            members: {
              contentType: {},
              content: {},
              groupNumber: {
                type: "integer"
              }
            }
          }
        },
        Si: {
          type: "structure",
          required: [
            "messages"
          ],
          members: {
            messages: {
              shape: "Sb"
            },
            responseCard: {}
          }
        },
        Sq: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "slotConstraint"
            ],
            members: {
              name: {},
              description: {},
              slotConstraint: {},
              slotType: {},
              slotTypeVersion: {},
              valueElicitationPrompt: {
                shape: "Sa"
              },
              priority: {
                type: "integer"
              },
              sampleUtterances: {
                type: "list",
                member: {}
              },
              responseCard: {},
              obfuscationSetting: {},
              defaultValueSpec: {
                type: "structure",
                required: [
                  "defaultValueList"
                ],
                members: {
                  defaultValueList: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "defaultValue"
                      ],
                      members: {
                        defaultValue: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S13: {
          type: "list",
          member: {}
        },
        S14: {
          type: "structure",
          required: [
            "prompt",
            "rejectionStatement"
          ],
          members: {
            prompt: {
              shape: "Sa"
            },
            rejectionStatement: {
              shape: "Si"
            }
          }
        },
        S15: {
          type: "structure",
          required: [
            "uri",
            "messageVersion"
          ],
          members: {
            uri: {},
            messageVersion: {}
          }
        },
        S18: {
          type: "structure",
          required: [
            "type"
          ],
          members: {
            type: {},
            codeHook: {
              shape: "S15"
            }
          }
        },
        S1b: {
          type: "structure",
          required: [
            "kendraIndex",
            "role"
          ],
          members: {
            kendraIndex: {},
            queryFilterString: {},
            role: {}
          }
        },
        S1f: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          }
        },
        S1i: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "timeToLiveInSeconds",
              "turnsToLive"
            ],
            members: {
              name: {},
              timeToLiveInSeconds: {
                type: "integer"
              },
              turnsToLive: {
                type: "integer"
              }
            }
          }
        },
        S1q: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "value"
            ],
            members: {
              value: {},
              synonyms: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S1v: {
          type: "list",
          member: {
            type: "structure",
            members: {
              regexConfiguration: {
                type: "structure",
                required: [
                  "pattern"
                ],
                members: {
                  pattern: {}
                }
              }
            }
          }
        },
        S2h: {
          type: "structure",
          members: {
            logSettings: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  logType: {},
                  destination: {},
                  kmsKeyArn: {},
                  resourceArn: {},
                  resourcePrefix: {}
                }
              }
            },
            iamRoleArn: {}
          }
        },
        S2z: {
          type: "map",
          key: {},
          value: {},
          sensitive: true
        },
        S38: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              description: {},
              status: {},
              lastUpdatedDate: {
                type: "timestamp"
              },
              createdDate: {
                type: "timestamp"
              },
              version: {}
            }
          }
        },
        S3e: {
          type: "list",
          member: {}
        },
        S45: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              description: {},
              lastUpdatedDate: {
                type: "timestamp"
              },
              createdDate: {
                type: "timestamp"
              },
              version: {}
            }
          }
        },
        S4x: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              description: {},
              lastUpdatedDate: {
                type: "timestamp"
              },
              createdDate: {
                type: "timestamp"
              },
              version: {}
            }
          }
        },
        S5e: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/lex-models-2017-04-19.paginators.json
var require_lex_models_2017_04_19_paginators = __commonJS({
  "node_modules/aws-sdk/apis/lex-models-2017-04-19.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetBotAliases: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetBotChannelAssociations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetBotVersions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetBots: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetBuiltinIntents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetBuiltinSlotTypes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetIntentVersions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetIntents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetMigrations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetSlotTypeVersions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetSlotTypes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/lexmodelbuildingservice.js
var require_lexmodelbuildingservice = __commonJS({
  "node_modules/aws-sdk/clients/lexmodelbuildingservice.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["lexmodelbuildingservice"] = {};
    AWS2.LexModelBuildingService = Service.defineService("lexmodelbuildingservice", ["2017-04-19"]);
    Object.defineProperty(apiLoader.services["lexmodelbuildingservice"], "2017-04-19", {
      get: function get() {
        var model = require_lex_models_2017_04_19_min();
        model.paginators = require_lex_models_2017_04_19_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.LexModelBuildingService;
  }
});

// node_modules/aws-sdk/apis/entitlement.marketplace-2017-01-11.min.json
var require_entitlement_marketplace_2017_01_11_min = __commonJS({
  "node_modules/aws-sdk/apis/entitlement.marketplace-2017-01-11.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-01-11",
        endpointPrefix: "entitlement.marketplace",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Marketplace Entitlement Service",
        serviceId: "Marketplace Entitlement Service",
        signatureVersion: "v4",
        signingName: "aws-marketplace",
        targetPrefix: "AWSMPEntitlementService",
        uid: "entitlement.marketplace-2017-01-11"
      },
      operations: {
        GetEntitlements: {
          input: {
            type: "structure",
            required: [
              "ProductCode"
            ],
            members: {
              ProductCode: {},
              Filter: {
                type: "map",
                key: {},
                value: {
                  type: "list",
                  member: {}
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Entitlements: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ProductCode: {},
                    Dimension: {},
                    CustomerIdentifier: {},
                    Value: {
                      type: "structure",
                      members: {
                        IntegerValue: {
                          type: "integer"
                        },
                        DoubleValue: {
                          type: "double"
                        },
                        BooleanValue: {
                          type: "boolean"
                        },
                        StringValue: {}
                      }
                    },
                    ExpirationDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/apis/entitlement.marketplace-2017-01-11.paginators.json
var require_entitlement_marketplace_2017_01_11_paginators = __commonJS({
  "node_modules/aws-sdk/apis/entitlement.marketplace-2017-01-11.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetEntitlements: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/marketplaceentitlementservice.js
var require_marketplaceentitlementservice = __commonJS({
  "node_modules/aws-sdk/clients/marketplaceentitlementservice.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["marketplaceentitlementservice"] = {};
    AWS2.MarketplaceEntitlementService = Service.defineService("marketplaceentitlementservice", ["2017-01-11"]);
    Object.defineProperty(apiLoader.services["marketplaceentitlementservice"], "2017-01-11", {
      get: function get() {
        var model = require_entitlement_marketplace_2017_01_11_min();
        model.paginators = require_entitlement_marketplace_2017_01_11_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.MarketplaceEntitlementService;
  }
});

// node_modules/aws-sdk/apis/athena-2017-05-18.min.json
var require_athena_2017_05_18_min = __commonJS({
  "node_modules/aws-sdk/apis/athena-2017-05-18.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-05-18",
        endpointPrefix: "athena",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Athena",
        serviceId: "Athena",
        signatureVersion: "v4",
        targetPrefix: "AmazonAthena",
        uid: "athena-2017-05-18"
      },
      operations: {
        BatchGetNamedQuery: {
          input: {
            type: "structure",
            required: [
              "NamedQueryIds"
            ],
            members: {
              NamedQueryIds: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NamedQueries: {
                type: "list",
                member: {
                  shape: "S6"
                }
              },
              UnprocessedNamedQueryIds: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    NamedQueryId: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        BatchGetPreparedStatement: {
          input: {
            type: "structure",
            required: [
              "PreparedStatementNames",
              "WorkGroup"
            ],
            members: {
              PreparedStatementNames: {
                type: "list",
                member: {}
              },
              WorkGroup: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PreparedStatements: {
                type: "list",
                member: {
                  shape: "Sl"
                }
              },
              UnprocessedPreparedStatementNames: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StatementName: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        BatchGetQueryExecution: {
          input: {
            type: "structure",
            required: [
              "QueryExecutionIds"
            ],
            members: {
              QueryExecutionIds: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              QueryExecutions: {
                type: "list",
                member: {
                  shape: "Su"
                }
              },
              UnprocessedQueryExecutionIds: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    QueryExecutionId: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        CancelCapacityReservation: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        CreateCapacityReservation: {
          input: {
            type: "structure",
            required: [
              "TargetDpus",
              "Name"
            ],
            members: {
              TargetDpus: {
                type: "integer"
              },
              Name: {},
              Tags: {
                shape: "S1v"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        CreateDataCatalog: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Type"
            ],
            members: {
              Name: {},
              Type: {},
              Description: {},
              Parameters: {
                shape: "S22"
              },
              Tags: {
                shape: "S1v"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateNamedQuery: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Database",
              "QueryString"
            ],
            members: {
              Name: {},
              Description: {},
              Database: {},
              QueryString: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              WorkGroup: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NamedQueryId: {}
            }
          },
          idempotent: true
        },
        CreateNotebook: {
          input: {
            type: "structure",
            required: [
              "WorkGroup",
              "Name"
            ],
            members: {
              WorkGroup: {},
              Name: {},
              ClientRequestToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NotebookId: {}
            }
          }
        },
        CreatePreparedStatement: {
          input: {
            type: "structure",
            required: [
              "StatementName",
              "WorkGroup",
              "QueryStatement"
            ],
            members: {
              StatementName: {},
              WorkGroup: {},
              QueryStatement: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreatePresignedNotebookUrl: {
          input: {
            type: "structure",
            required: [
              "SessionId"
            ],
            members: {
              SessionId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "NotebookUrl",
              "AuthToken",
              "AuthTokenExpirationTime"
            ],
            members: {
              NotebookUrl: {},
              AuthToken: {},
              AuthTokenExpirationTime: {
                type: "long"
              }
            }
          }
        },
        CreateWorkGroup: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Configuration: {
                shape: "S2l"
              },
              Description: {},
              Tags: {
                shape: "S1v"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteCapacityReservation: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteDataCatalog: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteNamedQuery: {
          input: {
            type: "structure",
            required: [
              "NamedQueryId"
            ],
            members: {
              NamedQueryId: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteNotebook: {
          input: {
            type: "structure",
            required: [
              "NotebookId"
            ],
            members: {
              NotebookId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeletePreparedStatement: {
          input: {
            type: "structure",
            required: [
              "StatementName",
              "WorkGroup"
            ],
            members: {
              StatementName: {},
              WorkGroup: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteWorkGroup: {
          input: {
            type: "structure",
            required: [
              "WorkGroup"
            ],
            members: {
              WorkGroup: {},
              RecursiveDeleteOption: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        ExportNotebook: {
          input: {
            type: "structure",
            required: [
              "NotebookId"
            ],
            members: {
              NotebookId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NotebookMetadata: {
                shape: "S38"
              },
              Payload: {}
            }
          }
        },
        GetCalculationExecution: {
          input: {
            type: "structure",
            required: [
              "CalculationExecutionId"
            ],
            members: {
              CalculationExecutionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CalculationExecutionId: {},
              SessionId: {},
              Description: {},
              WorkingDirectory: {},
              Status: {
                shape: "S3f"
              },
              Statistics: {
                shape: "S3h"
              },
              Result: {
                type: "structure",
                members: {
                  StdOutS3Uri: {},
                  StdErrorS3Uri: {},
                  ResultS3Uri: {},
                  ResultType: {}
                }
              }
            }
          }
        },
        GetCalculationExecutionCode: {
          input: {
            type: "structure",
            required: [
              "CalculationExecutionId"
            ],
            members: {
              CalculationExecutionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CodeBlock: {}
            }
          }
        },
        GetCalculationExecutionStatus: {
          input: {
            type: "structure",
            required: [
              "CalculationExecutionId"
            ],
            members: {
              CalculationExecutionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                shape: "S3f"
              },
              Statistics: {
                shape: "S3h"
              }
            }
          }
        },
        GetCapacityAssignmentConfiguration: {
          input: {
            type: "structure",
            required: [
              "CapacityReservationName"
            ],
            members: {
              CapacityReservationName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "CapacityAssignmentConfiguration"
            ],
            members: {
              CapacityAssignmentConfiguration: {
                type: "structure",
                members: {
                  CapacityReservationName: {},
                  CapacityAssignments: {
                    shape: "S3s"
                  }
                }
              }
            }
          }
        },
        GetCapacityReservation: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "CapacityReservation"
            ],
            members: {
              CapacityReservation: {
                shape: "S3x"
              }
            }
          }
        },
        GetDataCatalog: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              WorkGroup: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DataCatalog: {
                type: "structure",
                required: [
                  "Name",
                  "Type"
                ],
                members: {
                  Name: {},
                  Description: {},
                  Type: {},
                  Parameters: {
                    shape: "S22"
                  }
                }
              }
            }
          }
        },
        GetDatabase: {
          input: {
            type: "structure",
            required: [
              "CatalogName",
              "DatabaseName"
            ],
            members: {
              CatalogName: {},
              DatabaseName: {},
              WorkGroup: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Database: {
                shape: "S48"
              }
            }
          }
        },
        GetNamedQuery: {
          input: {
            type: "structure",
            required: [
              "NamedQueryId"
            ],
            members: {
              NamedQueryId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NamedQuery: {
                shape: "S6"
              }
            }
          }
        },
        GetNotebookMetadata: {
          input: {
            type: "structure",
            required: [
              "NotebookId"
            ],
            members: {
              NotebookId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NotebookMetadata: {
                shape: "S38"
              }
            }
          }
        },
        GetPreparedStatement: {
          input: {
            type: "structure",
            required: [
              "StatementName",
              "WorkGroup"
            ],
            members: {
              StatementName: {},
              WorkGroup: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PreparedStatement: {
                shape: "Sl"
              }
            }
          }
        },
        GetQueryExecution: {
          input: {
            type: "structure",
            required: [
              "QueryExecutionId"
            ],
            members: {
              QueryExecutionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              QueryExecution: {
                shape: "Su"
              }
            }
          }
        },
        GetQueryResults: {
          input: {
            type: "structure",
            required: [
              "QueryExecutionId"
            ],
            members: {
              QueryExecutionId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UpdateCount: {
                type: "long"
              },
              ResultSet: {
                type: "structure",
                members: {
                  Rows: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Data: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              VarCharValue: {}
                            }
                          }
                        }
                      }
                    }
                  },
                  ResultSetMetadata: {
                    type: "structure",
                    members: {
                      ColumnInfo: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "Name",
                            "Type"
                          ],
                          members: {
                            CatalogName: {},
                            SchemaName: {},
                            TableName: {},
                            Name: {},
                            Label: {},
                            Type: {},
                            Precision: {
                              type: "integer"
                            },
                            Scale: {
                              type: "integer"
                            },
                            Nullable: {},
                            CaseSensitive: {
                              type: "boolean"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetQueryRuntimeStatistics: {
          input: {
            type: "structure",
            required: [
              "QueryExecutionId"
            ],
            members: {
              QueryExecutionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              QueryRuntimeStatistics: {
                type: "structure",
                members: {
                  Timeline: {
                    type: "structure",
                    members: {
                      QueryQueueTimeInMillis: {
                        type: "long"
                      },
                      ServicePreProcessingTimeInMillis: {
                        type: "long"
                      },
                      QueryPlanningTimeInMillis: {
                        type: "long"
                      },
                      EngineExecutionTimeInMillis: {
                        type: "long"
                      },
                      ServiceProcessingTimeInMillis: {
                        type: "long"
                      },
                      TotalExecutionTimeInMillis: {
                        type: "long"
                      }
                    }
                  },
                  Rows: {
                    type: "structure",
                    members: {
                      InputRows: {
                        type: "long"
                      },
                      InputBytes: {
                        type: "long"
                      },
                      OutputBytes: {
                        type: "long"
                      },
                      OutputRows: {
                        type: "long"
                      }
                    }
                  },
                  OutputStage: {
                    shape: "S51"
                  }
                }
              }
            }
          }
        },
        GetSession: {
          input: {
            type: "structure",
            required: [
              "SessionId"
            ],
            members: {
              SessionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SessionId: {},
              Description: {},
              WorkGroup: {},
              EngineVersion: {},
              EngineConfiguration: {
                shape: "S58"
              },
              NotebookVersion: {},
              SessionConfiguration: {
                type: "structure",
                members: {
                  ExecutionRole: {},
                  WorkingDirectory: {},
                  IdleTimeoutSeconds: {
                    type: "long"
                  },
                  EncryptionConfiguration: {
                    shape: "Sy"
                  }
                }
              },
              Status: {
                shape: "S5d"
              },
              Statistics: {
                type: "structure",
                members: {
                  DpuExecutionInMillis: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        GetSessionStatus: {
          input: {
            type: "structure",
            required: [
              "SessionId"
            ],
            members: {
              SessionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SessionId: {},
              Status: {
                shape: "S5d"
              }
            }
          }
        },
        GetTableMetadata: {
          input: {
            type: "structure",
            required: [
              "CatalogName",
              "DatabaseName",
              "TableName"
            ],
            members: {
              CatalogName: {},
              DatabaseName: {},
              TableName: {},
              WorkGroup: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TableMetadata: {
                shape: "S5k"
              }
            }
          }
        },
        GetWorkGroup: {
          input: {
            type: "structure",
            required: [
              "WorkGroup"
            ],
            members: {
              WorkGroup: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WorkGroup: {
                type: "structure",
                required: [
                  "Name"
                ],
                members: {
                  Name: {},
                  State: {},
                  Configuration: {
                    shape: "S2l"
                  },
                  Description: {},
                  CreationTime: {
                    type: "timestamp"
                  },
                  IdentityCenterApplicationArn: {}
                }
              }
            }
          }
        },
        ImportNotebook: {
          input: {
            type: "structure",
            required: [
              "WorkGroup",
              "Name",
              "Payload",
              "Type"
            ],
            members: {
              WorkGroup: {},
              Name: {},
              Payload: {},
              Type: {},
              ClientRequestToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NotebookId: {}
            }
          }
        },
        ListApplicationDPUSizes: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationDPUSizes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApplicationRuntimeId: {},
                    SupportedDPUSizes: {
                      type: "list",
                      member: {
                        type: "integer"
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListCalculationExecutions: {
          input: {
            type: "structure",
            required: [
              "SessionId"
            ],
            members: {
              SessionId: {},
              StateFilter: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Calculations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CalculationExecutionId: {},
                    Description: {},
                    Status: {
                      shape: "S3f"
                    }
                  }
                }
              }
            }
          }
        },
        ListCapacityReservations: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CapacityReservations"
            ],
            members: {
              NextToken: {},
              CapacityReservations: {
                type: "list",
                member: {
                  shape: "S3x"
                }
              }
            }
          }
        },
        ListDataCatalogs: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              WorkGroup: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DataCatalogsSummary: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CatalogName: {},
                    Type: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDatabases: {
          input: {
            type: "structure",
            required: [
              "CatalogName"
            ],
            members: {
              CatalogName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              WorkGroup: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DatabaseList: {
                type: "list",
                member: {
                  shape: "S48"
                }
              },
              NextToken: {}
            }
          }
        },
        ListEngineVersions: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EngineVersions: {
                type: "list",
                member: {
                  shape: "S1i"
                }
              },
              NextToken: {}
            }
          }
        },
        ListExecutors: {
          input: {
            type: "structure",
            required: [
              "SessionId"
            ],
            members: {
              SessionId: {},
              ExecutorStateFilter: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "SessionId"
            ],
            members: {
              SessionId: {},
              NextToken: {},
              ExecutorsSummary: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ExecutorId"
                  ],
                  members: {
                    ExecutorId: {},
                    ExecutorType: {},
                    StartDateTime: {
                      type: "long"
                    },
                    TerminationDateTime: {
                      type: "long"
                    },
                    ExecutorState: {},
                    ExecutorSize: {
                      type: "long"
                    }
                  }
                }
              }
            }
          }
        },
        ListNamedQueries: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              WorkGroup: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NamedQueryIds: {
                shape: "S2"
              },
              NextToken: {}
            }
          }
        },
        ListNotebookMetadata: {
          input: {
            type: "structure",
            required: [
              "WorkGroup"
            ],
            members: {
              Filters: {
                type: "structure",
                members: {
                  Name: {}
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              WorkGroup: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              NotebookMetadataList: {
                type: "list",
                member: {
                  shape: "S38"
                }
              }
            }
          }
        },
        ListNotebookSessions: {
          input: {
            type: "structure",
            required: [
              "NotebookId"
            ],
            members: {
              NotebookId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "NotebookSessionsList"
            ],
            members: {
              NotebookSessionsList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SessionId: {},
                    CreationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPreparedStatements: {
          input: {
            type: "structure",
            required: [
              "WorkGroup"
            ],
            members: {
              WorkGroup: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PreparedStatements: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StatementName: {},
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListQueryExecutions: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              WorkGroup: {}
            }
          },
          output: {
            type: "structure",
            members: {
              QueryExecutionIds: {
                shape: "Sq"
              },
              NextToken: {}
            }
          }
        },
        ListSessions: {
          input: {
            type: "structure",
            required: [
              "WorkGroup"
            ],
            members: {
              WorkGroup: {},
              StateFilter: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Sessions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SessionId: {},
                    Description: {},
                    EngineVersion: {
                      shape: "S1i"
                    },
                    NotebookVersion: {},
                    Status: {
                      shape: "S5d"
                    }
                  }
                }
              }
            }
          }
        },
        ListTableMetadata: {
          input: {
            type: "structure",
            required: [
              "CatalogName",
              "DatabaseName"
            ],
            members: {
              CatalogName: {},
              DatabaseName: {},
              Expression: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              WorkGroup: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TableMetadataList: {
                type: "list",
                member: {
                  shape: "S5k"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S1v"
              },
              NextToken: {}
            }
          }
        },
        ListWorkGroups: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    State: {},
                    Description: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    EngineVersion: {
                      shape: "S1i"
                    },
                    IdentityCenterApplicationArn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        PutCapacityAssignmentConfiguration: {
          input: {
            type: "structure",
            required: [
              "CapacityReservationName",
              "CapacityAssignments"
            ],
            members: {
              CapacityReservationName: {},
              CapacityAssignments: {
                shape: "S3s"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        StartCalculationExecution: {
          input: {
            type: "structure",
            required: [
              "SessionId"
            ],
            members: {
              SessionId: {},
              Description: {},
              CalculationConfiguration: {
                deprecated: true,
                deprecatedMessage: "Kepler Post GA Tasks : https://sim.amazon.com/issues/ATHENA-39828",
                type: "structure",
                members: {
                  CodeBlock: {}
                }
              },
              CodeBlock: {},
              ClientRequestToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CalculationExecutionId: {},
              State: {}
            }
          }
        },
        StartQueryExecution: {
          input: {
            type: "structure",
            required: [
              "QueryString"
            ],
            members: {
              QueryString: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              QueryExecutionContext: {
                shape: "S18"
              },
              ResultConfiguration: {
                shape: "Sw"
              },
              WorkGroup: {},
              ExecutionParameters: {
                shape: "S1j"
              },
              ResultReuseConfiguration: {
                shape: "S14"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              QueryExecutionId: {}
            }
          },
          idempotent: true
        },
        StartSession: {
          input: {
            type: "structure",
            required: [
              "WorkGroup",
              "EngineConfiguration"
            ],
            members: {
              Description: {},
              WorkGroup: {},
              EngineConfiguration: {
                shape: "S58"
              },
              NotebookVersion: {},
              SessionIdleTimeoutInMinutes: {
                type: "integer"
              },
              ClientRequestToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SessionId: {},
              State: {}
            }
          }
        },
        StopCalculationExecution: {
          input: {
            type: "structure",
            required: [
              "CalculationExecutionId"
            ],
            members: {
              CalculationExecutionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              State: {}
            }
          }
        },
        StopQueryExecution: {
          input: {
            type: "structure",
            required: [
              "QueryExecutionId"
            ],
            members: {
              QueryExecutionId: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S1v"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TerminateSession: {
          input: {
            type: "structure",
            required: [
              "SessionId"
            ],
            members: {
              SessionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              State: {}
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateCapacityReservation: {
          input: {
            type: "structure",
            required: [
              "TargetDpus",
              "Name"
            ],
            members: {
              TargetDpus: {
                type: "integer"
              },
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDataCatalog: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Type"
            ],
            members: {
              Name: {},
              Type: {},
              Description: {},
              Parameters: {
                shape: "S22"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateNamedQuery: {
          input: {
            type: "structure",
            required: [
              "NamedQueryId",
              "Name",
              "QueryString"
            ],
            members: {
              NamedQueryId: {},
              Name: {},
              Description: {},
              QueryString: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateNotebook: {
          input: {
            type: "structure",
            required: [
              "NotebookId",
              "Payload",
              "Type"
            ],
            members: {
              NotebookId: {},
              Payload: {},
              Type: {},
              SessionId: {},
              ClientRequestToken: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateNotebookMetadata: {
          input: {
            type: "structure",
            required: [
              "NotebookId",
              "Name"
            ],
            members: {
              NotebookId: {},
              ClientRequestToken: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdatePreparedStatement: {
          input: {
            type: "structure",
            required: [
              "StatementName",
              "WorkGroup",
              "QueryStatement"
            ],
            members: {
              StatementName: {},
              WorkGroup: {},
              QueryStatement: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateWorkGroup: {
          input: {
            type: "structure",
            required: [
              "WorkGroup"
            ],
            members: {
              WorkGroup: {},
              Description: {},
              ConfigurationUpdates: {
                type: "structure",
                members: {
                  EnforceWorkGroupConfiguration: {
                    type: "boolean"
                  },
                  ResultConfigurationUpdates: {
                    type: "structure",
                    members: {
                      OutputLocation: {},
                      RemoveOutputLocation: {
                        type: "boolean"
                      },
                      EncryptionConfiguration: {
                        shape: "Sy"
                      },
                      RemoveEncryptionConfiguration: {
                        type: "boolean"
                      },
                      ExpectedBucketOwner: {},
                      RemoveExpectedBucketOwner: {
                        type: "boolean"
                      },
                      AclConfiguration: {
                        shape: "S12"
                      },
                      RemoveAclConfiguration: {
                        type: "boolean"
                      }
                    }
                  },
                  PublishCloudWatchMetricsEnabled: {
                    type: "boolean"
                  },
                  BytesScannedCutoffPerQuery: {
                    type: "long"
                  },
                  RemoveBytesScannedCutoffPerQuery: {
                    type: "boolean"
                  },
                  RequesterPaysEnabled: {
                    type: "boolean"
                  },
                  EngineVersion: {
                    shape: "S1i"
                  },
                  RemoveCustomerContentEncryptionConfiguration: {
                    type: "boolean"
                  },
                  AdditionalConfiguration: {},
                  ExecutionRole: {},
                  CustomerContentEncryptionConfiguration: {
                    shape: "S2o"
                  },
                  EnableMinimumEncryptionConfiguration: {
                    type: "boolean"
                  },
                  QueryResultsS3AccessGrantsConfiguration: {
                    shape: "S1l"
                  }
                }
              },
              State: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S2: {
          type: "list",
          member: {}
        },
        S6: {
          type: "structure",
          required: [
            "Name",
            "Database",
            "QueryString"
          ],
          members: {
            Name: {},
            Description: {},
            Database: {},
            QueryString: {},
            NamedQueryId: {},
            WorkGroup: {}
          }
        },
        Sl: {
          type: "structure",
          members: {
            StatementName: {},
            QueryStatement: {},
            WorkGroupName: {},
            Description: {},
            LastModifiedTime: {
              type: "timestamp"
            }
          }
        },
        Sq: {
          type: "list",
          member: {}
        },
        Su: {
          type: "structure",
          members: {
            QueryExecutionId: {},
            Query: {},
            StatementType: {},
            ResultConfiguration: {
              shape: "Sw"
            },
            ResultReuseConfiguration: {
              shape: "S14"
            },
            QueryExecutionContext: {
              shape: "S18"
            },
            Status: {
              type: "structure",
              members: {
                State: {},
                StateChangeReason: {},
                SubmissionDateTime: {
                  type: "timestamp"
                },
                CompletionDateTime: {
                  type: "timestamp"
                },
                AthenaError: {
                  type: "structure",
                  members: {
                    ErrorCategory: {
                      type: "integer"
                    },
                    ErrorType: {
                      type: "integer"
                    },
                    Retryable: {
                      type: "boolean"
                    },
                    ErrorMessage: {}
                  }
                }
              }
            },
            Statistics: {
              type: "structure",
              members: {
                EngineExecutionTimeInMillis: {
                  type: "long"
                },
                DataScannedInBytes: {
                  type: "long"
                },
                DataManifestLocation: {},
                TotalExecutionTimeInMillis: {
                  type: "long"
                },
                QueryQueueTimeInMillis: {
                  type: "long"
                },
                ServicePreProcessingTimeInMillis: {
                  type: "long"
                },
                QueryPlanningTimeInMillis: {
                  type: "long"
                },
                ServiceProcessingTimeInMillis: {
                  type: "long"
                },
                ResultReuseInformation: {
                  type: "structure",
                  required: [
                    "ReusedPreviousResult"
                  ],
                  members: {
                    ReusedPreviousResult: {
                      type: "boolean"
                    }
                  }
                }
              }
            },
            WorkGroup: {},
            EngineVersion: {
              shape: "S1i"
            },
            ExecutionParameters: {
              shape: "S1j"
            },
            SubstatementType: {},
            QueryResultsS3AccessGrantsConfiguration: {
              shape: "S1l"
            }
          }
        },
        Sw: {
          type: "structure",
          members: {
            OutputLocation: {},
            EncryptionConfiguration: {
              shape: "Sy"
            },
            ExpectedBucketOwner: {},
            AclConfiguration: {
              shape: "S12"
            }
          }
        },
        Sy: {
          type: "structure",
          required: [
            "EncryptionOption"
          ],
          members: {
            EncryptionOption: {},
            KmsKey: {}
          }
        },
        S12: {
          type: "structure",
          required: [
            "S3AclOption"
          ],
          members: {
            S3AclOption: {}
          }
        },
        S14: {
          type: "structure",
          members: {
            ResultReuseByAgeConfiguration: {
              type: "structure",
              required: [
                "Enabled"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                MaxAgeInMinutes: {
                  type: "integer"
                }
              }
            }
          }
        },
        S18: {
          type: "structure",
          members: {
            Database: {},
            Catalog: {}
          }
        },
        S1i: {
          type: "structure",
          members: {
            SelectedEngineVersion: {},
            EffectiveEngineVersion: {}
          }
        },
        S1j: {
          type: "list",
          member: {}
        },
        S1l: {
          type: "structure",
          required: [
            "EnableS3AccessGrants",
            "AuthenticationType"
          ],
          members: {
            EnableS3AccessGrants: {
              type: "boolean"
            },
            CreateUserLevelPrefix: {
              type: "boolean"
            },
            AuthenticationType: {}
          }
        },
        S1v: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S22: {
          type: "map",
          key: {},
          value: {}
        },
        S2l: {
          type: "structure",
          members: {
            ResultConfiguration: {
              shape: "Sw"
            },
            EnforceWorkGroupConfiguration: {
              type: "boolean"
            },
            PublishCloudWatchMetricsEnabled: {
              type: "boolean"
            },
            BytesScannedCutoffPerQuery: {
              type: "long"
            },
            RequesterPaysEnabled: {
              type: "boolean"
            },
            EngineVersion: {
              shape: "S1i"
            },
            AdditionalConfiguration: {},
            ExecutionRole: {},
            CustomerContentEncryptionConfiguration: {
              shape: "S2o"
            },
            EnableMinimumEncryptionConfiguration: {
              type: "boolean"
            },
            IdentityCenterConfiguration: {
              type: "structure",
              members: {
                EnableIdentityCenter: {
                  type: "boolean"
                },
                IdentityCenterInstanceArn: {}
              }
            },
            QueryResultsS3AccessGrantsConfiguration: {
              shape: "S1l"
            }
          }
        },
        S2o: {
          type: "structure",
          required: [
            "KmsKey"
          ],
          members: {
            KmsKey: {}
          }
        },
        S38: {
          type: "structure",
          members: {
            NotebookId: {},
            Name: {},
            WorkGroup: {},
            CreationTime: {
              type: "timestamp"
            },
            Type: {},
            LastModifiedTime: {
              type: "timestamp"
            }
          }
        },
        S3f: {
          type: "structure",
          members: {
            SubmissionDateTime: {
              type: "timestamp"
            },
            CompletionDateTime: {
              type: "timestamp"
            },
            State: {},
            StateChangeReason: {}
          }
        },
        S3h: {
          type: "structure",
          members: {
            DpuExecutionInMillis: {
              type: "long"
            },
            Progress: {}
          }
        },
        S3s: {
          type: "list",
          member: {
            type: "structure",
            members: {
              WorkGroupNames: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S3x: {
          type: "structure",
          required: [
            "Name",
            "Status",
            "TargetDpus",
            "AllocatedDpus",
            "CreationTime"
          ],
          members: {
            Name: {},
            Status: {},
            TargetDpus: {
              type: "integer"
            },
            AllocatedDpus: {
              type: "integer"
            },
            LastAllocation: {
              type: "structure",
              required: [
                "Status",
                "RequestTime"
              ],
              members: {
                Status: {},
                StatusMessage: {},
                RequestTime: {
                  type: "timestamp"
                },
                RequestCompletionTime: {
                  type: "timestamp"
                }
              }
            },
            LastSuccessfulAllocationTime: {
              type: "timestamp"
            },
            CreationTime: {
              type: "timestamp"
            }
          }
        },
        S48: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            Description: {},
            Parameters: {
              shape: "S22"
            }
          }
        },
        S51: {
          type: "structure",
          members: {
            StageId: {
              type: "long"
            },
            State: {},
            OutputBytes: {
              type: "long"
            },
            OutputRows: {
              type: "long"
            },
            InputBytes: {
              type: "long"
            },
            InputRows: {
              type: "long"
            },
            ExecutionTime: {
              type: "long"
            },
            QueryStagePlan: {
              shape: "S52"
            },
            SubStages: {
              type: "list",
              member: {
                shape: "S51"
              }
            }
          }
        },
        S52: {
          type: "structure",
          members: {
            Name: {},
            Identifier: {},
            Children: {
              type: "list",
              member: {
                shape: "S52"
              }
            },
            RemoteSources: {
              type: "list",
              member: {}
            }
          }
        },
        S58: {
          type: "structure",
          required: [
            "MaxConcurrentDpus"
          ],
          members: {
            CoordinatorDpuSize: {
              type: "integer"
            },
            MaxConcurrentDpus: {
              type: "integer"
            },
            DefaultExecutorDpuSize: {
              type: "integer"
            },
            AdditionalConfigs: {
              shape: "S22"
            },
            SparkProperties: {
              shape: "S22"
            }
          }
        },
        S5d: {
          type: "structure",
          members: {
            StartDateTime: {
              type: "timestamp"
            },
            LastModifiedDateTime: {
              type: "timestamp"
            },
            EndDateTime: {
              type: "timestamp"
            },
            IdleSinceDateTime: {
              type: "timestamp"
            },
            State: {},
            StateChangeReason: {}
          }
        },
        S5k: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            CreateTime: {
              type: "timestamp"
            },
            LastAccessTime: {
              type: "timestamp"
            },
            TableType: {},
            Columns: {
              shape: "S5m"
            },
            PartitionKeys: {
              shape: "S5m"
            },
            Parameters: {
              shape: "S22"
            }
          }
        },
        S5m: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Type: {},
              Comment: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/athena-2017-05-18.paginators.json
var require_athena_2017_05_18_paginators = __commonJS({
  "node_modules/aws-sdk/apis/athena-2017-05-18.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetQueryResults: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListApplicationDPUSizes: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListCalculationExecutions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListCapacityReservations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListDataCatalogs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "DataCatalogsSummary"
        },
        ListDatabases: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "DatabaseList"
        },
        ListEngineVersions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListExecutors: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListNamedQueries: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListPreparedStatements: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListQueryExecutions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListSessions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListTableMetadata: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TableMetadataList"
        },
        ListTagsForResource: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Tags"
        },
        ListWorkGroups: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/athena.js
var require_athena = __commonJS({
  "node_modules/aws-sdk/clients/athena.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["athena"] = {};
    AWS2.Athena = Service.defineService("athena", ["2017-05-18"]);
    Object.defineProperty(apiLoader.services["athena"], "2017-05-18", {
      get: function get() {
        var model = require_athena_2017_05_18_min();
        model.paginators = require_athena_2017_05_18_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Athena;
  }
});

// node_modules/aws-sdk/apis/greengrass-2017-06-07.min.json
var require_greengrass_2017_06_07_min = __commonJS({
  "node_modules/aws-sdk/apis/greengrass-2017-06-07.min.json"(exports2, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2017-06-07",
        endpointPrefix: "greengrass",
        signingName: "greengrass",
        serviceFullName: "AWS Greengrass",
        serviceId: "Greengrass",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "greengrass-2017-06-07",
        signatureVersion: "v4"
      },
      operations: {
        AssociateRoleToGroup: {
          http: {
            method: "PUT",
            requestUri: "/greengrass/groups/{GroupId}/role",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              },
              RoleArn: {}
            },
            required: [
              "GroupId",
              "RoleArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              AssociatedAt: {}
            }
          }
        },
        AssociateServiceRoleToAccount: {
          http: {
            method: "PUT",
            requestUri: "/greengrass/servicerole",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              RoleArn: {}
            },
            required: [
              "RoleArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              AssociatedAt: {}
            }
          }
        },
        CreateConnectorDefinition: {
          http: {
            requestUri: "/greengrass/definition/connectors",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              InitialVersion: {
                shape: "S7"
              },
              Name: {},
              tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {}
            }
          }
        },
        CreateConnectorDefinitionVersion: {
          http: {
            requestUri: "/greengrass/definition/connectors/{ConnectorDefinitionId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              ConnectorDefinitionId: {
                location: "uri",
                locationName: "ConnectorDefinitionId"
              },
              Connectors: {
                shape: "S8"
              }
            },
            required: [
              "ConnectorDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              Version: {}
            }
          }
        },
        CreateCoreDefinition: {
          http: {
            requestUri: "/greengrass/definition/cores",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              InitialVersion: {
                shape: "Sg"
              },
              Name: {},
              tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {}
            }
          }
        },
        CreateCoreDefinitionVersion: {
          http: {
            requestUri: "/greengrass/definition/cores/{CoreDefinitionId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              CoreDefinitionId: {
                location: "uri",
                locationName: "CoreDefinitionId"
              },
              Cores: {
                shape: "Sh"
              }
            },
            required: [
              "CoreDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              Version: {}
            }
          }
        },
        CreateDeployment: {
          http: {
            requestUri: "/greengrass/groups/{GroupId}/deployments",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              DeploymentId: {},
              DeploymentType: {},
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              },
              GroupVersionId: {}
            },
            required: [
              "GroupId",
              "DeploymentType"
            ]
          },
          output: {
            type: "structure",
            members: {
              DeploymentArn: {},
              DeploymentId: {}
            }
          }
        },
        CreateDeviceDefinition: {
          http: {
            requestUri: "/greengrass/definition/devices",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              InitialVersion: {
                shape: "Sr"
              },
              Name: {},
              tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {}
            }
          }
        },
        CreateDeviceDefinitionVersion: {
          http: {
            requestUri: "/greengrass/definition/devices/{DeviceDefinitionId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              DeviceDefinitionId: {
                location: "uri",
                locationName: "DeviceDefinitionId"
              },
              Devices: {
                shape: "Ss"
              }
            },
            required: [
              "DeviceDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              Version: {}
            }
          }
        },
        CreateFunctionDefinition: {
          http: {
            requestUri: "/greengrass/definition/functions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              InitialVersion: {
                shape: "Sy"
              },
              Name: {},
              tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {}
            }
          }
        },
        CreateFunctionDefinitionVersion: {
          http: {
            requestUri: "/greengrass/definition/functions/{FunctionDefinitionId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              DefaultConfig: {
                shape: "Sz"
              },
              FunctionDefinitionId: {
                location: "uri",
                locationName: "FunctionDefinitionId"
              },
              Functions: {
                shape: "S14"
              }
            },
            required: [
              "FunctionDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              Version: {}
            }
          }
        },
        CreateGroup: {
          http: {
            requestUri: "/greengrass/groups",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              InitialVersion: {
                shape: "S1h"
              },
              Name: {},
              tags: {
                shape: "Sb"
              }
            },
            required: [
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {}
            }
          }
        },
        CreateGroupCertificateAuthority: {
          http: {
            requestUri: "/greengrass/groups/{GroupId}/certificateauthorities",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              }
            },
            required: [
              "GroupId"
            ]
          },
          output: {
            type: "structure",
            members: {
              GroupCertificateAuthorityArn: {}
            }
          }
        },
        CreateGroupVersion: {
          http: {
            requestUri: "/greengrass/groups/{GroupId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              ConnectorDefinitionVersionArn: {},
              CoreDefinitionVersionArn: {},
              DeviceDefinitionVersionArn: {},
              FunctionDefinitionVersionArn: {},
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              },
              LoggerDefinitionVersionArn: {},
              ResourceDefinitionVersionArn: {},
              SubscriptionDefinitionVersionArn: {}
            },
            required: [
              "GroupId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              Version: {}
            }
          }
        },
        CreateLoggerDefinition: {
          http: {
            requestUri: "/greengrass/definition/loggers",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              InitialVersion: {
                shape: "S1o"
              },
              Name: {},
              tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {}
            }
          }
        },
        CreateLoggerDefinitionVersion: {
          http: {
            requestUri: "/greengrass/definition/loggers/{LoggerDefinitionId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              LoggerDefinitionId: {
                location: "uri",
                locationName: "LoggerDefinitionId"
              },
              Loggers: {
                shape: "S1p"
              }
            },
            required: [
              "LoggerDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              Version: {}
            }
          }
        },
        CreateResourceDefinition: {
          http: {
            requestUri: "/greengrass/definition/resources",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              InitialVersion: {
                shape: "S1y"
              },
              Name: {},
              tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {}
            }
          }
        },
        CreateResourceDefinitionVersion: {
          http: {
            requestUri: "/greengrass/definition/resources/{ResourceDefinitionId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              ResourceDefinitionId: {
                location: "uri",
                locationName: "ResourceDefinitionId"
              },
              Resources: {
                shape: "S1z"
              }
            },
            required: [
              "ResourceDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              Version: {}
            }
          }
        },
        CreateSoftwareUpdateJob: {
          http: {
            requestUri: "/greengrass/updates",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              S3UrlSignerRole: {},
              SoftwareToUpdate: {},
              UpdateAgentLogLevel: {},
              UpdateTargets: {
                type: "list",
                member: {}
              },
              UpdateTargetsArchitecture: {},
              UpdateTargetsOperatingSystem: {}
            },
            required: [
              "S3UrlSignerRole",
              "UpdateTargetsArchitecture",
              "SoftwareToUpdate",
              "UpdateTargets",
              "UpdateTargetsOperatingSystem"
            ]
          },
          output: {
            type: "structure",
            members: {
              IotJobArn: {},
              IotJobId: {},
              PlatformSoftwareVersion: {}
            }
          }
        },
        CreateSubscriptionDefinition: {
          http: {
            requestUri: "/greengrass/definition/subscriptions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              InitialVersion: {
                shape: "S2m"
              },
              Name: {},
              tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {}
            }
          }
        },
        CreateSubscriptionDefinitionVersion: {
          http: {
            requestUri: "/greengrass/definition/subscriptions/{SubscriptionDefinitionId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              SubscriptionDefinitionId: {
                location: "uri",
                locationName: "SubscriptionDefinitionId"
              },
              Subscriptions: {
                shape: "S2n"
              }
            },
            required: [
              "SubscriptionDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              Version: {}
            }
          }
        },
        DeleteConnectorDefinition: {
          http: {
            method: "DELETE",
            requestUri: "/greengrass/definition/connectors/{ConnectorDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConnectorDefinitionId: {
                location: "uri",
                locationName: "ConnectorDefinitionId"
              }
            },
            required: [
              "ConnectorDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteCoreDefinition: {
          http: {
            method: "DELETE",
            requestUri: "/greengrass/definition/cores/{CoreDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CoreDefinitionId: {
                location: "uri",
                locationName: "CoreDefinitionId"
              }
            },
            required: [
              "CoreDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDeviceDefinition: {
          http: {
            method: "DELETE",
            requestUri: "/greengrass/definition/devices/{DeviceDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeviceDefinitionId: {
                location: "uri",
                locationName: "DeviceDefinitionId"
              }
            },
            required: [
              "DeviceDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteFunctionDefinition: {
          http: {
            method: "DELETE",
            requestUri: "/greengrass/definition/functions/{FunctionDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              FunctionDefinitionId: {
                location: "uri",
                locationName: "FunctionDefinitionId"
              }
            },
            required: [
              "FunctionDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteGroup: {
          http: {
            method: "DELETE",
            requestUri: "/greengrass/groups/{GroupId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              }
            },
            required: [
              "GroupId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteLoggerDefinition: {
          http: {
            method: "DELETE",
            requestUri: "/greengrass/definition/loggers/{LoggerDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              LoggerDefinitionId: {
                location: "uri",
                locationName: "LoggerDefinitionId"
              }
            },
            required: [
              "LoggerDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteResourceDefinition: {
          http: {
            method: "DELETE",
            requestUri: "/greengrass/definition/resources/{ResourceDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceDefinitionId: {
                location: "uri",
                locationName: "ResourceDefinitionId"
              }
            },
            required: [
              "ResourceDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSubscriptionDefinition: {
          http: {
            method: "DELETE",
            requestUri: "/greengrass/definition/subscriptions/{SubscriptionDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              SubscriptionDefinitionId: {
                location: "uri",
                locationName: "SubscriptionDefinitionId"
              }
            },
            required: [
              "SubscriptionDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateRoleFromGroup: {
          http: {
            method: "DELETE",
            requestUri: "/greengrass/groups/{GroupId}/role",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              }
            },
            required: [
              "GroupId"
            ]
          },
          output: {
            type: "structure",
            members: {
              DisassociatedAt: {}
            }
          }
        },
        DisassociateServiceRoleFromAccount: {
          http: {
            method: "DELETE",
            requestUri: "/greengrass/servicerole",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              DisassociatedAt: {}
            }
          }
        },
        GetAssociatedRole: {
          http: {
            method: "GET",
            requestUri: "/greengrass/groups/{GroupId}/role",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              }
            },
            required: [
              "GroupId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AssociatedAt: {},
              RoleArn: {}
            }
          }
        },
        GetBulkDeploymentStatus: {
          http: {
            method: "GET",
            requestUri: "/greengrass/bulk/deployments/{BulkDeploymentId}/status",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BulkDeploymentId: {
                location: "uri",
                locationName: "BulkDeploymentId"
              }
            },
            required: [
              "BulkDeploymentId"
            ]
          },
          output: {
            type: "structure",
            members: {
              BulkDeploymentMetrics: {
                type: "structure",
                members: {
                  InvalidInputRecords: {
                    type: "integer"
                  },
                  RecordsProcessed: {
                    type: "integer"
                  },
                  RetryAttempts: {
                    type: "integer"
                  }
                }
              },
              BulkDeploymentStatus: {},
              CreatedAt: {},
              ErrorDetails: {
                shape: "S3i"
              },
              ErrorMessage: {},
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        GetConnectivityInfo: {
          http: {
            method: "GET",
            requestUri: "/greengrass/things/{ThingName}/connectivityInfo",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ThingName: {
                location: "uri",
                locationName: "ThingName"
              }
            },
            required: [
              "ThingName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ConnectivityInfo: {
                shape: "S3m"
              },
              Message: {
                locationName: "message"
              }
            }
          }
        },
        GetConnectorDefinition: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/connectors/{ConnectorDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConnectorDefinitionId: {
                location: "uri",
                locationName: "ConnectorDefinitionId"
              }
            },
            required: [
              "ConnectorDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {},
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        GetConnectorDefinitionVersion: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/connectors/{ConnectorDefinitionId}/versions/{ConnectorDefinitionVersionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConnectorDefinitionId: {
                location: "uri",
                locationName: "ConnectorDefinitionId"
              },
              ConnectorDefinitionVersionId: {
                location: "uri",
                locationName: "ConnectorDefinitionVersionId"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            },
            required: [
              "ConnectorDefinitionId",
              "ConnectorDefinitionVersionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Definition: {
                shape: "S7"
              },
              Id: {},
              NextToken: {},
              Version: {}
            }
          }
        },
        GetCoreDefinition: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/cores/{CoreDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CoreDefinitionId: {
                location: "uri",
                locationName: "CoreDefinitionId"
              }
            },
            required: [
              "CoreDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {},
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        GetCoreDefinitionVersion: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/cores/{CoreDefinitionId}/versions/{CoreDefinitionVersionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CoreDefinitionId: {
                location: "uri",
                locationName: "CoreDefinitionId"
              },
              CoreDefinitionVersionId: {
                location: "uri",
                locationName: "CoreDefinitionVersionId"
              }
            },
            required: [
              "CoreDefinitionId",
              "CoreDefinitionVersionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Definition: {
                shape: "Sg"
              },
              Id: {},
              NextToken: {},
              Version: {}
            }
          }
        },
        GetDeploymentStatus: {
          http: {
            method: "GET",
            requestUri: "/greengrass/groups/{GroupId}/deployments/{DeploymentId}/status",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeploymentId: {
                location: "uri",
                locationName: "DeploymentId"
              },
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              }
            },
            required: [
              "GroupId",
              "DeploymentId"
            ]
          },
          output: {
            type: "structure",
            members: {
              DeploymentStatus: {},
              DeploymentType: {},
              ErrorDetails: {
                shape: "S3i"
              },
              ErrorMessage: {},
              UpdatedAt: {}
            }
          }
        },
        GetDeviceDefinition: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/devices/{DeviceDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeviceDefinitionId: {
                location: "uri",
                locationName: "DeviceDefinitionId"
              }
            },
            required: [
              "DeviceDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {},
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        GetDeviceDefinitionVersion: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/devices/{DeviceDefinitionId}/versions/{DeviceDefinitionVersionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeviceDefinitionId: {
                location: "uri",
                locationName: "DeviceDefinitionId"
              },
              DeviceDefinitionVersionId: {
                location: "uri",
                locationName: "DeviceDefinitionVersionId"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            },
            required: [
              "DeviceDefinitionVersionId",
              "DeviceDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Definition: {
                shape: "Sr"
              },
              Id: {},
              NextToken: {},
              Version: {}
            }
          }
        },
        GetFunctionDefinition: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/functions/{FunctionDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              FunctionDefinitionId: {
                location: "uri",
                locationName: "FunctionDefinitionId"
              }
            },
            required: [
              "FunctionDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {},
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        GetFunctionDefinitionVersion: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/functions/{FunctionDefinitionId}/versions/{FunctionDefinitionVersionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              FunctionDefinitionId: {
                location: "uri",
                locationName: "FunctionDefinitionId"
              },
              FunctionDefinitionVersionId: {
                location: "uri",
                locationName: "FunctionDefinitionVersionId"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            },
            required: [
              "FunctionDefinitionId",
              "FunctionDefinitionVersionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Definition: {
                shape: "Sy"
              },
              Id: {},
              NextToken: {},
              Version: {}
            }
          }
        },
        GetGroup: {
          http: {
            method: "GET",
            requestUri: "/greengrass/groups/{GroupId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              }
            },
            required: [
              "GroupId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {},
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        GetGroupCertificateAuthority: {
          http: {
            method: "GET",
            requestUri: "/greengrass/groups/{GroupId}/certificateauthorities/{CertificateAuthorityId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CertificateAuthorityId: {
                location: "uri",
                locationName: "CertificateAuthorityId"
              },
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              }
            },
            required: [
              "CertificateAuthorityId",
              "GroupId"
            ]
          },
          output: {
            type: "structure",
            members: {
              GroupCertificateAuthorityArn: {},
              GroupCertificateAuthorityId: {},
              PemEncodedCertificate: {}
            }
          }
        },
        GetGroupCertificateConfiguration: {
          http: {
            method: "GET",
            requestUri: "/greengrass/groups/{GroupId}/certificateauthorities/configuration/expiry",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              }
            },
            required: [
              "GroupId"
            ]
          },
          output: {
            type: "structure",
            members: {
              CertificateAuthorityExpiryInMilliseconds: {},
              CertificateExpiryInMilliseconds: {},
              GroupId: {}
            }
          }
        },
        GetGroupVersion: {
          http: {
            method: "GET",
            requestUri: "/greengrass/groups/{GroupId}/versions/{GroupVersionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              },
              GroupVersionId: {
                location: "uri",
                locationName: "GroupVersionId"
              }
            },
            required: [
              "GroupVersionId",
              "GroupId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Definition: {
                shape: "S1h"
              },
              Id: {},
              Version: {}
            }
          }
        },
        GetLoggerDefinition: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/loggers/{LoggerDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              LoggerDefinitionId: {
                location: "uri",
                locationName: "LoggerDefinitionId"
              }
            },
            required: [
              "LoggerDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {},
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        GetLoggerDefinitionVersion: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/loggers/{LoggerDefinitionId}/versions/{LoggerDefinitionVersionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              LoggerDefinitionId: {
                location: "uri",
                locationName: "LoggerDefinitionId"
              },
              LoggerDefinitionVersionId: {
                location: "uri",
                locationName: "LoggerDefinitionVersionId"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            },
            required: [
              "LoggerDefinitionVersionId",
              "LoggerDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Definition: {
                shape: "S1o"
              },
              Id: {},
              Version: {}
            }
          }
        },
        GetResourceDefinition: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/resources/{ResourceDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceDefinitionId: {
                location: "uri",
                locationName: "ResourceDefinitionId"
              }
            },
            required: [
              "ResourceDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {},
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        GetResourceDefinitionVersion: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/resources/{ResourceDefinitionId}/versions/{ResourceDefinitionVersionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceDefinitionId: {
                location: "uri",
                locationName: "ResourceDefinitionId"
              },
              ResourceDefinitionVersionId: {
                location: "uri",
                locationName: "ResourceDefinitionVersionId"
              }
            },
            required: [
              "ResourceDefinitionVersionId",
              "ResourceDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Definition: {
                shape: "S1y"
              },
              Id: {},
              Version: {}
            }
          }
        },
        GetServiceRoleForAccount: {
          http: {
            method: "GET",
            requestUri: "/greengrass/servicerole",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              AssociatedAt: {},
              RoleArn: {}
            }
          }
        },
        GetSubscriptionDefinition: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/subscriptions/{SubscriptionDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              SubscriptionDefinitionId: {
                location: "uri",
                locationName: "SubscriptionDefinitionId"
              }
            },
            required: [
              "SubscriptionDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {},
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        GetSubscriptionDefinitionVersion: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/subscriptions/{SubscriptionDefinitionId}/versions/{SubscriptionDefinitionVersionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              SubscriptionDefinitionId: {
                location: "uri",
                locationName: "SubscriptionDefinitionId"
              },
              SubscriptionDefinitionVersionId: {
                location: "uri",
                locationName: "SubscriptionDefinitionVersionId"
              }
            },
            required: [
              "SubscriptionDefinitionId",
              "SubscriptionDefinitionVersionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Definition: {
                shape: "S2m"
              },
              Id: {},
              NextToken: {},
              Version: {}
            }
          }
        },
        GetThingRuntimeConfiguration: {
          http: {
            method: "GET",
            requestUri: "/greengrass/things/{ThingName}/runtimeconfig",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ThingName: {
                location: "uri",
                locationName: "ThingName"
              }
            },
            required: [
              "ThingName"
            ]
          },
          output: {
            type: "structure",
            members: {
              RuntimeConfiguration: {
                type: "structure",
                members: {
                  TelemetryConfiguration: {
                    type: "structure",
                    members: {
                      ConfigurationSyncStatus: {},
                      Telemetry: {}
                    },
                    required: [
                      "Telemetry"
                    ]
                  }
                }
              }
            }
          }
        },
        ListBulkDeploymentDetailedReports: {
          http: {
            method: "GET",
            requestUri: "/greengrass/bulk/deployments/{BulkDeploymentId}/detailed-reports",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BulkDeploymentId: {
                location: "uri",
                locationName: "BulkDeploymentId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            },
            required: [
              "BulkDeploymentId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Deployments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreatedAt: {},
                    DeploymentArn: {},
                    DeploymentId: {},
                    DeploymentStatus: {},
                    DeploymentType: {},
                    ErrorDetails: {
                      shape: "S3i"
                    },
                    ErrorMessage: {},
                    GroupArn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListBulkDeployments: {
          http: {
            method: "GET",
            requestUri: "/greengrass/bulk/deployments",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BulkDeployments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    BulkDeploymentArn: {},
                    BulkDeploymentId: {},
                    CreatedAt: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListConnectorDefinitionVersions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/connectors/{ConnectorDefinitionId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConnectorDefinitionId: {
                location: "uri",
                locationName: "ConnectorDefinitionId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            },
            required: [
              "ConnectorDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Versions: {
                shape: "S58"
              }
            }
          }
        },
        ListConnectorDefinitions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/connectors",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Definitions: {
                shape: "S5c"
              },
              NextToken: {}
            }
          }
        },
        ListCoreDefinitionVersions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/cores/{CoreDefinitionId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CoreDefinitionId: {
                location: "uri",
                locationName: "CoreDefinitionId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            },
            required: [
              "CoreDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Versions: {
                shape: "S58"
              }
            }
          }
        },
        ListCoreDefinitions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/cores",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Definitions: {
                shape: "S5c"
              },
              NextToken: {}
            }
          }
        },
        ListDeployments: {
          http: {
            method: "GET",
            requestUri: "/greengrass/groups/{GroupId}/deployments",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            },
            required: [
              "GroupId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Deployments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreatedAt: {},
                    DeploymentArn: {},
                    DeploymentId: {},
                    DeploymentType: {},
                    GroupArn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDeviceDefinitionVersions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/devices/{DeviceDefinitionId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeviceDefinitionId: {
                location: "uri",
                locationName: "DeviceDefinitionId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            },
            required: [
              "DeviceDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Versions: {
                shape: "S58"
              }
            }
          }
        },
        ListDeviceDefinitions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/devices",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Definitions: {
                shape: "S5c"
              },
              NextToken: {}
            }
          }
        },
        ListFunctionDefinitionVersions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/functions/{FunctionDefinitionId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              FunctionDefinitionId: {
                location: "uri",
                locationName: "FunctionDefinitionId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            },
            required: [
              "FunctionDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Versions: {
                shape: "S58"
              }
            }
          }
        },
        ListFunctionDefinitions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/functions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Definitions: {
                shape: "S5c"
              },
              NextToken: {}
            }
          }
        },
        ListGroupCertificateAuthorities: {
          http: {
            method: "GET",
            requestUri: "/greengrass/groups/{GroupId}/certificateauthorities",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              }
            },
            required: [
              "GroupId"
            ]
          },
          output: {
            type: "structure",
            members: {
              GroupCertificateAuthorities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    GroupCertificateAuthorityArn: {},
                    GroupCertificateAuthorityId: {}
                  }
                }
              }
            }
          }
        },
        ListGroupVersions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/groups/{GroupId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            },
            required: [
              "GroupId"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Versions: {
                shape: "S58"
              }
            }
          }
        },
        ListGroups: {
          http: {
            method: "GET",
            requestUri: "/greengrass/groups",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Groups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    CreationTimestamp: {},
                    Id: {},
                    LastUpdatedTimestamp: {},
                    LatestVersion: {},
                    LatestVersionArn: {},
                    Name: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListLoggerDefinitionVersions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/loggers/{LoggerDefinitionId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              LoggerDefinitionId: {
                location: "uri",
                locationName: "LoggerDefinitionId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            },
            required: [
              "LoggerDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Versions: {
                shape: "S58"
              }
            }
          }
        },
        ListLoggerDefinitions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/loggers",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Definitions: {
                shape: "S5c"
              },
              NextToken: {}
            }
          }
        },
        ListResourceDefinitionVersions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/resources/{ResourceDefinitionId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              ResourceDefinitionId: {
                location: "uri",
                locationName: "ResourceDefinitionId"
              }
            },
            required: [
              "ResourceDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Versions: {
                shape: "S58"
              }
            }
          }
        },
        ListResourceDefinitions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/resources",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Definitions: {
                shape: "S5c"
              },
              NextToken: {}
            }
          }
        },
        ListSubscriptionDefinitionVersions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/subscriptions/{SubscriptionDefinitionId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              SubscriptionDefinitionId: {
                location: "uri",
                locationName: "SubscriptionDefinitionId"
              }
            },
            required: [
              "SubscriptionDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Versions: {
                shape: "S58"
              }
            }
          }
        },
        ListSubscriptionDefinitions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/subscriptions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Definitions: {
                shape: "S5c"
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resource-arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              }
            },
            required: [
              "ResourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        ResetDeployments: {
          http: {
            requestUri: "/greengrass/groups/{GroupId}/deployments/$reset",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              Force: {
                type: "boolean"
              },
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              }
            },
            required: [
              "GroupId"
            ]
          },
          output: {
            type: "structure",
            members: {
              DeploymentArn: {},
              DeploymentId: {}
            }
          }
        },
        StartBulkDeployment: {
          http: {
            requestUri: "/greengrass/bulk/deployments",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              ExecutionRoleArn: {},
              InputFileUri: {},
              tags: {
                shape: "Sb"
              }
            },
            required: [
              "ExecutionRoleArn",
              "InputFileUri"
            ]
          },
          output: {
            type: "structure",
            members: {
              BulkDeploymentArn: {},
              BulkDeploymentId: {}
            }
          }
        },
        StopBulkDeployment: {
          http: {
            method: "PUT",
            requestUri: "/greengrass/bulk/deployments/{BulkDeploymentId}/$stop",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BulkDeploymentId: {
                location: "uri",
                locationName: "BulkDeploymentId"
              }
            },
            required: [
              "BulkDeploymentId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              tags: {
                shape: "Sb"
              }
            },
            required: [
              "ResourceArn"
            ]
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              TagKeys: {
                shape: "S29",
                location: "querystring",
                locationName: "tagKeys"
              }
            },
            required: [
              "TagKeys",
              "ResourceArn"
            ]
          }
        },
        UpdateConnectivityInfo: {
          http: {
            method: "PUT",
            requestUri: "/greengrass/things/{ThingName}/connectivityInfo",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConnectivityInfo: {
                shape: "S3m"
              },
              ThingName: {
                location: "uri",
                locationName: "ThingName"
              }
            },
            required: [
              "ThingName"
            ]
          },
          output: {
            type: "structure",
            members: {
              Message: {
                locationName: "message"
              },
              Version: {}
            }
          }
        },
        UpdateConnectorDefinition: {
          http: {
            method: "PUT",
            requestUri: "/greengrass/definition/connectors/{ConnectorDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConnectorDefinitionId: {
                location: "uri",
                locationName: "ConnectorDefinitionId"
              },
              Name: {}
            },
            required: [
              "ConnectorDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateCoreDefinition: {
          http: {
            method: "PUT",
            requestUri: "/greengrass/definition/cores/{CoreDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CoreDefinitionId: {
                location: "uri",
                locationName: "CoreDefinitionId"
              },
              Name: {}
            },
            required: [
              "CoreDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDeviceDefinition: {
          http: {
            method: "PUT",
            requestUri: "/greengrass/definition/devices/{DeviceDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeviceDefinitionId: {
                location: "uri",
                locationName: "DeviceDefinitionId"
              },
              Name: {}
            },
            required: [
              "DeviceDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateFunctionDefinition: {
          http: {
            method: "PUT",
            requestUri: "/greengrass/definition/functions/{FunctionDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              FunctionDefinitionId: {
                location: "uri",
                locationName: "FunctionDefinitionId"
              },
              Name: {}
            },
            required: [
              "FunctionDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateGroup: {
          http: {
            method: "PUT",
            requestUri: "/greengrass/groups/{GroupId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              },
              Name: {}
            },
            required: [
              "GroupId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateGroupCertificateConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/greengrass/groups/{GroupId}/certificateauthorities/configuration/expiry",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CertificateExpiryInMilliseconds: {},
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              }
            },
            required: [
              "GroupId"
            ]
          },
          output: {
            type: "structure",
            members: {
              CertificateAuthorityExpiryInMilliseconds: {},
              CertificateExpiryInMilliseconds: {},
              GroupId: {}
            }
          }
        },
        UpdateLoggerDefinition: {
          http: {
            method: "PUT",
            requestUri: "/greengrass/definition/loggers/{LoggerDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              LoggerDefinitionId: {
                location: "uri",
                locationName: "LoggerDefinitionId"
              },
              Name: {}
            },
            required: [
              "LoggerDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateResourceDefinition: {
          http: {
            method: "PUT",
            requestUri: "/greengrass/definition/resources/{ResourceDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Name: {},
              ResourceDefinitionId: {
                location: "uri",
                locationName: "ResourceDefinitionId"
              }
            },
            required: [
              "ResourceDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateSubscriptionDefinition: {
          http: {
            method: "PUT",
            requestUri: "/greengrass/definition/subscriptions/{SubscriptionDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Name: {},
              SubscriptionDefinitionId: {
                location: "uri",
                locationName: "SubscriptionDefinitionId"
              }
            },
            required: [
              "SubscriptionDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateThingRuntimeConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/greengrass/things/{ThingName}/runtimeconfig",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              TelemetryConfiguration: {
                type: "structure",
                members: {
                  Telemetry: {}
                },
                required: [
                  "Telemetry"
                ]
              },
              ThingName: {
                location: "uri",
                locationName: "ThingName"
              }
            },
            required: [
              "ThingName"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S7: {
          type: "structure",
          members: {
            Connectors: {
              shape: "S8"
            }
          }
        },
        S8: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ConnectorArn: {},
              Id: {},
              Parameters: {
                shape: "Sa"
              }
            },
            required: [
              "ConnectorArn",
              "Id"
            ]
          }
        },
        Sa: {
          type: "map",
          key: {},
          value: {}
        },
        Sb: {
          type: "map",
          key: {},
          value: {}
        },
        Sg: {
          type: "structure",
          members: {
            Cores: {
              shape: "Sh"
            }
          }
        },
        Sh: {
          type: "list",
          member: {
            type: "structure",
            members: {
              CertificateArn: {},
              Id: {},
              SyncShadow: {
                type: "boolean"
              },
              ThingArn: {}
            },
            required: [
              "ThingArn",
              "Id",
              "CertificateArn"
            ]
          }
        },
        Sr: {
          type: "structure",
          members: {
            Devices: {
              shape: "Ss"
            }
          }
        },
        Ss: {
          type: "list",
          member: {
            type: "structure",
            members: {
              CertificateArn: {},
              Id: {},
              SyncShadow: {
                type: "boolean"
              },
              ThingArn: {}
            },
            required: [
              "ThingArn",
              "Id",
              "CertificateArn"
            ]
          }
        },
        Sy: {
          type: "structure",
          members: {
            DefaultConfig: {
              shape: "Sz"
            },
            Functions: {
              shape: "S14"
            }
          }
        },
        Sz: {
          type: "structure",
          members: {
            Execution: {
              type: "structure",
              members: {
                IsolationMode: {},
                RunAs: {
                  shape: "S12"
                }
              }
            }
          }
        },
        S12: {
          type: "structure",
          members: {
            Gid: {
              type: "integer"
            },
            Uid: {
              type: "integer"
            }
          }
        },
        S14: {
          type: "list",
          member: {
            type: "structure",
            members: {
              FunctionArn: {},
              FunctionConfiguration: {
                type: "structure",
                members: {
                  EncodingType: {},
                  Environment: {
                    type: "structure",
                    members: {
                      AccessSysfs: {
                        type: "boolean"
                      },
                      Execution: {
                        type: "structure",
                        members: {
                          IsolationMode: {},
                          RunAs: {
                            shape: "S12"
                          }
                        }
                      },
                      ResourceAccessPolicies: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            Permission: {},
                            ResourceId: {}
                          },
                          required: [
                            "ResourceId"
                          ]
                        }
                      },
                      Variables: {
                        shape: "Sa"
                      }
                    }
                  },
                  ExecArgs: {},
                  Executable: {},
                  MemorySize: {
                    type: "integer"
                  },
                  Pinned: {
                    type: "boolean"
                  },
                  Timeout: {
                    type: "integer"
                  },
                  FunctionRuntimeOverride: {}
                }
              },
              Id: {}
            },
            required: [
              "Id"
            ]
          }
        },
        S1h: {
          type: "structure",
          members: {
            ConnectorDefinitionVersionArn: {},
            CoreDefinitionVersionArn: {},
            DeviceDefinitionVersionArn: {},
            FunctionDefinitionVersionArn: {},
            LoggerDefinitionVersionArn: {},
            ResourceDefinitionVersionArn: {},
            SubscriptionDefinitionVersionArn: {}
          }
        },
        S1o: {
          type: "structure",
          members: {
            Loggers: {
              shape: "S1p"
            }
          }
        },
        S1p: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Component: {},
              Id: {},
              Level: {},
              Space: {
                type: "integer"
              },
              Type: {}
            },
            required: [
              "Type",
              "Level",
              "Id",
              "Component"
            ]
          }
        },
        S1y: {
          type: "structure",
          members: {
            Resources: {
              shape: "S1z"
            }
          }
        },
        S1z: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Id: {},
              Name: {},
              ResourceDataContainer: {
                type: "structure",
                members: {
                  LocalDeviceResourceData: {
                    type: "structure",
                    members: {
                      GroupOwnerSetting: {
                        shape: "S23"
                      },
                      SourcePath: {}
                    }
                  },
                  LocalVolumeResourceData: {
                    type: "structure",
                    members: {
                      DestinationPath: {},
                      GroupOwnerSetting: {
                        shape: "S23"
                      },
                      SourcePath: {}
                    }
                  },
                  S3MachineLearningModelResourceData: {
                    type: "structure",
                    members: {
                      DestinationPath: {},
                      OwnerSetting: {
                        shape: "S26"
                      },
                      S3Uri: {}
                    }
                  },
                  SageMakerMachineLearningModelResourceData: {
                    type: "structure",
                    members: {
                      DestinationPath: {},
                      OwnerSetting: {
                        shape: "S26"
                      },
                      SageMakerJobArn: {}
                    }
                  },
                  SecretsManagerSecretResourceData: {
                    type: "structure",
                    members: {
                      ARN: {},
                      AdditionalStagingLabelsToDownload: {
                        shape: "S29"
                      }
                    }
                  }
                }
              }
            },
            required: [
              "ResourceDataContainer",
              "Id",
              "Name"
            ]
          }
        },
        S23: {
          type: "structure",
          members: {
            AutoAddGroupOwner: {
              type: "boolean"
            },
            GroupOwner: {}
          }
        },
        S26: {
          type: "structure",
          members: {
            GroupOwner: {},
            GroupPermission: {}
          },
          required: [
            "GroupOwner",
            "GroupPermission"
          ]
        },
        S29: {
          type: "list",
          member: {}
        },
        S2m: {
          type: "structure",
          members: {
            Subscriptions: {
              shape: "S2n"
            }
          }
        },
        S2n: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Id: {},
              Source: {},
              Subject: {},
              Target: {}
            },
            required: [
              "Target",
              "Id",
              "Subject",
              "Source"
            ]
          }
        },
        S3i: {
          type: "list",
          member: {
            type: "structure",
            members: {
              DetailedErrorCode: {},
              DetailedErrorMessage: {}
            }
          }
        },
        S3m: {
          type: "list",
          member: {
            type: "structure",
            members: {
              HostAddress: {},
              Id: {},
              Metadata: {},
              PortNumber: {
                type: "integer"
              }
            }
          }
        },
        S58: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              Version: {}
            }
          }
        },
        S5c: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {},
              Tags: {
                shape: "Sb",
                locationName: "tags"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/greengrass.js
var require_greengrass = __commonJS({
  "node_modules/aws-sdk/clients/greengrass.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["greengrass"] = {};
    AWS2.Greengrass = Service.defineService("greengrass", ["2017-06-07"]);
    Object.defineProperty(apiLoader.services["greengrass"], "2017-06-07", {
      get: function get() {
        var model = require_greengrass_2017_06_07_min();
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Greengrass;
  }
});

// node_modules/aws-sdk/apis/dax-2017-04-19.min.json
var require_dax_2017_04_19_min = __commonJS({
  "node_modules/aws-sdk/apis/dax-2017-04-19.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-04-19",
        endpointPrefix: "dax",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Amazon DAX",
        serviceFullName: "Amazon DynamoDB Accelerator (DAX)",
        serviceId: "DAX",
        signatureVersion: "v4",
        targetPrefix: "AmazonDAXV3",
        uid: "dax-2017-04-19"
      },
      operations: {
        CreateCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterName",
              "NodeType",
              "ReplicationFactor",
              "IamRoleArn"
            ],
            members: {
              ClusterName: {},
              NodeType: {},
              Description: {},
              ReplicationFactor: {
                type: "integer"
              },
              AvailabilityZones: {
                shape: "S4"
              },
              SubnetGroupName: {},
              SecurityGroupIds: {
                shape: "S5"
              },
              PreferredMaintenanceWindow: {},
              NotificationTopicArn: {},
              IamRoleArn: {},
              ParameterGroupName: {},
              Tags: {
                shape: "S6"
              },
              SSESpecification: {
                type: "structure",
                required: [
                  "Enabled"
                ],
                members: {
                  Enabled: {
                    type: "boolean"
                  }
                }
              },
              ClusterEndpointEncryptionType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                shape: "Sc"
              }
            }
          }
        },
        CreateParameterGroup: {
          input: {
            type: "structure",
            required: [
              "ParameterGroupName"
            ],
            members: {
              ParameterGroupName: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ParameterGroup: {
                shape: "Sr"
              }
            }
          }
        },
        CreateSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "SubnetGroupName",
              "SubnetIds"
            ],
            members: {
              SubnetGroupName: {},
              Description: {},
              SubnetIds: {
                shape: "St"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SubnetGroup: {
                shape: "Sv"
              }
            }
          }
        },
        DecreaseReplicationFactor: {
          input: {
            type: "structure",
            required: [
              "ClusterName",
              "NewReplicationFactor"
            ],
            members: {
              ClusterName: {},
              NewReplicationFactor: {
                type: "integer"
              },
              AvailabilityZones: {
                shape: "S4"
              },
              NodeIdsToRemove: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                shape: "Sc"
              }
            }
          }
        },
        DeleteCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterName"
            ],
            members: {
              ClusterName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                shape: "Sc"
              }
            }
          }
        },
        DeleteParameterGroup: {
          input: {
            type: "structure",
            required: [
              "ParameterGroupName"
            ],
            members: {
              ParameterGroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DeletionMessage: {}
            }
          }
        },
        DeleteSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "SubnetGroupName"
            ],
            members: {
              SubnetGroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DeletionMessage: {}
            }
          }
        },
        DescribeClusters: {
          input: {
            type: "structure",
            members: {
              ClusterNames: {
                type: "list",
                member: {}
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Clusters: {
                type: "list",
                member: {
                  shape: "Sc"
                }
              }
            }
          }
        },
        DescribeDefaultParameters: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Parameters: {
                shape: "S1c"
              }
            }
          }
        },
        DescribeEvents: {
          input: {
            type: "structure",
            members: {
              SourceName: {},
              SourceType: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Duration: {
                type: "integer"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Events: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SourceName: {},
                    SourceType: {},
                    Message: {},
                    Date: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeParameterGroups: {
          input: {
            type: "structure",
            members: {
              ParameterGroupNames: {
                type: "list",
                member: {}
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ParameterGroups: {
                type: "list",
                member: {
                  shape: "Sr"
                }
              }
            }
          }
        },
        DescribeParameters: {
          input: {
            type: "structure",
            required: [
              "ParameterGroupName"
            ],
            members: {
              ParameterGroupName: {},
              Source: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Parameters: {
                shape: "S1c"
              }
            }
          }
        },
        DescribeSubnetGroups: {
          input: {
            type: "structure",
            members: {
              SubnetGroupNames: {
                type: "list",
                member: {}
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              SubnetGroups: {
                type: "list",
                member: {
                  shape: "Sv"
                }
              }
            }
          }
        },
        IncreaseReplicationFactor: {
          input: {
            type: "structure",
            required: [
              "ClusterName",
              "NewReplicationFactor"
            ],
            members: {
              ClusterName: {},
              NewReplicationFactor: {
                type: "integer"
              },
              AvailabilityZones: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                shape: "Sc"
              }
            }
          }
        },
        ListTags: {
          input: {
            type: "structure",
            required: [
              "ResourceName"
            ],
            members: {
              ResourceName: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S6"
              },
              NextToken: {}
            }
          }
        },
        RebootNode: {
          input: {
            type: "structure",
            required: [
              "ClusterName",
              "NodeId"
            ],
            members: {
              ClusterName: {},
              NodeId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                shape: "Sc"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "Tags"
            ],
            members: {
              ResourceName: {},
              Tags: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S6"
              }
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "TagKeys"
            ],
            members: {
              ResourceName: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S6"
              }
            }
          }
        },
        UpdateCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterName"
            ],
            members: {
              ClusterName: {},
              Description: {},
              PreferredMaintenanceWindow: {},
              NotificationTopicArn: {},
              NotificationTopicStatus: {},
              ParameterGroupName: {},
              SecurityGroupIds: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                shape: "Sc"
              }
            }
          }
        },
        UpdateParameterGroup: {
          input: {
            type: "structure",
            required: [
              "ParameterGroupName",
              "ParameterNameValues"
            ],
            members: {
              ParameterGroupName: {},
              ParameterNameValues: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ParameterName: {},
                    ParameterValue: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ParameterGroup: {
                shape: "Sr"
              }
            }
          }
        },
        UpdateSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "SubnetGroupName"
            ],
            members: {
              SubnetGroupName: {},
              Description: {},
              SubnetIds: {
                shape: "St"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SubnetGroup: {
                shape: "Sv"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "list",
          member: {}
        },
        S5: {
          type: "list",
          member: {}
        },
        S6: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sc: {
          type: "structure",
          members: {
            ClusterName: {},
            Description: {},
            ClusterArn: {},
            TotalNodes: {
              type: "integer"
            },
            ActiveNodes: {
              type: "integer"
            },
            NodeType: {},
            Status: {},
            ClusterDiscoveryEndpoint: {
              shape: "Se"
            },
            NodeIdsToRemove: {
              shape: "Sf"
            },
            Nodes: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  NodeId: {},
                  Endpoint: {
                    shape: "Se"
                  },
                  NodeCreateTime: {
                    type: "timestamp"
                  },
                  AvailabilityZone: {},
                  NodeStatus: {},
                  ParameterGroupStatus: {}
                }
              }
            },
            PreferredMaintenanceWindow: {},
            NotificationConfiguration: {
              type: "structure",
              members: {
                TopicArn: {},
                TopicStatus: {}
              }
            },
            SubnetGroup: {},
            SecurityGroups: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  SecurityGroupIdentifier: {},
                  Status: {}
                }
              }
            },
            IamRoleArn: {},
            ParameterGroup: {
              type: "structure",
              members: {
                ParameterGroupName: {},
                ParameterApplyStatus: {},
                NodeIdsToReboot: {
                  shape: "Sf"
                }
              }
            },
            SSEDescription: {
              type: "structure",
              members: {
                Status: {}
              }
            },
            ClusterEndpointEncryptionType: {}
          }
        },
        Se: {
          type: "structure",
          members: {
            Address: {},
            Port: {
              type: "integer"
            },
            URL: {}
          }
        },
        Sf: {
          type: "list",
          member: {}
        },
        Sr: {
          type: "structure",
          members: {
            ParameterGroupName: {},
            Description: {}
          }
        },
        St: {
          type: "list",
          member: {}
        },
        Sv: {
          type: "structure",
          members: {
            SubnetGroupName: {},
            Description: {},
            VpcId: {},
            Subnets: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  SubnetIdentifier: {},
                  SubnetAvailabilityZone: {}
                }
              }
            }
          }
        },
        S1c: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ParameterName: {},
              ParameterType: {},
              ParameterValue: {},
              NodeTypeSpecificValues: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    NodeType: {},
                    Value: {}
                  }
                }
              },
              Description: {},
              Source: {},
              DataType: {},
              AllowedValues: {},
              IsModifiable: {},
              ChangeType: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/dax-2017-04-19.paginators.json
var require_dax_2017_04_19_paginators = __commonJS({
  "node_modules/aws-sdk/apis/dax-2017-04-19.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/dax.js
var require_dax = __commonJS({
  "node_modules/aws-sdk/clients/dax.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["dax"] = {};
    AWS2.DAX = Service.defineService("dax", ["2017-04-19"]);
    Object.defineProperty(apiLoader.services["dax"], "2017-04-19", {
      get: function get() {
        var model = require_dax_2017_04_19_min();
        model.paginators = require_dax_2017_04_19_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.DAX;
  }
});

// node_modules/aws-sdk/apis/AWSMigrationHub-2017-05-31.min.json
var require_AWSMigrationHub_2017_05_31_min = __commonJS({
  "node_modules/aws-sdk/apis/AWSMigrationHub-2017-05-31.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-05-31",
        endpointPrefix: "mgh",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Migration Hub",
        serviceId: "Migration Hub",
        signatureVersion: "v4",
        targetPrefix: "AWSMigrationHub",
        uid: "AWSMigrationHub-2017-05-31"
      },
      operations: {
        AssociateCreatedArtifact: {
          input: {
            type: "structure",
            required: [
              "ProgressUpdateStream",
              "MigrationTaskName",
              "CreatedArtifact"
            ],
            members: {
              ProgressUpdateStream: {},
              MigrationTaskName: {},
              CreatedArtifact: {
                shape: "S4"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateDiscoveredResource: {
          input: {
            type: "structure",
            required: [
              "ProgressUpdateStream",
              "MigrationTaskName",
              "DiscoveredResource"
            ],
            members: {
              ProgressUpdateStream: {},
              MigrationTaskName: {},
              DiscoveredResource: {
                shape: "Sa"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateProgressUpdateStream: {
          input: {
            type: "structure",
            required: [
              "ProgressUpdateStreamName"
            ],
            members: {
              ProgressUpdateStreamName: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteProgressUpdateStream: {
          input: {
            type: "structure",
            required: [
              "ProgressUpdateStreamName"
            ],
            members: {
              ProgressUpdateStreamName: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeApplicationState: {
          input: {
            type: "structure",
            required: [
              "ApplicationId"
            ],
            members: {
              ApplicationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationStatus: {},
              LastUpdatedTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeMigrationTask: {
          input: {
            type: "structure",
            required: [
              "ProgressUpdateStream",
              "MigrationTaskName"
            ],
            members: {
              ProgressUpdateStream: {},
              MigrationTaskName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MigrationTask: {
                type: "structure",
                members: {
                  ProgressUpdateStream: {},
                  MigrationTaskName: {},
                  Task: {
                    shape: "Sq"
                  },
                  UpdateDateTime: {
                    type: "timestamp"
                  },
                  ResourceAttributeList: {
                    type: "list",
                    member: {
                      shape: "Sv"
                    }
                  }
                }
              }
            }
          }
        },
        DisassociateCreatedArtifact: {
          input: {
            type: "structure",
            required: [
              "ProgressUpdateStream",
              "MigrationTaskName",
              "CreatedArtifactName"
            ],
            members: {
              ProgressUpdateStream: {},
              MigrationTaskName: {},
              CreatedArtifactName: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateDiscoveredResource: {
          input: {
            type: "structure",
            required: [
              "ProgressUpdateStream",
              "MigrationTaskName",
              "ConfigurationId"
            ],
            members: {
              ProgressUpdateStream: {},
              MigrationTaskName: {},
              ConfigurationId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ImportMigrationTask: {
          input: {
            type: "structure",
            required: [
              "ProgressUpdateStream",
              "MigrationTaskName"
            ],
            members: {
              ProgressUpdateStream: {},
              MigrationTaskName: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ListApplicationStates: {
          input: {
            type: "structure",
            members: {
              ApplicationIds: {
                type: "list",
                member: {}
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationStateList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApplicationId: {},
                    ApplicationStatus: {},
                    LastUpdatedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListCreatedArtifacts: {
          input: {
            type: "structure",
            required: [
              "ProgressUpdateStream",
              "MigrationTaskName"
            ],
            members: {
              ProgressUpdateStream: {},
              MigrationTaskName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              CreatedArtifactList: {
                type: "list",
                member: {
                  shape: "S4"
                }
              }
            }
          }
        },
        ListDiscoveredResources: {
          input: {
            type: "structure",
            required: [
              "ProgressUpdateStream",
              "MigrationTaskName"
            ],
            members: {
              ProgressUpdateStream: {},
              MigrationTaskName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              DiscoveredResourceList: {
                type: "list",
                member: {
                  shape: "Sa"
                }
              }
            }
          }
        },
        ListMigrationTasks: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ResourceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              MigrationTaskSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ProgressUpdateStream: {},
                    MigrationTaskName: {},
                    Status: {},
                    ProgressPercent: {
                      type: "integer"
                    },
                    StatusDetail: {},
                    UpdateDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListProgressUpdateStreams: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProgressUpdateStreamSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ProgressUpdateStreamName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        NotifyApplicationState: {
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "Status"
            ],
            members: {
              ApplicationId: {},
              Status: {},
              UpdateDateTime: {
                type: "timestamp"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        NotifyMigrationTaskState: {
          input: {
            type: "structure",
            required: [
              "ProgressUpdateStream",
              "MigrationTaskName",
              "Task",
              "UpdateDateTime",
              "NextUpdateSeconds"
            ],
            members: {
              ProgressUpdateStream: {},
              MigrationTaskName: {},
              Task: {
                shape: "Sq"
              },
              UpdateDateTime: {
                type: "timestamp"
              },
              NextUpdateSeconds: {
                type: "integer"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutResourceAttributes: {
          input: {
            type: "structure",
            required: [
              "ProgressUpdateStream",
              "MigrationTaskName",
              "ResourceAttributeList"
            ],
            members: {
              ProgressUpdateStream: {},
              MigrationTaskName: {},
              ResourceAttributeList: {
                type: "list",
                member: {
                  shape: "Sv"
                }
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            Description: {}
          }
        },
        Sa: {
          type: "structure",
          required: [
            "ConfigurationId"
          ],
          members: {
            ConfigurationId: {},
            Description: {}
          }
        },
        Sq: {
          type: "structure",
          required: [
            "Status"
          ],
          members: {
            Status: {},
            StatusDetail: {},
            ProgressPercent: {
              type: "integer"
            }
          }
        },
        Sv: {
          type: "structure",
          required: [
            "Type",
            "Value"
          ],
          members: {
            Type: {},
            Value: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/AWSMigrationHub-2017-05-31.paginators.json
var require_AWSMigrationHub_2017_05_31_paginators = __commonJS({
  "node_modules/aws-sdk/apis/AWSMigrationHub-2017-05-31.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListApplicationStates: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ApplicationStateList"
        },
        ListCreatedArtifacts: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "CreatedArtifactList"
        },
        ListDiscoveredResources: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "DiscoveredResourceList"
        },
        ListMigrationTasks: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "MigrationTaskSummaryList"
        },
        ListProgressUpdateStreams: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ProgressUpdateStreamSummaryList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/migrationhub.js
var require_migrationhub = __commonJS({
  "node_modules/aws-sdk/clients/migrationhub.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["migrationhub"] = {};
    AWS2.MigrationHub = Service.defineService("migrationhub", ["2017-05-31"]);
    Object.defineProperty(apiLoader.services["migrationhub"], "2017-05-31", {
      get: function get() {
        var model = require_AWSMigrationHub_2017_05_31_min();
        model.paginators = require_AWSMigrationHub_2017_05_31_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.MigrationHub;
  }
});

// node_modules/aws-sdk/apis/cloudhsmv2-2017-04-28.min.json
var require_cloudhsmv2_2017_04_28_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudhsmv2-2017-04-28.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-04-28",
        endpointPrefix: "cloudhsmv2",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "CloudHSM V2",
        serviceFullName: "AWS CloudHSM V2",
        serviceId: "CloudHSM V2",
        signatureVersion: "v4",
        signingName: "cloudhsm",
        targetPrefix: "BaldrApiService",
        uid: "cloudhsmv2-2017-04-28"
      },
      operations: {
        CopyBackupToRegion: {
          input: {
            type: "structure",
            required: [
              "DestinationRegion",
              "BackupId"
            ],
            members: {
              DestinationRegion: {},
              BackupId: {},
              TagList: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DestinationBackup: {
                type: "structure",
                members: {
                  CreateTimestamp: {
                    type: "timestamp"
                  },
                  SourceRegion: {},
                  SourceBackup: {},
                  SourceCluster: {}
                }
              }
            }
          }
        },
        CreateCluster: {
          input: {
            type: "structure",
            required: [
              "HsmType",
              "SubnetIds"
            ],
            members: {
              BackupRetentionPolicy: {
                shape: "Sd"
              },
              HsmType: {},
              SourceBackupId: {},
              SubnetIds: {
                type: "list",
                member: {}
              },
              TagList: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                shape: "Sk"
              }
            }
          }
        },
        CreateHsm: {
          input: {
            type: "structure",
            required: [
              "ClusterId",
              "AvailabilityZone"
            ],
            members: {
              ClusterId: {},
              AvailabilityZone: {},
              IpAddress: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Hsm: {
                shape: "Sn"
              }
            }
          }
        },
        DeleteBackup: {
          input: {
            type: "structure",
            required: [
              "BackupId"
            ],
            members: {
              BackupId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Backup: {
                shape: "S16"
              }
            }
          }
        },
        DeleteCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                shape: "Sk"
              }
            }
          }
        },
        DeleteHsm: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {},
              HsmId: {},
              EniId: {},
              EniIp: {}
            }
          },
          output: {
            type: "structure",
            members: {
              HsmId: {}
            }
          }
        },
        DescribeBackups: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S1g"
              },
              SortAscending: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Backups: {
                type: "list",
                member: {
                  shape: "S16"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeClusters: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S1g"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Clusters: {
                type: "list",
                member: {
                  shape: "Sk"
                }
              },
              NextToken: {}
            }
          }
        },
        InitializeCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterId",
              "SignedCert",
              "TrustAnchor"
            ],
            members: {
              ClusterId: {},
              SignedCert: {},
              TrustAnchor: {}
            }
          },
          output: {
            type: "structure",
            members: {
              State: {},
              StateMessage: {}
            }
          }
        },
        ListTags: {
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              ResourceId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TagList"
            ],
            members: {
              TagList: {
                shape: "S4"
              },
              NextToken: {}
            }
          }
        },
        ModifyBackupAttributes: {
          input: {
            type: "structure",
            required: [
              "BackupId",
              "NeverExpires"
            ],
            members: {
              BackupId: {},
              NeverExpires: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Backup: {
                shape: "S16"
              }
            }
          }
        },
        ModifyCluster: {
          input: {
            type: "structure",
            required: [
              "BackupRetentionPolicy",
              "ClusterId"
            ],
            members: {
              BackupRetentionPolicy: {
                shape: "Sd"
              },
              ClusterId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                shape: "Sk"
              }
            }
          }
        },
        RestoreBackup: {
          input: {
            type: "structure",
            required: [
              "BackupId"
            ],
            members: {
              BackupId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Backup: {
                shape: "S16"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "TagList"
            ],
            members: {
              ResourceId: {},
              TagList: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "TagKeyList"
            ],
            members: {
              ResourceId: {},
              TagKeyList: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S4: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sd: {
          type: "structure",
          members: {
            Type: {},
            Value: {}
          }
        },
        Sk: {
          type: "structure",
          members: {
            BackupPolicy: {},
            BackupRetentionPolicy: {
              shape: "Sd"
            },
            ClusterId: {},
            CreateTimestamp: {
              type: "timestamp"
            },
            Hsms: {
              type: "list",
              member: {
                shape: "Sn"
              }
            },
            HsmType: {},
            PreCoPassword: {},
            SecurityGroup: {},
            SourceBackupId: {},
            State: {},
            StateMessage: {},
            SubnetMapping: {
              type: "map",
              key: {},
              value: {}
            },
            VpcId: {},
            Certificates: {
              type: "structure",
              members: {
                ClusterCsr: {},
                HsmCertificate: {},
                AwsHardwareCertificate: {},
                ManufacturerHardwareCertificate: {},
                ClusterCertificate: {}
              }
            },
            TagList: {
              shape: "S4"
            }
          }
        },
        Sn: {
          type: "structure",
          required: [
            "HsmId"
          ],
          members: {
            AvailabilityZone: {},
            ClusterId: {},
            SubnetId: {},
            EniId: {},
            EniIp: {},
            HsmId: {},
            State: {},
            StateMessage: {}
          }
        },
        S16: {
          type: "structure",
          required: [
            "BackupId"
          ],
          members: {
            BackupId: {},
            BackupState: {},
            ClusterId: {},
            CreateTimestamp: {
              type: "timestamp"
            },
            CopyTimestamp: {
              type: "timestamp"
            },
            NeverExpires: {
              type: "boolean"
            },
            SourceRegion: {},
            SourceBackup: {},
            SourceCluster: {},
            DeleteTimestamp: {
              type: "timestamp"
            },
            TagList: {
              shape: "S4"
            }
          }
        },
        S1g: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudhsmv2-2017-04-28.paginators.json
var require_cloudhsmv2_2017_04_28_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloudhsmv2-2017-04-28.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeBackups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeClusters: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListTags: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/cloudhsmv2.js
var require_cloudhsmv2 = __commonJS({
  "node_modules/aws-sdk/clients/cloudhsmv2.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["cloudhsmv2"] = {};
    AWS2.CloudHSMV2 = Service.defineService("cloudhsmv2", ["2017-04-28"]);
    Object.defineProperty(apiLoader.services["cloudhsmv2"], "2017-04-28", {
      get: function get() {
        var model = require_cloudhsmv2_2017_04_28_min();
        model.paginators = require_cloudhsmv2_2017_04_28_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CloudHSMV2;
  }
});

// node_modules/aws-sdk/apis/glue-2017-03-31.min.json
var require_glue_2017_03_31_min = __commonJS({
  "node_modules/aws-sdk/apis/glue-2017-03-31.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-03-31",
        endpointPrefix: "glue",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Glue",
        serviceId: "Glue",
        signatureVersion: "v4",
        targetPrefix: "AWSGlue",
        uid: "glue-2017-03-31"
      },
      operations: {
        BatchCreatePartition: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "PartitionInputList"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              PartitionInputList: {
                type: "list",
                member: {
                  shape: "S5"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Errors: {
                shape: "S12"
              }
            }
          }
        },
        BatchDeleteConnection: {
          input: {
            type: "structure",
            required: [
              "ConnectionNameList"
            ],
            members: {
              CatalogId: {},
              ConnectionNameList: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Succeeded: {
                shape: "Sn"
              },
              Errors: {
                type: "map",
                key: {},
                value: {
                  shape: "S14"
                }
              }
            }
          }
        },
        BatchDeletePartition: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "PartitionsToDelete"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              PartitionsToDelete: {
                type: "list",
                member: {
                  shape: "S1c"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Errors: {
                shape: "S12"
              }
            }
          }
        },
        BatchDeleteTable: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TablesToDelete"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TablesToDelete: {
                type: "list",
                member: {}
              },
              TransactionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TableName: {},
                    ErrorDetail: {
                      shape: "S14"
                    }
                  }
                }
              }
            }
          }
        },
        BatchDeleteTableVersion: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "VersionIds"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              VersionIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TableName: {},
                    VersionId: {},
                    ErrorDetail: {
                      shape: "S14"
                    }
                  }
                }
              }
            }
          }
        },
        BatchGetBlueprints: {
          input: {
            type: "structure",
            required: [
              "Names"
            ],
            members: {
              Names: {
                type: "list",
                member: {}
              },
              IncludeBlueprint: {
                type: "boolean"
              },
              IncludeParameterSpec: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Blueprints: {
                type: "list",
                member: {
                  shape: "S1w"
                }
              },
              MissingBlueprints: {
                shape: "S24"
              }
            }
          }
        },
        BatchGetCrawlers: {
          input: {
            type: "structure",
            required: [
              "CrawlerNames"
            ],
            members: {
              CrawlerNames: {
                shape: "S26"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Crawlers: {
                shape: "S28"
              },
              CrawlersNotFound: {
                shape: "S26"
              }
            }
          }
        },
        BatchGetCustomEntityTypes: {
          input: {
            type: "structure",
            required: [
              "Names"
            ],
            members: {
              Names: {
                shape: "S3r"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CustomEntityTypes: {
                shape: "S3t"
              },
              CustomEntityTypesNotFound: {
                shape: "S3r"
              }
            }
          }
        },
        BatchGetDataQualityResult: {
          input: {
            type: "structure",
            required: [
              "ResultIds"
            ],
            members: {
              ResultIds: {
                shape: "S3x"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Results"
            ],
            members: {
              Results: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResultId: {},
                    Score: {
                      type: "double"
                    },
                    DataSource: {
                      shape: "S43"
                    },
                    RulesetName: {},
                    EvaluationContext: {},
                    StartedOn: {
                      type: "timestamp"
                    },
                    CompletedOn: {
                      type: "timestamp"
                    },
                    JobName: {},
                    JobRunId: {},
                    RulesetEvaluationRunId: {},
                    RuleResults: {
                      shape: "S46"
                    },
                    AnalyzerResults: {
                      shape: "S4b"
                    },
                    Observations: {
                      shape: "S4d"
                    }
                  }
                }
              },
              ResultsNotFound: {
                shape: "S3x"
              }
            }
          }
        },
        BatchGetDevEndpoints: {
          input: {
            type: "structure",
            required: [
              "DevEndpointNames"
            ],
            members: {
              DevEndpointNames: {
                shape: "S4k"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DevEndpoints: {
                shape: "S4m"
              },
              DevEndpointsNotFound: {
                shape: "S4k"
              }
            }
          }
        },
        BatchGetJobs: {
          input: {
            type: "structure",
            required: [
              "JobNames"
            ],
            members: {
              JobNames: {
                shape: "S4w"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Jobs: {
                shape: "S4y"
              },
              JobsNotFound: {
                shape: "S4w"
              }
            }
          }
        },
        BatchGetPartition: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "PartitionsToGet"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              PartitionsToGet: {
                shape: "Sad"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Partitions: {
                shape: "Saf"
              },
              UnprocessedKeys: {
                shape: "Sad"
              }
            }
          }
        },
        BatchGetTableOptimizer: {
          input: {
            type: "structure",
            required: [
              "Entries"
            ],
            members: {
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    catalogId: {},
                    databaseName: {},
                    tableName: {},
                    type: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TableOptimizers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    catalogId: {},
                    databaseName: {},
                    tableName: {},
                    tableOptimizer: {
                      shape: "Saq"
                    }
                  }
                }
              },
              Failures: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    error: {
                      shape: "S14"
                    },
                    catalogId: {},
                    databaseName: {},
                    tableName: {},
                    type: {}
                  }
                }
              }
            }
          }
        },
        BatchGetTriggers: {
          input: {
            type: "structure",
            required: [
              "TriggerNames"
            ],
            members: {
              TriggerNames: {
                shape: "Sb1"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Triggers: {
                shape: "Sb3"
              },
              TriggersNotFound: {
                shape: "Sb1"
              }
            }
          }
        },
        BatchGetWorkflows: {
          input: {
            type: "structure",
            required: [
              "Names"
            ],
            members: {
              Names: {
                shape: "Sbl"
              },
              IncludeGraph: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Workflows: {
                type: "list",
                member: {
                  shape: "Sbo"
                }
              },
              MissingWorkflows: {
                shape: "Sbl"
              }
            }
          }
        },
        BatchStopJobRun: {
          input: {
            type: "structure",
            required: [
              "JobName",
              "JobRunIds"
            ],
            members: {
              JobName: {},
              JobRunIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SuccessfulSubmissions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    JobName: {},
                    JobRunId: {}
                  }
                }
              },
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    JobName: {},
                    JobRunId: {},
                    ErrorDetail: {
                      shape: "S14"
                    }
                  }
                }
              }
            }
          }
        },
        BatchUpdatePartition: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "Entries"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "PartitionValueList",
                    "PartitionInput"
                  ],
                  members: {
                    PartitionValueList: {
                      shape: "Scm"
                    },
                    PartitionInput: {
                      shape: "S5"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PartitionValueList: {
                      shape: "Scm"
                    },
                    ErrorDetail: {
                      shape: "S14"
                    }
                  }
                }
              }
            }
          }
        },
        CancelDataQualityRuleRecommendationRun: {
          input: {
            type: "structure",
            required: [
              "RunId"
            ],
            members: {
              RunId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CancelDataQualityRulesetEvaluationRun: {
          input: {
            type: "structure",
            required: [
              "RunId"
            ],
            members: {
              RunId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CancelMLTaskRun: {
          input: {
            type: "structure",
            required: [
              "TransformId",
              "TaskRunId"
            ],
            members: {
              TransformId: {},
              TaskRunId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TransformId: {},
              TaskRunId: {},
              Status: {}
            }
          }
        },
        CancelStatement: {
          input: {
            type: "structure",
            required: [
              "SessionId",
              "Id"
            ],
            members: {
              SessionId: {},
              Id: {
                type: "integer"
              },
              RequestOrigin: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CheckSchemaVersionValidity: {
          input: {
            type: "structure",
            required: [
              "DataFormat",
              "SchemaDefinition"
            ],
            members: {
              DataFormat: {},
              SchemaDefinition: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Valid: {
                type: "boolean"
              },
              Error: {}
            }
          }
        },
        CreateBlueprint: {
          input: {
            type: "structure",
            required: [
              "Name",
              "BlueprintLocation"
            ],
            members: {
              Name: {},
              Description: {},
              BlueprintLocation: {},
              Tags: {
                shape: "Sd7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {}
            }
          }
        },
        CreateClassifier: {
          input: {
            type: "structure",
            members: {
              GrokClassifier: {
                type: "structure",
                required: [
                  "Classification",
                  "Name",
                  "GrokPattern"
                ],
                members: {
                  Classification: {},
                  Name: {},
                  GrokPattern: {},
                  CustomPatterns: {}
                }
              },
              XMLClassifier: {
                type: "structure",
                required: [
                  "Classification",
                  "Name"
                ],
                members: {
                  Classification: {},
                  Name: {},
                  RowTag: {}
                }
              },
              JsonClassifier: {
                type: "structure",
                required: [
                  "Name",
                  "JsonPath"
                ],
                members: {
                  Name: {},
                  JsonPath: {}
                }
              },
              CsvClassifier: {
                type: "structure",
                required: [
                  "Name"
                ],
                members: {
                  Name: {},
                  Delimiter: {},
                  QuoteSymbol: {},
                  ContainsHeader: {},
                  Header: {
                    shape: "Sdo"
                  },
                  DisableValueTrimming: {
                    type: "boolean"
                  },
                  AllowSingleColumn: {
                    type: "boolean"
                  },
                  CustomDatatypeConfigured: {
                    type: "boolean"
                  },
                  CustomDatatypes: {
                    shape: "Sdp"
                  },
                  Serde: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateConnection: {
          input: {
            type: "structure",
            required: [
              "ConnectionInput"
            ],
            members: {
              CatalogId: {},
              ConnectionInput: {
                shape: "Sdt"
              },
              Tags: {
                shape: "Sd7"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateCrawler: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Role",
              "Targets"
            ],
            members: {
              Name: {},
              Role: {},
              DatabaseName: {},
              Description: {},
              Targets: {
                shape: "S2b"
              },
              Schedule: {},
              Classifiers: {
                shape: "S32"
              },
              TablePrefix: {},
              SchemaChangePolicy: {
                shape: "S35"
              },
              RecrawlPolicy: {
                shape: "S33"
              },
              LineageConfiguration: {
                shape: "S38"
              },
              LakeFormationConfiguration: {
                shape: "S3o"
              },
              Configuration: {},
              CrawlerSecurityConfiguration: {},
              Tags: {
                shape: "Sd7"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateCustomEntityType: {
          input: {
            type: "structure",
            required: [
              "Name",
              "RegexString"
            ],
            members: {
              Name: {},
              RegexString: {},
              ContextWords: {
                shape: "S3v"
              },
              Tags: {
                shape: "Sd7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {}
            }
          }
        },
        CreateDataQualityRuleset: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Ruleset"
            ],
            members: {
              Name: {},
              Description: {},
              Ruleset: {},
              Tags: {
                shape: "Sd7"
              },
              TargetTable: {
                shape: "Se7"
              },
              ClientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {}
            }
          },
          idempotent: true
        },
        CreateDatabase: {
          input: {
            type: "structure",
            required: [
              "DatabaseInput"
            ],
            members: {
              CatalogId: {},
              DatabaseInput: {
                shape: "Sea"
              },
              Tags: {
                shape: "Sd7"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateDevEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointName",
              "RoleArn"
            ],
            members: {
              EndpointName: {},
              RoleArn: {},
              SecurityGroupIds: {
                shape: "S4p"
              },
              SubnetId: {},
              PublicKey: {},
              PublicKeys: {
                shape: "S4t"
              },
              NumberOfNodes: {
                type: "integer"
              },
              WorkerType: {},
              GlueVersion: {},
              NumberOfWorkers: {
                type: "integer"
              },
              ExtraPythonLibsS3Path: {},
              ExtraJarsS3Path: {},
              SecurityConfiguration: {},
              Tags: {
                shape: "Sd7"
              },
              Arguments: {
                shape: "S4u"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EndpointName: {},
              Status: {},
              SecurityGroupIds: {
                shape: "S4p"
              },
              SubnetId: {},
              RoleArn: {},
              YarnEndpointAddress: {},
              ZeppelinRemoteSparkInterpreterPort: {
                type: "integer"
              },
              NumberOfNodes: {
                type: "integer"
              },
              WorkerType: {},
              GlueVersion: {},
              NumberOfWorkers: {
                type: "integer"
              },
              AvailabilityZone: {},
              VpcId: {},
              ExtraPythonLibsS3Path: {},
              ExtraJarsS3Path: {},
              FailureReason: {},
              SecurityConfiguration: {},
              CreatedTimestamp: {
                type: "timestamp"
              },
              Arguments: {
                shape: "S4u"
              }
            }
          }
        },
        CreateJob: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Role",
              "Command"
            ],
            members: {
              Name: {},
              Description: {},
              LogUri: {},
              Role: {},
              ExecutionProperty: {
                shape: "S52"
              },
              Command: {
                shape: "S54"
              },
              DefaultArguments: {
                shape: "S58"
              },
              NonOverridableArguments: {
                shape: "S58"
              },
              Connections: {
                shape: "S59"
              },
              MaxRetries: {
                type: "integer"
              },
              AllocatedCapacity: {
                deprecated: true,
                deprecatedMessage: "This property is deprecated, use MaxCapacity instead.",
                type: "integer"
              },
              Timeout: {
                type: "integer"
              },
              MaxCapacity: {
                type: "double"
              },
              SecurityConfiguration: {},
              Tags: {
                shape: "Sd7"
              },
              NotificationProperty: {
                shape: "S5d"
              },
              GlueVersion: {},
              NumberOfWorkers: {
                type: "integer"
              },
              WorkerType: {},
              CodeGenConfigurationNodes: {
                shape: "S5f"
              },
              ExecutionClass: {},
              SourceControlDetails: {
                shape: "Sa9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {}
            }
          }
        },
        CreateMLTransform: {
          input: {
            type: "structure",
            required: [
              "Name",
              "InputRecordTables",
              "Parameters",
              "Role"
            ],
            members: {
              Name: {},
              Description: {},
              InputRecordTables: {
                shape: "Ser"
              },
              Parameters: {
                shape: "Ses"
              },
              Role: {},
              GlueVersion: {},
              MaxCapacity: {
                type: "double"
              },
              WorkerType: {},
              NumberOfWorkers: {
                type: "integer"
              },
              Timeout: {
                type: "integer"
              },
              MaxRetries: {
                type: "integer"
              },
              Tags: {
                shape: "Sd7"
              },
              TransformEncryption: {
                shape: "Sew"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransformId: {}
            }
          }
        },
        CreatePartition: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "PartitionInput"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              PartitionInput: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreatePartitionIndex: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "PartitionIndex"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              PartitionIndex: {
                shape: "Sf3"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateRegistry: {
          input: {
            type: "structure",
            required: [
              "RegistryName"
            ],
            members: {
              RegistryName: {},
              Description: {},
              Tags: {
                shape: "Sd7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RegistryArn: {},
              RegistryName: {},
              Description: {},
              Tags: {
                shape: "Sd7"
              }
            }
          }
        },
        CreateSchema: {
          input: {
            type: "structure",
            required: [
              "SchemaName",
              "DataFormat"
            ],
            members: {
              RegistryId: {
                shape: "Sf9"
              },
              SchemaName: {},
              DataFormat: {},
              Compatibility: {},
              Description: {},
              Tags: {
                shape: "Sd7"
              },
              SchemaDefinition: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RegistryName: {},
              RegistryArn: {},
              SchemaName: {},
              SchemaArn: {},
              Description: {},
              DataFormat: {},
              Compatibility: {},
              SchemaCheckpoint: {
                type: "long"
              },
              LatestSchemaVersion: {
                type: "long"
              },
              NextSchemaVersion: {
                type: "long"
              },
              SchemaStatus: {},
              Tags: {
                shape: "Sd7"
              },
              SchemaVersionId: {},
              SchemaVersionStatus: {}
            }
          }
        },
        CreateScript: {
          input: {
            type: "structure",
            members: {
              DagNodes: {
                shape: "Sfg"
              },
              DagEdges: {
                shape: "Sfo"
              },
              Language: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PythonScript: {},
              ScalaCode: {}
            }
          }
        },
        CreateSecurityConfiguration: {
          input: {
            type: "structure",
            required: [
              "Name",
              "EncryptionConfiguration"
            ],
            members: {
              Name: {},
              EncryptionConfiguration: {
                shape: "Sfv"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              CreatedTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        CreateSession: {
          input: {
            type: "structure",
            required: [
              "Id",
              "Role",
              "Command"
            ],
            members: {
              Id: {},
              Description: {},
              Role: {},
              Command: {
                shape: "Sg7"
              },
              Timeout: {
                type: "integer"
              },
              IdleTimeout: {
                type: "integer"
              },
              DefaultArguments: {
                shape: "Sg8"
              },
              Connections: {
                shape: "S59"
              },
              MaxCapacity: {
                type: "double"
              },
              NumberOfWorkers: {
                type: "integer"
              },
              WorkerType: {},
              SecurityConfiguration: {},
              GlueVersion: {},
              Tags: {
                shape: "Sd7"
              },
              RequestOrigin: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Session: {
                shape: "Sgb"
              }
            }
          }
        },
        CreateTable: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableInput"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableInput: {
                shape: "Sgg"
              },
              PartitionIndexes: {
                type: "list",
                member: {
                  shape: "Sf3"
                }
              },
              TransactionId: {},
              OpenTableFormatInput: {
                type: "structure",
                members: {
                  IcebergInput: {
                    type: "structure",
                    required: [
                      "MetadataOperation"
                    ],
                    members: {
                      MetadataOperation: {},
                      Version: {}
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateTableOptimizer: {
          input: {
            type: "structure",
            required: [
              "CatalogId",
              "DatabaseName",
              "TableName",
              "Type",
              "TableOptimizerConfiguration"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              Type: {},
              TableOptimizerConfiguration: {
                shape: "Sar"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateTrigger: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Type",
              "Actions"
            ],
            members: {
              Name: {},
              WorkflowName: {},
              Type: {},
              Schedule: {},
              Predicate: {
                shape: "Sba"
              },
              Actions: {
                shape: "Sb8"
              },
              Description: {},
              StartOnCreation: {
                type: "boolean"
              },
              Tags: {
                shape: "Sd7"
              },
              EventBatchingCondition: {
                shape: "Sbh"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {}
            }
          }
        },
        CreateUserDefinedFunction: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "FunctionInput"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              FunctionInput: {
                shape: "Sgv"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateWorkflow: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Description: {},
              DefaultRunProperties: {
                shape: "Sbp"
              },
              Tags: {
                shape: "Sd7"
              },
              MaxConcurrentRuns: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {}
            }
          }
        },
        DeleteBlueprint: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {}
            }
          }
        },
        DeleteClassifier: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteColumnStatisticsForPartition: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "PartitionValues",
              "ColumnName"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              PartitionValues: {
                shape: "S6"
              },
              ColumnName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteColumnStatisticsForTable: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "ColumnName"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              ColumnName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteConnection: {
          input: {
            type: "structure",
            required: [
              "ConnectionName"
            ],
            members: {
              CatalogId: {},
              ConnectionName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteCrawler: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteCustomEntityType: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {}
            }
          }
        },
        DeleteDataQualityRuleset: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDatabase: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              CatalogId: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDevEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointName"
            ],
            members: {
              EndpointName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteJob: {
          input: {
            type: "structure",
            required: [
              "JobName"
            ],
            members: {
              JobName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobName: {}
            }
          }
        },
        DeleteMLTransform: {
          input: {
            type: "structure",
            required: [
              "TransformId"
            ],
            members: {
              TransformId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TransformId: {}
            }
          }
        },
        DeletePartition: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "PartitionValues"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              PartitionValues: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeletePartitionIndex: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "IndexName"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              IndexName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRegistry: {
          input: {
            type: "structure",
            required: [
              "RegistryId"
            ],
            members: {
              RegistryId: {
                shape: "Sf9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RegistryName: {},
              RegistryArn: {},
              Status: {}
            }
          }
        },
        DeleteResourcePolicy: {
          input: {
            type: "structure",
            members: {
              PolicyHashCondition: {},
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSchema: {
          input: {
            type: "structure",
            required: [
              "SchemaId"
            ],
            members: {
              SchemaId: {
                shape: "Sw"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArn: {},
              SchemaName: {},
              Status: {}
            }
          }
        },
        DeleteSchemaVersions: {
          input: {
            type: "structure",
            required: [
              "SchemaId",
              "Versions"
            ],
            members: {
              SchemaId: {
                shape: "Sw"
              },
              Versions: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaVersionErrors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    VersionNumber: {
                      type: "long"
                    },
                    ErrorDetails: {
                      type: "structure",
                      members: {
                        ErrorCode: {},
                        ErrorMessage: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DeleteSecurityConfiguration: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSession: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {},
              RequestOrigin: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {}
            }
          }
        },
        DeleteTable: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "Name"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              Name: {},
              TransactionId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteTableOptimizer: {
          input: {
            type: "structure",
            required: [
              "CatalogId",
              "DatabaseName",
              "TableName",
              "Type"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              Type: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteTableVersion: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "VersionId"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              VersionId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteTrigger: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {}
            }
          }
        },
        DeleteUserDefinedFunction: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "FunctionName"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              FunctionName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteWorkflow: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {}
            }
          }
        },
        GetBlueprint: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              IncludeBlueprint: {
                type: "boolean"
              },
              IncludeParameterSpec: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Blueprint: {
                shape: "S1w"
              }
            }
          }
        },
        GetBlueprintRun: {
          input: {
            type: "structure",
            required: [
              "BlueprintName",
              "RunId"
            ],
            members: {
              BlueprintName: {},
              RunId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BlueprintRun: {
                shape: "Siu"
              }
            }
          }
        },
        GetBlueprintRuns: {
          input: {
            type: "structure",
            required: [
              "BlueprintName"
            ],
            members: {
              BlueprintName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BlueprintRuns: {
                type: "list",
                member: {
                  shape: "Siu"
                }
              },
              NextToken: {}
            }
          }
        },
        GetCatalogImportStatus: {
          input: {
            type: "structure",
            members: {
              CatalogId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ImportStatus: {
                type: "structure",
                members: {
                  ImportCompleted: {
                    type: "boolean"
                  },
                  ImportTime: {
                    type: "timestamp"
                  },
                  ImportedBy: {}
                }
              }
            }
          }
        },
        GetClassifier: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Classifier: {
                shape: "Sj7"
              }
            }
          }
        },
        GetClassifiers: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Classifiers: {
                type: "list",
                member: {
                  shape: "Sj7"
                }
              },
              NextToken: {}
            }
          }
        },
        GetColumnStatisticsForPartition: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "PartitionValues",
              "ColumnNames"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              PartitionValues: {
                shape: "S6"
              },
              ColumnNames: {
                shape: "Sjh"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ColumnStatisticsList: {
                shape: "Sjj"
              },
              Errors: {
                shape: "Sk1"
              }
            }
          }
        },
        GetColumnStatisticsForTable: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "ColumnNames"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              ColumnNames: {
                shape: "Sjh"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ColumnStatisticsList: {
                shape: "Sjj"
              },
              Errors: {
                shape: "Sk1"
              }
            }
          }
        },
        GetColumnStatisticsTaskRun: {
          input: {
            type: "structure",
            required: [
              "ColumnStatisticsTaskRunId"
            ],
            members: {
              ColumnStatisticsTaskRunId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ColumnStatisticsTaskRun: {
                shape: "Sk7"
              }
            }
          }
        },
        GetColumnStatisticsTaskRuns: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName"
            ],
            members: {
              DatabaseName: {},
              TableName: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ColumnStatisticsTaskRuns: {
                type: "list",
                member: {
                  shape: "Sk7"
                }
              },
              NextToken: {}
            }
          }
        },
        GetConnection: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              CatalogId: {},
              Name: {},
              HidePassword: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Connection: {
                shape: "Ski"
              }
            }
          }
        },
        GetConnections: {
          input: {
            type: "structure",
            members: {
              CatalogId: {},
              Filter: {
                type: "structure",
                members: {
                  MatchCriteria: {
                    shape: "Sdv"
                  },
                  ConnectionType: {}
                }
              },
              HidePassword: {
                type: "boolean"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionList: {
                type: "list",
                member: {
                  shape: "Ski"
                }
              },
              NextToken: {}
            }
          }
        },
        GetCrawler: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Crawler: {
                shape: "S29"
              }
            }
          }
        },
        GetCrawlerMetrics: {
          input: {
            type: "structure",
            members: {
              CrawlerNameList: {
                shape: "S26"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CrawlerMetricsList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CrawlerName: {},
                    TimeLeftSeconds: {
                      type: "double"
                    },
                    StillEstimating: {
                      type: "boolean"
                    },
                    LastRuntimeSeconds: {
                      type: "double"
                    },
                    MedianRuntimeSeconds: {
                      type: "double"
                    },
                    TablesCreated: {
                      type: "integer"
                    },
                    TablesUpdated: {
                      type: "integer"
                    },
                    TablesDeleted: {
                      type: "integer"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetCrawlers: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Crawlers: {
                shape: "S28"
              },
              NextToken: {}
            }
          }
        },
        GetCustomEntityType: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              RegexString: {},
              ContextWords: {
                shape: "S3v"
              }
            }
          }
        },
        GetDataCatalogEncryptionSettings: {
          input: {
            type: "structure",
            members: {
              CatalogId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DataCatalogEncryptionSettings: {
                shape: "Skz"
              }
            }
          }
        },
        GetDataQualityResult: {
          input: {
            type: "structure",
            required: [
              "ResultId"
            ],
            members: {
              ResultId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResultId: {},
              Score: {
                type: "double"
              },
              DataSource: {
                shape: "S43"
              },
              RulesetName: {},
              EvaluationContext: {},
              StartedOn: {
                type: "timestamp"
              },
              CompletedOn: {
                type: "timestamp"
              },
              JobName: {},
              JobRunId: {},
              RulesetEvaluationRunId: {},
              RuleResults: {
                shape: "S46"
              },
              AnalyzerResults: {
                shape: "S4b"
              },
              Observations: {
                shape: "S4d"
              }
            }
          }
        },
        GetDataQualityRuleRecommendationRun: {
          input: {
            type: "structure",
            required: [
              "RunId"
            ],
            members: {
              RunId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RunId: {},
              DataSource: {
                shape: "S43"
              },
              Role: {},
              NumberOfWorkers: {
                type: "integer"
              },
              Timeout: {
                type: "integer"
              },
              Status: {},
              ErrorString: {},
              StartedOn: {
                type: "timestamp"
              },
              LastModifiedOn: {
                type: "timestamp"
              },
              CompletedOn: {
                type: "timestamp"
              },
              ExecutionTime: {
                type: "integer"
              },
              RecommendedRuleset: {},
              CreatedRulesetName: {}
            }
          }
        },
        GetDataQualityRuleset: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Description: {},
              Ruleset: {},
              TargetTable: {
                shape: "Se7"
              },
              CreatedOn: {
                type: "timestamp"
              },
              LastModifiedOn: {
                type: "timestamp"
              },
              RecommendationRunId: {}
            }
          }
        },
        GetDataQualityRulesetEvaluationRun: {
          input: {
            type: "structure",
            required: [
              "RunId"
            ],
            members: {
              RunId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RunId: {},
              DataSource: {
                shape: "S43"
              },
              Role: {},
              NumberOfWorkers: {
                type: "integer"
              },
              Timeout: {
                type: "integer"
              },
              AdditionalRunOptions: {
                shape: "Slb"
              },
              Status: {},
              ErrorString: {},
              StartedOn: {
                type: "timestamp"
              },
              LastModifiedOn: {
                type: "timestamp"
              },
              CompletedOn: {
                type: "timestamp"
              },
              ExecutionTime: {
                type: "integer"
              },
              RulesetNames: {
                shape: "Slc"
              },
              ResultIds: {
                type: "list",
                member: {}
              },
              AdditionalDataSources: {
                shape: "Sle"
              }
            }
          }
        },
        GetDatabase: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              CatalogId: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Database: {
                shape: "Slh"
              }
            }
          }
        },
        GetDatabases: {
          input: {
            type: "structure",
            members: {
              CatalogId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ResourceShareType: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "DatabaseList"
            ],
            members: {
              DatabaseList: {
                type: "list",
                member: {
                  shape: "Slh"
                }
              },
              NextToken: {}
            }
          }
        },
        GetDataflowGraph: {
          input: {
            type: "structure",
            members: {
              PythonScript: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DagNodes: {
                shape: "Sfg"
              },
              DagEdges: {
                shape: "Sfo"
              }
            }
          }
        },
        GetDevEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointName"
            ],
            members: {
              EndpointName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DevEndpoint: {
                shape: "S4n"
              }
            }
          }
        },
        GetDevEndpoints: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DevEndpoints: {
                shape: "S4m"
              },
              NextToken: {}
            }
          }
        },
        GetJob: {
          input: {
            type: "structure",
            required: [
              "JobName"
            ],
            members: {
              JobName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Job: {
                shape: "S4z"
              }
            }
          }
        },
        GetJobBookmark: {
          input: {
            type: "structure",
            required: [
              "JobName"
            ],
            members: {
              JobName: {},
              RunId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobBookmarkEntry: {
                shape: "Slz"
              }
            }
          }
        },
        GetJobRun: {
          input: {
            type: "structure",
            required: [
              "JobName",
              "RunId"
            ],
            members: {
              JobName: {},
              RunId: {},
              PredecessorsIncluded: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobRun: {
                shape: "Sc0"
              }
            }
          }
        },
        GetJobRuns: {
          input: {
            type: "structure",
            required: [
              "JobName"
            ],
            members: {
              JobName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobRuns: {
                shape: "Sbz"
              },
              NextToken: {}
            }
          }
        },
        GetJobs: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Jobs: {
                shape: "S4y"
              },
              NextToken: {}
            }
          }
        },
        GetMLTaskRun: {
          input: {
            type: "structure",
            required: [
              "TransformId",
              "TaskRunId"
            ],
            members: {
              TransformId: {},
              TaskRunId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TransformId: {},
              TaskRunId: {},
              Status: {},
              LogGroupName: {},
              Properties: {
                shape: "Sm9"
              },
              ErrorString: {},
              StartedOn: {
                type: "timestamp"
              },
              LastModifiedOn: {
                type: "timestamp"
              },
              CompletedOn: {
                type: "timestamp"
              },
              ExecutionTime: {
                type: "integer"
              }
            }
          }
        },
        GetMLTaskRuns: {
          input: {
            type: "structure",
            required: [
              "TransformId"
            ],
            members: {
              TransformId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filter: {
                type: "structure",
                members: {
                  TaskRunType: {},
                  Status: {},
                  StartedBefore: {
                    type: "timestamp"
                  },
                  StartedAfter: {
                    type: "timestamp"
                  }
                }
              },
              Sort: {
                type: "structure",
                required: [
                  "Column",
                  "SortDirection"
                ],
                members: {
                  Column: {},
                  SortDirection: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TaskRuns: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TransformId: {},
                    TaskRunId: {},
                    Status: {},
                    LogGroupName: {},
                    Properties: {
                      shape: "Sm9"
                    },
                    ErrorString: {},
                    StartedOn: {
                      type: "timestamp"
                    },
                    LastModifiedOn: {
                      type: "timestamp"
                    },
                    CompletedOn: {
                      type: "timestamp"
                    },
                    ExecutionTime: {
                      type: "integer"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetMLTransform: {
          input: {
            type: "structure",
            required: [
              "TransformId"
            ],
            members: {
              TransformId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TransformId: {},
              Name: {},
              Description: {},
              Status: {},
              CreatedOn: {
                type: "timestamp"
              },
              LastModifiedOn: {
                type: "timestamp"
              },
              InputRecordTables: {
                shape: "Ser"
              },
              Parameters: {
                shape: "Ses"
              },
              EvaluationMetrics: {
                shape: "Sms"
              },
              LabelCount: {
                type: "integer"
              },
              Schema: {
                shape: "Smz"
              },
              Role: {},
              GlueVersion: {},
              MaxCapacity: {
                type: "double"
              },
              WorkerType: {},
              NumberOfWorkers: {
                type: "integer"
              },
              Timeout: {
                type: "integer"
              },
              MaxRetries: {
                type: "integer"
              },
              TransformEncryption: {
                shape: "Sew"
              }
            }
          }
        },
        GetMLTransforms: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filter: {
                shape: "Sn2"
              },
              Sort: {
                shape: "Sn3"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Transforms"
            ],
            members: {
              Transforms: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TransformId: {},
                    Name: {},
                    Description: {},
                    Status: {},
                    CreatedOn: {
                      type: "timestamp"
                    },
                    LastModifiedOn: {
                      type: "timestamp"
                    },
                    InputRecordTables: {
                      shape: "Ser"
                    },
                    Parameters: {
                      shape: "Ses"
                    },
                    EvaluationMetrics: {
                      shape: "Sms"
                    },
                    LabelCount: {
                      type: "integer"
                    },
                    Schema: {
                      shape: "Smz"
                    },
                    Role: {},
                    GlueVersion: {},
                    MaxCapacity: {
                      type: "double"
                    },
                    WorkerType: {},
                    NumberOfWorkers: {
                      type: "integer"
                    },
                    Timeout: {
                      type: "integer"
                    },
                    MaxRetries: {
                      type: "integer"
                    },
                    TransformEncryption: {
                      shape: "Sew"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetMapping: {
          input: {
            type: "structure",
            required: [
              "Source"
            ],
            members: {
              Source: {
                shape: "Sn9"
              },
              Sinks: {
                shape: "Sna"
              },
              Location: {
                shape: "Snb"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Mapping"
            ],
            members: {
              Mapping: {
                shape: "Snd"
              }
            }
          }
        },
        GetPartition: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "PartitionValues"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              PartitionValues: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Partition: {
                shape: "Sag"
              }
            }
          }
        },
        GetPartitionIndexes: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PartitionIndexDescriptorList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "IndexName",
                    "Keys",
                    "IndexStatus"
                  ],
                  members: {
                    IndexName: {},
                    Keys: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "Name",
                          "Type"
                        ],
                        members: {
                          Name: {},
                          Type: {}
                        }
                      }
                    },
                    IndexStatus: {},
                    BackfillErrors: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Code: {},
                          Partitions: {
                            type: "list",
                            member: {
                              shape: "S1c"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetPartitions: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              Expression: {},
              NextToken: {},
              Segment: {
                shape: "Snw"
              },
              MaxResults: {
                type: "integer"
              },
              ExcludeColumnSchema: {
                type: "boolean"
              },
              TransactionId: {},
              QueryAsOfTime: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Partitions: {
                shape: "Saf"
              },
              NextToken: {}
            }
          }
        },
        GetPlan: {
          input: {
            type: "structure",
            required: [
              "Mapping",
              "Source"
            ],
            members: {
              Mapping: {
                shape: "Snd"
              },
              Source: {
                shape: "Sn9"
              },
              Sinks: {
                shape: "Sna"
              },
              Location: {
                shape: "Snb"
              },
              Language: {},
              AdditionalPlanOptionsMap: {
                type: "map",
                key: {},
                value: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PythonScript: {},
              ScalaCode: {}
            }
          }
        },
        GetRegistry: {
          input: {
            type: "structure",
            required: [
              "RegistryId"
            ],
            members: {
              RegistryId: {
                shape: "Sf9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RegistryName: {},
              RegistryArn: {},
              Description: {},
              Status: {},
              CreatedTime: {},
              UpdatedTime: {}
            }
          }
        },
        GetResourcePolicies: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GetResourcePoliciesResponseList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PolicyInJson: {},
                    PolicyHash: {},
                    CreateTime: {
                      type: "timestamp"
                    },
                    UpdateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetResourcePolicy: {
          input: {
            type: "structure",
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyInJson: {},
              PolicyHash: {},
              CreateTime: {
                type: "timestamp"
              },
              UpdateTime: {
                type: "timestamp"
              }
            }
          }
        },
        GetSchema: {
          input: {
            type: "structure",
            required: [
              "SchemaId"
            ],
            members: {
              SchemaId: {
                shape: "Sw"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RegistryName: {},
              RegistryArn: {},
              SchemaName: {},
              SchemaArn: {},
              Description: {},
              DataFormat: {},
              Compatibility: {},
              SchemaCheckpoint: {
                type: "long"
              },
              LatestSchemaVersion: {
                type: "long"
              },
              NextSchemaVersion: {
                type: "long"
              },
              SchemaStatus: {},
              CreatedTime: {},
              UpdatedTime: {}
            }
          }
        },
        GetSchemaByDefinition: {
          input: {
            type: "structure",
            required: [
              "SchemaId",
              "SchemaDefinition"
            ],
            members: {
              SchemaId: {
                shape: "Sw"
              },
              SchemaDefinition: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaVersionId: {},
              SchemaArn: {},
              DataFormat: {},
              Status: {},
              CreatedTime: {}
            }
          }
        },
        GetSchemaVersion: {
          input: {
            type: "structure",
            members: {
              SchemaId: {
                shape: "Sw"
              },
              SchemaVersionId: {},
              SchemaVersionNumber: {
                shape: "Soj"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaVersionId: {},
              SchemaDefinition: {},
              DataFormat: {},
              SchemaArn: {},
              VersionNumber: {
                type: "long"
              },
              Status: {},
              CreatedTime: {}
            }
          }
        },
        GetSchemaVersionsDiff: {
          input: {
            type: "structure",
            required: [
              "SchemaId",
              "FirstSchemaVersionNumber",
              "SecondSchemaVersionNumber",
              "SchemaDiffType"
            ],
            members: {
              SchemaId: {
                shape: "Sw"
              },
              FirstSchemaVersionNumber: {
                shape: "Soj"
              },
              SecondSchemaVersionNumber: {
                shape: "Soj"
              },
              SchemaDiffType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Diff: {}
            }
          }
        },
        GetSecurityConfiguration: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SecurityConfiguration: {
                shape: "Sos"
              }
            }
          }
        },
        GetSecurityConfigurations: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SecurityConfigurations: {
                type: "list",
                member: {
                  shape: "Sos"
                }
              },
              NextToken: {}
            }
          }
        },
        GetSession: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {},
              RequestOrigin: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Session: {
                shape: "Sgb"
              }
            }
          }
        },
        GetStatement: {
          input: {
            type: "structure",
            required: [
              "SessionId",
              "Id"
            ],
            members: {
              SessionId: {},
              Id: {
                type: "integer"
              },
              RequestOrigin: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Statement: {
                shape: "Sp0"
              }
            }
          }
        },
        GetTable: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "Name"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              Name: {},
              TransactionId: {},
              QueryAsOfTime: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Table: {
                shape: "Sp7"
              }
            }
          }
        },
        GetTableOptimizer: {
          input: {
            type: "structure",
            required: [
              "CatalogId",
              "DatabaseName",
              "TableName",
              "Type"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              Type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              TableOptimizer: {
                shape: "Saq"
              }
            }
          }
        },
        GetTableVersion: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              VersionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TableVersion: {
                shape: "Spd"
              }
            }
          }
        },
        GetTableVersions: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TableVersions: {
                type: "list",
                member: {
                  shape: "Spd"
                }
              },
              NextToken: {}
            }
          }
        },
        GetTables: {
          input: {
            type: "structure",
            required: [
              "DatabaseName"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              Expression: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              TransactionId: {},
              QueryAsOfTime: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TableList: {
                shape: "Spk"
              },
              NextToken: {}
            }
          }
        },
        GetTags: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sd7"
              }
            }
          }
        },
        GetTrigger: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Trigger: {
                shape: "Sb4"
              }
            }
          }
        },
        GetTriggers: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              DependentJobName: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Triggers: {
                shape: "Sb3"
              },
              NextToken: {}
            }
          }
        },
        GetUnfilteredPartitionMetadata: {
          input: {
            type: "structure",
            required: [
              "CatalogId",
              "DatabaseName",
              "TableName",
              "PartitionValues",
              "SupportedPermissionTypes"
            ],
            members: {
              Region: {},
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              PartitionValues: {
                shape: "S6"
              },
              AuditContext: {
                shape: "Sps"
              },
              SupportedPermissionTypes: {
                shape: "Spv"
              },
              QuerySessionContext: {
                shape: "Spx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Partition: {
                shape: "Sag"
              },
              AuthorizedColumns: {
                shape: "Sn"
              },
              IsRegisteredWithLakeFormation: {
                type: "boolean"
              }
            }
          }
        },
        GetUnfilteredPartitionsMetadata: {
          input: {
            type: "structure",
            required: [
              "CatalogId",
              "DatabaseName",
              "TableName",
              "SupportedPermissionTypes"
            ],
            members: {
              Region: {},
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              Expression: {},
              AuditContext: {
                shape: "Sps"
              },
              SupportedPermissionTypes: {
                shape: "Spv"
              },
              NextToken: {},
              Segment: {
                shape: "Snw"
              },
              MaxResults: {
                type: "integer"
              },
              QuerySessionContext: {
                shape: "Spx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UnfilteredPartitions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Partition: {
                      shape: "Sag"
                    },
                    AuthorizedColumns: {
                      shape: "Sn"
                    },
                    IsRegisteredWithLakeFormation: {
                      type: "boolean"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetUnfilteredTableMetadata: {
          input: {
            type: "structure",
            required: [
              "CatalogId",
              "DatabaseName",
              "Name",
              "SupportedPermissionTypes"
            ],
            members: {
              Region: {},
              CatalogId: {},
              DatabaseName: {},
              Name: {},
              AuditContext: {
                shape: "Sps"
              },
              SupportedPermissionTypes: {
                shape: "Spv"
              },
              SupportedDialect: {
                type: "structure",
                members: {
                  Dialect: {},
                  DialectVersion: {}
                }
              },
              Permissions: {
                shape: "Seg"
              },
              QuerySessionContext: {
                shape: "Spx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Table: {
                shape: "Sp7"
              },
              AuthorizedColumns: {
                shape: "Sn"
              },
              IsRegisteredWithLakeFormation: {
                type: "boolean"
              },
              CellFilters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ColumnName: {},
                    RowFilterExpression: {}
                  }
                }
              },
              QueryAuthorizationId: {},
              ResourceArn: {},
              Permissions: {
                shape: "Seg"
              }
            }
          }
        },
        GetUserDefinedFunction: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "FunctionName"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              FunctionName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UserDefinedFunction: {
                shape: "Sqg"
              }
            }
          }
        },
        GetUserDefinedFunctions: {
          input: {
            type: "structure",
            required: [
              "Pattern"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              Pattern: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserDefinedFunctions: {
                type: "list",
                member: {
                  shape: "Sqg"
                }
              },
              NextToken: {}
            }
          }
        },
        GetWorkflow: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              IncludeGraph: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Workflow: {
                shape: "Sbo"
              }
            }
          }
        },
        GetWorkflowRun: {
          input: {
            type: "structure",
            required: [
              "Name",
              "RunId"
            ],
            members: {
              Name: {},
              RunId: {},
              IncludeGraph: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Run: {
                shape: "Sbq"
              }
            }
          }
        },
        GetWorkflowRunProperties: {
          input: {
            type: "structure",
            required: [
              "Name",
              "RunId"
            ],
            members: {
              Name: {},
              RunId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RunProperties: {
                shape: "Sbp"
              }
            }
          }
        },
        GetWorkflowRuns: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              IncludeGraph: {
                type: "boolean"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Runs: {
                type: "list",
                member: {
                  shape: "Sbq"
                }
              },
              NextToken: {}
            }
          }
        },
        ImportCatalogToGlue: {
          input: {
            type: "structure",
            members: {
              CatalogId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ListBlueprints: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Tags: {
                shape: "Sd7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Blueprints: {
                shape: "S24"
              },
              NextToken: {}
            }
          }
        },
        ListColumnStatisticsTaskRuns: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ColumnStatisticsTaskRunIds: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListCrawlers: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Tags: {
                shape: "Sd7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CrawlerNames: {
                shape: "S26"
              },
              NextToken: {}
            }
          }
        },
        ListCrawls: {
          input: {
            type: "structure",
            required: [
              "CrawlerName"
            ],
            members: {
              CrawlerName: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FieldName: {},
                    FilterOperator: {},
                    FieldValue: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Crawls: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CrawlId: {},
                    State: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    Summary: {},
                    ErrorMessage: {},
                    LogGroup: {},
                    LogStream: {},
                    MessagePrefix: {},
                    DPUHour: {
                      type: "double"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListCustomEntityTypes: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Tags: {
                shape: "Sd7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CustomEntityTypes: {
                shape: "S3t"
              },
              NextToken: {}
            }
          }
        },
        ListDataQualityResults: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                members: {
                  DataSource: {
                    shape: "S43"
                  },
                  JobName: {},
                  JobRunId: {},
                  StartedAfter: {
                    type: "timestamp"
                  },
                  StartedBefore: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Results"
            ],
            members: {
              Results: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResultId: {},
                    DataSource: {
                      shape: "S43"
                    },
                    JobName: {},
                    JobRunId: {},
                    StartedOn: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDataQualityRuleRecommendationRuns: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                required: [
                  "DataSource"
                ],
                members: {
                  DataSource: {
                    shape: "S43"
                  },
                  StartedBefore: {
                    type: "timestamp"
                  },
                  StartedAfter: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Runs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RunId: {},
                    Status: {},
                    StartedOn: {
                      type: "timestamp"
                    },
                    DataSource: {
                      shape: "S43"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDataQualityRulesetEvaluationRuns: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                required: [
                  "DataSource"
                ],
                members: {
                  DataSource: {
                    shape: "S43"
                  },
                  StartedBefore: {
                    type: "timestamp"
                  },
                  StartedAfter: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Runs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RunId: {},
                    Status: {},
                    StartedOn: {
                      type: "timestamp"
                    },
                    DataSource: {
                      shape: "S43"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDataQualityRulesets: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filter: {
                type: "structure",
                members: {
                  Name: {},
                  Description: {},
                  CreatedBefore: {
                    type: "timestamp"
                  },
                  CreatedAfter: {
                    type: "timestamp"
                  },
                  LastModifiedBefore: {
                    type: "timestamp"
                  },
                  LastModifiedAfter: {
                    type: "timestamp"
                  },
                  TargetTable: {
                    shape: "Se7"
                  }
                }
              },
              Tags: {
                shape: "Sd7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Rulesets: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Description: {},
                    CreatedOn: {
                      type: "timestamp"
                    },
                    LastModifiedOn: {
                      type: "timestamp"
                    },
                    TargetTable: {
                      shape: "Se7"
                    },
                    RecommendationRunId: {},
                    RuleCount: {
                      type: "integer"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDevEndpoints: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Tags: {
                shape: "Sd7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DevEndpointNames: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListJobs: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Tags: {
                shape: "Sd7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobNames: {
                shape: "S4w"
              },
              NextToken: {}
            }
          }
        },
        ListMLTransforms: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filter: {
                shape: "Sn2"
              },
              Sort: {
                shape: "Sn3"
              },
              Tags: {
                shape: "Sd7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TransformIds"
            ],
            members: {
              TransformIds: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListRegistries: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Registries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RegistryName: {},
                    RegistryArn: {},
                    Description: {},
                    Status: {},
                    CreatedTime: {},
                    UpdatedTime: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSchemaVersions: {
          input: {
            type: "structure",
            required: [
              "SchemaId"
            ],
            members: {
              SchemaId: {
                shape: "Sw"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Schemas: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SchemaArn: {},
                    SchemaVersionId: {},
                    VersionNumber: {
                      type: "long"
                    },
                    Status: {},
                    CreatedTime: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSchemas: {
          input: {
            type: "structure",
            members: {
              RegistryId: {
                shape: "Sf9"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Schemas: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RegistryName: {},
                    SchemaName: {},
                    SchemaArn: {},
                    Description: {},
                    SchemaStatus: {},
                    CreatedTime: {},
                    UpdatedTime: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSessions: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Tags: {
                shape: "Sd7"
              },
              RequestOrigin: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Ids: {
                type: "list",
                member: {}
              },
              Sessions: {
                type: "list",
                member: {
                  shape: "Sgb"
                }
              },
              NextToken: {}
            }
          }
        },
        ListStatements: {
          input: {
            type: "structure",
            required: [
              "SessionId"
            ],
            members: {
              SessionId: {},
              RequestOrigin: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Statements: {
                type: "list",
                member: {
                  shape: "Sp0"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTableOptimizerRuns: {
          input: {
            type: "structure",
            required: [
              "CatalogId",
              "DatabaseName",
              "TableName",
              "Type"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              Type: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              NextToken: {},
              TableOptimizerRuns: {
                type: "list",
                member: {
                  shape: "Sat"
                }
              }
            }
          }
        },
        ListTriggers: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              DependentJobName: {},
              MaxResults: {
                type: "integer"
              },
              Tags: {
                shape: "Sd7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TriggerNames: {
                shape: "Sb1"
              },
              NextToken: {}
            }
          }
        },
        ListWorkflows: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Workflows: {
                shape: "Sbl"
              },
              NextToken: {}
            }
          }
        },
        PutDataCatalogEncryptionSettings: {
          input: {
            type: "structure",
            required: [
              "DataCatalogEncryptionSettings"
            ],
            members: {
              CatalogId: {},
              DataCatalogEncryptionSettings: {
                shape: "Skz"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyInJson"
            ],
            members: {
              PolicyInJson: {},
              ResourceArn: {},
              PolicyHashCondition: {},
              PolicyExistsCondition: {},
              EnableHybrid: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyHash: {}
            }
          }
        },
        PutSchemaVersionMetadata: {
          input: {
            type: "structure",
            required: [
              "MetadataKeyValue"
            ],
            members: {
              SchemaId: {
                shape: "Sw"
              },
              SchemaVersionNumber: {
                shape: "Soj"
              },
              SchemaVersionId: {},
              MetadataKeyValue: {
                shape: "St8"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArn: {},
              SchemaName: {},
              RegistryName: {},
              LatestVersion: {
                type: "boolean"
              },
              VersionNumber: {
                type: "long"
              },
              SchemaVersionId: {},
              MetadataKey: {},
              MetadataValue: {}
            }
          }
        },
        PutWorkflowRunProperties: {
          input: {
            type: "structure",
            required: [
              "Name",
              "RunId",
              "RunProperties"
            ],
            members: {
              Name: {},
              RunId: {},
              RunProperties: {
                shape: "Sbp"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        QuerySchemaVersionMetadata: {
          input: {
            type: "structure",
            members: {
              SchemaId: {
                shape: "Sw"
              },
              SchemaVersionNumber: {
                shape: "Soj"
              },
              SchemaVersionId: {},
              MetadataList: {
                type: "list",
                member: {
                  shape: "St8"
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MetadataInfoMap: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    MetadataValue: {},
                    CreatedTime: {},
                    OtherMetadataValueList: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          MetadataValue: {},
                          CreatedTime: {}
                        }
                      }
                    }
                  }
                }
              },
              SchemaVersionId: {},
              NextToken: {}
            }
          }
        },
        RegisterSchemaVersion: {
          input: {
            type: "structure",
            required: [
              "SchemaId",
              "SchemaDefinition"
            ],
            members: {
              SchemaId: {
                shape: "Sw"
              },
              SchemaDefinition: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaVersionId: {},
              VersionNumber: {
                type: "long"
              },
              Status: {}
            }
          }
        },
        RemoveSchemaVersionMetadata: {
          input: {
            type: "structure",
            required: [
              "MetadataKeyValue"
            ],
            members: {
              SchemaId: {
                shape: "Sw"
              },
              SchemaVersionNumber: {
                shape: "Soj"
              },
              SchemaVersionId: {},
              MetadataKeyValue: {
                shape: "St8"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArn: {},
              SchemaName: {},
              RegistryName: {},
              LatestVersion: {
                type: "boolean"
              },
              VersionNumber: {
                type: "long"
              },
              SchemaVersionId: {},
              MetadataKey: {},
              MetadataValue: {}
            }
          }
        },
        ResetJobBookmark: {
          input: {
            type: "structure",
            required: [
              "JobName"
            ],
            members: {
              JobName: {},
              RunId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobBookmarkEntry: {
                shape: "Slz"
              }
            }
          }
        },
        ResumeWorkflowRun: {
          input: {
            type: "structure",
            required: [
              "Name",
              "RunId",
              "NodeIds"
            ],
            members: {
              Name: {},
              RunId: {},
              NodeIds: {
                shape: "Stt"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RunId: {},
              NodeIds: {
                shape: "Stt"
              }
            }
          }
        },
        RunStatement: {
          input: {
            type: "structure",
            required: [
              "SessionId",
              "Code"
            ],
            members: {
              SessionId: {},
              Code: {},
              RequestOrigin: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {
                type: "integer"
              }
            }
          }
        },
        SearchTables: {
          input: {
            type: "structure",
            members: {
              CatalogId: {},
              NextToken: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Key: {},
                    Value: {},
                    Comparator: {}
                  }
                }
              },
              SearchText: {},
              SortCriteria: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FieldName: {},
                    Sort: {}
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              ResourceShareType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              TableList: {
                shape: "Spk"
              }
            }
          }
        },
        StartBlueprintRun: {
          input: {
            type: "structure",
            required: [
              "BlueprintName",
              "RoleArn"
            ],
            members: {
              BlueprintName: {},
              Parameters: {},
              RoleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RunId: {}
            }
          }
        },
        StartColumnStatisticsTaskRun: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "Role"
            ],
            members: {
              DatabaseName: {},
              TableName: {},
              ColumnNameList: {
                shape: "Sk9"
              },
              Role: {},
              SampleSize: {
                type: "double"
              },
              CatalogID: {},
              SecurityConfiguration: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ColumnStatisticsTaskRunId: {}
            }
          }
        },
        StartCrawler: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartCrawlerSchedule: {
          input: {
            type: "structure",
            required: [
              "CrawlerName"
            ],
            members: {
              CrawlerName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartDataQualityRuleRecommendationRun: {
          input: {
            type: "structure",
            required: [
              "DataSource",
              "Role"
            ],
            members: {
              DataSource: {
                shape: "S43"
              },
              Role: {},
              NumberOfWorkers: {
                type: "integer"
              },
              Timeout: {
                type: "integer"
              },
              CreatedRulesetName: {},
              ClientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RunId: {}
            }
          },
          idempotent: true
        },
        StartDataQualityRulesetEvaluationRun: {
          input: {
            type: "structure",
            required: [
              "DataSource",
              "Role",
              "RulesetNames"
            ],
            members: {
              DataSource: {
                shape: "S43"
              },
              Role: {},
              NumberOfWorkers: {
                type: "integer"
              },
              Timeout: {
                type: "integer"
              },
              ClientToken: {},
              AdditionalRunOptions: {
                shape: "Slb"
              },
              RulesetNames: {
                shape: "Slc"
              },
              AdditionalDataSources: {
                shape: "Sle"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RunId: {}
            }
          },
          idempotent: true
        },
        StartExportLabelsTaskRun: {
          input: {
            type: "structure",
            required: [
              "TransformId",
              "OutputS3Path"
            ],
            members: {
              TransformId: {},
              OutputS3Path: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TaskRunId: {}
            }
          }
        },
        StartImportLabelsTaskRun: {
          input: {
            type: "structure",
            required: [
              "TransformId",
              "InputS3Path"
            ],
            members: {
              TransformId: {},
              InputS3Path: {},
              ReplaceAllLabels: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TaskRunId: {}
            }
          }
        },
        StartJobRun: {
          input: {
            type: "structure",
            required: [
              "JobName"
            ],
            members: {
              JobName: {},
              JobRunId: {},
              Arguments: {
                shape: "S58"
              },
              AllocatedCapacity: {
                deprecated: true,
                deprecatedMessage: "This property is deprecated, use MaxCapacity instead.",
                type: "integer"
              },
              Timeout: {
                type: "integer"
              },
              MaxCapacity: {
                type: "double"
              },
              SecurityConfiguration: {},
              NotificationProperty: {
                shape: "S5d"
              },
              WorkerType: {},
              NumberOfWorkers: {
                type: "integer"
              },
              ExecutionClass: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobRunId: {}
            }
          }
        },
        StartMLEvaluationTaskRun: {
          input: {
            type: "structure",
            required: [
              "TransformId"
            ],
            members: {
              TransformId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TaskRunId: {}
            }
          }
        },
        StartMLLabelingSetGenerationTaskRun: {
          input: {
            type: "structure",
            required: [
              "TransformId",
              "OutputS3Path"
            ],
            members: {
              TransformId: {},
              OutputS3Path: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TaskRunId: {}
            }
          }
        },
        StartTrigger: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {}
            }
          }
        },
        StartWorkflowRun: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              RunProperties: {
                shape: "Sbp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RunId: {}
            }
          }
        },
        StopColumnStatisticsTaskRun: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName"
            ],
            members: {
              DatabaseName: {},
              TableName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StopCrawler: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StopCrawlerSchedule: {
          input: {
            type: "structure",
            required: [
              "CrawlerName"
            ],
            members: {
              CrawlerName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StopSession: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {},
              RequestOrigin: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {}
            }
          }
        },
        StopTrigger: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {}
            }
          }
        },
        StopWorkflowRun: {
          input: {
            type: "structure",
            required: [
              "Name",
              "RunId"
            ],
            members: {
              Name: {},
              RunId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagsToAdd"
            ],
            members: {
              ResourceArn: {},
              TagsToAdd: {
                shape: "Sd7"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagsToRemove"
            ],
            members: {
              ResourceArn: {},
              TagsToRemove: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateBlueprint: {
          input: {
            type: "structure",
            required: [
              "Name",
              "BlueprintLocation"
            ],
            members: {
              Name: {},
              Description: {},
              BlueprintLocation: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {}
            }
          }
        },
        UpdateClassifier: {
          input: {
            type: "structure",
            members: {
              GrokClassifier: {
                type: "structure",
                required: [
                  "Name"
                ],
                members: {
                  Name: {},
                  Classification: {},
                  GrokPattern: {},
                  CustomPatterns: {}
                }
              },
              XMLClassifier: {
                type: "structure",
                required: [
                  "Name"
                ],
                members: {
                  Name: {},
                  Classification: {},
                  RowTag: {}
                }
              },
              JsonClassifier: {
                type: "structure",
                required: [
                  "Name"
                ],
                members: {
                  Name: {},
                  JsonPath: {}
                }
              },
              CsvClassifier: {
                type: "structure",
                required: [
                  "Name"
                ],
                members: {
                  Name: {},
                  Delimiter: {},
                  QuoteSymbol: {},
                  ContainsHeader: {},
                  Header: {
                    shape: "Sdo"
                  },
                  DisableValueTrimming: {
                    type: "boolean"
                  },
                  AllowSingleColumn: {
                    type: "boolean"
                  },
                  CustomDatatypeConfigured: {
                    type: "boolean"
                  },
                  CustomDatatypes: {
                    shape: "Sdp"
                  },
                  Serde: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateColumnStatisticsForPartition: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "PartitionValues",
              "ColumnStatisticsList"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              PartitionValues: {
                shape: "S6"
              },
              ColumnStatisticsList: {
                shape: "Svm"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Errors: {
                shape: "Svo"
              }
            }
          }
        },
        UpdateColumnStatisticsForTable: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "ColumnStatisticsList"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              ColumnStatisticsList: {
                shape: "Svm"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Errors: {
                shape: "Svo"
              }
            }
          }
        },
        UpdateConnection: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ConnectionInput"
            ],
            members: {
              CatalogId: {},
              Name: {},
              ConnectionInput: {
                shape: "Sdt"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateCrawler: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Role: {},
              DatabaseName: {},
              Description: {},
              Targets: {
                shape: "S2b"
              },
              Schedule: {},
              Classifiers: {
                shape: "S32"
              },
              TablePrefix: {},
              SchemaChangePolicy: {
                shape: "S35"
              },
              RecrawlPolicy: {
                shape: "S33"
              },
              LineageConfiguration: {
                shape: "S38"
              },
              LakeFormationConfiguration: {
                shape: "S3o"
              },
              Configuration: {},
              CrawlerSecurityConfiguration: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateCrawlerSchedule: {
          input: {
            type: "structure",
            required: [
              "CrawlerName"
            ],
            members: {
              CrawlerName: {},
              Schedule: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDataQualityRuleset: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Description: {},
              Ruleset: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Description: {},
              Ruleset: {}
            }
          }
        },
        UpdateDatabase: {
          input: {
            type: "structure",
            required: [
              "Name",
              "DatabaseInput"
            ],
            members: {
              CatalogId: {},
              Name: {},
              DatabaseInput: {
                shape: "Sea"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDevEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointName"
            ],
            members: {
              EndpointName: {},
              PublicKey: {},
              AddPublicKeys: {
                shape: "S4t"
              },
              DeletePublicKeys: {
                shape: "S4t"
              },
              CustomLibraries: {
                type: "structure",
                members: {
                  ExtraPythonLibsS3Path: {},
                  ExtraJarsS3Path: {}
                }
              },
              UpdateEtlLibraries: {
                type: "boolean"
              },
              DeleteArguments: {
                shape: "S4p"
              },
              AddArguments: {
                shape: "S4u"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateJob: {
          input: {
            type: "structure",
            required: [
              "JobName",
              "JobUpdate"
            ],
            members: {
              JobName: {},
              JobUpdate: {
                type: "structure",
                members: {
                  Description: {},
                  LogUri: {},
                  Role: {},
                  ExecutionProperty: {
                    shape: "S52"
                  },
                  Command: {
                    shape: "S54"
                  },
                  DefaultArguments: {
                    shape: "S58"
                  },
                  NonOverridableArguments: {
                    shape: "S58"
                  },
                  Connections: {
                    shape: "S59"
                  },
                  MaxRetries: {
                    type: "integer"
                  },
                  AllocatedCapacity: {
                    deprecated: true,
                    deprecatedMessage: "This property is deprecated, use MaxCapacity instead.",
                    type: "integer"
                  },
                  Timeout: {
                    type: "integer"
                  },
                  MaxCapacity: {
                    type: "double"
                  },
                  WorkerType: {},
                  NumberOfWorkers: {
                    type: "integer"
                  },
                  SecurityConfiguration: {},
                  NotificationProperty: {
                    shape: "S5d"
                  },
                  GlueVersion: {},
                  CodeGenConfigurationNodes: {
                    shape: "S5f"
                  },
                  ExecutionClass: {},
                  SourceControlDetails: {
                    shape: "Sa9"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobName: {}
            }
          }
        },
        UpdateJobFromSourceControl: {
          input: {
            type: "structure",
            members: {
              JobName: {},
              Provider: {},
              RepositoryName: {},
              RepositoryOwner: {},
              BranchName: {},
              Folder: {},
              CommitId: {},
              AuthStrategy: {},
              AuthToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobName: {}
            }
          }
        },
        UpdateMLTransform: {
          input: {
            type: "structure",
            required: [
              "TransformId"
            ],
            members: {
              TransformId: {},
              Name: {},
              Description: {},
              Parameters: {
                shape: "Ses"
              },
              Role: {},
              GlueVersion: {},
              MaxCapacity: {
                type: "double"
              },
              WorkerType: {},
              NumberOfWorkers: {
                type: "integer"
              },
              Timeout: {
                type: "integer"
              },
              MaxRetries: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransformId: {}
            }
          }
        },
        UpdatePartition: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "PartitionValueList",
              "PartitionInput"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              PartitionValueList: {
                shape: "Scm"
              },
              PartitionInput: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateRegistry: {
          input: {
            type: "structure",
            required: [
              "RegistryId",
              "Description"
            ],
            members: {
              RegistryId: {
                shape: "Sf9"
              },
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RegistryName: {},
              RegistryArn: {}
            }
          }
        },
        UpdateSchema: {
          input: {
            type: "structure",
            required: [
              "SchemaId"
            ],
            members: {
              SchemaId: {
                shape: "Sw"
              },
              SchemaVersionNumber: {
                shape: "Soj"
              },
              Compatibility: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArn: {},
              SchemaName: {},
              RegistryName: {}
            }
          }
        },
        UpdateSourceControlFromJob: {
          input: {
            type: "structure",
            members: {
              JobName: {},
              Provider: {},
              RepositoryName: {},
              RepositoryOwner: {},
              BranchName: {},
              Folder: {},
              CommitId: {},
              AuthStrategy: {},
              AuthToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobName: {}
            }
          }
        },
        UpdateTable: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableInput"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableInput: {
                shape: "Sgg"
              },
              SkipArchive: {
                type: "boolean"
              },
              TransactionId: {},
              VersionId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateTableOptimizer: {
          input: {
            type: "structure",
            required: [
              "CatalogId",
              "DatabaseName",
              "TableName",
              "Type",
              "TableOptimizerConfiguration"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              Type: {},
              TableOptimizerConfiguration: {
                shape: "Sar"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateTrigger: {
          input: {
            type: "structure",
            required: [
              "Name",
              "TriggerUpdate"
            ],
            members: {
              Name: {},
              TriggerUpdate: {
                type: "structure",
                members: {
                  Name: {},
                  Description: {},
                  Schedule: {},
                  Actions: {
                    shape: "Sb8"
                  },
                  Predicate: {
                    shape: "Sba"
                  },
                  EventBatchingCondition: {
                    shape: "Sbh"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Trigger: {
                shape: "Sb4"
              }
            }
          }
        },
        UpdateUserDefinedFunction: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "FunctionName",
              "FunctionInput"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              FunctionName: {},
              FunctionInput: {
                shape: "Sgv"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateWorkflow: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Description: {},
              DefaultRunProperties: {
                shape: "Sbp"
              },
              MaxConcurrentRuns: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {}
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          members: {
            Values: {
              shape: "S6"
            },
            LastAccessTime: {
              type: "timestamp"
            },
            StorageDescriptor: {
              shape: "S9"
            },
            Parameters: {
              shape: "Se"
            },
            LastAnalyzedTime: {
              type: "timestamp"
            }
          }
        },
        S6: {
          type: "list",
          member: {}
        },
        S9: {
          type: "structure",
          members: {
            Columns: {
              shape: "Sa"
            },
            Location: {},
            AdditionalLocations: {
              type: "list",
              member: {}
            },
            InputFormat: {},
            OutputFormat: {},
            Compressed: {
              type: "boolean"
            },
            NumberOfBuckets: {
              type: "integer"
            },
            SerdeInfo: {
              type: "structure",
              members: {
                Name: {},
                SerializationLibrary: {},
                Parameters: {
                  shape: "Se"
                }
              }
            },
            BucketColumns: {
              shape: "Sn"
            },
            SortColumns: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Column",
                  "SortOrder"
                ],
                members: {
                  Column: {},
                  SortOrder: {
                    type: "integer"
                  }
                }
              }
            },
            Parameters: {
              shape: "Se"
            },
            SkewedInfo: {
              type: "structure",
              members: {
                SkewedColumnNames: {
                  shape: "Sn"
                },
                SkewedColumnValues: {
                  type: "list",
                  member: {}
                },
                SkewedColumnValueLocationMaps: {
                  type: "map",
                  key: {},
                  value: {}
                }
              }
            },
            StoredAsSubDirectories: {
              type: "boolean"
            },
            SchemaReference: {
              type: "structure",
              members: {
                SchemaId: {
                  shape: "Sw"
                },
                SchemaVersionId: {},
                SchemaVersionNumber: {
                  type: "long"
                }
              }
            }
          }
        },
        Sa: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Type: {},
              Comment: {},
              Parameters: {
                shape: "Se"
              }
            }
          }
        },
        Se: {
          type: "map",
          key: {},
          value: {}
        },
        Sn: {
          type: "list",
          member: {}
        },
        Sw: {
          type: "structure",
          members: {
            SchemaArn: {},
            SchemaName: {},
            RegistryName: {}
          }
        },
        S12: {
          type: "list",
          member: {
            type: "structure",
            members: {
              PartitionValues: {
                shape: "S6"
              },
              ErrorDetail: {
                shape: "S14"
              }
            }
          }
        },
        S14: {
          type: "structure",
          members: {
            ErrorCode: {},
            ErrorMessage: {}
          }
        },
        S1c: {
          type: "structure",
          required: [
            "Values"
          ],
          members: {
            Values: {
              shape: "S6"
            }
          }
        },
        S1w: {
          type: "structure",
          members: {
            Name: {},
            Description: {},
            CreatedOn: {
              type: "timestamp"
            },
            LastModifiedOn: {
              type: "timestamp"
            },
            ParameterSpec: {},
            BlueprintLocation: {},
            BlueprintServiceLocation: {},
            Status: {},
            ErrorMessage: {},
            LastActiveDefinition: {
              type: "structure",
              members: {
                Description: {},
                LastModifiedOn: {
                  type: "timestamp"
                },
                ParameterSpec: {},
                BlueprintLocation: {},
                BlueprintServiceLocation: {}
              }
            }
          }
        },
        S24: {
          type: "list",
          member: {}
        },
        S26: {
          type: "list",
          member: {}
        },
        S28: {
          type: "list",
          member: {
            shape: "S29"
          }
        },
        S29: {
          type: "structure",
          members: {
            Name: {},
            Role: {},
            Targets: {
              shape: "S2b"
            },
            DatabaseName: {},
            Description: {},
            Classifiers: {
              shape: "S32"
            },
            RecrawlPolicy: {
              shape: "S33"
            },
            SchemaChangePolicy: {
              shape: "S35"
            },
            LineageConfiguration: {
              shape: "S38"
            },
            State: {},
            TablePrefix: {},
            Schedule: {
              type: "structure",
              members: {
                ScheduleExpression: {},
                State: {}
              }
            },
            CrawlElapsedTime: {
              type: "long"
            },
            CreationTime: {
              type: "timestamp"
            },
            LastUpdated: {
              type: "timestamp"
            },
            LastCrawl: {
              type: "structure",
              members: {
                Status: {},
                ErrorMessage: {},
                LogGroup: {},
                LogStream: {},
                MessagePrefix: {},
                StartTime: {
                  type: "timestamp"
                }
              }
            },
            Version: {
              type: "long"
            },
            Configuration: {},
            CrawlerSecurityConfiguration: {},
            LakeFormationConfiguration: {
              shape: "S3o"
            }
          }
        },
        S2b: {
          type: "structure",
          members: {
            S3Targets: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Path: {},
                  Exclusions: {
                    shape: "S2f"
                  },
                  ConnectionName: {},
                  SampleSize: {
                    type: "integer"
                  },
                  EventQueueArn: {},
                  DlqEventQueueArn: {}
                }
              }
            },
            JdbcTargets: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  ConnectionName: {},
                  Path: {},
                  Exclusions: {
                    shape: "S2f"
                  },
                  EnableAdditionalMetadata: {
                    type: "list",
                    member: {}
                  }
                }
              }
            },
            MongoDBTargets: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  ConnectionName: {},
                  Path: {},
                  ScanAll: {
                    type: "boolean"
                  }
                }
              }
            },
            DynamoDBTargets: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Path: {},
                  scanAll: {
                    type: "boolean"
                  },
                  scanRate: {
                    type: "double"
                  }
                }
              }
            },
            CatalogTargets: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "DatabaseName",
                  "Tables"
                ],
                members: {
                  DatabaseName: {},
                  Tables: {
                    type: "list",
                    member: {}
                  },
                  ConnectionName: {},
                  EventQueueArn: {},
                  DlqEventQueueArn: {}
                }
              }
            },
            DeltaTargets: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  DeltaTables: {
                    shape: "S2f"
                  },
                  ConnectionName: {},
                  WriteManifest: {
                    type: "boolean"
                  },
                  CreateNativeDeltaTable: {
                    type: "boolean"
                  }
                }
              }
            },
            IcebergTargets: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Paths: {
                    shape: "S2f"
                  },
                  ConnectionName: {},
                  Exclusions: {
                    shape: "S2f"
                  },
                  MaximumTraversalDepth: {
                    type: "integer"
                  }
                }
              }
            },
            HudiTargets: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Paths: {
                    shape: "S2f"
                  },
                  ConnectionName: {},
                  Exclusions: {
                    shape: "S2f"
                  },
                  MaximumTraversalDepth: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        S2f: {
          type: "list",
          member: {}
        },
        S32: {
          type: "list",
          member: {}
        },
        S33: {
          type: "structure",
          members: {
            RecrawlBehavior: {}
          }
        },
        S35: {
          type: "structure",
          members: {
            UpdateBehavior: {},
            DeleteBehavior: {}
          }
        },
        S38: {
          type: "structure",
          members: {
            CrawlerLineageSettings: {}
          }
        },
        S3o: {
          type: "structure",
          members: {
            UseLakeFormationCredentials: {
              type: "boolean"
            },
            AccountId: {}
          }
        },
        S3r: {
          type: "list",
          member: {}
        },
        S3t: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "RegexString"
            ],
            members: {
              Name: {},
              RegexString: {},
              ContextWords: {
                shape: "S3v"
              }
            }
          }
        },
        S3v: {
          type: "list",
          member: {}
        },
        S3x: {
          type: "list",
          member: {}
        },
        S43: {
          type: "structure",
          required: [
            "GlueTable"
          ],
          members: {
            GlueTable: {
              shape: "S44"
            }
          }
        },
        S44: {
          type: "structure",
          required: [
            "DatabaseName",
            "TableName"
          ],
          members: {
            DatabaseName: {},
            TableName: {},
            CatalogId: {},
            ConnectionName: {},
            AdditionalOptions: {
              type: "map",
              key: {},
              value: {}
            }
          }
        },
        S46: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Description: {},
              EvaluationMessage: {},
              Result: {},
              EvaluatedMetrics: {
                shape: "S4a"
              }
            }
          }
        },
        S4a: {
          type: "map",
          key: {},
          value: {
            type: "double"
          }
        },
        S4b: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Description: {},
              EvaluationMessage: {},
              EvaluatedMetrics: {
                shape: "S4a"
              }
            }
          }
        },
        S4d: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Description: {},
              MetricBasedObservation: {
                type: "structure",
                members: {
                  MetricName: {},
                  MetricValues: {
                    type: "structure",
                    members: {
                      ActualValue: {
                        type: "double"
                      },
                      ExpectedValue: {
                        type: "double"
                      },
                      LowerLimit: {
                        type: "double"
                      },
                      UpperLimit: {
                        type: "double"
                      }
                    }
                  },
                  NewRules: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          }
        },
        S4k: {
          type: "list",
          member: {}
        },
        S4m: {
          type: "list",
          member: {
            shape: "S4n"
          }
        },
        S4n: {
          type: "structure",
          members: {
            EndpointName: {},
            RoleArn: {},
            SecurityGroupIds: {
              shape: "S4p"
            },
            SubnetId: {},
            YarnEndpointAddress: {},
            PrivateAddress: {},
            ZeppelinRemoteSparkInterpreterPort: {
              type: "integer"
            },
            PublicAddress: {},
            Status: {},
            WorkerType: {},
            GlueVersion: {},
            NumberOfWorkers: {
              type: "integer"
            },
            NumberOfNodes: {
              type: "integer"
            },
            AvailabilityZone: {},
            VpcId: {},
            ExtraPythonLibsS3Path: {},
            ExtraJarsS3Path: {},
            FailureReason: {},
            LastUpdateStatus: {},
            CreatedTimestamp: {
              type: "timestamp"
            },
            LastModifiedTimestamp: {
              type: "timestamp"
            },
            PublicKey: {},
            PublicKeys: {
              shape: "S4t"
            },
            SecurityConfiguration: {},
            Arguments: {
              shape: "S4u"
            }
          }
        },
        S4p: {
          type: "list",
          member: {}
        },
        S4t: {
          type: "list",
          member: {}
        },
        S4u: {
          type: "map",
          key: {},
          value: {}
        },
        S4w: {
          type: "list",
          member: {}
        },
        S4y: {
          type: "list",
          member: {
            shape: "S4z"
          }
        },
        S4z: {
          type: "structure",
          members: {
            Name: {},
            Description: {},
            LogUri: {},
            Role: {},
            CreatedOn: {
              type: "timestamp"
            },
            LastModifiedOn: {
              type: "timestamp"
            },
            ExecutionProperty: {
              shape: "S52"
            },
            Command: {
              shape: "S54"
            },
            DefaultArguments: {
              shape: "S58"
            },
            NonOverridableArguments: {
              shape: "S58"
            },
            Connections: {
              shape: "S59"
            },
            MaxRetries: {
              type: "integer"
            },
            AllocatedCapacity: {
              deprecated: true,
              deprecatedMessage: "This property is deprecated, use MaxCapacity instead.",
              type: "integer"
            },
            Timeout: {
              type: "integer"
            },
            MaxCapacity: {
              type: "double"
            },
            WorkerType: {},
            NumberOfWorkers: {
              type: "integer"
            },
            SecurityConfiguration: {},
            NotificationProperty: {
              shape: "S5d"
            },
            GlueVersion: {},
            CodeGenConfigurationNodes: {
              shape: "S5f"
            },
            ExecutionClass: {},
            SourceControlDetails: {
              shape: "Sa9"
            }
          }
        },
        S52: {
          type: "structure",
          members: {
            MaxConcurrentRuns: {
              type: "integer"
            }
          }
        },
        S54: {
          type: "structure",
          members: {
            Name: {},
            ScriptLocation: {},
            PythonVersion: {},
            Runtime: {}
          }
        },
        S58: {
          type: "map",
          key: {},
          value: {}
        },
        S59: {
          type: "structure",
          members: {
            Connections: {
              shape: "S5a"
            }
          }
        },
        S5a: {
          type: "list",
          member: {}
        },
        S5d: {
          type: "structure",
          members: {
            NotifyDelayAfter: {
              type: "integer"
            }
          }
        },
        S5f: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              AthenaConnectorSource: {
                type: "structure",
                required: [
                  "Name",
                  "ConnectionName",
                  "ConnectorName",
                  "ConnectionType",
                  "SchemaName"
                ],
                members: {
                  Name: {},
                  ConnectionName: {},
                  ConnectorName: {},
                  ConnectionType: {},
                  ConnectionTable: {},
                  SchemaName: {},
                  OutputSchemas: {
                    shape: "S5m"
                  }
                }
              },
              JDBCConnectorSource: {
                type: "structure",
                required: [
                  "Name",
                  "ConnectionName",
                  "ConnectorName",
                  "ConnectionType"
                ],
                members: {
                  Name: {},
                  ConnectionName: {},
                  ConnectorName: {},
                  ConnectionType: {},
                  AdditionalOptions: {
                    type: "structure",
                    members: {
                      FilterPredicate: {},
                      PartitionColumn: {},
                      LowerBound: {
                        type: "long"
                      },
                      UpperBound: {
                        type: "long"
                      },
                      NumPartitions: {
                        type: "long"
                      },
                      JobBookmarkKeys: {
                        shape: "S5u"
                      },
                      JobBookmarkKeysSortOrder: {},
                      DataTypeMapping: {
                        type: "map",
                        key: {},
                        value: {}
                      }
                    }
                  },
                  ConnectionTable: {},
                  Query: {},
                  OutputSchemas: {
                    shape: "S5m"
                  }
                }
              },
              SparkConnectorSource: {
                type: "structure",
                required: [
                  "Name",
                  "ConnectionName",
                  "ConnectorName",
                  "ConnectionType"
                ],
                members: {
                  Name: {},
                  ConnectionName: {},
                  ConnectorName: {},
                  ConnectionType: {},
                  AdditionalOptions: {
                    shape: "S60"
                  },
                  OutputSchemas: {
                    shape: "S5m"
                  }
                }
              },
              CatalogSource: {
                type: "structure",
                required: [
                  "Name",
                  "Database",
                  "Table"
                ],
                members: {
                  Name: {},
                  Database: {},
                  Table: {}
                }
              },
              RedshiftSource: {
                type: "structure",
                required: [
                  "Name",
                  "Database",
                  "Table"
                ],
                members: {
                  Name: {},
                  Database: {},
                  Table: {},
                  RedshiftTmpDir: {},
                  TmpDirIAMRole: {}
                }
              },
              S3CatalogSource: {
                type: "structure",
                required: [
                  "Name",
                  "Database",
                  "Table"
                ],
                members: {
                  Name: {},
                  Database: {},
                  Table: {},
                  PartitionPredicate: {},
                  AdditionalOptions: {
                    shape: "S64"
                  }
                }
              },
              S3CsvSource: {
                type: "structure",
                required: [
                  "Name",
                  "Paths",
                  "Separator",
                  "QuoteChar"
                ],
                members: {
                  Name: {},
                  Paths: {
                    shape: "S5u"
                  },
                  CompressionType: {},
                  Exclusions: {
                    shape: "S5u"
                  },
                  GroupSize: {},
                  GroupFiles: {},
                  Recurse: {
                    type: "boolean"
                  },
                  MaxBand: {
                    type: "integer"
                  },
                  MaxFilesInBand: {
                    type: "integer"
                  },
                  AdditionalOptions: {
                    shape: "S6a"
                  },
                  Separator: {},
                  Escaper: {},
                  QuoteChar: {},
                  Multiline: {
                    type: "boolean"
                  },
                  WithHeader: {
                    type: "boolean"
                  },
                  WriteHeader: {
                    type: "boolean"
                  },
                  SkipFirst: {
                    type: "boolean"
                  },
                  OptimizePerformance: {
                    type: "boolean"
                  },
                  OutputSchemas: {
                    shape: "S5m"
                  }
                }
              },
              S3JsonSource: {
                type: "structure",
                required: [
                  "Name",
                  "Paths"
                ],
                members: {
                  Name: {},
                  Paths: {
                    shape: "S5u"
                  },
                  CompressionType: {},
                  Exclusions: {
                    shape: "S5u"
                  },
                  GroupSize: {},
                  GroupFiles: {},
                  Recurse: {
                    type: "boolean"
                  },
                  MaxBand: {
                    type: "integer"
                  },
                  MaxFilesInBand: {
                    type: "integer"
                  },
                  AdditionalOptions: {
                    shape: "S6a"
                  },
                  JsonPath: {},
                  Multiline: {
                    type: "boolean"
                  },
                  OutputSchemas: {
                    shape: "S5m"
                  }
                }
              },
              S3ParquetSource: {
                type: "structure",
                required: [
                  "Name",
                  "Paths"
                ],
                members: {
                  Name: {},
                  Paths: {
                    shape: "S5u"
                  },
                  CompressionType: {},
                  Exclusions: {
                    shape: "S5u"
                  },
                  GroupSize: {},
                  GroupFiles: {},
                  Recurse: {
                    type: "boolean"
                  },
                  MaxBand: {
                    type: "integer"
                  },
                  MaxFilesInBand: {
                    type: "integer"
                  },
                  AdditionalOptions: {
                    shape: "S6a"
                  },
                  OutputSchemas: {
                    shape: "S5m"
                  }
                }
              },
              RelationalCatalogSource: {
                type: "structure",
                required: [
                  "Name",
                  "Database",
                  "Table"
                ],
                members: {
                  Name: {},
                  Database: {},
                  Table: {}
                }
              },
              DynamoDBCatalogSource: {
                type: "structure",
                required: [
                  "Name",
                  "Database",
                  "Table"
                ],
                members: {
                  Name: {},
                  Database: {},
                  Table: {}
                }
              },
              JDBCConnectorTarget: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "ConnectionName",
                  "ConnectionTable",
                  "ConnectorName",
                  "ConnectionType"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  ConnectionName: {},
                  ConnectionTable: {},
                  ConnectorName: {},
                  ConnectionType: {},
                  AdditionalOptions: {
                    shape: "S60"
                  },
                  OutputSchemas: {
                    shape: "S5m"
                  }
                }
              },
              SparkConnectorTarget: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "ConnectionName",
                  "ConnectorName",
                  "ConnectionType"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  ConnectionName: {},
                  ConnectorName: {},
                  ConnectionType: {},
                  AdditionalOptions: {
                    shape: "S60"
                  },
                  OutputSchemas: {
                    shape: "S5m"
                  }
                }
              },
              CatalogTarget: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "Database",
                  "Table"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  Database: {},
                  Table: {}
                }
              },
              RedshiftTarget: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "Database",
                  "Table"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  Database: {},
                  Table: {},
                  RedshiftTmpDir: {},
                  TmpDirIAMRole: {},
                  UpsertRedshiftOptions: {
                    type: "structure",
                    members: {
                      TableLocation: {},
                      ConnectionName: {},
                      UpsertKeys: {
                        type: "list",
                        member: {}
                      }
                    }
                  }
                }
              },
              S3CatalogTarget: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "Table",
                  "Database"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  PartitionKeys: {
                    shape: "S6r"
                  },
                  Table: {},
                  Database: {},
                  SchemaChangePolicy: {
                    shape: "S6s"
                  }
                }
              },
              S3GlueParquetTarget: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "Path"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  PartitionKeys: {
                    shape: "S6r"
                  },
                  Path: {},
                  Compression: {},
                  SchemaChangePolicy: {
                    shape: "S6v"
                  }
                }
              },
              S3DirectTarget: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "Path",
                  "Format"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  PartitionKeys: {
                    shape: "S6r"
                  },
                  Path: {},
                  Compression: {},
                  Format: {},
                  SchemaChangePolicy: {
                    shape: "S6v"
                  }
                }
              },
              ApplyMapping: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "Mapping"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  Mapping: {
                    shape: "S6z"
                  }
                }
              },
              SelectFields: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "Paths"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  Paths: {
                    shape: "S6r"
                  }
                }
              },
              DropFields: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "Paths"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  Paths: {
                    shape: "S6r"
                  }
                }
              },
              RenameField: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "SourcePath",
                  "TargetPath"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  SourcePath: {
                    shape: "S5u"
                  },
                  TargetPath: {
                    shape: "S5u"
                  }
                }
              },
              Spigot: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "Path"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  Path: {},
                  Topk: {
                    type: "integer"
                  },
                  Prob: {
                    type: "double"
                  }
                }
              },
              Join: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "JoinType",
                  "Columns"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S78"
                  },
                  JoinType: {},
                  Columns: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "From",
                        "Keys"
                      ],
                      members: {
                        From: {},
                        Keys: {
                          shape: "S6r"
                        }
                      }
                    }
                  }
                }
              },
              SplitFields: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "Paths"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  Paths: {
                    shape: "S6r"
                  }
                }
              },
              SelectFromCollection: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "Index"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  Index: {
                    type: "integer"
                  }
                }
              },
              FillMissingValues: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "ImputedPath"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  ImputedPath: {},
                  FilledPath: {}
                }
              },
              Filter: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "LogicalOperator",
                  "Filters"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  LogicalOperator: {},
                  Filters: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Operation",
                        "Values"
                      ],
                      members: {
                        Operation: {},
                        Negated: {
                          type: "boolean"
                        },
                        Values: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "Type",
                              "Value"
                            ],
                            members: {
                              Type: {},
                              Value: {
                                shape: "S5u"
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              CustomCode: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "Code",
                  "ClassName"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S7p"
                  },
                  Code: {},
                  ClassName: {},
                  OutputSchemas: {
                    shape: "S5m"
                  }
                }
              },
              SparkSQL: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "SqlQuery",
                  "SqlAliases"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S7p"
                  },
                  SqlQuery: {},
                  SqlAliases: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "From",
                        "Alias"
                      ],
                      members: {
                        From: {},
                        Alias: {}
                      }
                    }
                  },
                  OutputSchemas: {
                    shape: "S5m"
                  }
                }
              },
              DirectKinesisSource: {
                type: "structure",
                required: [
                  "Name"
                ],
                members: {
                  Name: {},
                  WindowSize: {
                    type: "integer"
                  },
                  DetectSchema: {
                    type: "boolean"
                  },
                  StreamingOptions: {
                    shape: "S7w"
                  },
                  DataPreviewOptions: {
                    shape: "S7z"
                  }
                }
              },
              DirectKafkaSource: {
                type: "structure",
                required: [
                  "Name"
                ],
                members: {
                  Name: {},
                  StreamingOptions: {
                    shape: "S83"
                  },
                  WindowSize: {
                    type: "integer"
                  },
                  DetectSchema: {
                    type: "boolean"
                  },
                  DataPreviewOptions: {
                    shape: "S7z"
                  }
                }
              },
              CatalogKinesisSource: {
                type: "structure",
                required: [
                  "Name",
                  "Table",
                  "Database"
                ],
                members: {
                  Name: {},
                  WindowSize: {
                    type: "integer"
                  },
                  DetectSchema: {
                    type: "boolean"
                  },
                  Table: {},
                  Database: {},
                  StreamingOptions: {
                    shape: "S7w"
                  },
                  DataPreviewOptions: {
                    shape: "S7z"
                  }
                }
              },
              CatalogKafkaSource: {
                type: "structure",
                required: [
                  "Name",
                  "Table",
                  "Database"
                ],
                members: {
                  Name: {},
                  WindowSize: {
                    type: "integer"
                  },
                  DetectSchema: {
                    type: "boolean"
                  },
                  Table: {},
                  Database: {},
                  StreamingOptions: {
                    shape: "S83"
                  },
                  DataPreviewOptions: {
                    shape: "S7z"
                  }
                }
              },
              DropNullFields: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  NullCheckBoxList: {
                    type: "structure",
                    members: {
                      IsEmpty: {
                        type: "boolean"
                      },
                      IsNullString: {
                        type: "boolean"
                      },
                      IsNegOne: {
                        type: "boolean"
                      }
                    }
                  },
                  NullTextList: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Value",
                        "Datatype"
                      ],
                      members: {
                        Value: {},
                        Datatype: {
                          type: "structure",
                          required: [
                            "Id",
                            "Label"
                          ],
                          members: {
                            Id: {},
                            Label: {}
                          }
                        }
                      }
                    }
                  }
                }
              },
              Merge: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "Source",
                  "PrimaryKeys"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S78"
                  },
                  Source: {},
                  PrimaryKeys: {
                    shape: "S6r"
                  }
                }
              },
              Union: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "UnionType"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S78"
                  },
                  UnionType: {}
                }
              },
              PIIDetection: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "PiiType",
                  "EntityTypesToDetect"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  PiiType: {},
                  EntityTypesToDetect: {
                    shape: "S5u"
                  },
                  OutputColumnName: {},
                  SampleFraction: {
                    type: "double"
                  },
                  ThresholdFraction: {
                    type: "double"
                  },
                  MaskValue: {}
                }
              },
              Aggregate: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "Groups",
                  "Aggs"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  Groups: {
                    shape: "S6r"
                  },
                  Aggs: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Column",
                        "AggFunc"
                      ],
                      members: {
                        Column: {
                          shape: "S5u"
                        },
                        AggFunc: {}
                      }
                    }
                  }
                }
              },
              DropDuplicates: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  Columns: {
                    type: "list",
                    member: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              GovernedCatalogTarget: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "Table",
                  "Database"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  PartitionKeys: {
                    shape: "S6r"
                  },
                  Table: {},
                  Database: {},
                  SchemaChangePolicy: {
                    shape: "S6s"
                  }
                }
              },
              GovernedCatalogSource: {
                type: "structure",
                required: [
                  "Name",
                  "Database",
                  "Table"
                ],
                members: {
                  Name: {},
                  Database: {},
                  Table: {},
                  PartitionPredicate: {},
                  AdditionalOptions: {
                    shape: "S64"
                  }
                }
              },
              MicrosoftSQLServerCatalogSource: {
                type: "structure",
                required: [
                  "Name",
                  "Database",
                  "Table"
                ],
                members: {
                  Name: {},
                  Database: {},
                  Table: {}
                }
              },
              MySQLCatalogSource: {
                type: "structure",
                required: [
                  "Name",
                  "Database",
                  "Table"
                ],
                members: {
                  Name: {},
                  Database: {},
                  Table: {}
                }
              },
              OracleSQLCatalogSource: {
                type: "structure",
                required: [
                  "Name",
                  "Database",
                  "Table"
                ],
                members: {
                  Name: {},
                  Database: {},
                  Table: {}
                }
              },
              PostgreSQLCatalogSource: {
                type: "structure",
                required: [
                  "Name",
                  "Database",
                  "Table"
                ],
                members: {
                  Name: {},
                  Database: {},
                  Table: {}
                }
              },
              MicrosoftSQLServerCatalogTarget: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "Database",
                  "Table"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  Database: {},
                  Table: {}
                }
              },
              MySQLCatalogTarget: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "Database",
                  "Table"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  Database: {},
                  Table: {}
                }
              },
              OracleSQLCatalogTarget: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "Database",
                  "Table"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  Database: {},
                  Table: {}
                }
              },
              PostgreSQLCatalogTarget: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "Database",
                  "Table"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  Database: {},
                  Table: {}
                }
              },
              DynamicTransform: {
                type: "structure",
                required: [
                  "Name",
                  "TransformName",
                  "Inputs",
                  "FunctionName",
                  "Path"
                ],
                members: {
                  Name: {},
                  TransformName: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  Parameters: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Name",
                        "Type"
                      ],
                      members: {
                        Name: {},
                        Type: {},
                        ValidationRule: {},
                        ValidationMessage: {},
                        Value: {
                          shape: "S5u"
                        },
                        ListType: {},
                        IsOptional: {
                          type: "boolean"
                        }
                      }
                    }
                  },
                  FunctionName: {},
                  Path: {},
                  Version: {},
                  OutputSchemas: {
                    shape: "S5m"
                  }
                }
              },
              EvaluateDataQuality: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "Ruleset"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  Ruleset: {},
                  Output: {},
                  PublishingOptions: {
                    shape: "S97"
                  },
                  StopJobOnFailureOptions: {
                    shape: "S98"
                  }
                }
              },
              S3CatalogHudiSource: {
                type: "structure",
                required: [
                  "Name",
                  "Database",
                  "Table"
                ],
                members: {
                  Name: {},
                  Database: {},
                  Table: {},
                  AdditionalHudiOptions: {
                    shape: "S60"
                  },
                  OutputSchemas: {
                    shape: "S5m"
                  }
                }
              },
              CatalogHudiSource: {
                type: "structure",
                required: [
                  "Name",
                  "Database",
                  "Table"
                ],
                members: {
                  Name: {},
                  Database: {},
                  Table: {},
                  AdditionalHudiOptions: {
                    shape: "S60"
                  },
                  OutputSchemas: {
                    shape: "S5m"
                  }
                }
              },
              S3HudiSource: {
                type: "structure",
                required: [
                  "Name",
                  "Paths"
                ],
                members: {
                  Name: {},
                  Paths: {
                    shape: "S5u"
                  },
                  AdditionalHudiOptions: {
                    shape: "S60"
                  },
                  AdditionalOptions: {
                    shape: "S6a"
                  },
                  OutputSchemas: {
                    shape: "S5m"
                  }
                }
              },
              S3HudiCatalogTarget: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "Table",
                  "Database",
                  "AdditionalOptions"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  PartitionKeys: {
                    shape: "S6r"
                  },
                  Table: {},
                  Database: {},
                  AdditionalOptions: {
                    shape: "S60"
                  },
                  SchemaChangePolicy: {
                    shape: "S6s"
                  }
                }
              },
              S3HudiDirectTarget: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "Path",
                  "Compression",
                  "Format",
                  "AdditionalOptions"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  Path: {},
                  Compression: {},
                  PartitionKeys: {
                    shape: "S6r"
                  },
                  Format: {},
                  AdditionalOptions: {
                    shape: "S60"
                  },
                  SchemaChangePolicy: {
                    shape: "S6v"
                  }
                }
              },
              DirectJDBCSource: {
                type: "structure",
                required: [
                  "Name",
                  "Database",
                  "Table",
                  "ConnectionName",
                  "ConnectionType"
                ],
                members: {
                  Name: {},
                  Database: {},
                  Table: {},
                  ConnectionName: {},
                  ConnectionType: {},
                  RedshiftTmpDir: {}
                }
              },
              S3CatalogDeltaSource: {
                type: "structure",
                required: [
                  "Name",
                  "Database",
                  "Table"
                ],
                members: {
                  Name: {},
                  Database: {},
                  Table: {},
                  AdditionalDeltaOptions: {
                    shape: "S60"
                  },
                  OutputSchemas: {
                    shape: "S5m"
                  }
                }
              },
              CatalogDeltaSource: {
                type: "structure",
                required: [
                  "Name",
                  "Database",
                  "Table"
                ],
                members: {
                  Name: {},
                  Database: {},
                  Table: {},
                  AdditionalDeltaOptions: {
                    shape: "S60"
                  },
                  OutputSchemas: {
                    shape: "S5m"
                  }
                }
              },
              S3DeltaSource: {
                type: "structure",
                required: [
                  "Name",
                  "Paths"
                ],
                members: {
                  Name: {},
                  Paths: {
                    shape: "S5u"
                  },
                  AdditionalDeltaOptions: {
                    shape: "S60"
                  },
                  AdditionalOptions: {
                    shape: "S6a"
                  },
                  OutputSchemas: {
                    shape: "S5m"
                  }
                }
              },
              S3DeltaCatalogTarget: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "Table",
                  "Database"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  PartitionKeys: {
                    shape: "S6r"
                  },
                  Table: {},
                  Database: {},
                  AdditionalOptions: {
                    shape: "S60"
                  },
                  SchemaChangePolicy: {
                    shape: "S6s"
                  }
                }
              },
              S3DeltaDirectTarget: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "Path",
                  "Compression",
                  "Format"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  PartitionKeys: {
                    shape: "S6r"
                  },
                  Path: {},
                  Compression: {},
                  Format: {},
                  AdditionalOptions: {
                    shape: "S60"
                  },
                  SchemaChangePolicy: {
                    shape: "S6v"
                  }
                }
              },
              AmazonRedshiftSource: {
                type: "structure",
                members: {
                  Name: {},
                  Data: {
                    shape: "S9p"
                  }
                }
              },
              AmazonRedshiftTarget: {
                type: "structure",
                members: {
                  Name: {},
                  Data: {
                    shape: "S9p"
                  },
                  Inputs: {
                    shape: "S6k"
                  }
                }
              },
              EvaluateDataQualityMultiFrame: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "Ruleset"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S7p"
                  },
                  AdditionalDataSources: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  Ruleset: {},
                  PublishingOptions: {
                    shape: "S97"
                  },
                  AdditionalOptions: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  StopJobOnFailureOptions: {
                    shape: "S98"
                  }
                }
              },
              Recipe: {
                type: "structure",
                required: [
                  "Name",
                  "Inputs",
                  "RecipeReference"
                ],
                members: {
                  Name: {},
                  Inputs: {
                    shape: "S6k"
                  },
                  RecipeReference: {
                    type: "structure",
                    required: [
                      "RecipeArn",
                      "RecipeVersion"
                    ],
                    members: {
                      RecipeArn: {},
                      RecipeVersion: {}
                    }
                  }
                }
              },
              SnowflakeSource: {
                type: "structure",
                required: [
                  "Name",
                  "Data"
                ],
                members: {
                  Name: {},
                  Data: {
                    shape: "Sa3"
                  },
                  OutputSchemas: {
                    shape: "S5m"
                  }
                }
              },
              SnowflakeTarget: {
                type: "structure",
                required: [
                  "Name",
                  "Data"
                ],
                members: {
                  Name: {},
                  Data: {
                    shape: "Sa3"
                  },
                  Inputs: {
                    shape: "S6k"
                  }
                }
              },
              ConnectorDataSource: {
                type: "structure",
                required: [
                  "Name",
                  "ConnectionType",
                  "Data"
                ],
                members: {
                  Name: {},
                  ConnectionType: {},
                  Data: {
                    shape: "Sa6"
                  },
                  OutputSchemas: {
                    shape: "S5m"
                  }
                }
              },
              ConnectorDataTarget: {
                type: "structure",
                required: [
                  "Name",
                  "ConnectionType",
                  "Data"
                ],
                members: {
                  Name: {},
                  ConnectionType: {},
                  Data: {
                    shape: "Sa6"
                  },
                  Inputs: {
                    shape: "S6k"
                  }
                }
              }
            }
          },
          sensitive: true
        },
        S5m: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Columns: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name"
                  ],
                  members: {
                    Name: {},
                    Type: {}
                  }
                }
              }
            }
          }
        },
        S5u: {
          type: "list",
          member: {}
        },
        S60: {
          type: "map",
          key: {},
          value: {}
        },
        S64: {
          type: "structure",
          members: {
            BoundedSize: {
              type: "long"
            },
            BoundedFiles: {
              type: "long"
            }
          }
        },
        S6a: {
          type: "structure",
          members: {
            BoundedSize: {
              type: "long"
            },
            BoundedFiles: {
              type: "long"
            },
            EnableSamplePath: {
              type: "boolean"
            },
            SamplePath: {}
          }
        },
        S6k: {
          type: "list",
          member: {}
        },
        S6r: {
          type: "list",
          member: {
            shape: "S5u"
          }
        },
        S6s: {
          type: "structure",
          members: {
            EnableUpdateCatalog: {
              type: "boolean"
            },
            UpdateBehavior: {}
          }
        },
        S6v: {
          type: "structure",
          members: {
            EnableUpdateCatalog: {
              type: "boolean"
            },
            UpdateBehavior: {},
            Table: {},
            Database: {}
          }
        },
        S6z: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ToKey: {},
              FromPath: {
                shape: "S5u"
              },
              FromType: {},
              ToType: {},
              Dropped: {
                type: "boolean"
              },
              Children: {
                shape: "S6z"
              }
            }
          }
        },
        S78: {
          type: "list",
          member: {}
        },
        S7p: {
          type: "list",
          member: {}
        },
        S7w: {
          type: "structure",
          members: {
            EndpointUrl: {},
            StreamName: {},
            Classification: {},
            Delimiter: {},
            StartingPosition: {},
            MaxFetchTimeInMs: {
              type: "long"
            },
            MaxFetchRecordsPerShard: {
              type: "long"
            },
            MaxRecordPerRead: {
              type: "long"
            },
            AddIdleTimeBetweenReads: {
              type: "boolean"
            },
            IdleTimeBetweenReadsInMs: {
              type: "long"
            },
            DescribeShardInterval: {
              type: "long"
            },
            NumRetries: {
              type: "integer"
            },
            RetryIntervalMs: {
              type: "long"
            },
            MaxRetryIntervalMs: {
              type: "long"
            },
            AvoidEmptyBatches: {
              type: "boolean"
            },
            StreamArn: {},
            RoleArn: {},
            RoleSessionName: {},
            AddRecordTimestamp: {},
            EmitConsumerLagMetrics: {},
            StartingTimestamp: {
              shape: "S7y"
            }
          }
        },
        S7y: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S7z: {
          type: "structure",
          members: {
            PollingTime: {
              type: "long"
            },
            RecordPollingLimit: {
              type: "long"
            }
          }
        },
        S83: {
          type: "structure",
          members: {
            BootstrapServers: {},
            SecurityProtocol: {},
            ConnectionName: {},
            TopicName: {},
            Assign: {},
            SubscribePattern: {},
            Classification: {},
            Delimiter: {},
            StartingOffsets: {},
            EndingOffsets: {},
            PollTimeoutMs: {
              type: "long"
            },
            NumRetries: {
              type: "integer"
            },
            RetryIntervalMs: {
              type: "long"
            },
            MaxOffsetsPerTrigger: {
              type: "long"
            },
            MinPartitions: {
              type: "integer"
            },
            IncludeHeaders: {
              type: "boolean"
            },
            AddRecordTimestamp: {},
            EmitConsumerLagMetrics: {},
            StartingTimestamp: {
              shape: "S7y"
            }
          }
        },
        S97: {
          type: "structure",
          members: {
            EvaluationContext: {},
            ResultsS3Prefix: {},
            CloudWatchMetricsEnabled: {
              type: "boolean"
            },
            ResultsPublishingEnabled: {
              type: "boolean"
            }
          }
        },
        S98: {
          type: "structure",
          members: {
            StopJobOnFailureTiming: {}
          }
        },
        S9p: {
          type: "structure",
          members: {
            AccessType: {},
            SourceType: {},
            Connection: {
              shape: "S9q"
            },
            Schema: {
              shape: "S9q"
            },
            Table: {
              shape: "S9q"
            },
            CatalogDatabase: {
              shape: "S9q"
            },
            CatalogTable: {
              shape: "S9q"
            },
            CatalogRedshiftSchema: {},
            CatalogRedshiftTable: {},
            TempDir: {},
            IamRole: {
              shape: "S9q"
            },
            AdvancedOptions: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Key: {},
                  Value: {}
                }
              }
            },
            SampleQuery: {},
            PreAction: {},
            PostAction: {},
            Action: {},
            TablePrefix: {},
            Upsert: {
              type: "boolean"
            },
            MergeAction: {},
            MergeWhenMatched: {},
            MergeWhenNotMatched: {},
            MergeClause: {},
            CrawlerConnection: {},
            TableSchema: {
              shape: "S9t"
            },
            StagingTable: {},
            SelectedColumns: {
              shape: "S9t"
            }
          }
        },
        S9q: {
          type: "structure",
          members: {
            Value: {},
            Label: {},
            Description: {}
          }
        },
        S9t: {
          type: "list",
          member: {
            shape: "S9q"
          }
        },
        Sa3: {
          type: "structure",
          members: {
            SourceType: {},
            Connection: {
              shape: "S9q"
            },
            Schema: {},
            Table: {},
            Database: {},
            TempDir: {},
            IamRole: {
              shape: "S9q"
            },
            AdditionalOptions: {
              shape: "S60"
            },
            SampleQuery: {},
            PreAction: {},
            PostAction: {},
            Action: {},
            Upsert: {
              type: "boolean"
            },
            MergeAction: {},
            MergeWhenMatched: {},
            MergeWhenNotMatched: {},
            MergeClause: {},
            StagingTable: {},
            SelectedColumns: {
              shape: "S9t"
            },
            AutoPushdown: {
              type: "boolean"
            },
            TableSchema: {
              shape: "S9t"
            }
          }
        },
        Sa6: {
          type: "map",
          key: {},
          value: {}
        },
        Sa9: {
          type: "structure",
          members: {
            Provider: {},
            Repository: {},
            Owner: {},
            Branch: {},
            Folder: {},
            LastCommitId: {},
            AuthStrategy: {},
            AuthToken: {}
          }
        },
        Sad: {
          type: "list",
          member: {
            shape: "S1c"
          }
        },
        Saf: {
          type: "list",
          member: {
            shape: "Sag"
          }
        },
        Sag: {
          type: "structure",
          members: {
            Values: {
              shape: "S6"
            },
            DatabaseName: {},
            TableName: {},
            CreationTime: {
              type: "timestamp"
            },
            LastAccessTime: {
              type: "timestamp"
            },
            StorageDescriptor: {
              shape: "S9"
            },
            Parameters: {
              shape: "Se"
            },
            LastAnalyzedTime: {
              type: "timestamp"
            },
            CatalogId: {}
          }
        },
        Saq: {
          type: "structure",
          members: {
            type: {},
            configuration: {
              shape: "Sar"
            },
            lastRun: {
              shape: "Sat"
            }
          }
        },
        Sar: {
          type: "structure",
          members: {
            roleArn: {},
            enabled: {
              type: "boolean"
            }
          }
        },
        Sat: {
          type: "structure",
          members: {
            eventType: {},
            startTimestamp: {
              type: "timestamp"
            },
            endTimestamp: {
              type: "timestamp"
            },
            metrics: {
              type: "structure",
              members: {
                NumberOfBytesCompacted: {},
                NumberOfFilesCompacted: {},
                NumberOfDpus: {},
                JobDurationInHour: {}
              }
            },
            error: {}
          }
        },
        Sb1: {
          type: "list",
          member: {}
        },
        Sb3: {
          type: "list",
          member: {
            shape: "Sb4"
          }
        },
        Sb4: {
          type: "structure",
          members: {
            Name: {},
            WorkflowName: {},
            Id: {},
            Type: {},
            State: {},
            Description: {},
            Schedule: {},
            Actions: {
              shape: "Sb8"
            },
            Predicate: {
              shape: "Sba"
            },
            EventBatchingCondition: {
              shape: "Sbh"
            }
          }
        },
        Sb8: {
          type: "list",
          member: {
            type: "structure",
            members: {
              JobName: {},
              Arguments: {
                shape: "S58"
              },
              Timeout: {
                type: "integer"
              },
              SecurityConfiguration: {},
              NotificationProperty: {
                shape: "S5d"
              },
              CrawlerName: {}
            }
          }
        },
        Sba: {
          type: "structure",
          members: {
            Logical: {},
            Conditions: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  LogicalOperator: {},
                  JobName: {},
                  State: {},
                  CrawlerName: {},
                  CrawlState: {}
                }
              }
            }
          }
        },
        Sbh: {
          type: "structure",
          required: [
            "BatchSize"
          ],
          members: {
            BatchSize: {
              type: "integer"
            },
            BatchWindow: {
              type: "integer"
            }
          }
        },
        Sbl: {
          type: "list",
          member: {}
        },
        Sbo: {
          type: "structure",
          members: {
            Name: {},
            Description: {},
            DefaultRunProperties: {
              shape: "Sbp"
            },
            CreatedOn: {
              type: "timestamp"
            },
            LastModifiedOn: {
              type: "timestamp"
            },
            LastRun: {
              shape: "Sbq"
            },
            Graph: {
              shape: "Sbt"
            },
            MaxConcurrentRuns: {
              type: "integer"
            },
            BlueprintDetails: {
              type: "structure",
              members: {
                BlueprintName: {},
                RunId: {}
              }
            }
          }
        },
        Sbp: {
          type: "map",
          key: {},
          value: {}
        },
        Sbq: {
          type: "structure",
          members: {
            Name: {},
            WorkflowRunId: {},
            PreviousRunId: {},
            WorkflowRunProperties: {
              shape: "Sbp"
            },
            StartedOn: {
              type: "timestamp"
            },
            CompletedOn: {
              type: "timestamp"
            },
            Status: {},
            ErrorMessage: {},
            Statistics: {
              type: "structure",
              members: {
                TotalActions: {
                  type: "integer"
                },
                TimeoutActions: {
                  type: "integer"
                },
                FailedActions: {
                  type: "integer"
                },
                StoppedActions: {
                  type: "integer"
                },
                SucceededActions: {
                  type: "integer"
                },
                RunningActions: {
                  type: "integer"
                },
                ErroredActions: {
                  type: "integer"
                },
                WaitingActions: {
                  type: "integer"
                }
              }
            },
            Graph: {
              shape: "Sbt"
            },
            StartingEventBatchCondition: {
              type: "structure",
              members: {
                BatchSize: {
                  type: "integer"
                },
                BatchWindow: {
                  type: "integer"
                }
              }
            }
          }
        },
        Sbt: {
          type: "structure",
          members: {
            Nodes: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Type: {},
                  Name: {},
                  UniqueId: {},
                  TriggerDetails: {
                    type: "structure",
                    members: {
                      Trigger: {
                        shape: "Sb4"
                      }
                    }
                  },
                  JobDetails: {
                    type: "structure",
                    members: {
                      JobRuns: {
                        shape: "Sbz"
                      }
                    }
                  },
                  CrawlerDetails: {
                    type: "structure",
                    members: {
                      Crawls: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            State: {},
                            StartedOn: {
                              type: "timestamp"
                            },
                            CompletedOn: {
                              type: "timestamp"
                            },
                            ErrorMessage: {},
                            LogGroup: {},
                            LogStream: {}
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            Edges: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  SourceId: {},
                  DestinationId: {}
                }
              }
            }
          }
        },
        Sbz: {
          type: "list",
          member: {
            shape: "Sc0"
          }
        },
        Sc0: {
          type: "structure",
          members: {
            Id: {},
            Attempt: {
              type: "integer"
            },
            PreviousRunId: {},
            TriggerName: {},
            JobName: {},
            StartedOn: {
              type: "timestamp"
            },
            LastModifiedOn: {
              type: "timestamp"
            },
            CompletedOn: {
              type: "timestamp"
            },
            JobRunState: {},
            Arguments: {
              shape: "S58"
            },
            ErrorMessage: {},
            PredecessorRuns: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  JobName: {},
                  RunId: {}
                }
              }
            },
            AllocatedCapacity: {
              deprecated: true,
              deprecatedMessage: "This property is deprecated, use MaxCapacity instead.",
              type: "integer"
            },
            ExecutionTime: {
              type: "integer"
            },
            Timeout: {
              type: "integer"
            },
            MaxCapacity: {
              type: "double"
            },
            WorkerType: {},
            NumberOfWorkers: {
              type: "integer"
            },
            SecurityConfiguration: {},
            LogGroupName: {},
            NotificationProperty: {
              shape: "S5d"
            },
            GlueVersion: {},
            DPUSeconds: {
              type: "double"
            },
            ExecutionClass: {}
          }
        },
        Scm: {
          type: "list",
          member: {}
        },
        Sd7: {
          type: "map",
          key: {},
          value: {}
        },
        Sdo: {
          type: "list",
          member: {}
        },
        Sdp: {
          type: "list",
          member: {}
        },
        Sdt: {
          type: "structure",
          required: [
            "Name",
            "ConnectionType",
            "ConnectionProperties"
          ],
          members: {
            Name: {},
            Description: {},
            ConnectionType: {},
            MatchCriteria: {
              shape: "Sdv"
            },
            ConnectionProperties: {
              shape: "Sdw"
            },
            PhysicalConnectionRequirements: {
              shape: "Sdy"
            }
          }
        },
        Sdv: {
          type: "list",
          member: {}
        },
        Sdw: {
          type: "map",
          key: {},
          value: {}
        },
        Sdy: {
          type: "structure",
          members: {
            SubnetId: {},
            SecurityGroupIdList: {
              type: "list",
              member: {}
            },
            AvailabilityZone: {}
          }
        },
        Se7: {
          type: "structure",
          required: [
            "TableName",
            "DatabaseName"
          ],
          members: {
            TableName: {},
            DatabaseName: {},
            CatalogId: {}
          }
        },
        Sea: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            Description: {},
            LocationUri: {},
            Parameters: {
              shape: "Se"
            },
            CreateTableDefaultPermissions: {
              shape: "Sec"
            },
            TargetDatabase: {
              shape: "Sei"
            },
            FederatedDatabase: {
              shape: "Sej"
            }
          }
        },
        Sec: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Principal: {
                type: "structure",
                members: {
                  DataLakePrincipalIdentifier: {}
                }
              },
              Permissions: {
                shape: "Seg"
              }
            }
          }
        },
        Seg: {
          type: "list",
          member: {}
        },
        Sei: {
          type: "structure",
          members: {
            CatalogId: {},
            DatabaseName: {},
            Region: {}
          }
        },
        Sej: {
          type: "structure",
          members: {
            Identifier: {},
            ConnectionName: {}
          }
        },
        Ser: {
          type: "list",
          member: {
            shape: "S44"
          }
        },
        Ses: {
          type: "structure",
          required: [
            "TransformType"
          ],
          members: {
            TransformType: {},
            FindMatchesParameters: {
              type: "structure",
              members: {
                PrimaryKeyColumnName: {},
                PrecisionRecallTradeoff: {
                  type: "double"
                },
                AccuracyCostTradeoff: {
                  type: "double"
                },
                EnforceProvidedLabels: {
                  type: "boolean"
                }
              }
            }
          }
        },
        Sew: {
          type: "structure",
          members: {
            MlUserDataEncryption: {
              type: "structure",
              required: [
                "MlUserDataEncryptionMode"
              ],
              members: {
                MlUserDataEncryptionMode: {},
                KmsKeyId: {}
              }
            },
            TaskRunSecurityConfigurationName: {}
          }
        },
        Sf3: {
          type: "structure",
          required: [
            "Keys",
            "IndexName"
          ],
          members: {
            Keys: {
              type: "list",
              member: {}
            },
            IndexName: {}
          }
        },
        Sf9: {
          type: "structure",
          members: {
            RegistryName: {},
            RegistryArn: {}
          }
        },
        Sfg: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Id",
              "NodeType",
              "Args"
            ],
            members: {
              Id: {},
              NodeType: {},
              Args: {
                shape: "Sfk"
              },
              LineNumber: {
                type: "integer"
              }
            }
          }
        },
        Sfk: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Value"
            ],
            members: {
              Name: {},
              Value: {},
              Param: {
                type: "boolean"
              }
            }
          }
        },
        Sfo: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Source",
              "Target"
            ],
            members: {
              Source: {},
              Target: {},
              TargetParameter: {}
            }
          }
        },
        Sfv: {
          type: "structure",
          members: {
            S3Encryption: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  S3EncryptionMode: {},
                  KmsKeyArn: {}
                }
              }
            },
            CloudWatchEncryption: {
              type: "structure",
              members: {
                CloudWatchEncryptionMode: {},
                KmsKeyArn: {}
              }
            },
            JobBookmarksEncryption: {
              type: "structure",
              members: {
                JobBookmarksEncryptionMode: {},
                KmsKeyArn: {}
              }
            }
          }
        },
        Sg7: {
          type: "structure",
          members: {
            Name: {},
            PythonVersion: {}
          }
        },
        Sg8: {
          type: "map",
          key: {},
          value: {}
        },
        Sgb: {
          type: "structure",
          members: {
            Id: {},
            CreatedOn: {
              type: "timestamp"
            },
            Status: {},
            ErrorMessage: {},
            Description: {},
            Role: {},
            Command: {
              shape: "Sg7"
            },
            DefaultArguments: {
              shape: "Sg8"
            },
            Connections: {
              shape: "S59"
            },
            Progress: {
              type: "double"
            },
            MaxCapacity: {
              type: "double"
            },
            SecurityConfiguration: {},
            GlueVersion: {},
            NumberOfWorkers: {
              type: "integer"
            },
            WorkerType: {},
            CompletedOn: {
              type: "timestamp"
            },
            ExecutionTime: {
              type: "double"
            },
            DPUSeconds: {
              type: "double"
            },
            IdleTimeout: {
              type: "integer"
            }
          }
        },
        Sgg: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            Description: {},
            Owner: {},
            LastAccessTime: {
              type: "timestamp"
            },
            LastAnalyzedTime: {
              type: "timestamp"
            },
            Retention: {
              type: "integer"
            },
            StorageDescriptor: {
              shape: "S9"
            },
            PartitionKeys: {
              shape: "Sa"
            },
            ViewOriginalText: {},
            ViewExpandedText: {},
            TableType: {},
            Parameters: {
              shape: "Se"
            },
            TargetTable: {
              shape: "Sgk"
            }
          }
        },
        Sgk: {
          type: "structure",
          members: {
            CatalogId: {},
            DatabaseName: {},
            Name: {},
            Region: {}
          }
        },
        Sgv: {
          type: "structure",
          members: {
            FunctionName: {},
            ClassName: {},
            OwnerName: {},
            OwnerType: {},
            ResourceUris: {
              shape: "Sgx"
            }
          }
        },
        Sgx: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ResourceType: {},
              Uri: {}
            }
          }
        },
        Siu: {
          type: "structure",
          members: {
            BlueprintName: {},
            RunId: {},
            WorkflowName: {},
            State: {},
            StartedOn: {
              type: "timestamp"
            },
            CompletedOn: {
              type: "timestamp"
            },
            ErrorMessage: {},
            RollbackErrorMessage: {},
            Parameters: {},
            RoleArn: {}
          }
        },
        Sj7: {
          type: "structure",
          members: {
            GrokClassifier: {
              type: "structure",
              required: [
                "Name",
                "Classification",
                "GrokPattern"
              ],
              members: {
                Name: {},
                Classification: {},
                CreationTime: {
                  type: "timestamp"
                },
                LastUpdated: {
                  type: "timestamp"
                },
                Version: {
                  type: "long"
                },
                GrokPattern: {},
                CustomPatterns: {}
              }
            },
            XMLClassifier: {
              type: "structure",
              required: [
                "Name",
                "Classification"
              ],
              members: {
                Name: {},
                Classification: {},
                CreationTime: {
                  type: "timestamp"
                },
                LastUpdated: {
                  type: "timestamp"
                },
                Version: {
                  type: "long"
                },
                RowTag: {}
              }
            },
            JsonClassifier: {
              type: "structure",
              required: [
                "Name",
                "JsonPath"
              ],
              members: {
                Name: {},
                CreationTime: {
                  type: "timestamp"
                },
                LastUpdated: {
                  type: "timestamp"
                },
                Version: {
                  type: "long"
                },
                JsonPath: {}
              }
            },
            CsvClassifier: {
              type: "structure",
              required: [
                "Name"
              ],
              members: {
                Name: {},
                CreationTime: {
                  type: "timestamp"
                },
                LastUpdated: {
                  type: "timestamp"
                },
                Version: {
                  type: "long"
                },
                Delimiter: {},
                QuoteSymbol: {},
                ContainsHeader: {},
                Header: {
                  shape: "Sdo"
                },
                DisableValueTrimming: {
                  type: "boolean"
                },
                AllowSingleColumn: {
                  type: "boolean"
                },
                CustomDatatypeConfigured: {
                  type: "boolean"
                },
                CustomDatatypes: {
                  shape: "Sdp"
                },
                Serde: {}
              }
            }
          }
        },
        Sjh: {
          type: "list",
          member: {}
        },
        Sjj: {
          type: "list",
          member: {
            shape: "Sjk"
          }
        },
        Sjk: {
          type: "structure",
          required: [
            "ColumnName",
            "ColumnType",
            "AnalyzedTime",
            "StatisticsData"
          ],
          members: {
            ColumnName: {},
            ColumnType: {},
            AnalyzedTime: {
              type: "timestamp"
            },
            StatisticsData: {
              type: "structure",
              required: [
                "Type"
              ],
              members: {
                Type: {},
                BooleanColumnStatisticsData: {
                  type: "structure",
                  required: [
                    "NumberOfTrues",
                    "NumberOfFalses",
                    "NumberOfNulls"
                  ],
                  members: {
                    NumberOfTrues: {
                      type: "long"
                    },
                    NumberOfFalses: {
                      type: "long"
                    },
                    NumberOfNulls: {
                      type: "long"
                    }
                  }
                },
                DateColumnStatisticsData: {
                  type: "structure",
                  required: [
                    "NumberOfNulls",
                    "NumberOfDistinctValues"
                  ],
                  members: {
                    MinimumValue: {
                      type: "timestamp"
                    },
                    MaximumValue: {
                      type: "timestamp"
                    },
                    NumberOfNulls: {
                      type: "long"
                    },
                    NumberOfDistinctValues: {
                      type: "long"
                    }
                  }
                },
                DecimalColumnStatisticsData: {
                  type: "structure",
                  required: [
                    "NumberOfNulls",
                    "NumberOfDistinctValues"
                  ],
                  members: {
                    MinimumValue: {
                      shape: "Sjs"
                    },
                    MaximumValue: {
                      shape: "Sjs"
                    },
                    NumberOfNulls: {
                      type: "long"
                    },
                    NumberOfDistinctValues: {
                      type: "long"
                    }
                  }
                },
                DoubleColumnStatisticsData: {
                  type: "structure",
                  required: [
                    "NumberOfNulls",
                    "NumberOfDistinctValues"
                  ],
                  members: {
                    MinimumValue: {
                      type: "double"
                    },
                    MaximumValue: {
                      type: "double"
                    },
                    NumberOfNulls: {
                      type: "long"
                    },
                    NumberOfDistinctValues: {
                      type: "long"
                    }
                  }
                },
                LongColumnStatisticsData: {
                  type: "structure",
                  required: [
                    "NumberOfNulls",
                    "NumberOfDistinctValues"
                  ],
                  members: {
                    MinimumValue: {
                      type: "long"
                    },
                    MaximumValue: {
                      type: "long"
                    },
                    NumberOfNulls: {
                      type: "long"
                    },
                    NumberOfDistinctValues: {
                      type: "long"
                    }
                  }
                },
                StringColumnStatisticsData: {
                  type: "structure",
                  required: [
                    "MaximumLength",
                    "AverageLength",
                    "NumberOfNulls",
                    "NumberOfDistinctValues"
                  ],
                  members: {
                    MaximumLength: {
                      type: "long"
                    },
                    AverageLength: {
                      type: "double"
                    },
                    NumberOfNulls: {
                      type: "long"
                    },
                    NumberOfDistinctValues: {
                      type: "long"
                    }
                  }
                },
                BinaryColumnStatisticsData: {
                  type: "structure",
                  required: [
                    "MaximumLength",
                    "AverageLength",
                    "NumberOfNulls"
                  ],
                  members: {
                    MaximumLength: {
                      type: "long"
                    },
                    AverageLength: {
                      type: "double"
                    },
                    NumberOfNulls: {
                      type: "long"
                    }
                  }
                }
              }
            }
          }
        },
        Sjs: {
          type: "structure",
          required: [
            "UnscaledValue",
            "Scale"
          ],
          members: {
            UnscaledValue: {
              type: "blob"
            },
            Scale: {
              type: "integer"
            }
          }
        },
        Sk1: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ColumnName: {},
              Error: {
                shape: "S14"
              }
            }
          }
        },
        Sk7: {
          type: "structure",
          members: {
            CustomerId: {},
            ColumnStatisticsTaskRunId: {},
            DatabaseName: {},
            TableName: {},
            ColumnNameList: {
              shape: "Sk9"
            },
            CatalogID: {},
            Role: {},
            SampleSize: {
              type: "double"
            },
            SecurityConfiguration: {},
            NumberOfWorkers: {
              type: "integer"
            },
            WorkerType: {},
            Status: {},
            CreationTime: {
              type: "timestamp"
            },
            LastUpdated: {
              type: "timestamp"
            },
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            ErrorMessage: {},
            DPUSeconds: {
              type: "double"
            }
          }
        },
        Sk9: {
          type: "list",
          member: {}
        },
        Ski: {
          type: "structure",
          members: {
            Name: {},
            Description: {},
            ConnectionType: {},
            MatchCriteria: {
              shape: "Sdv"
            },
            ConnectionProperties: {
              shape: "Sdw"
            },
            PhysicalConnectionRequirements: {
              shape: "Sdy"
            },
            CreationTime: {
              type: "timestamp"
            },
            LastUpdatedTime: {
              type: "timestamp"
            },
            LastUpdatedBy: {}
          }
        },
        Skz: {
          type: "structure",
          members: {
            EncryptionAtRest: {
              type: "structure",
              required: [
                "CatalogEncryptionMode"
              ],
              members: {
                CatalogEncryptionMode: {},
                SseAwsKmsKeyId: {}
              }
            },
            ConnectionPasswordEncryption: {
              type: "structure",
              required: [
                "ReturnConnectionPasswordEncrypted"
              ],
              members: {
                ReturnConnectionPasswordEncrypted: {
                  type: "boolean"
                },
                AwsKmsKeyId: {}
              }
            }
          }
        },
        Slb: {
          type: "structure",
          members: {
            CloudWatchMetricsEnabled: {
              type: "boolean"
            },
            ResultsS3Prefix: {}
          }
        },
        Slc: {
          type: "list",
          member: {}
        },
        Sle: {
          type: "map",
          key: {},
          value: {
            shape: "S43"
          }
        },
        Slh: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            Description: {},
            LocationUri: {},
            Parameters: {
              shape: "Se"
            },
            CreateTime: {
              type: "timestamp"
            },
            CreateTableDefaultPermissions: {
              shape: "Sec"
            },
            TargetDatabase: {
              shape: "Sei"
            },
            CatalogId: {},
            FederatedDatabase: {
              shape: "Sej"
            }
          }
        },
        Slz: {
          type: "structure",
          members: {
            JobName: {},
            Version: {
              type: "integer"
            },
            Run: {
              type: "integer"
            },
            Attempt: {
              type: "integer"
            },
            PreviousRunId: {},
            RunId: {},
            JobBookmark: {}
          }
        },
        Sm9: {
          type: "structure",
          members: {
            TaskType: {},
            ImportLabelsTaskRunProperties: {
              type: "structure",
              members: {
                InputS3Path: {},
                Replace: {
                  type: "boolean"
                }
              }
            },
            ExportLabelsTaskRunProperties: {
              type: "structure",
              members: {
                OutputS3Path: {}
              }
            },
            LabelingSetGenerationTaskRunProperties: {
              type: "structure",
              members: {
                OutputS3Path: {}
              }
            },
            FindMatchesTaskRunProperties: {
              type: "structure",
              members: {
                JobId: {},
                JobName: {},
                JobRunId: {}
              }
            }
          }
        },
        Sms: {
          type: "structure",
          required: [
            "TransformType"
          ],
          members: {
            TransformType: {},
            FindMatchesMetrics: {
              type: "structure",
              members: {
                AreaUnderPRCurve: {
                  type: "double"
                },
                Precision: {
                  type: "double"
                },
                Recall: {
                  type: "double"
                },
                F1: {
                  type: "double"
                },
                ConfusionMatrix: {
                  type: "structure",
                  members: {
                    NumTruePositives: {
                      type: "long"
                    },
                    NumFalsePositives: {
                      type: "long"
                    },
                    NumTrueNegatives: {
                      type: "long"
                    },
                    NumFalseNegatives: {
                      type: "long"
                    }
                  }
                },
                ColumnImportances: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      ColumnName: {},
                      Importance: {
                        type: "double"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Smz: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              DataType: {}
            }
          }
        },
        Sn2: {
          type: "structure",
          members: {
            Name: {},
            TransformType: {},
            Status: {},
            GlueVersion: {},
            CreatedBefore: {
              type: "timestamp"
            },
            CreatedAfter: {
              type: "timestamp"
            },
            LastModifiedBefore: {
              type: "timestamp"
            },
            LastModifiedAfter: {
              type: "timestamp"
            },
            Schema: {
              shape: "Smz"
            }
          }
        },
        Sn3: {
          type: "structure",
          required: [
            "Column",
            "SortDirection"
          ],
          members: {
            Column: {},
            SortDirection: {}
          }
        },
        Sn9: {
          type: "structure",
          required: [
            "DatabaseName",
            "TableName"
          ],
          members: {
            DatabaseName: {},
            TableName: {}
          }
        },
        Sna: {
          type: "list",
          member: {
            shape: "Sn9"
          }
        },
        Snb: {
          type: "structure",
          members: {
            Jdbc: {
              shape: "Sfk"
            },
            S3: {
              shape: "Sfk"
            },
            DynamoDB: {
              shape: "Sfk"
            }
          }
        },
        Snd: {
          type: "list",
          member: {
            type: "structure",
            members: {
              SourceTable: {},
              SourcePath: {},
              SourceType: {},
              TargetTable: {},
              TargetPath: {},
              TargetType: {}
            }
          }
        },
        Snw: {
          type: "structure",
          required: [
            "SegmentNumber",
            "TotalSegments"
          ],
          members: {
            SegmentNumber: {
              type: "integer"
            },
            TotalSegments: {
              type: "integer"
            }
          }
        },
        Soj: {
          type: "structure",
          members: {
            LatestVersion: {
              type: "boolean"
            },
            VersionNumber: {
              type: "long"
            }
          }
        },
        Sos: {
          type: "structure",
          members: {
            Name: {},
            CreatedTimeStamp: {
              type: "timestamp"
            },
            EncryptionConfiguration: {
              shape: "Sfv"
            }
          }
        },
        Sp0: {
          type: "structure",
          members: {
            Id: {
              type: "integer"
            },
            Code: {},
            State: {},
            Output: {
              type: "structure",
              members: {
                Data: {
                  type: "structure",
                  members: {
                    TextPlain: {}
                  }
                },
                ExecutionCount: {
                  type: "integer"
                },
                Status: {},
                ErrorName: {},
                ErrorValue: {},
                Traceback: {
                  shape: "S5a"
                }
              }
            },
            Progress: {
              type: "double"
            },
            StartedOn: {
              type: "long"
            },
            CompletedOn: {
              type: "long"
            }
          }
        },
        Sp7: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            DatabaseName: {},
            Description: {},
            Owner: {},
            CreateTime: {
              type: "timestamp"
            },
            UpdateTime: {
              type: "timestamp"
            },
            LastAccessTime: {
              type: "timestamp"
            },
            LastAnalyzedTime: {
              type: "timestamp"
            },
            Retention: {
              type: "integer"
            },
            StorageDescriptor: {
              shape: "S9"
            },
            PartitionKeys: {
              shape: "Sa"
            },
            ViewOriginalText: {},
            ViewExpandedText: {},
            TableType: {},
            Parameters: {
              shape: "Se"
            },
            CreatedBy: {},
            IsRegisteredWithLakeFormation: {
              type: "boolean"
            },
            TargetTable: {
              shape: "Sgk"
            },
            CatalogId: {},
            VersionId: {},
            FederatedTable: {
              type: "structure",
              members: {
                Identifier: {},
                DatabaseIdentifier: {},
                ConnectionName: {}
              }
            }
          }
        },
        Spd: {
          type: "structure",
          members: {
            Table: {
              shape: "Sp7"
            },
            VersionId: {}
          }
        },
        Spk: {
          type: "list",
          member: {
            shape: "Sp7"
          }
        },
        Sps: {
          type: "structure",
          members: {
            AdditionalAuditContext: {},
            RequestedColumns: {
              type: "list",
              member: {}
            },
            AllColumnsRequested: {
              type: "boolean"
            }
          }
        },
        Spv: {
          type: "list",
          member: {}
        },
        Spx: {
          type: "structure",
          members: {
            QueryId: {},
            QueryStartTime: {
              type: "timestamp"
            },
            ClusterId: {},
            QueryAuthorizationId: {},
            AdditionalContext: {
              type: "map",
              key: {},
              value: {}
            }
          }
        },
        Sqg: {
          type: "structure",
          members: {
            FunctionName: {},
            DatabaseName: {},
            ClassName: {},
            OwnerName: {},
            OwnerType: {},
            CreateTime: {
              type: "timestamp"
            },
            ResourceUris: {
              shape: "Sgx"
            },
            CatalogId: {}
          }
        },
        St8: {
          type: "structure",
          members: {
            MetadataKey: {},
            MetadataValue: {}
          }
        },
        Stt: {
          type: "list",
          member: {}
        },
        Svm: {
          type: "list",
          member: {
            shape: "Sjk"
          }
        },
        Svo: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ColumnStatistics: {
                shape: "Sjk"
              },
              Error: {
                shape: "S14"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/glue-2017-03-31.paginators.json
var require_glue_2017_03_31_paginators = __commonJS({
  "node_modules/aws-sdk/apis/glue-2017-03-31.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetBlueprintRuns: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetClassifiers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetColumnStatisticsTaskRuns: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetConnections: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetCrawlerMetrics: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetCrawlers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetDatabases: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetDevEndpoints: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetJobRuns: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetJobs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetMLTaskRuns: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetMLTransforms: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetPartitionIndexes: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "PartitionIndexDescriptorList"
        },
        GetPartitions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetResourcePolicies: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "GetResourcePoliciesResponseList"
        },
        GetSecurityConfigurations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "SecurityConfigurations"
        },
        GetTableVersions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetTables: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetTriggers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetUnfilteredPartitionsMetadata: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetUserDefinedFunctions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetWorkflowRuns: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListBlueprints: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListColumnStatisticsTaskRuns: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListCrawlers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListCustomEntityTypes: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListDataQualityResults: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListDataQualityRuleRecommendationRuns: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListDataQualityRulesetEvaluationRuns: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListDataQualityRulesets: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListDevEndpoints: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListJobs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListMLTransforms: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListRegistries: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Registries"
        },
        ListSchemaVersions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Schemas"
        },
        ListSchemas: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Schemas"
        },
        ListSessions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListTableOptimizerRuns: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListTriggers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListWorkflows: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        SearchTables: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/glue.js
var require_glue = __commonJS({
  "node_modules/aws-sdk/clients/glue.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["glue"] = {};
    AWS2.Glue = Service.defineService("glue", ["2017-03-31"]);
    Object.defineProperty(apiLoader.services["glue"], "2017-03-31", {
      get: function get() {
        var model = require_glue_2017_03_31_min();
        model.paginators = require_glue_2017_03_31_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Glue;
  }
});

// node_modules/aws-sdk/apis/mobile-2017-07-01.min.json
var require_mobile_2017_07_01_min = __commonJS({
  "node_modules/aws-sdk/apis/mobile-2017-07-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-07-01",
        endpointPrefix: "mobile",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Mobile",
        serviceId: "Mobile",
        signatureVersion: "v4",
        signingName: "AWSMobileHubService",
        uid: "mobile-2017-07-01"
      },
      operations: {
        CreateProject: {
          http: {
            requestUri: "/projects"
          },
          input: {
            type: "structure",
            members: {
              name: {
                location: "querystring",
                locationName: "name"
              },
              region: {
                location: "querystring",
                locationName: "region"
              },
              contents: {
                type: "blob"
              },
              snapshotId: {
                location: "querystring",
                locationName: "snapshotId"
              }
            },
            payload: "contents"
          },
          output: {
            type: "structure",
            members: {
              details: {
                shape: "S7"
              }
            }
          }
        },
        DeleteProject: {
          http: {
            method: "DELETE",
            requestUri: "/projects/{projectId}"
          },
          input: {
            type: "structure",
            required: [
              "projectId"
            ],
            members: {
              projectId: {
                location: "uri",
                locationName: "projectId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              deletedResources: {
                shape: "Sc"
              },
              orphanedResources: {
                shape: "Sc"
              }
            }
          }
        },
        DescribeBundle: {
          http: {
            method: "GET",
            requestUri: "/bundles/{bundleId}"
          },
          input: {
            type: "structure",
            required: [
              "bundleId"
            ],
            members: {
              bundleId: {
                location: "uri",
                locationName: "bundleId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              details: {
                shape: "Sq"
              }
            }
          }
        },
        DescribeProject: {
          http: {
            method: "GET",
            requestUri: "/project"
          },
          input: {
            type: "structure",
            required: [
              "projectId"
            ],
            members: {
              projectId: {
                location: "querystring",
                locationName: "projectId"
              },
              syncFromResources: {
                location: "querystring",
                locationName: "syncFromResources",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              details: {
                shape: "S7"
              }
            }
          }
        },
        ExportBundle: {
          http: {
            requestUri: "/bundles/{bundleId}"
          },
          input: {
            type: "structure",
            required: [
              "bundleId"
            ],
            members: {
              bundleId: {
                location: "uri",
                locationName: "bundleId"
              },
              projectId: {
                location: "querystring",
                locationName: "projectId"
              },
              platform: {
                location: "querystring",
                locationName: "platform"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              downloadUrl: {}
            }
          }
        },
        ExportProject: {
          http: {
            requestUri: "/exports/{projectId}"
          },
          input: {
            type: "structure",
            required: [
              "projectId"
            ],
            members: {
              projectId: {
                location: "uri",
                locationName: "projectId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              downloadUrl: {},
              shareUrl: {},
              snapshotId: {}
            }
          }
        },
        ListBundles: {
          http: {
            method: "GET",
            requestUri: "/bundles"
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              bundleList: {
                type: "list",
                member: {
                  shape: "Sq"
                }
              },
              nextToken: {}
            }
          }
        },
        ListProjects: {
          http: {
            method: "GET",
            requestUri: "/projects"
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              projects: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    projectId: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        UpdateProject: {
          http: {
            requestUri: "/update"
          },
          input: {
            type: "structure",
            required: [
              "projectId"
            ],
            members: {
              contents: {
                type: "blob"
              },
              projectId: {
                location: "querystring",
                locationName: "projectId"
              }
            },
            payload: "contents"
          },
          output: {
            type: "structure",
            members: {
              details: {
                shape: "S7"
              }
            }
          }
        }
      },
      shapes: {
        S7: {
          type: "structure",
          members: {
            name: {},
            projectId: {},
            region: {},
            state: {},
            createdDate: {
              type: "timestamp"
            },
            lastUpdatedDate: {
              type: "timestamp"
            },
            consoleUrl: {},
            resources: {
              shape: "Sc"
            }
          }
        },
        Sc: {
          type: "list",
          member: {
            type: "structure",
            members: {
              type: {},
              name: {},
              arn: {},
              feature: {},
              attributes: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        Sq: {
          type: "structure",
          members: {
            bundleId: {},
            title: {},
            version: {},
            description: {},
            iconUrl: {},
            availablePlatforms: {
              type: "list",
              member: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/mobile-2017-07-01.paginators.json
var require_mobile_2017_07_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/mobile-2017-07-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListBundles: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListProjects: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/mobile.js
var require_mobile = __commonJS({
  "node_modules/aws-sdk/clients/mobile.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["mobile"] = {};
    AWS2.Mobile = Service.defineService("mobile", ["2017-07-01"]);
    Object.defineProperty(apiLoader.services["mobile"], "2017-07-01", {
      get: function get() {
        var model = require_mobile_2017_07_01_min();
        model.paginators = require_mobile_2017_07_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Mobile;
  }
});

// node_modules/aws-sdk/apis/pricing-2017-10-15.min.json
var require_pricing_2017_10_15_min = __commonJS({
  "node_modules/aws-sdk/apis/pricing-2017-10-15.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-10-15",
        endpointPrefix: "api.pricing",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "AWS Pricing",
        serviceFullName: "AWS Price List Service",
        serviceId: "Pricing",
        signatureVersion: "v4",
        signingName: "pricing",
        targetPrefix: "AWSPriceListService",
        uid: "pricing-2017-10-15"
      },
      operations: {
        DescribeServices: {
          input: {
            type: "structure",
            members: {
              ServiceCode: {},
              FormatVersion: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Services: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ServiceCode"
                  ],
                  members: {
                    ServiceCode: {},
                    AttributeNames: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              FormatVersion: {},
              NextToken: {}
            }
          }
        },
        GetAttributeValues: {
          input: {
            type: "structure",
            required: [
              "ServiceCode",
              "AttributeName"
            ],
            members: {
              ServiceCode: {},
              AttributeName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AttributeValues: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Value: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetPriceListFileUrl: {
          input: {
            type: "structure",
            required: [
              "PriceListArn",
              "FileFormat"
            ],
            members: {
              PriceListArn: {},
              FileFormat: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Url: {}
            }
          }
        },
        GetProducts: {
          input: {
            type: "structure",
            required: [
              "ServiceCode"
            ],
            members: {
              ServiceCode: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Type",
                    "Field",
                    "Value"
                  ],
                  members: {
                    Type: {},
                    Field: {},
                    Value: {}
                  }
                }
              },
              FormatVersion: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FormatVersion: {},
              PriceList: {
                type: "list",
                member: {
                  jsonvalue: true
                }
              },
              NextToken: {}
            }
          }
        },
        ListPriceLists: {
          input: {
            type: "structure",
            required: [
              "ServiceCode",
              "EffectiveDate",
              "CurrencyCode"
            ],
            members: {
              ServiceCode: {},
              EffectiveDate: {
                type: "timestamp"
              },
              RegionCode: {},
              CurrencyCode: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PriceLists: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PriceListArn: {},
                    RegionCode: {},
                    CurrencyCode: {},
                    FileFormats: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/apis/pricing-2017-10-15.paginators.json
var require_pricing_2017_10_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/pricing-2017-10-15.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeServices: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Services"
        },
        GetAttributeValues: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AttributeValues"
        },
        GetProducts: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "PriceList"
        },
        ListPriceLists: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "PriceLists"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/pricing-2017-10-15.waiters2.json
var require_pricing_2017_10_15_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/pricing-2017-10-15.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {}
    };
  }
});

// node_modules/aws-sdk/clients/pricing.js
var require_pricing = __commonJS({
  "node_modules/aws-sdk/clients/pricing.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["pricing"] = {};
    AWS2.Pricing = Service.defineService("pricing", ["2017-10-15"]);
    Object.defineProperty(apiLoader.services["pricing"], "2017-10-15", {
      get: function get() {
        var model = require_pricing_2017_10_15_min();
        model.paginators = require_pricing_2017_10_15_paginators().pagination;
        model.waiters = require_pricing_2017_10_15_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Pricing;
  }
});

// node_modules/aws-sdk/apis/ce-2017-10-25.min.json
var require_ce_2017_10_25_min = __commonJS({
  "node_modules/aws-sdk/apis/ce-2017-10-25.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-10-25",
        endpointPrefix: "ce",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "AWS Cost Explorer",
        serviceFullName: "AWS Cost Explorer Service",
        serviceId: "Cost Explorer",
        signatureVersion: "v4",
        signingName: "ce",
        targetPrefix: "AWSInsightsIndexService",
        uid: "ce-2017-10-25"
      },
      operations: {
        CreateAnomalyMonitor: {
          input: {
            type: "structure",
            required: [
              "AnomalyMonitor"
            ],
            members: {
              AnomalyMonitor: {
                shape: "S2"
              },
              ResourceTags: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "MonitorArn"
            ],
            members: {
              MonitorArn: {}
            }
          }
        },
        CreateAnomalySubscription: {
          input: {
            type: "structure",
            required: [
              "AnomalySubscription"
            ],
            members: {
              AnomalySubscription: {
                shape: "Sq"
              },
              ResourceTags: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "SubscriptionArn"
            ],
            members: {
              SubscriptionArn: {}
            }
          }
        },
        CreateCostCategoryDefinition: {
          input: {
            type: "structure",
            required: [
              "Name",
              "RuleVersion",
              "Rules"
            ],
            members: {
              Name: {},
              EffectiveStart: {},
              RuleVersion: {},
              Rules: {
                shape: "S14"
              },
              DefaultValue: {},
              SplitChargeRules: {
                shape: "S1a"
              },
              ResourceTags: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CostCategoryArn: {},
              EffectiveStart: {}
            }
          }
        },
        DeleteAnomalyMonitor: {
          input: {
            type: "structure",
            required: [
              "MonitorArn"
            ],
            members: {
              MonitorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAnomalySubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionArn"
            ],
            members: {
              SubscriptionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteCostCategoryDefinition: {
          input: {
            type: "structure",
            required: [
              "CostCategoryArn"
            ],
            members: {
              CostCategoryArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CostCategoryArn: {},
              EffectiveEnd: {}
            }
          }
        },
        DescribeCostCategoryDefinition: {
          input: {
            type: "structure",
            required: [
              "CostCategoryArn"
            ],
            members: {
              CostCategoryArn: {},
              EffectiveOn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CostCategory: {
                type: "structure",
                required: [
                  "CostCategoryArn",
                  "EffectiveStart",
                  "Name",
                  "RuleVersion",
                  "Rules"
                ],
                members: {
                  CostCategoryArn: {},
                  EffectiveStart: {},
                  EffectiveEnd: {},
                  Name: {},
                  RuleVersion: {},
                  Rules: {
                    shape: "S14"
                  },
                  SplitChargeRules: {
                    shape: "S1a"
                  },
                  ProcessingStatus: {
                    shape: "S1s"
                  },
                  DefaultValue: {}
                }
              }
            }
          }
        },
        GetAnomalies: {
          input: {
            type: "structure",
            required: [
              "DateInterval"
            ],
            members: {
              MonitorArn: {},
              DateInterval: {
                type: "structure",
                required: [
                  "StartDate"
                ],
                members: {
                  StartDate: {},
                  EndDate: {}
                }
              },
              Feedback: {},
              TotalImpact: {
                type: "structure",
                required: [
                  "NumericOperator",
                  "StartValue"
                ],
                members: {
                  NumericOperator: {},
                  StartValue: {
                    type: "double"
                  },
                  EndValue: {
                    type: "double"
                  }
                }
              },
              NextPageToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Anomalies"
            ],
            members: {
              Anomalies: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AnomalyId",
                    "AnomalyScore",
                    "Impact",
                    "MonitorArn"
                  ],
                  members: {
                    AnomalyId: {},
                    AnomalyStartDate: {},
                    AnomalyEndDate: {},
                    DimensionValue: {},
                    RootCauses: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Service: {},
                          Region: {},
                          LinkedAccount: {},
                          UsageType: {},
                          LinkedAccountName: {}
                        }
                      }
                    },
                    AnomalyScore: {
                      type: "structure",
                      required: [
                        "MaxScore",
                        "CurrentScore"
                      ],
                      members: {
                        MaxScore: {
                          type: "double"
                        },
                        CurrentScore: {
                          type: "double"
                        }
                      }
                    },
                    Impact: {
                      type: "structure",
                      required: [
                        "MaxImpact"
                      ],
                      members: {
                        MaxImpact: {
                          type: "double"
                        },
                        TotalImpact: {
                          type: "double"
                        },
                        TotalActualSpend: {
                          type: "double"
                        },
                        TotalExpectedSpend: {
                          type: "double"
                        },
                        TotalImpactPercentage: {
                          type: "double"
                        }
                      }
                    },
                    MonitorArn: {},
                    Feedback: {}
                  }
                }
              },
              NextPageToken: {}
            }
          }
        },
        GetAnomalyMonitors: {
          input: {
            type: "structure",
            members: {
              MonitorArnList: {
                shape: "Sb"
              },
              NextPageToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "AnomalyMonitors"
            ],
            members: {
              AnomalyMonitors: {
                type: "list",
                member: {
                  shape: "S2"
                }
              },
              NextPageToken: {}
            }
          }
        },
        GetAnomalySubscriptions: {
          input: {
            type: "structure",
            members: {
              SubscriptionArnList: {
                shape: "Sb"
              },
              MonitorArn: {},
              NextPageToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "AnomalySubscriptions"
            ],
            members: {
              AnomalySubscriptions: {
                type: "list",
                member: {
                  shape: "Sq"
                }
              },
              NextPageToken: {}
            }
          }
        },
        GetCostAndUsage: {
          input: {
            type: "structure",
            required: [
              "TimePeriod",
              "Granularity",
              "Metrics"
            ],
            members: {
              TimePeriod: {
                shape: "S2i"
              },
              Granularity: {},
              Filter: {
                shape: "S7"
              },
              Metrics: {
                shape: "S2k"
              },
              GroupBy: {
                shape: "S2m"
              },
              NextPageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextPageToken: {},
              GroupDefinitions: {
                shape: "S2m"
              },
              ResultsByTime: {
                shape: "S2r"
              },
              DimensionValueAttributes: {
                shape: "S32"
              }
            }
          }
        },
        GetCostAndUsageWithResources: {
          input: {
            type: "structure",
            required: [
              "TimePeriod",
              "Granularity",
              "Filter"
            ],
            members: {
              TimePeriod: {
                shape: "S2i"
              },
              Granularity: {},
              Filter: {
                shape: "S7"
              },
              Metrics: {
                shape: "S2k"
              },
              GroupBy: {
                shape: "S2m"
              },
              NextPageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextPageToken: {},
              GroupDefinitions: {
                shape: "S2m"
              },
              ResultsByTime: {
                shape: "S2r"
              },
              DimensionValueAttributes: {
                shape: "S32"
              }
            }
          }
        },
        GetCostCategories: {
          input: {
            type: "structure",
            required: [
              "TimePeriod"
            ],
            members: {
              SearchString: {},
              TimePeriod: {
                shape: "S2i"
              },
              CostCategoryName: {},
              Filter: {
                shape: "S7"
              },
              SortBy: {
                shape: "S3b"
              },
              MaxResults: {
                type: "integer"
              },
              NextPageToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ReturnSize",
              "TotalSize"
            ],
            members: {
              NextPageToken: {},
              CostCategoryNames: {
                type: "list",
                member: {}
              },
              CostCategoryValues: {
                shape: "S3i"
              },
              ReturnSize: {
                type: "integer"
              },
              TotalSize: {
                type: "integer"
              }
            }
          }
        },
        GetCostForecast: {
          input: {
            type: "structure",
            required: [
              "TimePeriod",
              "Metric",
              "Granularity"
            ],
            members: {
              TimePeriod: {
                shape: "S2i"
              },
              Metric: {},
              Granularity: {},
              Filter: {
                shape: "S7"
              },
              PredictionIntervalLevel: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Total: {
                shape: "S2u"
              },
              ForecastResultsByTime: {
                shape: "S3n"
              }
            }
          }
        },
        GetDimensionValues: {
          input: {
            type: "structure",
            required: [
              "TimePeriod",
              "Dimension"
            ],
            members: {
              SearchString: {},
              TimePeriod: {
                shape: "S2i"
              },
              Dimension: {},
              Context: {},
              Filter: {
                shape: "S7"
              },
              SortBy: {
                shape: "S3b"
              },
              MaxResults: {
                type: "integer"
              },
              NextPageToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "DimensionValues",
              "ReturnSize",
              "TotalSize"
            ],
            members: {
              DimensionValues: {
                shape: "S32"
              },
              ReturnSize: {
                type: "integer"
              },
              TotalSize: {
                type: "integer"
              },
              NextPageToken: {}
            }
          }
        },
        GetReservationCoverage: {
          input: {
            type: "structure",
            required: [
              "TimePeriod"
            ],
            members: {
              TimePeriod: {
                shape: "S2i"
              },
              GroupBy: {
                shape: "S2m"
              },
              Granularity: {},
              Filter: {
                shape: "S7"
              },
              Metrics: {
                shape: "S2k"
              },
              NextPageToken: {},
              SortBy: {
                shape: "S3c"
              },
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CoveragesByTime"
            ],
            members: {
              CoveragesByTime: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TimePeriod: {
                      shape: "S2i"
                    },
                    Groups: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Attributes: {
                            shape: "S34"
                          },
                          Coverage: {
                            shape: "S3y"
                          }
                        }
                      }
                    },
                    Total: {
                      shape: "S3y"
                    }
                  }
                }
              },
              Total: {
                shape: "S3y"
              },
              NextPageToken: {}
            }
          }
        },
        GetReservationPurchaseRecommendation: {
          input: {
            type: "structure",
            required: [
              "Service"
            ],
            members: {
              AccountId: {},
              Service: {},
              Filter: {
                shape: "S7"
              },
              AccountScope: {},
              LookbackPeriodInDays: {},
              TermInYears: {},
              PaymentOption: {},
              ServiceSpecification: {
                shape: "S4g"
              },
              PageSize: {
                type: "integer"
              },
              NextPageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Metadata: {
                type: "structure",
                members: {
                  RecommendationId: {},
                  GenerationTimestamp: {}
                }
              },
              Recommendations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AccountScope: {},
                    LookbackPeriodInDays: {},
                    TermInYears: {},
                    PaymentOption: {},
                    ServiceSpecification: {
                      shape: "S4g"
                    },
                    RecommendationDetails: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          AccountId: {},
                          InstanceDetails: {
                            type: "structure",
                            members: {
                              EC2InstanceDetails: {
                                type: "structure",
                                members: {
                                  Family: {},
                                  InstanceType: {},
                                  Region: {},
                                  AvailabilityZone: {},
                                  Platform: {},
                                  Tenancy: {},
                                  CurrentGeneration: {
                                    type: "boolean"
                                  },
                                  SizeFlexEligible: {
                                    type: "boolean"
                                  }
                                }
                              },
                              RDSInstanceDetails: {
                                type: "structure",
                                members: {
                                  Family: {},
                                  InstanceType: {},
                                  Region: {},
                                  DatabaseEngine: {},
                                  DatabaseEdition: {},
                                  DeploymentOption: {},
                                  LicenseModel: {},
                                  CurrentGeneration: {
                                    type: "boolean"
                                  },
                                  SizeFlexEligible: {
                                    type: "boolean"
                                  }
                                }
                              },
                              RedshiftInstanceDetails: {
                                type: "structure",
                                members: {
                                  Family: {},
                                  NodeType: {},
                                  Region: {},
                                  CurrentGeneration: {
                                    type: "boolean"
                                  },
                                  SizeFlexEligible: {
                                    type: "boolean"
                                  }
                                }
                              },
                              ElastiCacheInstanceDetails: {
                                type: "structure",
                                members: {
                                  Family: {},
                                  NodeType: {},
                                  Region: {},
                                  ProductDescription: {},
                                  CurrentGeneration: {
                                    type: "boolean"
                                  },
                                  SizeFlexEligible: {
                                    type: "boolean"
                                  }
                                }
                              },
                              ESInstanceDetails: {
                                type: "structure",
                                members: {
                                  InstanceClass: {},
                                  InstanceSize: {},
                                  Region: {},
                                  CurrentGeneration: {
                                    type: "boolean"
                                  },
                                  SizeFlexEligible: {
                                    type: "boolean"
                                  }
                                }
                              },
                              MemoryDBInstanceDetails: {
                                type: "structure",
                                members: {
                                  Family: {},
                                  NodeType: {},
                                  Region: {},
                                  CurrentGeneration: {
                                    type: "boolean"
                                  },
                                  SizeFlexEligible: {
                                    type: "boolean"
                                  }
                                }
                              }
                            }
                          },
                          RecommendedNumberOfInstancesToPurchase: {},
                          RecommendedNormalizedUnitsToPurchase: {},
                          MinimumNumberOfInstancesUsedPerHour: {},
                          MinimumNormalizedUnitsUsedPerHour: {},
                          MaximumNumberOfInstancesUsedPerHour: {},
                          MaximumNormalizedUnitsUsedPerHour: {},
                          AverageNumberOfInstancesUsedPerHour: {},
                          AverageNormalizedUnitsUsedPerHour: {},
                          AverageUtilization: {},
                          EstimatedBreakEvenInMonths: {},
                          CurrencyCode: {},
                          EstimatedMonthlySavingsAmount: {},
                          EstimatedMonthlySavingsPercentage: {},
                          EstimatedMonthlyOnDemandCost: {},
                          EstimatedReservationCostForLookbackPeriod: {},
                          UpfrontCost: {},
                          RecurringStandardMonthlyCost: {}
                        }
                      }
                    },
                    RecommendationSummary: {
                      type: "structure",
                      members: {
                        TotalEstimatedMonthlySavingsAmount: {},
                        TotalEstimatedMonthlySavingsPercentage: {},
                        CurrencyCode: {}
                      }
                    }
                  }
                }
              },
              NextPageToken: {}
            }
          }
        },
        GetReservationUtilization: {
          input: {
            type: "structure",
            required: [
              "TimePeriod"
            ],
            members: {
              TimePeriod: {
                shape: "S2i"
              },
              GroupBy: {
                shape: "S2m"
              },
              Granularity: {},
              Filter: {
                shape: "S7"
              },
              SortBy: {
                shape: "S3c"
              },
              NextPageToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UtilizationsByTime"
            ],
            members: {
              UtilizationsByTime: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TimePeriod: {
                      shape: "S2i"
                    },
                    Groups: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Key: {},
                          Value: {},
                          Attributes: {
                            shape: "S34"
                          },
                          Utilization: {
                            shape: "S56"
                          }
                        }
                      }
                    },
                    Total: {
                      shape: "S56"
                    }
                  }
                }
              },
              Total: {
                shape: "S56"
              },
              NextPageToken: {}
            }
          }
        },
        GetRightsizingRecommendation: {
          input: {
            type: "structure",
            required: [
              "Service"
            ],
            members: {
              Filter: {
                shape: "S7"
              },
              Configuration: {
                shape: "S5p"
              },
              Service: {},
              PageSize: {
                type: "integer"
              },
              NextPageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Metadata: {
                type: "structure",
                members: {
                  RecommendationId: {},
                  GenerationTimestamp: {},
                  LookbackPeriodInDays: {},
                  AdditionalMetadata: {}
                }
              },
              Summary: {
                type: "structure",
                members: {
                  TotalRecommendationCount: {},
                  EstimatedTotalMonthlySavingsAmount: {},
                  SavingsCurrencyCode: {},
                  SavingsPercentage: {}
                }
              },
              RightsizingRecommendations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AccountId: {},
                    CurrentInstance: {
                      type: "structure",
                      members: {
                        ResourceId: {},
                        InstanceName: {},
                        Tags: {
                          type: "list",
                          member: {
                            shape: "Sf"
                          }
                        },
                        ResourceDetails: {
                          shape: "S5y"
                        },
                        ResourceUtilization: {
                          shape: "S60"
                        },
                        ReservationCoveredHoursInLookbackPeriod: {},
                        SavingsPlansCoveredHoursInLookbackPeriod: {},
                        OnDemandHoursInLookbackPeriod: {},
                        TotalRunningHoursInLookbackPeriod: {},
                        MonthlyCost: {},
                        CurrencyCode: {}
                      }
                    },
                    RightsizingType: {},
                    ModifyRecommendationDetail: {
                      type: "structure",
                      members: {
                        TargetInstances: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              EstimatedMonthlyCost: {},
                              EstimatedMonthlySavings: {},
                              CurrencyCode: {},
                              DefaultTargetInstance: {
                                type: "boolean"
                              },
                              ResourceDetails: {
                                shape: "S5y"
                              },
                              ExpectedResourceUtilization: {
                                shape: "S60"
                              },
                              PlatformDifferences: {
                                type: "list",
                                member: {}
                              }
                            }
                          }
                        }
                      }
                    },
                    TerminateRecommendationDetail: {
                      type: "structure",
                      members: {
                        EstimatedMonthlySavings: {},
                        CurrencyCode: {}
                      }
                    },
                    FindingReasonCodes: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              NextPageToken: {},
              Configuration: {
                shape: "S5p"
              }
            }
          }
        },
        GetSavingsPlanPurchaseRecommendationDetails: {
          input: {
            type: "structure",
            required: [
              "RecommendationDetailId"
            ],
            members: {
              RecommendationDetailId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RecommendationDetailId: {},
              RecommendationDetailData: {
                type: "structure",
                members: {
                  AccountScope: {},
                  LookbackPeriodInDays: {},
                  SavingsPlansType: {},
                  TermInYears: {},
                  PaymentOption: {},
                  AccountId: {},
                  CurrencyCode: {},
                  InstanceFamily: {},
                  Region: {},
                  OfferingId: {},
                  GenerationTimestamp: {},
                  LatestUsageTimestamp: {},
                  CurrentAverageHourlyOnDemandSpend: {},
                  CurrentMaximumHourlyOnDemandSpend: {},
                  CurrentMinimumHourlyOnDemandSpend: {},
                  EstimatedAverageUtilization: {},
                  EstimatedMonthlySavingsAmount: {},
                  EstimatedOnDemandCost: {},
                  EstimatedOnDemandCostWithCurrentCommitment: {},
                  EstimatedROI: {},
                  EstimatedSPCost: {},
                  EstimatedSavingsAmount: {},
                  EstimatedSavingsPercentage: {},
                  ExistingHourlyCommitment: {},
                  HourlyCommitmentToPurchase: {},
                  UpfrontCost: {},
                  CurrentAverageCoverage: {},
                  EstimatedAverageCoverage: {},
                  MetricsOverLookbackPeriod: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        StartTime: {},
                        EstimatedOnDemandCost: {},
                        CurrentCoverage: {},
                        EstimatedCoverage: {},
                        EstimatedNewCommitmentUtilization: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetSavingsPlansCoverage: {
          input: {
            type: "structure",
            required: [
              "TimePeriod"
            ],
            members: {
              TimePeriod: {
                shape: "S2i"
              },
              GroupBy: {
                shape: "S2m"
              },
              Granularity: {},
              Filter: {
                shape: "S7"
              },
              Metrics: {
                shape: "S2k"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              SortBy: {
                shape: "S3c"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "SavingsPlansCoverages"
            ],
            members: {
              SavingsPlansCoverages: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Attributes: {
                      shape: "S34"
                    },
                    Coverage: {
                      type: "structure",
                      members: {
                        SpendCoveredBySavingsPlans: {},
                        OnDemandCost: {},
                        TotalCost: {},
                        CoveragePercentage: {}
                      }
                    },
                    TimePeriod: {
                      shape: "S2i"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetSavingsPlansPurchaseRecommendation: {
          input: {
            type: "structure",
            required: [
              "SavingsPlansType",
              "TermInYears",
              "PaymentOption",
              "LookbackPeriodInDays"
            ],
            members: {
              SavingsPlansType: {},
              TermInYears: {},
              PaymentOption: {},
              AccountScope: {},
              NextPageToken: {},
              PageSize: {
                type: "integer"
              },
              LookbackPeriodInDays: {},
              Filter: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Metadata: {
                type: "structure",
                members: {
                  RecommendationId: {},
                  GenerationTimestamp: {},
                  AdditionalMetadata: {}
                }
              },
              SavingsPlansPurchaseRecommendation: {
                type: "structure",
                members: {
                  AccountScope: {},
                  SavingsPlansType: {},
                  TermInYears: {},
                  PaymentOption: {},
                  LookbackPeriodInDays: {},
                  SavingsPlansPurchaseRecommendationDetails: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        SavingsPlansDetails: {
                          type: "structure",
                          members: {
                            Region: {},
                            InstanceFamily: {},
                            OfferingId: {}
                          }
                        },
                        AccountId: {},
                        UpfrontCost: {},
                        EstimatedROI: {},
                        CurrencyCode: {},
                        EstimatedSPCost: {},
                        EstimatedOnDemandCost: {},
                        EstimatedOnDemandCostWithCurrentCommitment: {},
                        EstimatedSavingsAmount: {},
                        EstimatedSavingsPercentage: {},
                        HourlyCommitmentToPurchase: {},
                        EstimatedAverageUtilization: {},
                        EstimatedMonthlySavingsAmount: {},
                        CurrentMinimumHourlyOnDemandSpend: {},
                        CurrentMaximumHourlyOnDemandSpend: {},
                        CurrentAverageHourlyOnDemandSpend: {},
                        RecommendationDetailId: {}
                      }
                    }
                  },
                  SavingsPlansPurchaseRecommendationSummary: {
                    type: "structure",
                    members: {
                      EstimatedROI: {},
                      CurrencyCode: {},
                      EstimatedTotalCost: {},
                      CurrentOnDemandSpend: {},
                      EstimatedSavingsAmount: {},
                      TotalRecommendationCount: {},
                      DailyCommitmentToPurchase: {},
                      HourlyCommitmentToPurchase: {},
                      EstimatedSavingsPercentage: {},
                      EstimatedMonthlySavingsAmount: {},
                      EstimatedOnDemandCostWithCurrentCommitment: {}
                    }
                  }
                }
              },
              NextPageToken: {}
            }
          }
        },
        GetSavingsPlansUtilization: {
          input: {
            type: "structure",
            required: [
              "TimePeriod"
            ],
            members: {
              TimePeriod: {
                shape: "S2i"
              },
              Granularity: {},
              Filter: {
                shape: "S7"
              },
              SortBy: {
                shape: "S3c"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Total"
            ],
            members: {
              SavingsPlansUtilizationsByTime: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "TimePeriod",
                    "Utilization"
                  ],
                  members: {
                    TimePeriod: {
                      shape: "S2i"
                    },
                    Utilization: {
                      shape: "S72"
                    },
                    Savings: {
                      shape: "S73"
                    },
                    AmortizedCommitment: {
                      shape: "S74"
                    }
                  }
                }
              },
              Total: {
                shape: "S75"
              }
            }
          }
        },
        GetSavingsPlansUtilizationDetails: {
          input: {
            type: "structure",
            required: [
              "TimePeriod"
            ],
            members: {
              TimePeriod: {
                shape: "S2i"
              },
              Filter: {
                shape: "S7"
              },
              DataType: {
                type: "list",
                member: {}
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              SortBy: {
                shape: "S3c"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "SavingsPlansUtilizationDetails",
              "TimePeriod"
            ],
            members: {
              SavingsPlansUtilizationDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SavingsPlanArn: {},
                    Attributes: {
                      shape: "S34"
                    },
                    Utilization: {
                      shape: "S72"
                    },
                    Savings: {
                      shape: "S73"
                    },
                    AmortizedCommitment: {
                      shape: "S74"
                    }
                  }
                }
              },
              Total: {
                shape: "S75"
              },
              TimePeriod: {
                shape: "S2i"
              },
              NextToken: {}
            }
          }
        },
        GetTags: {
          input: {
            type: "structure",
            required: [
              "TimePeriod"
            ],
            members: {
              SearchString: {},
              TimePeriod: {
                shape: "S2i"
              },
              TagKey: {},
              Filter: {
                shape: "S7"
              },
              SortBy: {
                shape: "S3b"
              },
              MaxResults: {
                type: "integer"
              },
              NextPageToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Tags",
              "ReturnSize",
              "TotalSize"
            ],
            members: {
              NextPageToken: {},
              Tags: {
                type: "list",
                member: {}
              },
              ReturnSize: {
                type: "integer"
              },
              TotalSize: {
                type: "integer"
              }
            }
          }
        },
        GetUsageForecast: {
          input: {
            type: "structure",
            required: [
              "TimePeriod",
              "Metric",
              "Granularity"
            ],
            members: {
              TimePeriod: {
                shape: "S2i"
              },
              Metric: {},
              Granularity: {},
              Filter: {
                shape: "S7"
              },
              PredictionIntervalLevel: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Total: {
                shape: "S2u"
              },
              ForecastResultsByTime: {
                shape: "S3n"
              }
            }
          }
        },
        ListCostAllocationTags: {
          input: {
            type: "structure",
            members: {
              Status: {},
              TagKeys: {
                type: "list",
                member: {}
              },
              Type: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CostAllocationTags: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "TagKey",
                    "Type",
                    "Status"
                  ],
                  members: {
                    TagKey: {},
                    Type: {},
                    Status: {},
                    LastUpdatedDate: {},
                    LastUsedDate: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListCostCategoryDefinitions: {
          input: {
            type: "structure",
            members: {
              EffectiveOn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CostCategoryReferences: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CostCategoryArn: {},
                    Name: {},
                    EffectiveStart: {},
                    EffectiveEnd: {},
                    NumberOfRules: {
                      type: "integer"
                    },
                    ProcessingStatus: {
                      shape: "S1s"
                    },
                    Values: {
                      shape: "S3i"
                    },
                    DefaultValue: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSavingsPlansPurchaseRecommendationGeneration: {
          input: {
            type: "structure",
            members: {
              GenerationStatus: {},
              RecommendationIds: {
                type: "list",
                member: {}
              },
              PageSize: {
                type: "integer"
              },
              NextPageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GenerationSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RecommendationId: {},
                    GenerationStatus: {},
                    GenerationStartedTime: {},
                    GenerationCompletionTime: {},
                    EstimatedCompletionTime: {}
                  }
                }
              },
              NextPageToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceTags: {
                shape: "Sk"
              }
            }
          }
        },
        ProvideAnomalyFeedback: {
          input: {
            type: "structure",
            required: [
              "AnomalyId",
              "Feedback"
            ],
            members: {
              AnomalyId: {},
              Feedback: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "AnomalyId"
            ],
            members: {
              AnomalyId: {}
            }
          }
        },
        StartSavingsPlansPurchaseRecommendationGeneration: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              RecommendationId: {},
              GenerationStartedTime: {},
              EstimatedCompletionTime: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "ResourceTags"
            ],
            members: {
              ResourceArn: {},
              ResourceTags: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "ResourceTagKeys"
            ],
            members: {
              ResourceArn: {},
              ResourceTagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAnomalyMonitor: {
          input: {
            type: "structure",
            required: [
              "MonitorArn"
            ],
            members: {
              MonitorArn: {},
              MonitorName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "MonitorArn"
            ],
            members: {
              MonitorArn: {}
            }
          }
        },
        UpdateAnomalySubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionArn"
            ],
            members: {
              SubscriptionArn: {},
              Threshold: {
                deprecated: true,
                deprecatedMessage: "Threshold has been deprecated in favor of ThresholdExpression",
                type: "double"
              },
              Frequency: {},
              MonitorArnList: {
                shape: "Sr"
              },
              Subscribers: {
                shape: "St"
              },
              SubscriptionName: {},
              ThresholdExpression: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "SubscriptionArn"
            ],
            members: {
              SubscriptionArn: {}
            }
          }
        },
        UpdateCostAllocationTagsStatus: {
          input: {
            type: "structure",
            required: [
              "CostAllocationTagsStatus"
            ],
            members: {
              CostAllocationTagsStatus: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "TagKey",
                    "Status"
                  ],
                  members: {
                    TagKey: {},
                    Status: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TagKey: {},
                    Code: {},
                    Message: {}
                  }
                }
              }
            }
          }
        },
        UpdateCostCategoryDefinition: {
          input: {
            type: "structure",
            required: [
              "CostCategoryArn",
              "RuleVersion",
              "Rules"
            ],
            members: {
              CostCategoryArn: {},
              EffectiveStart: {},
              RuleVersion: {},
              Rules: {
                shape: "S14"
              },
              DefaultValue: {},
              SplitChargeRules: {
                shape: "S1a"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CostCategoryArn: {},
              EffectiveStart: {}
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          required: [
            "MonitorName",
            "MonitorType"
          ],
          members: {
            MonitorArn: {},
            MonitorName: {},
            CreationDate: {},
            LastUpdatedDate: {},
            LastEvaluatedDate: {},
            MonitorType: {},
            MonitorDimension: {},
            MonitorSpecification: {
              shape: "S7"
            },
            DimensionalValueCount: {
              type: "integer"
            }
          }
        },
        S7: {
          type: "structure",
          members: {
            Or: {
              shape: "S8"
            },
            And: {
              shape: "S8"
            },
            Not: {
              shape: "S7"
            },
            Dimensions: {
              type: "structure",
              members: {
                Key: {},
                Values: {
                  shape: "Sb"
                },
                MatchOptions: {
                  shape: "Sd"
                }
              }
            },
            Tags: {
              shape: "Sf"
            },
            CostCategories: {
              type: "structure",
              members: {
                Key: {},
                Values: {
                  shape: "Sb"
                },
                MatchOptions: {
                  shape: "Sd"
                }
              }
            }
          }
        },
        S8: {
          type: "list",
          member: {
            shape: "S7"
          }
        },
        Sb: {
          type: "list",
          member: {}
        },
        Sd: {
          type: "list",
          member: {}
        },
        Sf: {
          type: "structure",
          members: {
            Key: {},
            Values: {
              shape: "Sb"
            },
            MatchOptions: {
              shape: "Sd"
            }
          }
        },
        Sk: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sq: {
          type: "structure",
          required: [
            "MonitorArnList",
            "Subscribers",
            "Frequency",
            "SubscriptionName"
          ],
          members: {
            SubscriptionArn: {},
            AccountId: {},
            MonitorArnList: {
              shape: "Sr"
            },
            Subscribers: {
              shape: "St"
            },
            Threshold: {
              deprecated: true,
              deprecatedMessage: "Threshold has been deprecated in favor of ThresholdExpression",
              type: "double"
            },
            Frequency: {},
            SubscriptionName: {},
            ThresholdExpression: {
              shape: "S7"
            }
          }
        },
        Sr: {
          type: "list",
          member: {}
        },
        St: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Address: {},
              Type: {},
              Status: {}
            }
          }
        },
        S14: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Value: {},
              Rule: {
                shape: "S7"
              },
              InheritedValue: {
                type: "structure",
                members: {
                  DimensionName: {},
                  DimensionKey: {}
                }
              },
              Type: {}
            }
          }
        },
        S1a: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Source",
              "Targets",
              "Method"
            ],
            members: {
              Source: {},
              Targets: {
                type: "list",
                member: {}
              },
              Method: {},
              Parameters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Type",
                    "Values"
                  ],
                  members: {
                    Type: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              }
            }
          }
        },
        S1s: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Component: {},
              Status: {}
            }
          }
        },
        S2i: {
          type: "structure",
          required: [
            "Start",
            "End"
          ],
          members: {
            Start: {},
            End: {}
          }
        },
        S2k: {
          type: "list",
          member: {}
        },
        S2m: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Type: {},
              Key: {}
            }
          }
        },
        S2r: {
          type: "list",
          member: {
            type: "structure",
            members: {
              TimePeriod: {
                shape: "S2i"
              },
              Total: {
                shape: "S2t"
              },
              Groups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Keys: {
                      type: "list",
                      member: {}
                    },
                    Metrics: {
                      shape: "S2t"
                    }
                  }
                }
              },
              Estimated: {
                type: "boolean"
              }
            }
          }
        },
        S2t: {
          type: "map",
          key: {},
          value: {
            shape: "S2u"
          }
        },
        S2u: {
          type: "structure",
          members: {
            Amount: {},
            Unit: {}
          }
        },
        S32: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Value: {},
              Attributes: {
                shape: "S34"
              }
            }
          }
        },
        S34: {
          type: "map",
          key: {},
          value: {}
        },
        S3b: {
          type: "list",
          member: {
            shape: "S3c"
          }
        },
        S3c: {
          type: "structure",
          required: [
            "Key"
          ],
          members: {
            Key: {},
            SortOrder: {}
          }
        },
        S3i: {
          type: "list",
          member: {}
        },
        S3n: {
          type: "list",
          member: {
            type: "structure",
            members: {
              TimePeriod: {
                shape: "S2i"
              },
              MeanValue: {},
              PredictionIntervalLowerBound: {},
              PredictionIntervalUpperBound: {}
            }
          }
        },
        S3y: {
          type: "structure",
          members: {
            CoverageHours: {
              type: "structure",
              members: {
                OnDemandHours: {},
                ReservedHours: {},
                TotalRunningHours: {},
                CoverageHoursPercentage: {}
              }
            },
            CoverageNormalizedUnits: {
              type: "structure",
              members: {
                OnDemandNormalizedUnits: {},
                ReservedNormalizedUnits: {},
                TotalRunningNormalizedUnits: {},
                CoverageNormalizedUnitsPercentage: {}
              }
            },
            CoverageCost: {
              type: "structure",
              members: {
                OnDemandCost: {}
              }
            }
          }
        },
        S4g: {
          type: "structure",
          members: {
            EC2Specification: {
              type: "structure",
              members: {
                OfferingClass: {}
              }
            }
          }
        },
        S56: {
          type: "structure",
          members: {
            UtilizationPercentage: {},
            UtilizationPercentageInUnits: {},
            PurchasedHours: {},
            PurchasedUnits: {},
            TotalActualHours: {},
            TotalActualUnits: {},
            UnusedHours: {},
            UnusedUnits: {},
            OnDemandCostOfRIHoursUsed: {},
            NetRISavings: {},
            TotalPotentialRISavings: {},
            AmortizedUpfrontFee: {},
            AmortizedRecurringFee: {},
            TotalAmortizedFee: {},
            RICostForUnusedHours: {},
            RealizedSavings: {},
            UnrealizedSavings: {}
          }
        },
        S5p: {
          type: "structure",
          required: [
            "RecommendationTarget",
            "BenefitsConsidered"
          ],
          members: {
            RecommendationTarget: {},
            BenefitsConsidered: {
              type: "boolean"
            }
          }
        },
        S5y: {
          type: "structure",
          members: {
            EC2ResourceDetails: {
              type: "structure",
              members: {
                HourlyOnDemandRate: {},
                InstanceType: {},
                Platform: {},
                Region: {},
                Sku: {},
                Memory: {},
                NetworkPerformance: {},
                Storage: {},
                Vcpu: {}
              }
            }
          }
        },
        S60: {
          type: "structure",
          members: {
            EC2ResourceUtilization: {
              type: "structure",
              members: {
                MaxCpuUtilizationPercentage: {},
                MaxMemoryUtilizationPercentage: {},
                MaxStorageUtilizationPercentage: {},
                EBSResourceUtilization: {
                  type: "structure",
                  members: {
                    EbsReadOpsPerSecond: {},
                    EbsWriteOpsPerSecond: {},
                    EbsReadBytesPerSecond: {},
                    EbsWriteBytesPerSecond: {}
                  }
                },
                DiskResourceUtilization: {
                  type: "structure",
                  members: {
                    DiskReadOpsPerSecond: {},
                    DiskWriteOpsPerSecond: {},
                    DiskReadBytesPerSecond: {},
                    DiskWriteBytesPerSecond: {}
                  }
                },
                NetworkResourceUtilization: {
                  type: "structure",
                  members: {
                    NetworkInBytesPerSecond: {},
                    NetworkOutBytesPerSecond: {},
                    NetworkPacketsInPerSecond: {},
                    NetworkPacketsOutPerSecond: {}
                  }
                }
              }
            }
          }
        },
        S72: {
          type: "structure",
          members: {
            TotalCommitment: {},
            UsedCommitment: {},
            UnusedCommitment: {},
            UtilizationPercentage: {}
          }
        },
        S73: {
          type: "structure",
          members: {
            NetSavings: {},
            OnDemandCostEquivalent: {}
          }
        },
        S74: {
          type: "structure",
          members: {
            AmortizedRecurringCommitment: {},
            AmortizedUpfrontCommitment: {},
            TotalAmortizedCommitment: {}
          }
        },
        S75: {
          type: "structure",
          required: [
            "Utilization"
          ],
          members: {
            Utilization: {
              shape: "S72"
            },
            Savings: {
              shape: "S73"
            },
            AmortizedCommitment: {
              shape: "S74"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ce-2017-10-25.paginators.json
var require_ce_2017_10_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/ce-2017-10-25.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetSavingsPlansCoverage: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        GetSavingsPlansUtilizationDetails: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListCostAllocationTags: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListCostCategoryDefinitions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/costexplorer.js
var require_costexplorer = __commonJS({
  "node_modules/aws-sdk/clients/costexplorer.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["costexplorer"] = {};
    AWS2.CostExplorer = Service.defineService("costexplorer", ["2017-10-25"]);
    Object.defineProperty(apiLoader.services["costexplorer"], "2017-10-25", {
      get: function get() {
        var model = require_ce_2017_10_25_min();
        model.paginators = require_ce_2017_10_25_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CostExplorer;
  }
});

// node_modules/aws-sdk/apis/mediaconvert-2017-08-29.min.json
var require_mediaconvert_2017_08_29_min = __commonJS({
  "node_modules/aws-sdk/apis/mediaconvert-2017-08-29.min.json"(exports2, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2017-08-29",
        endpointPrefix: "mediaconvert",
        signingName: "mediaconvert",
        serviceFullName: "AWS Elemental MediaConvert",
        serviceId: "MediaConvert",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "mediaconvert-2017-08-29",
        signatureVersion: "v4",
        serviceAbbreviation: "MediaConvert"
      },
      operations: {
        AssociateCertificate: {
          http: {
            requestUri: "/2017-08-29/certificates",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              }
            },
            required: [
              "Arn"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CancelJob: {
          http: {
            method: "DELETE",
            requestUri: "/2017-08-29/jobs/{id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              Id: {
                locationName: "id",
                location: "uri"
              }
            },
            required: [
              "Id"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateJob: {
          http: {
            requestUri: "/2017-08-29/jobs",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              AccelerationSettings: {
                shape: "S7",
                locationName: "accelerationSettings"
              },
              BillingTagsSource: {
                locationName: "billingTagsSource"
              },
              ClientRequestToken: {
                locationName: "clientRequestToken",
                idempotencyToken: true
              },
              HopDestinations: {
                shape: "Sa",
                locationName: "hopDestinations"
              },
              JobTemplate: {
                locationName: "jobTemplate"
              },
              Priority: {
                locationName: "priority",
                type: "integer"
              },
              Queue: {
                locationName: "queue"
              },
              Role: {
                locationName: "role"
              },
              Settings: {
                shape: "Se",
                locationName: "settings"
              },
              SimulateReservedQueue: {
                locationName: "simulateReservedQueue"
              },
              StatusUpdateInterval: {
                locationName: "statusUpdateInterval"
              },
              Tags: {
                shape: "Sl8",
                locationName: "tags"
              },
              UserMetadata: {
                shape: "Sl8",
                locationName: "userMetadata"
              }
            },
            required: [
              "Role",
              "Settings"
            ]
          },
          output: {
            type: "structure",
            members: {
              Job: {
                shape: "Sla",
                locationName: "job"
              }
            }
          }
        },
        CreateJobTemplate: {
          http: {
            requestUri: "/2017-08-29/jobTemplates",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              AccelerationSettings: {
                shape: "S7",
                locationName: "accelerationSettings"
              },
              Category: {
                locationName: "category"
              },
              Description: {
                locationName: "description"
              },
              HopDestinations: {
                shape: "Sa",
                locationName: "hopDestinations"
              },
              Name: {
                locationName: "name"
              },
              Priority: {
                locationName: "priority",
                type: "integer"
              },
              Queue: {
                locationName: "queue"
              },
              Settings: {
                shape: "Sls",
                locationName: "settings"
              },
              StatusUpdateInterval: {
                locationName: "statusUpdateInterval"
              },
              Tags: {
                shape: "Sl8",
                locationName: "tags"
              }
            },
            required: [
              "Settings",
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              JobTemplate: {
                shape: "Slw",
                locationName: "jobTemplate"
              }
            }
          }
        },
        CreatePreset: {
          http: {
            requestUri: "/2017-08-29/presets",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              Category: {
                locationName: "category"
              },
              Description: {
                locationName: "description"
              },
              Name: {
                locationName: "name"
              },
              Settings: {
                shape: "Slz",
                locationName: "settings"
              },
              Tags: {
                shape: "Sl8",
                locationName: "tags"
              }
            },
            required: [
              "Settings",
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              Preset: {
                shape: "Sm3",
                locationName: "preset"
              }
            }
          }
        },
        CreateQueue: {
          http: {
            requestUri: "/2017-08-29/queues",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              Description: {
                locationName: "description"
              },
              Name: {
                locationName: "name"
              },
              PricingPlan: {
                locationName: "pricingPlan"
              },
              ReservationPlanSettings: {
                shape: "Sm6",
                locationName: "reservationPlanSettings"
              },
              Status: {
                locationName: "status"
              },
              Tags: {
                shape: "Sl8",
                locationName: "tags"
              }
            },
            required: [
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              Queue: {
                shape: "Smb",
                locationName: "queue"
              }
            }
          }
        },
        DeleteJobTemplate: {
          http: {
            method: "DELETE",
            requestUri: "/2017-08-29/jobTemplates/{name}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              Name: {
                locationName: "name",
                location: "uri"
              }
            },
            required: [
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeletePolicy: {
          http: {
            method: "DELETE",
            requestUri: "/2017-08-29/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeletePreset: {
          http: {
            method: "DELETE",
            requestUri: "/2017-08-29/presets/{name}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              Name: {
                locationName: "name",
                location: "uri"
              }
            },
            required: [
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteQueue: {
          http: {
            method: "DELETE",
            requestUri: "/2017-08-29/queues/{name}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              Name: {
                locationName: "name",
                location: "uri"
              }
            },
            required: [
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeEndpoints: {
          http: {
            requestUri: "/2017-08-29/endpoints",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              Mode: {
                locationName: "mode"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Endpoints: {
                locationName: "endpoints",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Url: {
                      locationName: "url"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DisassociateCertificate: {
          http: {
            method: "DELETE",
            requestUri: "/2017-08-29/certificates/{arn}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn",
                location: "uri"
              }
            },
            required: [
              "Arn"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetJob: {
          http: {
            method: "GET",
            requestUri: "/2017-08-29/jobs/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Id: {
                locationName: "id",
                location: "uri"
              }
            },
            required: [
              "Id"
            ]
          },
          output: {
            type: "structure",
            members: {
              Job: {
                shape: "Sla",
                locationName: "job"
              }
            }
          }
        },
        GetJobTemplate: {
          http: {
            method: "GET",
            requestUri: "/2017-08-29/jobTemplates/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Name: {
                locationName: "name",
                location: "uri"
              }
            },
            required: [
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              JobTemplate: {
                shape: "Slw",
                locationName: "jobTemplate"
              }
            }
          }
        },
        GetPolicy: {
          http: {
            method: "GET",
            requestUri: "/2017-08-29/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              Policy: {
                shape: "Smz",
                locationName: "policy"
              }
            }
          }
        },
        GetPreset: {
          http: {
            method: "GET",
            requestUri: "/2017-08-29/presets/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Name: {
                locationName: "name",
                location: "uri"
              }
            },
            required: [
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              Preset: {
                shape: "Sm3",
                locationName: "preset"
              }
            }
          }
        },
        GetQueue: {
          http: {
            method: "GET",
            requestUri: "/2017-08-29/queues/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Name: {
                locationName: "name",
                location: "uri"
              }
            },
            required: [
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              Queue: {
                shape: "Smb",
                locationName: "queue"
              }
            }
          }
        },
        ListJobTemplates: {
          http: {
            method: "GET",
            requestUri: "/2017-08-29/jobTemplates",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Category: {
                locationName: "category",
                location: "querystring"
              },
              ListBy: {
                locationName: "listBy",
                location: "querystring"
              },
              MaxResults: {
                locationName: "maxResults",
                location: "querystring",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken",
                location: "querystring"
              },
              Order: {
                locationName: "order",
                location: "querystring"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobTemplates: {
                locationName: "jobTemplates",
                type: "list",
                member: {
                  shape: "Slw"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListJobs: {
          http: {
            method: "GET",
            requestUri: "/2017-08-29/jobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                locationName: "maxResults",
                location: "querystring",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken",
                location: "querystring"
              },
              Order: {
                locationName: "order",
                location: "querystring"
              },
              Queue: {
                locationName: "queue",
                location: "querystring"
              },
              Status: {
                locationName: "status",
                location: "querystring"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Jobs: {
                locationName: "jobs",
                type: "list",
                member: {
                  shape: "Sla"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListPresets: {
          http: {
            method: "GET",
            requestUri: "/2017-08-29/presets",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Category: {
                locationName: "category",
                location: "querystring"
              },
              ListBy: {
                locationName: "listBy",
                location: "querystring"
              },
              MaxResults: {
                locationName: "maxResults",
                location: "querystring",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken",
                location: "querystring"
              },
              Order: {
                locationName: "order",
                location: "querystring"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Presets: {
                locationName: "presets",
                type: "list",
                member: {
                  shape: "Sm3"
                }
              }
            }
          }
        },
        ListQueues: {
          http: {
            method: "GET",
            requestUri: "/2017-08-29/queues",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ListBy: {
                locationName: "listBy",
                location: "querystring"
              },
              MaxResults: {
                locationName: "maxResults",
                location: "querystring",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken",
                location: "querystring"
              },
              Order: {
                locationName: "order",
                location: "querystring"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Queues: {
                locationName: "queues",
                type: "list",
                member: {
                  shape: "Smb"
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/2017-08-29/tags/{arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn",
                location: "uri"
              }
            },
            required: [
              "Arn"
            ]
          },
          output: {
            type: "structure",
            members: {
              ResourceTags: {
                locationName: "resourceTags",
                type: "structure",
                members: {
                  Arn: {
                    locationName: "arn"
                  },
                  Tags: {
                    shape: "Sl8",
                    locationName: "tags"
                  }
                }
              }
            }
          }
        },
        PutPolicy: {
          http: {
            method: "PUT",
            requestUri: "/2017-08-29/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Policy: {
                shape: "Smz",
                locationName: "policy"
              }
            },
            required: [
              "Policy"
            ]
          },
          output: {
            type: "structure",
            members: {
              Policy: {
                shape: "Smz",
                locationName: "policy"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/2017-08-29/tags",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              Tags: {
                shape: "Sl8",
                locationName: "tags"
              }
            },
            required: [
              "Arn",
              "Tags"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "PUT",
            requestUri: "/2017-08-29/tags/{arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn",
                location: "uri"
              },
              TagKeys: {
                shape: "Slf",
                locationName: "tagKeys"
              }
            },
            required: [
              "Arn"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateJobTemplate: {
          http: {
            method: "PUT",
            requestUri: "/2017-08-29/jobTemplates/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AccelerationSettings: {
                shape: "S7",
                locationName: "accelerationSettings"
              },
              Category: {
                locationName: "category"
              },
              Description: {
                locationName: "description"
              },
              HopDestinations: {
                shape: "Sa",
                locationName: "hopDestinations"
              },
              Name: {
                locationName: "name",
                location: "uri"
              },
              Priority: {
                locationName: "priority",
                type: "integer"
              },
              Queue: {
                locationName: "queue"
              },
              Settings: {
                shape: "Sls",
                locationName: "settings"
              },
              StatusUpdateInterval: {
                locationName: "statusUpdateInterval"
              }
            },
            required: [
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              JobTemplate: {
                shape: "Slw",
                locationName: "jobTemplate"
              }
            }
          }
        },
        UpdatePreset: {
          http: {
            method: "PUT",
            requestUri: "/2017-08-29/presets/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Category: {
                locationName: "category"
              },
              Description: {
                locationName: "description"
              },
              Name: {
                locationName: "name",
                location: "uri"
              },
              Settings: {
                shape: "Slz",
                locationName: "settings"
              }
            },
            required: [
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              Preset: {
                shape: "Sm3",
                locationName: "preset"
              }
            }
          }
        },
        UpdateQueue: {
          http: {
            method: "PUT",
            requestUri: "/2017-08-29/queues/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Description: {
                locationName: "description"
              },
              Name: {
                locationName: "name",
                location: "uri"
              },
              ReservationPlanSettings: {
                shape: "Sm6",
                locationName: "reservationPlanSettings"
              },
              Status: {
                locationName: "status"
              }
            },
            required: [
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              Queue: {
                shape: "Smb",
                locationName: "queue"
              }
            }
          }
        }
      },
      shapes: {
        S7: {
          type: "structure",
          members: {
            Mode: {
              locationName: "mode"
            }
          },
          required: [
            "Mode"
          ]
        },
        Sa: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Priority: {
                locationName: "priority",
                type: "integer"
              },
              Queue: {
                locationName: "queue"
              },
              WaitMinutes: {
                locationName: "waitMinutes",
                type: "integer"
              }
            }
          }
        },
        Se: {
          type: "structure",
          members: {
            AdAvailOffset: {
              locationName: "adAvailOffset",
              type: "integer"
            },
            AvailBlanking: {
              shape: "Sg",
              locationName: "availBlanking"
            },
            ColorConversion3DLUTSettings: {
              shape: "Si",
              locationName: "colorConversion3DLUTSettings"
            },
            Esam: {
              shape: "Sn",
              locationName: "esam"
            },
            ExtendedDataServices: {
              shape: "St",
              locationName: "extendedDataServices"
            },
            FollowSource: {
              locationName: "followSource",
              type: "integer"
            },
            Inputs: {
              locationName: "inputs",
              type: "list",
              member: {
                type: "structure",
                members: {
                  AdvancedInputFilter: {
                    locationName: "advancedInputFilter"
                  },
                  AdvancedInputFilterSettings: {
                    shape: "S10",
                    locationName: "advancedInputFilterSettings"
                  },
                  AudioSelectorGroups: {
                    shape: "S13",
                    locationName: "audioSelectorGroups"
                  },
                  AudioSelectors: {
                    shape: "S17",
                    locationName: "audioSelectors"
                  },
                  CaptionSelectors: {
                    shape: "S1t",
                    locationName: "captionSelectors"
                  },
                  Crop: {
                    shape: "S2i",
                    locationName: "crop"
                  },
                  DeblockFilter: {
                    locationName: "deblockFilter"
                  },
                  DecryptionSettings: {
                    locationName: "decryptionSettings",
                    type: "structure",
                    members: {
                      DecryptionMode: {
                        locationName: "decryptionMode"
                      },
                      EncryptedDecryptionKey: {
                        locationName: "encryptedDecryptionKey"
                      },
                      InitializationVector: {
                        locationName: "initializationVector"
                      },
                      KmsKeyRegion: {
                        locationName: "kmsKeyRegion"
                      }
                    }
                  },
                  DenoiseFilter: {
                    locationName: "denoiseFilter"
                  },
                  DolbyVisionMetadataXml: {
                    locationName: "dolbyVisionMetadataXml"
                  },
                  FileInput: {
                    locationName: "fileInput"
                  },
                  FilterEnable: {
                    locationName: "filterEnable"
                  },
                  FilterStrength: {
                    locationName: "filterStrength",
                    type: "integer"
                  },
                  ImageInserter: {
                    shape: "S2u",
                    locationName: "imageInserter"
                  },
                  InputClippings: {
                    shape: "S32",
                    locationName: "inputClippings"
                  },
                  InputScanType: {
                    locationName: "inputScanType"
                  },
                  Position: {
                    shape: "S2i",
                    locationName: "position"
                  },
                  ProgramNumber: {
                    locationName: "programNumber",
                    type: "integer"
                  },
                  PsiControl: {
                    locationName: "psiControl"
                  },
                  SupplementalImps: {
                    locationName: "supplementalImps",
                    type: "list",
                    member: {}
                  },
                  TimecodeSource: {
                    locationName: "timecodeSource"
                  },
                  TimecodeStart: {
                    locationName: "timecodeStart"
                  },
                  VideoGenerator: {
                    locationName: "videoGenerator",
                    type: "structure",
                    members: {
                      Duration: {
                        locationName: "duration",
                        type: "integer"
                      }
                    }
                  },
                  VideoOverlays: {
                    shape: "S3d",
                    locationName: "videoOverlays"
                  },
                  VideoSelector: {
                    shape: "S3i",
                    locationName: "videoSelector"
                  }
                }
              }
            },
            KantarWatermark: {
              shape: "S3s",
              locationName: "kantarWatermark"
            },
            MotionImageInserter: {
              shape: "S40",
              locationName: "motionImageInserter"
            },
            NielsenConfiguration: {
              shape: "S48",
              locationName: "nielsenConfiguration"
            },
            NielsenNonLinearWatermark: {
              shape: "S4a",
              locationName: "nielsenNonLinearWatermark"
            },
            OutputGroups: {
              shape: "S4h",
              locationName: "outputGroups"
            },
            TimecodeConfig: {
              shape: "Sl0",
              locationName: "timecodeConfig"
            },
            TimedMetadataInsertion: {
              shape: "Sl3",
              locationName: "timedMetadataInsertion"
            }
          }
        },
        Sg: {
          type: "structure",
          members: {
            AvailBlankingImage: {
              locationName: "availBlankingImage"
            }
          }
        },
        Si: {
          type: "list",
          member: {
            type: "structure",
            members: {
              FileInput: {
                locationName: "fileInput"
              },
              InputColorSpace: {
                locationName: "inputColorSpace"
              },
              InputMasteringLuminance: {
                locationName: "inputMasteringLuminance",
                type: "integer"
              },
              OutputColorSpace: {
                locationName: "outputColorSpace"
              },
              OutputMasteringLuminance: {
                locationName: "outputMasteringLuminance",
                type: "integer"
              }
            }
          }
        },
        Sn: {
          type: "structure",
          members: {
            ManifestConfirmConditionNotification: {
              locationName: "manifestConfirmConditionNotification",
              type: "structure",
              members: {
                MccXml: {
                  locationName: "mccXml"
                }
              }
            },
            ResponseSignalPreroll: {
              locationName: "responseSignalPreroll",
              type: "integer"
            },
            SignalProcessingNotification: {
              locationName: "signalProcessingNotification",
              type: "structure",
              members: {
                SccXml: {
                  locationName: "sccXml"
                }
              }
            }
          }
        },
        St: {
          type: "structure",
          members: {
            CopyProtectionAction: {
              locationName: "copyProtectionAction"
            },
            VchipAction: {
              locationName: "vchipAction"
            }
          }
        },
        S10: {
          type: "structure",
          members: {
            AddTexture: {
              locationName: "addTexture"
            },
            Sharpening: {
              locationName: "sharpening"
            }
          }
        },
        S13: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              AudioSelectorNames: {
                shape: "S15",
                locationName: "audioSelectorNames"
              }
            }
          }
        },
        S15: {
          type: "list",
          member: {}
        },
        S17: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              AudioDurationCorrection: {
                locationName: "audioDurationCorrection"
              },
              CustomLanguageCode: {
                locationName: "customLanguageCode"
              },
              DefaultSelection: {
                locationName: "defaultSelection"
              },
              ExternalAudioFileInput: {
                locationName: "externalAudioFileInput"
              },
              HlsRenditionGroupSettings: {
                locationName: "hlsRenditionGroupSettings",
                type: "structure",
                members: {
                  RenditionGroupId: {
                    locationName: "renditionGroupId"
                  },
                  RenditionLanguageCode: {
                    locationName: "renditionLanguageCode"
                  },
                  RenditionName: {
                    locationName: "renditionName"
                  }
                }
              },
              LanguageCode: {
                locationName: "languageCode"
              },
              Offset: {
                locationName: "offset",
                type: "integer"
              },
              Pids: {
                shape: "S1g",
                locationName: "pids"
              },
              ProgramSelection: {
                locationName: "programSelection",
                type: "integer"
              },
              RemixSettings: {
                shape: "S1j",
                locationName: "remixSettings"
              },
              SelectorType: {
                locationName: "selectorType"
              },
              Tracks: {
                shape: "S1g",
                locationName: "tracks"
              }
            }
          }
        },
        S1g: {
          type: "list",
          member: {
            type: "integer"
          }
        },
        S1j: {
          type: "structure",
          members: {
            ChannelMapping: {
              locationName: "channelMapping",
              type: "structure",
              members: {
                OutputChannels: {
                  locationName: "outputChannels",
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      InputChannels: {
                        locationName: "inputChannels",
                        type: "list",
                        member: {
                          type: "integer"
                        }
                      },
                      InputChannelsFineTune: {
                        locationName: "inputChannelsFineTune",
                        type: "list",
                        member: {
                          type: "double"
                        }
                      }
                    }
                  }
                }
              }
            },
            ChannelsIn: {
              locationName: "channelsIn",
              type: "integer"
            },
            ChannelsOut: {
              locationName: "channelsOut",
              type: "integer"
            }
          }
        },
        S1t: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              CustomLanguageCode: {
                locationName: "customLanguageCode"
              },
              LanguageCode: {
                locationName: "languageCode"
              },
              SourceSettings: {
                locationName: "sourceSettings",
                type: "structure",
                members: {
                  AncillarySourceSettings: {
                    locationName: "ancillarySourceSettings",
                    type: "structure",
                    members: {
                      Convert608To708: {
                        locationName: "convert608To708"
                      },
                      SourceAncillaryChannelNumber: {
                        locationName: "sourceAncillaryChannelNumber",
                        type: "integer"
                      },
                      TerminateCaptions: {
                        locationName: "terminateCaptions"
                      }
                    }
                  },
                  DvbSubSourceSettings: {
                    locationName: "dvbSubSourceSettings",
                    type: "structure",
                    members: {
                      Pid: {
                        locationName: "pid",
                        type: "integer"
                      }
                    }
                  },
                  EmbeddedSourceSettings: {
                    locationName: "embeddedSourceSettings",
                    type: "structure",
                    members: {
                      Convert608To708: {
                        locationName: "convert608To708"
                      },
                      Source608ChannelNumber: {
                        locationName: "source608ChannelNumber",
                        type: "integer"
                      },
                      Source608TrackNumber: {
                        locationName: "source608TrackNumber",
                        type: "integer"
                      },
                      TerminateCaptions: {
                        locationName: "terminateCaptions"
                      }
                    }
                  },
                  FileSourceSettings: {
                    locationName: "fileSourceSettings",
                    type: "structure",
                    members: {
                      Convert608To708: {
                        locationName: "convert608To708"
                      },
                      ConvertPaintToPop: {
                        locationName: "convertPaintToPop"
                      },
                      Framerate: {
                        locationName: "framerate",
                        type: "structure",
                        members: {
                          FramerateDenominator: {
                            locationName: "framerateDenominator",
                            type: "integer"
                          },
                          FramerateNumerator: {
                            locationName: "framerateNumerator",
                            type: "integer"
                          }
                        }
                      },
                      SourceFile: {
                        locationName: "sourceFile"
                      },
                      TimeDelta: {
                        locationName: "timeDelta",
                        type: "integer"
                      },
                      TimeDeltaUnits: {
                        locationName: "timeDeltaUnits"
                      }
                    }
                  },
                  SourceType: {
                    locationName: "sourceType"
                  },
                  TeletextSourceSettings: {
                    locationName: "teletextSourceSettings",
                    type: "structure",
                    members: {
                      PageNumber: {
                        locationName: "pageNumber"
                      }
                    }
                  },
                  TrackSourceSettings: {
                    locationName: "trackSourceSettings",
                    type: "structure",
                    members: {
                      TrackNumber: {
                        locationName: "trackNumber",
                        type: "integer"
                      }
                    }
                  },
                  WebvttHlsSourceSettings: {
                    locationName: "webvttHlsSourceSettings",
                    type: "structure",
                    members: {
                      RenditionGroupId: {
                        locationName: "renditionGroupId"
                      },
                      RenditionLanguageCode: {
                        locationName: "renditionLanguageCode"
                      },
                      RenditionName: {
                        locationName: "renditionName"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S2i: {
          type: "structure",
          members: {
            Height: {
              locationName: "height",
              type: "integer"
            },
            Width: {
              locationName: "width",
              type: "integer"
            },
            X: {
              locationName: "x",
              type: "integer"
            },
            Y: {
              locationName: "y",
              type: "integer"
            }
          }
        },
        S2u: {
          type: "structure",
          members: {
            InsertableImages: {
              locationName: "insertableImages",
              type: "list",
              member: {
                type: "structure",
                members: {
                  Duration: {
                    locationName: "duration",
                    type: "integer"
                  },
                  FadeIn: {
                    locationName: "fadeIn",
                    type: "integer"
                  },
                  FadeOut: {
                    locationName: "fadeOut",
                    type: "integer"
                  },
                  Height: {
                    locationName: "height",
                    type: "integer"
                  },
                  ImageInserterInput: {
                    locationName: "imageInserterInput"
                  },
                  ImageX: {
                    locationName: "imageX",
                    type: "integer"
                  },
                  ImageY: {
                    locationName: "imageY",
                    type: "integer"
                  },
                  Layer: {
                    locationName: "layer",
                    type: "integer"
                  },
                  Opacity: {
                    locationName: "opacity",
                    type: "integer"
                  },
                  StartTime: {
                    locationName: "startTime"
                  },
                  Width: {
                    locationName: "width",
                    type: "integer"
                  }
                }
              }
            },
            SdrReferenceWhiteLevel: {
              locationName: "sdrReferenceWhiteLevel",
              type: "integer"
            }
          }
        },
        S32: {
          type: "list",
          member: {
            type: "structure",
            members: {
              EndTimecode: {
                locationName: "endTimecode"
              },
              StartTimecode: {
                locationName: "startTimecode"
              }
            }
          }
        },
        S3d: {
          type: "list",
          member: {
            type: "structure",
            members: {
              EndTimecode: {
                locationName: "endTimecode"
              },
              Input: {
                locationName: "input",
                type: "structure",
                members: {
                  FileInput: {
                    locationName: "fileInput"
                  },
                  InputClippings: {
                    locationName: "inputClippings",
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        EndTimecode: {
                          locationName: "endTimecode"
                        },
                        StartTimecode: {
                          locationName: "startTimecode"
                        }
                      }
                    }
                  },
                  TimecodeSource: {
                    locationName: "timecodeSource"
                  },
                  TimecodeStart: {
                    locationName: "timecodeStart"
                  }
                }
              },
              StartTimecode: {
                locationName: "startTimecode"
              }
            }
          }
        },
        S3i: {
          type: "structure",
          members: {
            AlphaBehavior: {
              locationName: "alphaBehavior"
            },
            ColorSpace: {
              locationName: "colorSpace"
            },
            ColorSpaceUsage: {
              locationName: "colorSpaceUsage"
            },
            EmbeddedTimecodeOverride: {
              locationName: "embeddedTimecodeOverride"
            },
            Hdr10Metadata: {
              shape: "S3m",
              locationName: "hdr10Metadata"
            },
            MaxLuminance: {
              locationName: "maxLuminance",
              type: "integer"
            },
            PadVideo: {
              locationName: "padVideo"
            },
            Pid: {
              locationName: "pid",
              type: "integer"
            },
            ProgramNumber: {
              locationName: "programNumber",
              type: "integer"
            },
            Rotate: {
              locationName: "rotate"
            },
            SampleRange: {
              locationName: "sampleRange"
            }
          }
        },
        S3m: {
          type: "structure",
          members: {
            BluePrimaryX: {
              locationName: "bluePrimaryX",
              type: "integer"
            },
            BluePrimaryY: {
              locationName: "bluePrimaryY",
              type: "integer"
            },
            GreenPrimaryX: {
              locationName: "greenPrimaryX",
              type: "integer"
            },
            GreenPrimaryY: {
              locationName: "greenPrimaryY",
              type: "integer"
            },
            MaxContentLightLevel: {
              locationName: "maxContentLightLevel",
              type: "integer"
            },
            MaxFrameAverageLightLevel: {
              locationName: "maxFrameAverageLightLevel",
              type: "integer"
            },
            MaxLuminance: {
              locationName: "maxLuminance",
              type: "integer"
            },
            MinLuminance: {
              locationName: "minLuminance",
              type: "integer"
            },
            RedPrimaryX: {
              locationName: "redPrimaryX",
              type: "integer"
            },
            RedPrimaryY: {
              locationName: "redPrimaryY",
              type: "integer"
            },
            WhitePointX: {
              locationName: "whitePointX",
              type: "integer"
            },
            WhitePointY: {
              locationName: "whitePointY",
              type: "integer"
            }
          }
        },
        S3s: {
          type: "structure",
          members: {
            ChannelName: {
              locationName: "channelName"
            },
            ContentReference: {
              locationName: "contentReference"
            },
            CredentialsSecretName: {
              locationName: "credentialsSecretName"
            },
            FileOffset: {
              locationName: "fileOffset",
              type: "double"
            },
            KantarLicenseId: {
              locationName: "kantarLicenseId",
              type: "integer"
            },
            KantarServerUrl: {
              locationName: "kantarServerUrl"
            },
            LogDestination: {
              locationName: "logDestination"
            },
            Metadata3: {
              locationName: "metadata3"
            },
            Metadata4: {
              locationName: "metadata4"
            },
            Metadata5: {
              locationName: "metadata5"
            },
            Metadata6: {
              locationName: "metadata6"
            },
            Metadata7: {
              locationName: "metadata7"
            },
            Metadata8: {
              locationName: "metadata8"
            }
          }
        },
        S40: {
          type: "structure",
          members: {
            Framerate: {
              locationName: "framerate",
              type: "structure",
              members: {
                FramerateDenominator: {
                  locationName: "framerateDenominator",
                  type: "integer"
                },
                FramerateNumerator: {
                  locationName: "framerateNumerator",
                  type: "integer"
                }
              }
            },
            Input: {
              locationName: "input"
            },
            InsertionMode: {
              locationName: "insertionMode"
            },
            Offset: {
              locationName: "offset",
              type: "structure",
              members: {
                ImageX: {
                  locationName: "imageX",
                  type: "integer"
                },
                ImageY: {
                  locationName: "imageY",
                  type: "integer"
                }
              }
            },
            Playback: {
              locationName: "playback"
            },
            StartTime: {
              locationName: "startTime"
            }
          }
        },
        S48: {
          type: "structure",
          members: {
            BreakoutCode: {
              locationName: "breakoutCode",
              type: "integer"
            },
            DistributorId: {
              locationName: "distributorId"
            }
          }
        },
        S4a: {
          type: "structure",
          members: {
            ActiveWatermarkProcess: {
              locationName: "activeWatermarkProcess"
            },
            AdiFilename: {
              locationName: "adiFilename"
            },
            AssetId: {
              locationName: "assetId"
            },
            AssetName: {
              locationName: "assetName"
            },
            CbetSourceId: {
              locationName: "cbetSourceId"
            },
            EpisodeId: {
              locationName: "episodeId"
            },
            MetadataDestination: {
              locationName: "metadataDestination"
            },
            SourceId: {
              locationName: "sourceId",
              type: "integer"
            },
            SourceWatermarkStatus: {
              locationName: "sourceWatermarkStatus"
            },
            TicServerUrl: {
              locationName: "ticServerUrl"
            },
            UniqueTicPerAudioTrack: {
              locationName: "uniqueTicPerAudioTrack"
            }
          }
        },
        S4h: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AutomatedEncodingSettings: {
                locationName: "automatedEncodingSettings",
                type: "structure",
                members: {
                  AbrSettings: {
                    locationName: "abrSettings",
                    type: "structure",
                    members: {
                      MaxAbrBitrate: {
                        locationName: "maxAbrBitrate",
                        type: "integer"
                      },
                      MaxRenditions: {
                        locationName: "maxRenditions",
                        type: "integer"
                      },
                      MinAbrBitrate: {
                        locationName: "minAbrBitrate",
                        type: "integer"
                      },
                      Rules: {
                        locationName: "rules",
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            AllowedRenditions: {
                              locationName: "allowedRenditions",
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  Height: {
                                    locationName: "height",
                                    type: "integer"
                                  },
                                  Required: {
                                    locationName: "required"
                                  },
                                  Width: {
                                    locationName: "width",
                                    type: "integer"
                                  }
                                }
                              }
                            },
                            ForceIncludeRenditions: {
                              locationName: "forceIncludeRenditions",
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  Height: {
                                    locationName: "height",
                                    type: "integer"
                                  },
                                  Width: {
                                    locationName: "width",
                                    type: "integer"
                                  }
                                }
                              }
                            },
                            MinBottomRenditionSize: {
                              locationName: "minBottomRenditionSize",
                              type: "structure",
                              members: {
                                Height: {
                                  locationName: "height",
                                  type: "integer"
                                },
                                Width: {
                                  locationName: "width",
                                  type: "integer"
                                }
                              }
                            },
                            MinTopRenditionSize: {
                              locationName: "minTopRenditionSize",
                              type: "structure",
                              members: {
                                Height: {
                                  locationName: "height",
                                  type: "integer"
                                },
                                Width: {
                                  locationName: "width",
                                  type: "integer"
                                }
                              }
                            },
                            Type: {
                              locationName: "type"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              CustomName: {
                locationName: "customName"
              },
              Name: {
                locationName: "name"
              },
              OutputGroupSettings: {
                locationName: "outputGroupSettings",
                type: "structure",
                members: {
                  CmafGroupSettings: {
                    locationName: "cmafGroupSettings",
                    type: "structure",
                    members: {
                      AdditionalManifests: {
                        locationName: "additionalManifests",
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            ManifestNameModifier: {
                              locationName: "manifestNameModifier"
                            },
                            SelectedOutputs: {
                              shape: "S15",
                              locationName: "selectedOutputs"
                            }
                          }
                        }
                      },
                      BaseUrl: {
                        locationName: "baseUrl"
                      },
                      ClientCache: {
                        locationName: "clientCache"
                      },
                      CodecSpecification: {
                        locationName: "codecSpecification"
                      },
                      DashManifestStyle: {
                        locationName: "dashManifestStyle"
                      },
                      Destination: {
                        locationName: "destination"
                      },
                      DestinationSettings: {
                        shape: "S55",
                        locationName: "destinationSettings"
                      },
                      Encryption: {
                        locationName: "encryption",
                        type: "structure",
                        members: {
                          ConstantInitializationVector: {
                            locationName: "constantInitializationVector"
                          },
                          EncryptionMethod: {
                            locationName: "encryptionMethod"
                          },
                          InitializationVectorInManifest: {
                            locationName: "initializationVectorInManifest"
                          },
                          SpekeKeyProvider: {
                            locationName: "spekeKeyProvider",
                            type: "structure",
                            members: {
                              CertificateArn: {
                                locationName: "certificateArn"
                              },
                              DashSignaledSystemIds: {
                                shape: "S5k",
                                locationName: "dashSignaledSystemIds"
                              },
                              HlsSignaledSystemIds: {
                                shape: "S5k",
                                locationName: "hlsSignaledSystemIds"
                              },
                              ResourceId: {
                                locationName: "resourceId"
                              },
                              Url: {
                                locationName: "url"
                              }
                            }
                          },
                          StaticKeyProvider: {
                            shape: "S5o",
                            locationName: "staticKeyProvider"
                          },
                          Type: {
                            locationName: "type"
                          }
                        }
                      },
                      FragmentLength: {
                        locationName: "fragmentLength",
                        type: "integer"
                      },
                      ImageBasedTrickPlay: {
                        locationName: "imageBasedTrickPlay"
                      },
                      ImageBasedTrickPlaySettings: {
                        locationName: "imageBasedTrickPlaySettings",
                        type: "structure",
                        members: {
                          IntervalCadence: {
                            locationName: "intervalCadence"
                          },
                          ThumbnailHeight: {
                            locationName: "thumbnailHeight",
                            type: "integer"
                          },
                          ThumbnailInterval: {
                            locationName: "thumbnailInterval",
                            type: "double"
                          },
                          ThumbnailWidth: {
                            locationName: "thumbnailWidth",
                            type: "integer"
                          },
                          TileHeight: {
                            locationName: "tileHeight",
                            type: "integer"
                          },
                          TileWidth: {
                            locationName: "tileWidth",
                            type: "integer"
                          }
                        }
                      },
                      ManifestCompression: {
                        locationName: "manifestCompression"
                      },
                      ManifestDurationFormat: {
                        locationName: "manifestDurationFormat"
                      },
                      MinBufferTime: {
                        locationName: "minBufferTime",
                        type: "integer"
                      },
                      MinFinalSegmentLength: {
                        locationName: "minFinalSegmentLength",
                        type: "double"
                      },
                      MpdManifestBandwidthType: {
                        locationName: "mpdManifestBandwidthType"
                      },
                      MpdProfile: {
                        locationName: "mpdProfile"
                      },
                      PtsOffsetHandlingForBFrames: {
                        locationName: "ptsOffsetHandlingForBFrames"
                      },
                      SegmentControl: {
                        locationName: "segmentControl"
                      },
                      SegmentLength: {
                        locationName: "segmentLength",
                        type: "integer"
                      },
                      SegmentLengthControl: {
                        locationName: "segmentLengthControl"
                      },
                      StreamInfResolution: {
                        locationName: "streamInfResolution"
                      },
                      TargetDurationCompatibilityMode: {
                        locationName: "targetDurationCompatibilityMode"
                      },
                      VideoCompositionOffsets: {
                        locationName: "videoCompositionOffsets"
                      },
                      WriteDashManifest: {
                        locationName: "writeDashManifest"
                      },
                      WriteHlsManifest: {
                        locationName: "writeHlsManifest"
                      },
                      WriteSegmentTimelineInRepresentation: {
                        locationName: "writeSegmentTimelineInRepresentation"
                      }
                    }
                  },
                  DashIsoGroupSettings: {
                    locationName: "dashIsoGroupSettings",
                    type: "structure",
                    members: {
                      AdditionalManifests: {
                        locationName: "additionalManifests",
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            ManifestNameModifier: {
                              locationName: "manifestNameModifier"
                            },
                            SelectedOutputs: {
                              shape: "S15",
                              locationName: "selectedOutputs"
                            }
                          }
                        }
                      },
                      AudioChannelConfigSchemeIdUri: {
                        locationName: "audioChannelConfigSchemeIdUri"
                      },
                      BaseUrl: {
                        locationName: "baseUrl"
                      },
                      DashManifestStyle: {
                        locationName: "dashManifestStyle"
                      },
                      Destination: {
                        locationName: "destination"
                      },
                      DestinationSettings: {
                        shape: "S55",
                        locationName: "destinationSettings"
                      },
                      Encryption: {
                        locationName: "encryption",
                        type: "structure",
                        members: {
                          PlaybackDeviceCompatibility: {
                            locationName: "playbackDeviceCompatibility"
                          },
                          SpekeKeyProvider: {
                            shape: "S6k",
                            locationName: "spekeKeyProvider"
                          }
                        }
                      },
                      FragmentLength: {
                        locationName: "fragmentLength",
                        type: "integer"
                      },
                      HbbtvCompliance: {
                        locationName: "hbbtvCompliance"
                      },
                      ImageBasedTrickPlay: {
                        locationName: "imageBasedTrickPlay"
                      },
                      ImageBasedTrickPlaySettings: {
                        locationName: "imageBasedTrickPlaySettings",
                        type: "structure",
                        members: {
                          IntervalCadence: {
                            locationName: "intervalCadence"
                          },
                          ThumbnailHeight: {
                            locationName: "thumbnailHeight",
                            type: "integer"
                          },
                          ThumbnailInterval: {
                            locationName: "thumbnailInterval",
                            type: "double"
                          },
                          ThumbnailWidth: {
                            locationName: "thumbnailWidth",
                            type: "integer"
                          },
                          TileHeight: {
                            locationName: "tileHeight",
                            type: "integer"
                          },
                          TileWidth: {
                            locationName: "tileWidth",
                            type: "integer"
                          }
                        }
                      },
                      MinBufferTime: {
                        locationName: "minBufferTime",
                        type: "integer"
                      },
                      MinFinalSegmentLength: {
                        locationName: "minFinalSegmentLength",
                        type: "double"
                      },
                      MpdManifestBandwidthType: {
                        locationName: "mpdManifestBandwidthType"
                      },
                      MpdProfile: {
                        locationName: "mpdProfile"
                      },
                      PtsOffsetHandlingForBFrames: {
                        locationName: "ptsOffsetHandlingForBFrames"
                      },
                      SegmentControl: {
                        locationName: "segmentControl"
                      },
                      SegmentLength: {
                        locationName: "segmentLength",
                        type: "integer"
                      },
                      SegmentLengthControl: {
                        locationName: "segmentLengthControl"
                      },
                      VideoCompositionOffsets: {
                        locationName: "videoCompositionOffsets"
                      },
                      WriteSegmentTimelineInRepresentation: {
                        locationName: "writeSegmentTimelineInRepresentation"
                      }
                    }
                  },
                  FileGroupSettings: {
                    locationName: "fileGroupSettings",
                    type: "structure",
                    members: {
                      Destination: {
                        locationName: "destination"
                      },
                      DestinationSettings: {
                        shape: "S55",
                        locationName: "destinationSettings"
                      }
                    }
                  },
                  HlsGroupSettings: {
                    locationName: "hlsGroupSettings",
                    type: "structure",
                    members: {
                      AdMarkers: {
                        locationName: "adMarkers",
                        type: "list",
                        member: {}
                      },
                      AdditionalManifests: {
                        locationName: "additionalManifests",
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            ManifestNameModifier: {
                              locationName: "manifestNameModifier"
                            },
                            SelectedOutputs: {
                              shape: "S15",
                              locationName: "selectedOutputs"
                            }
                          }
                        }
                      },
                      AudioOnlyHeader: {
                        locationName: "audioOnlyHeader"
                      },
                      BaseUrl: {
                        locationName: "baseUrl"
                      },
                      CaptionLanguageMappings: {
                        locationName: "captionLanguageMappings",
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            CaptionChannel: {
                              locationName: "captionChannel",
                              type: "integer"
                            },
                            CustomLanguageCode: {
                              locationName: "customLanguageCode"
                            },
                            LanguageCode: {
                              locationName: "languageCode"
                            },
                            LanguageDescription: {
                              locationName: "languageDescription"
                            }
                          }
                        }
                      },
                      CaptionLanguageSetting: {
                        locationName: "captionLanguageSetting"
                      },
                      CaptionSegmentLengthControl: {
                        locationName: "captionSegmentLengthControl"
                      },
                      ClientCache: {
                        locationName: "clientCache"
                      },
                      CodecSpecification: {
                        locationName: "codecSpecification"
                      },
                      Destination: {
                        locationName: "destination"
                      },
                      DestinationSettings: {
                        shape: "S55",
                        locationName: "destinationSettings"
                      },
                      DirectoryStructure: {
                        locationName: "directoryStructure"
                      },
                      Encryption: {
                        locationName: "encryption",
                        type: "structure",
                        members: {
                          ConstantInitializationVector: {
                            locationName: "constantInitializationVector"
                          },
                          EncryptionMethod: {
                            locationName: "encryptionMethod"
                          },
                          InitializationVectorInManifest: {
                            locationName: "initializationVectorInManifest"
                          },
                          OfflineEncrypted: {
                            locationName: "offlineEncrypted"
                          },
                          SpekeKeyProvider: {
                            shape: "S6k",
                            locationName: "spekeKeyProvider"
                          },
                          StaticKeyProvider: {
                            shape: "S5o",
                            locationName: "staticKeyProvider"
                          },
                          Type: {
                            locationName: "type"
                          }
                        }
                      },
                      ImageBasedTrickPlay: {
                        locationName: "imageBasedTrickPlay"
                      },
                      ImageBasedTrickPlaySettings: {
                        locationName: "imageBasedTrickPlaySettings",
                        type: "structure",
                        members: {
                          IntervalCadence: {
                            locationName: "intervalCadence"
                          },
                          ThumbnailHeight: {
                            locationName: "thumbnailHeight",
                            type: "integer"
                          },
                          ThumbnailInterval: {
                            locationName: "thumbnailInterval",
                            type: "double"
                          },
                          ThumbnailWidth: {
                            locationName: "thumbnailWidth",
                            type: "integer"
                          },
                          TileHeight: {
                            locationName: "tileHeight",
                            type: "integer"
                          },
                          TileWidth: {
                            locationName: "tileWidth",
                            type: "integer"
                          }
                        }
                      },
                      ManifestCompression: {
                        locationName: "manifestCompression"
                      },
                      ManifestDurationFormat: {
                        locationName: "manifestDurationFormat"
                      },
                      MinFinalSegmentLength: {
                        locationName: "minFinalSegmentLength",
                        type: "double"
                      },
                      MinSegmentLength: {
                        locationName: "minSegmentLength",
                        type: "integer"
                      },
                      OutputSelection: {
                        locationName: "outputSelection"
                      },
                      ProgramDateTime: {
                        locationName: "programDateTime"
                      },
                      ProgramDateTimePeriod: {
                        locationName: "programDateTimePeriod",
                        type: "integer"
                      },
                      ProgressiveWriteHlsManifest: {
                        locationName: "progressiveWriteHlsManifest"
                      },
                      SegmentControl: {
                        locationName: "segmentControl"
                      },
                      SegmentLength: {
                        locationName: "segmentLength",
                        type: "integer"
                      },
                      SegmentLengthControl: {
                        locationName: "segmentLengthControl"
                      },
                      SegmentsPerSubdirectory: {
                        locationName: "segmentsPerSubdirectory",
                        type: "integer"
                      },
                      StreamInfResolution: {
                        locationName: "streamInfResolution"
                      },
                      TargetDurationCompatibilityMode: {
                        locationName: "targetDurationCompatibilityMode"
                      },
                      TimedMetadataId3Frame: {
                        locationName: "timedMetadataId3Frame"
                      },
                      TimedMetadataId3Period: {
                        locationName: "timedMetadataId3Period",
                        type: "integer"
                      },
                      TimestampDeltaMilliseconds: {
                        locationName: "timestampDeltaMilliseconds",
                        type: "integer"
                      }
                    }
                  },
                  MsSmoothGroupSettings: {
                    locationName: "msSmoothGroupSettings",
                    type: "structure",
                    members: {
                      AdditionalManifests: {
                        locationName: "additionalManifests",
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            ManifestNameModifier: {
                              locationName: "manifestNameModifier"
                            },
                            SelectedOutputs: {
                              shape: "S15",
                              locationName: "selectedOutputs"
                            }
                          }
                        }
                      },
                      AudioDeduplication: {
                        locationName: "audioDeduplication"
                      },
                      Destination: {
                        locationName: "destination"
                      },
                      DestinationSettings: {
                        shape: "S55",
                        locationName: "destinationSettings"
                      },
                      Encryption: {
                        locationName: "encryption",
                        type: "structure",
                        members: {
                          SpekeKeyProvider: {
                            shape: "S6k",
                            locationName: "spekeKeyProvider"
                          }
                        }
                      },
                      FragmentLength: {
                        locationName: "fragmentLength",
                        type: "integer"
                      },
                      FragmentLengthControl: {
                        locationName: "fragmentLengthControl"
                      },
                      ManifestEncoding: {
                        locationName: "manifestEncoding"
                      }
                    }
                  },
                  Type: {
                    locationName: "type"
                  }
                }
              },
              Outputs: {
                locationName: "outputs",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AudioDescriptions: {
                      shape: "S86",
                      locationName: "audioDescriptions"
                    },
                    CaptionDescriptions: {
                      locationName: "captionDescriptions",
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          CaptionSelectorName: {
                            locationName: "captionSelectorName"
                          },
                          CustomLanguageCode: {
                            locationName: "customLanguageCode"
                          },
                          DestinationSettings: {
                            shape: "Sat",
                            locationName: "destinationSettings"
                          },
                          LanguageCode: {
                            locationName: "languageCode"
                          },
                          LanguageDescription: {
                            locationName: "languageDescription"
                          }
                        }
                      }
                    },
                    ContainerSettings: {
                      shape: "Sc3",
                      locationName: "containerSettings"
                    },
                    Extension: {
                      locationName: "extension"
                    },
                    NameModifier: {
                      locationName: "nameModifier"
                    },
                    OutputSettings: {
                      locationName: "outputSettings",
                      type: "structure",
                      members: {
                        HlsSettings: {
                          locationName: "hlsSettings",
                          type: "structure",
                          members: {
                            AudioGroupId: {
                              locationName: "audioGroupId"
                            },
                            AudioOnlyContainer: {
                              locationName: "audioOnlyContainer"
                            },
                            AudioRenditionSets: {
                              locationName: "audioRenditionSets"
                            },
                            AudioTrackType: {
                              locationName: "audioTrackType"
                            },
                            DescriptiveVideoServiceFlag: {
                              locationName: "descriptiveVideoServiceFlag"
                            },
                            IFrameOnlyManifest: {
                              locationName: "iFrameOnlyManifest"
                            },
                            SegmentModifier: {
                              locationName: "segmentModifier"
                            }
                          }
                        }
                      }
                    },
                    Preset: {
                      locationName: "preset"
                    },
                    VideoDescription: {
                      shape: "Sei",
                      locationName: "videoDescription"
                    }
                  }
                }
              }
            }
          }
        },
        S55: {
          type: "structure",
          members: {
            S3Settings: {
              locationName: "s3Settings",
              type: "structure",
              members: {
                AccessControl: {
                  locationName: "accessControl",
                  type: "structure",
                  members: {
                    CannedAcl: {
                      locationName: "cannedAcl"
                    }
                  }
                },
                Encryption: {
                  locationName: "encryption",
                  type: "structure",
                  members: {
                    EncryptionType: {
                      locationName: "encryptionType"
                    },
                    KmsEncryptionContext: {
                      locationName: "kmsEncryptionContext"
                    },
                    KmsKeyArn: {
                      locationName: "kmsKeyArn"
                    }
                  }
                },
                StorageClass: {
                  locationName: "storageClass"
                }
              }
            }
          }
        },
        S5k: {
          type: "list",
          member: {}
        },
        S5o: {
          type: "structure",
          members: {
            KeyFormat: {
              locationName: "keyFormat"
            },
            KeyFormatVersions: {
              locationName: "keyFormatVersions"
            },
            StaticKeyValue: {
              locationName: "staticKeyValue"
            },
            Url: {
              locationName: "url"
            }
          }
        },
        S6k: {
          type: "structure",
          members: {
            CertificateArn: {
              locationName: "certificateArn"
            },
            ResourceId: {
              locationName: "resourceId"
            },
            SystemIds: {
              locationName: "systemIds",
              type: "list",
              member: {}
            },
            Url: {
              locationName: "url"
            }
          }
        },
        S86: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AudioChannelTaggingSettings: {
                locationName: "audioChannelTaggingSettings",
                type: "structure",
                members: {
                  ChannelTag: {
                    locationName: "channelTag"
                  },
                  ChannelTags: {
                    locationName: "channelTags",
                    type: "list",
                    member: {}
                  }
                }
              },
              AudioNormalizationSettings: {
                locationName: "audioNormalizationSettings",
                type: "structure",
                members: {
                  Algorithm: {
                    locationName: "algorithm"
                  },
                  AlgorithmControl: {
                    locationName: "algorithmControl"
                  },
                  CorrectionGateLevel: {
                    locationName: "correctionGateLevel",
                    type: "integer"
                  },
                  LoudnessLogging: {
                    locationName: "loudnessLogging"
                  },
                  PeakCalculation: {
                    locationName: "peakCalculation"
                  },
                  TargetLkfs: {
                    locationName: "targetLkfs",
                    type: "double"
                  },
                  TruePeakLimiterThreshold: {
                    locationName: "truePeakLimiterThreshold",
                    type: "double"
                  }
                }
              },
              AudioSourceName: {
                locationName: "audioSourceName"
              },
              AudioType: {
                locationName: "audioType",
                type: "integer"
              },
              AudioTypeControl: {
                locationName: "audioTypeControl"
              },
              CodecSettings: {
                locationName: "codecSettings",
                type: "structure",
                members: {
                  AacSettings: {
                    locationName: "aacSettings",
                    type: "structure",
                    members: {
                      AudioDescriptionBroadcasterMix: {
                        locationName: "audioDescriptionBroadcasterMix"
                      },
                      Bitrate: {
                        locationName: "bitrate",
                        type: "integer"
                      },
                      CodecProfile: {
                        locationName: "codecProfile"
                      },
                      CodingMode: {
                        locationName: "codingMode"
                      },
                      RateControlMode: {
                        locationName: "rateControlMode"
                      },
                      RawFormat: {
                        locationName: "rawFormat"
                      },
                      SampleRate: {
                        locationName: "sampleRate",
                        type: "integer"
                      },
                      Specification: {
                        locationName: "specification"
                      },
                      VbrQuality: {
                        locationName: "vbrQuality"
                      }
                    }
                  },
                  Ac3Settings: {
                    locationName: "ac3Settings",
                    type: "structure",
                    members: {
                      Bitrate: {
                        locationName: "bitrate",
                        type: "integer"
                      },
                      BitstreamMode: {
                        locationName: "bitstreamMode"
                      },
                      CodingMode: {
                        locationName: "codingMode"
                      },
                      Dialnorm: {
                        locationName: "dialnorm",
                        type: "integer"
                      },
                      DynamicRangeCompressionLine: {
                        locationName: "dynamicRangeCompressionLine"
                      },
                      DynamicRangeCompressionProfile: {
                        locationName: "dynamicRangeCompressionProfile"
                      },
                      DynamicRangeCompressionRf: {
                        locationName: "dynamicRangeCompressionRf"
                      },
                      LfeFilter: {
                        locationName: "lfeFilter"
                      },
                      MetadataControl: {
                        locationName: "metadataControl"
                      },
                      SampleRate: {
                        locationName: "sampleRate",
                        type: "integer"
                      }
                    }
                  },
                  AiffSettings: {
                    locationName: "aiffSettings",
                    type: "structure",
                    members: {
                      BitDepth: {
                        locationName: "bitDepth",
                        type: "integer"
                      },
                      Channels: {
                        locationName: "channels",
                        type: "integer"
                      },
                      SampleRate: {
                        locationName: "sampleRate",
                        type: "integer"
                      }
                    }
                  },
                  Codec: {
                    locationName: "codec"
                  },
                  Eac3AtmosSettings: {
                    locationName: "eac3AtmosSettings",
                    type: "structure",
                    members: {
                      Bitrate: {
                        locationName: "bitrate",
                        type: "integer"
                      },
                      BitstreamMode: {
                        locationName: "bitstreamMode"
                      },
                      CodingMode: {
                        locationName: "codingMode"
                      },
                      DialogueIntelligence: {
                        locationName: "dialogueIntelligence"
                      },
                      DownmixControl: {
                        locationName: "downmixControl"
                      },
                      DynamicRangeCompressionLine: {
                        locationName: "dynamicRangeCompressionLine"
                      },
                      DynamicRangeCompressionRf: {
                        locationName: "dynamicRangeCompressionRf"
                      },
                      DynamicRangeControl: {
                        locationName: "dynamicRangeControl"
                      },
                      LoRoCenterMixLevel: {
                        locationName: "loRoCenterMixLevel",
                        type: "double"
                      },
                      LoRoSurroundMixLevel: {
                        locationName: "loRoSurroundMixLevel",
                        type: "double"
                      },
                      LtRtCenterMixLevel: {
                        locationName: "ltRtCenterMixLevel",
                        type: "double"
                      },
                      LtRtSurroundMixLevel: {
                        locationName: "ltRtSurroundMixLevel",
                        type: "double"
                      },
                      MeteringMode: {
                        locationName: "meteringMode"
                      },
                      SampleRate: {
                        locationName: "sampleRate",
                        type: "integer"
                      },
                      SpeechThreshold: {
                        locationName: "speechThreshold",
                        type: "integer"
                      },
                      StereoDownmix: {
                        locationName: "stereoDownmix"
                      },
                      SurroundExMode: {
                        locationName: "surroundExMode"
                      }
                    }
                  },
                  Eac3Settings: {
                    locationName: "eac3Settings",
                    type: "structure",
                    members: {
                      AttenuationControl: {
                        locationName: "attenuationControl"
                      },
                      Bitrate: {
                        locationName: "bitrate",
                        type: "integer"
                      },
                      BitstreamMode: {
                        locationName: "bitstreamMode"
                      },
                      CodingMode: {
                        locationName: "codingMode"
                      },
                      DcFilter: {
                        locationName: "dcFilter"
                      },
                      Dialnorm: {
                        locationName: "dialnorm",
                        type: "integer"
                      },
                      DynamicRangeCompressionLine: {
                        locationName: "dynamicRangeCompressionLine"
                      },
                      DynamicRangeCompressionRf: {
                        locationName: "dynamicRangeCompressionRf"
                      },
                      LfeControl: {
                        locationName: "lfeControl"
                      },
                      LfeFilter: {
                        locationName: "lfeFilter"
                      },
                      LoRoCenterMixLevel: {
                        locationName: "loRoCenterMixLevel",
                        type: "double"
                      },
                      LoRoSurroundMixLevel: {
                        locationName: "loRoSurroundMixLevel",
                        type: "double"
                      },
                      LtRtCenterMixLevel: {
                        locationName: "ltRtCenterMixLevel",
                        type: "double"
                      },
                      LtRtSurroundMixLevel: {
                        locationName: "ltRtSurroundMixLevel",
                        type: "double"
                      },
                      MetadataControl: {
                        locationName: "metadataControl"
                      },
                      PassthroughControl: {
                        locationName: "passthroughControl"
                      },
                      PhaseControl: {
                        locationName: "phaseControl"
                      },
                      SampleRate: {
                        locationName: "sampleRate",
                        type: "integer"
                      },
                      StereoDownmix: {
                        locationName: "stereoDownmix"
                      },
                      SurroundExMode: {
                        locationName: "surroundExMode"
                      },
                      SurroundMode: {
                        locationName: "surroundMode"
                      }
                    }
                  },
                  FlacSettings: {
                    locationName: "flacSettings",
                    type: "structure",
                    members: {
                      BitDepth: {
                        locationName: "bitDepth",
                        type: "integer"
                      },
                      Channels: {
                        locationName: "channels",
                        type: "integer"
                      },
                      SampleRate: {
                        locationName: "sampleRate",
                        type: "integer"
                      }
                    }
                  },
                  Mp2Settings: {
                    locationName: "mp2Settings",
                    type: "structure",
                    members: {
                      Bitrate: {
                        locationName: "bitrate",
                        type: "integer"
                      },
                      Channels: {
                        locationName: "channels",
                        type: "integer"
                      },
                      SampleRate: {
                        locationName: "sampleRate",
                        type: "integer"
                      }
                    }
                  },
                  Mp3Settings: {
                    locationName: "mp3Settings",
                    type: "structure",
                    members: {
                      Bitrate: {
                        locationName: "bitrate",
                        type: "integer"
                      },
                      Channels: {
                        locationName: "channels",
                        type: "integer"
                      },
                      RateControlMode: {
                        locationName: "rateControlMode"
                      },
                      SampleRate: {
                        locationName: "sampleRate",
                        type: "integer"
                      },
                      VbrQuality: {
                        locationName: "vbrQuality",
                        type: "integer"
                      }
                    }
                  },
                  OpusSettings: {
                    locationName: "opusSettings",
                    type: "structure",
                    members: {
                      Bitrate: {
                        locationName: "bitrate",
                        type: "integer"
                      },
                      Channels: {
                        locationName: "channels",
                        type: "integer"
                      },
                      SampleRate: {
                        locationName: "sampleRate",
                        type: "integer"
                      }
                    }
                  },
                  VorbisSettings: {
                    locationName: "vorbisSettings",
                    type: "structure",
                    members: {
                      Channels: {
                        locationName: "channels",
                        type: "integer"
                      },
                      SampleRate: {
                        locationName: "sampleRate",
                        type: "integer"
                      },
                      VbrQuality: {
                        locationName: "vbrQuality",
                        type: "integer"
                      }
                    }
                  },
                  WavSettings: {
                    locationName: "wavSettings",
                    type: "structure",
                    members: {
                      BitDepth: {
                        locationName: "bitDepth",
                        type: "integer"
                      },
                      Channels: {
                        locationName: "channels",
                        type: "integer"
                      },
                      Format: {
                        locationName: "format"
                      },
                      SampleRate: {
                        locationName: "sampleRate",
                        type: "integer"
                      }
                    }
                  }
                }
              },
              CustomLanguageCode: {
                locationName: "customLanguageCode"
              },
              LanguageCode: {
                locationName: "languageCode"
              },
              LanguageCodeControl: {
                locationName: "languageCodeControl"
              },
              RemixSettings: {
                shape: "S1j",
                locationName: "remixSettings"
              },
              StreamName: {
                locationName: "streamName"
              }
            }
          }
        },
        Sat: {
          type: "structure",
          members: {
            BurninDestinationSettings: {
              locationName: "burninDestinationSettings",
              type: "structure",
              members: {
                Alignment: {
                  locationName: "alignment"
                },
                ApplyFontColor: {
                  locationName: "applyFontColor"
                },
                BackgroundColor: {
                  locationName: "backgroundColor"
                },
                BackgroundOpacity: {
                  locationName: "backgroundOpacity",
                  type: "integer"
                },
                FallbackFont: {
                  locationName: "fallbackFont"
                },
                FontColor: {
                  locationName: "fontColor"
                },
                FontOpacity: {
                  locationName: "fontOpacity",
                  type: "integer"
                },
                FontResolution: {
                  locationName: "fontResolution",
                  type: "integer"
                },
                FontScript: {
                  locationName: "fontScript"
                },
                FontSize: {
                  locationName: "fontSize",
                  type: "integer"
                },
                HexFontColor: {
                  locationName: "hexFontColor"
                },
                OutlineColor: {
                  locationName: "outlineColor"
                },
                OutlineSize: {
                  locationName: "outlineSize",
                  type: "integer"
                },
                ShadowColor: {
                  locationName: "shadowColor"
                },
                ShadowOpacity: {
                  locationName: "shadowOpacity",
                  type: "integer"
                },
                ShadowXOffset: {
                  locationName: "shadowXOffset",
                  type: "integer"
                },
                ShadowYOffset: {
                  locationName: "shadowYOffset",
                  type: "integer"
                },
                StylePassthrough: {
                  locationName: "stylePassthrough"
                },
                TeletextSpacing: {
                  locationName: "teletextSpacing"
                },
                XPosition: {
                  locationName: "xPosition",
                  type: "integer"
                },
                YPosition: {
                  locationName: "yPosition",
                  type: "integer"
                }
              }
            },
            DestinationType: {
              locationName: "destinationType"
            },
            DvbSubDestinationSettings: {
              locationName: "dvbSubDestinationSettings",
              type: "structure",
              members: {
                Alignment: {
                  locationName: "alignment"
                },
                ApplyFontColor: {
                  locationName: "applyFontColor"
                },
                BackgroundColor: {
                  locationName: "backgroundColor"
                },
                BackgroundOpacity: {
                  locationName: "backgroundOpacity",
                  type: "integer"
                },
                DdsHandling: {
                  locationName: "ddsHandling"
                },
                DdsXCoordinate: {
                  locationName: "ddsXCoordinate",
                  type: "integer"
                },
                DdsYCoordinate: {
                  locationName: "ddsYCoordinate",
                  type: "integer"
                },
                FallbackFont: {
                  locationName: "fallbackFont"
                },
                FontColor: {
                  locationName: "fontColor"
                },
                FontOpacity: {
                  locationName: "fontOpacity",
                  type: "integer"
                },
                FontResolution: {
                  locationName: "fontResolution",
                  type: "integer"
                },
                FontScript: {
                  locationName: "fontScript"
                },
                FontSize: {
                  locationName: "fontSize",
                  type: "integer"
                },
                Height: {
                  locationName: "height",
                  type: "integer"
                },
                HexFontColor: {
                  locationName: "hexFontColor"
                },
                OutlineColor: {
                  locationName: "outlineColor"
                },
                OutlineSize: {
                  locationName: "outlineSize",
                  type: "integer"
                },
                ShadowColor: {
                  locationName: "shadowColor"
                },
                ShadowOpacity: {
                  locationName: "shadowOpacity",
                  type: "integer"
                },
                ShadowXOffset: {
                  locationName: "shadowXOffset",
                  type: "integer"
                },
                ShadowYOffset: {
                  locationName: "shadowYOffset",
                  type: "integer"
                },
                StylePassthrough: {
                  locationName: "stylePassthrough"
                },
                SubtitlingType: {
                  locationName: "subtitlingType"
                },
                TeletextSpacing: {
                  locationName: "teletextSpacing"
                },
                Width: {
                  locationName: "width",
                  type: "integer"
                },
                XPosition: {
                  locationName: "xPosition",
                  type: "integer"
                },
                YPosition: {
                  locationName: "yPosition",
                  type: "integer"
                }
              }
            },
            EmbeddedDestinationSettings: {
              locationName: "embeddedDestinationSettings",
              type: "structure",
              members: {
                Destination608ChannelNumber: {
                  locationName: "destination608ChannelNumber",
                  type: "integer"
                },
                Destination708ServiceNumber: {
                  locationName: "destination708ServiceNumber",
                  type: "integer"
                }
              }
            },
            ImscDestinationSettings: {
              locationName: "imscDestinationSettings",
              type: "structure",
              members: {
                Accessibility: {
                  locationName: "accessibility"
                },
                StylePassthrough: {
                  locationName: "stylePassthrough"
                }
              }
            },
            SccDestinationSettings: {
              locationName: "sccDestinationSettings",
              type: "structure",
              members: {
                Framerate: {
                  locationName: "framerate"
                }
              }
            },
            SrtDestinationSettings: {
              locationName: "srtDestinationSettings",
              type: "structure",
              members: {
                StylePassthrough: {
                  locationName: "stylePassthrough"
                }
              }
            },
            TeletextDestinationSettings: {
              locationName: "teletextDestinationSettings",
              type: "structure",
              members: {
                PageNumber: {
                  locationName: "pageNumber"
                },
                PageTypes: {
                  locationName: "pageTypes",
                  type: "list",
                  member: {}
                }
              }
            },
            TtmlDestinationSettings: {
              locationName: "ttmlDestinationSettings",
              type: "structure",
              members: {
                StylePassthrough: {
                  locationName: "stylePassthrough"
                }
              }
            },
            WebvttDestinationSettings: {
              locationName: "webvttDestinationSettings",
              type: "structure",
              members: {
                Accessibility: {
                  locationName: "accessibility"
                },
                StylePassthrough: {
                  locationName: "stylePassthrough"
                }
              }
            }
          }
        },
        Sc3: {
          type: "structure",
          members: {
            CmfcSettings: {
              locationName: "cmfcSettings",
              type: "structure",
              members: {
                AudioDuration: {
                  locationName: "audioDuration"
                },
                AudioGroupId: {
                  locationName: "audioGroupId"
                },
                AudioRenditionSets: {
                  locationName: "audioRenditionSets"
                },
                AudioTrackType: {
                  locationName: "audioTrackType"
                },
                DescriptiveVideoServiceFlag: {
                  locationName: "descriptiveVideoServiceFlag"
                },
                IFrameOnlyManifest: {
                  locationName: "iFrameOnlyManifest"
                },
                KlvMetadata: {
                  locationName: "klvMetadata"
                },
                ManifestMetadataSignaling: {
                  locationName: "manifestMetadataSignaling"
                },
                Scte35Esam: {
                  locationName: "scte35Esam"
                },
                Scte35Source: {
                  locationName: "scte35Source"
                },
                TimedMetadata: {
                  locationName: "timedMetadata"
                },
                TimedMetadataBoxVersion: {
                  locationName: "timedMetadataBoxVersion"
                },
                TimedMetadataSchemeIdUri: {
                  locationName: "timedMetadataSchemeIdUri"
                },
                TimedMetadataValue: {
                  locationName: "timedMetadataValue"
                }
              }
            },
            Container: {
              locationName: "container"
            },
            F4vSettings: {
              locationName: "f4vSettings",
              type: "structure",
              members: {
                MoovPlacement: {
                  locationName: "moovPlacement"
                }
              }
            },
            M2tsSettings: {
              locationName: "m2tsSettings",
              type: "structure",
              members: {
                AudioBufferModel: {
                  locationName: "audioBufferModel"
                },
                AudioDuration: {
                  locationName: "audioDuration"
                },
                AudioFramesPerPes: {
                  locationName: "audioFramesPerPes",
                  type: "integer"
                },
                AudioPids: {
                  shape: "Scm",
                  locationName: "audioPids"
                },
                Bitrate: {
                  locationName: "bitrate",
                  type: "integer"
                },
                BufferModel: {
                  locationName: "bufferModel"
                },
                DataPTSControl: {
                  locationName: "dataPTSControl"
                },
                DvbNitSettings: {
                  locationName: "dvbNitSettings",
                  type: "structure",
                  members: {
                    NetworkId: {
                      locationName: "networkId",
                      type: "integer"
                    },
                    NetworkName: {
                      locationName: "networkName"
                    },
                    NitInterval: {
                      locationName: "nitInterval",
                      type: "integer"
                    }
                  }
                },
                DvbSdtSettings: {
                  locationName: "dvbSdtSettings",
                  type: "structure",
                  members: {
                    OutputSdt: {
                      locationName: "outputSdt"
                    },
                    SdtInterval: {
                      locationName: "sdtInterval",
                      type: "integer"
                    },
                    ServiceName: {
                      locationName: "serviceName"
                    },
                    ServiceProviderName: {
                      locationName: "serviceProviderName"
                    }
                  }
                },
                DvbSubPids: {
                  shape: "Scm",
                  locationName: "dvbSubPids"
                },
                DvbTdtSettings: {
                  locationName: "dvbTdtSettings",
                  type: "structure",
                  members: {
                    TdtInterval: {
                      locationName: "tdtInterval",
                      type: "integer"
                    }
                  }
                },
                DvbTeletextPid: {
                  locationName: "dvbTeletextPid",
                  type: "integer"
                },
                EbpAudioInterval: {
                  locationName: "ebpAudioInterval"
                },
                EbpPlacement: {
                  locationName: "ebpPlacement"
                },
                EsRateInPes: {
                  locationName: "esRateInPes"
                },
                ForceTsVideoEbpOrder: {
                  locationName: "forceTsVideoEbpOrder"
                },
                FragmentTime: {
                  locationName: "fragmentTime",
                  type: "double"
                },
                KlvMetadata: {
                  locationName: "klvMetadata"
                },
                MaxPcrInterval: {
                  locationName: "maxPcrInterval",
                  type: "integer"
                },
                MinEbpInterval: {
                  locationName: "minEbpInterval",
                  type: "integer"
                },
                NielsenId3: {
                  locationName: "nielsenId3"
                },
                NullPacketBitrate: {
                  locationName: "nullPacketBitrate",
                  type: "double"
                },
                PatInterval: {
                  locationName: "patInterval",
                  type: "integer"
                },
                PcrControl: {
                  locationName: "pcrControl"
                },
                PcrPid: {
                  locationName: "pcrPid",
                  type: "integer"
                },
                PmtInterval: {
                  locationName: "pmtInterval",
                  type: "integer"
                },
                PmtPid: {
                  locationName: "pmtPid",
                  type: "integer"
                },
                PrivateMetadataPid: {
                  locationName: "privateMetadataPid",
                  type: "integer"
                },
                ProgramNumber: {
                  locationName: "programNumber",
                  type: "integer"
                },
                PtsOffset: {
                  locationName: "ptsOffset",
                  type: "integer"
                },
                PtsOffsetMode: {
                  locationName: "ptsOffsetMode"
                },
                RateMode: {
                  locationName: "rateMode"
                },
                Scte35Esam: {
                  locationName: "scte35Esam",
                  type: "structure",
                  members: {
                    Scte35EsamPid: {
                      locationName: "scte35EsamPid",
                      type: "integer"
                    }
                  }
                },
                Scte35Pid: {
                  locationName: "scte35Pid",
                  type: "integer"
                },
                Scte35Source: {
                  locationName: "scte35Source"
                },
                SegmentationMarkers: {
                  locationName: "segmentationMarkers"
                },
                SegmentationStyle: {
                  locationName: "segmentationStyle"
                },
                SegmentationTime: {
                  locationName: "segmentationTime",
                  type: "double"
                },
                TimedMetadataPid: {
                  locationName: "timedMetadataPid",
                  type: "integer"
                },
                TransportStreamId: {
                  locationName: "transportStreamId",
                  type: "integer"
                },
                VideoPid: {
                  locationName: "videoPid",
                  type: "integer"
                }
              }
            },
            M3u8Settings: {
              locationName: "m3u8Settings",
              type: "structure",
              members: {
                AudioDuration: {
                  locationName: "audioDuration"
                },
                AudioFramesPerPes: {
                  locationName: "audioFramesPerPes",
                  type: "integer"
                },
                AudioPids: {
                  shape: "Scm",
                  locationName: "audioPids"
                },
                DataPTSControl: {
                  locationName: "dataPTSControl"
                },
                MaxPcrInterval: {
                  locationName: "maxPcrInterval",
                  type: "integer"
                },
                NielsenId3: {
                  locationName: "nielsenId3"
                },
                PatInterval: {
                  locationName: "patInterval",
                  type: "integer"
                },
                PcrControl: {
                  locationName: "pcrControl"
                },
                PcrPid: {
                  locationName: "pcrPid",
                  type: "integer"
                },
                PmtInterval: {
                  locationName: "pmtInterval",
                  type: "integer"
                },
                PmtPid: {
                  locationName: "pmtPid",
                  type: "integer"
                },
                PrivateMetadataPid: {
                  locationName: "privateMetadataPid",
                  type: "integer"
                },
                ProgramNumber: {
                  locationName: "programNumber",
                  type: "integer"
                },
                PtsOffset: {
                  locationName: "ptsOffset",
                  type: "integer"
                },
                PtsOffsetMode: {
                  locationName: "ptsOffsetMode"
                },
                Scte35Pid: {
                  locationName: "scte35Pid",
                  type: "integer"
                },
                Scte35Source: {
                  locationName: "scte35Source"
                },
                TimedMetadata: {
                  locationName: "timedMetadata"
                },
                TimedMetadataPid: {
                  locationName: "timedMetadataPid",
                  type: "integer"
                },
                TransportStreamId: {
                  locationName: "transportStreamId",
                  type: "integer"
                },
                VideoPid: {
                  locationName: "videoPid",
                  type: "integer"
                }
              }
            },
            MovSettings: {
              locationName: "movSettings",
              type: "structure",
              members: {
                ClapAtom: {
                  locationName: "clapAtom"
                },
                CslgAtom: {
                  locationName: "cslgAtom"
                },
                Mpeg2FourCCControl: {
                  locationName: "mpeg2FourCCControl"
                },
                PaddingControl: {
                  locationName: "paddingControl"
                },
                Reference: {
                  locationName: "reference"
                }
              }
            },
            Mp4Settings: {
              locationName: "mp4Settings",
              type: "structure",
              members: {
                AudioDuration: {
                  locationName: "audioDuration"
                },
                CslgAtom: {
                  locationName: "cslgAtom"
                },
                CttsVersion: {
                  locationName: "cttsVersion",
                  type: "integer"
                },
                FreeSpaceBox: {
                  locationName: "freeSpaceBox"
                },
                MoovPlacement: {
                  locationName: "moovPlacement"
                },
                Mp4MajorBrand: {
                  locationName: "mp4MajorBrand"
                }
              }
            },
            MpdSettings: {
              locationName: "mpdSettings",
              type: "structure",
              members: {
                AccessibilityCaptionHints: {
                  locationName: "accessibilityCaptionHints"
                },
                AudioDuration: {
                  locationName: "audioDuration"
                },
                CaptionContainerType: {
                  locationName: "captionContainerType"
                },
                KlvMetadata: {
                  locationName: "klvMetadata"
                },
                ManifestMetadataSignaling: {
                  locationName: "manifestMetadataSignaling"
                },
                Scte35Esam: {
                  locationName: "scte35Esam"
                },
                Scte35Source: {
                  locationName: "scte35Source"
                },
                TimedMetadata: {
                  locationName: "timedMetadata"
                },
                TimedMetadataBoxVersion: {
                  locationName: "timedMetadataBoxVersion"
                },
                TimedMetadataSchemeIdUri: {
                  locationName: "timedMetadataSchemeIdUri"
                },
                TimedMetadataValue: {
                  locationName: "timedMetadataValue"
                }
              }
            },
            MxfSettings: {
              locationName: "mxfSettings",
              type: "structure",
              members: {
                AfdSignaling: {
                  locationName: "afdSignaling"
                },
                Profile: {
                  locationName: "profile"
                },
                XavcProfileSettings: {
                  locationName: "xavcProfileSettings",
                  type: "structure",
                  members: {
                    DurationMode: {
                      locationName: "durationMode"
                    },
                    MaxAncDataSize: {
                      locationName: "maxAncDataSize",
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        Scm: {
          type: "list",
          member: {
            type: "integer"
          }
        },
        Sei: {
          type: "structure",
          members: {
            AfdSignaling: {
              locationName: "afdSignaling"
            },
            AntiAlias: {
              locationName: "antiAlias"
            },
            CodecSettings: {
              locationName: "codecSettings",
              type: "structure",
              members: {
                Av1Settings: {
                  locationName: "av1Settings",
                  type: "structure",
                  members: {
                    AdaptiveQuantization: {
                      locationName: "adaptiveQuantization"
                    },
                    BitDepth: {
                      locationName: "bitDepth"
                    },
                    FilmGrainSynthesis: {
                      locationName: "filmGrainSynthesis"
                    },
                    FramerateControl: {
                      locationName: "framerateControl"
                    },
                    FramerateConversionAlgorithm: {
                      locationName: "framerateConversionAlgorithm"
                    },
                    FramerateDenominator: {
                      locationName: "framerateDenominator",
                      type: "integer"
                    },
                    FramerateNumerator: {
                      locationName: "framerateNumerator",
                      type: "integer"
                    },
                    GopSize: {
                      locationName: "gopSize",
                      type: "double"
                    },
                    MaxBitrate: {
                      locationName: "maxBitrate",
                      type: "integer"
                    },
                    NumberBFramesBetweenReferenceFrames: {
                      locationName: "numberBFramesBetweenReferenceFrames",
                      type: "integer"
                    },
                    QvbrSettings: {
                      locationName: "qvbrSettings",
                      type: "structure",
                      members: {
                        QvbrQualityLevel: {
                          locationName: "qvbrQualityLevel",
                          type: "integer"
                        },
                        QvbrQualityLevelFineTune: {
                          locationName: "qvbrQualityLevelFineTune",
                          type: "double"
                        }
                      }
                    },
                    RateControlMode: {
                      locationName: "rateControlMode"
                    },
                    Slices: {
                      locationName: "slices",
                      type: "integer"
                    },
                    SpatialAdaptiveQuantization: {
                      locationName: "spatialAdaptiveQuantization"
                    }
                  }
                },
                AvcIntraSettings: {
                  locationName: "avcIntraSettings",
                  type: "structure",
                  members: {
                    AvcIntraClass: {
                      locationName: "avcIntraClass"
                    },
                    AvcIntraUhdSettings: {
                      locationName: "avcIntraUhdSettings",
                      type: "structure",
                      members: {
                        QualityTuningLevel: {
                          locationName: "qualityTuningLevel"
                        }
                      }
                    },
                    FramerateControl: {
                      locationName: "framerateControl"
                    },
                    FramerateConversionAlgorithm: {
                      locationName: "framerateConversionAlgorithm"
                    },
                    FramerateDenominator: {
                      locationName: "framerateDenominator",
                      type: "integer"
                    },
                    FramerateNumerator: {
                      locationName: "framerateNumerator",
                      type: "integer"
                    },
                    InterlaceMode: {
                      locationName: "interlaceMode"
                    },
                    ScanTypeConversionMode: {
                      locationName: "scanTypeConversionMode"
                    },
                    SlowPal: {
                      locationName: "slowPal"
                    },
                    Telecine: {
                      locationName: "telecine"
                    }
                  }
                },
                Codec: {
                  locationName: "codec"
                },
                FrameCaptureSettings: {
                  locationName: "frameCaptureSettings",
                  type: "structure",
                  members: {
                    FramerateDenominator: {
                      locationName: "framerateDenominator",
                      type: "integer"
                    },
                    FramerateNumerator: {
                      locationName: "framerateNumerator",
                      type: "integer"
                    },
                    MaxCaptures: {
                      locationName: "maxCaptures",
                      type: "integer"
                    },
                    Quality: {
                      locationName: "quality",
                      type: "integer"
                    }
                  }
                },
                H264Settings: {
                  locationName: "h264Settings",
                  type: "structure",
                  members: {
                    AdaptiveQuantization: {
                      locationName: "adaptiveQuantization"
                    },
                    BandwidthReductionFilter: {
                      shape: "Sfh",
                      locationName: "bandwidthReductionFilter"
                    },
                    Bitrate: {
                      locationName: "bitrate",
                      type: "integer"
                    },
                    CodecLevel: {
                      locationName: "codecLevel"
                    },
                    CodecProfile: {
                      locationName: "codecProfile"
                    },
                    DynamicSubGop: {
                      locationName: "dynamicSubGop"
                    },
                    EndOfStreamMarkers: {
                      locationName: "endOfStreamMarkers"
                    },
                    EntropyEncoding: {
                      locationName: "entropyEncoding"
                    },
                    FieldEncoding: {
                      locationName: "fieldEncoding"
                    },
                    FlickerAdaptiveQuantization: {
                      locationName: "flickerAdaptiveQuantization"
                    },
                    FramerateControl: {
                      locationName: "framerateControl"
                    },
                    FramerateConversionAlgorithm: {
                      locationName: "framerateConversionAlgorithm"
                    },
                    FramerateDenominator: {
                      locationName: "framerateDenominator",
                      type: "integer"
                    },
                    FramerateNumerator: {
                      locationName: "framerateNumerator",
                      type: "integer"
                    },
                    GopBReference: {
                      locationName: "gopBReference"
                    },
                    GopClosedCadence: {
                      locationName: "gopClosedCadence",
                      type: "integer"
                    },
                    GopSize: {
                      locationName: "gopSize",
                      type: "double"
                    },
                    GopSizeUnits: {
                      locationName: "gopSizeUnits"
                    },
                    HrdBufferFinalFillPercentage: {
                      locationName: "hrdBufferFinalFillPercentage",
                      type: "integer"
                    },
                    HrdBufferInitialFillPercentage: {
                      locationName: "hrdBufferInitialFillPercentage",
                      type: "integer"
                    },
                    HrdBufferSize: {
                      locationName: "hrdBufferSize",
                      type: "integer"
                    },
                    InterlaceMode: {
                      locationName: "interlaceMode"
                    },
                    MaxBitrate: {
                      locationName: "maxBitrate",
                      type: "integer"
                    },
                    MinIInterval: {
                      locationName: "minIInterval",
                      type: "integer"
                    },
                    NumberBFramesBetweenReferenceFrames: {
                      locationName: "numberBFramesBetweenReferenceFrames",
                      type: "integer"
                    },
                    NumberReferenceFrames: {
                      locationName: "numberReferenceFrames",
                      type: "integer"
                    },
                    ParControl: {
                      locationName: "parControl"
                    },
                    ParDenominator: {
                      locationName: "parDenominator",
                      type: "integer"
                    },
                    ParNumerator: {
                      locationName: "parNumerator",
                      type: "integer"
                    },
                    QualityTuningLevel: {
                      locationName: "qualityTuningLevel"
                    },
                    QvbrSettings: {
                      locationName: "qvbrSettings",
                      type: "structure",
                      members: {
                        MaxAverageBitrate: {
                          locationName: "maxAverageBitrate",
                          type: "integer"
                        },
                        QvbrQualityLevel: {
                          locationName: "qvbrQualityLevel",
                          type: "integer"
                        },
                        QvbrQualityLevelFineTune: {
                          locationName: "qvbrQualityLevelFineTune",
                          type: "double"
                        }
                      }
                    },
                    RateControlMode: {
                      locationName: "rateControlMode"
                    },
                    RepeatPps: {
                      locationName: "repeatPps"
                    },
                    ScanTypeConversionMode: {
                      locationName: "scanTypeConversionMode"
                    },
                    SceneChangeDetect: {
                      locationName: "sceneChangeDetect"
                    },
                    Slices: {
                      locationName: "slices",
                      type: "integer"
                    },
                    SlowPal: {
                      locationName: "slowPal"
                    },
                    Softness: {
                      locationName: "softness",
                      type: "integer"
                    },
                    SpatialAdaptiveQuantization: {
                      locationName: "spatialAdaptiveQuantization"
                    },
                    Syntax: {
                      locationName: "syntax"
                    },
                    Telecine: {
                      locationName: "telecine"
                    },
                    TemporalAdaptiveQuantization: {
                      locationName: "temporalAdaptiveQuantization"
                    },
                    UnregisteredSeiTimecode: {
                      locationName: "unregisteredSeiTimecode"
                    }
                  }
                },
                H265Settings: {
                  locationName: "h265Settings",
                  type: "structure",
                  members: {
                    AdaptiveQuantization: {
                      locationName: "adaptiveQuantization"
                    },
                    AlternateTransferFunctionSei: {
                      locationName: "alternateTransferFunctionSei"
                    },
                    BandwidthReductionFilter: {
                      shape: "Sfh",
                      locationName: "bandwidthReductionFilter"
                    },
                    Bitrate: {
                      locationName: "bitrate",
                      type: "integer"
                    },
                    CodecLevel: {
                      locationName: "codecLevel"
                    },
                    CodecProfile: {
                      locationName: "codecProfile"
                    },
                    DynamicSubGop: {
                      locationName: "dynamicSubGop"
                    },
                    EndOfStreamMarkers: {
                      locationName: "endOfStreamMarkers"
                    },
                    FlickerAdaptiveQuantization: {
                      locationName: "flickerAdaptiveQuantization"
                    },
                    FramerateControl: {
                      locationName: "framerateControl"
                    },
                    FramerateConversionAlgorithm: {
                      locationName: "framerateConversionAlgorithm"
                    },
                    FramerateDenominator: {
                      locationName: "framerateDenominator",
                      type: "integer"
                    },
                    FramerateNumerator: {
                      locationName: "framerateNumerator",
                      type: "integer"
                    },
                    GopBReference: {
                      locationName: "gopBReference"
                    },
                    GopClosedCadence: {
                      locationName: "gopClosedCadence",
                      type: "integer"
                    },
                    GopSize: {
                      locationName: "gopSize",
                      type: "double"
                    },
                    GopSizeUnits: {
                      locationName: "gopSizeUnits"
                    },
                    HrdBufferFinalFillPercentage: {
                      locationName: "hrdBufferFinalFillPercentage",
                      type: "integer"
                    },
                    HrdBufferInitialFillPercentage: {
                      locationName: "hrdBufferInitialFillPercentage",
                      type: "integer"
                    },
                    HrdBufferSize: {
                      locationName: "hrdBufferSize",
                      type: "integer"
                    },
                    InterlaceMode: {
                      locationName: "interlaceMode"
                    },
                    MaxBitrate: {
                      locationName: "maxBitrate",
                      type: "integer"
                    },
                    MinIInterval: {
                      locationName: "minIInterval",
                      type: "integer"
                    },
                    NumberBFramesBetweenReferenceFrames: {
                      locationName: "numberBFramesBetweenReferenceFrames",
                      type: "integer"
                    },
                    NumberReferenceFrames: {
                      locationName: "numberReferenceFrames",
                      type: "integer"
                    },
                    ParControl: {
                      locationName: "parControl"
                    },
                    ParDenominator: {
                      locationName: "parDenominator",
                      type: "integer"
                    },
                    ParNumerator: {
                      locationName: "parNumerator",
                      type: "integer"
                    },
                    QualityTuningLevel: {
                      locationName: "qualityTuningLevel"
                    },
                    QvbrSettings: {
                      locationName: "qvbrSettings",
                      type: "structure",
                      members: {
                        MaxAverageBitrate: {
                          locationName: "maxAverageBitrate",
                          type: "integer"
                        },
                        QvbrQualityLevel: {
                          locationName: "qvbrQualityLevel",
                          type: "integer"
                        },
                        QvbrQualityLevelFineTune: {
                          locationName: "qvbrQualityLevelFineTune",
                          type: "double"
                        }
                      }
                    },
                    RateControlMode: {
                      locationName: "rateControlMode"
                    },
                    SampleAdaptiveOffsetFilterMode: {
                      locationName: "sampleAdaptiveOffsetFilterMode"
                    },
                    ScanTypeConversionMode: {
                      locationName: "scanTypeConversionMode"
                    },
                    SceneChangeDetect: {
                      locationName: "sceneChangeDetect"
                    },
                    Slices: {
                      locationName: "slices",
                      type: "integer"
                    },
                    SlowPal: {
                      locationName: "slowPal"
                    },
                    SpatialAdaptiveQuantization: {
                      locationName: "spatialAdaptiveQuantization"
                    },
                    Telecine: {
                      locationName: "telecine"
                    },
                    TemporalAdaptiveQuantization: {
                      locationName: "temporalAdaptiveQuantization"
                    },
                    TemporalIds: {
                      locationName: "temporalIds"
                    },
                    Tiles: {
                      locationName: "tiles"
                    },
                    UnregisteredSeiTimecode: {
                      locationName: "unregisteredSeiTimecode"
                    },
                    WriteMp4PackagingType: {
                      locationName: "writeMp4PackagingType"
                    }
                  }
                },
                Mpeg2Settings: {
                  locationName: "mpeg2Settings",
                  type: "structure",
                  members: {
                    AdaptiveQuantization: {
                      locationName: "adaptiveQuantization"
                    },
                    Bitrate: {
                      locationName: "bitrate",
                      type: "integer"
                    },
                    CodecLevel: {
                      locationName: "codecLevel"
                    },
                    CodecProfile: {
                      locationName: "codecProfile"
                    },
                    DynamicSubGop: {
                      locationName: "dynamicSubGop"
                    },
                    FramerateControl: {
                      locationName: "framerateControl"
                    },
                    FramerateConversionAlgorithm: {
                      locationName: "framerateConversionAlgorithm"
                    },
                    FramerateDenominator: {
                      locationName: "framerateDenominator",
                      type: "integer"
                    },
                    FramerateNumerator: {
                      locationName: "framerateNumerator",
                      type: "integer"
                    },
                    GopClosedCadence: {
                      locationName: "gopClosedCadence",
                      type: "integer"
                    },
                    GopSize: {
                      locationName: "gopSize",
                      type: "double"
                    },
                    GopSizeUnits: {
                      locationName: "gopSizeUnits"
                    },
                    HrdBufferFinalFillPercentage: {
                      locationName: "hrdBufferFinalFillPercentage",
                      type: "integer"
                    },
                    HrdBufferInitialFillPercentage: {
                      locationName: "hrdBufferInitialFillPercentage",
                      type: "integer"
                    },
                    HrdBufferSize: {
                      locationName: "hrdBufferSize",
                      type: "integer"
                    },
                    InterlaceMode: {
                      locationName: "interlaceMode"
                    },
                    IntraDcPrecision: {
                      locationName: "intraDcPrecision"
                    },
                    MaxBitrate: {
                      locationName: "maxBitrate",
                      type: "integer"
                    },
                    MinIInterval: {
                      locationName: "minIInterval",
                      type: "integer"
                    },
                    NumberBFramesBetweenReferenceFrames: {
                      locationName: "numberBFramesBetweenReferenceFrames",
                      type: "integer"
                    },
                    ParControl: {
                      locationName: "parControl"
                    },
                    ParDenominator: {
                      locationName: "parDenominator",
                      type: "integer"
                    },
                    ParNumerator: {
                      locationName: "parNumerator",
                      type: "integer"
                    },
                    QualityTuningLevel: {
                      locationName: "qualityTuningLevel"
                    },
                    RateControlMode: {
                      locationName: "rateControlMode"
                    },
                    ScanTypeConversionMode: {
                      locationName: "scanTypeConversionMode"
                    },
                    SceneChangeDetect: {
                      locationName: "sceneChangeDetect"
                    },
                    SlowPal: {
                      locationName: "slowPal"
                    },
                    Softness: {
                      locationName: "softness",
                      type: "integer"
                    },
                    SpatialAdaptiveQuantization: {
                      locationName: "spatialAdaptiveQuantization"
                    },
                    Syntax: {
                      locationName: "syntax"
                    },
                    Telecine: {
                      locationName: "telecine"
                    },
                    TemporalAdaptiveQuantization: {
                      locationName: "temporalAdaptiveQuantization"
                    }
                  }
                },
                ProresSettings: {
                  locationName: "proresSettings",
                  type: "structure",
                  members: {
                    ChromaSampling: {
                      locationName: "chromaSampling"
                    },
                    CodecProfile: {
                      locationName: "codecProfile"
                    },
                    FramerateControl: {
                      locationName: "framerateControl"
                    },
                    FramerateConversionAlgorithm: {
                      locationName: "framerateConversionAlgorithm"
                    },
                    FramerateDenominator: {
                      locationName: "framerateDenominator",
                      type: "integer"
                    },
                    FramerateNumerator: {
                      locationName: "framerateNumerator",
                      type: "integer"
                    },
                    InterlaceMode: {
                      locationName: "interlaceMode"
                    },
                    ParControl: {
                      locationName: "parControl"
                    },
                    ParDenominator: {
                      locationName: "parDenominator",
                      type: "integer"
                    },
                    ParNumerator: {
                      locationName: "parNumerator",
                      type: "integer"
                    },
                    ScanTypeConversionMode: {
                      locationName: "scanTypeConversionMode"
                    },
                    SlowPal: {
                      locationName: "slowPal"
                    },
                    Telecine: {
                      locationName: "telecine"
                    }
                  }
                },
                UncompressedSettings: {
                  locationName: "uncompressedSettings",
                  type: "structure",
                  members: {
                    Fourcc: {
                      locationName: "fourcc"
                    },
                    FramerateControl: {
                      locationName: "framerateControl"
                    },
                    FramerateConversionAlgorithm: {
                      locationName: "framerateConversionAlgorithm"
                    },
                    FramerateDenominator: {
                      locationName: "framerateDenominator",
                      type: "integer"
                    },
                    FramerateNumerator: {
                      locationName: "framerateNumerator",
                      type: "integer"
                    },
                    InterlaceMode: {
                      locationName: "interlaceMode"
                    },
                    ScanTypeConversionMode: {
                      locationName: "scanTypeConversionMode"
                    },
                    SlowPal: {
                      locationName: "slowPal"
                    },
                    Telecine: {
                      locationName: "telecine"
                    }
                  }
                },
                Vc3Settings: {
                  locationName: "vc3Settings",
                  type: "structure",
                  members: {
                    FramerateControl: {
                      locationName: "framerateControl"
                    },
                    FramerateConversionAlgorithm: {
                      locationName: "framerateConversionAlgorithm"
                    },
                    FramerateDenominator: {
                      locationName: "framerateDenominator",
                      type: "integer"
                    },
                    FramerateNumerator: {
                      locationName: "framerateNumerator",
                      type: "integer"
                    },
                    InterlaceMode: {
                      locationName: "interlaceMode"
                    },
                    ScanTypeConversionMode: {
                      locationName: "scanTypeConversionMode"
                    },
                    SlowPal: {
                      locationName: "slowPal"
                    },
                    Telecine: {
                      locationName: "telecine"
                    },
                    Vc3Class: {
                      locationName: "vc3Class"
                    }
                  }
                },
                Vp8Settings: {
                  locationName: "vp8Settings",
                  type: "structure",
                  members: {
                    Bitrate: {
                      locationName: "bitrate",
                      type: "integer"
                    },
                    FramerateControl: {
                      locationName: "framerateControl"
                    },
                    FramerateConversionAlgorithm: {
                      locationName: "framerateConversionAlgorithm"
                    },
                    FramerateDenominator: {
                      locationName: "framerateDenominator",
                      type: "integer"
                    },
                    FramerateNumerator: {
                      locationName: "framerateNumerator",
                      type: "integer"
                    },
                    GopSize: {
                      locationName: "gopSize",
                      type: "double"
                    },
                    HrdBufferSize: {
                      locationName: "hrdBufferSize",
                      type: "integer"
                    },
                    MaxBitrate: {
                      locationName: "maxBitrate",
                      type: "integer"
                    },
                    ParControl: {
                      locationName: "parControl"
                    },
                    ParDenominator: {
                      locationName: "parDenominator",
                      type: "integer"
                    },
                    ParNumerator: {
                      locationName: "parNumerator",
                      type: "integer"
                    },
                    QualityTuningLevel: {
                      locationName: "qualityTuningLevel"
                    },
                    RateControlMode: {
                      locationName: "rateControlMode"
                    }
                  }
                },
                Vp9Settings: {
                  locationName: "vp9Settings",
                  type: "structure",
                  members: {
                    Bitrate: {
                      locationName: "bitrate",
                      type: "integer"
                    },
                    FramerateControl: {
                      locationName: "framerateControl"
                    },
                    FramerateConversionAlgorithm: {
                      locationName: "framerateConversionAlgorithm"
                    },
                    FramerateDenominator: {
                      locationName: "framerateDenominator",
                      type: "integer"
                    },
                    FramerateNumerator: {
                      locationName: "framerateNumerator",
                      type: "integer"
                    },
                    GopSize: {
                      locationName: "gopSize",
                      type: "double"
                    },
                    HrdBufferSize: {
                      locationName: "hrdBufferSize",
                      type: "integer"
                    },
                    MaxBitrate: {
                      locationName: "maxBitrate",
                      type: "integer"
                    },
                    ParControl: {
                      locationName: "parControl"
                    },
                    ParDenominator: {
                      locationName: "parDenominator",
                      type: "integer"
                    },
                    ParNumerator: {
                      locationName: "parNumerator",
                      type: "integer"
                    },
                    QualityTuningLevel: {
                      locationName: "qualityTuningLevel"
                    },
                    RateControlMode: {
                      locationName: "rateControlMode"
                    }
                  }
                },
                XavcSettings: {
                  locationName: "xavcSettings",
                  type: "structure",
                  members: {
                    AdaptiveQuantization: {
                      locationName: "adaptiveQuantization"
                    },
                    EntropyEncoding: {
                      locationName: "entropyEncoding"
                    },
                    FramerateControl: {
                      locationName: "framerateControl"
                    },
                    FramerateConversionAlgorithm: {
                      locationName: "framerateConversionAlgorithm"
                    },
                    FramerateDenominator: {
                      locationName: "framerateDenominator",
                      type: "integer"
                    },
                    FramerateNumerator: {
                      locationName: "framerateNumerator",
                      type: "integer"
                    },
                    Profile: {
                      locationName: "profile"
                    },
                    SlowPal: {
                      locationName: "slowPal"
                    },
                    Softness: {
                      locationName: "softness",
                      type: "integer"
                    },
                    SpatialAdaptiveQuantization: {
                      locationName: "spatialAdaptiveQuantization"
                    },
                    TemporalAdaptiveQuantization: {
                      locationName: "temporalAdaptiveQuantization"
                    },
                    Xavc4kIntraCbgProfileSettings: {
                      locationName: "xavc4kIntraCbgProfileSettings",
                      type: "structure",
                      members: {
                        XavcClass: {
                          locationName: "xavcClass"
                        }
                      }
                    },
                    Xavc4kIntraVbrProfileSettings: {
                      locationName: "xavc4kIntraVbrProfileSettings",
                      type: "structure",
                      members: {
                        XavcClass: {
                          locationName: "xavcClass"
                        }
                      }
                    },
                    Xavc4kProfileSettings: {
                      locationName: "xavc4kProfileSettings",
                      type: "structure",
                      members: {
                        BitrateClass: {
                          locationName: "bitrateClass"
                        },
                        CodecProfile: {
                          locationName: "codecProfile"
                        },
                        FlickerAdaptiveQuantization: {
                          locationName: "flickerAdaptiveQuantization"
                        },
                        GopBReference: {
                          locationName: "gopBReference"
                        },
                        GopClosedCadence: {
                          locationName: "gopClosedCadence",
                          type: "integer"
                        },
                        HrdBufferSize: {
                          locationName: "hrdBufferSize",
                          type: "integer"
                        },
                        QualityTuningLevel: {
                          locationName: "qualityTuningLevel"
                        },
                        Slices: {
                          locationName: "slices",
                          type: "integer"
                        }
                      }
                    },
                    XavcHdIntraCbgProfileSettings: {
                      locationName: "xavcHdIntraCbgProfileSettings",
                      type: "structure",
                      members: {
                        XavcClass: {
                          locationName: "xavcClass"
                        }
                      }
                    },
                    XavcHdProfileSettings: {
                      locationName: "xavcHdProfileSettings",
                      type: "structure",
                      members: {
                        BitrateClass: {
                          locationName: "bitrateClass"
                        },
                        FlickerAdaptiveQuantization: {
                          locationName: "flickerAdaptiveQuantization"
                        },
                        GopBReference: {
                          locationName: "gopBReference"
                        },
                        GopClosedCadence: {
                          locationName: "gopClosedCadence",
                          type: "integer"
                        },
                        HrdBufferSize: {
                          locationName: "hrdBufferSize",
                          type: "integer"
                        },
                        InterlaceMode: {
                          locationName: "interlaceMode"
                        },
                        QualityTuningLevel: {
                          locationName: "qualityTuningLevel"
                        },
                        Slices: {
                          locationName: "slices",
                          type: "integer"
                        },
                        Telecine: {
                          locationName: "telecine"
                        }
                      }
                    }
                  }
                }
              }
            },
            ColorMetadata: {
              locationName: "colorMetadata"
            },
            Crop: {
              shape: "S2i",
              locationName: "crop"
            },
            DropFrameTimecode: {
              locationName: "dropFrameTimecode"
            },
            FixedAfd: {
              locationName: "fixedAfd",
              type: "integer"
            },
            Height: {
              locationName: "height",
              type: "integer"
            },
            Position: {
              shape: "S2i",
              locationName: "position"
            },
            RespondToAfd: {
              locationName: "respondToAfd"
            },
            ScalingBehavior: {
              locationName: "scalingBehavior"
            },
            Sharpness: {
              locationName: "sharpness",
              type: "integer"
            },
            TimecodeInsertion: {
              locationName: "timecodeInsertion"
            },
            VideoPreprocessors: {
              locationName: "videoPreprocessors",
              type: "structure",
              members: {
                ColorCorrector: {
                  locationName: "colorCorrector",
                  type: "structure",
                  members: {
                    Brightness: {
                      locationName: "brightness",
                      type: "integer"
                    },
                    ClipLimits: {
                      locationName: "clipLimits",
                      type: "structure",
                      members: {
                        MaximumRGBTolerance: {
                          locationName: "maximumRGBTolerance",
                          type: "integer"
                        },
                        MaximumYUV: {
                          locationName: "maximumYUV",
                          type: "integer"
                        },
                        MinimumRGBTolerance: {
                          locationName: "minimumRGBTolerance",
                          type: "integer"
                        },
                        MinimumYUV: {
                          locationName: "minimumYUV",
                          type: "integer"
                        }
                      }
                    },
                    ColorSpaceConversion: {
                      locationName: "colorSpaceConversion"
                    },
                    Contrast: {
                      locationName: "contrast",
                      type: "integer"
                    },
                    Hdr10Metadata: {
                      shape: "S3m",
                      locationName: "hdr10Metadata"
                    },
                    HdrToSdrToneMapper: {
                      locationName: "hdrToSdrToneMapper"
                    },
                    Hue: {
                      locationName: "hue",
                      type: "integer"
                    },
                    MaxLuminance: {
                      locationName: "maxLuminance",
                      type: "integer"
                    },
                    SampleRangeConversion: {
                      locationName: "sampleRangeConversion"
                    },
                    Saturation: {
                      locationName: "saturation",
                      type: "integer"
                    },
                    SdrReferenceWhiteLevel: {
                      locationName: "sdrReferenceWhiteLevel",
                      type: "integer"
                    }
                  }
                },
                Deinterlacer: {
                  locationName: "deinterlacer",
                  type: "structure",
                  members: {
                    Algorithm: {
                      locationName: "algorithm"
                    },
                    Control: {
                      locationName: "control"
                    },
                    Mode: {
                      locationName: "mode"
                    }
                  }
                },
                DolbyVision: {
                  locationName: "dolbyVision",
                  type: "structure",
                  members: {
                    L6Metadata: {
                      locationName: "l6Metadata",
                      type: "structure",
                      members: {
                        MaxCll: {
                          locationName: "maxCll",
                          type: "integer"
                        },
                        MaxFall: {
                          locationName: "maxFall",
                          type: "integer"
                        }
                      }
                    },
                    L6Mode: {
                      locationName: "l6Mode"
                    },
                    Mapping: {
                      locationName: "mapping"
                    },
                    Profile: {
                      locationName: "profile"
                    }
                  }
                },
                Hdr10Plus: {
                  locationName: "hdr10Plus",
                  type: "structure",
                  members: {
                    MasteringMonitorNits: {
                      locationName: "masteringMonitorNits",
                      type: "integer"
                    },
                    TargetMonitorNits: {
                      locationName: "targetMonitorNits",
                      type: "integer"
                    }
                  }
                },
                ImageInserter: {
                  shape: "S2u",
                  locationName: "imageInserter"
                },
                NoiseReducer: {
                  locationName: "noiseReducer",
                  type: "structure",
                  members: {
                    Filter: {
                      locationName: "filter"
                    },
                    FilterSettings: {
                      locationName: "filterSettings",
                      type: "structure",
                      members: {
                        Strength: {
                          locationName: "strength",
                          type: "integer"
                        }
                      }
                    },
                    SpatialFilterSettings: {
                      locationName: "spatialFilterSettings",
                      type: "structure",
                      members: {
                        PostFilterSharpenStrength: {
                          locationName: "postFilterSharpenStrength",
                          type: "integer"
                        },
                        Speed: {
                          locationName: "speed",
                          type: "integer"
                        },
                        Strength: {
                          locationName: "strength",
                          type: "integer"
                        }
                      }
                    },
                    TemporalFilterSettings: {
                      locationName: "temporalFilterSettings",
                      type: "structure",
                      members: {
                        AggressiveMode: {
                          locationName: "aggressiveMode",
                          type: "integer"
                        },
                        PostTemporalSharpening: {
                          locationName: "postTemporalSharpening"
                        },
                        PostTemporalSharpeningStrength: {
                          locationName: "postTemporalSharpeningStrength"
                        },
                        Speed: {
                          locationName: "speed",
                          type: "integer"
                        },
                        Strength: {
                          locationName: "strength",
                          type: "integer"
                        }
                      }
                    }
                  }
                },
                PartnerWatermarking: {
                  locationName: "partnerWatermarking",
                  type: "structure",
                  members: {
                    NexguardFileMarkerSettings: {
                      locationName: "nexguardFileMarkerSettings",
                      type: "structure",
                      members: {
                        License: {
                          locationName: "license"
                        },
                        Payload: {
                          locationName: "payload",
                          type: "integer"
                        },
                        Preset: {
                          locationName: "preset"
                        },
                        Strength: {
                          locationName: "strength"
                        }
                      }
                    }
                  }
                },
                TimecodeBurnin: {
                  locationName: "timecodeBurnin",
                  type: "structure",
                  members: {
                    FontSize: {
                      locationName: "fontSize",
                      type: "integer"
                    },
                    Position: {
                      locationName: "position"
                    },
                    Prefix: {
                      locationName: "prefix"
                    }
                  }
                }
              }
            },
            Width: {
              locationName: "width",
              type: "integer"
            }
          }
        },
        Sfh: {
          type: "structure",
          members: {
            Sharpening: {
              locationName: "sharpening"
            },
            Strength: {
              locationName: "strength"
            }
          }
        },
        Sl0: {
          type: "structure",
          members: {
            Anchor: {
              locationName: "anchor"
            },
            Source: {
              locationName: "source"
            },
            Start: {
              locationName: "start"
            },
            TimestampOffset: {
              locationName: "timestampOffset"
            }
          }
        },
        Sl3: {
          type: "structure",
          members: {
            Id3Insertions: {
              locationName: "id3Insertions",
              type: "list",
              member: {
                type: "structure",
                members: {
                  Id3: {
                    locationName: "id3"
                  },
                  Timecode: {
                    locationName: "timecode"
                  }
                }
              }
            }
          }
        },
        Sl8: {
          type: "map",
          key: {},
          value: {}
        },
        Sla: {
          type: "structure",
          members: {
            AccelerationSettings: {
              shape: "S7",
              locationName: "accelerationSettings"
            },
            AccelerationStatus: {
              locationName: "accelerationStatus"
            },
            Arn: {
              locationName: "arn"
            },
            BillingTagsSource: {
              locationName: "billingTagsSource"
            },
            ClientRequestToken: {
              locationName: "clientRequestToken"
            },
            CreatedAt: {
              shape: "Slc",
              locationName: "createdAt"
            },
            CurrentPhase: {
              locationName: "currentPhase"
            },
            ErrorCode: {
              locationName: "errorCode",
              type: "integer"
            },
            ErrorMessage: {
              locationName: "errorMessage"
            },
            HopDestinations: {
              shape: "Sa",
              locationName: "hopDestinations"
            },
            Id: {
              locationName: "id"
            },
            JobPercentComplete: {
              locationName: "jobPercentComplete",
              type: "integer"
            },
            JobTemplate: {
              locationName: "jobTemplate"
            },
            Messages: {
              locationName: "messages",
              type: "structure",
              members: {
                Info: {
                  shape: "Slf",
                  locationName: "info"
                },
                Warning: {
                  shape: "Slf",
                  locationName: "warning"
                }
              }
            },
            OutputGroupDetails: {
              locationName: "outputGroupDetails",
              type: "list",
              member: {
                type: "structure",
                members: {
                  OutputDetails: {
                    locationName: "outputDetails",
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        DurationInMs: {
                          locationName: "durationInMs",
                          type: "integer"
                        },
                        VideoDetails: {
                          locationName: "videoDetails",
                          type: "structure",
                          members: {
                            HeightInPx: {
                              locationName: "heightInPx",
                              type: "integer"
                            },
                            WidthInPx: {
                              locationName: "widthInPx",
                              type: "integer"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            Priority: {
              locationName: "priority",
              type: "integer"
            },
            Queue: {
              locationName: "queue"
            },
            QueueTransitions: {
              locationName: "queueTransitions",
              type: "list",
              member: {
                type: "structure",
                members: {
                  DestinationQueue: {
                    locationName: "destinationQueue"
                  },
                  SourceQueue: {
                    locationName: "sourceQueue"
                  },
                  Timestamp: {
                    shape: "Slc",
                    locationName: "timestamp"
                  }
                }
              }
            },
            RetryCount: {
              locationName: "retryCount",
              type: "integer"
            },
            Role: {
              locationName: "role"
            },
            Settings: {
              shape: "Se",
              locationName: "settings"
            },
            SimulateReservedQueue: {
              locationName: "simulateReservedQueue"
            },
            Status: {
              locationName: "status"
            },
            StatusUpdateInterval: {
              locationName: "statusUpdateInterval"
            },
            Timing: {
              locationName: "timing",
              type: "structure",
              members: {
                FinishTime: {
                  shape: "Slc",
                  locationName: "finishTime"
                },
                StartTime: {
                  shape: "Slc",
                  locationName: "startTime"
                },
                SubmitTime: {
                  shape: "Slc",
                  locationName: "submitTime"
                }
              }
            },
            UserMetadata: {
              shape: "Sl8",
              locationName: "userMetadata"
            },
            Warnings: {
              locationName: "warnings",
              type: "list",
              member: {
                type: "structure",
                members: {
                  Code: {
                    locationName: "code",
                    type: "integer"
                  },
                  Count: {
                    locationName: "count",
                    type: "integer"
                  }
                },
                required: [
                  "Count",
                  "Code"
                ]
              }
            }
          },
          required: [
            "Settings",
            "Role"
          ]
        },
        Slc: {
          type: "timestamp",
          timestampFormat: "unixTimestamp"
        },
        Slf: {
          type: "list",
          member: {}
        },
        Sls: {
          type: "structure",
          members: {
            AdAvailOffset: {
              locationName: "adAvailOffset",
              type: "integer"
            },
            AvailBlanking: {
              shape: "Sg",
              locationName: "availBlanking"
            },
            ColorConversion3DLUTSettings: {
              shape: "Si",
              locationName: "colorConversion3DLUTSettings"
            },
            Esam: {
              shape: "Sn",
              locationName: "esam"
            },
            ExtendedDataServices: {
              shape: "St",
              locationName: "extendedDataServices"
            },
            FollowSource: {
              locationName: "followSource",
              type: "integer"
            },
            Inputs: {
              locationName: "inputs",
              type: "list",
              member: {
                type: "structure",
                members: {
                  AdvancedInputFilter: {
                    locationName: "advancedInputFilter"
                  },
                  AdvancedInputFilterSettings: {
                    shape: "S10",
                    locationName: "advancedInputFilterSettings"
                  },
                  AudioSelectorGroups: {
                    shape: "S13",
                    locationName: "audioSelectorGroups"
                  },
                  AudioSelectors: {
                    shape: "S17",
                    locationName: "audioSelectors"
                  },
                  CaptionSelectors: {
                    shape: "S1t",
                    locationName: "captionSelectors"
                  },
                  Crop: {
                    shape: "S2i",
                    locationName: "crop"
                  },
                  DeblockFilter: {
                    locationName: "deblockFilter"
                  },
                  DenoiseFilter: {
                    locationName: "denoiseFilter"
                  },
                  DolbyVisionMetadataXml: {
                    locationName: "dolbyVisionMetadataXml"
                  },
                  FilterEnable: {
                    locationName: "filterEnable"
                  },
                  FilterStrength: {
                    locationName: "filterStrength",
                    type: "integer"
                  },
                  ImageInserter: {
                    shape: "S2u",
                    locationName: "imageInserter"
                  },
                  InputClippings: {
                    shape: "S32",
                    locationName: "inputClippings"
                  },
                  InputScanType: {
                    locationName: "inputScanType"
                  },
                  Position: {
                    shape: "S2i",
                    locationName: "position"
                  },
                  ProgramNumber: {
                    locationName: "programNumber",
                    type: "integer"
                  },
                  PsiControl: {
                    locationName: "psiControl"
                  },
                  TimecodeSource: {
                    locationName: "timecodeSource"
                  },
                  TimecodeStart: {
                    locationName: "timecodeStart"
                  },
                  VideoOverlays: {
                    shape: "S3d",
                    locationName: "videoOverlays"
                  },
                  VideoSelector: {
                    shape: "S3i",
                    locationName: "videoSelector"
                  }
                }
              }
            },
            KantarWatermark: {
              shape: "S3s",
              locationName: "kantarWatermark"
            },
            MotionImageInserter: {
              shape: "S40",
              locationName: "motionImageInserter"
            },
            NielsenConfiguration: {
              shape: "S48",
              locationName: "nielsenConfiguration"
            },
            NielsenNonLinearWatermark: {
              shape: "S4a",
              locationName: "nielsenNonLinearWatermark"
            },
            OutputGroups: {
              shape: "S4h",
              locationName: "outputGroups"
            },
            TimecodeConfig: {
              shape: "Sl0",
              locationName: "timecodeConfig"
            },
            TimedMetadataInsertion: {
              shape: "Sl3",
              locationName: "timedMetadataInsertion"
            }
          }
        },
        Slw: {
          type: "structure",
          members: {
            AccelerationSettings: {
              shape: "S7",
              locationName: "accelerationSettings"
            },
            Arn: {
              locationName: "arn"
            },
            Category: {
              locationName: "category"
            },
            CreatedAt: {
              shape: "Slc",
              locationName: "createdAt"
            },
            Description: {
              locationName: "description"
            },
            HopDestinations: {
              shape: "Sa",
              locationName: "hopDestinations"
            },
            LastUpdated: {
              shape: "Slc",
              locationName: "lastUpdated"
            },
            Name: {
              locationName: "name"
            },
            Priority: {
              locationName: "priority",
              type: "integer"
            },
            Queue: {
              locationName: "queue"
            },
            Settings: {
              shape: "Sls",
              locationName: "settings"
            },
            StatusUpdateInterval: {
              locationName: "statusUpdateInterval"
            },
            Type: {
              locationName: "type"
            }
          },
          required: [
            "Settings",
            "Name"
          ]
        },
        Slz: {
          type: "structure",
          members: {
            AudioDescriptions: {
              shape: "S86",
              locationName: "audioDescriptions"
            },
            CaptionDescriptions: {
              locationName: "captionDescriptions",
              type: "list",
              member: {
                type: "structure",
                members: {
                  CustomLanguageCode: {
                    locationName: "customLanguageCode"
                  },
                  DestinationSettings: {
                    shape: "Sat",
                    locationName: "destinationSettings"
                  },
                  LanguageCode: {
                    locationName: "languageCode"
                  },
                  LanguageDescription: {
                    locationName: "languageDescription"
                  }
                }
              }
            },
            ContainerSettings: {
              shape: "Sc3",
              locationName: "containerSettings"
            },
            VideoDescription: {
              shape: "Sei",
              locationName: "videoDescription"
            }
          }
        },
        Sm3: {
          type: "structure",
          members: {
            Arn: {
              locationName: "arn"
            },
            Category: {
              locationName: "category"
            },
            CreatedAt: {
              shape: "Slc",
              locationName: "createdAt"
            },
            Description: {
              locationName: "description"
            },
            LastUpdated: {
              shape: "Slc",
              locationName: "lastUpdated"
            },
            Name: {
              locationName: "name"
            },
            Settings: {
              shape: "Slz",
              locationName: "settings"
            },
            Type: {
              locationName: "type"
            }
          },
          required: [
            "Settings",
            "Name"
          ]
        },
        Sm6: {
          type: "structure",
          members: {
            Commitment: {
              locationName: "commitment"
            },
            RenewalType: {
              locationName: "renewalType"
            },
            ReservedSlots: {
              locationName: "reservedSlots",
              type: "integer"
            }
          },
          required: [
            "Commitment",
            "ReservedSlots",
            "RenewalType"
          ]
        },
        Smb: {
          type: "structure",
          members: {
            Arn: {
              locationName: "arn"
            },
            CreatedAt: {
              shape: "Slc",
              locationName: "createdAt"
            },
            Description: {
              locationName: "description"
            },
            LastUpdated: {
              shape: "Slc",
              locationName: "lastUpdated"
            },
            Name: {
              locationName: "name"
            },
            PricingPlan: {
              locationName: "pricingPlan"
            },
            ProgressingJobsCount: {
              locationName: "progressingJobsCount",
              type: "integer"
            },
            ReservationPlan: {
              locationName: "reservationPlan",
              type: "structure",
              members: {
                Commitment: {
                  locationName: "commitment"
                },
                ExpiresAt: {
                  shape: "Slc",
                  locationName: "expiresAt"
                },
                PurchasedAt: {
                  shape: "Slc",
                  locationName: "purchasedAt"
                },
                RenewalType: {
                  locationName: "renewalType"
                },
                ReservedSlots: {
                  locationName: "reservedSlots",
                  type: "integer"
                },
                Status: {
                  locationName: "status"
                }
              }
            },
            Status: {
              locationName: "status"
            },
            SubmittedJobsCount: {
              locationName: "submittedJobsCount",
              type: "integer"
            },
            Type: {
              locationName: "type"
            }
          },
          required: [
            "Name"
          ]
        },
        Smz: {
          type: "structure",
          members: {
            HttpInputs: {
              locationName: "httpInputs"
            },
            HttpsInputs: {
              locationName: "httpsInputs"
            },
            S3Inputs: {
              locationName: "s3Inputs"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/mediaconvert-2017-08-29.paginators.json
var require_mediaconvert_2017_08_29_paginators = __commonJS({
  "node_modules/aws-sdk/apis/mediaconvert-2017-08-29.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeEndpoints: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Endpoints"
        },
        ListJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Jobs"
        },
        ListPresets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Presets"
        },
        ListJobTemplates: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "JobTemplates"
        },
        ListQueues: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Queues"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/mediaconvert.js
var require_mediaconvert = __commonJS({
  "node_modules/aws-sdk/clients/mediaconvert.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["mediaconvert"] = {};
    AWS2.MediaConvert = Service.defineService("mediaconvert", ["2017-08-29"]);
    Object.defineProperty(apiLoader.services["mediaconvert"], "2017-08-29", {
      get: function get() {
        var model = require_mediaconvert_2017_08_29_min();
        model.paginators = require_mediaconvert_2017_08_29_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.MediaConvert;
  }
});

// node_modules/aws-sdk/apis/medialive-2017-10-14.min.json
var require_medialive_2017_10_14_min = __commonJS({
  "node_modules/aws-sdk/apis/medialive-2017-10-14.min.json"(exports2, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2017-10-14",
        endpointPrefix: "medialive",
        signingName: "medialive",
        serviceFullName: "AWS Elemental MediaLive",
        serviceId: "MediaLive",
        protocol: "rest-json",
        uid: "medialive-2017-10-14",
        signatureVersion: "v4",
        serviceAbbreviation: "MediaLive",
        jsonVersion: "1.1"
      },
      operations: {
        AcceptInputDeviceTransfer: {
          http: {
            requestUri: "/prod/inputDevices/{inputDeviceId}/accept",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              InputDeviceId: {
                location: "uri",
                locationName: "inputDeviceId"
              }
            },
            required: [
              "InputDeviceId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        BatchDelete: {
          http: {
            requestUri: "/prod/batch/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ChannelIds: {
                shape: "S5",
                locationName: "channelIds"
              },
              InputIds: {
                shape: "S5",
                locationName: "inputIds"
              },
              InputSecurityGroupIds: {
                shape: "S5",
                locationName: "inputSecurityGroupIds"
              },
              MultiplexIds: {
                shape: "S5",
                locationName: "multiplexIds"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Failed: {
                shape: "S7",
                locationName: "failed"
              },
              Successful: {
                shape: "S9",
                locationName: "successful"
              }
            }
          }
        },
        BatchStart: {
          http: {
            requestUri: "/prod/batch/start",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ChannelIds: {
                shape: "S5",
                locationName: "channelIds"
              },
              MultiplexIds: {
                shape: "S5",
                locationName: "multiplexIds"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Failed: {
                shape: "S7",
                locationName: "failed"
              },
              Successful: {
                shape: "S9",
                locationName: "successful"
              }
            }
          }
        },
        BatchStop: {
          http: {
            requestUri: "/prod/batch/stop",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ChannelIds: {
                shape: "S5",
                locationName: "channelIds"
              },
              MultiplexIds: {
                shape: "S5",
                locationName: "multiplexIds"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Failed: {
                shape: "S7",
                locationName: "failed"
              },
              Successful: {
                shape: "S9",
                locationName: "successful"
              }
            }
          }
        },
        BatchUpdateSchedule: {
          http: {
            method: "PUT",
            requestUri: "/prod/channels/{channelId}/schedule",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ChannelId: {
                location: "uri",
                locationName: "channelId"
              },
              Creates: {
                locationName: "creates",
                type: "structure",
                members: {
                  ScheduleActions: {
                    shape: "Sh",
                    locationName: "scheduleActions"
                  }
                },
                required: [
                  "ScheduleActions"
                ]
              },
              Deletes: {
                locationName: "deletes",
                type: "structure",
                members: {
                  ActionNames: {
                    shape: "S5",
                    locationName: "actionNames"
                  }
                },
                required: [
                  "ActionNames"
                ]
              }
            },
            required: [
              "ChannelId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Creates: {
                locationName: "creates",
                type: "structure",
                members: {
                  ScheduleActions: {
                    shape: "Sh",
                    locationName: "scheduleActions"
                  }
                },
                required: [
                  "ScheduleActions"
                ]
              },
              Deletes: {
                locationName: "deletes",
                type: "structure",
                members: {
                  ScheduleActions: {
                    shape: "Sh",
                    locationName: "scheduleActions"
                  }
                },
                required: [
                  "ScheduleActions"
                ]
              }
            }
          }
        },
        CancelInputDeviceTransfer: {
          http: {
            requestUri: "/prod/inputDevices/{inputDeviceId}/cancel",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              InputDeviceId: {
                location: "uri",
                locationName: "inputDeviceId"
              }
            },
            required: [
              "InputDeviceId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ClaimDevice: {
          http: {
            requestUri: "/prod/claimDevice",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Id: {
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateChannel: {
          http: {
            requestUri: "/prod/channels",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              CdiInputSpecification: {
                shape: "S27",
                locationName: "cdiInputSpecification"
              },
              ChannelClass: {
                locationName: "channelClass"
              },
              Destinations: {
                shape: "S2a",
                locationName: "destinations"
              },
              EncoderSettings: {
                shape: "S2i",
                locationName: "encoderSettings"
              },
              InputAttachments: {
                shape: "Sdf",
                locationName: "inputAttachments"
              },
              InputSpecification: {
                shape: "Sf4",
                locationName: "inputSpecification"
              },
              LogLevel: {
                locationName: "logLevel"
              },
              Maintenance: {
                locationName: "maintenance",
                type: "structure",
                members: {
                  MaintenanceDay: {
                    locationName: "maintenanceDay"
                  },
                  MaintenanceStartTime: {
                    locationName: "maintenanceStartTime"
                  }
                }
              },
              Name: {
                locationName: "name"
              },
              RequestId: {
                locationName: "requestId",
                idempotencyToken: true
              },
              Reserved: {
                locationName: "reserved",
                deprecated: true
              },
              RoleArn: {
                locationName: "roleArn"
              },
              Tags: {
                shape: "Sfc",
                locationName: "tags"
              },
              Vpc: {
                locationName: "vpc",
                type: "structure",
                members: {
                  PublicAddressAllocationIds: {
                    shape: "S5",
                    locationName: "publicAddressAllocationIds"
                  },
                  SecurityGroupIds: {
                    shape: "S5",
                    locationName: "securityGroupIds"
                  },
                  SubnetIds: {
                    shape: "S5",
                    locationName: "subnetIds"
                  }
                },
                required: [
                  "SubnetIds"
                ]
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Channel: {
                shape: "Sff",
                locationName: "channel"
              }
            }
          }
        },
        CreateInput: {
          http: {
            requestUri: "/prod/inputs",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              Destinations: {
                shape: "Sfo",
                locationName: "destinations"
              },
              InputDevices: {
                shape: "Sfq",
                locationName: "inputDevices"
              },
              InputSecurityGroups: {
                shape: "S5",
                locationName: "inputSecurityGroups"
              },
              MediaConnectFlows: {
                shape: "Sfs",
                locationName: "mediaConnectFlows"
              },
              Name: {
                locationName: "name"
              },
              RequestId: {
                locationName: "requestId",
                idempotencyToken: true
              },
              RoleArn: {
                locationName: "roleArn"
              },
              Sources: {
                shape: "Sfu",
                locationName: "sources"
              },
              Tags: {
                shape: "Sfc",
                locationName: "tags"
              },
              Type: {
                locationName: "type"
              },
              Vpc: {
                locationName: "vpc",
                type: "structure",
                members: {
                  SecurityGroupIds: {
                    shape: "S5",
                    locationName: "securityGroupIds"
                  },
                  SubnetIds: {
                    shape: "S5",
                    locationName: "subnetIds"
                  }
                },
                required: [
                  "SubnetIds"
                ]
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Input: {
                shape: "Sfz",
                locationName: "input"
              }
            }
          }
        },
        CreateInputSecurityGroup: {
          http: {
            requestUri: "/prod/inputSecurityGroups",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sfc",
                locationName: "tags"
              },
              WhitelistRules: {
                shape: "Sgb",
                locationName: "whitelistRules"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SecurityGroup: {
                shape: "Sge",
                locationName: "securityGroup"
              }
            }
          }
        },
        CreateMultiplex: {
          http: {
            requestUri: "/prod/multiplexes",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              AvailabilityZones: {
                shape: "S5",
                locationName: "availabilityZones"
              },
              MultiplexSettings: {
                shape: "Sgj",
                locationName: "multiplexSettings"
              },
              Name: {
                locationName: "name"
              },
              RequestId: {
                locationName: "requestId",
                idempotencyToken: true
              },
              Tags: {
                shape: "Sfc",
                locationName: "tags"
              }
            },
            required: [
              "RequestId",
              "MultiplexSettings",
              "AvailabilityZones",
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              Multiplex: {
                shape: "Sgo",
                locationName: "multiplex"
              }
            }
          }
        },
        CreateMultiplexProgram: {
          http: {
            requestUri: "/prod/multiplexes/{multiplexId}/programs",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              MultiplexId: {
                location: "uri",
                locationName: "multiplexId"
              },
              MultiplexProgramSettings: {
                shape: "Sgu",
                locationName: "multiplexProgramSettings"
              },
              ProgramName: {
                locationName: "programName"
              },
              RequestId: {
                locationName: "requestId",
                idempotencyToken: true
              }
            },
            required: [
              "MultiplexId",
              "RequestId",
              "MultiplexProgramSettings",
              "ProgramName"
            ]
          },
          output: {
            type: "structure",
            members: {
              MultiplexProgram: {
                shape: "Sh2",
                locationName: "multiplexProgram"
              }
            }
          }
        },
        CreatePartnerInput: {
          http: {
            requestUri: "/prod/inputs/{inputId}/partners",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              InputId: {
                location: "uri",
                locationName: "inputId"
              },
              RequestId: {
                locationName: "requestId",
                idempotencyToken: true
              },
              Tags: {
                shape: "Sfc",
                locationName: "tags"
              }
            },
            required: [
              "InputId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Input: {
                shape: "Sfz",
                locationName: "input"
              }
            }
          }
        },
        CreateTags: {
          http: {
            requestUri: "/prod/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              Tags: {
                shape: "Sfc",
                locationName: "tags"
              }
            },
            required: [
              "ResourceArn"
            ]
          }
        },
        DeleteChannel: {
          http: {
            method: "DELETE",
            requestUri: "/prod/channels/{channelId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ChannelId: {
                location: "uri",
                locationName: "channelId"
              }
            },
            required: [
              "ChannelId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              CdiInputSpecification: {
                shape: "S27",
                locationName: "cdiInputSpecification"
              },
              ChannelClass: {
                locationName: "channelClass"
              },
              Destinations: {
                shape: "S2a",
                locationName: "destinations"
              },
              EgressEndpoints: {
                shape: "Sfg",
                locationName: "egressEndpoints"
              },
              EncoderSettings: {
                shape: "S2i",
                locationName: "encoderSettings"
              },
              Id: {
                locationName: "id"
              },
              InputAttachments: {
                shape: "Sdf",
                locationName: "inputAttachments"
              },
              InputSpecification: {
                shape: "Sf4",
                locationName: "inputSpecification"
              },
              LogLevel: {
                locationName: "logLevel"
              },
              Maintenance: {
                shape: "Sfi",
                locationName: "maintenance"
              },
              Name: {
                locationName: "name"
              },
              PipelineDetails: {
                shape: "Sfj",
                locationName: "pipelineDetails"
              },
              PipelinesRunningCount: {
                locationName: "pipelinesRunningCount",
                type: "integer"
              },
              RoleArn: {
                locationName: "roleArn"
              },
              State: {
                locationName: "state"
              },
              Tags: {
                shape: "Sfc",
                locationName: "tags"
              },
              Vpc: {
                shape: "Sfm",
                locationName: "vpc"
              }
            }
          }
        },
        DeleteInput: {
          http: {
            method: "DELETE",
            requestUri: "/prod/inputs/{inputId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              InputId: {
                location: "uri",
                locationName: "inputId"
              }
            },
            required: [
              "InputId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteInputSecurityGroup: {
          http: {
            method: "DELETE",
            requestUri: "/prod/inputSecurityGroups/{inputSecurityGroupId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              InputSecurityGroupId: {
                location: "uri",
                locationName: "inputSecurityGroupId"
              }
            },
            required: [
              "InputSecurityGroupId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteMultiplex: {
          http: {
            method: "DELETE",
            requestUri: "/prod/multiplexes/{multiplexId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              MultiplexId: {
                location: "uri",
                locationName: "multiplexId"
              }
            },
            required: [
              "MultiplexId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              AvailabilityZones: {
                shape: "S5",
                locationName: "availabilityZones"
              },
              Destinations: {
                shape: "Sgp",
                locationName: "destinations"
              },
              Id: {
                locationName: "id"
              },
              MultiplexSettings: {
                shape: "Sgj",
                locationName: "multiplexSettings"
              },
              Name: {
                locationName: "name"
              },
              PipelinesRunningCount: {
                locationName: "pipelinesRunningCount",
                type: "integer"
              },
              ProgramCount: {
                locationName: "programCount",
                type: "integer"
              },
              State: {
                locationName: "state"
              },
              Tags: {
                shape: "Sfc",
                locationName: "tags"
              }
            }
          }
        },
        DeleteMultiplexProgram: {
          http: {
            method: "DELETE",
            requestUri: "/prod/multiplexes/{multiplexId}/programs/{programName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MultiplexId: {
                location: "uri",
                locationName: "multiplexId"
              },
              ProgramName: {
                location: "uri",
                locationName: "programName"
              }
            },
            required: [
              "MultiplexId",
              "ProgramName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ChannelId: {
                locationName: "channelId"
              },
              MultiplexProgramSettings: {
                shape: "Sgu",
                locationName: "multiplexProgramSettings"
              },
              PacketIdentifiersMap: {
                shape: "Sh3",
                locationName: "packetIdentifiersMap"
              },
              PipelineDetails: {
                shape: "Sh5",
                locationName: "pipelineDetails"
              },
              ProgramName: {
                locationName: "programName"
              }
            }
          }
        },
        DeleteReservation: {
          http: {
            method: "DELETE",
            requestUri: "/prod/reservations/{reservationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ReservationId: {
                location: "uri",
                locationName: "reservationId"
              }
            },
            required: [
              "ReservationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              Count: {
                locationName: "count",
                type: "integer"
              },
              CurrencyCode: {
                locationName: "currencyCode"
              },
              Duration: {
                locationName: "duration",
                type: "integer"
              },
              DurationUnits: {
                locationName: "durationUnits"
              },
              End: {
                locationName: "end"
              },
              FixedPrice: {
                locationName: "fixedPrice",
                type: "double"
              },
              Name: {
                locationName: "name"
              },
              OfferingDescription: {
                locationName: "offeringDescription"
              },
              OfferingId: {
                locationName: "offeringId"
              },
              OfferingType: {
                locationName: "offeringType"
              },
              Region: {
                locationName: "region"
              },
              RenewalSettings: {
                shape: "Sho",
                locationName: "renewalSettings"
              },
              ReservationId: {
                locationName: "reservationId"
              },
              ResourceSpecification: {
                shape: "Shq",
                locationName: "resourceSpecification"
              },
              Start: {
                locationName: "start"
              },
              State: {
                locationName: "state"
              },
              Tags: {
                shape: "Sfc",
                locationName: "tags"
              },
              UsagePrice: {
                locationName: "usagePrice",
                type: "double"
              }
            }
          }
        },
        DeleteSchedule: {
          http: {
            method: "DELETE",
            requestUri: "/prod/channels/{channelId}/schedule",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ChannelId: {
                location: "uri",
                locationName: "channelId"
              }
            },
            required: [
              "ChannelId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteTags: {
          http: {
            method: "DELETE",
            requestUri: "/prod/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              TagKeys: {
                shape: "S5",
                location: "querystring",
                locationName: "tagKeys"
              }
            },
            required: [
              "TagKeys",
              "ResourceArn"
            ]
          }
        },
        DescribeAccountConfiguration: {
          http: {
            method: "GET",
            requestUri: "/prod/accountConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              AccountConfiguration: {
                shape: "Si4",
                locationName: "accountConfiguration"
              }
            }
          }
        },
        DescribeChannel: {
          http: {
            method: "GET",
            requestUri: "/prod/channels/{channelId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ChannelId: {
                location: "uri",
                locationName: "channelId"
              }
            },
            required: [
              "ChannelId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              CdiInputSpecification: {
                shape: "S27",
                locationName: "cdiInputSpecification"
              },
              ChannelClass: {
                locationName: "channelClass"
              },
              Destinations: {
                shape: "S2a",
                locationName: "destinations"
              },
              EgressEndpoints: {
                shape: "Sfg",
                locationName: "egressEndpoints"
              },
              EncoderSettings: {
                shape: "S2i",
                locationName: "encoderSettings"
              },
              Id: {
                locationName: "id"
              },
              InputAttachments: {
                shape: "Sdf",
                locationName: "inputAttachments"
              },
              InputSpecification: {
                shape: "Sf4",
                locationName: "inputSpecification"
              },
              LogLevel: {
                locationName: "logLevel"
              },
              Maintenance: {
                shape: "Sfi",
                locationName: "maintenance"
              },
              Name: {
                locationName: "name"
              },
              PipelineDetails: {
                shape: "Sfj",
                locationName: "pipelineDetails"
              },
              PipelinesRunningCount: {
                locationName: "pipelinesRunningCount",
                type: "integer"
              },
              RoleArn: {
                locationName: "roleArn"
              },
              State: {
                locationName: "state"
              },
              Tags: {
                shape: "Sfc",
                locationName: "tags"
              },
              Vpc: {
                shape: "Sfm",
                locationName: "vpc"
              }
            }
          }
        },
        DescribeInput: {
          http: {
            method: "GET",
            requestUri: "/prod/inputs/{inputId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              InputId: {
                location: "uri",
                locationName: "inputId"
              }
            },
            required: [
              "InputId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              AttachedChannels: {
                shape: "S5",
                locationName: "attachedChannels"
              },
              Destinations: {
                shape: "Sg0",
                locationName: "destinations"
              },
              Id: {
                locationName: "id"
              },
              InputClass: {
                locationName: "inputClass"
              },
              InputDevices: {
                shape: "Sfq",
                locationName: "inputDevices"
              },
              InputPartnerIds: {
                shape: "S5",
                locationName: "inputPartnerIds"
              },
              InputSourceType: {
                locationName: "inputSourceType"
              },
              MediaConnectFlows: {
                shape: "Sg5",
                locationName: "mediaConnectFlows"
              },
              Name: {
                locationName: "name"
              },
              RoleArn: {
                locationName: "roleArn"
              },
              SecurityGroups: {
                shape: "S5",
                locationName: "securityGroups"
              },
              Sources: {
                shape: "Sg7",
                locationName: "sources"
              },
              State: {
                locationName: "state"
              },
              Tags: {
                shape: "Sfc",
                locationName: "tags"
              },
              Type: {
                locationName: "type"
              }
            }
          }
        },
        DescribeInputDevice: {
          http: {
            method: "GET",
            requestUri: "/prod/inputDevices/{inputDeviceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              InputDeviceId: {
                location: "uri",
                locationName: "inputDeviceId"
              }
            },
            required: [
              "InputDeviceId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              ConnectionState: {
                locationName: "connectionState"
              },
              DeviceSettingsSyncState: {
                locationName: "deviceSettingsSyncState"
              },
              DeviceUpdateStatus: {
                locationName: "deviceUpdateStatus"
              },
              HdDeviceSettings: {
                shape: "Sie",
                locationName: "hdDeviceSettings"
              },
              Id: {
                locationName: "id"
              },
              MacAddress: {
                locationName: "macAddress"
              },
              Name: {
                locationName: "name"
              },
              NetworkSettings: {
                shape: "Sij",
                locationName: "networkSettings"
              },
              SerialNumber: {
                locationName: "serialNumber"
              },
              Type: {
                locationName: "type"
              },
              UhdDeviceSettings: {
                shape: "Sim",
                locationName: "uhdDeviceSettings"
              },
              Tags: {
                shape: "Sfc",
                locationName: "tags"
              },
              AvailabilityZone: {
                locationName: "availabilityZone"
              },
              MedialiveInputArns: {
                shape: "S5",
                locationName: "medialiveInputArns"
              },
              OutputType: {
                locationName: "outputType"
              }
            }
          }
        },
        DescribeInputDeviceThumbnail: {
          http: {
            method: "GET",
            requestUri: "/prod/inputDevices/{inputDeviceId}/thumbnailData",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              InputDeviceId: {
                location: "uri",
                locationName: "inputDeviceId"
              },
              Accept: {
                location: "header",
                locationName: "accept"
              }
            },
            required: [
              "InputDeviceId",
              "Accept"
            ]
          },
          output: {
            type: "structure",
            members: {
              Body: {
                locationName: "body",
                type: "blob",
                streaming: true
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              ContentLength: {
                location: "header",
                locationName: "Content-Length",
                type: "long"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              },
              LastModified: {
                location: "header",
                locationName: "Last-Modified",
                type: "timestamp"
              }
            },
            payload: "Body"
          }
        },
        DescribeInputSecurityGroup: {
          http: {
            method: "GET",
            requestUri: "/prod/inputSecurityGroups/{inputSecurityGroupId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              InputSecurityGroupId: {
                location: "uri",
                locationName: "inputSecurityGroupId"
              }
            },
            required: [
              "InputSecurityGroupId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              Id: {
                locationName: "id"
              },
              Inputs: {
                shape: "S5",
                locationName: "inputs"
              },
              State: {
                locationName: "state"
              },
              Tags: {
                shape: "Sfc",
                locationName: "tags"
              },
              WhitelistRules: {
                shape: "Sgg",
                locationName: "whitelistRules"
              }
            }
          }
        },
        DescribeMultiplex: {
          http: {
            method: "GET",
            requestUri: "/prod/multiplexes/{multiplexId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MultiplexId: {
                location: "uri",
                locationName: "multiplexId"
              }
            },
            required: [
              "MultiplexId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              AvailabilityZones: {
                shape: "S5",
                locationName: "availabilityZones"
              },
              Destinations: {
                shape: "Sgp",
                locationName: "destinations"
              },
              Id: {
                locationName: "id"
              },
              MultiplexSettings: {
                shape: "Sgj",
                locationName: "multiplexSettings"
              },
              Name: {
                locationName: "name"
              },
              PipelinesRunningCount: {
                locationName: "pipelinesRunningCount",
                type: "integer"
              },
              ProgramCount: {
                locationName: "programCount",
                type: "integer"
              },
              State: {
                locationName: "state"
              },
              Tags: {
                shape: "Sfc",
                locationName: "tags"
              }
            }
          }
        },
        DescribeMultiplexProgram: {
          http: {
            method: "GET",
            requestUri: "/prod/multiplexes/{multiplexId}/programs/{programName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MultiplexId: {
                location: "uri",
                locationName: "multiplexId"
              },
              ProgramName: {
                location: "uri",
                locationName: "programName"
              }
            },
            required: [
              "MultiplexId",
              "ProgramName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ChannelId: {
                locationName: "channelId"
              },
              MultiplexProgramSettings: {
                shape: "Sgu",
                locationName: "multiplexProgramSettings"
              },
              PacketIdentifiersMap: {
                shape: "Sh3",
                locationName: "packetIdentifiersMap"
              },
              PipelineDetails: {
                shape: "Sh5",
                locationName: "pipelineDetails"
              },
              ProgramName: {
                locationName: "programName"
              }
            }
          }
        },
        DescribeOffering: {
          http: {
            method: "GET",
            requestUri: "/prod/offerings/{offeringId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              OfferingId: {
                location: "uri",
                locationName: "offeringId"
              }
            },
            required: [
              "OfferingId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              CurrencyCode: {
                locationName: "currencyCode"
              },
              Duration: {
                locationName: "duration",
                type: "integer"
              },
              DurationUnits: {
                locationName: "durationUnits"
              },
              FixedPrice: {
                locationName: "fixedPrice",
                type: "double"
              },
              OfferingDescription: {
                locationName: "offeringDescription"
              },
              OfferingId: {
                locationName: "offeringId"
              },
              OfferingType: {
                locationName: "offeringType"
              },
              Region: {
                locationName: "region"
              },
              ResourceSpecification: {
                shape: "Shq",
                locationName: "resourceSpecification"
              },
              UsagePrice: {
                locationName: "usagePrice",
                type: "double"
              }
            }
          }
        },
        DescribeReservation: {
          http: {
            method: "GET",
            requestUri: "/prod/reservations/{reservationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ReservationId: {
                location: "uri",
                locationName: "reservationId"
              }
            },
            required: [
              "ReservationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              Count: {
                locationName: "count",
                type: "integer"
              },
              CurrencyCode: {
                locationName: "currencyCode"
              },
              Duration: {
                locationName: "duration",
                type: "integer"
              },
              DurationUnits: {
                locationName: "durationUnits"
              },
              End: {
                locationName: "end"
              },
              FixedPrice: {
                locationName: "fixedPrice",
                type: "double"
              },
              Name: {
                locationName: "name"
              },
              OfferingDescription: {
                locationName: "offeringDescription"
              },
              OfferingId: {
                locationName: "offeringId"
              },
              OfferingType: {
                locationName: "offeringType"
              },
              Region: {
                locationName: "region"
              },
              RenewalSettings: {
                shape: "Sho",
                locationName: "renewalSettings"
              },
              ReservationId: {
                locationName: "reservationId"
              },
              ResourceSpecification: {
                shape: "Shq",
                locationName: "resourceSpecification"
              },
              Start: {
                locationName: "start"
              },
              State: {
                locationName: "state"
              },
              Tags: {
                shape: "Sfc",
                locationName: "tags"
              },
              UsagePrice: {
                locationName: "usagePrice",
                type: "double"
              }
            }
          }
        },
        DescribeSchedule: {
          http: {
            method: "GET",
            requestUri: "/prod/channels/{channelId}/schedule",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ChannelId: {
                location: "uri",
                locationName: "channelId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "ChannelId"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              ScheduleActions: {
                shape: "Sh",
                locationName: "scheduleActions"
              }
            }
          }
        },
        DescribeThumbnails: {
          http: {
            method: "GET",
            requestUri: "/prod/channels/{channelId}/thumbnails",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ChannelId: {
                location: "uri",
                locationName: "channelId"
              },
              PipelineId: {
                location: "querystring",
                locationName: "pipelineId"
              },
              ThumbnailType: {
                location: "querystring",
                locationName: "thumbnailType"
              }
            },
            required: [
              "ThumbnailType",
              "PipelineId",
              "ChannelId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ThumbnailDetails: {
                locationName: "thumbnailDetails",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PipelineId: {
                      locationName: "pipelineId"
                    },
                    Thumbnails: {
                      locationName: "thumbnails",
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Body: {
                            locationName: "body"
                          },
                          ContentType: {
                            locationName: "contentType"
                          },
                          ThumbnailType: {
                            locationName: "thumbnailType"
                          },
                          TimeStamp: {
                            locationName: "timeStamp",
                            type: "timestamp",
                            timestampFormat: "iso8601"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        ListChannels: {
          http: {
            method: "GET",
            requestUri: "/prod/channels",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Channels: {
                locationName: "channels",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {
                      locationName: "arn"
                    },
                    CdiInputSpecification: {
                      shape: "S27",
                      locationName: "cdiInputSpecification"
                    },
                    ChannelClass: {
                      locationName: "channelClass"
                    },
                    Destinations: {
                      shape: "S2a",
                      locationName: "destinations"
                    },
                    EgressEndpoints: {
                      shape: "Sfg",
                      locationName: "egressEndpoints"
                    },
                    Id: {
                      locationName: "id"
                    },
                    InputAttachments: {
                      shape: "Sdf",
                      locationName: "inputAttachments"
                    },
                    InputSpecification: {
                      shape: "Sf4",
                      locationName: "inputSpecification"
                    },
                    LogLevel: {
                      locationName: "logLevel"
                    },
                    Maintenance: {
                      shape: "Sfi",
                      locationName: "maintenance"
                    },
                    Name: {
                      locationName: "name"
                    },
                    PipelinesRunningCount: {
                      locationName: "pipelinesRunningCount",
                      type: "integer"
                    },
                    RoleArn: {
                      locationName: "roleArn"
                    },
                    State: {
                      locationName: "state"
                    },
                    Tags: {
                      shape: "Sfc",
                      locationName: "tags"
                    },
                    Vpc: {
                      shape: "Sfm",
                      locationName: "vpc"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListInputDeviceTransfers: {
          http: {
            method: "GET",
            requestUri: "/prod/inputDeviceTransfers",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              TransferType: {
                location: "querystring",
                locationName: "transferType"
              }
            },
            required: [
              "TransferType"
            ]
          },
          output: {
            type: "structure",
            members: {
              InputDeviceTransfers: {
                locationName: "inputDeviceTransfers",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {
                      locationName: "id"
                    },
                    Message: {
                      locationName: "message"
                    },
                    TargetCustomerId: {
                      locationName: "targetCustomerId"
                    },
                    TransferType: {
                      locationName: "transferType"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListInputDevices: {
          http: {
            method: "GET",
            requestUri: "/prod/inputDevices",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InputDevices: {
                locationName: "inputDevices",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {
                      locationName: "arn"
                    },
                    ConnectionState: {
                      locationName: "connectionState"
                    },
                    DeviceSettingsSyncState: {
                      locationName: "deviceSettingsSyncState"
                    },
                    DeviceUpdateStatus: {
                      locationName: "deviceUpdateStatus"
                    },
                    HdDeviceSettings: {
                      shape: "Sie",
                      locationName: "hdDeviceSettings"
                    },
                    Id: {
                      locationName: "id"
                    },
                    MacAddress: {
                      locationName: "macAddress"
                    },
                    Name: {
                      locationName: "name"
                    },
                    NetworkSettings: {
                      shape: "Sij",
                      locationName: "networkSettings"
                    },
                    SerialNumber: {
                      locationName: "serialNumber"
                    },
                    Type: {
                      locationName: "type"
                    },
                    UhdDeviceSettings: {
                      shape: "Sim",
                      locationName: "uhdDeviceSettings"
                    },
                    Tags: {
                      shape: "Sfc",
                      locationName: "tags"
                    },
                    AvailabilityZone: {
                      locationName: "availabilityZone"
                    },
                    MedialiveInputArns: {
                      shape: "S5",
                      locationName: "medialiveInputArns"
                    },
                    OutputType: {
                      locationName: "outputType"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListInputSecurityGroups: {
          http: {
            method: "GET",
            requestUri: "/prod/inputSecurityGroups",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InputSecurityGroups: {
                locationName: "inputSecurityGroups",
                type: "list",
                member: {
                  shape: "Sge"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListInputs: {
          http: {
            method: "GET",
            requestUri: "/prod/inputs",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Inputs: {
                locationName: "inputs",
                type: "list",
                member: {
                  shape: "Sfz"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListMultiplexPrograms: {
          http: {
            method: "GET",
            requestUri: "/prod/multiplexes/{multiplexId}/programs",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              MultiplexId: {
                location: "uri",
                locationName: "multiplexId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "MultiplexId"
            ]
          },
          output: {
            type: "structure",
            members: {
              MultiplexPrograms: {
                locationName: "multiplexPrograms",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ChannelId: {
                      locationName: "channelId"
                    },
                    ProgramName: {
                      locationName: "programName"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListMultiplexes: {
          http: {
            method: "GET",
            requestUri: "/prod/multiplexes",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Multiplexes: {
                locationName: "multiplexes",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {
                      locationName: "arn"
                    },
                    AvailabilityZones: {
                      shape: "S5",
                      locationName: "availabilityZones"
                    },
                    Id: {
                      locationName: "id"
                    },
                    MultiplexSettings: {
                      locationName: "multiplexSettings",
                      type: "structure",
                      members: {
                        TransportStreamBitrate: {
                          locationName: "transportStreamBitrate",
                          type: "integer"
                        }
                      }
                    },
                    Name: {
                      locationName: "name"
                    },
                    PipelinesRunningCount: {
                      locationName: "pipelinesRunningCount",
                      type: "integer"
                    },
                    ProgramCount: {
                      locationName: "programCount",
                      type: "integer"
                    },
                    State: {
                      locationName: "state"
                    },
                    Tags: {
                      shape: "Sfc",
                      locationName: "tags"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListOfferings: {
          http: {
            method: "GET",
            requestUri: "/prod/offerings",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ChannelClass: {
                location: "querystring",
                locationName: "channelClass"
              },
              ChannelConfiguration: {
                location: "querystring",
                locationName: "channelConfiguration"
              },
              Codec: {
                location: "querystring",
                locationName: "codec"
              },
              Duration: {
                location: "querystring",
                locationName: "duration"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              MaximumBitrate: {
                location: "querystring",
                locationName: "maximumBitrate"
              },
              MaximumFramerate: {
                location: "querystring",
                locationName: "maximumFramerate"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              Resolution: {
                location: "querystring",
                locationName: "resolution"
              },
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              },
              SpecialFeature: {
                location: "querystring",
                locationName: "specialFeature"
              },
              VideoQuality: {
                location: "querystring",
                locationName: "videoQuality"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Offerings: {
                locationName: "offerings",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {
                      locationName: "arn"
                    },
                    CurrencyCode: {
                      locationName: "currencyCode"
                    },
                    Duration: {
                      locationName: "duration",
                      type: "integer"
                    },
                    DurationUnits: {
                      locationName: "durationUnits"
                    },
                    FixedPrice: {
                      locationName: "fixedPrice",
                      type: "double"
                    },
                    OfferingDescription: {
                      locationName: "offeringDescription"
                    },
                    OfferingId: {
                      locationName: "offeringId"
                    },
                    OfferingType: {
                      locationName: "offeringType"
                    },
                    Region: {
                      locationName: "region"
                    },
                    ResourceSpecification: {
                      shape: "Shq",
                      locationName: "resourceSpecification"
                    },
                    UsagePrice: {
                      locationName: "usagePrice",
                      type: "double"
                    }
                  }
                }
              }
            }
          }
        },
        ListReservations: {
          http: {
            method: "GET",
            requestUri: "/prod/reservations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ChannelClass: {
                location: "querystring",
                locationName: "channelClass"
              },
              Codec: {
                location: "querystring",
                locationName: "codec"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              MaximumBitrate: {
                location: "querystring",
                locationName: "maximumBitrate"
              },
              MaximumFramerate: {
                location: "querystring",
                locationName: "maximumFramerate"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              Resolution: {
                location: "querystring",
                locationName: "resolution"
              },
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              },
              SpecialFeature: {
                location: "querystring",
                locationName: "specialFeature"
              },
              VideoQuality: {
                location: "querystring",
                locationName: "videoQuality"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Reservations: {
                locationName: "reservations",
                type: "list",
                member: {
                  shape: "Skk"
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/prod/tags/{resource-arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              }
            },
            required: [
              "ResourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sfc",
                locationName: "tags"
              }
            }
          }
        },
        PurchaseOffering: {
          http: {
            requestUri: "/prod/offerings/{offeringId}/purchase",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              Count: {
                locationName: "count",
                type: "integer"
              },
              Name: {
                locationName: "name"
              },
              OfferingId: {
                location: "uri",
                locationName: "offeringId"
              },
              RenewalSettings: {
                shape: "Sho",
                locationName: "renewalSettings"
              },
              RequestId: {
                locationName: "requestId",
                idempotencyToken: true
              },
              Start: {
                locationName: "start"
              },
              Tags: {
                shape: "Sfc",
                locationName: "tags"
              }
            },
            required: [
              "OfferingId",
              "Count"
            ]
          },
          output: {
            type: "structure",
            members: {
              Reservation: {
                shape: "Skk",
                locationName: "reservation"
              }
            }
          }
        },
        RebootInputDevice: {
          http: {
            requestUri: "/prod/inputDevices/{inputDeviceId}/reboot",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Force: {
                locationName: "force"
              },
              InputDeviceId: {
                location: "uri",
                locationName: "inputDeviceId"
              }
            },
            required: [
              "InputDeviceId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RejectInputDeviceTransfer: {
          http: {
            requestUri: "/prod/inputDevices/{inputDeviceId}/reject",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              InputDeviceId: {
                location: "uri",
                locationName: "inputDeviceId"
              }
            },
            required: [
              "InputDeviceId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartChannel: {
          http: {
            requestUri: "/prod/channels/{channelId}/start",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ChannelId: {
                location: "uri",
                locationName: "channelId"
              }
            },
            required: [
              "ChannelId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              CdiInputSpecification: {
                shape: "S27",
                locationName: "cdiInputSpecification"
              },
              ChannelClass: {
                locationName: "channelClass"
              },
              Destinations: {
                shape: "S2a",
                locationName: "destinations"
              },
              EgressEndpoints: {
                shape: "Sfg",
                locationName: "egressEndpoints"
              },
              EncoderSettings: {
                shape: "S2i",
                locationName: "encoderSettings"
              },
              Id: {
                locationName: "id"
              },
              InputAttachments: {
                shape: "Sdf",
                locationName: "inputAttachments"
              },
              InputSpecification: {
                shape: "Sf4",
                locationName: "inputSpecification"
              },
              LogLevel: {
                locationName: "logLevel"
              },
              Maintenance: {
                shape: "Sfi",
                locationName: "maintenance"
              },
              Name: {
                locationName: "name"
              },
              PipelineDetails: {
                shape: "Sfj",
                locationName: "pipelineDetails"
              },
              PipelinesRunningCount: {
                locationName: "pipelinesRunningCount",
                type: "integer"
              },
              RoleArn: {
                locationName: "roleArn"
              },
              State: {
                locationName: "state"
              },
              Tags: {
                shape: "Sfc",
                locationName: "tags"
              },
              Vpc: {
                shape: "Sfm",
                locationName: "vpc"
              }
            }
          }
        },
        StartInputDevice: {
          http: {
            requestUri: "/prod/inputDevices/{inputDeviceId}/start",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              InputDeviceId: {
                location: "uri",
                locationName: "inputDeviceId"
              }
            },
            required: [
              "InputDeviceId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartInputDeviceMaintenanceWindow: {
          http: {
            requestUri: "/prod/inputDevices/{inputDeviceId}/startInputDeviceMaintenanceWindow",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              InputDeviceId: {
                location: "uri",
                locationName: "inputDeviceId"
              }
            },
            required: [
              "InputDeviceId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartMultiplex: {
          http: {
            requestUri: "/prod/multiplexes/{multiplexId}/start",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              MultiplexId: {
                location: "uri",
                locationName: "multiplexId"
              }
            },
            required: [
              "MultiplexId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              AvailabilityZones: {
                shape: "S5",
                locationName: "availabilityZones"
              },
              Destinations: {
                shape: "Sgp",
                locationName: "destinations"
              },
              Id: {
                locationName: "id"
              },
              MultiplexSettings: {
                shape: "Sgj",
                locationName: "multiplexSettings"
              },
              Name: {
                locationName: "name"
              },
              PipelinesRunningCount: {
                locationName: "pipelinesRunningCount",
                type: "integer"
              },
              ProgramCount: {
                locationName: "programCount",
                type: "integer"
              },
              State: {
                locationName: "state"
              },
              Tags: {
                shape: "Sfc",
                locationName: "tags"
              }
            }
          }
        },
        StopChannel: {
          http: {
            requestUri: "/prod/channels/{channelId}/stop",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ChannelId: {
                location: "uri",
                locationName: "channelId"
              }
            },
            required: [
              "ChannelId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              CdiInputSpecification: {
                shape: "S27",
                locationName: "cdiInputSpecification"
              },
              ChannelClass: {
                locationName: "channelClass"
              },
              Destinations: {
                shape: "S2a",
                locationName: "destinations"
              },
              EgressEndpoints: {
                shape: "Sfg",
                locationName: "egressEndpoints"
              },
              EncoderSettings: {
                shape: "S2i",
                locationName: "encoderSettings"
              },
              Id: {
                locationName: "id"
              },
              InputAttachments: {
                shape: "Sdf",
                locationName: "inputAttachments"
              },
              InputSpecification: {
                shape: "Sf4",
                locationName: "inputSpecification"
              },
              LogLevel: {
                locationName: "logLevel"
              },
              Maintenance: {
                shape: "Sfi",
                locationName: "maintenance"
              },
              Name: {
                locationName: "name"
              },
              PipelineDetails: {
                shape: "Sfj",
                locationName: "pipelineDetails"
              },
              PipelinesRunningCount: {
                locationName: "pipelinesRunningCount",
                type: "integer"
              },
              RoleArn: {
                locationName: "roleArn"
              },
              State: {
                locationName: "state"
              },
              Tags: {
                shape: "Sfc",
                locationName: "tags"
              },
              Vpc: {
                shape: "Sfm",
                locationName: "vpc"
              }
            }
          }
        },
        StopInputDevice: {
          http: {
            requestUri: "/prod/inputDevices/{inputDeviceId}/stop",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              InputDeviceId: {
                location: "uri",
                locationName: "inputDeviceId"
              }
            },
            required: [
              "InputDeviceId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StopMultiplex: {
          http: {
            requestUri: "/prod/multiplexes/{multiplexId}/stop",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              MultiplexId: {
                location: "uri",
                locationName: "multiplexId"
              }
            },
            required: [
              "MultiplexId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              AvailabilityZones: {
                shape: "S5",
                locationName: "availabilityZones"
              },
              Destinations: {
                shape: "Sgp",
                locationName: "destinations"
              },
              Id: {
                locationName: "id"
              },
              MultiplexSettings: {
                shape: "Sgj",
                locationName: "multiplexSettings"
              },
              Name: {
                locationName: "name"
              },
              PipelinesRunningCount: {
                locationName: "pipelinesRunningCount",
                type: "integer"
              },
              ProgramCount: {
                locationName: "programCount",
                type: "integer"
              },
              State: {
                locationName: "state"
              },
              Tags: {
                shape: "Sfc",
                locationName: "tags"
              }
            }
          }
        },
        TransferInputDevice: {
          http: {
            requestUri: "/prod/inputDevices/{inputDeviceId}/transfer",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              InputDeviceId: {
                location: "uri",
                locationName: "inputDeviceId"
              },
              TargetCustomerId: {
                locationName: "targetCustomerId"
              },
              TargetRegion: {
                locationName: "targetRegion"
              },
              TransferMessage: {
                locationName: "transferMessage"
              }
            },
            required: [
              "InputDeviceId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAccountConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/prod/accountConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AccountConfiguration: {
                shape: "Si4",
                locationName: "accountConfiguration"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccountConfiguration: {
                shape: "Si4",
                locationName: "accountConfiguration"
              }
            }
          }
        },
        UpdateChannel: {
          http: {
            method: "PUT",
            requestUri: "/prod/channels/{channelId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CdiInputSpecification: {
                shape: "S27",
                locationName: "cdiInputSpecification"
              },
              ChannelId: {
                location: "uri",
                locationName: "channelId"
              },
              Destinations: {
                shape: "S2a",
                locationName: "destinations"
              },
              EncoderSettings: {
                shape: "S2i",
                locationName: "encoderSettings"
              },
              InputAttachments: {
                shape: "Sdf",
                locationName: "inputAttachments"
              },
              InputSpecification: {
                shape: "Sf4",
                locationName: "inputSpecification"
              },
              LogLevel: {
                locationName: "logLevel"
              },
              Maintenance: {
                locationName: "maintenance",
                type: "structure",
                members: {
                  MaintenanceDay: {
                    locationName: "maintenanceDay"
                  },
                  MaintenanceScheduledDate: {
                    locationName: "maintenanceScheduledDate"
                  },
                  MaintenanceStartTime: {
                    locationName: "maintenanceStartTime"
                  }
                }
              },
              Name: {
                locationName: "name"
              },
              RoleArn: {
                locationName: "roleArn"
              }
            },
            required: [
              "ChannelId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Channel: {
                shape: "Sff",
                locationName: "channel"
              }
            }
          }
        },
        UpdateChannelClass: {
          http: {
            method: "PUT",
            requestUri: "/prod/channels/{channelId}/channelClass",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ChannelClass: {
                locationName: "channelClass"
              },
              ChannelId: {
                location: "uri",
                locationName: "channelId"
              },
              Destinations: {
                shape: "S2a",
                locationName: "destinations"
              }
            },
            required: [
              "ChannelId",
              "ChannelClass"
            ]
          },
          output: {
            type: "structure",
            members: {
              Channel: {
                shape: "Sff",
                locationName: "channel"
              }
            }
          }
        },
        UpdateInput: {
          http: {
            method: "PUT",
            requestUri: "/prod/inputs/{inputId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Destinations: {
                shape: "Sfo",
                locationName: "destinations"
              },
              InputDevices: {
                locationName: "inputDevices",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {
                      locationName: "id"
                    }
                  }
                }
              },
              InputId: {
                location: "uri",
                locationName: "inputId"
              },
              InputSecurityGroups: {
                shape: "S5",
                locationName: "inputSecurityGroups"
              },
              MediaConnectFlows: {
                shape: "Sfs",
                locationName: "mediaConnectFlows"
              },
              Name: {
                locationName: "name"
              },
              RoleArn: {
                locationName: "roleArn"
              },
              Sources: {
                shape: "Sfu",
                locationName: "sources"
              }
            },
            required: [
              "InputId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Input: {
                shape: "Sfz",
                locationName: "input"
              }
            }
          }
        },
        UpdateInputDevice: {
          http: {
            method: "PUT",
            requestUri: "/prod/inputDevices/{inputDeviceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              HdDeviceSettings: {
                shape: "Slm",
                locationName: "hdDeviceSettings"
              },
              InputDeviceId: {
                location: "uri",
                locationName: "inputDeviceId"
              },
              Name: {
                locationName: "name"
              },
              UhdDeviceSettings: {
                shape: "Slm",
                locationName: "uhdDeviceSettings"
              },
              AvailabilityZone: {
                locationName: "availabilityZone"
              }
            },
            required: [
              "InputDeviceId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              ConnectionState: {
                locationName: "connectionState"
              },
              DeviceSettingsSyncState: {
                locationName: "deviceSettingsSyncState"
              },
              DeviceUpdateStatus: {
                locationName: "deviceUpdateStatus"
              },
              HdDeviceSettings: {
                shape: "Sie",
                locationName: "hdDeviceSettings"
              },
              Id: {
                locationName: "id"
              },
              MacAddress: {
                locationName: "macAddress"
              },
              Name: {
                locationName: "name"
              },
              NetworkSettings: {
                shape: "Sij",
                locationName: "networkSettings"
              },
              SerialNumber: {
                locationName: "serialNumber"
              },
              Type: {
                locationName: "type"
              },
              UhdDeviceSettings: {
                shape: "Sim",
                locationName: "uhdDeviceSettings"
              },
              Tags: {
                shape: "Sfc",
                locationName: "tags"
              },
              AvailabilityZone: {
                locationName: "availabilityZone"
              },
              MedialiveInputArns: {
                shape: "S5",
                locationName: "medialiveInputArns"
              },
              OutputType: {
                locationName: "outputType"
              }
            }
          }
        },
        UpdateInputSecurityGroup: {
          http: {
            method: "PUT",
            requestUri: "/prod/inputSecurityGroups/{inputSecurityGroupId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              InputSecurityGroupId: {
                location: "uri",
                locationName: "inputSecurityGroupId"
              },
              Tags: {
                shape: "Sfc",
                locationName: "tags"
              },
              WhitelistRules: {
                shape: "Sgb",
                locationName: "whitelistRules"
              }
            },
            required: [
              "InputSecurityGroupId"
            ]
          },
          output: {
            type: "structure",
            members: {
              SecurityGroup: {
                shape: "Sge",
                locationName: "securityGroup"
              }
            }
          }
        },
        UpdateMultiplex: {
          http: {
            method: "PUT",
            requestUri: "/prod/multiplexes/{multiplexId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MultiplexId: {
                location: "uri",
                locationName: "multiplexId"
              },
              MultiplexSettings: {
                shape: "Sgj",
                locationName: "multiplexSettings"
              },
              Name: {
                locationName: "name"
              }
            },
            required: [
              "MultiplexId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Multiplex: {
                shape: "Sgo",
                locationName: "multiplex"
              }
            }
          }
        },
        UpdateMultiplexProgram: {
          http: {
            method: "PUT",
            requestUri: "/prod/multiplexes/{multiplexId}/programs/{programName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MultiplexId: {
                location: "uri",
                locationName: "multiplexId"
              },
              MultiplexProgramSettings: {
                shape: "Sgu",
                locationName: "multiplexProgramSettings"
              },
              ProgramName: {
                location: "uri",
                locationName: "programName"
              }
            },
            required: [
              "MultiplexId",
              "ProgramName"
            ]
          },
          output: {
            type: "structure",
            members: {
              MultiplexProgram: {
                shape: "Sh2",
                locationName: "multiplexProgram"
              }
            }
          }
        },
        UpdateReservation: {
          http: {
            method: "PUT",
            requestUri: "/prod/reservations/{reservationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Name: {
                locationName: "name"
              },
              RenewalSettings: {
                shape: "Sho",
                locationName: "renewalSettings"
              },
              ReservationId: {
                location: "uri",
                locationName: "reservationId"
              }
            },
            required: [
              "ReservationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Reservation: {
                shape: "Skk",
                locationName: "reservation"
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "list",
          member: {}
        },
        S7: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              Code: {
                locationName: "code"
              },
              Id: {
                locationName: "id"
              },
              Message: {
                locationName: "message"
              }
            }
          }
        },
        S9: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              Id: {
                locationName: "id"
              },
              State: {
                locationName: "state"
              }
            }
          }
        },
        Sh: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ActionName: {
                locationName: "actionName"
              },
              ScheduleActionSettings: {
                locationName: "scheduleActionSettings",
                type: "structure",
                members: {
                  HlsId3SegmentTaggingSettings: {
                    locationName: "hlsId3SegmentTaggingSettings",
                    type: "structure",
                    members: {
                      Tag: {
                        locationName: "tag"
                      },
                      Id3: {
                        locationName: "id3"
                      }
                    }
                  },
                  HlsTimedMetadataSettings: {
                    locationName: "hlsTimedMetadataSettings",
                    type: "structure",
                    members: {
                      Id3: {
                        locationName: "id3"
                      }
                    },
                    required: [
                      "Id3"
                    ]
                  },
                  InputPrepareSettings: {
                    locationName: "inputPrepareSettings",
                    type: "structure",
                    members: {
                      InputAttachmentNameReference: {
                        locationName: "inputAttachmentNameReference"
                      },
                      InputClippingSettings: {
                        shape: "Sn",
                        locationName: "inputClippingSettings"
                      },
                      UrlPath: {
                        shape: "S5",
                        locationName: "urlPath"
                      }
                    }
                  },
                  InputSwitchSettings: {
                    locationName: "inputSwitchSettings",
                    type: "structure",
                    members: {
                      InputAttachmentNameReference: {
                        locationName: "inputAttachmentNameReference"
                      },
                      InputClippingSettings: {
                        shape: "Sn",
                        locationName: "inputClippingSettings"
                      },
                      UrlPath: {
                        shape: "S5",
                        locationName: "urlPath"
                      }
                    },
                    required: [
                      "InputAttachmentNameReference"
                    ]
                  },
                  MotionGraphicsImageActivateSettings: {
                    locationName: "motionGraphicsImageActivateSettings",
                    type: "structure",
                    members: {
                      Duration: {
                        locationName: "duration",
                        type: "long"
                      },
                      PasswordParam: {
                        locationName: "passwordParam"
                      },
                      Url: {
                        locationName: "url"
                      },
                      Username: {
                        locationName: "username"
                      }
                    }
                  },
                  MotionGraphicsImageDeactivateSettings: {
                    locationName: "motionGraphicsImageDeactivateSettings",
                    type: "structure",
                    members: {}
                  },
                  PauseStateSettings: {
                    locationName: "pauseStateSettings",
                    type: "structure",
                    members: {
                      Pipelines: {
                        locationName: "pipelines",
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            PipelineId: {
                              locationName: "pipelineId"
                            }
                          },
                          required: [
                            "PipelineId"
                          ]
                        }
                      }
                    }
                  },
                  Scte35InputSettings: {
                    locationName: "scte35InputSettings",
                    type: "structure",
                    members: {
                      InputAttachmentNameReference: {
                        locationName: "inputAttachmentNameReference"
                      },
                      Mode: {
                        locationName: "mode"
                      }
                    },
                    required: [
                      "Mode"
                    ]
                  },
                  Scte35ReturnToNetworkSettings: {
                    locationName: "scte35ReturnToNetworkSettings",
                    type: "structure",
                    members: {
                      SpliceEventId: {
                        locationName: "spliceEventId",
                        type: "long"
                      }
                    },
                    required: [
                      "SpliceEventId"
                    ]
                  },
                  Scte35SpliceInsertSettings: {
                    locationName: "scte35SpliceInsertSettings",
                    type: "structure",
                    members: {
                      Duration: {
                        locationName: "duration",
                        type: "long"
                      },
                      SpliceEventId: {
                        locationName: "spliceEventId",
                        type: "long"
                      }
                    },
                    required: [
                      "SpliceEventId"
                    ]
                  },
                  Scte35TimeSignalSettings: {
                    locationName: "scte35TimeSignalSettings",
                    type: "structure",
                    members: {
                      Scte35Descriptors: {
                        locationName: "scte35Descriptors",
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            Scte35DescriptorSettings: {
                              locationName: "scte35DescriptorSettings",
                              type: "structure",
                              members: {
                                SegmentationDescriptorScte35DescriptorSettings: {
                                  locationName: "segmentationDescriptorScte35DescriptorSettings",
                                  type: "structure",
                                  members: {
                                    DeliveryRestrictions: {
                                      locationName: "deliveryRestrictions",
                                      type: "structure",
                                      members: {
                                        ArchiveAllowedFlag: {
                                          locationName: "archiveAllowedFlag"
                                        },
                                        DeviceRestrictions: {
                                          locationName: "deviceRestrictions"
                                        },
                                        NoRegionalBlackoutFlag: {
                                          locationName: "noRegionalBlackoutFlag"
                                        },
                                        WebDeliveryAllowedFlag: {
                                          locationName: "webDeliveryAllowedFlag"
                                        }
                                      },
                                      required: [
                                        "DeviceRestrictions",
                                        "ArchiveAllowedFlag",
                                        "WebDeliveryAllowedFlag",
                                        "NoRegionalBlackoutFlag"
                                      ]
                                    },
                                    SegmentNum: {
                                      locationName: "segmentNum",
                                      type: "integer"
                                    },
                                    SegmentationCancelIndicator: {
                                      locationName: "segmentationCancelIndicator"
                                    },
                                    SegmentationDuration: {
                                      locationName: "segmentationDuration",
                                      type: "long"
                                    },
                                    SegmentationEventId: {
                                      locationName: "segmentationEventId",
                                      type: "long"
                                    },
                                    SegmentationTypeId: {
                                      locationName: "segmentationTypeId",
                                      type: "integer"
                                    },
                                    SegmentationUpid: {
                                      locationName: "segmentationUpid"
                                    },
                                    SegmentationUpidType: {
                                      locationName: "segmentationUpidType",
                                      type: "integer"
                                    },
                                    SegmentsExpected: {
                                      locationName: "segmentsExpected",
                                      type: "integer"
                                    },
                                    SubSegmentNum: {
                                      locationName: "subSegmentNum",
                                      type: "integer"
                                    },
                                    SubSegmentsExpected: {
                                      locationName: "subSegmentsExpected",
                                      type: "integer"
                                    }
                                  },
                                  required: [
                                    "SegmentationEventId",
                                    "SegmentationCancelIndicator"
                                  ]
                                }
                              },
                              required: [
                                "SegmentationDescriptorScte35DescriptorSettings"
                              ]
                            }
                          },
                          required: [
                            "Scte35DescriptorSettings"
                          ]
                        }
                      }
                    },
                    required: [
                      "Scte35Descriptors"
                    ]
                  },
                  StaticImageActivateSettings: {
                    locationName: "staticImageActivateSettings",
                    type: "structure",
                    members: {
                      Duration: {
                        locationName: "duration",
                        type: "integer"
                      },
                      FadeIn: {
                        locationName: "fadeIn",
                        type: "integer"
                      },
                      FadeOut: {
                        locationName: "fadeOut",
                        type: "integer"
                      },
                      Height: {
                        locationName: "height",
                        type: "integer"
                      },
                      Image: {
                        shape: "S1m",
                        locationName: "image"
                      },
                      ImageX: {
                        locationName: "imageX",
                        type: "integer"
                      },
                      ImageY: {
                        locationName: "imageY",
                        type: "integer"
                      },
                      Layer: {
                        locationName: "layer",
                        type: "integer"
                      },
                      Opacity: {
                        locationName: "opacity",
                        type: "integer"
                      },
                      Width: {
                        locationName: "width",
                        type: "integer"
                      }
                    },
                    required: [
                      "Image"
                    ]
                  },
                  StaticImageDeactivateSettings: {
                    locationName: "staticImageDeactivateSettings",
                    type: "structure",
                    members: {
                      FadeOut: {
                        locationName: "fadeOut",
                        type: "integer"
                      },
                      Layer: {
                        locationName: "layer",
                        type: "integer"
                      }
                    }
                  },
                  StaticImageOutputActivateSettings: {
                    locationName: "staticImageOutputActivateSettings",
                    type: "structure",
                    members: {
                      Duration: {
                        locationName: "duration",
                        type: "integer"
                      },
                      FadeIn: {
                        locationName: "fadeIn",
                        type: "integer"
                      },
                      FadeOut: {
                        locationName: "fadeOut",
                        type: "integer"
                      },
                      Height: {
                        locationName: "height",
                        type: "integer"
                      },
                      Image: {
                        shape: "S1m",
                        locationName: "image"
                      },
                      ImageX: {
                        locationName: "imageX",
                        type: "integer"
                      },
                      ImageY: {
                        locationName: "imageY",
                        type: "integer"
                      },
                      Layer: {
                        locationName: "layer",
                        type: "integer"
                      },
                      Opacity: {
                        locationName: "opacity",
                        type: "integer"
                      },
                      OutputNames: {
                        shape: "S5",
                        locationName: "outputNames"
                      },
                      Width: {
                        locationName: "width",
                        type: "integer"
                      }
                    },
                    required: [
                      "OutputNames",
                      "Image"
                    ]
                  },
                  StaticImageOutputDeactivateSettings: {
                    locationName: "staticImageOutputDeactivateSettings",
                    type: "structure",
                    members: {
                      FadeOut: {
                        locationName: "fadeOut",
                        type: "integer"
                      },
                      Layer: {
                        locationName: "layer",
                        type: "integer"
                      },
                      OutputNames: {
                        shape: "S5",
                        locationName: "outputNames"
                      }
                    },
                    required: [
                      "OutputNames"
                    ]
                  }
                }
              },
              ScheduleActionStartSettings: {
                locationName: "scheduleActionStartSettings",
                type: "structure",
                members: {
                  FixedModeScheduleActionStartSettings: {
                    locationName: "fixedModeScheduleActionStartSettings",
                    type: "structure",
                    members: {
                      Time: {
                        locationName: "time"
                      }
                    },
                    required: [
                      "Time"
                    ]
                  },
                  FollowModeScheduleActionStartSettings: {
                    locationName: "followModeScheduleActionStartSettings",
                    type: "structure",
                    members: {
                      FollowPoint: {
                        locationName: "followPoint"
                      },
                      ReferenceActionName: {
                        locationName: "referenceActionName"
                      }
                    },
                    required: [
                      "ReferenceActionName",
                      "FollowPoint"
                    ]
                  },
                  ImmediateModeScheduleActionStartSettings: {
                    locationName: "immediateModeScheduleActionStartSettings",
                    type: "structure",
                    members: {}
                  }
                }
              }
            },
            required: [
              "ActionName",
              "ScheduleActionStartSettings",
              "ScheduleActionSettings"
            ]
          }
        },
        Sn: {
          type: "structure",
          members: {
            InputTimecodeSource: {
              locationName: "inputTimecodeSource"
            },
            StartTimecode: {
              locationName: "startTimecode",
              type: "structure",
              members: {
                Timecode: {
                  locationName: "timecode"
                }
              }
            },
            StopTimecode: {
              locationName: "stopTimecode",
              type: "structure",
              members: {
                LastFrameClippingBehavior: {
                  locationName: "lastFrameClippingBehavior"
                },
                Timecode: {
                  locationName: "timecode"
                }
              }
            }
          },
          required: [
            "InputTimecodeSource"
          ]
        },
        S1m: {
          type: "structure",
          members: {
            PasswordParam: {
              locationName: "passwordParam"
            },
            Uri: {
              locationName: "uri"
            },
            Username: {
              locationName: "username"
            }
          },
          required: [
            "Uri"
          ]
        },
        S27: {
          type: "structure",
          members: {
            Resolution: {
              locationName: "resolution"
            }
          }
        },
        S2a: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Id: {
                locationName: "id"
              },
              MediaPackageSettings: {
                locationName: "mediaPackageSettings",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ChannelId: {
                      locationName: "channelId"
                    }
                  }
                }
              },
              MultiplexSettings: {
                locationName: "multiplexSettings",
                type: "structure",
                members: {
                  MultiplexId: {
                    locationName: "multiplexId"
                  },
                  ProgramName: {
                    locationName: "programName"
                  }
                }
              },
              Settings: {
                locationName: "settings",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PasswordParam: {
                      locationName: "passwordParam"
                    },
                    StreamName: {
                      locationName: "streamName"
                    },
                    Url: {
                      locationName: "url"
                    },
                    Username: {
                      locationName: "username"
                    }
                  }
                }
              }
            }
          }
        },
        S2i: {
          type: "structure",
          members: {
            AudioDescriptions: {
              locationName: "audioDescriptions",
              type: "list",
              member: {
                type: "structure",
                members: {
                  AudioNormalizationSettings: {
                    locationName: "audioNormalizationSettings",
                    type: "structure",
                    members: {
                      Algorithm: {
                        locationName: "algorithm"
                      },
                      AlgorithmControl: {
                        locationName: "algorithmControl"
                      },
                      TargetLkfs: {
                        locationName: "targetLkfs",
                        type: "double"
                      }
                    }
                  },
                  AudioSelectorName: {
                    locationName: "audioSelectorName"
                  },
                  AudioType: {
                    locationName: "audioType"
                  },
                  AudioTypeControl: {
                    locationName: "audioTypeControl"
                  },
                  AudioWatermarkingSettings: {
                    locationName: "audioWatermarkingSettings",
                    type: "structure",
                    members: {
                      NielsenWatermarksSettings: {
                        locationName: "nielsenWatermarksSettings",
                        type: "structure",
                        members: {
                          NielsenCbetSettings: {
                            locationName: "nielsenCbetSettings",
                            type: "structure",
                            members: {
                              CbetCheckDigitString: {
                                locationName: "cbetCheckDigitString"
                              },
                              CbetStepaside: {
                                locationName: "cbetStepaside"
                              },
                              Csid: {
                                locationName: "csid"
                              }
                            },
                            required: [
                              "CbetCheckDigitString",
                              "CbetStepaside",
                              "Csid"
                            ]
                          },
                          NielsenDistributionType: {
                            locationName: "nielsenDistributionType"
                          },
                          NielsenNaesIiNwSettings: {
                            locationName: "nielsenNaesIiNwSettings",
                            type: "structure",
                            members: {
                              CheckDigitString: {
                                locationName: "checkDigitString"
                              },
                              Sid: {
                                locationName: "sid",
                                type: "double"
                              },
                              Timezone: {
                                locationName: "timezone"
                              }
                            },
                            required: [
                              "CheckDigitString",
                              "Sid"
                            ]
                          }
                        }
                      }
                    }
                  },
                  CodecSettings: {
                    locationName: "codecSettings",
                    type: "structure",
                    members: {
                      AacSettings: {
                        locationName: "aacSettings",
                        type: "structure",
                        members: {
                          Bitrate: {
                            locationName: "bitrate",
                            type: "double"
                          },
                          CodingMode: {
                            locationName: "codingMode"
                          },
                          InputType: {
                            locationName: "inputType"
                          },
                          Profile: {
                            locationName: "profile"
                          },
                          RateControlMode: {
                            locationName: "rateControlMode"
                          },
                          RawFormat: {
                            locationName: "rawFormat"
                          },
                          SampleRate: {
                            locationName: "sampleRate",
                            type: "double"
                          },
                          Spec: {
                            locationName: "spec"
                          },
                          VbrQuality: {
                            locationName: "vbrQuality"
                          }
                        }
                      },
                      Ac3Settings: {
                        locationName: "ac3Settings",
                        type: "structure",
                        members: {
                          Bitrate: {
                            locationName: "bitrate",
                            type: "double"
                          },
                          BitstreamMode: {
                            locationName: "bitstreamMode"
                          },
                          CodingMode: {
                            locationName: "codingMode"
                          },
                          Dialnorm: {
                            locationName: "dialnorm",
                            type: "integer"
                          },
                          DrcProfile: {
                            locationName: "drcProfile"
                          },
                          LfeFilter: {
                            locationName: "lfeFilter"
                          },
                          MetadataControl: {
                            locationName: "metadataControl"
                          },
                          AttenuationControl: {
                            locationName: "attenuationControl"
                          }
                        }
                      },
                      Eac3AtmosSettings: {
                        locationName: "eac3AtmosSettings",
                        type: "structure",
                        members: {
                          Bitrate: {
                            locationName: "bitrate",
                            type: "double"
                          },
                          CodingMode: {
                            locationName: "codingMode"
                          },
                          Dialnorm: {
                            locationName: "dialnorm",
                            type: "integer"
                          },
                          DrcLine: {
                            locationName: "drcLine"
                          },
                          DrcRf: {
                            locationName: "drcRf"
                          },
                          HeightTrim: {
                            locationName: "heightTrim",
                            type: "double"
                          },
                          SurroundTrim: {
                            locationName: "surroundTrim",
                            type: "double"
                          }
                        }
                      },
                      Eac3Settings: {
                        locationName: "eac3Settings",
                        type: "structure",
                        members: {
                          AttenuationControl: {
                            locationName: "attenuationControl"
                          },
                          Bitrate: {
                            locationName: "bitrate",
                            type: "double"
                          },
                          BitstreamMode: {
                            locationName: "bitstreamMode"
                          },
                          CodingMode: {
                            locationName: "codingMode"
                          },
                          DcFilter: {
                            locationName: "dcFilter"
                          },
                          Dialnorm: {
                            locationName: "dialnorm",
                            type: "integer"
                          },
                          DrcLine: {
                            locationName: "drcLine"
                          },
                          DrcRf: {
                            locationName: "drcRf"
                          },
                          LfeControl: {
                            locationName: "lfeControl"
                          },
                          LfeFilter: {
                            locationName: "lfeFilter"
                          },
                          LoRoCenterMixLevel: {
                            locationName: "loRoCenterMixLevel",
                            type: "double"
                          },
                          LoRoSurroundMixLevel: {
                            locationName: "loRoSurroundMixLevel",
                            type: "double"
                          },
                          LtRtCenterMixLevel: {
                            locationName: "ltRtCenterMixLevel",
                            type: "double"
                          },
                          LtRtSurroundMixLevel: {
                            locationName: "ltRtSurroundMixLevel",
                            type: "double"
                          },
                          MetadataControl: {
                            locationName: "metadataControl"
                          },
                          PassthroughControl: {
                            locationName: "passthroughControl"
                          },
                          PhaseControl: {
                            locationName: "phaseControl"
                          },
                          StereoDownmix: {
                            locationName: "stereoDownmix"
                          },
                          SurroundExMode: {
                            locationName: "surroundExMode"
                          },
                          SurroundMode: {
                            locationName: "surroundMode"
                          }
                        }
                      },
                      Mp2Settings: {
                        locationName: "mp2Settings",
                        type: "structure",
                        members: {
                          Bitrate: {
                            locationName: "bitrate",
                            type: "double"
                          },
                          CodingMode: {
                            locationName: "codingMode"
                          },
                          SampleRate: {
                            locationName: "sampleRate",
                            type: "double"
                          }
                        }
                      },
                      PassThroughSettings: {
                        locationName: "passThroughSettings",
                        type: "structure",
                        members: {}
                      },
                      WavSettings: {
                        locationName: "wavSettings",
                        type: "structure",
                        members: {
                          BitDepth: {
                            locationName: "bitDepth",
                            type: "double"
                          },
                          CodingMode: {
                            locationName: "codingMode"
                          },
                          SampleRate: {
                            locationName: "sampleRate",
                            type: "double"
                          }
                        }
                      }
                    }
                  },
                  LanguageCode: {
                    locationName: "languageCode"
                  },
                  LanguageCodeControl: {
                    locationName: "languageCodeControl"
                  },
                  Name: {
                    locationName: "name"
                  },
                  RemixSettings: {
                    locationName: "remixSettings",
                    type: "structure",
                    members: {
                      ChannelMappings: {
                        locationName: "channelMappings",
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            InputChannelLevels: {
                              locationName: "inputChannelLevels",
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  Gain: {
                                    locationName: "gain",
                                    type: "integer"
                                  },
                                  InputChannel: {
                                    locationName: "inputChannel",
                                    type: "integer"
                                  }
                                },
                                required: [
                                  "InputChannel",
                                  "Gain"
                                ]
                              }
                            },
                            OutputChannel: {
                              locationName: "outputChannel",
                              type: "integer"
                            }
                          },
                          required: [
                            "OutputChannel",
                            "InputChannelLevels"
                          ]
                        }
                      },
                      ChannelsIn: {
                        locationName: "channelsIn",
                        type: "integer"
                      },
                      ChannelsOut: {
                        locationName: "channelsOut",
                        type: "integer"
                      }
                    },
                    required: [
                      "ChannelMappings"
                    ]
                  },
                  StreamName: {
                    locationName: "streamName"
                  }
                },
                required: [
                  "AudioSelectorName",
                  "Name"
                ]
              }
            },
            AvailBlanking: {
              locationName: "availBlanking",
              type: "structure",
              members: {
                AvailBlankingImage: {
                  shape: "S1m",
                  locationName: "availBlankingImage"
                },
                State: {
                  locationName: "state"
                }
              }
            },
            AvailConfiguration: {
              locationName: "availConfiguration",
              type: "structure",
              members: {
                AvailSettings: {
                  locationName: "availSettings",
                  type: "structure",
                  members: {
                    Esam: {
                      locationName: "esam",
                      type: "structure",
                      members: {
                        AcquisitionPointId: {
                          locationName: "acquisitionPointId"
                        },
                        AdAvailOffset: {
                          locationName: "adAvailOffset",
                          type: "integer"
                        },
                        PasswordParam: {
                          locationName: "passwordParam"
                        },
                        PoisEndpoint: {
                          locationName: "poisEndpoint"
                        },
                        Username: {
                          locationName: "username"
                        },
                        ZoneIdentity: {
                          locationName: "zoneIdentity"
                        }
                      },
                      required: [
                        "AcquisitionPointId",
                        "PoisEndpoint"
                      ]
                    },
                    Scte35SpliceInsert: {
                      locationName: "scte35SpliceInsert",
                      type: "structure",
                      members: {
                        AdAvailOffset: {
                          locationName: "adAvailOffset",
                          type: "integer"
                        },
                        NoRegionalBlackoutFlag: {
                          locationName: "noRegionalBlackoutFlag"
                        },
                        WebDeliveryAllowedFlag: {
                          locationName: "webDeliveryAllowedFlag"
                        }
                      }
                    },
                    Scte35TimeSignalApos: {
                      locationName: "scte35TimeSignalApos",
                      type: "structure",
                      members: {
                        AdAvailOffset: {
                          locationName: "adAvailOffset",
                          type: "integer"
                        },
                        NoRegionalBlackoutFlag: {
                          locationName: "noRegionalBlackoutFlag"
                        },
                        WebDeliveryAllowedFlag: {
                          locationName: "webDeliveryAllowedFlag"
                        }
                      }
                    }
                  }
                }
              }
            },
            BlackoutSlate: {
              locationName: "blackoutSlate",
              type: "structure",
              members: {
                BlackoutSlateImage: {
                  shape: "S1m",
                  locationName: "blackoutSlateImage"
                },
                NetworkEndBlackout: {
                  locationName: "networkEndBlackout"
                },
                NetworkEndBlackoutImage: {
                  shape: "S1m",
                  locationName: "networkEndBlackoutImage"
                },
                NetworkId: {
                  locationName: "networkId"
                },
                State: {
                  locationName: "state"
                }
              }
            },
            CaptionDescriptions: {
              locationName: "captionDescriptions",
              type: "list",
              member: {
                type: "structure",
                members: {
                  Accessibility: {
                    locationName: "accessibility"
                  },
                  CaptionSelectorName: {
                    locationName: "captionSelectorName"
                  },
                  DestinationSettings: {
                    locationName: "destinationSettings",
                    type: "structure",
                    members: {
                      AribDestinationSettings: {
                        locationName: "aribDestinationSettings",
                        type: "structure",
                        members: {}
                      },
                      BurnInDestinationSettings: {
                        locationName: "burnInDestinationSettings",
                        type: "structure",
                        members: {
                          Alignment: {
                            locationName: "alignment"
                          },
                          BackgroundColor: {
                            locationName: "backgroundColor"
                          },
                          BackgroundOpacity: {
                            locationName: "backgroundOpacity",
                            type: "integer"
                          },
                          Font: {
                            shape: "S1m",
                            locationName: "font"
                          },
                          FontColor: {
                            locationName: "fontColor"
                          },
                          FontOpacity: {
                            locationName: "fontOpacity",
                            type: "integer"
                          },
                          FontResolution: {
                            locationName: "fontResolution",
                            type: "integer"
                          },
                          FontSize: {
                            locationName: "fontSize"
                          },
                          OutlineColor: {
                            locationName: "outlineColor"
                          },
                          OutlineSize: {
                            locationName: "outlineSize",
                            type: "integer"
                          },
                          ShadowColor: {
                            locationName: "shadowColor"
                          },
                          ShadowOpacity: {
                            locationName: "shadowOpacity",
                            type: "integer"
                          },
                          ShadowXOffset: {
                            locationName: "shadowXOffset",
                            type: "integer"
                          },
                          ShadowYOffset: {
                            locationName: "shadowYOffset",
                            type: "integer"
                          },
                          TeletextGridControl: {
                            locationName: "teletextGridControl"
                          },
                          XPosition: {
                            locationName: "xPosition",
                            type: "integer"
                          },
                          YPosition: {
                            locationName: "yPosition",
                            type: "integer"
                          }
                        }
                      },
                      DvbSubDestinationSettings: {
                        locationName: "dvbSubDestinationSettings",
                        type: "structure",
                        members: {
                          Alignment: {
                            locationName: "alignment"
                          },
                          BackgroundColor: {
                            locationName: "backgroundColor"
                          },
                          BackgroundOpacity: {
                            locationName: "backgroundOpacity",
                            type: "integer"
                          },
                          Font: {
                            shape: "S1m",
                            locationName: "font"
                          },
                          FontColor: {
                            locationName: "fontColor"
                          },
                          FontOpacity: {
                            locationName: "fontOpacity",
                            type: "integer"
                          },
                          FontResolution: {
                            locationName: "fontResolution",
                            type: "integer"
                          },
                          FontSize: {
                            locationName: "fontSize"
                          },
                          OutlineColor: {
                            locationName: "outlineColor"
                          },
                          OutlineSize: {
                            locationName: "outlineSize",
                            type: "integer"
                          },
                          ShadowColor: {
                            locationName: "shadowColor"
                          },
                          ShadowOpacity: {
                            locationName: "shadowOpacity",
                            type: "integer"
                          },
                          ShadowXOffset: {
                            locationName: "shadowXOffset",
                            type: "integer"
                          },
                          ShadowYOffset: {
                            locationName: "shadowYOffset",
                            type: "integer"
                          },
                          TeletextGridControl: {
                            locationName: "teletextGridControl"
                          },
                          XPosition: {
                            locationName: "xPosition",
                            type: "integer"
                          },
                          YPosition: {
                            locationName: "yPosition",
                            type: "integer"
                          }
                        }
                      },
                      EbuTtDDestinationSettings: {
                        locationName: "ebuTtDDestinationSettings",
                        type: "structure",
                        members: {
                          CopyrightHolder: {
                            locationName: "copyrightHolder"
                          },
                          FillLineGap: {
                            locationName: "fillLineGap"
                          },
                          FontFamily: {
                            locationName: "fontFamily"
                          },
                          StyleControl: {
                            locationName: "styleControl"
                          }
                        }
                      },
                      EmbeddedDestinationSettings: {
                        locationName: "embeddedDestinationSettings",
                        type: "structure",
                        members: {}
                      },
                      EmbeddedPlusScte20DestinationSettings: {
                        locationName: "embeddedPlusScte20DestinationSettings",
                        type: "structure",
                        members: {}
                      },
                      RtmpCaptionInfoDestinationSettings: {
                        locationName: "rtmpCaptionInfoDestinationSettings",
                        type: "structure",
                        members: {}
                      },
                      Scte20PlusEmbeddedDestinationSettings: {
                        locationName: "scte20PlusEmbeddedDestinationSettings",
                        type: "structure",
                        members: {}
                      },
                      Scte27DestinationSettings: {
                        locationName: "scte27DestinationSettings",
                        type: "structure",
                        members: {}
                      },
                      SmpteTtDestinationSettings: {
                        locationName: "smpteTtDestinationSettings",
                        type: "structure",
                        members: {}
                      },
                      TeletextDestinationSettings: {
                        locationName: "teletextDestinationSettings",
                        type: "structure",
                        members: {}
                      },
                      TtmlDestinationSettings: {
                        locationName: "ttmlDestinationSettings",
                        type: "structure",
                        members: {
                          StyleControl: {
                            locationName: "styleControl"
                          }
                        }
                      },
                      WebvttDestinationSettings: {
                        locationName: "webvttDestinationSettings",
                        type: "structure",
                        members: {
                          StyleControl: {
                            locationName: "styleControl"
                          }
                        }
                      }
                    }
                  },
                  LanguageCode: {
                    locationName: "languageCode"
                  },
                  LanguageDescription: {
                    locationName: "languageDescription"
                  },
                  Name: {
                    locationName: "name"
                  }
                },
                required: [
                  "CaptionSelectorName",
                  "Name"
                ]
              }
            },
            FeatureActivations: {
              locationName: "featureActivations",
              type: "structure",
              members: {
                InputPrepareScheduleActions: {
                  locationName: "inputPrepareScheduleActions"
                },
                OutputStaticImageOverlayScheduleActions: {
                  locationName: "outputStaticImageOverlayScheduleActions"
                }
              }
            },
            GlobalConfiguration: {
              locationName: "globalConfiguration",
              type: "structure",
              members: {
                InitialAudioGain: {
                  locationName: "initialAudioGain",
                  type: "integer"
                },
                InputEndAction: {
                  locationName: "inputEndAction"
                },
                InputLossBehavior: {
                  locationName: "inputLossBehavior",
                  type: "structure",
                  members: {
                    BlackFrameMsec: {
                      locationName: "blackFrameMsec",
                      type: "integer"
                    },
                    InputLossImageColor: {
                      locationName: "inputLossImageColor"
                    },
                    InputLossImageSlate: {
                      shape: "S1m",
                      locationName: "inputLossImageSlate"
                    },
                    InputLossImageType: {
                      locationName: "inputLossImageType"
                    },
                    RepeatFrameMsec: {
                      locationName: "repeatFrameMsec",
                      type: "integer"
                    }
                  }
                },
                OutputLockingMode: {
                  locationName: "outputLockingMode"
                },
                OutputTimingSource: {
                  locationName: "outputTimingSource"
                },
                SupportLowFramerateInputs: {
                  locationName: "supportLowFramerateInputs"
                },
                OutputLockingSettings: {
                  locationName: "outputLockingSettings",
                  type: "structure",
                  members: {
                    EpochLockingSettings: {
                      locationName: "epochLockingSettings",
                      type: "structure",
                      members: {
                        CustomEpoch: {
                          locationName: "customEpoch"
                        },
                        JamSyncTime: {
                          locationName: "jamSyncTime"
                        }
                      }
                    },
                    PipelineLockingSettings: {
                      locationName: "pipelineLockingSettings",
                      type: "structure",
                      members: {}
                    }
                  }
                }
              }
            },
            MotionGraphicsConfiguration: {
              locationName: "motionGraphicsConfiguration",
              type: "structure",
              members: {
                MotionGraphicsInsertion: {
                  locationName: "motionGraphicsInsertion"
                },
                MotionGraphicsSettings: {
                  locationName: "motionGraphicsSettings",
                  type: "structure",
                  members: {
                    HtmlMotionGraphicsSettings: {
                      locationName: "htmlMotionGraphicsSettings",
                      type: "structure",
                      members: {}
                    }
                  }
                }
              },
              required: [
                "MotionGraphicsSettings"
              ]
            },
            NielsenConfiguration: {
              locationName: "nielsenConfiguration",
              type: "structure",
              members: {
                DistributorId: {
                  locationName: "distributorId"
                },
                NielsenPcmToId3Tagging: {
                  locationName: "nielsenPcmToId3Tagging"
                }
              }
            },
            OutputGroups: {
              locationName: "outputGroups",
              type: "list",
              member: {
                type: "structure",
                members: {
                  Name: {
                    locationName: "name"
                  },
                  OutputGroupSettings: {
                    locationName: "outputGroupSettings",
                    type: "structure",
                    members: {
                      ArchiveGroupSettings: {
                        locationName: "archiveGroupSettings",
                        type: "structure",
                        members: {
                          ArchiveCdnSettings: {
                            locationName: "archiveCdnSettings",
                            type: "structure",
                            members: {
                              ArchiveS3Settings: {
                                locationName: "archiveS3Settings",
                                type: "structure",
                                members: {
                                  CannedAcl: {
                                    locationName: "cannedAcl"
                                  }
                                }
                              }
                            }
                          },
                          Destination: {
                            shape: "S6v",
                            locationName: "destination"
                          },
                          RolloverInterval: {
                            locationName: "rolloverInterval",
                            type: "integer"
                          }
                        },
                        required: [
                          "Destination"
                        ]
                      },
                      FrameCaptureGroupSettings: {
                        locationName: "frameCaptureGroupSettings",
                        type: "structure",
                        members: {
                          Destination: {
                            shape: "S6v",
                            locationName: "destination"
                          },
                          FrameCaptureCdnSettings: {
                            locationName: "frameCaptureCdnSettings",
                            type: "structure",
                            members: {
                              FrameCaptureS3Settings: {
                                locationName: "frameCaptureS3Settings",
                                type: "structure",
                                members: {
                                  CannedAcl: {
                                    locationName: "cannedAcl"
                                  }
                                }
                              }
                            }
                          }
                        },
                        required: [
                          "Destination"
                        ]
                      },
                      HlsGroupSettings: {
                        locationName: "hlsGroupSettings",
                        type: "structure",
                        members: {
                          AdMarkers: {
                            locationName: "adMarkers",
                            type: "list",
                            member: {}
                          },
                          BaseUrlContent: {
                            locationName: "baseUrlContent"
                          },
                          BaseUrlContent1: {
                            locationName: "baseUrlContent1"
                          },
                          BaseUrlManifest: {
                            locationName: "baseUrlManifest"
                          },
                          BaseUrlManifest1: {
                            locationName: "baseUrlManifest1"
                          },
                          CaptionLanguageMappings: {
                            locationName: "captionLanguageMappings",
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                CaptionChannel: {
                                  locationName: "captionChannel",
                                  type: "integer"
                                },
                                LanguageCode: {
                                  locationName: "languageCode"
                                },
                                LanguageDescription: {
                                  locationName: "languageDescription"
                                }
                              },
                              required: [
                                "LanguageCode",
                                "LanguageDescription",
                                "CaptionChannel"
                              ]
                            }
                          },
                          CaptionLanguageSetting: {
                            locationName: "captionLanguageSetting"
                          },
                          ClientCache: {
                            locationName: "clientCache"
                          },
                          CodecSpecification: {
                            locationName: "codecSpecification"
                          },
                          ConstantIv: {
                            locationName: "constantIv"
                          },
                          Destination: {
                            shape: "S6v",
                            locationName: "destination"
                          },
                          DirectoryStructure: {
                            locationName: "directoryStructure"
                          },
                          DiscontinuityTags: {
                            locationName: "discontinuityTags"
                          },
                          EncryptionType: {
                            locationName: "encryptionType"
                          },
                          HlsCdnSettings: {
                            locationName: "hlsCdnSettings",
                            type: "structure",
                            members: {
                              HlsAkamaiSettings: {
                                locationName: "hlsAkamaiSettings",
                                type: "structure",
                                members: {
                                  ConnectionRetryInterval: {
                                    locationName: "connectionRetryInterval",
                                    type: "integer"
                                  },
                                  FilecacheDuration: {
                                    locationName: "filecacheDuration",
                                    type: "integer"
                                  },
                                  HttpTransferMode: {
                                    locationName: "httpTransferMode"
                                  },
                                  NumRetries: {
                                    locationName: "numRetries",
                                    type: "integer"
                                  },
                                  RestartDelay: {
                                    locationName: "restartDelay",
                                    type: "integer"
                                  },
                                  Salt: {
                                    locationName: "salt"
                                  },
                                  Token: {
                                    locationName: "token"
                                  }
                                }
                              },
                              HlsBasicPutSettings: {
                                locationName: "hlsBasicPutSettings",
                                type: "structure",
                                members: {
                                  ConnectionRetryInterval: {
                                    locationName: "connectionRetryInterval",
                                    type: "integer"
                                  },
                                  FilecacheDuration: {
                                    locationName: "filecacheDuration",
                                    type: "integer"
                                  },
                                  NumRetries: {
                                    locationName: "numRetries",
                                    type: "integer"
                                  },
                                  RestartDelay: {
                                    locationName: "restartDelay",
                                    type: "integer"
                                  }
                                }
                              },
                              HlsMediaStoreSettings: {
                                locationName: "hlsMediaStoreSettings",
                                type: "structure",
                                members: {
                                  ConnectionRetryInterval: {
                                    locationName: "connectionRetryInterval",
                                    type: "integer"
                                  },
                                  FilecacheDuration: {
                                    locationName: "filecacheDuration",
                                    type: "integer"
                                  },
                                  MediaStoreStorageClass: {
                                    locationName: "mediaStoreStorageClass"
                                  },
                                  NumRetries: {
                                    locationName: "numRetries",
                                    type: "integer"
                                  },
                                  RestartDelay: {
                                    locationName: "restartDelay",
                                    type: "integer"
                                  }
                                }
                              },
                              HlsS3Settings: {
                                locationName: "hlsS3Settings",
                                type: "structure",
                                members: {
                                  CannedAcl: {
                                    locationName: "cannedAcl"
                                  }
                                }
                              },
                              HlsWebdavSettings: {
                                locationName: "hlsWebdavSettings",
                                type: "structure",
                                members: {
                                  ConnectionRetryInterval: {
                                    locationName: "connectionRetryInterval",
                                    type: "integer"
                                  },
                                  FilecacheDuration: {
                                    locationName: "filecacheDuration",
                                    type: "integer"
                                  },
                                  HttpTransferMode: {
                                    locationName: "httpTransferMode"
                                  },
                                  NumRetries: {
                                    locationName: "numRetries",
                                    type: "integer"
                                  },
                                  RestartDelay: {
                                    locationName: "restartDelay",
                                    type: "integer"
                                  }
                                }
                              }
                            }
                          },
                          HlsId3SegmentTagging: {
                            locationName: "hlsId3SegmentTagging"
                          },
                          IFrameOnlyPlaylists: {
                            locationName: "iFrameOnlyPlaylists"
                          },
                          IncompleteSegmentBehavior: {
                            locationName: "incompleteSegmentBehavior"
                          },
                          IndexNSegments: {
                            locationName: "indexNSegments",
                            type: "integer"
                          },
                          InputLossAction: {
                            locationName: "inputLossAction"
                          },
                          IvInManifest: {
                            locationName: "ivInManifest"
                          },
                          IvSource: {
                            locationName: "ivSource"
                          },
                          KeepSegments: {
                            locationName: "keepSegments",
                            type: "integer"
                          },
                          KeyFormat: {
                            locationName: "keyFormat"
                          },
                          KeyFormatVersions: {
                            locationName: "keyFormatVersions"
                          },
                          KeyProviderSettings: {
                            locationName: "keyProviderSettings",
                            type: "structure",
                            members: {
                              StaticKeySettings: {
                                locationName: "staticKeySettings",
                                type: "structure",
                                members: {
                                  KeyProviderServer: {
                                    shape: "S1m",
                                    locationName: "keyProviderServer"
                                  },
                                  StaticKeyValue: {
                                    locationName: "staticKeyValue"
                                  }
                                },
                                required: [
                                  "StaticKeyValue"
                                ]
                              }
                            }
                          },
                          ManifestCompression: {
                            locationName: "manifestCompression"
                          },
                          ManifestDurationFormat: {
                            locationName: "manifestDurationFormat"
                          },
                          MinSegmentLength: {
                            locationName: "minSegmentLength",
                            type: "integer"
                          },
                          Mode: {
                            locationName: "mode"
                          },
                          OutputSelection: {
                            locationName: "outputSelection"
                          },
                          ProgramDateTime: {
                            locationName: "programDateTime"
                          },
                          ProgramDateTimeClock: {
                            locationName: "programDateTimeClock"
                          },
                          ProgramDateTimePeriod: {
                            locationName: "programDateTimePeriod",
                            type: "integer"
                          },
                          RedundantManifest: {
                            locationName: "redundantManifest"
                          },
                          SegmentLength: {
                            locationName: "segmentLength",
                            type: "integer"
                          },
                          SegmentationMode: {
                            locationName: "segmentationMode"
                          },
                          SegmentsPerSubdirectory: {
                            locationName: "segmentsPerSubdirectory",
                            type: "integer"
                          },
                          StreamInfResolution: {
                            locationName: "streamInfResolution"
                          },
                          TimedMetadataId3Frame: {
                            locationName: "timedMetadataId3Frame"
                          },
                          TimedMetadataId3Period: {
                            locationName: "timedMetadataId3Period",
                            type: "integer"
                          },
                          TimestampDeltaMilliseconds: {
                            locationName: "timestampDeltaMilliseconds",
                            type: "integer"
                          },
                          TsFileMode: {
                            locationName: "tsFileMode"
                          }
                        },
                        required: [
                          "Destination"
                        ]
                      },
                      MediaPackageGroupSettings: {
                        locationName: "mediaPackageGroupSettings",
                        type: "structure",
                        members: {
                          Destination: {
                            shape: "S6v",
                            locationName: "destination"
                          }
                        },
                        required: [
                          "Destination"
                        ]
                      },
                      MsSmoothGroupSettings: {
                        locationName: "msSmoothGroupSettings",
                        type: "structure",
                        members: {
                          AcquisitionPointId: {
                            locationName: "acquisitionPointId"
                          },
                          AudioOnlyTimecodeControl: {
                            locationName: "audioOnlyTimecodeControl"
                          },
                          CertificateMode: {
                            locationName: "certificateMode"
                          },
                          ConnectionRetryInterval: {
                            locationName: "connectionRetryInterval",
                            type: "integer"
                          },
                          Destination: {
                            shape: "S6v",
                            locationName: "destination"
                          },
                          EventId: {
                            locationName: "eventId"
                          },
                          EventIdMode: {
                            locationName: "eventIdMode"
                          },
                          EventStopBehavior: {
                            locationName: "eventStopBehavior"
                          },
                          FilecacheDuration: {
                            locationName: "filecacheDuration",
                            type: "integer"
                          },
                          FragmentLength: {
                            locationName: "fragmentLength",
                            type: "integer"
                          },
                          InputLossAction: {
                            locationName: "inputLossAction"
                          },
                          NumRetries: {
                            locationName: "numRetries",
                            type: "integer"
                          },
                          RestartDelay: {
                            locationName: "restartDelay",
                            type: "integer"
                          },
                          SegmentationMode: {
                            locationName: "segmentationMode"
                          },
                          SendDelayMs: {
                            locationName: "sendDelayMs",
                            type: "integer"
                          },
                          SparseTrackType: {
                            locationName: "sparseTrackType"
                          },
                          StreamManifestBehavior: {
                            locationName: "streamManifestBehavior"
                          },
                          TimestampOffset: {
                            locationName: "timestampOffset"
                          },
                          TimestampOffsetMode: {
                            locationName: "timestampOffsetMode"
                          }
                        },
                        required: [
                          "Destination"
                        ]
                      },
                      MultiplexGroupSettings: {
                        locationName: "multiplexGroupSettings",
                        type: "structure",
                        members: {}
                      },
                      RtmpGroupSettings: {
                        locationName: "rtmpGroupSettings",
                        type: "structure",
                        members: {
                          AdMarkers: {
                            locationName: "adMarkers",
                            type: "list",
                            member: {}
                          },
                          AuthenticationScheme: {
                            locationName: "authenticationScheme"
                          },
                          CacheFullBehavior: {
                            locationName: "cacheFullBehavior"
                          },
                          CacheLength: {
                            locationName: "cacheLength",
                            type: "integer"
                          },
                          CaptionData: {
                            locationName: "captionData"
                          },
                          InputLossAction: {
                            locationName: "inputLossAction"
                          },
                          RestartDelay: {
                            locationName: "restartDelay",
                            type: "integer"
                          },
                          IncludeFillerNalUnits: {
                            locationName: "includeFillerNalUnits"
                          }
                        }
                      },
                      UdpGroupSettings: {
                        locationName: "udpGroupSettings",
                        type: "structure",
                        members: {
                          InputLossAction: {
                            locationName: "inputLossAction"
                          },
                          TimedMetadataId3Frame: {
                            locationName: "timedMetadataId3Frame"
                          },
                          TimedMetadataId3Period: {
                            locationName: "timedMetadataId3Period",
                            type: "integer"
                          }
                        }
                      }
                    }
                  },
                  Outputs: {
                    locationName: "outputs",
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        AudioDescriptionNames: {
                          shape: "S5",
                          locationName: "audioDescriptionNames"
                        },
                        CaptionDescriptionNames: {
                          shape: "S5",
                          locationName: "captionDescriptionNames"
                        },
                        OutputName: {
                          locationName: "outputName"
                        },
                        OutputSettings: {
                          locationName: "outputSettings",
                          type: "structure",
                          members: {
                            ArchiveOutputSettings: {
                              locationName: "archiveOutputSettings",
                              type: "structure",
                              members: {
                                ContainerSettings: {
                                  locationName: "containerSettings",
                                  type: "structure",
                                  members: {
                                    M2tsSettings: {
                                      shape: "S93",
                                      locationName: "m2tsSettings"
                                    },
                                    RawSettings: {
                                      locationName: "rawSettings",
                                      type: "structure",
                                      members: {}
                                    }
                                  }
                                },
                                Extension: {
                                  locationName: "extension"
                                },
                                NameModifier: {
                                  locationName: "nameModifier"
                                }
                              },
                              required: [
                                "ContainerSettings"
                              ]
                            },
                            FrameCaptureOutputSettings: {
                              locationName: "frameCaptureOutputSettings",
                              type: "structure",
                              members: {
                                NameModifier: {
                                  locationName: "nameModifier"
                                }
                              }
                            },
                            HlsOutputSettings: {
                              locationName: "hlsOutputSettings",
                              type: "structure",
                              members: {
                                H265PackagingType: {
                                  locationName: "h265PackagingType"
                                },
                                HlsSettings: {
                                  locationName: "hlsSettings",
                                  type: "structure",
                                  members: {
                                    AudioOnlyHlsSettings: {
                                      locationName: "audioOnlyHlsSettings",
                                      type: "structure",
                                      members: {
                                        AudioGroupId: {
                                          locationName: "audioGroupId"
                                        },
                                        AudioOnlyImage: {
                                          shape: "S1m",
                                          locationName: "audioOnlyImage"
                                        },
                                        AudioTrackType: {
                                          locationName: "audioTrackType"
                                        },
                                        SegmentType: {
                                          locationName: "segmentType"
                                        }
                                      }
                                    },
                                    Fmp4HlsSettings: {
                                      locationName: "fmp4HlsSettings",
                                      type: "structure",
                                      members: {
                                        AudioRenditionSets: {
                                          locationName: "audioRenditionSets"
                                        },
                                        NielsenId3Behavior: {
                                          locationName: "nielsenId3Behavior"
                                        },
                                        TimedMetadataBehavior: {
                                          locationName: "timedMetadataBehavior"
                                        }
                                      }
                                    },
                                    FrameCaptureHlsSettings: {
                                      locationName: "frameCaptureHlsSettings",
                                      type: "structure",
                                      members: {}
                                    },
                                    StandardHlsSettings: {
                                      locationName: "standardHlsSettings",
                                      type: "structure",
                                      members: {
                                        AudioRenditionSets: {
                                          locationName: "audioRenditionSets"
                                        },
                                        M3u8Settings: {
                                          locationName: "m3u8Settings",
                                          type: "structure",
                                          members: {
                                            AudioFramesPerPes: {
                                              locationName: "audioFramesPerPes",
                                              type: "integer"
                                            },
                                            AudioPids: {
                                              locationName: "audioPids"
                                            },
                                            EcmPid: {
                                              locationName: "ecmPid"
                                            },
                                            NielsenId3Behavior: {
                                              locationName: "nielsenId3Behavior"
                                            },
                                            PatInterval: {
                                              locationName: "patInterval",
                                              type: "integer"
                                            },
                                            PcrControl: {
                                              locationName: "pcrControl"
                                            },
                                            PcrPeriod: {
                                              locationName: "pcrPeriod",
                                              type: "integer"
                                            },
                                            PcrPid: {
                                              locationName: "pcrPid"
                                            },
                                            PmtInterval: {
                                              locationName: "pmtInterval",
                                              type: "integer"
                                            },
                                            PmtPid: {
                                              locationName: "pmtPid"
                                            },
                                            ProgramNum: {
                                              locationName: "programNum",
                                              type: "integer"
                                            },
                                            Scte35Behavior: {
                                              locationName: "scte35Behavior"
                                            },
                                            Scte35Pid: {
                                              locationName: "scte35Pid"
                                            },
                                            TimedMetadataBehavior: {
                                              locationName: "timedMetadataBehavior"
                                            },
                                            TimedMetadataPid: {
                                              locationName: "timedMetadataPid"
                                            },
                                            TransportStreamId: {
                                              locationName: "transportStreamId",
                                              type: "integer"
                                            },
                                            VideoPid: {
                                              locationName: "videoPid"
                                            },
                                            KlvBehavior: {
                                              locationName: "klvBehavior"
                                            },
                                            KlvDataPids: {
                                              locationName: "klvDataPids"
                                            }
                                          }
                                        }
                                      },
                                      required: [
                                        "M3u8Settings"
                                      ]
                                    }
                                  }
                                },
                                NameModifier: {
                                  locationName: "nameModifier"
                                },
                                SegmentModifier: {
                                  locationName: "segmentModifier"
                                }
                              },
                              required: [
                                "HlsSettings"
                              ]
                            },
                            MediaPackageOutputSettings: {
                              locationName: "mediaPackageOutputSettings",
                              type: "structure",
                              members: {}
                            },
                            MsSmoothOutputSettings: {
                              locationName: "msSmoothOutputSettings",
                              type: "structure",
                              members: {
                                H265PackagingType: {
                                  locationName: "h265PackagingType"
                                },
                                NameModifier: {
                                  locationName: "nameModifier"
                                }
                              }
                            },
                            MultiplexOutputSettings: {
                              locationName: "multiplexOutputSettings",
                              type: "structure",
                              members: {
                                Destination: {
                                  shape: "S6v",
                                  locationName: "destination"
                                }
                              },
                              required: [
                                "Destination"
                              ]
                            },
                            RtmpOutputSettings: {
                              locationName: "rtmpOutputSettings",
                              type: "structure",
                              members: {
                                CertificateMode: {
                                  locationName: "certificateMode"
                                },
                                ConnectionRetryInterval: {
                                  locationName: "connectionRetryInterval",
                                  type: "integer"
                                },
                                Destination: {
                                  shape: "S6v",
                                  locationName: "destination"
                                },
                                NumRetries: {
                                  locationName: "numRetries",
                                  type: "integer"
                                }
                              },
                              required: [
                                "Destination"
                              ]
                            },
                            UdpOutputSettings: {
                              locationName: "udpOutputSettings",
                              type: "structure",
                              members: {
                                BufferMsec: {
                                  locationName: "bufferMsec",
                                  type: "integer"
                                },
                                ContainerSettings: {
                                  locationName: "containerSettings",
                                  type: "structure",
                                  members: {
                                    M2tsSettings: {
                                      shape: "S93",
                                      locationName: "m2tsSettings"
                                    }
                                  }
                                },
                                Destination: {
                                  shape: "S6v",
                                  locationName: "destination"
                                },
                                FecOutputSettings: {
                                  locationName: "fecOutputSettings",
                                  type: "structure",
                                  members: {
                                    ColumnDepth: {
                                      locationName: "columnDepth",
                                      type: "integer"
                                    },
                                    IncludeFec: {
                                      locationName: "includeFec"
                                    },
                                    RowLength: {
                                      locationName: "rowLength",
                                      type: "integer"
                                    }
                                  }
                                }
                              },
                              required: [
                                "Destination",
                                "ContainerSettings"
                              ]
                            }
                          }
                        },
                        VideoDescriptionName: {
                          locationName: "videoDescriptionName"
                        }
                      },
                      required: [
                        "OutputSettings"
                      ]
                    }
                  }
                },
                required: [
                  "Outputs",
                  "OutputGroupSettings"
                ]
              }
            },
            TimecodeConfig: {
              locationName: "timecodeConfig",
              type: "structure",
              members: {
                Source: {
                  locationName: "source"
                },
                SyncThreshold: {
                  locationName: "syncThreshold",
                  type: "integer"
                }
              },
              required: [
                "Source"
              ]
            },
            VideoDescriptions: {
              locationName: "videoDescriptions",
              type: "list",
              member: {
                type: "structure",
                members: {
                  CodecSettings: {
                    locationName: "codecSettings",
                    type: "structure",
                    members: {
                      FrameCaptureSettings: {
                        locationName: "frameCaptureSettings",
                        type: "structure",
                        members: {
                          CaptureInterval: {
                            locationName: "captureInterval",
                            type: "integer"
                          },
                          CaptureIntervalUnits: {
                            locationName: "captureIntervalUnits"
                          },
                          TimecodeBurninSettings: {
                            shape: "Sb6",
                            locationName: "timecodeBurninSettings"
                          }
                        }
                      },
                      H264Settings: {
                        locationName: "h264Settings",
                        type: "structure",
                        members: {
                          AdaptiveQuantization: {
                            locationName: "adaptiveQuantization"
                          },
                          AfdSignaling: {
                            locationName: "afdSignaling"
                          },
                          Bitrate: {
                            locationName: "bitrate",
                            type: "integer"
                          },
                          BufFillPct: {
                            locationName: "bufFillPct",
                            type: "integer"
                          },
                          BufSize: {
                            locationName: "bufSize",
                            type: "integer"
                          },
                          ColorMetadata: {
                            locationName: "colorMetadata"
                          },
                          ColorSpaceSettings: {
                            locationName: "colorSpaceSettings",
                            type: "structure",
                            members: {
                              ColorSpacePassthroughSettings: {
                                shape: "Sbf",
                                locationName: "colorSpacePassthroughSettings"
                              },
                              Rec601Settings: {
                                shape: "Sbg",
                                locationName: "rec601Settings"
                              },
                              Rec709Settings: {
                                shape: "Sbh",
                                locationName: "rec709Settings"
                              }
                            }
                          },
                          EntropyEncoding: {
                            locationName: "entropyEncoding"
                          },
                          FilterSettings: {
                            locationName: "filterSettings",
                            type: "structure",
                            members: {
                              TemporalFilterSettings: {
                                shape: "Sbk",
                                locationName: "temporalFilterSettings"
                              }
                            }
                          },
                          FixedAfd: {
                            locationName: "fixedAfd"
                          },
                          FlickerAq: {
                            locationName: "flickerAq"
                          },
                          ForceFieldPictures: {
                            locationName: "forceFieldPictures"
                          },
                          FramerateControl: {
                            locationName: "framerateControl"
                          },
                          FramerateDenominator: {
                            locationName: "framerateDenominator",
                            type: "integer"
                          },
                          FramerateNumerator: {
                            locationName: "framerateNumerator",
                            type: "integer"
                          },
                          GopBReference: {
                            locationName: "gopBReference"
                          },
                          GopClosedCadence: {
                            locationName: "gopClosedCadence",
                            type: "integer"
                          },
                          GopNumBFrames: {
                            locationName: "gopNumBFrames",
                            type: "integer"
                          },
                          GopSize: {
                            locationName: "gopSize",
                            type: "double"
                          },
                          GopSizeUnits: {
                            locationName: "gopSizeUnits"
                          },
                          Level: {
                            locationName: "level"
                          },
                          LookAheadRateControl: {
                            locationName: "lookAheadRateControl"
                          },
                          MaxBitrate: {
                            locationName: "maxBitrate",
                            type: "integer"
                          },
                          MinIInterval: {
                            locationName: "minIInterval",
                            type: "integer"
                          },
                          NumRefFrames: {
                            locationName: "numRefFrames",
                            type: "integer"
                          },
                          ParControl: {
                            locationName: "parControl"
                          },
                          ParDenominator: {
                            locationName: "parDenominator",
                            type: "integer"
                          },
                          ParNumerator: {
                            locationName: "parNumerator",
                            type: "integer"
                          },
                          Profile: {
                            locationName: "profile"
                          },
                          QualityLevel: {
                            locationName: "qualityLevel"
                          },
                          QvbrQualityLevel: {
                            locationName: "qvbrQualityLevel",
                            type: "integer"
                          },
                          RateControlMode: {
                            locationName: "rateControlMode"
                          },
                          ScanType: {
                            locationName: "scanType"
                          },
                          SceneChangeDetect: {
                            locationName: "sceneChangeDetect"
                          },
                          Slices: {
                            locationName: "slices",
                            type: "integer"
                          },
                          Softness: {
                            locationName: "softness",
                            type: "integer"
                          },
                          SpatialAq: {
                            locationName: "spatialAq"
                          },
                          SubgopLength: {
                            locationName: "subgopLength"
                          },
                          Syntax: {
                            locationName: "syntax"
                          },
                          TemporalAq: {
                            locationName: "temporalAq"
                          },
                          TimecodeInsertion: {
                            locationName: "timecodeInsertion"
                          },
                          TimecodeBurninSettings: {
                            shape: "Sb6",
                            locationName: "timecodeBurninSettings"
                          }
                        }
                      },
                      H265Settings: {
                        locationName: "h265Settings",
                        type: "structure",
                        members: {
                          AdaptiveQuantization: {
                            locationName: "adaptiveQuantization"
                          },
                          AfdSignaling: {
                            locationName: "afdSignaling"
                          },
                          AlternativeTransferFunction: {
                            locationName: "alternativeTransferFunction"
                          },
                          Bitrate: {
                            locationName: "bitrate",
                            type: "integer"
                          },
                          BufSize: {
                            locationName: "bufSize",
                            type: "integer"
                          },
                          ColorMetadata: {
                            locationName: "colorMetadata"
                          },
                          ColorSpaceSettings: {
                            locationName: "colorSpaceSettings",
                            type: "structure",
                            members: {
                              ColorSpacePassthroughSettings: {
                                shape: "Sbf",
                                locationName: "colorSpacePassthroughSettings"
                              },
                              DolbyVision81Settings: {
                                locationName: "dolbyVision81Settings",
                                type: "structure",
                                members: {}
                              },
                              Hdr10Settings: {
                                shape: "Scj",
                                locationName: "hdr10Settings"
                              },
                              Rec601Settings: {
                                shape: "Sbg",
                                locationName: "rec601Settings"
                              },
                              Rec709Settings: {
                                shape: "Sbh",
                                locationName: "rec709Settings"
                              }
                            }
                          },
                          FilterSettings: {
                            locationName: "filterSettings",
                            type: "structure",
                            members: {
                              TemporalFilterSettings: {
                                shape: "Sbk",
                                locationName: "temporalFilterSettings"
                              }
                            }
                          },
                          FixedAfd: {
                            locationName: "fixedAfd"
                          },
                          FlickerAq: {
                            locationName: "flickerAq"
                          },
                          FramerateDenominator: {
                            locationName: "framerateDenominator",
                            type: "integer"
                          },
                          FramerateNumerator: {
                            locationName: "framerateNumerator",
                            type: "integer"
                          },
                          GopClosedCadence: {
                            locationName: "gopClosedCadence",
                            type: "integer"
                          },
                          GopSize: {
                            locationName: "gopSize",
                            type: "double"
                          },
                          GopSizeUnits: {
                            locationName: "gopSizeUnits"
                          },
                          Level: {
                            locationName: "level"
                          },
                          LookAheadRateControl: {
                            locationName: "lookAheadRateControl"
                          },
                          MaxBitrate: {
                            locationName: "maxBitrate",
                            type: "integer"
                          },
                          MinIInterval: {
                            locationName: "minIInterval",
                            type: "integer"
                          },
                          ParDenominator: {
                            locationName: "parDenominator",
                            type: "integer"
                          },
                          ParNumerator: {
                            locationName: "parNumerator",
                            type: "integer"
                          },
                          Profile: {
                            locationName: "profile"
                          },
                          QvbrQualityLevel: {
                            locationName: "qvbrQualityLevel",
                            type: "integer"
                          },
                          RateControlMode: {
                            locationName: "rateControlMode"
                          },
                          ScanType: {
                            locationName: "scanType"
                          },
                          SceneChangeDetect: {
                            locationName: "sceneChangeDetect"
                          },
                          Slices: {
                            locationName: "slices",
                            type: "integer"
                          },
                          Tier: {
                            locationName: "tier"
                          },
                          TimecodeInsertion: {
                            locationName: "timecodeInsertion"
                          },
                          TimecodeBurninSettings: {
                            shape: "Sb6",
                            locationName: "timecodeBurninSettings"
                          }
                        },
                        required: [
                          "FramerateNumerator",
                          "FramerateDenominator"
                        ]
                      },
                      Mpeg2Settings: {
                        locationName: "mpeg2Settings",
                        type: "structure",
                        members: {
                          AdaptiveQuantization: {
                            locationName: "adaptiveQuantization"
                          },
                          AfdSignaling: {
                            locationName: "afdSignaling"
                          },
                          ColorMetadata: {
                            locationName: "colorMetadata"
                          },
                          ColorSpace: {
                            locationName: "colorSpace"
                          },
                          DisplayAspectRatio: {
                            locationName: "displayAspectRatio"
                          },
                          FilterSettings: {
                            locationName: "filterSettings",
                            type: "structure",
                            members: {
                              TemporalFilterSettings: {
                                shape: "Sbk",
                                locationName: "temporalFilterSettings"
                              }
                            }
                          },
                          FixedAfd: {
                            locationName: "fixedAfd"
                          },
                          FramerateDenominator: {
                            locationName: "framerateDenominator",
                            type: "integer"
                          },
                          FramerateNumerator: {
                            locationName: "framerateNumerator",
                            type: "integer"
                          },
                          GopClosedCadence: {
                            locationName: "gopClosedCadence",
                            type: "integer"
                          },
                          GopNumBFrames: {
                            locationName: "gopNumBFrames",
                            type: "integer"
                          },
                          GopSize: {
                            locationName: "gopSize",
                            type: "double"
                          },
                          GopSizeUnits: {
                            locationName: "gopSizeUnits"
                          },
                          ScanType: {
                            locationName: "scanType"
                          },
                          SubgopLength: {
                            locationName: "subgopLength"
                          },
                          TimecodeInsertion: {
                            locationName: "timecodeInsertion"
                          },
                          TimecodeBurninSettings: {
                            shape: "Sb6",
                            locationName: "timecodeBurninSettings"
                          }
                        },
                        required: [
                          "FramerateNumerator",
                          "FramerateDenominator"
                        ]
                      }
                    }
                  },
                  Height: {
                    locationName: "height",
                    type: "integer"
                  },
                  Name: {
                    locationName: "name"
                  },
                  RespondToAfd: {
                    locationName: "respondToAfd"
                  },
                  ScalingBehavior: {
                    locationName: "scalingBehavior"
                  },
                  Sharpness: {
                    locationName: "sharpness",
                    type: "integer"
                  },
                  Width: {
                    locationName: "width",
                    type: "integer"
                  }
                },
                required: [
                  "Name"
                ]
              }
            },
            ThumbnailConfiguration: {
              locationName: "thumbnailConfiguration",
              type: "structure",
              members: {
                State: {
                  locationName: "state"
                }
              },
              required: [
                "State"
              ]
            },
            ColorCorrectionSettings: {
              locationName: "colorCorrectionSettings",
              type: "structure",
              members: {
                GlobalColorCorrections: {
                  locationName: "globalColorCorrections",
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      InputColorSpace: {
                        locationName: "inputColorSpace"
                      },
                      OutputColorSpace: {
                        locationName: "outputColorSpace"
                      },
                      Uri: {
                        locationName: "uri"
                      }
                    },
                    required: [
                      "OutputColorSpace",
                      "InputColorSpace",
                      "Uri"
                    ]
                  }
                }
              },
              required: [
                "GlobalColorCorrections"
              ]
            }
          },
          required: [
            "VideoDescriptions",
            "AudioDescriptions",
            "OutputGroups",
            "TimecodeConfig"
          ]
        },
        S6v: {
          type: "structure",
          members: {
            DestinationRefId: {
              locationName: "destinationRefId"
            }
          }
        },
        S93: {
          type: "structure",
          members: {
            AbsentInputAudioBehavior: {
              locationName: "absentInputAudioBehavior"
            },
            Arib: {
              locationName: "arib"
            },
            AribCaptionsPid: {
              locationName: "aribCaptionsPid"
            },
            AribCaptionsPidControl: {
              locationName: "aribCaptionsPidControl"
            },
            AudioBufferModel: {
              locationName: "audioBufferModel"
            },
            AudioFramesPerPes: {
              locationName: "audioFramesPerPes",
              type: "integer"
            },
            AudioPids: {
              locationName: "audioPids"
            },
            AudioStreamType: {
              locationName: "audioStreamType"
            },
            Bitrate: {
              locationName: "bitrate",
              type: "integer"
            },
            BufferModel: {
              locationName: "bufferModel"
            },
            CcDescriptor: {
              locationName: "ccDescriptor"
            },
            DvbNitSettings: {
              locationName: "dvbNitSettings",
              type: "structure",
              members: {
                NetworkId: {
                  locationName: "networkId",
                  type: "integer"
                },
                NetworkName: {
                  locationName: "networkName"
                },
                RepInterval: {
                  locationName: "repInterval",
                  type: "integer"
                }
              },
              required: [
                "NetworkName",
                "NetworkId"
              ]
            },
            DvbSdtSettings: {
              locationName: "dvbSdtSettings",
              type: "structure",
              members: {
                OutputSdt: {
                  locationName: "outputSdt"
                },
                RepInterval: {
                  locationName: "repInterval",
                  type: "integer"
                },
                ServiceName: {
                  locationName: "serviceName"
                },
                ServiceProviderName: {
                  locationName: "serviceProviderName"
                }
              }
            },
            DvbSubPids: {
              locationName: "dvbSubPids"
            },
            DvbTdtSettings: {
              locationName: "dvbTdtSettings",
              type: "structure",
              members: {
                RepInterval: {
                  locationName: "repInterval",
                  type: "integer"
                }
              }
            },
            DvbTeletextPid: {
              locationName: "dvbTeletextPid"
            },
            Ebif: {
              locationName: "ebif"
            },
            EbpAudioInterval: {
              locationName: "ebpAudioInterval"
            },
            EbpLookaheadMs: {
              locationName: "ebpLookaheadMs",
              type: "integer"
            },
            EbpPlacement: {
              locationName: "ebpPlacement"
            },
            EcmPid: {
              locationName: "ecmPid"
            },
            EsRateInPes: {
              locationName: "esRateInPes"
            },
            EtvPlatformPid: {
              locationName: "etvPlatformPid"
            },
            EtvSignalPid: {
              locationName: "etvSignalPid"
            },
            FragmentTime: {
              locationName: "fragmentTime",
              type: "double"
            },
            Klv: {
              locationName: "klv"
            },
            KlvDataPids: {
              locationName: "klvDataPids"
            },
            NielsenId3Behavior: {
              locationName: "nielsenId3Behavior"
            },
            NullPacketBitrate: {
              locationName: "nullPacketBitrate",
              type: "double"
            },
            PatInterval: {
              locationName: "patInterval",
              type: "integer"
            },
            PcrControl: {
              locationName: "pcrControl"
            },
            PcrPeriod: {
              locationName: "pcrPeriod",
              type: "integer"
            },
            PcrPid: {
              locationName: "pcrPid"
            },
            PmtInterval: {
              locationName: "pmtInterval",
              type: "integer"
            },
            PmtPid: {
              locationName: "pmtPid"
            },
            ProgramNum: {
              locationName: "programNum",
              type: "integer"
            },
            RateMode: {
              locationName: "rateMode"
            },
            Scte27Pids: {
              locationName: "scte27Pids"
            },
            Scte35Control: {
              locationName: "scte35Control"
            },
            Scte35Pid: {
              locationName: "scte35Pid"
            },
            SegmentationMarkers: {
              locationName: "segmentationMarkers"
            },
            SegmentationStyle: {
              locationName: "segmentationStyle"
            },
            SegmentationTime: {
              locationName: "segmentationTime",
              type: "double"
            },
            TimedMetadataBehavior: {
              locationName: "timedMetadataBehavior"
            },
            TimedMetadataPid: {
              locationName: "timedMetadataPid"
            },
            TransportStreamId: {
              locationName: "transportStreamId",
              type: "integer"
            },
            VideoPid: {
              locationName: "videoPid"
            },
            Scte35PrerollPullupMilliseconds: {
              locationName: "scte35PrerollPullupMilliseconds",
              type: "double"
            }
          }
        },
        Sb6: {
          type: "structure",
          members: {
            FontSize: {
              locationName: "fontSize"
            },
            Position: {
              locationName: "position"
            },
            Prefix: {
              locationName: "prefix"
            }
          },
          required: [
            "Position",
            "FontSize"
          ]
        },
        Sbf: {
          type: "structure",
          members: {}
        },
        Sbg: {
          type: "structure",
          members: {}
        },
        Sbh: {
          type: "structure",
          members: {}
        },
        Sbk: {
          type: "structure",
          members: {
            PostFilterSharpening: {
              locationName: "postFilterSharpening"
            },
            Strength: {
              locationName: "strength"
            }
          }
        },
        Scj: {
          type: "structure",
          members: {
            MaxCll: {
              locationName: "maxCll",
              type: "integer"
            },
            MaxFall: {
              locationName: "maxFall",
              type: "integer"
            }
          }
        },
        Sdf: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AutomaticInputFailoverSettings: {
                locationName: "automaticInputFailoverSettings",
                type: "structure",
                members: {
                  ErrorClearTimeMsec: {
                    locationName: "errorClearTimeMsec",
                    type: "integer"
                  },
                  FailoverConditions: {
                    locationName: "failoverConditions",
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        FailoverConditionSettings: {
                          locationName: "failoverConditionSettings",
                          type: "structure",
                          members: {
                            AudioSilenceSettings: {
                              locationName: "audioSilenceSettings",
                              type: "structure",
                              members: {
                                AudioSelectorName: {
                                  locationName: "audioSelectorName"
                                },
                                AudioSilenceThresholdMsec: {
                                  locationName: "audioSilenceThresholdMsec",
                                  type: "integer"
                                }
                              },
                              required: [
                                "AudioSelectorName"
                              ]
                            },
                            InputLossSettings: {
                              locationName: "inputLossSettings",
                              type: "structure",
                              members: {
                                InputLossThresholdMsec: {
                                  locationName: "inputLossThresholdMsec",
                                  type: "integer"
                                }
                              }
                            },
                            VideoBlackSettings: {
                              locationName: "videoBlackSettings",
                              type: "structure",
                              members: {
                                BlackDetectThreshold: {
                                  locationName: "blackDetectThreshold",
                                  type: "double"
                                },
                                VideoBlackThresholdMsec: {
                                  locationName: "videoBlackThresholdMsec",
                                  type: "integer"
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  },
                  InputPreference: {
                    locationName: "inputPreference"
                  },
                  SecondaryInputId: {
                    locationName: "secondaryInputId"
                  }
                },
                required: [
                  "SecondaryInputId"
                ]
              },
              InputAttachmentName: {
                locationName: "inputAttachmentName"
              },
              InputId: {
                locationName: "inputId"
              },
              InputSettings: {
                locationName: "inputSettings",
                type: "structure",
                members: {
                  AudioSelectors: {
                    locationName: "audioSelectors",
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {
                          locationName: "name"
                        },
                        SelectorSettings: {
                          locationName: "selectorSettings",
                          type: "structure",
                          members: {
                            AudioHlsRenditionSelection: {
                              locationName: "audioHlsRenditionSelection",
                              type: "structure",
                              members: {
                                GroupId: {
                                  locationName: "groupId"
                                },
                                Name: {
                                  locationName: "name"
                                }
                              },
                              required: [
                                "Name",
                                "GroupId"
                              ]
                            },
                            AudioLanguageSelection: {
                              locationName: "audioLanguageSelection",
                              type: "structure",
                              members: {
                                LanguageCode: {
                                  locationName: "languageCode"
                                },
                                LanguageSelectionPolicy: {
                                  locationName: "languageSelectionPolicy"
                                }
                              },
                              required: [
                                "LanguageCode"
                              ]
                            },
                            AudioPidSelection: {
                              locationName: "audioPidSelection",
                              type: "structure",
                              members: {
                                Pid: {
                                  locationName: "pid",
                                  type: "integer"
                                }
                              },
                              required: [
                                "Pid"
                              ]
                            },
                            AudioTrackSelection: {
                              locationName: "audioTrackSelection",
                              type: "structure",
                              members: {
                                Tracks: {
                                  locationName: "tracks",
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      Track: {
                                        locationName: "track",
                                        type: "integer"
                                      }
                                    },
                                    required: [
                                      "Track"
                                    ]
                                  }
                                },
                                DolbyEDecode: {
                                  locationName: "dolbyEDecode",
                                  type: "structure",
                                  members: {
                                    ProgramSelection: {
                                      locationName: "programSelection"
                                    }
                                  },
                                  required: [
                                    "ProgramSelection"
                                  ]
                                }
                              },
                              required: [
                                "Tracks"
                              ]
                            }
                          }
                        }
                      },
                      required: [
                        "Name"
                      ]
                    }
                  },
                  CaptionSelectors: {
                    locationName: "captionSelectors",
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        LanguageCode: {
                          locationName: "languageCode"
                        },
                        Name: {
                          locationName: "name"
                        },
                        SelectorSettings: {
                          locationName: "selectorSettings",
                          type: "structure",
                          members: {
                            AncillarySourceSettings: {
                              locationName: "ancillarySourceSettings",
                              type: "structure",
                              members: {
                                SourceAncillaryChannelNumber: {
                                  locationName: "sourceAncillaryChannelNumber",
                                  type: "integer"
                                }
                              }
                            },
                            AribSourceSettings: {
                              locationName: "aribSourceSettings",
                              type: "structure",
                              members: {}
                            },
                            DvbSubSourceSettings: {
                              locationName: "dvbSubSourceSettings",
                              type: "structure",
                              members: {
                                OcrLanguage: {
                                  locationName: "ocrLanguage"
                                },
                                Pid: {
                                  locationName: "pid",
                                  type: "integer"
                                }
                              }
                            },
                            EmbeddedSourceSettings: {
                              locationName: "embeddedSourceSettings",
                              type: "structure",
                              members: {
                                Convert608To708: {
                                  locationName: "convert608To708"
                                },
                                Scte20Detection: {
                                  locationName: "scte20Detection"
                                },
                                Source608ChannelNumber: {
                                  locationName: "source608ChannelNumber",
                                  type: "integer"
                                },
                                Source608TrackNumber: {
                                  locationName: "source608TrackNumber",
                                  type: "integer"
                                }
                              }
                            },
                            Scte20SourceSettings: {
                              locationName: "scte20SourceSettings",
                              type: "structure",
                              members: {
                                Convert608To708: {
                                  locationName: "convert608To708"
                                },
                                Source608ChannelNumber: {
                                  locationName: "source608ChannelNumber",
                                  type: "integer"
                                }
                              }
                            },
                            Scte27SourceSettings: {
                              locationName: "scte27SourceSettings",
                              type: "structure",
                              members: {
                                OcrLanguage: {
                                  locationName: "ocrLanguage"
                                },
                                Pid: {
                                  locationName: "pid",
                                  type: "integer"
                                }
                              }
                            },
                            TeletextSourceSettings: {
                              locationName: "teletextSourceSettings",
                              type: "structure",
                              members: {
                                OutputRectangle: {
                                  locationName: "outputRectangle",
                                  type: "structure",
                                  members: {
                                    Height: {
                                      locationName: "height",
                                      type: "double"
                                    },
                                    LeftOffset: {
                                      locationName: "leftOffset",
                                      type: "double"
                                    },
                                    TopOffset: {
                                      locationName: "topOffset",
                                      type: "double"
                                    },
                                    Width: {
                                      locationName: "width",
                                      type: "double"
                                    }
                                  },
                                  required: [
                                    "TopOffset",
                                    "Height",
                                    "Width",
                                    "LeftOffset"
                                  ]
                                },
                                PageNumber: {
                                  locationName: "pageNumber"
                                }
                              }
                            }
                          }
                        }
                      },
                      required: [
                        "Name"
                      ]
                    }
                  },
                  DeblockFilter: {
                    locationName: "deblockFilter"
                  },
                  DenoiseFilter: {
                    locationName: "denoiseFilter"
                  },
                  FilterStrength: {
                    locationName: "filterStrength",
                    type: "integer"
                  },
                  InputFilter: {
                    locationName: "inputFilter"
                  },
                  NetworkInputSettings: {
                    locationName: "networkInputSettings",
                    type: "structure",
                    members: {
                      HlsInputSettings: {
                        locationName: "hlsInputSettings",
                        type: "structure",
                        members: {
                          Bandwidth: {
                            locationName: "bandwidth",
                            type: "integer"
                          },
                          BufferSegments: {
                            locationName: "bufferSegments",
                            type: "integer"
                          },
                          Retries: {
                            locationName: "retries",
                            type: "integer"
                          },
                          RetryInterval: {
                            locationName: "retryInterval",
                            type: "integer"
                          },
                          Scte35Source: {
                            locationName: "scte35Source"
                          }
                        }
                      },
                      ServerValidation: {
                        locationName: "serverValidation"
                      }
                    }
                  },
                  Scte35Pid: {
                    locationName: "scte35Pid",
                    type: "integer"
                  },
                  Smpte2038DataPreference: {
                    locationName: "smpte2038DataPreference"
                  },
                  SourceEndBehavior: {
                    locationName: "sourceEndBehavior"
                  },
                  VideoSelector: {
                    locationName: "videoSelector",
                    type: "structure",
                    members: {
                      ColorSpace: {
                        locationName: "colorSpace"
                      },
                      ColorSpaceSettings: {
                        locationName: "colorSpaceSettings",
                        type: "structure",
                        members: {
                          Hdr10Settings: {
                            shape: "Scj",
                            locationName: "hdr10Settings"
                          }
                        }
                      },
                      ColorSpaceUsage: {
                        locationName: "colorSpaceUsage"
                      },
                      SelectorSettings: {
                        locationName: "selectorSettings",
                        type: "structure",
                        members: {
                          VideoSelectorPid: {
                            locationName: "videoSelectorPid",
                            type: "structure",
                            members: {
                              Pid: {
                                locationName: "pid",
                                type: "integer"
                              }
                            }
                          },
                          VideoSelectorProgramId: {
                            locationName: "videoSelectorProgramId",
                            type: "structure",
                            members: {
                              ProgramId: {
                                locationName: "programId",
                                type: "integer"
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sf4: {
          type: "structure",
          members: {
            Codec: {
              locationName: "codec"
            },
            MaximumBitrate: {
              locationName: "maximumBitrate"
            },
            Resolution: {
              locationName: "resolution"
            }
          }
        },
        Sfc: {
          type: "map",
          key: {},
          value: {}
        },
        Sff: {
          type: "structure",
          members: {
            Arn: {
              locationName: "arn"
            },
            CdiInputSpecification: {
              shape: "S27",
              locationName: "cdiInputSpecification"
            },
            ChannelClass: {
              locationName: "channelClass"
            },
            Destinations: {
              shape: "S2a",
              locationName: "destinations"
            },
            EgressEndpoints: {
              shape: "Sfg",
              locationName: "egressEndpoints"
            },
            EncoderSettings: {
              shape: "S2i",
              locationName: "encoderSettings"
            },
            Id: {
              locationName: "id"
            },
            InputAttachments: {
              shape: "Sdf",
              locationName: "inputAttachments"
            },
            InputSpecification: {
              shape: "Sf4",
              locationName: "inputSpecification"
            },
            LogLevel: {
              locationName: "logLevel"
            },
            Maintenance: {
              shape: "Sfi",
              locationName: "maintenance"
            },
            Name: {
              locationName: "name"
            },
            PipelineDetails: {
              shape: "Sfj",
              locationName: "pipelineDetails"
            },
            PipelinesRunningCount: {
              locationName: "pipelinesRunningCount",
              type: "integer"
            },
            RoleArn: {
              locationName: "roleArn"
            },
            State: {
              locationName: "state"
            },
            Tags: {
              shape: "Sfc",
              locationName: "tags"
            },
            Vpc: {
              shape: "Sfm",
              locationName: "vpc"
            }
          }
        },
        Sfg: {
          type: "list",
          member: {
            type: "structure",
            members: {
              SourceIp: {
                locationName: "sourceIp"
              }
            }
          }
        },
        Sfi: {
          type: "structure",
          members: {
            MaintenanceDay: {
              locationName: "maintenanceDay"
            },
            MaintenanceDeadline: {
              locationName: "maintenanceDeadline"
            },
            MaintenanceScheduledDate: {
              locationName: "maintenanceScheduledDate"
            },
            MaintenanceStartTime: {
              locationName: "maintenanceStartTime"
            }
          }
        },
        Sfj: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ActiveInputAttachmentName: {
                locationName: "activeInputAttachmentName"
              },
              ActiveInputSwitchActionName: {
                locationName: "activeInputSwitchActionName"
              },
              ActiveMotionGraphicsActionName: {
                locationName: "activeMotionGraphicsActionName"
              },
              ActiveMotionGraphicsUri: {
                locationName: "activeMotionGraphicsUri"
              },
              PipelineId: {
                locationName: "pipelineId"
              }
            }
          }
        },
        Sfm: {
          type: "structure",
          members: {
            AvailabilityZones: {
              shape: "S5",
              locationName: "availabilityZones"
            },
            NetworkInterfaceIds: {
              shape: "S5",
              locationName: "networkInterfaceIds"
            },
            SecurityGroupIds: {
              shape: "S5",
              locationName: "securityGroupIds"
            },
            SubnetIds: {
              shape: "S5",
              locationName: "subnetIds"
            }
          }
        },
        Sfo: {
          type: "list",
          member: {
            type: "structure",
            members: {
              StreamName: {
                locationName: "streamName"
              }
            }
          }
        },
        Sfq: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Id: {
                locationName: "id"
              }
            }
          }
        },
        Sfs: {
          type: "list",
          member: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              }
            }
          }
        },
        Sfu: {
          type: "list",
          member: {
            type: "structure",
            members: {
              PasswordParam: {
                locationName: "passwordParam"
              },
              Url: {
                locationName: "url"
              },
              Username: {
                locationName: "username"
              }
            }
          }
        },
        Sfz: {
          type: "structure",
          members: {
            Arn: {
              locationName: "arn"
            },
            AttachedChannels: {
              shape: "S5",
              locationName: "attachedChannels"
            },
            Destinations: {
              shape: "Sg0",
              locationName: "destinations"
            },
            Id: {
              locationName: "id"
            },
            InputClass: {
              locationName: "inputClass"
            },
            InputDevices: {
              shape: "Sfq",
              locationName: "inputDevices"
            },
            InputPartnerIds: {
              shape: "S5",
              locationName: "inputPartnerIds"
            },
            InputSourceType: {
              locationName: "inputSourceType"
            },
            MediaConnectFlows: {
              shape: "Sg5",
              locationName: "mediaConnectFlows"
            },
            Name: {
              locationName: "name"
            },
            RoleArn: {
              locationName: "roleArn"
            },
            SecurityGroups: {
              shape: "S5",
              locationName: "securityGroups"
            },
            Sources: {
              shape: "Sg7",
              locationName: "sources"
            },
            State: {
              locationName: "state"
            },
            Tags: {
              shape: "Sfc",
              locationName: "tags"
            },
            Type: {
              locationName: "type"
            }
          }
        },
        Sg0: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Ip: {
                locationName: "ip"
              },
              Port: {
                locationName: "port"
              },
              Url: {
                locationName: "url"
              },
              Vpc: {
                locationName: "vpc",
                type: "structure",
                members: {
                  AvailabilityZone: {
                    locationName: "availabilityZone"
                  },
                  NetworkInterfaceId: {
                    locationName: "networkInterfaceId"
                  }
                }
              }
            }
          }
        },
        Sg5: {
          type: "list",
          member: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              }
            }
          }
        },
        Sg7: {
          type: "list",
          member: {
            type: "structure",
            members: {
              PasswordParam: {
                locationName: "passwordParam"
              },
              Url: {
                locationName: "url"
              },
              Username: {
                locationName: "username"
              }
            }
          }
        },
        Sgb: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Cidr: {
                locationName: "cidr"
              }
            }
          }
        },
        Sge: {
          type: "structure",
          members: {
            Arn: {
              locationName: "arn"
            },
            Id: {
              locationName: "id"
            },
            Inputs: {
              shape: "S5",
              locationName: "inputs"
            },
            State: {
              locationName: "state"
            },
            Tags: {
              shape: "Sfc",
              locationName: "tags"
            },
            WhitelistRules: {
              shape: "Sgg",
              locationName: "whitelistRules"
            }
          }
        },
        Sgg: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Cidr: {
                locationName: "cidr"
              }
            }
          }
        },
        Sgj: {
          type: "structure",
          members: {
            MaximumVideoBufferDelayMilliseconds: {
              locationName: "maximumVideoBufferDelayMilliseconds",
              type: "integer"
            },
            TransportStreamBitrate: {
              locationName: "transportStreamBitrate",
              type: "integer"
            },
            TransportStreamId: {
              locationName: "transportStreamId",
              type: "integer"
            },
            TransportStreamReservedBitrate: {
              locationName: "transportStreamReservedBitrate",
              type: "integer"
            }
          },
          required: [
            "TransportStreamBitrate",
            "TransportStreamId"
          ]
        },
        Sgo: {
          type: "structure",
          members: {
            Arn: {
              locationName: "arn"
            },
            AvailabilityZones: {
              shape: "S5",
              locationName: "availabilityZones"
            },
            Destinations: {
              shape: "Sgp",
              locationName: "destinations"
            },
            Id: {
              locationName: "id"
            },
            MultiplexSettings: {
              shape: "Sgj",
              locationName: "multiplexSettings"
            },
            Name: {
              locationName: "name"
            },
            PipelinesRunningCount: {
              locationName: "pipelinesRunningCount",
              type: "integer"
            },
            ProgramCount: {
              locationName: "programCount",
              type: "integer"
            },
            State: {
              locationName: "state"
            },
            Tags: {
              shape: "Sfc",
              locationName: "tags"
            }
          }
        },
        Sgp: {
          type: "list",
          member: {
            type: "structure",
            members: {
              MediaConnectSettings: {
                locationName: "mediaConnectSettings",
                type: "structure",
                members: {
                  EntitlementArn: {
                    locationName: "entitlementArn"
                  }
                }
              }
            }
          }
        },
        Sgu: {
          type: "structure",
          members: {
            PreferredChannelPipeline: {
              locationName: "preferredChannelPipeline"
            },
            ProgramNumber: {
              locationName: "programNumber",
              type: "integer"
            },
            ServiceDescriptor: {
              locationName: "serviceDescriptor",
              type: "structure",
              members: {
                ProviderName: {
                  locationName: "providerName"
                },
                ServiceName: {
                  locationName: "serviceName"
                }
              },
              required: [
                "ProviderName",
                "ServiceName"
              ]
            },
            VideoSettings: {
              locationName: "videoSettings",
              type: "structure",
              members: {
                ConstantBitrate: {
                  locationName: "constantBitrate",
                  type: "integer"
                },
                StatmuxSettings: {
                  locationName: "statmuxSettings",
                  type: "structure",
                  members: {
                    MaximumBitrate: {
                      locationName: "maximumBitrate",
                      type: "integer"
                    },
                    MinimumBitrate: {
                      locationName: "minimumBitrate",
                      type: "integer"
                    },
                    Priority: {
                      locationName: "priority",
                      type: "integer"
                    }
                  }
                }
              }
            }
          },
          required: [
            "ProgramNumber"
          ]
        },
        Sh2: {
          type: "structure",
          members: {
            ChannelId: {
              locationName: "channelId"
            },
            MultiplexProgramSettings: {
              shape: "Sgu",
              locationName: "multiplexProgramSettings"
            },
            PacketIdentifiersMap: {
              shape: "Sh3",
              locationName: "packetIdentifiersMap"
            },
            PipelineDetails: {
              shape: "Sh5",
              locationName: "pipelineDetails"
            },
            ProgramName: {
              locationName: "programName"
            }
          }
        },
        Sh3: {
          type: "structure",
          members: {
            AudioPids: {
              shape: "Sh4",
              locationName: "audioPids"
            },
            DvbSubPids: {
              shape: "Sh4",
              locationName: "dvbSubPids"
            },
            DvbTeletextPid: {
              locationName: "dvbTeletextPid",
              type: "integer"
            },
            EtvPlatformPid: {
              locationName: "etvPlatformPid",
              type: "integer"
            },
            EtvSignalPid: {
              locationName: "etvSignalPid",
              type: "integer"
            },
            KlvDataPids: {
              shape: "Sh4",
              locationName: "klvDataPids"
            },
            PcrPid: {
              locationName: "pcrPid",
              type: "integer"
            },
            PmtPid: {
              locationName: "pmtPid",
              type: "integer"
            },
            PrivateMetadataPid: {
              locationName: "privateMetadataPid",
              type: "integer"
            },
            Scte27Pids: {
              shape: "Sh4",
              locationName: "scte27Pids"
            },
            Scte35Pid: {
              locationName: "scte35Pid",
              type: "integer"
            },
            TimedMetadataPid: {
              locationName: "timedMetadataPid",
              type: "integer"
            },
            VideoPid: {
              locationName: "videoPid",
              type: "integer"
            }
          }
        },
        Sh4: {
          type: "list",
          member: {
            type: "integer"
          }
        },
        Sh5: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ActiveChannelPipeline: {
                locationName: "activeChannelPipeline"
              },
              PipelineId: {
                locationName: "pipelineId"
              }
            }
          }
        },
        Sho: {
          type: "structure",
          members: {
            AutomaticRenewal: {
              locationName: "automaticRenewal"
            },
            RenewalCount: {
              locationName: "renewalCount",
              type: "integer"
            }
          }
        },
        Shq: {
          type: "structure",
          members: {
            ChannelClass: {
              locationName: "channelClass"
            },
            Codec: {
              locationName: "codec"
            },
            MaximumBitrate: {
              locationName: "maximumBitrate"
            },
            MaximumFramerate: {
              locationName: "maximumFramerate"
            },
            Resolution: {
              locationName: "resolution"
            },
            ResourceType: {
              locationName: "resourceType"
            },
            SpecialFeature: {
              locationName: "specialFeature"
            },
            VideoQuality: {
              locationName: "videoQuality"
            }
          }
        },
        Si4: {
          type: "structure",
          members: {
            KmsKeyId: {
              locationName: "kmsKeyId"
            }
          }
        },
        Sie: {
          type: "structure",
          members: {
            ActiveInput: {
              locationName: "activeInput"
            },
            ConfiguredInput: {
              locationName: "configuredInput"
            },
            DeviceState: {
              locationName: "deviceState"
            },
            Framerate: {
              locationName: "framerate",
              type: "double"
            },
            Height: {
              locationName: "height",
              type: "integer"
            },
            MaxBitrate: {
              locationName: "maxBitrate",
              type: "integer"
            },
            ScanType: {
              locationName: "scanType"
            },
            Width: {
              locationName: "width",
              type: "integer"
            },
            LatencyMs: {
              locationName: "latencyMs",
              type: "integer"
            }
          }
        },
        Sij: {
          type: "structure",
          members: {
            DnsAddresses: {
              shape: "S5",
              locationName: "dnsAddresses"
            },
            Gateway: {
              locationName: "gateway"
            },
            IpAddress: {
              locationName: "ipAddress"
            },
            IpScheme: {
              locationName: "ipScheme"
            },
            SubnetMask: {
              locationName: "subnetMask"
            }
          }
        },
        Sim: {
          type: "structure",
          members: {
            ActiveInput: {
              locationName: "activeInput"
            },
            ConfiguredInput: {
              locationName: "configuredInput"
            },
            DeviceState: {
              locationName: "deviceState"
            },
            Framerate: {
              locationName: "framerate",
              type: "double"
            },
            Height: {
              locationName: "height",
              type: "integer"
            },
            MaxBitrate: {
              locationName: "maxBitrate",
              type: "integer"
            },
            ScanType: {
              locationName: "scanType"
            },
            Width: {
              locationName: "width",
              type: "integer"
            },
            LatencyMs: {
              locationName: "latencyMs",
              type: "integer"
            },
            Codec: {
              locationName: "codec"
            },
            MediaconnectSettings: {
              locationName: "mediaconnectSettings",
              type: "structure",
              members: {
                FlowArn: {
                  locationName: "flowArn"
                },
                RoleArn: {
                  locationName: "roleArn"
                },
                SecretArn: {
                  locationName: "secretArn"
                },
                SourceName: {
                  locationName: "sourceName"
                }
              }
            },
            AudioChannelPairs: {
              locationName: "audioChannelPairs",
              type: "list",
              member: {
                type: "structure",
                members: {
                  Id: {
                    locationName: "id",
                    type: "integer"
                  },
                  Profile: {
                    locationName: "profile"
                  }
                }
              }
            }
          }
        },
        Skk: {
          type: "structure",
          members: {
            Arn: {
              locationName: "arn"
            },
            Count: {
              locationName: "count",
              type: "integer"
            },
            CurrencyCode: {
              locationName: "currencyCode"
            },
            Duration: {
              locationName: "duration",
              type: "integer"
            },
            DurationUnits: {
              locationName: "durationUnits"
            },
            End: {
              locationName: "end"
            },
            FixedPrice: {
              locationName: "fixedPrice",
              type: "double"
            },
            Name: {
              locationName: "name"
            },
            OfferingDescription: {
              locationName: "offeringDescription"
            },
            OfferingId: {
              locationName: "offeringId"
            },
            OfferingType: {
              locationName: "offeringType"
            },
            Region: {
              locationName: "region"
            },
            RenewalSettings: {
              shape: "Sho",
              locationName: "renewalSettings"
            },
            ReservationId: {
              locationName: "reservationId"
            },
            ResourceSpecification: {
              shape: "Shq",
              locationName: "resourceSpecification"
            },
            Start: {
              locationName: "start"
            },
            State: {
              locationName: "state"
            },
            Tags: {
              shape: "Sfc",
              locationName: "tags"
            },
            UsagePrice: {
              locationName: "usagePrice",
              type: "double"
            }
          }
        },
        Slm: {
          type: "structure",
          members: {
            ConfiguredInput: {
              locationName: "configuredInput"
            },
            MaxBitrate: {
              locationName: "maxBitrate",
              type: "integer"
            },
            LatencyMs: {
              locationName: "latencyMs",
              type: "integer"
            },
            Codec: {
              locationName: "codec"
            },
            MediaconnectSettings: {
              locationName: "mediaconnectSettings",
              type: "structure",
              members: {
                FlowArn: {
                  locationName: "flowArn"
                },
                RoleArn: {
                  locationName: "roleArn"
                },
                SecretArn: {
                  locationName: "secretArn"
                },
                SourceName: {
                  locationName: "sourceName"
                }
              }
            },
            AudioChannelPairs: {
              locationName: "audioChannelPairs",
              type: "list",
              member: {
                type: "structure",
                members: {
                  Id: {
                    locationName: "id",
                    type: "integer"
                  },
                  Profile: {
                    locationName: "profile"
                  }
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/medialive-2017-10-14.paginators.json
var require_medialive_2017_10_14_paginators = __commonJS({
  "node_modules/aws-sdk/apis/medialive-2017-10-14.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeSchedule: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ScheduleActions"
        },
        ListChannels: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Channels"
        },
        ListInputSecurityGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "InputSecurityGroups"
        },
        ListInputs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Inputs"
        },
        ListOfferings: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Offerings"
        },
        ListReservations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Reservations"
        },
        ListMultiplexPrograms: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "MultiplexPrograms"
        },
        ListMultiplexes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Multiplexes"
        },
        ListInputDevices: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "InputDevices"
        },
        ListInputDeviceTransfers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "InputDeviceTransfers"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/medialive-2017-10-14.waiters2.json
var require_medialive_2017_10_14_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/medialive-2017-10-14.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        ChannelCreated: {
          description: "Wait until a channel has been created",
          operation: "DescribeChannel",
          delay: 3,
          maxAttempts: 5,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "State",
              expected: "IDLE"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "State",
              expected: "CREATING"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            },
            {
              state: "failure",
              matcher: "path",
              argument: "State",
              expected: "CREATE_FAILED"
            }
          ]
        },
        ChannelRunning: {
          description: "Wait until a channel is running",
          operation: "DescribeChannel",
          delay: 5,
          maxAttempts: 120,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "State",
              expected: "RUNNING"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "State",
              expected: "STARTING"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            }
          ]
        },
        ChannelStopped: {
          description: "Wait until a channel has is stopped",
          operation: "DescribeChannel",
          delay: 5,
          maxAttempts: 60,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "State",
              expected: "IDLE"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "State",
              expected: "STOPPING"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            }
          ]
        },
        ChannelDeleted: {
          description: "Wait until a channel has been deleted",
          operation: "DescribeChannel",
          delay: 5,
          maxAttempts: 84,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "State",
              expected: "DELETED"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "State",
              expected: "DELETING"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            }
          ]
        },
        InputAttached: {
          description: "Wait until an input has been attached",
          operation: "DescribeInput",
          delay: 5,
          maxAttempts: 20,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "State",
              expected: "ATTACHED"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "State",
              expected: "DETACHED"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            }
          ]
        },
        InputDetached: {
          description: "Wait until an input has been detached",
          operation: "DescribeInput",
          delay: 5,
          maxAttempts: 84,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "State",
              expected: "DETACHED"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "State",
              expected: "CREATING"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "State",
              expected: "ATTACHED"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            }
          ]
        },
        InputDeleted: {
          description: "Wait until an input has been deleted",
          operation: "DescribeInput",
          delay: 5,
          maxAttempts: 20,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "State",
              expected: "DELETED"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "State",
              expected: "DELETING"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            }
          ]
        },
        MultiplexCreated: {
          description: "Wait until a multiplex has been created",
          operation: "DescribeMultiplex",
          delay: 3,
          maxAttempts: 5,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "State",
              expected: "IDLE"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "State",
              expected: "CREATING"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            },
            {
              state: "failure",
              matcher: "path",
              argument: "State",
              expected: "CREATE_FAILED"
            }
          ]
        },
        MultiplexRunning: {
          description: "Wait until a multiplex is running",
          operation: "DescribeMultiplex",
          delay: 5,
          maxAttempts: 120,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "State",
              expected: "RUNNING"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "State",
              expected: "STARTING"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            }
          ]
        },
        MultiplexStopped: {
          description: "Wait until a multiplex has is stopped",
          operation: "DescribeMultiplex",
          delay: 5,
          maxAttempts: 28,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "State",
              expected: "IDLE"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "State",
              expected: "STOPPING"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            }
          ]
        },
        MultiplexDeleted: {
          description: "Wait until a multiplex has been deleted",
          operation: "DescribeMultiplex",
          delay: 5,
          maxAttempts: 20,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "State",
              expected: "DELETED"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "State",
              expected: "DELETING"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/medialive.js
var require_medialive = __commonJS({
  "node_modules/aws-sdk/clients/medialive.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["medialive"] = {};
    AWS2.MediaLive = Service.defineService("medialive", ["2017-10-14"]);
    Object.defineProperty(apiLoader.services["medialive"], "2017-10-14", {
      get: function get() {
        var model = require_medialive_2017_10_14_min();
        model.paginators = require_medialive_2017_10_14_paginators().pagination;
        model.waiters = require_medialive_2017_10_14_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.MediaLive;
  }
});

// node_modules/aws-sdk/apis/mediapackage-2017-10-12.min.json
var require_mediapackage_2017_10_12_min = __commonJS({
  "node_modules/aws-sdk/apis/mediapackage-2017-10-12.min.json"(exports2, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2017-10-12",
        endpointPrefix: "mediapackage",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "MediaPackage",
        serviceFullName: "AWS Elemental MediaPackage",
        serviceId: "MediaPackage",
        signatureVersion: "v4",
        signingName: "mediapackage",
        uid: "mediapackage-2017-10-12"
      },
      operations: {
        ConfigureLogs: {
          http: {
            method: "PUT",
            requestUri: "/channels/{id}/configure_logs",
            responseCode: 200
          },
          input: {
            members: {
              EgressAccessLogs: {
                locationName: "egressAccessLogs",
                shape: "S2"
              },
              Id: {
                location: "uri",
                locationName: "id"
              },
              IngressAccessLogs: {
                locationName: "ingressAccessLogs",
                shape: "S4"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              CreatedAt: {
                locationName: "createdAt"
              },
              Description: {
                locationName: "description"
              },
              EgressAccessLogs: {
                locationName: "egressAccessLogs",
                shape: "S2"
              },
              HlsIngest: {
                locationName: "hlsIngest",
                shape: "S6"
              },
              Id: {
                locationName: "id"
              },
              IngressAccessLogs: {
                locationName: "ingressAccessLogs",
                shape: "S4"
              },
              Tags: {
                locationName: "tags",
                shape: "Sa"
              }
            },
            type: "structure"
          }
        },
        CreateChannel: {
          http: {
            requestUri: "/channels",
            responseCode: 200
          },
          input: {
            members: {
              Description: {
                locationName: "description"
              },
              Id: {
                locationName: "id"
              },
              Tags: {
                locationName: "tags",
                shape: "Sa"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              CreatedAt: {
                locationName: "createdAt"
              },
              Description: {
                locationName: "description"
              },
              EgressAccessLogs: {
                locationName: "egressAccessLogs",
                shape: "S2"
              },
              HlsIngest: {
                locationName: "hlsIngest",
                shape: "S6"
              },
              Id: {
                locationName: "id"
              },
              IngressAccessLogs: {
                locationName: "ingressAccessLogs",
                shape: "S4"
              },
              Tags: {
                locationName: "tags",
                shape: "Sa"
              }
            },
            type: "structure"
          }
        },
        CreateHarvestJob: {
          http: {
            requestUri: "/harvest_jobs",
            responseCode: 200
          },
          input: {
            members: {
              EndTime: {
                locationName: "endTime"
              },
              Id: {
                locationName: "id"
              },
              OriginEndpointId: {
                locationName: "originEndpointId"
              },
              S3Destination: {
                locationName: "s3Destination",
                shape: "Se"
              },
              StartTime: {
                locationName: "startTime"
              }
            },
            required: [
              "S3Destination",
              "EndTime",
              "OriginEndpointId",
              "StartTime",
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              ChannelId: {
                locationName: "channelId"
              },
              CreatedAt: {
                locationName: "createdAt"
              },
              EndTime: {
                locationName: "endTime"
              },
              Id: {
                locationName: "id"
              },
              OriginEndpointId: {
                locationName: "originEndpointId"
              },
              S3Destination: {
                locationName: "s3Destination",
                shape: "Se"
              },
              StartTime: {
                locationName: "startTime"
              },
              Status: {
                locationName: "status"
              }
            },
            type: "structure"
          }
        },
        CreateOriginEndpoint: {
          http: {
            requestUri: "/origin_endpoints",
            responseCode: 200
          },
          input: {
            members: {
              Authorization: {
                locationName: "authorization",
                shape: "Si"
              },
              ChannelId: {
                locationName: "channelId"
              },
              CmafPackage: {
                locationName: "cmafPackage",
                shape: "Sj"
              },
              DashPackage: {
                locationName: "dashPackage",
                shape: "S12"
              },
              Description: {
                locationName: "description"
              },
              HlsPackage: {
                locationName: "hlsPackage",
                shape: "S1a"
              },
              Id: {
                locationName: "id"
              },
              ManifestName: {
                locationName: "manifestName"
              },
              MssPackage: {
                locationName: "mssPackage",
                shape: "S1d"
              },
              Origination: {
                locationName: "origination"
              },
              StartoverWindowSeconds: {
                locationName: "startoverWindowSeconds",
                type: "integer"
              },
              Tags: {
                locationName: "tags",
                shape: "Sa"
              },
              TimeDelaySeconds: {
                locationName: "timeDelaySeconds",
                type: "integer"
              },
              Whitelist: {
                locationName: "whitelist",
                shape: "Sr"
              }
            },
            required: [
              "ChannelId",
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              Authorization: {
                locationName: "authorization",
                shape: "Si"
              },
              ChannelId: {
                locationName: "channelId"
              },
              CmafPackage: {
                locationName: "cmafPackage",
                shape: "S1h"
              },
              CreatedAt: {
                locationName: "createdAt"
              },
              DashPackage: {
                locationName: "dashPackage",
                shape: "S12"
              },
              Description: {
                locationName: "description"
              },
              HlsPackage: {
                locationName: "hlsPackage",
                shape: "S1a"
              },
              Id: {
                locationName: "id"
              },
              ManifestName: {
                locationName: "manifestName"
              },
              MssPackage: {
                locationName: "mssPackage",
                shape: "S1d"
              },
              Origination: {
                locationName: "origination"
              },
              StartoverWindowSeconds: {
                locationName: "startoverWindowSeconds",
                type: "integer"
              },
              Tags: {
                locationName: "tags",
                shape: "Sa"
              },
              TimeDelaySeconds: {
                locationName: "timeDelaySeconds",
                type: "integer"
              },
              Url: {
                locationName: "url"
              },
              Whitelist: {
                locationName: "whitelist",
                shape: "Sr"
              }
            },
            type: "structure"
          }
        },
        DeleteChannel: {
          http: {
            method: "DELETE",
            requestUri: "/channels/{id}",
            responseCode: 202
          },
          input: {
            members: {
              Id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {},
            type: "structure"
          }
        },
        DeleteOriginEndpoint: {
          http: {
            method: "DELETE",
            requestUri: "/origin_endpoints/{id}",
            responseCode: 202
          },
          input: {
            members: {
              Id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {},
            type: "structure"
          }
        },
        DescribeChannel: {
          http: {
            method: "GET",
            requestUri: "/channels/{id}",
            responseCode: 200
          },
          input: {
            members: {
              Id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              CreatedAt: {
                locationName: "createdAt"
              },
              Description: {
                locationName: "description"
              },
              EgressAccessLogs: {
                locationName: "egressAccessLogs",
                shape: "S2"
              },
              HlsIngest: {
                locationName: "hlsIngest",
                shape: "S6"
              },
              Id: {
                locationName: "id"
              },
              IngressAccessLogs: {
                locationName: "ingressAccessLogs",
                shape: "S4"
              },
              Tags: {
                locationName: "tags",
                shape: "Sa"
              }
            },
            type: "structure"
          }
        },
        DescribeHarvestJob: {
          http: {
            method: "GET",
            requestUri: "/harvest_jobs/{id}",
            responseCode: 200
          },
          input: {
            members: {
              Id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              ChannelId: {
                locationName: "channelId"
              },
              CreatedAt: {
                locationName: "createdAt"
              },
              EndTime: {
                locationName: "endTime"
              },
              Id: {
                locationName: "id"
              },
              OriginEndpointId: {
                locationName: "originEndpointId"
              },
              S3Destination: {
                locationName: "s3Destination",
                shape: "Se"
              },
              StartTime: {
                locationName: "startTime"
              },
              Status: {
                locationName: "status"
              }
            },
            type: "structure"
          }
        },
        DescribeOriginEndpoint: {
          http: {
            method: "GET",
            requestUri: "/origin_endpoints/{id}",
            responseCode: 200
          },
          input: {
            members: {
              Id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              Authorization: {
                locationName: "authorization",
                shape: "Si"
              },
              ChannelId: {
                locationName: "channelId"
              },
              CmafPackage: {
                locationName: "cmafPackage",
                shape: "S1h"
              },
              CreatedAt: {
                locationName: "createdAt"
              },
              DashPackage: {
                locationName: "dashPackage",
                shape: "S12"
              },
              Description: {
                locationName: "description"
              },
              HlsPackage: {
                locationName: "hlsPackage",
                shape: "S1a"
              },
              Id: {
                locationName: "id"
              },
              ManifestName: {
                locationName: "manifestName"
              },
              MssPackage: {
                locationName: "mssPackage",
                shape: "S1d"
              },
              Origination: {
                locationName: "origination"
              },
              StartoverWindowSeconds: {
                locationName: "startoverWindowSeconds",
                type: "integer"
              },
              Tags: {
                locationName: "tags",
                shape: "Sa"
              },
              TimeDelaySeconds: {
                locationName: "timeDelaySeconds",
                type: "integer"
              },
              Url: {
                locationName: "url"
              },
              Whitelist: {
                locationName: "whitelist",
                shape: "Sr"
              }
            },
            type: "structure"
          }
        },
        ListChannels: {
          http: {
            method: "GET",
            requestUri: "/channels",
            responseCode: 200
          },
          input: {
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            type: "structure"
          },
          output: {
            members: {
              Channels: {
                locationName: "channels",
                member: {
                  members: {
                    Arn: {
                      locationName: "arn"
                    },
                    CreatedAt: {
                      locationName: "createdAt"
                    },
                    Description: {
                      locationName: "description"
                    },
                    EgressAccessLogs: {
                      locationName: "egressAccessLogs",
                      shape: "S2"
                    },
                    HlsIngest: {
                      locationName: "hlsIngest",
                      shape: "S6"
                    },
                    Id: {
                      locationName: "id"
                    },
                    IngressAccessLogs: {
                      locationName: "ingressAccessLogs",
                      shape: "S4"
                    },
                    Tags: {
                      locationName: "tags",
                      shape: "Sa"
                    }
                  },
                  type: "structure"
                },
                type: "list"
              },
              NextToken: {
                locationName: "nextToken"
              }
            },
            type: "structure"
          }
        },
        ListHarvestJobs: {
          http: {
            method: "GET",
            requestUri: "/harvest_jobs",
            responseCode: 200
          },
          input: {
            members: {
              IncludeChannelId: {
                location: "querystring",
                locationName: "includeChannelId"
              },
              IncludeStatus: {
                location: "querystring",
                locationName: "includeStatus"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            type: "structure"
          },
          output: {
            members: {
              HarvestJobs: {
                locationName: "harvestJobs",
                member: {
                  members: {
                    Arn: {
                      locationName: "arn"
                    },
                    ChannelId: {
                      locationName: "channelId"
                    },
                    CreatedAt: {
                      locationName: "createdAt"
                    },
                    EndTime: {
                      locationName: "endTime"
                    },
                    Id: {
                      locationName: "id"
                    },
                    OriginEndpointId: {
                      locationName: "originEndpointId"
                    },
                    S3Destination: {
                      locationName: "s3Destination",
                      shape: "Se"
                    },
                    StartTime: {
                      locationName: "startTime"
                    },
                    Status: {
                      locationName: "status"
                    }
                  },
                  type: "structure"
                },
                type: "list"
              },
              NextToken: {
                locationName: "nextToken"
              }
            },
            type: "structure"
          }
        },
        ListOriginEndpoints: {
          http: {
            method: "GET",
            requestUri: "/origin_endpoints",
            responseCode: 200
          },
          input: {
            members: {
              ChannelId: {
                location: "querystring",
                locationName: "channelId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            type: "structure"
          },
          output: {
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              OriginEndpoints: {
                locationName: "originEndpoints",
                member: {
                  members: {
                    Arn: {
                      locationName: "arn"
                    },
                    Authorization: {
                      locationName: "authorization",
                      shape: "Si"
                    },
                    ChannelId: {
                      locationName: "channelId"
                    },
                    CmafPackage: {
                      locationName: "cmafPackage",
                      shape: "S1h"
                    },
                    CreatedAt: {
                      locationName: "createdAt"
                    },
                    DashPackage: {
                      locationName: "dashPackage",
                      shape: "S12"
                    },
                    Description: {
                      locationName: "description"
                    },
                    HlsPackage: {
                      locationName: "hlsPackage",
                      shape: "S1a"
                    },
                    Id: {
                      locationName: "id"
                    },
                    ManifestName: {
                      locationName: "manifestName"
                    },
                    MssPackage: {
                      locationName: "mssPackage",
                      shape: "S1d"
                    },
                    Origination: {
                      locationName: "origination"
                    },
                    StartoverWindowSeconds: {
                      locationName: "startoverWindowSeconds",
                      type: "integer"
                    },
                    Tags: {
                      locationName: "tags",
                      shape: "Sa"
                    },
                    TimeDelaySeconds: {
                      locationName: "timeDelaySeconds",
                      type: "integer"
                    },
                    Url: {
                      locationName: "url"
                    },
                    Whitelist: {
                      locationName: "whitelist",
                      shape: "Sr"
                    }
                  },
                  type: "structure"
                },
                type: "list"
              }
            },
            type: "structure"
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resource-arn}",
            responseCode: 200
          },
          input: {
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              }
            },
            required: [
              "ResourceArn"
            ],
            type: "structure"
          },
          output: {
            members: {
              Tags: {
                locationName: "tags",
                shape: "S29"
              }
            },
            type: "structure"
          }
        },
        RotateChannelCredentials: {
          deprecated: true,
          deprecatedMessage: "This API is deprecated. Please use RotateIngestEndpointCredentials instead",
          http: {
            method: "PUT",
            requestUri: "/channels/{id}/credentials",
            responseCode: 200
          },
          input: {
            deprecated: true,
            members: {
              Id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            deprecated: true,
            members: {
              Arn: {
                locationName: "arn"
              },
              CreatedAt: {
                locationName: "createdAt"
              },
              Description: {
                locationName: "description"
              },
              EgressAccessLogs: {
                locationName: "egressAccessLogs",
                shape: "S2"
              },
              HlsIngest: {
                locationName: "hlsIngest",
                shape: "S6"
              },
              Id: {
                locationName: "id"
              },
              IngressAccessLogs: {
                locationName: "ingressAccessLogs",
                shape: "S4"
              },
              Tags: {
                locationName: "tags",
                shape: "Sa"
              }
            },
            type: "structure"
          }
        },
        RotateIngestEndpointCredentials: {
          http: {
            method: "PUT",
            requestUri: "/channels/{id}/ingest_endpoints/{ingest_endpoint_id}/credentials",
            responseCode: 200
          },
          input: {
            members: {
              Id: {
                location: "uri",
                locationName: "id"
              },
              IngestEndpointId: {
                location: "uri",
                locationName: "ingest_endpoint_id"
              }
            },
            required: [
              "IngestEndpointId",
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              CreatedAt: {
                locationName: "createdAt"
              },
              Description: {
                locationName: "description"
              },
              EgressAccessLogs: {
                locationName: "egressAccessLogs",
                shape: "S2"
              },
              HlsIngest: {
                locationName: "hlsIngest",
                shape: "S6"
              },
              Id: {
                locationName: "id"
              },
              IngressAccessLogs: {
                locationName: "ingressAccessLogs",
                shape: "S4"
              },
              Tags: {
                locationName: "tags",
                shape: "Sa"
              }
            },
            type: "structure"
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              Tags: {
                locationName: "tags",
                shape: "S29"
              }
            },
            required: [
              "ResourceArn",
              "Tags"
            ],
            type: "structure"
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                shape: "Sr"
              }
            },
            required: [
              "TagKeys",
              "ResourceArn"
            ],
            type: "structure"
          }
        },
        UpdateChannel: {
          http: {
            method: "PUT",
            requestUri: "/channels/{id}",
            responseCode: 200
          },
          input: {
            members: {
              Description: {
                locationName: "description"
              },
              Id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              CreatedAt: {
                locationName: "createdAt"
              },
              Description: {
                locationName: "description"
              },
              EgressAccessLogs: {
                locationName: "egressAccessLogs",
                shape: "S2"
              },
              HlsIngest: {
                locationName: "hlsIngest",
                shape: "S6"
              },
              Id: {
                locationName: "id"
              },
              IngressAccessLogs: {
                locationName: "ingressAccessLogs",
                shape: "S4"
              },
              Tags: {
                locationName: "tags",
                shape: "Sa"
              }
            },
            type: "structure"
          }
        },
        UpdateOriginEndpoint: {
          http: {
            method: "PUT",
            requestUri: "/origin_endpoints/{id}",
            responseCode: 200
          },
          input: {
            members: {
              Authorization: {
                locationName: "authorization",
                shape: "Si"
              },
              CmafPackage: {
                locationName: "cmafPackage",
                shape: "Sj"
              },
              DashPackage: {
                locationName: "dashPackage",
                shape: "S12"
              },
              Description: {
                locationName: "description"
              },
              HlsPackage: {
                locationName: "hlsPackage",
                shape: "S1a"
              },
              Id: {
                location: "uri",
                locationName: "id"
              },
              ManifestName: {
                locationName: "manifestName"
              },
              MssPackage: {
                locationName: "mssPackage",
                shape: "S1d"
              },
              Origination: {
                locationName: "origination"
              },
              StartoverWindowSeconds: {
                locationName: "startoverWindowSeconds",
                type: "integer"
              },
              TimeDelaySeconds: {
                locationName: "timeDelaySeconds",
                type: "integer"
              },
              Whitelist: {
                locationName: "whitelist",
                shape: "Sr"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              Authorization: {
                locationName: "authorization",
                shape: "Si"
              },
              ChannelId: {
                locationName: "channelId"
              },
              CmafPackage: {
                locationName: "cmafPackage",
                shape: "S1h"
              },
              CreatedAt: {
                locationName: "createdAt"
              },
              DashPackage: {
                locationName: "dashPackage",
                shape: "S12"
              },
              Description: {
                locationName: "description"
              },
              HlsPackage: {
                locationName: "hlsPackage",
                shape: "S1a"
              },
              Id: {
                locationName: "id"
              },
              ManifestName: {
                locationName: "manifestName"
              },
              MssPackage: {
                locationName: "mssPackage",
                shape: "S1d"
              },
              Origination: {
                locationName: "origination"
              },
              StartoverWindowSeconds: {
                locationName: "startoverWindowSeconds",
                type: "integer"
              },
              Tags: {
                locationName: "tags",
                shape: "Sa"
              },
              TimeDelaySeconds: {
                locationName: "timeDelaySeconds",
                type: "integer"
              },
              Url: {
                locationName: "url"
              },
              Whitelist: {
                locationName: "whitelist",
                shape: "Sr"
              }
            },
            type: "structure"
          }
        }
      },
      shapes: {
        S2: {
          members: {
            LogGroupName: {
              locationName: "logGroupName"
            }
          },
          type: "structure"
        },
        S4: {
          members: {
            LogGroupName: {
              locationName: "logGroupName"
            }
          },
          type: "structure"
        },
        S6: {
          members: {
            IngestEndpoints: {
              locationName: "ingestEndpoints",
              member: {
                members: {
                  Id: {
                    locationName: "id"
                  },
                  Password: {
                    locationName: "password",
                    shape: "S9"
                  },
                  Url: {
                    locationName: "url"
                  },
                  Username: {
                    locationName: "username",
                    shape: "S9"
                  }
                },
                type: "structure"
              },
              type: "list"
            }
          },
          type: "structure"
        },
        S9: {
          sensitive: true,
          type: "string"
        },
        Sa: {
          key: {},
          type: "map",
          value: {}
        },
        Se: {
          members: {
            BucketName: {
              locationName: "bucketName"
            },
            ManifestKey: {
              locationName: "manifestKey"
            },
            RoleArn: {
              locationName: "roleArn"
            }
          },
          required: [
            "ManifestKey",
            "BucketName",
            "RoleArn"
          ],
          type: "structure"
        },
        Si: {
          members: {
            CdnIdentifierSecret: {
              locationName: "cdnIdentifierSecret"
            },
            SecretsRoleArn: {
              locationName: "secretsRoleArn"
            }
          },
          required: [
            "SecretsRoleArn",
            "CdnIdentifierSecret"
          ],
          type: "structure"
        },
        Sj: {
          members: {
            Encryption: {
              locationName: "encryption",
              shape: "Sk"
            },
            HlsManifests: {
              locationName: "hlsManifests",
              member: {
                members: {
                  AdMarkers: {
                    locationName: "adMarkers"
                  },
                  AdTriggers: {
                    locationName: "adTriggers",
                    shape: "Sv"
                  },
                  AdsOnDeliveryRestrictions: {
                    locationName: "adsOnDeliveryRestrictions"
                  },
                  Id: {
                    locationName: "id"
                  },
                  IncludeIframeOnlyStream: {
                    locationName: "includeIframeOnlyStream",
                    type: "boolean"
                  },
                  ManifestName: {
                    locationName: "manifestName"
                  },
                  PlaylistType: {
                    locationName: "playlistType"
                  },
                  PlaylistWindowSeconds: {
                    locationName: "playlistWindowSeconds",
                    type: "integer"
                  },
                  ProgramDateTimeIntervalSeconds: {
                    locationName: "programDateTimeIntervalSeconds",
                    type: "integer"
                  }
                },
                required: [
                  "Id"
                ],
                type: "structure"
              },
              type: "list"
            },
            SegmentDurationSeconds: {
              locationName: "segmentDurationSeconds",
              type: "integer"
            },
            SegmentPrefix: {
              locationName: "segmentPrefix"
            },
            StreamSelection: {
              locationName: "streamSelection",
              shape: "S10"
            }
          },
          type: "structure"
        },
        Sk: {
          members: {
            ConstantInitializationVector: {
              locationName: "constantInitializationVector"
            },
            EncryptionMethod: {
              locationName: "encryptionMethod"
            },
            KeyRotationIntervalSeconds: {
              locationName: "keyRotationIntervalSeconds",
              type: "integer"
            },
            SpekeKeyProvider: {
              locationName: "spekeKeyProvider",
              shape: "Sn"
            }
          },
          required: [
            "SpekeKeyProvider"
          ],
          type: "structure"
        },
        Sn: {
          members: {
            CertificateArn: {
              locationName: "certificateArn"
            },
            EncryptionContractConfiguration: {
              locationName: "encryptionContractConfiguration",
              members: {
                PresetSpeke20Audio: {
                  locationName: "presetSpeke20Audio"
                },
                PresetSpeke20Video: {
                  locationName: "presetSpeke20Video"
                }
              },
              required: [
                "PresetSpeke20Audio",
                "PresetSpeke20Video"
              ],
              type: "structure"
            },
            ResourceId: {
              locationName: "resourceId"
            },
            RoleArn: {
              locationName: "roleArn"
            },
            SystemIds: {
              locationName: "systemIds",
              shape: "Sr"
            },
            Url: {
              locationName: "url"
            }
          },
          required: [
            "ResourceId",
            "SystemIds",
            "Url",
            "RoleArn"
          ],
          type: "structure"
        },
        Sr: {
          member: {},
          type: "list"
        },
        Sv: {
          member: {},
          type: "list"
        },
        S10: {
          members: {
            MaxVideoBitsPerSecond: {
              locationName: "maxVideoBitsPerSecond",
              type: "integer"
            },
            MinVideoBitsPerSecond: {
              locationName: "minVideoBitsPerSecond",
              type: "integer"
            },
            StreamOrder: {
              locationName: "streamOrder"
            }
          },
          type: "structure"
        },
        S12: {
          members: {
            AdTriggers: {
              locationName: "adTriggers",
              shape: "Sv"
            },
            AdsOnDeliveryRestrictions: {
              locationName: "adsOnDeliveryRestrictions"
            },
            Encryption: {
              locationName: "encryption",
              members: {
                KeyRotationIntervalSeconds: {
                  locationName: "keyRotationIntervalSeconds",
                  type: "integer"
                },
                SpekeKeyProvider: {
                  locationName: "spekeKeyProvider",
                  shape: "Sn"
                }
              },
              required: [
                "SpekeKeyProvider"
              ],
              type: "structure"
            },
            IncludeIframeOnlyStream: {
              locationName: "includeIframeOnlyStream",
              type: "boolean"
            },
            ManifestLayout: {
              locationName: "manifestLayout"
            },
            ManifestWindowSeconds: {
              locationName: "manifestWindowSeconds",
              type: "integer"
            },
            MinBufferTimeSeconds: {
              locationName: "minBufferTimeSeconds",
              type: "integer"
            },
            MinUpdatePeriodSeconds: {
              locationName: "minUpdatePeriodSeconds",
              type: "integer"
            },
            PeriodTriggers: {
              locationName: "periodTriggers",
              member: {},
              type: "list"
            },
            Profile: {
              locationName: "profile"
            },
            SegmentDurationSeconds: {
              locationName: "segmentDurationSeconds",
              type: "integer"
            },
            SegmentTemplateFormat: {
              locationName: "segmentTemplateFormat"
            },
            StreamSelection: {
              locationName: "streamSelection",
              shape: "S10"
            },
            SuggestedPresentationDelaySeconds: {
              locationName: "suggestedPresentationDelaySeconds",
              type: "integer"
            },
            UtcTiming: {
              locationName: "utcTiming"
            },
            UtcTimingUri: {
              locationName: "utcTimingUri"
            }
          },
          type: "structure"
        },
        S1a: {
          members: {
            AdMarkers: {
              locationName: "adMarkers"
            },
            AdTriggers: {
              locationName: "adTriggers",
              shape: "Sv"
            },
            AdsOnDeliveryRestrictions: {
              locationName: "adsOnDeliveryRestrictions"
            },
            Encryption: {
              locationName: "encryption",
              members: {
                ConstantInitializationVector: {
                  locationName: "constantInitializationVector"
                },
                EncryptionMethod: {
                  locationName: "encryptionMethod"
                },
                KeyRotationIntervalSeconds: {
                  locationName: "keyRotationIntervalSeconds",
                  type: "integer"
                },
                RepeatExtXKey: {
                  locationName: "repeatExtXKey",
                  type: "boolean"
                },
                SpekeKeyProvider: {
                  locationName: "spekeKeyProvider",
                  shape: "Sn"
                }
              },
              required: [
                "SpekeKeyProvider"
              ],
              type: "structure"
            },
            IncludeDvbSubtitles: {
              locationName: "includeDvbSubtitles",
              type: "boolean"
            },
            IncludeIframeOnlyStream: {
              locationName: "includeIframeOnlyStream",
              type: "boolean"
            },
            PlaylistType: {
              locationName: "playlistType"
            },
            PlaylistWindowSeconds: {
              locationName: "playlistWindowSeconds",
              type: "integer"
            },
            ProgramDateTimeIntervalSeconds: {
              locationName: "programDateTimeIntervalSeconds",
              type: "integer"
            },
            SegmentDurationSeconds: {
              locationName: "segmentDurationSeconds",
              type: "integer"
            },
            StreamSelection: {
              locationName: "streamSelection",
              shape: "S10"
            },
            UseAudioRenditionGroup: {
              locationName: "useAudioRenditionGroup",
              type: "boolean"
            }
          },
          type: "structure"
        },
        S1d: {
          members: {
            Encryption: {
              locationName: "encryption",
              members: {
                SpekeKeyProvider: {
                  locationName: "spekeKeyProvider",
                  shape: "Sn"
                }
              },
              required: [
                "SpekeKeyProvider"
              ],
              type: "structure"
            },
            ManifestWindowSeconds: {
              locationName: "manifestWindowSeconds",
              type: "integer"
            },
            SegmentDurationSeconds: {
              locationName: "segmentDurationSeconds",
              type: "integer"
            },
            StreamSelection: {
              locationName: "streamSelection",
              shape: "S10"
            }
          },
          type: "structure"
        },
        S1h: {
          members: {
            Encryption: {
              locationName: "encryption",
              shape: "Sk"
            },
            HlsManifests: {
              locationName: "hlsManifests",
              member: {
                members: {
                  AdMarkers: {
                    locationName: "adMarkers"
                  },
                  Id: {
                    locationName: "id"
                  },
                  IncludeIframeOnlyStream: {
                    locationName: "includeIframeOnlyStream",
                    type: "boolean"
                  },
                  ManifestName: {
                    locationName: "manifestName"
                  },
                  PlaylistType: {
                    locationName: "playlistType"
                  },
                  PlaylistWindowSeconds: {
                    locationName: "playlistWindowSeconds",
                    type: "integer"
                  },
                  ProgramDateTimeIntervalSeconds: {
                    locationName: "programDateTimeIntervalSeconds",
                    type: "integer"
                  },
                  Url: {
                    locationName: "url"
                  },
                  AdTriggers: {
                    locationName: "adTriggers",
                    shape: "Sv"
                  },
                  AdsOnDeliveryRestrictions: {
                    locationName: "adsOnDeliveryRestrictions"
                  }
                },
                required: [
                  "Id"
                ],
                type: "structure"
              },
              type: "list"
            },
            SegmentDurationSeconds: {
              locationName: "segmentDurationSeconds",
              type: "integer"
            },
            SegmentPrefix: {
              locationName: "segmentPrefix"
            },
            StreamSelection: {
              locationName: "streamSelection",
              shape: "S10"
            }
          },
          type: "structure"
        },
        S29: {
          key: {},
          type: "map",
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/mediapackage-2017-10-12.paginators.json
var require_mediapackage_2017_10_12_paginators = __commonJS({
  "node_modules/aws-sdk/apis/mediapackage-2017-10-12.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListChannels: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Channels"
        },
        ListOriginEndpoints: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "OriginEndpoints"
        },
        ListHarvestJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "HarvestJobs"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/mediapackage.js
var require_mediapackage = __commonJS({
  "node_modules/aws-sdk/clients/mediapackage.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["mediapackage"] = {};
    AWS2.MediaPackage = Service.defineService("mediapackage", ["2017-10-12"]);
    Object.defineProperty(apiLoader.services["mediapackage"], "2017-10-12", {
      get: function get() {
        var model = require_mediapackage_2017_10_12_min();
        model.paginators = require_mediapackage_2017_10_12_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.MediaPackage;
  }
});

// node_modules/aws-sdk/apis/mediastore-2017-09-01.min.json
var require_mediastore_2017_09_01_min = __commonJS({
  "node_modules/aws-sdk/apis/mediastore-2017-09-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-09-01",
        endpointPrefix: "mediastore",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "MediaStore",
        serviceFullName: "AWS Elemental MediaStore",
        serviceId: "MediaStore",
        signatureVersion: "v4",
        signingName: "mediastore",
        targetPrefix: "MediaStore_20170901",
        uid: "mediastore-2017-09-01"
      },
      operations: {
        CreateContainer: {
          input: {
            type: "structure",
            required: [
              "ContainerName"
            ],
            members: {
              ContainerName: {},
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Container"
            ],
            members: {
              Container: {
                shape: "S8"
              }
            }
          }
        },
        DeleteContainer: {
          input: {
            type: "structure",
            required: [
              "ContainerName"
            ],
            members: {
              ContainerName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteContainerPolicy: {
          input: {
            type: "structure",
            required: [
              "ContainerName"
            ],
            members: {
              ContainerName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteCorsPolicy: {
          input: {
            type: "structure",
            required: [
              "ContainerName"
            ],
            members: {
              ContainerName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteLifecyclePolicy: {
          input: {
            type: "structure",
            required: [
              "ContainerName"
            ],
            members: {
              ContainerName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteMetricPolicy: {
          input: {
            type: "structure",
            required: [
              "ContainerName"
            ],
            members: {
              ContainerName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeContainer: {
          input: {
            type: "structure",
            members: {
              ContainerName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Container: {
                shape: "S8"
              }
            }
          }
        },
        GetContainerPolicy: {
          input: {
            type: "structure",
            required: [
              "ContainerName"
            ],
            members: {
              ContainerName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Policy"
            ],
            members: {
              Policy: {}
            }
          }
        },
        GetCorsPolicy: {
          input: {
            type: "structure",
            required: [
              "ContainerName"
            ],
            members: {
              ContainerName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "CorsPolicy"
            ],
            members: {
              CorsPolicy: {
                shape: "Sv"
              }
            }
          }
        },
        GetLifecyclePolicy: {
          input: {
            type: "structure",
            required: [
              "ContainerName"
            ],
            members: {
              ContainerName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "LifecyclePolicy"
            ],
            members: {
              LifecyclePolicy: {}
            }
          }
        },
        GetMetricPolicy: {
          input: {
            type: "structure",
            required: [
              "ContainerName"
            ],
            members: {
              ContainerName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "MetricPolicy"
            ],
            members: {
              MetricPolicy: {
                shape: "S1a"
              }
            }
          }
        },
        ListContainers: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Containers"
            ],
            members: {
              Containers: {
                type: "list",
                member: {
                  shape: "S8"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "Resource"
            ],
            members: {
              Resource: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S3"
              }
            }
          }
        },
        PutContainerPolicy: {
          input: {
            type: "structure",
            required: [
              "ContainerName",
              "Policy"
            ],
            members: {
              ContainerName: {},
              Policy: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutCorsPolicy: {
          input: {
            type: "structure",
            required: [
              "ContainerName",
              "CorsPolicy"
            ],
            members: {
              ContainerName: {},
              CorsPolicy: {
                shape: "Sv"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutLifecyclePolicy: {
          input: {
            type: "structure",
            required: [
              "ContainerName",
              "LifecyclePolicy"
            ],
            members: {
              ContainerName: {},
              LifecyclePolicy: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutMetricPolicy: {
          input: {
            type: "structure",
            required: [
              "ContainerName",
              "MetricPolicy"
            ],
            members: {
              ContainerName: {},
              MetricPolicy: {
                shape: "S1a"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartAccessLogging: {
          input: {
            type: "structure",
            required: [
              "ContainerName"
            ],
            members: {
              ContainerName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StopAccessLogging: {
          input: {
            type: "structure",
            required: [
              "ContainerName"
            ],
            members: {
              ContainerName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "Resource",
              "Tags"
            ],
            members: {
              Resource: {},
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "Resource",
              "TagKeys"
            ],
            members: {
              Resource: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S8: {
          type: "structure",
          members: {
            Endpoint: {},
            CreationTime: {
              type: "timestamp"
            },
            ARN: {},
            Name: {},
            Status: {},
            AccessLoggingEnabled: {
              type: "boolean"
            }
          }
        },
        Sv: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AllowedOrigins",
              "AllowedHeaders"
            ],
            members: {
              AllowedOrigins: {
                type: "list",
                member: {}
              },
              AllowedMethods: {
                type: "list",
                member: {}
              },
              AllowedHeaders: {
                type: "list",
                member: {}
              },
              MaxAgeSeconds: {
                type: "integer"
              },
              ExposeHeaders: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S1a: {
          type: "structure",
          required: [
            "ContainerLevelMetrics"
          ],
          members: {
            ContainerLevelMetrics: {},
            MetricPolicyRules: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "ObjectGroup",
                  "ObjectGroupName"
                ],
                members: {
                  ObjectGroup: {},
                  ObjectGroupName: {}
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/mediastore-2017-09-01.paginators.json
var require_mediastore_2017_09_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/mediastore-2017-09-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListContainers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/mediastore.js
var require_mediastore = __commonJS({
  "node_modules/aws-sdk/clients/mediastore.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["mediastore"] = {};
    AWS2.MediaStore = Service.defineService("mediastore", ["2017-09-01"]);
    Object.defineProperty(apiLoader.services["mediastore"], "2017-09-01", {
      get: function get() {
        var model = require_mediastore_2017_09_01_min();
        model.paginators = require_mediastore_2017_09_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.MediaStore;
  }
});

// node_modules/aws-sdk/apis/mediastore-data-2017-09-01.min.json
var require_mediastore_data_2017_09_01_min = __commonJS({
  "node_modules/aws-sdk/apis/mediastore-data-2017-09-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-09-01",
        endpointPrefix: "data.mediastore",
        protocol: "rest-json",
        serviceAbbreviation: "MediaStore Data",
        serviceFullName: "AWS Elemental MediaStore Data Plane",
        serviceId: "MediaStore Data",
        signatureVersion: "v4",
        signingName: "mediastore",
        uid: "mediastore-data-2017-09-01"
      },
      operations: {
        DeleteObject: {
          http: {
            method: "DELETE",
            requestUri: "/{Path+}"
          },
          input: {
            type: "structure",
            required: [
              "Path"
            ],
            members: {
              Path: {
                location: "uri",
                locationName: "Path"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeObject: {
          http: {
            method: "HEAD",
            requestUri: "/{Path+}"
          },
          input: {
            type: "structure",
            required: [
              "Path"
            ],
            members: {
              Path: {
                location: "uri",
                locationName: "Path"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ETag: {
                location: "header",
                locationName: "ETag"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              ContentLength: {
                location: "header",
                locationName: "Content-Length",
                type: "long"
              },
              CacheControl: {
                location: "header",
                locationName: "Cache-Control"
              },
              LastModified: {
                location: "header",
                locationName: "Last-Modified",
                type: "timestamp"
              }
            }
          }
        },
        GetObject: {
          http: {
            method: "GET",
            requestUri: "/{Path+}"
          },
          input: {
            type: "structure",
            required: [
              "Path"
            ],
            members: {
              Path: {
                location: "uri",
                locationName: "Path"
              },
              Range: {
                location: "header",
                locationName: "Range"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "StatusCode"
            ],
            members: {
              Body: {
                shape: "Se"
              },
              CacheControl: {
                location: "header",
                locationName: "Cache-Control"
              },
              ContentRange: {
                location: "header",
                locationName: "Content-Range"
              },
              ContentLength: {
                location: "header",
                locationName: "Content-Length",
                type: "long"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              },
              LastModified: {
                location: "header",
                locationName: "Last-Modified",
                type: "timestamp"
              },
              StatusCode: {
                location: "statusCode",
                type: "integer"
              }
            },
            payload: "Body"
          }
        },
        ListItems: {
          http: {
            method: "GET"
          },
          input: {
            type: "structure",
            members: {
              Path: {
                location: "querystring",
                locationName: "Path"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Type: {},
                    ETag: {},
                    LastModified: {
                      type: "timestamp"
                    },
                    ContentType: {},
                    ContentLength: {
                      type: "long"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        PutObject: {
          http: {
            method: "PUT",
            requestUri: "/{Path+}"
          },
          input: {
            type: "structure",
            required: [
              "Body",
              "Path"
            ],
            members: {
              Body: {
                shape: "Se"
              },
              Path: {
                location: "uri",
                locationName: "Path"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              CacheControl: {
                location: "header",
                locationName: "Cache-Control"
              },
              StorageClass: {
                location: "header",
                locationName: "x-amz-storage-class"
              },
              UploadAvailability: {
                location: "header",
                locationName: "x-amz-upload-availability"
              }
            },
            payload: "Body"
          },
          output: {
            type: "structure",
            members: {
              ContentSHA256: {},
              ETag: {},
              StorageClass: {}
            }
          },
          authtype: "v4-unsigned-body"
        }
      },
      shapes: {
        Se: {
          type: "blob",
          streaming: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/mediastore-data-2017-09-01.paginators.json
var require_mediastore_data_2017_09_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/mediastore-data-2017-09-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListItems: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/mediastoredata.js
var require_mediastoredata = __commonJS({
  "node_modules/aws-sdk/clients/mediastoredata.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["mediastoredata"] = {};
    AWS2.MediaStoreData = Service.defineService("mediastoredata", ["2017-09-01"]);
    Object.defineProperty(apiLoader.services["mediastoredata"], "2017-09-01", {
      get: function get() {
        var model = require_mediastore_data_2017_09_01_min();
        model.paginators = require_mediastore_data_2017_09_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.MediaStoreData;
  }
});

// node_modules/aws-sdk/apis/appsync-2017-07-25.min.json
var require_appsync_2017_07_25_min = __commonJS({
  "node_modules/aws-sdk/apis/appsync-2017-07-25.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-07-25",
        endpointPrefix: "appsync",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "AWSAppSync",
        serviceFullName: "AWS AppSync",
        serviceId: "AppSync",
        signatureVersion: "v4",
        signingName: "appsync",
        uid: "appsync-2017-07-25"
      },
      operations: {
        AssociateApi: {
          http: {
            requestUri: "/v1/domainnames/{domainName}/apiassociation"
          },
          input: {
            type: "structure",
            required: [
              "domainName",
              "apiId"
            ],
            members: {
              domainName: {
                location: "uri",
                locationName: "domainName"
              },
              apiId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              apiAssociation: {
                shape: "S5"
              }
            }
          }
        },
        AssociateMergedGraphqlApi: {
          http: {
            requestUri: "/v1/sourceApis/{sourceApiIdentifier}/mergedApiAssociations"
          },
          input: {
            type: "structure",
            required: [
              "sourceApiIdentifier",
              "mergedApiIdentifier"
            ],
            members: {
              sourceApiIdentifier: {
                location: "uri",
                locationName: "sourceApiIdentifier"
              },
              mergedApiIdentifier: {},
              description: {},
              sourceApiAssociationConfig: {
                shape: "S8"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              sourceApiAssociation: {
                shape: "Sb"
              }
            }
          }
        },
        AssociateSourceGraphqlApi: {
          http: {
            requestUri: "/v1/mergedApis/{mergedApiIdentifier}/sourceApiAssociations"
          },
          input: {
            type: "structure",
            required: [
              "mergedApiIdentifier",
              "sourceApiIdentifier"
            ],
            members: {
              mergedApiIdentifier: {
                location: "uri",
                locationName: "mergedApiIdentifier"
              },
              sourceApiIdentifier: {},
              description: {},
              sourceApiAssociationConfig: {
                shape: "S8"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              sourceApiAssociation: {
                shape: "Sb"
              }
            }
          }
        },
        CreateApiCache: {
          http: {
            requestUri: "/v1/apis/{apiId}/ApiCaches"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "ttl",
              "apiCachingBehavior",
              "type"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              ttl: {
                type: "long"
              },
              transitEncryptionEnabled: {
                type: "boolean"
              },
              atRestEncryptionEnabled: {
                type: "boolean"
              },
              apiCachingBehavior: {},
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              apiCache: {
                shape: "Sm"
              }
            }
          }
        },
        CreateApiKey: {
          http: {
            requestUri: "/v1/apis/{apiId}/apikeys"
          },
          input: {
            type: "structure",
            required: [
              "apiId"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              description: {},
              expires: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              apiKey: {
                shape: "Sq"
              }
            }
          }
        },
        CreateDataSource: {
          http: {
            requestUri: "/v1/apis/{apiId}/datasources"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "name",
              "type"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              name: {},
              description: {},
              type: {},
              serviceRoleArn: {},
              dynamodbConfig: {
                shape: "Su"
              },
              lambdaConfig: {
                shape: "Sw"
              },
              elasticsearchConfig: {
                shape: "Sx"
              },
              openSearchServiceConfig: {
                shape: "Sy"
              },
              httpConfig: {
                shape: "Sz"
              },
              relationalDatabaseConfig: {
                shape: "S13"
              },
              eventBridgeConfig: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              dataSource: {
                shape: "S18"
              }
            }
          }
        },
        CreateDomainName: {
          http: {
            requestUri: "/v1/domainnames"
          },
          input: {
            type: "structure",
            required: [
              "domainName",
              "certificateArn"
            ],
            members: {
              domainName: {},
              certificateArn: {},
              description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              domainNameConfig: {
                shape: "S1d"
              }
            }
          }
        },
        CreateFunction: {
          http: {
            requestUri: "/v1/apis/{apiId}/functions"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "name",
              "dataSourceName"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              name: {},
              description: {},
              dataSourceName: {},
              requestMappingTemplate: {},
              responseMappingTemplate: {},
              functionVersion: {},
              syncConfig: {
                shape: "S1g"
              },
              maxBatchSize: {
                type: "integer"
              },
              runtime: {
                shape: "S1l"
              },
              code: {}
            }
          },
          output: {
            type: "structure",
            members: {
              functionConfiguration: {
                shape: "S1p"
              }
            }
          }
        },
        CreateGraphqlApi: {
          http: {
            requestUri: "/v1/apis"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "authenticationType"
            ],
            members: {
              name: {},
              logConfig: {
                shape: "S1r"
              },
              authenticationType: {},
              userPoolConfig: {
                shape: "S1u"
              },
              openIDConnectConfig: {
                shape: "S1w"
              },
              tags: {
                shape: "S1x"
              },
              additionalAuthenticationProviders: {
                shape: "S20"
              },
              xrayEnabled: {
                type: "boolean"
              },
              lambdaAuthorizerConfig: {
                shape: "S23"
              },
              visibility: {},
              apiType: {},
              mergedApiExecutionRoleArn: {},
              ownerContact: {},
              introspectionConfig: {},
              queryDepthLimit: {
                type: "integer"
              },
              resolverCountLimit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              graphqlApi: {
                shape: "S2b"
              }
            }
          }
        },
        CreateResolver: {
          http: {
            requestUri: "/v1/apis/{apiId}/types/{typeName}/resolvers"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "typeName",
              "fieldName"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              typeName: {
                location: "uri",
                locationName: "typeName"
              },
              fieldName: {},
              dataSourceName: {},
              requestMappingTemplate: {},
              responseMappingTemplate: {},
              kind: {},
              pipelineConfig: {
                shape: "S2f"
              },
              syncConfig: {
                shape: "S1g"
              },
              cachingConfig: {
                shape: "S2h"
              },
              maxBatchSize: {
                type: "integer"
              },
              runtime: {
                shape: "S1l"
              },
              code: {}
            }
          },
          output: {
            type: "structure",
            members: {
              resolver: {
                shape: "S2k"
              }
            }
          }
        },
        CreateType: {
          http: {
            requestUri: "/v1/apis/{apiId}/types"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "definition",
              "format"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              definition: {},
              format: {}
            }
          },
          output: {
            type: "structure",
            members: {
              type: {
                shape: "S2o"
              }
            }
          }
        },
        DeleteApiCache: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apis/{apiId}/ApiCaches"
          },
          input: {
            type: "structure",
            required: [
              "apiId"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteApiKey: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apis/{apiId}/apikeys/{id}"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "id"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDataSource: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apis/{apiId}/datasources/{name}"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "name"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDomainName: {
          http: {
            method: "DELETE",
            requestUri: "/v1/domainnames/{domainName}"
          },
          input: {
            type: "structure",
            required: [
              "domainName"
            ],
            members: {
              domainName: {
                location: "uri",
                locationName: "domainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteFunction: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apis/{apiId}/functions/{functionId}"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "functionId"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              functionId: {
                location: "uri",
                locationName: "functionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteGraphqlApi: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apis/{apiId}"
          },
          input: {
            type: "structure",
            required: [
              "apiId"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteResolver: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apis/{apiId}/types/{typeName}/resolvers/{fieldName}"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "typeName",
              "fieldName"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              typeName: {
                location: "uri",
                locationName: "typeName"
              },
              fieldName: {
                location: "uri",
                locationName: "fieldName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteType: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apis/{apiId}/types/{typeName}"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "typeName"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              typeName: {
                location: "uri",
                locationName: "typeName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateApi: {
          http: {
            method: "DELETE",
            requestUri: "/v1/domainnames/{domainName}/apiassociation"
          },
          input: {
            type: "structure",
            required: [
              "domainName"
            ],
            members: {
              domainName: {
                location: "uri",
                locationName: "domainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateMergedGraphqlApi: {
          http: {
            method: "DELETE",
            requestUri: "/v1/sourceApis/{sourceApiIdentifier}/mergedApiAssociations/{associationId}"
          },
          input: {
            type: "structure",
            required: [
              "sourceApiIdentifier",
              "associationId"
            ],
            members: {
              sourceApiIdentifier: {
                location: "uri",
                locationName: "sourceApiIdentifier"
              },
              associationId: {
                location: "uri",
                locationName: "associationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              sourceApiAssociationStatus: {}
            }
          }
        },
        DisassociateSourceGraphqlApi: {
          http: {
            method: "DELETE",
            requestUri: "/v1/mergedApis/{mergedApiIdentifier}/sourceApiAssociations/{associationId}"
          },
          input: {
            type: "structure",
            required: [
              "mergedApiIdentifier",
              "associationId"
            ],
            members: {
              mergedApiIdentifier: {
                location: "uri",
                locationName: "mergedApiIdentifier"
              },
              associationId: {
                location: "uri",
                locationName: "associationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              sourceApiAssociationStatus: {}
            }
          }
        },
        EvaluateCode: {
          http: {
            requestUri: "/v1/dataplane-evaluatecode"
          },
          input: {
            type: "structure",
            required: [
              "runtime",
              "code",
              "context"
            ],
            members: {
              runtime: {
                shape: "S1l"
              },
              code: {},
              context: {},
              function: {}
            }
          },
          output: {
            type: "structure",
            members: {
              evaluationResult: {},
              error: {
                type: "structure",
                members: {
                  message: {},
                  codeErrors: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        errorType: {},
                        value: {},
                        location: {
                          type: "structure",
                          members: {
                            line: {
                              type: "integer"
                            },
                            column: {
                              type: "integer"
                            },
                            span: {
                              type: "integer"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              logs: {
                shape: "S3n"
              }
            }
          }
        },
        EvaluateMappingTemplate: {
          http: {
            requestUri: "/v1/dataplane-evaluatetemplate"
          },
          input: {
            type: "structure",
            required: [
              "template",
              "context"
            ],
            members: {
              template: {},
              context: {}
            }
          },
          output: {
            type: "structure",
            members: {
              evaluationResult: {},
              error: {
                type: "structure",
                members: {
                  message: {}
                }
              },
              logs: {
                shape: "S3n"
              }
            }
          }
        },
        FlushApiCache: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apis/{apiId}/FlushCache"
          },
          input: {
            type: "structure",
            required: [
              "apiId"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetApiAssociation: {
          http: {
            method: "GET",
            requestUri: "/v1/domainnames/{domainName}/apiassociation"
          },
          input: {
            type: "structure",
            required: [
              "domainName"
            ],
            members: {
              domainName: {
                location: "uri",
                locationName: "domainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              apiAssociation: {
                shape: "S5"
              }
            }
          }
        },
        GetApiCache: {
          http: {
            method: "GET",
            requestUri: "/v1/apis/{apiId}/ApiCaches"
          },
          input: {
            type: "structure",
            required: [
              "apiId"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              apiCache: {
                shape: "Sm"
              }
            }
          }
        },
        GetDataSource: {
          http: {
            method: "GET",
            requestUri: "/v1/apis/{apiId}/datasources/{name}"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "name"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              dataSource: {
                shape: "S18"
              }
            }
          }
        },
        GetDataSourceIntrospection: {
          http: {
            method: "GET",
            requestUri: "/v1/datasources/introspections/{introspectionId}"
          },
          input: {
            type: "structure",
            required: [
              "introspectionId"
            ],
            members: {
              introspectionId: {
                location: "uri",
                locationName: "introspectionId"
              },
              includeModelsSDL: {
                location: "querystring",
                locationName: "includeModelsSDL",
                type: "boolean"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              introspectionId: {},
              introspectionStatus: {},
              introspectionStatusDetail: {},
              introspectionResult: {
                type: "structure",
                members: {
                  models: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        name: {},
                        fields: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              name: {},
                              type: {
                                shape: "S4a"
                              },
                              length: {
                                type: "long"
                              }
                            }
                          }
                        },
                        primaryKey: {
                          shape: "S4c"
                        },
                        indexes: {
                          type: "list",
                          member: {
                            shape: "S4c"
                          }
                        },
                        sdl: {}
                      }
                    }
                  },
                  nextToken: {}
                }
              }
            }
          }
        },
        GetDomainName: {
          http: {
            method: "GET",
            requestUri: "/v1/domainnames/{domainName}"
          },
          input: {
            type: "structure",
            required: [
              "domainName"
            ],
            members: {
              domainName: {
                location: "uri",
                locationName: "domainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              domainNameConfig: {
                shape: "S1d"
              }
            }
          }
        },
        GetFunction: {
          http: {
            method: "GET",
            requestUri: "/v1/apis/{apiId}/functions/{functionId}"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "functionId"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              functionId: {
                location: "uri",
                locationName: "functionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              functionConfiguration: {
                shape: "S1p"
              }
            }
          }
        },
        GetGraphqlApi: {
          http: {
            method: "GET",
            requestUri: "/v1/apis/{apiId}"
          },
          input: {
            type: "structure",
            required: [
              "apiId"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              graphqlApi: {
                shape: "S2b"
              }
            }
          }
        },
        GetIntrospectionSchema: {
          http: {
            method: "GET",
            requestUri: "/v1/apis/{apiId}/schema"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "format"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              includeDirectives: {
                location: "querystring",
                locationName: "includeDirectives",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              schema: {
                type: "blob"
              }
            },
            payload: "schema"
          }
        },
        GetResolver: {
          http: {
            method: "GET",
            requestUri: "/v1/apis/{apiId}/types/{typeName}/resolvers/{fieldName}"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "typeName",
              "fieldName"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              typeName: {
                location: "uri",
                locationName: "typeName"
              },
              fieldName: {
                location: "uri",
                locationName: "fieldName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resolver: {
                shape: "S2k"
              }
            }
          }
        },
        GetSchemaCreationStatus: {
          http: {
            method: "GET",
            requestUri: "/v1/apis/{apiId}/schemacreation"
          },
          input: {
            type: "structure",
            required: [
              "apiId"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              status: {},
              details: {}
            }
          }
        },
        GetSourceApiAssociation: {
          http: {
            method: "GET",
            requestUri: "/v1/mergedApis/{mergedApiIdentifier}/sourceApiAssociations/{associationId}"
          },
          input: {
            type: "structure",
            required: [
              "mergedApiIdentifier",
              "associationId"
            ],
            members: {
              mergedApiIdentifier: {
                location: "uri",
                locationName: "mergedApiIdentifier"
              },
              associationId: {
                location: "uri",
                locationName: "associationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              sourceApiAssociation: {
                shape: "Sb"
              }
            }
          }
        },
        GetType: {
          http: {
            method: "GET",
            requestUri: "/v1/apis/{apiId}/types/{typeName}"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "typeName",
              "format"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              typeName: {
                location: "uri",
                locationName: "typeName"
              },
              format: {
                location: "querystring",
                locationName: "format"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              type: {
                shape: "S2o"
              }
            }
          }
        },
        ListApiKeys: {
          http: {
            method: "GET",
            requestUri: "/v1/apis/{apiId}/apikeys"
          },
          input: {
            type: "structure",
            required: [
              "apiId"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              apiKeys: {
                type: "list",
                member: {
                  shape: "Sq"
                }
              },
              nextToken: {}
            }
          }
        },
        ListDataSources: {
          http: {
            method: "GET",
            requestUri: "/v1/apis/{apiId}/datasources"
          },
          input: {
            type: "structure",
            required: [
              "apiId"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              dataSources: {
                type: "list",
                member: {
                  shape: "S18"
                }
              },
              nextToken: {}
            }
          }
        },
        ListDomainNames: {
          http: {
            method: "GET",
            requestUri: "/v1/domainnames"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              domainNameConfigs: {
                type: "list",
                member: {
                  shape: "S1d"
                }
              },
              nextToken: {}
            }
          }
        },
        ListFunctions: {
          http: {
            method: "GET",
            requestUri: "/v1/apis/{apiId}/functions"
          },
          input: {
            type: "structure",
            required: [
              "apiId"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              functions: {
                type: "list",
                member: {
                  shape: "S1p"
                }
              },
              nextToken: {}
            }
          }
        },
        ListGraphqlApis: {
          http: {
            method: "GET",
            requestUri: "/v1/apis"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              apiType: {
                location: "querystring",
                locationName: "apiType"
              },
              owner: {
                location: "querystring",
                locationName: "owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              graphqlApis: {
                type: "list",
                member: {
                  shape: "S2b"
                }
              },
              nextToken: {}
            }
          }
        },
        ListResolvers: {
          http: {
            method: "GET",
            requestUri: "/v1/apis/{apiId}/types/{typeName}/resolvers"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "typeName"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              typeName: {
                location: "uri",
                locationName: "typeName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resolvers: {
                shape: "S5h"
              },
              nextToken: {}
            }
          }
        },
        ListResolversByFunction: {
          http: {
            method: "GET",
            requestUri: "/v1/apis/{apiId}/functions/{functionId}/resolvers"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "functionId"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              functionId: {
                location: "uri",
                locationName: "functionId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resolvers: {
                shape: "S5h"
              },
              nextToken: {}
            }
          }
        },
        ListSourceApiAssociations: {
          http: {
            method: "GET",
            requestUri: "/v1/apis/{apiId}/sourceApiAssociations"
          },
          input: {
            type: "structure",
            required: [
              "apiId"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              sourceApiAssociationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    associationId: {},
                    associationArn: {},
                    sourceApiId: {},
                    sourceApiArn: {},
                    mergedApiId: {},
                    mergedApiArn: {},
                    description: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/v1/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S1x"
              }
            }
          }
        },
        ListTypes: {
          http: {
            method: "GET",
            requestUri: "/v1/apis/{apiId}/types"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "format"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              types: {
                shape: "S5t"
              },
              nextToken: {}
            }
          }
        },
        ListTypesByAssociation: {
          http: {
            method: "GET",
            requestUri: "/v1/mergedApis/{mergedApiIdentifier}/sourceApiAssociations/{associationId}/types"
          },
          input: {
            type: "structure",
            required: [
              "mergedApiIdentifier",
              "associationId",
              "format"
            ],
            members: {
              mergedApiIdentifier: {
                location: "uri",
                locationName: "mergedApiIdentifier"
              },
              associationId: {
                location: "uri",
                locationName: "associationId"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              types: {
                shape: "S5t"
              },
              nextToken: {}
            }
          }
        },
        StartDataSourceIntrospection: {
          http: {
            requestUri: "/v1/datasources/introspections"
          },
          input: {
            type: "structure",
            members: {
              rdsDataApiConfig: {
                type: "structure",
                required: [
                  "resourceArn",
                  "secretArn",
                  "databaseName"
                ],
                members: {
                  resourceArn: {},
                  secretArn: {},
                  databaseName: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              introspectionId: {},
              introspectionStatus: {},
              introspectionStatusDetail: {}
            }
          }
        },
        StartSchemaCreation: {
          http: {
            requestUri: "/v1/apis/{apiId}/schemacreation"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "definition"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              definition: {
                type: "blob"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              status: {}
            }
          }
        },
        StartSchemaMerge: {
          http: {
            requestUri: "/v1/mergedApis/{mergedApiIdentifier}/sourceApiAssociations/{associationId}/merge"
          },
          input: {
            type: "structure",
            required: [
              "associationId",
              "mergedApiIdentifier"
            ],
            members: {
              associationId: {
                location: "uri",
                locationName: "associationId"
              },
              mergedApiIdentifier: {
                location: "uri",
                locationName: "mergedApiIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              sourceApiAssociationStatus: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/v1/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S1x"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/v1/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateApiCache: {
          http: {
            requestUri: "/v1/apis/{apiId}/ApiCaches/update"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "ttl",
              "apiCachingBehavior",
              "type"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              ttl: {
                type: "long"
              },
              apiCachingBehavior: {},
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              apiCache: {
                shape: "Sm"
              }
            }
          }
        },
        UpdateApiKey: {
          http: {
            requestUri: "/v1/apis/{apiId}/apikeys/{id}"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "id"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              id: {
                location: "uri",
                locationName: "id"
              },
              description: {},
              expires: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              apiKey: {
                shape: "Sq"
              }
            }
          }
        },
        UpdateDataSource: {
          http: {
            requestUri: "/v1/apis/{apiId}/datasources/{name}"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "name",
              "type"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              name: {
                location: "uri",
                locationName: "name"
              },
              description: {},
              type: {},
              serviceRoleArn: {},
              dynamodbConfig: {
                shape: "Su"
              },
              lambdaConfig: {
                shape: "Sw"
              },
              elasticsearchConfig: {
                shape: "Sx"
              },
              openSearchServiceConfig: {
                shape: "Sy"
              },
              httpConfig: {
                shape: "Sz"
              },
              relationalDatabaseConfig: {
                shape: "S13"
              },
              eventBridgeConfig: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              dataSource: {
                shape: "S18"
              }
            }
          }
        },
        UpdateDomainName: {
          http: {
            requestUri: "/v1/domainnames/{domainName}"
          },
          input: {
            type: "structure",
            required: [
              "domainName"
            ],
            members: {
              domainName: {
                location: "uri",
                locationName: "domainName"
              },
              description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              domainNameConfig: {
                shape: "S1d"
              }
            }
          }
        },
        UpdateFunction: {
          http: {
            requestUri: "/v1/apis/{apiId}/functions/{functionId}"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "name",
              "functionId",
              "dataSourceName"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              name: {},
              description: {},
              functionId: {
                location: "uri",
                locationName: "functionId"
              },
              dataSourceName: {},
              requestMappingTemplate: {},
              responseMappingTemplate: {},
              functionVersion: {},
              syncConfig: {
                shape: "S1g"
              },
              maxBatchSize: {
                type: "integer"
              },
              runtime: {
                shape: "S1l"
              },
              code: {}
            }
          },
          output: {
            type: "structure",
            members: {
              functionConfiguration: {
                shape: "S1p"
              }
            }
          }
        },
        UpdateGraphqlApi: {
          http: {
            requestUri: "/v1/apis/{apiId}"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "name"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              name: {},
              logConfig: {
                shape: "S1r"
              },
              authenticationType: {},
              userPoolConfig: {
                shape: "S1u"
              },
              openIDConnectConfig: {
                shape: "S1w"
              },
              additionalAuthenticationProviders: {
                shape: "S20"
              },
              xrayEnabled: {
                type: "boolean"
              },
              lambdaAuthorizerConfig: {
                shape: "S23"
              },
              mergedApiExecutionRoleArn: {},
              ownerContact: {},
              introspectionConfig: {},
              queryDepthLimit: {
                type: "integer"
              },
              resolverCountLimit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              graphqlApi: {
                shape: "S2b"
              }
            }
          }
        },
        UpdateResolver: {
          http: {
            requestUri: "/v1/apis/{apiId}/types/{typeName}/resolvers/{fieldName}"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "typeName",
              "fieldName"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              typeName: {
                location: "uri",
                locationName: "typeName"
              },
              fieldName: {
                location: "uri",
                locationName: "fieldName"
              },
              dataSourceName: {},
              requestMappingTemplate: {},
              responseMappingTemplate: {},
              kind: {},
              pipelineConfig: {
                shape: "S2f"
              },
              syncConfig: {
                shape: "S1g"
              },
              cachingConfig: {
                shape: "S2h"
              },
              maxBatchSize: {
                type: "integer"
              },
              runtime: {
                shape: "S1l"
              },
              code: {}
            }
          },
          output: {
            type: "structure",
            members: {
              resolver: {
                shape: "S2k"
              }
            }
          }
        },
        UpdateSourceApiAssociation: {
          http: {
            requestUri: "/v1/mergedApis/{mergedApiIdentifier}/sourceApiAssociations/{associationId}"
          },
          input: {
            type: "structure",
            required: [
              "associationId",
              "mergedApiIdentifier"
            ],
            members: {
              associationId: {
                location: "uri",
                locationName: "associationId"
              },
              mergedApiIdentifier: {
                location: "uri",
                locationName: "mergedApiIdentifier"
              },
              description: {},
              sourceApiAssociationConfig: {
                shape: "S8"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              sourceApiAssociation: {
                shape: "Sb"
              }
            }
          }
        },
        UpdateType: {
          http: {
            requestUri: "/v1/apis/{apiId}/types/{typeName}"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "typeName",
              "format"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              typeName: {
                location: "uri",
                locationName: "typeName"
              },
              definition: {},
              format: {}
            }
          },
          output: {
            type: "structure",
            members: {
              type: {
                shape: "S2o"
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          members: {
            domainName: {},
            apiId: {},
            associationStatus: {},
            deploymentDetail: {}
          }
        },
        S8: {
          type: "structure",
          members: {
            mergeType: {}
          }
        },
        Sb: {
          type: "structure",
          members: {
            associationId: {},
            associationArn: {},
            sourceApiId: {},
            sourceApiArn: {},
            mergedApiArn: {},
            mergedApiId: {},
            description: {},
            sourceApiAssociationConfig: {
              shape: "S8"
            },
            sourceApiAssociationStatus: {},
            sourceApiAssociationStatusDetail: {},
            lastSuccessfulMergeDate: {
              type: "timestamp"
            }
          }
        },
        Sm: {
          type: "structure",
          members: {
            ttl: {
              type: "long"
            },
            apiCachingBehavior: {},
            transitEncryptionEnabled: {
              type: "boolean"
            },
            atRestEncryptionEnabled: {
              type: "boolean"
            },
            type: {},
            status: {}
          }
        },
        Sq: {
          type: "structure",
          members: {
            id: {},
            description: {},
            expires: {
              type: "long"
            },
            deletes: {
              type: "long"
            }
          }
        },
        Su: {
          type: "structure",
          required: [
            "tableName",
            "awsRegion"
          ],
          members: {
            tableName: {},
            awsRegion: {},
            useCallerCredentials: {
              type: "boolean"
            },
            deltaSyncConfig: {
              type: "structure",
              members: {
                baseTableTTL: {
                  type: "long"
                },
                deltaSyncTableName: {},
                deltaSyncTableTTL: {
                  type: "long"
                }
              }
            },
            versioned: {
              type: "boolean"
            }
          }
        },
        Sw: {
          type: "structure",
          required: [
            "lambdaFunctionArn"
          ],
          members: {
            lambdaFunctionArn: {}
          }
        },
        Sx: {
          type: "structure",
          required: [
            "endpoint",
            "awsRegion"
          ],
          members: {
            endpoint: {},
            awsRegion: {}
          }
        },
        Sy: {
          type: "structure",
          required: [
            "endpoint",
            "awsRegion"
          ],
          members: {
            endpoint: {},
            awsRegion: {}
          }
        },
        Sz: {
          type: "structure",
          members: {
            endpoint: {},
            authorizationConfig: {
              type: "structure",
              required: [
                "authorizationType"
              ],
              members: {
                authorizationType: {},
                awsIamConfig: {
                  type: "structure",
                  members: {
                    signingRegion: {},
                    signingServiceName: {}
                  }
                }
              }
            }
          }
        },
        S13: {
          type: "structure",
          members: {
            relationalDatabaseSourceType: {},
            rdsHttpEndpointConfig: {
              type: "structure",
              members: {
                awsRegion: {},
                dbClusterIdentifier: {},
                databaseName: {},
                schema: {},
                awsSecretStoreArn: {}
              }
            }
          }
        },
        S16: {
          type: "structure",
          required: [
            "eventBusArn"
          ],
          members: {
            eventBusArn: {}
          }
        },
        S18: {
          type: "structure",
          members: {
            dataSourceArn: {},
            name: {},
            description: {},
            type: {},
            serviceRoleArn: {},
            dynamodbConfig: {
              shape: "Su"
            },
            lambdaConfig: {
              shape: "Sw"
            },
            elasticsearchConfig: {
              shape: "Sx"
            },
            openSearchServiceConfig: {
              shape: "Sy"
            },
            httpConfig: {
              shape: "Sz"
            },
            relationalDatabaseConfig: {
              shape: "S13"
            },
            eventBridgeConfig: {
              shape: "S16"
            }
          }
        },
        S1d: {
          type: "structure",
          members: {
            domainName: {},
            description: {},
            certificateArn: {},
            appsyncDomainName: {},
            hostedZoneId: {}
          }
        },
        S1g: {
          type: "structure",
          members: {
            conflictHandler: {},
            conflictDetection: {},
            lambdaConflictHandlerConfig: {
              type: "structure",
              members: {
                lambdaConflictHandlerArn: {}
              }
            }
          }
        },
        S1l: {
          type: "structure",
          required: [
            "name",
            "runtimeVersion"
          ],
          members: {
            name: {},
            runtimeVersion: {}
          }
        },
        S1p: {
          type: "structure",
          members: {
            functionId: {},
            functionArn: {},
            name: {},
            description: {},
            dataSourceName: {},
            requestMappingTemplate: {},
            responseMappingTemplate: {},
            functionVersion: {},
            syncConfig: {
              shape: "S1g"
            },
            maxBatchSize: {
              type: "integer"
            },
            runtime: {
              shape: "S1l"
            },
            code: {}
          }
        },
        S1r: {
          type: "structure",
          required: [
            "fieldLogLevel",
            "cloudWatchLogsRoleArn"
          ],
          members: {
            fieldLogLevel: {},
            cloudWatchLogsRoleArn: {},
            excludeVerboseContent: {
              type: "boolean"
            }
          }
        },
        S1u: {
          type: "structure",
          required: [
            "userPoolId",
            "awsRegion",
            "defaultAction"
          ],
          members: {
            userPoolId: {},
            awsRegion: {},
            defaultAction: {},
            appIdClientRegex: {}
          }
        },
        S1w: {
          type: "structure",
          required: [
            "issuer"
          ],
          members: {
            issuer: {},
            clientId: {},
            iatTTL: {
              type: "long"
            },
            authTTL: {
              type: "long"
            }
          }
        },
        S1x: {
          type: "map",
          key: {},
          value: {}
        },
        S20: {
          type: "list",
          member: {
            type: "structure",
            members: {
              authenticationType: {},
              openIDConnectConfig: {
                shape: "S1w"
              },
              userPoolConfig: {
                type: "structure",
                required: [
                  "userPoolId",
                  "awsRegion"
                ],
                members: {
                  userPoolId: {},
                  awsRegion: {},
                  appIdClientRegex: {}
                }
              },
              lambdaAuthorizerConfig: {
                shape: "S23"
              }
            }
          }
        },
        S23: {
          type: "structure",
          required: [
            "authorizerUri"
          ],
          members: {
            authorizerResultTtlInSeconds: {
              type: "integer"
            },
            authorizerUri: {},
            identityValidationExpression: {}
          }
        },
        S2b: {
          type: "structure",
          members: {
            name: {},
            apiId: {},
            authenticationType: {},
            logConfig: {
              shape: "S1r"
            },
            userPoolConfig: {
              shape: "S1u"
            },
            openIDConnectConfig: {
              shape: "S1w"
            },
            arn: {},
            uris: {
              shape: "S2c"
            },
            tags: {
              shape: "S1x"
            },
            additionalAuthenticationProviders: {
              shape: "S20"
            },
            xrayEnabled: {
              type: "boolean"
            },
            wafWebAclArn: {},
            lambdaAuthorizerConfig: {
              shape: "S23"
            },
            dns: {
              shape: "S2c"
            },
            visibility: {},
            apiType: {},
            mergedApiExecutionRoleArn: {},
            owner: {},
            ownerContact: {},
            introspectionConfig: {},
            queryDepthLimit: {
              type: "integer"
            },
            resolverCountLimit: {
              type: "integer"
            }
          }
        },
        S2c: {
          type: "map",
          key: {},
          value: {}
        },
        S2f: {
          type: "structure",
          members: {
            functions: {
              type: "list",
              member: {}
            }
          }
        },
        S2h: {
          type: "structure",
          required: [
            "ttl"
          ],
          members: {
            ttl: {
              type: "long"
            },
            cachingKeys: {
              type: "list",
              member: {}
            }
          }
        },
        S2k: {
          type: "structure",
          members: {
            typeName: {},
            fieldName: {},
            dataSourceName: {},
            resolverArn: {},
            requestMappingTemplate: {},
            responseMappingTemplate: {},
            kind: {},
            pipelineConfig: {
              shape: "S2f"
            },
            syncConfig: {
              shape: "S1g"
            },
            cachingConfig: {
              shape: "S2h"
            },
            maxBatchSize: {
              type: "integer"
            },
            runtime: {
              shape: "S1l"
            },
            code: {}
          }
        },
        S2o: {
          type: "structure",
          members: {
            name: {},
            description: {},
            arn: {},
            definition: {},
            format: {}
          }
        },
        S3n: {
          type: "list",
          member: {}
        },
        S4a: {
          type: "structure",
          members: {
            kind: {},
            name: {},
            type: {
              shape: "S4a"
            },
            values: {
              type: "list",
              member: {}
            }
          }
        },
        S4c: {
          type: "structure",
          members: {
            name: {},
            fields: {
              type: "list",
              member: {}
            }
          }
        },
        S5h: {
          type: "list",
          member: {
            shape: "S2k"
          }
        },
        S5t: {
          type: "list",
          member: {
            shape: "S2o"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/appsync-2017-07-25.paginators.json
var require_appsync_2017_07_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/appsync-2017-07-25.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/appsync.js
var require_appsync = __commonJS({
  "node_modules/aws-sdk/clients/appsync.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["appsync"] = {};
    AWS2.AppSync = Service.defineService("appsync", ["2017-07-25"]);
    Object.defineProperty(apiLoader.services["appsync"], "2017-07-25", {
      get: function get() {
        var model = require_appsync_2017_07_25_min();
        model.paginators = require_appsync_2017_07_25_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.AppSync;
  }
});

// node_modules/aws-sdk/apis/guardduty-2017-11-28.min.json
var require_guardduty_2017_11_28_min = __commonJS({
  "node_modules/aws-sdk/apis/guardduty-2017-11-28.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-11-28",
        endpointPrefix: "guardduty",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon GuardDuty",
        serviceId: "GuardDuty",
        signatureVersion: "v4",
        signingName: "guardduty",
        uid: "guardduty-2017-11-28"
      },
      operations: {
        AcceptAdministratorInvitation: {
          http: {
            requestUri: "/detector/{detectorId}/administrator",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "AdministratorId",
              "InvitationId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              AdministratorId: {
                locationName: "administratorId"
              },
              InvitationId: {
                locationName: "invitationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AcceptInvitation: {
          http: {
            requestUri: "/detector/{detectorId}/master",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "MasterId",
              "InvitationId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              MasterId: {
                locationName: "masterId"
              },
              InvitationId: {
                locationName: "invitationId"
              }
            },
            deprecated: true,
            deprecatedMessage: "This input is deprecated, use AcceptAdministratorInvitationRequest instead"
          },
          output: {
            type: "structure",
            members: {},
            deprecated: true,
            deprecatedMessage: "This output is deprecated, use AcceptAdministratorInvitationResponse instead"
          },
          deprecated: true,
          deprecatedMessage: "This operation is deprecated, use AcceptAdministratorInvitation instead"
        },
        ArchiveFindings: {
          http: {
            requestUri: "/detector/{detectorId}/findings/archive",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "FindingIds"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              FindingIds: {
                shape: "S8",
                locationName: "findingIds"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateDetector: {
          http: {
            requestUri: "/detector",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Enable"
            ],
            members: {
              Enable: {
                locationName: "enable",
                type: "boolean"
              },
              ClientToken: {
                idempotencyToken: true,
                locationName: "clientToken"
              },
              FindingPublishingFrequency: {
                locationName: "findingPublishingFrequency"
              },
              DataSources: {
                shape: "Sf",
                deprecated: true,
                deprecatedMessage: "This parameter is deprecated, use Features instead",
                locationName: "dataSources"
              },
              Tags: {
                shape: "Sl",
                locationName: "tags"
              },
              Features: {
                shape: "So",
                locationName: "features"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DetectorId: {
                locationName: "detectorId"
              },
              UnprocessedDataSources: {
                locationName: "unprocessedDataSources",
                type: "structure",
                members: {
                  MalwareProtection: {
                    shape: "Sx",
                    locationName: "malwareProtection"
                  }
                }
              }
            }
          }
        },
        CreateFilter: {
          http: {
            requestUri: "/detector/{detectorId}/filter",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "Name",
              "FindingCriteria"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              Name: {
                locationName: "name"
              },
              Description: {
                locationName: "description"
              },
              Action: {
                locationName: "action"
              },
              Rank: {
                locationName: "rank",
                type: "integer"
              },
              FindingCriteria: {
                shape: "S16",
                locationName: "findingCriteria"
              },
              ClientToken: {
                idempotencyToken: true,
                locationName: "clientToken"
              },
              Tags: {
                shape: "Sl",
                locationName: "tags"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                locationName: "name"
              }
            }
          }
        },
        CreateIPSet: {
          http: {
            requestUri: "/detector/{detectorId}/ipset",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "Name",
              "Format",
              "Location",
              "Activate"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              Name: {
                locationName: "name"
              },
              Format: {
                locationName: "format"
              },
              Location: {
                locationName: "location"
              },
              Activate: {
                locationName: "activate",
                type: "boolean"
              },
              ClientToken: {
                idempotencyToken: true,
                locationName: "clientToken"
              },
              Tags: {
                shape: "Sl",
                locationName: "tags"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "IpSetId"
            ],
            members: {
              IpSetId: {
                locationName: "ipSetId"
              }
            }
          }
        },
        CreateMembers: {
          http: {
            requestUri: "/detector/{detectorId}/member",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "AccountDetails"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              AccountDetails: {
                locationName: "accountDetails",
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AccountId",
                    "Email"
                  ],
                  members: {
                    AccountId: {
                      locationName: "accountId"
                    },
                    Email: {
                      locationName: "email"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UnprocessedAccounts"
            ],
            members: {
              UnprocessedAccounts: {
                shape: "S1r",
                locationName: "unprocessedAccounts"
              }
            }
          }
        },
        CreatePublishingDestination: {
          http: {
            requestUri: "/detector/{detectorId}/publishingDestination",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "DestinationType",
              "DestinationProperties"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              DestinationType: {
                locationName: "destinationType"
              },
              DestinationProperties: {
                shape: "S1v",
                locationName: "destinationProperties"
              },
              ClientToken: {
                idempotencyToken: true,
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DestinationId"
            ],
            members: {
              DestinationId: {
                locationName: "destinationId"
              }
            }
          }
        },
        CreateSampleFindings: {
          http: {
            requestUri: "/detector/{detectorId}/findings/create",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              FindingTypes: {
                locationName: "findingTypes",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateThreatIntelSet: {
          http: {
            requestUri: "/detector/{detectorId}/threatintelset",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "Name",
              "Format",
              "Location",
              "Activate"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              Name: {
                locationName: "name"
              },
              Format: {
                locationName: "format"
              },
              Location: {
                locationName: "location"
              },
              Activate: {
                locationName: "activate",
                type: "boolean"
              },
              ClientToken: {
                idempotencyToken: true,
                locationName: "clientToken"
              },
              Tags: {
                shape: "Sl",
                locationName: "tags"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ThreatIntelSetId"
            ],
            members: {
              ThreatIntelSetId: {
                locationName: "threatIntelSetId"
              }
            }
          }
        },
        DeclineInvitations: {
          http: {
            requestUri: "/invitation/decline",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountIds"
            ],
            members: {
              AccountIds: {
                shape: "S25",
                locationName: "accountIds"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UnprocessedAccounts"
            ],
            members: {
              UnprocessedAccounts: {
                shape: "S1r",
                locationName: "unprocessedAccounts"
              }
            }
          }
        },
        DeleteDetector: {
          http: {
            method: "DELETE",
            requestUri: "/detector/{detectorId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteFilter: {
          http: {
            method: "DELETE",
            requestUri: "/detector/{detectorId}/filter/{filterName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "FilterName"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              FilterName: {
                location: "uri",
                locationName: "filterName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteIPSet: {
          http: {
            method: "DELETE",
            requestUri: "/detector/{detectorId}/ipset/{ipSetId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "IpSetId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              IpSetId: {
                location: "uri",
                locationName: "ipSetId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteInvitations: {
          http: {
            requestUri: "/invitation/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountIds"
            ],
            members: {
              AccountIds: {
                shape: "S25",
                locationName: "accountIds"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UnprocessedAccounts"
            ],
            members: {
              UnprocessedAccounts: {
                shape: "S1r",
                locationName: "unprocessedAccounts"
              }
            }
          }
        },
        DeleteMembers: {
          http: {
            requestUri: "/detector/{detectorId}/member/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "AccountIds"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              AccountIds: {
                shape: "S25",
                locationName: "accountIds"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UnprocessedAccounts"
            ],
            members: {
              UnprocessedAccounts: {
                shape: "S1r",
                locationName: "unprocessedAccounts"
              }
            }
          }
        },
        DeletePublishingDestination: {
          http: {
            method: "DELETE",
            requestUri: "/detector/{detectorId}/publishingDestination/{destinationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "DestinationId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              DestinationId: {
                location: "uri",
                locationName: "destinationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteThreatIntelSet: {
          http: {
            method: "DELETE",
            requestUri: "/detector/{detectorId}/threatintelset/{threatIntelSetId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "ThreatIntelSetId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              ThreatIntelSetId: {
                location: "uri",
                locationName: "threatIntelSetId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeMalwareScans: {
          http: {
            requestUri: "/detector/{detectorId}/malware-scans",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              NextToken: {
                locationName: "nextToken"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              FilterCriteria: {
                locationName: "filterCriteria",
                type: "structure",
                members: {
                  FilterCriterion: {
                    locationName: "filterCriterion",
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        CriterionKey: {
                          locationName: "criterionKey"
                        },
                        FilterCondition: {
                          locationName: "filterCondition",
                          type: "structure",
                          members: {
                            EqualsValue: {
                              locationName: "equalsValue"
                            },
                            GreaterThan: {
                              locationName: "greaterThan",
                              type: "long"
                            },
                            LessThan: {
                              locationName: "lessThan",
                              type: "long"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              SortCriteria: {
                shape: "S2u",
                locationName: "sortCriteria"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Scans"
            ],
            members: {
              Scans: {
                locationName: "scans",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DetectorId: {
                      locationName: "detectorId"
                    },
                    AdminDetectorId: {
                      locationName: "adminDetectorId"
                    },
                    ScanId: {
                      locationName: "scanId"
                    },
                    ScanStatus: {
                      locationName: "scanStatus"
                    },
                    FailureReason: {
                      locationName: "failureReason"
                    },
                    ScanStartTime: {
                      locationName: "scanStartTime",
                      type: "timestamp"
                    },
                    ScanEndTime: {
                      locationName: "scanEndTime",
                      type: "timestamp"
                    },
                    TriggerDetails: {
                      locationName: "triggerDetails",
                      type: "structure",
                      members: {
                        GuardDutyFindingId: {
                          locationName: "guardDutyFindingId"
                        },
                        Description: {
                          locationName: "description"
                        }
                      }
                    },
                    ResourceDetails: {
                      locationName: "resourceDetails",
                      type: "structure",
                      members: {
                        InstanceArn: {
                          locationName: "instanceArn"
                        }
                      }
                    },
                    ScanResultDetails: {
                      locationName: "scanResultDetails",
                      type: "structure",
                      members: {
                        ScanResult: {
                          locationName: "scanResult"
                        }
                      }
                    },
                    AccountId: {
                      locationName: "accountId"
                    },
                    TotalBytes: {
                      locationName: "totalBytes",
                      type: "long"
                    },
                    FileCount: {
                      locationName: "fileCount",
                      type: "long"
                    },
                    AttachedVolumes: {
                      shape: "S37",
                      locationName: "attachedVolumes"
                    },
                    ScanType: {
                      locationName: "scanType"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeOrganizationConfiguration: {
          http: {
            method: "GET",
            requestUri: "/detector/{detectorId}/admin",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "MemberAccountLimitReached"
            ],
            members: {
              AutoEnable: {
                deprecated: true,
                deprecatedMessage: "This field is deprecated, use AutoEnableOrganizationMembers instead",
                locationName: "autoEnable",
                type: "boolean"
              },
              MemberAccountLimitReached: {
                locationName: "memberAccountLimitReached",
                type: "boolean"
              },
              DataSources: {
                deprecated: true,
                deprecatedMessage: "This parameter is deprecated, use Features instead",
                locationName: "dataSources",
                type: "structure",
                required: [
                  "S3Logs"
                ],
                members: {
                  S3Logs: {
                    locationName: "s3Logs",
                    type: "structure",
                    required: [
                      "AutoEnable"
                    ],
                    members: {
                      AutoEnable: {
                        locationName: "autoEnable",
                        type: "boolean"
                      }
                    }
                  },
                  Kubernetes: {
                    locationName: "kubernetes",
                    type: "structure",
                    required: [
                      "AuditLogs"
                    ],
                    members: {
                      AuditLogs: {
                        locationName: "auditLogs",
                        type: "structure",
                        required: [
                          "AutoEnable"
                        ],
                        members: {
                          AutoEnable: {
                            locationName: "autoEnable",
                            type: "boolean"
                          }
                        }
                      }
                    }
                  },
                  MalwareProtection: {
                    locationName: "malwareProtection",
                    type: "structure",
                    members: {
                      ScanEc2InstanceWithFindings: {
                        locationName: "scanEc2InstanceWithFindings",
                        type: "structure",
                        members: {
                          EbsVolumes: {
                            locationName: "ebsVolumes",
                            type: "structure",
                            members: {
                              AutoEnable: {
                                locationName: "autoEnable",
                                type: "boolean"
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              Features: {
                locationName: "features",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {
                      locationName: "name"
                    },
                    AutoEnable: {
                      locationName: "autoEnable"
                    },
                    AdditionalConfiguration: {
                      locationName: "additionalConfiguration",
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Name: {
                            locationName: "name"
                          },
                          AutoEnable: {
                            locationName: "autoEnable"
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              },
              AutoEnableOrganizationMembers: {
                locationName: "autoEnableOrganizationMembers"
              }
            }
          }
        },
        DescribePublishingDestination: {
          http: {
            method: "GET",
            requestUri: "/detector/{detectorId}/publishingDestination/{destinationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "DestinationId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              DestinationId: {
                location: "uri",
                locationName: "destinationId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DestinationId",
              "DestinationType",
              "Status",
              "PublishingFailureStartTimestamp",
              "DestinationProperties"
            ],
            members: {
              DestinationId: {
                locationName: "destinationId"
              },
              DestinationType: {
                locationName: "destinationType"
              },
              Status: {
                locationName: "status"
              },
              PublishingFailureStartTimestamp: {
                locationName: "publishingFailureStartTimestamp",
                type: "long"
              },
              DestinationProperties: {
                shape: "S1v",
                locationName: "destinationProperties"
              }
            }
          }
        },
        DisableOrganizationAdminAccount: {
          http: {
            requestUri: "/admin/disable",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AdminAccountId"
            ],
            members: {
              AdminAccountId: {
                locationName: "adminAccountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateFromAdministratorAccount: {
          http: {
            requestUri: "/detector/{detectorId}/administrator/disassociate",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateFromMasterAccount: {
          http: {
            requestUri: "/detector/{detectorId}/master/disassociate",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              }
            },
            deprecated: true,
            deprecatedMessage: "This input is deprecated, use DisassociateFromAdministratorAccountRequest instead"
          },
          output: {
            type: "structure",
            members: {},
            deprecated: true,
            deprecatedMessage: "This output is deprecated, use DisassociateFromAdministratorAccountResponse instead"
          },
          deprecated: true,
          deprecatedMessage: "This operation is deprecated, use DisassociateFromAdministratorAccount instead"
        },
        DisassociateMembers: {
          http: {
            requestUri: "/detector/{detectorId}/member/disassociate",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "AccountIds"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              AccountIds: {
                shape: "S25",
                locationName: "accountIds"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UnprocessedAccounts"
            ],
            members: {
              UnprocessedAccounts: {
                shape: "S1r",
                locationName: "unprocessedAccounts"
              }
            }
          }
        },
        EnableOrganizationAdminAccount: {
          http: {
            requestUri: "/admin/enable",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AdminAccountId"
            ],
            members: {
              AdminAccountId: {
                locationName: "adminAccountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetAdministratorAccount: {
          http: {
            method: "GET",
            requestUri: "/detector/{detectorId}/administrator",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Administrator"
            ],
            members: {
              Administrator: {
                locationName: "administrator",
                type: "structure",
                members: {
                  AccountId: {
                    locationName: "accountId"
                  },
                  InvitationId: {
                    locationName: "invitationId"
                  },
                  RelationshipStatus: {
                    locationName: "relationshipStatus"
                  },
                  InvitedAt: {
                    locationName: "invitedAt"
                  }
                }
              }
            }
          }
        },
        GetCoverageStatistics: {
          http: {
            requestUri: "/detector/{detectorId}/coverage/statistics",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "StatisticsType"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              FilterCriteria: {
                shape: "S49",
                locationName: "filterCriteria"
              },
              StatisticsType: {
                locationName: "statisticsType",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CoverageStatistics: {
                locationName: "coverageStatistics",
                type: "structure",
                members: {
                  CountByResourceType: {
                    locationName: "countByResourceType",
                    type: "map",
                    key: {},
                    value: {
                      type: "long"
                    }
                  },
                  CountByCoverageStatus: {
                    locationName: "countByCoverageStatus",
                    type: "map",
                    key: {},
                    value: {
                      type: "long"
                    }
                  }
                }
              }
            }
          }
        },
        GetDetector: {
          http: {
            method: "GET",
            requestUri: "/detector/{detectorId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ServiceRole",
              "Status"
            ],
            members: {
              CreatedAt: {
                locationName: "createdAt"
              },
              FindingPublishingFrequency: {
                locationName: "findingPublishingFrequency"
              },
              ServiceRole: {
                locationName: "serviceRole"
              },
              Status: {
                locationName: "status"
              },
              UpdatedAt: {
                locationName: "updatedAt"
              },
              DataSources: {
                shape: "S4p",
                deprecated: true,
                deprecatedMessage: "This parameter is deprecated, use Features instead",
                locationName: "dataSources"
              },
              Tags: {
                shape: "Sl",
                locationName: "tags"
              },
              Features: {
                locationName: "features",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {
                      locationName: "name"
                    },
                    Status: {
                      locationName: "status"
                    },
                    UpdatedAt: {
                      locationName: "updatedAt",
                      type: "timestamp"
                    },
                    AdditionalConfiguration: {
                      locationName: "additionalConfiguration",
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Name: {
                            locationName: "name"
                          },
                          Status: {
                            locationName: "status"
                          },
                          UpdatedAt: {
                            locationName: "updatedAt",
                            type: "timestamp"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetFilter: {
          http: {
            method: "GET",
            requestUri: "/detector/{detectorId}/filter/{filterName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "FilterName"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              FilterName: {
                location: "uri",
                locationName: "filterName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name",
              "Action",
              "FindingCriteria"
            ],
            members: {
              Name: {
                locationName: "name"
              },
              Description: {
                locationName: "description"
              },
              Action: {
                locationName: "action"
              },
              Rank: {
                locationName: "rank",
                type: "integer"
              },
              FindingCriteria: {
                shape: "S16",
                locationName: "findingCriteria"
              },
              Tags: {
                shape: "Sl",
                locationName: "tags"
              }
            }
          }
        },
        GetFindings: {
          http: {
            requestUri: "/detector/{detectorId}/findings/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "FindingIds"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              FindingIds: {
                shape: "S8",
                locationName: "findingIds"
              },
              SortCriteria: {
                shape: "S2u",
                locationName: "sortCriteria"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Findings"
            ],
            members: {
              Findings: {
                locationName: "findings",
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AccountId",
                    "Arn",
                    "CreatedAt",
                    "Id",
                    "Region",
                    "Resource",
                    "SchemaVersion",
                    "Severity",
                    "Type",
                    "UpdatedAt"
                  ],
                  members: {
                    AccountId: {
                      locationName: "accountId"
                    },
                    Arn: {
                      locationName: "arn"
                    },
                    Confidence: {
                      locationName: "confidence",
                      type: "double"
                    },
                    CreatedAt: {
                      locationName: "createdAt"
                    },
                    Description: {
                      locationName: "description"
                    },
                    Id: {
                      locationName: "id"
                    },
                    Partition: {
                      locationName: "partition"
                    },
                    Region: {
                      locationName: "region"
                    },
                    Resource: {
                      locationName: "resource",
                      type: "structure",
                      members: {
                        AccessKeyDetails: {
                          locationName: "accessKeyDetails",
                          type: "structure",
                          members: {
                            AccessKeyId: {
                              locationName: "accessKeyId"
                            },
                            PrincipalId: {
                              locationName: "principalId"
                            },
                            UserName: {
                              locationName: "userName"
                            },
                            UserType: {
                              locationName: "userType"
                            }
                          }
                        },
                        S3BucketDetails: {
                          locationName: "s3BucketDetails",
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              Arn: {
                                locationName: "arn"
                              },
                              Name: {
                                locationName: "name"
                              },
                              Type: {
                                locationName: "type"
                              },
                              CreatedAt: {
                                locationName: "createdAt",
                                type: "timestamp"
                              },
                              Owner: {
                                locationName: "owner",
                                type: "structure",
                                members: {
                                  Id: {
                                    locationName: "id"
                                  }
                                }
                              },
                              Tags: {
                                shape: "S5d",
                                locationName: "tags"
                              },
                              DefaultServerSideEncryption: {
                                locationName: "defaultServerSideEncryption",
                                type: "structure",
                                members: {
                                  EncryptionType: {
                                    locationName: "encryptionType"
                                  },
                                  KmsMasterKeyArn: {
                                    locationName: "kmsMasterKeyArn"
                                  }
                                }
                              },
                              PublicAccess: {
                                locationName: "publicAccess",
                                type: "structure",
                                members: {
                                  PermissionConfiguration: {
                                    locationName: "permissionConfiguration",
                                    type: "structure",
                                    members: {
                                      BucketLevelPermissions: {
                                        locationName: "bucketLevelPermissions",
                                        type: "structure",
                                        members: {
                                          AccessControlList: {
                                            locationName: "accessControlList",
                                            type: "structure",
                                            members: {
                                              AllowsPublicReadAccess: {
                                                locationName: "allowsPublicReadAccess",
                                                type: "boolean"
                                              },
                                              AllowsPublicWriteAccess: {
                                                locationName: "allowsPublicWriteAccess",
                                                type: "boolean"
                                              }
                                            }
                                          },
                                          BucketPolicy: {
                                            locationName: "bucketPolicy",
                                            type: "structure",
                                            members: {
                                              AllowsPublicReadAccess: {
                                                locationName: "allowsPublicReadAccess",
                                                type: "boolean"
                                              },
                                              AllowsPublicWriteAccess: {
                                                locationName: "allowsPublicWriteAccess",
                                                type: "boolean"
                                              }
                                            }
                                          },
                                          BlockPublicAccess: {
                                            shape: "S5l",
                                            locationName: "blockPublicAccess"
                                          }
                                        }
                                      },
                                      AccountLevelPermissions: {
                                        locationName: "accountLevelPermissions",
                                        type: "structure",
                                        members: {
                                          BlockPublicAccess: {
                                            shape: "S5l",
                                            locationName: "blockPublicAccess"
                                          }
                                        }
                                      }
                                    }
                                  },
                                  EffectivePermission: {
                                    locationName: "effectivePermission"
                                  }
                                }
                              }
                            }
                          }
                        },
                        InstanceDetails: {
                          locationName: "instanceDetails",
                          type: "structure",
                          members: {
                            AvailabilityZone: {
                              locationName: "availabilityZone"
                            },
                            IamInstanceProfile: {
                              locationName: "iamInstanceProfile",
                              type: "structure",
                              members: {
                                Arn: {
                                  locationName: "arn"
                                },
                                Id: {
                                  locationName: "id"
                                }
                              }
                            },
                            ImageDescription: {
                              locationName: "imageDescription"
                            },
                            ImageId: {
                              locationName: "imageId"
                            },
                            InstanceId: {
                              locationName: "instanceId"
                            },
                            InstanceState: {
                              locationName: "instanceState"
                            },
                            InstanceType: {
                              locationName: "instanceType"
                            },
                            OutpostArn: {
                              locationName: "outpostArn"
                            },
                            LaunchTime: {
                              locationName: "launchTime"
                            },
                            NetworkInterfaces: {
                              locationName: "networkInterfaces",
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  Ipv6Addresses: {
                                    locationName: "ipv6Addresses",
                                    type: "list",
                                    member: {}
                                  },
                                  NetworkInterfaceId: {
                                    locationName: "networkInterfaceId"
                                  },
                                  PrivateDnsName: {
                                    locationName: "privateDnsName"
                                  },
                                  PrivateIpAddress: {
                                    locationName: "privateIpAddress"
                                  },
                                  PrivateIpAddresses: {
                                    locationName: "privateIpAddresses",
                                    type: "list",
                                    member: {
                                      type: "structure",
                                      members: {
                                        PrivateDnsName: {
                                          locationName: "privateDnsName"
                                        },
                                        PrivateIpAddress: {
                                          locationName: "privateIpAddress"
                                        }
                                      }
                                    }
                                  },
                                  PublicDnsName: {
                                    locationName: "publicDnsName"
                                  },
                                  PublicIp: {
                                    locationName: "publicIp"
                                  },
                                  SecurityGroups: {
                                    shape: "S5u",
                                    locationName: "securityGroups"
                                  },
                                  SubnetId: {
                                    locationName: "subnetId"
                                  },
                                  VpcId: {
                                    locationName: "vpcId"
                                  }
                                }
                              }
                            },
                            Platform: {
                              locationName: "platform"
                            },
                            ProductCodes: {
                              locationName: "productCodes",
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  Code: {
                                    locationName: "productCodeId"
                                  },
                                  ProductType: {
                                    locationName: "productCodeType"
                                  }
                                }
                              }
                            },
                            Tags: {
                              shape: "S5d",
                              locationName: "tags"
                            }
                          }
                        },
                        EksClusterDetails: {
                          locationName: "eksClusterDetails",
                          type: "structure",
                          members: {
                            Name: {
                              locationName: "name"
                            },
                            Arn: {
                              locationName: "arn"
                            },
                            VpcId: {
                              locationName: "vpcId"
                            },
                            Status: {
                              locationName: "status"
                            },
                            Tags: {
                              shape: "S5d",
                              locationName: "tags"
                            },
                            CreatedAt: {
                              locationName: "createdAt",
                              type: "timestamp"
                            }
                          }
                        },
                        KubernetesDetails: {
                          locationName: "kubernetesDetails",
                          type: "structure",
                          members: {
                            KubernetesUserDetails: {
                              locationName: "kubernetesUserDetails",
                              type: "structure",
                              members: {
                                Username: {
                                  locationName: "username"
                                },
                                Uid: {
                                  locationName: "uid"
                                },
                                Groups: {
                                  shape: "S61",
                                  locationName: "groups"
                                },
                                SessionName: {
                                  locationName: "sessionName",
                                  type: "list",
                                  member: {}
                                },
                                ImpersonatedUser: {
                                  locationName: "impersonatedUser",
                                  type: "structure",
                                  members: {
                                    Username: {
                                      locationName: "username"
                                    },
                                    Groups: {
                                      shape: "S61",
                                      locationName: "groups"
                                    }
                                  }
                                }
                              }
                            },
                            KubernetesWorkloadDetails: {
                              locationName: "kubernetesWorkloadDetails",
                              type: "structure",
                              members: {
                                Name: {
                                  locationName: "name"
                                },
                                Type: {
                                  locationName: "type"
                                },
                                Uid: {
                                  locationName: "uid"
                                },
                                Namespace: {
                                  locationName: "namespace"
                                },
                                HostNetwork: {
                                  locationName: "hostNetwork",
                                  type: "boolean"
                                },
                                Containers: {
                                  shape: "S65",
                                  locationName: "containers"
                                },
                                Volumes: {
                                  shape: "S6a",
                                  locationName: "volumes"
                                },
                                ServiceAccountName: {
                                  locationName: "serviceAccountName"
                                },
                                HostIPC: {
                                  locationName: "hostIPC",
                                  type: "boolean"
                                },
                                HostPID: {
                                  locationName: "hostPID",
                                  type: "boolean"
                                }
                              }
                            }
                          }
                        },
                        ResourceType: {
                          locationName: "resourceType"
                        },
                        EbsVolumeDetails: {
                          locationName: "ebsVolumeDetails",
                          type: "structure",
                          members: {
                            ScannedVolumeDetails: {
                              shape: "S37",
                              locationName: "scannedVolumeDetails"
                            },
                            SkippedVolumeDetails: {
                              shape: "S37",
                              locationName: "skippedVolumeDetails"
                            }
                          }
                        },
                        EcsClusterDetails: {
                          locationName: "ecsClusterDetails",
                          type: "structure",
                          members: {
                            Name: {
                              locationName: "name"
                            },
                            Arn: {
                              locationName: "arn"
                            },
                            Status: {
                              locationName: "status"
                            },
                            ActiveServicesCount: {
                              locationName: "activeServicesCount",
                              type: "integer"
                            },
                            RegisteredContainerInstancesCount: {
                              locationName: "registeredContainerInstancesCount",
                              type: "integer"
                            },
                            RunningTasksCount: {
                              locationName: "runningTasksCount",
                              type: "integer"
                            },
                            Tags: {
                              shape: "S5d",
                              locationName: "tags"
                            },
                            TaskDetails: {
                              locationName: "taskDetails",
                              type: "structure",
                              members: {
                                Arn: {
                                  locationName: "arn"
                                },
                                DefinitionArn: {
                                  locationName: "definitionArn"
                                },
                                Version: {
                                  locationName: "version"
                                },
                                TaskCreatedAt: {
                                  locationName: "createdAt",
                                  type: "timestamp"
                                },
                                StartedAt: {
                                  locationName: "startedAt",
                                  type: "timestamp"
                                },
                                StartedBy: {
                                  locationName: "startedBy"
                                },
                                Tags: {
                                  shape: "S5d",
                                  locationName: "tags"
                                },
                                Volumes: {
                                  shape: "S6a",
                                  locationName: "volumes"
                                },
                                Containers: {
                                  shape: "S65",
                                  locationName: "containers"
                                },
                                Group: {
                                  locationName: "group"
                                }
                              }
                            }
                          }
                        },
                        ContainerDetails: {
                          shape: "S66",
                          locationName: "containerDetails"
                        },
                        RdsDbInstanceDetails: {
                          locationName: "rdsDbInstanceDetails",
                          type: "structure",
                          members: {
                            DbInstanceIdentifier: {
                              locationName: "dbInstanceIdentifier"
                            },
                            Engine: {
                              locationName: "engine"
                            },
                            EngineVersion: {
                              locationName: "engineVersion"
                            },
                            DbClusterIdentifier: {
                              locationName: "dbClusterIdentifier"
                            },
                            DbInstanceArn: {
                              locationName: "dbInstanceArn"
                            },
                            Tags: {
                              shape: "S5d",
                              locationName: "tags"
                            }
                          }
                        },
                        RdsDbUserDetails: {
                          locationName: "rdsDbUserDetails",
                          type: "structure",
                          members: {
                            User: {
                              locationName: "user"
                            },
                            Application: {
                              locationName: "application"
                            },
                            Database: {
                              locationName: "database"
                            },
                            Ssl: {
                              locationName: "ssl"
                            },
                            AuthMethod: {
                              locationName: "authMethod"
                            }
                          }
                        },
                        LambdaDetails: {
                          locationName: "lambdaDetails",
                          type: "structure",
                          members: {
                            FunctionArn: {
                              locationName: "functionArn"
                            },
                            FunctionName: {
                              locationName: "functionName"
                            },
                            Description: {
                              locationName: "description"
                            },
                            LastModifiedAt: {
                              locationName: "lastModifiedAt",
                              type: "timestamp"
                            },
                            RevisionId: {
                              locationName: "revisionId"
                            },
                            FunctionVersion: {
                              locationName: "functionVersion"
                            },
                            Role: {
                              locationName: "role"
                            },
                            VpcConfig: {
                              locationName: "vpcConfig",
                              type: "structure",
                              members: {
                                SubnetIds: {
                                  locationName: "subnetIds",
                                  type: "list",
                                  member: {}
                                },
                                VpcId: {
                                  locationName: "vpcId"
                                },
                                SecurityGroups: {
                                  shape: "S5u",
                                  locationName: "securityGroups"
                                }
                              }
                            },
                            Tags: {
                              shape: "S5d",
                              locationName: "tags"
                            }
                          }
                        }
                      }
                    },
                    SchemaVersion: {
                      locationName: "schemaVersion"
                    },
                    Service: {
                      locationName: "service",
                      type: "structure",
                      members: {
                        Action: {
                          locationName: "action",
                          type: "structure",
                          members: {
                            ActionType: {
                              locationName: "actionType"
                            },
                            AwsApiCallAction: {
                              locationName: "awsApiCallAction",
                              type: "structure",
                              members: {
                                Api: {
                                  locationName: "api"
                                },
                                CallerType: {
                                  locationName: "callerType"
                                },
                                DomainDetails: {
                                  locationName: "domainDetails",
                                  type: "structure",
                                  members: {
                                    Domain: {
                                      locationName: "domain"
                                    }
                                  }
                                },
                                ErrorCode: {
                                  locationName: "errorCode"
                                },
                                UserAgent: {
                                  locationName: "userAgent"
                                },
                                RemoteIpDetails: {
                                  shape: "S6p",
                                  locationName: "remoteIpDetails"
                                },
                                ServiceName: {
                                  locationName: "serviceName"
                                },
                                RemoteAccountDetails: {
                                  locationName: "remoteAccountDetails",
                                  type: "structure",
                                  members: {
                                    AccountId: {
                                      locationName: "accountId"
                                    },
                                    Affiliated: {
                                      locationName: "affiliated",
                                      type: "boolean"
                                    }
                                  }
                                },
                                AffectedResources: {
                                  locationName: "affectedResources",
                                  type: "map",
                                  key: {},
                                  value: {}
                                }
                              }
                            },
                            DnsRequestAction: {
                              locationName: "dnsRequestAction",
                              type: "structure",
                              members: {
                                Domain: {
                                  locationName: "domain"
                                },
                                Protocol: {
                                  locationName: "protocol"
                                },
                                Blocked: {
                                  locationName: "blocked",
                                  type: "boolean"
                                },
                                DomainWithSuffix: {
                                  locationName: "domainWithSuffix"
                                }
                              }
                            },
                            NetworkConnectionAction: {
                              locationName: "networkConnectionAction",
                              type: "structure",
                              members: {
                                Blocked: {
                                  locationName: "blocked",
                                  type: "boolean"
                                },
                                ConnectionDirection: {
                                  locationName: "connectionDirection"
                                },
                                LocalPortDetails: {
                                  shape: "S6y",
                                  locationName: "localPortDetails"
                                },
                                Protocol: {
                                  locationName: "protocol"
                                },
                                LocalIpDetails: {
                                  shape: "S6z",
                                  locationName: "localIpDetails"
                                },
                                RemoteIpDetails: {
                                  shape: "S6p",
                                  locationName: "remoteIpDetails"
                                },
                                RemotePortDetails: {
                                  locationName: "remotePortDetails",
                                  type: "structure",
                                  members: {
                                    Port: {
                                      locationName: "port",
                                      type: "integer"
                                    },
                                    PortName: {
                                      locationName: "portName"
                                    }
                                  }
                                }
                              }
                            },
                            PortProbeAction: {
                              locationName: "portProbeAction",
                              type: "structure",
                              members: {
                                Blocked: {
                                  locationName: "blocked",
                                  type: "boolean"
                                },
                                PortProbeDetails: {
                                  locationName: "portProbeDetails",
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      LocalPortDetails: {
                                        shape: "S6y",
                                        locationName: "localPortDetails"
                                      },
                                      LocalIpDetails: {
                                        shape: "S6z",
                                        locationName: "localIpDetails"
                                      },
                                      RemoteIpDetails: {
                                        shape: "S6p",
                                        locationName: "remoteIpDetails"
                                      }
                                    }
                                  }
                                }
                              }
                            },
                            KubernetesApiCallAction: {
                              locationName: "kubernetesApiCallAction",
                              type: "structure",
                              members: {
                                RequestUri: {
                                  locationName: "requestUri"
                                },
                                Verb: {
                                  locationName: "verb"
                                },
                                SourceIps: {
                                  locationName: "sourceIps",
                                  type: "list",
                                  member: {}
                                },
                                UserAgent: {
                                  locationName: "userAgent"
                                },
                                RemoteIpDetails: {
                                  shape: "S6p",
                                  locationName: "remoteIpDetails"
                                },
                                StatusCode: {
                                  locationName: "statusCode",
                                  type: "integer"
                                },
                                Parameters: {
                                  locationName: "parameters"
                                },
                                Resource: {
                                  locationName: "resource"
                                },
                                Subresource: {
                                  locationName: "subresource"
                                },
                                Namespace: {
                                  locationName: "namespace"
                                },
                                ResourceName: {
                                  locationName: "resourceName"
                                }
                              }
                            },
                            RdsLoginAttemptAction: {
                              locationName: "rdsLoginAttemptAction",
                              type: "structure",
                              members: {
                                RemoteIpDetails: {
                                  shape: "S6p",
                                  locationName: "remoteIpDetails"
                                },
                                LoginAttributes: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      User: {
                                        locationName: "user"
                                      },
                                      Application: {
                                        locationName: "application"
                                      },
                                      FailedLoginAttempts: {
                                        locationName: "failedLoginAttempts",
                                        type: "integer"
                                      },
                                      SuccessfulLoginAttempts: {
                                        locationName: "successfulLoginAttempts",
                                        type: "integer"
                                      }
                                    }
                                  }
                                }
                              }
                            },
                            KubernetesPermissionCheckedDetails: {
                              locationName: "kubernetesPermissionCheckedDetails",
                              type: "structure",
                              members: {
                                Verb: {
                                  locationName: "verb"
                                },
                                Resource: {
                                  locationName: "resource"
                                },
                                Namespace: {
                                  locationName: "namespace"
                                },
                                Allowed: {
                                  locationName: "allowed",
                                  type: "boolean"
                                }
                              }
                            },
                            KubernetesRoleBindingDetails: {
                              locationName: "kubernetesRoleBindingDetails",
                              type: "structure",
                              members: {
                                Kind: {
                                  locationName: "kind"
                                },
                                Name: {
                                  locationName: "name"
                                },
                                Uid: {
                                  locationName: "uid"
                                },
                                RoleRefName: {
                                  locationName: "roleRefName"
                                },
                                RoleRefKind: {
                                  locationName: "roleRefKind"
                                }
                              }
                            },
                            KubernetesRoleDetails: {
                              locationName: "kubernetesRoleDetails",
                              type: "structure",
                              members: {
                                Kind: {
                                  locationName: "kind"
                                },
                                Name: {
                                  locationName: "name"
                                },
                                Uid: {
                                  locationName: "uid"
                                }
                              }
                            }
                          }
                        },
                        Evidence: {
                          locationName: "evidence",
                          type: "structure",
                          members: {
                            ThreatIntelligenceDetails: {
                              locationName: "threatIntelligenceDetails",
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  ThreatListName: {
                                    locationName: "threatListName"
                                  },
                                  ThreatNames: {
                                    locationName: "threatNames",
                                    type: "list",
                                    member: {}
                                  }
                                }
                              }
                            }
                          }
                        },
                        Archived: {
                          locationName: "archived",
                          type: "boolean"
                        },
                        Count: {
                          locationName: "count",
                          type: "integer"
                        },
                        DetectorId: {
                          locationName: "detectorId"
                        },
                        EventFirstSeen: {
                          locationName: "eventFirstSeen"
                        },
                        EventLastSeen: {
                          locationName: "eventLastSeen"
                        },
                        ResourceRole: {
                          locationName: "resourceRole"
                        },
                        ServiceName: {
                          locationName: "serviceName"
                        },
                        UserFeedback: {
                          locationName: "userFeedback"
                        },
                        AdditionalInfo: {
                          locationName: "additionalInfo",
                          type: "structure",
                          members: {
                            Value: {
                              locationName: "value"
                            },
                            Type: {
                              locationName: "type"
                            }
                          }
                        },
                        FeatureName: {
                          locationName: "featureName"
                        },
                        EbsVolumeScanDetails: {
                          locationName: "ebsVolumeScanDetails",
                          type: "structure",
                          members: {
                            ScanId: {
                              locationName: "scanId"
                            },
                            ScanStartedAt: {
                              locationName: "scanStartedAt",
                              type: "timestamp"
                            },
                            ScanCompletedAt: {
                              locationName: "scanCompletedAt",
                              type: "timestamp"
                            },
                            TriggerFindingId: {
                              locationName: "triggerFindingId"
                            },
                            Sources: {
                              locationName: "sources",
                              type: "list",
                              member: {}
                            },
                            ScanDetections: {
                              locationName: "scanDetections",
                              type: "structure",
                              members: {
                                ScannedItemCount: {
                                  locationName: "scannedItemCount",
                                  type: "structure",
                                  members: {
                                    TotalGb: {
                                      locationName: "totalGb",
                                      type: "integer"
                                    },
                                    Files: {
                                      locationName: "files",
                                      type: "integer"
                                    },
                                    Volumes: {
                                      locationName: "volumes",
                                      type: "integer"
                                    }
                                  }
                                },
                                ThreatsDetectedItemCount: {
                                  locationName: "threatsDetectedItemCount",
                                  type: "structure",
                                  members: {
                                    Files: {
                                      locationName: "files",
                                      type: "integer"
                                    }
                                  }
                                },
                                HighestSeverityThreatDetails: {
                                  locationName: "highestSeverityThreatDetails",
                                  type: "structure",
                                  members: {
                                    Severity: {
                                      locationName: "severity"
                                    },
                                    ThreatName: {
                                      locationName: "threatName"
                                    },
                                    Count: {
                                      locationName: "count",
                                      type: "integer"
                                    }
                                  }
                                },
                                ThreatDetectedByName: {
                                  locationName: "threatDetectedByName",
                                  type: "structure",
                                  members: {
                                    ItemCount: {
                                      locationName: "itemCount",
                                      type: "integer"
                                    },
                                    UniqueThreatNameCount: {
                                      locationName: "uniqueThreatNameCount",
                                      type: "integer"
                                    },
                                    Shortened: {
                                      locationName: "shortened",
                                      type: "boolean"
                                    },
                                    ThreatNames: {
                                      locationName: "threatNames",
                                      type: "list",
                                      member: {
                                        type: "structure",
                                        members: {
                                          Name: {
                                            locationName: "name"
                                          },
                                          Severity: {
                                            locationName: "severity"
                                          },
                                          ItemCount: {
                                            locationName: "itemCount",
                                            type: "integer"
                                          },
                                          FilePaths: {
                                            locationName: "filePaths",
                                            type: "list",
                                            member: {
                                              type: "structure",
                                              members: {
                                                FilePath: {
                                                  locationName: "filePath"
                                                },
                                                VolumeArn: {
                                                  locationName: "volumeArn"
                                                },
                                                Hash: {
                                                  locationName: "hash"
                                                },
                                                FileName: {
                                                  locationName: "fileName"
                                                }
                                              }
                                            }
                                          }
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            },
                            ScanType: {
                              locationName: "scanType"
                            }
                          }
                        },
                        RuntimeDetails: {
                          locationName: "runtimeDetails",
                          type: "structure",
                          members: {
                            Process: {
                              shape: "S7t",
                              locationName: "process"
                            },
                            Context: {
                              locationName: "context",
                              type: "structure",
                              members: {
                                ModifyingProcess: {
                                  shape: "S7t",
                                  locationName: "modifyingProcess"
                                },
                                ModifiedAt: {
                                  locationName: "modifiedAt",
                                  type: "timestamp"
                                },
                                ScriptPath: {
                                  locationName: "scriptPath"
                                },
                                LibraryPath: {
                                  locationName: "libraryPath"
                                },
                                LdPreloadValue: {
                                  locationName: "ldPreloadValue"
                                },
                                SocketPath: {
                                  locationName: "socketPath"
                                },
                                RuncBinaryPath: {
                                  locationName: "runcBinaryPath"
                                },
                                ReleaseAgentPath: {
                                  locationName: "releaseAgentPath"
                                },
                                MountSource: {
                                  locationName: "mountSource"
                                },
                                MountTarget: {
                                  locationName: "mountTarget"
                                },
                                FileSystemType: {
                                  locationName: "fileSystemType"
                                },
                                Flags: {
                                  locationName: "flags",
                                  type: "list",
                                  member: {}
                                },
                                ModuleName: {
                                  locationName: "moduleName"
                                },
                                ModuleFilePath: {
                                  locationName: "moduleFilePath"
                                },
                                ModuleSha256: {
                                  locationName: "moduleSha256"
                                },
                                ShellHistoryFilePath: {
                                  locationName: "shellHistoryFilePath"
                                },
                                TargetProcess: {
                                  shape: "S7t",
                                  locationName: "targetProcess"
                                },
                                AddressFamily: {
                                  locationName: "addressFamily"
                                },
                                IanaProtocolNumber: {
                                  locationName: "ianaProtocolNumber",
                                  type: "integer"
                                },
                                MemoryRegions: {
                                  locationName: "memoryRegions",
                                  type: "list",
                                  member: {}
                                }
                              }
                            }
                          }
                        },
                        Detection: {
                          locationName: "detection",
                          type: "structure",
                          members: {
                            Anomaly: {
                              locationName: "anomaly",
                              type: "structure",
                              members: {
                                Profiles: {
                                  locationName: "profiles",
                                  type: "map",
                                  key: {},
                                  value: {
                                    type: "map",
                                    key: {},
                                    value: {
                                      type: "list",
                                      member: {
                                        shape: "S84"
                                      }
                                    }
                                  }
                                },
                                Unusual: {
                                  locationName: "unusual",
                                  type: "structure",
                                  members: {
                                    Behavior: {
                                      locationName: "behavior",
                                      type: "map",
                                      key: {},
                                      value: {
                                        type: "map",
                                        key: {},
                                        value: {
                                          shape: "S84"
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    Severity: {
                      locationName: "severity",
                      type: "double"
                    },
                    Title: {
                      locationName: "title"
                    },
                    Type: {
                      locationName: "type"
                    },
                    UpdatedAt: {
                      locationName: "updatedAt"
                    }
                  }
                }
              }
            }
          }
        },
        GetFindingsStatistics: {
          http: {
            requestUri: "/detector/{detectorId}/findings/statistics",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "FindingStatisticTypes"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              FindingStatisticTypes: {
                locationName: "findingStatisticTypes",
                type: "list",
                member: {}
              },
              FindingCriteria: {
                shape: "S16",
                locationName: "findingCriteria"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "FindingStatistics"
            ],
            members: {
              FindingStatistics: {
                locationName: "findingStatistics",
                type: "structure",
                members: {
                  CountBySeverity: {
                    locationName: "countBySeverity",
                    type: "map",
                    key: {},
                    value: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        GetIPSet: {
          http: {
            method: "GET",
            requestUri: "/detector/{detectorId}/ipset/{ipSetId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "IpSetId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              IpSetId: {
                location: "uri",
                locationName: "ipSetId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name",
              "Format",
              "Location",
              "Status"
            ],
            members: {
              Name: {
                locationName: "name"
              },
              Format: {
                locationName: "format"
              },
              Location: {
                locationName: "location"
              },
              Status: {
                locationName: "status"
              },
              Tags: {
                shape: "Sl",
                locationName: "tags"
              }
            }
          }
        },
        GetInvitationsCount: {
          http: {
            method: "GET",
            requestUri: "/invitation/count",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              InvitationsCount: {
                locationName: "invitationsCount",
                type: "integer"
              }
            }
          }
        },
        GetMalwareScanSettings: {
          http: {
            method: "GET",
            requestUri: "/detector/{detectorId}/malware-scan-settings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ScanResourceCriteria: {
                shape: "S8p",
                locationName: "scanResourceCriteria"
              },
              EbsSnapshotPreservation: {
                locationName: "ebsSnapshotPreservation"
              }
            }
          }
        },
        GetMasterAccount: {
          http: {
            method: "GET",
            requestUri: "/detector/{detectorId}/master",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              }
            },
            deprecated: true,
            deprecatedMessage: "This input is deprecated, use GetAdministratorAccountRequest instead"
          },
          output: {
            type: "structure",
            required: [
              "Master"
            ],
            members: {
              Master: {
                locationName: "master",
                type: "structure",
                members: {
                  AccountId: {
                    locationName: "accountId"
                  },
                  InvitationId: {
                    locationName: "invitationId"
                  },
                  RelationshipStatus: {
                    locationName: "relationshipStatus"
                  },
                  InvitedAt: {
                    locationName: "invitedAt"
                  }
                }
              }
            },
            deprecated: true,
            deprecatedMessage: "This output is deprecated, use GetAdministratorAccountResponse instead"
          },
          deprecated: true,
          deprecatedMessage: "This operation is deprecated, use GetAdministratorAccount instead"
        },
        GetMemberDetectors: {
          http: {
            requestUri: "/detector/{detectorId}/member/detector/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "AccountIds"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              AccountIds: {
                shape: "S25",
                locationName: "accountIds"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "MemberDataSourceConfigurations",
              "UnprocessedAccounts"
            ],
            members: {
              MemberDataSourceConfigurations: {
                locationName: "members",
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AccountId"
                  ],
                  members: {
                    AccountId: {
                      locationName: "accountId"
                    },
                    DataSources: {
                      shape: "S4p",
                      deprecated: true,
                      deprecatedMessage: "This parameter is deprecated, use Features instead",
                      locationName: "dataSources"
                    },
                    Features: {
                      locationName: "features",
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Name: {
                            locationName: "name"
                          },
                          Status: {
                            locationName: "status"
                          },
                          UpdatedAt: {
                            locationName: "updatedAt",
                            type: "timestamp"
                          },
                          AdditionalConfiguration: {
                            locationName: "additionalConfiguration",
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Name: {
                                  locationName: "name"
                                },
                                Status: {
                                  locationName: "status"
                                },
                                UpdatedAt: {
                                  locationName: "updatedAt",
                                  type: "timestamp"
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              UnprocessedAccounts: {
                shape: "S1r",
                locationName: "unprocessedAccounts"
              }
            }
          }
        },
        GetMembers: {
          http: {
            requestUri: "/detector/{detectorId}/member/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "AccountIds"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              AccountIds: {
                shape: "S25",
                locationName: "accountIds"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Members",
              "UnprocessedAccounts"
            ],
            members: {
              Members: {
                shape: "S99",
                locationName: "members"
              },
              UnprocessedAccounts: {
                shape: "S1r",
                locationName: "unprocessedAccounts"
              }
            }
          }
        },
        GetOrganizationStatistics: {
          http: {
            method: "GET",
            requestUri: "/organization/statistics",
            responseCode: 200
          },
          output: {
            type: "structure",
            members: {
              OrganizationDetails: {
                locationName: "organizationDetails",
                type: "structure",
                members: {
                  UpdatedAt: {
                    locationName: "updatedAt",
                    type: "timestamp"
                  },
                  OrganizationStatistics: {
                    locationName: "organizationStatistics",
                    type: "structure",
                    members: {
                      TotalAccountsCount: {
                        locationName: "totalAccountsCount",
                        type: "integer"
                      },
                      MemberAccountsCount: {
                        locationName: "memberAccountsCount",
                        type: "integer"
                      },
                      ActiveAccountsCount: {
                        locationName: "activeAccountsCount",
                        type: "integer"
                      },
                      EnabledAccountsCount: {
                        locationName: "enabledAccountsCount",
                        type: "integer"
                      },
                      CountByFeature: {
                        locationName: "countByFeature",
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            Name: {
                              locationName: "name"
                            },
                            EnabledAccountsCount: {
                              locationName: "enabledAccountsCount",
                              type: "integer"
                            },
                            AdditionalConfiguration: {
                              locationName: "additionalConfiguration",
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  Name: {
                                    locationName: "name"
                                  },
                                  EnabledAccountsCount: {
                                    locationName: "enabledAccountsCount",
                                    type: "integer"
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetRemainingFreeTrialDays: {
          http: {
            requestUri: "/detector/{detectorId}/freeTrial/daysRemaining",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              AccountIds: {
                shape: "S25",
                locationName: "accountIds"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Accounts: {
                locationName: "accounts",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AccountId: {
                      locationName: "accountId"
                    },
                    DataSources: {
                      deprecated: true,
                      deprecatedMessage: "This parameter is deprecated, use Features instead",
                      locationName: "dataSources",
                      type: "structure",
                      members: {
                        CloudTrail: {
                          shape: "S9n",
                          locationName: "cloudTrail"
                        },
                        DnsLogs: {
                          shape: "S9n",
                          locationName: "dnsLogs"
                        },
                        FlowLogs: {
                          shape: "S9n",
                          locationName: "flowLogs"
                        },
                        S3Logs: {
                          shape: "S9n",
                          locationName: "s3Logs"
                        },
                        Kubernetes: {
                          locationName: "kubernetes",
                          type: "structure",
                          members: {
                            AuditLogs: {
                              shape: "S9n",
                              locationName: "auditLogs"
                            }
                          }
                        },
                        MalwareProtection: {
                          locationName: "malwareProtection",
                          type: "structure",
                          members: {
                            ScanEc2InstanceWithFindings: {
                              shape: "S9n",
                              locationName: "scanEc2InstanceWithFindings"
                            }
                          }
                        }
                      }
                    },
                    Features: {
                      locationName: "features",
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Name: {
                            locationName: "name"
                          },
                          FreeTrialDaysRemaining: {
                            locationName: "freeTrialDaysRemaining",
                            type: "integer"
                          }
                        }
                      }
                    }
                  }
                }
              },
              UnprocessedAccounts: {
                shape: "S1r",
                locationName: "unprocessedAccounts"
              }
            }
          }
        },
        GetThreatIntelSet: {
          http: {
            method: "GET",
            requestUri: "/detector/{detectorId}/threatintelset/{threatIntelSetId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "ThreatIntelSetId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              ThreatIntelSetId: {
                location: "uri",
                locationName: "threatIntelSetId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name",
              "Format",
              "Location",
              "Status"
            ],
            members: {
              Name: {
                locationName: "name"
              },
              Format: {
                locationName: "format"
              },
              Location: {
                locationName: "location"
              },
              Status: {
                locationName: "status"
              },
              Tags: {
                shape: "Sl",
                locationName: "tags"
              }
            }
          }
        },
        GetUsageStatistics: {
          http: {
            requestUri: "/detector/{detectorId}/usage/statistics",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "UsageStatisticType",
              "UsageCriteria"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              UsageStatisticType: {
                locationName: "usageStatisticsType"
              },
              UsageCriteria: {
                locationName: "usageCriteria",
                type: "structure",
                members: {
                  AccountIds: {
                    shape: "S25",
                    locationName: "accountIds"
                  },
                  DataSources: {
                    deprecated: true,
                    deprecatedMessage: "This parameter is deprecated, use Features instead",
                    locationName: "dataSources",
                    type: "list",
                    member: {}
                  },
                  Resources: {
                    locationName: "resources",
                    type: "list",
                    member: {}
                  },
                  Features: {
                    locationName: "features",
                    type: "list",
                    member: {}
                  }
                }
              },
              Unit: {
                locationName: "unit"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UsageStatistics: {
                locationName: "usageStatistics",
                type: "structure",
                members: {
                  SumByAccount: {
                    locationName: "sumByAccount",
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        AccountId: {
                          locationName: "accountId"
                        },
                        Total: {
                          shape: "Sa8",
                          locationName: "total"
                        }
                      }
                    }
                  },
                  TopAccountsByFeature: {
                    locationName: "topAccountsByFeature",
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Feature: {
                          locationName: "feature"
                        },
                        Accounts: {
                          locationName: "accounts",
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              AccountId: {
                                locationName: "accountId"
                              },
                              Total: {
                                shape: "Sa8",
                                locationName: "total"
                              }
                            }
                          }
                        }
                      }
                    }
                  },
                  SumByDataSource: {
                    locationName: "sumByDataSource",
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        DataSource: {
                          locationName: "dataSource"
                        },
                        Total: {
                          shape: "Sa8",
                          locationName: "total"
                        }
                      }
                    }
                  },
                  SumByResource: {
                    shape: "Saf",
                    locationName: "sumByResource"
                  },
                  TopResources: {
                    shape: "Saf",
                    locationName: "topResources"
                  },
                  SumByFeature: {
                    locationName: "sumByFeature",
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Feature: {
                          locationName: "feature"
                        },
                        Total: {
                          shape: "Sa8",
                          locationName: "total"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        InviteMembers: {
          http: {
            requestUri: "/detector/{detectorId}/member/invite",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "AccountIds"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              AccountIds: {
                shape: "S25",
                locationName: "accountIds"
              },
              DisableEmailNotification: {
                locationName: "disableEmailNotification",
                type: "boolean"
              },
              Message: {
                locationName: "message"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UnprocessedAccounts"
            ],
            members: {
              UnprocessedAccounts: {
                shape: "S1r",
                locationName: "unprocessedAccounts"
              }
            }
          }
        },
        ListCoverage: {
          http: {
            requestUri: "/detector/{detectorId}/coverage",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              NextToken: {
                locationName: "nextToken"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              FilterCriteria: {
                shape: "S49",
                locationName: "filterCriteria"
              },
              SortCriteria: {
                locationName: "sortCriteria",
                type: "structure",
                members: {
                  AttributeName: {
                    locationName: "attributeName"
                  },
                  OrderBy: {
                    locationName: "orderBy"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Resources"
            ],
            members: {
              Resources: {
                locationName: "resources",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceId: {
                      locationName: "resourceId"
                    },
                    DetectorId: {
                      locationName: "detectorId"
                    },
                    AccountId: {
                      locationName: "accountId"
                    },
                    ResourceDetails: {
                      locationName: "resourceDetails",
                      type: "structure",
                      members: {
                        EksClusterDetails: {
                          locationName: "eksClusterDetails",
                          type: "structure",
                          members: {
                            ClusterName: {
                              locationName: "clusterName"
                            },
                            CoveredNodes: {
                              locationName: "coveredNodes",
                              type: "long"
                            },
                            CompatibleNodes: {
                              locationName: "compatibleNodes",
                              type: "long"
                            },
                            AddonDetails: {
                              locationName: "addonDetails",
                              type: "structure",
                              members: {
                                AddonVersion: {
                                  locationName: "addonVersion"
                                },
                                AddonStatus: {
                                  locationName: "addonStatus"
                                }
                              }
                            },
                            ManagementType: {
                              locationName: "managementType"
                            }
                          }
                        },
                        ResourceType: {
                          locationName: "resourceType"
                        },
                        EcsClusterDetails: {
                          locationName: "ecsClusterDetails",
                          type: "structure",
                          members: {
                            ClusterName: {
                              locationName: "clusterName"
                            },
                            FargateDetails: {
                              locationName: "fargateDetails",
                              type: "structure",
                              members: {
                                Issues: {
                                  locationName: "issues",
                                  type: "list",
                                  member: {}
                                },
                                ManagementType: {
                                  locationName: "managementType"
                                }
                              }
                            },
                            ContainerInstanceDetails: {
                              locationName: "containerInstanceDetails",
                              type: "structure",
                              members: {
                                CoveredContainerInstances: {
                                  locationName: "coveredContainerInstances",
                                  type: "long"
                                },
                                CompatibleContainerInstances: {
                                  locationName: "compatibleContainerInstances",
                                  type: "long"
                                }
                              }
                            }
                          }
                        },
                        Ec2InstanceDetails: {
                          locationName: "ec2InstanceDetails",
                          type: "structure",
                          members: {
                            InstanceId: {
                              locationName: "instanceId"
                            },
                            InstanceType: {
                              locationName: "instanceType"
                            },
                            ClusterArn: {
                              locationName: "clusterArn"
                            },
                            AgentDetails: {
                              locationName: "agentDetails",
                              type: "structure",
                              members: {
                                Version: {
                                  locationName: "version"
                                }
                              }
                            },
                            ManagementType: {
                              locationName: "managementType"
                            }
                          }
                        }
                      }
                    },
                    CoverageStatus: {
                      locationName: "coverageStatus"
                    },
                    Issue: {
                      locationName: "issue"
                    },
                    UpdatedAt: {
                      locationName: "updatedAt",
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListDetectors: {
          http: {
            method: "GET",
            requestUri: "/detector",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DetectorIds"
            ],
            members: {
              DetectorIds: {
                locationName: "detectorIds",
                type: "list",
                member: {}
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListFilters: {
          http: {
            method: "GET",
            requestUri: "/detector/{detectorId}/filter",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "FilterNames"
            ],
            members: {
              FilterNames: {
                locationName: "filterNames",
                type: "list",
                member: {}
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListFindings: {
          http: {
            requestUri: "/detector/{detectorId}/findings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              FindingCriteria: {
                shape: "S16",
                locationName: "findingCriteria"
              },
              SortCriteria: {
                shape: "S2u",
                locationName: "sortCriteria"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "FindingIds"
            ],
            members: {
              FindingIds: {
                shape: "S8",
                locationName: "findingIds"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListIPSets: {
          http: {
            method: "GET",
            requestUri: "/detector/{detectorId}/ipset",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "IpSetIds"
            ],
            members: {
              IpSetIds: {
                locationName: "ipSetIds",
                type: "list",
                member: {}
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListInvitations: {
          http: {
            method: "GET",
            requestUri: "/invitation",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Invitations: {
                locationName: "invitations",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AccountId: {
                      locationName: "accountId"
                    },
                    InvitationId: {
                      locationName: "invitationId"
                    },
                    RelationshipStatus: {
                      locationName: "relationshipStatus"
                    },
                    InvitedAt: {
                      locationName: "invitedAt"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListMembers: {
          http: {
            method: "GET",
            requestUri: "/detector/{detectorId}/member",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              OnlyAssociated: {
                location: "querystring",
                locationName: "onlyAssociated"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Members: {
                shape: "S99",
                locationName: "members"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListOrganizationAdminAccounts: {
          http: {
            method: "GET",
            requestUri: "/admin",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AdminAccounts: {
                locationName: "adminAccounts",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AdminAccountId: {
                      locationName: "adminAccountId"
                    },
                    AdminStatus: {
                      locationName: "adminStatus"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListPublishingDestinations: {
          http: {
            method: "GET",
            requestUri: "/detector/{detectorId}/publishingDestination",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Destinations"
            ],
            members: {
              Destinations: {
                locationName: "destinations",
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "DestinationId",
                    "DestinationType",
                    "Status"
                  ],
                  members: {
                    DestinationId: {
                      locationName: "destinationId"
                    },
                    DestinationType: {
                      locationName: "destinationType"
                    },
                    Status: {
                      locationName: "status"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sl",
                locationName: "tags"
              }
            }
          }
        },
        ListThreatIntelSets: {
          http: {
            method: "GET",
            requestUri: "/detector/{detectorId}/threatintelset",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ThreatIntelSetIds"
            ],
            members: {
              ThreatIntelSetIds: {
                locationName: "threatIntelSetIds",
                type: "list",
                member: {}
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        StartMalwareScan: {
          http: {
            requestUri: "/malware-scan/start",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ScanId: {
                locationName: "scanId"
              }
            }
          }
        },
        StartMonitoringMembers: {
          http: {
            requestUri: "/detector/{detectorId}/member/start",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "AccountIds"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              AccountIds: {
                shape: "S25",
                locationName: "accountIds"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UnprocessedAccounts"
            ],
            members: {
              UnprocessedAccounts: {
                shape: "S1r",
                locationName: "unprocessedAccounts"
              }
            }
          }
        },
        StopMonitoringMembers: {
          http: {
            requestUri: "/detector/{detectorId}/member/stop",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "AccountIds"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              AccountIds: {
                shape: "S25",
                locationName: "accountIds"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UnprocessedAccounts"
            ],
            members: {
              UnprocessedAccounts: {
                shape: "S1r",
                locationName: "unprocessedAccounts"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              Tags: {
                shape: "Sl",
                locationName: "tags"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UnarchiveFindings: {
          http: {
            requestUri: "/detector/{detectorId}/findings/unarchive",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "FindingIds"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              FindingIds: {
                shape: "S8",
                locationName: "findingIds"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDetector: {
          http: {
            requestUri: "/detector/{detectorId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              Enable: {
                locationName: "enable",
                type: "boolean"
              },
              FindingPublishingFrequency: {
                locationName: "findingPublishingFrequency"
              },
              DataSources: {
                shape: "Sf",
                deprecated: true,
                deprecatedMessage: "This parameter is deprecated, use Features instead",
                locationName: "dataSources"
              },
              Features: {
                shape: "So",
                locationName: "features"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateFilter: {
          http: {
            requestUri: "/detector/{detectorId}/filter/{filterName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "FilterName"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              FilterName: {
                location: "uri",
                locationName: "filterName"
              },
              Description: {
                locationName: "description"
              },
              Action: {
                locationName: "action"
              },
              Rank: {
                locationName: "rank",
                type: "integer"
              },
              FindingCriteria: {
                shape: "S16",
                locationName: "findingCriteria"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                locationName: "name"
              }
            }
          }
        },
        UpdateFindingsFeedback: {
          http: {
            requestUri: "/detector/{detectorId}/findings/feedback",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "FindingIds",
              "Feedback"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              FindingIds: {
                shape: "S8",
                locationName: "findingIds"
              },
              Feedback: {
                locationName: "feedback"
              },
              Comments: {
                locationName: "comments"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateIPSet: {
          http: {
            requestUri: "/detector/{detectorId}/ipset/{ipSetId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "IpSetId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              IpSetId: {
                location: "uri",
                locationName: "ipSetId"
              },
              Name: {
                locationName: "name"
              },
              Location: {
                locationName: "location"
              },
              Activate: {
                locationName: "activate",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateMalwareScanSettings: {
          http: {
            requestUri: "/detector/{detectorId}/malware-scan-settings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              ScanResourceCriteria: {
                shape: "S8p",
                locationName: "scanResourceCriteria"
              },
              EbsSnapshotPreservation: {
                locationName: "ebsSnapshotPreservation"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateMemberDetectors: {
          http: {
            requestUri: "/detector/{detectorId}/member/detector/update",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "AccountIds"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              AccountIds: {
                shape: "S25",
                locationName: "accountIds"
              },
              DataSources: {
                shape: "Sf",
                deprecated: true,
                deprecatedMessage: "This parameter is deprecated, use Features instead",
                locationName: "dataSources"
              },
              Features: {
                locationName: "features",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {
                      locationName: "name"
                    },
                    Status: {
                      locationName: "status"
                    },
                    AdditionalConfiguration: {
                      locationName: "additionalConfiguration",
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Name: {
                            locationName: "name"
                          },
                          Status: {
                            locationName: "status"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UnprocessedAccounts"
            ],
            members: {
              UnprocessedAccounts: {
                shape: "S1r",
                locationName: "unprocessedAccounts"
              }
            }
          }
        },
        UpdateOrganizationConfiguration: {
          http: {
            requestUri: "/detector/{detectorId}/admin",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              AutoEnable: {
                deprecated: true,
                deprecatedMessage: "This field is deprecated, use AutoEnableOrganizationMembers instead",
                locationName: "autoEnable",
                type: "boolean"
              },
              DataSources: {
                deprecated: true,
                deprecatedMessage: "This parameter is deprecated, use Features instead",
                locationName: "dataSources",
                type: "structure",
                members: {
                  S3Logs: {
                    locationName: "s3Logs",
                    type: "structure",
                    required: [
                      "AutoEnable"
                    ],
                    members: {
                      AutoEnable: {
                        locationName: "autoEnable",
                        type: "boolean"
                      }
                    }
                  },
                  Kubernetes: {
                    locationName: "kubernetes",
                    type: "structure",
                    required: [
                      "AuditLogs"
                    ],
                    members: {
                      AuditLogs: {
                        locationName: "auditLogs",
                        type: "structure",
                        required: [
                          "AutoEnable"
                        ],
                        members: {
                          AutoEnable: {
                            locationName: "autoEnable",
                            type: "boolean"
                          }
                        }
                      }
                    }
                  },
                  MalwareProtection: {
                    locationName: "malwareProtection",
                    type: "structure",
                    members: {
                      ScanEc2InstanceWithFindings: {
                        locationName: "scanEc2InstanceWithFindings",
                        type: "structure",
                        members: {
                          EbsVolumes: {
                            locationName: "ebsVolumes",
                            type: "structure",
                            members: {
                              AutoEnable: {
                                locationName: "autoEnable",
                                type: "boolean"
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              Features: {
                locationName: "features",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {
                      locationName: "name"
                    },
                    AutoEnable: {
                      locationName: "autoEnable"
                    },
                    AdditionalConfiguration: {
                      locationName: "additionalConfiguration",
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Name: {
                            locationName: "name"
                          },
                          AutoEnable: {
                            locationName: "autoEnable"
                          }
                        }
                      }
                    }
                  }
                }
              },
              AutoEnableOrganizationMembers: {
                locationName: "autoEnableOrganizationMembers"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdatePublishingDestination: {
          http: {
            requestUri: "/detector/{detectorId}/publishingDestination/{destinationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "DestinationId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              DestinationId: {
                location: "uri",
                locationName: "destinationId"
              },
              DestinationProperties: {
                shape: "S1v",
                locationName: "destinationProperties"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateThreatIntelSet: {
          http: {
            requestUri: "/detector/{detectorId}/threatintelset/{threatIntelSetId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "ThreatIntelSetId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              ThreatIntelSetId: {
                location: "uri",
                locationName: "threatIntelSetId"
              },
              Name: {
                locationName: "name"
              },
              Location: {
                locationName: "location"
              },
              Activate: {
                locationName: "activate",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S8: {
          type: "list",
          member: {}
        },
        Sf: {
          type: "structure",
          members: {
            S3Logs: {
              locationName: "s3Logs",
              type: "structure",
              required: [
                "Enable"
              ],
              members: {
                Enable: {
                  locationName: "enable",
                  type: "boolean"
                }
              }
            },
            Kubernetes: {
              locationName: "kubernetes",
              type: "structure",
              required: [
                "AuditLogs"
              ],
              members: {
                AuditLogs: {
                  locationName: "auditLogs",
                  type: "structure",
                  required: [
                    "Enable"
                  ],
                  members: {
                    Enable: {
                      locationName: "enable",
                      type: "boolean"
                    }
                  }
                }
              }
            },
            MalwareProtection: {
              locationName: "malwareProtection",
              type: "structure",
              members: {
                ScanEc2InstanceWithFindings: {
                  locationName: "scanEc2InstanceWithFindings",
                  type: "structure",
                  members: {
                    EbsVolumes: {
                      locationName: "ebsVolumes",
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        Sl: {
          type: "map",
          key: {},
          value: {}
        },
        So: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {
                locationName: "name"
              },
              Status: {
                locationName: "status"
              },
              AdditionalConfiguration: {
                locationName: "additionalConfiguration",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {
                      locationName: "name"
                    },
                    Status: {
                      locationName: "status"
                    }
                  }
                }
              }
            }
          }
        },
        Sx: {
          type: "structure",
          members: {
            ScanEc2InstanceWithFindings: {
              locationName: "scanEc2InstanceWithFindings",
              type: "structure",
              members: {
                EbsVolumes: {
                  locationName: "ebsVolumes",
                  type: "structure",
                  members: {
                    Status: {
                      locationName: "status"
                    },
                    Reason: {
                      locationName: "reason"
                    }
                  }
                }
              }
            },
            ServiceRole: {
              locationName: "serviceRole"
            }
          }
        },
        S16: {
          type: "structure",
          members: {
            Criterion: {
              locationName: "criterion",
              type: "map",
              key: {},
              value: {
                type: "structure",
                members: {
                  Eq: {
                    deprecated: true,
                    locationName: "eq",
                    type: "list",
                    member: {}
                  },
                  Neq: {
                    deprecated: true,
                    locationName: "neq",
                    type: "list",
                    member: {}
                  },
                  Gt: {
                    deprecated: true,
                    locationName: "gt",
                    type: "integer"
                  },
                  Gte: {
                    deprecated: true,
                    locationName: "gte",
                    type: "integer"
                  },
                  Lt: {
                    deprecated: true,
                    locationName: "lt",
                    type: "integer"
                  },
                  Lte: {
                    deprecated: true,
                    locationName: "lte",
                    type: "integer"
                  },
                  Equals: {
                    shape: "S1c",
                    locationName: "equals"
                  },
                  NotEquals: {
                    shape: "S1d",
                    locationName: "notEquals"
                  },
                  GreaterThan: {
                    locationName: "greaterThan",
                    type: "long"
                  },
                  GreaterThanOrEqual: {
                    locationName: "greaterThanOrEqual",
                    type: "long"
                  },
                  LessThan: {
                    locationName: "lessThan",
                    type: "long"
                  },
                  LessThanOrEqual: {
                    locationName: "lessThanOrEqual",
                    type: "long"
                  }
                }
              }
            }
          }
        },
        S1c: {
          type: "list",
          member: {}
        },
        S1d: {
          type: "list",
          member: {}
        },
        S1r: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AccountId",
              "Result"
            ],
            members: {
              AccountId: {
                locationName: "accountId"
              },
              Result: {
                locationName: "result"
              }
            }
          }
        },
        S1v: {
          type: "structure",
          members: {
            DestinationArn: {
              locationName: "destinationArn"
            },
            KmsKeyArn: {
              locationName: "kmsKeyArn"
            }
          }
        },
        S25: {
          type: "list",
          member: {}
        },
        S2u: {
          type: "structure",
          members: {
            AttributeName: {
              locationName: "attributeName"
            },
            OrderBy: {
              locationName: "orderBy"
            }
          }
        },
        S37: {
          type: "list",
          member: {
            type: "structure",
            members: {
              VolumeArn: {
                locationName: "volumeArn"
              },
              VolumeType: {
                locationName: "volumeType"
              },
              DeviceName: {
                locationName: "deviceName"
              },
              VolumeSizeInGB: {
                locationName: "volumeSizeInGB",
                type: "integer"
              },
              EncryptionType: {
                locationName: "encryptionType"
              },
              SnapshotArn: {
                locationName: "snapshotArn"
              },
              KmsKeyArn: {
                locationName: "kmsKeyArn"
              }
            }
          }
        },
        S49: {
          type: "structure",
          members: {
            FilterCriterion: {
              locationName: "filterCriterion",
              type: "list",
              member: {
                type: "structure",
                members: {
                  CriterionKey: {
                    locationName: "criterionKey"
                  },
                  FilterCondition: {
                    locationName: "filterCondition",
                    type: "structure",
                    members: {
                      Equals: {
                        shape: "S1c",
                        locationName: "equals"
                      },
                      NotEquals: {
                        shape: "S1d",
                        locationName: "notEquals"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S4p: {
          type: "structure",
          required: [
            "CloudTrail",
            "DNSLogs",
            "FlowLogs",
            "S3Logs"
          ],
          members: {
            CloudTrail: {
              locationName: "cloudTrail",
              type: "structure",
              required: [
                "Status"
              ],
              members: {
                Status: {
                  locationName: "status"
                }
              }
            },
            DNSLogs: {
              locationName: "dnsLogs",
              type: "structure",
              required: [
                "Status"
              ],
              members: {
                Status: {
                  locationName: "status"
                }
              }
            },
            FlowLogs: {
              locationName: "flowLogs",
              type: "structure",
              required: [
                "Status"
              ],
              members: {
                Status: {
                  locationName: "status"
                }
              }
            },
            S3Logs: {
              locationName: "s3Logs",
              type: "structure",
              required: [
                "Status"
              ],
              members: {
                Status: {
                  locationName: "status"
                }
              }
            },
            Kubernetes: {
              locationName: "kubernetes",
              type: "structure",
              required: [
                "AuditLogs"
              ],
              members: {
                AuditLogs: {
                  locationName: "auditLogs",
                  type: "structure",
                  required: [
                    "Status"
                  ],
                  members: {
                    Status: {
                      locationName: "status"
                    }
                  }
                }
              }
            },
            MalwareProtection: {
              shape: "Sx",
              locationName: "malwareProtection"
            }
          }
        },
        S5d: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {
                locationName: "key"
              },
              Value: {
                locationName: "value"
              }
            }
          }
        },
        S5l: {
          type: "structure",
          members: {
            IgnorePublicAcls: {
              locationName: "ignorePublicAcls",
              type: "boolean"
            },
            RestrictPublicBuckets: {
              locationName: "restrictPublicBuckets",
              type: "boolean"
            },
            BlockPublicAcls: {
              locationName: "blockPublicAcls",
              type: "boolean"
            },
            BlockPublicPolicy: {
              locationName: "blockPublicPolicy",
              type: "boolean"
            }
          }
        },
        S5u: {
          type: "list",
          member: {
            type: "structure",
            members: {
              GroupId: {
                locationName: "groupId"
              },
              GroupName: {
                locationName: "groupName"
              }
            }
          }
        },
        S61: {
          type: "list",
          member: {}
        },
        S65: {
          type: "list",
          member: {
            shape: "S66"
          }
        },
        S66: {
          type: "structure",
          members: {
            ContainerRuntime: {
              locationName: "containerRuntime"
            },
            Id: {
              locationName: "id"
            },
            Name: {
              locationName: "name"
            },
            Image: {
              locationName: "image"
            },
            ImagePrefix: {
              locationName: "imagePrefix"
            },
            VolumeMounts: {
              locationName: "volumeMounts",
              type: "list",
              member: {
                type: "structure",
                members: {
                  Name: {
                    locationName: "name"
                  },
                  MountPath: {
                    locationName: "mountPath"
                  }
                }
              }
            },
            SecurityContext: {
              locationName: "securityContext",
              type: "structure",
              members: {
                Privileged: {
                  locationName: "privileged",
                  type: "boolean"
                },
                AllowPrivilegeEscalation: {
                  locationName: "allowPrivilegeEscalation",
                  type: "boolean"
                }
              }
            }
          }
        },
        S6a: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {
                locationName: "name"
              },
              HostPath: {
                locationName: "hostPath",
                type: "structure",
                members: {
                  Path: {
                    locationName: "path"
                  }
                }
              }
            }
          }
        },
        S6p: {
          type: "structure",
          members: {
            City: {
              locationName: "city",
              type: "structure",
              members: {
                CityName: {
                  locationName: "cityName"
                }
              }
            },
            Country: {
              locationName: "country",
              type: "structure",
              members: {
                CountryCode: {
                  locationName: "countryCode"
                },
                CountryName: {
                  locationName: "countryName"
                }
              }
            },
            GeoLocation: {
              locationName: "geoLocation",
              type: "structure",
              members: {
                Lat: {
                  locationName: "lat",
                  type: "double"
                },
                Lon: {
                  locationName: "lon",
                  type: "double"
                }
              }
            },
            IpAddressV4: {
              locationName: "ipAddressV4"
            },
            Organization: {
              locationName: "organization",
              type: "structure",
              members: {
                Asn: {
                  locationName: "asn"
                },
                AsnOrg: {
                  locationName: "asnOrg"
                },
                Isp: {
                  locationName: "isp"
                },
                Org: {
                  locationName: "org"
                }
              }
            }
          }
        },
        S6y: {
          type: "structure",
          members: {
            Port: {
              locationName: "port",
              type: "integer"
            },
            PortName: {
              locationName: "portName"
            }
          }
        },
        S6z: {
          type: "structure",
          members: {
            IpAddressV4: {
              locationName: "ipAddressV4"
            }
          }
        },
        S7t: {
          type: "structure",
          members: {
            Name: {
              locationName: "name"
            },
            ExecutablePath: {
              locationName: "executablePath"
            },
            ExecutableSha256: {
              locationName: "executableSha256"
            },
            NamespacePid: {
              locationName: "namespacePid",
              type: "integer"
            },
            Pwd: {
              locationName: "pwd"
            },
            Pid: {
              locationName: "pid",
              type: "integer"
            },
            StartTime: {
              locationName: "startTime",
              type: "timestamp"
            },
            Uuid: {
              locationName: "uuid"
            },
            ParentUuid: {
              locationName: "parentUuid"
            },
            User: {
              locationName: "user"
            },
            UserId: {
              locationName: "userId",
              type: "integer"
            },
            Euid: {
              locationName: "euid",
              type: "integer"
            },
            Lineage: {
              locationName: "lineage",
              type: "list",
              member: {
                type: "structure",
                members: {
                  StartTime: {
                    locationName: "startTime",
                    type: "timestamp"
                  },
                  NamespacePid: {
                    locationName: "namespacePid",
                    type: "integer"
                  },
                  UserId: {
                    locationName: "userId",
                    type: "integer"
                  },
                  Name: {
                    locationName: "name"
                  },
                  Pid: {
                    locationName: "pid",
                    type: "integer"
                  },
                  Uuid: {
                    locationName: "uuid"
                  },
                  ExecutablePath: {
                    locationName: "executablePath"
                  },
                  Euid: {
                    locationName: "euid",
                    type: "integer"
                  },
                  ParentUuid: {
                    locationName: "parentUuid"
                  }
                }
              }
            }
          }
        },
        S84: {
          type: "structure",
          members: {
            ProfileType: {
              locationName: "profileType"
            },
            ProfileSubtype: {
              locationName: "profileSubtype"
            },
            Observations: {
              locationName: "observations",
              type: "structure",
              members: {
                Text: {
                  locationName: "text",
                  type: "list",
                  member: {}
                }
              }
            }
          }
        },
        S8p: {
          type: "structure",
          members: {
            Include: {
              shape: "S8q",
              locationName: "include"
            },
            Exclude: {
              shape: "S8q",
              locationName: "exclude"
            }
          }
        },
        S8q: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "MapEquals"
            ],
            members: {
              MapEquals: {
                locationName: "mapEquals",
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key"
                  ],
                  members: {
                    Key: {
                      locationName: "key"
                    },
                    Value: {
                      locationName: "value"
                    }
                  }
                }
              }
            }
          }
        },
        S99: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AccountId",
              "MasterId",
              "Email",
              "RelationshipStatus",
              "UpdatedAt"
            ],
            members: {
              AccountId: {
                locationName: "accountId"
              },
              DetectorId: {
                locationName: "detectorId"
              },
              MasterId: {
                locationName: "masterId"
              },
              Email: {
                locationName: "email"
              },
              RelationshipStatus: {
                locationName: "relationshipStatus"
              },
              InvitedAt: {
                locationName: "invitedAt"
              },
              UpdatedAt: {
                locationName: "updatedAt"
              },
              AdministratorId: {
                locationName: "administratorId"
              }
            }
          }
        },
        S9n: {
          type: "structure",
          members: {
            FreeTrialDaysRemaining: {
              locationName: "freeTrialDaysRemaining",
              type: "integer"
            }
          }
        },
        Sa8: {
          type: "structure",
          members: {
            Amount: {
              locationName: "amount"
            },
            Unit: {
              locationName: "unit"
            }
          }
        },
        Saf: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Resource: {
                locationName: "resource"
              },
              Total: {
                shape: "Sa8",
                locationName: "total"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/guardduty-2017-11-28.paginators.json
var require_guardduty_2017_11_28_paginators = __commonJS({
  "node_modules/aws-sdk/apis/guardduty-2017-11-28.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeMalwareScans: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Scans"
        },
        DescribeOrganizationConfiguration: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        GetUsageStatistics: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListCoverage: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Resources"
        },
        ListDetectors: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "DetectorIds"
        },
        ListFilters: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "FilterNames"
        },
        ListFindings: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "FindingIds"
        },
        ListIPSets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "IpSetIds"
        },
        ListInvitations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Invitations"
        },
        ListMembers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Members"
        },
        ListOrganizationAdminAccounts: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AdminAccounts"
        },
        ListPublishingDestinations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListThreatIntelSets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ThreatIntelSetIds"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/guardduty.js
var require_guardduty = __commonJS({
  "node_modules/aws-sdk/clients/guardduty.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["guardduty"] = {};
    AWS2.GuardDuty = Service.defineService("guardduty", ["2017-11-28"]);
    Object.defineProperty(apiLoader.services["guardduty"], "2017-11-28", {
      get: function get() {
        var model = require_guardduty_2017_11_28_min();
        model.paginators = require_guardduty_2017_11_28_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.GuardDuty;
  }
});

// node_modules/aws-sdk/apis/mq-2017-11-27.min.json
var require_mq_2017_11_27_min = __commonJS({
  "node_modules/aws-sdk/apis/mq-2017-11-27.min.json"(exports2, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2017-11-27",
        endpointPrefix: "mq",
        signingName: "mq",
        serviceFullName: "AmazonMQ",
        serviceId: "mq",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "mq-2017-11-27",
        signatureVersion: "v4"
      },
      operations: {
        CreateBroker: {
          http: {
            requestUri: "/v1/brokers",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AuthenticationStrategy: {
                locationName: "authenticationStrategy"
              },
              AutoMinorVersionUpgrade: {
                locationName: "autoMinorVersionUpgrade",
                type: "boolean"
              },
              BrokerName: {
                locationName: "brokerName"
              },
              Configuration: {
                shape: "S5",
                locationName: "configuration"
              },
              CreatorRequestId: {
                locationName: "creatorRequestId",
                idempotencyToken: true
              },
              DeploymentMode: {
                locationName: "deploymentMode"
              },
              EncryptionOptions: {
                shape: "S8",
                locationName: "encryptionOptions"
              },
              EngineType: {
                locationName: "engineType"
              },
              EngineVersion: {
                locationName: "engineVersion"
              },
              HostInstanceType: {
                locationName: "hostInstanceType"
              },
              LdapServerMetadata: {
                shape: "Sa",
                locationName: "ldapServerMetadata"
              },
              Logs: {
                shape: "Sc",
                locationName: "logs"
              },
              MaintenanceWindowStartTime: {
                shape: "Sd",
                locationName: "maintenanceWindowStartTime"
              },
              PubliclyAccessible: {
                locationName: "publiclyAccessible",
                type: "boolean"
              },
              SecurityGroups: {
                shape: "Sb",
                locationName: "securityGroups"
              },
              StorageType: {
                locationName: "storageType"
              },
              SubnetIds: {
                shape: "Sb",
                locationName: "subnetIds"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              },
              Users: {
                locationName: "users",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ConsoleAccess: {
                      locationName: "consoleAccess",
                      type: "boolean"
                    },
                    Groups: {
                      shape: "Sb",
                      locationName: "groups"
                    },
                    Password: {
                      locationName: "password"
                    },
                    Username: {
                      locationName: "username"
                    },
                    ReplicationUser: {
                      locationName: "replicationUser",
                      type: "boolean"
                    }
                  },
                  required: [
                    "Username",
                    "Password"
                  ]
                }
              },
              DataReplicationMode: {
                locationName: "dataReplicationMode"
              },
              DataReplicationPrimaryBrokerArn: {
                locationName: "dataReplicationPrimaryBrokerArn"
              }
            },
            required: [
              "EngineVersion",
              "HostInstanceType",
              "AutoMinorVersionUpgrade",
              "Users",
              "BrokerName",
              "DeploymentMode",
              "EngineType",
              "PubliclyAccessible"
            ]
          },
          output: {
            type: "structure",
            members: {
              BrokerArn: {
                locationName: "brokerArn"
              },
              BrokerId: {
                locationName: "brokerId"
              }
            }
          }
        },
        CreateConfiguration: {
          http: {
            requestUri: "/v1/configurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AuthenticationStrategy: {
                locationName: "authenticationStrategy"
              },
              EngineType: {
                locationName: "engineType"
              },
              EngineVersion: {
                locationName: "engineVersion"
              },
              Name: {
                locationName: "name"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              }
            },
            required: [
              "EngineVersion",
              "EngineType",
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              AuthenticationStrategy: {
                locationName: "authenticationStrategy"
              },
              Created: {
                shape: "Sn",
                locationName: "created"
              },
              Id: {
                locationName: "id"
              },
              LatestRevision: {
                shape: "So",
                locationName: "latestRevision"
              },
              Name: {
                locationName: "name"
              }
            }
          }
        },
        CreateTags: {
          http: {
            requestUri: "/v1/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              }
            },
            required: [
              "ResourceArn"
            ]
          }
        },
        CreateUser: {
          http: {
            requestUri: "/v1/brokers/{broker-id}/users/{username}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BrokerId: {
                location: "uri",
                locationName: "broker-id"
              },
              ConsoleAccess: {
                locationName: "consoleAccess",
                type: "boolean"
              },
              Groups: {
                shape: "Sb",
                locationName: "groups"
              },
              Password: {
                locationName: "password"
              },
              Username: {
                location: "uri",
                locationName: "username"
              },
              ReplicationUser: {
                locationName: "replicationUser",
                type: "boolean"
              }
            },
            required: [
              "Username",
              "BrokerId",
              "Password"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteBroker: {
          http: {
            method: "DELETE",
            requestUri: "/v1/brokers/{broker-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BrokerId: {
                location: "uri",
                locationName: "broker-id"
              }
            },
            required: [
              "BrokerId"
            ]
          },
          output: {
            type: "structure",
            members: {
              BrokerId: {
                locationName: "brokerId"
              }
            }
          }
        },
        DeleteTags: {
          http: {
            method: "DELETE",
            requestUri: "/v1/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              TagKeys: {
                shape: "Sb",
                location: "querystring",
                locationName: "tagKeys"
              }
            },
            required: [
              "TagKeys",
              "ResourceArn"
            ]
          }
        },
        DeleteUser: {
          http: {
            method: "DELETE",
            requestUri: "/v1/brokers/{broker-id}/users/{username}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BrokerId: {
                location: "uri",
                locationName: "broker-id"
              },
              Username: {
                location: "uri",
                locationName: "username"
              }
            },
            required: [
              "Username",
              "BrokerId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeBroker: {
          http: {
            method: "GET",
            requestUri: "/v1/brokers/{broker-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BrokerId: {
                location: "uri",
                locationName: "broker-id"
              }
            },
            required: [
              "BrokerId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ActionsRequired: {
                locationName: "actionsRequired",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ActionRequiredCode: {
                      locationName: "actionRequiredCode"
                    },
                    ActionRequiredInfo: {
                      locationName: "actionRequiredInfo"
                    }
                  }
                }
              },
              AuthenticationStrategy: {
                locationName: "authenticationStrategy"
              },
              AutoMinorVersionUpgrade: {
                locationName: "autoMinorVersionUpgrade",
                type: "boolean"
              },
              BrokerArn: {
                locationName: "brokerArn"
              },
              BrokerId: {
                locationName: "brokerId"
              },
              BrokerInstances: {
                locationName: "brokerInstances",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ConsoleURL: {
                      locationName: "consoleURL"
                    },
                    Endpoints: {
                      shape: "Sb",
                      locationName: "endpoints"
                    },
                    IpAddress: {
                      locationName: "ipAddress"
                    }
                  }
                }
              },
              BrokerName: {
                locationName: "brokerName"
              },
              BrokerState: {
                locationName: "brokerState"
              },
              Configurations: {
                locationName: "configurations",
                type: "structure",
                members: {
                  Current: {
                    shape: "S5",
                    locationName: "current"
                  },
                  History: {
                    locationName: "history",
                    type: "list",
                    member: {
                      shape: "S5"
                    }
                  },
                  Pending: {
                    shape: "S5",
                    locationName: "pending"
                  }
                }
              },
              Created: {
                shape: "Sn",
                locationName: "created"
              },
              DeploymentMode: {
                locationName: "deploymentMode"
              },
              EncryptionOptions: {
                shape: "S8",
                locationName: "encryptionOptions"
              },
              EngineType: {
                locationName: "engineType"
              },
              EngineVersion: {
                locationName: "engineVersion"
              },
              HostInstanceType: {
                locationName: "hostInstanceType"
              },
              LdapServerMetadata: {
                shape: "S16",
                locationName: "ldapServerMetadata"
              },
              Logs: {
                locationName: "logs",
                type: "structure",
                members: {
                  Audit: {
                    locationName: "audit",
                    type: "boolean"
                  },
                  AuditLogGroup: {
                    locationName: "auditLogGroup"
                  },
                  General: {
                    locationName: "general",
                    type: "boolean"
                  },
                  GeneralLogGroup: {
                    locationName: "generalLogGroup"
                  },
                  Pending: {
                    locationName: "pending",
                    type: "structure",
                    members: {
                      Audit: {
                        locationName: "audit",
                        type: "boolean"
                      },
                      General: {
                        locationName: "general",
                        type: "boolean"
                      }
                    }
                  }
                },
                required: [
                  "GeneralLogGroup",
                  "General"
                ]
              },
              MaintenanceWindowStartTime: {
                shape: "Sd",
                locationName: "maintenanceWindowStartTime"
              },
              PendingAuthenticationStrategy: {
                locationName: "pendingAuthenticationStrategy"
              },
              PendingEngineVersion: {
                locationName: "pendingEngineVersion"
              },
              PendingHostInstanceType: {
                locationName: "pendingHostInstanceType"
              },
              PendingLdapServerMetadata: {
                shape: "S16",
                locationName: "pendingLdapServerMetadata"
              },
              PendingSecurityGroups: {
                shape: "Sb",
                locationName: "pendingSecurityGroups"
              },
              PubliclyAccessible: {
                locationName: "publiclyAccessible",
                type: "boolean"
              },
              SecurityGroups: {
                shape: "Sb",
                locationName: "securityGroups"
              },
              StorageType: {
                locationName: "storageType"
              },
              SubnetIds: {
                shape: "Sb",
                locationName: "subnetIds"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              },
              Users: {
                shape: "S19",
                locationName: "users"
              },
              DataReplicationMetadata: {
                shape: "S1c",
                locationName: "dataReplicationMetadata"
              },
              DataReplicationMode: {
                locationName: "dataReplicationMode"
              },
              PendingDataReplicationMetadata: {
                shape: "S1c",
                locationName: "pendingDataReplicationMetadata"
              },
              PendingDataReplicationMode: {
                locationName: "pendingDataReplicationMode"
              }
            }
          }
        },
        DescribeBrokerEngineTypes: {
          http: {
            method: "GET",
            requestUri: "/v1/broker-engine-types",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              EngineType: {
                location: "querystring",
                locationName: "engineType"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BrokerEngineTypes: {
                locationName: "brokerEngineTypes",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EngineType: {
                      locationName: "engineType"
                    },
                    EngineVersions: {
                      locationName: "engineVersions",
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Name: {
                            locationName: "name"
                          }
                        }
                      }
                    }
                  }
                }
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeBrokerInstanceOptions: {
          http: {
            method: "GET",
            requestUri: "/v1/broker-instance-options",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              EngineType: {
                location: "querystring",
                locationName: "engineType"
              },
              HostInstanceType: {
                location: "querystring",
                locationName: "hostInstanceType"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              StorageType: {
                location: "querystring",
                locationName: "storageType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BrokerInstanceOptions: {
                locationName: "brokerInstanceOptions",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AvailabilityZones: {
                      locationName: "availabilityZones",
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Name: {
                            locationName: "name"
                          }
                        }
                      }
                    },
                    EngineType: {
                      locationName: "engineType"
                    },
                    HostInstanceType: {
                      locationName: "hostInstanceType"
                    },
                    StorageType: {
                      locationName: "storageType"
                    },
                    SupportedDeploymentModes: {
                      locationName: "supportedDeploymentModes",
                      type: "list",
                      member: {}
                    },
                    SupportedEngineVersions: {
                      shape: "Sb",
                      locationName: "supportedEngineVersions"
                    }
                  }
                }
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeConfiguration: {
          http: {
            method: "GET",
            requestUri: "/v1/configurations/{configuration-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConfigurationId: {
                location: "uri",
                locationName: "configuration-id"
              }
            },
            required: [
              "ConfigurationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              AuthenticationStrategy: {
                locationName: "authenticationStrategy"
              },
              Created: {
                shape: "Sn",
                locationName: "created"
              },
              Description: {
                locationName: "description"
              },
              EngineType: {
                locationName: "engineType"
              },
              EngineVersion: {
                locationName: "engineVersion"
              },
              Id: {
                locationName: "id"
              },
              LatestRevision: {
                shape: "So",
                locationName: "latestRevision"
              },
              Name: {
                locationName: "name"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              }
            }
          }
        },
        DescribeConfigurationRevision: {
          http: {
            method: "GET",
            requestUri: "/v1/configurations/{configuration-id}/revisions/{configuration-revision}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConfigurationId: {
                location: "uri",
                locationName: "configuration-id"
              },
              ConfigurationRevision: {
                location: "uri",
                locationName: "configuration-revision"
              }
            },
            required: [
              "ConfigurationRevision",
              "ConfigurationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ConfigurationId: {
                locationName: "configurationId"
              },
              Created: {
                shape: "Sn",
                locationName: "created"
              },
              Data: {
                locationName: "data"
              },
              Description: {
                locationName: "description"
              }
            }
          }
        },
        DescribeUser: {
          http: {
            method: "GET",
            requestUri: "/v1/brokers/{broker-id}/users/{username}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BrokerId: {
                location: "uri",
                locationName: "broker-id"
              },
              Username: {
                location: "uri",
                locationName: "username"
              }
            },
            required: [
              "Username",
              "BrokerId"
            ]
          },
          output: {
            type: "structure",
            members: {
              BrokerId: {
                locationName: "brokerId"
              },
              ConsoleAccess: {
                locationName: "consoleAccess",
                type: "boolean"
              },
              Groups: {
                shape: "Sb",
                locationName: "groups"
              },
              Pending: {
                locationName: "pending",
                type: "structure",
                members: {
                  ConsoleAccess: {
                    locationName: "consoleAccess",
                    type: "boolean"
                  },
                  Groups: {
                    shape: "Sb",
                    locationName: "groups"
                  },
                  PendingChange: {
                    locationName: "pendingChange"
                  }
                },
                required: [
                  "PendingChange"
                ]
              },
              Username: {
                locationName: "username"
              },
              ReplicationUser: {
                locationName: "replicationUser",
                type: "boolean"
              }
            }
          }
        },
        ListBrokers: {
          http: {
            method: "GET",
            requestUri: "/v1/brokers",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BrokerSummaries: {
                locationName: "brokerSummaries",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    BrokerArn: {
                      locationName: "brokerArn"
                    },
                    BrokerId: {
                      locationName: "brokerId"
                    },
                    BrokerName: {
                      locationName: "brokerName"
                    },
                    BrokerState: {
                      locationName: "brokerState"
                    },
                    Created: {
                      shape: "Sn",
                      locationName: "created"
                    },
                    DeploymentMode: {
                      locationName: "deploymentMode"
                    },
                    EngineType: {
                      locationName: "engineType"
                    },
                    HostInstanceType: {
                      locationName: "hostInstanceType"
                    }
                  },
                  required: [
                    "DeploymentMode",
                    "EngineType"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListConfigurationRevisions: {
          http: {
            method: "GET",
            requestUri: "/v1/configurations/{configuration-id}/revisions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConfigurationId: {
                location: "uri",
                locationName: "configuration-id"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "ConfigurationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ConfigurationId: {
                locationName: "configurationId"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              },
              Revisions: {
                locationName: "revisions",
                type: "list",
                member: {
                  shape: "So"
                }
              }
            }
          }
        },
        ListConfigurations: {
          http: {
            method: "GET",
            requestUri: "/v1/configurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Configurations: {
                locationName: "configurations",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {
                      locationName: "arn"
                    },
                    AuthenticationStrategy: {
                      locationName: "authenticationStrategy"
                    },
                    Created: {
                      shape: "Sn",
                      locationName: "created"
                    },
                    Description: {
                      locationName: "description"
                    },
                    EngineType: {
                      locationName: "engineType"
                    },
                    EngineVersion: {
                      locationName: "engineVersion"
                    },
                    Id: {
                      locationName: "id"
                    },
                    LatestRevision: {
                      shape: "So",
                      locationName: "latestRevision"
                    },
                    Name: {
                      locationName: "name"
                    },
                    Tags: {
                      shape: "Sg",
                      locationName: "tags"
                    }
                  },
                  required: [
                    "Description",
                    "EngineVersion",
                    "LatestRevision",
                    "AuthenticationStrategy",
                    "EngineType",
                    "Id",
                    "Arn",
                    "Name",
                    "Created"
                  ]
                }
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListTags: {
          http: {
            method: "GET",
            requestUri: "/v1/tags/{resource-arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              }
            },
            required: [
              "ResourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sg",
                locationName: "tags"
              }
            }
          }
        },
        ListUsers: {
          http: {
            method: "GET",
            requestUri: "/v1/brokers/{broker-id}/users",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BrokerId: {
                location: "uri",
                locationName: "broker-id"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "BrokerId"
            ]
          },
          output: {
            type: "structure",
            members: {
              BrokerId: {
                locationName: "brokerId"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              },
              Users: {
                shape: "S19",
                locationName: "users"
              }
            }
          }
        },
        Promote: {
          http: {
            requestUri: "/v1/brokers/{broker-id}/promote",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BrokerId: {
                location: "uri",
                locationName: "broker-id"
              },
              Mode: {
                locationName: "mode"
              }
            },
            required: [
              "BrokerId",
              "Mode"
            ]
          },
          output: {
            type: "structure",
            members: {
              BrokerId: {
                locationName: "brokerId"
              }
            }
          }
        },
        RebootBroker: {
          http: {
            requestUri: "/v1/brokers/{broker-id}/reboot",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BrokerId: {
                location: "uri",
                locationName: "broker-id"
              }
            },
            required: [
              "BrokerId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateBroker: {
          http: {
            method: "PUT",
            requestUri: "/v1/brokers/{broker-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AuthenticationStrategy: {
                locationName: "authenticationStrategy"
              },
              AutoMinorVersionUpgrade: {
                locationName: "autoMinorVersionUpgrade",
                type: "boolean"
              },
              BrokerId: {
                location: "uri",
                locationName: "broker-id"
              },
              Configuration: {
                shape: "S5",
                locationName: "configuration"
              },
              EngineVersion: {
                locationName: "engineVersion"
              },
              HostInstanceType: {
                locationName: "hostInstanceType"
              },
              LdapServerMetadata: {
                shape: "Sa",
                locationName: "ldapServerMetadata"
              },
              Logs: {
                shape: "Sc",
                locationName: "logs"
              },
              MaintenanceWindowStartTime: {
                shape: "Sd",
                locationName: "maintenanceWindowStartTime"
              },
              SecurityGroups: {
                shape: "Sb",
                locationName: "securityGroups"
              },
              DataReplicationMode: {
                locationName: "dataReplicationMode"
              }
            },
            required: [
              "BrokerId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AuthenticationStrategy: {
                locationName: "authenticationStrategy"
              },
              AutoMinorVersionUpgrade: {
                locationName: "autoMinorVersionUpgrade",
                type: "boolean"
              },
              BrokerId: {
                locationName: "brokerId"
              },
              Configuration: {
                shape: "S5",
                locationName: "configuration"
              },
              EngineVersion: {
                locationName: "engineVersion"
              },
              HostInstanceType: {
                locationName: "hostInstanceType"
              },
              LdapServerMetadata: {
                shape: "S16",
                locationName: "ldapServerMetadata"
              },
              Logs: {
                shape: "Sc",
                locationName: "logs"
              },
              MaintenanceWindowStartTime: {
                shape: "Sd",
                locationName: "maintenanceWindowStartTime"
              },
              SecurityGroups: {
                shape: "Sb",
                locationName: "securityGroups"
              },
              DataReplicationMetadata: {
                shape: "S1c",
                locationName: "dataReplicationMetadata"
              },
              DataReplicationMode: {
                locationName: "dataReplicationMode"
              },
              PendingDataReplicationMetadata: {
                shape: "S1c",
                locationName: "pendingDataReplicationMetadata"
              },
              PendingDataReplicationMode: {
                locationName: "pendingDataReplicationMode"
              }
            }
          }
        },
        UpdateConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/v1/configurations/{configuration-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConfigurationId: {
                location: "uri",
                locationName: "configuration-id"
              },
              Data: {
                locationName: "data"
              },
              Description: {
                locationName: "description"
              }
            },
            required: [
              "ConfigurationId",
              "Data"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              Created: {
                shape: "Sn",
                locationName: "created"
              },
              Id: {
                locationName: "id"
              },
              LatestRevision: {
                shape: "So",
                locationName: "latestRevision"
              },
              Name: {
                locationName: "name"
              },
              Warnings: {
                locationName: "warnings",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AttributeName: {
                      locationName: "attributeName"
                    },
                    ElementName: {
                      locationName: "elementName"
                    },
                    Reason: {
                      locationName: "reason"
                    }
                  },
                  required: [
                    "Reason"
                  ]
                }
              }
            }
          }
        },
        UpdateUser: {
          http: {
            method: "PUT",
            requestUri: "/v1/brokers/{broker-id}/users/{username}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BrokerId: {
                location: "uri",
                locationName: "broker-id"
              },
              ConsoleAccess: {
                locationName: "consoleAccess",
                type: "boolean"
              },
              Groups: {
                shape: "Sb",
                locationName: "groups"
              },
              Password: {
                locationName: "password"
              },
              Username: {
                location: "uri",
                locationName: "username"
              },
              ReplicationUser: {
                locationName: "replicationUser",
                type: "boolean"
              }
            },
            required: [
              "Username",
              "BrokerId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          members: {
            Id: {
              locationName: "id"
            },
            Revision: {
              locationName: "revision",
              type: "integer"
            }
          },
          required: [
            "Id"
          ]
        },
        S8: {
          type: "structure",
          members: {
            KmsKeyId: {
              locationName: "kmsKeyId"
            },
            UseAwsOwnedKey: {
              locationName: "useAwsOwnedKey",
              type: "boolean"
            }
          },
          required: [
            "UseAwsOwnedKey"
          ]
        },
        Sa: {
          type: "structure",
          members: {
            Hosts: {
              shape: "Sb",
              locationName: "hosts"
            },
            RoleBase: {
              locationName: "roleBase"
            },
            RoleName: {
              locationName: "roleName"
            },
            RoleSearchMatching: {
              locationName: "roleSearchMatching"
            },
            RoleSearchSubtree: {
              locationName: "roleSearchSubtree",
              type: "boolean"
            },
            ServiceAccountPassword: {
              locationName: "serviceAccountPassword"
            },
            ServiceAccountUsername: {
              locationName: "serviceAccountUsername"
            },
            UserBase: {
              locationName: "userBase"
            },
            UserRoleName: {
              locationName: "userRoleName"
            },
            UserSearchMatching: {
              locationName: "userSearchMatching"
            },
            UserSearchSubtree: {
              locationName: "userSearchSubtree",
              type: "boolean"
            }
          },
          required: [
            "Hosts",
            "UserSearchMatching",
            "UserBase",
            "RoleSearchMatching",
            "ServiceAccountUsername",
            "RoleBase",
            "ServiceAccountPassword"
          ]
        },
        Sb: {
          type: "list",
          member: {}
        },
        Sc: {
          type: "structure",
          members: {
            Audit: {
              locationName: "audit",
              type: "boolean"
            },
            General: {
              locationName: "general",
              type: "boolean"
            }
          }
        },
        Sd: {
          type: "structure",
          members: {
            DayOfWeek: {
              locationName: "dayOfWeek"
            },
            TimeOfDay: {
              locationName: "timeOfDay"
            },
            TimeZone: {
              locationName: "timeZone"
            }
          },
          required: [
            "TimeOfDay",
            "DayOfWeek"
          ]
        },
        Sg: {
          type: "map",
          key: {},
          value: {}
        },
        Sn: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        So: {
          type: "structure",
          members: {
            Created: {
              shape: "Sn",
              locationName: "created"
            },
            Description: {
              locationName: "description"
            },
            Revision: {
              locationName: "revision",
              type: "integer"
            }
          },
          required: [
            "Revision",
            "Created"
          ]
        },
        S16: {
          type: "structure",
          members: {
            Hosts: {
              shape: "Sb",
              locationName: "hosts"
            },
            RoleBase: {
              locationName: "roleBase"
            },
            RoleName: {
              locationName: "roleName"
            },
            RoleSearchMatching: {
              locationName: "roleSearchMatching"
            },
            RoleSearchSubtree: {
              locationName: "roleSearchSubtree",
              type: "boolean"
            },
            ServiceAccountUsername: {
              locationName: "serviceAccountUsername"
            },
            UserBase: {
              locationName: "userBase"
            },
            UserRoleName: {
              locationName: "userRoleName"
            },
            UserSearchMatching: {
              locationName: "userSearchMatching"
            },
            UserSearchSubtree: {
              locationName: "userSearchSubtree",
              type: "boolean"
            }
          },
          required: [
            "Hosts",
            "UserSearchMatching",
            "UserBase",
            "RoleSearchMatching",
            "ServiceAccountUsername",
            "RoleBase"
          ]
        },
        S19: {
          type: "list",
          member: {
            type: "structure",
            members: {
              PendingChange: {
                locationName: "pendingChange"
              },
              Username: {
                locationName: "username"
              }
            },
            required: [
              "Username"
            ]
          }
        },
        S1c: {
          type: "structure",
          members: {
            DataReplicationCounterpart: {
              locationName: "dataReplicationCounterpart",
              type: "structure",
              members: {
                BrokerId: {
                  locationName: "brokerId"
                },
                Region: {
                  locationName: "region"
                }
              },
              required: [
                "BrokerId",
                "Region"
              ]
            },
            DataReplicationRole: {
              locationName: "dataReplicationRole"
            }
          },
          required: [
            "DataReplicationRole"
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/mq-2017-11-27.paginators.json
var require_mq_2017_11_27_paginators = __commonJS({
  "node_modules/aws-sdk/apis/mq-2017-11-27.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListBrokers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "BrokerSummaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/mq.js
var require_mq = __commonJS({
  "node_modules/aws-sdk/clients/mq.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["mq"] = {};
    AWS2.MQ = Service.defineService("mq", ["2017-11-27"]);
    Object.defineProperty(apiLoader.services["mq"], "2017-11-27", {
      get: function get() {
        var model = require_mq_2017_11_27_min();
        model.paginators = require_mq_2017_11_27_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.MQ;
  }
});

// node_modules/aws-sdk/apis/comprehend-2017-11-27.min.json
var require_comprehend_2017_11_27_min = __commonJS({
  "node_modules/aws-sdk/apis/comprehend-2017-11-27.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-11-27",
        endpointPrefix: "comprehend",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Comprehend",
        serviceId: "Comprehend",
        signatureVersion: "v4",
        signingName: "comprehend",
        targetPrefix: "Comprehend_20171127",
        uid: "comprehend-2017-11-27"
      },
      operations: {
        BatchDetectDominantLanguage: {
          input: {
            type: "structure",
            required: [
              "TextList"
            ],
            members: {
              TextList: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ResultList",
              "ErrorList"
            ],
            members: {
              ResultList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Index: {
                      type: "integer"
                    },
                    Languages: {
                      shape: "S8"
                    }
                  }
                }
              },
              ErrorList: {
                shape: "Sc"
              }
            },
            sensitive: true
          }
        },
        BatchDetectEntities: {
          input: {
            type: "structure",
            required: [
              "TextList",
              "LanguageCode"
            ],
            members: {
              TextList: {
                shape: "S2"
              },
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ResultList",
              "ErrorList"
            ],
            members: {
              ResultList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Index: {
                      type: "integer"
                    },
                    Entities: {
                      shape: "Sj"
                    }
                  }
                }
              },
              ErrorList: {
                shape: "Sc"
              }
            },
            sensitive: true
          }
        },
        BatchDetectKeyPhrases: {
          input: {
            type: "structure",
            required: [
              "TextList",
              "LanguageCode"
            ],
            members: {
              TextList: {
                shape: "S2"
              },
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ResultList",
              "ErrorList"
            ],
            members: {
              ResultList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Index: {
                      type: "integer"
                    },
                    KeyPhrases: {
                      shape: "Su"
                    }
                  }
                }
              },
              ErrorList: {
                shape: "Sc"
              }
            },
            sensitive: true
          }
        },
        BatchDetectSentiment: {
          input: {
            type: "structure",
            required: [
              "TextList",
              "LanguageCode"
            ],
            members: {
              TextList: {
                shape: "S2"
              },
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ResultList",
              "ErrorList"
            ],
            members: {
              ResultList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Index: {
                      type: "integer"
                    },
                    Sentiment: {},
                    SentimentScore: {
                      shape: "S11"
                    }
                  }
                }
              },
              ErrorList: {
                shape: "Sc"
              }
            },
            sensitive: true
          }
        },
        BatchDetectSyntax: {
          input: {
            type: "structure",
            required: [
              "TextList",
              "LanguageCode"
            ],
            members: {
              TextList: {
                shape: "S2"
              },
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ResultList",
              "ErrorList"
            ],
            members: {
              ResultList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Index: {
                      type: "integer"
                    },
                    SyntaxTokens: {
                      shape: "S17"
                    }
                  }
                }
              },
              ErrorList: {
                shape: "Sc"
              }
            },
            sensitive: true
          }
        },
        BatchDetectTargetedSentiment: {
          input: {
            type: "structure",
            required: [
              "TextList",
              "LanguageCode"
            ],
            members: {
              TextList: {
                shape: "S2"
              },
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ResultList",
              "ErrorList"
            ],
            members: {
              ResultList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Index: {
                      type: "integer"
                    },
                    Entities: {
                      shape: "S1f"
                    }
                  }
                }
              },
              ErrorList: {
                shape: "Sc"
              }
            },
            sensitive: true
          }
        },
        ClassifyDocument: {
          input: {
            type: "structure",
            required: [
              "EndpointArn"
            ],
            members: {
              Text: {
                shape: "S3"
              },
              EndpointArn: {},
              Bytes: {
                type: "blob"
              },
              DocumentReaderConfig: {
                shape: "S1p"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Classes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Score: {
                      type: "float"
                    },
                    Page: {
                      type: "integer"
                    }
                  }
                }
              },
              Labels: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Score: {
                      type: "float"
                    },
                    Page: {
                      type: "integer"
                    }
                  }
                }
              },
              DocumentMetadata: {
                shape: "S1z"
              },
              DocumentType: {
                shape: "S22"
              },
              Errors: {
                shape: "S25"
              },
              Warnings: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Page: {
                      type: "integer"
                    },
                    WarnCode: {},
                    WarnMessage: {}
                  }
                }
              }
            },
            sensitive: true
          }
        },
        ContainsPiiEntities: {
          input: {
            type: "structure",
            required: [
              "Text",
              "LanguageCode"
            ],
            members: {
              Text: {},
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Labels: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Score: {
                      type: "float"
                    }
                  }
                }
              }
            }
          }
        },
        CreateDataset: {
          input: {
            type: "structure",
            required: [
              "FlywheelArn",
              "DatasetName",
              "InputDataConfig"
            ],
            members: {
              FlywheelArn: {},
              DatasetName: {},
              DatasetType: {},
              Description: {},
              InputDataConfig: {
                type: "structure",
                members: {
                  AugmentedManifests: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "AttributeNames",
                        "S3Uri"
                      ],
                      members: {
                        AttributeNames: {
                          shape: "S2o"
                        },
                        S3Uri: {},
                        AnnotationDataS3Uri: {},
                        SourceDocumentsS3Uri: {},
                        DocumentType: {}
                      }
                    }
                  },
                  DataFormat: {},
                  DocumentClassifierInputDataConfig: {
                    type: "structure",
                    required: [
                      "S3Uri"
                    ],
                    members: {
                      S3Uri: {},
                      LabelDelimiter: {}
                    }
                  },
                  EntityRecognizerInputDataConfig: {
                    type: "structure",
                    required: [
                      "Documents"
                    ],
                    members: {
                      Annotations: {
                        type: "structure",
                        required: [
                          "S3Uri"
                        ],
                        members: {
                          S3Uri: {}
                        }
                      },
                      Documents: {
                        type: "structure",
                        required: [
                          "S3Uri"
                        ],
                        members: {
                          S3Uri: {},
                          InputFormat: {}
                        }
                      },
                      EntityList: {
                        type: "structure",
                        required: [
                          "S3Uri"
                        ],
                        members: {
                          S3Uri: {}
                        }
                      }
                    }
                  }
                }
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S31"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetArn: {}
            }
          }
        },
        CreateDocumentClassifier: {
          input: {
            type: "structure",
            required: [
              "DocumentClassifierName",
              "DataAccessRoleArn",
              "InputDataConfig",
              "LanguageCode"
            ],
            members: {
              DocumentClassifierName: {},
              VersionName: {},
              DataAccessRoleArn: {},
              Tags: {
                shape: "S31"
              },
              InputDataConfig: {
                shape: "S3a"
              },
              OutputDataConfig: {
                shape: "S3h"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              LanguageCode: {},
              VolumeKmsKeyId: {},
              VpcConfig: {
                shape: "S3j"
              },
              Mode: {},
              ModelKmsKeyId: {},
              ModelPolicy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentClassifierArn: {}
            }
          }
        },
        CreateEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointName",
              "DesiredInferenceUnits"
            ],
            members: {
              EndpointName: {},
              ModelArn: {},
              DesiredInferenceUnits: {
                type: "integer"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S31"
              },
              DataAccessRoleArn: {},
              FlywheelArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EndpointArn: {},
              ModelArn: {}
            }
          }
        },
        CreateEntityRecognizer: {
          input: {
            type: "structure",
            required: [
              "RecognizerName",
              "DataAccessRoleArn",
              "InputDataConfig",
              "LanguageCode"
            ],
            members: {
              RecognizerName: {},
              VersionName: {},
              DataAccessRoleArn: {},
              Tags: {
                shape: "S31"
              },
              InputDataConfig: {
                shape: "S3z"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              LanguageCode: {},
              VolumeKmsKeyId: {},
              VpcConfig: {
                shape: "S3j"
              },
              ModelKmsKeyId: {},
              ModelPolicy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EntityRecognizerArn: {}
            }
          }
        },
        CreateFlywheel: {
          input: {
            type: "structure",
            required: [
              "FlywheelName",
              "DataAccessRoleArn",
              "DataLakeS3Uri"
            ],
            members: {
              FlywheelName: {},
              ActiveModelArn: {},
              DataAccessRoleArn: {},
              TaskConfig: {
                shape: "S4b"
              },
              ModelType: {},
              DataLakeS3Uri: {},
              DataSecurityConfig: {
                shape: "S4i"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S31"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FlywheelArn: {},
              ActiveModelArn: {}
            }
          }
        },
        DeleteDocumentClassifier: {
          input: {
            type: "structure",
            required: [
              "DocumentClassifierArn"
            ],
            members: {
              DocumentClassifierArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointArn"
            ],
            members: {
              EndpointArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteEntityRecognizer: {
          input: {
            type: "structure",
            required: [
              "EntityRecognizerArn"
            ],
            members: {
              EntityRecognizerArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteFlywheel: {
          input: {
            type: "structure",
            required: [
              "FlywheelArn"
            ],
            members: {
              FlywheelArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              PolicyRevisionId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeDataset: {
          input: {
            type: "structure",
            required: [
              "DatasetArn"
            ],
            members: {
              DatasetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetProperties: {
                shape: "S4x"
              }
            }
          }
        },
        DescribeDocumentClassificationJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentClassificationJobProperties: {
                shape: "S55"
              }
            }
          }
        },
        DescribeDocumentClassifier: {
          input: {
            type: "structure",
            required: [
              "DocumentClassifierArn"
            ],
            members: {
              DocumentClassifierArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentClassifierProperties: {
                shape: "S5d"
              }
            }
          }
        },
        DescribeDominantLanguageDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DominantLanguageDetectionJobProperties: {
                shape: "S5k"
              }
            }
          }
        },
        DescribeEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointArn"
            ],
            members: {
              EndpointArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EndpointProperties: {
                shape: "S5n"
              }
            }
          }
        },
        DescribeEntitiesDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EntitiesDetectionJobProperties: {
                shape: "S5r"
              }
            }
          }
        },
        DescribeEntityRecognizer: {
          input: {
            type: "structure",
            required: [
              "EntityRecognizerArn"
            ],
            members: {
              EntityRecognizerArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EntityRecognizerProperties: {
                shape: "S5u"
              }
            }
          }
        },
        DescribeEventsDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EventsDetectionJobProperties: {
                shape: "S63"
              }
            }
          }
        },
        DescribeFlywheel: {
          input: {
            type: "structure",
            required: [
              "FlywheelArn"
            ],
            members: {
              FlywheelArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FlywheelProperties: {
                shape: "S68"
              }
            }
          }
        },
        DescribeFlywheelIteration: {
          input: {
            type: "structure",
            required: [
              "FlywheelArn",
              "FlywheelIterationId"
            ],
            members: {
              FlywheelArn: {},
              FlywheelIterationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FlywheelIterationProperties: {
                shape: "S6d"
              }
            }
          }
        },
        DescribeKeyPhrasesDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              KeyPhrasesDetectionJobProperties: {
                shape: "S6i"
              }
            }
          }
        },
        DescribePiiEntitiesDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PiiEntitiesDetectionJobProperties: {
                shape: "S6l"
              }
            }
          }
        },
        DescribeResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourcePolicy: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              PolicyRevisionId: {}
            }
          }
        },
        DescribeSentimentDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SentimentDetectionJobProperties: {
                shape: "S6w"
              }
            }
          }
        },
        DescribeTargetedSentimentDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TargetedSentimentDetectionJobProperties: {
                shape: "S6z"
              }
            }
          }
        },
        DescribeTopicsDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TopicsDetectionJobProperties: {
                shape: "S72"
              }
            }
          }
        },
        DetectDominantLanguage: {
          input: {
            type: "structure",
            required: [
              "Text"
            ],
            members: {
              Text: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Languages: {
                shape: "S8"
              }
            },
            sensitive: true
          }
        },
        DetectEntities: {
          input: {
            type: "structure",
            members: {
              Text: {
                shape: "S3"
              },
              LanguageCode: {},
              EndpointArn: {},
              Bytes: {
                type: "blob"
              },
              DocumentReaderConfig: {
                shape: "S1p"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Entities: {
                shape: "Sj"
              },
              DocumentMetadata: {
                shape: "S1z"
              },
              DocumentType: {
                shape: "S22"
              },
              Blocks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    BlockType: {},
                    Text: {},
                    Page: {
                      type: "integer"
                    },
                    Geometry: {
                      type: "structure",
                      members: {
                        BoundingBox: {
                          type: "structure",
                          members: {
                            Height: {
                              type: "float"
                            },
                            Left: {
                              type: "float"
                            },
                            Top: {
                              type: "float"
                            },
                            Width: {
                              type: "float"
                            }
                          }
                        },
                        Polygon: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              X: {
                                type: "float"
                              },
                              Y: {
                                type: "float"
                              }
                            }
                          }
                        }
                      }
                    },
                    Relationships: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Ids: {
                            type: "list",
                            member: {}
                          },
                          Type: {}
                        }
                      }
                    }
                  }
                }
              },
              Errors: {
                shape: "S25"
              }
            },
            sensitive: true
          }
        },
        DetectKeyPhrases: {
          input: {
            type: "structure",
            required: [
              "Text",
              "LanguageCode"
            ],
            members: {
              Text: {
                shape: "S3"
              },
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              KeyPhrases: {
                shape: "Su"
              }
            },
            sensitive: true
          }
        },
        DetectPiiEntities: {
          input: {
            type: "structure",
            required: [
              "Text",
              "LanguageCode"
            ],
            members: {
              Text: {},
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Entities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Score: {
                      type: "float"
                    },
                    Type: {},
                    BeginOffset: {
                      type: "integer"
                    },
                    EndOffset: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        DetectSentiment: {
          input: {
            type: "structure",
            required: [
              "Text",
              "LanguageCode"
            ],
            members: {
              Text: {
                shape: "S3"
              },
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Sentiment: {},
              SentimentScore: {
                shape: "S11"
              }
            },
            sensitive: true
          }
        },
        DetectSyntax: {
          input: {
            type: "structure",
            required: [
              "Text",
              "LanguageCode"
            ],
            members: {
              Text: {
                shape: "S3"
              },
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SyntaxTokens: {
                shape: "S17"
              }
            },
            sensitive: true
          }
        },
        DetectTargetedSentiment: {
          input: {
            type: "structure",
            required: [
              "Text",
              "LanguageCode"
            ],
            members: {
              Text: {
                shape: "S3"
              },
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Entities: {
                shape: "S1f"
              }
            },
            sensitive: true
          }
        },
        DetectToxicContent: {
          input: {
            type: "structure",
            required: [
              "TextSegments",
              "LanguageCode"
            ],
            members: {
              TextSegments: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Text"
                  ],
                  members: {
                    Text: {
                      shape: "S3"
                    }
                  }
                },
                sensitive: true
              },
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResultList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Labels: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Name: {},
                          Score: {
                            type: "float"
                          }
                        }
                      }
                    },
                    Toxicity: {
                      type: "float"
                    }
                  }
                }
              }
            }
          }
        },
        ImportModel: {
          input: {
            type: "structure",
            required: [
              "SourceModelArn"
            ],
            members: {
              SourceModelArn: {},
              ModelName: {},
              VersionName: {},
              ModelKmsKeyId: {},
              DataAccessRoleArn: {},
              Tags: {
                shape: "S31"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ModelArn: {}
            }
          }
        },
        ListDatasets: {
          input: {
            type: "structure",
            members: {
              FlywheelArn: {},
              Filter: {
                type: "structure",
                members: {
                  Status: {},
                  DatasetType: {},
                  CreationTimeAfter: {
                    type: "timestamp"
                  },
                  CreationTimeBefore: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetPropertiesList: {
                type: "list",
                member: {
                  shape: "S4x"
                }
              },
              NextToken: {}
            }
          }
        },
        ListDocumentClassificationJobs: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                members: {
                  JobName: {},
                  JobStatus: {},
                  SubmitTimeBefore: {
                    type: "timestamp"
                  },
                  SubmitTimeAfter: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentClassificationJobPropertiesList: {
                type: "list",
                member: {
                  shape: "S55"
                }
              },
              NextToken: {}
            }
          }
        },
        ListDocumentClassifierSummaries: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentClassifierSummariesList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DocumentClassifierName: {},
                    NumberOfVersions: {
                      type: "integer"
                    },
                    LatestVersionCreatedAt: {
                      type: "timestamp"
                    },
                    LatestVersionName: {},
                    LatestVersionStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDocumentClassifiers: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                members: {
                  Status: {},
                  DocumentClassifierName: {},
                  SubmitTimeBefore: {
                    type: "timestamp"
                  },
                  SubmitTimeAfter: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentClassifierPropertiesList: {
                type: "list",
                member: {
                  shape: "S5d"
                }
              },
              NextToken: {}
            }
          }
        },
        ListDominantLanguageDetectionJobs: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                members: {
                  JobName: {},
                  JobStatus: {},
                  SubmitTimeBefore: {
                    type: "timestamp"
                  },
                  SubmitTimeAfter: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DominantLanguageDetectionJobPropertiesList: {
                type: "list",
                member: {
                  shape: "S5k"
                }
              },
              NextToken: {}
            }
          }
        },
        ListEndpoints: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                members: {
                  ModelArn: {},
                  Status: {},
                  CreationTimeBefore: {
                    type: "timestamp"
                  },
                  CreationTimeAfter: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EndpointPropertiesList: {
                type: "list",
                member: {
                  shape: "S5n"
                }
              },
              NextToken: {}
            }
          }
        },
        ListEntitiesDetectionJobs: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                members: {
                  JobName: {},
                  JobStatus: {},
                  SubmitTimeBefore: {
                    type: "timestamp"
                  },
                  SubmitTimeAfter: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EntitiesDetectionJobPropertiesList: {
                type: "list",
                member: {
                  shape: "S5r"
                }
              },
              NextToken: {}
            }
          }
        },
        ListEntityRecognizerSummaries: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EntityRecognizerSummariesList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RecognizerName: {},
                    NumberOfVersions: {
                      type: "integer"
                    },
                    LatestVersionCreatedAt: {
                      type: "timestamp"
                    },
                    LatestVersionName: {},
                    LatestVersionStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEntityRecognizers: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                members: {
                  Status: {},
                  RecognizerName: {},
                  SubmitTimeBefore: {
                    type: "timestamp"
                  },
                  SubmitTimeAfter: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EntityRecognizerPropertiesList: {
                type: "list",
                member: {
                  shape: "S5u"
                }
              },
              NextToken: {}
            }
          }
        },
        ListEventsDetectionJobs: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                members: {
                  JobName: {},
                  JobStatus: {},
                  SubmitTimeBefore: {
                    type: "timestamp"
                  },
                  SubmitTimeAfter: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventsDetectionJobPropertiesList: {
                type: "list",
                member: {
                  shape: "S63"
                }
              },
              NextToken: {}
            }
          }
        },
        ListFlywheelIterationHistory: {
          input: {
            type: "structure",
            required: [
              "FlywheelArn"
            ],
            members: {
              FlywheelArn: {},
              Filter: {
                type: "structure",
                members: {
                  CreationTimeAfter: {
                    type: "timestamp"
                  },
                  CreationTimeBefore: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FlywheelIterationPropertiesList: {
                type: "list",
                member: {
                  shape: "S6d"
                }
              },
              NextToken: {}
            }
          }
        },
        ListFlywheels: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                members: {
                  Status: {},
                  CreationTimeAfter: {
                    type: "timestamp"
                  },
                  CreationTimeBefore: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FlywheelSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FlywheelArn: {},
                    ActiveModelArn: {},
                    DataLakeS3Uri: {},
                    Status: {},
                    ModelType: {},
                    Message: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    LatestFlywheelIteration: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListKeyPhrasesDetectionJobs: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                members: {
                  JobName: {},
                  JobStatus: {},
                  SubmitTimeBefore: {
                    type: "timestamp"
                  },
                  SubmitTimeAfter: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KeyPhrasesDetectionJobPropertiesList: {
                type: "list",
                member: {
                  shape: "S6i"
                }
              },
              NextToken: {}
            }
          }
        },
        ListPiiEntitiesDetectionJobs: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                members: {
                  JobName: {},
                  JobStatus: {},
                  SubmitTimeBefore: {
                    type: "timestamp"
                  },
                  SubmitTimeAfter: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PiiEntitiesDetectionJobPropertiesList: {
                type: "list",
                member: {
                  shape: "S6l"
                }
              },
              NextToken: {}
            }
          }
        },
        ListSentimentDetectionJobs: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                members: {
                  JobName: {},
                  JobStatus: {},
                  SubmitTimeBefore: {
                    type: "timestamp"
                  },
                  SubmitTimeAfter: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SentimentDetectionJobPropertiesList: {
                type: "list",
                member: {
                  shape: "S6w"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S31"
              }
            }
          }
        },
        ListTargetedSentimentDetectionJobs: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                members: {
                  JobName: {},
                  JobStatus: {},
                  SubmitTimeBefore: {
                    type: "timestamp"
                  },
                  SubmitTimeAfter: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TargetedSentimentDetectionJobPropertiesList: {
                type: "list",
                member: {
                  shape: "S6z"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTopicsDetectionJobs: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                members: {
                  JobName: {},
                  JobStatus: {},
                  SubmitTimeBefore: {
                    type: "timestamp"
                  },
                  SubmitTimeAfter: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TopicsDetectionJobPropertiesList: {
                type: "list",
                member: {
                  shape: "S72"
                }
              },
              NextToken: {}
            }
          }
        },
        PutResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "ResourcePolicy"
            ],
            members: {
              ResourceArn: {},
              ResourcePolicy: {},
              PolicyRevisionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyRevisionId: {}
            }
          }
        },
        StartDocumentClassificationJob: {
          input: {
            type: "structure",
            required: [
              "InputDataConfig",
              "OutputDataConfig",
              "DataAccessRoleArn"
            ],
            members: {
              JobName: {},
              DocumentClassifierArn: {},
              InputDataConfig: {
                shape: "S59"
              },
              OutputDataConfig: {
                shape: "S5a"
              },
              DataAccessRoleArn: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              VolumeKmsKeyId: {},
              VpcConfig: {
                shape: "S3j"
              },
              Tags: {
                shape: "S31"
              },
              FlywheelArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobArn: {},
              JobStatus: {},
              DocumentClassifierArn: {}
            }
          }
        },
        StartDominantLanguageDetectionJob: {
          input: {
            type: "structure",
            required: [
              "InputDataConfig",
              "OutputDataConfig",
              "DataAccessRoleArn"
            ],
            members: {
              InputDataConfig: {
                shape: "S59"
              },
              OutputDataConfig: {
                shape: "S5a"
              },
              DataAccessRoleArn: {},
              JobName: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              VolumeKmsKeyId: {},
              VpcConfig: {
                shape: "S3j"
              },
              Tags: {
                shape: "S31"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobArn: {},
              JobStatus: {}
            }
          }
        },
        StartEntitiesDetectionJob: {
          input: {
            type: "structure",
            required: [
              "InputDataConfig",
              "OutputDataConfig",
              "DataAccessRoleArn",
              "LanguageCode"
            ],
            members: {
              InputDataConfig: {
                shape: "S59"
              },
              OutputDataConfig: {
                shape: "S5a"
              },
              DataAccessRoleArn: {},
              JobName: {},
              EntityRecognizerArn: {},
              LanguageCode: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              VolumeKmsKeyId: {},
              VpcConfig: {
                shape: "S3j"
              },
              Tags: {
                shape: "S31"
              },
              FlywheelArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobArn: {},
              JobStatus: {},
              EntityRecognizerArn: {}
            }
          }
        },
        StartEventsDetectionJob: {
          input: {
            type: "structure",
            required: [
              "InputDataConfig",
              "OutputDataConfig",
              "DataAccessRoleArn",
              "LanguageCode",
              "TargetEventTypes"
            ],
            members: {
              InputDataConfig: {
                shape: "S59"
              },
              OutputDataConfig: {
                shape: "S5a"
              },
              DataAccessRoleArn: {},
              JobName: {},
              LanguageCode: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              TargetEventTypes: {
                shape: "S64"
              },
              Tags: {
                shape: "S31"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobArn: {},
              JobStatus: {}
            }
          }
        },
        StartFlywheelIteration: {
          input: {
            type: "structure",
            required: [
              "FlywheelArn"
            ],
            members: {
              FlywheelArn: {},
              ClientRequestToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FlywheelArn: {},
              FlywheelIterationId: {}
            }
          }
        },
        StartKeyPhrasesDetectionJob: {
          input: {
            type: "structure",
            required: [
              "InputDataConfig",
              "OutputDataConfig",
              "DataAccessRoleArn",
              "LanguageCode"
            ],
            members: {
              InputDataConfig: {
                shape: "S59"
              },
              OutputDataConfig: {
                shape: "S5a"
              },
              DataAccessRoleArn: {},
              JobName: {},
              LanguageCode: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              VolumeKmsKeyId: {},
              VpcConfig: {
                shape: "S3j"
              },
              Tags: {
                shape: "S31"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobArn: {},
              JobStatus: {}
            }
          }
        },
        StartPiiEntitiesDetectionJob: {
          input: {
            type: "structure",
            required: [
              "InputDataConfig",
              "OutputDataConfig",
              "Mode",
              "DataAccessRoleArn",
              "LanguageCode"
            ],
            members: {
              InputDataConfig: {
                shape: "S59"
              },
              OutputDataConfig: {
                shape: "S5a"
              },
              Mode: {},
              RedactionConfig: {
                shape: "S6n"
              },
              DataAccessRoleArn: {},
              JobName: {},
              LanguageCode: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S31"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobArn: {},
              JobStatus: {}
            }
          }
        },
        StartSentimentDetectionJob: {
          input: {
            type: "structure",
            required: [
              "InputDataConfig",
              "OutputDataConfig",
              "DataAccessRoleArn",
              "LanguageCode"
            ],
            members: {
              InputDataConfig: {
                shape: "S59"
              },
              OutputDataConfig: {
                shape: "S5a"
              },
              DataAccessRoleArn: {},
              JobName: {},
              LanguageCode: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              VolumeKmsKeyId: {},
              VpcConfig: {
                shape: "S3j"
              },
              Tags: {
                shape: "S31"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobArn: {},
              JobStatus: {}
            }
          }
        },
        StartTargetedSentimentDetectionJob: {
          input: {
            type: "structure",
            required: [
              "InputDataConfig",
              "OutputDataConfig",
              "DataAccessRoleArn",
              "LanguageCode"
            ],
            members: {
              InputDataConfig: {
                shape: "S59"
              },
              OutputDataConfig: {
                shape: "S5a"
              },
              DataAccessRoleArn: {},
              JobName: {},
              LanguageCode: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              VolumeKmsKeyId: {},
              VpcConfig: {
                shape: "S3j"
              },
              Tags: {
                shape: "S31"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobArn: {},
              JobStatus: {}
            }
          }
        },
        StartTopicsDetectionJob: {
          input: {
            type: "structure",
            required: [
              "InputDataConfig",
              "OutputDataConfig",
              "DataAccessRoleArn"
            ],
            members: {
              InputDataConfig: {
                shape: "S59"
              },
              OutputDataConfig: {
                shape: "S5a"
              },
              DataAccessRoleArn: {},
              JobName: {},
              NumberOfTopics: {
                type: "integer"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              VolumeKmsKeyId: {},
              VpcConfig: {
                shape: "S3j"
              },
              Tags: {
                shape: "S31"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobArn: {},
              JobStatus: {}
            }
          }
        },
        StopDominantLanguageDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobStatus: {}
            }
          }
        },
        StopEntitiesDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobStatus: {}
            }
          }
        },
        StopEventsDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobStatus: {}
            }
          }
        },
        StopKeyPhrasesDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobStatus: {}
            }
          }
        },
        StopPiiEntitiesDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobStatus: {}
            }
          }
        },
        StopSentimentDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobStatus: {}
            }
          }
        },
        StopTargetedSentimentDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobStatus: {}
            }
          }
        },
        StopTrainingDocumentClassifier: {
          input: {
            type: "structure",
            required: [
              "DocumentClassifierArn"
            ],
            members: {
              DocumentClassifierArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StopTrainingEntityRecognizer: {
          input: {
            type: "structure",
            required: [
              "EntityRecognizerArn"
            ],
            members: {
              EntityRecognizerArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S31"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointArn"
            ],
            members: {
              EndpointArn: {},
              DesiredModelArn: {},
              DesiredInferenceUnits: {
                type: "integer"
              },
              DesiredDataAccessRoleArn: {},
              FlywheelArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DesiredModelArn: {}
            }
          }
        },
        UpdateFlywheel: {
          input: {
            type: "structure",
            required: [
              "FlywheelArn"
            ],
            members: {
              FlywheelArn: {},
              ActiveModelArn: {},
              DataAccessRoleArn: {},
              DataSecurityConfig: {
                type: "structure",
                members: {
                  ModelKmsKeyId: {},
                  VolumeKmsKeyId: {},
                  VpcConfig: {
                    shape: "S3j"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FlywheelProperties: {
                shape: "S68"
              }
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "list",
          member: {
            shape: "S3"
          },
          sensitive: true
        },
        S3: {
          type: "string",
          sensitive: true
        },
        S8: {
          type: "list",
          member: {
            type: "structure",
            members: {
              LanguageCode: {},
              Score: {
                type: "float"
              }
            }
          }
        },
        Sc: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Index: {
                type: "integer"
              },
              ErrorCode: {},
              ErrorMessage: {}
            }
          }
        },
        Sj: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Score: {
                type: "float"
              },
              Type: {},
              Text: {},
              BeginOffset: {
                type: "integer"
              },
              EndOffset: {
                type: "integer"
              },
              BlockReferences: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    BlockId: {},
                    BeginOffset: {
                      type: "integer"
                    },
                    EndOffset: {
                      type: "integer"
                    },
                    ChildBlocks: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ChildBlockId: {},
                          BeginOffset: {
                            type: "integer"
                          },
                          EndOffset: {
                            type: "integer"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Su: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Score: {
                type: "float"
              },
              Text: {},
              BeginOffset: {
                type: "integer"
              },
              EndOffset: {
                type: "integer"
              }
            }
          }
        },
        S11: {
          type: "structure",
          members: {
            Positive: {
              type: "float"
            },
            Negative: {
              type: "float"
            },
            Neutral: {
              type: "float"
            },
            Mixed: {
              type: "float"
            }
          }
        },
        S17: {
          type: "list",
          member: {
            type: "structure",
            members: {
              TokenId: {
                type: "integer"
              },
              Text: {},
              BeginOffset: {
                type: "integer"
              },
              EndOffset: {
                type: "integer"
              },
              PartOfSpeech: {
                type: "structure",
                members: {
                  Tag: {},
                  Score: {
                    type: "float"
                  }
                }
              }
            }
          }
        },
        S1f: {
          type: "list",
          member: {
            type: "structure",
            members: {
              DescriptiveMentionIndex: {
                type: "list",
                member: {
                  type: "integer"
                }
              },
              Mentions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Score: {
                      type: "float"
                    },
                    GroupScore: {
                      type: "float"
                    },
                    Text: {},
                    Type: {},
                    MentionSentiment: {
                      type: "structure",
                      members: {
                        Sentiment: {},
                        SentimentScore: {
                          shape: "S11"
                        }
                      }
                    },
                    BeginOffset: {
                      type: "integer"
                    },
                    EndOffset: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        S1p: {
          type: "structure",
          required: [
            "DocumentReadAction"
          ],
          members: {
            DocumentReadAction: {},
            DocumentReadMode: {},
            FeatureTypes: {
              type: "list",
              member: {}
            }
          }
        },
        S1z: {
          type: "structure",
          members: {
            Pages: {
              type: "integer"
            },
            ExtractedCharacters: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Page: {
                    type: "integer"
                  },
                  Count: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        S22: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Page: {
                type: "integer"
              },
              Type: {}
            }
          }
        },
        S25: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Page: {
                type: "integer"
              },
              ErrorCode: {},
              ErrorMessage: {}
            }
          }
        },
        S2o: {
          type: "list",
          member: {}
        },
        S31: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S3a: {
          type: "structure",
          members: {
            DataFormat: {},
            S3Uri: {},
            TestS3Uri: {},
            LabelDelimiter: {},
            AugmentedManifests: {
              type: "list",
              member: {
                shape: "S3d"
              }
            },
            DocumentType: {},
            Documents: {
              type: "structure",
              required: [
                "S3Uri"
              ],
              members: {
                S3Uri: {},
                TestS3Uri: {}
              }
            },
            DocumentReaderConfig: {
              shape: "S1p"
            }
          }
        },
        S3d: {
          type: "structure",
          required: [
            "S3Uri",
            "AttributeNames"
          ],
          members: {
            S3Uri: {},
            Split: {},
            AttributeNames: {
              shape: "S2o"
            },
            AnnotationDataS3Uri: {},
            SourceDocumentsS3Uri: {},
            DocumentType: {}
          }
        },
        S3h: {
          type: "structure",
          members: {
            S3Uri: {},
            KmsKeyId: {},
            FlywheelStatsS3Prefix: {}
          }
        },
        S3j: {
          type: "structure",
          required: [
            "SecurityGroupIds",
            "Subnets"
          ],
          members: {
            SecurityGroupIds: {
              type: "list",
              member: {}
            },
            Subnets: {
              type: "list",
              member: {}
            }
          }
        },
        S3z: {
          type: "structure",
          required: [
            "EntityTypes"
          ],
          members: {
            DataFormat: {},
            EntityTypes: {
              shape: "S41"
            },
            Documents: {
              type: "structure",
              required: [
                "S3Uri"
              ],
              members: {
                S3Uri: {},
                TestS3Uri: {},
                InputFormat: {}
              }
            },
            Annotations: {
              type: "structure",
              required: [
                "S3Uri"
              ],
              members: {
                S3Uri: {},
                TestS3Uri: {}
              }
            },
            EntityList: {
              type: "structure",
              required: [
                "S3Uri"
              ],
              members: {
                S3Uri: {}
              }
            },
            AugmentedManifests: {
              type: "list",
              member: {
                shape: "S3d"
              }
            }
          }
        },
        S41: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Type"
            ],
            members: {
              Type: {}
            }
          }
        },
        S4b: {
          type: "structure",
          required: [
            "LanguageCode"
          ],
          members: {
            LanguageCode: {},
            DocumentClassificationConfig: {
              type: "structure",
              required: [
                "Mode"
              ],
              members: {
                Mode: {},
                Labels: {
                  type: "list",
                  member: {}
                }
              }
            },
            EntityRecognitionConfig: {
              type: "structure",
              required: [
                "EntityTypes"
              ],
              members: {
                EntityTypes: {
                  shape: "S41"
                }
              }
            }
          }
        },
        S4i: {
          type: "structure",
          members: {
            ModelKmsKeyId: {},
            VolumeKmsKeyId: {},
            DataLakeKmsKeyId: {},
            VpcConfig: {
              shape: "S3j"
            }
          }
        },
        S4x: {
          type: "structure",
          members: {
            DatasetArn: {},
            DatasetName: {},
            DatasetType: {},
            DatasetS3Uri: {},
            Description: {},
            Status: {},
            Message: {},
            NumberOfDocuments: {
              type: "long"
            },
            CreationTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            }
          }
        },
        S55: {
          type: "structure",
          members: {
            JobId: {},
            JobArn: {},
            JobName: {},
            JobStatus: {},
            Message: {},
            SubmitTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            DocumentClassifierArn: {},
            InputDataConfig: {
              shape: "S59"
            },
            OutputDataConfig: {
              shape: "S5a"
            },
            DataAccessRoleArn: {},
            VolumeKmsKeyId: {},
            VpcConfig: {
              shape: "S3j"
            },
            FlywheelArn: {}
          }
        },
        S59: {
          type: "structure",
          required: [
            "S3Uri"
          ],
          members: {
            S3Uri: {},
            InputFormat: {},
            DocumentReaderConfig: {
              shape: "S1p"
            }
          }
        },
        S5a: {
          type: "structure",
          required: [
            "S3Uri"
          ],
          members: {
            S3Uri: {},
            KmsKeyId: {}
          }
        },
        S5d: {
          type: "structure",
          members: {
            DocumentClassifierArn: {},
            LanguageCode: {},
            Status: {},
            Message: {},
            SubmitTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            TrainingStartTime: {
              type: "timestamp"
            },
            TrainingEndTime: {
              type: "timestamp"
            },
            InputDataConfig: {
              shape: "S3a"
            },
            OutputDataConfig: {
              shape: "S3h"
            },
            ClassifierMetadata: {
              type: "structure",
              members: {
                NumberOfLabels: {
                  type: "integer"
                },
                NumberOfTrainedDocuments: {
                  type: "integer"
                },
                NumberOfTestDocuments: {
                  type: "integer"
                },
                EvaluationMetrics: {
                  type: "structure",
                  members: {
                    Accuracy: {
                      type: "double"
                    },
                    Precision: {
                      type: "double"
                    },
                    Recall: {
                      type: "double"
                    },
                    F1Score: {
                      type: "double"
                    },
                    MicroPrecision: {
                      type: "double"
                    },
                    MicroRecall: {
                      type: "double"
                    },
                    MicroF1Score: {
                      type: "double"
                    },
                    HammingLoss: {
                      type: "double"
                    }
                  }
                }
              },
              sensitive: true
            },
            DataAccessRoleArn: {},
            VolumeKmsKeyId: {},
            VpcConfig: {
              shape: "S3j"
            },
            Mode: {},
            ModelKmsKeyId: {},
            VersionName: {},
            SourceModelArn: {},
            FlywheelArn: {}
          }
        },
        S5k: {
          type: "structure",
          members: {
            JobId: {},
            JobArn: {},
            JobName: {},
            JobStatus: {},
            Message: {},
            SubmitTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            InputDataConfig: {
              shape: "S59"
            },
            OutputDataConfig: {
              shape: "S5a"
            },
            DataAccessRoleArn: {},
            VolumeKmsKeyId: {},
            VpcConfig: {
              shape: "S3j"
            }
          }
        },
        S5n: {
          type: "structure",
          members: {
            EndpointArn: {},
            Status: {},
            Message: {},
            ModelArn: {},
            DesiredModelArn: {},
            DesiredInferenceUnits: {
              type: "integer"
            },
            CurrentInferenceUnits: {
              type: "integer"
            },
            CreationTime: {
              type: "timestamp"
            },
            LastModifiedTime: {
              type: "timestamp"
            },
            DataAccessRoleArn: {},
            DesiredDataAccessRoleArn: {},
            FlywheelArn: {}
          }
        },
        S5r: {
          type: "structure",
          members: {
            JobId: {},
            JobArn: {},
            JobName: {},
            JobStatus: {},
            Message: {},
            SubmitTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            EntityRecognizerArn: {},
            InputDataConfig: {
              shape: "S59"
            },
            OutputDataConfig: {
              shape: "S5a"
            },
            LanguageCode: {},
            DataAccessRoleArn: {},
            VolumeKmsKeyId: {},
            VpcConfig: {
              shape: "S3j"
            },
            FlywheelArn: {}
          }
        },
        S5u: {
          type: "structure",
          members: {
            EntityRecognizerArn: {},
            LanguageCode: {},
            Status: {},
            Message: {},
            SubmitTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            TrainingStartTime: {
              type: "timestamp"
            },
            TrainingEndTime: {
              type: "timestamp"
            },
            InputDataConfig: {
              shape: "S3z"
            },
            RecognizerMetadata: {
              type: "structure",
              members: {
                NumberOfTrainedDocuments: {
                  type: "integer"
                },
                NumberOfTestDocuments: {
                  type: "integer"
                },
                EvaluationMetrics: {
                  type: "structure",
                  members: {
                    Precision: {
                      type: "double"
                    },
                    Recall: {
                      type: "double"
                    },
                    F1Score: {
                      type: "double"
                    }
                  }
                },
                EntityTypes: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      Type: {},
                      EvaluationMetrics: {
                        type: "structure",
                        members: {
                          Precision: {
                            type: "double"
                          },
                          Recall: {
                            type: "double"
                          },
                          F1Score: {
                            type: "double"
                          }
                        }
                      },
                      NumberOfTrainMentions: {
                        type: "integer"
                      }
                    }
                  }
                }
              },
              sensitive: true
            },
            DataAccessRoleArn: {},
            VolumeKmsKeyId: {},
            VpcConfig: {
              shape: "S3j"
            },
            ModelKmsKeyId: {},
            VersionName: {},
            SourceModelArn: {},
            FlywheelArn: {},
            OutputDataConfig: {
              type: "structure",
              members: {
                FlywheelStatsS3Prefix: {}
              }
            }
          }
        },
        S63: {
          type: "structure",
          members: {
            JobId: {},
            JobArn: {},
            JobName: {},
            JobStatus: {},
            Message: {},
            SubmitTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            InputDataConfig: {
              shape: "S59"
            },
            OutputDataConfig: {
              shape: "S5a"
            },
            LanguageCode: {},
            DataAccessRoleArn: {},
            TargetEventTypes: {
              shape: "S64"
            }
          }
        },
        S64: {
          type: "list",
          member: {}
        },
        S68: {
          type: "structure",
          members: {
            FlywheelArn: {},
            ActiveModelArn: {},
            DataAccessRoleArn: {},
            TaskConfig: {
              shape: "S4b"
            },
            DataLakeS3Uri: {},
            DataSecurityConfig: {
              shape: "S4i"
            },
            Status: {},
            ModelType: {},
            Message: {},
            CreationTime: {
              type: "timestamp"
            },
            LastModifiedTime: {
              type: "timestamp"
            },
            LatestFlywheelIteration: {}
          }
        },
        S6d: {
          type: "structure",
          members: {
            FlywheelArn: {},
            FlywheelIterationId: {},
            CreationTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            Status: {},
            Message: {},
            EvaluatedModelArn: {},
            EvaluatedModelMetrics: {
              shape: "S6f"
            },
            TrainedModelArn: {},
            TrainedModelMetrics: {
              shape: "S6f"
            },
            EvaluationManifestS3Prefix: {}
          }
        },
        S6f: {
          type: "structure",
          members: {
            AverageF1Score: {
              type: "double"
            },
            AveragePrecision: {
              type: "double"
            },
            AverageRecall: {
              type: "double"
            },
            AverageAccuracy: {
              type: "double"
            }
          }
        },
        S6i: {
          type: "structure",
          members: {
            JobId: {},
            JobArn: {},
            JobName: {},
            JobStatus: {},
            Message: {},
            SubmitTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            InputDataConfig: {
              shape: "S59"
            },
            OutputDataConfig: {
              shape: "S5a"
            },
            LanguageCode: {},
            DataAccessRoleArn: {},
            VolumeKmsKeyId: {},
            VpcConfig: {
              shape: "S3j"
            }
          }
        },
        S6l: {
          type: "structure",
          members: {
            JobId: {},
            JobArn: {},
            JobName: {},
            JobStatus: {},
            Message: {},
            SubmitTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            InputDataConfig: {
              shape: "S59"
            },
            OutputDataConfig: {
              type: "structure",
              required: [
                "S3Uri"
              ],
              members: {
                S3Uri: {},
                KmsKeyId: {}
              }
            },
            RedactionConfig: {
              shape: "S6n"
            },
            LanguageCode: {},
            DataAccessRoleArn: {},
            Mode: {}
          }
        },
        S6n: {
          type: "structure",
          members: {
            PiiEntityTypes: {
              type: "list",
              member: {}
            },
            MaskMode: {},
            MaskCharacter: {}
          }
        },
        S6w: {
          type: "structure",
          members: {
            JobId: {},
            JobArn: {},
            JobName: {},
            JobStatus: {},
            Message: {},
            SubmitTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            InputDataConfig: {
              shape: "S59"
            },
            OutputDataConfig: {
              shape: "S5a"
            },
            LanguageCode: {},
            DataAccessRoleArn: {},
            VolumeKmsKeyId: {},
            VpcConfig: {
              shape: "S3j"
            }
          }
        },
        S6z: {
          type: "structure",
          members: {
            JobId: {},
            JobArn: {},
            JobName: {},
            JobStatus: {},
            Message: {},
            SubmitTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            InputDataConfig: {
              shape: "S59"
            },
            OutputDataConfig: {
              shape: "S5a"
            },
            LanguageCode: {},
            DataAccessRoleArn: {},
            VolumeKmsKeyId: {},
            VpcConfig: {
              shape: "S3j"
            }
          }
        },
        S72: {
          type: "structure",
          members: {
            JobId: {},
            JobArn: {},
            JobName: {},
            JobStatus: {},
            Message: {},
            SubmitTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            InputDataConfig: {
              shape: "S59"
            },
            OutputDataConfig: {
              shape: "S5a"
            },
            NumberOfTopics: {
              type: "integer"
            },
            DataAccessRoleArn: {},
            VolumeKmsKeyId: {},
            VpcConfig: {
              shape: "S3j"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/comprehend-2017-11-27.paginators.json
var require_comprehend_2017_11_27_paginators = __commonJS({
  "node_modules/aws-sdk/apis/comprehend-2017-11-27.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListDatasets: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListDocumentClassificationJobs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListDocumentClassifierSummaries: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListDocumentClassifiers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListDominantLanguageDetectionJobs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListEndpoints: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "EndpointPropertiesList"
        },
        ListEntitiesDetectionJobs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListEntityRecognizerSummaries: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListEntityRecognizers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListEventsDetectionJobs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListFlywheelIterationHistory: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListFlywheels: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListKeyPhrasesDetectionJobs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListPiiEntitiesDetectionJobs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PiiEntitiesDetectionJobPropertiesList"
        },
        ListSentimentDetectionJobs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListTargetedSentimentDetectionJobs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListTopicsDetectionJobs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/comprehend.js
var require_comprehend = __commonJS({
  "node_modules/aws-sdk/clients/comprehend.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["comprehend"] = {};
    AWS2.Comprehend = Service.defineService("comprehend", ["2017-11-27"]);
    Object.defineProperty(apiLoader.services["comprehend"], "2017-11-27", {
      get: function get() {
        var model = require_comprehend_2017_11_27_min();
        model.paginators = require_comprehend_2017_11_27_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Comprehend;
  }
});

// node_modules/aws-sdk/apis/iot-jobs-data-2017-09-29.min.json
var require_iot_jobs_data_2017_09_29_min = __commonJS({
  "node_modules/aws-sdk/apis/iot-jobs-data-2017-09-29.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-09-29",
        endpointPrefix: "data.jobs.iot",
        protocol: "rest-json",
        serviceFullName: "AWS IoT Jobs Data Plane",
        serviceId: "IoT Jobs Data Plane",
        signatureVersion: "v4",
        signingName: "iot-jobs-data",
        uid: "iot-jobs-data-2017-09-29"
      },
      operations: {
        DescribeJobExecution: {
          http: {
            method: "GET",
            requestUri: "/things/{thingName}/jobs/{jobId}"
          },
          input: {
            type: "structure",
            required: [
              "jobId",
              "thingName"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              includeJobDocument: {
                location: "querystring",
                locationName: "includeJobDocument",
                type: "boolean"
              },
              executionNumber: {
                location: "querystring",
                locationName: "executionNumber",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              execution: {
                shape: "S7"
              }
            }
          }
        },
        GetPendingJobExecutions: {
          http: {
            method: "GET",
            requestUri: "/things/{thingName}/jobs"
          },
          input: {
            type: "structure",
            required: [
              "thingName"
            ],
            members: {
              thingName: {
                location: "uri",
                locationName: "thingName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              inProgressJobs: {
                shape: "Sl"
              },
              queuedJobs: {
                shape: "Sl"
              }
            }
          }
        },
        StartNextPendingJobExecution: {
          http: {
            method: "PUT",
            requestUri: "/things/{thingName}/jobs/$next"
          },
          input: {
            type: "structure",
            required: [
              "thingName"
            ],
            members: {
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              statusDetails: {
                shape: "Sa"
              },
              stepTimeoutInMinutes: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              execution: {
                shape: "S7"
              }
            }
          }
        },
        UpdateJobExecution: {
          http: {
            requestUri: "/things/{thingName}/jobs/{jobId}"
          },
          input: {
            type: "structure",
            required: [
              "jobId",
              "thingName",
              "status"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              status: {},
              statusDetails: {
                shape: "Sa"
              },
              stepTimeoutInMinutes: {
                type: "long"
              },
              expectedVersion: {
                type: "long"
              },
              includeJobExecutionState: {
                type: "boolean"
              },
              includeJobDocument: {
                type: "boolean"
              },
              executionNumber: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              executionState: {
                type: "structure",
                members: {
                  status: {},
                  statusDetails: {
                    shape: "Sa"
                  },
                  versionNumber: {
                    type: "long"
                  }
                }
              },
              jobDocument: {}
            }
          }
        }
      },
      shapes: {
        S7: {
          type: "structure",
          members: {
            jobId: {},
            thingName: {},
            status: {},
            statusDetails: {
              shape: "Sa"
            },
            queuedAt: {
              type: "long"
            },
            startedAt: {
              type: "long"
            },
            lastUpdatedAt: {
              type: "long"
            },
            approximateSecondsBeforeTimedOut: {
              type: "long"
            },
            versionNumber: {
              type: "long"
            },
            executionNumber: {
              type: "long"
            },
            jobDocument: {}
          }
        },
        Sa: {
          type: "map",
          key: {},
          value: {}
        },
        Sl: {
          type: "list",
          member: {
            type: "structure",
            members: {
              jobId: {},
              queuedAt: {
                type: "long"
              },
              startedAt: {
                type: "long"
              },
              lastUpdatedAt: {
                type: "long"
              },
              versionNumber: {
                type: "long"
              },
              executionNumber: {
                type: "long"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iot-jobs-data-2017-09-29.paginators.json
var require_iot_jobs_data_2017_09_29_paginators = __commonJS({
  "node_modules/aws-sdk/apis/iot-jobs-data-2017-09-29.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/iotjobsdataplane.js
var require_iotjobsdataplane = __commonJS({
  "node_modules/aws-sdk/clients/iotjobsdataplane.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["iotjobsdataplane"] = {};
    AWS2.IoTJobsDataPlane = Service.defineService("iotjobsdataplane", ["2017-09-29"]);
    Object.defineProperty(apiLoader.services["iotjobsdataplane"], "2017-09-29", {
      get: function get() {
        var model = require_iot_jobs_data_2017_09_29_min();
        model.paginators = require_iot_jobs_data_2017_09_29_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.IoTJobsDataPlane;
  }
});

// node_modules/aws-sdk/apis/kinesis-video-archived-media-2017-09-30.min.json
var require_kinesis_video_archived_media_2017_09_30_min = __commonJS({
  "node_modules/aws-sdk/apis/kinesis-video-archived-media-2017-09-30.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-09-30",
        endpointPrefix: "kinesisvideo",
        protocol: "rest-json",
        serviceAbbreviation: "Kinesis Video Archived Media",
        serviceFullName: "Amazon Kinesis Video Streams Archived Media",
        serviceId: "Kinesis Video Archived Media",
        signatureVersion: "v4",
        uid: "kinesis-video-archived-media-2017-09-30"
      },
      operations: {
        GetClip: {
          http: {
            requestUri: "/getClip"
          },
          input: {
            type: "structure",
            required: [
              "ClipFragmentSelector"
            ],
            members: {
              StreamName: {},
              StreamARN: {},
              ClipFragmentSelector: {
                type: "structure",
                required: [
                  "FragmentSelectorType",
                  "TimestampRange"
                ],
                members: {
                  FragmentSelectorType: {},
                  TimestampRange: {
                    type: "structure",
                    required: [
                      "StartTimestamp",
                      "EndTimestamp"
                    ],
                    members: {
                      StartTimestamp: {
                        type: "timestamp"
                      },
                      EndTimestamp: {
                        type: "timestamp"
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              Payload: {
                shape: "Sa"
              }
            },
            payload: "Payload"
          }
        },
        GetDASHStreamingSessionURL: {
          http: {
            requestUri: "/getDASHStreamingSessionURL"
          },
          input: {
            type: "structure",
            members: {
              StreamName: {},
              StreamARN: {},
              PlaybackMode: {},
              DisplayFragmentTimestamp: {},
              DisplayFragmentNumber: {},
              DASHFragmentSelector: {
                type: "structure",
                members: {
                  FragmentSelectorType: {},
                  TimestampRange: {
                    type: "structure",
                    members: {
                      StartTimestamp: {
                        type: "timestamp"
                      },
                      EndTimestamp: {
                        type: "timestamp"
                      }
                    }
                  }
                }
              },
              Expires: {
                type: "integer"
              },
              MaxManifestFragmentResults: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DASHStreamingSessionURL: {}
            }
          }
        },
        GetHLSStreamingSessionURL: {
          http: {
            requestUri: "/getHLSStreamingSessionURL"
          },
          input: {
            type: "structure",
            members: {
              StreamName: {},
              StreamARN: {},
              PlaybackMode: {},
              HLSFragmentSelector: {
                type: "structure",
                members: {
                  FragmentSelectorType: {},
                  TimestampRange: {
                    type: "structure",
                    members: {
                      StartTimestamp: {
                        type: "timestamp"
                      },
                      EndTimestamp: {
                        type: "timestamp"
                      }
                    }
                  }
                }
              },
              ContainerFormat: {},
              DiscontinuityMode: {},
              DisplayFragmentTimestamp: {},
              Expires: {
                type: "integer"
              },
              MaxMediaPlaylistFragmentResults: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HLSStreamingSessionURL: {}
            }
          }
        },
        GetImages: {
          http: {
            requestUri: "/getImages"
          },
          input: {
            type: "structure",
            required: [
              "ImageSelectorType",
              "StartTimestamp",
              "EndTimestamp",
              "Format"
            ],
            members: {
              StreamName: {},
              StreamARN: {},
              ImageSelectorType: {},
              StartTimestamp: {
                type: "timestamp"
              },
              EndTimestamp: {
                type: "timestamp"
              },
              SamplingInterval: {
                type: "integer"
              },
              Format: {},
              FormatConfig: {
                type: "map",
                key: {},
                value: {}
              },
              WidthPixels: {
                type: "integer"
              },
              HeightPixels: {
                type: "integer"
              },
              MaxResults: {
                type: "long"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Images: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TimeStamp: {
                      type: "timestamp"
                    },
                    Error: {},
                    ImageContent: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetMediaForFragmentList: {
          http: {
            requestUri: "/getMediaForFragmentList"
          },
          input: {
            type: "structure",
            required: [
              "Fragments"
            ],
            members: {
              StreamName: {},
              StreamARN: {},
              Fragments: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              Payload: {
                shape: "Sa"
              }
            },
            payload: "Payload"
          }
        },
        ListFragments: {
          http: {
            requestUri: "/listFragments"
          },
          input: {
            type: "structure",
            members: {
              StreamName: {},
              StreamARN: {},
              MaxResults: {
                type: "long"
              },
              NextToken: {},
              FragmentSelector: {
                type: "structure",
                required: [
                  "FragmentSelectorType",
                  "TimestampRange"
                ],
                members: {
                  FragmentSelectorType: {},
                  TimestampRange: {
                    type: "structure",
                    required: [
                      "StartTimestamp",
                      "EndTimestamp"
                    ],
                    members: {
                      StartTimestamp: {
                        type: "timestamp"
                      },
                      EndTimestamp: {
                        type: "timestamp"
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Fragments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FragmentNumber: {},
                    FragmentSizeInBytes: {
                      type: "long"
                    },
                    ProducerTimestamp: {
                      type: "timestamp"
                    },
                    ServerTimestamp: {
                      type: "timestamp"
                    },
                    FragmentLengthInMilliseconds: {
                      type: "long"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        }
      },
      shapes: {
        Sa: {
          type: "blob",
          streaming: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/kinesis-video-archived-media-2017-09-30.paginators.json
var require_kinesis_video_archived_media_2017_09_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/kinesis-video-archived-media-2017-09-30.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetImages: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Images"
        },
        ListFragments: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Fragments"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/kinesisvideoarchivedmedia.js
var require_kinesisvideoarchivedmedia = __commonJS({
  "node_modules/aws-sdk/clients/kinesisvideoarchivedmedia.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["kinesisvideoarchivedmedia"] = {};
    AWS2.KinesisVideoArchivedMedia = Service.defineService("kinesisvideoarchivedmedia", ["2017-09-30"]);
    Object.defineProperty(apiLoader.services["kinesisvideoarchivedmedia"], "2017-09-30", {
      get: function get() {
        var model = require_kinesis_video_archived_media_2017_09_30_min();
        model.paginators = require_kinesis_video_archived_media_2017_09_30_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.KinesisVideoArchivedMedia;
  }
});

// node_modules/aws-sdk/apis/kinesis-video-media-2017-09-30.min.json
var require_kinesis_video_media_2017_09_30_min = __commonJS({
  "node_modules/aws-sdk/apis/kinesis-video-media-2017-09-30.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-09-30",
        endpointPrefix: "kinesisvideo",
        protocol: "rest-json",
        serviceAbbreviation: "Kinesis Video Media",
        serviceFullName: "Amazon Kinesis Video Streams Media",
        serviceId: "Kinesis Video Media",
        signatureVersion: "v4",
        uid: "kinesis-video-media-2017-09-30"
      },
      operations: {
        GetMedia: {
          http: {
            requestUri: "/getMedia"
          },
          input: {
            type: "structure",
            required: [
              "StartSelector"
            ],
            members: {
              StreamName: {},
              StreamARN: {},
              StartSelector: {
                type: "structure",
                required: [
                  "StartSelectorType"
                ],
                members: {
                  StartSelectorType: {},
                  AfterFragmentNumber: {},
                  StartTimestamp: {
                    type: "timestamp"
                  },
                  ContinuationToken: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              Payload: {
                type: "blob",
                streaming: true
              }
            },
            payload: "Payload"
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/apis/kinesis-video-media-2017-09-30.paginators.json
var require_kinesis_video_media_2017_09_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/kinesis-video-media-2017-09-30.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/kinesisvideomedia.js
var require_kinesisvideomedia = __commonJS({
  "node_modules/aws-sdk/clients/kinesisvideomedia.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["kinesisvideomedia"] = {};
    AWS2.KinesisVideoMedia = Service.defineService("kinesisvideomedia", ["2017-09-30"]);
    Object.defineProperty(apiLoader.services["kinesisvideomedia"], "2017-09-30", {
      get: function get() {
        var model = require_kinesis_video_media_2017_09_30_min();
        model.paginators = require_kinesis_video_media_2017_09_30_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.KinesisVideoMedia;
  }
});

// node_modules/aws-sdk/apis/kinesisvideo-2017-09-30.min.json
var require_kinesisvideo_2017_09_30_min = __commonJS({
  "node_modules/aws-sdk/apis/kinesisvideo-2017-09-30.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-09-30",
        endpointPrefix: "kinesisvideo",
        protocol: "rest-json",
        serviceAbbreviation: "Kinesis Video",
        serviceFullName: "Amazon Kinesis Video Streams",
        serviceId: "Kinesis Video",
        signatureVersion: "v4",
        uid: "kinesisvideo-2017-09-30"
      },
      operations: {
        CreateSignalingChannel: {
          http: {
            requestUri: "/createSignalingChannel"
          },
          input: {
            type: "structure",
            required: [
              "ChannelName"
            ],
            members: {
              ChannelName: {},
              ChannelType: {},
              SingleMasterConfiguration: {
                shape: "S4"
              },
              Tags: {
                type: "list",
                member: {
                  shape: "S7"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelARN: {}
            }
          }
        },
        CreateStream: {
          http: {
            requestUri: "/createStream"
          },
          input: {
            type: "structure",
            required: [
              "StreamName"
            ],
            members: {
              DeviceName: {},
              StreamName: {},
              MediaType: {},
              KmsKeyId: {},
              DataRetentionInHours: {
                type: "integer"
              },
              Tags: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamARN: {}
            }
          }
        },
        DeleteEdgeConfiguration: {
          http: {
            requestUri: "/deleteEdgeConfiguration"
          },
          input: {
            type: "structure",
            members: {
              StreamName: {},
              StreamARN: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSignalingChannel: {
          http: {
            requestUri: "/deleteSignalingChannel"
          },
          input: {
            type: "structure",
            required: [
              "ChannelARN"
            ],
            members: {
              ChannelARN: {},
              CurrentVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteStream: {
          http: {
            requestUri: "/deleteStream"
          },
          input: {
            type: "structure",
            required: [
              "StreamARN"
            ],
            members: {
              StreamARN: {},
              CurrentVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeEdgeConfiguration: {
          http: {
            requestUri: "/describeEdgeConfiguration"
          },
          input: {
            type: "structure",
            members: {
              StreamName: {},
              StreamARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StreamName: {},
              StreamARN: {},
              CreationTime: {
                type: "timestamp"
              },
              LastUpdatedTime: {
                type: "timestamp"
              },
              SyncStatus: {},
              FailedStatusDetails: {},
              EdgeConfig: {
                shape: "Sw"
              },
              EdgeAgentStatus: {
                type: "structure",
                members: {
                  LastRecorderStatus: {
                    type: "structure",
                    members: {
                      JobStatusDetails: {},
                      LastCollectedTime: {
                        type: "timestamp"
                      },
                      LastUpdatedTime: {
                        type: "timestamp"
                      },
                      RecorderStatus: {}
                    }
                  },
                  LastUploaderStatus: {
                    type: "structure",
                    members: {
                      JobStatusDetails: {},
                      LastCollectedTime: {
                        type: "timestamp"
                      },
                      LastUpdatedTime: {
                        type: "timestamp"
                      },
                      UploaderStatus: {}
                    }
                  }
                }
              }
            }
          }
        },
        DescribeImageGenerationConfiguration: {
          http: {
            requestUri: "/describeImageGenerationConfiguration"
          },
          input: {
            type: "structure",
            members: {
              StreamName: {},
              StreamARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ImageGenerationConfiguration: {
                shape: "S1k"
              }
            }
          }
        },
        DescribeMappedResourceConfiguration: {
          http: {
            requestUri: "/describeMappedResourceConfiguration"
          },
          input: {
            type: "structure",
            members: {
              StreamName: {},
              StreamARN: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MappedResourceConfigurationList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    ARN: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeMediaStorageConfiguration: {
          http: {
            requestUri: "/describeMediaStorageConfiguration"
          },
          input: {
            type: "structure",
            members: {
              ChannelName: {},
              ChannelARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MediaStorageConfiguration: {
                shape: "S26"
              }
            }
          }
        },
        DescribeNotificationConfiguration: {
          http: {
            requestUri: "/describeNotificationConfiguration"
          },
          input: {
            type: "structure",
            members: {
              StreamName: {},
              StreamARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NotificationConfiguration: {
                shape: "S2a"
              }
            }
          }
        },
        DescribeSignalingChannel: {
          http: {
            requestUri: "/describeSignalingChannel"
          },
          input: {
            type: "structure",
            members: {
              ChannelName: {},
              ChannelARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelInfo: {
                shape: "S2e"
              }
            }
          }
        },
        DescribeStream: {
          http: {
            requestUri: "/describeStream"
          },
          input: {
            type: "structure",
            members: {
              StreamName: {},
              StreamARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StreamInfo: {
                shape: "S2i"
              }
            }
          }
        },
        GetDataEndpoint: {
          http: {
            requestUri: "/getDataEndpoint"
          },
          input: {
            type: "structure",
            required: [
              "APIName"
            ],
            members: {
              StreamName: {},
              StreamARN: {},
              APIName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DataEndpoint: {}
            }
          }
        },
        GetSignalingChannelEndpoint: {
          http: {
            requestUri: "/getSignalingChannelEndpoint"
          },
          input: {
            type: "structure",
            required: [
              "ChannelARN"
            ],
            members: {
              ChannelARN: {},
              SingleMasterChannelEndpointConfiguration: {
                type: "structure",
                members: {
                  Protocols: {
                    type: "list",
                    member: {}
                  },
                  Role: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceEndpointList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Protocol: {},
                    ResourceEndpoint: {}
                  }
                }
              }
            }
          }
        },
        ListEdgeAgentConfigurations: {
          http: {
            requestUri: "/listEdgeAgentConfigurations"
          },
          input: {
            type: "structure",
            required: [
              "HubDeviceArn"
            ],
            members: {
              HubDeviceArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EdgeConfigs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StreamName: {},
                    StreamARN: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastUpdatedTime: {
                      type: "timestamp"
                    },
                    SyncStatus: {},
                    FailedStatusDetails: {},
                    EdgeConfig: {
                      shape: "Sw"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSignalingChannels: {
          http: {
            requestUri: "/listSignalingChannels"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              ChannelNameCondition: {
                type: "structure",
                members: {
                  ComparisonOperator: {},
                  ComparisonValue: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelInfoList: {
                type: "list",
                member: {
                  shape: "S2e"
                }
              },
              NextToken: {}
            }
          }
        },
        ListStreams: {
          http: {
            requestUri: "/listStreams"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              StreamNameCondition: {
                type: "structure",
                members: {
                  ComparisonOperator: {},
                  ComparisonValue: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamInfoList: {
                type: "list",
                member: {
                  shape: "S2i"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            requestUri: "/ListTagsForResource"
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              NextToken: {},
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Tags: {
                shape: "Si"
              }
            }
          }
        },
        ListTagsForStream: {
          http: {
            requestUri: "/listTagsForStream"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {},
              StreamARN: {},
              StreamName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Tags: {
                shape: "Si"
              }
            }
          }
        },
        StartEdgeConfigurationUpdate: {
          http: {
            requestUri: "/startEdgeConfigurationUpdate"
          },
          input: {
            type: "structure",
            required: [
              "EdgeConfig"
            ],
            members: {
              StreamName: {},
              StreamARN: {},
              EdgeConfig: {
                shape: "Sw"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamName: {},
              StreamARN: {},
              CreationTime: {
                type: "timestamp"
              },
              LastUpdatedTime: {
                type: "timestamp"
              },
              SyncStatus: {},
              FailedStatusDetails: {},
              EdgeConfig: {
                shape: "Sw"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/TagResource"
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                type: "list",
                member: {
                  shape: "S7"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagStream: {
          http: {
            requestUri: "/tagStream"
          },
          input: {
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              StreamARN: {},
              StreamName: {},
              Tags: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            requestUri: "/UntagResource"
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeyList"
            ],
            members: {
              ResourceARN: {},
              TagKeyList: {
                shape: "S3n"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagStream: {
          http: {
            requestUri: "/untagStream"
          },
          input: {
            type: "structure",
            required: [
              "TagKeyList"
            ],
            members: {
              StreamARN: {},
              StreamName: {},
              TagKeyList: {
                shape: "S3n"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDataRetention: {
          http: {
            requestUri: "/updateDataRetention"
          },
          input: {
            type: "structure",
            required: [
              "CurrentVersion",
              "Operation",
              "DataRetentionChangeInHours"
            ],
            members: {
              StreamName: {},
              StreamARN: {},
              CurrentVersion: {},
              Operation: {},
              DataRetentionChangeInHours: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateImageGenerationConfiguration: {
          http: {
            requestUri: "/updateImageGenerationConfiguration"
          },
          input: {
            type: "structure",
            members: {
              StreamName: {},
              StreamARN: {},
              ImageGenerationConfiguration: {
                shape: "S1k"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateMediaStorageConfiguration: {
          http: {
            requestUri: "/updateMediaStorageConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "ChannelARN",
              "MediaStorageConfiguration"
            ],
            members: {
              ChannelARN: {},
              MediaStorageConfiguration: {
                shape: "S26"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateNotificationConfiguration: {
          http: {
            requestUri: "/updateNotificationConfiguration"
          },
          input: {
            type: "structure",
            members: {
              StreamName: {},
              StreamARN: {},
              NotificationConfiguration: {
                shape: "S2a"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateSignalingChannel: {
          http: {
            requestUri: "/updateSignalingChannel"
          },
          input: {
            type: "structure",
            required: [
              "ChannelARN",
              "CurrentVersion"
            ],
            members: {
              ChannelARN: {},
              CurrentVersion: {},
              SingleMasterConfiguration: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateStream: {
          http: {
            requestUri: "/updateStream"
          },
          input: {
            type: "structure",
            required: [
              "CurrentVersion"
            ],
            members: {
              StreamName: {},
              StreamARN: {},
              CurrentVersion: {},
              DeviceName: {},
              MediaType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            MessageTtlSeconds: {
              type: "integer"
            }
          }
        },
        S7: {
          type: "structure",
          required: [
            "Key",
            "Value"
          ],
          members: {
            Key: {},
            Value: {}
          }
        },
        Si: {
          type: "map",
          key: {},
          value: {}
        },
        Sw: {
          type: "structure",
          required: [
            "HubDeviceArn",
            "RecorderConfig"
          ],
          members: {
            HubDeviceArn: {},
            RecorderConfig: {
              type: "structure",
              required: [
                "MediaSourceConfig"
              ],
              members: {
                MediaSourceConfig: {
                  type: "structure",
                  required: [
                    "MediaUriSecretArn",
                    "MediaUriType"
                  ],
                  members: {
                    MediaUriSecretArn: {
                      type: "string",
                      sensitive: true
                    },
                    MediaUriType: {}
                  }
                },
                ScheduleConfig: {
                  shape: "S12"
                }
              }
            },
            UploaderConfig: {
              type: "structure",
              required: [
                "ScheduleConfig"
              ],
              members: {
                ScheduleConfig: {
                  shape: "S12"
                }
              }
            },
            DeletionConfig: {
              type: "structure",
              members: {
                EdgeRetentionInHours: {
                  type: "integer"
                },
                LocalSizeConfig: {
                  type: "structure",
                  members: {
                    MaxLocalMediaSizeInMB: {
                      type: "integer"
                    },
                    StrategyOnFullSize: {}
                  }
                },
                DeleteAfterUpload: {
                  type: "boolean"
                }
              }
            }
          }
        },
        S12: {
          type: "structure",
          required: [
            "ScheduleExpression",
            "DurationInSeconds"
          ],
          members: {
            ScheduleExpression: {},
            DurationInSeconds: {
              type: "integer"
            }
          }
        },
        S1k: {
          type: "structure",
          required: [
            "Status",
            "ImageSelectorType",
            "DestinationConfig",
            "SamplingInterval",
            "Format"
          ],
          members: {
            Status: {},
            ImageSelectorType: {},
            DestinationConfig: {
              type: "structure",
              required: [
                "Uri",
                "DestinationRegion"
              ],
              members: {
                Uri: {},
                DestinationRegion: {}
              }
            },
            SamplingInterval: {
              type: "integer"
            },
            Format: {},
            FormatConfig: {
              type: "map",
              key: {},
              value: {}
            },
            WidthPixels: {
              type: "integer"
            },
            HeightPixels: {
              type: "integer"
            }
          }
        },
        S26: {
          type: "structure",
          required: [
            "Status"
          ],
          members: {
            StreamARN: {},
            Status: {}
          }
        },
        S2a: {
          type: "structure",
          required: [
            "Status",
            "DestinationConfig"
          ],
          members: {
            Status: {},
            DestinationConfig: {
              type: "structure",
              required: [
                "Uri"
              ],
              members: {
                Uri: {}
              }
            }
          }
        },
        S2e: {
          type: "structure",
          members: {
            ChannelName: {},
            ChannelARN: {},
            ChannelType: {},
            ChannelStatus: {},
            CreationTime: {
              type: "timestamp"
            },
            SingleMasterConfiguration: {
              shape: "S4"
            },
            Version: {}
          }
        },
        S2i: {
          type: "structure",
          members: {
            DeviceName: {},
            StreamName: {},
            StreamARN: {},
            MediaType: {},
            KmsKeyId: {},
            Version: {},
            Status: {},
            CreationTime: {
              type: "timestamp"
            },
            DataRetentionInHours: {
              type: "integer"
            }
          }
        },
        S3n: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/kinesisvideo-2017-09-30.paginators.json
var require_kinesisvideo_2017_09_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/kinesisvideo-2017-09-30.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeMappedResourceConfiguration: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "MappedResourceConfigurationList"
        },
        ListEdgeAgentConfigurations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "EdgeConfigs"
        },
        ListSignalingChannels: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ChannelInfoList"
        },
        ListStreams: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "StreamInfoList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/kinesisvideo.js
var require_kinesisvideo = __commonJS({
  "node_modules/aws-sdk/clients/kinesisvideo.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["kinesisvideo"] = {};
    AWS2.KinesisVideo = Service.defineService("kinesisvideo", ["2017-09-30"]);
    Object.defineProperty(apiLoader.services["kinesisvideo"], "2017-09-30", {
      get: function get() {
        var model = require_kinesisvideo_2017_09_30_min();
        model.paginators = require_kinesisvideo_2017_09_30_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.KinesisVideo;
  }
});

// node_modules/aws-sdk/apis/runtime.sagemaker-2017-05-13.min.json
var require_runtime_sagemaker_2017_05_13_min = __commonJS({
  "node_modules/aws-sdk/apis/runtime.sagemaker-2017-05-13.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-05-13",
        endpointPrefix: "runtime.sagemaker",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon SageMaker Runtime",
        serviceId: "SageMaker Runtime",
        signatureVersion: "v4",
        signingName: "sagemaker",
        uid: "runtime.sagemaker-2017-05-13"
      },
      operations: {
        InvokeEndpoint: {
          http: {
            requestUri: "/endpoints/{EndpointName}/invocations"
          },
          input: {
            type: "structure",
            required: [
              "EndpointName",
              "Body"
            ],
            members: {
              EndpointName: {
                location: "uri",
                locationName: "EndpointName"
              },
              Body: {
                shape: "S3"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              Accept: {
                location: "header",
                locationName: "Accept"
              },
              CustomAttributes: {
                shape: "S5",
                location: "header",
                locationName: "X-Amzn-SageMaker-Custom-Attributes"
              },
              TargetModel: {
                location: "header",
                locationName: "X-Amzn-SageMaker-Target-Model"
              },
              TargetVariant: {
                location: "header",
                locationName: "X-Amzn-SageMaker-Target-Variant"
              },
              TargetContainerHostname: {
                location: "header",
                locationName: "X-Amzn-SageMaker-Target-Container-Hostname"
              },
              InferenceId: {
                location: "header",
                locationName: "X-Amzn-SageMaker-Inference-Id"
              },
              EnableExplanations: {
                location: "header",
                locationName: "X-Amzn-SageMaker-Enable-Explanations"
              },
              InferenceComponentName: {
                location: "header",
                locationName: "X-Amzn-SageMaker-Inference-Component"
              }
            },
            payload: "Body"
          },
          output: {
            type: "structure",
            required: [
              "Body"
            ],
            members: {
              Body: {
                shape: "S3"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              InvokedProductionVariant: {
                location: "header",
                locationName: "x-Amzn-Invoked-Production-Variant"
              },
              CustomAttributes: {
                shape: "S5",
                location: "header",
                locationName: "X-Amzn-SageMaker-Custom-Attributes"
              }
            },
            payload: "Body"
          }
        },
        InvokeEndpointAsync: {
          http: {
            requestUri: "/endpoints/{EndpointName}/async-invocations",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "EndpointName",
              "InputLocation"
            ],
            members: {
              EndpointName: {
                location: "uri",
                locationName: "EndpointName"
              },
              ContentType: {
                location: "header",
                locationName: "X-Amzn-SageMaker-Content-Type"
              },
              Accept: {
                location: "header",
                locationName: "X-Amzn-SageMaker-Accept"
              },
              CustomAttributes: {
                shape: "S5",
                location: "header",
                locationName: "X-Amzn-SageMaker-Custom-Attributes"
              },
              InferenceId: {
                location: "header",
                locationName: "X-Amzn-SageMaker-Inference-Id"
              },
              InputLocation: {
                location: "header",
                locationName: "X-Amzn-SageMaker-InputLocation"
              },
              RequestTTLSeconds: {
                location: "header",
                locationName: "X-Amzn-SageMaker-RequestTTLSeconds",
                type: "integer"
              },
              InvocationTimeoutSeconds: {
                location: "header",
                locationName: "X-Amzn-SageMaker-InvocationTimeoutSeconds",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InferenceId: {},
              OutputLocation: {
                location: "header",
                locationName: "X-Amzn-SageMaker-OutputLocation"
              },
              FailureLocation: {
                location: "header",
                locationName: "X-Amzn-SageMaker-FailureLocation"
              }
            }
          }
        },
        InvokeEndpointWithResponseStream: {
          http: {
            requestUri: "/endpoints/{EndpointName}/invocations-response-stream"
          },
          input: {
            type: "structure",
            required: [
              "EndpointName",
              "Body"
            ],
            members: {
              EndpointName: {
                location: "uri",
                locationName: "EndpointName"
              },
              Body: {
                shape: "S3"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              Accept: {
                location: "header",
                locationName: "X-Amzn-SageMaker-Accept"
              },
              CustomAttributes: {
                shape: "S5",
                location: "header",
                locationName: "X-Amzn-SageMaker-Custom-Attributes"
              },
              TargetVariant: {
                location: "header",
                locationName: "X-Amzn-SageMaker-Target-Variant"
              },
              TargetContainerHostname: {
                location: "header",
                locationName: "X-Amzn-SageMaker-Target-Container-Hostname"
              },
              InferenceId: {
                location: "header",
                locationName: "X-Amzn-SageMaker-Inference-Id"
              },
              InferenceComponentName: {
                location: "header",
                locationName: "X-Amzn-SageMaker-Inference-Component"
              }
            },
            payload: "Body"
          },
          output: {
            type: "structure",
            required: [
              "Body"
            ],
            members: {
              Body: {
                type: "structure",
                members: {
                  PayloadPart: {
                    type: "structure",
                    members: {
                      Bytes: {
                        eventpayload: true,
                        type: "blob",
                        sensitive: true
                      }
                    },
                    event: true
                  },
                  ModelStreamError: {
                    type: "structure",
                    members: {
                      Message: {},
                      ErrorCode: {}
                    },
                    exception: true,
                    synthetic: true
                  },
                  InternalStreamFailure: {
                    type: "structure",
                    members: {
                      Message: {}
                    },
                    exception: true,
                    fault: true,
                    synthetic: true
                  }
                },
                eventstream: true
              },
              ContentType: {
                location: "header",
                locationName: "X-Amzn-SageMaker-Content-Type"
              },
              InvokedProductionVariant: {
                location: "header",
                locationName: "x-Amzn-Invoked-Production-Variant"
              },
              CustomAttributes: {
                shape: "S5",
                location: "header",
                locationName: "X-Amzn-SageMaker-Custom-Attributes"
              }
            },
            payload: "Body"
          }
        }
      },
      shapes: {
        S3: {
          type: "blob",
          sensitive: true
        },
        S5: {
          type: "string",
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/runtime.sagemaker-2017-05-13.paginators.json
var require_runtime_sagemaker_2017_05_13_paginators = __commonJS({
  "node_modules/aws-sdk/apis/runtime.sagemaker-2017-05-13.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/sagemakerruntime.js
var require_sagemakerruntime = __commonJS({
  "node_modules/aws-sdk/clients/sagemakerruntime.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["sagemakerruntime"] = {};
    AWS2.SageMakerRuntime = Service.defineService("sagemakerruntime", ["2017-05-13"]);
    Object.defineProperty(apiLoader.services["sagemakerruntime"], "2017-05-13", {
      get: function get() {
        var model = require_runtime_sagemaker_2017_05_13_min();
        model.paginators = require_runtime_sagemaker_2017_05_13_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.SageMakerRuntime;
  }
});

// node_modules/aws-sdk/apis/sagemaker-2017-07-24.min.json
var require_sagemaker_2017_07_24_min = __commonJS({
  "node_modules/aws-sdk/apis/sagemaker-2017-07-24.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-07-24",
        endpointPrefix: "api.sagemaker",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "SageMaker",
        serviceFullName: "Amazon SageMaker Service",
        serviceId: "SageMaker",
        signatureVersion: "v4",
        signingName: "sagemaker",
        targetPrefix: "SageMaker",
        uid: "sagemaker-2017-07-24"
      },
      operations: {
        AddAssociation: {
          input: {
            type: "structure",
            required: [
              "SourceArn",
              "DestinationArn"
            ],
            members: {
              SourceArn: {},
              DestinationArn: {},
              AssociationType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SourceArn: {},
              DestinationArn: {}
            }
          }
        },
        AddTags: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S7"
              }
            }
          }
        },
        AssociateTrialComponent: {
          input: {
            type: "structure",
            required: [
              "TrialComponentName",
              "TrialName"
            ],
            members: {
              TrialComponentName: {},
              TrialName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrialComponentArn: {},
              TrialArn: {}
            }
          }
        },
        BatchDescribeModelPackage: {
          input: {
            type: "structure",
            required: [
              "ModelPackageArnList"
            ],
            members: {
              ModelPackageArnList: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ModelPackageSummaries: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  required: [
                    "ModelPackageGroupName",
                    "ModelPackageArn",
                    "CreationTime",
                    "InferenceSpecification",
                    "ModelPackageStatus"
                  ],
                  members: {
                    ModelPackageGroupName: {},
                    ModelPackageVersion: {
                      type: "integer"
                    },
                    ModelPackageArn: {},
                    ModelPackageDescription: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    InferenceSpecification: {
                      shape: "Sr"
                    },
                    ModelPackageStatus: {},
                    ModelApprovalStatus: {}
                  }
                }
              },
              BatchDescribeModelPackageErrorMap: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  required: [
                    "ErrorCode",
                    "ErrorResponse"
                  ],
                  members: {
                    ErrorCode: {},
                    ErrorResponse: {}
                  }
                }
              }
            }
          }
        },
        CreateAction: {
          input: {
            type: "structure",
            required: [
              "ActionName",
              "Source",
              "ActionType"
            ],
            members: {
              ActionName: {},
              Source: {
                shape: "S1n"
              },
              ActionType: {},
              Description: {},
              Status: {},
              Properties: {
                shape: "S1s"
              },
              MetadataProperties: {
                shape: "S1u"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ActionArn: {}
            }
          }
        },
        CreateAlgorithm: {
          input: {
            type: "structure",
            required: [
              "AlgorithmName",
              "TrainingSpecification"
            ],
            members: {
              AlgorithmName: {},
              AlgorithmDescription: {},
              TrainingSpecification: {
                shape: "S1z"
              },
              InferenceSpecification: {
                shape: "Sr"
              },
              ValidationSpecification: {
                shape: "S2r"
              },
              CertifyForMarketplace: {
                type: "boolean"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "AlgorithmArn"
            ],
            members: {
              AlgorithmArn: {}
            }
          }
        },
        CreateApp: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "AppType",
              "AppName"
            ],
            members: {
              DomainId: {},
              UserProfileName: {},
              SpaceName: {},
              AppType: {},
              AppName: {},
              Tags: {
                shape: "S7"
              },
              ResourceSpec: {
                shape: "S4i"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppArn: {}
            }
          }
        },
        CreateAppImageConfig: {
          input: {
            type: "structure",
            required: [
              "AppImageConfigName"
            ],
            members: {
              AppImageConfigName: {},
              Tags: {
                shape: "S7"
              },
              KernelGatewayImageConfig: {
                shape: "S4s"
              },
              JupyterLabAppImageConfig: {
                shape: "S51"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppImageConfigArn: {}
            }
          }
        },
        CreateArtifact: {
          input: {
            type: "structure",
            required: [
              "Source",
              "ArtifactType"
            ],
            members: {
              ArtifactName: {},
              Source: {
                shape: "S5b"
              },
              ArtifactType: {},
              Properties: {
                shape: "S5f"
              },
              MetadataProperties: {
                shape: "S1u"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ArtifactArn: {}
            }
          }
        },
        CreateAutoMLJob: {
          input: {
            type: "structure",
            required: [
              "AutoMLJobName",
              "InputDataConfig",
              "OutputDataConfig",
              "RoleArn"
            ],
            members: {
              AutoMLJobName: {},
              InputDataConfig: {
                shape: "S5l"
              },
              OutputDataConfig: {
                shape: "S5t"
              },
              ProblemType: {},
              AutoMLJobObjective: {
                shape: "S5v"
              },
              AutoMLJobConfig: {
                shape: "S5x"
              },
              RoleArn: {},
              GenerateCandidateDefinitionsOnly: {
                type: "boolean"
              },
              Tags: {
                shape: "S7"
              },
              ModelDeployConfig: {
                shape: "S6h"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "AutoMLJobArn"
            ],
            members: {
              AutoMLJobArn: {}
            }
          }
        },
        CreateAutoMLJobV2: {
          input: {
            type: "structure",
            required: [
              "AutoMLJobName",
              "AutoMLJobInputDataConfig",
              "OutputDataConfig",
              "AutoMLProblemTypeConfig",
              "RoleArn"
            ],
            members: {
              AutoMLJobName: {},
              AutoMLJobInputDataConfig: {
                shape: "S6n"
              },
              OutputDataConfig: {
                shape: "S5t"
              },
              AutoMLProblemTypeConfig: {
                shape: "S6p"
              },
              RoleArn: {},
              Tags: {
                shape: "S7"
              },
              SecurityConfig: {
                shape: "S62"
              },
              AutoMLJobObjective: {
                shape: "S5v"
              },
              ModelDeployConfig: {
                shape: "S6h"
              },
              DataSplitConfig: {
                shape: "S6d"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "AutoMLJobArn"
            ],
            members: {
              AutoMLJobArn: {}
            }
          }
        },
        CreateCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterName",
              "InstanceGroups"
            ],
            members: {
              ClusterName: {},
              InstanceGroups: {
                shape: "S7r"
              },
              VpcConfig: {
                shape: "S63"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ClusterArn"
            ],
            members: {
              ClusterArn: {}
            }
          }
        },
        CreateCodeRepository: {
          input: {
            type: "structure",
            required: [
              "CodeRepositoryName",
              "GitConfig"
            ],
            members: {
              CodeRepositoryName: {},
              GitConfig: {
                shape: "S82"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CodeRepositoryArn"
            ],
            members: {
              CodeRepositoryArn: {}
            }
          }
        },
        CreateCompilationJob: {
          input: {
            type: "structure",
            required: [
              "CompilationJobName",
              "RoleArn",
              "OutputConfig",
              "StoppingCondition"
            ],
            members: {
              CompilationJobName: {},
              RoleArn: {},
              ModelPackageVersionArn: {},
              InputConfig: {
                shape: "S89"
              },
              OutputConfig: {
                shape: "S8c"
              },
              VpcConfig: {
                shape: "S8j"
              },
              StoppingCondition: {
                shape: "S3p"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CompilationJobArn"
            ],
            members: {
              CompilationJobArn: {}
            }
          }
        },
        CreateContext: {
          input: {
            type: "structure",
            required: [
              "ContextName",
              "Source",
              "ContextType"
            ],
            members: {
              ContextName: {},
              Source: {
                shape: "S8s"
              },
              ContextType: {},
              Description: {},
              Properties: {
                shape: "S1s"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContextArn: {}
            }
          }
        },
        CreateDataQualityJobDefinition: {
          input: {
            type: "structure",
            required: [
              "JobDefinitionName",
              "DataQualityAppSpecification",
              "DataQualityJobInput",
              "DataQualityJobOutputConfig",
              "JobResources",
              "RoleArn"
            ],
            members: {
              JobDefinitionName: {},
              DataQualityBaselineConfig: {
                shape: "S8x"
              },
              DataQualityAppSpecification: {
                shape: "S91"
              },
              DataQualityJobInput: {
                shape: "S9a"
              },
              DataQualityJobOutputConfig: {
                shape: "S9o"
              },
              JobResources: {
                shape: "S9u"
              },
              NetworkConfig: {
                shape: "S9z"
              },
              RoleArn: {},
              StoppingCondition: {
                shape: "Sa0"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "JobDefinitionArn"
            ],
            members: {
              JobDefinitionArn: {}
            }
          }
        },
        CreateDeviceFleet: {
          input: {
            type: "structure",
            required: [
              "DeviceFleetName",
              "OutputConfig"
            ],
            members: {
              DeviceFleetName: {},
              RoleArn: {},
              Description: {},
              OutputConfig: {
                shape: "Sa6"
              },
              Tags: {
                shape: "S7"
              },
              EnableIotRoleAlias: {
                type: "boolean"
              }
            }
          }
        },
        CreateDomain: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "AuthMode",
              "DefaultUserSettings",
              "SubnetIds",
              "VpcId"
            ],
            members: {
              DomainName: {},
              AuthMode: {},
              DefaultUserSettings: {
                shape: "Sac"
              },
              DomainSettings: {
                shape: "Sbj"
              },
              SubnetIds: {
                shape: "S66"
              },
              VpcId: {},
              Tags: {
                shape: "S7"
              },
              AppNetworkAccessType: {},
              HomeEfsFileSystemKmsKeyId: {
                deprecated: true,
                deprecatedMessage: "This property is deprecated, use KmsKeyId instead."
              },
              KmsKeyId: {},
              AppSecurityGroupManagement: {},
              DefaultSpaceSettings: {
                shape: "Sbt"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainArn: {},
              Url: {}
            }
          }
        },
        CreateEdgeDeploymentPlan: {
          input: {
            type: "structure",
            required: [
              "EdgeDeploymentPlanName",
              "ModelConfigs",
              "DeviceFleetName"
            ],
            members: {
              EdgeDeploymentPlanName: {},
              ModelConfigs: {
                shape: "Sby"
              },
              DeviceFleetName: {},
              Stages: {
                shape: "Sc0"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EdgeDeploymentPlanArn"
            ],
            members: {
              EdgeDeploymentPlanArn: {}
            }
          }
        },
        CreateEdgeDeploymentStage: {
          input: {
            type: "structure",
            required: [
              "EdgeDeploymentPlanName",
              "Stages"
            ],
            members: {
              EdgeDeploymentPlanName: {},
              Stages: {
                shape: "Sc0"
              }
            }
          }
        },
        CreateEdgePackagingJob: {
          input: {
            type: "structure",
            required: [
              "EdgePackagingJobName",
              "CompilationJobName",
              "ModelName",
              "ModelVersion",
              "RoleArn",
              "OutputConfig"
            ],
            members: {
              EdgePackagingJobName: {},
              CompilationJobName: {},
              ModelName: {},
              ModelVersion: {},
              RoleArn: {},
              OutputConfig: {
                shape: "Sa6"
              },
              ResourceKey: {},
              Tags: {
                shape: "S7"
              }
            }
          }
        },
        CreateEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointName",
              "EndpointConfigName"
            ],
            members: {
              EndpointName: {},
              EndpointConfigName: {},
              DeploymentConfig: {
                shape: "Scg"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EndpointArn"
            ],
            members: {
              EndpointArn: {}
            }
          }
        },
        CreateEndpointConfig: {
          input: {
            type: "structure",
            required: [
              "EndpointConfigName",
              "ProductionVariants"
            ],
            members: {
              EndpointConfigName: {},
              ProductionVariants: {
                shape: "Scy"
              },
              DataCaptureConfig: {
                shape: "Sdk"
              },
              Tags: {
                shape: "S7"
              },
              KmsKeyId: {},
              AsyncInferenceConfig: {
                shape: "Sdv"
              },
              ExplainerConfig: {
                shape: "Se3"
              },
              ShadowProductionVariants: {
                shape: "Scy"
              },
              ExecutionRoleArn: {},
              VpcConfig: {
                shape: "S63"
              },
              EnableNetworkIsolation: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EndpointConfigArn"
            ],
            members: {
              EndpointConfigArn: {}
            }
          }
        },
        CreateExperiment: {
          input: {
            type: "structure",
            required: [
              "ExperimentName"
            ],
            members: {
              ExperimentName: {},
              DisplayName: {},
              Description: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ExperimentArn: {}
            }
          }
        },
        CreateFeatureGroup: {
          input: {
            type: "structure",
            required: [
              "FeatureGroupName",
              "RecordIdentifierFeatureName",
              "EventTimeFeatureName",
              "FeatureDefinitions"
            ],
            members: {
              FeatureGroupName: {},
              RecordIdentifierFeatureName: {},
              EventTimeFeatureName: {},
              FeatureDefinitions: {
                shape: "Sf2"
              },
              OnlineStoreConfig: {
                shape: "Sf9"
              },
              OfflineStoreConfig: {
                shape: "Sff"
              },
              ThroughputConfig: {
                type: "structure",
                required: [
                  "ThroughputMode"
                ],
                members: {
                  ThroughputMode: {},
                  ProvisionedReadCapacityUnits: {
                    type: "integer"
                  },
                  ProvisionedWriteCapacityUnits: {
                    type: "integer"
                  }
                }
              },
              RoleArn: {},
              Description: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "FeatureGroupArn"
            ],
            members: {
              FeatureGroupArn: {}
            }
          }
        },
        CreateFlowDefinition: {
          input: {
            type: "structure",
            required: [
              "FlowDefinitionName",
              "OutputConfig",
              "RoleArn"
            ],
            members: {
              FlowDefinitionName: {},
              HumanLoopRequestSource: {
                shape: "Sfu"
              },
              HumanLoopActivationConfig: {
                shape: "Sfw"
              },
              HumanLoopConfig: {
                shape: "Sfz"
              },
              OutputConfig: {
                shape: "Sge"
              },
              RoleArn: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "FlowDefinitionArn"
            ],
            members: {
              FlowDefinitionArn: {}
            }
          }
        },
        CreateHub: {
          input: {
            type: "structure",
            required: [
              "HubName",
              "HubDescription"
            ],
            members: {
              HubName: {},
              HubDescription: {},
              HubDisplayName: {},
              HubSearchKeywords: {
                shape: "Sgl"
              },
              S3StorageConfig: {
                shape: "Sgn"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HubArn"
            ],
            members: {
              HubArn: {}
            }
          }
        },
        CreateHumanTaskUi: {
          input: {
            type: "structure",
            required: [
              "HumanTaskUiName",
              "UiTemplate"
            ],
            members: {
              HumanTaskUiName: {},
              UiTemplate: {
                shape: "Sgt"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HumanTaskUiArn"
            ],
            members: {
              HumanTaskUiArn: {}
            }
          }
        },
        CreateHyperParameterTuningJob: {
          input: {
            type: "structure",
            required: [
              "HyperParameterTuningJobName",
              "HyperParameterTuningJobConfig"
            ],
            members: {
              HyperParameterTuningJobName: {},
              HyperParameterTuningJobConfig: {
                shape: "Sgy"
              },
              TrainingJobDefinition: {
                shape: "Shr"
              },
              TrainingJobDefinitions: {
                shape: "Si7"
              },
              WarmStartConfig: {
                shape: "Si8"
              },
              Tags: {
                shape: "S7"
              },
              Autotune: {
                shape: "Sic"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HyperParameterTuningJobArn"
            ],
            members: {
              HyperParameterTuningJobArn: {}
            }
          }
        },
        CreateImage: {
          input: {
            type: "structure",
            required: [
              "ImageName",
              "RoleArn"
            ],
            members: {
              Description: {},
              DisplayName: {},
              ImageName: {},
              RoleArn: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ImageArn: {}
            }
          }
        },
        CreateImageVersion: {
          input: {
            type: "structure",
            required: [
              "BaseImage",
              "ClientToken",
              "ImageName"
            ],
            members: {
              BaseImage: {},
              ClientToken: {
                idempotencyToken: true
              },
              ImageName: {},
              Aliases: {
                shape: "Sin"
              },
              VendorGuidance: {},
              JobType: {},
              MLFramework: {},
              ProgrammingLang: {},
              Processor: {},
              Horovod: {
                type: "boolean"
              },
              ReleaseNotes: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ImageVersionArn: {}
            }
          }
        },
        CreateInferenceComponent: {
          input: {
            type: "structure",
            required: [
              "InferenceComponentName",
              "EndpointName",
              "VariantName",
              "Specification",
              "RuntimeConfig"
            ],
            members: {
              InferenceComponentName: {},
              EndpointName: {},
              VariantName: {},
              Specification: {
                shape: "Siz"
              },
              RuntimeConfig: {
                shape: "Sj6"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "InferenceComponentArn"
            ],
            members: {
              InferenceComponentArn: {}
            }
          }
        },
        CreateInferenceExperiment: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Type",
              "RoleArn",
              "EndpointName",
              "ModelVariants",
              "ShadowModeConfig"
            ],
            members: {
              Name: {},
              Type: {},
              Schedule: {
                shape: "Sjd"
              },
              Description: {},
              RoleArn: {},
              EndpointName: {},
              ModelVariants: {
                shape: "Sjg"
              },
              DataStorageConfig: {
                shape: "Sjo"
              },
              ShadowModeConfig: {
                shape: "Sjp"
              },
              KmsKey: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "InferenceExperimentArn"
            ],
            members: {
              InferenceExperimentArn: {}
            }
          }
        },
        CreateInferenceRecommendationsJob: {
          input: {
            type: "structure",
            required: [
              "JobName",
              "JobType",
              "RoleArn",
              "InputConfig"
            ],
            members: {
              JobName: {},
              JobType: {},
              RoleArn: {},
              InputConfig: {
                shape: "Sjx"
              },
              JobDescription: {},
              StoppingConditions: {
                shape: "Sl3"
              },
              OutputConfig: {
                type: "structure",
                members: {
                  KmsKeyId: {},
                  CompiledOutputConfig: {
                    type: "structure",
                    members: {
                      S3OutputUri: {}
                    }
                  }
                }
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "JobArn"
            ],
            members: {
              JobArn: {}
            }
          }
        },
        CreateLabelingJob: {
          input: {
            type: "structure",
            required: [
              "LabelingJobName",
              "LabelAttributeName",
              "InputConfig",
              "OutputConfig",
              "RoleArn",
              "HumanTaskConfig"
            ],
            members: {
              LabelingJobName: {},
              LabelAttributeName: {},
              InputConfig: {
                shape: "Slf"
              },
              OutputConfig: {
                shape: "Slm"
              },
              RoleArn: {},
              LabelCategoryConfigS3Uri: {},
              StoppingConditions: {
                shape: "Sln"
              },
              LabelingJobAlgorithmsConfig: {
                shape: "Slq"
              },
              HumanTaskConfig: {
                shape: "Slu"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "LabelingJobArn"
            ],
            members: {
              LabelingJobArn: {}
            }
          }
        },
        CreateModel: {
          input: {
            type: "structure",
            required: [
              "ModelName"
            ],
            members: {
              ModelName: {},
              PrimaryContainer: {
                shape: "Sm9"
              },
              Containers: {
                shape: "Smn"
              },
              InferenceExecutionConfig: {
                shape: "Smo"
              },
              ExecutionRoleArn: {},
              Tags: {
                shape: "S7"
              },
              VpcConfig: {
                shape: "S63"
              },
              EnableNetworkIsolation: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ModelArn"
            ],
            members: {
              ModelArn: {}
            }
          }
        },
        CreateModelBiasJobDefinition: {
          input: {
            type: "structure",
            required: [
              "JobDefinitionName",
              "ModelBiasAppSpecification",
              "ModelBiasJobInput",
              "ModelBiasJobOutputConfig",
              "JobResources",
              "RoleArn"
            ],
            members: {
              JobDefinitionName: {},
              ModelBiasBaselineConfig: {
                shape: "Sms"
              },
              ModelBiasAppSpecification: {
                shape: "Smt"
              },
              ModelBiasJobInput: {
                shape: "Smu"
              },
              ModelBiasJobOutputConfig: {
                shape: "S9o"
              },
              JobResources: {
                shape: "S9u"
              },
              NetworkConfig: {
                shape: "S9z"
              },
              RoleArn: {},
              StoppingCondition: {
                shape: "Sa0"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "JobDefinitionArn"
            ],
            members: {
              JobDefinitionArn: {}
            }
          }
        },
        CreateModelCard: {
          input: {
            type: "structure",
            required: [
              "ModelCardName",
              "Content",
              "ModelCardStatus"
            ],
            members: {
              ModelCardName: {},
              SecurityConfig: {
                shape: "Smy"
              },
              Content: {
                shape: "Smz"
              },
              ModelCardStatus: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ModelCardArn"
            ],
            members: {
              ModelCardArn: {}
            }
          }
        },
        CreateModelCardExportJob: {
          input: {
            type: "structure",
            required: [
              "ModelCardName",
              "ModelCardExportJobName",
              "OutputConfig"
            ],
            members: {
              ModelCardName: {},
              ModelCardVersion: {
                type: "integer"
              },
              ModelCardExportJobName: {},
              OutputConfig: {
                shape: "Sn5"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ModelCardExportJobArn"
            ],
            members: {
              ModelCardExportJobArn: {}
            }
          }
        },
        CreateModelExplainabilityJobDefinition: {
          input: {
            type: "structure",
            required: [
              "JobDefinitionName",
              "ModelExplainabilityAppSpecification",
              "ModelExplainabilityJobInput",
              "ModelExplainabilityJobOutputConfig",
              "JobResources",
              "RoleArn"
            ],
            members: {
              JobDefinitionName: {},
              ModelExplainabilityBaselineConfig: {
                shape: "Sn9"
              },
              ModelExplainabilityAppSpecification: {
                shape: "Sna"
              },
              ModelExplainabilityJobInput: {
                shape: "Snb"
              },
              ModelExplainabilityJobOutputConfig: {
                shape: "S9o"
              },
              JobResources: {
                shape: "S9u"
              },
              NetworkConfig: {
                shape: "S9z"
              },
              RoleArn: {},
              StoppingCondition: {
                shape: "Sa0"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "JobDefinitionArn"
            ],
            members: {
              JobDefinitionArn: {}
            }
          }
        },
        CreateModelPackage: {
          input: {
            type: "structure",
            members: {
              ModelPackageName: {},
              ModelPackageGroupName: {},
              ModelPackageDescription: {},
              InferenceSpecification: {
                shape: "Sr"
              },
              ValidationSpecification: {
                shape: "Sne"
              },
              SourceAlgorithmSpecification: {
                shape: "Snh"
              },
              CertifyForMarketplace: {
                type: "boolean"
              },
              Tags: {
                shape: "S7"
              },
              ModelApprovalStatus: {},
              MetadataProperties: {
                shape: "S1u"
              },
              ModelMetrics: {
                shape: "Snk"
              },
              ClientToken: {
                idempotencyToken: true
              },
              Domain: {},
              Task: {},
              SamplePayloadUrl: {},
              CustomerMetadataProperties: {
                shape: "Snr"
              },
              DriftCheckBaselines: {
                shape: "Snu"
              },
              AdditionalInferenceSpecifications: {
                shape: "So0"
              },
              SkipModelValidation: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ModelPackageArn"
            ],
            members: {
              ModelPackageArn: {}
            }
          }
        },
        CreateModelPackageGroup: {
          input: {
            type: "structure",
            required: [
              "ModelPackageGroupName"
            ],
            members: {
              ModelPackageGroupName: {},
              ModelPackageGroupDescription: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ModelPackageGroupArn"
            ],
            members: {
              ModelPackageGroupArn: {}
            }
          }
        },
        CreateModelQualityJobDefinition: {
          input: {
            type: "structure",
            required: [
              "JobDefinitionName",
              "ModelQualityAppSpecification",
              "ModelQualityJobInput",
              "ModelQualityJobOutputConfig",
              "JobResources",
              "RoleArn"
            ],
            members: {
              JobDefinitionName: {},
              ModelQualityBaselineConfig: {
                shape: "So8"
              },
              ModelQualityAppSpecification: {
                shape: "So9"
              },
              ModelQualityJobInput: {
                shape: "Sob"
              },
              ModelQualityJobOutputConfig: {
                shape: "S9o"
              },
              JobResources: {
                shape: "S9u"
              },
              NetworkConfig: {
                shape: "S9z"
              },
              RoleArn: {},
              StoppingCondition: {
                shape: "Sa0"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "JobDefinitionArn"
            ],
            members: {
              JobDefinitionArn: {}
            }
          }
        },
        CreateMonitoringSchedule: {
          input: {
            type: "structure",
            required: [
              "MonitoringScheduleName",
              "MonitoringScheduleConfig"
            ],
            members: {
              MonitoringScheduleName: {},
              MonitoringScheduleConfig: {
                shape: "Sof"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "MonitoringScheduleArn"
            ],
            members: {
              MonitoringScheduleArn: {}
            }
          }
        },
        CreateNotebookInstance: {
          input: {
            type: "structure",
            required: [
              "NotebookInstanceName",
              "InstanceType",
              "RoleArn"
            ],
            members: {
              NotebookInstanceName: {},
              InstanceType: {},
              SubnetId: {},
              SecurityGroupIds: {
                shape: "Sad"
              },
              RoleArn: {},
              KmsKeyId: {},
              Tags: {
                shape: "S7"
              },
              LifecycleConfigName: {},
              DirectInternetAccess: {},
              VolumeSizeInGB: {
                type: "integer"
              },
              AcceleratorTypes: {
                shape: "Sow"
              },
              DefaultCodeRepository: {},
              AdditionalCodeRepositories: {
                shape: "Soz"
              },
              RootAccess: {},
              PlatformIdentifier: {},
              InstanceMetadataServiceConfiguration: {
                shape: "Sp2"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NotebookInstanceArn: {}
            }
          }
        },
        CreateNotebookInstanceLifecycleConfig: {
          input: {
            type: "structure",
            required: [
              "NotebookInstanceLifecycleConfigName"
            ],
            members: {
              NotebookInstanceLifecycleConfigName: {},
              OnCreate: {
                shape: "Sp7"
              },
              OnStart: {
                shape: "Sp7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NotebookInstanceLifecycleConfigArn: {}
            }
          }
        },
        CreatePipeline: {
          input: {
            type: "structure",
            required: [
              "PipelineName",
              "ClientRequestToken",
              "RoleArn"
            ],
            members: {
              PipelineName: {},
              PipelineDisplayName: {},
              PipelineDefinition: {},
              PipelineDefinitionS3Location: {
                shape: "Spf"
              },
              PipelineDescription: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              RoleArn: {},
              Tags: {
                shape: "S7"
              },
              ParallelismConfiguration: {
                shape: "Spl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineArn: {}
            }
          }
        },
        CreatePresignedDomainUrl: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "UserProfileName"
            ],
            members: {
              DomainId: {},
              UserProfileName: {},
              SessionExpirationDurationInSeconds: {
                type: "integer"
              },
              ExpiresInSeconds: {
                type: "integer"
              },
              SpaceName: {},
              LandingUri: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AuthorizedUrl: {}
            }
          }
        },
        CreatePresignedNotebookInstanceUrl: {
          input: {
            type: "structure",
            required: [
              "NotebookInstanceName"
            ],
            members: {
              NotebookInstanceName: {},
              SessionExpirationDurationInSeconds: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AuthorizedUrl: {}
            }
          }
        },
        CreateProcessingJob: {
          input: {
            type: "structure",
            required: [
              "ProcessingJobName",
              "ProcessingResources",
              "AppSpecification",
              "RoleArn"
            ],
            members: {
              ProcessingInputs: {
                shape: "Spy"
              },
              ProcessingOutputConfig: {
                shape: "Sql"
              },
              ProcessingJobName: {},
              ProcessingResources: {
                shape: "Sqq"
              },
              StoppingCondition: {
                shape: "Sqs"
              },
              AppSpecification: {
                shape: "Squ"
              },
              Environment: {
                shape: "Sqw"
              },
              NetworkConfig: {
                shape: "Son"
              },
              RoleArn: {},
              Tags: {
                shape: "S7"
              },
              ExperimentConfig: {
                shape: "Sqx"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ProcessingJobArn"
            ],
            members: {
              ProcessingJobArn: {}
            }
          }
        },
        CreateProject: {
          input: {
            type: "structure",
            required: [
              "ProjectName",
              "ServiceCatalogProvisioningDetails"
            ],
            members: {
              ProjectName: {},
              ProjectDescription: {},
              ServiceCatalogProvisioningDetails: {
                shape: "Sr2"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ProjectArn",
              "ProjectId"
            ],
            members: {
              ProjectArn: {},
              ProjectId: {}
            }
          }
        },
        CreateSpace: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "SpaceName"
            ],
            members: {
              DomainId: {},
              SpaceName: {},
              Tags: {
                shape: "S7"
              },
              SpaceSettings: {
                shape: "Src"
              },
              OwnershipSettings: {
                shape: "Srk"
              },
              SpaceSharingSettings: {
                shape: "Srl"
              },
              SpaceDisplayName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SpaceArn: {}
            }
          }
        },
        CreateStudioLifecycleConfig: {
          input: {
            type: "structure",
            required: [
              "StudioLifecycleConfigName",
              "StudioLifecycleConfigContent",
              "StudioLifecycleConfigAppType"
            ],
            members: {
              StudioLifecycleConfigName: {},
              StudioLifecycleConfigContent: {},
              StudioLifecycleConfigAppType: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StudioLifecycleConfigArn: {}
            }
          }
        },
        CreateTrainingJob: {
          input: {
            type: "structure",
            required: [
              "TrainingJobName",
              "AlgorithmSpecification",
              "RoleArn",
              "OutputDataConfig",
              "ResourceConfig",
              "StoppingCondition"
            ],
            members: {
              TrainingJobName: {},
              HyperParameters: {
                shape: "S2w"
              },
              AlgorithmSpecification: {
                shape: "Srw"
              },
              RoleArn: {},
              InputDataConfig: {
                shape: "S2y"
              },
              OutputDataConfig: {
                shape: "S3g"
              },
              ResourceConfig: {
                shape: "S3j"
              },
              VpcConfig: {
                shape: "S63"
              },
              StoppingCondition: {
                shape: "S3p"
              },
              Tags: {
                shape: "S7"
              },
              EnableNetworkIsolation: {
                type: "boolean"
              },
              EnableInterContainerTrafficEncryption: {
                type: "boolean"
              },
              EnableManagedSpotTraining: {
                type: "boolean"
              },
              CheckpointConfig: {
                shape: "Si1"
              },
              DebugHookConfig: {
                shape: "Ss5"
              },
              DebugRuleConfigurations: {
                shape: "Ssd"
              },
              TensorBoardOutputConfig: {
                shape: "Ssh"
              },
              ExperimentConfig: {
                shape: "Sqx"
              },
              ProfilerConfig: {
                shape: "Ssi"
              },
              ProfilerRuleConfigurations: {
                shape: "Ssm"
              },
              Environment: {
                shape: "Sso"
              },
              RetryStrategy: {
                shape: "Si2"
              },
              RemoteDebugConfig: {
                shape: "Ssr"
              },
              InfraCheckConfig: {
                shape: "Sst"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TrainingJobArn"
            ],
            members: {
              TrainingJobArn: {}
            }
          }
        },
        CreateTransformJob: {
          input: {
            type: "structure",
            required: [
              "TransformJobName",
              "ModelName",
              "TransformInput",
              "TransformOutput",
              "TransformResources"
            ],
            members: {
              TransformJobName: {},
              ModelName: {},
              MaxConcurrentTransforms: {
                type: "integer"
              },
              ModelClientConfig: {
                shape: "Ssz"
              },
              MaxPayloadInMB: {
                type: "integer"
              },
              BatchStrategy: {},
              Environment: {
                shape: "S3x"
              },
              TransformInput: {
                shape: "S40"
              },
              TransformOutput: {
                shape: "S44"
              },
              DataCaptureConfig: {
                shape: "St2"
              },
              TransformResources: {
                shape: "S47"
              },
              DataProcessing: {
                shape: "St3"
              },
              Tags: {
                shape: "S7"
              },
              ExperimentConfig: {
                shape: "Sqx"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TransformJobArn"
            ],
            members: {
              TransformJobArn: {}
            }
          }
        },
        CreateTrial: {
          input: {
            type: "structure",
            required: [
              "TrialName",
              "ExperimentName"
            ],
            members: {
              TrialName: {},
              DisplayName: {},
              ExperimentName: {},
              MetadataProperties: {
                shape: "S1u"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrialArn: {}
            }
          }
        },
        CreateTrialComponent: {
          input: {
            type: "structure",
            required: [
              "TrialComponentName"
            ],
            members: {
              TrialComponentName: {},
              DisplayName: {},
              Status: {
                shape: "Stb"
              },
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Parameters: {
                shape: "Ste"
              },
              InputArtifacts: {
                shape: "Sti"
              },
              OutputArtifacts: {
                shape: "Sti"
              },
              MetadataProperties: {
                shape: "S1u"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrialComponentArn: {}
            }
          }
        },
        CreateUserProfile: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "UserProfileName"
            ],
            members: {
              DomainId: {},
              UserProfileName: {},
              SingleSignOnUserIdentifier: {},
              SingleSignOnUserValue: {},
              Tags: {
                shape: "S7"
              },
              UserSettings: {
                shape: "Sac"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserProfileArn: {}
            }
          }
        },
        CreateWorkforce: {
          input: {
            type: "structure",
            required: [
              "WorkforceName"
            ],
            members: {
              CognitoConfig: {
                shape: "Stt"
              },
              OidcConfig: {
                shape: "Stw"
              },
              SourceIpConfig: {
                shape: "Stz"
              },
              WorkforceName: {},
              Tags: {
                shape: "S7"
              },
              WorkforceVpcConfig: {
                shape: "Su3"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "WorkforceArn"
            ],
            members: {
              WorkforceArn: {}
            }
          }
        },
        CreateWorkteam: {
          input: {
            type: "structure",
            required: [
              "WorkteamName",
              "MemberDefinitions",
              "Description"
            ],
            members: {
              WorkteamName: {},
              WorkforceName: {},
              MemberDefinitions: {
                shape: "Sud"
              },
              Description: {},
              NotificationConfiguration: {
                shape: "Sul"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkteamArn: {}
            }
          }
        },
        DeleteAction: {
          input: {
            type: "structure",
            required: [
              "ActionName"
            ],
            members: {
              ActionName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ActionArn: {}
            }
          }
        },
        DeleteAlgorithm: {
          input: {
            type: "structure",
            required: [
              "AlgorithmName"
            ],
            members: {
              AlgorithmName: {}
            }
          }
        },
        DeleteApp: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "AppType",
              "AppName"
            ],
            members: {
              DomainId: {},
              UserProfileName: {},
              SpaceName: {},
              AppType: {},
              AppName: {}
            }
          }
        },
        DeleteAppImageConfig: {
          input: {
            type: "structure",
            required: [
              "AppImageConfigName"
            ],
            members: {
              AppImageConfigName: {}
            }
          }
        },
        DeleteArtifact: {
          input: {
            type: "structure",
            members: {
              ArtifactArn: {},
              Source: {
                shape: "S5b"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ArtifactArn: {}
            }
          }
        },
        DeleteAssociation: {
          input: {
            type: "structure",
            required: [
              "SourceArn",
              "DestinationArn"
            ],
            members: {
              SourceArn: {},
              DestinationArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SourceArn: {},
              DestinationArn: {}
            }
          }
        },
        DeleteCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterName"
            ],
            members: {
              ClusterName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ClusterArn"
            ],
            members: {
              ClusterArn: {}
            }
          }
        },
        DeleteCodeRepository: {
          input: {
            type: "structure",
            required: [
              "CodeRepositoryName"
            ],
            members: {
              CodeRepositoryName: {}
            }
          }
        },
        DeleteCompilationJob: {
          input: {
            type: "structure",
            required: [
              "CompilationJobName"
            ],
            members: {
              CompilationJobName: {}
            }
          }
        },
        DeleteContext: {
          input: {
            type: "structure",
            required: [
              "ContextName"
            ],
            members: {
              ContextName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ContextArn: {}
            }
          }
        },
        DeleteDataQualityJobDefinition: {
          input: {
            type: "structure",
            required: [
              "JobDefinitionName"
            ],
            members: {
              JobDefinitionName: {}
            }
          }
        },
        DeleteDeviceFleet: {
          input: {
            type: "structure",
            required: [
              "DeviceFleetName"
            ],
            members: {
              DeviceFleetName: {}
            }
          }
        },
        DeleteDomain: {
          input: {
            type: "structure",
            required: [
              "DomainId"
            ],
            members: {
              DomainId: {},
              RetentionPolicy: {
                type: "structure",
                members: {
                  HomeEfsFileSystem: {}
                }
              }
            }
          }
        },
        DeleteEdgeDeploymentPlan: {
          input: {
            type: "structure",
            required: [
              "EdgeDeploymentPlanName"
            ],
            members: {
              EdgeDeploymentPlanName: {}
            }
          }
        },
        DeleteEdgeDeploymentStage: {
          input: {
            type: "structure",
            required: [
              "EdgeDeploymentPlanName",
              "StageName"
            ],
            members: {
              EdgeDeploymentPlanName: {},
              StageName: {}
            }
          }
        },
        DeleteEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointName"
            ],
            members: {
              EndpointName: {}
            }
          }
        },
        DeleteEndpointConfig: {
          input: {
            type: "structure",
            required: [
              "EndpointConfigName"
            ],
            members: {
              EndpointConfigName: {}
            }
          }
        },
        DeleteExperiment: {
          input: {
            type: "structure",
            required: [
              "ExperimentName"
            ],
            members: {
              ExperimentName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ExperimentArn: {}
            }
          }
        },
        DeleteFeatureGroup: {
          input: {
            type: "structure",
            required: [
              "FeatureGroupName"
            ],
            members: {
              FeatureGroupName: {}
            }
          }
        },
        DeleteFlowDefinition: {
          input: {
            type: "structure",
            required: [
              "FlowDefinitionName"
            ],
            members: {
              FlowDefinitionName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteHub: {
          input: {
            type: "structure",
            required: [
              "HubName"
            ],
            members: {
              HubName: {}
            }
          }
        },
        DeleteHubContent: {
          input: {
            type: "structure",
            required: [
              "HubName",
              "HubContentType",
              "HubContentName",
              "HubContentVersion"
            ],
            members: {
              HubName: {},
              HubContentType: {},
              HubContentName: {},
              HubContentVersion: {}
            }
          }
        },
        DeleteHumanTaskUi: {
          input: {
            type: "structure",
            required: [
              "HumanTaskUiName"
            ],
            members: {
              HumanTaskUiName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteImage: {
          input: {
            type: "structure",
            required: [
              "ImageName"
            ],
            members: {
              ImageName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteImageVersion: {
          input: {
            type: "structure",
            required: [
              "ImageName"
            ],
            members: {
              ImageName: {},
              Version: {
                type: "integer"
              },
              Alias: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteInferenceComponent: {
          input: {
            type: "structure",
            required: [
              "InferenceComponentName"
            ],
            members: {
              InferenceComponentName: {}
            }
          }
        },
        DeleteInferenceExperiment: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "InferenceExperimentArn"
            ],
            members: {
              InferenceExperimentArn: {}
            }
          }
        },
        DeleteModel: {
          input: {
            type: "structure",
            required: [
              "ModelName"
            ],
            members: {
              ModelName: {}
            }
          }
        },
        DeleteModelBiasJobDefinition: {
          input: {
            type: "structure",
            required: [
              "JobDefinitionName"
            ],
            members: {
              JobDefinitionName: {}
            }
          }
        },
        DeleteModelCard: {
          input: {
            type: "structure",
            required: [
              "ModelCardName"
            ],
            members: {
              ModelCardName: {}
            }
          }
        },
        DeleteModelExplainabilityJobDefinition: {
          input: {
            type: "structure",
            required: [
              "JobDefinitionName"
            ],
            members: {
              JobDefinitionName: {}
            }
          }
        },
        DeleteModelPackage: {
          input: {
            type: "structure",
            required: [
              "ModelPackageName"
            ],
            members: {
              ModelPackageName: {}
            }
          }
        },
        DeleteModelPackageGroup: {
          input: {
            type: "structure",
            required: [
              "ModelPackageGroupName"
            ],
            members: {
              ModelPackageGroupName: {}
            }
          }
        },
        DeleteModelPackageGroupPolicy: {
          input: {
            type: "structure",
            required: [
              "ModelPackageGroupName"
            ],
            members: {
              ModelPackageGroupName: {}
            }
          }
        },
        DeleteModelQualityJobDefinition: {
          input: {
            type: "structure",
            required: [
              "JobDefinitionName"
            ],
            members: {
              JobDefinitionName: {}
            }
          }
        },
        DeleteMonitoringSchedule: {
          input: {
            type: "structure",
            required: [
              "MonitoringScheduleName"
            ],
            members: {
              MonitoringScheduleName: {}
            }
          }
        },
        DeleteNotebookInstance: {
          input: {
            type: "structure",
            required: [
              "NotebookInstanceName"
            ],
            members: {
              NotebookInstanceName: {}
            }
          }
        },
        DeleteNotebookInstanceLifecycleConfig: {
          input: {
            type: "structure",
            required: [
              "NotebookInstanceLifecycleConfigName"
            ],
            members: {
              NotebookInstanceLifecycleConfigName: {}
            }
          }
        },
        DeletePipeline: {
          input: {
            type: "structure",
            required: [
              "PipelineName",
              "ClientRequestToken"
            ],
            members: {
              PipelineName: {},
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineArn: {}
            }
          }
        },
        DeleteProject: {
          input: {
            type: "structure",
            required: [
              "ProjectName"
            ],
            members: {
              ProjectName: {}
            }
          }
        },
        DeleteSpace: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "SpaceName"
            ],
            members: {
              DomainId: {},
              SpaceName: {}
            }
          }
        },
        DeleteStudioLifecycleConfig: {
          input: {
            type: "structure",
            required: [
              "StudioLifecycleConfigName"
            ],
            members: {
              StudioLifecycleConfigName: {}
            }
          }
        },
        DeleteTags: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteTrial: {
          input: {
            type: "structure",
            required: [
              "TrialName"
            ],
            members: {
              TrialName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrialArn: {}
            }
          }
        },
        DeleteTrialComponent: {
          input: {
            type: "structure",
            required: [
              "TrialComponentName"
            ],
            members: {
              TrialComponentName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrialComponentArn: {}
            }
          }
        },
        DeleteUserProfile: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "UserProfileName"
            ],
            members: {
              DomainId: {},
              UserProfileName: {}
            }
          }
        },
        DeleteWorkforce: {
          input: {
            type: "structure",
            required: [
              "WorkforceName"
            ],
            members: {
              WorkforceName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteWorkteam: {
          input: {
            type: "structure",
            required: [
              "WorkteamName"
            ],
            members: {
              WorkteamName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Success"
            ],
            members: {
              Success: {
                type: "boolean"
              }
            }
          }
        },
        DeregisterDevices: {
          input: {
            type: "structure",
            required: [
              "DeviceFleetName",
              "DeviceNames"
            ],
            members: {
              DeviceFleetName: {},
              DeviceNames: {
                shape: "Sc5"
              }
            }
          }
        },
        DescribeAction: {
          input: {
            type: "structure",
            required: [
              "ActionName"
            ],
            members: {
              ActionName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ActionName: {},
              ActionArn: {},
              Source: {
                shape: "S1n"
              },
              ActionType: {},
              Description: {},
              Status: {},
              Properties: {
                shape: "S1s"
              },
              CreationTime: {
                type: "timestamp"
              },
              CreatedBy: {
                shape: "Swt"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastModifiedBy: {
                shape: "Swt"
              },
              MetadataProperties: {
                shape: "S1u"
              },
              LineageGroupArn: {}
            }
          }
        },
        DescribeAlgorithm: {
          input: {
            type: "structure",
            required: [
              "AlgorithmName"
            ],
            members: {
              AlgorithmName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "AlgorithmName",
              "AlgorithmArn",
              "CreationTime",
              "TrainingSpecification",
              "AlgorithmStatus",
              "AlgorithmStatusDetails"
            ],
            members: {
              AlgorithmName: {},
              AlgorithmArn: {},
              AlgorithmDescription: {},
              CreationTime: {
                type: "timestamp"
              },
              TrainingSpecification: {
                shape: "S1z"
              },
              InferenceSpecification: {
                shape: "Sr"
              },
              ValidationSpecification: {
                shape: "S2r"
              },
              AlgorithmStatus: {},
              AlgorithmStatusDetails: {
                type: "structure",
                members: {
                  ValidationStatuses: {
                    shape: "Sx0"
                  },
                  ImageScanStatuses: {
                    shape: "Sx0"
                  }
                }
              },
              ProductId: {},
              CertifyForMarketplace: {
                type: "boolean"
              }
            }
          }
        },
        DescribeApp: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "AppType",
              "AppName"
            ],
            members: {
              DomainId: {},
              UserProfileName: {},
              SpaceName: {},
              AppType: {},
              AppName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AppArn: {},
              AppType: {},
              AppName: {},
              DomainId: {},
              UserProfileName: {},
              SpaceName: {},
              Status: {},
              LastHealthCheckTimestamp: {
                type: "timestamp"
              },
              LastUserActivityTimestamp: {
                type: "timestamp"
              },
              CreationTime: {
                type: "timestamp"
              },
              FailureReason: {},
              ResourceSpec: {
                shape: "S4i"
              }
            }
          }
        },
        DescribeAppImageConfig: {
          input: {
            type: "structure",
            required: [
              "AppImageConfigName"
            ],
            members: {
              AppImageConfigName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AppImageConfigArn: {},
              AppImageConfigName: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              KernelGatewayImageConfig: {
                shape: "S4s"
              },
              JupyterLabAppImageConfig: {
                shape: "S51"
              }
            }
          }
        },
        DescribeArtifact: {
          input: {
            type: "structure",
            required: [
              "ArtifactArn"
            ],
            members: {
              ArtifactArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ArtifactName: {},
              ArtifactArn: {},
              Source: {
                shape: "S5b"
              },
              ArtifactType: {},
              Properties: {
                shape: "S1s"
              },
              CreationTime: {
                type: "timestamp"
              },
              CreatedBy: {
                shape: "Swt"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastModifiedBy: {
                shape: "Swt"
              },
              MetadataProperties: {
                shape: "S1u"
              },
              LineageGroupArn: {}
            }
          }
        },
        DescribeAutoMLJob: {
          input: {
            type: "structure",
            required: [
              "AutoMLJobName"
            ],
            members: {
              AutoMLJobName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "AutoMLJobName",
              "AutoMLJobArn",
              "InputDataConfig",
              "OutputDataConfig",
              "RoleArn",
              "CreationTime",
              "LastModifiedTime",
              "AutoMLJobStatus",
              "AutoMLJobSecondaryStatus"
            ],
            members: {
              AutoMLJobName: {},
              AutoMLJobArn: {},
              InputDataConfig: {
                shape: "S5l"
              },
              OutputDataConfig: {
                shape: "S5t"
              },
              RoleArn: {},
              AutoMLJobObjective: {
                shape: "S5v"
              },
              ProblemType: {},
              AutoMLJobConfig: {
                shape: "S5x"
              },
              CreationTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              FailureReason: {},
              PartialFailureReasons: {
                shape: "Sxe"
              },
              BestCandidate: {
                shape: "Sxg"
              },
              AutoMLJobStatus: {},
              AutoMLJobSecondaryStatus: {},
              GenerateCandidateDefinitionsOnly: {
                type: "boolean"
              },
              AutoMLJobArtifacts: {
                shape: "Sy8"
              },
              ResolvedAttributes: {
                type: "structure",
                members: {
                  AutoMLJobObjective: {
                    shape: "S5v"
                  },
                  ProblemType: {},
                  CompletionCriteria: {
                    shape: "S5y"
                  }
                }
              },
              ModelDeployConfig: {
                shape: "S6h"
              },
              ModelDeployResult: {
                shape: "Syc"
              }
            }
          }
        },
        DescribeAutoMLJobV2: {
          input: {
            type: "structure",
            required: [
              "AutoMLJobName"
            ],
            members: {
              AutoMLJobName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "AutoMLJobName",
              "AutoMLJobArn",
              "AutoMLJobInputDataConfig",
              "OutputDataConfig",
              "RoleArn",
              "CreationTime",
              "LastModifiedTime",
              "AutoMLJobStatus",
              "AutoMLJobSecondaryStatus"
            ],
            members: {
              AutoMLJobName: {},
              AutoMLJobArn: {},
              AutoMLJobInputDataConfig: {
                shape: "S6n"
              },
              OutputDataConfig: {
                shape: "S5t"
              },
              RoleArn: {},
              AutoMLJobObjective: {
                shape: "S5v"
              },
              AutoMLProblemTypeConfig: {
                shape: "S6p"
              },
              AutoMLProblemTypeConfigName: {},
              CreationTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              FailureReason: {},
              PartialFailureReasons: {
                shape: "Sxe"
              },
              BestCandidate: {
                shape: "Sxg"
              },
              AutoMLJobStatus: {},
              AutoMLJobSecondaryStatus: {},
              AutoMLJobArtifacts: {
                shape: "Sy8"
              },
              ResolvedAttributes: {
                type: "structure",
                members: {
                  AutoMLJobObjective: {
                    shape: "S5v"
                  },
                  CompletionCriteria: {
                    shape: "S5y"
                  },
                  AutoMLProblemTypeResolvedAttributes: {
                    type: "structure",
                    members: {
                      TabularResolvedAttributes: {
                        type: "structure",
                        members: {
                          ProblemType: {}
                        }
                      },
                      TextGenerationResolvedAttributes: {
                        type: "structure",
                        members: {
                          BaseModelName: {}
                        }
                      }
                    },
                    union: true
                  }
                }
              },
              ModelDeployConfig: {
                shape: "S6h"
              },
              ModelDeployResult: {
                shape: "Syc"
              },
              DataSplitConfig: {
                shape: "S6d"
              },
              SecurityConfig: {
                shape: "S62"
              }
            }
          }
        },
        DescribeCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterName"
            ],
            members: {
              ClusterName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ClusterArn",
              "ClusterStatus",
              "InstanceGroups"
            ],
            members: {
              ClusterArn: {},
              ClusterName: {},
              ClusterStatus: {},
              CreationTime: {
                type: "timestamp"
              },
              FailureMessage: {},
              InstanceGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CurrentCount: {
                      type: "integer"
                    },
                    TargetCount: {
                      type: "integer"
                    },
                    InstanceGroupName: {},
                    InstanceType: {},
                    LifeCycleConfig: {
                      shape: "S7w"
                    },
                    ExecutionRole: {},
                    ThreadsPerCore: {
                      type: "integer"
                    }
                  }
                }
              },
              VpcConfig: {
                shape: "S63"
              }
            }
          }
        },
        DescribeClusterNode: {
          input: {
            type: "structure",
            required: [
              "ClusterName",
              "NodeId"
            ],
            members: {
              ClusterName: {},
              NodeId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "NodeDetails"
            ],
            members: {
              NodeDetails: {
                type: "structure",
                members: {
                  InstanceGroupName: {},
                  InstanceId: {},
                  InstanceStatus: {
                    shape: "Syu"
                  },
                  InstanceType: {},
                  LaunchTime: {
                    type: "timestamp"
                  },
                  LifeCycleConfig: {
                    shape: "S7w"
                  },
                  ThreadsPerCore: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        DescribeCodeRepository: {
          input: {
            type: "structure",
            required: [
              "CodeRepositoryName"
            ],
            members: {
              CodeRepositoryName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "CodeRepositoryName",
              "CodeRepositoryArn",
              "CreationTime",
              "LastModifiedTime"
            ],
            members: {
              CodeRepositoryName: {},
              CodeRepositoryArn: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              GitConfig: {
                shape: "S82"
              }
            }
          }
        },
        DescribeCompilationJob: {
          input: {
            type: "structure",
            required: [
              "CompilationJobName"
            ],
            members: {
              CompilationJobName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "CompilationJobName",
              "CompilationJobArn",
              "CompilationJobStatus",
              "StoppingCondition",
              "CreationTime",
              "LastModifiedTime",
              "FailureReason",
              "ModelArtifacts",
              "RoleArn",
              "InputConfig",
              "OutputConfig"
            ],
            members: {
              CompilationJobName: {},
              CompilationJobArn: {},
              CompilationJobStatus: {},
              CompilationStartTime: {
                type: "timestamp"
              },
              CompilationEndTime: {
                type: "timestamp"
              },
              StoppingCondition: {
                shape: "S3p"
              },
              InferenceImage: {},
              ModelPackageVersionArn: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              FailureReason: {},
              ModelArtifacts: {
                shape: "Sz3"
              },
              ModelDigests: {
                type: "structure",
                members: {
                  ArtifactDigest: {}
                }
              },
              RoleArn: {},
              InputConfig: {
                shape: "S89"
              },
              OutputConfig: {
                shape: "S8c"
              },
              VpcConfig: {
                shape: "S8j"
              },
              DerivedInformation: {
                type: "structure",
                members: {
                  DerivedDataInputConfig: {}
                }
              }
            }
          }
        },
        DescribeContext: {
          input: {
            type: "structure",
            required: [
              "ContextName"
            ],
            members: {
              ContextName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ContextName: {},
              ContextArn: {},
              Source: {
                shape: "S8s"
              },
              ContextType: {},
              Description: {},
              Properties: {
                shape: "S1s"
              },
              CreationTime: {
                type: "timestamp"
              },
              CreatedBy: {
                shape: "Swt"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastModifiedBy: {
                shape: "Swt"
              },
              LineageGroupArn: {}
            }
          }
        },
        DescribeDataQualityJobDefinition: {
          input: {
            type: "structure",
            required: [
              "JobDefinitionName"
            ],
            members: {
              JobDefinitionName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "JobDefinitionArn",
              "JobDefinitionName",
              "CreationTime",
              "DataQualityAppSpecification",
              "DataQualityJobInput",
              "DataQualityJobOutputConfig",
              "JobResources",
              "RoleArn"
            ],
            members: {
              JobDefinitionArn: {},
              JobDefinitionName: {},
              CreationTime: {
                type: "timestamp"
              },
              DataQualityBaselineConfig: {
                shape: "S8x"
              },
              DataQualityAppSpecification: {
                shape: "S91"
              },
              DataQualityJobInput: {
                shape: "S9a"
              },
              DataQualityJobOutputConfig: {
                shape: "S9o"
              },
              JobResources: {
                shape: "S9u"
              },
              NetworkConfig: {
                shape: "S9z"
              },
              RoleArn: {},
              StoppingCondition: {
                shape: "Sa0"
              }
            }
          }
        },
        DescribeDevice: {
          input: {
            type: "structure",
            required: [
              "DeviceName",
              "DeviceFleetName"
            ],
            members: {
              NextToken: {},
              DeviceName: {},
              DeviceFleetName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "DeviceName",
              "DeviceFleetName",
              "RegistrationTime"
            ],
            members: {
              DeviceArn: {},
              DeviceName: {},
              Description: {},
              DeviceFleetName: {},
              IotThingName: {},
              RegistrationTime: {
                type: "timestamp"
              },
              LatestHeartbeat: {
                type: "timestamp"
              },
              Models: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ModelName",
                    "ModelVersion"
                  ],
                  members: {
                    ModelName: {},
                    ModelVersion: {},
                    LatestSampleTime: {
                      type: "timestamp"
                    },
                    LatestInference: {
                      type: "timestamp"
                    }
                  }
                }
              },
              MaxModels: {
                type: "integer"
              },
              NextToken: {},
              AgentVersion: {}
            }
          }
        },
        DescribeDeviceFleet: {
          input: {
            type: "structure",
            required: [
              "DeviceFleetName"
            ],
            members: {
              DeviceFleetName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "DeviceFleetName",
              "DeviceFleetArn",
              "OutputConfig",
              "CreationTime",
              "LastModifiedTime"
            ],
            members: {
              DeviceFleetName: {},
              DeviceFleetArn: {},
              OutputConfig: {
                shape: "Sa6"
              },
              Description: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              RoleArn: {},
              IotRoleAlias: {}
            }
          }
        },
        DescribeDomain: {
          input: {
            type: "structure",
            required: [
              "DomainId"
            ],
            members: {
              DomainId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DomainArn: {},
              DomainId: {},
              DomainName: {},
              HomeEfsFileSystemId: {},
              SingleSignOnManagedApplicationInstanceId: {},
              SingleSignOnApplicationArn: {},
              Status: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              FailureReason: {},
              SecurityGroupIdForDomainBoundary: {},
              AuthMode: {},
              DefaultUserSettings: {
                shape: "Sac"
              },
              DomainSettings: {
                shape: "Sbj"
              },
              AppNetworkAccessType: {},
              HomeEfsFileSystemKmsKeyId: {
                deprecated: true,
                deprecatedMessage: "This property is deprecated, use KmsKeyId instead."
              },
              SubnetIds: {
                shape: "S66"
              },
              Url: {},
              VpcId: {},
              KmsKeyId: {},
              AppSecurityGroupManagement: {},
              DefaultSpaceSettings: {
                shape: "Sbt"
              }
            }
          }
        },
        DescribeEdgeDeploymentPlan: {
          input: {
            type: "structure",
            required: [
              "EdgeDeploymentPlanName"
            ],
            members: {
              EdgeDeploymentPlanName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EdgeDeploymentPlanArn",
              "EdgeDeploymentPlanName",
              "ModelConfigs",
              "DeviceFleetName",
              "Stages"
            ],
            members: {
              EdgeDeploymentPlanArn: {},
              EdgeDeploymentPlanName: {},
              ModelConfigs: {
                shape: "Sby"
              },
              DeviceFleetName: {},
              EdgeDeploymentSuccess: {
                type: "integer"
              },
              EdgeDeploymentPending: {
                type: "integer"
              },
              EdgeDeploymentFailed: {
                type: "integer"
              },
              Stages: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "StageName",
                    "DeviceSelectionConfig",
                    "DeploymentConfig",
                    "DeploymentStatus"
                  ],
                  members: {
                    StageName: {},
                    DeviceSelectionConfig: {
                      shape: "Sc2"
                    },
                    DeploymentConfig: {
                      shape: "Sc7"
                    },
                    DeploymentStatus: {
                      type: "structure",
                      required: [
                        "StageStatus",
                        "EdgeDeploymentSuccessInStage",
                        "EdgeDeploymentPendingInStage",
                        "EdgeDeploymentFailedInStage"
                      ],
                      members: {
                        StageStatus: {},
                        EdgeDeploymentSuccessInStage: {
                          type: "integer"
                        },
                        EdgeDeploymentPendingInStage: {
                          type: "integer"
                        },
                        EdgeDeploymentFailedInStage: {
                          type: "integer"
                        },
                        EdgeDeploymentStatusMessage: {},
                        EdgeDeploymentStageStartTime: {
                          type: "timestamp"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeEdgePackagingJob: {
          input: {
            type: "structure",
            required: [
              "EdgePackagingJobName"
            ],
            members: {
              EdgePackagingJobName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "EdgePackagingJobArn",
              "EdgePackagingJobName",
              "EdgePackagingJobStatus"
            ],
            members: {
              EdgePackagingJobArn: {},
              EdgePackagingJobName: {},
              CompilationJobName: {},
              ModelName: {},
              ModelVersion: {},
              RoleArn: {},
              OutputConfig: {
                shape: "Sa6"
              },
              ResourceKey: {},
              EdgePackagingJobStatus: {},
              EdgePackagingJobStatusMessage: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              ModelArtifact: {},
              ModelSignature: {},
              PresetDeploymentOutput: {
                type: "structure",
                required: [
                  "Type"
                ],
                members: {
                  Type: {},
                  Artifact: {},
                  Status: {},
                  StatusMessage: {}
                }
              }
            }
          }
        },
        DescribeEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointName"
            ],
            members: {
              EndpointName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "EndpointName",
              "EndpointArn",
              "EndpointStatus",
              "CreationTime",
              "LastModifiedTime"
            ],
            members: {
              EndpointName: {},
              EndpointArn: {},
              EndpointConfigName: {},
              ProductionVariants: {
                shape: "S109"
              },
              DataCaptureConfig: {
                shape: "S10h"
              },
              EndpointStatus: {},
              FailureReason: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastDeploymentConfig: {
                shape: "Scg"
              },
              AsyncInferenceConfig: {
                shape: "Sdv"
              },
              PendingDeploymentSummary: {
                type: "structure",
                required: [
                  "EndpointConfigName"
                ],
                members: {
                  EndpointConfigName: {},
                  ProductionVariants: {
                    shape: "S10l"
                  },
                  StartTime: {
                    type: "timestamp"
                  },
                  ShadowProductionVariants: {
                    shape: "S10l"
                  }
                }
              },
              ExplainerConfig: {
                shape: "Se3"
              },
              ShadowProductionVariants: {
                shape: "S109"
              }
            }
          }
        },
        DescribeEndpointConfig: {
          input: {
            type: "structure",
            required: [
              "EndpointConfigName"
            ],
            members: {
              EndpointConfigName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "EndpointConfigName",
              "EndpointConfigArn",
              "ProductionVariants",
              "CreationTime"
            ],
            members: {
              EndpointConfigName: {},
              EndpointConfigArn: {},
              ProductionVariants: {
                shape: "Scy"
              },
              DataCaptureConfig: {
                shape: "Sdk"
              },
              KmsKeyId: {},
              CreationTime: {
                type: "timestamp"
              },
              AsyncInferenceConfig: {
                shape: "Sdv"
              },
              ExplainerConfig: {
                shape: "Se3"
              },
              ShadowProductionVariants: {
                shape: "Scy"
              },
              ExecutionRoleArn: {},
              VpcConfig: {
                shape: "S63"
              },
              EnableNetworkIsolation: {
                type: "boolean"
              }
            }
          }
        },
        DescribeExperiment: {
          input: {
            type: "structure",
            required: [
              "ExperimentName"
            ],
            members: {
              ExperimentName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ExperimentName: {},
              ExperimentArn: {},
              DisplayName: {},
              Source: {
                shape: "S10r"
              },
              Description: {},
              CreationTime: {
                type: "timestamp"
              },
              CreatedBy: {
                shape: "Swt"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastModifiedBy: {
                shape: "Swt"
              }
            }
          }
        },
        DescribeFeatureGroup: {
          input: {
            type: "structure",
            required: [
              "FeatureGroupName"
            ],
            members: {
              FeatureGroupName: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "FeatureGroupArn",
              "FeatureGroupName",
              "RecordIdentifierFeatureName",
              "EventTimeFeatureName",
              "FeatureDefinitions",
              "CreationTime",
              "NextToken"
            ],
            members: {
              FeatureGroupArn: {},
              FeatureGroupName: {},
              RecordIdentifierFeatureName: {},
              EventTimeFeatureName: {},
              FeatureDefinitions: {
                shape: "Sf2"
              },
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              OnlineStoreConfig: {
                shape: "Sf9"
              },
              OfflineStoreConfig: {
                shape: "Sff"
              },
              ThroughputConfig: {
                type: "structure",
                required: [
                  "ThroughputMode"
                ],
                members: {
                  ThroughputMode: {},
                  ProvisionedReadCapacityUnits: {
                    type: "integer"
                  },
                  ProvisionedWriteCapacityUnits: {
                    type: "integer"
                  }
                }
              },
              RoleArn: {},
              FeatureGroupStatus: {},
              OfflineStoreStatus: {
                shape: "S10z"
              },
              LastUpdateStatus: {
                shape: "S112"
              },
              FailureReason: {},
              Description: {},
              NextToken: {},
              OnlineStoreTotalSizeBytes: {
                type: "long"
              }
            }
          }
        },
        DescribeFeatureMetadata: {
          input: {
            type: "structure",
            required: [
              "FeatureGroupName",
              "FeatureName"
            ],
            members: {
              FeatureGroupName: {},
              FeatureName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "FeatureGroupArn",
              "FeatureGroupName",
              "FeatureName",
              "FeatureType",
              "CreationTime",
              "LastModifiedTime"
            ],
            members: {
              FeatureGroupArn: {},
              FeatureGroupName: {},
              FeatureName: {},
              FeatureType: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              Description: {},
              Parameters: {
                shape: "S118"
              }
            }
          }
        },
        DescribeFlowDefinition: {
          input: {
            type: "structure",
            required: [
              "FlowDefinitionName"
            ],
            members: {
              FlowDefinitionName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "FlowDefinitionArn",
              "FlowDefinitionName",
              "FlowDefinitionStatus",
              "CreationTime",
              "OutputConfig",
              "RoleArn"
            ],
            members: {
              FlowDefinitionArn: {},
              FlowDefinitionName: {},
              FlowDefinitionStatus: {},
              CreationTime: {
                type: "timestamp"
              },
              HumanLoopRequestSource: {
                shape: "Sfu"
              },
              HumanLoopActivationConfig: {
                shape: "Sfw"
              },
              HumanLoopConfig: {
                shape: "Sfz"
              },
              OutputConfig: {
                shape: "Sge"
              },
              RoleArn: {},
              FailureReason: {}
            }
          }
        },
        DescribeHub: {
          input: {
            type: "structure",
            required: [
              "HubName"
            ],
            members: {
              HubName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "HubName",
              "HubArn",
              "HubStatus",
              "CreationTime",
              "LastModifiedTime"
            ],
            members: {
              HubName: {},
              HubArn: {},
              HubDisplayName: {},
              HubDescription: {},
              HubSearchKeywords: {
                shape: "Sgl"
              },
              S3StorageConfig: {
                shape: "Sgn"
              },
              HubStatus: {},
              FailureReason: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeHubContent: {
          input: {
            type: "structure",
            required: [
              "HubName",
              "HubContentType",
              "HubContentName"
            ],
            members: {
              HubName: {},
              HubContentType: {},
              HubContentName: {},
              HubContentVersion: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "HubContentName",
              "HubContentArn",
              "HubContentVersion",
              "HubContentType",
              "DocumentSchemaVersion",
              "HubName",
              "HubArn",
              "HubContentDocument",
              "HubContentStatus",
              "CreationTime"
            ],
            members: {
              HubContentName: {},
              HubContentArn: {},
              HubContentVersion: {},
              HubContentType: {},
              DocumentSchemaVersion: {},
              HubName: {},
              HubArn: {},
              HubContentDisplayName: {},
              HubContentDescription: {},
              HubContentMarkdown: {},
              HubContentDocument: {},
              HubContentSearchKeywords: {
                shape: "S11q"
              },
              HubContentDependencies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DependencyOriginPath: {},
                    DependencyCopyPath: {}
                  }
                }
              },
              HubContentStatus: {},
              FailureReason: {},
              CreationTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeHumanTaskUi: {
          input: {
            type: "structure",
            required: [
              "HumanTaskUiName"
            ],
            members: {
              HumanTaskUiName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "HumanTaskUiArn",
              "HumanTaskUiName",
              "CreationTime",
              "UiTemplate"
            ],
            members: {
              HumanTaskUiArn: {},
              HumanTaskUiName: {},
              HumanTaskUiStatus: {},
              CreationTime: {
                type: "timestamp"
              },
              UiTemplate: {
                type: "structure",
                members: {
                  Url: {},
                  ContentSha256: {}
                }
              }
            }
          }
        },
        DescribeHyperParameterTuningJob: {
          input: {
            type: "structure",
            required: [
              "HyperParameterTuningJobName"
            ],
            members: {
              HyperParameterTuningJobName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "HyperParameterTuningJobName",
              "HyperParameterTuningJobArn",
              "HyperParameterTuningJobConfig",
              "HyperParameterTuningJobStatus",
              "CreationTime",
              "TrainingJobStatusCounters",
              "ObjectiveStatusCounters"
            ],
            members: {
              HyperParameterTuningJobName: {},
              HyperParameterTuningJobArn: {},
              HyperParameterTuningJobConfig: {
                shape: "Sgy"
              },
              TrainingJobDefinition: {
                shape: "Shr"
              },
              TrainingJobDefinitions: {
                shape: "Si7"
              },
              HyperParameterTuningJobStatus: {},
              CreationTime: {
                type: "timestamp"
              },
              HyperParameterTuningEndTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              TrainingJobStatusCounters: {
                shape: "S125"
              },
              ObjectiveStatusCounters: {
                shape: "S127"
              },
              BestTrainingJob: {
                shape: "S129"
              },
              OverallBestTrainingJob: {
                shape: "S129"
              },
              WarmStartConfig: {
                shape: "Si8"
              },
              Autotune: {
                shape: "Sic"
              },
              FailureReason: {},
              TuningJobCompletionDetails: {
                shape: "S12c"
              },
              ConsumedResources: {
                shape: "S12d"
              }
            }
          }
        },
        DescribeImage: {
          input: {
            type: "structure",
            required: [
              "ImageName"
            ],
            members: {
              ImageName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CreationTime: {
                type: "timestamp"
              },
              Description: {},
              DisplayName: {},
              FailureReason: {},
              ImageArn: {},
              ImageName: {},
              ImageStatus: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              RoleArn: {}
            }
          }
        },
        DescribeImageVersion: {
          input: {
            type: "structure",
            required: [
              "ImageName"
            ],
            members: {
              ImageName: {},
              Version: {
                type: "integer"
              },
              Alias: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BaseImage: {},
              ContainerImage: {},
              CreationTime: {
                type: "timestamp"
              },
              FailureReason: {},
              ImageArn: {},
              ImageVersionArn: {},
              ImageVersionStatus: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              Version: {
                type: "integer"
              },
              VendorGuidance: {},
              JobType: {},
              MLFramework: {},
              ProgrammingLang: {},
              Processor: {},
              Horovod: {
                type: "boolean"
              },
              ReleaseNotes: {}
            }
          }
        },
        DescribeInferenceComponent: {
          input: {
            type: "structure",
            required: [
              "InferenceComponentName"
            ],
            members: {
              InferenceComponentName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "InferenceComponentName",
              "InferenceComponentArn",
              "EndpointName",
              "EndpointArn",
              "CreationTime",
              "LastModifiedTime"
            ],
            members: {
              InferenceComponentName: {},
              InferenceComponentArn: {},
              EndpointName: {},
              EndpointArn: {},
              VariantName: {},
              FailureReason: {},
              Specification: {
                type: "structure",
                members: {
                  ModelName: {},
                  Container: {
                    type: "structure",
                    members: {
                      DeployedImage: {
                        shape: "S10c"
                      },
                      ArtifactUrl: {},
                      Environment: {
                        shape: "Sz"
                      }
                    }
                  },
                  StartupParameters: {
                    shape: "Sj1"
                  },
                  ComputeResourceRequirements: {
                    shape: "Sj2"
                  }
                }
              },
              RuntimeConfig: {
                type: "structure",
                members: {
                  DesiredCopyCount: {
                    type: "integer"
                  },
                  CurrentCopyCount: {
                    type: "integer"
                  }
                }
              },
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              InferenceComponentStatus: {}
            }
          }
        },
        DescribeInferenceExperiment: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Arn",
              "Name",
              "Type",
              "Status",
              "EndpointMetadata",
              "ModelVariants"
            ],
            members: {
              Arn: {},
              Name: {},
              Type: {},
              Schedule: {
                shape: "Sjd"
              },
              Status: {},
              StatusReason: {},
              Description: {},
              CreationTime: {
                type: "timestamp"
              },
              CompletionTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              RoleArn: {},
              EndpointMetadata: {
                type: "structure",
                required: [
                  "EndpointName"
                ],
                members: {
                  EndpointName: {},
                  EndpointConfigName: {},
                  EndpointStatus: {},
                  FailureReason: {}
                }
              },
              ModelVariants: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ModelName",
                    "VariantName",
                    "InfrastructureConfig",
                    "Status"
                  ],
                  members: {
                    ModelName: {},
                    VariantName: {},
                    InfrastructureConfig: {
                      shape: "Sjj"
                    },
                    Status: {}
                  }
                }
              },
              DataStorageConfig: {
                shape: "Sjo"
              },
              ShadowModeConfig: {
                shape: "Sjp"
              },
              KmsKey: {}
            }
          }
        },
        DescribeInferenceRecommendationsJob: {
          input: {
            type: "structure",
            required: [
              "JobName"
            ],
            members: {
              JobName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "JobName",
              "JobType",
              "JobArn",
              "RoleArn",
              "Status",
              "CreationTime",
              "LastModifiedTime",
              "InputConfig"
            ],
            members: {
              JobName: {},
              JobDescription: {},
              JobType: {},
              JobArn: {},
              RoleArn: {},
              Status: {},
              CreationTime: {
                type: "timestamp"
              },
              CompletionTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              FailureReason: {},
              InputConfig: {
                shape: "Sjx"
              },
              StoppingConditions: {
                shape: "Sl3"
              },
              InferenceRecommendations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Metrics",
                    "EndpointConfiguration",
                    "ModelConfiguration"
                  ],
                  members: {
                    RecommendationId: {},
                    Metrics: {
                      shape: "S134"
                    },
                    EndpointConfiguration: {
                      shape: "S137"
                    },
                    ModelConfiguration: {
                      shape: "S139"
                    },
                    InvocationEndTime: {
                      type: "timestamp"
                    },
                    InvocationStartTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              EndpointPerformances: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Metrics",
                    "EndpointInfo"
                  ],
                  members: {
                    Metrics: {
                      shape: "S13h"
                    },
                    EndpointInfo: {
                      shape: "Skw"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeLabelingJob: {
          input: {
            type: "structure",
            required: [
              "LabelingJobName"
            ],
            members: {
              LabelingJobName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "LabelingJobStatus",
              "LabelCounters",
              "CreationTime",
              "LastModifiedTime",
              "JobReferenceCode",
              "LabelingJobName",
              "LabelingJobArn",
              "InputConfig",
              "OutputConfig",
              "RoleArn",
              "HumanTaskConfig"
            ],
            members: {
              LabelingJobStatus: {},
              LabelCounters: {
                shape: "S13l"
              },
              FailureReason: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              JobReferenceCode: {},
              LabelingJobName: {},
              LabelingJobArn: {},
              LabelAttributeName: {},
              InputConfig: {
                shape: "Slf"
              },
              OutputConfig: {
                shape: "Slm"
              },
              RoleArn: {},
              LabelCategoryConfigS3Uri: {},
              StoppingConditions: {
                shape: "Sln"
              },
              LabelingJobAlgorithmsConfig: {
                shape: "Slq"
              },
              HumanTaskConfig: {
                shape: "Slu"
              },
              Tags: {
                shape: "S7"
              },
              LabelingJobOutput: {
                shape: "S13o"
              }
            }
          }
        },
        DescribeLineageGroup: {
          input: {
            type: "structure",
            required: [
              "LineageGroupName"
            ],
            members: {
              LineageGroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LineageGroupName: {},
              LineageGroupArn: {},
              DisplayName: {},
              Description: {},
              CreationTime: {
                type: "timestamp"
              },
              CreatedBy: {
                shape: "Swt"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastModifiedBy: {
                shape: "Swt"
              }
            }
          }
        },
        DescribeModel: {
          input: {
            type: "structure",
            required: [
              "ModelName"
            ],
            members: {
              ModelName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ModelName",
              "CreationTime",
              "ModelArn"
            ],
            members: {
              ModelName: {},
              PrimaryContainer: {
                shape: "Sm9"
              },
              Containers: {
                shape: "Smn"
              },
              InferenceExecutionConfig: {
                shape: "Smo"
              },
              ExecutionRoleArn: {},
              VpcConfig: {
                shape: "S63"
              },
              CreationTime: {
                type: "timestamp"
              },
              ModelArn: {},
              EnableNetworkIsolation: {
                type: "boolean"
              },
              DeploymentRecommendation: {
                shape: "S13t"
              }
            }
          }
        },
        DescribeModelBiasJobDefinition: {
          input: {
            type: "structure",
            required: [
              "JobDefinitionName"
            ],
            members: {
              JobDefinitionName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "JobDefinitionArn",
              "JobDefinitionName",
              "CreationTime",
              "ModelBiasAppSpecification",
              "ModelBiasJobInput",
              "ModelBiasJobOutputConfig",
              "JobResources",
              "RoleArn"
            ],
            members: {
              JobDefinitionArn: {},
              JobDefinitionName: {},
              CreationTime: {
                type: "timestamp"
              },
              ModelBiasBaselineConfig: {
                shape: "Sms"
              },
              ModelBiasAppSpecification: {
                shape: "Smt"
              },
              ModelBiasJobInput: {
                shape: "Smu"
              },
              ModelBiasJobOutputConfig: {
                shape: "S9o"
              },
              JobResources: {
                shape: "S9u"
              },
              NetworkConfig: {
                shape: "S9z"
              },
              RoleArn: {},
              StoppingCondition: {
                shape: "Sa0"
              }
            }
          }
        },
        DescribeModelCard: {
          input: {
            type: "structure",
            required: [
              "ModelCardName"
            ],
            members: {
              ModelCardName: {},
              ModelCardVersion: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ModelCardArn",
              "ModelCardName",
              "ModelCardVersion",
              "Content",
              "ModelCardStatus",
              "CreationTime",
              "CreatedBy"
            ],
            members: {
              ModelCardArn: {},
              ModelCardName: {},
              ModelCardVersion: {
                type: "integer"
              },
              Content: {
                shape: "Smz"
              },
              ModelCardStatus: {},
              SecurityConfig: {
                shape: "Smy"
              },
              CreationTime: {
                type: "timestamp"
              },
              CreatedBy: {
                shape: "Swt"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastModifiedBy: {
                shape: "Swt"
              },
              ModelCardProcessingStatus: {}
            }
          }
        },
        DescribeModelCardExportJob: {
          input: {
            type: "structure",
            required: [
              "ModelCardExportJobArn"
            ],
            members: {
              ModelCardExportJobArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ModelCardExportJobName",
              "ModelCardExportJobArn",
              "Status",
              "ModelCardName",
              "ModelCardVersion",
              "OutputConfig",
              "CreatedAt",
              "LastModifiedAt"
            ],
            members: {
              ModelCardExportJobName: {},
              ModelCardExportJobArn: {},
              Status: {},
              ModelCardName: {},
              ModelCardVersion: {
                type: "integer"
              },
              OutputConfig: {
                shape: "Sn5"
              },
              CreatedAt: {
                type: "timestamp"
              },
              LastModifiedAt: {
                type: "timestamp"
              },
              FailureReason: {},
              ExportArtifacts: {
                type: "structure",
                required: [
                  "S3ExportArtifacts"
                ],
                members: {
                  S3ExportArtifacts: {}
                }
              }
            }
          }
        },
        DescribeModelExplainabilityJobDefinition: {
          input: {
            type: "structure",
            required: [
              "JobDefinitionName"
            ],
            members: {
              JobDefinitionName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "JobDefinitionArn",
              "JobDefinitionName",
              "CreationTime",
              "ModelExplainabilityAppSpecification",
              "ModelExplainabilityJobInput",
              "ModelExplainabilityJobOutputConfig",
              "JobResources",
              "RoleArn"
            ],
            members: {
              JobDefinitionArn: {},
              JobDefinitionName: {},
              CreationTime: {
                type: "timestamp"
              },
              ModelExplainabilityBaselineConfig: {
                shape: "Sn9"
              },
              ModelExplainabilityAppSpecification: {
                shape: "Sna"
              },
              ModelExplainabilityJobInput: {
                shape: "Snb"
              },
              ModelExplainabilityJobOutputConfig: {
                shape: "S9o"
              },
              JobResources: {
                shape: "S9u"
              },
              NetworkConfig: {
                shape: "S9z"
              },
              RoleArn: {},
              StoppingCondition: {
                shape: "Sa0"
              }
            }
          }
        },
        DescribeModelPackage: {
          input: {
            type: "structure",
            required: [
              "ModelPackageName"
            ],
            members: {
              ModelPackageName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ModelPackageName",
              "ModelPackageArn",
              "CreationTime",
              "ModelPackageStatus",
              "ModelPackageStatusDetails"
            ],
            members: {
              ModelPackageName: {},
              ModelPackageGroupName: {},
              ModelPackageVersion: {
                type: "integer"
              },
              ModelPackageArn: {},
              ModelPackageDescription: {},
              CreationTime: {
                type: "timestamp"
              },
              InferenceSpecification: {
                shape: "Sr"
              },
              SourceAlgorithmSpecification: {
                shape: "Snh"
              },
              ValidationSpecification: {
                shape: "Sne"
              },
              ModelPackageStatus: {},
              ModelPackageStatusDetails: {
                shape: "S14a"
              },
              CertifyForMarketplace: {
                type: "boolean"
              },
              ModelApprovalStatus: {},
              CreatedBy: {
                shape: "Swt"
              },
              MetadataProperties: {
                shape: "S1u"
              },
              ModelMetrics: {
                shape: "Snk"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastModifiedBy: {
                shape: "Swt"
              },
              ApprovalDescription: {},
              Domain: {},
              Task: {},
              SamplePayloadUrl: {},
              CustomerMetadataProperties: {
                shape: "Snr"
              },
              DriftCheckBaselines: {
                shape: "Snu"
              },
              AdditionalInferenceSpecifications: {
                shape: "So0"
              },
              SkipModelValidation: {}
            }
          }
        },
        DescribeModelPackageGroup: {
          input: {
            type: "structure",
            required: [
              "ModelPackageGroupName"
            ],
            members: {
              ModelPackageGroupName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ModelPackageGroupName",
              "ModelPackageGroupArn",
              "CreationTime",
              "CreatedBy",
              "ModelPackageGroupStatus"
            ],
            members: {
              ModelPackageGroupName: {},
              ModelPackageGroupArn: {},
              ModelPackageGroupDescription: {},
              CreationTime: {
                type: "timestamp"
              },
              CreatedBy: {
                shape: "Swt"
              },
              ModelPackageGroupStatus: {}
            }
          }
        },
        DescribeModelQualityJobDefinition: {
          input: {
            type: "structure",
            required: [
              "JobDefinitionName"
            ],
            members: {
              JobDefinitionName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "JobDefinitionArn",
              "JobDefinitionName",
              "CreationTime",
              "ModelQualityAppSpecification",
              "ModelQualityJobInput",
              "ModelQualityJobOutputConfig",
              "JobResources",
              "RoleArn"
            ],
            members: {
              JobDefinitionArn: {},
              JobDefinitionName: {},
              CreationTime: {
                type: "timestamp"
              },
              ModelQualityBaselineConfig: {
                shape: "So8"
              },
              ModelQualityAppSpecification: {
                shape: "So9"
              },
              ModelQualityJobInput: {
                shape: "Sob"
              },
              ModelQualityJobOutputConfig: {
                shape: "S9o"
              },
              JobResources: {
                shape: "S9u"
              },
              NetworkConfig: {
                shape: "S9z"
              },
              RoleArn: {},
              StoppingCondition: {
                shape: "Sa0"
              }
            }
          }
        },
        DescribeMonitoringSchedule: {
          input: {
            type: "structure",
            required: [
              "MonitoringScheduleName"
            ],
            members: {
              MonitoringScheduleName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "MonitoringScheduleArn",
              "MonitoringScheduleName",
              "MonitoringScheduleStatus",
              "CreationTime",
              "LastModifiedTime",
              "MonitoringScheduleConfig"
            ],
            members: {
              MonitoringScheduleArn: {},
              MonitoringScheduleName: {},
              MonitoringScheduleStatus: {},
              MonitoringType: {},
              FailureReason: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              MonitoringScheduleConfig: {
                shape: "Sof"
              },
              EndpointName: {},
              LastMonitoringExecutionSummary: {
                shape: "S14n"
              }
            }
          }
        },
        DescribeNotebookInstance: {
          input: {
            type: "structure",
            required: [
              "NotebookInstanceName"
            ],
            members: {
              NotebookInstanceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NotebookInstanceArn: {},
              NotebookInstanceName: {},
              NotebookInstanceStatus: {},
              FailureReason: {},
              Url: {},
              InstanceType: {},
              SubnetId: {},
              SecurityGroups: {
                shape: "Sad"
              },
              RoleArn: {},
              KmsKeyId: {},
              NetworkInterfaceId: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              CreationTime: {
                type: "timestamp"
              },
              NotebookInstanceLifecycleConfigName: {},
              DirectInternetAccess: {},
              VolumeSizeInGB: {
                type: "integer"
              },
              AcceleratorTypes: {
                shape: "Sow"
              },
              DefaultCodeRepository: {},
              AdditionalCodeRepositories: {
                shape: "Soz"
              },
              RootAccess: {},
              PlatformIdentifier: {},
              InstanceMetadataServiceConfiguration: {
                shape: "Sp2"
              }
            }
          }
        },
        DescribeNotebookInstanceLifecycleConfig: {
          input: {
            type: "structure",
            required: [
              "NotebookInstanceLifecycleConfigName"
            ],
            members: {
              NotebookInstanceLifecycleConfigName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NotebookInstanceLifecycleConfigArn: {},
              NotebookInstanceLifecycleConfigName: {},
              OnCreate: {
                shape: "Sp7"
              },
              OnStart: {
                shape: "Sp7"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              CreationTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribePipeline: {
          input: {
            type: "structure",
            required: [
              "PipelineName"
            ],
            members: {
              PipelineName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineArn: {},
              PipelineName: {},
              PipelineDisplayName: {},
              PipelineDefinition: {},
              PipelineDescription: {},
              RoleArn: {},
              PipelineStatus: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastRunTime: {
                type: "timestamp"
              },
              CreatedBy: {
                shape: "Swt"
              },
              LastModifiedBy: {
                shape: "Swt"
              },
              ParallelismConfiguration: {
                shape: "Spl"
              }
            }
          }
        },
        DescribePipelineDefinitionForExecution: {
          input: {
            type: "structure",
            required: [
              "PipelineExecutionArn"
            ],
            members: {
              PipelineExecutionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineDefinition: {},
              CreationTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribePipelineExecution: {
          input: {
            type: "structure",
            required: [
              "PipelineExecutionArn"
            ],
            members: {
              PipelineExecutionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineArn: {},
              PipelineExecutionArn: {},
              PipelineExecutionDisplayName: {},
              PipelineExecutionStatus: {},
              PipelineExecutionDescription: {},
              PipelineExperimentConfig: {
                shape: "S157"
              },
              FailureReason: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              CreatedBy: {
                shape: "Swt"
              },
              LastModifiedBy: {
                shape: "Swt"
              },
              ParallelismConfiguration: {
                shape: "Spl"
              },
              SelectiveExecutionConfig: {
                shape: "S159"
              }
            }
          }
        },
        DescribeProcessingJob: {
          input: {
            type: "structure",
            required: [
              "ProcessingJobName"
            ],
            members: {
              ProcessingJobName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ProcessingJobName",
              "ProcessingResources",
              "AppSpecification",
              "ProcessingJobArn",
              "ProcessingJobStatus",
              "CreationTime"
            ],
            members: {
              ProcessingInputs: {
                shape: "Spy"
              },
              ProcessingOutputConfig: {
                shape: "Sql"
              },
              ProcessingJobName: {},
              ProcessingResources: {
                shape: "Sqq"
              },
              StoppingCondition: {
                shape: "Sqs"
              },
              AppSpecification: {
                shape: "Squ"
              },
              Environment: {
                shape: "Sqw"
              },
              NetworkConfig: {
                shape: "Son"
              },
              RoleArn: {},
              ExperimentConfig: {
                shape: "Sqx"
              },
              ProcessingJobArn: {},
              ProcessingJobStatus: {},
              ExitMessage: {},
              FailureReason: {},
              ProcessingEndTime: {
                type: "timestamp"
              },
              ProcessingStartTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              CreationTime: {
                type: "timestamp"
              },
              MonitoringScheduleArn: {},
              AutoMLJobArn: {},
              TrainingJobArn: {}
            }
          }
        },
        DescribeProject: {
          input: {
            type: "structure",
            required: [
              "ProjectName"
            ],
            members: {
              ProjectName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ProjectArn",
              "ProjectName",
              "ProjectId",
              "ServiceCatalogProvisioningDetails",
              "ProjectStatus",
              "CreationTime"
            ],
            members: {
              ProjectArn: {},
              ProjectName: {},
              ProjectId: {},
              ProjectDescription: {},
              ServiceCatalogProvisioningDetails: {
                shape: "Sr2"
              },
              ServiceCatalogProvisionedProductDetails: {
                shape: "S15i"
              },
              ProjectStatus: {},
              CreatedBy: {
                shape: "Swt"
              },
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastModifiedBy: {
                shape: "Swt"
              }
            }
          }
        },
        DescribeSpace: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "SpaceName"
            ],
            members: {
              DomainId: {},
              SpaceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DomainId: {},
              SpaceArn: {},
              SpaceName: {},
              HomeEfsFileSystemUid: {},
              Status: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              CreationTime: {
                type: "timestamp"
              },
              FailureReason: {},
              SpaceSettings: {
                shape: "Src"
              },
              OwnershipSettings: {
                shape: "Srk"
              },
              SpaceSharingSettings: {
                shape: "Srl"
              },
              SpaceDisplayName: {},
              Url: {}
            }
          }
        },
        DescribeStudioLifecycleConfig: {
          input: {
            type: "structure",
            required: [
              "StudioLifecycleConfigName"
            ],
            members: {
              StudioLifecycleConfigName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StudioLifecycleConfigArn: {},
              StudioLifecycleConfigName: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              StudioLifecycleConfigContent: {},
              StudioLifecycleConfigAppType: {}
            }
          }
        },
        DescribeSubscribedWorkteam: {
          input: {
            type: "structure",
            required: [
              "WorkteamArn"
            ],
            members: {
              WorkteamArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "SubscribedWorkteam"
            ],
            members: {
              SubscribedWorkteam: {
                shape: "S15t"
              }
            }
          }
        },
        DescribeTrainingJob: {
          input: {
            type: "structure",
            required: [
              "TrainingJobName"
            ],
            members: {
              TrainingJobName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "TrainingJobName",
              "TrainingJobArn",
              "ModelArtifacts",
              "TrainingJobStatus",
              "SecondaryStatus",
              "AlgorithmSpecification",
              "ResourceConfig",
              "StoppingCondition",
              "CreationTime"
            ],
            members: {
              TrainingJobName: {},
              TrainingJobArn: {},
              TuningJobArn: {},
              LabelingJobArn: {},
              AutoMLJobArn: {},
              ModelArtifacts: {
                shape: "Sz3"
              },
              TrainingJobStatus: {},
              SecondaryStatus: {},
              FailureReason: {},
              HyperParameters: {
                shape: "S2w"
              },
              AlgorithmSpecification: {
                shape: "Srw"
              },
              RoleArn: {},
              InputDataConfig: {
                shape: "S2y"
              },
              OutputDataConfig: {
                shape: "S3g"
              },
              ResourceConfig: {
                shape: "S3j"
              },
              WarmPoolStatus: {
                shape: "S15x"
              },
              VpcConfig: {
                shape: "S63"
              },
              StoppingCondition: {
                shape: "S3p"
              },
              CreationTime: {
                type: "timestamp"
              },
              TrainingStartTime: {
                type: "timestamp"
              },
              TrainingEndTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              SecondaryStatusTransitions: {
                shape: "S160"
              },
              FinalMetricDataList: {
                shape: "S163"
              },
              EnableNetworkIsolation: {
                type: "boolean"
              },
              EnableInterContainerTrafficEncryption: {
                type: "boolean"
              },
              EnableManagedSpotTraining: {
                type: "boolean"
              },
              CheckpointConfig: {
                shape: "Si1"
              },
              TrainingTimeInSeconds: {
                type: "integer"
              },
              BillableTimeInSeconds: {
                type: "integer"
              },
              DebugHookConfig: {
                shape: "Ss5"
              },
              ExperimentConfig: {
                shape: "Sqx"
              },
              DebugRuleConfigurations: {
                shape: "Ssd"
              },
              TensorBoardOutputConfig: {
                shape: "Ssh"
              },
              DebugRuleEvaluationStatuses: {
                shape: "S167"
              },
              ProfilerConfig: {
                shape: "Ssi"
              },
              ProfilerRuleConfigurations: {
                shape: "Ssm"
              },
              ProfilerRuleEvaluationStatuses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RuleConfigurationName: {},
                    RuleEvaluationJobArn: {},
                    RuleEvaluationStatus: {},
                    StatusDetails: {},
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              ProfilingStatus: {},
              Environment: {
                shape: "Sso"
              },
              RetryStrategy: {
                shape: "Si2"
              },
              RemoteDebugConfig: {
                shape: "Ssr"
              },
              InfraCheckConfig: {
                shape: "Sst"
              }
            }
          }
        },
        DescribeTransformJob: {
          input: {
            type: "structure",
            required: [
              "TransformJobName"
            ],
            members: {
              TransformJobName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "TransformJobName",
              "TransformJobArn",
              "TransformJobStatus",
              "ModelName",
              "TransformInput",
              "TransformResources",
              "CreationTime"
            ],
            members: {
              TransformJobName: {},
              TransformJobArn: {},
              TransformJobStatus: {},
              FailureReason: {},
              ModelName: {},
              MaxConcurrentTransforms: {
                type: "integer"
              },
              ModelClientConfig: {
                shape: "Ssz"
              },
              MaxPayloadInMB: {
                type: "integer"
              },
              BatchStrategy: {},
              Environment: {
                shape: "S3x"
              },
              TransformInput: {
                shape: "S40"
              },
              TransformOutput: {
                shape: "S44"
              },
              DataCaptureConfig: {
                shape: "St2"
              },
              TransformResources: {
                shape: "S47"
              },
              CreationTime: {
                type: "timestamp"
              },
              TransformStartTime: {
                type: "timestamp"
              },
              TransformEndTime: {
                type: "timestamp"
              },
              LabelingJobArn: {},
              AutoMLJobArn: {},
              DataProcessing: {
                shape: "St3"
              },
              ExperimentConfig: {
                shape: "Sqx"
              }
            }
          }
        },
        DescribeTrial: {
          input: {
            type: "structure",
            required: [
              "TrialName"
            ],
            members: {
              TrialName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrialName: {},
              TrialArn: {},
              DisplayName: {},
              ExperimentName: {},
              Source: {
                shape: "S16j"
              },
              CreationTime: {
                type: "timestamp"
              },
              CreatedBy: {
                shape: "Swt"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastModifiedBy: {
                shape: "Swt"
              },
              MetadataProperties: {
                shape: "S1u"
              }
            }
          }
        },
        DescribeTrialComponent: {
          input: {
            type: "structure",
            required: [
              "TrialComponentName"
            ],
            members: {
              TrialComponentName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrialComponentName: {},
              TrialComponentArn: {},
              DisplayName: {},
              Source: {
                shape: "S16n"
              },
              Status: {
                shape: "Stb"
              },
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              CreationTime: {
                type: "timestamp"
              },
              CreatedBy: {
                shape: "Swt"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastModifiedBy: {
                shape: "Swt"
              },
              Parameters: {
                shape: "Ste"
              },
              InputArtifacts: {
                shape: "Sti"
              },
              OutputArtifacts: {
                shape: "Sti"
              },
              MetadataProperties: {
                shape: "S1u"
              },
              Metrics: {
                shape: "S16p"
              },
              LineageGroupArn: {},
              Sources: {
                type: "list",
                member: {
                  shape: "S16n"
                }
              }
            }
          }
        },
        DescribeUserProfile: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "UserProfileName"
            ],
            members: {
              DomainId: {},
              UserProfileName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DomainId: {},
              UserProfileArn: {},
              UserProfileName: {},
              HomeEfsFileSystemUid: {},
              Status: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              CreationTime: {
                type: "timestamp"
              },
              FailureReason: {},
              SingleSignOnUserIdentifier: {},
              SingleSignOnUserValue: {},
              UserSettings: {
                shape: "Sac"
              }
            }
          }
        },
        DescribeWorkforce: {
          input: {
            type: "structure",
            required: [
              "WorkforceName"
            ],
            members: {
              WorkforceName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Workforce"
            ],
            members: {
              Workforce: {
                shape: "S16z"
              }
            }
          }
        },
        DescribeWorkteam: {
          input: {
            type: "structure",
            required: [
              "WorkteamName"
            ],
            members: {
              WorkteamName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Workteam"
            ],
            members: {
              Workteam: {
                shape: "S177"
              }
            }
          }
        },
        DisableSagemakerServicecatalogPortfolio: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateTrialComponent: {
          input: {
            type: "structure",
            required: [
              "TrialComponentName",
              "TrialName"
            ],
            members: {
              TrialComponentName: {},
              TrialName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrialComponentArn: {},
              TrialArn: {}
            }
          }
        },
        EnableSagemakerServicecatalogPortfolio: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetDeviceFleetReport: {
          input: {
            type: "structure",
            required: [
              "DeviceFleetName"
            ],
            members: {
              DeviceFleetName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "DeviceFleetArn",
              "DeviceFleetName"
            ],
            members: {
              DeviceFleetArn: {},
              DeviceFleetName: {},
              OutputConfig: {
                shape: "Sa6"
              },
              Description: {},
              ReportGenerated: {
                type: "timestamp"
              },
              DeviceStats: {
                type: "structure",
                required: [
                  "ConnectedDeviceCount",
                  "RegisteredDeviceCount"
                ],
                members: {
                  ConnectedDeviceCount: {
                    type: "long"
                  },
                  RegisteredDeviceCount: {
                    type: "long"
                  }
                }
              },
              AgentVersions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Version",
                    "AgentCount"
                  ],
                  members: {
                    Version: {},
                    AgentCount: {
                      type: "long"
                    }
                  }
                }
              },
              ModelStats: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ModelName",
                    "ModelVersion",
                    "OfflineDeviceCount",
                    "ConnectedDeviceCount",
                    "ActiveDeviceCount",
                    "SamplingDeviceCount"
                  ],
                  members: {
                    ModelName: {},
                    ModelVersion: {},
                    OfflineDeviceCount: {
                      type: "long"
                    },
                    ConnectedDeviceCount: {
                      type: "long"
                    },
                    ActiveDeviceCount: {
                      type: "long"
                    },
                    SamplingDeviceCount: {
                      type: "long"
                    }
                  }
                }
              }
            }
          }
        },
        GetLineageGroupPolicy: {
          input: {
            type: "structure",
            required: [
              "LineageGroupName"
            ],
            members: {
              LineageGroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LineageGroupArn: {},
              ResourcePolicy: {}
            }
          }
        },
        GetModelPackageGroupPolicy: {
          input: {
            type: "structure",
            required: [
              "ModelPackageGroupName"
            ],
            members: {
              ModelPackageGroupName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ResourcePolicy"
            ],
            members: {
              ResourcePolicy: {}
            }
          }
        },
        GetSagemakerServicecatalogPortfolioStatus: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              Status: {}
            }
          }
        },
        GetScalingConfigurationRecommendation: {
          input: {
            type: "structure",
            required: [
              "InferenceRecommendationsJobName"
            ],
            members: {
              InferenceRecommendationsJobName: {},
              RecommendationId: {},
              EndpointName: {},
              TargetCpuUtilizationPerCore: {
                type: "integer"
              },
              ScalingPolicyObjective: {
                shape: "S17z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InferenceRecommendationsJobName: {},
              RecommendationId: {},
              EndpointName: {},
              TargetCpuUtilizationPerCore: {
                type: "integer"
              },
              ScalingPolicyObjective: {
                shape: "S17z"
              },
              Metric: {
                type: "structure",
                members: {
                  InvocationsPerInstance: {
                    type: "integer"
                  },
                  ModelLatency: {
                    type: "integer"
                  }
                }
              },
              DynamicScalingConfiguration: {
                type: "structure",
                members: {
                  MinCapacity: {
                    type: "integer"
                  },
                  MaxCapacity: {
                    type: "integer"
                  },
                  ScaleInCooldown: {
                    type: "integer"
                  },
                  ScaleOutCooldown: {
                    type: "integer"
                  },
                  ScalingPolicies: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        TargetTracking: {
                          type: "structure",
                          members: {
                            MetricSpecification: {
                              type: "structure",
                              members: {
                                Predefined: {
                                  type: "structure",
                                  members: {
                                    PredefinedMetricType: {}
                                  }
                                },
                                Customized: {
                                  type: "structure",
                                  members: {
                                    MetricName: {},
                                    Namespace: {},
                                    Statistic: {}
                                  }
                                }
                              },
                              union: true
                            },
                            TargetValue: {
                              type: "double"
                            }
                          }
                        }
                      },
                      union: true
                    }
                  }
                }
              }
            }
          }
        },
        GetSearchSuggestions: {
          input: {
            type: "structure",
            required: [
              "Resource"
            ],
            members: {
              Resource: {},
              SuggestionQuery: {
                type: "structure",
                members: {
                  PropertyNameQuery: {
                    type: "structure",
                    required: [
                      "PropertyNameHint"
                    ],
                    members: {
                      PropertyNameHint: {}
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PropertyNameSuggestions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PropertyName: {}
                  }
                }
              }
            }
          }
        },
        ImportHubContent: {
          input: {
            type: "structure",
            required: [
              "HubContentName",
              "HubContentType",
              "DocumentSchemaVersion",
              "HubName",
              "HubContentDocument"
            ],
            members: {
              HubContentName: {},
              HubContentVersion: {},
              HubContentType: {},
              DocumentSchemaVersion: {},
              HubName: {},
              HubContentDisplayName: {},
              HubContentDescription: {},
              HubContentMarkdown: {},
              HubContentDocument: {},
              HubContentSearchKeywords: {
                shape: "S11q"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HubArn",
              "HubContentArn"
            ],
            members: {
              HubArn: {},
              HubContentArn: {}
            }
          }
        },
        ListActions: {
          input: {
            type: "structure",
            members: {
              SourceUri: {},
              ActionType: {},
              CreatedAfter: {
                type: "timestamp"
              },
              CreatedBefore: {
                type: "timestamp"
              },
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ActionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ActionArn: {},
                    ActionName: {},
                    Source: {
                      shape: "S1n"
                    },
                    ActionType: {},
                    Status: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListAlgorithms: {
          input: {
            type: "structure",
            members: {
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              MaxResults: {
                type: "integer"
              },
              NameContains: {},
              NextToken: {},
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "AlgorithmSummaryList"
            ],
            members: {
              AlgorithmSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AlgorithmName",
                    "AlgorithmArn",
                    "CreationTime",
                    "AlgorithmStatus"
                  ],
                  members: {
                    AlgorithmName: {},
                    AlgorithmArn: {},
                    AlgorithmDescription: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    AlgorithmStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListAliases: {
          input: {
            type: "structure",
            required: [
              "ImageName"
            ],
            members: {
              ImageName: {},
              Alias: {},
              Version: {
                type: "integer"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SageMakerImageVersionAliases: {
                shape: "Sin"
              },
              NextToken: {}
            }
          }
        },
        ListAppImageConfigs: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              NameContains: {},
              CreationTimeBefore: {
                type: "timestamp"
              },
              CreationTimeAfter: {
                type: "timestamp"
              },
              ModifiedTimeBefore: {
                type: "timestamp"
              },
              ModifiedTimeAfter: {
                type: "timestamp"
              },
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              AppImageConfigs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AppImageConfigArn: {},
                    AppImageConfigName: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    KernelGatewayImageConfig: {
                      shape: "S4s"
                    },
                    JupyterLabAppImageConfig: {
                      shape: "S51"
                    }
                  }
                }
              }
            }
          }
        },
        ListApps: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              SortOrder: {},
              SortBy: {},
              DomainIdEquals: {},
              UserProfileNameEquals: {},
              SpaceNameEquals: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Apps: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DomainId: {},
                    UserProfileName: {},
                    SpaceName: {},
                    AppType: {},
                    AppName: {},
                    Status: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    ResourceSpec: {
                      shape: "S4i"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListArtifacts: {
          input: {
            type: "structure",
            members: {
              SourceUri: {},
              ArtifactType: {},
              CreatedAfter: {
                type: "timestamp"
              },
              CreatedBefore: {
                type: "timestamp"
              },
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ArtifactSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ArtifactArn: {},
                    ArtifactName: {},
                    Source: {
                      shape: "S5b"
                    },
                    ArtifactType: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListAssociations: {
          input: {
            type: "structure",
            members: {
              SourceArn: {},
              DestinationArn: {},
              SourceType: {},
              DestinationType: {},
              AssociationType: {},
              CreatedAfter: {
                type: "timestamp"
              },
              CreatedBefore: {
                type: "timestamp"
              },
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssociationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SourceArn: {},
                    DestinationArn: {},
                    SourceType: {},
                    DestinationType: {},
                    AssociationType: {},
                    SourceName: {},
                    DestinationName: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    CreatedBy: {
                      shape: "Swt"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListAutoMLJobs: {
          input: {
            type: "structure",
            members: {
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              NameContains: {},
              StatusEquals: {},
              SortOrder: {},
              SortBy: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "AutoMLJobSummaries"
            ],
            members: {
              AutoMLJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AutoMLJobName",
                    "AutoMLJobArn",
                    "AutoMLJobStatus",
                    "AutoMLJobSecondaryStatus",
                    "CreationTime",
                    "LastModifiedTime"
                  ],
                  members: {
                    AutoMLJobName: {},
                    AutoMLJobArn: {},
                    AutoMLJobStatus: {},
                    AutoMLJobSecondaryStatus: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    FailureReason: {},
                    PartialFailureReasons: {
                      shape: "Sxe"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListCandidatesForAutoMLJob: {
          input: {
            type: "structure",
            required: [
              "AutoMLJobName"
            ],
            members: {
              AutoMLJobName: {},
              StatusEquals: {},
              CandidateNameEquals: {},
              SortOrder: {},
              SortBy: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Candidates"
            ],
            members: {
              Candidates: {
                type: "list",
                member: {
                  shape: "Sxg"
                }
              },
              NextToken: {}
            }
          }
        },
        ListClusterNodes: {
          input: {
            type: "structure",
            required: [
              "ClusterName"
            ],
            members: {
              ClusterName: {},
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              InstanceGroupNameContains: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "NextToken",
              "ClusterNodeSummaries"
            ],
            members: {
              NextToken: {},
              ClusterNodeSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "InstanceGroupName",
                    "InstanceId",
                    "InstanceType",
                    "LaunchTime",
                    "InstanceStatus"
                  ],
                  members: {
                    InstanceGroupName: {},
                    InstanceId: {},
                    InstanceType: {},
                    LaunchTime: {
                      type: "timestamp"
                    },
                    InstanceStatus: {
                      shape: "Syu"
                    }
                  }
                }
              }
            }
          }
        },
        ListClusters: {
          input: {
            type: "structure",
            members: {
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              MaxResults: {
                type: "integer"
              },
              NameContains: {},
              NextToken: {},
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "NextToken",
              "ClusterSummaries"
            ],
            members: {
              NextToken: {},
              ClusterSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ClusterArn",
                    "ClusterName",
                    "CreationTime",
                    "ClusterStatus"
                  ],
                  members: {
                    ClusterArn: {},
                    ClusterName: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    ClusterStatus: {}
                  }
                }
              }
            }
          }
        },
        ListCodeRepositories: {
          input: {
            type: "structure",
            members: {
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              MaxResults: {
                type: "integer"
              },
              NameContains: {},
              NextToken: {},
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "CodeRepositorySummaryList"
            ],
            members: {
              CodeRepositorySummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "CodeRepositoryName",
                    "CodeRepositoryArn",
                    "CreationTime",
                    "LastModifiedTime"
                  ],
                  members: {
                    CodeRepositoryName: {},
                    CodeRepositoryArn: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    GitConfig: {
                      shape: "S82"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListCompilationJobs: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              NameContains: {},
              StatusEquals: {},
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "CompilationJobSummaries"
            ],
            members: {
              CompilationJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "CompilationJobName",
                    "CompilationJobArn",
                    "CreationTime",
                    "CompilationJobStatus"
                  ],
                  members: {
                    CompilationJobName: {},
                    CompilationJobArn: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    CompilationStartTime: {
                      type: "timestamp"
                    },
                    CompilationEndTime: {
                      type: "timestamp"
                    },
                    CompilationTargetDevice: {},
                    CompilationTargetPlatformOs: {},
                    CompilationTargetPlatformArch: {},
                    CompilationTargetPlatformAccelerator: {},
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    CompilationJobStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListContexts: {
          input: {
            type: "structure",
            members: {
              SourceUri: {},
              ContextType: {},
              CreatedAfter: {
                type: "timestamp"
              },
              CreatedBefore: {
                type: "timestamp"
              },
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContextSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ContextArn: {},
                    ContextName: {},
                    Source: {
                      shape: "S8s"
                    },
                    ContextType: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDataQualityJobDefinitions: {
          input: {
            type: "structure",
            members: {
              EndpointName: {},
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              NameContains: {},
              CreationTimeBefore: {
                type: "timestamp"
              },
              CreationTimeAfter: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "JobDefinitionSummaries"
            ],
            members: {
              JobDefinitionSummaries: {
                shape: "S1ar"
              },
              NextToken: {}
            }
          }
        },
        ListDeviceFleets: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              NameContains: {},
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "DeviceFleetSummaries"
            ],
            members: {
              DeviceFleetSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "DeviceFleetArn",
                    "DeviceFleetName"
                  ],
                  members: {
                    DeviceFleetArn: {},
                    DeviceFleetName: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDevices: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              LatestHeartbeatAfter: {
                type: "timestamp"
              },
              ModelName: {},
              DeviceFleetName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "DeviceSummaries"
            ],
            members: {
              DeviceSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "DeviceName",
                    "DeviceArn"
                  ],
                  members: {
                    DeviceName: {},
                    DeviceArn: {},
                    Description: {},
                    DeviceFleetName: {},
                    IotThingName: {},
                    RegistrationTime: {
                      type: "timestamp"
                    },
                    LatestHeartbeat: {
                      type: "timestamp"
                    },
                    Models: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "ModelName",
                          "ModelVersion"
                        ],
                        members: {
                          ModelName: {},
                          ModelVersion: {}
                        }
                      }
                    },
                    AgentVersion: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDomains: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Domains: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DomainArn: {},
                    DomainId: {},
                    DomainName: {},
                    Status: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    Url: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEdgeDeploymentPlans: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              NameContains: {},
              DeviceFleetNameContains: {},
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "EdgeDeploymentPlanSummaries"
            ],
            members: {
              EdgeDeploymentPlanSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "EdgeDeploymentPlanArn",
                    "EdgeDeploymentPlanName",
                    "DeviceFleetName",
                    "EdgeDeploymentSuccess",
                    "EdgeDeploymentPending",
                    "EdgeDeploymentFailed"
                  ],
                  members: {
                    EdgeDeploymentPlanArn: {},
                    EdgeDeploymentPlanName: {},
                    DeviceFleetName: {},
                    EdgeDeploymentSuccess: {
                      type: "integer"
                    },
                    EdgeDeploymentPending: {
                      type: "integer"
                    },
                    EdgeDeploymentFailed: {
                      type: "integer"
                    },
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEdgePackagingJobs: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              NameContains: {},
              ModelNameContains: {},
              StatusEquals: {},
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "EdgePackagingJobSummaries"
            ],
            members: {
              EdgePackagingJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "EdgePackagingJobArn",
                    "EdgePackagingJobName",
                    "EdgePackagingJobStatus"
                  ],
                  members: {
                    EdgePackagingJobArn: {},
                    EdgePackagingJobName: {},
                    EdgePackagingJobStatus: {},
                    CompilationJobName: {},
                    ModelName: {},
                    ModelVersion: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEndpointConfigs: {
          input: {
            type: "structure",
            members: {
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              NameContains: {},
              CreationTimeBefore: {
                type: "timestamp"
              },
              CreationTimeAfter: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EndpointConfigs"
            ],
            members: {
              EndpointConfigs: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "EndpointConfigName",
                    "EndpointConfigArn",
                    "CreationTime"
                  ],
                  members: {
                    EndpointConfigName: {},
                    EndpointConfigArn: {},
                    CreationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEndpoints: {
          input: {
            type: "structure",
            members: {
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              NameContains: {},
              CreationTimeBefore: {
                type: "timestamp"
              },
              CreationTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              StatusEquals: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Endpoints"
            ],
            members: {
              Endpoints: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "EndpointName",
                    "EndpointArn",
                    "CreationTime",
                    "LastModifiedTime",
                    "EndpointStatus"
                  ],
                  members: {
                    EndpointName: {},
                    EndpointArn: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    EndpointStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListExperiments: {
          input: {
            type: "structure",
            members: {
              CreatedAfter: {
                type: "timestamp"
              },
              CreatedBefore: {
                type: "timestamp"
              },
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ExperimentSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ExperimentArn: {},
                    ExperimentName: {},
                    DisplayName: {},
                    ExperimentSource: {
                      shape: "S10r"
                    },
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListFeatureGroups: {
          input: {
            type: "structure",
            members: {
              NameContains: {},
              FeatureGroupStatusEquals: {},
              OfflineStoreStatusEquals: {},
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              SortOrder: {},
              SortBy: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "FeatureGroupSummaries"
            ],
            members: {
              FeatureGroupSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "FeatureGroupName",
                    "FeatureGroupArn",
                    "CreationTime"
                  ],
                  members: {
                    FeatureGroupName: {},
                    FeatureGroupArn: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    FeatureGroupStatus: {},
                    OfflineStoreStatus: {
                      shape: "S10z"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListFlowDefinitions: {
          input: {
            type: "structure",
            members: {
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "FlowDefinitionSummaries"
            ],
            members: {
              FlowDefinitionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "FlowDefinitionName",
                    "FlowDefinitionArn",
                    "FlowDefinitionStatus",
                    "CreationTime"
                  ],
                  members: {
                    FlowDefinitionName: {},
                    FlowDefinitionArn: {},
                    FlowDefinitionStatus: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    FailureReason: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListHubContentVersions: {
          input: {
            type: "structure",
            required: [
              "HubName",
              "HubContentType",
              "HubContentName"
            ],
            members: {
              HubName: {},
              HubContentType: {},
              HubContentName: {},
              MinVersion: {},
              MaxSchemaVersion: {},
              CreationTimeBefore: {
                type: "timestamp"
              },
              CreationTimeAfter: {
                type: "timestamp"
              },
              SortBy: {},
              SortOrder: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "HubContentSummaries"
            ],
            members: {
              HubContentSummaries: {
                shape: "S1ch"
              },
              NextToken: {}
            }
          }
        },
        ListHubContents: {
          input: {
            type: "structure",
            required: [
              "HubName",
              "HubContentType"
            ],
            members: {
              HubName: {},
              HubContentType: {},
              NameContains: {},
              MaxSchemaVersion: {},
              CreationTimeBefore: {
                type: "timestamp"
              },
              CreationTimeAfter: {
                type: "timestamp"
              },
              SortBy: {},
              SortOrder: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "HubContentSummaries"
            ],
            members: {
              HubContentSummaries: {
                shape: "S1ch"
              },
              NextToken: {}
            }
          }
        },
        ListHubs: {
          input: {
            type: "structure",
            members: {
              NameContains: {},
              CreationTimeBefore: {
                type: "timestamp"
              },
              CreationTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              SortBy: {},
              SortOrder: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "HubSummaries"
            ],
            members: {
              HubSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "HubName",
                    "HubArn",
                    "HubStatus",
                    "CreationTime",
                    "LastModifiedTime"
                  ],
                  members: {
                    HubName: {},
                    HubArn: {},
                    HubDisplayName: {},
                    HubDescription: {},
                    HubSearchKeywords: {
                      shape: "Sgl"
                    },
                    HubStatus: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListHumanTaskUis: {
          input: {
            type: "structure",
            members: {
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HumanTaskUiSummaries"
            ],
            members: {
              HumanTaskUiSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "HumanTaskUiName",
                    "HumanTaskUiArn",
                    "CreationTime"
                  ],
                  members: {
                    HumanTaskUiName: {},
                    HumanTaskUiArn: {},
                    CreationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListHyperParameterTuningJobs: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              SortBy: {},
              SortOrder: {},
              NameContains: {},
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              StatusEquals: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "HyperParameterTuningJobSummaries"
            ],
            members: {
              HyperParameterTuningJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "HyperParameterTuningJobName",
                    "HyperParameterTuningJobArn",
                    "HyperParameterTuningJobStatus",
                    "Strategy",
                    "CreationTime",
                    "TrainingJobStatusCounters",
                    "ObjectiveStatusCounters"
                  ],
                  members: {
                    HyperParameterTuningJobName: {},
                    HyperParameterTuningJobArn: {},
                    HyperParameterTuningJobStatus: {},
                    Strategy: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    HyperParameterTuningEndTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    TrainingJobStatusCounters: {
                      shape: "S125"
                    },
                    ObjectiveStatusCounters: {
                      shape: "S127"
                    },
                    ResourceLimits: {
                      shape: "Sh4"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListImageVersions: {
          input: {
            type: "structure",
            required: [
              "ImageName"
            ],
            members: {
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              ImageName: {},
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ImageVersions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "CreationTime",
                    "ImageArn",
                    "ImageVersionArn",
                    "ImageVersionStatus",
                    "LastModifiedTime",
                    "Version"
                  ],
                  members: {
                    CreationTime: {
                      type: "timestamp"
                    },
                    FailureReason: {},
                    ImageArn: {},
                    ImageVersionArn: {},
                    ImageVersionStatus: {},
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    Version: {
                      type: "integer"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListImages: {
          input: {
            type: "structure",
            members: {
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              MaxResults: {
                type: "integer"
              },
              NameContains: {},
              NextToken: {},
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Images: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "CreationTime",
                    "ImageArn",
                    "ImageName",
                    "ImageStatus",
                    "LastModifiedTime"
                  ],
                  members: {
                    CreationTime: {
                      type: "timestamp"
                    },
                    Description: {},
                    DisplayName: {},
                    FailureReason: {},
                    ImageArn: {},
                    ImageName: {},
                    ImageStatus: {},
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListInferenceComponents: {
          input: {
            type: "structure",
            members: {
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              NameContains: {},
              CreationTimeBefore: {
                type: "timestamp"
              },
              CreationTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              StatusEquals: {},
              EndpointNameEquals: {},
              VariantNameEquals: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "InferenceComponents"
            ],
            members: {
              InferenceComponents: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "CreationTime",
                    "InferenceComponentArn",
                    "InferenceComponentName",
                    "EndpointArn",
                    "EndpointName",
                    "VariantName",
                    "LastModifiedTime"
                  ],
                  members: {
                    CreationTime: {
                      type: "timestamp"
                    },
                    InferenceComponentArn: {},
                    InferenceComponentName: {},
                    EndpointArn: {},
                    EndpointName: {},
                    VariantName: {},
                    InferenceComponentStatus: {},
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListInferenceExperiments: {
          input: {
            type: "structure",
            members: {
              NameContains: {},
              Type: {},
              StatusEquals: {},
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InferenceExperiments: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Type",
                    "Status",
                    "CreationTime",
                    "LastModifiedTime"
                  ],
                  members: {
                    Name: {},
                    Type: {},
                    Schedule: {
                      shape: "Sjd"
                    },
                    Status: {},
                    StatusReason: {},
                    Description: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    CompletionTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    RoleArn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListInferenceRecommendationsJobSteps: {
          input: {
            type: "structure",
            required: [
              "JobName"
            ],
            members: {
              JobName: {},
              Status: {},
              StepType: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Steps: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "StepType",
                    "JobName",
                    "Status"
                  ],
                  members: {
                    StepType: {},
                    JobName: {},
                    Status: {},
                    InferenceBenchmark: {
                      type: "structure",
                      required: [
                        "ModelConfiguration"
                      ],
                      members: {
                        Metrics: {
                          shape: "S134"
                        },
                        EndpointMetrics: {
                          shape: "S13h"
                        },
                        EndpointConfiguration: {
                          shape: "S137"
                        },
                        ModelConfiguration: {
                          shape: "S139"
                        },
                        FailureReason: {},
                        InvocationEndTime: {
                          type: "timestamp"
                        },
                        InvocationStartTime: {
                          type: "timestamp"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListInferenceRecommendationsJobs: {
          input: {
            type: "structure",
            members: {
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              NameContains: {},
              StatusEquals: {},
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ModelNameEquals: {},
              ModelPackageVersionArnEquals: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "InferenceRecommendationsJobs"
            ],
            members: {
              InferenceRecommendationsJobs: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "JobName",
                    "JobDescription",
                    "JobType",
                    "JobArn",
                    "Status",
                    "CreationTime",
                    "RoleArn",
                    "LastModifiedTime"
                  ],
                  members: {
                    JobName: {},
                    JobDescription: {},
                    JobType: {},
                    JobArn: {},
                    Status: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    CompletionTime: {
                      type: "timestamp"
                    },
                    RoleArn: {},
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    FailureReason: {},
                    ModelName: {},
                    SamplePayloadUrl: {},
                    ModelPackageVersionArn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListLabelingJobs: {
          input: {
            type: "structure",
            members: {
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              NameContains: {},
              SortBy: {},
              SortOrder: {},
              StatusEquals: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LabelingJobSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "LabelingJobName",
                    "LabelingJobArn",
                    "CreationTime",
                    "LastModifiedTime",
                    "LabelingJobStatus",
                    "LabelCounters",
                    "WorkteamArn",
                    "PreHumanTaskLambdaArn"
                  ],
                  members: {
                    LabelingJobName: {},
                    LabelingJobArn: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    LabelingJobStatus: {},
                    LabelCounters: {
                      shape: "S13l"
                    },
                    WorkteamArn: {},
                    PreHumanTaskLambdaArn: {},
                    AnnotationConsolidationLambdaArn: {},
                    FailureReason: {},
                    LabelingJobOutput: {
                      shape: "S13o"
                    },
                    InputConfig: {
                      shape: "Slf"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListLabelingJobsForWorkteam: {
          input: {
            type: "structure",
            required: [
              "WorkteamArn"
            ],
            members: {
              WorkteamArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              JobReferenceCodeContains: {},
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "LabelingJobSummaryList"
            ],
            members: {
              LabelingJobSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "JobReferenceCode",
                    "WorkRequesterAccountId",
                    "CreationTime"
                  ],
                  members: {
                    LabelingJobName: {},
                    JobReferenceCode: {},
                    WorkRequesterAccountId: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LabelCounters: {
                      type: "structure",
                      members: {
                        HumanLabeled: {
                          type: "integer"
                        },
                        PendingHuman: {
                          type: "integer"
                        },
                        Total: {
                          type: "integer"
                        }
                      }
                    },
                    NumberOfHumanWorkersPerDataObject: {
                      type: "integer"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListLineageGroups: {
          input: {
            type: "structure",
            members: {
              CreatedAfter: {
                type: "timestamp"
              },
              CreatedBefore: {
                type: "timestamp"
              },
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LineageGroupSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LineageGroupArn: {},
                    LineageGroupName: {},
                    DisplayName: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListModelBiasJobDefinitions: {
          input: {
            type: "structure",
            members: {
              EndpointName: {},
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              NameContains: {},
              CreationTimeBefore: {
                type: "timestamp"
              },
              CreationTimeAfter: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "JobDefinitionSummaries"
            ],
            members: {
              JobDefinitionSummaries: {
                shape: "S1ar"
              },
              NextToken: {}
            }
          }
        },
        ListModelCardExportJobs: {
          input: {
            type: "structure",
            required: [
              "ModelCardName"
            ],
            members: {
              ModelCardName: {},
              ModelCardVersion: {
                type: "integer"
              },
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              ModelCardExportJobNameContains: {},
              StatusEquals: {},
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ModelCardExportJobSummaries"
            ],
            members: {
              ModelCardExportJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ModelCardExportJobName",
                    "ModelCardExportJobArn",
                    "Status",
                    "ModelCardName",
                    "ModelCardVersion",
                    "CreatedAt",
                    "LastModifiedAt"
                  ],
                  members: {
                    ModelCardExportJobName: {},
                    ModelCardExportJobArn: {},
                    Status: {},
                    ModelCardName: {},
                    ModelCardVersion: {
                      type: "integer"
                    },
                    CreatedAt: {
                      type: "timestamp"
                    },
                    LastModifiedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListModelCardVersions: {
          input: {
            type: "structure",
            required: [
              "ModelCardName"
            ],
            members: {
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              MaxResults: {
                type: "integer"
              },
              ModelCardName: {},
              ModelCardStatus: {},
              NextToken: {},
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ModelCardVersionSummaryList"
            ],
            members: {
              ModelCardVersionSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ModelCardName",
                    "ModelCardArn",
                    "ModelCardStatus",
                    "ModelCardVersion",
                    "CreationTime"
                  ],
                  members: {
                    ModelCardName: {},
                    ModelCardArn: {},
                    ModelCardStatus: {},
                    ModelCardVersion: {
                      type: "integer"
                    },
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListModelCards: {
          input: {
            type: "structure",
            members: {
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              MaxResults: {
                type: "integer"
              },
              NameContains: {},
              ModelCardStatus: {},
              NextToken: {},
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ModelCardSummaries"
            ],
            members: {
              ModelCardSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ModelCardName",
                    "ModelCardArn",
                    "ModelCardStatus",
                    "CreationTime"
                  ],
                  members: {
                    ModelCardName: {},
                    ModelCardArn: {},
                    ModelCardStatus: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListModelExplainabilityJobDefinitions: {
          input: {
            type: "structure",
            members: {
              EndpointName: {},
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              NameContains: {},
              CreationTimeBefore: {
                type: "timestamp"
              },
              CreationTimeAfter: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "JobDefinitionSummaries"
            ],
            members: {
              JobDefinitionSummaries: {
                shape: "S1ar"
              },
              NextToken: {}
            }
          }
        },
        ListModelMetadata: {
          input: {
            type: "structure",
            members: {
              SearchExpression: {
                type: "structure",
                members: {
                  Filters: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Name",
                        "Value"
                      ],
                      members: {
                        Name: {},
                        Value: {}
                      }
                    }
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ModelMetadataSummaries"
            ],
            members: {
              ModelMetadataSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Domain",
                    "Framework",
                    "Task",
                    "Model",
                    "FrameworkVersion"
                  ],
                  members: {
                    Domain: {},
                    Framework: {},
                    Task: {},
                    Model: {},
                    FrameworkVersion: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListModelPackageGroups: {
          input: {
            type: "structure",
            members: {
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              MaxResults: {
                type: "integer"
              },
              NameContains: {},
              NextToken: {},
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ModelPackageGroupSummaryList"
            ],
            members: {
              ModelPackageGroupSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ModelPackageGroupName",
                    "ModelPackageGroupArn",
                    "CreationTime",
                    "ModelPackageGroupStatus"
                  ],
                  members: {
                    ModelPackageGroupName: {},
                    ModelPackageGroupArn: {},
                    ModelPackageGroupDescription: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    ModelPackageGroupStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListModelPackages: {
          input: {
            type: "structure",
            members: {
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              MaxResults: {
                type: "integer"
              },
              NameContains: {},
              ModelApprovalStatus: {},
              ModelPackageGroupName: {},
              ModelPackageType: {},
              NextToken: {},
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ModelPackageSummaryList"
            ],
            members: {
              ModelPackageSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ModelPackageArn",
                    "CreationTime",
                    "ModelPackageStatus"
                  ],
                  members: {
                    ModelPackageName: {},
                    ModelPackageGroupName: {},
                    ModelPackageVersion: {
                      type: "integer"
                    },
                    ModelPackageArn: {},
                    ModelPackageDescription: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    ModelPackageStatus: {},
                    ModelApprovalStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListModelQualityJobDefinitions: {
          input: {
            type: "structure",
            members: {
              EndpointName: {},
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              NameContains: {},
              CreationTimeBefore: {
                type: "timestamp"
              },
              CreationTimeAfter: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "JobDefinitionSummaries"
            ],
            members: {
              JobDefinitionSummaries: {
                shape: "S1ar"
              },
              NextToken: {}
            }
          }
        },
        ListModels: {
          input: {
            type: "structure",
            members: {
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              NameContains: {},
              CreationTimeBefore: {
                type: "timestamp"
              },
              CreationTimeAfter: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Models"
            ],
            members: {
              Models: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ModelName",
                    "ModelArn",
                    "CreationTime"
                  ],
                  members: {
                    ModelName: {},
                    ModelArn: {},
                    CreationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListMonitoringAlertHistory: {
          input: {
            type: "structure",
            members: {
              MonitoringScheduleName: {},
              MonitoringAlertName: {},
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              CreationTimeAfter: {
                type: "timestamp"
              },
              StatusEquals: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MonitoringAlertHistory: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "MonitoringScheduleName",
                    "MonitoringAlertName",
                    "CreationTime",
                    "AlertStatus"
                  ],
                  members: {
                    MonitoringScheduleName: {},
                    MonitoringAlertName: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    AlertStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListMonitoringAlerts: {
          input: {
            type: "structure",
            required: [
              "MonitoringScheduleName"
            ],
            members: {
              MonitoringScheduleName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MonitoringAlertSummaries: {
                shape: "S1g1"
              },
              NextToken: {}
            }
          }
        },
        ListMonitoringExecutions: {
          input: {
            type: "structure",
            members: {
              MonitoringScheduleName: {},
              EndpointName: {},
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ScheduledTimeBefore: {
                type: "timestamp"
              },
              ScheduledTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              CreationTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              StatusEquals: {},
              MonitoringJobDefinitionName: {},
              MonitoringTypeEquals: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "MonitoringExecutionSummaries"
            ],
            members: {
              MonitoringExecutionSummaries: {
                type: "list",
                member: {
                  shape: "S14n"
                }
              },
              NextToken: {}
            }
          }
        },
        ListMonitoringSchedules: {
          input: {
            type: "structure",
            members: {
              EndpointName: {},
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              NameContains: {},
              CreationTimeBefore: {
                type: "timestamp"
              },
              CreationTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              StatusEquals: {},
              MonitoringJobDefinitionName: {},
              MonitoringTypeEquals: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "MonitoringScheduleSummaries"
            ],
            members: {
              MonitoringScheduleSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "MonitoringScheduleName",
                    "MonitoringScheduleArn",
                    "CreationTime",
                    "LastModifiedTime",
                    "MonitoringScheduleStatus"
                  ],
                  members: {
                    MonitoringScheduleName: {},
                    MonitoringScheduleArn: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    MonitoringScheduleStatus: {},
                    EndpointName: {},
                    MonitoringJobDefinitionName: {},
                    MonitoringType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListNotebookInstanceLifecycleConfigs: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              SortBy: {},
              SortOrder: {},
              NameContains: {},
              CreationTimeBefore: {
                type: "timestamp"
              },
              CreationTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              NotebookInstanceLifecycleConfigs: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "NotebookInstanceLifecycleConfigName",
                    "NotebookInstanceLifecycleConfigArn"
                  ],
                  members: {
                    NotebookInstanceLifecycleConfigName: {},
                    NotebookInstanceLifecycleConfigArn: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListNotebookInstances: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              SortBy: {},
              SortOrder: {},
              NameContains: {},
              CreationTimeBefore: {
                type: "timestamp"
              },
              CreationTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              StatusEquals: {},
              NotebookInstanceLifecycleConfigNameContains: {},
              DefaultCodeRepositoryContains: {},
              AdditionalCodeRepositoryEquals: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              NotebookInstances: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "NotebookInstanceName",
                    "NotebookInstanceArn"
                  ],
                  members: {
                    NotebookInstanceName: {},
                    NotebookInstanceArn: {},
                    NotebookInstanceStatus: {},
                    Url: {},
                    InstanceType: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    NotebookInstanceLifecycleConfigName: {},
                    DefaultCodeRepository: {},
                    AdditionalCodeRepositories: {
                      shape: "Soz"
                    }
                  }
                }
              }
            }
          }
        },
        ListPipelineExecutionSteps: {
          input: {
            type: "structure",
            members: {
              PipelineExecutionArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineExecutionSteps: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StepName: {},
                    StepDisplayName: {},
                    StepDescription: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    StepStatus: {},
                    CacheHitResult: {
                      type: "structure",
                      members: {
                        SourcePipelineExecutionArn: {}
                      }
                    },
                    FailureReason: {},
                    Metadata: {
                      type: "structure",
                      members: {
                        TrainingJob: {
                          type: "structure",
                          members: {
                            Arn: {}
                          }
                        },
                        ProcessingJob: {
                          type: "structure",
                          members: {
                            Arn: {}
                          }
                        },
                        TransformJob: {
                          type: "structure",
                          members: {
                            Arn: {}
                          }
                        },
                        TuningJob: {
                          type: "structure",
                          members: {
                            Arn: {}
                          }
                        },
                        Model: {
                          type: "structure",
                          members: {
                            Arn: {}
                          }
                        },
                        RegisterModel: {
                          type: "structure",
                          members: {
                            Arn: {}
                          }
                        },
                        Condition: {
                          type: "structure",
                          members: {
                            Outcome: {}
                          }
                        },
                        Callback: {
                          type: "structure",
                          members: {
                            CallbackToken: {},
                            SqsQueueUrl: {},
                            OutputParameters: {
                              shape: "S1hf"
                            }
                          }
                        },
                        Lambda: {
                          type: "structure",
                          members: {
                            Arn: {},
                            OutputParameters: {
                              shape: "S1hf"
                            }
                          }
                        },
                        EMR: {
                          type: "structure",
                          members: {
                            ClusterId: {},
                            StepId: {},
                            StepName: {},
                            LogFilePath: {}
                          }
                        },
                        QualityCheck: {
                          type: "structure",
                          members: {
                            CheckType: {},
                            BaselineUsedForDriftCheckStatistics: {},
                            BaselineUsedForDriftCheckConstraints: {},
                            CalculatedBaselineStatistics: {},
                            CalculatedBaselineConstraints: {},
                            ModelPackageGroupName: {},
                            ViolationReport: {},
                            CheckJobArn: {},
                            SkipCheck: {
                              type: "boolean"
                            },
                            RegisterNewBaseline: {
                              type: "boolean"
                            }
                          }
                        },
                        ClarifyCheck: {
                          type: "structure",
                          members: {
                            CheckType: {},
                            BaselineUsedForDriftCheckConstraints: {},
                            CalculatedBaselineConstraints: {},
                            ModelPackageGroupName: {},
                            ViolationReport: {},
                            CheckJobArn: {},
                            SkipCheck: {
                              type: "boolean"
                            },
                            RegisterNewBaseline: {
                              type: "boolean"
                            }
                          }
                        },
                        Fail: {
                          type: "structure",
                          members: {
                            ErrorMessage: {}
                          }
                        },
                        AutoMLJob: {
                          type: "structure",
                          members: {
                            Arn: {}
                          }
                        }
                      }
                    },
                    AttemptCount: {
                      type: "integer"
                    },
                    SelectiveExecutionResult: {
                      type: "structure",
                      members: {
                        SourcePipelineExecutionArn: {}
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPipelineExecutions: {
          input: {
            type: "structure",
            required: [
              "PipelineName"
            ],
            members: {
              PipelineName: {},
              CreatedAfter: {
                type: "timestamp"
              },
              CreatedBefore: {
                type: "timestamp"
              },
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineExecutionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PipelineExecutionArn: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    PipelineExecutionStatus: {},
                    PipelineExecutionDescription: {},
                    PipelineExecutionDisplayName: {},
                    PipelineExecutionFailureReason: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPipelineParametersForExecution: {
          input: {
            type: "structure",
            required: [
              "PipelineExecutionArn"
            ],
            members: {
              PipelineExecutionArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineParameters: {
                shape: "S1hw"
              },
              NextToken: {}
            }
          }
        },
        ListPipelines: {
          input: {
            type: "structure",
            members: {
              PipelineNamePrefix: {},
              CreatedAfter: {
                type: "timestamp"
              },
              CreatedBefore: {
                type: "timestamp"
              },
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PipelineArn: {},
                    PipelineName: {},
                    PipelineDisplayName: {},
                    PipelineDescription: {},
                    RoleArn: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    LastExecutionTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListProcessingJobs: {
          input: {
            type: "structure",
            members: {
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              NameContains: {},
              StatusEquals: {},
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ProcessingJobSummaries"
            ],
            members: {
              ProcessingJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ProcessingJobName",
                    "ProcessingJobArn",
                    "CreationTime",
                    "ProcessingJobStatus"
                  ],
                  members: {
                    ProcessingJobName: {},
                    ProcessingJobArn: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    ProcessingEndTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    ProcessingJobStatus: {},
                    FailureReason: {},
                    ExitMessage: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListProjects: {
          input: {
            type: "structure",
            members: {
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              MaxResults: {
                type: "integer"
              },
              NameContains: {},
              NextToken: {},
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ProjectSummaryList"
            ],
            members: {
              ProjectSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ProjectName",
                    "ProjectArn",
                    "ProjectId",
                    "CreationTime",
                    "ProjectStatus"
                  ],
                  members: {
                    ProjectName: {},
                    ProjectDescription: {},
                    ProjectArn: {},
                    ProjectId: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    ProjectStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListResourceCatalogs: {
          input: {
            type: "structure",
            members: {
              NameContains: {},
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              SortOrder: {},
              SortBy: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceCatalogs: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ResourceCatalogArn",
                    "ResourceCatalogName",
                    "Description",
                    "CreationTime"
                  ],
                  members: {
                    ResourceCatalogArn: {},
                    ResourceCatalogName: {},
                    Description: {},
                    CreationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSpaces: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              SortOrder: {},
              SortBy: {},
              DomainIdEquals: {},
              SpaceNameContains: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Spaces: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DomainId: {},
                    SpaceName: {},
                    Status: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    SpaceSettingsSummary: {
                      type: "structure",
                      members: {
                        AppType: {},
                        SpaceStorageSettings: {
                          shape: "Srf"
                        }
                      }
                    },
                    SpaceSharingSettingsSummary: {
                      type: "structure",
                      members: {
                        SharingType: {}
                      }
                    },
                    OwnershipSettingsSummary: {
                      type: "structure",
                      members: {
                        OwnerUserProfileName: {}
                      }
                    },
                    SpaceDisplayName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListStageDevices: {
          input: {
            type: "structure",
            required: [
              "EdgeDeploymentPlanName",
              "StageName"
            ],
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              EdgeDeploymentPlanName: {},
              ExcludeDevicesDeployedInOtherStage: {
                type: "boolean"
              },
              StageName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "DeviceDeploymentSummaries"
            ],
            members: {
              DeviceDeploymentSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "EdgeDeploymentPlanArn",
                    "EdgeDeploymentPlanName",
                    "StageName",
                    "DeviceName",
                    "DeviceArn"
                  ],
                  members: {
                    EdgeDeploymentPlanArn: {},
                    EdgeDeploymentPlanName: {},
                    StageName: {},
                    DeployedStageName: {},
                    DeviceFleetName: {},
                    DeviceName: {},
                    DeviceArn: {},
                    DeviceDeploymentStatus: {},
                    DeviceDeploymentStatusMessage: {},
                    Description: {},
                    DeploymentStartTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListStudioLifecycleConfigs: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              NameContains: {},
              AppTypeEquals: {},
              CreationTimeBefore: {
                type: "timestamp"
              },
              CreationTimeAfter: {
                type: "timestamp"
              },
              ModifiedTimeBefore: {
                type: "timestamp"
              },
              ModifiedTimeAfter: {
                type: "timestamp"
              },
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              StudioLifecycleConfigs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StudioLifecycleConfigArn: {},
                    StudioLifecycleConfigName: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    StudioLifecycleConfigAppType: {}
                  }
                }
              }
            }
          }
        },
        ListSubscribedWorkteams: {
          input: {
            type: "structure",
            members: {
              NameContains: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "SubscribedWorkteams"
            ],
            members: {
              SubscribedWorkteams: {
                type: "list",
                member: {
                  shape: "S15t"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTags: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S7"
              },
              NextToken: {}
            }
          }
        },
        ListTrainingJobs: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              NameContains: {},
              StatusEquals: {},
              SortBy: {},
              SortOrder: {},
              WarmPoolStatusEquals: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "TrainingJobSummaries"
            ],
            members: {
              TrainingJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "TrainingJobName",
                    "TrainingJobArn",
                    "CreationTime",
                    "TrainingJobStatus"
                  ],
                  members: {
                    TrainingJobName: {},
                    TrainingJobArn: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    TrainingEndTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    TrainingJobStatus: {},
                    WarmPoolStatus: {
                      shape: "S15x"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTrainingJobsForHyperParameterTuningJob: {
          input: {
            type: "structure",
            required: [
              "HyperParameterTuningJobName"
            ],
            members: {
              HyperParameterTuningJobName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              StatusEquals: {},
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "TrainingJobSummaries"
            ],
            members: {
              TrainingJobSummaries: {
                type: "list",
                member: {
                  shape: "S129"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTransformJobs: {
          input: {
            type: "structure",
            members: {
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              NameContains: {},
              StatusEquals: {},
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TransformJobSummaries"
            ],
            members: {
              TransformJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "TransformJobName",
                    "TransformJobArn",
                    "CreationTime",
                    "TransformJobStatus"
                  ],
                  members: {
                    TransformJobName: {},
                    TransformJobArn: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    TransformEndTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    TransformJobStatus: {},
                    FailureReason: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTrialComponents: {
          input: {
            type: "structure",
            members: {
              ExperimentName: {},
              TrialName: {},
              SourceArn: {},
              CreatedAfter: {
                type: "timestamp"
              },
              CreatedBefore: {
                type: "timestamp"
              },
              SortBy: {},
              SortOrder: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrialComponentSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TrialComponentName: {},
                    TrialComponentArn: {},
                    DisplayName: {},
                    TrialComponentSource: {
                      shape: "S16n"
                    },
                    Status: {
                      shape: "Stb"
                    },
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    CreationTime: {
                      type: "timestamp"
                    },
                    CreatedBy: {
                      shape: "Swt"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    LastModifiedBy: {
                      shape: "Swt"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTrials: {
          input: {
            type: "structure",
            members: {
              ExperimentName: {},
              TrialComponentName: {},
              CreatedAfter: {
                type: "timestamp"
              },
              CreatedBefore: {
                type: "timestamp"
              },
              SortBy: {},
              SortOrder: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrialSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TrialArn: {},
                    TrialName: {},
                    DisplayName: {},
                    TrialSource: {
                      shape: "S16j"
                    },
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListUserProfiles: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              SortOrder: {},
              SortBy: {},
              DomainIdEquals: {},
              UserProfileNameContains: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UserProfiles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DomainId: {},
                    UserProfileName: {},
                    Status: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListWorkforces: {
          input: {
            type: "structure",
            members: {
              SortBy: {},
              SortOrder: {},
              NameContains: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Workforces"
            ],
            members: {
              Workforces: {
                type: "list",
                member: {
                  shape: "S16z"
                }
              },
              NextToken: {}
            }
          }
        },
        ListWorkteams: {
          input: {
            type: "structure",
            members: {
              SortBy: {},
              SortOrder: {},
              NameContains: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Workteams"
            ],
            members: {
              Workteams: {
                type: "list",
                member: {
                  shape: "S177"
                }
              },
              NextToken: {}
            }
          }
        },
        PutModelPackageGroupPolicy: {
          input: {
            type: "structure",
            required: [
              "ModelPackageGroupName",
              "ResourcePolicy"
            ],
            members: {
              ModelPackageGroupName: {},
              ResourcePolicy: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ModelPackageGroupArn"
            ],
            members: {
              ModelPackageGroupArn: {}
            }
          }
        },
        QueryLineage: {
          input: {
            type: "structure",
            members: {
              StartArns: {
                type: "list",
                member: {}
              },
              Direction: {},
              IncludeEdges: {
                type: "boolean"
              },
              Filters: {
                type: "structure",
                members: {
                  Types: {
                    type: "list",
                    member: {}
                  },
                  LineageTypes: {
                    type: "list",
                    member: {}
                  },
                  CreatedBefore: {
                    type: "timestamp"
                  },
                  CreatedAfter: {
                    type: "timestamp"
                  },
                  ModifiedBefore: {
                    type: "timestamp"
                  },
                  ModifiedAfter: {
                    type: "timestamp"
                  },
                  Properties: {
                    type: "map",
                    key: {},
                    value: {}
                  }
                }
              },
              MaxDepth: {
                type: "integer"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Vertices: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Type: {},
                    LineageType: {}
                  }
                }
              },
              Edges: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SourceArn: {},
                    DestinationArn: {},
                    AssociationType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        RegisterDevices: {
          input: {
            type: "structure",
            required: [
              "DeviceFleetName",
              "Devices"
            ],
            members: {
              DeviceFleetName: {},
              Devices: {
                shape: "S1ku"
              },
              Tags: {
                shape: "S7"
              }
            }
          }
        },
        RenderUiTemplate: {
          input: {
            type: "structure",
            required: [
              "Task",
              "RoleArn"
            ],
            members: {
              UiTemplate: {
                shape: "Sgt"
              },
              Task: {
                type: "structure",
                required: [
                  "Input"
                ],
                members: {
                  Input: {}
                }
              },
              RoleArn: {},
              HumanTaskUiArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "RenderedContent",
              "Errors"
            ],
            members: {
              RenderedContent: {},
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Code",
                    "Message"
                  ],
                  members: {
                    Code: {},
                    Message: {}
                  }
                }
              }
            }
          }
        },
        RetryPipelineExecution: {
          input: {
            type: "structure",
            required: [
              "PipelineExecutionArn",
              "ClientRequestToken"
            ],
            members: {
              PipelineExecutionArn: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              ParallelismConfiguration: {
                shape: "Spl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineExecutionArn: {}
            }
          }
        },
        Search: {
          input: {
            type: "structure",
            required: [
              "Resource"
            ],
            members: {
              Resource: {},
              SearchExpression: {
                shape: "S1l5"
              },
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              CrossAccountFilterOption: {},
              VisibilityConditions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Key: {},
                    Value: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Results: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TrainingJob: {
                      shape: "S1ln"
                    },
                    Experiment: {
                      type: "structure",
                      members: {
                        ExperimentName: {},
                        ExperimentArn: {},
                        DisplayName: {},
                        Source: {
                          shape: "S10r"
                        },
                        Description: {},
                        CreationTime: {
                          type: "timestamp"
                        },
                        CreatedBy: {
                          shape: "Swt"
                        },
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        LastModifiedBy: {
                          shape: "Swt"
                        },
                        Tags: {
                          shape: "S7"
                        }
                      }
                    },
                    Trial: {
                      type: "structure",
                      members: {
                        TrialName: {},
                        TrialArn: {},
                        DisplayName: {},
                        ExperimentName: {},
                        Source: {
                          shape: "S16j"
                        },
                        CreationTime: {
                          type: "timestamp"
                        },
                        CreatedBy: {
                          shape: "Swt"
                        },
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        LastModifiedBy: {
                          shape: "Swt"
                        },
                        MetadataProperties: {
                          shape: "S1u"
                        },
                        Tags: {
                          shape: "S7"
                        },
                        TrialComponentSummaries: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              TrialComponentName: {},
                              TrialComponentArn: {},
                              TrialComponentSource: {
                                shape: "S16n"
                              },
                              CreationTime: {
                                type: "timestamp"
                              },
                              CreatedBy: {
                                shape: "Swt"
                              }
                            }
                          }
                        }
                      }
                    },
                    TrialComponent: {
                      type: "structure",
                      members: {
                        TrialComponentName: {},
                        DisplayName: {},
                        TrialComponentArn: {},
                        Source: {
                          shape: "S16n"
                        },
                        Status: {
                          shape: "Stb"
                        },
                        StartTime: {
                          type: "timestamp"
                        },
                        EndTime: {
                          type: "timestamp"
                        },
                        CreationTime: {
                          type: "timestamp"
                        },
                        CreatedBy: {
                          shape: "Swt"
                        },
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        LastModifiedBy: {
                          shape: "Swt"
                        },
                        Parameters: {
                          shape: "Ste"
                        },
                        InputArtifacts: {
                          shape: "Sti"
                        },
                        OutputArtifacts: {
                          shape: "Sti"
                        },
                        Metrics: {
                          shape: "S16p"
                        },
                        MetadataProperties: {
                          shape: "S1u"
                        },
                        SourceDetail: {
                          type: "structure",
                          members: {
                            SourceArn: {},
                            TrainingJob: {
                              shape: "S1ln"
                            },
                            ProcessingJob: {
                              type: "structure",
                              members: {
                                ProcessingInputs: {
                                  shape: "Spy"
                                },
                                ProcessingOutputConfig: {
                                  shape: "Sql"
                                },
                                ProcessingJobName: {},
                                ProcessingResources: {
                                  shape: "Sqq"
                                },
                                StoppingCondition: {
                                  shape: "Sqs"
                                },
                                AppSpecification: {
                                  shape: "Squ"
                                },
                                Environment: {
                                  shape: "Sqw"
                                },
                                NetworkConfig: {
                                  shape: "Son"
                                },
                                RoleArn: {},
                                ExperimentConfig: {
                                  shape: "Sqx"
                                },
                                ProcessingJobArn: {},
                                ProcessingJobStatus: {},
                                ExitMessage: {},
                                FailureReason: {},
                                ProcessingEndTime: {
                                  type: "timestamp"
                                },
                                ProcessingStartTime: {
                                  type: "timestamp"
                                },
                                LastModifiedTime: {
                                  type: "timestamp"
                                },
                                CreationTime: {
                                  type: "timestamp"
                                },
                                MonitoringScheduleArn: {},
                                AutoMLJobArn: {},
                                TrainingJobArn: {},
                                Tags: {
                                  shape: "S7"
                                }
                              }
                            },
                            TransformJob: {
                              shape: "S1lv"
                            }
                          }
                        },
                        LineageGroupArn: {},
                        Tags: {
                          shape: "S7"
                        },
                        Parents: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              TrialName: {},
                              ExperimentName: {}
                            }
                          }
                        },
                        RunName: {}
                      }
                    },
                    Endpoint: {
                      type: "structure",
                      required: [
                        "EndpointName",
                        "EndpointArn",
                        "EndpointConfigName",
                        "EndpointStatus",
                        "CreationTime",
                        "LastModifiedTime"
                      ],
                      members: {
                        EndpointName: {},
                        EndpointArn: {},
                        EndpointConfigName: {},
                        ProductionVariants: {
                          shape: "S109"
                        },
                        DataCaptureConfig: {
                          shape: "S10h"
                        },
                        EndpointStatus: {},
                        FailureReason: {},
                        CreationTime: {
                          type: "timestamp"
                        },
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        MonitoringSchedules: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              MonitoringScheduleArn: {},
                              MonitoringScheduleName: {},
                              MonitoringScheduleStatus: {},
                              MonitoringType: {},
                              FailureReason: {},
                              CreationTime: {
                                type: "timestamp"
                              },
                              LastModifiedTime: {
                                type: "timestamp"
                              },
                              MonitoringScheduleConfig: {
                                shape: "Sof"
                              },
                              EndpointName: {},
                              LastMonitoringExecutionSummary: {
                                shape: "S14n"
                              },
                              Tags: {
                                shape: "S7"
                              }
                            }
                          }
                        },
                        Tags: {
                          shape: "S7"
                        },
                        ShadowProductionVariants: {
                          shape: "S109"
                        }
                      }
                    },
                    ModelPackage: {
                      type: "structure",
                      members: {
                        ModelPackageName: {},
                        ModelPackageGroupName: {},
                        ModelPackageVersion: {
                          type: "integer"
                        },
                        ModelPackageArn: {},
                        ModelPackageDescription: {},
                        CreationTime: {
                          type: "timestamp"
                        },
                        InferenceSpecification: {
                          shape: "Sr"
                        },
                        SourceAlgorithmSpecification: {
                          shape: "Snh"
                        },
                        ValidationSpecification: {
                          shape: "Sne"
                        },
                        ModelPackageStatus: {},
                        ModelPackageStatusDetails: {
                          shape: "S14a"
                        },
                        CertifyForMarketplace: {
                          type: "boolean"
                        },
                        ModelApprovalStatus: {},
                        CreatedBy: {
                          shape: "Swt"
                        },
                        MetadataProperties: {
                          shape: "S1u"
                        },
                        ModelMetrics: {
                          shape: "Snk"
                        },
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        LastModifiedBy: {
                          shape: "Swt"
                        },
                        ApprovalDescription: {},
                        Domain: {},
                        Task: {},
                        SamplePayloadUrl: {},
                        AdditionalInferenceSpecifications: {
                          shape: "So0"
                        },
                        Tags: {
                          shape: "S7"
                        },
                        CustomerMetadataProperties: {
                          shape: "Snr"
                        },
                        DriftCheckBaselines: {
                          shape: "Snu"
                        },
                        SkipModelValidation: {}
                      }
                    },
                    ModelPackageGroup: {
                      type: "structure",
                      members: {
                        ModelPackageGroupName: {},
                        ModelPackageGroupArn: {},
                        ModelPackageGroupDescription: {},
                        CreationTime: {
                          type: "timestamp"
                        },
                        CreatedBy: {
                          shape: "Swt"
                        },
                        ModelPackageGroupStatus: {},
                        Tags: {
                          shape: "S7"
                        }
                      }
                    },
                    Pipeline: {
                      type: "structure",
                      members: {
                        PipelineArn: {},
                        PipelineName: {},
                        PipelineDisplayName: {},
                        PipelineDescription: {},
                        RoleArn: {},
                        PipelineStatus: {},
                        CreationTime: {
                          type: "timestamp"
                        },
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        LastRunTime: {
                          type: "timestamp"
                        },
                        CreatedBy: {
                          shape: "Swt"
                        },
                        LastModifiedBy: {
                          shape: "Swt"
                        },
                        ParallelismConfiguration: {
                          shape: "Spl"
                        },
                        Tags: {
                          shape: "S7"
                        }
                      }
                    },
                    PipelineExecution: {
                      type: "structure",
                      members: {
                        PipelineArn: {},
                        PipelineExecutionArn: {},
                        PipelineExecutionDisplayName: {},
                        PipelineExecutionStatus: {},
                        PipelineExecutionDescription: {},
                        PipelineExperimentConfig: {
                          shape: "S157"
                        },
                        FailureReason: {},
                        CreationTime: {
                          type: "timestamp"
                        },
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        CreatedBy: {
                          shape: "Swt"
                        },
                        LastModifiedBy: {
                          shape: "Swt"
                        },
                        ParallelismConfiguration: {
                          shape: "Spl"
                        },
                        SelectiveExecutionConfig: {
                          shape: "S159"
                        },
                        PipelineParameters: {
                          shape: "S1hw"
                        }
                      }
                    },
                    FeatureGroup: {
                      type: "structure",
                      members: {
                        FeatureGroupArn: {},
                        FeatureGroupName: {},
                        RecordIdentifierFeatureName: {},
                        EventTimeFeatureName: {},
                        FeatureDefinitions: {
                          shape: "Sf2"
                        },
                        CreationTime: {
                          type: "timestamp"
                        },
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        OnlineStoreConfig: {
                          shape: "Sf9"
                        },
                        OfflineStoreConfig: {
                          shape: "Sff"
                        },
                        RoleArn: {},
                        FeatureGroupStatus: {},
                        OfflineStoreStatus: {
                          shape: "S10z"
                        },
                        LastUpdateStatus: {
                          shape: "S112"
                        },
                        FailureReason: {},
                        Description: {},
                        Tags: {
                          shape: "S7"
                        }
                      }
                    },
                    FeatureMetadata: {
                      type: "structure",
                      members: {
                        FeatureGroupArn: {},
                        FeatureGroupName: {},
                        FeatureName: {},
                        FeatureType: {},
                        CreationTime: {
                          type: "timestamp"
                        },
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        Description: {},
                        Parameters: {
                          shape: "S118"
                        }
                      }
                    },
                    Project: {
                      type: "structure",
                      members: {
                        ProjectArn: {},
                        ProjectName: {},
                        ProjectId: {},
                        ProjectDescription: {},
                        ServiceCatalogProvisioningDetails: {
                          shape: "Sr2"
                        },
                        ServiceCatalogProvisionedProductDetails: {
                          shape: "S15i"
                        },
                        ProjectStatus: {},
                        CreatedBy: {
                          shape: "Swt"
                        },
                        CreationTime: {
                          type: "timestamp"
                        },
                        Tags: {
                          shape: "S7"
                        },
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        LastModifiedBy: {
                          shape: "Swt"
                        }
                      }
                    },
                    HyperParameterTuningJob: {
                      type: "structure",
                      members: {
                        HyperParameterTuningJobName: {},
                        HyperParameterTuningJobArn: {},
                        HyperParameterTuningJobConfig: {
                          shape: "Sgy"
                        },
                        TrainingJobDefinition: {
                          shape: "Shr"
                        },
                        TrainingJobDefinitions: {
                          shape: "Si7"
                        },
                        HyperParameterTuningJobStatus: {},
                        CreationTime: {
                          type: "timestamp"
                        },
                        HyperParameterTuningEndTime: {
                          type: "timestamp"
                        },
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        TrainingJobStatusCounters: {
                          shape: "S125"
                        },
                        ObjectiveStatusCounters: {
                          shape: "S127"
                        },
                        BestTrainingJob: {
                          shape: "S129"
                        },
                        OverallBestTrainingJob: {
                          shape: "S129"
                        },
                        WarmStartConfig: {
                          shape: "Si8"
                        },
                        FailureReason: {},
                        TuningJobCompletionDetails: {
                          shape: "S12c"
                        },
                        ConsumedResources: {
                          shape: "S12d"
                        },
                        Tags: {
                          shape: "S7"
                        }
                      }
                    },
                    ModelCard: {
                      type: "structure",
                      members: {
                        ModelCardArn: {},
                        ModelCardName: {},
                        ModelCardVersion: {
                          type: "integer"
                        },
                        Content: {
                          shape: "Smz"
                        },
                        ModelCardStatus: {},
                        SecurityConfig: {
                          shape: "Smy"
                        },
                        CreationTime: {
                          type: "timestamp"
                        },
                        CreatedBy: {
                          shape: "Swt"
                        },
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        LastModifiedBy: {
                          shape: "Swt"
                        },
                        Tags: {
                          shape: "S7"
                        },
                        ModelId: {},
                        RiskRating: {},
                        ModelPackageGroupName: {}
                      }
                    },
                    Model: {
                      type: "structure",
                      members: {
                        Model: {
                          type: "structure",
                          members: {
                            ModelName: {},
                            PrimaryContainer: {
                              shape: "Sm9"
                            },
                            Containers: {
                              shape: "Smn"
                            },
                            InferenceExecutionConfig: {
                              shape: "Smo"
                            },
                            ExecutionRoleArn: {},
                            VpcConfig: {
                              shape: "S63"
                            },
                            CreationTime: {
                              type: "timestamp"
                            },
                            ModelArn: {},
                            EnableNetworkIsolation: {
                              type: "boolean"
                            },
                            Tags: {
                              shape: "S7"
                            },
                            DeploymentRecommendation: {
                              shape: "S13t"
                            }
                          }
                        },
                        Endpoints: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "EndpointName",
                              "EndpointArn",
                              "CreationTime",
                              "LastModifiedTime",
                              "EndpointStatus"
                            ],
                            members: {
                              EndpointName: {},
                              EndpointArn: {},
                              CreationTime: {
                                type: "timestamp"
                              },
                              LastModifiedTime: {
                                type: "timestamp"
                              },
                              EndpointStatus: {}
                            }
                          }
                        },
                        LastBatchTransformJob: {
                          shape: "S1lv"
                        },
                        MonitoringSchedules: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              MonitoringScheduleArn: {},
                              MonitoringScheduleName: {},
                              MonitoringScheduleStatus: {},
                              MonitoringType: {},
                              FailureReason: {},
                              CreationTime: {
                                type: "timestamp"
                              },
                              LastModifiedTime: {
                                type: "timestamp"
                              },
                              MonitoringScheduleConfig: {
                                shape: "Sof"
                              },
                              EndpointName: {},
                              MonitoringAlertSummaries: {
                                shape: "S1g1"
                              },
                              LastMonitoringExecutionSummary: {
                                shape: "S14n"
                              },
                              BatchTransformInput: {
                                shape: "S9i"
                              }
                            }
                          }
                        },
                        ModelCard: {
                          type: "structure",
                          members: {
                            ModelCardArn: {},
                            ModelCardName: {},
                            ModelCardVersion: {
                              type: "integer"
                            },
                            ModelCardStatus: {},
                            SecurityConfig: {
                              shape: "Smy"
                            },
                            CreationTime: {
                              type: "timestamp"
                            },
                            CreatedBy: {
                              shape: "Swt"
                            },
                            LastModifiedTime: {
                              type: "timestamp"
                            },
                            LastModifiedBy: {
                              shape: "Swt"
                            },
                            Tags: {
                              shape: "S7"
                            },
                            ModelId: {},
                            RiskRating: {}
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        SendPipelineExecutionStepFailure: {
          input: {
            type: "structure",
            required: [
              "CallbackToken"
            ],
            members: {
              CallbackToken: {},
              FailureReason: {},
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineExecutionArn: {}
            }
          }
        },
        SendPipelineExecutionStepSuccess: {
          input: {
            type: "structure",
            required: [
              "CallbackToken"
            ],
            members: {
              CallbackToken: {},
              OutputParameters: {
                shape: "S1hf"
              },
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineExecutionArn: {}
            }
          }
        },
        StartEdgeDeploymentStage: {
          input: {
            type: "structure",
            required: [
              "EdgeDeploymentPlanName",
              "StageName"
            ],
            members: {
              EdgeDeploymentPlanName: {},
              StageName: {}
            }
          }
        },
        StartInferenceExperiment: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "InferenceExperimentArn"
            ],
            members: {
              InferenceExperimentArn: {}
            }
          }
        },
        StartMonitoringSchedule: {
          input: {
            type: "structure",
            required: [
              "MonitoringScheduleName"
            ],
            members: {
              MonitoringScheduleName: {}
            }
          }
        },
        StartNotebookInstance: {
          input: {
            type: "structure",
            required: [
              "NotebookInstanceName"
            ],
            members: {
              NotebookInstanceName: {}
            }
          }
        },
        StartPipelineExecution: {
          input: {
            type: "structure",
            required: [
              "PipelineName",
              "ClientRequestToken"
            ],
            members: {
              PipelineName: {},
              PipelineExecutionDisplayName: {},
              PipelineParameters: {
                shape: "S1hw"
              },
              PipelineExecutionDescription: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              ParallelismConfiguration: {
                shape: "Spl"
              },
              SelectiveExecutionConfig: {
                shape: "S159"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineExecutionArn: {}
            }
          }
        },
        StopAutoMLJob: {
          input: {
            type: "structure",
            required: [
              "AutoMLJobName"
            ],
            members: {
              AutoMLJobName: {}
            }
          }
        },
        StopCompilationJob: {
          input: {
            type: "structure",
            required: [
              "CompilationJobName"
            ],
            members: {
              CompilationJobName: {}
            }
          }
        },
        StopEdgeDeploymentStage: {
          input: {
            type: "structure",
            required: [
              "EdgeDeploymentPlanName",
              "StageName"
            ],
            members: {
              EdgeDeploymentPlanName: {},
              StageName: {}
            }
          }
        },
        StopEdgePackagingJob: {
          input: {
            type: "structure",
            required: [
              "EdgePackagingJobName"
            ],
            members: {
              EdgePackagingJobName: {}
            }
          }
        },
        StopHyperParameterTuningJob: {
          input: {
            type: "structure",
            required: [
              "HyperParameterTuningJobName"
            ],
            members: {
              HyperParameterTuningJobName: {}
            }
          }
        },
        StopInferenceExperiment: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ModelVariantActions"
            ],
            members: {
              Name: {},
              ModelVariantActions: {
                type: "map",
                key: {},
                value: {}
              },
              DesiredModelVariants: {
                shape: "Sjg"
              },
              DesiredState: {},
              Reason: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "InferenceExperimentArn"
            ],
            members: {
              InferenceExperimentArn: {}
            }
          }
        },
        StopInferenceRecommendationsJob: {
          input: {
            type: "structure",
            required: [
              "JobName"
            ],
            members: {
              JobName: {}
            }
          }
        },
        StopLabelingJob: {
          input: {
            type: "structure",
            required: [
              "LabelingJobName"
            ],
            members: {
              LabelingJobName: {}
            }
          }
        },
        StopMonitoringSchedule: {
          input: {
            type: "structure",
            required: [
              "MonitoringScheduleName"
            ],
            members: {
              MonitoringScheduleName: {}
            }
          }
        },
        StopNotebookInstance: {
          input: {
            type: "structure",
            required: [
              "NotebookInstanceName"
            ],
            members: {
              NotebookInstanceName: {}
            }
          }
        },
        StopPipelineExecution: {
          input: {
            type: "structure",
            required: [
              "PipelineExecutionArn",
              "ClientRequestToken"
            ],
            members: {
              PipelineExecutionArn: {},
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineExecutionArn: {}
            }
          }
        },
        StopProcessingJob: {
          input: {
            type: "structure",
            required: [
              "ProcessingJobName"
            ],
            members: {
              ProcessingJobName: {}
            }
          }
        },
        StopTrainingJob: {
          input: {
            type: "structure",
            required: [
              "TrainingJobName"
            ],
            members: {
              TrainingJobName: {}
            }
          }
        },
        StopTransformJob: {
          input: {
            type: "structure",
            required: [
              "TransformJobName"
            ],
            members: {
              TransformJobName: {}
            }
          }
        },
        UpdateAction: {
          input: {
            type: "structure",
            required: [
              "ActionName"
            ],
            members: {
              ActionName: {},
              Description: {},
              Status: {},
              Properties: {
                shape: "S1s"
              },
              PropertiesToRemove: {
                shape: "S1nc"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ActionArn: {}
            }
          }
        },
        UpdateAppImageConfig: {
          input: {
            type: "structure",
            required: [
              "AppImageConfigName"
            ],
            members: {
              AppImageConfigName: {},
              KernelGatewayImageConfig: {
                shape: "S4s"
              },
              JupyterLabAppImageConfig: {
                shape: "S51"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppImageConfigArn: {}
            }
          }
        },
        UpdateArtifact: {
          input: {
            type: "structure",
            required: [
              "ArtifactArn"
            ],
            members: {
              ArtifactArn: {},
              ArtifactName: {},
              Properties: {
                shape: "S5f"
              },
              PropertiesToRemove: {
                shape: "S1nc"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ArtifactArn: {}
            }
          }
        },
        UpdateCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterName",
              "InstanceGroups"
            ],
            members: {
              ClusterName: {},
              InstanceGroups: {
                shape: "S7r"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ClusterArn"
            ],
            members: {
              ClusterArn: {}
            }
          }
        },
        UpdateCodeRepository: {
          input: {
            type: "structure",
            required: [
              "CodeRepositoryName"
            ],
            members: {
              CodeRepositoryName: {},
              GitConfig: {
                type: "structure",
                members: {
                  SecretArn: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CodeRepositoryArn"
            ],
            members: {
              CodeRepositoryArn: {}
            }
          }
        },
        UpdateContext: {
          input: {
            type: "structure",
            required: [
              "ContextName"
            ],
            members: {
              ContextName: {},
              Description: {},
              Properties: {
                shape: "S1s"
              },
              PropertiesToRemove: {
                shape: "S1nc"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContextArn: {}
            }
          }
        },
        UpdateDeviceFleet: {
          input: {
            type: "structure",
            required: [
              "DeviceFleetName",
              "OutputConfig"
            ],
            members: {
              DeviceFleetName: {},
              RoleArn: {},
              Description: {},
              OutputConfig: {
                shape: "Sa6"
              },
              EnableIotRoleAlias: {
                type: "boolean"
              }
            }
          }
        },
        UpdateDevices: {
          input: {
            type: "structure",
            required: [
              "DeviceFleetName",
              "Devices"
            ],
            members: {
              DeviceFleetName: {},
              Devices: {
                shape: "S1ku"
              }
            }
          }
        },
        UpdateDomain: {
          input: {
            type: "structure",
            required: [
              "DomainId"
            ],
            members: {
              DomainId: {},
              DefaultUserSettings: {
                shape: "Sac"
              },
              DomainSettingsForUpdate: {
                type: "structure",
                members: {
                  RStudioServerProDomainSettingsForUpdate: {
                    type: "structure",
                    required: [
                      "DomainExecutionRoleArn"
                    ],
                    members: {
                      DomainExecutionRoleArn: {},
                      DefaultResourceSpec: {
                        shape: "S4i"
                      },
                      RStudioConnectUrl: {},
                      RStudioPackageManagerUrl: {}
                    }
                  },
                  ExecutionRoleIdentityConfig: {},
                  SecurityGroupIds: {
                    shape: "Sbk"
                  },
                  DockerSettings: {
                    shape: "Sbn"
                  }
                }
              },
              AppSecurityGroupManagement: {},
              DefaultSpaceSettings: {
                shape: "Sbt"
              },
              SubnetIds: {
                shape: "S66"
              },
              AppNetworkAccessType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DomainArn: {}
            }
          }
        },
        UpdateEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointName",
              "EndpointConfigName"
            ],
            members: {
              EndpointName: {},
              EndpointConfigName: {},
              RetainAllVariantProperties: {
                type: "boolean"
              },
              ExcludeRetainedVariantProperties: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "VariantPropertyType"
                  ],
                  members: {
                    VariantPropertyType: {}
                  }
                }
              },
              DeploymentConfig: {
                shape: "Scg"
              },
              RetainDeploymentConfig: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EndpointArn"
            ],
            members: {
              EndpointArn: {}
            }
          }
        },
        UpdateEndpointWeightsAndCapacities: {
          input: {
            type: "structure",
            required: [
              "EndpointName",
              "DesiredWeightsAndCapacities"
            ],
            members: {
              EndpointName: {},
              DesiredWeightsAndCapacities: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "VariantName"
                  ],
                  members: {
                    VariantName: {},
                    DesiredWeight: {
                      type: "float"
                    },
                    DesiredInstanceCount: {
                      type: "integer"
                    },
                    ServerlessUpdateConfig: {
                      type: "structure",
                      members: {
                        MaxConcurrency: {
                          type: "integer"
                        },
                        ProvisionedConcurrency: {
                          type: "integer"
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EndpointArn"
            ],
            members: {
              EndpointArn: {}
            }
          }
        },
        UpdateExperiment: {
          input: {
            type: "structure",
            required: [
              "ExperimentName"
            ],
            members: {
              ExperimentName: {},
              DisplayName: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ExperimentArn: {}
            }
          }
        },
        UpdateFeatureGroup: {
          input: {
            type: "structure",
            required: [
              "FeatureGroupName"
            ],
            members: {
              FeatureGroupName: {},
              FeatureAdditions: {
                type: "list",
                member: {
                  shape: "Sf3"
                }
              },
              OnlineStoreConfig: {
                type: "structure",
                members: {
                  TtlDuration: {
                    shape: "Sfb"
                  }
                }
              },
              ThroughputConfig: {
                type: "structure",
                members: {
                  ThroughputMode: {},
                  ProvisionedReadCapacityUnits: {
                    type: "integer"
                  },
                  ProvisionedWriteCapacityUnits: {
                    type: "integer"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "FeatureGroupArn"
            ],
            members: {
              FeatureGroupArn: {}
            }
          }
        },
        UpdateFeatureMetadata: {
          input: {
            type: "structure",
            required: [
              "FeatureGroupName",
              "FeatureName"
            ],
            members: {
              FeatureGroupName: {},
              FeatureName: {},
              Description: {},
              ParameterAdditions: {
                type: "list",
                member: {
                  shape: "S119"
                }
              },
              ParameterRemovals: {
                type: "list",
                member: {}
              }
            }
          }
        },
        UpdateHub: {
          input: {
            type: "structure",
            required: [
              "HubName"
            ],
            members: {
              HubName: {},
              HubDescription: {},
              HubDisplayName: {},
              HubSearchKeywords: {
                shape: "Sgl"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HubArn"
            ],
            members: {
              HubArn: {}
            }
          }
        },
        UpdateImage: {
          input: {
            type: "structure",
            required: [
              "ImageName"
            ],
            members: {
              DeleteProperties: {
                type: "list",
                member: {}
              },
              Description: {},
              DisplayName: {},
              ImageName: {},
              RoleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ImageArn: {}
            }
          }
        },
        UpdateImageVersion: {
          input: {
            type: "structure",
            required: [
              "ImageName"
            ],
            members: {
              ImageName: {},
              Alias: {},
              Version: {
                type: "integer"
              },
              AliasesToAdd: {
                shape: "Sin"
              },
              AliasesToDelete: {
                shape: "Sin"
              },
              VendorGuidance: {},
              JobType: {},
              MLFramework: {},
              ProgrammingLang: {},
              Processor: {},
              Horovod: {
                type: "boolean"
              },
              ReleaseNotes: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ImageVersionArn: {}
            }
          }
        },
        UpdateInferenceComponent: {
          input: {
            type: "structure",
            required: [
              "InferenceComponentName"
            ],
            members: {
              InferenceComponentName: {},
              Specification: {
                shape: "Siz"
              },
              RuntimeConfig: {
                shape: "Sj6"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "InferenceComponentArn"
            ],
            members: {
              InferenceComponentArn: {}
            }
          }
        },
        UpdateInferenceComponentRuntimeConfig: {
          input: {
            type: "structure",
            required: [
              "InferenceComponentName",
              "DesiredRuntimeConfig"
            ],
            members: {
              InferenceComponentName: {},
              DesiredRuntimeConfig: {
                shape: "Sj6"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "InferenceComponentArn"
            ],
            members: {
              InferenceComponentArn: {}
            }
          }
        },
        UpdateInferenceExperiment: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Schedule: {
                shape: "Sjd"
              },
              Description: {},
              ModelVariants: {
                shape: "Sjg"
              },
              DataStorageConfig: {
                shape: "Sjo"
              },
              ShadowModeConfig: {
                shape: "Sjp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "InferenceExperimentArn"
            ],
            members: {
              InferenceExperimentArn: {}
            }
          }
        },
        UpdateModelCard: {
          input: {
            type: "structure",
            required: [
              "ModelCardName"
            ],
            members: {
              ModelCardName: {},
              Content: {
                shape: "Smz"
              },
              ModelCardStatus: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ModelCardArn"
            ],
            members: {
              ModelCardArn: {}
            }
          }
        },
        UpdateModelPackage: {
          input: {
            type: "structure",
            required: [
              "ModelPackageArn"
            ],
            members: {
              ModelPackageArn: {},
              ModelApprovalStatus: {},
              ApprovalDescription: {},
              CustomerMetadataProperties: {
                shape: "Snr"
              },
              CustomerMetadataPropertiesToRemove: {
                type: "list",
                member: {}
              },
              AdditionalInferenceSpecificationsToAdd: {
                shape: "So0"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ModelPackageArn"
            ],
            members: {
              ModelPackageArn: {}
            }
          }
        },
        UpdateMonitoringAlert: {
          input: {
            type: "structure",
            required: [
              "MonitoringScheduleName",
              "MonitoringAlertName",
              "DatapointsToAlert",
              "EvaluationPeriod"
            ],
            members: {
              MonitoringScheduleName: {},
              MonitoringAlertName: {},
              DatapointsToAlert: {
                type: "integer"
              },
              EvaluationPeriod: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "MonitoringScheduleArn"
            ],
            members: {
              MonitoringScheduleArn: {},
              MonitoringAlertName: {}
            }
          }
        },
        UpdateMonitoringSchedule: {
          input: {
            type: "structure",
            required: [
              "MonitoringScheduleName",
              "MonitoringScheduleConfig"
            ],
            members: {
              MonitoringScheduleName: {},
              MonitoringScheduleConfig: {
                shape: "Sof"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "MonitoringScheduleArn"
            ],
            members: {
              MonitoringScheduleArn: {}
            }
          }
        },
        UpdateNotebookInstance: {
          input: {
            type: "structure",
            required: [
              "NotebookInstanceName"
            ],
            members: {
              NotebookInstanceName: {},
              InstanceType: {},
              RoleArn: {},
              LifecycleConfigName: {},
              DisassociateLifecycleConfig: {
                type: "boolean"
              },
              VolumeSizeInGB: {
                type: "integer"
              },
              DefaultCodeRepository: {},
              AdditionalCodeRepositories: {
                shape: "Soz"
              },
              AcceleratorTypes: {
                shape: "Sow"
              },
              DisassociateAcceleratorTypes: {
                type: "boolean"
              },
              DisassociateDefaultCodeRepository: {
                type: "boolean"
              },
              DisassociateAdditionalCodeRepositories: {
                type: "boolean"
              },
              RootAccess: {},
              InstanceMetadataServiceConfiguration: {
                shape: "Sp2"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateNotebookInstanceLifecycleConfig: {
          input: {
            type: "structure",
            required: [
              "NotebookInstanceLifecycleConfigName"
            ],
            members: {
              NotebookInstanceLifecycleConfigName: {},
              OnCreate: {
                shape: "Sp7"
              },
              OnStart: {
                shape: "Sp7"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdatePipeline: {
          input: {
            type: "structure",
            required: [
              "PipelineName"
            ],
            members: {
              PipelineName: {},
              PipelineDisplayName: {},
              PipelineDefinition: {},
              PipelineDefinitionS3Location: {
                shape: "Spf"
              },
              PipelineDescription: {},
              RoleArn: {},
              ParallelismConfiguration: {
                shape: "Spl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineArn: {}
            }
          }
        },
        UpdatePipelineExecution: {
          input: {
            type: "structure",
            required: [
              "PipelineExecutionArn"
            ],
            members: {
              PipelineExecutionArn: {},
              PipelineExecutionDescription: {},
              PipelineExecutionDisplayName: {},
              ParallelismConfiguration: {
                shape: "Spl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineExecutionArn: {}
            }
          }
        },
        UpdateProject: {
          input: {
            type: "structure",
            required: [
              "ProjectName"
            ],
            members: {
              ProjectName: {},
              ProjectDescription: {},
              ServiceCatalogProvisioningUpdateDetails: {
                type: "structure",
                members: {
                  ProvisioningArtifactId: {},
                  ProvisioningParameters: {
                    shape: "Sr4"
                  }
                }
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ProjectArn"
            ],
            members: {
              ProjectArn: {}
            }
          }
        },
        UpdateSpace: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "SpaceName"
            ],
            members: {
              DomainId: {},
              SpaceName: {},
              SpaceSettings: {
                shape: "Src"
              },
              SpaceDisplayName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SpaceArn: {}
            }
          }
        },
        UpdateTrainingJob: {
          input: {
            type: "structure",
            required: [
              "TrainingJobName"
            ],
            members: {
              TrainingJobName: {},
              ProfilerConfig: {
                type: "structure",
                members: {
                  S3OutputPath: {},
                  ProfilingIntervalInMilliseconds: {
                    type: "long"
                  },
                  ProfilingParameters: {
                    shape: "Ssk"
                  },
                  DisableProfiler: {
                    type: "boolean"
                  }
                }
              },
              ProfilerRuleConfigurations: {
                shape: "Ssm"
              },
              ResourceConfig: {
                type: "structure",
                required: [
                  "KeepAlivePeriodInSeconds"
                ],
                members: {
                  KeepAlivePeriodInSeconds: {
                    type: "integer"
                  }
                }
              },
              RemoteDebugConfig: {
                type: "structure",
                members: {
                  EnableRemoteDebug: {
                    type: "boolean"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TrainingJobArn"
            ],
            members: {
              TrainingJobArn: {}
            }
          }
        },
        UpdateTrial: {
          input: {
            type: "structure",
            required: [
              "TrialName"
            ],
            members: {
              TrialName: {},
              DisplayName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrialArn: {}
            }
          }
        },
        UpdateTrialComponent: {
          input: {
            type: "structure",
            required: [
              "TrialComponentName"
            ],
            members: {
              TrialComponentName: {},
              DisplayName: {},
              Status: {
                shape: "Stb"
              },
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Parameters: {
                shape: "Ste"
              },
              ParametersToRemove: {
                shape: "S1pr"
              },
              InputArtifacts: {
                shape: "Sti"
              },
              InputArtifactsToRemove: {
                shape: "S1pr"
              },
              OutputArtifacts: {
                shape: "Sti"
              },
              OutputArtifactsToRemove: {
                shape: "S1pr"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrialComponentArn: {}
            }
          }
        },
        UpdateUserProfile: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "UserProfileName"
            ],
            members: {
              DomainId: {},
              UserProfileName: {},
              UserSettings: {
                shape: "Sac"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserProfileArn: {}
            }
          }
        },
        UpdateWorkforce: {
          input: {
            type: "structure",
            required: [
              "WorkforceName"
            ],
            members: {
              WorkforceName: {},
              SourceIpConfig: {
                shape: "Stz"
              },
              OidcConfig: {
                shape: "Stw"
              },
              WorkforceVpcConfig: {
                shape: "Su3"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Workforce"
            ],
            members: {
              Workforce: {
                shape: "S16z"
              }
            }
          }
        },
        UpdateWorkteam: {
          input: {
            type: "structure",
            required: [
              "WorkteamName"
            ],
            members: {
              WorkteamName: {},
              MemberDefinitions: {
                shape: "Sud"
              },
              Description: {},
              NotificationConfiguration: {
                shape: "Sul"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Workteam"
            ],
            members: {
              Workteam: {
                shape: "S177"
              }
            }
          }
        }
      },
      shapes: {
        S7: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sr: {
          type: "structure",
          required: [
            "Containers"
          ],
          members: {
            Containers: {
              shape: "Ss"
            },
            SupportedTransformInstanceTypes: {
              shape: "S1a"
            },
            SupportedRealtimeInferenceInstanceTypes: {
              shape: "S1c"
            },
            SupportedContentTypes: {
              shape: "S1e"
            },
            SupportedResponseMIMETypes: {
              shape: "S1g"
            }
          }
        },
        Ss: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Image"
            ],
            members: {
              ContainerHostname: {},
              Image: {},
              ImageDigest: {},
              ModelDataUrl: {},
              ProductId: {},
              Environment: {
                shape: "Sz"
              },
              ModelInput: {
                type: "structure",
                required: [
                  "DataInputConfig"
                ],
                members: {
                  DataInputConfig: {}
                }
              },
              Framework: {},
              FrameworkVersion: {},
              NearestModelName: {},
              AdditionalS3DataSource: {
                shape: "S16"
              }
            }
          }
        },
        Sz: {
          type: "map",
          key: {},
          value: {}
        },
        S16: {
          type: "structure",
          required: [
            "S3DataType",
            "S3Uri"
          ],
          members: {
            S3DataType: {},
            S3Uri: {},
            CompressionType: {}
          }
        },
        S1a: {
          type: "list",
          member: {}
        },
        S1c: {
          type: "list",
          member: {}
        },
        S1e: {
          type: "list",
          member: {}
        },
        S1g: {
          type: "list",
          member: {}
        },
        S1n: {
          type: "structure",
          required: [
            "SourceUri"
          ],
          members: {
            SourceUri: {},
            SourceType: {},
            SourceId: {}
          }
        },
        S1s: {
          type: "map",
          key: {},
          value: {}
        },
        S1u: {
          type: "structure",
          members: {
            CommitId: {},
            Repository: {},
            GeneratedBy: {},
            ProjectId: {}
          }
        },
        S1z: {
          type: "structure",
          required: [
            "TrainingImage",
            "SupportedTrainingInstanceTypes",
            "TrainingChannels"
          ],
          members: {
            TrainingImage: {},
            TrainingImageDigest: {},
            SupportedHyperParameters: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name",
                  "Type"
                ],
                members: {
                  Name: {},
                  Description: {},
                  Type: {},
                  Range: {
                    type: "structure",
                    members: {
                      IntegerParameterRangeSpecification: {
                        type: "structure",
                        required: [
                          "MinValue",
                          "MaxValue"
                        ],
                        members: {
                          MinValue: {},
                          MaxValue: {}
                        }
                      },
                      ContinuousParameterRangeSpecification: {
                        type: "structure",
                        required: [
                          "MinValue",
                          "MaxValue"
                        ],
                        members: {
                          MinValue: {},
                          MaxValue: {}
                        }
                      },
                      CategoricalParameterRangeSpecification: {
                        type: "structure",
                        required: [
                          "Values"
                        ],
                        members: {
                          Values: {
                            shape: "S29"
                          }
                        }
                      }
                    }
                  },
                  IsTunable: {
                    type: "boolean"
                  },
                  IsRequired: {
                    type: "boolean"
                  },
                  DefaultValue: {}
                }
              }
            },
            SupportedTrainingInstanceTypes: {
              type: "list",
              member: {}
            },
            SupportsDistributedTraining: {
              type: "boolean"
            },
            MetricDefinitions: {
              shape: "S2e"
            },
            TrainingChannels: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name",
                  "SupportedContentTypes",
                  "SupportedInputModes"
                ],
                members: {
                  Name: {},
                  Description: {},
                  IsRequired: {
                    type: "boolean"
                  },
                  SupportedContentTypes: {
                    shape: "S1e"
                  },
                  SupportedCompressionTypes: {
                    type: "list",
                    member: {}
                  },
                  SupportedInputModes: {
                    type: "list",
                    member: {}
                  }
                }
              }
            },
            SupportedTuningJobObjectiveMetrics: {
              type: "list",
              member: {
                shape: "S2p"
              }
            },
            AdditionalS3DataSource: {
              shape: "S16"
            }
          }
        },
        S29: {
          type: "list",
          member: {}
        },
        S2e: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Regex"
            ],
            members: {
              Name: {},
              Regex: {}
            }
          }
        },
        S2p: {
          type: "structure",
          required: [
            "Type",
            "MetricName"
          ],
          members: {
            Type: {},
            MetricName: {}
          }
        },
        S2r: {
          type: "structure",
          required: [
            "ValidationRole",
            "ValidationProfiles"
          ],
          members: {
            ValidationRole: {},
            ValidationProfiles: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "ProfileName",
                  "TrainingJobDefinition"
                ],
                members: {
                  ProfileName: {},
                  TrainingJobDefinition: {
                    type: "structure",
                    required: [
                      "TrainingInputMode",
                      "InputDataConfig",
                      "OutputDataConfig",
                      "ResourceConfig",
                      "StoppingCondition"
                    ],
                    members: {
                      TrainingInputMode: {},
                      HyperParameters: {
                        shape: "S2w"
                      },
                      InputDataConfig: {
                        shape: "S2y"
                      },
                      OutputDataConfig: {
                        shape: "S3g"
                      },
                      ResourceConfig: {
                        shape: "S3j"
                      },
                      StoppingCondition: {
                        shape: "S3p"
                      }
                    }
                  },
                  TransformJobDefinition: {
                    shape: "S3t"
                  }
                }
              }
            }
          }
        },
        S2w: {
          type: "map",
          key: {},
          value: {}
        },
        S2y: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ChannelName",
              "DataSource"
            ],
            members: {
              ChannelName: {},
              DataSource: {
                type: "structure",
                members: {
                  S3DataSource: {
                    type: "structure",
                    required: [
                      "S3DataType",
                      "S3Uri"
                    ],
                    members: {
                      S3DataType: {},
                      S3Uri: {},
                      S3DataDistributionType: {},
                      AttributeNames: {
                        type: "list",
                        member: {}
                      },
                      InstanceGroupNames: {
                        type: "list",
                        member: {}
                      }
                    }
                  },
                  FileSystemDataSource: {
                    type: "structure",
                    required: [
                      "FileSystemId",
                      "FileSystemAccessMode",
                      "FileSystemType",
                      "DirectoryPath"
                    ],
                    members: {
                      FileSystemId: {},
                      FileSystemAccessMode: {},
                      FileSystemType: {},
                      DirectoryPath: {}
                    }
                  }
                }
              },
              ContentType: {},
              CompressionType: {},
              RecordWrapperType: {},
              InputMode: {},
              ShuffleConfig: {
                type: "structure",
                required: [
                  "Seed"
                ],
                members: {
                  Seed: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        S3g: {
          type: "structure",
          required: [
            "S3OutputPath"
          ],
          members: {
            KmsKeyId: {},
            S3OutputPath: {},
            CompressionType: {}
          }
        },
        S3j: {
          type: "structure",
          required: [
            "VolumeSizeInGB"
          ],
          members: {
            InstanceType: {},
            InstanceCount: {
              type: "integer"
            },
            VolumeSizeInGB: {
              type: "integer"
            },
            VolumeKmsKeyId: {},
            KeepAlivePeriodInSeconds: {
              type: "integer"
            },
            InstanceGroups: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "InstanceType",
                  "InstanceCount",
                  "InstanceGroupName"
                ],
                members: {
                  InstanceType: {},
                  InstanceCount: {
                    type: "integer"
                  },
                  InstanceGroupName: {}
                }
              }
            }
          }
        },
        S3p: {
          type: "structure",
          members: {
            MaxRuntimeInSeconds: {
              type: "integer"
            },
            MaxWaitTimeInSeconds: {
              type: "integer"
            },
            MaxPendingTimeInSeconds: {
              type: "integer"
            }
          }
        },
        S3t: {
          type: "structure",
          required: [
            "TransformInput",
            "TransformOutput",
            "TransformResources"
          ],
          members: {
            MaxConcurrentTransforms: {
              type: "integer"
            },
            MaxPayloadInMB: {
              type: "integer"
            },
            BatchStrategy: {},
            Environment: {
              shape: "S3x"
            },
            TransformInput: {
              shape: "S40"
            },
            TransformOutput: {
              shape: "S44"
            },
            TransformResources: {
              shape: "S47"
            }
          }
        },
        S3x: {
          type: "map",
          key: {},
          value: {}
        },
        S40: {
          type: "structure",
          required: [
            "DataSource"
          ],
          members: {
            DataSource: {
              type: "structure",
              required: [
                "S3DataSource"
              ],
              members: {
                S3DataSource: {
                  type: "structure",
                  required: [
                    "S3DataType",
                    "S3Uri"
                  ],
                  members: {
                    S3DataType: {},
                    S3Uri: {}
                  }
                }
              }
            },
            ContentType: {},
            CompressionType: {},
            SplitType: {}
          }
        },
        S44: {
          type: "structure",
          required: [
            "S3OutputPath"
          ],
          members: {
            S3OutputPath: {},
            Accept: {},
            AssembleWith: {},
            KmsKeyId: {}
          }
        },
        S47: {
          type: "structure",
          required: [
            "InstanceType",
            "InstanceCount"
          ],
          members: {
            InstanceType: {},
            InstanceCount: {
              type: "integer"
            },
            VolumeKmsKeyId: {}
          }
        },
        S4i: {
          type: "structure",
          members: {
            SageMakerImageArn: {},
            SageMakerImageVersionArn: {},
            SageMakerImageVersionAlias: {},
            InstanceType: {},
            LifecycleConfigArn: {}
          }
        },
        S4s: {
          type: "structure",
          required: [
            "KernelSpecs"
          ],
          members: {
            KernelSpecs: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name"
                ],
                members: {
                  Name: {},
                  DisplayName: {}
                }
              }
            },
            FileSystemConfig: {
              shape: "S4x"
            }
          }
        },
        S4x: {
          type: "structure",
          members: {
            MountPath: {},
            DefaultUid: {
              type: "integer"
            },
            DefaultGid: {
              type: "integer"
            }
          }
        },
        S51: {
          type: "structure",
          members: {
            FileSystemConfig: {
              shape: "S4x"
            },
            ContainerConfig: {
              type: "structure",
              members: {
                ContainerArguments: {
                  type: "list",
                  member: {}
                },
                ContainerEntrypoint: {
                  type: "list",
                  member: {}
                },
                ContainerEnvironmentVariables: {
                  type: "map",
                  key: {},
                  value: {}
                }
              }
            }
          }
        },
        S5b: {
          type: "structure",
          required: [
            "SourceUri"
          ],
          members: {
            SourceUri: {},
            SourceTypes: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "SourceIdType",
                  "Value"
                ],
                members: {
                  SourceIdType: {},
                  Value: {}
                }
              }
            }
          }
        },
        S5f: {
          type: "map",
          key: {},
          value: {}
        },
        S5l: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "TargetAttributeName"
            ],
            members: {
              DataSource: {
                shape: "S5n"
              },
              CompressionType: {},
              TargetAttributeName: {},
              ContentType: {},
              ChannelType: {},
              SampleWeightAttributeName: {}
            }
          }
        },
        S5n: {
          type: "structure",
          required: [
            "S3DataSource"
          ],
          members: {
            S3DataSource: {
              type: "structure",
              required: [
                "S3DataType",
                "S3Uri"
              ],
              members: {
                S3DataType: {},
                S3Uri: {}
              }
            }
          }
        },
        S5t: {
          type: "structure",
          required: [
            "S3OutputPath"
          ],
          members: {
            KmsKeyId: {},
            S3OutputPath: {}
          }
        },
        S5v: {
          type: "structure",
          required: [
            "MetricName"
          ],
          members: {
            MetricName: {}
          }
        },
        S5x: {
          type: "structure",
          members: {
            CompletionCriteria: {
              shape: "S5y"
            },
            SecurityConfig: {
              shape: "S62"
            },
            CandidateGenerationConfig: {
              type: "structure",
              members: {
                FeatureSpecificationS3Uri: {},
                AlgorithmsConfig: {
                  shape: "S69"
                }
              }
            },
            DataSplitConfig: {
              shape: "S6d"
            },
            Mode: {}
          }
        },
        S5y: {
          type: "structure",
          members: {
            MaxCandidates: {
              type: "integer"
            },
            MaxRuntimePerTrainingJobInSeconds: {
              type: "integer"
            },
            MaxAutoMLJobRuntimeInSeconds: {
              type: "integer"
            }
          }
        },
        S62: {
          type: "structure",
          members: {
            VolumeKmsKeyId: {},
            EnableInterContainerTrafficEncryption: {
              type: "boolean"
            },
            VpcConfig: {
              shape: "S63"
            }
          }
        },
        S63: {
          type: "structure",
          required: [
            "SecurityGroupIds",
            "Subnets"
          ],
          members: {
            SecurityGroupIds: {
              type: "list",
              member: {}
            },
            Subnets: {
              shape: "S66"
            }
          }
        },
        S66: {
          type: "list",
          member: {}
        },
        S69: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AutoMLAlgorithms"
            ],
            members: {
              AutoMLAlgorithms: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S6d: {
          type: "structure",
          members: {
            ValidationFraction: {
              type: "float"
            }
          }
        },
        S6h: {
          type: "structure",
          members: {
            AutoGenerateEndpointName: {
              type: "boolean"
            },
            EndpointName: {}
          }
        },
        S6n: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ChannelType: {},
              ContentType: {},
              CompressionType: {},
              DataSource: {
                shape: "S5n"
              }
            }
          }
        },
        S6p: {
          type: "structure",
          members: {
            ImageClassificationJobConfig: {
              type: "structure",
              members: {
                CompletionCriteria: {
                  shape: "S5y"
                }
              }
            },
            TextClassificationJobConfig: {
              type: "structure",
              required: [
                "ContentColumn",
                "TargetLabelColumn"
              ],
              members: {
                CompletionCriteria: {
                  shape: "S5y"
                },
                ContentColumn: {},
                TargetLabelColumn: {}
              }
            },
            TimeSeriesForecastingJobConfig: {
              type: "structure",
              required: [
                "ForecastFrequency",
                "ForecastHorizon",
                "TimeSeriesConfig"
              ],
              members: {
                FeatureSpecificationS3Uri: {},
                CompletionCriteria: {
                  shape: "S5y"
                },
                ForecastFrequency: {},
                ForecastHorizon: {
                  type: "integer"
                },
                ForecastQuantiles: {
                  type: "list",
                  member: {}
                },
                Transformations: {
                  type: "structure",
                  members: {
                    Filling: {
                      type: "map",
                      key: {},
                      value: {
                        type: "map",
                        key: {},
                        value: {}
                      }
                    },
                    Aggregation: {
                      type: "map",
                      key: {},
                      value: {}
                    }
                  }
                },
                TimeSeriesConfig: {
                  type: "structure",
                  required: [
                    "TargetAttributeName",
                    "TimestampAttributeName",
                    "ItemIdentifierAttributeName"
                  ],
                  members: {
                    TargetAttributeName: {},
                    TimestampAttributeName: {},
                    ItemIdentifierAttributeName: {},
                    GroupingAttributeNames: {
                      type: "list",
                      member: {}
                    }
                  }
                },
                HolidayConfig: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      CountryCode: {}
                    }
                  }
                }
              }
            },
            TabularJobConfig: {
              type: "structure",
              required: [
                "TargetAttributeName"
              ],
              members: {
                CandidateGenerationConfig: {
                  type: "structure",
                  members: {
                    AlgorithmsConfig: {
                      shape: "S69"
                    }
                  }
                },
                CompletionCriteria: {
                  shape: "S5y"
                },
                FeatureSpecificationS3Uri: {},
                Mode: {},
                GenerateCandidateDefinitionsOnly: {
                  type: "boolean"
                },
                ProblemType: {},
                TargetAttributeName: {},
                SampleWeightAttributeName: {}
              }
            },
            TextGenerationJobConfig: {
              type: "structure",
              members: {
                CompletionCriteria: {
                  shape: "S5y"
                },
                BaseModelName: {},
                TextGenerationHyperParameters: {
                  type: "map",
                  key: {},
                  value: {}
                },
                ModelAccessConfig: {
                  shape: "S7m"
                }
              }
            }
          },
          union: true
        },
        S7m: {
          type: "structure",
          required: [
            "AcceptEula"
          ],
          members: {
            AcceptEula: {
              type: "boolean"
            }
          }
        },
        S7r: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "InstanceCount",
              "InstanceGroupName",
              "InstanceType",
              "LifeCycleConfig",
              "ExecutionRole"
            ],
            members: {
              InstanceCount: {
                type: "integer"
              },
              InstanceGroupName: {},
              InstanceType: {},
              LifeCycleConfig: {
                shape: "S7w"
              },
              ExecutionRole: {},
              ThreadsPerCore: {
                type: "integer"
              }
            }
          }
        },
        S7w: {
          type: "structure",
          required: [
            "SourceS3Uri",
            "OnCreate"
          ],
          members: {
            SourceS3Uri: {},
            OnCreate: {}
          }
        },
        S82: {
          type: "structure",
          required: [
            "RepositoryUrl"
          ],
          members: {
            RepositoryUrl: {},
            Branch: {},
            SecretArn: {}
          }
        },
        S89: {
          type: "structure",
          required: [
            "S3Uri",
            "Framework"
          ],
          members: {
            S3Uri: {},
            DataInputConfig: {},
            Framework: {},
            FrameworkVersion: {}
          }
        },
        S8c: {
          type: "structure",
          required: [
            "S3OutputLocation"
          ],
          members: {
            S3OutputLocation: {},
            TargetDevice: {},
            TargetPlatform: {
              type: "structure",
              required: [
                "Os",
                "Arch"
              ],
              members: {
                Os: {},
                Arch: {},
                Accelerator: {}
              }
            },
            CompilerOptions: {},
            KmsKeyId: {}
          }
        },
        S8j: {
          type: "structure",
          required: [
            "SecurityGroupIds",
            "Subnets"
          ],
          members: {
            SecurityGroupIds: {
              type: "list",
              member: {}
            },
            Subnets: {
              type: "list",
              member: {}
            }
          }
        },
        S8s: {
          type: "structure",
          required: [
            "SourceUri"
          ],
          members: {
            SourceUri: {},
            SourceType: {},
            SourceId: {}
          }
        },
        S8x: {
          type: "structure",
          members: {
            BaseliningJobName: {},
            ConstraintsResource: {
              shape: "S8z"
            },
            StatisticsResource: {
              shape: "S90"
            }
          }
        },
        S8z: {
          type: "structure",
          members: {
            S3Uri: {}
          }
        },
        S90: {
          type: "structure",
          members: {
            S3Uri: {}
          }
        },
        S91: {
          type: "structure",
          required: [
            "ImageUri"
          ],
          members: {
            ImageUri: {},
            ContainerEntrypoint: {
              shape: "S93"
            },
            ContainerArguments: {
              shape: "S95"
            },
            RecordPreprocessorSourceUri: {},
            PostAnalyticsProcessorSourceUri: {},
            Environment: {
              shape: "S97"
            }
          }
        },
        S93: {
          type: "list",
          member: {}
        },
        S95: {
          type: "list",
          member: {}
        },
        S97: {
          type: "map",
          key: {},
          value: {}
        },
        S9a: {
          type: "structure",
          members: {
            EndpointInput: {
              shape: "S9b"
            },
            BatchTransformInput: {
              shape: "S9i"
            }
          }
        },
        S9b: {
          type: "structure",
          required: [
            "EndpointName",
            "LocalPath"
          ],
          members: {
            EndpointName: {},
            LocalPath: {},
            S3InputMode: {},
            S3DataDistributionType: {},
            FeaturesAttribute: {},
            InferenceAttribute: {},
            ProbabilityAttribute: {},
            ProbabilityThresholdAttribute: {
              type: "double"
            },
            StartTimeOffset: {},
            EndTimeOffset: {},
            ExcludeFeaturesAttribute: {}
          }
        },
        S9i: {
          type: "structure",
          required: [
            "DataCapturedDestinationS3Uri",
            "DatasetFormat",
            "LocalPath"
          ],
          members: {
            DataCapturedDestinationS3Uri: {},
            DatasetFormat: {
              type: "structure",
              members: {
                Csv: {
                  type: "structure",
                  members: {
                    Header: {
                      type: "boolean"
                    }
                  }
                },
                Json: {
                  type: "structure",
                  members: {
                    Line: {
                      type: "boolean"
                    }
                  }
                },
                Parquet: {
                  type: "structure",
                  members: {}
                }
              }
            },
            LocalPath: {},
            S3InputMode: {},
            S3DataDistributionType: {},
            FeaturesAttribute: {},
            InferenceAttribute: {},
            ProbabilityAttribute: {},
            ProbabilityThresholdAttribute: {
              type: "double"
            },
            StartTimeOffset: {},
            EndTimeOffset: {},
            ExcludeFeaturesAttribute: {}
          }
        },
        S9o: {
          type: "structure",
          required: [
            "MonitoringOutputs"
          ],
          members: {
            MonitoringOutputs: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "S3Output"
                ],
                members: {
                  S3Output: {
                    type: "structure",
                    required: [
                      "S3Uri",
                      "LocalPath"
                    ],
                    members: {
                      S3Uri: {},
                      LocalPath: {},
                      S3UploadMode: {}
                    }
                  }
                }
              }
            },
            KmsKeyId: {}
          }
        },
        S9u: {
          type: "structure",
          required: [
            "ClusterConfig"
          ],
          members: {
            ClusterConfig: {
              type: "structure",
              required: [
                "InstanceCount",
                "InstanceType",
                "VolumeSizeInGB"
              ],
              members: {
                InstanceCount: {
                  type: "integer"
                },
                InstanceType: {},
                VolumeSizeInGB: {
                  type: "integer"
                },
                VolumeKmsKeyId: {}
              }
            }
          }
        },
        S9z: {
          type: "structure",
          members: {
            EnableInterContainerTrafficEncryption: {
              type: "boolean"
            },
            EnableNetworkIsolation: {
              type: "boolean"
            },
            VpcConfig: {
              shape: "S63"
            }
          }
        },
        Sa0: {
          type: "structure",
          required: [
            "MaxRuntimeInSeconds"
          ],
          members: {
            MaxRuntimeInSeconds: {
              type: "integer"
            }
          }
        },
        Sa6: {
          type: "structure",
          required: [
            "S3OutputLocation"
          ],
          members: {
            S3OutputLocation: {},
            KmsKeyId: {},
            PresetDeploymentType: {},
            PresetDeploymentConfig: {}
          }
        },
        Sac: {
          type: "structure",
          members: {
            ExecutionRole: {},
            SecurityGroups: {
              shape: "Sad"
            },
            SharingSettings: {
              type: "structure",
              members: {
                NotebookOutputOption: {},
                S3OutputPath: {},
                S3KmsKeyId: {}
              }
            },
            JupyterServerAppSettings: {
              shape: "Sag"
            },
            KernelGatewayAppSettings: {
              shape: "Sal"
            },
            TensorBoardAppSettings: {
              type: "structure",
              members: {
                DefaultResourceSpec: {
                  shape: "S4i"
                }
              }
            },
            RStudioServerProAppSettings: {
              type: "structure",
              members: {
                AccessStatus: {},
                UserGroup: {}
              }
            },
            RSessionAppSettings: {
              type: "structure",
              members: {
                DefaultResourceSpec: {
                  shape: "S4i"
                },
                CustomImages: {
                  shape: "Sam"
                }
              }
            },
            CanvasAppSettings: {
              type: "structure",
              members: {
                TimeSeriesForecastingSettings: {
                  type: "structure",
                  members: {
                    Status: {},
                    AmazonForecastRoleArn: {}
                  }
                },
                ModelRegisterSettings: {
                  type: "structure",
                  members: {
                    Status: {},
                    CrossAccountModelRegisterRoleArn: {}
                  }
                },
                WorkspaceSettings: {
                  type: "structure",
                  members: {
                    S3ArtifactPath: {},
                    S3KmsKeyId: {}
                  }
                },
                IdentityProviderOAuthSettings: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      DataSourceName: {},
                      Status: {},
                      SecretArn: {}
                    }
                  }
                },
                DirectDeploySettings: {
                  type: "structure",
                  members: {
                    Status: {}
                  }
                },
                KendraSettings: {
                  type: "structure",
                  members: {
                    Status: {}
                  }
                }
              }
            },
            CodeEditorAppSettings: {
              type: "structure",
              members: {
                DefaultResourceSpec: {
                  shape: "S4i"
                },
                LifecycleConfigArns: {
                  shape: "Sah"
                }
              }
            },
            JupyterLabAppSettings: {
              type: "structure",
              members: {
                DefaultResourceSpec: {
                  shape: "S4i"
                },
                CustomImages: {
                  shape: "Sam"
                },
                LifecycleConfigArns: {
                  shape: "Sah"
                },
                CodeRepositories: {
                  shape: "Sai"
                }
              }
            },
            SpaceStorageSettings: {
              type: "structure",
              members: {
                DefaultEbsStorageSettings: {
                  type: "structure",
                  required: [
                    "DefaultEbsVolumeSizeInGb",
                    "MaximumEbsVolumeSizeInGb"
                  ],
                  members: {
                    DefaultEbsVolumeSizeInGb: {
                      type: "integer"
                    },
                    MaximumEbsVolumeSizeInGb: {
                      type: "integer"
                    }
                  }
                }
              }
            },
            DefaultLandingUri: {},
            StudioWebPortal: {},
            CustomPosixUserConfig: {
              type: "structure",
              required: [
                "Uid",
                "Gid"
              ],
              members: {
                Uid: {
                  type: "long"
                },
                Gid: {
                  type: "long"
                }
              }
            },
            CustomFileSystemConfigs: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  EFSFileSystemConfig: {
                    type: "structure",
                    required: [
                      "FileSystemId"
                    ],
                    members: {
                      FileSystemId: {},
                      FileSystemPath: {}
                    }
                  }
                },
                union: true
              }
            }
          }
        },
        Sad: {
          type: "list",
          member: {}
        },
        Sag: {
          type: "structure",
          members: {
            DefaultResourceSpec: {
              shape: "S4i"
            },
            LifecycleConfigArns: {
              shape: "Sah"
            },
            CodeRepositories: {
              shape: "Sai"
            }
          }
        },
        Sah: {
          type: "list",
          member: {}
        },
        Sai: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "RepositoryUrl"
            ],
            members: {
              RepositoryUrl: {}
            }
          }
        },
        Sal: {
          type: "structure",
          members: {
            DefaultResourceSpec: {
              shape: "S4i"
            },
            CustomImages: {
              shape: "Sam"
            },
            LifecycleConfigArns: {
              shape: "Sah"
            }
          }
        },
        Sam: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ImageName",
              "AppImageConfigName"
            ],
            members: {
              ImageName: {},
              ImageVersionNumber: {
                type: "integer"
              },
              AppImageConfigName: {}
            }
          }
        },
        Sbj: {
          type: "structure",
          members: {
            SecurityGroupIds: {
              shape: "Sbk"
            },
            RStudioServerProDomainSettings: {
              type: "structure",
              required: [
                "DomainExecutionRoleArn"
              ],
              members: {
                DomainExecutionRoleArn: {},
                RStudioConnectUrl: {},
                RStudioPackageManagerUrl: {},
                DefaultResourceSpec: {
                  shape: "S4i"
                }
              }
            },
            ExecutionRoleIdentityConfig: {},
            DockerSettings: {
              shape: "Sbn"
            }
          }
        },
        Sbk: {
          type: "list",
          member: {}
        },
        Sbn: {
          type: "structure",
          members: {
            EnableDockerAccess: {},
            VpcOnlyTrustedAccounts: {
              type: "list",
              member: {}
            }
          }
        },
        Sbt: {
          type: "structure",
          members: {
            ExecutionRole: {},
            SecurityGroups: {
              shape: "Sad"
            },
            JupyterServerAppSettings: {
              shape: "Sag"
            },
            KernelGatewayAppSettings: {
              shape: "Sal"
            }
          }
        },
        Sby: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ModelHandle",
              "EdgePackagingJobName"
            ],
            members: {
              ModelHandle: {},
              EdgePackagingJobName: {}
            }
          }
        },
        Sc0: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "StageName",
              "DeviceSelectionConfig"
            ],
            members: {
              StageName: {},
              DeviceSelectionConfig: {
                shape: "Sc2"
              },
              DeploymentConfig: {
                shape: "Sc7"
              }
            }
          }
        },
        Sc2: {
          type: "structure",
          required: [
            "DeviceSubsetType"
          ],
          members: {
            DeviceSubsetType: {},
            Percentage: {
              type: "integer"
            },
            DeviceNames: {
              shape: "Sc5"
            },
            DeviceNameContains: {}
          }
        },
        Sc5: {
          type: "list",
          member: {}
        },
        Sc7: {
          type: "structure",
          required: [
            "FailureHandlingPolicy"
          ],
          members: {
            FailureHandlingPolicy: {}
          }
        },
        Scg: {
          type: "structure",
          members: {
            BlueGreenUpdatePolicy: {
              type: "structure",
              required: [
                "TrafficRoutingConfiguration"
              ],
              members: {
                TrafficRoutingConfiguration: {
                  type: "structure",
                  required: [
                    "Type",
                    "WaitIntervalInSeconds"
                  ],
                  members: {
                    Type: {},
                    WaitIntervalInSeconds: {
                      type: "integer"
                    },
                    CanarySize: {
                      shape: "Scl"
                    },
                    LinearStepSize: {
                      shape: "Scl"
                    }
                  }
                },
                TerminationWaitInSeconds: {
                  type: "integer"
                },
                MaximumExecutionTimeoutInSeconds: {
                  type: "integer"
                }
              }
            },
            RollingUpdatePolicy: {
              type: "structure",
              required: [
                "MaximumBatchSize",
                "WaitIntervalInSeconds"
              ],
              members: {
                MaximumBatchSize: {
                  shape: "Scl"
                },
                WaitIntervalInSeconds: {
                  type: "integer"
                },
                MaximumExecutionTimeoutInSeconds: {
                  type: "integer"
                },
                RollbackMaximumBatchSize: {
                  shape: "Scl"
                }
              }
            },
            AutoRollbackConfiguration: {
              type: "structure",
              members: {
                Alarms: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      AlarmName: {}
                    }
                  }
                }
              }
            }
          }
        },
        Scl: {
          type: "structure",
          required: [
            "Type",
            "Value"
          ],
          members: {
            Type: {},
            Value: {
              type: "integer"
            }
          }
        },
        Scy: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "VariantName"
            ],
            members: {
              VariantName: {},
              ModelName: {},
              InitialInstanceCount: {
                type: "integer"
              },
              InstanceType: {},
              InitialVariantWeight: {
                type: "float"
              },
              AcceleratorType: {},
              CoreDumpConfig: {
                type: "structure",
                required: [
                  "DestinationS3Uri"
                ],
                members: {
                  DestinationS3Uri: {},
                  KmsKeyId: {}
                }
              },
              ServerlessConfig: {
                shape: "Sd6"
              },
              VolumeSizeInGB: {
                type: "integer"
              },
              ModelDataDownloadTimeoutInSeconds: {
                type: "integer"
              },
              ContainerStartupHealthCheckTimeoutInSeconds: {
                type: "integer"
              },
              EnableSSMAccess: {
                type: "boolean"
              },
              ManagedInstanceScaling: {
                shape: "Sde"
              },
              RoutingConfig: {
                shape: "Sdi"
              }
            }
          }
        },
        Sd6: {
          type: "structure",
          required: [
            "MemorySizeInMB",
            "MaxConcurrency"
          ],
          members: {
            MemorySizeInMB: {
              type: "integer"
            },
            MaxConcurrency: {
              type: "integer"
            },
            ProvisionedConcurrency: {
              type: "integer"
            }
          }
        },
        Sde: {
          type: "structure",
          members: {
            Status: {},
            MinInstanceCount: {
              type: "integer"
            },
            MaxInstanceCount: {
              type: "integer"
            }
          }
        },
        Sdi: {
          type: "structure",
          required: [
            "RoutingStrategy"
          ],
          members: {
            RoutingStrategy: {}
          }
        },
        Sdk: {
          type: "structure",
          required: [
            "InitialSamplingPercentage",
            "DestinationS3Uri",
            "CaptureOptions"
          ],
          members: {
            EnableCapture: {
              type: "boolean"
            },
            InitialSamplingPercentage: {
              type: "integer"
            },
            DestinationS3Uri: {},
            KmsKeyId: {},
            CaptureOptions: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "CaptureMode"
                ],
                members: {
                  CaptureMode: {}
                }
              }
            },
            CaptureContentTypeHeader: {
              shape: "Sdq"
            }
          }
        },
        Sdq: {
          type: "structure",
          members: {
            CsvContentTypes: {
              type: "list",
              member: {}
            },
            JsonContentTypes: {
              type: "list",
              member: {}
            }
          }
        },
        Sdv: {
          type: "structure",
          required: [
            "OutputConfig"
          ],
          members: {
            ClientConfig: {
              type: "structure",
              members: {
                MaxConcurrentInvocationsPerInstance: {
                  type: "integer"
                }
              }
            },
            OutputConfig: {
              type: "structure",
              members: {
                KmsKeyId: {},
                S3OutputPath: {},
                NotificationConfig: {
                  type: "structure",
                  members: {
                    SuccessTopic: {},
                    ErrorTopic: {},
                    IncludeInferenceResponseIn: {
                      type: "list",
                      member: {}
                    }
                  }
                },
                S3FailurePath: {}
              }
            }
          }
        },
        Se3: {
          type: "structure",
          members: {
            ClarifyExplainerConfig: {
              type: "structure",
              required: [
                "ShapConfig"
              ],
              members: {
                EnableExplanations: {},
                InferenceConfig: {
                  type: "structure",
                  members: {
                    FeaturesAttribute: {},
                    ContentTemplate: {},
                    MaxRecordCount: {
                      type: "integer"
                    },
                    MaxPayloadInMB: {
                      type: "integer"
                    },
                    ProbabilityIndex: {
                      type: "integer"
                    },
                    LabelIndex: {
                      type: "integer"
                    },
                    ProbabilityAttribute: {},
                    LabelAttribute: {},
                    LabelHeaders: {
                      type: "list",
                      member: {}
                    },
                    FeatureHeaders: {
                      type: "list",
                      member: {}
                    },
                    FeatureTypes: {
                      type: "list",
                      member: {}
                    }
                  }
                },
                ShapConfig: {
                  type: "structure",
                  required: [
                    "ShapBaselineConfig"
                  ],
                  members: {
                    ShapBaselineConfig: {
                      type: "structure",
                      members: {
                        MimeType: {},
                        ShapBaseline: {},
                        ShapBaselineUri: {}
                      }
                    },
                    NumberOfSamples: {
                      type: "integer"
                    },
                    UseLogit: {
                      type: "boolean"
                    },
                    Seed: {
                      type: "integer"
                    },
                    TextConfig: {
                      type: "structure",
                      required: [
                        "Language",
                        "Granularity"
                      ],
                      members: {
                        Language: {},
                        Granularity: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sf2: {
          type: "list",
          member: {
            shape: "Sf3"
          }
        },
        Sf3: {
          type: "structure",
          required: [
            "FeatureName",
            "FeatureType"
          ],
          members: {
            FeatureName: {},
            FeatureType: {},
            CollectionType: {},
            CollectionConfig: {
              type: "structure",
              members: {
                VectorConfig: {
                  type: "structure",
                  required: [
                    "Dimension"
                  ],
                  members: {
                    Dimension: {
                      type: "integer"
                    }
                  }
                }
              },
              union: true
            }
          }
        },
        Sf9: {
          type: "structure",
          members: {
            SecurityConfig: {
              type: "structure",
              members: {
                KmsKeyId: {}
              }
            },
            EnableOnlineStore: {
              type: "boolean"
            },
            TtlDuration: {
              shape: "Sfb"
            },
            StorageType: {}
          }
        },
        Sfb: {
          type: "structure",
          members: {
            Unit: {},
            Value: {
              type: "integer"
            }
          }
        },
        Sff: {
          type: "structure",
          required: [
            "S3StorageConfig"
          ],
          members: {
            S3StorageConfig: {
              type: "structure",
              required: [
                "S3Uri"
              ],
              members: {
                S3Uri: {},
                KmsKeyId: {},
                ResolvedOutputS3Uri: {}
              }
            },
            DisableGlueTableCreation: {
              type: "boolean"
            },
            DataCatalogConfig: {
              type: "structure",
              required: [
                "TableName",
                "Catalog",
                "Database"
              ],
              members: {
                TableName: {},
                Catalog: {},
                Database: {}
              }
            },
            TableFormat: {}
          }
        },
        Sfu: {
          type: "structure",
          required: [
            "AwsManagedHumanLoopRequestSource"
          ],
          members: {
            AwsManagedHumanLoopRequestSource: {}
          }
        },
        Sfw: {
          type: "structure",
          required: [
            "HumanLoopActivationConditionsConfig"
          ],
          members: {
            HumanLoopActivationConditionsConfig: {
              type: "structure",
              required: [
                "HumanLoopActivationConditions"
              ],
              members: {
                HumanLoopActivationConditions: {
                  jsonvalue: true
                }
              }
            }
          }
        },
        Sfz: {
          type: "structure",
          required: [
            "WorkteamArn",
            "HumanTaskUiArn",
            "TaskTitle",
            "TaskDescription",
            "TaskCount"
          ],
          members: {
            WorkteamArn: {},
            HumanTaskUiArn: {},
            TaskTitle: {},
            TaskDescription: {},
            TaskCount: {
              type: "integer"
            },
            TaskAvailabilityLifetimeInSeconds: {
              type: "integer"
            },
            TaskTimeLimitInSeconds: {
              type: "integer"
            },
            TaskKeywords: {
              type: "list",
              member: {}
            },
            PublicWorkforceTaskPrice: {
              shape: "Sg9"
            }
          }
        },
        Sg9: {
          type: "structure",
          members: {
            AmountInUsd: {
              type: "structure",
              members: {
                Dollars: {
                  type: "integer"
                },
                Cents: {
                  type: "integer"
                },
                TenthFractionsOfACent: {
                  type: "integer"
                }
              }
            }
          }
        },
        Sge: {
          type: "structure",
          required: [
            "S3OutputPath"
          ],
          members: {
            S3OutputPath: {},
            KmsKeyId: {}
          }
        },
        Sgl: {
          type: "list",
          member: {}
        },
        Sgn: {
          type: "structure",
          members: {
            S3OutputPath: {}
          }
        },
        Sgt: {
          type: "structure",
          required: [
            "Content"
          ],
          members: {
            Content: {}
          }
        },
        Sgy: {
          type: "structure",
          required: [
            "Strategy",
            "ResourceLimits"
          ],
          members: {
            Strategy: {},
            StrategyConfig: {
              type: "structure",
              members: {
                HyperbandStrategyConfig: {
                  type: "structure",
                  members: {
                    MinResource: {
                      type: "integer"
                    },
                    MaxResource: {
                      type: "integer"
                    }
                  }
                }
              }
            },
            HyperParameterTuningJobObjective: {
              shape: "S2p"
            },
            ResourceLimits: {
              shape: "Sh4"
            },
            ParameterRanges: {
              shape: "Sh8"
            },
            TrainingJobEarlyStoppingType: {},
            TuningJobCompletionCriteria: {
              type: "structure",
              members: {
                TargetObjectiveMetricValue: {
                  type: "float"
                },
                BestObjectiveNotImproving: {
                  type: "structure",
                  members: {
                    MaxNumberOfTrainingJobsNotImproving: {
                      type: "integer"
                    }
                  }
                },
                ConvergenceDetected: {
                  type: "structure",
                  members: {
                    CompleteOnConvergence: {}
                  }
                }
              }
            },
            RandomSeed: {
              type: "integer"
            }
          }
        },
        Sh4: {
          type: "structure",
          required: [
            "MaxParallelTrainingJobs"
          ],
          members: {
            MaxNumberOfTrainingJobs: {
              type: "integer"
            },
            MaxParallelTrainingJobs: {
              type: "integer"
            },
            MaxRuntimeInSeconds: {
              type: "integer"
            }
          }
        },
        Sh8: {
          type: "structure",
          members: {
            IntegerParameterRanges: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name",
                  "MinValue",
                  "MaxValue"
                ],
                members: {
                  Name: {},
                  MinValue: {},
                  MaxValue: {},
                  ScalingType: {}
                }
              }
            },
            ContinuousParameterRanges: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name",
                  "MinValue",
                  "MaxValue"
                ],
                members: {
                  Name: {},
                  MinValue: {},
                  MaxValue: {},
                  ScalingType: {}
                }
              }
            },
            CategoricalParameterRanges: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name",
                  "Values"
                ],
                members: {
                  Name: {},
                  Values: {
                    shape: "S29"
                  }
                }
              }
            },
            AutoParameters: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name",
                  "ValueHint"
                ],
                members: {
                  Name: {},
                  ValueHint: {}
                }
              }
            }
          }
        },
        Shr: {
          type: "structure",
          required: [
            "AlgorithmSpecification",
            "RoleArn",
            "OutputDataConfig",
            "StoppingCondition"
          ],
          members: {
            DefinitionName: {},
            TuningObjective: {
              shape: "S2p"
            },
            HyperParameterRanges: {
              shape: "Sh8"
            },
            StaticHyperParameters: {
              shape: "S2w"
            },
            AlgorithmSpecification: {
              type: "structure",
              required: [
                "TrainingInputMode"
              ],
              members: {
                TrainingImage: {},
                TrainingInputMode: {},
                AlgorithmName: {},
                MetricDefinitions: {
                  shape: "S2e"
                }
              }
            },
            RoleArn: {},
            InputDataConfig: {
              shape: "S2y"
            },
            VpcConfig: {
              shape: "S63"
            },
            OutputDataConfig: {
              shape: "S3g"
            },
            ResourceConfig: {
              shape: "S3j"
            },
            HyperParameterTuningResourceConfig: {
              type: "structure",
              members: {
                InstanceType: {},
                InstanceCount: {
                  type: "integer"
                },
                VolumeSizeInGB: {
                  type: "integer"
                },
                VolumeKmsKeyId: {},
                AllocationStrategy: {},
                InstanceConfigs: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "InstanceType",
                      "InstanceCount",
                      "VolumeSizeInGB"
                    ],
                    members: {
                      InstanceType: {},
                      InstanceCount: {
                        type: "integer"
                      },
                      VolumeSizeInGB: {
                        type: "integer"
                      }
                    }
                  }
                }
              }
            },
            StoppingCondition: {
              shape: "S3p"
            },
            EnableNetworkIsolation: {
              type: "boolean"
            },
            EnableInterContainerTrafficEncryption: {
              type: "boolean"
            },
            EnableManagedSpotTraining: {
              type: "boolean"
            },
            CheckpointConfig: {
              shape: "Si1"
            },
            RetryStrategy: {
              shape: "Si2"
            },
            Environment: {
              type: "map",
              key: {},
              value: {}
            }
          }
        },
        Si1: {
          type: "structure",
          required: [
            "S3Uri"
          ],
          members: {
            S3Uri: {},
            LocalPath: {}
          }
        },
        Si2: {
          type: "structure",
          required: [
            "MaximumRetryAttempts"
          ],
          members: {
            MaximumRetryAttempts: {
              type: "integer"
            }
          }
        },
        Si7: {
          type: "list",
          member: {
            shape: "Shr"
          }
        },
        Si8: {
          type: "structure",
          required: [
            "ParentHyperParameterTuningJobs",
            "WarmStartType"
          ],
          members: {
            ParentHyperParameterTuningJobs: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  HyperParameterTuningJobName: {}
                }
              }
            },
            WarmStartType: {}
          }
        },
        Sic: {
          type: "structure",
          required: [
            "Mode"
          ],
          members: {
            Mode: {}
          }
        },
        Sin: {
          type: "list",
          member: {}
        },
        Siz: {
          type: "structure",
          required: [
            "ComputeResourceRequirements"
          ],
          members: {
            ModelName: {},
            Container: {
              type: "structure",
              members: {
                Image: {},
                ArtifactUrl: {},
                Environment: {
                  shape: "Sz"
                }
              }
            },
            StartupParameters: {
              shape: "Sj1"
            },
            ComputeResourceRequirements: {
              shape: "Sj2"
            }
          }
        },
        Sj1: {
          type: "structure",
          members: {
            ModelDataDownloadTimeoutInSeconds: {
              type: "integer"
            },
            ContainerStartupHealthCheckTimeoutInSeconds: {
              type: "integer"
            }
          }
        },
        Sj2: {
          type: "structure",
          required: [
            "MinMemoryRequiredInMb"
          ],
          members: {
            NumberOfCpuCoresRequired: {
              type: "float"
            },
            NumberOfAcceleratorDevicesRequired: {
              type: "float"
            },
            MinMemoryRequiredInMb: {
              type: "integer"
            },
            MaxMemoryRequiredInMb: {
              type: "integer"
            }
          }
        },
        Sj6: {
          type: "structure",
          required: [
            "CopyCount"
          ],
          members: {
            CopyCount: {
              type: "integer"
            }
          }
        },
        Sjd: {
          type: "structure",
          members: {
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            }
          }
        },
        Sjg: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ModelName",
              "VariantName",
              "InfrastructureConfig"
            ],
            members: {
              ModelName: {},
              VariantName: {},
              InfrastructureConfig: {
                shape: "Sjj"
              }
            }
          }
        },
        Sjj: {
          type: "structure",
          required: [
            "InfrastructureType",
            "RealTimeInferenceConfig"
          ],
          members: {
            InfrastructureType: {},
            RealTimeInferenceConfig: {
              type: "structure",
              required: [
                "InstanceType",
                "InstanceCount"
              ],
              members: {
                InstanceType: {},
                InstanceCount: {
                  type: "integer"
                }
              }
            }
          }
        },
        Sjo: {
          type: "structure",
          required: [
            "Destination"
          ],
          members: {
            Destination: {},
            KmsKey: {},
            ContentType: {
              shape: "Sdq"
            }
          }
        },
        Sjp: {
          type: "structure",
          required: [
            "SourceModelVariantName",
            "ShadowModelVariants"
          ],
          members: {
            SourceModelVariantName: {},
            ShadowModelVariants: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "ShadowModelVariantName",
                  "SamplingPercentage"
                ],
                members: {
                  ShadowModelVariantName: {},
                  SamplingPercentage: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        Sjx: {
          type: "structure",
          members: {
            ModelPackageVersionArn: {},
            ModelName: {},
            JobDurationInSeconds: {
              type: "integer"
            },
            TrafficPattern: {
              type: "structure",
              members: {
                TrafficType: {},
                Phases: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      InitialNumberOfUsers: {
                        type: "integer"
                      },
                      SpawnRate: {
                        type: "integer"
                      },
                      DurationInSeconds: {
                        type: "integer"
                      }
                    }
                  }
                },
                Stairs: {
                  type: "structure",
                  members: {
                    DurationInSeconds: {
                      type: "integer"
                    },
                    NumberOfSteps: {
                      type: "integer"
                    },
                    UsersPerStep: {
                      type: "integer"
                    }
                  }
                }
              }
            },
            ResourceLimit: {
              type: "structure",
              members: {
                MaxNumberOfTests: {
                  type: "integer"
                },
                MaxParallelOfTests: {
                  type: "integer"
                }
              }
            },
            EndpointConfigurations: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  InstanceType: {},
                  ServerlessConfig: {
                    shape: "Sd6"
                  },
                  InferenceSpecificationName: {},
                  EnvironmentParameterRanges: {
                    type: "structure",
                    members: {
                      CategoricalParameterRanges: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "Name",
                            "Value"
                          ],
                          members: {
                            Name: {},
                            Value: {
                              type: "list",
                              member: {}
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            VolumeKmsKeyId: {},
            ContainerConfig: {
              type: "structure",
              members: {
                Domain: {},
                Task: {},
                Framework: {},
                FrameworkVersion: {},
                PayloadConfig: {
                  type: "structure",
                  members: {
                    SamplePayloadUrl: {},
                    SupportedContentTypes: {
                      type: "list",
                      member: {}
                    }
                  }
                },
                NearestModelName: {},
                SupportedInstanceTypes: {
                  type: "list",
                  member: {}
                },
                SupportedEndpointType: {},
                DataInputConfig: {},
                SupportedResponseMIMETypes: {
                  type: "list",
                  member: {}
                }
              }
            },
            Endpoints: {
              type: "list",
              member: {
                shape: "Skw"
              }
            },
            VpcConfig: {
              type: "structure",
              required: [
                "SecurityGroupIds",
                "Subnets"
              ],
              members: {
                SecurityGroupIds: {
                  type: "list",
                  member: {}
                },
                Subnets: {
                  type: "list",
                  member: {}
                }
              }
            }
          }
        },
        Skw: {
          type: "structure",
          members: {
            EndpointName: {}
          }
        },
        Sl3: {
          type: "structure",
          members: {
            MaxInvocations: {
              type: "integer"
            },
            ModelLatencyThresholds: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Percentile: {},
                  ValueInMilliseconds: {
                    type: "integer"
                  }
                }
              }
            },
            FlatInvocations: {}
          }
        },
        Slf: {
          type: "structure",
          required: [
            "DataSource"
          ],
          members: {
            DataSource: {
              type: "structure",
              members: {
                S3DataSource: {
                  type: "structure",
                  required: [
                    "ManifestS3Uri"
                  ],
                  members: {
                    ManifestS3Uri: {}
                  }
                },
                SnsDataSource: {
                  type: "structure",
                  required: [
                    "SnsTopicArn"
                  ],
                  members: {
                    SnsTopicArn: {}
                  }
                }
              }
            },
            DataAttributes: {
              type: "structure",
              members: {
                ContentClassifiers: {
                  type: "list",
                  member: {}
                }
              }
            }
          }
        },
        Slm: {
          type: "structure",
          required: [
            "S3OutputPath"
          ],
          members: {
            S3OutputPath: {},
            KmsKeyId: {},
            SnsTopicArn: {}
          }
        },
        Sln: {
          type: "structure",
          members: {
            MaxHumanLabeledObjectCount: {
              type: "integer"
            },
            MaxPercentageOfInputDatasetLabeled: {
              type: "integer"
            }
          }
        },
        Slq: {
          type: "structure",
          required: [
            "LabelingJobAlgorithmSpecificationArn"
          ],
          members: {
            LabelingJobAlgorithmSpecificationArn: {},
            InitialActiveLearningModelArn: {},
            LabelingJobResourceConfig: {
              type: "structure",
              members: {
                VolumeKmsKeyId: {},
                VpcConfig: {
                  shape: "S63"
                }
              }
            }
          }
        },
        Slu: {
          type: "structure",
          required: [
            "WorkteamArn",
            "UiConfig",
            "PreHumanTaskLambdaArn",
            "TaskTitle",
            "TaskDescription",
            "NumberOfHumanWorkersPerDataObject",
            "TaskTimeLimitInSeconds",
            "AnnotationConsolidationConfig"
          ],
          members: {
            WorkteamArn: {},
            UiConfig: {
              type: "structure",
              members: {
                UiTemplateS3Uri: {},
                HumanTaskUiArn: {}
              }
            },
            PreHumanTaskLambdaArn: {},
            TaskKeywords: {
              type: "list",
              member: {}
            },
            TaskTitle: {},
            TaskDescription: {},
            NumberOfHumanWorkersPerDataObject: {
              type: "integer"
            },
            TaskTimeLimitInSeconds: {
              type: "integer"
            },
            TaskAvailabilityLifetimeInSeconds: {
              type: "integer"
            },
            MaxConcurrentTaskCount: {
              type: "integer"
            },
            AnnotationConsolidationConfig: {
              type: "structure",
              required: [
                "AnnotationConsolidationLambdaArn"
              ],
              members: {
                AnnotationConsolidationLambdaArn: {}
              }
            },
            PublicWorkforceTaskPrice: {
              shape: "Sg9"
            }
          }
        },
        Sm9: {
          type: "structure",
          members: {
            ContainerHostname: {},
            Image: {},
            ImageConfig: {
              type: "structure",
              required: [
                "RepositoryAccessMode"
              ],
              members: {
                RepositoryAccessMode: {},
                RepositoryAuthConfig: {
                  type: "structure",
                  required: [
                    "RepositoryCredentialsProviderArn"
                  ],
                  members: {
                    RepositoryCredentialsProviderArn: {}
                  }
                }
              }
            },
            Mode: {},
            ModelDataUrl: {},
            ModelDataSource: {
              type: "structure",
              members: {
                S3DataSource: {
                  type: "structure",
                  required: [
                    "S3Uri",
                    "S3DataType",
                    "CompressionType"
                  ],
                  members: {
                    S3Uri: {},
                    S3DataType: {},
                    CompressionType: {},
                    ModelAccessConfig: {
                      shape: "S7m"
                    }
                  }
                }
              }
            },
            Environment: {
              shape: "Sz"
            },
            ModelPackageName: {},
            InferenceSpecificationName: {},
            MultiModelConfig: {
              type: "structure",
              members: {
                ModelCacheSetting: {}
              }
            }
          }
        },
        Smn: {
          type: "list",
          member: {
            shape: "Sm9"
          }
        },
        Smo: {
          type: "structure",
          required: [
            "Mode"
          ],
          members: {
            Mode: {}
          }
        },
        Sms: {
          type: "structure",
          members: {
            BaseliningJobName: {},
            ConstraintsResource: {
              shape: "S8z"
            }
          }
        },
        Smt: {
          type: "structure",
          required: [
            "ImageUri",
            "ConfigUri"
          ],
          members: {
            ImageUri: {},
            ConfigUri: {},
            Environment: {
              shape: "S97"
            }
          }
        },
        Smu: {
          type: "structure",
          required: [
            "GroundTruthS3Input"
          ],
          members: {
            EndpointInput: {
              shape: "S9b"
            },
            BatchTransformInput: {
              shape: "S9i"
            },
            GroundTruthS3Input: {
              shape: "Smv"
            }
          }
        },
        Smv: {
          type: "structure",
          members: {
            S3Uri: {}
          }
        },
        Smy: {
          type: "structure",
          members: {
            KmsKeyId: {}
          }
        },
        Smz: {
          type: "string",
          sensitive: true
        },
        Sn5: {
          type: "structure",
          required: [
            "S3OutputPath"
          ],
          members: {
            S3OutputPath: {}
          }
        },
        Sn9: {
          type: "structure",
          members: {
            BaseliningJobName: {},
            ConstraintsResource: {
              shape: "S8z"
            }
          }
        },
        Sna: {
          type: "structure",
          required: [
            "ImageUri",
            "ConfigUri"
          ],
          members: {
            ImageUri: {},
            ConfigUri: {},
            Environment: {
              shape: "S97"
            }
          }
        },
        Snb: {
          type: "structure",
          members: {
            EndpointInput: {
              shape: "S9b"
            },
            BatchTransformInput: {
              shape: "S9i"
            }
          }
        },
        Sne: {
          type: "structure",
          required: [
            "ValidationRole",
            "ValidationProfiles"
          ],
          members: {
            ValidationRole: {},
            ValidationProfiles: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "ProfileName",
                  "TransformJobDefinition"
                ],
                members: {
                  ProfileName: {},
                  TransformJobDefinition: {
                    shape: "S3t"
                  }
                }
              }
            }
          }
        },
        Snh: {
          type: "structure",
          required: [
            "SourceAlgorithms"
          ],
          members: {
            SourceAlgorithms: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "AlgorithmName"
                ],
                members: {
                  ModelDataUrl: {},
                  AlgorithmName: {}
                }
              }
            }
          }
        },
        Snk: {
          type: "structure",
          members: {
            ModelQuality: {
              type: "structure",
              members: {
                Statistics: {
                  shape: "Snm"
                },
                Constraints: {
                  shape: "Snm"
                }
              }
            },
            ModelDataQuality: {
              type: "structure",
              members: {
                Statistics: {
                  shape: "Snm"
                },
                Constraints: {
                  shape: "Snm"
                }
              }
            },
            Bias: {
              type: "structure",
              members: {
                Report: {
                  shape: "Snm"
                },
                PreTrainingReport: {
                  shape: "Snm"
                },
                PostTrainingReport: {
                  shape: "Snm"
                }
              }
            },
            Explainability: {
              type: "structure",
              members: {
                Report: {
                  shape: "Snm"
                }
              }
            }
          }
        },
        Snm: {
          type: "structure",
          required: [
            "ContentType",
            "S3Uri"
          ],
          members: {
            ContentType: {},
            ContentDigest: {},
            S3Uri: {}
          }
        },
        Snr: {
          type: "map",
          key: {},
          value: {}
        },
        Snu: {
          type: "structure",
          members: {
            Bias: {
              type: "structure",
              members: {
                ConfigFile: {
                  shape: "Snw"
                },
                PreTrainingConstraints: {
                  shape: "Snm"
                },
                PostTrainingConstraints: {
                  shape: "Snm"
                }
              }
            },
            Explainability: {
              type: "structure",
              members: {
                Constraints: {
                  shape: "Snm"
                },
                ConfigFile: {
                  shape: "Snw"
                }
              }
            },
            ModelQuality: {
              type: "structure",
              members: {
                Statistics: {
                  shape: "Snm"
                },
                Constraints: {
                  shape: "Snm"
                }
              }
            },
            ModelDataQuality: {
              type: "structure",
              members: {
                Statistics: {
                  shape: "Snm"
                },
                Constraints: {
                  shape: "Snm"
                }
              }
            }
          }
        },
        Snw: {
          type: "structure",
          required: [
            "S3Uri"
          ],
          members: {
            ContentType: {},
            ContentDigest: {},
            S3Uri: {}
          }
        },
        So0: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Containers"
            ],
            members: {
              Name: {},
              Description: {},
              Containers: {
                shape: "Ss"
              },
              SupportedTransformInstanceTypes: {
                shape: "S1a"
              },
              SupportedRealtimeInferenceInstanceTypes: {
                shape: "S1c"
              },
              SupportedContentTypes: {
                shape: "S1e"
              },
              SupportedResponseMIMETypes: {
                shape: "S1g"
              }
            }
          }
        },
        So8: {
          type: "structure",
          members: {
            BaseliningJobName: {},
            ConstraintsResource: {
              shape: "S8z"
            }
          }
        },
        So9: {
          type: "structure",
          required: [
            "ImageUri"
          ],
          members: {
            ImageUri: {},
            ContainerEntrypoint: {
              shape: "S93"
            },
            ContainerArguments: {
              shape: "S95"
            },
            RecordPreprocessorSourceUri: {},
            PostAnalyticsProcessorSourceUri: {},
            ProblemType: {},
            Environment: {
              shape: "S97"
            }
          }
        },
        Sob: {
          type: "structure",
          required: [
            "GroundTruthS3Input"
          ],
          members: {
            EndpointInput: {
              shape: "S9b"
            },
            BatchTransformInput: {
              shape: "S9i"
            },
            GroundTruthS3Input: {
              shape: "Smv"
            }
          }
        },
        Sof: {
          type: "structure",
          members: {
            ScheduleConfig: {
              type: "structure",
              required: [
                "ScheduleExpression"
              ],
              members: {
                ScheduleExpression: {},
                DataAnalysisStartTime: {},
                DataAnalysisEndTime: {}
              }
            },
            MonitoringJobDefinition: {
              type: "structure",
              required: [
                "MonitoringInputs",
                "MonitoringOutputConfig",
                "MonitoringResources",
                "MonitoringAppSpecification",
                "RoleArn"
              ],
              members: {
                BaselineConfig: {
                  type: "structure",
                  members: {
                    BaseliningJobName: {},
                    ConstraintsResource: {
                      shape: "S8z"
                    },
                    StatisticsResource: {
                      shape: "S90"
                    }
                  }
                },
                MonitoringInputs: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      EndpointInput: {
                        shape: "S9b"
                      },
                      BatchTransformInput: {
                        shape: "S9i"
                      }
                    }
                  }
                },
                MonitoringOutputConfig: {
                  shape: "S9o"
                },
                MonitoringResources: {
                  shape: "S9u"
                },
                MonitoringAppSpecification: {
                  type: "structure",
                  required: [
                    "ImageUri"
                  ],
                  members: {
                    ImageUri: {},
                    ContainerEntrypoint: {
                      shape: "S93"
                    },
                    ContainerArguments: {
                      shape: "S95"
                    },
                    RecordPreprocessorSourceUri: {},
                    PostAnalyticsProcessorSourceUri: {}
                  }
                },
                StoppingCondition: {
                  shape: "Sa0"
                },
                Environment: {
                  shape: "S97"
                },
                NetworkConfig: {
                  shape: "Son"
                },
                RoleArn: {}
              }
            },
            MonitoringJobDefinitionName: {},
            MonitoringType: {}
          }
        },
        Son: {
          type: "structure",
          members: {
            EnableInterContainerTrafficEncryption: {
              type: "boolean"
            },
            EnableNetworkIsolation: {
              type: "boolean"
            },
            VpcConfig: {
              shape: "S63"
            }
          }
        },
        Sow: {
          type: "list",
          member: {}
        },
        Soz: {
          type: "list",
          member: {}
        },
        Sp2: {
          type: "structure",
          required: [
            "MinimumInstanceMetadataServiceVersion"
          ],
          members: {
            MinimumInstanceMetadataServiceVersion: {}
          }
        },
        Sp7: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Content: {}
            }
          }
        },
        Spf: {
          type: "structure",
          required: [
            "Bucket",
            "ObjectKey"
          ],
          members: {
            Bucket: {},
            ObjectKey: {},
            VersionId: {}
          }
        },
        Spl: {
          type: "structure",
          required: [
            "MaxParallelExecutionSteps"
          ],
          members: {
            MaxParallelExecutionSteps: {
              type: "integer"
            }
          }
        },
        Spy: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "InputName"
            ],
            members: {
              InputName: {},
              AppManaged: {
                type: "boolean"
              },
              S3Input: {
                type: "structure",
                required: [
                  "S3Uri",
                  "S3DataType"
                ],
                members: {
                  S3Uri: {},
                  LocalPath: {},
                  S3DataType: {},
                  S3InputMode: {},
                  S3DataDistributionType: {},
                  S3CompressionType: {}
                }
              },
              DatasetDefinition: {
                type: "structure",
                members: {
                  AthenaDatasetDefinition: {
                    type: "structure",
                    required: [
                      "Catalog",
                      "Database",
                      "QueryString",
                      "OutputS3Uri",
                      "OutputFormat"
                    ],
                    members: {
                      Catalog: {},
                      Database: {},
                      QueryString: {},
                      WorkGroup: {},
                      OutputS3Uri: {},
                      KmsKeyId: {},
                      OutputFormat: {},
                      OutputCompression: {}
                    }
                  },
                  RedshiftDatasetDefinition: {
                    type: "structure",
                    required: [
                      "ClusterId",
                      "Database",
                      "DbUser",
                      "QueryString",
                      "ClusterRoleArn",
                      "OutputS3Uri",
                      "OutputFormat"
                    ],
                    members: {
                      ClusterId: {},
                      Database: {},
                      DbUser: {},
                      QueryString: {},
                      ClusterRoleArn: {},
                      OutputS3Uri: {},
                      KmsKeyId: {},
                      OutputFormat: {},
                      OutputCompression: {}
                    }
                  },
                  LocalPath: {},
                  DataDistributionType: {},
                  InputMode: {}
                }
              }
            }
          }
        },
        Sql: {
          type: "structure",
          required: [
            "Outputs"
          ],
          members: {
            Outputs: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "OutputName"
                ],
                members: {
                  OutputName: {},
                  S3Output: {
                    type: "structure",
                    required: [
                      "S3Uri",
                      "LocalPath",
                      "S3UploadMode"
                    ],
                    members: {
                      S3Uri: {},
                      LocalPath: {},
                      S3UploadMode: {}
                    }
                  },
                  FeatureStoreOutput: {
                    type: "structure",
                    required: [
                      "FeatureGroupName"
                    ],
                    members: {
                      FeatureGroupName: {}
                    }
                  },
                  AppManaged: {
                    type: "boolean"
                  }
                }
              }
            },
            KmsKeyId: {}
          }
        },
        Sqq: {
          type: "structure",
          required: [
            "ClusterConfig"
          ],
          members: {
            ClusterConfig: {
              type: "structure",
              required: [
                "InstanceCount",
                "InstanceType",
                "VolumeSizeInGB"
              ],
              members: {
                InstanceCount: {
                  type: "integer"
                },
                InstanceType: {},
                VolumeSizeInGB: {
                  type: "integer"
                },
                VolumeKmsKeyId: {}
              }
            }
          }
        },
        Sqs: {
          type: "structure",
          required: [
            "MaxRuntimeInSeconds"
          ],
          members: {
            MaxRuntimeInSeconds: {
              type: "integer"
            }
          }
        },
        Squ: {
          type: "structure",
          required: [
            "ImageUri"
          ],
          members: {
            ImageUri: {},
            ContainerEntrypoint: {
              shape: "S93"
            },
            ContainerArguments: {
              type: "list",
              member: {}
            }
          }
        },
        Sqw: {
          type: "map",
          key: {},
          value: {}
        },
        Sqx: {
          type: "structure",
          members: {
            ExperimentName: {},
            TrialName: {},
            TrialComponentDisplayName: {},
            RunName: {}
          }
        },
        Sr2: {
          type: "structure",
          required: [
            "ProductId"
          ],
          members: {
            ProductId: {},
            ProvisioningArtifactId: {},
            PathId: {},
            ProvisioningParameters: {
              shape: "Sr4"
            }
          }
        },
        Sr4: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Src: {
          type: "structure",
          members: {
            JupyterServerAppSettings: {
              shape: "Sag"
            },
            KernelGatewayAppSettings: {
              shape: "Sal"
            },
            CodeEditorAppSettings: {
              type: "structure",
              members: {
                DefaultResourceSpec: {
                  shape: "S4i"
                }
              }
            },
            JupyterLabAppSettings: {
              type: "structure",
              members: {
                DefaultResourceSpec: {
                  shape: "S4i"
                },
                CodeRepositories: {
                  shape: "Sai"
                }
              }
            },
            AppType: {},
            SpaceStorageSettings: {
              shape: "Srf"
            },
            CustomFileSystems: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  EFSFileSystem: {
                    type: "structure",
                    required: [
                      "FileSystemId"
                    ],
                    members: {
                      FileSystemId: {}
                    }
                  }
                },
                union: true
              }
            }
          }
        },
        Srf: {
          type: "structure",
          members: {
            EbsStorageSettings: {
              type: "structure",
              required: [
                "EbsVolumeSizeInGb"
              ],
              members: {
                EbsVolumeSizeInGb: {
                  type: "integer"
                }
              }
            }
          }
        },
        Srk: {
          type: "structure",
          required: [
            "OwnerUserProfileName"
          ],
          members: {
            OwnerUserProfileName: {}
          }
        },
        Srl: {
          type: "structure",
          required: [
            "SharingType"
          ],
          members: {
            SharingType: {}
          }
        },
        Srw: {
          type: "structure",
          required: [
            "TrainingInputMode"
          ],
          members: {
            TrainingImage: {},
            AlgorithmName: {},
            TrainingInputMode: {},
            MetricDefinitions: {
              shape: "S2e"
            },
            EnableSageMakerMetricsTimeSeries: {
              type: "boolean"
            },
            ContainerEntrypoint: {
              type: "list",
              member: {}
            },
            ContainerArguments: {
              type: "list",
              member: {}
            },
            TrainingImageConfig: {
              type: "structure",
              required: [
                "TrainingRepositoryAccessMode"
              ],
              members: {
                TrainingRepositoryAccessMode: {},
                TrainingRepositoryAuthConfig: {
                  type: "structure",
                  required: [
                    "TrainingRepositoryCredentialsProviderArn"
                  ],
                  members: {
                    TrainingRepositoryCredentialsProviderArn: {}
                  }
                }
              }
            }
          }
        },
        Ss5: {
          type: "structure",
          required: [
            "S3OutputPath"
          ],
          members: {
            LocalPath: {},
            S3OutputPath: {},
            HookParameters: {
              type: "map",
              key: {},
              value: {}
            },
            CollectionConfigurations: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  CollectionName: {},
                  CollectionParameters: {
                    type: "map",
                    key: {},
                    value: {}
                  }
                }
              }
            }
          }
        },
        Ssd: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "RuleConfigurationName",
              "RuleEvaluatorImage"
            ],
            members: {
              RuleConfigurationName: {},
              LocalPath: {},
              S3OutputPath: {},
              RuleEvaluatorImage: {},
              InstanceType: {},
              VolumeSizeInGB: {
                type: "integer"
              },
              RuleParameters: {
                shape: "Ssg"
              }
            }
          }
        },
        Ssg: {
          type: "map",
          key: {},
          value: {}
        },
        Ssh: {
          type: "structure",
          required: [
            "S3OutputPath"
          ],
          members: {
            LocalPath: {},
            S3OutputPath: {}
          }
        },
        Ssi: {
          type: "structure",
          members: {
            S3OutputPath: {},
            ProfilingIntervalInMilliseconds: {
              type: "long"
            },
            ProfilingParameters: {
              shape: "Ssk"
            },
            DisableProfiler: {
              type: "boolean"
            }
          }
        },
        Ssk: {
          type: "map",
          key: {},
          value: {}
        },
        Ssm: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "RuleConfigurationName",
              "RuleEvaluatorImage"
            ],
            members: {
              RuleConfigurationName: {},
              LocalPath: {},
              S3OutputPath: {},
              RuleEvaluatorImage: {},
              InstanceType: {},
              VolumeSizeInGB: {
                type: "integer"
              },
              RuleParameters: {
                shape: "Ssg"
              }
            }
          }
        },
        Sso: {
          type: "map",
          key: {},
          value: {}
        },
        Ssr: {
          type: "structure",
          members: {
            EnableRemoteDebug: {
              type: "boolean"
            }
          }
        },
        Sst: {
          type: "structure",
          members: {
            EnableInfraCheck: {
              type: "boolean"
            }
          }
        },
        Ssz: {
          type: "structure",
          members: {
            InvocationsTimeoutInSeconds: {
              type: "integer"
            },
            InvocationsMaxRetries: {
              type: "integer"
            }
          }
        },
        St2: {
          type: "structure",
          required: [
            "DestinationS3Uri"
          ],
          members: {
            DestinationS3Uri: {},
            KmsKeyId: {},
            GenerateInferenceId: {
              type: "boolean"
            }
          }
        },
        St3: {
          type: "structure",
          members: {
            InputFilter: {},
            OutputFilter: {},
            JoinSource: {}
          }
        },
        Stb: {
          type: "structure",
          members: {
            PrimaryStatus: {},
            Message: {}
          }
        },
        Ste: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              StringValue: {},
              NumberValue: {
                type: "double"
              }
            }
          }
        },
        Sti: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "Value"
            ],
            members: {
              MediaType: {},
              Value: {}
            }
          }
        },
        Stt: {
          type: "structure",
          required: [
            "UserPool",
            "ClientId"
          ],
          members: {
            UserPool: {},
            ClientId: {}
          }
        },
        Stw: {
          type: "structure",
          required: [
            "ClientId",
            "ClientSecret",
            "Issuer",
            "AuthorizationEndpoint",
            "TokenEndpoint",
            "UserInfoEndpoint",
            "LogoutEndpoint",
            "JwksUri"
          ],
          members: {
            ClientId: {},
            ClientSecret: {
              type: "string",
              sensitive: true
            },
            Issuer: {},
            AuthorizationEndpoint: {},
            TokenEndpoint: {},
            UserInfoEndpoint: {},
            LogoutEndpoint: {},
            JwksUri: {}
          }
        },
        Stz: {
          type: "structure",
          required: [
            "Cidrs"
          ],
          members: {
            Cidrs: {
              type: "list",
              member: {}
            }
          }
        },
        Su3: {
          type: "structure",
          members: {
            VpcId: {},
            SecurityGroupIds: {
              shape: "Su5"
            },
            Subnets: {
              shape: "Su7"
            }
          }
        },
        Su5: {
          type: "list",
          member: {}
        },
        Su7: {
          type: "list",
          member: {}
        },
        Sud: {
          type: "list",
          member: {
            type: "structure",
            members: {
              CognitoMemberDefinition: {
                type: "structure",
                required: [
                  "UserPool",
                  "UserGroup",
                  "ClientId"
                ],
                members: {
                  UserPool: {},
                  UserGroup: {},
                  ClientId: {}
                }
              },
              OidcMemberDefinition: {
                type: "structure",
                members: {
                  Groups: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          }
        },
        Sul: {
          type: "structure",
          members: {
            NotificationTopicArn: {}
          }
        },
        Swt: {
          type: "structure",
          members: {
            UserProfileArn: {},
            UserProfileName: {},
            DomainId: {},
            IamIdentity: {
              type: "structure",
              members: {
                Arn: {},
                PrincipalId: {},
                SourceIdentity: {}
              }
            }
          }
        },
        Sx0: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Status"
            ],
            members: {
              Name: {},
              Status: {},
              FailureReason: {}
            }
          }
        },
        Sxe: {
          type: "list",
          member: {
            type: "structure",
            members: {
              PartialFailureMessage: {}
            }
          }
        },
        Sxg: {
          type: "structure",
          required: [
            "CandidateName",
            "ObjectiveStatus",
            "CandidateSteps",
            "CandidateStatus",
            "CreationTime",
            "LastModifiedTime"
          ],
          members: {
            CandidateName: {},
            FinalAutoMLJobObjectiveMetric: {
              type: "structure",
              required: [
                "MetricName",
                "Value"
              ],
              members: {
                Type: {},
                MetricName: {},
                Value: {
                  type: "float"
                },
                StandardMetricName: {}
              }
            },
            ObjectiveStatus: {},
            CandidateSteps: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "CandidateStepType",
                  "CandidateStepArn",
                  "CandidateStepName"
                ],
                members: {
                  CandidateStepType: {},
                  CandidateStepArn: {},
                  CandidateStepName: {}
                }
              }
            },
            CandidateStatus: {},
            InferenceContainers: {
              shape: "Sxs"
            },
            CreationTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            LastModifiedTime: {
              type: "timestamp"
            },
            FailureReason: {},
            CandidateProperties: {
              type: "structure",
              members: {
                CandidateArtifactLocations: {
                  type: "structure",
                  required: [
                    "Explainability"
                  ],
                  members: {
                    Explainability: {},
                    ModelInsights: {},
                    BacktestResults: {}
                  }
                },
                CandidateMetrics: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      MetricName: {},
                      Value: {
                        type: "float"
                      },
                      Set: {},
                      StandardMetricName: {}
                    }
                  }
                }
              }
            },
            InferenceContainerDefinitions: {
              type: "map",
              key: {},
              value: {
                shape: "Sxs"
              }
            }
          }
        },
        Sxs: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Image",
              "ModelDataUrl"
            ],
            members: {
              Image: {},
              ModelDataUrl: {},
              Environment: {
                shape: "Sz"
              }
            }
          }
        },
        Sy8: {
          type: "structure",
          members: {
            CandidateDefinitionNotebookLocation: {},
            DataExplorationNotebookLocation: {}
          }
        },
        Syc: {
          type: "structure",
          members: {
            EndpointName: {}
          }
        },
        Syu: {
          type: "structure",
          required: [
            "Status"
          ],
          members: {
            Status: {},
            Message: {}
          }
        },
        Sz3: {
          type: "structure",
          required: [
            "S3ModelArtifacts"
          ],
          members: {
            S3ModelArtifacts: {}
          }
        },
        S109: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "VariantName"
            ],
            members: {
              VariantName: {},
              DeployedImages: {
                shape: "S10b"
              },
              CurrentWeight: {
                type: "float"
              },
              DesiredWeight: {
                type: "float"
              },
              CurrentInstanceCount: {
                type: "integer"
              },
              DesiredInstanceCount: {
                type: "integer"
              },
              VariantStatus: {
                shape: "S10d"
              },
              CurrentServerlessConfig: {
                shape: "Sd6"
              },
              DesiredServerlessConfig: {
                shape: "Sd6"
              },
              ManagedInstanceScaling: {
                shape: "Sde"
              },
              RoutingConfig: {
                shape: "Sdi"
              }
            }
          }
        },
        S10b: {
          type: "list",
          member: {
            shape: "S10c"
          }
        },
        S10c: {
          type: "structure",
          members: {
            SpecifiedImage: {},
            ResolvedImage: {},
            ResolutionTime: {
              type: "timestamp"
            }
          }
        },
        S10d: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Status"
            ],
            members: {
              Status: {},
              StatusMessage: {},
              StartTime: {
                type: "timestamp"
              }
            }
          }
        },
        S10h: {
          type: "structure",
          required: [
            "EnableCapture",
            "CaptureStatus",
            "CurrentSamplingPercentage",
            "DestinationS3Uri",
            "KmsKeyId"
          ],
          members: {
            EnableCapture: {
              type: "boolean"
            },
            CaptureStatus: {},
            CurrentSamplingPercentage: {
              type: "integer"
            },
            DestinationS3Uri: {},
            KmsKeyId: {}
          }
        },
        S10l: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "VariantName"
            ],
            members: {
              VariantName: {},
              DeployedImages: {
                shape: "S10b"
              },
              CurrentWeight: {
                type: "float"
              },
              DesiredWeight: {
                type: "float"
              },
              CurrentInstanceCount: {
                type: "integer"
              },
              DesiredInstanceCount: {
                type: "integer"
              },
              InstanceType: {},
              AcceleratorType: {},
              VariantStatus: {
                shape: "S10d"
              },
              CurrentServerlessConfig: {
                shape: "Sd6"
              },
              DesiredServerlessConfig: {
                shape: "Sd6"
              },
              ManagedInstanceScaling: {
                shape: "Sde"
              },
              RoutingConfig: {
                shape: "Sdi"
              }
            }
          }
        },
        S10r: {
          type: "structure",
          required: [
            "SourceArn"
          ],
          members: {
            SourceArn: {},
            SourceType: {}
          }
        },
        S10z: {
          type: "structure",
          required: [
            "Status"
          ],
          members: {
            Status: {},
            BlockedReason: {}
          }
        },
        S112: {
          type: "structure",
          required: [
            "Status"
          ],
          members: {
            Status: {},
            FailureReason: {}
          }
        },
        S118: {
          type: "list",
          member: {
            shape: "S119"
          }
        },
        S119: {
          type: "structure",
          members: {
            Key: {},
            Value: {}
          }
        },
        S11q: {
          type: "list",
          member: {}
        },
        S125: {
          type: "structure",
          members: {
            Completed: {
              type: "integer"
            },
            InProgress: {
              type: "integer"
            },
            RetryableError: {
              type: "integer"
            },
            NonRetryableError: {
              type: "integer"
            },
            Stopped: {
              type: "integer"
            }
          }
        },
        S127: {
          type: "structure",
          members: {
            Succeeded: {
              type: "integer"
            },
            Pending: {
              type: "integer"
            },
            Failed: {
              type: "integer"
            }
          }
        },
        S129: {
          type: "structure",
          required: [
            "TrainingJobName",
            "TrainingJobArn",
            "CreationTime",
            "TrainingJobStatus",
            "TunedHyperParameters"
          ],
          members: {
            TrainingJobDefinitionName: {},
            TrainingJobName: {},
            TrainingJobArn: {},
            TuningJobName: {},
            CreationTime: {
              type: "timestamp"
            },
            TrainingStartTime: {
              type: "timestamp"
            },
            TrainingEndTime: {
              type: "timestamp"
            },
            TrainingJobStatus: {},
            TunedHyperParameters: {
              shape: "S2w"
            },
            FailureReason: {},
            FinalHyperParameterTuningJobObjectiveMetric: {
              type: "structure",
              required: [
                "MetricName",
                "Value"
              ],
              members: {
                Type: {},
                MetricName: {},
                Value: {
                  type: "float"
                }
              }
            },
            ObjectiveStatus: {}
          }
        },
        S12c: {
          type: "structure",
          members: {
            NumberOfTrainingJobsObjectiveNotImproving: {
              type: "integer"
            },
            ConvergenceDetectedTime: {
              type: "timestamp"
            }
          }
        },
        S12d: {
          type: "structure",
          members: {
            RuntimeInSeconds: {
              type: "integer"
            }
          }
        },
        S134: {
          type: "structure",
          required: [
            "CostPerHour",
            "CostPerInference",
            "MaxInvocations",
            "ModelLatency"
          ],
          members: {
            CostPerHour: {
              type: "float"
            },
            CostPerInference: {
              type: "float"
            },
            MaxInvocations: {
              type: "integer"
            },
            ModelLatency: {
              type: "integer"
            },
            CpuUtilization: {
              type: "float"
            },
            MemoryUtilization: {
              type: "float"
            },
            ModelSetupTime: {
              type: "integer"
            }
          }
        },
        S137: {
          type: "structure",
          required: [
            "EndpointName",
            "VariantName"
          ],
          members: {
            EndpointName: {},
            VariantName: {},
            InstanceType: {},
            InitialInstanceCount: {
              type: "integer"
            },
            ServerlessConfig: {
              shape: "Sd6"
            }
          }
        },
        S139: {
          type: "structure",
          members: {
            InferenceSpecificationName: {},
            EnvironmentParameters: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Key",
                  "ValueType",
                  "Value"
                ],
                members: {
                  Key: {},
                  ValueType: {},
                  Value: {}
                }
              }
            },
            CompilationJobName: {}
          }
        },
        S13h: {
          type: "structure",
          required: [
            "MaxInvocations",
            "ModelLatency"
          ],
          members: {
            MaxInvocations: {
              type: "integer"
            },
            ModelLatency: {
              type: "integer"
            }
          }
        },
        S13l: {
          type: "structure",
          members: {
            TotalLabeled: {
              type: "integer"
            },
            HumanLabeled: {
              type: "integer"
            },
            MachineLabeled: {
              type: "integer"
            },
            FailedNonRetryableError: {
              type: "integer"
            },
            Unlabeled: {
              type: "integer"
            }
          }
        },
        S13o: {
          type: "structure",
          required: [
            "OutputDatasetS3Uri"
          ],
          members: {
            OutputDatasetS3Uri: {},
            FinalActiveLearningModelArn: {}
          }
        },
        S13t: {
          type: "structure",
          required: [
            "RecommendationStatus"
          ],
          members: {
            RecommendationStatus: {},
            RealTimeInferenceRecommendations: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "RecommendationId",
                  "InstanceType"
                ],
                members: {
                  RecommendationId: {},
                  InstanceType: {},
                  Environment: {
                    shape: "Sz"
                  }
                }
              }
            }
          }
        },
        S14a: {
          type: "structure",
          required: [
            "ValidationStatuses"
          ],
          members: {
            ValidationStatuses: {
              shape: "S14b"
            },
            ImageScanStatuses: {
              shape: "S14b"
            }
          }
        },
        S14b: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Status"
            ],
            members: {
              Name: {},
              Status: {},
              FailureReason: {}
            }
          }
        },
        S14n: {
          type: "structure",
          required: [
            "MonitoringScheduleName",
            "ScheduledTime",
            "CreationTime",
            "LastModifiedTime",
            "MonitoringExecutionStatus"
          ],
          members: {
            MonitoringScheduleName: {},
            ScheduledTime: {
              type: "timestamp"
            },
            CreationTime: {
              type: "timestamp"
            },
            LastModifiedTime: {
              type: "timestamp"
            },
            MonitoringExecutionStatus: {},
            ProcessingJobArn: {},
            EndpointName: {},
            FailureReason: {},
            MonitoringJobDefinitionName: {},
            MonitoringType: {}
          }
        },
        S157: {
          type: "structure",
          members: {
            ExperimentName: {},
            TrialName: {}
          }
        },
        S159: {
          type: "structure",
          required: [
            "SelectedSteps"
          ],
          members: {
            SourcePipelineExecutionArn: {},
            SelectedSteps: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "StepName"
                ],
                members: {
                  StepName: {}
                }
              }
            }
          }
        },
        S15i: {
          type: "structure",
          members: {
            ProvisionedProductId: {},
            ProvisionedProductStatusMessage: {}
          }
        },
        S15t: {
          type: "structure",
          required: [
            "WorkteamArn"
          ],
          members: {
            WorkteamArn: {},
            MarketplaceTitle: {},
            SellerName: {},
            MarketplaceDescription: {},
            ListingId: {}
          }
        },
        S15x: {
          type: "structure",
          required: [
            "Status"
          ],
          members: {
            Status: {},
            ResourceRetainedBillableTimeInSeconds: {
              type: "integer"
            },
            ReusedByJob: {}
          }
        },
        S160: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Status",
              "StartTime"
            ],
            members: {
              Status: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              StatusMessage: {}
            }
          }
        },
        S163: {
          type: "list",
          member: {
            type: "structure",
            members: {
              MetricName: {},
              Value: {
                type: "float"
              },
              Timestamp: {
                type: "timestamp"
              }
            }
          }
        },
        S167: {
          type: "list",
          member: {
            type: "structure",
            members: {
              RuleConfigurationName: {},
              RuleEvaluationJobArn: {},
              RuleEvaluationStatus: {},
              StatusDetails: {},
              LastModifiedTime: {
                type: "timestamp"
              }
            }
          }
        },
        S16j: {
          type: "structure",
          required: [
            "SourceArn"
          ],
          members: {
            SourceArn: {},
            SourceType: {}
          }
        },
        S16n: {
          type: "structure",
          required: [
            "SourceArn"
          ],
          members: {
            SourceArn: {},
            SourceType: {}
          }
        },
        S16p: {
          type: "list",
          member: {
            type: "structure",
            members: {
              MetricName: {},
              SourceArn: {},
              TimeStamp: {
                type: "timestamp"
              },
              Max: {
                type: "double"
              },
              Min: {
                type: "double"
              },
              Last: {
                type: "double"
              },
              Count: {
                type: "integer"
              },
              Avg: {
                type: "double"
              },
              StdDev: {
                type: "double"
              }
            }
          }
        },
        S16z: {
          type: "structure",
          required: [
            "WorkforceName",
            "WorkforceArn"
          ],
          members: {
            WorkforceName: {},
            WorkforceArn: {},
            LastUpdatedDate: {
              type: "timestamp"
            },
            SourceIpConfig: {
              shape: "Stz"
            },
            SubDomain: {},
            CognitoConfig: {
              shape: "Stt"
            },
            OidcConfig: {
              type: "structure",
              members: {
                ClientId: {},
                Issuer: {},
                AuthorizationEndpoint: {},
                TokenEndpoint: {},
                UserInfoEndpoint: {},
                LogoutEndpoint: {},
                JwksUri: {}
              }
            },
            CreateDate: {
              type: "timestamp"
            },
            WorkforceVpcConfig: {
              type: "structure",
              required: [
                "VpcId",
                "SecurityGroupIds",
                "Subnets"
              ],
              members: {
                VpcId: {},
                SecurityGroupIds: {
                  shape: "Su5"
                },
                Subnets: {
                  shape: "Su7"
                },
                VpcEndpointId: {}
              }
            },
            Status: {},
            FailureReason: {}
          }
        },
        S177: {
          type: "structure",
          required: [
            "WorkteamName",
            "MemberDefinitions",
            "WorkteamArn",
            "Description"
          ],
          members: {
            WorkteamName: {},
            MemberDefinitions: {
              shape: "Sud"
            },
            WorkteamArn: {},
            WorkforceArn: {},
            ProductListingIds: {
              type: "list",
              member: {}
            },
            Description: {},
            SubDomain: {},
            CreateDate: {
              type: "timestamp"
            },
            LastUpdatedDate: {
              type: "timestamp"
            },
            NotificationConfiguration: {
              shape: "Sul"
            }
          }
        },
        S17z: {
          type: "structure",
          members: {
            MinInvocationsPerMinute: {
              type: "integer"
            },
            MaxInvocationsPerMinute: {
              type: "integer"
            }
          }
        },
        S1ar: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "MonitoringJobDefinitionName",
              "MonitoringJobDefinitionArn",
              "CreationTime",
              "EndpointName"
            ],
            members: {
              MonitoringJobDefinitionName: {},
              MonitoringJobDefinitionArn: {},
              CreationTime: {
                type: "timestamp"
              },
              EndpointName: {}
            }
          }
        },
        S1ch: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "HubContentName",
              "HubContentArn",
              "HubContentVersion",
              "HubContentType",
              "DocumentSchemaVersion",
              "HubContentStatus",
              "CreationTime"
            ],
            members: {
              HubContentName: {},
              HubContentArn: {},
              HubContentVersion: {},
              HubContentType: {},
              DocumentSchemaVersion: {},
              HubContentDisplayName: {},
              HubContentDescription: {},
              HubContentSearchKeywords: {
                shape: "S11q"
              },
              HubContentStatus: {},
              CreationTime: {
                type: "timestamp"
              }
            }
          }
        },
        S1g1: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "MonitoringAlertName",
              "CreationTime",
              "LastModifiedTime",
              "AlertStatus",
              "DatapointsToAlert",
              "EvaluationPeriod",
              "Actions"
            ],
            members: {
              MonitoringAlertName: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              AlertStatus: {},
              DatapointsToAlert: {
                type: "integer"
              },
              EvaluationPeriod: {
                type: "integer"
              },
              Actions: {
                type: "structure",
                members: {
                  ModelDashboardIndicator: {
                    type: "structure",
                    members: {
                      Enabled: {
                        type: "boolean"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S1hf: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Value"
            ],
            members: {
              Name: {},
              Value: {}
            }
          }
        },
        S1hw: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Value"
            ],
            members: {
              Name: {},
              Value: {}
            }
          }
        },
        S1ku: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "DeviceName"
            ],
            members: {
              DeviceName: {},
              Description: {},
              IotThingName: {}
            }
          }
        },
        S1l5: {
          type: "structure",
          members: {
            Filters: {
              shape: "S1l6"
            },
            NestedFilters: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "NestedPropertyName",
                  "Filters"
                ],
                members: {
                  NestedPropertyName: {},
                  Filters: {
                    shape: "S1l6"
                  }
                }
              }
            },
            SubExpressions: {
              type: "list",
              member: {
                shape: "S1l5"
              }
            },
            Operator: {}
          }
        },
        S1l6: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Operator: {},
              Value: {}
            }
          }
        },
        S1ln: {
          type: "structure",
          members: {
            TrainingJobName: {},
            TrainingJobArn: {},
            TuningJobArn: {},
            LabelingJobArn: {},
            AutoMLJobArn: {},
            ModelArtifacts: {
              shape: "Sz3"
            },
            TrainingJobStatus: {},
            SecondaryStatus: {},
            FailureReason: {},
            HyperParameters: {
              shape: "S2w"
            },
            AlgorithmSpecification: {
              shape: "Srw"
            },
            RoleArn: {},
            InputDataConfig: {
              shape: "S2y"
            },
            OutputDataConfig: {
              shape: "S3g"
            },
            ResourceConfig: {
              shape: "S3j"
            },
            VpcConfig: {
              shape: "S63"
            },
            StoppingCondition: {
              shape: "S3p"
            },
            CreationTime: {
              type: "timestamp"
            },
            TrainingStartTime: {
              type: "timestamp"
            },
            TrainingEndTime: {
              type: "timestamp"
            },
            LastModifiedTime: {
              type: "timestamp"
            },
            SecondaryStatusTransitions: {
              shape: "S160"
            },
            FinalMetricDataList: {
              shape: "S163"
            },
            EnableNetworkIsolation: {
              type: "boolean"
            },
            EnableInterContainerTrafficEncryption: {
              type: "boolean"
            },
            EnableManagedSpotTraining: {
              type: "boolean"
            },
            CheckpointConfig: {
              shape: "Si1"
            },
            TrainingTimeInSeconds: {
              type: "integer"
            },
            BillableTimeInSeconds: {
              type: "integer"
            },
            DebugHookConfig: {
              shape: "Ss5"
            },
            ExperimentConfig: {
              shape: "Sqx"
            },
            DebugRuleConfigurations: {
              shape: "Ssd"
            },
            TensorBoardOutputConfig: {
              shape: "Ssh"
            },
            DebugRuleEvaluationStatuses: {
              shape: "S167"
            },
            ProfilerConfig: {
              shape: "Ssi"
            },
            Environment: {
              shape: "Sso"
            },
            RetryStrategy: {
              shape: "Si2"
            },
            Tags: {
              shape: "S7"
            }
          }
        },
        S1lv: {
          type: "structure",
          members: {
            TransformJobName: {},
            TransformJobArn: {},
            TransformJobStatus: {},
            FailureReason: {},
            ModelName: {},
            MaxConcurrentTransforms: {
              type: "integer"
            },
            ModelClientConfig: {
              shape: "Ssz"
            },
            MaxPayloadInMB: {
              type: "integer"
            },
            BatchStrategy: {},
            Environment: {
              shape: "S3x"
            },
            TransformInput: {
              shape: "S40"
            },
            TransformOutput: {
              shape: "S44"
            },
            DataCaptureConfig: {
              shape: "St2"
            },
            TransformResources: {
              shape: "S47"
            },
            CreationTime: {
              type: "timestamp"
            },
            TransformStartTime: {
              type: "timestamp"
            },
            TransformEndTime: {
              type: "timestamp"
            },
            LabelingJobArn: {},
            AutoMLJobArn: {},
            DataProcessing: {
              shape: "St3"
            },
            ExperimentConfig: {
              shape: "Sqx"
            },
            Tags: {
              shape: "S7"
            }
          }
        },
        S1nc: {
          type: "list",
          member: {}
        },
        S1pr: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/sagemaker-2017-07-24.paginators.json
var require_sagemaker_2017_07_24_paginators = __commonJS({
  "node_modules/aws-sdk/apis/sagemaker-2017-07-24.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListActions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ActionSummaries"
        },
        ListAlgorithms: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AlgorithmSummaryList"
        },
        ListAliases: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "SageMakerImageVersionAliases"
        },
        ListAppImageConfigs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AppImageConfigs"
        },
        ListApps: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Apps"
        },
        ListArtifacts: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ArtifactSummaries"
        },
        ListAssociations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AssociationSummaries"
        },
        ListAutoMLJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AutoMLJobSummaries"
        },
        ListCandidatesForAutoMLJob: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Candidates"
        },
        ListClusterNodes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ClusterNodeSummaries"
        },
        ListClusters: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ClusterSummaries"
        },
        ListCodeRepositories: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "CodeRepositorySummaryList"
        },
        ListCompilationJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "CompilationJobSummaries"
        },
        ListContexts: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ContextSummaries"
        },
        ListDataQualityJobDefinitions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "JobDefinitionSummaries"
        },
        ListDeviceFleets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "DeviceFleetSummaries"
        },
        ListDevices: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "DeviceSummaries"
        },
        ListDomains: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Domains"
        },
        ListEdgeDeploymentPlans: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "EdgeDeploymentPlanSummaries"
        },
        ListEdgePackagingJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "EdgePackagingJobSummaries"
        },
        ListEndpointConfigs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "EndpointConfigs"
        },
        ListEndpoints: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Endpoints"
        },
        ListExperiments: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ExperimentSummaries"
        },
        ListFeatureGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "FeatureGroupSummaries"
        },
        ListFlowDefinitions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "FlowDefinitionSummaries"
        },
        ListHumanTaskUis: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "HumanTaskUiSummaries"
        },
        ListHyperParameterTuningJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "HyperParameterTuningJobSummaries"
        },
        ListImageVersions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ImageVersions"
        },
        ListImages: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Images"
        },
        ListInferenceComponents: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "InferenceComponents"
        },
        ListInferenceExperiments: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "InferenceExperiments"
        },
        ListInferenceRecommendationsJobSteps: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Steps"
        },
        ListInferenceRecommendationsJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "InferenceRecommendationsJobs"
        },
        ListLabelingJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "LabelingJobSummaryList"
        },
        ListLabelingJobsForWorkteam: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "LabelingJobSummaryList"
        },
        ListLineageGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "LineageGroupSummaries"
        },
        ListModelBiasJobDefinitions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "JobDefinitionSummaries"
        },
        ListModelCardExportJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ModelCardExportJobSummaries"
        },
        ListModelCardVersions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ModelCardVersionSummaryList"
        },
        ListModelCards: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ModelCardSummaries"
        },
        ListModelExplainabilityJobDefinitions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "JobDefinitionSummaries"
        },
        ListModelMetadata: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ModelMetadataSummaries"
        },
        ListModelPackageGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ModelPackageGroupSummaryList"
        },
        ListModelPackages: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ModelPackageSummaryList"
        },
        ListModelQualityJobDefinitions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "JobDefinitionSummaries"
        },
        ListModels: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Models"
        },
        ListMonitoringAlertHistory: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "MonitoringAlertHistory"
        },
        ListMonitoringAlerts: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "MonitoringAlertSummaries"
        },
        ListMonitoringExecutions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "MonitoringExecutionSummaries"
        },
        ListMonitoringSchedules: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "MonitoringScheduleSummaries"
        },
        ListNotebookInstanceLifecycleConfigs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "NotebookInstanceLifecycleConfigs"
        },
        ListNotebookInstances: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "NotebookInstances"
        },
        ListPipelineExecutionSteps: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "PipelineExecutionSteps"
        },
        ListPipelineExecutions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "PipelineExecutionSummaries"
        },
        ListPipelineParametersForExecution: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "PipelineParameters"
        },
        ListPipelines: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "PipelineSummaries"
        },
        ListProcessingJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ProcessingJobSummaries"
        },
        ListProjects: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListResourceCatalogs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ResourceCatalogs"
        },
        ListSpaces: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Spaces"
        },
        ListStageDevices: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "DeviceDeploymentSummaries"
        },
        ListStudioLifecycleConfigs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "StudioLifecycleConfigs"
        },
        ListSubscribedWorkteams: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "SubscribedWorkteams"
        },
        ListTags: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Tags"
        },
        ListTrainingJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "TrainingJobSummaries"
        },
        ListTrainingJobsForHyperParameterTuningJob: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "TrainingJobSummaries"
        },
        ListTransformJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "TransformJobSummaries"
        },
        ListTrialComponents: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "TrialComponentSummaries"
        },
        ListTrials: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "TrialSummaries"
        },
        ListUserProfiles: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "UserProfiles"
        },
        ListWorkforces: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Workforces"
        },
        ListWorkteams: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Workteams"
        },
        QueryLineage: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        Search: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Results"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/sagemaker-2017-07-24.waiters2.json
var require_sagemaker_2017_07_24_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/sagemaker-2017-07-24.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        NotebookInstanceInService: {
          delay: 30,
          maxAttempts: 60,
          operation: "DescribeNotebookInstance",
          acceptors: [
            {
              expected: "InService",
              matcher: "path",
              state: "success",
              argument: "NotebookInstanceStatus"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "NotebookInstanceStatus"
            }
          ]
        },
        NotebookInstanceStopped: {
          delay: 30,
          operation: "DescribeNotebookInstance",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "Stopped",
              matcher: "path",
              state: "success",
              argument: "NotebookInstanceStatus"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "NotebookInstanceStatus"
            }
          ]
        },
        NotebookInstanceDeleted: {
          delay: 30,
          maxAttempts: 60,
          operation: "DescribeNotebookInstance",
          acceptors: [
            {
              expected: "ValidationException",
              matcher: "error",
              state: "success"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "NotebookInstanceStatus"
            }
          ]
        },
        TrainingJobCompletedOrStopped: {
          delay: 120,
          maxAttempts: 180,
          operation: "DescribeTrainingJob",
          acceptors: [
            {
              expected: "Completed",
              matcher: "path",
              state: "success",
              argument: "TrainingJobStatus"
            },
            {
              expected: "Stopped",
              matcher: "path",
              state: "success",
              argument: "TrainingJobStatus"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "TrainingJobStatus"
            },
            {
              expected: "ValidationException",
              matcher: "error",
              state: "failure"
            }
          ]
        },
        EndpointInService: {
          delay: 30,
          maxAttempts: 120,
          operation: "DescribeEndpoint",
          acceptors: [
            {
              expected: "InService",
              matcher: "path",
              state: "success",
              argument: "EndpointStatus"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "EndpointStatus"
            },
            {
              expected: "ValidationException",
              matcher: "error",
              state: "failure"
            }
          ]
        },
        EndpointDeleted: {
          delay: 30,
          maxAttempts: 60,
          operation: "DescribeEndpoint",
          acceptors: [
            {
              expected: "ValidationException",
              matcher: "error",
              state: "success"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "EndpointStatus"
            }
          ]
        },
        TransformJobCompletedOrStopped: {
          delay: 60,
          maxAttempts: 60,
          operation: "DescribeTransformJob",
          acceptors: [
            {
              expected: "Completed",
              matcher: "path",
              state: "success",
              argument: "TransformJobStatus"
            },
            {
              expected: "Stopped",
              matcher: "path",
              state: "success",
              argument: "TransformJobStatus"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "TransformJobStatus"
            },
            {
              expected: "ValidationException",
              matcher: "error",
              state: "failure"
            }
          ]
        },
        ProcessingJobCompletedOrStopped: {
          delay: 60,
          maxAttempts: 60,
          operation: "DescribeProcessingJob",
          acceptors: [
            {
              expected: "Completed",
              matcher: "path",
              state: "success",
              argument: "ProcessingJobStatus"
            },
            {
              expected: "Stopped",
              matcher: "path",
              state: "success",
              argument: "ProcessingJobStatus"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "ProcessingJobStatus"
            },
            {
              expected: "ValidationException",
              matcher: "error",
              state: "failure"
            }
          ]
        },
        ImageCreated: {
          delay: 60,
          maxAttempts: 60,
          operation: "DescribeImage",
          acceptors: [
            {
              expected: "CREATED",
              matcher: "path",
              state: "success",
              argument: "ImageStatus"
            },
            {
              expected: "CREATE_FAILED",
              matcher: "path",
              state: "failure",
              argument: "ImageStatus"
            },
            {
              expected: "ValidationException",
              matcher: "error",
              state: "failure"
            }
          ]
        },
        ImageUpdated: {
          delay: 60,
          maxAttempts: 60,
          operation: "DescribeImage",
          acceptors: [
            {
              expected: "CREATED",
              matcher: "path",
              state: "success",
              argument: "ImageStatus"
            },
            {
              expected: "UPDATE_FAILED",
              matcher: "path",
              state: "failure",
              argument: "ImageStatus"
            },
            {
              expected: "ValidationException",
              matcher: "error",
              state: "failure"
            }
          ]
        },
        ImageDeleted: {
          delay: 60,
          maxAttempts: 60,
          operation: "DescribeImage",
          acceptors: [
            {
              expected: "ResourceNotFoundException",
              matcher: "error",
              state: "success"
            },
            {
              expected: "DELETE_FAILED",
              matcher: "path",
              state: "failure",
              argument: "ImageStatus"
            },
            {
              expected: "ValidationException",
              matcher: "error",
              state: "failure"
            }
          ]
        },
        ImageVersionCreated: {
          delay: 60,
          maxAttempts: 60,
          operation: "DescribeImageVersion",
          acceptors: [
            {
              expected: "CREATED",
              matcher: "path",
              state: "success",
              argument: "ImageVersionStatus"
            },
            {
              expected: "CREATE_FAILED",
              matcher: "path",
              state: "failure",
              argument: "ImageVersionStatus"
            },
            {
              expected: "ValidationException",
              matcher: "error",
              state: "failure"
            }
          ]
        },
        ImageVersionDeleted: {
          delay: 60,
          maxAttempts: 60,
          operation: "DescribeImageVersion",
          acceptors: [
            {
              expected: "ResourceNotFoundException",
              matcher: "error",
              state: "success"
            },
            {
              expected: "DELETE_FAILED",
              matcher: "path",
              state: "failure",
              argument: "ImageVersionStatus"
            },
            {
              expected: "ValidationException",
              matcher: "error",
              state: "failure"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/sagemaker.js
var require_sagemaker = __commonJS({
  "node_modules/aws-sdk/clients/sagemaker.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["sagemaker"] = {};
    AWS2.SageMaker = Service.defineService("sagemaker", ["2017-07-24"]);
    Object.defineProperty(apiLoader.services["sagemaker"], "2017-07-24", {
      get: function get() {
        var model = require_sagemaker_2017_07_24_min();
        model.paginators = require_sagemaker_2017_07_24_paginators().pagination;
        model.waiters = require_sagemaker_2017_07_24_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.SageMaker;
  }
});

// node_modules/aws-sdk/apis/translate-2017-07-01.min.json
var require_translate_2017_07_01_min = __commonJS({
  "node_modules/aws-sdk/apis/translate-2017-07-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-07-01",
        endpointPrefix: "translate",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Translate",
        serviceId: "Translate",
        signatureVersion: "v4",
        signingName: "translate",
        targetPrefix: "AWSShineFrontendService_20170701",
        uid: "translate-2017-07-01"
      },
      operations: {
        CreateParallelData: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ParallelDataConfig",
              "ClientToken"
            ],
            members: {
              Name: {},
              Description: {},
              ParallelDataConfig: {
                shape: "S4"
              },
              EncryptionKey: {
                shape: "S7"
              },
              ClientToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Status: {}
            }
          }
        },
        DeleteParallelData: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Status: {}
            }
          }
        },
        DeleteTerminology: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        DescribeTextTranslationJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TextTranslationJobProperties: {
                shape: "Sn"
              }
            }
          }
        },
        GetParallelData: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ParallelDataProperties: {
                shape: "S17"
              },
              DataLocation: {
                shape: "S1b"
              },
              AuxiliaryDataLocation: {
                shape: "S1b"
              },
              LatestUpdateAttemptAuxiliaryDataLocation: {
                shape: "S1b"
              }
            }
          }
        },
        GetTerminology: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              TerminologyDataFormat: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TerminologyProperties: {
                shape: "S1g"
              },
              TerminologyDataLocation: {
                shape: "S1j"
              },
              AuxiliaryDataLocation: {
                shape: "S1j"
              }
            }
          }
        },
        ImportTerminology: {
          input: {
            type: "structure",
            required: [
              "Name",
              "MergeStrategy",
              "TerminologyData"
            ],
            members: {
              Name: {},
              MergeStrategy: {},
              Description: {},
              TerminologyData: {
                type: "structure",
                required: [
                  "File",
                  "Format"
                ],
                members: {
                  File: {
                    type: "blob",
                    sensitive: true
                  },
                  Format: {},
                  Directionality: {}
                }
              },
              EncryptionKey: {
                shape: "S7"
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TerminologyProperties: {
                shape: "S1g"
              },
              AuxiliaryDataLocation: {
                shape: "S1j"
              }
            }
          }
        },
        ListLanguages: {
          input: {
            type: "structure",
            members: {
              DisplayLanguageCode: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Languages: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "LanguageName",
                    "LanguageCode"
                  ],
                  members: {
                    LanguageName: {},
                    LanguageCode: {}
                  }
                }
              },
              DisplayLanguageCode: {},
              NextToken: {}
            }
          }
        },
        ListParallelData: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ParallelDataPropertiesList: {
                type: "list",
                member: {
                  shape: "S17"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sb"
              }
            }
          }
        },
        ListTerminologies: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TerminologyPropertiesList: {
                type: "list",
                member: {
                  shape: "S1g"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTextTranslationJobs: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                members: {
                  JobName: {},
                  JobStatus: {},
                  SubmittedBeforeTime: {
                    type: "timestamp"
                  },
                  SubmittedAfterTime: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TextTranslationJobPropertiesList: {
                type: "list",
                member: {
                  shape: "Sn"
                }
              },
              NextToken: {}
            }
          }
        },
        StartTextTranslationJob: {
          input: {
            type: "structure",
            required: [
              "InputDataConfig",
              "OutputDataConfig",
              "DataAccessRoleArn",
              "SourceLanguageCode",
              "TargetLanguageCodes",
              "ClientToken"
            ],
            members: {
              JobName: {},
              InputDataConfig: {
                shape: "Sx"
              },
              OutputDataConfig: {
                shape: "Sz"
              },
              DataAccessRoleArn: {},
              SourceLanguageCode: {},
              TargetLanguageCodes: {
                shape: "St"
              },
              TerminologyNames: {
                shape: "Su"
              },
              ParallelDataNames: {
                shape: "Su"
              },
              ClientToken: {
                idempotencyToken: true
              },
              Settings: {
                shape: "S11"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobStatus: {}
            }
          }
        },
        StopTextTranslationJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobStatus: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TranslateDocument: {
          input: {
            type: "structure",
            required: [
              "Document",
              "SourceLanguageCode",
              "TargetLanguageCode"
            ],
            members: {
              Document: {
                type: "structure",
                required: [
                  "Content",
                  "ContentType"
                ],
                members: {
                  Content: {
                    type: "blob",
                    sensitive: true
                  },
                  ContentType: {}
                }
              },
              TerminologyNames: {
                shape: "Su"
              },
              SourceLanguageCode: {},
              TargetLanguageCode: {},
              Settings: {
                shape: "S11"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TranslatedDocument",
              "SourceLanguageCode",
              "TargetLanguageCode"
            ],
            members: {
              TranslatedDocument: {
                type: "structure",
                required: [
                  "Content"
                ],
                members: {
                  Content: {
                    type: "blob",
                    sensitive: true
                  }
                }
              },
              SourceLanguageCode: {},
              TargetLanguageCode: {},
              AppliedTerminologies: {
                shape: "S2m"
              },
              AppliedSettings: {
                shape: "S11"
              }
            }
          }
        },
        TranslateText: {
          input: {
            type: "structure",
            required: [
              "Text",
              "SourceLanguageCode",
              "TargetLanguageCode"
            ],
            members: {
              Text: {},
              TerminologyNames: {
                shape: "Su"
              },
              SourceLanguageCode: {},
              TargetLanguageCode: {},
              Settings: {
                shape: "S11"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TranslatedText",
              "SourceLanguageCode",
              "TargetLanguageCode"
            ],
            members: {
              TranslatedText: {},
              SourceLanguageCode: {},
              TargetLanguageCode: {},
              AppliedTerminologies: {
                shape: "S2m"
              },
              AppliedSettings: {
                shape: "S11"
              }
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateParallelData: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ParallelDataConfig",
              "ClientToken"
            ],
            members: {
              Name: {},
              Description: {},
              ParallelDataConfig: {
                shape: "S4"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Status: {},
              LatestUpdateAttemptStatus: {},
              LatestUpdateAttemptAt: {
                type: "timestamp"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            S3Uri: {},
            Format: {}
          }
        },
        S7: {
          type: "structure",
          required: [
            "Type",
            "Id"
          ],
          members: {
            Type: {},
            Id: {}
          }
        },
        Sb: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sn: {
          type: "structure",
          members: {
            JobId: {},
            JobName: {},
            JobStatus: {},
            JobDetails: {
              type: "structure",
              members: {
                TranslatedDocumentsCount: {
                  type: "integer"
                },
                DocumentsWithErrorsCount: {
                  type: "integer"
                },
                InputDocumentsCount: {
                  type: "integer"
                }
              }
            },
            SourceLanguageCode: {},
            TargetLanguageCodes: {
              shape: "St"
            },
            TerminologyNames: {
              shape: "Su"
            },
            ParallelDataNames: {
              shape: "Su"
            },
            Message: {},
            SubmittedTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            InputDataConfig: {
              shape: "Sx"
            },
            OutputDataConfig: {
              shape: "Sz"
            },
            DataAccessRoleArn: {},
            Settings: {
              shape: "S11"
            }
          }
        },
        St: {
          type: "list",
          member: {}
        },
        Su: {
          type: "list",
          member: {}
        },
        Sx: {
          type: "structure",
          required: [
            "S3Uri",
            "ContentType"
          ],
          members: {
            S3Uri: {},
            ContentType: {}
          }
        },
        Sz: {
          type: "structure",
          required: [
            "S3Uri"
          ],
          members: {
            S3Uri: {},
            EncryptionKey: {
              shape: "S7"
            }
          }
        },
        S11: {
          type: "structure",
          members: {
            Formality: {},
            Profanity: {},
            Brevity: {}
          }
        },
        S17: {
          type: "structure",
          members: {
            Name: {},
            Arn: {},
            Description: {},
            Status: {},
            SourceLanguageCode: {},
            TargetLanguageCodes: {
              shape: "S19"
            },
            ParallelDataConfig: {
              shape: "S4"
            },
            Message: {},
            ImportedDataSize: {
              type: "long"
            },
            ImportedRecordCount: {
              type: "long"
            },
            FailedRecordCount: {
              type: "long"
            },
            SkippedRecordCount: {
              type: "long"
            },
            EncryptionKey: {
              shape: "S7"
            },
            CreatedAt: {
              type: "timestamp"
            },
            LastUpdatedAt: {
              type: "timestamp"
            },
            LatestUpdateAttemptStatus: {},
            LatestUpdateAttemptAt: {
              type: "timestamp"
            }
          }
        },
        S19: {
          type: "list",
          member: {}
        },
        S1b: {
          type: "structure",
          required: [
            "RepositoryType",
            "Location"
          ],
          members: {
            RepositoryType: {},
            Location: {}
          }
        },
        S1g: {
          type: "structure",
          members: {
            Name: {},
            Description: {},
            Arn: {},
            SourceLanguageCode: {},
            TargetLanguageCodes: {
              shape: "S19"
            },
            EncryptionKey: {
              shape: "S7"
            },
            SizeBytes: {
              type: "integer"
            },
            TermCount: {
              type: "integer"
            },
            CreatedAt: {
              type: "timestamp"
            },
            LastUpdatedAt: {
              type: "timestamp"
            },
            Directionality: {},
            Message: {},
            SkippedTermCount: {
              type: "integer"
            },
            Format: {}
          }
        },
        S1j: {
          type: "structure",
          required: [
            "RepositoryType",
            "Location"
          ],
          members: {
            RepositoryType: {},
            Location: {}
          }
        },
        S2m: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Terms: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SourceText: {},
                    TargetText: {}
                  }
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/translate-2017-07-01.paginators.json
var require_translate_2017_07_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/translate-2017-07-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListLanguages: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListParallelData: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListTerminologies: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListTextTranslationJobs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/translate.js
var require_translate = __commonJS({
  "node_modules/aws-sdk/clients/translate.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["translate"] = {};
    AWS2.Translate = Service.defineService("translate", ["2017-07-01"]);
    Object.defineProperty(apiLoader.services["translate"], "2017-07-01", {
      get: function get() {
        var model = require_translate_2017_07_01_min();
        model.paginators = require_translate_2017_07_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Translate;
  }
});

// node_modules/aws-sdk/apis/resource-groups-2017-11-27.min.json
var require_resource_groups_2017_11_27_min = __commonJS({
  "node_modules/aws-sdk/apis/resource-groups-2017-11-27.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-11-27",
        endpointPrefix: "resource-groups",
        protocol: "rest-json",
        serviceAbbreviation: "Resource Groups",
        serviceFullName: "AWS Resource Groups",
        serviceId: "Resource Groups",
        signatureVersion: "v4",
        signingName: "resource-groups",
        uid: "resource-groups-2017-11-27"
      },
      operations: {
        CreateGroup: {
          http: {
            requestUri: "/groups"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Description: {},
              ResourceQuery: {
                shape: "S4"
              },
              Tags: {
                shape: "S7"
              },
              Configuration: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Group: {
                shape: "Sj"
              },
              ResourceQuery: {
                shape: "S4"
              },
              Tags: {
                shape: "S7"
              },
              GroupConfiguration: {
                shape: "Sl"
              }
            }
          }
        },
        DeleteGroup: {
          http: {
            requestUri: "/delete-group"
          },
          input: {
            type: "structure",
            members: {
              GroupName: {
                deprecated: true,
                deprecatedMessage: "This field is deprecated, use Group instead."
              },
              Group: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Group: {
                shape: "Sj"
              }
            }
          }
        },
        GetAccountSettings: {
          http: {
            requestUri: "/get-account-settings"
          },
          output: {
            type: "structure",
            members: {
              AccountSettings: {
                shape: "Ss"
              }
            }
          }
        },
        GetGroup: {
          http: {
            requestUri: "/get-group"
          },
          input: {
            type: "structure",
            members: {
              GroupName: {
                deprecated: true,
                deprecatedMessage: "This field is deprecated, use Group instead."
              },
              Group: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Group: {
                shape: "Sj"
              }
            }
          }
        },
        GetGroupConfiguration: {
          http: {
            requestUri: "/get-group-configuration"
          },
          input: {
            type: "structure",
            members: {
              Group: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GroupConfiguration: {
                shape: "Sl"
              }
            }
          }
        },
        GetGroupQuery: {
          http: {
            requestUri: "/get-group-query"
          },
          input: {
            type: "structure",
            members: {
              GroupName: {
                deprecated: true,
                deprecatedMessage: "This field is deprecated, use Group instead."
              },
              Group: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GroupQuery: {
                shape: "S12"
              }
            }
          }
        },
        GetTags: {
          http: {
            method: "GET",
            requestUri: "/resources/{Arn}/tags"
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {
                location: "uri",
                locationName: "Arn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Tags: {
                shape: "S7"
              }
            }
          }
        },
        GroupResources: {
          http: {
            requestUri: "/group-resources"
          },
          input: {
            type: "structure",
            required: [
              "Group",
              "ResourceArns"
            ],
            members: {
              Group: {},
              ResourceArns: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Succeeded: {
                shape: "S16"
              },
              Failed: {
                shape: "S19"
              },
              Pending: {
                shape: "S1d"
              }
            }
          }
        },
        ListGroupResources: {
          http: {
            requestUri: "/list-group-resources"
          },
          input: {
            type: "structure",
            members: {
              GroupName: {
                deprecated: true,
                deprecatedMessage: "This field is deprecated, use Group instead."
              },
              Group: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Values"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Resources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Identifier: {
                      shape: "S1q"
                    },
                    Status: {
                      type: "structure",
                      members: {
                        Name: {}
                      }
                    }
                  }
                }
              },
              ResourceIdentifiers: {
                shape: "S1u",
                deprecated: true,
                deprecatedMessage: "This field is deprecated, use Resources instead."
              },
              NextToken: {},
              QueryErrors: {
                shape: "S1v"
              }
            }
          }
        },
        ListGroups: {
          http: {
            requestUri: "/groups-list"
          },
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Values"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GroupIdentifiers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    GroupName: {},
                    GroupArn: {}
                  }
                }
              },
              Groups: {
                deprecated: true,
                deprecatedMessage: "This field is deprecated, use GroupIdentifiers instead.",
                type: "list",
                member: {
                  shape: "Sj"
                }
              },
              NextToken: {}
            }
          }
        },
        PutGroupConfiguration: {
          http: {
            requestUri: "/put-group-configuration",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              Group: {},
              Configuration: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SearchResources: {
          http: {
            requestUri: "/resources/search"
          },
          input: {
            type: "structure",
            required: [
              "ResourceQuery"
            ],
            members: {
              ResourceQuery: {
                shape: "S4"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceIdentifiers: {
                shape: "S1u"
              },
              NextToken: {},
              QueryErrors: {
                shape: "S1v"
              }
            }
          }
        },
        Tag: {
          http: {
            method: "PUT",
            requestUri: "/resources/{Arn}/tags"
          },
          input: {
            type: "structure",
            required: [
              "Arn",
              "Tags"
            ],
            members: {
              Arn: {
                location: "uri",
                locationName: "Arn"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Tags: {
                shape: "S7"
              }
            }
          }
        },
        UngroupResources: {
          http: {
            requestUri: "/ungroup-resources"
          },
          input: {
            type: "structure",
            required: [
              "Group",
              "ResourceArns"
            ],
            members: {
              Group: {},
              ResourceArns: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Succeeded: {
                shape: "S16"
              },
              Failed: {
                shape: "S19"
              },
              Pending: {
                shape: "S1d"
              }
            }
          }
        },
        Untag: {
          http: {
            method: "PATCH",
            requestUri: "/resources/{Arn}/tags"
          },
          input: {
            type: "structure",
            required: [
              "Arn",
              "Keys"
            ],
            members: {
              Arn: {
                location: "uri",
                locationName: "Arn"
              },
              Keys: {
                shape: "S2i"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Keys: {
                shape: "S2i"
              }
            }
          }
        },
        UpdateAccountSettings: {
          http: {
            requestUri: "/update-account-settings"
          },
          input: {
            type: "structure",
            members: {
              GroupLifecycleEventsDesiredStatus: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AccountSettings: {
                shape: "Ss"
              }
            }
          }
        },
        UpdateGroup: {
          http: {
            requestUri: "/update-group"
          },
          input: {
            type: "structure",
            members: {
              GroupName: {
                deprecated: true,
                deprecatedMessage: "This field is deprecated, use Group instead."
              },
              Group: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Group: {
                shape: "Sj"
              }
            }
          }
        },
        UpdateGroupQuery: {
          http: {
            requestUri: "/update-group-query"
          },
          input: {
            type: "structure",
            required: [
              "ResourceQuery"
            ],
            members: {
              GroupName: {
                deprecated: true,
                deprecatedMessage: "This field is deprecated, use Group instead."
              },
              Group: {},
              ResourceQuery: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GroupQuery: {
                shape: "S12"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          required: [
            "Type",
            "Query"
          ],
          members: {
            Type: {},
            Query: {}
          }
        },
        S7: {
          type: "map",
          key: {},
          value: {}
        },
        Sa: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Type"
            ],
            members: {
              Type: {},
              Parameters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              }
            }
          }
        },
        Sj: {
          type: "structure",
          required: [
            "GroupArn",
            "Name"
          ],
          members: {
            GroupArn: {},
            Name: {},
            Description: {}
          }
        },
        Sl: {
          type: "structure",
          members: {
            Configuration: {
              shape: "Sa"
            },
            ProposedConfiguration: {
              shape: "Sa"
            },
            Status: {},
            FailureReason: {}
          }
        },
        Ss: {
          type: "structure",
          members: {
            GroupLifecycleEventsDesiredStatus: {},
            GroupLifecycleEventsStatus: {},
            GroupLifecycleEventsStatusMessage: {}
          }
        },
        S12: {
          type: "structure",
          required: [
            "GroupName",
            "ResourceQuery"
          ],
          members: {
            GroupName: {},
            ResourceQuery: {
              shape: "S4"
            }
          }
        },
        S16: {
          type: "list",
          member: {}
        },
        S19: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ResourceArn: {},
              ErrorMessage: {},
              ErrorCode: {}
            }
          }
        },
        S1d: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ResourceArn: {}
            }
          }
        },
        S1q: {
          type: "structure",
          members: {
            ResourceArn: {},
            ResourceType: {}
          }
        },
        S1u: {
          type: "list",
          member: {
            shape: "S1q"
          }
        },
        S1v: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ErrorCode: {},
              Message: {}
            }
          }
        },
        S2i: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/resource-groups-2017-11-27.paginators.json
var require_resource_groups_2017_11_27_paginators = __commonJS({
  "node_modules/aws-sdk/apis/resource-groups-2017-11-27.paginators.json"(exports2, module2) {
    module2.exports = { pagination: { ListGroupResources: { input_token: "NextToken", output_token: "NextToken", limit_key: "MaxResults", result_key: ["ResourceIdentifiers", "Resources"] }, ListGroups: { input_token: "NextToken", output_token: "NextToken", limit_key: "MaxResults", result_key: "GroupIdentifiers" }, SearchResources: { input_token: "NextToken", output_token: "NextToken", limit_key: "MaxResults", result_key: "ResourceIdentifiers" } } };
  }
});

// node_modules/aws-sdk/clients/resourcegroups.js
var require_resourcegroups = __commonJS({
  "node_modules/aws-sdk/clients/resourcegroups.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["resourcegroups"] = {};
    AWS2.ResourceGroups = Service.defineService("resourcegroups", ["2017-11-27"]);
    Object.defineProperty(apiLoader.services["resourcegroups"], "2017-11-27", {
      get: function get() {
        var model = require_resource_groups_2017_11_27_min();
        model.paginators = require_resource_groups_2017_11_27_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ResourceGroups;
  }
});

// node_modules/aws-sdk/apis/alexaforbusiness-2017-11-09.min.json
var require_alexaforbusiness_2017_11_09_min = __commonJS({
  "node_modules/aws-sdk/apis/alexaforbusiness-2017-11-09.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-11-09",
        endpointPrefix: "a4b",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Alexa For Business",
        serviceId: "Alexa For Business",
        signatureVersion: "v4",
        targetPrefix: "AlexaForBusiness",
        uid: "alexaforbusiness-2017-11-09"
      },
      operations: {
        ApproveSkill: {
          input: {
            type: "structure",
            required: [
              "SkillId"
            ],
            members: {
              SkillId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        AssociateContactWithAddressBook: {
          input: {
            type: "structure",
            required: [
              "ContactArn",
              "AddressBookArn"
            ],
            members: {
              ContactArn: {},
              AddressBookArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        AssociateDeviceWithNetworkProfile: {
          input: {
            type: "structure",
            required: [
              "DeviceArn",
              "NetworkProfileArn"
            ],
            members: {
              DeviceArn: {},
              NetworkProfileArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        AssociateDeviceWithRoom: {
          input: {
            type: "structure",
            members: {
              DeviceArn: {},
              RoomArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        AssociateSkillGroupWithRoom: {
          input: {
            type: "structure",
            members: {
              SkillGroupArn: {},
              RoomArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        AssociateSkillWithSkillGroup: {
          input: {
            type: "structure",
            required: [
              "SkillId"
            ],
            members: {
              SkillGroupArn: {},
              SkillId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        AssociateSkillWithUsers: {
          input: {
            type: "structure",
            required: [
              "SkillId"
            ],
            members: {
              SkillId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        CreateAddressBook: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Description: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AddressBookArn: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        CreateBusinessReportSchedule: {
          input: {
            type: "structure",
            required: [
              "Format",
              "ContentRange"
            ],
            members: {
              ScheduleName: {},
              S3BucketName: {},
              S3KeyPrefix: {},
              Format: {},
              ContentRange: {
                shape: "Sv"
              },
              Recurrence: {
                shape: "Sx"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ScheduleArn: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        CreateConferenceProvider: {
          input: {
            type: "structure",
            required: [
              "ConferenceProviderName",
              "ConferenceProviderType",
              "MeetingSetting"
            ],
            members: {
              ConferenceProviderName: {},
              ConferenceProviderType: {},
              IPDialIn: {
                shape: "S13"
              },
              PSTNDialIn: {
                shape: "S16"
              },
              MeetingSetting: {
                shape: "S1b"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConferenceProviderArn: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        CreateContact: {
          input: {
            type: "structure",
            required: [
              "FirstName"
            ],
            members: {
              DisplayName: {},
              FirstName: {},
              LastName: {},
              PhoneNumber: {
                shape: "S1g"
              },
              PhoneNumbers: {
                shape: "S1h"
              },
              SipAddresses: {
                shape: "S1k"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContactArn: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        CreateGatewayGroup: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ClientRequestToken"
            ],
            members: {
              Name: {},
              Description: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayGroupArn: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        CreateNetworkProfile: {
          input: {
            type: "structure",
            required: [
              "NetworkProfileName",
              "Ssid",
              "SecurityType",
              "ClientRequestToken"
            ],
            members: {
              NetworkProfileName: {},
              Description: {},
              Ssid: {},
              SecurityType: {},
              EapMethod: {},
              CurrentPassword: {
                shape: "S1z"
              },
              NextPassword: {
                shape: "S20"
              },
              CertificateAuthorityArn: {},
              TrustAnchors: {
                shape: "S21"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkProfileArn: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        CreateProfile: {
          input: {
            type: "structure",
            required: [
              "ProfileName",
              "Timezone",
              "Address",
              "DistanceUnit",
              "TemperatureUnit",
              "WakeWord"
            ],
            members: {
              ProfileName: {},
              Timezone: {},
              Address: {},
              DistanceUnit: {},
              TemperatureUnit: {},
              WakeWord: {},
              Locale: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              SetupModeDisabled: {
                type: "boolean"
              },
              MaxVolumeLimit: {
                type: "integer"
              },
              PSTNEnabled: {
                type: "boolean"
              },
              DataRetentionOptIn: {
                type: "boolean"
              },
              MeetingRoomConfiguration: {
                type: "structure",
                members: {
                  RoomUtilizationMetricsEnabled: {
                    type: "boolean"
                  },
                  EndOfMeetingReminder: {
                    type: "structure",
                    required: [
                      "ReminderAtMinutes",
                      "ReminderType",
                      "Enabled"
                    ],
                    members: {
                      ReminderAtMinutes: {
                        shape: "S2g"
                      },
                      ReminderType: {},
                      Enabled: {
                        type: "boolean"
                      }
                    }
                  },
                  InstantBooking: {
                    type: "structure",
                    required: [
                      "DurationInMinutes",
                      "Enabled"
                    ],
                    members: {
                      DurationInMinutes: {
                        type: "integer"
                      },
                      Enabled: {
                        type: "boolean"
                      }
                    }
                  },
                  RequireCheckIn: {
                    type: "structure",
                    required: [
                      "ReleaseAfterMinutes",
                      "Enabled"
                    ],
                    members: {
                      ReleaseAfterMinutes: {
                        type: "integer"
                      },
                      Enabled: {
                        type: "boolean"
                      }
                    }
                  },
                  ProactiveJoin: {
                    type: "structure",
                    required: [
                      "EnabledByMotion"
                    ],
                    members: {
                      EnabledByMotion: {
                        type: "boolean"
                      }
                    }
                  }
                }
              },
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProfileArn: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        CreateRoom: {
          input: {
            type: "structure",
            required: [
              "RoomName"
            ],
            members: {
              RoomName: {},
              Description: {},
              ProfileArn: {},
              ProviderCalendarId: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RoomArn: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        CreateSkillGroup: {
          input: {
            type: "structure",
            required: [
              "SkillGroupName"
            ],
            members: {
              SkillGroupName: {},
              Description: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SkillGroupArn: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        CreateUser: {
          input: {
            type: "structure",
            required: [
              "UserId"
            ],
            members: {
              UserId: {},
              FirstName: {},
              LastName: {},
              Email: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserArn: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        DeleteAddressBook: {
          input: {
            type: "structure",
            required: [
              "AddressBookArn"
            ],
            members: {
              AddressBookArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        DeleteBusinessReportSchedule: {
          input: {
            type: "structure",
            required: [
              "ScheduleArn"
            ],
            members: {
              ScheduleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        DeleteConferenceProvider: {
          input: {
            type: "structure",
            required: [
              "ConferenceProviderArn"
            ],
            members: {
              ConferenceProviderArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        DeleteContact: {
          input: {
            type: "structure",
            required: [
              "ContactArn"
            ],
            members: {
              ContactArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        DeleteDevice: {
          input: {
            type: "structure",
            required: [
              "DeviceArn"
            ],
            members: {
              DeviceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        DeleteDeviceUsageData: {
          input: {
            type: "structure",
            required: [
              "DeviceArn",
              "DeviceUsageType"
            ],
            members: {
              DeviceArn: {},
              DeviceUsageType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        DeleteGatewayGroup: {
          input: {
            type: "structure",
            required: [
              "GatewayGroupArn"
            ],
            members: {
              GatewayGroupArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        DeleteNetworkProfile: {
          input: {
            type: "structure",
            required: [
              "NetworkProfileArn"
            ],
            members: {
              NetworkProfileArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        DeleteProfile: {
          input: {
            type: "structure",
            members: {
              ProfileArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        DeleteRoom: {
          input: {
            type: "structure",
            members: {
              RoomArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        DeleteRoomSkillParameter: {
          input: {
            type: "structure",
            required: [
              "SkillId",
              "ParameterKey"
            ],
            members: {
              RoomArn: {},
              SkillId: {},
              ParameterKey: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        DeleteSkillAuthorization: {
          input: {
            type: "structure",
            required: [
              "SkillId"
            ],
            members: {
              SkillId: {},
              RoomArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        DeleteSkillGroup: {
          input: {
            type: "structure",
            members: {
              SkillGroupArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        DeleteUser: {
          input: {
            type: "structure",
            required: [
              "EnrollmentId"
            ],
            members: {
              UserArn: {},
              EnrollmentId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        DisassociateContactFromAddressBook: {
          input: {
            type: "structure",
            required: [
              "ContactArn",
              "AddressBookArn"
            ],
            members: {
              ContactArn: {},
              AddressBookArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        DisassociateDeviceFromRoom: {
          input: {
            type: "structure",
            members: {
              DeviceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        DisassociateSkillFromSkillGroup: {
          input: {
            type: "structure",
            required: [
              "SkillId"
            ],
            members: {
              SkillGroupArn: {},
              SkillId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        DisassociateSkillFromUsers: {
          input: {
            type: "structure",
            required: [
              "SkillId"
            ],
            members: {
              SkillId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        DisassociateSkillGroupFromRoom: {
          input: {
            type: "structure",
            members: {
              SkillGroupArn: {},
              RoomArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        ForgetSmartHomeAppliances: {
          input: {
            type: "structure",
            required: [
              "RoomArn"
            ],
            members: {
              RoomArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        GetAddressBook: {
          input: {
            type: "structure",
            required: [
              "AddressBookArn"
            ],
            members: {
              AddressBookArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AddressBook: {
                type: "structure",
                members: {
                  AddressBookArn: {},
                  Name: {},
                  Description: {}
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        GetConferencePreference: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              Preference: {
                shape: "S4e"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        GetConferenceProvider: {
          input: {
            type: "structure",
            required: [
              "ConferenceProviderArn"
            ],
            members: {
              ConferenceProviderArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConferenceProvider: {
                shape: "S4h"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        GetContact: {
          input: {
            type: "structure",
            required: [
              "ContactArn"
            ],
            members: {
              ContactArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Contact: {
                type: "structure",
                members: {
                  ContactArn: {},
                  DisplayName: {},
                  FirstName: {},
                  LastName: {},
                  PhoneNumber: {
                    shape: "S1g"
                  },
                  PhoneNumbers: {
                    shape: "S1h"
                  },
                  SipAddresses: {
                    shape: "S1k"
                  }
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        GetDevice: {
          input: {
            type: "structure",
            members: {
              DeviceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Device: {
                type: "structure",
                members: {
                  DeviceArn: {},
                  DeviceSerialNumber: {},
                  DeviceType: {},
                  DeviceName: {},
                  SoftwareVersion: {},
                  MacAddress: {},
                  RoomArn: {},
                  DeviceStatus: {},
                  DeviceStatusInfo: {
                    shape: "S4u"
                  },
                  NetworkProfileInfo: {
                    type: "structure",
                    members: {
                      NetworkProfileArn: {},
                      CertificateArn: {},
                      CertificateExpirationTime: {
                        type: "timestamp"
                      }
                    }
                  }
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        GetGateway: {
          input: {
            type: "structure",
            required: [
              "GatewayArn"
            ],
            members: {
              GatewayArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Gateway: {
                type: "structure",
                members: {
                  Arn: {},
                  Name: {},
                  Description: {},
                  GatewayGroupArn: {},
                  SoftwareVersion: {}
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        GetGatewayGroup: {
          input: {
            type: "structure",
            required: [
              "GatewayGroupArn"
            ],
            members: {
              GatewayGroupArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayGroup: {
                type: "structure",
                members: {
                  Arn: {},
                  Name: {},
                  Description: {}
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        GetInvitationConfiguration: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              OrganizationName: {},
              ContactEmail: {},
              PrivateSkillIds: {
                shape: "S5f"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        GetNetworkProfile: {
          input: {
            type: "structure",
            required: [
              "NetworkProfileArn"
            ],
            members: {
              NetworkProfileArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkProfile: {
                type: "structure",
                members: {
                  NetworkProfileArn: {},
                  NetworkProfileName: {},
                  Description: {},
                  Ssid: {},
                  SecurityType: {},
                  EapMethod: {},
                  CurrentPassword: {
                    shape: "S1z"
                  },
                  NextPassword: {
                    shape: "S20"
                  },
                  CertificateAuthorityArn: {},
                  TrustAnchors: {
                    shape: "S21"
                  }
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        GetProfile: {
          input: {
            type: "structure",
            members: {
              ProfileArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Profile: {
                type: "structure",
                members: {
                  ProfileArn: {},
                  ProfileName: {},
                  IsDefault: {
                    type: "boolean"
                  },
                  Address: {},
                  Timezone: {},
                  DistanceUnit: {},
                  TemperatureUnit: {},
                  WakeWord: {},
                  Locale: {},
                  SetupModeDisabled: {
                    type: "boolean"
                  },
                  MaxVolumeLimit: {
                    type: "integer"
                  },
                  PSTNEnabled: {
                    type: "boolean"
                  },
                  DataRetentionOptIn: {
                    type: "boolean"
                  },
                  AddressBookArn: {},
                  MeetingRoomConfiguration: {
                    type: "structure",
                    members: {
                      RoomUtilizationMetricsEnabled: {
                        type: "boolean"
                      },
                      EndOfMeetingReminder: {
                        type: "structure",
                        members: {
                          ReminderAtMinutes: {
                            shape: "S2g"
                          },
                          ReminderType: {},
                          Enabled: {
                            type: "boolean"
                          }
                        }
                      },
                      InstantBooking: {
                        type: "structure",
                        members: {
                          DurationInMinutes: {
                            type: "integer"
                          },
                          Enabled: {
                            type: "boolean"
                          }
                        }
                      },
                      RequireCheckIn: {
                        type: "structure",
                        members: {
                          ReleaseAfterMinutes: {
                            type: "integer"
                          },
                          Enabled: {
                            type: "boolean"
                          }
                        }
                      },
                      ProactiveJoin: {
                        type: "structure",
                        members: {
                          EnabledByMotion: {
                            type: "boolean"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        GetRoom: {
          input: {
            type: "structure",
            members: {
              RoomArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Room: {
                type: "structure",
                members: {
                  RoomArn: {},
                  RoomName: {},
                  Description: {},
                  ProviderCalendarId: {},
                  ProfileArn: {}
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        GetRoomSkillParameter: {
          input: {
            type: "structure",
            required: [
              "SkillId",
              "ParameterKey"
            ],
            members: {
              RoomArn: {},
              SkillId: {},
              ParameterKey: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RoomSkillParameter: {
                shape: "S5w"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        GetSkillGroup: {
          input: {
            type: "structure",
            members: {
              SkillGroupArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SkillGroup: {
                type: "structure",
                members: {
                  SkillGroupArn: {},
                  SkillGroupName: {},
                  Description: {}
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        ListBusinessReportSchedules: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BusinessReportSchedules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ScheduleArn: {},
                    ScheduleName: {},
                    S3BucketName: {},
                    S3KeyPrefix: {},
                    Format: {},
                    ContentRange: {
                      shape: "Sv"
                    },
                    Recurrence: {
                      shape: "Sx"
                    },
                    LastBusinessReport: {
                      type: "structure",
                      members: {
                        Status: {},
                        FailureCode: {},
                        S3Location: {
                          type: "structure",
                          members: {
                            Path: {},
                            BucketName: {}
                          }
                        },
                        DeliveryTime: {
                          type: "timestamp"
                        },
                        DownloadUrl: {}
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        ListConferenceProviders: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConferenceProviders: {
                type: "list",
                member: {
                  shape: "S4h"
                }
              },
              NextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        ListDeviceEvents: {
          input: {
            type: "structure",
            required: [
              "DeviceArn"
            ],
            members: {
              DeviceArn: {},
              EventType: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeviceEvents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    Value: {},
                    Timestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        ListGatewayGroups: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Name: {},
                    Description: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        ListGateways: {
          input: {
            type: "structure",
            members: {
              GatewayGroupArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Gateways: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Name: {},
                    Description: {},
                    GatewayGroupArn: {},
                    SoftwareVersion: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        ListSkills: {
          input: {
            type: "structure",
            members: {
              SkillGroupArn: {},
              EnablementType: {},
              SkillType: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SkillSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SkillId: {},
                    SkillName: {},
                    SupportsLinking: {
                      type: "boolean"
                    },
                    EnablementType: {},
                    SkillType: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        ListSkillsStoreCategories: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CategoryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CategoryId: {
                      type: "long"
                    },
                    CategoryName: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        ListSkillsStoreSkillsByCategory: {
          input: {
            type: "structure",
            required: [
              "CategoryId"
            ],
            members: {
              CategoryId: {
                type: "long"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SkillsStoreSkills: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SkillId: {},
                    SkillName: {},
                    ShortDescription: {},
                    IconUrl: {},
                    SampleUtterances: {
                      type: "list",
                      member: {}
                    },
                    SkillDetails: {
                      type: "structure",
                      members: {
                        ProductDescription: {},
                        InvocationPhrase: {},
                        ReleaseDate: {},
                        EndUserLicenseAgreement: {},
                        GenericKeywords: {
                          type: "list",
                          member: {}
                        },
                        BulletPoints: {
                          type: "list",
                          member: {}
                        },
                        NewInThisVersionBulletPoints: {
                          type: "list",
                          member: {}
                        },
                        SkillTypes: {
                          type: "list",
                          member: {}
                        },
                        Reviews: {
                          type: "map",
                          key: {},
                          value: {}
                        },
                        DeveloperInfo: {
                          type: "structure",
                          members: {
                            DeveloperName: {},
                            PrivacyPolicy: {},
                            Email: {},
                            Url: {}
                          }
                        }
                      }
                    },
                    SupportsLinking: {
                      type: "boolean"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        ListSmartHomeAppliances: {
          input: {
            type: "structure",
            required: [
              "RoomArn"
            ],
            members: {
              RoomArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SmartHomeAppliances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FriendlyName: {},
                    Description: {},
                    ManufacturerName: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        ListTags: {
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sl"
              },
              NextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        PutConferencePreference: {
          input: {
            type: "structure",
            required: [
              "ConferencePreference"
            ],
            members: {
              ConferencePreference: {
                shape: "S4e"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        PutInvitationConfiguration: {
          input: {
            type: "structure",
            required: [
              "OrganizationName"
            ],
            members: {
              OrganizationName: {},
              ContactEmail: {},
              PrivateSkillIds: {
                shape: "S5f"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        PutRoomSkillParameter: {
          input: {
            type: "structure",
            required: [
              "SkillId",
              "RoomSkillParameter"
            ],
            members: {
              RoomArn: {},
              SkillId: {},
              RoomSkillParameter: {
                shape: "S5w"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        PutSkillAuthorization: {
          input: {
            type: "structure",
            required: [
              "AuthorizationResult",
              "SkillId"
            ],
            members: {
              AuthorizationResult: {
                type: "map",
                key: {},
                value: {},
                sensitive: true
              },
              SkillId: {},
              RoomArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        RegisterAVSDevice: {
          input: {
            type: "structure",
            required: [
              "ClientId",
              "UserCode",
              "ProductId",
              "AmazonId"
            ],
            members: {
              ClientId: {},
              UserCode: {},
              ProductId: {},
              DeviceSerialNumber: {},
              AmazonId: {},
              RoomArn: {},
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeviceArn: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        RejectSkill: {
          input: {
            type: "structure",
            required: [
              "SkillId"
            ],
            members: {
              SkillId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        ResolveRoom: {
          input: {
            type: "structure",
            required: [
              "UserId",
              "SkillId"
            ],
            members: {
              UserId: {},
              SkillId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RoomArn: {},
              RoomName: {},
              RoomSkillParameters: {
                type: "list",
                member: {
                  shape: "S5w"
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        RevokeInvitation: {
          input: {
            type: "structure",
            members: {
              UserArn: {},
              EnrollmentId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        SearchAddressBooks: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S94"
              },
              SortCriteria: {
                shape: "S99"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AddressBooks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AddressBookArn: {},
                    Name: {},
                    Description: {}
                  }
                }
              },
              NextToken: {},
              TotalCount: {
                type: "integer"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        SearchContacts: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S94"
              },
              SortCriteria: {
                shape: "S99"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Contacts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ContactArn: {},
                    DisplayName: {},
                    FirstName: {},
                    LastName: {},
                    PhoneNumber: {
                      shape: "S1g"
                    },
                    PhoneNumbers: {
                      shape: "S1h"
                    },
                    SipAddresses: {
                      shape: "S1k"
                    }
                  }
                }
              },
              NextToken: {},
              TotalCount: {
                type: "integer"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        SearchDevices: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S94"
              },
              SortCriteria: {
                shape: "S99"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Devices: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DeviceArn: {},
                    DeviceSerialNumber: {},
                    DeviceType: {},
                    DeviceName: {},
                    SoftwareVersion: {},
                    MacAddress: {},
                    DeviceStatus: {},
                    NetworkProfileArn: {},
                    NetworkProfileName: {},
                    RoomArn: {},
                    RoomName: {},
                    DeviceStatusInfo: {
                      shape: "S4u"
                    },
                    CreatedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {},
              TotalCount: {
                type: "integer"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        SearchNetworkProfiles: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S94"
              },
              SortCriteria: {
                shape: "S99"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkProfiles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    NetworkProfileArn: {},
                    NetworkProfileName: {},
                    Description: {},
                    Ssid: {},
                    SecurityType: {},
                    EapMethod: {},
                    CertificateAuthorityArn: {}
                  }
                }
              },
              NextToken: {},
              TotalCount: {
                type: "integer"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        SearchProfiles: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S94"
              },
              SortCriteria: {
                shape: "S99"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Profiles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ProfileArn: {},
                    ProfileName: {},
                    IsDefault: {
                      type: "boolean"
                    },
                    Address: {},
                    Timezone: {},
                    DistanceUnit: {},
                    TemperatureUnit: {},
                    WakeWord: {},
                    Locale: {}
                  }
                }
              },
              NextToken: {},
              TotalCount: {
                type: "integer"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        SearchRooms: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S94"
              },
              SortCriteria: {
                shape: "S99"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Rooms: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RoomArn: {},
                    RoomName: {},
                    Description: {},
                    ProviderCalendarId: {},
                    ProfileArn: {},
                    ProfileName: {}
                  }
                }
              },
              NextToken: {},
              TotalCount: {
                type: "integer"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        SearchSkillGroups: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S94"
              },
              SortCriteria: {
                shape: "S99"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SkillGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SkillGroupArn: {},
                    SkillGroupName: {},
                    Description: {}
                  }
                }
              },
              NextToken: {},
              TotalCount: {
                type: "integer"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        SearchUsers: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S94"
              },
              SortCriteria: {
                shape: "S99"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Users: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    UserArn: {},
                    FirstName: {},
                    LastName: {},
                    Email: {},
                    EnrollmentStatus: {},
                    EnrollmentId: {}
                  }
                }
              },
              NextToken: {},
              TotalCount: {
                type: "integer"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        SendAnnouncement: {
          input: {
            type: "structure",
            required: [
              "RoomFilters",
              "Content",
              "ClientRequestToken"
            ],
            members: {
              RoomFilters: {
                shape: "S94"
              },
              Content: {
                type: "structure",
                members: {
                  TextList: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Locale",
                        "Value"
                      ],
                      members: {
                        Locale: {},
                        Value: {}
                      }
                    }
                  },
                  SsmlList: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Locale",
                        "Value"
                      ],
                      members: {
                        Locale: {},
                        Value: {}
                      }
                    }
                  },
                  AudioList: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Locale",
                        "Location"
                      ],
                      members: {
                        Locale: {},
                        Location: {}
                      }
                    }
                  }
                }
              },
              TimeToLiveInSeconds: {
                type: "integer"
              },
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AnnouncementArn: {}
            }
          }
        },
        SendInvitation: {
          input: {
            type: "structure",
            members: {
              UserArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        StartDeviceSync: {
          input: {
            type: "structure",
            required: [
              "Features"
            ],
            members: {
              RoomArn: {},
              DeviceArn: {},
              Features: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        StartSmartHomeApplianceDiscovery: {
          input: {
            type: "structure",
            required: [
              "RoomArn"
            ],
            members: {
              RoomArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "Arn",
              "Tags"
            ],
            members: {
              Arn: {},
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "Arn",
              "TagKeys"
            ],
            members: {
              Arn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        UpdateAddressBook: {
          input: {
            type: "structure",
            required: [
              "AddressBookArn"
            ],
            members: {
              AddressBookArn: {},
              Name: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        UpdateBusinessReportSchedule: {
          input: {
            type: "structure",
            required: [
              "ScheduleArn"
            ],
            members: {
              ScheduleArn: {},
              S3BucketName: {},
              S3KeyPrefix: {},
              Format: {},
              ScheduleName: {},
              Recurrence: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        UpdateConferenceProvider: {
          input: {
            type: "structure",
            required: [
              "ConferenceProviderArn",
              "ConferenceProviderType",
              "MeetingSetting"
            ],
            members: {
              ConferenceProviderArn: {},
              ConferenceProviderType: {},
              IPDialIn: {
                shape: "S13"
              },
              PSTNDialIn: {
                shape: "S16"
              },
              MeetingSetting: {
                shape: "S1b"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        UpdateContact: {
          input: {
            type: "structure",
            required: [
              "ContactArn"
            ],
            members: {
              ContactArn: {},
              DisplayName: {},
              FirstName: {},
              LastName: {},
              PhoneNumber: {
                shape: "S1g"
              },
              PhoneNumbers: {
                shape: "S1h"
              },
              SipAddresses: {
                shape: "S1k"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        UpdateDevice: {
          input: {
            type: "structure",
            members: {
              DeviceArn: {},
              DeviceName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        UpdateGateway: {
          input: {
            type: "structure",
            required: [
              "GatewayArn"
            ],
            members: {
              GatewayArn: {},
              Name: {},
              Description: {},
              SoftwareVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        UpdateGatewayGroup: {
          input: {
            type: "structure",
            required: [
              "GatewayGroupArn"
            ],
            members: {
              GatewayGroupArn: {},
              Name: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        UpdateNetworkProfile: {
          input: {
            type: "structure",
            required: [
              "NetworkProfileArn"
            ],
            members: {
              NetworkProfileArn: {},
              NetworkProfileName: {},
              Description: {},
              CurrentPassword: {
                shape: "S1z"
              },
              NextPassword: {
                shape: "S20"
              },
              CertificateAuthorityArn: {},
              TrustAnchors: {
                shape: "S21"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        UpdateProfile: {
          input: {
            type: "structure",
            members: {
              ProfileArn: {},
              ProfileName: {},
              IsDefault: {
                type: "boolean"
              },
              Timezone: {},
              Address: {},
              DistanceUnit: {},
              TemperatureUnit: {},
              WakeWord: {},
              Locale: {},
              SetupModeDisabled: {
                type: "boolean"
              },
              MaxVolumeLimit: {
                type: "integer"
              },
              PSTNEnabled: {
                type: "boolean"
              },
              DataRetentionOptIn: {
                type: "boolean"
              },
              MeetingRoomConfiguration: {
                type: "structure",
                members: {
                  RoomUtilizationMetricsEnabled: {
                    type: "boolean"
                  },
                  EndOfMeetingReminder: {
                    type: "structure",
                    members: {
                      ReminderAtMinutes: {
                        shape: "S2g"
                      },
                      ReminderType: {},
                      Enabled: {
                        type: "boolean"
                      }
                    }
                  },
                  InstantBooking: {
                    type: "structure",
                    members: {
                      DurationInMinutes: {
                        type: "integer"
                      },
                      Enabled: {
                        type: "boolean"
                      }
                    }
                  },
                  RequireCheckIn: {
                    type: "structure",
                    members: {
                      ReleaseAfterMinutes: {
                        type: "integer"
                      },
                      Enabled: {
                        type: "boolean"
                      }
                    }
                  },
                  ProactiveJoin: {
                    type: "structure",
                    required: [
                      "EnabledByMotion"
                    ],
                    members: {
                      EnabledByMotion: {
                        type: "boolean"
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        UpdateRoom: {
          input: {
            type: "structure",
            members: {
              RoomArn: {},
              RoomName: {},
              Description: {},
              ProviderCalendarId: {},
              ProfileArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        },
        UpdateSkillGroup: {
          input: {
            type: "structure",
            members: {
              SkillGroupArn: {},
              SkillGroupName: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Alexa For Business is no longer supported"
        }
      },
      shapes: {
        Sl: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sv: {
          type: "structure",
          required: [
            "Interval"
          ],
          members: {
            Interval: {}
          }
        },
        Sx: {
          type: "structure",
          members: {
            StartDate: {}
          }
        },
        S13: {
          type: "structure",
          required: [
            "Endpoint",
            "CommsProtocol"
          ],
          members: {
            Endpoint: {},
            CommsProtocol: {}
          }
        },
        S16: {
          type: "structure",
          required: [
            "CountryCode",
            "PhoneNumber",
            "OneClickIdDelay",
            "OneClickPinDelay"
          ],
          members: {
            CountryCode: {},
            PhoneNumber: {},
            OneClickIdDelay: {},
            OneClickPinDelay: {}
          }
        },
        S1b: {
          type: "structure",
          required: [
            "RequirePin"
          ],
          members: {
            RequirePin: {}
          }
        },
        S1g: {
          type: "string",
          sensitive: true
        },
        S1h: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Number",
              "Type"
            ],
            members: {
              Number: {
                shape: "S1g"
              },
              Type: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        S1k: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Uri",
              "Type"
            ],
            members: {
              Uri: {
                type: "string",
                sensitive: true
              },
              Type: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        S1z: {
          type: "string",
          sensitive: true
        },
        S20: {
          type: "string",
          sensitive: true
        },
        S21: {
          type: "list",
          member: {}
        },
        S2g: {
          type: "list",
          member: {
            type: "integer"
          }
        },
        S4e: {
          type: "structure",
          members: {
            DefaultConferenceProviderArn: {}
          }
        },
        S4h: {
          type: "structure",
          members: {
            Arn: {},
            Name: {},
            Type: {},
            IPDialIn: {
              shape: "S13"
            },
            PSTNDialIn: {
              shape: "S16"
            },
            MeetingSetting: {
              shape: "S1b"
            }
          }
        },
        S4u: {
          type: "structure",
          members: {
            DeviceStatusDetails: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Feature: {},
                  Code: {}
                }
              }
            },
            ConnectionStatus: {},
            ConnectionStatusUpdatedTime: {
              type: "timestamp"
            }
          }
        },
        S5f: {
          type: "list",
          member: {}
        },
        S5w: {
          type: "structure",
          required: [
            "ParameterKey",
            "ParameterValue"
          ],
          members: {
            ParameterKey: {},
            ParameterValue: {}
          }
        },
        S94: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Values"
            ],
            members: {
              Key: {},
              Values: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S99: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        }
      },
      deprecated: true,
      deprecatedMessage: "Alexa For Business is no longer supported"
    };
  }
});

// node_modules/aws-sdk/apis/alexaforbusiness-2017-11-09.paginators.json
var require_alexaforbusiness_2017_11_09_paginators = __commonJS({
  "node_modules/aws-sdk/apis/alexaforbusiness-2017-11-09.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListBusinessReportSchedules: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListConferenceProviders: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDeviceEvents: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListGatewayGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListGateways: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListSkills: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListSkillsStoreCategories: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListSkillsStoreSkillsByCategory: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListSmartHomeAppliances: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListTags: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        SearchAddressBooks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        SearchContacts: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        SearchDevices: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        SearchNetworkProfiles: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        SearchProfiles: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        SearchRooms: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        SearchSkillGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        SearchUsers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/alexaforbusiness.js
var require_alexaforbusiness = __commonJS({
  "node_modules/aws-sdk/clients/alexaforbusiness.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["alexaforbusiness"] = {};
    AWS2.AlexaForBusiness = Service.defineService("alexaforbusiness", ["2017-11-09"]);
    Object.defineProperty(apiLoader.services["alexaforbusiness"], "2017-11-09", {
      get: function get() {
        var model = require_alexaforbusiness_2017_11_09_min();
        model.paginators = require_alexaforbusiness_2017_11_09_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.AlexaForBusiness;
  }
});

// node_modules/aws-sdk/apis/cloud9-2017-09-23.min.json
var require_cloud9_2017_09_23_min = __commonJS({
  "node_modules/aws-sdk/apis/cloud9-2017-09-23.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-09-23",
        endpointPrefix: "cloud9",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Cloud9",
        serviceId: "Cloud9",
        signatureVersion: "v4",
        targetPrefix: "AWSCloud9WorkspaceManagementService",
        uid: "cloud9-2017-09-23"
      },
      operations: {
        CreateEnvironmentEC2: {
          input: {
            type: "structure",
            required: [
              "name",
              "instanceType",
              "imageId"
            ],
            members: {
              name: {},
              description: {
                shape: "S3"
              },
              clientRequestToken: {},
              instanceType: {},
              subnetId: {},
              imageId: {},
              automaticStopTimeMinutes: {
                type: "integer"
              },
              ownerArn: {},
              tags: {
                shape: "Sa"
              },
              connectionType: {},
              dryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              environmentId: {}
            }
          },
          idempotent: true
        },
        CreateEnvironmentMembership: {
          input: {
            type: "structure",
            required: [
              "environmentId",
              "userArn",
              "permissions"
            ],
            members: {
              environmentId: {},
              userArn: {},
              permissions: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "membership"
            ],
            members: {
              membership: {
                shape: "Sl"
              }
            }
          },
          idempotent: true
        },
        DeleteEnvironment: {
          input: {
            type: "structure",
            required: [
              "environmentId"
            ],
            members: {
              environmentId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteEnvironmentMembership: {
          input: {
            type: "structure",
            required: [
              "environmentId",
              "userArn"
            ],
            members: {
              environmentId: {},
              userArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DescribeEnvironmentMemberships: {
          input: {
            type: "structure",
            members: {
              userArn: {},
              environmentId: {},
              permissions: {
                type: "list",
                member: {}
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              memberships: {
                type: "list",
                member: {
                  shape: "Sl"
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeEnvironmentStatus: {
          input: {
            type: "structure",
            required: [
              "environmentId"
            ],
            members: {
              environmentId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "status",
              "message"
            ],
            members: {
              status: {},
              message: {}
            }
          }
        },
        DescribeEnvironments: {
          input: {
            type: "structure",
            required: [
              "environmentIds"
            ],
            members: {
              environmentIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              environments: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "type",
                    "arn",
                    "ownerArn"
                  ],
                  members: {
                    id: {},
                    name: {},
                    description: {
                      shape: "S3"
                    },
                    type: {},
                    connectionType: {},
                    arn: {},
                    ownerArn: {},
                    lifecycle: {
                      type: "structure",
                      members: {
                        status: {},
                        reason: {},
                        failureResource: {}
                      }
                    },
                    managedCredentialsStatus: {}
                  }
                }
              }
            }
          }
        },
        ListEnvironments: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              environmentIds: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sa"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {
                  shape: "Sc"
                },
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateEnvironment: {
          input: {
            type: "structure",
            required: [
              "environmentId"
            ],
            members: {
              environmentId: {},
              name: {},
              description: {
                shape: "S3"
              },
              managedCredentialsAction: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateEnvironmentMembership: {
          input: {
            type: "structure",
            required: [
              "environmentId",
              "userArn",
              "permissions"
            ],
            members: {
              environmentId: {},
              userArn: {},
              permissions: {}
            }
          },
          output: {
            type: "structure",
            members: {
              membership: {
                shape: "Sl"
              }
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S3: {
          type: "string",
          sensitive: true
        },
        Sa: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {
                shape: "Sc"
              },
              Value: {
                type: "string",
                sensitive: true
              }
            },
            sensitive: true
          },
          sensitive: true
        },
        Sc: {
          type: "string",
          sensitive: true
        },
        Sl: {
          type: "structure",
          required: [
            "permissions",
            "userId",
            "userArn",
            "environmentId"
          ],
          members: {
            permissions: {},
            userId: {},
            userArn: {},
            environmentId: {},
            lastAccess: {
              type: "timestamp"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloud9-2017-09-23.paginators.json
var require_cloud9_2017_09_23_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloud9-2017-09-23.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeEnvironmentMemberships: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListEnvironments: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/cloud9.js
var require_cloud9 = __commonJS({
  "node_modules/aws-sdk/clients/cloud9.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["cloud9"] = {};
    AWS2.Cloud9 = Service.defineService("cloud9", ["2017-09-23"]);
    Object.defineProperty(apiLoader.services["cloud9"], "2017-09-23", {
      get: function get() {
        var model = require_cloud9_2017_09_23_min();
        model.paginators = require_cloud9_2017_09_23_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Cloud9;
  }
});

// node_modules/aws-sdk/apis/serverlessrepo-2017-09-08.min.json
var require_serverlessrepo_2017_09_08_min = __commonJS({
  "node_modules/aws-sdk/apis/serverlessrepo-2017-09-08.min.json"(exports2, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2017-09-08",
        endpointPrefix: "serverlessrepo",
        signingName: "serverlessrepo",
        serviceFullName: "AWSServerlessApplicationRepository",
        serviceId: "ServerlessApplicationRepository",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "serverlessrepo-2017-09-08",
        signatureVersion: "v4"
      },
      operations: {
        CreateApplication: {
          http: {
            requestUri: "/applications",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              Author: {
                locationName: "author"
              },
              Description: {
                locationName: "description"
              },
              HomePageUrl: {
                locationName: "homePageUrl"
              },
              Labels: {
                shape: "S3",
                locationName: "labels"
              },
              LicenseBody: {
                locationName: "licenseBody"
              },
              LicenseUrl: {
                locationName: "licenseUrl"
              },
              Name: {
                locationName: "name"
              },
              ReadmeBody: {
                locationName: "readmeBody"
              },
              ReadmeUrl: {
                locationName: "readmeUrl"
              },
              SemanticVersion: {
                locationName: "semanticVersion"
              },
              SourceCodeArchiveUrl: {
                locationName: "sourceCodeArchiveUrl"
              },
              SourceCodeUrl: {
                locationName: "sourceCodeUrl"
              },
              SpdxLicenseId: {
                locationName: "spdxLicenseId"
              },
              TemplateBody: {
                locationName: "templateBody"
              },
              TemplateUrl: {
                locationName: "templateUrl"
              }
            },
            required: [
              "Description",
              "Name",
              "Author"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApplicationId: {
                locationName: "applicationId"
              },
              Author: {
                locationName: "author"
              },
              CreationTime: {
                locationName: "creationTime"
              },
              Description: {
                locationName: "description"
              },
              HomePageUrl: {
                locationName: "homePageUrl"
              },
              IsVerifiedAuthor: {
                locationName: "isVerifiedAuthor",
                type: "boolean"
              },
              Labels: {
                shape: "S3",
                locationName: "labels"
              },
              LicenseUrl: {
                locationName: "licenseUrl"
              },
              Name: {
                locationName: "name"
              },
              ReadmeUrl: {
                locationName: "readmeUrl"
              },
              SpdxLicenseId: {
                locationName: "spdxLicenseId"
              },
              VerifiedAuthorUrl: {
                locationName: "verifiedAuthorUrl"
              },
              Version: {
                shape: "S6",
                locationName: "version"
              }
            }
          }
        },
        CreateApplicationVersion: {
          http: {
            method: "PUT",
            requestUri: "/applications/{applicationId}/versions/{semanticVersion}",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              SemanticVersion: {
                location: "uri",
                locationName: "semanticVersion"
              },
              SourceCodeArchiveUrl: {
                locationName: "sourceCodeArchiveUrl"
              },
              SourceCodeUrl: {
                locationName: "sourceCodeUrl"
              },
              TemplateBody: {
                locationName: "templateBody"
              },
              TemplateUrl: {
                locationName: "templateUrl"
              }
            },
            required: [
              "ApplicationId",
              "SemanticVersion"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApplicationId: {
                locationName: "applicationId"
              },
              CreationTime: {
                locationName: "creationTime"
              },
              ParameterDefinitions: {
                shape: "S7",
                locationName: "parameterDefinitions"
              },
              RequiredCapabilities: {
                shape: "Sa",
                locationName: "requiredCapabilities"
              },
              ResourcesSupported: {
                locationName: "resourcesSupported",
                type: "boolean"
              },
              SemanticVersion: {
                locationName: "semanticVersion"
              },
              SourceCodeArchiveUrl: {
                locationName: "sourceCodeArchiveUrl"
              },
              SourceCodeUrl: {
                locationName: "sourceCodeUrl"
              },
              TemplateUrl: {
                locationName: "templateUrl"
              }
            }
          }
        },
        CreateCloudFormationChangeSet: {
          http: {
            requestUri: "/applications/{applicationId}/changesets",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              Capabilities: {
                shape: "S3",
                locationName: "capabilities"
              },
              ChangeSetName: {
                locationName: "changeSetName"
              },
              ClientToken: {
                locationName: "clientToken"
              },
              Description: {
                locationName: "description"
              },
              NotificationArns: {
                shape: "S3",
                locationName: "notificationArns"
              },
              ParameterOverrides: {
                locationName: "parameterOverrides",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {
                      locationName: "name"
                    },
                    Value: {
                      locationName: "value"
                    }
                  },
                  required: [
                    "Value",
                    "Name"
                  ]
                }
              },
              ResourceTypes: {
                shape: "S3",
                locationName: "resourceTypes"
              },
              RollbackConfiguration: {
                locationName: "rollbackConfiguration",
                type: "structure",
                members: {
                  MonitoringTimeInMinutes: {
                    locationName: "monitoringTimeInMinutes",
                    type: "integer"
                  },
                  RollbackTriggers: {
                    locationName: "rollbackTriggers",
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Arn: {
                          locationName: "arn"
                        },
                        Type: {
                          locationName: "type"
                        }
                      },
                      required: [
                        "Type",
                        "Arn"
                      ]
                    }
                  }
                }
              },
              SemanticVersion: {
                locationName: "semanticVersion"
              },
              StackName: {
                locationName: "stackName"
              },
              Tags: {
                locationName: "tags",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Key: {
                      locationName: "key"
                    },
                    Value: {
                      locationName: "value"
                    }
                  },
                  required: [
                    "Value",
                    "Key"
                  ]
                }
              },
              TemplateId: {
                locationName: "templateId"
              }
            },
            required: [
              "ApplicationId",
              "StackName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApplicationId: {
                locationName: "applicationId"
              },
              ChangeSetId: {
                locationName: "changeSetId"
              },
              SemanticVersion: {
                locationName: "semanticVersion"
              },
              StackId: {
                locationName: "stackId"
              }
            }
          }
        },
        CreateCloudFormationTemplate: {
          http: {
            requestUri: "/applications/{applicationId}/templates",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              SemanticVersion: {
                locationName: "semanticVersion"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApplicationId: {
                locationName: "applicationId"
              },
              CreationTime: {
                locationName: "creationTime"
              },
              ExpirationTime: {
                locationName: "expirationTime"
              },
              SemanticVersion: {
                locationName: "semanticVersion"
              },
              Status: {
                locationName: "status"
              },
              TemplateId: {
                locationName: "templateId"
              },
              TemplateUrl: {
                locationName: "templateUrl"
              }
            }
          }
        },
        DeleteApplication: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{applicationId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "applicationId"
              }
            },
            required: [
              "ApplicationId"
            ]
          }
        },
        GetApplication: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              SemanticVersion: {
                location: "querystring",
                locationName: "semanticVersion"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApplicationId: {
                locationName: "applicationId"
              },
              Author: {
                locationName: "author"
              },
              CreationTime: {
                locationName: "creationTime"
              },
              Description: {
                locationName: "description"
              },
              HomePageUrl: {
                locationName: "homePageUrl"
              },
              IsVerifiedAuthor: {
                locationName: "isVerifiedAuthor",
                type: "boolean"
              },
              Labels: {
                shape: "S3",
                locationName: "labels"
              },
              LicenseUrl: {
                locationName: "licenseUrl"
              },
              Name: {
                locationName: "name"
              },
              ReadmeUrl: {
                locationName: "readmeUrl"
              },
              SpdxLicenseId: {
                locationName: "spdxLicenseId"
              },
              VerifiedAuthorUrl: {
                locationName: "verifiedAuthorUrl"
              },
              Version: {
                shape: "S6",
                locationName: "version"
              }
            }
          }
        },
        GetApplicationPolicy: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "applicationId"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Statements: {
                shape: "Sv",
                locationName: "statements"
              }
            }
          }
        },
        GetCloudFormationTemplate: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/templates/{templateId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              TemplateId: {
                location: "uri",
                locationName: "templateId"
              }
            },
            required: [
              "ApplicationId",
              "TemplateId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApplicationId: {
                locationName: "applicationId"
              },
              CreationTime: {
                locationName: "creationTime"
              },
              ExpirationTime: {
                locationName: "expirationTime"
              },
              SemanticVersion: {
                locationName: "semanticVersion"
              },
              Status: {
                locationName: "status"
              },
              TemplateId: {
                locationName: "templateId"
              },
              TemplateUrl: {
                locationName: "templateUrl"
              }
            }
          }
        },
        ListApplicationDependencies: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/dependencies",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              MaxItems: {
                location: "querystring",
                locationName: "maxItems",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              SemanticVersion: {
                location: "querystring",
                locationName: "semanticVersion"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Dependencies: {
                locationName: "dependencies",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApplicationId: {
                      locationName: "applicationId"
                    },
                    SemanticVersion: {
                      locationName: "semanticVersion"
                    }
                  },
                  required: [
                    "ApplicationId",
                    "SemanticVersion"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListApplicationVersions: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              MaxItems: {
                location: "querystring",
                locationName: "maxItems",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Versions: {
                locationName: "versions",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApplicationId: {
                      locationName: "applicationId"
                    },
                    CreationTime: {
                      locationName: "creationTime"
                    },
                    SemanticVersion: {
                      locationName: "semanticVersion"
                    },
                    SourceCodeUrl: {
                      locationName: "sourceCodeUrl"
                    }
                  },
                  required: [
                    "CreationTime",
                    "ApplicationId",
                    "SemanticVersion"
                  ]
                }
              }
            }
          }
        },
        ListApplications: {
          http: {
            method: "GET",
            requestUri: "/applications",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxItems: {
                location: "querystring",
                locationName: "maxItems",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Applications: {
                locationName: "applications",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApplicationId: {
                      locationName: "applicationId"
                    },
                    Author: {
                      locationName: "author"
                    },
                    CreationTime: {
                      locationName: "creationTime"
                    },
                    Description: {
                      locationName: "description"
                    },
                    HomePageUrl: {
                      locationName: "homePageUrl"
                    },
                    Labels: {
                      shape: "S3",
                      locationName: "labels"
                    },
                    Name: {
                      locationName: "name"
                    },
                    SpdxLicenseId: {
                      locationName: "spdxLicenseId"
                    }
                  },
                  required: [
                    "Description",
                    "Author",
                    "ApplicationId",
                    "Name"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        PutApplicationPolicy: {
          http: {
            method: "PUT",
            requestUri: "/applications/{applicationId}/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              Statements: {
                shape: "Sv",
                locationName: "statements"
              }
            },
            required: [
              "ApplicationId",
              "Statements"
            ]
          },
          output: {
            type: "structure",
            members: {
              Statements: {
                shape: "Sv",
                locationName: "statements"
              }
            }
          }
        },
        UnshareApplication: {
          http: {
            requestUri: "/applications/{applicationId}/unshare",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              OrganizationId: {
                locationName: "organizationId"
              }
            },
            required: [
              "ApplicationId",
              "OrganizationId"
            ]
          }
        },
        UpdateApplication: {
          http: {
            method: "PATCH",
            requestUri: "/applications/{applicationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              Author: {
                locationName: "author"
              },
              Description: {
                locationName: "description"
              },
              HomePageUrl: {
                locationName: "homePageUrl"
              },
              Labels: {
                shape: "S3",
                locationName: "labels"
              },
              ReadmeBody: {
                locationName: "readmeBody"
              },
              ReadmeUrl: {
                locationName: "readmeUrl"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApplicationId: {
                locationName: "applicationId"
              },
              Author: {
                locationName: "author"
              },
              CreationTime: {
                locationName: "creationTime"
              },
              Description: {
                locationName: "description"
              },
              HomePageUrl: {
                locationName: "homePageUrl"
              },
              IsVerifiedAuthor: {
                locationName: "isVerifiedAuthor",
                type: "boolean"
              },
              Labels: {
                shape: "S3",
                locationName: "labels"
              },
              LicenseUrl: {
                locationName: "licenseUrl"
              },
              Name: {
                locationName: "name"
              },
              ReadmeUrl: {
                locationName: "readmeUrl"
              },
              SpdxLicenseId: {
                locationName: "spdxLicenseId"
              },
              VerifiedAuthorUrl: {
                locationName: "verifiedAuthorUrl"
              },
              Version: {
                shape: "S6",
                locationName: "version"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {}
        },
        S6: {
          type: "structure",
          members: {
            ApplicationId: {
              locationName: "applicationId"
            },
            CreationTime: {
              locationName: "creationTime"
            },
            ParameterDefinitions: {
              shape: "S7",
              locationName: "parameterDefinitions"
            },
            RequiredCapabilities: {
              shape: "Sa",
              locationName: "requiredCapabilities"
            },
            ResourcesSupported: {
              locationName: "resourcesSupported",
              type: "boolean"
            },
            SemanticVersion: {
              locationName: "semanticVersion"
            },
            SourceCodeArchiveUrl: {
              locationName: "sourceCodeArchiveUrl"
            },
            SourceCodeUrl: {
              locationName: "sourceCodeUrl"
            },
            TemplateUrl: {
              locationName: "templateUrl"
            }
          },
          required: [
            "TemplateUrl",
            "ParameterDefinitions",
            "ResourcesSupported",
            "CreationTime",
            "RequiredCapabilities",
            "ApplicationId",
            "SemanticVersion"
          ]
        },
        S7: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AllowedPattern: {
                locationName: "allowedPattern"
              },
              AllowedValues: {
                shape: "S3",
                locationName: "allowedValues"
              },
              ConstraintDescription: {
                locationName: "constraintDescription"
              },
              DefaultValue: {
                locationName: "defaultValue"
              },
              Description: {
                locationName: "description"
              },
              MaxLength: {
                locationName: "maxLength",
                type: "integer"
              },
              MaxValue: {
                locationName: "maxValue",
                type: "integer"
              },
              MinLength: {
                locationName: "minLength",
                type: "integer"
              },
              MinValue: {
                locationName: "minValue",
                type: "integer"
              },
              Name: {
                locationName: "name"
              },
              NoEcho: {
                locationName: "noEcho",
                type: "boolean"
              },
              ReferencedByResources: {
                shape: "S3",
                locationName: "referencedByResources"
              },
              Type: {
                locationName: "type"
              }
            },
            required: [
              "ReferencedByResources",
              "Name"
            ]
          }
        },
        Sa: {
          type: "list",
          member: {}
        },
        Sv: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Actions: {
                shape: "S3",
                locationName: "actions"
              },
              PrincipalOrgIDs: {
                shape: "S3",
                locationName: "principalOrgIDs"
              },
              Principals: {
                shape: "S3",
                locationName: "principals"
              },
              StatementId: {
                locationName: "statementId"
              }
            },
            required: [
              "Principals",
              "Actions"
            ]
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/serverlessrepo-2017-09-08.paginators.json
var require_serverlessrepo_2017_09_08_paginators = __commonJS({
  "node_modules/aws-sdk/apis/serverlessrepo-2017-09-08.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListApplicationVersions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxItems"
        },
        ListApplications: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxItems"
        },
        ListApplicationDependencies: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxItems"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/serverlessapplicationrepository.js
var require_serverlessapplicationrepository = __commonJS({
  "node_modules/aws-sdk/clients/serverlessapplicationrepository.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["serverlessapplicationrepository"] = {};
    AWS2.ServerlessApplicationRepository = Service.defineService("serverlessapplicationrepository", ["2017-09-08"]);
    Object.defineProperty(apiLoader.services["serverlessapplicationrepository"], "2017-09-08", {
      get: function get() {
        var model = require_serverlessrepo_2017_09_08_min();
        model.paginators = require_serverlessrepo_2017_09_08_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ServerlessApplicationRepository;
  }
});

// node_modules/aws-sdk/apis/servicediscovery-2017-03-14.min.json
var require_servicediscovery_2017_03_14_min = __commonJS({
  "node_modules/aws-sdk/apis/servicediscovery-2017-03-14.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-03-14",
        endpointPrefix: "servicediscovery",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "ServiceDiscovery",
        serviceFullName: "AWS Cloud Map",
        serviceId: "ServiceDiscovery",
        signatureVersion: "v4",
        targetPrefix: "Route53AutoNaming_v20170314",
        uid: "servicediscovery-2017-03-14"
      },
      operations: {
        CreateHttpNamespace: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              CreatorRequestId: {
                idempotencyToken: true
              },
              Description: {},
              Tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        CreatePrivateDnsNamespace: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Vpc"
            ],
            members: {
              Name: {},
              CreatorRequestId: {
                idempotencyToken: true
              },
              Description: {},
              Vpc: {},
              Tags: {
                shape: "S5"
              },
              Properties: {
                type: "structure",
                required: [
                  "DnsProperties"
                ],
                members: {
                  DnsProperties: {
                    type: "structure",
                    required: [
                      "SOA"
                    ],
                    members: {
                      SOA: {
                        shape: "Sf"
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        CreatePublicDnsNamespace: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              CreatorRequestId: {
                idempotencyToken: true
              },
              Description: {},
              Tags: {
                shape: "S5"
              },
              Properties: {
                type: "structure",
                required: [
                  "DnsProperties"
                ],
                members: {
                  DnsProperties: {
                    type: "structure",
                    required: [
                      "SOA"
                    ],
                    members: {
                      SOA: {
                        shape: "Sf"
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        CreateService: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              NamespaceId: {},
              CreatorRequestId: {
                idempotencyToken: true
              },
              Description: {},
              DnsConfig: {
                shape: "Sp"
              },
              HealthCheckConfig: {
                shape: "Su"
              },
              HealthCheckCustomConfig: {
                shape: "Sy"
              },
              Tags: {
                shape: "S5"
              },
              Type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Service: {
                shape: "S11"
              }
            }
          }
        },
        DeleteNamespace: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        DeleteService: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeregisterInstance: {
          input: {
            type: "structure",
            required: [
              "ServiceId",
              "InstanceId"
            ],
            members: {
              ServiceId: {},
              InstanceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        DiscoverInstances: {
          input: {
            type: "structure",
            required: [
              "NamespaceName",
              "ServiceName"
            ],
            members: {
              NamespaceName: {},
              ServiceName: {},
              MaxResults: {
                type: "integer"
              },
              QueryParameters: {
                shape: "S1f"
              },
              OptionalParameters: {
                shape: "S1f"
              },
              HealthStatus: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Instances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InstanceId: {},
                    NamespaceName: {},
                    ServiceName: {},
                    HealthStatus: {},
                    Attributes: {
                      shape: "S1f"
                    }
                  }
                }
              },
              InstancesRevision: {
                type: "long"
              }
            }
          },
          endpoint: {
            hostPrefix: "data-"
          }
        },
        DiscoverInstancesRevision: {
          input: {
            type: "structure",
            required: [
              "NamespaceName",
              "ServiceName"
            ],
            members: {
              NamespaceName: {},
              ServiceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstancesRevision: {
                type: "long"
              }
            }
          },
          endpoint: {
            hostPrefix: "data-"
          }
        },
        GetInstance: {
          input: {
            type: "structure",
            required: [
              "ServiceId",
              "InstanceId"
            ],
            members: {
              ServiceId: {},
              InstanceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Instance: {
                type: "structure",
                required: [
                  "Id"
                ],
                members: {
                  Id: {},
                  CreatorRequestId: {},
                  Attributes: {
                    shape: "S1f"
                  }
                }
              }
            }
          }
        },
        GetInstancesHealthStatus: {
          input: {
            type: "structure",
            required: [
              "ServiceId"
            ],
            members: {
              ServiceId: {},
              Instances: {
                type: "list",
                member: {}
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                type: "map",
                key: {},
                value: {}
              },
              NextToken: {}
            }
          }
        },
        GetNamespace: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Namespace: {
                type: "structure",
                members: {
                  Id: {},
                  Arn: {},
                  Name: {},
                  Type: {},
                  Description: {},
                  ServiceCount: {
                    type: "integer"
                  },
                  Properties: {
                    shape: "S23"
                  },
                  CreateDate: {
                    type: "timestamp"
                  },
                  CreatorRequestId: {}
                }
              }
            }
          }
        },
        GetOperation: {
          input: {
            type: "structure",
            required: [
              "OperationId"
            ],
            members: {
              OperationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Operation: {
                type: "structure",
                members: {
                  Id: {},
                  Type: {},
                  Status: {},
                  ErrorMessage: {},
                  ErrorCode: {},
                  CreateDate: {
                    type: "timestamp"
                  },
                  UpdateDate: {
                    type: "timestamp"
                  },
                  Targets: {
                    type: "map",
                    key: {},
                    value: {}
                  }
                }
              }
            }
          }
        },
        GetService: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Service: {
                shape: "S11"
              }
            }
          }
        },
        ListInstances: {
          input: {
            type: "structure",
            required: [
              "ServiceId"
            ],
            members: {
              ServiceId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Instances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Attributes: {
                      shape: "S1f"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListNamespaces: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Values"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      shape: "S2p"
                    },
                    Condition: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Namespaces: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Name: {},
                    Type: {},
                    Description: {},
                    ServiceCount: {
                      type: "integer"
                    },
                    Properties: {
                      shape: "S23"
                    },
                    CreateDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListOperations: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Values"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      shape: "S2p"
                    },
                    Condition: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Operations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Status: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListServices: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Values"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      shape: "S2p"
                    },
                    Condition: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Services: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Name: {},
                    Type: {},
                    Description: {},
                    InstanceCount: {
                      type: "integer"
                    },
                    DnsConfig: {
                      shape: "Sp"
                    },
                    HealthCheckConfig: {
                      shape: "Su"
                    },
                    HealthCheckCustomConfig: {
                      shape: "Sy"
                    },
                    CreateDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S5"
              }
            }
          }
        },
        RegisterInstance: {
          input: {
            type: "structure",
            required: [
              "ServiceId",
              "InstanceId",
              "Attributes"
            ],
            members: {
              ServiceId: {},
              InstanceId: {},
              CreatorRequestId: {
                idempotencyToken: true
              },
              Attributes: {
                shape: "S1f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateHttpNamespace: {
          input: {
            type: "structure",
            required: [
              "Id",
              "Namespace"
            ],
            members: {
              Id: {},
              UpdaterRequestId: {
                idempotencyToken: true
              },
              Namespace: {
                type: "structure",
                required: [
                  "Description"
                ],
                members: {
                  Description: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        UpdateInstanceCustomHealthStatus: {
          input: {
            type: "structure",
            required: [
              "ServiceId",
              "InstanceId",
              "Status"
            ],
            members: {
              ServiceId: {},
              InstanceId: {},
              Status: {}
            }
          }
        },
        UpdatePrivateDnsNamespace: {
          input: {
            type: "structure",
            required: [
              "Id",
              "Namespace"
            ],
            members: {
              Id: {},
              UpdaterRequestId: {
                idempotencyToken: true
              },
              Namespace: {
                type: "structure",
                members: {
                  Description: {},
                  Properties: {
                    type: "structure",
                    required: [
                      "DnsProperties"
                    ],
                    members: {
                      DnsProperties: {
                        type: "structure",
                        required: [
                          "SOA"
                        ],
                        members: {
                          SOA: {
                            shape: "S3t"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        UpdatePublicDnsNamespace: {
          input: {
            type: "structure",
            required: [
              "Id",
              "Namespace"
            ],
            members: {
              Id: {},
              UpdaterRequestId: {
                idempotencyToken: true
              },
              Namespace: {
                type: "structure",
                members: {
                  Description: {},
                  Properties: {
                    type: "structure",
                    required: [
                      "DnsProperties"
                    ],
                    members: {
                      DnsProperties: {
                        type: "structure",
                        required: [
                          "SOA"
                        ],
                        members: {
                          SOA: {
                            shape: "S3t"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        UpdateService: {
          input: {
            type: "structure",
            required: [
              "Id",
              "Service"
            ],
            members: {
              Id: {},
              Service: {
                type: "structure",
                members: {
                  Description: {},
                  DnsConfig: {
                    type: "structure",
                    required: [
                      "DnsRecords"
                    ],
                    members: {
                      DnsRecords: {
                        shape: "Sr"
                      }
                    }
                  },
                  HealthCheckConfig: {
                    shape: "Su"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sf: {
          type: "structure",
          required: [
            "TTL"
          ],
          members: {
            TTL: {
              type: "long"
            }
          }
        },
        Sp: {
          type: "structure",
          required: [
            "DnsRecords"
          ],
          members: {
            NamespaceId: {
              deprecated: true,
              deprecatedMessage: "Top level attribute in request should be used to reference namespace-id"
            },
            RoutingPolicy: {},
            DnsRecords: {
              shape: "Sr"
            }
          }
        },
        Sr: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Type",
              "TTL"
            ],
            members: {
              Type: {},
              TTL: {
                type: "long"
              }
            }
          }
        },
        Su: {
          type: "structure",
          required: [
            "Type"
          ],
          members: {
            Type: {},
            ResourcePath: {},
            FailureThreshold: {
              type: "integer"
            }
          }
        },
        Sy: {
          type: "structure",
          members: {
            FailureThreshold: {
              deprecated: true,
              deprecatedMessage: "Configurable FailureThreshold of HealthCheckCustomConfig is deprecated.  It will always have value 1.",
              type: "integer"
            }
          }
        },
        S11: {
          type: "structure",
          members: {
            Id: {},
            Arn: {},
            Name: {},
            NamespaceId: {},
            Description: {},
            InstanceCount: {
              type: "integer"
            },
            DnsConfig: {
              shape: "Sp"
            },
            Type: {},
            HealthCheckConfig: {
              shape: "Su"
            },
            HealthCheckCustomConfig: {
              shape: "Sy"
            },
            CreateDate: {
              type: "timestamp"
            },
            CreatorRequestId: {}
          }
        },
        S1f: {
          type: "map",
          key: {},
          value: {}
        },
        S23: {
          type: "structure",
          members: {
            DnsProperties: {
              type: "structure",
              members: {
                HostedZoneId: {},
                SOA: {
                  shape: "Sf"
                }
              }
            },
            HttpProperties: {
              type: "structure",
              members: {
                HttpName: {}
              }
            }
          }
        },
        S2p: {
          type: "list",
          member: {}
        },
        S3t: {
          type: "structure",
          required: [
            "TTL"
          ],
          members: {
            TTL: {
              type: "long"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/servicediscovery-2017-03-14.paginators.json
var require_servicediscovery_2017_03_14_paginators = __commonJS({
  "node_modules/aws-sdk/apis/servicediscovery-2017-03-14.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetInstancesHealthStatus: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListInstances: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListNamespaces: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListOperations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListServices: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/servicediscovery.js
var require_servicediscovery = __commonJS({
  "node_modules/aws-sdk/clients/servicediscovery.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["servicediscovery"] = {};
    AWS2.ServiceDiscovery = Service.defineService("servicediscovery", ["2017-03-14"]);
    Object.defineProperty(apiLoader.services["servicediscovery"], "2017-03-14", {
      get: function get() {
        var model = require_servicediscovery_2017_03_14_min();
        model.paginators = require_servicediscovery_2017_03_14_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ServiceDiscovery;
  }
});

// node_modules/aws-sdk/apis/workmail-2017-10-01.min.json
var require_workmail_2017_10_01_min = __commonJS({
  "node_modules/aws-sdk/apis/workmail-2017-10-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-10-01",
        endpointPrefix: "workmail",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon WorkMail",
        serviceId: "WorkMail",
        signatureVersion: "v4",
        targetPrefix: "WorkMailService",
        uid: "workmail-2017-10-01"
      },
      operations: {
        AssociateDelegateToResource: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "ResourceId",
              "EntityId"
            ],
            members: {
              OrganizationId: {},
              ResourceId: {},
              EntityId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        AssociateMemberToGroup: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "GroupId",
              "MemberId"
            ],
            members: {
              OrganizationId: {},
              GroupId: {},
              MemberId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        AssumeImpersonationRole: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "ImpersonationRoleId"
            ],
            members: {
              OrganizationId: {},
              ImpersonationRoleId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Token: {},
              ExpiresIn: {
                type: "long"
              }
            }
          }
        },
        CancelMailboxExportJob: {
          input: {
            type: "structure",
            required: [
              "ClientToken",
              "JobId",
              "OrganizationId"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              JobId: {},
              OrganizationId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        CreateAlias: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "EntityId",
              "Alias"
            ],
            members: {
              OrganizationId: {},
              EntityId: {},
              Alias: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        CreateAvailabilityConfiguration: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "DomainName"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              OrganizationId: {},
              DomainName: {},
              EwsProvider: {
                shape: "Sm"
              },
              LambdaProvider: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        CreateGroup: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "Name"
            ],
            members: {
              OrganizationId: {},
              Name: {},
              HiddenFromGlobalAddressList: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GroupId: {}
            }
          },
          idempotent: true
        },
        CreateImpersonationRole: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "Name",
              "Type",
              "Rules"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              OrganizationId: {},
              Name: {},
              Type: {},
              Description: {},
              Rules: {
                shape: "S11"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ImpersonationRoleId: {}
            }
          }
        },
        CreateMobileDeviceAccessRule: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "Name",
              "Effect"
            ],
            members: {
              OrganizationId: {},
              ClientToken: {
                idempotencyToken: true
              },
              Name: {},
              Description: {},
              Effect: {},
              DeviceTypes: {
                shape: "S1d"
              },
              NotDeviceTypes: {
                shape: "S1d"
              },
              DeviceModels: {
                shape: "S1f"
              },
              NotDeviceModels: {
                shape: "S1f"
              },
              DeviceOperatingSystems: {
                shape: "S1h"
              },
              NotDeviceOperatingSystems: {
                shape: "S1h"
              },
              DeviceUserAgents: {
                shape: "S1j"
              },
              NotDeviceUserAgents: {
                shape: "S1j"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MobileDeviceAccessRuleId: {}
            }
          }
        },
        CreateOrganization: {
          input: {
            type: "structure",
            required: [
              "Alias"
            ],
            members: {
              DirectoryId: {},
              Alias: {},
              ClientToken: {
                idempotencyToken: true
              },
              Domains: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "DomainName"
                  ],
                  members: {
                    DomainName: {},
                    HostedZoneId: {}
                  }
                }
              },
              KmsKeyArn: {},
              EnableInteroperability: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationId: {}
            }
          },
          idempotent: true
        },
        CreateResource: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "Name",
              "Type"
            ],
            members: {
              OrganizationId: {},
              Name: {},
              Type: {},
              Description: {},
              HiddenFromGlobalAddressList: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceId: {}
            }
          },
          idempotent: true
        },
        CreateUser: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "Name",
              "DisplayName"
            ],
            members: {
              OrganizationId: {},
              Name: {},
              DisplayName: {
                shape: "S23"
              },
              Password: {
                shape: "Sp"
              },
              Role: {},
              FirstName: {
                shape: "S23"
              },
              LastName: {
                shape: "S23"
              },
              HiddenFromGlobalAddressList: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserId: {}
            }
          },
          idempotent: true
        },
        DeleteAccessControlRule: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "Name"
            ],
            members: {
              OrganizationId: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAlias: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "EntityId",
              "Alias"
            ],
            members: {
              OrganizationId: {},
              EntityId: {},
              Alias: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteAvailabilityConfiguration: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "DomainName"
            ],
            members: {
              OrganizationId: {},
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteEmailMonitoringConfiguration: {
          input: {
            type: "structure",
            required: [
              "OrganizationId"
            ],
            members: {
              OrganizationId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteGroup: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "GroupId"
            ],
            members: {
              OrganizationId: {},
              GroupId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteImpersonationRole: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "ImpersonationRoleId"
            ],
            members: {
              OrganizationId: {},
              ImpersonationRoleId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteMailboxPermissions: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "EntityId",
              "GranteeId"
            ],
            members: {
              OrganizationId: {},
              EntityId: {},
              GranteeId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteMobileDeviceAccessOverride: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "UserId",
              "DeviceId"
            ],
            members: {
              OrganizationId: {},
              UserId: {},
              DeviceId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteMobileDeviceAccessRule: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "MobileDeviceAccessRuleId"
            ],
            members: {
              OrganizationId: {},
              MobileDeviceAccessRuleId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteOrganization: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "DeleteDirectory"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              OrganizationId: {},
              DeleteDirectory: {
                type: "boolean"
              },
              ForceDelete: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationId: {},
              State: {}
            }
          },
          idempotent: true
        },
        DeleteResource: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "ResourceId"
            ],
            members: {
              OrganizationId: {},
              ResourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteRetentionPolicy: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "Id"
            ],
            members: {
              OrganizationId: {},
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteUser: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "UserId"
            ],
            members: {
              OrganizationId: {},
              UserId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeregisterFromWorkMail: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "EntityId"
            ],
            members: {
              OrganizationId: {},
              EntityId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeregisterMailDomain: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "DomainName"
            ],
            members: {
              OrganizationId: {},
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DescribeEmailMonitoringConfiguration: {
          input: {
            type: "structure",
            required: [
              "OrganizationId"
            ],
            members: {
              OrganizationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RoleArn: {},
              LogGroupArn: {}
            }
          },
          idempotent: true
        },
        DescribeEntity: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "Email"
            ],
            members: {
              OrganizationId: {},
              Email: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EntityId: {},
              Name: {},
              Type: {}
            }
          },
          idempotent: true
        },
        DescribeGroup: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "GroupId"
            ],
            members: {
              OrganizationId: {},
              GroupId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GroupId: {},
              Name: {},
              Email: {},
              State: {},
              EnabledDate: {
                type: "timestamp"
              },
              DisabledDate: {
                type: "timestamp"
              },
              HiddenFromGlobalAddressList: {
                type: "boolean"
              }
            }
          },
          idempotent: true
        },
        DescribeInboundDmarcSettings: {
          input: {
            type: "structure",
            required: [
              "OrganizationId"
            ],
            members: {
              OrganizationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Enforced: {
                type: "boolean"
              }
            }
          },
          idempotent: true
        },
        DescribeMailboxExportJob: {
          input: {
            type: "structure",
            required: [
              "JobId",
              "OrganizationId"
            ],
            members: {
              JobId: {},
              OrganizationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EntityId: {},
              Description: {},
              RoleArn: {},
              KmsKeyArn: {},
              S3BucketName: {},
              S3Prefix: {},
              S3Path: {},
              EstimatedProgress: {
                type: "integer"
              },
              State: {},
              ErrorInfo: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        DescribeOrganization: {
          input: {
            type: "structure",
            required: [
              "OrganizationId"
            ],
            members: {
              OrganizationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationId: {},
              Alias: {},
              State: {},
              DirectoryId: {},
              DirectoryType: {},
              DefaultMailDomain: {},
              CompletedDate: {
                type: "timestamp"
              },
              ErrorMessage: {},
              ARN: {},
              MigrationAdmin: {},
              InteroperabilityEnabled: {
                type: "boolean"
              }
            }
          },
          idempotent: true
        },
        DescribeResource: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "ResourceId"
            ],
            members: {
              OrganizationId: {},
              ResourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceId: {},
              Email: {},
              Name: {},
              Type: {},
              BookingOptions: {
                shape: "S3v"
              },
              State: {},
              EnabledDate: {
                type: "timestamp"
              },
              DisabledDate: {
                type: "timestamp"
              },
              Description: {},
              HiddenFromGlobalAddressList: {
                type: "boolean"
              }
            }
          },
          idempotent: true
        },
        DescribeUser: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "UserId"
            ],
            members: {
              OrganizationId: {},
              UserId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UserId: {},
              Name: {},
              Email: {},
              DisplayName: {
                shape: "S23"
              },
              State: {},
              UserRole: {},
              EnabledDate: {
                type: "timestamp"
              },
              DisabledDate: {
                type: "timestamp"
              },
              MailboxProvisionedDate: {
                type: "timestamp"
              },
              MailboxDeprovisionedDate: {
                type: "timestamp"
              },
              FirstName: {
                shape: "S23"
              },
              LastName: {
                shape: "S23"
              },
              HiddenFromGlobalAddressList: {
                type: "boolean"
              },
              Initials: {
                shape: "S23"
              },
              Telephone: {
                shape: "S23"
              },
              Street: {
                shape: "S23"
              },
              JobTitle: {
                shape: "S23"
              },
              City: {
                shape: "S23"
              },
              Company: {
                shape: "S23"
              },
              ZipCode: {
                shape: "S23"
              },
              Department: {
                shape: "S23"
              },
              Country: {
                shape: "S23"
              },
              Office: {
                shape: "S23"
              }
            }
          },
          idempotent: true
        },
        DisassociateDelegateFromResource: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "ResourceId",
              "EntityId"
            ],
            members: {
              OrganizationId: {},
              ResourceId: {},
              EntityId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DisassociateMemberFromGroup: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "GroupId",
              "MemberId"
            ],
            members: {
              OrganizationId: {},
              GroupId: {},
              MemberId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        GetAccessControlEffect: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "IpAddress",
              "Action"
            ],
            members: {
              OrganizationId: {},
              IpAddress: {},
              Action: {},
              UserId: {},
              ImpersonationRoleId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Effect: {},
              MatchedRules: {
                type: "list",
                member: {}
              }
            }
          }
        },
        GetDefaultRetentionPolicy: {
          input: {
            type: "structure",
            required: [
              "OrganizationId"
            ],
            members: {
              OrganizationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {},
              Name: {},
              Description: {},
              FolderConfigurations: {
                shape: "S4a"
              }
            }
          },
          idempotent: true
        },
        GetImpersonationRole: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "ImpersonationRoleId"
            ],
            members: {
              OrganizationId: {},
              ImpersonationRoleId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ImpersonationRoleId: {},
              Name: {},
              Type: {},
              Description: {},
              Rules: {
                shape: "S11"
              },
              DateCreated: {
                type: "timestamp"
              },
              DateModified: {
                type: "timestamp"
              }
            }
          }
        },
        GetImpersonationRoleEffect: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "ImpersonationRoleId",
              "TargetUser"
            ],
            members: {
              OrganizationId: {},
              ImpersonationRoleId: {},
              TargetUser: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Type: {},
              Effect: {},
              MatchedRules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ImpersonationRuleId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        GetMailDomain: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "DomainName"
            ],
            members: {
              OrganizationId: {},
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Records: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    Hostname: {},
                    Value: {}
                  }
                }
              },
              IsTestDomain: {
                type: "boolean"
              },
              IsDefault: {
                type: "boolean"
              },
              OwnershipVerificationStatus: {},
              DkimVerificationStatus: {}
            }
          },
          idempotent: true
        },
        GetMailboxDetails: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "UserId"
            ],
            members: {
              OrganizationId: {},
              UserId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MailboxQuota: {
                type: "integer"
              },
              MailboxSize: {
                type: "double"
              }
            }
          },
          idempotent: true
        },
        GetMobileDeviceAccessEffect: {
          input: {
            type: "structure",
            required: [
              "OrganizationId"
            ],
            members: {
              OrganizationId: {},
              DeviceType: {},
              DeviceModel: {},
              DeviceOperatingSystem: {},
              DeviceUserAgent: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Effect: {},
              MatchedRules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MobileDeviceAccessRuleId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        GetMobileDeviceAccessOverride: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "UserId",
              "DeviceId"
            ],
            members: {
              OrganizationId: {},
              UserId: {},
              DeviceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UserId: {},
              DeviceId: {},
              Effect: {},
              Description: {},
              DateCreated: {
                type: "timestamp"
              },
              DateModified: {
                type: "timestamp"
              }
            }
          }
        },
        ListAccessControlRules: {
          input: {
            type: "structure",
            required: [
              "OrganizationId"
            ],
            members: {
              OrganizationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Rules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Effect: {},
                    Description: {},
                    IpRanges: {
                      shape: "S55"
                    },
                    NotIpRanges: {
                      shape: "S55"
                    },
                    Actions: {
                      shape: "S57"
                    },
                    NotActions: {
                      shape: "S57"
                    },
                    UserIds: {
                      shape: "S58"
                    },
                    NotUserIds: {
                      shape: "S58"
                    },
                    DateCreated: {
                      type: "timestamp"
                    },
                    DateModified: {
                      type: "timestamp"
                    },
                    ImpersonationRoleIds: {
                      shape: "S59"
                    },
                    NotImpersonationRoleIds: {
                      shape: "S59"
                    }
                  }
                }
              }
            }
          }
        },
        ListAliases: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "EntityId"
            ],
            members: {
              OrganizationId: {},
              EntityId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Aliases: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListAvailabilityConfigurations: {
          input: {
            type: "structure",
            required: [
              "OrganizationId"
            ],
            members: {
              OrganizationId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AvailabilityConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DomainName: {},
                    ProviderType: {},
                    EwsProvider: {
                      type: "structure",
                      members: {
                        EwsEndpoint: {},
                        EwsUsername: {}
                      }
                    },
                    LambdaProvider: {
                      shape: "Sq"
                    },
                    DateCreated: {
                      type: "timestamp"
                    },
                    DateModified: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListGroupMembers: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "GroupId"
            ],
            members: {
              OrganizationId: {},
              GroupId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Members: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Name: {},
                    Type: {},
                    State: {},
                    EnabledDate: {
                      type: "timestamp"
                    },
                    DisabledDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListGroups: {
          input: {
            type: "structure",
            required: [
              "OrganizationId"
            ],
            members: {
              OrganizationId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                type: "structure",
                members: {
                  NamePrefix: {},
                  PrimaryEmailPrefix: {},
                  State: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Groups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Email: {},
                    Name: {},
                    State: {},
                    EnabledDate: {
                      type: "timestamp"
                    },
                    DisabledDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListGroupsForEntity: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "EntityId"
            ],
            members: {
              OrganizationId: {},
              EntityId: {},
              Filters: {
                type: "structure",
                members: {
                  GroupNamePrefix: {}
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Groups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    GroupId: {},
                    GroupName: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListImpersonationRoles: {
          input: {
            type: "structure",
            required: [
              "OrganizationId"
            ],
            members: {
              OrganizationId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Roles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ImpersonationRoleId: {},
                    Name: {},
                    Type: {},
                    DateCreated: {
                      type: "timestamp"
                    },
                    DateModified: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListMailDomains: {
          input: {
            type: "structure",
            required: [
              "OrganizationId"
            ],
            members: {
              OrganizationId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MailDomains: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DomainName: {},
                    DefaultDomain: {
                      type: "boolean"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListMailboxExportJobs: {
          input: {
            type: "structure",
            required: [
              "OrganizationId"
            ],
            members: {
              OrganizationId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Jobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    JobId: {},
                    EntityId: {},
                    Description: {},
                    S3BucketName: {},
                    S3Path: {},
                    EstimatedProgress: {
                      type: "integer"
                    },
                    State: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListMailboxPermissions: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "EntityId"
            ],
            members: {
              OrganizationId: {},
              EntityId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Permissions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "GranteeId",
                    "GranteeType",
                    "PermissionValues"
                  ],
                  members: {
                    GranteeId: {},
                    GranteeType: {},
                    PermissionValues: {
                      shape: "S6g"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListMobileDeviceAccessOverrides: {
          input: {
            type: "structure",
            required: [
              "OrganizationId"
            ],
            members: {
              OrganizationId: {},
              UserId: {},
              DeviceId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Overrides: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    UserId: {},
                    DeviceId: {},
                    Effect: {},
                    Description: {},
                    DateCreated: {
                      type: "timestamp"
                    },
                    DateModified: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListMobileDeviceAccessRules: {
          input: {
            type: "structure",
            required: [
              "OrganizationId"
            ],
            members: {
              OrganizationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Rules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MobileDeviceAccessRuleId: {},
                    Name: {},
                    Description: {},
                    Effect: {},
                    DeviceTypes: {
                      shape: "S1d"
                    },
                    NotDeviceTypes: {
                      shape: "S1d"
                    },
                    DeviceModels: {
                      shape: "S1f"
                    },
                    NotDeviceModels: {
                      shape: "S1f"
                    },
                    DeviceOperatingSystems: {
                      shape: "S1h"
                    },
                    NotDeviceOperatingSystems: {
                      shape: "S1h"
                    },
                    DeviceUserAgents: {
                      shape: "S1j"
                    },
                    NotDeviceUserAgents: {
                      shape: "S1j"
                    },
                    DateCreated: {
                      type: "timestamp"
                    },
                    DateModified: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListOrganizations: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    OrganizationId: {},
                    Alias: {},
                    DefaultMailDomain: {},
                    ErrorMessage: {},
                    State: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListResourceDelegates: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "ResourceId"
            ],
            members: {
              OrganizationId: {},
              ResourceId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Delegates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Id",
                    "Type"
                  ],
                  members: {
                    Id: {},
                    Type: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListResources: {
          input: {
            type: "structure",
            required: [
              "OrganizationId"
            ],
            members: {
              OrganizationId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                type: "structure",
                members: {
                  NamePrefix: {},
                  PrimaryEmailPrefix: {},
                  State: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Resources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Email: {},
                    Name: {},
                    Type: {},
                    State: {},
                    EnabledDate: {
                      type: "timestamp"
                    },
                    DisabledDate: {
                      type: "timestamp"
                    },
                    Description: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S75"
              }
            }
          }
        },
        ListUsers: {
          input: {
            type: "structure",
            required: [
              "OrganizationId"
            ],
            members: {
              OrganizationId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                type: "structure",
                members: {
                  UsernamePrefix: {},
                  DisplayNamePrefix: {
                    shape: "S23"
                  },
                  PrimaryEmailPrefix: {},
                  State: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Users: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Email: {},
                    Name: {},
                    DisplayName: {},
                    State: {},
                    UserRole: {},
                    EnabledDate: {
                      type: "timestamp"
                    },
                    DisabledDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        PutAccessControlRule: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Effect",
              "Description",
              "OrganizationId"
            ],
            members: {
              Name: {},
              Effect: {},
              Description: {},
              IpRanges: {
                shape: "S55"
              },
              NotIpRanges: {
                shape: "S55"
              },
              Actions: {
                shape: "S57"
              },
              NotActions: {
                shape: "S57"
              },
              UserIds: {
                shape: "S58"
              },
              NotUserIds: {
                shape: "S58"
              },
              OrganizationId: {},
              ImpersonationRoleIds: {
                shape: "S59"
              },
              NotImpersonationRoleIds: {
                shape: "S59"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutEmailMonitoringConfiguration: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "RoleArn",
              "LogGroupArn"
            ],
            members: {
              OrganizationId: {},
              RoleArn: {},
              LogGroupArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        PutInboundDmarcSettings: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "Enforced"
            ],
            members: {
              OrganizationId: {},
              Enforced: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        PutMailboxPermissions: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "EntityId",
              "GranteeId",
              "PermissionValues"
            ],
            members: {
              OrganizationId: {},
              EntityId: {},
              GranteeId: {},
              PermissionValues: {
                shape: "S6g"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        PutMobileDeviceAccessOverride: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "UserId",
              "DeviceId",
              "Effect"
            ],
            members: {
              OrganizationId: {},
              UserId: {},
              DeviceId: {},
              Effect: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutRetentionPolicy: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "Name",
              "FolderConfigurations"
            ],
            members: {
              OrganizationId: {},
              Id: {},
              Name: {},
              Description: {
                type: "string",
                sensitive: true
              },
              FolderConfigurations: {
                shape: "S4a"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        RegisterMailDomain: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "DomainName"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              OrganizationId: {},
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        RegisterToWorkMail: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "EntityId",
              "Email"
            ],
            members: {
              OrganizationId: {},
              EntityId: {},
              Email: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        ResetPassword: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "UserId",
              "Password"
            ],
            members: {
              OrganizationId: {},
              UserId: {},
              Password: {
                shape: "Sp"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        StartMailboxExportJob: {
          input: {
            type: "structure",
            required: [
              "ClientToken",
              "OrganizationId",
              "EntityId",
              "RoleArn",
              "KmsKeyArn",
              "S3BucketName",
              "S3Prefix"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              OrganizationId: {},
              EntityId: {},
              Description: {},
              RoleArn: {},
              KmsKeyArn: {},
              S3BucketName: {},
              S3Prefix: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          },
          idempotent: true
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S75"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TestAvailabilityConfiguration: {
          input: {
            type: "structure",
            required: [
              "OrganizationId"
            ],
            members: {
              OrganizationId: {},
              DomainName: {},
              EwsProvider: {
                shape: "Sm"
              },
              LambdaProvider: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TestPassed: {
                type: "boolean"
              },
              FailureReason: {}
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAvailabilityConfiguration: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "DomainName"
            ],
            members: {
              OrganizationId: {},
              DomainName: {},
              EwsProvider: {
                shape: "Sm"
              },
              LambdaProvider: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateDefaultMailDomain: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "DomainName"
            ],
            members: {
              OrganizationId: {},
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateGroup: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "GroupId"
            ],
            members: {
              OrganizationId: {},
              GroupId: {},
              HiddenFromGlobalAddressList: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateImpersonationRole: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "ImpersonationRoleId",
              "Name",
              "Type",
              "Rules"
            ],
            members: {
              OrganizationId: {},
              ImpersonationRoleId: {},
              Name: {},
              Type: {},
              Description: {},
              Rules: {
                shape: "S11"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateMailboxQuota: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "UserId",
              "MailboxQuota"
            ],
            members: {
              OrganizationId: {},
              UserId: {},
              MailboxQuota: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateMobileDeviceAccessRule: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "MobileDeviceAccessRuleId",
              "Name",
              "Effect"
            ],
            members: {
              OrganizationId: {},
              MobileDeviceAccessRuleId: {},
              Name: {},
              Description: {},
              Effect: {},
              DeviceTypes: {
                shape: "S1d"
              },
              NotDeviceTypes: {
                shape: "S1d"
              },
              DeviceModels: {
                shape: "S1f"
              },
              NotDeviceModels: {
                shape: "S1f"
              },
              DeviceOperatingSystems: {
                shape: "S1h"
              },
              NotDeviceOperatingSystems: {
                shape: "S1h"
              },
              DeviceUserAgents: {
                shape: "S1j"
              },
              NotDeviceUserAgents: {
                shape: "S1j"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdatePrimaryEmailAddress: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "EntityId",
              "Email"
            ],
            members: {
              OrganizationId: {},
              EntityId: {},
              Email: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateResource: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "ResourceId"
            ],
            members: {
              OrganizationId: {},
              ResourceId: {},
              Name: {},
              BookingOptions: {
                shape: "S3v"
              },
              Description: {},
              Type: {},
              HiddenFromGlobalAddressList: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateUser: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "UserId"
            ],
            members: {
              OrganizationId: {},
              UserId: {},
              Role: {},
              DisplayName: {
                shape: "S23"
              },
              FirstName: {
                shape: "S23"
              },
              LastName: {
                shape: "S23"
              },
              HiddenFromGlobalAddressList: {
                type: "boolean"
              },
              Initials: {
                shape: "S23"
              },
              Telephone: {
                shape: "S23"
              },
              Street: {
                shape: "S23"
              },
              JobTitle: {
                shape: "S23"
              },
              City: {
                shape: "S23"
              },
              Company: {
                shape: "S23"
              },
              ZipCode: {
                shape: "S23"
              },
              Department: {
                shape: "S23"
              },
              Country: {
                shape: "S23"
              },
              Office: {
                shape: "S23"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        }
      },
      shapes: {
        Sm: {
          type: "structure",
          required: [
            "EwsEndpoint",
            "EwsUsername",
            "EwsPassword"
          ],
          members: {
            EwsEndpoint: {},
            EwsUsername: {},
            EwsPassword: {
              shape: "Sp"
            }
          }
        },
        Sp: {
          type: "string",
          sensitive: true
        },
        Sq: {
          type: "structure",
          required: [
            "LambdaArn"
          ],
          members: {
            LambdaArn: {}
          }
        },
        S11: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ImpersonationRuleId",
              "Effect"
            ],
            members: {
              ImpersonationRuleId: {},
              Name: {},
              Description: {},
              Effect: {},
              TargetUsers: {
                shape: "S17"
              },
              NotTargetUsers: {
                shape: "S17"
              }
            }
          }
        },
        S17: {
          type: "list",
          member: {}
        },
        S1d: {
          type: "list",
          member: {}
        },
        S1f: {
          type: "list",
          member: {}
        },
        S1h: {
          type: "list",
          member: {}
        },
        S1j: {
          type: "list",
          member: {}
        },
        S23: {
          type: "string",
          sensitive: true
        },
        S3v: {
          type: "structure",
          members: {
            AutoAcceptRequests: {
              type: "boolean"
            },
            AutoDeclineRecurringRequests: {
              type: "boolean"
            },
            AutoDeclineConflictingRequests: {
              type: "boolean"
            }
          }
        },
        S4a: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Action"
            ],
            members: {
              Name: {},
              Action: {},
              Period: {
                type: "integer"
              }
            }
          }
        },
        S55: {
          type: "list",
          member: {}
        },
        S57: {
          type: "list",
          member: {}
        },
        S58: {
          type: "list",
          member: {}
        },
        S59: {
          type: "list",
          member: {}
        },
        S6g: {
          type: "list",
          member: {}
        },
        S75: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/workmail-2017-10-01.paginators.json
var require_workmail_2017_10_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/workmail-2017-10-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAliases: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAvailabilityConfigurations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AvailabilityConfigurations"
        },
        ListGroupMembers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListGroupsForEntity: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListImpersonationRoles: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMailDomains: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMailboxExportJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMailboxPermissions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMobileDeviceAccessOverrides: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListOrganizations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListResourceDelegates: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListResources: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListUsers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/workmail.js
var require_workmail = __commonJS({
  "node_modules/aws-sdk/clients/workmail.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["workmail"] = {};
    AWS2.WorkMail = Service.defineService("workmail", ["2017-10-01"]);
    Object.defineProperty(apiLoader.services["workmail"], "2017-10-01", {
      get: function get() {
        var model = require_workmail_2017_10_01_min();
        model.paginators = require_workmail_2017_10_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.WorkMail;
  }
});

// node_modules/aws-sdk/apis/autoscaling-plans-2018-01-06.min.json
var require_autoscaling_plans_2018_01_06_min = __commonJS({
  "node_modules/aws-sdk/apis/autoscaling-plans-2018-01-06.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-01-06",
        endpointPrefix: "autoscaling-plans",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Auto Scaling Plans",
        serviceId: "Auto Scaling Plans",
        signatureVersion: "v4",
        signingName: "autoscaling-plans",
        targetPrefix: "AnyScaleScalingPlannerFrontendService",
        uid: "autoscaling-plans-2018-01-06"
      },
      operations: {
        CreateScalingPlan: {
          input: {
            type: "structure",
            required: [
              "ScalingPlanName",
              "ApplicationSource",
              "ScalingInstructions"
            ],
            members: {
              ScalingPlanName: {},
              ApplicationSource: {
                shape: "S3"
              },
              ScalingInstructions: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ScalingPlanVersion"
            ],
            members: {
              ScalingPlanVersion: {
                type: "long"
              }
            }
          }
        },
        DeleteScalingPlan: {
          input: {
            type: "structure",
            required: [
              "ScalingPlanName",
              "ScalingPlanVersion"
            ],
            members: {
              ScalingPlanName: {},
              ScalingPlanVersion: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeScalingPlanResources: {
          input: {
            type: "structure",
            required: [
              "ScalingPlanName",
              "ScalingPlanVersion"
            ],
            members: {
              ScalingPlanName: {},
              ScalingPlanVersion: {
                type: "long"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ScalingPlanResources: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ScalingPlanName",
                    "ScalingPlanVersion",
                    "ServiceNamespace",
                    "ResourceId",
                    "ScalableDimension",
                    "ScalingStatusCode"
                  ],
                  members: {
                    ScalingPlanName: {},
                    ScalingPlanVersion: {
                      type: "long"
                    },
                    ServiceNamespace: {},
                    ResourceId: {},
                    ScalableDimension: {},
                    ScalingPolicies: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "PolicyName",
                          "PolicyType"
                        ],
                        members: {
                          PolicyName: {},
                          PolicyType: {},
                          TargetTrackingConfiguration: {
                            shape: "Sh"
                          }
                        }
                      }
                    },
                    ScalingStatusCode: {},
                    ScalingStatusMessage: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeScalingPlans: {
          input: {
            type: "structure",
            members: {
              ScalingPlanNames: {
                type: "list",
                member: {}
              },
              ScalingPlanVersion: {
                type: "long"
              },
              ApplicationSources: {
                type: "list",
                member: {
                  shape: "S3"
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ScalingPlans: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ScalingPlanName",
                    "ScalingPlanVersion",
                    "ApplicationSource",
                    "ScalingInstructions",
                    "StatusCode"
                  ],
                  members: {
                    ScalingPlanName: {},
                    ScalingPlanVersion: {
                      type: "long"
                    },
                    ApplicationSource: {
                      shape: "S3"
                    },
                    ScalingInstructions: {
                      shape: "Sa"
                    },
                    StatusCode: {},
                    StatusMessage: {},
                    StatusStartTime: {
                      type: "timestamp"
                    },
                    CreationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetScalingPlanResourceForecastData: {
          input: {
            type: "structure",
            required: [
              "ScalingPlanName",
              "ScalingPlanVersion",
              "ServiceNamespace",
              "ResourceId",
              "ScalableDimension",
              "ForecastDataType",
              "StartTime",
              "EndTime"
            ],
            members: {
              ScalingPlanName: {},
              ScalingPlanVersion: {
                type: "long"
              },
              ServiceNamespace: {},
              ResourceId: {},
              ScalableDimension: {},
              ForecastDataType: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Datapoints"
            ],
            members: {
              Datapoints: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Timestamp: {
                      type: "timestamp"
                    },
                    Value: {
                      type: "double"
                    }
                  }
                }
              }
            }
          }
        },
        UpdateScalingPlan: {
          input: {
            type: "structure",
            required: [
              "ScalingPlanName",
              "ScalingPlanVersion"
            ],
            members: {
              ScalingPlanName: {},
              ScalingPlanVersion: {
                type: "long"
              },
              ApplicationSource: {
                shape: "S3"
              },
              ScalingInstructions: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          members: {
            CloudFormationStackARN: {},
            TagFilters: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Key: {},
                  Values: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          }
        },
        Sa: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ServiceNamespace",
              "ResourceId",
              "ScalableDimension",
              "MinCapacity",
              "MaxCapacity",
              "TargetTrackingConfigurations"
            ],
            members: {
              ServiceNamespace: {},
              ResourceId: {},
              ScalableDimension: {},
              MinCapacity: {
                type: "integer"
              },
              MaxCapacity: {
                type: "integer"
              },
              TargetTrackingConfigurations: {
                type: "list",
                member: {
                  shape: "Sh"
                }
              },
              PredefinedLoadMetricSpecification: {
                type: "structure",
                required: [
                  "PredefinedLoadMetricType"
                ],
                members: {
                  PredefinedLoadMetricType: {},
                  ResourceLabel: {}
                }
              },
              CustomizedLoadMetricSpecification: {
                type: "structure",
                required: [
                  "MetricName",
                  "Namespace",
                  "Statistic"
                ],
                members: {
                  MetricName: {},
                  Namespace: {},
                  Dimensions: {
                    shape: "So"
                  },
                  Statistic: {},
                  Unit: {}
                }
              },
              ScheduledActionBufferTime: {
                type: "integer"
              },
              PredictiveScalingMaxCapacityBehavior: {},
              PredictiveScalingMaxCapacityBuffer: {
                type: "integer"
              },
              PredictiveScalingMode: {},
              ScalingPolicyUpdateBehavior: {},
              DisableDynamicScaling: {
                type: "boolean"
              }
            }
          }
        },
        Sh: {
          type: "structure",
          required: [
            "TargetValue"
          ],
          members: {
            PredefinedScalingMetricSpecification: {
              type: "structure",
              required: [
                "PredefinedScalingMetricType"
              ],
              members: {
                PredefinedScalingMetricType: {},
                ResourceLabel: {}
              }
            },
            CustomizedScalingMetricSpecification: {
              type: "structure",
              required: [
                "MetricName",
                "Namespace",
                "Statistic"
              ],
              members: {
                MetricName: {},
                Namespace: {},
                Dimensions: {
                  shape: "So"
                },
                Statistic: {},
                Unit: {}
              }
            },
            TargetValue: {
              type: "double"
            },
            DisableScaleIn: {
              type: "boolean"
            },
            ScaleOutCooldown: {
              type: "integer"
            },
            ScaleInCooldown: {
              type: "integer"
            },
            EstimatedInstanceWarmup: {
              type: "integer"
            }
          }
        },
        So: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Value"
            ],
            members: {
              Name: {},
              Value: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/autoscaling-plans-2018-01-06.paginators.json
var require_autoscaling_plans_2018_01_06_paginators = __commonJS({
  "node_modules/aws-sdk/apis/autoscaling-plans-2018-01-06.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/autoscalingplans.js
var require_autoscalingplans = __commonJS({
  "node_modules/aws-sdk/clients/autoscalingplans.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["autoscalingplans"] = {};
    AWS2.AutoScalingPlans = Service.defineService("autoscalingplans", ["2018-01-06"]);
    Object.defineProperty(apiLoader.services["autoscalingplans"], "2018-01-06", {
      get: function get() {
        var model = require_autoscaling_plans_2018_01_06_min();
        model.paginators = require_autoscaling_plans_2018_01_06_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.AutoScalingPlans;
  }
});

// node_modules/aws-sdk/apis/transcribe-2017-10-26.min.json
var require_transcribe_2017_10_26_min = __commonJS({
  "node_modules/aws-sdk/apis/transcribe-2017-10-26.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-10-26",
        endpointPrefix: "transcribe",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Transcribe Service",
        serviceId: "Transcribe",
        signatureVersion: "v4",
        signingName: "transcribe",
        targetPrefix: "Transcribe",
        uid: "transcribe-2017-10-26"
      },
      operations: {
        CreateCallAnalyticsCategory: {
          input: {
            type: "structure",
            required: [
              "CategoryName",
              "Rules"
            ],
            members: {
              CategoryName: {},
              Rules: {
                shape: "S3"
              },
              InputType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CategoryProperties: {
                shape: "Sm"
              }
            }
          }
        },
        CreateLanguageModel: {
          input: {
            type: "structure",
            required: [
              "LanguageCode",
              "BaseModelName",
              "ModelName",
              "InputDataConfig"
            ],
            members: {
              LanguageCode: {},
              BaseModelName: {},
              ModelName: {},
              InputDataConfig: {
                shape: "Ss"
              },
              Tags: {
                shape: "Sv"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LanguageCode: {},
              BaseModelName: {},
              ModelName: {},
              InputDataConfig: {
                shape: "Ss"
              },
              ModelStatus: {}
            }
          }
        },
        CreateMedicalVocabulary: {
          input: {
            type: "structure",
            required: [
              "VocabularyName",
              "LanguageCode",
              "VocabularyFileUri"
            ],
            members: {
              VocabularyName: {},
              LanguageCode: {},
              VocabularyFileUri: {},
              Tags: {
                shape: "Sv"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VocabularyName: {},
              LanguageCode: {},
              VocabularyState: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              FailureReason: {}
            }
          }
        },
        CreateVocabulary: {
          input: {
            type: "structure",
            required: [
              "VocabularyName",
              "LanguageCode"
            ],
            members: {
              VocabularyName: {},
              LanguageCode: {},
              Phrases: {
                shape: "S18"
              },
              VocabularyFileUri: {},
              Tags: {
                shape: "Sv"
              },
              DataAccessRoleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VocabularyName: {},
              LanguageCode: {},
              VocabularyState: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              FailureReason: {}
            }
          }
        },
        CreateVocabularyFilter: {
          input: {
            type: "structure",
            required: [
              "VocabularyFilterName",
              "LanguageCode"
            ],
            members: {
              VocabularyFilterName: {},
              LanguageCode: {},
              Words: {
                shape: "S1d"
              },
              VocabularyFilterFileUri: {},
              Tags: {
                shape: "Sv"
              },
              DataAccessRoleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VocabularyFilterName: {},
              LanguageCode: {},
              LastModifiedTime: {
                type: "timestamp"
              }
            }
          }
        },
        DeleteCallAnalyticsCategory: {
          input: {
            type: "structure",
            required: [
              "CategoryName"
            ],
            members: {
              CategoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteCallAnalyticsJob: {
          input: {
            type: "structure",
            required: [
              "CallAnalyticsJobName"
            ],
            members: {
              CallAnalyticsJobName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteLanguageModel: {
          input: {
            type: "structure",
            required: [
              "ModelName"
            ],
            members: {
              ModelName: {}
            }
          }
        },
        DeleteMedicalScribeJob: {
          input: {
            type: "structure",
            required: [
              "MedicalScribeJobName"
            ],
            members: {
              MedicalScribeJobName: {}
            }
          }
        },
        DeleteMedicalTranscriptionJob: {
          input: {
            type: "structure",
            required: [
              "MedicalTranscriptionJobName"
            ],
            members: {
              MedicalTranscriptionJobName: {}
            }
          }
        },
        DeleteMedicalVocabulary: {
          input: {
            type: "structure",
            required: [
              "VocabularyName"
            ],
            members: {
              VocabularyName: {}
            }
          }
        },
        DeleteTranscriptionJob: {
          input: {
            type: "structure",
            required: [
              "TranscriptionJobName"
            ],
            members: {
              TranscriptionJobName: {}
            }
          }
        },
        DeleteVocabulary: {
          input: {
            type: "structure",
            required: [
              "VocabularyName"
            ],
            members: {
              VocabularyName: {}
            }
          }
        },
        DeleteVocabularyFilter: {
          input: {
            type: "structure",
            required: [
              "VocabularyFilterName"
            ],
            members: {
              VocabularyFilterName: {}
            }
          }
        },
        DescribeLanguageModel: {
          input: {
            type: "structure",
            required: [
              "ModelName"
            ],
            members: {
              ModelName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LanguageModel: {
                shape: "S1v"
              }
            }
          }
        },
        GetCallAnalyticsCategory: {
          input: {
            type: "structure",
            required: [
              "CategoryName"
            ],
            members: {
              CategoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CategoryProperties: {
                shape: "Sm"
              }
            }
          }
        },
        GetCallAnalyticsJob: {
          input: {
            type: "structure",
            required: [
              "CallAnalyticsJobName"
            ],
            members: {
              CallAnalyticsJobName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CallAnalyticsJob: {
                shape: "S20"
              }
            }
          }
        },
        GetMedicalScribeJob: {
          input: {
            type: "structure",
            required: [
              "MedicalScribeJobName"
            ],
            members: {
              MedicalScribeJobName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MedicalScribeJob: {
                shape: "S2n"
              }
            }
          }
        },
        GetMedicalTranscriptionJob: {
          input: {
            type: "structure",
            required: [
              "MedicalTranscriptionJobName"
            ],
            members: {
              MedicalTranscriptionJobName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MedicalTranscriptionJob: {
                shape: "S2z"
              }
            }
          }
        },
        GetMedicalVocabulary: {
          input: {
            type: "structure",
            required: [
              "VocabularyName"
            ],
            members: {
              VocabularyName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VocabularyName: {},
              LanguageCode: {},
              VocabularyState: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              FailureReason: {},
              DownloadUri: {}
            }
          }
        },
        GetTranscriptionJob: {
          input: {
            type: "structure",
            required: [
              "TranscriptionJobName"
            ],
            members: {
              TranscriptionJobName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TranscriptionJob: {
                shape: "S3c"
              }
            }
          }
        },
        GetVocabulary: {
          input: {
            type: "structure",
            required: [
              "VocabularyName"
            ],
            members: {
              VocabularyName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VocabularyName: {},
              LanguageCode: {},
              VocabularyState: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              FailureReason: {},
              DownloadUri: {}
            }
          }
        },
        GetVocabularyFilter: {
          input: {
            type: "structure",
            required: [
              "VocabularyFilterName"
            ],
            members: {
              VocabularyFilterName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VocabularyFilterName: {},
              LanguageCode: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              DownloadUri: {}
            }
          }
        },
        ListCallAnalyticsCategories: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Categories: {
                type: "list",
                member: {
                  shape: "Sm"
                }
              }
            }
          }
        },
        ListCallAnalyticsJobs: {
          input: {
            type: "structure",
            members: {
              Status: {},
              JobNameContains: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {},
              NextToken: {},
              CallAnalyticsJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CallAnalyticsJobName: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    StartTime: {
                      type: "timestamp"
                    },
                    CompletionTime: {
                      type: "timestamp"
                    },
                    LanguageCode: {},
                    CallAnalyticsJobStatus: {},
                    FailureReason: {}
                  }
                }
              }
            }
          }
        },
        ListLanguageModels: {
          input: {
            type: "structure",
            members: {
              StatusEquals: {},
              NameContains: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Models: {
                type: "list",
                member: {
                  shape: "S1v"
                }
              }
            }
          }
        },
        ListMedicalScribeJobs: {
          input: {
            type: "structure",
            members: {
              Status: {},
              JobNameContains: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {},
              NextToken: {},
              MedicalScribeJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MedicalScribeJobName: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    StartTime: {
                      type: "timestamp"
                    },
                    CompletionTime: {
                      type: "timestamp"
                    },
                    LanguageCode: {},
                    MedicalScribeJobStatus: {},
                    FailureReason: {}
                  }
                }
              }
            }
          }
        },
        ListMedicalTranscriptionJobs: {
          input: {
            type: "structure",
            members: {
              Status: {},
              JobNameContains: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {},
              NextToken: {},
              MedicalTranscriptionJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MedicalTranscriptionJobName: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    StartTime: {
                      type: "timestamp"
                    },
                    CompletionTime: {
                      type: "timestamp"
                    },
                    LanguageCode: {},
                    TranscriptionJobStatus: {},
                    FailureReason: {},
                    OutputLocationType: {},
                    Specialty: {},
                    ContentIdentificationType: {},
                    Type: {}
                  }
                }
              }
            }
          }
        },
        ListMedicalVocabularies: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              StateEquals: {},
              NameContains: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {},
              NextToken: {},
              Vocabularies: {
                shape: "S4j"
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceArn: {},
              Tags: {
                shape: "Sv"
              }
            }
          }
        },
        ListTranscriptionJobs: {
          input: {
            type: "structure",
            members: {
              Status: {},
              JobNameContains: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {},
              NextToken: {},
              TranscriptionJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TranscriptionJobName: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    StartTime: {
                      type: "timestamp"
                    },
                    CompletionTime: {
                      type: "timestamp"
                    },
                    LanguageCode: {},
                    TranscriptionJobStatus: {},
                    FailureReason: {},
                    OutputLocationType: {},
                    ContentRedaction: {
                      shape: "S29"
                    },
                    ModelSettings: {
                      shape: "S3e"
                    },
                    IdentifyLanguage: {
                      type: "boolean"
                    },
                    IdentifyMultipleLanguages: {
                      type: "boolean"
                    },
                    IdentifiedLanguageScore: {
                      type: "float"
                    },
                    LanguageCodes: {
                      shape: "S3g"
                    },
                    ToxicityDetection: {
                      shape: "S3o"
                    }
                  }
                }
              }
            }
          }
        },
        ListVocabularies: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              StateEquals: {},
              NameContains: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {},
              NextToken: {},
              Vocabularies: {
                shape: "S4j"
              }
            }
          }
        },
        ListVocabularyFilters: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              NameContains: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              VocabularyFilters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    VocabularyFilterName: {},
                    LanguageCode: {},
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        StartCallAnalyticsJob: {
          input: {
            type: "structure",
            required: [
              "CallAnalyticsJobName",
              "Media"
            ],
            members: {
              CallAnalyticsJobName: {},
              Media: {
                shape: "S24"
              },
              OutputLocation: {},
              OutputEncryptionKMSKeyId: {},
              DataAccessRoleArn: {},
              Settings: {
                shape: "S27"
              },
              ChannelDefinitions: {
                shape: "S2i"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CallAnalyticsJob: {
                shape: "S20"
              }
            }
          }
        },
        StartMedicalScribeJob: {
          input: {
            type: "structure",
            required: [
              "MedicalScribeJobName",
              "Media",
              "OutputBucketName",
              "DataAccessRoleArn",
              "Settings"
            ],
            members: {
              MedicalScribeJobName: {},
              Media: {
                shape: "S24"
              },
              OutputBucketName: {},
              OutputEncryptionKMSKeyId: {},
              KMSEncryptionContext: {
                shape: "S53"
              },
              DataAccessRoleArn: {},
              Settings: {
                shape: "S2r"
              },
              ChannelDefinitions: {
                shape: "S2t"
              },
              Tags: {
                shape: "Sv"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MedicalScribeJob: {
                shape: "S2n"
              }
            }
          }
        },
        StartMedicalTranscriptionJob: {
          input: {
            type: "structure",
            required: [
              "MedicalTranscriptionJobName",
              "LanguageCode",
              "Media",
              "OutputBucketName",
              "Specialty",
              "Type"
            ],
            members: {
              MedicalTranscriptionJobName: {},
              LanguageCode: {},
              MediaSampleRateHertz: {
                type: "integer"
              },
              MediaFormat: {},
              Media: {
                shape: "S24"
              },
              OutputBucketName: {},
              OutputKey: {},
              OutputEncryptionKMSKeyId: {},
              KMSEncryptionContext: {
                shape: "S53"
              },
              Settings: {
                shape: "S33"
              },
              ContentIdentificationType: {},
              Specialty: {},
              Type: {},
              Tags: {
                shape: "Sv"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MedicalTranscriptionJob: {
                shape: "S2z"
              }
            }
          }
        },
        StartTranscriptionJob: {
          input: {
            type: "structure",
            required: [
              "TranscriptionJobName",
              "Media"
            ],
            members: {
              TranscriptionJobName: {},
              LanguageCode: {},
              MediaSampleRateHertz: {
                type: "integer"
              },
              MediaFormat: {},
              Media: {
                shape: "S24"
              },
              OutputBucketName: {},
              OutputKey: {},
              OutputEncryptionKMSKeyId: {},
              KMSEncryptionContext: {
                shape: "S53"
              },
              Settings: {
                shape: "S3d"
              },
              ModelSettings: {
                shape: "S3e"
              },
              JobExecutionSettings: {
                shape: "S3f"
              },
              ContentRedaction: {
                shape: "S29"
              },
              IdentifyLanguage: {
                type: "boolean"
              },
              IdentifyMultipleLanguages: {
                type: "boolean"
              },
              LanguageOptions: {
                shape: "S2e"
              },
              Subtitles: {
                type: "structure",
                members: {
                  Formats: {
                    shape: "S3k"
                  },
                  OutputStartIndex: {
                    type: "integer"
                  }
                }
              },
              Tags: {
                shape: "Sv"
              },
              LanguageIdSettings: {
                shape: "S2f"
              },
              ToxicityDetection: {
                shape: "S3o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TranscriptionJob: {
                shape: "S3c"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "Sv"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateCallAnalyticsCategory: {
          input: {
            type: "structure",
            required: [
              "CategoryName",
              "Rules"
            ],
            members: {
              CategoryName: {},
              Rules: {
                shape: "S3"
              },
              InputType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CategoryProperties: {
                shape: "Sm"
              }
            }
          }
        },
        UpdateMedicalVocabulary: {
          input: {
            type: "structure",
            required: [
              "VocabularyName",
              "LanguageCode",
              "VocabularyFileUri"
            ],
            members: {
              VocabularyName: {},
              LanguageCode: {},
              VocabularyFileUri: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VocabularyName: {},
              LanguageCode: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              VocabularyState: {}
            }
          }
        },
        UpdateVocabulary: {
          input: {
            type: "structure",
            required: [
              "VocabularyName",
              "LanguageCode"
            ],
            members: {
              VocabularyName: {},
              LanguageCode: {},
              Phrases: {
                shape: "S18"
              },
              VocabularyFileUri: {},
              DataAccessRoleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VocabularyName: {},
              LanguageCode: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              VocabularyState: {}
            }
          }
        },
        UpdateVocabularyFilter: {
          input: {
            type: "structure",
            required: [
              "VocabularyFilterName"
            ],
            members: {
              VocabularyFilterName: {},
              Words: {
                shape: "S1d"
              },
              VocabularyFilterFileUri: {},
              DataAccessRoleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VocabularyFilterName: {},
              LanguageCode: {},
              LastModifiedTime: {
                type: "timestamp"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {
            type: "structure",
            members: {
              NonTalkTimeFilter: {
                type: "structure",
                members: {
                  Threshold: {
                    type: "long"
                  },
                  AbsoluteTimeRange: {
                    shape: "S7"
                  },
                  RelativeTimeRange: {
                    shape: "S8"
                  },
                  Negate: {
                    type: "boolean"
                  }
                }
              },
              InterruptionFilter: {
                type: "structure",
                members: {
                  Threshold: {
                    type: "long"
                  },
                  ParticipantRole: {},
                  AbsoluteTimeRange: {
                    shape: "S7"
                  },
                  RelativeTimeRange: {
                    shape: "S8"
                  },
                  Negate: {
                    type: "boolean"
                  }
                }
              },
              TranscriptFilter: {
                type: "structure",
                required: [
                  "TranscriptFilterType",
                  "Targets"
                ],
                members: {
                  TranscriptFilterType: {},
                  AbsoluteTimeRange: {
                    shape: "S7"
                  },
                  RelativeTimeRange: {
                    shape: "S8"
                  },
                  ParticipantRole: {},
                  Negate: {
                    type: "boolean"
                  },
                  Targets: {
                    type: "list",
                    member: {}
                  }
                }
              },
              SentimentFilter: {
                type: "structure",
                required: [
                  "Sentiments"
                ],
                members: {
                  Sentiments: {
                    type: "list",
                    member: {}
                  },
                  AbsoluteTimeRange: {
                    shape: "S7"
                  },
                  RelativeTimeRange: {
                    shape: "S8"
                  },
                  ParticipantRole: {},
                  Negate: {
                    type: "boolean"
                  }
                }
              }
            },
            union: true
          }
        },
        S7: {
          type: "structure",
          members: {
            StartTime: {
              type: "long"
            },
            EndTime: {
              type: "long"
            },
            First: {
              type: "long"
            },
            Last: {
              type: "long"
            }
          }
        },
        S8: {
          type: "structure",
          members: {
            StartPercentage: {
              type: "integer"
            },
            EndPercentage: {
              type: "integer"
            },
            First: {
              type: "integer"
            },
            Last: {
              type: "integer"
            }
          }
        },
        Sm: {
          type: "structure",
          members: {
            CategoryName: {},
            Rules: {
              shape: "S3"
            },
            CreateTime: {
              type: "timestamp"
            },
            LastUpdateTime: {
              type: "timestamp"
            },
            InputType: {}
          }
        },
        Ss: {
          type: "structure",
          required: [
            "S3Uri",
            "DataAccessRoleArn"
          ],
          members: {
            S3Uri: {},
            TuningDataS3Uri: {},
            DataAccessRoleArn: {}
          }
        },
        Sv: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S18: {
          type: "list",
          member: {}
        },
        S1d: {
          type: "list",
          member: {}
        },
        S1v: {
          type: "structure",
          members: {
            ModelName: {},
            CreateTime: {
              type: "timestamp"
            },
            LastModifiedTime: {
              type: "timestamp"
            },
            LanguageCode: {},
            BaseModelName: {},
            ModelStatus: {},
            UpgradeAvailability: {
              type: "boolean"
            },
            FailureReason: {},
            InputDataConfig: {
              shape: "Ss"
            }
          }
        },
        S20: {
          type: "structure",
          members: {
            CallAnalyticsJobName: {},
            CallAnalyticsJobStatus: {},
            LanguageCode: {},
            MediaSampleRateHertz: {
              type: "integer"
            },
            MediaFormat: {},
            Media: {
              shape: "S24"
            },
            Transcript: {
              shape: "S25"
            },
            StartTime: {
              type: "timestamp"
            },
            CreationTime: {
              type: "timestamp"
            },
            CompletionTime: {
              type: "timestamp"
            },
            FailureReason: {},
            DataAccessRoleArn: {},
            IdentifiedLanguageScore: {
              type: "float"
            },
            Settings: {
              shape: "S27"
            },
            ChannelDefinitions: {
              shape: "S2i"
            }
          }
        },
        S24: {
          type: "structure",
          members: {
            MediaFileUri: {},
            RedactedMediaFileUri: {}
          }
        },
        S25: {
          type: "structure",
          members: {
            TranscriptFileUri: {},
            RedactedTranscriptFileUri: {}
          }
        },
        S27: {
          type: "structure",
          members: {
            VocabularyName: {},
            VocabularyFilterName: {},
            VocabularyFilterMethod: {},
            LanguageModelName: {},
            ContentRedaction: {
              shape: "S29"
            },
            LanguageOptions: {
              shape: "S2e"
            },
            LanguageIdSettings: {
              shape: "S2f"
            },
            Summarization: {
              type: "structure",
              required: [
                "GenerateAbstractiveSummary"
              ],
              members: {
                GenerateAbstractiveSummary: {
                  type: "boolean"
                }
              }
            }
          }
        },
        S29: {
          type: "structure",
          required: [
            "RedactionType",
            "RedactionOutput"
          ],
          members: {
            RedactionType: {},
            RedactionOutput: {},
            PiiEntityTypes: {
              type: "list",
              member: {}
            }
          }
        },
        S2e: {
          type: "list",
          member: {}
        },
        S2f: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              VocabularyName: {},
              VocabularyFilterName: {},
              LanguageModelName: {}
            }
          }
        },
        S2i: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ChannelId: {
                type: "integer"
              },
              ParticipantRole: {}
            }
          }
        },
        S2n: {
          type: "structure",
          members: {
            MedicalScribeJobName: {},
            MedicalScribeJobStatus: {},
            LanguageCode: {},
            Media: {
              shape: "S24"
            },
            MedicalScribeOutput: {
              type: "structure",
              required: [
                "TranscriptFileUri",
                "ClinicalDocumentUri"
              ],
              members: {
                TranscriptFileUri: {},
                ClinicalDocumentUri: {}
              }
            },
            StartTime: {
              type: "timestamp"
            },
            CreationTime: {
              type: "timestamp"
            },
            CompletionTime: {
              type: "timestamp"
            },
            FailureReason: {},
            Settings: {
              shape: "S2r"
            },
            DataAccessRoleArn: {},
            ChannelDefinitions: {
              shape: "S2t"
            },
            Tags: {
              shape: "Sv"
            }
          }
        },
        S2r: {
          type: "structure",
          members: {
            ShowSpeakerLabels: {
              type: "boolean"
            },
            MaxSpeakerLabels: {
              type: "integer"
            },
            ChannelIdentification: {
              type: "boolean"
            },
            VocabularyName: {},
            VocabularyFilterName: {},
            VocabularyFilterMethod: {}
          }
        },
        S2t: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ChannelId",
              "ParticipantRole"
            ],
            members: {
              ChannelId: {
                type: "integer"
              },
              ParticipantRole: {}
            }
          }
        },
        S2z: {
          type: "structure",
          members: {
            MedicalTranscriptionJobName: {},
            TranscriptionJobStatus: {},
            LanguageCode: {},
            MediaSampleRateHertz: {
              type: "integer"
            },
            MediaFormat: {},
            Media: {
              shape: "S24"
            },
            Transcript: {
              type: "structure",
              members: {
                TranscriptFileUri: {}
              }
            },
            StartTime: {
              type: "timestamp"
            },
            CreationTime: {
              type: "timestamp"
            },
            CompletionTime: {
              type: "timestamp"
            },
            FailureReason: {},
            Settings: {
              shape: "S33"
            },
            ContentIdentificationType: {},
            Specialty: {},
            Type: {},
            Tags: {
              shape: "Sv"
            }
          }
        },
        S33: {
          type: "structure",
          members: {
            ShowSpeakerLabels: {
              type: "boolean"
            },
            MaxSpeakerLabels: {
              type: "integer"
            },
            ChannelIdentification: {
              type: "boolean"
            },
            ShowAlternatives: {
              type: "boolean"
            },
            MaxAlternatives: {
              type: "integer"
            },
            VocabularyName: {}
          }
        },
        S3c: {
          type: "structure",
          members: {
            TranscriptionJobName: {},
            TranscriptionJobStatus: {},
            LanguageCode: {},
            MediaSampleRateHertz: {
              type: "integer"
            },
            MediaFormat: {},
            Media: {
              shape: "S24"
            },
            Transcript: {
              shape: "S25"
            },
            StartTime: {
              type: "timestamp"
            },
            CreationTime: {
              type: "timestamp"
            },
            CompletionTime: {
              type: "timestamp"
            },
            FailureReason: {},
            Settings: {
              shape: "S3d"
            },
            ModelSettings: {
              shape: "S3e"
            },
            JobExecutionSettings: {
              shape: "S3f"
            },
            ContentRedaction: {
              shape: "S29"
            },
            IdentifyLanguage: {
              type: "boolean"
            },
            IdentifyMultipleLanguages: {
              type: "boolean"
            },
            LanguageOptions: {
              shape: "S2e"
            },
            IdentifiedLanguageScore: {
              type: "float"
            },
            LanguageCodes: {
              shape: "S3g"
            },
            Tags: {
              shape: "Sv"
            },
            Subtitles: {
              type: "structure",
              members: {
                Formats: {
                  shape: "S3k"
                },
                SubtitleFileUris: {
                  type: "list",
                  member: {}
                },
                OutputStartIndex: {
                  type: "integer"
                }
              }
            },
            LanguageIdSettings: {
              shape: "S2f"
            },
            ToxicityDetection: {
              shape: "S3o"
            }
          }
        },
        S3d: {
          type: "structure",
          members: {
            VocabularyName: {},
            ShowSpeakerLabels: {
              type: "boolean"
            },
            MaxSpeakerLabels: {
              type: "integer"
            },
            ChannelIdentification: {
              type: "boolean"
            },
            ShowAlternatives: {
              type: "boolean"
            },
            MaxAlternatives: {
              type: "integer"
            },
            VocabularyFilterName: {},
            VocabularyFilterMethod: {}
          }
        },
        S3e: {
          type: "structure",
          members: {
            LanguageModelName: {}
          }
        },
        S3f: {
          type: "structure",
          members: {
            AllowDeferredExecution: {
              type: "boolean"
            },
            DataAccessRoleArn: {}
          }
        },
        S3g: {
          type: "list",
          member: {
            type: "structure",
            members: {
              LanguageCode: {},
              DurationInSeconds: {
                type: "float"
              }
            }
          }
        },
        S3k: {
          type: "list",
          member: {}
        },
        S3o: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ToxicityCategories"
            ],
            members: {
              ToxicityCategories: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S4j: {
          type: "list",
          member: {
            type: "structure",
            members: {
              VocabularyName: {},
              LanguageCode: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              VocabularyState: {}
            }
          }
        },
        S53: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/transcribe-2017-10-26.paginators.json
var require_transcribe_2017_10_26_paginators = __commonJS({
  "node_modules/aws-sdk/apis/transcribe-2017-10-26.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListCallAnalyticsCategories: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListCallAnalyticsJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListLanguageModels: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMedicalScribeJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMedicalTranscriptionJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMedicalVocabularies: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListTranscriptionJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListVocabularies: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListVocabularyFilters: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/transcribeservice.js
var require_transcribeservice = __commonJS({
  "node_modules/aws-sdk/clients/transcribeservice.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["transcribeservice"] = {};
    AWS2.TranscribeService = Service.defineService("transcribeservice", ["2017-10-26"]);
    Object.defineProperty(apiLoader.services["transcribeservice"], "2017-10-26", {
      get: function get() {
        var model = require_transcribe_2017_10_26_min();
        model.paginators = require_transcribe_2017_10_26_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.TranscribeService;
  }
});

// node_modules/aws-sdk/apis/connect-2017-08-08.min.json
var require_connect_2017_08_08_min = __commonJS({
  "node_modules/aws-sdk/apis/connect-2017-08-08.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-08-08",
        endpointPrefix: "connect",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Amazon Connect",
        serviceFullName: "Amazon Connect Service",
        serviceId: "Connect",
        signatureVersion: "v4",
        signingName: "connect",
        uid: "connect-2017-08-08"
      },
      operations: {
        ActivateEvaluationForm: {
          http: {
            requestUri: "/evaluation-forms/{InstanceId}/{EvaluationFormId}/activate"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "EvaluationFormId",
              "EvaluationFormVersion"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              EvaluationFormId: {
                location: "uri",
                locationName: "EvaluationFormId"
              },
              EvaluationFormVersion: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EvaluationFormId",
              "EvaluationFormArn",
              "EvaluationFormVersion"
            ],
            members: {
              EvaluationFormId: {},
              EvaluationFormArn: {},
              EvaluationFormVersion: {
                type: "integer"
              }
            }
          }
        },
        AssociateAnalyticsDataSet: {
          http: {
            method: "PUT",
            requestUri: "/analytics-data/instance/{InstanceId}/association"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "DataSetId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              DataSetId: {},
              TargetAccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DataSetId: {},
              TargetAccountId: {},
              ResourceShareId: {},
              ResourceShareArn: {}
            }
          }
        },
        AssociateApprovedOrigin: {
          http: {
            method: "PUT",
            requestUri: "/instance/{InstanceId}/approved-origin"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Origin"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Origin: {}
            }
          }
        },
        AssociateBot: {
          http: {
            method: "PUT",
            requestUri: "/instance/{InstanceId}/bot"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              LexBot: {
                shape: "Sf"
              },
              LexV2Bot: {
                shape: "Si"
              }
            }
          }
        },
        AssociateDefaultVocabulary: {
          http: {
            method: "PUT",
            requestUri: "/default-vocabulary/{InstanceId}/{LanguageCode}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "LanguageCode"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              LanguageCode: {
                location: "uri",
                locationName: "LanguageCode"
              },
              VocabularyId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateFlow: {
          http: {
            method: "PUT",
            requestUri: "/flow-associations/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ResourceId",
              "FlowId",
              "ResourceType"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ResourceId: {},
              FlowId: {},
              ResourceType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateInstanceStorageConfig: {
          http: {
            method: "PUT",
            requestUri: "/instance/{InstanceId}/storage-config"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ResourceType",
              "StorageConfig"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ResourceType: {},
              StorageConfig: {
                shape: "St"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssociationId: {}
            }
          }
        },
        AssociateLambdaFunction: {
          http: {
            method: "PUT",
            requestUri: "/instance/{InstanceId}/lambda-function"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "FunctionArn"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              FunctionArn: {}
            }
          }
        },
        AssociateLexBot: {
          http: {
            method: "PUT",
            requestUri: "/instance/{InstanceId}/lex-bot"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "LexBot"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              LexBot: {
                shape: "Sf"
              }
            }
          }
        },
        AssociatePhoneNumberContactFlow: {
          http: {
            method: "PUT",
            requestUri: "/phone-number/{PhoneNumberId}/contact-flow"
          },
          input: {
            type: "structure",
            required: [
              "PhoneNumberId",
              "InstanceId",
              "ContactFlowId"
            ],
            members: {
              PhoneNumberId: {
                location: "uri",
                locationName: "PhoneNumberId"
              },
              InstanceId: {},
              ContactFlowId: {}
            }
          }
        },
        AssociateQueueQuickConnects: {
          http: {
            requestUri: "/queues/{InstanceId}/{QueueId}/associate-quick-connects"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "QueueId",
              "QuickConnectIds"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              QueueId: {
                location: "uri",
                locationName: "QueueId"
              },
              QuickConnectIds: {
                shape: "S1f"
              }
            }
          }
        },
        AssociateRoutingProfileQueues: {
          http: {
            requestUri: "/routing-profiles/{InstanceId}/{RoutingProfileId}/associate-queues"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "RoutingProfileId",
              "QueueConfigs"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              RoutingProfileId: {
                location: "uri",
                locationName: "RoutingProfileId"
              },
              QueueConfigs: {
                shape: "S1j"
              }
            }
          }
        },
        AssociateSecurityKey: {
          http: {
            method: "PUT",
            requestUri: "/instance/{InstanceId}/security-key"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Key"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Key: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AssociationId: {}
            }
          }
        },
        AssociateTrafficDistributionGroupUser: {
          http: {
            method: "PUT",
            requestUri: "/traffic-distribution-group/{TrafficDistributionGroupId}/user"
          },
          input: {
            type: "structure",
            required: [
              "TrafficDistributionGroupId",
              "UserId",
              "InstanceId"
            ],
            members: {
              TrafficDistributionGroupId: {
                location: "uri",
                locationName: "TrafficDistributionGroupId"
              },
              UserId: {},
              InstanceId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        AssociateUserProficiencies: {
          http: {
            requestUri: "/users/{InstanceId}/{UserId}/associate-proficiencies"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "UserId",
              "UserProficiencies"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              UserId: {
                location: "uri",
                locationName: "UserId"
              },
              UserProficiencies: {
                shape: "S1x"
              }
            }
          }
        },
        BatchAssociateAnalyticsDataSet: {
          http: {
            method: "PUT",
            requestUri: "/analytics-data/instance/{InstanceId}/associations"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "DataSetIds"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              DataSetIds: {
                shape: "S23"
              },
              TargetAccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Created: {
                shape: "S25"
              },
              Errors: {
                shape: "S27"
              }
            }
          }
        },
        BatchDisassociateAnalyticsDataSet: {
          http: {
            requestUri: "/analytics-data/instance/{InstanceId}/associations"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "DataSetIds"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              DataSetIds: {
                shape: "S23"
              },
              TargetAccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Deleted: {
                shape: "S23"
              },
              Errors: {
                shape: "S27"
              }
            }
          }
        },
        BatchGetFlowAssociation: {
          http: {
            requestUri: "/flow-associations-batch/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ResourceIds"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ResourceIds: {
                type: "list",
                member: {}
              },
              ResourceType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FlowAssociationSummaryList: {
                shape: "S2f"
              }
            }
          }
        },
        BatchPutContact: {
          http: {
            method: "PUT",
            requestUri: "/contact/batch/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactDataRequestList"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ContactDataRequestList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SystemEndpoint: {
                      shape: "S2l"
                    },
                    CustomerEndpoint: {
                      shape: "S2l"
                    },
                    RequestIdentifier: {},
                    QueueId: {},
                    Attributes: {
                      shape: "S2p"
                    },
                    Campaign: {
                      type: "structure",
                      members: {
                        CampaignId: {}
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SuccessfulRequestList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RequestIdentifier: {},
                    ContactId: {}
                  }
                }
              },
              FailedRequestList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RequestIdentifier: {},
                    FailureReasonCode: {},
                    FailureReasonMessage: {}
                  }
                }
              }
            }
          },
          idempotent: true
        },
        ClaimPhoneNumber: {
          http: {
            requestUri: "/phone-number/claim"
          },
          input: {
            type: "structure",
            required: [
              "PhoneNumber"
            ],
            members: {
              TargetArn: {},
              InstanceId: {},
              PhoneNumber: {},
              PhoneNumberDescription: {},
              Tags: {
                shape: "S34"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberId: {},
              PhoneNumberArn: {}
            }
          }
        },
        CreateAgentStatus: {
          http: {
            method: "PUT",
            requestUri: "/agent-status/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Name",
              "State"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Name: {},
              Description: {},
              State: {},
              DisplayOrder: {
                type: "integer"
              },
              Tags: {
                shape: "S34"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AgentStatusARN: {},
              AgentStatusId: {}
            }
          }
        },
        CreateContactFlow: {
          http: {
            method: "PUT",
            requestUri: "/contact-flows/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Name",
              "Type",
              "Content"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Name: {},
              Type: {},
              Description: {},
              Content: {},
              Tags: {
                shape: "S34"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContactFlowId: {},
              ContactFlowArn: {}
            }
          }
        },
        CreateContactFlowModule: {
          http: {
            method: "PUT",
            requestUri: "/contact-flow-modules/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Name",
              "Content"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Name: {},
              Description: {},
              Content: {},
              Tags: {
                shape: "S34"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {},
              Arn: {}
            }
          }
        },
        CreateEvaluationForm: {
          http: {
            method: "PUT",
            requestUri: "/evaluation-forms/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Title",
              "Items"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Title: {},
              Description: {},
              Items: {
                shape: "S3u"
              },
              ScoringStrategy: {
                shape: "S4p"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EvaluationFormId",
              "EvaluationFormArn"
            ],
            members: {
              EvaluationFormId: {},
              EvaluationFormArn: {}
            }
          },
          idempotent: true
        },
        CreateHoursOfOperation: {
          http: {
            method: "PUT",
            requestUri: "/hours-of-operations/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Name",
              "TimeZone",
              "Config"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Name: {},
              Description: {},
              TimeZone: {},
              Config: {
                shape: "S4x"
              },
              Tags: {
                shape: "S34"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HoursOfOperationId: {},
              HoursOfOperationArn: {}
            }
          }
        },
        CreateInstance: {
          http: {
            method: "PUT",
            requestUri: "/instance"
          },
          input: {
            type: "structure",
            required: [
              "IdentityManagementType",
              "InboundCallsEnabled",
              "OutboundCallsEnabled"
            ],
            members: {
              ClientToken: {},
              IdentityManagementType: {},
              InstanceAlias: {
                shape: "S57"
              },
              DirectoryId: {},
              InboundCallsEnabled: {
                type: "boolean"
              },
              OutboundCallsEnabled: {
                type: "boolean"
              },
              Tags: {
                shape: "S34"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {},
              Arn: {}
            }
          }
        },
        CreateIntegrationAssociation: {
          http: {
            method: "PUT",
            requestUri: "/instance/{InstanceId}/integration-associations"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "IntegrationType",
              "IntegrationArn"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              IntegrationType: {},
              IntegrationArn: {},
              SourceApplicationUrl: {},
              SourceApplicationName: {},
              SourceType: {},
              Tags: {
                shape: "S34"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IntegrationAssociationId: {},
              IntegrationAssociationArn: {}
            }
          }
        },
        CreateParticipant: {
          http: {
            requestUri: "/contact/create-participant"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactId",
              "ParticipantDetails"
            ],
            members: {
              InstanceId: {},
              ContactId: {},
              ClientToken: {
                idempotencyToken: true
              },
              ParticipantDetails: {
                type: "structure",
                members: {
                  ParticipantRole: {},
                  DisplayName: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ParticipantCredentials: {
                type: "structure",
                members: {
                  ParticipantToken: {},
                  Expiry: {}
                }
              },
              ParticipantId: {}
            }
          }
        },
        CreatePersistentContactAssociation: {
          http: {
            requestUri: "/contact/persistent-contact-association/{InstanceId}/{InitialContactId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "InitialContactId",
              "RehydrationType",
              "SourceContactId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              InitialContactId: {
                location: "uri",
                locationName: "InitialContactId"
              },
              RehydrationType: {},
              SourceContactId: {},
              ClientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ContinuedFromContactId: {}
            }
          }
        },
        CreatePredefinedAttribute: {
          http: {
            method: "PUT",
            requestUri: "/predefined-attributes/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Name",
              "Values"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Name: {},
              Values: {
                shape: "S5w"
              }
            }
          }
        },
        CreatePrompt: {
          http: {
            method: "PUT",
            requestUri: "/prompts/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Name",
              "S3Uri"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Name: {},
              Description: {},
              S3Uri: {},
              Tags: {
                shape: "S34"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PromptARN: {},
              PromptId: {}
            }
          }
        },
        CreateQueue: {
          http: {
            method: "PUT",
            requestUri: "/queues/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Name",
              "HoursOfOperationId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Name: {},
              Description: {},
              OutboundCallerConfig: {
                shape: "S65"
              },
              HoursOfOperationId: {},
              MaxContacts: {
                type: "integer"
              },
              QuickConnectIds: {
                shape: "S1f"
              },
              Tags: {
                shape: "S34"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              QueueArn: {},
              QueueId: {}
            }
          }
        },
        CreateQuickConnect: {
          http: {
            method: "PUT",
            requestUri: "/quick-connects/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Name",
              "QuickConnectConfig"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Name: {},
              Description: {},
              QuickConnectConfig: {
                shape: "S6c"
              },
              Tags: {
                shape: "S34"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              QuickConnectARN: {},
              QuickConnectId: {}
            }
          }
        },
        CreateRoutingProfile: {
          http: {
            method: "PUT",
            requestUri: "/routing-profiles/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Name",
              "Description",
              "DefaultOutboundQueueId",
              "MediaConcurrencies"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Name: {},
              Description: {},
              DefaultOutboundQueueId: {},
              QueueConfigs: {
                shape: "S1j"
              },
              MediaConcurrencies: {
                shape: "S6l"
              },
              Tags: {
                shape: "S34"
              },
              AgentAvailabilityTimer: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RoutingProfileArn: {},
              RoutingProfileId: {}
            }
          }
        },
        CreateRule: {
          http: {
            requestUri: "/rules/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Name",
              "TriggerEventSource",
              "Function",
              "Actions",
              "PublishStatus"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Name: {},
              TriggerEventSource: {
                shape: "S6u"
              },
              Function: {},
              Actions: {
                shape: "S6x"
              },
              PublishStatus: {},
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "RuleArn",
              "RuleId"
            ],
            members: {
              RuleArn: {},
              RuleId: {}
            }
          }
        },
        CreateSecurityProfile: {
          http: {
            method: "PUT",
            requestUri: "/security-profiles/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "SecurityProfileName",
              "InstanceId"
            ],
            members: {
              SecurityProfileName: {},
              Description: {},
              Permissions: {
                shape: "S80"
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Tags: {
                shape: "S34"
              },
              AllowedAccessControlTags: {
                shape: "S82"
              },
              TagRestrictedResources: {
                shape: "S85"
              },
              Applications: {
                shape: "S87"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SecurityProfileId: {},
              SecurityProfileArn: {}
            }
          }
        },
        CreateTaskTemplate: {
          http: {
            method: "PUT",
            requestUri: "/instance/{InstanceId}/task/template"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Name",
              "Fields"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Name: {},
              Description: {},
              ContactFlowId: {},
              Constraints: {
                shape: "S8h"
              },
              Defaults: {
                shape: "S8q"
              },
              Status: {},
              Fields: {
                shape: "S8v"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Id",
              "Arn"
            ],
            members: {
              Id: {},
              Arn: {}
            }
          }
        },
        CreateTrafficDistributionGroup: {
          http: {
            method: "PUT",
            requestUri: "/traffic-distribution-group"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "InstanceId"
            ],
            members: {
              Name: {},
              Description: {},
              InstanceId: {},
              ClientToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S34"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {},
              Arn: {}
            }
          }
        },
        CreateUseCase: {
          http: {
            method: "PUT",
            requestUri: "/instance/{InstanceId}/integration-associations/{IntegrationAssociationId}/use-cases"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "IntegrationAssociationId",
              "UseCaseType"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              IntegrationAssociationId: {
                location: "uri",
                locationName: "IntegrationAssociationId"
              },
              UseCaseType: {},
              Tags: {
                shape: "S34"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UseCaseId: {},
              UseCaseArn: {}
            }
          }
        },
        CreateUser: {
          http: {
            method: "PUT",
            requestUri: "/users/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "Username",
              "PhoneConfig",
              "SecurityProfileIds",
              "RoutingProfileId",
              "InstanceId"
            ],
            members: {
              Username: {},
              Password: {},
              IdentityInfo: {
                shape: "S9i"
              },
              PhoneConfig: {
                shape: "S9m"
              },
              DirectoryUserId: {},
              SecurityProfileIds: {
                shape: "S9r"
              },
              RoutingProfileId: {},
              HierarchyGroupId: {},
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Tags: {
                shape: "S34"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserId: {},
              UserArn: {}
            }
          }
        },
        CreateUserHierarchyGroup: {
          http: {
            method: "PUT",
            requestUri: "/user-hierarchy-groups/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "InstanceId"
            ],
            members: {
              Name: {},
              ParentGroupId: {},
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Tags: {
                shape: "S34"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HierarchyGroupId: {},
              HierarchyGroupArn: {}
            }
          }
        },
        CreateView: {
          http: {
            method: "PUT",
            requestUri: "/views/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Status",
              "Content",
              "Name"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ClientToken: {},
              Status: {},
              Content: {
                shape: "Sa1"
              },
              Description: {},
              Name: {
                shape: "Sa6"
              },
              Tags: {
                shape: "S34"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              View: {
                shape: "Sa8"
              }
            }
          },
          idempotent: true
        },
        CreateViewVersion: {
          http: {
            method: "PUT",
            requestUri: "/views/{InstanceId}/{ViewId}/versions"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ViewId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ViewId: {
                location: "uri",
                locationName: "ViewId"
              },
              VersionDescription: {},
              ViewContentSha256: {}
            }
          },
          output: {
            type: "structure",
            members: {
              View: {
                shape: "Sa8"
              }
            }
          },
          idempotent: true
        },
        CreateVocabulary: {
          http: {
            requestUri: "/vocabulary/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "VocabularyName",
              "LanguageCode",
              "Content"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              VocabularyName: {},
              LanguageCode: {},
              Content: {},
              Tags: {
                shape: "S34"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "VocabularyArn",
              "VocabularyId",
              "State"
            ],
            members: {
              VocabularyArn: {},
              VocabularyId: {},
              State: {}
            }
          }
        },
        DeactivateEvaluationForm: {
          http: {
            requestUri: "/evaluation-forms/{InstanceId}/{EvaluationFormId}/deactivate"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "EvaluationFormId",
              "EvaluationFormVersion"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              EvaluationFormId: {
                location: "uri",
                locationName: "EvaluationFormId"
              },
              EvaluationFormVersion: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EvaluationFormId",
              "EvaluationFormArn",
              "EvaluationFormVersion"
            ],
            members: {
              EvaluationFormId: {},
              EvaluationFormArn: {},
              EvaluationFormVersion: {
                type: "integer"
              }
            }
          }
        },
        DeleteContactEvaluation: {
          http: {
            method: "DELETE",
            requestUri: "/contact-evaluations/{InstanceId}/{EvaluationId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "EvaluationId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              EvaluationId: {
                location: "uri",
                locationName: "EvaluationId"
              }
            }
          },
          idempotent: true
        },
        DeleteContactFlow: {
          http: {
            method: "DELETE",
            requestUri: "/contact-flows/{InstanceId}/{ContactFlowId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactFlowId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ContactFlowId: {
                location: "uri",
                locationName: "ContactFlowId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteContactFlowModule: {
          http: {
            method: "DELETE",
            requestUri: "/contact-flow-modules/{InstanceId}/{ContactFlowModuleId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactFlowModuleId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ContactFlowModuleId: {
                location: "uri",
                locationName: "ContactFlowModuleId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteEvaluationForm: {
          http: {
            method: "DELETE",
            requestUri: "/evaluation-forms/{InstanceId}/{EvaluationFormId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "EvaluationFormId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              EvaluationFormId: {
                location: "uri",
                locationName: "EvaluationFormId"
              },
              EvaluationFormVersion: {
                location: "querystring",
                locationName: "version",
                type: "integer"
              }
            }
          },
          idempotent: true
        },
        DeleteHoursOfOperation: {
          http: {
            method: "DELETE",
            requestUri: "/hours-of-operations/{InstanceId}/{HoursOfOperationId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "HoursOfOperationId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              HoursOfOperationId: {
                location: "uri",
                locationName: "HoursOfOperationId"
              }
            }
          }
        },
        DeleteInstance: {
          http: {
            method: "DELETE",
            requestUri: "/instance/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              }
            }
          }
        },
        DeleteIntegrationAssociation: {
          http: {
            method: "DELETE",
            requestUri: "/instance/{InstanceId}/integration-associations/{IntegrationAssociationId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "IntegrationAssociationId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              IntegrationAssociationId: {
                location: "uri",
                locationName: "IntegrationAssociationId"
              }
            }
          }
        },
        DeletePredefinedAttribute: {
          http: {
            method: "DELETE",
            requestUri: "/predefined-attributes/{InstanceId}/{Name}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Name"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          idempotent: true
        },
        DeletePrompt: {
          http: {
            method: "DELETE",
            requestUri: "/prompts/{InstanceId}/{PromptId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "PromptId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              PromptId: {
                location: "uri",
                locationName: "PromptId"
              }
            }
          }
        },
        DeleteQueue: {
          http: {
            method: "DELETE",
            requestUri: "/queues/{InstanceId}/{QueueId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "QueueId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              QueueId: {
                location: "uri",
                locationName: "QueueId"
              }
            }
          }
        },
        DeleteQuickConnect: {
          http: {
            method: "DELETE",
            requestUri: "/quick-connects/{InstanceId}/{QuickConnectId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "QuickConnectId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              QuickConnectId: {
                location: "uri",
                locationName: "QuickConnectId"
              }
            }
          }
        },
        DeleteRoutingProfile: {
          http: {
            method: "DELETE",
            requestUri: "/routing-profiles/{InstanceId}/{RoutingProfileId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "RoutingProfileId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              RoutingProfileId: {
                location: "uri",
                locationName: "RoutingProfileId"
              }
            }
          }
        },
        DeleteRule: {
          http: {
            method: "DELETE",
            requestUri: "/rules/{InstanceId}/{RuleId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "RuleId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              RuleId: {
                location: "uri",
                locationName: "RuleId"
              }
            }
          }
        },
        DeleteSecurityProfile: {
          http: {
            method: "DELETE",
            requestUri: "/security-profiles/{InstanceId}/{SecurityProfileId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "SecurityProfileId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              SecurityProfileId: {
                location: "uri",
                locationName: "SecurityProfileId"
              }
            }
          }
        },
        DeleteTaskTemplate: {
          http: {
            method: "DELETE",
            requestUri: "/instance/{InstanceId}/task/template/{TaskTemplateId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "TaskTemplateId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              TaskTemplateId: {
                location: "uri",
                locationName: "TaskTemplateId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteTrafficDistributionGroup: {
          http: {
            method: "DELETE",
            requestUri: "/traffic-distribution-group/{TrafficDistributionGroupId}"
          },
          input: {
            type: "structure",
            required: [
              "TrafficDistributionGroupId"
            ],
            members: {
              TrafficDistributionGroupId: {
                location: "uri",
                locationName: "TrafficDistributionGroupId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteUseCase: {
          http: {
            method: "DELETE",
            requestUri: "/instance/{InstanceId}/integration-associations/{IntegrationAssociationId}/use-cases/{UseCaseId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "IntegrationAssociationId",
              "UseCaseId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              IntegrationAssociationId: {
                location: "uri",
                locationName: "IntegrationAssociationId"
              },
              UseCaseId: {
                location: "uri",
                locationName: "UseCaseId"
              }
            }
          }
        },
        DeleteUser: {
          http: {
            method: "DELETE",
            requestUri: "/users/{InstanceId}/{UserId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "UserId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              UserId: {
                location: "uri",
                locationName: "UserId"
              }
            }
          }
        },
        DeleteUserHierarchyGroup: {
          http: {
            method: "DELETE",
            requestUri: "/user-hierarchy-groups/{InstanceId}/{HierarchyGroupId}"
          },
          input: {
            type: "structure",
            required: [
              "HierarchyGroupId",
              "InstanceId"
            ],
            members: {
              HierarchyGroupId: {
                location: "uri",
                locationName: "HierarchyGroupId"
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              }
            }
          }
        },
        DeleteView: {
          http: {
            method: "DELETE",
            requestUri: "/views/{InstanceId}/{ViewId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ViewId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ViewId: {
                location: "uri",
                locationName: "ViewId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteViewVersion: {
          http: {
            method: "DELETE",
            requestUri: "/views/{InstanceId}/{ViewId}/versions/{ViewVersion}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ViewId",
              "ViewVersion"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ViewId: {
                location: "uri",
                locationName: "ViewId"
              },
              ViewVersion: {
                location: "uri",
                locationName: "ViewVersion",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteVocabulary: {
          http: {
            requestUri: "/vocabulary-remove/{InstanceId}/{VocabularyId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "VocabularyId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              VocabularyId: {
                location: "uri",
                locationName: "VocabularyId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "VocabularyArn",
              "VocabularyId",
              "State"
            ],
            members: {
              VocabularyArn: {},
              VocabularyId: {},
              State: {}
            }
          }
        },
        DescribeAgentStatus: {
          http: {
            method: "GET",
            requestUri: "/agent-status/{InstanceId}/{AgentStatusId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "AgentStatusId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              AgentStatusId: {
                location: "uri",
                locationName: "AgentStatusId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AgentStatus: {
                type: "structure",
                members: {
                  AgentStatusARN: {},
                  AgentStatusId: {},
                  Name: {},
                  Description: {},
                  Type: {},
                  DisplayOrder: {
                    type: "integer"
                  },
                  State: {},
                  Tags: {
                    shape: "S34"
                  },
                  LastModifiedTime: {
                    type: "timestamp"
                  },
                  LastModifiedRegion: {}
                }
              }
            }
          }
        },
        DescribeContact: {
          http: {
            method: "GET",
            requestUri: "/contacts/{InstanceId}/{ContactId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ContactId: {
                location: "uri",
                locationName: "ContactId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Contact: {
                type: "structure",
                members: {
                  Arn: {},
                  Id: {},
                  InitialContactId: {},
                  PreviousContactId: {},
                  InitiationMethod: {},
                  Name: {},
                  Description: {},
                  Channel: {},
                  QueueInfo: {
                    type: "structure",
                    members: {
                      Id: {},
                      EnqueueTimestamp: {
                        type: "timestamp"
                      }
                    }
                  },
                  AgentInfo: {
                    type: "structure",
                    members: {
                      Id: {},
                      ConnectedToAgentTimestamp: {
                        type: "timestamp"
                      },
                      AgentPauseDurationInSeconds: {
                        type: "integer"
                      }
                    }
                  },
                  InitiationTimestamp: {
                    type: "timestamp"
                  },
                  DisconnectTimestamp: {
                    type: "timestamp"
                  },
                  LastUpdateTimestamp: {
                    type: "timestamp"
                  },
                  LastPausedTimestamp: {
                    type: "timestamp"
                  },
                  LastResumedTimestamp: {
                    type: "timestamp"
                  },
                  TotalPauseCount: {
                    type: "integer"
                  },
                  TotalPauseDurationInSeconds: {
                    type: "integer"
                  },
                  ScheduledTimestamp: {
                    type: "timestamp"
                  },
                  RelatedContactId: {},
                  WisdomInfo: {
                    type: "structure",
                    members: {
                      SessionArn: {}
                    }
                  },
                  QueueTimeAdjustmentSeconds: {
                    type: "integer"
                  },
                  QueuePriority: {
                    type: "long"
                  },
                  Tags: {
                    shape: "Sc3"
                  }
                }
              }
            }
          }
        },
        DescribeContactEvaluation: {
          http: {
            method: "GET",
            requestUri: "/contact-evaluations/{InstanceId}/{EvaluationId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "EvaluationId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              EvaluationId: {
                location: "uri",
                locationName: "EvaluationId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Evaluation",
              "EvaluationForm"
            ],
            members: {
              Evaluation: {
                type: "structure",
                required: [
                  "EvaluationId",
                  "EvaluationArn",
                  "Metadata",
                  "Answers",
                  "Notes",
                  "Status",
                  "CreatedTime",
                  "LastModifiedTime"
                ],
                members: {
                  EvaluationId: {},
                  EvaluationArn: {},
                  Metadata: {
                    type: "structure",
                    required: [
                      "ContactId",
                      "EvaluatorArn"
                    ],
                    members: {
                      ContactId: {},
                      EvaluatorArn: {},
                      ContactAgentId: {},
                      Score: {
                        shape: "Sca"
                      }
                    }
                  },
                  Answers: {
                    type: "map",
                    key: {},
                    value: {
                      type: "structure",
                      members: {
                        Value: {
                          shape: "Sce"
                        },
                        SystemSuggestedValue: {
                          shape: "Sce"
                        }
                      }
                    }
                  },
                  Notes: {
                    shape: "Sch"
                  },
                  Status: {},
                  Scores: {
                    type: "map",
                    key: {},
                    value: {
                      shape: "Sca"
                    }
                  },
                  CreatedTime: {
                    type: "timestamp"
                  },
                  LastModifiedTime: {
                    type: "timestamp"
                  },
                  Tags: {
                    shape: "S34"
                  }
                }
              },
              EvaluationForm: {
                type: "structure",
                required: [
                  "EvaluationFormVersion",
                  "EvaluationFormId",
                  "EvaluationFormArn",
                  "Title",
                  "Items"
                ],
                members: {
                  EvaluationFormVersion: {
                    type: "integer"
                  },
                  EvaluationFormId: {},
                  EvaluationFormArn: {},
                  Title: {},
                  Description: {},
                  Items: {
                    shape: "S3u"
                  },
                  ScoringStrategy: {
                    shape: "S4p"
                  }
                }
              }
            }
          }
        },
        DescribeContactFlow: {
          http: {
            method: "GET",
            requestUri: "/contact-flows/{InstanceId}/{ContactFlowId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactFlowId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ContactFlowId: {
                location: "uri",
                locationName: "ContactFlowId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContactFlow: {
                type: "structure",
                members: {
                  Arn: {},
                  Id: {},
                  Name: {},
                  Type: {},
                  State: {},
                  Description: {},
                  Content: {},
                  Tags: {
                    shape: "S34"
                  }
                }
              }
            }
          }
        },
        DescribeContactFlowModule: {
          http: {
            method: "GET",
            requestUri: "/contact-flow-modules/{InstanceId}/{ContactFlowModuleId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactFlowModuleId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ContactFlowModuleId: {
                location: "uri",
                locationName: "ContactFlowModuleId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContactFlowModule: {
                type: "structure",
                members: {
                  Arn: {},
                  Id: {},
                  Name: {},
                  Content: {},
                  Description: {},
                  State: {},
                  Status: {},
                  Tags: {
                    shape: "S34"
                  }
                }
              }
            }
          }
        },
        DescribeEvaluationForm: {
          http: {
            method: "GET",
            requestUri: "/evaluation-forms/{InstanceId}/{EvaluationFormId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "EvaluationFormId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              EvaluationFormId: {
                location: "uri",
                locationName: "EvaluationFormId"
              },
              EvaluationFormVersion: {
                location: "querystring",
                locationName: "version",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EvaluationForm"
            ],
            members: {
              EvaluationForm: {
                type: "structure",
                required: [
                  "EvaluationFormId",
                  "EvaluationFormVersion",
                  "Locked",
                  "EvaluationFormArn",
                  "Title",
                  "Status",
                  "Items",
                  "CreatedTime",
                  "CreatedBy",
                  "LastModifiedTime",
                  "LastModifiedBy"
                ],
                members: {
                  EvaluationFormId: {},
                  EvaluationFormVersion: {
                    type: "integer"
                  },
                  Locked: {
                    type: "boolean"
                  },
                  EvaluationFormArn: {},
                  Title: {},
                  Description: {},
                  Status: {},
                  Items: {
                    shape: "S3u"
                  },
                  ScoringStrategy: {
                    shape: "S4p"
                  },
                  CreatedTime: {
                    type: "timestamp"
                  },
                  CreatedBy: {},
                  LastModifiedTime: {
                    type: "timestamp"
                  },
                  LastModifiedBy: {},
                  Tags: {
                    shape: "S34"
                  }
                }
              }
            }
          }
        },
        DescribeHoursOfOperation: {
          http: {
            method: "GET",
            requestUri: "/hours-of-operations/{InstanceId}/{HoursOfOperationId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "HoursOfOperationId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              HoursOfOperationId: {
                location: "uri",
                locationName: "HoursOfOperationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HoursOfOperation: {
                shape: "Sd3"
              }
            }
          }
        },
        DescribeInstance: {
          http: {
            method: "GET",
            requestUri: "/instance/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Instance: {
                type: "structure",
                members: {
                  Id: {},
                  Arn: {},
                  IdentityManagementType: {},
                  InstanceAlias: {
                    shape: "S57"
                  },
                  CreatedTime: {
                    type: "timestamp"
                  },
                  ServiceRole: {},
                  InstanceStatus: {},
                  StatusReason: {
                    type: "structure",
                    members: {
                      Message: {}
                    }
                  },
                  InboundCallsEnabled: {
                    type: "boolean"
                  },
                  OutboundCallsEnabled: {
                    type: "boolean"
                  },
                  InstanceAccessUrl: {},
                  Tags: {
                    shape: "S34"
                  }
                }
              }
            }
          }
        },
        DescribeInstanceAttribute: {
          http: {
            method: "GET",
            requestUri: "/instance/{InstanceId}/attribute/{AttributeType}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "AttributeType"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              AttributeType: {
                location: "uri",
                locationName: "AttributeType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attribute: {
                shape: "Sdd"
              }
            }
          }
        },
        DescribeInstanceStorageConfig: {
          http: {
            method: "GET",
            requestUri: "/instance/{InstanceId}/storage-config/{AssociationId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "AssociationId",
              "ResourceType"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              AssociationId: {
                location: "uri",
                locationName: "AssociationId"
              },
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StorageConfig: {
                shape: "St"
              }
            }
          }
        },
        DescribePhoneNumber: {
          http: {
            method: "GET",
            requestUri: "/phone-number/{PhoneNumberId}"
          },
          input: {
            type: "structure",
            required: [
              "PhoneNumberId"
            ],
            members: {
              PhoneNumberId: {
                location: "uri",
                locationName: "PhoneNumberId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ClaimedPhoneNumberSummary: {
                type: "structure",
                members: {
                  PhoneNumberId: {},
                  PhoneNumberArn: {},
                  PhoneNumber: {},
                  PhoneNumberCountryCode: {},
                  PhoneNumberType: {},
                  PhoneNumberDescription: {},
                  TargetArn: {},
                  InstanceId: {},
                  Tags: {
                    shape: "S34"
                  },
                  PhoneNumberStatus: {
                    type: "structure",
                    members: {
                      Status: {},
                      Message: {}
                    }
                  },
                  SourcePhoneNumberArn: {}
                }
              }
            }
          }
        },
        DescribePredefinedAttribute: {
          http: {
            method: "GET",
            requestUri: "/predefined-attributes/{InstanceId}/{Name}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Name"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PredefinedAttribute: {
                shape: "Sdr"
              }
            }
          }
        },
        DescribePrompt: {
          http: {
            method: "GET",
            requestUri: "/prompts/{InstanceId}/{PromptId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "PromptId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              PromptId: {
                location: "uri",
                locationName: "PromptId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Prompt: {
                shape: "Sdu"
              }
            }
          }
        },
        DescribeQueue: {
          http: {
            method: "GET",
            requestUri: "/queues/{InstanceId}/{QueueId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "QueueId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              QueueId: {
                location: "uri",
                locationName: "QueueId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Queue: {
                shape: "Sdx"
              }
            }
          }
        },
        DescribeQuickConnect: {
          http: {
            method: "GET",
            requestUri: "/quick-connects/{InstanceId}/{QuickConnectId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "QuickConnectId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              QuickConnectId: {
                location: "uri",
                locationName: "QuickConnectId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              QuickConnect: {
                shape: "Se1"
              }
            }
          }
        },
        DescribeRoutingProfile: {
          http: {
            method: "GET",
            requestUri: "/routing-profiles/{InstanceId}/{RoutingProfileId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "RoutingProfileId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              RoutingProfileId: {
                location: "uri",
                locationName: "RoutingProfileId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RoutingProfile: {
                shape: "Se4"
              }
            }
          }
        },
        DescribeRule: {
          http: {
            method: "GET",
            requestUri: "/rules/{InstanceId}/{RuleId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "RuleId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              RuleId: {
                location: "uri",
                locationName: "RuleId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Rule"
            ],
            members: {
              Rule: {
                type: "structure",
                required: [
                  "Name",
                  "RuleId",
                  "RuleArn",
                  "TriggerEventSource",
                  "Function",
                  "Actions",
                  "PublishStatus",
                  "CreatedTime",
                  "LastUpdatedTime",
                  "LastUpdatedBy"
                ],
                members: {
                  Name: {},
                  RuleId: {},
                  RuleArn: {},
                  TriggerEventSource: {
                    shape: "S6u"
                  },
                  Function: {},
                  Actions: {
                    shape: "S6x"
                  },
                  PublishStatus: {},
                  CreatedTime: {
                    type: "timestamp"
                  },
                  LastUpdatedTime: {
                    type: "timestamp"
                  },
                  LastUpdatedBy: {},
                  Tags: {
                    shape: "S34"
                  }
                }
              }
            }
          }
        },
        DescribeSecurityProfile: {
          http: {
            method: "GET",
            requestUri: "/security-profiles/{InstanceId}/{SecurityProfileId}"
          },
          input: {
            type: "structure",
            required: [
              "SecurityProfileId",
              "InstanceId"
            ],
            members: {
              SecurityProfileId: {
                location: "uri",
                locationName: "SecurityProfileId"
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SecurityProfile: {
                type: "structure",
                members: {
                  Id: {},
                  OrganizationResourceId: {},
                  Arn: {},
                  SecurityProfileName: {},
                  Description: {},
                  Tags: {
                    shape: "S34"
                  },
                  AllowedAccessControlTags: {
                    shape: "S82"
                  },
                  TagRestrictedResources: {
                    shape: "S85"
                  },
                  LastModifiedTime: {
                    type: "timestamp"
                  },
                  LastModifiedRegion: {}
                }
              }
            }
          }
        },
        DescribeTrafficDistributionGroup: {
          http: {
            method: "GET",
            requestUri: "/traffic-distribution-group/{TrafficDistributionGroupId}"
          },
          input: {
            type: "structure",
            required: [
              "TrafficDistributionGroupId"
            ],
            members: {
              TrafficDistributionGroupId: {
                location: "uri",
                locationName: "TrafficDistributionGroupId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrafficDistributionGroup: {
                type: "structure",
                members: {
                  Id: {},
                  Arn: {},
                  Name: {},
                  Description: {},
                  InstanceArn: {},
                  Status: {},
                  Tags: {
                    shape: "S34"
                  },
                  IsDefault: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        DescribeUser: {
          http: {
            method: "GET",
            requestUri: "/users/{InstanceId}/{UserId}"
          },
          input: {
            type: "structure",
            required: [
              "UserId",
              "InstanceId"
            ],
            members: {
              UserId: {
                location: "uri",
                locationName: "UserId"
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                type: "structure",
                members: {
                  Id: {},
                  Arn: {},
                  Username: {},
                  IdentityInfo: {
                    shape: "S9i"
                  },
                  PhoneConfig: {
                    shape: "S9m"
                  },
                  DirectoryUserId: {},
                  SecurityProfileIds: {
                    shape: "S9r"
                  },
                  RoutingProfileId: {},
                  HierarchyGroupId: {},
                  Tags: {
                    shape: "S34"
                  },
                  LastModifiedTime: {
                    type: "timestamp"
                  },
                  LastModifiedRegion: {}
                }
              }
            }
          }
        },
        DescribeUserHierarchyGroup: {
          http: {
            method: "GET",
            requestUri: "/user-hierarchy-groups/{InstanceId}/{HierarchyGroupId}"
          },
          input: {
            type: "structure",
            required: [
              "HierarchyGroupId",
              "InstanceId"
            ],
            members: {
              HierarchyGroupId: {
                location: "uri",
                locationName: "HierarchyGroupId"
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HierarchyGroup: {
                type: "structure",
                members: {
                  Id: {},
                  Arn: {},
                  Name: {},
                  LevelId: {},
                  HierarchyPath: {
                    type: "structure",
                    members: {
                      LevelOne: {
                        shape: "Seq"
                      },
                      LevelTwo: {
                        shape: "Seq"
                      },
                      LevelThree: {
                        shape: "Seq"
                      },
                      LevelFour: {
                        shape: "Seq"
                      },
                      LevelFive: {
                        shape: "Seq"
                      }
                    }
                  },
                  Tags: {
                    shape: "S34"
                  },
                  LastModifiedTime: {
                    type: "timestamp"
                  },
                  LastModifiedRegion: {}
                }
              }
            }
          }
        },
        DescribeUserHierarchyStructure: {
          http: {
            method: "GET",
            requestUri: "/user-hierarchy-structure/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HierarchyStructure: {
                type: "structure",
                members: {
                  LevelOne: {
                    shape: "Seu"
                  },
                  LevelTwo: {
                    shape: "Seu"
                  },
                  LevelThree: {
                    shape: "Seu"
                  },
                  LevelFour: {
                    shape: "Seu"
                  },
                  LevelFive: {
                    shape: "Seu"
                  }
                }
              }
            }
          }
        },
        DescribeView: {
          http: {
            method: "GET",
            requestUri: "/views/{InstanceId}/{ViewId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ViewId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ViewId: {
                location: "uri",
                locationName: "ViewId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              View: {
                shape: "Sa8"
              }
            }
          }
        },
        DescribeVocabulary: {
          http: {
            method: "GET",
            requestUri: "/vocabulary/{InstanceId}/{VocabularyId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "VocabularyId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              VocabularyId: {
                location: "uri",
                locationName: "VocabularyId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Vocabulary"
            ],
            members: {
              Vocabulary: {
                type: "structure",
                required: [
                  "Name",
                  "Id",
                  "Arn",
                  "LanguageCode",
                  "State",
                  "LastModifiedTime"
                ],
                members: {
                  Name: {},
                  Id: {},
                  Arn: {},
                  LanguageCode: {},
                  State: {},
                  LastModifiedTime: {
                    type: "timestamp"
                  },
                  FailureReason: {},
                  Content: {},
                  Tags: {
                    shape: "S34"
                  }
                }
              }
            }
          }
        },
        DisassociateAnalyticsDataSet: {
          http: {
            requestUri: "/analytics-data/instance/{InstanceId}/association"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "DataSetId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              DataSetId: {},
              TargetAccountId: {}
            }
          }
        },
        DisassociateApprovedOrigin: {
          http: {
            method: "DELETE",
            requestUri: "/instance/{InstanceId}/approved-origin"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Origin"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Origin: {
                location: "querystring",
                locationName: "origin"
              }
            }
          }
        },
        DisassociateBot: {
          http: {
            requestUri: "/instance/{InstanceId}/bot"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              LexBot: {
                shape: "Sf"
              },
              LexV2Bot: {
                shape: "Si"
              }
            }
          }
        },
        DisassociateFlow: {
          http: {
            method: "DELETE",
            requestUri: "/flow-associations/{InstanceId}/{ResourceId}/{ResourceType}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ResourceId",
              "ResourceType"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ResourceId: {
                location: "uri",
                locationName: "ResourceId"
              },
              ResourceType: {
                location: "uri",
                locationName: "ResourceType"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateInstanceStorageConfig: {
          http: {
            method: "DELETE",
            requestUri: "/instance/{InstanceId}/storage-config/{AssociationId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "AssociationId",
              "ResourceType"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              AssociationId: {
                location: "uri",
                locationName: "AssociationId"
              },
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              }
            }
          }
        },
        DisassociateLambdaFunction: {
          http: {
            method: "DELETE",
            requestUri: "/instance/{InstanceId}/lambda-function"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "FunctionArn"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              FunctionArn: {
                location: "querystring",
                locationName: "functionArn"
              }
            }
          }
        },
        DisassociateLexBot: {
          http: {
            method: "DELETE",
            requestUri: "/instance/{InstanceId}/lex-bot"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "BotName",
              "LexRegion"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              BotName: {
                location: "querystring",
                locationName: "botName"
              },
              LexRegion: {
                location: "querystring",
                locationName: "lexRegion"
              }
            }
          }
        },
        DisassociatePhoneNumberContactFlow: {
          http: {
            method: "DELETE",
            requestUri: "/phone-number/{PhoneNumberId}/contact-flow"
          },
          input: {
            type: "structure",
            required: [
              "PhoneNumberId",
              "InstanceId"
            ],
            members: {
              PhoneNumberId: {
                location: "uri",
                locationName: "PhoneNumberId"
              },
              InstanceId: {
                location: "querystring",
                locationName: "instanceId"
              }
            }
          }
        },
        DisassociateQueueQuickConnects: {
          http: {
            requestUri: "/queues/{InstanceId}/{QueueId}/disassociate-quick-connects"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "QueueId",
              "QuickConnectIds"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              QueueId: {
                location: "uri",
                locationName: "QueueId"
              },
              QuickConnectIds: {
                shape: "S1f"
              }
            }
          }
        },
        DisassociateRoutingProfileQueues: {
          http: {
            requestUri: "/routing-profiles/{InstanceId}/{RoutingProfileId}/disassociate-queues"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "RoutingProfileId",
              "QueueReferences"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              RoutingProfileId: {
                location: "uri",
                locationName: "RoutingProfileId"
              },
              QueueReferences: {
                type: "list",
                member: {
                  shape: "S1l"
                }
              }
            }
          }
        },
        DisassociateSecurityKey: {
          http: {
            method: "DELETE",
            requestUri: "/instance/{InstanceId}/security-key/{AssociationId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "AssociationId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              AssociationId: {
                location: "uri",
                locationName: "AssociationId"
              }
            }
          }
        },
        DisassociateTrafficDistributionGroupUser: {
          http: {
            method: "DELETE",
            requestUri: "/traffic-distribution-group/{TrafficDistributionGroupId}/user"
          },
          input: {
            type: "structure",
            required: [
              "TrafficDistributionGroupId",
              "UserId",
              "InstanceId"
            ],
            members: {
              TrafficDistributionGroupId: {
                location: "uri",
                locationName: "TrafficDistributionGroupId"
              },
              UserId: {
                location: "querystring",
                locationName: "UserId"
              },
              InstanceId: {
                location: "querystring",
                locationName: "InstanceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DisassociateUserProficiencies: {
          http: {
            requestUri: "/users/{InstanceId}/{UserId}/disassociate-proficiencies"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "UserId",
              "UserProficiencies"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              UserId: {
                location: "uri",
                locationName: "UserId"
              },
              UserProficiencies: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AttributeName",
                    "AttributeValue"
                  ],
                  members: {
                    AttributeName: {},
                    AttributeValue: {}
                  }
                }
              }
            }
          }
        },
        DismissUserContact: {
          http: {
            requestUri: "/users/{InstanceId}/{UserId}/contact"
          },
          input: {
            type: "structure",
            required: [
              "UserId",
              "InstanceId",
              "ContactId"
            ],
            members: {
              UserId: {
                location: "uri",
                locationName: "UserId"
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ContactId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetContactAttributes: {
          http: {
            method: "GET",
            requestUri: "/contact/attributes/{InstanceId}/{InitialContactId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "InitialContactId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              InitialContactId: {
                location: "uri",
                locationName: "InitialContactId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "S2p"
              }
            }
          }
        },
        GetCurrentMetricData: {
          http: {
            requestUri: "/metrics/current/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Filters",
              "CurrentMetrics"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Filters: {
                shape: "Sfq"
              },
              Groupings: {
                shape: "Sfw"
              },
              CurrentMetrics: {
                type: "list",
                member: {
                  shape: "Sfz"
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              SortCriteria: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SortByMetric: {},
                    SortOrder: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              MetricResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Dimensions: {
                      shape: "Sga"
                    },
                    Collections: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Metric: {
                            shape: "Sfz"
                          },
                          Value: {
                            type: "double"
                          }
                        }
                      }
                    }
                  }
                }
              },
              DataSnapshotTime: {
                type: "timestamp"
              },
              ApproximateTotalCount: {
                type: "long"
              }
            }
          }
        },
        GetCurrentUserData: {
          http: {
            requestUri: "/metrics/userdata/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Filters"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Filters: {
                type: "structure",
                members: {
                  Queues: {
                    shape: "Sfr"
                  },
                  ContactFilter: {
                    type: "structure",
                    members: {
                      ContactStates: {
                        type: "list",
                        member: {}
                      }
                    }
                  },
                  RoutingProfiles: {
                    shape: "Sft"
                  },
                  Agents: {
                    type: "list",
                    member: {}
                  },
                  UserHierarchyGroups: {
                    type: "list",
                    member: {}
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              UserDataList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    User: {
                      type: "structure",
                      members: {
                        Id: {},
                        Arn: {}
                      }
                    },
                    RoutingProfile: {
                      shape: "Sgc"
                    },
                    HierarchyPath: {
                      type: "structure",
                      members: {
                        LevelOne: {
                          shape: "Sgt"
                        },
                        LevelTwo: {
                          shape: "Sgt"
                        },
                        LevelThree: {
                          shape: "Sgt"
                        },
                        LevelFour: {
                          shape: "Sgt"
                        },
                        LevelFive: {
                          shape: "Sgt"
                        }
                      }
                    },
                    Status: {
                      type: "structure",
                      members: {
                        StatusStartTimestamp: {
                          type: "timestamp"
                        },
                        StatusArn: {},
                        StatusName: {}
                      }
                    },
                    AvailableSlotsByChannel: {
                      shape: "Sgv"
                    },
                    MaxSlotsByChannel: {
                      shape: "Sgv"
                    },
                    ActiveSlotsByChannel: {
                      shape: "Sgv"
                    },
                    Contacts: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ContactId: {},
                          Channel: {},
                          InitiationMethod: {},
                          AgentContactState: {},
                          StateStartTimestamp: {
                            type: "timestamp"
                          },
                          ConnectedToAgentTimestamp: {
                            type: "timestamp"
                          },
                          Queue: {
                            shape: "Sgb"
                          }
                        }
                      }
                    },
                    NextStatus: {}
                  }
                }
              },
              ApproximateTotalCount: {
                type: "long"
              }
            }
          }
        },
        GetFederationToken: {
          http: {
            method: "GET",
            requestUri: "/user/federate/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Credentials: {
                type: "structure",
                members: {
                  AccessToken: {
                    shape: "Sh2"
                  },
                  AccessTokenExpiration: {
                    type: "timestamp"
                  },
                  RefreshToken: {
                    shape: "Sh2"
                  },
                  RefreshTokenExpiration: {
                    type: "timestamp"
                  }
                }
              },
              SignInUrl: {},
              UserArn: {},
              UserId: {}
            }
          }
        },
        GetFlowAssociation: {
          http: {
            method: "GET",
            requestUri: "/flow-associations/{InstanceId}/{ResourceId}/{ResourceType}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ResourceId",
              "ResourceType"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ResourceId: {
                location: "uri",
                locationName: "ResourceId"
              },
              ResourceType: {
                location: "uri",
                locationName: "ResourceType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceId: {},
              FlowId: {},
              ResourceType: {}
            }
          }
        },
        GetMetricData: {
          http: {
            requestUri: "/metrics/historical/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "StartTime",
              "EndTime",
              "Filters",
              "HistoricalMetrics"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Filters: {
                shape: "Sfq"
              },
              Groupings: {
                shape: "Sfw"
              },
              HistoricalMetrics: {
                type: "list",
                member: {
                  shape: "Sh7"
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              MetricResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Dimensions: {
                      shape: "Sga"
                    },
                    Collections: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Metric: {
                            shape: "Sh7"
                          },
                          Value: {
                            type: "double"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetMetricDataV2: {
          http: {
            requestUri: "/metrics/data"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "StartTime",
              "EndTime",
              "Filters",
              "Metrics"
            ],
            members: {
              ResourceArn: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Interval: {
                type: "structure",
                members: {
                  TimeZone: {},
                  IntervalPeriod: {}
                }
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FilterKey: {},
                    FilterValues: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              Groupings: {
                type: "list",
                member: {}
              },
              Metrics: {
                type: "list",
                member: {
                  shape: "Shs"
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              MetricResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Dimensions: {
                      type: "map",
                      key: {},
                      value: {}
                    },
                    MetricInterval: {
                      type: "structure",
                      members: {
                        Interval: {},
                        StartTime: {
                          type: "timestamp"
                        },
                        EndTime: {
                          type: "timestamp"
                        }
                      }
                    },
                    Collections: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Metric: {
                            shape: "Shs"
                          },
                          Value: {
                            type: "double"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetPromptFile: {
          http: {
            method: "GET",
            requestUri: "/prompts/{InstanceId}/{PromptId}/file"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "PromptId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              PromptId: {
                location: "uri",
                locationName: "PromptId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PromptPresignedUrl: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              LastModifiedRegion: {}
            }
          }
        },
        GetTaskTemplate: {
          http: {
            method: "GET",
            requestUri: "/instance/{InstanceId}/task/template/{TaskTemplateId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "TaskTemplateId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              TaskTemplateId: {
                location: "uri",
                locationName: "TaskTemplateId"
              },
              SnapshotVersion: {
                location: "querystring",
                locationName: "snapshotVersion"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Id",
              "Arn",
              "Name"
            ],
            members: {
              InstanceId: {},
              Id: {},
              Arn: {},
              Name: {},
              Description: {},
              ContactFlowId: {},
              Constraints: {
                shape: "S8h"
              },
              Defaults: {
                shape: "S8q"
              },
              Fields: {
                shape: "S8v"
              },
              Status: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              CreatedTime: {
                type: "timestamp"
              },
              Tags: {
                shape: "S34"
              }
            }
          }
        },
        GetTrafficDistribution: {
          http: {
            method: "GET",
            requestUri: "/traffic-distribution/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TelephonyConfig: {
                shape: "Sih"
              },
              Id: {},
              Arn: {},
              SignInConfig: {
                shape: "Sim"
              },
              AgentConfig: {
                shape: "Sip"
              }
            }
          }
        },
        ImportPhoneNumber: {
          http: {
            requestUri: "/phone-number/import"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "SourcePhoneNumberArn"
            ],
            members: {
              InstanceId: {},
              SourcePhoneNumberArn: {},
              PhoneNumberDescription: {},
              Tags: {
                shape: "S34"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberId: {},
              PhoneNumberArn: {}
            }
          }
        },
        ListAgentStatuses: {
          http: {
            method: "GET",
            requestUri: "/agent-status/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              AgentStatusTypes: {
                location: "querystring",
                locationName: "AgentStatusTypes",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              AgentStatusSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Name: {},
                    Type: {},
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    LastModifiedRegion: {}
                  }
                }
              }
            }
          }
        },
        ListAnalyticsDataAssociations: {
          http: {
            method: "GET",
            requestUri: "/analytics-data/instance/{InstanceId}/association"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              DataSetId: {
                location: "querystring",
                locationName: "DataSetId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Results: {
                shape: "S25"
              },
              NextToken: {}
            }
          }
        },
        ListApprovedOrigins: {
          http: {
            method: "GET",
            requestUri: "/instance/{InstanceId}/approved-origins"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Origins: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListBots: {
          http: {
            method: "GET",
            requestUri: "/instance/{InstanceId}/bots"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "LexVersion"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              LexVersion: {
                location: "querystring",
                locationName: "lexVersion"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LexBots: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LexBot: {
                      shape: "Sf"
                    },
                    LexV2Bot: {
                      shape: "Si"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListContactEvaluations: {
          http: {
            method: "GET",
            requestUri: "/contact-evaluations/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ContactId: {
                location: "querystring",
                locationName: "contactId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EvaluationSummaryList"
            ],
            members: {
              EvaluationSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "EvaluationId",
                    "EvaluationArn",
                    "EvaluationFormTitle",
                    "EvaluationFormId",
                    "Status",
                    "EvaluatorArn",
                    "CreatedTime",
                    "LastModifiedTime"
                  ],
                  members: {
                    EvaluationId: {},
                    EvaluationArn: {},
                    EvaluationFormTitle: {},
                    EvaluationFormId: {},
                    Status: {},
                    EvaluatorArn: {},
                    Score: {
                      shape: "Sca"
                    },
                    CreatedTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListContactFlowModules: {
          http: {
            method: "GET",
            requestUri: "/contact-flow-modules-summary/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              ContactFlowModuleState: {
                location: "querystring",
                locationName: "state"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContactFlowModulesSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Name: {},
                    State: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListContactFlows: {
          http: {
            method: "GET",
            requestUri: "/contact-flows-summary/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ContactFlowTypes: {
                location: "querystring",
                locationName: "contactFlowTypes",
                type: "list",
                member: {}
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContactFlowSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Name: {},
                    ContactFlowType: {},
                    ContactFlowState: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListContactReferences: {
          http: {
            method: "GET",
            requestUri: "/contact/references/{InstanceId}/{ContactId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactId",
              "ReferenceTypes"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ContactId: {
                location: "uri",
                locationName: "ContactId"
              },
              ReferenceTypes: {
                location: "querystring",
                locationName: "referenceTypes",
                type: "list",
                member: {}
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReferenceSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Url: {
                      type: "structure",
                      members: {
                        Name: {},
                        Value: {}
                      }
                    },
                    Attachment: {
                      type: "structure",
                      members: {
                        Name: {},
                        Value: {},
                        Status: {}
                      }
                    },
                    String: {
                      type: "structure",
                      members: {
                        Name: {},
                        Value: {}
                      }
                    },
                    Number: {
                      type: "structure",
                      members: {
                        Name: {},
                        Value: {}
                      }
                    },
                    Date: {
                      type: "structure",
                      members: {
                        Name: {},
                        Value: {}
                      }
                    },
                    Email: {
                      type: "structure",
                      members: {
                        Name: {},
                        Value: {}
                      }
                    }
                  },
                  union: true
                }
              },
              NextToken: {}
            }
          }
        },
        ListDefaultVocabularies: {
          http: {
            requestUri: "/default-vocabulary-summary/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              LanguageCode: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "DefaultVocabularyList"
            ],
            members: {
              DefaultVocabularyList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "InstanceId",
                    "LanguageCode",
                    "VocabularyId",
                    "VocabularyName"
                  ],
                  members: {
                    InstanceId: {},
                    LanguageCode: {},
                    VocabularyId: {},
                    VocabularyName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEvaluationFormVersions: {
          http: {
            method: "GET",
            requestUri: "/evaluation-forms/{InstanceId}/{EvaluationFormId}/versions"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "EvaluationFormId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              EvaluationFormId: {
                location: "uri",
                locationName: "EvaluationFormId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EvaluationFormVersionSummaryList"
            ],
            members: {
              EvaluationFormVersionSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "EvaluationFormArn",
                    "EvaluationFormId",
                    "EvaluationFormVersion",
                    "Locked",
                    "Status",
                    "CreatedTime",
                    "CreatedBy",
                    "LastModifiedTime",
                    "LastModifiedBy"
                  ],
                  members: {
                    EvaluationFormArn: {},
                    EvaluationFormId: {},
                    EvaluationFormVersion: {
                      type: "integer"
                    },
                    Locked: {
                      type: "boolean"
                    },
                    Status: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    CreatedBy: {},
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    LastModifiedBy: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEvaluationForms: {
          http: {
            method: "GET",
            requestUri: "/evaluation-forms/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EvaluationFormSummaryList"
            ],
            members: {
              EvaluationFormSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "EvaluationFormId",
                    "EvaluationFormArn",
                    "Title",
                    "CreatedTime",
                    "CreatedBy",
                    "LastModifiedTime",
                    "LastModifiedBy",
                    "LatestVersion"
                  ],
                  members: {
                    EvaluationFormId: {},
                    EvaluationFormArn: {},
                    Title: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    CreatedBy: {},
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    LastModifiedBy: {},
                    LastActivatedTime: {
                      type: "timestamp"
                    },
                    LastActivatedBy: {},
                    LatestVersion: {
                      type: "integer"
                    },
                    ActiveVersion: {
                      type: "integer"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListFlowAssociations: {
          http: {
            method: "GET",
            requestUri: "/flow-associations-summary/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ResourceType: {
                location: "querystring",
                locationName: "ResourceType"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FlowAssociationSummaryList: {
                shape: "S2f"
              },
              NextToken: {}
            }
          }
        },
        ListHoursOfOperations: {
          http: {
            method: "GET",
            requestUri: "/hours-of-operations-summary/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HoursOfOperationSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Name: {},
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    LastModifiedRegion: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListInstanceAttributes: {
          http: {
            method: "GET",
            requestUri: "/instance/{InstanceId}/attributes"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                type: "list",
                member: {
                  shape: "Sdd"
                }
              },
              NextToken: {}
            }
          }
        },
        ListInstanceStorageConfigs: {
          http: {
            method: "GET",
            requestUri: "/instance/{InstanceId}/storage-configs"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ResourceType"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StorageConfigs: {
                type: "list",
                member: {
                  shape: "St"
                }
              },
              NextToken: {}
            }
          }
        },
        ListInstances: {
          http: {
            method: "GET",
            requestUri: "/instance"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    IdentityManagementType: {},
                    InstanceAlias: {
                      shape: "S57"
                    },
                    CreatedTime: {
                      type: "timestamp"
                    },
                    ServiceRole: {},
                    InstanceStatus: {},
                    InboundCallsEnabled: {
                      type: "boolean"
                    },
                    OutboundCallsEnabled: {
                      type: "boolean"
                    },
                    InstanceAccessUrl: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListIntegrationAssociations: {
          http: {
            method: "GET",
            requestUri: "/instance/{InstanceId}/integration-associations"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              IntegrationType: {
                location: "querystring",
                locationName: "integrationType"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              IntegrationArn: {
                location: "querystring",
                locationName: "integrationArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IntegrationAssociationSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    IntegrationAssociationId: {},
                    IntegrationAssociationArn: {},
                    InstanceId: {},
                    IntegrationType: {},
                    IntegrationArn: {},
                    SourceApplicationUrl: {},
                    SourceApplicationName: {},
                    SourceType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListLambdaFunctions: {
          http: {
            method: "GET",
            requestUri: "/instance/{InstanceId}/lambda-functions"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LambdaFunctions: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListLexBots: {
          http: {
            method: "GET",
            requestUri: "/instance/{InstanceId}/lex-bots"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LexBots: {
                type: "list",
                member: {
                  shape: "Sf"
                }
              },
              NextToken: {}
            }
          }
        },
        ListPhoneNumbers: {
          http: {
            method: "GET",
            requestUri: "/phone-numbers-summary/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              PhoneNumberTypes: {
                shape: "Sl5",
                location: "querystring",
                locationName: "phoneNumberTypes"
              },
              PhoneNumberCountryCodes: {
                shape: "Sl6",
                location: "querystring",
                locationName: "phoneNumberCountryCodes"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    PhoneNumber: {},
                    PhoneNumberType: {},
                    PhoneNumberCountryCode: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPhoneNumbersV2: {
          http: {
            requestUri: "/phone-number/list"
          },
          input: {
            type: "structure",
            members: {
              TargetArn: {},
              InstanceId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              PhoneNumberCountryCodes: {
                shape: "Sl6"
              },
              PhoneNumberTypes: {
                shape: "Sl5"
              },
              PhoneNumberPrefix: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ListPhoneNumbersSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PhoneNumberId: {},
                    PhoneNumberArn: {},
                    PhoneNumber: {},
                    PhoneNumberCountryCode: {},
                    PhoneNumberType: {},
                    TargetArn: {},
                    InstanceId: {},
                    PhoneNumberDescription: {},
                    SourcePhoneNumberArn: {}
                  }
                }
              }
            }
          }
        },
        ListPredefinedAttributes: {
          http: {
            method: "GET",
            requestUri: "/predefined-attributes/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              PredefinedAttributeSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    LastModifiedRegion: {}
                  }
                }
              }
            }
          }
        },
        ListPrompts: {
          http: {
            method: "GET",
            requestUri: "/prompts-summary/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PromptSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Name: {},
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    LastModifiedRegion: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListQueueQuickConnects: {
          http: {
            method: "GET",
            requestUri: "/queues/{InstanceId}/{QueueId}/quick-connects"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "QueueId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              QueueId: {
                location: "uri",
                locationName: "QueueId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              QuickConnectSummaryList: {
                shape: "Slr"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastModifiedRegion: {}
            }
          }
        },
        ListQueues: {
          http: {
            method: "GET",
            requestUri: "/queues-summary/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              QueueTypes: {
                location: "querystring",
                locationName: "queueTypes",
                type: "list",
                member: {}
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              QueueSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Name: {},
                    QueueType: {},
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    LastModifiedRegion: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListQuickConnects: {
          http: {
            method: "GET",
            requestUri: "/quick-connects/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              QuickConnectTypes: {
                location: "querystring",
                locationName: "QuickConnectTypes",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              QuickConnectSummaryList: {
                shape: "Slr"
              },
              NextToken: {}
            }
          }
        },
        ListRealtimeContactAnalysisSegmentsV2: {
          http: {
            requestUri: "/contact/list-real-time-analysis-segments-v2/{InstanceId}/{ContactId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactId",
              "OutputType",
              "SegmentTypes"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ContactId: {
                location: "uri",
                locationName: "ContactId"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              OutputType: {},
              SegmentTypes: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Channel",
              "Status",
              "Segments"
            ],
            members: {
              Channel: {},
              Status: {},
              Segments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Transcript: {
                      type: "structure",
                      required: [
                        "Id",
                        "ParticipantId",
                        "ParticipantRole",
                        "Content",
                        "Time"
                      ],
                      members: {
                        Id: {},
                        ParticipantId: {},
                        ParticipantRole: {},
                        DisplayName: {},
                        Content: {},
                        ContentType: {},
                        Time: {
                          shape: "Smg"
                        },
                        Redaction: {
                          type: "structure",
                          members: {
                            CharacterOffsets: {
                              type: "list",
                              member: {
                                shape: "Smk"
                              }
                            }
                          }
                        },
                        Sentiment: {}
                      }
                    },
                    Categories: {
                      type: "structure",
                      required: [
                        "MatchedDetails"
                      ],
                      members: {
                        MatchedDetails: {
                          type: "map",
                          key: {},
                          value: {
                            type: "structure",
                            required: [
                              "PointsOfInterest"
                            ],
                            members: {
                              PointsOfInterest: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    TranscriptItems: {
                                      type: "list",
                                      member: {
                                        type: "structure",
                                        required: [
                                          "Id"
                                        ],
                                        members: {
                                          Id: {},
                                          CharacterOffsets: {
                                            shape: "Smk"
                                          }
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    Issues: {
                      type: "structure",
                      required: [
                        "IssuesDetected"
                      ],
                      members: {
                        IssuesDetected: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "TranscriptItems"
                            ],
                            members: {
                              TranscriptItems: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  required: [
                                    "Id"
                                  ],
                                  members: {
                                    Content: {},
                                    Id: {},
                                    CharacterOffsets: {
                                      shape: "Smk"
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    Event: {
                      type: "structure",
                      required: [
                        "Id",
                        "EventType",
                        "Time"
                      ],
                      members: {
                        Id: {},
                        ParticipantId: {},
                        ParticipantRole: {},
                        DisplayName: {},
                        EventType: {},
                        Time: {
                          shape: "Smg"
                        }
                      }
                    },
                    Attachments: {
                      type: "structure",
                      required: [
                        "Id",
                        "ParticipantId",
                        "ParticipantRole",
                        "Attachments",
                        "Time"
                      ],
                      members: {
                        Id: {},
                        ParticipantId: {},
                        ParticipantRole: {},
                        DisplayName: {},
                        Attachments: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "AttachmentName",
                              "AttachmentId"
                            ],
                            members: {
                              AttachmentName: {},
                              ContentType: {},
                              AttachmentId: {},
                              Status: {}
                            }
                          }
                        },
                        Time: {
                          shape: "Smg"
                        }
                      }
                    }
                  },
                  union: true
                }
              },
              NextToken: {}
            }
          }
        },
        ListRoutingProfileQueues: {
          http: {
            method: "GET",
            requestUri: "/routing-profiles/{InstanceId}/{RoutingProfileId}/queues"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "RoutingProfileId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              RoutingProfileId: {
                location: "uri",
                locationName: "RoutingProfileId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              RoutingProfileQueueConfigSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "QueueId",
                    "QueueArn",
                    "QueueName",
                    "Priority",
                    "Delay",
                    "Channel"
                  ],
                  members: {
                    QueueId: {},
                    QueueArn: {},
                    QueueName: {},
                    Priority: {
                      type: "integer"
                    },
                    Delay: {
                      type: "integer"
                    },
                    Channel: {}
                  }
                }
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastModifiedRegion: {}
            }
          }
        },
        ListRoutingProfiles: {
          http: {
            method: "GET",
            requestUri: "/routing-profiles-summary/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RoutingProfileSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Name: {},
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    LastModifiedRegion: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListRules: {
          http: {
            method: "GET",
            requestUri: "/rules/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              PublishStatus: {
                location: "querystring",
                locationName: "publishStatus"
              },
              EventSourceName: {
                location: "querystring",
                locationName: "eventSourceName"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "RuleSummaryList"
            ],
            members: {
              RuleSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "RuleId",
                    "RuleArn",
                    "EventSourceName",
                    "PublishStatus",
                    "ActionSummaries",
                    "CreatedTime",
                    "LastUpdatedTime"
                  ],
                  members: {
                    Name: {},
                    RuleId: {},
                    RuleArn: {},
                    EventSourceName: {},
                    PublishStatus: {},
                    ActionSummaries: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "ActionType"
                        ],
                        members: {
                          ActionType: {}
                        }
                      }
                    },
                    CreatedTime: {
                      type: "timestamp"
                    },
                    LastUpdatedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSecurityKeys: {
          http: {
            method: "GET",
            requestUri: "/instance/{InstanceId}/security-keys"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SecurityKeys: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AssociationId: {},
                    Key: {},
                    CreationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSecurityProfileApplications: {
          http: {
            method: "GET",
            requestUri: "/security-profiles-applications/{InstanceId}/{SecurityProfileId}"
          },
          input: {
            type: "structure",
            required: [
              "SecurityProfileId",
              "InstanceId"
            ],
            members: {
              SecurityProfileId: {
                location: "uri",
                locationName: "SecurityProfileId"
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Applications: {
                shape: "S87"
              },
              NextToken: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              LastModifiedRegion: {}
            }
          }
        },
        ListSecurityProfilePermissions: {
          http: {
            method: "GET",
            requestUri: "/security-profiles-permissions/{InstanceId}/{SecurityProfileId}"
          },
          input: {
            type: "structure",
            required: [
              "SecurityProfileId",
              "InstanceId"
            ],
            members: {
              SecurityProfileId: {
                location: "uri",
                locationName: "SecurityProfileId"
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Permissions: {
                shape: "S80"
              },
              NextToken: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              LastModifiedRegion: {}
            }
          }
        },
        ListSecurityProfiles: {
          http: {
            method: "GET",
            requestUri: "/security-profiles-summary/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SecurityProfileSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Name: {},
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    LastModifiedRegion: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S34"
              }
            }
          }
        },
        ListTaskTemplates: {
          http: {
            method: "GET",
            requestUri: "/instance/{InstanceId}/task/template"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              Status: {
                location: "querystring",
                locationName: "status"
              },
              Name: {
                location: "querystring",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TaskTemplates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Name: {},
                    Description: {},
                    Status: {},
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    CreatedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTrafficDistributionGroupUsers: {
          http: {
            method: "GET",
            requestUri: "/traffic-distribution-group/{TrafficDistributionGroupId}/user"
          },
          input: {
            type: "structure",
            required: [
              "TrafficDistributionGroupId"
            ],
            members: {
              TrafficDistributionGroupId: {
                location: "uri",
                locationName: "TrafficDistributionGroupId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              TrafficDistributionGroupUserSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    UserId: {}
                  }
                }
              }
            }
          }
        },
        ListTrafficDistributionGroups: {
          http: {
            method: "GET",
            requestUri: "/traffic-distribution-groups"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              InstanceId: {
                location: "querystring",
                locationName: "instanceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              TrafficDistributionGroupSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Name: {},
                    InstanceArn: {},
                    Status: {},
                    IsDefault: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        ListUseCases: {
          http: {
            method: "GET",
            requestUri: "/instance/{InstanceId}/integration-associations/{IntegrationAssociationId}/use-cases"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "IntegrationAssociationId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              IntegrationAssociationId: {
                location: "uri",
                locationName: "IntegrationAssociationId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UseCaseSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    UseCaseId: {},
                    UseCaseArn: {},
                    UseCaseType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListUserHierarchyGroups: {
          http: {
            method: "GET",
            requestUri: "/user-hierarchy-groups-summary/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserHierarchyGroupSummaryList: {
                type: "list",
                member: {
                  shape: "Seq"
                }
              },
              NextToken: {}
            }
          }
        },
        ListUserProficiencies: {
          http: {
            method: "GET",
            requestUri: "/users/{InstanceId}/{UserId}/proficiencies"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "UserId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              UserId: {
                location: "uri",
                locationName: "UserId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              UserProficiencyList: {
                shape: "S1x"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastModifiedRegion: {}
            }
          }
        },
        ListUsers: {
          http: {
            method: "GET",
            requestUri: "/users-summary/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Username: {},
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    LastModifiedRegion: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListViewVersions: {
          http: {
            method: "GET",
            requestUri: "/views/{InstanceId}/{ViewId}/versions"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ViewId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ViewId: {
                location: "uri",
                locationName: "ViewId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ViewVersionSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Description: {},
                    Name: {
                      shape: "Sa6"
                    },
                    Type: {},
                    Version: {
                      type: "integer"
                    },
                    VersionDescription: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListViews: {
          http: {
            method: "GET",
            requestUri: "/views/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Type: {
                location: "querystring",
                locationName: "type"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ViewsSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Name: {
                      shape: "Sa6"
                    },
                    Type: {},
                    Status: {},
                    Description: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        MonitorContact: {
          http: {
            requestUri: "/contact/monitor"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactId",
              "UserId"
            ],
            members: {
              InstanceId: {},
              ContactId: {},
              UserId: {},
              AllowedMonitorCapabilities: {
                type: "list",
                member: {}
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContactId: {},
              ContactArn: {}
            }
          }
        },
        PauseContact: {
          http: {
            requestUri: "/contact/pause"
          },
          input: {
            type: "structure",
            required: [
              "ContactId",
              "InstanceId"
            ],
            members: {
              ContactId: {},
              InstanceId: {},
              ContactFlowId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutUserStatus: {
          http: {
            method: "PUT",
            requestUri: "/users/{InstanceId}/{UserId}/status"
          },
          input: {
            type: "structure",
            required: [
              "UserId",
              "InstanceId",
              "AgentStatusId"
            ],
            members: {
              UserId: {
                location: "uri",
                locationName: "UserId"
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              AgentStatusId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ReleasePhoneNumber: {
          http: {
            method: "DELETE",
            requestUri: "/phone-number/{PhoneNumberId}"
          },
          input: {
            type: "structure",
            required: [
              "PhoneNumberId"
            ],
            members: {
              PhoneNumberId: {
                location: "uri",
                locationName: "PhoneNumberId"
              },
              ClientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          }
        },
        ReplicateInstance: {
          http: {
            requestUri: "/instance/{InstanceId}/replicate"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ReplicaRegion",
              "ReplicaAlias"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ReplicaRegion: {},
              ClientToken: {
                idempotencyToken: true
              },
              ReplicaAlias: {
                shape: "S57"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {},
              Arn: {}
            }
          }
        },
        ResumeContact: {
          http: {
            requestUri: "/contact/resume"
          },
          input: {
            type: "structure",
            required: [
              "ContactId",
              "InstanceId"
            ],
            members: {
              ContactId: {},
              InstanceId: {},
              ContactFlowId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ResumeContactRecording: {
          http: {
            requestUri: "/contact/resume-recording"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactId",
              "InitialContactId"
            ],
            members: {
              InstanceId: {},
              ContactId: {},
              InitialContactId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SearchAvailablePhoneNumbers: {
          http: {
            requestUri: "/phone-number/search-available"
          },
          input: {
            type: "structure",
            required: [
              "PhoneNumberCountryCode",
              "PhoneNumberType"
            ],
            members: {
              TargetArn: {},
              InstanceId: {},
              PhoneNumberCountryCode: {},
              PhoneNumberType: {},
              PhoneNumberPrefix: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              AvailableNumbersList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PhoneNumber: {},
                    PhoneNumberCountryCode: {},
                    PhoneNumberType: {}
                  }
                }
              }
            }
          }
        },
        SearchContacts: {
          http: {
            requestUri: "/search-contacts"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "TimeRange"
            ],
            members: {
              InstanceId: {},
              TimeRange: {
                type: "structure",
                required: [
                  "Type",
                  "StartTime",
                  "EndTime"
                ],
                members: {
                  Type: {},
                  StartTime: {
                    type: "timestamp"
                  },
                  EndTime: {
                    type: "timestamp"
                  }
                }
              },
              SearchCriteria: {
                type: "structure",
                members: {
                  AgentIds: {
                    type: "list",
                    member: {}
                  },
                  AgentHierarchyGroups: {
                    type: "structure",
                    members: {
                      L1Ids: {
                        shape: "Spr"
                      },
                      L2Ids: {
                        shape: "Spr"
                      },
                      L3Ids: {
                        shape: "Spr"
                      },
                      L4Ids: {
                        shape: "Spr"
                      },
                      L5Ids: {
                        shape: "Spr"
                      }
                    }
                  },
                  Channels: {
                    type: "list",
                    member: {}
                  },
                  ContactAnalysis: {
                    type: "structure",
                    members: {
                      Transcript: {
                        type: "structure",
                        required: [
                          "Criteria"
                        ],
                        members: {
                          Criteria: {
                            type: "list",
                            member: {
                              type: "structure",
                              required: [
                                "ParticipantRole",
                                "SearchText",
                                "MatchType"
                              ],
                              members: {
                                ParticipantRole: {},
                                SearchText: {
                                  type: "list",
                                  member: {
                                    type: "string",
                                    sensitive: true
                                  }
                                },
                                MatchType: {}
                              }
                            }
                          },
                          MatchType: {}
                        }
                      }
                    }
                  },
                  InitiationMethods: {
                    type: "list",
                    member: {}
                  },
                  QueueIds: {
                    type: "list",
                    member: {}
                  },
                  SearchableContactAttributes: {
                    type: "structure",
                    required: [
                      "Criteria"
                    ],
                    members: {
                      Criteria: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "Key",
                            "Values"
                          ],
                          members: {
                            Key: {
                              type: "string",
                              sensitive: true
                            },
                            Values: {
                              type: "list",
                              member: {
                                type: "string",
                                sensitive: true
                              }
                            }
                          }
                        }
                      },
                      MatchType: {}
                    }
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Sort: {
                type: "structure",
                required: [
                  "FieldName",
                  "Order"
                ],
                members: {
                  FieldName: {},
                  Order: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Contacts"
            ],
            members: {
              Contacts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Id: {},
                    InitialContactId: {},
                    PreviousContactId: {},
                    InitiationMethod: {},
                    Channel: {},
                    QueueInfo: {
                      type: "structure",
                      members: {
                        Id: {},
                        EnqueueTimestamp: {
                          type: "timestamp"
                        }
                      }
                    },
                    AgentInfo: {
                      type: "structure",
                      members: {
                        Id: {},
                        ConnectedToAgentTimestamp: {
                          type: "timestamp"
                        }
                      }
                    },
                    InitiationTimestamp: {
                      type: "timestamp"
                    },
                    DisconnectTimestamp: {
                      type: "timestamp"
                    },
                    ScheduledTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {},
              TotalCount: {
                type: "long"
              }
            }
          }
        },
        SearchHoursOfOperations: {
          http: {
            requestUri: "/search-hours-of-operations"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              SearchFilter: {
                type: "structure",
                members: {
                  TagFilter: {
                    shape: "Sqi"
                  }
                }
              },
              SearchCriteria: {
                shape: "Sqm"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HoursOfOperations: {
                type: "list",
                member: {
                  shape: "Sd3"
                }
              },
              NextToken: {},
              ApproximateTotalCount: {
                type: "long"
              }
            }
          }
        },
        SearchPredefinedAttributes: {
          http: {
            requestUri: "/search-predefined-attributes"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              SearchCriteria: {
                shape: "Sqt"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PredefinedAttributes: {
                type: "list",
                member: {
                  shape: "Sdr"
                }
              },
              NextToken: {},
              ApproximateTotalCount: {
                type: "long"
              }
            }
          }
        },
        SearchPrompts: {
          http: {
            requestUri: "/search-prompts"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              SearchFilter: {
                type: "structure",
                members: {
                  TagFilter: {
                    shape: "Sqi"
                  }
                }
              },
              SearchCriteria: {
                shape: "Sqz"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Prompts: {
                type: "list",
                member: {
                  shape: "Sdu"
                }
              },
              NextToken: {},
              ApproximateTotalCount: {
                type: "long"
              }
            }
          }
        },
        SearchQueues: {
          http: {
            requestUri: "/search-queues"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              SearchFilter: {
                type: "structure",
                members: {
                  TagFilter: {
                    shape: "Sqi"
                  }
                }
              },
              SearchCriteria: {
                shape: "Sr5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Queues: {
                type: "list",
                member: {
                  shape: "Sdx"
                }
              },
              NextToken: {},
              ApproximateTotalCount: {
                type: "long"
              }
            }
          }
        },
        SearchQuickConnects: {
          http: {
            requestUri: "/search-quick-connects"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              SearchFilter: {
                type: "structure",
                members: {
                  TagFilter: {
                    shape: "Sqi"
                  }
                }
              },
              SearchCriteria: {
                shape: "Src"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              QuickConnects: {
                type: "list",
                member: {
                  shape: "Se1"
                }
              },
              NextToken: {},
              ApproximateTotalCount: {
                type: "long"
              }
            }
          }
        },
        SearchResourceTags: {
          http: {
            requestUri: "/search-resource-tags"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              ResourceTypes: {
                type: "list",
                member: {}
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              SearchCriteria: {
                type: "structure",
                members: {
                  TagSearchCondition: {
                    type: "structure",
                    members: {
                      tagKey: {},
                      tagValue: {},
                      tagKeyComparisonType: {},
                      tagValueComparisonType: {}
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    key: {},
                    value: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        SearchRoutingProfiles: {
          http: {
            requestUri: "/search-routing-profiles"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              SearchFilter: {
                type: "structure",
                members: {
                  TagFilter: {
                    shape: "Sqi"
                  }
                }
              },
              SearchCriteria: {
                shape: "Srr"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RoutingProfiles: {
                type: "list",
                member: {
                  shape: "Se4"
                }
              },
              NextToken: {},
              ApproximateTotalCount: {
                type: "long"
              }
            }
          }
        },
        SearchSecurityProfiles: {
          http: {
            requestUri: "/search-security-profiles"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              SearchCriteria: {
                shape: "Srw"
              },
              SearchFilter: {
                type: "structure",
                members: {
                  TagFilter: {
                    shape: "Sqi"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SecurityProfiles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    OrganizationResourceId: {},
                    Arn: {},
                    SecurityProfileName: {},
                    Description: {},
                    Tags: {
                      shape: "S34"
                    }
                  }
                }
              },
              NextToken: {},
              ApproximateTotalCount: {
                type: "long"
              }
            }
          }
        },
        SearchUsers: {
          http: {
            requestUri: "/search-users"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              SearchFilter: {
                type: "structure",
                members: {
                  TagFilter: {
                    shape: "Sqi"
                  }
                }
              },
              SearchCriteria: {
                shape: "Ss4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Users: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    DirectoryUserId: {},
                    HierarchyGroupId: {},
                    Id: {},
                    IdentityInfo: {
                      type: "structure",
                      members: {
                        FirstName: {},
                        LastName: {}
                      }
                    },
                    PhoneConfig: {
                      shape: "S9m"
                    },
                    RoutingProfileId: {},
                    SecurityProfileIds: {
                      shape: "S9r"
                    },
                    Tags: {
                      shape: "S34"
                    },
                    Username: {}
                  }
                }
              },
              NextToken: {},
              ApproximateTotalCount: {
                type: "long"
              }
            }
          }
        },
        SearchVocabularies: {
          http: {
            requestUri: "/vocabulary-summary/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              State: {},
              NameStartsWith: {},
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VocabularySummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Id",
                    "Arn",
                    "LanguageCode",
                    "State",
                    "LastModifiedTime"
                  ],
                  members: {
                    Name: {},
                    Id: {},
                    Arn: {},
                    LanguageCode: {},
                    State: {},
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    FailureReason: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        SendChatIntegrationEvent: {
          http: {
            requestUri: "/chat-integration-event"
          },
          input: {
            type: "structure",
            required: [
              "SourceId",
              "DestinationId",
              "Event"
            ],
            members: {
              SourceId: {},
              DestinationId: {},
              Subtype: {},
              Event: {
                type: "structure",
                required: [
                  "Type"
                ],
                members: {
                  Type: {},
                  ContentType: {},
                  Content: {}
                }
              },
              NewSessionDetails: {
                type: "structure",
                members: {
                  SupportedMessagingContentTypes: {
                    shape: "Ssp"
                  },
                  ParticipantDetails: {
                    shape: "Ssr"
                  },
                  Attributes: {
                    shape: "S2p"
                  },
                  StreamingConfiguration: {
                    shape: "Sss"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InitialContactId: {},
              NewChatCreated: {
                type: "boolean"
              }
            }
          }
        },
        StartChatContact: {
          http: {
            method: "PUT",
            requestUri: "/contact/chat"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactFlowId",
              "ParticipantDetails"
            ],
            members: {
              InstanceId: {},
              ContactFlowId: {},
              Attributes: {
                shape: "S2p"
              },
              ParticipantDetails: {
                shape: "Ssr"
              },
              InitialMessage: {
                type: "structure",
                required: [
                  "ContentType",
                  "Content"
                ],
                members: {
                  ContentType: {},
                  Content: {}
                }
              },
              ClientToken: {
                idempotencyToken: true
              },
              ChatDurationInMinutes: {
                type: "integer"
              },
              SupportedMessagingContentTypes: {
                shape: "Ssp"
              },
              PersistentChat: {
                type: "structure",
                members: {
                  RehydrationType: {},
                  SourceContactId: {}
                }
              },
              RelatedContactId: {},
              SegmentAttributes: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    ValueString: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContactId: {},
              ParticipantId: {},
              ParticipantToken: {},
              ContinuedFromContactId: {}
            }
          }
        },
        StartContactEvaluation: {
          http: {
            method: "PUT",
            requestUri: "/contact-evaluations/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactId",
              "EvaluationFormId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ContactId: {},
              EvaluationFormId: {},
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EvaluationId",
              "EvaluationArn"
            ],
            members: {
              EvaluationId: {},
              EvaluationArn: {}
            }
          },
          idempotent: true
        },
        StartContactRecording: {
          http: {
            requestUri: "/contact/start-recording"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactId",
              "InitialContactId",
              "VoiceRecordingConfiguration"
            ],
            members: {
              InstanceId: {},
              ContactId: {},
              InitialContactId: {},
              VoiceRecordingConfiguration: {
                type: "structure",
                members: {
                  VoiceRecordingTrack: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartContactStreaming: {
          http: {
            requestUri: "/contact/start-streaming"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactId",
              "ChatStreamingConfiguration",
              "ClientToken"
            ],
            members: {
              InstanceId: {},
              ContactId: {},
              ChatStreamingConfiguration: {
                shape: "Sss"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "StreamingId"
            ],
            members: {
              StreamingId: {}
            }
          }
        },
        StartOutboundVoiceContact: {
          http: {
            method: "PUT",
            requestUri: "/contact/outbound-voice"
          },
          input: {
            type: "structure",
            required: [
              "DestinationPhoneNumber",
              "ContactFlowId",
              "InstanceId"
            ],
            members: {
              Name: {},
              Description: {},
              References: {
                shape: "S73"
              },
              RelatedContactId: {},
              DestinationPhoneNumber: {},
              ContactFlowId: {},
              InstanceId: {},
              ClientToken: {
                idempotencyToken: true
              },
              SourcePhoneNumber: {},
              QueueId: {},
              Attributes: {
                shape: "S2p"
              },
              AnswerMachineDetectionConfig: {
                type: "structure",
                members: {
                  EnableAnswerMachineDetection: {
                    type: "boolean"
                  },
                  AwaitAnswerMachinePrompt: {
                    type: "boolean"
                  }
                }
              },
              CampaignId: {},
              TrafficType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ContactId: {}
            }
          }
        },
        StartTaskContact: {
          http: {
            method: "PUT",
            requestUri: "/contact/task"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Name"
            ],
            members: {
              InstanceId: {},
              PreviousContactId: {},
              ContactFlowId: {},
              Attributes: {
                shape: "S2p"
              },
              Name: {},
              References: {
                shape: "S73"
              },
              Description: {},
              ClientToken: {
                idempotencyToken: true
              },
              ScheduledTime: {
                type: "timestamp"
              },
              TaskTemplateId: {},
              QuickConnectId: {},
              RelatedContactId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ContactId: {}
            }
          }
        },
        StartWebRTCContact: {
          http: {
            method: "PUT",
            requestUri: "/contact/webrtc"
          },
          input: {
            type: "structure",
            required: [
              "ContactFlowId",
              "InstanceId",
              "ParticipantDetails"
            ],
            members: {
              Attributes: {
                shape: "S2p"
              },
              ClientToken: {
                idempotencyToken: true
              },
              ContactFlowId: {},
              InstanceId: {},
              AllowedCapabilities: {
                type: "structure",
                members: {
                  Customer: {
                    shape: "Stm"
                  },
                  Agent: {
                    shape: "Stm"
                  }
                }
              },
              ParticipantDetails: {
                shape: "Ssr"
              },
              RelatedContactId: {},
              References: {
                shape: "S73"
              },
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionData: {
                type: "structure",
                members: {
                  Attendee: {
                    type: "structure",
                    members: {
                      AttendeeId: {},
                      JoinToken: {
                        type: "string",
                        sensitive: true
                      }
                    }
                  },
                  Meeting: {
                    type: "structure",
                    members: {
                      MediaRegion: {},
                      MediaPlacement: {
                        type: "structure",
                        members: {
                          AudioHostUrl: {},
                          AudioFallbackUrl: {},
                          SignalingUrl: {},
                          TurnControlUrl: {},
                          EventIngestionUrl: {}
                        }
                      },
                      MeetingFeatures: {
                        type: "structure",
                        members: {
                          Audio: {
                            type: "structure",
                            members: {
                              EchoReduction: {}
                            }
                          }
                        }
                      },
                      MeetingId: {}
                    }
                  }
                }
              },
              ContactId: {},
              ParticipantId: {},
              ParticipantToken: {}
            }
          }
        },
        StopContact: {
          http: {
            requestUri: "/contact/stop"
          },
          input: {
            type: "structure",
            required: [
              "ContactId",
              "InstanceId"
            ],
            members: {
              ContactId: {},
              InstanceId: {},
              DisconnectReason: {
                type: "structure",
                members: {
                  Code: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StopContactRecording: {
          http: {
            requestUri: "/contact/stop-recording"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactId",
              "InitialContactId"
            ],
            members: {
              InstanceId: {},
              ContactId: {},
              InitialContactId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StopContactStreaming: {
          http: {
            requestUri: "/contact/stop-streaming"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactId",
              "StreamingId"
            ],
            members: {
              InstanceId: {},
              ContactId: {},
              StreamingId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SubmitContactEvaluation: {
          http: {
            requestUri: "/contact-evaluations/{InstanceId}/{EvaluationId}/submit"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "EvaluationId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              EvaluationId: {
                location: "uri",
                locationName: "EvaluationId"
              },
              Answers: {
                shape: "Su9"
              },
              Notes: {
                shape: "Sch"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EvaluationId",
              "EvaluationArn"
            ],
            members: {
              EvaluationId: {},
              EvaluationArn: {}
            }
          }
        },
        SuspendContactRecording: {
          http: {
            requestUri: "/contact/suspend-recording"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactId",
              "InitialContactId"
            ],
            members: {
              InstanceId: {},
              ContactId: {},
              InitialContactId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagContact: {
          http: {
            requestUri: "/contact/tags"
          },
          input: {
            type: "structure",
            required: [
              "ContactId",
              "InstanceId",
              "Tags"
            ],
            members: {
              ContactId: {},
              InstanceId: {},
              Tags: {
                shape: "Sc3"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S34"
              }
            }
          }
        },
        TransferContact: {
          http: {
            requestUri: "/contact/transfer"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactId",
              "ContactFlowId"
            ],
            members: {
              InstanceId: {},
              ContactId: {},
              QueueId: {},
              UserId: {},
              ContactFlowId: {},
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContactId: {},
              ContactArn: {}
            }
          }
        },
        UntagContact: {
          http: {
            method: "DELETE",
            requestUri: "/contact/tags/{InstanceId}/{ContactId}"
          },
          input: {
            type: "structure",
            required: [
              "ContactId",
              "InstanceId",
              "TagKeys"
            ],
            members: {
              ContactId: {
                location: "uri",
                locationName: "ContactId"
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              TagKeys: {
                location: "querystring",
                locationName: "TagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          }
        },
        UpdateAgentStatus: {
          http: {
            requestUri: "/agent-status/{InstanceId}/{AgentStatusId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "AgentStatusId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              AgentStatusId: {
                location: "uri",
                locationName: "AgentStatusId"
              },
              Name: {},
              Description: {},
              State: {},
              DisplayOrder: {
                type: "integer"
              },
              ResetOrderNumber: {
                type: "boolean"
              }
            }
          }
        },
        UpdateContact: {
          http: {
            requestUri: "/contacts/{InstanceId}/{ContactId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ContactId: {
                location: "uri",
                locationName: "ContactId"
              },
              Name: {},
              Description: {},
              References: {
                shape: "S73"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateContactAttributes: {
          http: {
            requestUri: "/contact/attributes"
          },
          input: {
            type: "structure",
            required: [
              "InitialContactId",
              "InstanceId",
              "Attributes"
            ],
            members: {
              InitialContactId: {},
              InstanceId: {},
              Attributes: {
                shape: "S2p"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateContactEvaluation: {
          http: {
            requestUri: "/contact-evaluations/{InstanceId}/{EvaluationId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "EvaluationId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              EvaluationId: {
                location: "uri",
                locationName: "EvaluationId"
              },
              Answers: {
                shape: "Su9"
              },
              Notes: {
                shape: "Sch"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EvaluationId",
              "EvaluationArn"
            ],
            members: {
              EvaluationId: {},
              EvaluationArn: {}
            }
          }
        },
        UpdateContactFlowContent: {
          http: {
            requestUri: "/contact-flows/{InstanceId}/{ContactFlowId}/content"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactFlowId",
              "Content"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ContactFlowId: {
                location: "uri",
                locationName: "ContactFlowId"
              },
              Content: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateContactFlowMetadata: {
          http: {
            requestUri: "/contact-flows/{InstanceId}/{ContactFlowId}/metadata"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactFlowId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ContactFlowId: {
                location: "uri",
                locationName: "ContactFlowId"
              },
              Name: {},
              Description: {},
              ContactFlowState: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateContactFlowModuleContent: {
          http: {
            requestUri: "/contact-flow-modules/{InstanceId}/{ContactFlowModuleId}/content"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactFlowModuleId",
              "Content"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ContactFlowModuleId: {
                location: "uri",
                locationName: "ContactFlowModuleId"
              },
              Content: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateContactFlowModuleMetadata: {
          http: {
            requestUri: "/contact-flow-modules/{InstanceId}/{ContactFlowModuleId}/metadata"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactFlowModuleId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ContactFlowModuleId: {
                location: "uri",
                locationName: "ContactFlowModuleId"
              },
              Name: {},
              Description: {},
              State: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateContactFlowName: {
          http: {
            requestUri: "/contact-flows/{InstanceId}/{ContactFlowId}/name"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactFlowId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ContactFlowId: {
                location: "uri",
                locationName: "ContactFlowId"
              },
              Name: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateContactRoutingData: {
          http: {
            requestUri: "/contacts/{InstanceId}/{ContactId}/routing-data"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ContactId: {
                location: "uri",
                locationName: "ContactId"
              },
              QueueTimeAdjustmentSeconds: {
                type: "integer"
              },
              QueuePriority: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateContactSchedule: {
          http: {
            requestUri: "/contact/schedule"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactId",
              "ScheduledTime"
            ],
            members: {
              InstanceId: {},
              ContactId: {},
              ScheduledTime: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateEvaluationForm: {
          http: {
            method: "PUT",
            requestUri: "/evaluation-forms/{InstanceId}/{EvaluationFormId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "EvaluationFormId",
              "EvaluationFormVersion",
              "Title",
              "Items"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              EvaluationFormId: {
                location: "uri",
                locationName: "EvaluationFormId"
              },
              EvaluationFormVersion: {
                type: "integer"
              },
              CreateNewVersion: {
                type: "boolean"
              },
              Title: {},
              Description: {},
              Items: {
                shape: "S3u"
              },
              ScoringStrategy: {
                shape: "S4p"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EvaluationFormId",
              "EvaluationFormArn",
              "EvaluationFormVersion"
            ],
            members: {
              EvaluationFormId: {},
              EvaluationFormArn: {},
              EvaluationFormVersion: {
                type: "integer"
              }
            }
          },
          idempotent: true
        },
        UpdateHoursOfOperation: {
          http: {
            requestUri: "/hours-of-operations/{InstanceId}/{HoursOfOperationId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "HoursOfOperationId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              HoursOfOperationId: {
                location: "uri",
                locationName: "HoursOfOperationId"
              },
              Name: {},
              Description: {},
              TimeZone: {},
              Config: {
                shape: "S4x"
              }
            }
          }
        },
        UpdateInstanceAttribute: {
          http: {
            requestUri: "/instance/{InstanceId}/attribute/{AttributeType}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "AttributeType",
              "Value"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              AttributeType: {
                location: "uri",
                locationName: "AttributeType"
              },
              Value: {}
            }
          }
        },
        UpdateInstanceStorageConfig: {
          http: {
            requestUri: "/instance/{InstanceId}/storage-config/{AssociationId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "AssociationId",
              "ResourceType",
              "StorageConfig"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              AssociationId: {
                location: "uri",
                locationName: "AssociationId"
              },
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              },
              StorageConfig: {
                shape: "St"
              }
            }
          }
        },
        UpdateParticipantRoleConfig: {
          http: {
            method: "PUT",
            requestUri: "/contact/participant-role-config/{InstanceId}/{ContactId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactId",
              "ChannelConfiguration"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ContactId: {
                location: "uri",
                locationName: "ContactId"
              },
              ChannelConfiguration: {
                type: "structure",
                members: {
                  Chat: {
                    type: "structure",
                    required: [
                      "ParticipantTimerConfigList"
                    ],
                    members: {
                      ParticipantTimerConfigList: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "ParticipantRole",
                            "TimerType",
                            "TimerValue"
                          ],
                          members: {
                            ParticipantRole: {},
                            TimerType: {},
                            TimerValue: {
                              type: "structure",
                              members: {
                                ParticipantTimerAction: {},
                                ParticipantTimerDurationInMinutes: {
                                  type: "integer"
                                }
                              },
                              union: true
                            }
                          }
                        }
                      }
                    }
                  }
                },
                union: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdatePhoneNumber: {
          http: {
            method: "PUT",
            requestUri: "/phone-number/{PhoneNumberId}"
          },
          input: {
            type: "structure",
            required: [
              "PhoneNumberId"
            ],
            members: {
              PhoneNumberId: {
                location: "uri",
                locationName: "PhoneNumberId"
              },
              TargetArn: {},
              InstanceId: {},
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberId: {},
              PhoneNumberArn: {}
            }
          }
        },
        UpdatePhoneNumberMetadata: {
          http: {
            method: "PUT",
            requestUri: "/phone-number/{PhoneNumberId}/metadata"
          },
          input: {
            type: "structure",
            required: [
              "PhoneNumberId"
            ],
            members: {
              PhoneNumberId: {
                location: "uri",
                locationName: "PhoneNumberId"
              },
              PhoneNumberDescription: {},
              ClientToken: {
                idempotencyToken: true
              }
            }
          }
        },
        UpdatePredefinedAttribute: {
          http: {
            requestUri: "/predefined-attributes/{InstanceId}/{Name}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Name"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Name: {
                location: "uri",
                locationName: "Name"
              },
              Values: {
                shape: "S5w"
              }
            }
          }
        },
        UpdatePrompt: {
          http: {
            requestUri: "/prompts/{InstanceId}/{PromptId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "PromptId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              PromptId: {
                location: "uri",
                locationName: "PromptId"
              },
              Name: {},
              Description: {},
              S3Uri: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PromptARN: {},
              PromptId: {}
            }
          }
        },
        UpdateQueueHoursOfOperation: {
          http: {
            requestUri: "/queues/{InstanceId}/{QueueId}/hours-of-operation"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "QueueId",
              "HoursOfOperationId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              QueueId: {
                location: "uri",
                locationName: "QueueId"
              },
              HoursOfOperationId: {}
            }
          }
        },
        UpdateQueueMaxContacts: {
          http: {
            requestUri: "/queues/{InstanceId}/{QueueId}/max-contacts"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "QueueId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              QueueId: {
                location: "uri",
                locationName: "QueueId"
              },
              MaxContacts: {
                type: "integer"
              }
            }
          }
        },
        UpdateQueueName: {
          http: {
            requestUri: "/queues/{InstanceId}/{QueueId}/name"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "QueueId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              QueueId: {
                location: "uri",
                locationName: "QueueId"
              },
              Name: {},
              Description: {}
            }
          }
        },
        UpdateQueueOutboundCallerConfig: {
          http: {
            requestUri: "/queues/{InstanceId}/{QueueId}/outbound-caller-config"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "QueueId",
              "OutboundCallerConfig"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              QueueId: {
                location: "uri",
                locationName: "QueueId"
              },
              OutboundCallerConfig: {
                shape: "S65"
              }
            }
          }
        },
        UpdateQueueStatus: {
          http: {
            requestUri: "/queues/{InstanceId}/{QueueId}/status"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "QueueId",
              "Status"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              QueueId: {
                location: "uri",
                locationName: "QueueId"
              },
              Status: {}
            }
          }
        },
        UpdateQuickConnectConfig: {
          http: {
            requestUri: "/quick-connects/{InstanceId}/{QuickConnectId}/config"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "QuickConnectId",
              "QuickConnectConfig"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              QuickConnectId: {
                location: "uri",
                locationName: "QuickConnectId"
              },
              QuickConnectConfig: {
                shape: "S6c"
              }
            }
          }
        },
        UpdateQuickConnectName: {
          http: {
            requestUri: "/quick-connects/{InstanceId}/{QuickConnectId}/name"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "QuickConnectId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              QuickConnectId: {
                location: "uri",
                locationName: "QuickConnectId"
              },
              Name: {},
              Description: {}
            }
          }
        },
        UpdateRoutingProfileAgentAvailabilityTimer: {
          http: {
            requestUri: "/routing-profiles/{InstanceId}/{RoutingProfileId}/agent-availability-timer"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "RoutingProfileId",
              "AgentAvailabilityTimer"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              RoutingProfileId: {
                location: "uri",
                locationName: "RoutingProfileId"
              },
              AgentAvailabilityTimer: {}
            }
          }
        },
        UpdateRoutingProfileConcurrency: {
          http: {
            requestUri: "/routing-profiles/{InstanceId}/{RoutingProfileId}/concurrency"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "RoutingProfileId",
              "MediaConcurrencies"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              RoutingProfileId: {
                location: "uri",
                locationName: "RoutingProfileId"
              },
              MediaConcurrencies: {
                shape: "S6l"
              }
            }
          }
        },
        UpdateRoutingProfileDefaultOutboundQueue: {
          http: {
            requestUri: "/routing-profiles/{InstanceId}/{RoutingProfileId}/default-outbound-queue"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "RoutingProfileId",
              "DefaultOutboundQueueId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              RoutingProfileId: {
                location: "uri",
                locationName: "RoutingProfileId"
              },
              DefaultOutboundQueueId: {}
            }
          }
        },
        UpdateRoutingProfileName: {
          http: {
            requestUri: "/routing-profiles/{InstanceId}/{RoutingProfileId}/name"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "RoutingProfileId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              RoutingProfileId: {
                location: "uri",
                locationName: "RoutingProfileId"
              },
              Name: {},
              Description: {}
            }
          }
        },
        UpdateRoutingProfileQueues: {
          http: {
            requestUri: "/routing-profiles/{InstanceId}/{RoutingProfileId}/queues"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "RoutingProfileId",
              "QueueConfigs"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              RoutingProfileId: {
                location: "uri",
                locationName: "RoutingProfileId"
              },
              QueueConfigs: {
                shape: "S1j"
              }
            }
          }
        },
        UpdateRule: {
          http: {
            method: "PUT",
            requestUri: "/rules/{InstanceId}/{RuleId}"
          },
          input: {
            type: "structure",
            required: [
              "RuleId",
              "InstanceId",
              "Name",
              "Function",
              "Actions",
              "PublishStatus"
            ],
            members: {
              RuleId: {
                location: "uri",
                locationName: "RuleId"
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Name: {},
              Function: {},
              Actions: {
                shape: "S6x"
              },
              PublishStatus: {}
            }
          }
        },
        UpdateSecurityProfile: {
          http: {
            requestUri: "/security-profiles/{InstanceId}/{SecurityProfileId}"
          },
          input: {
            type: "structure",
            required: [
              "SecurityProfileId",
              "InstanceId"
            ],
            members: {
              Description: {},
              Permissions: {
                shape: "S80"
              },
              SecurityProfileId: {
                location: "uri",
                locationName: "SecurityProfileId"
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              AllowedAccessControlTags: {
                shape: "S82"
              },
              TagRestrictedResources: {
                shape: "S85"
              },
              Applications: {
                shape: "S87"
              }
            }
          }
        },
        UpdateTaskTemplate: {
          http: {
            requestUri: "/instance/{InstanceId}/task/template/{TaskTemplateId}"
          },
          input: {
            type: "structure",
            required: [
              "TaskTemplateId",
              "InstanceId"
            ],
            members: {
              TaskTemplateId: {
                location: "uri",
                locationName: "TaskTemplateId"
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Name: {},
              Description: {},
              ContactFlowId: {},
              Constraints: {
                shape: "S8h"
              },
              Defaults: {
                shape: "S8q"
              },
              Status: {},
              Fields: {
                shape: "S8v"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceId: {},
              Id: {},
              Arn: {},
              Name: {},
              Description: {},
              ContactFlowId: {},
              Constraints: {
                shape: "S8h"
              },
              Defaults: {
                shape: "S8q"
              },
              Fields: {
                shape: "S8v"
              },
              Status: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              CreatedTime: {
                type: "timestamp"
              }
            }
          }
        },
        UpdateTrafficDistribution: {
          http: {
            method: "PUT",
            requestUri: "/traffic-distribution/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              TelephonyConfig: {
                shape: "Sih"
              },
              SignInConfig: {
                shape: "Sim"
              },
              AgentConfig: {
                shape: "Sip"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateUserHierarchy: {
          http: {
            requestUri: "/users/{InstanceId}/{UserId}/hierarchy"
          },
          input: {
            type: "structure",
            required: [
              "UserId",
              "InstanceId"
            ],
            members: {
              HierarchyGroupId: {},
              UserId: {
                location: "uri",
                locationName: "UserId"
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              }
            }
          }
        },
        UpdateUserHierarchyGroupName: {
          http: {
            requestUri: "/user-hierarchy-groups/{InstanceId}/{HierarchyGroupId}/name"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "HierarchyGroupId",
              "InstanceId"
            ],
            members: {
              Name: {},
              HierarchyGroupId: {
                location: "uri",
                locationName: "HierarchyGroupId"
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              }
            }
          }
        },
        UpdateUserHierarchyStructure: {
          http: {
            requestUri: "/user-hierarchy-structure/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "HierarchyStructure",
              "InstanceId"
            ],
            members: {
              HierarchyStructure: {
                type: "structure",
                members: {
                  LevelOne: {
                    shape: "Swl"
                  },
                  LevelTwo: {
                    shape: "Swl"
                  },
                  LevelThree: {
                    shape: "Swl"
                  },
                  LevelFour: {
                    shape: "Swl"
                  },
                  LevelFive: {
                    shape: "Swl"
                  }
                }
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              }
            }
          }
        },
        UpdateUserIdentityInfo: {
          http: {
            requestUri: "/users/{InstanceId}/{UserId}/identity-info"
          },
          input: {
            type: "structure",
            required: [
              "IdentityInfo",
              "UserId",
              "InstanceId"
            ],
            members: {
              IdentityInfo: {
                shape: "S9i"
              },
              UserId: {
                location: "uri",
                locationName: "UserId"
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              }
            }
          }
        },
        UpdateUserPhoneConfig: {
          http: {
            requestUri: "/users/{InstanceId}/{UserId}/phone-config"
          },
          input: {
            type: "structure",
            required: [
              "PhoneConfig",
              "UserId",
              "InstanceId"
            ],
            members: {
              PhoneConfig: {
                shape: "S9m"
              },
              UserId: {
                location: "uri",
                locationName: "UserId"
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              }
            }
          }
        },
        UpdateUserProficiencies: {
          http: {
            requestUri: "/users/{InstanceId}/{UserId}/proficiencies"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "UserId",
              "UserProficiencies"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              UserId: {
                location: "uri",
                locationName: "UserId"
              },
              UserProficiencies: {
                shape: "S1x"
              }
            }
          }
        },
        UpdateUserRoutingProfile: {
          http: {
            requestUri: "/users/{InstanceId}/{UserId}/routing-profile"
          },
          input: {
            type: "structure",
            required: [
              "RoutingProfileId",
              "UserId",
              "InstanceId"
            ],
            members: {
              RoutingProfileId: {},
              UserId: {
                location: "uri",
                locationName: "UserId"
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              }
            }
          }
        },
        UpdateUserSecurityProfiles: {
          http: {
            requestUri: "/users/{InstanceId}/{UserId}/security-profiles"
          },
          input: {
            type: "structure",
            required: [
              "SecurityProfileIds",
              "UserId",
              "InstanceId"
            ],
            members: {
              SecurityProfileIds: {
                shape: "S9r"
              },
              UserId: {
                location: "uri",
                locationName: "UserId"
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              }
            }
          }
        },
        UpdateViewContent: {
          http: {
            requestUri: "/views/{InstanceId}/{ViewId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ViewId",
              "Status",
              "Content"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ViewId: {
                location: "uri",
                locationName: "ViewId"
              },
              Status: {},
              Content: {
                shape: "Sa1"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              View: {
                shape: "Sa8"
              }
            }
          }
        },
        UpdateViewMetadata: {
          http: {
            requestUri: "/views/{InstanceId}/{ViewId}/metadata"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ViewId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ViewId: {
                location: "uri",
                locationName: "ViewId"
              },
              Name: {
                shape: "Sa6"
              },
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        Sf: {
          type: "structure",
          required: [
            "Name",
            "LexRegion"
          ],
          members: {
            Name: {},
            LexRegion: {}
          }
        },
        Si: {
          type: "structure",
          members: {
            AliasArn: {}
          }
        },
        St: {
          type: "structure",
          required: [
            "StorageType"
          ],
          members: {
            AssociationId: {},
            StorageType: {},
            S3Config: {
              type: "structure",
              required: [
                "BucketName",
                "BucketPrefix"
              ],
              members: {
                BucketName: {},
                BucketPrefix: {},
                EncryptionConfig: {
                  shape: "Sz"
                }
              }
            },
            KinesisVideoStreamConfig: {
              type: "structure",
              required: [
                "Prefix",
                "RetentionPeriodHours",
                "EncryptionConfig"
              ],
              members: {
                Prefix: {},
                RetentionPeriodHours: {
                  type: "integer"
                },
                EncryptionConfig: {
                  shape: "Sz"
                }
              }
            },
            KinesisStreamConfig: {
              type: "structure",
              required: [
                "StreamArn"
              ],
              members: {
                StreamArn: {}
              }
            },
            KinesisFirehoseConfig: {
              type: "structure",
              required: [
                "FirehoseArn"
              ],
              members: {
                FirehoseArn: {}
              }
            }
          }
        },
        Sz: {
          type: "structure",
          required: [
            "EncryptionType",
            "KeyId"
          ],
          members: {
            EncryptionType: {},
            KeyId: {}
          }
        },
        S1f: {
          type: "list",
          member: {}
        },
        S1j: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "QueueReference",
              "Priority",
              "Delay"
            ],
            members: {
              QueueReference: {
                shape: "S1l"
              },
              Priority: {
                type: "integer"
              },
              Delay: {
                type: "integer"
              }
            }
          }
        },
        S1l: {
          type: "structure",
          required: [
            "QueueId",
            "Channel"
          ],
          members: {
            QueueId: {},
            Channel: {}
          }
        },
        S1x: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AttributeName",
              "AttributeValue",
              "Level"
            ],
            members: {
              AttributeName: {},
              AttributeValue: {},
              Level: {
                type: "float"
              }
            }
          }
        },
        S23: {
          type: "list",
          member: {}
        },
        S25: {
          type: "list",
          member: {
            type: "structure",
            members: {
              DataSetId: {},
              TargetAccountId: {},
              ResourceShareId: {},
              ResourceShareArn: {}
            }
          }
        },
        S27: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ErrorCode: {},
              ErrorMessage: {}
            }
          }
        },
        S2f: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ResourceId: {},
              FlowId: {},
              ResourceType: {}
            }
          }
        },
        S2l: {
          type: "structure",
          members: {
            Type: {},
            Address: {}
          }
        },
        S2p: {
          type: "map",
          key: {},
          value: {}
        },
        S34: {
          type: "map",
          key: {},
          value: {}
        },
        S3u: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Section: {
                type: "structure",
                required: [
                  "Title",
                  "RefId",
                  "Items"
                ],
                members: {
                  Title: {},
                  RefId: {},
                  Instructions: {},
                  Items: {
                    shape: "S3u"
                  },
                  Weight: {
                    type: "double"
                  }
                }
              },
              Question: {
                type: "structure",
                required: [
                  "Title",
                  "RefId",
                  "QuestionType"
                ],
                members: {
                  Title: {},
                  Instructions: {},
                  RefId: {},
                  NotApplicableEnabled: {
                    type: "boolean"
                  },
                  QuestionType: {},
                  QuestionTypeProperties: {
                    type: "structure",
                    members: {
                      Numeric: {
                        type: "structure",
                        required: [
                          "MinValue",
                          "MaxValue"
                        ],
                        members: {
                          MinValue: {
                            type: "integer"
                          },
                          MaxValue: {
                            type: "integer"
                          },
                          Options: {
                            type: "list",
                            member: {
                              type: "structure",
                              required: [
                                "MinValue",
                                "MaxValue"
                              ],
                              members: {
                                MinValue: {
                                  type: "integer"
                                },
                                MaxValue: {
                                  type: "integer"
                                },
                                Score: {
                                  type: "integer"
                                },
                                AutomaticFail: {
                                  type: "boolean"
                                }
                              }
                            }
                          },
                          Automation: {
                            type: "structure",
                            members: {
                              PropertyValue: {
                                type: "structure",
                                required: [
                                  "Label"
                                ],
                                members: {
                                  Label: {}
                                }
                              }
                            },
                            union: true
                          }
                        }
                      },
                      SingleSelect: {
                        type: "structure",
                        required: [
                          "Options"
                        ],
                        members: {
                          Options: {
                            type: "list",
                            member: {
                              type: "structure",
                              required: [
                                "RefId",
                                "Text"
                              ],
                              members: {
                                RefId: {},
                                Text: {},
                                Score: {
                                  type: "integer"
                                },
                                AutomaticFail: {
                                  type: "boolean"
                                }
                              }
                            }
                          },
                          DisplayAs: {},
                          Automation: {
                            type: "structure",
                            required: [
                              "Options"
                            ],
                            members: {
                              Options: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    RuleCategory: {
                                      type: "structure",
                                      required: [
                                        "Category",
                                        "Condition",
                                        "OptionRefId"
                                      ],
                                      members: {
                                        Category: {},
                                        Condition: {},
                                        OptionRefId: {}
                                      }
                                    }
                                  },
                                  union: true
                                }
                              },
                              DefaultOptionRefId: {}
                            }
                          }
                        }
                      }
                    },
                    union: true
                  },
                  Weight: {
                    type: "double"
                  }
                }
              }
            },
            union: true
          }
        },
        S4p: {
          type: "structure",
          required: [
            "Mode",
            "Status"
          ],
          members: {
            Mode: {},
            Status: {}
          }
        },
        S4x: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Day",
              "StartTime",
              "EndTime"
            ],
            members: {
              Day: {},
              StartTime: {
                shape: "S50"
              },
              EndTime: {
                shape: "S50"
              }
            }
          }
        },
        S50: {
          type: "structure",
          required: [
            "Hours",
            "Minutes"
          ],
          members: {
            Hours: {
              type: "integer"
            },
            Minutes: {
              type: "integer"
            }
          }
        },
        S57: {
          type: "string",
          sensitive: true
        },
        S5w: {
          type: "structure",
          members: {
            StringList: {
              type: "list",
              member: {}
            }
          },
          union: true
        },
        S65: {
          type: "structure",
          members: {
            OutboundCallerIdName: {},
            OutboundCallerIdNumberId: {},
            OutboundFlowId: {}
          }
        },
        S6c: {
          type: "structure",
          required: [
            "QuickConnectType"
          ],
          members: {
            QuickConnectType: {},
            UserConfig: {
              type: "structure",
              required: [
                "UserId",
                "ContactFlowId"
              ],
              members: {
                UserId: {},
                ContactFlowId: {}
              }
            },
            QueueConfig: {
              type: "structure",
              required: [
                "QueueId",
                "ContactFlowId"
              ],
              members: {
                QueueId: {},
                ContactFlowId: {}
              }
            },
            PhoneConfig: {
              type: "structure",
              required: [
                "PhoneNumber"
              ],
              members: {
                PhoneNumber: {}
              }
            }
          }
        },
        S6l: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Channel",
              "Concurrency"
            ],
            members: {
              Channel: {},
              Concurrency: {
                type: "integer"
              },
              CrossChannelBehavior: {
                type: "structure",
                required: [
                  "BehaviorType"
                ],
                members: {
                  BehaviorType: {}
                }
              }
            }
          }
        },
        S6u: {
          type: "structure",
          required: [
            "EventSourceName"
          ],
          members: {
            EventSourceName: {},
            IntegrationAssociationId: {}
          }
        },
        S6x: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ActionType"
            ],
            members: {
              ActionType: {},
              TaskAction: {
                type: "structure",
                required: [
                  "Name",
                  "ContactFlowId"
                ],
                members: {
                  Name: {},
                  Description: {},
                  ContactFlowId: {},
                  References: {
                    shape: "S73"
                  }
                }
              },
              EventBridgeAction: {
                type: "structure",
                required: [
                  "Name"
                ],
                members: {
                  Name: {}
                }
              },
              AssignContactCategoryAction: {
                type: "structure",
                members: {}
              },
              SendNotificationAction: {
                type: "structure",
                required: [
                  "DeliveryMethod",
                  "Content",
                  "ContentType",
                  "Recipient"
                ],
                members: {
                  DeliveryMethod: {},
                  Subject: {},
                  Content: {},
                  ContentType: {},
                  Recipient: {
                    type: "structure",
                    members: {
                      UserTags: {
                        type: "map",
                        key: {},
                        value: {}
                      },
                      UserIds: {
                        type: "list",
                        member: {}
                      }
                    }
                  }
                }
              },
              CreateCaseAction: {
                type: "structure",
                required: [
                  "Fields",
                  "TemplateId"
                ],
                members: {
                  Fields: {
                    shape: "S7k"
                  },
                  TemplateId: {}
                }
              },
              UpdateCaseAction: {
                type: "structure",
                required: [
                  "Fields"
                ],
                members: {
                  Fields: {
                    shape: "S7k"
                  }
                }
              },
              EndAssociatedTasksAction: {
                type: "structure",
                members: {}
              }
            }
          }
        },
        S73: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "Value",
              "Type"
            ],
            members: {
              Value: {},
              Type: {}
            }
          }
        },
        S7k: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Id",
              "Value"
            ],
            members: {
              Id: {},
              Value: {
                type: "structure",
                members: {
                  BooleanValue: {
                    type: "boolean"
                  },
                  DoubleValue: {
                    type: "double"
                  },
                  EmptyValue: {
                    type: "structure",
                    members: {}
                  },
                  StringValue: {}
                }
              }
            }
          }
        },
        S80: {
          type: "list",
          member: {}
        },
        S82: {
          type: "map",
          key: {},
          value: {}
        },
        S85: {
          type: "list",
          member: {}
        },
        S87: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Namespace: {},
              ApplicationPermissions: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S8h: {
          type: "structure",
          members: {
            RequiredFields: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Id: {
                    shape: "S8k"
                  }
                }
              }
            },
            ReadOnlyFields: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Id: {
                    shape: "S8k"
                  }
                }
              }
            },
            InvisibleFields: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Id: {
                    shape: "S8k"
                  }
                }
              }
            }
          }
        },
        S8k: {
          type: "structure",
          members: {
            Name: {}
          }
        },
        S8q: {
          type: "structure",
          members: {
            DefaultFieldValues: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Id: {
                    shape: "S8k"
                  },
                  DefaultValue: {}
                }
              }
            }
          }
        },
        S8v: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                shape: "S8k"
              },
              Description: {},
              Type: {},
              SingleSelectOptions: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S9i: {
          type: "structure",
          members: {
            FirstName: {},
            LastName: {},
            Email: {},
            SecondaryEmail: {},
            Mobile: {}
          }
        },
        S9m: {
          type: "structure",
          required: [
            "PhoneType"
          ],
          members: {
            PhoneType: {},
            AutoAccept: {
              type: "boolean"
            },
            AfterContactWorkTimeLimit: {
              type: "integer"
            },
            DeskPhoneNumber: {}
          }
        },
        S9r: {
          type: "list",
          member: {}
        },
        Sa1: {
          type: "structure",
          members: {
            Template: {},
            Actions: {
              shape: "Sa3"
            }
          }
        },
        Sa3: {
          type: "list",
          member: {
            type: "string",
            sensitive: true
          }
        },
        Sa6: {
          type: "string",
          sensitive: true
        },
        Sa8: {
          type: "structure",
          members: {
            Id: {},
            Arn: {},
            Name: {
              shape: "Sa6"
            },
            Status: {},
            Type: {},
            Description: {},
            Version: {
              type: "integer"
            },
            VersionDescription: {},
            Content: {
              type: "structure",
              members: {
                InputSchema: {
                  type: "string",
                  sensitive: true
                },
                Template: {},
                Actions: {
                  shape: "Sa3"
                }
              }
            },
            Tags: {
              shape: "S34"
            },
            CreatedTime: {
              type: "timestamp"
            },
            LastModifiedTime: {
              type: "timestamp"
            },
            ViewContentSha256: {}
          }
        },
        Sc3: {
          type: "map",
          key: {},
          value: {}
        },
        Sca: {
          type: "structure",
          members: {
            Percentage: {
              type: "double"
            },
            NotApplicable: {
              type: "boolean"
            },
            AutomaticFail: {
              type: "boolean"
            }
          }
        },
        Sce: {
          type: "structure",
          members: {
            StringValue: {},
            NumericValue: {
              type: "double"
            },
            NotApplicable: {
              type: "boolean"
            }
          },
          union: true
        },
        Sch: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              Value: {}
            }
          }
        },
        Sd3: {
          type: "structure",
          members: {
            HoursOfOperationId: {},
            HoursOfOperationArn: {},
            Name: {},
            Description: {},
            TimeZone: {},
            Config: {
              shape: "S4x"
            },
            Tags: {
              shape: "S34"
            },
            LastModifiedTime: {
              type: "timestamp"
            },
            LastModifiedRegion: {}
          }
        },
        Sdd: {
          type: "structure",
          members: {
            AttributeType: {},
            Value: {}
          }
        },
        Sdr: {
          type: "structure",
          members: {
            Name: {},
            Values: {
              shape: "S5w"
            },
            LastModifiedTime: {
              type: "timestamp"
            },
            LastModifiedRegion: {}
          }
        },
        Sdu: {
          type: "structure",
          members: {
            PromptARN: {},
            PromptId: {},
            Name: {},
            Description: {},
            Tags: {
              shape: "S34"
            },
            LastModifiedTime: {
              type: "timestamp"
            },
            LastModifiedRegion: {}
          }
        },
        Sdx: {
          type: "structure",
          members: {
            Name: {},
            QueueArn: {},
            QueueId: {},
            Description: {},
            OutboundCallerConfig: {
              shape: "S65"
            },
            HoursOfOperationId: {},
            MaxContacts: {
              type: "integer"
            },
            Status: {},
            Tags: {
              shape: "S34"
            },
            LastModifiedTime: {
              type: "timestamp"
            },
            LastModifiedRegion: {}
          }
        },
        Se1: {
          type: "structure",
          members: {
            QuickConnectARN: {},
            QuickConnectId: {},
            Name: {},
            Description: {},
            QuickConnectConfig: {
              shape: "S6c"
            },
            Tags: {
              shape: "S34"
            },
            LastModifiedTime: {
              type: "timestamp"
            },
            LastModifiedRegion: {}
          }
        },
        Se4: {
          type: "structure",
          members: {
            InstanceId: {},
            Name: {},
            RoutingProfileArn: {},
            RoutingProfileId: {},
            Description: {},
            MediaConcurrencies: {
              shape: "S6l"
            },
            DefaultOutboundQueueId: {},
            Tags: {
              shape: "S34"
            },
            NumberOfAssociatedQueues: {
              type: "long"
            },
            NumberOfAssociatedUsers: {
              type: "long"
            },
            AgentAvailabilityTimer: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            LastModifiedRegion: {},
            IsDefault: {
              type: "boolean"
            }
          }
        },
        Seq: {
          type: "structure",
          members: {
            Id: {},
            Arn: {},
            Name: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            LastModifiedRegion: {}
          }
        },
        Seu: {
          type: "structure",
          members: {
            Id: {},
            Arn: {},
            Name: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            LastModifiedRegion: {}
          }
        },
        Sfq: {
          type: "structure",
          members: {
            Queues: {
              shape: "Sfr"
            },
            Channels: {
              type: "list",
              member: {}
            },
            RoutingProfiles: {
              shape: "Sft"
            },
            RoutingStepExpressions: {
              type: "list",
              member: {}
            }
          }
        },
        Sfr: {
          type: "list",
          member: {}
        },
        Sft: {
          type: "list",
          member: {}
        },
        Sfw: {
          type: "list",
          member: {}
        },
        Sfz: {
          type: "structure",
          members: {
            Name: {},
            Unit: {}
          }
        },
        Sga: {
          type: "structure",
          members: {
            Queue: {
              shape: "Sgb"
            },
            Channel: {},
            RoutingProfile: {
              shape: "Sgc"
            },
            RoutingStepExpression: {}
          }
        },
        Sgb: {
          type: "structure",
          members: {
            Id: {},
            Arn: {}
          }
        },
        Sgc: {
          type: "structure",
          members: {
            Id: {},
            Arn: {}
          }
        },
        Sgt: {
          type: "structure",
          members: {
            Id: {},
            Arn: {}
          }
        },
        Sgv: {
          type: "map",
          key: {},
          value: {
            type: "integer"
          }
        },
        Sh2: {
          type: "string",
          sensitive: true
        },
        Sh7: {
          type: "structure",
          members: {
            Name: {},
            Threshold: {
              type: "structure",
              members: {
                Comparison: {},
                ThresholdValue: {
                  type: "double"
                }
              }
            },
            Statistic: {},
            Unit: {}
          }
        },
        Shs: {
          type: "structure",
          members: {
            Name: {},
            Threshold: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Comparison: {},
                  ThresholdValue: {
                    type: "double"
                  }
                }
              }
            },
            MetricFilters: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  MetricFilterKey: {},
                  MetricFilterValues: {
                    type: "list",
                    member: {}
                  },
                  Negate: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        Sih: {
          type: "structure",
          required: [
            "Distributions"
          ],
          members: {
            Distributions: {
              shape: "Sii"
            }
          }
        },
        Sii: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Region",
              "Percentage"
            ],
            members: {
              Region: {},
              Percentage: {
                type: "integer"
              }
            }
          }
        },
        Sim: {
          type: "structure",
          required: [
            "Distributions"
          ],
          members: {
            Distributions: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Region",
                  "Enabled"
                ],
                members: {
                  Region: {},
                  Enabled: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        Sip: {
          type: "structure",
          required: [
            "Distributions"
          ],
          members: {
            Distributions: {
              shape: "Sii"
            }
          }
        },
        Sl5: {
          type: "list",
          member: {}
        },
        Sl6: {
          type: "list",
          member: {}
        },
        Slr: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Id: {},
              Arn: {},
              Name: {},
              QuickConnectType: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              LastModifiedRegion: {}
            }
          }
        },
        Smg: {
          type: "structure",
          members: {
            AbsoluteTime: {
              type: "timestamp",
              timestampFormat: "iso8601"
            }
          },
          union: true
        },
        Smk: {
          type: "structure",
          required: [
            "BeginOffsetChar",
            "EndOffsetChar"
          ],
          members: {
            BeginOffsetChar: {
              type: "integer"
            },
            EndOffsetChar: {
              type: "integer"
            }
          }
        },
        Spr: {
          type: "list",
          member: {}
        },
        Sqi: {
          type: "structure",
          members: {
            OrConditions: {
              type: "list",
              member: {
                shape: "Sqk"
              }
            },
            AndConditions: {
              shape: "Sqk"
            },
            TagCondition: {
              shape: "Sql"
            }
          }
        },
        Sqk: {
          type: "list",
          member: {
            shape: "Sql"
          }
        },
        Sql: {
          type: "structure",
          members: {
            TagKey: {},
            TagValue: {}
          }
        },
        Sqm: {
          type: "structure",
          members: {
            OrConditions: {
              shape: "Sqn"
            },
            AndConditions: {
              shape: "Sqn"
            },
            StringCondition: {
              shape: "Sqo"
            }
          }
        },
        Sqn: {
          type: "list",
          member: {
            shape: "Sqm"
          }
        },
        Sqo: {
          type: "structure",
          members: {
            FieldName: {},
            Value: {},
            ComparisonType: {}
          }
        },
        Sqt: {
          type: "structure",
          members: {
            OrConditions: {
              shape: "Squ"
            },
            AndConditions: {
              shape: "Squ"
            },
            StringCondition: {
              shape: "Sqo"
            }
          }
        },
        Squ: {
          type: "list",
          member: {
            shape: "Sqt"
          }
        },
        Sqz: {
          type: "structure",
          members: {
            OrConditions: {
              shape: "Sr0"
            },
            AndConditions: {
              shape: "Sr0"
            },
            StringCondition: {
              shape: "Sqo"
            }
          }
        },
        Sr0: {
          type: "list",
          member: {
            shape: "Sqz"
          }
        },
        Sr5: {
          type: "structure",
          members: {
            OrConditions: {
              shape: "Sr6"
            },
            AndConditions: {
              shape: "Sr6"
            },
            StringCondition: {
              shape: "Sqo"
            },
            QueueTypeCondition: {}
          }
        },
        Sr6: {
          type: "list",
          member: {
            shape: "Sr5"
          }
        },
        Src: {
          type: "structure",
          members: {
            OrConditions: {
              shape: "Srd"
            },
            AndConditions: {
              shape: "Srd"
            },
            StringCondition: {
              shape: "Sqo"
            }
          }
        },
        Srd: {
          type: "list",
          member: {
            shape: "Src"
          }
        },
        Srr: {
          type: "structure",
          members: {
            OrConditions: {
              shape: "Srs"
            },
            AndConditions: {
              shape: "Srs"
            },
            StringCondition: {
              shape: "Sqo"
            }
          }
        },
        Srs: {
          type: "list",
          member: {
            shape: "Srr"
          }
        },
        Srw: {
          type: "structure",
          members: {
            OrConditions: {
              shape: "Srx"
            },
            AndConditions: {
              shape: "Srx"
            },
            StringCondition: {
              shape: "Sqo"
            }
          }
        },
        Srx: {
          type: "list",
          member: {
            shape: "Srw"
          }
        },
        Ss4: {
          type: "structure",
          members: {
            OrConditions: {
              shape: "Ss5"
            },
            AndConditions: {
              shape: "Ss5"
            },
            StringCondition: {
              shape: "Sqo"
            },
            HierarchyGroupCondition: {
              type: "structure",
              members: {
                Value: {},
                HierarchyGroupMatchType: {}
              }
            }
          }
        },
        Ss5: {
          type: "list",
          member: {
            shape: "Ss4"
          }
        },
        Ssp: {
          type: "list",
          member: {}
        },
        Ssr: {
          type: "structure",
          required: [
            "DisplayName"
          ],
          members: {
            DisplayName: {}
          }
        },
        Sss: {
          type: "structure",
          required: [
            "StreamingEndpointArn"
          ],
          members: {
            StreamingEndpointArn: {}
          }
        },
        Stm: {
          type: "structure",
          members: {
            Video: {}
          }
        },
        Su9: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              Value: {
                shape: "Sce"
              }
            }
          }
        },
        Swl: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/connect-2017-08-08.paginators.json
var require_connect_2017_08_08_paginators = __commonJS({
  "node_modules/aws-sdk/apis/connect-2017-08-08.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetCurrentMetricData: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetCurrentUserData: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetMetricData: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetMetricDataV2: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListAgentStatuses: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "AgentStatusSummaryList"
        },
        ListApprovedOrigins: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Origins"
        },
        ListBots: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "LexBots"
        },
        ListContactEvaluations: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "EvaluationSummaryList"
        },
        ListContactFlowModules: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ContactFlowModulesSummaryList"
        },
        ListContactFlows: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ContactFlowSummaryList"
        },
        ListContactReferences: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "ReferenceSummaryList"
        },
        ListDefaultVocabularies: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "DefaultVocabularyList"
        },
        ListEvaluationFormVersions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "EvaluationFormVersionSummaryList"
        },
        ListEvaluationForms: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "EvaluationFormSummaryList"
        },
        ListFlowAssociations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "FlowAssociationSummaryList"
        },
        ListHoursOfOperations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "HoursOfOperationSummaryList"
        },
        ListInstanceAttributes: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Attributes"
        },
        ListInstanceStorageConfigs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "StorageConfigs"
        },
        ListInstances: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "InstanceSummaryList"
        },
        ListIntegrationAssociations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "IntegrationAssociationSummaryList"
        },
        ListLambdaFunctions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "LambdaFunctions"
        },
        ListLexBots: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "LexBots"
        },
        ListPhoneNumbers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PhoneNumberSummaryList"
        },
        ListPhoneNumbersV2: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ListPhoneNumbersSummaryList"
        },
        ListPredefinedAttributes: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PredefinedAttributeSummaryList"
        },
        ListPrompts: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PromptSummaryList"
        },
        ListQueueQuickConnects: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          non_aggregate_keys: [
            "LastModifiedRegion",
            "LastModifiedTime"
          ],
          output_token: "NextToken",
          result_key: "QuickConnectSummaryList"
        },
        ListQueues: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "QueueSummaryList"
        },
        ListQuickConnects: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "QuickConnectSummaryList"
        },
        ListRealtimeContactAnalysisSegmentsV2: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListRoutingProfileQueues: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          non_aggregate_keys: [
            "LastModifiedRegion",
            "LastModifiedTime"
          ],
          output_token: "NextToken",
          result_key: "RoutingProfileQueueConfigSummaryList"
        },
        ListRoutingProfiles: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "RoutingProfileSummaryList"
        },
        ListRules: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "RuleSummaryList"
        },
        ListSecurityKeys: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "SecurityKeys"
        },
        ListSecurityProfileApplications: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          non_aggregate_keys: [
            "LastModifiedRegion",
            "LastModifiedTime"
          ],
          output_token: "NextToken",
          result_key: "Applications"
        },
        ListSecurityProfilePermissions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          non_aggregate_keys: [
            "LastModifiedRegion",
            "LastModifiedTime"
          ],
          output_token: "NextToken",
          result_key: "Permissions"
        },
        ListSecurityProfiles: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "SecurityProfileSummaryList"
        },
        ListTaskTemplates: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TaskTemplates"
        },
        ListTrafficDistributionGroupUsers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TrafficDistributionGroupUserSummaryList"
        },
        ListTrafficDistributionGroups: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TrafficDistributionGroupSummaryList"
        },
        ListUseCases: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "UseCaseSummaryList"
        },
        ListUserHierarchyGroups: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "UserHierarchyGroupSummaryList"
        },
        ListUserProficiencies: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          non_aggregate_keys: [
            "LastModifiedTime",
            "LastModifiedRegion"
          ],
          output_token: "NextToken",
          result_key: "UserProficiencyList"
        },
        ListUsers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "UserSummaryList"
        },
        ListViewVersions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ViewVersionSummaryList"
        },
        ListViews: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ViewsSummaryList"
        },
        SearchAvailablePhoneNumbers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "AvailableNumbersList"
        },
        SearchContacts: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          non_aggregate_keys: [
            "TotalCount"
          ],
          output_token: "NextToken",
          result_key: "Contacts"
        },
        SearchHoursOfOperations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          non_aggregate_keys: [
            "ApproximateTotalCount"
          ],
          output_token: "NextToken",
          result_key: "HoursOfOperations"
        },
        SearchPredefinedAttributes: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          non_aggregate_keys: [
            "ApproximateTotalCount"
          ],
          output_token: "NextToken",
          result_key: "PredefinedAttributes"
        },
        SearchPrompts: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          non_aggregate_keys: [
            "ApproximateTotalCount"
          ],
          output_token: "NextToken",
          result_key: "Prompts"
        },
        SearchQueues: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          non_aggregate_keys: [
            "ApproximateTotalCount"
          ],
          output_token: "NextToken",
          result_key: "Queues"
        },
        SearchQuickConnects: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          non_aggregate_keys: [
            "ApproximateTotalCount"
          ],
          output_token: "NextToken",
          result_key: "QuickConnects"
        },
        SearchResourceTags: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Tags"
        },
        SearchRoutingProfiles: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          non_aggregate_keys: [
            "ApproximateTotalCount"
          ],
          output_token: "NextToken",
          result_key: "RoutingProfiles"
        },
        SearchSecurityProfiles: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          non_aggregate_keys: [
            "ApproximateTotalCount"
          ],
          output_token: "NextToken",
          result_key: "SecurityProfiles"
        },
        SearchUsers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          non_aggregate_keys: [
            "ApproximateTotalCount"
          ],
          output_token: "NextToken",
          result_key: "Users"
        },
        SearchVocabularies: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "VocabularySummaryList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/connect.js
var require_connect = __commonJS({
  "node_modules/aws-sdk/clients/connect.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["connect"] = {};
    AWS2.Connect = Service.defineService("connect", ["2017-08-08"]);
    Object.defineProperty(apiLoader.services["connect"], "2017-08-08", {
      get: function get() {
        var model = require_connect_2017_08_08_min();
        model.paginators = require_connect_2017_08_08_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Connect;
  }
});

// node_modules/aws-sdk/apis/acm-pca-2017-08-22.min.json
var require_acm_pca_2017_08_22_min = __commonJS({
  "node_modules/aws-sdk/apis/acm-pca-2017-08-22.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-08-22",
        endpointPrefix: "acm-pca",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "ACM-PCA",
        serviceFullName: "AWS Certificate Manager Private Certificate Authority",
        serviceId: "ACM PCA",
        signatureVersion: "v4",
        targetPrefix: "ACMPrivateCA",
        uid: "acm-pca-2017-08-22"
      },
      operations: {
        CreateCertificateAuthority: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityConfiguration",
              "CertificateAuthorityType"
            ],
            members: {
              CertificateAuthorityConfiguration: {
                shape: "S2"
              },
              RevocationConfiguration: {
                shape: "Sv"
              },
              CertificateAuthorityType: {},
              IdempotencyToken: {},
              KeyStorageSecurityStandard: {},
              Tags: {
                shape: "S15"
              },
              UsageMode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CertificateAuthorityArn: {}
            }
          },
          idempotent: true
        },
        CreateCertificateAuthorityAuditReport: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn",
              "S3BucketName",
              "AuditReportResponseFormat"
            ],
            members: {
              CertificateAuthorityArn: {},
              S3BucketName: {},
              AuditReportResponseFormat: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AuditReportId: {},
              S3Key: {}
            }
          },
          idempotent: true
        },
        CreatePermission: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn",
              "Principal",
              "Actions"
            ],
            members: {
              CertificateAuthorityArn: {},
              Principal: {},
              SourceAccount: {},
              Actions: {
                shape: "S1l"
              }
            }
          }
        },
        DeleteCertificateAuthority: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn"
            ],
            members: {
              CertificateAuthorityArn: {},
              PermanentDeletionTimeInDays: {
                type: "integer"
              }
            }
          }
        },
        DeletePermission: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn",
              "Principal"
            ],
            members: {
              CertificateAuthorityArn: {},
              Principal: {},
              SourceAccount: {}
            }
          }
        },
        DeletePolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          }
        },
        DescribeCertificateAuthority: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn"
            ],
            members: {
              CertificateAuthorityArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CertificateAuthority: {
                shape: "S1t"
              }
            }
          }
        },
        DescribeCertificateAuthorityAuditReport: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn",
              "AuditReportId"
            ],
            members: {
              CertificateAuthorityArn: {},
              AuditReportId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AuditReportStatus: {},
              S3BucketName: {},
              S3Key: {},
              CreatedAt: {
                type: "timestamp"
              }
            }
          }
        },
        GetCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn",
              "CertificateArn"
            ],
            members: {
              CertificateAuthorityArn: {},
              CertificateArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Certificate: {},
              CertificateChain: {}
            }
          }
        },
        GetCertificateAuthorityCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn"
            ],
            members: {
              CertificateAuthorityArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Certificate: {},
              CertificateChain: {}
            }
          }
        },
        GetCertificateAuthorityCsr: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn"
            ],
            members: {
              CertificateAuthorityArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Csr: {}
            }
          }
        },
        GetPolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {}
            }
          }
        },
        ImportCertificateAuthorityCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn",
              "Certificate"
            ],
            members: {
              CertificateAuthorityArn: {},
              Certificate: {
                type: "blob"
              },
              CertificateChain: {
                type: "blob"
              }
            }
          }
        },
        IssueCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn",
              "Csr",
              "SigningAlgorithm",
              "Validity"
            ],
            members: {
              ApiPassthrough: {
                type: "structure",
                members: {
                  Extensions: {
                    type: "structure",
                    members: {
                      CertificatePolicies: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "CertPolicyId"
                          ],
                          members: {
                            CertPolicyId: {},
                            PolicyQualifiers: {
                              type: "list",
                              member: {
                                type: "structure",
                                required: [
                                  "PolicyQualifierId",
                                  "Qualifier"
                                ],
                                members: {
                                  PolicyQualifierId: {},
                                  Qualifier: {
                                    type: "structure",
                                    required: [
                                      "CpsUri"
                                    ],
                                    members: {
                                      CpsUri: {}
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      },
                      ExtendedKeyUsage: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            ExtendedKeyUsageType: {},
                            ExtendedKeyUsageObjectIdentifier: {}
                          }
                        }
                      },
                      KeyUsage: {
                        shape: "Sj"
                      },
                      SubjectAlternativeNames: {
                        type: "list",
                        member: {
                          shape: "Sp"
                        }
                      },
                      CustomExtensions: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "ObjectIdentifier",
                            "Value"
                          ],
                          members: {
                            ObjectIdentifier: {},
                            Value: {},
                            Critical: {
                              type: "boolean"
                            }
                          }
                        }
                      }
                    }
                  },
                  Subject: {
                    shape: "S5"
                  }
                }
              },
              CertificateAuthorityArn: {},
              Csr: {
                type: "blob"
              },
              SigningAlgorithm: {},
              TemplateArn: {},
              Validity: {
                shape: "S2x"
              },
              ValidityNotBefore: {
                shape: "S2x"
              },
              IdempotencyToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CertificateArn: {}
            }
          },
          idempotent: true
        },
        ListCertificateAuthorities: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ResourceOwner: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CertificateAuthorities: {
                type: "list",
                member: {
                  shape: "S1t"
                }
              },
              NextToken: {}
            }
          }
        },
        ListPermissions: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn"
            ],
            members: {
              CertificateAuthorityArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Permissions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CertificateAuthorityArn: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    Principal: {},
                    SourceAccount: {},
                    Actions: {
                      shape: "S1l"
                    },
                    Policy: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTags: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn"
            ],
            members: {
              CertificateAuthorityArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S15"
              },
              NextToken: {}
            }
          }
        },
        PutPolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Policy"
            ],
            members: {
              ResourceArn: {},
              Policy: {}
            }
          }
        },
        RestoreCertificateAuthority: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn"
            ],
            members: {
              CertificateAuthorityArn: {}
            }
          }
        },
        RevokeCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn",
              "CertificateSerial",
              "RevocationReason"
            ],
            members: {
              CertificateAuthorityArn: {},
              CertificateSerial: {},
              RevocationReason: {}
            }
          }
        },
        TagCertificateAuthority: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn",
              "Tags"
            ],
            members: {
              CertificateAuthorityArn: {},
              Tags: {
                shape: "S15"
              }
            }
          }
        },
        UntagCertificateAuthority: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn",
              "Tags"
            ],
            members: {
              CertificateAuthorityArn: {},
              Tags: {
                shape: "S15"
              }
            }
          }
        },
        UpdateCertificateAuthority: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn"
            ],
            members: {
              CertificateAuthorityArn: {},
              RevocationConfiguration: {
                shape: "Sv"
              },
              Status: {}
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          required: [
            "KeyAlgorithm",
            "SigningAlgorithm",
            "Subject"
          ],
          members: {
            KeyAlgorithm: {},
            SigningAlgorithm: {},
            Subject: {
              shape: "S5"
            },
            CsrExtensions: {
              type: "structure",
              members: {
                KeyUsage: {
                  shape: "Sj"
                },
                SubjectInformationAccess: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "AccessMethod",
                      "AccessLocation"
                    ],
                    members: {
                      AccessMethod: {
                        type: "structure",
                        members: {
                          CustomObjectIdentifier: {},
                          AccessMethodType: {}
                        }
                      },
                      AccessLocation: {
                        shape: "Sp"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S5: {
          type: "structure",
          members: {
            Country: {},
            Organization: {},
            OrganizationalUnit: {},
            DistinguishedNameQualifier: {},
            State: {},
            CommonName: {},
            SerialNumber: {},
            Locality: {},
            Title: {},
            Surname: {},
            GivenName: {},
            Initials: {},
            Pseudonym: {},
            GenerationQualifier: {},
            CustomAttributes: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "ObjectIdentifier",
                  "Value"
                ],
                members: {
                  ObjectIdentifier: {},
                  Value: {}
                }
              }
            }
          }
        },
        Sj: {
          type: "structure",
          members: {
            DigitalSignature: {
              type: "boolean"
            },
            NonRepudiation: {
              type: "boolean"
            },
            KeyEncipherment: {
              type: "boolean"
            },
            DataEncipherment: {
              type: "boolean"
            },
            KeyAgreement: {
              type: "boolean"
            },
            KeyCertSign: {
              type: "boolean"
            },
            CRLSign: {
              type: "boolean"
            },
            EncipherOnly: {
              type: "boolean"
            },
            DecipherOnly: {
              type: "boolean"
            }
          }
        },
        Sp: {
          type: "structure",
          members: {
            OtherName: {
              type: "structure",
              required: [
                "TypeId",
                "Value"
              ],
              members: {
                TypeId: {},
                Value: {}
              }
            },
            Rfc822Name: {},
            DnsName: {},
            DirectoryName: {
              shape: "S5"
            },
            EdiPartyName: {
              type: "structure",
              required: [
                "PartyName"
              ],
              members: {
                PartyName: {},
                NameAssigner: {}
              }
            },
            UniformResourceIdentifier: {},
            IpAddress: {},
            RegisteredId: {}
          }
        },
        Sv: {
          type: "structure",
          members: {
            CrlConfiguration: {
              type: "structure",
              required: [
                "Enabled"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                ExpirationInDays: {
                  type: "integer"
                },
                CustomCname: {},
                S3BucketName: {},
                S3ObjectAcl: {}
              }
            },
            OcspConfiguration: {
              type: "structure",
              required: [
                "Enabled"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                OcspCustomCname: {}
              }
            }
          }
        },
        S15: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S1l: {
          type: "list",
          member: {}
        },
        S1t: {
          type: "structure",
          members: {
            Arn: {},
            OwnerAccount: {},
            CreatedAt: {
              type: "timestamp"
            },
            LastStateChangeAt: {
              type: "timestamp"
            },
            Type: {},
            Serial: {},
            Status: {},
            NotBefore: {
              type: "timestamp"
            },
            NotAfter: {
              type: "timestamp"
            },
            FailureReason: {},
            CertificateAuthorityConfiguration: {
              shape: "S2"
            },
            RevocationConfiguration: {
              shape: "Sv"
            },
            RestorableUntil: {
              type: "timestamp"
            },
            KeyStorageSecurityStandard: {},
            UsageMode: {}
          }
        },
        S2x: {
          type: "structure",
          required: [
            "Value",
            "Type"
          ],
          members: {
            Value: {
              type: "long"
            },
            Type: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/acm-pca-2017-08-22.paginators.json
var require_acm_pca_2017_08_22_paginators = __commonJS({
  "node_modules/aws-sdk/apis/acm-pca-2017-08-22.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListCertificateAuthorities: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "CertificateAuthorities"
        },
        ListPermissions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Permissions"
        },
        ListTags: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Tags"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/acm-pca-2017-08-22.waiters2.json
var require_acm_pca_2017_08_22_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/acm-pca-2017-08-22.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        CertificateAuthorityCSRCreated: {
          description: "Wait until a Certificate Authority CSR is created",
          operation: "GetCertificateAuthorityCsr",
          delay: 3,
          maxAttempts: 60,
          acceptors: [
            {
              state: "success",
              matcher: "status",
              expected: 200
            },
            {
              state: "retry",
              matcher: "error",
              expected: "RequestInProgressException"
            }
          ]
        },
        CertificateIssued: {
          description: "Wait until a certificate is issued",
          operation: "GetCertificate",
          delay: 3,
          maxAttempts: 60,
          acceptors: [
            {
              state: "success",
              matcher: "status",
              expected: 200
            },
            {
              state: "retry",
              matcher: "error",
              expected: "RequestInProgressException"
            }
          ]
        },
        AuditReportCreated: {
          description: "Wait until a Audit Report is created",
          operation: "DescribeCertificateAuthorityAuditReport",
          delay: 3,
          maxAttempts: 60,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "AuditReportStatus",
              expected: "SUCCESS"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "AuditReportStatus",
              expected: "FAILED"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/acmpca.js
var require_acmpca = __commonJS({
  "node_modules/aws-sdk/clients/acmpca.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["acmpca"] = {};
    AWS2.ACMPCA = Service.defineService("acmpca", ["2017-08-22"]);
    Object.defineProperty(apiLoader.services["acmpca"], "2017-08-22", {
      get: function get() {
        var model = require_acm_pca_2017_08_22_min();
        model.paginators = require_acm_pca_2017_08_22_paginators().pagination;
        model.waiters = require_acm_pca_2017_08_22_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ACMPCA;
  }
});

// node_modules/aws-sdk/apis/fms-2018-01-01.min.json
var require_fms_2018_01_01_min = __commonJS({
  "node_modules/aws-sdk/apis/fms-2018-01-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-01-01",
        endpointPrefix: "fms",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "FMS",
        serviceFullName: "Firewall Management Service",
        serviceId: "FMS",
        signatureVersion: "v4",
        targetPrefix: "AWSFMS_20180101",
        uid: "fms-2018-01-01"
      },
      operations: {
        AssociateAdminAccount: {
          input: {
            type: "structure",
            required: [
              "AdminAccount"
            ],
            members: {
              AdminAccount: {}
            }
          }
        },
        AssociateThirdPartyFirewall: {
          input: {
            type: "structure",
            required: [
              "ThirdPartyFirewall"
            ],
            members: {
              ThirdPartyFirewall: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ThirdPartyFirewallStatus: {}
            }
          }
        },
        BatchAssociateResource: {
          input: {
            type: "structure",
            required: [
              "ResourceSetIdentifier",
              "Items"
            ],
            members: {
              ResourceSetIdentifier: {},
              Items: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ResourceSetIdentifier",
              "FailedItems"
            ],
            members: {
              ResourceSetIdentifier: {},
              FailedItems: {
                shape: "Sb"
              }
            }
          }
        },
        BatchDisassociateResource: {
          input: {
            type: "structure",
            required: [
              "ResourceSetIdentifier",
              "Items"
            ],
            members: {
              ResourceSetIdentifier: {},
              Items: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ResourceSetIdentifier",
              "FailedItems"
            ],
            members: {
              ResourceSetIdentifier: {},
              FailedItems: {
                shape: "Sb"
              }
            }
          }
        },
        DeleteAppsList: {
          input: {
            type: "structure",
            required: [
              "ListId"
            ],
            members: {
              ListId: {}
            }
          }
        },
        DeleteNotificationChannel: {
          input: {
            type: "structure",
            members: {}
          }
        },
        DeletePolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyId"
            ],
            members: {
              PolicyId: {},
              DeleteAllPolicyResources: {
                type: "boolean"
              }
            }
          }
        },
        DeleteProtocolsList: {
          input: {
            type: "structure",
            required: [
              "ListId"
            ],
            members: {
              ListId: {}
            }
          }
        },
        DeleteResourceSet: {
          input: {
            type: "structure",
            required: [
              "Identifier"
            ],
            members: {
              Identifier: {}
            }
          }
        },
        DisassociateAdminAccount: {
          input: {
            type: "structure",
            members: {}
          }
        },
        DisassociateThirdPartyFirewall: {
          input: {
            type: "structure",
            required: [
              "ThirdPartyFirewall"
            ],
            members: {
              ThirdPartyFirewall: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ThirdPartyFirewallStatus: {}
            }
          }
        },
        GetAdminAccount: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              AdminAccount: {},
              RoleStatus: {}
            }
          }
        },
        GetAdminScope: {
          input: {
            type: "structure",
            required: [
              "AdminAccount"
            ],
            members: {
              AdminAccount: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AdminScope: {
                shape: "Sx"
              },
              Status: {}
            }
          }
        },
        GetAppsList: {
          input: {
            type: "structure",
            required: [
              "ListId"
            ],
            members: {
              ListId: {},
              DefaultList: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppsList: {
                shape: "S1c"
              },
              AppsListArn: {}
            }
          }
        },
        GetComplianceDetail: {
          input: {
            type: "structure",
            required: [
              "PolicyId",
              "MemberAccount"
            ],
            members: {
              PolicyId: {},
              MemberAccount: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyComplianceDetail: {
                type: "structure",
                members: {
                  PolicyOwner: {},
                  PolicyId: {},
                  MemberAccount: {},
                  Violators: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        ResourceId: {},
                        ViolationReason: {},
                        ResourceType: {},
                        Metadata: {
                          type: "map",
                          key: {},
                          value: {}
                        }
                      }
                    }
                  },
                  EvaluationLimitExceeded: {
                    type: "boolean"
                  },
                  ExpiredAt: {
                    type: "timestamp"
                  },
                  IssueInfoMap: {
                    shape: "S1x"
                  }
                }
              }
            }
          }
        },
        GetNotificationChannel: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              SnsTopicArn: {},
              SnsRoleName: {}
            }
          }
        },
        GetPolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyId"
            ],
            members: {
              PolicyId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {
                shape: "S24"
              },
              PolicyArn: {}
            }
          }
        },
        GetProtectionStatus: {
          input: {
            type: "structure",
            required: [
              "PolicyId"
            ],
            members: {
              PolicyId: {},
              MemberAccountId: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AdminAccountId: {},
              ServiceType: {},
              Data: {},
              NextToken: {}
            }
          }
        },
        GetProtocolsList: {
          input: {
            type: "structure",
            required: [
              "ListId"
            ],
            members: {
              ListId: {},
              DefaultList: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProtocolsList: {
                shape: "S2v"
              },
              ProtocolsListArn: {}
            }
          }
        },
        GetResourceSet: {
          input: {
            type: "structure",
            required: [
              "Identifier"
            ],
            members: {
              Identifier: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ResourceSet",
              "ResourceSetArn"
            ],
            members: {
              ResourceSet: {
                shape: "S30"
              },
              ResourceSetArn: {}
            }
          }
        },
        GetThirdPartyFirewallAssociationStatus: {
          input: {
            type: "structure",
            required: [
              "ThirdPartyFirewall"
            ],
            members: {
              ThirdPartyFirewall: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ThirdPartyFirewallStatus: {},
              MarketplaceOnboardingStatus: {}
            }
          }
        },
        GetViolationDetails: {
          input: {
            type: "structure",
            required: [
              "PolicyId",
              "MemberAccount",
              "ResourceId",
              "ResourceType"
            ],
            members: {
              PolicyId: {},
              MemberAccount: {},
              ResourceId: {},
              ResourceType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ViolationDetail: {
                type: "structure",
                required: [
                  "PolicyId",
                  "MemberAccount",
                  "ResourceId",
                  "ResourceType",
                  "ResourceViolations"
                ],
                members: {
                  PolicyId: {},
                  MemberAccount: {},
                  ResourceId: {},
                  ResourceType: {},
                  ResourceViolations: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        AwsVPCSecurityGroupViolation: {
                          type: "structure",
                          members: {
                            ViolationTarget: {},
                            ViolationTargetDescription: {},
                            PartialMatches: {
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  Reference: {},
                                  TargetViolationReasons: {
                                    type: "list",
                                    member: {}
                                  }
                                }
                              }
                            },
                            PossibleSecurityGroupRemediationActions: {
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  RemediationActionType: {},
                                  Description: {},
                                  RemediationResult: {
                                    type: "structure",
                                    members: {
                                      IPV4Range: {},
                                      IPV6Range: {},
                                      PrefixListId: {},
                                      Protocol: {},
                                      FromPort: {
                                        type: "long"
                                      },
                                      ToPort: {
                                        type: "long"
                                      }
                                    }
                                  },
                                  IsDefaultAction: {
                                    type: "boolean"
                                  }
                                }
                              }
                            }
                          }
                        },
                        AwsEc2NetworkInterfaceViolation: {
                          shape: "S3p"
                        },
                        AwsEc2InstanceViolation: {
                          type: "structure",
                          members: {
                            ViolationTarget: {},
                            AwsEc2NetworkInterfaceViolations: {
                              type: "list",
                              member: {
                                shape: "S3p"
                              }
                            }
                          }
                        },
                        NetworkFirewallMissingFirewallViolation: {
                          type: "structure",
                          members: {
                            ViolationTarget: {},
                            VPC: {},
                            AvailabilityZone: {},
                            TargetViolationReason: {}
                          }
                        },
                        NetworkFirewallMissingSubnetViolation: {
                          type: "structure",
                          members: {
                            ViolationTarget: {},
                            VPC: {},
                            AvailabilityZone: {},
                            TargetViolationReason: {}
                          }
                        },
                        NetworkFirewallMissingExpectedRTViolation: {
                          type: "structure",
                          members: {
                            ViolationTarget: {},
                            VPC: {},
                            AvailabilityZone: {},
                            CurrentRouteTable: {},
                            ExpectedRouteTable: {}
                          }
                        },
                        NetworkFirewallPolicyModifiedViolation: {
                          type: "structure",
                          members: {
                            ViolationTarget: {},
                            CurrentPolicyDescription: {
                              shape: "S3x"
                            },
                            ExpectedPolicyDescription: {
                              shape: "S3x"
                            }
                          }
                        },
                        NetworkFirewallInternetTrafficNotInspectedViolation: {
                          type: "structure",
                          members: {
                            SubnetId: {},
                            SubnetAvailabilityZone: {},
                            RouteTableId: {},
                            ViolatingRoutes: {
                              shape: "S4c"
                            },
                            IsRouteTableUsedInDifferentAZ: {
                              type: "boolean"
                            },
                            CurrentFirewallSubnetRouteTable: {},
                            ExpectedFirewallEndpoint: {},
                            FirewallSubnetId: {},
                            ExpectedFirewallSubnetRoutes: {
                              shape: "S4g"
                            },
                            ActualFirewallSubnetRoutes: {
                              shape: "S4c"
                            },
                            InternetGatewayId: {},
                            CurrentInternetGatewayRouteTable: {},
                            ExpectedInternetGatewayRoutes: {
                              shape: "S4g"
                            },
                            ActualInternetGatewayRoutes: {
                              shape: "S4c"
                            },
                            VpcId: {}
                          }
                        },
                        NetworkFirewallInvalidRouteConfigurationViolation: {
                          type: "structure",
                          members: {
                            AffectedSubnets: {
                              shape: "S3q"
                            },
                            RouteTableId: {},
                            IsRouteTableUsedInDifferentAZ: {
                              type: "boolean"
                            },
                            ViolatingRoute: {
                              shape: "S4d"
                            },
                            CurrentFirewallSubnetRouteTable: {},
                            ExpectedFirewallEndpoint: {},
                            ActualFirewallEndpoint: {},
                            ExpectedFirewallSubnetId: {},
                            ActualFirewallSubnetId: {},
                            ExpectedFirewallSubnetRoutes: {
                              shape: "S4g"
                            },
                            ActualFirewallSubnetRoutes: {
                              shape: "S4c"
                            },
                            InternetGatewayId: {},
                            CurrentInternetGatewayRouteTable: {},
                            ExpectedInternetGatewayRoutes: {
                              shape: "S4g"
                            },
                            ActualInternetGatewayRoutes: {
                              shape: "S4c"
                            },
                            VpcId: {}
                          }
                        },
                        NetworkFirewallBlackHoleRouteDetectedViolation: {
                          type: "structure",
                          members: {
                            ViolationTarget: {},
                            RouteTableId: {},
                            VpcId: {},
                            ViolatingRoutes: {
                              shape: "S4c"
                            }
                          }
                        },
                        NetworkFirewallUnexpectedFirewallRoutesViolation: {
                          type: "structure",
                          members: {
                            FirewallSubnetId: {},
                            ViolatingRoutes: {
                              shape: "S4c"
                            },
                            RouteTableId: {},
                            FirewallEndpoint: {},
                            VpcId: {}
                          }
                        },
                        NetworkFirewallUnexpectedGatewayRoutesViolation: {
                          type: "structure",
                          members: {
                            GatewayId: {},
                            ViolatingRoutes: {
                              shape: "S4c"
                            },
                            RouteTableId: {},
                            VpcId: {}
                          }
                        },
                        NetworkFirewallMissingExpectedRoutesViolation: {
                          type: "structure",
                          members: {
                            ViolationTarget: {},
                            ExpectedRoutes: {
                              shape: "S4g"
                            },
                            VpcId: {}
                          }
                        },
                        DnsRuleGroupPriorityConflictViolation: {
                          type: "structure",
                          members: {
                            ViolationTarget: {},
                            ViolationTargetDescription: {},
                            ConflictingPriority: {
                              type: "integer"
                            },
                            ConflictingPolicyId: {},
                            UnavailablePriorities: {
                              type: "list",
                              member: {
                                type: "integer"
                              }
                            }
                          }
                        },
                        DnsDuplicateRuleGroupViolation: {
                          type: "structure",
                          members: {
                            ViolationTarget: {},
                            ViolationTargetDescription: {}
                          }
                        },
                        DnsRuleGroupLimitExceededViolation: {
                          type: "structure",
                          members: {
                            ViolationTarget: {},
                            ViolationTargetDescription: {},
                            NumberOfRuleGroupsAlreadyAssociated: {
                              type: "integer"
                            }
                          }
                        },
                        PossibleRemediationActions: {
                          type: "structure",
                          members: {
                            Description: {},
                            Actions: {
                              type: "list",
                              member: {
                                type: "structure",
                                required: [
                                  "OrderedRemediationActions"
                                ],
                                members: {
                                  Description: {},
                                  OrderedRemediationActions: {
                                    type: "list",
                                    member: {
                                      type: "structure",
                                      members: {
                                        RemediationAction: {
                                          type: "structure",
                                          members: {
                                            Description: {},
                                            EC2CreateRouteAction: {
                                              type: "structure",
                                              required: [
                                                "RouteTableId"
                                              ],
                                              members: {
                                                Description: {},
                                                DestinationCidrBlock: {},
                                                DestinationPrefixListId: {},
                                                DestinationIpv6CidrBlock: {},
                                                VpcEndpointId: {
                                                  shape: "S51"
                                                },
                                                GatewayId: {
                                                  shape: "S51"
                                                },
                                                RouteTableId: {
                                                  shape: "S51"
                                                }
                                              }
                                            },
                                            EC2ReplaceRouteAction: {
                                              type: "structure",
                                              required: [
                                                "RouteTableId"
                                              ],
                                              members: {
                                                Description: {},
                                                DestinationCidrBlock: {},
                                                DestinationPrefixListId: {},
                                                DestinationIpv6CidrBlock: {},
                                                GatewayId: {
                                                  shape: "S51"
                                                },
                                                RouteTableId: {
                                                  shape: "S51"
                                                }
                                              }
                                            },
                                            EC2DeleteRouteAction: {
                                              type: "structure",
                                              required: [
                                                "RouteTableId"
                                              ],
                                              members: {
                                                Description: {},
                                                DestinationCidrBlock: {},
                                                DestinationPrefixListId: {},
                                                DestinationIpv6CidrBlock: {},
                                                RouteTableId: {
                                                  shape: "S51"
                                                }
                                              }
                                            },
                                            EC2CopyRouteTableAction: {
                                              type: "structure",
                                              required: [
                                                "VpcId",
                                                "RouteTableId"
                                              ],
                                              members: {
                                                Description: {},
                                                VpcId: {
                                                  shape: "S51"
                                                },
                                                RouteTableId: {
                                                  shape: "S51"
                                                }
                                              }
                                            },
                                            EC2ReplaceRouteTableAssociationAction: {
                                              type: "structure",
                                              required: [
                                                "AssociationId",
                                                "RouteTableId"
                                              ],
                                              members: {
                                                Description: {},
                                                AssociationId: {
                                                  shape: "S51"
                                                },
                                                RouteTableId: {
                                                  shape: "S51"
                                                }
                                              }
                                            },
                                            EC2AssociateRouteTableAction: {
                                              type: "structure",
                                              required: [
                                                "RouteTableId"
                                              ],
                                              members: {
                                                Description: {},
                                                RouteTableId: {
                                                  shape: "S51"
                                                },
                                                SubnetId: {
                                                  shape: "S51"
                                                },
                                                GatewayId: {
                                                  shape: "S51"
                                                }
                                              }
                                            },
                                            EC2CreateRouteTableAction: {
                                              type: "structure",
                                              required: [
                                                "VpcId"
                                              ],
                                              members: {
                                                Description: {},
                                                VpcId: {
                                                  shape: "S51"
                                                }
                                              }
                                            },
                                            FMSPolicyUpdateFirewallCreationConfigAction: {
                                              type: "structure",
                                              members: {
                                                Description: {},
                                                FirewallCreationConfig: {}
                                              }
                                            }
                                          }
                                        },
                                        Order: {
                                          type: "integer"
                                        }
                                      }
                                    }
                                  },
                                  IsDefaultAction: {
                                    type: "boolean"
                                  }
                                }
                              }
                            }
                          }
                        },
                        FirewallSubnetIsOutOfScopeViolation: {
                          type: "structure",
                          members: {
                            FirewallSubnetId: {},
                            VpcId: {},
                            SubnetAvailabilityZone: {},
                            SubnetAvailabilityZoneId: {},
                            VpcEndpointId: {}
                          }
                        },
                        RouteHasOutOfScopeEndpointViolation: {
                          type: "structure",
                          members: {
                            SubnetId: {},
                            VpcId: {},
                            RouteTableId: {},
                            ViolatingRoutes: {
                              shape: "S4c"
                            },
                            SubnetAvailabilityZone: {},
                            SubnetAvailabilityZoneId: {},
                            CurrentFirewallSubnetRouteTable: {},
                            FirewallSubnetId: {},
                            FirewallSubnetRoutes: {
                              shape: "S4c"
                            },
                            InternetGatewayId: {},
                            CurrentInternetGatewayRouteTable: {},
                            InternetGatewayRoutes: {
                              shape: "S4c"
                            }
                          }
                        },
                        ThirdPartyFirewallMissingFirewallViolation: {
                          type: "structure",
                          members: {
                            ViolationTarget: {},
                            VPC: {},
                            AvailabilityZone: {},
                            TargetViolationReason: {}
                          }
                        },
                        ThirdPartyFirewallMissingSubnetViolation: {
                          type: "structure",
                          members: {
                            ViolationTarget: {},
                            VPC: {},
                            AvailabilityZone: {},
                            TargetViolationReason: {}
                          }
                        },
                        ThirdPartyFirewallMissingExpectedRouteTableViolation: {
                          type: "structure",
                          members: {
                            ViolationTarget: {},
                            VPC: {},
                            AvailabilityZone: {},
                            CurrentRouteTable: {},
                            ExpectedRouteTable: {}
                          }
                        },
                        FirewallSubnetMissingVPCEndpointViolation: {
                          type: "structure",
                          members: {
                            FirewallSubnetId: {},
                            VpcId: {},
                            SubnetAvailabilityZone: {},
                            SubnetAvailabilityZoneId: {}
                          }
                        }
                      }
                    }
                  },
                  ResourceTags: {
                    shape: "S5f"
                  },
                  ResourceDescription: {}
                }
              }
            }
          }
        },
        ListAdminAccountsForOrganization: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AdminAccounts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AdminAccount: {},
                    DefaultAdmin: {
                      type: "boolean"
                    },
                    Status: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListAdminsManagingAccount: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AdminAccounts: {
                shape: "Sz"
              },
              NextToken: {}
            }
          }
        },
        ListAppsLists: {
          input: {
            type: "structure",
            required: [
              "MaxResults"
            ],
            members: {
              DefaultLists: {
                type: "boolean"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppsLists: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ListArn: {},
                    ListId: {},
                    ListName: {},
                    AppsList: {
                      shape: "S1g"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListComplianceStatus: {
          input: {
            type: "structure",
            required: [
              "PolicyId"
            ],
            members: {
              PolicyId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyComplianceStatusList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PolicyOwner: {},
                    PolicyId: {},
                    PolicyName: {},
                    MemberAccount: {},
                    EvaluationResults: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ComplianceStatus: {},
                          ViolatorCount: {
                            type: "long"
                          },
                          EvaluationLimitExceeded: {
                            type: "boolean"
                          }
                        }
                      }
                    },
                    LastUpdated: {
                      type: "timestamp"
                    },
                    IssueInfoMap: {
                      shape: "S1x"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDiscoveredResources: {
          input: {
            type: "structure",
            required: [
              "MemberAccountIds",
              "ResourceType"
            ],
            members: {
              MemberAccountIds: {
                type: "list",
                member: {}
              },
              ResourceType: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    URI: {},
                    AccountId: {},
                    Type: {},
                    Name: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListMemberAccounts: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MemberAccounts: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListPolicies: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PolicyArn: {},
                    PolicyId: {},
                    PolicyName: {},
                    ResourceType: {},
                    SecurityServiceType: {},
                    RemediationEnabled: {
                      type: "boolean"
                    },
                    DeleteUnusedFMManagedResources: {
                      type: "boolean"
                    },
                    PolicyStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListProtocolsLists: {
          input: {
            type: "structure",
            required: [
              "MaxResults"
            ],
            members: {
              DefaultLists: {
                type: "boolean"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProtocolsLists: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ListArn: {},
                    ListId: {},
                    ListName: {},
                    ProtocolsList: {
                      shape: "S2w"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListResourceSetResources: {
          input: {
            type: "structure",
            required: [
              "Identifier"
            ],
            members: {
              Identifier: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Items"
            ],
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "URI"
                  ],
                  members: {
                    URI: {},
                    AccountId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListResourceSets: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceSets: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Name: {},
                    Description: {},
                    LastUpdateTime: {
                      type: "timestamp"
                    },
                    ResourceSetStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TagList: {
                shape: "S5f"
              }
            }
          }
        },
        ListThirdPartyFirewallFirewallPolicies: {
          input: {
            type: "structure",
            required: [
              "ThirdPartyFirewall",
              "MaxResults"
            ],
            members: {
              ThirdPartyFirewall: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ThirdPartyFirewallFirewallPolicies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FirewallPolicyId: {},
                    FirewallPolicyName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        PutAdminAccount: {
          input: {
            type: "structure",
            required: [
              "AdminAccount"
            ],
            members: {
              AdminAccount: {},
              AdminScope: {
                shape: "Sx"
              }
            }
          }
        },
        PutAppsList: {
          input: {
            type: "structure",
            required: [
              "AppsList"
            ],
            members: {
              AppsList: {
                shape: "S1c"
              },
              TagList: {
                shape: "S5f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppsList: {
                shape: "S1c"
              },
              AppsListArn: {}
            }
          }
        },
        PutNotificationChannel: {
          input: {
            type: "structure",
            required: [
              "SnsTopicArn",
              "SnsRoleName"
            ],
            members: {
              SnsTopicArn: {},
              SnsRoleName: {}
            }
          }
        },
        PutPolicy: {
          input: {
            type: "structure",
            required: [
              "Policy"
            ],
            members: {
              Policy: {
                shape: "S24"
              },
              TagList: {
                shape: "S5f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {
                shape: "S24"
              },
              PolicyArn: {}
            }
          }
        },
        PutProtocolsList: {
          input: {
            type: "structure",
            required: [
              "ProtocolsList"
            ],
            members: {
              ProtocolsList: {
                shape: "S2v"
              },
              TagList: {
                shape: "S5f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProtocolsList: {
                shape: "S2v"
              },
              ProtocolsListArn: {}
            }
          }
        },
        PutResourceSet: {
          input: {
            type: "structure",
            required: [
              "ResourceSet"
            ],
            members: {
              ResourceSet: {
                shape: "S30"
              },
              TagList: {
                shape: "S5f"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ResourceSet",
              "ResourceSetArn"
            ],
            members: {
              ResourceSet: {
                shape: "S30"
              },
              ResourceSetArn: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagList"
            ],
            members: {
              ResourceArn: {},
              TagList: {
                shape: "S5f"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S9: {
          type: "list",
          member: {}
        },
        Sb: {
          type: "list",
          member: {
            type: "structure",
            members: {
              URI: {},
              Reason: {}
            }
          }
        },
        Sx: {
          type: "structure",
          members: {
            AccountScope: {
              type: "structure",
              members: {
                Accounts: {
                  shape: "Sz"
                },
                AllAccountsEnabled: {
                  type: "boolean"
                },
                ExcludeSpecifiedAccounts: {
                  type: "boolean"
                }
              }
            },
            OrganizationalUnitScope: {
              type: "structure",
              members: {
                OrganizationalUnits: {
                  type: "list",
                  member: {}
                },
                AllOrganizationalUnitsEnabled: {
                  type: "boolean"
                },
                ExcludeSpecifiedOrganizationalUnits: {
                  type: "boolean"
                }
              }
            },
            RegionScope: {
              type: "structure",
              members: {
                Regions: {
                  type: "list",
                  member: {}
                },
                AllRegionsEnabled: {
                  type: "boolean"
                }
              }
            },
            PolicyTypeScope: {
              type: "structure",
              members: {
                PolicyTypes: {
                  type: "list",
                  member: {}
                },
                AllPolicyTypesEnabled: {
                  type: "boolean"
                }
              }
            }
          }
        },
        Sz: {
          type: "list",
          member: {}
        },
        S1c: {
          type: "structure",
          required: [
            "ListName",
            "AppsList"
          ],
          members: {
            ListId: {},
            ListName: {},
            ListUpdateToken: {},
            CreateTime: {
              type: "timestamp"
            },
            LastUpdateTime: {
              type: "timestamp"
            },
            AppsList: {
              shape: "S1g"
            },
            PreviousAppsList: {
              type: "map",
              key: {},
              value: {
                shape: "S1g"
              }
            }
          }
        },
        S1g: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AppName",
              "Protocol",
              "Port"
            ],
            members: {
              AppName: {},
              Protocol: {},
              Port: {
                type: "long"
              }
            }
          }
        },
        S1x: {
          type: "map",
          key: {},
          value: {}
        },
        S24: {
          type: "structure",
          required: [
            "PolicyName",
            "SecurityServicePolicyData",
            "ResourceType",
            "ExcludeResourceTags",
            "RemediationEnabled"
          ],
          members: {
            PolicyId: {},
            PolicyName: {},
            PolicyUpdateToken: {},
            SecurityServicePolicyData: {
              type: "structure",
              required: [
                "Type"
              ],
              members: {
                Type: {},
                ManagedServiceData: {},
                PolicyOption: {
                  type: "structure",
                  members: {
                    NetworkFirewallPolicy: {
                      type: "structure",
                      members: {
                        FirewallDeploymentModel: {}
                      }
                    },
                    ThirdPartyFirewallPolicy: {
                      type: "structure",
                      members: {
                        FirewallDeploymentModel: {}
                      }
                    }
                  }
                }
              }
            },
            ResourceType: {},
            ResourceTypeList: {
              shape: "S2c"
            },
            ResourceTags: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Key"
                ],
                members: {
                  Key: {},
                  Value: {}
                }
              }
            },
            ExcludeResourceTags: {
              type: "boolean"
            },
            RemediationEnabled: {
              type: "boolean"
            },
            DeleteUnusedFMManagedResources: {
              type: "boolean"
            },
            IncludeMap: {
              shape: "S2h"
            },
            ExcludeMap: {
              shape: "S2h"
            },
            ResourceSetIds: {
              type: "list",
              member: {}
            },
            PolicyDescription: {},
            PolicyStatus: {}
          }
        },
        S2c: {
          type: "list",
          member: {}
        },
        S2h: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {}
          }
        },
        S2v: {
          type: "structure",
          required: [
            "ListName",
            "ProtocolsList"
          ],
          members: {
            ListId: {},
            ListName: {},
            ListUpdateToken: {},
            CreateTime: {
              type: "timestamp"
            },
            LastUpdateTime: {
              type: "timestamp"
            },
            ProtocolsList: {
              shape: "S2w"
            },
            PreviousProtocolsList: {
              type: "map",
              key: {},
              value: {
                shape: "S2w"
              }
            }
          }
        },
        S2w: {
          type: "list",
          member: {}
        },
        S30: {
          type: "structure",
          required: [
            "Name",
            "ResourceTypeList"
          ],
          members: {
            Id: {},
            Name: {},
            Description: {},
            UpdateToken: {},
            ResourceTypeList: {
              shape: "S2c"
            },
            LastUpdateTime: {
              type: "timestamp"
            },
            ResourceSetStatus: {}
          }
        },
        S3p: {
          type: "structure",
          members: {
            ViolationTarget: {},
            ViolatingSecurityGroups: {
              shape: "S3q"
            }
          }
        },
        S3q: {
          type: "list",
          member: {}
        },
        S3x: {
          type: "structure",
          members: {
            StatelessRuleGroups: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  RuleGroupName: {},
                  ResourceId: {},
                  Priority: {
                    type: "integer"
                  }
                }
              }
            },
            StatelessDefaultActions: {
              shape: "S42"
            },
            StatelessFragmentDefaultActions: {
              shape: "S42"
            },
            StatelessCustomActions: {
              shape: "S42"
            },
            StatefulRuleGroups: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  RuleGroupName: {},
                  ResourceId: {},
                  Priority: {
                    type: "integer"
                  },
                  Override: {
                    type: "structure",
                    members: {
                      Action: {}
                    }
                  }
                }
              }
            },
            StatefulDefaultActions: {
              shape: "S42"
            },
            StatefulEngineOptions: {
              type: "structure",
              members: {
                RuleOrder: {}
              }
            }
          }
        },
        S42: {
          type: "list",
          member: {}
        },
        S4c: {
          type: "list",
          member: {
            shape: "S4d"
          }
        },
        S4d: {
          type: "structure",
          members: {
            DestinationType: {},
            TargetType: {},
            Destination: {},
            Target: {}
          }
        },
        S4g: {
          type: "list",
          member: {
            type: "structure",
            members: {
              IpV4Cidr: {},
              PrefixListId: {},
              IpV6Cidr: {},
              ContributingSubnets: {
                shape: "S3q"
              },
              AllowedTargets: {
                type: "list",
                member: {}
              },
              RouteTableId: {}
            }
          }
        },
        S51: {
          type: "structure",
          members: {
            ResourceId: {},
            Description: {}
          }
        },
        S5f: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/fms-2018-01-01.paginators.json
var require_fms_2018_01_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/fms-2018-01-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAdminAccountsForOrganization: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "AdminAccounts"
        },
        ListAdminsManagingAccount: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "AdminAccounts"
        },
        ListAppsLists: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "AppsLists"
        },
        ListComplianceStatus: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PolicyComplianceStatusList"
        },
        ListMemberAccounts: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "MemberAccounts"
        },
        ListPolicies: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PolicyList"
        },
        ListProtocolsLists: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ProtocolsLists"
        },
        ListThirdPartyFirewallFirewallPolicies: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ThirdPartyFirewallFirewallPolicies"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/fms.js
var require_fms = __commonJS({
  "node_modules/aws-sdk/clients/fms.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["fms"] = {};
    AWS2.FMS = Service.defineService("fms", ["2018-01-01"]);
    Object.defineProperty(apiLoader.services["fms"], "2018-01-01", {
      get: function get() {
        var model = require_fms_2018_01_01_min();
        model.paginators = require_fms_2018_01_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.FMS;
  }
});

// node_modules/aws-sdk/apis/secretsmanager-2017-10-17.min.json
var require_secretsmanager_2017_10_17_min = __commonJS({
  "node_modules/aws-sdk/apis/secretsmanager-2017-10-17.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-10-17",
        endpointPrefix: "secretsmanager",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Secrets Manager",
        serviceId: "Secrets Manager",
        signatureVersion: "v4",
        signingName: "secretsmanager",
        targetPrefix: "secretsmanager",
        uid: "secretsmanager-2017-10-17"
      },
      operations: {
        BatchGetSecretValue: {
          input: {
            type: "structure",
            members: {
              SecretIdList: {
                type: "list",
                member: {}
              },
              Filters: {
                shape: "S4"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SecretValues: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ARN: {},
                    Name: {},
                    VersionId: {},
                    SecretBinary: {
                      shape: "Sh"
                    },
                    SecretString: {
                      shape: "Si"
                    },
                    VersionStages: {
                      shape: "Sj"
                    },
                    CreatedDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {},
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SecretId: {},
                    ErrorCode: {},
                    Message: {}
                  }
                }
              }
            }
          }
        },
        CancelRotateSecret: {
          input: {
            type: "structure",
            required: [
              "SecretId"
            ],
            members: {
              SecretId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {},
              Name: {},
              VersionId: {}
            }
          }
        },
        CreateSecret: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              Description: {},
              KmsKeyId: {},
              SecretBinary: {
                shape: "Sh"
              },
              SecretString: {
                shape: "Si"
              },
              Tags: {
                shape: "Sx"
              },
              AddReplicaRegions: {
                shape: "S11"
              },
              ForceOverwriteReplicaSecret: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {},
              Name: {},
              VersionId: {},
              ReplicationStatus: {
                shape: "S16"
              }
            }
          }
        },
        DeleteResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "SecretId"
            ],
            members: {
              SecretId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {},
              Name: {}
            }
          }
        },
        DeleteSecret: {
          input: {
            type: "structure",
            required: [
              "SecretId"
            ],
            members: {
              SecretId: {},
              RecoveryWindowInDays: {
                type: "long"
              },
              ForceDeleteWithoutRecovery: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {},
              Name: {},
              DeletionDate: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeSecret: {
          input: {
            type: "structure",
            required: [
              "SecretId"
            ],
            members: {
              SecretId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {},
              Name: {},
              Description: {},
              KmsKeyId: {},
              RotationEnabled: {
                type: "boolean"
              },
              RotationLambdaARN: {},
              RotationRules: {
                shape: "S1l"
              },
              LastRotatedDate: {
                type: "timestamp"
              },
              LastChangedDate: {
                type: "timestamp"
              },
              LastAccessedDate: {
                type: "timestamp"
              },
              DeletedDate: {
                type: "timestamp"
              },
              NextRotationDate: {
                type: "timestamp"
              },
              Tags: {
                shape: "Sx"
              },
              VersionIdsToStages: {
                shape: "S1t"
              },
              OwningService: {},
              CreatedDate: {
                type: "timestamp"
              },
              PrimaryRegion: {},
              ReplicationStatus: {
                shape: "S16"
              }
            }
          }
        },
        GetRandomPassword: {
          input: {
            type: "structure",
            members: {
              PasswordLength: {
                type: "long"
              },
              ExcludeCharacters: {},
              ExcludeNumbers: {
                type: "boolean"
              },
              ExcludePunctuation: {
                type: "boolean"
              },
              ExcludeUppercase: {
                type: "boolean"
              },
              ExcludeLowercase: {
                type: "boolean"
              },
              IncludeSpace: {
                type: "boolean"
              },
              RequireEachIncludedType: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RandomPassword: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        GetResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "SecretId"
            ],
            members: {
              SecretId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {},
              Name: {},
              ResourcePolicy: {}
            }
          }
        },
        GetSecretValue: {
          input: {
            type: "structure",
            required: [
              "SecretId"
            ],
            members: {
              SecretId: {},
              VersionId: {},
              VersionStage: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {},
              Name: {},
              VersionId: {},
              SecretBinary: {
                shape: "Sh"
              },
              SecretString: {
                shape: "Si"
              },
              VersionStages: {
                shape: "Sj"
              },
              CreatedDate: {
                type: "timestamp"
              }
            }
          }
        },
        ListSecretVersionIds: {
          input: {
            type: "structure",
            required: [
              "SecretId"
            ],
            members: {
              SecretId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              IncludeDeprecated: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Versions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    VersionId: {},
                    VersionStages: {
                      shape: "Sj"
                    },
                    LastAccessedDate: {
                      type: "timestamp"
                    },
                    CreatedDate: {
                      type: "timestamp"
                    },
                    KmsKeyIds: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              NextToken: {},
              ARN: {},
              Name: {}
            }
          }
        },
        ListSecrets: {
          input: {
            type: "structure",
            members: {
              IncludePlannedDeletion: {
                type: "boolean"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "S4"
              },
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SecretList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ARN: {},
                    Name: {},
                    Description: {},
                    KmsKeyId: {},
                    RotationEnabled: {
                      type: "boolean"
                    },
                    RotationLambdaARN: {},
                    RotationRules: {
                      shape: "S1l"
                    },
                    LastRotatedDate: {
                      type: "timestamp"
                    },
                    LastChangedDate: {
                      type: "timestamp"
                    },
                    LastAccessedDate: {
                      type: "timestamp"
                    },
                    DeletedDate: {
                      type: "timestamp"
                    },
                    NextRotationDate: {
                      type: "timestamp"
                    },
                    Tags: {
                      shape: "Sx"
                    },
                    SecretVersionsToStages: {
                      shape: "S1t"
                    },
                    OwningService: {},
                    CreatedDate: {
                      type: "timestamp"
                    },
                    PrimaryRegion: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        PutResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "SecretId",
              "ResourcePolicy"
            ],
            members: {
              SecretId: {},
              ResourcePolicy: {},
              BlockPublicPolicy: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {},
              Name: {}
            }
          }
        },
        PutSecretValue: {
          input: {
            type: "structure",
            required: [
              "SecretId"
            ],
            members: {
              SecretId: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              SecretBinary: {
                shape: "Sh"
              },
              SecretString: {
                shape: "Si"
              },
              VersionStages: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {},
              Name: {},
              VersionId: {},
              VersionStages: {
                shape: "Sj"
              }
            }
          }
        },
        RemoveRegionsFromReplication: {
          input: {
            type: "structure",
            required: [
              "SecretId",
              "RemoveReplicaRegions"
            ],
            members: {
              SecretId: {},
              RemoveReplicaRegions: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {},
              ReplicationStatus: {
                shape: "S16"
              }
            }
          }
        },
        ReplicateSecretToRegions: {
          input: {
            type: "structure",
            required: [
              "SecretId",
              "AddReplicaRegions"
            ],
            members: {
              SecretId: {},
              AddReplicaRegions: {
                shape: "S11"
              },
              ForceOverwriteReplicaSecret: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {},
              ReplicationStatus: {
                shape: "S16"
              }
            }
          }
        },
        RestoreSecret: {
          input: {
            type: "structure",
            required: [
              "SecretId"
            ],
            members: {
              SecretId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {},
              Name: {}
            }
          }
        },
        RotateSecret: {
          input: {
            type: "structure",
            required: [
              "SecretId"
            ],
            members: {
              SecretId: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              RotationLambdaARN: {},
              RotationRules: {
                shape: "S1l"
              },
              RotateImmediately: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {},
              Name: {},
              VersionId: {}
            }
          }
        },
        StopReplicationToReplica: {
          input: {
            type: "structure",
            required: [
              "SecretId"
            ],
            members: {
              SecretId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "SecretId",
              "Tags"
            ],
            members: {
              SecretId: {},
              Tags: {
                shape: "Sx"
              }
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "SecretId",
              "TagKeys"
            ],
            members: {
              SecretId: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        },
        UpdateSecret: {
          input: {
            type: "structure",
            required: [
              "SecretId"
            ],
            members: {
              SecretId: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              Description: {},
              KmsKeyId: {},
              SecretBinary: {
                shape: "Sh"
              },
              SecretString: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {},
              Name: {},
              VersionId: {}
            }
          }
        },
        UpdateSecretVersionStage: {
          input: {
            type: "structure",
            required: [
              "SecretId",
              "VersionStage"
            ],
            members: {
              SecretId: {},
              VersionStage: {},
              RemoveFromVersionId: {},
              MoveToVersionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {},
              Name: {}
            }
          }
        },
        ValidateResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "ResourcePolicy"
            ],
            members: {
              SecretId: {},
              ResourcePolicy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyValidationPassed: {
                type: "boolean"
              },
              ValidationErrors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CheckName: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Values: {
                type: "list",
                member: {}
              }
            }
          }
        },
        Sh: {
          type: "blob",
          sensitive: true
        },
        Si: {
          type: "string",
          sensitive: true
        },
        Sj: {
          type: "list",
          member: {}
        },
        Sx: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S11: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Region: {},
              KmsKeyId: {}
            }
          }
        },
        S16: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Region: {},
              KmsKeyId: {},
              Status: {},
              StatusMessage: {},
              LastAccessedDate: {
                type: "timestamp"
              }
            }
          }
        },
        S1l: {
          type: "structure",
          members: {
            AutomaticallyAfterDays: {
              type: "long"
            },
            Duration: {},
            ScheduleExpression: {}
          }
        },
        S1t: {
          type: "map",
          key: {},
          value: {
            shape: "Sj"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/secretsmanager-2017-10-17.paginators.json
var require_secretsmanager_2017_10_17_paginators = __commonJS({
  "node_modules/aws-sdk/apis/secretsmanager-2017-10-17.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        BatchGetSecretValue: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListSecretVersionIds: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListSecrets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/secretsmanager.js
var require_secretsmanager = __commonJS({
  "node_modules/aws-sdk/clients/secretsmanager.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["secretsmanager"] = {};
    AWS2.SecretsManager = Service.defineService("secretsmanager", ["2017-10-17"]);
    Object.defineProperty(apiLoader.services["secretsmanager"], "2017-10-17", {
      get: function get() {
        var model = require_secretsmanager_2017_10_17_min();
        model.paginators = require_secretsmanager_2017_10_17_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.SecretsManager;
  }
});

// node_modules/aws-sdk/apis/iotanalytics-2017-11-27.min.json
var require_iotanalytics_2017_11_27_min = __commonJS({
  "node_modules/aws-sdk/apis/iotanalytics-2017-11-27.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-11-27",
        endpointPrefix: "iotanalytics",
        protocol: "rest-json",
        serviceFullName: "AWS IoT Analytics",
        serviceId: "IoTAnalytics",
        signatureVersion: "v4",
        signingName: "iotanalytics",
        uid: "iotanalytics-2017-11-27"
      },
      operations: {
        BatchPutMessage: {
          http: {
            requestUri: "/messages/batch",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "channelName",
              "messages"
            ],
            members: {
              channelName: {},
              messages: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "messageId",
                    "payload"
                  ],
                  members: {
                    messageId: {},
                    payload: {
                      type: "blob"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              batchPutMessageErrorEntries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    messageId: {},
                    errorCode: {},
                    errorMessage: {}
                  }
                }
              }
            }
          }
        },
        CancelPipelineReprocessing: {
          http: {
            method: "DELETE",
            requestUri: "/pipelines/{pipelineName}/reprocessing/{reprocessingId}"
          },
          input: {
            type: "structure",
            required: [
              "pipelineName",
              "reprocessingId"
            ],
            members: {
              pipelineName: {
                location: "uri",
                locationName: "pipelineName"
              },
              reprocessingId: {
                location: "uri",
                locationName: "reprocessingId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateChannel: {
          http: {
            requestUri: "/channels",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "channelName"
            ],
            members: {
              channelName: {},
              channelStorage: {
                shape: "Sh"
              },
              retentionPeriod: {
                shape: "Sn"
              },
              tags: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              channelName: {},
              channelArn: {},
              retentionPeriod: {
                shape: "Sn"
              }
            }
          }
        },
        CreateDataset: {
          http: {
            requestUri: "/datasets",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "datasetName",
              "actions"
            ],
            members: {
              datasetName: {},
              actions: {
                shape: "Sy"
              },
              triggers: {
                shape: "S1l"
              },
              contentDeliveryRules: {
                shape: "S1q"
              },
              retentionPeriod: {
                shape: "Sn"
              },
              versioningConfiguration: {
                shape: "S21"
              },
              tags: {
                shape: "Sq"
              },
              lateDataRules: {
                shape: "S24"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datasetName: {},
              datasetArn: {},
              retentionPeriod: {
                shape: "Sn"
              }
            }
          }
        },
        CreateDatasetContent: {
          http: {
            requestUri: "/datasets/{datasetName}/content"
          },
          input: {
            type: "structure",
            required: [
              "datasetName"
            ],
            members: {
              datasetName: {
                location: "uri",
                locationName: "datasetName"
              },
              versionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              versionId: {}
            }
          }
        },
        CreateDatastore: {
          http: {
            requestUri: "/datastores",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "datastoreName"
            ],
            members: {
              datastoreName: {},
              datastoreStorage: {
                shape: "S2h"
              },
              retentionPeriod: {
                shape: "Sn"
              },
              tags: {
                shape: "Sq"
              },
              fileFormatConfiguration: {
                shape: "S2m"
              },
              datastorePartitions: {
                shape: "S2u"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datastoreName: {},
              datastoreArn: {},
              retentionPeriod: {
                shape: "Sn"
              }
            }
          }
        },
        CreatePipeline: {
          http: {
            requestUri: "/pipelines",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "pipelineName",
              "pipelineActivities"
            ],
            members: {
              pipelineName: {},
              pipelineActivities: {
                shape: "S34"
              },
              tags: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              pipelineName: {},
              pipelineArn: {}
            }
          }
        },
        DeleteChannel: {
          http: {
            method: "DELETE",
            requestUri: "/channels/{channelName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "channelName"
            ],
            members: {
              channelName: {
                location: "uri",
                locationName: "channelName"
              }
            }
          }
        },
        DeleteDataset: {
          http: {
            method: "DELETE",
            requestUri: "/datasets/{datasetName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "datasetName"
            ],
            members: {
              datasetName: {
                location: "uri",
                locationName: "datasetName"
              }
            }
          }
        },
        DeleteDatasetContent: {
          http: {
            method: "DELETE",
            requestUri: "/datasets/{datasetName}/content",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "datasetName"
            ],
            members: {
              datasetName: {
                location: "uri",
                locationName: "datasetName"
              },
              versionId: {
                location: "querystring",
                locationName: "versionId"
              }
            }
          }
        },
        DeleteDatastore: {
          http: {
            method: "DELETE",
            requestUri: "/datastores/{datastoreName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "datastoreName"
            ],
            members: {
              datastoreName: {
                location: "uri",
                locationName: "datastoreName"
              }
            }
          }
        },
        DeletePipeline: {
          http: {
            method: "DELETE",
            requestUri: "/pipelines/{pipelineName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "pipelineName"
            ],
            members: {
              pipelineName: {
                location: "uri",
                locationName: "pipelineName"
              }
            }
          }
        },
        DescribeChannel: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelName}"
          },
          input: {
            type: "structure",
            required: [
              "channelName"
            ],
            members: {
              channelName: {
                location: "uri",
                locationName: "channelName"
              },
              includeStatistics: {
                location: "querystring",
                locationName: "includeStatistics",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              channel: {
                type: "structure",
                members: {
                  name: {},
                  storage: {
                    shape: "Sh"
                  },
                  arn: {},
                  status: {},
                  retentionPeriod: {
                    shape: "Sn"
                  },
                  creationTime: {
                    type: "timestamp"
                  },
                  lastUpdateTime: {
                    type: "timestamp"
                  },
                  lastMessageArrivalTime: {
                    type: "timestamp"
                  }
                }
              },
              statistics: {
                type: "structure",
                members: {
                  size: {
                    shape: "S42"
                  }
                }
              }
            }
          }
        },
        DescribeDataset: {
          http: {
            method: "GET",
            requestUri: "/datasets/{datasetName}"
          },
          input: {
            type: "structure",
            required: [
              "datasetName"
            ],
            members: {
              datasetName: {
                location: "uri",
                locationName: "datasetName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              dataset: {
                type: "structure",
                members: {
                  name: {},
                  arn: {},
                  actions: {
                    shape: "Sy"
                  },
                  triggers: {
                    shape: "S1l"
                  },
                  contentDeliveryRules: {
                    shape: "S1q"
                  },
                  status: {},
                  creationTime: {
                    type: "timestamp"
                  },
                  lastUpdateTime: {
                    type: "timestamp"
                  },
                  retentionPeriod: {
                    shape: "Sn"
                  },
                  versioningConfiguration: {
                    shape: "S21"
                  },
                  lateDataRules: {
                    shape: "S24"
                  }
                }
              }
            }
          }
        },
        DescribeDatastore: {
          http: {
            method: "GET",
            requestUri: "/datastores/{datastoreName}"
          },
          input: {
            type: "structure",
            required: [
              "datastoreName"
            ],
            members: {
              datastoreName: {
                location: "uri",
                locationName: "datastoreName"
              },
              includeStatistics: {
                location: "querystring",
                locationName: "includeStatistics",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datastore: {
                type: "structure",
                members: {
                  name: {},
                  storage: {
                    shape: "S2h"
                  },
                  arn: {},
                  status: {},
                  retentionPeriod: {
                    shape: "Sn"
                  },
                  creationTime: {
                    type: "timestamp"
                  },
                  lastUpdateTime: {
                    type: "timestamp"
                  },
                  lastMessageArrivalTime: {
                    type: "timestamp"
                  },
                  fileFormatConfiguration: {
                    shape: "S2m"
                  },
                  datastorePartitions: {
                    shape: "S2u"
                  }
                }
              },
              statistics: {
                type: "structure",
                members: {
                  size: {
                    shape: "S42"
                  }
                }
              }
            }
          }
        },
        DescribeLoggingOptions: {
          http: {
            method: "GET",
            requestUri: "/logging"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              loggingOptions: {
                shape: "S4f"
              }
            }
          }
        },
        DescribePipeline: {
          http: {
            method: "GET",
            requestUri: "/pipelines/{pipelineName}"
          },
          input: {
            type: "structure",
            required: [
              "pipelineName"
            ],
            members: {
              pipelineName: {
                location: "uri",
                locationName: "pipelineName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              pipeline: {
                type: "structure",
                members: {
                  name: {},
                  arn: {},
                  activities: {
                    shape: "S34"
                  },
                  reprocessingSummaries: {
                    shape: "S4l"
                  },
                  creationTime: {
                    type: "timestamp"
                  },
                  lastUpdateTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        GetDatasetContent: {
          http: {
            method: "GET",
            requestUri: "/datasets/{datasetName}/content"
          },
          input: {
            type: "structure",
            required: [
              "datasetName"
            ],
            members: {
              datasetName: {
                location: "uri",
                locationName: "datasetName"
              },
              versionId: {
                location: "querystring",
                locationName: "versionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              entries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    entryName: {},
                    dataURI: {}
                  }
                }
              },
              timestamp: {
                type: "timestamp"
              },
              status: {
                shape: "S4t"
              }
            }
          }
        },
        ListChannels: {
          http: {
            method: "GET",
            requestUri: "/channels"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              channelSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    channelName: {},
                    channelStorage: {
                      type: "structure",
                      members: {
                        serviceManagedS3: {
                          type: "structure",
                          members: {}
                        },
                        customerManagedS3: {
                          type: "structure",
                          members: {
                            bucket: {},
                            keyPrefix: {},
                            roleArn: {}
                          }
                        }
                      }
                    },
                    status: {},
                    creationTime: {
                      type: "timestamp"
                    },
                    lastUpdateTime: {
                      type: "timestamp"
                    },
                    lastMessageArrivalTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDatasetContents: {
          http: {
            method: "GET",
            requestUri: "/datasets/{datasetName}/contents"
          },
          input: {
            type: "structure",
            required: [
              "datasetName"
            ],
            members: {
              datasetName: {
                location: "uri",
                locationName: "datasetName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              scheduledOnOrAfter: {
                location: "querystring",
                locationName: "scheduledOnOrAfter",
                type: "timestamp"
              },
              scheduledBefore: {
                location: "querystring",
                locationName: "scheduledBefore",
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datasetContentSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    version: {},
                    status: {
                      shape: "S4t"
                    },
                    creationTime: {
                      type: "timestamp"
                    },
                    scheduleTime: {
                      type: "timestamp"
                    },
                    completionTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDatasets: {
          http: {
            method: "GET",
            requestUri: "/datasets"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datasetSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    datasetName: {},
                    status: {},
                    creationTime: {
                      type: "timestamp"
                    },
                    lastUpdateTime: {
                      type: "timestamp"
                    },
                    triggers: {
                      shape: "S1l"
                    },
                    actions: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          actionName: {},
                          actionType: {}
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDatastores: {
          http: {
            method: "GET",
            requestUri: "/datastores"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datastoreSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    datastoreName: {},
                    datastoreStorage: {
                      type: "structure",
                      members: {
                        serviceManagedS3: {
                          type: "structure",
                          members: {}
                        },
                        customerManagedS3: {
                          type: "structure",
                          members: {
                            bucket: {},
                            keyPrefix: {},
                            roleArn: {}
                          }
                        },
                        iotSiteWiseMultiLayerStorage: {
                          type: "structure",
                          members: {
                            customerManagedS3Storage: {
                              type: "structure",
                              members: {
                                bucket: {},
                                keyPrefix: {}
                              }
                            }
                          }
                        }
                      }
                    },
                    status: {},
                    creationTime: {
                      type: "timestamp"
                    },
                    lastUpdateTime: {
                      type: "timestamp"
                    },
                    lastMessageArrivalTime: {
                      type: "timestamp"
                    },
                    fileFormatType: {},
                    datastorePartitions: {
                      shape: "S2u"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListPipelines: {
          http: {
            method: "GET",
            requestUri: "/pipelines"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              pipelineSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    pipelineName: {},
                    reprocessingSummaries: {
                      shape: "S4l"
                    },
                    creationTime: {
                      type: "timestamp"
                    },
                    lastUpdateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sq"
              }
            }
          }
        },
        PutLoggingOptions: {
          http: {
            method: "PUT",
            requestUri: "/logging"
          },
          input: {
            type: "structure",
            required: [
              "loggingOptions"
            ],
            members: {
              loggingOptions: {
                shape: "S4f"
              }
            }
          }
        },
        RunPipelineActivity: {
          http: {
            requestUri: "/pipelineactivities/run"
          },
          input: {
            type: "structure",
            required: [
              "pipelineActivity",
              "payloads"
            ],
            members: {
              pipelineActivity: {
                shape: "S35"
              },
              payloads: {
                shape: "S5z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              payloads: {
                shape: "S5z"
              },
              logResult: {}
            }
          }
        },
        SampleChannelData: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelName}/sample"
          },
          input: {
            type: "structure",
            required: [
              "channelName"
            ],
            members: {
              channelName: {
                location: "uri",
                locationName: "channelName"
              },
              maxMessages: {
                location: "querystring",
                locationName: "maxMessages",
                type: "integer"
              },
              startTime: {
                location: "querystring",
                locationName: "startTime",
                type: "timestamp"
              },
              endTime: {
                location: "querystring",
                locationName: "endTime",
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              payloads: {
                shape: "S5z"
              }
            }
          }
        },
        StartPipelineReprocessing: {
          http: {
            requestUri: "/pipelines/{pipelineName}/reprocessing"
          },
          input: {
            type: "structure",
            required: [
              "pipelineName"
            ],
            members: {
              pipelineName: {
                location: "uri",
                locationName: "pipelineName"
              },
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              channelMessages: {
                type: "structure",
                members: {
                  s3Paths: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              reprocessingId: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateChannel: {
          http: {
            method: "PUT",
            requestUri: "/channels/{channelName}"
          },
          input: {
            type: "structure",
            required: [
              "channelName"
            ],
            members: {
              channelName: {
                location: "uri",
                locationName: "channelName"
              },
              channelStorage: {
                shape: "Sh"
              },
              retentionPeriod: {
                shape: "Sn"
              }
            }
          }
        },
        UpdateDataset: {
          http: {
            method: "PUT",
            requestUri: "/datasets/{datasetName}"
          },
          input: {
            type: "structure",
            required: [
              "datasetName",
              "actions"
            ],
            members: {
              datasetName: {
                location: "uri",
                locationName: "datasetName"
              },
              actions: {
                shape: "Sy"
              },
              triggers: {
                shape: "S1l"
              },
              contentDeliveryRules: {
                shape: "S1q"
              },
              retentionPeriod: {
                shape: "Sn"
              },
              versioningConfiguration: {
                shape: "S21"
              },
              lateDataRules: {
                shape: "S24"
              }
            }
          }
        },
        UpdateDatastore: {
          http: {
            method: "PUT",
            requestUri: "/datastores/{datastoreName}"
          },
          input: {
            type: "structure",
            required: [
              "datastoreName"
            ],
            members: {
              datastoreName: {
                location: "uri",
                locationName: "datastoreName"
              },
              retentionPeriod: {
                shape: "Sn"
              },
              datastoreStorage: {
                shape: "S2h"
              },
              fileFormatConfiguration: {
                shape: "S2m"
              }
            }
          }
        },
        UpdatePipeline: {
          http: {
            method: "PUT",
            requestUri: "/pipelines/{pipelineName}"
          },
          input: {
            type: "structure",
            required: [
              "pipelineName",
              "pipelineActivities"
            ],
            members: {
              pipelineName: {
                location: "uri",
                locationName: "pipelineName"
              },
              pipelineActivities: {
                shape: "S34"
              }
            }
          }
        }
      },
      shapes: {
        Sh: {
          type: "structure",
          members: {
            serviceManagedS3: {
              type: "structure",
              members: {}
            },
            customerManagedS3: {
              type: "structure",
              required: [
                "bucket",
                "roleArn"
              ],
              members: {
                bucket: {},
                keyPrefix: {},
                roleArn: {}
              }
            }
          }
        },
        Sn: {
          type: "structure",
          members: {
            unlimited: {
              type: "boolean"
            },
            numberOfDays: {
              type: "integer"
            }
          }
        },
        Sq: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        Sy: {
          type: "list",
          member: {
            type: "structure",
            members: {
              actionName: {},
              queryAction: {
                type: "structure",
                required: [
                  "sqlQuery"
                ],
                members: {
                  sqlQuery: {},
                  filters: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        deltaTime: {
                          type: "structure",
                          required: [
                            "offsetSeconds",
                            "timeExpression"
                          ],
                          members: {
                            offsetSeconds: {
                              type: "integer"
                            },
                            timeExpression: {}
                          }
                        }
                      }
                    }
                  }
                }
              },
              containerAction: {
                type: "structure",
                required: [
                  "image",
                  "executionRoleArn",
                  "resourceConfiguration"
                ],
                members: {
                  image: {},
                  executionRoleArn: {},
                  resourceConfiguration: {
                    type: "structure",
                    required: [
                      "computeType",
                      "volumeSizeInGB"
                    ],
                    members: {
                      computeType: {},
                      volumeSizeInGB: {
                        type: "integer"
                      }
                    }
                  },
                  variables: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "name"
                      ],
                      members: {
                        name: {},
                        stringValue: {},
                        doubleValue: {
                          type: "double"
                        },
                        datasetContentVersionValue: {
                          type: "structure",
                          required: [
                            "datasetName"
                          ],
                          members: {
                            datasetName: {}
                          }
                        },
                        outputFileUriValue: {
                          type: "structure",
                          required: [
                            "fileName"
                          ],
                          members: {
                            fileName: {}
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S1l: {
          type: "list",
          member: {
            type: "structure",
            members: {
              schedule: {
                type: "structure",
                members: {
                  expression: {}
                }
              },
              dataset: {
                type: "structure",
                required: [
                  "name"
                ],
                members: {
                  name: {}
                }
              }
            }
          }
        },
        S1q: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "destination"
            ],
            members: {
              entryName: {},
              destination: {
                type: "structure",
                members: {
                  iotEventsDestinationConfiguration: {
                    type: "structure",
                    required: [
                      "inputName",
                      "roleArn"
                    ],
                    members: {
                      inputName: {},
                      roleArn: {}
                    }
                  },
                  s3DestinationConfiguration: {
                    type: "structure",
                    required: [
                      "bucket",
                      "key",
                      "roleArn"
                    ],
                    members: {
                      bucket: {},
                      key: {},
                      glueConfiguration: {
                        type: "structure",
                        required: [
                          "tableName",
                          "databaseName"
                        ],
                        members: {
                          tableName: {},
                          databaseName: {}
                        }
                      },
                      roleArn: {}
                    }
                  }
                }
              }
            }
          }
        },
        S21: {
          type: "structure",
          members: {
            unlimited: {
              type: "boolean"
            },
            maxVersions: {
              type: "integer"
            }
          }
        },
        S24: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ruleConfiguration"
            ],
            members: {
              ruleName: {},
              ruleConfiguration: {
                type: "structure",
                members: {
                  deltaTimeSessionWindowConfiguration: {
                    type: "structure",
                    required: [
                      "timeoutInMinutes"
                    ],
                    members: {
                      timeoutInMinutes: {
                        type: "integer"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S2h: {
          type: "structure",
          members: {
            serviceManagedS3: {
              type: "structure",
              members: {}
            },
            customerManagedS3: {
              type: "structure",
              required: [
                "bucket",
                "roleArn"
              ],
              members: {
                bucket: {},
                keyPrefix: {},
                roleArn: {}
              }
            },
            iotSiteWiseMultiLayerStorage: {
              type: "structure",
              required: [
                "customerManagedS3Storage"
              ],
              members: {
                customerManagedS3Storage: {
                  type: "structure",
                  required: [
                    "bucket"
                  ],
                  members: {
                    bucket: {},
                    keyPrefix: {}
                  }
                }
              }
            }
          }
        },
        S2m: {
          type: "structure",
          members: {
            jsonConfiguration: {
              type: "structure",
              members: {}
            },
            parquetConfiguration: {
              type: "structure",
              members: {
                schemaDefinition: {
                  type: "structure",
                  members: {
                    columns: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "name",
                          "type"
                        ],
                        members: {
                          name: {},
                          type: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S2u: {
          type: "structure",
          members: {
            partitions: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  attributePartition: {
                    type: "structure",
                    required: [
                      "attributeName"
                    ],
                    members: {
                      attributeName: {}
                    }
                  },
                  timestampPartition: {
                    type: "structure",
                    required: [
                      "attributeName"
                    ],
                    members: {
                      attributeName: {},
                      timestampFormat: {}
                    }
                  }
                }
              }
            }
          }
        },
        S34: {
          type: "list",
          member: {
            shape: "S35"
          }
        },
        S35: {
          type: "structure",
          members: {
            channel: {
              type: "structure",
              required: [
                "name",
                "channelName"
              ],
              members: {
                name: {},
                channelName: {},
                next: {}
              }
            },
            lambda: {
              type: "structure",
              required: [
                "name",
                "lambdaName",
                "batchSize"
              ],
              members: {
                name: {},
                lambdaName: {},
                batchSize: {
                  type: "integer"
                },
                next: {}
              }
            },
            datastore: {
              type: "structure",
              required: [
                "name",
                "datastoreName"
              ],
              members: {
                name: {},
                datastoreName: {}
              }
            },
            addAttributes: {
              type: "structure",
              required: [
                "name",
                "attributes"
              ],
              members: {
                name: {},
                attributes: {
                  type: "map",
                  key: {},
                  value: {}
                },
                next: {}
              }
            },
            removeAttributes: {
              type: "structure",
              required: [
                "name",
                "attributes"
              ],
              members: {
                name: {},
                attributes: {
                  shape: "S3g"
                },
                next: {}
              }
            },
            selectAttributes: {
              type: "structure",
              required: [
                "name",
                "attributes"
              ],
              members: {
                name: {},
                attributes: {
                  shape: "S3g"
                },
                next: {}
              }
            },
            filter: {
              type: "structure",
              required: [
                "name",
                "filter"
              ],
              members: {
                name: {},
                filter: {},
                next: {}
              }
            },
            math: {
              type: "structure",
              required: [
                "name",
                "attribute",
                "math"
              ],
              members: {
                name: {},
                attribute: {},
                math: {},
                next: {}
              }
            },
            deviceRegistryEnrich: {
              type: "structure",
              required: [
                "name",
                "attribute",
                "thingName",
                "roleArn"
              ],
              members: {
                name: {},
                attribute: {},
                thingName: {},
                roleArn: {},
                next: {}
              }
            },
            deviceShadowEnrich: {
              type: "structure",
              required: [
                "name",
                "attribute",
                "thingName",
                "roleArn"
              ],
              members: {
                name: {},
                attribute: {},
                thingName: {},
                roleArn: {},
                next: {}
              }
            }
          }
        },
        S3g: {
          type: "list",
          member: {}
        },
        S42: {
          type: "structure",
          members: {
            estimatedSizeInBytes: {
              type: "double"
            },
            estimatedOn: {
              type: "timestamp"
            }
          }
        },
        S4f: {
          type: "structure",
          required: [
            "roleArn",
            "level",
            "enabled"
          ],
          members: {
            roleArn: {},
            level: {},
            enabled: {
              type: "boolean"
            }
          }
        },
        S4l: {
          type: "list",
          member: {
            type: "structure",
            members: {
              id: {},
              status: {},
              creationTime: {
                type: "timestamp"
              }
            }
          }
        },
        S4t: {
          type: "structure",
          members: {
            state: {},
            reason: {}
          }
        },
        S5z: {
          type: "list",
          member: {
            type: "blob"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iotanalytics-2017-11-27.paginators.json
var require_iotanalytics_2017_11_27_paginators = __commonJS({
  "node_modules/aws-sdk/apis/iotanalytics-2017-11-27.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListChannels: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListDatasetContents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListDatasets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListDatastores: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListPipelines: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/iotanalytics.js
var require_iotanalytics = __commonJS({
  "node_modules/aws-sdk/clients/iotanalytics.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["iotanalytics"] = {};
    AWS2.IoTAnalytics = Service.defineService("iotanalytics", ["2017-11-27"]);
    Object.defineProperty(apiLoader.services["iotanalytics"], "2017-11-27", {
      get: function get() {
        var model = require_iotanalytics_2017_11_27_min();
        model.paginators = require_iotanalytics_2017_11_27_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.IoTAnalytics;
  }
});

// node_modules/aws-sdk/apis/iot1click-devices-2018-05-14.min.json
var require_iot1click_devices_2018_05_14_min = __commonJS({
  "node_modules/aws-sdk/apis/iot1click-devices-2018-05-14.min.json"(exports2, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2018-05-14",
        endpointPrefix: "devices.iot1click",
        signingName: "iot1click",
        serviceFullName: "AWS IoT 1-Click Devices Service",
        serviceId: "IoT 1Click Devices Service",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "devices-2018-05-14",
        signatureVersion: "v4"
      },
      operations: {
        ClaimDevicesByClaimCode: {
          http: {
            method: "PUT",
            requestUri: "/claims/{claimCode}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClaimCode: {
                location: "uri",
                locationName: "claimCode"
              }
            },
            required: [
              "ClaimCode"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClaimCode: {
                locationName: "claimCode"
              },
              Total: {
                locationName: "total",
                type: "integer"
              }
            }
          }
        },
        DescribeDevice: {
          http: {
            method: "GET",
            requestUri: "/devices/{deviceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeviceId: {
                location: "uri",
                locationName: "deviceId"
              }
            },
            required: [
              "DeviceId"
            ]
          },
          output: {
            type: "structure",
            members: {
              DeviceDescription: {
                shape: "S8",
                locationName: "deviceDescription"
              }
            }
          }
        },
        FinalizeDeviceClaim: {
          http: {
            method: "PUT",
            requestUri: "/devices/{deviceId}/finalize-claim",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeviceId: {
                location: "uri",
                locationName: "deviceId"
              },
              Tags: {
                shape: "Sc",
                locationName: "tags"
              }
            },
            required: [
              "DeviceId"
            ]
          },
          output: {
            type: "structure",
            members: {
              State: {
                locationName: "state"
              }
            }
          }
        },
        GetDeviceMethods: {
          http: {
            method: "GET",
            requestUri: "/devices/{deviceId}/methods",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeviceId: {
                location: "uri",
                locationName: "deviceId"
              }
            },
            required: [
              "DeviceId"
            ]
          },
          output: {
            type: "structure",
            members: {
              DeviceMethods: {
                locationName: "deviceMethods",
                type: "list",
                member: {
                  shape: "Si"
                }
              }
            }
          }
        },
        InitiateDeviceClaim: {
          http: {
            method: "PUT",
            requestUri: "/devices/{deviceId}/initiate-claim",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeviceId: {
                location: "uri",
                locationName: "deviceId"
              }
            },
            required: [
              "DeviceId"
            ]
          },
          output: {
            type: "structure",
            members: {
              State: {
                locationName: "state"
              }
            }
          }
        },
        InvokeDeviceMethod: {
          http: {
            requestUri: "/devices/{deviceId}/methods",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeviceId: {
                location: "uri",
                locationName: "deviceId"
              },
              DeviceMethod: {
                shape: "Si",
                locationName: "deviceMethod"
              },
              DeviceMethodParameters: {
                locationName: "deviceMethodParameters"
              }
            },
            required: [
              "DeviceId"
            ]
          },
          output: {
            type: "structure",
            members: {
              DeviceMethodResponse: {
                locationName: "deviceMethodResponse"
              }
            }
          }
        },
        ListDeviceEvents: {
          http: {
            method: "GET",
            requestUri: "/devices/{deviceId}/events",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeviceId: {
                location: "uri",
                locationName: "deviceId"
              },
              FromTimeStamp: {
                shape: "So",
                location: "querystring",
                locationName: "fromTimeStamp"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              ToTimeStamp: {
                shape: "So",
                location: "querystring",
                locationName: "toTimeStamp"
              }
            },
            required: [
              "DeviceId",
              "FromTimeStamp",
              "ToTimeStamp"
            ]
          },
          output: {
            type: "structure",
            members: {
              Events: {
                locationName: "events",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Device: {
                      locationName: "device",
                      type: "structure",
                      members: {
                        Attributes: {
                          locationName: "attributes",
                          type: "structure",
                          members: {}
                        },
                        DeviceId: {
                          locationName: "deviceId"
                        },
                        Type: {
                          locationName: "type"
                        }
                      }
                    },
                    StdEvent: {
                      locationName: "stdEvent"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListDevices: {
          http: {
            method: "GET",
            requestUri: "/devices",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeviceType: {
                location: "querystring",
                locationName: "deviceType"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Devices: {
                locationName: "devices",
                type: "list",
                member: {
                  shape: "S8"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resource-arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              }
            },
            required: [
              "ResourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sc",
                locationName: "tags"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              Tags: {
                shape: "Sc",
                locationName: "tags"
              }
            },
            required: [
              "ResourceArn",
              "Tags"
            ]
          }
        },
        UnclaimDevice: {
          http: {
            method: "PUT",
            requestUri: "/devices/{deviceId}/unclaim",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeviceId: {
                location: "uri",
                locationName: "deviceId"
              }
            },
            required: [
              "DeviceId"
            ]
          },
          output: {
            type: "structure",
            members: {
              State: {
                locationName: "state"
              }
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            },
            required: [
              "TagKeys",
              "ResourceArn"
            ]
          }
        },
        UpdateDeviceState: {
          http: {
            method: "PUT",
            requestUri: "/devices/{deviceId}/state",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeviceId: {
                location: "uri",
                locationName: "deviceId"
              },
              Enabled: {
                locationName: "enabled",
                type: "boolean"
              }
            },
            required: [
              "DeviceId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S8: {
          type: "structure",
          members: {
            Arn: {
              locationName: "arn"
            },
            Attributes: {
              locationName: "attributes",
              type: "map",
              key: {},
              value: {}
            },
            DeviceId: {
              locationName: "deviceId"
            },
            Enabled: {
              locationName: "enabled",
              type: "boolean"
            },
            RemainingLife: {
              locationName: "remainingLife",
              type: "double"
            },
            Type: {
              locationName: "type"
            },
            Tags: {
              shape: "Sc",
              locationName: "tags"
            }
          }
        },
        Sc: {
          type: "map",
          key: {},
          value: {}
        },
        Si: {
          type: "structure",
          members: {
            DeviceType: {
              locationName: "deviceType"
            },
            MethodName: {
              locationName: "methodName"
            }
          }
        },
        So: {
          type: "timestamp",
          timestampFormat: "iso8601"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/iot1clickdevicesservice.js
var require_iot1clickdevicesservice = __commonJS({
  "node_modules/aws-sdk/clients/iot1clickdevicesservice.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["iot1clickdevicesservice"] = {};
    AWS2.IoT1ClickDevicesService = Service.defineService("iot1clickdevicesservice", ["2018-05-14"]);
    Object.defineProperty(apiLoader.services["iot1clickdevicesservice"], "2018-05-14", {
      get: function get() {
        var model = require_iot1click_devices_2018_05_14_min();
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.IoT1ClickDevicesService;
  }
});

// node_modules/aws-sdk/apis/iot1click-projects-2018-05-14.min.json
var require_iot1click_projects_2018_05_14_min = __commonJS({
  "node_modules/aws-sdk/apis/iot1click-projects-2018-05-14.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-05-14",
        endpointPrefix: "projects.iot1click",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "AWS IoT 1-Click Projects",
        serviceFullName: "AWS IoT 1-Click Projects Service",
        serviceId: "IoT 1Click Projects",
        signatureVersion: "v4",
        signingName: "iot1click",
        uid: "iot1click-projects-2018-05-14"
      },
      operations: {
        AssociateDeviceWithPlacement: {
          http: {
            method: "PUT",
            requestUri: "/projects/{projectName}/placements/{placementName}/devices/{deviceTemplateName}"
          },
          input: {
            type: "structure",
            required: [
              "projectName",
              "placementName",
              "deviceId",
              "deviceTemplateName"
            ],
            members: {
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              placementName: {
                location: "uri",
                locationName: "placementName"
              },
              deviceId: {},
              deviceTemplateName: {
                location: "uri",
                locationName: "deviceTemplateName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreatePlacement: {
          http: {
            requestUri: "/projects/{projectName}/placements"
          },
          input: {
            type: "structure",
            required: [
              "placementName",
              "projectName"
            ],
            members: {
              placementName: {},
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              attributes: {
                shape: "S8"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateProject: {
          http: {
            requestUri: "/projects"
          },
          input: {
            type: "structure",
            required: [
              "projectName"
            ],
            members: {
              projectName: {},
              description: {},
              placementTemplate: {
                shape: "Se"
              },
              tags: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeletePlacement: {
          http: {
            method: "DELETE",
            requestUri: "/projects/{projectName}/placements/{placementName}"
          },
          input: {
            type: "structure",
            required: [
              "placementName",
              "projectName"
            ],
            members: {
              placementName: {
                location: "uri",
                locationName: "placementName"
              },
              projectName: {
                location: "uri",
                locationName: "projectName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteProject: {
          http: {
            method: "DELETE",
            requestUri: "/projects/{projectName}"
          },
          input: {
            type: "structure",
            required: [
              "projectName"
            ],
            members: {
              projectName: {
                location: "uri",
                locationName: "projectName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribePlacement: {
          http: {
            method: "GET",
            requestUri: "/projects/{projectName}/placements/{placementName}"
          },
          input: {
            type: "structure",
            required: [
              "placementName",
              "projectName"
            ],
            members: {
              placementName: {
                location: "uri",
                locationName: "placementName"
              },
              projectName: {
                location: "uri",
                locationName: "projectName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "placement"
            ],
            members: {
              placement: {
                type: "structure",
                required: [
                  "projectName",
                  "placementName",
                  "attributes",
                  "createdDate",
                  "updatedDate"
                ],
                members: {
                  projectName: {},
                  placementName: {},
                  attributes: {
                    shape: "S8"
                  },
                  createdDate: {
                    type: "timestamp"
                  },
                  updatedDate: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        DescribeProject: {
          http: {
            method: "GET",
            requestUri: "/projects/{projectName}"
          },
          input: {
            type: "structure",
            required: [
              "projectName"
            ],
            members: {
              projectName: {
                location: "uri",
                locationName: "projectName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "project"
            ],
            members: {
              project: {
                type: "structure",
                required: [
                  "projectName",
                  "createdDate",
                  "updatedDate"
                ],
                members: {
                  arn: {},
                  projectName: {},
                  description: {},
                  createdDate: {
                    type: "timestamp"
                  },
                  updatedDate: {
                    type: "timestamp"
                  },
                  placementTemplate: {
                    shape: "Se"
                  },
                  tags: {
                    shape: "Sn"
                  }
                }
              }
            }
          }
        },
        DisassociateDeviceFromPlacement: {
          http: {
            method: "DELETE",
            requestUri: "/projects/{projectName}/placements/{placementName}/devices/{deviceTemplateName}"
          },
          input: {
            type: "structure",
            required: [
              "projectName",
              "placementName",
              "deviceTemplateName"
            ],
            members: {
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              placementName: {
                location: "uri",
                locationName: "placementName"
              },
              deviceTemplateName: {
                location: "uri",
                locationName: "deviceTemplateName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetDevicesInPlacement: {
          http: {
            method: "GET",
            requestUri: "/projects/{projectName}/placements/{placementName}/devices"
          },
          input: {
            type: "structure",
            required: [
              "projectName",
              "placementName"
            ],
            members: {
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              placementName: {
                location: "uri",
                locationName: "placementName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "devices"
            ],
            members: {
              devices: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        ListPlacements: {
          http: {
            method: "GET",
            requestUri: "/projects/{projectName}/placements"
          },
          input: {
            type: "structure",
            required: [
              "projectName"
            ],
            members: {
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "placements"
            ],
            members: {
              placements: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "projectName",
                    "placementName",
                    "createdDate",
                    "updatedDate"
                  ],
                  members: {
                    projectName: {},
                    placementName: {},
                    createdDate: {
                      type: "timestamp"
                    },
                    updatedDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListProjects: {
          http: {
            method: "GET",
            requestUri: "/projects"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "projects"
            ],
            members: {
              projects: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "projectName",
                    "createdDate",
                    "updatedDate"
                  ],
                  members: {
                    arn: {},
                    projectName: {},
                    createdDate: {
                      type: "timestamp"
                    },
                    updatedDate: {
                      type: "timestamp"
                    },
                    tags: {
                      shape: "Sn"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sn"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdatePlacement: {
          http: {
            method: "PUT",
            requestUri: "/projects/{projectName}/placements/{placementName}"
          },
          input: {
            type: "structure",
            required: [
              "placementName",
              "projectName"
            ],
            members: {
              placementName: {
                location: "uri",
                locationName: "placementName"
              },
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              attributes: {
                shape: "S8"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateProject: {
          http: {
            method: "PUT",
            requestUri: "/projects/{projectName}"
          },
          input: {
            type: "structure",
            required: [
              "projectName"
            ],
            members: {
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              description: {},
              placementTemplate: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S8: {
          type: "map",
          key: {},
          value: {}
        },
        Se: {
          type: "structure",
          members: {
            defaultAttributes: {
              type: "map",
              key: {},
              value: {}
            },
            deviceTemplates: {
              type: "map",
              key: {},
              value: {
                type: "structure",
                members: {
                  deviceType: {},
                  callbackOverrides: {
                    type: "map",
                    key: {},
                    value: {}
                  }
                }
              }
            }
          }
        },
        Sn: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iot1click-projects-2018-05-14.paginators.json
var require_iot1click_projects_2018_05_14_paginators = __commonJS({
  "node_modules/aws-sdk/apis/iot1click-projects-2018-05-14.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListPlacements: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "placements"
        },
        ListProjects: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "projects"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/iot1clickprojects.js
var require_iot1clickprojects = __commonJS({
  "node_modules/aws-sdk/clients/iot1clickprojects.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["iot1clickprojects"] = {};
    AWS2.IoT1ClickProjects = Service.defineService("iot1clickprojects", ["2018-05-14"]);
    Object.defineProperty(apiLoader.services["iot1clickprojects"], "2018-05-14", {
      get: function get() {
        var model = require_iot1click_projects_2018_05_14_min();
        model.paginators = require_iot1click_projects_2018_05_14_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.IoT1ClickProjects;
  }
});

// node_modules/aws-sdk/apis/pi-2018-02-27.min.json
var require_pi_2018_02_27_min = __commonJS({
  "node_modules/aws-sdk/apis/pi-2018-02-27.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-02-27",
        endpointPrefix: "pi",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "AWS PI",
        serviceFullName: "AWS Performance Insights",
        serviceId: "PI",
        signatureVersion: "v4",
        signingName: "pi",
        targetPrefix: "PerformanceInsightsv20180227",
        uid: "pi-2018-02-27"
      },
      operations: {
        CreatePerformanceAnalysisReport: {
          input: {
            type: "structure",
            required: [
              "ServiceType",
              "Identifier",
              "StartTime",
              "EndTime"
            ],
            members: {
              ServiceType: {},
              Identifier: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AnalysisReportId: {}
            }
          }
        },
        DeletePerformanceAnalysisReport: {
          input: {
            type: "structure",
            required: [
              "ServiceType",
              "Identifier",
              "AnalysisReportId"
            ],
            members: {
              ServiceType: {},
              Identifier: {},
              AnalysisReportId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeDimensionKeys: {
          input: {
            type: "structure",
            required: [
              "ServiceType",
              "Identifier",
              "StartTime",
              "EndTime",
              "Metric",
              "GroupBy"
            ],
            members: {
              ServiceType: {},
              Identifier: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Metric: {},
              PeriodInSeconds: {
                type: "integer"
              },
              GroupBy: {
                shape: "Sg"
              },
              AdditionalMetrics: {
                type: "list",
                member: {}
              },
              PartitionBy: {
                shape: "Sg"
              },
              Filter: {
                shape: "Sk"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AlignedStartTime: {
                type: "timestamp"
              },
              AlignedEndTime: {
                type: "timestamp"
              },
              PartitionKeys: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Dimensions"
                  ],
                  members: {
                    Dimensions: {
                      shape: "Sq"
                    }
                  }
                }
              },
              Keys: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Dimensions: {
                      shape: "Sq"
                    },
                    Total: {
                      type: "double"
                    },
                    AdditionalMetrics: {
                      type: "map",
                      key: {},
                      value: {
                        type: "double"
                      }
                    },
                    Partitions: {
                      type: "list",
                      member: {
                        type: "double"
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetDimensionKeyDetails: {
          input: {
            type: "structure",
            required: [
              "ServiceType",
              "Identifier",
              "Group",
              "GroupIdentifier"
            ],
            members: {
              ServiceType: {},
              Identifier: {},
              Group: {},
              GroupIdentifier: {},
              RequestedDimensions: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Dimensions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Value: {},
                    Dimension: {},
                    Status: {}
                  }
                }
              }
            }
          }
        },
        GetPerformanceAnalysisReport: {
          input: {
            type: "structure",
            required: [
              "ServiceType",
              "Identifier",
              "AnalysisReportId"
            ],
            members: {
              ServiceType: {},
              Identifier: {},
              AnalysisReportId: {},
              TextFormat: {},
              AcceptLanguage: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AnalysisReport: {
                type: "structure",
                required: [
                  "AnalysisReportId"
                ],
                members: {
                  AnalysisReportId: {},
                  Identifier: {},
                  ServiceType: {},
                  CreateTime: {
                    type: "timestamp"
                  },
                  StartTime: {
                    type: "timestamp"
                  },
                  EndTime: {
                    type: "timestamp"
                  },
                  Status: {},
                  Insights: {
                    shape: "S19"
                  }
                }
              }
            }
          }
        },
        GetResourceMetadata: {
          input: {
            type: "structure",
            required: [
              "ServiceType",
              "Identifier"
            ],
            members: {
              ServiceType: {},
              Identifier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Identifier: {},
              Features: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    Status: {}
                  }
                }
              }
            }
          }
        },
        GetResourceMetrics: {
          input: {
            type: "structure",
            required: [
              "ServiceType",
              "Identifier",
              "MetricQueries",
              "StartTime",
              "EndTime"
            ],
            members: {
              ServiceType: {},
              Identifier: {},
              MetricQueries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Metric"
                  ],
                  members: {
                    Metric: {},
                    GroupBy: {
                      shape: "Sg"
                    },
                    Filter: {
                      shape: "Sk"
                    }
                  }
                }
              },
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              PeriodInSeconds: {
                type: "integer"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              PeriodAlignment: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AlignedStartTime: {
                type: "timestamp"
              },
              AlignedEndTime: {
                type: "timestamp"
              },
              Identifier: {},
              MetricList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Key: {
                      type: "structure",
                      required: [
                        "Metric"
                      ],
                      members: {
                        Metric: {},
                        Dimensions: {
                          shape: "Sq"
                        }
                      }
                    },
                    DataPoints: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "Timestamp",
                          "Value"
                        ],
                        members: {
                          Timestamp: {
                            type: "timestamp"
                          },
                          Value: {
                            type: "double"
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListAvailableResourceDimensions: {
          input: {
            type: "structure",
            required: [
              "ServiceType",
              "Identifier",
              "Metrics"
            ],
            members: {
              ServiceType: {},
              Identifier: {},
              Metrics: {
                type: "list",
                member: {}
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MetricDimensions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Metric: {},
                    Groups: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Group: {},
                          Dimensions: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Identifier: {}
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListAvailableResourceMetrics: {
          input: {
            type: "structure",
            required: [
              "ServiceType",
              "Identifier",
              "MetricTypes"
            ],
            members: {
              ServiceType: {},
              Identifier: {},
              MetricTypes: {
                type: "list",
                member: {}
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Metrics: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Metric: {},
                    Description: {},
                    Unit: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPerformanceAnalysisReports: {
          input: {
            type: "structure",
            required: [
              "ServiceType",
              "Identifier"
            ],
            members: {
              ServiceType: {},
              Identifier: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ListTags: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AnalysisReports: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AnalysisReportId: {},
                    CreateTime: {
                      type: "timestamp"
                    },
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    Status: {},
                    Tags: {
                      shape: "S5"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ServiceType",
              "ResourceARN"
            ],
            members: {
              ServiceType: {},
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S5"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ServiceType",
              "ResourceARN",
              "Tags"
            ],
            members: {
              ServiceType: {},
              ResourceARN: {},
              Tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ServiceType",
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ServiceType: {},
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S5: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sg: {
          type: "structure",
          required: [
            "Group"
          ],
          members: {
            Group: {},
            Dimensions: {
              type: "list",
              member: {}
            },
            Limit: {
              type: "integer"
            }
          }
        },
        Sk: {
          type: "map",
          key: {},
          value: {}
        },
        Sq: {
          type: "map",
          key: {},
          value: {}
        },
        S19: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "InsightId"
            ],
            members: {
              InsightId: {},
              InsightType: {},
              Context: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Severity: {},
              SupportingInsights: {
                shape: "S19"
              },
              Description: {
                shape: "S1d"
              },
              Recommendations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RecommendationId: {},
                    RecommendationDescription: {
                      shape: "S1d"
                    }
                  }
                }
              },
              InsightData: {
                shape: "S1g"
              },
              BaselineData: {
                shape: "S1g"
              }
            }
          }
        },
        S1d: {
          type: "string",
          sensitive: true
        },
        S1g: {
          type: "list",
          member: {
            type: "structure",
            members: {
              PerformanceInsightsMetric: {
                type: "structure",
                members: {
                  Metric: {},
                  DisplayName: {},
                  Dimensions: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  Value: {
                    type: "double"
                  }
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/pi-2018-02-27.paginators.json
var require_pi_2018_02_27_paginators = __commonJS({
  "node_modules/aws-sdk/apis/pi-2018-02-27.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeDimensionKeys: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        GetResourceMetrics: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAvailableResourceDimensions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAvailableResourceMetrics: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListPerformanceAnalysisReports: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/pi.js
var require_pi = __commonJS({
  "node_modules/aws-sdk/clients/pi.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["pi"] = {};
    AWS2.PI = Service.defineService("pi", ["2018-02-27"]);
    Object.defineProperty(apiLoader.services["pi"], "2018-02-27", {
      get: function get() {
        var model = require_pi_2018_02_27_min();
        model.paginators = require_pi_2018_02_27_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.PI;
  }
});

// node_modules/aws-sdk/lib/services/neptune.js
var require_neptune = __commonJS({
  "node_modules/aws-sdk/lib/services/neptune.js"() {
    "use strict";
    var AWS2 = require_core();
    var rdsutil = require_rdsutil();
    var crossRegionOperations = ["createDBCluster", "copyDBClusterSnapshot"];
    AWS2.util.update(AWS2.Neptune.prototype, {
      /**
      * @api private
      */
      setupRequestListeners: function setupRequestListeners(request) {
        if (crossRegionOperations.indexOf(request.operation) !== -1 && this.config.params && this.config.params.SourceRegion && request.params && !request.params.SourceRegion) {
          request.params.SourceRegion = this.config.params.SourceRegion;
        }
        rdsutil.setupRequestListeners(this, request, crossRegionOperations);
      }
    });
  }
});

// node_modules/aws-sdk/apis/neptune-2014-10-31.min.json
var require_neptune_2014_10_31_min = __commonJS({
  "node_modules/aws-sdk/apis/neptune-2014-10-31.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-10-31",
        endpointPrefix: "rds",
        protocol: "query",
        serviceAbbreviation: "Amazon Neptune",
        serviceFullName: "Amazon Neptune",
        serviceId: "Neptune",
        signatureVersion: "v4",
        signingName: "rds",
        uid: "neptune-2014-10-31",
        xmlNamespace: "http://rds.amazonaws.com/doc/2014-10-31/"
      },
      operations: {
        AddRoleToDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "RoleArn"
            ],
            members: {
              DBClusterIdentifier: {},
              RoleArn: {},
              FeatureName: {}
            }
          }
        },
        AddSourceIdentifierToSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SourceIdentifier"
            ],
            members: {
              SubscriptionName: {},
              SourceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "AddSourceIdentifierToSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S5"
              }
            }
          }
        },
        AddTagsToResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "Tags"
            ],
            members: {
              ResourceName: {},
              Tags: {
                shape: "Sa"
              }
            }
          }
        },
        ApplyPendingMaintenanceAction: {
          input: {
            type: "structure",
            required: [
              "ResourceIdentifier",
              "ApplyAction",
              "OptInType"
            ],
            members: {
              ResourceIdentifier: {},
              ApplyAction: {},
              OptInType: {}
            }
          },
          output: {
            resultWrapper: "ApplyPendingMaintenanceActionResult",
            type: "structure",
            members: {
              ResourcePendingMaintenanceActions: {
                shape: "Se"
              }
            }
          }
        },
        CopyDBClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "SourceDBClusterParameterGroupIdentifier",
              "TargetDBClusterParameterGroupIdentifier",
              "TargetDBClusterParameterGroupDescription"
            ],
            members: {
              SourceDBClusterParameterGroupIdentifier: {},
              TargetDBClusterParameterGroupIdentifier: {},
              TargetDBClusterParameterGroupDescription: {},
              Tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            resultWrapper: "CopyDBClusterParameterGroupResult",
            type: "structure",
            members: {
              DBClusterParameterGroup: {
                shape: "Sk"
              }
            }
          }
        },
        CopyDBClusterSnapshot: {
          input: {
            type: "structure",
            required: [
              "SourceDBClusterSnapshotIdentifier",
              "TargetDBClusterSnapshotIdentifier"
            ],
            members: {
              SourceDBClusterSnapshotIdentifier: {},
              TargetDBClusterSnapshotIdentifier: {},
              KmsKeyId: {},
              PreSignedUrl: {},
              CopyTags: {
                type: "boolean"
              },
              Tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            resultWrapper: "CopyDBClusterSnapshotResult",
            type: "structure",
            members: {
              DBClusterSnapshot: {
                shape: "So"
              }
            }
          }
        },
        CopyDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "SourceDBParameterGroupIdentifier",
              "TargetDBParameterGroupIdentifier",
              "TargetDBParameterGroupDescription"
            ],
            members: {
              SourceDBParameterGroupIdentifier: {},
              TargetDBParameterGroupIdentifier: {},
              TargetDBParameterGroupDescription: {},
              Tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            resultWrapper: "CopyDBParameterGroupResult",
            type: "structure",
            members: {
              DBParameterGroup: {
                shape: "St"
              }
            }
          }
        },
        CreateDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "Engine"
            ],
            members: {
              AvailabilityZones: {
                shape: "Sp"
              },
              BackupRetentionPeriod: {
                type: "integer"
              },
              CharacterSetName: {},
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              DatabaseName: {},
              DBClusterIdentifier: {},
              DBClusterParameterGroupName: {},
              VpcSecurityGroupIds: {
                shape: "Sw"
              },
              DBSubnetGroupName: {},
              Engine: {},
              EngineVersion: {},
              Port: {
                type: "integer"
              },
              MasterUsername: {},
              MasterUserPassword: {},
              OptionGroupName: {},
              PreferredBackupWindow: {},
              PreferredMaintenanceWindow: {},
              ReplicationSourceIdentifier: {},
              Tags: {
                shape: "Sa"
              },
              StorageEncrypted: {
                type: "boolean"
              },
              KmsKeyId: {},
              PreSignedUrl: {},
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              EnableCloudwatchLogsExports: {
                shape: "Sx"
              },
              DeletionProtection: {
                type: "boolean"
              },
              ServerlessV2ScalingConfiguration: {
                shape: "Sy"
              },
              GlobalClusterIdentifier: {},
              StorageType: {}
            }
          },
          output: {
            resultWrapper: "CreateDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "S12"
              }
            }
          }
        },
        CreateDBClusterEndpoint: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "DBClusterEndpointIdentifier",
              "EndpointType"
            ],
            members: {
              DBClusterIdentifier: {},
              DBClusterEndpointIdentifier: {},
              EndpointType: {},
              StaticMembers: {
                shape: "S1g"
              },
              ExcludedMembers: {
                shape: "S1g"
              },
              Tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBClusterEndpointResult",
            type: "structure",
            members: {
              DBClusterEndpointIdentifier: {},
              DBClusterIdentifier: {},
              DBClusterEndpointResourceIdentifier: {},
              Endpoint: {},
              Status: {},
              EndpointType: {},
              CustomEndpointType: {},
              StaticMembers: {
                shape: "S1g"
              },
              ExcludedMembers: {
                shape: "S1g"
              },
              DBClusterEndpointArn: {}
            }
          }
        },
        CreateDBClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBClusterParameterGroupName",
              "DBParameterGroupFamily",
              "Description"
            ],
            members: {
              DBClusterParameterGroupName: {},
              DBParameterGroupFamily: {},
              Description: {},
              Tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBClusterParameterGroupResult",
            type: "structure",
            members: {
              DBClusterParameterGroup: {
                shape: "Sk"
              }
            }
          }
        },
        CreateDBClusterSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBClusterSnapshotIdentifier",
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterSnapshotIdentifier: {},
              DBClusterIdentifier: {},
              Tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBClusterSnapshotResult",
            type: "structure",
            members: {
              DBClusterSnapshot: {
                shape: "So"
              }
            }
          }
        },
        CreateDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "DBInstanceClass",
              "Engine",
              "DBClusterIdentifier"
            ],
            members: {
              DBName: {},
              DBInstanceIdentifier: {},
              AllocatedStorage: {
                type: "integer"
              },
              DBInstanceClass: {},
              Engine: {},
              MasterUsername: {},
              MasterUserPassword: {},
              DBSecurityGroups: {
                shape: "S1n"
              },
              VpcSecurityGroupIds: {
                shape: "Sw"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              PreferredMaintenanceWindow: {},
              DBParameterGroupName: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {},
              Port: {
                type: "integer"
              },
              MultiAZ: {
                type: "boolean"
              },
              EngineVersion: {},
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              CharacterSetName: {},
              PubliclyAccessible: {
                deprecated: true,
                type: "boolean"
              },
              Tags: {
                shape: "Sa"
              },
              DBClusterIdentifier: {},
              StorageType: {},
              TdeCredentialArn: {},
              TdeCredentialPassword: {
                shape: "S1o"
              },
              StorageEncrypted: {
                type: "boolean"
              },
              KmsKeyId: {},
              Domain: {},
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              MonitoringInterval: {
                type: "integer"
              },
              MonitoringRoleArn: {},
              DomainIAMRoleName: {},
              PromotionTier: {
                type: "integer"
              },
              Timezone: {},
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              EnablePerformanceInsights: {
                type: "boolean"
              },
              PerformanceInsightsKMSKeyId: {},
              EnableCloudwatchLogsExports: {
                shape: "Sx"
              },
              DeletionProtection: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S1q"
              }
            }
          }
        },
        CreateDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName",
              "DBParameterGroupFamily",
              "Description"
            ],
            members: {
              DBParameterGroupName: {},
              DBParameterGroupFamily: {},
              Description: {},
              Tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBParameterGroupResult",
            type: "structure",
            members: {
              DBParameterGroup: {
                shape: "St"
              }
            }
          }
        },
        CreateDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName",
              "DBSubnetGroupDescription",
              "SubnetIds"
            ],
            members: {
              DBSubnetGroupName: {},
              DBSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S2c"
              },
              Tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBSubnetGroupResult",
            type: "structure",
            members: {
              DBSubnetGroup: {
                shape: "S1w"
              }
            }
          }
        },
        CreateEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SnsTopicArn"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S7"
              },
              SourceIds: {
                shape: "S6"
              },
              Enabled: {
                type: "boolean"
              },
              Tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            resultWrapper: "CreateEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S5"
              }
            }
          }
        },
        CreateGlobalCluster: {
          input: {
            type: "structure",
            required: [
              "GlobalClusterIdentifier"
            ],
            members: {
              GlobalClusterIdentifier: {},
              SourceDBClusterIdentifier: {},
              Engine: {},
              EngineVersion: {},
              DeletionProtection: {
                type: "boolean"
              },
              StorageEncrypted: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CreateGlobalClusterResult",
            type: "structure",
            members: {
              GlobalCluster: {
                shape: "S2i"
              }
            }
          }
        },
        DeleteDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {},
              SkipFinalSnapshot: {
                type: "boolean"
              },
              FinalDBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "S12"
              }
            }
          }
        },
        DeleteDBClusterEndpoint: {
          input: {
            type: "structure",
            required: [
              "DBClusterEndpointIdentifier"
            ],
            members: {
              DBClusterEndpointIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBClusterEndpointResult",
            type: "structure",
            members: {
              DBClusterEndpointIdentifier: {},
              DBClusterIdentifier: {},
              DBClusterEndpointResourceIdentifier: {},
              Endpoint: {},
              Status: {},
              EndpointType: {},
              CustomEndpointType: {},
              StaticMembers: {
                shape: "S1g"
              },
              ExcludedMembers: {
                shape: "S1g"
              },
              DBClusterEndpointArn: {}
            }
          }
        },
        DeleteDBClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBClusterParameterGroupName"
            ],
            members: {
              DBClusterParameterGroupName: {}
            }
          }
        },
        DeleteDBClusterSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBClusterSnapshotIdentifier"
            ],
            members: {
              DBClusterSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBClusterSnapshotResult",
            type: "structure",
            members: {
              DBClusterSnapshot: {
                shape: "So"
              }
            }
          }
        },
        DeleteDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              SkipFinalSnapshot: {
                type: "boolean"
              },
              FinalDBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S1q"
              }
            }
          }
        },
        DeleteDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {}
            }
          }
        },
        DeleteDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName"
            ],
            members: {
              DBSubnetGroupName: {}
            }
          }
        },
        DeleteEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {}
            }
          },
          output: {
            resultWrapper: "DeleteEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S5"
              }
            }
          }
        },
        DeleteGlobalCluster: {
          input: {
            type: "structure",
            required: [
              "GlobalClusterIdentifier"
            ],
            members: {
              GlobalClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteGlobalClusterResult",
            type: "structure",
            members: {
              GlobalCluster: {
                shape: "S2i"
              }
            }
          }
        },
        DescribeDBClusterEndpoints: {
          input: {
            type: "structure",
            members: {
              DBClusterIdentifier: {},
              DBClusterEndpointIdentifier: {},
              Filters: {
                shape: "S32"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBClusterEndpointsResult",
            type: "structure",
            members: {
              Marker: {},
              DBClusterEndpoints: {
                type: "list",
                member: {
                  locationName: "DBClusterEndpointList",
                  type: "structure",
                  members: {
                    DBClusterEndpointIdentifier: {},
                    DBClusterIdentifier: {},
                    DBClusterEndpointResourceIdentifier: {},
                    Endpoint: {},
                    Status: {},
                    EndpointType: {},
                    CustomEndpointType: {},
                    StaticMembers: {
                      shape: "S1g"
                    },
                    ExcludedMembers: {
                      shape: "S1g"
                    },
                    DBClusterEndpointArn: {}
                  }
                }
              }
            }
          }
        },
        DescribeDBClusterParameterGroups: {
          input: {
            type: "structure",
            members: {
              DBClusterParameterGroupName: {},
              Filters: {
                shape: "S32"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBClusterParameterGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBClusterParameterGroups: {
                type: "list",
                member: {
                  shape: "Sk",
                  locationName: "DBClusterParameterGroup"
                }
              }
            }
          }
        },
        DescribeDBClusterParameters: {
          input: {
            type: "structure",
            required: [
              "DBClusterParameterGroupName"
            ],
            members: {
              DBClusterParameterGroupName: {},
              Source: {},
              Filters: {
                shape: "S32"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBClusterParametersResult",
            type: "structure",
            members: {
              Parameters: {
                shape: "S3d"
              },
              Marker: {}
            }
          }
        },
        DescribeDBClusterSnapshotAttributes: {
          input: {
            type: "structure",
            required: [
              "DBClusterSnapshotIdentifier"
            ],
            members: {
              DBClusterSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBClusterSnapshotAttributesResult",
            type: "structure",
            members: {
              DBClusterSnapshotAttributesResult: {
                shape: "S3i"
              }
            }
          }
        },
        DescribeDBClusterSnapshots: {
          input: {
            type: "structure",
            members: {
              DBClusterIdentifier: {},
              DBClusterSnapshotIdentifier: {},
              SnapshotType: {},
              Filters: {
                shape: "S32"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              IncludeShared: {
                type: "boolean"
              },
              IncludePublic: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeDBClusterSnapshotsResult",
            type: "structure",
            members: {
              Marker: {},
              DBClusterSnapshots: {
                type: "list",
                member: {
                  shape: "So",
                  locationName: "DBClusterSnapshot"
                }
              }
            }
          }
        },
        DescribeDBClusters: {
          input: {
            type: "structure",
            members: {
              DBClusterIdentifier: {},
              Filters: {
                shape: "S32"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBClustersResult",
            type: "structure",
            members: {
              Marker: {},
              DBClusters: {
                type: "list",
                member: {
                  shape: "S12",
                  locationName: "DBCluster"
                }
              }
            }
          }
        },
        DescribeDBEngineVersions: {
          input: {
            type: "structure",
            members: {
              Engine: {},
              EngineVersion: {},
              DBParameterGroupFamily: {},
              Filters: {
                shape: "S32"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              DefaultOnly: {
                type: "boolean"
              },
              ListSupportedCharacterSets: {
                type: "boolean"
              },
              ListSupportedTimezones: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeDBEngineVersionsResult",
            type: "structure",
            members: {
              Marker: {},
              DBEngineVersions: {
                type: "list",
                member: {
                  locationName: "DBEngineVersion",
                  type: "structure",
                  members: {
                    Engine: {},
                    EngineVersion: {},
                    DBParameterGroupFamily: {},
                    DBEngineDescription: {},
                    DBEngineVersionDescription: {},
                    DefaultCharacterSet: {
                      shape: "S3w"
                    },
                    SupportedCharacterSets: {
                      type: "list",
                      member: {
                        shape: "S3w",
                        locationName: "CharacterSet"
                      }
                    },
                    ValidUpgradeTarget: {
                      type: "list",
                      member: {
                        locationName: "UpgradeTarget",
                        type: "structure",
                        members: {
                          Engine: {},
                          EngineVersion: {},
                          Description: {},
                          AutoUpgrade: {
                            type: "boolean"
                          },
                          IsMajorVersionUpgrade: {
                            type: "boolean"
                          },
                          SupportsGlobalDatabases: {
                            type: "boolean"
                          }
                        }
                      }
                    },
                    SupportedTimezones: {
                      type: "list",
                      member: {
                        locationName: "Timezone",
                        type: "structure",
                        members: {
                          TimezoneName: {}
                        }
                      }
                    },
                    ExportableLogTypes: {
                      shape: "Sx"
                    },
                    SupportsLogExportsToCloudwatchLogs: {
                      type: "boolean"
                    },
                    SupportsReadReplica: {
                      type: "boolean"
                    },
                    SupportsGlobalDatabases: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeDBInstances: {
          input: {
            type: "structure",
            members: {
              DBInstanceIdentifier: {},
              Filters: {
                shape: "S32"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBInstancesResult",
            type: "structure",
            members: {
              Marker: {},
              DBInstances: {
                type: "list",
                member: {
                  shape: "S1q",
                  locationName: "DBInstance"
                }
              }
            }
          }
        },
        DescribeDBParameterGroups: {
          input: {
            type: "structure",
            members: {
              DBParameterGroupName: {},
              Filters: {
                shape: "S32"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBParameterGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBParameterGroups: {
                type: "list",
                member: {
                  shape: "St",
                  locationName: "DBParameterGroup"
                }
              }
            }
          }
        },
        DescribeDBParameters: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {},
              Source: {},
              Filters: {
                shape: "S32"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBParametersResult",
            type: "structure",
            members: {
              Parameters: {
                shape: "S3d"
              },
              Marker: {}
            }
          }
        },
        DescribeDBSubnetGroups: {
          input: {
            type: "structure",
            members: {
              DBSubnetGroupName: {},
              Filters: {
                shape: "S32"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSubnetGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSubnetGroups: {
                type: "list",
                member: {
                  shape: "S1w",
                  locationName: "DBSubnetGroup"
                }
              }
            }
          }
        },
        DescribeEngineDefaultClusterParameters: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupFamily"
            ],
            members: {
              DBParameterGroupFamily: {},
              Filters: {
                shape: "S32"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEngineDefaultClusterParametersResult",
            type: "structure",
            members: {
              EngineDefaults: {
                shape: "S4f"
              }
            }
          }
        },
        DescribeEngineDefaultParameters: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupFamily"
            ],
            members: {
              DBParameterGroupFamily: {},
              Filters: {
                shape: "S32"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEngineDefaultParametersResult",
            type: "structure",
            members: {
              EngineDefaults: {
                shape: "S4f"
              }
            }
          }
        },
        DescribeEventCategories: {
          input: {
            type: "structure",
            members: {
              SourceType: {},
              Filters: {
                shape: "S32"
              }
            }
          },
          output: {
            resultWrapper: "DescribeEventCategoriesResult",
            type: "structure",
            members: {
              EventCategoriesMapList: {
                type: "list",
                member: {
                  locationName: "EventCategoriesMap",
                  type: "structure",
                  members: {
                    SourceType: {},
                    EventCategories: {
                      shape: "S7"
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        DescribeEventSubscriptions: {
          input: {
            type: "structure",
            members: {
              SubscriptionName: {},
              Filters: {
                shape: "S32"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventSubscriptionsResult",
            type: "structure",
            members: {
              Marker: {},
              EventSubscriptionsList: {
                type: "list",
                member: {
                  shape: "S5",
                  locationName: "EventSubscription"
                }
              }
            }
          }
        },
        DescribeEvents: {
          input: {
            type: "structure",
            members: {
              SourceIdentifier: {},
              SourceType: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Duration: {
                type: "integer"
              },
              EventCategories: {
                shape: "S7"
              },
              Filters: {
                shape: "S32"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventsResult",
            type: "structure",
            members: {
              Marker: {},
              Events: {
                type: "list",
                member: {
                  locationName: "Event",
                  type: "structure",
                  members: {
                    SourceIdentifier: {},
                    SourceType: {},
                    Message: {},
                    EventCategories: {
                      shape: "S7"
                    },
                    Date: {
                      type: "timestamp"
                    },
                    SourceArn: {}
                  }
                }
              }
            }
          }
        },
        DescribeGlobalClusters: {
          input: {
            type: "structure",
            members: {
              GlobalClusterIdentifier: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeGlobalClustersResult",
            type: "structure",
            members: {
              Marker: {},
              GlobalClusters: {
                type: "list",
                member: {
                  shape: "S2i",
                  locationName: "GlobalClusterMember"
                }
              }
            }
          }
        },
        DescribeOrderableDBInstanceOptions: {
          input: {
            type: "structure",
            required: [
              "Engine"
            ],
            members: {
              Engine: {},
              EngineVersion: {},
              DBInstanceClass: {},
              LicenseModel: {},
              Vpc: {
                type: "boolean"
              },
              Filters: {
                shape: "S32"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeOrderableDBInstanceOptionsResult",
            type: "structure",
            members: {
              OrderableDBInstanceOptions: {
                type: "list",
                member: {
                  locationName: "OrderableDBInstanceOption",
                  type: "structure",
                  members: {
                    Engine: {},
                    EngineVersion: {},
                    DBInstanceClass: {},
                    LicenseModel: {},
                    AvailabilityZones: {
                      type: "list",
                      member: {
                        shape: "S1z",
                        locationName: "AvailabilityZone"
                      }
                    },
                    MultiAZCapable: {
                      type: "boolean"
                    },
                    ReadReplicaCapable: {
                      type: "boolean"
                    },
                    Vpc: {
                      type: "boolean"
                    },
                    SupportsStorageEncryption: {
                      type: "boolean"
                    },
                    StorageType: {},
                    SupportsIops: {
                      type: "boolean"
                    },
                    SupportsEnhancedMonitoring: {
                      type: "boolean"
                    },
                    SupportsIAMDatabaseAuthentication: {
                      type: "boolean"
                    },
                    SupportsPerformanceInsights: {
                      type: "boolean"
                    },
                    MinStorageSize: {
                      type: "integer"
                    },
                    MaxStorageSize: {
                      type: "integer"
                    },
                    MinIopsPerDbInstance: {
                      type: "integer"
                    },
                    MaxIopsPerDbInstance: {
                      type: "integer"
                    },
                    MinIopsPerGib: {
                      type: "double"
                    },
                    MaxIopsPerGib: {
                      type: "double"
                    },
                    SupportsGlobalDatabases: {
                      type: "boolean"
                    }
                  },
                  wrapper: true
                }
              },
              Marker: {}
            }
          }
        },
        DescribePendingMaintenanceActions: {
          input: {
            type: "structure",
            members: {
              ResourceIdentifier: {},
              Filters: {
                shape: "S32"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribePendingMaintenanceActionsResult",
            type: "structure",
            members: {
              PendingMaintenanceActions: {
                type: "list",
                member: {
                  shape: "Se",
                  locationName: "ResourcePendingMaintenanceActions"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeValidDBInstanceModifications: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DescribeValidDBInstanceModificationsResult",
            type: "structure",
            members: {
              ValidDBInstanceModificationsMessage: {
                type: "structure",
                members: {
                  Storage: {
                    type: "list",
                    member: {
                      locationName: "ValidStorageOptions",
                      type: "structure",
                      members: {
                        StorageType: {},
                        StorageSize: {
                          shape: "S5a"
                        },
                        ProvisionedIops: {
                          shape: "S5a"
                        },
                        IopsToStorageRatio: {
                          type: "list",
                          member: {
                            locationName: "DoubleRange",
                            type: "structure",
                            members: {
                              From: {
                                type: "double"
                              },
                              To: {
                                type: "double"
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                },
                wrapper: true
              }
            }
          }
        },
        FailoverDBCluster: {
          input: {
            type: "structure",
            members: {
              DBClusterIdentifier: {},
              TargetDBInstanceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "FailoverDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "S12"
              }
            }
          }
        },
        FailoverGlobalCluster: {
          input: {
            type: "structure",
            required: [
              "GlobalClusterIdentifier",
              "TargetDbClusterIdentifier"
            ],
            members: {
              GlobalClusterIdentifier: {},
              TargetDbClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "FailoverGlobalClusterResult",
            type: "structure",
            members: {
              GlobalCluster: {
                shape: "S2i"
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName"
            ],
            members: {
              ResourceName: {},
              Filters: {
                shape: "S32"
              }
            }
          },
          output: {
            resultWrapper: "ListTagsForResourceResult",
            type: "structure",
            members: {
              TagList: {
                shape: "Sa"
              }
            }
          }
        },
        ModifyDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {},
              NewDBClusterIdentifier: {},
              ApplyImmediately: {
                type: "boolean"
              },
              BackupRetentionPeriod: {
                type: "integer"
              },
              DBClusterParameterGroupName: {},
              VpcSecurityGroupIds: {
                shape: "Sw"
              },
              Port: {
                type: "integer"
              },
              MasterUserPassword: {},
              OptionGroupName: {},
              PreferredBackupWindow: {},
              PreferredMaintenanceWindow: {},
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              CloudwatchLogsExportConfiguration: {
                shape: "S5m"
              },
              EngineVersion: {},
              AllowMajorVersionUpgrade: {
                type: "boolean"
              },
              DBInstanceParameterGroupName: {},
              DeletionProtection: {
                type: "boolean"
              },
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              ServerlessV2ScalingConfiguration: {
                shape: "Sy"
              },
              StorageType: {}
            }
          },
          output: {
            resultWrapper: "ModifyDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "S12"
              }
            }
          }
        },
        ModifyDBClusterEndpoint: {
          input: {
            type: "structure",
            required: [
              "DBClusterEndpointIdentifier"
            ],
            members: {
              DBClusterEndpointIdentifier: {},
              EndpointType: {},
              StaticMembers: {
                shape: "S1g"
              },
              ExcludedMembers: {
                shape: "S1g"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBClusterEndpointResult",
            type: "structure",
            members: {
              DBClusterEndpointIdentifier: {},
              DBClusterIdentifier: {},
              DBClusterEndpointResourceIdentifier: {},
              Endpoint: {},
              Status: {},
              EndpointType: {},
              CustomEndpointType: {},
              StaticMembers: {
                shape: "S1g"
              },
              ExcludedMembers: {
                shape: "S1g"
              },
              DBClusterEndpointArn: {}
            }
          }
        },
        ModifyDBClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBClusterParameterGroupName",
              "Parameters"
            ],
            members: {
              DBClusterParameterGroupName: {},
              Parameters: {
                shape: "S3d"
              }
            }
          },
          output: {
            shape: "S5r",
            resultWrapper: "ModifyDBClusterParameterGroupResult"
          }
        },
        ModifyDBClusterSnapshotAttribute: {
          input: {
            type: "structure",
            required: [
              "DBClusterSnapshotIdentifier",
              "AttributeName"
            ],
            members: {
              DBClusterSnapshotIdentifier: {},
              AttributeName: {},
              ValuesToAdd: {
                shape: "S3l"
              },
              ValuesToRemove: {
                shape: "S3l"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBClusterSnapshotAttributeResult",
            type: "structure",
            members: {
              DBClusterSnapshotAttributesResult: {
                shape: "S3i"
              }
            }
          }
        },
        ModifyDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              AllocatedStorage: {
                type: "integer"
              },
              DBInstanceClass: {},
              DBSubnetGroupName: {},
              DBSecurityGroups: {
                shape: "S1n"
              },
              VpcSecurityGroupIds: {
                shape: "Sw"
              },
              ApplyImmediately: {
                type: "boolean"
              },
              MasterUserPassword: {},
              DBParameterGroupName: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {},
              PreferredMaintenanceWindow: {},
              MultiAZ: {
                type: "boolean"
              },
              EngineVersion: {},
              AllowMajorVersionUpgrade: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              NewDBInstanceIdentifier: {},
              StorageType: {},
              TdeCredentialArn: {},
              TdeCredentialPassword: {
                shape: "S1o"
              },
              CACertificateIdentifier: {},
              Domain: {},
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              MonitoringInterval: {
                type: "integer"
              },
              DBPortNumber: {
                type: "integer"
              },
              PubliclyAccessible: {
                deprecated: true,
                type: "boolean"
              },
              MonitoringRoleArn: {},
              DomainIAMRoleName: {},
              PromotionTier: {
                type: "integer"
              },
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              EnablePerformanceInsights: {
                type: "boolean"
              },
              PerformanceInsightsKMSKeyId: {},
              CloudwatchLogsExportConfiguration: {
                shape: "S5m"
              },
              DeletionProtection: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S1q"
              }
            }
          }
        },
        ModifyDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName",
              "Parameters"
            ],
            members: {
              DBParameterGroupName: {},
              Parameters: {
                shape: "S3d"
              }
            }
          },
          output: {
            shape: "S5x",
            resultWrapper: "ModifyDBParameterGroupResult"
          }
        },
        ModifyDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName",
              "SubnetIds"
            ],
            members: {
              DBSubnetGroupName: {},
              DBSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S2c"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBSubnetGroupResult",
            type: "structure",
            members: {
              DBSubnetGroup: {
                shape: "S1w"
              }
            }
          }
        },
        ModifyEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S7"
              },
              Enabled: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S5"
              }
            }
          }
        },
        ModifyGlobalCluster: {
          input: {
            type: "structure",
            required: [
              "GlobalClusterIdentifier"
            ],
            members: {
              GlobalClusterIdentifier: {},
              NewGlobalClusterIdentifier: {},
              DeletionProtection: {
                type: "boolean"
              },
              EngineVersion: {},
              AllowMajorVersionUpgrade: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyGlobalClusterResult",
            type: "structure",
            members: {
              GlobalCluster: {
                shape: "S2i"
              }
            }
          }
        },
        PromoteReadReplicaDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "PromoteReadReplicaDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "S12"
              }
            }
          }
        },
        RebootDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              ForceFailover: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "RebootDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S1q"
              }
            }
          }
        },
        RemoveFromGlobalCluster: {
          input: {
            type: "structure",
            required: [
              "GlobalClusterIdentifier",
              "DbClusterIdentifier"
            ],
            members: {
              GlobalClusterIdentifier: {},
              DbClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "RemoveFromGlobalClusterResult",
            type: "structure",
            members: {
              GlobalCluster: {
                shape: "S2i"
              }
            }
          }
        },
        RemoveRoleFromDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "RoleArn"
            ],
            members: {
              DBClusterIdentifier: {},
              RoleArn: {},
              FeatureName: {}
            }
          }
        },
        RemoveSourceIdentifierFromSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SourceIdentifier"
            ],
            members: {
              SubscriptionName: {},
              SourceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "RemoveSourceIdentifierFromSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S5"
              }
            }
          }
        },
        RemoveTagsFromResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "TagKeys"
            ],
            members: {
              ResourceName: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ResetDBClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBClusterParameterGroupName"
            ],
            members: {
              DBClusterParameterGroupName: {},
              ResetAllParameters: {
                type: "boolean"
              },
              Parameters: {
                shape: "S3d"
              }
            }
          },
          output: {
            shape: "S5r",
            resultWrapper: "ResetDBClusterParameterGroupResult"
          }
        },
        ResetDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {},
              ResetAllParameters: {
                type: "boolean"
              },
              Parameters: {
                shape: "S3d"
              }
            }
          },
          output: {
            shape: "S5x",
            resultWrapper: "ResetDBParameterGroupResult"
          }
        },
        RestoreDBClusterFromSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "SnapshotIdentifier",
              "Engine"
            ],
            members: {
              AvailabilityZones: {
                shape: "Sp"
              },
              DBClusterIdentifier: {},
              SnapshotIdentifier: {},
              Engine: {},
              EngineVersion: {},
              Port: {
                type: "integer"
              },
              DBSubnetGroupName: {},
              DatabaseName: {},
              OptionGroupName: {},
              VpcSecurityGroupIds: {
                shape: "Sw"
              },
              Tags: {
                shape: "Sa"
              },
              KmsKeyId: {},
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              EnableCloudwatchLogsExports: {
                shape: "Sx"
              },
              DBClusterParameterGroupName: {},
              DeletionProtection: {
                type: "boolean"
              },
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              ServerlessV2ScalingConfiguration: {
                shape: "Sy"
              },
              StorageType: {}
            }
          },
          output: {
            resultWrapper: "RestoreDBClusterFromSnapshotResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "S12"
              }
            }
          }
        },
        RestoreDBClusterToPointInTime: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "SourceDBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {},
              RestoreType: {},
              SourceDBClusterIdentifier: {},
              RestoreToTime: {
                type: "timestamp"
              },
              UseLatestRestorableTime: {
                type: "boolean"
              },
              Port: {
                type: "integer"
              },
              DBSubnetGroupName: {},
              OptionGroupName: {},
              VpcSecurityGroupIds: {
                shape: "Sw"
              },
              Tags: {
                shape: "Sa"
              },
              KmsKeyId: {},
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              EnableCloudwatchLogsExports: {
                shape: "Sx"
              },
              DBClusterParameterGroupName: {},
              DeletionProtection: {
                type: "boolean"
              },
              ServerlessV2ScalingConfiguration: {
                shape: "Sy"
              },
              StorageType: {}
            }
          },
          output: {
            resultWrapper: "RestoreDBClusterToPointInTimeResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "S12"
              }
            }
          }
        },
        StartDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "StartDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "S12"
              }
            }
          }
        },
        StopDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "StopDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "S12"
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          members: {
            CustomerAwsId: {},
            CustSubscriptionId: {},
            SnsTopicArn: {},
            Status: {},
            SubscriptionCreationTime: {},
            SourceType: {},
            SourceIdsList: {
              shape: "S6"
            },
            EventCategoriesList: {
              shape: "S7"
            },
            Enabled: {
              type: "boolean"
            },
            EventSubscriptionArn: {}
          },
          wrapper: true
        },
        S6: {
          type: "list",
          member: {
            locationName: "SourceId"
          }
        },
        S7: {
          type: "list",
          member: {
            locationName: "EventCategory"
          }
        },
        Sa: {
          type: "list",
          member: {
            locationName: "Tag",
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Se: {
          type: "structure",
          members: {
            ResourceIdentifier: {},
            PendingMaintenanceActionDetails: {
              type: "list",
              member: {
                locationName: "PendingMaintenanceAction",
                type: "structure",
                members: {
                  Action: {},
                  AutoAppliedAfterDate: {
                    type: "timestamp"
                  },
                  ForcedApplyDate: {
                    type: "timestamp"
                  },
                  OptInStatus: {},
                  CurrentApplyDate: {
                    type: "timestamp"
                  },
                  Description: {}
                }
              }
            }
          },
          wrapper: true
        },
        Sk: {
          type: "structure",
          members: {
            DBClusterParameterGroupName: {},
            DBParameterGroupFamily: {},
            Description: {},
            DBClusterParameterGroupArn: {}
          },
          wrapper: true
        },
        So: {
          type: "structure",
          members: {
            AvailabilityZones: {
              shape: "Sp"
            },
            DBClusterSnapshotIdentifier: {},
            DBClusterIdentifier: {},
            SnapshotCreateTime: {
              type: "timestamp"
            },
            Engine: {},
            AllocatedStorage: {
              type: "integer"
            },
            Status: {},
            Port: {
              type: "integer"
            },
            VpcId: {},
            ClusterCreateTime: {
              type: "timestamp"
            },
            MasterUsername: {},
            EngineVersion: {},
            LicenseModel: {},
            SnapshotType: {},
            PercentProgress: {
              type: "integer"
            },
            StorageEncrypted: {
              type: "boolean"
            },
            KmsKeyId: {},
            DBClusterSnapshotArn: {},
            SourceDBClusterSnapshotArn: {},
            IAMDatabaseAuthenticationEnabled: {
              type: "boolean"
            },
            StorageType: {}
          },
          wrapper: true
        },
        Sp: {
          type: "list",
          member: {
            locationName: "AvailabilityZone"
          }
        },
        St: {
          type: "structure",
          members: {
            DBParameterGroupName: {},
            DBParameterGroupFamily: {},
            Description: {},
            DBParameterGroupArn: {}
          },
          wrapper: true
        },
        Sw: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroupId"
          }
        },
        Sx: {
          type: "list",
          member: {}
        },
        Sy: {
          type: "structure",
          members: {
            MinCapacity: {
              type: "double"
            },
            MaxCapacity: {
              type: "double"
            }
          }
        },
        S12: {
          type: "structure",
          members: {
            AllocatedStorage: {
              type: "integer"
            },
            AvailabilityZones: {
              shape: "Sp"
            },
            BackupRetentionPeriod: {
              type: "integer"
            },
            CharacterSetName: {},
            DatabaseName: {},
            DBClusterIdentifier: {},
            DBClusterParameterGroup: {},
            DBSubnetGroup: {},
            Status: {},
            PercentProgress: {},
            EarliestRestorableTime: {
              type: "timestamp"
            },
            Endpoint: {},
            ReaderEndpoint: {},
            MultiAZ: {
              type: "boolean"
            },
            Engine: {},
            EngineVersion: {},
            LatestRestorableTime: {
              type: "timestamp"
            },
            Port: {
              type: "integer"
            },
            MasterUsername: {},
            DBClusterOptionGroupMemberships: {
              type: "list",
              member: {
                locationName: "DBClusterOptionGroup",
                type: "structure",
                members: {
                  DBClusterOptionGroupName: {},
                  Status: {}
                }
              }
            },
            PreferredBackupWindow: {},
            PreferredMaintenanceWindow: {},
            ReplicationSourceIdentifier: {},
            ReadReplicaIdentifiers: {
              type: "list",
              member: {
                locationName: "ReadReplicaIdentifier"
              }
            },
            DBClusterMembers: {
              type: "list",
              member: {
                locationName: "DBClusterMember",
                type: "structure",
                members: {
                  DBInstanceIdentifier: {},
                  IsClusterWriter: {
                    type: "boolean"
                  },
                  DBClusterParameterGroupStatus: {},
                  PromotionTier: {
                    type: "integer"
                  }
                },
                wrapper: true
              }
            },
            VpcSecurityGroups: {
              shape: "S18"
            },
            HostedZoneId: {},
            StorageEncrypted: {
              type: "boolean"
            },
            KmsKeyId: {},
            DbClusterResourceId: {},
            DBClusterArn: {},
            AssociatedRoles: {
              type: "list",
              member: {
                locationName: "DBClusterRole",
                type: "structure",
                members: {
                  RoleArn: {},
                  Status: {},
                  FeatureName: {}
                }
              }
            },
            IAMDatabaseAuthenticationEnabled: {
              type: "boolean"
            },
            CloneGroupId: {},
            ClusterCreateTime: {
              type: "timestamp"
            },
            CopyTagsToSnapshot: {
              type: "boolean"
            },
            EnabledCloudwatchLogsExports: {
              shape: "Sx"
            },
            PendingModifiedValues: {
              type: "structure",
              members: {
                PendingCloudwatchLogsExports: {
                  shape: "S1d"
                },
                DBClusterIdentifier: {},
                IAMDatabaseAuthenticationEnabled: {
                  type: "boolean"
                },
                EngineVersion: {},
                BackupRetentionPeriod: {
                  type: "integer"
                },
                StorageType: {},
                AllocatedStorage: {
                  type: "integer"
                },
                Iops: {
                  type: "integer"
                }
              }
            },
            DeletionProtection: {
              type: "boolean"
            },
            CrossAccountClone: {
              type: "boolean"
            },
            AutomaticRestartTime: {
              type: "timestamp"
            },
            ServerlessV2ScalingConfiguration: {
              type: "structure",
              members: {
                MinCapacity: {
                  type: "double"
                },
                MaxCapacity: {
                  type: "double"
                }
              }
            },
            GlobalClusterIdentifier: {},
            IOOptimizedNextAllowedModificationTime: {
              type: "timestamp"
            },
            StorageType: {}
          },
          wrapper: true
        },
        S18: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroupMembership",
            type: "structure",
            members: {
              VpcSecurityGroupId: {},
              Status: {}
            }
          }
        },
        S1d: {
          type: "structure",
          members: {
            LogTypesToEnable: {
              shape: "Sx"
            },
            LogTypesToDisable: {
              shape: "Sx"
            }
          }
        },
        S1g: {
          type: "list",
          member: {}
        },
        S1n: {
          type: "list",
          member: {
            locationName: "DBSecurityGroupName"
          }
        },
        S1o: {
          type: "string",
          sensitive: true
        },
        S1q: {
          type: "structure",
          members: {
            DBInstanceIdentifier: {},
            DBInstanceClass: {},
            Engine: {},
            DBInstanceStatus: {},
            MasterUsername: {},
            DBName: {},
            Endpoint: {
              type: "structure",
              members: {
                Address: {},
                Port: {
                  type: "integer"
                },
                HostedZoneId: {}
              }
            },
            AllocatedStorage: {
              type: "integer"
            },
            InstanceCreateTime: {
              type: "timestamp"
            },
            PreferredBackupWindow: {},
            BackupRetentionPeriod: {
              type: "integer"
            },
            DBSecurityGroups: {
              type: "list",
              member: {
                locationName: "DBSecurityGroup",
                type: "structure",
                members: {
                  DBSecurityGroupName: {},
                  Status: {}
                }
              }
            },
            VpcSecurityGroups: {
              shape: "S18"
            },
            DBParameterGroups: {
              type: "list",
              member: {
                locationName: "DBParameterGroup",
                type: "structure",
                members: {
                  DBParameterGroupName: {},
                  ParameterApplyStatus: {}
                }
              }
            },
            AvailabilityZone: {},
            DBSubnetGroup: {
              shape: "S1w"
            },
            PreferredMaintenanceWindow: {},
            PendingModifiedValues: {
              type: "structure",
              members: {
                DBInstanceClass: {},
                AllocatedStorage: {
                  type: "integer"
                },
                MasterUserPassword: {},
                Port: {
                  type: "integer"
                },
                BackupRetentionPeriod: {
                  type: "integer"
                },
                MultiAZ: {
                  type: "boolean"
                },
                EngineVersion: {},
                LicenseModel: {},
                Iops: {
                  type: "integer"
                },
                DBInstanceIdentifier: {},
                StorageType: {},
                CACertificateIdentifier: {},
                DBSubnetGroupName: {},
                PendingCloudwatchLogsExports: {
                  shape: "S1d"
                }
              }
            },
            LatestRestorableTime: {
              type: "timestamp"
            },
            MultiAZ: {
              type: "boolean"
            },
            EngineVersion: {},
            AutoMinorVersionUpgrade: {
              type: "boolean"
            },
            ReadReplicaSourceDBInstanceIdentifier: {},
            ReadReplicaDBInstanceIdentifiers: {
              type: "list",
              member: {
                locationName: "ReadReplicaDBInstanceIdentifier"
              }
            },
            ReadReplicaDBClusterIdentifiers: {
              type: "list",
              member: {
                locationName: "ReadReplicaDBClusterIdentifier"
              }
            },
            LicenseModel: {},
            Iops: {
              type: "integer"
            },
            OptionGroupMemberships: {
              type: "list",
              member: {
                locationName: "OptionGroupMembership",
                type: "structure",
                members: {
                  OptionGroupName: {},
                  Status: {}
                }
              }
            },
            CharacterSetName: {},
            SecondaryAvailabilityZone: {},
            PubliclyAccessible: {
              deprecated: true,
              type: "boolean"
            },
            StatusInfos: {
              type: "list",
              member: {
                locationName: "DBInstanceStatusInfo",
                type: "structure",
                members: {
                  StatusType: {},
                  Normal: {
                    type: "boolean"
                  },
                  Status: {},
                  Message: {}
                }
              }
            },
            StorageType: {},
            TdeCredentialArn: {},
            DbInstancePort: {
              type: "integer"
            },
            DBClusterIdentifier: {},
            StorageEncrypted: {
              type: "boolean"
            },
            KmsKeyId: {},
            DbiResourceId: {},
            CACertificateIdentifier: {},
            DomainMemberships: {
              type: "list",
              member: {
                locationName: "DomainMembership",
                type: "structure",
                members: {
                  Domain: {},
                  Status: {},
                  FQDN: {},
                  IAMRoleName: {}
                }
              }
            },
            CopyTagsToSnapshot: {
              type: "boolean"
            },
            MonitoringInterval: {
              type: "integer"
            },
            EnhancedMonitoringResourceArn: {},
            MonitoringRoleArn: {},
            PromotionTier: {
              type: "integer"
            },
            DBInstanceArn: {},
            Timezone: {},
            IAMDatabaseAuthenticationEnabled: {
              type: "boolean"
            },
            PerformanceInsightsEnabled: {
              type: "boolean"
            },
            PerformanceInsightsKMSKeyId: {},
            EnabledCloudwatchLogsExports: {
              shape: "Sx"
            },
            DeletionProtection: {
              type: "boolean"
            }
          },
          wrapper: true
        },
        S1w: {
          type: "structure",
          members: {
            DBSubnetGroupName: {},
            DBSubnetGroupDescription: {},
            VpcId: {},
            SubnetGroupStatus: {},
            Subnets: {
              type: "list",
              member: {
                locationName: "Subnet",
                type: "structure",
                members: {
                  SubnetIdentifier: {},
                  SubnetAvailabilityZone: {
                    shape: "S1z"
                  },
                  SubnetStatus: {}
                }
              }
            },
            DBSubnetGroupArn: {}
          },
          wrapper: true
        },
        S1z: {
          type: "structure",
          members: {
            Name: {}
          },
          wrapper: true
        },
        S2c: {
          type: "list",
          member: {
            locationName: "SubnetIdentifier"
          }
        },
        S2i: {
          type: "structure",
          members: {
            GlobalClusterIdentifier: {},
            GlobalClusterResourceId: {},
            GlobalClusterArn: {},
            Status: {},
            Engine: {},
            EngineVersion: {},
            StorageEncrypted: {
              type: "boolean"
            },
            DeletionProtection: {
              type: "boolean"
            },
            GlobalClusterMembers: {
              type: "list",
              member: {
                locationName: "GlobalClusterMember",
                type: "structure",
                members: {
                  DBClusterArn: {},
                  Readers: {
                    type: "list",
                    member: {}
                  },
                  IsWriter: {
                    type: "boolean"
                  }
                },
                wrapper: true
              }
            }
          },
          wrapper: true
        },
        S32: {
          type: "list",
          member: {
            locationName: "Filter",
            type: "structure",
            required: [
              "Name",
              "Values"
            ],
            members: {
              Name: {},
              Values: {
                type: "list",
                member: {
                  locationName: "Value"
                }
              }
            }
          }
        },
        S3d: {
          type: "list",
          member: {
            locationName: "Parameter",
            type: "structure",
            members: {
              ParameterName: {},
              ParameterValue: {},
              Description: {},
              Source: {},
              ApplyType: {},
              DataType: {},
              AllowedValues: {},
              IsModifiable: {
                type: "boolean"
              },
              MinimumEngineVersion: {},
              ApplyMethod: {}
            }
          }
        },
        S3i: {
          type: "structure",
          members: {
            DBClusterSnapshotIdentifier: {},
            DBClusterSnapshotAttributes: {
              type: "list",
              member: {
                locationName: "DBClusterSnapshotAttribute",
                type: "structure",
                members: {
                  AttributeName: {},
                  AttributeValues: {
                    shape: "S3l"
                  }
                }
              }
            }
          },
          wrapper: true
        },
        S3l: {
          type: "list",
          member: {
            locationName: "AttributeValue"
          }
        },
        S3w: {
          type: "structure",
          members: {
            CharacterSetName: {},
            CharacterSetDescription: {}
          }
        },
        S4f: {
          type: "structure",
          members: {
            DBParameterGroupFamily: {},
            Marker: {},
            Parameters: {
              shape: "S3d"
            }
          },
          wrapper: true
        },
        S5a: {
          type: "list",
          member: {
            locationName: "Range",
            type: "structure",
            members: {
              From: {
                type: "integer"
              },
              To: {
                type: "integer"
              },
              Step: {
                type: "integer"
              }
            }
          }
        },
        S5m: {
          type: "structure",
          members: {
            EnableLogTypes: {
              shape: "Sx"
            },
            DisableLogTypes: {
              shape: "Sx"
            }
          }
        },
        S5r: {
          type: "structure",
          members: {
            DBClusterParameterGroupName: {}
          }
        },
        S5x: {
          type: "structure",
          members: {
            DBParameterGroupName: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/neptune-2014-10-31.paginators.json
var require_neptune_2014_10_31_paginators = __commonJS({
  "node_modules/aws-sdk/apis/neptune-2014-10-31.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeDBClusterEndpoints: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBClusterEndpoints"
        },
        DescribeDBClusterParameterGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBClusterParameterGroups"
        },
        DescribeDBClusterParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Parameters"
        },
        DescribeDBClusterSnapshots: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBClusterSnapshots"
        },
        DescribeDBClusters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBClusters"
        },
        DescribeDBEngineVersions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBEngineVersions"
        },
        DescribeDBInstances: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBInstances"
        },
        DescribeDBParameterGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBParameterGroups"
        },
        DescribeDBParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Parameters"
        },
        DescribeDBSubnetGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBSubnetGroups"
        },
        DescribeEngineDefaultParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "EngineDefaults.Marker",
          result_key: "EngineDefaults.Parameters"
        },
        DescribeEventSubscriptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "EventSubscriptionsList"
        },
        DescribeEvents: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Events"
        },
        DescribeGlobalClusters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "GlobalClusters"
        },
        DescribeOrderableDBInstanceOptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "OrderableDBInstanceOptions"
        },
        DescribePendingMaintenanceActions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "PendingMaintenanceActions"
        },
        ListTagsForResource: {
          result_key: "TagList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/neptune-2014-10-31.waiters2.json
var require_neptune_2014_10_31_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/neptune-2014-10-31.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        DBInstanceAvailable: {
          delay: 30,
          operation: "DescribeDBInstances",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "available",
              matcher: "pathAll",
              state: "success",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "deleted",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "deleting",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "failed",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "incompatible-restore",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "incompatible-parameters",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            }
          ]
        },
        DBInstanceDeleted: {
          delay: 30,
          operation: "DescribeDBInstances",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "deleted",
              matcher: "pathAll",
              state: "success",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "DBInstanceNotFound",
              matcher: "error",
              state: "success"
            },
            {
              expected: "creating",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "modifying",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "rebooting",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "resetting-master-credentials",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/neptune.js
var require_neptune2 = __commonJS({
  "node_modules/aws-sdk/clients/neptune.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["neptune"] = {};
    AWS2.Neptune = Service.defineService("neptune", ["2014-10-31"]);
    require_neptune();
    Object.defineProperty(apiLoader.services["neptune"], "2014-10-31", {
      get: function get() {
        var model = require_neptune_2014_10_31_min();
        model.paginators = require_neptune_2014_10_31_paginators().pagination;
        model.waiters = require_neptune_2014_10_31_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Neptune;
  }
});

// node_modules/aws-sdk/apis/mediatailor-2018-04-23.min.json
var require_mediatailor_2018_04_23_min = __commonJS({
  "node_modules/aws-sdk/apis/mediatailor-2018-04-23.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-04-23",
        endpointPrefix: "api.mediatailor",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "MediaTailor",
        serviceFullName: "AWS MediaTailor",
        serviceId: "MediaTailor",
        signatureVersion: "v4",
        signingName: "mediatailor",
        uid: "mediatailor-2018-04-23"
      },
      operations: {
        ConfigureLogsForChannel: {
          http: {
            method: "PUT",
            requestUri: "/configureLogs/channel",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelName",
              "LogTypes"
            ],
            members: {
              ChannelName: {},
              LogTypes: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelName: {},
              LogTypes: {
                shape: "S3"
              }
            }
          }
        },
        ConfigureLogsForPlaybackConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/configureLogs/playbackConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "PercentEnabled",
              "PlaybackConfigurationName"
            ],
            members: {
              PercentEnabled: {
                type: "integer"
              },
              PlaybackConfigurationName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "PercentEnabled"
            ],
            members: {
              PercentEnabled: {
                type: "integer"
              },
              PlaybackConfigurationName: {}
            }
          },
          idempotent: true
        },
        CreateChannel: {
          http: {
            requestUri: "/channel/{ChannelName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelName",
              "Outputs",
              "PlaybackMode"
            ],
            members: {
              ChannelName: {
                location: "uri",
                locationName: "ChannelName"
              },
              FillerSlate: {
                shape: "Sa"
              },
              Outputs: {
                shape: "Sb"
              },
              PlaybackMode: {},
              Tags: {
                shape: "Si",
                locationName: "tags"
              },
              Tier: {},
              TimeShiftConfiguration: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              ChannelName: {},
              ChannelState: {},
              CreationTime: {
                shape: "Sn"
              },
              FillerSlate: {
                shape: "Sa"
              },
              LastModifiedTime: {
                shape: "Sn"
              },
              Outputs: {
                shape: "So"
              },
              PlaybackMode: {},
              Tags: {
                shape: "Si",
                locationName: "tags"
              },
              Tier: {},
              TimeShiftConfiguration: {
                shape: "Sk"
              }
            }
          },
          idempotent: true
        },
        CreateLiveSource: {
          http: {
            requestUri: "/sourceLocation/{SourceLocationName}/liveSource/{LiveSourceName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "HttpPackageConfigurations",
              "LiveSourceName",
              "SourceLocationName"
            ],
            members: {
              HttpPackageConfigurations: {
                shape: "Sr"
              },
              LiveSourceName: {
                location: "uri",
                locationName: "LiveSourceName"
              },
              SourceLocationName: {
                location: "uri",
                locationName: "SourceLocationName"
              },
              Tags: {
                shape: "Si",
                locationName: "tags"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTime: {
                shape: "Sn"
              },
              HttpPackageConfigurations: {
                shape: "Sr"
              },
              LastModifiedTime: {
                shape: "Sn"
              },
              LiveSourceName: {},
              SourceLocationName: {},
              Tags: {
                shape: "Si",
                locationName: "tags"
              }
            }
          },
          idempotent: true
        },
        CreatePrefetchSchedule: {
          http: {
            requestUri: "/prefetchSchedule/{PlaybackConfigurationName}/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Consumption",
              "Name",
              "PlaybackConfigurationName",
              "Retrieval"
            ],
            members: {
              Consumption: {
                shape: "Sw"
              },
              Name: {
                location: "uri",
                locationName: "Name"
              },
              PlaybackConfigurationName: {
                location: "uri",
                locationName: "PlaybackConfigurationName"
              },
              Retrieval: {
                shape: "S10"
              },
              StreamId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Consumption: {
                shape: "Sw"
              },
              Name: {},
              PlaybackConfigurationName: {},
              Retrieval: {
                shape: "S10"
              },
              StreamId: {}
            }
          },
          idempotent: true
        },
        CreateProgram: {
          http: {
            requestUri: "/channel/{ChannelName}/program/{ProgramName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelName",
              "ProgramName",
              "ScheduleConfiguration",
              "SourceLocationName"
            ],
            members: {
              AdBreaks: {
                shape: "S13"
              },
              ChannelName: {
                location: "uri",
                locationName: "ChannelName"
              },
              LiveSourceName: {},
              ProgramName: {
                location: "uri",
                locationName: "ProgramName"
              },
              ScheduleConfiguration: {
                type: "structure",
                required: [
                  "Transition"
                ],
                members: {
                  ClipRange: {
                    shape: "S1g"
                  },
                  Transition: {
                    type: "structure",
                    required: [
                      "RelativePosition",
                      "Type"
                    ],
                    members: {
                      DurationMillis: {
                        type: "long"
                      },
                      RelativePosition: {},
                      RelativeProgram: {},
                      ScheduledStartTimeMillis: {
                        type: "long"
                      },
                      Type: {}
                    }
                  }
                }
              },
              SourceLocationName: {},
              VodSourceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AdBreaks: {
                shape: "S13"
              },
              Arn: {},
              ChannelName: {},
              ClipRange: {
                shape: "S1g"
              },
              CreationTime: {
                shape: "Sn"
              },
              DurationMillis: {
                type: "long"
              },
              LiveSourceName: {},
              ProgramName: {},
              ScheduledStartTime: {
                shape: "Sn"
              },
              SourceLocationName: {},
              VodSourceName: {}
            }
          },
          idempotent: true
        },
        CreateSourceLocation: {
          http: {
            requestUri: "/sourceLocation/{SourceLocationName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "HttpConfiguration",
              "SourceLocationName"
            ],
            members: {
              AccessConfiguration: {
                shape: "S1l"
              },
              DefaultSegmentDeliveryConfiguration: {
                shape: "S1o"
              },
              HttpConfiguration: {
                shape: "S1p"
              },
              SegmentDeliveryConfigurations: {
                shape: "S1q"
              },
              SourceLocationName: {
                location: "uri",
                locationName: "SourceLocationName"
              },
              Tags: {
                shape: "Si",
                locationName: "tags"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccessConfiguration: {
                shape: "S1l"
              },
              Arn: {},
              CreationTime: {
                shape: "Sn"
              },
              DefaultSegmentDeliveryConfiguration: {
                shape: "S1o"
              },
              HttpConfiguration: {
                shape: "S1p"
              },
              LastModifiedTime: {
                shape: "Sn"
              },
              SegmentDeliveryConfigurations: {
                shape: "S1q"
              },
              SourceLocationName: {},
              Tags: {
                shape: "Si",
                locationName: "tags"
              }
            }
          },
          idempotent: true
        },
        CreateVodSource: {
          http: {
            requestUri: "/sourceLocation/{SourceLocationName}/vodSource/{VodSourceName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "HttpPackageConfigurations",
              "SourceLocationName",
              "VodSourceName"
            ],
            members: {
              HttpPackageConfigurations: {
                shape: "Sr"
              },
              SourceLocationName: {
                location: "uri",
                locationName: "SourceLocationName"
              },
              Tags: {
                shape: "Si",
                locationName: "tags"
              },
              VodSourceName: {
                location: "uri",
                locationName: "VodSourceName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTime: {
                shape: "Sn"
              },
              HttpPackageConfigurations: {
                shape: "Sr"
              },
              LastModifiedTime: {
                shape: "Sn"
              },
              SourceLocationName: {},
              Tags: {
                shape: "Si",
                locationName: "tags"
              },
              VodSourceName: {}
            }
          },
          idempotent: true
        },
        DeleteChannel: {
          http: {
            method: "DELETE",
            requestUri: "/channel/{ChannelName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelName"
            ],
            members: {
              ChannelName: {
                location: "uri",
                locationName: "ChannelName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteChannelPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/channel/{ChannelName}/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelName"
            ],
            members: {
              ChannelName: {
                location: "uri",
                locationName: "ChannelName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteLiveSource: {
          http: {
            method: "DELETE",
            requestUri: "/sourceLocation/{SourceLocationName}/liveSource/{LiveSourceName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "LiveSourceName",
              "SourceLocationName"
            ],
            members: {
              LiveSourceName: {
                location: "uri",
                locationName: "LiveSourceName"
              },
              SourceLocationName: {
                location: "uri",
                locationName: "SourceLocationName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeletePlaybackConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/playbackConfiguration/{Name}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeletePrefetchSchedule: {
          http: {
            method: "DELETE",
            requestUri: "/prefetchSchedule/{PlaybackConfigurationName}/{Name}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "PlaybackConfigurationName"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              },
              PlaybackConfigurationName: {
                location: "uri",
                locationName: "PlaybackConfigurationName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteProgram: {
          http: {
            method: "DELETE",
            requestUri: "/channel/{ChannelName}/program/{ProgramName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelName",
              "ProgramName"
            ],
            members: {
              ChannelName: {
                location: "uri",
                locationName: "ChannelName"
              },
              ProgramName: {
                location: "uri",
                locationName: "ProgramName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteSourceLocation: {
          http: {
            method: "DELETE",
            requestUri: "/sourceLocation/{SourceLocationName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SourceLocationName"
            ],
            members: {
              SourceLocationName: {
                location: "uri",
                locationName: "SourceLocationName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteVodSource: {
          http: {
            method: "DELETE",
            requestUri: "/sourceLocation/{SourceLocationName}/vodSource/{VodSourceName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SourceLocationName",
              "VodSourceName"
            ],
            members: {
              SourceLocationName: {
                location: "uri",
                locationName: "SourceLocationName"
              },
              VodSourceName: {
                location: "uri",
                locationName: "VodSourceName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DescribeChannel: {
          http: {
            method: "GET",
            requestUri: "/channel/{ChannelName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelName"
            ],
            members: {
              ChannelName: {
                location: "uri",
                locationName: "ChannelName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "LogConfiguration"
            ],
            members: {
              Arn: {},
              ChannelName: {},
              ChannelState: {},
              CreationTime: {
                shape: "Sn"
              },
              FillerSlate: {
                shape: "Sa"
              },
              LastModifiedTime: {
                shape: "Sn"
              },
              LogConfiguration: {
                shape: "S2d"
              },
              Outputs: {
                shape: "So"
              },
              PlaybackMode: {},
              Tags: {
                shape: "Si",
                locationName: "tags"
              },
              Tier: {},
              TimeShiftConfiguration: {
                shape: "Sk"
              }
            }
          }
        },
        DescribeLiveSource: {
          http: {
            method: "GET",
            requestUri: "/sourceLocation/{SourceLocationName}/liveSource/{LiveSourceName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "LiveSourceName",
              "SourceLocationName"
            ],
            members: {
              LiveSourceName: {
                location: "uri",
                locationName: "LiveSourceName"
              },
              SourceLocationName: {
                location: "uri",
                locationName: "SourceLocationName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTime: {
                shape: "Sn"
              },
              HttpPackageConfigurations: {
                shape: "Sr"
              },
              LastModifiedTime: {
                shape: "Sn"
              },
              LiveSourceName: {},
              SourceLocationName: {},
              Tags: {
                shape: "Si",
                locationName: "tags"
              }
            }
          }
        },
        DescribeProgram: {
          http: {
            method: "GET",
            requestUri: "/channel/{ChannelName}/program/{ProgramName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelName",
              "ProgramName"
            ],
            members: {
              ChannelName: {
                location: "uri",
                locationName: "ChannelName"
              },
              ProgramName: {
                location: "uri",
                locationName: "ProgramName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AdBreaks: {
                shape: "S13"
              },
              Arn: {},
              ChannelName: {},
              ClipRange: {
                shape: "S1g"
              },
              CreationTime: {
                shape: "Sn"
              },
              DurationMillis: {
                type: "long"
              },
              LiveSourceName: {},
              ProgramName: {},
              ScheduledStartTime: {
                shape: "Sn"
              },
              SourceLocationName: {},
              VodSourceName: {}
            }
          }
        },
        DescribeSourceLocation: {
          http: {
            method: "GET",
            requestUri: "/sourceLocation/{SourceLocationName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SourceLocationName"
            ],
            members: {
              SourceLocationName: {
                location: "uri",
                locationName: "SourceLocationName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccessConfiguration: {
                shape: "S1l"
              },
              Arn: {},
              CreationTime: {
                shape: "Sn"
              },
              DefaultSegmentDeliveryConfiguration: {
                shape: "S1o"
              },
              HttpConfiguration: {
                shape: "S1p"
              },
              LastModifiedTime: {
                shape: "Sn"
              },
              SegmentDeliveryConfigurations: {
                shape: "S1q"
              },
              SourceLocationName: {},
              Tags: {
                shape: "Si",
                locationName: "tags"
              }
            }
          }
        },
        DescribeVodSource: {
          http: {
            method: "GET",
            requestUri: "/sourceLocation/{SourceLocationName}/vodSource/{VodSourceName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SourceLocationName",
              "VodSourceName"
            ],
            members: {
              SourceLocationName: {
                location: "uri",
                locationName: "SourceLocationName"
              },
              VodSourceName: {
                location: "uri",
                locationName: "VodSourceName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AdBreakOpportunities: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "OffsetMillis"
                  ],
                  members: {
                    OffsetMillis: {
                      type: "long"
                    }
                  }
                }
              },
              Arn: {},
              CreationTime: {
                shape: "Sn"
              },
              HttpPackageConfigurations: {
                shape: "Sr"
              },
              LastModifiedTime: {
                shape: "Sn"
              },
              SourceLocationName: {},
              Tags: {
                shape: "Si",
                locationName: "tags"
              },
              VodSourceName: {}
            }
          }
        },
        GetChannelPolicy: {
          http: {
            method: "GET",
            requestUri: "/channel/{ChannelName}/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelName"
            ],
            members: {
              ChannelName: {
                location: "uri",
                locationName: "ChannelName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {}
            }
          }
        },
        GetChannelSchedule: {
          http: {
            method: "GET",
            requestUri: "/channel/{ChannelName}/schedule",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelName"
            ],
            members: {
              ChannelName: {
                location: "uri",
                locationName: "ChannelName"
              },
              DurationMinutes: {
                location: "querystring",
                locationName: "durationMinutes"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Arn",
                    "ChannelName",
                    "ProgramName",
                    "SourceLocationName"
                  ],
                  members: {
                    ApproximateDurationSeconds: {
                      type: "long"
                    },
                    ApproximateStartTime: {
                      shape: "Sn"
                    },
                    Arn: {},
                    ChannelName: {},
                    LiveSourceName: {},
                    ProgramName: {},
                    ScheduleAdBreaks: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ApproximateDurationSeconds: {
                            type: "long"
                          },
                          ApproximateStartTime: {
                            shape: "Sn"
                          },
                          SourceLocationName: {},
                          VodSourceName: {}
                        }
                      }
                    },
                    ScheduleEntryType: {},
                    SourceLocationName: {},
                    VodSourceName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetPlaybackConfiguration: {
          http: {
            method: "GET",
            requestUri: "/playbackConfiguration/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AdDecisionServerUrl: {},
              AvailSuppression: {
                shape: "S31"
              },
              Bumper: {
                shape: "S34"
              },
              CdnConfiguration: {
                shape: "S35"
              },
              ConfigurationAliases: {
                shape: "S36"
              },
              DashConfiguration: {
                shape: "S37"
              },
              HlsConfiguration: {
                shape: "S39"
              },
              LivePreRollConfiguration: {
                shape: "S3a"
              },
              LogConfiguration: {
                shape: "S3b"
              },
              ManifestProcessingRules: {
                shape: "S3c"
              },
              Name: {},
              PersonalizationThresholdSeconds: {
                type: "integer"
              },
              PlaybackConfigurationArn: {},
              PlaybackEndpointPrefix: {},
              SessionInitializationEndpointPrefix: {},
              SlateAdUrl: {},
              Tags: {
                shape: "Si",
                locationName: "tags"
              },
              TranscodeProfileName: {},
              VideoContentSourceUrl: {}
            }
          }
        },
        GetPrefetchSchedule: {
          http: {
            method: "GET",
            requestUri: "/prefetchSchedule/{PlaybackConfigurationName}/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "PlaybackConfigurationName"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              },
              PlaybackConfigurationName: {
                location: "uri",
                locationName: "PlaybackConfigurationName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Consumption: {
                shape: "Sw"
              },
              Name: {},
              PlaybackConfigurationName: {},
              Retrieval: {
                shape: "S10"
              },
              StreamId: {}
            }
          }
        },
        ListAlerts: {
          http: {
            method: "GET",
            requestUri: "/alerts",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              ResourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AlertCode",
                    "AlertMessage",
                    "LastModifiedTime",
                    "RelatedResourceArns",
                    "ResourceArn"
                  ],
                  members: {
                    AlertCode: {},
                    AlertMessage: {},
                    Category: {},
                    LastModifiedTime: {
                      shape: "Sn"
                    },
                    RelatedResourceArns: {
                      shape: "S3n"
                    },
                    ResourceArn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListChannels: {
          http: {
            method: "GET",
            requestUri: "/channels",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Arn",
                    "ChannelName",
                    "ChannelState",
                    "LogConfiguration",
                    "Outputs",
                    "PlaybackMode",
                    "Tier"
                  ],
                  members: {
                    Arn: {},
                    ChannelName: {},
                    ChannelState: {},
                    CreationTime: {
                      shape: "Sn"
                    },
                    FillerSlate: {
                      shape: "Sa"
                    },
                    LastModifiedTime: {
                      shape: "Sn"
                    },
                    LogConfiguration: {
                      shape: "S2d"
                    },
                    Outputs: {
                      shape: "So"
                    },
                    PlaybackMode: {},
                    Tags: {
                      shape: "Si",
                      locationName: "tags"
                    },
                    Tier: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListLiveSources: {
          http: {
            method: "GET",
            requestUri: "/sourceLocation/{SourceLocationName}/liveSources",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SourceLocationName"
            ],
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              SourceLocationName: {
                location: "uri",
                locationName: "SourceLocationName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Arn",
                    "HttpPackageConfigurations",
                    "LiveSourceName",
                    "SourceLocationName"
                  ],
                  members: {
                    Arn: {},
                    CreationTime: {
                      shape: "Sn"
                    },
                    HttpPackageConfigurations: {
                      shape: "Sr"
                    },
                    LastModifiedTime: {
                      shape: "Sn"
                    },
                    LiveSourceName: {},
                    SourceLocationName: {},
                    Tags: {
                      shape: "Si",
                      locationName: "tags"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPlaybackConfigurations: {
          http: {
            method: "GET",
            requestUri: "/playbackConfigurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AdDecisionServerUrl: {},
                    AvailSuppression: {
                      shape: "S31"
                    },
                    Bumper: {
                      shape: "S34"
                    },
                    CdnConfiguration: {
                      shape: "S35"
                    },
                    ConfigurationAliases: {
                      shape: "S36"
                    },
                    DashConfiguration: {
                      shape: "S37"
                    },
                    HlsConfiguration: {
                      shape: "S39"
                    },
                    LivePreRollConfiguration: {
                      shape: "S3a"
                    },
                    LogConfiguration: {
                      shape: "S3b"
                    },
                    ManifestProcessingRules: {
                      shape: "S3c"
                    },
                    Name: {},
                    PersonalizationThresholdSeconds: {
                      type: "integer"
                    },
                    PlaybackConfigurationArn: {},
                    PlaybackEndpointPrefix: {},
                    SessionInitializationEndpointPrefix: {},
                    SlateAdUrl: {},
                    Tags: {
                      shape: "Si",
                      locationName: "tags"
                    },
                    TranscodeProfileName: {},
                    VideoContentSourceUrl: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPrefetchSchedules: {
          http: {
            requestUri: "/prefetchSchedule/{PlaybackConfigurationName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "PlaybackConfigurationName"
            ],
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              PlaybackConfigurationName: {
                location: "uri",
                locationName: "PlaybackConfigurationName"
              },
              StreamId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Arn",
                    "Consumption",
                    "Name",
                    "PlaybackConfigurationName",
                    "Retrieval"
                  ],
                  members: {
                    Arn: {},
                    Consumption: {
                      shape: "Sw"
                    },
                    Name: {},
                    PlaybackConfigurationName: {},
                    Retrieval: {
                      shape: "S10"
                    },
                    StreamId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSourceLocations: {
          http: {
            method: "GET",
            requestUri: "/sourceLocations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Arn",
                    "HttpConfiguration",
                    "SourceLocationName"
                  ],
                  members: {
                    AccessConfiguration: {
                      shape: "S1l"
                    },
                    Arn: {},
                    CreationTime: {
                      shape: "Sn"
                    },
                    DefaultSegmentDeliveryConfiguration: {
                      shape: "S1o"
                    },
                    HttpConfiguration: {
                      shape: "S1p"
                    },
                    LastModifiedTime: {
                      shape: "Sn"
                    },
                    SegmentDeliveryConfigurations: {
                      shape: "S1q"
                    },
                    SourceLocationName: {},
                    Tags: {
                      shape: "Si",
                      locationName: "tags"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Si",
                locationName: "tags"
              }
            }
          }
        },
        ListVodSources: {
          http: {
            method: "GET",
            requestUri: "/sourceLocation/{SourceLocationName}/vodSources",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SourceLocationName"
            ],
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              SourceLocationName: {
                location: "uri",
                locationName: "SourceLocationName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Arn",
                    "HttpPackageConfigurations",
                    "SourceLocationName",
                    "VodSourceName"
                  ],
                  members: {
                    Arn: {},
                    CreationTime: {
                      shape: "Sn"
                    },
                    HttpPackageConfigurations: {
                      shape: "Sr"
                    },
                    LastModifiedTime: {
                      shape: "Sn"
                    },
                    SourceLocationName: {},
                    Tags: {
                      shape: "Si",
                      locationName: "tags"
                    },
                    VodSourceName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        PutChannelPolicy: {
          http: {
            method: "PUT",
            requestUri: "/channel/{ChannelName}/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelName",
              "Policy"
            ],
            members: {
              ChannelName: {
                location: "uri",
                locationName: "ChannelName"
              },
              Policy: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        PutPlaybackConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/playbackConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              AdDecisionServerUrl: {},
              AvailSuppression: {
                shape: "S31"
              },
              Bumper: {
                shape: "S34"
              },
              CdnConfiguration: {
                shape: "S35"
              },
              ConfigurationAliases: {
                type: "map",
                key: {},
                value: {
                  shape: "Si"
                }
              },
              DashConfiguration: {
                type: "structure",
                members: {
                  MpdLocation: {},
                  OriginManifestType: {}
                }
              },
              LivePreRollConfiguration: {
                shape: "S3a"
              },
              ManifestProcessingRules: {
                shape: "S3c"
              },
              Name: {},
              PersonalizationThresholdSeconds: {
                type: "integer"
              },
              SlateAdUrl: {},
              Tags: {
                shape: "Si",
                locationName: "tags"
              },
              TranscodeProfileName: {},
              VideoContentSourceUrl: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AdDecisionServerUrl: {},
              AvailSuppression: {
                shape: "S31"
              },
              Bumper: {
                shape: "S34"
              },
              CdnConfiguration: {
                shape: "S35"
              },
              ConfigurationAliases: {
                shape: "S36"
              },
              DashConfiguration: {
                shape: "S37"
              },
              HlsConfiguration: {
                shape: "S39"
              },
              LivePreRollConfiguration: {
                shape: "S3a"
              },
              LogConfiguration: {
                shape: "S3b"
              },
              ManifestProcessingRules: {
                shape: "S3c"
              },
              Name: {},
              PersonalizationThresholdSeconds: {
                type: "integer"
              },
              PlaybackConfigurationArn: {},
              PlaybackEndpointPrefix: {},
              SessionInitializationEndpointPrefix: {},
              SlateAdUrl: {},
              Tags: {
                shape: "Si",
                locationName: "tags"
              },
              TranscodeProfileName: {},
              VideoContentSourceUrl: {}
            }
          },
          idempotent: true
        },
        StartChannel: {
          http: {
            method: "PUT",
            requestUri: "/channel/{ChannelName}/start",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelName"
            ],
            members: {
              ChannelName: {
                location: "uri",
                locationName: "ChannelName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        StopChannel: {
          http: {
            method: "PUT",
            requestUri: "/channel/{ChannelName}/stop",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelName"
            ],
            members: {
              ChannelName: {
                location: "uri",
                locationName: "ChannelName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        TagResource: {
          http: {
            requestUri: "/tags/{ResourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "Si",
                locationName: "tags"
              }
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              TagKeys: {
                shape: "S3n",
                location: "querystring",
                locationName: "tagKeys"
              }
            }
          },
          idempotent: true
        },
        UpdateChannel: {
          http: {
            method: "PUT",
            requestUri: "/channel/{ChannelName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelName",
              "Outputs"
            ],
            members: {
              ChannelName: {
                location: "uri",
                locationName: "ChannelName"
              },
              FillerSlate: {
                shape: "Sa"
              },
              Outputs: {
                shape: "Sb"
              },
              TimeShiftConfiguration: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              ChannelName: {},
              ChannelState: {},
              CreationTime: {
                shape: "Sn"
              },
              FillerSlate: {
                shape: "Sa"
              },
              LastModifiedTime: {
                shape: "Sn"
              },
              Outputs: {
                shape: "So"
              },
              PlaybackMode: {},
              Tags: {
                shape: "Si",
                locationName: "tags"
              },
              Tier: {},
              TimeShiftConfiguration: {
                shape: "Sk"
              }
            }
          },
          idempotent: true
        },
        UpdateLiveSource: {
          http: {
            method: "PUT",
            requestUri: "/sourceLocation/{SourceLocationName}/liveSource/{LiveSourceName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "HttpPackageConfigurations",
              "LiveSourceName",
              "SourceLocationName"
            ],
            members: {
              HttpPackageConfigurations: {
                shape: "Sr"
              },
              LiveSourceName: {
                location: "uri",
                locationName: "LiveSourceName"
              },
              SourceLocationName: {
                location: "uri",
                locationName: "SourceLocationName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTime: {
                shape: "Sn"
              },
              HttpPackageConfigurations: {
                shape: "Sr"
              },
              LastModifiedTime: {
                shape: "Sn"
              },
              LiveSourceName: {},
              SourceLocationName: {},
              Tags: {
                shape: "Si",
                locationName: "tags"
              }
            }
          },
          idempotent: true
        },
        UpdateProgram: {
          http: {
            method: "PUT",
            requestUri: "/channel/{ChannelName}/program/{ProgramName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelName",
              "ProgramName",
              "ScheduleConfiguration"
            ],
            members: {
              AdBreaks: {
                shape: "S13"
              },
              ChannelName: {
                location: "uri",
                locationName: "ChannelName"
              },
              ProgramName: {
                location: "uri",
                locationName: "ProgramName"
              },
              ScheduleConfiguration: {
                type: "structure",
                members: {
                  ClipRange: {
                    shape: "S1g"
                  },
                  Transition: {
                    type: "structure",
                    members: {
                      DurationMillis: {
                        type: "long"
                      },
                      ScheduledStartTimeMillis: {
                        type: "long"
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AdBreaks: {
                shape: "S13"
              },
              Arn: {},
              ChannelName: {},
              ClipRange: {
                shape: "S1g"
              },
              CreationTime: {
                shape: "Sn"
              },
              DurationMillis: {
                type: "long"
              },
              LiveSourceName: {},
              ProgramName: {},
              ScheduledStartTime: {
                shape: "Sn"
              },
              SourceLocationName: {},
              VodSourceName: {}
            }
          },
          idempotent: true
        },
        UpdateSourceLocation: {
          http: {
            method: "PUT",
            requestUri: "/sourceLocation/{SourceLocationName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "HttpConfiguration",
              "SourceLocationName"
            ],
            members: {
              AccessConfiguration: {
                shape: "S1l"
              },
              DefaultSegmentDeliveryConfiguration: {
                shape: "S1o"
              },
              HttpConfiguration: {
                shape: "S1p"
              },
              SegmentDeliveryConfigurations: {
                shape: "S1q"
              },
              SourceLocationName: {
                location: "uri",
                locationName: "SourceLocationName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccessConfiguration: {
                shape: "S1l"
              },
              Arn: {},
              CreationTime: {
                shape: "Sn"
              },
              DefaultSegmentDeliveryConfiguration: {
                shape: "S1o"
              },
              HttpConfiguration: {
                shape: "S1p"
              },
              LastModifiedTime: {
                shape: "Sn"
              },
              SegmentDeliveryConfigurations: {
                shape: "S1q"
              },
              SourceLocationName: {},
              Tags: {
                shape: "Si",
                locationName: "tags"
              }
            }
          },
          idempotent: true
        },
        UpdateVodSource: {
          http: {
            method: "PUT",
            requestUri: "/sourceLocation/{SourceLocationName}/vodSource/{VodSourceName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "HttpPackageConfigurations",
              "SourceLocationName",
              "VodSourceName"
            ],
            members: {
              HttpPackageConfigurations: {
                shape: "Sr"
              },
              SourceLocationName: {
                location: "uri",
                locationName: "SourceLocationName"
              },
              VodSourceName: {
                location: "uri",
                locationName: "VodSourceName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTime: {
                shape: "Sn"
              },
              HttpPackageConfigurations: {
                shape: "Sr"
              },
              LastModifiedTime: {
                shape: "Sn"
              },
              SourceLocationName: {},
              Tags: {
                shape: "Si",
                locationName: "tags"
              },
              VodSourceName: {}
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {}
        },
        Sa: {
          type: "structure",
          members: {
            SourceLocationName: {},
            VodSourceName: {}
          }
        },
        Sb: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ManifestName",
              "SourceGroup"
            ],
            members: {
              DashPlaylistSettings: {
                shape: "Sd"
              },
              HlsPlaylistSettings: {
                shape: "Se"
              },
              ManifestName: {},
              SourceGroup: {}
            }
          }
        },
        Sd: {
          type: "structure",
          members: {
            ManifestWindowSeconds: {
              type: "integer"
            },
            MinBufferTimeSeconds: {
              type: "integer"
            },
            MinUpdatePeriodSeconds: {
              type: "integer"
            },
            SuggestedPresentationDelaySeconds: {
              type: "integer"
            }
          }
        },
        Se: {
          type: "structure",
          members: {
            AdMarkupType: {
              type: "list",
              member: {}
            },
            ManifestWindowSeconds: {
              type: "integer"
            }
          }
        },
        Si: {
          type: "map",
          key: {},
          value: {}
        },
        Sk: {
          type: "structure",
          required: [
            "MaxTimeDelaySeconds"
          ],
          members: {
            MaxTimeDelaySeconds: {
              type: "integer"
            }
          }
        },
        Sn: {
          type: "timestamp",
          timestampFormat: "unixTimestamp"
        },
        So: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ManifestName",
              "PlaybackUrl",
              "SourceGroup"
            ],
            members: {
              DashPlaylistSettings: {
                shape: "Sd"
              },
              HlsPlaylistSettings: {
                shape: "Se"
              },
              ManifestName: {},
              PlaybackUrl: {},
              SourceGroup: {}
            }
          }
        },
        Sr: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Path",
              "SourceGroup",
              "Type"
            ],
            members: {
              Path: {},
              SourceGroup: {},
              Type: {}
            }
          }
        },
        Sw: {
          type: "structure",
          required: [
            "EndTime"
          ],
          members: {
            AvailMatchingCriteria: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "DynamicVariable",
                  "Operator"
                ],
                members: {
                  DynamicVariable: {},
                  Operator: {}
                }
              }
            },
            EndTime: {
              shape: "Sn"
            },
            StartTime: {
              shape: "Sn"
            }
          }
        },
        S10: {
          type: "structure",
          required: [
            "EndTime"
          ],
          members: {
            DynamicVariables: {
              shape: "Si"
            },
            EndTime: {
              shape: "Sn"
            },
            StartTime: {
              shape: "Sn"
            }
          }
        },
        S13: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AdBreakMetadata: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key",
                    "Value"
                  ],
                  members: {
                    Key: {},
                    Value: {}
                  }
                }
              },
              MessageType: {},
              OffsetMillis: {
                type: "long"
              },
              Slate: {
                shape: "Sa"
              },
              SpliceInsertMessage: {
                type: "structure",
                members: {
                  AvailNum: {
                    type: "integer"
                  },
                  AvailsExpected: {
                    type: "integer"
                  },
                  SpliceEventId: {
                    type: "integer"
                  },
                  UniqueProgramId: {
                    type: "integer"
                  }
                }
              },
              TimeSignalMessage: {
                type: "structure",
                members: {
                  SegmentationDescriptors: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        SegmentNum: {
                          type: "integer"
                        },
                        SegmentationEventId: {
                          type: "integer"
                        },
                        SegmentationTypeId: {
                          type: "integer"
                        },
                        SegmentationUpid: {},
                        SegmentationUpidType: {
                          type: "integer"
                        },
                        SegmentsExpected: {
                          type: "integer"
                        },
                        SubSegmentNum: {
                          type: "integer"
                        },
                        SubSegmentsExpected: {
                          type: "integer"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S1g: {
          type: "structure",
          required: [
            "EndOffsetMillis"
          ],
          members: {
            EndOffsetMillis: {
              type: "long"
            }
          }
        },
        S1l: {
          type: "structure",
          members: {
            AccessType: {},
            SecretsManagerAccessTokenConfiguration: {
              type: "structure",
              members: {
                HeaderName: {},
                SecretArn: {},
                SecretStringKey: {}
              }
            }
          }
        },
        S1o: {
          type: "structure",
          members: {
            BaseUrl: {}
          }
        },
        S1p: {
          type: "structure",
          required: [
            "BaseUrl"
          ],
          members: {
            BaseUrl: {}
          }
        },
        S1q: {
          type: "list",
          member: {
            type: "structure",
            members: {
              BaseUrl: {},
              Name: {}
            }
          }
        },
        S2d: {
          type: "structure",
          members: {
            LogTypes: {
              shape: "S3"
            }
          }
        },
        S31: {
          type: "structure",
          members: {
            FillPolicy: {},
            Mode: {},
            Value: {}
          }
        },
        S34: {
          type: "structure",
          members: {
            EndUrl: {},
            StartUrl: {}
          }
        },
        S35: {
          type: "structure",
          members: {
            AdSegmentUrlPrefix: {},
            ContentSegmentUrlPrefix: {}
          }
        },
        S36: {
          type: "map",
          key: {},
          value: {
            shape: "Si"
          }
        },
        S37: {
          type: "structure",
          members: {
            ManifestEndpointPrefix: {},
            MpdLocation: {},
            OriginManifestType: {}
          }
        },
        S39: {
          type: "structure",
          members: {
            ManifestEndpointPrefix: {}
          }
        },
        S3a: {
          type: "structure",
          members: {
            AdDecisionServerUrl: {},
            MaxDurationSeconds: {
              type: "integer"
            }
          }
        },
        S3b: {
          type: "structure",
          required: [
            "PercentEnabled"
          ],
          members: {
            PercentEnabled: {
              type: "integer"
            }
          }
        },
        S3c: {
          type: "structure",
          members: {
            AdMarkerPassthrough: {
              type: "structure",
              members: {
                Enabled: {
                  type: "boolean"
                }
              }
            }
          }
        },
        S3n: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/mediatailor-2018-04-23.paginators.json
var require_mediatailor_2018_04_23_paginators = __commonJS({
  "node_modules/aws-sdk/apis/mediatailor-2018-04-23.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetChannelSchedule: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Items"
        },
        ListAlerts: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Items"
        },
        ListChannels: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Items"
        },
        ListLiveSources: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Items"
        },
        ListPlaybackConfigurations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Items"
        },
        ListPrefetchSchedules: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Items"
        },
        ListSourceLocations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Items"
        },
        ListVodSources: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/mediatailor.js
var require_mediatailor = __commonJS({
  "node_modules/aws-sdk/clients/mediatailor.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["mediatailor"] = {};
    AWS2.MediaTailor = Service.defineService("mediatailor", ["2018-04-23"]);
    Object.defineProperty(apiLoader.services["mediatailor"], "2018-04-23", {
      get: function get() {
        var model = require_mediatailor_2018_04_23_min();
        model.paginators = require_mediatailor_2018_04_23_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.MediaTailor;
  }
});

// node_modules/aws-sdk/apis/eks-2017-11-01.min.json
var require_eks_2017_11_01_min = __commonJS({
  "node_modules/aws-sdk/apis/eks-2017-11-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-11-01",
        endpointPrefix: "eks",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Amazon EKS",
        serviceFullName: "Amazon Elastic Kubernetes Service",
        serviceId: "EKS",
        signatureVersion: "v4",
        signingName: "eks",
        uid: "eks-2017-11-01"
      },
      operations: {
        AssociateAccessPolicy: {
          http: {
            requestUri: "/clusters/{name}/access-entries/{principalArn}/access-policies"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "principalArn",
              "policyArn",
              "accessScope"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              principalArn: {
                location: "uri",
                locationName: "principalArn"
              },
              policyArn: {},
              accessScope: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              clusterName: {},
              principalArn: {},
              associatedAccessPolicy: {
                shape: "S7"
              }
            }
          }
        },
        AssociateEncryptionConfig: {
          http: {
            requestUri: "/clusters/{name}/encryption-config/associate"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "encryptionConfig"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              encryptionConfig: {
                shape: "Sa"
              },
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              update: {
                shape: "Se"
              }
            }
          }
        },
        AssociateIdentityProviderConfig: {
          http: {
            requestUri: "/clusters/{name}/identity-provider-configs/associate"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "oidc"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              oidc: {
                type: "structure",
                required: [
                  "identityProviderConfigName",
                  "issuerUrl",
                  "clientId"
                ],
                members: {
                  identityProviderConfigName: {},
                  issuerUrl: {},
                  clientId: {},
                  usernameClaim: {},
                  usernamePrefix: {},
                  groupsClaim: {},
                  groupsPrefix: {},
                  requiredClaims: {
                    shape: "Sp"
                  }
                }
              },
              tags: {
                shape: "Ss"
              },
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              update: {
                shape: "Se"
              },
              tags: {
                shape: "Ss"
              }
            }
          }
        },
        CreateAccessEntry: {
          http: {
            requestUri: "/clusters/{name}/access-entries"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "principalArn"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              principalArn: {},
              kubernetesGroups: {
                shape: "S5"
              },
              tags: {
                shape: "Ss"
              },
              clientRequestToken: {
                idempotencyToken: true
              },
              username: {},
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              accessEntry: {
                shape: "Sy"
              }
            }
          }
        },
        CreateAddon: {
          http: {
            requestUri: "/clusters/{name}/addons"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "addonName"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              addonName: {},
              addonVersion: {},
              serviceAccountRoleArn: {},
              resolveConflicts: {},
              clientRequestToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "Ss"
              },
              configurationValues: {}
            }
          },
          output: {
            type: "structure",
            members: {
              addon: {
                shape: "S14"
              }
            }
          }
        },
        CreateCluster: {
          http: {
            requestUri: "/clusters"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "roleArn",
              "resourcesVpcConfig"
            ],
            members: {
              name: {},
              version: {},
              roleArn: {},
              resourcesVpcConfig: {
                shape: "S1c"
              },
              kubernetesNetworkConfig: {
                type: "structure",
                members: {
                  serviceIpv4Cidr: {},
                  ipFamily: {}
                }
              },
              logging: {
                shape: "S1g"
              },
              clientRequestToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "Ss"
              },
              encryptionConfig: {
                shape: "Sa"
              },
              outpostConfig: {
                type: "structure",
                required: [
                  "outpostArns",
                  "controlPlaneInstanceType"
                ],
                members: {
                  outpostArns: {
                    shape: "S5"
                  },
                  controlPlaneInstanceType: {},
                  controlPlanePlacement: {
                    type: "structure",
                    members: {
                      groupName: {}
                    }
                  }
                }
              },
              accessConfig: {
                type: "structure",
                members: {
                  bootstrapClusterCreatorAdminPermissions: {
                    type: "boolean"
                  },
                  authenticationMode: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              cluster: {
                shape: "S1q"
              }
            }
          }
        },
        CreateEksAnywhereSubscription: {
          http: {
            requestUri: "/eks-anywhere-subscriptions"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "term"
            ],
            members: {
              name: {},
              term: {
                shape: "S28"
              },
              licenseQuantity: {
                type: "integer"
              },
              licenseType: {},
              autoRenew: {
                type: "boolean"
              },
              clientRequestToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "Ss"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              subscription: {
                shape: "S2d"
              }
            }
          }
        },
        CreateFargateProfile: {
          http: {
            requestUri: "/clusters/{name}/fargate-profiles"
          },
          input: {
            type: "structure",
            required: [
              "fargateProfileName",
              "clusterName",
              "podExecutionRoleArn"
            ],
            members: {
              fargateProfileName: {},
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              podExecutionRoleArn: {},
              subnets: {
                shape: "S5"
              },
              selectors: {
                shape: "S2f"
              },
              clientRequestToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "Ss"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              fargateProfile: {
                shape: "S2j"
              }
            }
          }
        },
        CreateNodegroup: {
          http: {
            requestUri: "/clusters/{name}/node-groups"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "nodegroupName",
              "subnets",
              "nodeRole"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              nodegroupName: {},
              scalingConfig: {
                shape: "S2m"
              },
              diskSize: {
                type: "integer"
              },
              subnets: {
                shape: "S5"
              },
              instanceTypes: {
                shape: "S5"
              },
              amiType: {},
              remoteAccess: {
                shape: "S2r"
              },
              nodeRole: {},
              labels: {
                shape: "S2s"
              },
              taints: {
                shape: "S2v"
              },
              tags: {
                shape: "Ss"
              },
              clientRequestToken: {
                idempotencyToken: true
              },
              launchTemplate: {
                shape: "S30"
              },
              updateConfig: {
                shape: "S31"
              },
              capacityType: {},
              version: {},
              releaseVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              nodegroup: {
                shape: "S36"
              }
            }
          }
        },
        CreatePodIdentityAssociation: {
          http: {
            requestUri: "/clusters/{name}/pod-identity-associations"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "namespace",
              "serviceAccount",
              "roleArn"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              namespace: {},
              serviceAccount: {},
              roleArn: {},
              clientRequestToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "Ss"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              association: {
                shape: "S3h"
              }
            }
          }
        },
        DeleteAccessEntry: {
          http: {
            method: "DELETE",
            requestUri: "/clusters/{name}/access-entries/{principalArn}"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "principalArn"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              principalArn: {
                location: "uri",
                locationName: "principalArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAddon: {
          http: {
            method: "DELETE",
            requestUri: "/clusters/{name}/addons/{addonName}"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "addonName"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              addonName: {
                location: "uri",
                locationName: "addonName"
              },
              preserve: {
                location: "querystring",
                locationName: "preserve",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              addon: {
                shape: "S14"
              }
            }
          }
        },
        DeleteCluster: {
          http: {
            method: "DELETE",
            requestUri: "/clusters/{name}"
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              cluster: {
                shape: "S1q"
              }
            }
          }
        },
        DeleteEksAnywhereSubscription: {
          http: {
            method: "DELETE",
            requestUri: "/eks-anywhere-subscriptions/{id}"
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              subscription: {
                shape: "S2d"
              }
            }
          }
        },
        DeleteFargateProfile: {
          http: {
            method: "DELETE",
            requestUri: "/clusters/{name}/fargate-profiles/{fargateProfileName}"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "fargateProfileName"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              fargateProfileName: {
                location: "uri",
                locationName: "fargateProfileName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              fargateProfile: {
                shape: "S2j"
              }
            }
          }
        },
        DeleteNodegroup: {
          http: {
            method: "DELETE",
            requestUri: "/clusters/{name}/node-groups/{nodegroupName}"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "nodegroupName"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              nodegroupName: {
                location: "uri",
                locationName: "nodegroupName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nodegroup: {
                shape: "S36"
              }
            }
          }
        },
        DeletePodIdentityAssociation: {
          http: {
            method: "DELETE",
            requestUri: "/clusters/{name}/pod-identity-associations/{associationId}"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "associationId"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              associationId: {
                location: "uri",
                locationName: "associationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              association: {
                shape: "S3h"
              }
            }
          }
        },
        DeregisterCluster: {
          http: {
            method: "DELETE",
            requestUri: "/cluster-registrations/{name}"
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              cluster: {
                shape: "S1q"
              }
            }
          }
        },
        DescribeAccessEntry: {
          http: {
            method: "GET",
            requestUri: "/clusters/{name}/access-entries/{principalArn}"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "principalArn"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              principalArn: {
                location: "uri",
                locationName: "principalArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              accessEntry: {
                shape: "Sy"
              }
            }
          }
        },
        DescribeAddon: {
          http: {
            method: "GET",
            requestUri: "/clusters/{name}/addons/{addonName}"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "addonName"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              addonName: {
                location: "uri",
                locationName: "addonName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              addon: {
                shape: "S14"
              }
            }
          }
        },
        DescribeAddonConfiguration: {
          http: {
            method: "GET",
            requestUri: "/addons/configuration-schemas"
          },
          input: {
            type: "structure",
            required: [
              "addonName",
              "addonVersion"
            ],
            members: {
              addonName: {
                location: "querystring",
                locationName: "addonName"
              },
              addonVersion: {
                location: "querystring",
                locationName: "addonVersion"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              addonName: {},
              addonVersion: {},
              configurationSchema: {}
            }
          }
        },
        DescribeAddonVersions: {
          http: {
            method: "GET",
            requestUri: "/addons/supported-versions"
          },
          input: {
            type: "structure",
            members: {
              kubernetesVersion: {
                location: "querystring",
                locationName: "kubernetesVersion"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              addonName: {
                location: "querystring",
                locationName: "addonName"
              },
              types: {
                shape: "S5",
                location: "querystring",
                locationName: "types"
              },
              publishers: {
                shape: "S5",
                location: "querystring",
                locationName: "publishers"
              },
              owners: {
                shape: "S5",
                location: "querystring",
                locationName: "owners"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              addons: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    addonName: {},
                    type: {},
                    addonVersions: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          addonVersion: {},
                          architecture: {
                            shape: "S5"
                          },
                          compatibilities: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                clusterVersion: {},
                                platformVersions: {
                                  shape: "S5"
                                },
                                defaultVersion: {
                                  type: "boolean"
                                }
                              }
                            }
                          },
                          requiresConfiguration: {
                            type: "boolean"
                          }
                        }
                      }
                    },
                    publisher: {},
                    owner: {},
                    marketplaceInformation: {
                      shape: "S1a"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeCluster: {
          http: {
            method: "GET",
            requestUri: "/clusters/{name}"
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              cluster: {
                shape: "S1q"
              }
            }
          }
        },
        DescribeEksAnywhereSubscription: {
          http: {
            method: "GET",
            requestUri: "/eks-anywhere-subscriptions/{id}"
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              subscription: {
                shape: "S2d"
              }
            }
          }
        },
        DescribeFargateProfile: {
          http: {
            method: "GET",
            requestUri: "/clusters/{name}/fargate-profiles/{fargateProfileName}"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "fargateProfileName"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              fargateProfileName: {
                location: "uri",
                locationName: "fargateProfileName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              fargateProfile: {
                shape: "S2j"
              }
            }
          }
        },
        DescribeIdentityProviderConfig: {
          http: {
            requestUri: "/clusters/{name}/identity-provider-configs/describe"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "identityProviderConfig"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              identityProviderConfig: {
                shape: "S4k"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              identityProviderConfig: {
                type: "structure",
                members: {
                  oidc: {
                    type: "structure",
                    members: {
                      identityProviderConfigName: {},
                      identityProviderConfigArn: {},
                      clusterName: {},
                      issuerUrl: {},
                      clientId: {},
                      usernameClaim: {},
                      usernamePrefix: {},
                      groupsClaim: {},
                      groupsPrefix: {},
                      requiredClaims: {
                        shape: "Sp"
                      },
                      tags: {
                        shape: "Ss"
                      },
                      status: {}
                    }
                  }
                }
              }
            }
          }
        },
        DescribeInsight: {
          http: {
            method: "GET",
            requestUri: "/clusters/{name}/insights/{id}"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "id"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              insight: {
                type: "structure",
                members: {
                  id: {},
                  name: {},
                  category: {},
                  kubernetesVersion: {},
                  lastRefreshTime: {
                    type: "timestamp"
                  },
                  lastTransitionTime: {
                    type: "timestamp"
                  },
                  description: {},
                  insightStatus: {
                    shape: "S4t"
                  },
                  recommendation: {},
                  additionalInfo: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  resources: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        insightStatus: {
                          shape: "S4t"
                        },
                        kubernetesResourceUri: {},
                        arn: {}
                      }
                    }
                  },
                  categorySpecificSummary: {
                    type: "structure",
                    members: {
                      deprecationDetails: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            usage: {},
                            replacedWith: {},
                            stopServingVersion: {},
                            startServingReplacementVersion: {},
                            clientStats: {
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  userAgent: {},
                                  numberOfRequestsLast30Days: {
                                    type: "integer"
                                  },
                                  lastRequestTime: {
                                    type: "timestamp"
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeNodegroup: {
          http: {
            method: "GET",
            requestUri: "/clusters/{name}/node-groups/{nodegroupName}"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "nodegroupName"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              nodegroupName: {
                location: "uri",
                locationName: "nodegroupName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nodegroup: {
                shape: "S36"
              }
            }
          }
        },
        DescribePodIdentityAssociation: {
          http: {
            method: "GET",
            requestUri: "/clusters/{name}/pod-identity-associations/{associationId}"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "associationId"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              associationId: {
                location: "uri",
                locationName: "associationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              association: {
                shape: "S3h"
              }
            }
          }
        },
        DescribeUpdate: {
          http: {
            method: "GET",
            requestUri: "/clusters/{name}/updates/{updateId}"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "updateId"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              updateId: {
                location: "uri",
                locationName: "updateId"
              },
              nodegroupName: {
                location: "querystring",
                locationName: "nodegroupName"
              },
              addonName: {
                location: "querystring",
                locationName: "addonName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              update: {
                shape: "Se"
              }
            }
          }
        },
        DisassociateAccessPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/clusters/{name}/access-entries/{principalArn}/access-policies/{policyArn}"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "principalArn",
              "policyArn"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              principalArn: {
                location: "uri",
                locationName: "principalArn"
              },
              policyArn: {
                location: "uri",
                locationName: "policyArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateIdentityProviderConfig: {
          http: {
            requestUri: "/clusters/{name}/identity-provider-configs/disassociate"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "identityProviderConfig"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              identityProviderConfig: {
                shape: "S4k"
              },
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              update: {
                shape: "Se"
              }
            }
          }
        },
        ListAccessEntries: {
          http: {
            method: "GET",
            requestUri: "/clusters/{name}/access-entries"
          },
          input: {
            type: "structure",
            required: [
              "clusterName"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              associatedPolicyArn: {
                location: "querystring",
                locationName: "associatedPolicyArn"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              accessEntries: {
                shape: "S5"
              },
              nextToken: {}
            }
          }
        },
        ListAccessPolicies: {
          http: {
            method: "GET",
            requestUri: "/access-policies"
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              accessPolicies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    arn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAddons: {
          http: {
            method: "GET",
            requestUri: "/clusters/{name}/addons"
          },
          input: {
            type: "structure",
            required: [
              "clusterName"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              addons: {
                shape: "S5"
              },
              nextToken: {}
            }
          }
        },
        ListAssociatedAccessPolicies: {
          http: {
            method: "GET",
            requestUri: "/clusters/{name}/access-entries/{principalArn}/access-policies"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "principalArn"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              principalArn: {
                location: "uri",
                locationName: "principalArn"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              clusterName: {},
              principalArn: {},
              nextToken: {},
              associatedAccessPolicies: {
                type: "list",
                member: {
                  shape: "S7"
                }
              }
            }
          }
        },
        ListClusters: {
          http: {
            method: "GET",
            requestUri: "/clusters"
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              include: {
                location: "querystring",
                locationName: "include",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              clusters: {
                shape: "S5"
              },
              nextToken: {}
            }
          }
        },
        ListEksAnywhereSubscriptions: {
          http: {
            method: "GET",
            requestUri: "/eks-anywhere-subscriptions"
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              includeStatus: {
                location: "querystring",
                locationName: "includeStatus",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              subscriptions: {
                type: "list",
                member: {
                  shape: "S2d"
                }
              },
              nextToken: {}
            }
          }
        },
        ListFargateProfiles: {
          http: {
            method: "GET",
            requestUri: "/clusters/{name}/fargate-profiles"
          },
          input: {
            type: "structure",
            required: [
              "clusterName"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              fargateProfileNames: {
                shape: "S5"
              },
              nextToken: {}
            }
          }
        },
        ListIdentityProviderConfigs: {
          http: {
            method: "GET",
            requestUri: "/clusters/{name}/identity-provider-configs"
          },
          input: {
            type: "structure",
            required: [
              "clusterName"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              identityProviderConfigs: {
                type: "list",
                member: {
                  shape: "S4k"
                }
              },
              nextToken: {}
            }
          }
        },
        ListInsights: {
          http: {
            requestUri: "/clusters/{name}/insights"
          },
          input: {
            type: "structure",
            required: [
              "clusterName"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              filter: {
                type: "structure",
                members: {
                  categories: {
                    type: "list",
                    member: {}
                  },
                  kubernetesVersions: {
                    shape: "S5"
                  },
                  statuses: {
                    type: "list",
                    member: {}
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              insights: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    name: {},
                    category: {},
                    kubernetesVersion: {},
                    lastRefreshTime: {
                      type: "timestamp"
                    },
                    lastTransitionTime: {
                      type: "timestamp"
                    },
                    description: {},
                    insightStatus: {
                      shape: "S4t"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListNodegroups: {
          http: {
            method: "GET",
            requestUri: "/clusters/{name}/node-groups"
          },
          input: {
            type: "structure",
            required: [
              "clusterName"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nodegroups: {
                shape: "S5"
              },
              nextToken: {}
            }
          }
        },
        ListPodIdentityAssociations: {
          http: {
            method: "GET",
            requestUri: "/clusters/{name}/pod-identity-associations"
          },
          input: {
            type: "structure",
            required: [
              "clusterName"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              serviceAccount: {
                location: "querystring",
                locationName: "serviceAccount"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              associations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    clusterName: {},
                    namespace: {},
                    serviceAccount: {},
                    associationArn: {},
                    associationId: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Ss"
              }
            }
          }
        },
        ListUpdates: {
          http: {
            method: "GET",
            requestUri: "/clusters/{name}/updates"
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              nodegroupName: {
                location: "querystring",
                locationName: "nodegroupName"
              },
              addonName: {
                location: "querystring",
                locationName: "addonName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              updateIds: {
                shape: "S5"
              },
              nextToken: {}
            }
          }
        },
        RegisterCluster: {
          http: {
            requestUri: "/cluster-registrations"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "connectorConfig"
            ],
            members: {
              name: {},
              connectorConfig: {
                type: "structure",
                required: [
                  "roleArn",
                  "provider"
                ],
                members: {
                  roleArn: {},
                  provider: {}
                }
              },
              clientRequestToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "Ss"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              cluster: {
                shape: "S1q"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Ss"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAccessEntry: {
          http: {
            requestUri: "/clusters/{name}/access-entries/{principalArn}"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "principalArn"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              principalArn: {
                location: "uri",
                locationName: "principalArn"
              },
              kubernetesGroups: {
                shape: "S5"
              },
              clientRequestToken: {
                idempotencyToken: true
              },
              username: {}
            }
          },
          output: {
            type: "structure",
            members: {
              accessEntry: {
                shape: "Sy"
              }
            }
          }
        },
        UpdateAddon: {
          http: {
            requestUri: "/clusters/{name}/addons/{addonName}/update"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "addonName"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              addonName: {
                location: "uri",
                locationName: "addonName"
              },
              addonVersion: {},
              serviceAccountRoleArn: {},
              resolveConflicts: {},
              clientRequestToken: {
                idempotencyToken: true
              },
              configurationValues: {}
            }
          },
          output: {
            type: "structure",
            members: {
              update: {
                shape: "Se"
              }
            }
          }
        },
        UpdateClusterConfig: {
          http: {
            requestUri: "/clusters/{name}/update-config"
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              resourcesVpcConfig: {
                shape: "S1c"
              },
              logging: {
                shape: "S1g"
              },
              clientRequestToken: {
                idempotencyToken: true
              },
              accessConfig: {
                type: "structure",
                members: {
                  authenticationMode: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              update: {
                shape: "Se"
              }
            }
          }
        },
        UpdateClusterVersion: {
          http: {
            requestUri: "/clusters/{name}/updates"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "version"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              version: {},
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              update: {
                shape: "Se"
              }
            }
          }
        },
        UpdateEksAnywhereSubscription: {
          http: {
            requestUri: "/eks-anywhere-subscriptions/{id}"
          },
          input: {
            type: "structure",
            required: [
              "id",
              "autoRenew"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              autoRenew: {
                type: "boolean"
              },
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              subscription: {
                shape: "S2d"
              }
            }
          }
        },
        UpdateNodegroupConfig: {
          http: {
            requestUri: "/clusters/{name}/node-groups/{nodegroupName}/update-config"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "nodegroupName"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              nodegroupName: {
                location: "uri",
                locationName: "nodegroupName"
              },
              labels: {
                type: "structure",
                members: {
                  addOrUpdateLabels: {
                    shape: "S2s"
                  },
                  removeLabels: {
                    type: "list",
                    member: {}
                  }
                }
              },
              taints: {
                type: "structure",
                members: {
                  addOrUpdateTaints: {
                    shape: "S2v"
                  },
                  removeTaints: {
                    shape: "S2v"
                  }
                }
              },
              scalingConfig: {
                shape: "S2m"
              },
              updateConfig: {
                shape: "S31"
              },
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              update: {
                shape: "Se"
              }
            }
          }
        },
        UpdateNodegroupVersion: {
          http: {
            requestUri: "/clusters/{name}/node-groups/{nodegroupName}/update-version"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "nodegroupName"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              nodegroupName: {
                location: "uri",
                locationName: "nodegroupName"
              },
              version: {},
              releaseVersion: {},
              launchTemplate: {
                shape: "S30"
              },
              force: {
                type: "boolean"
              },
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              update: {
                shape: "Se"
              }
            }
          }
        },
        UpdatePodIdentityAssociation: {
          http: {
            requestUri: "/clusters/{name}/pod-identity-associations/{associationId}"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "associationId"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              associationId: {
                location: "uri",
                locationName: "associationId"
              },
              roleArn: {},
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              association: {
                shape: "S3h"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          members: {
            type: {},
            namespaces: {
              shape: "S5"
            }
          }
        },
        S5: {
          type: "list",
          member: {}
        },
        S7: {
          type: "structure",
          members: {
            policyArn: {},
            accessScope: {
              shape: "S3"
            },
            associatedAt: {
              type: "timestamp"
            },
            modifiedAt: {
              type: "timestamp"
            }
          }
        },
        Sa: {
          type: "list",
          member: {
            type: "structure",
            members: {
              resources: {
                shape: "S5"
              },
              provider: {
                type: "structure",
                members: {
                  keyArn: {}
                }
              }
            }
          }
        },
        Se: {
          type: "structure",
          members: {
            id: {},
            status: {},
            type: {},
            params: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  type: {},
                  value: {}
                }
              }
            },
            createdAt: {
              type: "timestamp"
            },
            errors: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  errorCode: {},
                  errorMessage: {},
                  resourceIds: {
                    shape: "S5"
                  }
                }
              }
            }
          }
        },
        Sp: {
          type: "map",
          key: {},
          value: {}
        },
        Ss: {
          type: "map",
          key: {},
          value: {}
        },
        Sy: {
          type: "structure",
          members: {
            clusterName: {},
            principalArn: {},
            kubernetesGroups: {
              shape: "S5"
            },
            accessEntryArn: {},
            createdAt: {
              type: "timestamp"
            },
            modifiedAt: {
              type: "timestamp"
            },
            tags: {
              shape: "Ss"
            },
            username: {},
            type: {}
          }
        },
        S14: {
          type: "structure",
          members: {
            addonName: {},
            clusterName: {},
            status: {},
            addonVersion: {},
            health: {
              type: "structure",
              members: {
                issues: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      code: {},
                      message: {},
                      resourceIds: {
                        shape: "S5"
                      }
                    }
                  }
                }
              }
            },
            addonArn: {},
            createdAt: {
              type: "timestamp"
            },
            modifiedAt: {
              type: "timestamp"
            },
            serviceAccountRoleArn: {},
            tags: {
              shape: "Ss"
            },
            publisher: {},
            owner: {},
            marketplaceInformation: {
              shape: "S1a"
            },
            configurationValues: {}
          }
        },
        S1a: {
          type: "structure",
          members: {
            productId: {},
            productUrl: {}
          }
        },
        S1c: {
          type: "structure",
          members: {
            subnetIds: {
              shape: "S5"
            },
            securityGroupIds: {
              shape: "S5"
            },
            endpointPublicAccess: {
              type: "boolean"
            },
            endpointPrivateAccess: {
              type: "boolean"
            },
            publicAccessCidrs: {
              shape: "S5"
            }
          }
        },
        S1g: {
          type: "structure",
          members: {
            clusterLogging: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  types: {
                    type: "list",
                    member: {}
                  },
                  enabled: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        S1q: {
          type: "structure",
          members: {
            name: {},
            arn: {},
            createdAt: {
              type: "timestamp"
            },
            version: {},
            endpoint: {},
            roleArn: {},
            resourcesVpcConfig: {
              type: "structure",
              members: {
                subnetIds: {
                  shape: "S5"
                },
                securityGroupIds: {
                  shape: "S5"
                },
                clusterSecurityGroupId: {},
                vpcId: {},
                endpointPublicAccess: {
                  type: "boolean"
                },
                endpointPrivateAccess: {
                  type: "boolean"
                },
                publicAccessCidrs: {
                  shape: "S5"
                }
              }
            },
            kubernetesNetworkConfig: {
              type: "structure",
              members: {
                serviceIpv4Cidr: {},
                serviceIpv6Cidr: {},
                ipFamily: {}
              }
            },
            logging: {
              shape: "S1g"
            },
            identity: {
              type: "structure",
              members: {
                oidc: {
                  type: "structure",
                  members: {
                    issuer: {}
                  }
                }
              }
            },
            status: {},
            certificateAuthority: {
              type: "structure",
              members: {
                data: {}
              }
            },
            clientRequestToken: {},
            platformVersion: {},
            tags: {
              shape: "Ss"
            },
            encryptionConfig: {
              shape: "Sa"
            },
            connectorConfig: {
              type: "structure",
              members: {
                activationId: {},
                activationCode: {},
                activationExpiry: {
                  type: "timestamp"
                },
                provider: {},
                roleArn: {}
              }
            },
            id: {},
            health: {
              type: "structure",
              members: {
                issues: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      code: {},
                      message: {},
                      resourceIds: {
                        shape: "S5"
                      }
                    }
                  }
                }
              }
            },
            outpostConfig: {
              type: "structure",
              required: [
                "outpostArns",
                "controlPlaneInstanceType"
              ],
              members: {
                outpostArns: {
                  shape: "S5"
                },
                controlPlaneInstanceType: {},
                controlPlanePlacement: {
                  type: "structure",
                  members: {
                    groupName: {}
                  }
                }
              }
            },
            accessConfig: {
              type: "structure",
              members: {
                bootstrapClusterCreatorAdminPermissions: {
                  type: "boolean"
                },
                authenticationMode: {}
              }
            }
          }
        },
        S28: {
          type: "structure",
          members: {
            duration: {
              type: "integer"
            },
            unit: {}
          }
        },
        S2d: {
          type: "structure",
          members: {
            id: {},
            arn: {},
            createdAt: {
              type: "timestamp"
            },
            effectiveDate: {
              type: "timestamp"
            },
            expirationDate: {
              type: "timestamp"
            },
            licenseQuantity: {
              type: "integer"
            },
            licenseType: {},
            term: {
              shape: "S28"
            },
            status: {},
            autoRenew: {
              type: "boolean"
            },
            licenseArns: {
              shape: "S5"
            },
            tags: {
              shape: "Ss"
            }
          }
        },
        S2f: {
          type: "list",
          member: {
            type: "structure",
            members: {
              namespace: {},
              labels: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        S2j: {
          type: "structure",
          members: {
            fargateProfileName: {},
            fargateProfileArn: {},
            clusterName: {},
            createdAt: {
              type: "timestamp"
            },
            podExecutionRoleArn: {},
            subnets: {
              shape: "S5"
            },
            selectors: {
              shape: "S2f"
            },
            status: {},
            tags: {
              shape: "Ss"
            }
          }
        },
        S2m: {
          type: "structure",
          members: {
            minSize: {
              type: "integer"
            },
            maxSize: {
              type: "integer"
            },
            desiredSize: {
              type: "integer"
            }
          }
        },
        S2r: {
          type: "structure",
          members: {
            ec2SshKey: {},
            sourceSecurityGroups: {
              shape: "S5"
            }
          }
        },
        S2s: {
          type: "map",
          key: {},
          value: {}
        },
        S2v: {
          type: "list",
          member: {
            type: "structure",
            members: {
              key: {},
              value: {},
              effect: {}
            }
          }
        },
        S30: {
          type: "structure",
          members: {
            name: {},
            version: {},
            id: {}
          }
        },
        S31: {
          type: "structure",
          members: {
            maxUnavailable: {
              type: "integer"
            },
            maxUnavailablePercentage: {
              type: "integer"
            }
          }
        },
        S36: {
          type: "structure",
          members: {
            nodegroupName: {},
            nodegroupArn: {},
            clusterName: {},
            version: {},
            releaseVersion: {},
            createdAt: {
              type: "timestamp"
            },
            modifiedAt: {
              type: "timestamp"
            },
            status: {},
            capacityType: {},
            scalingConfig: {
              shape: "S2m"
            },
            instanceTypes: {
              shape: "S5"
            },
            subnets: {
              shape: "S5"
            },
            remoteAccess: {
              shape: "S2r"
            },
            amiType: {},
            nodeRole: {},
            labels: {
              shape: "S2s"
            },
            taints: {
              shape: "S2v"
            },
            resources: {
              type: "structure",
              members: {
                autoScalingGroups: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      name: {}
                    }
                  }
                },
                remoteAccessSecurityGroup: {}
              }
            },
            diskSize: {
              type: "integer"
            },
            health: {
              type: "structure",
              members: {
                issues: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      code: {},
                      message: {},
                      resourceIds: {
                        shape: "S5"
                      }
                    }
                  }
                }
              }
            },
            updateConfig: {
              shape: "S31"
            },
            launchTemplate: {
              shape: "S30"
            },
            tags: {
              shape: "Ss"
            }
          }
        },
        S3h: {
          type: "structure",
          members: {
            clusterName: {},
            namespace: {},
            serviceAccount: {},
            roleArn: {},
            associationArn: {},
            associationId: {},
            tags: {
              shape: "Ss"
            },
            createdAt: {
              type: "timestamp"
            },
            modifiedAt: {
              type: "timestamp"
            }
          }
        },
        S4k: {
          type: "structure",
          required: [
            "type",
            "name"
          ],
          members: {
            type: {},
            name: {}
          }
        },
        S4t: {
          type: "structure",
          members: {
            status: {},
            reason: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/eks-2017-11-01.paginators.json
var require_eks_2017_11_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/eks-2017-11-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeAddonVersions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "addons"
        },
        ListAccessEntries: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "accessEntries"
        },
        ListAccessPolicies: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "accessPolicies"
        },
        ListAddons: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "addons"
        },
        ListAssociatedAccessPolicies: {
          input_token: "nextToken",
          limit_key: "maxResults",
          non_aggregate_keys: [
            "clusterName",
            "principalArn"
          ],
          output_token: "nextToken",
          result_key: "associatedAccessPolicies"
        },
        ListClusters: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "clusters"
        },
        ListEksAnywhereSubscriptions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "subscriptions"
        },
        ListFargateProfiles: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "fargateProfileNames"
        },
        ListIdentityProviderConfigs: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "identityProviderConfigs"
        },
        ListInsights: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "insights"
        },
        ListNodegroups: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "nodegroups"
        },
        ListPodIdentityAssociations: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "associations"
        },
        ListUpdates: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "updateIds"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/eks-2017-11-01.waiters2.json
var require_eks_2017_11_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/eks-2017-11-01.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        ClusterActive: {
          delay: 30,
          operation: "DescribeCluster",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "DELETING",
              matcher: "path",
              state: "failure",
              argument: "cluster.status"
            },
            {
              expected: "FAILED",
              matcher: "path",
              state: "failure",
              argument: "cluster.status"
            },
            {
              expected: "ACTIVE",
              matcher: "path",
              state: "success",
              argument: "cluster.status"
            }
          ]
        },
        ClusterDeleted: {
          delay: 30,
          operation: "DescribeCluster",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "ACTIVE",
              matcher: "path",
              state: "failure",
              argument: "cluster.status"
            },
            {
              expected: "CREATING",
              matcher: "path",
              state: "failure",
              argument: "cluster.status"
            },
            {
              expected: "PENDING",
              matcher: "path",
              state: "failure",
              argument: "cluster.status"
            },
            {
              expected: "ResourceNotFoundException",
              matcher: "error",
              state: "success"
            }
          ]
        },
        NodegroupActive: {
          delay: 30,
          operation: "DescribeNodegroup",
          maxAttempts: 80,
          acceptors: [
            {
              expected: "CREATE_FAILED",
              matcher: "path",
              state: "failure",
              argument: "nodegroup.status"
            },
            {
              expected: "ACTIVE",
              matcher: "path",
              state: "success",
              argument: "nodegroup.status"
            }
          ]
        },
        NodegroupDeleted: {
          delay: 30,
          operation: "DescribeNodegroup",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "DELETE_FAILED",
              matcher: "path",
              state: "failure",
              argument: "nodegroup.status"
            },
            {
              expected: "ResourceNotFoundException",
              matcher: "error",
              state: "success"
            }
          ]
        },
        AddonActive: {
          delay: 10,
          operation: "DescribeAddon",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "CREATE_FAILED",
              matcher: "path",
              state: "failure",
              argument: "addon.status"
            },
            {
              expected: "DEGRADED",
              matcher: "path",
              state: "failure",
              argument: "addon.status"
            },
            {
              expected: "ACTIVE",
              matcher: "path",
              state: "success",
              argument: "addon.status"
            }
          ]
        },
        AddonDeleted: {
          delay: 10,
          operation: "DescribeAddon",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "DELETE_FAILED",
              matcher: "path",
              state: "failure",
              argument: "addon.status"
            },
            {
              expected: "ResourceNotFoundException",
              matcher: "error",
              state: "success"
            }
          ]
        },
        FargateProfileActive: {
          delay: 10,
          operation: "DescribeFargateProfile",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "CREATE_FAILED",
              matcher: "path",
              state: "failure",
              argument: "fargateProfile.status"
            },
            {
              expected: "ACTIVE",
              matcher: "path",
              state: "success",
              argument: "fargateProfile.status"
            }
          ]
        },
        FargateProfileDeleted: {
          delay: 30,
          operation: "DescribeFargateProfile",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "DELETE_FAILED",
              matcher: "path",
              state: "failure",
              argument: "fargateProfile.status"
            },
            {
              expected: "ResourceNotFoundException",
              matcher: "error",
              state: "success"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/eks.js
var require_eks = __commonJS({
  "node_modules/aws-sdk/clients/eks.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["eks"] = {};
    AWS2.EKS = Service.defineService("eks", ["2017-11-01"]);
    Object.defineProperty(apiLoader.services["eks"], "2017-11-01", {
      get: function get() {
        var model = require_eks_2017_11_01_min();
        model.paginators = require_eks_2017_11_01_paginators().pagination;
        model.waiters = require_eks_2017_11_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.EKS;
  }
});

// node_modules/aws-sdk/apis/dlm-2018-01-12.min.json
var require_dlm_2018_01_12_min = __commonJS({
  "node_modules/aws-sdk/apis/dlm-2018-01-12.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-01-12",
        endpointPrefix: "dlm",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Amazon DLM",
        serviceFullName: "Amazon Data Lifecycle Manager",
        serviceId: "DLM",
        signatureVersion: "v4",
        signingName: "dlm",
        uid: "dlm-2018-01-12"
      },
      operations: {
        CreateLifecyclePolicy: {
          http: {
            requestUri: "/policies"
          },
          input: {
            type: "structure",
            required: [
              "ExecutionRoleArn",
              "Description",
              "State"
            ],
            members: {
              ExecutionRoleArn: {},
              Description: {},
              State: {},
              PolicyDetails: {
                shape: "S5"
              },
              Tags: {
                shape: "S2g"
              },
              DefaultPolicy: {},
              CreateInterval: {
                type: "integer"
              },
              RetainInterval: {
                type: "integer"
              },
              CopyTags: {
                type: "boolean"
              },
              ExtendDeletion: {
                type: "boolean"
              },
              CrossRegionCopyTargets: {
                shape: "S28"
              },
              Exclusions: {
                shape: "S2b"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyId: {}
            }
          }
        },
        DeleteLifecyclePolicy: {
          http: {
            method: "DELETE",
            requestUri: "/policies/{policyId}"
          },
          input: {
            type: "structure",
            required: [
              "PolicyId"
            ],
            members: {
              PolicyId: {
                location: "uri",
                locationName: "policyId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetLifecyclePolicies: {
          http: {
            method: "GET",
            requestUri: "/policies"
          },
          input: {
            type: "structure",
            members: {
              PolicyIds: {
                location: "querystring",
                locationName: "policyIds",
                type: "list",
                member: {}
              },
              State: {
                location: "querystring",
                locationName: "state"
              },
              ResourceTypes: {
                shape: "S7",
                location: "querystring",
                locationName: "resourceTypes"
              },
              TargetTags: {
                location: "querystring",
                locationName: "targetTags",
                type: "list",
                member: {}
              },
              TagsToAdd: {
                location: "querystring",
                locationName: "tagsToAdd",
                type: "list",
                member: {}
              },
              DefaultPolicyType: {
                location: "querystring",
                locationName: "defaultPolicyType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PolicyId: {},
                    Description: {},
                    State: {},
                    Tags: {
                      shape: "S2g"
                    },
                    PolicyType: {},
                    DefaultPolicy: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        GetLifecyclePolicy: {
          http: {
            method: "GET",
            requestUri: "/policies/{policyId}"
          },
          input: {
            type: "structure",
            required: [
              "PolicyId"
            ],
            members: {
              PolicyId: {
                location: "uri",
                locationName: "policyId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {
                type: "structure",
                members: {
                  PolicyId: {},
                  Description: {},
                  State: {},
                  StatusMessage: {},
                  ExecutionRoleArn: {},
                  DateCreated: {
                    shape: "S33"
                  },
                  DateModified: {
                    shape: "S33"
                  },
                  PolicyDetails: {
                    shape: "S5"
                  },
                  Tags: {
                    shape: "S2g"
                  },
                  PolicyArn: {},
                  DefaultPolicy: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S2g"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              Tags: {
                shape: "S2g"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateLifecyclePolicy: {
          http: {
            method: "PATCH",
            requestUri: "/policies/{policyId}"
          },
          input: {
            type: "structure",
            required: [
              "PolicyId"
            ],
            members: {
              PolicyId: {
                location: "uri",
                locationName: "policyId"
              },
              ExecutionRoleArn: {},
              State: {},
              Description: {},
              PolicyDetails: {
                shape: "S5"
              },
              CreateInterval: {
                type: "integer"
              },
              RetainInterval: {
                type: "integer"
              },
              CopyTags: {
                type: "boolean"
              },
              ExtendDeletion: {
                type: "boolean"
              },
              CrossRegionCopyTargets: {
                shape: "S28"
              },
              Exclusions: {
                shape: "S2b"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          members: {
            PolicyType: {},
            ResourceTypes: {
              shape: "S7"
            },
            ResourceLocations: {
              type: "list",
              member: {}
            },
            TargetTags: {
              type: "list",
              member: {
                shape: "Sc"
              }
            },
            Schedules: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Name: {},
                  CopyTags: {
                    type: "boolean"
                  },
                  TagsToAdd: {
                    type: "list",
                    member: {
                      shape: "Sc"
                    }
                  },
                  VariableTags: {
                    type: "list",
                    member: {
                      shape: "Sc"
                    }
                  },
                  CreateRule: {
                    type: "structure",
                    members: {
                      Location: {},
                      Interval: {
                        type: "integer"
                      },
                      IntervalUnit: {},
                      Times: {
                        type: "list",
                        member: {}
                      },
                      CronExpression: {},
                      Scripts: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "ExecutionHandler"
                          ],
                          members: {
                            Stages: {
                              type: "list",
                              member: {}
                            },
                            ExecutionHandlerService: {},
                            ExecutionHandler: {},
                            ExecuteOperationOnScriptFailure: {
                              type: "boolean"
                            },
                            ExecutionTimeout: {
                              type: "integer"
                            },
                            MaximumRetryCount: {
                              type: "integer"
                            }
                          }
                        }
                      }
                    }
                  },
                  RetainRule: {
                    type: "structure",
                    members: {
                      Count: {
                        type: "integer"
                      },
                      Interval: {
                        type: "integer"
                      },
                      IntervalUnit: {}
                    }
                  },
                  FastRestoreRule: {
                    type: "structure",
                    required: [
                      "AvailabilityZones"
                    ],
                    members: {
                      Count: {
                        type: "integer"
                      },
                      Interval: {
                        type: "integer"
                      },
                      IntervalUnit: {},
                      AvailabilityZones: {
                        type: "list",
                        member: {}
                      }
                    }
                  },
                  CrossRegionCopyRules: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Encrypted"
                      ],
                      members: {
                        TargetRegion: {},
                        Target: {},
                        Encrypted: {
                          type: "boolean"
                        },
                        CmkArn: {},
                        CopyTags: {
                          type: "boolean"
                        },
                        RetainRule: {
                          shape: "S1f"
                        },
                        DeprecateRule: {
                          type: "structure",
                          members: {
                            Interval: {
                              type: "integer"
                            },
                            IntervalUnit: {}
                          }
                        }
                      }
                    }
                  },
                  ShareRules: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "TargetAccounts"
                      ],
                      members: {
                        TargetAccounts: {
                          type: "list",
                          member: {}
                        },
                        UnshareInterval: {
                          type: "integer"
                        },
                        UnshareIntervalUnit: {}
                      }
                    }
                  },
                  DeprecateRule: {
                    type: "structure",
                    members: {
                      Count: {
                        type: "integer"
                      },
                      Interval: {
                        type: "integer"
                      },
                      IntervalUnit: {}
                    }
                  },
                  ArchiveRule: {
                    type: "structure",
                    required: [
                      "RetainRule"
                    ],
                    members: {
                      RetainRule: {
                        type: "structure",
                        required: [
                          "RetentionArchiveTier"
                        ],
                        members: {
                          RetentionArchiveTier: {
                            type: "structure",
                            members: {
                              Count: {
                                type: "integer"
                              },
                              Interval: {
                                type: "integer"
                              },
                              IntervalUnit: {}
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            Parameters: {
              type: "structure",
              members: {
                ExcludeBootVolume: {
                  type: "boolean"
                },
                NoReboot: {
                  type: "boolean"
                },
                ExcludeDataVolumeTags: {
                  type: "list",
                  member: {
                    shape: "Sc"
                  }
                }
              }
            },
            EventSource: {
              type: "structure",
              required: [
                "Type"
              ],
              members: {
                Type: {},
                Parameters: {
                  type: "structure",
                  required: [
                    "EventType",
                    "SnapshotOwner",
                    "DescriptionRegex"
                  ],
                  members: {
                    EventType: {},
                    SnapshotOwner: {
                      type: "list",
                      member: {}
                    },
                    DescriptionRegex: {}
                  }
                }
              }
            },
            Actions: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name",
                  "CrossRegionCopy"
                ],
                members: {
                  Name: {},
                  CrossRegionCopy: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Target",
                        "EncryptionConfiguration"
                      ],
                      members: {
                        Target: {},
                        EncryptionConfiguration: {
                          type: "structure",
                          required: [
                            "Encrypted"
                          ],
                          members: {
                            Encrypted: {
                              type: "boolean"
                            },
                            CmkArn: {}
                          }
                        },
                        RetainRule: {
                          shape: "S1f"
                        }
                      }
                    }
                  }
                }
              }
            },
            PolicyLanguage: {},
            ResourceType: {},
            CreateInterval: {
              type: "integer"
            },
            RetainInterval: {
              type: "integer"
            },
            CopyTags: {
              type: "boolean"
            },
            CrossRegionCopyTargets: {
              shape: "S28"
            },
            ExtendDeletion: {
              type: "boolean"
            },
            Exclusions: {
              shape: "S2b"
            }
          }
        },
        S7: {
          type: "list",
          member: {}
        },
        Sc: {
          type: "structure",
          required: [
            "Key",
            "Value"
          ],
          members: {
            Key: {},
            Value: {}
          }
        },
        S1f: {
          type: "structure",
          members: {
            Interval: {
              type: "integer"
            },
            IntervalUnit: {}
          }
        },
        S28: {
          type: "list",
          member: {
            type: "structure",
            members: {
              TargetRegion: {}
            }
          }
        },
        S2b: {
          type: "structure",
          members: {
            ExcludeBootVolumes: {
              type: "boolean"
            },
            ExcludeVolumeTypes: {
              type: "list",
              member: {}
            },
            ExcludeTags: {
              type: "list",
              member: {
                shape: "Sc"
              }
            }
          }
        },
        S2g: {
          type: "map",
          key: {},
          value: {}
        },
        S33: {
          type: "timestamp",
          timestampFormat: "iso8601"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/dlm-2018-01-12.paginators.json
var require_dlm_2018_01_12_paginators = __commonJS({
  "node_modules/aws-sdk/apis/dlm-2018-01-12.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/dlm.js
var require_dlm = __commonJS({
  "node_modules/aws-sdk/clients/dlm.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["dlm"] = {};
    AWS2.DLM = Service.defineService("dlm", ["2018-01-12"]);
    Object.defineProperty(apiLoader.services["dlm"], "2018-01-12", {
      get: function get() {
        var model = require_dlm_2018_01_12_min();
        model.paginators = require_dlm_2018_01_12_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.DLM;
  }
});

// node_modules/aws-sdk/apis/signer-2017-08-25.min.json
var require_signer_2017_08_25_min = __commonJS({
  "node_modules/aws-sdk/apis/signer-2017-08-25.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-08-25",
        endpointPrefix: "signer",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "signer",
        serviceFullName: "AWS Signer",
        serviceId: "signer",
        signatureVersion: "v4",
        signingName: "signer",
        uid: "signer-2017-08-25"
      },
      operations: {
        AddProfilePermission: {
          http: {
            requestUri: "/signing-profiles/{profileName}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "action",
              "principal",
              "statementId",
              "profileName"
            ],
            members: {
              profileName: {
                location: "uri",
                locationName: "profileName"
              },
              profileVersion: {},
              action: {},
              principal: {},
              revisionId: {},
              statementId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              revisionId: {}
            }
          }
        },
        CancelSigningProfile: {
          http: {
            method: "DELETE",
            requestUri: "/signing-profiles/{profileName}"
          },
          input: {
            type: "structure",
            required: [
              "profileName"
            ],
            members: {
              profileName: {
                location: "uri",
                locationName: "profileName"
              }
            }
          }
        },
        DescribeSigningJob: {
          http: {
            method: "GET",
            requestUri: "/signing-jobs/{jobId}"
          },
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobId: {},
              source: {
                shape: "Sa"
              },
              signingMaterial: {
                shape: "Sf"
              },
              platformId: {},
              platformDisplayName: {},
              profileName: {},
              profileVersion: {},
              overrides: {
                shape: "Sj"
              },
              signingParameters: {
                shape: "So"
              },
              createdAt: {
                type: "timestamp"
              },
              completedAt: {
                type: "timestamp"
              },
              signatureExpiresAt: {
                type: "timestamp"
              },
              requestedBy: {},
              status: {},
              statusReason: {},
              revocationRecord: {
                type: "structure",
                members: {
                  reason: {},
                  revokedAt: {
                    type: "timestamp"
                  },
                  revokedBy: {}
                }
              },
              signedObject: {
                shape: "Sw"
              },
              jobOwner: {},
              jobInvoker: {}
            }
          }
        },
        GetRevocationStatus: {
          http: {
            method: "GET",
            requestUri: "/revocations"
          },
          input: {
            type: "structure",
            required: [
              "signatureTimestamp",
              "platformId",
              "profileVersionArn",
              "jobArn",
              "certificateHashes"
            ],
            members: {
              signatureTimestamp: {
                location: "querystring",
                locationName: "signatureTimestamp",
                type: "timestamp"
              },
              platformId: {
                location: "querystring",
                locationName: "platformId"
              },
              profileVersionArn: {
                location: "querystring",
                locationName: "profileVersionArn"
              },
              jobArn: {
                location: "querystring",
                locationName: "jobArn"
              },
              certificateHashes: {
                location: "querystring",
                locationName: "certificateHashes",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              revokedEntities: {
                type: "list",
                member: {}
              }
            }
          },
          endpoint: {
            hostPrefix: "verification."
          }
        },
        GetSigningPlatform: {
          http: {
            method: "GET",
            requestUri: "/signing-platforms/{platformId}"
          },
          input: {
            type: "structure",
            required: [
              "platformId"
            ],
            members: {
              platformId: {
                location: "uri",
                locationName: "platformId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              platformId: {},
              displayName: {},
              partner: {},
              target: {},
              category: {},
              signingConfiguration: {
                shape: "S17"
              },
              signingImageFormat: {
                shape: "S1c"
              },
              maxSizeInMB: {
                type: "integer"
              },
              revocationSupported: {
                type: "boolean"
              }
            }
          }
        },
        GetSigningProfile: {
          http: {
            method: "GET",
            requestUri: "/signing-profiles/{profileName}"
          },
          input: {
            type: "structure",
            required: [
              "profileName"
            ],
            members: {
              profileName: {
                location: "uri",
                locationName: "profileName"
              },
              profileOwner: {
                location: "querystring",
                locationName: "profileOwner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              profileName: {},
              profileVersion: {},
              profileVersionArn: {},
              revocationRecord: {
                type: "structure",
                members: {
                  revocationEffectiveFrom: {
                    type: "timestamp"
                  },
                  revokedAt: {
                    type: "timestamp"
                  },
                  revokedBy: {}
                }
              },
              signingMaterial: {
                shape: "Sf"
              },
              platformId: {},
              platformDisplayName: {},
              signatureValidityPeriod: {
                shape: "S1j"
              },
              overrides: {
                shape: "Sj"
              },
              signingParameters: {
                shape: "So"
              },
              status: {},
              statusReason: {},
              arn: {},
              tags: {
                shape: "S1o"
              }
            }
          }
        },
        ListProfilePermissions: {
          http: {
            method: "GET",
            requestUri: "/signing-profiles/{profileName}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "profileName"
            ],
            members: {
              profileName: {
                location: "uri",
                locationName: "profileName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              revisionId: {},
              policySizeBytes: {
                type: "integer"
              },
              permissions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    action: {},
                    principal: {},
                    statementId: {},
                    profileVersion: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSigningJobs: {
          http: {
            method: "GET",
            requestUri: "/signing-jobs"
          },
          input: {
            type: "structure",
            members: {
              status: {
                location: "querystring",
                locationName: "status"
              },
              platformId: {
                location: "querystring",
                locationName: "platformId"
              },
              requestedBy: {
                location: "querystring",
                locationName: "requestedBy"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              isRevoked: {
                location: "querystring",
                locationName: "isRevoked",
                type: "boolean"
              },
              signatureExpiresBefore: {
                location: "querystring",
                locationName: "signatureExpiresBefore",
                type: "timestamp"
              },
              signatureExpiresAfter: {
                location: "querystring",
                locationName: "signatureExpiresAfter",
                type: "timestamp"
              },
              jobInvoker: {
                location: "querystring",
                locationName: "jobInvoker"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    jobId: {},
                    source: {
                      shape: "Sa"
                    },
                    signedObject: {
                      shape: "Sw"
                    },
                    signingMaterial: {
                      shape: "Sf"
                    },
                    createdAt: {
                      type: "timestamp"
                    },
                    status: {},
                    isRevoked: {
                      type: "boolean"
                    },
                    profileName: {},
                    profileVersion: {},
                    platformId: {},
                    platformDisplayName: {},
                    signatureExpiresAt: {
                      type: "timestamp"
                    },
                    jobOwner: {},
                    jobInvoker: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSigningPlatforms: {
          http: {
            method: "GET",
            requestUri: "/signing-platforms"
          },
          input: {
            type: "structure",
            members: {
              category: {
                location: "querystring",
                locationName: "category"
              },
              partner: {
                location: "querystring",
                locationName: "partner"
              },
              target: {
                location: "querystring",
                locationName: "target"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              platforms: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    platformId: {},
                    displayName: {},
                    partner: {},
                    target: {},
                    category: {},
                    signingConfiguration: {
                      shape: "S17"
                    },
                    signingImageFormat: {
                      shape: "S1c"
                    },
                    maxSizeInMB: {
                      type: "integer"
                    },
                    revocationSupported: {
                      type: "boolean"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSigningProfiles: {
          http: {
            method: "GET",
            requestUri: "/signing-profiles"
          },
          input: {
            type: "structure",
            members: {
              includeCanceled: {
                location: "querystring",
                locationName: "includeCanceled",
                type: "boolean"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              platformId: {
                location: "querystring",
                locationName: "platformId"
              },
              statuses: {
                location: "querystring",
                locationName: "statuses",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              profiles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    profileName: {},
                    profileVersion: {},
                    profileVersionArn: {},
                    signingMaterial: {
                      shape: "Sf"
                    },
                    signatureValidityPeriod: {
                      shape: "S1j"
                    },
                    platformId: {},
                    platformDisplayName: {},
                    signingParameters: {
                      shape: "So"
                    },
                    status: {},
                    arn: {},
                    tags: {
                      shape: "S1o"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S1o"
              }
            }
          }
        },
        PutSigningProfile: {
          http: {
            method: "PUT",
            requestUri: "/signing-profiles/{profileName}"
          },
          input: {
            type: "structure",
            required: [
              "profileName",
              "platformId"
            ],
            members: {
              profileName: {
                location: "uri",
                locationName: "profileName"
              },
              signingMaterial: {
                shape: "Sf"
              },
              signatureValidityPeriod: {
                shape: "S1j"
              },
              platformId: {},
              overrides: {
                shape: "Sj"
              },
              signingParameters: {
                shape: "So"
              },
              tags: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              profileVersion: {},
              profileVersionArn: {}
            }
          }
        },
        RemoveProfilePermission: {
          http: {
            method: "DELETE",
            requestUri: "/signing-profiles/{profileName}/permissions/{statementId}"
          },
          input: {
            type: "structure",
            required: [
              "revisionId",
              "profileName",
              "statementId"
            ],
            members: {
              profileName: {
                location: "uri",
                locationName: "profileName"
              },
              revisionId: {
                location: "querystring",
                locationName: "revisionId"
              },
              statementId: {
                location: "uri",
                locationName: "statementId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              revisionId: {}
            }
          }
        },
        RevokeSignature: {
          http: {
            method: "PUT",
            requestUri: "/signing-jobs/{jobId}/revoke"
          },
          input: {
            type: "structure",
            required: [
              "reason",
              "jobId"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              jobOwner: {},
              reason: {}
            }
          }
        },
        RevokeSigningProfile: {
          http: {
            method: "PUT",
            requestUri: "/signing-profiles/{profileName}/revoke"
          },
          input: {
            type: "structure",
            required: [
              "profileVersion",
              "reason",
              "effectiveTime",
              "profileName"
            ],
            members: {
              profileName: {
                location: "uri",
                locationName: "profileName"
              },
              profileVersion: {},
              reason: {},
              effectiveTime: {
                type: "timestamp"
              }
            }
          }
        },
        SignPayload: {
          http: {
            requestUri: "/signing-jobs/with-payload"
          },
          input: {
            type: "structure",
            required: [
              "profileName",
              "payload",
              "payloadFormat"
            ],
            members: {
              profileName: {},
              profileOwner: {},
              payload: {
                type: "blob"
              },
              payloadFormat: {}
            }
          },
          output: {
            type: "structure",
            members: {
              jobId: {},
              jobOwner: {},
              metadata: {
                type: "map",
                key: {},
                value: {}
              },
              signature: {
                type: "blob"
              }
            }
          }
        },
        StartSigningJob: {
          http: {
            requestUri: "/signing-jobs"
          },
          input: {
            type: "structure",
            required: [
              "source",
              "destination",
              "profileName",
              "clientRequestToken"
            ],
            members: {
              source: {
                shape: "Sa"
              },
              destination: {
                type: "structure",
                members: {
                  s3: {
                    type: "structure",
                    members: {
                      bucketName: {},
                      prefix: {}
                    }
                  }
                }
              },
              profileName: {},
              clientRequestToken: {
                idempotencyToken: true
              },
              profileOwner: {}
            }
          },
          output: {
            type: "structure",
            members: {
              jobId: {},
              jobOwner: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        Sa: {
          type: "structure",
          members: {
            s3: {
              type: "structure",
              required: [
                "bucketName",
                "key",
                "version"
              ],
              members: {
                bucketName: {},
                key: {},
                version: {}
              }
            }
          }
        },
        Sf: {
          type: "structure",
          required: [
            "certificateArn"
          ],
          members: {
            certificateArn: {}
          }
        },
        Sj: {
          type: "structure",
          members: {
            signingConfiguration: {
              type: "structure",
              members: {
                encryptionAlgorithm: {},
                hashAlgorithm: {}
              }
            },
            signingImageFormat: {}
          }
        },
        So: {
          type: "map",
          key: {},
          value: {}
        },
        Sw: {
          type: "structure",
          members: {
            s3: {
              type: "structure",
              members: {
                bucketName: {},
                key: {}
              }
            }
          }
        },
        S17: {
          type: "structure",
          required: [
            "encryptionAlgorithmOptions",
            "hashAlgorithmOptions"
          ],
          members: {
            encryptionAlgorithmOptions: {
              type: "structure",
              required: [
                "allowedValues",
                "defaultValue"
              ],
              members: {
                allowedValues: {
                  type: "list",
                  member: {}
                },
                defaultValue: {}
              }
            },
            hashAlgorithmOptions: {
              type: "structure",
              required: [
                "allowedValues",
                "defaultValue"
              ],
              members: {
                allowedValues: {
                  type: "list",
                  member: {}
                },
                defaultValue: {}
              }
            }
          }
        },
        S1c: {
          type: "structure",
          required: [
            "supportedFormats",
            "defaultFormat"
          ],
          members: {
            supportedFormats: {
              type: "list",
              member: {}
            },
            defaultFormat: {}
          }
        },
        S1j: {
          type: "structure",
          members: {
            value: {
              type: "integer"
            },
            type: {}
          }
        },
        S1o: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/signer-2017-08-25.paginators.json
var require_signer_2017_08_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/signer-2017-08-25.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListSigningJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListSigningPlatforms: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListSigningProfiles: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/signer-2017-08-25.waiters2.json
var require_signer_2017_08_25_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/signer-2017-08-25.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        SuccessfulSigningJob: {
          delay: 20,
          operation: "DescribeSigningJob",
          maxAttempts: 25,
          acceptors: [
            {
              expected: "Succeeded",
              matcher: "path",
              state: "success",
              argument: "status"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "status"
            },
            {
              expected: "ResourceNotFoundException",
              matcher: "error",
              state: "failure"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/signer.js
var require_signer3 = __commonJS({
  "node_modules/aws-sdk/clients/signer.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["signer"] = {};
    AWS2.Signer = Service.defineService("signer", ["2017-08-25"]);
    Object.defineProperty(apiLoader.services["signer"], "2017-08-25", {
      get: function get() {
        var model = require_signer_2017_08_25_min();
        model.paginators = require_signer_2017_08_25_paginators().pagination;
        model.waiters = require_signer_2017_08_25_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Signer;
  }
});

// node_modules/aws-sdk/apis/chime-2018-05-01.min.json
var require_chime_2018_05_01_min = __commonJS({
  "node_modules/aws-sdk/apis/chime-2018-05-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-05-01",
        endpointPrefix: "chime",
        protocol: "rest-json",
        serviceFullName: "Amazon Chime",
        serviceId: "Chime",
        signatureVersion: "v4",
        uid: "chime-2018-05-01"
      },
      operations: {
        AssociatePhoneNumberWithUser: {
          http: {
            requestUri: "/accounts/{accountId}/users/{userId}?operation=associate-phone-number",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "UserId",
              "E164PhoneNumber"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              UserId: {
                location: "uri",
                locationName: "userId"
              },
              E164PhoneNumber: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociatePhoneNumbersWithVoiceConnector: {
          http: {
            requestUri: "/voice-connectors/{voiceConnectorId}?operation=associate-phone-numbers",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "E164PhoneNumbers"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              E164PhoneNumbers: {
                shape: "S7"
              },
              ForceAssociate: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberErrors: {
                shape: "Sa"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by AssociatePhoneNumbersWithVoiceConnector in the Amazon Chime SDK Voice Namespace"
        },
        AssociatePhoneNumbersWithVoiceConnectorGroup: {
          http: {
            requestUri: "/voice-connector-groups/{voiceConnectorGroupId}?operation=associate-phone-numbers",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorGroupId",
              "E164PhoneNumbers"
            ],
            members: {
              VoiceConnectorGroupId: {
                location: "uri",
                locationName: "voiceConnectorGroupId"
              },
              E164PhoneNumbers: {
                shape: "S7"
              },
              ForceAssociate: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberErrors: {
                shape: "Sa"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by AssociatePhoneNumbersWithVoiceConnectorGroup in the Amazon Chime SDK Voice Namespace"
        },
        AssociateSigninDelegateGroupsWithAccount: {
          http: {
            requestUri: "/accounts/{accountId}?operation=associate-signin-delegate-groups",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "SigninDelegateGroups"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              SigninDelegateGroups: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        BatchCreateAttendee: {
          http: {
            requestUri: "/meetings/{meetingId}/attendees?operation=batch-create",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "MeetingId",
              "Attendees"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              },
              Attendees: {
                type: "list",
                member: {
                  shape: "Sm"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attendees: {
                shape: "St"
              },
              Errors: {
                shape: "Sw"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by BatchCreateAttendee in the Amazon Chime SDK Meetings Namespace"
        },
        BatchCreateChannelMembership: {
          http: {
            requestUri: "/channels/{channelArn}/memberships?operation=batch-create",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MemberArns"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              Type: {},
              MemberArns: {
                type: "list",
                member: {}
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BatchChannelMemberships: {
                type: "structure",
                members: {
                  InvitedBy: {
                    shape: "S14"
                  },
                  Type: {},
                  Members: {
                    type: "list",
                    member: {
                      shape: "S14"
                    }
                  },
                  ChannelArn: {}
                }
              },
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MemberArn: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by BatchCreateChannelMembership in the Amazon Chime SDK Messaging Namespace",
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        BatchCreateRoomMembership: {
          http: {
            requestUri: "/accounts/{accountId}/rooms/{roomId}/memberships?operation=batch-create",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "RoomId",
              "MembershipItemList"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              RoomId: {
                location: "uri",
                locationName: "roomId"
              },
              MembershipItemList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MemberId: {},
                    Role: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MemberId: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        BatchDeletePhoneNumber: {
          http: {
            requestUri: "/phone-numbers?operation=batch-delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "PhoneNumberIds"
            ],
            members: {
              PhoneNumberIds: {
                shape: "S1h"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberErrors: {
                shape: "Sa"
              }
            }
          }
        },
        BatchSuspendUser: {
          http: {
            requestUri: "/accounts/{accountId}/users?operation=suspend",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "UserIdList"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              UserIdList: {
                shape: "S1k"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserErrors: {
                shape: "S1m"
              }
            }
          }
        },
        BatchUnsuspendUser: {
          http: {
            requestUri: "/accounts/{accountId}/users?operation=unsuspend",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "UserIdList"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              UserIdList: {
                shape: "S1k"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserErrors: {
                shape: "S1m"
              }
            }
          }
        },
        BatchUpdatePhoneNumber: {
          http: {
            requestUri: "/phone-numbers?operation=batch-update",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "UpdatePhoneNumberRequestItems"
            ],
            members: {
              UpdatePhoneNumberRequestItems: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "PhoneNumberId"
                  ],
                  members: {
                    PhoneNumberId: {},
                    ProductType: {},
                    CallingName: {
                      shape: "S1u"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberErrors: {
                shape: "Sa"
              }
            }
          }
        },
        BatchUpdateUser: {
          http: {
            requestUri: "/accounts/{accountId}/users",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "UpdateUserRequestItems"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              UpdateUserRequestItems: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "UserId"
                  ],
                  members: {
                    UserId: {},
                    LicenseType: {},
                    UserType: {},
                    AlexaForBusinessMetadata: {
                      shape: "S21"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserErrors: {
                shape: "S1m"
              }
            }
          }
        },
        CreateAccount: {
          http: {
            requestUri: "/accounts",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Account: {
                shape: "S28"
              }
            }
          }
        },
        CreateAppInstance: {
          http: {
            requestUri: "/app-instances",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "ClientRequestToken"
            ],
            members: {
              Name: {
                shape: "S2e"
              },
              Metadata: {
                shape: "S2f"
              },
              ClientRequestToken: {
                shape: "S2g",
                idempotencyToken: true
              },
              Tags: {
                shape: "S2h"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceArn: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by CreateAppInstance in the Amazon Chime SDK Identity Namespace",
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        CreateAppInstanceAdmin: {
          http: {
            requestUri: "/app-instances/{appInstanceArn}/admins",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceAdminArn",
              "AppInstanceArn"
            ],
            members: {
              AppInstanceAdminArn: {},
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceAdmin: {
                shape: "S14"
              },
              AppInstanceArn: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by CreateAppInstanceAdmin in the Amazon Chime SDK Identity Namespace",
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        CreateAppInstanceUser: {
          http: {
            requestUri: "/app-instance-users",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn",
              "AppInstanceUserId",
              "Name",
              "ClientRequestToken"
            ],
            members: {
              AppInstanceArn: {},
              AppInstanceUserId: {
                type: "string",
                sensitive: true
              },
              Name: {
                shape: "S2n"
              },
              Metadata: {
                shape: "S2f"
              },
              ClientRequestToken: {
                shape: "S2g",
                idempotencyToken: true
              },
              Tags: {
                shape: "S2h"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceUserArn: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by CreateAppInstanceUser in the Amazon Chime SDK Identity Namespace",
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        CreateAttendee: {
          http: {
            requestUri: "/meetings/{meetingId}/attendees",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "MeetingId",
              "ExternalUserId"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              },
              ExternalUserId: {
                shape: "Sn"
              },
              Tags: {
                shape: "So"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attendee: {
                shape: "Su"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by CreateAttendee in the Amazon Chime SDK Meetings Namespace"
        },
        CreateBot: {
          http: {
            requestUri: "/accounts/{accountId}/bots",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DisplayName",
              "AccountId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              DisplayName: {
                shape: "S23"
              },
              Domain: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Bot: {
                shape: "S2t"
              }
            }
          }
        },
        CreateChannel: {
          http: {
            requestUri: "/channels",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn",
              "Name",
              "ClientRequestToken"
            ],
            members: {
              AppInstanceArn: {},
              Name: {
                shape: "S2e"
              },
              Mode: {},
              Privacy: {},
              Metadata: {
                shape: "S2f"
              },
              ClientRequestToken: {
                shape: "S2g",
                idempotencyToken: true
              },
              Tags: {
                shape: "S2h"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by CreateChannel in the Amazon Chime SDK Messaging Namespace",
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        CreateChannelBan: {
          http: {
            requestUri: "/channels/{channelArn}/bans",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MemberArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MemberArn: {},
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              Member: {
                shape: "S14"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by CreateChannelBan in the Amazon Chime SDK Messaging Namespace",
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        CreateChannelMembership: {
          http: {
            requestUri: "/channels/{channelArn}/memberships",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MemberArn",
              "Type"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MemberArn: {},
              Type: {},
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              Member: {
                shape: "S14"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by CreateChannelMembership in the Amazon Chime SDK Messaging Namespace",
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        CreateChannelModerator: {
          http: {
            requestUri: "/channels/{channelArn}/moderators",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "ChannelModeratorArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              ChannelModeratorArn: {},
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              ChannelModerator: {
                shape: "S14"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by CreateChannelModerator in the Amazon Chime SDK Messaging Namespace",
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        CreateMediaCapturePipeline: {
          http: {
            requestUri: "/media-capture-pipelines",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "SourceType",
              "SourceArn",
              "SinkType",
              "SinkArn"
            ],
            members: {
              SourceType: {},
              SourceArn: {
                shape: "S37"
              },
              SinkType: {},
              SinkArn: {
                shape: "S37"
              },
              ClientRequestToken: {
                shape: "S2g",
                idempotencyToken: true
              },
              ChimeSdkMeetingConfiguration: {
                shape: "S39"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MediaCapturePipeline: {
                shape: "S3n"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by CreateMediaCapturePipeline in the Amazon Chime SDK Media Pipelines Namespace"
        },
        CreateMeeting: {
          http: {
            requestUri: "/meetings",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ClientRequestToken"
            ],
            members: {
              ClientRequestToken: {
                shape: "S2g",
                idempotencyToken: true
              },
              ExternalMeetingId: {
                shape: "S3q"
              },
              MeetingHostId: {
                shape: "Sn"
              },
              MediaRegion: {},
              Tags: {
                shape: "S3r"
              },
              NotificationsConfiguration: {
                shape: "S3s"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Meeting: {
                shape: "S3u"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by CreateMeeting in the Amazon Chime SDK Meetings Namespace"
        },
        CreateMeetingDialOut: {
          http: {
            requestUri: "/meetings/{meetingId}/dial-outs",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "MeetingId",
              "FromPhoneNumber",
              "ToPhoneNumber",
              "JoinToken"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              },
              FromPhoneNumber: {
                shape: "S3"
              },
              ToPhoneNumber: {
                shape: "S3"
              },
              JoinToken: {
                shape: "Sv"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransactionId: {}
            }
          }
        },
        CreateMeetingWithAttendees: {
          http: {
            requestUri: "/meetings?operation=create-attendees",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ClientRequestToken"
            ],
            members: {
              ClientRequestToken: {
                shape: "S2g",
                idempotencyToken: true
              },
              ExternalMeetingId: {
                shape: "S3q"
              },
              MeetingHostId: {
                shape: "Sn"
              },
              MediaRegion: {},
              Tags: {
                shape: "S3r"
              },
              NotificationsConfiguration: {
                shape: "S3s"
              },
              Attendees: {
                type: "list",
                member: {
                  shape: "Sm"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Meeting: {
                shape: "S3u"
              },
              Attendees: {
                shape: "St"
              },
              Errors: {
                shape: "Sw"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by CreateMeetingWithAttendees in the Amazon Chime SDK Meetings Namespace"
        },
        CreatePhoneNumberOrder: {
          http: {
            requestUri: "/phone-number-orders",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ProductType",
              "E164PhoneNumbers"
            ],
            members: {
              ProductType: {},
              E164PhoneNumbers: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberOrder: {
                shape: "S44"
              }
            }
          }
        },
        CreateProxySession: {
          http: {
            requestUri: "/voice-connectors/{voiceConnectorId}/proxy-sessions",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ParticipantPhoneNumbers",
              "Capabilities",
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              ParticipantPhoneNumbers: {
                type: "list",
                member: {
                  shape: "S3"
                }
              },
              Name: {
                type: "string",
                sensitive: true
              },
              ExpiryMinutes: {
                type: "integer"
              },
              Capabilities: {
                shape: "S4e"
              },
              NumberSelectionBehavior: {},
              GeoMatchLevel: {},
              GeoMatchParams: {
                shape: "S4i"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProxySession: {
                shape: "S4m"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by CreateProxySession in the Amazon Chime SDK Voice Namespace"
        },
        CreateRoom: {
          http: {
            requestUri: "/accounts/{accountId}/rooms",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Name"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              Name: {
                shape: "S23"
              },
              ClientRequestToken: {
                shape: "S2g",
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Room: {
                shape: "S4t"
              }
            }
          }
        },
        CreateRoomMembership: {
          http: {
            requestUri: "/accounts/{accountId}/rooms/{roomId}/memberships",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "RoomId",
              "MemberId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              RoomId: {
                location: "uri",
                locationName: "roomId"
              },
              MemberId: {},
              Role: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RoomMembership: {
                shape: "S4w"
              }
            }
          }
        },
        CreateSipMediaApplication: {
          http: {
            requestUri: "/sip-media-applications",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AwsRegion",
              "Name",
              "Endpoints"
            ],
            members: {
              AwsRegion: {},
              Name: {},
              Endpoints: {
                shape: "S51"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipMediaApplication: {
                shape: "S55"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by CreateSipMediaApplication in the Amazon Chime SDK Voice Namespace"
        },
        CreateSipMediaApplicationCall: {
          http: {
            requestUri: "/sip-media-applications/{sipMediaApplicationId}/calls",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FromPhoneNumber",
              "ToPhoneNumber",
              "SipMediaApplicationId"
            ],
            members: {
              FromPhoneNumber: {
                shape: "S3"
              },
              ToPhoneNumber: {
                shape: "S3"
              },
              SipMediaApplicationId: {
                location: "uri",
                locationName: "sipMediaApplicationId"
              },
              SipHeaders: {
                type: "map",
                key: {
                  shape: "S23"
                },
                value: {
                  shape: "S23"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipMediaApplicationCall: {
                shape: "S59"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by CreateSipMediaApplicationCall in the Amazon Chime SDK Voice Namespace"
        },
        CreateSipRule: {
          http: {
            requestUri: "/sip-rules",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "TriggerType",
              "TriggerValue",
              "TargetApplications"
            ],
            members: {
              Name: {},
              TriggerType: {},
              TriggerValue: {},
              Disabled: {
                type: "boolean"
              },
              TargetApplications: {
                shape: "S5d"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipRule: {
                shape: "S5h"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by CreateSipRule in the Amazon Chime SDK Voice Namespace"
        },
        CreateUser: {
          http: {
            requestUri: "/accounts/{accountId}/users?operation=create",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              Username: {},
              Email: {
                shape: "S5j"
              },
              UserType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                shape: "S5l"
              }
            }
          }
        },
        CreateVoiceConnector: {
          http: {
            requestUri: "/voice-connectors",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "RequireEncryption"
            ],
            members: {
              Name: {},
              AwsRegion: {},
              RequireEncryption: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceConnector: {
                shape: "S5s"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by CreateVoiceConnector in the Amazon Chime SDK Voice Namespace"
        },
        CreateVoiceConnectorGroup: {
          http: {
            requestUri: "/voice-connector-groups",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              VoiceConnectorItems: {
                shape: "S5v"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceConnectorGroup: {
                shape: "S5z"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by CreateVoiceConnectorGroup in the Amazon Chime SDK Voice Namespace"
        },
        DeleteAccount: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{accountId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAppInstance: {
          http: {
            method: "DELETE",
            requestUri: "/app-instances/{appInstanceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DeleteAppInstance in the Amazon Chime SDK Identity Namespace",
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        DeleteAppInstanceAdmin: {
          http: {
            method: "DELETE",
            requestUri: "/app-instances/{appInstanceArn}/admins/{appInstanceAdminArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceAdminArn",
              "AppInstanceArn"
            ],
            members: {
              AppInstanceAdminArn: {
                location: "uri",
                locationName: "appInstanceAdminArn"
              },
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DeleteAppInstanceAdmin in the Amazon Chime SDK Identity Namespace",
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        DeleteAppInstanceStreamingConfigurations: {
          http: {
            method: "DELETE",
            requestUri: "/app-instances/{appInstanceArn}/streaming-configurations",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DeleteAppInstanceStreamingConfigurations in the Amazon Chime SDK Messaging Namespace"
        },
        DeleteAppInstanceUser: {
          http: {
            method: "DELETE",
            requestUri: "/app-instance-users/{appInstanceUserArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceUserArn"
            ],
            members: {
              AppInstanceUserArn: {
                location: "uri",
                locationName: "appInstanceUserArn"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DeleteAppInstanceUser in the Amazon Chime SDK Identity Namespace",
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        DeleteAttendee: {
          http: {
            method: "DELETE",
            requestUri: "/meetings/{meetingId}/attendees/{attendeeId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "MeetingId",
              "AttendeeId"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              },
              AttendeeId: {
                location: "uri",
                locationName: "attendeeId"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DeleteAttendee in the Amazon Chime SDK Meetings Namespace"
        },
        DeleteChannel: {
          http: {
            method: "DELETE",
            requestUri: "/channels/{channelArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DeleteChannel in the Amazon Chime SDK Messaging Namespace",
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        DeleteChannelBan: {
          http: {
            method: "DELETE",
            requestUri: "/channels/{channelArn}/bans/{memberArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MemberArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MemberArn: {
                location: "uri",
                locationName: "memberArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DeleteChannelBan in the Amazon Chime SDK Messaging Namespace",
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        DeleteChannelMembership: {
          http: {
            method: "DELETE",
            requestUri: "/channels/{channelArn}/memberships/{memberArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MemberArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MemberArn: {
                location: "uri",
                locationName: "memberArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DeleteChannelMembership in the Amazon Chime SDK Messaging Namespace",
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        DeleteChannelMessage: {
          http: {
            method: "DELETE",
            requestUri: "/channels/{channelArn}/messages/{messageId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MessageId"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MessageId: {
                location: "uri",
                locationName: "messageId"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DeleteChannelMessage in the Amazon Chime SDK Messaging Namespace",
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        DeleteChannelModerator: {
          http: {
            method: "DELETE",
            requestUri: "/channels/{channelArn}/moderators/{channelModeratorArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "ChannelModeratorArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              ChannelModeratorArn: {
                location: "uri",
                locationName: "channelModeratorArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DeleteChannelModerator in the Amazon Chime SDK Messaging Namespace",
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        DeleteEventsConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{accountId}/bots/{botId}/events-configuration",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BotId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              BotId: {
                location: "uri",
                locationName: "botId"
              }
            }
          }
        },
        DeleteMediaCapturePipeline: {
          http: {
            method: "DELETE",
            requestUri: "/media-capture-pipelines/{mediaPipelineId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "MediaPipelineId"
            ],
            members: {
              MediaPipelineId: {
                location: "uri",
                locationName: "mediaPipelineId"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DeleteMediaCapturePipeline in the Amazon Chime SDK Media Pipelines Namespace"
        },
        DeleteMeeting: {
          http: {
            method: "DELETE",
            requestUri: "/meetings/{meetingId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "MeetingId"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DeleteMeeting in the Amazon Chime SDK Meetings Namespace"
        },
        DeletePhoneNumber: {
          http: {
            method: "DELETE",
            requestUri: "/phone-numbers/{phoneNumberId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "PhoneNumberId"
            ],
            members: {
              PhoneNumberId: {
                location: "uri",
                locationName: "phoneNumberId"
              }
            }
          }
        },
        DeleteProxySession: {
          http: {
            method: "DELETE",
            requestUri: "/voice-connectors/{voiceConnectorId}/proxy-sessions/{proxySessionId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "ProxySessionId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              ProxySessionId: {
                location: "uri",
                locationName: "proxySessionId"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DeleteProxySession in the Amazon Chime SDK Voice Namespace"
        },
        DeleteRoom: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{accountId}/rooms/{roomId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "RoomId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              RoomId: {
                location: "uri",
                locationName: "roomId"
              }
            }
          }
        },
        DeleteRoomMembership: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{accountId}/rooms/{roomId}/memberships/{memberId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "RoomId",
              "MemberId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              RoomId: {
                location: "uri",
                locationName: "roomId"
              },
              MemberId: {
                location: "uri",
                locationName: "memberId"
              }
            }
          }
        },
        DeleteSipMediaApplication: {
          http: {
            method: "DELETE",
            requestUri: "/sip-media-applications/{sipMediaApplicationId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "SipMediaApplicationId"
            ],
            members: {
              SipMediaApplicationId: {
                location: "uri",
                locationName: "sipMediaApplicationId"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DeleteSipMediaApplication in the Amazon Chime SDK Voice Namespace"
        },
        DeleteSipRule: {
          http: {
            method: "DELETE",
            requestUri: "/sip-rules/{sipRuleId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "SipRuleId"
            ],
            members: {
              SipRuleId: {
                location: "uri",
                locationName: "sipRuleId"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DeleteSipRule in the Amazon Chime SDK Voice Namespace"
        },
        DeleteVoiceConnector: {
          http: {
            method: "DELETE",
            requestUri: "/voice-connectors/{voiceConnectorId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DeleteVoiceConnector in the Amazon Chime SDK Voice Namespace"
        },
        DeleteVoiceConnectorEmergencyCallingConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/voice-connectors/{voiceConnectorId}/emergency-calling-configuration",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DeleteVoiceConnectorEmergencyCallingConfiguration in the Amazon Chime SDK Voice Namespace"
        },
        DeleteVoiceConnectorGroup: {
          http: {
            method: "DELETE",
            requestUri: "/voice-connector-groups/{voiceConnectorGroupId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorGroupId"
            ],
            members: {
              VoiceConnectorGroupId: {
                location: "uri",
                locationName: "voiceConnectorGroupId"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DeleteVoiceConnectorGroup in the Amazon Chime SDK Voice Namespace"
        },
        DeleteVoiceConnectorOrigination: {
          http: {
            method: "DELETE",
            requestUri: "/voice-connectors/{voiceConnectorId}/origination",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DeleteVoiceConnectorOrigination in the Amazon Chime SDK Voice Namespace"
        },
        DeleteVoiceConnectorProxy: {
          http: {
            method: "DELETE",
            requestUri: "/voice-connectors/{voiceConnectorId}/programmable-numbers/proxy",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DeleteVoiceConnectorProxy in the Amazon Chime SDK Voice Namespace"
        },
        DeleteVoiceConnectorStreamingConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/voice-connectors/{voiceConnectorId}/streaming-configuration",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DeleteVoiceConnectorStreamingConfiguration in the Amazon Chime SDK Voice Namespace"
        },
        DeleteVoiceConnectorTermination: {
          http: {
            method: "DELETE",
            requestUri: "/voice-connectors/{voiceConnectorId}/termination",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DeleteVoiceConnectorTermination in the Amazon Chime SDK Voice Namespace"
        },
        DeleteVoiceConnectorTerminationCredentials: {
          http: {
            requestUri: "/voice-connectors/{voiceConnectorId}/termination/credentials?operation=delete",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Usernames",
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              Usernames: {
                shape: "S6u"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DeleteVoiceConnectorTerminationCredentials in the Amazon Chime SDK Voice Namespace"
        },
        DescribeAppInstance: {
          http: {
            method: "GET",
            requestUri: "/app-instances/{appInstanceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstance: {
                type: "structure",
                members: {
                  AppInstanceArn: {},
                  Name: {
                    shape: "S2e"
                  },
                  Metadata: {
                    shape: "S2f"
                  },
                  CreatedTimestamp: {
                    type: "timestamp"
                  },
                  LastUpdatedTimestamp: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DescribeAppInstance in the Amazon Chime SDK Identity Namespace",
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        DescribeAppInstanceAdmin: {
          http: {
            method: "GET",
            requestUri: "/app-instances/{appInstanceArn}/admins/{appInstanceAdminArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceAdminArn",
              "AppInstanceArn"
            ],
            members: {
              AppInstanceAdminArn: {
                location: "uri",
                locationName: "appInstanceAdminArn"
              },
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceAdmin: {
                type: "structure",
                members: {
                  Admin: {
                    shape: "S14"
                  },
                  AppInstanceArn: {},
                  CreatedTimestamp: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DescribeAppInstanceAdmin in the Amazon Chime SDK Identity Namespace",
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        DescribeAppInstanceUser: {
          http: {
            method: "GET",
            requestUri: "/app-instance-users/{appInstanceUserArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceUserArn"
            ],
            members: {
              AppInstanceUserArn: {
                location: "uri",
                locationName: "appInstanceUserArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceUser: {
                type: "structure",
                members: {
                  AppInstanceUserArn: {},
                  Name: {
                    shape: "S2n"
                  },
                  CreatedTimestamp: {
                    type: "timestamp"
                  },
                  Metadata: {
                    shape: "S2f"
                  },
                  LastUpdatedTimestamp: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DescribeAppInstanceUser in the Amazon Chime SDK Identity Namespace",
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        DescribeChannel: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Channel: {
                type: "structure",
                members: {
                  Name: {
                    shape: "S2e"
                  },
                  ChannelArn: {},
                  Mode: {},
                  Privacy: {},
                  Metadata: {
                    shape: "S2f"
                  },
                  CreatedBy: {
                    shape: "S14"
                  },
                  CreatedTimestamp: {
                    type: "timestamp"
                  },
                  LastMessageTimestamp: {
                    type: "timestamp"
                  },
                  LastUpdatedTimestamp: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DescribeChannel in the Amazon Chime SDK Messaging Namespace",
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        DescribeChannelBan: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/bans/{memberArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MemberArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MemberArn: {
                location: "uri",
                locationName: "memberArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelBan: {
                type: "structure",
                members: {
                  Member: {
                    shape: "S14"
                  },
                  ChannelArn: {},
                  CreatedTimestamp: {
                    type: "timestamp"
                  },
                  CreatedBy: {
                    shape: "S14"
                  }
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DescribeChannelBan in the Amazon Chime SDK Messaging Namespace",
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        DescribeChannelMembership: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/memberships/{memberArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MemberArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MemberArn: {
                location: "uri",
                locationName: "memberArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelMembership: {
                type: "structure",
                members: {
                  InvitedBy: {
                    shape: "S14"
                  },
                  Type: {},
                  Member: {
                    shape: "S14"
                  },
                  ChannelArn: {},
                  CreatedTimestamp: {
                    type: "timestamp"
                  },
                  LastUpdatedTimestamp: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DescribeChannelMembership in the Amazon Chime SDK Messaging Namespace",
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        DescribeChannelMembershipForAppInstanceUser: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}?scope=app-instance-user-membership",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "AppInstanceUserArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              AppInstanceUserArn: {
                location: "querystring",
                locationName: "app-instance-user-arn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelMembership: {
                shape: "S7g"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DescribeChannelMembershipForAppInstanceUser in the Amazon Chime SDK Messaging Namespace",
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        DescribeChannelModeratedByAppInstanceUser: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}?scope=app-instance-user-moderated-channel",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "AppInstanceUserArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              AppInstanceUserArn: {
                location: "querystring",
                locationName: "app-instance-user-arn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Channel: {
                shape: "S7l"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DescribeChannelModeratedByAppInstanceUser in the Amazon Chime SDK Messaging Namespace",
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        DescribeChannelModerator: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/moderators/{channelModeratorArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "ChannelModeratorArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              ChannelModeratorArn: {
                location: "uri",
                locationName: "channelModeratorArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelModerator: {
                type: "structure",
                members: {
                  Moderator: {
                    shape: "S14"
                  },
                  ChannelArn: {},
                  CreatedTimestamp: {
                    type: "timestamp"
                  },
                  CreatedBy: {
                    shape: "S14"
                  }
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DescribeChannelModerator in the Amazon Chime SDK Messaging Namespace",
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        DisassociatePhoneNumberFromUser: {
          http: {
            requestUri: "/accounts/{accountId}/users/{userId}?operation=disassociate-phone-number",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "UserId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              UserId: {
                location: "uri",
                locationName: "userId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociatePhoneNumbersFromVoiceConnector: {
          http: {
            requestUri: "/voice-connectors/{voiceConnectorId}?operation=disassociate-phone-numbers",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "E164PhoneNumbers"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              E164PhoneNumbers: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberErrors: {
                shape: "Sa"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DisassociatePhoneNumbersFromVoiceConnector in the Amazon Chime SDK Voice Namespace"
        },
        DisassociatePhoneNumbersFromVoiceConnectorGroup: {
          http: {
            requestUri: "/voice-connector-groups/{voiceConnectorGroupId}?operation=disassociate-phone-numbers",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorGroupId",
              "E164PhoneNumbers"
            ],
            members: {
              VoiceConnectorGroupId: {
                location: "uri",
                locationName: "voiceConnectorGroupId"
              },
              E164PhoneNumbers: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberErrors: {
                shape: "Sa"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by DisassociatePhoneNumbersFromVoiceConnectorGroup in the Amazon Chime SDK Voice Namespace"
        },
        DisassociateSigninDelegateGroupsFromAccount: {
          http: {
            requestUri: "/accounts/{accountId}?operation=disassociate-signin-delegate-groups",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "GroupNames"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              GroupNames: {
                shape: "S1h"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetAccount: {
          http: {
            method: "GET",
            requestUri: "/accounts/{accountId}"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Account: {
                shape: "S28"
              }
            }
          }
        },
        GetAccountSettings: {
          http: {
            method: "GET",
            requestUri: "/accounts/{accountId}/settings"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccountSettings: {
                shape: "S81"
              }
            }
          }
        },
        GetAppInstanceRetentionSettings: {
          http: {
            method: "GET",
            requestUri: "/app-instances/{appInstanceArn}/retention-settings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceRetentionSettings: {
                shape: "S84"
              },
              InitiateDeletionTimestamp: {
                type: "timestamp"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by GetAppInstanceRetentionSettings in the Amazon Chime SDK Identity Namespace",
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        GetAppInstanceStreamingConfigurations: {
          http: {
            method: "GET",
            requestUri: "/app-instances/{appInstanceArn}/streaming-configurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceStreamingConfigurations: {
                shape: "S89"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by GetAppInstanceStreamingConfigurations in the Amazon Chime SDK Messaging Namespace"
        },
        GetAttendee: {
          http: {
            method: "GET",
            requestUri: "/meetings/{meetingId}/attendees/{attendeeId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MeetingId",
              "AttendeeId"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              },
              AttendeeId: {
                location: "uri",
                locationName: "attendeeId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attendee: {
                shape: "Su"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by GetAttendee in the Amazon Chime SDK Meetings Namespace"
        },
        GetBot: {
          http: {
            method: "GET",
            requestUri: "/accounts/{accountId}/bots/{botId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BotId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              BotId: {
                location: "uri",
                locationName: "botId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Bot: {
                shape: "S2t"
              }
            }
          }
        },
        GetChannelMessage: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/messages/{messageId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MessageId"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MessageId: {
                location: "uri",
                locationName: "messageId"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelMessage: {
                type: "structure",
                members: {
                  ChannelArn: {},
                  MessageId: {},
                  Content: {
                    shape: "S8j"
                  },
                  Metadata: {
                    shape: "S2f"
                  },
                  Type: {},
                  CreatedTimestamp: {
                    type: "timestamp"
                  },
                  LastEditedTimestamp: {
                    type: "timestamp"
                  },
                  LastUpdatedTimestamp: {
                    type: "timestamp"
                  },
                  Sender: {
                    shape: "S14"
                  },
                  Redacted: {
                    type: "boolean"
                  },
                  Persistence: {}
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by GetChannelMessage in the Amazon Chime SDK Messaging Namespace",
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        GetEventsConfiguration: {
          http: {
            method: "GET",
            requestUri: "/accounts/{accountId}/bots/{botId}/events-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BotId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              BotId: {
                location: "uri",
                locationName: "botId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventsConfiguration: {
                shape: "S8p"
              }
            }
          }
        },
        GetGlobalSettings: {
          http: {
            method: "GET",
            requestUri: "/settings",
            responseCode: 200
          },
          output: {
            type: "structure",
            members: {
              BusinessCalling: {
                shape: "S8r"
              },
              VoiceConnector: {
                shape: "S8s"
              }
            }
          }
        },
        GetMediaCapturePipeline: {
          http: {
            method: "GET",
            requestUri: "/media-capture-pipelines/{mediaPipelineId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MediaPipelineId"
            ],
            members: {
              MediaPipelineId: {
                location: "uri",
                locationName: "mediaPipelineId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MediaCapturePipeline: {
                shape: "S3n"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by GetMediaCapturePipeline in the Amazon Chime SDK Media Pipelines Namespace"
        },
        GetMeeting: {
          http: {
            method: "GET",
            requestUri: "/meetings/{meetingId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MeetingId"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Meeting: {
                shape: "S3u"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by GetMeeting in the Amazon Chime SDK Meetings Namespace"
        },
        GetMessagingSessionEndpoint: {
          http: {
            method: "GET",
            requestUri: "/endpoints/messaging-session",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              Endpoint: {
                type: "structure",
                members: {
                  Url: {}
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by GetMessagingSessionEndpoint in the Amazon Chime SDK Messaging Namespace",
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        GetPhoneNumber: {
          http: {
            method: "GET",
            requestUri: "/phone-numbers/{phoneNumberId}"
          },
          input: {
            type: "structure",
            required: [
              "PhoneNumberId"
            ],
            members: {
              PhoneNumberId: {
                location: "uri",
                locationName: "phoneNumberId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumber: {
                shape: "S93"
              }
            }
          }
        },
        GetPhoneNumberOrder: {
          http: {
            method: "GET",
            requestUri: "/phone-number-orders/{phoneNumberOrderId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "PhoneNumberOrderId"
            ],
            members: {
              PhoneNumberOrderId: {
                location: "uri",
                locationName: "phoneNumberOrderId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberOrder: {
                shape: "S44"
              }
            }
          }
        },
        GetPhoneNumberSettings: {
          http: {
            method: "GET",
            requestUri: "/settings/phone-number",
            responseCode: 200
          },
          output: {
            type: "structure",
            members: {
              CallingName: {
                shape: "S1u"
              },
              CallingNameUpdatedTimestamp: {
                shape: "S2a"
              }
            }
          }
        },
        GetProxySession: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}/proxy-sessions/{proxySessionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "ProxySessionId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              ProxySessionId: {
                location: "uri",
                locationName: "proxySessionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProxySession: {
                shape: "S4m"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by GetProxySession in the Amazon Chime SDK Voice Namespace"
        },
        GetRetentionSettings: {
          http: {
            method: "GET",
            requestUri: "/accounts/{accountId}/retention-settings"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RetentionSettings: {
                shape: "S9j"
              },
              InitiateDeletionTimestamp: {
                shape: "S2a"
              }
            }
          }
        },
        GetRoom: {
          http: {
            method: "GET",
            requestUri: "/accounts/{accountId}/rooms/{roomId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "RoomId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              RoomId: {
                location: "uri",
                locationName: "roomId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Room: {
                shape: "S4t"
              }
            }
          }
        },
        GetSipMediaApplication: {
          http: {
            method: "GET",
            requestUri: "/sip-media-applications/{sipMediaApplicationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SipMediaApplicationId"
            ],
            members: {
              SipMediaApplicationId: {
                location: "uri",
                locationName: "sipMediaApplicationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipMediaApplication: {
                shape: "S55"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by GetSipMediaApplication in the Amazon Chime SDK Voice Namespace"
        },
        GetSipMediaApplicationLoggingConfiguration: {
          http: {
            method: "GET",
            requestUri: "/sip-media-applications/{sipMediaApplicationId}/logging-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SipMediaApplicationId"
            ],
            members: {
              SipMediaApplicationId: {
                location: "uri",
                locationName: "sipMediaApplicationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipMediaApplicationLoggingConfiguration: {
                shape: "S9s"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by GetSipMediaApplicationLoggingConfiguration in the Amazon Chime SDK Voice Namespace"
        },
        GetSipRule: {
          http: {
            method: "GET",
            requestUri: "/sip-rules/{sipRuleId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SipRuleId"
            ],
            members: {
              SipRuleId: {
                location: "uri",
                locationName: "sipRuleId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipRule: {
                shape: "S5h"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by GetSipRule in the Amazon Chime SDK Voice Namespace"
        },
        GetUser: {
          http: {
            method: "GET",
            requestUri: "/accounts/{accountId}/users/{userId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "UserId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              UserId: {
                location: "uri",
                locationName: "userId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                shape: "S5l"
              }
            }
          }
        },
        GetUserSettings: {
          http: {
            method: "GET",
            requestUri: "/accounts/{accountId}/users/{userId}/settings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "UserId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              UserId: {
                location: "uri",
                locationName: "userId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserSettings: {
                shape: "S9z"
              }
            }
          }
        },
        GetVoiceConnector: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceConnector: {
                shape: "S5s"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by GetVoiceConnector in the Amazon Chime SDK Voice Namespace"
        },
        GetVoiceConnectorEmergencyCallingConfiguration: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}/emergency-calling-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EmergencyCallingConfiguration: {
                shape: "Sa5"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by GetVoiceConnectorEmergencyCallingConfiguration in the Amazon Chime SDK Voice Namespace"
        },
        GetVoiceConnectorGroup: {
          http: {
            method: "GET",
            requestUri: "/voice-connector-groups/{voiceConnectorGroupId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorGroupId"
            ],
            members: {
              VoiceConnectorGroupId: {
                location: "uri",
                locationName: "voiceConnectorGroupId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceConnectorGroup: {
                shape: "S5z"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by GetVoiceConnectorGroup in the Amazon Chime SDK Voice Namespace"
        },
        GetVoiceConnectorLoggingConfiguration: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}/logging-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LoggingConfiguration: {
                shape: "Sac"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by GetVoiceConnectorLoggingConfiguration in the Amazon Chime SDK Voice Namespace"
        },
        GetVoiceConnectorOrigination: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}/origination",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Origination: {
                shape: "Saf"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by GetVoiceConnectorOrigination in the Amazon Chime SDK Voice Namespace"
        },
        GetVoiceConnectorProxy: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}/programmable-numbers/proxy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Proxy: {
                shape: "Sao"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by GetVoiceConnectorProxy in the Amazon Chime SDK Voice Namespace"
        },
        GetVoiceConnectorStreamingConfiguration: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}/streaming-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingConfiguration: {
                shape: "Sat"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by GetVoiceConnectorStreamingConfiguration in the Amazon Chime SDK Voice Namespace"
        },
        GetVoiceConnectorTermination: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}/termination",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Termination: {
                shape: "Sb0"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by GetVoiceConnectorTermination in the Amazon Chime SDK Voice Namespace"
        },
        GetVoiceConnectorTerminationHealth: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}/termination/health",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TerminationHealth: {
                type: "structure",
                members: {
                  Timestamp: {
                    shape: "S2a"
                  },
                  Source: {}
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by GetVoiceConnectorTerminationHealth in the Amazon Chime SDK Voice Namespace"
        },
        InviteUsers: {
          http: {
            requestUri: "/accounts/{accountId}/users?operation=add",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "UserEmailList"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              UserEmailList: {
                type: "list",
                member: {
                  shape: "S5j"
                }
              },
              UserType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Invites: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InviteId: {},
                    Status: {},
                    EmailAddress: {
                      shape: "S5j"
                    },
                    EmailStatus: {}
                  }
                }
              }
            }
          }
        },
        ListAccounts: {
          http: {
            method: "GET",
            requestUri: "/accounts"
          },
          input: {
            type: "structure",
            members: {
              Name: {
                location: "querystring",
                locationName: "name"
              },
              UserEmail: {
                shape: "S5j",
                location: "querystring",
                locationName: "user-email"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Accounts: {
                type: "list",
                member: {
                  shape: "S28"
                }
              },
              NextToken: {}
            }
          }
        },
        ListAppInstanceAdmins: {
          http: {
            method: "GET",
            requestUri: "/app-instances/{appInstanceArn}/admins",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "Sbj",
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceArn: {},
              AppInstanceAdmins: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Admin: {
                      shape: "S14"
                    }
                  }
                }
              },
              NextToken: {
                shape: "Sbj"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by ListAppInstanceAdmins in the Amazon Chime SDK Identity Namespace",
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        ListAppInstanceUsers: {
          http: {
            method: "GET",
            requestUri: "/app-instance-users",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn"
            ],
            members: {
              AppInstanceArn: {
                location: "querystring",
                locationName: "app-instance-arn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "Sbj",
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceArn: {},
              AppInstanceUsers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AppInstanceUserArn: {},
                    Name: {
                      shape: "S2n"
                    },
                    Metadata: {
                      shape: "S2f"
                    }
                  }
                }
              },
              NextToken: {
                shape: "Sbj"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by ListAppInstanceUsers in the Amazon Chime SDK Identity Namespace",
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        ListAppInstances: {
          http: {
            method: "GET",
            requestUri: "/app-instances",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "Sbj",
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AppInstanceArn: {},
                    Name: {
                      shape: "S2e"
                    },
                    Metadata: {
                      shape: "S2f"
                    }
                  }
                }
              },
              NextToken: {
                shape: "Sbj"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by ListAppInstances in the Amazon Chime SDK Identity Namespace",
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        ListAttendeeTags: {
          http: {
            method: "GET",
            requestUri: "/meetings/{meetingId}/attendees/{attendeeId}/tags",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MeetingId",
              "AttendeeId"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              },
              AttendeeId: {
                location: "uri",
                locationName: "attendeeId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S2h"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Attendee Tags are not supported in the Amazon Chime SDK Meetings Namespace. Update your application to remove calls to this API."
        },
        ListAttendees: {
          http: {
            method: "GET",
            requestUri: "/meetings/{meetingId}/attendees",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MeetingId"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attendees: {
                shape: "St"
              },
              NextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by ListAttendees in the Amazon Chime SDK Meetings Namespace"
        },
        ListBots: {
          http: {
            method: "GET",
            requestUri: "/accounts/{accountId}/bots",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Bots: {
                type: "list",
                member: {
                  shape: "S2t"
                }
              },
              NextToken: {}
            }
          }
        },
        ListChannelBans: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/bans",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "Sbj",
                location: "querystring",
                locationName: "next-token"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              NextToken: {
                shape: "Sbj"
              },
              ChannelBans: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Member: {
                      shape: "S14"
                    }
                  }
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by ListChannelBans in the Amazon Chime SDK Messaging Namespace",
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        ListChannelMemberships: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/memberships",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              Type: {
                location: "querystring",
                locationName: "type"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "Sbj",
                location: "querystring",
                locationName: "next-token"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              ChannelMemberships: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Member: {
                      shape: "S14"
                    }
                  }
                }
              },
              NextToken: {
                shape: "Sbj"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by ListChannelMemberships in the Amazon Chime SDK Messaging Namespace",
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        ListChannelMembershipsForAppInstanceUser: {
          http: {
            method: "GET",
            requestUri: "/channels?scope=app-instance-user-memberships",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppInstanceUserArn: {
                location: "querystring",
                locationName: "app-instance-user-arn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "Sbj",
                location: "querystring",
                locationName: "next-token"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelMemberships: {
                type: "list",
                member: {
                  shape: "S7g"
                }
              },
              NextToken: {
                shape: "Sbj"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by ListChannelMembershipsForAppInstanceUser in the Amazon Chime SDK Messaging Namespace",
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        ListChannelMessages: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/messages",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              SortOrder: {
                location: "querystring",
                locationName: "sort-order"
              },
              NotBefore: {
                location: "querystring",
                locationName: "not-before",
                type: "timestamp"
              },
              NotAfter: {
                location: "querystring",
                locationName: "not-after",
                type: "timestamp"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "Sbj",
                location: "querystring",
                locationName: "next-token"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              NextToken: {
                shape: "Sbj"
              },
              ChannelMessages: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MessageId: {},
                    Content: {
                      shape: "S8j"
                    },
                    Metadata: {
                      shape: "S2f"
                    },
                    Type: {},
                    CreatedTimestamp: {
                      type: "timestamp"
                    },
                    LastUpdatedTimestamp: {
                      type: "timestamp"
                    },
                    LastEditedTimestamp: {
                      type: "timestamp"
                    },
                    Sender: {
                      shape: "S14"
                    },
                    Redacted: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by ListChannelMessages in the Amazon Chime SDK Messaging Namespace",
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        ListChannelModerators: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/moderators",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "Sbj",
                location: "querystring",
                locationName: "next-token"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              NextToken: {
                shape: "Sbj"
              },
              ChannelModerators: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Moderator: {
                      shape: "S14"
                    }
                  }
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by ListChannelModerators in the Amazon Chime SDK Messaging Namespace",
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        ListChannels: {
          http: {
            method: "GET",
            requestUri: "/channels",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn"
            ],
            members: {
              AppInstanceArn: {
                location: "querystring",
                locationName: "app-instance-arn"
              },
              Privacy: {
                location: "querystring",
                locationName: "privacy"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "Sbj",
                location: "querystring",
                locationName: "next-token"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Channels: {
                type: "list",
                member: {
                  shape: "S7h"
                }
              },
              NextToken: {
                shape: "Sbj"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by ListChannels in the Amazon Chime SDK Messaging Namespace",
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        ListChannelsModeratedByAppInstanceUser: {
          http: {
            method: "GET",
            requestUri: "/channels?scope=app-instance-user-moderated-channels",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppInstanceUserArn: {
                location: "querystring",
                locationName: "app-instance-user-arn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "Sbj",
                location: "querystring",
                locationName: "next-token"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Channels: {
                type: "list",
                member: {
                  shape: "S7l"
                }
              },
              NextToken: {
                shape: "Sbj"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by ListChannelsModeratedByAppInstanceUser in the Amazon Chime SDK Messaging Namespace",
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        ListMediaCapturePipelines: {
          http: {
            method: "GET",
            requestUri: "/media-capture-pipelines",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MediaCapturePipelines: {
                type: "list",
                member: {
                  shape: "S3n"
                }
              },
              NextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by ListMediaCapturePipelines in the Amazon Chime SDK Media Pipelines Namespace"
        },
        ListMeetingTags: {
          http: {
            method: "GET",
            requestUri: "/meetings/{meetingId}/tags",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MeetingId"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S2h"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Use ListTagsForResource in the Amazon Chime SDK Meetings Namespace."
        },
        ListMeetings: {
          http: {
            method: "GET",
            requestUri: "/meetings",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Meetings: {
                type: "list",
                member: {
                  shape: "S3u"
                }
              },
              NextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "ListMeetings is not supported in the Amazon Chime SDK Meetings Namespace. Update your application to remove calls to this API."
        },
        ListPhoneNumberOrders: {
          http: {
            method: "GET",
            requestUri: "/phone-number-orders",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberOrders: {
                type: "list",
                member: {
                  shape: "S44"
                }
              },
              NextToken: {}
            }
          }
        },
        ListPhoneNumbers: {
          http: {
            method: "GET",
            requestUri: "/phone-numbers"
          },
          input: {
            type: "structure",
            members: {
              Status: {
                location: "querystring",
                locationName: "status"
              },
              ProductType: {
                location: "querystring",
                locationName: "product-type"
              },
              FilterName: {
                location: "querystring",
                locationName: "filter-name"
              },
              FilterValue: {
                location: "querystring",
                locationName: "filter-value"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumbers: {
                type: "list",
                member: {
                  shape: "S93"
                }
              },
              NextToken: {}
            }
          }
        },
        ListProxySessions: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}/proxy-sessions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              Status: {
                location: "querystring",
                locationName: "status"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProxySessions: {
                type: "list",
                member: {
                  shape: "S4m"
                }
              },
              NextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by ListProxySessions in the Amazon Chime SDK Voice Namespace"
        },
        ListRoomMemberships: {
          http: {
            method: "GET",
            requestUri: "/accounts/{accountId}/rooms/{roomId}/memberships",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "RoomId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              RoomId: {
                location: "uri",
                locationName: "roomId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RoomMemberships: {
                type: "list",
                member: {
                  shape: "S4w"
                }
              },
              NextToken: {}
            }
          }
        },
        ListRooms: {
          http: {
            method: "GET",
            requestUri: "/accounts/{accountId}/rooms",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              MemberId: {
                location: "querystring",
                locationName: "member-id"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Rooms: {
                type: "list",
                member: {
                  shape: "S4t"
                }
              },
              NextToken: {}
            }
          }
        },
        ListSipMediaApplications: {
          http: {
            method: "GET",
            requestUri: "/sip-media-applications",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipMediaApplications: {
                type: "list",
                member: {
                  shape: "S55"
                }
              },
              NextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by ListSipMediaApplications in the Amazon Chime SDK Voice Namespace"
        },
        ListSipRules: {
          http: {
            method: "GET",
            requestUri: "/sip-rules",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              SipMediaApplicationId: {
                location: "querystring",
                locationName: "sip-media-application"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipRules: {
                type: "list",
                member: {
                  shape: "S5h"
                }
              },
              NextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by ListSipRules in the Amazon Chime SDK Voice Namespace"
        },
        ListSupportedPhoneNumberCountries: {
          http: {
            method: "GET",
            requestUri: "/phone-number-countries",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ProductType"
            ],
            members: {
              ProductType: {
                location: "querystring",
                locationName: "product-type"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberCountries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CountryCode: {},
                    SupportedPhoneNumberTypes: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags"
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {
                shape: "S37",
                location: "querystring",
                locationName: "arn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S2h"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by ListTagsForResource in the Amazon Chime SDK Voice, Amazon Chime SDK Meetings, Amazon Chime SDK Identity, Amazon Chime SDK Messaging, and Amazon Chime SDK Media Pipelines Namespaces"
        },
        ListUsers: {
          http: {
            method: "GET",
            requestUri: "/accounts/{accountId}/users",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              UserEmail: {
                shape: "S5j",
                location: "querystring",
                locationName: "user-email"
              },
              UserType: {
                location: "querystring",
                locationName: "user-type"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Users: {
                type: "list",
                member: {
                  shape: "S5l"
                }
              },
              NextToken: {}
            }
          }
        },
        ListVoiceConnectorGroups: {
          http: {
            method: "GET",
            requestUri: "/voice-connector-groups",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceConnectorGroups: {
                type: "list",
                member: {
                  shape: "S5z"
                }
              },
              NextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by ListVoiceConnectorGroups in the Amazon Chime SDK Voice Namespace"
        },
        ListVoiceConnectorTerminationCredentials: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}/termination/credentials",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Usernames: {
                shape: "S6u"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by ListVoiceConnectorTerminationCredentials in the Amazon Chime SDK Voice Namespace"
        },
        ListVoiceConnectors: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceConnectors: {
                type: "list",
                member: {
                  shape: "S5s"
                }
              },
              NextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by ListVoiceConnectors in the Amazon Chime SDK Voice Namespace"
        },
        LogoutUser: {
          http: {
            requestUri: "/accounts/{accountId}/users/{userId}?operation=logout",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "UserId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              UserId: {
                location: "uri",
                locationName: "userId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutAppInstanceRetentionSettings: {
          http: {
            method: "PUT",
            requestUri: "/app-instances/{appInstanceArn}/retention-settings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn",
              "AppInstanceRetentionSettings"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              },
              AppInstanceRetentionSettings: {
                shape: "S84"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceRetentionSettings: {
                shape: "S84"
              },
              InitiateDeletionTimestamp: {
                type: "timestamp"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by PutAppInstanceRetentionSettings in the Amazon Chime SDK Identity Namespace",
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        PutAppInstanceStreamingConfigurations: {
          http: {
            method: "PUT",
            requestUri: "/app-instances/{appInstanceArn}/streaming-configurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn",
              "AppInstanceStreamingConfigurations"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              },
              AppInstanceStreamingConfigurations: {
                shape: "S89"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceStreamingConfigurations: {
                shape: "S89"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by PutAppInstanceStreamingConfigurations in the Amazon Chime SDK Messaging Namespace"
        },
        PutEventsConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{accountId}/bots/{botId}/events-configuration",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BotId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              BotId: {
                location: "uri",
                locationName: "botId"
              },
              OutboundEventsHTTPSEndpoint: {
                shape: "S23"
              },
              LambdaFunctionArn: {
                shape: "S23"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventsConfiguration: {
                shape: "S8p"
              }
            }
          }
        },
        PutRetentionSettings: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{accountId}/retention-settings",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "RetentionSettings"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              RetentionSettings: {
                shape: "S9j"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RetentionSettings: {
                shape: "S9j"
              },
              InitiateDeletionTimestamp: {
                shape: "S2a"
              }
            }
          }
        },
        PutSipMediaApplicationLoggingConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/sip-media-applications/{sipMediaApplicationId}/logging-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SipMediaApplicationId"
            ],
            members: {
              SipMediaApplicationId: {
                location: "uri",
                locationName: "sipMediaApplicationId"
              },
              SipMediaApplicationLoggingConfiguration: {
                shape: "S9s"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipMediaApplicationLoggingConfiguration: {
                shape: "S9s"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by PutSipMediaApplicationLoggingConfiguration in the Amazon Chime SDK Voice Namespace"
        },
        PutVoiceConnectorEmergencyCallingConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/voice-connectors/{voiceConnectorId}/emergency-calling-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "EmergencyCallingConfiguration"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              EmergencyCallingConfiguration: {
                shape: "Sa5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EmergencyCallingConfiguration: {
                shape: "Sa5"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by PutVoiceConnectorEmergencyCallingConfiguration in the Amazon Chime SDK Voice Namespace"
        },
        PutVoiceConnectorLoggingConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/voice-connectors/{voiceConnectorId}/logging-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "LoggingConfiguration"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              LoggingConfiguration: {
                shape: "Sac"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LoggingConfiguration: {
                shape: "Sac"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by PutVoiceConnectorLoggingConfiguration in the Amazon Chime SDK Voice Namespace"
        },
        PutVoiceConnectorOrigination: {
          http: {
            method: "PUT",
            requestUri: "/voice-connectors/{voiceConnectorId}/origination",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "Origination"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              Origination: {
                shape: "Saf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Origination: {
                shape: "Saf"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by PutVoiceConnectorOrigination in the Amazon Chime SDK Voice Namespace"
        },
        PutVoiceConnectorProxy: {
          http: {
            method: "PUT",
            requestUri: "/voice-connectors/{voiceConnectorId}/programmable-numbers/proxy"
          },
          input: {
            type: "structure",
            required: [
              "DefaultSessionExpiryMinutes",
              "PhoneNumberPoolCountries",
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              DefaultSessionExpiryMinutes: {
                type: "integer"
              },
              PhoneNumberPoolCountries: {
                type: "list",
                member: {}
              },
              FallBackPhoneNumber: {
                shape: "S3"
              },
              Disabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Proxy: {
                shape: "Sao"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by PutVoiceConnectorProxy in the Amazon Chime SDK Voice Namespace"
        },
        PutVoiceConnectorStreamingConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/voice-connectors/{voiceConnectorId}/streaming-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "StreamingConfiguration"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              StreamingConfiguration: {
                shape: "Sat"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingConfiguration: {
                shape: "Sat"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by PutVoiceConnectorStreamingConfiguration in the Amazon Chime SDK Voice Namespace"
        },
        PutVoiceConnectorTermination: {
          http: {
            method: "PUT",
            requestUri: "/voice-connectors/{voiceConnectorId}/termination",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "Termination"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              Termination: {
                shape: "Sb0"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Termination: {
                shape: "Sb0"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by PutVoiceConnectorTermination in the Amazon Chime SDK Voice Namespace"
        },
        PutVoiceConnectorTerminationCredentials: {
          http: {
            requestUri: "/voice-connectors/{voiceConnectorId}/termination/credentials?operation=put",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              Credentials: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Username: {
                      shape: "S23"
                    },
                    Password: {
                      shape: "S23"
                    }
                  }
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by PutVoiceConnectorTerminationCredentials in the Amazon Chime SDK Voice Namespace"
        },
        RedactChannelMessage: {
          http: {
            requestUri: "/channels/{channelArn}/messages/{messageId}?operation=redact",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MessageId"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MessageId: {
                location: "uri",
                locationName: "messageId"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              MessageId: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by RedactChannelMessage in the Amazon Chime SDK Messaging Namespace",
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        RedactConversationMessage: {
          http: {
            requestUri: "/accounts/{accountId}/conversations/{conversationId}/messages/{messageId}?operation=redact",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "ConversationId",
              "MessageId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              ConversationId: {
                location: "uri",
                locationName: "conversationId"
              },
              MessageId: {
                location: "uri",
                locationName: "messageId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RedactRoomMessage: {
          http: {
            requestUri: "/accounts/{accountId}/rooms/{roomId}/messages/{messageId}?operation=redact",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "RoomId",
              "MessageId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              RoomId: {
                location: "uri",
                locationName: "roomId"
              },
              MessageId: {
                location: "uri",
                locationName: "messageId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RegenerateSecurityToken: {
          http: {
            requestUri: "/accounts/{accountId}/bots/{botId}?operation=regenerate-security-token",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BotId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              BotId: {
                location: "uri",
                locationName: "botId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Bot: {
                shape: "S2t"
              }
            }
          }
        },
        ResetPersonalPIN: {
          http: {
            requestUri: "/accounts/{accountId}/users/{userId}?operation=reset-personal-pin",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "UserId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              UserId: {
                location: "uri",
                locationName: "userId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                shape: "S5l"
              }
            }
          }
        },
        RestorePhoneNumber: {
          http: {
            requestUri: "/phone-numbers/{phoneNumberId}?operation=restore",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "PhoneNumberId"
            ],
            members: {
              PhoneNumberId: {
                location: "uri",
                locationName: "phoneNumberId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumber: {
                shape: "S93"
              }
            }
          }
        },
        SearchAvailablePhoneNumbers: {
          http: {
            method: "GET",
            requestUri: "/search?type=phone-numbers"
          },
          input: {
            type: "structure",
            members: {
              AreaCode: {
                location: "querystring",
                locationName: "area-code"
              },
              City: {
                location: "querystring",
                locationName: "city"
              },
              Country: {
                location: "querystring",
                locationName: "country"
              },
              State: {
                location: "querystring",
                locationName: "state"
              },
              TollFreePrefix: {
                location: "querystring",
                locationName: "toll-free-prefix"
              },
              PhoneNumberType: {
                location: "querystring",
                locationName: "phone-number-type"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              E164PhoneNumbers: {
                shape: "S7"
              },
              NextToken: {}
            }
          }
        },
        SendChannelMessage: {
          http: {
            requestUri: "/channels/{channelArn}/messages",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "Content",
              "Type",
              "Persistence",
              "ClientRequestToken"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              Content: {
                type: "string",
                sensitive: true
              },
              Type: {},
              Persistence: {},
              Metadata: {
                shape: "S2f"
              },
              ClientRequestToken: {
                shape: "S2g",
                idempotencyToken: true
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              MessageId: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by SendChannelMessage in the Amazon Chime SDK Messaging Namespace",
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        StartMeetingTranscription: {
          http: {
            requestUri: "/meetings/{meetingId}/transcription?operation=start",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MeetingId",
              "TranscriptionConfiguration"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              },
              TranscriptionConfiguration: {
                type: "structure",
                members: {
                  EngineTranscribeSettings: {
                    type: "structure",
                    members: {
                      LanguageCode: {},
                      VocabularyFilterMethod: {},
                      VocabularyFilterName: {},
                      VocabularyName: {},
                      Region: {},
                      EnablePartialResultsStabilization: {
                        type: "boolean"
                      },
                      PartialResultsStability: {},
                      ContentIdentificationType: {},
                      ContentRedactionType: {},
                      PiiEntityTypes: {},
                      LanguageModelName: {},
                      IdentifyLanguage: {
                        type: "boolean"
                      },
                      LanguageOptions: {},
                      PreferredLanguage: {},
                      VocabularyNames: {},
                      VocabularyFilterNames: {}
                    }
                  },
                  EngineTranscribeMedicalSettings: {
                    type: "structure",
                    required: [
                      "LanguageCode",
                      "Specialty",
                      "Type"
                    ],
                    members: {
                      LanguageCode: {},
                      Specialty: {},
                      Type: {},
                      VocabularyName: {},
                      Region: {},
                      ContentIdentificationType: {}
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Replaced by StartMeetingTranscription in the Amazon Chime SDK Meetings Namespace"
        },
        StopMeetingTranscription: {
          http: {
            requestUri: "/meetings/{meetingId}/transcription?operation=stop",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MeetingId"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Replaced by StopMeetingTranscription in the Amazon Chime SDK Meetings Namespace"
        },
        TagAttendee: {
          http: {
            requestUri: "/meetings/{meetingId}/attendees/{attendeeId}/tags?operation=add",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "MeetingId",
              "AttendeeId",
              "Tags"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              },
              AttendeeId: {
                location: "uri",
                locationName: "attendeeId"
              },
              Tags: {
                shape: "So"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Attendee Tags are not supported in the Amazon Chime SDK Meetings Namespace. Update your application to remove calls to this API."
        },
        TagMeeting: {
          http: {
            requestUri: "/meetings/{meetingId}/tags?operation=add",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "MeetingId",
              "Tags"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              },
              Tags: {
                shape: "S3r"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Use TagResource in the Amazon Chime SDK Meetings Namespace."
        },
        TagResource: {
          http: {
            requestUri: "/tags?operation=tag-resource",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {
                shape: "S37"
              },
              Tags: {
                shape: "S2h"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by TagResource in the Amazon Chime SDK Voice, Amazon Chime SDK Meetings, Amazon Chime SDK Identity, Amazon Chime SDK Messaging, and Amazon Chime SDK Media Pipelines Namespaces"
        },
        UntagAttendee: {
          http: {
            requestUri: "/meetings/{meetingId}/attendees/{attendeeId}/tags?operation=delete",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "MeetingId",
              "TagKeys",
              "AttendeeId"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              },
              AttendeeId: {
                location: "uri",
                locationName: "attendeeId"
              },
              TagKeys: {
                type: "list",
                member: {
                  shape: "Sq"
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Attendee Tags are not supported in the Amazon Chime SDK Meetings Namespace. Update your application to remove calls to this API."
        },
        UntagMeeting: {
          http: {
            requestUri: "/meetings/{meetingId}/tags?operation=delete",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "MeetingId",
              "TagKeys"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              },
              TagKeys: {
                type: "list",
                member: {
                  shape: "Sq"
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Use UntagResource in the Amazon Chime SDK Meetings Namespace."
        },
        UntagResource: {
          http: {
            requestUri: "/tags?operation=untag-resource",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {
                shape: "S37"
              },
              TagKeys: {
                type: "list",
                member: {
                  shape: "Sq"
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by UntagResource in the Amazon Chime SDK Voice, Amazon Chime SDK Meetings, Amazon Chime SDK Identity, Amazon Chime SDK Messaging, and Amazon Chime SDK Media Pipelines Namespaces"
        },
        UpdateAccount: {
          http: {
            requestUri: "/accounts/{accountId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              Name: {},
              DefaultLicense: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Account: {
                shape: "S28"
              }
            }
          }
        },
        UpdateAccountSettings: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{accountId}/settings",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "AccountSettings"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              AccountSettings: {
                shape: "S81"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAppInstance: {
          http: {
            method: "PUT",
            requestUri: "/app-instances/{appInstanceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn",
              "Name"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              },
              Name: {
                shape: "S2e"
              },
              Metadata: {
                shape: "S2f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceArn: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by UpdateAppInstance in the Amazon Chime SDK Identity Namespace",
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        UpdateAppInstanceUser: {
          http: {
            method: "PUT",
            requestUri: "/app-instance-users/{appInstanceUserArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceUserArn",
              "Name"
            ],
            members: {
              AppInstanceUserArn: {
                location: "uri",
                locationName: "appInstanceUserArn"
              },
              Name: {
                shape: "S2n"
              },
              Metadata: {
                shape: "S2f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceUserArn: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by UpdateAppInstanceUser in the Amazon Chime SDK Identity Namespace",
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        UpdateBot: {
          http: {
            requestUri: "/accounts/{accountId}/bots/{botId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BotId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              BotId: {
                location: "uri",
                locationName: "botId"
              },
              Disabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Bot: {
                shape: "S2t"
              }
            }
          }
        },
        UpdateChannel: {
          http: {
            method: "PUT",
            requestUri: "/channels/{channelArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "Name",
              "Mode"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              Name: {
                shape: "S2e"
              },
              Mode: {},
              Metadata: {
                shape: "S2f"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by UpdateChannel in the Amazon Chime SDK Messaging Namespace",
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        UpdateChannelMessage: {
          http: {
            method: "PUT",
            requestUri: "/channels/{channelArn}/messages/{messageId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MessageId"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MessageId: {
                location: "uri",
                locationName: "messageId"
              },
              Content: {
                shape: "S8j"
              },
              Metadata: {
                shape: "S2f"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              MessageId: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by UpdateChannelMessage in the Amazon Chime SDK Messaging Namespace",
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        UpdateChannelReadMarker: {
          http: {
            method: "PUT",
            requestUri: "/channels/{channelArn}/readMarker",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by UpdateChannelReadMarker in the Amazon Chime SDK Messaging Namespace",
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        UpdateGlobalSettings: {
          http: {
            method: "PUT",
            requestUri: "/settings",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              BusinessCalling: {
                shape: "S8r"
              },
              VoiceConnector: {
                shape: "S8s"
              }
            }
          }
        },
        UpdatePhoneNumber: {
          http: {
            requestUri: "/phone-numbers/{phoneNumberId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "PhoneNumberId"
            ],
            members: {
              PhoneNumberId: {
                location: "uri",
                locationName: "phoneNumberId"
              },
              ProductType: {},
              CallingName: {
                shape: "S1u"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumber: {
                shape: "S93"
              }
            }
          }
        },
        UpdatePhoneNumberSettings: {
          http: {
            method: "PUT",
            requestUri: "/settings/phone-number",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "CallingName"
            ],
            members: {
              CallingName: {
                shape: "S1u"
              }
            }
          }
        },
        UpdateProxySession: {
          http: {
            requestUri: "/voice-connectors/{voiceConnectorId}/proxy-sessions/{proxySessionId}",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Capabilities",
              "VoiceConnectorId",
              "ProxySessionId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              ProxySessionId: {
                location: "uri",
                locationName: "proxySessionId"
              },
              Capabilities: {
                shape: "S4e"
              },
              ExpiryMinutes: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProxySession: {
                shape: "S4m"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by UpdateProxySession in the Amazon Chime SDK Voice Namespace"
        },
        UpdateRoom: {
          http: {
            requestUri: "/accounts/{accountId}/rooms/{roomId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "RoomId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              RoomId: {
                location: "uri",
                locationName: "roomId"
              },
              Name: {
                shape: "S23"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Room: {
                shape: "S4t"
              }
            }
          }
        },
        UpdateRoomMembership: {
          http: {
            requestUri: "/accounts/{accountId}/rooms/{roomId}/memberships/{memberId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "RoomId",
              "MemberId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              RoomId: {
                location: "uri",
                locationName: "roomId"
              },
              MemberId: {
                location: "uri",
                locationName: "memberId"
              },
              Role: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RoomMembership: {
                shape: "S4w"
              }
            }
          }
        },
        UpdateSipMediaApplication: {
          http: {
            method: "PUT",
            requestUri: "/sip-media-applications/{sipMediaApplicationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SipMediaApplicationId"
            ],
            members: {
              SipMediaApplicationId: {
                location: "uri",
                locationName: "sipMediaApplicationId"
              },
              Name: {},
              Endpoints: {
                shape: "S51"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipMediaApplication: {
                shape: "S55"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by UpdateSipMediaApplication in the Amazon Chime SDK Voice Namespace"
        },
        UpdateSipMediaApplicationCall: {
          http: {
            requestUri: "/sip-media-applications/{sipMediaApplicationId}/calls/{transactionId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "SipMediaApplicationId",
              "TransactionId",
              "Arguments"
            ],
            members: {
              SipMediaApplicationId: {
                location: "uri",
                locationName: "sipMediaApplicationId"
              },
              TransactionId: {
                location: "uri",
                locationName: "transactionId"
              },
              Arguments: {
                type: "map",
                key: {
                  shape: "S23"
                },
                value: {
                  shape: "S23"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipMediaApplicationCall: {
                shape: "S59"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by UpdateSipMediaApplicationCall in the Amazon Chime SDK Voice Namespace"
        },
        UpdateSipRule: {
          http: {
            method: "PUT",
            requestUri: "/sip-rules/{sipRuleId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "SipRuleId",
              "Name"
            ],
            members: {
              SipRuleId: {
                location: "uri",
                locationName: "sipRuleId"
              },
              Name: {},
              Disabled: {
                type: "boolean"
              },
              TargetApplications: {
                shape: "S5d"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipRule: {
                shape: "S5h"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by UpdateSipRule in the Amazon Chime SDK Voice Namespace"
        },
        UpdateUser: {
          http: {
            requestUri: "/accounts/{accountId}/users/{userId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "UserId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              UserId: {
                location: "uri",
                locationName: "userId"
              },
              LicenseType: {},
              UserType: {},
              AlexaForBusinessMetadata: {
                shape: "S21"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                shape: "S5l"
              }
            }
          }
        },
        UpdateUserSettings: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{accountId}/users/{userId}/settings",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "UserId",
              "UserSettings"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              UserId: {
                location: "uri",
                locationName: "userId"
              },
              UserSettings: {
                shape: "S9z"
              }
            }
          }
        },
        UpdateVoiceConnector: {
          http: {
            method: "PUT",
            requestUri: "/voice-connectors/{voiceConnectorId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "Name",
              "RequireEncryption"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              Name: {},
              RequireEncryption: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceConnector: {
                shape: "S5s"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by UpdateVoiceConnector in the Amazon Chime SDK Voice Namespace"
        },
        UpdateVoiceConnectorGroup: {
          http: {
            method: "PUT",
            requestUri: "/voice-connector-groups/{voiceConnectorGroupId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorGroupId",
              "Name",
              "VoiceConnectorItems"
            ],
            members: {
              VoiceConnectorGroupId: {
                location: "uri",
                locationName: "voiceConnectorGroupId"
              },
              Name: {},
              VoiceConnectorItems: {
                shape: "S5v"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceConnectorGroup: {
                shape: "S5z"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by UpdateVoiceConnectorGroup in the Amazon Chime SDK Voice Namespace"
        },
        ValidateE911Address: {
          http: {
            requestUri: "/emergency-calling/address",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "StreetNumber",
              "StreetInfo",
              "City",
              "State",
              "Country",
              "PostalCode"
            ],
            members: {
              AwsAccountId: {},
              StreetNumber: {
                shape: "Shg"
              },
              StreetInfo: {
                shape: "Shg"
              },
              City: {
                shape: "Shg"
              },
              State: {
                shape: "Shg"
              },
              Country: {
                shape: "Shg"
              },
              PostalCode: {
                shape: "Shg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ValidationResult: {
                type: "integer"
              },
              AddressExternalId: {},
              Address: {
                type: "structure",
                members: {
                  streetName: {
                    shape: "Shg"
                  },
                  streetSuffix: {
                    shape: "Shg"
                  },
                  postDirectional: {
                    shape: "Shg"
                  },
                  preDirectional: {
                    shape: "Shg"
                  },
                  streetNumber: {
                    shape: "Shg"
                  },
                  city: {
                    shape: "Shg"
                  },
                  state: {
                    shape: "Shg"
                  },
                  postalCode: {
                    shape: "Shg"
                  },
                  postalCodePlus4: {
                    shape: "Shg"
                  },
                  country: {
                    shape: "Shg"
                  }
                }
              },
              CandidateAddressList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    streetInfo: {
                      shape: "Shg"
                    },
                    streetNumber: {
                      shape: "Shg"
                    },
                    city: {
                      shape: "Shg"
                    },
                    state: {
                      shape: "Shg"
                    },
                    postalCode: {
                      shape: "Shg"
                    },
                    postalCodePlus4: {
                      shape: "Shg"
                    },
                    country: {
                      shape: "Shg"
                    }
                  }
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Replaced by ValidateE911Address in the Amazon Chime SDK Voice Namespace"
        }
      },
      shapes: {
        S3: {
          type: "string",
          sensitive: true
        },
        S7: {
          type: "list",
          member: {
            shape: "S3"
          }
        },
        Sa: {
          type: "list",
          member: {
            type: "structure",
            members: {
              PhoneNumberId: {},
              ErrorCode: {},
              ErrorMessage: {}
            }
          }
        },
        Sg: {
          type: "list",
          member: {
            type: "structure",
            members: {
              GroupName: {}
            }
          }
        },
        Sm: {
          type: "structure",
          required: [
            "ExternalUserId"
          ],
          members: {
            ExternalUserId: {
              shape: "Sn"
            },
            Tags: {
              shape: "So"
            }
          }
        },
        Sn: {
          type: "string",
          sensitive: true
        },
        So: {
          type: "list",
          member: {
            shape: "Sp"
          }
        },
        Sp: {
          type: "structure",
          required: [
            "Key",
            "Value"
          ],
          members: {
            Key: {
              shape: "Sq"
            },
            Value: {
              type: "string",
              sensitive: true
            }
          }
        },
        Sq: {
          type: "string",
          sensitive: true
        },
        St: {
          type: "list",
          member: {
            shape: "Su"
          }
        },
        Su: {
          type: "structure",
          members: {
            ExternalUserId: {
              shape: "Sn"
            },
            AttendeeId: {},
            JoinToken: {
              shape: "Sv"
            }
          }
        },
        Sv: {
          type: "string",
          sensitive: true
        },
        Sw: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ExternalUserId: {
                shape: "Sn"
              },
              ErrorCode: {},
              ErrorMessage: {}
            }
          }
        },
        S14: {
          type: "structure",
          members: {
            Arn: {},
            Name: {
              type: "string",
              sensitive: true
            }
          }
        },
        S1h: {
          type: "list",
          member: {}
        },
        S1k: {
          type: "list",
          member: {}
        },
        S1m: {
          type: "list",
          member: {
            type: "structure",
            members: {
              UserId: {},
              ErrorCode: {},
              ErrorMessage: {}
            }
          }
        },
        S1u: {
          type: "string",
          sensitive: true
        },
        S21: {
          type: "structure",
          members: {
            IsAlexaForBusinessEnabled: {
              type: "boolean"
            },
            AlexaForBusinessRoomArn: {
              shape: "S23"
            }
          }
        },
        S23: {
          type: "string",
          sensitive: true
        },
        S28: {
          type: "structure",
          required: [
            "AwsAccountId",
            "AccountId",
            "Name"
          ],
          members: {
            AwsAccountId: {},
            AccountId: {},
            Name: {},
            AccountType: {},
            CreatedTimestamp: {
              shape: "S2a"
            },
            DefaultLicense: {},
            SupportedLicenses: {
              type: "list",
              member: {}
            },
            AccountStatus: {},
            SigninDelegateGroups: {
              shape: "Sg"
            }
          }
        },
        S2a: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S2e: {
          type: "string",
          sensitive: true
        },
        S2f: {
          type: "string",
          sensitive: true
        },
        S2g: {
          type: "string",
          sensitive: true
        },
        S2h: {
          type: "list",
          member: {
            shape: "Sp"
          }
        },
        S2n: {
          type: "string",
          sensitive: true
        },
        S2t: {
          type: "structure",
          members: {
            BotId: {},
            UserId: {},
            DisplayName: {
              shape: "S23"
            },
            BotType: {},
            Disabled: {
              type: "boolean"
            },
            CreatedTimestamp: {
              shape: "S2a"
            },
            UpdatedTimestamp: {
              shape: "S2a"
            },
            BotEmail: {
              shape: "S23"
            },
            SecurityToken: {
              shape: "S23"
            }
          }
        },
        S37: {
          type: "string",
          sensitive: true
        },
        S39: {
          type: "structure",
          members: {
            SourceConfiguration: {
              type: "structure",
              members: {
                SelectedVideoStreams: {
                  type: "structure",
                  members: {
                    AttendeeIds: {
                      type: "list",
                      member: {}
                    },
                    ExternalUserIds: {
                      type: "list",
                      member: {
                        shape: "Sn"
                      }
                    }
                  }
                }
              }
            },
            ArtifactsConfiguration: {
              type: "structure",
              required: [
                "Audio",
                "Video",
                "Content"
              ],
              members: {
                Audio: {
                  type: "structure",
                  required: [
                    "MuxType"
                  ],
                  members: {
                    MuxType: {}
                  }
                },
                Video: {
                  type: "structure",
                  required: [
                    "State"
                  ],
                  members: {
                    State: {},
                    MuxType: {}
                  }
                },
                Content: {
                  type: "structure",
                  required: [
                    "State"
                  ],
                  members: {
                    State: {},
                    MuxType: {}
                  }
                }
              }
            }
          }
        },
        S3n: {
          type: "structure",
          members: {
            MediaPipelineId: {},
            SourceType: {},
            SourceArn: {
              shape: "S37"
            },
            Status: {},
            SinkType: {},
            SinkArn: {
              shape: "S37"
            },
            CreatedTimestamp: {
              shape: "S2a"
            },
            UpdatedTimestamp: {
              shape: "S2a"
            },
            ChimeSdkMeetingConfiguration: {
              shape: "S39"
            }
          }
        },
        S3q: {
          type: "string",
          sensitive: true
        },
        S3r: {
          type: "list",
          member: {
            shape: "Sp"
          }
        },
        S3s: {
          type: "structure",
          members: {
            SnsTopicArn: {
              shape: "S37"
            },
            SqsQueueArn: {
              shape: "S37"
            }
          }
        },
        S3u: {
          type: "structure",
          members: {
            MeetingId: {},
            ExternalMeetingId: {
              shape: "S3q"
            },
            MediaPlacement: {
              type: "structure",
              members: {
                AudioHostUrl: {},
                AudioFallbackUrl: {},
                ScreenDataUrl: {},
                ScreenSharingUrl: {},
                ScreenViewingUrl: {},
                SignalingUrl: {},
                TurnControlUrl: {},
                EventIngestionUrl: {}
              }
            },
            MediaRegion: {}
          }
        },
        S44: {
          type: "structure",
          members: {
            PhoneNumberOrderId: {},
            ProductType: {},
            Status: {},
            OrderedPhoneNumbers: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  E164PhoneNumber: {
                    shape: "S3"
                  },
                  Status: {}
                }
              }
            },
            CreatedTimestamp: {
              shape: "S2a"
            },
            UpdatedTimestamp: {
              shape: "S2a"
            }
          }
        },
        S4e: {
          type: "list",
          member: {}
        },
        S4i: {
          type: "structure",
          required: [
            "Country",
            "AreaCode"
          ],
          members: {
            Country: {},
            AreaCode: {}
          }
        },
        S4m: {
          type: "structure",
          members: {
            VoiceConnectorId: {},
            ProxySessionId: {},
            Name: {},
            Status: {},
            ExpiryMinutes: {
              type: "integer"
            },
            Capabilities: {
              shape: "S4e"
            },
            CreatedTimestamp: {
              shape: "S2a"
            },
            UpdatedTimestamp: {
              shape: "S2a"
            },
            EndedTimestamp: {
              shape: "S2a"
            },
            Participants: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  PhoneNumber: {
                    shape: "S3"
                  },
                  ProxyPhoneNumber: {
                    shape: "S3"
                  }
                }
              }
            },
            NumberSelectionBehavior: {},
            GeoMatchLevel: {},
            GeoMatchParams: {
              shape: "S4i"
            }
          }
        },
        S4t: {
          type: "structure",
          members: {
            RoomId: {},
            Name: {
              shape: "S23"
            },
            AccountId: {},
            CreatedBy: {},
            CreatedTimestamp: {
              shape: "S2a"
            },
            UpdatedTimestamp: {
              shape: "S2a"
            }
          }
        },
        S4w: {
          type: "structure",
          members: {
            RoomId: {},
            Member: {
              type: "structure",
              members: {
                MemberId: {},
                MemberType: {},
                Email: {
                  shape: "S23"
                },
                FullName: {
                  shape: "S23"
                },
                AccountId: {}
              }
            },
            Role: {},
            InvitedBy: {},
            UpdatedTimestamp: {
              shape: "S2a"
            }
          }
        },
        S51: {
          type: "list",
          member: {
            type: "structure",
            members: {
              LambdaArn: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        S55: {
          type: "structure",
          members: {
            SipMediaApplicationId: {},
            AwsRegion: {},
            Name: {},
            Endpoints: {
              shape: "S51"
            },
            CreatedTimestamp: {
              shape: "S2a"
            },
            UpdatedTimestamp: {
              shape: "S2a"
            }
          }
        },
        S59: {
          type: "structure",
          members: {
            TransactionId: {}
          }
        },
        S5d: {
          type: "list",
          member: {
            type: "structure",
            members: {
              SipMediaApplicationId: {},
              Priority: {
                type: "integer"
              },
              AwsRegion: {}
            }
          }
        },
        S5h: {
          type: "structure",
          members: {
            SipRuleId: {},
            Name: {},
            Disabled: {
              type: "boolean"
            },
            TriggerType: {},
            TriggerValue: {},
            TargetApplications: {
              shape: "S5d"
            },
            CreatedTimestamp: {
              shape: "S2a"
            },
            UpdatedTimestamp: {
              shape: "S2a"
            }
          }
        },
        S5j: {
          type: "string",
          sensitive: true
        },
        S5l: {
          type: "structure",
          required: [
            "UserId"
          ],
          members: {
            UserId: {},
            AccountId: {},
            PrimaryEmail: {
              shape: "S5j"
            },
            PrimaryProvisionedNumber: {
              shape: "S23"
            },
            DisplayName: {
              shape: "S23"
            },
            LicenseType: {},
            UserType: {},
            UserRegistrationStatus: {},
            UserInvitationStatus: {},
            RegisteredOn: {
              shape: "S2a"
            },
            InvitedOn: {
              shape: "S2a"
            },
            AlexaForBusinessMetadata: {
              shape: "S21"
            },
            PersonalPIN: {}
          }
        },
        S5s: {
          type: "structure",
          members: {
            VoiceConnectorId: {},
            AwsRegion: {},
            Name: {},
            OutboundHostName: {},
            RequireEncryption: {
              type: "boolean"
            },
            CreatedTimestamp: {
              shape: "S2a"
            },
            UpdatedTimestamp: {
              shape: "S2a"
            },
            VoiceConnectorArn: {}
          }
        },
        S5v: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "Priority"
            ],
            members: {
              VoiceConnectorId: {},
              Priority: {
                type: "integer"
              }
            }
          }
        },
        S5z: {
          type: "structure",
          members: {
            VoiceConnectorGroupId: {},
            Name: {},
            VoiceConnectorItems: {
              shape: "S5v"
            },
            CreatedTimestamp: {
              shape: "S2a"
            },
            UpdatedTimestamp: {
              shape: "S2a"
            },
            VoiceConnectorGroupArn: {}
          }
        },
        S6u: {
          type: "list",
          member: {
            shape: "S23"
          }
        },
        S7g: {
          type: "structure",
          members: {
            ChannelSummary: {
              shape: "S7h"
            },
            AppInstanceUserMembershipSummary: {
              type: "structure",
              members: {
                Type: {},
                ReadMarkerTimestamp: {
                  type: "timestamp"
                }
              }
            }
          }
        },
        S7h: {
          type: "structure",
          members: {
            Name: {
              shape: "S2e"
            },
            ChannelArn: {},
            Mode: {},
            Privacy: {},
            Metadata: {
              shape: "S2f"
            },
            LastMessageTimestamp: {
              type: "timestamp"
            }
          }
        },
        S7l: {
          type: "structure",
          members: {
            ChannelSummary: {
              shape: "S7h"
            }
          }
        },
        S81: {
          type: "structure",
          members: {
            DisableRemoteControl: {
              type: "boolean"
            },
            EnableDialOut: {
              type: "boolean"
            }
          }
        },
        S84: {
          type: "structure",
          members: {
            ChannelRetentionSettings: {
              type: "structure",
              members: {
                RetentionDays: {
                  type: "integer"
                }
              }
            }
          }
        },
        S89: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AppInstanceDataType",
              "ResourceArn"
            ],
            members: {
              AppInstanceDataType: {},
              ResourceArn: {
                shape: "S37"
              }
            }
          }
        },
        S8j: {
          type: "string",
          sensitive: true
        },
        S8p: {
          type: "structure",
          members: {
            BotId: {},
            OutboundEventsHTTPSEndpoint: {
              shape: "S23"
            },
            LambdaFunctionArn: {
              shape: "S23"
            }
          }
        },
        S8r: {
          type: "structure",
          members: {
            CdrBucket: {}
          }
        },
        S8s: {
          type: "structure",
          members: {
            CdrBucket: {}
          }
        },
        S93: {
          type: "structure",
          members: {
            PhoneNumberId: {},
            E164PhoneNumber: {
              shape: "S3"
            },
            Country: {},
            Type: {},
            ProductType: {},
            Status: {},
            Capabilities: {
              type: "structure",
              members: {
                InboundCall: {
                  type: "boolean"
                },
                OutboundCall: {
                  type: "boolean"
                },
                InboundSMS: {
                  type: "boolean"
                },
                OutboundSMS: {
                  type: "boolean"
                },
                InboundMMS: {
                  type: "boolean"
                },
                OutboundMMS: {
                  type: "boolean"
                }
              }
            },
            Associations: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Value: {},
                  Name: {},
                  AssociatedTimestamp: {
                    shape: "S2a"
                  }
                }
              }
            },
            CallingName: {
              shape: "S1u"
            },
            CallingNameStatus: {},
            CreatedTimestamp: {
              shape: "S2a"
            },
            UpdatedTimestamp: {
              shape: "S2a"
            },
            DeletionTimestamp: {
              shape: "S2a"
            }
          }
        },
        S9j: {
          type: "structure",
          members: {
            RoomRetentionSettings: {
              type: "structure",
              members: {
                RetentionDays: {
                  type: "integer"
                }
              }
            },
            ConversationRetentionSettings: {
              type: "structure",
              members: {
                RetentionDays: {
                  type: "integer"
                }
              }
            }
          }
        },
        S9s: {
          type: "structure",
          members: {
            EnableSipMediaApplicationMessageLogs: {
              type: "boolean"
            }
          }
        },
        S9z: {
          type: "structure",
          required: [
            "Telephony"
          ],
          members: {
            Telephony: {
              type: "structure",
              required: [
                "InboundCalling",
                "OutboundCalling",
                "SMS"
              ],
              members: {
                InboundCalling: {
                  type: "boolean"
                },
                OutboundCalling: {
                  type: "boolean"
                },
                SMS: {
                  type: "boolean"
                }
              }
            }
          }
        },
        Sa5: {
          type: "structure",
          members: {
            DNIS: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "EmergencyPhoneNumber",
                  "CallingCountry"
                ],
                members: {
                  EmergencyPhoneNumber: {
                    shape: "S3"
                  },
                  TestPhoneNumber: {
                    shape: "S3"
                  },
                  CallingCountry: {}
                }
              }
            }
          }
        },
        Sac: {
          type: "structure",
          members: {
            EnableSIPLogs: {
              type: "boolean"
            },
            EnableMediaMetricLogs: {
              type: "boolean"
            }
          }
        },
        Saf: {
          type: "structure",
          members: {
            Routes: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Host: {},
                  Port: {
                    type: "integer"
                  },
                  Protocol: {},
                  Priority: {
                    type: "integer"
                  },
                  Weight: {
                    type: "integer"
                  }
                }
              }
            },
            Disabled: {
              type: "boolean"
            }
          }
        },
        Sao: {
          type: "structure",
          members: {
            DefaultSessionExpiryMinutes: {
              type: "integer"
            },
            Disabled: {
              type: "boolean"
            },
            FallBackPhoneNumber: {
              shape: "S3"
            },
            PhoneNumberCountries: {
              shape: "Saq"
            }
          }
        },
        Saq: {
          type: "list",
          member: {}
        },
        Sat: {
          type: "structure",
          required: [
            "DataRetentionInHours"
          ],
          members: {
            DataRetentionInHours: {
              type: "integer"
            },
            Disabled: {
              type: "boolean"
            },
            StreamingNotificationTargets: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "NotificationTarget"
                ],
                members: {
                  NotificationTarget: {}
                }
              }
            }
          }
        },
        Sb0: {
          type: "structure",
          members: {
            CpsLimit: {
              type: "integer"
            },
            DefaultPhoneNumber: {
              shape: "S3"
            },
            CallingRegions: {
              type: "list",
              member: {}
            },
            CidrAllowedList: {
              shape: "Saq"
            },
            Disabled: {
              type: "boolean"
            }
          }
        },
        Sbj: {
          type: "string",
          sensitive: true
        },
        Shg: {
          type: "string",
          sensitive: true
        }
      },
      deprecated: true,
      deprecatedMessage: "This namespace has been deprecated"
    };
  }
});

// node_modules/aws-sdk/apis/chime-2018-05-01.paginators.json
var require_chime_2018_05_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/chime-2018-05-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAccounts: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAppInstanceAdmins: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAppInstanceUsers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAppInstances: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAttendees: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListBots: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListChannelBans: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListChannelMemberships: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListChannelMembershipsForAppInstanceUser: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListChannelMessages: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListChannelModerators: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListChannels: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListChannelsModeratedByAppInstanceUser: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMediaCapturePipelines: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMeetings: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListPhoneNumberOrders: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListPhoneNumbers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListProxySessions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListRoomMemberships: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListRooms: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListSipMediaApplications: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListSipRules: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListUsers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListVoiceConnectorGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListVoiceConnectors: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        SearchAvailablePhoneNumbers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/chime.js
var require_chime = __commonJS({
  "node_modules/aws-sdk/clients/chime.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["chime"] = {};
    AWS2.Chime = Service.defineService("chime", ["2018-05-01"]);
    Object.defineProperty(apiLoader.services["chime"], "2018-05-01", {
      get: function get() {
        var model = require_chime_2018_05_01_min();
        model.paginators = require_chime_2018_05_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Chime;
  }
});

// node_modules/aws-sdk/apis/pinpoint-email-2018-07-26.min.json
var require_pinpoint_email_2018_07_26_min = __commonJS({
  "node_modules/aws-sdk/apis/pinpoint-email-2018-07-26.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-07-26",
        endpointPrefix: "email",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Pinpoint Email",
        serviceFullName: "Amazon Pinpoint Email Service",
        serviceId: "Pinpoint Email",
        signatureVersion: "v4",
        signingName: "ses",
        uid: "pinpoint-email-2018-07-26"
      },
      operations: {
        CreateConfigurationSet: {
          http: {
            requestUri: "/v1/email/configuration-sets"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {},
              TrackingOptions: {
                shape: "S3"
              },
              DeliveryOptions: {
                shape: "S5"
              },
              ReputationOptions: {
                shape: "S8"
              },
              SendingOptions: {
                shape: "Sb"
              },
              Tags: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateConfigurationSetEventDestination: {
          http: {
            requestUri: "/v1/email/configuration-sets/{ConfigurationSetName}/event-destinations"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName",
              "EventDestinationName",
              "EventDestination"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              EventDestinationName: {},
              EventDestination: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateDedicatedIpPool: {
          http: {
            requestUri: "/v1/email/dedicated-ip-pools"
          },
          input: {
            type: "structure",
            required: [
              "PoolName"
            ],
            members: {
              PoolName: {},
              Tags: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateDeliverabilityTestReport: {
          http: {
            requestUri: "/v1/email/deliverability-dashboard/test"
          },
          input: {
            type: "structure",
            required: [
              "FromEmailAddress",
              "Content"
            ],
            members: {
              ReportName: {},
              FromEmailAddress: {},
              Content: {
                shape: "S12"
              },
              Tags: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ReportId",
              "DeliverabilityTestStatus"
            ],
            members: {
              ReportId: {},
              DeliverabilityTestStatus: {}
            }
          }
        },
        CreateEmailIdentity: {
          http: {
            requestUri: "/v1/email/identities"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity"
            ],
            members: {
              EmailIdentity: {},
              Tags: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityType: {},
              VerifiedForSendingStatus: {
                type: "boolean"
              },
              DkimAttributes: {
                shape: "S1k"
              }
            }
          }
        },
        DeleteConfigurationSet: {
          http: {
            method: "DELETE",
            requestUri: "/v1/email/configuration-sets/{ConfigurationSetName}"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteConfigurationSetEventDestination: {
          http: {
            method: "DELETE",
            requestUri: "/v1/email/configuration-sets/{ConfigurationSetName}/event-destinations/{EventDestinationName}"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName",
              "EventDestinationName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              EventDestinationName: {
                location: "uri",
                locationName: "EventDestinationName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDedicatedIpPool: {
          http: {
            method: "DELETE",
            requestUri: "/v1/email/dedicated-ip-pools/{PoolName}"
          },
          input: {
            type: "structure",
            required: [
              "PoolName"
            ],
            members: {
              PoolName: {
                location: "uri",
                locationName: "PoolName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteEmailIdentity: {
          http: {
            method: "DELETE",
            requestUri: "/v1/email/identities/{EmailIdentity}"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetAccount: {
          http: {
            method: "GET",
            requestUri: "/v1/email/account"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              SendQuota: {
                type: "structure",
                members: {
                  Max24HourSend: {
                    type: "double"
                  },
                  MaxSendRate: {
                    type: "double"
                  },
                  SentLast24Hours: {
                    type: "double"
                  }
                }
              },
              SendingEnabled: {
                type: "boolean"
              },
              DedicatedIpAutoWarmupEnabled: {
                type: "boolean"
              },
              EnforcementStatus: {},
              ProductionAccessEnabled: {
                type: "boolean"
              }
            }
          }
        },
        GetBlacklistReports: {
          http: {
            method: "GET",
            requestUri: "/v1/email/deliverability-dashboard/blacklist-report"
          },
          input: {
            type: "structure",
            required: [
              "BlacklistItemNames"
            ],
            members: {
              BlacklistItemNames: {
                location: "querystring",
                locationName: "BlacklistItemNames",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "BlacklistReport"
            ],
            members: {
              BlacklistReport: {
                type: "map",
                key: {},
                value: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      RblName: {},
                      ListingTime: {
                        type: "timestamp"
                      },
                      Description: {}
                    }
                  }
                }
              }
            }
          }
        },
        GetConfigurationSet: {
          http: {
            method: "GET",
            requestUri: "/v1/email/configuration-sets/{ConfigurationSetName}"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationSetName: {},
              TrackingOptions: {
                shape: "S3"
              },
              DeliveryOptions: {
                shape: "S5"
              },
              ReputationOptions: {
                shape: "S8"
              },
              SendingOptions: {
                shape: "Sb"
              },
              Tags: {
                shape: "Sc"
              }
            }
          }
        },
        GetConfigurationSetEventDestinations: {
          http: {
            method: "GET",
            requestUri: "/v1/email/configuration-sets/{ConfigurationSetName}/event-destinations"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventDestinations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "MatchingEventTypes"
                  ],
                  members: {
                    Name: {},
                    Enabled: {
                      type: "boolean"
                    },
                    MatchingEventTypes: {
                      shape: "Sk"
                    },
                    KinesisFirehoseDestination: {
                      shape: "Sm"
                    },
                    CloudWatchDestination: {
                      shape: "So"
                    },
                    SnsDestination: {
                      shape: "Su"
                    },
                    PinpointDestination: {
                      shape: "Sv"
                    }
                  }
                }
              }
            }
          }
        },
        GetDedicatedIp: {
          http: {
            method: "GET",
            requestUri: "/v1/email/dedicated-ips/{IP}"
          },
          input: {
            type: "structure",
            required: [
              "Ip"
            ],
            members: {
              Ip: {
                location: "uri",
                locationName: "IP"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DedicatedIp: {
                shape: "S2m"
              }
            }
          }
        },
        GetDedicatedIps: {
          http: {
            method: "GET",
            requestUri: "/v1/email/dedicated-ips"
          },
          input: {
            type: "structure",
            members: {
              PoolName: {
                location: "querystring",
                locationName: "PoolName"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DedicatedIps: {
                type: "list",
                member: {
                  shape: "S2m"
                }
              },
              NextToken: {}
            }
          }
        },
        GetDeliverabilityDashboardOptions: {
          http: {
            method: "GET",
            requestUri: "/v1/email/deliverability-dashboard"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "DashboardEnabled"
            ],
            members: {
              DashboardEnabled: {
                type: "boolean"
              },
              SubscriptionExpiryDate: {
                type: "timestamp"
              },
              AccountStatus: {},
              ActiveSubscribedDomains: {
                shape: "S2x"
              },
              PendingExpirationSubscribedDomains: {
                shape: "S2x"
              }
            }
          }
        },
        GetDeliverabilityTestReport: {
          http: {
            method: "GET",
            requestUri: "/v1/email/deliverability-dashboard/test-reports/{ReportId}"
          },
          input: {
            type: "structure",
            required: [
              "ReportId"
            ],
            members: {
              ReportId: {
                location: "uri",
                locationName: "ReportId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DeliverabilityTestReport",
              "OverallPlacement",
              "IspPlacements"
            ],
            members: {
              DeliverabilityTestReport: {
                shape: "S35"
              },
              OverallPlacement: {
                shape: "S37"
              },
              IspPlacements: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    IspName: {},
                    PlacementStatistics: {
                      shape: "S37"
                    }
                  }
                }
              },
              Message: {},
              Tags: {
                shape: "Sc"
              }
            }
          }
        },
        GetDomainDeliverabilityCampaign: {
          http: {
            method: "GET",
            requestUri: "/v1/email/deliverability-dashboard/campaigns/{CampaignId}"
          },
          input: {
            type: "structure",
            required: [
              "CampaignId"
            ],
            members: {
              CampaignId: {
                location: "uri",
                locationName: "CampaignId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainDeliverabilityCampaign"
            ],
            members: {
              DomainDeliverabilityCampaign: {
                shape: "S3f"
              }
            }
          }
        },
        GetDomainStatisticsReport: {
          http: {
            method: "GET",
            requestUri: "/v1/email/deliverability-dashboard/statistics-report/{Domain}"
          },
          input: {
            type: "structure",
            required: [
              "Domain",
              "StartDate",
              "EndDate"
            ],
            members: {
              Domain: {
                location: "uri",
                locationName: "Domain"
              },
              StartDate: {
                location: "querystring",
                locationName: "StartDate",
                type: "timestamp"
              },
              EndDate: {
                location: "querystring",
                locationName: "EndDate",
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "OverallVolume",
              "DailyVolumes"
            ],
            members: {
              OverallVolume: {
                type: "structure",
                members: {
                  VolumeStatistics: {
                    shape: "S3p"
                  },
                  ReadRatePercent: {
                    type: "double"
                  },
                  DomainIspPlacements: {
                    shape: "S3q"
                  }
                }
              },
              DailyVolumes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StartDate: {
                      type: "timestamp"
                    },
                    VolumeStatistics: {
                      shape: "S3p"
                    },
                    DomainIspPlacements: {
                      shape: "S3q"
                    }
                  }
                }
              }
            }
          }
        },
        GetEmailIdentity: {
          http: {
            method: "GET",
            requestUri: "/v1/email/identities/{EmailIdentity}"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityType: {},
              FeedbackForwardingStatus: {
                type: "boolean"
              },
              VerifiedForSendingStatus: {
                type: "boolean"
              },
              DkimAttributes: {
                shape: "S1k"
              },
              MailFromAttributes: {
                type: "structure",
                required: [
                  "MailFromDomain",
                  "MailFromDomainStatus",
                  "BehaviorOnMxFailure"
                ],
                members: {
                  MailFromDomain: {},
                  MailFromDomainStatus: {},
                  BehaviorOnMxFailure: {}
                }
              },
              Tags: {
                shape: "Sc"
              }
            }
          }
        },
        ListConfigurationSets: {
          http: {
            method: "GET",
            requestUri: "/v1/email/configuration-sets"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationSets: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListDedicatedIpPools: {
          http: {
            method: "GET",
            requestUri: "/v1/email/dedicated-ip-pools"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DedicatedIpPools: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListDeliverabilityTestReports: {
          http: {
            method: "GET",
            requestUri: "/v1/email/deliverability-dashboard/test-reports"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DeliverabilityTestReports"
            ],
            members: {
              DeliverabilityTestReports: {
                type: "list",
                member: {
                  shape: "S35"
                }
              },
              NextToken: {}
            }
          }
        },
        ListDomainDeliverabilityCampaigns: {
          http: {
            method: "GET",
            requestUri: "/v1/email/deliverability-dashboard/domains/{SubscribedDomain}/campaigns"
          },
          input: {
            type: "structure",
            required: [
              "StartDate",
              "EndDate",
              "SubscribedDomain"
            ],
            members: {
              StartDate: {
                location: "querystring",
                locationName: "StartDate",
                type: "timestamp"
              },
              EndDate: {
                location: "querystring",
                locationName: "EndDate",
                type: "timestamp"
              },
              SubscribedDomain: {
                location: "uri",
                locationName: "SubscribedDomain"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainDeliverabilityCampaigns"
            ],
            members: {
              DomainDeliverabilityCampaigns: {
                type: "list",
                member: {
                  shape: "S3f"
                }
              },
              NextToken: {}
            }
          }
        },
        ListEmailIdentities: {
          http: {
            method: "GET",
            requestUri: "/v1/email/identities"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EmailIdentities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    IdentityType: {},
                    IdentityName: {},
                    SendingEnabled: {
                      type: "boolean"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/v1/email/tags"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "querystring",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "Sc"
              }
            }
          }
        },
        PutAccountDedicatedIpWarmupAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v1/email/account/dedicated-ips/warmup"
          },
          input: {
            type: "structure",
            members: {
              AutoWarmupEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutAccountSendingAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v1/email/account/sending"
          },
          input: {
            type: "structure",
            members: {
              SendingEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutConfigurationSetDeliveryOptions: {
          http: {
            method: "PUT",
            requestUri: "/v1/email/configuration-sets/{ConfigurationSetName}/delivery-options"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              TlsPolicy: {},
              SendingPoolName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutConfigurationSetReputationOptions: {
          http: {
            method: "PUT",
            requestUri: "/v1/email/configuration-sets/{ConfigurationSetName}/reputation-options"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              ReputationMetricsEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutConfigurationSetSendingOptions: {
          http: {
            method: "PUT",
            requestUri: "/v1/email/configuration-sets/{ConfigurationSetName}/sending"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              SendingEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutConfigurationSetTrackingOptions: {
          http: {
            method: "PUT",
            requestUri: "/v1/email/configuration-sets/{ConfigurationSetName}/tracking-options"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              CustomRedirectDomain: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutDedicatedIpInPool: {
          http: {
            method: "PUT",
            requestUri: "/v1/email/dedicated-ips/{IP}/pool"
          },
          input: {
            type: "structure",
            required: [
              "Ip",
              "DestinationPoolName"
            ],
            members: {
              Ip: {
                location: "uri",
                locationName: "IP"
              },
              DestinationPoolName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutDedicatedIpWarmupAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v1/email/dedicated-ips/{IP}/warmup"
          },
          input: {
            type: "structure",
            required: [
              "Ip",
              "WarmupPercentage"
            ],
            members: {
              Ip: {
                location: "uri",
                locationName: "IP"
              },
              WarmupPercentage: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutDeliverabilityDashboardOption: {
          http: {
            method: "PUT",
            requestUri: "/v1/email/deliverability-dashboard"
          },
          input: {
            type: "structure",
            required: [
              "DashboardEnabled"
            ],
            members: {
              DashboardEnabled: {
                type: "boolean"
              },
              SubscribedDomains: {
                shape: "S2x"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutEmailIdentityDkimAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v1/email/identities/{EmailIdentity}/dkim"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              },
              SigningEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutEmailIdentityFeedbackAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v1/email/identities/{EmailIdentity}/feedback"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              },
              EmailForwardingEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutEmailIdentityMailFromAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v1/email/identities/{EmailIdentity}/mail-from"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              },
              MailFromDomain: {},
              BehaviorOnMxFailure: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SendEmail: {
          http: {
            requestUri: "/v1/email/outbound-emails"
          },
          input: {
            type: "structure",
            required: [
              "Destination",
              "Content"
            ],
            members: {
              FromEmailAddress: {},
              Destination: {
                type: "structure",
                members: {
                  ToAddresses: {
                    shape: "S59"
                  },
                  CcAddresses: {
                    shape: "S59"
                  },
                  BccAddresses: {
                    shape: "S59"
                  }
                }
              },
              ReplyToAddresses: {
                shape: "S59"
              },
              FeedbackForwardingEmailAddress: {},
              Content: {
                shape: "S12"
              },
              EmailTags: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Value"
                  ],
                  members: {
                    Name: {},
                    Value: {}
                  }
                }
              },
              ConfigurationSetName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MessageId: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/v1/email/tags"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/v1/email/tags"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "querystring",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "TagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateConfigurationSetEventDestination: {
          http: {
            method: "PUT",
            requestUri: "/v1/email/configuration-sets/{ConfigurationSetName}/event-destinations/{EventDestinationName}"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName",
              "EventDestinationName",
              "EventDestination"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              EventDestinationName: {
                location: "uri",
                locationName: "EventDestinationName"
              },
              EventDestination: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          required: [
            "CustomRedirectDomain"
          ],
          members: {
            CustomRedirectDomain: {}
          }
        },
        S5: {
          type: "structure",
          members: {
            TlsPolicy: {},
            SendingPoolName: {}
          }
        },
        S8: {
          type: "structure",
          members: {
            ReputationMetricsEnabled: {
              type: "boolean"
            },
            LastFreshStart: {
              type: "timestamp"
            }
          }
        },
        Sb: {
          type: "structure",
          members: {
            SendingEnabled: {
              type: "boolean"
            }
          }
        },
        Sc: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sj: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            MatchingEventTypes: {
              shape: "Sk"
            },
            KinesisFirehoseDestination: {
              shape: "Sm"
            },
            CloudWatchDestination: {
              shape: "So"
            },
            SnsDestination: {
              shape: "Su"
            },
            PinpointDestination: {
              shape: "Sv"
            }
          }
        },
        Sk: {
          type: "list",
          member: {}
        },
        Sm: {
          type: "structure",
          required: [
            "IamRoleArn",
            "DeliveryStreamArn"
          ],
          members: {
            IamRoleArn: {},
            DeliveryStreamArn: {}
          }
        },
        So: {
          type: "structure",
          required: [
            "DimensionConfigurations"
          ],
          members: {
            DimensionConfigurations: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "DimensionName",
                  "DimensionValueSource",
                  "DefaultDimensionValue"
                ],
                members: {
                  DimensionName: {},
                  DimensionValueSource: {},
                  DefaultDimensionValue: {}
                }
              }
            }
          }
        },
        Su: {
          type: "structure",
          required: [
            "TopicArn"
          ],
          members: {
            TopicArn: {}
          }
        },
        Sv: {
          type: "structure",
          members: {
            ApplicationArn: {}
          }
        },
        S12: {
          type: "structure",
          members: {
            Simple: {
              type: "structure",
              required: [
                "Subject",
                "Body"
              ],
              members: {
                Subject: {
                  shape: "S14"
                },
                Body: {
                  type: "structure",
                  members: {
                    Text: {
                      shape: "S14"
                    },
                    Html: {
                      shape: "S14"
                    }
                  }
                }
              }
            },
            Raw: {
              type: "structure",
              required: [
                "Data"
              ],
              members: {
                Data: {
                  type: "blob"
                }
              }
            },
            Template: {
              type: "structure",
              members: {
                TemplateArn: {},
                TemplateData: {}
              }
            }
          }
        },
        S14: {
          type: "structure",
          required: [
            "Data"
          ],
          members: {
            Data: {},
            Charset: {}
          }
        },
        S1k: {
          type: "structure",
          members: {
            SigningEnabled: {
              type: "boolean"
            },
            Status: {},
            Tokens: {
              type: "list",
              member: {}
            }
          }
        },
        S2m: {
          type: "structure",
          required: [
            "Ip",
            "WarmupStatus",
            "WarmupPercentage"
          ],
          members: {
            Ip: {},
            WarmupStatus: {},
            WarmupPercentage: {
              type: "integer"
            },
            PoolName: {}
          }
        },
        S2x: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Domain: {},
              SubscriptionStartDate: {
                type: "timestamp"
              },
              InboxPlacementTrackingOption: {
                type: "structure",
                members: {
                  Global: {
                    type: "boolean"
                  },
                  TrackedIsps: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          }
        },
        S35: {
          type: "structure",
          members: {
            ReportId: {},
            ReportName: {},
            Subject: {},
            FromEmailAddress: {},
            CreateDate: {
              type: "timestamp"
            },
            DeliverabilityTestStatus: {}
          }
        },
        S37: {
          type: "structure",
          members: {
            InboxPercentage: {
              type: "double"
            },
            SpamPercentage: {
              type: "double"
            },
            MissingPercentage: {
              type: "double"
            },
            SpfPercentage: {
              type: "double"
            },
            DkimPercentage: {
              type: "double"
            }
          }
        },
        S3f: {
          type: "structure",
          members: {
            CampaignId: {},
            ImageUrl: {},
            Subject: {},
            FromAddress: {},
            SendingIps: {
              type: "list",
              member: {}
            },
            FirstSeenDateTime: {
              type: "timestamp"
            },
            LastSeenDateTime: {
              type: "timestamp"
            },
            InboxCount: {
              type: "long"
            },
            SpamCount: {
              type: "long"
            },
            ReadRate: {
              type: "double"
            },
            DeleteRate: {
              type: "double"
            },
            ReadDeleteRate: {
              type: "double"
            },
            ProjectedVolume: {
              type: "long"
            },
            Esps: {
              type: "list",
              member: {}
            }
          }
        },
        S3p: {
          type: "structure",
          members: {
            InboxRawCount: {
              type: "long"
            },
            SpamRawCount: {
              type: "long"
            },
            ProjectedInbox: {
              type: "long"
            },
            ProjectedSpam: {
              type: "long"
            }
          }
        },
        S3q: {
          type: "list",
          member: {
            type: "structure",
            members: {
              IspName: {},
              InboxRawCount: {
                type: "long"
              },
              SpamRawCount: {
                type: "long"
              },
              InboxPercentage: {
                type: "double"
              },
              SpamPercentage: {
                type: "double"
              }
            }
          }
        },
        S59: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/pinpoint-email-2018-07-26.paginators.json
var require_pinpoint_email_2018_07_26_paginators = __commonJS({
  "node_modules/aws-sdk/apis/pinpoint-email-2018-07-26.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetDedicatedIps: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListConfigurationSets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListDedicatedIpPools: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListDeliverabilityTestReports: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListDomainDeliverabilityCampaigns: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListEmailIdentities: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/pinpointemail.js
var require_pinpointemail = __commonJS({
  "node_modules/aws-sdk/clients/pinpointemail.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["pinpointemail"] = {};
    AWS2.PinpointEmail = Service.defineService("pinpointemail", ["2018-07-26"]);
    Object.defineProperty(apiLoader.services["pinpointemail"], "2018-07-26", {
      get: function get() {
        var model = require_pinpoint_email_2018_07_26_min();
        model.paginators = require_pinpoint_email_2018_07_26_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.PinpointEmail;
  }
});

// node_modules/aws-sdk/apis/ram-2018-01-04.min.json
var require_ram_2018_01_04_min = __commonJS({
  "node_modules/aws-sdk/apis/ram-2018-01-04.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-01-04",
        endpointPrefix: "ram",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "RAM",
        serviceFullName: "AWS Resource Access Manager",
        serviceId: "RAM",
        signatureVersion: "v4",
        uid: "ram-2018-01-04"
      },
      operations: {
        AcceptResourceShareInvitation: {
          http: {
            requestUri: "/acceptresourceshareinvitation"
          },
          input: {
            type: "structure",
            required: [
              "resourceShareInvitationArn"
            ],
            members: {
              resourceShareInvitationArn: {},
              clientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              resourceShareInvitation: {
                shape: "S4"
              },
              clientToken: {}
            }
          }
        },
        AssociateResourceShare: {
          http: {
            requestUri: "/associateresourceshare"
          },
          input: {
            type: "structure",
            required: [
              "resourceShareArn"
            ],
            members: {
              resourceShareArn: {},
              resourceArns: {
                shape: "Sd"
              },
              principals: {
                shape: "Se"
              },
              clientToken: {},
              sources: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resourceShareAssociations: {
                shape: "S7"
              },
              clientToken: {}
            }
          }
        },
        AssociateResourceSharePermission: {
          http: {
            requestUri: "/associateresourcesharepermission"
          },
          input: {
            type: "structure",
            required: [
              "resourceShareArn",
              "permissionArn"
            ],
            members: {
              resourceShareArn: {},
              permissionArn: {},
              replace: {
                type: "boolean"
              },
              clientToken: {},
              permissionVersion: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              returnValue: {
                type: "boolean"
              },
              clientToken: {}
            }
          }
        },
        CreatePermission: {
          http: {
            requestUri: "/createpermission"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "resourceType",
              "policyTemplate"
            ],
            members: {
              name: {},
              resourceType: {},
              policyTemplate: {},
              clientToken: {},
              tags: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              permission: {
                shape: "Ss"
              },
              clientToken: {}
            }
          }
        },
        CreatePermissionVersion: {
          http: {
            requestUri: "/createpermissionversion"
          },
          input: {
            type: "structure",
            required: [
              "permissionArn",
              "policyTemplate"
            ],
            members: {
              permissionArn: {},
              policyTemplate: {},
              clientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              permission: {
                shape: "Sx"
              },
              clientToken: {}
            }
          }
        },
        CreateResourceShare: {
          http: {
            requestUri: "/createresourceshare"
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              resourceArns: {
                shape: "Sd"
              },
              principals: {
                shape: "Se"
              },
              tags: {
                shape: "Sn"
              },
              allowExternalPrincipals: {
                type: "boolean"
              },
              clientToken: {},
              permissionArns: {
                type: "list",
                member: {}
              },
              sources: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resourceShare: {
                shape: "S12"
              },
              clientToken: {}
            }
          }
        },
        DeletePermission: {
          http: {
            method: "DELETE",
            requestUri: "/deletepermission"
          },
          input: {
            type: "structure",
            required: [
              "permissionArn"
            ],
            members: {
              permissionArn: {
                location: "querystring",
                locationName: "permissionArn"
              },
              clientToken: {
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              returnValue: {
                type: "boolean"
              },
              clientToken: {},
              permissionStatus: {}
            }
          }
        },
        DeletePermissionVersion: {
          http: {
            method: "DELETE",
            requestUri: "/deletepermissionversion"
          },
          input: {
            type: "structure",
            required: [
              "permissionArn",
              "permissionVersion"
            ],
            members: {
              permissionArn: {
                location: "querystring",
                locationName: "permissionArn"
              },
              permissionVersion: {
                location: "querystring",
                locationName: "permissionVersion",
                type: "integer"
              },
              clientToken: {
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              returnValue: {
                type: "boolean"
              },
              clientToken: {},
              permissionStatus: {}
            }
          }
        },
        DeleteResourceShare: {
          http: {
            method: "DELETE",
            requestUri: "/deleteresourceshare"
          },
          input: {
            type: "structure",
            required: [
              "resourceShareArn"
            ],
            members: {
              resourceShareArn: {
                location: "querystring",
                locationName: "resourceShareArn"
              },
              clientToken: {
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              returnValue: {
                type: "boolean"
              },
              clientToken: {}
            }
          }
        },
        DisassociateResourceShare: {
          http: {
            requestUri: "/disassociateresourceshare"
          },
          input: {
            type: "structure",
            required: [
              "resourceShareArn"
            ],
            members: {
              resourceShareArn: {},
              resourceArns: {
                shape: "Sd"
              },
              principals: {
                shape: "Se"
              },
              clientToken: {},
              sources: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resourceShareAssociations: {
                shape: "S7"
              },
              clientToken: {}
            }
          }
        },
        DisassociateResourceSharePermission: {
          http: {
            requestUri: "/disassociateresourcesharepermission"
          },
          input: {
            type: "structure",
            required: [
              "resourceShareArn",
              "permissionArn"
            ],
            members: {
              resourceShareArn: {},
              permissionArn: {},
              clientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              returnValue: {
                type: "boolean"
              },
              clientToken: {}
            }
          }
        },
        EnableSharingWithAwsOrganization: {
          http: {
            requestUri: "/enablesharingwithawsorganization"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              returnValue: {
                type: "boolean"
              }
            }
          }
        },
        GetPermission: {
          http: {
            requestUri: "/getpermission"
          },
          input: {
            type: "structure",
            required: [
              "permissionArn"
            ],
            members: {
              permissionArn: {},
              permissionVersion: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              permission: {
                shape: "Sx"
              }
            }
          }
        },
        GetResourcePolicies: {
          http: {
            requestUri: "/getresourcepolicies"
          },
          input: {
            type: "structure",
            required: [
              "resourceArns"
            ],
            members: {
              resourceArns: {
                shape: "Sd"
              },
              principal: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              policies: {
                type: "list",
                member: {}
              },
              nextToken: {}
            }
          }
        },
        GetResourceShareAssociations: {
          http: {
            requestUri: "/getresourceshareassociations"
          },
          input: {
            type: "structure",
            required: [
              "associationType"
            ],
            members: {
              associationType: {},
              resourceShareArns: {
                shape: "S1o"
              },
              resourceArn: {},
              principal: {},
              associationStatus: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resourceShareAssociations: {
                shape: "S7"
              },
              nextToken: {}
            }
          }
        },
        GetResourceShareInvitations: {
          http: {
            requestUri: "/getresourceshareinvitations"
          },
          input: {
            type: "structure",
            members: {
              resourceShareInvitationArns: {
                type: "list",
                member: {}
              },
              resourceShareArns: {
                shape: "S1o"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resourceShareInvitations: {
                type: "list",
                member: {
                  shape: "S4"
                }
              },
              nextToken: {}
            }
          }
        },
        GetResourceShares: {
          http: {
            requestUri: "/getresourceshares"
          },
          input: {
            type: "structure",
            required: [
              "resourceOwner"
            ],
            members: {
              resourceShareArns: {
                shape: "S1o"
              },
              resourceShareStatus: {},
              resourceOwner: {},
              name: {},
              tagFilters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    tagKey: {},
                    tagValues: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              permissionArn: {},
              permissionVersion: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resourceShares: {
                type: "list",
                member: {
                  shape: "S12"
                }
              },
              nextToken: {}
            }
          }
        },
        ListPendingInvitationResources: {
          http: {
            requestUri: "/listpendinginvitationresources"
          },
          input: {
            type: "structure",
            required: [
              "resourceShareInvitationArn"
            ],
            members: {
              resourceShareInvitationArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              resourceRegionScope: {}
            }
          },
          output: {
            type: "structure",
            members: {
              resources: {
                shape: "S24"
              },
              nextToken: {}
            }
          }
        },
        ListPermissionAssociations: {
          http: {
            requestUri: "/listpermissionassociations"
          },
          input: {
            type: "structure",
            members: {
              permissionArn: {},
              permissionVersion: {
                type: "integer"
              },
              associationStatus: {},
              resourceType: {},
              featureSet: {},
              defaultVersion: {
                type: "boolean"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              permissions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    permissionVersion: {},
                    defaultVersion: {
                      type: "boolean"
                    },
                    resourceType: {},
                    status: {},
                    featureSet: {},
                    lastUpdatedTime: {
                      type: "timestamp"
                    },
                    resourceShareArn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListPermissionVersions: {
          http: {
            requestUri: "/listpermissionversions"
          },
          input: {
            type: "structure",
            required: [
              "permissionArn"
            ],
            members: {
              permissionArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              permissions: {
                shape: "S2e"
              },
              nextToken: {}
            }
          }
        },
        ListPermissions: {
          http: {
            requestUri: "/listpermissions"
          },
          input: {
            type: "structure",
            members: {
              resourceType: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              permissionType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              permissions: {
                shape: "S2e"
              },
              nextToken: {}
            }
          }
        },
        ListPrincipals: {
          http: {
            requestUri: "/listprincipals"
          },
          input: {
            type: "structure",
            required: [
              "resourceOwner"
            ],
            members: {
              resourceOwner: {},
              resourceArn: {},
              principals: {
                shape: "Se"
              },
              resourceType: {},
              resourceShareArns: {
                shape: "S1o"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              principals: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    resourceShareArn: {},
                    creationTime: {
                      type: "timestamp"
                    },
                    lastUpdatedTime: {
                      type: "timestamp"
                    },
                    external: {
                      type: "boolean"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListReplacePermissionAssociationsWork: {
          http: {
            requestUri: "/listreplacepermissionassociationswork"
          },
          input: {
            type: "structure",
            members: {
              workIds: {
                type: "list",
                member: {}
              },
              status: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              replacePermissionAssociationsWorks: {
                type: "list",
                member: {
                  shape: "S2r"
                }
              },
              nextToken: {}
            }
          }
        },
        ListResourceSharePermissions: {
          http: {
            requestUri: "/listresourcesharepermissions"
          },
          input: {
            type: "structure",
            required: [
              "resourceShareArn"
            ],
            members: {
              resourceShareArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              permissions: {
                shape: "S2e"
              },
              nextToken: {}
            }
          }
        },
        ListResourceTypes: {
          http: {
            requestUri: "/listresourcetypes"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              resourceRegionScope: {}
            }
          },
          output: {
            type: "structure",
            members: {
              resourceTypes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    resourceType: {},
                    serviceName: {},
                    resourceRegionScope: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListResources: {
          http: {
            requestUri: "/listresources"
          },
          input: {
            type: "structure",
            required: [
              "resourceOwner"
            ],
            members: {
              resourceOwner: {},
              principal: {},
              resourceType: {},
              resourceArns: {
                shape: "Sd"
              },
              resourceShareArns: {
                shape: "S1o"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              resourceRegionScope: {}
            }
          },
          output: {
            type: "structure",
            members: {
              resources: {
                shape: "S24"
              },
              nextToken: {}
            }
          }
        },
        PromotePermissionCreatedFromPolicy: {
          http: {
            requestUri: "/promotepermissioncreatedfrompolicy"
          },
          input: {
            type: "structure",
            required: [
              "permissionArn",
              "name"
            ],
            members: {
              permissionArn: {},
              name: {},
              clientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              permission: {
                shape: "Ss"
              },
              clientToken: {}
            }
          }
        },
        PromoteResourceShareCreatedFromPolicy: {
          http: {
            requestUri: "/promoteresourcesharecreatedfrompolicy"
          },
          input: {
            type: "structure",
            required: [
              "resourceShareArn"
            ],
            members: {
              resourceShareArn: {
                location: "querystring",
                locationName: "resourceShareArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              returnValue: {
                type: "boolean"
              }
            }
          }
        },
        RejectResourceShareInvitation: {
          http: {
            requestUri: "/rejectresourceshareinvitation"
          },
          input: {
            type: "structure",
            required: [
              "resourceShareInvitationArn"
            ],
            members: {
              resourceShareInvitationArn: {},
              clientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              resourceShareInvitation: {
                shape: "S4"
              },
              clientToken: {}
            }
          }
        },
        ReplacePermissionAssociations: {
          http: {
            requestUri: "/replacepermissionassociations"
          },
          input: {
            type: "structure",
            required: [
              "fromPermissionArn",
              "toPermissionArn"
            ],
            members: {
              fromPermissionArn: {},
              fromPermissionVersion: {
                type: "integer"
              },
              toPermissionArn: {},
              clientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              replacePermissionAssociationsWork: {
                shape: "S2r"
              },
              clientToken: {}
            }
          }
        },
        SetDefaultPermissionVersion: {
          http: {
            requestUri: "/setdefaultpermissionversion"
          },
          input: {
            type: "structure",
            required: [
              "permissionArn",
              "permissionVersion"
            ],
            members: {
              permissionArn: {},
              permissionVersion: {
                type: "integer"
              },
              clientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              returnValue: {
                type: "boolean"
              },
              clientToken: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tagresource"
          },
          input: {
            type: "structure",
            required: [
              "tags"
            ],
            members: {
              resourceShareArn: {},
              tags: {
                shape: "Sn"
              },
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            requestUri: "/untagresource"
          },
          input: {
            type: "structure",
            required: [
              "tagKeys"
            ],
            members: {
              resourceShareArn: {},
              tagKeys: {
                type: "list",
                member: {}
              },
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateResourceShare: {
          http: {
            requestUri: "/updateresourceshare"
          },
          input: {
            type: "structure",
            required: [
              "resourceShareArn"
            ],
            members: {
              resourceShareArn: {},
              name: {},
              allowExternalPrincipals: {
                type: "boolean"
              },
              clientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              resourceShare: {
                shape: "S12"
              },
              clientToken: {}
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            resourceShareInvitationArn: {},
            resourceShareName: {},
            resourceShareArn: {},
            senderAccountId: {},
            receiverAccountId: {},
            invitationTimestamp: {
              type: "timestamp"
            },
            status: {},
            resourceShareAssociations: {
              shape: "S7",
              deprecated: true,
              deprecatedMessage: "This member has been deprecated. Use ListPendingInvitationResources."
            },
            receiverArn: {}
          }
        },
        S7: {
          type: "list",
          member: {
            type: "structure",
            members: {
              resourceShareArn: {},
              resourceShareName: {},
              associatedEntity: {},
              associationType: {},
              status: {},
              statusMessage: {},
              creationTime: {
                type: "timestamp"
              },
              lastUpdatedTime: {
                type: "timestamp"
              },
              external: {
                type: "boolean"
              }
            }
          }
        },
        Sd: {
          type: "list",
          member: {}
        },
        Se: {
          type: "list",
          member: {}
        },
        Sf: {
          type: "list",
          member: {}
        },
        Sn: {
          type: "list",
          member: {
            type: "structure",
            members: {
              key: {},
              value: {}
            }
          }
        },
        Ss: {
          type: "structure",
          members: {
            arn: {},
            version: {},
            defaultVersion: {
              type: "boolean"
            },
            name: {},
            resourceType: {},
            status: {},
            creationTime: {
              type: "timestamp"
            },
            lastUpdatedTime: {
              type: "timestamp"
            },
            isResourceTypeDefault: {
              type: "boolean"
            },
            permissionType: {},
            featureSet: {},
            tags: {
              shape: "Sn"
            }
          }
        },
        Sx: {
          type: "structure",
          members: {
            arn: {},
            version: {},
            defaultVersion: {
              type: "boolean"
            },
            name: {},
            resourceType: {},
            permission: {},
            creationTime: {
              type: "timestamp"
            },
            lastUpdatedTime: {
              type: "timestamp"
            },
            isResourceTypeDefault: {
              type: "boolean"
            },
            permissionType: {},
            featureSet: {},
            status: {},
            tags: {
              shape: "Sn"
            }
          }
        },
        S12: {
          type: "structure",
          members: {
            resourceShareArn: {},
            name: {},
            owningAccountId: {},
            allowExternalPrincipals: {
              type: "boolean"
            },
            status: {},
            statusMessage: {},
            tags: {
              shape: "Sn"
            },
            creationTime: {
              type: "timestamp"
            },
            lastUpdatedTime: {
              type: "timestamp"
            },
            featureSet: {}
          }
        },
        S1o: {
          type: "list",
          member: {}
        },
        S24: {
          type: "list",
          member: {
            type: "structure",
            members: {
              arn: {},
              type: {},
              resourceShareArn: {},
              resourceGroupArn: {},
              status: {},
              statusMessage: {},
              creationTime: {
                type: "timestamp"
              },
              lastUpdatedTime: {
                type: "timestamp"
              },
              resourceRegionScope: {}
            }
          }
        },
        S2e: {
          type: "list",
          member: {
            shape: "Ss"
          }
        },
        S2r: {
          type: "structure",
          members: {
            id: {},
            fromPermissionArn: {},
            fromPermissionVersion: {},
            toPermissionArn: {},
            toPermissionVersion: {},
            status: {},
            statusMessage: {},
            creationTime: {
              type: "timestamp"
            },
            lastUpdatedTime: {
              type: "timestamp"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ram-2018-01-04.paginators.json
var require_ram_2018_01_04_paginators = __commonJS({
  "node_modules/aws-sdk/apis/ram-2018-01-04.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetResourcePolicies: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetResourceShareAssociations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetResourceShareInvitations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetResourceShares: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListPendingInvitationResources: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListPermissionAssociations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListPermissionVersions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListPermissions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListPrincipals: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListReplacePermissionAssociationsWork: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListResourceSharePermissions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListResourceTypes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListResources: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/ram.js
var require_ram = __commonJS({
  "node_modules/aws-sdk/clients/ram.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["ram"] = {};
    AWS2.RAM = Service.defineService("ram", ["2018-01-04"]);
    Object.defineProperty(apiLoader.services["ram"], "2018-01-04", {
      get: function get() {
        var model = require_ram_2018_01_04_min();
        model.paginators = require_ram_2018_01_04_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.RAM;
  }
});

// node_modules/aws-sdk/apis/route53resolver-2018-04-01.min.json
var require_route53resolver_2018_04_01_min = __commonJS({
  "node_modules/aws-sdk/apis/route53resolver-2018-04-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-04-01",
        endpointPrefix: "route53resolver",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Route53Resolver",
        serviceFullName: "Amazon Route 53 Resolver",
        serviceId: "Route53Resolver",
        signatureVersion: "v4",
        targetPrefix: "Route53Resolver",
        uid: "route53resolver-2018-04-01"
      },
      operations: {
        AssociateFirewallRuleGroup: {
          input: {
            type: "structure",
            required: [
              "CreatorRequestId",
              "FirewallRuleGroupId",
              "VpcId",
              "Priority",
              "Name"
            ],
            members: {
              CreatorRequestId: {
                idempotencyToken: true
              },
              FirewallRuleGroupId: {},
              VpcId: {},
              Priority: {
                type: "integer"
              },
              Name: {},
              MutationProtection: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallRuleGroupAssociation: {
                shape: "Sc"
              }
            }
          }
        },
        AssociateResolverEndpointIpAddress: {
          input: {
            type: "structure",
            required: [
              "ResolverEndpointId",
              "IpAddress"
            ],
            members: {
              ResolverEndpointId: {},
              IpAddress: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverEndpoint: {
                shape: "So"
              }
            }
          }
        },
        AssociateResolverQueryLogConfig: {
          input: {
            type: "structure",
            required: [
              "ResolverQueryLogConfigId",
              "ResourceId"
            ],
            members: {
              ResolverQueryLogConfigId: {},
              ResourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverQueryLogConfigAssociation: {
                shape: "S10"
              }
            }
          }
        },
        AssociateResolverRule: {
          input: {
            type: "structure",
            required: [
              "ResolverRuleId",
              "VPCId"
            ],
            members: {
              ResolverRuleId: {},
              Name: {},
              VPCId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverRuleAssociation: {
                shape: "S16"
              }
            }
          }
        },
        CreateFirewallDomainList: {
          input: {
            type: "structure",
            required: [
              "CreatorRequestId",
              "Name"
            ],
            members: {
              CreatorRequestId: {
                idempotencyToken: true
              },
              Name: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallDomainList: {
                shape: "S1a"
              }
            }
          }
        },
        CreateFirewallRule: {
          input: {
            type: "structure",
            required: [
              "CreatorRequestId",
              "FirewallRuleGroupId",
              "FirewallDomainListId",
              "Priority",
              "Action",
              "Name"
            ],
            members: {
              CreatorRequestId: {
                idempotencyToken: true
              },
              FirewallRuleGroupId: {},
              FirewallDomainListId: {},
              Priority: {
                type: "integer"
              },
              Action: {},
              BlockResponse: {},
              BlockOverrideDomain: {},
              BlockOverrideDnsType: {},
              BlockOverrideTtl: {
                type: "integer"
              },
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallRule: {
                shape: "S1k"
              }
            }
          }
        },
        CreateFirewallRuleGroup: {
          input: {
            type: "structure",
            required: [
              "CreatorRequestId",
              "Name"
            ],
            members: {
              CreatorRequestId: {
                idempotencyToken: true
              },
              Name: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallRuleGroup: {
                shape: "S1n"
              }
            }
          }
        },
        CreateOutpostResolver: {
          input: {
            type: "structure",
            required: [
              "CreatorRequestId",
              "Name",
              "PreferredInstanceType",
              "OutpostArn"
            ],
            members: {
              CreatorRequestId: {},
              Name: {},
              InstanceCount: {
                type: "integer"
              },
              PreferredInstanceType: {},
              OutpostArn: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OutpostResolver: {
                shape: "S1v"
              }
            }
          }
        },
        CreateResolverEndpoint: {
          input: {
            type: "structure",
            required: [
              "CreatorRequestId",
              "SecurityGroupIds",
              "Direction",
              "IpAddresses"
            ],
            members: {
              CreatorRequestId: {},
              Name: {},
              SecurityGroupIds: {
                shape: "Sp"
              },
              Direction: {},
              IpAddresses: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "SubnetId"
                  ],
                  members: {
                    SubnetId: {},
                    Ip: {},
                    Ipv6: {}
                  }
                }
              },
              OutpostArn: {},
              PreferredInstanceType: {},
              Tags: {
                shape: "S7"
              },
              ResolverEndpointType: {},
              Protocols: {
                shape: "Sw"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverEndpoint: {
                shape: "So"
              }
            }
          }
        },
        CreateResolverQueryLogConfig: {
          input: {
            type: "structure",
            required: [
              "Name",
              "DestinationArn",
              "CreatorRequestId"
            ],
            members: {
              Name: {},
              DestinationArn: {},
              CreatorRequestId: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverQueryLogConfig: {
                shape: "S26"
              }
            }
          }
        },
        CreateResolverRule: {
          input: {
            type: "structure",
            required: [
              "CreatorRequestId",
              "RuleType"
            ],
            members: {
              CreatorRequestId: {},
              Name: {},
              RuleType: {},
              DomainName: {},
              TargetIps: {
                shape: "S2c"
              },
              ResolverEndpointId: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverRule: {
                shape: "S2g"
              }
            }
          }
        },
        DeleteFirewallDomainList: {
          input: {
            type: "structure",
            required: [
              "FirewallDomainListId"
            ],
            members: {
              FirewallDomainListId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallDomainList: {
                shape: "S1a"
              }
            }
          }
        },
        DeleteFirewallRule: {
          input: {
            type: "structure",
            required: [
              "FirewallRuleGroupId",
              "FirewallDomainListId"
            ],
            members: {
              FirewallRuleGroupId: {},
              FirewallDomainListId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallRule: {
                shape: "S1k"
              }
            }
          }
        },
        DeleteFirewallRuleGroup: {
          input: {
            type: "structure",
            required: [
              "FirewallRuleGroupId"
            ],
            members: {
              FirewallRuleGroupId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallRuleGroup: {
                shape: "S1n"
              }
            }
          }
        },
        DeleteOutpostResolver: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OutpostResolver: {
                shape: "S1v"
              }
            }
          }
        },
        DeleteResolverEndpoint: {
          input: {
            type: "structure",
            required: [
              "ResolverEndpointId"
            ],
            members: {
              ResolverEndpointId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverEndpoint: {
                shape: "So"
              }
            }
          }
        },
        DeleteResolverQueryLogConfig: {
          input: {
            type: "structure",
            required: [
              "ResolverQueryLogConfigId"
            ],
            members: {
              ResolverQueryLogConfigId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverQueryLogConfig: {
                shape: "S26"
              }
            }
          }
        },
        DeleteResolverRule: {
          input: {
            type: "structure",
            required: [
              "ResolverRuleId"
            ],
            members: {
              ResolverRuleId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverRule: {
                shape: "S2g"
              }
            }
          }
        },
        DisassociateFirewallRuleGroup: {
          input: {
            type: "structure",
            required: [
              "FirewallRuleGroupAssociationId"
            ],
            members: {
              FirewallRuleGroupAssociationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallRuleGroupAssociation: {
                shape: "Sc"
              }
            }
          }
        },
        DisassociateResolverEndpointIpAddress: {
          input: {
            type: "structure",
            required: [
              "ResolverEndpointId",
              "IpAddress"
            ],
            members: {
              ResolverEndpointId: {},
              IpAddress: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverEndpoint: {
                shape: "So"
              }
            }
          }
        },
        DisassociateResolverQueryLogConfig: {
          input: {
            type: "structure",
            required: [
              "ResolverQueryLogConfigId",
              "ResourceId"
            ],
            members: {
              ResolverQueryLogConfigId: {},
              ResourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverQueryLogConfigAssociation: {
                shape: "S10"
              }
            }
          }
        },
        DisassociateResolverRule: {
          input: {
            type: "structure",
            required: [
              "VPCId",
              "ResolverRuleId"
            ],
            members: {
              VPCId: {},
              ResolverRuleId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverRuleAssociation: {
                shape: "S16"
              }
            }
          }
        },
        GetFirewallConfig: {
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              ResourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallConfig: {
                shape: "S36"
              }
            }
          }
        },
        GetFirewallDomainList: {
          input: {
            type: "structure",
            required: [
              "FirewallDomainListId"
            ],
            members: {
              FirewallDomainListId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallDomainList: {
                shape: "S1a"
              }
            }
          }
        },
        GetFirewallRuleGroup: {
          input: {
            type: "structure",
            required: [
              "FirewallRuleGroupId"
            ],
            members: {
              FirewallRuleGroupId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallRuleGroup: {
                shape: "S1n"
              }
            }
          }
        },
        GetFirewallRuleGroupAssociation: {
          input: {
            type: "structure",
            required: [
              "FirewallRuleGroupAssociationId"
            ],
            members: {
              FirewallRuleGroupAssociationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallRuleGroupAssociation: {
                shape: "Sc"
              }
            }
          }
        },
        GetFirewallRuleGroupPolicy: {
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallRuleGroupPolicy: {}
            }
          }
        },
        GetOutpostResolver: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OutpostResolver: {
                shape: "S1v"
              }
            }
          }
        },
        GetResolverConfig: {
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              ResourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverConfig: {
                shape: "S3l"
              }
            }
          }
        },
        GetResolverDnssecConfig: {
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              ResourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverDNSSECConfig: {
                shape: "S3p"
              }
            }
          }
        },
        GetResolverEndpoint: {
          input: {
            type: "structure",
            required: [
              "ResolverEndpointId"
            ],
            members: {
              ResolverEndpointId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverEndpoint: {
                shape: "So"
              }
            }
          }
        },
        GetResolverQueryLogConfig: {
          input: {
            type: "structure",
            required: [
              "ResolverQueryLogConfigId"
            ],
            members: {
              ResolverQueryLogConfigId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverQueryLogConfig: {
                shape: "S26"
              }
            }
          }
        },
        GetResolverQueryLogConfigAssociation: {
          input: {
            type: "structure",
            required: [
              "ResolverQueryLogConfigAssociationId"
            ],
            members: {
              ResolverQueryLogConfigAssociationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverQueryLogConfigAssociation: {
                shape: "S10"
              }
            }
          }
        },
        GetResolverQueryLogConfigPolicy: {
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverQueryLogConfigPolicy: {}
            }
          }
        },
        GetResolverRule: {
          input: {
            type: "structure",
            required: [
              "ResolverRuleId"
            ],
            members: {
              ResolverRuleId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverRule: {
                shape: "S2g"
              }
            }
          }
        },
        GetResolverRuleAssociation: {
          input: {
            type: "structure",
            required: [
              "ResolverRuleAssociationId"
            ],
            members: {
              ResolverRuleAssociationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverRuleAssociation: {
                shape: "S16"
              }
            }
          }
        },
        GetResolverRulePolicy: {
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverRulePolicy: {}
            }
          }
        },
        ImportFirewallDomains: {
          input: {
            type: "structure",
            required: [
              "FirewallDomainListId",
              "Operation",
              "DomainFileUrl"
            ],
            members: {
              FirewallDomainListId: {},
              Operation: {},
              DomainFileUrl: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {},
              Name: {},
              Status: {},
              StatusMessage: {}
            }
          }
        },
        ListFirewallConfigs: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              FirewallConfigs: {
                type: "list",
                member: {
                  shape: "S36"
                }
              }
            }
          }
        },
        ListFirewallDomainLists: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              FirewallDomainLists: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Name: {},
                    CreatorRequestId: {},
                    ManagedOwnerName: {}
                  }
                }
              }
            }
          }
        },
        ListFirewallDomains: {
          input: {
            type: "structure",
            required: [
              "FirewallDomainListId"
            ],
            members: {
              FirewallDomainListId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Domains: {
                shape: "S4o"
              }
            }
          }
        },
        ListFirewallRuleGroupAssociations: {
          input: {
            type: "structure",
            members: {
              FirewallRuleGroupId: {},
              VpcId: {},
              Priority: {
                type: "integer"
              },
              Status: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              FirewallRuleGroupAssociations: {
                type: "list",
                member: {
                  shape: "Sc"
                }
              }
            }
          }
        },
        ListFirewallRuleGroups: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              FirewallRuleGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Name: {},
                    OwnerId: {},
                    CreatorRequestId: {},
                    ShareStatus: {}
                  }
                }
              }
            }
          }
        },
        ListFirewallRules: {
          input: {
            type: "structure",
            required: [
              "FirewallRuleGroupId"
            ],
            members: {
              FirewallRuleGroupId: {},
              Priority: {
                type: "integer"
              },
              Action: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              FirewallRules: {
                type: "list",
                member: {
                  shape: "S1k"
                }
              }
            }
          }
        },
        ListOutpostResolvers: {
          input: {
            type: "structure",
            members: {
              OutpostArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OutpostResolvers: {
                type: "list",
                member: {
                  shape: "S1v"
                }
              },
              NextToken: {}
            }
          }
        },
        ListResolverConfigs: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ResolverConfigs: {
                type: "list",
                member: {
                  shape: "S3l"
                }
              }
            }
          }
        },
        ListResolverDnssecConfigs: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "S58"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ResolverDnssecConfigs: {
                type: "list",
                member: {
                  shape: "S3p"
                }
              }
            }
          }
        },
        ListResolverEndpointIpAddresses: {
          input: {
            type: "structure",
            required: [
              "ResolverEndpointId"
            ],
            members: {
              ResolverEndpointId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              IpAddresses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    IpId: {},
                    SubnetId: {},
                    Ip: {},
                    Ipv6: {},
                    Status: {},
                    StatusMessage: {},
                    CreationTime: {},
                    ModificationTime: {}
                  }
                }
              }
            }
          }
        },
        ListResolverEndpoints: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "S58"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ResolverEndpoints: {
                type: "list",
                member: {
                  shape: "So"
                }
              }
            }
          }
        },
        ListResolverQueryLogConfigAssociations: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "S58"
              },
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              TotalCount: {
                type: "integer"
              },
              TotalFilteredCount: {
                type: "integer"
              },
              ResolverQueryLogConfigAssociations: {
                type: "list",
                member: {
                  shape: "S10"
                }
              }
            }
          }
        },
        ListResolverQueryLogConfigs: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "S58"
              },
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              TotalCount: {
                type: "integer"
              },
              TotalFilteredCount: {
                type: "integer"
              },
              ResolverQueryLogConfigs: {
                type: "list",
                member: {
                  shape: "S26"
                }
              }
            }
          }
        },
        ListResolverRuleAssociations: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "S58"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ResolverRuleAssociations: {
                type: "list",
                member: {
                  shape: "S16"
                }
              }
            }
          }
        },
        ListResolverRules: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "S58"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ResolverRules: {
                type: "list",
                member: {
                  shape: "S2g"
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S7"
              },
              NextToken: {}
            }
          }
        },
        PutFirewallRuleGroupPolicy: {
          input: {
            type: "structure",
            required: [
              "Arn",
              "FirewallRuleGroupPolicy"
            ],
            members: {
              Arn: {},
              FirewallRuleGroupPolicy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReturnValue: {
                type: "boolean"
              }
            }
          }
        },
        PutResolverQueryLogConfigPolicy: {
          input: {
            type: "structure",
            required: [
              "Arn",
              "ResolverQueryLogConfigPolicy"
            ],
            members: {
              Arn: {},
              ResolverQueryLogConfigPolicy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReturnValue: {
                type: "boolean"
              }
            }
          }
        },
        PutResolverRulePolicy: {
          input: {
            type: "structure",
            required: [
              "Arn",
              "ResolverRulePolicy"
            ],
            members: {
              Arn: {},
              ResolverRulePolicy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReturnValue: {
                type: "boolean"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateFirewallConfig: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "FirewallFailOpen"
            ],
            members: {
              ResourceId: {},
              FirewallFailOpen: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallConfig: {
                shape: "S36"
              }
            }
          }
        },
        UpdateFirewallDomains: {
          input: {
            type: "structure",
            required: [
              "FirewallDomainListId",
              "Operation",
              "Domains"
            ],
            members: {
              FirewallDomainListId: {},
              Operation: {},
              Domains: {
                shape: "S4o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {},
              Name: {},
              Status: {},
              StatusMessage: {}
            }
          }
        },
        UpdateFirewallRule: {
          input: {
            type: "structure",
            required: [
              "FirewallRuleGroupId",
              "FirewallDomainListId"
            ],
            members: {
              FirewallRuleGroupId: {},
              FirewallDomainListId: {},
              Priority: {
                type: "integer"
              },
              Action: {},
              BlockResponse: {},
              BlockOverrideDomain: {},
              BlockOverrideDnsType: {},
              BlockOverrideTtl: {
                type: "integer"
              },
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallRule: {
                shape: "S1k"
              }
            }
          }
        },
        UpdateFirewallRuleGroupAssociation: {
          input: {
            type: "structure",
            required: [
              "FirewallRuleGroupAssociationId"
            ],
            members: {
              FirewallRuleGroupAssociationId: {},
              Priority: {
                type: "integer"
              },
              MutationProtection: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallRuleGroupAssociation: {
                shape: "Sc"
              }
            }
          }
        },
        UpdateOutpostResolver: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {},
              Name: {},
              InstanceCount: {
                type: "integer"
              },
              PreferredInstanceType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OutpostResolver: {
                shape: "S1v"
              }
            }
          }
        },
        UpdateResolverConfig: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "AutodefinedReverseFlag"
            ],
            members: {
              ResourceId: {},
              AutodefinedReverseFlag: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverConfig: {
                shape: "S3l"
              }
            }
          }
        },
        UpdateResolverDnssecConfig: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "Validation"
            ],
            members: {
              ResourceId: {},
              Validation: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverDNSSECConfig: {
                shape: "S3p"
              }
            }
          }
        },
        UpdateResolverEndpoint: {
          input: {
            type: "structure",
            required: [
              "ResolverEndpointId"
            ],
            members: {
              ResolverEndpointId: {},
              Name: {},
              ResolverEndpointType: {},
              UpdateIpAddresses: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "IpId",
                    "Ipv6"
                  ],
                  members: {
                    IpId: {},
                    Ipv6: {}
                  }
                }
              },
              Protocols: {
                shape: "Sw"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverEndpoint: {
                shape: "So"
              }
            }
          }
        },
        UpdateResolverRule: {
          input: {
            type: "structure",
            required: [
              "ResolverRuleId",
              "Config"
            ],
            members: {
              ResolverRuleId: {},
              Config: {
                type: "structure",
                members: {
                  Name: {},
                  TargetIps: {
                    shape: "S2c"
                  },
                  ResolverEndpointId: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverRule: {
                shape: "S2g"
              }
            }
          }
        }
      },
      shapes: {
        S7: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sc: {
          type: "structure",
          members: {
            Id: {},
            Arn: {},
            FirewallRuleGroupId: {},
            VpcId: {},
            Name: {},
            Priority: {
              type: "integer"
            },
            MutationProtection: {},
            ManagedOwnerName: {},
            Status: {},
            StatusMessage: {},
            CreatorRequestId: {},
            CreationTime: {},
            ModificationTime: {}
          }
        },
        Sj: {
          type: "structure",
          members: {
            IpId: {},
            SubnetId: {},
            Ip: {},
            Ipv6: {}
          }
        },
        So: {
          type: "structure",
          members: {
            Id: {},
            CreatorRequestId: {},
            Arn: {},
            Name: {},
            SecurityGroupIds: {
              shape: "Sp"
            },
            Direction: {},
            IpAddressCount: {
              type: "integer"
            },
            HostVPCId: {},
            Status: {},
            StatusMessage: {},
            CreationTime: {},
            ModificationTime: {},
            OutpostArn: {},
            PreferredInstanceType: {},
            ResolverEndpointType: {},
            Protocols: {
              shape: "Sw"
            }
          }
        },
        Sp: {
          type: "list",
          member: {}
        },
        Sw: {
          type: "list",
          member: {}
        },
        S10: {
          type: "structure",
          members: {
            Id: {},
            ResolverQueryLogConfigId: {},
            ResourceId: {},
            Status: {},
            Error: {},
            ErrorMessage: {},
            CreationTime: {}
          }
        },
        S16: {
          type: "structure",
          members: {
            Id: {},
            ResolverRuleId: {},
            Name: {},
            VPCId: {},
            Status: {},
            StatusMessage: {}
          }
        },
        S1a: {
          type: "structure",
          members: {
            Id: {},
            Arn: {},
            Name: {},
            DomainCount: {
              type: "integer"
            },
            Status: {},
            StatusMessage: {},
            ManagedOwnerName: {},
            CreatorRequestId: {},
            CreationTime: {},
            ModificationTime: {}
          }
        },
        S1k: {
          type: "structure",
          members: {
            FirewallRuleGroupId: {},
            FirewallDomainListId: {},
            Name: {},
            Priority: {
              type: "integer"
            },
            Action: {},
            BlockResponse: {},
            BlockOverrideDomain: {},
            BlockOverrideDnsType: {},
            BlockOverrideTtl: {
              type: "integer"
            },
            CreatorRequestId: {},
            CreationTime: {},
            ModificationTime: {}
          }
        },
        S1n: {
          type: "structure",
          members: {
            Id: {},
            Arn: {},
            Name: {},
            RuleCount: {
              type: "integer"
            },
            Status: {},
            StatusMessage: {},
            OwnerId: {},
            CreatorRequestId: {},
            ShareStatus: {},
            CreationTime: {},
            ModificationTime: {}
          }
        },
        S1v: {
          type: "structure",
          members: {
            Arn: {},
            CreationTime: {},
            ModificationTime: {},
            CreatorRequestId: {},
            Id: {},
            InstanceCount: {
              type: "integer"
            },
            PreferredInstanceType: {},
            Name: {},
            Status: {},
            StatusMessage: {},
            OutpostArn: {}
          }
        },
        S26: {
          type: "structure",
          members: {
            Id: {},
            OwnerId: {},
            Status: {},
            ShareStatus: {},
            AssociationCount: {
              type: "integer"
            },
            Arn: {},
            Name: {},
            DestinationArn: {},
            CreatorRequestId: {},
            CreationTime: {}
          }
        },
        S2c: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Ip: {},
              Port: {
                type: "integer"
              },
              Ipv6: {},
              Protocol: {}
            }
          }
        },
        S2g: {
          type: "structure",
          members: {
            Id: {},
            CreatorRequestId: {},
            Arn: {},
            DomainName: {},
            Status: {},
            StatusMessage: {},
            RuleType: {},
            Name: {},
            TargetIps: {
              shape: "S2c"
            },
            ResolverEndpointId: {},
            OwnerId: {},
            ShareStatus: {},
            CreationTime: {},
            ModificationTime: {}
          }
        },
        S36: {
          type: "structure",
          members: {
            Id: {},
            ResourceId: {},
            OwnerId: {},
            FirewallFailOpen: {}
          }
        },
        S3l: {
          type: "structure",
          members: {
            Id: {},
            ResourceId: {},
            OwnerId: {},
            AutodefinedReverse: {}
          }
        },
        S3p: {
          type: "structure",
          members: {
            Id: {},
            OwnerId: {},
            ResourceId: {},
            ValidationStatus: {}
          }
        },
        S4o: {
          type: "list",
          member: {}
        },
        S58: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Values: {
                type: "list",
                member: {}
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/route53resolver-2018-04-01.paginators.json
var require_route53resolver_2018_04_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/route53resolver-2018-04-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListFirewallConfigs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "FirewallConfigs"
        },
        ListFirewallDomainLists: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "FirewallDomainLists"
        },
        ListFirewallDomains: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Domains"
        },
        ListFirewallRuleGroupAssociations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "FirewallRuleGroupAssociations"
        },
        ListFirewallRuleGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "FirewallRuleGroups"
        },
        ListFirewallRules: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "FirewallRules"
        },
        ListOutpostResolvers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "OutpostResolvers"
        },
        ListResolverConfigs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ResolverConfigs"
        },
        ListResolverDnssecConfigs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ResolverDnssecConfigs"
        },
        ListResolverEndpointIpAddresses: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "IpAddresses"
        },
        ListResolverEndpoints: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ResolverEndpoints"
        },
        ListResolverQueryLogConfigAssociations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ResolverQueryLogConfigAssociations"
        },
        ListResolverQueryLogConfigs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ResolverQueryLogConfigs"
        },
        ListResolverRuleAssociations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ResolverRuleAssociations"
        },
        ListResolverRules: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ResolverRules"
        },
        ListTagsForResource: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Tags"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/route53resolver.js
var require_route53resolver = __commonJS({
  "node_modules/aws-sdk/clients/route53resolver.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["route53resolver"] = {};
    AWS2.Route53Resolver = Service.defineService("route53resolver", ["2018-04-01"]);
    Object.defineProperty(apiLoader.services["route53resolver"], "2018-04-01", {
      get: function get() {
        var model = require_route53resolver_2018_04_01_min();
        model.paginators = require_route53resolver_2018_04_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Route53Resolver;
  }
});

// node_modules/aws-sdk/apis/sms-voice-2018-09-05.min.json
var require_sms_voice_2018_09_05_min = __commonJS({
  "node_modules/aws-sdk/apis/sms-voice-2018-09-05.min.json"(exports2, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2018-09-05",
        endpointPrefix: "sms-voice.pinpoint",
        signingName: "sms-voice",
        serviceAbbreviation: "Pinpoint SMS Voice",
        serviceFullName: "Amazon Pinpoint SMS and Voice Service",
        serviceId: "Pinpoint SMS Voice",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "pinpoint-sms-voice-2018-09-05",
        signatureVersion: "v4"
      },
      operations: {
        CreateConfigurationSet: {
          http: {
            requestUri: "/v1/sms-voice/configuration-sets",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConfigurationSetName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateConfigurationSetEventDestination: {
          http: {
            requestUri: "/v1/sms-voice/configuration-sets/{ConfigurationSetName}/event-destinations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              EventDestination: {
                shape: "S6"
              },
              EventDestinationName: {}
            },
            required: [
              "ConfigurationSetName"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteConfigurationSet: {
          http: {
            method: "DELETE",
            requestUri: "/v1/sms-voice/configuration-sets/{ConfigurationSetName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              }
            },
            required: [
              "ConfigurationSetName"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteConfigurationSetEventDestination: {
          http: {
            method: "DELETE",
            requestUri: "/v1/sms-voice/configuration-sets/{ConfigurationSetName}/event-destinations/{EventDestinationName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              EventDestinationName: {
                location: "uri",
                locationName: "EventDestinationName"
              }
            },
            required: [
              "EventDestinationName",
              "ConfigurationSetName"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetConfigurationSetEventDestinations: {
          http: {
            method: "GET",
            requestUri: "/v1/sms-voice/configuration-sets/{ConfigurationSetName}/event-destinations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              }
            },
            required: [
              "ConfigurationSetName"
            ]
          },
          output: {
            type: "structure",
            members: {
              EventDestinations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CloudWatchLogsDestination: {
                      shape: "S7"
                    },
                    Enabled: {
                      type: "boolean"
                    },
                    KinesisFirehoseDestination: {
                      shape: "Sa"
                    },
                    MatchingEventTypes: {
                      shape: "Sb"
                    },
                    Name: {},
                    SnsDestination: {
                      shape: "Sd"
                    }
                  }
                }
              }
            }
          }
        },
        ListConfigurationSets: {
          http: {
            method: "GET",
            requestUri: "/v1/sms-voice/configuration-sets",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationSets: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        SendVoiceMessage: {
          http: {
            requestUri: "/v1/sms-voice/voice/message",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CallerId: {},
              ConfigurationSetName: {},
              Content: {
                type: "structure",
                members: {
                  CallInstructionsMessage: {
                    type: "structure",
                    members: {
                      Text: {}
                    },
                    required: []
                  },
                  PlainTextMessage: {
                    type: "structure",
                    members: {
                      LanguageCode: {},
                      Text: {},
                      VoiceId: {}
                    },
                    required: []
                  },
                  SSMLMessage: {
                    type: "structure",
                    members: {
                      LanguageCode: {},
                      Text: {},
                      VoiceId: {}
                    },
                    required: []
                  }
                }
              },
              DestinationPhoneNumber: {},
              OriginationPhoneNumber: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MessageId: {}
            }
          }
        },
        UpdateConfigurationSetEventDestination: {
          http: {
            method: "PUT",
            requestUri: "/v1/sms-voice/configuration-sets/{ConfigurationSetName}/event-destinations/{EventDestinationName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              EventDestination: {
                shape: "S6"
              },
              EventDestinationName: {
                location: "uri",
                locationName: "EventDestinationName"
              }
            },
            required: [
              "EventDestinationName",
              "ConfigurationSetName"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S6: {
          type: "structure",
          members: {
            CloudWatchLogsDestination: {
              shape: "S7"
            },
            Enabled: {
              type: "boolean"
            },
            KinesisFirehoseDestination: {
              shape: "Sa"
            },
            MatchingEventTypes: {
              shape: "Sb"
            },
            SnsDestination: {
              shape: "Sd"
            }
          },
          required: []
        },
        S7: {
          type: "structure",
          members: {
            IamRoleArn: {},
            LogGroupArn: {}
          },
          required: []
        },
        Sa: {
          type: "structure",
          members: {
            DeliveryStreamArn: {},
            IamRoleArn: {}
          },
          required: []
        },
        Sb: {
          type: "list",
          member: {}
        },
        Sd: {
          type: "structure",
          members: {
            TopicArn: {}
          },
          required: []
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/pinpointsmsvoice.js
var require_pinpointsmsvoice = __commonJS({
  "node_modules/aws-sdk/clients/pinpointsmsvoice.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["pinpointsmsvoice"] = {};
    AWS2.PinpointSMSVoice = Service.defineService("pinpointsmsvoice", ["2018-09-05"]);
    Object.defineProperty(apiLoader.services["pinpointsmsvoice"], "2018-09-05", {
      get: function get() {
        var model = require_sms_voice_2018_09_05_min();
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.PinpointSMSVoice;
  }
});

// node_modules/aws-sdk/apis/quicksight-2018-04-01.min.json
var require_quicksight_2018_04_01_min = __commonJS({
  "node_modules/aws-sdk/apis/quicksight-2018-04-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-04-01",
        endpointPrefix: "quicksight",
        jsonVersion: "1.0",
        protocol: "rest-json",
        serviceFullName: "Amazon QuickSight",
        serviceId: "QuickSight",
        signatureVersion: "v4",
        uid: "quicksight-2018-04-01"
      },
      operations: {
        CancelIngestion: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/data-sets/{DataSetId}/ingestions/{IngestionId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSetId",
              "IngestionId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              IngestionId: {
                location: "uri",
                locationName: "IngestionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              IngestionId: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        CreateAccountCustomization: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/customizations"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "AccountCustomization"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              AccountCustomization: {
                shape: "Sa"
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              AwsAccountId: {},
              Namespace: {},
              AccountCustomization: {
                shape: "Sa"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        CreateAccountSubscription: {
          http: {
            requestUri: "/account/{AwsAccountId}"
          },
          input: {
            type: "structure",
            required: [
              "Edition",
              "AuthenticationMethod",
              "AwsAccountId",
              "AccountName",
              "NotificationEmail"
            ],
            members: {
              Edition: {},
              AuthenticationMethod: {},
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              AccountName: {},
              NotificationEmail: {},
              ActiveDirectoryName: {},
              Realm: {},
              DirectoryId: {},
              AdminGroup: {
                shape: "Sk"
              },
              AuthorGroup: {
                shape: "Sk"
              },
              ReaderGroup: {
                shape: "Sk"
              },
              FirstName: {},
              LastName: {},
              EmailAddress: {},
              ContactNumber: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SignupResponse: {
                type: "structure",
                members: {
                  IAMUser: {
                    type: "boolean"
                  },
                  userLoginName: {},
                  accountName: {},
                  directoryType: {}
                }
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        CreateAnalysis: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/analyses/{AnalysisId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "AnalysisId",
              "Name"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              AnalysisId: {
                location: "uri",
                locationName: "AnalysisId"
              },
              Name: {},
              Parameters: {
                shape: "Sr"
              },
              Permissions: {
                shape: "S19"
              },
              SourceEntity: {
                shape: "S1d"
              },
              ThemeArn: {},
              Tags: {
                shape: "Sb"
              },
              Definition: {
                shape: "S1h"
              },
              ValidationStrategy: {
                shape: "Sm5"
              },
              FolderArns: {
                shape: "Sm7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              AnalysisId: {},
              CreationStatus: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        CreateDashboard: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/dashboards/{DashboardId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DashboardId",
              "Name"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DashboardId: {
                location: "uri",
                locationName: "DashboardId"
              },
              Name: {},
              Parameters: {
                shape: "Sr"
              },
              Permissions: {
                shape: "S19"
              },
              SourceEntity: {
                shape: "Smc"
              },
              Tags: {
                shape: "Sb"
              },
              VersionDescription: {},
              DashboardPublishOptions: {
                shape: "Smf"
              },
              ThemeArn: {},
              Definition: {
                shape: "Smu"
              },
              ValidationStrategy: {
                shape: "Sm5"
              },
              FolderArns: {
                shape: "Sm7"
              },
              LinkSharingConfiguration: {
                shape: "Smv"
              },
              LinkEntities: {
                shape: "Smw"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              VersionArn: {},
              DashboardId: {},
              CreationStatus: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        CreateDataSet: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/data-sets"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSetId",
              "Name",
              "PhysicalTableMap",
              "ImportMode"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSetId: {},
              Name: {},
              PhysicalTableMap: {
                shape: "Sn2"
              },
              LogicalTableMap: {
                shape: "Snm"
              },
              ImportMode: {},
              ColumnGroups: {
                shape: "Sot"
              },
              FieldFolders: {
                shape: "Soz"
              },
              Permissions: {
                shape: "S19"
              },
              RowLevelPermissionDataSet: {
                shape: "Sp4"
              },
              RowLevelPermissionTagConfiguration: {
                shape: "Sp8"
              },
              ColumnLevelPermissionRules: {
                shape: "Spg"
              },
              Tags: {
                shape: "Sb"
              },
              DataSetUsageConfiguration: {
                shape: "Spk"
              },
              DatasetParameters: {
                shape: "Spl"
              },
              FolderArns: {
                shape: "Sm7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              DataSetId: {},
              IngestionArn: {},
              IngestionId: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        CreateDataSource: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/data-sources"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSourceId",
              "Name",
              "Type"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSourceId: {},
              Name: {},
              Type: {},
              DataSourceParameters: {
                shape: "Sq0"
              },
              Credentials: {
                shape: "Srh"
              },
              Permissions: {
                shape: "S19"
              },
              VpcConnectionProperties: {
                shape: "Sro"
              },
              SslProperties: {
                shape: "Srp"
              },
              Tags: {
                shape: "Sb"
              },
              FolderArns: {
                shape: "Sm7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              DataSourceId: {},
              CreationStatus: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        CreateFolder: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/folders/{FolderId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "FolderId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              },
              Name: {},
              FolderType: {},
              ParentFolderArn: {},
              Permissions: {
                shape: "S19"
              },
              Tags: {
                shape: "Sb"
              },
              SharingModel: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              },
              Arn: {},
              FolderId: {},
              RequestId: {}
            }
          }
        },
        CreateFolderMembership: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/folders/{FolderId}/members/{MemberType}/{MemberId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "FolderId",
              "MemberId",
              "MemberType"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              },
              MemberId: {
                location: "uri",
                locationName: "MemberId"
              },
              MemberType: {
                location: "uri",
                locationName: "MemberType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                type: "integer"
              },
              FolderMember: {
                type: "structure",
                members: {
                  MemberId: {},
                  MemberType: {}
                }
              },
              RequestId: {}
            }
          }
        },
        CreateGroup: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/groups"
          },
          input: {
            type: "structure",
            required: [
              "GroupName",
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              GroupName: {},
              Description: {},
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Group: {
                shape: "Ss5"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        CreateGroupMembership: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/groups/{GroupName}/members/{MemberName}"
          },
          input: {
            type: "structure",
            required: [
              "MemberName",
              "GroupName",
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              MemberName: {
                location: "uri",
                locationName: "MemberName"
              },
              GroupName: {
                location: "uri",
                locationName: "GroupName"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GroupMember: {
                shape: "Ss9"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        CreateIAMPolicyAssignment: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/iam-policy-assignments/"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "AssignmentName",
              "AssignmentStatus",
              "Namespace"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              AssignmentName: {},
              AssignmentStatus: {},
              PolicyArn: {},
              Identities: {
                shape: "Ssd"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssignmentName: {},
              AssignmentId: {},
              AssignmentStatus: {},
              PolicyArn: {},
              Identities: {
                shape: "Ssd"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        CreateIngestion: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/data-sets/{DataSetId}/ingestions/{IngestionId}"
          },
          input: {
            type: "structure",
            required: [
              "DataSetId",
              "IngestionId",
              "AwsAccountId"
            ],
            members: {
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              IngestionId: {
                location: "uri",
                locationName: "IngestionId"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              IngestionType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              IngestionId: {},
              IngestionStatus: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        CreateNamespace: {
          http: {
            requestUri: "/accounts/{AwsAccountId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "Namespace",
              "IdentityStore"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {},
              IdentityStore: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Name: {},
              CapacityRegion: {},
              CreationStatus: {},
              IdentityStore: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        CreateRefreshSchedule: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/data-sets/{DataSetId}/refresh-schedules"
          },
          input: {
            type: "structure",
            required: [
              "DataSetId",
              "AwsAccountId",
              "Schedule"
            ],
            members: {
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Schedule: {
                shape: "Ssq"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {},
              ScheduleId: {},
              Arn: {}
            }
          }
        },
        CreateRoleMembership: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/roles/{Role}/members/{MemberName}"
          },
          input: {
            type: "structure",
            required: [
              "MemberName",
              "AwsAccountId",
              "Namespace",
              "Role"
            ],
            members: {
              MemberName: {
                location: "uri",
                locationName: "MemberName"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              },
              Role: {
                location: "uri",
                locationName: "Role"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        CreateTemplate: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/templates/{TemplateId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TemplateId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TemplateId: {
                location: "uri",
                locationName: "TemplateId"
              },
              Name: {},
              Permissions: {
                shape: "S19"
              },
              SourceEntity: {
                shape: "St2"
              },
              Tags: {
                shape: "Sb"
              },
              VersionDescription: {},
              Definition: {
                shape: "St5"
              },
              ValidationStrategy: {
                shape: "Sm5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              VersionArn: {},
              TemplateId: {},
              CreationStatus: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        CreateTemplateAlias: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/templates/{TemplateId}/aliases/{AliasName}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TemplateId",
              "AliasName",
              "TemplateVersionNumber"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TemplateId: {
                location: "uri",
                locationName: "TemplateId"
              },
              AliasName: {
                location: "uri",
                locationName: "AliasName"
              },
              TemplateVersionNumber: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplateAlias: {
                shape: "Stk"
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        CreateTheme: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/themes/{ThemeId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "ThemeId",
              "Name",
              "BaseThemeId",
              "Configuration"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              ThemeId: {
                location: "uri",
                locationName: "ThemeId"
              },
              Name: {},
              BaseThemeId: {},
              VersionDescription: {},
              Configuration: {
                shape: "Stn"
              },
              Permissions: {
                shape: "S19"
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              VersionArn: {},
              ThemeId: {},
              CreationStatus: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        CreateThemeAlias: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/themes/{ThemeId}/aliases/{AliasName}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "ThemeId",
              "AliasName",
              "ThemeVersionNumber"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              ThemeId: {
                location: "uri",
                locationName: "ThemeId"
              },
              AliasName: {
                location: "uri",
                locationName: "AliasName"
              },
              ThemeVersionNumber: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ThemeAlias: {
                shape: "Su3"
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        CreateTopic: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/topics"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TopicId",
              "Topic"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TopicId: {},
              Topic: {
                shape: "Su6"
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              TopicId: {},
              RefreshArn: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        CreateTopicRefreshSchedule: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/topics/{TopicId}/schedules"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TopicId",
              "DatasetArn",
              "RefreshSchedule"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TopicId: {
                location: "uri",
                locationName: "TopicId"
              },
              DatasetArn: {},
              DatasetName: {},
              RefreshSchedule: {
                shape: "Svv"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TopicId: {},
              TopicArn: {},
              DatasetArn: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        CreateVPCConnection: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/vpc-connections"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "VPCConnectionId",
              "Name",
              "SubnetIds",
              "SecurityGroupIds",
              "RoleArn"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              VPCConnectionId: {},
              Name: {},
              SubnetIds: {
                shape: "Sw0"
              },
              SecurityGroupIds: {
                shape: "Sw2"
              },
              DnsResolvers: {
                shape: "Sw4"
              },
              RoleArn: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              VPCConnectionId: {},
              CreationStatus: {},
              AvailabilityStatus: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DeleteAccountCustomization: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/customizations"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "querystring",
                locationName: "namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DeleteAccountSubscription: {
          http: {
            method: "DELETE",
            requestUri: "/account/{AwsAccountId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DeleteAnalysis: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/analyses/{AnalysisId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "AnalysisId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              AnalysisId: {
                location: "uri",
                locationName: "AnalysisId"
              },
              RecoveryWindowInDays: {
                location: "querystring",
                locationName: "recovery-window-in-days",
                type: "long"
              },
              ForceDeleteWithoutRecovery: {
                location: "querystring",
                locationName: "force-delete-without-recovery",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              },
              Arn: {},
              AnalysisId: {},
              DeletionTime: {
                type: "timestamp"
              },
              RequestId: {}
            }
          }
        },
        DeleteDashboard: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/dashboards/{DashboardId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DashboardId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DashboardId: {
                location: "uri",
                locationName: "DashboardId"
              },
              VersionNumber: {
                location: "querystring",
                locationName: "version-number",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              },
              Arn: {},
              DashboardId: {},
              RequestId: {}
            }
          }
        },
        DeleteDataSet: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/data-sets/{DataSetId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSetId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              DataSetId: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DeleteDataSetRefreshProperties: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/data-sets/{DataSetId}/refresh-properties"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSetId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DeleteDataSource: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/data-sources/{DataSourceId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSourceId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSourceId: {
                location: "uri",
                locationName: "DataSourceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              DataSourceId: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DeleteFolder: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/folders/{FolderId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "FolderId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              },
              Arn: {},
              FolderId: {},
              RequestId: {}
            }
          }
        },
        DeleteFolderMembership: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/folders/{FolderId}/members/{MemberType}/{MemberId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "FolderId",
              "MemberId",
              "MemberType"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              },
              MemberId: {
                location: "uri",
                locationName: "MemberId"
              },
              MemberType: {
                location: "uri",
                locationName: "MemberType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        DeleteGroup: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/groups/{GroupName}"
          },
          input: {
            type: "structure",
            required: [
              "GroupName",
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              GroupName: {
                location: "uri",
                locationName: "GroupName"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DeleteGroupMembership: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/groups/{GroupName}/members/{MemberName}"
          },
          input: {
            type: "structure",
            required: [
              "MemberName",
              "GroupName",
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              MemberName: {
                location: "uri",
                locationName: "MemberName"
              },
              GroupName: {
                location: "uri",
                locationName: "GroupName"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DeleteIAMPolicyAssignment: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/namespace/{Namespace}/iam-policy-assignments/{AssignmentName}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "AssignmentName",
              "Namespace"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              AssignmentName: {
                location: "uri",
                locationName: "AssignmentName"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssignmentName: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DeleteIdentityPropagationConfig: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/identity-propagation-config/{Service}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "Service"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Service: {
                location: "uri",
                locationName: "Service"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DeleteNamespace: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DeleteRefreshSchedule: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/data-sets/{DataSetId}/refresh-schedules/{ScheduleId}"
          },
          input: {
            type: "structure",
            required: [
              "DataSetId",
              "AwsAccountId",
              "ScheduleId"
            ],
            members: {
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              ScheduleId: {
                location: "uri",
                locationName: "ScheduleId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {},
              ScheduleId: {},
              Arn: {}
            }
          }
        },
        DeleteRoleCustomPermission: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/roles/{Role}/custom-permission"
          },
          input: {
            type: "structure",
            required: [
              "Role",
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              Role: {
                location: "uri",
                locationName: "Role"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Status: {
                type: "integer"
              }
            }
          }
        },
        DeleteRoleMembership: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/roles/{Role}/members/{MemberName}"
          },
          input: {
            type: "structure",
            required: [
              "MemberName",
              "Role",
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              MemberName: {
                location: "uri",
                locationName: "MemberName"
              },
              Role: {
                location: "uri",
                locationName: "Role"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DeleteTemplate: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/templates/{TemplateId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TemplateId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TemplateId: {
                location: "uri",
                locationName: "TemplateId"
              },
              VersionNumber: {
                location: "querystring",
                locationName: "version-number",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Arn: {},
              TemplateId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DeleteTemplateAlias: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/templates/{TemplateId}/aliases/{AliasName}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TemplateId",
              "AliasName"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TemplateId: {
                location: "uri",
                locationName: "TemplateId"
              },
              AliasName: {
                location: "uri",
                locationName: "AliasName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              },
              TemplateId: {},
              AliasName: {},
              Arn: {},
              RequestId: {}
            }
          }
        },
        DeleteTheme: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/themes/{ThemeId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "ThemeId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              ThemeId: {
                location: "uri",
                locationName: "ThemeId"
              },
              VersionNumber: {
                location: "querystring",
                locationName: "version-number",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              ThemeId: {}
            }
          }
        },
        DeleteThemeAlias: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/themes/{ThemeId}/aliases/{AliasName}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "ThemeId",
              "AliasName"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              ThemeId: {
                location: "uri",
                locationName: "ThemeId"
              },
              AliasName: {
                location: "uri",
                locationName: "AliasName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AliasName: {},
              Arn: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              ThemeId: {}
            }
          }
        },
        DeleteTopic: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/topics/{TopicId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TopicId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TopicId: {
                location: "uri",
                locationName: "TopicId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              TopicId: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DeleteTopicRefreshSchedule: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/topics/{TopicId}/schedules/{DatasetId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TopicId",
              "DatasetId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TopicId: {
                location: "uri",
                locationName: "TopicId"
              },
              DatasetId: {
                location: "uri",
                locationName: "DatasetId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TopicId: {},
              TopicArn: {},
              DatasetArn: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        DeleteUser: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/users/{UserName}"
          },
          input: {
            type: "structure",
            required: [
              "UserName",
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              UserName: {
                location: "uri",
                locationName: "UserName"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DeleteUserByPrincipalId: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/user-principals/{PrincipalId}"
          },
          input: {
            type: "structure",
            required: [
              "PrincipalId",
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              PrincipalId: {
                location: "uri",
                locationName: "PrincipalId"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DeleteVPCConnection: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/vpc-connections/{VPCConnectionId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "VPCConnectionId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              VPCConnectionId: {
                location: "uri",
                locationName: "VPCConnectionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              VPCConnectionId: {},
              DeletionStatus: {},
              AvailabilityStatus: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeAccountCustomization: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/customizations"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              Resolved: {
                location: "querystring",
                locationName: "resolved",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              AwsAccountId: {},
              Namespace: {},
              AccountCustomization: {
                shape: "Sa"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeAccountSettings: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/settings"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccountSettings: {
                type: "structure",
                members: {
                  AccountName: {},
                  Edition: {},
                  DefaultNamespace: {},
                  NotificationEmail: {},
                  PublicSharingEnabled: {
                    type: "boolean"
                  },
                  TerminationProtectionEnabled: {
                    type: "boolean"
                  }
                }
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeAccountSubscription: {
          http: {
            method: "GET",
            requestUri: "/account/{AwsAccountId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccountInfo: {
                type: "structure",
                members: {
                  AccountName: {},
                  Edition: {},
                  NotificationEmail: {},
                  AuthenticationType: {},
                  AccountSubscriptionStatus: {},
                  IAMIdentityCenterInstanceArn: {}
                }
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        DescribeAnalysis: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/analyses/{AnalysisId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "AnalysisId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              AnalysisId: {
                location: "uri",
                locationName: "AnalysisId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Analysis: {
                type: "structure",
                members: {
                  AnalysisId: {},
                  Arn: {},
                  Name: {},
                  Status: {},
                  Errors: {
                    shape: "Sy5"
                  },
                  DataSetArns: {
                    shape: "Sya"
                  },
                  ThemeArn: {},
                  CreatedTime: {
                    type: "timestamp"
                  },
                  LastUpdatedTime: {
                    type: "timestamp"
                  },
                  Sheets: {
                    shape: "Syb"
                  }
                }
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        DescribeAnalysisDefinition: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/analyses/{AnalysisId}/definition"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "AnalysisId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              AnalysisId: {
                location: "uri",
                locationName: "AnalysisId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AnalysisId: {},
              Name: {},
              Errors: {
                shape: "Sy5"
              },
              ResourceStatus: {},
              ThemeArn: {},
              Definition: {
                shape: "S1h"
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        DescribeAnalysisPermissions: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/analyses/{AnalysisId}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "AnalysisId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              AnalysisId: {
                location: "uri",
                locationName: "AnalysisId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AnalysisId: {},
              AnalysisArn: {},
              Permissions: {
                shape: "S19"
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        DescribeAssetBundleExportJob: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/asset-bundle-export-jobs/{AssetBundleExportJobId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "AssetBundleExportJobId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              AssetBundleExportJobId: {
                location: "uri",
                locationName: "AssetBundleExportJobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobStatus: {},
              DownloadUrl: {
                shape: "Syk"
              },
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Type: {},
                    Message: {}
                  }
                }
              },
              Arn: {},
              CreatedTime: {
                type: "timestamp"
              },
              AssetBundleExportJobId: {},
              AwsAccountId: {},
              ResourceArns: {
                shape: "Syn"
              },
              IncludeAllDependencies: {
                type: "boolean"
              },
              ExportFormat: {},
              CloudFormationOverridePropertyConfiguration: {
                shape: "Syp"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              IncludePermissions: {
                type: "boolean"
              },
              IncludeTags: {
                type: "boolean"
              },
              ValidationStrategy: {
                shape: "Szj"
              },
              Warnings: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Message: {}
                  }
                }
              }
            }
          }
        },
        DescribeAssetBundleImportJob: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/asset-bundle-import-jobs/{AssetBundleImportJobId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "AssetBundleImportJobId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              AssetBundleImportJobId: {
                location: "uri",
                locationName: "AssetBundleImportJobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobStatus: {},
              Errors: {
                shape: "Szp"
              },
              RollbackErrors: {
                shape: "Szp"
              },
              Arn: {},
              CreatedTime: {
                type: "timestamp"
              },
              AssetBundleImportJobId: {},
              AwsAccountId: {},
              AssetBundleImportSource: {
                type: "structure",
                members: {
                  Body: {
                    shape: "Syk"
                  },
                  S3Uri: {}
                }
              },
              OverrideParameters: {
                shape: "Szt"
              },
              FailureAction: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              OverridePermissions: {
                shape: "S10c"
              },
              OverrideTags: {
                shape: "S10s"
              },
              OverrideValidationStrategy: {
                shape: "S115"
              }
            }
          }
        },
        DescribeDashboard: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/dashboards/{DashboardId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DashboardId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DashboardId: {
                location: "uri",
                locationName: "DashboardId"
              },
              VersionNumber: {
                location: "querystring",
                locationName: "version-number",
                type: "long"
              },
              AliasName: {
                location: "querystring",
                locationName: "alias-name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Dashboard: {
                type: "structure",
                members: {
                  DashboardId: {},
                  Arn: {},
                  Name: {},
                  Version: {
                    type: "structure",
                    members: {
                      CreatedTime: {
                        type: "timestamp"
                      },
                      Errors: {
                        shape: "S11a"
                      },
                      VersionNumber: {
                        type: "long"
                      },
                      Status: {},
                      Arn: {},
                      SourceEntityArn: {},
                      DataSetArns: {
                        shape: "Sya"
                      },
                      Description: {},
                      ThemeArn: {},
                      Sheets: {
                        shape: "Syb"
                      }
                    }
                  },
                  CreatedTime: {
                    type: "timestamp"
                  },
                  LastPublishedTime: {
                    type: "timestamp"
                  },
                  LastUpdatedTime: {
                    type: "timestamp"
                  },
                  LinkEntities: {
                    shape: "Smw"
                  }
                }
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        DescribeDashboardDefinition: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/dashboards/{DashboardId}/definition"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DashboardId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DashboardId: {
                location: "uri",
                locationName: "DashboardId"
              },
              VersionNumber: {
                location: "querystring",
                locationName: "version-number",
                type: "long"
              },
              AliasName: {
                location: "querystring",
                locationName: "alias-name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DashboardId: {},
              Errors: {
                shape: "S11a"
              },
              Name: {},
              ResourceStatus: {},
              ThemeArn: {},
              Definition: {
                shape: "Smu"
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {},
              DashboardPublishOptions: {
                shape: "Smf"
              }
            }
          }
        },
        DescribeDashboardPermissions: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/dashboards/{DashboardId}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DashboardId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DashboardId: {
                location: "uri",
                locationName: "DashboardId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DashboardId: {},
              DashboardArn: {},
              Permissions: {
                shape: "S19"
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {},
              LinkSharingConfiguration: {
                shape: "Smv"
              }
            }
          }
        },
        DescribeDashboardSnapshotJob: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/dashboards/{DashboardId}/snapshot-jobs/{SnapshotJobId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DashboardId",
              "SnapshotJobId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DashboardId: {
                location: "uri",
                locationName: "DashboardId"
              },
              SnapshotJobId: {
                location: "uri",
                locationName: "SnapshotJobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AwsAccountId: {},
              DashboardId: {},
              SnapshotJobId: {},
              UserConfiguration: {
                type: "structure",
                members: {
                  AnonymousUsers: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        RowLevelPermissionTagKeys: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  }
                }
              },
              SnapshotConfiguration: {
                shape: "S11n"
              },
              Arn: {},
              JobStatus: {},
              CreatedTime: {
                type: "timestamp"
              },
              LastUpdatedTime: {
                type: "timestamp"
              },
              RequestId: {},
              Status: {
                type: "integer"
              }
            }
          }
        },
        DescribeDashboardSnapshotJobResult: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/dashboards/{DashboardId}/snapshot-jobs/{SnapshotJobId}/result"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DashboardId",
              "SnapshotJobId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DashboardId: {
                location: "uri",
                locationName: "DashboardId"
              },
              SnapshotJobId: {
                location: "uri",
                locationName: "SnapshotJobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              JobStatus: {},
              CreatedTime: {
                type: "timestamp"
              },
              LastUpdatedTime: {
                type: "timestamp"
              },
              Result: {
                type: "structure",
                members: {
                  AnonymousUsers: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        FileGroups: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              Files: {
                                shape: "S11q"
                              },
                              S3Results: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    S3DestinationConfiguration: {
                                      shape: "S11z"
                                    },
                                    S3Uri: {
                                      shape: "Syk"
                                    },
                                    ErrorInfo: {
                                      type: "list",
                                      member: {
                                        type: "structure",
                                        members: {
                                          ErrorMessage: {},
                                          ErrorType: {}
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              ErrorInfo: {
                type: "structure",
                members: {
                  ErrorMessage: {},
                  ErrorType: {}
                }
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeDataSet: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/data-sets/{DataSetId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSetId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataSet: {
                type: "structure",
                members: {
                  Arn: {},
                  DataSetId: {},
                  Name: {},
                  CreatedTime: {
                    type: "timestamp"
                  },
                  LastUpdatedTime: {
                    type: "timestamp"
                  },
                  PhysicalTableMap: {
                    shape: "Sn2"
                  },
                  LogicalTableMap: {
                    shape: "Snm"
                  },
                  OutputColumns: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {},
                        Description: {},
                        Type: {},
                        SubType: {}
                      }
                    }
                  },
                  ImportMode: {},
                  ConsumedSpiceCapacityInBytes: {
                    type: "long"
                  },
                  ColumnGroups: {
                    shape: "Sot"
                  },
                  FieldFolders: {
                    shape: "Soz"
                  },
                  RowLevelPermissionDataSet: {
                    shape: "Sp4"
                  },
                  RowLevelPermissionTagConfiguration: {
                    shape: "Sp8"
                  },
                  ColumnLevelPermissionRules: {
                    shape: "Spg"
                  },
                  DataSetUsageConfiguration: {
                    shape: "Spk"
                  },
                  DatasetParameters: {
                    shape: "Spl"
                  }
                }
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeDataSetPermissions: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/data-sets/{DataSetId}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSetId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataSetArn: {},
              DataSetId: {},
              Permissions: {
                shape: "S19"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeDataSetRefreshProperties: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/data-sets/{DataSetId}/refresh-properties"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSetId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              DataSetRefreshProperties: {
                shape: "S12n"
              }
            }
          }
        },
        DescribeDataSource: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/data-sources/{DataSourceId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSourceId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSourceId: {
                location: "uri",
                locationName: "DataSourceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataSource: {
                shape: "S12v"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeDataSourcePermissions: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/data-sources/{DataSourceId}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSourceId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSourceId: {
                location: "uri",
                locationName: "DataSourceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataSourceArn: {},
              DataSourceId: {},
              Permissions: {
                shape: "S19"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeFolder: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/folders/{FolderId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "FolderId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              },
              Folder: {
                type: "structure",
                members: {
                  FolderId: {},
                  Arn: {},
                  Name: {},
                  FolderType: {},
                  FolderPath: {
                    type: "list",
                    member: {}
                  },
                  CreatedTime: {
                    type: "timestamp"
                  },
                  LastUpdatedTime: {
                    type: "timestamp"
                  },
                  SharingModel: {}
                }
              },
              RequestId: {}
            }
          }
        },
        DescribeFolderPermissions: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/folders/{FolderId}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "FolderId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              },
              Namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              },
              FolderId: {},
              Arn: {},
              Permissions: {
                shape: "S19"
              },
              RequestId: {},
              NextToken: {}
            }
          }
        },
        DescribeFolderResolvedPermissions: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/folders/{FolderId}/resolved-permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "FolderId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              },
              Namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              },
              FolderId: {},
              Arn: {},
              Permissions: {
                shape: "S19"
              },
              RequestId: {},
              NextToken: {}
            }
          }
        },
        DescribeGroup: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/groups/{GroupName}"
          },
          input: {
            type: "structure",
            required: [
              "GroupName",
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              GroupName: {
                location: "uri",
                locationName: "GroupName"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Group: {
                shape: "Ss5"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeGroupMembership: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/groups/{GroupName}/members/{MemberName}"
          },
          input: {
            type: "structure",
            required: [
              "MemberName",
              "GroupName",
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              MemberName: {
                location: "uri",
                locationName: "MemberName"
              },
              GroupName: {
                location: "uri",
                locationName: "GroupName"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GroupMember: {
                shape: "Ss9"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeIAMPolicyAssignment: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/iam-policy-assignments/{AssignmentName}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "AssignmentName",
              "Namespace"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              AssignmentName: {
                location: "uri",
                locationName: "AssignmentName"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IAMPolicyAssignment: {
                type: "structure",
                members: {
                  AwsAccountId: {},
                  AssignmentId: {},
                  AssignmentName: {},
                  PolicyArn: {},
                  Identities: {
                    shape: "Ssd"
                  },
                  AssignmentStatus: {}
                }
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeIngestion: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/data-sets/{DataSetId}/ingestions/{IngestionId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSetId",
              "IngestionId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              IngestionId: {
                location: "uri",
                locationName: "IngestionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Ingestion: {
                shape: "S13i"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeIpRestriction: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/ip-restriction"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AwsAccountId: {},
              IpRestrictionRuleMap: {
                shape: "S13r"
              },
              Enabled: {
                type: "boolean"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeNamespace: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Namespace: {
                shape: "S13w"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeRefreshSchedule: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/data-sets/{DataSetId}/refresh-schedules/{ScheduleId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSetId",
              "ScheduleId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              ScheduleId: {
                location: "uri",
                locationName: "ScheduleId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RefreshSchedule: {
                shape: "Ssq"
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {},
              Arn: {}
            }
          }
        },
        DescribeRoleCustomPermission: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/roles/{Role}/custom-permission"
          },
          input: {
            type: "structure",
            required: [
              "Role",
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              Role: {
                location: "uri",
                locationName: "Role"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CustomPermissionsName: {},
              RequestId: {},
              Status: {
                type: "integer"
              }
            }
          }
        },
        DescribeTemplate: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/templates/{TemplateId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TemplateId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TemplateId: {
                location: "uri",
                locationName: "TemplateId"
              },
              VersionNumber: {
                location: "querystring",
                locationName: "version-number",
                type: "long"
              },
              AliasName: {
                location: "querystring",
                locationName: "alias-name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Template: {
                type: "structure",
                members: {
                  Arn: {},
                  Name: {},
                  Version: {
                    type: "structure",
                    members: {
                      CreatedTime: {
                        type: "timestamp"
                      },
                      Errors: {
                        shape: "S148"
                      },
                      VersionNumber: {
                        type: "long"
                      },
                      Status: {},
                      DataSetConfigurations: {
                        shape: "St6"
                      },
                      Description: {},
                      SourceEntityArn: {},
                      ThemeArn: {},
                      Sheets: {
                        shape: "Syb"
                      }
                    }
                  },
                  TemplateId: {},
                  LastUpdatedTime: {
                    type: "timestamp"
                  },
                  CreatedTime: {
                    type: "timestamp"
                  }
                }
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        DescribeTemplateAlias: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/templates/{TemplateId}/aliases/{AliasName}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TemplateId",
              "AliasName"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TemplateId: {
                location: "uri",
                locationName: "TemplateId"
              },
              AliasName: {
                location: "uri",
                locationName: "AliasName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplateAlias: {
                shape: "Stk"
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        DescribeTemplateDefinition: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/templates/{TemplateId}/definition"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TemplateId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TemplateId: {
                location: "uri",
                locationName: "TemplateId"
              },
              VersionNumber: {
                location: "querystring",
                locationName: "version-number",
                type: "long"
              },
              AliasName: {
                location: "querystring",
                locationName: "alias-name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              TemplateId: {},
              Errors: {
                shape: "S148"
              },
              ResourceStatus: {},
              ThemeArn: {},
              Definition: {
                shape: "St5"
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        DescribeTemplatePermissions: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/templates/{TemplateId}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TemplateId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TemplateId: {
                location: "uri",
                locationName: "TemplateId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplateId: {},
              TemplateArn: {},
              Permissions: {
                shape: "S19"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeTheme: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/themes/{ThemeId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "ThemeId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              ThemeId: {
                location: "uri",
                locationName: "ThemeId"
              },
              VersionNumber: {
                location: "querystring",
                locationName: "version-number",
                type: "long"
              },
              AliasName: {
                location: "querystring",
                locationName: "alias-name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Theme: {
                type: "structure",
                members: {
                  Arn: {},
                  Name: {},
                  ThemeId: {},
                  Version: {
                    type: "structure",
                    members: {
                      VersionNumber: {
                        type: "long"
                      },
                      Arn: {},
                      Description: {},
                      BaseThemeId: {},
                      CreatedTime: {
                        type: "timestamp"
                      },
                      Configuration: {
                        shape: "Stn"
                      },
                      Errors: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            Type: {},
                            Message: {}
                          }
                        }
                      },
                      Status: {}
                    }
                  },
                  CreatedTime: {
                    type: "timestamp"
                  },
                  LastUpdatedTime: {
                    type: "timestamp"
                  },
                  Type: {}
                }
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        DescribeThemeAlias: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/themes/{ThemeId}/aliases/{AliasName}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "ThemeId",
              "AliasName"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              ThemeId: {
                location: "uri",
                locationName: "ThemeId"
              },
              AliasName: {
                location: "uri",
                locationName: "AliasName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ThemeAlias: {
                shape: "Su3"
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        DescribeThemePermissions: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/themes/{ThemeId}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "ThemeId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              ThemeId: {
                location: "uri",
                locationName: "ThemeId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ThemeId: {},
              ThemeArn: {},
              Permissions: {
                shape: "S19"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeTopic: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/topics/{TopicId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TopicId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TopicId: {
                location: "uri",
                locationName: "TopicId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              TopicId: {},
              Topic: {
                shape: "Su6"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeTopicPermissions: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/topics/{TopicId}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TopicId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TopicId: {
                location: "uri",
                locationName: "TopicId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TopicId: {},
              TopicArn: {},
              Permissions: {
                shape: "S19"
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        DescribeTopicRefresh: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/topics/{TopicId}/refresh/{RefreshId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TopicId",
              "RefreshId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TopicId: {
                location: "uri",
                locationName: "TopicId"
              },
              RefreshId: {
                location: "uri",
                locationName: "RefreshId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RefreshDetails: {
                type: "structure",
                members: {
                  RefreshArn: {},
                  RefreshId: {},
                  RefreshStatus: {}
                }
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeTopicRefreshSchedule: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/topics/{TopicId}/schedules/{DatasetId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TopicId",
              "DatasetId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TopicId: {
                location: "uri",
                locationName: "TopicId"
              },
              DatasetId: {
                location: "uri",
                locationName: "DatasetId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TopicId: {},
              TopicArn: {},
              DatasetArn: {},
              RefreshSchedule: {
                shape: "Svv"
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        DescribeUser: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/users/{UserName}"
          },
          input: {
            type: "structure",
            required: [
              "UserName",
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              UserName: {
                location: "uri",
                locationName: "UserName"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                shape: "S156"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeVPCConnection: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/vpc-connections/{VPCConnectionId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "VPCConnectionId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              VPCConnectionId: {
                location: "uri",
                locationName: "VPCConnectionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VPCConnection: {
                type: "structure",
                members: {
                  VPCConnectionId: {},
                  Arn: {},
                  Name: {},
                  VPCId: {},
                  SecurityGroupIds: {
                    shape: "Sw2"
                  },
                  DnsResolvers: {
                    shape: "Suo"
                  },
                  Status: {},
                  AvailabilityStatus: {},
                  NetworkInterfaces: {
                    shape: "S15c"
                  },
                  RoleArn: {},
                  CreatedTime: {
                    type: "timestamp"
                  },
                  LastUpdatedTime: {
                    type: "timestamp"
                  }
                }
              },
              RequestId: {},
              Status: {
                type: "integer"
              }
            }
          }
        },
        GenerateEmbedUrlForAnonymousUser: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/embed-url/anonymous-user"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "Namespace",
              "AuthorizedResourceArns",
              "ExperienceConfiguration"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              SessionLifetimeInMinutes: {
                type: "long"
              },
              Namespace: {},
              SessionTags: {
                shape: "S15i"
              },
              AuthorizedResourceArns: {
                type: "list",
                member: {}
              },
              ExperienceConfiguration: {
                type: "structure",
                members: {
                  Dashboard: {
                    type: "structure",
                    required: [
                      "InitialDashboardId"
                    ],
                    members: {
                      InitialDashboardId: {}
                    }
                  },
                  DashboardVisual: {
                    type: "structure",
                    required: [
                      "InitialDashboardVisualId"
                    ],
                    members: {
                      InitialDashboardVisualId: {
                        shape: "S15o"
                      }
                    }
                  },
                  QSearchBar: {
                    type: "structure",
                    required: [
                      "InitialTopicId"
                    ],
                    members: {
                      InitialTopicId: {}
                    }
                  }
                }
              },
              AllowedDomains: {
                shape: "Suo"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EmbedUrl",
              "Status",
              "RequestId",
              "AnonymousUserArn"
            ],
            members: {
              EmbedUrl: {
                shape: "S15r"
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {},
              AnonymousUserArn: {}
            }
          }
        },
        GenerateEmbedUrlForRegisteredUser: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/embed-url/registered-user"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "UserArn",
              "ExperienceConfiguration"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              SessionLifetimeInMinutes: {
                type: "long"
              },
              UserArn: {},
              ExperienceConfiguration: {
                type: "structure",
                members: {
                  Dashboard: {
                    type: "structure",
                    required: [
                      "InitialDashboardId"
                    ],
                    members: {
                      InitialDashboardId: {},
                      FeatureConfigurations: {
                        type: "structure",
                        members: {
                          StatePersistence: {
                            shape: "S15w"
                          },
                          Bookmarks: {
                            type: "structure",
                            required: [
                              "Enabled"
                            ],
                            members: {
                              Enabled: {
                                type: "boolean"
                              }
                            }
                          }
                        }
                      }
                    }
                  },
                  QuickSightConsole: {
                    type: "structure",
                    members: {
                      InitialPath: {},
                      FeatureConfigurations: {
                        type: "structure",
                        members: {
                          StatePersistence: {
                            shape: "S15w"
                          }
                        }
                      }
                    }
                  },
                  QSearchBar: {
                    type: "structure",
                    members: {
                      InitialTopicId: {}
                    }
                  },
                  DashboardVisual: {
                    type: "structure",
                    required: [
                      "InitialDashboardVisualId"
                    ],
                    members: {
                      InitialDashboardVisualId: {
                        shape: "S15o"
                      }
                    }
                  }
                }
              },
              AllowedDomains: {
                shape: "Suo"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EmbedUrl",
              "Status",
              "RequestId"
            ],
            members: {
              EmbedUrl: {
                shape: "S15r"
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        GetDashboardEmbedUrl: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/dashboards/{DashboardId}/embed-url"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DashboardId",
              "IdentityType"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DashboardId: {
                location: "uri",
                locationName: "DashboardId"
              },
              IdentityType: {
                location: "querystring",
                locationName: "creds-type"
              },
              SessionLifetimeInMinutes: {
                location: "querystring",
                locationName: "session-lifetime",
                type: "long"
              },
              UndoRedoDisabled: {
                location: "querystring",
                locationName: "undo-redo-disabled",
                type: "boolean"
              },
              ResetDisabled: {
                location: "querystring",
                locationName: "reset-disabled",
                type: "boolean"
              },
              StatePersistenceEnabled: {
                location: "querystring",
                locationName: "state-persistence-enabled",
                type: "boolean"
              },
              UserArn: {
                location: "querystring",
                locationName: "user-arn"
              },
              Namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              AdditionalDashboardIds: {
                location: "querystring",
                locationName: "additional-dashboard-ids",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EmbedUrl: {
                shape: "S15r"
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        GetSessionEmbedUrl: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/session-embed-url"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              EntryPoint: {
                location: "querystring",
                locationName: "entry-point"
              },
              SessionLifetimeInMinutes: {
                location: "querystring",
                locationName: "session-lifetime",
                type: "long"
              },
              UserArn: {
                location: "querystring",
                locationName: "user-arn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EmbedUrl: {
                shape: "S15r"
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        ListAnalyses: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/analyses"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AnalysisSummaryList: {
                shape: "S16d"
              },
              NextToken: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        ListAssetBundleExportJobs: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/asset-bundle-export-jobs"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssetBundleExportJobSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    JobStatus: {},
                    Arn: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    AssetBundleExportJobId: {},
                    IncludeAllDependencies: {
                      type: "boolean"
                    },
                    ExportFormat: {},
                    IncludePermissions: {
                      type: "boolean"
                    },
                    IncludeTags: {
                      type: "boolean"
                    }
                  }
                }
              },
              NextToken: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        ListAssetBundleImportJobs: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/asset-bundle-import-jobs"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssetBundleImportJobSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    JobStatus: {},
                    Arn: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    AssetBundleImportJobId: {},
                    FailureAction: {}
                  }
                }
              },
              NextToken: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        ListDashboardVersions: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/dashboards/{DashboardId}/versions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DashboardId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DashboardId: {
                location: "uri",
                locationName: "DashboardId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DashboardVersionSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    VersionNumber: {
                      type: "long"
                    },
                    Status: {},
                    SourceEntityArn: {},
                    Description: {}
                  }
                }
              },
              NextToken: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        ListDashboards: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/dashboards"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DashboardSummaryList: {
                shape: "S16t"
              },
              NextToken: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        ListDataSets: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/data-sets"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataSetSummaries: {
                shape: "S16x"
              },
              NextToken: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        ListDataSources: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/data-sources"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataSources: {
                type: "list",
                member: {
                  shape: "S12v"
                }
              },
              NextToken: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        ListFolderMembers: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/folders/{FolderId}/members"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "FolderId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              },
              FolderMemberList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MemberId: {},
                    MemberArn: {}
                  }
                }
              },
              NextToken: {},
              RequestId: {}
            }
          }
        },
        ListFolders: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/folders"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              },
              FolderSummaryList: {
                shape: "S178"
              },
              NextToken: {},
              RequestId: {}
            }
          }
        },
        ListGroupMemberships: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/groups/{GroupName}/members"
          },
          input: {
            type: "structure",
            required: [
              "GroupName",
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              GroupName: {
                location: "uri",
                locationName: "GroupName"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GroupMemberList: {
                type: "list",
                member: {
                  shape: "Ss9"
                }
              },
              NextToken: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        ListGroups: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/groups"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GroupList: {
                shape: "S17f"
              },
              NextToken: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        ListIAMPolicyAssignments: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/v2/iam-policy-assignments"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              AssignmentStatus: {
                location: "querystring",
                locationName: "assignment-status"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IAMPolicyAssignments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AssignmentName: {},
                    AssignmentStatus: {}
                  }
                }
              },
              NextToken: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        ListIAMPolicyAssignmentsForUser: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/users/{UserName}/iam-policy-assignments"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "UserName",
              "Namespace"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              UserName: {
                location: "uri",
                locationName: "UserName"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ActiveAssignments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AssignmentName: {},
                    PolicyArn: {}
                  }
                }
              },
              RequestId: {},
              NextToken: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        ListIdentityPropagationConfigs: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/identity-propagation-config"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Services: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Service: {},
                    AuthorizedTargets: {
                      shape: "S17t"
                    }
                  }
                }
              },
              NextToken: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        ListIngestions: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/data-sets/{DataSetId}/ingestions"
          },
          input: {
            type: "structure",
            required: [
              "DataSetId",
              "AwsAccountId"
            ],
            members: {
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Ingestions: {
                type: "list",
                member: {
                  shape: "S13i"
                }
              },
              NextToken: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        ListNamespaces: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/namespaces"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Namespaces: {
                type: "list",
                member: {
                  shape: "S13w"
                }
              },
              NextToken: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        ListRefreshSchedules: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/data-sets/{DataSetId}/refresh-schedules"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSetId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RefreshSchedules: {
                type: "list",
                member: {
                  shape: "Ssq"
                }
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        ListRoleMemberships: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/roles/{Role}/members"
          },
          input: {
            type: "structure",
            required: [
              "Role",
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              Role: {
                location: "uri",
                locationName: "Role"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MembersList: {
                shape: "Sk"
              },
              NextToken: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/resources/{ResourceArn}/tags"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sb"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        ListTemplateAliases: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/templates/{TemplateId}/aliases"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TemplateId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TemplateId: {
                location: "uri",
                locationName: "TemplateId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-result",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplateAliasList: {
                type: "list",
                member: {
                  shape: "Stk"
                }
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {},
              NextToken: {}
            }
          }
        },
        ListTemplateVersions: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/templates/{TemplateId}/versions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TemplateId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TemplateId: {
                location: "uri",
                locationName: "TemplateId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplateVersionSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    VersionNumber: {
                      type: "long"
                    },
                    CreatedTime: {
                      type: "timestamp"
                    },
                    Status: {},
                    Description: {}
                  }
                }
              },
              NextToken: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        ListTemplates: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/templates"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-result",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplateSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    TemplateId: {},
                    Name: {},
                    LatestVersionNumber: {
                      type: "long"
                    },
                    CreatedTime: {
                      type: "timestamp"
                    },
                    LastUpdatedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        ListThemeAliases: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/themes/{ThemeId}/aliases"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "ThemeId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              ThemeId: {
                location: "uri",
                locationName: "ThemeId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-result",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ThemeAliasList: {
                type: "list",
                member: {
                  shape: "Su3"
                }
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {},
              NextToken: {}
            }
          }
        },
        ListThemeVersions: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/themes/{ThemeId}/versions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "ThemeId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              ThemeId: {
                location: "uri",
                locationName: "ThemeId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ThemeVersionSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    VersionNumber: {
                      type: "long"
                    },
                    Arn: {},
                    Description: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    Status: {}
                  }
                }
              },
              NextToken: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        ListThemes: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/themes"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              Type: {
                location: "querystring",
                locationName: "type"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ThemeSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Name: {},
                    ThemeId: {},
                    LatestVersionNumber: {
                      type: "long"
                    },
                    CreatedTime: {
                      type: "timestamp"
                    },
                    LastUpdatedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        ListTopicRefreshSchedules: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/topics/{TopicId}/schedules"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TopicId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TopicId: {
                location: "uri",
                locationName: "TopicId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TopicId: {},
              TopicArn: {},
              RefreshSchedules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DatasetId: {},
                    DatasetArn: {},
                    DatasetName: {},
                    RefreshSchedule: {
                      shape: "Svv"
                    }
                  }
                }
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        ListTopics: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/topics"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TopicsSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    TopicId: {},
                    Name: {}
                  }
                }
              },
              NextToken: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        ListUserGroups: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/users/{UserName}/groups"
          },
          input: {
            type: "structure",
            required: [
              "UserName",
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              UserName: {
                location: "uri",
                locationName: "UserName"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GroupList: {
                shape: "S17f"
              },
              NextToken: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        ListUsers: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/users"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserList: {
                type: "list",
                member: {
                  shape: "S156"
                }
              },
              NextToken: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        ListVPCConnections: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/vpc-connections"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VPCConnectionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    VPCConnectionId: {},
                    Arn: {},
                    Name: {},
                    VPCId: {},
                    SecurityGroupIds: {
                      shape: "Sw2"
                    },
                    DnsResolvers: {
                      shape: "Suo"
                    },
                    Status: {},
                    AvailabilityStatus: {},
                    NetworkInterfaces: {
                      shape: "S15c"
                    },
                    RoleArn: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    LastUpdatedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        PutDataSetRefreshProperties: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/data-sets/{DataSetId}/refresh-properties"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSetId",
              "DataSetRefreshProperties"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              DataSetRefreshProperties: {
                shape: "S12n"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        RegisterUser: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/users"
          },
          input: {
            type: "structure",
            required: [
              "IdentityType",
              "Email",
              "UserRole",
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              IdentityType: {},
              Email: {},
              UserRole: {},
              IamArn: {},
              SessionName: {},
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              },
              UserName: {},
              CustomPermissionsName: {},
              ExternalLoginFederationProviderType: {},
              CustomFederationProviderUrl: {},
              ExternalLoginId: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                shape: "S156"
              },
              UserInvitationUrl: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        RestoreAnalysis: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/restore/analyses/{AnalysisId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "AnalysisId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              AnalysisId: {
                location: "uri",
                locationName: "AnalysisId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              },
              Arn: {},
              AnalysisId: {},
              RequestId: {}
            }
          }
        },
        SearchAnalyses: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/search/analyses"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "Filters"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Operator: {},
                    Name: {},
                    Value: {}
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AnalysisSummaryList: {
                shape: "S16d"
              },
              NextToken: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        SearchDashboards: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/search/dashboards"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "Filters"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Operator"
                  ],
                  members: {
                    Operator: {},
                    Name: {},
                    Value: {}
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DashboardSummaryList: {
                shape: "S16t"
              },
              NextToken: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        SearchDataSets: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/search/data-sets"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "Filters"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Operator",
                    "Name",
                    "Value"
                  ],
                  members: {
                    Operator: {},
                    Name: {},
                    Value: {}
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataSetSummaries: {
                shape: "S16x"
              },
              NextToken: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        SearchDataSources: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/search/data-sources"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "Filters"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Operator",
                    "Name",
                    "Value"
                  ],
                  members: {
                    Operator: {},
                    Name: {},
                    Value: {}
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataSourceSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    DataSourceId: {},
                    Name: {},
                    Type: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    LastUpdatedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        SearchFolders: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/search/folders"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "Filters"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Operator: {},
                    Name: {},
                    Value: {}
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              },
              FolderSummaryList: {
                shape: "S178"
              },
              NextToken: {},
              RequestId: {}
            }
          }
        },
        SearchGroups: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/groups-search"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "Namespace",
              "Filters"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Operator",
                    "Name",
                    "Value"
                  ],
                  members: {
                    Operator: {},
                    Name: {},
                    Value: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GroupList: {
                shape: "S17f"
              },
              NextToken: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        StartAssetBundleExportJob: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/asset-bundle-export-jobs/export"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "AssetBundleExportJobId",
              "ResourceArns",
              "ExportFormat"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              AssetBundleExportJobId: {},
              ResourceArns: {
                shape: "Syn"
              },
              IncludeAllDependencies: {
                type: "boolean"
              },
              ExportFormat: {},
              CloudFormationOverridePropertyConfiguration: {
                shape: "Syp"
              },
              IncludePermissions: {
                type: "boolean"
              },
              IncludeTags: {
                type: "boolean"
              },
              ValidationStrategy: {
                shape: "Szj"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              AssetBundleExportJobId: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        StartAssetBundleImportJob: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/asset-bundle-import-jobs/import"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "AssetBundleImportJobId",
              "AssetBundleImportSource"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              AssetBundleImportJobId: {},
              AssetBundleImportSource: {
                type: "structure",
                members: {
                  Body: {
                    type: "blob",
                    sensitive: true
                  },
                  S3Uri: {}
                }
              },
              OverrideParameters: {
                shape: "Szt"
              },
              FailureAction: {},
              OverridePermissions: {
                shape: "S10c"
              },
              OverrideTags: {
                shape: "S10s"
              },
              OverrideValidationStrategy: {
                shape: "S115"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              AssetBundleImportJobId: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        StartDashboardSnapshotJob: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/dashboards/{DashboardId}/snapshot-jobs"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DashboardId",
              "SnapshotJobId",
              "UserConfiguration",
              "SnapshotConfiguration"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DashboardId: {
                location: "uri",
                locationName: "DashboardId"
              },
              SnapshotJobId: {},
              UserConfiguration: {
                type: "structure",
                members: {
                  AnonymousUsers: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        RowLevelPermissionTags: {
                          shape: "S15i"
                        }
                      }
                    }
                  }
                }
              },
              SnapshotConfiguration: {
                shape: "S11n"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              SnapshotJobId: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/resources/{ResourceArn}/tags"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/resources/{ResourceArn}/tags"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "keys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UpdateAccountCustomization: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/customizations"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "AccountCustomization"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              AccountCustomization: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              AwsAccountId: {},
              Namespace: {},
              AccountCustomization: {
                shape: "Sa"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UpdateAccountSettings: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/settings"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DefaultNamespace"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DefaultNamespace: {},
              NotificationEmail: {},
              TerminationProtectionEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UpdateAnalysis: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/analyses/{AnalysisId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "AnalysisId",
              "Name"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              AnalysisId: {
                location: "uri",
                locationName: "AnalysisId"
              },
              Name: {},
              Parameters: {
                shape: "Sr"
              },
              SourceEntity: {
                shape: "S1d"
              },
              ThemeArn: {},
              Definition: {
                shape: "S1h"
              },
              ValidationStrategy: {
                shape: "Sm5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              AnalysisId: {},
              UpdateStatus: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        UpdateAnalysisPermissions: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/analyses/{AnalysisId}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "AnalysisId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              AnalysisId: {
                location: "uri",
                locationName: "AnalysisId"
              },
              GrantPermissions: {
                shape: "S1b3"
              },
              RevokePermissions: {
                shape: "S1b3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AnalysisArn: {},
              AnalysisId: {},
              Permissions: {
                shape: "S19"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UpdateDashboard: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/dashboards/{DashboardId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DashboardId",
              "Name"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DashboardId: {
                location: "uri",
                locationName: "DashboardId"
              },
              Name: {},
              SourceEntity: {
                shape: "Smc"
              },
              Parameters: {
                shape: "Sr"
              },
              VersionDescription: {},
              DashboardPublishOptions: {
                shape: "Smf"
              },
              ThemeArn: {},
              Definition: {
                shape: "Smu"
              },
              ValidationStrategy: {
                shape: "Sm5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              VersionArn: {},
              DashboardId: {},
              CreationStatus: {},
              Status: {
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        UpdateDashboardLinks: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/dashboards/{DashboardId}/linked-entities"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DashboardId",
              "LinkEntities"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DashboardId: {
                location: "uri",
                locationName: "DashboardId"
              },
              LinkEntities: {
                shape: "Smw"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              DashboardArn: {},
              LinkEntities: {
                shape: "Smw"
              }
            }
          }
        },
        UpdateDashboardPermissions: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/dashboards/{DashboardId}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DashboardId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DashboardId: {
                location: "uri",
                locationName: "DashboardId"
              },
              GrantPermissions: {
                shape: "S1b3"
              },
              RevokePermissions: {
                shape: "S1b3"
              },
              GrantLinkPermissions: {
                shape: "S1ba"
              },
              RevokeLinkPermissions: {
                shape: "S1ba"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DashboardArn: {},
              DashboardId: {},
              Permissions: {
                shape: "S19"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              LinkSharingConfiguration: {
                shape: "Smv"
              }
            }
          }
        },
        UpdateDashboardPublishedVersion: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/dashboards/{DashboardId}/versions/{VersionNumber}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DashboardId",
              "VersionNumber"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DashboardId: {
                location: "uri",
                locationName: "DashboardId"
              },
              VersionNumber: {
                location: "uri",
                locationName: "VersionNumber",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DashboardId: {},
              DashboardArn: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        UpdateDataSet: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/data-sets/{DataSetId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSetId",
              "Name",
              "PhysicalTableMap",
              "ImportMode"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              Name: {},
              PhysicalTableMap: {
                shape: "Sn2"
              },
              LogicalTableMap: {
                shape: "Snm"
              },
              ImportMode: {},
              ColumnGroups: {
                shape: "Sot"
              },
              FieldFolders: {
                shape: "Soz"
              },
              RowLevelPermissionDataSet: {
                shape: "Sp4"
              },
              RowLevelPermissionTagConfiguration: {
                shape: "Sp8"
              },
              ColumnLevelPermissionRules: {
                shape: "Spg"
              },
              DataSetUsageConfiguration: {
                shape: "Spk"
              },
              DatasetParameters: {
                shape: "Spl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              DataSetId: {},
              IngestionArn: {},
              IngestionId: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UpdateDataSetPermissions: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/data-sets/{DataSetId}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSetId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              GrantPermissions: {
                shape: "S19"
              },
              RevokePermissions: {
                shape: "S19"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataSetArn: {},
              DataSetId: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UpdateDataSource: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/data-sources/{DataSourceId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSourceId",
              "Name"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSourceId: {
                location: "uri",
                locationName: "DataSourceId"
              },
              Name: {},
              DataSourceParameters: {
                shape: "Sq0"
              },
              Credentials: {
                shape: "Srh"
              },
              VpcConnectionProperties: {
                shape: "Sro"
              },
              SslProperties: {
                shape: "Srp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              DataSourceId: {},
              UpdateStatus: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UpdateDataSourcePermissions: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/data-sources/{DataSourceId}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSourceId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSourceId: {
                location: "uri",
                locationName: "DataSourceId"
              },
              GrantPermissions: {
                shape: "S19"
              },
              RevokePermissions: {
                shape: "S19"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataSourceArn: {},
              DataSourceId: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UpdateFolder: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/folders/{FolderId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "FolderId",
              "Name"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              },
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              },
              Arn: {},
              FolderId: {},
              RequestId: {}
            }
          }
        },
        UpdateFolderPermissions: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/folders/{FolderId}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "FolderId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              },
              GrantPermissions: {
                shape: "S19"
              },
              RevokePermissions: {
                shape: "S19"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                type: "integer"
              },
              Arn: {},
              FolderId: {},
              Permissions: {
                shape: "S19"
              },
              RequestId: {}
            }
          }
        },
        UpdateGroup: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/groups/{GroupName}"
          },
          input: {
            type: "structure",
            required: [
              "GroupName",
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              GroupName: {
                location: "uri",
                locationName: "GroupName"
              },
              Description: {},
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Group: {
                shape: "Ss5"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UpdateIAMPolicyAssignment: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/iam-policy-assignments/{AssignmentName}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "AssignmentName",
              "Namespace"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              AssignmentName: {
                location: "uri",
                locationName: "AssignmentName"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              },
              AssignmentStatus: {},
              PolicyArn: {},
              Identities: {
                shape: "Ssd"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssignmentName: {},
              AssignmentId: {},
              PolicyArn: {},
              Identities: {
                shape: "Ssd"
              },
              AssignmentStatus: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UpdateIdentityPropagationConfig: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/identity-propagation-config/{Service}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "Service"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Service: {
                location: "uri",
                locationName: "Service"
              },
              AuthorizedTargets: {
                shape: "S17t"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UpdateIpRestriction: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/ip-restriction"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              IpRestrictionRuleMap: {
                shape: "S13r"
              },
              Enabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AwsAccountId: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UpdatePublicSharingSettings: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/public-sharing-settings"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              PublicSharingEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UpdateRefreshSchedule: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/data-sets/{DataSetId}/refresh-schedules"
          },
          input: {
            type: "structure",
            required: [
              "DataSetId",
              "AwsAccountId",
              "Schedule"
            ],
            members: {
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Schedule: {
                shape: "Ssq"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {},
              ScheduleId: {},
              Arn: {}
            }
          }
        },
        UpdateRoleCustomPermission: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/roles/{Role}/custom-permission"
          },
          input: {
            type: "structure",
            required: [
              "CustomPermissionsName",
              "Role",
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              CustomPermissionsName: {},
              Role: {
                location: "uri",
                locationName: "Role"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Status: {
                type: "integer"
              }
            }
          }
        },
        UpdateTemplate: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/templates/{TemplateId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TemplateId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TemplateId: {
                location: "uri",
                locationName: "TemplateId"
              },
              SourceEntity: {
                shape: "St2"
              },
              VersionDescription: {},
              Name: {},
              Definition: {
                shape: "St5"
              },
              ValidationStrategy: {
                shape: "Sm5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplateId: {},
              Arn: {},
              VersionArn: {},
              CreationStatus: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        UpdateTemplateAlias: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/templates/{TemplateId}/aliases/{AliasName}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TemplateId",
              "AliasName",
              "TemplateVersionNumber"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TemplateId: {
                location: "uri",
                locationName: "TemplateId"
              },
              AliasName: {
                location: "uri",
                locationName: "AliasName"
              },
              TemplateVersionNumber: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplateAlias: {
                shape: "Stk"
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        UpdateTemplatePermissions: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/templates/{TemplateId}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TemplateId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TemplateId: {
                location: "uri",
                locationName: "TemplateId"
              },
              GrantPermissions: {
                shape: "S1b3"
              },
              RevokePermissions: {
                shape: "S1b3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplateId: {},
              TemplateArn: {},
              Permissions: {
                shape: "S19"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UpdateTheme: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/themes/{ThemeId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "ThemeId",
              "BaseThemeId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              ThemeId: {
                location: "uri",
                locationName: "ThemeId"
              },
              Name: {},
              BaseThemeId: {},
              VersionDescription: {},
              Configuration: {
                shape: "Stn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ThemeId: {},
              Arn: {},
              VersionArn: {},
              CreationStatus: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        UpdateThemeAlias: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/themes/{ThemeId}/aliases/{AliasName}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "ThemeId",
              "AliasName",
              "ThemeVersionNumber"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              ThemeId: {
                location: "uri",
                locationName: "ThemeId"
              },
              AliasName: {
                location: "uri",
                locationName: "AliasName"
              },
              ThemeVersionNumber: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ThemeAlias: {
                shape: "Su3"
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        UpdateThemePermissions: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/themes/{ThemeId}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "ThemeId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              ThemeId: {
                location: "uri",
                locationName: "ThemeId"
              },
              GrantPermissions: {
                shape: "S1b3"
              },
              RevokePermissions: {
                shape: "S1b3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ThemeId: {},
              ThemeArn: {},
              Permissions: {
                shape: "S19"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UpdateTopic: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/topics/{TopicId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TopicId",
              "Topic"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TopicId: {
                location: "uri",
                locationName: "TopicId"
              },
              Topic: {
                shape: "Su6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TopicId: {},
              Arn: {},
              RefreshArn: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UpdateTopicPermissions: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/topics/{TopicId}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TopicId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TopicId: {
                location: "uri",
                locationName: "TopicId"
              },
              GrantPermissions: {
                shape: "S1b3"
              },
              RevokePermissions: {
                shape: "S1b3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TopicId: {},
              TopicArn: {},
              Permissions: {
                shape: "S19"
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        UpdateTopicRefreshSchedule: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/topics/{TopicId}/schedules/{DatasetId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TopicId",
              "DatasetId",
              "RefreshSchedule"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TopicId: {
                location: "uri",
                locationName: "TopicId"
              },
              DatasetId: {
                location: "uri",
                locationName: "DatasetId"
              },
              RefreshSchedule: {
                shape: "Svv"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TopicId: {},
              TopicArn: {},
              DatasetArn: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        UpdateUser: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/users/{UserName}"
          },
          input: {
            type: "structure",
            required: [
              "UserName",
              "AwsAccountId",
              "Namespace",
              "Email",
              "Role"
            ],
            members: {
              UserName: {
                location: "uri",
                locationName: "UserName"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              },
              Email: {},
              Role: {},
              CustomPermissionsName: {},
              UnapplyCustomPermissions: {
                type: "boolean"
              },
              ExternalLoginFederationProviderType: {},
              CustomFederationProviderUrl: {},
              ExternalLoginId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                shape: "S156"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UpdateVPCConnection: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/vpc-connections/{VPCConnectionId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "VPCConnectionId",
              "Name",
              "SubnetIds",
              "SecurityGroupIds",
              "RoleArn"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              VPCConnectionId: {
                location: "uri",
                locationName: "VPCConnectionId"
              },
              Name: {},
              SubnetIds: {
                shape: "Sw0"
              },
              SecurityGroupIds: {
                shape: "Sw2"
              },
              DnsResolvers: {
                shape: "Sw4"
              },
              RoleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              VPCConnectionId: {},
              UpdateStatus: {},
              AvailabilityStatus: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        }
      },
      shapes: {
        Sa: {
          type: "structure",
          members: {
            DefaultTheme: {},
            DefaultEmailCustomizationTemplate: {}
          }
        },
        Sb: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sk: {
          type: "list",
          member: {}
        },
        Sr: {
          type: "structure",
          members: {
            StringParameters: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name",
                  "Values"
                ],
                members: {
                  Name: {},
                  Values: {
                    shape: "Sv"
                  }
                }
              }
            },
            IntegerParameters: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name",
                  "Values"
                ],
                members: {
                  Name: {},
                  Values: {
                    type: "list",
                    member: {
                      shape: "S10"
                    }
                  }
                }
              }
            },
            DecimalParameters: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name",
                  "Values"
                ],
                members: {
                  Name: {},
                  Values: {
                    type: "list",
                    member: {
                      shape: "S14"
                    }
                  }
                }
              }
            },
            DateTimeParameters: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name",
                  "Values"
                ],
                members: {
                  Name: {},
                  Values: {
                    type: "list",
                    member: {
                      shape: "S18"
                    }
                  }
                }
              }
            }
          }
        },
        Sv: {
          type: "list",
          member: {
            shape: "Sw"
          }
        },
        Sw: {
          type: "string",
          sensitive: true
        },
        S10: {
          type: "long",
          sensitive: true
        },
        S14: {
          type: "double",
          sensitive: true
        },
        S18: {
          type: "timestamp",
          sensitive: true
        },
        S19: {
          type: "list",
          member: {
            shape: "S1a"
          }
        },
        S1a: {
          type: "structure",
          required: [
            "Principal",
            "Actions"
          ],
          members: {
            Principal: {},
            Actions: {
              shape: "S1c"
            }
          }
        },
        S1c: {
          type: "list",
          member: {}
        },
        S1d: {
          type: "structure",
          members: {
            SourceTemplate: {
              type: "structure",
              required: [
                "DataSetReferences",
                "Arn"
              ],
              members: {
                DataSetReferences: {
                  shape: "S1f"
                },
                Arn: {}
              }
            }
          }
        },
        S1f: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "DataSetPlaceholder",
              "DataSetArn"
            ],
            members: {
              DataSetPlaceholder: {},
              DataSetArn: {}
            }
          }
        },
        S1h: {
          type: "structure",
          required: [
            "DataSetIdentifierDeclarations"
          ],
          members: {
            DataSetIdentifierDeclarations: {
              shape: "S1i"
            },
            Sheets: {
              shape: "S1l"
            },
            CalculatedFields: {
              shape: "Sk2"
            },
            ParameterDeclarations: {
              shape: "Sk5"
            },
            FilterGroups: {
              shape: "Skp"
            },
            ColumnConfigurations: {
              shape: "Slp"
            },
            AnalysisDefaults: {
              shape: "Slw"
            },
            Options: {
              shape: "Sm3"
            }
          }
        },
        S1i: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Identifier",
              "DataSetArn"
            ],
            members: {
              Identifier: {},
              DataSetArn: {}
            }
          }
        },
        S1l: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "SheetId"
            ],
            members: {
              SheetId: {},
              Title: {},
              Description: {},
              Name: {},
              ParameterControls: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DateTimePicker: {
                      type: "structure",
                      required: [
                        "ParameterControlId",
                        "Title",
                        "SourceParameterName"
                      ],
                      members: {
                        ParameterControlId: {},
                        Title: {},
                        SourceParameterName: {},
                        DisplayOptions: {
                          shape: "S1v"
                        }
                      }
                    },
                    List: {
                      type: "structure",
                      required: [
                        "ParameterControlId",
                        "Title",
                        "SourceParameterName"
                      ],
                      members: {
                        ParameterControlId: {},
                        Title: {},
                        SourceParameterName: {},
                        DisplayOptions: {
                          shape: "S2a"
                        },
                        Type: {},
                        SelectableValues: {
                          shape: "S2e"
                        },
                        CascadingControlConfiguration: {
                          shape: "S2i"
                        }
                      }
                    },
                    Dropdown: {
                      type: "structure",
                      required: [
                        "ParameterControlId",
                        "Title",
                        "SourceParameterName"
                      ],
                      members: {
                        ParameterControlId: {},
                        Title: {},
                        SourceParameterName: {},
                        DisplayOptions: {
                          shape: "S2m"
                        },
                        Type: {},
                        SelectableValues: {
                          shape: "S2e"
                        },
                        CascadingControlConfiguration: {
                          shape: "S2i"
                        }
                      }
                    },
                    TextField: {
                      type: "structure",
                      required: [
                        "ParameterControlId",
                        "Title",
                        "SourceParameterName"
                      ],
                      members: {
                        ParameterControlId: {},
                        Title: {},
                        SourceParameterName: {},
                        DisplayOptions: {
                          shape: "S2o"
                        }
                      }
                    },
                    TextArea: {
                      type: "structure",
                      required: [
                        "ParameterControlId",
                        "Title",
                        "SourceParameterName"
                      ],
                      members: {
                        ParameterControlId: {},
                        Title: {},
                        SourceParameterName: {},
                        Delimiter: {},
                        DisplayOptions: {
                          shape: "S2s"
                        }
                      }
                    },
                    Slider: {
                      type: "structure",
                      required: [
                        "ParameterControlId",
                        "Title",
                        "SourceParameterName",
                        "MaximumValue",
                        "MinimumValue",
                        "StepSize"
                      ],
                      members: {
                        ParameterControlId: {},
                        Title: {},
                        SourceParameterName: {},
                        DisplayOptions: {
                          shape: "S2u"
                        },
                        MaximumValue: {
                          type: "double"
                        },
                        MinimumValue: {
                          type: "double"
                        },
                        StepSize: {
                          type: "double"
                        }
                      }
                    }
                  }
                }
              },
              FilterControls: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DateTimePicker: {
                      type: "structure",
                      required: [
                        "FilterControlId",
                        "Title",
                        "SourceFilterId"
                      ],
                      members: {
                        FilterControlId: {},
                        Title: {},
                        SourceFilterId: {},
                        DisplayOptions: {
                          shape: "S1v"
                        },
                        Type: {}
                      }
                    },
                    List: {
                      type: "structure",
                      required: [
                        "FilterControlId",
                        "Title",
                        "SourceFilterId"
                      ],
                      members: {
                        FilterControlId: {},
                        Title: {},
                        SourceFilterId: {},
                        DisplayOptions: {
                          shape: "S2a"
                        },
                        Type: {},
                        SelectableValues: {
                          shape: "S31"
                        },
                        CascadingControlConfiguration: {
                          shape: "S2i"
                        }
                      }
                    },
                    Dropdown: {
                      type: "structure",
                      required: [
                        "FilterControlId",
                        "Title",
                        "SourceFilterId"
                      ],
                      members: {
                        FilterControlId: {},
                        Title: {},
                        SourceFilterId: {},
                        DisplayOptions: {
                          shape: "S2m"
                        },
                        Type: {},
                        SelectableValues: {
                          shape: "S31"
                        },
                        CascadingControlConfiguration: {
                          shape: "S2i"
                        }
                      }
                    },
                    TextField: {
                      type: "structure",
                      required: [
                        "FilterControlId",
                        "Title",
                        "SourceFilterId"
                      ],
                      members: {
                        FilterControlId: {},
                        Title: {},
                        SourceFilterId: {},
                        DisplayOptions: {
                          shape: "S2o"
                        }
                      }
                    },
                    TextArea: {
                      type: "structure",
                      required: [
                        "FilterControlId",
                        "Title",
                        "SourceFilterId"
                      ],
                      members: {
                        FilterControlId: {},
                        Title: {},
                        SourceFilterId: {},
                        Delimiter: {},
                        DisplayOptions: {
                          shape: "S2s"
                        }
                      }
                    },
                    Slider: {
                      type: "structure",
                      required: [
                        "FilterControlId",
                        "Title",
                        "SourceFilterId",
                        "MaximumValue",
                        "MinimumValue",
                        "StepSize"
                      ],
                      members: {
                        FilterControlId: {},
                        Title: {},
                        SourceFilterId: {},
                        DisplayOptions: {
                          shape: "S2u"
                        },
                        Type: {},
                        MaximumValue: {
                          type: "double"
                        },
                        MinimumValue: {
                          type: "double"
                        },
                        StepSize: {
                          type: "double"
                        }
                      }
                    },
                    RelativeDateTime: {
                      type: "structure",
                      required: [
                        "FilterControlId",
                        "Title",
                        "SourceFilterId"
                      ],
                      members: {
                        FilterControlId: {},
                        Title: {},
                        SourceFilterId: {},
                        DisplayOptions: {
                          type: "structure",
                          members: {
                            TitleOptions: {
                              shape: "S1w"
                            },
                            DateTimeFormat: {},
                            InfoIconLabelOptions: {
                              shape: "S27"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              Visuals: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TableVisual: {
                      type: "structure",
                      required: [
                        "VisualId"
                      ],
                      members: {
                        VisualId: {},
                        Title: {
                          shape: "S3c"
                        },
                        Subtitle: {
                          shape: "S3g"
                        },
                        ChartConfiguration: {
                          type: "structure",
                          members: {
                            FieldWells: {
                              type: "structure",
                              members: {
                                TableAggregatedFieldWells: {
                                  type: "structure",
                                  members: {
                                    GroupBy: {
                                      shape: "S3n"
                                    },
                                    Values: {
                                      shape: "S4f"
                                    }
                                  }
                                },
                                TableUnaggregatedFieldWells: {
                                  type: "structure",
                                  members: {
                                    Values: {
                                      type: "list",
                                      member: {
                                        type: "structure",
                                        required: [
                                          "FieldId",
                                          "Column"
                                        ],
                                        members: {
                                          FieldId: {},
                                          Column: {
                                            shape: "S2g"
                                          },
                                          FormatConfiguration: {
                                            shape: "S4v"
                                          }
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            },
                            SortConfiguration: {
                              type: "structure",
                              members: {
                                RowSort: {
                                  type: "list",
                                  member: {
                                    shape: "S4y"
                                  }
                                },
                                PaginationConfiguration: {
                                  shape: "S55"
                                }
                              }
                            },
                            TableOptions: {
                              type: "structure",
                              members: {
                                Orientation: {},
                                HeaderStyle: {
                                  shape: "S5a"
                                },
                                CellStyle: {
                                  shape: "S5a"
                                },
                                RowAlternateColorOptions: {
                                  shape: "S5k"
                                }
                              }
                            },
                            TotalOptions: {
                              type: "structure",
                              members: {
                                TotalsVisibility: {},
                                Placement: {},
                                ScrollStatus: {},
                                CustomLabel: {},
                                TotalCellStyle: {
                                  shape: "S5a"
                                },
                                TotalAggregationOptions: {
                                  shape: "S5q"
                                }
                              }
                            },
                            FieldOptions: {
                              type: "structure",
                              members: {
                                SelectedFieldOptions: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    required: [
                                      "FieldId"
                                    ],
                                    members: {
                                      FieldId: {},
                                      Width: {},
                                      CustomLabel: {},
                                      Visibility: {},
                                      URLStyling: {
                                        type: "structure",
                                        members: {
                                          LinkConfiguration: {
                                            type: "structure",
                                            required: [
                                              "Target",
                                              "Content"
                                            ],
                                            members: {
                                              Target: {},
                                              Content: {
                                                type: "structure",
                                                members: {
                                                  CustomTextContent: {
                                                    type: "structure",
                                                    required: [
                                                      "FontConfiguration"
                                                    ],
                                                    members: {
                                                      Value: {},
                                                      FontConfiguration: {
                                                        shape: "S1y"
                                                      }
                                                    }
                                                  },
                                                  CustomIconContent: {
                                                    type: "structure",
                                                    members: {
                                                      Icon: {}
                                                    }
                                                  }
                                                }
                                              }
                                            }
                                          },
                                          ImageConfiguration: {
                                            type: "structure",
                                            members: {
                                              SizingOptions: {
                                                type: "structure",
                                                members: {
                                                  TableCellImageScalingConfiguration: {}
                                                }
                                              }
                                            }
                                          }
                                        }
                                      }
                                    }
                                  }
                                },
                                Order: {
                                  type: "list",
                                  member: {}
                                },
                                PinnedFieldOptions: {
                                  type: "structure",
                                  members: {
                                    PinnedLeftFields: {
                                      type: "list",
                                      member: {}
                                    }
                                  }
                                }
                              }
                            },
                            PaginatedReportOptions: {
                              type: "structure",
                              members: {
                                VerticalOverflowVisibility: {},
                                OverflowColumnHeaderVisibility: {}
                              }
                            },
                            TableInlineVisualizations: {
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  DataBars: {
                                    type: "structure",
                                    required: [
                                      "FieldId"
                                    ],
                                    members: {
                                      FieldId: {},
                                      PositiveColor: {},
                                      NegativeColor: {}
                                    }
                                  }
                                }
                              }
                            }
                          }
                        },
                        ConditionalFormatting: {
                          type: "structure",
                          members: {
                            ConditionalFormattingOptions: {
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  Cell: {
                                    type: "structure",
                                    required: [
                                      "FieldId"
                                    ],
                                    members: {
                                      FieldId: {},
                                      TextFormat: {
                                        shape: "S6k"
                                      }
                                    }
                                  },
                                  Row: {
                                    type: "structure",
                                    members: {
                                      BackgroundColor: {
                                        shape: "S6l"
                                      },
                                      TextColor: {
                                        shape: "S6l"
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        },
                        Actions: {
                          shape: "S71"
                        }
                      }
                    },
                    PivotTableVisual: {
                      type: "structure",
                      required: [
                        "VisualId"
                      ],
                      members: {
                        VisualId: {},
                        Title: {
                          shape: "S3c"
                        },
                        Subtitle: {
                          shape: "S3g"
                        },
                        ChartConfiguration: {
                          type: "structure",
                          members: {
                            FieldWells: {
                              type: "structure",
                              members: {
                                PivotTableAggregatedFieldWells: {
                                  type: "structure",
                                  members: {
                                    Rows: {
                                      shape: "S83"
                                    },
                                    Columns: {
                                      shape: "S83"
                                    },
                                    Values: {
                                      type: "list",
                                      member: {
                                        shape: "S4g"
                                      }
                                    }
                                  }
                                }
                              }
                            },
                            SortConfiguration: {
                              type: "structure",
                              members: {
                                FieldSortOptions: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    required: [
                                      "FieldId",
                                      "SortBy"
                                    ],
                                    members: {
                                      FieldId: {},
                                      SortBy: {
                                        type: "structure",
                                        members: {
                                          Field: {
                                            shape: "S4z"
                                          },
                                          Column: {
                                            shape: "S51"
                                          },
                                          DataPath: {
                                            type: "structure",
                                            required: [
                                              "Direction",
                                              "SortPaths"
                                            ],
                                            members: {
                                              Direction: {},
                                              SortPaths: {
                                                shape: "S8a"
                                              }
                                            }
                                          }
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            },
                            TableOptions: {
                              type: "structure",
                              members: {
                                MetricPlacement: {},
                                SingleMetricVisibility: {},
                                ColumnNamesVisibility: {},
                                ToggleButtonsVisibility: {},
                                ColumnHeaderStyle: {
                                  shape: "S5a"
                                },
                                RowHeaderStyle: {
                                  shape: "S5a"
                                },
                                CellStyle: {
                                  shape: "S5a"
                                },
                                RowFieldNamesStyle: {
                                  shape: "S5a"
                                },
                                RowAlternateColorOptions: {
                                  shape: "S5k"
                                },
                                CollapsedRowDimensionsVisibility: {},
                                RowsLayout: {},
                                RowsLabelOptions: {
                                  type: "structure",
                                  members: {
                                    Visibility: {},
                                    CustomLabel: {}
                                  }
                                },
                                DefaultCellWidth: {}
                              }
                            },
                            TotalOptions: {
                              type: "structure",
                              members: {
                                RowSubtotalOptions: {
                                  shape: "S8l"
                                },
                                ColumnSubtotalOptions: {
                                  shape: "S8l"
                                },
                                RowTotalOptions: {
                                  shape: "S8s"
                                },
                                ColumnTotalOptions: {
                                  shape: "S8s"
                                }
                              }
                            },
                            FieldOptions: {
                              type: "structure",
                              members: {
                                SelectedFieldOptions: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    required: [
                                      "FieldId"
                                    ],
                                    members: {
                                      FieldId: {},
                                      CustomLabel: {},
                                      Visibility: {}
                                    }
                                  }
                                },
                                DataPathOptions: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    required: [
                                      "DataPathList"
                                    ],
                                    members: {
                                      DataPathList: {
                                        shape: "S8a"
                                      },
                                      Width: {}
                                    }
                                  }
                                },
                                CollapseStateOptions: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    required: [
                                      "Target"
                                    ],
                                    members: {
                                      Target: {
                                        type: "structure",
                                        members: {
                                          FieldId: {},
                                          FieldDataPathValues: {
                                            shape: "S8a"
                                          }
                                        }
                                      },
                                      State: {}
                                    }
                                  }
                                }
                              }
                            },
                            PaginatedReportOptions: {
                              type: "structure",
                              members: {
                                VerticalOverflowVisibility: {},
                                OverflowColumnHeaderVisibility: {}
                              }
                            }
                          }
                        },
                        ConditionalFormatting: {
                          type: "structure",
                          members: {
                            ConditionalFormattingOptions: {
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  Cell: {
                                    type: "structure",
                                    required: [
                                      "FieldId"
                                    ],
                                    members: {
                                      FieldId: {},
                                      TextFormat: {
                                        shape: "S6k"
                                      },
                                      Scope: {
                                        shape: "S97"
                                      },
                                      Scopes: {
                                        type: "list",
                                        member: {
                                          shape: "S97"
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        },
                        Actions: {
                          shape: "S71"
                        }
                      }
                    },
                    BarChartVisual: {
                      type: "structure",
                      required: [
                        "VisualId"
                      ],
                      members: {
                        VisualId: {},
                        Title: {
                          shape: "S3c"
                        },
                        Subtitle: {
                          shape: "S3g"
                        },
                        ChartConfiguration: {
                          type: "structure",
                          members: {
                            FieldWells: {
                              type: "structure",
                              members: {
                                BarChartAggregatedFieldWells: {
                                  type: "structure",
                                  members: {
                                    Category: {
                                      shape: "S3n"
                                    },
                                    Values: {
                                      shape: "S4f"
                                    },
                                    Colors: {
                                      shape: "S3n"
                                    },
                                    SmallMultiples: {
                                      shape: "S9e"
                                    }
                                  }
                                }
                              }
                            },
                            SortConfiguration: {
                              type: "structure",
                              members: {
                                CategorySort: {
                                  shape: "S9g"
                                },
                                CategoryItemsLimit: {
                                  shape: "S9h"
                                },
                                ColorSort: {
                                  shape: "S9g"
                                },
                                ColorItemsLimit: {
                                  shape: "S9h"
                                },
                                SmallMultiplesSort: {
                                  shape: "S9g"
                                },
                                SmallMultiplesLimitConfiguration: {
                                  shape: "S9h"
                                }
                              }
                            },
                            Orientation: {},
                            BarsArrangement: {},
                            VisualPalette: {
                              shape: "S9l"
                            },
                            SmallMultiplesOptions: {
                              shape: "S9o"
                            },
                            CategoryAxis: {
                              shape: "S9y"
                            },
                            CategoryLabelOptions: {
                              shape: "Sae"
                            },
                            ValueAxis: {
                              shape: "S9y"
                            },
                            ValueLabelOptions: {
                              shape: "Sae"
                            },
                            ColorLabelOptions: {
                              shape: "Sae"
                            },
                            Legend: {
                              shape: "Sai"
                            },
                            DataLabels: {
                              shape: "Sak"
                            },
                            Tooltip: {
                              shape: "Sav"
                            },
                            ReferenceLines: {
                              shape: "Sb3"
                            },
                            ContributionAnalysisDefaults: {
                              shape: "Sbi"
                            }
                          }
                        },
                        Actions: {
                          shape: "S71"
                        },
                        ColumnHierarchies: {
                          shape: "Sbl"
                        }
                      }
                    },
                    KPIVisual: {
                      type: "structure",
                      required: [
                        "VisualId"
                      ],
                      members: {
                        VisualId: {},
                        Title: {
                          shape: "S3c"
                        },
                        Subtitle: {
                          shape: "S3g"
                        },
                        ChartConfiguration: {
                          type: "structure",
                          members: {
                            FieldWells: {
                              type: "structure",
                              members: {
                                Values: {
                                  shape: "S4f"
                                },
                                TargetValues: {
                                  shape: "S4f"
                                },
                                TrendGroups: {
                                  shape: "S3n"
                                }
                              }
                            },
                            SortConfiguration: {
                              type: "structure",
                              members: {
                                TrendGroupSort: {
                                  shape: "S9g"
                                }
                              }
                            },
                            KPIOptions: {
                              type: "structure",
                              members: {
                                ProgressBar: {
                                  type: "structure",
                                  members: {
                                    Visibility: {}
                                  }
                                },
                                TrendArrows: {
                                  type: "structure",
                                  members: {
                                    Visibility: {}
                                  }
                                },
                                SecondaryValue: {
                                  type: "structure",
                                  members: {
                                    Visibility: {}
                                  }
                                },
                                Comparison: {
                                  shape: "Sc8"
                                },
                                PrimaryValueDisplayType: {},
                                PrimaryValueFontConfiguration: {
                                  shape: "S1y"
                                },
                                SecondaryValueFontConfiguration: {
                                  shape: "S1y"
                                },
                                Sparkline: {
                                  type: "structure",
                                  required: [
                                    "Type"
                                  ],
                                  members: {
                                    Visibility: {},
                                    Type: {},
                                    Color: {},
                                    TooltipVisibility: {}
                                  }
                                },
                                VisualLayoutOptions: {
                                  type: "structure",
                                  members: {
                                    StandardLayout: {
                                      type: "structure",
                                      required: [
                                        "Type"
                                      ],
                                      members: {
                                        Type: {}
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        },
                        ConditionalFormatting: {
                          type: "structure",
                          members: {
                            ConditionalFormattingOptions: {
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  PrimaryValue: {
                                    type: "structure",
                                    members: {
                                      TextColor: {
                                        shape: "S6l"
                                      },
                                      Icon: {
                                        shape: "S6r"
                                      }
                                    }
                                  },
                                  ProgressBar: {
                                    type: "structure",
                                    members: {
                                      ForegroundColor: {
                                        shape: "S6l"
                                      }
                                    }
                                  },
                                  ActualValue: {
                                    type: "structure",
                                    members: {
                                      TextColor: {
                                        shape: "S6l"
                                      },
                                      Icon: {
                                        shape: "S6r"
                                      }
                                    }
                                  },
                                  ComparisonValue: {
                                    type: "structure",
                                    members: {
                                      TextColor: {
                                        shape: "S6l"
                                      },
                                      Icon: {
                                        shape: "S6r"
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        },
                        Actions: {
                          shape: "S71"
                        },
                        ColumnHierarchies: {
                          shape: "Sbl"
                        }
                      }
                    },
                    PieChartVisual: {
                      type: "structure",
                      required: [
                        "VisualId"
                      ],
                      members: {
                        VisualId: {},
                        Title: {
                          shape: "S3c"
                        },
                        Subtitle: {
                          shape: "S3g"
                        },
                        ChartConfiguration: {
                          type: "structure",
                          members: {
                            FieldWells: {
                              type: "structure",
                              members: {
                                PieChartAggregatedFieldWells: {
                                  type: "structure",
                                  members: {
                                    Category: {
                                      shape: "S3n"
                                    },
                                    Values: {
                                      shape: "S4f"
                                    },
                                    SmallMultiples: {
                                      shape: "S9e"
                                    }
                                  }
                                }
                              }
                            },
                            SortConfiguration: {
                              type: "structure",
                              members: {
                                CategorySort: {
                                  shape: "S9g"
                                },
                                CategoryItemsLimit: {
                                  shape: "S9h"
                                },
                                SmallMultiplesSort: {
                                  shape: "S9g"
                                },
                                SmallMultiplesLimitConfiguration: {
                                  shape: "S9h"
                                }
                              }
                            },
                            DonutOptions: {
                              type: "structure",
                              members: {
                                ArcOptions: {
                                  type: "structure",
                                  members: {
                                    ArcThickness: {}
                                  }
                                },
                                DonutCenterOptions: {
                                  type: "structure",
                                  members: {
                                    LabelVisibility: {}
                                  }
                                }
                              }
                            },
                            SmallMultiplesOptions: {
                              shape: "S9o"
                            },
                            CategoryLabelOptions: {
                              shape: "Sae"
                            },
                            ValueLabelOptions: {
                              shape: "Sae"
                            },
                            Legend: {
                              shape: "Sai"
                            },
                            DataLabels: {
                              shape: "Sak"
                            },
                            Tooltip: {
                              shape: "Sav"
                            },
                            VisualPalette: {
                              shape: "S9l"
                            },
                            ContributionAnalysisDefaults: {
                              shape: "Sbi"
                            }
                          }
                        },
                        Actions: {
                          shape: "S71"
                        },
                        ColumnHierarchies: {
                          shape: "Sbl"
                        }
                      }
                    },
                    GaugeChartVisual: {
                      type: "structure",
                      required: [
                        "VisualId"
                      ],
                      members: {
                        VisualId: {},
                        Title: {
                          shape: "S3c"
                        },
                        Subtitle: {
                          shape: "S3g"
                        },
                        ChartConfiguration: {
                          type: "structure",
                          members: {
                            FieldWells: {
                              type: "structure",
                              members: {
                                Values: {
                                  shape: "S4f"
                                },
                                TargetValues: {
                                  shape: "S4f"
                                }
                              }
                            },
                            GaugeChartOptions: {
                              type: "structure",
                              members: {
                                PrimaryValueDisplayType: {},
                                Comparison: {
                                  shape: "Sc8"
                                },
                                ArcAxis: {
                                  type: "structure",
                                  members: {
                                    Range: {
                                      type: "structure",
                                      members: {
                                        Min: {
                                          type: "double"
                                        },
                                        Max: {
                                          type: "double"
                                        }
                                      }
                                    },
                                    ReserveRange: {
                                      type: "integer"
                                    }
                                  }
                                },
                                Arc: {
                                  type: "structure",
                                  members: {
                                    ArcAngle: {
                                      type: "double"
                                    },
                                    ArcThickness: {}
                                  }
                                },
                                PrimaryValueFontConfiguration: {
                                  shape: "S1y"
                                }
                              }
                            },
                            DataLabels: {
                              shape: "Sak"
                            },
                            TooltipOptions: {
                              shape: "Sav"
                            },
                            VisualPalette: {
                              shape: "S9l"
                            }
                          }
                        },
                        ConditionalFormatting: {
                          type: "structure",
                          members: {
                            ConditionalFormattingOptions: {
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  PrimaryValue: {
                                    type: "structure",
                                    members: {
                                      TextColor: {
                                        shape: "S6l"
                                      },
                                      Icon: {
                                        shape: "S6r"
                                      }
                                    }
                                  },
                                  Arc: {
                                    type: "structure",
                                    members: {
                                      ForegroundColor: {
                                        shape: "S6l"
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        },
                        Actions: {
                          shape: "S71"
                        }
                      }
                    },
                    LineChartVisual: {
                      type: "structure",
                      required: [
                        "VisualId"
                      ],
                      members: {
                        VisualId: {},
                        Title: {
                          shape: "S3c"
                        },
                        Subtitle: {
                          shape: "S3g"
                        },
                        ChartConfiguration: {
                          type: "structure",
                          members: {
                            FieldWells: {
                              type: "structure",
                              members: {
                                LineChartAggregatedFieldWells: {
                                  type: "structure",
                                  members: {
                                    Category: {
                                      shape: "S3n"
                                    },
                                    Values: {
                                      shape: "S4f"
                                    },
                                    Colors: {
                                      shape: "S3n"
                                    },
                                    SmallMultiples: {
                                      shape: "S9e"
                                    }
                                  }
                                }
                              }
                            },
                            SortConfiguration: {
                              type: "structure",
                              members: {
                                CategorySort: {
                                  shape: "S9g"
                                },
                                CategoryItemsLimitConfiguration: {
                                  shape: "S9h"
                                },
                                ColorItemsLimitConfiguration: {
                                  shape: "S9h"
                                },
                                SmallMultiplesSort: {
                                  shape: "S9g"
                                },
                                SmallMultiplesLimitConfiguration: {
                                  shape: "S9h"
                                }
                              }
                            },
                            ForecastConfigurations: {
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  ForecastProperties: {
                                    type: "structure",
                                    members: {
                                      PeriodsForward: {
                                        type: "integer"
                                      },
                                      PeriodsBackward: {
                                        type: "integer"
                                      },
                                      UpperBoundary: {
                                        type: "double"
                                      },
                                      LowerBoundary: {
                                        type: "double"
                                      },
                                      PredictionInterval: {
                                        type: "integer"
                                      },
                                      Seasonality: {
                                        type: "integer"
                                      }
                                    }
                                  },
                                  Scenario: {
                                    type: "structure",
                                    members: {
                                      WhatIfPointScenario: {
                                        type: "structure",
                                        required: [
                                          "Date",
                                          "Value"
                                        ],
                                        members: {
                                          Date: {
                                            type: "timestamp"
                                          },
                                          Value: {
                                            type: "double"
                                          }
                                        }
                                      },
                                      WhatIfRangeScenario: {
                                        type: "structure",
                                        required: [
                                          "StartDate",
                                          "EndDate",
                                          "Value"
                                        ],
                                        members: {
                                          StartDate: {
                                            type: "timestamp"
                                          },
                                          EndDate: {
                                            type: "timestamp"
                                          },
                                          Value: {
                                            type: "double"
                                          }
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            },
                            Type: {},
                            SmallMultiplesOptions: {
                              shape: "S9o"
                            },
                            XAxisDisplayOptions: {
                              shape: "S9y"
                            },
                            XAxisLabelOptions: {
                              shape: "Sae"
                            },
                            PrimaryYAxisDisplayOptions: {
                              shape: "Sdq"
                            },
                            PrimaryYAxisLabelOptions: {
                              shape: "Sae"
                            },
                            SecondaryYAxisDisplayOptions: {
                              shape: "Sdq"
                            },
                            SecondaryYAxisLabelOptions: {
                              shape: "Sae"
                            },
                            SingleAxisOptions: {
                              shape: "Sdu"
                            },
                            DefaultSeriesSettings: {
                              type: "structure",
                              members: {
                                AxisBinding: {},
                                LineStyleSettings: {
                                  shape: "Sdy"
                                },
                                MarkerStyleSettings: {
                                  shape: "Se1"
                                }
                              }
                            },
                            Series: {
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  FieldSeriesItem: {
                                    type: "structure",
                                    required: [
                                      "FieldId",
                                      "AxisBinding"
                                    ],
                                    members: {
                                      FieldId: {},
                                      AxisBinding: {},
                                      Settings: {
                                        shape: "Se6"
                                      }
                                    }
                                  },
                                  DataFieldSeriesItem: {
                                    type: "structure",
                                    required: [
                                      "FieldId",
                                      "AxisBinding"
                                    ],
                                    members: {
                                      FieldId: {},
                                      FieldValue: {
                                        shape: "Sw"
                                      },
                                      AxisBinding: {},
                                      Settings: {
                                        shape: "Se6"
                                      }
                                    }
                                  }
                                }
                              }
                            },
                            Legend: {
                              shape: "Sai"
                            },
                            DataLabels: {
                              shape: "Sak"
                            },
                            ReferenceLines: {
                              shape: "Sb3"
                            },
                            Tooltip: {
                              shape: "Sav"
                            },
                            ContributionAnalysisDefaults: {
                              shape: "Sbi"
                            },
                            VisualPalette: {
                              shape: "S9l"
                            }
                          }
                        },
                        Actions: {
                          shape: "S71"
                        },
                        ColumnHierarchies: {
                          shape: "Sbl"
                        }
                      }
                    },
                    HeatMapVisual: {
                      type: "structure",
                      required: [
                        "VisualId"
                      ],
                      members: {
                        VisualId: {},
                        Title: {
                          shape: "S3c"
                        },
                        Subtitle: {
                          shape: "S3g"
                        },
                        ChartConfiguration: {
                          type: "structure",
                          members: {
                            FieldWells: {
                              type: "structure",
                              members: {
                                HeatMapAggregatedFieldWells: {
                                  type: "structure",
                                  members: {
                                    Rows: {
                                      shape: "Sec"
                                    },
                                    Columns: {
                                      shape: "Sec"
                                    },
                                    Values: {
                                      type: "list",
                                      member: {
                                        shape: "S4g"
                                      }
                                    }
                                  }
                                }
                              }
                            },
                            SortConfiguration: {
                              type: "structure",
                              members: {
                                HeatMapRowSort: {
                                  shape: "S9g"
                                },
                                HeatMapColumnSort: {
                                  shape: "S9g"
                                },
                                HeatMapRowItemsLimitConfiguration: {
                                  shape: "S9h"
                                },
                                HeatMapColumnItemsLimitConfiguration: {
                                  shape: "S9h"
                                }
                              }
                            },
                            RowLabelOptions: {
                              shape: "Sae"
                            },
                            ColumnLabelOptions: {
                              shape: "Sae"
                            },
                            ColorScale: {
                              shape: "Sef"
                            },
                            Legend: {
                              shape: "Sai"
                            },
                            DataLabels: {
                              shape: "Sak"
                            },
                            Tooltip: {
                              shape: "Sav"
                            }
                          }
                        },
                        ColumnHierarchies: {
                          shape: "Sbl"
                        },
                        Actions: {
                          shape: "S71"
                        }
                      }
                    },
                    TreeMapVisual: {
                      type: "structure",
                      required: [
                        "VisualId"
                      ],
                      members: {
                        VisualId: {},
                        Title: {
                          shape: "S3c"
                        },
                        Subtitle: {
                          shape: "S3g"
                        },
                        ChartConfiguration: {
                          type: "structure",
                          members: {
                            FieldWells: {
                              type: "structure",
                              members: {
                                TreeMapAggregatedFieldWells: {
                                  type: "structure",
                                  members: {
                                    Groups: {
                                      type: "list",
                                      member: {
                                        shape: "S3o"
                                      }
                                    },
                                    Sizes: {
                                      shape: "Seo"
                                    },
                                    Colors: {
                                      shape: "Seo"
                                    }
                                  }
                                }
                              }
                            },
                            SortConfiguration: {
                              type: "structure",
                              members: {
                                TreeMapSort: {
                                  shape: "S9g"
                                },
                                TreeMapGroupItemsLimitConfiguration: {
                                  shape: "S9h"
                                }
                              }
                            },
                            GroupLabelOptions: {
                              shape: "Sae"
                            },
                            SizeLabelOptions: {
                              shape: "Sae"
                            },
                            ColorLabelOptions: {
                              shape: "Sae"
                            },
                            ColorScale: {
                              shape: "Sef"
                            },
                            Legend: {
                              shape: "Sai"
                            },
                            DataLabels: {
                              shape: "Sak"
                            },
                            Tooltip: {
                              shape: "Sav"
                            }
                          }
                        },
                        Actions: {
                          shape: "S71"
                        },
                        ColumnHierarchies: {
                          shape: "Sbl"
                        }
                      }
                    },
                    GeospatialMapVisual: {
                      type: "structure",
                      required: [
                        "VisualId"
                      ],
                      members: {
                        VisualId: {},
                        Title: {
                          shape: "S3c"
                        },
                        Subtitle: {
                          shape: "S3g"
                        },
                        ChartConfiguration: {
                          type: "structure",
                          members: {
                            FieldWells: {
                              type: "structure",
                              members: {
                                GeospatialMapAggregatedFieldWells: {
                                  type: "structure",
                                  members: {
                                    Geospatial: {
                                      shape: "S3n"
                                    },
                                    Values: {
                                      shape: "S4f"
                                    },
                                    Colors: {
                                      shape: "S3n"
                                    }
                                  }
                                }
                              }
                            },
                            Legend: {
                              shape: "Sai"
                            },
                            Tooltip: {
                              shape: "Sav"
                            },
                            WindowOptions: {
                              shape: "Seu"
                            },
                            MapStyleOptions: {
                              shape: "Sez"
                            },
                            PointStyleOptions: {
                              type: "structure",
                              members: {
                                SelectedPointStyle: {},
                                ClusterMarkerConfiguration: {
                                  type: "structure",
                                  members: {
                                    ClusterMarker: {
                                      type: "structure",
                                      members: {
                                        SimpleClusterMarker: {
                                          type: "structure",
                                          members: {
                                            Color: {}
                                          }
                                        }
                                      }
                                    }
                                  }
                                },
                                HeatmapConfiguration: {
                                  type: "structure",
                                  members: {
                                    HeatmapColor: {
                                      type: "structure",
                                      members: {
                                        Colors: {
                                          type: "list",
                                          member: {
                                            type: "structure",
                                            required: [
                                              "Color"
                                            ],
                                            members: {
                                              Color: {}
                                            }
                                          }
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            },
                            VisualPalette: {
                              shape: "S9l"
                            }
                          }
                        },
                        ColumnHierarchies: {
                          shape: "Sbl"
                        },
                        Actions: {
                          shape: "S71"
                        }
                      }
                    },
                    FilledMapVisual: {
                      type: "structure",
                      required: [
                        "VisualId"
                      ],
                      members: {
                        VisualId: {},
                        Title: {
                          shape: "S3c"
                        },
                        Subtitle: {
                          shape: "S3g"
                        },
                        ChartConfiguration: {
                          type: "structure",
                          members: {
                            FieldWells: {
                              type: "structure",
                              members: {
                                FilledMapAggregatedFieldWells: {
                                  type: "structure",
                                  members: {
                                    Geospatial: {
                                      type: "list",
                                      member: {
                                        shape: "S3o"
                                      }
                                    },
                                    Values: {
                                      type: "list",
                                      member: {
                                        shape: "S4g"
                                      }
                                    }
                                  }
                                }
                              }
                            },
                            SortConfiguration: {
                              type: "structure",
                              members: {
                                CategorySort: {
                                  shape: "S9g"
                                }
                              }
                            },
                            Legend: {
                              shape: "Sai"
                            },
                            Tooltip: {
                              shape: "Sav"
                            },
                            WindowOptions: {
                              shape: "Seu"
                            },
                            MapStyleOptions: {
                              shape: "Sez"
                            }
                          }
                        },
                        ConditionalFormatting: {
                          type: "structure",
                          required: [
                            "ConditionalFormattingOptions"
                          ],
                          members: {
                            ConditionalFormattingOptions: {
                              type: "list",
                              member: {
                                type: "structure",
                                required: [
                                  "Shape"
                                ],
                                members: {
                                  Shape: {
                                    type: "structure",
                                    required: [
                                      "FieldId"
                                    ],
                                    members: {
                                      FieldId: {},
                                      Format: {
                                        type: "structure",
                                        required: [
                                          "BackgroundColor"
                                        ],
                                        members: {
                                          BackgroundColor: {
                                            shape: "S6l"
                                          }
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        },
                        ColumnHierarchies: {
                          shape: "Sbl"
                        },
                        Actions: {
                          shape: "S71"
                        }
                      }
                    },
                    FunnelChartVisual: {
                      type: "structure",
                      required: [
                        "VisualId"
                      ],
                      members: {
                        VisualId: {},
                        Title: {
                          shape: "S3c"
                        },
                        Subtitle: {
                          shape: "S3g"
                        },
                        ChartConfiguration: {
                          type: "structure",
                          members: {
                            FieldWells: {
                              type: "structure",
                              members: {
                                FunnelChartAggregatedFieldWells: {
                                  type: "structure",
                                  members: {
                                    Category: {
                                      type: "list",
                                      member: {
                                        shape: "S3o"
                                      }
                                    },
                                    Values: {
                                      type: "list",
                                      member: {
                                        shape: "S4g"
                                      }
                                    }
                                  }
                                }
                              }
                            },
                            SortConfiguration: {
                              type: "structure",
                              members: {
                                CategorySort: {
                                  shape: "S9g"
                                },
                                CategoryItemsLimit: {
                                  shape: "S9h"
                                }
                              }
                            },
                            CategoryLabelOptions: {
                              shape: "Sae"
                            },
                            ValueLabelOptions: {
                              shape: "Sae"
                            },
                            Tooltip: {
                              shape: "Sav"
                            },
                            DataLabelOptions: {
                              type: "structure",
                              members: {
                                Visibility: {},
                                CategoryLabelVisibility: {},
                                MeasureLabelVisibility: {},
                                Position: {},
                                LabelFontConfiguration: {
                                  shape: "S1y"
                                },
                                LabelColor: {},
                                MeasureDataLabelStyle: {}
                              }
                            },
                            VisualPalette: {
                              shape: "S9l"
                            }
                          }
                        },
                        Actions: {
                          shape: "S71"
                        },
                        ColumnHierarchies: {
                          shape: "Sbl"
                        }
                      }
                    },
                    ScatterPlotVisual: {
                      type: "structure",
                      required: [
                        "VisualId"
                      ],
                      members: {
                        VisualId: {},
                        Title: {
                          shape: "S3c"
                        },
                        Subtitle: {
                          shape: "S3g"
                        },
                        ChartConfiguration: {
                          type: "structure",
                          members: {
                            FieldWells: {
                              type: "structure",
                              members: {
                                ScatterPlotCategoricallyAggregatedFieldWells: {
                                  type: "structure",
                                  members: {
                                    XAxis: {
                                      shape: "S4f"
                                    },
                                    YAxis: {
                                      shape: "S4f"
                                    },
                                    Category: {
                                      shape: "S3n"
                                    },
                                    Size: {
                                      shape: "S4f"
                                    },
                                    Label: {
                                      shape: "S3n"
                                    }
                                  }
                                },
                                ScatterPlotUnaggregatedFieldWells: {
                                  type: "structure",
                                  members: {
                                    XAxis: {
                                      shape: "S3n"
                                    },
                                    YAxis: {
                                      shape: "S3n"
                                    },
                                    Size: {
                                      shape: "S4f"
                                    },
                                    Category: {
                                      shape: "S3n"
                                    },
                                    Label: {
                                      shape: "S3n"
                                    }
                                  }
                                }
                              }
                            },
                            SortConfiguration: {
                              type: "structure",
                              members: {
                                ScatterPlotLimitConfiguration: {
                                  shape: "S9h"
                                }
                              }
                            },
                            XAxisLabelOptions: {
                              shape: "Sae"
                            },
                            XAxisDisplayOptions: {
                              shape: "S9y"
                            },
                            YAxisLabelOptions: {
                              shape: "Sae"
                            },
                            YAxisDisplayOptions: {
                              shape: "S9y"
                            },
                            Legend: {
                              shape: "Sai"
                            },
                            DataLabels: {
                              shape: "Sak"
                            },
                            Tooltip: {
                              shape: "Sav"
                            },
                            VisualPalette: {
                              shape: "S9l"
                            }
                          }
                        },
                        Actions: {
                          shape: "S71"
                        },
                        ColumnHierarchies: {
                          shape: "Sbl"
                        }
                      }
                    },
                    ComboChartVisual: {
                      type: "structure",
                      required: [
                        "VisualId"
                      ],
                      members: {
                        VisualId: {},
                        Title: {
                          shape: "S3c"
                        },
                        Subtitle: {
                          shape: "S3g"
                        },
                        ChartConfiguration: {
                          type: "structure",
                          members: {
                            FieldWells: {
                              type: "structure",
                              members: {
                                ComboChartAggregatedFieldWells: {
                                  type: "structure",
                                  members: {
                                    Category: {
                                      shape: "S3n"
                                    },
                                    BarValues: {
                                      shape: "S4f"
                                    },
                                    Colors: {
                                      shape: "S3n"
                                    },
                                    LineValues: {
                                      shape: "S4f"
                                    }
                                  }
                                }
                              }
                            },
                            SortConfiguration: {
                              type: "structure",
                              members: {
                                CategorySort: {
                                  shape: "S9g"
                                },
                                CategoryItemsLimit: {
                                  shape: "S9h"
                                },
                                ColorSort: {
                                  shape: "S9g"
                                },
                                ColorItemsLimit: {
                                  shape: "S9h"
                                }
                              }
                            },
                            BarsArrangement: {},
                            CategoryAxis: {
                              shape: "S9y"
                            },
                            CategoryLabelOptions: {
                              shape: "Sae"
                            },
                            PrimaryYAxisDisplayOptions: {
                              shape: "S9y"
                            },
                            PrimaryYAxisLabelOptions: {
                              shape: "Sae"
                            },
                            SecondaryYAxisDisplayOptions: {
                              shape: "S9y"
                            },
                            SecondaryYAxisLabelOptions: {
                              shape: "Sae"
                            },
                            SingleAxisOptions: {
                              shape: "Sdu"
                            },
                            ColorLabelOptions: {
                              shape: "Sae"
                            },
                            Legend: {
                              shape: "Sai"
                            },
                            BarDataLabels: {
                              shape: "Sak"
                            },
                            LineDataLabels: {
                              shape: "Sak"
                            },
                            Tooltip: {
                              shape: "Sav"
                            },
                            ReferenceLines: {
                              shape: "Sb3"
                            },
                            VisualPalette: {
                              shape: "S9l"
                            }
                          }
                        },
                        Actions: {
                          shape: "S71"
                        },
                        ColumnHierarchies: {
                          shape: "Sbl"
                        }
                      }
                    },
                    BoxPlotVisual: {
                      type: "structure",
                      required: [
                        "VisualId"
                      ],
                      members: {
                        VisualId: {},
                        Title: {
                          shape: "S3c"
                        },
                        Subtitle: {
                          shape: "S3g"
                        },
                        ChartConfiguration: {
                          type: "structure",
                          members: {
                            FieldWells: {
                              type: "structure",
                              members: {
                                BoxPlotAggregatedFieldWells: {
                                  type: "structure",
                                  members: {
                                    GroupBy: {
                                      type: "list",
                                      member: {
                                        shape: "S3o"
                                      }
                                    },
                                    Values: {
                                      type: "list",
                                      member: {
                                        shape: "S4g"
                                      }
                                    }
                                  }
                                }
                              }
                            },
                            SortConfiguration: {
                              type: "structure",
                              members: {
                                CategorySort: {
                                  shape: "S9g"
                                },
                                PaginationConfiguration: {
                                  shape: "S55"
                                }
                              }
                            },
                            BoxPlotOptions: {
                              type: "structure",
                              members: {
                                StyleOptions: {
                                  type: "structure",
                                  members: {
                                    FillStyle: {}
                                  }
                                },
                                OutlierVisibility: {},
                                AllDataPointsVisibility: {}
                              }
                            },
                            CategoryAxis: {
                              shape: "S9y"
                            },
                            CategoryLabelOptions: {
                              shape: "Sae"
                            },
                            PrimaryYAxisDisplayOptions: {
                              shape: "S9y"
                            },
                            PrimaryYAxisLabelOptions: {
                              shape: "Sae"
                            },
                            Legend: {
                              shape: "Sai"
                            },
                            Tooltip: {
                              shape: "Sav"
                            },
                            ReferenceLines: {
                              shape: "Sb3"
                            },
                            VisualPalette: {
                              shape: "S9l"
                            }
                          }
                        },
                        Actions: {
                          shape: "S71"
                        },
                        ColumnHierarchies: {
                          shape: "Sbl"
                        }
                      }
                    },
                    WaterfallVisual: {
                      type: "structure",
                      required: [
                        "VisualId"
                      ],
                      members: {
                        VisualId: {},
                        Title: {
                          shape: "S3c"
                        },
                        Subtitle: {
                          shape: "S3g"
                        },
                        ChartConfiguration: {
                          type: "structure",
                          members: {
                            FieldWells: {
                              type: "structure",
                              members: {
                                WaterfallChartAggregatedFieldWells: {
                                  type: "structure",
                                  members: {
                                    Categories: {
                                      shape: "S3n"
                                    },
                                    Values: {
                                      shape: "S4f"
                                    },
                                    Breakdowns: {
                                      shape: "S3n"
                                    }
                                  }
                                }
                              }
                            },
                            SortConfiguration: {
                              type: "structure",
                              members: {
                                CategorySort: {
                                  shape: "S9g"
                                },
                                BreakdownItemsLimit: {
                                  shape: "S9h"
                                }
                              }
                            },
                            WaterfallChartOptions: {
                              type: "structure",
                              members: {
                                TotalBarLabel: {}
                              }
                            },
                            CategoryAxisLabelOptions: {
                              shape: "Sae"
                            },
                            CategoryAxisDisplayOptions: {
                              shape: "S9y"
                            },
                            PrimaryYAxisLabelOptions: {
                              shape: "Sae"
                            },
                            PrimaryYAxisDisplayOptions: {
                              shape: "S9y"
                            },
                            Legend: {
                              shape: "Sai"
                            },
                            DataLabels: {
                              shape: "Sak"
                            },
                            VisualPalette: {
                              shape: "S9l"
                            }
                          }
                        },
                        Actions: {
                          shape: "S71"
                        },
                        ColumnHierarchies: {
                          shape: "Sbl"
                        }
                      }
                    },
                    HistogramVisual: {
                      type: "structure",
                      required: [
                        "VisualId"
                      ],
                      members: {
                        VisualId: {},
                        Title: {
                          shape: "S3c"
                        },
                        Subtitle: {
                          shape: "S3g"
                        },
                        ChartConfiguration: {
                          type: "structure",
                          members: {
                            FieldWells: {
                              type: "structure",
                              members: {
                                HistogramAggregatedFieldWells: {
                                  type: "structure",
                                  members: {
                                    Values: {
                                      type: "list",
                                      member: {
                                        shape: "S4g"
                                      }
                                    }
                                  }
                                }
                              }
                            },
                            XAxisDisplayOptions: {
                              shape: "S9y"
                            },
                            XAxisLabelOptions: {
                              shape: "Sae"
                            },
                            YAxisDisplayOptions: {
                              shape: "S9y"
                            },
                            BinOptions: {
                              type: "structure",
                              members: {
                                SelectedBinType: {},
                                BinCount: {
                                  type: "structure",
                                  members: {
                                    Value: {
                                      type: "integer"
                                    }
                                  }
                                },
                                BinWidth: {
                                  type: "structure",
                                  members: {
                                    Value: {
                                      type: "double"
                                    },
                                    BinCountLimit: {
                                      type: "long"
                                    }
                                  }
                                },
                                StartValue: {
                                  type: "double"
                                }
                              }
                            },
                            DataLabels: {
                              shape: "Sak"
                            },
                            Tooltip: {
                              shape: "Sav"
                            },
                            VisualPalette: {
                              shape: "S9l"
                            }
                          }
                        },
                        Actions: {
                          shape: "S71"
                        }
                      }
                    },
                    WordCloudVisual: {
                      type: "structure",
                      required: [
                        "VisualId"
                      ],
                      members: {
                        VisualId: {},
                        Title: {
                          shape: "S3c"
                        },
                        Subtitle: {
                          shape: "S3g"
                        },
                        ChartConfiguration: {
                          type: "structure",
                          members: {
                            FieldWells: {
                              type: "structure",
                              members: {
                                WordCloudAggregatedFieldWells: {
                                  type: "structure",
                                  members: {
                                    GroupBy: {
                                      type: "list",
                                      member: {
                                        shape: "S3o"
                                      }
                                    },
                                    Size: {
                                      type: "list",
                                      member: {
                                        shape: "S4g"
                                      }
                                    }
                                  }
                                }
                              }
                            },
                            SortConfiguration: {
                              type: "structure",
                              members: {
                                CategoryItemsLimit: {
                                  shape: "S9h"
                                },
                                CategorySort: {
                                  shape: "S9g"
                                }
                              }
                            },
                            CategoryLabelOptions: {
                              shape: "Sae"
                            },
                            WordCloudOptions: {
                              type: "structure",
                              members: {
                                WordOrientation: {},
                                WordScaling: {},
                                CloudLayout: {},
                                WordCasing: {},
                                WordPadding: {},
                                MaximumStringLength: {
                                  type: "integer"
                                }
                              }
                            }
                          }
                        },
                        Actions: {
                          shape: "S71"
                        },
                        ColumnHierarchies: {
                          shape: "Sbl"
                        }
                      }
                    },
                    InsightVisual: {
                      type: "structure",
                      required: [
                        "VisualId",
                        "DataSetIdentifier"
                      ],
                      members: {
                        VisualId: {},
                        Title: {
                          shape: "S3c"
                        },
                        Subtitle: {
                          shape: "S3g"
                        },
                        InsightConfiguration: {
                          type: "structure",
                          members: {
                            Computations: {
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  TopBottomRanked: {
                                    type: "structure",
                                    required: [
                                      "ComputationId",
                                      "Type"
                                    ],
                                    members: {
                                      ComputationId: {},
                                      Name: {},
                                      Category: {
                                        shape: "S3o"
                                      },
                                      Value: {
                                        shape: "S4g"
                                      },
                                      ResultSize: {
                                        type: "integer"
                                      },
                                      Type: {}
                                    }
                                  },
                                  TopBottomMovers: {
                                    type: "structure",
                                    required: [
                                      "ComputationId",
                                      "Type"
                                    ],
                                    members: {
                                      ComputationId: {},
                                      Name: {},
                                      Time: {
                                        shape: "S3o"
                                      },
                                      Category: {
                                        shape: "S3o"
                                      },
                                      Value: {
                                        shape: "S4g"
                                      },
                                      MoverSize: {
                                        type: "integer"
                                      },
                                      SortOrder: {},
                                      Type: {}
                                    }
                                  },
                                  TotalAggregation: {
                                    type: "structure",
                                    required: [
                                      "ComputationId"
                                    ],
                                    members: {
                                      ComputationId: {},
                                      Name: {},
                                      Value: {
                                        shape: "S4g"
                                      }
                                    }
                                  },
                                  MaximumMinimum: {
                                    type: "structure",
                                    required: [
                                      "ComputationId",
                                      "Type"
                                    ],
                                    members: {
                                      ComputationId: {},
                                      Name: {},
                                      Time: {
                                        shape: "S3o"
                                      },
                                      Value: {
                                        shape: "S4g"
                                      },
                                      Type: {}
                                    }
                                  },
                                  MetricComparison: {
                                    type: "structure",
                                    required: [
                                      "ComputationId"
                                    ],
                                    members: {
                                      ComputationId: {},
                                      Name: {},
                                      Time: {
                                        shape: "S3o"
                                      },
                                      FromValue: {
                                        shape: "S4g"
                                      },
                                      TargetValue: {
                                        shape: "S4g"
                                      }
                                    }
                                  },
                                  PeriodOverPeriod: {
                                    type: "structure",
                                    required: [
                                      "ComputationId"
                                    ],
                                    members: {
                                      ComputationId: {},
                                      Name: {},
                                      Time: {
                                        shape: "S3o"
                                      },
                                      Value: {
                                        shape: "S4g"
                                      }
                                    }
                                  },
                                  PeriodToDate: {
                                    type: "structure",
                                    required: [
                                      "ComputationId"
                                    ],
                                    members: {
                                      ComputationId: {},
                                      Name: {},
                                      Time: {
                                        shape: "S3o"
                                      },
                                      Value: {
                                        shape: "S4g"
                                      },
                                      PeriodTimeGranularity: {}
                                    }
                                  },
                                  GrowthRate: {
                                    type: "structure",
                                    required: [
                                      "ComputationId"
                                    ],
                                    members: {
                                      ComputationId: {},
                                      Name: {},
                                      Time: {
                                        shape: "S3o"
                                      },
                                      Value: {
                                        shape: "S4g"
                                      },
                                      PeriodSize: {
                                        type: "integer"
                                      }
                                    }
                                  },
                                  UniqueValues: {
                                    type: "structure",
                                    required: [
                                      "ComputationId"
                                    ],
                                    members: {
                                      ComputationId: {},
                                      Name: {},
                                      Category: {
                                        shape: "S3o"
                                      }
                                    }
                                  },
                                  Forecast: {
                                    type: "structure",
                                    required: [
                                      "ComputationId"
                                    ],
                                    members: {
                                      ComputationId: {},
                                      Name: {},
                                      Time: {
                                        shape: "S3o"
                                      },
                                      Value: {
                                        shape: "S4g"
                                      },
                                      PeriodsForward: {
                                        type: "integer"
                                      },
                                      PeriodsBackward: {
                                        type: "integer"
                                      },
                                      UpperBoundary: {
                                        type: "double"
                                      },
                                      LowerBoundary: {
                                        type: "double"
                                      },
                                      PredictionInterval: {
                                        type: "integer"
                                      },
                                      Seasonality: {},
                                      CustomSeasonalityValue: {
                                        type: "integer"
                                      }
                                    }
                                  }
                                }
                              }
                            },
                            CustomNarrative: {
                              type: "structure",
                              required: [
                                "Narrative"
                              ],
                              members: {
                                Narrative: {}
                              }
                            }
                          }
                        },
                        Actions: {
                          shape: "S71"
                        },
                        DataSetIdentifier: {}
                      }
                    },
                    SankeyDiagramVisual: {
                      type: "structure",
                      required: [
                        "VisualId"
                      ],
                      members: {
                        VisualId: {},
                        Title: {
                          shape: "S3c"
                        },
                        Subtitle: {
                          shape: "S3g"
                        },
                        ChartConfiguration: {
                          type: "structure",
                          members: {
                            FieldWells: {
                              type: "structure",
                              members: {
                                SankeyDiagramAggregatedFieldWells: {
                                  type: "structure",
                                  members: {
                                    Source: {
                                      shape: "S3n"
                                    },
                                    Destination: {
                                      shape: "S3n"
                                    },
                                    Weight: {
                                      shape: "S4f"
                                    }
                                  }
                                }
                              }
                            },
                            SortConfiguration: {
                              type: "structure",
                              members: {
                                WeightSort: {
                                  shape: "S9g"
                                },
                                SourceItemsLimit: {
                                  shape: "S9h"
                                },
                                DestinationItemsLimit: {
                                  shape: "S9h"
                                }
                              }
                            },
                            DataLabels: {
                              shape: "Sak"
                            }
                          }
                        },
                        Actions: {
                          shape: "S71"
                        }
                      }
                    },
                    CustomContentVisual: {
                      type: "structure",
                      required: [
                        "VisualId",
                        "DataSetIdentifier"
                      ],
                      members: {
                        VisualId: {},
                        Title: {
                          shape: "S3c"
                        },
                        Subtitle: {
                          shape: "S3g"
                        },
                        ChartConfiguration: {
                          type: "structure",
                          members: {
                            ContentUrl: {},
                            ContentType: {},
                            ImageScaling: {}
                          }
                        },
                        Actions: {
                          shape: "S71"
                        },
                        DataSetIdentifier: {}
                      }
                    },
                    EmptyVisual: {
                      type: "structure",
                      required: [
                        "VisualId",
                        "DataSetIdentifier"
                      ],
                      members: {
                        VisualId: {},
                        DataSetIdentifier: {},
                        Actions: {
                          shape: "S71"
                        }
                      }
                    },
                    RadarChartVisual: {
                      type: "structure",
                      required: [
                        "VisualId"
                      ],
                      members: {
                        VisualId: {},
                        Title: {
                          shape: "S3c"
                        },
                        Subtitle: {
                          shape: "S3g"
                        },
                        ChartConfiguration: {
                          type: "structure",
                          members: {
                            FieldWells: {
                              type: "structure",
                              members: {
                                RadarChartAggregatedFieldWells: {
                                  type: "structure",
                                  members: {
                                    Category: {
                                      type: "list",
                                      member: {
                                        shape: "S3o"
                                      }
                                    },
                                    Color: {
                                      type: "list",
                                      member: {
                                        shape: "S3o"
                                      }
                                    },
                                    Values: {
                                      type: "list",
                                      member: {
                                        shape: "S4g"
                                      }
                                    }
                                  }
                                }
                              }
                            },
                            SortConfiguration: {
                              type: "structure",
                              members: {
                                CategorySort: {
                                  shape: "S9g"
                                },
                                CategoryItemsLimit: {
                                  shape: "S9h"
                                },
                                ColorSort: {
                                  shape: "S9g"
                                },
                                ColorItemsLimit: {
                                  shape: "S9h"
                                }
                              }
                            },
                            Shape: {},
                            BaseSeriesSettings: {
                              type: "structure",
                              members: {
                                AreaStyleSettings: {
                                  type: "structure",
                                  members: {
                                    Visibility: {}
                                  }
                                }
                              }
                            },
                            StartAngle: {
                              type: "double"
                            },
                            VisualPalette: {
                              shape: "S9l"
                            },
                            AlternateBandColorsVisibility: {},
                            AlternateBandEvenColor: {},
                            AlternateBandOddColor: {},
                            CategoryAxis: {
                              shape: "S9y"
                            },
                            CategoryLabelOptions: {
                              shape: "Sae"
                            },
                            ColorAxis: {
                              shape: "S9y"
                            },
                            ColorLabelOptions: {
                              shape: "Sae"
                            },
                            Legend: {
                              shape: "Sai"
                            },
                            AxesRangeScale: {}
                          }
                        },
                        Actions: {
                          shape: "S71"
                        },
                        ColumnHierarchies: {
                          shape: "Sbl"
                        }
                      }
                    }
                  }
                }
              },
              TextBoxes: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "SheetTextBoxId"
                  ],
                  members: {
                    SheetTextBoxId: {},
                    Content: {}
                  }
                }
              },
              Layouts: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Configuration"
                  ],
                  members: {
                    Configuration: {
                      type: "structure",
                      members: {
                        GridLayout: {
                          shape: "Sit"
                        },
                        FreeFormLayout: {
                          type: "structure",
                          required: [
                            "Elements"
                          ],
                          members: {
                            Elements: {
                              shape: "Sj5"
                            },
                            CanvasSizeOptions: {
                              shape: "Sje"
                            }
                          }
                        },
                        SectionBasedLayout: {
                          type: "structure",
                          required: [
                            "HeaderSections",
                            "BodySections",
                            "FooterSections",
                            "CanvasSizeOptions"
                          ],
                          members: {
                            HeaderSections: {
                              shape: "Sjh"
                            },
                            BodySections: {
                              type: "list",
                              member: {
                                type: "structure",
                                required: [
                                  "SectionId",
                                  "Content"
                                ],
                                members: {
                                  SectionId: {},
                                  Content: {
                                    type: "structure",
                                    members: {
                                      Layout: {
                                        shape: "Sjj"
                                      }
                                    }
                                  },
                                  Style: {
                                    shape: "Sjl"
                                  },
                                  PageBreakConfiguration: {
                                    type: "structure",
                                    members: {
                                      After: {
                                        type: "structure",
                                        members: {
                                          Status: {}
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            },
                            FooterSections: {
                              shape: "Sjh"
                            },
                            CanvasSizeOptions: {
                              shape: "Sju"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              SheetControlLayouts: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Configuration"
                  ],
                  members: {
                    Configuration: {
                      type: "structure",
                      members: {
                        GridLayout: {
                          shape: "Sit"
                        }
                      }
                    }
                  }
                }
              },
              ContentType: {}
            }
          }
        },
        S1v: {
          type: "structure",
          members: {
            TitleOptions: {
              shape: "S1w"
            },
            DateTimeFormat: {},
            InfoIconLabelOptions: {
              shape: "S27"
            }
          }
        },
        S1w: {
          type: "structure",
          members: {
            Visibility: {},
            FontConfiguration: {
              shape: "S1y"
            },
            CustomLabel: {}
          }
        },
        S1y: {
          type: "structure",
          members: {
            FontSize: {
              type: "structure",
              members: {
                Relative: {}
              }
            },
            FontDecoration: {},
            FontColor: {},
            FontWeight: {
              type: "structure",
              members: {
                Name: {}
              }
            },
            FontStyle: {}
          }
        },
        S27: {
          type: "structure",
          members: {
            Visibility: {},
            InfoIconText: {}
          }
        },
        S2a: {
          type: "structure",
          members: {
            SearchOptions: {
              type: "structure",
              members: {
                Visibility: {}
              }
            },
            SelectAllOptions: {
              shape: "S2c"
            },
            TitleOptions: {
              shape: "S1w"
            },
            InfoIconLabelOptions: {
              shape: "S27"
            }
          }
        },
        S2c: {
          type: "structure",
          members: {
            Visibility: {}
          }
        },
        S2e: {
          type: "structure",
          members: {
            Values: {
              shape: "S2f"
            },
            LinkToDataSetColumn: {
              shape: "S2g"
            }
          }
        },
        S2f: {
          type: "list",
          member: {}
        },
        S2g: {
          type: "structure",
          required: [
            "DataSetIdentifier",
            "ColumnName"
          ],
          members: {
            DataSetIdentifier: {},
            ColumnName: {}
          }
        },
        S2i: {
          type: "structure",
          members: {
            SourceControls: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  SourceSheetControlId: {},
                  ColumnToMatch: {
                    shape: "S2g"
                  }
                }
              }
            }
          }
        },
        S2m: {
          type: "structure",
          members: {
            SelectAllOptions: {
              shape: "S2c"
            },
            TitleOptions: {
              shape: "S1w"
            },
            InfoIconLabelOptions: {
              shape: "S27"
            }
          }
        },
        S2o: {
          type: "structure",
          members: {
            TitleOptions: {
              shape: "S1w"
            },
            PlaceholderOptions: {
              shape: "S2p"
            },
            InfoIconLabelOptions: {
              shape: "S27"
            }
          }
        },
        S2p: {
          type: "structure",
          members: {
            Visibility: {}
          }
        },
        S2s: {
          type: "structure",
          members: {
            TitleOptions: {
              shape: "S1w"
            },
            PlaceholderOptions: {
              shape: "S2p"
            },
            InfoIconLabelOptions: {
              shape: "S27"
            }
          }
        },
        S2u: {
          type: "structure",
          members: {
            TitleOptions: {
              shape: "S1w"
            },
            InfoIconLabelOptions: {
              shape: "S27"
            }
          }
        },
        S31: {
          type: "structure",
          members: {
            Values: {
              shape: "S2f"
            }
          }
        },
        S3c: {
          type: "structure",
          members: {
            Visibility: {},
            FormatText: {
              type: "structure",
              members: {
                PlainText: {},
                RichText: {}
              }
            }
          }
        },
        S3g: {
          type: "structure",
          members: {
            Visibility: {},
            FormatText: {
              type: "structure",
              members: {
                PlainText: {},
                RichText: {}
              }
            }
          }
        },
        S3n: {
          type: "list",
          member: {
            shape: "S3o"
          }
        },
        S3o: {
          type: "structure",
          members: {
            NumericalDimensionField: {
              type: "structure",
              required: [
                "FieldId",
                "Column"
              ],
              members: {
                FieldId: {},
                Column: {
                  shape: "S2g"
                },
                HierarchyId: {},
                FormatConfiguration: {
                  shape: "S3s"
                }
              }
            },
            CategoricalDimensionField: {
              type: "structure",
              required: [
                "FieldId",
                "Column"
              ],
              members: {
                FieldId: {},
                Column: {
                  shape: "S2g"
                },
                HierarchyId: {},
                FormatConfiguration: {
                  shape: "S4b"
                }
              }
            },
            DateDimensionField: {
              type: "structure",
              required: [
                "FieldId",
                "Column"
              ],
              members: {
                FieldId: {},
                Column: {
                  shape: "S2g"
                },
                DateGranularity: {},
                HierarchyId: {},
                FormatConfiguration: {
                  shape: "S4e"
                }
              }
            }
          }
        },
        S3s: {
          type: "structure",
          members: {
            FormatConfiguration: {
              shape: "S3t"
            }
          }
        },
        S3t: {
          type: "structure",
          members: {
            NumberDisplayFormatConfiguration: {
              shape: "S3u"
            },
            CurrencyDisplayFormatConfiguration: {
              type: "structure",
              members: {
                Prefix: {
                  shape: "S3v"
                },
                Suffix: {
                  shape: "S3w"
                },
                SeparatorConfiguration: {
                  shape: "S3x"
                },
                Symbol: {},
                DecimalPlacesConfiguration: {
                  shape: "S40"
                },
                NumberScale: {},
                NegativeValueConfiguration: {
                  shape: "S43"
                },
                NullValueFormatConfiguration: {
                  shape: "S45"
                }
              }
            },
            PercentageDisplayFormatConfiguration: {
              shape: "S49"
            }
          }
        },
        S3u: {
          type: "structure",
          members: {
            Prefix: {
              shape: "S3v"
            },
            Suffix: {
              shape: "S3w"
            },
            SeparatorConfiguration: {
              shape: "S3x"
            },
            DecimalPlacesConfiguration: {
              shape: "S40"
            },
            NumberScale: {},
            NegativeValueConfiguration: {
              shape: "S43"
            },
            NullValueFormatConfiguration: {
              shape: "S45"
            }
          }
        },
        S3v: {
          type: "string",
          sensitive: true
        },
        S3w: {
          type: "string",
          sensitive: true
        },
        S3x: {
          type: "structure",
          members: {
            DecimalSeparator: {},
            ThousandsSeparator: {
              type: "structure",
              members: {
                Symbol: {},
                Visibility: {}
              }
            }
          }
        },
        S40: {
          type: "structure",
          required: [
            "DecimalPlaces"
          ],
          members: {
            DecimalPlaces: {
              type: "long"
            }
          }
        },
        S43: {
          type: "structure",
          required: [
            "DisplayMode"
          ],
          members: {
            DisplayMode: {}
          }
        },
        S45: {
          type: "structure",
          required: [
            "NullString"
          ],
          members: {
            NullString: {
              type: "string",
              sensitive: true
            }
          }
        },
        S49: {
          type: "structure",
          members: {
            Prefix: {
              shape: "S3v"
            },
            Suffix: {
              shape: "S3w"
            },
            SeparatorConfiguration: {
              shape: "S3x"
            },
            DecimalPlacesConfiguration: {
              shape: "S40"
            },
            NegativeValueConfiguration: {
              shape: "S43"
            },
            NullValueFormatConfiguration: {
              shape: "S45"
            }
          }
        },
        S4b: {
          type: "structure",
          members: {
            NullValueFormatConfiguration: {
              shape: "S45"
            },
            NumericFormatConfiguration: {
              shape: "S3t"
            }
          }
        },
        S4e: {
          type: "structure",
          members: {
            DateTimeFormat: {},
            NullValueFormatConfiguration: {
              shape: "S45"
            },
            NumericFormatConfiguration: {
              shape: "S3t"
            }
          }
        },
        S4f: {
          type: "list",
          member: {
            shape: "S4g"
          }
        },
        S4g: {
          type: "structure",
          members: {
            NumericalMeasureField: {
              type: "structure",
              required: [
                "FieldId",
                "Column"
              ],
              members: {
                FieldId: {},
                Column: {
                  shape: "S2g"
                },
                AggregationFunction: {
                  shape: "S4i"
                },
                FormatConfiguration: {
                  shape: "S3s"
                }
              }
            },
            CategoricalMeasureField: {
              type: "structure",
              required: [
                "FieldId",
                "Column"
              ],
              members: {
                FieldId: {},
                Column: {
                  shape: "S2g"
                },
                AggregationFunction: {},
                FormatConfiguration: {
                  shape: "S4b"
                }
              }
            },
            DateMeasureField: {
              type: "structure",
              required: [
                "FieldId",
                "Column"
              ],
              members: {
                FieldId: {},
                Column: {
                  shape: "S2g"
                },
                AggregationFunction: {},
                FormatConfiguration: {
                  shape: "S4e"
                }
              }
            },
            CalculatedMeasureField: {
              type: "structure",
              required: [
                "FieldId",
                "Expression"
              ],
              members: {
                FieldId: {},
                Expression: {
                  shape: "S4r"
                }
              }
            }
          }
        },
        S4i: {
          type: "structure",
          members: {
            SimpleNumericalAggregation: {},
            PercentileAggregation: {
              type: "structure",
              members: {
                PercentileValue: {
                  type: "double"
                }
              }
            }
          }
        },
        S4r: {
          type: "string",
          sensitive: true
        },
        S4v: {
          type: "structure",
          members: {
            StringFormatConfiguration: {
              shape: "S4b"
            },
            NumberFormatConfiguration: {
              shape: "S3s"
            },
            DateTimeFormatConfiguration: {
              shape: "S4e"
            }
          }
        },
        S4y: {
          type: "structure",
          members: {
            FieldSort: {
              shape: "S4z"
            },
            ColumnSort: {
              shape: "S51"
            }
          }
        },
        S4z: {
          type: "structure",
          required: [
            "FieldId",
            "Direction"
          ],
          members: {
            FieldId: {},
            Direction: {}
          }
        },
        S51: {
          type: "structure",
          required: [
            "SortBy",
            "Direction"
          ],
          members: {
            SortBy: {
              shape: "S2g"
            },
            Direction: {},
            AggregationFunction: {
              shape: "S52"
            }
          }
        },
        S52: {
          type: "structure",
          members: {
            NumericalAggregationFunction: {
              shape: "S4i"
            },
            CategoricalAggregationFunction: {},
            DateAggregationFunction: {},
            AttributeAggregationFunction: {
              type: "structure",
              members: {
                SimpleAttributeAggregation: {},
                ValueForMultipleValues: {}
              }
            }
          }
        },
        S55: {
          type: "structure",
          required: [
            "PageSize",
            "PageNumber"
          ],
          members: {
            PageSize: {
              type: "long"
            },
            PageNumber: {
              type: "long"
            }
          }
        },
        S5a: {
          type: "structure",
          members: {
            Visibility: {},
            FontConfiguration: {
              shape: "S1y"
            },
            TextWrap: {},
            HorizontalTextAlignment: {},
            VerticalTextAlignment: {},
            BackgroundColor: {},
            Height: {
              type: "integer"
            },
            Border: {
              type: "structure",
              members: {
                UniformBorder: {
                  shape: "S5g"
                },
                SideSpecificBorder: {
                  type: "structure",
                  members: {
                    InnerVertical: {
                      shape: "S5g"
                    },
                    InnerHorizontal: {
                      shape: "S5g"
                    },
                    Left: {
                      shape: "S5g"
                    },
                    Right: {
                      shape: "S5g"
                    },
                    Top: {
                      shape: "S5g"
                    },
                    Bottom: {
                      shape: "S5g"
                    }
                  }
                }
              }
            }
          }
        },
        S5g: {
          type: "structure",
          members: {
            Color: {},
            Thickness: {
              type: "integer"
            },
            Style: {}
          }
        },
        S5k: {
          type: "structure",
          members: {
            Status: {},
            RowAlternateColors: {
              type: "list",
              member: {}
            },
            UsePrimaryBackgroundColor: {}
          }
        },
        S5q: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "FieldId",
              "TotalAggregationFunction"
            ],
            members: {
              FieldId: {},
              TotalAggregationFunction: {
                type: "structure",
                members: {
                  SimpleTotalAggregationFunction: {}
                }
              }
            }
          }
        },
        S6k: {
          type: "structure",
          members: {
            BackgroundColor: {
              shape: "S6l"
            },
            TextColor: {
              shape: "S6l"
            },
            Icon: {
              shape: "S6r"
            }
          }
        },
        S6l: {
          type: "structure",
          members: {
            Solid: {
              type: "structure",
              required: [
                "Expression"
              ],
              members: {
                Expression: {
                  shape: "S4r"
                },
                Color: {}
              }
            },
            Gradient: {
              type: "structure",
              required: [
                "Expression",
                "Color"
              ],
              members: {
                Expression: {
                  shape: "S4r"
                },
                Color: {
                  type: "structure",
                  members: {
                    Stops: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "GradientOffset"
                        ],
                        members: {
                          GradientOffset: {
                            type: "double"
                          },
                          DataValue: {
                            type: "double"
                          },
                          Color: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S6r: {
          type: "structure",
          members: {
            IconSet: {
              type: "structure",
              required: [
                "Expression"
              ],
              members: {
                Expression: {
                  shape: "S4r"
                },
                IconSetType: {}
              }
            },
            CustomCondition: {
              type: "structure",
              required: [
                "Expression",
                "IconOptions"
              ],
              members: {
                Expression: {
                  shape: "S4r"
                },
                IconOptions: {
                  type: "structure",
                  members: {
                    Icon: {},
                    UnicodeIcon: {}
                  }
                },
                Color: {},
                DisplayConfiguration: {
                  type: "structure",
                  members: {
                    IconDisplayOption: {}
                  }
                }
              }
            }
          }
        },
        S71: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "CustomActionId",
              "Name",
              "Trigger",
              "ActionOperations"
            ],
            members: {
              CustomActionId: {},
              Name: {},
              Status: {},
              Trigger: {},
              ActionOperations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FilterOperation: {
                      type: "structure",
                      required: [
                        "SelectedFieldsConfiguration",
                        "TargetVisualsConfiguration"
                      ],
                      members: {
                        SelectedFieldsConfiguration: {
                          type: "structure",
                          members: {
                            SelectedFields: {
                              type: "list",
                              member: {}
                            },
                            SelectedFieldOptions: {},
                            SelectedColumns: {
                              type: "list",
                              member: {
                                shape: "S2g"
                              }
                            }
                          }
                        },
                        TargetVisualsConfiguration: {
                          type: "structure",
                          members: {
                            SameSheetTargetVisualConfiguration: {
                              type: "structure",
                              members: {
                                TargetVisuals: {
                                  type: "list",
                                  member: {}
                                },
                                TargetVisualOptions: {}
                              }
                            }
                          }
                        }
                      }
                    },
                    NavigationOperation: {
                      type: "structure",
                      members: {
                        LocalNavigationConfiguration: {
                          type: "structure",
                          required: [
                            "TargetSheetId"
                          ],
                          members: {
                            TargetSheetId: {}
                          }
                        }
                      }
                    },
                    URLOperation: {
                      type: "structure",
                      required: [
                        "URLTemplate",
                        "URLTarget"
                      ],
                      members: {
                        URLTemplate: {},
                        URLTarget: {}
                      }
                    },
                    SetParametersOperation: {
                      type: "structure",
                      required: [
                        "ParameterValueConfigurations"
                      ],
                      members: {
                        ParameterValueConfigurations: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "DestinationParameterName",
                              "Value"
                            ],
                            members: {
                              DestinationParameterName: {},
                              Value: {
                                type: "structure",
                                members: {
                                  CustomValuesConfiguration: {
                                    type: "structure",
                                    required: [
                                      "CustomValues"
                                    ],
                                    members: {
                                      IncludeNullValue: {
                                        type: "boolean"
                                      },
                                      CustomValues: {
                                        type: "structure",
                                        members: {
                                          StringValues: {
                                            shape: "S7r"
                                          },
                                          IntegerValues: {
                                            shape: "S7t"
                                          },
                                          DecimalValues: {
                                            shape: "S7v"
                                          },
                                          DateTimeValues: {
                                            shape: "S7x"
                                          }
                                        }
                                      }
                                    }
                                  },
                                  SelectAllValueOptions: {},
                                  SourceParameterName: {},
                                  SourceField: {},
                                  SourceColumn: {
                                    shape: "S2g"
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S7r: {
          type: "list",
          member: {
            type: "string",
            sensitive: true
          }
        },
        S7t: {
          type: "list",
          member: {
            type: "long",
            sensitive: true
          }
        },
        S7v: {
          type: "list",
          member: {
            type: "double",
            sensitive: true
          }
        },
        S7x: {
          type: "list",
          member: {
            shape: "S18"
          }
        },
        S83: {
          type: "list",
          member: {
            shape: "S3o"
          }
        },
        S8a: {
          type: "list",
          member: {
            shape: "S8b"
          }
        },
        S8b: {
          type: "structure",
          members: {
            FieldId: {},
            FieldValue: {
              shape: "S8c"
            },
            DataPathType: {
              type: "structure",
              members: {
                PivotTableDataPathType: {}
              }
            }
          }
        },
        S8c: {
          type: "string",
          sensitive: true
        },
        S8l: {
          type: "structure",
          members: {
            TotalsVisibility: {},
            CustomLabel: {},
            FieldLevel: {},
            FieldLevelOptions: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  FieldId: {}
                }
              }
            },
            TotalCellStyle: {
              shape: "S5a"
            },
            ValueCellStyle: {
              shape: "S5a"
            },
            MetricHeaderCellStyle: {
              shape: "S5a"
            },
            StyleTargets: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "CellType"
                ],
                members: {
                  CellType: {}
                }
              }
            }
          }
        },
        S8s: {
          type: "structure",
          members: {
            TotalsVisibility: {},
            Placement: {},
            ScrollStatus: {},
            CustomLabel: {},
            TotalCellStyle: {
              shape: "S5a"
            },
            ValueCellStyle: {
              shape: "S5a"
            },
            MetricHeaderCellStyle: {
              shape: "S5a"
            },
            TotalAggregationOptions: {
              shape: "S5q"
            }
          }
        },
        S97: {
          type: "structure",
          members: {
            Role: {}
          }
        },
        S9e: {
          type: "list",
          member: {
            shape: "S3o"
          }
        },
        S9g: {
          type: "list",
          member: {
            shape: "S4y"
          }
        },
        S9h: {
          type: "structure",
          members: {
            ItemsLimit: {
              type: "long"
            },
            OtherCategories: {}
          }
        },
        S9l: {
          type: "structure",
          members: {
            ChartColor: {},
            ColorMap: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Element",
                  "Color"
                ],
                members: {
                  Element: {
                    shape: "S8b"
                  },
                  Color: {},
                  TimeGranularity: {}
                }
              }
            }
          }
        },
        S9o: {
          type: "structure",
          members: {
            MaxVisibleRows: {
              type: "long"
            },
            MaxVisibleColumns: {
              type: "long"
            },
            PanelConfiguration: {
              type: "structure",
              members: {
                Title: {
                  type: "structure",
                  members: {
                    Visibility: {},
                    FontConfiguration: {
                      shape: "S1y"
                    },
                    HorizontalTextAlignment: {}
                  }
                },
                BorderVisibility: {},
                BorderThickness: {},
                BorderStyle: {},
                BorderColor: {},
                GutterVisibility: {},
                GutterSpacing: {},
                BackgroundVisibility: {},
                BackgroundColor: {}
              }
            },
            XAxis: {
              shape: "S9v"
            },
            YAxis: {
              shape: "S9v"
            }
          }
        },
        S9v: {
          type: "structure",
          members: {
            Scale: {},
            Placement: {}
          }
        },
        S9y: {
          type: "structure",
          members: {
            TickLabelOptions: {
              type: "structure",
              members: {
                LabelOptions: {
                  shape: "S1w"
                },
                RotationAngle: {
                  type: "double"
                }
              }
            },
            AxisLineVisibility: {},
            GridLineVisibility: {},
            DataOptions: {
              type: "structure",
              members: {
                NumericAxisOptions: {
                  type: "structure",
                  members: {
                    Scale: {
                      type: "structure",
                      members: {
                        Linear: {
                          type: "structure",
                          members: {
                            StepCount: {
                              type: "integer"
                            },
                            StepSize: {
                              type: "double"
                            }
                          }
                        },
                        Logarithmic: {
                          type: "structure",
                          members: {
                            Base: {
                              type: "double"
                            }
                          }
                        }
                      }
                    },
                    Range: {
                      type: "structure",
                      members: {
                        MinMax: {
                          type: "structure",
                          members: {
                            Minimum: {
                              type: "double"
                            },
                            Maximum: {
                              type: "double"
                            }
                          }
                        },
                        DataDriven: {
                          type: "structure",
                          members: {}
                        }
                      }
                    }
                  }
                },
                DateAxisOptions: {
                  type: "structure",
                  members: {
                    MissingDateVisibility: {}
                  }
                }
              }
            },
            ScrollbarOptions: {
              type: "structure",
              members: {
                Visibility: {},
                VisibleRange: {
                  type: "structure",
                  members: {
                    PercentRange: {
                      type: "structure",
                      members: {
                        From: {
                          type: "double"
                        },
                        To: {
                          type: "double"
                        }
                      }
                    }
                  }
                }
              }
            },
            AxisOffset: {}
          }
        },
        Sae: {
          type: "structure",
          members: {
            Visibility: {},
            SortIconVisibility: {},
            AxisLabelOptions: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  FontConfiguration: {
                    shape: "S1y"
                  },
                  CustomLabel: {},
                  ApplyTo: {
                    type: "structure",
                    required: [
                      "FieldId",
                      "Column"
                    ],
                    members: {
                      FieldId: {},
                      Column: {
                        shape: "S2g"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sai: {
          type: "structure",
          members: {
            Visibility: {},
            Title: {
              shape: "S1w"
            },
            Position: {},
            Width: {},
            Height: {}
          }
        },
        Sak: {
          type: "structure",
          members: {
            Visibility: {},
            CategoryLabelVisibility: {},
            MeasureLabelVisibility: {},
            DataLabelTypes: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  FieldLabelType: {
                    type: "structure",
                    members: {
                      FieldId: {},
                      Visibility: {}
                    }
                  },
                  DataPathLabelType: {
                    type: "structure",
                    members: {
                      FieldId: {},
                      FieldValue: {
                        shape: "S8c"
                      },
                      Visibility: {}
                    }
                  },
                  RangeEndsLabelType: {
                    type: "structure",
                    members: {
                      Visibility: {}
                    }
                  },
                  MinimumLabelType: {
                    type: "structure",
                    members: {
                      Visibility: {}
                    }
                  },
                  MaximumLabelType: {
                    type: "structure",
                    members: {
                      Visibility: {}
                    }
                  }
                }
              }
            },
            Position: {},
            LabelContent: {},
            LabelFontConfiguration: {
              shape: "S1y"
            },
            LabelColor: {},
            Overlap: {},
            TotalsVisibility: {}
          }
        },
        Sav: {
          type: "structure",
          members: {
            TooltipVisibility: {},
            SelectedTooltipType: {},
            FieldBasedTooltip: {
              type: "structure",
              members: {
                AggregationVisibility: {},
                TooltipTitleType: {},
                TooltipFields: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      FieldTooltipItem: {
                        type: "structure",
                        required: [
                          "FieldId"
                        ],
                        members: {
                          FieldId: {},
                          Label: {},
                          Visibility: {}
                        }
                      },
                      ColumnTooltipItem: {
                        type: "structure",
                        required: [
                          "Column"
                        ],
                        members: {
                          Column: {
                            shape: "S2g"
                          },
                          Label: {},
                          Visibility: {},
                          Aggregation: {
                            shape: "S52"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sb3: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "DataConfiguration"
            ],
            members: {
              Status: {},
              DataConfiguration: {
                type: "structure",
                members: {
                  StaticConfiguration: {
                    type: "structure",
                    required: [
                      "Value"
                    ],
                    members: {
                      Value: {
                        shape: "S14"
                      }
                    }
                  },
                  DynamicConfiguration: {
                    type: "structure",
                    required: [
                      "Column",
                      "Calculation"
                    ],
                    members: {
                      Column: {
                        shape: "S2g"
                      },
                      MeasureAggregationFunction: {
                        shape: "S52"
                      },
                      Calculation: {
                        shape: "S4i"
                      }
                    }
                  },
                  AxisBinding: {},
                  SeriesType: {}
                }
              },
              StyleConfiguration: {
                type: "structure",
                members: {
                  Pattern: {},
                  Color: {}
                }
              },
              LabelConfiguration: {
                type: "structure",
                members: {
                  ValueLabelConfiguration: {
                    type: "structure",
                    members: {
                      RelativePosition: {},
                      FormatConfiguration: {
                        shape: "S3t"
                      }
                    }
                  },
                  CustomLabelConfiguration: {
                    type: "structure",
                    required: [
                      "CustomLabel"
                    ],
                    members: {
                      CustomLabel: {}
                    }
                  },
                  FontConfiguration: {
                    shape: "S1y"
                  },
                  FontColor: {},
                  HorizontalPosition: {},
                  VerticalPosition: {}
                }
              }
            }
          }
        },
        Sbi: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "MeasureFieldId",
              "ContributorDimensions"
            ],
            members: {
              MeasureFieldId: {},
              ContributorDimensions: {
                type: "list",
                member: {
                  shape: "S2g"
                }
              }
            }
          }
        },
        Sbl: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ExplicitHierarchy: {
                type: "structure",
                required: [
                  "HierarchyId",
                  "Columns"
                ],
                members: {
                  HierarchyId: {},
                  Columns: {
                    type: "list",
                    member: {
                      shape: "S2g"
                    }
                  },
                  DrillDownFilters: {
                    shape: "Sbp"
                  }
                }
              },
              DateTimeHierarchy: {
                type: "structure",
                required: [
                  "HierarchyId"
                ],
                members: {
                  HierarchyId: {},
                  DrillDownFilters: {
                    shape: "Sbp"
                  }
                }
              },
              PredefinedHierarchy: {
                type: "structure",
                required: [
                  "HierarchyId",
                  "Columns"
                ],
                members: {
                  HierarchyId: {},
                  Columns: {
                    type: "list",
                    member: {
                      shape: "S2g"
                    }
                  },
                  DrillDownFilters: {
                    shape: "Sbp"
                  }
                }
              }
            }
          }
        },
        Sbp: {
          type: "list",
          member: {
            type: "structure",
            members: {
              NumericEqualityFilter: {
                type: "structure",
                required: [
                  "Column",
                  "Value"
                ],
                members: {
                  Column: {
                    shape: "S2g"
                  },
                  Value: {
                    type: "double"
                  }
                }
              },
              CategoryFilter: {
                type: "structure",
                required: [
                  "Column",
                  "CategoryValues"
                ],
                members: {
                  Column: {
                    shape: "S2g"
                  },
                  CategoryValues: {
                    shape: "Sbt"
                  }
                }
              },
              TimeRangeFilter: {
                type: "structure",
                required: [
                  "Column",
                  "RangeMinimum",
                  "RangeMaximum",
                  "TimeGranularity"
                ],
                members: {
                  Column: {
                    shape: "S2g"
                  },
                  RangeMinimum: {
                    type: "timestamp"
                  },
                  RangeMaximum: {
                    type: "timestamp"
                  },
                  TimeGranularity: {}
                }
              }
            }
          }
        },
        Sbt: {
          type: "list",
          member: {}
        },
        Sc8: {
          type: "structure",
          members: {
            ComparisonMethod: {},
            ComparisonFormat: {
              type: "structure",
              members: {
                NumberDisplayFormatConfiguration: {
                  shape: "S3u"
                },
                PercentageDisplayFormatConfiguration: {
                  shape: "S49"
                }
              }
            }
          }
        },
        Sdq: {
          type: "structure",
          members: {
            AxisOptions: {
              shape: "S9y"
            },
            MissingDataConfigurations: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  TreatmentOption: {}
                }
              }
            }
          }
        },
        Sdu: {
          type: "structure",
          members: {
            YAxisOptions: {
              type: "structure",
              required: [
                "YAxis"
              ],
              members: {
                YAxis: {}
              }
            }
          }
        },
        Sdy: {
          type: "structure",
          members: {
            LineVisibility: {},
            LineInterpolation: {},
            LineStyle: {},
            LineWidth: {}
          }
        },
        Se1: {
          type: "structure",
          members: {
            MarkerVisibility: {},
            MarkerShape: {},
            MarkerSize: {},
            MarkerColor: {}
          }
        },
        Se6: {
          type: "structure",
          members: {
            LineStyleSettings: {
              shape: "Sdy"
            },
            MarkerStyleSettings: {
              shape: "Se1"
            }
          }
        },
        Sec: {
          type: "list",
          member: {
            shape: "S3o"
          }
        },
        Sef: {
          type: "structure",
          required: [
            "Colors",
            "ColorFillType"
          ],
          members: {
            Colors: {
              type: "list",
              member: {
                shape: "Seh"
              }
            },
            ColorFillType: {},
            NullValueColor: {
              shape: "Seh"
            }
          }
        },
        Seh: {
          type: "structure",
          members: {
            Color: {},
            DataValue: {
              type: "double"
            }
          }
        },
        Seo: {
          type: "list",
          member: {
            shape: "S4g"
          }
        },
        Seu: {
          type: "structure",
          members: {
            Bounds: {
              type: "structure",
              required: [
                "North",
                "South",
                "West",
                "East"
              ],
              members: {
                North: {
                  type: "double"
                },
                South: {
                  type: "double"
                },
                West: {
                  type: "double"
                },
                East: {
                  type: "double"
                }
              }
            },
            MapZoomMode: {}
          }
        },
        Sez: {
          type: "structure",
          members: {
            BaseMapStyle: {}
          }
        },
        Sit: {
          type: "structure",
          required: [
            "Elements"
          ],
          members: {
            Elements: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "ElementId",
                  "ElementType",
                  "ColumnSpan",
                  "RowSpan"
                ],
                members: {
                  ElementId: {},
                  ElementType: {},
                  ColumnIndex: {
                    type: "integer"
                  },
                  ColumnSpan: {
                    type: "integer"
                  },
                  RowIndex: {
                    type: "integer"
                  },
                  RowSpan: {
                    type: "integer"
                  }
                }
              }
            },
            CanvasSizeOptions: {
              shape: "Sj1"
            }
          }
        },
        Sj1: {
          type: "structure",
          members: {
            ScreenCanvasSizeOptions: {
              type: "structure",
              required: [
                "ResizeOption"
              ],
              members: {
                ResizeOption: {},
                OptimizedViewPortWidth: {}
              }
            }
          }
        },
        Sj5: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ElementId",
              "ElementType",
              "XAxisLocation",
              "YAxisLocation",
              "Width",
              "Height"
            ],
            members: {
              ElementId: {},
              ElementType: {},
              XAxisLocation: {},
              YAxisLocation: {},
              Width: {},
              Height: {},
              Visibility: {},
              RenderingRules: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Expression",
                    "ConfigurationOverrides"
                  ],
                  members: {
                    Expression: {
                      shape: "S4r"
                    },
                    ConfigurationOverrides: {
                      type: "structure",
                      members: {
                        Visibility: {}
                      }
                    }
                  }
                }
              },
              BorderStyle: {
                shape: "Sjb"
              },
              SelectedBorderStyle: {
                shape: "Sjb"
              },
              BackgroundStyle: {
                type: "structure",
                members: {
                  Visibility: {},
                  Color: {}
                }
              },
              LoadingAnimation: {
                type: "structure",
                members: {
                  Visibility: {}
                }
              }
            }
          }
        },
        Sjb: {
          type: "structure",
          members: {
            Visibility: {},
            Color: {}
          }
        },
        Sje: {
          type: "structure",
          members: {
            ScreenCanvasSizeOptions: {
              type: "structure",
              required: [
                "OptimizedViewPortWidth"
              ],
              members: {
                OptimizedViewPortWidth: {}
              }
            }
          }
        },
        Sjh: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "SectionId",
              "Layout"
            ],
            members: {
              SectionId: {},
              Layout: {
                shape: "Sjj"
              },
              Style: {
                shape: "Sjl"
              }
            }
          }
        },
        Sjj: {
          type: "structure",
          required: [
            "FreeFormLayout"
          ],
          members: {
            FreeFormLayout: {
              type: "structure",
              required: [
                "Elements"
              ],
              members: {
                Elements: {
                  shape: "Sj5"
                }
              }
            }
          }
        },
        Sjl: {
          type: "structure",
          members: {
            Height: {},
            Padding: {
              shape: "Sjm"
            }
          }
        },
        Sjm: {
          type: "structure",
          members: {
            Top: {},
            Bottom: {},
            Left: {},
            Right: {}
          }
        },
        Sju: {
          type: "structure",
          members: {
            PaperCanvasSizeOptions: {
              type: "structure",
              members: {
                PaperSize: {},
                PaperOrientation: {},
                PaperMargin: {
                  shape: "Sjm"
                }
              }
            }
          }
        },
        Sk2: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "DataSetIdentifier",
              "Name",
              "Expression"
            ],
            members: {
              DataSetIdentifier: {},
              Name: {},
              Expression: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        Sk5: {
          type: "list",
          member: {
            type: "structure",
            members: {
              StringParameterDeclaration: {
                type: "structure",
                required: [
                  "ParameterValueType",
                  "Name"
                ],
                members: {
                  ParameterValueType: {},
                  Name: {},
                  DefaultValues: {
                    type: "structure",
                    members: {
                      DynamicValue: {
                        shape: "Ska"
                      },
                      StaticValues: {
                        shape: "S7r"
                      }
                    }
                  },
                  ValueWhenUnset: {
                    type: "structure",
                    members: {
                      ValueWhenUnsetOption: {},
                      CustomValue: {
                        shape: "Sw"
                      }
                    }
                  },
                  MappedDataSetParameters: {
                    shape: "Skd"
                  }
                }
              },
              DecimalParameterDeclaration: {
                type: "structure",
                required: [
                  "ParameterValueType",
                  "Name"
                ],
                members: {
                  ParameterValueType: {},
                  Name: {},
                  DefaultValues: {
                    type: "structure",
                    members: {
                      DynamicValue: {
                        shape: "Ska"
                      },
                      StaticValues: {
                        shape: "S7v"
                      }
                    }
                  },
                  ValueWhenUnset: {
                    type: "structure",
                    members: {
                      ValueWhenUnsetOption: {},
                      CustomValue: {
                        shape: "S14"
                      }
                    }
                  },
                  MappedDataSetParameters: {
                    shape: "Skd"
                  }
                }
              },
              IntegerParameterDeclaration: {
                type: "structure",
                required: [
                  "ParameterValueType",
                  "Name"
                ],
                members: {
                  ParameterValueType: {},
                  Name: {},
                  DefaultValues: {
                    type: "structure",
                    members: {
                      DynamicValue: {
                        shape: "Ska"
                      },
                      StaticValues: {
                        shape: "S7t"
                      }
                    }
                  },
                  ValueWhenUnset: {
                    type: "structure",
                    members: {
                      ValueWhenUnsetOption: {},
                      CustomValue: {
                        shape: "S10"
                      }
                    }
                  },
                  MappedDataSetParameters: {
                    shape: "Skd"
                  }
                }
              },
              DateTimeParameterDeclaration: {
                type: "structure",
                required: [
                  "Name"
                ],
                members: {
                  Name: {},
                  DefaultValues: {
                    type: "structure",
                    members: {
                      DynamicValue: {
                        shape: "Ska"
                      },
                      StaticValues: {
                        shape: "S7x"
                      },
                      RollingDate: {
                        shape: "Skn"
                      }
                    }
                  },
                  TimeGranularity: {},
                  ValueWhenUnset: {
                    type: "structure",
                    members: {
                      ValueWhenUnsetOption: {},
                      CustomValue: {
                        shape: "S18"
                      }
                    }
                  },
                  MappedDataSetParameters: {
                    shape: "Skd"
                  }
                }
              }
            }
          }
        },
        Ska: {
          type: "structure",
          required: [
            "DefaultValueColumn"
          ],
          members: {
            UserNameColumn: {
              shape: "S2g"
            },
            GroupNameColumn: {
              shape: "S2g"
            },
            DefaultValueColumn: {
              shape: "S2g"
            }
          }
        },
        Skd: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "DataSetIdentifier",
              "DataSetParameterName"
            ],
            members: {
              DataSetIdentifier: {},
              DataSetParameterName: {}
            }
          }
        },
        Skn: {
          type: "structure",
          required: [
            "Expression"
          ],
          members: {
            DataSetIdentifier: {},
            Expression: {
              shape: "S4r"
            }
          }
        },
        Skp: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "FilterGroupId",
              "Filters",
              "ScopeConfiguration",
              "CrossDataset"
            ],
            members: {
              FilterGroupId: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CategoryFilter: {
                      type: "structure",
                      required: [
                        "FilterId",
                        "Column",
                        "Configuration"
                      ],
                      members: {
                        FilterId: {},
                        Column: {
                          shape: "S2g"
                        },
                        Configuration: {
                          type: "structure",
                          members: {
                            FilterListConfiguration: {
                              type: "structure",
                              required: [
                                "MatchOperator"
                              ],
                              members: {
                                MatchOperator: {},
                                CategoryValues: {
                                  shape: "Sbt"
                                },
                                SelectAllOptions: {},
                                NullOption: {}
                              }
                            },
                            CustomFilterListConfiguration: {
                              type: "structure",
                              required: [
                                "MatchOperator",
                                "NullOption"
                              ],
                              members: {
                                MatchOperator: {},
                                CategoryValues: {
                                  shape: "Sbt"
                                },
                                SelectAllOptions: {},
                                NullOption: {}
                              }
                            },
                            CustomFilterConfiguration: {
                              type: "structure",
                              required: [
                                "MatchOperator",
                                "NullOption"
                              ],
                              members: {
                                MatchOperator: {},
                                CategoryValue: {},
                                SelectAllOptions: {},
                                ParameterName: {},
                                NullOption: {}
                              }
                            }
                          }
                        }
                      }
                    },
                    NumericRangeFilter: {
                      type: "structure",
                      required: [
                        "FilterId",
                        "Column",
                        "NullOption"
                      ],
                      members: {
                        FilterId: {},
                        Column: {
                          shape: "S2g"
                        },
                        IncludeMinimum: {
                          type: "boolean"
                        },
                        IncludeMaximum: {
                          type: "boolean"
                        },
                        RangeMinimum: {
                          shape: "Sl2"
                        },
                        RangeMaximum: {
                          shape: "Sl2"
                        },
                        SelectAllOptions: {},
                        AggregationFunction: {
                          shape: "S52"
                        },
                        NullOption: {}
                      }
                    },
                    NumericEqualityFilter: {
                      type: "structure",
                      required: [
                        "FilterId",
                        "Column",
                        "MatchOperator",
                        "NullOption"
                      ],
                      members: {
                        FilterId: {},
                        Column: {
                          shape: "S2g"
                        },
                        Value: {
                          type: "double"
                        },
                        SelectAllOptions: {},
                        MatchOperator: {},
                        AggregationFunction: {
                          shape: "S52"
                        },
                        ParameterName: {},
                        NullOption: {}
                      }
                    },
                    TimeEqualityFilter: {
                      type: "structure",
                      required: [
                        "FilterId",
                        "Column"
                      ],
                      members: {
                        FilterId: {},
                        Column: {
                          shape: "S2g"
                        },
                        Value: {
                          type: "timestamp"
                        },
                        ParameterName: {},
                        TimeGranularity: {},
                        RollingDate: {
                          shape: "Skn"
                        }
                      }
                    },
                    TimeRangeFilter: {
                      type: "structure",
                      required: [
                        "FilterId",
                        "Column",
                        "NullOption"
                      ],
                      members: {
                        FilterId: {},
                        Column: {
                          shape: "S2g"
                        },
                        IncludeMinimum: {
                          type: "boolean"
                        },
                        IncludeMaximum: {
                          type: "boolean"
                        },
                        RangeMinimumValue: {
                          shape: "Sl8"
                        },
                        RangeMaximumValue: {
                          shape: "Sl8"
                        },
                        NullOption: {},
                        ExcludePeriodConfiguration: {
                          shape: "Sl9"
                        },
                        TimeGranularity: {}
                      }
                    },
                    RelativeDatesFilter: {
                      type: "structure",
                      required: [
                        "FilterId",
                        "Column",
                        "AnchorDateConfiguration",
                        "TimeGranularity",
                        "RelativeDateType",
                        "NullOption"
                      ],
                      members: {
                        FilterId: {},
                        Column: {
                          shape: "S2g"
                        },
                        AnchorDateConfiguration: {
                          type: "structure",
                          members: {
                            AnchorOption: {},
                            ParameterName: {}
                          }
                        },
                        MinimumGranularity: {},
                        TimeGranularity: {},
                        RelativeDateType: {},
                        RelativeDateValue: {
                          type: "integer"
                        },
                        ParameterName: {},
                        NullOption: {},
                        ExcludePeriodConfiguration: {
                          shape: "Sl9"
                        }
                      }
                    },
                    TopBottomFilter: {
                      type: "structure",
                      required: [
                        "FilterId",
                        "Column",
                        "AggregationSortConfigurations"
                      ],
                      members: {
                        FilterId: {},
                        Column: {
                          shape: "S2g"
                        },
                        Limit: {
                          type: "integer"
                        },
                        AggregationSortConfigurations: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "Column",
                              "SortDirection"
                            ],
                            members: {
                              Column: {
                                shape: "S2g"
                              },
                              SortDirection: {},
                              AggregationFunction: {
                                shape: "S52"
                              }
                            }
                          }
                        },
                        TimeGranularity: {},
                        ParameterName: {}
                      }
                    }
                  }
                }
              },
              ScopeConfiguration: {
                type: "structure",
                members: {
                  SelectedSheets: {
                    type: "structure",
                    members: {
                      SheetVisualScopingConfigurations: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "SheetId",
                            "Scope"
                          ],
                          members: {
                            SheetId: {},
                            Scope: {},
                            VisualIds: {
                              type: "list",
                              member: {}
                            }
                          }
                        }
                      }
                    }
                  },
                  AllSheets: {
                    type: "structure",
                    members: {}
                  }
                }
              },
              Status: {},
              CrossDataset: {}
            }
          }
        },
        Sl2: {
          type: "structure",
          members: {
            StaticValue: {
              type: "double"
            },
            Parameter: {}
          }
        },
        Sl8: {
          type: "structure",
          members: {
            StaticValue: {
              type: "timestamp"
            },
            RollingDate: {
              shape: "Skn"
            },
            Parameter: {}
          }
        },
        Sl9: {
          type: "structure",
          required: [
            "Amount",
            "Granularity"
          ],
          members: {
            Amount: {
              type: "integer"
            },
            Granularity: {},
            Status: {}
          }
        },
        Slp: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Column"
            ],
            members: {
              Column: {
                shape: "S2g"
              },
              FormatConfiguration: {
                shape: "S4v"
              },
              Role: {},
              ColorsConfiguration: {
                type: "structure",
                members: {
                  CustomColors: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Color"
                      ],
                      members: {
                        FieldValue: {
                          shape: "S8c"
                        },
                        Color: {},
                        SpecialValue: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Slw: {
          type: "structure",
          required: [
            "DefaultNewSheetConfiguration"
          ],
          members: {
            DefaultNewSheetConfiguration: {
              type: "structure",
              members: {
                InteractiveLayoutConfiguration: {
                  type: "structure",
                  members: {
                    Grid: {
                      type: "structure",
                      required: [
                        "CanvasSizeOptions"
                      ],
                      members: {
                        CanvasSizeOptions: {
                          shape: "Sj1"
                        }
                      }
                    },
                    FreeForm: {
                      type: "structure",
                      required: [
                        "CanvasSizeOptions"
                      ],
                      members: {
                        CanvasSizeOptions: {
                          shape: "Sje"
                        }
                      }
                    }
                  }
                },
                PaginatedLayoutConfiguration: {
                  type: "structure",
                  members: {
                    SectionBased: {
                      type: "structure",
                      required: [
                        "CanvasSizeOptions"
                      ],
                      members: {
                        CanvasSizeOptions: {
                          shape: "Sju"
                        }
                      }
                    }
                  }
                },
                SheetContentType: {}
              }
            }
          }
        },
        Sm3: {
          type: "structure",
          members: {
            Timezone: {},
            WeekStart: {}
          }
        },
        Sm5: {
          type: "structure",
          required: [
            "Mode"
          ],
          members: {
            Mode: {}
          }
        },
        Sm7: {
          type: "list",
          member: {}
        },
        Smc: {
          type: "structure",
          members: {
            SourceTemplate: {
              type: "structure",
              required: [
                "DataSetReferences",
                "Arn"
              ],
              members: {
                DataSetReferences: {
                  shape: "S1f"
                },
                Arn: {}
              }
            }
          }
        },
        Smf: {
          type: "structure",
          members: {
            AdHocFilteringOption: {
              type: "structure",
              members: {
                AvailabilityStatus: {}
              }
            },
            ExportToCSVOption: {
              type: "structure",
              members: {
                AvailabilityStatus: {}
              }
            },
            SheetControlsOption: {
              type: "structure",
              members: {
                VisibilityState: {}
              }
            },
            VisualPublishOptions: {
              deprecated: true,
              deprecatedMessage: "VisualPublishOptions property will reach its end of standard support in a future release. To perform this action, use ExportWithHiddenFields.",
              type: "structure",
              members: {
                ExportHiddenFieldsOption: {
                  type: "structure",
                  members: {
                    AvailabilityStatus: {}
                  }
                }
              }
            },
            SheetLayoutElementMaximizationOption: {
              type: "structure",
              members: {
                AvailabilityStatus: {}
              }
            },
            VisualMenuOption: {
              type: "structure",
              members: {
                AvailabilityStatus: {}
              }
            },
            VisualAxisSortOption: {
              type: "structure",
              members: {
                AvailabilityStatus: {}
              }
            },
            ExportWithHiddenFieldsOption: {
              type: "structure",
              members: {
                AvailabilityStatus: {}
              }
            },
            DataPointDrillUpDownOption: {
              type: "structure",
              members: {
                AvailabilityStatus: {}
              }
            },
            DataPointMenuLabelOption: {
              type: "structure",
              members: {
                AvailabilityStatus: {}
              }
            },
            DataPointTooltipOption: {
              type: "structure",
              members: {
                AvailabilityStatus: {}
              }
            }
          }
        },
        Smu: {
          type: "structure",
          required: [
            "DataSetIdentifierDeclarations"
          ],
          members: {
            DataSetIdentifierDeclarations: {
              shape: "S1i"
            },
            Sheets: {
              shape: "S1l"
            },
            CalculatedFields: {
              shape: "Sk2"
            },
            ParameterDeclarations: {
              shape: "Sk5"
            },
            FilterGroups: {
              shape: "Skp"
            },
            ColumnConfigurations: {
              shape: "Slp"
            },
            AnalysisDefaults: {
              shape: "Slw"
            },
            Options: {
              shape: "Sm3"
            }
          }
        },
        Smv: {
          type: "structure",
          members: {
            Permissions: {
              shape: "S19"
            }
          }
        },
        Smw: {
          type: "list",
          member: {}
        },
        Sn2: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              RelationalTable: {
                type: "structure",
                required: [
                  "DataSourceArn",
                  "Name",
                  "InputColumns"
                ],
                members: {
                  DataSourceArn: {},
                  Catalog: {},
                  Schema: {},
                  Name: {},
                  InputColumns: {
                    shape: "Sn9"
                  }
                }
              },
              CustomSql: {
                type: "structure",
                required: [
                  "DataSourceArn",
                  "Name",
                  "SqlQuery"
                ],
                members: {
                  DataSourceArn: {},
                  Name: {},
                  SqlQuery: {},
                  Columns: {
                    shape: "Sn9"
                  }
                }
              },
              S3Source: {
                type: "structure",
                required: [
                  "DataSourceArn",
                  "InputColumns"
                ],
                members: {
                  DataSourceArn: {},
                  UploadSettings: {
                    type: "structure",
                    members: {
                      Format: {},
                      StartFromRow: {
                        type: "integer"
                      },
                      ContainsHeader: {
                        type: "boolean"
                      },
                      TextQualifier: {},
                      Delimiter: {}
                    }
                  },
                  InputColumns: {
                    shape: "Sn9"
                  }
                }
              }
            }
          }
        },
        Sn9: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Type"
            ],
            members: {
              Name: {},
              Type: {},
              SubType: {}
            }
          }
        },
        Snm: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "Alias",
              "Source"
            ],
            members: {
              Alias: {},
              DataTransforms: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ProjectOperation: {
                      type: "structure",
                      required: [
                        "ProjectedColumns"
                      ],
                      members: {
                        ProjectedColumns: {
                          type: "list",
                          member: {}
                        }
                      }
                    },
                    FilterOperation: {
                      type: "structure",
                      required: [
                        "ConditionExpression"
                      ],
                      members: {
                        ConditionExpression: {
                          shape: "S4r"
                        }
                      }
                    },
                    CreateColumnsOperation: {
                      type: "structure",
                      required: [
                        "Columns"
                      ],
                      members: {
                        Columns: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "ColumnName",
                              "ColumnId",
                              "Expression"
                            ],
                            members: {
                              ColumnName: {},
                              ColumnId: {},
                              Expression: {
                                shape: "S4r"
                              }
                            }
                          }
                        }
                      }
                    },
                    RenameColumnOperation: {
                      type: "structure",
                      required: [
                        "ColumnName",
                        "NewColumnName"
                      ],
                      members: {
                        ColumnName: {},
                        NewColumnName: {}
                      }
                    },
                    CastColumnTypeOperation: {
                      type: "structure",
                      required: [
                        "ColumnName",
                        "NewColumnType"
                      ],
                      members: {
                        ColumnName: {},
                        NewColumnType: {},
                        SubType: {},
                        Format: {}
                      }
                    },
                    TagColumnOperation: {
                      type: "structure",
                      required: [
                        "ColumnName",
                        "Tags"
                      ],
                      members: {
                        ColumnName: {},
                        Tags: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              ColumnGeographicRole: {},
                              ColumnDescription: {
                                type: "structure",
                                members: {
                                  Text: {}
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    UntagColumnOperation: {
                      type: "structure",
                      required: [
                        "ColumnName",
                        "TagNames"
                      ],
                      members: {
                        ColumnName: {},
                        TagNames: {
                          type: "list",
                          member: {}
                        }
                      }
                    },
                    OverrideDatasetParameterOperation: {
                      type: "structure",
                      required: [
                        "ParameterName"
                      ],
                      members: {
                        ParameterName: {},
                        NewParameterName: {},
                        NewDefaultValues: {
                          type: "structure",
                          members: {
                            StringStaticValues: {
                              shape: "Sof"
                            },
                            DecimalStaticValues: {
                              shape: "Soh"
                            },
                            DateTimeStaticValues: {
                              shape: "Soj"
                            },
                            IntegerStaticValues: {
                              shape: "Sol"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              Source: {
                type: "structure",
                members: {
                  JoinInstruction: {
                    type: "structure",
                    required: [
                      "LeftOperand",
                      "RightOperand",
                      "Type",
                      "OnClause"
                    ],
                    members: {
                      LeftOperand: {},
                      RightOperand: {},
                      LeftJoinKeyProperties: {
                        shape: "Sop"
                      },
                      RightJoinKeyProperties: {
                        shape: "Sop"
                      },
                      Type: {},
                      OnClause: {}
                    }
                  },
                  PhysicalTableId: {},
                  DataSetArn: {}
                }
              }
            }
          }
        },
        Sof: {
          type: "list",
          member: {}
        },
        Soh: {
          type: "list",
          member: {
            type: "double"
          }
        },
        Soj: {
          type: "list",
          member: {
            type: "timestamp"
          }
        },
        Sol: {
          type: "list",
          member: {
            type: "long"
          }
        },
        Sop: {
          type: "structure",
          members: {
            UniqueKey: {
              type: "boolean"
            }
          }
        },
        Sot: {
          type: "list",
          member: {
            type: "structure",
            members: {
              GeoSpatialColumnGroup: {
                type: "structure",
                required: [
                  "Name",
                  "Columns"
                ],
                members: {
                  Name: {},
                  CountryCode: {},
                  Columns: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          }
        },
        Soz: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              description: {},
              columns: {
                type: "list",
                member: {}
              }
            }
          }
        },
        Sp4: {
          type: "structure",
          required: [
            "Arn",
            "PermissionPolicy"
          ],
          members: {
            Namespace: {},
            Arn: {},
            PermissionPolicy: {},
            FormatVersion: {},
            Status: {}
          }
        },
        Sp8: {
          type: "structure",
          required: [
            "TagRules"
          ],
          members: {
            Status: {},
            TagRules: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "TagKey",
                  "ColumnName"
                ],
                members: {
                  TagKey: {},
                  ColumnName: {},
                  TagMultiValueDelimiter: {},
                  MatchAllValue: {
                    shape: "Spd"
                  }
                }
              }
            },
            TagRuleConfigurations: {
              type: "list",
              member: {
                type: "list",
                member: {}
              }
            }
          }
        },
        Spd: {
          type: "string",
          sensitive: true
        },
        Spg: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Principals: {
                type: "list",
                member: {}
              },
              ColumnNames: {
                type: "list",
                member: {}
              }
            }
          }
        },
        Spk: {
          type: "structure",
          members: {
            DisableUseAsDirectQuerySource: {
              type: "boolean"
            },
            DisableUseAsImportedSource: {
              type: "boolean"
            }
          }
        },
        Spl: {
          type: "list",
          member: {
            type: "structure",
            members: {
              StringDatasetParameter: {
                type: "structure",
                required: [
                  "Id",
                  "Name",
                  "ValueType"
                ],
                members: {
                  Id: {},
                  Name: {},
                  ValueType: {},
                  DefaultValues: {
                    type: "structure",
                    members: {
                      StaticValues: {
                        shape: "Sof"
                      }
                    }
                  }
                }
              },
              DecimalDatasetParameter: {
                type: "structure",
                required: [
                  "Id",
                  "Name",
                  "ValueType"
                ],
                members: {
                  Id: {},
                  Name: {},
                  ValueType: {},
                  DefaultValues: {
                    type: "structure",
                    members: {
                      StaticValues: {
                        shape: "Soh"
                      }
                    }
                  }
                }
              },
              IntegerDatasetParameter: {
                type: "structure",
                required: [
                  "Id",
                  "Name",
                  "ValueType"
                ],
                members: {
                  Id: {},
                  Name: {},
                  ValueType: {},
                  DefaultValues: {
                    type: "structure",
                    members: {
                      StaticValues: {
                        shape: "Sol"
                      }
                    }
                  }
                }
              },
              DateTimeDatasetParameter: {
                type: "structure",
                required: [
                  "Id",
                  "Name",
                  "ValueType"
                ],
                members: {
                  Id: {},
                  Name: {},
                  ValueType: {},
                  TimeGranularity: {},
                  DefaultValues: {
                    type: "structure",
                    members: {
                      StaticValues: {
                        shape: "Soj"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sq0: {
          type: "structure",
          members: {
            AmazonElasticsearchParameters: {
              type: "structure",
              required: [
                "Domain"
              ],
              members: {
                Domain: {}
              }
            },
            AthenaParameters: {
              type: "structure",
              members: {
                WorkGroup: {},
                RoleArn: {}
              }
            },
            AuroraParameters: {
              type: "structure",
              required: [
                "Host",
                "Port",
                "Database"
              ],
              members: {
                Host: {},
                Port: {
                  type: "integer"
                },
                Database: {}
              }
            },
            AuroraPostgreSqlParameters: {
              type: "structure",
              required: [
                "Host",
                "Port",
                "Database"
              ],
              members: {
                Host: {},
                Port: {
                  type: "integer"
                },
                Database: {}
              }
            },
            AwsIotAnalyticsParameters: {
              type: "structure",
              required: [
                "DataSetName"
              ],
              members: {
                DataSetName: {}
              }
            },
            JiraParameters: {
              type: "structure",
              required: [
                "SiteBaseUrl"
              ],
              members: {
                SiteBaseUrl: {}
              }
            },
            MariaDbParameters: {
              type: "structure",
              required: [
                "Host",
                "Port",
                "Database"
              ],
              members: {
                Host: {},
                Port: {
                  type: "integer"
                },
                Database: {}
              }
            },
            MySqlParameters: {
              type: "structure",
              required: [
                "Host",
                "Port",
                "Database"
              ],
              members: {
                Host: {},
                Port: {
                  type: "integer"
                },
                Database: {}
              }
            },
            OracleParameters: {
              type: "structure",
              required: [
                "Host",
                "Port",
                "Database"
              ],
              members: {
                Host: {},
                Port: {
                  type: "integer"
                },
                Database: {}
              }
            },
            PostgreSqlParameters: {
              type: "structure",
              required: [
                "Host",
                "Port",
                "Database"
              ],
              members: {
                Host: {},
                Port: {
                  type: "integer"
                },
                Database: {}
              }
            },
            PrestoParameters: {
              type: "structure",
              required: [
                "Host",
                "Port",
                "Catalog"
              ],
              members: {
                Host: {},
                Port: {
                  type: "integer"
                },
                Catalog: {}
              }
            },
            RdsParameters: {
              type: "structure",
              required: [
                "InstanceId",
                "Database"
              ],
              members: {
                InstanceId: {},
                Database: {}
              }
            },
            RedshiftParameters: {
              type: "structure",
              required: [
                "Database"
              ],
              members: {
                Host: {},
                Port: {
                  type: "integer"
                },
                Database: {},
                ClusterId: {},
                IAMParameters: {
                  type: "structure",
                  required: [
                    "RoleArn",
                    "DatabaseUser"
                  ],
                  members: {
                    RoleArn: {},
                    DatabaseUser: {},
                    DatabaseGroups: {
                      type: "list",
                      member: {}
                    },
                    AutoCreateDatabaseUser: {
                      type: "boolean"
                    }
                  }
                },
                IdentityCenterConfiguration: {
                  type: "structure",
                  members: {
                    EnableIdentityPropagation: {
                      type: "boolean"
                    }
                  }
                }
              }
            },
            S3Parameters: {
              type: "structure",
              required: [
                "ManifestFileLocation"
              ],
              members: {
                ManifestFileLocation: {
                  type: "structure",
                  required: [
                    "Bucket",
                    "Key"
                  ],
                  members: {
                    Bucket: {},
                    Key: {}
                  }
                },
                RoleArn: {}
              }
            },
            ServiceNowParameters: {
              type: "structure",
              required: [
                "SiteBaseUrl"
              ],
              members: {
                SiteBaseUrl: {}
              }
            },
            SnowflakeParameters: {
              type: "structure",
              required: [
                "Host",
                "Database",
                "Warehouse"
              ],
              members: {
                Host: {},
                Database: {},
                Warehouse: {}
              }
            },
            SparkParameters: {
              type: "structure",
              required: [
                "Host",
                "Port"
              ],
              members: {
                Host: {},
                Port: {
                  type: "integer"
                }
              }
            },
            SqlServerParameters: {
              type: "structure",
              required: [
                "Host",
                "Port",
                "Database"
              ],
              members: {
                Host: {},
                Port: {
                  type: "integer"
                },
                Database: {}
              }
            },
            TeradataParameters: {
              type: "structure",
              required: [
                "Host",
                "Port",
                "Database"
              ],
              members: {
                Host: {},
                Port: {
                  type: "integer"
                },
                Database: {}
              }
            },
            TwitterParameters: {
              type: "structure",
              required: [
                "Query",
                "MaxRows"
              ],
              members: {
                Query: {},
                MaxRows: {
                  type: "integer"
                }
              }
            },
            AmazonOpenSearchParameters: {
              type: "structure",
              required: [
                "Domain"
              ],
              members: {
                Domain: {}
              }
            },
            ExasolParameters: {
              type: "structure",
              required: [
                "Host",
                "Port"
              ],
              members: {
                Host: {},
                Port: {
                  type: "integer"
                }
              }
            },
            DatabricksParameters: {
              type: "structure",
              required: [
                "Host",
                "Port",
                "SqlEndpointPath"
              ],
              members: {
                Host: {},
                Port: {
                  type: "integer"
                },
                SqlEndpointPath: {}
              }
            },
            StarburstParameters: {
              type: "structure",
              required: [
                "Host",
                "Port",
                "Catalog"
              ],
              members: {
                Host: {},
                Port: {
                  type: "integer"
                },
                Catalog: {},
                ProductType: {}
              }
            },
            TrinoParameters: {
              type: "structure",
              required: [
                "Host",
                "Port",
                "Catalog"
              ],
              members: {
                Host: {},
                Port: {
                  type: "integer"
                },
                Catalog: {}
              }
            },
            BigQueryParameters: {
              type: "structure",
              required: [
                "ProjectId"
              ],
              members: {
                ProjectId: {},
                DataSetRegion: {}
              }
            }
          }
        },
        Srh: {
          type: "structure",
          members: {
            CredentialPair: {
              type: "structure",
              required: [
                "Username",
                "Password"
              ],
              members: {
                Username: {},
                Password: {},
                AlternateDataSourceParameters: {
                  shape: "Srl"
                }
              }
            },
            CopySourceArn: {},
            SecretArn: {}
          },
          sensitive: true
        },
        Srl: {
          type: "list",
          member: {
            shape: "Sq0"
          }
        },
        Sro: {
          type: "structure",
          required: [
            "VpcConnectionArn"
          ],
          members: {
            VpcConnectionArn: {}
          }
        },
        Srp: {
          type: "structure",
          members: {
            DisableSsl: {
              type: "boolean"
            }
          }
        },
        Ss5: {
          type: "structure",
          members: {
            Arn: {},
            GroupName: {},
            Description: {},
            PrincipalId: {}
          }
        },
        Ss9: {
          type: "structure",
          members: {
            Arn: {},
            MemberName: {}
          }
        },
        Ssd: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {}
          }
        },
        Ssq: {
          type: "structure",
          required: [
            "ScheduleId",
            "ScheduleFrequency",
            "RefreshType"
          ],
          members: {
            ScheduleId: {},
            ScheduleFrequency: {
              type: "structure",
              required: [
                "Interval"
              ],
              members: {
                Interval: {},
                RefreshOnDay: {
                  type: "structure",
                  members: {
                    DayOfWeek: {},
                    DayOfMonth: {}
                  }
                },
                Timezone: {},
                TimeOfTheDay: {}
              }
            },
            StartAfterDateTime: {
              type: "timestamp"
            },
            RefreshType: {},
            Arn: {}
          }
        },
        St2: {
          type: "structure",
          members: {
            SourceAnalysis: {
              type: "structure",
              required: [
                "Arn",
                "DataSetReferences"
              ],
              members: {
                Arn: {},
                DataSetReferences: {
                  shape: "S1f"
                }
              }
            },
            SourceTemplate: {
              type: "structure",
              required: [
                "Arn"
              ],
              members: {
                Arn: {}
              }
            }
          }
        },
        St5: {
          type: "structure",
          required: [
            "DataSetConfigurations"
          ],
          members: {
            DataSetConfigurations: {
              shape: "St6"
            },
            Sheets: {
              shape: "S1l"
            },
            CalculatedFields: {
              shape: "Sk2"
            },
            ParameterDeclarations: {
              shape: "Sk5"
            },
            FilterGroups: {
              shape: "Skp"
            },
            ColumnConfigurations: {
              shape: "Slp"
            },
            AnalysisDefaults: {
              shape: "Slw"
            },
            Options: {
              shape: "Sm3"
            }
          }
        },
        St6: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Placeholder: {},
              DataSetSchema: {
                type: "structure",
                members: {
                  ColumnSchemaList: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {},
                        DataType: {},
                        GeographicRole: {}
                      }
                    }
                  }
                }
              },
              ColumnGroupSchemaList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    ColumnGroupColumnSchemaList: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Name: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Stk: {
          type: "structure",
          members: {
            AliasName: {},
            Arn: {},
            TemplateVersionNumber: {
              type: "long"
            }
          }
        },
        Stn: {
          type: "structure",
          members: {
            DataColorPalette: {
              type: "structure",
              members: {
                Colors: {
                  shape: "Stp"
                },
                MinMaxGradient: {
                  shape: "Stp"
                },
                EmptyFillColor: {}
              }
            },
            UIColorPalette: {
              type: "structure",
              members: {
                PrimaryForeground: {},
                PrimaryBackground: {},
                SecondaryForeground: {},
                SecondaryBackground: {},
                Accent: {},
                AccentForeground: {},
                Danger: {},
                DangerForeground: {},
                Warning: {},
                WarningForeground: {},
                Success: {},
                SuccessForeground: {},
                Dimension: {},
                DimensionForeground: {},
                Measure: {},
                MeasureForeground: {}
              }
            },
            Sheet: {
              type: "structure",
              members: {
                Tile: {
                  type: "structure",
                  members: {
                    Border: {
                      type: "structure",
                      members: {
                        Show: {
                          type: "boolean"
                        }
                      }
                    }
                  }
                },
                TileLayout: {
                  type: "structure",
                  members: {
                    Gutter: {
                      type: "structure",
                      members: {
                        Show: {
                          type: "boolean"
                        }
                      }
                    },
                    Margin: {
                      type: "structure",
                      members: {
                        Show: {
                          type: "boolean"
                        }
                      }
                    }
                  }
                }
              }
            },
            Typography: {
              type: "structure",
              members: {
                FontFamilies: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      FontFamily: {}
                    }
                  }
                }
              }
            }
          }
        },
        Stp: {
          type: "list",
          member: {}
        },
        Su3: {
          type: "structure",
          members: {
            Arn: {},
            AliasName: {},
            ThemeVersionNumber: {
              type: "long"
            }
          }
        },
        Su6: {
          type: "structure",
          members: {
            Name: {},
            Description: {},
            UserExperienceVersion: {},
            DataSets: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "DatasetArn"
                ],
                members: {
                  DatasetArn: {},
                  DatasetName: {},
                  DatasetDescription: {},
                  DataAggregation: {
                    type: "structure",
                    members: {
                      DatasetRowDateGranularity: {},
                      DefaultDateColumnName: {}
                    }
                  },
                  Filters: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "FilterName",
                        "OperandFieldName"
                      ],
                      members: {
                        FilterDescription: {},
                        FilterClass: {},
                        FilterName: {},
                        FilterSynonyms: {
                          shape: "Sug"
                        },
                        OperandFieldName: {},
                        FilterType: {},
                        CategoryFilter: {
                          type: "structure",
                          members: {
                            CategoryFilterFunction: {},
                            CategoryFilterType: {},
                            Constant: {
                              type: "structure",
                              members: {
                                ConstantType: {},
                                SingularConstant: {},
                                CollectiveConstant: {
                                  type: "structure",
                                  members: {
                                    ValueList: {
                                      shape: "Suo"
                                    }
                                  }
                                }
                              },
                              sensitive: true
                            },
                            Inverse: {
                              type: "boolean"
                            }
                          }
                        },
                        NumericEqualityFilter: {
                          type: "structure",
                          members: {
                            Constant: {
                              shape: "Suq"
                            },
                            Aggregation: {}
                          }
                        },
                        NumericRangeFilter: {
                          type: "structure",
                          members: {
                            Inclusive: {
                              type: "boolean"
                            },
                            Constant: {
                              shape: "Sut"
                            },
                            Aggregation: {}
                          }
                        },
                        DateRangeFilter: {
                          type: "structure",
                          members: {
                            Inclusive: {
                              type: "boolean"
                            },
                            Constant: {
                              shape: "Sut"
                            }
                          }
                        },
                        RelativeDateFilter: {
                          type: "structure",
                          members: {
                            TimeGranularity: {},
                            RelativeDateFilterFunction: {},
                            Constant: {
                              shape: "Suq"
                            }
                          }
                        }
                      }
                    }
                  },
                  Columns: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "ColumnName"
                      ],
                      members: {
                        ColumnName: {},
                        ColumnFriendlyName: {},
                        ColumnDescription: {},
                        ColumnSynonyms: {
                          shape: "Sug"
                        },
                        ColumnDataRole: {},
                        Aggregation: {},
                        IsIncludedInTopic: {
                          type: "boolean"
                        },
                        DisableIndexing: {
                          type: "boolean"
                        },
                        ComparativeOrder: {
                          shape: "Sv3"
                        },
                        SemanticType: {
                          shape: "Sv6"
                        },
                        TimeGranularity: {},
                        AllowedAggregations: {
                          shape: "Sv8"
                        },
                        NotAllowedAggregations: {
                          shape: "Sv8"
                        },
                        DefaultFormatting: {
                          shape: "Sva"
                        },
                        NeverAggregateInFilter: {
                          type: "boolean"
                        },
                        CellValueSynonyms: {
                          shape: "Svf"
                        },
                        NonAdditive: {
                          type: "boolean"
                        }
                      }
                    }
                  },
                  CalculatedFields: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "CalculatedFieldName",
                        "Expression"
                      ],
                      members: {
                        CalculatedFieldName: {},
                        CalculatedFieldDescription: {},
                        Expression: {
                          shape: "S4r"
                        },
                        CalculatedFieldSynonyms: {
                          shape: "Sug"
                        },
                        IsIncludedInTopic: {
                          type: "boolean"
                        },
                        DisableIndexing: {
                          type: "boolean"
                        },
                        ColumnDataRole: {},
                        TimeGranularity: {},
                        DefaultFormatting: {
                          shape: "Sva"
                        },
                        Aggregation: {},
                        ComparativeOrder: {
                          shape: "Sv3"
                        },
                        SemanticType: {
                          shape: "Sv6"
                        },
                        AllowedAggregations: {
                          shape: "Sv8"
                        },
                        NotAllowedAggregations: {
                          shape: "Sv8"
                        },
                        NeverAggregateInFilter: {
                          type: "boolean"
                        },
                        CellValueSynonyms: {
                          shape: "Svf"
                        },
                        NonAdditive: {
                          type: "boolean"
                        }
                      }
                    }
                  },
                  NamedEntities: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "EntityName"
                      ],
                      members: {
                        EntityName: {},
                        EntityDescription: {},
                        EntitySynonyms: {
                          shape: "Sug"
                        },
                        SemanticEntityType: {
                          type: "structure",
                          members: {
                            TypeName: {},
                            SubTypeName: {},
                            TypeParameters: {
                              shape: "Sv7"
                            }
                          }
                        },
                        Definition: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              FieldName: {},
                              PropertyName: {},
                              PropertyRole: {},
                              PropertyUsage: {},
                              Metric: {
                                type: "structure",
                                members: {
                                  Aggregation: {},
                                  AggregationFunctionParameters: {
                                    type: "map",
                                    key: {},
                                    value: {}
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sug: {
          type: "list",
          member: {}
        },
        Suo: {
          type: "list",
          member: {}
        },
        Suq: {
          type: "structure",
          members: {
            ConstantType: {},
            SingularConstant: {}
          },
          sensitive: true
        },
        Sut: {
          type: "structure",
          members: {
            ConstantType: {},
            RangeConstant: {
              type: "structure",
              members: {
                Minimum: {},
                Maximum: {}
              }
            }
          },
          sensitive: true
        },
        Sv3: {
          type: "structure",
          members: {
            UseOrdering: {},
            SpecifedOrder: {
              shape: "Suo"
            },
            TreatUndefinedSpecifiedValues: {}
          }
        },
        Sv6: {
          type: "structure",
          members: {
            TypeName: {},
            SubTypeName: {},
            TypeParameters: {
              shape: "Sv7"
            },
            TruthyCellValue: {
              shape: "Sw"
            },
            TruthyCellValueSynonyms: {
              shape: "Sv"
            },
            FalseyCellValue: {
              shape: "Sw"
            },
            FalseyCellValueSynonyms: {
              shape: "Sv"
            }
          }
        },
        Sv7: {
          type: "map",
          key: {},
          value: {}
        },
        Sv8: {
          type: "list",
          member: {}
        },
        Sva: {
          type: "structure",
          members: {
            DisplayFormat: {},
            DisplayFormatOptions: {
              type: "structure",
              members: {
                UseBlankCellFormat: {
                  type: "boolean"
                },
                BlankCellFormat: {},
                DateFormat: {},
                DecimalSeparator: {},
                GroupingSeparator: {},
                UseGrouping: {
                  type: "boolean"
                },
                FractionDigits: {
                  type: "integer"
                },
                Prefix: {},
                Suffix: {},
                UnitScaler: {},
                NegativeFormat: {
                  type: "structure",
                  members: {
                    Prefix: {},
                    Suffix: {}
                  }
                },
                CurrencySymbol: {}
              }
            }
          }
        },
        Svf: {
          type: "list",
          member: {
            type: "structure",
            members: {
              CellValue: {},
              Synonyms: {
                shape: "Suo"
              }
            }
          }
        },
        Svv: {
          type: "structure",
          required: [
            "IsEnabled",
            "BasedOnSpiceSchedule"
          ],
          members: {
            IsEnabled: {
              type: "boolean"
            },
            BasedOnSpiceSchedule: {
              type: "boolean"
            },
            StartingAt: {
              type: "timestamp"
            },
            Timezone: {},
            RepeatAt: {},
            TopicScheduleType: {}
          }
        },
        Sw0: {
          type: "list",
          member: {}
        },
        Sw2: {
          type: "list",
          member: {}
        },
        Sw4: {
          type: "list",
          member: {}
        },
        Sy5: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Type: {},
              Message: {},
              ViolatedEntities: {
                shape: "Sy8"
              }
            }
          }
        },
        Sy8: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Path: {}
            }
          }
        },
        Sya: {
          type: "list",
          member: {}
        },
        Syb: {
          type: "list",
          member: {
            type: "structure",
            members: {
              SheetId: {},
              Name: {}
            }
          }
        },
        Syk: {
          type: "string",
          sensitive: true
        },
        Syn: {
          type: "list",
          member: {}
        },
        Syp: {
          type: "structure",
          members: {
            ResourceIdOverrideConfiguration: {
              type: "structure",
              members: {
                PrefixForAllResources: {
                  type: "boolean"
                }
              }
            },
            VPCConnections: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Arn",
                  "Properties"
                ],
                members: {
                  Arn: {},
                  Properties: {
                    type: "list",
                    member: {}
                  }
                }
              }
            },
            RefreshSchedules: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Arn",
                  "Properties"
                ],
                members: {
                  Arn: {},
                  Properties: {
                    type: "list",
                    member: {}
                  }
                }
              }
            },
            DataSources: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Arn",
                  "Properties"
                ],
                members: {
                  Arn: {},
                  Properties: {
                    type: "list",
                    member: {}
                  }
                }
              }
            },
            DataSets: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Arn",
                  "Properties"
                ],
                members: {
                  Arn: {},
                  Properties: {
                    type: "list",
                    member: {}
                  }
                }
              }
            },
            Themes: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Arn",
                  "Properties"
                ],
                members: {
                  Arn: {},
                  Properties: {
                    type: "list",
                    member: {}
                  }
                }
              }
            },
            Analyses: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Arn",
                  "Properties"
                ],
                members: {
                  Arn: {},
                  Properties: {
                    type: "list",
                    member: {}
                  }
                }
              }
            },
            Dashboards: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Arn",
                  "Properties"
                ],
                members: {
                  Arn: {},
                  Properties: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          }
        },
        Szj: {
          type: "structure",
          members: {
            StrictModeForAllResources: {
              type: "boolean"
            }
          }
        },
        Szp: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Arn: {},
              Type: {},
              Message: {}
            }
          }
        },
        Szt: {
          type: "structure",
          members: {
            ResourceIdOverrideConfiguration: {
              type: "structure",
              members: {
                PrefixForAllResources: {}
              }
            },
            VPCConnections: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "VPCConnectionId"
                ],
                members: {
                  VPCConnectionId: {},
                  Name: {},
                  SubnetIds: {
                    shape: "Sw0"
                  },
                  SecurityGroupIds: {
                    shape: "Sw2"
                  },
                  DnsResolvers: {
                    shape: "Sw4"
                  },
                  RoleArn: {}
                }
              }
            },
            RefreshSchedules: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "DataSetId",
                  "ScheduleId"
                ],
                members: {
                  DataSetId: {},
                  ScheduleId: {},
                  StartAfterDateTime: {
                    type: "timestamp"
                  }
                }
              }
            },
            DataSources: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "DataSourceId"
                ],
                members: {
                  DataSourceId: {},
                  Name: {},
                  DataSourceParameters: {
                    shape: "Sq0"
                  },
                  VpcConnectionProperties: {
                    shape: "Sro"
                  },
                  SslProperties: {
                    shape: "Srp"
                  },
                  Credentials: {
                    type: "structure",
                    members: {
                      CredentialPair: {
                        type: "structure",
                        required: [
                          "Username",
                          "Password"
                        ],
                        members: {
                          Username: {},
                          Password: {}
                        },
                        sensitive: true
                      },
                      SecretArn: {}
                    }
                  }
                }
              }
            },
            DataSets: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "DataSetId"
                ],
                members: {
                  DataSetId: {},
                  Name: {}
                }
              }
            },
            Themes: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "ThemeId"
                ],
                members: {
                  ThemeId: {},
                  Name: {}
                }
              }
            },
            Analyses: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "AnalysisId"
                ],
                members: {
                  AnalysisId: {},
                  Name: {}
                }
              }
            },
            Dashboards: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "DashboardId"
                ],
                members: {
                  DashboardId: {},
                  Name: {}
                }
              }
            }
          }
        },
        S10c: {
          type: "structure",
          members: {
            DataSources: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "DataSourceIds",
                  "Permissions"
                ],
                members: {
                  DataSourceIds: {
                    shape: "S10f"
                  },
                  Permissions: {
                    shape: "S10h"
                  }
                }
              }
            },
            DataSets: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "DataSetIds",
                  "Permissions"
                ],
                members: {
                  DataSetIds: {
                    shape: "S10f"
                  },
                  Permissions: {
                    shape: "S10h"
                  }
                }
              }
            },
            Themes: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "ThemeIds",
                  "Permissions"
                ],
                members: {
                  ThemeIds: {
                    shape: "S10f"
                  },
                  Permissions: {
                    shape: "S10h"
                  }
                }
              }
            },
            Analyses: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "AnalysisIds",
                  "Permissions"
                ],
                members: {
                  AnalysisIds: {
                    shape: "S10f"
                  },
                  Permissions: {
                    shape: "S10h"
                  }
                }
              }
            },
            Dashboards: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "DashboardIds"
                ],
                members: {
                  DashboardIds: {
                    shape: "S10f"
                  },
                  Permissions: {
                    shape: "S10h"
                  },
                  LinkSharingConfiguration: {
                    type: "structure",
                    members: {
                      Permissions: {
                        shape: "S10h"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S10f: {
          type: "list",
          member: {}
        },
        S10h: {
          type: "structure",
          required: [
            "Principals",
            "Actions"
          ],
          members: {
            Principals: {
              type: "list",
              member: {}
            },
            Actions: {
              shape: "S1c"
            }
          }
        },
        S10s: {
          type: "structure",
          members: {
            VPCConnections: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "VPCConnectionIds",
                  "Tags"
                ],
                members: {
                  VPCConnectionIds: {
                    shape: "S10f"
                  },
                  Tags: {
                    shape: "Sb"
                  }
                }
              }
            },
            DataSources: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "DataSourceIds",
                  "Tags"
                ],
                members: {
                  DataSourceIds: {
                    shape: "S10f"
                  },
                  Tags: {
                    shape: "Sb"
                  }
                }
              }
            },
            DataSets: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "DataSetIds",
                  "Tags"
                ],
                members: {
                  DataSetIds: {
                    shape: "S10f"
                  },
                  Tags: {
                    shape: "Sb"
                  }
                }
              }
            },
            Themes: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "ThemeIds",
                  "Tags"
                ],
                members: {
                  ThemeIds: {
                    shape: "S10f"
                  },
                  Tags: {
                    shape: "Sb"
                  }
                }
              }
            },
            Analyses: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "AnalysisIds",
                  "Tags"
                ],
                members: {
                  AnalysisIds: {
                    shape: "S10f"
                  },
                  Tags: {
                    shape: "Sb"
                  }
                }
              }
            },
            Dashboards: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "DashboardIds",
                  "Tags"
                ],
                members: {
                  DashboardIds: {
                    shape: "S10f"
                  },
                  Tags: {
                    shape: "Sb"
                  }
                }
              }
            }
          }
        },
        S115: {
          type: "structure",
          members: {
            StrictModeForAllResources: {
              type: "boolean"
            }
          }
        },
        S11a: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Type: {},
              Message: {},
              ViolatedEntities: {
                shape: "Sy8"
              }
            }
          }
        },
        S11n: {
          type: "structure",
          required: [
            "FileGroups"
          ],
          members: {
            FileGroups: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Files: {
                    shape: "S11q"
                  }
                }
              }
            },
            DestinationConfiguration: {
              type: "structure",
              members: {
                S3Destinations: {
                  type: "list",
                  member: {
                    shape: "S11z"
                  }
                }
              }
            },
            Parameters: {
              shape: "Sr"
            }
          }
        },
        S11q: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "SheetSelections",
              "FormatType"
            ],
            members: {
              SheetSelections: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "SheetId",
                    "SelectionScope"
                  ],
                  members: {
                    SheetId: {},
                    SelectionScope: {},
                    VisualIds: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              FormatType: {}
            }
          }
        },
        S11z: {
          type: "structure",
          required: [
            "BucketConfiguration"
          ],
          members: {
            BucketConfiguration: {
              type: "structure",
              required: [
                "BucketName",
                "BucketPrefix",
                "BucketRegion"
              ],
              members: {
                BucketName: {},
                BucketPrefix: {},
                BucketRegion: {}
              }
            }
          }
        },
        S12n: {
          type: "structure",
          required: [
            "RefreshConfiguration"
          ],
          members: {
            RefreshConfiguration: {
              type: "structure",
              required: [
                "IncrementalRefresh"
              ],
              members: {
                IncrementalRefresh: {
                  type: "structure",
                  required: [
                    "LookbackWindow"
                  ],
                  members: {
                    LookbackWindow: {
                      type: "structure",
                      required: [
                        "ColumnName",
                        "Size",
                        "SizeUnit"
                      ],
                      members: {
                        ColumnName: {},
                        Size: {
                          type: "long"
                        },
                        SizeUnit: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S12v: {
          type: "structure",
          members: {
            Arn: {},
            DataSourceId: {},
            Name: {},
            Type: {},
            Status: {},
            CreatedTime: {
              type: "timestamp"
            },
            LastUpdatedTime: {
              type: "timestamp"
            },
            DataSourceParameters: {
              shape: "Sq0"
            },
            AlternateDataSourceParameters: {
              shape: "Srl"
            },
            VpcConnectionProperties: {
              shape: "Sro"
            },
            SslProperties: {
              shape: "Srp"
            },
            ErrorInfo: {
              type: "structure",
              members: {
                Type: {},
                Message: {}
              }
            },
            SecretArn: {}
          }
        },
        S13i: {
          type: "structure",
          required: [
            "Arn",
            "IngestionStatus",
            "CreatedTime"
          ],
          members: {
            Arn: {},
            IngestionId: {},
            IngestionStatus: {},
            ErrorInfo: {
              type: "structure",
              members: {
                Type: {},
                Message: {}
              }
            },
            RowInfo: {
              type: "structure",
              members: {
                RowsIngested: {
                  type: "long"
                },
                RowsDropped: {
                  type: "long"
                },
                TotalRowsInDataset: {
                  type: "long"
                }
              }
            },
            QueueInfo: {
              type: "structure",
              required: [
                "WaitingOnIngestion",
                "QueuedIngestion"
              ],
              members: {
                WaitingOnIngestion: {},
                QueuedIngestion: {}
              }
            },
            CreatedTime: {
              type: "timestamp"
            },
            IngestionTimeInSeconds: {
              type: "long"
            },
            IngestionSizeInBytes: {
              type: "long"
            },
            RequestSource: {},
            RequestType: {}
          }
        },
        S13r: {
          type: "map",
          key: {},
          value: {}
        },
        S13w: {
          type: "structure",
          members: {
            Name: {},
            Arn: {},
            CapacityRegion: {},
            CreationStatus: {},
            IdentityStore: {},
            NamespaceError: {
              type: "structure",
              members: {
                Type: {},
                Message: {}
              }
            }
          }
        },
        S148: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Type: {},
              Message: {},
              ViolatedEntities: {
                shape: "Sy8"
              }
            }
          }
        },
        S156: {
          type: "structure",
          members: {
            Arn: {},
            UserName: {},
            Email: {},
            Role: {},
            IdentityType: {},
            Active: {
              type: "boolean"
            },
            PrincipalId: {},
            CustomPermissionsName: {},
            ExternalLoginFederationProviderType: {},
            ExternalLoginFederationProviderUrl: {},
            ExternalLoginId: {}
          }
        },
        S15c: {
          type: "list",
          member: {
            type: "structure",
            members: {
              SubnetId: {},
              AvailabilityZone: {},
              ErrorMessage: {},
              Status: {},
              NetworkInterfaceId: {}
            }
          }
        },
        S15i: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {
                shape: "Spd"
              }
            }
          }
        },
        S15o: {
          type: "structure",
          required: [
            "DashboardId",
            "SheetId",
            "VisualId"
          ],
          members: {
            DashboardId: {},
            SheetId: {},
            VisualId: {}
          }
        },
        S15r: {
          type: "string",
          sensitive: true
        },
        S15w: {
          type: "structure",
          required: [
            "Enabled"
          ],
          members: {
            Enabled: {
              type: "boolean"
            }
          }
        },
        S16d: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Arn: {},
              AnalysisId: {},
              Name: {},
              Status: {},
              CreatedTime: {
                type: "timestamp"
              },
              LastUpdatedTime: {
                type: "timestamp"
              }
            }
          }
        },
        S16t: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Arn: {},
              DashboardId: {},
              Name: {},
              CreatedTime: {
                type: "timestamp"
              },
              LastUpdatedTime: {
                type: "timestamp"
              },
              PublishedVersionNumber: {
                type: "long"
              },
              LastPublishedTime: {
                type: "timestamp"
              }
            }
          }
        },
        S16x: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Arn: {},
              DataSetId: {},
              Name: {},
              CreatedTime: {
                type: "timestamp"
              },
              LastUpdatedTime: {
                type: "timestamp"
              },
              ImportMode: {},
              RowLevelPermissionDataSet: {
                shape: "Sp4"
              },
              RowLevelPermissionTagConfigurationApplied: {
                type: "boolean"
              },
              ColumnLevelPermissionRulesApplied: {
                type: "boolean"
              }
            }
          }
        },
        S178: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Arn: {},
              FolderId: {},
              Name: {},
              FolderType: {},
              CreatedTime: {
                type: "timestamp"
              },
              LastUpdatedTime: {
                type: "timestamp"
              },
              SharingModel: {}
            }
          }
        },
        S17f: {
          type: "list",
          member: {
            shape: "Ss5"
          }
        },
        S17t: {
          type: "list",
          member: {}
        },
        S1b3: {
          type: "list",
          member: {
            shape: "S1a"
          }
        },
        S1ba: {
          type: "list",
          member: {
            shape: "S1a"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/quicksight-2018-04-01.paginators.json
var require_quicksight_2018_04_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/quicksight-2018-04-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeFolderPermissions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Permissions"
        },
        DescribeFolderResolvedPermissions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Permissions"
        },
        ListAnalyses: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AnalysisSummaryList"
        },
        ListAssetBundleExportJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AssetBundleExportJobSummaryList"
        },
        ListAssetBundleImportJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AssetBundleImportJobSummaryList"
        },
        ListDashboardVersions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "DashboardVersionSummaryList"
        },
        ListDashboards: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "DashboardSummaryList"
        },
        ListDataSets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "DataSetSummaries"
        },
        ListDataSources: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "DataSources"
        },
        ListFolderMembers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "FolderMemberList"
        },
        ListFolders: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "FolderSummaryList"
        },
        ListGroupMemberships: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "GroupMemberList"
        },
        ListGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "GroupList"
        },
        ListIAMPolicyAssignments: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "IAMPolicyAssignments"
        },
        ListIAMPolicyAssignmentsForUser: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ActiveAssignments"
        },
        ListIngestions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Ingestions"
        },
        ListNamespaces: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Namespaces"
        },
        ListRoleMemberships: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "MembersList"
        },
        ListTemplateAliases: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "TemplateAliasList"
        },
        ListTemplateVersions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "TemplateVersionSummaryList"
        },
        ListTemplates: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "TemplateSummaryList"
        },
        ListThemeVersions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ThemeVersionSummaryList"
        },
        ListThemes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ThemeSummaryList"
        },
        ListTopics: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListUserGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "GroupList"
        },
        ListUsers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "UserList"
        },
        ListVPCConnections: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        SearchAnalyses: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AnalysisSummaryList"
        },
        SearchDashboards: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "DashboardSummaryList"
        },
        SearchDataSets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "DataSetSummaries"
        },
        SearchDataSources: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "DataSourceSummaries"
        },
        SearchFolders: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "FolderSummaryList"
        },
        SearchGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "GroupList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/quicksight.js
var require_quicksight = __commonJS({
  "node_modules/aws-sdk/clients/quicksight.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["quicksight"] = {};
    AWS2.QuickSight = Service.defineService("quicksight", ["2018-04-01"]);
    Object.defineProperty(apiLoader.services["quicksight"], "2018-04-01", {
      get: function get() {
        var model = require_quicksight_2018_04_01_min();
        model.paginators = require_quicksight_2018_04_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.QuickSight;
  }
});

// node_modules/aws-sdk/lib/services/rdsdataservice.js
var require_rdsdataservice = __commonJS({
  "node_modules/aws-sdk/lib/services/rdsdataservice.js"() {
    "use strict";
    var AWS2 = require_core();
    AWS2.util.update(AWS2.RDSDataService.prototype, {
      /**
       * @return [Boolean] whether the error can be retried
       * @api private
       */
      retryableError: function retryableError(error) {
        if (error.code === "BadRequestException" && error.message && error.message.match(/^Communications link failure/) && error.statusCode === 400) {
          return true;
        } else {
          var _super = AWS2.Service.prototype.retryableError;
          return _super.call(this, error);
        }
      }
    });
  }
});

// node_modules/aws-sdk/apis/rds-data-2018-08-01.min.json
var require_rds_data_2018_08_01_min = __commonJS({
  "node_modules/aws-sdk/apis/rds-data-2018-08-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-08-01",
        endpointPrefix: "rds-data",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS RDS DataService",
        serviceId: "RDS Data",
        signatureVersion: "v4",
        signingName: "rds-data",
        uid: "rds-data-2018-08-01"
      },
      operations: {
        BatchExecuteStatement: {
          http: {
            requestUri: "/BatchExecute",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "secretArn",
              "sql"
            ],
            members: {
              resourceArn: {},
              secretArn: {},
              sql: {},
              database: {},
              schema: {},
              parameterSets: {
                type: "list",
                member: {
                  shape: "S6"
                }
              },
              transactionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              updateResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    generatedFields: {
                      shape: "Sq"
                    }
                  }
                }
              }
            }
          }
        },
        BeginTransaction: {
          http: {
            requestUri: "/BeginTransaction",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "secretArn"
            ],
            members: {
              resourceArn: {},
              secretArn: {},
              database: {},
              schema: {}
            }
          },
          output: {
            type: "structure",
            members: {
              transactionId: {}
            }
          }
        },
        CommitTransaction: {
          http: {
            requestUri: "/CommitTransaction",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "secretArn",
              "transactionId"
            ],
            members: {
              resourceArn: {},
              secretArn: {},
              transactionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              transactionStatus: {}
            }
          }
        },
        ExecuteSql: {
          http: {
            requestUri: "/ExecuteSql",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "dbClusterOrInstanceArn",
              "awsSecretStoreArn",
              "sqlStatements"
            ],
            members: {
              dbClusterOrInstanceArn: {},
              awsSecretStoreArn: {},
              sqlStatements: {},
              database: {},
              schema: {}
            }
          },
          output: {
            type: "structure",
            members: {
              sqlStatementResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    resultFrame: {
                      type: "structure",
                      members: {
                        resultSetMetadata: {
                          type: "structure",
                          members: {
                            columnCount: {
                              type: "long"
                            },
                            columnMetadata: {
                              shape: "S13"
                            }
                          }
                        },
                        records: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              values: {
                                type: "list",
                                member: {
                                  shape: "S1a"
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    numberOfRecordsUpdated: {
                      type: "long"
                    }
                  }
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "The ExecuteSql API is deprecated, please use the ExecuteStatement API."
        },
        ExecuteStatement: {
          http: {
            requestUri: "/Execute",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "secretArn",
              "sql"
            ],
            members: {
              resourceArn: {},
              secretArn: {},
              sql: {},
              database: {},
              schema: {},
              parameters: {
                shape: "S6"
              },
              transactionId: {},
              includeResultMetadata: {
                type: "boolean"
              },
              continueAfterTimeout: {
                type: "boolean"
              },
              resultSetOptions: {
                type: "structure",
                members: {
                  decimalReturnType: {},
                  longReturnType: {}
                }
              },
              formatRecordsAs: {}
            }
          },
          output: {
            type: "structure",
            members: {
              records: {
                type: "list",
                member: {
                  shape: "Sq"
                }
              },
              columnMetadata: {
                shape: "S13"
              },
              numberOfRecordsUpdated: {
                type: "long"
              },
              generatedFields: {
                shape: "Sq"
              },
              formattedRecords: {}
            }
          }
        },
        RollbackTransaction: {
          http: {
            requestUri: "/RollbackTransaction",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "secretArn",
              "transactionId"
            ],
            members: {
              resourceArn: {},
              secretArn: {},
              transactionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              transactionStatus: {}
            }
          }
        }
      },
      shapes: {
        S6: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              value: {
                shape: "S9"
              },
              typeHint: {}
            }
          }
        },
        S9: {
          type: "structure",
          members: {
            isNull: {
              type: "boolean"
            },
            booleanValue: {
              type: "boolean"
            },
            longValue: {
              type: "long"
            },
            doubleValue: {
              type: "double"
            },
            stringValue: {},
            blobValue: {
              type: "blob"
            },
            arrayValue: {
              shape: "Sf"
            }
          },
          union: true
        },
        Sf: {
          type: "structure",
          members: {
            booleanValues: {
              type: "list",
              member: {
                type: "boolean"
              }
            },
            longValues: {
              type: "list",
              member: {
                type: "long"
              }
            },
            doubleValues: {
              type: "list",
              member: {
                type: "double"
              }
            },
            stringValues: {
              type: "list",
              member: {}
            },
            arrayValues: {
              type: "list",
              member: {
                shape: "Sf"
              }
            }
          },
          union: true
        },
        Sq: {
          type: "list",
          member: {
            shape: "S9"
          }
        },
        S13: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              type: {
                type: "integer"
              },
              typeName: {},
              label: {},
              schemaName: {},
              tableName: {},
              isAutoIncrement: {
                type: "boolean"
              },
              isSigned: {
                type: "boolean"
              },
              isCurrency: {
                type: "boolean"
              },
              isCaseSensitive: {
                type: "boolean"
              },
              nullable: {
                type: "integer"
              },
              precision: {
                type: "integer"
              },
              scale: {
                type: "integer"
              },
              arrayBaseColumnType: {
                type: "integer"
              }
            }
          }
        },
        S1a: {
          type: "structure",
          members: {
            isNull: {
              type: "boolean"
            },
            bitValue: {
              type: "boolean"
            },
            bigIntValue: {
              type: "long"
            },
            intValue: {
              type: "integer"
            },
            doubleValue: {
              type: "double"
            },
            realValue: {
              type: "float"
            },
            stringValue: {},
            blobValue: {
              type: "blob"
            },
            arrayValues: {
              shape: "S1d"
            },
            structValue: {
              type: "structure",
              members: {
                attributes: {
                  shape: "S1d"
                }
              }
            }
          },
          union: true
        },
        S1d: {
          type: "list",
          member: {
            shape: "S1a"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/rds-data-2018-08-01.paginators.json
var require_rds_data_2018_08_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/rds-data-2018-08-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/rdsdataservice.js
var require_rdsdataservice2 = __commonJS({
  "node_modules/aws-sdk/clients/rdsdataservice.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["rdsdataservice"] = {};
    AWS2.RDSDataService = Service.defineService("rdsdataservice", ["2018-08-01"]);
    require_rdsdataservice();
    Object.defineProperty(apiLoader.services["rdsdataservice"], "2018-08-01", {
      get: function get() {
        var model = require_rds_data_2018_08_01_min();
        model.paginators = require_rds_data_2018_08_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.RDSDataService;
  }
});

// node_modules/aws-sdk/apis/amplify-2017-07-25.min.json
var require_amplify_2017_07_25_min = __commonJS({
  "node_modules/aws-sdk/apis/amplify-2017-07-25.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-07-25",
        endpointPrefix: "amplify",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Amplify",
        serviceFullName: "AWS Amplify",
        serviceId: "Amplify",
        signatureVersion: "v4",
        signingName: "amplify",
        uid: "amplify-2017-07-25"
      },
      operations: {
        CreateApp: {
          http: {
            requestUri: "/apps"
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              description: {},
              repository: {},
              platform: {},
              iamServiceRoleArn: {},
              oauthToken: {
                shape: "S7"
              },
              accessToken: {
                shape: "S8"
              },
              environmentVariables: {
                shape: "S9"
              },
              enableBranchAutoBuild: {
                type: "boolean"
              },
              enableBranchAutoDeletion: {
                type: "boolean"
              },
              enableBasicAuth: {
                type: "boolean"
              },
              basicAuthCredentials: {
                shape: "Sf"
              },
              customRules: {
                shape: "Sg"
              },
              tags: {
                shape: "Sm"
              },
              buildSpec: {
                shape: "Sp"
              },
              customHeaders: {},
              enableAutoBranchCreation: {
                type: "boolean"
              },
              autoBranchCreationPatterns: {
                shape: "Ss"
              },
              autoBranchCreationConfig: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "app"
            ],
            members: {
              app: {
                shape: "S12"
              }
            }
          }
        },
        CreateBackendEnvironment: {
          http: {
            requestUri: "/apps/{appId}/backendenvironments"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "environmentName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              environmentName: {},
              stackName: {},
              deploymentArtifacts: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "backendEnvironment"
            ],
            members: {
              backendEnvironment: {
                shape: "S1i"
              }
            }
          }
        },
        CreateBranch: {
          http: {
            requestUri: "/apps/{appId}/branches"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "branchName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              branchName: {},
              description: {},
              stage: {},
              framework: {},
              enableNotification: {
                type: "boolean"
              },
              enableAutoBuild: {
                type: "boolean"
              },
              environmentVariables: {
                shape: "S9"
              },
              basicAuthCredentials: {
                shape: "Sf"
              },
              enableBasicAuth: {
                type: "boolean"
              },
              enablePerformanceMode: {
                type: "boolean"
              },
              tags: {
                shape: "Sm"
              },
              buildSpec: {
                shape: "Sp"
              },
              ttl: {},
              displayName: {},
              enablePullRequestPreview: {
                type: "boolean"
              },
              pullRequestEnvironmentName: {},
              backendEnvironmentArn: {},
              backend: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "branch"
            ],
            members: {
              branch: {
                shape: "S1r"
              }
            }
          }
        },
        CreateDeployment: {
          http: {
            requestUri: "/apps/{appId}/branches/{branchName}/deployments"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "branchName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              branchName: {
                location: "uri",
                locationName: "branchName"
              },
              fileMap: {
                type: "map",
                key: {},
                value: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "fileUploadUrls",
              "zipUploadUrl"
            ],
            members: {
              jobId: {},
              fileUploadUrls: {
                type: "map",
                key: {},
                value: {}
              },
              zipUploadUrl: {}
            }
          }
        },
        CreateDomainAssociation: {
          http: {
            requestUri: "/apps/{appId}/domains"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "domainName",
              "subDomainSettings"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              domainName: {},
              enableAutoSubDomain: {
                type: "boolean"
              },
              subDomainSettings: {
                shape: "S2a"
              },
              autoSubDomainCreationPatterns: {
                shape: "S2d"
              },
              autoSubDomainIAMRole: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "domainAssociation"
            ],
            members: {
              domainAssociation: {
                shape: "S2h"
              }
            }
          }
        },
        CreateWebhook: {
          http: {
            requestUri: "/apps/{appId}/webhooks"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "branchName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              branchName: {},
              description: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "webhook"
            ],
            members: {
              webhook: {
                shape: "S2s"
              }
            }
          }
        },
        DeleteApp: {
          http: {
            method: "DELETE",
            requestUri: "/apps/{appId}"
          },
          input: {
            type: "structure",
            required: [
              "appId"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "app"
            ],
            members: {
              app: {
                shape: "S12"
              }
            }
          }
        },
        DeleteBackendEnvironment: {
          http: {
            method: "DELETE",
            requestUri: "/apps/{appId}/backendenvironments/{environmentName}"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "environmentName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              environmentName: {
                location: "uri",
                locationName: "environmentName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "backendEnvironment"
            ],
            members: {
              backendEnvironment: {
                shape: "S1i"
              }
            }
          }
        },
        DeleteBranch: {
          http: {
            method: "DELETE",
            requestUri: "/apps/{appId}/branches/{branchName}"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "branchName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              branchName: {
                location: "uri",
                locationName: "branchName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "branch"
            ],
            members: {
              branch: {
                shape: "S1r"
              }
            }
          }
        },
        DeleteDomainAssociation: {
          http: {
            method: "DELETE",
            requestUri: "/apps/{appId}/domains/{domainName}"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "domainName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              domainName: {
                location: "uri",
                locationName: "domainName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "domainAssociation"
            ],
            members: {
              domainAssociation: {
                shape: "S2h"
              }
            }
          }
        },
        DeleteJob: {
          http: {
            method: "DELETE",
            requestUri: "/apps/{appId}/branches/{branchName}/jobs/{jobId}"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "branchName",
              "jobId"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              branchName: {
                location: "uri",
                locationName: "branchName"
              },
              jobId: {
                location: "uri",
                locationName: "jobId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobSummary"
            ],
            members: {
              jobSummary: {
                shape: "S36"
              }
            }
          }
        },
        DeleteWebhook: {
          http: {
            method: "DELETE",
            requestUri: "/webhooks/{webhookId}"
          },
          input: {
            type: "structure",
            required: [
              "webhookId"
            ],
            members: {
              webhookId: {
                location: "uri",
                locationName: "webhookId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "webhook"
            ],
            members: {
              webhook: {
                shape: "S2s"
              }
            }
          }
        },
        GenerateAccessLogs: {
          http: {
            requestUri: "/apps/{appId}/accesslogs"
          },
          input: {
            type: "structure",
            required: [
              "domainName",
              "appId"
            ],
            members: {
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              domainName: {},
              appId: {
                location: "uri",
                locationName: "appId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              logUrl: {}
            }
          }
        },
        GetApp: {
          http: {
            method: "GET",
            requestUri: "/apps/{appId}"
          },
          input: {
            type: "structure",
            required: [
              "appId"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "app"
            ],
            members: {
              app: {
                shape: "S12"
              }
            }
          }
        },
        GetArtifactUrl: {
          http: {
            method: "GET",
            requestUri: "/artifacts/{artifactId}"
          },
          input: {
            type: "structure",
            required: [
              "artifactId"
            ],
            members: {
              artifactId: {
                location: "uri",
                locationName: "artifactId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "artifactId",
              "artifactUrl"
            ],
            members: {
              artifactId: {},
              artifactUrl: {}
            }
          }
        },
        GetBackendEnvironment: {
          http: {
            method: "GET",
            requestUri: "/apps/{appId}/backendenvironments/{environmentName}"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "environmentName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              environmentName: {
                location: "uri",
                locationName: "environmentName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "backendEnvironment"
            ],
            members: {
              backendEnvironment: {
                shape: "S1i"
              }
            }
          }
        },
        GetBranch: {
          http: {
            method: "GET",
            requestUri: "/apps/{appId}/branches/{branchName}"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "branchName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              branchName: {
                location: "uri",
                locationName: "branchName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "branch"
            ],
            members: {
              branch: {
                shape: "S1r"
              }
            }
          }
        },
        GetDomainAssociation: {
          http: {
            method: "GET",
            requestUri: "/apps/{appId}/domains/{domainName}"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "domainName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              domainName: {
                location: "uri",
                locationName: "domainName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "domainAssociation"
            ],
            members: {
              domainAssociation: {
                shape: "S2h"
              }
            }
          }
        },
        GetJob: {
          http: {
            method: "GET",
            requestUri: "/apps/{appId}/branches/{branchName}/jobs/{jobId}"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "branchName",
              "jobId"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              branchName: {
                location: "uri",
                locationName: "branchName"
              },
              jobId: {
                location: "uri",
                locationName: "jobId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "job"
            ],
            members: {
              job: {
                type: "structure",
                required: [
                  "summary",
                  "steps"
                ],
                members: {
                  summary: {
                    shape: "S36"
                  },
                  steps: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "stepName",
                        "startTime",
                        "status",
                        "endTime"
                      ],
                      members: {
                        stepName: {},
                        startTime: {
                          type: "timestamp"
                        },
                        status: {},
                        endTime: {
                          type: "timestamp"
                        },
                        logUrl: {},
                        artifactsUrl: {},
                        testArtifactsUrl: {},
                        testConfigUrl: {},
                        screenshots: {
                          type: "map",
                          key: {},
                          value: {}
                        },
                        statusReason: {},
                        context: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetWebhook: {
          http: {
            method: "GET",
            requestUri: "/webhooks/{webhookId}"
          },
          input: {
            type: "structure",
            required: [
              "webhookId"
            ],
            members: {
              webhookId: {
                location: "uri",
                locationName: "webhookId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "webhook"
            ],
            members: {
              webhook: {
                shape: "S2s"
              }
            }
          }
        },
        ListApps: {
          http: {
            method: "GET",
            requestUri: "/apps"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "apps"
            ],
            members: {
              apps: {
                type: "list",
                member: {
                  shape: "S12"
                }
              },
              nextToken: {}
            }
          }
        },
        ListArtifacts: {
          http: {
            method: "GET",
            requestUri: "/apps/{appId}/branches/{branchName}/jobs/{jobId}/artifacts"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "branchName",
              "jobId"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              branchName: {
                location: "uri",
                locationName: "branchName"
              },
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "artifacts"
            ],
            members: {
              artifacts: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "artifactFileName",
                    "artifactId"
                  ],
                  members: {
                    artifactFileName: {},
                    artifactId: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListBackendEnvironments: {
          http: {
            method: "GET",
            requestUri: "/apps/{appId}/backendenvironments"
          },
          input: {
            type: "structure",
            required: [
              "appId"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              environmentName: {
                location: "querystring",
                locationName: "environmentName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "backendEnvironments"
            ],
            members: {
              backendEnvironments: {
                type: "list",
                member: {
                  shape: "S1i"
                }
              },
              nextToken: {}
            }
          }
        },
        ListBranches: {
          http: {
            method: "GET",
            requestUri: "/apps/{appId}/branches"
          },
          input: {
            type: "structure",
            required: [
              "appId"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "branches"
            ],
            members: {
              branches: {
                type: "list",
                member: {
                  shape: "S1r"
                }
              },
              nextToken: {}
            }
          }
        },
        ListDomainAssociations: {
          http: {
            method: "GET",
            requestUri: "/apps/{appId}/domains"
          },
          input: {
            type: "structure",
            required: [
              "appId"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "domainAssociations"
            ],
            members: {
              domainAssociations: {
                type: "list",
                member: {
                  shape: "S2h"
                }
              },
              nextToken: {}
            }
          }
        },
        ListJobs: {
          http: {
            method: "GET",
            requestUri: "/apps/{appId}/branches/{branchName}/jobs"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "branchName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              branchName: {
                location: "uri",
                locationName: "branchName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobSummaries"
            ],
            members: {
              jobSummaries: {
                type: "list",
                member: {
                  shape: "S36"
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sm"
              }
            }
          }
        },
        ListWebhooks: {
          http: {
            method: "GET",
            requestUri: "/apps/{appId}/webhooks"
          },
          input: {
            type: "structure",
            required: [
              "appId"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "webhooks"
            ],
            members: {
              webhooks: {
                type: "list",
                member: {
                  shape: "S2s"
                }
              },
              nextToken: {}
            }
          }
        },
        StartDeployment: {
          http: {
            requestUri: "/apps/{appId}/branches/{branchName}/deployments/start"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "branchName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              branchName: {
                location: "uri",
                locationName: "branchName"
              },
              jobId: {},
              sourceUrl: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "jobSummary"
            ],
            members: {
              jobSummary: {
                shape: "S36"
              }
            }
          }
        },
        StartJob: {
          http: {
            requestUri: "/apps/{appId}/branches/{branchName}/jobs"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "branchName",
              "jobType"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              branchName: {
                location: "uri",
                locationName: "branchName"
              },
              jobId: {},
              jobType: {},
              jobReason: {},
              commitId: {},
              commitMessage: {},
              commitTime: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobSummary"
            ],
            members: {
              jobSummary: {
                shape: "S36"
              }
            }
          }
        },
        StopJob: {
          http: {
            method: "DELETE",
            requestUri: "/apps/{appId}/branches/{branchName}/jobs/{jobId}/stop"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "branchName",
              "jobId"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              branchName: {
                location: "uri",
                locationName: "branchName"
              },
              jobId: {
                location: "uri",
                locationName: "jobId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobSummary"
            ],
            members: {
              jobSummary: {
                shape: "S36"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateApp: {
          http: {
            requestUri: "/apps/{appId}"
          },
          input: {
            type: "structure",
            required: [
              "appId"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              name: {},
              description: {},
              platform: {},
              iamServiceRoleArn: {},
              environmentVariables: {
                shape: "S9"
              },
              enableBranchAutoBuild: {
                type: "boolean"
              },
              enableBranchAutoDeletion: {
                type: "boolean"
              },
              enableBasicAuth: {
                type: "boolean"
              },
              basicAuthCredentials: {
                shape: "Sf"
              },
              customRules: {
                shape: "Sg"
              },
              buildSpec: {
                shape: "Sp"
              },
              customHeaders: {},
              enableAutoBranchCreation: {
                type: "boolean"
              },
              autoBranchCreationPatterns: {
                shape: "Ss"
              },
              autoBranchCreationConfig: {
                shape: "Su"
              },
              repository: {},
              oauthToken: {
                shape: "S7"
              },
              accessToken: {
                shape: "S8"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "app"
            ],
            members: {
              app: {
                shape: "S12"
              }
            }
          }
        },
        UpdateBranch: {
          http: {
            requestUri: "/apps/{appId}/branches/{branchName}"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "branchName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              branchName: {
                location: "uri",
                locationName: "branchName"
              },
              description: {},
              framework: {},
              stage: {},
              enableNotification: {
                type: "boolean"
              },
              enableAutoBuild: {
                type: "boolean"
              },
              environmentVariables: {
                shape: "S9"
              },
              basicAuthCredentials: {
                shape: "Sf"
              },
              enableBasicAuth: {
                type: "boolean"
              },
              enablePerformanceMode: {
                type: "boolean"
              },
              buildSpec: {
                shape: "Sp"
              },
              ttl: {},
              displayName: {},
              enablePullRequestPreview: {
                type: "boolean"
              },
              pullRequestEnvironmentName: {},
              backendEnvironmentArn: {},
              backend: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "branch"
            ],
            members: {
              branch: {
                shape: "S1r"
              }
            }
          }
        },
        UpdateDomainAssociation: {
          http: {
            requestUri: "/apps/{appId}/domains/{domainName}"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "domainName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              domainName: {
                location: "uri",
                locationName: "domainName"
              },
              enableAutoSubDomain: {
                type: "boolean"
              },
              subDomainSettings: {
                shape: "S2a"
              },
              autoSubDomainCreationPatterns: {
                shape: "S2d"
              },
              autoSubDomainIAMRole: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "domainAssociation"
            ],
            members: {
              domainAssociation: {
                shape: "S2h"
              }
            }
          }
        },
        UpdateWebhook: {
          http: {
            requestUri: "/webhooks/{webhookId}"
          },
          input: {
            type: "structure",
            required: [
              "webhookId"
            ],
            members: {
              webhookId: {
                location: "uri",
                locationName: "webhookId"
              },
              branchName: {},
              description: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "webhook"
            ],
            members: {
              webhook: {
                shape: "S2s"
              }
            }
          }
        }
      },
      shapes: {
        S7: {
          type: "string",
          sensitive: true
        },
        S8: {
          type: "string",
          sensitive: true
        },
        S9: {
          type: "map",
          key: {},
          value: {}
        },
        Sf: {
          type: "string",
          sensitive: true
        },
        Sg: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "source",
              "target"
            ],
            members: {
              source: {},
              target: {},
              status: {},
              condition: {}
            }
          }
        },
        Sm: {
          type: "map",
          key: {},
          value: {}
        },
        Sp: {
          type: "string",
          sensitive: true
        },
        Ss: {
          type: "list",
          member: {}
        },
        Su: {
          type: "structure",
          members: {
            stage: {},
            framework: {},
            enableAutoBuild: {
              type: "boolean"
            },
            environmentVariables: {
              shape: "S9"
            },
            basicAuthCredentials: {
              shape: "Sf"
            },
            enableBasicAuth: {
              type: "boolean"
            },
            enablePerformanceMode: {
              type: "boolean"
            },
            buildSpec: {
              shape: "Sp"
            },
            enablePullRequestPreview: {
              type: "boolean"
            },
            pullRequestEnvironmentName: {}
          }
        },
        S12: {
          type: "structure",
          required: [
            "appId",
            "appArn",
            "name",
            "description",
            "repository",
            "platform",
            "createTime",
            "updateTime",
            "environmentVariables",
            "defaultDomain",
            "enableBranchAutoBuild",
            "enableBasicAuth"
          ],
          members: {
            appId: {},
            appArn: {},
            name: {},
            tags: {
              shape: "Sm"
            },
            description: {},
            repository: {},
            platform: {},
            createTime: {
              type: "timestamp"
            },
            updateTime: {
              type: "timestamp"
            },
            iamServiceRoleArn: {},
            environmentVariables: {
              shape: "S9"
            },
            defaultDomain: {},
            enableBranchAutoBuild: {
              type: "boolean"
            },
            enableBranchAutoDeletion: {
              type: "boolean"
            },
            enableBasicAuth: {
              type: "boolean"
            },
            basicAuthCredentials: {
              shape: "Sf"
            },
            customRules: {
              shape: "Sg"
            },
            productionBranch: {
              type: "structure",
              members: {
                lastDeployTime: {
                  type: "timestamp"
                },
                status: {},
                thumbnailUrl: {},
                branchName: {}
              }
            },
            buildSpec: {
              shape: "Sp"
            },
            customHeaders: {},
            enableAutoBranchCreation: {
              type: "boolean"
            },
            autoBranchCreationPatterns: {
              shape: "Ss"
            },
            autoBranchCreationConfig: {
              shape: "Su"
            },
            repositoryCloneMethod: {}
          }
        },
        S1i: {
          type: "structure",
          required: [
            "backendEnvironmentArn",
            "environmentName",
            "createTime",
            "updateTime"
          ],
          members: {
            backendEnvironmentArn: {},
            environmentName: {},
            stackName: {},
            deploymentArtifacts: {},
            createTime: {
              type: "timestamp"
            },
            updateTime: {
              type: "timestamp"
            }
          }
        },
        S1o: {
          type: "structure",
          members: {
            stackArn: {}
          }
        },
        S1r: {
          type: "structure",
          required: [
            "branchArn",
            "branchName",
            "description",
            "stage",
            "displayName",
            "enableNotification",
            "createTime",
            "updateTime",
            "environmentVariables",
            "enableAutoBuild",
            "customDomains",
            "framework",
            "activeJobId",
            "totalNumberOfJobs",
            "enableBasicAuth",
            "ttl",
            "enablePullRequestPreview"
          ],
          members: {
            branchArn: {},
            branchName: {},
            description: {},
            tags: {
              shape: "Sm"
            },
            stage: {},
            displayName: {},
            enableNotification: {
              type: "boolean"
            },
            createTime: {
              type: "timestamp"
            },
            updateTime: {
              type: "timestamp"
            },
            environmentVariables: {
              shape: "S9"
            },
            enableAutoBuild: {
              type: "boolean"
            },
            customDomains: {
              type: "list",
              member: {}
            },
            framework: {},
            activeJobId: {},
            totalNumberOfJobs: {},
            enableBasicAuth: {
              type: "boolean"
            },
            enablePerformanceMode: {
              type: "boolean"
            },
            thumbnailUrl: {},
            basicAuthCredentials: {
              shape: "Sf"
            },
            buildSpec: {
              shape: "Sp"
            },
            ttl: {},
            associatedResources: {
              type: "list",
              member: {}
            },
            enablePullRequestPreview: {
              type: "boolean"
            },
            pullRequestEnvironmentName: {},
            destinationBranch: {},
            sourceBranch: {},
            backendEnvironmentArn: {},
            backend: {
              shape: "S1o"
            }
          }
        },
        S2a: {
          type: "list",
          member: {
            shape: "S2b"
          }
        },
        S2b: {
          type: "structure",
          required: [
            "prefix",
            "branchName"
          ],
          members: {
            prefix: {},
            branchName: {}
          }
        },
        S2d: {
          type: "list",
          member: {}
        },
        S2h: {
          type: "structure",
          required: [
            "domainAssociationArn",
            "domainName",
            "enableAutoSubDomain",
            "domainStatus",
            "statusReason",
            "subDomains"
          ],
          members: {
            domainAssociationArn: {},
            domainName: {},
            enableAutoSubDomain: {
              type: "boolean"
            },
            autoSubDomainCreationPatterns: {
              shape: "S2d"
            },
            autoSubDomainIAMRole: {},
            domainStatus: {},
            statusReason: {},
            certificateVerificationDNSRecord: {},
            subDomains: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "subDomainSetting",
                  "verified",
                  "dnsRecord"
                ],
                members: {
                  subDomainSetting: {
                    shape: "S2b"
                  },
                  verified: {
                    type: "boolean"
                  },
                  dnsRecord: {}
                }
              }
            }
          }
        },
        S2s: {
          type: "structure",
          required: [
            "webhookArn",
            "webhookId",
            "webhookUrl",
            "branchName",
            "description",
            "createTime",
            "updateTime"
          ],
          members: {
            webhookArn: {},
            webhookId: {},
            webhookUrl: {},
            branchName: {},
            description: {},
            createTime: {
              type: "timestamp"
            },
            updateTime: {
              type: "timestamp"
            }
          }
        },
        S36: {
          type: "structure",
          required: [
            "jobArn",
            "jobId",
            "commitId",
            "commitMessage",
            "commitTime",
            "startTime",
            "status",
            "jobType"
          ],
          members: {
            jobArn: {},
            jobId: {},
            commitId: {},
            commitMessage: {},
            commitTime: {
              type: "timestamp"
            },
            startTime: {
              type: "timestamp"
            },
            status: {},
            endTime: {
              type: "timestamp"
            },
            jobType: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/amplify-2017-07-25.paginators.json
var require_amplify_2017_07_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/amplify-2017-07-25.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListApps: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "apps"
        },
        ListBranches: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "branches"
        },
        ListDomainAssociations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "domainAssociations"
        },
        ListJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "jobSummaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/amplify.js
var require_amplify = __commonJS({
  "node_modules/aws-sdk/clients/amplify.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["amplify"] = {};
    AWS2.Amplify = Service.defineService("amplify", ["2017-07-25"]);
    Object.defineProperty(apiLoader.services["amplify"], "2017-07-25", {
      get: function get() {
        var model = require_amplify_2017_07_25_min();
        model.paginators = require_amplify_2017_07_25_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Amplify;
  }
});

// node_modules/aws-sdk/apis/datasync-2018-11-09.min.json
var require_datasync_2018_11_09_min = __commonJS({
  "node_modules/aws-sdk/apis/datasync-2018-11-09.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-11-09",
        endpointPrefix: "datasync",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "DataSync",
        serviceFullName: "AWS DataSync",
        serviceId: "DataSync",
        signatureVersion: "v4",
        signingName: "datasync",
        targetPrefix: "FmrsService",
        uid: "datasync-2018-11-09"
      },
      operations: {
        AddStorageSystem: {
          input: {
            type: "structure",
            required: [
              "ServerConfiguration",
              "SystemType",
              "AgentArns",
              "ClientToken",
              "Credentials"
            ],
            members: {
              ServerConfiguration: {
                shape: "S2"
              },
              SystemType: {},
              AgentArns: {
                shape: "S6"
              },
              CloudWatchLogGroupArn: {},
              Tags: {
                shape: "S9"
              },
              Name: {},
              ClientToken: {
                idempotencyToken: true
              },
              Credentials: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "StorageSystemArn"
            ],
            members: {
              StorageSystemArn: {}
            }
          },
          endpoint: {
            hostPrefix: "discovery-"
          }
        },
        CancelTaskExecution: {
          input: {
            type: "structure",
            required: [
              "TaskExecutionArn"
            ],
            members: {
              TaskExecutionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateAgent: {
          input: {
            type: "structure",
            required: [
              "ActivationKey"
            ],
            members: {
              ActivationKey: {},
              AgentName: {},
              Tags: {
                shape: "S9"
              },
              VpcEndpointId: {},
              SubnetArns: {
                shape: "Sq"
              },
              SecurityGroupArns: {
                shape: "Ss"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AgentArn: {}
            }
          }
        },
        CreateLocationAzureBlob: {
          input: {
            type: "structure",
            required: [
              "ContainerUrl",
              "AuthenticationType",
              "AgentArns"
            ],
            members: {
              ContainerUrl: {},
              AuthenticationType: {},
              SasConfiguration: {
                shape: "Sy"
              },
              BlobType: {},
              AccessTier: {},
              Subdirectory: {},
              AgentArns: {
                shape: "S13"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {}
            }
          }
        },
        CreateLocationEfs: {
          input: {
            type: "structure",
            required: [
              "EfsFilesystemArn",
              "Ec2Config"
            ],
            members: {
              Subdirectory: {},
              EfsFilesystemArn: {},
              Ec2Config: {
                shape: "S19"
              },
              Tags: {
                shape: "S9"
              },
              AccessPointArn: {},
              FileSystemAccessRoleArn: {},
              InTransitEncryption: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {}
            }
          }
        },
        CreateLocationFsxLustre: {
          input: {
            type: "structure",
            required: [
              "FsxFilesystemArn",
              "SecurityGroupArns"
            ],
            members: {
              FsxFilesystemArn: {},
              SecurityGroupArns: {
                shape: "S1a"
              },
              Subdirectory: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {}
            }
          }
        },
        CreateLocationFsxOntap: {
          input: {
            type: "structure",
            required: [
              "Protocol",
              "SecurityGroupArns",
              "StorageVirtualMachineArn"
            ],
            members: {
              Protocol: {
                shape: "S1k"
              },
              SecurityGroupArns: {
                shape: "S1a"
              },
              StorageVirtualMachineArn: {},
              Subdirectory: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {}
            }
          }
        },
        CreateLocationFsxOpenZfs: {
          input: {
            type: "structure",
            required: [
              "FsxFilesystemArn",
              "Protocol",
              "SecurityGroupArns"
            ],
            members: {
              FsxFilesystemArn: {},
              Protocol: {
                shape: "S1k"
              },
              SecurityGroupArns: {
                shape: "S1a"
              },
              Subdirectory: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {}
            }
          }
        },
        CreateLocationFsxWindows: {
          input: {
            type: "structure",
            required: [
              "FsxFilesystemArn",
              "SecurityGroupArns",
              "User",
              "Password"
            ],
            members: {
              Subdirectory: {},
              FsxFilesystemArn: {},
              SecurityGroupArns: {
                shape: "S1a"
              },
              Tags: {
                shape: "S9"
              },
              User: {},
              Domain: {},
              Password: {
                shape: "S1s"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {}
            }
          }
        },
        CreateLocationHdfs: {
          input: {
            type: "structure",
            required: [
              "NameNodes",
              "AuthenticationType",
              "AgentArns"
            ],
            members: {
              Subdirectory: {},
              NameNodes: {
                shape: "S25"
              },
              BlockSize: {
                type: "integer"
              },
              ReplicationFactor: {
                type: "integer"
              },
              KmsKeyProviderUri: {},
              QopConfiguration: {
                shape: "S2c"
              },
              AuthenticationType: {},
              SimpleUser: {},
              KerberosPrincipal: {},
              KerberosKeytab: {
                type: "blob"
              },
              KerberosKrb5Conf: {
                type: "blob"
              },
              AgentArns: {
                shape: "S13"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {}
            }
          }
        },
        CreateLocationNfs: {
          input: {
            type: "structure",
            required: [
              "Subdirectory",
              "ServerHostname",
              "OnPremConfig"
            ],
            members: {
              Subdirectory: {},
              ServerHostname: {},
              OnPremConfig: {
                shape: "S2o"
              },
              MountOptions: {
                shape: "S1m"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {}
            }
          }
        },
        CreateLocationObjectStorage: {
          input: {
            type: "structure",
            required: [
              "ServerHostname",
              "BucketName",
              "AgentArns"
            ],
            members: {
              ServerHostname: {},
              ServerPort: {
                type: "integer"
              },
              ServerProtocol: {},
              Subdirectory: {},
              BucketName: {},
              AccessKey: {},
              SecretKey: {
                shape: "S2w"
              },
              AgentArns: {
                shape: "S13"
              },
              Tags: {
                shape: "S9"
              },
              ServerCertificate: {
                type: "blob"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {}
            }
          }
        },
        CreateLocationS3: {
          input: {
            type: "structure",
            required: [
              "S3BucketArn",
              "S3Config"
            ],
            members: {
              Subdirectory: {},
              S3BucketArn: {},
              S3StorageClass: {},
              S3Config: {
                shape: "S32"
              },
              AgentArns: {
                shape: "S13"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {}
            }
          }
        },
        CreateLocationSmb: {
          input: {
            type: "structure",
            required: [
              "Subdirectory",
              "ServerHostname",
              "User",
              "Password",
              "AgentArns"
            ],
            members: {
              Subdirectory: {},
              ServerHostname: {},
              User: {},
              Domain: {},
              Password: {
                shape: "S1s"
              },
              AgentArns: {
                shape: "S13"
              },
              MountOptions: {
                shape: "S1q"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {}
            }
          }
        },
        CreateTask: {
          input: {
            type: "structure",
            required: [
              "SourceLocationArn",
              "DestinationLocationArn"
            ],
            members: {
              SourceLocationArn: {},
              DestinationLocationArn: {},
              CloudWatchLogGroupArn: {},
              Name: {},
              Options: {
                shape: "S38"
              },
              Excludes: {
                shape: "S3o"
              },
              Schedule: {
                shape: "S3s"
              },
              Tags: {
                shape: "S9"
              },
              Includes: {
                shape: "S3o"
              },
              TaskReportConfig: {
                shape: "S3u"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TaskArn: {}
            }
          }
        },
        DeleteAgent: {
          input: {
            type: "structure",
            required: [
              "AgentArn"
            ],
            members: {
              AgentArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteLocation: {
          input: {
            type: "structure",
            required: [
              "LocationArn"
            ],
            members: {
              LocationArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteTask: {
          input: {
            type: "structure",
            required: [
              "TaskArn"
            ],
            members: {
              TaskArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeAgent: {
          input: {
            type: "structure",
            required: [
              "AgentArn"
            ],
            members: {
              AgentArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AgentArn: {},
              Name: {},
              Status: {},
              LastConnectionTime: {
                type: "timestamp"
              },
              CreationTime: {
                type: "timestamp"
              },
              EndpointType: {},
              PrivateLinkConfig: {
                type: "structure",
                members: {
                  VpcEndpointId: {},
                  PrivateLinkEndpoint: {},
                  SubnetArns: {
                    shape: "Sq"
                  },
                  SecurityGroupArns: {
                    shape: "Ss"
                  }
                }
              },
              Platform: {
                shape: "S4h"
              }
            }
          }
        },
        DescribeDiscoveryJob: {
          input: {
            type: "structure",
            required: [
              "DiscoveryJobArn"
            ],
            members: {
              DiscoveryJobArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StorageSystemArn: {},
              DiscoveryJobArn: {},
              CollectionDurationMinutes: {
                type: "integer"
              },
              Status: {},
              JobStartTime: {
                type: "timestamp"
              },
              JobEndTime: {
                type: "timestamp"
              }
            }
          },
          endpoint: {
            hostPrefix: "discovery-"
          }
        },
        DescribeLocationAzureBlob: {
          input: {
            type: "structure",
            required: [
              "LocationArn"
            ],
            members: {
              LocationArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {},
              LocationUri: {},
              AuthenticationType: {},
              BlobType: {},
              AccessTier: {},
              AgentArns: {
                shape: "S13"
              },
              CreationTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeLocationEfs: {
          input: {
            type: "structure",
            required: [
              "LocationArn"
            ],
            members: {
              LocationArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {},
              LocationUri: {},
              Ec2Config: {
                shape: "S19"
              },
              CreationTime: {
                type: "timestamp"
              },
              AccessPointArn: {},
              FileSystemAccessRoleArn: {},
              InTransitEncryption: {}
            }
          }
        },
        DescribeLocationFsxLustre: {
          input: {
            type: "structure",
            required: [
              "LocationArn"
            ],
            members: {
              LocationArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {},
              LocationUri: {},
              SecurityGroupArns: {
                shape: "S1a"
              },
              CreationTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeLocationFsxOntap: {
          input: {
            type: "structure",
            required: [
              "LocationArn"
            ],
            members: {
              LocationArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CreationTime: {
                type: "timestamp"
              },
              LocationArn: {},
              LocationUri: {},
              Protocol: {
                shape: "S1k"
              },
              SecurityGroupArns: {
                shape: "S1a"
              },
              StorageVirtualMachineArn: {},
              FsxFilesystemArn: {}
            }
          }
        },
        DescribeLocationFsxOpenZfs: {
          input: {
            type: "structure",
            required: [
              "LocationArn"
            ],
            members: {
              LocationArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {},
              LocationUri: {},
              SecurityGroupArns: {
                shape: "S1a"
              },
              Protocol: {
                shape: "S1k"
              },
              CreationTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeLocationFsxWindows: {
          input: {
            type: "structure",
            required: [
              "LocationArn"
            ],
            members: {
              LocationArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {},
              LocationUri: {},
              SecurityGroupArns: {
                shape: "S1a"
              },
              CreationTime: {
                type: "timestamp"
              },
              User: {},
              Domain: {}
            }
          }
        },
        DescribeLocationHdfs: {
          input: {
            type: "structure",
            required: [
              "LocationArn"
            ],
            members: {
              LocationArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {},
              LocationUri: {},
              NameNodes: {
                shape: "S25"
              },
              BlockSize: {
                type: "integer"
              },
              ReplicationFactor: {
                type: "integer"
              },
              KmsKeyProviderUri: {},
              QopConfiguration: {
                shape: "S2c"
              },
              AuthenticationType: {},
              SimpleUser: {},
              KerberosPrincipal: {},
              AgentArns: {
                shape: "S13"
              },
              CreationTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeLocationNfs: {
          input: {
            type: "structure",
            required: [
              "LocationArn"
            ],
            members: {
              LocationArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {},
              LocationUri: {},
              OnPremConfig: {
                shape: "S2o"
              },
              MountOptions: {
                shape: "S1m"
              },
              CreationTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeLocationObjectStorage: {
          input: {
            type: "structure",
            required: [
              "LocationArn"
            ],
            members: {
              LocationArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {},
              LocationUri: {},
              AccessKey: {},
              ServerPort: {
                type: "integer"
              },
              ServerProtocol: {},
              AgentArns: {
                shape: "S13"
              },
              CreationTime: {
                type: "timestamp"
              },
              ServerCertificate: {
                type: "blob"
              }
            }
          }
        },
        DescribeLocationS3: {
          input: {
            type: "structure",
            required: [
              "LocationArn"
            ],
            members: {
              LocationArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {},
              LocationUri: {},
              S3StorageClass: {},
              S3Config: {
                shape: "S32"
              },
              AgentArns: {
                shape: "S13"
              },
              CreationTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeLocationSmb: {
          input: {
            type: "structure",
            required: [
              "LocationArn"
            ],
            members: {
              LocationArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {},
              LocationUri: {},
              AgentArns: {
                shape: "S13"
              },
              User: {},
              Domain: {},
              MountOptions: {
                shape: "S1q"
              },
              CreationTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeStorageSystem: {
          input: {
            type: "structure",
            required: [
              "StorageSystemArn"
            ],
            members: {
              StorageSystemArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StorageSystemArn: {},
              ServerConfiguration: {
                shape: "S2"
              },
              SystemType: {},
              AgentArns: {
                shape: "S6"
              },
              Name: {},
              ErrorMessage: {},
              ConnectivityStatus: {},
              CloudWatchLogGroupArn: {},
              CreationTime: {
                type: "timestamp"
              },
              SecretsManagerArn: {}
            }
          },
          endpoint: {
            hostPrefix: "discovery-"
          }
        },
        DescribeStorageSystemResourceMetrics: {
          input: {
            type: "structure",
            required: [
              "DiscoveryJobArn",
              "ResourceType",
              "ResourceId"
            ],
            members: {
              DiscoveryJobArn: {},
              ResourceType: {},
              ResourceId: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Metrics: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Timestamp: {
                      type: "timestamp"
                    },
                    P95Metrics: {
                      type: "structure",
                      members: {
                        IOPS: {
                          type: "structure",
                          members: {
                            Read: {
                              type: "double"
                            },
                            Write: {
                              type: "double"
                            },
                            Other: {
                              type: "double"
                            },
                            Total: {
                              type: "double"
                            }
                          }
                        },
                        Throughput: {
                          type: "structure",
                          members: {
                            Read: {
                              type: "double"
                            },
                            Write: {
                              type: "double"
                            },
                            Other: {
                              type: "double"
                            },
                            Total: {
                              type: "double"
                            }
                          }
                        },
                        Latency: {
                          type: "structure",
                          members: {
                            Read: {
                              type: "double"
                            },
                            Write: {
                              type: "double"
                            },
                            Other: {
                              type: "double"
                            }
                          }
                        }
                      }
                    },
                    Capacity: {
                      type: "structure",
                      members: {
                        Used: {
                          type: "long"
                        },
                        Provisioned: {
                          type: "long"
                        },
                        LogicalUsed: {
                          type: "long"
                        },
                        ClusterCloudStorageUsed: {
                          type: "long"
                        }
                      }
                    },
                    ResourceId: {},
                    ResourceType: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "discovery-"
          }
        },
        DescribeStorageSystemResources: {
          input: {
            type: "structure",
            required: [
              "DiscoveryJobArn",
              "ResourceType"
            ],
            members: {
              DiscoveryJobArn: {},
              ResourceType: {},
              ResourceIds: {
                shape: "S5y"
              },
              Filter: {
                type: "map",
                key: {},
                value: {
                  type: "list",
                  member: {}
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceDetails: {
                type: "structure",
                members: {
                  NetAppONTAPSVMs: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        ClusterUuid: {},
                        ResourceId: {},
                        SvmName: {},
                        CifsShareCount: {
                          type: "long"
                        },
                        EnabledProtocols: {
                          type: "list",
                          member: {}
                        },
                        TotalCapacityUsed: {
                          type: "long"
                        },
                        TotalCapacityProvisioned: {
                          type: "long"
                        },
                        TotalLogicalCapacityUsed: {
                          type: "long"
                        },
                        MaxP95Performance: {
                          shape: "S68"
                        },
                        Recommendations: {
                          shape: "S69"
                        },
                        NfsExportedVolumes: {
                          type: "long"
                        },
                        RecommendationStatus: {},
                        TotalSnapshotCapacityUsed: {
                          type: "long"
                        },
                        LunCount: {
                          type: "long"
                        }
                      }
                    }
                  },
                  NetAppONTAPVolumes: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        VolumeName: {},
                        ResourceId: {},
                        CifsShareCount: {
                          type: "long"
                        },
                        SecurityStyle: {},
                        SvmUuid: {},
                        SvmName: {},
                        CapacityUsed: {
                          type: "long"
                        },
                        CapacityProvisioned: {
                          type: "long"
                        },
                        LogicalCapacityUsed: {
                          type: "long"
                        },
                        NfsExported: {
                          type: "boolean"
                        },
                        SnapshotCapacityUsed: {
                          type: "long"
                        },
                        MaxP95Performance: {
                          shape: "S68"
                        },
                        Recommendations: {
                          shape: "S69"
                        },
                        RecommendationStatus: {},
                        LunCount: {
                          type: "long"
                        }
                      }
                    }
                  },
                  NetAppONTAPClusters: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        CifsShareCount: {
                          type: "long"
                        },
                        NfsExportedVolumes: {
                          type: "long"
                        },
                        ResourceId: {},
                        ClusterName: {},
                        MaxP95Performance: {
                          shape: "S68"
                        },
                        ClusterBlockStorageSize: {
                          type: "long"
                        },
                        ClusterBlockStorageUsed: {
                          type: "long"
                        },
                        ClusterBlockStorageLogicalUsed: {
                          type: "long"
                        },
                        Recommendations: {
                          shape: "S69"
                        },
                        RecommendationStatus: {},
                        LunCount: {
                          type: "long"
                        },
                        ClusterCloudStorageUsed: {
                          type: "long"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "discovery-"
          }
        },
        DescribeTask: {
          input: {
            type: "structure",
            required: [
              "TaskArn"
            ],
            members: {
              TaskArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TaskArn: {},
              Status: {},
              Name: {},
              CurrentTaskExecutionArn: {},
              SourceLocationArn: {},
              DestinationLocationArn: {},
              CloudWatchLogGroupArn: {},
              SourceNetworkInterfaceArns: {
                type: "list",
                member: {}
              },
              DestinationNetworkInterfaceArns: {
                type: "list",
                member: {}
              },
              Options: {
                shape: "S38"
              },
              Excludes: {
                shape: "S3o"
              },
              Schedule: {
                shape: "S3s"
              },
              ErrorCode: {},
              ErrorDetail: {},
              CreationTime: {
                type: "timestamp"
              },
              Includes: {
                shape: "S3o"
              },
              TaskReportConfig: {
                shape: "S3u"
              }
            }
          }
        },
        DescribeTaskExecution: {
          input: {
            type: "structure",
            required: [
              "TaskExecutionArn"
            ],
            members: {
              TaskExecutionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TaskExecutionArn: {},
              Status: {},
              Options: {
                shape: "S38"
              },
              Excludes: {
                shape: "S3o"
              },
              Includes: {
                shape: "S3o"
              },
              StartTime: {
                type: "timestamp"
              },
              EstimatedFilesToTransfer: {
                type: "long"
              },
              EstimatedBytesToTransfer: {
                type: "long"
              },
              FilesTransferred: {
                type: "long"
              },
              BytesWritten: {
                type: "long"
              },
              BytesTransferred: {
                type: "long"
              },
              Result: {
                type: "structure",
                members: {
                  PrepareDuration: {
                    type: "long"
                  },
                  PrepareStatus: {},
                  TotalDuration: {
                    type: "long"
                  },
                  TransferDuration: {
                    type: "long"
                  },
                  TransferStatus: {},
                  VerifyDuration: {
                    type: "long"
                  },
                  VerifyStatus: {},
                  ErrorCode: {},
                  ErrorDetail: {}
                }
              },
              BytesCompressed: {
                type: "long"
              },
              TaskReportConfig: {
                shape: "S3u"
              },
              FilesDeleted: {
                type: "long"
              },
              FilesSkipped: {
                type: "long"
              },
              FilesVerified: {
                type: "long"
              },
              ReportResult: {
                type: "structure",
                members: {
                  Status: {},
                  ErrorCode: {},
                  ErrorDetail: {}
                }
              },
              EstimatedFilesToDelete: {
                type: "long"
              }
            }
          }
        },
        GenerateRecommendations: {
          input: {
            type: "structure",
            required: [
              "DiscoveryJobArn",
              "ResourceIds",
              "ResourceType"
            ],
            members: {
              DiscoveryJobArn: {},
              ResourceIds: {
                shape: "S5y"
              },
              ResourceType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "discovery-"
          }
        },
        ListAgents: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Agents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AgentArn: {},
                    Name: {},
                    Status: {},
                    Platform: {
                      shape: "S4h"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDiscoveryJobs: {
          input: {
            type: "structure",
            members: {
              StorageSystemArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DiscoveryJobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DiscoveryJobArn: {},
                    Status: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "discovery-"
          }
        },
        ListLocations: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Values",
                    "Operator"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      shape: "S7d"
                    },
                    Operator: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Locations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LocationArn: {},
                    LocationUri: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListStorageSystems: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StorageSystems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StorageSystemArn: {},
                    Name: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "discovery-"
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                type: "list",
                member: {
                  shape: "Sa"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTaskExecutions: {
          input: {
            type: "structure",
            members: {
              TaskArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TaskExecutions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TaskExecutionArn: {},
                    Status: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTasks: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Values",
                    "Operator"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      shape: "S7d"
                    },
                    Operator: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tasks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TaskArn: {},
                    Status: {},
                    Name: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        RemoveStorageSystem: {
          input: {
            type: "structure",
            required: [
              "StorageSystemArn"
            ],
            members: {
              StorageSystemArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "discovery-"
          }
        },
        StartDiscoveryJob: {
          input: {
            type: "structure",
            required: [
              "StorageSystemArn",
              "CollectionDurationMinutes",
              "ClientToken"
            ],
            members: {
              StorageSystemArn: {},
              CollectionDurationMinutes: {
                type: "integer"
              },
              ClientToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DiscoveryJobArn: {}
            }
          },
          endpoint: {
            hostPrefix: "discovery-"
          }
        },
        StartTaskExecution: {
          input: {
            type: "structure",
            required: [
              "TaskArn"
            ],
            members: {
              TaskArn: {},
              OverrideOptions: {
                shape: "S38"
              },
              Includes: {
                shape: "S3o"
              },
              Excludes: {
                shape: "S3o"
              },
              Tags: {
                shape: "S9"
              },
              TaskReportConfig: {
                shape: "S3u"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TaskExecutionArn: {}
            }
          }
        },
        StopDiscoveryJob: {
          input: {
            type: "structure",
            required: [
              "DiscoveryJobArn"
            ],
            members: {
              DiscoveryJobArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "discovery-"
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Keys"
            ],
            members: {
              ResourceArn: {},
              Keys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAgent: {
          input: {
            type: "structure",
            required: [
              "AgentArn"
            ],
            members: {
              AgentArn: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDiscoveryJob: {
          input: {
            type: "structure",
            required: [
              "DiscoveryJobArn",
              "CollectionDurationMinutes"
            ],
            members: {
              DiscoveryJobArn: {},
              CollectionDurationMinutes: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "discovery-"
          }
        },
        UpdateLocationAzureBlob: {
          input: {
            type: "structure",
            required: [
              "LocationArn"
            ],
            members: {
              LocationArn: {},
              Subdirectory: {},
              AuthenticationType: {},
              SasConfiguration: {
                shape: "Sy"
              },
              BlobType: {},
              AccessTier: {},
              AgentArns: {
                shape: "S13"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateLocationHdfs: {
          input: {
            type: "structure",
            required: [
              "LocationArn"
            ],
            members: {
              LocationArn: {},
              Subdirectory: {},
              NameNodes: {
                shape: "S25"
              },
              BlockSize: {
                type: "integer"
              },
              ReplicationFactor: {
                type: "integer"
              },
              KmsKeyProviderUri: {},
              QopConfiguration: {
                shape: "S2c"
              },
              AuthenticationType: {},
              SimpleUser: {},
              KerberosPrincipal: {},
              KerberosKeytab: {
                type: "blob"
              },
              KerberosKrb5Conf: {
                type: "blob"
              },
              AgentArns: {
                shape: "S13"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateLocationNfs: {
          input: {
            type: "structure",
            required: [
              "LocationArn"
            ],
            members: {
              LocationArn: {},
              Subdirectory: {},
              OnPremConfig: {
                shape: "S2o"
              },
              MountOptions: {
                shape: "S1m"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateLocationObjectStorage: {
          input: {
            type: "structure",
            required: [
              "LocationArn"
            ],
            members: {
              LocationArn: {},
              ServerPort: {
                type: "integer"
              },
              ServerProtocol: {},
              Subdirectory: {},
              AccessKey: {},
              SecretKey: {
                shape: "S2w"
              },
              AgentArns: {
                shape: "S13"
              },
              ServerCertificate: {
                type: "blob"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateLocationSmb: {
          input: {
            type: "structure",
            required: [
              "LocationArn"
            ],
            members: {
              LocationArn: {},
              Subdirectory: {},
              User: {},
              Domain: {},
              Password: {
                shape: "S1s"
              },
              AgentArns: {
                shape: "S13"
              },
              MountOptions: {
                shape: "S1q"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateStorageSystem: {
          input: {
            type: "structure",
            required: [
              "StorageSystemArn"
            ],
            members: {
              StorageSystemArn: {},
              ServerConfiguration: {
                shape: "S2"
              },
              AgentArns: {
                shape: "S6"
              },
              Name: {},
              CloudWatchLogGroupArn: {},
              Credentials: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "discovery-"
          }
        },
        UpdateTask: {
          input: {
            type: "structure",
            required: [
              "TaskArn"
            ],
            members: {
              TaskArn: {},
              Options: {
                shape: "S38"
              },
              Excludes: {
                shape: "S3o"
              },
              Schedule: {
                shape: "S3s"
              },
              Name: {},
              CloudWatchLogGroupArn: {},
              Includes: {
                shape: "S3o"
              },
              TaskReportConfig: {
                shape: "S3u"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateTaskExecution: {
          input: {
            type: "structure",
            required: [
              "TaskExecutionArn",
              "Options"
            ],
            members: {
              TaskExecutionArn: {},
              Options: {
                shape: "S38"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          required: [
            "ServerHostname"
          ],
          members: {
            ServerHostname: {},
            ServerPort: {
              type: "integer"
            }
          }
        },
        S6: {
          type: "list",
          member: {}
        },
        S9: {
          type: "list",
          member: {
            shape: "Sa"
          }
        },
        Sa: {
          type: "structure",
          required: [
            "Key"
          ],
          members: {
            Key: {},
            Value: {}
          }
        },
        Sf: {
          type: "structure",
          required: [
            "Username",
            "Password"
          ],
          members: {
            Username: {
              type: "string",
              sensitive: true
            },
            Password: {
              type: "string",
              sensitive: true
            }
          }
        },
        Sq: {
          type: "list",
          member: {}
        },
        Ss: {
          type: "list",
          member: {}
        },
        Sy: {
          type: "structure",
          required: [
            "Token"
          ],
          members: {
            Token: {
              type: "string",
              sensitive: true
            }
          }
        },
        S13: {
          type: "list",
          member: {}
        },
        S19: {
          type: "structure",
          required: [
            "SubnetArn",
            "SecurityGroupArns"
          ],
          members: {
            SubnetArn: {},
            SecurityGroupArns: {
              shape: "S1a"
            }
          }
        },
        S1a: {
          type: "list",
          member: {}
        },
        S1k: {
          type: "structure",
          members: {
            NFS: {
              type: "structure",
              members: {
                MountOptions: {
                  shape: "S1m"
                }
              }
            },
            SMB: {
              type: "structure",
              required: [
                "Password",
                "User"
              ],
              members: {
                Domain: {},
                MountOptions: {
                  shape: "S1q"
                },
                Password: {
                  shape: "S1s"
                },
                User: {}
              }
            }
          }
        },
        S1m: {
          type: "structure",
          members: {
            Version: {}
          }
        },
        S1q: {
          type: "structure",
          members: {
            Version: {}
          }
        },
        S1s: {
          type: "string",
          sensitive: true
        },
        S25: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Hostname",
              "Port"
            ],
            members: {
              Hostname: {},
              Port: {
                type: "integer"
              }
            }
          }
        },
        S2c: {
          type: "structure",
          members: {
            RpcProtection: {},
            DataTransferProtection: {}
          }
        },
        S2o: {
          type: "structure",
          required: [
            "AgentArns"
          ],
          members: {
            AgentArns: {
              shape: "S13"
            }
          }
        },
        S2w: {
          type: "string",
          sensitive: true
        },
        S32: {
          type: "structure",
          required: [
            "BucketAccessRoleArn"
          ],
          members: {
            BucketAccessRoleArn: {}
          }
        },
        S38: {
          type: "structure",
          members: {
            VerifyMode: {},
            OverwriteMode: {},
            Atime: {},
            Mtime: {},
            Uid: {},
            Gid: {},
            PreserveDeletedFiles: {},
            PreserveDevices: {},
            PosixPermissions: {},
            BytesPerSecond: {
              type: "long"
            },
            TaskQueueing: {},
            LogLevel: {},
            TransferMode: {},
            SecurityDescriptorCopyFlags: {},
            ObjectTags: {}
          }
        },
        S3o: {
          type: "list",
          member: {
            type: "structure",
            members: {
              FilterType: {},
              Value: {}
            }
          }
        },
        S3s: {
          type: "structure",
          required: [
            "ScheduleExpression"
          ],
          members: {
            ScheduleExpression: {}
          }
        },
        S3u: {
          type: "structure",
          members: {
            Destination: {
              type: "structure",
              members: {
                S3: {
                  type: "structure",
                  required: [
                    "S3BucketArn",
                    "BucketAccessRoleArn"
                  ],
                  members: {
                    Subdirectory: {},
                    S3BucketArn: {},
                    BucketAccessRoleArn: {}
                  }
                }
              }
            },
            OutputType: {},
            ReportLevel: {},
            ObjectVersionIds: {},
            Overrides: {
              type: "structure",
              members: {
                Transferred: {
                  shape: "S41"
                },
                Verified: {
                  shape: "S41"
                },
                Deleted: {
                  shape: "S41"
                },
                Skipped: {
                  shape: "S41"
                }
              }
            }
          }
        },
        S41: {
          type: "structure",
          members: {
            ReportLevel: {}
          }
        },
        S4h: {
          type: "structure",
          members: {
            Version: {}
          }
        },
        S5y: {
          type: "list",
          member: {}
        },
        S68: {
          type: "structure",
          members: {
            IopsRead: {
              type: "double"
            },
            IopsWrite: {
              type: "double"
            },
            IopsOther: {
              type: "double"
            },
            IopsTotal: {
              type: "double"
            },
            ThroughputRead: {
              type: "double"
            },
            ThroughputWrite: {
              type: "double"
            },
            ThroughputOther: {
              type: "double"
            },
            ThroughputTotal: {
              type: "double"
            },
            LatencyRead: {
              type: "double"
            },
            LatencyWrite: {
              type: "double"
            },
            LatencyOther: {
              type: "double"
            }
          }
        },
        S69: {
          type: "list",
          member: {
            type: "structure",
            members: {
              StorageType: {},
              StorageConfiguration: {
                type: "map",
                key: {},
                value: {}
              },
              EstimatedMonthlyStorageCost: {}
            }
          }
        },
        S7d: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/datasync-2018-11-09.paginators.json
var require_datasync_2018_11_09_paginators = __commonJS({
  "node_modules/aws-sdk/apis/datasync-2018-11-09.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeStorageSystemResourceMetrics: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Metrics"
        },
        DescribeStorageSystemResources: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAgents: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Agents"
        },
        ListDiscoveryJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "DiscoveryJobs"
        },
        ListLocations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Locations"
        },
        ListStorageSystems: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "StorageSystems"
        },
        ListTagsForResource: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Tags"
        },
        ListTaskExecutions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "TaskExecutions"
        },
        ListTasks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Tasks"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/datasync.js
var require_datasync = __commonJS({
  "node_modules/aws-sdk/clients/datasync.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["datasync"] = {};
    AWS2.DataSync = Service.defineService("datasync", ["2018-11-09"]);
    Object.defineProperty(apiLoader.services["datasync"], "2018-11-09", {
      get: function get() {
        var model = require_datasync_2018_11_09_min();
        model.paginators = require_datasync_2018_11_09_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.DataSync;
  }
});

// node_modules/aws-sdk/apis/robomaker-2018-06-29.min.json
var require_robomaker_2018_06_29_min = __commonJS({
  "node_modules/aws-sdk/apis/robomaker-2018-06-29.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-06-29",
        endpointPrefix: "robomaker",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "RoboMaker",
        serviceFullName: "AWS RoboMaker",
        serviceId: "RoboMaker",
        signatureVersion: "v4",
        signingName: "robomaker",
        uid: "robomaker-2018-06-29"
      },
      operations: {
        BatchDeleteWorlds: {
          http: {
            requestUri: "/batchDeleteWorlds"
          },
          input: {
            type: "structure",
            required: [
              "worlds"
            ],
            members: {
              worlds: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              unprocessedWorlds: {
                shape: "S2"
              }
            }
          }
        },
        BatchDescribeSimulationJob: {
          http: {
            requestUri: "/batchDescribeSimulationJob"
          },
          input: {
            type: "structure",
            required: [
              "jobs"
            ],
            members: {
              jobs: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    name: {},
                    status: {},
                    lastStartedAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    failureBehavior: {},
                    failureCode: {},
                    failureReason: {},
                    clientRequestToken: {},
                    outputLocation: {
                      shape: "Sh"
                    },
                    loggingConfig: {
                      shape: "Sk"
                    },
                    maxJobDurationInSeconds: {
                      type: "long"
                    },
                    simulationTimeMillis: {
                      type: "long"
                    },
                    iamRole: {},
                    robotApplications: {
                      shape: "Sp"
                    },
                    simulationApplications: {
                      shape: "S1d"
                    },
                    dataSources: {
                      shape: "S1h"
                    },
                    tags: {
                      shape: "S1o"
                    },
                    vpcConfig: {
                      shape: "S1r"
                    },
                    networkInterface: {
                      shape: "S1u"
                    },
                    compute: {
                      shape: "S1v"
                    }
                  }
                }
              },
              unprocessedJobs: {
                shape: "S2"
              }
            }
          }
        },
        CancelDeploymentJob: {
          http: {
            requestUri: "/cancelDeploymentJob"
          },
          input: {
            type: "structure",
            required: [
              "job"
            ],
            members: {
              job: {}
            },
            deprecated: true,
            deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
          },
          output: {
            type: "structure",
            members: {},
            deprecated: true,
            deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
          },
          deprecated: true,
          deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
        },
        CancelSimulationJob: {
          http: {
            requestUri: "/cancelSimulationJob"
          },
          input: {
            type: "structure",
            required: [
              "job"
            ],
            members: {
              job: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CancelSimulationJobBatch: {
          http: {
            requestUri: "/cancelSimulationJobBatch"
          },
          input: {
            type: "structure",
            required: [
              "batch"
            ],
            members: {
              batch: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CancelWorldExportJob: {
          http: {
            requestUri: "/cancelWorldExportJob"
          },
          input: {
            type: "structure",
            required: [
              "job"
            ],
            members: {
              job: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CancelWorldGenerationJob: {
          http: {
            requestUri: "/cancelWorldGenerationJob"
          },
          input: {
            type: "structure",
            required: [
              "job"
            ],
            members: {
              job: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateDeploymentJob: {
          http: {
            requestUri: "/createDeploymentJob"
          },
          input: {
            type: "structure",
            required: [
              "clientRequestToken",
              "fleet",
              "deploymentApplicationConfigs"
            ],
            members: {
              deploymentConfig: {
                shape: "S2a"
              },
              clientRequestToken: {
                idempotencyToken: true
              },
              fleet: {},
              deploymentApplicationConfigs: {
                shape: "S2e"
              },
              tags: {
                shape: "S1o"
              }
            },
            deprecated: true,
            deprecatedMessage: "AWS RoboMaker is unable to process this request as the support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              fleet: {},
              status: {},
              deploymentApplicationConfigs: {
                shape: "S2e"
              },
              failureReason: {},
              failureCode: {},
              createdAt: {
                type: "timestamp"
              },
              deploymentConfig: {
                shape: "S2a"
              },
              tags: {
                shape: "S1o"
              }
            },
            deprecated: true,
            deprecatedMessage: "AWS RoboMaker is unable to process this request as the support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
          },
          deprecated: true,
          deprecatedMessage: "AWS RoboMaker is unable to process this request as the support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
        },
        CreateFleet: {
          http: {
            requestUri: "/createFleet"
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              tags: {
                shape: "S1o"
              }
            },
            deprecated: true,
            deprecatedMessage: "AWS RoboMaker is unable to process this request as the support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              name: {},
              createdAt: {
                type: "timestamp"
              },
              tags: {
                shape: "S1o"
              }
            },
            deprecated: true,
            deprecatedMessage: "AWS RoboMaker is unable to process this request as the support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
          },
          deprecated: true,
          deprecatedMessage: "AWS RoboMaker is unable to process this request as the support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
        },
        CreateRobot: {
          http: {
            requestUri: "/createRobot"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "architecture",
              "greengrassGroupId"
            ],
            members: {
              name: {},
              architecture: {},
              greengrassGroupId: {},
              tags: {
                shape: "S1o"
              }
            },
            deprecated: true,
            deprecatedMessage: "AWS RoboMaker is unable to process this request as the support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              name: {},
              createdAt: {
                type: "timestamp"
              },
              greengrassGroupId: {},
              architecture: {},
              tags: {
                shape: "S1o"
              }
            },
            deprecated: true,
            deprecatedMessage: "AWS RoboMaker is unable to process this request as the support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
          },
          deprecated: true,
          deprecatedMessage: "AWS RoboMaker is unable to process this request as the support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
        },
        CreateRobotApplication: {
          http: {
            requestUri: "/createRobotApplication"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "robotSoftwareSuite"
            ],
            members: {
              name: {},
              sources: {
                shape: "S2t"
              },
              robotSoftwareSuite: {
                shape: "S2v"
              },
              tags: {
                shape: "S1o"
              },
              environment: {
                shape: "S2y"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              name: {},
              version: {},
              sources: {
                shape: "S31"
              },
              robotSoftwareSuite: {
                shape: "S2v"
              },
              lastUpdatedAt: {
                type: "timestamp"
              },
              revisionId: {},
              tags: {
                shape: "S1o"
              },
              environment: {
                shape: "S2y"
              }
            }
          }
        },
        CreateRobotApplicationVersion: {
          http: {
            requestUri: "/createRobotApplicationVersion"
          },
          input: {
            type: "structure",
            required: [
              "application"
            ],
            members: {
              application: {},
              currentRevisionId: {},
              s3Etags: {
                shape: "S35"
              },
              imageDigest: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              name: {},
              version: {},
              sources: {
                shape: "S31"
              },
              robotSoftwareSuite: {
                shape: "S2v"
              },
              lastUpdatedAt: {
                type: "timestamp"
              },
              revisionId: {},
              environment: {
                shape: "S2y"
              }
            }
          }
        },
        CreateSimulationApplication: {
          http: {
            requestUri: "/createSimulationApplication"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "simulationSoftwareSuite",
              "robotSoftwareSuite"
            ],
            members: {
              name: {},
              sources: {
                shape: "S2t"
              },
              simulationSoftwareSuite: {
                shape: "S39"
              },
              robotSoftwareSuite: {
                shape: "S2v"
              },
              renderingEngine: {
                shape: "S3c"
              },
              tags: {
                shape: "S1o"
              },
              environment: {
                shape: "S2y"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              name: {},
              version: {},
              sources: {
                shape: "S31"
              },
              simulationSoftwareSuite: {
                shape: "S39"
              },
              robotSoftwareSuite: {
                shape: "S2v"
              },
              renderingEngine: {
                shape: "S3c"
              },
              lastUpdatedAt: {
                type: "timestamp"
              },
              revisionId: {},
              tags: {
                shape: "S1o"
              },
              environment: {
                shape: "S2y"
              }
            }
          }
        },
        CreateSimulationApplicationVersion: {
          http: {
            requestUri: "/createSimulationApplicationVersion"
          },
          input: {
            type: "structure",
            required: [
              "application"
            ],
            members: {
              application: {},
              currentRevisionId: {},
              s3Etags: {
                shape: "S35"
              },
              imageDigest: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              name: {},
              version: {},
              sources: {
                shape: "S31"
              },
              simulationSoftwareSuite: {
                shape: "S39"
              },
              robotSoftwareSuite: {
                shape: "S2v"
              },
              renderingEngine: {
                shape: "S3c"
              },
              lastUpdatedAt: {
                type: "timestamp"
              },
              revisionId: {},
              environment: {
                shape: "S2y"
              }
            }
          }
        },
        CreateSimulationJob: {
          http: {
            requestUri: "/createSimulationJob"
          },
          input: {
            type: "structure",
            required: [
              "maxJobDurationInSeconds",
              "iamRole"
            ],
            members: {
              clientRequestToken: {
                idempotencyToken: true
              },
              outputLocation: {
                shape: "Sh"
              },
              loggingConfig: {
                shape: "Sk"
              },
              maxJobDurationInSeconds: {
                type: "long"
              },
              iamRole: {},
              failureBehavior: {},
              robotApplications: {
                shape: "Sp"
              },
              simulationApplications: {
                shape: "S1d"
              },
              dataSources: {
                shape: "S3j"
              },
              tags: {
                shape: "S1o"
              },
              vpcConfig: {
                shape: "S3m"
              },
              compute: {
                shape: "S3n"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              status: {},
              lastStartedAt: {
                type: "timestamp"
              },
              lastUpdatedAt: {
                type: "timestamp"
              },
              failureBehavior: {},
              failureCode: {},
              clientRequestToken: {},
              outputLocation: {
                shape: "Sh"
              },
              loggingConfig: {
                shape: "Sk"
              },
              maxJobDurationInSeconds: {
                type: "long"
              },
              simulationTimeMillis: {
                type: "long"
              },
              iamRole: {},
              robotApplications: {
                shape: "Sp"
              },
              simulationApplications: {
                shape: "S1d"
              },
              dataSources: {
                shape: "S1h"
              },
              tags: {
                shape: "S1o"
              },
              vpcConfig: {
                shape: "S1r"
              },
              compute: {
                shape: "S1v"
              }
            }
          }
        },
        CreateWorldExportJob: {
          http: {
            requestUri: "/createWorldExportJob"
          },
          input: {
            type: "structure",
            required: [
              "worlds",
              "outputLocation",
              "iamRole"
            ],
            members: {
              clientRequestToken: {
                idempotencyToken: true
              },
              worlds: {
                shape: "S2"
              },
              outputLocation: {
                shape: "Sh"
              },
              iamRole: {},
              tags: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              status: {},
              createdAt: {
                type: "timestamp"
              },
              failureCode: {},
              clientRequestToken: {},
              outputLocation: {
                shape: "Sh"
              },
              iamRole: {},
              tags: {
                shape: "S1o"
              }
            }
          }
        },
        CreateWorldGenerationJob: {
          http: {
            requestUri: "/createWorldGenerationJob"
          },
          input: {
            type: "structure",
            required: [
              "template",
              "worldCount"
            ],
            members: {
              clientRequestToken: {
                idempotencyToken: true
              },
              template: {},
              worldCount: {
                shape: "S3u"
              },
              tags: {
                shape: "S1o"
              },
              worldTags: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              status: {},
              createdAt: {
                type: "timestamp"
              },
              failureCode: {},
              clientRequestToken: {},
              template: {},
              worldCount: {
                shape: "S3u"
              },
              tags: {
                shape: "S1o"
              },
              worldTags: {
                shape: "S1o"
              }
            }
          }
        },
        CreateWorldTemplate: {
          http: {
            requestUri: "/createWorldTemplate"
          },
          input: {
            type: "structure",
            members: {
              clientRequestToken: {},
              name: {},
              templateBody: {},
              templateLocation: {
                shape: "S43"
              },
              tags: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              clientRequestToken: {},
              createdAt: {
                type: "timestamp"
              },
              name: {},
              tags: {
                shape: "S1o"
              }
            }
          }
        },
        DeleteFleet: {
          http: {
            requestUri: "/deleteFleet"
          },
          input: {
            type: "structure",
            required: [
              "fleet"
            ],
            members: {
              fleet: {}
            },
            deprecated: true,
            deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
          },
          output: {
            type: "structure",
            members: {},
            deprecated: true,
            deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
          },
          deprecated: true,
          deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
        },
        DeleteRobot: {
          http: {
            requestUri: "/deleteRobot"
          },
          input: {
            type: "structure",
            required: [
              "robot"
            ],
            members: {
              robot: {}
            },
            deprecated: true,
            deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
          },
          output: {
            type: "structure",
            members: {},
            deprecated: true,
            deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
          },
          deprecated: true,
          deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
        },
        DeleteRobotApplication: {
          http: {
            requestUri: "/deleteRobotApplication"
          },
          input: {
            type: "structure",
            required: [
              "application"
            ],
            members: {
              application: {},
              applicationVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSimulationApplication: {
          http: {
            requestUri: "/deleteSimulationApplication"
          },
          input: {
            type: "structure",
            required: [
              "application"
            ],
            members: {
              application: {},
              applicationVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteWorldTemplate: {
          http: {
            requestUri: "/deleteWorldTemplate"
          },
          input: {
            type: "structure",
            required: [
              "template"
            ],
            members: {
              template: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeregisterRobot: {
          http: {
            requestUri: "/deregisterRobot"
          },
          input: {
            type: "structure",
            required: [
              "fleet",
              "robot"
            ],
            members: {
              fleet: {},
              robot: {}
            },
            deprecated: true,
            deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
          },
          output: {
            type: "structure",
            members: {
              fleet: {},
              robot: {}
            },
            deprecated: true,
            deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
          },
          deprecated: true,
          deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
        },
        DescribeDeploymentJob: {
          http: {
            requestUri: "/describeDeploymentJob"
          },
          input: {
            type: "structure",
            required: [
              "job"
            ],
            members: {
              job: {}
            },
            deprecated: true,
            deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              fleet: {},
              status: {},
              deploymentConfig: {
                shape: "S2a"
              },
              deploymentApplicationConfigs: {
                shape: "S2e"
              },
              failureReason: {},
              failureCode: {},
              createdAt: {
                type: "timestamp"
              },
              robotDeploymentSummary: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    deploymentStartTime: {
                      type: "timestamp"
                    },
                    deploymentFinishTime: {
                      type: "timestamp"
                    },
                    status: {},
                    progressDetail: {
                      type: "structure",
                      members: {
                        currentProgress: {},
                        percentDone: {
                          type: "float"
                        },
                        estimatedTimeRemainingSeconds: {
                          type: "integer"
                        },
                        targetResource: {}
                      }
                    },
                    failureReason: {},
                    failureCode: {}
                  }
                }
              },
              tags: {
                shape: "S1o"
              }
            },
            deprecated: true,
            deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
          },
          deprecated: true,
          deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
        },
        DescribeFleet: {
          http: {
            requestUri: "/describeFleet"
          },
          input: {
            type: "structure",
            required: [
              "fleet"
            ],
            members: {
              fleet: {}
            },
            deprecated: true,
            deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
          },
          output: {
            type: "structure",
            members: {
              name: {},
              arn: {},
              robots: {
                shape: "S4s"
              },
              createdAt: {
                type: "timestamp"
              },
              lastDeploymentStatus: {},
              lastDeploymentJob: {},
              lastDeploymentTime: {
                type: "timestamp"
              },
              tags: {
                shape: "S1o"
              }
            },
            deprecated: true,
            deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
          },
          deprecated: true,
          deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
        },
        DescribeRobot: {
          http: {
            requestUri: "/describeRobot"
          },
          input: {
            type: "structure",
            required: [
              "robot"
            ],
            members: {
              robot: {}
            },
            deprecated: true,
            deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              name: {},
              fleetArn: {},
              status: {},
              greengrassGroupId: {},
              createdAt: {
                type: "timestamp"
              },
              architecture: {},
              lastDeploymentJob: {},
              lastDeploymentTime: {
                type: "timestamp"
              },
              tags: {
                shape: "S1o"
              }
            },
            deprecated: true,
            deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
          },
          deprecated: true,
          deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
        },
        DescribeRobotApplication: {
          http: {
            requestUri: "/describeRobotApplication"
          },
          input: {
            type: "structure",
            required: [
              "application"
            ],
            members: {
              application: {},
              applicationVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              name: {},
              version: {},
              sources: {
                shape: "S31"
              },
              robotSoftwareSuite: {
                shape: "S2v"
              },
              revisionId: {},
              lastUpdatedAt: {
                type: "timestamp"
              },
              tags: {
                shape: "S1o"
              },
              environment: {
                shape: "S2y"
              },
              imageDigest: {}
            }
          }
        },
        DescribeSimulationApplication: {
          http: {
            requestUri: "/describeSimulationApplication"
          },
          input: {
            type: "structure",
            required: [
              "application"
            ],
            members: {
              application: {},
              applicationVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              name: {},
              version: {},
              sources: {
                shape: "S31"
              },
              simulationSoftwareSuite: {
                shape: "S39"
              },
              robotSoftwareSuite: {
                shape: "S2v"
              },
              renderingEngine: {
                shape: "S3c"
              },
              revisionId: {},
              lastUpdatedAt: {
                type: "timestamp"
              },
              tags: {
                shape: "S1o"
              },
              environment: {
                shape: "S2y"
              },
              imageDigest: {}
            }
          }
        },
        DescribeSimulationJob: {
          http: {
            requestUri: "/describeSimulationJob"
          },
          input: {
            type: "structure",
            required: [
              "job"
            ],
            members: {
              job: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              name: {},
              status: {},
              lastStartedAt: {
                type: "timestamp"
              },
              lastUpdatedAt: {
                type: "timestamp"
              },
              failureBehavior: {},
              failureCode: {},
              failureReason: {},
              clientRequestToken: {},
              outputLocation: {
                shape: "Sh"
              },
              loggingConfig: {
                shape: "Sk"
              },
              maxJobDurationInSeconds: {
                type: "long"
              },
              simulationTimeMillis: {
                type: "long"
              },
              iamRole: {},
              robotApplications: {
                shape: "Sp"
              },
              simulationApplications: {
                shape: "S1d"
              },
              dataSources: {
                shape: "S1h"
              },
              tags: {
                shape: "S1o"
              },
              vpcConfig: {
                shape: "S1r"
              },
              networkInterface: {
                shape: "S1u"
              },
              compute: {
                shape: "S1v"
              }
            }
          }
        },
        DescribeSimulationJobBatch: {
          http: {
            requestUri: "/describeSimulationJobBatch"
          },
          input: {
            type: "structure",
            required: [
              "batch"
            ],
            members: {
              batch: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              status: {},
              lastUpdatedAt: {
                type: "timestamp"
              },
              createdAt: {
                type: "timestamp"
              },
              clientRequestToken: {},
              batchPolicy: {
                shape: "S55"
              },
              failureCode: {},
              failureReason: {},
              failedRequests: {
                shape: "S59"
              },
              pendingRequests: {
                shape: "S5d"
              },
              createdRequests: {
                shape: "S5e"
              },
              tags: {
                shape: "S1o"
              }
            }
          }
        },
        DescribeWorld: {
          http: {
            requestUri: "/describeWorld"
          },
          input: {
            type: "structure",
            required: [
              "world"
            ],
            members: {
              world: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              generationJob: {},
              template: {},
              createdAt: {
                type: "timestamp"
              },
              tags: {
                shape: "S1o"
              },
              worldDescriptionBody: {}
            }
          }
        },
        DescribeWorldExportJob: {
          http: {
            requestUri: "/describeWorldExportJob"
          },
          input: {
            type: "structure",
            required: [
              "job"
            ],
            members: {
              job: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              status: {},
              createdAt: {
                type: "timestamp"
              },
              failureCode: {},
              failureReason: {},
              clientRequestToken: {},
              worlds: {
                shape: "S2"
              },
              outputLocation: {
                shape: "Sh"
              },
              iamRole: {},
              tags: {
                shape: "S1o"
              }
            }
          }
        },
        DescribeWorldGenerationJob: {
          http: {
            requestUri: "/describeWorldGenerationJob"
          },
          input: {
            type: "structure",
            required: [
              "job"
            ],
            members: {
              job: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              status: {},
              createdAt: {
                type: "timestamp"
              },
              failureCode: {},
              failureReason: {},
              clientRequestToken: {},
              template: {},
              worldCount: {
                shape: "S3u"
              },
              finishedWorldsSummary: {
                type: "structure",
                members: {
                  finishedCount: {
                    type: "integer"
                  },
                  succeededWorlds: {
                    shape: "S2"
                  },
                  failureSummary: {
                    type: "structure",
                    members: {
                      totalFailureCount: {
                        type: "integer"
                      },
                      failures: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            failureCode: {},
                            sampleFailureReason: {},
                            failureCount: {
                              type: "integer"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              tags: {
                shape: "S1o"
              },
              worldTags: {
                shape: "S1o"
              }
            }
          }
        },
        DescribeWorldTemplate: {
          http: {
            requestUri: "/describeWorldTemplate"
          },
          input: {
            type: "structure",
            required: [
              "template"
            ],
            members: {
              template: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              clientRequestToken: {},
              name: {},
              createdAt: {
                type: "timestamp"
              },
              lastUpdatedAt: {
                type: "timestamp"
              },
              tags: {
                shape: "S1o"
              },
              version: {}
            }
          }
        },
        GetWorldTemplateBody: {
          http: {
            requestUri: "/getWorldTemplateBody"
          },
          input: {
            type: "structure",
            members: {
              template: {},
              generationJob: {}
            }
          },
          output: {
            type: "structure",
            members: {
              templateBody: {}
            }
          }
        },
        ListDeploymentJobs: {
          http: {
            requestUri: "/listDeploymentJobs"
          },
          input: {
            type: "structure",
            members: {
              filters: {
                shape: "S5z"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            },
            deprecated: true,
            deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
          },
          output: {
            type: "structure",
            members: {
              deploymentJobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    fleet: {},
                    status: {},
                    deploymentApplicationConfigs: {
                      shape: "S2e"
                    },
                    deploymentConfig: {
                      shape: "S2a"
                    },
                    failureReason: {},
                    failureCode: {},
                    createdAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            },
            deprecated: true,
            deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
          },
          deprecated: true,
          deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
        },
        ListFleets: {
          http: {
            requestUri: "/listFleets"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filters: {
                shape: "S5z"
              }
            },
            deprecated: true,
            deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
          },
          output: {
            type: "structure",
            members: {
              fleetDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    lastDeploymentStatus: {},
                    lastDeploymentJob: {},
                    lastDeploymentTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            },
            deprecated: true,
            deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
          },
          deprecated: true,
          deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
        },
        ListRobotApplications: {
          http: {
            requestUri: "/listRobotApplications"
          },
          input: {
            type: "structure",
            members: {
              versionQualifier: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filters: {
                shape: "S5z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              robotApplicationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    arn: {},
                    version: {},
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    robotSoftwareSuite: {
                      shape: "S2v"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListRobots: {
          http: {
            requestUri: "/listRobots"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filters: {
                shape: "S5z"
              }
            },
            deprecated: true,
            deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
          },
          output: {
            type: "structure",
            members: {
              robots: {
                shape: "S4s"
              },
              nextToken: {}
            },
            deprecated: true,
            deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
          },
          deprecated: true,
          deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
        },
        ListSimulationApplications: {
          http: {
            requestUri: "/listSimulationApplications"
          },
          input: {
            type: "structure",
            members: {
              versionQualifier: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filters: {
                shape: "S5z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              simulationApplicationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    arn: {},
                    version: {},
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    robotSoftwareSuite: {
                      shape: "S2v"
                    },
                    simulationSoftwareSuite: {
                      shape: "S39"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSimulationJobBatches: {
          http: {
            requestUri: "/listSimulationJobBatches"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filters: {
                shape: "S5z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              simulationJobBatchSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    createdAt: {
                      type: "timestamp"
                    },
                    status: {},
                    failedRequestCount: {
                      type: "integer"
                    },
                    pendingRequestCount: {
                      type: "integer"
                    },
                    createdRequestCount: {
                      type: "integer"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSimulationJobs: {
          http: {
            requestUri: "/listSimulationJobs"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filters: {
                shape: "S5z"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "simulationJobSummaries"
            ],
            members: {
              simulationJobSummaries: {
                shape: "S5e"
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S1o"
              }
            }
          }
        },
        ListWorldExportJobs: {
          http: {
            requestUri: "/listWorldExportJobs"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filters: {
                shape: "S5z"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "worldExportJobSummaries"
            ],
            members: {
              worldExportJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    status: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    worlds: {
                      shape: "S2"
                    },
                    outputLocation: {
                      shape: "Sh"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListWorldGenerationJobs: {
          http: {
            requestUri: "/listWorldGenerationJobs"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filters: {
                shape: "S5z"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "worldGenerationJobSummaries"
            ],
            members: {
              worldGenerationJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    template: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    status: {},
                    worldCount: {
                      shape: "S3u"
                    },
                    succeededWorldCount: {
                      type: "integer"
                    },
                    failedWorldCount: {
                      type: "integer"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListWorldTemplates: {
          http: {
            requestUri: "/listWorldTemplates"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              templateSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    name: {},
                    version: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListWorlds: {
          http: {
            requestUri: "/listWorlds"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filters: {
                shape: "S5z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              worldSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    generationJob: {},
                    template: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        RegisterRobot: {
          http: {
            requestUri: "/registerRobot"
          },
          input: {
            type: "structure",
            required: [
              "fleet",
              "robot"
            ],
            members: {
              fleet: {},
              robot: {}
            },
            deprecated: true,
            deprecatedMessage: "AWS RoboMaker is unable to process this request as the support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
          },
          output: {
            type: "structure",
            members: {
              fleet: {},
              robot: {}
            },
            deprecated: true,
            deprecatedMessage: "AWS RoboMaker is unable to process this request as the support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
          },
          deprecated: true,
          deprecatedMessage: "AWS RoboMaker is unable to process this request as the support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
        },
        RestartSimulationJob: {
          http: {
            requestUri: "/restartSimulationJob"
          },
          input: {
            type: "structure",
            required: [
              "job"
            ],
            members: {
              job: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartSimulationJobBatch: {
          http: {
            requestUri: "/startSimulationJobBatch"
          },
          input: {
            type: "structure",
            required: [
              "createSimulationJobRequests"
            ],
            members: {
              clientRequestToken: {
                idempotencyToken: true
              },
              batchPolicy: {
                shape: "S55"
              },
              createSimulationJobRequests: {
                shape: "S5d"
              },
              tags: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              status: {},
              createdAt: {
                type: "timestamp"
              },
              clientRequestToken: {},
              batchPolicy: {
                shape: "S55"
              },
              failureCode: {},
              failureReason: {},
              failedRequests: {
                shape: "S59"
              },
              pendingRequests: {
                shape: "S5d"
              },
              createdRequests: {
                shape: "S5e"
              },
              tags: {
                shape: "S1o"
              }
            }
          }
        },
        SyncDeploymentJob: {
          http: {
            requestUri: "/syncDeploymentJob"
          },
          input: {
            type: "structure",
            required: [
              "clientRequestToken",
              "fleet"
            ],
            members: {
              clientRequestToken: {
                idempotencyToken: true
              },
              fleet: {}
            },
            deprecated: true,
            deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              fleet: {},
              status: {},
              deploymentConfig: {
                shape: "S2a"
              },
              deploymentApplicationConfigs: {
                shape: "S2e"
              },
              failureReason: {},
              failureCode: {},
              createdAt: {
                type: "timestamp"
              }
            },
            deprecated: true,
            deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
          },
          deprecated: true,
          deprecatedMessage: "Support for the AWS RoboMaker application deployment feature has ended. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/fleets.html."
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateRobotApplication: {
          http: {
            requestUri: "/updateRobotApplication"
          },
          input: {
            type: "structure",
            required: [
              "application",
              "robotSoftwareSuite"
            ],
            members: {
              application: {},
              sources: {
                shape: "S2t"
              },
              robotSoftwareSuite: {
                shape: "S2v"
              },
              currentRevisionId: {},
              environment: {
                shape: "S2y"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              name: {},
              version: {},
              sources: {
                shape: "S31"
              },
              robotSoftwareSuite: {
                shape: "S2v"
              },
              lastUpdatedAt: {
                type: "timestamp"
              },
              revisionId: {},
              environment: {
                shape: "S2y"
              }
            }
          }
        },
        UpdateSimulationApplication: {
          http: {
            requestUri: "/updateSimulationApplication"
          },
          input: {
            type: "structure",
            required: [
              "application",
              "simulationSoftwareSuite",
              "robotSoftwareSuite"
            ],
            members: {
              application: {},
              sources: {
                shape: "S2t"
              },
              simulationSoftwareSuite: {
                shape: "S39"
              },
              robotSoftwareSuite: {
                shape: "S2v"
              },
              renderingEngine: {
                shape: "S3c"
              },
              currentRevisionId: {},
              environment: {
                shape: "S2y"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              name: {},
              version: {},
              sources: {
                shape: "S31"
              },
              simulationSoftwareSuite: {
                shape: "S39"
              },
              robotSoftwareSuite: {
                shape: "S2v"
              },
              renderingEngine: {
                shape: "S3c"
              },
              lastUpdatedAt: {
                type: "timestamp"
              },
              revisionId: {},
              environment: {
                shape: "S2y"
              }
            }
          }
        },
        UpdateWorldTemplate: {
          http: {
            requestUri: "/updateWorldTemplate"
          },
          input: {
            type: "structure",
            required: [
              "template"
            ],
            members: {
              template: {},
              name: {},
              templateBody: {},
              templateLocation: {
                shape: "S43"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              name: {},
              createdAt: {
                type: "timestamp"
              },
              lastUpdatedAt: {
                type: "timestamp"
              }
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "list",
          member: {}
        },
        Sh: {
          type: "structure",
          members: {
            s3Bucket: {},
            s3Prefix: {}
          }
        },
        Sk: {
          type: "structure",
          members: {
            recordAllRosTopics: {
              deprecated: true,
              deprecatedMessage: "AWS RoboMaker is ending support for ROS software suite. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/software-support-policy.html.",
              type: "boolean"
            }
          }
        },
        Sp: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "application",
              "launchConfig"
            ],
            members: {
              application: {},
              applicationVersion: {},
              launchConfig: {
                shape: "Ss"
              },
              uploadConfigurations: {
                shape: "S15"
              },
              useDefaultUploadConfigurations: {
                deprecated: true,
                deprecatedMessage: "AWS RoboMaker is ending support for ROS software suite. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/software-support-policy.html.",
                type: "boolean"
              },
              tools: {
                shape: "S19"
              },
              useDefaultTools: {
                deprecated: true,
                deprecatedMessage: "AWS RoboMaker is ending support for ROS software suite. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/software-support-policy.html.",
                type: "boolean"
              }
            }
          }
        },
        Ss: {
          type: "structure",
          members: {
            packageName: {},
            launchFile: {},
            environmentVariables: {
              shape: "Su"
            },
            portForwardingConfig: {
              type: "structure",
              members: {
                portMappings: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "jobPort",
                      "applicationPort"
                    ],
                    members: {
                      jobPort: {
                        type: "integer"
                      },
                      applicationPort: {
                        type: "integer"
                      },
                      enableOnPublicIp: {
                        type: "boolean"
                      }
                    }
                  }
                }
              }
            },
            streamUI: {
              type: "boolean"
            },
            command: {
              type: "list",
              member: {}
            }
          }
        },
        Su: {
          type: "map",
          key: {},
          value: {}
        },
        S15: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "path",
              "uploadBehavior"
            ],
            members: {
              name: {},
              path: {},
              uploadBehavior: {}
            }
          }
        },
        S19: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "command"
            ],
            members: {
              streamUI: {
                type: "boolean"
              },
              name: {},
              command: {},
              streamOutputToCloudWatch: {
                type: "boolean"
              },
              exitBehavior: {}
            }
          }
        },
        S1d: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "application",
              "launchConfig"
            ],
            members: {
              application: {},
              applicationVersion: {},
              launchConfig: {
                shape: "Ss"
              },
              uploadConfigurations: {
                shape: "S15"
              },
              worldConfigs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    world: {}
                  }
                }
              },
              useDefaultUploadConfigurations: {
                deprecated: true,
                deprecatedMessage: "AWS RoboMaker is ending support for ROS software suite. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/software-support-policy.html.",
                type: "boolean"
              },
              tools: {
                shape: "S19"
              },
              useDefaultTools: {
                deprecated: true,
                deprecatedMessage: "AWS RoboMaker is ending support for ROS software suite. For additional information, see https://docs.aws.amazon.com/robomaker/latest/dg/software-support-policy.html.",
                type: "boolean"
              }
            }
          }
        },
        S1h: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              s3Bucket: {},
              s3Keys: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    s3Key: {},
                    etag: {}
                  }
                }
              },
              type: {},
              destination: {}
            }
          }
        },
        S1o: {
          type: "map",
          key: {},
          value: {}
        },
        S1r: {
          type: "structure",
          members: {
            subnets: {
              shape: "S1s"
            },
            securityGroups: {
              shape: "S1t"
            },
            vpcId: {},
            assignPublicIp: {
              type: "boolean"
            }
          }
        },
        S1s: {
          type: "list",
          member: {}
        },
        S1t: {
          type: "list",
          member: {}
        },
        S1u: {
          type: "structure",
          members: {
            networkInterfaceId: {},
            privateIpAddress: {},
            publicIpAddress: {}
          }
        },
        S1v: {
          type: "structure",
          members: {
            simulationUnitLimit: {
              type: "integer"
            },
            computeType: {},
            gpuUnitLimit: {
              type: "integer"
            }
          }
        },
        S2a: {
          type: "structure",
          members: {
            concurrentDeploymentPercentage: {
              type: "integer"
            },
            failureThresholdPercentage: {
              type: "integer"
            },
            robotDeploymentTimeoutInSeconds: {
              type: "long"
            },
            downloadConditionFile: {
              type: "structure",
              required: [
                "bucket",
                "key"
              ],
              members: {
                bucket: {},
                key: {},
                etag: {}
              }
            }
          }
        },
        S2e: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "application",
              "applicationVersion",
              "launchConfig"
            ],
            members: {
              application: {},
              applicationVersion: {},
              launchConfig: {
                type: "structure",
                required: [
                  "packageName",
                  "launchFile"
                ],
                members: {
                  packageName: {},
                  preLaunchFile: {},
                  launchFile: {},
                  postLaunchFile: {},
                  environmentVariables: {
                    shape: "Su"
                  }
                }
              }
            }
          }
        },
        S2t: {
          type: "list",
          member: {
            type: "structure",
            members: {
              s3Bucket: {},
              s3Key: {},
              architecture: {}
            }
          }
        },
        S2v: {
          type: "structure",
          members: {
            name: {},
            version: {}
          }
        },
        S2y: {
          type: "structure",
          members: {
            uri: {}
          }
        },
        S31: {
          type: "list",
          member: {
            type: "structure",
            members: {
              s3Bucket: {},
              s3Key: {},
              etag: {},
              architecture: {}
            }
          }
        },
        S35: {
          type: "list",
          member: {}
        },
        S39: {
          type: "structure",
          members: {
            name: {},
            version: {}
          }
        },
        S3c: {
          type: "structure",
          members: {
            name: {},
            version: {}
          }
        },
        S3j: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "s3Bucket",
              "s3Keys"
            ],
            members: {
              name: {},
              s3Bucket: {},
              s3Keys: {
                type: "list",
                member: {}
              },
              type: {},
              destination: {}
            }
          }
        },
        S3m: {
          type: "structure",
          required: [
            "subnets"
          ],
          members: {
            subnets: {
              shape: "S1s"
            },
            securityGroups: {
              shape: "S1t"
            },
            assignPublicIp: {
              type: "boolean"
            }
          }
        },
        S3n: {
          type: "structure",
          members: {
            simulationUnitLimit: {
              type: "integer"
            },
            computeType: {},
            gpuUnitLimit: {
              type: "integer"
            }
          }
        },
        S3u: {
          type: "structure",
          members: {
            floorplanCount: {
              type: "integer"
            },
            interiorCountPerFloorplan: {
              type: "integer"
            }
          }
        },
        S43: {
          type: "structure",
          required: [
            "s3Bucket",
            "s3Key"
          ],
          members: {
            s3Bucket: {},
            s3Key: {}
          }
        },
        S4s: {
          type: "list",
          member: {
            type: "structure",
            members: {
              arn: {},
              name: {},
              fleetArn: {},
              status: {},
              greenGrassGroupId: {},
              createdAt: {
                type: "timestamp"
              },
              architecture: {},
              lastDeploymentJob: {},
              lastDeploymentTime: {
                type: "timestamp"
              }
            }
          }
        },
        S55: {
          type: "structure",
          members: {
            timeoutInSeconds: {
              type: "long"
            },
            maxConcurrency: {
              type: "integer"
            }
          }
        },
        S59: {
          type: "list",
          member: {
            type: "structure",
            members: {
              request: {
                shape: "S5b"
              },
              failureReason: {},
              failureCode: {},
              failedAt: {
                type: "timestamp"
              }
            }
          }
        },
        S5b: {
          type: "structure",
          required: [
            "maxJobDurationInSeconds"
          ],
          members: {
            outputLocation: {
              shape: "Sh"
            },
            loggingConfig: {
              shape: "Sk"
            },
            maxJobDurationInSeconds: {
              type: "long"
            },
            iamRole: {},
            failureBehavior: {},
            useDefaultApplications: {
              type: "boolean"
            },
            robotApplications: {
              shape: "Sp"
            },
            simulationApplications: {
              shape: "S1d"
            },
            dataSources: {
              shape: "S3j"
            },
            vpcConfig: {
              shape: "S3m"
            },
            compute: {
              shape: "S3n"
            },
            tags: {
              shape: "S1o"
            }
          }
        },
        S5d: {
          type: "list",
          member: {
            shape: "S5b"
          }
        },
        S5e: {
          type: "list",
          member: {
            type: "structure",
            members: {
              arn: {},
              lastUpdatedAt: {
                type: "timestamp"
              },
              name: {},
              status: {},
              simulationApplicationNames: {
                type: "list",
                member: {}
              },
              robotApplicationNames: {
                type: "list",
                member: {}
              },
              dataSourceNames: {
                type: "list",
                member: {}
              },
              computeType: {}
            }
          }
        },
        S5z: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              values: {
                type: "list",
                member: {}
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/robomaker-2018-06-29.paginators.json
var require_robomaker_2018_06_29_paginators = __commonJS({
  "node_modules/aws-sdk/apis/robomaker-2018-06-29.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListDeploymentJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "deploymentJobs"
        },
        ListFleets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "fleetDetails"
        },
        ListRobotApplications: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "robotApplicationSummaries"
        },
        ListRobots: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "robots"
        },
        ListSimulationApplications: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "simulationApplicationSummaries"
        },
        ListSimulationJobBatches: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "simulationJobBatchSummaries"
        },
        ListSimulationJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "simulationJobSummaries"
        },
        ListWorldExportJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "worldExportJobSummaries"
        },
        ListWorldGenerationJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "worldGenerationJobSummaries"
        },
        ListWorldTemplates: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "templateSummaries"
        },
        ListWorlds: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "worldSummaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/robomaker.js
var require_robomaker = __commonJS({
  "node_modules/aws-sdk/clients/robomaker.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["robomaker"] = {};
    AWS2.RoboMaker = Service.defineService("robomaker", ["2018-06-29"]);
    Object.defineProperty(apiLoader.services["robomaker"], "2018-06-29", {
      get: function get() {
        var model = require_robomaker_2018_06_29_min();
        model.paginators = require_robomaker_2018_06_29_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.RoboMaker;
  }
});

// node_modules/aws-sdk/apis/transfer-2018-11-05.min.json
var require_transfer_2018_11_05_min = __commonJS({
  "node_modules/aws-sdk/apis/transfer-2018-11-05.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-11-05",
        endpointPrefix: "transfer",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "AWS Transfer",
        serviceFullName: "AWS Transfer Family",
        serviceId: "Transfer",
        signatureVersion: "v4",
        signingName: "transfer",
        targetPrefix: "TransferService",
        uid: "transfer-2018-11-05"
      },
      operations: {
        CreateAccess: {
          input: {
            type: "structure",
            required: [
              "Role",
              "ServerId",
              "ExternalId"
            ],
            members: {
              HomeDirectory: {},
              HomeDirectoryType: {},
              HomeDirectoryMappings: {
                shape: "S4"
              },
              Policy: {},
              PosixProfile: {
                shape: "Sa"
              },
              Role: {},
              ServerId: {},
              ExternalId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ServerId",
              "ExternalId"
            ],
            members: {
              ServerId: {},
              ExternalId: {}
            }
          }
        },
        CreateAgreement: {
          input: {
            type: "structure",
            required: [
              "ServerId",
              "LocalProfileId",
              "PartnerProfileId",
              "BaseDirectory",
              "AccessRole"
            ],
            members: {
              Description: {},
              ServerId: {},
              LocalProfileId: {},
              PartnerProfileId: {},
              BaseDirectory: {},
              AccessRole: {},
              Status: {},
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "AgreementId"
            ],
            members: {
              AgreementId: {}
            }
          }
        },
        CreateConnector: {
          input: {
            type: "structure",
            required: [
              "Url",
              "AccessRole"
            ],
            members: {
              Url: {},
              As2Config: {
                shape: "St"
              },
              AccessRole: {},
              LoggingRole: {},
              Tags: {
                shape: "Sl"
              },
              SftpConfig: {
                shape: "S11"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ConnectorId"
            ],
            members: {
              ConnectorId: {}
            }
          }
        },
        CreateProfile: {
          input: {
            type: "structure",
            required: [
              "As2Id",
              "ProfileType"
            ],
            members: {
              As2Id: {},
              ProfileType: {},
              CertificateIds: {
                shape: "S1a"
              },
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ProfileId"
            ],
            members: {
              ProfileId: {}
            }
          }
        },
        CreateServer: {
          input: {
            type: "structure",
            members: {
              Certificate: {},
              Domain: {},
              EndpointDetails: {
                shape: "S1g"
              },
              EndpointType: {},
              HostKey: {
                shape: "S1q"
              },
              IdentityProviderDetails: {
                shape: "S1r"
              },
              IdentityProviderType: {},
              LoggingRole: {},
              PostAuthenticationLoginBanner: {},
              PreAuthenticationLoginBanner: {},
              Protocols: {
                shape: "S1z"
              },
              ProtocolDetails: {
                shape: "S21"
              },
              SecurityPolicyName: {},
              Tags: {
                shape: "Sl"
              },
              WorkflowDetails: {
                shape: "S28"
              },
              StructuredLogDestinations: {
                shape: "S2d"
              },
              S3StorageOptions: {
                shape: "S2f"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ServerId"
            ],
            members: {
              ServerId: {}
            }
          }
        },
        CreateUser: {
          input: {
            type: "structure",
            required: [
              "Role",
              "ServerId",
              "UserName"
            ],
            members: {
              HomeDirectory: {},
              HomeDirectoryType: {},
              HomeDirectoryMappings: {
                shape: "S4"
              },
              Policy: {},
              PosixProfile: {
                shape: "Sa"
              },
              Role: {},
              ServerId: {},
              SshPublicKeyBody: {},
              Tags: {
                shape: "Sl"
              },
              UserName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ServerId",
              "UserName"
            ],
            members: {
              ServerId: {},
              UserName: {}
            }
          }
        },
        CreateWorkflow: {
          input: {
            type: "structure",
            required: [
              "Steps"
            ],
            members: {
              Description: {},
              Steps: {
                shape: "S2o"
              },
              OnExceptionSteps: {
                shape: "S2o"
              },
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "WorkflowId"
            ],
            members: {
              WorkflowId: {}
            }
          }
        },
        DeleteAccess: {
          input: {
            type: "structure",
            required: [
              "ServerId",
              "ExternalId"
            ],
            members: {
              ServerId: {},
              ExternalId: {}
            }
          }
        },
        DeleteAgreement: {
          input: {
            type: "structure",
            required: [
              "AgreementId",
              "ServerId"
            ],
            members: {
              AgreementId: {},
              ServerId: {}
            }
          }
        },
        DeleteCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateId"
            ],
            members: {
              CertificateId: {}
            }
          }
        },
        DeleteConnector: {
          input: {
            type: "structure",
            required: [
              "ConnectorId"
            ],
            members: {
              ConnectorId: {}
            }
          }
        },
        DeleteHostKey: {
          input: {
            type: "structure",
            required: [
              "ServerId",
              "HostKeyId"
            ],
            members: {
              ServerId: {},
              HostKeyId: {}
            }
          }
        },
        DeleteProfile: {
          input: {
            type: "structure",
            required: [
              "ProfileId"
            ],
            members: {
              ProfileId: {}
            }
          }
        },
        DeleteServer: {
          input: {
            type: "structure",
            required: [
              "ServerId"
            ],
            members: {
              ServerId: {}
            }
          }
        },
        DeleteSshPublicKey: {
          input: {
            type: "structure",
            required: [
              "ServerId",
              "SshPublicKeyId",
              "UserName"
            ],
            members: {
              ServerId: {},
              SshPublicKeyId: {},
              UserName: {}
            }
          }
        },
        DeleteUser: {
          input: {
            type: "structure",
            required: [
              "ServerId",
              "UserName"
            ],
            members: {
              ServerId: {},
              UserName: {}
            }
          }
        },
        DeleteWorkflow: {
          input: {
            type: "structure",
            required: [
              "WorkflowId"
            ],
            members: {
              WorkflowId: {}
            }
          }
        },
        DescribeAccess: {
          input: {
            type: "structure",
            required: [
              "ServerId",
              "ExternalId"
            ],
            members: {
              ServerId: {},
              ExternalId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ServerId",
              "Access"
            ],
            members: {
              ServerId: {},
              Access: {
                type: "structure",
                members: {
                  HomeDirectory: {},
                  HomeDirectoryMappings: {
                    shape: "S4"
                  },
                  HomeDirectoryType: {},
                  Policy: {},
                  PosixProfile: {
                    shape: "Sa"
                  },
                  Role: {},
                  ExternalId: {}
                }
              }
            }
          }
        },
        DescribeAgreement: {
          input: {
            type: "structure",
            required: [
              "AgreementId",
              "ServerId"
            ],
            members: {
              AgreementId: {},
              ServerId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Agreement"
            ],
            members: {
              Agreement: {
                type: "structure",
                required: [
                  "Arn"
                ],
                members: {
                  Arn: {},
                  AgreementId: {},
                  Description: {},
                  Status: {},
                  ServerId: {},
                  LocalProfileId: {},
                  PartnerProfileId: {},
                  BaseDirectory: {},
                  AccessRole: {},
                  Tags: {
                    shape: "Sl"
                  }
                }
              }
            }
          }
        },
        DescribeCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateId"
            ],
            members: {
              CertificateId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Certificate"
            ],
            members: {
              Certificate: {
                type: "structure",
                required: [
                  "Arn"
                ],
                members: {
                  Arn: {},
                  CertificateId: {},
                  Usage: {},
                  Status: {},
                  Certificate: {
                    shape: "S41"
                  },
                  CertificateChain: {
                    shape: "S42"
                  },
                  ActiveDate: {
                    type: "timestamp"
                  },
                  InactiveDate: {
                    type: "timestamp"
                  },
                  Serial: {},
                  NotBeforeDate: {
                    type: "timestamp"
                  },
                  NotAfterDate: {
                    type: "timestamp"
                  },
                  Type: {},
                  Description: {},
                  Tags: {
                    shape: "Sl"
                  }
                }
              }
            }
          }
        },
        DescribeConnector: {
          input: {
            type: "structure",
            required: [
              "ConnectorId"
            ],
            members: {
              ConnectorId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Connector"
            ],
            members: {
              Connector: {
                type: "structure",
                required: [
                  "Arn"
                ],
                members: {
                  Arn: {},
                  ConnectorId: {},
                  Url: {},
                  As2Config: {
                    shape: "St"
                  },
                  AccessRole: {},
                  LoggingRole: {},
                  Tags: {
                    shape: "Sl"
                  },
                  SftpConfig: {
                    shape: "S11"
                  }
                }
              }
            }
          }
        },
        DescribeExecution: {
          input: {
            type: "structure",
            required: [
              "ExecutionId",
              "WorkflowId"
            ],
            members: {
              ExecutionId: {},
              WorkflowId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "WorkflowId",
              "Execution"
            ],
            members: {
              WorkflowId: {},
              Execution: {
                type: "structure",
                members: {
                  ExecutionId: {},
                  InitialFileLocation: {
                    shape: "S4d"
                  },
                  ServiceMetadata: {
                    shape: "S4h"
                  },
                  ExecutionRole: {},
                  LoggingConfiguration: {
                    type: "structure",
                    members: {
                      LoggingRole: {},
                      LogGroupName: {}
                    }
                  },
                  PosixProfile: {
                    shape: "Sa"
                  },
                  Status: {},
                  Results: {
                    type: "structure",
                    members: {
                      Steps: {
                        shape: "S4o"
                      },
                      OnExceptionSteps: {
                        shape: "S4o"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeHostKey: {
          input: {
            type: "structure",
            required: [
              "ServerId",
              "HostKeyId"
            ],
            members: {
              ServerId: {},
              HostKeyId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "HostKey"
            ],
            members: {
              HostKey: {
                type: "structure",
                required: [
                  "Arn"
                ],
                members: {
                  Arn: {},
                  HostKeyId: {},
                  HostKeyFingerprint: {},
                  Description: {},
                  Type: {},
                  DateImported: {
                    type: "timestamp"
                  },
                  Tags: {
                    shape: "Sl"
                  }
                }
              }
            }
          }
        },
        DescribeProfile: {
          input: {
            type: "structure",
            required: [
              "ProfileId"
            ],
            members: {
              ProfileId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Profile"
            ],
            members: {
              Profile: {
                type: "structure",
                required: [
                  "Arn"
                ],
                members: {
                  Arn: {},
                  ProfileId: {},
                  ProfileType: {},
                  As2Id: {},
                  CertificateIds: {
                    shape: "S1a"
                  },
                  Tags: {
                    shape: "Sl"
                  }
                }
              }
            }
          }
        },
        DescribeSecurityPolicy: {
          input: {
            type: "structure",
            required: [
              "SecurityPolicyName"
            ],
            members: {
              SecurityPolicyName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "SecurityPolicy"
            ],
            members: {
              SecurityPolicy: {
                type: "structure",
                required: [
                  "SecurityPolicyName"
                ],
                members: {
                  Fips: {
                    type: "boolean"
                  },
                  SecurityPolicyName: {},
                  SshCiphers: {
                    shape: "S58"
                  },
                  SshKexs: {
                    shape: "S58"
                  },
                  SshMacs: {
                    shape: "S58"
                  },
                  TlsCiphers: {
                    shape: "S58"
                  }
                }
              }
            }
          }
        },
        DescribeServer: {
          input: {
            type: "structure",
            required: [
              "ServerId"
            ],
            members: {
              ServerId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Server"
            ],
            members: {
              Server: {
                type: "structure",
                required: [
                  "Arn"
                ],
                members: {
                  Arn: {},
                  Certificate: {},
                  ProtocolDetails: {
                    shape: "S21"
                  },
                  Domain: {},
                  EndpointDetails: {
                    shape: "S1g"
                  },
                  EndpointType: {},
                  HostKeyFingerprint: {},
                  IdentityProviderDetails: {
                    shape: "S1r"
                  },
                  IdentityProviderType: {},
                  LoggingRole: {},
                  PostAuthenticationLoginBanner: {},
                  PreAuthenticationLoginBanner: {},
                  Protocols: {
                    shape: "S1z"
                  },
                  SecurityPolicyName: {},
                  ServerId: {},
                  State: {},
                  Tags: {
                    shape: "Sl"
                  },
                  UserCount: {
                    type: "integer"
                  },
                  WorkflowDetails: {
                    shape: "S28"
                  },
                  StructuredLogDestinations: {
                    shape: "S2d"
                  },
                  S3StorageOptions: {
                    shape: "S2f"
                  }
                }
              }
            }
          }
        },
        DescribeUser: {
          input: {
            type: "structure",
            required: [
              "ServerId",
              "UserName"
            ],
            members: {
              ServerId: {},
              UserName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ServerId",
              "User"
            ],
            members: {
              ServerId: {},
              User: {
                type: "structure",
                required: [
                  "Arn"
                ],
                members: {
                  Arn: {},
                  HomeDirectory: {},
                  HomeDirectoryMappings: {
                    shape: "S4"
                  },
                  HomeDirectoryType: {},
                  Policy: {},
                  PosixProfile: {
                    shape: "Sa"
                  },
                  Role: {},
                  SshPublicKeys: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "DateImported",
                        "SshPublicKeyBody",
                        "SshPublicKeyId"
                      ],
                      members: {
                        DateImported: {
                          type: "timestamp"
                        },
                        SshPublicKeyBody: {},
                        SshPublicKeyId: {}
                      }
                    }
                  },
                  Tags: {
                    shape: "Sl"
                  },
                  UserName: {}
                }
              }
            }
          }
        },
        DescribeWorkflow: {
          input: {
            type: "structure",
            required: [
              "WorkflowId"
            ],
            members: {
              WorkflowId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Workflow"
            ],
            members: {
              Workflow: {
                type: "structure",
                required: [
                  "Arn"
                ],
                members: {
                  Arn: {},
                  Description: {},
                  Steps: {
                    shape: "S2o"
                  },
                  OnExceptionSteps: {
                    shape: "S2o"
                  },
                  WorkflowId: {},
                  Tags: {
                    shape: "Sl"
                  }
                }
              }
            }
          }
        },
        ImportCertificate: {
          input: {
            type: "structure",
            required: [
              "Usage",
              "Certificate"
            ],
            members: {
              Usage: {},
              Certificate: {
                shape: "S41"
              },
              CertificateChain: {
                shape: "S42"
              },
              PrivateKey: {
                type: "string",
                sensitive: true
              },
              ActiveDate: {
                type: "timestamp"
              },
              InactiveDate: {
                type: "timestamp"
              },
              Description: {},
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CertificateId"
            ],
            members: {
              CertificateId: {}
            }
          }
        },
        ImportHostKey: {
          input: {
            type: "structure",
            required: [
              "ServerId",
              "HostKeyBody"
            ],
            members: {
              ServerId: {},
              HostKeyBody: {
                shape: "S1q"
              },
              Description: {},
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ServerId",
              "HostKeyId"
            ],
            members: {
              ServerId: {},
              HostKeyId: {}
            }
          }
        },
        ImportSshPublicKey: {
          input: {
            type: "structure",
            required: [
              "ServerId",
              "SshPublicKeyBody",
              "UserName"
            ],
            members: {
              ServerId: {},
              SshPublicKeyBody: {},
              UserName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ServerId",
              "SshPublicKeyId",
              "UserName"
            ],
            members: {
              ServerId: {},
              SshPublicKeyId: {},
              UserName: {}
            }
          }
        },
        ListAccesses: {
          input: {
            type: "structure",
            required: [
              "ServerId"
            ],
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              ServerId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ServerId",
              "Accesses"
            ],
            members: {
              NextToken: {},
              ServerId: {},
              Accesses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    HomeDirectory: {},
                    HomeDirectoryType: {},
                    Role: {},
                    ExternalId: {}
                  }
                }
              }
            }
          }
        },
        ListAgreements: {
          input: {
            type: "structure",
            required: [
              "ServerId"
            ],
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              ServerId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Agreements"
            ],
            members: {
              NextToken: {},
              Agreements: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    AgreementId: {},
                    Description: {},
                    Status: {},
                    ServerId: {},
                    LocalProfileId: {},
                    PartnerProfileId: {}
                  }
                }
              }
            }
          }
        },
        ListCertificates: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Certificates"
            ],
            members: {
              NextToken: {},
              Certificates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    CertificateId: {},
                    Usage: {},
                    Status: {},
                    ActiveDate: {
                      type: "timestamp"
                    },
                    InactiveDate: {
                      type: "timestamp"
                    },
                    Type: {},
                    Description: {}
                  }
                }
              }
            }
          }
        },
        ListConnectors: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Connectors"
            ],
            members: {
              NextToken: {},
              Connectors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    ConnectorId: {},
                    Url: {}
                  }
                }
              }
            }
          }
        },
        ListExecutions: {
          input: {
            type: "structure",
            required: [
              "WorkflowId"
            ],
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              WorkflowId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "WorkflowId",
              "Executions"
            ],
            members: {
              NextToken: {},
              WorkflowId: {},
              Executions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ExecutionId: {},
                    InitialFileLocation: {
                      shape: "S4d"
                    },
                    ServiceMetadata: {
                      shape: "S4h"
                    },
                    Status: {}
                  }
                }
              }
            }
          }
        },
        ListHostKeys: {
          input: {
            type: "structure",
            required: [
              "ServerId"
            ],
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              ServerId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ServerId",
              "HostKeys"
            ],
            members: {
              NextToken: {},
              ServerId: {},
              HostKeys: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Arn"
                  ],
                  members: {
                    Arn: {},
                    HostKeyId: {},
                    Fingerprint: {},
                    Description: {},
                    Type: {},
                    DateImported: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListProfiles: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              ProfileType: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Profiles"
            ],
            members: {
              NextToken: {},
              Profiles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    ProfileId: {},
                    As2Id: {},
                    ProfileType: {}
                  }
                }
              }
            }
          }
        },
        ListSecurityPolicies: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "SecurityPolicyNames"
            ],
            members: {
              NextToken: {},
              SecurityPolicyNames: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ListServers: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Servers"
            ],
            members: {
              NextToken: {},
              Servers: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Arn"
                  ],
                  members: {
                    Arn: {},
                    Domain: {},
                    IdentityProviderType: {},
                    EndpointType: {},
                    LoggingRole: {},
                    ServerId: {},
                    State: {},
                    UserCount: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              NextToken: {},
              Tags: {
                shape: "Sl"
              }
            }
          }
        },
        ListUsers: {
          input: {
            type: "structure",
            required: [
              "ServerId"
            ],
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              ServerId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ServerId",
              "Users"
            ],
            members: {
              NextToken: {},
              ServerId: {},
              Users: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Arn"
                  ],
                  members: {
                    Arn: {},
                    HomeDirectory: {},
                    HomeDirectoryType: {},
                    Role: {},
                    SshPublicKeyCount: {
                      type: "integer"
                    },
                    UserName: {}
                  }
                }
              }
            }
          }
        },
        ListWorkflows: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Workflows"
            ],
            members: {
              NextToken: {},
              Workflows: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WorkflowId: {},
                    Description: {},
                    Arn: {}
                  }
                }
              }
            }
          }
        },
        SendWorkflowStepState: {
          input: {
            type: "structure",
            required: [
              "WorkflowId",
              "ExecutionId",
              "Token",
              "Status"
            ],
            members: {
              WorkflowId: {},
              ExecutionId: {},
              Token: {},
              Status: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartFileTransfer: {
          input: {
            type: "structure",
            required: [
              "ConnectorId"
            ],
            members: {
              ConnectorId: {},
              SendFilePaths: {
                shape: "S7b"
              },
              RetrieveFilePaths: {
                shape: "S7b"
              },
              LocalDirectoryPath: {},
              RemoteDirectoryPath: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "TransferId"
            ],
            members: {
              TransferId: {}
            }
          }
        },
        StartServer: {
          input: {
            type: "structure",
            required: [
              "ServerId"
            ],
            members: {
              ServerId: {}
            }
          }
        },
        StopServer: {
          input: {
            type: "structure",
            required: [
              "ServerId"
            ],
            members: {
              ServerId: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "Arn",
              "Tags"
            ],
            members: {
              Arn: {},
              Tags: {
                shape: "Sl"
              }
            }
          }
        },
        TestConnection: {
          input: {
            type: "structure",
            required: [
              "ConnectorId"
            ],
            members: {
              ConnectorId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectorId: {},
              Status: {},
              StatusMessage: {}
            }
          }
        },
        TestIdentityProvider: {
          input: {
            type: "structure",
            required: [
              "ServerId",
              "UserName"
            ],
            members: {
              ServerId: {},
              ServerProtocol: {},
              SourceIp: {},
              UserName: {},
              UserPassword: {
                type: "string",
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "StatusCode",
              "Url"
            ],
            members: {
              Response: {},
              StatusCode: {
                type: "integer"
              },
              Message: {},
              Url: {}
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "Arn",
              "TagKeys"
            ],
            members: {
              Arn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        },
        UpdateAccess: {
          input: {
            type: "structure",
            required: [
              "ServerId",
              "ExternalId"
            ],
            members: {
              HomeDirectory: {},
              HomeDirectoryType: {},
              HomeDirectoryMappings: {
                shape: "S4"
              },
              Policy: {},
              PosixProfile: {
                shape: "Sa"
              },
              Role: {},
              ServerId: {},
              ExternalId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ServerId",
              "ExternalId"
            ],
            members: {
              ServerId: {},
              ExternalId: {}
            }
          }
        },
        UpdateAgreement: {
          input: {
            type: "structure",
            required: [
              "AgreementId",
              "ServerId"
            ],
            members: {
              AgreementId: {},
              ServerId: {},
              Description: {},
              Status: {},
              LocalProfileId: {},
              PartnerProfileId: {},
              BaseDirectory: {},
              AccessRole: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "AgreementId"
            ],
            members: {
              AgreementId: {}
            }
          }
        },
        UpdateCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateId"
            ],
            members: {
              CertificateId: {},
              ActiveDate: {
                type: "timestamp"
              },
              InactiveDate: {
                type: "timestamp"
              },
              Description: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "CertificateId"
            ],
            members: {
              CertificateId: {}
            }
          }
        },
        UpdateConnector: {
          input: {
            type: "structure",
            required: [
              "ConnectorId"
            ],
            members: {
              ConnectorId: {},
              Url: {},
              As2Config: {
                shape: "St"
              },
              AccessRole: {},
              LoggingRole: {},
              SftpConfig: {
                shape: "S11"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ConnectorId"
            ],
            members: {
              ConnectorId: {}
            }
          }
        },
        UpdateHostKey: {
          input: {
            type: "structure",
            required: [
              "ServerId",
              "HostKeyId",
              "Description"
            ],
            members: {
              ServerId: {},
              HostKeyId: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ServerId",
              "HostKeyId"
            ],
            members: {
              ServerId: {},
              HostKeyId: {}
            }
          }
        },
        UpdateProfile: {
          input: {
            type: "structure",
            required: [
              "ProfileId"
            ],
            members: {
              ProfileId: {},
              CertificateIds: {
                shape: "S1a"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ProfileId"
            ],
            members: {
              ProfileId: {}
            }
          }
        },
        UpdateServer: {
          input: {
            type: "structure",
            required: [
              "ServerId"
            ],
            members: {
              Certificate: {},
              ProtocolDetails: {
                shape: "S21"
              },
              EndpointDetails: {
                shape: "S1g"
              },
              EndpointType: {},
              HostKey: {
                shape: "S1q"
              },
              IdentityProviderDetails: {
                shape: "S1r"
              },
              LoggingRole: {},
              PostAuthenticationLoginBanner: {},
              PreAuthenticationLoginBanner: {},
              Protocols: {
                shape: "S1z"
              },
              SecurityPolicyName: {},
              ServerId: {},
              WorkflowDetails: {
                shape: "S28"
              },
              StructuredLogDestinations: {
                shape: "S2d"
              },
              S3StorageOptions: {
                shape: "S2f"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ServerId"
            ],
            members: {
              ServerId: {}
            }
          }
        },
        UpdateUser: {
          input: {
            type: "structure",
            required: [
              "ServerId",
              "UserName"
            ],
            members: {
              HomeDirectory: {},
              HomeDirectoryType: {},
              HomeDirectoryMappings: {
                shape: "S4"
              },
              Policy: {},
              PosixProfile: {
                shape: "Sa"
              },
              Role: {},
              ServerId: {},
              UserName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ServerId",
              "UserName"
            ],
            members: {
              ServerId: {},
              UserName: {}
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Entry",
              "Target"
            ],
            members: {
              Entry: {},
              Target: {},
              Type: {}
            }
          }
        },
        Sa: {
          type: "structure",
          required: [
            "Uid",
            "Gid"
          ],
          members: {
            Uid: {
              type: "long"
            },
            Gid: {
              type: "long"
            },
            SecondaryGids: {
              type: "list",
              member: {
                type: "long"
              }
            }
          }
        },
        Sl: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        St: {
          type: "structure",
          members: {
            LocalProfileId: {},
            PartnerProfileId: {},
            MessageSubject: {},
            Compression: {},
            EncryptionAlgorithm: {},
            SigningAlgorithm: {},
            MdnSigningAlgorithm: {},
            MdnResponse: {},
            BasicAuthSecretId: {}
          }
        },
        S11: {
          type: "structure",
          members: {
            UserSecretId: {},
            TrustedHostKeys: {
              type: "list",
              member: {}
            }
          }
        },
        S1a: {
          type: "list",
          member: {}
        },
        S1g: {
          type: "structure",
          members: {
            AddressAllocationIds: {
              type: "list",
              member: {}
            },
            SubnetIds: {
              type: "list",
              member: {}
            },
            VpcEndpointId: {},
            VpcId: {},
            SecurityGroupIds: {
              type: "list",
              member: {}
            }
          }
        },
        S1q: {
          type: "string",
          sensitive: true
        },
        S1r: {
          type: "structure",
          members: {
            Url: {},
            InvocationRole: {},
            DirectoryId: {},
            Function: {},
            SftpAuthenticationMethods: {}
          }
        },
        S1z: {
          type: "list",
          member: {}
        },
        S21: {
          type: "structure",
          members: {
            PassiveIp: {},
            TlsSessionResumptionMode: {},
            SetStatOption: {},
            As2Transports: {
              type: "list",
              member: {}
            }
          }
        },
        S28: {
          type: "structure",
          members: {
            OnUpload: {
              type: "list",
              member: {
                shape: "S2a"
              }
            },
            OnPartialUpload: {
              type: "list",
              member: {
                shape: "S2a"
              }
            }
          }
        },
        S2a: {
          type: "structure",
          required: [
            "WorkflowId",
            "ExecutionRole"
          ],
          members: {
            WorkflowId: {},
            ExecutionRole: {}
          }
        },
        S2d: {
          type: "list",
          member: {}
        },
        S2f: {
          type: "structure",
          members: {
            DirectoryListingOptimization: {}
          }
        },
        S2o: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Type: {},
              CopyStepDetails: {
                type: "structure",
                members: {
                  Name: {},
                  DestinationFileLocation: {
                    shape: "S2t"
                  },
                  OverwriteExisting: {},
                  SourceFileLocation: {}
                }
              },
              CustomStepDetails: {
                type: "structure",
                members: {
                  Name: {},
                  Target: {},
                  TimeoutSeconds: {
                    type: "integer"
                  },
                  SourceFileLocation: {}
                }
              },
              DeleteStepDetails: {
                type: "structure",
                members: {
                  Name: {},
                  SourceFileLocation: {}
                }
              },
              TagStepDetails: {
                type: "structure",
                members: {
                  Name: {},
                  Tags: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Key",
                        "Value"
                      ],
                      members: {
                        Key: {},
                        Value: {}
                      }
                    }
                  },
                  SourceFileLocation: {}
                }
              },
              DecryptStepDetails: {
                type: "structure",
                required: [
                  "Type",
                  "DestinationFileLocation"
                ],
                members: {
                  Name: {},
                  Type: {},
                  SourceFileLocation: {},
                  OverwriteExisting: {},
                  DestinationFileLocation: {
                    shape: "S2t"
                  }
                }
              }
            }
          }
        },
        S2t: {
          type: "structure",
          members: {
            S3FileLocation: {
              type: "structure",
              members: {
                Bucket: {},
                Key: {}
              }
            },
            EfsFileLocation: {
              shape: "S2x"
            }
          }
        },
        S2x: {
          type: "structure",
          members: {
            FileSystemId: {},
            Path: {}
          }
        },
        S41: {
          type: "string",
          sensitive: true
        },
        S42: {
          type: "string",
          sensitive: true
        },
        S4d: {
          type: "structure",
          members: {
            S3FileLocation: {
              type: "structure",
              members: {
                Bucket: {},
                Key: {},
                VersionId: {},
                Etag: {}
              }
            },
            EfsFileLocation: {
              shape: "S2x"
            }
          }
        },
        S4h: {
          type: "structure",
          required: [
            "UserDetails"
          ],
          members: {
            UserDetails: {
              type: "structure",
              required: [
                "UserName",
                "ServerId"
              ],
              members: {
                UserName: {},
                ServerId: {},
                SessionId: {}
              }
            }
          }
        },
        S4o: {
          type: "list",
          member: {
            type: "structure",
            members: {
              StepType: {},
              Outputs: {},
              Error: {
                type: "structure",
                required: [
                  "Type",
                  "Message"
                ],
                members: {
                  Type: {},
                  Message: {}
                }
              }
            }
          }
        },
        S58: {
          type: "list",
          member: {}
        },
        S7b: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/transfer-2018-11-05.paginators.json
var require_transfer_2018_11_05_paginators = __commonJS({
  "node_modules/aws-sdk/apis/transfer-2018-11-05.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAccesses: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Accesses"
        },
        ListAgreements: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Agreements"
        },
        ListCertificates: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Certificates"
        },
        ListConnectors: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Connectors"
        },
        ListExecutions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Executions"
        },
        ListProfiles: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Profiles"
        },
        ListSecurityPolicies: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "SecurityPolicyNames"
        },
        ListServers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Servers"
        },
        ListTagsForResource: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Tags"
        },
        ListUsers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Users"
        },
        ListWorkflows: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Workflows"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/transfer-2018-11-05.waiters2.json
var require_transfer_2018_11_05_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/transfer-2018-11-05.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        ServerOffline: {
          delay: 30,
          maxAttempts: 120,
          operation: "DescribeServer",
          acceptors: [{
            matcher: "path",
            argument: "Server.State",
            state: "success",
            expected: "OFFLINE"
          }, {
            matcher: "path",
            argument: "Server.State",
            state: "failure",
            expected: "STOP_FAILED"
          }]
        },
        ServerOnline: {
          delay: 30,
          maxAttempts: 120,
          operation: "DescribeServer",
          acceptors: [{
            matcher: "path",
            argument: "Server.State",
            state: "success",
            expected: "ONLINE"
          }, {
            matcher: "path",
            argument: "Server.State",
            state: "failure",
            expected: "START_FAILED"
          }]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/transfer.js
var require_transfer = __commonJS({
  "node_modules/aws-sdk/clients/transfer.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["transfer"] = {};
    AWS2.Transfer = Service.defineService("transfer", ["2018-11-05"]);
    Object.defineProperty(apiLoader.services["transfer"], "2018-11-05", {
      get: function get() {
        var model = require_transfer_2018_11_05_min();
        model.paginators = require_transfer_2018_11_05_paginators().pagination;
        model.waiters = require_transfer_2018_11_05_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Transfer;
  }
});

// node_modules/aws-sdk/apis/globalaccelerator-2018-08-08.min.json
var require_globalaccelerator_2018_08_08_min = __commonJS({
  "node_modules/aws-sdk/apis/globalaccelerator-2018-08-08.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-08-08",
        endpointPrefix: "globalaccelerator",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Global Accelerator",
        serviceId: "Global Accelerator",
        signatureVersion: "v4",
        signingName: "globalaccelerator",
        targetPrefix: "GlobalAccelerator_V20180706",
        uid: "globalaccelerator-2018-08-08"
      },
      operations: {
        AddCustomRoutingEndpoints: {
          input: {
            type: "structure",
            required: [
              "EndpointConfigurations",
              "EndpointGroupArn"
            ],
            members: {
              EndpointConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EndpointId: {},
                    AttachmentArn: {}
                  }
                }
              },
              EndpointGroupArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EndpointDescriptions: {
                shape: "S6"
              },
              EndpointGroupArn: {}
            }
          }
        },
        AddEndpoints: {
          input: {
            type: "structure",
            required: [
              "EndpointConfigurations",
              "EndpointGroupArn"
            ],
            members: {
              EndpointConfigurations: {
                shape: "S9"
              },
              EndpointGroupArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EndpointDescriptions: {
                shape: "Se"
              },
              EndpointGroupArn: {}
            }
          }
        },
        AdvertiseByoipCidr: {
          input: {
            type: "structure",
            required: [
              "Cidr"
            ],
            members: {
              Cidr: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ByoipCidr: {
                shape: "Sj"
              }
            }
          }
        },
        AllowCustomRoutingTraffic: {
          input: {
            type: "structure",
            required: [
              "EndpointGroupArn",
              "EndpointId"
            ],
            members: {
              EndpointGroupArn: {},
              EndpointId: {},
              DestinationAddresses: {
                shape: "Sp"
              },
              DestinationPorts: {
                shape: "Sr"
              },
              AllowAllTrafficToEndpoint: {
                type: "boolean"
              }
            }
          }
        },
        CreateAccelerator: {
          input: {
            type: "structure",
            required: [
              "Name",
              "IdempotencyToken"
            ],
            members: {
              Name: {},
              IpAddressType: {},
              IpAddresses: {
                shape: "Sv"
              },
              Enabled: {
                type: "boolean"
              },
              IdempotencyToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Accelerator: {
                shape: "S12"
              }
            }
          }
        },
        CreateCrossAccountAttachment: {
          input: {
            type: "structure",
            required: [
              "Name",
              "IdempotencyToken"
            ],
            members: {
              Name: {},
              Principals: {
                shape: "S1b"
              },
              Resources: {
                shape: "S1d"
              },
              IdempotencyToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CrossAccountAttachment: {
                shape: "S1g"
              }
            }
          }
        },
        CreateCustomRoutingAccelerator: {
          input: {
            type: "structure",
            required: [
              "Name",
              "IdempotencyToken"
            ],
            members: {
              Name: {},
              IpAddressType: {},
              IpAddresses: {
                shape: "Sv"
              },
              Enabled: {
                type: "boolean"
              },
              IdempotencyToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Accelerator: {
                shape: "S1j"
              }
            }
          }
        },
        CreateCustomRoutingEndpointGroup: {
          input: {
            type: "structure",
            required: [
              "ListenerArn",
              "EndpointGroupRegion",
              "DestinationConfigurations",
              "IdempotencyToken"
            ],
            members: {
              ListenerArn: {},
              EndpointGroupRegion: {},
              DestinationConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "FromPort",
                    "ToPort",
                    "Protocols"
                  ],
                  members: {
                    FromPort: {
                      type: "integer"
                    },
                    ToPort: {
                      type: "integer"
                    },
                    Protocols: {
                      shape: "S1o"
                    }
                  }
                }
              },
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EndpointGroup: {
                shape: "S1r"
              }
            }
          }
        },
        CreateCustomRoutingListener: {
          input: {
            type: "structure",
            required: [
              "AcceleratorArn",
              "PortRanges",
              "IdempotencyToken"
            ],
            members: {
              AcceleratorArn: {},
              PortRanges: {
                shape: "S1x"
              },
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Listener: {
                shape: "S20"
              }
            }
          }
        },
        CreateEndpointGroup: {
          input: {
            type: "structure",
            required: [
              "ListenerArn",
              "EndpointGroupRegion",
              "IdempotencyToken"
            ],
            members: {
              ListenerArn: {},
              EndpointGroupRegion: {},
              EndpointConfigurations: {
                shape: "S9"
              },
              TrafficDialPercentage: {
                type: "float"
              },
              HealthCheckPort: {
                type: "integer"
              },
              HealthCheckProtocol: {},
              HealthCheckPath: {},
              HealthCheckIntervalSeconds: {
                type: "integer"
              },
              ThresholdCount: {
                type: "integer"
              },
              IdempotencyToken: {
                idempotencyToken: true
              },
              PortOverrides: {
                shape: "S28"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EndpointGroup: {
                shape: "S2b"
              }
            }
          }
        },
        CreateListener: {
          input: {
            type: "structure",
            required: [
              "AcceleratorArn",
              "PortRanges",
              "Protocol",
              "IdempotencyToken"
            ],
            members: {
              AcceleratorArn: {},
              PortRanges: {
                shape: "S1x"
              },
              Protocol: {},
              ClientAffinity: {},
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Listener: {
                shape: "S2f"
              }
            }
          }
        },
        DeleteAccelerator: {
          input: {
            type: "structure",
            required: [
              "AcceleratorArn"
            ],
            members: {
              AcceleratorArn: {}
            }
          }
        },
        DeleteCrossAccountAttachment: {
          input: {
            type: "structure",
            required: [
              "AttachmentArn"
            ],
            members: {
              AttachmentArn: {}
            }
          }
        },
        DeleteCustomRoutingAccelerator: {
          input: {
            type: "structure",
            required: [
              "AcceleratorArn"
            ],
            members: {
              AcceleratorArn: {}
            }
          }
        },
        DeleteCustomRoutingEndpointGroup: {
          input: {
            type: "structure",
            required: [
              "EndpointGroupArn"
            ],
            members: {
              EndpointGroupArn: {}
            }
          }
        },
        DeleteCustomRoutingListener: {
          input: {
            type: "structure",
            required: [
              "ListenerArn"
            ],
            members: {
              ListenerArn: {}
            }
          }
        },
        DeleteEndpointGroup: {
          input: {
            type: "structure",
            required: [
              "EndpointGroupArn"
            ],
            members: {
              EndpointGroupArn: {}
            }
          }
        },
        DeleteListener: {
          input: {
            type: "structure",
            required: [
              "ListenerArn"
            ],
            members: {
              ListenerArn: {}
            }
          }
        },
        DenyCustomRoutingTraffic: {
          input: {
            type: "structure",
            required: [
              "EndpointGroupArn",
              "EndpointId"
            ],
            members: {
              EndpointGroupArn: {},
              EndpointId: {},
              DestinationAddresses: {
                shape: "Sp"
              },
              DestinationPorts: {
                shape: "Sr"
              },
              DenyAllTrafficToEndpoint: {
                type: "boolean"
              }
            }
          }
        },
        DeprovisionByoipCidr: {
          input: {
            type: "structure",
            required: [
              "Cidr"
            ],
            members: {
              Cidr: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ByoipCidr: {
                shape: "Sj"
              }
            }
          }
        },
        DescribeAccelerator: {
          input: {
            type: "structure",
            required: [
              "AcceleratorArn"
            ],
            members: {
              AcceleratorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Accelerator: {
                shape: "S12"
              }
            }
          }
        },
        DescribeAcceleratorAttributes: {
          input: {
            type: "structure",
            required: [
              "AcceleratorArn"
            ],
            members: {
              AcceleratorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AcceleratorAttributes: {
                shape: "S2u"
              }
            }
          }
        },
        DescribeCrossAccountAttachment: {
          input: {
            type: "structure",
            required: [
              "AttachmentArn"
            ],
            members: {
              AttachmentArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CrossAccountAttachment: {
                shape: "S1g"
              }
            }
          }
        },
        DescribeCustomRoutingAccelerator: {
          input: {
            type: "structure",
            required: [
              "AcceleratorArn"
            ],
            members: {
              AcceleratorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Accelerator: {
                shape: "S1j"
              }
            }
          }
        },
        DescribeCustomRoutingAcceleratorAttributes: {
          input: {
            type: "structure",
            required: [
              "AcceleratorArn"
            ],
            members: {
              AcceleratorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AcceleratorAttributes: {
                shape: "S31"
              }
            }
          }
        },
        DescribeCustomRoutingEndpointGroup: {
          input: {
            type: "structure",
            required: [
              "EndpointGroupArn"
            ],
            members: {
              EndpointGroupArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EndpointGroup: {
                shape: "S1r"
              }
            }
          }
        },
        DescribeCustomRoutingListener: {
          input: {
            type: "structure",
            required: [
              "ListenerArn"
            ],
            members: {
              ListenerArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Listener: {
                shape: "S20"
              }
            }
          }
        },
        DescribeEndpointGroup: {
          input: {
            type: "structure",
            required: [
              "EndpointGroupArn"
            ],
            members: {
              EndpointGroupArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EndpointGroup: {
                shape: "S2b"
              }
            }
          }
        },
        DescribeListener: {
          input: {
            type: "structure",
            required: [
              "ListenerArn"
            ],
            members: {
              ListenerArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Listener: {
                shape: "S2f"
              }
            }
          }
        },
        ListAccelerators: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Accelerators: {
                type: "list",
                member: {
                  shape: "S12"
                }
              },
              NextToken: {}
            }
          }
        },
        ListByoipCidrs: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ByoipCidrs: {
                type: "list",
                member: {
                  shape: "Sj"
                }
              },
              NextToken: {}
            }
          }
        },
        ListCrossAccountAttachments: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CrossAccountAttachments: {
                type: "list",
                member: {
                  shape: "S1g"
                }
              },
              NextToken: {}
            }
          }
        },
        ListCrossAccountResourceAccounts: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              ResourceOwnerAwsAccountIds: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ListCrossAccountResources: {
          input: {
            type: "structure",
            required: [
              "ResourceOwnerAwsAccountId"
            ],
            members: {
              AcceleratorArn: {},
              ResourceOwnerAwsAccountId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CrossAccountResources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EndpointId: {},
                    AttachmentArn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListCustomRoutingAccelerators: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Accelerators: {
                type: "list",
                member: {
                  shape: "S1j"
                }
              },
              NextToken: {}
            }
          }
        },
        ListCustomRoutingEndpointGroups: {
          input: {
            type: "structure",
            required: [
              "ListenerArn"
            ],
            members: {
              ListenerArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EndpointGroups: {
                type: "list",
                member: {
                  shape: "S1r"
                }
              },
              NextToken: {}
            }
          }
        },
        ListCustomRoutingListeners: {
          input: {
            type: "structure",
            required: [
              "AcceleratorArn"
            ],
            members: {
              AcceleratorArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Listeners: {
                type: "list",
                member: {
                  shape: "S20"
                }
              },
              NextToken: {}
            }
          }
        },
        ListCustomRoutingPortMappings: {
          input: {
            type: "structure",
            required: [
              "AcceleratorArn"
            ],
            members: {
              AcceleratorArn: {},
              EndpointGroupArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PortMappings: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AcceleratorPort: {
                      type: "integer"
                    },
                    EndpointGroupArn: {},
                    EndpointId: {},
                    DestinationSocketAddress: {
                      shape: "S46"
                    },
                    Protocols: {
                      shape: "S1o"
                    },
                    DestinationTrafficState: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListCustomRoutingPortMappingsByDestination: {
          input: {
            type: "structure",
            required: [
              "EndpointId",
              "DestinationAddress"
            ],
            members: {
              EndpointId: {},
              DestinationAddress: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DestinationPortMappings: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AcceleratorArn: {},
                    AcceleratorSocketAddresses: {
                      type: "list",
                      member: {
                        shape: "S46"
                      }
                    },
                    EndpointGroupArn: {},
                    EndpointId: {},
                    EndpointGroupRegion: {},
                    DestinationSocketAddress: {
                      shape: "S46"
                    },
                    IpAddressType: {},
                    DestinationTrafficState: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEndpointGroups: {
          input: {
            type: "structure",
            required: [
              "ListenerArn"
            ],
            members: {
              ListenerArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EndpointGroups: {
                type: "list",
                member: {
                  shape: "S2b"
                }
              },
              NextToken: {}
            }
          }
        },
        ListListeners: {
          input: {
            type: "structure",
            required: [
              "AcceleratorArn"
            ],
            members: {
              AcceleratorArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Listeners: {
                type: "list",
                member: {
                  shape: "S2f"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sx"
              }
            }
          }
        },
        ProvisionByoipCidr: {
          input: {
            type: "structure",
            required: [
              "Cidr",
              "CidrAuthorizationContext"
            ],
            members: {
              Cidr: {},
              CidrAuthorizationContext: {
                type: "structure",
                required: [
                  "Message",
                  "Signature"
                ],
                members: {
                  Message: {},
                  Signature: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ByoipCidr: {
                shape: "Sj"
              }
            }
          }
        },
        RemoveCustomRoutingEndpoints: {
          input: {
            type: "structure",
            required: [
              "EndpointIds",
              "EndpointGroupArn"
            ],
            members: {
              EndpointIds: {
                type: "list",
                member: {}
              },
              EndpointGroupArn: {}
            }
          }
        },
        RemoveEndpoints: {
          input: {
            type: "structure",
            required: [
              "EndpointIdentifiers",
              "EndpointGroupArn"
            ],
            members: {
              EndpointIdentifiers: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "EndpointId"
                  ],
                  members: {
                    EndpointId: {},
                    ClientIPPreservationEnabled: {
                      type: "boolean"
                    }
                  }
                }
              },
              EndpointGroupArn: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAccelerator: {
          input: {
            type: "structure",
            required: [
              "AcceleratorArn"
            ],
            members: {
              AcceleratorArn: {},
              Name: {},
              IpAddressType: {},
              Enabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Accelerator: {
                shape: "S12"
              }
            }
          }
        },
        UpdateAcceleratorAttributes: {
          input: {
            type: "structure",
            required: [
              "AcceleratorArn"
            ],
            members: {
              AcceleratorArn: {},
              FlowLogsEnabled: {
                type: "boolean"
              },
              FlowLogsS3Bucket: {},
              FlowLogsS3Prefix: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AcceleratorAttributes: {
                shape: "S2u"
              }
            }
          }
        },
        UpdateCrossAccountAttachment: {
          input: {
            type: "structure",
            required: [
              "AttachmentArn"
            ],
            members: {
              AttachmentArn: {},
              Name: {},
              AddPrincipals: {
                shape: "S1b"
              },
              RemovePrincipals: {
                shape: "S1b"
              },
              AddResources: {
                shape: "S1d"
              },
              RemoveResources: {
                shape: "S1d"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CrossAccountAttachment: {
                shape: "S1g"
              }
            }
          }
        },
        UpdateCustomRoutingAccelerator: {
          input: {
            type: "structure",
            required: [
              "AcceleratorArn"
            ],
            members: {
              AcceleratorArn: {},
              Name: {},
              IpAddressType: {},
              Enabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Accelerator: {
                shape: "S1j"
              }
            }
          }
        },
        UpdateCustomRoutingAcceleratorAttributes: {
          input: {
            type: "structure",
            required: [
              "AcceleratorArn"
            ],
            members: {
              AcceleratorArn: {},
              FlowLogsEnabled: {
                type: "boolean"
              },
              FlowLogsS3Bucket: {},
              FlowLogsS3Prefix: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AcceleratorAttributes: {
                shape: "S31"
              }
            }
          }
        },
        UpdateCustomRoutingListener: {
          input: {
            type: "structure",
            required: [
              "ListenerArn",
              "PortRanges"
            ],
            members: {
              ListenerArn: {},
              PortRanges: {
                shape: "S1x"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Listener: {
                shape: "S20"
              }
            }
          }
        },
        UpdateEndpointGroup: {
          input: {
            type: "structure",
            required: [
              "EndpointGroupArn"
            ],
            members: {
              EndpointGroupArn: {},
              EndpointConfigurations: {
                shape: "S9"
              },
              TrafficDialPercentage: {
                type: "float"
              },
              HealthCheckPort: {
                type: "integer"
              },
              HealthCheckProtocol: {},
              HealthCheckPath: {},
              HealthCheckIntervalSeconds: {
                type: "integer"
              },
              ThresholdCount: {
                type: "integer"
              },
              PortOverrides: {
                shape: "S28"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EndpointGroup: {
                shape: "S2b"
              }
            }
          }
        },
        UpdateListener: {
          input: {
            type: "structure",
            required: [
              "ListenerArn"
            ],
            members: {
              ListenerArn: {},
              PortRanges: {
                shape: "S1x"
              },
              Protocol: {},
              ClientAffinity: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Listener: {
                shape: "S2f"
              }
            }
          }
        },
        WithdrawByoipCidr: {
          input: {
            type: "structure",
            required: [
              "Cidr"
            ],
            members: {
              Cidr: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ByoipCidr: {
                shape: "Sj"
              }
            }
          }
        }
      },
      shapes: {
        S6: {
          type: "list",
          member: {
            type: "structure",
            members: {
              EndpointId: {}
            }
          }
        },
        S9: {
          type: "list",
          member: {
            type: "structure",
            members: {
              EndpointId: {},
              Weight: {
                type: "integer"
              },
              ClientIPPreservationEnabled: {
                type: "boolean"
              },
              AttachmentArn: {}
            }
          }
        },
        Se: {
          type: "list",
          member: {
            type: "structure",
            members: {
              EndpointId: {},
              Weight: {
                type: "integer"
              },
              HealthState: {},
              HealthReason: {},
              ClientIPPreservationEnabled: {
                type: "boolean"
              }
            }
          }
        },
        Sj: {
          type: "structure",
          members: {
            Cidr: {},
            State: {},
            Events: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Message: {},
                  Timestamp: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        Sp: {
          type: "list",
          member: {}
        },
        Sr: {
          type: "list",
          member: {
            type: "integer"
          }
        },
        Sv: {
          type: "list",
          member: {}
        },
        Sx: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S12: {
          type: "structure",
          members: {
            AcceleratorArn: {},
            Name: {},
            IpAddressType: {},
            Enabled: {
              type: "boolean"
            },
            IpSets: {
              shape: "S13"
            },
            DnsName: {},
            Status: {},
            CreatedTime: {
              type: "timestamp"
            },
            LastModifiedTime: {
              type: "timestamp"
            },
            DualStackDnsName: {},
            Events: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Message: {},
                  Timestamp: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        S13: {
          type: "list",
          member: {
            type: "structure",
            members: {
              IpFamily: {
                deprecated: true,
                deprecatedMessage: "IpFamily has been replaced by IpAddressFamily"
              },
              IpAddresses: {
                shape: "Sv"
              },
              IpAddressFamily: {}
            }
          }
        },
        S1b: {
          type: "list",
          member: {}
        },
        S1d: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "EndpointId"
            ],
            members: {
              EndpointId: {},
              Region: {}
            }
          }
        },
        S1g: {
          type: "structure",
          members: {
            AttachmentArn: {},
            Name: {},
            Principals: {
              shape: "S1b"
            },
            Resources: {
              shape: "S1d"
            },
            LastModifiedTime: {
              type: "timestamp"
            },
            CreatedTime: {
              type: "timestamp"
            }
          }
        },
        S1j: {
          type: "structure",
          members: {
            AcceleratorArn: {},
            Name: {},
            IpAddressType: {},
            Enabled: {
              type: "boolean"
            },
            IpSets: {
              shape: "S13"
            },
            DnsName: {},
            Status: {},
            CreatedTime: {
              type: "timestamp"
            },
            LastModifiedTime: {
              type: "timestamp"
            }
          }
        },
        S1o: {
          type: "list",
          member: {}
        },
        S1r: {
          type: "structure",
          members: {
            EndpointGroupArn: {},
            EndpointGroupRegion: {},
            DestinationDescriptions: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  FromPort: {
                    type: "integer"
                  },
                  ToPort: {
                    type: "integer"
                  },
                  Protocols: {
                    type: "list",
                    member: {}
                  }
                }
              }
            },
            EndpointDescriptions: {
              shape: "S6"
            }
          }
        },
        S1x: {
          type: "list",
          member: {
            type: "structure",
            members: {
              FromPort: {
                type: "integer"
              },
              ToPort: {
                type: "integer"
              }
            }
          }
        },
        S20: {
          type: "structure",
          members: {
            ListenerArn: {},
            PortRanges: {
              shape: "S1x"
            }
          }
        },
        S28: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ListenerPort: {
                type: "integer"
              },
              EndpointPort: {
                type: "integer"
              }
            }
          }
        },
        S2b: {
          type: "structure",
          members: {
            EndpointGroupArn: {},
            EndpointGroupRegion: {},
            EndpointDescriptions: {
              shape: "Se"
            },
            TrafficDialPercentage: {
              type: "float"
            },
            HealthCheckPort: {
              type: "integer"
            },
            HealthCheckProtocol: {},
            HealthCheckPath: {},
            HealthCheckIntervalSeconds: {
              type: "integer"
            },
            ThresholdCount: {
              type: "integer"
            },
            PortOverrides: {
              shape: "S28"
            }
          }
        },
        S2f: {
          type: "structure",
          members: {
            ListenerArn: {},
            PortRanges: {
              shape: "S1x"
            },
            Protocol: {},
            ClientAffinity: {}
          }
        },
        S2u: {
          type: "structure",
          members: {
            FlowLogsEnabled: {
              type: "boolean"
            },
            FlowLogsS3Bucket: {},
            FlowLogsS3Prefix: {}
          }
        },
        S31: {
          type: "structure",
          members: {
            FlowLogsEnabled: {
              type: "boolean"
            },
            FlowLogsS3Bucket: {},
            FlowLogsS3Prefix: {}
          }
        },
        S46: {
          type: "structure",
          members: {
            IpAddress: {},
            Port: {
              type: "integer"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/globalaccelerator-2018-08-08.paginators.json
var require_globalaccelerator_2018_08_08_paginators = __commonJS({
  "node_modules/aws-sdk/apis/globalaccelerator-2018-08-08.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAccelerators: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Accelerators"
        },
        ListByoipCidrs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ByoipCidrs"
        },
        ListCrossAccountAttachments: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "CrossAccountAttachments"
        },
        ListCrossAccountResources: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "CrossAccountResources"
        },
        ListCustomRoutingAccelerators: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Accelerators"
        },
        ListCustomRoutingEndpointGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "EndpointGroups"
        },
        ListCustomRoutingListeners: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Listeners"
        },
        ListCustomRoutingPortMappings: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "PortMappings"
        },
        ListCustomRoutingPortMappingsByDestination: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "DestinationPortMappings"
        },
        ListEndpointGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "EndpointGroups"
        },
        ListListeners: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Listeners"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/globalaccelerator.js
var require_globalaccelerator = __commonJS({
  "node_modules/aws-sdk/clients/globalaccelerator.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["globalaccelerator"] = {};
    AWS2.GlobalAccelerator = Service.defineService("globalaccelerator", ["2018-08-08"]);
    Object.defineProperty(apiLoader.services["globalaccelerator"], "2018-08-08", {
      get: function get() {
        var model = require_globalaccelerator_2018_08_08_min();
        model.paginators = require_globalaccelerator_2018_08_08_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.GlobalAccelerator;
  }
});

// node_modules/aws-sdk/apis/comprehendmedical-2018-10-30.min.json
var require_comprehendmedical_2018_10_30_min = __commonJS({
  "node_modules/aws-sdk/apis/comprehendmedical-2018-10-30.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-10-30",
        endpointPrefix: "comprehendmedical",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "ComprehendMedical",
        serviceFullName: "AWS Comprehend Medical",
        serviceId: "ComprehendMedical",
        signatureVersion: "v4",
        signingName: "comprehendmedical",
        targetPrefix: "ComprehendMedical_20181030",
        uid: "comprehendmedical-2018-10-30"
      },
      operations: {
        DescribeEntitiesDetectionV2Job: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ComprehendMedicalAsyncJobProperties: {
                shape: "S4"
              }
            }
          }
        },
        DescribeICD10CMInferenceJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ComprehendMedicalAsyncJobProperties: {
                shape: "S4"
              }
            }
          }
        },
        DescribePHIDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ComprehendMedicalAsyncJobProperties: {
                shape: "S4"
              }
            }
          }
        },
        DescribeRxNormInferenceJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ComprehendMedicalAsyncJobProperties: {
                shape: "S4"
              }
            }
          }
        },
        DescribeSNOMEDCTInferenceJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ComprehendMedicalAsyncJobProperties: {
                shape: "S4"
              }
            }
          }
        },
        DetectEntities: {
          input: {
            type: "structure",
            required: [
              "Text"
            ],
            members: {
              Text: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Entities",
              "ModelVersion"
            ],
            members: {
              Entities: {
                shape: "St"
              },
              UnmappedAttributes: {
                shape: "S16"
              },
              PaginationToken: {},
              ModelVersion: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This operation is deprecated, use DetectEntitiesV2 instead."
        },
        DetectEntitiesV2: {
          input: {
            type: "structure",
            required: [
              "Text"
            ],
            members: {
              Text: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Entities",
              "ModelVersion"
            ],
            members: {
              Entities: {
                shape: "St"
              },
              UnmappedAttributes: {
                shape: "S16"
              },
              PaginationToken: {},
              ModelVersion: {}
            }
          }
        },
        DetectPHI: {
          input: {
            type: "structure",
            required: [
              "Text"
            ],
            members: {
              Text: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Entities",
              "ModelVersion"
            ],
            members: {
              Entities: {
                shape: "St"
              },
              PaginationToken: {},
              ModelVersion: {}
            }
          }
        },
        InferICD10CM: {
          input: {
            type: "structure",
            required: [
              "Text"
            ],
            members: {
              Text: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Entities"
            ],
            members: {
              Entities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {
                      type: "integer"
                    },
                    Text: {},
                    Category: {},
                    Type: {},
                    Score: {
                      type: "float"
                    },
                    BeginOffset: {
                      type: "integer"
                    },
                    EndOffset: {
                      type: "integer"
                    },
                    Attributes: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Type: {},
                          Score: {
                            type: "float"
                          },
                          RelationshipScore: {
                            type: "float"
                          },
                          Id: {
                            type: "integer"
                          },
                          BeginOffset: {
                            type: "integer"
                          },
                          EndOffset: {
                            type: "integer"
                          },
                          Text: {},
                          Traits: {
                            shape: "S1m"
                          },
                          Category: {},
                          RelationshipType: {}
                        }
                      }
                    },
                    Traits: {
                      shape: "S1m"
                    },
                    ICD10CMConcepts: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Description: {},
                          Code: {},
                          Score: {
                            type: "float"
                          }
                        }
                      }
                    }
                  }
                }
              },
              PaginationToken: {},
              ModelVersion: {}
            }
          }
        },
        InferRxNorm: {
          input: {
            type: "structure",
            required: [
              "Text"
            ],
            members: {
              Text: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Entities"
            ],
            members: {
              Entities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {
                      type: "integer"
                    },
                    Text: {},
                    Category: {},
                    Type: {},
                    Score: {
                      type: "float"
                    },
                    BeginOffset: {
                      type: "integer"
                    },
                    EndOffset: {
                      type: "integer"
                    },
                    Attributes: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Type: {},
                          Score: {
                            type: "float"
                          },
                          RelationshipScore: {
                            type: "float"
                          },
                          Id: {
                            type: "integer"
                          },
                          BeginOffset: {
                            type: "integer"
                          },
                          EndOffset: {
                            type: "integer"
                          },
                          Text: {},
                          Traits: {
                            shape: "S21"
                          }
                        }
                      }
                    },
                    Traits: {
                      shape: "S21"
                    },
                    RxNormConcepts: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Description: {},
                          Code: {},
                          Score: {
                            type: "float"
                          }
                        }
                      }
                    }
                  }
                }
              },
              PaginationToken: {},
              ModelVersion: {}
            }
          }
        },
        InferSNOMEDCT: {
          input: {
            type: "structure",
            required: [
              "Text"
            ],
            members: {
              Text: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Entities"
            ],
            members: {
              Entities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {
                      type: "integer"
                    },
                    Text: {},
                    Category: {},
                    Type: {},
                    Score: {
                      type: "float"
                    },
                    BeginOffset: {
                      type: "integer"
                    },
                    EndOffset: {
                      type: "integer"
                    },
                    Attributes: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Category: {},
                          Type: {},
                          Score: {
                            type: "float"
                          },
                          RelationshipScore: {
                            type: "float"
                          },
                          RelationshipType: {},
                          Id: {
                            type: "integer"
                          },
                          BeginOffset: {
                            type: "integer"
                          },
                          EndOffset: {
                            type: "integer"
                          },
                          Text: {},
                          Traits: {
                            shape: "S2g"
                          },
                          SNOMEDCTConcepts: {
                            shape: "S2j"
                          }
                        }
                      }
                    },
                    Traits: {
                      shape: "S2g"
                    },
                    SNOMEDCTConcepts: {
                      shape: "S2j"
                    }
                  }
                }
              },
              PaginationToken: {},
              ModelVersion: {},
              SNOMEDCTDetails: {
                type: "structure",
                members: {
                  Edition: {},
                  Language: {},
                  VersionDate: {}
                }
              },
              Characters: {
                type: "structure",
                members: {
                  OriginalTextCharacters: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        ListEntitiesDetectionV2Jobs: {
          input: {
            type: "structure",
            members: {
              Filter: {
                shape: "S2o"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ComprehendMedicalAsyncJobPropertiesList: {
                shape: "S2r"
              },
              NextToken: {}
            }
          }
        },
        ListICD10CMInferenceJobs: {
          input: {
            type: "structure",
            members: {
              Filter: {
                shape: "S2o"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ComprehendMedicalAsyncJobPropertiesList: {
                shape: "S2r"
              },
              NextToken: {}
            }
          }
        },
        ListPHIDetectionJobs: {
          input: {
            type: "structure",
            members: {
              Filter: {
                shape: "S2o"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ComprehendMedicalAsyncJobPropertiesList: {
                shape: "S2r"
              },
              NextToken: {}
            }
          }
        },
        ListRxNormInferenceJobs: {
          input: {
            type: "structure",
            members: {
              Filter: {
                shape: "S2o"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ComprehendMedicalAsyncJobPropertiesList: {
                shape: "S2r"
              },
              NextToken: {}
            }
          }
        },
        ListSNOMEDCTInferenceJobs: {
          input: {
            type: "structure",
            members: {
              Filter: {
                shape: "S2o"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ComprehendMedicalAsyncJobPropertiesList: {
                shape: "S2r"
              },
              NextToken: {}
            }
          }
        },
        StartEntitiesDetectionV2Job: {
          input: {
            type: "structure",
            required: [
              "InputDataConfig",
              "OutputDataConfig",
              "DataAccessRoleArn",
              "LanguageCode"
            ],
            members: {
              InputDataConfig: {
                shape: "S9"
              },
              OutputDataConfig: {
                shape: "Sc"
              },
              DataAccessRoleArn: {},
              JobName: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              KMSKey: {},
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          }
        },
        StartICD10CMInferenceJob: {
          input: {
            type: "structure",
            required: [
              "InputDataConfig",
              "OutputDataConfig",
              "DataAccessRoleArn",
              "LanguageCode"
            ],
            members: {
              InputDataConfig: {
                shape: "S9"
              },
              OutputDataConfig: {
                shape: "Sc"
              },
              DataAccessRoleArn: {},
              JobName: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              KMSKey: {},
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          }
        },
        StartPHIDetectionJob: {
          input: {
            type: "structure",
            required: [
              "InputDataConfig",
              "OutputDataConfig",
              "DataAccessRoleArn",
              "LanguageCode"
            ],
            members: {
              InputDataConfig: {
                shape: "S9"
              },
              OutputDataConfig: {
                shape: "Sc"
              },
              DataAccessRoleArn: {},
              JobName: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              KMSKey: {},
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          }
        },
        StartRxNormInferenceJob: {
          input: {
            type: "structure",
            required: [
              "InputDataConfig",
              "OutputDataConfig",
              "DataAccessRoleArn",
              "LanguageCode"
            ],
            members: {
              InputDataConfig: {
                shape: "S9"
              },
              OutputDataConfig: {
                shape: "Sc"
              },
              DataAccessRoleArn: {},
              JobName: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              KMSKey: {},
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          }
        },
        StartSNOMEDCTInferenceJob: {
          input: {
            type: "structure",
            required: [
              "InputDataConfig",
              "OutputDataConfig",
              "DataAccessRoleArn",
              "LanguageCode"
            ],
            members: {
              InputDataConfig: {
                shape: "S9"
              },
              OutputDataConfig: {
                shape: "Sc"
              },
              DataAccessRoleArn: {},
              JobName: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              KMSKey: {},
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          }
        },
        StopEntitiesDetectionV2Job: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          }
        },
        StopICD10CMInferenceJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          }
        },
        StopPHIDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          }
        },
        StopRxNormInferenceJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          }
        },
        StopSNOMEDCTInferenceJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            JobId: {},
            JobName: {},
            JobStatus: {},
            Message: {},
            SubmitTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            ExpirationTime: {
              type: "timestamp"
            },
            InputDataConfig: {
              shape: "S9"
            },
            OutputDataConfig: {
              shape: "Sc"
            },
            LanguageCode: {},
            DataAccessRoleArn: {},
            ManifestFilePath: {},
            KMSKey: {},
            ModelVersion: {}
          }
        },
        S9: {
          type: "structure",
          required: [
            "S3Bucket"
          ],
          members: {
            S3Bucket: {},
            S3Key: {}
          }
        },
        Sc: {
          type: "structure",
          required: [
            "S3Bucket"
          ],
          members: {
            S3Bucket: {},
            S3Key: {}
          }
        },
        St: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Id: {
                type: "integer"
              },
              BeginOffset: {
                type: "integer"
              },
              EndOffset: {
                type: "integer"
              },
              Score: {
                type: "float"
              },
              Text: {},
              Category: {},
              Type: {},
              Traits: {
                shape: "S10"
              },
              Attributes: {
                type: "list",
                member: {
                  shape: "S14"
                }
              }
            }
          }
        },
        S10: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Score: {
                type: "float"
              }
            }
          }
        },
        S14: {
          type: "structure",
          members: {
            Type: {},
            Score: {
              type: "float"
            },
            RelationshipScore: {
              type: "float"
            },
            RelationshipType: {},
            Id: {
              type: "integer"
            },
            BeginOffset: {
              type: "integer"
            },
            EndOffset: {
              type: "integer"
            },
            Text: {},
            Category: {},
            Traits: {
              shape: "S10"
            }
          }
        },
        S16: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Type: {},
              Attribute: {
                shape: "S14"
              }
            }
          }
        },
        S1m: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Score: {
                type: "float"
              }
            }
          }
        },
        S21: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Score: {
                type: "float"
              }
            }
          }
        },
        S2g: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Score: {
                type: "float"
              }
            }
          }
        },
        S2j: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Description: {},
              Code: {},
              Score: {
                type: "float"
              }
            }
          }
        },
        S2o: {
          type: "structure",
          members: {
            JobName: {},
            JobStatus: {},
            SubmitTimeBefore: {
              type: "timestamp"
            },
            SubmitTimeAfter: {
              type: "timestamp"
            }
          }
        },
        S2r: {
          type: "list",
          member: {
            shape: "S4"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/comprehendmedical-2018-10-30.paginators.json
var require_comprehendmedical_2018_10_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/comprehendmedical-2018-10-30.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/comprehendmedical.js
var require_comprehendmedical = __commonJS({
  "node_modules/aws-sdk/clients/comprehendmedical.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["comprehendmedical"] = {};
    AWS2.ComprehendMedical = Service.defineService("comprehendmedical", ["2018-10-30"]);
    Object.defineProperty(apiLoader.services["comprehendmedical"], "2018-10-30", {
      get: function get() {
        var model = require_comprehendmedical_2018_10_30_min();
        model.paginators = require_comprehendmedical_2018_10_30_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ComprehendMedical;
  }
});

// node_modules/aws-sdk/apis/kinesisanalyticsv2-2018-05-23.min.json
var require_kinesisanalyticsv2_2018_05_23_min = __commonJS({
  "node_modules/aws-sdk/apis/kinesisanalyticsv2-2018-05-23.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-05-23",
        endpointPrefix: "kinesisanalytics",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Kinesis Analytics V2",
        serviceFullName: "Amazon Kinesis Analytics",
        serviceId: "Kinesis Analytics V2",
        signatureVersion: "v4",
        signingName: "kinesisanalytics",
        targetPrefix: "KinesisAnalytics_20180523",
        uid: "kinesisanalyticsv2-2018-05-23"
      },
      operations: {
        AddApplicationCloudWatchLoggingOption: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CloudWatchLoggingOption"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              CloudWatchLoggingOption: {
                shape: "S4"
              },
              ConditionalToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationARN: {},
              ApplicationVersionId: {
                type: "long"
              },
              CloudWatchLoggingOptionDescriptions: {
                shape: "S9"
              }
            }
          }
        },
        AddApplicationInput: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "Input"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              Input: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationARN: {},
              ApplicationVersionId: {
                type: "long"
              },
              InputDescriptions: {
                shape: "S12"
              }
            }
          }
        },
        AddApplicationInputProcessingConfiguration: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "InputId",
              "InputProcessingConfiguration"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              InputId: {},
              InputProcessingConfiguration: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationARN: {},
              ApplicationVersionId: {
                type: "long"
              },
              InputId: {},
              InputProcessingConfigurationDescription: {
                shape: "S15"
              }
            }
          }
        },
        AddApplicationOutput: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "Output"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              Output: {
                shape: "S1e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationARN: {},
              ApplicationVersionId: {
                type: "long"
              },
              OutputDescriptions: {
                shape: "S1k"
              }
            }
          }
        },
        AddApplicationReferenceDataSource: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "ReferenceDataSource"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              ReferenceDataSource: {
                shape: "S1q"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationARN: {},
              ApplicationVersionId: {
                type: "long"
              },
              ReferenceDataSourceDescriptions: {
                shape: "S1w"
              }
            }
          }
        },
        AddApplicationVpcConfiguration: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "VpcConfiguration"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              VpcConfiguration: {
                shape: "S20"
              },
              ConditionalToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationARN: {},
              ApplicationVersionId: {
                type: "long"
              },
              VpcConfigurationDescription: {
                shape: "S26"
              }
            }
          }
        },
        CreateApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "RuntimeEnvironment",
              "ServiceExecutionRole"
            ],
            members: {
              ApplicationName: {},
              ApplicationDescription: {},
              RuntimeEnvironment: {},
              ServiceExecutionRole: {},
              ApplicationConfiguration: {
                type: "structure",
                members: {
                  SqlApplicationConfiguration: {
                    type: "structure",
                    members: {
                      Inputs: {
                        type: "list",
                        member: {
                          shape: "Se"
                        }
                      },
                      Outputs: {
                        type: "list",
                        member: {
                          shape: "S1e"
                        }
                      },
                      ReferenceDataSources: {
                        type: "list",
                        member: {
                          shape: "S1q"
                        }
                      }
                    }
                  },
                  FlinkApplicationConfiguration: {
                    type: "structure",
                    members: {
                      CheckpointConfiguration: {
                        type: "structure",
                        required: [
                          "ConfigurationType"
                        ],
                        members: {
                          ConfigurationType: {},
                          CheckpointingEnabled: {
                            type: "boolean"
                          },
                          CheckpointInterval: {
                            type: "long"
                          },
                          MinPauseBetweenCheckpoints: {
                            type: "long"
                          }
                        }
                      },
                      MonitoringConfiguration: {
                        type: "structure",
                        required: [
                          "ConfigurationType"
                        ],
                        members: {
                          ConfigurationType: {},
                          MetricsLevel: {},
                          LogLevel: {}
                        }
                      },
                      ParallelismConfiguration: {
                        type: "structure",
                        required: [
                          "ConfigurationType"
                        ],
                        members: {
                          ConfigurationType: {},
                          Parallelism: {
                            type: "integer"
                          },
                          ParallelismPerKPU: {
                            type: "integer"
                          },
                          AutoScalingEnabled: {
                            type: "boolean"
                          }
                        }
                      }
                    }
                  },
                  EnvironmentProperties: {
                    type: "structure",
                    required: [
                      "PropertyGroups"
                    ],
                    members: {
                      PropertyGroups: {
                        shape: "S2t"
                      }
                    }
                  },
                  ApplicationCodeConfiguration: {
                    type: "structure",
                    required: [
                      "CodeContentType"
                    ],
                    members: {
                      CodeContent: {
                        type: "structure",
                        members: {
                          TextContent: {},
                          ZipFileContent: {
                            type: "blob"
                          },
                          S3ContentLocation: {
                            shape: "S32"
                          }
                        }
                      },
                      CodeContentType: {}
                    }
                  },
                  ApplicationSnapshotConfiguration: {
                    type: "structure",
                    required: [
                      "SnapshotsEnabled"
                    ],
                    members: {
                      SnapshotsEnabled: {
                        type: "boolean"
                      }
                    }
                  },
                  VpcConfigurations: {
                    type: "list",
                    member: {
                      shape: "S20"
                    }
                  },
                  ZeppelinApplicationConfiguration: {
                    type: "structure",
                    members: {
                      MonitoringConfiguration: {
                        type: "structure",
                        required: [
                          "LogLevel"
                        ],
                        members: {
                          LogLevel: {}
                        }
                      },
                      CatalogConfiguration: {
                        type: "structure",
                        required: [
                          "GlueDataCatalogConfiguration"
                        ],
                        members: {
                          GlueDataCatalogConfiguration: {
                            type: "structure",
                            required: [
                              "DatabaseARN"
                            ],
                            members: {
                              DatabaseARN: {}
                            }
                          }
                        }
                      },
                      DeployAsApplicationConfiguration: {
                        type: "structure",
                        required: [
                          "S3ContentLocation"
                        ],
                        members: {
                          S3ContentLocation: {
                            type: "structure",
                            required: [
                              "BucketARN"
                            ],
                            members: {
                              BucketARN: {},
                              BasePath: {}
                            }
                          }
                        }
                      },
                      CustomArtifactsConfiguration: {
                        shape: "S3f"
                      }
                    }
                  }
                }
              },
              CloudWatchLoggingOptions: {
                type: "list",
                member: {
                  shape: "S4"
                }
              },
              Tags: {
                shape: "S3n"
              },
              ApplicationMode: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ApplicationDetail"
            ],
            members: {
              ApplicationDetail: {
                shape: "S3t"
              }
            }
          }
        },
        CreateApplicationPresignedUrl: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "UrlType"
            ],
            members: {
              ApplicationName: {},
              UrlType: {},
              SessionExpirationDurationInSeconds: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AuthorizedUrl: {}
            }
          }
        },
        CreateApplicationSnapshot: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "SnapshotName"
            ],
            members: {
              ApplicationName: {},
              SnapshotName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CreateTimestamp"
            ],
            members: {
              ApplicationName: {},
              CreateTimestamp: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteApplicationCloudWatchLoggingOption: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CloudWatchLoggingOptionId"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              CloudWatchLoggingOptionId: {},
              ConditionalToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationARN: {},
              ApplicationVersionId: {
                type: "long"
              },
              CloudWatchLoggingOptionDescriptions: {
                shape: "S9"
              }
            }
          }
        },
        DeleteApplicationInputProcessingConfiguration: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "InputId"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              InputId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationARN: {},
              ApplicationVersionId: {
                type: "long"
              }
            }
          }
        },
        DeleteApplicationOutput: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "OutputId"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              OutputId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationARN: {},
              ApplicationVersionId: {
                type: "long"
              }
            }
          }
        },
        DeleteApplicationReferenceDataSource: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "ReferenceId"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              ReferenceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationARN: {},
              ApplicationVersionId: {
                type: "long"
              }
            }
          }
        },
        DeleteApplicationSnapshot: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "SnapshotName",
              "SnapshotCreationTimestamp"
            ],
            members: {
              ApplicationName: {},
              SnapshotName: {},
              SnapshotCreationTimestamp: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteApplicationVpcConfiguration: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "VpcConfigurationId"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              VpcConfigurationId: {},
              ConditionalToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationARN: {},
              ApplicationVersionId: {
                type: "long"
              }
            }
          }
        },
        DescribeApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName"
            ],
            members: {
              ApplicationName: {},
              IncludeAdditionalDetails: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ApplicationDetail"
            ],
            members: {
              ApplicationDetail: {
                shape: "S3t"
              }
            }
          }
        },
        DescribeApplicationSnapshot: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "SnapshotName"
            ],
            members: {
              ApplicationName: {},
              SnapshotName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "SnapshotDetails"
            ],
            members: {
              SnapshotDetails: {
                shape: "S5g"
              }
            }
          }
        },
        DescribeApplicationVersion: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "ApplicationVersionId"
            ],
            members: {
              ApplicationName: {},
              ApplicationVersionId: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationVersionDetail: {
                shape: "S3t"
              }
            }
          }
        },
        DiscoverInputSchema: {
          input: {
            type: "structure",
            required: [
              "ServiceExecutionRole"
            ],
            members: {
              ResourceARN: {},
              ServiceExecutionRole: {},
              InputStartingPositionConfiguration: {
                shape: "S19"
              },
              S3Configuration: {
                type: "structure",
                required: [
                  "BucketARN",
                  "FileKey"
                ],
                members: {
                  BucketARN: {},
                  FileKey: {}
                }
              },
              InputProcessingConfiguration: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InputSchema: {
                shape: "Sm"
              },
              ParsedInputRecords: {
                type: "list",
                member: {
                  type: "list",
                  member: {}
                }
              },
              ProcessedInputRecords: {
                type: "list",
                member: {}
              },
              RawInputRecords: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ListApplicationSnapshots: {
          input: {
            type: "structure",
            required: [
              "ApplicationName"
            ],
            members: {
              ApplicationName: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SnapshotSummaries: {
                type: "list",
                member: {
                  shape: "S5g"
                }
              },
              NextToken: {}
            }
          }
        },
        ListApplicationVersions: {
          input: {
            type: "structure",
            required: [
              "ApplicationName"
            ],
            members: {
              ApplicationName: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationVersionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ApplicationVersionId",
                    "ApplicationStatus"
                  ],
                  members: {
                    ApplicationVersionId: {
                      type: "long"
                    },
                    ApplicationStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListApplications: {
          input: {
            type: "structure",
            members: {
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ApplicationSummaries"
            ],
            members: {
              ApplicationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ApplicationName",
                    "ApplicationARN",
                    "ApplicationStatus",
                    "ApplicationVersionId",
                    "RuntimeEnvironment"
                  ],
                  members: {
                    ApplicationName: {},
                    ApplicationARN: {},
                    ApplicationStatus: {},
                    ApplicationVersionId: {
                      type: "long"
                    },
                    RuntimeEnvironment: {},
                    ApplicationMode: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S3n"
              }
            }
          }
        },
        RollbackApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ApplicationDetail"
            ],
            members: {
              ApplicationDetail: {
                shape: "S3t"
              }
            }
          }
        },
        StartApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName"
            ],
            members: {
              ApplicationName: {},
              RunConfiguration: {
                type: "structure",
                members: {
                  FlinkRunConfiguration: {
                    shape: "S47"
                  },
                  SqlRunConfigurations: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "InputId",
                        "InputStartingPositionConfiguration"
                      ],
                      members: {
                        InputId: {},
                        InputStartingPositionConfiguration: {
                          shape: "S19"
                        }
                      }
                    }
                  },
                  ApplicationRestoreConfiguration: {
                    shape: "S44"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StopApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName"
            ],
            members: {
              ApplicationName: {},
              Force: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S3n"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              ApplicationConfigurationUpdate: {
                type: "structure",
                members: {
                  SqlApplicationConfigurationUpdate: {
                    type: "structure",
                    members: {
                      InputUpdates: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "InputId"
                          ],
                          members: {
                            InputId: {},
                            NamePrefixUpdate: {},
                            InputProcessingConfigurationUpdate: {
                              type: "structure",
                              required: [
                                "InputLambdaProcessorUpdate"
                              ],
                              members: {
                                InputLambdaProcessorUpdate: {
                                  type: "structure",
                                  required: [
                                    "ResourceARNUpdate"
                                  ],
                                  members: {
                                    ResourceARNUpdate: {}
                                  }
                                }
                              }
                            },
                            KinesisStreamsInputUpdate: {
                              type: "structure",
                              required: [
                                "ResourceARNUpdate"
                              ],
                              members: {
                                ResourceARNUpdate: {}
                              }
                            },
                            KinesisFirehoseInputUpdate: {
                              type: "structure",
                              required: [
                                "ResourceARNUpdate"
                              ],
                              members: {
                                ResourceARNUpdate: {}
                              }
                            },
                            InputSchemaUpdate: {
                              type: "structure",
                              members: {
                                RecordFormatUpdate: {
                                  shape: "Sn"
                                },
                                RecordEncodingUpdate: {},
                                RecordColumnUpdates: {
                                  shape: "Sw"
                                }
                              }
                            },
                            InputParallelismUpdate: {
                              type: "structure",
                              required: [
                                "CountUpdate"
                              ],
                              members: {
                                CountUpdate: {
                                  type: "integer"
                                }
                              }
                            }
                          }
                        }
                      },
                      OutputUpdates: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "OutputId"
                          ],
                          members: {
                            OutputId: {},
                            NameUpdate: {},
                            KinesisStreamsOutputUpdate: {
                              type: "structure",
                              required: [
                                "ResourceARNUpdate"
                              ],
                              members: {
                                ResourceARNUpdate: {}
                              }
                            },
                            KinesisFirehoseOutputUpdate: {
                              type: "structure",
                              required: [
                                "ResourceARNUpdate"
                              ],
                              members: {
                                ResourceARNUpdate: {}
                              }
                            },
                            LambdaOutputUpdate: {
                              type: "structure",
                              required: [
                                "ResourceARNUpdate"
                              ],
                              members: {
                                ResourceARNUpdate: {}
                              }
                            },
                            DestinationSchemaUpdate: {
                              shape: "S1i"
                            }
                          }
                        }
                      },
                      ReferenceDataSourceUpdates: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "ReferenceId"
                          ],
                          members: {
                            ReferenceId: {},
                            TableNameUpdate: {},
                            S3ReferenceDataSourceUpdate: {
                              type: "structure",
                              members: {
                                BucketARNUpdate: {},
                                FileKeyUpdate: {}
                              }
                            },
                            ReferenceSchemaUpdate: {
                              shape: "Sm"
                            }
                          }
                        }
                      }
                    }
                  },
                  ApplicationCodeConfigurationUpdate: {
                    type: "structure",
                    members: {
                      CodeContentTypeUpdate: {},
                      CodeContentUpdate: {
                        type: "structure",
                        members: {
                          TextContentUpdate: {},
                          ZipFileContentUpdate: {
                            type: "blob"
                          },
                          S3ContentLocationUpdate: {
                            type: "structure",
                            members: {
                              BucketARNUpdate: {},
                              FileKeyUpdate: {},
                              ObjectVersionUpdate: {}
                            }
                          }
                        }
                      }
                    }
                  },
                  FlinkApplicationConfigurationUpdate: {
                    type: "structure",
                    members: {
                      CheckpointConfigurationUpdate: {
                        type: "structure",
                        members: {
                          ConfigurationTypeUpdate: {},
                          CheckpointingEnabledUpdate: {
                            type: "boolean"
                          },
                          CheckpointIntervalUpdate: {
                            type: "long"
                          },
                          MinPauseBetweenCheckpointsUpdate: {
                            type: "long"
                          }
                        }
                      },
                      MonitoringConfigurationUpdate: {
                        type: "structure",
                        members: {
                          ConfigurationTypeUpdate: {},
                          MetricsLevelUpdate: {},
                          LogLevelUpdate: {}
                        }
                      },
                      ParallelismConfigurationUpdate: {
                        type: "structure",
                        members: {
                          ConfigurationTypeUpdate: {},
                          ParallelismUpdate: {
                            type: "integer"
                          },
                          ParallelismPerKPUUpdate: {
                            type: "integer"
                          },
                          AutoScalingEnabledUpdate: {
                            type: "boolean"
                          }
                        }
                      }
                    }
                  },
                  EnvironmentPropertyUpdates: {
                    type: "structure",
                    required: [
                      "PropertyGroups"
                    ],
                    members: {
                      PropertyGroups: {
                        shape: "S2t"
                      }
                    }
                  },
                  ApplicationSnapshotConfigurationUpdate: {
                    type: "structure",
                    required: [
                      "SnapshotsEnabledUpdate"
                    ],
                    members: {
                      SnapshotsEnabledUpdate: {
                        type: "boolean"
                      }
                    }
                  },
                  VpcConfigurationUpdates: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "VpcConfigurationId"
                      ],
                      members: {
                        VpcConfigurationId: {},
                        SubnetIdUpdates: {
                          shape: "S21"
                        },
                        SecurityGroupIdUpdates: {
                          shape: "S23"
                        }
                      }
                    }
                  },
                  ZeppelinApplicationConfigurationUpdate: {
                    type: "structure",
                    members: {
                      MonitoringConfigurationUpdate: {
                        type: "structure",
                        required: [
                          "LogLevelUpdate"
                        ],
                        members: {
                          LogLevelUpdate: {}
                        }
                      },
                      CatalogConfigurationUpdate: {
                        type: "structure",
                        required: [
                          "GlueDataCatalogConfigurationUpdate"
                        ],
                        members: {
                          GlueDataCatalogConfigurationUpdate: {
                            type: "structure",
                            required: [
                              "DatabaseARNUpdate"
                            ],
                            members: {
                              DatabaseARNUpdate: {}
                            }
                          }
                        }
                      },
                      DeployAsApplicationConfigurationUpdate: {
                        type: "structure",
                        members: {
                          S3ContentLocationUpdate: {
                            type: "structure",
                            members: {
                              BucketARNUpdate: {},
                              BasePathUpdate: {}
                            }
                          }
                        }
                      },
                      CustomArtifactsConfigurationUpdate: {
                        shape: "S3f"
                      }
                    }
                  }
                }
              },
              ServiceExecutionRoleUpdate: {},
              RunConfigurationUpdate: {
                type: "structure",
                members: {
                  FlinkRunConfiguration: {
                    shape: "S47"
                  },
                  ApplicationRestoreConfiguration: {
                    shape: "S44"
                  }
                }
              },
              CloudWatchLoggingOptionUpdates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "CloudWatchLoggingOptionId"
                  ],
                  members: {
                    CloudWatchLoggingOptionId: {},
                    LogStreamARNUpdate: {}
                  }
                }
              },
              ConditionalToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ApplicationDetail"
            ],
            members: {
              ApplicationDetail: {
                shape: "S3t"
              }
            }
          }
        },
        UpdateApplicationMaintenanceConfiguration: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "ApplicationMaintenanceConfigurationUpdate"
            ],
            members: {
              ApplicationName: {},
              ApplicationMaintenanceConfigurationUpdate: {
                type: "structure",
                required: [
                  "ApplicationMaintenanceWindowStartTimeUpdate"
                ],
                members: {
                  ApplicationMaintenanceWindowStartTimeUpdate: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationARN: {},
              ApplicationMaintenanceConfigurationDescription: {
                shape: "S4o"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          required: [
            "LogStreamARN"
          ],
          members: {
            LogStreamARN: {}
          }
        },
        S9: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "LogStreamARN"
            ],
            members: {
              CloudWatchLoggingOptionId: {},
              LogStreamARN: {},
              RoleARN: {}
            }
          }
        },
        Se: {
          type: "structure",
          required: [
            "NamePrefix",
            "InputSchema"
          ],
          members: {
            NamePrefix: {},
            InputProcessingConfiguration: {
              shape: "Sg"
            },
            KinesisStreamsInput: {
              type: "structure",
              required: [
                "ResourceARN"
              ],
              members: {
                ResourceARN: {}
              }
            },
            KinesisFirehoseInput: {
              type: "structure",
              required: [
                "ResourceARN"
              ],
              members: {
                ResourceARN: {}
              }
            },
            InputParallelism: {
              shape: "Sk"
            },
            InputSchema: {
              shape: "Sm"
            }
          }
        },
        Sg: {
          type: "structure",
          required: [
            "InputLambdaProcessor"
          ],
          members: {
            InputLambdaProcessor: {
              type: "structure",
              required: [
                "ResourceARN"
              ],
              members: {
                ResourceARN: {}
              }
            }
          }
        },
        Sk: {
          type: "structure",
          members: {
            Count: {
              type: "integer"
            }
          }
        },
        Sm: {
          type: "structure",
          required: [
            "RecordFormat",
            "RecordColumns"
          ],
          members: {
            RecordFormat: {
              shape: "Sn"
            },
            RecordEncoding: {},
            RecordColumns: {
              shape: "Sw"
            }
          }
        },
        Sn: {
          type: "structure",
          required: [
            "RecordFormatType"
          ],
          members: {
            RecordFormatType: {},
            MappingParameters: {
              type: "structure",
              members: {
                JSONMappingParameters: {
                  type: "structure",
                  required: [
                    "RecordRowPath"
                  ],
                  members: {
                    RecordRowPath: {}
                  }
                },
                CSVMappingParameters: {
                  type: "structure",
                  required: [
                    "RecordRowDelimiter",
                    "RecordColumnDelimiter"
                  ],
                  members: {
                    RecordRowDelimiter: {},
                    RecordColumnDelimiter: {}
                  }
                }
              }
            }
          }
        },
        Sw: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "SqlType"
            ],
            members: {
              Name: {},
              Mapping: {},
              SqlType: {}
            }
          }
        },
        S12: {
          type: "list",
          member: {
            type: "structure",
            members: {
              InputId: {},
              NamePrefix: {},
              InAppStreamNames: {
                type: "list",
                member: {}
              },
              InputProcessingConfigurationDescription: {
                shape: "S15"
              },
              KinesisStreamsInputDescription: {
                type: "structure",
                required: [
                  "ResourceARN"
                ],
                members: {
                  ResourceARN: {},
                  RoleARN: {}
                }
              },
              KinesisFirehoseInputDescription: {
                type: "structure",
                required: [
                  "ResourceARN"
                ],
                members: {
                  ResourceARN: {},
                  RoleARN: {}
                }
              },
              InputSchema: {
                shape: "Sm"
              },
              InputParallelism: {
                shape: "Sk"
              },
              InputStartingPositionConfiguration: {
                shape: "S19"
              }
            }
          }
        },
        S15: {
          type: "structure",
          members: {
            InputLambdaProcessorDescription: {
              type: "structure",
              required: [
                "ResourceARN"
              ],
              members: {
                ResourceARN: {},
                RoleARN: {}
              }
            }
          }
        },
        S19: {
          type: "structure",
          members: {
            InputStartingPosition: {}
          }
        },
        S1e: {
          type: "structure",
          required: [
            "Name",
            "DestinationSchema"
          ],
          members: {
            Name: {},
            KinesisStreamsOutput: {
              type: "structure",
              required: [
                "ResourceARN"
              ],
              members: {
                ResourceARN: {}
              }
            },
            KinesisFirehoseOutput: {
              type: "structure",
              required: [
                "ResourceARN"
              ],
              members: {
                ResourceARN: {}
              }
            },
            LambdaOutput: {
              type: "structure",
              required: [
                "ResourceARN"
              ],
              members: {
                ResourceARN: {}
              }
            },
            DestinationSchema: {
              shape: "S1i"
            }
          }
        },
        S1i: {
          type: "structure",
          required: [
            "RecordFormatType"
          ],
          members: {
            RecordFormatType: {}
          }
        },
        S1k: {
          type: "list",
          member: {
            type: "structure",
            members: {
              OutputId: {},
              Name: {},
              KinesisStreamsOutputDescription: {
                type: "structure",
                required: [
                  "ResourceARN"
                ],
                members: {
                  ResourceARN: {},
                  RoleARN: {}
                }
              },
              KinesisFirehoseOutputDescription: {
                type: "structure",
                required: [
                  "ResourceARN"
                ],
                members: {
                  ResourceARN: {},
                  RoleARN: {}
                }
              },
              LambdaOutputDescription: {
                type: "structure",
                required: [
                  "ResourceARN"
                ],
                members: {
                  ResourceARN: {},
                  RoleARN: {}
                }
              },
              DestinationSchema: {
                shape: "S1i"
              }
            }
          }
        },
        S1q: {
          type: "structure",
          required: [
            "TableName",
            "ReferenceSchema"
          ],
          members: {
            TableName: {},
            S3ReferenceDataSource: {
              type: "structure",
              members: {
                BucketARN: {},
                FileKey: {}
              }
            },
            ReferenceSchema: {
              shape: "Sm"
            }
          }
        },
        S1w: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ReferenceId",
              "TableName",
              "S3ReferenceDataSourceDescription"
            ],
            members: {
              ReferenceId: {},
              TableName: {},
              S3ReferenceDataSourceDescription: {
                type: "structure",
                required: [
                  "BucketARN",
                  "FileKey"
                ],
                members: {
                  BucketARN: {},
                  FileKey: {},
                  ReferenceRoleARN: {}
                }
              },
              ReferenceSchema: {
                shape: "Sm"
              }
            }
          }
        },
        S20: {
          type: "structure",
          required: [
            "SubnetIds",
            "SecurityGroupIds"
          ],
          members: {
            SubnetIds: {
              shape: "S21"
            },
            SecurityGroupIds: {
              shape: "S23"
            }
          }
        },
        S21: {
          type: "list",
          member: {}
        },
        S23: {
          type: "list",
          member: {}
        },
        S26: {
          type: "structure",
          required: [
            "VpcConfigurationId",
            "VpcId",
            "SubnetIds",
            "SecurityGroupIds"
          ],
          members: {
            VpcConfigurationId: {},
            VpcId: {},
            SubnetIds: {
              shape: "S21"
            },
            SecurityGroupIds: {
              shape: "S23"
            }
          }
        },
        S2t: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "PropertyGroupId",
              "PropertyMap"
            ],
            members: {
              PropertyGroupId: {},
              PropertyMap: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        S32: {
          type: "structure",
          required: [
            "BucketARN",
            "FileKey"
          ],
          members: {
            BucketARN: {},
            FileKey: {},
            ObjectVersion: {}
          }
        },
        S3f: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ArtifactType"
            ],
            members: {
              ArtifactType: {},
              S3ContentLocation: {
                shape: "S32"
              },
              MavenReference: {
                shape: "S3i"
              }
            }
          }
        },
        S3i: {
          type: "structure",
          required: [
            "GroupId",
            "ArtifactId",
            "Version"
          ],
          members: {
            GroupId: {},
            ArtifactId: {},
            Version: {}
          }
        },
        S3n: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S3t: {
          type: "structure",
          required: [
            "ApplicationARN",
            "ApplicationName",
            "RuntimeEnvironment",
            "ApplicationStatus",
            "ApplicationVersionId"
          ],
          members: {
            ApplicationARN: {},
            ApplicationDescription: {},
            ApplicationName: {},
            RuntimeEnvironment: {},
            ServiceExecutionRole: {},
            ApplicationStatus: {},
            ApplicationVersionId: {
              type: "long"
            },
            CreateTimestamp: {
              type: "timestamp"
            },
            LastUpdateTimestamp: {
              type: "timestamp"
            },
            ApplicationConfigurationDescription: {
              type: "structure",
              members: {
                SqlApplicationConfigurationDescription: {
                  type: "structure",
                  members: {
                    InputDescriptions: {
                      shape: "S12"
                    },
                    OutputDescriptions: {
                      shape: "S1k"
                    },
                    ReferenceDataSourceDescriptions: {
                      shape: "S1w"
                    }
                  }
                },
                ApplicationCodeConfigurationDescription: {
                  type: "structure",
                  required: [
                    "CodeContentType"
                  ],
                  members: {
                    CodeContentType: {},
                    CodeContentDescription: {
                      type: "structure",
                      members: {
                        TextContent: {},
                        CodeMD5: {},
                        CodeSize: {
                          type: "long"
                        },
                        S3ApplicationCodeLocationDescription: {
                          type: "structure",
                          required: [
                            "BucketARN",
                            "FileKey"
                          ],
                          members: {
                            BucketARN: {},
                            FileKey: {},
                            ObjectVersion: {}
                          }
                        }
                      }
                    }
                  }
                },
                RunConfigurationDescription: {
                  type: "structure",
                  members: {
                    ApplicationRestoreConfigurationDescription: {
                      shape: "S44"
                    },
                    FlinkRunConfigurationDescription: {
                      shape: "S47"
                    }
                  }
                },
                FlinkApplicationConfigurationDescription: {
                  type: "structure",
                  members: {
                    CheckpointConfigurationDescription: {
                      type: "structure",
                      members: {
                        ConfigurationType: {},
                        CheckpointingEnabled: {
                          type: "boolean"
                        },
                        CheckpointInterval: {
                          type: "long"
                        },
                        MinPauseBetweenCheckpoints: {
                          type: "long"
                        }
                      }
                    },
                    MonitoringConfigurationDescription: {
                      type: "structure",
                      members: {
                        ConfigurationType: {},
                        MetricsLevel: {},
                        LogLevel: {}
                      }
                    },
                    ParallelismConfigurationDescription: {
                      type: "structure",
                      members: {
                        ConfigurationType: {},
                        Parallelism: {
                          type: "integer"
                        },
                        ParallelismPerKPU: {
                          type: "integer"
                        },
                        CurrentParallelism: {
                          type: "integer"
                        },
                        AutoScalingEnabled: {
                          type: "boolean"
                        }
                      }
                    },
                    JobPlanDescription: {}
                  }
                },
                EnvironmentPropertyDescriptions: {
                  type: "structure",
                  members: {
                    PropertyGroupDescriptions: {
                      shape: "S2t"
                    }
                  }
                },
                ApplicationSnapshotConfigurationDescription: {
                  type: "structure",
                  required: [
                    "SnapshotsEnabled"
                  ],
                  members: {
                    SnapshotsEnabled: {
                      type: "boolean"
                    }
                  }
                },
                VpcConfigurationDescriptions: {
                  type: "list",
                  member: {
                    shape: "S26"
                  }
                },
                ZeppelinApplicationConfigurationDescription: {
                  type: "structure",
                  required: [
                    "MonitoringConfigurationDescription"
                  ],
                  members: {
                    MonitoringConfigurationDescription: {
                      type: "structure",
                      members: {
                        LogLevel: {}
                      }
                    },
                    CatalogConfigurationDescription: {
                      type: "structure",
                      required: [
                        "GlueDataCatalogConfigurationDescription"
                      ],
                      members: {
                        GlueDataCatalogConfigurationDescription: {
                          type: "structure",
                          required: [
                            "DatabaseARN"
                          ],
                          members: {
                            DatabaseARN: {}
                          }
                        }
                      }
                    },
                    DeployAsApplicationConfigurationDescription: {
                      type: "structure",
                      required: [
                        "S3ContentLocationDescription"
                      ],
                      members: {
                        S3ContentLocationDescription: {
                          type: "structure",
                          required: [
                            "BucketARN"
                          ],
                          members: {
                            BucketARN: {},
                            BasePath: {}
                          }
                        }
                      }
                    },
                    CustomArtifactsConfigurationDescription: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ArtifactType: {},
                          S3ContentLocationDescription: {
                            shape: "S32"
                          },
                          MavenReferenceDescription: {
                            shape: "S3i"
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            CloudWatchLoggingOptionDescriptions: {
              shape: "S9"
            },
            ApplicationMaintenanceConfigurationDescription: {
              shape: "S4o"
            },
            ApplicationVersionUpdatedFrom: {
              type: "long"
            },
            ApplicationVersionRolledBackFrom: {
              type: "long"
            },
            ConditionalToken: {},
            ApplicationVersionRolledBackTo: {
              type: "long"
            },
            ApplicationMode: {}
          }
        },
        S44: {
          type: "structure",
          required: [
            "ApplicationRestoreType"
          ],
          members: {
            ApplicationRestoreType: {},
            SnapshotName: {}
          }
        },
        S47: {
          type: "structure",
          members: {
            AllowNonRestoredState: {
              type: "boolean"
            }
          }
        },
        S4o: {
          type: "structure",
          required: [
            "ApplicationMaintenanceWindowStartTime",
            "ApplicationMaintenanceWindowEndTime"
          ],
          members: {
            ApplicationMaintenanceWindowStartTime: {},
            ApplicationMaintenanceWindowEndTime: {}
          }
        },
        S5g: {
          type: "structure",
          required: [
            "SnapshotName",
            "SnapshotStatus",
            "ApplicationVersionId"
          ],
          members: {
            SnapshotName: {},
            SnapshotStatus: {},
            ApplicationVersionId: {
              type: "long"
            },
            SnapshotCreationTimestamp: {
              type: "timestamp"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/kinesisanalyticsv2-2018-05-23.paginators.json
var require_kinesisanalyticsv2_2018_05_23_paginators = __commonJS({
  "node_modules/aws-sdk/apis/kinesisanalyticsv2-2018-05-23.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/kinesisanalyticsv2.js
var require_kinesisanalyticsv2 = __commonJS({
  "node_modules/aws-sdk/clients/kinesisanalyticsv2.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["kinesisanalyticsv2"] = {};
    AWS2.KinesisAnalyticsV2 = Service.defineService("kinesisanalyticsv2", ["2018-05-23"]);
    Object.defineProperty(apiLoader.services["kinesisanalyticsv2"], "2018-05-23", {
      get: function get() {
        var model = require_kinesisanalyticsv2_2018_05_23_min();
        model.paginators = require_kinesisanalyticsv2_2018_05_23_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.KinesisAnalyticsV2;
  }
});

// node_modules/aws-sdk/apis/mediaconnect-2018-11-14.min.json
var require_mediaconnect_2018_11_14_min = __commonJS({
  "node_modules/aws-sdk/apis/mediaconnect-2018-11-14.min.json"(exports2, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2018-11-14",
        endpointPrefix: "mediaconnect",
        signingName: "mediaconnect",
        serviceFullName: "AWS MediaConnect",
        serviceId: "MediaConnect",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "mediaconnect-2018-11-14",
        signatureVersion: "v4"
      },
      operations: {
        AddBridgeOutputs: {
          http: {
            requestUri: "/v1/bridges/{bridgeArn}/outputs",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              BridgeArn: {
                location: "uri",
                locationName: "bridgeArn"
              },
              Outputs: {
                shape: "S3",
                locationName: "outputs"
              }
            },
            required: [
              "BridgeArn",
              "Outputs"
            ]
          },
          output: {
            type: "structure",
            members: {
              BridgeArn: {
                locationName: "bridgeArn"
              },
              Outputs: {
                shape: "S9",
                locationName: "outputs"
              }
            }
          }
        },
        AddBridgeSources: {
          http: {
            requestUri: "/v1/bridges/{bridgeArn}/sources",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              BridgeArn: {
                location: "uri",
                locationName: "bridgeArn"
              },
              Sources: {
                shape: "Se",
                locationName: "sources"
              }
            },
            required: [
              "BridgeArn",
              "Sources"
            ]
          },
          output: {
            type: "structure",
            members: {
              BridgeArn: {
                locationName: "bridgeArn"
              },
              Sources: {
                shape: "Sk",
                locationName: "sources"
              }
            }
          }
        },
        AddFlowMediaStreams: {
          http: {
            requestUri: "/v1/flows/{flowArn}/mediaStreams",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              },
              MediaStreams: {
                shape: "Sp",
                locationName: "mediaStreams"
              }
            },
            required: [
              "FlowArn",
              "MediaStreams"
            ]
          },
          output: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              },
              MediaStreams: {
                shape: "Sz",
                locationName: "mediaStreams"
              }
            }
          }
        },
        AddFlowOutputs: {
          http: {
            requestUri: "/v1/flows/{flowArn}/outputs",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              },
              Outputs: {
                shape: "S14",
                locationName: "outputs"
              }
            },
            required: [
              "FlowArn",
              "Outputs"
            ]
          },
          output: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              },
              Outputs: {
                shape: "S1k",
                locationName: "outputs"
              }
            }
          }
        },
        AddFlowSources: {
          http: {
            requestUri: "/v1/flows/{flowArn}/source",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              },
              Sources: {
                shape: "S1v",
                locationName: "sources"
              }
            },
            required: [
              "FlowArn",
              "Sources"
            ]
          },
          output: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              },
              Sources: {
                shape: "S23",
                locationName: "sources"
              }
            }
          }
        },
        AddFlowVpcInterfaces: {
          http: {
            requestUri: "/v1/flows/{flowArn}/vpcInterfaces",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              },
              VpcInterfaces: {
                shape: "S2b",
                locationName: "vpcInterfaces"
              }
            },
            required: [
              "FlowArn",
              "VpcInterfaces"
            ]
          },
          output: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              },
              VpcInterfaces: {
                shape: "S2f",
                locationName: "vpcInterfaces"
              }
            }
          }
        },
        CreateBridge: {
          http: {
            requestUri: "/v1/bridges",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              EgressGatewayBridge: {
                locationName: "egressGatewayBridge",
                type: "structure",
                members: {
                  MaxBitrate: {
                    locationName: "maxBitrate",
                    type: "integer"
                  }
                },
                required: [
                  "MaxBitrate"
                ]
              },
              IngressGatewayBridge: {
                locationName: "ingressGatewayBridge",
                type: "structure",
                members: {
                  MaxBitrate: {
                    locationName: "maxBitrate",
                    type: "integer"
                  },
                  MaxOutputs: {
                    locationName: "maxOutputs",
                    type: "integer"
                  }
                },
                required: [
                  "MaxOutputs",
                  "MaxBitrate"
                ]
              },
              Name: {
                locationName: "name"
              },
              Outputs: {
                shape: "S3",
                locationName: "outputs"
              },
              PlacementArn: {
                locationName: "placementArn"
              },
              SourceFailoverConfig: {
                shape: "S2k",
                locationName: "sourceFailoverConfig"
              },
              Sources: {
                shape: "Se",
                locationName: "sources"
              }
            },
            required: [
              "Sources",
              "PlacementArn",
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              Bridge: {
                shape: "S2p",
                locationName: "bridge"
              }
            }
          }
        },
        CreateFlow: {
          http: {
            requestUri: "/v1/flows",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              AvailabilityZone: {
                locationName: "availabilityZone"
              },
              Entitlements: {
                shape: "S2w",
                locationName: "entitlements"
              },
              MediaStreams: {
                shape: "Sp",
                locationName: "mediaStreams"
              },
              Name: {
                locationName: "name"
              },
              Outputs: {
                shape: "S14",
                locationName: "outputs"
              },
              Source: {
                shape: "S1w",
                locationName: "source"
              },
              SourceFailoverConfig: {
                shape: "S2k",
                locationName: "sourceFailoverConfig"
              },
              Sources: {
                shape: "S1v",
                locationName: "sources"
              },
              VpcInterfaces: {
                shape: "S2b",
                locationName: "vpcInterfaces"
              },
              Maintenance: {
                locationName: "maintenance",
                type: "structure",
                members: {
                  MaintenanceDay: {
                    locationName: "maintenanceDay"
                  },
                  MaintenanceStartHour: {
                    locationName: "maintenanceStartHour"
                  }
                },
                required: [
                  "MaintenanceDay",
                  "MaintenanceStartHour"
                ]
              }
            },
            required: [
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              Flow: {
                shape: "S32",
                locationName: "flow"
              }
            }
          }
        },
        CreateGateway: {
          http: {
            requestUri: "/v1/gateways",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              EgressCidrBlocks: {
                shape: "S16",
                locationName: "egressCidrBlocks"
              },
              Name: {
                locationName: "name"
              },
              Networks: {
                shape: "S38",
                locationName: "networks"
              }
            },
            required: [
              "Networks",
              "EgressCidrBlocks",
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              Gateway: {
                shape: "S3b",
                locationName: "gateway"
              }
            }
          }
        },
        DeleteBridge: {
          http: {
            method: "DELETE",
            requestUri: "/v1/bridges/{bridgeArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BridgeArn: {
                location: "uri",
                locationName: "bridgeArn"
              }
            },
            required: [
              "BridgeArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              BridgeArn: {
                locationName: "bridgeArn"
              }
            }
          }
        },
        DeleteFlow: {
          http: {
            method: "DELETE",
            requestUri: "/v1/flows/{flowArn}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              }
            },
            required: [
              "FlowArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        DeleteGateway: {
          http: {
            method: "DELETE",
            requestUri: "/v1/gateways/{gatewayArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              GatewayArn: {
                location: "uri",
                locationName: "gatewayArn"
              }
            },
            required: [
              "GatewayArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              GatewayArn: {
                locationName: "gatewayArn"
              }
            }
          }
        },
        DeregisterGatewayInstance: {
          http: {
            method: "DELETE",
            requestUri: "/v1/gateway-instances/{gatewayInstanceArn}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              Force: {
                location: "querystring",
                locationName: "force",
                type: "boolean"
              },
              GatewayInstanceArn: {
                location: "uri",
                locationName: "gatewayInstanceArn"
              }
            },
            required: [
              "GatewayInstanceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              GatewayInstanceArn: {
                locationName: "gatewayInstanceArn"
              },
              InstanceState: {
                locationName: "instanceState"
              }
            }
          }
        },
        DescribeBridge: {
          http: {
            method: "GET",
            requestUri: "/v1/bridges/{bridgeArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BridgeArn: {
                location: "uri",
                locationName: "bridgeArn"
              }
            },
            required: [
              "BridgeArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Bridge: {
                shape: "S2p",
                locationName: "bridge"
              }
            }
          }
        },
        DescribeFlow: {
          http: {
            method: "GET",
            requestUri: "/v1/flows/{flowArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              }
            },
            required: [
              "FlowArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Flow: {
                shape: "S32",
                locationName: "flow"
              },
              Messages: {
                locationName: "messages",
                type: "structure",
                members: {
                  Errors: {
                    shape: "S16",
                    locationName: "errors"
                  }
                },
                required: [
                  "Errors"
                ]
              }
            }
          }
        },
        DescribeFlowSourceMetadata: {
          http: {
            method: "GET",
            requestUri: "/v1/flows/{flowArn}/source-metadata",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              }
            },
            required: [
              "FlowArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              },
              Messages: {
                shape: "S2q",
                locationName: "messages"
              },
              Timestamp: {
                locationName: "timestamp",
                type: "timestamp",
                timestampFormat: "iso8601"
              },
              TransportMediaInfo: {
                locationName: "transportMediaInfo",
                type: "structure",
                members: {
                  Programs: {
                    locationName: "programs",
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        PcrPid: {
                          locationName: "pcrPid",
                          type: "integer"
                        },
                        ProgramName: {
                          locationName: "programName"
                        },
                        ProgramNumber: {
                          locationName: "programNumber",
                          type: "integer"
                        },
                        ProgramPid: {
                          locationName: "programPid",
                          type: "integer"
                        },
                        Streams: {
                          locationName: "streams",
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              Channels: {
                                locationName: "channels",
                                type: "integer"
                              },
                              Codec: {
                                locationName: "codec"
                              },
                              FrameRate: {
                                locationName: "frameRate"
                              },
                              FrameResolution: {
                                locationName: "frameResolution",
                                type: "structure",
                                members: {
                                  FrameHeight: {
                                    locationName: "frameHeight",
                                    type: "integer"
                                  },
                                  FrameWidth: {
                                    locationName: "frameWidth",
                                    type: "integer"
                                  }
                                },
                                required: [
                                  "FrameWidth",
                                  "FrameHeight"
                                ]
                              },
                              Pid: {
                                locationName: "pid",
                                type: "integer"
                              },
                              SampleRate: {
                                locationName: "sampleRate",
                                type: "integer"
                              },
                              SampleSize: {
                                locationName: "sampleSize",
                                type: "integer"
                              },
                              StreamType: {
                                locationName: "streamType"
                              }
                            },
                            required: [
                              "StreamType",
                              "Pid"
                            ]
                          }
                        }
                      },
                      required: [
                        "ProgramPid",
                        "PcrPid",
                        "ProgramNumber",
                        "Streams"
                      ]
                    }
                  }
                },
                required: [
                  "Programs"
                ]
              }
            }
          }
        },
        DescribeGateway: {
          http: {
            method: "GET",
            requestUri: "/v1/gateways/{gatewayArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              GatewayArn: {
                location: "uri",
                locationName: "gatewayArn"
              }
            },
            required: [
              "GatewayArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Gateway: {
                shape: "S3b",
                locationName: "gateway"
              }
            }
          }
        },
        DescribeGatewayInstance: {
          http: {
            method: "GET",
            requestUri: "/v1/gateway-instances/{gatewayInstanceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              GatewayInstanceArn: {
                location: "uri",
                locationName: "gatewayInstanceArn"
              }
            },
            required: [
              "GatewayInstanceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              GatewayInstance: {
                locationName: "gatewayInstance",
                type: "structure",
                members: {
                  BridgePlacement: {
                    locationName: "bridgePlacement"
                  },
                  ConnectionStatus: {
                    locationName: "connectionStatus"
                  },
                  GatewayArn: {
                    locationName: "gatewayArn"
                  },
                  GatewayInstanceArn: {
                    locationName: "gatewayInstanceArn"
                  },
                  InstanceId: {
                    locationName: "instanceId"
                  },
                  InstanceMessages: {
                    shape: "S2q",
                    locationName: "instanceMessages"
                  },
                  InstanceState: {
                    locationName: "instanceState"
                  },
                  RunningBridgeCount: {
                    locationName: "runningBridgeCount",
                    type: "integer"
                  }
                },
                required: [
                  "GatewayArn",
                  "InstanceState",
                  "GatewayInstanceArn",
                  "InstanceId",
                  "RunningBridgeCount",
                  "BridgePlacement",
                  "ConnectionStatus"
                ]
              }
            }
          }
        },
        DescribeOffering: {
          http: {
            method: "GET",
            requestUri: "/v1/offerings/{offeringArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              OfferingArn: {
                location: "uri",
                locationName: "offeringArn"
              }
            },
            required: [
              "OfferingArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Offering: {
                shape: "S4a",
                locationName: "offering"
              }
            }
          }
        },
        DescribeReservation: {
          http: {
            method: "GET",
            requestUri: "/v1/reservations/{reservationArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ReservationArn: {
                location: "uri",
                locationName: "reservationArn"
              }
            },
            required: [
              "ReservationArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Reservation: {
                shape: "S4h",
                locationName: "reservation"
              }
            }
          }
        },
        GrantFlowEntitlements: {
          http: {
            requestUri: "/v1/flows/{flowArn}/entitlements",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Entitlements: {
                shape: "S2w",
                locationName: "entitlements"
              },
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              }
            },
            required: [
              "FlowArn",
              "Entitlements"
            ]
          },
          output: {
            type: "structure",
            members: {
              Entitlements: {
                shape: "S33",
                locationName: "entitlements"
              },
              FlowArn: {
                locationName: "flowArn"
              }
            }
          }
        },
        ListBridges: {
          http: {
            method: "GET",
            requestUri: "/v1/bridges",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              FilterArn: {
                location: "querystring",
                locationName: "filterArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Bridges: {
                locationName: "bridges",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    BridgeArn: {
                      locationName: "bridgeArn"
                    },
                    BridgeState: {
                      locationName: "bridgeState"
                    },
                    BridgeType: {
                      locationName: "bridgeType"
                    },
                    Name: {
                      locationName: "name"
                    },
                    PlacementArn: {
                      locationName: "placementArn"
                    }
                  },
                  required: [
                    "BridgeArn",
                    "BridgeState",
                    "PlacementArn",
                    "BridgeType",
                    "Name"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListEntitlements: {
          http: {
            method: "GET",
            requestUri: "/v1/entitlements",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Entitlements: {
                locationName: "entitlements",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DataTransferSubscriberFeePercent: {
                      locationName: "dataTransferSubscriberFeePercent",
                      type: "integer"
                    },
                    EntitlementArn: {
                      locationName: "entitlementArn"
                    },
                    EntitlementName: {
                      locationName: "entitlementName"
                    }
                  },
                  required: [
                    "EntitlementArn",
                    "EntitlementName"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListFlows: {
          http: {
            method: "GET",
            requestUri: "/v1/flows",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Flows: {
                locationName: "flows",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AvailabilityZone: {
                      locationName: "availabilityZone"
                    },
                    Description: {
                      locationName: "description"
                    },
                    FlowArn: {
                      locationName: "flowArn"
                    },
                    Name: {
                      locationName: "name"
                    },
                    SourceType: {
                      locationName: "sourceType"
                    },
                    Status: {
                      locationName: "status"
                    },
                    Maintenance: {
                      shape: "S36",
                      locationName: "maintenance"
                    }
                  },
                  required: [
                    "Status",
                    "Description",
                    "SourceType",
                    "AvailabilityZone",
                    "FlowArn",
                    "Name"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListGatewayInstances: {
          http: {
            method: "GET",
            requestUri: "/v1/gateway-instances",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              FilterArn: {
                location: "querystring",
                locationName: "filterArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Instances: {
                locationName: "instances",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    GatewayArn: {
                      locationName: "gatewayArn"
                    },
                    GatewayInstanceArn: {
                      locationName: "gatewayInstanceArn"
                    },
                    InstanceId: {
                      locationName: "instanceId"
                    },
                    InstanceState: {
                      locationName: "instanceState"
                    }
                  },
                  required: [
                    "GatewayArn",
                    "GatewayInstanceArn",
                    "InstanceId"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListGateways: {
          http: {
            method: "GET",
            requestUri: "/v1/gateways",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Gateways: {
                locationName: "gateways",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    GatewayArn: {
                      locationName: "gatewayArn"
                    },
                    GatewayState: {
                      locationName: "gatewayState"
                    },
                    Name: {
                      locationName: "name"
                    }
                  },
                  required: [
                    "GatewayArn",
                    "GatewayState",
                    "Name"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListOfferings: {
          http: {
            method: "GET",
            requestUri: "/v1/offerings",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Offerings: {
                locationName: "offerings",
                type: "list",
                member: {
                  shape: "S4a"
                }
              }
            }
          }
        },
        ListReservations: {
          http: {
            method: "GET",
            requestUri: "/v1/reservations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Reservations: {
                locationName: "reservations",
                type: "list",
                member: {
                  shape: "S4h"
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            },
            required: [
              "ResourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S5f",
                locationName: "tags"
              }
            }
          }
        },
        PurchaseOffering: {
          http: {
            requestUri: "/v1/offerings/{offeringArn}",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              OfferingArn: {
                location: "uri",
                locationName: "offeringArn"
              },
              ReservationName: {
                locationName: "reservationName"
              },
              Start: {
                locationName: "start"
              }
            },
            required: [
              "OfferingArn",
              "Start",
              "ReservationName"
            ]
          },
          output: {
            type: "structure",
            members: {
              Reservation: {
                shape: "S4h",
                locationName: "reservation"
              }
            }
          }
        },
        RemoveBridgeOutput: {
          http: {
            method: "DELETE",
            requestUri: "/v1/bridges/{bridgeArn}/outputs/{outputName}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              BridgeArn: {
                location: "uri",
                locationName: "bridgeArn"
              },
              OutputName: {
                location: "uri",
                locationName: "outputName"
              }
            },
            required: [
              "OutputName",
              "BridgeArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              BridgeArn: {
                locationName: "bridgeArn"
              },
              OutputName: {
                locationName: "outputName"
              }
            }
          }
        },
        RemoveBridgeSource: {
          http: {
            method: "DELETE",
            requestUri: "/v1/bridges/{bridgeArn}/sources/{sourceName}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              BridgeArn: {
                location: "uri",
                locationName: "bridgeArn"
              },
              SourceName: {
                location: "uri",
                locationName: "sourceName"
              }
            },
            required: [
              "BridgeArn",
              "SourceName"
            ]
          },
          output: {
            type: "structure",
            members: {
              BridgeArn: {
                locationName: "bridgeArn"
              },
              SourceName: {
                locationName: "sourceName"
              }
            }
          }
        },
        RemoveFlowMediaStream: {
          http: {
            method: "DELETE",
            requestUri: "/v1/flows/{flowArn}/mediaStreams/{mediaStreamName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              },
              MediaStreamName: {
                location: "uri",
                locationName: "mediaStreamName"
              }
            },
            required: [
              "FlowArn",
              "MediaStreamName"
            ]
          },
          output: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              },
              MediaStreamName: {
                locationName: "mediaStreamName"
              }
            }
          }
        },
        RemoveFlowOutput: {
          http: {
            method: "DELETE",
            requestUri: "/v1/flows/{flowArn}/outputs/{outputArn}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              },
              OutputArn: {
                location: "uri",
                locationName: "outputArn"
              }
            },
            required: [
              "FlowArn",
              "OutputArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              },
              OutputArn: {
                locationName: "outputArn"
              }
            }
          }
        },
        RemoveFlowSource: {
          http: {
            method: "DELETE",
            requestUri: "/v1/flows/{flowArn}/source/{sourceArn}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              },
              SourceArn: {
                location: "uri",
                locationName: "sourceArn"
              }
            },
            required: [
              "FlowArn",
              "SourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              },
              SourceArn: {
                locationName: "sourceArn"
              }
            }
          }
        },
        RemoveFlowVpcInterface: {
          http: {
            method: "DELETE",
            requestUri: "/v1/flows/{flowArn}/vpcInterfaces/{vpcInterfaceName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              },
              VpcInterfaceName: {
                location: "uri",
                locationName: "vpcInterfaceName"
              }
            },
            required: [
              "FlowArn",
              "VpcInterfaceName"
            ]
          },
          output: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              },
              NonDeletedNetworkInterfaceIds: {
                shape: "S16",
                locationName: "nonDeletedNetworkInterfaceIds"
              },
              VpcInterfaceName: {
                locationName: "vpcInterfaceName"
              }
            }
          }
        },
        RevokeFlowEntitlement: {
          http: {
            method: "DELETE",
            requestUri: "/v1/flows/{flowArn}/entitlements/{entitlementArn}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              EntitlementArn: {
                location: "uri",
                locationName: "entitlementArn"
              },
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              }
            },
            required: [
              "FlowArn",
              "EntitlementArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              EntitlementArn: {
                locationName: "entitlementArn"
              },
              FlowArn: {
                locationName: "flowArn"
              }
            }
          }
        },
        StartFlow: {
          http: {
            requestUri: "/v1/flows/start/{flowArn}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              }
            },
            required: [
              "FlowArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        StopFlow: {
          http: {
            requestUri: "/v1/flows/stop/{flowArn}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              }
            },
            required: [
              "FlowArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              Tags: {
                shape: "S5f",
                locationName: "tags"
              }
            },
            required: [
              "ResourceArn",
              "Tags"
            ]
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              TagKeys: {
                shape: "S16",
                location: "querystring",
                locationName: "tagKeys"
              }
            },
            required: [
              "TagKeys",
              "ResourceArn"
            ]
          }
        },
        UpdateBridge: {
          http: {
            method: "PUT",
            requestUri: "/v1/bridges/{bridgeArn}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              BridgeArn: {
                location: "uri",
                locationName: "bridgeArn"
              },
              EgressGatewayBridge: {
                locationName: "egressGatewayBridge",
                type: "structure",
                members: {
                  MaxBitrate: {
                    locationName: "maxBitrate",
                    type: "integer"
                  }
                }
              },
              IngressGatewayBridge: {
                locationName: "ingressGatewayBridge",
                type: "structure",
                members: {
                  MaxBitrate: {
                    locationName: "maxBitrate",
                    type: "integer"
                  },
                  MaxOutputs: {
                    locationName: "maxOutputs",
                    type: "integer"
                  }
                }
              },
              SourceFailoverConfig: {
                shape: "S65",
                locationName: "sourceFailoverConfig"
              }
            },
            required: [
              "BridgeArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Bridge: {
                shape: "S2p",
                locationName: "bridge"
              }
            }
          }
        },
        UpdateBridgeOutput: {
          http: {
            method: "PUT",
            requestUri: "/v1/bridges/{bridgeArn}/outputs/{outputName}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              BridgeArn: {
                location: "uri",
                locationName: "bridgeArn"
              },
              NetworkOutput: {
                locationName: "networkOutput",
                type: "structure",
                members: {
                  IpAddress: {
                    locationName: "ipAddress"
                  },
                  NetworkName: {
                    locationName: "networkName"
                  },
                  Port: {
                    locationName: "port",
                    type: "integer"
                  },
                  Protocol: {
                    locationName: "protocol"
                  },
                  Ttl: {
                    locationName: "ttl",
                    type: "integer"
                  }
                }
              },
              OutputName: {
                location: "uri",
                locationName: "outputName"
              }
            },
            required: [
              "OutputName",
              "BridgeArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              BridgeArn: {
                locationName: "bridgeArn"
              },
              Output: {
                shape: "Sa",
                locationName: "output"
              }
            }
          }
        },
        UpdateBridgeSource: {
          http: {
            method: "PUT",
            requestUri: "/v1/bridges/{bridgeArn}/sources/{sourceName}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              BridgeArn: {
                location: "uri",
                locationName: "bridgeArn"
              },
              FlowSource: {
                locationName: "flowSource",
                type: "structure",
                members: {
                  FlowArn: {
                    locationName: "flowArn"
                  },
                  FlowVpcInterfaceAttachment: {
                    shape: "Sh",
                    locationName: "flowVpcInterfaceAttachment"
                  }
                }
              },
              NetworkSource: {
                locationName: "networkSource",
                type: "structure",
                members: {
                  MulticastIp: {
                    locationName: "multicastIp"
                  },
                  NetworkName: {
                    locationName: "networkName"
                  },
                  Port: {
                    locationName: "port",
                    type: "integer"
                  },
                  Protocol: {
                    locationName: "protocol"
                  }
                }
              },
              SourceName: {
                location: "uri",
                locationName: "sourceName"
              }
            },
            required: [
              "BridgeArn",
              "SourceName"
            ]
          },
          output: {
            type: "structure",
            members: {
              BridgeArn: {
                locationName: "bridgeArn"
              },
              Source: {
                shape: "Sl",
                locationName: "source"
              }
            }
          }
        },
        UpdateBridgeState: {
          http: {
            method: "PUT",
            requestUri: "/v1/bridges/{bridgeArn}/state",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              BridgeArn: {
                location: "uri",
                locationName: "bridgeArn"
              },
              DesiredState: {
                locationName: "desiredState"
              }
            },
            required: [
              "BridgeArn",
              "DesiredState"
            ]
          },
          output: {
            type: "structure",
            members: {
              BridgeArn: {
                locationName: "bridgeArn"
              },
              DesiredState: {
                locationName: "desiredState"
              }
            }
          }
        },
        UpdateFlow: {
          http: {
            method: "PUT",
            requestUri: "/v1/flows/{flowArn}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              },
              SourceFailoverConfig: {
                shape: "S65",
                locationName: "sourceFailoverConfig"
              },
              Maintenance: {
                locationName: "maintenance",
                type: "structure",
                members: {
                  MaintenanceDay: {
                    locationName: "maintenanceDay"
                  },
                  MaintenanceScheduledDate: {
                    locationName: "maintenanceScheduledDate"
                  },
                  MaintenanceStartHour: {
                    locationName: "maintenanceStartHour"
                  }
                }
              }
            },
            required: [
              "FlowArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Flow: {
                shape: "S32",
                locationName: "flow"
              }
            }
          }
        },
        UpdateFlowEntitlement: {
          http: {
            method: "PUT",
            requestUri: "/v1/flows/{flowArn}/entitlements/{entitlementArn}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              Description: {
                locationName: "description"
              },
              Encryption: {
                shape: "S6l",
                locationName: "encryption"
              },
              EntitlementArn: {
                location: "uri",
                locationName: "entitlementArn"
              },
              EntitlementStatus: {
                locationName: "entitlementStatus"
              },
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              },
              Subscribers: {
                shape: "S16",
                locationName: "subscribers"
              }
            },
            required: [
              "FlowArn",
              "EntitlementArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Entitlement: {
                shape: "S34",
                locationName: "entitlement"
              },
              FlowArn: {
                locationName: "flowArn"
              }
            }
          }
        },
        UpdateFlowMediaStream: {
          http: {
            method: "PUT",
            requestUri: "/v1/flows/{flowArn}/mediaStreams/{mediaStreamName}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              Attributes: {
                shape: "Sr",
                locationName: "attributes"
              },
              ClockRate: {
                locationName: "clockRate",
                type: "integer"
              },
              Description: {
                locationName: "description"
              },
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              },
              MediaStreamName: {
                location: "uri",
                locationName: "mediaStreamName"
              },
              MediaStreamType: {
                locationName: "mediaStreamType"
              },
              VideoFormat: {
                locationName: "videoFormat"
              }
            },
            required: [
              "FlowArn",
              "MediaStreamName"
            ]
          },
          output: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              },
              MediaStream: {
                shape: "S10",
                locationName: "mediaStream"
              }
            }
          }
        },
        UpdateFlowOutput: {
          http: {
            method: "PUT",
            requestUri: "/v1/flows/{flowArn}/outputs/{outputArn}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              CidrAllowList: {
                shape: "S16",
                locationName: "cidrAllowList"
              },
              Description: {
                locationName: "description"
              },
              Destination: {
                locationName: "destination"
              },
              Encryption: {
                shape: "S6l",
                locationName: "encryption"
              },
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              },
              MaxLatency: {
                locationName: "maxLatency",
                type: "integer"
              },
              MediaStreamOutputConfigurations: {
                shape: "S1a",
                locationName: "mediaStreamOutputConfigurations"
              },
              MinLatency: {
                locationName: "minLatency",
                type: "integer"
              },
              OutputArn: {
                location: "uri",
                locationName: "outputArn"
              },
              Port: {
                locationName: "port",
                type: "integer"
              },
              Protocol: {
                locationName: "protocol"
              },
              RemoteId: {
                locationName: "remoteId"
              },
              SenderControlPort: {
                locationName: "senderControlPort",
                type: "integer"
              },
              SenderIpAddress: {
                locationName: "senderIpAddress"
              },
              SmoothingLatency: {
                locationName: "smoothingLatency",
                type: "integer"
              },
              StreamId: {
                locationName: "streamId"
              },
              VpcInterfaceAttachment: {
                shape: "Sh",
                locationName: "vpcInterfaceAttachment"
              }
            },
            required: [
              "FlowArn",
              "OutputArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              },
              Output: {
                shape: "S1l",
                locationName: "output"
              }
            }
          }
        },
        UpdateFlowSource: {
          http: {
            method: "PUT",
            requestUri: "/v1/flows/{flowArn}/source/{sourceArn}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              Decryption: {
                shape: "S6l",
                locationName: "decryption"
              },
              Description: {
                locationName: "description"
              },
              EntitlementArn: {
                locationName: "entitlementArn"
              },
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              },
              IngestPort: {
                locationName: "ingestPort",
                type: "integer"
              },
              MaxBitrate: {
                locationName: "maxBitrate",
                type: "integer"
              },
              MaxLatency: {
                locationName: "maxLatency",
                type: "integer"
              },
              MaxSyncBuffer: {
                locationName: "maxSyncBuffer",
                type: "integer"
              },
              MediaStreamSourceConfigurations: {
                shape: "S1x",
                locationName: "mediaStreamSourceConfigurations"
              },
              MinLatency: {
                locationName: "minLatency",
                type: "integer"
              },
              Protocol: {
                locationName: "protocol"
              },
              SenderControlPort: {
                locationName: "senderControlPort",
                type: "integer"
              },
              SenderIpAddress: {
                locationName: "senderIpAddress"
              },
              SourceArn: {
                location: "uri",
                locationName: "sourceArn"
              },
              SourceListenerAddress: {
                locationName: "sourceListenerAddress"
              },
              SourceListenerPort: {
                locationName: "sourceListenerPort",
                type: "integer"
              },
              StreamId: {
                locationName: "streamId"
              },
              VpcInterfaceName: {
                locationName: "vpcInterfaceName"
              },
              WhitelistCidr: {
                locationName: "whitelistCidr"
              },
              GatewayBridgeSource: {
                locationName: "gatewayBridgeSource",
                type: "structure",
                members: {
                  BridgeArn: {
                    locationName: "bridgeArn"
                  },
                  VpcInterfaceAttachment: {
                    shape: "Sh",
                    locationName: "vpcInterfaceAttachment"
                  }
                }
              }
            },
            required: [
              "FlowArn",
              "SourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              },
              Source: {
                shape: "S24",
                locationName: "source"
              }
            }
          }
        },
        UpdateGatewayInstance: {
          http: {
            method: "PUT",
            requestUri: "/v1/gateway-instances/{gatewayInstanceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BridgePlacement: {
                locationName: "bridgePlacement"
              },
              GatewayInstanceArn: {
                location: "uri",
                locationName: "gatewayInstanceArn"
              }
            },
            required: [
              "GatewayInstanceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              BridgePlacement: {
                locationName: "bridgePlacement"
              },
              GatewayInstanceArn: {
                locationName: "gatewayInstanceArn"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {
            type: "structure",
            members: {
              NetworkOutput: {
                locationName: "networkOutput",
                type: "structure",
                members: {
                  IpAddress: {
                    locationName: "ipAddress"
                  },
                  Name: {
                    locationName: "name"
                  },
                  NetworkName: {
                    locationName: "networkName"
                  },
                  Port: {
                    locationName: "port",
                    type: "integer"
                  },
                  Protocol: {
                    locationName: "protocol"
                  },
                  Ttl: {
                    locationName: "ttl",
                    type: "integer"
                  }
                },
                required: [
                  "NetworkName",
                  "Port",
                  "IpAddress",
                  "Protocol",
                  "Ttl",
                  "Name"
                ]
              }
            }
          }
        },
        S9: {
          type: "list",
          member: {
            shape: "Sa"
          }
        },
        Sa: {
          type: "structure",
          members: {
            FlowOutput: {
              locationName: "flowOutput",
              type: "structure",
              members: {
                FlowArn: {
                  locationName: "flowArn"
                },
                FlowSourceArn: {
                  locationName: "flowSourceArn"
                },
                Name: {
                  locationName: "name"
                }
              },
              required: [
                "FlowSourceArn",
                "FlowArn",
                "Name"
              ]
            },
            NetworkOutput: {
              locationName: "networkOutput",
              type: "structure",
              members: {
                IpAddress: {
                  locationName: "ipAddress"
                },
                Name: {
                  locationName: "name"
                },
                NetworkName: {
                  locationName: "networkName"
                },
                Port: {
                  locationName: "port",
                  type: "integer"
                },
                Protocol: {
                  locationName: "protocol"
                },
                Ttl: {
                  locationName: "ttl",
                  type: "integer"
                }
              },
              required: [
                "NetworkName",
                "Port",
                "IpAddress",
                "Protocol",
                "Ttl",
                "Name"
              ]
            }
          }
        },
        Se: {
          type: "list",
          member: {
            type: "structure",
            members: {
              FlowSource: {
                locationName: "flowSource",
                type: "structure",
                members: {
                  FlowArn: {
                    locationName: "flowArn"
                  },
                  FlowVpcInterfaceAttachment: {
                    shape: "Sh",
                    locationName: "flowVpcInterfaceAttachment"
                  },
                  Name: {
                    locationName: "name"
                  }
                },
                required: [
                  "FlowArn",
                  "Name"
                ]
              },
              NetworkSource: {
                locationName: "networkSource",
                type: "structure",
                members: {
                  MulticastIp: {
                    locationName: "multicastIp"
                  },
                  Name: {
                    locationName: "name"
                  },
                  NetworkName: {
                    locationName: "networkName"
                  },
                  Port: {
                    locationName: "port",
                    type: "integer"
                  },
                  Protocol: {
                    locationName: "protocol"
                  }
                },
                required: [
                  "NetworkName",
                  "MulticastIp",
                  "Port",
                  "Protocol",
                  "Name"
                ]
              }
            }
          }
        },
        Sh: {
          type: "structure",
          members: {
            VpcInterfaceName: {
              locationName: "vpcInterfaceName"
            }
          }
        },
        Sk: {
          type: "list",
          member: {
            shape: "Sl"
          }
        },
        Sl: {
          type: "structure",
          members: {
            FlowSource: {
              locationName: "flowSource",
              type: "structure",
              members: {
                FlowArn: {
                  locationName: "flowArn"
                },
                FlowVpcInterfaceAttachment: {
                  shape: "Sh",
                  locationName: "flowVpcInterfaceAttachment"
                },
                Name: {
                  locationName: "name"
                },
                OutputArn: {
                  locationName: "outputArn"
                }
              },
              required: [
                "FlowArn",
                "Name"
              ]
            },
            NetworkSource: {
              locationName: "networkSource",
              type: "structure",
              members: {
                MulticastIp: {
                  locationName: "multicastIp"
                },
                Name: {
                  locationName: "name"
                },
                NetworkName: {
                  locationName: "networkName"
                },
                Port: {
                  locationName: "port",
                  type: "integer"
                },
                Protocol: {
                  locationName: "protocol"
                }
              },
              required: [
                "NetworkName",
                "MulticastIp",
                "Port",
                "Protocol",
                "Name"
              ]
            }
          }
        },
        Sp: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Attributes: {
                shape: "Sr",
                locationName: "attributes"
              },
              ClockRate: {
                locationName: "clockRate",
                type: "integer"
              },
              Description: {
                locationName: "description"
              },
              MediaStreamId: {
                locationName: "mediaStreamId",
                type: "integer"
              },
              MediaStreamName: {
                locationName: "mediaStreamName"
              },
              MediaStreamType: {
                locationName: "mediaStreamType"
              },
              VideoFormat: {
                locationName: "videoFormat"
              }
            },
            required: [
              "MediaStreamType",
              "MediaStreamId",
              "MediaStreamName"
            ]
          }
        },
        Sr: {
          type: "structure",
          members: {
            Fmtp: {
              locationName: "fmtp",
              type: "structure",
              members: {
                ChannelOrder: {
                  locationName: "channelOrder"
                },
                Colorimetry: {
                  locationName: "colorimetry"
                },
                ExactFramerate: {
                  locationName: "exactFramerate"
                },
                Par: {
                  locationName: "par"
                },
                Range: {
                  locationName: "range"
                },
                ScanMode: {
                  locationName: "scanMode"
                },
                Tcs: {
                  locationName: "tcs"
                }
              }
            },
            Lang: {
              locationName: "lang"
            }
          }
        },
        Sz: {
          type: "list",
          member: {
            shape: "S10"
          }
        },
        S10: {
          type: "structure",
          members: {
            Attributes: {
              locationName: "attributes",
              type: "structure",
              members: {
                Fmtp: {
                  locationName: "fmtp",
                  type: "structure",
                  members: {
                    ChannelOrder: {
                      locationName: "channelOrder"
                    },
                    Colorimetry: {
                      locationName: "colorimetry"
                    },
                    ExactFramerate: {
                      locationName: "exactFramerate"
                    },
                    Par: {
                      locationName: "par"
                    },
                    Range: {
                      locationName: "range"
                    },
                    ScanMode: {
                      locationName: "scanMode"
                    },
                    Tcs: {
                      locationName: "tcs"
                    }
                  }
                },
                Lang: {
                  locationName: "lang"
                }
              },
              required: [
                "Fmtp"
              ]
            },
            ClockRate: {
              locationName: "clockRate",
              type: "integer"
            },
            Description: {
              locationName: "description"
            },
            Fmt: {
              locationName: "fmt",
              type: "integer"
            },
            MediaStreamId: {
              locationName: "mediaStreamId",
              type: "integer"
            },
            MediaStreamName: {
              locationName: "mediaStreamName"
            },
            MediaStreamType: {
              locationName: "mediaStreamType"
            },
            VideoFormat: {
              locationName: "videoFormat"
            }
          },
          required: [
            "MediaStreamType",
            "MediaStreamId",
            "MediaStreamName",
            "Fmt"
          ]
        },
        S14: {
          type: "list",
          member: {
            type: "structure",
            members: {
              CidrAllowList: {
                shape: "S16",
                locationName: "cidrAllowList"
              },
              Description: {
                locationName: "description"
              },
              Destination: {
                locationName: "destination"
              },
              Encryption: {
                shape: "S17",
                locationName: "encryption"
              },
              MaxLatency: {
                locationName: "maxLatency",
                type: "integer"
              },
              MediaStreamOutputConfigurations: {
                shape: "S1a",
                locationName: "mediaStreamOutputConfigurations"
              },
              MinLatency: {
                locationName: "minLatency",
                type: "integer"
              },
              Name: {
                locationName: "name"
              },
              Port: {
                locationName: "port",
                type: "integer"
              },
              Protocol: {
                locationName: "protocol"
              },
              RemoteId: {
                locationName: "remoteId"
              },
              SenderControlPort: {
                locationName: "senderControlPort",
                type: "integer"
              },
              SmoothingLatency: {
                locationName: "smoothingLatency",
                type: "integer"
              },
              StreamId: {
                locationName: "streamId"
              },
              VpcInterfaceAttachment: {
                shape: "Sh",
                locationName: "vpcInterfaceAttachment"
              }
            },
            required: [
              "Protocol"
            ]
          }
        },
        S16: {
          type: "list",
          member: {}
        },
        S17: {
          type: "structure",
          members: {
            Algorithm: {
              locationName: "algorithm"
            },
            ConstantInitializationVector: {
              locationName: "constantInitializationVector"
            },
            DeviceId: {
              locationName: "deviceId"
            },
            KeyType: {
              locationName: "keyType"
            },
            Region: {
              locationName: "region"
            },
            ResourceId: {
              locationName: "resourceId"
            },
            RoleArn: {
              locationName: "roleArn"
            },
            SecretArn: {
              locationName: "secretArn"
            },
            Url: {
              locationName: "url"
            }
          },
          required: [
            "RoleArn"
          ]
        },
        S1a: {
          type: "list",
          member: {
            type: "structure",
            members: {
              DestinationConfigurations: {
                locationName: "destinationConfigurations",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DestinationIp: {
                      locationName: "destinationIp"
                    },
                    DestinationPort: {
                      locationName: "destinationPort",
                      type: "integer"
                    },
                    Interface: {
                      shape: "S1e",
                      locationName: "interface"
                    }
                  },
                  required: [
                    "DestinationIp",
                    "DestinationPort",
                    "Interface"
                  ]
                }
              },
              EncodingName: {
                locationName: "encodingName"
              },
              EncodingParameters: {
                locationName: "encodingParameters",
                type: "structure",
                members: {
                  CompressionFactor: {
                    locationName: "compressionFactor",
                    type: "double"
                  },
                  EncoderProfile: {
                    locationName: "encoderProfile"
                  }
                },
                required: [
                  "EncoderProfile",
                  "CompressionFactor"
                ]
              },
              MediaStreamName: {
                locationName: "mediaStreamName"
              }
            },
            required: [
              "MediaStreamName",
              "EncodingName"
            ]
          }
        },
        S1e: {
          type: "structure",
          members: {
            Name: {
              locationName: "name"
            }
          },
          required: [
            "Name"
          ]
        },
        S1k: {
          type: "list",
          member: {
            shape: "S1l"
          }
        },
        S1l: {
          type: "structure",
          members: {
            DataTransferSubscriberFeePercent: {
              locationName: "dataTransferSubscriberFeePercent",
              type: "integer"
            },
            Description: {
              locationName: "description"
            },
            Destination: {
              locationName: "destination"
            },
            Encryption: {
              shape: "S17",
              locationName: "encryption"
            },
            EntitlementArn: {
              locationName: "entitlementArn"
            },
            ListenerAddress: {
              locationName: "listenerAddress"
            },
            MediaLiveInputArn: {
              locationName: "mediaLiveInputArn"
            },
            MediaStreamOutputConfigurations: {
              locationName: "mediaStreamOutputConfigurations",
              type: "list",
              member: {
                type: "structure",
                members: {
                  DestinationConfigurations: {
                    locationName: "destinationConfigurations",
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        DestinationIp: {
                          locationName: "destinationIp"
                        },
                        DestinationPort: {
                          locationName: "destinationPort",
                          type: "integer"
                        },
                        Interface: {
                          shape: "S1q",
                          locationName: "interface"
                        },
                        OutboundIp: {
                          locationName: "outboundIp"
                        }
                      },
                      required: [
                        "DestinationIp",
                        "DestinationPort",
                        "Interface",
                        "OutboundIp"
                      ]
                    }
                  },
                  EncodingName: {
                    locationName: "encodingName"
                  },
                  EncodingParameters: {
                    locationName: "encodingParameters",
                    type: "structure",
                    members: {
                      CompressionFactor: {
                        locationName: "compressionFactor",
                        type: "double"
                      },
                      EncoderProfile: {
                        locationName: "encoderProfile"
                      }
                    },
                    required: [
                      "EncoderProfile",
                      "CompressionFactor"
                    ]
                  },
                  MediaStreamName: {
                    locationName: "mediaStreamName"
                  }
                },
                required: [
                  "MediaStreamName",
                  "EncodingName"
                ]
              }
            },
            Name: {
              locationName: "name"
            },
            OutputArn: {
              locationName: "outputArn"
            },
            Port: {
              locationName: "port",
              type: "integer"
            },
            Transport: {
              shape: "S1s",
              locationName: "transport"
            },
            VpcInterfaceAttachment: {
              shape: "Sh",
              locationName: "vpcInterfaceAttachment"
            },
            BridgeArn: {
              locationName: "bridgeArn"
            },
            BridgePorts: {
              locationName: "bridgePorts",
              type: "list",
              member: {
                type: "integer"
              }
            }
          },
          required: [
            "OutputArn",
            "Name"
          ]
        },
        S1q: {
          type: "structure",
          members: {
            Name: {
              locationName: "name"
            }
          },
          required: [
            "Name"
          ]
        },
        S1s: {
          type: "structure",
          members: {
            CidrAllowList: {
              shape: "S16",
              locationName: "cidrAllowList"
            },
            MaxBitrate: {
              locationName: "maxBitrate",
              type: "integer"
            },
            MaxLatency: {
              locationName: "maxLatency",
              type: "integer"
            },
            MaxSyncBuffer: {
              locationName: "maxSyncBuffer",
              type: "integer"
            },
            MinLatency: {
              locationName: "minLatency",
              type: "integer"
            },
            Protocol: {
              locationName: "protocol"
            },
            RemoteId: {
              locationName: "remoteId"
            },
            SenderControlPort: {
              locationName: "senderControlPort",
              type: "integer"
            },
            SenderIpAddress: {
              locationName: "senderIpAddress"
            },
            SmoothingLatency: {
              locationName: "smoothingLatency",
              type: "integer"
            },
            SourceListenerAddress: {
              locationName: "sourceListenerAddress"
            },
            SourceListenerPort: {
              locationName: "sourceListenerPort",
              type: "integer"
            },
            StreamId: {
              locationName: "streamId"
            }
          },
          required: [
            "Protocol"
          ]
        },
        S1v: {
          type: "list",
          member: {
            shape: "S1w"
          }
        },
        S1w: {
          type: "structure",
          members: {
            Decryption: {
              shape: "S17",
              locationName: "decryption"
            },
            Description: {
              locationName: "description"
            },
            EntitlementArn: {
              locationName: "entitlementArn"
            },
            IngestPort: {
              locationName: "ingestPort",
              type: "integer"
            },
            MaxBitrate: {
              locationName: "maxBitrate",
              type: "integer"
            },
            MaxLatency: {
              locationName: "maxLatency",
              type: "integer"
            },
            MaxSyncBuffer: {
              locationName: "maxSyncBuffer",
              type: "integer"
            },
            MediaStreamSourceConfigurations: {
              shape: "S1x",
              locationName: "mediaStreamSourceConfigurations"
            },
            MinLatency: {
              locationName: "minLatency",
              type: "integer"
            },
            Name: {
              locationName: "name"
            },
            Protocol: {
              locationName: "protocol"
            },
            SenderControlPort: {
              locationName: "senderControlPort",
              type: "integer"
            },
            SenderIpAddress: {
              locationName: "senderIpAddress"
            },
            SourceListenerAddress: {
              locationName: "sourceListenerAddress"
            },
            SourceListenerPort: {
              locationName: "sourceListenerPort",
              type: "integer"
            },
            StreamId: {
              locationName: "streamId"
            },
            VpcInterfaceName: {
              locationName: "vpcInterfaceName"
            },
            WhitelistCidr: {
              locationName: "whitelistCidr"
            },
            GatewayBridgeSource: {
              locationName: "gatewayBridgeSource",
              type: "structure",
              members: {
                BridgeArn: {
                  locationName: "bridgeArn"
                },
                VpcInterfaceAttachment: {
                  shape: "Sh",
                  locationName: "vpcInterfaceAttachment"
                }
              },
              required: [
                "BridgeArn"
              ]
            }
          }
        },
        S1x: {
          type: "list",
          member: {
            type: "structure",
            members: {
              EncodingName: {
                locationName: "encodingName"
              },
              InputConfigurations: {
                locationName: "inputConfigurations",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InputPort: {
                      locationName: "inputPort",
                      type: "integer"
                    },
                    Interface: {
                      shape: "S1e",
                      locationName: "interface"
                    }
                  },
                  required: [
                    "InputPort",
                    "Interface"
                  ]
                }
              },
              MediaStreamName: {
                locationName: "mediaStreamName"
              }
            },
            required: [
              "MediaStreamName",
              "EncodingName"
            ]
          }
        },
        S23: {
          type: "list",
          member: {
            shape: "S24"
          }
        },
        S24: {
          type: "structure",
          members: {
            DataTransferSubscriberFeePercent: {
              locationName: "dataTransferSubscriberFeePercent",
              type: "integer"
            },
            Decryption: {
              shape: "S17",
              locationName: "decryption"
            },
            Description: {
              locationName: "description"
            },
            EntitlementArn: {
              locationName: "entitlementArn"
            },
            IngestIp: {
              locationName: "ingestIp"
            },
            IngestPort: {
              locationName: "ingestPort",
              type: "integer"
            },
            MediaStreamSourceConfigurations: {
              locationName: "mediaStreamSourceConfigurations",
              type: "list",
              member: {
                type: "structure",
                members: {
                  EncodingName: {
                    locationName: "encodingName"
                  },
                  InputConfigurations: {
                    locationName: "inputConfigurations",
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        InputIp: {
                          locationName: "inputIp"
                        },
                        InputPort: {
                          locationName: "inputPort",
                          type: "integer"
                        },
                        Interface: {
                          shape: "S1q",
                          locationName: "interface"
                        }
                      },
                      required: [
                        "InputPort",
                        "InputIp",
                        "Interface"
                      ]
                    }
                  },
                  MediaStreamName: {
                    locationName: "mediaStreamName"
                  }
                },
                required: [
                  "MediaStreamName",
                  "EncodingName"
                ]
              }
            },
            Name: {
              locationName: "name"
            },
            SenderControlPort: {
              locationName: "senderControlPort",
              type: "integer"
            },
            SenderIpAddress: {
              locationName: "senderIpAddress"
            },
            SourceArn: {
              locationName: "sourceArn"
            },
            Transport: {
              shape: "S1s",
              locationName: "transport"
            },
            VpcInterfaceName: {
              locationName: "vpcInterfaceName"
            },
            WhitelistCidr: {
              locationName: "whitelistCidr"
            },
            GatewayBridgeSource: {
              locationName: "gatewayBridgeSource",
              type: "structure",
              members: {
                BridgeArn: {
                  locationName: "bridgeArn"
                },
                VpcInterfaceAttachment: {
                  shape: "Sh",
                  locationName: "vpcInterfaceAttachment"
                }
              },
              required: [
                "BridgeArn"
              ]
            }
          },
          required: [
            "Name",
            "SourceArn"
          ]
        },
        S2b: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {
                locationName: "name"
              },
              NetworkInterfaceType: {
                locationName: "networkInterfaceType"
              },
              RoleArn: {
                locationName: "roleArn"
              },
              SecurityGroupIds: {
                shape: "S16",
                locationName: "securityGroupIds"
              },
              SubnetId: {
                locationName: "subnetId"
              }
            },
            required: [
              "SubnetId",
              "SecurityGroupIds",
              "RoleArn",
              "Name"
            ]
          }
        },
        S2f: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {
                locationName: "name"
              },
              NetworkInterfaceIds: {
                shape: "S16",
                locationName: "networkInterfaceIds"
              },
              NetworkInterfaceType: {
                locationName: "networkInterfaceType"
              },
              RoleArn: {
                locationName: "roleArn"
              },
              SecurityGroupIds: {
                shape: "S16",
                locationName: "securityGroupIds"
              },
              SubnetId: {
                locationName: "subnetId"
              }
            },
            required: [
              "NetworkInterfaceType",
              "NetworkInterfaceIds",
              "SubnetId",
              "SecurityGroupIds",
              "RoleArn",
              "Name"
            ]
          }
        },
        S2k: {
          type: "structure",
          members: {
            FailoverMode: {
              locationName: "failoverMode"
            },
            RecoveryWindow: {
              locationName: "recoveryWindow",
              type: "integer"
            },
            SourcePriority: {
              shape: "S2m",
              locationName: "sourcePriority"
            },
            State: {
              locationName: "state"
            }
          }
        },
        S2m: {
          type: "structure",
          members: {
            PrimarySource: {
              locationName: "primarySource"
            }
          }
        },
        S2p: {
          type: "structure",
          members: {
            BridgeArn: {
              locationName: "bridgeArn"
            },
            BridgeMessages: {
              shape: "S2q",
              locationName: "bridgeMessages"
            },
            BridgeState: {
              locationName: "bridgeState"
            },
            EgressGatewayBridge: {
              locationName: "egressGatewayBridge",
              type: "structure",
              members: {
                InstanceId: {
                  locationName: "instanceId"
                },
                MaxBitrate: {
                  locationName: "maxBitrate",
                  type: "integer"
                }
              },
              required: [
                "MaxBitrate"
              ]
            },
            IngressGatewayBridge: {
              locationName: "ingressGatewayBridge",
              type: "structure",
              members: {
                InstanceId: {
                  locationName: "instanceId"
                },
                MaxBitrate: {
                  locationName: "maxBitrate",
                  type: "integer"
                },
                MaxOutputs: {
                  locationName: "maxOutputs",
                  type: "integer"
                }
              },
              required: [
                "MaxOutputs",
                "MaxBitrate"
              ]
            },
            Name: {
              locationName: "name"
            },
            Outputs: {
              shape: "S9",
              locationName: "outputs"
            },
            PlacementArn: {
              locationName: "placementArn"
            },
            SourceFailoverConfig: {
              shape: "S2k",
              locationName: "sourceFailoverConfig"
            },
            Sources: {
              shape: "Sk",
              locationName: "sources"
            }
          },
          required: [
            "BridgeArn",
            "BridgeState",
            "PlacementArn",
            "Name"
          ]
        },
        S2q: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Code: {
                locationName: "code"
              },
              Message: {
                locationName: "message"
              },
              ResourceName: {
                locationName: "resourceName"
              }
            },
            required: [
              "Message",
              "Code"
            ]
          }
        },
        S2w: {
          type: "list",
          member: {
            type: "structure",
            members: {
              DataTransferSubscriberFeePercent: {
                locationName: "dataTransferSubscriberFeePercent",
                type: "integer"
              },
              Description: {
                locationName: "description"
              },
              Encryption: {
                shape: "S17",
                locationName: "encryption"
              },
              EntitlementStatus: {
                locationName: "entitlementStatus"
              },
              Name: {
                locationName: "name"
              },
              Subscribers: {
                shape: "S16",
                locationName: "subscribers"
              }
            },
            required: [
              "Subscribers"
            ]
          }
        },
        S32: {
          type: "structure",
          members: {
            AvailabilityZone: {
              locationName: "availabilityZone"
            },
            Description: {
              locationName: "description"
            },
            EgressIp: {
              locationName: "egressIp"
            },
            Entitlements: {
              shape: "S33",
              locationName: "entitlements"
            },
            FlowArn: {
              locationName: "flowArn"
            },
            MediaStreams: {
              shape: "Sz",
              locationName: "mediaStreams"
            },
            Name: {
              locationName: "name"
            },
            Outputs: {
              shape: "S1k",
              locationName: "outputs"
            },
            Source: {
              shape: "S24",
              locationName: "source"
            },
            SourceFailoverConfig: {
              shape: "S2k",
              locationName: "sourceFailoverConfig"
            },
            Sources: {
              shape: "S23",
              locationName: "sources"
            },
            Status: {
              locationName: "status"
            },
            VpcInterfaces: {
              shape: "S2f",
              locationName: "vpcInterfaces"
            },
            Maintenance: {
              shape: "S36",
              locationName: "maintenance"
            }
          },
          required: [
            "Status",
            "AvailabilityZone",
            "Source",
            "Name",
            "Entitlements",
            "Outputs",
            "FlowArn"
          ]
        },
        S33: {
          type: "list",
          member: {
            shape: "S34"
          }
        },
        S34: {
          type: "structure",
          members: {
            DataTransferSubscriberFeePercent: {
              locationName: "dataTransferSubscriberFeePercent",
              type: "integer"
            },
            Description: {
              locationName: "description"
            },
            Encryption: {
              shape: "S17",
              locationName: "encryption"
            },
            EntitlementArn: {
              locationName: "entitlementArn"
            },
            EntitlementStatus: {
              locationName: "entitlementStatus"
            },
            Name: {
              locationName: "name"
            },
            Subscribers: {
              shape: "S16",
              locationName: "subscribers"
            }
          },
          required: [
            "EntitlementArn",
            "Subscribers",
            "Name"
          ]
        },
        S36: {
          type: "structure",
          members: {
            MaintenanceDay: {
              locationName: "maintenanceDay"
            },
            MaintenanceDeadline: {
              locationName: "maintenanceDeadline"
            },
            MaintenanceScheduledDate: {
              locationName: "maintenanceScheduledDate"
            },
            MaintenanceStartHour: {
              locationName: "maintenanceStartHour"
            }
          }
        },
        S38: {
          type: "list",
          member: {
            type: "structure",
            members: {
              CidrBlock: {
                locationName: "cidrBlock"
              },
              Name: {
                locationName: "name"
              }
            },
            required: [
              "CidrBlock",
              "Name"
            ]
          }
        },
        S3b: {
          type: "structure",
          members: {
            EgressCidrBlocks: {
              shape: "S16",
              locationName: "egressCidrBlocks"
            },
            GatewayArn: {
              locationName: "gatewayArn"
            },
            GatewayMessages: {
              shape: "S2q",
              locationName: "gatewayMessages"
            },
            GatewayState: {
              locationName: "gatewayState"
            },
            Name: {
              locationName: "name"
            },
            Networks: {
              shape: "S38",
              locationName: "networks"
            }
          },
          required: [
            "GatewayArn",
            "Networks",
            "EgressCidrBlocks",
            "Name"
          ]
        },
        S4a: {
          type: "structure",
          members: {
            CurrencyCode: {
              locationName: "currencyCode"
            },
            Duration: {
              locationName: "duration",
              type: "integer"
            },
            DurationUnits: {
              locationName: "durationUnits"
            },
            OfferingArn: {
              locationName: "offeringArn"
            },
            OfferingDescription: {
              locationName: "offeringDescription"
            },
            PricePerUnit: {
              locationName: "pricePerUnit"
            },
            PriceUnits: {
              locationName: "priceUnits"
            },
            ResourceSpecification: {
              shape: "S4d",
              locationName: "resourceSpecification"
            }
          },
          required: [
            "CurrencyCode",
            "OfferingArn",
            "OfferingDescription",
            "DurationUnits",
            "Duration",
            "PricePerUnit",
            "ResourceSpecification",
            "PriceUnits"
          ]
        },
        S4d: {
          type: "structure",
          members: {
            ReservedBitrate: {
              locationName: "reservedBitrate",
              type: "integer"
            },
            ResourceType: {
              locationName: "resourceType"
            }
          },
          required: [
            "ResourceType"
          ]
        },
        S4h: {
          type: "structure",
          members: {
            CurrencyCode: {
              locationName: "currencyCode"
            },
            Duration: {
              locationName: "duration",
              type: "integer"
            },
            DurationUnits: {
              locationName: "durationUnits"
            },
            End: {
              locationName: "end"
            },
            OfferingArn: {
              locationName: "offeringArn"
            },
            OfferingDescription: {
              locationName: "offeringDescription"
            },
            PricePerUnit: {
              locationName: "pricePerUnit"
            },
            PriceUnits: {
              locationName: "priceUnits"
            },
            ReservationArn: {
              locationName: "reservationArn"
            },
            ReservationName: {
              locationName: "reservationName"
            },
            ReservationState: {
              locationName: "reservationState"
            },
            ResourceSpecification: {
              shape: "S4d",
              locationName: "resourceSpecification"
            },
            Start: {
              locationName: "start"
            }
          },
          required: [
            "CurrencyCode",
            "ReservationState",
            "OfferingArn",
            "ReservationArn",
            "Start",
            "OfferingDescription",
            "ReservationName",
            "End",
            "Duration",
            "DurationUnits",
            "PricePerUnit",
            "ResourceSpecification",
            "PriceUnits"
          ]
        },
        S5f: {
          type: "map",
          key: {},
          value: {}
        },
        S65: {
          type: "structure",
          members: {
            FailoverMode: {
              locationName: "failoverMode"
            },
            RecoveryWindow: {
              locationName: "recoveryWindow",
              type: "integer"
            },
            SourcePriority: {
              shape: "S2m",
              locationName: "sourcePriority"
            },
            State: {
              locationName: "state"
            }
          }
        },
        S6l: {
          type: "structure",
          members: {
            Algorithm: {
              locationName: "algorithm"
            },
            ConstantInitializationVector: {
              locationName: "constantInitializationVector"
            },
            DeviceId: {
              locationName: "deviceId"
            },
            KeyType: {
              locationName: "keyType"
            },
            Region: {
              locationName: "region"
            },
            ResourceId: {
              locationName: "resourceId"
            },
            RoleArn: {
              locationName: "roleArn"
            },
            SecretArn: {
              locationName: "secretArn"
            },
            Url: {
              locationName: "url"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/mediaconnect-2018-11-14.paginators.json
var require_mediaconnect_2018_11_14_paginators = __commonJS({
  "node_modules/aws-sdk/apis/mediaconnect-2018-11-14.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListBridges: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Bridges"
        },
        ListEntitlements: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Entitlements"
        },
        ListFlows: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Flows"
        },
        ListGatewayInstances: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Instances"
        },
        ListGateways: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Gateways"
        },
        ListOfferings: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Offerings"
        },
        ListReservations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Reservations"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/mediaconnect-2018-11-14.waiters2.json
var require_mediaconnect_2018_11_14_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/mediaconnect-2018-11-14.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        FlowActive: {
          description: "Wait until a flow is active",
          operation: "DescribeFlow",
          delay: 3,
          maxAttempts: 40,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "Flow.Status",
              expected: "ACTIVE"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "Flow.Status",
              expected: "STARTING"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "Flow.Status",
              expected: "UPDATING"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            },
            {
              state: "retry",
              matcher: "status",
              expected: 503
            },
            {
              state: "failure",
              matcher: "path",
              argument: "Flow.Status",
              expected: "ERROR"
            }
          ]
        },
        FlowStandby: {
          description: "Wait until a flow is in standby mode",
          operation: "DescribeFlow",
          delay: 3,
          maxAttempts: 40,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "Flow.Status",
              expected: "STANDBY"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "Flow.Status",
              expected: "STOPPING"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            },
            {
              state: "retry",
              matcher: "status",
              expected: 503
            },
            {
              state: "failure",
              matcher: "path",
              argument: "Flow.Status",
              expected: "ERROR"
            }
          ]
        },
        FlowDeleted: {
          description: "Wait until a flow is deleted",
          operation: "DescribeFlow",
          delay: 3,
          maxAttempts: 40,
          acceptors: [
            {
              state: "success",
              matcher: "status",
              expected: 404
            },
            {
              state: "retry",
              matcher: "path",
              argument: "Flow.Status",
              expected: "DELETING"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            },
            {
              state: "retry",
              matcher: "status",
              expected: 503
            },
            {
              state: "failure",
              matcher: "path",
              argument: "Flow.Status",
              expected: "ERROR"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/mediaconnect.js
var require_mediaconnect = __commonJS({
  "node_modules/aws-sdk/clients/mediaconnect.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["mediaconnect"] = {};
    AWS2.MediaConnect = Service.defineService("mediaconnect", ["2018-11-14"]);
    Object.defineProperty(apiLoader.services["mediaconnect"], "2018-11-14", {
      get: function get() {
        var model = require_mediaconnect_2018_11_14_min();
        model.paginators = require_mediaconnect_2018_11_14_paginators().pagination;
        model.waiters = require_mediaconnect_2018_11_14_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.MediaConnect;
  }
});

// node_modules/aws-sdk/apis/fsx-2018-03-01.min.json
var require_fsx_2018_03_01_min = __commonJS({
  "node_modules/aws-sdk/apis/fsx-2018-03-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-03-01",
        endpointPrefix: "fsx",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon FSx",
        serviceId: "FSx",
        signatureVersion: "v4",
        signingName: "fsx",
        targetPrefix: "AWSSimbaAPIService_v20180301",
        uid: "fsx-2018-03-01"
      },
      operations: {
        AssociateFileSystemAliases: {
          input: {
            type: "structure",
            required: [
              "FileSystemId",
              "Aliases"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              FileSystemId: {},
              Aliases: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Aliases: {
                shape: "S7"
              }
            }
          }
        },
        CancelDataRepositoryTask: {
          input: {
            type: "structure",
            required: [
              "TaskId"
            ],
            members: {
              TaskId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Lifecycle: {},
              TaskId: {}
            }
          },
          idempotent: true
        },
        CopyBackup: {
          input: {
            type: "structure",
            required: [
              "SourceBackupId"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              SourceBackupId: {},
              SourceRegion: {},
              KmsKeyId: {},
              CopyTags: {
                type: "boolean"
              },
              Tags: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Backup: {
                shape: "So"
              }
            }
          },
          idempotent: true
        },
        CopySnapshotAndUpdateVolume: {
          input: {
            type: "structure",
            required: [
              "VolumeId",
              "SourceSnapshotARN"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              VolumeId: {},
              SourceSnapshotARN: {},
              CopyStrategy: {},
              Options: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VolumeId: {},
              Lifecycle: {},
              AdministrativeActions: {
                shape: "S2e"
              }
            }
          },
          idempotent: true
        },
        CreateBackup: {
          input: {
            type: "structure",
            members: {
              FileSystemId: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sj"
              },
              VolumeId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Backup: {
                shape: "So"
              }
            }
          },
          idempotent: true
        },
        CreateDataRepositoryAssociation: {
          input: {
            type: "structure",
            required: [
              "FileSystemId",
              "DataRepositoryPath"
            ],
            members: {
              FileSystemId: {},
              FileSystemPath: {},
              DataRepositoryPath: {},
              BatchImportMetaDataOnCreate: {
                type: "boolean"
              },
              ImportedFileChunkSize: {
                type: "integer"
              },
              S3: {
                shape: "S4v"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Association: {
                shape: "S51"
              }
            }
          },
          idempotent: true
        },
        CreateDataRepositoryTask: {
          input: {
            type: "structure",
            required: [
              "Type",
              "FileSystemId",
              "Report"
            ],
            members: {
              Type: {},
              Paths: {
                shape: "S5a"
              },
              FileSystemId: {},
              Report: {
                shape: "S5c"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sj"
              },
              CapacityToRelease: {
                type: "long"
              },
              ReleaseConfiguration: {
                shape: "S5g"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataRepositoryTask: {
                shape: "S5l"
              }
            }
          },
          idempotent: true
        },
        CreateFileCache: {
          input: {
            type: "structure",
            required: [
              "FileCacheType",
              "FileCacheTypeVersion",
              "StorageCapacity",
              "SubnetIds"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              FileCacheType: {},
              FileCacheTypeVersion: {},
              StorageCapacity: {
                type: "integer"
              },
              SubnetIds: {
                shape: "S15"
              },
              SecurityGroupIds: {
                shape: "S5x"
              },
              Tags: {
                shape: "Sj"
              },
              CopyTagsToDataRepositoryAssociations: {
                type: "boolean"
              },
              KmsKeyId: {},
              LustreConfiguration: {
                type: "structure",
                required: [
                  "PerUnitStorageThroughput",
                  "DeploymentType",
                  "MetadataConfiguration"
                ],
                members: {
                  PerUnitStorageThroughput: {
                    type: "integer"
                  },
                  DeploymentType: {},
                  WeeklyMaintenanceStartTime: {},
                  MetadataConfiguration: {
                    shape: "S62"
                  }
                }
              },
              DataRepositoryAssociations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "FileCachePath",
                    "DataRepositoryPath"
                  ],
                  members: {
                    FileCachePath: {},
                    DataRepositoryPath: {},
                    DataRepositorySubdirectories: {
                      shape: "S54"
                    },
                    NFS: {
                      type: "structure",
                      required: [
                        "Version"
                      ],
                      members: {
                        Version: {},
                        DnsIps: {
                          shape: "S57"
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FileCache: {
                type: "structure",
                members: {
                  OwnerId: {},
                  CreationTime: {
                    type: "timestamp"
                  },
                  FileCacheId: {},
                  FileCacheType: {},
                  FileCacheTypeVersion: {},
                  Lifecycle: {},
                  FailureDetails: {
                    shape: "S6a"
                  },
                  StorageCapacity: {
                    type: "integer"
                  },
                  VpcId: {},
                  SubnetIds: {
                    shape: "S15"
                  },
                  NetworkInterfaceIds: {
                    shape: "S17"
                  },
                  DNSName: {},
                  KmsKeyId: {},
                  ResourceARN: {},
                  Tags: {
                    shape: "Sj"
                  },
                  CopyTagsToDataRepositoryAssociations: {
                    type: "boolean"
                  },
                  LustreConfiguration: {
                    shape: "S6b"
                  },
                  DataRepositoryAssociationIds: {
                    shape: "S6c"
                  }
                }
              }
            }
          },
          idempotent: true
        },
        CreateFileSystem: {
          input: {
            type: "structure",
            required: [
              "FileSystemType",
              "StorageCapacity",
              "SubnetIds"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              FileSystemType: {},
              StorageCapacity: {
                type: "integer"
              },
              StorageType: {},
              SubnetIds: {
                shape: "S15"
              },
              SecurityGroupIds: {
                shape: "S5x"
              },
              Tags: {
                shape: "Sj"
              },
              KmsKeyId: {},
              WindowsConfiguration: {
                shape: "S6e"
              },
              LustreConfiguration: {
                shape: "S6i"
              },
              OntapConfiguration: {
                type: "structure",
                required: [
                  "DeploymentType"
                ],
                members: {
                  AutomaticBackupRetentionDays: {
                    type: "integer"
                  },
                  DailyAutomaticBackupStartTime: {},
                  DeploymentType: {},
                  EndpointIpAddressRange: {},
                  FsxAdminPassword: {
                    shape: "S4e"
                  },
                  DiskIopsConfiguration: {
                    shape: "S1t"
                  },
                  PreferredSubnetId: {},
                  RouteTableIds: {
                    shape: "S4c"
                  },
                  ThroughputCapacity: {
                    type: "integer"
                  },
                  WeeklyMaintenanceStartTime: {},
                  HAPairs: {
                    type: "integer"
                  },
                  ThroughputCapacityPerHAPair: {
                    type: "integer"
                  }
                }
              },
              FileSystemTypeVersion: {},
              OpenZFSConfiguration: {
                shape: "S6l"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FileSystem: {
                shape: "Sx"
              }
            }
          }
        },
        CreateFileSystemFromBackup: {
          input: {
            type: "structure",
            required: [
              "BackupId",
              "SubnetIds"
            ],
            members: {
              BackupId: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              SubnetIds: {
                shape: "S15"
              },
              SecurityGroupIds: {
                shape: "S5x"
              },
              Tags: {
                shape: "Sj"
              },
              WindowsConfiguration: {
                shape: "S6e"
              },
              LustreConfiguration: {
                shape: "S6i"
              },
              StorageType: {},
              KmsKeyId: {},
              FileSystemTypeVersion: {},
              OpenZFSConfiguration: {
                shape: "S6l"
              },
              StorageCapacity: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FileSystem: {
                shape: "Sx"
              }
            }
          }
        },
        CreateSnapshot: {
          input: {
            type: "structure",
            required: [
              "Name",
              "VolumeId"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              Name: {},
              VolumeId: {},
              Tags: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Snapshot: {
                shape: "S41"
              }
            }
          },
          idempotent: true
        },
        CreateStorageVirtualMachine: {
          input: {
            type: "structure",
            required: [
              "FileSystemId",
              "Name"
            ],
            members: {
              ActiveDirectoryConfiguration: {
                type: "structure",
                required: [
                  "NetBiosName"
                ],
                members: {
                  NetBiosName: {},
                  SelfManagedActiveDirectoryConfiguration: {
                    shape: "S6f"
                  }
                }
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              FileSystemId: {},
              Name: {},
              SvmAdminPassword: {
                shape: "S4e"
              },
              Tags: {
                shape: "Sj"
              },
              RootVolumeSecurityStyle: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StorageVirtualMachine: {
                shape: "S6y"
              }
            }
          }
        },
        CreateVolume: {
          input: {
            type: "structure",
            required: [
              "VolumeType",
              "Name"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              VolumeType: {},
              Name: {},
              OntapConfiguration: {
                shape: "S75"
              },
              Tags: {
                shape: "Sj"
              },
              OpenZFSConfiguration: {
                type: "structure",
                required: [
                  "ParentVolumeId"
                ],
                members: {
                  ParentVolumeId: {},
                  StorageCapacityReservationGiB: {
                    type: "integer"
                  },
                  StorageCapacityQuotaGiB: {
                    type: "integer"
                  },
                  RecordSizeKiB: {
                    type: "integer"
                  },
                  DataCompressionType: {},
                  CopyTagsToSnapshots: {
                    type: "boolean"
                  },
                  OriginSnapshot: {
                    type: "structure",
                    required: [
                      "SnapshotARN",
                      "CopyStrategy"
                    ],
                    members: {
                      SnapshotARN: {},
                      CopyStrategy: {}
                    }
                  },
                  ReadOnly: {
                    type: "boolean"
                  },
                  NfsExports: {
                    shape: "S3q"
                  },
                  UserAndGroupQuotas: {
                    shape: "S3x"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Volume: {
                shape: "S2k"
              }
            }
          }
        },
        CreateVolumeFromBackup: {
          input: {
            type: "structure",
            required: [
              "BackupId",
              "Name"
            ],
            members: {
              BackupId: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              Name: {},
              OntapConfiguration: {
                shape: "S75"
              },
              Tags: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Volume: {
                shape: "S2k"
              }
            }
          }
        },
        DeleteBackup: {
          input: {
            type: "structure",
            required: [
              "BackupId"
            ],
            members: {
              BackupId: {},
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupId: {},
              Lifecycle: {}
            }
          },
          idempotent: true
        },
        DeleteDataRepositoryAssociation: {
          input: {
            type: "structure",
            required: [
              "AssociationId"
            ],
            members: {
              AssociationId: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              DeleteDataInFileSystem: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssociationId: {},
              Lifecycle: {},
              DeleteDataInFileSystem: {
                type: "boolean"
              }
            }
          },
          idempotent: true
        },
        DeleteFileCache: {
          input: {
            type: "structure",
            required: [
              "FileCacheId"
            ],
            members: {
              FileCacheId: {},
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FileCacheId: {},
              Lifecycle: {}
            }
          },
          idempotent: true
        },
        DeleteFileSystem: {
          input: {
            type: "structure",
            required: [
              "FileSystemId"
            ],
            members: {
              FileSystemId: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              WindowsConfiguration: {
                type: "structure",
                members: {
                  SkipFinalBackup: {
                    type: "boolean"
                  },
                  FinalBackupTags: {
                    shape: "Sj"
                  }
                }
              },
              LustreConfiguration: {
                type: "structure",
                members: {
                  SkipFinalBackup: {
                    type: "boolean"
                  },
                  FinalBackupTags: {
                    shape: "Sj"
                  }
                }
              },
              OpenZFSConfiguration: {
                type: "structure",
                members: {
                  SkipFinalBackup: {
                    type: "boolean"
                  },
                  FinalBackupTags: {
                    shape: "Sj"
                  },
                  Options: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FileSystemId: {},
              Lifecycle: {},
              WindowsResponse: {
                type: "structure",
                members: {
                  FinalBackupId: {},
                  FinalBackupTags: {
                    shape: "Sj"
                  }
                }
              },
              LustreResponse: {
                type: "structure",
                members: {
                  FinalBackupId: {},
                  FinalBackupTags: {
                    shape: "Sj"
                  }
                }
              },
              OpenZFSResponse: {
                type: "structure",
                members: {
                  FinalBackupId: {},
                  FinalBackupTags: {
                    shape: "Sj"
                  }
                }
              }
            }
          },
          idempotent: true
        },
        DeleteSnapshot: {
          input: {
            type: "structure",
            required: [
              "SnapshotId"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              SnapshotId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SnapshotId: {},
              Lifecycle: {}
            }
          },
          idempotent: true
        },
        DeleteStorageVirtualMachine: {
          input: {
            type: "structure",
            required: [
              "StorageVirtualMachineId"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              StorageVirtualMachineId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StorageVirtualMachineId: {},
              Lifecycle: {}
            }
          }
        },
        DeleteVolume: {
          input: {
            type: "structure",
            required: [
              "VolumeId"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              VolumeId: {},
              OntapConfiguration: {
                type: "structure",
                members: {
                  SkipFinalBackup: {
                    type: "boolean"
                  },
                  FinalBackupTags: {
                    shape: "Sj"
                  },
                  BypassSnaplockEnterpriseRetention: {
                    type: "boolean"
                  }
                }
              },
              OpenZFSConfiguration: {
                type: "structure",
                members: {
                  Options: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VolumeId: {},
              Lifecycle: {},
              OntapResponse: {
                type: "structure",
                members: {
                  FinalBackupId: {},
                  FinalBackupTags: {
                    shape: "Sj"
                  }
                }
              }
            }
          }
        },
        DescribeBackups: {
          input: {
            type: "structure",
            members: {
              BackupIds: {
                type: "list",
                member: {}
              },
              Filters: {
                shape: "S8a"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Backups: {
                type: "list",
                member: {
                  shape: "So"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeDataRepositoryAssociations: {
          input: {
            type: "structure",
            members: {
              AssociationIds: {
                shape: "S6c"
              },
              Filters: {
                shape: "S8a"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Associations: {
                type: "list",
                member: {
                  shape: "S51"
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        DescribeDataRepositoryTasks: {
          input: {
            type: "structure",
            members: {
              TaskIds: {
                type: "list",
                member: {}
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DataRepositoryTasks: {
                type: "list",
                member: {
                  shape: "S5l"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeFileCaches: {
          input: {
            type: "structure",
            members: {
              FileCacheIds: {
                type: "list",
                member: {}
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FileCaches: {
                type: "list",
                member: {
                  shape: "S90"
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        DescribeFileSystemAliases: {
          input: {
            type: "structure",
            required: [
              "FileSystemId"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              FileSystemId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Aliases: {
                shape: "S7"
              },
              NextToken: {}
            }
          }
        },
        DescribeFileSystems: {
          input: {
            type: "structure",
            members: {
              FileSystemIds: {
                type: "list",
                member: {}
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FileSystems: {
                type: "list",
                member: {
                  shape: "Sx"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeSharedVpcConfiguration: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              EnableFsxRouteTableUpdatesFromParticipantAccounts: {}
            }
          }
        },
        DescribeSnapshots: {
          input: {
            type: "structure",
            members: {
              SnapshotIds: {
                type: "list",
                member: {}
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              IncludeShared: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Snapshots: {
                type: "list",
                member: {
                  shape: "S41"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeStorageVirtualMachines: {
          input: {
            type: "structure",
            members: {
              StorageVirtualMachineIds: {
                type: "list",
                member: {}
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StorageVirtualMachines: {
                type: "list",
                member: {
                  shape: "S6y"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeVolumes: {
          input: {
            type: "structure",
            members: {
              VolumeIds: {
                type: "list",
                member: {}
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Volumes: {
                type: "list",
                member: {
                  shape: "S2k"
                }
              },
              NextToken: {}
            }
          }
        },
        DisassociateFileSystemAliases: {
          input: {
            type: "structure",
            required: [
              "FileSystemId",
              "Aliases"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              FileSystemId: {},
              Aliases: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Aliases: {
                shape: "S7"
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sj"
              },
              NextToken: {}
            }
          }
        },
        ReleaseFileSystemNfsV3Locks: {
          input: {
            type: "structure",
            required: [
              "FileSystemId"
            ],
            members: {
              FileSystemId: {},
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FileSystem: {
                shape: "Sx"
              }
            }
          },
          idempotent: true
        },
        RestoreVolumeFromSnapshot: {
          input: {
            type: "structure",
            required: [
              "VolumeId",
              "SnapshotId"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              VolumeId: {},
              SnapshotId: {},
              Options: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VolumeId: {},
              Lifecycle: {},
              AdministrativeActions: {
                shape: "S2e"
              }
            }
          },
          idempotent: true
        },
        StartMisconfiguredStateRecovery: {
          input: {
            type: "structure",
            required: [
              "FileSystemId"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              FileSystemId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FileSystem: {
                shape: "Sx"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateDataRepositoryAssociation: {
          input: {
            type: "structure",
            required: [
              "AssociationId"
            ],
            members: {
              AssociationId: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              ImportedFileChunkSize: {
                type: "integer"
              },
              S3: {
                shape: "S4v"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Association: {
                shape: "S51"
              }
            }
          },
          idempotent: true
        },
        UpdateFileCache: {
          input: {
            type: "structure",
            required: [
              "FileCacheId"
            ],
            members: {
              FileCacheId: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              LustreConfiguration: {
                type: "structure",
                members: {
                  WeeklyMaintenanceStartTime: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FileCache: {
                shape: "S90"
              }
            }
          },
          idempotent: true
        },
        UpdateFileSystem: {
          input: {
            type: "structure",
            required: [
              "FileSystemId"
            ],
            members: {
              FileSystemId: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              StorageCapacity: {
                type: "integer"
              },
              WindowsConfiguration: {
                type: "structure",
                members: {
                  WeeklyMaintenanceStartTime: {},
                  DailyAutomaticBackupStartTime: {},
                  AutomaticBackupRetentionDays: {
                    type: "integer"
                  },
                  ThroughputCapacity: {
                    type: "integer"
                  },
                  SelfManagedActiveDirectoryConfiguration: {
                    shape: "Saq"
                  },
                  AuditLogConfiguration: {
                    shape: "S6h"
                  },
                  DiskIopsConfiguration: {
                    shape: "S1t"
                  }
                }
              },
              LustreConfiguration: {
                type: "structure",
                members: {
                  WeeklyMaintenanceStartTime: {},
                  DailyAutomaticBackupStartTime: {},
                  AutomaticBackupRetentionDays: {
                    type: "integer"
                  },
                  AutoImportPolicy: {},
                  DataCompressionType: {},
                  LogConfiguration: {
                    shape: "S6j"
                  },
                  RootSquashConfiguration: {
                    shape: "S2a"
                  },
                  PerUnitStorageThroughput: {
                    type: "integer"
                  }
                }
              },
              OntapConfiguration: {
                type: "structure",
                members: {
                  AutomaticBackupRetentionDays: {
                    type: "integer"
                  },
                  DailyAutomaticBackupStartTime: {},
                  FsxAdminPassword: {
                    shape: "S4e"
                  },
                  WeeklyMaintenanceStartTime: {},
                  DiskIopsConfiguration: {
                    shape: "S1t"
                  },
                  ThroughputCapacity: {
                    type: "integer"
                  },
                  AddRouteTableIds: {
                    shape: "S4c"
                  },
                  RemoveRouteTableIds: {
                    shape: "S4c"
                  },
                  ThroughputCapacityPerHAPair: {
                    type: "integer"
                  }
                }
              },
              OpenZFSConfiguration: {
                type: "structure",
                members: {
                  AutomaticBackupRetentionDays: {
                    type: "integer"
                  },
                  CopyTagsToBackups: {
                    type: "boolean"
                  },
                  CopyTagsToVolumes: {
                    type: "boolean"
                  },
                  DailyAutomaticBackupStartTime: {},
                  ThroughputCapacity: {
                    type: "integer"
                  },
                  WeeklyMaintenanceStartTime: {},
                  DiskIopsConfiguration: {
                    shape: "S1t"
                  },
                  AddRouteTableIds: {
                    shape: "S4c"
                  },
                  RemoveRouteTableIds: {
                    shape: "S4c"
                  }
                }
              },
              StorageType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FileSystem: {
                shape: "Sx"
              }
            }
          }
        },
        UpdateSharedVpcConfiguration: {
          input: {
            type: "structure",
            members: {
              EnableFsxRouteTableUpdatesFromParticipantAccounts: {},
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EnableFsxRouteTableUpdatesFromParticipantAccounts: {}
            }
          }
        },
        UpdateSnapshot: {
          input: {
            type: "structure",
            required: [
              "Name",
              "SnapshotId"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              Name: {},
              SnapshotId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Snapshot: {
                shape: "S41"
              }
            }
          },
          idempotent: true
        },
        UpdateStorageVirtualMachine: {
          input: {
            type: "structure",
            required: [
              "StorageVirtualMachineId"
            ],
            members: {
              ActiveDirectoryConfiguration: {
                type: "structure",
                members: {
                  SelfManagedActiveDirectoryConfiguration: {
                    shape: "Saq"
                  },
                  NetBiosName: {}
                }
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              StorageVirtualMachineId: {},
              SvmAdminPassword: {
                shape: "S4e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StorageVirtualMachine: {
                shape: "S6y"
              }
            }
          }
        },
        UpdateVolume: {
          input: {
            type: "structure",
            required: [
              "VolumeId"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              VolumeId: {},
              OntapConfiguration: {
                type: "structure",
                members: {
                  JunctionPath: {},
                  SecurityStyle: {},
                  SizeInMegabytes: {
                    type: "integer"
                  },
                  StorageEfficiencyEnabled: {
                    type: "boolean"
                  },
                  TieringPolicy: {
                    shape: "S2t"
                  },
                  SnapshotPolicy: {},
                  CopyTagsToBackups: {
                    type: "boolean"
                  },
                  SnaplockConfiguration: {
                    type: "structure",
                    members: {
                      AuditLogVolume: {
                        type: "boolean"
                      },
                      AutocommitPeriod: {
                        shape: "S30"
                      },
                      PrivilegedDelete: {},
                      RetentionPeriod: {
                        shape: "S34"
                      },
                      VolumeAppendModeEnabled: {
                        type: "boolean"
                      }
                    }
                  },
                  SizeInBytes: {
                    type: "long"
                  }
                }
              },
              Name: {},
              OpenZFSConfiguration: {
                type: "structure",
                members: {
                  StorageCapacityReservationGiB: {
                    type: "integer"
                  },
                  StorageCapacityQuotaGiB: {
                    type: "integer"
                  },
                  RecordSizeKiB: {
                    type: "integer"
                  },
                  DataCompressionType: {},
                  NfsExports: {
                    shape: "S3q"
                  },
                  UserAndGroupQuotas: {
                    shape: "S3x"
                  },
                  ReadOnly: {
                    type: "boolean"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Volume: {
                shape: "S2k"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "list",
          member: {}
        },
        S7: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Lifecycle: {}
            }
          }
        },
        Sj: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        So: {
          type: "structure",
          required: [
            "BackupId",
            "Lifecycle",
            "Type",
            "CreationTime",
            "FileSystem"
          ],
          members: {
            BackupId: {},
            Lifecycle: {},
            FailureDetails: {
              type: "structure",
              members: {
                Message: {}
              }
            },
            Type: {},
            ProgressPercent: {
              type: "integer"
            },
            CreationTime: {
              type: "timestamp"
            },
            KmsKeyId: {},
            ResourceARN: {},
            Tags: {
              shape: "Sj"
            },
            FileSystem: {
              shape: "Sx"
            },
            DirectoryInformation: {
              type: "structure",
              members: {
                DomainName: {},
                ActiveDirectoryId: {},
                ResourceARN: {}
              }
            },
            OwnerId: {},
            SourceBackupId: {},
            SourceBackupRegion: {},
            ResourceType: {},
            Volume: {
              shape: "S2k"
            }
          }
        },
        Sx: {
          type: "structure",
          members: {
            OwnerId: {},
            CreationTime: {
              type: "timestamp"
            },
            FileSystemId: {},
            FileSystemType: {},
            Lifecycle: {},
            FailureDetails: {
              type: "structure",
              members: {
                Message: {}
              }
            },
            StorageCapacity: {
              type: "integer"
            },
            StorageType: {},
            VpcId: {},
            SubnetIds: {
              shape: "S15"
            },
            NetworkInterfaceIds: {
              shape: "S17"
            },
            DNSName: {},
            KmsKeyId: {},
            ResourceARN: {},
            Tags: {
              shape: "Sj"
            },
            WindowsConfiguration: {
              type: "structure",
              members: {
                ActiveDirectoryId: {},
                SelfManagedActiveDirectoryConfiguration: {
                  shape: "S1c"
                },
                DeploymentType: {},
                RemoteAdministrationEndpoint: {},
                PreferredSubnetId: {},
                PreferredFileServerIp: {},
                ThroughputCapacity: {
                  type: "integer"
                },
                MaintenanceOperationsInProgress: {
                  type: "list",
                  member: {}
                },
                WeeklyMaintenanceStartTime: {},
                DailyAutomaticBackupStartTime: {},
                AutomaticBackupRetentionDays: {
                  type: "integer"
                },
                CopyTagsToBackups: {
                  type: "boolean"
                },
                Aliases: {
                  shape: "S7"
                },
                AuditLogConfiguration: {
                  type: "structure",
                  required: [
                    "FileAccessAuditLogLevel",
                    "FileShareAccessAuditLogLevel"
                  ],
                  members: {
                    FileAccessAuditLogLevel: {},
                    FileShareAccessAuditLogLevel: {},
                    AuditLogDestination: {}
                  }
                },
                DiskIopsConfiguration: {
                  shape: "S1t"
                }
              }
            },
            LustreConfiguration: {
              type: "structure",
              members: {
                WeeklyMaintenanceStartTime: {},
                DataRepositoryConfiguration: {
                  type: "structure",
                  members: {
                    Lifecycle: {},
                    ImportPath: {},
                    ExportPath: {},
                    ImportedFileChunkSize: {
                      type: "integer"
                    },
                    AutoImportPolicy: {},
                    FailureDetails: {
                      shape: "S22"
                    }
                  }
                },
                DeploymentType: {},
                PerUnitStorageThroughput: {
                  type: "integer"
                },
                MountName: {},
                DailyAutomaticBackupStartTime: {},
                AutomaticBackupRetentionDays: {
                  type: "integer"
                },
                CopyTagsToBackups: {
                  type: "boolean"
                },
                DriveCacheType: {},
                DataCompressionType: {},
                LogConfiguration: {
                  shape: "S28"
                },
                RootSquashConfiguration: {
                  shape: "S2a"
                }
              }
            },
            AdministrativeActions: {
              shape: "S2e"
            },
            OntapConfiguration: {
              type: "structure",
              members: {
                AutomaticBackupRetentionDays: {
                  type: "integer"
                },
                DailyAutomaticBackupStartTime: {},
                DeploymentType: {},
                EndpointIpAddressRange: {},
                Endpoints: {
                  type: "structure",
                  members: {
                    Intercluster: {
                      shape: "S4a"
                    },
                    Management: {
                      shape: "S4a"
                    }
                  }
                },
                DiskIopsConfiguration: {
                  shape: "S1t"
                },
                PreferredSubnetId: {},
                RouteTableIds: {
                  shape: "S4c"
                },
                ThroughputCapacity: {
                  type: "integer"
                },
                WeeklyMaintenanceStartTime: {},
                FsxAdminPassword: {
                  shape: "S4e"
                },
                HAPairs: {
                  type: "integer"
                },
                ThroughputCapacityPerHAPair: {
                  type: "integer"
                }
              }
            },
            FileSystemTypeVersion: {},
            OpenZFSConfiguration: {
              type: "structure",
              members: {
                AutomaticBackupRetentionDays: {
                  type: "integer"
                },
                CopyTagsToBackups: {
                  type: "boolean"
                },
                CopyTagsToVolumes: {
                  type: "boolean"
                },
                DailyAutomaticBackupStartTime: {},
                DeploymentType: {},
                ThroughputCapacity: {
                  type: "integer"
                },
                WeeklyMaintenanceStartTime: {},
                DiskIopsConfiguration: {
                  shape: "S1t"
                },
                RootVolumeId: {},
                PreferredSubnetId: {},
                EndpointIpAddressRange: {},
                RouteTableIds: {
                  shape: "S4c"
                },
                EndpointIpAddress: {}
              }
            }
          }
        },
        S15: {
          type: "list",
          member: {}
        },
        S17: {
          type: "list",
          member: {}
        },
        S1c: {
          type: "structure",
          members: {
            DomainName: {},
            OrganizationalUnitDistinguishedName: {},
            FileSystemAdministratorsGroup: {},
            UserName: {},
            DnsIps: {
              shape: "S1h"
            }
          }
        },
        S1h: {
          type: "list",
          member: {}
        },
        S1t: {
          type: "structure",
          members: {
            Mode: {},
            Iops: {
              type: "long"
            }
          }
        },
        S22: {
          type: "structure",
          members: {
            Message: {}
          }
        },
        S28: {
          type: "structure",
          required: [
            "Level"
          ],
          members: {
            Level: {},
            Destination: {}
          }
        },
        S2a: {
          type: "structure",
          members: {
            RootSquash: {},
            NoSquashNids: {
              type: "list",
              member: {}
            }
          }
        },
        S2e: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AdministrativeActionType: {},
              ProgressPercent: {
                type: "integer"
              },
              RequestTime: {
                type: "timestamp"
              },
              Status: {},
              TargetFileSystemValues: {
                shape: "Sx"
              },
              FailureDetails: {
                type: "structure",
                members: {
                  Message: {}
                }
              },
              TargetVolumeValues: {
                shape: "S2k"
              },
              TargetSnapshotValues: {
                shape: "S41"
              },
              TotalTransferBytes: {
                type: "long"
              },
              RemainingTransferBytes: {
                type: "long"
              }
            }
          }
        },
        S2k: {
          type: "structure",
          members: {
            CreationTime: {
              type: "timestamp"
            },
            FileSystemId: {},
            Lifecycle: {},
            Name: {},
            OntapConfiguration: {
              type: "structure",
              members: {
                FlexCacheEndpointType: {},
                JunctionPath: {},
                SecurityStyle: {},
                SizeInMegabytes: {
                  type: "integer"
                },
                StorageEfficiencyEnabled: {
                  type: "boolean"
                },
                StorageVirtualMachineId: {},
                StorageVirtualMachineRoot: {
                  type: "boolean"
                },
                TieringPolicy: {
                  shape: "S2t"
                },
                UUID: {},
                OntapVolumeType: {},
                SnapshotPolicy: {},
                CopyTagsToBackups: {
                  type: "boolean"
                },
                SnaplockConfiguration: {
                  type: "structure",
                  members: {
                    AuditLogVolume: {
                      type: "boolean"
                    },
                    AutocommitPeriod: {
                      shape: "S30"
                    },
                    PrivilegedDelete: {},
                    RetentionPeriod: {
                      shape: "S34"
                    },
                    SnaplockType: {},
                    VolumeAppendModeEnabled: {
                      type: "boolean"
                    }
                  }
                },
                VolumeStyle: {},
                AggregateConfiguration: {
                  type: "structure",
                  members: {
                    Aggregates: {
                      shape: "S3b"
                    },
                    TotalConstituents: {
                      type: "integer"
                    }
                  }
                },
                SizeInBytes: {
                  type: "long"
                }
              }
            },
            ResourceARN: {},
            Tags: {
              shape: "Sj"
            },
            VolumeId: {},
            VolumeType: {},
            LifecycleTransitionReason: {
              shape: "S3h"
            },
            AdministrativeActions: {
              shape: "S2e"
            },
            OpenZFSConfiguration: {
              type: "structure",
              members: {
                ParentVolumeId: {},
                VolumePath: {},
                StorageCapacityReservationGiB: {
                  type: "integer"
                },
                StorageCapacityQuotaGiB: {
                  type: "integer"
                },
                RecordSizeKiB: {
                  type: "integer"
                },
                DataCompressionType: {},
                CopyTagsToSnapshots: {
                  type: "boolean"
                },
                OriginSnapshot: {
                  type: "structure",
                  members: {
                    SnapshotARN: {},
                    CopyStrategy: {}
                  }
                },
                ReadOnly: {
                  type: "boolean"
                },
                NfsExports: {
                  shape: "S3q"
                },
                UserAndGroupQuotas: {
                  shape: "S3x"
                },
                RestoreToSnapshot: {},
                DeleteIntermediateSnaphots: {
                  type: "boolean"
                },
                DeleteClonedVolumes: {
                  type: "boolean"
                },
                DeleteIntermediateData: {
                  type: "boolean"
                },
                SourceSnapshotARN: {},
                DestinationSnapshot: {},
                CopyStrategy: {}
              }
            }
          }
        },
        S2t: {
          type: "structure",
          members: {
            CoolingPeriod: {
              type: "integer"
            },
            Name: {}
          }
        },
        S30: {
          type: "structure",
          required: [
            "Type"
          ],
          members: {
            Type: {},
            Value: {
              type: "integer"
            }
          }
        },
        S34: {
          type: "structure",
          required: [
            "DefaultRetention",
            "MinimumRetention",
            "MaximumRetention"
          ],
          members: {
            DefaultRetention: {
              shape: "S35"
            },
            MinimumRetention: {
              shape: "S35"
            },
            MaximumRetention: {
              shape: "S35"
            }
          }
        },
        S35: {
          type: "structure",
          required: [
            "Type"
          ],
          members: {
            Type: {},
            Value: {
              type: "integer"
            }
          }
        },
        S3b: {
          type: "list",
          member: {}
        },
        S3h: {
          type: "structure",
          members: {
            Message: {}
          }
        },
        S3q: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ClientConfigurations"
            ],
            members: {
              ClientConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Clients",
                    "Options"
                  ],
                  members: {
                    Clients: {},
                    Options: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              }
            }
          }
        },
        S3x: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Type",
              "Id",
              "StorageCapacityQuotaGiB"
            ],
            members: {
              Type: {},
              Id: {
                type: "integer"
              },
              StorageCapacityQuotaGiB: {
                type: "integer"
              }
            }
          }
        },
        S41: {
          type: "structure",
          members: {
            ResourceARN: {},
            SnapshotId: {},
            Name: {},
            VolumeId: {},
            CreationTime: {
              type: "timestamp"
            },
            Lifecycle: {},
            LifecycleTransitionReason: {
              shape: "S3h"
            },
            Tags: {
              shape: "Sj"
            },
            AdministrativeActions: {
              shape: "S2e"
            }
          }
        },
        S4a: {
          type: "structure",
          members: {
            DNSName: {},
            IpAddresses: {
              shape: "S4b"
            }
          }
        },
        S4b: {
          type: "list",
          member: {}
        },
        S4c: {
          type: "list",
          member: {}
        },
        S4e: {
          type: "string",
          sensitive: true
        },
        S4v: {
          type: "structure",
          members: {
            AutoImportPolicy: {
              type: "structure",
              members: {
                Events: {
                  shape: "S4x"
                }
              }
            },
            AutoExportPolicy: {
              shape: "S4z"
            }
          }
        },
        S4x: {
          type: "list",
          member: {}
        },
        S4z: {
          type: "structure",
          members: {
            Events: {
              shape: "S4x"
            }
          }
        },
        S51: {
          type: "structure",
          members: {
            AssociationId: {},
            ResourceARN: {},
            FileSystemId: {},
            Lifecycle: {},
            FailureDetails: {
              shape: "S22"
            },
            FileSystemPath: {},
            DataRepositoryPath: {},
            BatchImportMetaDataOnCreate: {
              type: "boolean"
            },
            ImportedFileChunkSize: {
              type: "integer"
            },
            S3: {
              shape: "S4v"
            },
            Tags: {
              shape: "Sj"
            },
            CreationTime: {
              type: "timestamp"
            },
            FileCacheId: {},
            FileCachePath: {},
            DataRepositorySubdirectories: {
              shape: "S54"
            },
            NFS: {
              type: "structure",
              required: [
                "Version"
              ],
              members: {
                Version: {},
                DnsIps: {
                  shape: "S57"
                },
                AutoExportPolicy: {
                  shape: "S4z"
                }
              }
            }
          }
        },
        S54: {
          type: "list",
          member: {}
        },
        S57: {
          type: "list",
          member: {}
        },
        S5a: {
          type: "list",
          member: {}
        },
        S5c: {
          type: "structure",
          required: [
            "Enabled"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Path: {},
            Format: {},
            Scope: {}
          }
        },
        S5g: {
          type: "structure",
          members: {
            DurationSinceLastAccess: {
              type: "structure",
              members: {
                Unit: {},
                Value: {
                  type: "long"
                }
              }
            }
          }
        },
        S5l: {
          type: "structure",
          required: [
            "TaskId",
            "Lifecycle",
            "Type",
            "CreationTime"
          ],
          members: {
            TaskId: {},
            Lifecycle: {},
            Type: {},
            CreationTime: {
              type: "timestamp"
            },
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            ResourceARN: {},
            Tags: {
              shape: "Sj"
            },
            FileSystemId: {},
            Paths: {
              shape: "S5a"
            },
            FailureDetails: {
              type: "structure",
              members: {
                Message: {}
              }
            },
            Status: {
              type: "structure",
              members: {
                TotalCount: {
                  type: "long"
                },
                SucceededCount: {
                  type: "long"
                },
                FailedCount: {
                  type: "long"
                },
                LastUpdatedTime: {
                  type: "timestamp"
                },
                ReleasedCapacity: {
                  type: "long"
                }
              }
            },
            Report: {
              shape: "S5c"
            },
            CapacityToRelease: {
              type: "long"
            },
            FileCacheId: {},
            ReleaseConfiguration: {
              shape: "S5g"
            }
          }
        },
        S5x: {
          type: "list",
          member: {}
        },
        S62: {
          type: "structure",
          required: [
            "StorageCapacity"
          ],
          members: {
            StorageCapacity: {
              type: "integer"
            }
          }
        },
        S6a: {
          type: "structure",
          members: {
            Message: {}
          }
        },
        S6b: {
          type: "structure",
          members: {
            PerUnitStorageThroughput: {
              type: "integer"
            },
            DeploymentType: {},
            MountName: {},
            WeeklyMaintenanceStartTime: {},
            MetadataConfiguration: {
              shape: "S62"
            },
            LogConfiguration: {
              shape: "S28"
            }
          }
        },
        S6c: {
          type: "list",
          member: {}
        },
        S6e: {
          type: "structure",
          required: [
            "ThroughputCapacity"
          ],
          members: {
            ActiveDirectoryId: {},
            SelfManagedActiveDirectoryConfiguration: {
              shape: "S6f"
            },
            DeploymentType: {},
            PreferredSubnetId: {},
            ThroughputCapacity: {
              type: "integer"
            },
            WeeklyMaintenanceStartTime: {},
            DailyAutomaticBackupStartTime: {},
            AutomaticBackupRetentionDays: {
              type: "integer"
            },
            CopyTagsToBackups: {
              type: "boolean"
            },
            Aliases: {
              shape: "S4"
            },
            AuditLogConfiguration: {
              shape: "S6h"
            },
            DiskIopsConfiguration: {
              shape: "S1t"
            }
          }
        },
        S6f: {
          type: "structure",
          required: [
            "DomainName",
            "UserName",
            "Password",
            "DnsIps"
          ],
          members: {
            DomainName: {},
            OrganizationalUnitDistinguishedName: {},
            FileSystemAdministratorsGroup: {},
            UserName: {},
            Password: {
              shape: "S6g"
            },
            DnsIps: {
              shape: "S1h"
            }
          }
        },
        S6g: {
          type: "string",
          sensitive: true
        },
        S6h: {
          type: "structure",
          required: [
            "FileAccessAuditLogLevel",
            "FileShareAccessAuditLogLevel"
          ],
          members: {
            FileAccessAuditLogLevel: {},
            FileShareAccessAuditLogLevel: {},
            AuditLogDestination: {}
          }
        },
        S6i: {
          type: "structure",
          members: {
            WeeklyMaintenanceStartTime: {},
            ImportPath: {},
            ExportPath: {},
            ImportedFileChunkSize: {
              type: "integer"
            },
            DeploymentType: {},
            AutoImportPolicy: {},
            PerUnitStorageThroughput: {
              type: "integer"
            },
            DailyAutomaticBackupStartTime: {},
            AutomaticBackupRetentionDays: {
              type: "integer"
            },
            CopyTagsToBackups: {
              type: "boolean"
            },
            DriveCacheType: {},
            DataCompressionType: {},
            LogConfiguration: {
              shape: "S6j"
            },
            RootSquashConfiguration: {
              shape: "S2a"
            }
          }
        },
        S6j: {
          type: "structure",
          required: [
            "Level"
          ],
          members: {
            Level: {},
            Destination: {}
          }
        },
        S6l: {
          type: "structure",
          required: [
            "DeploymentType",
            "ThroughputCapacity"
          ],
          members: {
            AutomaticBackupRetentionDays: {
              type: "integer"
            },
            CopyTagsToBackups: {
              type: "boolean"
            },
            CopyTagsToVolumes: {
              type: "boolean"
            },
            DailyAutomaticBackupStartTime: {},
            DeploymentType: {},
            ThroughputCapacity: {
              type: "integer"
            },
            WeeklyMaintenanceStartTime: {},
            DiskIopsConfiguration: {
              shape: "S1t"
            },
            RootVolumeConfiguration: {
              type: "structure",
              members: {
                RecordSizeKiB: {
                  type: "integer"
                },
                DataCompressionType: {},
                NfsExports: {
                  shape: "S3q"
                },
                UserAndGroupQuotas: {
                  shape: "S3x"
                },
                CopyTagsToSnapshots: {
                  type: "boolean"
                },
                ReadOnly: {
                  type: "boolean"
                }
              }
            },
            PreferredSubnetId: {},
            EndpointIpAddressRange: {},
            RouteTableIds: {
              shape: "S4c"
            }
          }
        },
        S6y: {
          type: "structure",
          members: {
            ActiveDirectoryConfiguration: {
              type: "structure",
              members: {
                NetBiosName: {},
                SelfManagedActiveDirectoryConfiguration: {
                  shape: "S1c"
                }
              }
            },
            CreationTime: {
              type: "timestamp"
            },
            Endpoints: {
              type: "structure",
              members: {
                Iscsi: {
                  shape: "S71"
                },
                Management: {
                  shape: "S71"
                },
                Nfs: {
                  shape: "S71"
                },
                Smb: {
                  shape: "S71"
                }
              }
            },
            FileSystemId: {},
            Lifecycle: {},
            Name: {},
            ResourceARN: {},
            StorageVirtualMachineId: {},
            Subtype: {},
            UUID: {},
            Tags: {
              shape: "Sj"
            },
            LifecycleTransitionReason: {
              shape: "S3h"
            },
            RootVolumeSecurityStyle: {}
          }
        },
        S71: {
          type: "structure",
          members: {
            DNSName: {},
            IpAddresses: {
              shape: "S4b"
            }
          }
        },
        S75: {
          type: "structure",
          required: [
            "StorageVirtualMachineId"
          ],
          members: {
            JunctionPath: {},
            SecurityStyle: {},
            SizeInMegabytes: {
              deprecated: true,
              deprecatedMessage: "This property is deprecated, use SizeInBytes instead",
              type: "integer"
            },
            StorageEfficiencyEnabled: {
              type: "boolean"
            },
            StorageVirtualMachineId: {},
            TieringPolicy: {
              shape: "S2t"
            },
            OntapVolumeType: {},
            SnapshotPolicy: {},
            CopyTagsToBackups: {
              type: "boolean"
            },
            SnaplockConfiguration: {
              type: "structure",
              required: [
                "SnaplockType"
              ],
              members: {
                AuditLogVolume: {
                  type: "boolean"
                },
                AutocommitPeriod: {
                  shape: "S30"
                },
                PrivilegedDelete: {},
                RetentionPeriod: {
                  shape: "S34"
                },
                SnaplockType: {},
                VolumeAppendModeEnabled: {
                  type: "boolean"
                }
              }
            },
            VolumeStyle: {},
            AggregateConfiguration: {
              type: "structure",
              members: {
                Aggregates: {
                  shape: "S3b"
                },
                ConstituentsPerAggregate: {
                  type: "integer"
                }
              }
            },
            SizeInBytes: {
              type: "long"
            }
          }
        },
        S8a: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Values: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S90: {
          type: "structure",
          members: {
            OwnerId: {},
            CreationTime: {
              type: "timestamp"
            },
            FileCacheId: {},
            FileCacheType: {},
            FileCacheTypeVersion: {},
            Lifecycle: {},
            FailureDetails: {
              shape: "S6a"
            },
            StorageCapacity: {
              type: "integer"
            },
            VpcId: {},
            SubnetIds: {
              shape: "S15"
            },
            NetworkInterfaceIds: {
              shape: "S17"
            },
            DNSName: {},
            KmsKeyId: {},
            ResourceARN: {},
            LustreConfiguration: {
              shape: "S6b"
            },
            DataRepositoryAssociationIds: {
              shape: "S6c"
            }
          }
        },
        Saq: {
          type: "structure",
          members: {
            UserName: {},
            Password: {
              shape: "S6g"
            },
            DnsIps: {
              shape: "S1h"
            },
            DomainName: {},
            OrganizationalUnitDistinguishedName: {},
            FileSystemAdministratorsGroup: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/fsx-2018-03-01.paginators.json
var require_fsx_2018_03_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/fsx-2018-03-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeBackups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeDataRepositoryAssociations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeDataRepositoryTasks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeFileCaches: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeFileSystemAliases: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeFileSystems: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeSnapshots: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeStorageVirtualMachines: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "StorageVirtualMachines"
        },
        DescribeVolumes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Volumes"
        },
        ListTagsForResource: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/fsx.js
var require_fsx = __commonJS({
  "node_modules/aws-sdk/clients/fsx.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["fsx"] = {};
    AWS2.FSx = Service.defineService("fsx", ["2018-03-01"]);
    Object.defineProperty(apiLoader.services["fsx"], "2018-03-01", {
      get: function get() {
        var model = require_fsx_2018_03_01_min();
        model.paginators = require_fsx_2018_03_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.FSx;
  }
});

// node_modules/aws-sdk/apis/securityhub-2018-10-26.min.json
var require_securityhub_2018_10_26_min = __commonJS({
  "node_modules/aws-sdk/apis/securityhub-2018-10-26.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-10-26",
        endpointPrefix: "securityhub",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS SecurityHub",
        serviceId: "SecurityHub",
        signatureVersion: "v4",
        signingName: "securityhub",
        uid: "securityhub-2018-10-26"
      },
      operations: {
        AcceptAdministratorInvitation: {
          http: {
            requestUri: "/administrator"
          },
          input: {
            type: "structure",
            required: [
              "AdministratorId",
              "InvitationId"
            ],
            members: {
              AdministratorId: {},
              InvitationId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AcceptInvitation: {
          http: {
            requestUri: "/master"
          },
          input: {
            type: "structure",
            required: [
              "MasterId",
              "InvitationId"
            ],
            members: {
              MasterId: {},
              InvitationId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "This API has been deprecated, use AcceptAdministratorInvitation API instead."
        },
        BatchDeleteAutomationRules: {
          http: {
            requestUri: "/automationrules/delete"
          },
          input: {
            type: "structure",
            required: [
              "AutomationRulesArns"
            ],
            members: {
              AutomationRulesArns: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProcessedAutomationRules: {
                shape: "S7"
              },
              UnprocessedAutomationRules: {
                shape: "S9"
              }
            }
          }
        },
        BatchDisableStandards: {
          http: {
            requestUri: "/standards/deregister"
          },
          input: {
            type: "structure",
            required: [
              "StandardsSubscriptionArns"
            ],
            members: {
              StandardsSubscriptionArns: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StandardsSubscriptions: {
                shape: "Sf"
              }
            }
          }
        },
        BatchEnableStandards: {
          http: {
            requestUri: "/standards/register"
          },
          input: {
            type: "structure",
            required: [
              "StandardsSubscriptionRequests"
            ],
            members: {
              StandardsSubscriptionRequests: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "StandardsArn"
                  ],
                  members: {
                    StandardsArn: {},
                    StandardsInput: {
                      shape: "Sh"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StandardsSubscriptions: {
                shape: "Sf"
              }
            }
          }
        },
        BatchGetAutomationRules: {
          http: {
            requestUri: "/automationrules/get"
          },
          input: {
            type: "structure",
            required: [
              "AutomationRulesArns"
            ],
            members: {
              AutomationRulesArns: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Rules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RuleArn: {},
                    RuleStatus: {},
                    RuleOrder: {
                      type: "integer"
                    },
                    RuleName: {},
                    Description: {},
                    IsTerminal: {
                      type: "boolean"
                    },
                    Criteria: {
                      shape: "Sw"
                    },
                    Actions: {
                      shape: "S1a"
                    },
                    CreatedAt: {
                      shape: "S1p"
                    },
                    UpdatedAt: {
                      shape: "S1p"
                    },
                    CreatedBy: {}
                  }
                }
              },
              UnprocessedAutomationRules: {
                shape: "S9"
              }
            }
          }
        },
        BatchGetConfigurationPolicyAssociations: {
          http: {
            requestUri: "/configurationPolicyAssociation/batchget"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationPolicyAssociationIdentifiers"
            ],
            members: {
              ConfigurationPolicyAssociationIdentifiers: {
                type: "list",
                member: {
                  shape: "S1s"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationPolicyAssociations: {
                type: "list",
                member: {
                  shape: "S1w"
                }
              },
              UnprocessedConfigurationPolicyAssociations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ConfigurationPolicyAssociationIdentifiers: {
                      shape: "S1s"
                    },
                    ErrorCode: {},
                    ErrorReason: {}
                  }
                }
              }
            }
          }
        },
        BatchGetSecurityControls: {
          http: {
            requestUri: "/securityControls/batchGet"
          },
          input: {
            type: "structure",
            required: [
              "SecurityControlIds"
            ],
            members: {
              SecurityControlIds: {
                shape: "S23"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "SecurityControls"
            ],
            members: {
              SecurityControls: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "SecurityControlId",
                    "SecurityControlArn",
                    "Title",
                    "Description",
                    "RemediationUrl",
                    "SeverityRating",
                    "SecurityControlStatus"
                  ],
                  members: {
                    SecurityControlId: {},
                    SecurityControlArn: {},
                    Title: {},
                    Description: {},
                    RemediationUrl: {},
                    SeverityRating: {},
                    SecurityControlStatus: {},
                    UpdateStatus: {},
                    Parameters: {
                      shape: "S2a"
                    },
                    LastUpdateReason: {}
                  }
                }
              },
              UnprocessedIds: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "SecurityControlId",
                    "ErrorCode"
                  ],
                  members: {
                    SecurityControlId: {},
                    ErrorCode: {},
                    ErrorReason: {}
                  }
                }
              }
            }
          }
        },
        BatchGetStandardsControlAssociations: {
          http: {
            requestUri: "/associations/batchGet"
          },
          input: {
            type: "structure",
            required: [
              "StandardsControlAssociationIds"
            ],
            members: {
              StandardsControlAssociationIds: {
                type: "list",
                member: {
                  shape: "S2l"
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "StandardsControlAssociationDetails"
            ],
            members: {
              StandardsControlAssociationDetails: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "StandardsArn",
                    "SecurityControlId",
                    "SecurityControlArn",
                    "AssociationStatus"
                  ],
                  members: {
                    StandardsArn: {},
                    SecurityControlId: {},
                    SecurityControlArn: {},
                    AssociationStatus: {},
                    RelatedRequirements: {
                      shape: "S2q"
                    },
                    UpdatedAt: {
                      shape: "S1p"
                    },
                    UpdatedReason: {},
                    StandardsControlTitle: {},
                    StandardsControlDescription: {},
                    StandardsControlArns: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              UnprocessedAssociations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "StandardsControlAssociationId",
                    "ErrorCode"
                  ],
                  members: {
                    StandardsControlAssociationId: {
                      shape: "S2l"
                    },
                    ErrorCode: {},
                    ErrorReason: {}
                  }
                }
              }
            }
          }
        },
        BatchImportFindings: {
          http: {
            requestUri: "/findings/import"
          },
          input: {
            type: "structure",
            required: [
              "Findings"
            ],
            members: {
              Findings: {
                type: "list",
                member: {
                  shape: "S2w"
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "FailedCount",
              "SuccessCount"
            ],
            members: {
              FailedCount: {
                type: "integer"
              },
              SuccessCount: {
                type: "integer"
              },
              FailedFindings: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Id",
                    "ErrorCode",
                    "ErrorMessage"
                  ],
                  members: {
                    Id: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        BatchUpdateAutomationRules: {
          http: {
            method: "PATCH",
            requestUri: "/automationrules/update"
          },
          input: {
            type: "structure",
            required: [
              "UpdateAutomationRulesRequestItems"
            ],
            members: {
              UpdateAutomationRulesRequestItems: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "RuleArn"
                  ],
                  members: {
                    RuleArn: {},
                    RuleStatus: {},
                    RuleOrder: {
                      type: "integer"
                    },
                    Description: {},
                    RuleName: {},
                    IsTerminal: {
                      type: "boolean"
                    },
                    Criteria: {
                      shape: "Sw"
                    },
                    Actions: {
                      shape: "S1a"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProcessedAutomationRules: {
                shape: "S7"
              },
              UnprocessedAutomationRules: {
                shape: "S9"
              }
            }
          }
        },
        BatchUpdateFindings: {
          http: {
            method: "PATCH",
            requestUri: "/findings/batchupdate"
          },
          input: {
            type: "structure",
            required: [
              "FindingIdentifiers"
            ],
            members: {
              FindingIdentifiers: {
                shape: "Spm"
              },
              Note: {
                shape: "S1e"
              },
              Severity: {
                shape: "S1f"
              },
              VerificationState: {},
              Confidence: {
                type: "integer"
              },
              Criticality: {
                type: "integer"
              },
              Types: {
                shape: "S1j"
              },
              UserDefinedFields: {
                shape: "S1k"
              },
              Workflow: {
                shape: "S1l"
              },
              RelatedFindings: {
                shape: "S1n"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ProcessedFindings",
              "UnprocessedFindings"
            ],
            members: {
              ProcessedFindings: {
                shape: "Spm"
              },
              UnprocessedFindings: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "FindingIdentifier",
                    "ErrorCode",
                    "ErrorMessage"
                  ],
                  members: {
                    FindingIdentifier: {
                      shape: "Spn"
                    },
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        BatchUpdateStandardsControlAssociations: {
          http: {
            method: "PATCH",
            requestUri: "/associations"
          },
          input: {
            type: "structure",
            required: [
              "StandardsControlAssociationUpdates"
            ],
            members: {
              StandardsControlAssociationUpdates: {
                type: "list",
                member: {
                  shape: "Spt"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UnprocessedAssociationUpdates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "StandardsControlAssociationUpdate",
                    "ErrorCode"
                  ],
                  members: {
                    StandardsControlAssociationUpdate: {
                      shape: "Spt"
                    },
                    ErrorCode: {},
                    ErrorReason: {}
                  }
                }
              }
            }
          }
        },
        CreateActionTarget: {
          http: {
            requestUri: "/actionTargets"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "Description",
              "Id"
            ],
            members: {
              Name: {},
              Description: {},
              Id: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ActionTargetArn"
            ],
            members: {
              ActionTargetArn: {}
            }
          }
        },
        CreateAutomationRule: {
          http: {
            requestUri: "/automationrules/create"
          },
          input: {
            type: "structure",
            required: [
              "RuleOrder",
              "RuleName",
              "Description",
              "Criteria",
              "Actions"
            ],
            members: {
              Tags: {
                shape: "Sq0"
              },
              RuleStatus: {},
              RuleOrder: {
                type: "integer"
              },
              RuleName: {},
              Description: {},
              IsTerminal: {
                type: "boolean"
              },
              Criteria: {
                shape: "Sw"
              },
              Actions: {
                shape: "S1a"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RuleArn: {}
            }
          }
        },
        CreateConfigurationPolicy: {
          http: {
            requestUri: "/configurationPolicy/create"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "ConfigurationPolicy"
            ],
            members: {
              Name: {},
              Description: {},
              ConfigurationPolicy: {
                shape: "Sq5"
              },
              Tags: {
                shape: "Sq0"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Id: {},
              Name: {},
              Description: {},
              UpdatedAt: {
                shape: "S1p"
              },
              CreatedAt: {
                shape: "S1p"
              },
              ConfigurationPolicy: {
                shape: "Sq5"
              }
            }
          }
        },
        CreateFindingAggregator: {
          http: {
            requestUri: "/findingAggregator/create"
          },
          input: {
            type: "structure",
            required: [
              "RegionLinkingMode"
            ],
            members: {
              RegionLinkingMode: {},
              Regions: {
                shape: "S23"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FindingAggregatorArn: {},
              FindingAggregationRegion: {},
              RegionLinkingMode: {},
              Regions: {
                shape: "S23"
              }
            }
          }
        },
        CreateInsight: {
          http: {
            requestUri: "/insights"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "Filters",
              "GroupByAttribute"
            ],
            members: {
              Name: {},
              Filters: {
                shape: "Sqh"
              },
              GroupByAttribute: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "InsightArn"
            ],
            members: {
              InsightArn: {}
            }
          }
        },
        CreateMembers: {
          http: {
            requestUri: "/members"
          },
          input: {
            type: "structure",
            required: [
              "AccountDetails"
            ],
            members: {
              AccountDetails: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AccountId"
                  ],
                  members: {
                    AccountId: {},
                    Email: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UnprocessedAccounts: {
                shape: "Squ"
              }
            }
          }
        },
        DeclineInvitations: {
          http: {
            requestUri: "/invitations/decline"
          },
          input: {
            type: "structure",
            required: [
              "AccountIds"
            ],
            members: {
              AccountIds: {
                shape: "Sqx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UnprocessedAccounts: {
                shape: "Squ"
              }
            }
          }
        },
        DeleteActionTarget: {
          http: {
            method: "DELETE",
            requestUri: "/actionTargets/{ActionTargetArn+}"
          },
          input: {
            type: "structure",
            required: [
              "ActionTargetArn"
            ],
            members: {
              ActionTargetArn: {
                location: "uri",
                locationName: "ActionTargetArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ActionTargetArn"
            ],
            members: {
              ActionTargetArn: {}
            }
          }
        },
        DeleteConfigurationPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/configurationPolicy/{Identifier}"
          },
          input: {
            type: "structure",
            required: [
              "Identifier"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "Identifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteFindingAggregator: {
          http: {
            method: "DELETE",
            requestUri: "/findingAggregator/delete/{FindingAggregatorArn+}"
          },
          input: {
            type: "structure",
            required: [
              "FindingAggregatorArn"
            ],
            members: {
              FindingAggregatorArn: {
                location: "uri",
                locationName: "FindingAggregatorArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteInsight: {
          http: {
            method: "DELETE",
            requestUri: "/insights/{InsightArn+}"
          },
          input: {
            type: "structure",
            required: [
              "InsightArn"
            ],
            members: {
              InsightArn: {
                location: "uri",
                locationName: "InsightArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "InsightArn"
            ],
            members: {
              InsightArn: {}
            }
          }
        },
        DeleteInvitations: {
          http: {
            requestUri: "/invitations/delete"
          },
          input: {
            type: "structure",
            required: [
              "AccountIds"
            ],
            members: {
              AccountIds: {
                shape: "Sqx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UnprocessedAccounts: {
                shape: "Squ"
              }
            }
          }
        },
        DeleteMembers: {
          http: {
            requestUri: "/members/delete"
          },
          input: {
            type: "structure",
            required: [
              "AccountIds"
            ],
            members: {
              AccountIds: {
                shape: "Sqx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UnprocessedAccounts: {
                shape: "Squ"
              }
            }
          }
        },
        DescribeActionTargets: {
          http: {
            requestUri: "/actionTargets/get"
          },
          input: {
            type: "structure",
            members: {
              ActionTargetArns: {
                shape: "Src"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ActionTargets"
            ],
            members: {
              ActionTargets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ActionTargetArn",
                    "Name",
                    "Description"
                  ],
                  members: {
                    ActionTargetArn: {},
                    Name: {},
                    Description: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeHub: {
          http: {
            method: "GET",
            requestUri: "/accounts"
          },
          input: {
            type: "structure",
            members: {
              HubArn: {
                location: "querystring",
                locationName: "HubArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HubArn: {},
              SubscribedAt: {},
              AutoEnableControls: {
                type: "boolean"
              },
              ControlFindingGenerator: {}
            }
          }
        },
        DescribeOrganizationConfiguration: {
          http: {
            method: "GET",
            requestUri: "/organization/configuration"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              AutoEnable: {
                type: "boolean"
              },
              MemberAccountLimitReached: {
                type: "boolean"
              },
              AutoEnableStandards: {},
              OrganizationConfiguration: {
                shape: "Sro"
              }
            }
          }
        },
        DescribeProducts: {
          http: {
            method: "GET",
            requestUri: "/products"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              ProductArn: {
                location: "querystring",
                locationName: "ProductArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Products"
            ],
            members: {
              Products: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ProductArn"
                  ],
                  members: {
                    ProductArn: {},
                    ProductName: {},
                    CompanyName: {},
                    Description: {},
                    Categories: {
                      type: "list",
                      member: {}
                    },
                    IntegrationTypes: {
                      type: "list",
                      member: {}
                    },
                    MarketplaceUrl: {},
                    ActivationUrl: {},
                    ProductSubscriptionResourcePolicy: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeStandards: {
          http: {
            method: "GET",
            requestUri: "/standards"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Standards: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StandardsArn: {},
                    Name: {},
                    Description: {},
                    EnabledByDefault: {
                      type: "boolean"
                    },
                    StandardsManagedBy: {
                      type: "structure",
                      members: {
                        Company: {},
                        Product: {}
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeStandardsControls: {
          http: {
            method: "GET",
            requestUri: "/standards/controls/{StandardsSubscriptionArn+}"
          },
          input: {
            type: "structure",
            required: [
              "StandardsSubscriptionArn"
            ],
            members: {
              StandardsSubscriptionArn: {
                location: "uri",
                locationName: "StandardsSubscriptionArn"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Controls: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StandardsControlArn: {},
                    ControlStatus: {},
                    DisabledReason: {},
                    ControlStatusUpdatedAt: {
                      shape: "S1p"
                    },
                    ControlId: {},
                    Title: {},
                    Description: {},
                    RemediationUrl: {},
                    SeverityRating: {},
                    RelatedRequirements: {
                      shape: "S2q"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DisableImportFindingsForProduct: {
          http: {
            method: "DELETE",
            requestUri: "/productSubscriptions/{ProductSubscriptionArn+}"
          },
          input: {
            type: "structure",
            required: [
              "ProductSubscriptionArn"
            ],
            members: {
              ProductSubscriptionArn: {
                location: "uri",
                locationName: "ProductSubscriptionArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisableOrganizationAdminAccount: {
          http: {
            requestUri: "/organization/admin/disable"
          },
          input: {
            type: "structure",
            required: [
              "AdminAccountId"
            ],
            members: {
              AdminAccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisableSecurityHub: {
          http: {
            method: "DELETE",
            requestUri: "/accounts"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateFromAdministratorAccount: {
          http: {
            requestUri: "/administrator/disassociate"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateFromMasterAccount: {
          http: {
            requestUri: "/master/disassociate"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "This API has been deprecated, use DisassociateFromAdministratorAccount API instead."
        },
        DisassociateMembers: {
          http: {
            requestUri: "/members/disassociate"
          },
          input: {
            type: "structure",
            required: [
              "AccountIds"
            ],
            members: {
              AccountIds: {
                shape: "Sqx"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        EnableImportFindingsForProduct: {
          http: {
            requestUri: "/productSubscriptions"
          },
          input: {
            type: "structure",
            required: [
              "ProductArn"
            ],
            members: {
              ProductArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProductSubscriptionArn: {}
            }
          }
        },
        EnableOrganizationAdminAccount: {
          http: {
            requestUri: "/organization/admin/enable"
          },
          input: {
            type: "structure",
            required: [
              "AdminAccountId"
            ],
            members: {
              AdminAccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        EnableSecurityHub: {
          http: {
            requestUri: "/accounts"
          },
          input: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sq0"
              },
              EnableDefaultStandards: {
                type: "boolean"
              },
              ControlFindingGenerator: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetAdministratorAccount: {
          http: {
            method: "GET",
            requestUri: "/administrator"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              Administrator: {
                shape: "Ssr"
              }
            }
          }
        },
        GetConfigurationPolicy: {
          http: {
            method: "GET",
            requestUri: "/configurationPolicy/get/{Identifier}"
          },
          input: {
            type: "structure",
            required: [
              "Identifier"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "Identifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Id: {},
              Name: {},
              Description: {},
              UpdatedAt: {
                shape: "S1p"
              },
              CreatedAt: {
                shape: "S1p"
              },
              ConfigurationPolicy: {
                shape: "Sq5"
              }
            }
          }
        },
        GetConfigurationPolicyAssociation: {
          http: {
            requestUri: "/configurationPolicyAssociation/get"
          },
          input: {
            type: "structure",
            required: [
              "Target"
            ],
            members: {
              Target: {
                shape: "S1t"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationPolicyId: {},
              TargetId: {},
              TargetType: {},
              AssociationType: {},
              UpdatedAt: {
                shape: "S1p"
              },
              AssociationStatus: {},
              AssociationStatusMessage: {}
            }
          }
        },
        GetEnabledStandards: {
          http: {
            requestUri: "/standards/get"
          },
          input: {
            type: "structure",
            members: {
              StandardsSubscriptionArns: {
                shape: "Sd"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StandardsSubscriptions: {
                shape: "Sf"
              },
              NextToken: {}
            }
          }
        },
        GetFindingAggregator: {
          http: {
            method: "GET",
            requestUri: "/findingAggregator/get/{FindingAggregatorArn+}"
          },
          input: {
            type: "structure",
            required: [
              "FindingAggregatorArn"
            ],
            members: {
              FindingAggregatorArn: {
                location: "uri",
                locationName: "FindingAggregatorArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FindingAggregatorArn: {},
              FindingAggregationRegion: {},
              RegionLinkingMode: {},
              Regions: {
                shape: "S23"
              }
            }
          }
        },
        GetFindingHistory: {
          http: {
            requestUri: "/findingHistory/get"
          },
          input: {
            type: "structure",
            required: [
              "FindingIdentifier"
            ],
            members: {
              FindingIdentifier: {
                shape: "Spn"
              },
              StartTime: {
                shape: "S1p"
              },
              EndTime: {
                shape: "S1p"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Records: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FindingIdentifier: {
                      shape: "Spn"
                    },
                    UpdateTime: {
                      shape: "S1p"
                    },
                    FindingCreated: {
                      type: "boolean"
                    },
                    UpdateSource: {
                      type: "structure",
                      members: {
                        Type: {},
                        Identity: {}
                      }
                    },
                    Updates: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          UpdatedField: {},
                          OldValue: {},
                          NewValue: {}
                        }
                      }
                    },
                    NextToken: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetFindings: {
          http: {
            requestUri: "/findings"
          },
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Sqh"
              },
              SortCriteria: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Field: {},
                    SortOrder: {}
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Findings"
            ],
            members: {
              Findings: {
                type: "list",
                member: {
                  shape: "S2w"
                }
              },
              NextToken: {}
            }
          }
        },
        GetInsightResults: {
          http: {
            method: "GET",
            requestUri: "/insights/results/{InsightArn+}"
          },
          input: {
            type: "structure",
            required: [
              "InsightArn"
            ],
            members: {
              InsightArn: {
                location: "uri",
                locationName: "InsightArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "InsightResults"
            ],
            members: {
              InsightResults: {
                type: "structure",
                required: [
                  "InsightArn",
                  "GroupByAttribute",
                  "ResultValues"
                ],
                members: {
                  InsightArn: {},
                  GroupByAttribute: {},
                  ResultValues: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "GroupByAttributeValue",
                        "Count"
                      ],
                      members: {
                        GroupByAttributeValue: {},
                        Count: {
                          type: "integer"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetInsights: {
          http: {
            requestUri: "/insights/get"
          },
          input: {
            type: "structure",
            members: {
              InsightArns: {
                shape: "Src"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Insights"
            ],
            members: {
              Insights: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "InsightArn",
                    "Name",
                    "Filters",
                    "GroupByAttribute"
                  ],
                  members: {
                    InsightArn: {},
                    Name: {},
                    Filters: {
                      shape: "Sqh"
                    },
                    GroupByAttribute: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetInvitationsCount: {
          http: {
            method: "GET",
            requestUri: "/invitations/count"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              InvitationsCount: {
                type: "integer"
              }
            }
          }
        },
        GetMasterAccount: {
          http: {
            method: "GET",
            requestUri: "/master"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              Master: {
                shape: "Ssr"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "This API has been deprecated, use GetAdministratorAccount API instead."
        },
        GetMembers: {
          http: {
            requestUri: "/members/get"
          },
          input: {
            type: "structure",
            required: [
              "AccountIds"
            ],
            members: {
              AccountIds: {
                shape: "Sqx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Members: {
                shape: "Stt"
              },
              UnprocessedAccounts: {
                shape: "Squ"
              }
            }
          }
        },
        GetSecurityControlDefinition: {
          http: {
            method: "GET",
            requestUri: "/securityControl/definition"
          },
          input: {
            type: "structure",
            required: [
              "SecurityControlId"
            ],
            members: {
              SecurityControlId: {
                location: "querystring",
                locationName: "SecurityControlId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "SecurityControlDefinition"
            ],
            members: {
              SecurityControlDefinition: {
                shape: "Stx"
              }
            }
          }
        },
        InviteMembers: {
          http: {
            requestUri: "/members/invite"
          },
          input: {
            type: "structure",
            required: [
              "AccountIds"
            ],
            members: {
              AccountIds: {
                shape: "Sqx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UnprocessedAccounts: {
                shape: "Squ"
              }
            }
          }
        },
        ListAutomationRules: {
          http: {
            method: "GET",
            requestUri: "/automationrules/list"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AutomationRulesMetadata: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RuleArn: {},
                    RuleStatus: {},
                    RuleOrder: {
                      type: "integer"
                    },
                    RuleName: {},
                    Description: {},
                    IsTerminal: {
                      type: "boolean"
                    },
                    CreatedAt: {
                      shape: "S1p"
                    },
                    UpdatedAt: {
                      shape: "S1p"
                    },
                    CreatedBy: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListConfigurationPolicies: {
          http: {
            method: "GET",
            requestUri: "/configurationPolicy/list"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationPolicySummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Id: {},
                    Name: {},
                    Description: {},
                    UpdatedAt: {
                      shape: "S1p"
                    },
                    ServiceEnabled: {
                      type: "boolean"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListConfigurationPolicyAssociations: {
          http: {
            requestUri: "/configurationPolicyAssociation/list"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                type: "structure",
                members: {
                  ConfigurationPolicyId: {},
                  AssociationType: {},
                  AssociationStatus: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationPolicyAssociationSummaries: {
                type: "list",
                member: {
                  shape: "S1w"
                }
              },
              NextToken: {}
            }
          }
        },
        ListEnabledProductsForImport: {
          http: {
            method: "GET",
            requestUri: "/productSubscriptions"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProductSubscriptions: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListFindingAggregators: {
          http: {
            method: "GET",
            requestUri: "/findingAggregator/list"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FindingAggregators: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FindingAggregatorArn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListInvitations: {
          http: {
            method: "GET",
            requestUri: "/invitations"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Invitations: {
                type: "list",
                member: {
                  shape: "Ssr"
                }
              },
              NextToken: {}
            }
          }
        },
        ListMembers: {
          http: {
            method: "GET",
            requestUri: "/members"
          },
          input: {
            type: "structure",
            members: {
              OnlyAssociated: {
                location: "querystring",
                locationName: "OnlyAssociated",
                type: "boolean"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Members: {
                shape: "Stt"
              },
              NextToken: {}
            }
          }
        },
        ListOrganizationAdminAccounts: {
          http: {
            method: "GET",
            requestUri: "/organization/admin"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AdminAccounts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AccountId: {},
                    Status: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSecurityControlDefinitions: {
          http: {
            method: "GET",
            requestUri: "/securityControls/definitions"
          },
          input: {
            type: "structure",
            members: {
              StandardsArn: {
                location: "querystring",
                locationName: "StandardsArn"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "SecurityControlDefinitions"
            ],
            members: {
              SecurityControlDefinitions: {
                type: "list",
                member: {
                  shape: "Stx"
                }
              },
              NextToken: {}
            }
          }
        },
        ListStandardsControlAssociations: {
          http: {
            method: "GET",
            requestUri: "/associations"
          },
          input: {
            type: "structure",
            required: [
              "SecurityControlId"
            ],
            members: {
              SecurityControlId: {
                location: "querystring",
                locationName: "SecurityControlId"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "StandardsControlAssociationSummaries"
            ],
            members: {
              StandardsControlAssociationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "StandardsArn",
                    "SecurityControlId",
                    "SecurityControlArn",
                    "AssociationStatus"
                  ],
                  members: {
                    StandardsArn: {},
                    SecurityControlId: {},
                    SecurityControlArn: {},
                    AssociationStatus: {},
                    RelatedRequirements: {
                      shape: "S2q"
                    },
                    UpdatedAt: {
                      shape: "S1p"
                    },
                    UpdatedReason: {},
                    StandardsControlTitle: {},
                    StandardsControlDescription: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{ResourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sq0"
              }
            }
          }
        },
        StartConfigurationPolicyAssociation: {
          http: {
            requestUri: "/configurationPolicyAssociation/associate"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationPolicyIdentifier",
              "Target"
            ],
            members: {
              ConfigurationPolicyIdentifier: {},
              Target: {
                shape: "S1t"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationPolicyId: {},
              TargetId: {},
              TargetType: {},
              AssociationType: {},
              UpdatedAt: {
                shape: "S1p"
              },
              AssociationStatus: {},
              AssociationStatusMessage: {}
            }
          }
        },
        StartConfigurationPolicyDisassociation: {
          http: {
            requestUri: "/configurationPolicyAssociation/disassociate"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationPolicyIdentifier"
            ],
            members: {
              Target: {
                shape: "S1t"
              },
              ConfigurationPolicyIdentifier: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{ResourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "Sq0"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{ResourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateActionTarget: {
          http: {
            method: "PATCH",
            requestUri: "/actionTargets/{ActionTargetArn+}"
          },
          input: {
            type: "structure",
            required: [
              "ActionTargetArn"
            ],
            members: {
              ActionTargetArn: {
                location: "uri",
                locationName: "ActionTargetArn"
              },
              Name: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateConfigurationPolicy: {
          http: {
            method: "PATCH",
            requestUri: "/configurationPolicy/{Identifier}"
          },
          input: {
            type: "structure",
            required: [
              "Identifier"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "Identifier"
              },
              Name: {},
              Description: {},
              UpdatedReason: {},
              ConfigurationPolicy: {
                shape: "Sq5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Id: {},
              Name: {},
              Description: {},
              UpdatedAt: {
                shape: "S1p"
              },
              CreatedAt: {
                shape: "S1p"
              },
              ConfigurationPolicy: {
                shape: "Sq5"
              }
            }
          }
        },
        UpdateFindingAggregator: {
          http: {
            method: "PATCH",
            requestUri: "/findingAggregator/update"
          },
          input: {
            type: "structure",
            required: [
              "FindingAggregatorArn",
              "RegionLinkingMode"
            ],
            members: {
              FindingAggregatorArn: {},
              RegionLinkingMode: {},
              Regions: {
                shape: "S23"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FindingAggregatorArn: {},
              FindingAggregationRegion: {},
              RegionLinkingMode: {},
              Regions: {
                shape: "S23"
              }
            }
          }
        },
        UpdateFindings: {
          http: {
            method: "PATCH",
            requestUri: "/findings"
          },
          input: {
            type: "structure",
            required: [
              "Filters"
            ],
            members: {
              Filters: {
                shape: "Sqh"
              },
              Note: {
                shape: "S1e"
              },
              RecordState: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateInsight: {
          http: {
            method: "PATCH",
            requestUri: "/insights/{InsightArn+}"
          },
          input: {
            type: "structure",
            required: [
              "InsightArn"
            ],
            members: {
              InsightArn: {
                location: "uri",
                locationName: "InsightArn"
              },
              Name: {},
              Filters: {
                shape: "Sqh"
              },
              GroupByAttribute: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateOrganizationConfiguration: {
          http: {
            requestUri: "/organization/configuration"
          },
          input: {
            type: "structure",
            required: [
              "AutoEnable"
            ],
            members: {
              AutoEnable: {
                type: "boolean"
              },
              AutoEnableStandards: {},
              OrganizationConfiguration: {
                shape: "Sro"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateSecurityControl: {
          http: {
            method: "PATCH",
            requestUri: "/securityControl/update"
          },
          input: {
            type: "structure",
            required: [
              "SecurityControlId",
              "Parameters"
            ],
            members: {
              SecurityControlId: {},
              Parameters: {
                shape: "S2a"
              },
              LastUpdateReason: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateSecurityHubConfiguration: {
          http: {
            method: "PATCH",
            requestUri: "/accounts"
          },
          input: {
            type: "structure",
            members: {
              AutoEnableControls: {
                type: "boolean"
              },
              ControlFindingGenerator: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateStandardsControl: {
          http: {
            method: "PATCH",
            requestUri: "/standards/control/{StandardsControlArn+}"
          },
          input: {
            type: "structure",
            required: [
              "StandardsControlArn"
            ],
            members: {
              StandardsControlArn: {
                location: "uri",
                locationName: "StandardsControlArn"
              },
              ControlStatus: {},
              DisabledReason: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S7: {
          type: "list",
          member: {}
        },
        S9: {
          type: "list",
          member: {
            type: "structure",
            members: {
              RuleArn: {},
              ErrorCode: {
                type: "integer"
              },
              ErrorMessage: {}
            }
          }
        },
        Sd: {
          type: "list",
          member: {}
        },
        Sf: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "StandardsSubscriptionArn",
              "StandardsArn",
              "StandardsInput",
              "StandardsStatus"
            ],
            members: {
              StandardsSubscriptionArn: {},
              StandardsArn: {},
              StandardsInput: {
                shape: "Sh"
              },
              StandardsStatus: {},
              StandardsStatusReason: {
                type: "structure",
                required: [
                  "StatusReasonCode"
                ],
                members: {
                  StatusReasonCode: {}
                }
              }
            }
          }
        },
        Sh: {
          type: "map",
          key: {},
          value: {}
        },
        Sw: {
          type: "structure",
          members: {
            ProductArn: {
              shape: "Sx"
            },
            AwsAccountId: {
              shape: "Sx"
            },
            Id: {
              shape: "Sx"
            },
            GeneratorId: {
              shape: "Sx"
            },
            Type: {
              shape: "Sx"
            },
            FirstObservedAt: {
              shape: "S10"
            },
            LastObservedAt: {
              shape: "S10"
            },
            CreatedAt: {
              shape: "S10"
            },
            UpdatedAt: {
              shape: "S10"
            },
            Confidence: {
              shape: "S14"
            },
            Criticality: {
              shape: "S14"
            },
            Title: {
              shape: "Sx"
            },
            Description: {
              shape: "Sx"
            },
            SourceUrl: {
              shape: "Sx"
            },
            ProductName: {
              shape: "Sx"
            },
            CompanyName: {
              shape: "Sx"
            },
            SeverityLabel: {
              shape: "Sx"
            },
            ResourceType: {
              shape: "Sx"
            },
            ResourceId: {
              shape: "Sx"
            },
            ResourcePartition: {
              shape: "Sx"
            },
            ResourceRegion: {
              shape: "Sx"
            },
            ResourceTags: {
              shape: "S17"
            },
            ResourceDetailsOther: {
              shape: "S17"
            },
            ComplianceStatus: {
              shape: "Sx"
            },
            ComplianceSecurityControlId: {
              shape: "Sx"
            },
            ComplianceAssociatedStandardsId: {
              shape: "Sx"
            },
            VerificationState: {
              shape: "Sx"
            },
            WorkflowStatus: {
              shape: "Sx"
            },
            RecordState: {
              shape: "Sx"
            },
            RelatedFindingsProductArn: {
              shape: "Sx"
            },
            RelatedFindingsId: {
              shape: "Sx"
            },
            NoteText: {
              shape: "Sx"
            },
            NoteUpdatedAt: {
              shape: "S10"
            },
            NoteUpdatedBy: {
              shape: "Sx"
            },
            UserDefinedFields: {
              shape: "S17"
            },
            ResourceApplicationArn: {
              shape: "Sx"
            },
            ResourceApplicationName: {
              shape: "Sx"
            },
            AwsAccountName: {
              shape: "Sx"
            }
          }
        },
        Sx: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Value: {},
              Comparison: {}
            }
          }
        },
        S10: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Start: {},
              End: {},
              DateRange: {
                type: "structure",
                members: {
                  Value: {
                    type: "integer"
                  },
                  Unit: {}
                }
              }
            }
          }
        },
        S14: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Gte: {
                type: "double"
              },
              Lte: {
                type: "double"
              },
              Eq: {
                type: "double"
              },
              Gt: {
                type: "double"
              },
              Lt: {
                type: "double"
              }
            }
          }
        },
        S17: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {},
              Comparison: {}
            }
          }
        },
        S1a: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Type: {},
              FindingFieldsUpdate: {
                type: "structure",
                members: {
                  Note: {
                    shape: "S1e"
                  },
                  Severity: {
                    shape: "S1f"
                  },
                  VerificationState: {},
                  Confidence: {
                    type: "integer"
                  },
                  Criticality: {
                    type: "integer"
                  },
                  Types: {
                    shape: "S1j"
                  },
                  UserDefinedFields: {
                    shape: "S1k"
                  },
                  Workflow: {
                    shape: "S1l"
                  },
                  RelatedFindings: {
                    shape: "S1n"
                  }
                }
              }
            }
          }
        },
        S1e: {
          type: "structure",
          required: [
            "Text",
            "UpdatedBy"
          ],
          members: {
            Text: {},
            UpdatedBy: {}
          }
        },
        S1f: {
          type: "structure",
          members: {
            Normalized: {
              type: "integer"
            },
            Product: {
              type: "double"
            },
            Label: {}
          }
        },
        S1j: {
          type: "list",
          member: {}
        },
        S1k: {
          type: "map",
          key: {},
          value: {}
        },
        S1l: {
          type: "structure",
          members: {
            Status: {}
          }
        },
        S1n: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ProductArn",
              "Id"
            ],
            members: {
              ProductArn: {},
              Id: {}
            }
          }
        },
        S1p: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S1s: {
          type: "structure",
          members: {
            Target: {
              shape: "S1t"
            }
          }
        },
        S1t: {
          type: "structure",
          members: {
            AccountId: {},
            OrganizationalUnitId: {},
            RootId: {}
          },
          union: true
        },
        S1w: {
          type: "structure",
          members: {
            ConfigurationPolicyId: {},
            TargetId: {},
            TargetType: {},
            AssociationType: {},
            UpdatedAt: {
              shape: "S1p"
            },
            AssociationStatus: {},
            AssociationStatusMessage: {}
          }
        },
        S23: {
          type: "list",
          member: {}
        },
        S2a: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "ValueType"
            ],
            members: {
              ValueType: {},
              Value: {
                type: "structure",
                members: {
                  Integer: {
                    type: "integer"
                  },
                  IntegerList: {
                    shape: "S2e"
                  },
                  Double: {
                    type: "double"
                  },
                  String: {},
                  StringList: {
                    shape: "S23"
                  },
                  Boolean: {
                    type: "boolean"
                  },
                  Enum: {},
                  EnumList: {
                    shape: "S23"
                  }
                },
                union: true
              }
            }
          }
        },
        S2e: {
          type: "list",
          member: {
            type: "integer"
          }
        },
        S2l: {
          type: "structure",
          required: [
            "SecurityControlId",
            "StandardsArn"
          ],
          members: {
            SecurityControlId: {},
            StandardsArn: {}
          }
        },
        S2q: {
          type: "list",
          member: {}
        },
        S2w: {
          type: "structure",
          required: [
            "SchemaVersion",
            "Id",
            "ProductArn",
            "GeneratorId",
            "AwsAccountId",
            "CreatedAt",
            "UpdatedAt",
            "Title",
            "Description",
            "Resources"
          ],
          members: {
            SchemaVersion: {},
            Id: {},
            ProductArn: {},
            ProductName: {},
            CompanyName: {},
            Region: {},
            GeneratorId: {},
            AwsAccountId: {},
            Types: {
              shape: "S1j"
            },
            FirstObservedAt: {},
            LastObservedAt: {},
            CreatedAt: {},
            UpdatedAt: {},
            Severity: {
              type: "structure",
              members: {
                Product: {
                  type: "double"
                },
                Label: {},
                Normalized: {
                  type: "integer"
                },
                Original: {}
              }
            },
            Confidence: {
              type: "integer"
            },
            Criticality: {
              type: "integer"
            },
            Title: {},
            Description: {},
            Remediation: {
              type: "structure",
              members: {
                Recommendation: {
                  type: "structure",
                  members: {
                    Text: {},
                    Url: {}
                  }
                }
              }
            },
            SourceUrl: {},
            ProductFields: {
              shape: "S1k"
            },
            UserDefinedFields: {
              shape: "S1k"
            },
            Malware: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name"
                ],
                members: {
                  Name: {},
                  Type: {},
                  Path: {},
                  State: {}
                }
              }
            },
            Network: {
              type: "structure",
              members: {
                Direction: {},
                Protocol: {},
                OpenPortRange: {
                  shape: "S36"
                },
                SourceIpV4: {},
                SourceIpV6: {},
                SourcePort: {
                  type: "integer"
                },
                SourceDomain: {},
                SourceMac: {},
                DestinationIpV4: {},
                DestinationIpV6: {},
                DestinationPort: {
                  type: "integer"
                },
                DestinationDomain: {}
              }
            },
            NetworkPath: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  ComponentId: {},
                  ComponentType: {},
                  Egress: {
                    shape: "S39"
                  },
                  Ingress: {
                    shape: "S39"
                  }
                }
              }
            },
            Process: {
              type: "structure",
              members: {
                Name: {},
                Path: {},
                Pid: {
                  type: "integer"
                },
                ParentPid: {
                  type: "integer"
                },
                LaunchedAt: {},
                TerminatedAt: {}
              }
            },
            Threats: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Name: {},
                  Severity: {},
                  ItemCount: {
                    type: "integer"
                  },
                  FilePaths: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        FilePath: {},
                        FileName: {},
                        ResourceId: {},
                        Hash: {}
                      }
                    }
                  }
                }
              }
            },
            ThreatIntelIndicators: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Type: {},
                  Value: {},
                  Category: {},
                  LastObservedAt: {},
                  Source: {},
                  SourceUrl: {}
                }
              }
            },
            Resources: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Type",
                  "Id"
                ],
                members: {
                  Type: {},
                  Id: {},
                  Partition: {},
                  Region: {},
                  ResourceRole: {},
                  Tags: {
                    shape: "S1k"
                  },
                  DataClassification: {
                    type: "structure",
                    members: {
                      DetailedResultsLocation: {},
                      Result: {
                        type: "structure",
                        members: {
                          MimeType: {},
                          SizeClassified: {
                            type: "long"
                          },
                          AdditionalOccurrences: {
                            type: "boolean"
                          },
                          Status: {
                            type: "structure",
                            members: {
                              Code: {},
                              Reason: {}
                            }
                          },
                          SensitiveData: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Category: {},
                                Detections: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      Count: {
                                        type: "long"
                                      },
                                      Type: {},
                                      Occurrences: {
                                        shape: "S3w"
                                      }
                                    }
                                  }
                                },
                                TotalCount: {
                                  type: "long"
                                }
                              }
                            }
                          },
                          CustomDataIdentifiers: {
                            type: "structure",
                            members: {
                              Detections: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    Count: {
                                      type: "long"
                                    },
                                    Arn: {},
                                    Name: {},
                                    Occurrences: {
                                      shape: "S3w"
                                    }
                                  }
                                }
                              },
                              TotalCount: {
                                type: "long"
                              }
                            }
                          }
                        }
                      }
                    }
                  },
                  Details: {
                    type: "structure",
                    members: {
                      AwsAutoScalingAutoScalingGroup: {
                        type: "structure",
                        members: {
                          LaunchConfigurationName: {},
                          LoadBalancerNames: {
                            shape: "S23"
                          },
                          HealthCheckType: {},
                          HealthCheckGracePeriod: {
                            type: "integer"
                          },
                          CreatedTime: {},
                          MixedInstancesPolicy: {
                            type: "structure",
                            members: {
                              InstancesDistribution: {
                                type: "structure",
                                members: {
                                  OnDemandAllocationStrategy: {},
                                  OnDemandBaseCapacity: {
                                    type: "integer"
                                  },
                                  OnDemandPercentageAboveBaseCapacity: {
                                    type: "integer"
                                  },
                                  SpotAllocationStrategy: {},
                                  SpotInstancePools: {
                                    type: "integer"
                                  },
                                  SpotMaxPrice: {}
                                }
                              },
                              LaunchTemplate: {
                                type: "structure",
                                members: {
                                  LaunchTemplateSpecification: {
                                    type: "structure",
                                    members: {
                                      LaunchTemplateId: {},
                                      LaunchTemplateName: {},
                                      Version: {}
                                    }
                                  },
                                  Overrides: {
                                    type: "list",
                                    member: {
                                      type: "structure",
                                      members: {
                                        InstanceType: {},
                                        WeightedCapacity: {}
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          },
                          AvailabilityZones: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Value: {}
                              }
                            }
                          },
                          LaunchTemplate: {
                            type: "structure",
                            members: {
                              LaunchTemplateId: {},
                              LaunchTemplateName: {},
                              Version: {}
                            }
                          },
                          CapacityRebalance: {
                            type: "boolean"
                          }
                        }
                      },
                      AwsCodeBuildProject: {
                        type: "structure",
                        members: {
                          EncryptionKey: {},
                          Artifacts: {
                            shape: "S4k"
                          },
                          Environment: {
                            type: "structure",
                            members: {
                              Certificate: {},
                              EnvironmentVariables: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    Name: {},
                                    Type: {},
                                    Value: {}
                                  }
                                }
                              },
                              PrivilegedMode: {
                                type: "boolean"
                              },
                              ImagePullCredentialsType: {},
                              RegistryCredential: {
                                type: "structure",
                                members: {
                                  Credential: {},
                                  CredentialProvider: {}
                                }
                              },
                              Type: {}
                            }
                          },
                          Name: {},
                          Source: {
                            type: "structure",
                            members: {
                              Type: {},
                              Location: {},
                              GitCloneDepth: {
                                type: "integer"
                              },
                              InsecureSsl: {
                                type: "boolean"
                              }
                            }
                          },
                          ServiceRole: {},
                          LogsConfig: {
                            type: "structure",
                            members: {
                              CloudWatchLogs: {
                                type: "structure",
                                members: {
                                  GroupName: {},
                                  Status: {},
                                  StreamName: {}
                                }
                              },
                              S3Logs: {
                                type: "structure",
                                members: {
                                  EncryptionDisabled: {
                                    type: "boolean"
                                  },
                                  Location: {},
                                  Status: {}
                                }
                              }
                            }
                          },
                          VpcConfig: {
                            type: "structure",
                            members: {
                              VpcId: {},
                              Subnets: {
                                shape: "S4v"
                              },
                              SecurityGroupIds: {
                                shape: "S4v"
                              }
                            }
                          },
                          SecondaryArtifacts: {
                            shape: "S4k"
                          }
                        }
                      },
                      AwsCloudFrontDistribution: {
                        type: "structure",
                        members: {
                          CacheBehaviors: {
                            type: "structure",
                            members: {
                              Items: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    ViewerProtocolPolicy: {}
                                  }
                                }
                              }
                            }
                          },
                          DefaultCacheBehavior: {
                            type: "structure",
                            members: {
                              ViewerProtocolPolicy: {}
                            }
                          },
                          DefaultRootObject: {},
                          DomainName: {},
                          ETag: {},
                          LastModifiedTime: {},
                          Logging: {
                            type: "structure",
                            members: {
                              Bucket: {},
                              Enabled: {
                                type: "boolean"
                              },
                              IncludeCookies: {
                                type: "boolean"
                              },
                              Prefix: {}
                            }
                          },
                          Origins: {
                            type: "structure",
                            members: {
                              Items: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    DomainName: {},
                                    Id: {},
                                    OriginPath: {},
                                    S3OriginConfig: {
                                      type: "structure",
                                      members: {
                                        OriginAccessIdentity: {}
                                      }
                                    },
                                    CustomOriginConfig: {
                                      type: "structure",
                                      members: {
                                        HttpPort: {
                                          type: "integer"
                                        },
                                        HttpsPort: {
                                          type: "integer"
                                        },
                                        OriginKeepaliveTimeout: {
                                          type: "integer"
                                        },
                                        OriginProtocolPolicy: {},
                                        OriginReadTimeout: {
                                          type: "integer"
                                        },
                                        OriginSslProtocols: {
                                          type: "structure",
                                          members: {
                                            Items: {
                                              shape: "S4v"
                                            },
                                            Quantity: {
                                              type: "integer"
                                            }
                                          }
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          },
                          OriginGroups: {
                            type: "structure",
                            members: {
                              Items: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    FailoverCriteria: {
                                      type: "structure",
                                      members: {
                                        StatusCodes: {
                                          type: "structure",
                                          members: {
                                            Items: {
                                              type: "list",
                                              member: {
                                                type: "integer"
                                              }
                                            },
                                            Quantity: {
                                              type: "integer"
                                            }
                                          }
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          },
                          ViewerCertificate: {
                            type: "structure",
                            members: {
                              AcmCertificateArn: {},
                              Certificate: {},
                              CertificateSource: {},
                              CloudFrontDefaultCertificate: {
                                type: "boolean"
                              },
                              IamCertificateId: {},
                              MinimumProtocolVersion: {},
                              SslSupportMethod: {}
                            }
                          },
                          Status: {},
                          WebAclId: {}
                        }
                      },
                      AwsEc2Instance: {
                        type: "structure",
                        members: {
                          Type: {},
                          ImageId: {},
                          IpV4Addresses: {
                            shape: "S23"
                          },
                          IpV6Addresses: {
                            shape: "S23"
                          },
                          KeyName: {},
                          IamInstanceProfileArn: {},
                          VpcId: {},
                          SubnetId: {},
                          LaunchedAt: {},
                          NetworkInterfaces: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                NetworkInterfaceId: {}
                              }
                            }
                          },
                          VirtualizationType: {},
                          MetadataOptions: {
                            type: "structure",
                            members: {
                              HttpEndpoint: {},
                              HttpProtocolIpv6: {},
                              HttpPutResponseHopLimit: {
                                type: "integer"
                              },
                              HttpTokens: {},
                              InstanceMetadataTags: {}
                            }
                          },
                          Monitoring: {
                            type: "structure",
                            members: {
                              State: {}
                            }
                          }
                        }
                      },
                      AwsEc2NetworkInterface: {
                        type: "structure",
                        members: {
                          Attachment: {
                            type: "structure",
                            members: {
                              AttachTime: {},
                              AttachmentId: {},
                              DeleteOnTermination: {
                                type: "boolean"
                              },
                              DeviceIndex: {
                                type: "integer"
                              },
                              InstanceId: {},
                              InstanceOwnerId: {},
                              Status: {}
                            }
                          },
                          NetworkInterfaceId: {},
                          SecurityGroups: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                GroupName: {},
                                GroupId: {}
                              }
                            }
                          },
                          SourceDestCheck: {
                            type: "boolean"
                          },
                          IpV6Addresses: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                IpV6Address: {}
                              }
                            }
                          },
                          PrivateIpAddresses: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                PrivateIpAddress: {},
                                PrivateDnsName: {}
                              }
                            }
                          },
                          PublicDnsName: {},
                          PublicIp: {}
                        }
                      },
                      AwsEc2SecurityGroup: {
                        type: "structure",
                        members: {
                          GroupName: {},
                          GroupId: {},
                          OwnerId: {},
                          VpcId: {},
                          IpPermissions: {
                            shape: "S5t"
                          },
                          IpPermissionsEgress: {
                            shape: "S5t"
                          }
                        }
                      },
                      AwsEc2Volume: {
                        type: "structure",
                        members: {
                          CreateTime: {},
                          DeviceName: {},
                          Encrypted: {
                            type: "boolean"
                          },
                          Size: {
                            type: "integer"
                          },
                          SnapshotId: {},
                          Status: {},
                          KmsKeyId: {},
                          Attachments: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                AttachTime: {},
                                DeleteOnTermination: {
                                  type: "boolean"
                                },
                                InstanceId: {},
                                Status: {}
                              }
                            }
                          },
                          VolumeId: {},
                          VolumeType: {},
                          VolumeScanStatus: {}
                        }
                      },
                      AwsEc2Vpc: {
                        type: "structure",
                        members: {
                          CidrBlockAssociationSet: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                AssociationId: {},
                                CidrBlock: {},
                                CidrBlockState: {}
                              }
                            }
                          },
                          Ipv6CidrBlockAssociationSet: {
                            shape: "S69"
                          },
                          DhcpOptionsId: {},
                          State: {}
                        }
                      },
                      AwsEc2Eip: {
                        type: "structure",
                        members: {
                          InstanceId: {},
                          PublicIp: {},
                          AllocationId: {},
                          AssociationId: {},
                          Domain: {},
                          PublicIpv4Pool: {},
                          NetworkBorderGroup: {},
                          NetworkInterfaceId: {},
                          NetworkInterfaceOwnerId: {},
                          PrivateIpAddress: {}
                        }
                      },
                      AwsEc2Subnet: {
                        type: "structure",
                        members: {
                          AssignIpv6AddressOnCreation: {
                            type: "boolean"
                          },
                          AvailabilityZone: {},
                          AvailabilityZoneId: {},
                          AvailableIpAddressCount: {
                            type: "integer"
                          },
                          CidrBlock: {},
                          DefaultForAz: {
                            type: "boolean"
                          },
                          MapPublicIpOnLaunch: {
                            type: "boolean"
                          },
                          OwnerId: {},
                          State: {},
                          SubnetArn: {},
                          SubnetId: {},
                          VpcId: {},
                          Ipv6CidrBlockAssociationSet: {
                            shape: "S69"
                          }
                        }
                      },
                      AwsEc2NetworkAcl: {
                        type: "structure",
                        members: {
                          IsDefault: {
                            type: "boolean"
                          },
                          NetworkAclId: {},
                          OwnerId: {},
                          VpcId: {},
                          Associations: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                NetworkAclAssociationId: {},
                                NetworkAclId: {},
                                SubnetId: {}
                              }
                            }
                          },
                          Entries: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                CidrBlock: {},
                                Egress: {
                                  type: "boolean"
                                },
                                IcmpTypeCode: {
                                  type: "structure",
                                  members: {
                                    Code: {
                                      type: "integer"
                                    },
                                    Type: {
                                      type: "integer"
                                    }
                                  }
                                },
                                Ipv6CidrBlock: {},
                                PortRange: {
                                  type: "structure",
                                  members: {
                                    From: {
                                      type: "integer"
                                    },
                                    To: {
                                      type: "integer"
                                    }
                                  }
                                },
                                Protocol: {},
                                RuleAction: {},
                                RuleNumber: {
                                  type: "integer"
                                }
                              }
                            }
                          }
                        }
                      },
                      AwsElbv2LoadBalancer: {
                        type: "structure",
                        members: {
                          AvailabilityZones: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                ZoneName: {},
                                SubnetId: {}
                              }
                            }
                          },
                          CanonicalHostedZoneId: {},
                          CreatedTime: {},
                          DNSName: {},
                          IpAddressType: {},
                          Scheme: {},
                          SecurityGroups: {
                            type: "list",
                            member: {}
                          },
                          State: {
                            type: "structure",
                            members: {
                              Code: {},
                              Reason: {}
                            }
                          },
                          Type: {},
                          VpcId: {},
                          LoadBalancerAttributes: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Key: {},
                                Value: {}
                              }
                            }
                          }
                        }
                      },
                      AwsElasticBeanstalkEnvironment: {
                        type: "structure",
                        members: {
                          ApplicationName: {},
                          Cname: {},
                          DateCreated: {},
                          DateUpdated: {},
                          Description: {},
                          EndpointUrl: {},
                          EnvironmentArn: {},
                          EnvironmentId: {},
                          EnvironmentLinks: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                EnvironmentName: {},
                                LinkName: {}
                              }
                            }
                          },
                          EnvironmentName: {},
                          OptionSettings: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Namespace: {},
                                OptionName: {},
                                ResourceName: {},
                                Value: {}
                              }
                            }
                          },
                          PlatformArn: {},
                          SolutionStackName: {},
                          Status: {},
                          Tier: {
                            type: "structure",
                            members: {
                              Name: {},
                              Type: {},
                              Version: {}
                            }
                          },
                          VersionLabel: {}
                        }
                      },
                      AwsElasticsearchDomain: {
                        type: "structure",
                        members: {
                          AccessPolicies: {},
                          DomainEndpointOptions: {
                            type: "structure",
                            members: {
                              EnforceHTTPS: {
                                type: "boolean"
                              },
                              TLSSecurityPolicy: {}
                            }
                          },
                          DomainId: {},
                          DomainName: {},
                          Endpoint: {},
                          Endpoints: {
                            shape: "S1k"
                          },
                          ElasticsearchVersion: {},
                          ElasticsearchClusterConfig: {
                            type: "structure",
                            members: {
                              DedicatedMasterCount: {
                                type: "integer"
                              },
                              DedicatedMasterEnabled: {
                                type: "boolean"
                              },
                              DedicatedMasterType: {},
                              InstanceCount: {
                                type: "integer"
                              },
                              InstanceType: {},
                              ZoneAwarenessConfig: {
                                type: "structure",
                                members: {
                                  AvailabilityZoneCount: {
                                    type: "integer"
                                  }
                                }
                              },
                              ZoneAwarenessEnabled: {
                                type: "boolean"
                              }
                            }
                          },
                          EncryptionAtRestOptions: {
                            type: "structure",
                            members: {
                              Enabled: {
                                type: "boolean"
                              },
                              KmsKeyId: {}
                            }
                          },
                          LogPublishingOptions: {
                            type: "structure",
                            members: {
                              IndexSlowLogs: {
                                shape: "S73"
                              },
                              SearchSlowLogs: {
                                shape: "S73"
                              },
                              AuditLogs: {
                                shape: "S73"
                              }
                            }
                          },
                          NodeToNodeEncryptionOptions: {
                            type: "structure",
                            members: {
                              Enabled: {
                                type: "boolean"
                              }
                            }
                          },
                          ServiceSoftwareOptions: {
                            type: "structure",
                            members: {
                              AutomatedUpdateDate: {},
                              Cancellable: {
                                type: "boolean"
                              },
                              CurrentVersion: {},
                              Description: {},
                              NewVersion: {},
                              UpdateAvailable: {
                                type: "boolean"
                              },
                              UpdateStatus: {}
                            }
                          },
                          VPCOptions: {
                            type: "structure",
                            members: {
                              AvailabilityZones: {
                                shape: "S4v"
                              },
                              SecurityGroupIds: {
                                shape: "S4v"
                              },
                              SubnetIds: {
                                shape: "S4v"
                              },
                              VPCId: {}
                            }
                          }
                        }
                      },
                      AwsS3Bucket: {
                        type: "structure",
                        members: {
                          OwnerId: {},
                          OwnerName: {},
                          OwnerAccountId: {},
                          CreatedAt: {},
                          ServerSideEncryptionConfiguration: {
                            type: "structure",
                            members: {
                              Rules: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    ApplyServerSideEncryptionByDefault: {
                                      type: "structure",
                                      members: {
                                        SSEAlgorithm: {},
                                        KMSMasterKeyID: {}
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          },
                          BucketLifecycleConfiguration: {
                            type: "structure",
                            members: {
                              Rules: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    AbortIncompleteMultipartUpload: {
                                      type: "structure",
                                      members: {
                                        DaysAfterInitiation: {
                                          type: "integer"
                                        }
                                      }
                                    },
                                    ExpirationDate: {},
                                    ExpirationInDays: {
                                      type: "integer"
                                    },
                                    ExpiredObjectDeleteMarker: {
                                      type: "boolean"
                                    },
                                    Filter: {
                                      type: "structure",
                                      members: {
                                        Predicate: {
                                          type: "structure",
                                          members: {
                                            Operands: {
                                              type: "list",
                                              member: {
                                                type: "structure",
                                                members: {
                                                  Prefix: {},
                                                  Tag: {
                                                    type: "structure",
                                                    members: {
                                                      Key: {},
                                                      Value: {}
                                                    }
                                                  },
                                                  Type: {}
                                                }
                                              }
                                            },
                                            Prefix: {},
                                            Tag: {
                                              type: "structure",
                                              members: {
                                                Key: {},
                                                Value: {}
                                              }
                                            },
                                            Type: {}
                                          }
                                        }
                                      }
                                    },
                                    ID: {},
                                    NoncurrentVersionExpirationInDays: {
                                      type: "integer"
                                    },
                                    NoncurrentVersionTransitions: {
                                      type: "list",
                                      member: {
                                        type: "structure",
                                        members: {
                                          Days: {
                                            type: "integer"
                                          },
                                          StorageClass: {}
                                        }
                                      }
                                    },
                                    Prefix: {},
                                    Status: {},
                                    Transitions: {
                                      type: "list",
                                      member: {
                                        type: "structure",
                                        members: {
                                          Date: {},
                                          Days: {
                                            type: "integer"
                                          },
                                          StorageClass: {}
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          },
                          PublicAccessBlockConfiguration: {
                            shape: "S7q"
                          },
                          AccessControlList: {},
                          BucketLoggingConfiguration: {
                            type: "structure",
                            members: {
                              DestinationBucketName: {},
                              LogFilePrefix: {}
                            }
                          },
                          BucketWebsiteConfiguration: {
                            type: "structure",
                            members: {
                              ErrorDocument: {},
                              IndexDocumentSuffix: {},
                              RedirectAllRequestsTo: {
                                type: "structure",
                                members: {
                                  Hostname: {},
                                  Protocol: {}
                                }
                              },
                              RoutingRules: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    Condition: {
                                      type: "structure",
                                      members: {
                                        HttpErrorCodeReturnedEquals: {},
                                        KeyPrefixEquals: {}
                                      }
                                    },
                                    Redirect: {
                                      type: "structure",
                                      members: {
                                        Hostname: {},
                                        HttpRedirectCode: {},
                                        Protocol: {},
                                        ReplaceKeyPrefixWith: {},
                                        ReplaceKeyWith: {}
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          },
                          BucketNotificationConfiguration: {
                            type: "structure",
                            members: {
                              Configurations: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    Events: {
                                      type: "list",
                                      member: {}
                                    },
                                    Filter: {
                                      type: "structure",
                                      members: {
                                        S3KeyFilter: {
                                          type: "structure",
                                          members: {
                                            FilterRules: {
                                              type: "list",
                                              member: {
                                                type: "structure",
                                                members: {
                                                  Name: {},
                                                  Value: {}
                                                }
                                              }
                                            }
                                          }
                                        }
                                      }
                                    },
                                    Destination: {},
                                    Type: {}
                                  }
                                }
                              }
                            }
                          },
                          BucketVersioningConfiguration: {
                            type: "structure",
                            members: {
                              IsMfaDeleteEnabled: {
                                type: "boolean"
                              },
                              Status: {}
                            }
                          },
                          ObjectLockConfiguration: {
                            type: "structure",
                            members: {
                              ObjectLockEnabled: {},
                              Rule: {
                                type: "structure",
                                members: {
                                  DefaultRetention: {
                                    type: "structure",
                                    members: {
                                      Days: {
                                        type: "integer"
                                      },
                                      Mode: {},
                                      Years: {
                                        type: "integer"
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          },
                          Name: {}
                        }
                      },
                      AwsS3AccountPublicAccessBlock: {
                        shape: "S7q"
                      },
                      AwsS3Object: {
                        type: "structure",
                        members: {
                          LastModified: {},
                          ETag: {},
                          VersionId: {},
                          ContentType: {},
                          ServerSideEncryption: {},
                          SSEKMSKeyId: {}
                        }
                      },
                      AwsSecretsManagerSecret: {
                        type: "structure",
                        members: {
                          RotationRules: {
                            type: "structure",
                            members: {
                              AutomaticallyAfterDays: {
                                type: "integer"
                              }
                            }
                          },
                          RotationOccurredWithinFrequency: {
                            type: "boolean"
                          },
                          KmsKeyId: {},
                          RotationEnabled: {
                            type: "boolean"
                          },
                          RotationLambdaArn: {},
                          Deleted: {
                            type: "boolean"
                          },
                          Name: {},
                          Description: {}
                        }
                      },
                      AwsIamAccessKey: {
                        type: "structure",
                        members: {
                          UserName: {
                            deprecated: true,
                            deprecatedMessage: "This filter is deprecated. Instead, use PrincipalName."
                          },
                          Status: {},
                          CreatedAt: {},
                          PrincipalId: {},
                          PrincipalType: {},
                          PrincipalName: {},
                          AccountId: {},
                          AccessKeyId: {},
                          SessionContext: {
                            type: "structure",
                            members: {
                              Attributes: {
                                type: "structure",
                                members: {
                                  MfaAuthenticated: {
                                    type: "boolean"
                                  },
                                  CreationDate: {}
                                }
                              },
                              SessionIssuer: {
                                type: "structure",
                                members: {
                                  Type: {},
                                  PrincipalId: {},
                                  Arn: {},
                                  AccountId: {},
                                  UserName: {}
                                }
                              }
                            }
                          }
                        }
                      },
                      AwsIamUser: {
                        type: "structure",
                        members: {
                          AttachedManagedPolicies: {
                            shape: "S8k"
                          },
                          CreateDate: {},
                          GroupList: {
                            shape: "S23"
                          },
                          Path: {},
                          PermissionsBoundary: {
                            shape: "S8m"
                          },
                          UserId: {},
                          UserName: {},
                          UserPolicyList: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                PolicyName: {}
                              }
                            }
                          }
                        }
                      },
                      AwsIamPolicy: {
                        type: "structure",
                        members: {
                          AttachmentCount: {
                            type: "integer"
                          },
                          CreateDate: {},
                          DefaultVersionId: {},
                          Description: {},
                          IsAttachable: {
                            type: "boolean"
                          },
                          Path: {},
                          PermissionsBoundaryUsageCount: {
                            type: "integer"
                          },
                          PolicyId: {},
                          PolicyName: {},
                          PolicyVersionList: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                VersionId: {},
                                IsDefaultVersion: {
                                  type: "boolean"
                                },
                                CreateDate: {}
                              }
                            }
                          },
                          UpdateDate: {}
                        }
                      },
                      AwsApiGatewayV2Stage: {
                        type: "structure",
                        members: {
                          ClientCertificateId: {},
                          CreatedDate: {},
                          Description: {},
                          DefaultRouteSettings: {
                            shape: "S8t"
                          },
                          DeploymentId: {},
                          LastUpdatedDate: {},
                          RouteSettings: {
                            shape: "S8t"
                          },
                          StageName: {},
                          StageVariables: {
                            shape: "S1k"
                          },
                          AccessLogSettings: {
                            shape: "S8u"
                          },
                          AutoDeploy: {
                            type: "boolean"
                          },
                          LastDeploymentStatusMessage: {},
                          ApiGatewayManaged: {
                            type: "boolean"
                          }
                        }
                      },
                      AwsApiGatewayV2Api: {
                        type: "structure",
                        members: {
                          ApiEndpoint: {},
                          ApiId: {},
                          ApiKeySelectionExpression: {},
                          CreatedDate: {},
                          Description: {},
                          Version: {},
                          Name: {},
                          ProtocolType: {},
                          RouteSelectionExpression: {},
                          CorsConfiguration: {
                            type: "structure",
                            members: {
                              AllowOrigins: {
                                shape: "S4v"
                              },
                              AllowCredentials: {
                                type: "boolean"
                              },
                              ExposeHeaders: {
                                shape: "S4v"
                              },
                              MaxAge: {
                                type: "integer"
                              },
                              AllowMethods: {
                                shape: "S4v"
                              },
                              AllowHeaders: {
                                shape: "S4v"
                              }
                            }
                          }
                        }
                      },
                      AwsDynamoDbTable: {
                        type: "structure",
                        members: {
                          AttributeDefinitions: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                AttributeName: {},
                                AttributeType: {}
                              }
                            }
                          },
                          BillingModeSummary: {
                            type: "structure",
                            members: {
                              BillingMode: {},
                              LastUpdateToPayPerRequestDateTime: {}
                            }
                          },
                          CreationDateTime: {},
                          GlobalSecondaryIndexes: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Backfilling: {
                                  type: "boolean"
                                },
                                IndexArn: {},
                                IndexName: {},
                                IndexSizeBytes: {
                                  type: "long"
                                },
                                IndexStatus: {},
                                ItemCount: {
                                  type: "integer"
                                },
                                KeySchema: {
                                  shape: "S94"
                                },
                                Projection: {
                                  shape: "S96"
                                },
                                ProvisionedThroughput: {
                                  shape: "S97"
                                }
                              }
                            }
                          },
                          GlobalTableVersion: {},
                          ItemCount: {
                            type: "integer"
                          },
                          KeySchema: {
                            shape: "S94"
                          },
                          LatestStreamArn: {},
                          LatestStreamLabel: {},
                          LocalSecondaryIndexes: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                IndexArn: {},
                                IndexName: {},
                                KeySchema: {
                                  shape: "S94"
                                },
                                Projection: {
                                  shape: "S96"
                                }
                              }
                            }
                          },
                          ProvisionedThroughput: {
                            shape: "S97"
                          },
                          Replicas: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                GlobalSecondaryIndexes: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      IndexName: {},
                                      ProvisionedThroughputOverride: {
                                        shape: "S9e"
                                      }
                                    }
                                  }
                                },
                                KmsMasterKeyId: {},
                                ProvisionedThroughputOverride: {
                                  shape: "S9e"
                                },
                                RegionName: {},
                                ReplicaStatus: {},
                                ReplicaStatusDescription: {}
                              }
                            }
                          },
                          RestoreSummary: {
                            type: "structure",
                            members: {
                              SourceBackupArn: {},
                              SourceTableArn: {},
                              RestoreDateTime: {},
                              RestoreInProgress: {
                                type: "boolean"
                              }
                            }
                          },
                          SseDescription: {
                            type: "structure",
                            members: {
                              InaccessibleEncryptionDateTime: {},
                              Status: {},
                              SseType: {},
                              KmsMasterKeyArn: {}
                            }
                          },
                          StreamSpecification: {
                            type: "structure",
                            members: {
                              StreamEnabled: {
                                type: "boolean"
                              },
                              StreamViewType: {}
                            }
                          },
                          TableId: {},
                          TableName: {},
                          TableSizeBytes: {
                            type: "long"
                          },
                          TableStatus: {},
                          DeletionProtectionEnabled: {
                            type: "boolean"
                          }
                        }
                      },
                      AwsApiGatewayStage: {
                        type: "structure",
                        members: {
                          DeploymentId: {},
                          ClientCertificateId: {},
                          StageName: {},
                          Description: {},
                          CacheClusterEnabled: {
                            type: "boolean"
                          },
                          CacheClusterSize: {},
                          CacheClusterStatus: {},
                          MethodSettings: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                MetricsEnabled: {
                                  type: "boolean"
                                },
                                LoggingLevel: {},
                                DataTraceEnabled: {
                                  type: "boolean"
                                },
                                ThrottlingBurstLimit: {
                                  type: "integer"
                                },
                                ThrottlingRateLimit: {
                                  type: "double"
                                },
                                CachingEnabled: {
                                  type: "boolean"
                                },
                                CacheTtlInSeconds: {
                                  type: "integer"
                                },
                                CacheDataEncrypted: {
                                  type: "boolean"
                                },
                                RequireAuthorizationForCacheControl: {
                                  type: "boolean"
                                },
                                UnauthorizedCacheControlHeaderStrategy: {},
                                HttpMethod: {},
                                ResourcePath: {}
                              }
                            }
                          },
                          Variables: {
                            shape: "S1k"
                          },
                          DocumentationVersion: {},
                          AccessLogSettings: {
                            shape: "S8u"
                          },
                          CanarySettings: {
                            type: "structure",
                            members: {
                              PercentTraffic: {
                                type: "double"
                              },
                              DeploymentId: {},
                              StageVariableOverrides: {
                                shape: "S1k"
                              },
                              UseStageCache: {
                                type: "boolean"
                              }
                            }
                          },
                          TracingEnabled: {
                            type: "boolean"
                          },
                          CreatedDate: {},
                          LastUpdatedDate: {},
                          WebAclArn: {}
                        }
                      },
                      AwsApiGatewayRestApi: {
                        type: "structure",
                        members: {
                          Id: {},
                          Name: {},
                          Description: {},
                          CreatedDate: {},
                          Version: {},
                          BinaryMediaTypes: {
                            shape: "S4v"
                          },
                          MinimumCompressionSize: {
                            type: "integer"
                          },
                          ApiKeySource: {},
                          EndpointConfiguration: {
                            type: "structure",
                            members: {
                              Types: {
                                shape: "S4v"
                              }
                            }
                          }
                        }
                      },
                      AwsCloudTrailTrail: {
                        type: "structure",
                        members: {
                          CloudWatchLogsLogGroupArn: {},
                          CloudWatchLogsRoleArn: {},
                          HasCustomEventSelectors: {
                            type: "boolean"
                          },
                          HomeRegion: {},
                          IncludeGlobalServiceEvents: {
                            type: "boolean"
                          },
                          IsMultiRegionTrail: {
                            type: "boolean"
                          },
                          IsOrganizationTrail: {
                            type: "boolean"
                          },
                          KmsKeyId: {},
                          LogFileValidationEnabled: {
                            type: "boolean"
                          },
                          Name: {},
                          S3BucketName: {},
                          S3KeyPrefix: {},
                          SnsTopicArn: {},
                          SnsTopicName: {},
                          TrailArn: {}
                        }
                      },
                      AwsSsmPatchCompliance: {
                        type: "structure",
                        members: {
                          Patch: {
                            type: "structure",
                            members: {
                              ComplianceSummary: {
                                type: "structure",
                                members: {
                                  Status: {},
                                  CompliantCriticalCount: {
                                    type: "integer"
                                  },
                                  CompliantHighCount: {
                                    type: "integer"
                                  },
                                  CompliantMediumCount: {
                                    type: "integer"
                                  },
                                  ExecutionType: {},
                                  NonCompliantCriticalCount: {
                                    type: "integer"
                                  },
                                  CompliantInformationalCount: {
                                    type: "integer"
                                  },
                                  NonCompliantInformationalCount: {
                                    type: "integer"
                                  },
                                  CompliantUnspecifiedCount: {
                                    type: "integer"
                                  },
                                  NonCompliantLowCount: {
                                    type: "integer"
                                  },
                                  NonCompliantHighCount: {
                                    type: "integer"
                                  },
                                  CompliantLowCount: {
                                    type: "integer"
                                  },
                                  ComplianceType: {},
                                  PatchBaselineId: {},
                                  OverallSeverity: {},
                                  NonCompliantMediumCount: {
                                    type: "integer"
                                  },
                                  NonCompliantUnspecifiedCount: {
                                    type: "integer"
                                  },
                                  PatchGroup: {}
                                }
                              }
                            }
                          }
                        }
                      },
                      AwsCertificateManagerCertificate: {
                        type: "structure",
                        members: {
                          CertificateAuthorityArn: {},
                          CreatedAt: {},
                          DomainName: {},
                          DomainValidationOptions: {
                            shape: "S9t"
                          },
                          ExtendedKeyUsages: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Name: {},
                                OId: {}
                              }
                            }
                          },
                          FailureReason: {},
                          ImportedAt: {},
                          InUseBy: {
                            shape: "S23"
                          },
                          IssuedAt: {},
                          Issuer: {},
                          KeyAlgorithm: {},
                          KeyUsages: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Name: {}
                              }
                            }
                          },
                          NotAfter: {},
                          NotBefore: {},
                          Options: {
                            type: "structure",
                            members: {
                              CertificateTransparencyLoggingPreference: {}
                            }
                          },
                          RenewalEligibility: {},
                          RenewalSummary: {
                            type: "structure",
                            members: {
                              DomainValidationOptions: {
                                shape: "S9t"
                              },
                              RenewalStatus: {},
                              RenewalStatusReason: {},
                              UpdatedAt: {}
                            }
                          },
                          Serial: {},
                          SignatureAlgorithm: {},
                          Status: {},
                          Subject: {},
                          SubjectAlternativeNames: {
                            shape: "S23"
                          },
                          Type: {}
                        }
                      },
                      AwsRedshiftCluster: {
                        type: "structure",
                        members: {
                          AllowVersionUpgrade: {
                            type: "boolean"
                          },
                          AutomatedSnapshotRetentionPeriod: {
                            type: "integer"
                          },
                          AvailabilityZone: {},
                          ClusterAvailabilityStatus: {},
                          ClusterCreateTime: {},
                          ClusterIdentifier: {},
                          ClusterNodes: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                NodeRole: {},
                                PrivateIpAddress: {},
                                PublicIpAddress: {}
                              }
                            }
                          },
                          ClusterParameterGroups: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                ClusterParameterStatusList: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      ParameterName: {},
                                      ParameterApplyStatus: {},
                                      ParameterApplyErrorDescription: {}
                                    }
                                  }
                                },
                                ParameterApplyStatus: {},
                                ParameterGroupName: {}
                              }
                            }
                          },
                          ClusterPublicKey: {},
                          ClusterRevisionNumber: {},
                          ClusterSecurityGroups: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                ClusterSecurityGroupName: {},
                                Status: {}
                              }
                            }
                          },
                          ClusterSnapshotCopyStatus: {
                            type: "structure",
                            members: {
                              DestinationRegion: {},
                              ManualSnapshotRetentionPeriod: {
                                type: "integer"
                              },
                              RetentionPeriod: {
                                type: "integer"
                              },
                              SnapshotCopyGrantName: {}
                            }
                          },
                          ClusterStatus: {},
                          ClusterSubnetGroupName: {},
                          ClusterVersion: {},
                          DBName: {},
                          DeferredMaintenanceWindows: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                DeferMaintenanceEndTime: {},
                                DeferMaintenanceIdentifier: {},
                                DeferMaintenanceStartTime: {}
                              }
                            }
                          },
                          ElasticIpStatus: {
                            type: "structure",
                            members: {
                              ElasticIp: {},
                              Status: {}
                            }
                          },
                          ElasticResizeNumberOfNodeOptions: {},
                          Encrypted: {
                            type: "boolean"
                          },
                          Endpoint: {
                            type: "structure",
                            members: {
                              Address: {},
                              Port: {
                                type: "integer"
                              }
                            }
                          },
                          EnhancedVpcRouting: {
                            type: "boolean"
                          },
                          ExpectedNextSnapshotScheduleTime: {},
                          ExpectedNextSnapshotScheduleTimeStatus: {},
                          HsmStatus: {
                            type: "structure",
                            members: {
                              HsmClientCertificateIdentifier: {},
                              HsmConfigurationIdentifier: {},
                              Status: {}
                            }
                          },
                          IamRoles: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                ApplyStatus: {},
                                IamRoleArn: {}
                              }
                            }
                          },
                          KmsKeyId: {},
                          MaintenanceTrackName: {},
                          ManualSnapshotRetentionPeriod: {
                            type: "integer"
                          },
                          MasterUsername: {},
                          NextMaintenanceWindowStartTime: {},
                          NodeType: {},
                          NumberOfNodes: {
                            type: "integer"
                          },
                          PendingActions: {
                            shape: "S23"
                          },
                          PendingModifiedValues: {
                            type: "structure",
                            members: {
                              AutomatedSnapshotRetentionPeriod: {
                                type: "integer"
                              },
                              ClusterIdentifier: {},
                              ClusterType: {},
                              ClusterVersion: {},
                              EncryptionType: {},
                              EnhancedVpcRouting: {
                                type: "boolean"
                              },
                              MaintenanceTrackName: {},
                              MasterUserPassword: {},
                              NodeType: {},
                              NumberOfNodes: {
                                type: "integer"
                              },
                              PubliclyAccessible: {
                                type: "boolean"
                              }
                            }
                          },
                          PreferredMaintenanceWindow: {},
                          PubliclyAccessible: {
                            type: "boolean"
                          },
                          ResizeInfo: {
                            type: "structure",
                            members: {
                              AllowCancelResize: {
                                type: "boolean"
                              },
                              ResizeType: {}
                            }
                          },
                          RestoreStatus: {
                            type: "structure",
                            members: {
                              CurrentRestoreRateInMegaBytesPerSecond: {
                                type: "double"
                              },
                              ElapsedTimeInSeconds: {
                                type: "long"
                              },
                              EstimatedTimeToCompletionInSeconds: {
                                type: "long"
                              },
                              ProgressInMegaBytes: {
                                type: "long"
                              },
                              SnapshotSizeInMegaBytes: {
                                type: "long"
                              },
                              Status: {}
                            }
                          },
                          SnapshotScheduleIdentifier: {},
                          SnapshotScheduleState: {},
                          VpcId: {},
                          VpcSecurityGroups: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Status: {},
                                VpcSecurityGroupId: {}
                              }
                            }
                          },
                          LoggingStatus: {
                            type: "structure",
                            members: {
                              BucketName: {},
                              LastFailureMessage: {},
                              LastFailureTime: {},
                              LastSuccessfulDeliveryTime: {},
                              LoggingEnabled: {
                                type: "boolean"
                              },
                              S3KeyPrefix: {}
                            }
                          }
                        }
                      },
                      AwsElbLoadBalancer: {
                        type: "structure",
                        members: {
                          AvailabilityZones: {
                            shape: "S23"
                          },
                          BackendServerDescriptions: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                InstancePort: {
                                  type: "integer"
                                },
                                PolicyNames: {
                                  shape: "S23"
                                }
                              }
                            }
                          },
                          CanonicalHostedZoneName: {},
                          CanonicalHostedZoneNameID: {},
                          CreatedTime: {},
                          DnsName: {},
                          HealthCheck: {
                            type: "structure",
                            members: {
                              HealthyThreshold: {
                                type: "integer"
                              },
                              Interval: {
                                type: "integer"
                              },
                              Target: {},
                              Timeout: {
                                type: "integer"
                              },
                              UnhealthyThreshold: {
                                type: "integer"
                              }
                            }
                          },
                          Instances: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                InstanceId: {}
                              }
                            }
                          },
                          ListenerDescriptions: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Listener: {
                                  type: "structure",
                                  members: {
                                    InstancePort: {
                                      type: "integer"
                                    },
                                    InstanceProtocol: {},
                                    LoadBalancerPort: {
                                      type: "integer"
                                    },
                                    Protocol: {},
                                    SslCertificateId: {}
                                  }
                                },
                                PolicyNames: {
                                  shape: "S23"
                                }
                              }
                            }
                          },
                          LoadBalancerAttributes: {
                            type: "structure",
                            members: {
                              AccessLog: {
                                type: "structure",
                                members: {
                                  EmitInterval: {
                                    type: "integer"
                                  },
                                  Enabled: {
                                    type: "boolean"
                                  },
                                  S3BucketName: {},
                                  S3BucketPrefix: {}
                                }
                              },
                              ConnectionDraining: {
                                type: "structure",
                                members: {
                                  Enabled: {
                                    type: "boolean"
                                  },
                                  Timeout: {
                                    type: "integer"
                                  }
                                }
                              },
                              ConnectionSettings: {
                                type: "structure",
                                members: {
                                  IdleTimeout: {
                                    type: "integer"
                                  }
                                }
                              },
                              CrossZoneLoadBalancing: {
                                type: "structure",
                                members: {
                                  Enabled: {
                                    type: "boolean"
                                  }
                                }
                              },
                              AdditionalAttributes: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    Key: {},
                                    Value: {}
                                  }
                                }
                              }
                            }
                          },
                          LoadBalancerName: {},
                          Policies: {
                            type: "structure",
                            members: {
                              AppCookieStickinessPolicies: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    CookieName: {},
                                    PolicyName: {}
                                  }
                                }
                              },
                              LbCookieStickinessPolicies: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    CookieExpirationPeriod: {
                                      type: "long"
                                    },
                                    PolicyName: {}
                                  }
                                }
                              },
                              OtherPolicies: {
                                shape: "S23"
                              }
                            }
                          },
                          Scheme: {},
                          SecurityGroups: {
                            shape: "S23"
                          },
                          SourceSecurityGroup: {
                            type: "structure",
                            members: {
                              GroupName: {},
                              OwnerAlias: {}
                            }
                          },
                          Subnets: {
                            shape: "S23"
                          },
                          VpcId: {}
                        }
                      },
                      AwsIamGroup: {
                        type: "structure",
                        members: {
                          AttachedManagedPolicies: {
                            shape: "S8k"
                          },
                          CreateDate: {},
                          GroupId: {},
                          GroupName: {},
                          GroupPolicyList: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                PolicyName: {}
                              }
                            }
                          },
                          Path: {}
                        }
                      },
                      AwsIamRole: {
                        type: "structure",
                        members: {
                          AssumeRolePolicyDocument: {},
                          AttachedManagedPolicies: {
                            shape: "S8k"
                          },
                          CreateDate: {},
                          InstanceProfileList: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Arn: {},
                                CreateDate: {},
                                InstanceProfileId: {},
                                InstanceProfileName: {},
                                Path: {},
                                Roles: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      Arn: {},
                                      AssumeRolePolicyDocument: {},
                                      CreateDate: {},
                                      Path: {},
                                      RoleId: {},
                                      RoleName: {}
                                    }
                                  }
                                }
                              }
                            }
                          },
                          PermissionsBoundary: {
                            shape: "S8m"
                          },
                          RoleId: {},
                          RoleName: {},
                          RolePolicyList: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                PolicyName: {}
                              }
                            }
                          },
                          MaxSessionDuration: {
                            type: "integer"
                          },
                          Path: {}
                        }
                      },
                      AwsKmsKey: {
                        type: "structure",
                        members: {
                          AWSAccountId: {},
                          CreationDate: {
                            type: "double"
                          },
                          KeyId: {},
                          KeyManager: {},
                          KeyState: {},
                          Origin: {},
                          Description: {},
                          KeyRotationStatus: {
                            type: "boolean"
                          }
                        }
                      },
                      AwsLambdaFunction: {
                        type: "structure",
                        members: {
                          Code: {
                            type: "structure",
                            members: {
                              S3Bucket: {},
                              S3Key: {},
                              S3ObjectVersion: {},
                              ZipFile: {}
                            }
                          },
                          CodeSha256: {},
                          DeadLetterConfig: {
                            type: "structure",
                            members: {
                              TargetArn: {}
                            }
                          },
                          Environment: {
                            type: "structure",
                            members: {
                              Variables: {
                                shape: "S1k"
                              },
                              Error: {
                                type: "structure",
                                members: {
                                  ErrorCode: {},
                                  Message: {}
                                }
                              }
                            }
                          },
                          FunctionName: {},
                          Handler: {},
                          KmsKeyArn: {},
                          LastModified: {},
                          Layers: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Arn: {},
                                CodeSize: {
                                  type: "integer"
                                }
                              }
                            }
                          },
                          MasterArn: {},
                          MemorySize: {
                            type: "integer"
                          },
                          RevisionId: {},
                          Role: {},
                          Runtime: {},
                          Timeout: {
                            type: "integer"
                          },
                          TracingConfig: {
                            type: "structure",
                            members: {
                              Mode: {}
                            }
                          },
                          VpcConfig: {
                            type: "structure",
                            members: {
                              SecurityGroupIds: {
                                shape: "S4v"
                              },
                              SubnetIds: {
                                shape: "S4v"
                              },
                              VpcId: {}
                            }
                          },
                          Version: {},
                          Architectures: {
                            shape: "S4v"
                          },
                          PackageType: {}
                        }
                      },
                      AwsLambdaLayerVersion: {
                        type: "structure",
                        members: {
                          Version: {
                            type: "long"
                          },
                          CompatibleRuntimes: {
                            shape: "S4v"
                          },
                          CreatedDate: {}
                        }
                      },
                      AwsRdsDbInstance: {
                        type: "structure",
                        members: {
                          AssociatedRoles: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                RoleArn: {},
                                FeatureName: {},
                                Status: {}
                              }
                            }
                          },
                          CACertificateIdentifier: {},
                          DBClusterIdentifier: {},
                          DBInstanceIdentifier: {},
                          DBInstanceClass: {},
                          DbInstancePort: {
                            type: "integer"
                          },
                          DbiResourceId: {},
                          DBName: {},
                          DeletionProtection: {
                            type: "boolean"
                          },
                          Endpoint: {
                            shape: "Sc1"
                          },
                          Engine: {},
                          EngineVersion: {},
                          IAMDatabaseAuthenticationEnabled: {
                            type: "boolean"
                          },
                          InstanceCreateTime: {},
                          KmsKeyId: {},
                          PubliclyAccessible: {
                            type: "boolean"
                          },
                          StorageEncrypted: {
                            type: "boolean"
                          },
                          TdeCredentialArn: {},
                          VpcSecurityGroups: {
                            shape: "Sc2"
                          },
                          MultiAz: {
                            type: "boolean"
                          },
                          EnhancedMonitoringResourceArn: {},
                          DbInstanceStatus: {},
                          MasterUsername: {},
                          AllocatedStorage: {
                            type: "integer"
                          },
                          PreferredBackupWindow: {},
                          BackupRetentionPeriod: {
                            type: "integer"
                          },
                          DbSecurityGroups: {
                            shape: "S23"
                          },
                          DbParameterGroups: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                DbParameterGroupName: {},
                                ParameterApplyStatus: {}
                              }
                            }
                          },
                          AvailabilityZone: {},
                          DbSubnetGroup: {
                            type: "structure",
                            members: {
                              DbSubnetGroupName: {},
                              DbSubnetGroupDescription: {},
                              VpcId: {},
                              SubnetGroupStatus: {},
                              Subnets: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    SubnetIdentifier: {},
                                    SubnetAvailabilityZone: {
                                      type: "structure",
                                      members: {
                                        Name: {}
                                      }
                                    },
                                    SubnetStatus: {}
                                  }
                                }
                              },
                              DbSubnetGroupArn: {}
                            }
                          },
                          PreferredMaintenanceWindow: {},
                          PendingModifiedValues: {
                            type: "structure",
                            members: {
                              DbInstanceClass: {},
                              AllocatedStorage: {
                                type: "integer"
                              },
                              MasterUserPassword: {},
                              Port: {
                                type: "integer"
                              },
                              BackupRetentionPeriod: {
                                type: "integer"
                              },
                              MultiAZ: {
                                type: "boolean"
                              },
                              EngineVersion: {},
                              LicenseModel: {},
                              Iops: {
                                type: "integer"
                              },
                              DbInstanceIdentifier: {},
                              StorageType: {},
                              CaCertificateIdentifier: {},
                              DbSubnetGroupName: {},
                              PendingCloudWatchLogsExports: {
                                type: "structure",
                                members: {
                                  LogTypesToEnable: {
                                    shape: "S23"
                                  },
                                  LogTypesToDisable: {
                                    shape: "S23"
                                  }
                                }
                              },
                              ProcessorFeatures: {
                                shape: "Scc"
                              }
                            }
                          },
                          LatestRestorableTime: {},
                          AutoMinorVersionUpgrade: {
                            type: "boolean"
                          },
                          ReadReplicaSourceDBInstanceIdentifier: {},
                          ReadReplicaDBInstanceIdentifiers: {
                            shape: "S23"
                          },
                          ReadReplicaDBClusterIdentifiers: {
                            shape: "S23"
                          },
                          LicenseModel: {},
                          Iops: {
                            type: "integer"
                          },
                          OptionGroupMemberships: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                OptionGroupName: {},
                                Status: {}
                              }
                            }
                          },
                          CharacterSetName: {},
                          SecondaryAvailabilityZone: {},
                          StatusInfos: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                StatusType: {},
                                Normal: {
                                  type: "boolean"
                                },
                                Status: {},
                                Message: {}
                              }
                            }
                          },
                          StorageType: {},
                          DomainMemberships: {
                            shape: "Sci"
                          },
                          CopyTagsToSnapshot: {
                            type: "boolean"
                          },
                          MonitoringInterval: {
                            type: "integer"
                          },
                          MonitoringRoleArn: {},
                          PromotionTier: {
                            type: "integer"
                          },
                          Timezone: {},
                          PerformanceInsightsEnabled: {
                            type: "boolean"
                          },
                          PerformanceInsightsKmsKeyId: {},
                          PerformanceInsightsRetentionPeriod: {
                            type: "integer"
                          },
                          EnabledCloudWatchLogsExports: {
                            shape: "S23"
                          },
                          ProcessorFeatures: {
                            shape: "Scc"
                          },
                          ListenerEndpoint: {
                            shape: "Sc1"
                          },
                          MaxAllocatedStorage: {
                            type: "integer"
                          }
                        }
                      },
                      AwsSnsTopic: {
                        type: "structure",
                        members: {
                          KmsMasterKeyId: {},
                          Subscription: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Endpoint: {},
                                Protocol: {}
                              }
                            }
                          },
                          TopicName: {},
                          Owner: {},
                          SqsSuccessFeedbackRoleArn: {},
                          SqsFailureFeedbackRoleArn: {},
                          ApplicationSuccessFeedbackRoleArn: {},
                          FirehoseSuccessFeedbackRoleArn: {},
                          FirehoseFailureFeedbackRoleArn: {},
                          HttpSuccessFeedbackRoleArn: {},
                          HttpFailureFeedbackRoleArn: {}
                        }
                      },
                      AwsSqsQueue: {
                        type: "structure",
                        members: {
                          KmsDataKeyReusePeriodSeconds: {
                            type: "integer"
                          },
                          KmsMasterKeyId: {},
                          QueueName: {},
                          DeadLetterTargetArn: {}
                        }
                      },
                      AwsWafWebAcl: {
                        type: "structure",
                        members: {
                          Name: {},
                          DefaultAction: {},
                          Rules: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Action: {
                                  type: "structure",
                                  members: {
                                    Type: {}
                                  }
                                },
                                ExcludedRules: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      RuleId: {}
                                    }
                                  }
                                },
                                OverrideAction: {
                                  type: "structure",
                                  members: {
                                    Type: {}
                                  }
                                },
                                Priority: {
                                  type: "integer"
                                },
                                RuleId: {},
                                Type: {}
                              }
                            }
                          },
                          WebAclId: {}
                        }
                      },
                      AwsRdsDbSnapshot: {
                        type: "structure",
                        members: {
                          DbSnapshotIdentifier: {},
                          DbInstanceIdentifier: {},
                          SnapshotCreateTime: {},
                          Engine: {},
                          AllocatedStorage: {
                            type: "integer"
                          },
                          Status: {},
                          Port: {
                            type: "integer"
                          },
                          AvailabilityZone: {},
                          VpcId: {},
                          InstanceCreateTime: {},
                          MasterUsername: {},
                          EngineVersion: {},
                          LicenseModel: {},
                          SnapshotType: {},
                          Iops: {
                            type: "integer"
                          },
                          OptionGroupName: {},
                          PercentProgress: {
                            type: "integer"
                          },
                          SourceRegion: {},
                          SourceDbSnapshotIdentifier: {},
                          StorageType: {},
                          TdeCredentialArn: {},
                          Encrypted: {
                            type: "boolean"
                          },
                          KmsKeyId: {},
                          Timezone: {},
                          IamDatabaseAuthenticationEnabled: {
                            type: "boolean"
                          },
                          ProcessorFeatures: {
                            shape: "Scc"
                          },
                          DbiResourceId: {}
                        }
                      },
                      AwsRdsDbClusterSnapshot: {
                        type: "structure",
                        members: {
                          AvailabilityZones: {
                            shape: "S23"
                          },
                          SnapshotCreateTime: {},
                          Engine: {},
                          AllocatedStorage: {
                            type: "integer"
                          },
                          Status: {},
                          Port: {
                            type: "integer"
                          },
                          VpcId: {},
                          ClusterCreateTime: {},
                          MasterUsername: {},
                          EngineVersion: {},
                          LicenseModel: {},
                          SnapshotType: {},
                          PercentProgress: {
                            type: "integer"
                          },
                          StorageEncrypted: {
                            type: "boolean"
                          },
                          KmsKeyId: {},
                          DbClusterIdentifier: {},
                          DbClusterSnapshotIdentifier: {},
                          IamDatabaseAuthenticationEnabled: {
                            type: "boolean"
                          },
                          DbClusterSnapshotAttributes: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                AttributeName: {},
                                AttributeValues: {
                                  shape: "S4v"
                                }
                              }
                            }
                          }
                        }
                      },
                      AwsRdsDbCluster: {
                        type: "structure",
                        members: {
                          AllocatedStorage: {
                            type: "integer"
                          },
                          AvailabilityZones: {
                            shape: "S23"
                          },
                          BackupRetentionPeriod: {
                            type: "integer"
                          },
                          DatabaseName: {},
                          Status: {},
                          Endpoint: {},
                          ReaderEndpoint: {},
                          CustomEndpoints: {
                            shape: "S23"
                          },
                          MultiAz: {
                            type: "boolean"
                          },
                          Engine: {},
                          EngineVersion: {},
                          Port: {
                            type: "integer"
                          },
                          MasterUsername: {},
                          PreferredBackupWindow: {},
                          PreferredMaintenanceWindow: {},
                          ReadReplicaIdentifiers: {
                            shape: "S23"
                          },
                          VpcSecurityGroups: {
                            shape: "Sc2"
                          },
                          HostedZoneId: {},
                          StorageEncrypted: {
                            type: "boolean"
                          },
                          KmsKeyId: {},
                          DbClusterResourceId: {},
                          AssociatedRoles: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                RoleArn: {},
                                Status: {}
                              }
                            }
                          },
                          ClusterCreateTime: {},
                          EnabledCloudWatchLogsExports: {
                            shape: "S23"
                          },
                          EngineMode: {},
                          DeletionProtection: {
                            type: "boolean"
                          },
                          HttpEndpointEnabled: {
                            type: "boolean"
                          },
                          ActivityStreamStatus: {},
                          CopyTagsToSnapshot: {
                            type: "boolean"
                          },
                          CrossAccountClone: {
                            type: "boolean"
                          },
                          DomainMemberships: {
                            shape: "Sci"
                          },
                          DbClusterParameterGroup: {},
                          DbSubnetGroup: {},
                          DbClusterOptionGroupMemberships: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                DbClusterOptionGroupName: {},
                                Status: {}
                              }
                            }
                          },
                          DbClusterIdentifier: {},
                          DbClusterMembers: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                IsClusterWriter: {
                                  type: "boolean"
                                },
                                PromotionTier: {
                                  type: "integer"
                                },
                                DbInstanceIdentifier: {},
                                DbClusterParameterGroupStatus: {}
                              }
                            }
                          },
                          IamDatabaseAuthenticationEnabled: {
                            type: "boolean"
                          },
                          AutoMinorVersionUpgrade: {
                            type: "boolean"
                          }
                        }
                      },
                      AwsEcsCluster: {
                        type: "structure",
                        members: {
                          ClusterArn: {},
                          ActiveServicesCount: {
                            type: "integer"
                          },
                          CapacityProviders: {
                            shape: "S4v"
                          },
                          ClusterSettings: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Name: {},
                                Value: {}
                              }
                            }
                          },
                          Configuration: {
                            type: "structure",
                            members: {
                              ExecuteCommandConfiguration: {
                                type: "structure",
                                members: {
                                  KmsKeyId: {},
                                  LogConfiguration: {
                                    type: "structure",
                                    members: {
                                      CloudWatchEncryptionEnabled: {
                                        type: "boolean"
                                      },
                                      CloudWatchLogGroupName: {},
                                      S3BucketName: {},
                                      S3EncryptionEnabled: {
                                        type: "boolean"
                                      },
                                      S3KeyPrefix: {}
                                    }
                                  },
                                  Logging: {}
                                }
                              }
                            }
                          },
                          DefaultCapacityProviderStrategy: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Base: {
                                  type: "integer"
                                },
                                CapacityProvider: {},
                                Weight: {
                                  type: "integer"
                                }
                              }
                            }
                          },
                          ClusterName: {},
                          RegisteredContainerInstancesCount: {
                            type: "integer"
                          },
                          RunningTasksCount: {
                            type: "integer"
                          },
                          Status: {}
                        }
                      },
                      AwsEcsContainer: {
                        shape: "Sde"
                      },
                      AwsEcsTaskDefinition: {
                        type: "structure",
                        members: {
                          ContainerDefinitions: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Command: {
                                  shape: "S4v"
                                },
                                Cpu: {
                                  type: "integer"
                                },
                                DependsOn: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      Condition: {},
                                      ContainerName: {}
                                    }
                                  }
                                },
                                DisableNetworking: {
                                  type: "boolean"
                                },
                                DnsSearchDomains: {
                                  shape: "S4v"
                                },
                                DnsServers: {
                                  shape: "S4v"
                                },
                                DockerLabels: {
                                  shape: "S1k"
                                },
                                DockerSecurityOptions: {
                                  shape: "S4v"
                                },
                                EntryPoint: {
                                  shape: "S4v"
                                },
                                Environment: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      Name: {},
                                      Value: {}
                                    }
                                  }
                                },
                                EnvironmentFiles: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      Type: {},
                                      Value: {}
                                    }
                                  }
                                },
                                Essential: {
                                  type: "boolean"
                                },
                                ExtraHosts: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      Hostname: {},
                                      IpAddress: {}
                                    }
                                  }
                                },
                                FirelensConfiguration: {
                                  type: "structure",
                                  members: {
                                    Options: {
                                      shape: "S1k"
                                    },
                                    Type: {}
                                  }
                                },
                                HealthCheck: {
                                  type: "structure",
                                  members: {
                                    Command: {
                                      shape: "S4v"
                                    },
                                    Interval: {
                                      type: "integer"
                                    },
                                    Retries: {
                                      type: "integer"
                                    },
                                    StartPeriod: {
                                      type: "integer"
                                    },
                                    Timeout: {
                                      type: "integer"
                                    }
                                  }
                                },
                                Hostname: {},
                                Image: {},
                                Interactive: {
                                  type: "boolean"
                                },
                                Links: {
                                  shape: "S4v"
                                },
                                LinuxParameters: {
                                  type: "structure",
                                  members: {
                                    Capabilities: {
                                      type: "structure",
                                      members: {
                                        Add: {
                                          shape: "S4v"
                                        },
                                        Drop: {
                                          shape: "S4v"
                                        }
                                      }
                                    },
                                    Devices: {
                                      type: "list",
                                      member: {
                                        type: "structure",
                                        members: {
                                          ContainerPath: {},
                                          HostPath: {},
                                          Permissions: {
                                            shape: "S4v"
                                          }
                                        }
                                      }
                                    },
                                    InitProcessEnabled: {
                                      type: "boolean"
                                    },
                                    MaxSwap: {
                                      type: "integer"
                                    },
                                    SharedMemorySize: {
                                      type: "integer"
                                    },
                                    Swappiness: {
                                      type: "integer"
                                    },
                                    Tmpfs: {
                                      type: "list",
                                      member: {
                                        type: "structure",
                                        members: {
                                          ContainerPath: {},
                                          MountOptions: {
                                            shape: "S4v"
                                          },
                                          Size: {
                                            type: "integer"
                                          }
                                        }
                                      }
                                    }
                                  }
                                },
                                LogConfiguration: {
                                  type: "structure",
                                  members: {
                                    LogDriver: {},
                                    Options: {
                                      shape: "S1k"
                                    },
                                    SecretOptions: {
                                      type: "list",
                                      member: {
                                        type: "structure",
                                        members: {
                                          Name: {},
                                          ValueFrom: {}
                                        }
                                      }
                                    }
                                  }
                                },
                                Memory: {
                                  type: "integer"
                                },
                                MemoryReservation: {
                                  type: "integer"
                                },
                                MountPoints: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      ContainerPath: {},
                                      ReadOnly: {
                                        type: "boolean"
                                      },
                                      SourceVolume: {}
                                    }
                                  }
                                },
                                Name: {},
                                PortMappings: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      ContainerPort: {
                                        type: "integer"
                                      },
                                      HostPort: {
                                        type: "integer"
                                      },
                                      Protocol: {}
                                    }
                                  }
                                },
                                Privileged: {
                                  type: "boolean"
                                },
                                PseudoTerminal: {
                                  type: "boolean"
                                },
                                ReadonlyRootFilesystem: {
                                  type: "boolean"
                                },
                                RepositoryCredentials: {
                                  type: "structure",
                                  members: {
                                    CredentialsParameter: {}
                                  }
                                },
                                ResourceRequirements: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      Type: {},
                                      Value: {}
                                    }
                                  }
                                },
                                Secrets: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      Name: {},
                                      ValueFrom: {}
                                    }
                                  }
                                },
                                StartTimeout: {
                                  type: "integer"
                                },
                                StopTimeout: {
                                  type: "integer"
                                },
                                SystemControls: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      Namespace: {},
                                      Value: {}
                                    }
                                  }
                                },
                                Ulimits: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      HardLimit: {
                                        type: "integer"
                                      },
                                      Name: {},
                                      SoftLimit: {
                                        type: "integer"
                                      }
                                    }
                                  }
                                },
                                User: {},
                                VolumesFrom: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      ReadOnly: {
                                        type: "boolean"
                                      },
                                      SourceContainer: {}
                                    }
                                  }
                                },
                                WorkingDirectory: {}
                              }
                            }
                          },
                          Cpu: {},
                          ExecutionRoleArn: {},
                          Family: {},
                          InferenceAccelerators: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                DeviceName: {},
                                DeviceType: {}
                              }
                            }
                          },
                          IpcMode: {},
                          Memory: {},
                          NetworkMode: {},
                          PidMode: {},
                          PlacementConstraints: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Expression: {},
                                Type: {}
                              }
                            }
                          },
                          ProxyConfiguration: {
                            type: "structure",
                            members: {
                              ContainerName: {},
                              ProxyConfigurationProperties: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    Name: {},
                                    Value: {}
                                  }
                                }
                              },
                              Type: {}
                            }
                          },
                          RequiresCompatibilities: {
                            shape: "S4v"
                          },
                          TaskRoleArn: {},
                          Volumes: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                DockerVolumeConfiguration: {
                                  type: "structure",
                                  members: {
                                    Autoprovision: {
                                      type: "boolean"
                                    },
                                    Driver: {},
                                    DriverOpts: {
                                      shape: "S1k"
                                    },
                                    Labels: {
                                      shape: "S1k"
                                    },
                                    Scope: {}
                                  }
                                },
                                EfsVolumeConfiguration: {
                                  type: "structure",
                                  members: {
                                    AuthorizationConfig: {
                                      type: "structure",
                                      members: {
                                        AccessPointId: {},
                                        Iam: {}
                                      }
                                    },
                                    FilesystemId: {},
                                    RootDirectory: {},
                                    TransitEncryption: {},
                                    TransitEncryptionPort: {
                                      type: "integer"
                                    }
                                  }
                                },
                                Host: {
                                  type: "structure",
                                  members: {
                                    SourcePath: {}
                                  }
                                },
                                Name: {}
                              }
                            }
                          },
                          Status: {}
                        }
                      },
                      Container: {
                        type: "structure",
                        members: {
                          ContainerRuntime: {},
                          Name: {},
                          ImageId: {},
                          ImageName: {},
                          LaunchedAt: {},
                          VolumeMounts: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Name: {},
                                MountPath: {}
                              }
                            }
                          },
                          Privileged: {
                            type: "boolean"
                          }
                        }
                      },
                      Other: {
                        shape: "S1k"
                      },
                      AwsRdsEventSubscription: {
                        type: "structure",
                        members: {
                          CustSubscriptionId: {},
                          CustomerAwsId: {},
                          Enabled: {
                            type: "boolean"
                          },
                          EventCategoriesList: {
                            shape: "S4v"
                          },
                          EventSubscriptionArn: {},
                          SnsTopicArn: {},
                          SourceIdsList: {
                            shape: "S4v"
                          },
                          SourceType: {},
                          Status: {},
                          SubscriptionCreationTime: {}
                        }
                      },
                      AwsEcsService: {
                        type: "structure",
                        members: {
                          CapacityProviderStrategy: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Base: {
                                  type: "integer"
                                },
                                CapacityProvider: {},
                                Weight: {
                                  type: "integer"
                                }
                              }
                            }
                          },
                          Cluster: {},
                          DeploymentConfiguration: {
                            type: "structure",
                            members: {
                              DeploymentCircuitBreaker: {
                                type: "structure",
                                members: {
                                  Enable: {
                                    type: "boolean"
                                  },
                                  Rollback: {
                                    type: "boolean"
                                  }
                                }
                              },
                              MaximumPercent: {
                                type: "integer"
                              },
                              MinimumHealthyPercent: {
                                type: "integer"
                              }
                            }
                          },
                          DeploymentController: {
                            type: "structure",
                            members: {
                              Type: {}
                            }
                          },
                          DesiredCount: {
                            type: "integer"
                          },
                          EnableEcsManagedTags: {
                            type: "boolean"
                          },
                          EnableExecuteCommand: {
                            type: "boolean"
                          },
                          HealthCheckGracePeriodSeconds: {
                            type: "integer"
                          },
                          LaunchType: {},
                          LoadBalancers: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                ContainerName: {},
                                ContainerPort: {
                                  type: "integer"
                                },
                                LoadBalancerName: {},
                                TargetGroupArn: {}
                              }
                            }
                          },
                          Name: {},
                          NetworkConfiguration: {
                            type: "structure",
                            members: {
                              AwsVpcConfiguration: {
                                type: "structure",
                                members: {
                                  AssignPublicIp: {},
                                  SecurityGroups: {
                                    shape: "S4v"
                                  },
                                  Subnets: {
                                    shape: "S4v"
                                  }
                                }
                              }
                            }
                          },
                          PlacementConstraints: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Expression: {},
                                Type: {}
                              }
                            }
                          },
                          PlacementStrategies: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Field: {},
                                Type: {}
                              }
                            }
                          },
                          PlatformVersion: {},
                          PropagateTags: {},
                          Role: {},
                          SchedulingStrategy: {},
                          ServiceArn: {},
                          ServiceName: {},
                          ServiceRegistries: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                ContainerName: {},
                                ContainerPort: {
                                  type: "integer"
                                },
                                Port: {
                                  type: "integer"
                                },
                                RegistryArn: {}
                              }
                            }
                          },
                          TaskDefinition: {}
                        }
                      },
                      AwsAutoScalingLaunchConfiguration: {
                        type: "structure",
                        members: {
                          AssociatePublicIpAddress: {
                            type: "boolean"
                          },
                          BlockDeviceMappings: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                DeviceName: {},
                                Ebs: {
                                  type: "structure",
                                  members: {
                                    DeleteOnTermination: {
                                      type: "boolean"
                                    },
                                    Encrypted: {
                                      type: "boolean"
                                    },
                                    Iops: {
                                      type: "integer"
                                    },
                                    SnapshotId: {},
                                    VolumeSize: {
                                      type: "integer"
                                    },
                                    VolumeType: {}
                                  }
                                },
                                NoDevice: {
                                  type: "boolean"
                                },
                                VirtualName: {}
                              }
                            }
                          },
                          ClassicLinkVpcId: {},
                          ClassicLinkVpcSecurityGroups: {
                            shape: "S4v"
                          },
                          CreatedTime: {},
                          EbsOptimized: {
                            type: "boolean"
                          },
                          IamInstanceProfile: {},
                          ImageId: {},
                          InstanceMonitoring: {
                            type: "structure",
                            members: {
                              Enabled: {
                                type: "boolean"
                              }
                            }
                          },
                          InstanceType: {},
                          KernelId: {},
                          KeyName: {},
                          LaunchConfigurationName: {},
                          PlacementTenancy: {},
                          RamdiskId: {},
                          SecurityGroups: {
                            shape: "S4v"
                          },
                          SpotPrice: {},
                          UserData: {},
                          MetadataOptions: {
                            type: "structure",
                            members: {
                              HttpEndpoint: {},
                              HttpPutResponseHopLimit: {
                                type: "integer"
                              },
                              HttpTokens: {}
                            }
                          }
                        }
                      },
                      AwsEc2VpnConnection: {
                        type: "structure",
                        members: {
                          VpnConnectionId: {},
                          State: {},
                          CustomerGatewayId: {},
                          CustomerGatewayConfiguration: {},
                          Type: {},
                          VpnGatewayId: {},
                          Category: {},
                          VgwTelemetry: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                AcceptedRouteCount: {
                                  type: "integer"
                                },
                                CertificateArn: {},
                                LastStatusChange: {},
                                OutsideIpAddress: {},
                                Status: {},
                                StatusMessage: {}
                              }
                            }
                          },
                          Options: {
                            type: "structure",
                            members: {
                              StaticRoutesOnly: {
                                type: "boolean"
                              },
                              TunnelOptions: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    DpdTimeoutSeconds: {
                                      type: "integer"
                                    },
                                    IkeVersions: {
                                      shape: "S4v"
                                    },
                                    OutsideIpAddress: {},
                                    Phase1DhGroupNumbers: {
                                      shape: "S2e"
                                    },
                                    Phase1EncryptionAlgorithms: {
                                      shape: "S4v"
                                    },
                                    Phase1IntegrityAlgorithms: {
                                      shape: "S4v"
                                    },
                                    Phase1LifetimeSeconds: {
                                      type: "integer"
                                    },
                                    Phase2DhGroupNumbers: {
                                      shape: "S2e"
                                    },
                                    Phase2EncryptionAlgorithms: {
                                      shape: "S4v"
                                    },
                                    Phase2IntegrityAlgorithms: {
                                      shape: "S4v"
                                    },
                                    Phase2LifetimeSeconds: {
                                      type: "integer"
                                    },
                                    PreSharedKey: {},
                                    RekeyFuzzPercentage: {
                                      type: "integer"
                                    },
                                    RekeyMarginTimeSeconds: {
                                      type: "integer"
                                    },
                                    ReplayWindowSize: {
                                      type: "integer"
                                    },
                                    TunnelInsideCidr: {}
                                  }
                                }
                              }
                            }
                          },
                          Routes: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                DestinationCidrBlock: {},
                                State: {}
                              }
                            }
                          },
                          TransitGatewayId: {}
                        }
                      },
                      AwsEcrContainerImage: {
                        type: "structure",
                        members: {
                          RegistryId: {},
                          RepositoryName: {},
                          Architecture: {},
                          ImageDigest: {},
                          ImageTags: {
                            shape: "S4v"
                          },
                          ImagePublishedAt: {}
                        }
                      },
                      AwsOpenSearchServiceDomain: {
                        type: "structure",
                        members: {
                          Arn: {},
                          AccessPolicies: {},
                          DomainName: {},
                          Id: {},
                          DomainEndpoint: {},
                          EngineVersion: {},
                          EncryptionAtRestOptions: {
                            type: "structure",
                            members: {
                              Enabled: {
                                type: "boolean"
                              },
                              KmsKeyId: {}
                            }
                          },
                          NodeToNodeEncryptionOptions: {
                            type: "structure",
                            members: {
                              Enabled: {
                                type: "boolean"
                              }
                            }
                          },
                          ServiceSoftwareOptions: {
                            type: "structure",
                            members: {
                              AutomatedUpdateDate: {},
                              Cancellable: {
                                type: "boolean"
                              },
                              CurrentVersion: {},
                              Description: {},
                              NewVersion: {},
                              UpdateAvailable: {
                                type: "boolean"
                              },
                              UpdateStatus: {},
                              OptionalDeployment: {
                                type: "boolean"
                              }
                            }
                          },
                          ClusterConfig: {
                            type: "structure",
                            members: {
                              InstanceCount: {
                                type: "integer"
                              },
                              WarmEnabled: {
                                type: "boolean"
                              },
                              WarmCount: {
                                type: "integer"
                              },
                              DedicatedMasterEnabled: {
                                type: "boolean"
                              },
                              ZoneAwarenessConfig: {
                                type: "structure",
                                members: {
                                  AvailabilityZoneCount: {
                                    type: "integer"
                                  }
                                }
                              },
                              DedicatedMasterCount: {
                                type: "integer"
                              },
                              InstanceType: {},
                              WarmType: {},
                              ZoneAwarenessEnabled: {
                                type: "boolean"
                              },
                              DedicatedMasterType: {}
                            }
                          },
                          DomainEndpointOptions: {
                            type: "structure",
                            members: {
                              CustomEndpointCertificateArn: {},
                              CustomEndpointEnabled: {
                                type: "boolean"
                              },
                              EnforceHTTPS: {
                                type: "boolean"
                              },
                              CustomEndpoint: {},
                              TLSSecurityPolicy: {}
                            }
                          },
                          VpcOptions: {
                            type: "structure",
                            members: {
                              SecurityGroupIds: {
                                shape: "S4v"
                              },
                              SubnetIds: {
                                shape: "S4v"
                              }
                            }
                          },
                          LogPublishingOptions: {
                            type: "structure",
                            members: {
                              IndexSlowLogs: {
                                shape: "Sg3"
                              },
                              SearchSlowLogs: {
                                shape: "Sg3"
                              },
                              AuditLogs: {
                                shape: "Sg3"
                              }
                            }
                          },
                          DomainEndpoints: {
                            shape: "S1k"
                          },
                          AdvancedSecurityOptions: {
                            type: "structure",
                            members: {
                              Enabled: {
                                type: "boolean"
                              },
                              InternalUserDatabaseEnabled: {
                                type: "boolean"
                              },
                              MasterUserOptions: {
                                type: "structure",
                                members: {
                                  MasterUserArn: {},
                                  MasterUserName: {},
                                  MasterUserPassword: {}
                                }
                              }
                            }
                          }
                        }
                      },
                      AwsEc2VpcEndpointService: {
                        type: "structure",
                        members: {
                          AcceptanceRequired: {
                            type: "boolean"
                          },
                          AvailabilityZones: {
                            shape: "S4v"
                          },
                          BaseEndpointDnsNames: {
                            shape: "S4v"
                          },
                          ManagesVpcEndpoints: {
                            type: "boolean"
                          },
                          GatewayLoadBalancerArns: {
                            shape: "S4v"
                          },
                          NetworkLoadBalancerArns: {
                            shape: "S4v"
                          },
                          PrivateDnsName: {},
                          ServiceId: {},
                          ServiceName: {},
                          ServiceState: {},
                          ServiceType: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                ServiceType: {}
                              }
                            }
                          }
                        }
                      },
                      AwsXrayEncryptionConfig: {
                        type: "structure",
                        members: {
                          KeyId: {},
                          Status: {},
                          Type: {}
                        }
                      },
                      AwsWafRateBasedRule: {
                        type: "structure",
                        members: {
                          MetricName: {},
                          Name: {},
                          RateKey: {},
                          RateLimit: {
                            type: "long"
                          },
                          RuleId: {},
                          MatchPredicates: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                DataId: {},
                                Negated: {
                                  type: "boolean"
                                },
                                Type: {}
                              }
                            }
                          }
                        }
                      },
                      AwsWafRegionalRateBasedRule: {
                        type: "structure",
                        members: {
                          MetricName: {},
                          Name: {},
                          RateKey: {},
                          RateLimit: {
                            type: "long"
                          },
                          RuleId: {},
                          MatchPredicates: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                DataId: {},
                                Negated: {
                                  type: "boolean"
                                },
                                Type: {}
                              }
                            }
                          }
                        }
                      },
                      AwsEcrRepository: {
                        type: "structure",
                        members: {
                          Arn: {},
                          ImageScanningConfiguration: {
                            type: "structure",
                            members: {
                              ScanOnPush: {
                                type: "boolean"
                              }
                            }
                          },
                          ImageTagMutability: {},
                          LifecyclePolicy: {
                            type: "structure",
                            members: {
                              LifecyclePolicyText: {},
                              RegistryId: {}
                            }
                          },
                          RepositoryName: {},
                          RepositoryPolicyText: {}
                        }
                      },
                      AwsEksCluster: {
                        type: "structure",
                        members: {
                          Arn: {},
                          CertificateAuthorityData: {},
                          ClusterStatus: {},
                          Endpoint: {},
                          Name: {},
                          ResourcesVpcConfig: {
                            type: "structure",
                            members: {
                              SecurityGroupIds: {
                                shape: "S4v"
                              },
                              SubnetIds: {
                                shape: "S4v"
                              },
                              EndpointPublicAccess: {
                                type: "boolean"
                              }
                            }
                          },
                          RoleArn: {},
                          Version: {},
                          Logging: {
                            type: "structure",
                            members: {
                              ClusterLogging: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    Enabled: {
                                      type: "boolean"
                                    },
                                    Types: {
                                      shape: "S4v"
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      },
                      AwsNetworkFirewallFirewallPolicy: {
                        type: "structure",
                        members: {
                          FirewallPolicy: {
                            type: "structure",
                            members: {
                              StatefulRuleGroupReferences: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    ResourceArn: {}
                                  }
                                }
                              },
                              StatelessCustomActions: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    ActionDefinition: {
                                      shape: "Sgu"
                                    },
                                    ActionName: {}
                                  }
                                }
                              },
                              StatelessDefaultActions: {
                                shape: "S4v"
                              },
                              StatelessFragmentDefaultActions: {
                                shape: "S4v"
                              },
                              StatelessRuleGroupReferences: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    Priority: {
                                      type: "integer"
                                    },
                                    ResourceArn: {}
                                  }
                                }
                              }
                            }
                          },
                          FirewallPolicyArn: {},
                          FirewallPolicyId: {},
                          FirewallPolicyName: {},
                          Description: {}
                        }
                      },
                      AwsNetworkFirewallFirewall: {
                        type: "structure",
                        members: {
                          DeleteProtection: {
                            type: "boolean"
                          },
                          Description: {},
                          FirewallArn: {},
                          FirewallId: {},
                          FirewallName: {},
                          FirewallPolicyArn: {},
                          FirewallPolicyChangeProtection: {
                            type: "boolean"
                          },
                          SubnetChangeProtection: {
                            type: "boolean"
                          },
                          SubnetMappings: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                SubnetId: {}
                              }
                            }
                          },
                          VpcId: {}
                        }
                      },
                      AwsNetworkFirewallRuleGroup: {
                        type: "structure",
                        members: {
                          Capacity: {
                            type: "integer"
                          },
                          Description: {},
                          RuleGroup: {
                            type: "structure",
                            members: {
                              RuleVariables: {
                                type: "structure",
                                members: {
                                  IpSets: {
                                    type: "structure",
                                    members: {
                                      Definition: {
                                        shape: "S4v"
                                      }
                                    }
                                  },
                                  PortSets: {
                                    type: "structure",
                                    members: {
                                      Definition: {
                                        shape: "S4v"
                                      }
                                    }
                                  }
                                }
                              },
                              RulesSource: {
                                type: "structure",
                                members: {
                                  RulesSourceList: {
                                    type: "structure",
                                    members: {
                                      GeneratedRulesType: {},
                                      TargetTypes: {
                                        shape: "S4v"
                                      },
                                      Targets: {
                                        shape: "S4v"
                                      }
                                    }
                                  },
                                  RulesString: {},
                                  StatefulRules: {
                                    type: "list",
                                    member: {
                                      type: "structure",
                                      members: {
                                        Action: {},
                                        Header: {
                                          type: "structure",
                                          members: {
                                            Destination: {},
                                            DestinationPort: {},
                                            Direction: {},
                                            Protocol: {},
                                            Source: {},
                                            SourcePort: {}
                                          }
                                        },
                                        RuleOptions: {
                                          type: "list",
                                          member: {
                                            type: "structure",
                                            members: {
                                              Keyword: {},
                                              Settings: {
                                                type: "list",
                                                member: {}
                                              }
                                            }
                                          }
                                        }
                                      }
                                    }
                                  },
                                  StatelessRulesAndCustomActions: {
                                    type: "structure",
                                    members: {
                                      CustomActions: {
                                        type: "list",
                                        member: {
                                          type: "structure",
                                          members: {
                                            ActionDefinition: {
                                              shape: "Sgu"
                                            },
                                            ActionName: {}
                                          }
                                        }
                                      },
                                      StatelessRules: {
                                        type: "list",
                                        member: {
                                          type: "structure",
                                          members: {
                                            Priority: {
                                              type: "integer"
                                            },
                                            RuleDefinition: {
                                              type: "structure",
                                              members: {
                                                Actions: {
                                                  shape: "S4v"
                                                },
                                                MatchAttributes: {
                                                  type: "structure",
                                                  members: {
                                                    DestinationPorts: {
                                                      type: "list",
                                                      member: {
                                                        type: "structure",
                                                        members: {
                                                          FromPort: {
                                                            type: "integer"
                                                          },
                                                          ToPort: {
                                                            type: "integer"
                                                          }
                                                        }
                                                      }
                                                    },
                                                    Destinations: {
                                                      type: "list",
                                                      member: {
                                                        type: "structure",
                                                        members: {
                                                          AddressDefinition: {}
                                                        }
                                                      }
                                                    },
                                                    Protocols: {
                                                      type: "list",
                                                      member: {
                                                        type: "integer"
                                                      }
                                                    },
                                                    SourcePorts: {
                                                      type: "list",
                                                      member: {
                                                        type: "structure",
                                                        members: {
                                                          FromPort: {
                                                            type: "integer"
                                                          },
                                                          ToPort: {
                                                            type: "integer"
                                                          }
                                                        }
                                                      }
                                                    },
                                                    Sources: {
                                                      type: "list",
                                                      member: {
                                                        type: "structure",
                                                        members: {
                                                          AddressDefinition: {}
                                                        }
                                                      }
                                                    },
                                                    TcpFlags: {
                                                      type: "list",
                                                      member: {
                                                        type: "structure",
                                                        members: {
                                                          Flags: {
                                                            shape: "S4v"
                                                          },
                                                          Masks: {
                                                            shape: "S4v"
                                                          }
                                                        }
                                                      }
                                                    }
                                                  }
                                                }
                                              }
                                            }
                                          }
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          },
                          RuleGroupArn: {},
                          RuleGroupId: {},
                          RuleGroupName: {},
                          Type: {}
                        }
                      },
                      AwsRdsDbSecurityGroup: {
                        type: "structure",
                        members: {
                          DbSecurityGroupArn: {},
                          DbSecurityGroupDescription: {},
                          DbSecurityGroupName: {},
                          Ec2SecurityGroups: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Ec2SecurityGroupId: {},
                                Ec2SecurityGroupName: {},
                                Ec2SecurityGroupOwnerId: {},
                                Status: {}
                              }
                            }
                          },
                          IpRanges: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                CidrIp: {},
                                Status: {}
                              }
                            }
                          },
                          OwnerId: {},
                          VpcId: {}
                        }
                      },
                      AwsKinesisStream: {
                        type: "structure",
                        members: {
                          Name: {},
                          Arn: {},
                          StreamEncryption: {
                            type: "structure",
                            members: {
                              EncryptionType: {},
                              KeyId: {}
                            }
                          },
                          ShardCount: {
                            type: "integer"
                          },
                          RetentionPeriodHours: {
                            type: "integer"
                          }
                        }
                      },
                      AwsEc2TransitGateway: {
                        type: "structure",
                        members: {
                          Id: {},
                          Description: {},
                          DefaultRouteTablePropagation: {},
                          AutoAcceptSharedAttachments: {},
                          DefaultRouteTableAssociation: {},
                          TransitGatewayCidrBlocks: {
                            shape: "S4v"
                          },
                          AssociationDefaultRouteTableId: {},
                          PropagationDefaultRouteTableId: {},
                          VpnEcmpSupport: {},
                          DnsSupport: {},
                          MulticastSupport: {},
                          AmazonSideAsn: {
                            type: "integer"
                          }
                        }
                      },
                      AwsEfsAccessPoint: {
                        type: "structure",
                        members: {
                          AccessPointId: {},
                          Arn: {},
                          ClientToken: {},
                          FileSystemId: {},
                          PosixUser: {
                            type: "structure",
                            members: {
                              Gid: {},
                              SecondaryGids: {
                                shape: "S4v"
                              },
                              Uid: {}
                            }
                          },
                          RootDirectory: {
                            type: "structure",
                            members: {
                              CreationInfo: {
                                type: "structure",
                                members: {
                                  OwnerGid: {},
                                  OwnerUid: {},
                                  Permissions: {}
                                }
                              },
                              Path: {}
                            }
                          }
                        }
                      },
                      AwsCloudFormationStack: {
                        type: "structure",
                        members: {
                          Capabilities: {
                            shape: "S4v"
                          },
                          CreationTime: {},
                          Description: {},
                          DisableRollback: {
                            type: "boolean"
                          },
                          DriftInformation: {
                            type: "structure",
                            members: {
                              StackDriftStatus: {}
                            }
                          },
                          EnableTerminationProtection: {
                            type: "boolean"
                          },
                          LastUpdatedTime: {},
                          NotificationArns: {
                            shape: "S4v"
                          },
                          Outputs: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Description: {},
                                OutputKey: {},
                                OutputValue: {}
                              }
                            }
                          },
                          RoleArn: {},
                          StackId: {},
                          StackName: {},
                          StackStatus: {},
                          StackStatusReason: {},
                          TimeoutInMinutes: {
                            type: "integer"
                          }
                        }
                      },
                      AwsCloudWatchAlarm: {
                        type: "structure",
                        members: {
                          ActionsEnabled: {
                            type: "boolean"
                          },
                          AlarmActions: {
                            shape: "S4v"
                          },
                          AlarmArn: {},
                          AlarmConfigurationUpdatedTimestamp: {},
                          AlarmDescription: {},
                          AlarmName: {},
                          ComparisonOperator: {},
                          DatapointsToAlarm: {
                            type: "integer"
                          },
                          Dimensions: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Name: {},
                                Value: {}
                              }
                            }
                          },
                          EvaluateLowSampleCountPercentile: {},
                          EvaluationPeriods: {
                            type: "integer"
                          },
                          ExtendedStatistic: {},
                          InsufficientDataActions: {
                            shape: "S4v"
                          },
                          MetricName: {},
                          Namespace: {},
                          OkActions: {
                            shape: "S4v"
                          },
                          Period: {
                            type: "integer"
                          },
                          Statistic: {},
                          Threshold: {
                            type: "double"
                          },
                          ThresholdMetricId: {},
                          TreatMissingData: {},
                          Unit: {}
                        }
                      },
                      AwsEc2VpcPeeringConnection: {
                        type: "structure",
                        members: {
                          AccepterVpcInfo: {
                            shape: "Sii"
                          },
                          ExpirationTime: {},
                          RequesterVpcInfo: {
                            shape: "Sii"
                          },
                          Status: {
                            type: "structure",
                            members: {
                              Code: {},
                              Message: {}
                            }
                          },
                          VpcPeeringConnectionId: {}
                        }
                      },
                      AwsWafRegionalRuleGroup: {
                        type: "structure",
                        members: {
                          MetricName: {},
                          Name: {},
                          RuleGroupId: {},
                          Rules: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Action: {
                                  type: "structure",
                                  members: {
                                    Type: {}
                                  }
                                },
                                Priority: {
                                  type: "integer"
                                },
                                RuleId: {},
                                Type: {}
                              }
                            }
                          }
                        }
                      },
                      AwsWafRegionalRule: {
                        type: "structure",
                        members: {
                          MetricName: {},
                          Name: {},
                          PredicateList: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                DataId: {},
                                Negated: {
                                  type: "boolean"
                                },
                                Type: {}
                              }
                            }
                          },
                          RuleId: {}
                        }
                      },
                      AwsWafRegionalWebAcl: {
                        type: "structure",
                        members: {
                          DefaultAction: {},
                          MetricName: {},
                          Name: {},
                          RulesList: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Action: {
                                  type: "structure",
                                  members: {
                                    Type: {}
                                  }
                                },
                                OverrideAction: {
                                  type: "structure",
                                  members: {
                                    Type: {}
                                  }
                                },
                                Priority: {
                                  type: "integer"
                                },
                                RuleId: {},
                                Type: {}
                              }
                            }
                          },
                          WebAclId: {}
                        }
                      },
                      AwsWafRule: {
                        type: "structure",
                        members: {
                          MetricName: {},
                          Name: {},
                          PredicateList: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                DataId: {},
                                Negated: {
                                  type: "boolean"
                                },
                                Type: {}
                              }
                            }
                          },
                          RuleId: {}
                        }
                      },
                      AwsWafRuleGroup: {
                        type: "structure",
                        members: {
                          MetricName: {},
                          Name: {},
                          RuleGroupId: {},
                          Rules: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Action: {
                                  type: "structure",
                                  members: {
                                    Type: {}
                                  }
                                },
                                Priority: {
                                  type: "integer"
                                },
                                RuleId: {},
                                Type: {}
                              }
                            }
                          }
                        }
                      },
                      AwsEcsTask: {
                        type: "structure",
                        members: {
                          ClusterArn: {},
                          TaskDefinitionArn: {},
                          Version: {},
                          CreatedAt: {},
                          StartedAt: {},
                          StartedBy: {},
                          Group: {},
                          Volumes: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Name: {},
                                Host: {
                                  type: "structure",
                                  members: {
                                    SourcePath: {}
                                  }
                                }
                              }
                            }
                          },
                          Containers: {
                            type: "list",
                            member: {
                              shape: "Sde"
                            }
                          }
                        }
                      },
                      AwsBackupBackupVault: {
                        type: "structure",
                        members: {
                          BackupVaultArn: {},
                          BackupVaultName: {},
                          EncryptionKeyArn: {},
                          Notifications: {
                            type: "structure",
                            members: {
                              BackupVaultEvents: {
                                shape: "S4v"
                              },
                              SnsTopicArn: {}
                            }
                          },
                          AccessPolicy: {}
                        }
                      },
                      AwsBackupBackupPlan: {
                        type: "structure",
                        members: {
                          BackupPlan: {
                            type: "structure",
                            members: {
                              BackupPlanName: {},
                              AdvancedBackupSettings: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    BackupOptions: {
                                      shape: "S1k"
                                    },
                                    ResourceType: {}
                                  }
                                }
                              },
                              BackupPlanRule: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    TargetBackupVault: {},
                                    StartWindowMinutes: {
                                      type: "long"
                                    },
                                    ScheduleExpression: {},
                                    RuleName: {},
                                    RuleId: {},
                                    EnableContinuousBackup: {
                                      type: "boolean"
                                    },
                                    CompletionWindowMinutes: {
                                      type: "long"
                                    },
                                    CopyActions: {
                                      type: "list",
                                      member: {
                                        type: "structure",
                                        members: {
                                          DestinationBackupVaultArn: {},
                                          Lifecycle: {
                                            shape: "Sjn"
                                          }
                                        }
                                      }
                                    },
                                    Lifecycle: {
                                      shape: "Sjn"
                                    }
                                  }
                                }
                              }
                            }
                          },
                          BackupPlanArn: {},
                          BackupPlanId: {},
                          VersionId: {}
                        }
                      },
                      AwsBackupRecoveryPoint: {
                        type: "structure",
                        members: {
                          BackupSizeInBytes: {
                            type: "long"
                          },
                          BackupVaultArn: {},
                          BackupVaultName: {},
                          CalculatedLifecycle: {
                            type: "structure",
                            members: {
                              DeleteAt: {},
                              MoveToColdStorageAt: {}
                            }
                          },
                          CompletionDate: {},
                          CreatedBy: {
                            type: "structure",
                            members: {
                              BackupPlanArn: {},
                              BackupPlanId: {},
                              BackupPlanVersion: {},
                              BackupRuleId: {}
                            }
                          },
                          CreationDate: {},
                          EncryptionKeyArn: {},
                          IamRoleArn: {},
                          IsEncrypted: {
                            type: "boolean"
                          },
                          LastRestoreTime: {},
                          Lifecycle: {
                            type: "structure",
                            members: {
                              DeleteAfterDays: {
                                type: "long"
                              },
                              MoveToColdStorageAfterDays: {
                                type: "long"
                              }
                            }
                          },
                          RecoveryPointArn: {},
                          ResourceArn: {},
                          ResourceType: {},
                          SourceBackupVaultArn: {},
                          Status: {},
                          StatusMessage: {},
                          StorageClass: {}
                        }
                      },
                      AwsEc2LaunchTemplate: {
                        type: "structure",
                        members: {
                          LaunchTemplateName: {},
                          Id: {},
                          LaunchTemplateData: {
                            type: "structure",
                            members: {
                              BlockDeviceMappingSet: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    DeviceName: {},
                                    Ebs: {
                                      type: "structure",
                                      members: {
                                        DeleteOnTermination: {
                                          type: "boolean"
                                        },
                                        Encrypted: {
                                          type: "boolean"
                                        },
                                        Iops: {
                                          type: "integer"
                                        },
                                        KmsKeyId: {},
                                        SnapshotId: {},
                                        Throughput: {
                                          type: "integer"
                                        },
                                        VolumeSize: {
                                          type: "integer"
                                        },
                                        VolumeType: {}
                                      }
                                    },
                                    NoDevice: {},
                                    VirtualName: {}
                                  }
                                }
                              },
                              CapacityReservationSpecification: {
                                type: "structure",
                                members: {
                                  CapacityReservationPreference: {},
                                  CapacityReservationTarget: {
                                    type: "structure",
                                    members: {
                                      CapacityReservationId: {},
                                      CapacityReservationResourceGroupArn: {}
                                    }
                                  }
                                }
                              },
                              CpuOptions: {
                                type: "structure",
                                members: {
                                  CoreCount: {
                                    type: "integer"
                                  },
                                  ThreadsPerCore: {
                                    type: "integer"
                                  }
                                }
                              },
                              CreditSpecification: {
                                type: "structure",
                                members: {
                                  CpuCredits: {}
                                }
                              },
                              DisableApiStop: {
                                type: "boolean"
                              },
                              DisableApiTermination: {
                                type: "boolean"
                              },
                              EbsOptimized: {
                                type: "boolean"
                              },
                              ElasticGpuSpecificationSet: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    Type: {}
                                  }
                                }
                              },
                              ElasticInferenceAcceleratorSet: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    Count: {
                                      type: "integer"
                                    },
                                    Type: {}
                                  }
                                }
                              },
                              EnclaveOptions: {
                                type: "structure",
                                members: {
                                  Enabled: {
                                    type: "boolean"
                                  }
                                }
                              },
                              HibernationOptions: {
                                type: "structure",
                                members: {
                                  Configured: {
                                    type: "boolean"
                                  }
                                }
                              },
                              IamInstanceProfile: {
                                type: "structure",
                                members: {
                                  Arn: {},
                                  Name: {}
                                }
                              },
                              ImageId: {},
                              InstanceInitiatedShutdownBehavior: {},
                              InstanceMarketOptions: {
                                type: "structure",
                                members: {
                                  MarketType: {},
                                  SpotOptions: {
                                    type: "structure",
                                    members: {
                                      BlockDurationMinutes: {
                                        type: "integer"
                                      },
                                      InstanceInterruptionBehavior: {},
                                      MaxPrice: {},
                                      SpotInstanceType: {},
                                      ValidUntil: {}
                                    }
                                  }
                                }
                              },
                              InstanceRequirements: {
                                type: "structure",
                                members: {
                                  AcceleratorCount: {
                                    type: "structure",
                                    members: {
                                      Max: {
                                        type: "integer"
                                      },
                                      Min: {
                                        type: "integer"
                                      }
                                    }
                                  },
                                  AcceleratorManufacturers: {
                                    shape: "S4v"
                                  },
                                  AcceleratorNames: {
                                    shape: "S4v"
                                  },
                                  AcceleratorTotalMemoryMiB: {
                                    type: "structure",
                                    members: {
                                      Max: {
                                        type: "integer"
                                      },
                                      Min: {
                                        type: "integer"
                                      }
                                    }
                                  },
                                  AcceleratorTypes: {
                                    shape: "S4v"
                                  },
                                  BareMetal: {},
                                  BaselineEbsBandwidthMbps: {
                                    type: "structure",
                                    members: {
                                      Max: {
                                        type: "integer"
                                      },
                                      Min: {
                                        type: "integer"
                                      }
                                    }
                                  },
                                  BurstablePerformance: {},
                                  CpuManufacturers: {
                                    shape: "S4v"
                                  },
                                  ExcludedInstanceTypes: {
                                    shape: "S4v"
                                  },
                                  InstanceGenerations: {
                                    shape: "S4v"
                                  },
                                  LocalStorage: {},
                                  LocalStorageTypes: {
                                    shape: "S4v"
                                  },
                                  MemoryGiBPerVCpu: {
                                    type: "structure",
                                    members: {
                                      Max: {
                                        type: "double"
                                      },
                                      Min: {
                                        type: "double"
                                      }
                                    }
                                  },
                                  MemoryMiB: {
                                    type: "structure",
                                    members: {
                                      Max: {
                                        type: "integer"
                                      },
                                      Min: {
                                        type: "integer"
                                      }
                                    }
                                  },
                                  NetworkInterfaceCount: {
                                    type: "structure",
                                    members: {
                                      Max: {
                                        type: "integer"
                                      },
                                      Min: {
                                        type: "integer"
                                      }
                                    }
                                  },
                                  OnDemandMaxPricePercentageOverLowestPrice: {
                                    type: "integer"
                                  },
                                  RequireHibernateSupport: {
                                    type: "boolean"
                                  },
                                  SpotMaxPricePercentageOverLowestPrice: {
                                    type: "integer"
                                  },
                                  TotalLocalStorageGB: {
                                    type: "structure",
                                    members: {
                                      Max: {
                                        type: "double"
                                      },
                                      Min: {
                                        type: "double"
                                      }
                                    }
                                  },
                                  VCpuCount: {
                                    type: "structure",
                                    members: {
                                      Max: {
                                        type: "integer"
                                      },
                                      Min: {
                                        type: "integer"
                                      }
                                    }
                                  }
                                }
                              },
                              InstanceType: {},
                              KernelId: {},
                              KeyName: {},
                              LicenseSet: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    LicenseConfigurationArn: {}
                                  }
                                }
                              },
                              MaintenanceOptions: {
                                type: "structure",
                                members: {
                                  AutoRecovery: {}
                                }
                              },
                              MetadataOptions: {
                                type: "structure",
                                members: {
                                  HttpEndpoint: {},
                                  HttpProtocolIpv6: {},
                                  HttpTokens: {},
                                  HttpPutResponseHopLimit: {
                                    type: "integer"
                                  },
                                  InstanceMetadataTags: {}
                                }
                              },
                              Monitoring: {
                                type: "structure",
                                members: {
                                  Enabled: {
                                    type: "boolean"
                                  }
                                }
                              },
                              NetworkInterfaceSet: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    AssociateCarrierIpAddress: {
                                      type: "boolean"
                                    },
                                    AssociatePublicIpAddress: {
                                      type: "boolean"
                                    },
                                    DeleteOnTermination: {
                                      type: "boolean"
                                    },
                                    Description: {},
                                    DeviceIndex: {
                                      type: "integer"
                                    },
                                    Groups: {
                                      shape: "S4v"
                                    },
                                    InterfaceType: {},
                                    Ipv4PrefixCount: {
                                      type: "integer"
                                    },
                                    Ipv4Prefixes: {
                                      type: "list",
                                      member: {
                                        type: "structure",
                                        members: {
                                          Ipv4Prefix: {}
                                        }
                                      }
                                    },
                                    Ipv6AddressCount: {
                                      type: "integer"
                                    },
                                    Ipv6Addresses: {
                                      type: "list",
                                      member: {
                                        type: "structure",
                                        members: {
                                          Ipv6Address: {}
                                        }
                                      }
                                    },
                                    Ipv6PrefixCount: {
                                      type: "integer"
                                    },
                                    Ipv6Prefixes: {
                                      type: "list",
                                      member: {
                                        type: "structure",
                                        members: {
                                          Ipv6Prefix: {}
                                        }
                                      }
                                    },
                                    NetworkCardIndex: {
                                      type: "integer"
                                    },
                                    NetworkInterfaceId: {},
                                    PrivateIpAddress: {},
                                    PrivateIpAddresses: {
                                      type: "list",
                                      member: {
                                        type: "structure",
                                        members: {
                                          Primary: {
                                            type: "boolean"
                                          },
                                          PrivateIpAddress: {}
                                        }
                                      }
                                    },
                                    SecondaryPrivateIpAddressCount: {
                                      type: "integer"
                                    },
                                    SubnetId: {}
                                  }
                                }
                              },
                              Placement: {
                                type: "structure",
                                members: {
                                  Affinity: {},
                                  AvailabilityZone: {},
                                  GroupName: {},
                                  HostId: {},
                                  HostResourceGroupArn: {},
                                  PartitionNumber: {
                                    type: "integer"
                                  },
                                  SpreadDomain: {},
                                  Tenancy: {}
                                }
                              },
                              PrivateDnsNameOptions: {
                                type: "structure",
                                members: {
                                  EnableResourceNameDnsAAAARecord: {
                                    type: "boolean"
                                  },
                                  EnableResourceNameDnsARecord: {
                                    type: "boolean"
                                  },
                                  HostnameType: {}
                                }
                              },
                              RamDiskId: {},
                              SecurityGroupIdSet: {
                                shape: "S4v"
                              },
                              SecurityGroupSet: {
                                shape: "S4v"
                              },
                              UserData: {}
                            }
                          },
                          DefaultVersionNumber: {
                            type: "long"
                          },
                          LatestVersionNumber: {
                            type: "long"
                          }
                        }
                      },
                      AwsSageMakerNotebookInstance: {
                        type: "structure",
                        members: {
                          AcceleratorTypes: {
                            shape: "S4v"
                          },
                          AdditionalCodeRepositories: {
                            shape: "S4v"
                          },
                          DefaultCodeRepository: {},
                          DirectInternetAccess: {},
                          FailureReason: {},
                          InstanceMetadataServiceConfiguration: {
                            type: "structure",
                            members: {
                              MinimumInstanceMetadataServiceVersion: {}
                            }
                          },
                          InstanceType: {},
                          KmsKeyId: {},
                          NetworkInterfaceId: {},
                          NotebookInstanceArn: {},
                          NotebookInstanceLifecycleConfigName: {},
                          NotebookInstanceName: {},
                          NotebookInstanceStatus: {},
                          PlatformIdentifier: {},
                          RoleArn: {},
                          RootAccess: {},
                          SecurityGroups: {
                            shape: "S4v"
                          },
                          SubnetId: {},
                          Url: {},
                          VolumeSizeInGB: {
                            type: "integer"
                          }
                        }
                      },
                      AwsWafv2WebAcl: {
                        type: "structure",
                        members: {
                          Name: {},
                          Arn: {},
                          ManagedbyFirewallManager: {
                            type: "boolean"
                          },
                          Id: {},
                          Capacity: {
                            type: "long"
                          },
                          CaptchaConfig: {
                            type: "structure",
                            members: {
                              ImmunityTimeProperty: {
                                type: "structure",
                                members: {
                                  ImmunityTime: {
                                    type: "long"
                                  }
                                }
                              }
                            }
                          },
                          DefaultAction: {
                            type: "structure",
                            members: {
                              Allow: {
                                shape: "Sl6"
                              },
                              Block: {
                                shape: "Sla"
                              }
                            }
                          },
                          Description: {},
                          Rules: {
                            shape: "Slc"
                          },
                          VisibilityConfig: {
                            shape: "Slh"
                          }
                        }
                      },
                      AwsWafv2RuleGroup: {
                        type: "structure",
                        members: {
                          Capacity: {
                            type: "long"
                          },
                          Description: {},
                          Id: {},
                          Name: {},
                          Arn: {},
                          Rules: {
                            shape: "Slc"
                          },
                          Scope: {},
                          VisibilityConfig: {
                            shape: "Slh"
                          }
                        }
                      },
                      AwsEc2RouteTable: {
                        type: "structure",
                        members: {
                          AssociationSet: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                AssociationState: {
                                  type: "structure",
                                  members: {
                                    State: {},
                                    StatusMessage: {}
                                  }
                                },
                                GatewayId: {},
                                Main: {
                                  type: "boolean"
                                },
                                RouteTableAssociationId: {},
                                RouteTableId: {},
                                SubnetId: {}
                              }
                            }
                          },
                          OwnerId: {},
                          PropagatingVgwSet: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                GatewayId: {}
                              }
                            }
                          },
                          RouteTableId: {},
                          RouteSet: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                CarrierGatewayId: {},
                                CoreNetworkArn: {},
                                DestinationCidrBlock: {},
                                DestinationIpv6CidrBlock: {},
                                DestinationPrefixListId: {},
                                EgressOnlyInternetGatewayId: {},
                                GatewayId: {},
                                InstanceId: {},
                                InstanceOwnerId: {},
                                LocalGatewayId: {},
                                NatGatewayId: {},
                                NetworkInterfaceId: {},
                                Origin: {},
                                State: {},
                                TransitGatewayId: {},
                                VpcPeeringConnectionId: {}
                              }
                            }
                          },
                          VpcId: {}
                        }
                      },
                      AwsAmazonMqBroker: {
                        type: "structure",
                        members: {
                          AuthenticationStrategy: {},
                          AutoMinorVersionUpgrade: {
                            type: "boolean"
                          },
                          BrokerArn: {},
                          BrokerName: {},
                          DeploymentMode: {},
                          EncryptionOptions: {
                            type: "structure",
                            members: {
                              KmsKeyId: {},
                              UseAwsOwnedKey: {
                                type: "boolean"
                              }
                            }
                          },
                          EngineType: {},
                          EngineVersion: {},
                          HostInstanceType: {},
                          BrokerId: {},
                          LdapServerMetadata: {
                            type: "structure",
                            members: {
                              Hosts: {
                                shape: "S23"
                              },
                              RoleBase: {},
                              RoleName: {},
                              RoleSearchMatching: {},
                              RoleSearchSubtree: {
                                type: "boolean"
                              },
                              ServiceAccountUsername: {},
                              UserBase: {},
                              UserRoleName: {},
                              UserSearchMatching: {},
                              UserSearchSubtree: {
                                type: "boolean"
                              }
                            }
                          },
                          Logs: {
                            type: "structure",
                            members: {
                              Audit: {
                                type: "boolean"
                              },
                              General: {
                                type: "boolean"
                              },
                              AuditLogGroup: {},
                              GeneralLogGroup: {},
                              Pending: {
                                type: "structure",
                                members: {
                                  Audit: {
                                    type: "boolean"
                                  },
                                  General: {
                                    type: "boolean"
                                  }
                                }
                              }
                            }
                          },
                          MaintenanceWindowStartTime: {
                            type: "structure",
                            members: {
                              DayOfWeek: {},
                              TimeOfDay: {},
                              TimeZone: {}
                            }
                          },
                          PubliclyAccessible: {
                            type: "boolean"
                          },
                          SecurityGroups: {
                            shape: "S23"
                          },
                          StorageType: {},
                          SubnetIds: {
                            shape: "S23"
                          },
                          Users: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                PendingChange: {},
                                Username: {}
                              }
                            }
                          }
                        }
                      },
                      AwsAppSyncGraphQlApi: {
                        type: "structure",
                        members: {
                          ApiId: {},
                          Id: {},
                          OpenIdConnectConfig: {
                            shape: "Sm0"
                          },
                          Name: {},
                          LambdaAuthorizerConfig: {
                            shape: "Sm1"
                          },
                          XrayEnabled: {
                            type: "boolean"
                          },
                          Arn: {},
                          UserPoolConfig: {
                            shape: "Sm2"
                          },
                          AuthenticationType: {},
                          LogConfig: {
                            type: "structure",
                            members: {
                              CloudWatchLogsRoleArn: {},
                              ExcludeVerboseContent: {
                                type: "boolean"
                              },
                              FieldLogLevel: {}
                            }
                          },
                          AdditionalAuthenticationProviders: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                AuthenticationType: {},
                                LambdaAuthorizerConfig: {
                                  shape: "Sm1"
                                },
                                OpenIdConnectConfig: {
                                  shape: "Sm0"
                                },
                                UserPoolConfig: {
                                  shape: "Sm2"
                                }
                              }
                            }
                          },
                          WafWebAclArn: {}
                        }
                      },
                      AwsEventSchemasRegistry: {
                        type: "structure",
                        members: {
                          Description: {},
                          RegistryArn: {},
                          RegistryName: {}
                        }
                      },
                      AwsGuardDutyDetector: {
                        type: "structure",
                        members: {
                          DataSources: {
                            type: "structure",
                            members: {
                              CloudTrail: {
                                type: "structure",
                                members: {
                                  Status: {}
                                }
                              },
                              DnsLogs: {
                                type: "structure",
                                members: {
                                  Status: {}
                                }
                              },
                              FlowLogs: {
                                type: "structure",
                                members: {
                                  Status: {}
                                }
                              },
                              Kubernetes: {
                                type: "structure",
                                members: {
                                  AuditLogs: {
                                    type: "structure",
                                    members: {
                                      Status: {}
                                    }
                                  }
                                }
                              },
                              MalwareProtection: {
                                type: "structure",
                                members: {
                                  ScanEc2InstanceWithFindings: {
                                    type: "structure",
                                    members: {
                                      EbsVolumes: {
                                        type: "structure",
                                        members: {
                                          Reason: {},
                                          Status: {}
                                        }
                                      }
                                    }
                                  },
                                  ServiceRole: {}
                                }
                              },
                              S3Logs: {
                                type: "structure",
                                members: {
                                  Status: {}
                                }
                              }
                            }
                          },
                          Features: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Name: {},
                                Status: {}
                              }
                            }
                          },
                          FindingPublishingFrequency: {},
                          ServiceRole: {},
                          Status: {}
                        }
                      },
                      AwsStepFunctionStateMachine: {
                        type: "structure",
                        members: {
                          Label: {},
                          LoggingConfiguration: {
                            type: "structure",
                            members: {
                              Destinations: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    CloudWatchLogsLogGroup: {
                                      type: "structure",
                                      members: {
                                        LogGroupArn: {}
                                      }
                                    }
                                  }
                                }
                              },
                              IncludeExecutionData: {
                                type: "boolean"
                              },
                              Level: {}
                            }
                          },
                          Name: {},
                          RoleArn: {},
                          StateMachineArn: {},
                          Status: {},
                          TracingConfiguration: {
                            type: "structure",
                            members: {
                              Enabled: {
                                type: "boolean"
                              }
                            }
                          },
                          Type: {}
                        }
                      },
                      AwsAthenaWorkGroup: {
                        type: "structure",
                        members: {
                          Name: {},
                          Description: {},
                          State: {},
                          Configuration: {
                            type: "structure",
                            members: {
                              ResultConfiguration: {
                                type: "structure",
                                members: {
                                  EncryptionConfiguration: {
                                    type: "structure",
                                    members: {
                                      EncryptionOption: {},
                                      KmsKey: {}
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      },
                      AwsEventsEventbus: {
                        type: "structure",
                        members: {
                          Arn: {},
                          Name: {},
                          Policy: {}
                        }
                      },
                      AwsDmsEndpoint: {
                        type: "structure",
                        members: {
                          CertificateArn: {},
                          DatabaseName: {},
                          EndpointArn: {},
                          EndpointIdentifier: {},
                          EndpointType: {},
                          EngineName: {},
                          ExternalId: {},
                          ExtraConnectionAttributes: {},
                          KmsKeyId: {},
                          Port: {
                            type: "integer"
                          },
                          ServerName: {},
                          SslMode: {},
                          Username: {}
                        }
                      },
                      AwsEventsEndpoint: {
                        type: "structure",
                        members: {
                          Arn: {},
                          Description: {},
                          EndpointId: {},
                          EndpointUrl: {},
                          EventBuses: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                EventBusArn: {}
                              }
                            }
                          },
                          Name: {},
                          ReplicationConfig: {
                            type: "structure",
                            members: {
                              State: {}
                            }
                          },
                          RoleArn: {},
                          RoutingConfig: {
                            type: "structure",
                            members: {
                              FailoverConfig: {
                                type: "structure",
                                members: {
                                  Primary: {
                                    type: "structure",
                                    members: {
                                      HealthCheck: {}
                                    }
                                  },
                                  Secondary: {
                                    type: "structure",
                                    members: {
                                      Route: {}
                                    }
                                  }
                                }
                              }
                            }
                          },
                          State: {},
                          StateReason: {}
                        }
                      },
                      AwsDmsReplicationTask: {
                        type: "structure",
                        members: {
                          CdcStartPosition: {},
                          CdcStartTime: {},
                          CdcStopPosition: {},
                          MigrationType: {},
                          Id: {},
                          ResourceIdentifier: {},
                          ReplicationInstanceArn: {},
                          ReplicationTaskIdentifier: {},
                          ReplicationTaskSettings: {},
                          SourceEndpointArn: {},
                          TableMappings: {},
                          TargetEndpointArn: {},
                          TaskData: {}
                        }
                      },
                      AwsDmsReplicationInstance: {
                        type: "structure",
                        members: {
                          AllocatedStorage: {
                            type: "integer"
                          },
                          AutoMinorVersionUpgrade: {
                            type: "boolean"
                          },
                          AvailabilityZone: {},
                          EngineVersion: {},
                          KmsKeyId: {},
                          MultiAZ: {
                            type: "boolean"
                          },
                          PreferredMaintenanceWindow: {},
                          PubliclyAccessible: {
                            type: "boolean"
                          },
                          ReplicationInstanceClass: {},
                          ReplicationInstanceIdentifier: {},
                          ReplicationSubnetGroup: {
                            type: "structure",
                            members: {
                              ReplicationSubnetGroupIdentifier: {}
                            }
                          },
                          VpcSecurityGroups: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                VpcSecurityGroupId: {}
                              }
                            }
                          }
                        }
                      },
                      AwsRoute53HostedZone: {
                        type: "structure",
                        members: {
                          HostedZone: {
                            type: "structure",
                            members: {
                              Id: {},
                              Name: {},
                              Config: {
                                type: "structure",
                                members: {
                                  Comment: {}
                                }
                              }
                            }
                          },
                          Vpcs: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Id: {},
                                Region: {}
                              }
                            }
                          },
                          NameServers: {
                            type: "list",
                            member: {}
                          },
                          QueryLoggingConfig: {
                            type: "structure",
                            members: {
                              CloudWatchLogsLogGroupArn: {
                                type: "structure",
                                members: {
                                  CloudWatchLogsLogGroupArn: {},
                                  HostedZoneId: {},
                                  Id: {}
                                }
                              }
                            }
                          }
                        }
                      },
                      AwsMskCluster: {
                        type: "structure",
                        members: {
                          ClusterInfo: {
                            type: "structure",
                            members: {
                              EncryptionInfo: {
                                type: "structure",
                                members: {
                                  EncryptionInTransit: {
                                    type: "structure",
                                    members: {
                                      InCluster: {
                                        type: "boolean"
                                      },
                                      ClientBroker: {}
                                    }
                                  },
                                  EncryptionAtRest: {
                                    type: "structure",
                                    members: {
                                      DataVolumeKMSKeyId: {}
                                    }
                                  }
                                }
                              },
                              CurrentVersion: {},
                              NumberOfBrokerNodes: {
                                type: "integer"
                              },
                              ClusterName: {},
                              ClientAuthentication: {
                                type: "structure",
                                members: {
                                  Sasl: {
                                    type: "structure",
                                    members: {
                                      Iam: {
                                        type: "structure",
                                        members: {
                                          Enabled: {
                                            type: "boolean"
                                          }
                                        }
                                      },
                                      Scram: {
                                        type: "structure",
                                        members: {
                                          Enabled: {
                                            type: "boolean"
                                          }
                                        }
                                      }
                                    }
                                  },
                                  Unauthenticated: {
                                    type: "structure",
                                    members: {
                                      Enabled: {
                                        type: "boolean"
                                      }
                                    }
                                  },
                                  Tls: {
                                    type: "structure",
                                    members: {
                                      CertificateAuthorityArnList: {
                                        shape: "S23"
                                      },
                                      Enabled: {
                                        type: "boolean"
                                      }
                                    }
                                  }
                                }
                              },
                              EnhancedMonitoring: {}
                            }
                          }
                        }
                      },
                      AwsS3AccessPoint: {
                        type: "structure",
                        members: {
                          AccessPointArn: {},
                          Alias: {},
                          Bucket: {},
                          BucketAccountId: {},
                          Name: {},
                          NetworkOrigin: {},
                          PublicAccessBlockConfiguration: {
                            shape: "S7q"
                          },
                          VpcConfiguration: {
                            type: "structure",
                            members: {
                              VpcId: {}
                            }
                          }
                        }
                      },
                      AwsEc2ClientVpnEndpoint: {
                        type: "structure",
                        members: {
                          ClientVpnEndpointId: {},
                          Description: {},
                          ClientCidrBlock: {},
                          DnsServer: {
                            shape: "S23"
                          },
                          SplitTunnel: {
                            type: "boolean"
                          },
                          TransportProtocol: {},
                          VpnPort: {
                            type: "integer"
                          },
                          ServerCertificateArn: {},
                          AuthenticationOptions: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Type: {},
                                ActiveDirectory: {
                                  type: "structure",
                                  members: {
                                    DirectoryId: {}
                                  }
                                },
                                MutualAuthentication: {
                                  type: "structure",
                                  members: {
                                    ClientRootCertificateChain: {}
                                  }
                                },
                                FederatedAuthentication: {
                                  type: "structure",
                                  members: {
                                    SamlProviderArn: {},
                                    SelfServiceSamlProviderArn: {}
                                  }
                                }
                              }
                            }
                          },
                          ConnectionLogOptions: {
                            type: "structure",
                            members: {
                              Enabled: {
                                type: "boolean"
                              },
                              CloudwatchLogGroup: {},
                              CloudwatchLogStream: {}
                            }
                          },
                          SecurityGroupIdSet: {
                            shape: "S23"
                          },
                          VpcId: {},
                          SelfServicePortalUrl: {},
                          ClientConnectOptions: {
                            type: "structure",
                            members: {
                              Enabled: {
                                type: "boolean"
                              },
                              LambdaFunctionArn: {},
                              Status: {
                                type: "structure",
                                members: {
                                  Code: {},
                                  Message: {}
                                }
                              }
                            }
                          },
                          SessionTimeoutHours: {
                            type: "integer"
                          },
                          ClientLoginBannerOptions: {
                            type: "structure",
                            members: {
                              Enabled: {
                                type: "boolean"
                              },
                              BannerText: {}
                            }
                          }
                        }
                      }
                    }
                  },
                  ApplicationName: {},
                  ApplicationArn: {}
                }
              }
            },
            Compliance: {
              type: "structure",
              members: {
                Status: {},
                RelatedRequirements: {
                  shape: "S2q"
                },
                StatusReasons: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "ReasonCode"
                    ],
                    members: {
                      ReasonCode: {},
                      Description: {}
                    }
                  }
                },
                SecurityControlId: {},
                AssociatedStandards: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      StandardsId: {}
                    }
                  }
                },
                SecurityControlParameters: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      Name: {},
                      Value: {
                        shape: "S1j"
                      }
                    }
                  }
                }
              }
            },
            VerificationState: {},
            WorkflowState: {
              type: "string",
              deprecated: true,
              deprecatedMessage: "This filter is deprecated. Instead, use SeverityLabel or FindingProviderFieldsSeverityLabel."
            },
            Workflow: {
              type: "structure",
              members: {
                Status: {}
              }
            },
            RecordState: {},
            RelatedFindings: {
              shape: "S1n"
            },
            Note: {
              type: "structure",
              required: [
                "Text",
                "UpdatedBy",
                "UpdatedAt"
              ],
              members: {
                Text: {},
                UpdatedBy: {},
                UpdatedAt: {}
              }
            },
            Vulnerabilities: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Id"
                ],
                members: {
                  Id: {},
                  VulnerablePackages: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {},
                        Version: {},
                        Epoch: {},
                        Release: {},
                        Architecture: {},
                        PackageManager: {},
                        FilePath: {},
                        FixedInVersion: {},
                        Remediation: {},
                        SourceLayerHash: {},
                        SourceLayerArn: {}
                      }
                    }
                  },
                  Cvss: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Version: {},
                        BaseScore: {
                          type: "double"
                        },
                        BaseVector: {},
                        Source: {},
                        Adjustments: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              Metric: {},
                              Reason: {}
                            }
                          }
                        }
                      }
                    }
                  },
                  RelatedVulnerabilities: {
                    shape: "S23"
                  },
                  Vendor: {
                    type: "structure",
                    required: [
                      "Name"
                    ],
                    members: {
                      Name: {},
                      Url: {},
                      VendorSeverity: {},
                      VendorCreatedAt: {},
                      VendorUpdatedAt: {}
                    }
                  },
                  ReferenceUrls: {
                    shape: "S23"
                  },
                  FixAvailable: {},
                  EpssScore: {
                    type: "double"
                  },
                  ExploitAvailable: {},
                  CodeVulnerabilities: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Cwes: {
                          shape: "S1j"
                        },
                        FilePath: {
                          type: "structure",
                          members: {
                            EndLine: {
                              type: "integer"
                            },
                            FileName: {},
                            FilePath: {},
                            StartLine: {
                              type: "integer"
                            }
                          }
                        },
                        SourceArn: {}
                      }
                    }
                  }
                }
              }
            },
            PatchSummary: {
              type: "structure",
              required: [
                "Id"
              ],
              members: {
                Id: {},
                InstalledCount: {
                  type: "integer"
                },
                MissingCount: {
                  type: "integer"
                },
                FailedCount: {
                  type: "integer"
                },
                InstalledOtherCount: {
                  type: "integer"
                },
                InstalledRejectedCount: {
                  type: "integer"
                },
                InstalledPendingReboot: {
                  type: "integer"
                },
                OperationStartTime: {},
                OperationEndTime: {},
                RebootOption: {},
                Operation: {}
              }
            },
            Action: {
              type: "structure",
              members: {
                ActionType: {},
                NetworkConnectionAction: {
                  type: "structure",
                  members: {
                    ConnectionDirection: {},
                    RemoteIpDetails: {
                      shape: "Sox"
                    },
                    RemotePortDetails: {
                      type: "structure",
                      members: {
                        Port: {
                          type: "integer"
                        },
                        PortName: {}
                      }
                    },
                    LocalPortDetails: {
                      shape: "Sp3"
                    },
                    Protocol: {},
                    Blocked: {
                      type: "boolean"
                    }
                  }
                },
                AwsApiCallAction: {
                  type: "structure",
                  members: {
                    Api: {},
                    ServiceName: {},
                    CallerType: {},
                    RemoteIpDetails: {
                      shape: "Sox"
                    },
                    DomainDetails: {
                      type: "structure",
                      members: {
                        Domain: {}
                      }
                    },
                    AffectedResources: {
                      shape: "S1k"
                    },
                    FirstSeen: {},
                    LastSeen: {}
                  }
                },
                DnsRequestAction: {
                  type: "structure",
                  members: {
                    Domain: {},
                    Protocol: {},
                    Blocked: {
                      type: "boolean"
                    }
                  }
                },
                PortProbeAction: {
                  type: "structure",
                  members: {
                    PortProbeDetails: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          LocalPortDetails: {
                            shape: "Sp3"
                          },
                          LocalIpDetails: {
                            type: "structure",
                            members: {
                              IpAddressV4: {}
                            }
                          },
                          RemoteIpDetails: {
                            shape: "Sox"
                          }
                        }
                      }
                    },
                    Blocked: {
                      type: "boolean"
                    }
                  }
                }
              }
            },
            FindingProviderFields: {
              type: "structure",
              members: {
                Confidence: {
                  type: "integer"
                },
                Criticality: {
                  type: "integer"
                },
                RelatedFindings: {
                  shape: "S1n"
                },
                Severity: {
                  type: "structure",
                  members: {
                    Label: {},
                    Original: {}
                  }
                },
                Types: {
                  shape: "S1j"
                }
              }
            },
            Sample: {
              type: "boolean"
            },
            GeneratorDetails: {
              type: "structure",
              members: {
                Name: {},
                Description: {},
                Labels: {
                  shape: "S1j"
                }
              }
            },
            ProcessedAt: {},
            AwsAccountName: {}
          }
        },
        S36: {
          type: "structure",
          members: {
            Begin: {
              type: "integer"
            },
            End: {
              type: "integer"
            }
          }
        },
        S39: {
          type: "structure",
          members: {
            Protocol: {},
            Destination: {
              shape: "S3a"
            },
            Source: {
              shape: "S3a"
            }
          }
        },
        S3a: {
          type: "structure",
          members: {
            Address: {
              shape: "S23"
            },
            PortRanges: {
              type: "list",
              member: {
                shape: "S36"
              }
            }
          }
        },
        S3w: {
          type: "structure",
          members: {
            LineRanges: {
              shape: "S3x"
            },
            OffsetRanges: {
              shape: "S3x"
            },
            Pages: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  PageNumber: {
                    type: "long"
                  },
                  LineRange: {
                    shape: "S3y"
                  },
                  OffsetRange: {
                    shape: "S3y"
                  }
                }
              }
            },
            Records: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  JsonPath: {},
                  RecordIndex: {
                    type: "long"
                  }
                }
              }
            },
            Cells: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Column: {
                    type: "long"
                  },
                  Row: {
                    type: "long"
                  },
                  ColumnName: {},
                  CellReference: {}
                }
              }
            }
          }
        },
        S3x: {
          type: "list",
          member: {
            shape: "S3y"
          }
        },
        S3y: {
          type: "structure",
          members: {
            Start: {
              type: "long"
            },
            End: {
              type: "long"
            },
            StartColumn: {
              type: "long"
            }
          }
        },
        S4k: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ArtifactIdentifier: {},
              EncryptionDisabled: {
                type: "boolean"
              },
              Location: {},
              Name: {},
              NamespaceType: {},
              OverrideArtifactName: {
                type: "boolean"
              },
              Packaging: {},
              Path: {},
              Type: {}
            }
          }
        },
        S4v: {
          type: "list",
          member: {}
        },
        S5t: {
          type: "list",
          member: {
            type: "structure",
            members: {
              IpProtocol: {},
              FromPort: {
                type: "integer"
              },
              ToPort: {
                type: "integer"
              },
              UserIdGroupPairs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    GroupId: {},
                    GroupName: {},
                    PeeringStatus: {},
                    UserId: {},
                    VpcId: {},
                    VpcPeeringConnectionId: {}
                  }
                }
              },
              IpRanges: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CidrIp: {}
                  }
                }
              },
              Ipv6Ranges: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CidrIpv6: {}
                  }
                }
              },
              PrefixListIds: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PrefixListId: {}
                  }
                }
              }
            }
          }
        },
        S69: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AssociationId: {},
              Ipv6CidrBlock: {},
              CidrBlockState: {}
            }
          }
        },
        S73: {
          type: "structure",
          members: {
            CloudWatchLogsLogGroupArn: {},
            Enabled: {
              type: "boolean"
            }
          }
        },
        S7q: {
          type: "structure",
          members: {
            BlockPublicAcls: {
              type: "boolean"
            },
            BlockPublicPolicy: {
              type: "boolean"
            },
            IgnorePublicAcls: {
              type: "boolean"
            },
            RestrictPublicBuckets: {
              type: "boolean"
            }
          }
        },
        S8k: {
          type: "list",
          member: {
            type: "structure",
            members: {
              PolicyName: {},
              PolicyArn: {}
            }
          }
        },
        S8m: {
          type: "structure",
          members: {
            PermissionsBoundaryArn: {},
            PermissionsBoundaryType: {}
          }
        },
        S8t: {
          type: "structure",
          members: {
            DetailedMetricsEnabled: {
              type: "boolean"
            },
            LoggingLevel: {},
            DataTraceEnabled: {
              type: "boolean"
            },
            ThrottlingBurstLimit: {
              type: "integer"
            },
            ThrottlingRateLimit: {
              type: "double"
            }
          }
        },
        S8u: {
          type: "structure",
          members: {
            Format: {},
            DestinationArn: {}
          }
        },
        S94: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AttributeName: {},
              KeyType: {}
            }
          }
        },
        S96: {
          type: "structure",
          members: {
            NonKeyAttributes: {
              shape: "S23"
            },
            ProjectionType: {}
          }
        },
        S97: {
          type: "structure",
          members: {
            LastDecreaseDateTime: {},
            LastIncreaseDateTime: {},
            NumberOfDecreasesToday: {
              type: "integer"
            },
            ReadCapacityUnits: {
              type: "integer"
            },
            WriteCapacityUnits: {
              type: "integer"
            }
          }
        },
        S9e: {
          type: "structure",
          members: {
            ReadCapacityUnits: {
              type: "integer"
            }
          }
        },
        S9t: {
          type: "list",
          member: {
            type: "structure",
            members: {
              DomainName: {},
              ResourceRecord: {
                type: "structure",
                members: {
                  Name: {},
                  Type: {},
                  Value: {}
                }
              },
              ValidationDomain: {},
              ValidationEmails: {
                shape: "S23"
              },
              ValidationMethod: {},
              ValidationStatus: {}
            }
          }
        },
        Sc1: {
          type: "structure",
          members: {
            Address: {},
            Port: {
              type: "integer"
            },
            HostedZoneId: {}
          }
        },
        Sc2: {
          type: "list",
          member: {
            type: "structure",
            members: {
              VpcSecurityGroupId: {},
              Status: {}
            }
          }
        },
        Scc: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Value: {}
            }
          }
        },
        Sci: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Domain: {},
              Status: {},
              Fqdn: {},
              IamRoleName: {}
            }
          }
        },
        Sde: {
          type: "structure",
          members: {
            Name: {},
            Image: {},
            MountPoints: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  SourceVolume: {},
                  ContainerPath: {}
                }
              }
            },
            Privileged: {
              type: "boolean"
            }
          }
        },
        Sg3: {
          type: "structure",
          members: {
            CloudWatchLogsLogGroupArn: {},
            Enabled: {
              type: "boolean"
            }
          }
        },
        Sgu: {
          type: "structure",
          members: {
            PublishMetricAction: {
              type: "structure",
              members: {
                Dimensions: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      Value: {}
                    }
                  }
                }
              }
            }
          }
        },
        Sii: {
          type: "structure",
          members: {
            CidrBlock: {},
            CidrBlockSet: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  CidrBlock: {}
                }
              }
            },
            Ipv6CidrBlockSet: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Ipv6CidrBlock: {}
                }
              }
            },
            OwnerId: {},
            PeeringOptions: {
              type: "structure",
              members: {
                AllowDnsResolutionFromRemoteVpc: {
                  type: "boolean"
                },
                AllowEgressFromLocalClassicLinkToRemoteVpc: {
                  type: "boolean"
                },
                AllowEgressFromLocalVpcToRemoteClassicLink: {
                  type: "boolean"
                }
              }
            },
            Region: {},
            VpcId: {}
          }
        },
        Sjn: {
          type: "structure",
          members: {
            DeleteAfterDays: {
              type: "long"
            },
            MoveToColdStorageAfterDays: {
              type: "long"
            }
          }
        },
        Sl6: {
          type: "structure",
          members: {
            CustomRequestHandling: {
              shape: "Sl7"
            }
          }
        },
        Sl7: {
          type: "structure",
          members: {
            InsertHeaders: {
              shape: "Sl8"
            }
          }
        },
        Sl8: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Value: {}
            }
          }
        },
        Sla: {
          type: "structure",
          members: {
            CustomResponse: {
              type: "structure",
              members: {
                CustomResponseBodyKey: {},
                ResponseCode: {
                  type: "integer"
                },
                ResponseHeaders: {
                  shape: "Sl8"
                }
              }
            }
          }
        },
        Slc: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Action: {
                type: "structure",
                members: {
                  Allow: {
                    shape: "Sl6"
                  },
                  Block: {
                    shape: "Sla"
                  },
                  Captcha: {
                    type: "structure",
                    members: {
                      CustomRequestHandling: {
                        shape: "Sl7"
                      }
                    }
                  },
                  Count: {
                    type: "structure",
                    members: {
                      CustomRequestHandling: {
                        shape: "Sl7"
                      }
                    }
                  }
                }
              },
              Name: {},
              OverrideAction: {},
              Priority: {
                type: "integer"
              },
              VisibilityConfig: {
                shape: "Slh"
              }
            }
          }
        },
        Slh: {
          type: "structure",
          members: {
            CloudWatchMetricsEnabled: {
              type: "boolean"
            },
            MetricName: {},
            SampledRequestsEnabled: {
              type: "boolean"
            }
          }
        },
        Sm0: {
          type: "structure",
          members: {
            AuthTtL: {
              type: "long"
            },
            ClientId: {},
            IatTtL: {
              type: "long"
            },
            Issuer: {}
          }
        },
        Sm1: {
          type: "structure",
          members: {
            AuthorizerResultTtlInSeconds: {
              type: "integer"
            },
            AuthorizerUri: {},
            IdentityValidationExpression: {}
          }
        },
        Sm2: {
          type: "structure",
          members: {
            AppIdClientRegex: {},
            AwsRegion: {},
            DefaultAction: {},
            UserPoolId: {}
          }
        },
        Sox: {
          type: "structure",
          members: {
            IpAddressV4: {},
            Organization: {
              type: "structure",
              members: {
                Asn: {
                  type: "integer"
                },
                AsnOrg: {},
                Isp: {},
                Org: {}
              }
            },
            Country: {
              type: "structure",
              members: {
                CountryCode: {},
                CountryName: {}
              }
            },
            City: {
              type: "structure",
              members: {
                CityName: {}
              }
            },
            GeoLocation: {
              type: "structure",
              members: {
                Lon: {
                  type: "double"
                },
                Lat: {
                  type: "double"
                }
              }
            }
          }
        },
        Sp3: {
          type: "structure",
          members: {
            Port: {
              type: "integer"
            },
            PortName: {}
          }
        },
        Spm: {
          type: "list",
          member: {
            shape: "Spn"
          }
        },
        Spn: {
          type: "structure",
          required: [
            "Id",
            "ProductArn"
          ],
          members: {
            Id: {},
            ProductArn: {}
          }
        },
        Spt: {
          type: "structure",
          required: [
            "StandardsArn",
            "SecurityControlId",
            "AssociationStatus"
          ],
          members: {
            StandardsArn: {},
            SecurityControlId: {},
            AssociationStatus: {},
            UpdatedReason: {}
          }
        },
        Sq0: {
          type: "map",
          key: {},
          value: {}
        },
        Sq5: {
          type: "structure",
          members: {
            SecurityHub: {
              type: "structure",
              members: {
                ServiceEnabled: {
                  type: "boolean"
                },
                EnabledStandardIdentifiers: {
                  type: "list",
                  member: {}
                },
                SecurityControlsConfiguration: {
                  type: "structure",
                  members: {
                    EnabledSecurityControlIdentifiers: {
                      type: "list",
                      member: {}
                    },
                    DisabledSecurityControlIdentifiers: {
                      type: "list",
                      member: {}
                    },
                    SecurityControlCustomParameters: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          SecurityControlId: {},
                          Parameters: {
                            shape: "S2a"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          union: true
        },
        Sqh: {
          type: "structure",
          members: {
            ProductArn: {
              shape: "Sx"
            },
            AwsAccountId: {
              shape: "Sx"
            },
            Id: {
              shape: "Sx"
            },
            GeneratorId: {
              shape: "Sx"
            },
            Region: {
              shape: "Sx"
            },
            Type: {
              shape: "Sx"
            },
            FirstObservedAt: {
              shape: "S10"
            },
            LastObservedAt: {
              shape: "S10"
            },
            CreatedAt: {
              shape: "S10"
            },
            UpdatedAt: {
              shape: "S10"
            },
            SeverityProduct: {
              shape: "S14",
              deprecated: true,
              deprecatedMessage: "This filter is deprecated. Instead, use FindingProviderSeverityOriginal."
            },
            SeverityNormalized: {
              shape: "S14",
              deprecated: true,
              deprecatedMessage: "This filter is deprecated. Instead, use SeverityLabel or FindingProviderFieldsSeverityLabel."
            },
            SeverityLabel: {
              shape: "Sx"
            },
            Confidence: {
              shape: "S14"
            },
            Criticality: {
              shape: "S14"
            },
            Title: {
              shape: "Sx"
            },
            Description: {
              shape: "Sx"
            },
            RecommendationText: {
              shape: "Sx"
            },
            SourceUrl: {
              shape: "Sx"
            },
            ProductFields: {
              shape: "S17"
            },
            ProductName: {
              shape: "Sx"
            },
            CompanyName: {
              shape: "Sx"
            },
            UserDefinedFields: {
              shape: "S17"
            },
            MalwareName: {
              shape: "Sx"
            },
            MalwareType: {
              shape: "Sx"
            },
            MalwarePath: {
              shape: "Sx"
            },
            MalwareState: {
              shape: "Sx"
            },
            NetworkDirection: {
              shape: "Sx"
            },
            NetworkProtocol: {
              shape: "Sx"
            },
            NetworkSourceIpV4: {
              shape: "Sqi"
            },
            NetworkSourceIpV6: {
              shape: "Sqi"
            },
            NetworkSourcePort: {
              shape: "S14"
            },
            NetworkSourceDomain: {
              shape: "Sx"
            },
            NetworkSourceMac: {
              shape: "Sx"
            },
            NetworkDestinationIpV4: {
              shape: "Sqi"
            },
            NetworkDestinationIpV6: {
              shape: "Sqi"
            },
            NetworkDestinationPort: {
              shape: "S14"
            },
            NetworkDestinationDomain: {
              shape: "Sx"
            },
            ProcessName: {
              shape: "Sx"
            },
            ProcessPath: {
              shape: "Sx"
            },
            ProcessPid: {
              shape: "S14"
            },
            ProcessParentPid: {
              shape: "S14"
            },
            ProcessLaunchedAt: {
              shape: "S10"
            },
            ProcessTerminatedAt: {
              shape: "S10"
            },
            ThreatIntelIndicatorType: {
              shape: "Sx"
            },
            ThreatIntelIndicatorValue: {
              shape: "Sx"
            },
            ThreatIntelIndicatorCategory: {
              shape: "Sx"
            },
            ThreatIntelIndicatorLastObservedAt: {
              shape: "S10"
            },
            ThreatIntelIndicatorSource: {
              shape: "Sx"
            },
            ThreatIntelIndicatorSourceUrl: {
              shape: "Sx"
            },
            ResourceType: {
              shape: "Sx"
            },
            ResourceId: {
              shape: "Sx"
            },
            ResourcePartition: {
              shape: "Sx"
            },
            ResourceRegion: {
              shape: "Sx"
            },
            ResourceTags: {
              shape: "S17"
            },
            ResourceAwsEc2InstanceType: {
              shape: "Sx"
            },
            ResourceAwsEc2InstanceImageId: {
              shape: "Sx"
            },
            ResourceAwsEc2InstanceIpV4Addresses: {
              shape: "Sqi"
            },
            ResourceAwsEc2InstanceIpV6Addresses: {
              shape: "Sqi"
            },
            ResourceAwsEc2InstanceKeyName: {
              shape: "Sx"
            },
            ResourceAwsEc2InstanceIamInstanceProfileArn: {
              shape: "Sx"
            },
            ResourceAwsEc2InstanceVpcId: {
              shape: "Sx"
            },
            ResourceAwsEc2InstanceSubnetId: {
              shape: "Sx"
            },
            ResourceAwsEc2InstanceLaunchedAt: {
              shape: "S10"
            },
            ResourceAwsS3BucketOwnerId: {
              shape: "Sx"
            },
            ResourceAwsS3BucketOwnerName: {
              shape: "Sx"
            },
            ResourceAwsIamAccessKeyUserName: {
              shape: "Sx",
              deprecated: true,
              deprecatedMessage: "This filter is deprecated. Instead, use ResourceAwsIamAccessKeyPrincipalName."
            },
            ResourceAwsIamAccessKeyPrincipalName: {
              shape: "Sx"
            },
            ResourceAwsIamAccessKeyStatus: {
              shape: "Sx"
            },
            ResourceAwsIamAccessKeyCreatedAt: {
              shape: "S10"
            },
            ResourceAwsIamUserUserName: {
              shape: "Sx"
            },
            ResourceContainerName: {
              shape: "Sx"
            },
            ResourceContainerImageId: {
              shape: "Sx"
            },
            ResourceContainerImageName: {
              shape: "Sx"
            },
            ResourceContainerLaunchedAt: {
              shape: "S10"
            },
            ResourceDetailsOther: {
              shape: "S17"
            },
            ComplianceStatus: {
              shape: "Sx"
            },
            VerificationState: {
              shape: "Sx"
            },
            WorkflowState: {
              shape: "Sx"
            },
            WorkflowStatus: {
              shape: "Sx"
            },
            RecordState: {
              shape: "Sx"
            },
            RelatedFindingsProductArn: {
              shape: "Sx"
            },
            RelatedFindingsId: {
              shape: "Sx"
            },
            NoteText: {
              shape: "Sx"
            },
            NoteUpdatedAt: {
              shape: "S10"
            },
            NoteUpdatedBy: {
              shape: "Sx"
            },
            Keyword: {
              deprecated: true,
              deprecatedMessage: "The Keyword property is deprecated.",
              type: "list",
              member: {
                type: "structure",
                members: {
                  Value: {}
                }
              }
            },
            FindingProviderFieldsConfidence: {
              shape: "S14"
            },
            FindingProviderFieldsCriticality: {
              shape: "S14"
            },
            FindingProviderFieldsRelatedFindingsId: {
              shape: "Sx"
            },
            FindingProviderFieldsRelatedFindingsProductArn: {
              shape: "Sx"
            },
            FindingProviderFieldsSeverityLabel: {
              shape: "Sx"
            },
            FindingProviderFieldsSeverityOriginal: {
              shape: "Sx"
            },
            FindingProviderFieldsTypes: {
              shape: "Sx"
            },
            Sample: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Value: {
                    type: "boolean"
                  }
                }
              }
            },
            ComplianceSecurityControlId: {
              shape: "Sx"
            },
            ComplianceAssociatedStandardsId: {
              shape: "Sx"
            },
            VulnerabilitiesExploitAvailable: {
              shape: "Sx"
            },
            VulnerabilitiesFixAvailable: {
              shape: "Sx"
            },
            ComplianceSecurityControlParametersName: {
              shape: "Sx"
            },
            ComplianceSecurityControlParametersValue: {
              shape: "Sx"
            },
            AwsAccountName: {
              shape: "Sx"
            },
            ResourceApplicationName: {
              shape: "Sx"
            },
            ResourceApplicationArn: {
              shape: "Sx"
            }
          }
        },
        Sqi: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Cidr: {}
            }
          }
        },
        Squ: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AccountId: {},
              ProcessingResult: {}
            }
          }
        },
        Sqx: {
          type: "list",
          member: {}
        },
        Src: {
          type: "list",
          member: {}
        },
        Sro: {
          type: "structure",
          members: {
            ConfigurationType: {},
            Status: {},
            StatusMessage: {}
          }
        },
        Ssr: {
          type: "structure",
          members: {
            AccountId: {},
            InvitationId: {},
            InvitedAt: {
              shape: "S1p"
            },
            MemberStatus: {}
          }
        },
        Stt: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AccountId: {},
              Email: {},
              MasterId: {
                deprecated: true,
                deprecatedMessage: "This field is deprecated, use AdministratorId instead."
              },
              AdministratorId: {},
              MemberStatus: {},
              InvitedAt: {
                shape: "S1p"
              },
              UpdatedAt: {
                shape: "S1p"
              }
            }
          }
        },
        Stx: {
          type: "structure",
          required: [
            "SecurityControlId",
            "Title",
            "Description",
            "RemediationUrl",
            "SeverityRating",
            "CurrentRegionAvailability"
          ],
          members: {
            SecurityControlId: {},
            Title: {},
            Description: {},
            RemediationUrl: {},
            SeverityRating: {},
            CurrentRegionAvailability: {},
            CustomizableProperties: {
              type: "list",
              member: {}
            },
            ParameterDefinitions: {
              type: "map",
              key: {},
              value: {
                type: "structure",
                required: [
                  "Description",
                  "ConfigurationOptions"
                ],
                members: {
                  Description: {},
                  ConfigurationOptions: {
                    type: "structure",
                    members: {
                      Integer: {
                        type: "structure",
                        members: {
                          DefaultValue: {
                            type: "integer"
                          },
                          Min: {
                            type: "integer"
                          },
                          Max: {
                            type: "integer"
                          }
                        }
                      },
                      IntegerList: {
                        type: "structure",
                        members: {
                          DefaultValue: {
                            shape: "S2e"
                          },
                          Min: {
                            type: "integer"
                          },
                          Max: {
                            type: "integer"
                          },
                          MaxItems: {
                            type: "integer"
                          }
                        }
                      },
                      Double: {
                        type: "structure",
                        members: {
                          DefaultValue: {
                            type: "double"
                          },
                          Min: {
                            type: "double"
                          },
                          Max: {
                            type: "double"
                          }
                        }
                      },
                      String: {
                        type: "structure",
                        members: {
                          DefaultValue: {},
                          Re2Expression: {},
                          ExpressionDescription: {}
                        }
                      },
                      StringList: {
                        type: "structure",
                        members: {
                          DefaultValue: {
                            shape: "S23"
                          },
                          Re2Expression: {},
                          MaxItems: {
                            type: "integer"
                          },
                          ExpressionDescription: {}
                        }
                      },
                      Boolean: {
                        type: "structure",
                        members: {
                          DefaultValue: {
                            type: "boolean"
                          }
                        }
                      },
                      Enum: {
                        type: "structure",
                        members: {
                          DefaultValue: {},
                          AllowedValues: {
                            shape: "S23"
                          }
                        }
                      },
                      EnumList: {
                        type: "structure",
                        members: {
                          DefaultValue: {
                            shape: "S23"
                          },
                          MaxItems: {
                            type: "integer"
                          },
                          AllowedValues: {
                            shape: "S23"
                          }
                        }
                      }
                    },
                    union: true
                  }
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/securityhub-2018-10-26.paginators.json
var require_securityhub_2018_10_26_paginators = __commonJS({
  "node_modules/aws-sdk/apis/securityhub-2018-10-26.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeActionTargets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ActionTargets"
        },
        DescribeProducts: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Products"
        },
        DescribeStandards: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Standards"
        },
        DescribeStandardsControls: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Controls"
        },
        GetEnabledStandards: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "StandardsSubscriptions"
        },
        GetFindingHistory: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Records"
        },
        GetFindings: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Findings"
        },
        GetInsights: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Insights"
        },
        ListConfigurationPolicies: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ConfigurationPolicySummaries"
        },
        ListConfigurationPolicyAssociations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ConfigurationPolicyAssociationSummaries"
        },
        ListEnabledProductsForImport: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ProductSubscriptions"
        },
        ListFindingAggregators: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "FindingAggregators"
        },
        ListInvitations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Invitations"
        },
        ListMembers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Members"
        },
        ListOrganizationAdminAccounts: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AdminAccounts"
        },
        ListSecurityControlDefinitions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "SecurityControlDefinitions"
        },
        ListStandardsControlAssociations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "StandardsControlAssociationSummaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/securityhub.js
var require_securityhub = __commonJS({
  "node_modules/aws-sdk/clients/securityhub.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["securityhub"] = {};
    AWS2.SecurityHub = Service.defineService("securityhub", ["2018-10-26"]);
    Object.defineProperty(apiLoader.services["securityhub"], "2018-10-26", {
      get: function get() {
        var model = require_securityhub_2018_10_26_min();
        model.paginators = require_securityhub_2018_10_26_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.SecurityHub;
  }
});

// node_modules/aws-sdk/apis/appmesh-2018-10-01.min.json
var require_appmesh_2018_10_01_min = __commonJS({
  "node_modules/aws-sdk/apis/appmesh-2018-10-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-10-01",
        endpointPrefix: "appmesh",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS App Mesh",
        serviceId: "App Mesh",
        signatureVersion: "v4",
        signingName: "appmesh",
        uid: "appmesh-2018-10-01"
      },
      operations: {
        CreateMesh: {
          http: {
            method: "PUT",
            requestUri: "/meshes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              mesh: {
                shape: "S5"
              }
            },
            payload: "mesh"
          },
          idempotent: true
        },
        CreateRoute: {
          http: {
            method: "PUT",
            requestUri: "/meshes/{meshName}/virtualRouter/{virtualRouterName}/routes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "routeName",
              "spec",
              "virtualRouterName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              routeName: {},
              spec: {
                shape: "Sd"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              route: {
                shape: "Sl"
              }
            },
            payload: "route"
          },
          idempotent: true
        },
        CreateVirtualNode: {
          http: {
            method: "PUT",
            requestUri: "/meshes/{meshName}/virtualNodes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "spec",
              "virtualNodeName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              spec: {
                shape: "Sp"
              },
              virtualNodeName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              virtualNode: {
                shape: "S14"
              }
            },
            payload: "virtualNode"
          },
          idempotent: true
        },
        CreateVirtualRouter: {
          http: {
            method: "PUT",
            requestUri: "/meshes/{meshName}/virtualRouters",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "spec",
              "virtualRouterName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              spec: {
                shape: "S18"
              },
              virtualRouterName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              virtualRouter: {
                shape: "S1b"
              }
            },
            payload: "virtualRouter"
          },
          idempotent: true
        },
        DeleteMesh: {
          http: {
            method: "DELETE",
            requestUri: "/meshes/{meshName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              mesh: {
                shape: "S5"
              }
            },
            payload: "mesh"
          },
          idempotent: true
        },
        DeleteRoute: {
          http: {
            method: "DELETE",
            requestUri: "/meshes/{meshName}/virtualRouter/{virtualRouterName}/routes/{routeName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "routeName",
              "virtualRouterName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              routeName: {
                location: "uri",
                locationName: "routeName"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              route: {
                shape: "Sl"
              }
            },
            payload: "route"
          },
          idempotent: true
        },
        DeleteVirtualNode: {
          http: {
            method: "DELETE",
            requestUri: "/meshes/{meshName}/virtualNodes/{virtualNodeName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "virtualNodeName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              virtualNodeName: {
                location: "uri",
                locationName: "virtualNodeName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              virtualNode: {
                shape: "S14"
              }
            },
            payload: "virtualNode"
          },
          idempotent: true
        },
        DeleteVirtualRouter: {
          http: {
            method: "DELETE",
            requestUri: "/meshes/{meshName}/virtualRouters/{virtualRouterName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "virtualRouterName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              virtualRouter: {
                shape: "S1b"
              }
            },
            payload: "virtualRouter"
          },
          idempotent: true
        },
        DescribeMesh: {
          http: {
            method: "GET",
            requestUri: "/meshes/{meshName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              mesh: {
                shape: "S5"
              }
            },
            payload: "mesh"
          }
        },
        DescribeRoute: {
          http: {
            method: "GET",
            requestUri: "/meshes/{meshName}/virtualRouter/{virtualRouterName}/routes/{routeName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "routeName",
              "virtualRouterName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              routeName: {
                location: "uri",
                locationName: "routeName"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              route: {
                shape: "Sl"
              }
            },
            payload: "route"
          }
        },
        DescribeVirtualNode: {
          http: {
            method: "GET",
            requestUri: "/meshes/{meshName}/virtualNodes/{virtualNodeName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "virtualNodeName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              virtualNodeName: {
                location: "uri",
                locationName: "virtualNodeName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              virtualNode: {
                shape: "S14"
              }
            },
            payload: "virtualNode"
          }
        },
        DescribeVirtualRouter: {
          http: {
            method: "GET",
            requestUri: "/meshes/{meshName}/virtualRouters/{virtualRouterName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "virtualRouterName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              virtualRouter: {
                shape: "S1b"
              }
            },
            payload: "virtualRouter"
          }
        },
        ListMeshes: {
          http: {
            method: "GET",
            requestUri: "/meshes",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "meshes"
            ],
            members: {
              meshes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    meshName: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListRoutes: {
          http: {
            method: "GET",
            requestUri: "/meshes/{meshName}/virtualRouter/{virtualRouterName}/routes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "virtualRouterName"
            ],
            members: {
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "routes"
            ],
            members: {
              nextToken: {},
              routes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    meshName: {},
                    routeName: {},
                    virtualRouterName: {}
                  }
                }
              }
            }
          }
        },
        ListVirtualNodes: {
          http: {
            method: "GET",
            requestUri: "/meshes/{meshName}/virtualNodes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName"
            ],
            members: {
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualNodes"
            ],
            members: {
              nextToken: {},
              virtualNodes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    meshName: {},
                    virtualNodeName: {}
                  }
                }
              }
            }
          }
        },
        ListVirtualRouters: {
          http: {
            method: "GET",
            requestUri: "/meshes/{meshName}/virtualRouters",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName"
            ],
            members: {
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualRouters"
            ],
            members: {
              nextToken: {},
              virtualRouters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    meshName: {},
                    virtualRouterName: {}
                  }
                }
              }
            }
          }
        },
        UpdateRoute: {
          http: {
            method: "PUT",
            requestUri: "/meshes/{meshName}/virtualRouter/{virtualRouterName}/routes/{routeName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "routeName",
              "spec",
              "virtualRouterName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              routeName: {
                location: "uri",
                locationName: "routeName"
              },
              spec: {
                shape: "Sd"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              route: {
                shape: "Sl"
              }
            },
            payload: "route"
          },
          idempotent: true
        },
        UpdateVirtualNode: {
          http: {
            method: "PUT",
            requestUri: "/meshes/{meshName}/virtualNodes/{virtualNodeName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "spec",
              "virtualNodeName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              spec: {
                shape: "Sp"
              },
              virtualNodeName: {
                location: "uri",
                locationName: "virtualNodeName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              virtualNode: {
                shape: "S14"
              }
            },
            payload: "virtualNode"
          },
          idempotent: true
        },
        UpdateVirtualRouter: {
          http: {
            method: "PUT",
            requestUri: "/meshes/{meshName}/virtualRouters/{virtualRouterName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "spec",
              "virtualRouterName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              spec: {
                shape: "S18"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              virtualRouter: {
                shape: "S1b"
              }
            },
            payload: "virtualRouter"
          },
          idempotent: true
        }
      },
      shapes: {
        S5: {
          type: "structure",
          required: [
            "meshName",
            "metadata"
          ],
          members: {
            meshName: {},
            metadata: {
              shape: "S6"
            },
            status: {
              type: "structure",
              members: {
                status: {}
              }
            }
          }
        },
        S6: {
          type: "structure",
          members: {
            arn: {},
            createdAt: {
              type: "timestamp"
            },
            lastUpdatedAt: {
              type: "timestamp"
            },
            uid: {},
            version: {
              type: "long"
            }
          }
        },
        Sd: {
          type: "structure",
          members: {
            httpRoute: {
              type: "structure",
              members: {
                action: {
                  type: "structure",
                  members: {
                    weightedTargets: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          virtualNode: {},
                          weight: {
                            type: "integer"
                          }
                        }
                      }
                    }
                  }
                },
                match: {
                  type: "structure",
                  members: {
                    prefix: {}
                  }
                }
              }
            }
          }
        },
        Sl: {
          type: "structure",
          required: [
            "meshName",
            "routeName",
            "virtualRouterName"
          ],
          members: {
            meshName: {},
            metadata: {
              shape: "S6"
            },
            routeName: {},
            spec: {
              shape: "Sd"
            },
            status: {
              type: "structure",
              members: {
                status: {}
              }
            },
            virtualRouterName: {}
          }
        },
        Sp: {
          type: "structure",
          members: {
            backends: {
              type: "list",
              member: {}
            },
            listeners: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  healthCheck: {
                    type: "structure",
                    required: [
                      "healthyThreshold",
                      "intervalMillis",
                      "protocol",
                      "timeoutMillis",
                      "unhealthyThreshold"
                    ],
                    members: {
                      healthyThreshold: {
                        type: "integer"
                      },
                      intervalMillis: {
                        type: "long"
                      },
                      path: {},
                      port: {
                        type: "integer"
                      },
                      protocol: {},
                      timeoutMillis: {
                        type: "long"
                      },
                      unhealthyThreshold: {
                        type: "integer"
                      }
                    }
                  },
                  portMapping: {
                    type: "structure",
                    members: {
                      port: {
                        type: "integer"
                      },
                      protocol: {}
                    }
                  }
                }
              }
            },
            serviceDiscovery: {
              type: "structure",
              members: {
                dns: {
                  type: "structure",
                  members: {
                    serviceName: {}
                  }
                }
              }
            }
          }
        },
        S14: {
          type: "structure",
          required: [
            "meshName",
            "virtualNodeName"
          ],
          members: {
            meshName: {},
            metadata: {
              shape: "S6"
            },
            spec: {
              shape: "Sp"
            },
            status: {
              type: "structure",
              members: {
                status: {}
              }
            },
            virtualNodeName: {}
          }
        },
        S18: {
          type: "structure",
          members: {
            serviceNames: {
              type: "list",
              member: {}
            }
          }
        },
        S1b: {
          type: "structure",
          required: [
            "meshName",
            "virtualRouterName"
          ],
          members: {
            meshName: {},
            metadata: {
              shape: "S6"
            },
            spec: {
              shape: "S18"
            },
            status: {
              type: "structure",
              members: {
                status: {}
              }
            },
            virtualRouterName: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/appmesh-2018-10-01.paginators.json
var require_appmesh_2018_10_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/appmesh-2018-10-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListMeshes: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextToken",
          result_key: "meshes"
        },
        ListRoutes: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextToken",
          result_key: "routes"
        },
        ListVirtualNodes: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextToken",
          result_key: "virtualNodes"
        },
        ListVirtualRouters: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextToken",
          result_key: "virtualRouters"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/appmesh-2019-01-25.min.json
var require_appmesh_2019_01_25_min = __commonJS({
  "node_modules/aws-sdk/apis/appmesh-2019-01-25.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-01-25",
        endpointPrefix: "appmesh",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS App Mesh",
        serviceId: "App Mesh",
        signatureVersion: "v4",
        signingName: "appmesh",
        uid: "appmesh-2019-01-25"
      },
      operations: {
        CreateGatewayRoute: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/meshes/{meshName}/virtualGateway/{virtualGatewayName}/gatewayRoutes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "gatewayRouteName",
              "meshName",
              "spec",
              "virtualGatewayName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              gatewayRouteName: {},
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              spec: {
                shape: "S5"
              },
              tags: {
                shape: "S1a"
              },
              virtualGatewayName: {
                location: "uri",
                locationName: "virtualGatewayName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "gatewayRoute"
            ],
            members: {
              gatewayRoute: {
                shape: "S1f"
              }
            },
            payload: "gatewayRoute"
          },
          idempotent: true
        },
        CreateMesh: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/meshes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {},
              spec: {
                shape: "S1m"
              },
              tags: {
                shape: "S1a"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "mesh"
            ],
            members: {
              mesh: {
                shape: "S1s"
              }
            },
            payload: "mesh"
          },
          idempotent: true
        },
        CreateRoute: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/meshes/{meshName}/virtualRouter/{virtualRouterName}/routes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "routeName",
              "spec",
              "virtualRouterName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              routeName: {},
              spec: {
                shape: "S1w"
              },
              tags: {
                shape: "S1a"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "route"
            ],
            members: {
              route: {
                shape: "S2x"
              }
            },
            payload: "route"
          },
          idempotent: true
        },
        CreateVirtualGateway: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/meshes/{meshName}/virtualGateways",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "spec",
              "virtualGatewayName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              spec: {
                shape: "S31"
              },
              tags: {
                shape: "S1a"
              },
              virtualGatewayName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualGateway"
            ],
            members: {
              virtualGateway: {
                shape: "S4h"
              }
            },
            payload: "virtualGateway"
          },
          idempotent: true
        },
        CreateVirtualNode: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/meshes/{meshName}/virtualNodes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "spec",
              "virtualNodeName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              spec: {
                shape: "S4l"
              },
              tags: {
                shape: "S1a"
              },
              virtualNodeName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualNode"
            ],
            members: {
              virtualNode: {
                shape: "S63"
              }
            },
            payload: "virtualNode"
          },
          idempotent: true
        },
        CreateVirtualRouter: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/meshes/{meshName}/virtualRouters",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "spec",
              "virtualRouterName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              spec: {
                shape: "S67"
              },
              tags: {
                shape: "S1a"
              },
              virtualRouterName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualRouter"
            ],
            members: {
              virtualRouter: {
                shape: "S6b"
              }
            },
            payload: "virtualRouter"
          },
          idempotent: true
        },
        CreateVirtualService: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/meshes/{meshName}/virtualServices",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "spec",
              "virtualServiceName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              spec: {
                shape: "S6f"
              },
              tags: {
                shape: "S1a"
              },
              virtualServiceName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualService"
            ],
            members: {
              virtualService: {
                shape: "S6k"
              }
            },
            payload: "virtualService"
          },
          idempotent: true
        },
        DeleteGatewayRoute: {
          http: {
            method: "DELETE",
            requestUri: "/v20190125/meshes/{meshName}/virtualGateway/{virtualGatewayName}/gatewayRoutes/{gatewayRouteName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "gatewayRouteName",
              "meshName",
              "virtualGatewayName"
            ],
            members: {
              gatewayRouteName: {
                location: "uri",
                locationName: "gatewayRouteName"
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              virtualGatewayName: {
                location: "uri",
                locationName: "virtualGatewayName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "gatewayRoute"
            ],
            members: {
              gatewayRoute: {
                shape: "S1f"
              }
            },
            payload: "gatewayRoute"
          },
          idempotent: true
        },
        DeleteMesh: {
          http: {
            method: "DELETE",
            requestUri: "/v20190125/meshes/{meshName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "mesh"
            ],
            members: {
              mesh: {
                shape: "S1s"
              }
            },
            payload: "mesh"
          },
          idempotent: true
        },
        DeleteRoute: {
          http: {
            method: "DELETE",
            requestUri: "/v20190125/meshes/{meshName}/virtualRouter/{virtualRouterName}/routes/{routeName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "routeName",
              "virtualRouterName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              routeName: {
                location: "uri",
                locationName: "routeName"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "route"
            ],
            members: {
              route: {
                shape: "S2x"
              }
            },
            payload: "route"
          },
          idempotent: true
        },
        DeleteVirtualGateway: {
          http: {
            method: "DELETE",
            requestUri: "/v20190125/meshes/{meshName}/virtualGateways/{virtualGatewayName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "virtualGatewayName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              virtualGatewayName: {
                location: "uri",
                locationName: "virtualGatewayName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualGateway"
            ],
            members: {
              virtualGateway: {
                shape: "S4h"
              }
            },
            payload: "virtualGateway"
          },
          idempotent: true
        },
        DeleteVirtualNode: {
          http: {
            method: "DELETE",
            requestUri: "/v20190125/meshes/{meshName}/virtualNodes/{virtualNodeName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "virtualNodeName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              virtualNodeName: {
                location: "uri",
                locationName: "virtualNodeName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualNode"
            ],
            members: {
              virtualNode: {
                shape: "S63"
              }
            },
            payload: "virtualNode"
          },
          idempotent: true
        },
        DeleteVirtualRouter: {
          http: {
            method: "DELETE",
            requestUri: "/v20190125/meshes/{meshName}/virtualRouters/{virtualRouterName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "virtualRouterName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualRouter"
            ],
            members: {
              virtualRouter: {
                shape: "S6b"
              }
            },
            payload: "virtualRouter"
          },
          idempotent: true
        },
        DeleteVirtualService: {
          http: {
            method: "DELETE",
            requestUri: "/v20190125/meshes/{meshName}/virtualServices/{virtualServiceName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "virtualServiceName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              virtualServiceName: {
                location: "uri",
                locationName: "virtualServiceName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualService"
            ],
            members: {
              virtualService: {
                shape: "S6k"
              }
            },
            payload: "virtualService"
          },
          idempotent: true
        },
        DescribeGatewayRoute: {
          http: {
            method: "GET",
            requestUri: "/v20190125/meshes/{meshName}/virtualGateway/{virtualGatewayName}/gatewayRoutes/{gatewayRouteName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "gatewayRouteName",
              "meshName",
              "virtualGatewayName"
            ],
            members: {
              gatewayRouteName: {
                location: "uri",
                locationName: "gatewayRouteName"
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              virtualGatewayName: {
                location: "uri",
                locationName: "virtualGatewayName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "gatewayRoute"
            ],
            members: {
              gatewayRoute: {
                shape: "S1f"
              }
            },
            payload: "gatewayRoute"
          }
        },
        DescribeMesh: {
          http: {
            method: "GET",
            requestUri: "/v20190125/meshes/{meshName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "mesh"
            ],
            members: {
              mesh: {
                shape: "S1s"
              }
            },
            payload: "mesh"
          }
        },
        DescribeRoute: {
          http: {
            method: "GET",
            requestUri: "/v20190125/meshes/{meshName}/virtualRouter/{virtualRouterName}/routes/{routeName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "routeName",
              "virtualRouterName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              routeName: {
                location: "uri",
                locationName: "routeName"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "route"
            ],
            members: {
              route: {
                shape: "S2x"
              }
            },
            payload: "route"
          }
        },
        DescribeVirtualGateway: {
          http: {
            method: "GET",
            requestUri: "/v20190125/meshes/{meshName}/virtualGateways/{virtualGatewayName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "virtualGatewayName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              virtualGatewayName: {
                location: "uri",
                locationName: "virtualGatewayName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualGateway"
            ],
            members: {
              virtualGateway: {
                shape: "S4h"
              }
            },
            payload: "virtualGateway"
          }
        },
        DescribeVirtualNode: {
          http: {
            method: "GET",
            requestUri: "/v20190125/meshes/{meshName}/virtualNodes/{virtualNodeName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "virtualNodeName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              virtualNodeName: {
                location: "uri",
                locationName: "virtualNodeName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualNode"
            ],
            members: {
              virtualNode: {
                shape: "S63"
              }
            },
            payload: "virtualNode"
          }
        },
        DescribeVirtualRouter: {
          http: {
            method: "GET",
            requestUri: "/v20190125/meshes/{meshName}/virtualRouters/{virtualRouterName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "virtualRouterName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualRouter"
            ],
            members: {
              virtualRouter: {
                shape: "S6b"
              }
            },
            payload: "virtualRouter"
          }
        },
        DescribeVirtualService: {
          http: {
            method: "GET",
            requestUri: "/v20190125/meshes/{meshName}/virtualServices/{virtualServiceName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "virtualServiceName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              virtualServiceName: {
                location: "uri",
                locationName: "virtualServiceName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualService"
            ],
            members: {
              virtualService: {
                shape: "S6k"
              }
            },
            payload: "virtualService"
          }
        },
        ListGatewayRoutes: {
          http: {
            method: "GET",
            requestUri: "/v20190125/meshes/{meshName}/virtualGateway/{virtualGatewayName}/gatewayRoutes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "virtualGatewayName"
            ],
            members: {
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              virtualGatewayName: {
                location: "uri",
                locationName: "virtualGatewayName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "gatewayRoutes"
            ],
            members: {
              gatewayRoutes: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "gatewayRouteName",
                    "lastUpdatedAt",
                    "meshName",
                    "meshOwner",
                    "resourceOwner",
                    "version",
                    "virtualGatewayName"
                  ],
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    gatewayRouteName: {},
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    meshName: {},
                    meshOwner: {},
                    resourceOwner: {},
                    version: {
                      type: "long"
                    },
                    virtualGatewayName: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListMeshes: {
          http: {
            method: "GET",
            requestUri: "/v20190125/meshes",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "meshes"
            ],
            members: {
              meshes: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "lastUpdatedAt",
                    "meshName",
                    "meshOwner",
                    "resourceOwner",
                    "version"
                  ],
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    meshName: {},
                    meshOwner: {},
                    resourceOwner: {},
                    version: {
                      type: "long"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListRoutes: {
          http: {
            method: "GET",
            requestUri: "/v20190125/meshes/{meshName}/virtualRouter/{virtualRouterName}/routes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "virtualRouterName"
            ],
            members: {
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "routes"
            ],
            members: {
              nextToken: {},
              routes: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "lastUpdatedAt",
                    "meshName",
                    "meshOwner",
                    "resourceOwner",
                    "routeName",
                    "version",
                    "virtualRouterName"
                  ],
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    meshName: {},
                    meshOwner: {},
                    resourceOwner: {},
                    routeName: {},
                    version: {
                      type: "long"
                    },
                    virtualRouterName: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/v20190125/tags",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "tags"
            ],
            members: {
              nextToken: {},
              tags: {
                shape: "S1a"
              }
            }
          }
        },
        ListVirtualGateways: {
          http: {
            method: "GET",
            requestUri: "/v20190125/meshes/{meshName}/virtualGateways",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName"
            ],
            members: {
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualGateways"
            ],
            members: {
              nextToken: {},
              virtualGateways: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "lastUpdatedAt",
                    "meshName",
                    "meshOwner",
                    "resourceOwner",
                    "version",
                    "virtualGatewayName"
                  ],
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    meshName: {},
                    meshOwner: {},
                    resourceOwner: {},
                    version: {
                      type: "long"
                    },
                    virtualGatewayName: {}
                  }
                }
              }
            }
          }
        },
        ListVirtualNodes: {
          http: {
            method: "GET",
            requestUri: "/v20190125/meshes/{meshName}/virtualNodes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName"
            ],
            members: {
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualNodes"
            ],
            members: {
              nextToken: {},
              virtualNodes: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "lastUpdatedAt",
                    "meshName",
                    "meshOwner",
                    "resourceOwner",
                    "version",
                    "virtualNodeName"
                  ],
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    meshName: {},
                    meshOwner: {},
                    resourceOwner: {},
                    version: {
                      type: "long"
                    },
                    virtualNodeName: {}
                  }
                }
              }
            }
          }
        },
        ListVirtualRouters: {
          http: {
            method: "GET",
            requestUri: "/v20190125/meshes/{meshName}/virtualRouters",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName"
            ],
            members: {
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualRouters"
            ],
            members: {
              nextToken: {},
              virtualRouters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "lastUpdatedAt",
                    "meshName",
                    "meshOwner",
                    "resourceOwner",
                    "version",
                    "virtualRouterName"
                  ],
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    meshName: {},
                    meshOwner: {},
                    resourceOwner: {},
                    version: {
                      type: "long"
                    },
                    virtualRouterName: {}
                  }
                }
              }
            }
          }
        },
        ListVirtualServices: {
          http: {
            method: "GET",
            requestUri: "/v20190125/meshes/{meshName}/virtualServices",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName"
            ],
            members: {
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualServices"
            ],
            members: {
              nextToken: {},
              virtualServices: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "lastUpdatedAt",
                    "meshName",
                    "meshOwner",
                    "resourceOwner",
                    "version",
                    "virtualServiceName"
                  ],
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    meshName: {},
                    meshOwner: {},
                    resourceOwner: {},
                    version: {
                      type: "long"
                    },
                    virtualServiceName: {}
                  }
                }
              }
            }
          }
        },
        TagResource: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/tag",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S1a"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UntagResource: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/untag",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateGatewayRoute: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/meshes/{meshName}/virtualGateway/{virtualGatewayName}/gatewayRoutes/{gatewayRouteName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "gatewayRouteName",
              "meshName",
              "spec",
              "virtualGatewayName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              gatewayRouteName: {
                location: "uri",
                locationName: "gatewayRouteName"
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              spec: {
                shape: "S5"
              },
              virtualGatewayName: {
                location: "uri",
                locationName: "virtualGatewayName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "gatewayRoute"
            ],
            members: {
              gatewayRoute: {
                shape: "S1f"
              }
            },
            payload: "gatewayRoute"
          },
          idempotent: true
        },
        UpdateMesh: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/meshes/{meshName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              spec: {
                shape: "S1m"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "mesh"
            ],
            members: {
              mesh: {
                shape: "S1s"
              }
            },
            payload: "mesh"
          },
          idempotent: true
        },
        UpdateRoute: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/meshes/{meshName}/virtualRouter/{virtualRouterName}/routes/{routeName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "routeName",
              "spec",
              "virtualRouterName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              routeName: {
                location: "uri",
                locationName: "routeName"
              },
              spec: {
                shape: "S1w"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "route"
            ],
            members: {
              route: {
                shape: "S2x"
              }
            },
            payload: "route"
          },
          idempotent: true
        },
        UpdateVirtualGateway: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/meshes/{meshName}/virtualGateways/{virtualGatewayName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "spec",
              "virtualGatewayName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              spec: {
                shape: "S31"
              },
              virtualGatewayName: {
                location: "uri",
                locationName: "virtualGatewayName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualGateway"
            ],
            members: {
              virtualGateway: {
                shape: "S4h"
              }
            },
            payload: "virtualGateway"
          },
          idempotent: true
        },
        UpdateVirtualNode: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/meshes/{meshName}/virtualNodes/{virtualNodeName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "spec",
              "virtualNodeName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              spec: {
                shape: "S4l"
              },
              virtualNodeName: {
                location: "uri",
                locationName: "virtualNodeName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualNode"
            ],
            members: {
              virtualNode: {
                shape: "S63"
              }
            },
            payload: "virtualNode"
          },
          idempotent: true
        },
        UpdateVirtualRouter: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/meshes/{meshName}/virtualRouters/{virtualRouterName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "spec",
              "virtualRouterName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              spec: {
                shape: "S67"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualRouter"
            ],
            members: {
              virtualRouter: {
                shape: "S6b"
              }
            },
            payload: "virtualRouter"
          },
          idempotent: true
        },
        UpdateVirtualService: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/meshes/{meshName}/virtualServices/{virtualServiceName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "spec",
              "virtualServiceName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              spec: {
                shape: "S6f"
              },
              virtualServiceName: {
                location: "uri",
                locationName: "virtualServiceName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualService"
            ],
            members: {
              virtualService: {
                shape: "S6k"
              }
            },
            payload: "virtualService"
          },
          idempotent: true
        }
      },
      shapes: {
        S5: {
          type: "structure",
          members: {
            grpcRoute: {
              type: "structure",
              required: [
                "action",
                "match"
              ],
              members: {
                action: {
                  type: "structure",
                  required: [
                    "target"
                  ],
                  members: {
                    rewrite: {
                      type: "structure",
                      members: {
                        hostname: {
                          shape: "S9"
                        }
                      }
                    },
                    target: {
                      shape: "Sb"
                    }
                  }
                },
                match: {
                  type: "structure",
                  members: {
                    hostname: {
                      shape: "Sf"
                    },
                    metadata: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "name"
                        ],
                        members: {
                          invert: {
                            type: "boolean"
                          },
                          match: {
                            type: "structure",
                            members: {
                              exact: {},
                              prefix: {},
                              range: {
                                shape: "Sn"
                              },
                              regex: {},
                              suffix: {}
                            },
                            union: true
                          },
                          name: {}
                        }
                      }
                    },
                    port: {
                      type: "integer"
                    },
                    serviceName: {}
                  }
                }
              }
            },
            http2Route: {
              shape: "Sr"
            },
            httpRoute: {
              shape: "Sr"
            },
            priority: {
              type: "integer"
            }
          }
        },
        S9: {
          type: "structure",
          members: {
            defaultTargetHostname: {}
          }
        },
        Sb: {
          type: "structure",
          required: [
            "virtualService"
          ],
          members: {
            port: {
              type: "integer"
            },
            virtualService: {
              type: "structure",
              required: [
                "virtualServiceName"
              ],
              members: {
                virtualServiceName: {}
              }
            }
          }
        },
        Sf: {
          type: "structure",
          members: {
            exact: {},
            suffix: {}
          }
        },
        Sn: {
          type: "structure",
          required: [
            "end",
            "start"
          ],
          members: {
            end: {
              type: "long"
            },
            start: {
              type: "long"
            }
          }
        },
        Sr: {
          type: "structure",
          required: [
            "action",
            "match"
          ],
          members: {
            action: {
              type: "structure",
              required: [
                "target"
              ],
              members: {
                rewrite: {
                  type: "structure",
                  members: {
                    hostname: {
                      shape: "S9"
                    },
                    path: {
                      type: "structure",
                      members: {
                        exact: {}
                      }
                    },
                    prefix: {
                      type: "structure",
                      members: {
                        defaultPrefix: {},
                        value: {}
                      }
                    }
                  }
                },
                target: {
                  shape: "Sb"
                }
              }
            },
            match: {
              type: "structure",
              members: {
                headers: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "name"
                    ],
                    members: {
                      invert: {
                        type: "boolean"
                      },
                      match: {
                        shape: "S11"
                      },
                      name: {}
                    }
                  }
                },
                hostname: {
                  shape: "Sf"
                },
                method: {},
                path: {
                  shape: "S13"
                },
                port: {
                  type: "integer"
                },
                prefix: {},
                queryParameters: {
                  shape: "S15"
                }
              }
            }
          }
        },
        S11: {
          type: "structure",
          members: {
            exact: {},
            prefix: {},
            range: {
              shape: "Sn"
            },
            regex: {},
            suffix: {}
          },
          union: true
        },
        S13: {
          type: "structure",
          members: {
            exact: {},
            regex: {}
          }
        },
        S15: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              match: {
                type: "structure",
                members: {
                  exact: {}
                }
              },
              name: {}
            }
          }
        },
        S1a: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        S1f: {
          type: "structure",
          required: [
            "gatewayRouteName",
            "meshName",
            "metadata",
            "spec",
            "status",
            "virtualGatewayName"
          ],
          members: {
            gatewayRouteName: {},
            meshName: {},
            metadata: {
              shape: "S1g"
            },
            spec: {
              shape: "S5"
            },
            status: {
              type: "structure",
              required: [
                "status"
              ],
              members: {
                status: {}
              }
            },
            virtualGatewayName: {}
          }
        },
        S1g: {
          type: "structure",
          required: [
            "arn",
            "createdAt",
            "lastUpdatedAt",
            "meshOwner",
            "resourceOwner",
            "uid",
            "version"
          ],
          members: {
            arn: {},
            createdAt: {
              type: "timestamp"
            },
            lastUpdatedAt: {
              type: "timestamp"
            },
            meshOwner: {},
            resourceOwner: {},
            uid: {},
            version: {
              type: "long"
            }
          }
        },
        S1m: {
          type: "structure",
          members: {
            egressFilter: {
              type: "structure",
              required: [
                "type"
              ],
              members: {
                type: {}
              }
            },
            serviceDiscovery: {
              type: "structure",
              members: {
                ipPreference: {}
              }
            }
          }
        },
        S1s: {
          type: "structure",
          required: [
            "meshName",
            "metadata",
            "spec",
            "status"
          ],
          members: {
            meshName: {},
            metadata: {
              shape: "S1g"
            },
            spec: {
              shape: "S1m"
            },
            status: {
              type: "structure",
              members: {
                status: {}
              }
            }
          }
        },
        S1w: {
          type: "structure",
          members: {
            grpcRoute: {
              type: "structure",
              required: [
                "action",
                "match"
              ],
              members: {
                action: {
                  type: "structure",
                  required: [
                    "weightedTargets"
                  ],
                  members: {
                    weightedTargets: {
                      shape: "S1z"
                    }
                  }
                },
                match: {
                  type: "structure",
                  members: {
                    metadata: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "name"
                        ],
                        members: {
                          invert: {
                            type: "boolean"
                          },
                          match: {
                            type: "structure",
                            members: {
                              exact: {},
                              prefix: {},
                              range: {
                                shape: "Sn"
                              },
                              regex: {},
                              suffix: {}
                            },
                            union: true
                          },
                          name: {}
                        }
                      }
                    },
                    methodName: {},
                    port: {
                      type: "integer"
                    },
                    serviceName: {}
                  }
                },
                retryPolicy: {
                  type: "structure",
                  required: [
                    "maxRetries",
                    "perRetryTimeout"
                  ],
                  members: {
                    grpcRetryEvents: {
                      type: "list",
                      member: {}
                    },
                    httpRetryEvents: {
                      shape: "S2a"
                    },
                    maxRetries: {
                      type: "long"
                    },
                    perRetryTimeout: {
                      shape: "S2d"
                    },
                    tcpRetryEvents: {
                      shape: "S2g"
                    }
                  }
                },
                timeout: {
                  shape: "S2i"
                }
              }
            },
            http2Route: {
              shape: "S2j"
            },
            httpRoute: {
              shape: "S2j"
            },
            priority: {
              type: "integer"
            },
            tcpRoute: {
              type: "structure",
              required: [
                "action"
              ],
              members: {
                action: {
                  type: "structure",
                  required: [
                    "weightedTargets"
                  ],
                  members: {
                    weightedTargets: {
                      shape: "S1z"
                    }
                  }
                },
                match: {
                  type: "structure",
                  members: {
                    port: {
                      type: "integer"
                    }
                  }
                },
                timeout: {
                  shape: "S2v"
                }
              }
            }
          }
        },
        S1z: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "virtualNode",
              "weight"
            ],
            members: {
              port: {
                type: "integer"
              },
              virtualNode: {},
              weight: {
                type: "integer"
              }
            }
          }
        },
        S2a: {
          type: "list",
          member: {}
        },
        S2d: {
          type: "structure",
          members: {
            unit: {},
            value: {
              type: "long"
            }
          }
        },
        S2g: {
          type: "list",
          member: {}
        },
        S2i: {
          type: "structure",
          members: {
            idle: {
              shape: "S2d"
            },
            perRequest: {
              shape: "S2d"
            }
          }
        },
        S2j: {
          type: "structure",
          required: [
            "action",
            "match"
          ],
          members: {
            action: {
              type: "structure",
              required: [
                "weightedTargets"
              ],
              members: {
                weightedTargets: {
                  shape: "S1z"
                }
              }
            },
            match: {
              type: "structure",
              members: {
                headers: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "name"
                    ],
                    members: {
                      invert: {
                        type: "boolean"
                      },
                      match: {
                        shape: "S11"
                      },
                      name: {}
                    }
                  }
                },
                method: {},
                path: {
                  shape: "S13"
                },
                port: {
                  type: "integer"
                },
                prefix: {},
                queryParameters: {
                  shape: "S15"
                },
                scheme: {}
              }
            },
            retryPolicy: {
              type: "structure",
              required: [
                "maxRetries",
                "perRetryTimeout"
              ],
              members: {
                httpRetryEvents: {
                  shape: "S2a"
                },
                maxRetries: {
                  type: "long"
                },
                perRetryTimeout: {
                  shape: "S2d"
                },
                tcpRetryEvents: {
                  shape: "S2g"
                }
              }
            },
            timeout: {
              shape: "S2q"
            }
          }
        },
        S2q: {
          type: "structure",
          members: {
            idle: {
              shape: "S2d"
            },
            perRequest: {
              shape: "S2d"
            }
          }
        },
        S2v: {
          type: "structure",
          members: {
            idle: {
              shape: "S2d"
            }
          }
        },
        S2x: {
          type: "structure",
          required: [
            "meshName",
            "metadata",
            "routeName",
            "spec",
            "status",
            "virtualRouterName"
          ],
          members: {
            meshName: {},
            metadata: {
              shape: "S1g"
            },
            routeName: {},
            spec: {
              shape: "S1w"
            },
            status: {
              type: "structure",
              required: [
                "status"
              ],
              members: {
                status: {}
              }
            },
            virtualRouterName: {}
          }
        },
        S31: {
          type: "structure",
          required: [
            "listeners"
          ],
          members: {
            backendDefaults: {
              type: "structure",
              members: {
                clientPolicy: {
                  type: "structure",
                  members: {
                    tls: {
                      type: "structure",
                      required: [
                        "validation"
                      ],
                      members: {
                        certificate: {
                          type: "structure",
                          members: {
                            file: {
                              shape: "S36"
                            },
                            sds: {
                              shape: "S38"
                            }
                          },
                          union: true
                        },
                        enforce: {
                          type: "boolean"
                        },
                        ports: {
                          shape: "S3a"
                        },
                        validation: {
                          type: "structure",
                          required: [
                            "trust"
                          ],
                          members: {
                            subjectAlternativeNames: {
                              shape: "S3d"
                            },
                            trust: {
                              type: "structure",
                              members: {
                                acm: {
                                  type: "structure",
                                  required: [
                                    "certificateAuthorityArns"
                                  ],
                                  members: {
                                    certificateAuthorityArns: {
                                      type: "list",
                                      member: {}
                                    }
                                  }
                                },
                                file: {
                                  shape: "S3k"
                                },
                                sds: {
                                  shape: "S3l"
                                }
                              },
                              union: true
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            listeners: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "portMapping"
                ],
                members: {
                  connectionPool: {
                    type: "structure",
                    members: {
                      grpc: {
                        type: "structure",
                        required: [
                          "maxRequests"
                        ],
                        members: {
                          maxRequests: {
                            type: "integer"
                          }
                        }
                      },
                      http: {
                        type: "structure",
                        required: [
                          "maxConnections"
                        ],
                        members: {
                          maxConnections: {
                            type: "integer"
                          },
                          maxPendingRequests: {
                            type: "integer"
                          }
                        }
                      },
                      http2: {
                        type: "structure",
                        required: [
                          "maxRequests"
                        ],
                        members: {
                          maxRequests: {
                            type: "integer"
                          }
                        }
                      }
                    },
                    union: true
                  },
                  healthCheck: {
                    type: "structure",
                    required: [
                      "healthyThreshold",
                      "intervalMillis",
                      "protocol",
                      "timeoutMillis",
                      "unhealthyThreshold"
                    ],
                    members: {
                      healthyThreshold: {
                        type: "integer"
                      },
                      intervalMillis: {
                        type: "long"
                      },
                      path: {},
                      port: {
                        type: "integer"
                      },
                      protocol: {},
                      timeoutMillis: {
                        type: "long"
                      },
                      unhealthyThreshold: {
                        type: "integer"
                      }
                    }
                  },
                  portMapping: {
                    type: "structure",
                    required: [
                      "port",
                      "protocol"
                    ],
                    members: {
                      port: {
                        type: "integer"
                      },
                      protocol: {}
                    }
                  },
                  tls: {
                    type: "structure",
                    required: [
                      "certificate",
                      "mode"
                    ],
                    members: {
                      certificate: {
                        type: "structure",
                        members: {
                          acm: {
                            type: "structure",
                            required: [
                              "certificateArn"
                            ],
                            members: {
                              certificateArn: {}
                            }
                          },
                          file: {
                            shape: "S36"
                          },
                          sds: {
                            shape: "S38"
                          }
                        },
                        union: true
                      },
                      mode: {},
                      validation: {
                        type: "structure",
                        required: [
                          "trust"
                        ],
                        members: {
                          subjectAlternativeNames: {
                            shape: "S3d"
                          },
                          trust: {
                            type: "structure",
                            members: {
                              file: {
                                shape: "S3k"
                              },
                              sds: {
                                shape: "S3l"
                              }
                            },
                            union: true
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            logging: {
              type: "structure",
              members: {
                accessLog: {
                  type: "structure",
                  members: {
                    file: {
                      type: "structure",
                      required: [
                        "path"
                      ],
                      members: {
                        format: {
                          shape: "S4a"
                        },
                        path: {}
                      }
                    }
                  },
                  union: true
                }
              }
            }
          }
        },
        S36: {
          type: "structure",
          required: [
            "certificateChain",
            "privateKey"
          ],
          members: {
            certificateChain: {},
            privateKey: {}
          }
        },
        S38: {
          type: "structure",
          required: [
            "secretName"
          ],
          members: {
            secretName: {}
          }
        },
        S3a: {
          type: "list",
          member: {
            type: "integer"
          }
        },
        S3d: {
          type: "structure",
          required: [
            "match"
          ],
          members: {
            match: {
              type: "structure",
              required: [
                "exact"
              ],
              members: {
                exact: {
                  type: "list",
                  member: {}
                }
              }
            }
          }
        },
        S3k: {
          type: "structure",
          required: [
            "certificateChain"
          ],
          members: {
            certificateChain: {}
          }
        },
        S3l: {
          type: "structure",
          required: [
            "secretName"
          ],
          members: {
            secretName: {}
          }
        },
        S4a: {
          type: "structure",
          members: {
            json: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "key",
                  "value"
                ],
                members: {
                  key: {},
                  value: {}
                }
              }
            },
            text: {}
          },
          union: true
        },
        S4h: {
          type: "structure",
          required: [
            "meshName",
            "metadata",
            "spec",
            "status",
            "virtualGatewayName"
          ],
          members: {
            meshName: {},
            metadata: {
              shape: "S1g"
            },
            spec: {
              shape: "S31"
            },
            status: {
              type: "structure",
              required: [
                "status"
              ],
              members: {
                status: {}
              }
            },
            virtualGatewayName: {}
          }
        },
        S4l: {
          type: "structure",
          members: {
            backendDefaults: {
              type: "structure",
              members: {
                clientPolicy: {
                  shape: "S4n"
                }
              }
            },
            backends: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  virtualService: {
                    type: "structure",
                    required: [
                      "virtualServiceName"
                    ],
                    members: {
                      clientPolicy: {
                        shape: "S4n"
                      },
                      virtualServiceName: {}
                    }
                  }
                },
                union: true
              }
            },
            listeners: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "portMapping"
                ],
                members: {
                  connectionPool: {
                    type: "structure",
                    members: {
                      grpc: {
                        type: "structure",
                        required: [
                          "maxRequests"
                        ],
                        members: {
                          maxRequests: {
                            type: "integer"
                          }
                        }
                      },
                      http: {
                        type: "structure",
                        required: [
                          "maxConnections"
                        ],
                        members: {
                          maxConnections: {
                            type: "integer"
                          },
                          maxPendingRequests: {
                            type: "integer"
                          }
                        }
                      },
                      http2: {
                        type: "structure",
                        required: [
                          "maxRequests"
                        ],
                        members: {
                          maxRequests: {
                            type: "integer"
                          }
                        }
                      },
                      tcp: {
                        type: "structure",
                        required: [
                          "maxConnections"
                        ],
                        members: {
                          maxConnections: {
                            type: "integer"
                          }
                        }
                      }
                    },
                    union: true
                  },
                  healthCheck: {
                    type: "structure",
                    required: [
                      "healthyThreshold",
                      "intervalMillis",
                      "protocol",
                      "timeoutMillis",
                      "unhealthyThreshold"
                    ],
                    members: {
                      healthyThreshold: {
                        type: "integer"
                      },
                      intervalMillis: {
                        type: "long"
                      },
                      path: {},
                      port: {
                        type: "integer"
                      },
                      protocol: {},
                      timeoutMillis: {
                        type: "long"
                      },
                      unhealthyThreshold: {
                        type: "integer"
                      }
                    }
                  },
                  outlierDetection: {
                    type: "structure",
                    required: [
                      "baseEjectionDuration",
                      "interval",
                      "maxEjectionPercent",
                      "maxServerErrors"
                    ],
                    members: {
                      baseEjectionDuration: {
                        shape: "S2d"
                      },
                      interval: {
                        shape: "S2d"
                      },
                      maxEjectionPercent: {
                        type: "integer"
                      },
                      maxServerErrors: {
                        type: "long"
                      }
                    }
                  },
                  portMapping: {
                    shape: "S5h"
                  },
                  timeout: {
                    type: "structure",
                    members: {
                      grpc: {
                        shape: "S2i"
                      },
                      http: {
                        shape: "S2q"
                      },
                      http2: {
                        shape: "S2q"
                      },
                      tcp: {
                        shape: "S2v"
                      }
                    },
                    union: true
                  },
                  tls: {
                    type: "structure",
                    required: [
                      "certificate",
                      "mode"
                    ],
                    members: {
                      certificate: {
                        type: "structure",
                        members: {
                          acm: {
                            type: "structure",
                            required: [
                              "certificateArn"
                            ],
                            members: {
                              certificateArn: {}
                            }
                          },
                          file: {
                            shape: "S4q"
                          },
                          sds: {
                            shape: "S4r"
                          }
                        },
                        union: true
                      },
                      mode: {},
                      validation: {
                        type: "structure",
                        required: [
                          "trust"
                        ],
                        members: {
                          subjectAlternativeNames: {
                            shape: "S3d"
                          },
                          trust: {
                            type: "structure",
                            members: {
                              file: {
                                shape: "S4x"
                              },
                              sds: {
                                shape: "S4y"
                              }
                            },
                            union: true
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            logging: {
              type: "structure",
              members: {
                accessLog: {
                  type: "structure",
                  members: {
                    file: {
                      type: "structure",
                      required: [
                        "path"
                      ],
                      members: {
                        format: {
                          shape: "S4a"
                        },
                        path: {}
                      }
                    }
                  },
                  union: true
                }
              }
            },
            serviceDiscovery: {
              type: "structure",
              members: {
                awsCloudMap: {
                  type: "structure",
                  required: [
                    "namespaceName",
                    "serviceName"
                  ],
                  members: {
                    attributes: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "key",
                          "value"
                        ],
                        members: {
                          key: {},
                          value: {}
                        }
                      }
                    },
                    ipPreference: {},
                    namespaceName: {},
                    serviceName: {}
                  }
                },
                dns: {
                  type: "structure",
                  required: [
                    "hostname"
                  ],
                  members: {
                    hostname: {},
                    ipPreference: {},
                    responseType: {}
                  }
                }
              },
              union: true
            }
          }
        },
        S4n: {
          type: "structure",
          members: {
            tls: {
              type: "structure",
              required: [
                "validation"
              ],
              members: {
                certificate: {
                  type: "structure",
                  members: {
                    file: {
                      shape: "S4q"
                    },
                    sds: {
                      shape: "S4r"
                    }
                  },
                  union: true
                },
                enforce: {
                  type: "boolean"
                },
                ports: {
                  shape: "S3a"
                },
                validation: {
                  type: "structure",
                  required: [
                    "trust"
                  ],
                  members: {
                    subjectAlternativeNames: {
                      shape: "S3d"
                    },
                    trust: {
                      type: "structure",
                      members: {
                        acm: {
                          type: "structure",
                          required: [
                            "certificateAuthorityArns"
                          ],
                          members: {
                            certificateAuthorityArns: {
                              type: "list",
                              member: {}
                            }
                          }
                        },
                        file: {
                          shape: "S4x"
                        },
                        sds: {
                          shape: "S4y"
                        }
                      },
                      union: true
                    }
                  }
                }
              }
            }
          }
        },
        S4q: {
          type: "structure",
          required: [
            "certificateChain",
            "privateKey"
          ],
          members: {
            certificateChain: {},
            privateKey: {}
          }
        },
        S4r: {
          type: "structure",
          required: [
            "secretName"
          ],
          members: {
            secretName: {}
          }
        },
        S4x: {
          type: "structure",
          required: [
            "certificateChain"
          ],
          members: {
            certificateChain: {}
          }
        },
        S4y: {
          type: "structure",
          required: [
            "secretName"
          ],
          members: {
            secretName: {}
          }
        },
        S5h: {
          type: "structure",
          required: [
            "port",
            "protocol"
          ],
          members: {
            port: {
              type: "integer"
            },
            protocol: {}
          }
        },
        S63: {
          type: "structure",
          required: [
            "meshName",
            "metadata",
            "spec",
            "status",
            "virtualNodeName"
          ],
          members: {
            meshName: {},
            metadata: {
              shape: "S1g"
            },
            spec: {
              shape: "S4l"
            },
            status: {
              type: "structure",
              required: [
                "status"
              ],
              members: {
                status: {}
              }
            },
            virtualNodeName: {}
          }
        },
        S67: {
          type: "structure",
          members: {
            listeners: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "portMapping"
                ],
                members: {
                  portMapping: {
                    shape: "S5h"
                  }
                }
              }
            }
          }
        },
        S6b: {
          type: "structure",
          required: [
            "meshName",
            "metadata",
            "spec",
            "status",
            "virtualRouterName"
          ],
          members: {
            meshName: {},
            metadata: {
              shape: "S1g"
            },
            spec: {
              shape: "S67"
            },
            status: {
              type: "structure",
              required: [
                "status"
              ],
              members: {
                status: {}
              }
            },
            virtualRouterName: {}
          }
        },
        S6f: {
          type: "structure",
          members: {
            provider: {
              type: "structure",
              members: {
                virtualNode: {
                  type: "structure",
                  required: [
                    "virtualNodeName"
                  ],
                  members: {
                    virtualNodeName: {}
                  }
                },
                virtualRouter: {
                  type: "structure",
                  required: [
                    "virtualRouterName"
                  ],
                  members: {
                    virtualRouterName: {}
                  }
                }
              },
              union: true
            }
          }
        },
        S6k: {
          type: "structure",
          required: [
            "meshName",
            "metadata",
            "spec",
            "status",
            "virtualServiceName"
          ],
          members: {
            meshName: {},
            metadata: {
              shape: "S1g"
            },
            spec: {
              shape: "S6f"
            },
            status: {
              type: "structure",
              required: [
                "status"
              ],
              members: {
                status: {}
              }
            },
            virtualServiceName: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/appmesh-2019-01-25.paginators.json
var require_appmesh_2019_01_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/appmesh-2019-01-25.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListGatewayRoutes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "limit",
          result_key: "gatewayRoutes"
        },
        ListMeshes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "limit",
          result_key: "meshes"
        },
        ListRoutes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "limit",
          result_key: "routes"
        },
        ListTagsForResource: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "limit",
          result_key: "tags"
        },
        ListVirtualGateways: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "limit",
          result_key: "virtualGateways"
        },
        ListVirtualNodes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "limit",
          result_key: "virtualNodes"
        },
        ListVirtualRouters: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "limit",
          result_key: "virtualRouters"
        },
        ListVirtualServices: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "limit",
          result_key: "virtualServices"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/appmesh.js
var require_appmesh = __commonJS({
  "node_modules/aws-sdk/clients/appmesh.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["appmesh"] = {};
    AWS2.AppMesh = Service.defineService("appmesh", ["2018-10-01", "2018-10-01*", "2019-01-25"]);
    Object.defineProperty(apiLoader.services["appmesh"], "2018-10-01", {
      get: function get() {
        var model = require_appmesh_2018_10_01_min();
        model.paginators = require_appmesh_2018_10_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(apiLoader.services["appmesh"], "2019-01-25", {
      get: function get() {
        var model = require_appmesh_2019_01_25_min();
        model.paginators = require_appmesh_2019_01_25_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.AppMesh;
  }
});

// node_modules/aws-sdk/apis/license-manager-2018-08-01.min.json
var require_license_manager_2018_08_01_min = __commonJS({
  "node_modules/aws-sdk/apis/license-manager-2018-08-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-08-01",
        endpointPrefix: "license-manager",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS License Manager",
        serviceId: "License Manager",
        signatureVersion: "v4",
        targetPrefix: "AWSLicenseManager",
        uid: "license-manager-2018-08-01"
      },
      operations: {
        AcceptGrant: {
          input: {
            type: "structure",
            required: [
              "GrantArn"
            ],
            members: {
              GrantArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GrantArn: {},
              Status: {},
              Version: {}
            }
          }
        },
        CheckInLicense: {
          input: {
            type: "structure",
            required: [
              "LicenseConsumptionToken"
            ],
            members: {
              LicenseConsumptionToken: {},
              Beneficiary: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CheckoutBorrowLicense: {
          input: {
            type: "structure",
            required: [
              "LicenseArn",
              "Entitlements",
              "DigitalSignatureMethod",
              "ClientToken"
            ],
            members: {
              LicenseArn: {},
              Entitlements: {
                shape: "S9"
              },
              DigitalSignatureMethod: {},
              NodeId: {},
              CheckoutMetadata: {
                shape: "Sd"
              },
              ClientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseArn: {},
              LicenseConsumptionToken: {},
              EntitlementsAllowed: {
                shape: "S9"
              },
              NodeId: {},
              SignedToken: {},
              IssuedAt: {},
              Expiration: {},
              CheckoutMetadata: {
                shape: "Sd"
              }
            }
          }
        },
        CheckoutLicense: {
          input: {
            type: "structure",
            required: [
              "ProductSKU",
              "CheckoutType",
              "KeyFingerprint",
              "Entitlements",
              "ClientToken"
            ],
            members: {
              ProductSKU: {},
              CheckoutType: {},
              KeyFingerprint: {},
              Entitlements: {
                shape: "S9"
              },
              ClientToken: {},
              Beneficiary: {},
              NodeId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CheckoutType: {},
              LicenseConsumptionToken: {},
              EntitlementsAllowed: {
                shape: "S9"
              },
              SignedToken: {},
              NodeId: {},
              IssuedAt: {},
              Expiration: {},
              LicenseArn: {}
            }
          }
        },
        CreateGrant: {
          input: {
            type: "structure",
            required: [
              "ClientToken",
              "GrantName",
              "LicenseArn",
              "Principals",
              "HomeRegion",
              "AllowedOperations"
            ],
            members: {
              ClientToken: {},
              GrantName: {},
              LicenseArn: {},
              Principals: {
                type: "list",
                member: {}
              },
              HomeRegion: {},
              AllowedOperations: {
                shape: "So"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GrantArn: {},
              Status: {},
              Version: {}
            }
          }
        },
        CreateGrantVersion: {
          input: {
            type: "structure",
            required: [
              "ClientToken",
              "GrantArn"
            ],
            members: {
              ClientToken: {},
              GrantArn: {},
              GrantName: {},
              AllowedOperations: {
                shape: "So"
              },
              Status: {},
              StatusReason: {},
              SourceVersion: {},
              Options: {
                shape: "St"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GrantArn: {},
              Status: {},
              Version: {}
            }
          }
        },
        CreateLicense: {
          input: {
            type: "structure",
            required: [
              "LicenseName",
              "ProductName",
              "ProductSKU",
              "Issuer",
              "HomeRegion",
              "Validity",
              "Entitlements",
              "Beneficiary",
              "ConsumptionConfiguration",
              "ClientToken"
            ],
            members: {
              LicenseName: {},
              ProductName: {},
              ProductSKU: {},
              Issuer: {
                shape: "Sx"
              },
              HomeRegion: {},
              Validity: {
                shape: "Sy"
              },
              Entitlements: {
                shape: "Sz"
              },
              Beneficiary: {},
              ConsumptionConfiguration: {
                shape: "S14"
              },
              LicenseMetadata: {
                shape: "Sd"
              },
              ClientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseArn: {},
              Status: {},
              Version: {}
            }
          }
        },
        CreateLicenseConfiguration: {
          input: {
            type: "structure",
            required: [
              "Name",
              "LicenseCountingType"
            ],
            members: {
              Name: {},
              Description: {},
              LicenseCountingType: {},
              LicenseCount: {
                type: "long"
              },
              LicenseCountHardLimit: {
                type: "boolean"
              },
              LicenseRules: {
                shape: "S1e"
              },
              Tags: {
                shape: "S1f"
              },
              DisassociateWhenNotFound: {
                type: "boolean"
              },
              ProductInformationList: {
                shape: "S1h"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseConfigurationArn: {}
            }
          }
        },
        CreateLicenseConversionTaskForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "SourceLicenseContext",
              "DestinationLicenseContext"
            ],
            members: {
              ResourceArn: {},
              SourceLicenseContext: {
                shape: "S1n"
              },
              DestinationLicenseContext: {
                shape: "S1n"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseConversionTaskId: {}
            }
          }
        },
        CreateLicenseManagerReportGenerator: {
          input: {
            type: "structure",
            required: [
              "ReportGeneratorName",
              "Type",
              "ReportContext",
              "ReportFrequency",
              "ClientToken"
            ],
            members: {
              ReportGeneratorName: {},
              Type: {
                shape: "S1t"
              },
              ReportContext: {
                shape: "S1v"
              },
              ReportFrequency: {
                shape: "S1x"
              },
              ClientToken: {},
              Description: {},
              Tags: {
                shape: "S1f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseManagerReportGeneratorArn: {}
            }
          }
        },
        CreateLicenseVersion: {
          input: {
            type: "structure",
            required: [
              "LicenseArn",
              "LicenseName",
              "ProductName",
              "Issuer",
              "HomeRegion",
              "Validity",
              "Entitlements",
              "ConsumptionConfiguration",
              "Status",
              "ClientToken"
            ],
            members: {
              LicenseArn: {},
              LicenseName: {},
              ProductName: {},
              Issuer: {
                shape: "Sx"
              },
              HomeRegion: {},
              Validity: {
                shape: "Sy"
              },
              LicenseMetadata: {
                shape: "Sd"
              },
              Entitlements: {
                shape: "Sz"
              },
              ConsumptionConfiguration: {
                shape: "S14"
              },
              Status: {},
              ClientToken: {},
              SourceVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseArn: {},
              Version: {},
              Status: {}
            }
          }
        },
        CreateToken: {
          input: {
            type: "structure",
            required: [
              "LicenseArn",
              "ClientToken"
            ],
            members: {
              LicenseArn: {},
              RoleArns: {
                shape: "S1w"
              },
              ExpirationInDays: {
                type: "integer"
              },
              TokenProperties: {
                shape: "S25"
              },
              ClientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TokenId: {},
              TokenType: {},
              Token: {}
            }
          }
        },
        DeleteGrant: {
          input: {
            type: "structure",
            required: [
              "GrantArn",
              "Version"
            ],
            members: {
              GrantArn: {},
              StatusReason: {},
              Version: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GrantArn: {},
              Status: {},
              Version: {}
            }
          }
        },
        DeleteLicense: {
          input: {
            type: "structure",
            required: [
              "LicenseArn",
              "SourceVersion"
            ],
            members: {
              LicenseArn: {},
              SourceVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {},
              DeletionDate: {}
            }
          }
        },
        DeleteLicenseConfiguration: {
          input: {
            type: "structure",
            required: [
              "LicenseConfigurationArn"
            ],
            members: {
              LicenseConfigurationArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteLicenseManagerReportGenerator: {
          input: {
            type: "structure",
            required: [
              "LicenseManagerReportGeneratorArn"
            ],
            members: {
              LicenseManagerReportGeneratorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteToken: {
          input: {
            type: "structure",
            required: [
              "TokenId"
            ],
            members: {
              TokenId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ExtendLicenseConsumption: {
          input: {
            type: "structure",
            required: [
              "LicenseConsumptionToken"
            ],
            members: {
              LicenseConsumptionToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseConsumptionToken: {},
              Expiration: {}
            }
          }
        },
        GetAccessToken: {
          input: {
            type: "structure",
            required: [
              "Token"
            ],
            members: {
              Token: {},
              TokenProperties: {
                shape: "S25"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccessToken: {}
            }
          }
        },
        GetGrant: {
          input: {
            type: "structure",
            required: [
              "GrantArn"
            ],
            members: {
              GrantArn: {},
              Version: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Grant: {
                shape: "S2r"
              }
            }
          }
        },
        GetLicense: {
          input: {
            type: "structure",
            required: [
              "LicenseArn"
            ],
            members: {
              LicenseArn: {},
              Version: {}
            }
          },
          output: {
            type: "structure",
            members: {
              License: {
                shape: "S2u"
              }
            }
          }
        },
        GetLicenseConfiguration: {
          input: {
            type: "structure",
            required: [
              "LicenseConfigurationArn"
            ],
            members: {
              LicenseConfigurationArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseConfigurationId: {},
              LicenseConfigurationArn: {},
              Name: {},
              Description: {},
              LicenseCountingType: {},
              LicenseRules: {
                shape: "S1e"
              },
              LicenseCount: {
                type: "long"
              },
              LicenseCountHardLimit: {
                type: "boolean"
              },
              ConsumedLicenses: {
                type: "long"
              },
              Status: {},
              OwnerAccountId: {},
              ConsumedLicenseSummaryList: {
                shape: "S2y"
              },
              ManagedResourceSummaryList: {
                shape: "S31"
              },
              Tags: {
                shape: "S1f"
              },
              ProductInformationList: {
                shape: "S1h"
              },
              AutomatedDiscoveryInformation: {
                shape: "S33"
              },
              DisassociateWhenNotFound: {
                type: "boolean"
              }
            }
          }
        },
        GetLicenseConversionTask: {
          input: {
            type: "structure",
            required: [
              "LicenseConversionTaskId"
            ],
            members: {
              LicenseConversionTaskId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseConversionTaskId: {},
              ResourceArn: {},
              SourceLicenseContext: {
                shape: "S1n"
              },
              DestinationLicenseContext: {
                shape: "S1n"
              },
              StatusMessage: {},
              Status: {},
              StartTime: {
                type: "timestamp"
              },
              LicenseConversionTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              }
            }
          }
        },
        GetLicenseManagerReportGenerator: {
          input: {
            type: "structure",
            required: [
              "LicenseManagerReportGeneratorArn"
            ],
            members: {
              LicenseManagerReportGeneratorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReportGenerator: {
                shape: "S3a"
              }
            }
          }
        },
        GetLicenseUsage: {
          input: {
            type: "structure",
            required: [
              "LicenseArn"
            ],
            members: {
              LicenseArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseUsage: {
                type: "structure",
                members: {
                  EntitlementUsages: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Name",
                        "ConsumedValue",
                        "Unit"
                      ],
                      members: {
                        Name: {},
                        ConsumedValue: {},
                        MaxCount: {},
                        Unit: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetServiceSettings: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              S3BucketArn: {},
              SnsTopicArn: {},
              OrganizationConfiguration: {
                shape: "S3j"
              },
              EnableCrossAccountsDiscovery: {
                type: "boolean"
              },
              LicenseManagerResourceShareArn: {}
            }
          }
        },
        ListAssociationsForLicenseConfiguration: {
          input: {
            type: "structure",
            required: [
              "LicenseConfigurationArn"
            ],
            members: {
              LicenseConfigurationArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseConfigurationAssociations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceArn: {},
                    ResourceType: {},
                    ResourceOwnerId: {},
                    AssociationTime: {
                      type: "timestamp"
                    },
                    AmiAssociationScope: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDistributedGrants: {
          input: {
            type: "structure",
            members: {
              GrantArns: {
                shape: "S1w"
              },
              Filters: {
                shape: "S3p"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Grants: {
                shape: "S3w"
              },
              NextToken: {}
            }
          }
        },
        ListFailuresForLicenseConfigurationOperations: {
          input: {
            type: "structure",
            required: [
              "LicenseConfigurationArn"
            ],
            members: {
              LicenseConfigurationArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseOperationFailureList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceArn: {},
                    ResourceType: {},
                    ErrorMessage: {},
                    FailureTime: {
                      type: "timestamp"
                    },
                    OperationName: {},
                    ResourceOwnerId: {},
                    OperationRequestedBy: {},
                    MetadataList: {
                      shape: "Sd"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListLicenseConfigurations: {
          input: {
            type: "structure",
            members: {
              LicenseConfigurationArns: {
                shape: "S1e"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "S42"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LicenseConfigurationId: {},
                    LicenseConfigurationArn: {},
                    Name: {},
                    Description: {},
                    LicenseCountingType: {},
                    LicenseRules: {
                      shape: "S1e"
                    },
                    LicenseCount: {
                      type: "long"
                    },
                    LicenseCountHardLimit: {
                      type: "boolean"
                    },
                    DisassociateWhenNotFound: {
                      type: "boolean"
                    },
                    ConsumedLicenses: {
                      type: "long"
                    },
                    Status: {},
                    OwnerAccountId: {},
                    ConsumedLicenseSummaryList: {
                      shape: "S2y"
                    },
                    ManagedResourceSummaryList: {
                      shape: "S31"
                    },
                    ProductInformationList: {
                      shape: "S1h"
                    },
                    AutomatedDiscoveryInformation: {
                      shape: "S33"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListLicenseConversionTasks: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S42"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseConversionTasks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LicenseConversionTaskId: {},
                    ResourceArn: {},
                    SourceLicenseContext: {
                      shape: "S1n"
                    },
                    DestinationLicenseContext: {
                      shape: "S1n"
                    },
                    Status: {},
                    StatusMessage: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    LicenseConversionTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListLicenseManagerReportGenerators: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S3p"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReportGenerators: {
                type: "list",
                member: {
                  shape: "S3a"
                }
              },
              NextToken: {}
            }
          }
        },
        ListLicenseSpecificationsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseSpecifications: {
                shape: "S4f"
              },
              NextToken: {}
            }
          }
        },
        ListLicenseVersions: {
          input: {
            type: "structure",
            required: [
              "LicenseArn"
            ],
            members: {
              LicenseArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Licenses: {
                shape: "S4j"
              },
              NextToken: {}
            }
          }
        },
        ListLicenses: {
          input: {
            type: "structure",
            members: {
              LicenseArns: {
                shape: "S1w"
              },
              Filters: {
                shape: "S3p"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Licenses: {
                shape: "S4j"
              },
              NextToken: {}
            }
          }
        },
        ListReceivedGrants: {
          input: {
            type: "structure",
            members: {
              GrantArns: {
                shape: "S1w"
              },
              Filters: {
                shape: "S3p"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Grants: {
                shape: "S3w"
              },
              NextToken: {}
            }
          }
        },
        ListReceivedGrantsForOrganization: {
          input: {
            type: "structure",
            required: [
              "LicenseArn"
            ],
            members: {
              LicenseArn: {},
              Filters: {
                shape: "S3p"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Grants: {
                shape: "S3w"
              },
              NextToken: {}
            }
          }
        },
        ListReceivedLicenses: {
          input: {
            type: "structure",
            members: {
              LicenseArns: {
                shape: "S1w"
              },
              Filters: {
                shape: "S3p"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Licenses: {
                shape: "S4s"
              },
              NextToken: {}
            }
          }
        },
        ListReceivedLicensesForOrganization: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S3p"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Licenses: {
                shape: "S4s"
              },
              NextToken: {}
            }
          }
        },
        ListResourceInventory: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Condition"
                  ],
                  members: {
                    Name: {},
                    Condition: {},
                    Value: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceInventoryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceId: {},
                    ResourceType: {},
                    ResourceArn: {},
                    Platform: {},
                    PlatformVersion: {},
                    ResourceOwningAccountId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S1f"
              }
            }
          }
        },
        ListTokens: {
          input: {
            type: "structure",
            members: {
              TokenIds: {
                shape: "S1e"
              },
              Filters: {
                shape: "S3p"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tokens: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TokenId: {},
                    TokenType: {},
                    LicenseArn: {},
                    ExpirationTime: {},
                    TokenProperties: {
                      shape: "S25"
                    },
                    RoleArns: {
                      shape: "S1w"
                    },
                    Status: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListUsageForLicenseConfiguration: {
          input: {
            type: "structure",
            required: [
              "LicenseConfigurationArn"
            ],
            members: {
              LicenseConfigurationArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "S42"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseConfigurationUsageList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceArn: {},
                    ResourceType: {},
                    ResourceStatus: {},
                    ResourceOwnerId: {},
                    AssociationTime: {
                      type: "timestamp"
                    },
                    ConsumedLicenses: {
                      type: "long"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        RejectGrant: {
          input: {
            type: "structure",
            required: [
              "GrantArn"
            ],
            members: {
              GrantArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GrantArn: {},
              Status: {},
              Version: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S1f"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateLicenseConfiguration: {
          input: {
            type: "structure",
            required: [
              "LicenseConfigurationArn"
            ],
            members: {
              LicenseConfigurationArn: {},
              LicenseConfigurationStatus: {},
              LicenseRules: {
                shape: "S1e"
              },
              LicenseCount: {
                type: "long"
              },
              LicenseCountHardLimit: {
                type: "boolean"
              },
              Name: {},
              Description: {},
              ProductInformationList: {
                shape: "S1h"
              },
              DisassociateWhenNotFound: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateLicenseManagerReportGenerator: {
          input: {
            type: "structure",
            required: [
              "LicenseManagerReportGeneratorArn",
              "ReportGeneratorName",
              "Type",
              "ReportContext",
              "ReportFrequency",
              "ClientToken"
            ],
            members: {
              LicenseManagerReportGeneratorArn: {},
              ReportGeneratorName: {},
              Type: {
                shape: "S1t"
              },
              ReportContext: {
                shape: "S1v"
              },
              ReportFrequency: {
                shape: "S1x"
              },
              ClientToken: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateLicenseSpecificationsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              AddLicenseSpecifications: {
                shape: "S4f"
              },
              RemoveLicenseSpecifications: {
                shape: "S4f"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateServiceSettings: {
          input: {
            type: "structure",
            members: {
              S3BucketArn: {},
              SnsTopicArn: {},
              OrganizationConfiguration: {
                shape: "S3j"
              },
              EnableCrossAccountsDiscovery: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S9: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Unit"
            ],
            members: {
              Name: {},
              Value: {},
              Unit: {}
            }
          }
        },
        Sd: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Value: {}
            }
          }
        },
        So: {
          type: "list",
          member: {}
        },
        St: {
          type: "structure",
          members: {
            ActivationOverrideBehavior: {}
          }
        },
        Sx: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            SignKey: {}
          }
        },
        Sy: {
          type: "structure",
          required: [
            "Begin"
          ],
          members: {
            Begin: {},
            End: {}
          }
        },
        Sz: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Unit"
            ],
            members: {
              Name: {},
              Value: {},
              MaxCount: {
                type: "long"
              },
              Overage: {
                type: "boolean"
              },
              Unit: {},
              AllowCheckIn: {
                type: "boolean"
              }
            }
          }
        },
        S14: {
          type: "structure",
          members: {
            RenewType: {},
            ProvisionalConfiguration: {
              type: "structure",
              required: [
                "MaxTimeToLiveInMinutes"
              ],
              members: {
                MaxTimeToLiveInMinutes: {
                  type: "integer"
                }
              }
            },
            BorrowConfiguration: {
              type: "structure",
              required: [
                "AllowEarlyCheckIn",
                "MaxTimeToLiveInMinutes"
              ],
              members: {
                AllowEarlyCheckIn: {
                  type: "boolean"
                },
                MaxTimeToLiveInMinutes: {
                  type: "integer"
                }
              }
            }
          }
        },
        S1e: {
          type: "list",
          member: {}
        },
        S1f: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S1h: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ResourceType",
              "ProductInformationFilterList"
            ],
            members: {
              ResourceType: {},
              ProductInformationFilterList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ProductInformationFilterName",
                    "ProductInformationFilterComparator"
                  ],
                  members: {
                    ProductInformationFilterName: {},
                    ProductInformationFilterValue: {
                      shape: "S1e"
                    },
                    ProductInformationFilterComparator: {}
                  }
                }
              }
            }
          }
        },
        S1n: {
          type: "structure",
          members: {
            UsageOperation: {}
          }
        },
        S1t: {
          type: "list",
          member: {}
        },
        S1v: {
          type: "structure",
          required: [
            "licenseConfigurationArns"
          ],
          members: {
            licenseConfigurationArns: {
              shape: "S1w"
            }
          }
        },
        S1w: {
          type: "list",
          member: {}
        },
        S1x: {
          type: "structure",
          members: {
            value: {
              type: "integer"
            },
            period: {}
          }
        },
        S25: {
          type: "list",
          member: {}
        },
        S2r: {
          type: "structure",
          required: [
            "GrantArn",
            "GrantName",
            "ParentArn",
            "LicenseArn",
            "GranteePrincipalArn",
            "HomeRegion",
            "GrantStatus",
            "Version",
            "GrantedOperations"
          ],
          members: {
            GrantArn: {},
            GrantName: {},
            ParentArn: {},
            LicenseArn: {},
            GranteePrincipalArn: {},
            HomeRegion: {},
            GrantStatus: {},
            StatusReason: {},
            Version: {},
            GrantedOperations: {
              shape: "So"
            },
            Options: {
              shape: "St"
            }
          }
        },
        S2u: {
          type: "structure",
          members: {
            LicenseArn: {},
            LicenseName: {},
            ProductName: {},
            ProductSKU: {},
            Issuer: {
              shape: "S2v"
            },
            HomeRegion: {},
            Status: {},
            Validity: {
              shape: "Sy"
            },
            Beneficiary: {},
            Entitlements: {
              shape: "Sz"
            },
            ConsumptionConfiguration: {
              shape: "S14"
            },
            LicenseMetadata: {
              shape: "Sd"
            },
            CreateTime: {},
            Version: {}
          }
        },
        S2v: {
          type: "structure",
          members: {
            Name: {},
            SignKey: {},
            KeyFingerprint: {}
          }
        },
        S2y: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ResourceType: {},
              ConsumedLicenses: {
                type: "long"
              }
            }
          }
        },
        S31: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ResourceType: {},
              AssociationCount: {
                type: "long"
              }
            }
          }
        },
        S33: {
          type: "structure",
          members: {
            LastRunTime: {
              type: "timestamp"
            }
          }
        },
        S3a: {
          type: "structure",
          members: {
            ReportGeneratorName: {},
            ReportType: {
              shape: "S1t"
            },
            ReportContext: {
              shape: "S1v"
            },
            ReportFrequency: {
              shape: "S1x"
            },
            LicenseManagerReportGeneratorArn: {},
            LastRunStatus: {},
            LastRunFailureReason: {},
            LastReportGenerationTime: {},
            ReportCreatorAccount: {},
            Description: {},
            S3Location: {
              type: "structure",
              members: {
                bucket: {},
                keyPrefix: {}
              }
            },
            CreateTime: {},
            Tags: {
              shape: "S1f"
            }
          }
        },
        S3j: {
          type: "structure",
          required: [
            "EnableIntegration"
          ],
          members: {
            EnableIntegration: {
              type: "boolean"
            }
          }
        },
        S3p: {
          type: "list",
          member: {
            shape: "S3q"
          }
        },
        S3q: {
          type: "structure",
          members: {
            Name: {},
            Values: {
              type: "list",
              member: {}
            }
          }
        },
        S3w: {
          type: "list",
          member: {
            shape: "S2r"
          }
        },
        S42: {
          type: "list",
          member: {
            shape: "S3q"
          }
        },
        S4f: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "LicenseConfigurationArn"
            ],
            members: {
              LicenseConfigurationArn: {},
              AmiAssociationScope: {}
            }
          }
        },
        S4j: {
          type: "list",
          member: {
            shape: "S2u"
          }
        },
        S4s: {
          type: "list",
          member: {
            type: "structure",
            members: {
              LicenseArn: {},
              LicenseName: {},
              ProductName: {},
              ProductSKU: {},
              Issuer: {
                shape: "S2v"
              },
              HomeRegion: {},
              Status: {},
              Validity: {
                shape: "Sy"
              },
              Beneficiary: {},
              Entitlements: {
                shape: "Sz"
              },
              ConsumptionConfiguration: {
                shape: "S14"
              },
              LicenseMetadata: {
                shape: "Sd"
              },
              CreateTime: {},
              Version: {},
              ReceivedMetadata: {
                type: "structure",
                members: {
                  ReceivedStatus: {},
                  ReceivedStatusReason: {},
                  AllowedOperations: {
                    shape: "So"
                  }
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/license-manager-2018-08-01.paginators.json
var require_license_manager_2018_08_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/license-manager-2018-08-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/licensemanager.js
var require_licensemanager = __commonJS({
  "node_modules/aws-sdk/clients/licensemanager.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["licensemanager"] = {};
    AWS2.LicenseManager = Service.defineService("licensemanager", ["2018-08-01"]);
    Object.defineProperty(apiLoader.services["licensemanager"], "2018-08-01", {
      get: function get() {
        var model = require_license_manager_2018_08_01_min();
        model.paginators = require_license_manager_2018_08_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.LicenseManager;
  }
});

// node_modules/aws-sdk/apis/kafka-2018-11-14.min.json
var require_kafka_2018_11_14_min = __commonJS({
  "node_modules/aws-sdk/apis/kafka-2018-11-14.min.json"(exports2, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2018-11-14",
        endpointPrefix: "kafka",
        signingName: "kafka",
        serviceFullName: "Managed Streaming for Kafka",
        serviceAbbreviation: "Kafka",
        serviceId: "Kafka",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "kafka-2018-11-14",
        signatureVersion: "v4"
      },
      operations: {
        BatchAssociateScramSecret: {
          http: {
            requestUri: "/v1/clusters/{clusterArn}/scram-secrets",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              SecretArnList: {
                shape: "S3",
                locationName: "secretArnList"
              }
            },
            required: [
              "ClusterArn",
              "SecretArnList"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterArn: {
                locationName: "clusterArn"
              },
              UnprocessedScramSecrets: {
                shape: "S5",
                locationName: "unprocessedScramSecrets"
              }
            }
          }
        },
        CreateCluster: {
          http: {
            requestUri: "/v1/clusters",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BrokerNodeGroupInfo: {
                shape: "S8",
                locationName: "brokerNodeGroupInfo"
              },
              ClientAuthentication: {
                shape: "Sp",
                locationName: "clientAuthentication"
              },
              ClusterName: {
                locationName: "clusterName"
              },
              ConfigurationInfo: {
                shape: "Sw",
                locationName: "configurationInfo"
              },
              EncryptionInfo: {
                shape: "Sy",
                locationName: "encryptionInfo"
              },
              EnhancedMonitoring: {
                locationName: "enhancedMonitoring"
              },
              OpenMonitoring: {
                shape: "S13",
                locationName: "openMonitoring"
              },
              KafkaVersion: {
                locationName: "kafkaVersion"
              },
              LoggingInfo: {
                shape: "S18",
                locationName: "loggingInfo"
              },
              NumberOfBrokerNodes: {
                locationName: "numberOfBrokerNodes",
                type: "integer"
              },
              Tags: {
                shape: "S1e",
                locationName: "tags"
              },
              StorageMode: {
                locationName: "storageMode"
              }
            },
            required: [
              "BrokerNodeGroupInfo",
              "KafkaVersion",
              "NumberOfBrokerNodes",
              "ClusterName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterArn: {
                locationName: "clusterArn"
              },
              ClusterName: {
                locationName: "clusterName"
              },
              State: {
                locationName: "state"
              }
            }
          }
        },
        CreateClusterV2: {
          http: {
            requestUri: "/api/v2/clusters",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterName: {
                locationName: "clusterName"
              },
              Tags: {
                shape: "S1e",
                locationName: "tags"
              },
              Provisioned: {
                locationName: "provisioned",
                type: "structure",
                members: {
                  BrokerNodeGroupInfo: {
                    shape: "S8",
                    locationName: "brokerNodeGroupInfo"
                  },
                  ClientAuthentication: {
                    shape: "Sp",
                    locationName: "clientAuthentication"
                  },
                  ConfigurationInfo: {
                    shape: "Sw",
                    locationName: "configurationInfo"
                  },
                  EncryptionInfo: {
                    shape: "Sy",
                    locationName: "encryptionInfo"
                  },
                  EnhancedMonitoring: {
                    locationName: "enhancedMonitoring"
                  },
                  OpenMonitoring: {
                    shape: "S13",
                    locationName: "openMonitoring"
                  },
                  KafkaVersion: {
                    locationName: "kafkaVersion"
                  },
                  LoggingInfo: {
                    shape: "S18",
                    locationName: "loggingInfo"
                  },
                  NumberOfBrokerNodes: {
                    locationName: "numberOfBrokerNodes",
                    type: "integer"
                  },
                  StorageMode: {
                    locationName: "storageMode"
                  }
                },
                required: [
                  "BrokerNodeGroupInfo",
                  "KafkaVersion",
                  "NumberOfBrokerNodes"
                ]
              },
              Serverless: {
                locationName: "serverless",
                type: "structure",
                members: {
                  VpcConfigs: {
                    shape: "S1l",
                    locationName: "vpcConfigs"
                  },
                  ClientAuthentication: {
                    shape: "S1n",
                    locationName: "clientAuthentication"
                  }
                },
                required: [
                  "VpcConfigs"
                ]
              }
            },
            required: [
              "ClusterName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterArn: {
                locationName: "clusterArn"
              },
              ClusterName: {
                locationName: "clusterName"
              },
              State: {
                locationName: "state"
              },
              ClusterType: {
                locationName: "clusterType"
              }
            }
          }
        },
        CreateConfiguration: {
          http: {
            requestUri: "/v1/configurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Description: {
                locationName: "description"
              },
              KafkaVersions: {
                shape: "S3",
                locationName: "kafkaVersions"
              },
              Name: {
                locationName: "name"
              },
              ServerProperties: {
                locationName: "serverProperties",
                type: "blob"
              }
            },
            required: [
              "ServerProperties",
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              CreationTime: {
                shape: "S1u",
                locationName: "creationTime"
              },
              LatestRevision: {
                shape: "S1v",
                locationName: "latestRevision"
              },
              Name: {
                locationName: "name"
              },
              State: {
                locationName: "state"
              }
            }
          }
        },
        CreateReplicator: {
          http: {
            requestUri: "/replication/v1/replicators",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Description: {
                locationName: "description"
              },
              KafkaClusters: {
                locationName: "kafkaClusters",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AmazonMskCluster: {
                      shape: "S21",
                      locationName: "amazonMskCluster"
                    },
                    VpcConfig: {
                      shape: "S22",
                      locationName: "vpcConfig"
                    }
                  },
                  required: [
                    "VpcConfig",
                    "AmazonMskCluster"
                  ]
                }
              },
              ReplicationInfoList: {
                locationName: "replicationInfoList",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ConsumerGroupReplication: {
                      shape: "S25",
                      locationName: "consumerGroupReplication"
                    },
                    SourceKafkaClusterArn: {
                      locationName: "sourceKafkaClusterArn"
                    },
                    TargetCompressionType: {
                      locationName: "targetCompressionType"
                    },
                    TargetKafkaClusterArn: {
                      locationName: "targetKafkaClusterArn"
                    },
                    TopicReplication: {
                      shape: "S29",
                      locationName: "topicReplication"
                    }
                  },
                  required: [
                    "TargetCompressionType",
                    "TopicReplication",
                    "ConsumerGroupReplication",
                    "SourceKafkaClusterArn",
                    "TargetKafkaClusterArn"
                  ]
                }
              },
              ReplicatorName: {
                locationName: "replicatorName"
              },
              ServiceExecutionRoleArn: {
                locationName: "serviceExecutionRoleArn"
              },
              Tags: {
                shape: "S1e",
                locationName: "tags"
              }
            },
            required: [
              "ServiceExecutionRoleArn",
              "ReplicatorName",
              "ReplicationInfoList",
              "KafkaClusters"
            ]
          },
          output: {
            type: "structure",
            members: {
              ReplicatorArn: {
                locationName: "replicatorArn"
              },
              ReplicatorName: {
                locationName: "replicatorName"
              },
              ReplicatorState: {
                locationName: "replicatorState"
              }
            }
          }
        },
        CreateVpcConnection: {
          http: {
            requestUri: "/v1/vpc-connection",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              TargetClusterArn: {
                locationName: "targetClusterArn"
              },
              Authentication: {
                locationName: "authentication"
              },
              VpcId: {
                locationName: "vpcId"
              },
              ClientSubnets: {
                shape: "S3",
                locationName: "clientSubnets"
              },
              SecurityGroups: {
                shape: "S3",
                locationName: "securityGroups"
              },
              Tags: {
                shape: "S1e",
                locationName: "tags"
              }
            },
            required: [
              "TargetClusterArn",
              "Authentication",
              "VpcId",
              "ClientSubnets",
              "SecurityGroups"
            ]
          },
          output: {
            type: "structure",
            members: {
              VpcConnectionArn: {
                locationName: "vpcConnectionArn"
              },
              State: {
                locationName: "state"
              },
              Authentication: {
                locationName: "authentication"
              },
              VpcId: {
                locationName: "vpcId"
              },
              ClientSubnets: {
                shape: "S3",
                locationName: "clientSubnets"
              },
              SecurityGroups: {
                shape: "S3",
                locationName: "securityGroups"
              },
              CreationTime: {
                shape: "S1u",
                locationName: "creationTime"
              },
              Tags: {
                shape: "S1e",
                locationName: "tags"
              }
            }
          }
        },
        DeleteCluster: {
          http: {
            method: "DELETE",
            requestUri: "/v1/clusters/{clusterArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              CurrentVersion: {
                location: "querystring",
                locationName: "currentVersion"
              }
            },
            required: [
              "ClusterArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterArn: {
                locationName: "clusterArn"
              },
              State: {
                locationName: "state"
              }
            }
          }
        },
        DeleteClusterPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/v1/clusters/{clusterArn}/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              }
            },
            required: [
              "ClusterArn"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/v1/configurations/{arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Arn: {
                location: "uri",
                locationName: "arn"
              }
            },
            required: [
              "Arn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              State: {
                locationName: "state"
              }
            }
          }
        },
        DeleteReplicator: {
          http: {
            method: "DELETE",
            requestUri: "/replication/v1/replicators/{replicatorArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CurrentVersion: {
                location: "querystring",
                locationName: "currentVersion"
              },
              ReplicatorArn: {
                location: "uri",
                locationName: "replicatorArn"
              }
            },
            required: [
              "ReplicatorArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              ReplicatorArn: {
                locationName: "replicatorArn"
              },
              ReplicatorState: {
                locationName: "replicatorState"
              }
            }
          }
        },
        DeleteVpcConnection: {
          http: {
            method: "DELETE",
            requestUri: "/v1/vpc-connection/{arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Arn: {
                location: "uri",
                locationName: "arn"
              }
            },
            required: [
              "Arn"
            ]
          },
          output: {
            type: "structure",
            members: {
              VpcConnectionArn: {
                locationName: "vpcConnectionArn"
              },
              State: {
                locationName: "state"
              }
            }
          }
        },
        DescribeCluster: {
          http: {
            method: "GET",
            requestUri: "/v1/clusters/{clusterArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              }
            },
            required: [
              "ClusterArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterInfo: {
                shape: "S2u",
                locationName: "clusterInfo"
              }
            }
          }
        },
        DescribeClusterV2: {
          http: {
            method: "GET",
            requestUri: "/api/v2/clusters/{clusterArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              }
            },
            required: [
              "ClusterArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterInfo: {
                shape: "S34",
                locationName: "clusterInfo"
              }
            }
          }
        },
        DescribeClusterOperation: {
          http: {
            method: "GET",
            requestUri: "/v1/operations/{clusterOperationArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterOperationArn: {
                location: "uri",
                locationName: "clusterOperationArn"
              }
            },
            required: [
              "ClusterOperationArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterOperationInfo: {
                shape: "S39",
                locationName: "clusterOperationInfo"
              }
            }
          }
        },
        DescribeClusterOperationV2: {
          http: {
            method: "GET",
            requestUri: "/api/v2/operations/{clusterOperationArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterOperationArn: {
                location: "uri",
                locationName: "clusterOperationArn"
              }
            },
            required: [
              "ClusterOperationArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterOperationInfo: {
                locationName: "clusterOperationInfo",
                type: "structure",
                members: {
                  ClusterArn: {
                    locationName: "clusterArn"
                  },
                  ClusterType: {
                    locationName: "clusterType"
                  },
                  StartTime: {
                    shape: "S1u",
                    locationName: "startTime"
                  },
                  EndTime: {
                    shape: "S1u",
                    locationName: "endTime"
                  },
                  ErrorInfo: {
                    shape: "S3a",
                    locationName: "errorInfo"
                  },
                  OperationArn: {
                    locationName: "operationArn"
                  },
                  OperationState: {
                    locationName: "operationState"
                  },
                  OperationType: {
                    locationName: "operationType"
                  },
                  Provisioned: {
                    locationName: "provisioned",
                    type: "structure",
                    members: {
                      OperationSteps: {
                        shape: "S3b",
                        locationName: "operationSteps"
                      },
                      SourceClusterInfo: {
                        shape: "S3e",
                        locationName: "sourceClusterInfo"
                      },
                      TargetClusterInfo: {
                        shape: "S3e",
                        locationName: "targetClusterInfo"
                      },
                      VpcConnectionInfo: {
                        shape: "S3h",
                        locationName: "vpcConnectionInfo"
                      }
                    }
                  },
                  Serverless: {
                    locationName: "serverless",
                    type: "structure",
                    members: {
                      VpcConnectionInfo: {
                        locationName: "vpcConnectionInfo",
                        type: "structure",
                        members: {
                          CreationTime: {
                            shape: "S1u",
                            locationName: "creationTime"
                          },
                          Owner: {
                            locationName: "owner"
                          },
                          UserIdentity: {
                            shape: "S3i",
                            locationName: "userIdentity"
                          },
                          VpcConnectionArn: {
                            locationName: "vpcConnectionArn"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeConfiguration: {
          http: {
            method: "GET",
            requestUri: "/v1/configurations/{arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Arn: {
                location: "uri",
                locationName: "arn"
              }
            },
            required: [
              "Arn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              CreationTime: {
                shape: "S1u",
                locationName: "creationTime"
              },
              Description: {
                locationName: "description"
              },
              KafkaVersions: {
                shape: "S3",
                locationName: "kafkaVersions"
              },
              LatestRevision: {
                shape: "S1v",
                locationName: "latestRevision"
              },
              Name: {
                locationName: "name"
              },
              State: {
                locationName: "state"
              }
            }
          }
        },
        DescribeConfigurationRevision: {
          http: {
            method: "GET",
            requestUri: "/v1/configurations/{arn}/revisions/{revision}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Arn: {
                location: "uri",
                locationName: "arn"
              },
              Revision: {
                location: "uri",
                locationName: "revision",
                type: "long"
              }
            },
            required: [
              "Revision",
              "Arn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              CreationTime: {
                shape: "S1u",
                locationName: "creationTime"
              },
              Description: {
                locationName: "description"
              },
              Revision: {
                locationName: "revision",
                type: "long"
              },
              ServerProperties: {
                locationName: "serverProperties",
                type: "blob"
              }
            }
          }
        },
        DescribeReplicator: {
          http: {
            method: "GET",
            requestUri: "/replication/v1/replicators/{replicatorArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ReplicatorArn: {
                location: "uri",
                locationName: "replicatorArn"
              }
            },
            required: [
              "ReplicatorArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              CreationTime: {
                shape: "S1u",
                locationName: "creationTime"
              },
              CurrentVersion: {
                locationName: "currentVersion"
              },
              IsReplicatorReference: {
                locationName: "isReplicatorReference",
                type: "boolean"
              },
              KafkaClusters: {
                locationName: "kafkaClusters",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AmazonMskCluster: {
                      shape: "S21",
                      locationName: "amazonMskCluster"
                    },
                    KafkaClusterAlias: {
                      locationName: "kafkaClusterAlias"
                    },
                    VpcConfig: {
                      shape: "S22",
                      locationName: "vpcConfig"
                    }
                  }
                }
              },
              ReplicationInfoList: {
                locationName: "replicationInfoList",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ConsumerGroupReplication: {
                      shape: "S25",
                      locationName: "consumerGroupReplication"
                    },
                    SourceKafkaClusterAlias: {
                      locationName: "sourceKafkaClusterAlias"
                    },
                    TargetCompressionType: {
                      locationName: "targetCompressionType"
                    },
                    TargetKafkaClusterAlias: {
                      locationName: "targetKafkaClusterAlias"
                    },
                    TopicReplication: {
                      shape: "S29",
                      locationName: "topicReplication"
                    }
                  }
                }
              },
              ReplicatorArn: {
                locationName: "replicatorArn"
              },
              ReplicatorDescription: {
                locationName: "replicatorDescription"
              },
              ReplicatorName: {
                locationName: "replicatorName"
              },
              ReplicatorResourceArn: {
                locationName: "replicatorResourceArn"
              },
              ReplicatorState: {
                locationName: "replicatorState"
              },
              ServiceExecutionRoleArn: {
                locationName: "serviceExecutionRoleArn"
              },
              StateInfo: {
                locationName: "stateInfo",
                type: "structure",
                members: {
                  Code: {
                    locationName: "code"
                  },
                  Message: {
                    locationName: "message"
                  }
                }
              },
              Tags: {
                shape: "S1e",
                locationName: "tags"
              }
            }
          }
        },
        DescribeVpcConnection: {
          http: {
            method: "GET",
            requestUri: "/v1/vpc-connection/{arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Arn: {
                location: "uri",
                locationName: "arn"
              }
            },
            required: [
              "Arn"
            ]
          },
          output: {
            type: "structure",
            members: {
              VpcConnectionArn: {
                locationName: "vpcConnectionArn"
              },
              TargetClusterArn: {
                locationName: "targetClusterArn"
              },
              State: {
                locationName: "state"
              },
              Authentication: {
                locationName: "authentication"
              },
              VpcId: {
                locationName: "vpcId"
              },
              Subnets: {
                shape: "S3",
                locationName: "subnets"
              },
              SecurityGroups: {
                shape: "S3",
                locationName: "securityGroups"
              },
              CreationTime: {
                shape: "S1u",
                locationName: "creationTime"
              },
              Tags: {
                shape: "S1e",
                locationName: "tags"
              }
            }
          }
        },
        BatchDisassociateScramSecret: {
          http: {
            method: "PATCH",
            requestUri: "/v1/clusters/{clusterArn}/scram-secrets",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              SecretArnList: {
                shape: "S3",
                locationName: "secretArnList"
              }
            },
            required: [
              "ClusterArn",
              "SecretArnList"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterArn: {
                locationName: "clusterArn"
              },
              UnprocessedScramSecrets: {
                shape: "S5",
                locationName: "unprocessedScramSecrets"
              }
            }
          }
        },
        GetBootstrapBrokers: {
          http: {
            method: "GET",
            requestUri: "/v1/clusters/{clusterArn}/bootstrap-brokers",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              }
            },
            required: [
              "ClusterArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              BootstrapBrokerString: {
                locationName: "bootstrapBrokerString"
              },
              BootstrapBrokerStringTls: {
                locationName: "bootstrapBrokerStringTls"
              },
              BootstrapBrokerStringSaslScram: {
                locationName: "bootstrapBrokerStringSaslScram"
              },
              BootstrapBrokerStringSaslIam: {
                locationName: "bootstrapBrokerStringSaslIam"
              },
              BootstrapBrokerStringPublicTls: {
                locationName: "bootstrapBrokerStringPublicTls"
              },
              BootstrapBrokerStringPublicSaslScram: {
                locationName: "bootstrapBrokerStringPublicSaslScram"
              },
              BootstrapBrokerStringPublicSaslIam: {
                locationName: "bootstrapBrokerStringPublicSaslIam"
              },
              BootstrapBrokerStringVpcConnectivityTls: {
                locationName: "bootstrapBrokerStringVpcConnectivityTls"
              },
              BootstrapBrokerStringVpcConnectivitySaslScram: {
                locationName: "bootstrapBrokerStringVpcConnectivitySaslScram"
              },
              BootstrapBrokerStringVpcConnectivitySaslIam: {
                locationName: "bootstrapBrokerStringVpcConnectivitySaslIam"
              }
            }
          }
        },
        GetCompatibleKafkaVersions: {
          http: {
            method: "GET",
            requestUri: "/v1/compatible-kafka-versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "querystring",
                locationName: "clusterArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CompatibleKafkaVersions: {
                locationName: "compatibleKafkaVersions",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SourceVersion: {
                      locationName: "sourceVersion"
                    },
                    TargetVersions: {
                      shape: "S3",
                      locationName: "targetVersions"
                    }
                  }
                }
              }
            }
          }
        },
        GetClusterPolicy: {
          http: {
            method: "GET",
            requestUri: "/v1/clusters/{clusterArn}/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              }
            },
            required: [
              "ClusterArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              CurrentVersion: {
                locationName: "currentVersion"
              },
              Policy: {
                locationName: "policy"
              }
            }
          }
        },
        ListClusterOperations: {
          http: {
            method: "GET",
            requestUri: "/v1/clusters/{clusterArn}/operations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "ClusterArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterOperationInfoList: {
                locationName: "clusterOperationInfoList",
                type: "list",
                member: {
                  shape: "S39"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListClusterOperationsV2: {
          http: {
            method: "GET",
            requestUri: "/api/v2/clusters/{clusterArn}/operations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "ClusterArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterOperationInfoList: {
                locationName: "clusterOperationInfoList",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ClusterArn: {
                      locationName: "clusterArn"
                    },
                    ClusterType: {
                      locationName: "clusterType"
                    },
                    StartTime: {
                      shape: "S1u",
                      locationName: "startTime"
                    },
                    EndTime: {
                      shape: "S1u",
                      locationName: "endTime"
                    },
                    OperationArn: {
                      locationName: "operationArn"
                    },
                    OperationState: {
                      locationName: "operationState"
                    },
                    OperationType: {
                      locationName: "operationType"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListClusters: {
          http: {
            method: "GET",
            requestUri: "/v1/clusters",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterNameFilter: {
                location: "querystring",
                locationName: "clusterNameFilter"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ClusterInfoList: {
                locationName: "clusterInfoList",
                type: "list",
                member: {
                  shape: "S2u"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListClustersV2: {
          http: {
            method: "GET",
            requestUri: "/api/v2/clusters",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterNameFilter: {
                location: "querystring",
                locationName: "clusterNameFilter"
              },
              ClusterTypeFilter: {
                location: "querystring",
                locationName: "clusterTypeFilter"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ClusterInfoList: {
                locationName: "clusterInfoList",
                type: "list",
                member: {
                  shape: "S34"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListConfigurationRevisions: {
          http: {
            method: "GET",
            requestUri: "/v1/configurations/{arn}/revisions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Arn: {
                location: "uri",
                locationName: "arn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "Arn"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Revisions: {
                locationName: "revisions",
                type: "list",
                member: {
                  shape: "S1v"
                }
              }
            }
          }
        },
        ListConfigurations: {
          http: {
            method: "GET",
            requestUri: "/v1/configurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Configurations: {
                locationName: "configurations",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {
                      locationName: "arn"
                    },
                    CreationTime: {
                      shape: "S1u",
                      locationName: "creationTime"
                    },
                    Description: {
                      locationName: "description"
                    },
                    KafkaVersions: {
                      shape: "S3",
                      locationName: "kafkaVersions"
                    },
                    LatestRevision: {
                      shape: "S1v",
                      locationName: "latestRevision"
                    },
                    Name: {
                      locationName: "name"
                    },
                    State: {
                      locationName: "state"
                    }
                  },
                  required: [
                    "Description",
                    "LatestRevision",
                    "CreationTime",
                    "KafkaVersions",
                    "Arn",
                    "Name",
                    "State"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListKafkaVersions: {
          http: {
            method: "GET",
            requestUri: "/v1/kafka-versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KafkaVersions: {
                locationName: "kafkaVersions",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Version: {
                      locationName: "version"
                    },
                    Status: {
                      locationName: "status"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListNodes: {
          http: {
            method: "GET",
            requestUri: "/v1/clusters/{clusterArn}/nodes",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "ClusterArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              NodeInfoList: {
                locationName: "nodeInfoList",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AddedToClusterTime: {
                      locationName: "addedToClusterTime"
                    },
                    BrokerNodeInfo: {
                      locationName: "brokerNodeInfo",
                      type: "structure",
                      members: {
                        AttachedENIId: {
                          locationName: "attachedENIId"
                        },
                        BrokerId: {
                          locationName: "brokerId",
                          type: "double"
                        },
                        ClientSubnet: {
                          locationName: "clientSubnet"
                        },
                        ClientVpcIpAddress: {
                          locationName: "clientVpcIpAddress"
                        },
                        CurrentBrokerSoftwareInfo: {
                          shape: "S2v",
                          locationName: "currentBrokerSoftwareInfo"
                        },
                        Endpoints: {
                          shape: "S3",
                          locationName: "endpoints"
                        }
                      }
                    },
                    InstanceType: {
                      locationName: "instanceType"
                    },
                    NodeARN: {
                      locationName: "nodeARN"
                    },
                    NodeType: {
                      locationName: "nodeType"
                    },
                    ZookeeperNodeInfo: {
                      locationName: "zookeeperNodeInfo",
                      type: "structure",
                      members: {
                        AttachedENIId: {
                          locationName: "attachedENIId"
                        },
                        ClientVpcIpAddress: {
                          locationName: "clientVpcIpAddress"
                        },
                        Endpoints: {
                          shape: "S3",
                          locationName: "endpoints"
                        },
                        ZookeeperId: {
                          locationName: "zookeeperId",
                          type: "double"
                        },
                        ZookeeperVersion: {
                          locationName: "zookeeperVersion"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        ListReplicators: {
          http: {
            method: "GET",
            requestUri: "/replication/v1/replicators",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              ReplicatorNameFilter: {
                location: "querystring",
                locationName: "replicatorNameFilter"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Replicators: {
                locationName: "replicators",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreationTime: {
                      shape: "S1u",
                      locationName: "creationTime"
                    },
                    CurrentVersion: {
                      locationName: "currentVersion"
                    },
                    IsReplicatorReference: {
                      locationName: "isReplicatorReference",
                      type: "boolean"
                    },
                    KafkaClustersSummary: {
                      locationName: "kafkaClustersSummary",
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          AmazonMskCluster: {
                            shape: "S21",
                            locationName: "amazonMskCluster"
                          },
                          KafkaClusterAlias: {
                            locationName: "kafkaClusterAlias"
                          }
                        }
                      }
                    },
                    ReplicationInfoSummaryList: {
                      locationName: "replicationInfoSummaryList",
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          SourceKafkaClusterAlias: {
                            locationName: "sourceKafkaClusterAlias"
                          },
                          TargetKafkaClusterAlias: {
                            locationName: "targetKafkaClusterAlias"
                          }
                        }
                      }
                    },
                    ReplicatorArn: {
                      locationName: "replicatorArn"
                    },
                    ReplicatorName: {
                      locationName: "replicatorName"
                    },
                    ReplicatorResourceArn: {
                      locationName: "replicatorResourceArn"
                    },
                    ReplicatorState: {
                      locationName: "replicatorState"
                    }
                  }
                }
              }
            }
          }
        },
        ListScramSecrets: {
          http: {
            method: "GET",
            requestUri: "/v1/clusters/{clusterArn}/scram-secrets",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "ClusterArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              SecretArnList: {
                shape: "S3",
                locationName: "secretArnList"
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/v1/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            },
            required: [
              "ResourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S1e",
                locationName: "tags"
              }
            }
          }
        },
        ListClientVpcConnections: {
          http: {
            method: "GET",
            requestUri: "/v1/clusters/{clusterArn}/client-vpc-connections",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "ClusterArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClientVpcConnections: {
                locationName: "clientVpcConnections",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Authentication: {
                      locationName: "authentication"
                    },
                    CreationTime: {
                      shape: "S1u",
                      locationName: "creationTime"
                    },
                    State: {
                      locationName: "state"
                    },
                    VpcConnectionArn: {
                      locationName: "vpcConnectionArn"
                    },
                    Owner: {
                      locationName: "owner"
                    }
                  },
                  required: [
                    "VpcConnectionArn"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListVpcConnections: {
          http: {
            method: "GET",
            requestUri: "/v1/vpc-connections",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpcConnections: {
                locationName: "vpcConnections",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    VpcConnectionArn: {
                      locationName: "vpcConnectionArn"
                    },
                    TargetClusterArn: {
                      locationName: "targetClusterArn"
                    },
                    CreationTime: {
                      shape: "S1u",
                      locationName: "creationTime"
                    },
                    Authentication: {
                      locationName: "authentication"
                    },
                    VpcId: {
                      locationName: "vpcId"
                    },
                    State: {
                      locationName: "state"
                    }
                  },
                  required: [
                    "VpcConnectionArn",
                    "TargetClusterArn"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        RejectClientVpcConnection: {
          http: {
            method: "PUT",
            requestUri: "/v1/clusters/{clusterArn}/client-vpc-connection",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              VpcConnectionArn: {
                locationName: "vpcConnectionArn"
              }
            },
            required: [
              "VpcConnectionArn",
              "ClusterArn"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutClusterPolicy: {
          http: {
            method: "PUT",
            requestUri: "/v1/clusters/{clusterArn}/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              CurrentVersion: {
                locationName: "currentVersion"
              },
              Policy: {
                locationName: "policy"
              }
            },
            required: [
              "ClusterArn",
              "Policy"
            ]
          },
          output: {
            type: "structure",
            members: {
              CurrentVersion: {
                locationName: "currentVersion"
              }
            }
          }
        },
        RebootBroker: {
          http: {
            method: "PUT",
            requestUri: "/v1/clusters/{clusterArn}/reboot-broker",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BrokerIds: {
                shape: "S3",
                locationName: "brokerIds"
              },
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              }
            },
            required: [
              "ClusterArn",
              "BrokerIds"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterArn: {
                locationName: "clusterArn"
              },
              ClusterOperationArn: {
                locationName: "clusterOperationArn"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/v1/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              Tags: {
                shape: "S1e",
                locationName: "tags"
              }
            },
            required: [
              "ResourceArn",
              "Tags"
            ]
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/v1/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              TagKeys: {
                shape: "S3",
                location: "querystring",
                locationName: "tagKeys"
              }
            },
            required: [
              "TagKeys",
              "ResourceArn"
            ]
          }
        },
        UpdateBrokerCount: {
          http: {
            method: "PUT",
            requestUri: "/v1/clusters/{clusterArn}/nodes/count",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              CurrentVersion: {
                locationName: "currentVersion"
              },
              TargetNumberOfBrokerNodes: {
                locationName: "targetNumberOfBrokerNodes",
                type: "integer"
              }
            },
            required: [
              "ClusterArn",
              "CurrentVersion",
              "TargetNumberOfBrokerNodes"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterArn: {
                locationName: "clusterArn"
              },
              ClusterOperationArn: {
                locationName: "clusterOperationArn"
              }
            }
          }
        },
        UpdateBrokerType: {
          http: {
            method: "PUT",
            requestUri: "/v1/clusters/{clusterArn}/nodes/type",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              CurrentVersion: {
                locationName: "currentVersion"
              },
              TargetInstanceType: {
                locationName: "targetInstanceType"
              }
            },
            required: [
              "ClusterArn",
              "CurrentVersion",
              "TargetInstanceType"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterArn: {
                locationName: "clusterArn"
              },
              ClusterOperationArn: {
                locationName: "clusterOperationArn"
              }
            }
          }
        },
        UpdateBrokerStorage: {
          http: {
            method: "PUT",
            requestUri: "/v1/clusters/{clusterArn}/nodes/storage",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              CurrentVersion: {
                locationName: "currentVersion"
              },
              TargetBrokerEBSVolumeInfo: {
                shape: "S3f",
                locationName: "targetBrokerEBSVolumeInfo"
              }
            },
            required: [
              "ClusterArn",
              "TargetBrokerEBSVolumeInfo",
              "CurrentVersion"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterArn: {
                locationName: "clusterArn"
              },
              ClusterOperationArn: {
                locationName: "clusterOperationArn"
              }
            }
          }
        },
        UpdateConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/v1/configurations/{arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Arn: {
                location: "uri",
                locationName: "arn"
              },
              Description: {
                locationName: "description"
              },
              ServerProperties: {
                locationName: "serverProperties",
                type: "blob"
              }
            },
            required: [
              "Arn",
              "ServerProperties"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              LatestRevision: {
                shape: "S1v",
                locationName: "latestRevision"
              }
            }
          }
        },
        UpdateConnectivity: {
          http: {
            method: "PUT",
            requestUri: "/v1/clusters/{clusterArn}/connectivity",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              ConnectivityInfo: {
                shape: "Sh",
                locationName: "connectivityInfo"
              },
              CurrentVersion: {
                locationName: "currentVersion"
              }
            },
            required: [
              "ClusterArn",
              "ConnectivityInfo",
              "CurrentVersion"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterArn: {
                locationName: "clusterArn"
              },
              ClusterOperationArn: {
                locationName: "clusterOperationArn"
              }
            }
          }
        },
        UpdateClusterConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/v1/clusters/{clusterArn}/configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              ConfigurationInfo: {
                shape: "Sw",
                locationName: "configurationInfo"
              },
              CurrentVersion: {
                locationName: "currentVersion"
              }
            },
            required: [
              "ClusterArn",
              "CurrentVersion",
              "ConfigurationInfo"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterArn: {
                locationName: "clusterArn"
              },
              ClusterOperationArn: {
                locationName: "clusterOperationArn"
              }
            }
          }
        },
        UpdateClusterKafkaVersion: {
          http: {
            method: "PUT",
            requestUri: "/v1/clusters/{clusterArn}/version",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              ConfigurationInfo: {
                shape: "Sw",
                locationName: "configurationInfo"
              },
              CurrentVersion: {
                locationName: "currentVersion"
              },
              TargetKafkaVersion: {
                locationName: "targetKafkaVersion"
              }
            },
            required: [
              "ClusterArn",
              "TargetKafkaVersion",
              "CurrentVersion"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterArn: {
                locationName: "clusterArn"
              },
              ClusterOperationArn: {
                locationName: "clusterOperationArn"
              }
            }
          }
        },
        UpdateMonitoring: {
          http: {
            method: "PUT",
            requestUri: "/v1/clusters/{clusterArn}/monitoring",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              CurrentVersion: {
                locationName: "currentVersion"
              },
              EnhancedMonitoring: {
                locationName: "enhancedMonitoring"
              },
              OpenMonitoring: {
                shape: "S13",
                locationName: "openMonitoring"
              },
              LoggingInfo: {
                shape: "S18",
                locationName: "loggingInfo"
              }
            },
            required: [
              "ClusterArn",
              "CurrentVersion"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterArn: {
                locationName: "clusterArn"
              },
              ClusterOperationArn: {
                locationName: "clusterOperationArn"
              }
            }
          }
        },
        UpdateReplicationInfo: {
          http: {
            method: "PUT",
            requestUri: "/replication/v1/replicators/{replicatorArn}/replication-info",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConsumerGroupReplication: {
                locationName: "consumerGroupReplication",
                type: "structure",
                members: {
                  ConsumerGroupsToExclude: {
                    shape: "S26",
                    locationName: "consumerGroupsToExclude"
                  },
                  ConsumerGroupsToReplicate: {
                    shape: "S26",
                    locationName: "consumerGroupsToReplicate"
                  },
                  DetectAndCopyNewConsumerGroups: {
                    locationName: "detectAndCopyNewConsumerGroups",
                    type: "boolean"
                  },
                  SynchroniseConsumerGroupOffsets: {
                    locationName: "synchroniseConsumerGroupOffsets",
                    type: "boolean"
                  }
                },
                required: [
                  "ConsumerGroupsToReplicate",
                  "ConsumerGroupsToExclude",
                  "SynchroniseConsumerGroupOffsets",
                  "DetectAndCopyNewConsumerGroups"
                ]
              },
              CurrentVersion: {
                locationName: "currentVersion"
              },
              ReplicatorArn: {
                location: "uri",
                locationName: "replicatorArn"
              },
              SourceKafkaClusterArn: {
                locationName: "sourceKafkaClusterArn"
              },
              TargetKafkaClusterArn: {
                locationName: "targetKafkaClusterArn"
              },
              TopicReplication: {
                locationName: "topicReplication",
                type: "structure",
                members: {
                  CopyAccessControlListsForTopics: {
                    locationName: "copyAccessControlListsForTopics",
                    type: "boolean"
                  },
                  CopyTopicConfigurations: {
                    locationName: "copyTopicConfigurations",
                    type: "boolean"
                  },
                  DetectAndCopyNewTopics: {
                    locationName: "detectAndCopyNewTopics",
                    type: "boolean"
                  },
                  TopicsToExclude: {
                    shape: "S2a",
                    locationName: "topicsToExclude"
                  },
                  TopicsToReplicate: {
                    shape: "S2a",
                    locationName: "topicsToReplicate"
                  }
                },
                required: [
                  "TopicsToReplicate",
                  "TopicsToExclude",
                  "CopyTopicConfigurations",
                  "DetectAndCopyNewTopics",
                  "CopyAccessControlListsForTopics"
                ]
              }
            },
            required: [
              "ReplicatorArn",
              "SourceKafkaClusterArn",
              "CurrentVersion",
              "TargetKafkaClusterArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              ReplicatorArn: {
                locationName: "replicatorArn"
              },
              ReplicatorState: {
                locationName: "replicatorState"
              }
            }
          }
        },
        UpdateSecurity: {
          http: {
            method: "PATCH",
            requestUri: "/v1/clusters/{clusterArn}/security",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClientAuthentication: {
                shape: "Sp",
                locationName: "clientAuthentication"
              },
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              CurrentVersion: {
                locationName: "currentVersion"
              },
              EncryptionInfo: {
                shape: "Sy",
                locationName: "encryptionInfo"
              }
            },
            required: [
              "ClusterArn",
              "CurrentVersion"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterArn: {
                locationName: "clusterArn"
              },
              ClusterOperationArn: {
                locationName: "clusterOperationArn"
              }
            }
          }
        },
        UpdateStorage: {
          http: {
            method: "PUT",
            requestUri: "/v1/clusters/{clusterArn}/storage",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              CurrentVersion: {
                locationName: "currentVersion"
              },
              ProvisionedThroughput: {
                shape: "Sd",
                locationName: "provisionedThroughput"
              },
              StorageMode: {
                locationName: "storageMode"
              },
              VolumeSizeGB: {
                locationName: "volumeSizeGB",
                type: "integer"
              }
            },
            required: [
              "ClusterArn",
              "CurrentVersion"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterArn: {
                locationName: "clusterArn"
              },
              ClusterOperationArn: {
                locationName: "clusterOperationArn"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {}
        },
        S5: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ErrorCode: {
                locationName: "errorCode"
              },
              ErrorMessage: {
                locationName: "errorMessage"
              },
              SecretArn: {
                locationName: "secretArn"
              }
            }
          }
        },
        S8: {
          type: "structure",
          members: {
            BrokerAZDistribution: {
              locationName: "brokerAZDistribution"
            },
            ClientSubnets: {
              shape: "S3",
              locationName: "clientSubnets"
            },
            InstanceType: {
              locationName: "instanceType"
            },
            SecurityGroups: {
              shape: "S3",
              locationName: "securityGroups"
            },
            StorageInfo: {
              locationName: "storageInfo",
              type: "structure",
              members: {
                EbsStorageInfo: {
                  locationName: "ebsStorageInfo",
                  type: "structure",
                  members: {
                    ProvisionedThroughput: {
                      shape: "Sd",
                      locationName: "provisionedThroughput"
                    },
                    VolumeSize: {
                      locationName: "volumeSize",
                      type: "integer"
                    }
                  }
                }
              }
            },
            ConnectivityInfo: {
              shape: "Sh",
              locationName: "connectivityInfo"
            },
            ZoneIds: {
              shape: "S3",
              locationName: "zoneIds"
            }
          },
          required: [
            "ClientSubnets",
            "InstanceType"
          ]
        },
        Sd: {
          type: "structure",
          members: {
            Enabled: {
              locationName: "enabled",
              type: "boolean"
            },
            VolumeThroughput: {
              locationName: "volumeThroughput",
              type: "integer"
            }
          }
        },
        Sh: {
          type: "structure",
          members: {
            PublicAccess: {
              locationName: "publicAccess",
              type: "structure",
              members: {
                Type: {
                  locationName: "type"
                }
              }
            },
            VpcConnectivity: {
              locationName: "vpcConnectivity",
              type: "structure",
              members: {
                ClientAuthentication: {
                  locationName: "clientAuthentication",
                  type: "structure",
                  members: {
                    Sasl: {
                      locationName: "sasl",
                      type: "structure",
                      members: {
                        Scram: {
                          locationName: "scram",
                          type: "structure",
                          members: {
                            Enabled: {
                              locationName: "enabled",
                              type: "boolean"
                            }
                          }
                        },
                        Iam: {
                          locationName: "iam",
                          type: "structure",
                          members: {
                            Enabled: {
                              locationName: "enabled",
                              type: "boolean"
                            }
                          }
                        }
                      }
                    },
                    Tls: {
                      locationName: "tls",
                      type: "structure",
                      members: {
                        Enabled: {
                          locationName: "enabled",
                          type: "boolean"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sp: {
          type: "structure",
          members: {
            Sasl: {
              locationName: "sasl",
              type: "structure",
              members: {
                Scram: {
                  locationName: "scram",
                  type: "structure",
                  members: {
                    Enabled: {
                      locationName: "enabled",
                      type: "boolean"
                    }
                  }
                },
                Iam: {
                  shape: "Ss",
                  locationName: "iam"
                }
              }
            },
            Tls: {
              locationName: "tls",
              type: "structure",
              members: {
                CertificateAuthorityArnList: {
                  shape: "S3",
                  locationName: "certificateAuthorityArnList"
                },
                Enabled: {
                  locationName: "enabled",
                  type: "boolean"
                }
              }
            },
            Unauthenticated: {
              locationName: "unauthenticated",
              type: "structure",
              members: {
                Enabled: {
                  locationName: "enabled",
                  type: "boolean"
                }
              }
            }
          }
        },
        Ss: {
          type: "structure",
          members: {
            Enabled: {
              locationName: "enabled",
              type: "boolean"
            }
          }
        },
        Sw: {
          type: "structure",
          members: {
            Arn: {
              locationName: "arn"
            },
            Revision: {
              locationName: "revision",
              type: "long"
            }
          },
          required: [
            "Revision",
            "Arn"
          ]
        },
        Sy: {
          type: "structure",
          members: {
            EncryptionAtRest: {
              locationName: "encryptionAtRest",
              type: "structure",
              members: {
                DataVolumeKMSKeyId: {
                  locationName: "dataVolumeKMSKeyId"
                }
              },
              required: [
                "DataVolumeKMSKeyId"
              ]
            },
            EncryptionInTransit: {
              locationName: "encryptionInTransit",
              type: "structure",
              members: {
                ClientBroker: {
                  locationName: "clientBroker"
                },
                InCluster: {
                  locationName: "inCluster",
                  type: "boolean"
                }
              }
            }
          }
        },
        S13: {
          type: "structure",
          members: {
            Prometheus: {
              locationName: "prometheus",
              type: "structure",
              members: {
                JmxExporter: {
                  locationName: "jmxExporter",
                  type: "structure",
                  members: {
                    EnabledInBroker: {
                      locationName: "enabledInBroker",
                      type: "boolean"
                    }
                  },
                  required: [
                    "EnabledInBroker"
                  ]
                },
                NodeExporter: {
                  locationName: "nodeExporter",
                  type: "structure",
                  members: {
                    EnabledInBroker: {
                      locationName: "enabledInBroker",
                      type: "boolean"
                    }
                  },
                  required: [
                    "EnabledInBroker"
                  ]
                }
              }
            }
          },
          required: [
            "Prometheus"
          ]
        },
        S18: {
          type: "structure",
          members: {
            BrokerLogs: {
              locationName: "brokerLogs",
              type: "structure",
              members: {
                CloudWatchLogs: {
                  locationName: "cloudWatchLogs",
                  type: "structure",
                  members: {
                    Enabled: {
                      locationName: "enabled",
                      type: "boolean"
                    },
                    LogGroup: {
                      locationName: "logGroup"
                    }
                  },
                  required: [
                    "Enabled"
                  ]
                },
                Firehose: {
                  locationName: "firehose",
                  type: "structure",
                  members: {
                    DeliveryStream: {
                      locationName: "deliveryStream"
                    },
                    Enabled: {
                      locationName: "enabled",
                      type: "boolean"
                    }
                  },
                  required: [
                    "Enabled"
                  ]
                },
                S3: {
                  locationName: "s3",
                  type: "structure",
                  members: {
                    Bucket: {
                      locationName: "bucket"
                    },
                    Enabled: {
                      locationName: "enabled",
                      type: "boolean"
                    },
                    Prefix: {
                      locationName: "prefix"
                    }
                  },
                  required: [
                    "Enabled"
                  ]
                }
              }
            }
          },
          required: [
            "BrokerLogs"
          ]
        },
        S1e: {
          type: "map",
          key: {},
          value: {}
        },
        S1l: {
          type: "list",
          member: {
            type: "structure",
            members: {
              SubnetIds: {
                shape: "S3",
                locationName: "subnetIds"
              },
              SecurityGroupIds: {
                shape: "S3",
                locationName: "securityGroupIds"
              }
            },
            required: [
              "SubnetIds"
            ]
          }
        },
        S1n: {
          type: "structure",
          members: {
            Sasl: {
              locationName: "sasl",
              type: "structure",
              members: {
                Iam: {
                  shape: "Ss",
                  locationName: "iam"
                }
              }
            }
          }
        },
        S1u: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S1v: {
          type: "structure",
          members: {
            CreationTime: {
              shape: "S1u",
              locationName: "creationTime"
            },
            Description: {
              locationName: "description"
            },
            Revision: {
              locationName: "revision",
              type: "long"
            }
          },
          required: [
            "Revision",
            "CreationTime"
          ]
        },
        S21: {
          type: "structure",
          members: {
            MskClusterArn: {
              locationName: "mskClusterArn"
            }
          },
          required: [
            "MskClusterArn"
          ]
        },
        S22: {
          type: "structure",
          members: {
            SecurityGroupIds: {
              shape: "S3",
              locationName: "securityGroupIds"
            },
            SubnetIds: {
              shape: "S3",
              locationName: "subnetIds"
            }
          },
          required: [
            "SubnetIds"
          ]
        },
        S25: {
          type: "structure",
          members: {
            ConsumerGroupsToExclude: {
              shape: "S26",
              locationName: "consumerGroupsToExclude"
            },
            ConsumerGroupsToReplicate: {
              shape: "S26",
              locationName: "consumerGroupsToReplicate"
            },
            DetectAndCopyNewConsumerGroups: {
              locationName: "detectAndCopyNewConsumerGroups",
              type: "boolean"
            },
            SynchroniseConsumerGroupOffsets: {
              locationName: "synchroniseConsumerGroupOffsets",
              type: "boolean"
            }
          },
          required: [
            "ConsumerGroupsToReplicate"
          ]
        },
        S26: {
          type: "list",
          member: {}
        },
        S29: {
          type: "structure",
          members: {
            CopyAccessControlListsForTopics: {
              locationName: "copyAccessControlListsForTopics",
              type: "boolean"
            },
            CopyTopicConfigurations: {
              locationName: "copyTopicConfigurations",
              type: "boolean"
            },
            DetectAndCopyNewTopics: {
              locationName: "detectAndCopyNewTopics",
              type: "boolean"
            },
            TopicsToExclude: {
              shape: "S2a",
              locationName: "topicsToExclude"
            },
            TopicsToReplicate: {
              shape: "S2a",
              locationName: "topicsToReplicate"
            }
          },
          required: [
            "TopicsToReplicate"
          ]
        },
        S2a: {
          type: "list",
          member: {}
        },
        S2u: {
          type: "structure",
          members: {
            ActiveOperationArn: {
              locationName: "activeOperationArn"
            },
            BrokerNodeGroupInfo: {
              shape: "S8",
              locationName: "brokerNodeGroupInfo"
            },
            ClientAuthentication: {
              shape: "Sp",
              locationName: "clientAuthentication"
            },
            ClusterArn: {
              locationName: "clusterArn"
            },
            ClusterName: {
              locationName: "clusterName"
            },
            CreationTime: {
              shape: "S1u",
              locationName: "creationTime"
            },
            CurrentBrokerSoftwareInfo: {
              shape: "S2v",
              locationName: "currentBrokerSoftwareInfo"
            },
            CurrentVersion: {
              locationName: "currentVersion"
            },
            EncryptionInfo: {
              shape: "Sy",
              locationName: "encryptionInfo"
            },
            EnhancedMonitoring: {
              locationName: "enhancedMonitoring"
            },
            OpenMonitoring: {
              shape: "S2w",
              locationName: "openMonitoring"
            },
            LoggingInfo: {
              shape: "S18",
              locationName: "loggingInfo"
            },
            NumberOfBrokerNodes: {
              locationName: "numberOfBrokerNodes",
              type: "integer"
            },
            State: {
              locationName: "state"
            },
            StateInfo: {
              shape: "S30",
              locationName: "stateInfo"
            },
            Tags: {
              shape: "S1e",
              locationName: "tags"
            },
            ZookeeperConnectString: {
              locationName: "zookeeperConnectString"
            },
            ZookeeperConnectStringTls: {
              locationName: "zookeeperConnectStringTls"
            },
            StorageMode: {
              locationName: "storageMode"
            },
            CustomerActionStatus: {
              locationName: "customerActionStatus"
            }
          }
        },
        S2v: {
          type: "structure",
          members: {
            ConfigurationArn: {
              locationName: "configurationArn"
            },
            ConfigurationRevision: {
              locationName: "configurationRevision",
              type: "long"
            },
            KafkaVersion: {
              locationName: "kafkaVersion"
            }
          }
        },
        S2w: {
          type: "structure",
          members: {
            Prometheus: {
              locationName: "prometheus",
              type: "structure",
              members: {
                JmxExporter: {
                  locationName: "jmxExporter",
                  type: "structure",
                  members: {
                    EnabledInBroker: {
                      locationName: "enabledInBroker",
                      type: "boolean"
                    }
                  },
                  required: [
                    "EnabledInBroker"
                  ]
                },
                NodeExporter: {
                  locationName: "nodeExporter",
                  type: "structure",
                  members: {
                    EnabledInBroker: {
                      locationName: "enabledInBroker",
                      type: "boolean"
                    }
                  },
                  required: [
                    "EnabledInBroker"
                  ]
                }
              }
            }
          },
          required: [
            "Prometheus"
          ]
        },
        S30: {
          type: "structure",
          members: {
            Code: {
              locationName: "code"
            },
            Message: {
              locationName: "message"
            }
          }
        },
        S34: {
          type: "structure",
          members: {
            ActiveOperationArn: {
              locationName: "activeOperationArn"
            },
            ClusterType: {
              locationName: "clusterType"
            },
            ClusterArn: {
              locationName: "clusterArn"
            },
            ClusterName: {
              locationName: "clusterName"
            },
            CreationTime: {
              shape: "S1u",
              locationName: "creationTime"
            },
            CurrentVersion: {
              locationName: "currentVersion"
            },
            State: {
              locationName: "state"
            },
            StateInfo: {
              shape: "S30",
              locationName: "stateInfo"
            },
            Tags: {
              shape: "S1e",
              locationName: "tags"
            },
            Provisioned: {
              locationName: "provisioned",
              type: "structure",
              members: {
                BrokerNodeGroupInfo: {
                  shape: "S8",
                  locationName: "brokerNodeGroupInfo"
                },
                CurrentBrokerSoftwareInfo: {
                  shape: "S2v",
                  locationName: "currentBrokerSoftwareInfo"
                },
                ClientAuthentication: {
                  shape: "Sp",
                  locationName: "clientAuthentication"
                },
                EncryptionInfo: {
                  shape: "Sy",
                  locationName: "encryptionInfo"
                },
                EnhancedMonitoring: {
                  locationName: "enhancedMonitoring"
                },
                OpenMonitoring: {
                  shape: "S13",
                  locationName: "openMonitoring"
                },
                LoggingInfo: {
                  shape: "S18",
                  locationName: "loggingInfo"
                },
                NumberOfBrokerNodes: {
                  locationName: "numberOfBrokerNodes",
                  type: "integer"
                },
                ZookeeperConnectString: {
                  locationName: "zookeeperConnectString"
                },
                ZookeeperConnectStringTls: {
                  locationName: "zookeeperConnectStringTls"
                },
                StorageMode: {
                  locationName: "storageMode"
                },
                CustomerActionStatus: {
                  locationName: "customerActionStatus"
                }
              },
              required: [
                "BrokerNodeGroupInfo",
                "NumberOfBrokerNodes"
              ]
            },
            Serverless: {
              locationName: "serverless",
              type: "structure",
              members: {
                VpcConfigs: {
                  shape: "S1l",
                  locationName: "vpcConfigs"
                },
                ClientAuthentication: {
                  shape: "S1n",
                  locationName: "clientAuthentication"
                }
              },
              required: [
                "VpcConfigs"
              ]
            }
          }
        },
        S39: {
          type: "structure",
          members: {
            ClientRequestId: {
              locationName: "clientRequestId"
            },
            ClusterArn: {
              locationName: "clusterArn"
            },
            CreationTime: {
              shape: "S1u",
              locationName: "creationTime"
            },
            EndTime: {
              shape: "S1u",
              locationName: "endTime"
            },
            ErrorInfo: {
              shape: "S3a",
              locationName: "errorInfo"
            },
            OperationArn: {
              locationName: "operationArn"
            },
            OperationState: {
              locationName: "operationState"
            },
            OperationSteps: {
              shape: "S3b",
              locationName: "operationSteps"
            },
            OperationType: {
              locationName: "operationType"
            },
            SourceClusterInfo: {
              shape: "S3e",
              locationName: "sourceClusterInfo"
            },
            TargetClusterInfo: {
              shape: "S3e",
              locationName: "targetClusterInfo"
            },
            VpcConnectionInfo: {
              shape: "S3h",
              locationName: "vpcConnectionInfo"
            }
          }
        },
        S3a: {
          type: "structure",
          members: {
            ErrorCode: {
              locationName: "errorCode"
            },
            ErrorString: {
              locationName: "errorString"
            }
          }
        },
        S3b: {
          type: "list",
          member: {
            type: "structure",
            members: {
              StepInfo: {
                locationName: "stepInfo",
                type: "structure",
                members: {
                  StepStatus: {
                    locationName: "stepStatus"
                  }
                }
              },
              StepName: {
                locationName: "stepName"
              }
            }
          }
        },
        S3e: {
          type: "structure",
          members: {
            BrokerEBSVolumeInfo: {
              shape: "S3f",
              locationName: "brokerEBSVolumeInfo"
            },
            ConfigurationInfo: {
              shape: "Sw",
              locationName: "configurationInfo"
            },
            NumberOfBrokerNodes: {
              locationName: "numberOfBrokerNodes",
              type: "integer"
            },
            EnhancedMonitoring: {
              locationName: "enhancedMonitoring"
            },
            OpenMonitoring: {
              shape: "S2w",
              locationName: "openMonitoring"
            },
            KafkaVersion: {
              locationName: "kafkaVersion"
            },
            LoggingInfo: {
              shape: "S18",
              locationName: "loggingInfo"
            },
            InstanceType: {
              locationName: "instanceType"
            },
            ClientAuthentication: {
              shape: "Sp",
              locationName: "clientAuthentication"
            },
            EncryptionInfo: {
              shape: "Sy",
              locationName: "encryptionInfo"
            },
            ConnectivityInfo: {
              shape: "Sh",
              locationName: "connectivityInfo"
            },
            StorageMode: {
              locationName: "storageMode"
            }
          }
        },
        S3f: {
          type: "list",
          member: {
            type: "structure",
            members: {
              KafkaBrokerNodeId: {
                locationName: "kafkaBrokerNodeId"
              },
              ProvisionedThroughput: {
                shape: "Sd",
                locationName: "provisionedThroughput"
              },
              VolumeSizeGB: {
                locationName: "volumeSizeGB",
                type: "integer"
              }
            },
            required: [
              "KafkaBrokerNodeId"
            ]
          }
        },
        S3h: {
          type: "structure",
          members: {
            VpcConnectionArn: {
              locationName: "vpcConnectionArn"
            },
            Owner: {
              locationName: "owner"
            },
            UserIdentity: {
              shape: "S3i",
              locationName: "userIdentity"
            },
            CreationTime: {
              shape: "S1u",
              locationName: "creationTime"
            }
          }
        },
        S3i: {
          type: "structure",
          members: {
            Type: {
              locationName: "type"
            },
            PrincipalId: {
              locationName: "principalId"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/kafka-2018-11-14.paginators.json
var require_kafka_2018_11_14_paginators = __commonJS({
  "node_modules/aws-sdk/apis/kafka-2018-11-14.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListClusters: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ClusterInfoList"
        },
        ListClustersV2: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ClusterInfoList"
        },
        ListConfigurations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Configurations"
        },
        ListKafkaVersions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "KafkaVersions"
        },
        ListNodes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "NodeInfoList"
        },
        ListClusterOperations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ClusterOperationInfoList"
        },
        ListClusterOperationsV2: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ClusterOperationInfoList"
        },
        ListConfigurationRevisions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Revisions"
        },
        ListReplicators: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Replicators"
        },
        ListScramSecrets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "SecretArnList"
        },
        ListVpcConnections: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "VpcConnections"
        },
        ListClientVpcConnections: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ClientVpcConnections"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/kafka.js
var require_kafka = __commonJS({
  "node_modules/aws-sdk/clients/kafka.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["kafka"] = {};
    AWS2.Kafka = Service.defineService("kafka", ["2018-11-14"]);
    Object.defineProperty(apiLoader.services["kafka"], "2018-11-14", {
      get: function get() {
        var model = require_kafka_2018_11_14_min();
        model.paginators = require_kafka_2018_11_14_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Kafka;
  }
});

// node_modules/aws-sdk/apis/apigatewaymanagementapi-2018-11-29.min.json
var require_apigatewaymanagementapi_2018_11_29_min = __commonJS({
  "node_modules/aws-sdk/apis/apigatewaymanagementapi-2018-11-29.min.json"(exports2, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2018-11-29",
        endpointPrefix: "execute-api",
        signingName: "execute-api",
        serviceFullName: "AmazonApiGatewayManagementApi",
        serviceId: "ApiGatewayManagementApi",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "apigatewaymanagementapi-2018-11-29",
        signatureVersion: "v4"
      },
      operations: {
        DeleteConnection: {
          http: {
            method: "DELETE",
            requestUri: "/@connections/{connectionId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ConnectionId: {
                location: "uri",
                locationName: "connectionId"
              }
            },
            required: [
              "ConnectionId"
            ]
          }
        },
        GetConnection: {
          http: {
            method: "GET",
            requestUri: "/@connections/{connectionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConnectionId: {
                location: "uri",
                locationName: "connectionId"
              }
            },
            required: [
              "ConnectionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ConnectedAt: {
                shape: "S5",
                locationName: "connectedAt"
              },
              Identity: {
                locationName: "identity",
                type: "structure",
                members: {
                  SourceIp: {
                    locationName: "sourceIp"
                  },
                  UserAgent: {
                    locationName: "userAgent"
                  }
                },
                required: [
                  "SourceIp",
                  "UserAgent"
                ]
              },
              LastActiveAt: {
                shape: "S5",
                locationName: "lastActiveAt"
              }
            }
          }
        },
        PostToConnection: {
          http: {
            requestUri: "/@connections/{connectionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Data: {
                type: "blob"
              },
              ConnectionId: {
                location: "uri",
                locationName: "connectionId"
              }
            },
            required: [
              "ConnectionId",
              "Data"
            ],
            payload: "Data"
          }
        }
      },
      shapes: {
        S5: {
          type: "timestamp",
          timestampFormat: "iso8601"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/apigatewaymanagementapi-2018-11-29.paginators.json
var require_apigatewaymanagementapi_2018_11_29_paginators = __commonJS({
  "node_modules/aws-sdk/apis/apigatewaymanagementapi-2018-11-29.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/apigatewaymanagementapi.js
var require_apigatewaymanagementapi = __commonJS({
  "node_modules/aws-sdk/clients/apigatewaymanagementapi.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["apigatewaymanagementapi"] = {};
    AWS2.ApiGatewayManagementApi = Service.defineService("apigatewaymanagementapi", ["2018-11-29"]);
    Object.defineProperty(apiLoader.services["apigatewaymanagementapi"], "2018-11-29", {
      get: function get() {
        var model = require_apigatewaymanagementapi_2018_11_29_min();
        model.paginators = require_apigatewaymanagementapi_2018_11_29_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ApiGatewayManagementApi;
  }
});

// node_modules/aws-sdk/apis/apigatewayv2-2018-11-29.min.json
var require_apigatewayv2_2018_11_29_min = __commonJS({
  "node_modules/aws-sdk/apis/apigatewayv2-2018-11-29.min.json"(exports2, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2018-11-29",
        endpointPrefix: "apigateway",
        signingName: "apigateway",
        serviceFullName: "AmazonApiGatewayV2",
        serviceId: "ApiGatewayV2",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "apigatewayv2-2018-11-29",
        signatureVersion: "v4"
      },
      operations: {
        CreateApi: {
          http: {
            requestUri: "/v2/apis",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApiKeySelectionExpression: {
                locationName: "apiKeySelectionExpression"
              },
              CorsConfiguration: {
                shape: "S3",
                locationName: "corsConfiguration"
              },
              CredentialsArn: {
                locationName: "credentialsArn"
              },
              Description: {
                locationName: "description"
              },
              DisableSchemaValidation: {
                locationName: "disableSchemaValidation",
                type: "boolean"
              },
              DisableExecuteApiEndpoint: {
                locationName: "disableExecuteApiEndpoint",
                type: "boolean"
              },
              Name: {
                locationName: "name"
              },
              ProtocolType: {
                locationName: "protocolType"
              },
              RouteKey: {
                locationName: "routeKey"
              },
              RouteSelectionExpression: {
                locationName: "routeSelectionExpression"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              },
              Target: {
                locationName: "target"
              },
              Version: {
                locationName: "version"
              }
            },
            required: [
              "ProtocolType",
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiEndpoint: {
                locationName: "apiEndpoint"
              },
              ApiGatewayManaged: {
                locationName: "apiGatewayManaged",
                type: "boolean"
              },
              ApiId: {
                locationName: "apiId"
              },
              ApiKeySelectionExpression: {
                locationName: "apiKeySelectionExpression"
              },
              CorsConfiguration: {
                shape: "S3",
                locationName: "corsConfiguration"
              },
              CreatedDate: {
                shape: "Sl",
                locationName: "createdDate"
              },
              Description: {
                locationName: "description"
              },
              DisableSchemaValidation: {
                locationName: "disableSchemaValidation",
                type: "boolean"
              },
              DisableExecuteApiEndpoint: {
                locationName: "disableExecuteApiEndpoint",
                type: "boolean"
              },
              ImportInfo: {
                shape: "Sm",
                locationName: "importInfo"
              },
              Name: {
                locationName: "name"
              },
              ProtocolType: {
                locationName: "protocolType"
              },
              RouteSelectionExpression: {
                locationName: "routeSelectionExpression"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              },
              Version: {
                locationName: "version"
              },
              Warnings: {
                shape: "Sm",
                locationName: "warnings"
              }
            }
          }
        },
        CreateApiMapping: {
          http: {
            requestUri: "/v2/domainnames/{domainName}/apimappings",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                locationName: "apiId"
              },
              ApiMappingKey: {
                locationName: "apiMappingKey"
              },
              DomainName: {
                location: "uri",
                locationName: "domainName"
              },
              Stage: {
                locationName: "stage"
              }
            },
            required: [
              "DomainName",
              "Stage",
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiId: {
                locationName: "apiId"
              },
              ApiMappingId: {
                locationName: "apiMappingId"
              },
              ApiMappingKey: {
                locationName: "apiMappingKey"
              },
              Stage: {
                locationName: "stage"
              }
            }
          }
        },
        CreateAuthorizer: {
          http: {
            requestUri: "/v2/apis/{apiId}/authorizers",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              AuthorizerCredentialsArn: {
                locationName: "authorizerCredentialsArn"
              },
              AuthorizerPayloadFormatVersion: {
                locationName: "authorizerPayloadFormatVersion"
              },
              AuthorizerResultTtlInSeconds: {
                locationName: "authorizerResultTtlInSeconds",
                type: "integer"
              },
              AuthorizerType: {
                locationName: "authorizerType"
              },
              AuthorizerUri: {
                locationName: "authorizerUri"
              },
              EnableSimpleResponses: {
                locationName: "enableSimpleResponses",
                type: "boolean"
              },
              IdentitySource: {
                shape: "Ss",
                locationName: "identitySource"
              },
              IdentityValidationExpression: {
                locationName: "identityValidationExpression"
              },
              JwtConfiguration: {
                shape: "St",
                locationName: "jwtConfiguration"
              },
              Name: {
                locationName: "name"
              }
            },
            required: [
              "ApiId",
              "AuthorizerType",
              "IdentitySource",
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              AuthorizerCredentialsArn: {
                locationName: "authorizerCredentialsArn"
              },
              AuthorizerId: {
                locationName: "authorizerId"
              },
              AuthorizerPayloadFormatVersion: {
                locationName: "authorizerPayloadFormatVersion"
              },
              AuthorizerResultTtlInSeconds: {
                locationName: "authorizerResultTtlInSeconds",
                type: "integer"
              },
              AuthorizerType: {
                locationName: "authorizerType"
              },
              AuthorizerUri: {
                locationName: "authorizerUri"
              },
              EnableSimpleResponses: {
                locationName: "enableSimpleResponses",
                type: "boolean"
              },
              IdentitySource: {
                shape: "Ss",
                locationName: "identitySource"
              },
              IdentityValidationExpression: {
                locationName: "identityValidationExpression"
              },
              JwtConfiguration: {
                shape: "St",
                locationName: "jwtConfiguration"
              },
              Name: {
                locationName: "name"
              }
            }
          }
        },
        CreateDeployment: {
          http: {
            requestUri: "/v2/apis/{apiId}/deployments",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              Description: {
                locationName: "description"
              },
              StageName: {
                locationName: "stageName"
              }
            },
            required: [
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AutoDeployed: {
                locationName: "autoDeployed",
                type: "boolean"
              },
              CreatedDate: {
                shape: "Sl",
                locationName: "createdDate"
              },
              DeploymentId: {
                locationName: "deploymentId"
              },
              DeploymentStatus: {
                locationName: "deploymentStatus"
              },
              DeploymentStatusMessage: {
                locationName: "deploymentStatusMessage"
              },
              Description: {
                locationName: "description"
              }
            }
          }
        },
        CreateDomainName: {
          http: {
            requestUri: "/v2/domainnames",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              DomainName: {
                locationName: "domainName"
              },
              DomainNameConfigurations: {
                shape: "S10",
                locationName: "domainNameConfigurations"
              },
              MutualTlsAuthentication: {
                shape: "S15",
                locationName: "mutualTlsAuthentication"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              }
            },
            required: [
              "DomainName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiMappingSelectionExpression: {
                locationName: "apiMappingSelectionExpression"
              },
              DomainName: {
                locationName: "domainName"
              },
              DomainNameConfigurations: {
                shape: "S10",
                locationName: "domainNameConfigurations"
              },
              MutualTlsAuthentication: {
                shape: "S17",
                locationName: "mutualTlsAuthentication"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              }
            }
          }
        },
        CreateIntegration: {
          http: {
            requestUri: "/v2/apis/{apiId}/integrations",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              ConnectionId: {
                locationName: "connectionId"
              },
              ConnectionType: {
                locationName: "connectionType"
              },
              ContentHandlingStrategy: {
                locationName: "contentHandlingStrategy"
              },
              CredentialsArn: {
                locationName: "credentialsArn"
              },
              Description: {
                locationName: "description"
              },
              IntegrationMethod: {
                locationName: "integrationMethod"
              },
              IntegrationSubtype: {
                locationName: "integrationSubtype"
              },
              IntegrationType: {
                locationName: "integrationType"
              },
              IntegrationUri: {
                locationName: "integrationUri"
              },
              PassthroughBehavior: {
                locationName: "passthroughBehavior"
              },
              PayloadFormatVersion: {
                locationName: "payloadFormatVersion"
              },
              RequestParameters: {
                shape: "S1e",
                locationName: "requestParameters"
              },
              RequestTemplates: {
                shape: "S1f",
                locationName: "requestTemplates"
              },
              ResponseParameters: {
                shape: "S1h",
                locationName: "responseParameters"
              },
              TemplateSelectionExpression: {
                locationName: "templateSelectionExpression"
              },
              TimeoutInMillis: {
                locationName: "timeoutInMillis",
                type: "integer"
              },
              TlsConfig: {
                shape: "S1j",
                locationName: "tlsConfig"
              }
            },
            required: [
              "ApiId",
              "IntegrationType"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiGatewayManaged: {
                locationName: "apiGatewayManaged",
                type: "boolean"
              },
              ConnectionId: {
                locationName: "connectionId"
              },
              ConnectionType: {
                locationName: "connectionType"
              },
              ContentHandlingStrategy: {
                locationName: "contentHandlingStrategy"
              },
              CredentialsArn: {
                locationName: "credentialsArn"
              },
              Description: {
                locationName: "description"
              },
              IntegrationId: {
                locationName: "integrationId"
              },
              IntegrationMethod: {
                locationName: "integrationMethod"
              },
              IntegrationResponseSelectionExpression: {
                locationName: "integrationResponseSelectionExpression"
              },
              IntegrationSubtype: {
                locationName: "integrationSubtype"
              },
              IntegrationType: {
                locationName: "integrationType"
              },
              IntegrationUri: {
                locationName: "integrationUri"
              },
              PassthroughBehavior: {
                locationName: "passthroughBehavior"
              },
              PayloadFormatVersion: {
                locationName: "payloadFormatVersion"
              },
              RequestParameters: {
                shape: "S1e",
                locationName: "requestParameters"
              },
              RequestTemplates: {
                shape: "S1f",
                locationName: "requestTemplates"
              },
              ResponseParameters: {
                shape: "S1h",
                locationName: "responseParameters"
              },
              TemplateSelectionExpression: {
                locationName: "templateSelectionExpression"
              },
              TimeoutInMillis: {
                locationName: "timeoutInMillis",
                type: "integer"
              },
              TlsConfig: {
                shape: "S1l",
                locationName: "tlsConfig"
              }
            }
          }
        },
        CreateIntegrationResponse: {
          http: {
            requestUri: "/v2/apis/{apiId}/integrations/{integrationId}/integrationresponses",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              ContentHandlingStrategy: {
                locationName: "contentHandlingStrategy"
              },
              IntegrationId: {
                location: "uri",
                locationName: "integrationId"
              },
              IntegrationResponseKey: {
                locationName: "integrationResponseKey"
              },
              ResponseParameters: {
                shape: "S1e",
                locationName: "responseParameters"
              },
              ResponseTemplates: {
                shape: "S1f",
                locationName: "responseTemplates"
              },
              TemplateSelectionExpression: {
                locationName: "templateSelectionExpression"
              }
            },
            required: [
              "ApiId",
              "IntegrationId",
              "IntegrationResponseKey"
            ]
          },
          output: {
            type: "structure",
            members: {
              ContentHandlingStrategy: {
                locationName: "contentHandlingStrategy"
              },
              IntegrationResponseId: {
                locationName: "integrationResponseId"
              },
              IntegrationResponseKey: {
                locationName: "integrationResponseKey"
              },
              ResponseParameters: {
                shape: "S1e",
                locationName: "responseParameters"
              },
              ResponseTemplates: {
                shape: "S1f",
                locationName: "responseTemplates"
              },
              TemplateSelectionExpression: {
                locationName: "templateSelectionExpression"
              }
            }
          }
        },
        CreateModel: {
          http: {
            requestUri: "/v2/apis/{apiId}/models",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              ContentType: {
                locationName: "contentType"
              },
              Description: {
                locationName: "description"
              },
              Name: {
                locationName: "name"
              },
              Schema: {
                locationName: "schema"
              }
            },
            required: [
              "ApiId",
              "Schema",
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              ContentType: {
                locationName: "contentType"
              },
              Description: {
                locationName: "description"
              },
              ModelId: {
                locationName: "modelId"
              },
              Name: {
                locationName: "name"
              },
              Schema: {
                locationName: "schema"
              }
            }
          }
        },
        CreateRoute: {
          http: {
            requestUri: "/v2/apis/{apiId}/routes",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              ApiKeyRequired: {
                locationName: "apiKeyRequired",
                type: "boolean"
              },
              AuthorizationScopes: {
                shape: "S1s",
                locationName: "authorizationScopes"
              },
              AuthorizationType: {
                locationName: "authorizationType"
              },
              AuthorizerId: {
                locationName: "authorizerId"
              },
              ModelSelectionExpression: {
                locationName: "modelSelectionExpression"
              },
              OperationName: {
                locationName: "operationName"
              },
              RequestModels: {
                shape: "S1u",
                locationName: "requestModels"
              },
              RequestParameters: {
                shape: "S1v",
                locationName: "requestParameters"
              },
              RouteKey: {
                locationName: "routeKey"
              },
              RouteResponseSelectionExpression: {
                locationName: "routeResponseSelectionExpression"
              },
              Target: {
                locationName: "target"
              }
            },
            required: [
              "ApiId",
              "RouteKey"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiGatewayManaged: {
                locationName: "apiGatewayManaged",
                type: "boolean"
              },
              ApiKeyRequired: {
                locationName: "apiKeyRequired",
                type: "boolean"
              },
              AuthorizationScopes: {
                shape: "S1s",
                locationName: "authorizationScopes"
              },
              AuthorizationType: {
                locationName: "authorizationType"
              },
              AuthorizerId: {
                locationName: "authorizerId"
              },
              ModelSelectionExpression: {
                locationName: "modelSelectionExpression"
              },
              OperationName: {
                locationName: "operationName"
              },
              RequestModels: {
                shape: "S1u",
                locationName: "requestModels"
              },
              RequestParameters: {
                shape: "S1v",
                locationName: "requestParameters"
              },
              RouteId: {
                locationName: "routeId"
              },
              RouteKey: {
                locationName: "routeKey"
              },
              RouteResponseSelectionExpression: {
                locationName: "routeResponseSelectionExpression"
              },
              Target: {
                locationName: "target"
              }
            }
          }
        },
        CreateRouteResponse: {
          http: {
            requestUri: "/v2/apis/{apiId}/routes/{routeId}/routeresponses",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              ModelSelectionExpression: {
                locationName: "modelSelectionExpression"
              },
              ResponseModels: {
                shape: "S1u",
                locationName: "responseModels"
              },
              ResponseParameters: {
                shape: "S1v",
                locationName: "responseParameters"
              },
              RouteId: {
                location: "uri",
                locationName: "routeId"
              },
              RouteResponseKey: {
                locationName: "routeResponseKey"
              }
            },
            required: [
              "ApiId",
              "RouteId",
              "RouteResponseKey"
            ]
          },
          output: {
            type: "structure",
            members: {
              ModelSelectionExpression: {
                locationName: "modelSelectionExpression"
              },
              ResponseModels: {
                shape: "S1u",
                locationName: "responseModels"
              },
              ResponseParameters: {
                shape: "S1v",
                locationName: "responseParameters"
              },
              RouteResponseId: {
                locationName: "routeResponseId"
              },
              RouteResponseKey: {
                locationName: "routeResponseKey"
              }
            }
          }
        },
        CreateStage: {
          http: {
            requestUri: "/v2/apis/{apiId}/stages",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              AccessLogSettings: {
                shape: "S21",
                locationName: "accessLogSettings"
              },
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              AutoDeploy: {
                locationName: "autoDeploy",
                type: "boolean"
              },
              ClientCertificateId: {
                locationName: "clientCertificateId"
              },
              DefaultRouteSettings: {
                shape: "S22",
                locationName: "defaultRouteSettings"
              },
              DeploymentId: {
                locationName: "deploymentId"
              },
              Description: {
                locationName: "description"
              },
              RouteSettings: {
                shape: "S26",
                locationName: "routeSettings"
              },
              StageName: {
                locationName: "stageName"
              },
              StageVariables: {
                shape: "S27",
                locationName: "stageVariables"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              }
            },
            required: [
              "ApiId",
              "StageName"
            ]
          },
          output: {
            type: "structure",
            members: {
              AccessLogSettings: {
                shape: "S21",
                locationName: "accessLogSettings"
              },
              ApiGatewayManaged: {
                locationName: "apiGatewayManaged",
                type: "boolean"
              },
              AutoDeploy: {
                locationName: "autoDeploy",
                type: "boolean"
              },
              ClientCertificateId: {
                locationName: "clientCertificateId"
              },
              CreatedDate: {
                shape: "Sl",
                locationName: "createdDate"
              },
              DefaultRouteSettings: {
                shape: "S22",
                locationName: "defaultRouteSettings"
              },
              DeploymentId: {
                locationName: "deploymentId"
              },
              Description: {
                locationName: "description"
              },
              LastDeploymentStatusMessage: {
                locationName: "lastDeploymentStatusMessage"
              },
              LastUpdatedDate: {
                shape: "Sl",
                locationName: "lastUpdatedDate"
              },
              RouteSettings: {
                shape: "S26",
                locationName: "routeSettings"
              },
              StageName: {
                locationName: "stageName"
              },
              StageVariables: {
                shape: "S27",
                locationName: "stageVariables"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              }
            }
          }
        },
        CreateVpcLink: {
          http: {
            requestUri: "/v2/vpclinks",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              Name: {
                locationName: "name"
              },
              SecurityGroupIds: {
                shape: "S2b",
                locationName: "securityGroupIds"
              },
              SubnetIds: {
                shape: "S2c",
                locationName: "subnetIds"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              }
            },
            required: [
              "SubnetIds",
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              CreatedDate: {
                shape: "Sl",
                locationName: "createdDate"
              },
              Name: {
                locationName: "name"
              },
              SecurityGroupIds: {
                shape: "S2b",
                locationName: "securityGroupIds"
              },
              SubnetIds: {
                shape: "S2c",
                locationName: "subnetIds"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              },
              VpcLinkId: {
                locationName: "vpcLinkId"
              },
              VpcLinkStatus: {
                locationName: "vpcLinkStatus"
              },
              VpcLinkStatusMessage: {
                locationName: "vpcLinkStatusMessage"
              },
              VpcLinkVersion: {
                locationName: "vpcLinkVersion"
              }
            }
          }
        },
        DeleteAccessLogSettings: {
          http: {
            method: "DELETE",
            requestUri: "/v2/apis/{apiId}/stages/{stageName}/accesslogsettings",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              StageName: {
                location: "uri",
                locationName: "stageName"
              }
            },
            required: [
              "StageName",
              "ApiId"
            ]
          }
        },
        DeleteApi: {
          http: {
            method: "DELETE",
            requestUri: "/v2/apis/{apiId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              }
            },
            required: [
              "ApiId"
            ]
          }
        },
        DeleteApiMapping: {
          http: {
            method: "DELETE",
            requestUri: "/v2/domainnames/{domainName}/apimappings/{apiMappingId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApiMappingId: {
                location: "uri",
                locationName: "apiMappingId"
              },
              DomainName: {
                location: "uri",
                locationName: "domainName"
              }
            },
            required: [
              "ApiMappingId",
              "DomainName"
            ]
          }
        },
        DeleteAuthorizer: {
          http: {
            method: "DELETE",
            requestUri: "/v2/apis/{apiId}/authorizers/{authorizerId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              AuthorizerId: {
                location: "uri",
                locationName: "authorizerId"
              }
            },
            required: [
              "AuthorizerId",
              "ApiId"
            ]
          }
        },
        DeleteCorsConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/v2/apis/{apiId}/cors",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              }
            },
            required: [
              "ApiId"
            ]
          }
        },
        DeleteDeployment: {
          http: {
            method: "DELETE",
            requestUri: "/v2/apis/{apiId}/deployments/{deploymentId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              DeploymentId: {
                location: "uri",
                locationName: "deploymentId"
              }
            },
            required: [
              "ApiId",
              "DeploymentId"
            ]
          }
        },
        DeleteDomainName: {
          http: {
            method: "DELETE",
            requestUri: "/v2/domainnames/{domainName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              DomainName: {
                location: "uri",
                locationName: "domainName"
              }
            },
            required: [
              "DomainName"
            ]
          }
        },
        DeleteIntegration: {
          http: {
            method: "DELETE",
            requestUri: "/v2/apis/{apiId}/integrations/{integrationId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              IntegrationId: {
                location: "uri",
                locationName: "integrationId"
              }
            },
            required: [
              "ApiId",
              "IntegrationId"
            ]
          }
        },
        DeleteIntegrationResponse: {
          http: {
            method: "DELETE",
            requestUri: "/v2/apis/{apiId}/integrations/{integrationId}/integrationresponses/{integrationResponseId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              IntegrationId: {
                location: "uri",
                locationName: "integrationId"
              },
              IntegrationResponseId: {
                location: "uri",
                locationName: "integrationResponseId"
              }
            },
            required: [
              "ApiId",
              "IntegrationResponseId",
              "IntegrationId"
            ]
          }
        },
        DeleteModel: {
          http: {
            method: "DELETE",
            requestUri: "/v2/apis/{apiId}/models/{modelId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              ModelId: {
                location: "uri",
                locationName: "modelId"
              }
            },
            required: [
              "ModelId",
              "ApiId"
            ]
          }
        },
        DeleteRoute: {
          http: {
            method: "DELETE",
            requestUri: "/v2/apis/{apiId}/routes/{routeId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              RouteId: {
                location: "uri",
                locationName: "routeId"
              }
            },
            required: [
              "ApiId",
              "RouteId"
            ]
          }
        },
        DeleteRouteRequestParameter: {
          http: {
            method: "DELETE",
            requestUri: "/v2/apis/{apiId}/routes/{routeId}/requestparameters/{requestParameterKey}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              RequestParameterKey: {
                location: "uri",
                locationName: "requestParameterKey"
              },
              RouteId: {
                location: "uri",
                locationName: "routeId"
              }
            },
            required: [
              "RequestParameterKey",
              "ApiId",
              "RouteId"
            ]
          }
        },
        DeleteRouteResponse: {
          http: {
            method: "DELETE",
            requestUri: "/v2/apis/{apiId}/routes/{routeId}/routeresponses/{routeResponseId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              RouteId: {
                location: "uri",
                locationName: "routeId"
              },
              RouteResponseId: {
                location: "uri",
                locationName: "routeResponseId"
              }
            },
            required: [
              "RouteResponseId",
              "ApiId",
              "RouteId"
            ]
          }
        },
        DeleteRouteSettings: {
          http: {
            method: "DELETE",
            requestUri: "/v2/apis/{apiId}/stages/{stageName}/routesettings/{routeKey}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              RouteKey: {
                location: "uri",
                locationName: "routeKey"
              },
              StageName: {
                location: "uri",
                locationName: "stageName"
              }
            },
            required: [
              "StageName",
              "RouteKey",
              "ApiId"
            ]
          }
        },
        DeleteStage: {
          http: {
            method: "DELETE",
            requestUri: "/v2/apis/{apiId}/stages/{stageName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              StageName: {
                location: "uri",
                locationName: "stageName"
              }
            },
            required: [
              "StageName",
              "ApiId"
            ]
          }
        },
        DeleteVpcLink: {
          http: {
            method: "DELETE",
            requestUri: "/v2/vpclinks/{vpcLinkId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              VpcLinkId: {
                location: "uri",
                locationName: "vpcLinkId"
              }
            },
            required: [
              "VpcLinkId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ExportApi: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/exports/{specification}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              ExportVersion: {
                location: "querystring",
                locationName: "exportVersion"
              },
              IncludeExtensions: {
                location: "querystring",
                locationName: "includeExtensions",
                type: "boolean"
              },
              OutputType: {
                location: "querystring",
                locationName: "outputType"
              },
              Specification: {
                location: "uri",
                locationName: "specification"
              },
              StageName: {
                location: "querystring",
                locationName: "stageName"
              }
            },
            required: [
              "Specification",
              "OutputType",
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              body: {
                type: "blob"
              }
            },
            payload: "body"
          }
        },
        ResetAuthorizersCache: {
          http: {
            method: "DELETE",
            requestUri: "/v2/apis/{apiId}/stages/{stageName}/cache/authorizers",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              StageName: {
                location: "uri",
                locationName: "stageName"
              }
            },
            required: [
              "StageName",
              "ApiId"
            ]
          }
        },
        GetApi: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              }
            },
            required: [
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiEndpoint: {
                locationName: "apiEndpoint"
              },
              ApiGatewayManaged: {
                locationName: "apiGatewayManaged",
                type: "boolean"
              },
              ApiId: {
                locationName: "apiId"
              },
              ApiKeySelectionExpression: {
                locationName: "apiKeySelectionExpression"
              },
              CorsConfiguration: {
                shape: "S3",
                locationName: "corsConfiguration"
              },
              CreatedDate: {
                shape: "Sl",
                locationName: "createdDate"
              },
              Description: {
                locationName: "description"
              },
              DisableSchemaValidation: {
                locationName: "disableSchemaValidation",
                type: "boolean"
              },
              DisableExecuteApiEndpoint: {
                locationName: "disableExecuteApiEndpoint",
                type: "boolean"
              },
              ImportInfo: {
                shape: "Sm",
                locationName: "importInfo"
              },
              Name: {
                locationName: "name"
              },
              ProtocolType: {
                locationName: "protocolType"
              },
              RouteSelectionExpression: {
                locationName: "routeSelectionExpression"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              },
              Version: {
                locationName: "version"
              },
              Warnings: {
                shape: "Sm",
                locationName: "warnings"
              }
            }
          }
        },
        GetApiMapping: {
          http: {
            method: "GET",
            requestUri: "/v2/domainnames/{domainName}/apimappings/{apiMappingId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiMappingId: {
                location: "uri",
                locationName: "apiMappingId"
              },
              DomainName: {
                location: "uri",
                locationName: "domainName"
              }
            },
            required: [
              "ApiMappingId",
              "DomainName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiId: {
                locationName: "apiId"
              },
              ApiMappingId: {
                locationName: "apiMappingId"
              },
              ApiMappingKey: {
                locationName: "apiMappingKey"
              },
              Stage: {
                locationName: "stage"
              }
            }
          }
        },
        GetApiMappings: {
          http: {
            method: "GET",
            requestUri: "/v2/domainnames/{domainName}/apimappings",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DomainName: {
                location: "uri",
                locationName: "domainName"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "DomainName"
            ]
          },
          output: {
            type: "structure",
            members: {
              Items: {
                locationName: "items",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApiId: {
                      locationName: "apiId"
                    },
                    ApiMappingId: {
                      locationName: "apiMappingId"
                    },
                    ApiMappingKey: {
                      locationName: "apiMappingKey"
                    },
                    Stage: {
                      locationName: "stage"
                    }
                  },
                  required: [
                    "Stage",
                    "ApiId"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetApis: {
          http: {
            method: "GET",
            requestUri: "/v2/apis",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                locationName: "items",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApiEndpoint: {
                      locationName: "apiEndpoint"
                    },
                    ApiGatewayManaged: {
                      locationName: "apiGatewayManaged",
                      type: "boolean"
                    },
                    ApiId: {
                      locationName: "apiId"
                    },
                    ApiKeySelectionExpression: {
                      locationName: "apiKeySelectionExpression"
                    },
                    CorsConfiguration: {
                      shape: "S3",
                      locationName: "corsConfiguration"
                    },
                    CreatedDate: {
                      shape: "Sl",
                      locationName: "createdDate"
                    },
                    Description: {
                      locationName: "description"
                    },
                    DisableSchemaValidation: {
                      locationName: "disableSchemaValidation",
                      type: "boolean"
                    },
                    DisableExecuteApiEndpoint: {
                      locationName: "disableExecuteApiEndpoint",
                      type: "boolean"
                    },
                    ImportInfo: {
                      shape: "Sm",
                      locationName: "importInfo"
                    },
                    Name: {
                      locationName: "name"
                    },
                    ProtocolType: {
                      locationName: "protocolType"
                    },
                    RouteSelectionExpression: {
                      locationName: "routeSelectionExpression"
                    },
                    Tags: {
                      shape: "Sg",
                      locationName: "tags"
                    },
                    Version: {
                      locationName: "version"
                    },
                    Warnings: {
                      shape: "Sm",
                      locationName: "warnings"
                    }
                  },
                  required: [
                    "RouteSelectionExpression",
                    "Name",
                    "ProtocolType"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetAuthorizer: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/authorizers/{authorizerId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              AuthorizerId: {
                location: "uri",
                locationName: "authorizerId"
              }
            },
            required: [
              "AuthorizerId",
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AuthorizerCredentialsArn: {
                locationName: "authorizerCredentialsArn"
              },
              AuthorizerId: {
                locationName: "authorizerId"
              },
              AuthorizerPayloadFormatVersion: {
                locationName: "authorizerPayloadFormatVersion"
              },
              AuthorizerResultTtlInSeconds: {
                locationName: "authorizerResultTtlInSeconds",
                type: "integer"
              },
              AuthorizerType: {
                locationName: "authorizerType"
              },
              AuthorizerUri: {
                locationName: "authorizerUri"
              },
              EnableSimpleResponses: {
                locationName: "enableSimpleResponses",
                type: "boolean"
              },
              IdentitySource: {
                shape: "Ss",
                locationName: "identitySource"
              },
              IdentityValidationExpression: {
                locationName: "identityValidationExpression"
              },
              JwtConfiguration: {
                shape: "St",
                locationName: "jwtConfiguration"
              },
              Name: {
                locationName: "name"
              }
            }
          }
        },
        GetAuthorizers: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/authorizers",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Items: {
                locationName: "items",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AuthorizerCredentialsArn: {
                      locationName: "authorizerCredentialsArn"
                    },
                    AuthorizerId: {
                      locationName: "authorizerId"
                    },
                    AuthorizerPayloadFormatVersion: {
                      locationName: "authorizerPayloadFormatVersion"
                    },
                    AuthorizerResultTtlInSeconds: {
                      locationName: "authorizerResultTtlInSeconds",
                      type: "integer"
                    },
                    AuthorizerType: {
                      locationName: "authorizerType"
                    },
                    AuthorizerUri: {
                      locationName: "authorizerUri"
                    },
                    EnableSimpleResponses: {
                      locationName: "enableSimpleResponses",
                      type: "boolean"
                    },
                    IdentitySource: {
                      shape: "Ss",
                      locationName: "identitySource"
                    },
                    IdentityValidationExpression: {
                      locationName: "identityValidationExpression"
                    },
                    JwtConfiguration: {
                      shape: "St",
                      locationName: "jwtConfiguration"
                    },
                    Name: {
                      locationName: "name"
                    }
                  },
                  required: [
                    "Name"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetDeployment: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/deployments/{deploymentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              DeploymentId: {
                location: "uri",
                locationName: "deploymentId"
              }
            },
            required: [
              "ApiId",
              "DeploymentId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AutoDeployed: {
                locationName: "autoDeployed",
                type: "boolean"
              },
              CreatedDate: {
                shape: "Sl",
                locationName: "createdDate"
              },
              DeploymentId: {
                locationName: "deploymentId"
              },
              DeploymentStatus: {
                locationName: "deploymentStatus"
              },
              DeploymentStatusMessage: {
                locationName: "deploymentStatusMessage"
              },
              Description: {
                locationName: "description"
              }
            }
          }
        },
        GetDeployments: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/deployments",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Items: {
                locationName: "items",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AutoDeployed: {
                      locationName: "autoDeployed",
                      type: "boolean"
                    },
                    CreatedDate: {
                      shape: "Sl",
                      locationName: "createdDate"
                    },
                    DeploymentId: {
                      locationName: "deploymentId"
                    },
                    DeploymentStatus: {
                      locationName: "deploymentStatus"
                    },
                    DeploymentStatusMessage: {
                      locationName: "deploymentStatusMessage"
                    },
                    Description: {
                      locationName: "description"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetDomainName: {
          http: {
            method: "GET",
            requestUri: "/v2/domainnames/{domainName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DomainName: {
                location: "uri",
                locationName: "domainName"
              }
            },
            required: [
              "DomainName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiMappingSelectionExpression: {
                locationName: "apiMappingSelectionExpression"
              },
              DomainName: {
                locationName: "domainName"
              },
              DomainNameConfigurations: {
                shape: "S10",
                locationName: "domainNameConfigurations"
              },
              MutualTlsAuthentication: {
                shape: "S17",
                locationName: "mutualTlsAuthentication"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              }
            }
          }
        },
        GetDomainNames: {
          http: {
            method: "GET",
            requestUri: "/v2/domainnames",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                locationName: "items",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApiMappingSelectionExpression: {
                      locationName: "apiMappingSelectionExpression"
                    },
                    DomainName: {
                      locationName: "domainName"
                    },
                    DomainNameConfigurations: {
                      shape: "S10",
                      locationName: "domainNameConfigurations"
                    },
                    MutualTlsAuthentication: {
                      shape: "S17",
                      locationName: "mutualTlsAuthentication"
                    },
                    Tags: {
                      shape: "Sg",
                      locationName: "tags"
                    }
                  },
                  required: [
                    "DomainName"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetIntegration: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/integrations/{integrationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              IntegrationId: {
                location: "uri",
                locationName: "integrationId"
              }
            },
            required: [
              "ApiId",
              "IntegrationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiGatewayManaged: {
                locationName: "apiGatewayManaged",
                type: "boolean"
              },
              ConnectionId: {
                locationName: "connectionId"
              },
              ConnectionType: {
                locationName: "connectionType"
              },
              ContentHandlingStrategy: {
                locationName: "contentHandlingStrategy"
              },
              CredentialsArn: {
                locationName: "credentialsArn"
              },
              Description: {
                locationName: "description"
              },
              IntegrationId: {
                locationName: "integrationId"
              },
              IntegrationMethod: {
                locationName: "integrationMethod"
              },
              IntegrationResponseSelectionExpression: {
                locationName: "integrationResponseSelectionExpression"
              },
              IntegrationSubtype: {
                locationName: "integrationSubtype"
              },
              IntegrationType: {
                locationName: "integrationType"
              },
              IntegrationUri: {
                locationName: "integrationUri"
              },
              PassthroughBehavior: {
                locationName: "passthroughBehavior"
              },
              PayloadFormatVersion: {
                locationName: "payloadFormatVersion"
              },
              RequestParameters: {
                shape: "S1e",
                locationName: "requestParameters"
              },
              RequestTemplates: {
                shape: "S1f",
                locationName: "requestTemplates"
              },
              ResponseParameters: {
                shape: "S1h",
                locationName: "responseParameters"
              },
              TemplateSelectionExpression: {
                locationName: "templateSelectionExpression"
              },
              TimeoutInMillis: {
                locationName: "timeoutInMillis",
                type: "integer"
              },
              TlsConfig: {
                shape: "S1l",
                locationName: "tlsConfig"
              }
            }
          }
        },
        GetIntegrationResponse: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/integrations/{integrationId}/integrationresponses/{integrationResponseId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              IntegrationId: {
                location: "uri",
                locationName: "integrationId"
              },
              IntegrationResponseId: {
                location: "uri",
                locationName: "integrationResponseId"
              }
            },
            required: [
              "ApiId",
              "IntegrationResponseId",
              "IntegrationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ContentHandlingStrategy: {
                locationName: "contentHandlingStrategy"
              },
              IntegrationResponseId: {
                locationName: "integrationResponseId"
              },
              IntegrationResponseKey: {
                locationName: "integrationResponseKey"
              },
              ResponseParameters: {
                shape: "S1e",
                locationName: "responseParameters"
              },
              ResponseTemplates: {
                shape: "S1f",
                locationName: "responseTemplates"
              },
              TemplateSelectionExpression: {
                locationName: "templateSelectionExpression"
              }
            }
          }
        },
        GetIntegrationResponses: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/integrations/{integrationId}/integrationresponses",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              IntegrationId: {
                location: "uri",
                locationName: "integrationId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "IntegrationId",
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Items: {
                locationName: "items",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ContentHandlingStrategy: {
                      locationName: "contentHandlingStrategy"
                    },
                    IntegrationResponseId: {
                      locationName: "integrationResponseId"
                    },
                    IntegrationResponseKey: {
                      locationName: "integrationResponseKey"
                    },
                    ResponseParameters: {
                      shape: "S1e",
                      locationName: "responseParameters"
                    },
                    ResponseTemplates: {
                      shape: "S1f",
                      locationName: "responseTemplates"
                    },
                    TemplateSelectionExpression: {
                      locationName: "templateSelectionExpression"
                    }
                  },
                  required: [
                    "IntegrationResponseKey"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetIntegrations: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/integrations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Items: {
                locationName: "items",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApiGatewayManaged: {
                      locationName: "apiGatewayManaged",
                      type: "boolean"
                    },
                    ConnectionId: {
                      locationName: "connectionId"
                    },
                    ConnectionType: {
                      locationName: "connectionType"
                    },
                    ContentHandlingStrategy: {
                      locationName: "contentHandlingStrategy"
                    },
                    CredentialsArn: {
                      locationName: "credentialsArn"
                    },
                    Description: {
                      locationName: "description"
                    },
                    IntegrationId: {
                      locationName: "integrationId"
                    },
                    IntegrationMethod: {
                      locationName: "integrationMethod"
                    },
                    IntegrationResponseSelectionExpression: {
                      locationName: "integrationResponseSelectionExpression"
                    },
                    IntegrationSubtype: {
                      locationName: "integrationSubtype"
                    },
                    IntegrationType: {
                      locationName: "integrationType"
                    },
                    IntegrationUri: {
                      locationName: "integrationUri"
                    },
                    PassthroughBehavior: {
                      locationName: "passthroughBehavior"
                    },
                    PayloadFormatVersion: {
                      locationName: "payloadFormatVersion"
                    },
                    RequestParameters: {
                      shape: "S1e",
                      locationName: "requestParameters"
                    },
                    RequestTemplates: {
                      shape: "S1f",
                      locationName: "requestTemplates"
                    },
                    ResponseParameters: {
                      shape: "S1h",
                      locationName: "responseParameters"
                    },
                    TemplateSelectionExpression: {
                      locationName: "templateSelectionExpression"
                    },
                    TimeoutInMillis: {
                      locationName: "timeoutInMillis",
                      type: "integer"
                    },
                    TlsConfig: {
                      shape: "S1l",
                      locationName: "tlsConfig"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetModel: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/models/{modelId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              ModelId: {
                location: "uri",
                locationName: "modelId"
              }
            },
            required: [
              "ModelId",
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ContentType: {
                locationName: "contentType"
              },
              Description: {
                locationName: "description"
              },
              ModelId: {
                locationName: "modelId"
              },
              Name: {
                locationName: "name"
              },
              Schema: {
                locationName: "schema"
              }
            }
          }
        },
        GetModelTemplate: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/models/{modelId}/template",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              ModelId: {
                location: "uri",
                locationName: "modelId"
              }
            },
            required: [
              "ModelId",
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Value: {
                locationName: "value"
              }
            }
          }
        },
        GetModels: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/models",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Items: {
                locationName: "items",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ContentType: {
                      locationName: "contentType"
                    },
                    Description: {
                      locationName: "description"
                    },
                    ModelId: {
                      locationName: "modelId"
                    },
                    Name: {
                      locationName: "name"
                    },
                    Schema: {
                      locationName: "schema"
                    }
                  },
                  required: [
                    "Name"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetRoute: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/routes/{routeId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              RouteId: {
                location: "uri",
                locationName: "routeId"
              }
            },
            required: [
              "ApiId",
              "RouteId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiGatewayManaged: {
                locationName: "apiGatewayManaged",
                type: "boolean"
              },
              ApiKeyRequired: {
                locationName: "apiKeyRequired",
                type: "boolean"
              },
              AuthorizationScopes: {
                shape: "S1s",
                locationName: "authorizationScopes"
              },
              AuthorizationType: {
                locationName: "authorizationType"
              },
              AuthorizerId: {
                locationName: "authorizerId"
              },
              ModelSelectionExpression: {
                locationName: "modelSelectionExpression"
              },
              OperationName: {
                locationName: "operationName"
              },
              RequestModels: {
                shape: "S1u",
                locationName: "requestModels"
              },
              RequestParameters: {
                shape: "S1v",
                locationName: "requestParameters"
              },
              RouteId: {
                locationName: "routeId"
              },
              RouteKey: {
                locationName: "routeKey"
              },
              RouteResponseSelectionExpression: {
                locationName: "routeResponseSelectionExpression"
              },
              Target: {
                locationName: "target"
              }
            }
          }
        },
        GetRouteResponse: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/routes/{routeId}/routeresponses/{routeResponseId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              RouteId: {
                location: "uri",
                locationName: "routeId"
              },
              RouteResponseId: {
                location: "uri",
                locationName: "routeResponseId"
              }
            },
            required: [
              "RouteResponseId",
              "ApiId",
              "RouteId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ModelSelectionExpression: {
                locationName: "modelSelectionExpression"
              },
              ResponseModels: {
                shape: "S1u",
                locationName: "responseModels"
              },
              ResponseParameters: {
                shape: "S1v",
                locationName: "responseParameters"
              },
              RouteResponseId: {
                locationName: "routeResponseId"
              },
              RouteResponseKey: {
                locationName: "routeResponseKey"
              }
            }
          }
        },
        GetRouteResponses: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/routes/{routeId}/routeresponses",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              RouteId: {
                location: "uri",
                locationName: "routeId"
              }
            },
            required: [
              "RouteId",
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Items: {
                locationName: "items",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ModelSelectionExpression: {
                      locationName: "modelSelectionExpression"
                    },
                    ResponseModels: {
                      shape: "S1u",
                      locationName: "responseModels"
                    },
                    ResponseParameters: {
                      shape: "S1v",
                      locationName: "responseParameters"
                    },
                    RouteResponseId: {
                      locationName: "routeResponseId"
                    },
                    RouteResponseKey: {
                      locationName: "routeResponseKey"
                    }
                  },
                  required: [
                    "RouteResponseKey"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetRoutes: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/routes",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Items: {
                locationName: "items",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApiGatewayManaged: {
                      locationName: "apiGatewayManaged",
                      type: "boolean"
                    },
                    ApiKeyRequired: {
                      locationName: "apiKeyRequired",
                      type: "boolean"
                    },
                    AuthorizationScopes: {
                      shape: "S1s",
                      locationName: "authorizationScopes"
                    },
                    AuthorizationType: {
                      locationName: "authorizationType"
                    },
                    AuthorizerId: {
                      locationName: "authorizerId"
                    },
                    ModelSelectionExpression: {
                      locationName: "modelSelectionExpression"
                    },
                    OperationName: {
                      locationName: "operationName"
                    },
                    RequestModels: {
                      shape: "S1u",
                      locationName: "requestModels"
                    },
                    RequestParameters: {
                      shape: "S1v",
                      locationName: "requestParameters"
                    },
                    RouteId: {
                      locationName: "routeId"
                    },
                    RouteKey: {
                      locationName: "routeKey"
                    },
                    RouteResponseSelectionExpression: {
                      locationName: "routeResponseSelectionExpression"
                    },
                    Target: {
                      locationName: "target"
                    }
                  },
                  required: [
                    "RouteKey"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetStage: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/stages/{stageName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              StageName: {
                location: "uri",
                locationName: "stageName"
              }
            },
            required: [
              "StageName",
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AccessLogSettings: {
                shape: "S21",
                locationName: "accessLogSettings"
              },
              ApiGatewayManaged: {
                locationName: "apiGatewayManaged",
                type: "boolean"
              },
              AutoDeploy: {
                locationName: "autoDeploy",
                type: "boolean"
              },
              ClientCertificateId: {
                locationName: "clientCertificateId"
              },
              CreatedDate: {
                shape: "Sl",
                locationName: "createdDate"
              },
              DefaultRouteSettings: {
                shape: "S22",
                locationName: "defaultRouteSettings"
              },
              DeploymentId: {
                locationName: "deploymentId"
              },
              Description: {
                locationName: "description"
              },
              LastDeploymentStatusMessage: {
                locationName: "lastDeploymentStatusMessage"
              },
              LastUpdatedDate: {
                shape: "Sl",
                locationName: "lastUpdatedDate"
              },
              RouteSettings: {
                shape: "S26",
                locationName: "routeSettings"
              },
              StageName: {
                locationName: "stageName"
              },
              StageVariables: {
                shape: "S27",
                locationName: "stageVariables"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              }
            }
          }
        },
        GetStages: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/stages",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Items: {
                locationName: "items",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AccessLogSettings: {
                      shape: "S21",
                      locationName: "accessLogSettings"
                    },
                    ApiGatewayManaged: {
                      locationName: "apiGatewayManaged",
                      type: "boolean"
                    },
                    AutoDeploy: {
                      locationName: "autoDeploy",
                      type: "boolean"
                    },
                    ClientCertificateId: {
                      locationName: "clientCertificateId"
                    },
                    CreatedDate: {
                      shape: "Sl",
                      locationName: "createdDate"
                    },
                    DefaultRouteSettings: {
                      shape: "S22",
                      locationName: "defaultRouteSettings"
                    },
                    DeploymentId: {
                      locationName: "deploymentId"
                    },
                    Description: {
                      locationName: "description"
                    },
                    LastDeploymentStatusMessage: {
                      locationName: "lastDeploymentStatusMessage"
                    },
                    LastUpdatedDate: {
                      shape: "Sl",
                      locationName: "lastUpdatedDate"
                    },
                    RouteSettings: {
                      shape: "S26",
                      locationName: "routeSettings"
                    },
                    StageName: {
                      locationName: "stageName"
                    },
                    StageVariables: {
                      shape: "S27",
                      locationName: "stageVariables"
                    },
                    Tags: {
                      shape: "Sg",
                      locationName: "tags"
                    }
                  },
                  required: [
                    "StageName"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetTags: {
          http: {
            method: "GET",
            requestUri: "/v2/tags/{resource-arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              }
            },
            required: [
              "ResourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sg",
                locationName: "tags"
              }
            }
          }
        },
        GetVpcLink: {
          http: {
            method: "GET",
            requestUri: "/v2/vpclinks/{vpcLinkId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              VpcLinkId: {
                location: "uri",
                locationName: "vpcLinkId"
              }
            },
            required: [
              "VpcLinkId"
            ]
          },
          output: {
            type: "structure",
            members: {
              CreatedDate: {
                shape: "Sl",
                locationName: "createdDate"
              },
              Name: {
                locationName: "name"
              },
              SecurityGroupIds: {
                shape: "S2b",
                locationName: "securityGroupIds"
              },
              SubnetIds: {
                shape: "S2c",
                locationName: "subnetIds"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              },
              VpcLinkId: {
                locationName: "vpcLinkId"
              },
              VpcLinkStatus: {
                locationName: "vpcLinkStatus"
              },
              VpcLinkStatusMessage: {
                locationName: "vpcLinkStatusMessage"
              },
              VpcLinkVersion: {
                locationName: "vpcLinkVersion"
              }
            }
          }
        },
        GetVpcLinks: {
          http: {
            method: "GET",
            requestUri: "/v2/vpclinks",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                locationName: "items",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreatedDate: {
                      shape: "Sl",
                      locationName: "createdDate"
                    },
                    Name: {
                      locationName: "name"
                    },
                    SecurityGroupIds: {
                      shape: "S2b",
                      locationName: "securityGroupIds"
                    },
                    SubnetIds: {
                      shape: "S2c",
                      locationName: "subnetIds"
                    },
                    Tags: {
                      shape: "Sg",
                      locationName: "tags"
                    },
                    VpcLinkId: {
                      locationName: "vpcLinkId"
                    },
                    VpcLinkStatus: {
                      locationName: "vpcLinkStatus"
                    },
                    VpcLinkStatusMessage: {
                      locationName: "vpcLinkStatusMessage"
                    },
                    VpcLinkVersion: {
                      locationName: "vpcLinkVersion"
                    }
                  },
                  required: [
                    "VpcLinkId",
                    "SecurityGroupIds",
                    "SubnetIds",
                    "Name"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ImportApi: {
          http: {
            method: "PUT",
            requestUri: "/v2/apis",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              Basepath: {
                location: "querystring",
                locationName: "basepath"
              },
              Body: {
                locationName: "body"
              },
              FailOnWarnings: {
                location: "querystring",
                locationName: "failOnWarnings",
                type: "boolean"
              }
            },
            required: [
              "Body"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiEndpoint: {
                locationName: "apiEndpoint"
              },
              ApiGatewayManaged: {
                locationName: "apiGatewayManaged",
                type: "boolean"
              },
              ApiId: {
                locationName: "apiId"
              },
              ApiKeySelectionExpression: {
                locationName: "apiKeySelectionExpression"
              },
              CorsConfiguration: {
                shape: "S3",
                locationName: "corsConfiguration"
              },
              CreatedDate: {
                shape: "Sl",
                locationName: "createdDate"
              },
              Description: {
                locationName: "description"
              },
              DisableSchemaValidation: {
                locationName: "disableSchemaValidation",
                type: "boolean"
              },
              DisableExecuteApiEndpoint: {
                locationName: "disableExecuteApiEndpoint",
                type: "boolean"
              },
              ImportInfo: {
                shape: "Sm",
                locationName: "importInfo"
              },
              Name: {
                locationName: "name"
              },
              ProtocolType: {
                locationName: "protocolType"
              },
              RouteSelectionExpression: {
                locationName: "routeSelectionExpression"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              },
              Version: {
                locationName: "version"
              },
              Warnings: {
                shape: "Sm",
                locationName: "warnings"
              }
            }
          }
        },
        ReimportApi: {
          http: {
            method: "PUT",
            requestUri: "/v2/apis/{apiId}",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              Basepath: {
                location: "querystring",
                locationName: "basepath"
              },
              Body: {
                locationName: "body"
              },
              FailOnWarnings: {
                location: "querystring",
                locationName: "failOnWarnings",
                type: "boolean"
              }
            },
            required: [
              "ApiId",
              "Body"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiEndpoint: {
                locationName: "apiEndpoint"
              },
              ApiGatewayManaged: {
                locationName: "apiGatewayManaged",
                type: "boolean"
              },
              ApiId: {
                locationName: "apiId"
              },
              ApiKeySelectionExpression: {
                locationName: "apiKeySelectionExpression"
              },
              CorsConfiguration: {
                shape: "S3",
                locationName: "corsConfiguration"
              },
              CreatedDate: {
                shape: "Sl",
                locationName: "createdDate"
              },
              Description: {
                locationName: "description"
              },
              DisableSchemaValidation: {
                locationName: "disableSchemaValidation",
                type: "boolean"
              },
              DisableExecuteApiEndpoint: {
                locationName: "disableExecuteApiEndpoint",
                type: "boolean"
              },
              ImportInfo: {
                shape: "Sm",
                locationName: "importInfo"
              },
              Name: {
                locationName: "name"
              },
              ProtocolType: {
                locationName: "protocolType"
              },
              RouteSelectionExpression: {
                locationName: "routeSelectionExpression"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              },
              Version: {
                locationName: "version"
              },
              Warnings: {
                shape: "Sm",
                locationName: "warnings"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/v2/tags/{resource-arn}",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              }
            },
            required: [
              "ResourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/v2/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              TagKeys: {
                shape: "Sm",
                location: "querystring",
                locationName: "tagKeys"
              }
            },
            required: [
              "ResourceArn",
              "TagKeys"
            ]
          }
        },
        UpdateApi: {
          http: {
            method: "PATCH",
            requestUri: "/v2/apis/{apiId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              ApiKeySelectionExpression: {
                locationName: "apiKeySelectionExpression"
              },
              CorsConfiguration: {
                shape: "S3",
                locationName: "corsConfiguration"
              },
              CredentialsArn: {
                locationName: "credentialsArn"
              },
              Description: {
                locationName: "description"
              },
              DisableSchemaValidation: {
                locationName: "disableSchemaValidation",
                type: "boolean"
              },
              DisableExecuteApiEndpoint: {
                locationName: "disableExecuteApiEndpoint",
                type: "boolean"
              },
              Name: {
                locationName: "name"
              },
              RouteKey: {
                locationName: "routeKey"
              },
              RouteSelectionExpression: {
                locationName: "routeSelectionExpression"
              },
              Target: {
                locationName: "target"
              },
              Version: {
                locationName: "version"
              }
            },
            required: [
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiEndpoint: {
                locationName: "apiEndpoint"
              },
              ApiGatewayManaged: {
                locationName: "apiGatewayManaged",
                type: "boolean"
              },
              ApiId: {
                locationName: "apiId"
              },
              ApiKeySelectionExpression: {
                locationName: "apiKeySelectionExpression"
              },
              CorsConfiguration: {
                shape: "S3",
                locationName: "corsConfiguration"
              },
              CreatedDate: {
                shape: "Sl",
                locationName: "createdDate"
              },
              Description: {
                locationName: "description"
              },
              DisableSchemaValidation: {
                locationName: "disableSchemaValidation",
                type: "boolean"
              },
              DisableExecuteApiEndpoint: {
                locationName: "disableExecuteApiEndpoint",
                type: "boolean"
              },
              ImportInfo: {
                shape: "Sm",
                locationName: "importInfo"
              },
              Name: {
                locationName: "name"
              },
              ProtocolType: {
                locationName: "protocolType"
              },
              RouteSelectionExpression: {
                locationName: "routeSelectionExpression"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              },
              Version: {
                locationName: "version"
              },
              Warnings: {
                shape: "Sm",
                locationName: "warnings"
              }
            }
          }
        },
        UpdateApiMapping: {
          http: {
            method: "PATCH",
            requestUri: "/v2/domainnames/{domainName}/apimappings/{apiMappingId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                locationName: "apiId"
              },
              ApiMappingId: {
                location: "uri",
                locationName: "apiMappingId"
              },
              ApiMappingKey: {
                locationName: "apiMappingKey"
              },
              DomainName: {
                location: "uri",
                locationName: "domainName"
              },
              Stage: {
                locationName: "stage"
              }
            },
            required: [
              "ApiMappingId",
              "ApiId",
              "DomainName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiId: {
                locationName: "apiId"
              },
              ApiMappingId: {
                locationName: "apiMappingId"
              },
              ApiMappingKey: {
                locationName: "apiMappingKey"
              },
              Stage: {
                locationName: "stage"
              }
            }
          }
        },
        UpdateAuthorizer: {
          http: {
            method: "PATCH",
            requestUri: "/v2/apis/{apiId}/authorizers/{authorizerId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              AuthorizerCredentialsArn: {
                locationName: "authorizerCredentialsArn"
              },
              AuthorizerId: {
                location: "uri",
                locationName: "authorizerId"
              },
              AuthorizerPayloadFormatVersion: {
                locationName: "authorizerPayloadFormatVersion"
              },
              AuthorizerResultTtlInSeconds: {
                locationName: "authorizerResultTtlInSeconds",
                type: "integer"
              },
              AuthorizerType: {
                locationName: "authorizerType"
              },
              AuthorizerUri: {
                locationName: "authorizerUri"
              },
              EnableSimpleResponses: {
                locationName: "enableSimpleResponses",
                type: "boolean"
              },
              IdentitySource: {
                shape: "Ss",
                locationName: "identitySource"
              },
              IdentityValidationExpression: {
                locationName: "identityValidationExpression"
              },
              JwtConfiguration: {
                shape: "St",
                locationName: "jwtConfiguration"
              },
              Name: {
                locationName: "name"
              }
            },
            required: [
              "AuthorizerId",
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AuthorizerCredentialsArn: {
                locationName: "authorizerCredentialsArn"
              },
              AuthorizerId: {
                locationName: "authorizerId"
              },
              AuthorizerPayloadFormatVersion: {
                locationName: "authorizerPayloadFormatVersion"
              },
              AuthorizerResultTtlInSeconds: {
                locationName: "authorizerResultTtlInSeconds",
                type: "integer"
              },
              AuthorizerType: {
                locationName: "authorizerType"
              },
              AuthorizerUri: {
                locationName: "authorizerUri"
              },
              EnableSimpleResponses: {
                locationName: "enableSimpleResponses",
                type: "boolean"
              },
              IdentitySource: {
                shape: "Ss",
                locationName: "identitySource"
              },
              IdentityValidationExpression: {
                locationName: "identityValidationExpression"
              },
              JwtConfiguration: {
                shape: "St",
                locationName: "jwtConfiguration"
              },
              Name: {
                locationName: "name"
              }
            }
          }
        },
        UpdateDeployment: {
          http: {
            method: "PATCH",
            requestUri: "/v2/apis/{apiId}/deployments/{deploymentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              DeploymentId: {
                location: "uri",
                locationName: "deploymentId"
              },
              Description: {
                locationName: "description"
              }
            },
            required: [
              "ApiId",
              "DeploymentId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AutoDeployed: {
                locationName: "autoDeployed",
                type: "boolean"
              },
              CreatedDate: {
                shape: "Sl",
                locationName: "createdDate"
              },
              DeploymentId: {
                locationName: "deploymentId"
              },
              DeploymentStatus: {
                locationName: "deploymentStatus"
              },
              DeploymentStatusMessage: {
                locationName: "deploymentStatusMessage"
              },
              Description: {
                locationName: "description"
              }
            }
          }
        },
        UpdateDomainName: {
          http: {
            method: "PATCH",
            requestUri: "/v2/domainnames/{domainName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DomainName: {
                location: "uri",
                locationName: "domainName"
              },
              DomainNameConfigurations: {
                shape: "S10",
                locationName: "domainNameConfigurations"
              },
              MutualTlsAuthentication: {
                shape: "S15",
                locationName: "mutualTlsAuthentication"
              }
            },
            required: [
              "DomainName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiMappingSelectionExpression: {
                locationName: "apiMappingSelectionExpression"
              },
              DomainName: {
                locationName: "domainName"
              },
              DomainNameConfigurations: {
                shape: "S10",
                locationName: "domainNameConfigurations"
              },
              MutualTlsAuthentication: {
                shape: "S17",
                locationName: "mutualTlsAuthentication"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              }
            }
          }
        },
        UpdateIntegration: {
          http: {
            method: "PATCH",
            requestUri: "/v2/apis/{apiId}/integrations/{integrationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              ConnectionId: {
                locationName: "connectionId"
              },
              ConnectionType: {
                locationName: "connectionType"
              },
              ContentHandlingStrategy: {
                locationName: "contentHandlingStrategy"
              },
              CredentialsArn: {
                locationName: "credentialsArn"
              },
              Description: {
                locationName: "description"
              },
              IntegrationId: {
                location: "uri",
                locationName: "integrationId"
              },
              IntegrationMethod: {
                locationName: "integrationMethod"
              },
              IntegrationSubtype: {
                locationName: "integrationSubtype"
              },
              IntegrationType: {
                locationName: "integrationType"
              },
              IntegrationUri: {
                locationName: "integrationUri"
              },
              PassthroughBehavior: {
                locationName: "passthroughBehavior"
              },
              PayloadFormatVersion: {
                locationName: "payloadFormatVersion"
              },
              RequestParameters: {
                shape: "S1e",
                locationName: "requestParameters"
              },
              RequestTemplates: {
                shape: "S1f",
                locationName: "requestTemplates"
              },
              ResponseParameters: {
                shape: "S1h",
                locationName: "responseParameters"
              },
              TemplateSelectionExpression: {
                locationName: "templateSelectionExpression"
              },
              TimeoutInMillis: {
                locationName: "timeoutInMillis",
                type: "integer"
              },
              TlsConfig: {
                shape: "S1j",
                locationName: "tlsConfig"
              }
            },
            required: [
              "ApiId",
              "IntegrationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiGatewayManaged: {
                locationName: "apiGatewayManaged",
                type: "boolean"
              },
              ConnectionId: {
                locationName: "connectionId"
              },
              ConnectionType: {
                locationName: "connectionType"
              },
              ContentHandlingStrategy: {
                locationName: "contentHandlingStrategy"
              },
              CredentialsArn: {
                locationName: "credentialsArn"
              },
              Description: {
                locationName: "description"
              },
              IntegrationId: {
                locationName: "integrationId"
              },
              IntegrationMethod: {
                locationName: "integrationMethod"
              },
              IntegrationResponseSelectionExpression: {
                locationName: "integrationResponseSelectionExpression"
              },
              IntegrationSubtype: {
                locationName: "integrationSubtype"
              },
              IntegrationType: {
                locationName: "integrationType"
              },
              IntegrationUri: {
                locationName: "integrationUri"
              },
              PassthroughBehavior: {
                locationName: "passthroughBehavior"
              },
              PayloadFormatVersion: {
                locationName: "payloadFormatVersion"
              },
              RequestParameters: {
                shape: "S1e",
                locationName: "requestParameters"
              },
              RequestTemplates: {
                shape: "S1f",
                locationName: "requestTemplates"
              },
              ResponseParameters: {
                shape: "S1h",
                locationName: "responseParameters"
              },
              TemplateSelectionExpression: {
                locationName: "templateSelectionExpression"
              },
              TimeoutInMillis: {
                locationName: "timeoutInMillis",
                type: "integer"
              },
              TlsConfig: {
                shape: "S1l",
                locationName: "tlsConfig"
              }
            }
          }
        },
        UpdateIntegrationResponse: {
          http: {
            method: "PATCH",
            requestUri: "/v2/apis/{apiId}/integrations/{integrationId}/integrationresponses/{integrationResponseId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              ContentHandlingStrategy: {
                locationName: "contentHandlingStrategy"
              },
              IntegrationId: {
                location: "uri",
                locationName: "integrationId"
              },
              IntegrationResponseId: {
                location: "uri",
                locationName: "integrationResponseId"
              },
              IntegrationResponseKey: {
                locationName: "integrationResponseKey"
              },
              ResponseParameters: {
                shape: "S1e",
                locationName: "responseParameters"
              },
              ResponseTemplates: {
                shape: "S1f",
                locationName: "responseTemplates"
              },
              TemplateSelectionExpression: {
                locationName: "templateSelectionExpression"
              }
            },
            required: [
              "ApiId",
              "IntegrationResponseId",
              "IntegrationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ContentHandlingStrategy: {
                locationName: "contentHandlingStrategy"
              },
              IntegrationResponseId: {
                locationName: "integrationResponseId"
              },
              IntegrationResponseKey: {
                locationName: "integrationResponseKey"
              },
              ResponseParameters: {
                shape: "S1e",
                locationName: "responseParameters"
              },
              ResponseTemplates: {
                shape: "S1f",
                locationName: "responseTemplates"
              },
              TemplateSelectionExpression: {
                locationName: "templateSelectionExpression"
              }
            }
          }
        },
        UpdateModel: {
          http: {
            method: "PATCH",
            requestUri: "/v2/apis/{apiId}/models/{modelId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              ContentType: {
                locationName: "contentType"
              },
              Description: {
                locationName: "description"
              },
              ModelId: {
                location: "uri",
                locationName: "modelId"
              },
              Name: {
                locationName: "name"
              },
              Schema: {
                locationName: "schema"
              }
            },
            required: [
              "ModelId",
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ContentType: {
                locationName: "contentType"
              },
              Description: {
                locationName: "description"
              },
              ModelId: {
                locationName: "modelId"
              },
              Name: {
                locationName: "name"
              },
              Schema: {
                locationName: "schema"
              }
            }
          }
        },
        UpdateRoute: {
          http: {
            method: "PATCH",
            requestUri: "/v2/apis/{apiId}/routes/{routeId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              ApiKeyRequired: {
                locationName: "apiKeyRequired",
                type: "boolean"
              },
              AuthorizationScopes: {
                shape: "S1s",
                locationName: "authorizationScopes"
              },
              AuthorizationType: {
                locationName: "authorizationType"
              },
              AuthorizerId: {
                locationName: "authorizerId"
              },
              ModelSelectionExpression: {
                locationName: "modelSelectionExpression"
              },
              OperationName: {
                locationName: "operationName"
              },
              RequestModels: {
                shape: "S1u",
                locationName: "requestModels"
              },
              RequestParameters: {
                shape: "S1v",
                locationName: "requestParameters"
              },
              RouteId: {
                location: "uri",
                locationName: "routeId"
              },
              RouteKey: {
                locationName: "routeKey"
              },
              RouteResponseSelectionExpression: {
                locationName: "routeResponseSelectionExpression"
              },
              Target: {
                locationName: "target"
              }
            },
            required: [
              "ApiId",
              "RouteId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiGatewayManaged: {
                locationName: "apiGatewayManaged",
                type: "boolean"
              },
              ApiKeyRequired: {
                locationName: "apiKeyRequired",
                type: "boolean"
              },
              AuthorizationScopes: {
                shape: "S1s",
                locationName: "authorizationScopes"
              },
              AuthorizationType: {
                locationName: "authorizationType"
              },
              AuthorizerId: {
                locationName: "authorizerId"
              },
              ModelSelectionExpression: {
                locationName: "modelSelectionExpression"
              },
              OperationName: {
                locationName: "operationName"
              },
              RequestModels: {
                shape: "S1u",
                locationName: "requestModels"
              },
              RequestParameters: {
                shape: "S1v",
                locationName: "requestParameters"
              },
              RouteId: {
                locationName: "routeId"
              },
              RouteKey: {
                locationName: "routeKey"
              },
              RouteResponseSelectionExpression: {
                locationName: "routeResponseSelectionExpression"
              },
              Target: {
                locationName: "target"
              }
            }
          }
        },
        UpdateRouteResponse: {
          http: {
            method: "PATCH",
            requestUri: "/v2/apis/{apiId}/routes/{routeId}/routeresponses/{routeResponseId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              ModelSelectionExpression: {
                locationName: "modelSelectionExpression"
              },
              ResponseModels: {
                shape: "S1u",
                locationName: "responseModels"
              },
              ResponseParameters: {
                shape: "S1v",
                locationName: "responseParameters"
              },
              RouteId: {
                location: "uri",
                locationName: "routeId"
              },
              RouteResponseId: {
                location: "uri",
                locationName: "routeResponseId"
              },
              RouteResponseKey: {
                locationName: "routeResponseKey"
              }
            },
            required: [
              "RouteResponseId",
              "ApiId",
              "RouteId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ModelSelectionExpression: {
                locationName: "modelSelectionExpression"
              },
              ResponseModels: {
                shape: "S1u",
                locationName: "responseModels"
              },
              ResponseParameters: {
                shape: "S1v",
                locationName: "responseParameters"
              },
              RouteResponseId: {
                locationName: "routeResponseId"
              },
              RouteResponseKey: {
                locationName: "routeResponseKey"
              }
            }
          }
        },
        UpdateStage: {
          http: {
            method: "PATCH",
            requestUri: "/v2/apis/{apiId}/stages/{stageName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AccessLogSettings: {
                shape: "S21",
                locationName: "accessLogSettings"
              },
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              AutoDeploy: {
                locationName: "autoDeploy",
                type: "boolean"
              },
              ClientCertificateId: {
                locationName: "clientCertificateId"
              },
              DefaultRouteSettings: {
                shape: "S22",
                locationName: "defaultRouteSettings"
              },
              DeploymentId: {
                locationName: "deploymentId"
              },
              Description: {
                locationName: "description"
              },
              RouteSettings: {
                shape: "S26",
                locationName: "routeSettings"
              },
              StageName: {
                location: "uri",
                locationName: "stageName"
              },
              StageVariables: {
                shape: "S27",
                locationName: "stageVariables"
              }
            },
            required: [
              "StageName",
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AccessLogSettings: {
                shape: "S21",
                locationName: "accessLogSettings"
              },
              ApiGatewayManaged: {
                locationName: "apiGatewayManaged",
                type: "boolean"
              },
              AutoDeploy: {
                locationName: "autoDeploy",
                type: "boolean"
              },
              ClientCertificateId: {
                locationName: "clientCertificateId"
              },
              CreatedDate: {
                shape: "Sl",
                locationName: "createdDate"
              },
              DefaultRouteSettings: {
                shape: "S22",
                locationName: "defaultRouteSettings"
              },
              DeploymentId: {
                locationName: "deploymentId"
              },
              Description: {
                locationName: "description"
              },
              LastDeploymentStatusMessage: {
                locationName: "lastDeploymentStatusMessage"
              },
              LastUpdatedDate: {
                shape: "Sl",
                locationName: "lastUpdatedDate"
              },
              RouteSettings: {
                shape: "S26",
                locationName: "routeSettings"
              },
              StageName: {
                locationName: "stageName"
              },
              StageVariables: {
                shape: "S27",
                locationName: "stageVariables"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              }
            }
          }
        },
        UpdateVpcLink: {
          http: {
            method: "PATCH",
            requestUri: "/v2/vpclinks/{vpcLinkId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Name: {
                locationName: "name"
              },
              VpcLinkId: {
                location: "uri",
                locationName: "vpcLinkId"
              }
            },
            required: [
              "VpcLinkId"
            ]
          },
          output: {
            type: "structure",
            members: {
              CreatedDate: {
                shape: "Sl",
                locationName: "createdDate"
              },
              Name: {
                locationName: "name"
              },
              SecurityGroupIds: {
                shape: "S2b",
                locationName: "securityGroupIds"
              },
              SubnetIds: {
                shape: "S2c",
                locationName: "subnetIds"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              },
              VpcLinkId: {
                locationName: "vpcLinkId"
              },
              VpcLinkStatus: {
                locationName: "vpcLinkStatus"
              },
              VpcLinkStatusMessage: {
                locationName: "vpcLinkStatusMessage"
              },
              VpcLinkVersion: {
                locationName: "vpcLinkVersion"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          members: {
            AllowCredentials: {
              locationName: "allowCredentials",
              type: "boolean"
            },
            AllowHeaders: {
              shape: "S5",
              locationName: "allowHeaders"
            },
            AllowMethods: {
              locationName: "allowMethods",
              type: "list",
              member: {}
            },
            AllowOrigins: {
              locationName: "allowOrigins",
              type: "list",
              member: {}
            },
            ExposeHeaders: {
              shape: "S5",
              locationName: "exposeHeaders"
            },
            MaxAge: {
              locationName: "maxAge",
              type: "integer"
            }
          }
        },
        S5: {
          type: "list",
          member: {}
        },
        Sg: {
          type: "map",
          key: {},
          value: {}
        },
        Sl: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        Sm: {
          type: "list",
          member: {}
        },
        Ss: {
          type: "list",
          member: {}
        },
        St: {
          type: "structure",
          members: {
            Audience: {
              shape: "Sm",
              locationName: "audience"
            },
            Issuer: {
              locationName: "issuer"
            }
          }
        },
        S10: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ApiGatewayDomainName: {
                locationName: "apiGatewayDomainName"
              },
              CertificateArn: {
                locationName: "certificateArn"
              },
              CertificateName: {
                locationName: "certificateName"
              },
              CertificateUploadDate: {
                shape: "Sl",
                locationName: "certificateUploadDate"
              },
              DomainNameStatus: {
                locationName: "domainNameStatus"
              },
              DomainNameStatusMessage: {
                locationName: "domainNameStatusMessage"
              },
              EndpointType: {
                locationName: "endpointType"
              },
              HostedZoneId: {
                locationName: "hostedZoneId"
              },
              SecurityPolicy: {
                locationName: "securityPolicy"
              },
              OwnershipVerificationCertificateArn: {
                locationName: "ownershipVerificationCertificateArn"
              }
            }
          }
        },
        S15: {
          type: "structure",
          members: {
            TruststoreUri: {
              locationName: "truststoreUri"
            },
            TruststoreVersion: {
              locationName: "truststoreVersion"
            }
          }
        },
        S17: {
          type: "structure",
          members: {
            TruststoreUri: {
              locationName: "truststoreUri"
            },
            TruststoreVersion: {
              locationName: "truststoreVersion"
            },
            TruststoreWarnings: {
              shape: "Sm",
              locationName: "truststoreWarnings"
            }
          }
        },
        S1e: {
          type: "map",
          key: {},
          value: {}
        },
        S1f: {
          type: "map",
          key: {},
          value: {}
        },
        S1h: {
          type: "map",
          key: {},
          value: {
            shape: "S1e"
          }
        },
        S1j: {
          type: "structure",
          members: {
            ServerNameToVerify: {
              locationName: "serverNameToVerify"
            }
          }
        },
        S1l: {
          type: "structure",
          members: {
            ServerNameToVerify: {
              locationName: "serverNameToVerify"
            }
          }
        },
        S1s: {
          type: "list",
          member: {}
        },
        S1u: {
          type: "map",
          key: {},
          value: {}
        },
        S1v: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              Required: {
                locationName: "required",
                type: "boolean"
              }
            }
          }
        },
        S21: {
          type: "structure",
          members: {
            DestinationArn: {
              locationName: "destinationArn"
            },
            Format: {
              locationName: "format"
            }
          }
        },
        S22: {
          type: "structure",
          members: {
            DataTraceEnabled: {
              locationName: "dataTraceEnabled",
              type: "boolean"
            },
            DetailedMetricsEnabled: {
              locationName: "detailedMetricsEnabled",
              type: "boolean"
            },
            LoggingLevel: {
              locationName: "loggingLevel"
            },
            ThrottlingBurstLimit: {
              locationName: "throttlingBurstLimit",
              type: "integer"
            },
            ThrottlingRateLimit: {
              locationName: "throttlingRateLimit",
              type: "double"
            }
          }
        },
        S26: {
          type: "map",
          key: {},
          value: {
            shape: "S22"
          }
        },
        S27: {
          type: "map",
          key: {},
          value: {}
        },
        S2b: {
          type: "list",
          member: {}
        },
        S2c: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/apigatewayv2-2018-11-29.paginators.json
var require_apigatewayv2_2018_11_29_paginators = __commonJS({
  "node_modules/aws-sdk/apis/apigatewayv2-2018-11-29.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/apigatewayv2.js
var require_apigatewayv2 = __commonJS({
  "node_modules/aws-sdk/clients/apigatewayv2.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["apigatewayv2"] = {};
    AWS2.ApiGatewayV2 = Service.defineService("apigatewayv2", ["2018-11-29"]);
    Object.defineProperty(apiLoader.services["apigatewayv2"], "2018-11-29", {
      get: function get() {
        var model = require_apigatewayv2_2018_11_29_min();
        model.paginators = require_apigatewayv2_2018_11_29_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ApiGatewayV2;
  }
});

// node_modules/aws-sdk/lib/services/docdb.js
var require_docdb = __commonJS({
  "node_modules/aws-sdk/lib/services/docdb.js"() {
    "use strict";
    var AWS2 = require_core();
    var rdsutil = require_rdsutil();
    var crossRegionOperations = ["createDBCluster", "copyDBClusterSnapshot"];
    AWS2.util.update(AWS2.DocDB.prototype, {
      /**
      * @api private
      */
      setupRequestListeners: function setupRequestListeners(request) {
        if (crossRegionOperations.indexOf(request.operation) !== -1 && this.config.params && this.config.params.SourceRegion && request.params && !request.params.SourceRegion) {
          request.params.SourceRegion = this.config.params.SourceRegion;
        }
        rdsutil.setupRequestListeners(this, request, crossRegionOperations);
      }
    });
  }
});

// node_modules/aws-sdk/apis/docdb-2014-10-31.min.json
var require_docdb_2014_10_31_min = __commonJS({
  "node_modules/aws-sdk/apis/docdb-2014-10-31.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-10-31",
        endpointPrefix: "rds",
        protocol: "query",
        serviceAbbreviation: "Amazon DocDB",
        serviceFullName: "Amazon DocumentDB with MongoDB compatibility",
        serviceId: "DocDB",
        signatureVersion: "v4",
        signingName: "rds",
        uid: "docdb-2014-10-31",
        xmlNamespace: "http://rds.amazonaws.com/doc/2014-10-31/"
      },
      operations: {
        AddSourceIdentifierToSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SourceIdentifier"
            ],
            members: {
              SubscriptionName: {},
              SourceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "AddSourceIdentifierToSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        AddTagsToResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "Tags"
            ],
            members: {
              ResourceName: {},
              Tags: {
                shape: "S9"
              }
            }
          }
        },
        ApplyPendingMaintenanceAction: {
          input: {
            type: "structure",
            required: [
              "ResourceIdentifier",
              "ApplyAction",
              "OptInType"
            ],
            members: {
              ResourceIdentifier: {},
              ApplyAction: {},
              OptInType: {}
            }
          },
          output: {
            resultWrapper: "ApplyPendingMaintenanceActionResult",
            type: "structure",
            members: {
              ResourcePendingMaintenanceActions: {
                shape: "Sd"
              }
            }
          }
        },
        CopyDBClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "SourceDBClusterParameterGroupIdentifier",
              "TargetDBClusterParameterGroupIdentifier",
              "TargetDBClusterParameterGroupDescription"
            ],
            members: {
              SourceDBClusterParameterGroupIdentifier: {},
              TargetDBClusterParameterGroupIdentifier: {},
              TargetDBClusterParameterGroupDescription: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CopyDBClusterParameterGroupResult",
            type: "structure",
            members: {
              DBClusterParameterGroup: {
                shape: "Sj"
              }
            }
          }
        },
        CopyDBClusterSnapshot: {
          input: {
            type: "structure",
            required: [
              "SourceDBClusterSnapshotIdentifier",
              "TargetDBClusterSnapshotIdentifier"
            ],
            members: {
              SourceDBClusterSnapshotIdentifier: {},
              TargetDBClusterSnapshotIdentifier: {},
              KmsKeyId: {},
              PreSignedUrl: {},
              CopyTags: {
                type: "boolean"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CopyDBClusterSnapshotResult",
            type: "structure",
            members: {
              DBClusterSnapshot: {
                shape: "Sn"
              }
            }
          }
        },
        CreateDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "Engine"
            ],
            members: {
              AvailabilityZones: {
                shape: "So"
              },
              BackupRetentionPeriod: {
                type: "integer"
              },
              DBClusterIdentifier: {},
              DBClusterParameterGroupName: {},
              VpcSecurityGroupIds: {
                shape: "Ss"
              },
              DBSubnetGroupName: {},
              Engine: {},
              EngineVersion: {},
              Port: {
                type: "integer"
              },
              MasterUsername: {},
              MasterUserPassword: {},
              PreferredBackupWindow: {},
              PreferredMaintenanceWindow: {},
              Tags: {
                shape: "S9"
              },
              StorageEncrypted: {
                type: "boolean"
              },
              KmsKeyId: {},
              PreSignedUrl: {},
              EnableCloudwatchLogsExports: {
                shape: "St"
              },
              DeletionProtection: {
                type: "boolean"
              },
              GlobalClusterIdentifier: {},
              StorageType: {}
            }
          },
          output: {
            resultWrapper: "CreateDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "Sw"
              }
            }
          }
        },
        CreateDBClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBClusterParameterGroupName",
              "DBParameterGroupFamily",
              "Description"
            ],
            members: {
              DBClusterParameterGroupName: {},
              DBParameterGroupFamily: {},
              Description: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBClusterParameterGroupResult",
            type: "structure",
            members: {
              DBClusterParameterGroup: {
                shape: "Sj"
              }
            }
          }
        },
        CreateDBClusterSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBClusterSnapshotIdentifier",
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterSnapshotIdentifier: {},
              DBClusterIdentifier: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBClusterSnapshotResult",
            type: "structure",
            members: {
              DBClusterSnapshot: {
                shape: "Sn"
              }
            }
          }
        },
        CreateDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "DBInstanceClass",
              "Engine",
              "DBClusterIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              DBInstanceClass: {},
              Engine: {},
              AvailabilityZone: {},
              PreferredMaintenanceWindow: {},
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              Tags: {
                shape: "S9"
              },
              DBClusterIdentifier: {},
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              PromotionTier: {
                type: "integer"
              },
              EnablePerformanceInsights: {
                type: "boolean"
              },
              PerformanceInsightsKMSKeyId: {},
              CACertificateIdentifier: {}
            }
          },
          output: {
            resultWrapper: "CreateDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S1a"
              }
            }
          }
        },
        CreateDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName",
              "DBSubnetGroupDescription",
              "SubnetIds"
            ],
            members: {
              DBSubnetGroupName: {},
              DBSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S1m"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBSubnetGroupResult",
            type: "structure",
            members: {
              DBSubnetGroup: {
                shape: "S1c"
              }
            }
          }
        },
        CreateEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SnsTopicArn"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S6"
              },
              SourceIds: {
                shape: "S5"
              },
              Enabled: {
                type: "boolean"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        CreateGlobalCluster: {
          input: {
            type: "structure",
            required: [
              "GlobalClusterIdentifier"
            ],
            members: {
              GlobalClusterIdentifier: {},
              SourceDBClusterIdentifier: {},
              Engine: {},
              EngineVersion: {},
              DeletionProtection: {
                type: "boolean"
              },
              DatabaseName: {},
              StorageEncrypted: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CreateGlobalClusterResult",
            type: "structure",
            members: {
              GlobalCluster: {
                shape: "S1s"
              }
            }
          }
        },
        DeleteDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {},
              SkipFinalSnapshot: {
                type: "boolean"
              },
              FinalDBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "Sw"
              }
            }
          }
        },
        DeleteDBClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBClusterParameterGroupName"
            ],
            members: {
              DBClusterParameterGroupName: {}
            }
          }
        },
        DeleteDBClusterSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBClusterSnapshotIdentifier"
            ],
            members: {
              DBClusterSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBClusterSnapshotResult",
            type: "structure",
            members: {
              DBClusterSnapshot: {
                shape: "Sn"
              }
            }
          }
        },
        DeleteDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S1a"
              }
            }
          }
        },
        DeleteDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName"
            ],
            members: {
              DBSubnetGroupName: {}
            }
          }
        },
        DeleteEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {}
            }
          },
          output: {
            resultWrapper: "DeleteEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        DeleteGlobalCluster: {
          input: {
            type: "structure",
            required: [
              "GlobalClusterIdentifier"
            ],
            members: {
              GlobalClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteGlobalClusterResult",
            type: "structure",
            members: {
              GlobalCluster: {
                shape: "S1s"
              }
            }
          }
        },
        DescribeCertificates: {
          input: {
            type: "structure",
            members: {
              CertificateIdentifier: {},
              Filters: {
                shape: "S29"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeCertificatesResult",
            type: "structure",
            members: {
              Certificates: {
                type: "list",
                member: {
                  locationName: "Certificate",
                  type: "structure",
                  members: {
                    CertificateIdentifier: {},
                    CertificateType: {},
                    Thumbprint: {},
                    ValidFrom: {
                      type: "timestamp"
                    },
                    ValidTill: {
                      type: "timestamp"
                    },
                    CertificateArn: {}
                  },
                  wrapper: true
                }
              },
              Marker: {}
            }
          }
        },
        DescribeDBClusterParameterGroups: {
          input: {
            type: "structure",
            members: {
              DBClusterParameterGroupName: {},
              Filters: {
                shape: "S29"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBClusterParameterGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBClusterParameterGroups: {
                type: "list",
                member: {
                  shape: "Sj",
                  locationName: "DBClusterParameterGroup"
                }
              }
            }
          }
        },
        DescribeDBClusterParameters: {
          input: {
            type: "structure",
            required: [
              "DBClusterParameterGroupName"
            ],
            members: {
              DBClusterParameterGroupName: {},
              Source: {},
              Filters: {
                shape: "S29"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBClusterParametersResult",
            type: "structure",
            members: {
              Parameters: {
                shape: "S2k"
              },
              Marker: {}
            }
          }
        },
        DescribeDBClusterSnapshotAttributes: {
          input: {
            type: "structure",
            required: [
              "DBClusterSnapshotIdentifier"
            ],
            members: {
              DBClusterSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBClusterSnapshotAttributesResult",
            type: "structure",
            members: {
              DBClusterSnapshotAttributesResult: {
                shape: "S2p"
              }
            }
          }
        },
        DescribeDBClusterSnapshots: {
          input: {
            type: "structure",
            members: {
              DBClusterIdentifier: {},
              DBClusterSnapshotIdentifier: {},
              SnapshotType: {},
              Filters: {
                shape: "S29"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              IncludeShared: {
                type: "boolean"
              },
              IncludePublic: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeDBClusterSnapshotsResult",
            type: "structure",
            members: {
              Marker: {},
              DBClusterSnapshots: {
                type: "list",
                member: {
                  shape: "Sn",
                  locationName: "DBClusterSnapshot"
                }
              }
            }
          }
        },
        DescribeDBClusters: {
          input: {
            type: "structure",
            members: {
              DBClusterIdentifier: {},
              Filters: {
                shape: "S29"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBClustersResult",
            type: "structure",
            members: {
              Marker: {},
              DBClusters: {
                type: "list",
                member: {
                  shape: "Sw",
                  locationName: "DBCluster"
                }
              }
            }
          }
        },
        DescribeDBEngineVersions: {
          input: {
            type: "structure",
            members: {
              Engine: {},
              EngineVersion: {},
              DBParameterGroupFamily: {},
              Filters: {
                shape: "S29"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              DefaultOnly: {
                type: "boolean"
              },
              ListSupportedCharacterSets: {
                type: "boolean"
              },
              ListSupportedTimezones: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeDBEngineVersionsResult",
            type: "structure",
            members: {
              Marker: {},
              DBEngineVersions: {
                type: "list",
                member: {
                  locationName: "DBEngineVersion",
                  type: "structure",
                  members: {
                    Engine: {},
                    EngineVersion: {},
                    DBParameterGroupFamily: {},
                    DBEngineDescription: {},
                    DBEngineVersionDescription: {},
                    ValidUpgradeTarget: {
                      type: "list",
                      member: {
                        locationName: "UpgradeTarget",
                        type: "structure",
                        members: {
                          Engine: {},
                          EngineVersion: {},
                          Description: {},
                          AutoUpgrade: {
                            type: "boolean"
                          },
                          IsMajorVersionUpgrade: {
                            type: "boolean"
                          }
                        }
                      }
                    },
                    ExportableLogTypes: {
                      shape: "St"
                    },
                    SupportsLogExportsToCloudwatchLogs: {
                      type: "boolean"
                    },
                    SupportedCACertificateIdentifiers: {
                      type: "list",
                      member: {}
                    },
                    SupportsCertificateRotationWithoutRestart: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeDBInstances: {
          input: {
            type: "structure",
            members: {
              DBInstanceIdentifier: {},
              Filters: {
                shape: "S29"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBInstancesResult",
            type: "structure",
            members: {
              Marker: {},
              DBInstances: {
                type: "list",
                member: {
                  shape: "S1a",
                  locationName: "DBInstance"
                }
              }
            }
          }
        },
        DescribeDBSubnetGroups: {
          input: {
            type: "structure",
            members: {
              DBSubnetGroupName: {},
              Filters: {
                shape: "S29"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSubnetGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSubnetGroups: {
                type: "list",
                member: {
                  shape: "S1c",
                  locationName: "DBSubnetGroup"
                }
              }
            }
          }
        },
        DescribeEngineDefaultClusterParameters: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupFamily"
            ],
            members: {
              DBParameterGroupFamily: {},
              Filters: {
                shape: "S29"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEngineDefaultClusterParametersResult",
            type: "structure",
            members: {
              EngineDefaults: {
                type: "structure",
                members: {
                  DBParameterGroupFamily: {},
                  Marker: {},
                  Parameters: {
                    shape: "S2k"
                  }
                },
                wrapper: true
              }
            }
          }
        },
        DescribeEventCategories: {
          input: {
            type: "structure",
            members: {
              SourceType: {},
              Filters: {
                shape: "S29"
              }
            }
          },
          output: {
            resultWrapper: "DescribeEventCategoriesResult",
            type: "structure",
            members: {
              EventCategoriesMapList: {
                type: "list",
                member: {
                  locationName: "EventCategoriesMap",
                  type: "structure",
                  members: {
                    SourceType: {},
                    EventCategories: {
                      shape: "S6"
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        DescribeEventSubscriptions: {
          input: {
            type: "structure",
            members: {
              SubscriptionName: {},
              Filters: {
                shape: "S29"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventSubscriptionsResult",
            type: "structure",
            members: {
              Marker: {},
              EventSubscriptionsList: {
                type: "list",
                member: {
                  shape: "S4",
                  locationName: "EventSubscription"
                }
              }
            }
          }
        },
        DescribeEvents: {
          input: {
            type: "structure",
            members: {
              SourceIdentifier: {},
              SourceType: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Duration: {
                type: "integer"
              },
              EventCategories: {
                shape: "S6"
              },
              Filters: {
                shape: "S29"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventsResult",
            type: "structure",
            members: {
              Marker: {},
              Events: {
                type: "list",
                member: {
                  locationName: "Event",
                  type: "structure",
                  members: {
                    SourceIdentifier: {},
                    SourceType: {},
                    Message: {},
                    EventCategories: {
                      shape: "S6"
                    },
                    Date: {
                      type: "timestamp"
                    },
                    SourceArn: {}
                  }
                }
              }
            }
          }
        },
        DescribeGlobalClusters: {
          input: {
            type: "structure",
            members: {
              GlobalClusterIdentifier: {},
              Filters: {
                shape: "S29"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeGlobalClustersResult",
            type: "structure",
            members: {
              Marker: {},
              GlobalClusters: {
                type: "list",
                member: {
                  shape: "S1s",
                  locationName: "GlobalClusterMember"
                }
              }
            }
          }
        },
        DescribeOrderableDBInstanceOptions: {
          input: {
            type: "structure",
            required: [
              "Engine"
            ],
            members: {
              Engine: {},
              EngineVersion: {},
              DBInstanceClass: {},
              LicenseModel: {},
              Vpc: {
                type: "boolean"
              },
              Filters: {
                shape: "S29"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeOrderableDBInstanceOptionsResult",
            type: "structure",
            members: {
              OrderableDBInstanceOptions: {
                type: "list",
                member: {
                  locationName: "OrderableDBInstanceOption",
                  type: "structure",
                  members: {
                    Engine: {},
                    EngineVersion: {},
                    DBInstanceClass: {},
                    LicenseModel: {},
                    AvailabilityZones: {
                      type: "list",
                      member: {
                        shape: "S1f",
                        locationName: "AvailabilityZone"
                      }
                    },
                    Vpc: {
                      type: "boolean"
                    },
                    StorageType: {}
                  },
                  wrapper: true
                }
              },
              Marker: {}
            }
          }
        },
        DescribePendingMaintenanceActions: {
          input: {
            type: "structure",
            members: {
              ResourceIdentifier: {},
              Filters: {
                shape: "S29"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribePendingMaintenanceActionsResult",
            type: "structure",
            members: {
              PendingMaintenanceActions: {
                type: "list",
                member: {
                  shape: "Sd",
                  locationName: "ResourcePendingMaintenanceActions"
                }
              },
              Marker: {}
            }
          }
        },
        FailoverDBCluster: {
          input: {
            type: "structure",
            members: {
              DBClusterIdentifier: {},
              TargetDBInstanceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "FailoverDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "Sw"
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName"
            ],
            members: {
              ResourceName: {},
              Filters: {
                shape: "S29"
              }
            }
          },
          output: {
            resultWrapper: "ListTagsForResourceResult",
            type: "structure",
            members: {
              TagList: {
                shape: "S9"
              }
            }
          }
        },
        ModifyDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {},
              NewDBClusterIdentifier: {},
              ApplyImmediately: {
                type: "boolean"
              },
              BackupRetentionPeriod: {
                type: "integer"
              },
              DBClusterParameterGroupName: {},
              VpcSecurityGroupIds: {
                shape: "Ss"
              },
              Port: {
                type: "integer"
              },
              MasterUserPassword: {},
              PreferredBackupWindow: {},
              PreferredMaintenanceWindow: {},
              CloudwatchLogsExportConfiguration: {
                type: "structure",
                members: {
                  EnableLogTypes: {
                    shape: "St"
                  },
                  DisableLogTypes: {
                    shape: "St"
                  }
                }
              },
              EngineVersion: {},
              AllowMajorVersionUpgrade: {
                type: "boolean"
              },
              DeletionProtection: {
                type: "boolean"
              },
              StorageType: {}
            }
          },
          output: {
            resultWrapper: "ModifyDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "Sw"
              }
            }
          }
        },
        ModifyDBClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBClusterParameterGroupName",
              "Parameters"
            ],
            members: {
              DBClusterParameterGroupName: {},
              Parameters: {
                shape: "S2k"
              }
            }
          },
          output: {
            shape: "S4a",
            resultWrapper: "ModifyDBClusterParameterGroupResult"
          }
        },
        ModifyDBClusterSnapshotAttribute: {
          input: {
            type: "structure",
            required: [
              "DBClusterSnapshotIdentifier",
              "AttributeName"
            ],
            members: {
              DBClusterSnapshotIdentifier: {},
              AttributeName: {},
              ValuesToAdd: {
                shape: "S2s"
              },
              ValuesToRemove: {
                shape: "S2s"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBClusterSnapshotAttributeResult",
            type: "structure",
            members: {
              DBClusterSnapshotAttributesResult: {
                shape: "S2p"
              }
            }
          }
        },
        ModifyDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              DBInstanceClass: {},
              ApplyImmediately: {
                type: "boolean"
              },
              PreferredMaintenanceWindow: {},
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              NewDBInstanceIdentifier: {},
              CACertificateIdentifier: {},
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              PromotionTier: {
                type: "integer"
              },
              EnablePerformanceInsights: {
                type: "boolean"
              },
              PerformanceInsightsKMSKeyId: {},
              CertificateRotationRestart: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S1a"
              }
            }
          }
        },
        ModifyDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName",
              "SubnetIds"
            ],
            members: {
              DBSubnetGroupName: {},
              DBSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S1m"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBSubnetGroupResult",
            type: "structure",
            members: {
              DBSubnetGroup: {
                shape: "S1c"
              }
            }
          }
        },
        ModifyEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S6"
              },
              Enabled: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        ModifyGlobalCluster: {
          input: {
            type: "structure",
            required: [
              "GlobalClusterIdentifier"
            ],
            members: {
              GlobalClusterIdentifier: {},
              NewGlobalClusterIdentifier: {},
              DeletionProtection: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyGlobalClusterResult",
            type: "structure",
            members: {
              GlobalCluster: {
                shape: "S1s"
              }
            }
          }
        },
        RebootDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              ForceFailover: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "RebootDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S1a"
              }
            }
          }
        },
        RemoveFromGlobalCluster: {
          input: {
            type: "structure",
            required: [
              "GlobalClusterIdentifier",
              "DbClusterIdentifier"
            ],
            members: {
              GlobalClusterIdentifier: {},
              DbClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "RemoveFromGlobalClusterResult",
            type: "structure",
            members: {
              GlobalCluster: {
                shape: "S1s"
              }
            }
          }
        },
        RemoveSourceIdentifierFromSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SourceIdentifier"
            ],
            members: {
              SubscriptionName: {},
              SourceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "RemoveSourceIdentifierFromSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        RemoveTagsFromResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "TagKeys"
            ],
            members: {
              ResourceName: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ResetDBClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBClusterParameterGroupName"
            ],
            members: {
              DBClusterParameterGroupName: {},
              ResetAllParameters: {
                type: "boolean"
              },
              Parameters: {
                shape: "S2k"
              }
            }
          },
          output: {
            shape: "S4a",
            resultWrapper: "ResetDBClusterParameterGroupResult"
          }
        },
        RestoreDBClusterFromSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "SnapshotIdentifier",
              "Engine"
            ],
            members: {
              AvailabilityZones: {
                shape: "So"
              },
              DBClusterIdentifier: {},
              SnapshotIdentifier: {},
              Engine: {},
              EngineVersion: {},
              Port: {
                type: "integer"
              },
              DBSubnetGroupName: {},
              VpcSecurityGroupIds: {
                shape: "Ss"
              },
              Tags: {
                shape: "S9"
              },
              KmsKeyId: {},
              EnableCloudwatchLogsExports: {
                shape: "St"
              },
              DeletionProtection: {
                type: "boolean"
              },
              DBClusterParameterGroupName: {},
              StorageType: {}
            }
          },
          output: {
            resultWrapper: "RestoreDBClusterFromSnapshotResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "Sw"
              }
            }
          }
        },
        RestoreDBClusterToPointInTime: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "SourceDBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {},
              RestoreType: {},
              SourceDBClusterIdentifier: {},
              RestoreToTime: {
                type: "timestamp"
              },
              UseLatestRestorableTime: {
                type: "boolean"
              },
              Port: {
                type: "integer"
              },
              DBSubnetGroupName: {},
              VpcSecurityGroupIds: {
                shape: "Ss"
              },
              Tags: {
                shape: "S9"
              },
              KmsKeyId: {},
              EnableCloudwatchLogsExports: {
                shape: "St"
              },
              DeletionProtection: {
                type: "boolean"
              },
              StorageType: {}
            }
          },
          output: {
            resultWrapper: "RestoreDBClusterToPointInTimeResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "Sw"
              }
            }
          }
        },
        StartDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "StartDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "Sw"
              }
            }
          }
        },
        StopDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "StopDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "Sw"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            CustomerAwsId: {},
            CustSubscriptionId: {},
            SnsTopicArn: {},
            Status: {},
            SubscriptionCreationTime: {},
            SourceType: {},
            SourceIdsList: {
              shape: "S5"
            },
            EventCategoriesList: {
              shape: "S6"
            },
            Enabled: {
              type: "boolean"
            },
            EventSubscriptionArn: {}
          },
          wrapper: true
        },
        S5: {
          type: "list",
          member: {
            locationName: "SourceId"
          }
        },
        S6: {
          type: "list",
          member: {
            locationName: "EventCategory"
          }
        },
        S9: {
          type: "list",
          member: {
            locationName: "Tag",
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sd: {
          type: "structure",
          members: {
            ResourceIdentifier: {},
            PendingMaintenanceActionDetails: {
              type: "list",
              member: {
                locationName: "PendingMaintenanceAction",
                type: "structure",
                members: {
                  Action: {},
                  AutoAppliedAfterDate: {
                    type: "timestamp"
                  },
                  ForcedApplyDate: {
                    type: "timestamp"
                  },
                  OptInStatus: {},
                  CurrentApplyDate: {
                    type: "timestamp"
                  },
                  Description: {}
                }
              }
            }
          },
          wrapper: true
        },
        Sj: {
          type: "structure",
          members: {
            DBClusterParameterGroupName: {},
            DBParameterGroupFamily: {},
            Description: {},
            DBClusterParameterGroupArn: {}
          },
          wrapper: true
        },
        Sn: {
          type: "structure",
          members: {
            AvailabilityZones: {
              shape: "So"
            },
            DBClusterSnapshotIdentifier: {},
            DBClusterIdentifier: {},
            SnapshotCreateTime: {
              type: "timestamp"
            },
            Engine: {},
            Status: {},
            Port: {
              type: "integer"
            },
            VpcId: {},
            ClusterCreateTime: {
              type: "timestamp"
            },
            MasterUsername: {},
            EngineVersion: {},
            SnapshotType: {},
            PercentProgress: {
              type: "integer"
            },
            StorageEncrypted: {
              type: "boolean"
            },
            KmsKeyId: {},
            DBClusterSnapshotArn: {},
            SourceDBClusterSnapshotArn: {},
            StorageType: {}
          },
          wrapper: true
        },
        So: {
          type: "list",
          member: {
            locationName: "AvailabilityZone"
          }
        },
        Ss: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroupId"
          }
        },
        St: {
          type: "list",
          member: {}
        },
        Sw: {
          type: "structure",
          members: {
            AvailabilityZones: {
              shape: "So"
            },
            BackupRetentionPeriod: {
              type: "integer"
            },
            DBClusterIdentifier: {},
            DBClusterParameterGroup: {},
            DBSubnetGroup: {},
            Status: {},
            PercentProgress: {},
            EarliestRestorableTime: {
              type: "timestamp"
            },
            Endpoint: {},
            ReaderEndpoint: {},
            MultiAZ: {
              type: "boolean"
            },
            Engine: {},
            EngineVersion: {},
            LatestRestorableTime: {
              type: "timestamp"
            },
            Port: {
              type: "integer"
            },
            MasterUsername: {},
            PreferredBackupWindow: {},
            PreferredMaintenanceWindow: {},
            ReplicationSourceIdentifier: {},
            ReadReplicaIdentifiers: {
              type: "list",
              member: {
                locationName: "ReadReplicaIdentifier"
              }
            },
            DBClusterMembers: {
              type: "list",
              member: {
                locationName: "DBClusterMember",
                type: "structure",
                members: {
                  DBInstanceIdentifier: {},
                  IsClusterWriter: {
                    type: "boolean"
                  },
                  DBClusterParameterGroupStatus: {},
                  PromotionTier: {
                    type: "integer"
                  }
                },
                wrapper: true
              }
            },
            VpcSecurityGroups: {
              shape: "S10"
            },
            HostedZoneId: {},
            StorageEncrypted: {
              type: "boolean"
            },
            KmsKeyId: {},
            DbClusterResourceId: {},
            DBClusterArn: {},
            AssociatedRoles: {
              type: "list",
              member: {
                locationName: "DBClusterRole",
                type: "structure",
                members: {
                  RoleArn: {},
                  Status: {}
                }
              }
            },
            CloneGroupId: {},
            ClusterCreateTime: {
              type: "timestamp"
            },
            EnabledCloudwatchLogsExports: {
              shape: "St"
            },
            DeletionProtection: {
              type: "boolean"
            },
            StorageType: {}
          },
          wrapper: true
        },
        S10: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroupMembership",
            type: "structure",
            members: {
              VpcSecurityGroupId: {},
              Status: {}
            }
          }
        },
        S1a: {
          type: "structure",
          members: {
            DBInstanceIdentifier: {},
            DBInstanceClass: {},
            Engine: {},
            DBInstanceStatus: {},
            Endpoint: {
              type: "structure",
              members: {
                Address: {},
                Port: {
                  type: "integer"
                },
                HostedZoneId: {}
              }
            },
            InstanceCreateTime: {
              type: "timestamp"
            },
            PreferredBackupWindow: {},
            BackupRetentionPeriod: {
              type: "integer"
            },
            VpcSecurityGroups: {
              shape: "S10"
            },
            AvailabilityZone: {},
            DBSubnetGroup: {
              shape: "S1c"
            },
            PreferredMaintenanceWindow: {},
            PendingModifiedValues: {
              type: "structure",
              members: {
                DBInstanceClass: {},
                AllocatedStorage: {
                  type: "integer"
                },
                MasterUserPassword: {},
                Port: {
                  type: "integer"
                },
                BackupRetentionPeriod: {
                  type: "integer"
                },
                MultiAZ: {
                  type: "boolean"
                },
                EngineVersion: {},
                LicenseModel: {},
                Iops: {
                  type: "integer"
                },
                DBInstanceIdentifier: {},
                StorageType: {},
                CACertificateIdentifier: {},
                DBSubnetGroupName: {},
                PendingCloudwatchLogsExports: {
                  type: "structure",
                  members: {
                    LogTypesToEnable: {
                      shape: "St"
                    },
                    LogTypesToDisable: {
                      shape: "St"
                    }
                  }
                }
              }
            },
            LatestRestorableTime: {
              type: "timestamp"
            },
            EngineVersion: {},
            AutoMinorVersionUpgrade: {
              type: "boolean"
            },
            PubliclyAccessible: {
              type: "boolean"
            },
            StatusInfos: {
              type: "list",
              member: {
                locationName: "DBInstanceStatusInfo",
                type: "structure",
                members: {
                  StatusType: {},
                  Normal: {
                    type: "boolean"
                  },
                  Status: {},
                  Message: {}
                }
              }
            },
            DBClusterIdentifier: {},
            StorageEncrypted: {
              type: "boolean"
            },
            KmsKeyId: {},
            DbiResourceId: {},
            CACertificateIdentifier: {},
            CopyTagsToSnapshot: {
              type: "boolean"
            },
            PromotionTier: {
              type: "integer"
            },
            DBInstanceArn: {},
            EnabledCloudwatchLogsExports: {
              shape: "St"
            },
            CertificateDetails: {
              type: "structure",
              members: {
                CAIdentifier: {},
                ValidTill: {
                  type: "timestamp"
                }
              }
            },
            PerformanceInsightsEnabled: {
              type: "boolean"
            },
            PerformanceInsightsKMSKeyId: {}
          },
          wrapper: true
        },
        S1c: {
          type: "structure",
          members: {
            DBSubnetGroupName: {},
            DBSubnetGroupDescription: {},
            VpcId: {},
            SubnetGroupStatus: {},
            Subnets: {
              type: "list",
              member: {
                locationName: "Subnet",
                type: "structure",
                members: {
                  SubnetIdentifier: {},
                  SubnetAvailabilityZone: {
                    shape: "S1f"
                  },
                  SubnetStatus: {}
                }
              }
            },
            DBSubnetGroupArn: {}
          },
          wrapper: true
        },
        S1f: {
          type: "structure",
          members: {
            Name: {}
          },
          wrapper: true
        },
        S1m: {
          type: "list",
          member: {
            locationName: "SubnetIdentifier"
          }
        },
        S1s: {
          type: "structure",
          members: {
            GlobalClusterIdentifier: {},
            GlobalClusterResourceId: {},
            GlobalClusterArn: {},
            Status: {},
            Engine: {},
            EngineVersion: {},
            DatabaseName: {},
            StorageEncrypted: {
              type: "boolean"
            },
            DeletionProtection: {
              type: "boolean"
            },
            GlobalClusterMembers: {
              type: "list",
              member: {
                locationName: "GlobalClusterMember",
                type: "structure",
                members: {
                  DBClusterArn: {},
                  Readers: {
                    type: "list",
                    member: {}
                  },
                  IsWriter: {
                    type: "boolean"
                  }
                },
                wrapper: true
              }
            }
          },
          wrapper: true
        },
        S29: {
          type: "list",
          member: {
            locationName: "Filter",
            type: "structure",
            required: [
              "Name",
              "Values"
            ],
            members: {
              Name: {},
              Values: {
                type: "list",
                member: {
                  locationName: "Value"
                }
              }
            }
          }
        },
        S2k: {
          type: "list",
          member: {
            locationName: "Parameter",
            type: "structure",
            members: {
              ParameterName: {},
              ParameterValue: {},
              Description: {},
              Source: {},
              ApplyType: {},
              DataType: {},
              AllowedValues: {},
              IsModifiable: {
                type: "boolean"
              },
              MinimumEngineVersion: {},
              ApplyMethod: {}
            }
          }
        },
        S2p: {
          type: "structure",
          members: {
            DBClusterSnapshotIdentifier: {},
            DBClusterSnapshotAttributes: {
              type: "list",
              member: {
                locationName: "DBClusterSnapshotAttribute",
                type: "structure",
                members: {
                  AttributeName: {},
                  AttributeValues: {
                    shape: "S2s"
                  }
                }
              }
            }
          },
          wrapper: true
        },
        S2s: {
          type: "list",
          member: {
            locationName: "AttributeValue"
          }
        },
        S4a: {
          type: "structure",
          members: {
            DBClusterParameterGroupName: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/docdb-2014-10-31.paginators.json
var require_docdb_2014_10_31_paginators = __commonJS({
  "node_modules/aws-sdk/apis/docdb-2014-10-31.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeCertificates: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Certificates"
        },
        DescribeDBClusterParameterGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBClusterParameterGroups"
        },
        DescribeDBClusterParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Parameters"
        },
        DescribeDBClusterSnapshots: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBClusterSnapshots"
        },
        DescribeDBClusters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBClusters"
        },
        DescribeDBEngineVersions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBEngineVersions"
        },
        DescribeDBInstances: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBInstances"
        },
        DescribeDBSubnetGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBSubnetGroups"
        },
        DescribeEventSubscriptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "EventSubscriptionsList"
        },
        DescribeEvents: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Events"
        },
        DescribeGlobalClusters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "GlobalClusters"
        },
        DescribeOrderableDBInstanceOptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "OrderableDBInstanceOptions"
        },
        DescribePendingMaintenanceActions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "PendingMaintenanceActions"
        },
        ListTagsForResource: {
          result_key: "TagList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/docdb-2014-10-31.waiters2.json
var require_docdb_2014_10_31_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/docdb-2014-10-31.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        DBInstanceAvailable: {
          delay: 30,
          operation: "DescribeDBInstances",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "available",
              matcher: "pathAll",
              state: "success",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "deleted",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "deleting",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "failed",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "incompatible-restore",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "incompatible-parameters",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            }
          ]
        },
        DBInstanceDeleted: {
          delay: 30,
          operation: "DescribeDBInstances",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "deleted",
              matcher: "pathAll",
              state: "success",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "DBInstanceNotFound",
              matcher: "error",
              state: "success"
            },
            {
              expected: "creating",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "modifying",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "rebooting",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "resetting-master-credentials",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/docdb.js
var require_docdb2 = __commonJS({
  "node_modules/aws-sdk/clients/docdb.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["docdb"] = {};
    AWS2.DocDB = Service.defineService("docdb", ["2014-10-31"]);
    require_docdb();
    Object.defineProperty(apiLoader.services["docdb"], "2014-10-31", {
      get: function get() {
        var model = require_docdb_2014_10_31_min();
        model.paginators = require_docdb_2014_10_31_paginators().pagination;
        model.waiters = require_docdb_2014_10_31_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.DocDB;
  }
});

// node_modules/aws-sdk/apis/backup-2018-11-15.min.json
var require_backup_2018_11_15_min = __commonJS({
  "node_modules/aws-sdk/apis/backup-2018-11-15.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-11-15",
        endpointPrefix: "backup",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Backup",
        serviceId: "Backup",
        signatureVersion: "v4",
        uid: "backup-2018-11-15"
      },
      operations: {
        CancelLegalHold: {
          http: {
            method: "DELETE",
            requestUri: "/legal-holds/{legalHoldId}",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "LegalHoldId",
              "CancelDescription"
            ],
            members: {
              LegalHoldId: {
                location: "uri",
                locationName: "legalHoldId"
              },
              CancelDescription: {
                location: "querystring",
                locationName: "cancelDescription"
              },
              RetainRecordInDays: {
                location: "querystring",
                locationName: "retainRecordInDays",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        CreateBackupPlan: {
          http: {
            method: "PUT",
            requestUri: "/backup/plans/"
          },
          input: {
            type: "structure",
            required: [
              "BackupPlan"
            ],
            members: {
              BackupPlan: {
                shape: "S6"
              },
              BackupPlanTags: {
                shape: "Sg"
              },
              CreatorRequestId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BackupPlanId: {},
              BackupPlanArn: {},
              CreationDate: {
                type: "timestamp"
              },
              VersionId: {},
              AdvancedBackupSettings: {
                shape: "Sn"
              }
            }
          },
          idempotent: true
        },
        CreateBackupSelection: {
          http: {
            method: "PUT",
            requestUri: "/backup/plans/{backupPlanId}/selections/"
          },
          input: {
            type: "structure",
            required: [
              "BackupPlanId",
              "BackupSelection"
            ],
            members: {
              BackupPlanId: {
                location: "uri",
                locationName: "backupPlanId"
              },
              BackupSelection: {
                shape: "Sw"
              },
              CreatorRequestId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SelectionId: {},
              BackupPlanId: {},
              CreationDate: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        CreateBackupVault: {
          http: {
            method: "PUT",
            requestUri: "/backup-vaults/{backupVaultName}"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              },
              BackupVaultTags: {
                shape: "Sg"
              },
              EncryptionKeyArn: {},
              CreatorRequestId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BackupVaultName: {},
              BackupVaultArn: {},
              CreationDate: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        CreateFramework: {
          http: {
            requestUri: "/audit/frameworks"
          },
          input: {
            type: "structure",
            required: [
              "FrameworkName",
              "FrameworkControls"
            ],
            members: {
              FrameworkName: {},
              FrameworkDescription: {},
              FrameworkControls: {
                shape: "S1e"
              },
              IdempotencyToken: {
                idempotencyToken: true
              },
              FrameworkTags: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FrameworkName: {},
              FrameworkArn: {}
            }
          },
          idempotent: true
        },
        CreateLegalHold: {
          http: {
            requestUri: "/legal-holds/"
          },
          input: {
            type: "structure",
            required: [
              "Title",
              "Description"
            ],
            members: {
              Title: {},
              Description: {},
              IdempotencyToken: {},
              RecoveryPointSelection: {
                shape: "S1r"
              },
              Tags: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Title: {},
              Status: {},
              Description: {},
              LegalHoldId: {},
              LegalHoldArn: {},
              CreationDate: {
                type: "timestamp"
              },
              RecoveryPointSelection: {
                shape: "S1r"
              }
            }
          },
          idempotent: true
        },
        CreateLogicallyAirGappedBackupVault: {
          http: {
            method: "PUT",
            requestUri: "/logically-air-gapped-backup-vaults/{backupVaultName}"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName",
              "MinRetentionDays",
              "MaxRetentionDays"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              },
              BackupVaultTags: {
                shape: "Sg"
              },
              CreatorRequestId: {},
              MinRetentionDays: {
                type: "long"
              },
              MaxRetentionDays: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupVaultName: {},
              BackupVaultArn: {},
              CreationDate: {
                type: "timestamp"
              },
              VaultState: {}
            }
          },
          idempotent: true
        },
        CreateReportPlan: {
          http: {
            requestUri: "/audit/report-plans"
          },
          input: {
            type: "structure",
            required: [
              "ReportPlanName",
              "ReportDeliveryChannel",
              "ReportSetting"
            ],
            members: {
              ReportPlanName: {},
              ReportPlanDescription: {},
              ReportDeliveryChannel: {
                shape: "S23"
              },
              ReportSetting: {
                shape: "S25"
              },
              ReportPlanTags: {
                shape: "S1o"
              },
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReportPlanName: {},
              ReportPlanArn: {},
              CreationTime: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        CreateRestoreTestingPlan: {
          http: {
            method: "PUT",
            requestUri: "/restore-testing/plans",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "RestoreTestingPlan"
            ],
            members: {
              CreatorRequestId: {},
              RestoreTestingPlan: {
                type: "structure",
                required: [
                  "RecoveryPointSelection",
                  "RestoreTestingPlanName",
                  "ScheduleExpression"
                ],
                members: {
                  RecoveryPointSelection: {
                    shape: "S2c"
                  },
                  RestoreTestingPlanName: {},
                  ScheduleExpression: {},
                  ScheduleExpressionTimezone: {},
                  StartWindowHours: {
                    type: "integer"
                  }
                }
              },
              Tags: {
                shape: "S2g"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CreationTime",
              "RestoreTestingPlanArn",
              "RestoreTestingPlanName"
            ],
            members: {
              CreationTime: {
                type: "timestamp"
              },
              RestoreTestingPlanArn: {},
              RestoreTestingPlanName: {}
            }
          },
          idempotent: true
        },
        CreateRestoreTestingSelection: {
          http: {
            method: "PUT",
            requestUri: "/restore-testing/plans/{RestoreTestingPlanName}/selections",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "RestoreTestingPlanName",
              "RestoreTestingSelection"
            ],
            members: {
              CreatorRequestId: {},
              RestoreTestingPlanName: {
                location: "uri",
                locationName: "RestoreTestingPlanName"
              },
              RestoreTestingSelection: {
                type: "structure",
                required: [
                  "IamRoleArn",
                  "ProtectedResourceType",
                  "RestoreTestingSelectionName"
                ],
                members: {
                  IamRoleArn: {},
                  ProtectedResourceArns: {
                    shape: "S26"
                  },
                  ProtectedResourceConditions: {
                    shape: "S2l"
                  },
                  ProtectedResourceType: {},
                  RestoreMetadataOverrides: {
                    shape: "S2g"
                  },
                  RestoreTestingSelectionName: {},
                  ValidationWindowHours: {
                    type: "integer"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CreationTime",
              "RestoreTestingPlanArn",
              "RestoreTestingPlanName",
              "RestoreTestingSelectionName"
            ],
            members: {
              CreationTime: {
                type: "timestamp"
              },
              RestoreTestingPlanArn: {},
              RestoreTestingPlanName: {},
              RestoreTestingSelectionName: {}
            }
          },
          idempotent: true
        },
        DeleteBackupPlan: {
          http: {
            method: "DELETE",
            requestUri: "/backup/plans/{backupPlanId}"
          },
          input: {
            type: "structure",
            required: [
              "BackupPlanId"
            ],
            members: {
              BackupPlanId: {
                location: "uri",
                locationName: "backupPlanId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupPlanId: {},
              BackupPlanArn: {},
              DeletionDate: {
                type: "timestamp"
              },
              VersionId: {}
            }
          }
        },
        DeleteBackupSelection: {
          http: {
            method: "DELETE",
            requestUri: "/backup/plans/{backupPlanId}/selections/{selectionId}"
          },
          input: {
            type: "structure",
            required: [
              "BackupPlanId",
              "SelectionId"
            ],
            members: {
              BackupPlanId: {
                location: "uri",
                locationName: "backupPlanId"
              },
              SelectionId: {
                location: "uri",
                locationName: "selectionId"
              }
            }
          }
        },
        DeleteBackupVault: {
          http: {
            method: "DELETE",
            requestUri: "/backup-vaults/{backupVaultName}"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              }
            }
          }
        },
        DeleteBackupVaultAccessPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/backup-vaults/{backupVaultName}/access-policy"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              }
            }
          },
          idempotent: true
        },
        DeleteBackupVaultLockConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/backup-vaults/{backupVaultName}/vault-lock"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              }
            }
          },
          idempotent: true
        },
        DeleteBackupVaultNotifications: {
          http: {
            method: "DELETE",
            requestUri: "/backup-vaults/{backupVaultName}/notification-configuration"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              }
            }
          },
          idempotent: true
        },
        DeleteFramework: {
          http: {
            method: "DELETE",
            requestUri: "/audit/frameworks/{frameworkName}"
          },
          input: {
            type: "structure",
            required: [
              "FrameworkName"
            ],
            members: {
              FrameworkName: {
                location: "uri",
                locationName: "frameworkName"
              }
            }
          }
        },
        DeleteRecoveryPoint: {
          http: {
            method: "DELETE",
            requestUri: "/backup-vaults/{backupVaultName}/recovery-points/{recoveryPointArn}"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName",
              "RecoveryPointArn"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              },
              RecoveryPointArn: {
                location: "uri",
                locationName: "recoveryPointArn"
              }
            }
          },
          idempotent: true
        },
        DeleteReportPlan: {
          http: {
            method: "DELETE",
            requestUri: "/audit/report-plans/{reportPlanName}"
          },
          input: {
            type: "structure",
            required: [
              "ReportPlanName"
            ],
            members: {
              ReportPlanName: {
                location: "uri",
                locationName: "reportPlanName"
              }
            }
          },
          idempotent: true
        },
        DeleteRestoreTestingPlan: {
          http: {
            method: "DELETE",
            requestUri: "/restore-testing/plans/{RestoreTestingPlanName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "RestoreTestingPlanName"
            ],
            members: {
              RestoreTestingPlanName: {
                location: "uri",
                locationName: "RestoreTestingPlanName"
              }
            }
          },
          idempotent: true
        },
        DeleteRestoreTestingSelection: {
          http: {
            method: "DELETE",
            requestUri: "/restore-testing/plans/{RestoreTestingPlanName}/selections/{RestoreTestingSelectionName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "RestoreTestingPlanName",
              "RestoreTestingSelectionName"
            ],
            members: {
              RestoreTestingPlanName: {
                location: "uri",
                locationName: "RestoreTestingPlanName"
              },
              RestoreTestingSelectionName: {
                location: "uri",
                locationName: "RestoreTestingSelectionName"
              }
            }
          },
          idempotent: true
        },
        DescribeBackupJob: {
          http: {
            method: "GET",
            requestUri: "/backup-jobs/{backupJobId}"
          },
          input: {
            type: "structure",
            required: [
              "BackupJobId"
            ],
            members: {
              BackupJobId: {
                location: "uri",
                locationName: "backupJobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccountId: {},
              BackupJobId: {},
              BackupVaultName: {},
              BackupVaultArn: {},
              RecoveryPointArn: {},
              ResourceArn: {},
              CreationDate: {
                type: "timestamp"
              },
              CompletionDate: {
                type: "timestamp"
              },
              State: {},
              StatusMessage: {},
              PercentDone: {},
              BackupSizeInBytes: {
                type: "long"
              },
              IamRoleArn: {},
              CreatedBy: {
                shape: "S35"
              },
              ResourceType: {},
              BytesTransferred: {
                type: "long"
              },
              ExpectedCompletionDate: {
                type: "timestamp"
              },
              StartBy: {
                type: "timestamp"
              },
              BackupOptions: {
                shape: "Sq"
              },
              BackupType: {},
              ParentJobId: {},
              IsParent: {
                type: "boolean"
              },
              NumberOfChildJobs: {
                type: "long"
              },
              ChildJobsInState: {
                type: "map",
                key: {},
                value: {
                  type: "long"
                }
              },
              ResourceName: {},
              InitiationDate: {
                type: "timestamp"
              },
              MessageCategory: {}
            }
          },
          idempotent: true
        },
        DescribeBackupVault: {
          http: {
            method: "GET",
            requestUri: "/backup-vaults/{backupVaultName}"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              },
              BackupVaultAccountId: {
                location: "querystring",
                locationName: "backupVaultAccountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupVaultName: {},
              BackupVaultArn: {},
              VaultType: {},
              EncryptionKeyArn: {},
              CreationDate: {
                type: "timestamp"
              },
              CreatorRequestId: {},
              NumberOfRecoveryPoints: {
                type: "long"
              },
              Locked: {
                type: "boolean"
              },
              MinRetentionDays: {
                type: "long"
              },
              MaxRetentionDays: {
                type: "long"
              },
              LockDate: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        DescribeCopyJob: {
          http: {
            method: "GET",
            requestUri: "/copy-jobs/{copyJobId}"
          },
          input: {
            type: "structure",
            required: [
              "CopyJobId"
            ],
            members: {
              CopyJobId: {
                location: "uri",
                locationName: "copyJobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CopyJob: {
                shape: "S3e"
              }
            }
          },
          idempotent: true
        },
        DescribeFramework: {
          http: {
            method: "GET",
            requestUri: "/audit/frameworks/{frameworkName}"
          },
          input: {
            type: "structure",
            required: [
              "FrameworkName"
            ],
            members: {
              FrameworkName: {
                location: "uri",
                locationName: "frameworkName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FrameworkName: {},
              FrameworkArn: {},
              FrameworkDescription: {},
              FrameworkControls: {
                shape: "S1e"
              },
              CreationTime: {
                type: "timestamp"
              },
              DeploymentStatus: {},
              FrameworkStatus: {},
              IdempotencyToken: {}
            }
          }
        },
        DescribeGlobalSettings: {
          http: {
            method: "GET",
            requestUri: "/global-settings"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              GlobalSettings: {
                shape: "S3l"
              },
              LastUpdateTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeProtectedResource: {
          http: {
            method: "GET",
            requestUri: "/resources/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceArn: {},
              ResourceType: {},
              LastBackupTime: {
                type: "timestamp"
              },
              ResourceName: {},
              LastBackupVaultArn: {},
              LastRecoveryPointArn: {},
              LatestRestoreExecutionTimeMinutes: {
                type: "long"
              },
              LatestRestoreJobCreationDate: {
                type: "timestamp"
              },
              LatestRestoreRecoveryPointCreationDate: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        DescribeRecoveryPoint: {
          http: {
            method: "GET",
            requestUri: "/backup-vaults/{backupVaultName}/recovery-points/{recoveryPointArn}"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName",
              "RecoveryPointArn"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              },
              RecoveryPointArn: {
                location: "uri",
                locationName: "recoveryPointArn"
              },
              BackupVaultAccountId: {
                location: "querystring",
                locationName: "backupVaultAccountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RecoveryPointArn: {},
              BackupVaultName: {},
              BackupVaultArn: {},
              SourceBackupVaultArn: {},
              ResourceArn: {},
              ResourceType: {},
              CreatedBy: {
                shape: "S35"
              },
              IamRoleArn: {},
              Status: {},
              StatusMessage: {},
              CreationDate: {
                type: "timestamp"
              },
              CompletionDate: {
                type: "timestamp"
              },
              BackupSizeInBytes: {
                type: "long"
              },
              CalculatedLifecycle: {
                shape: "S3t"
              },
              Lifecycle: {
                shape: "Se"
              },
              EncryptionKeyArn: {},
              IsEncrypted: {
                type: "boolean"
              },
              StorageClass: {},
              LastRestoreTime: {
                type: "timestamp"
              },
              ParentRecoveryPointArn: {},
              CompositeMemberIdentifier: {},
              IsParent: {
                type: "boolean"
              },
              ResourceName: {},
              VaultType: {}
            }
          },
          idempotent: true
        },
        DescribeRegionSettings: {
          http: {
            method: "GET",
            requestUri: "/account-settings"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              ResourceTypeOptInPreference: {
                shape: "S3x"
              },
              ResourceTypeManagementPreference: {
                shape: "S3z"
              }
            }
          }
        },
        DescribeReportJob: {
          http: {
            method: "GET",
            requestUri: "/audit/report-jobs/{reportJobId}"
          },
          input: {
            type: "structure",
            required: [
              "ReportJobId"
            ],
            members: {
              ReportJobId: {
                location: "uri",
                locationName: "reportJobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReportJob: {
                shape: "S43"
              }
            }
          }
        },
        DescribeReportPlan: {
          http: {
            method: "GET",
            requestUri: "/audit/report-plans/{reportPlanName}"
          },
          input: {
            type: "structure",
            required: [
              "ReportPlanName"
            ],
            members: {
              ReportPlanName: {
                location: "uri",
                locationName: "reportPlanName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReportPlan: {
                shape: "S47"
              }
            }
          }
        },
        DescribeRestoreJob: {
          http: {
            method: "GET",
            requestUri: "/restore-jobs/{restoreJobId}"
          },
          input: {
            type: "structure",
            required: [
              "RestoreJobId"
            ],
            members: {
              RestoreJobId: {
                location: "uri",
                locationName: "restoreJobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccountId: {},
              RestoreJobId: {},
              RecoveryPointArn: {},
              CreationDate: {
                type: "timestamp"
              },
              CompletionDate: {
                type: "timestamp"
              },
              Status: {},
              StatusMessage: {},
              PercentDone: {},
              BackupSizeInBytes: {
                type: "long"
              },
              IamRoleArn: {},
              ExpectedCompletionTimeMinutes: {
                type: "long"
              },
              CreatedResourceArn: {},
              ResourceType: {},
              RecoveryPointCreationDate: {
                type: "timestamp"
              },
              CreatedBy: {
                shape: "S4c"
              },
              ValidationStatus: {},
              ValidationStatusMessage: {},
              DeletionStatus: {},
              DeletionStatusMessage: {}
            }
          },
          idempotent: true
        },
        DisassociateRecoveryPoint: {
          http: {
            requestUri: "/backup-vaults/{backupVaultName}/recovery-points/{recoveryPointArn}/disassociate"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName",
              "RecoveryPointArn"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              },
              RecoveryPointArn: {
                location: "uri",
                locationName: "recoveryPointArn"
              }
            }
          }
        },
        DisassociateRecoveryPointFromParent: {
          http: {
            method: "DELETE",
            requestUri: "/backup-vaults/{backupVaultName}/recovery-points/{recoveryPointArn}/parentAssociation",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName",
              "RecoveryPointArn"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              },
              RecoveryPointArn: {
                location: "uri",
                locationName: "recoveryPointArn"
              }
            }
          }
        },
        ExportBackupPlanTemplate: {
          http: {
            method: "GET",
            requestUri: "/backup/plans/{backupPlanId}/toTemplate/"
          },
          input: {
            type: "structure",
            required: [
              "BackupPlanId"
            ],
            members: {
              BackupPlanId: {
                location: "uri",
                locationName: "backupPlanId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupPlanTemplateJson: {}
            }
          }
        },
        GetBackupPlan: {
          http: {
            method: "GET",
            requestUri: "/backup/plans/{backupPlanId}/"
          },
          input: {
            type: "structure",
            required: [
              "BackupPlanId"
            ],
            members: {
              BackupPlanId: {
                location: "uri",
                locationName: "backupPlanId"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupPlan: {
                shape: "S4l"
              },
              BackupPlanId: {},
              BackupPlanArn: {},
              VersionId: {},
              CreatorRequestId: {},
              CreationDate: {
                type: "timestamp"
              },
              DeletionDate: {
                type: "timestamp"
              },
              LastExecutionDate: {
                type: "timestamp"
              },
              AdvancedBackupSettings: {
                shape: "Sn"
              }
            }
          },
          idempotent: true
        },
        GetBackupPlanFromJSON: {
          http: {
            requestUri: "/backup/template/json/toPlan"
          },
          input: {
            type: "structure",
            required: [
              "BackupPlanTemplateJson"
            ],
            members: {
              BackupPlanTemplateJson: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BackupPlan: {
                shape: "S4l"
              }
            }
          }
        },
        GetBackupPlanFromTemplate: {
          http: {
            method: "GET",
            requestUri: "/backup/template/plans/{templateId}/toPlan"
          },
          input: {
            type: "structure",
            required: [
              "BackupPlanTemplateId"
            ],
            members: {
              BackupPlanTemplateId: {
                location: "uri",
                locationName: "templateId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupPlanDocument: {
                shape: "S4l"
              }
            }
          }
        },
        GetBackupSelection: {
          http: {
            method: "GET",
            requestUri: "/backup/plans/{backupPlanId}/selections/{selectionId}"
          },
          input: {
            type: "structure",
            required: [
              "BackupPlanId",
              "SelectionId"
            ],
            members: {
              BackupPlanId: {
                location: "uri",
                locationName: "backupPlanId"
              },
              SelectionId: {
                location: "uri",
                locationName: "selectionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupSelection: {
                shape: "Sw"
              },
              SelectionId: {},
              BackupPlanId: {},
              CreationDate: {
                type: "timestamp"
              },
              CreatorRequestId: {}
            }
          },
          idempotent: true
        },
        GetBackupVaultAccessPolicy: {
          http: {
            method: "GET",
            requestUri: "/backup-vaults/{backupVaultName}/access-policy"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupVaultName: {},
              BackupVaultArn: {},
              Policy: {}
            }
          },
          idempotent: true
        },
        GetBackupVaultNotifications: {
          http: {
            method: "GET",
            requestUri: "/backup-vaults/{backupVaultName}/notification-configuration"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupVaultName: {},
              BackupVaultArn: {},
              SNSTopicArn: {},
              BackupVaultEvents: {
                shape: "S4z"
              }
            }
          },
          idempotent: true
        },
        GetLegalHold: {
          http: {
            method: "GET",
            requestUri: "/legal-holds/{legalHoldId}/"
          },
          input: {
            type: "structure",
            required: [
              "LegalHoldId"
            ],
            members: {
              LegalHoldId: {
                location: "uri",
                locationName: "legalHoldId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Title: {},
              Status: {},
              Description: {},
              CancelDescription: {},
              LegalHoldId: {},
              LegalHoldArn: {},
              CreationDate: {
                type: "timestamp"
              },
              CancellationDate: {
                type: "timestamp"
              },
              RetainRecordUntil: {
                type: "timestamp"
              },
              RecoveryPointSelection: {
                shape: "S1r"
              }
            }
          },
          idempotent: true
        },
        GetRecoveryPointRestoreMetadata: {
          http: {
            method: "GET",
            requestUri: "/backup-vaults/{backupVaultName}/recovery-points/{recoveryPointArn}/restore-metadata"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName",
              "RecoveryPointArn"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              },
              RecoveryPointArn: {
                location: "uri",
                locationName: "recoveryPointArn"
              },
              BackupVaultAccountId: {
                location: "querystring",
                locationName: "backupVaultAccountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupVaultArn: {},
              RecoveryPointArn: {},
              RestoreMetadata: {
                shape: "S55"
              },
              ResourceType: {}
            }
          },
          idempotent: true
        },
        GetRestoreJobMetadata: {
          http: {
            method: "GET",
            requestUri: "/restore-jobs/{restoreJobId}/metadata"
          },
          input: {
            type: "structure",
            required: [
              "RestoreJobId"
            ],
            members: {
              RestoreJobId: {
                location: "uri",
                locationName: "restoreJobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RestoreJobId: {},
              Metadata: {
                shape: "S55"
              }
            }
          }
        },
        GetRestoreTestingInferredMetadata: {
          http: {
            method: "GET",
            requestUri: "/restore-testing/inferred-metadata",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName",
              "RecoveryPointArn"
            ],
            members: {
              BackupVaultAccountId: {
                location: "querystring",
                locationName: "BackupVaultAccountId"
              },
              BackupVaultName: {
                location: "querystring",
                locationName: "BackupVaultName"
              },
              RecoveryPointArn: {
                location: "querystring",
                locationName: "RecoveryPointArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "InferredMetadata"
            ],
            members: {
              InferredMetadata: {
                shape: "S1o"
              }
            }
          }
        },
        GetRestoreTestingPlan: {
          http: {
            method: "GET",
            requestUri: "/restore-testing/plans/{RestoreTestingPlanName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "RestoreTestingPlanName"
            ],
            members: {
              RestoreTestingPlanName: {
                location: "uri",
                locationName: "RestoreTestingPlanName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "RestoreTestingPlan"
            ],
            members: {
              RestoreTestingPlan: {
                type: "structure",
                required: [
                  "CreationTime",
                  "RecoveryPointSelection",
                  "RestoreTestingPlanArn",
                  "RestoreTestingPlanName",
                  "ScheduleExpression"
                ],
                members: {
                  CreationTime: {
                    type: "timestamp"
                  },
                  CreatorRequestId: {},
                  LastExecutionTime: {
                    type: "timestamp"
                  },
                  LastUpdateTime: {
                    type: "timestamp"
                  },
                  RecoveryPointSelection: {
                    shape: "S2c"
                  },
                  RestoreTestingPlanArn: {},
                  RestoreTestingPlanName: {},
                  ScheduleExpression: {},
                  ScheduleExpressionTimezone: {},
                  StartWindowHours: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        GetRestoreTestingSelection: {
          http: {
            method: "GET",
            requestUri: "/restore-testing/plans/{RestoreTestingPlanName}/selections/{RestoreTestingSelectionName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "RestoreTestingPlanName",
              "RestoreTestingSelectionName"
            ],
            members: {
              RestoreTestingPlanName: {
                location: "uri",
                locationName: "RestoreTestingPlanName"
              },
              RestoreTestingSelectionName: {
                location: "uri",
                locationName: "RestoreTestingSelectionName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "RestoreTestingSelection"
            ],
            members: {
              RestoreTestingSelection: {
                type: "structure",
                required: [
                  "CreationTime",
                  "IamRoleArn",
                  "ProtectedResourceType",
                  "RestoreTestingPlanName",
                  "RestoreTestingSelectionName"
                ],
                members: {
                  CreationTime: {
                    type: "timestamp"
                  },
                  CreatorRequestId: {},
                  IamRoleArn: {},
                  ProtectedResourceArns: {
                    shape: "S26"
                  },
                  ProtectedResourceConditions: {
                    shape: "S2l"
                  },
                  ProtectedResourceType: {},
                  RestoreMetadataOverrides: {
                    shape: "S2g"
                  },
                  RestoreTestingPlanName: {},
                  RestoreTestingSelectionName: {},
                  ValidationWindowHours: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        GetSupportedResourceTypes: {
          http: {
            method: "GET",
            requestUri: "/supported-resource-types"
          },
          output: {
            type: "structure",
            members: {
              ResourceTypes: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ListBackupJobSummaries: {
          http: {
            method: "GET",
            requestUri: "/audit/backup-job-summaries"
          },
          input: {
            type: "structure",
            members: {
              AccountId: {
                location: "querystring",
                locationName: "AccountId"
              },
              State: {
                location: "querystring",
                locationName: "State"
              },
              ResourceType: {
                location: "querystring",
                locationName: "ResourceType"
              },
              MessageCategory: {
                location: "querystring",
                locationName: "MessageCategory"
              },
              AggregationPeriod: {
                location: "querystring",
                locationName: "AggregationPeriod"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Region: {},
                    AccountId: {},
                    State: {},
                    ResourceType: {},
                    MessageCategory: {},
                    Count: {
                      type: "integer"
                    },
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              AggregationPeriod: {},
              NextToken: {}
            }
          }
        },
        ListBackupJobs: {
          http: {
            method: "GET",
            requestUri: "/backup-jobs/"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              ByResourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              ByState: {
                location: "querystring",
                locationName: "state"
              },
              ByBackupVaultName: {
                location: "querystring",
                locationName: "backupVaultName"
              },
              ByCreatedBefore: {
                location: "querystring",
                locationName: "createdBefore",
                type: "timestamp"
              },
              ByCreatedAfter: {
                location: "querystring",
                locationName: "createdAfter",
                type: "timestamp"
              },
              ByResourceType: {
                location: "querystring",
                locationName: "resourceType"
              },
              ByAccountId: {
                location: "querystring",
                locationName: "accountId"
              },
              ByCompleteAfter: {
                location: "querystring",
                locationName: "completeAfter",
                type: "timestamp"
              },
              ByCompleteBefore: {
                location: "querystring",
                locationName: "completeBefore",
                type: "timestamp"
              },
              ByParentJobId: {
                location: "querystring",
                locationName: "parentJobId"
              },
              ByMessageCategory: {
                location: "querystring",
                locationName: "messageCategory"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupJobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AccountId: {},
                    BackupJobId: {},
                    BackupVaultName: {},
                    BackupVaultArn: {},
                    RecoveryPointArn: {},
                    ResourceArn: {},
                    CreationDate: {
                      type: "timestamp"
                    },
                    CompletionDate: {
                      type: "timestamp"
                    },
                    State: {},
                    StatusMessage: {},
                    PercentDone: {},
                    BackupSizeInBytes: {
                      type: "long"
                    },
                    IamRoleArn: {},
                    CreatedBy: {
                      shape: "S35"
                    },
                    ExpectedCompletionDate: {
                      type: "timestamp"
                    },
                    StartBy: {
                      type: "timestamp"
                    },
                    ResourceType: {},
                    BytesTransferred: {
                      type: "long"
                    },
                    BackupOptions: {
                      shape: "Sq"
                    },
                    BackupType: {},
                    ParentJobId: {},
                    IsParent: {
                      type: "boolean"
                    },
                    ResourceName: {},
                    InitiationDate: {
                      type: "timestamp"
                    },
                    MessageCategory: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListBackupPlanTemplates: {
          http: {
            method: "GET",
            requestUri: "/backup/template/plans"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              BackupPlanTemplatesList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    BackupPlanTemplateId: {},
                    BackupPlanTemplateName: {}
                  }
                }
              }
            }
          }
        },
        ListBackupPlanVersions: {
          http: {
            method: "GET",
            requestUri: "/backup/plans/{backupPlanId}/versions/"
          },
          input: {
            type: "structure",
            required: [
              "BackupPlanId"
            ],
            members: {
              BackupPlanId: {
                location: "uri",
                locationName: "backupPlanId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              BackupPlanVersionsList: {
                type: "list",
                member: {
                  shape: "S64"
                }
              }
            }
          },
          idempotent: true
        },
        ListBackupPlans: {
          http: {
            method: "GET",
            requestUri: "/backup/plans/"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              IncludeDeleted: {
                location: "querystring",
                locationName: "includeDeleted",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              BackupPlansList: {
                type: "list",
                member: {
                  shape: "S64"
                }
              }
            }
          },
          idempotent: true
        },
        ListBackupSelections: {
          http: {
            method: "GET",
            requestUri: "/backup/plans/{backupPlanId}/selections/"
          },
          input: {
            type: "structure",
            required: [
              "BackupPlanId"
            ],
            members: {
              BackupPlanId: {
                location: "uri",
                locationName: "backupPlanId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              BackupSelectionsList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SelectionId: {},
                    SelectionName: {},
                    BackupPlanId: {},
                    CreationDate: {
                      type: "timestamp"
                    },
                    CreatorRequestId: {},
                    IamRoleArn: {}
                  }
                }
              }
            }
          },
          idempotent: true
        },
        ListBackupVaults: {
          http: {
            method: "GET",
            requestUri: "/backup-vaults/"
          },
          input: {
            type: "structure",
            members: {
              ByVaultType: {
                location: "querystring",
                locationName: "vaultType"
              },
              ByShared: {
                location: "querystring",
                locationName: "shared",
                type: "boolean"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupVaultList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    BackupVaultName: {},
                    BackupVaultArn: {},
                    CreationDate: {
                      type: "timestamp"
                    },
                    EncryptionKeyArn: {},
                    CreatorRequestId: {},
                    NumberOfRecoveryPoints: {
                      type: "long"
                    },
                    Locked: {
                      type: "boolean"
                    },
                    MinRetentionDays: {
                      type: "long"
                    },
                    MaxRetentionDays: {
                      type: "long"
                    },
                    LockDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListCopyJobSummaries: {
          http: {
            method: "GET",
            requestUri: "/audit/copy-job-summaries"
          },
          input: {
            type: "structure",
            members: {
              AccountId: {
                location: "querystring",
                locationName: "AccountId"
              },
              State: {
                location: "querystring",
                locationName: "State"
              },
              ResourceType: {
                location: "querystring",
                locationName: "ResourceType"
              },
              MessageCategory: {
                location: "querystring",
                locationName: "MessageCategory"
              },
              AggregationPeriod: {
                location: "querystring",
                locationName: "AggregationPeriod"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CopyJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Region: {},
                    AccountId: {},
                    State: {},
                    ResourceType: {},
                    MessageCategory: {},
                    Count: {
                      type: "integer"
                    },
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              AggregationPeriod: {},
              NextToken: {}
            }
          }
        },
        ListCopyJobs: {
          http: {
            method: "GET",
            requestUri: "/copy-jobs/"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              ByResourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              ByState: {
                location: "querystring",
                locationName: "state"
              },
              ByCreatedBefore: {
                location: "querystring",
                locationName: "createdBefore",
                type: "timestamp"
              },
              ByCreatedAfter: {
                location: "querystring",
                locationName: "createdAfter",
                type: "timestamp"
              },
              ByResourceType: {
                location: "querystring",
                locationName: "resourceType"
              },
              ByDestinationVaultArn: {
                location: "querystring",
                locationName: "destinationVaultArn"
              },
              ByAccountId: {
                location: "querystring",
                locationName: "accountId"
              },
              ByCompleteBefore: {
                location: "querystring",
                locationName: "completeBefore",
                type: "timestamp"
              },
              ByCompleteAfter: {
                location: "querystring",
                locationName: "completeAfter",
                type: "timestamp"
              },
              ByParentJobId: {
                location: "querystring",
                locationName: "parentJobId"
              },
              ByMessageCategory: {
                location: "querystring",
                locationName: "messageCategory"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CopyJobs: {
                type: "list",
                member: {
                  shape: "S3e"
                }
              },
              NextToken: {}
            }
          }
        },
        ListFrameworks: {
          http: {
            method: "GET",
            requestUri: "/audit/frameworks"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Frameworks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FrameworkName: {},
                    FrameworkArn: {},
                    FrameworkDescription: {},
                    NumberOfControls: {
                      type: "integer"
                    },
                    CreationTime: {
                      type: "timestamp"
                    },
                    DeploymentStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListLegalHolds: {
          http: {
            method: "GET",
            requestUri: "/legal-holds/"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              LegalHolds: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Title: {},
                    Status: {},
                    Description: {},
                    LegalHoldId: {},
                    LegalHoldArn: {},
                    CreationDate: {
                      type: "timestamp"
                    },
                    CancellationDate: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          },
          idempotent: true
        },
        ListProtectedResources: {
          http: {
            method: "GET",
            requestUri: "/resources/"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Results: {
                shape: "S6z"
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListProtectedResourcesByBackupVault: {
          http: {
            method: "GET",
            requestUri: "/backup-vaults/{backupVaultName}/resources/"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              },
              BackupVaultAccountId: {
                location: "querystring",
                locationName: "backupVaultAccountId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Results: {
                shape: "S6z"
              },
              NextToken: {}
            }
          }
        },
        ListRecoveryPointsByBackupVault: {
          http: {
            method: "GET",
            requestUri: "/backup-vaults/{backupVaultName}/recovery-points/"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              },
              BackupVaultAccountId: {
                location: "querystring",
                locationName: "backupVaultAccountId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              ByResourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              ByResourceType: {
                location: "querystring",
                locationName: "resourceType"
              },
              ByBackupPlanId: {
                location: "querystring",
                locationName: "backupPlanId"
              },
              ByCreatedBefore: {
                location: "querystring",
                locationName: "createdBefore",
                type: "timestamp"
              },
              ByCreatedAfter: {
                location: "querystring",
                locationName: "createdAfter",
                type: "timestamp"
              },
              ByParentRecoveryPointArn: {
                location: "querystring",
                locationName: "parentRecoveryPointArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              RecoveryPoints: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RecoveryPointArn: {},
                    BackupVaultName: {},
                    BackupVaultArn: {},
                    SourceBackupVaultArn: {},
                    ResourceArn: {},
                    ResourceType: {},
                    CreatedBy: {
                      shape: "S35"
                    },
                    IamRoleArn: {},
                    Status: {},
                    StatusMessage: {},
                    CreationDate: {
                      type: "timestamp"
                    },
                    CompletionDate: {
                      type: "timestamp"
                    },
                    BackupSizeInBytes: {
                      type: "long"
                    },
                    CalculatedLifecycle: {
                      shape: "S3t"
                    },
                    Lifecycle: {
                      shape: "Se"
                    },
                    EncryptionKeyArn: {},
                    IsEncrypted: {
                      type: "boolean"
                    },
                    LastRestoreTime: {
                      type: "timestamp"
                    },
                    ParentRecoveryPointArn: {},
                    CompositeMemberIdentifier: {},
                    IsParent: {
                      type: "boolean"
                    },
                    ResourceName: {},
                    VaultType: {}
                  }
                }
              }
            }
          },
          idempotent: true
        },
        ListRecoveryPointsByLegalHold: {
          http: {
            method: "GET",
            requestUri: "/legal-holds/{legalHoldId}/recovery-points"
          },
          input: {
            type: "structure",
            required: [
              "LegalHoldId"
            ],
            members: {
              LegalHoldId: {
                location: "uri",
                locationName: "legalHoldId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RecoveryPoints: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RecoveryPointArn: {},
                    ResourceArn: {},
                    ResourceType: {},
                    BackupVaultName: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListRecoveryPointsByResource: {
          http: {
            method: "GET",
            requestUri: "/resources/{resourceArn}/recovery-points/"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              RecoveryPoints: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RecoveryPointArn: {},
                    CreationDate: {
                      type: "timestamp"
                    },
                    Status: {},
                    StatusMessage: {},
                    EncryptionKeyArn: {},
                    BackupSizeBytes: {
                      type: "long"
                    },
                    BackupVaultName: {},
                    IsParent: {
                      type: "boolean"
                    },
                    ParentRecoveryPointArn: {},
                    ResourceName: {}
                  }
                }
              }
            }
          },
          idempotent: true
        },
        ListReportJobs: {
          http: {
            method: "GET",
            requestUri: "/audit/report-jobs"
          },
          input: {
            type: "structure",
            members: {
              ByReportPlanName: {
                location: "querystring",
                locationName: "ReportPlanName"
              },
              ByCreationBefore: {
                location: "querystring",
                locationName: "CreationBefore",
                type: "timestamp"
              },
              ByCreationAfter: {
                location: "querystring",
                locationName: "CreationAfter",
                type: "timestamp"
              },
              ByStatus: {
                location: "querystring",
                locationName: "Status"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReportJobs: {
                type: "list",
                member: {
                  shape: "S43"
                }
              },
              NextToken: {}
            }
          }
        },
        ListReportPlans: {
          http: {
            method: "GET",
            requestUri: "/audit/report-plans"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReportPlans: {
                type: "list",
                member: {
                  shape: "S47"
                }
              },
              NextToken: {}
            }
          }
        },
        ListRestoreJobSummaries: {
          http: {
            method: "GET",
            requestUri: "/audit/restore-job-summaries"
          },
          input: {
            type: "structure",
            members: {
              AccountId: {
                location: "querystring",
                locationName: "AccountId"
              },
              State: {
                location: "querystring",
                locationName: "State"
              },
              ResourceType: {
                location: "querystring",
                locationName: "ResourceType"
              },
              AggregationPeriod: {
                location: "querystring",
                locationName: "AggregationPeriod"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RestoreJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Region: {},
                    AccountId: {},
                    State: {},
                    ResourceType: {},
                    Count: {
                      type: "integer"
                    },
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              AggregationPeriod: {},
              NextToken: {}
            }
          }
        },
        ListRestoreJobs: {
          http: {
            method: "GET",
            requestUri: "/restore-jobs/"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              ByAccountId: {
                location: "querystring",
                locationName: "accountId"
              },
              ByResourceType: {
                location: "querystring",
                locationName: "resourceType"
              },
              ByCreatedBefore: {
                location: "querystring",
                locationName: "createdBefore",
                type: "timestamp"
              },
              ByCreatedAfter: {
                location: "querystring",
                locationName: "createdAfter",
                type: "timestamp"
              },
              ByStatus: {
                location: "querystring",
                locationName: "status"
              },
              ByCompleteBefore: {
                location: "querystring",
                locationName: "completeBefore",
                type: "timestamp"
              },
              ByCompleteAfter: {
                location: "querystring",
                locationName: "completeAfter",
                type: "timestamp"
              },
              ByRestoreTestingPlanArn: {
                location: "querystring",
                locationName: "restoreTestingPlanArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RestoreJobs: {
                shape: "S7s"
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListRestoreJobsByProtectedResource: {
          http: {
            method: "GET",
            requestUri: "/resources/{resourceArn}/restore-jobs/"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              ByStatus: {
                location: "querystring",
                locationName: "status"
              },
              ByRecoveryPointCreationDateAfter: {
                location: "querystring",
                locationName: "recoveryPointCreationDateAfter",
                type: "timestamp"
              },
              ByRecoveryPointCreationDateBefore: {
                location: "querystring",
                locationName: "recoveryPointCreationDateBefore",
                type: "timestamp"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RestoreJobs: {
                shape: "S7s"
              },
              NextToken: {}
            }
          }
        },
        ListRestoreTestingPlans: {
          http: {
            method: "GET",
            requestUri: "/restore-testing/plans",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "RestoreTestingPlans"
            ],
            members: {
              NextToken: {},
              RestoreTestingPlans: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "CreationTime",
                    "RestoreTestingPlanArn",
                    "RestoreTestingPlanName",
                    "ScheduleExpression"
                  ],
                  members: {
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastExecutionTime: {
                      type: "timestamp"
                    },
                    LastUpdateTime: {
                      type: "timestamp"
                    },
                    RestoreTestingPlanArn: {},
                    RestoreTestingPlanName: {},
                    ScheduleExpression: {},
                    ScheduleExpressionTimezone: {},
                    StartWindowHours: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        ListRestoreTestingSelections: {
          http: {
            method: "GET",
            requestUri: "/restore-testing/plans/{RestoreTestingPlanName}/selections",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "RestoreTestingPlanName"
            ],
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              RestoreTestingPlanName: {
                location: "uri",
                locationName: "RestoreTestingPlanName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "RestoreTestingSelections"
            ],
            members: {
              NextToken: {},
              RestoreTestingSelections: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "CreationTime",
                    "IamRoleArn",
                    "ProtectedResourceType",
                    "RestoreTestingPlanName",
                    "RestoreTestingSelectionName"
                  ],
                  members: {
                    CreationTime: {
                      type: "timestamp"
                    },
                    IamRoleArn: {},
                    ProtectedResourceType: {},
                    RestoreTestingPlanName: {},
                    RestoreTestingSelectionName: {},
                    ValidationWindowHours: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        ListTags: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}/"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Tags: {
                shape: "Sg"
              }
            }
          },
          idempotent: true
        },
        PutBackupVaultAccessPolicy: {
          http: {
            method: "PUT",
            requestUri: "/backup-vaults/{backupVaultName}/access-policy"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              },
              Policy: {}
            }
          },
          idempotent: true
        },
        PutBackupVaultLockConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/backup-vaults/{backupVaultName}/vault-lock"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              },
              MinRetentionDays: {
                type: "long"
              },
              MaxRetentionDays: {
                type: "long"
              },
              ChangeableForDays: {
                type: "long"
              }
            }
          },
          idempotent: true
        },
        PutBackupVaultNotifications: {
          http: {
            method: "PUT",
            requestUri: "/backup-vaults/{backupVaultName}/notification-configuration"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName",
              "SNSTopicArn",
              "BackupVaultEvents"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              },
              SNSTopicArn: {},
              BackupVaultEvents: {
                shape: "S4z"
              }
            }
          },
          idempotent: true
        },
        PutRestoreValidationResult: {
          http: {
            method: "PUT",
            requestUri: "/restore-jobs/{restoreJobId}/validations",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "RestoreJobId",
              "ValidationStatus"
            ],
            members: {
              RestoreJobId: {
                location: "uri",
                locationName: "restoreJobId"
              },
              ValidationStatus: {},
              ValidationStatusMessage: {}
            }
          },
          idempotent: true
        },
        StartBackupJob: {
          http: {
            method: "PUT",
            requestUri: "/backup-jobs"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName",
              "ResourceArn",
              "IamRoleArn"
            ],
            members: {
              BackupVaultName: {},
              ResourceArn: {},
              IamRoleArn: {},
              IdempotencyToken: {},
              StartWindowMinutes: {
                type: "long"
              },
              CompleteWindowMinutes: {
                type: "long"
              },
              Lifecycle: {
                shape: "Se"
              },
              RecoveryPointTags: {
                shape: "Sg"
              },
              BackupOptions: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupJobId: {},
              RecoveryPointArn: {},
              CreationDate: {
                type: "timestamp"
              },
              IsParent: {
                type: "boolean"
              }
            }
          },
          idempotent: true
        },
        StartCopyJob: {
          http: {
            method: "PUT",
            requestUri: "/copy-jobs"
          },
          input: {
            type: "structure",
            required: [
              "RecoveryPointArn",
              "SourceBackupVaultName",
              "DestinationBackupVaultArn",
              "IamRoleArn"
            ],
            members: {
              RecoveryPointArn: {},
              SourceBackupVaultName: {},
              DestinationBackupVaultArn: {},
              IamRoleArn: {},
              IdempotencyToken: {},
              Lifecycle: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CopyJobId: {},
              CreationDate: {
                type: "timestamp"
              },
              IsParent: {
                type: "boolean"
              }
            }
          },
          idempotent: true
        },
        StartReportJob: {
          http: {
            requestUri: "/audit/report-jobs/{reportPlanName}"
          },
          input: {
            type: "structure",
            required: [
              "ReportPlanName"
            ],
            members: {
              ReportPlanName: {
                location: "uri",
                locationName: "reportPlanName"
              },
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReportJobId: {}
            }
          },
          idempotent: true
        },
        StartRestoreJob: {
          http: {
            method: "PUT",
            requestUri: "/restore-jobs"
          },
          input: {
            type: "structure",
            required: [
              "RecoveryPointArn",
              "Metadata"
            ],
            members: {
              RecoveryPointArn: {},
              Metadata: {
                shape: "S55"
              },
              IamRoleArn: {},
              IdempotencyToken: {},
              ResourceType: {},
              CopySourceTagsToRestoredResource: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RestoreJobId: {}
            }
          },
          idempotent: true
        },
        StopBackupJob: {
          http: {
            requestUri: "/backup-jobs/{backupJobId}"
          },
          input: {
            type: "structure",
            required: [
              "BackupJobId"
            ],
            members: {
              BackupJobId: {
                location: "uri",
                locationName: "backupJobId"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              Tags: {
                shape: "Sg"
              }
            }
          },
          idempotent: true
        },
        UntagResource: {
          http: {
            requestUri: "/untag/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeyList"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              TagKeyList: {
                type: "list",
                member: {},
                sensitive: true
              }
            }
          },
          idempotent: true
        },
        UpdateBackupPlan: {
          http: {
            requestUri: "/backup/plans/{backupPlanId}"
          },
          input: {
            type: "structure",
            required: [
              "BackupPlanId",
              "BackupPlan"
            ],
            members: {
              BackupPlanId: {
                location: "uri",
                locationName: "backupPlanId"
              },
              BackupPlan: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupPlanId: {},
              BackupPlanArn: {},
              CreationDate: {
                type: "timestamp"
              },
              VersionId: {},
              AdvancedBackupSettings: {
                shape: "Sn"
              }
            }
          },
          idempotent: true
        },
        UpdateFramework: {
          http: {
            method: "PUT",
            requestUri: "/audit/frameworks/{frameworkName}"
          },
          input: {
            type: "structure",
            required: [
              "FrameworkName"
            ],
            members: {
              FrameworkName: {
                location: "uri",
                locationName: "frameworkName"
              },
              FrameworkDescription: {},
              FrameworkControls: {
                shape: "S1e"
              },
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FrameworkName: {},
              FrameworkArn: {},
              CreationTime: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        UpdateGlobalSettings: {
          http: {
            method: "PUT",
            requestUri: "/global-settings"
          },
          input: {
            type: "structure",
            members: {
              GlobalSettings: {
                shape: "S3l"
              }
            }
          }
        },
        UpdateRecoveryPointLifecycle: {
          http: {
            requestUri: "/backup-vaults/{backupVaultName}/recovery-points/{recoveryPointArn}"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName",
              "RecoveryPointArn"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              },
              RecoveryPointArn: {
                location: "uri",
                locationName: "recoveryPointArn"
              },
              Lifecycle: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupVaultArn: {},
              RecoveryPointArn: {},
              Lifecycle: {
                shape: "Se"
              },
              CalculatedLifecycle: {
                shape: "S3t"
              }
            }
          },
          idempotent: true
        },
        UpdateRegionSettings: {
          http: {
            method: "PUT",
            requestUri: "/account-settings"
          },
          input: {
            type: "structure",
            members: {
              ResourceTypeOptInPreference: {
                shape: "S3x"
              },
              ResourceTypeManagementPreference: {
                shape: "S3z"
              }
            }
          }
        },
        UpdateReportPlan: {
          http: {
            method: "PUT",
            requestUri: "/audit/report-plans/{reportPlanName}"
          },
          input: {
            type: "structure",
            required: [
              "ReportPlanName"
            ],
            members: {
              ReportPlanName: {
                location: "uri",
                locationName: "reportPlanName"
              },
              ReportPlanDescription: {},
              ReportDeliveryChannel: {
                shape: "S23"
              },
              ReportSetting: {
                shape: "S25"
              },
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReportPlanName: {},
              ReportPlanArn: {},
              CreationTime: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        UpdateRestoreTestingPlan: {
          http: {
            method: "PUT",
            requestUri: "/restore-testing/plans/{RestoreTestingPlanName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "RestoreTestingPlan",
              "RestoreTestingPlanName"
            ],
            members: {
              RestoreTestingPlan: {
                type: "structure",
                members: {
                  RecoveryPointSelection: {
                    shape: "S2c"
                  },
                  ScheduleExpression: {},
                  ScheduleExpressionTimezone: {},
                  StartWindowHours: {
                    type: "integer"
                  }
                }
              },
              RestoreTestingPlanName: {
                location: "uri",
                locationName: "RestoreTestingPlanName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CreationTime",
              "RestoreTestingPlanArn",
              "RestoreTestingPlanName",
              "UpdateTime"
            ],
            members: {
              CreationTime: {
                type: "timestamp"
              },
              RestoreTestingPlanArn: {},
              RestoreTestingPlanName: {},
              UpdateTime: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        UpdateRestoreTestingSelection: {
          http: {
            method: "PUT",
            requestUri: "/restore-testing/plans/{RestoreTestingPlanName}/selections/{RestoreTestingSelectionName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "RestoreTestingPlanName",
              "RestoreTestingSelection",
              "RestoreTestingSelectionName"
            ],
            members: {
              RestoreTestingPlanName: {
                location: "uri",
                locationName: "RestoreTestingPlanName"
              },
              RestoreTestingSelection: {
                type: "structure",
                members: {
                  IamRoleArn: {},
                  ProtectedResourceArns: {
                    shape: "S26"
                  },
                  ProtectedResourceConditions: {
                    shape: "S2l"
                  },
                  RestoreMetadataOverrides: {
                    shape: "S2g"
                  },
                  ValidationWindowHours: {
                    type: "integer"
                  }
                }
              },
              RestoreTestingSelectionName: {
                location: "uri",
                locationName: "RestoreTestingSelectionName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CreationTime",
              "RestoreTestingPlanArn",
              "RestoreTestingPlanName",
              "RestoreTestingSelectionName",
              "UpdateTime"
            ],
            members: {
              CreationTime: {
                type: "timestamp"
              },
              RestoreTestingPlanArn: {},
              RestoreTestingPlanName: {},
              RestoreTestingSelectionName: {},
              UpdateTime: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S6: {
          type: "structure",
          required: [
            "BackupPlanName",
            "Rules"
          ],
          members: {
            BackupPlanName: {},
            Rules: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "RuleName",
                  "TargetBackupVaultName"
                ],
                members: {
                  RuleName: {},
                  TargetBackupVaultName: {},
                  ScheduleExpression: {},
                  StartWindowMinutes: {
                    type: "long"
                  },
                  CompletionWindowMinutes: {
                    type: "long"
                  },
                  Lifecycle: {
                    shape: "Se"
                  },
                  RecoveryPointTags: {
                    shape: "Sg"
                  },
                  CopyActions: {
                    shape: "Sj"
                  },
                  EnableContinuousBackup: {
                    type: "boolean"
                  },
                  ScheduleExpressionTimezone: {}
                }
              }
            },
            AdvancedBackupSettings: {
              shape: "Sn"
            }
          }
        },
        Se: {
          type: "structure",
          members: {
            MoveToColdStorageAfterDays: {
              type: "long"
            },
            DeleteAfterDays: {
              type: "long"
            },
            OptInToArchiveForSupportedResources: {
              type: "boolean"
            }
          }
        },
        Sg: {
          type: "map",
          key: {},
          value: {},
          sensitive: true
        },
        Sj: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "DestinationBackupVaultArn"
            ],
            members: {
              Lifecycle: {
                shape: "Se"
              },
              DestinationBackupVaultArn: {}
            }
          }
        },
        Sn: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ResourceType: {},
              BackupOptions: {
                shape: "Sq"
              }
            }
          }
        },
        Sq: {
          type: "map",
          key: {},
          value: {}
        },
        Sw: {
          type: "structure",
          required: [
            "SelectionName",
            "IamRoleArn"
          ],
          members: {
            SelectionName: {},
            IamRoleArn: {},
            Resources: {
              shape: "Sz"
            },
            ListOfTags: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "ConditionType",
                  "ConditionKey",
                  "ConditionValue"
                ],
                members: {
                  ConditionType: {},
                  ConditionKey: {},
                  ConditionValue: {}
                }
              }
            },
            NotResources: {
              shape: "Sz"
            },
            Conditions: {
              type: "structure",
              members: {
                StringEquals: {
                  shape: "S16"
                },
                StringNotEquals: {
                  shape: "S16"
                },
                StringLike: {
                  shape: "S16"
                },
                StringNotLike: {
                  shape: "S16"
                }
              }
            }
          }
        },
        Sz: {
          type: "list",
          member: {}
        },
        S16: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ConditionKey: {},
              ConditionValue: {}
            }
          }
        },
        S1e: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ControlName"
            ],
            members: {
              ControlName: {},
              ControlInputParameters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ParameterName: {},
                    ParameterValue: {}
                  }
                }
              },
              ControlScope: {
                type: "structure",
                members: {
                  ComplianceResourceIds: {
                    type: "list",
                    member: {}
                  },
                  ComplianceResourceTypes: {
                    type: "list",
                    member: {}
                  },
                  Tags: {
                    shape: "S1o"
                  }
                }
              }
            }
          }
        },
        S1o: {
          type: "map",
          key: {},
          value: {}
        },
        S1r: {
          type: "structure",
          members: {
            VaultNames: {
              type: "list",
              member: {}
            },
            ResourceIdentifiers: {
              type: "list",
              member: {}
            },
            DateRange: {
              type: "structure",
              required: [
                "FromDate",
                "ToDate"
              ],
              members: {
                FromDate: {
                  type: "timestamp"
                },
                ToDate: {
                  type: "timestamp"
                }
              }
            }
          }
        },
        S23: {
          type: "structure",
          required: [
            "S3BucketName"
          ],
          members: {
            S3BucketName: {},
            S3KeyPrefix: {},
            Formats: {
              type: "list",
              member: {}
            }
          }
        },
        S25: {
          type: "structure",
          required: [
            "ReportTemplate"
          ],
          members: {
            ReportTemplate: {},
            FrameworkArns: {
              shape: "S26"
            },
            NumberOfFrameworks: {
              type: "integer"
            },
            Accounts: {
              shape: "S26"
            },
            OrganizationUnits: {
              shape: "S26"
            },
            Regions: {
              shape: "S26"
            }
          }
        },
        S26: {
          type: "list",
          member: {}
        },
        S2c: {
          type: "structure",
          members: {
            Algorithm: {},
            ExcludeVaults: {
              shape: "S26"
            },
            IncludeVaults: {
              shape: "S26"
            },
            RecoveryPointTypes: {
              type: "list",
              member: {}
            },
            SelectionWindowDays: {
              type: "integer"
            }
          }
        },
        S2g: {
          type: "map",
          key: {},
          value: {},
          sensitive: true
        },
        S2l: {
          type: "structure",
          members: {
            StringEquals: {
              shape: "S2m"
            },
            StringNotEquals: {
              shape: "S2m"
            }
          }
        },
        S2m: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S35: {
          type: "structure",
          members: {
            BackupPlanId: {},
            BackupPlanArn: {},
            BackupPlanVersion: {},
            BackupRuleId: {}
          }
        },
        S3e: {
          type: "structure",
          members: {
            AccountId: {},
            CopyJobId: {},
            SourceBackupVaultArn: {},
            SourceRecoveryPointArn: {},
            DestinationBackupVaultArn: {},
            DestinationRecoveryPointArn: {},
            ResourceArn: {},
            CreationDate: {
              type: "timestamp"
            },
            CompletionDate: {
              type: "timestamp"
            },
            State: {},
            StatusMessage: {},
            BackupSizeInBytes: {
              type: "long"
            },
            IamRoleArn: {},
            CreatedBy: {
              shape: "S35"
            },
            ResourceType: {},
            ParentJobId: {},
            IsParent: {
              type: "boolean"
            },
            CompositeMemberIdentifier: {},
            NumberOfChildJobs: {
              type: "long"
            },
            ChildJobsInState: {
              type: "map",
              key: {},
              value: {
                type: "long"
              }
            },
            ResourceName: {},
            MessageCategory: {}
          }
        },
        S3l: {
          type: "map",
          key: {},
          value: {}
        },
        S3t: {
          type: "structure",
          members: {
            MoveToColdStorageAt: {
              type: "timestamp"
            },
            DeleteAt: {
              type: "timestamp"
            }
          }
        },
        S3x: {
          type: "map",
          key: {},
          value: {
            type: "boolean"
          }
        },
        S3z: {
          type: "map",
          key: {},
          value: {
            type: "boolean"
          }
        },
        S43: {
          type: "structure",
          members: {
            ReportJobId: {},
            ReportPlanArn: {},
            ReportTemplate: {},
            CreationTime: {
              type: "timestamp"
            },
            CompletionTime: {
              type: "timestamp"
            },
            Status: {},
            StatusMessage: {},
            ReportDestination: {
              type: "structure",
              members: {
                S3BucketName: {},
                S3Keys: {
                  shape: "S26"
                }
              }
            }
          }
        },
        S47: {
          type: "structure",
          members: {
            ReportPlanArn: {},
            ReportPlanName: {},
            ReportPlanDescription: {},
            ReportSetting: {
              shape: "S25"
            },
            ReportDeliveryChannel: {
              shape: "S23"
            },
            DeploymentStatus: {},
            CreationTime: {
              type: "timestamp"
            },
            LastAttemptedExecutionTime: {
              type: "timestamp"
            },
            LastSuccessfulExecutionTime: {
              type: "timestamp"
            }
          }
        },
        S4c: {
          type: "structure",
          members: {
            RestoreTestingPlanArn: {}
          }
        },
        S4l: {
          type: "structure",
          required: [
            "BackupPlanName",
            "Rules"
          ],
          members: {
            BackupPlanName: {},
            Rules: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "RuleName",
                  "TargetBackupVaultName"
                ],
                members: {
                  RuleName: {},
                  TargetBackupVaultName: {},
                  ScheduleExpression: {},
                  StartWindowMinutes: {
                    type: "long"
                  },
                  CompletionWindowMinutes: {
                    type: "long"
                  },
                  Lifecycle: {
                    shape: "Se"
                  },
                  RecoveryPointTags: {
                    shape: "Sg"
                  },
                  RuleId: {},
                  CopyActions: {
                    shape: "Sj"
                  },
                  EnableContinuousBackup: {
                    type: "boolean"
                  },
                  ScheduleExpressionTimezone: {}
                }
              }
            },
            AdvancedBackupSettings: {
              shape: "Sn"
            }
          }
        },
        S4z: {
          type: "list",
          member: {}
        },
        S55: {
          type: "map",
          key: {},
          value: {},
          sensitive: true
        },
        S64: {
          type: "structure",
          members: {
            BackupPlanArn: {},
            BackupPlanId: {},
            CreationDate: {
              type: "timestamp"
            },
            DeletionDate: {
              type: "timestamp"
            },
            VersionId: {},
            BackupPlanName: {},
            CreatorRequestId: {},
            LastExecutionDate: {
              type: "timestamp"
            },
            AdvancedBackupSettings: {
              shape: "Sn"
            }
          }
        },
        S6z: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ResourceArn: {},
              ResourceType: {},
              LastBackupTime: {
                type: "timestamp"
              },
              ResourceName: {},
              LastBackupVaultArn: {},
              LastRecoveryPointArn: {}
            }
          }
        },
        S7s: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AccountId: {},
              RestoreJobId: {},
              RecoveryPointArn: {},
              CreationDate: {
                type: "timestamp"
              },
              CompletionDate: {
                type: "timestamp"
              },
              Status: {},
              StatusMessage: {},
              PercentDone: {},
              BackupSizeInBytes: {
                type: "long"
              },
              IamRoleArn: {},
              ExpectedCompletionTimeMinutes: {
                type: "long"
              },
              CreatedResourceArn: {},
              ResourceType: {},
              RecoveryPointCreationDate: {
                type: "timestamp"
              },
              CreatedBy: {
                shape: "S4c"
              },
              ValidationStatus: {},
              ValidationStatusMessage: {},
              DeletionStatus: {},
              DeletionStatusMessage: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/backup-2018-11-15.paginators.json
var require_backup_2018_11_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/backup-2018-11-15.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListBackupJobSummaries: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListBackupJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "BackupJobs"
        },
        ListBackupPlanTemplates: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "BackupPlanTemplatesList"
        },
        ListBackupPlanVersions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "BackupPlanVersionsList"
        },
        ListBackupPlans: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "BackupPlansList"
        },
        ListBackupSelections: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "BackupSelectionsList"
        },
        ListBackupVaults: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "BackupVaultList"
        },
        ListCopyJobSummaries: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListCopyJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "CopyJobs"
        },
        ListFrameworks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListLegalHolds: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "LegalHolds"
        },
        ListProtectedResources: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Results"
        },
        ListProtectedResourcesByBackupVault: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Results"
        },
        ListRecoveryPointsByBackupVault: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "RecoveryPoints"
        },
        ListRecoveryPointsByLegalHold: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "RecoveryPoints"
        },
        ListRecoveryPointsByResource: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "RecoveryPoints"
        },
        ListReportJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListReportPlans: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListRestoreJobSummaries: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListRestoreJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "RestoreJobs"
        },
        ListRestoreJobsByProtectedResource: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "RestoreJobs"
        },
        ListRestoreTestingPlans: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "RestoreTestingPlans"
        },
        ListRestoreTestingSelections: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "RestoreTestingSelections"
        },
        ListTags: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/backup.js
var require_backup = __commonJS({
  "node_modules/aws-sdk/clients/backup.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["backup"] = {};
    AWS2.Backup = Service.defineService("backup", ["2018-11-15"]);
    Object.defineProperty(apiLoader.services["backup"], "2018-11-15", {
      get: function get() {
        var model = require_backup_2018_11_15_min();
        model.paginators = require_backup_2018_11_15_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Backup;
  }
});

// node_modules/aws-sdk/apis/worklink-2018-09-25.min.json
var require_worklink_2018_09_25_min = __commonJS({
  "node_modules/aws-sdk/apis/worklink-2018-09-25.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-09-25",
        endpointPrefix: "worklink",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "WorkLink",
        serviceFullName: "Amazon WorkLink",
        serviceId: "WorkLink",
        signatureVersion: "v4",
        signingName: "worklink",
        uid: "worklink-2018-09-25"
      },
      operations: {
        AssociateDomain: {
          http: {
            requestUri: "/associateDomain"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn",
              "DomainName",
              "AcmCertificateArn"
            ],
            members: {
              FleetArn: {},
              DomainName: {},
              DisplayName: {},
              AcmCertificateArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        AssociateWebsiteAuthorizationProvider: {
          http: {
            requestUri: "/associateWebsiteAuthorizationProvider"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn",
              "AuthorizationProviderType"
            ],
            members: {
              FleetArn: {},
              AuthorizationProviderType: {},
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AuthorizationProviderId: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        AssociateWebsiteCertificateAuthority: {
          http: {
            requestUri: "/associateWebsiteCertificateAuthority"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn",
              "Certificate"
            ],
            members: {
              FleetArn: {},
              Certificate: {},
              DisplayName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WebsiteCaId: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        CreateFleet: {
          http: {
            requestUri: "/createFleet"
          },
          input: {
            type: "structure",
            required: [
              "FleetName"
            ],
            members: {
              FleetName: {},
              DisplayName: {},
              OptimizeForEndUserLocation: {
                type: "boolean"
              },
              Tags: {
                shape: "Sh"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FleetArn: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        DeleteFleet: {
          http: {
            requestUri: "/deleteFleet"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn"
            ],
            members: {
              FleetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        DescribeAuditStreamConfiguration: {
          http: {
            requestUri: "/describeAuditStreamConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn"
            ],
            members: {
              FleetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AuditStreamArn: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        DescribeCompanyNetworkConfiguration: {
          http: {
            requestUri: "/describeCompanyNetworkConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn"
            ],
            members: {
              FleetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VpcId: {},
              SubnetIds: {
                shape: "St"
              },
              SecurityGroupIds: {
                shape: "Sv"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        DescribeDevice: {
          http: {
            requestUri: "/describeDevice"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn",
              "DeviceId"
            ],
            members: {
              FleetArn: {},
              DeviceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {},
              Model: {},
              Manufacturer: {},
              OperatingSystem: {},
              OperatingSystemVersion: {},
              PatchLevel: {},
              FirstAccessedTime: {
                type: "timestamp"
              },
              LastAccessedTime: {
                type: "timestamp"
              },
              Username: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        DescribeDevicePolicyConfiguration: {
          http: {
            requestUri: "/describeDevicePolicyConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn"
            ],
            members: {
              FleetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DeviceCaCertificate: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        DescribeDomain: {
          http: {
            requestUri: "/describeDomain"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn",
              "DomainName"
            ],
            members: {
              FleetArn: {},
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DomainName: {},
              DisplayName: {},
              CreatedTime: {
                type: "timestamp"
              },
              DomainStatus: {},
              AcmCertificateArn: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        DescribeFleetMetadata: {
          http: {
            requestUri: "/describeFleetMetadata"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn"
            ],
            members: {
              FleetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CreatedTime: {
                type: "timestamp"
              },
              LastUpdatedTime: {
                type: "timestamp"
              },
              FleetName: {},
              DisplayName: {},
              OptimizeForEndUserLocation: {
                type: "boolean"
              },
              CompanyCode: {},
              FleetStatus: {},
              Tags: {
                shape: "Sh"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        DescribeIdentityProviderConfiguration: {
          http: {
            requestUri: "/describeIdentityProviderConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn"
            ],
            members: {
              FleetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityProviderType: {},
              ServiceProviderSamlMetadata: {},
              IdentityProviderSamlMetadata: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        DescribeWebsiteCertificateAuthority: {
          http: {
            requestUri: "/describeWebsiteCertificateAuthority"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn",
              "WebsiteCaId"
            ],
            members: {
              FleetArn: {},
              WebsiteCaId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Certificate: {},
              CreatedTime: {
                type: "timestamp"
              },
              DisplayName: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        DisassociateDomain: {
          http: {
            requestUri: "/disassociateDomain"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn",
              "DomainName"
            ],
            members: {
              FleetArn: {},
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        DisassociateWebsiteAuthorizationProvider: {
          http: {
            requestUri: "/disassociateWebsiteAuthorizationProvider"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn",
              "AuthorizationProviderId"
            ],
            members: {
              FleetArn: {},
              AuthorizationProviderId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        DisassociateWebsiteCertificateAuthority: {
          http: {
            requestUri: "/disassociateWebsiteCertificateAuthority"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn",
              "WebsiteCaId"
            ],
            members: {
              FleetArn: {},
              WebsiteCaId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        ListDevices: {
          http: {
            requestUri: "/listDevices"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn"
            ],
            members: {
              FleetArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Devices: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DeviceId: {},
                    DeviceStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        ListDomains: {
          http: {
            requestUri: "/listDomains"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn"
            ],
            members: {
              FleetArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Domains: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "DomainName",
                    "CreatedTime",
                    "DomainStatus"
                  ],
                  members: {
                    DomainName: {},
                    DisplayName: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    DomainStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        ListFleets: {
          http: {
            requestUri: "/listFleets"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FleetSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FleetArn: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    LastUpdatedTime: {
                      type: "timestamp"
                    },
                    FleetName: {},
                    DisplayName: {},
                    CompanyCode: {},
                    FleetStatus: {},
                    Tags: {
                      shape: "Sh"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{ResourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sh"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        ListWebsiteAuthorizationProviders: {
          http: {
            requestUri: "/listWebsiteAuthorizationProviders"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn"
            ],
            members: {
              FleetArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WebsiteAuthorizationProviders: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AuthorizationProviderType"
                  ],
                  members: {
                    AuthorizationProviderId: {},
                    AuthorizationProviderType: {},
                    DomainName: {},
                    CreatedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        ListWebsiteCertificateAuthorities: {
          http: {
            requestUri: "/listWebsiteCertificateAuthorities"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn"
            ],
            members: {
              FleetArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WebsiteCertificateAuthorities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WebsiteCaId: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    DisplayName: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        RestoreDomainAccess: {
          http: {
            requestUri: "/restoreDomainAccess"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn",
              "DomainName"
            ],
            members: {
              FleetArn: {},
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        RevokeDomainAccess: {
          http: {
            requestUri: "/revokeDomainAccess"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn",
              "DomainName"
            ],
            members: {
              FleetArn: {},
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        SignOutUser: {
          http: {
            requestUri: "/signOutUser"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn",
              "Username"
            ],
            members: {
              FleetArn: {},
              Username: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        TagResource: {
          http: {
            requestUri: "/tags/{ResourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "Sh"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{ResourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        UpdateAuditStreamConfiguration: {
          http: {
            requestUri: "/updateAuditStreamConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn"
            ],
            members: {
              FleetArn: {},
              AuditStreamArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        UpdateCompanyNetworkConfiguration: {
          http: {
            requestUri: "/updateCompanyNetworkConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn",
              "VpcId",
              "SubnetIds",
              "SecurityGroupIds"
            ],
            members: {
              FleetArn: {},
              VpcId: {},
              SubnetIds: {
                shape: "St"
              },
              SecurityGroupIds: {
                shape: "Sv"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        UpdateDevicePolicyConfiguration: {
          http: {
            requestUri: "/updateDevicePolicyConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn"
            ],
            members: {
              FleetArn: {},
              DeviceCaCertificate: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        UpdateDomainMetadata: {
          http: {
            requestUri: "/updateDomainMetadata"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn",
              "DomainName"
            ],
            members: {
              FleetArn: {},
              DomainName: {},
              DisplayName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        UpdateFleetMetadata: {
          http: {
            requestUri: "/UpdateFleetMetadata"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn"
            ],
            members: {
              FleetArn: {},
              DisplayName: {},
              OptimizeForEndUserLocation: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        },
        UpdateIdentityProviderConfiguration: {
          http: {
            requestUri: "/updateIdentityProviderConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn",
              "IdentityProviderType"
            ],
            members: {
              FleetArn: {},
              IdentityProviderType: {},
              IdentityProviderSamlMetadata: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "Amazon WorkLink is no longer supported. This will be removed in a future version of the SDK."
        }
      },
      shapes: {
        Sh: {
          type: "map",
          key: {},
          value: {}
        },
        St: {
          type: "list",
          member: {}
        },
        Sv: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/worklink-2018-09-25.paginators.json
var require_worklink_2018_09_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/worklink-2018-09-25.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListDevices: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDomains: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListFleets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListWebsiteAuthorizationProviders: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListWebsiteCertificateAuthorities: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/worklink.js
var require_worklink = __commonJS({
  "node_modules/aws-sdk/clients/worklink.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["worklink"] = {};
    AWS2.WorkLink = Service.defineService("worklink", ["2018-09-25"]);
    Object.defineProperty(apiLoader.services["worklink"], "2018-09-25", {
      get: function get() {
        var model = require_worklink_2018_09_25_min();
        model.paginators = require_worklink_2018_09_25_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.WorkLink;
  }
});

// node_modules/aws-sdk/apis/textract-2018-06-27.min.json
var require_textract_2018_06_27_min = __commonJS({
  "node_modules/aws-sdk/apis/textract-2018-06-27.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-06-27",
        endpointPrefix: "textract",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Textract",
        serviceId: "Textract",
        signatureVersion: "v4",
        targetPrefix: "Textract",
        uid: "textract-2018-06-27"
      },
      operations: {
        AnalyzeDocument: {
          input: {
            type: "structure",
            required: [
              "Document",
              "FeatureTypes"
            ],
            members: {
              Document: {
                shape: "S2"
              },
              FeatureTypes: {
                shape: "S8"
              },
              HumanLoopConfig: {
                type: "structure",
                required: [
                  "HumanLoopName",
                  "FlowDefinitionArn"
                ],
                members: {
                  HumanLoopName: {},
                  FlowDefinitionArn: {},
                  DataAttributes: {
                    type: "structure",
                    members: {
                      ContentClassifiers: {
                        type: "list",
                        member: {}
                      }
                    }
                  }
                }
              },
              QueriesConfig: {
                shape: "Sg"
              },
              AdaptersConfig: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentMetadata: {
                shape: "Su"
              },
              Blocks: {
                shape: "Sw"
              },
              HumanLoopActivationOutput: {
                type: "structure",
                members: {
                  HumanLoopArn: {},
                  HumanLoopActivationReasons: {
                    type: "list",
                    member: {}
                  },
                  HumanLoopActivationConditionsEvaluationResults: {
                    jsonvalue: true
                  }
                }
              },
              AnalyzeDocumentModelVersion: {}
            }
          }
        },
        AnalyzeExpense: {
          input: {
            type: "structure",
            required: [
              "Document"
            ],
            members: {
              Document: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentMetadata: {
                shape: "Su"
              },
              ExpenseDocuments: {
                shape: "S1m"
              }
            }
          }
        },
        AnalyzeID: {
          input: {
            type: "structure",
            required: [
              "DocumentPages"
            ],
            members: {
              DocumentPages: {
                type: "list",
                member: {
                  shape: "S2"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityDocuments: {
                type: "list",
                member: {
                  shape: "S24"
                }
              },
              DocumentMetadata: {
                shape: "Su"
              },
              AnalyzeIDModelVersion: {}
            }
          }
        },
        CreateAdapter: {
          input: {
            type: "structure",
            required: [
              "AdapterName",
              "FeatureTypes"
            ],
            members: {
              AdapterName: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              Description: {},
              FeatureTypes: {
                shape: "S8"
              },
              AutoUpdate: {},
              Tags: {
                shape: "S2f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AdapterId: {}
            }
          },
          idempotent: true
        },
        CreateAdapterVersion: {
          input: {
            type: "structure",
            required: [
              "AdapterId",
              "DatasetConfig",
              "OutputConfig"
            ],
            members: {
              AdapterId: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              DatasetConfig: {
                shape: "S2k"
              },
              KMSKeyId: {},
              OutputConfig: {
                shape: "S2m"
              },
              Tags: {
                shape: "S2f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AdapterId: {},
              AdapterVersion: {}
            }
          },
          idempotent: true
        },
        DeleteAdapter: {
          input: {
            type: "structure",
            required: [
              "AdapterId"
            ],
            members: {
              AdapterId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteAdapterVersion: {
          input: {
            type: "structure",
            required: [
              "AdapterId",
              "AdapterVersion"
            ],
            members: {
              AdapterId: {},
              AdapterVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DetectDocumentText: {
          input: {
            type: "structure",
            required: [
              "Document"
            ],
            members: {
              Document: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentMetadata: {
                shape: "Su"
              },
              Blocks: {
                shape: "Sw"
              },
              DetectDocumentTextModelVersion: {}
            }
          }
        },
        GetAdapter: {
          input: {
            type: "structure",
            required: [
              "AdapterId"
            ],
            members: {
              AdapterId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AdapterId: {},
              AdapterName: {},
              CreationTime: {
                type: "timestamp"
              },
              Description: {},
              FeatureTypes: {
                shape: "S8"
              },
              AutoUpdate: {},
              Tags: {
                shape: "S2f"
              }
            }
          }
        },
        GetAdapterVersion: {
          input: {
            type: "structure",
            required: [
              "AdapterId",
              "AdapterVersion"
            ],
            members: {
              AdapterId: {},
              AdapterVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AdapterId: {},
              AdapterVersion: {},
              CreationTime: {
                type: "timestamp"
              },
              FeatureTypes: {
                shape: "S8"
              },
              Status: {},
              StatusMessage: {},
              DatasetConfig: {
                shape: "S2k"
              },
              KMSKeyId: {},
              OutputConfig: {
                shape: "S2m"
              },
              EvaluationMetrics: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Baseline: {
                      shape: "S33"
                    },
                    AdapterVersion: {
                      shape: "S33"
                    },
                    FeatureType: {}
                  }
                }
              },
              Tags: {
                shape: "S2f"
              }
            }
          }
        },
        GetDocumentAnalysis: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentMetadata: {
                shape: "Su"
              },
              JobStatus: {},
              NextToken: {},
              Blocks: {
                shape: "Sw"
              },
              Warnings: {
                shape: "S3a"
              },
              StatusMessage: {},
              AnalyzeDocumentModelVersion: {}
            }
          }
        },
        GetDocumentTextDetection: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentMetadata: {
                shape: "Su"
              },
              JobStatus: {},
              NextToken: {},
              Blocks: {
                shape: "Sw"
              },
              Warnings: {
                shape: "S3a"
              },
              StatusMessage: {},
              DetectDocumentTextModelVersion: {}
            }
          }
        },
        GetExpenseAnalysis: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentMetadata: {
                shape: "Su"
              },
              JobStatus: {},
              NextToken: {},
              ExpenseDocuments: {
                shape: "S1m"
              },
              Warnings: {
                shape: "S3a"
              },
              StatusMessage: {},
              AnalyzeExpenseModelVersion: {}
            }
          }
        },
        GetLendingAnalysis: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentMetadata: {
                shape: "Su"
              },
              JobStatus: {},
              NextToken: {},
              Results: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Page: {
                      type: "integer"
                    },
                    PageClassification: {
                      type: "structure",
                      required: [
                        "PageType",
                        "PageNumber"
                      ],
                      members: {
                        PageType: {
                          shape: "S3o"
                        },
                        PageNumber: {
                          shape: "S3o"
                        }
                      }
                    },
                    Extractions: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          LendingDocument: {
                            type: "structure",
                            members: {
                              LendingFields: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    Type: {},
                                    KeyDetection: {
                                      shape: "S3v"
                                    },
                                    ValueDetections: {
                                      type: "list",
                                      member: {
                                        shape: "S3v"
                                      }
                                    }
                                  }
                                }
                              },
                              SignatureDetections: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    Confidence: {
                                      type: "float"
                                    },
                                    Geometry: {
                                      shape: "S12"
                                    }
                                  }
                                }
                              }
                            }
                          },
                          ExpenseDocument: {
                            shape: "S1n"
                          },
                          IdentityDocument: {
                            shape: "S24"
                          }
                        }
                      }
                    }
                  }
                }
              },
              Warnings: {
                shape: "S3a"
              },
              StatusMessage: {},
              AnalyzeLendingModelVersion: {}
            }
          }
        },
        GetLendingAnalysisSummary: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentMetadata: {
                shape: "Su"
              },
              JobStatus: {},
              Summary: {
                type: "structure",
                members: {
                  DocumentGroups: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Type: {},
                        SplitDocuments: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              Index: {
                                type: "integer"
                              },
                              Pages: {
                                type: "list",
                                member: {
                                  type: "integer"
                                }
                              }
                            }
                          }
                        },
                        DetectedSignatures: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              Page: {
                                type: "integer"
                              }
                            }
                          }
                        },
                        UndetectedSignatures: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              Page: {
                                type: "integer"
                              }
                            }
                          }
                        }
                      }
                    }
                  },
                  UndetectedDocumentTypes: {
                    type: "list",
                    member: {}
                  }
                }
              },
              Warnings: {
                shape: "S3a"
              },
              StatusMessage: {},
              AnalyzeLendingModelVersion: {}
            }
          }
        },
        ListAdapterVersions: {
          input: {
            type: "structure",
            members: {
              AdapterId: {},
              AfterCreationTime: {
                type: "timestamp"
              },
              BeforeCreationTime: {
                type: "timestamp"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AdapterVersions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AdapterId: {},
                    AdapterVersion: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    FeatureTypes: {
                      shape: "S8"
                    },
                    Status: {},
                    StatusMessage: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListAdapters: {
          input: {
            type: "structure",
            members: {
              AfterCreationTime: {
                type: "timestamp"
              },
              BeforeCreationTime: {
                type: "timestamp"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Adapters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AdapterId: {},
                    AdapterName: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    FeatureTypes: {
                      shape: "S8"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S2f"
              }
            }
          }
        },
        StartDocumentAnalysis: {
          input: {
            type: "structure",
            required: [
              "DocumentLocation",
              "FeatureTypes"
            ],
            members: {
              DocumentLocation: {
                shape: "S4o"
              },
              FeatureTypes: {
                shape: "S8"
              },
              ClientRequestToken: {},
              JobTag: {},
              NotificationChannel: {
                shape: "S4q"
              },
              OutputConfig: {
                shape: "S2m"
              },
              KMSKeyId: {},
              QueriesConfig: {
                shape: "Sg"
              },
              AdaptersConfig: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          }
        },
        StartDocumentTextDetection: {
          input: {
            type: "structure",
            required: [
              "DocumentLocation"
            ],
            members: {
              DocumentLocation: {
                shape: "S4o"
              },
              ClientRequestToken: {},
              JobTag: {},
              NotificationChannel: {
                shape: "S4q"
              },
              OutputConfig: {
                shape: "S2m"
              },
              KMSKeyId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          }
        },
        StartExpenseAnalysis: {
          input: {
            type: "structure",
            required: [
              "DocumentLocation"
            ],
            members: {
              DocumentLocation: {
                shape: "S4o"
              },
              ClientRequestToken: {},
              JobTag: {},
              NotificationChannel: {
                shape: "S4q"
              },
              OutputConfig: {
                shape: "S2m"
              },
              KMSKeyId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          }
        },
        StartLendingAnalysis: {
          input: {
            type: "structure",
            required: [
              "DocumentLocation"
            ],
            members: {
              DocumentLocation: {
                shape: "S4o"
              },
              ClientRequestToken: {},
              JobTag: {},
              NotificationChannel: {
                shape: "S4q"
              },
              OutputConfig: {
                shape: "S2m"
              },
              KMSKeyId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S2f"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAdapter: {
          input: {
            type: "structure",
            required: [
              "AdapterId"
            ],
            members: {
              AdapterId: {},
              Description: {},
              AdapterName: {},
              AutoUpdate: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AdapterId: {},
              AdapterName: {},
              CreationTime: {
                type: "timestamp"
              },
              Description: {},
              FeatureTypes: {
                shape: "S8"
              },
              AutoUpdate: {}
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          members: {
            Bytes: {
              type: "blob"
            },
            S3Object: {
              shape: "S4"
            }
          }
        },
        S4: {
          type: "structure",
          members: {
            Bucket: {},
            Name: {},
            Version: {}
          }
        },
        S8: {
          type: "list",
          member: {}
        },
        Sg: {
          type: "structure",
          required: [
            "Queries"
          ],
          members: {
            Queries: {
              type: "list",
              member: {
                shape: "Si"
              }
            }
          }
        },
        Si: {
          type: "structure",
          required: [
            "Text"
          ],
          members: {
            Text: {},
            Alias: {},
            Pages: {
              type: "list",
              member: {}
            }
          }
        },
        Sm: {
          type: "structure",
          required: [
            "Adapters"
          ],
          members: {
            Adapters: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "AdapterId",
                  "Version"
                ],
                members: {
                  AdapterId: {},
                  Pages: {
                    type: "list",
                    member: {}
                  },
                  Version: {}
                }
              }
            }
          }
        },
        Su: {
          type: "structure",
          members: {
            Pages: {
              type: "integer"
            }
          }
        },
        Sw: {
          type: "list",
          member: {
            type: "structure",
            members: {
              BlockType: {},
              Confidence: {
                type: "float"
              },
              Text: {},
              TextType: {},
              RowIndex: {
                type: "integer"
              },
              ColumnIndex: {
                type: "integer"
              },
              RowSpan: {
                type: "integer"
              },
              ColumnSpan: {
                type: "integer"
              },
              Geometry: {
                shape: "S12"
              },
              Id: {},
              Relationships: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    Ids: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              EntityTypes: {
                type: "list",
                member: {}
              },
              SelectionStatus: {},
              Page: {
                type: "integer"
              },
              Query: {
                shape: "Si"
              }
            }
          }
        },
        S12: {
          type: "structure",
          members: {
            BoundingBox: {
              type: "structure",
              members: {
                Width: {
                  type: "float"
                },
                Height: {
                  type: "float"
                },
                Left: {
                  type: "float"
                },
                Top: {
                  type: "float"
                }
              }
            },
            Polygon: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  X: {
                    type: "float"
                  },
                  Y: {
                    type: "float"
                  }
                }
              }
            }
          }
        },
        S1m: {
          type: "list",
          member: {
            shape: "S1n"
          }
        },
        S1n: {
          type: "structure",
          members: {
            ExpenseIndex: {
              type: "integer"
            },
            SummaryFields: {
              shape: "S1o"
            },
            LineItemGroups: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  LineItemGroupIndex: {
                    type: "integer"
                  },
                  LineItems: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        LineItemExpenseFields: {
                          shape: "S1o"
                        }
                      }
                    }
                  }
                }
              }
            },
            Blocks: {
              shape: "Sw"
            }
          }
        },
        S1o: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Type: {
                type: "structure",
                members: {
                  Text: {},
                  Confidence: {
                    type: "float"
                  }
                }
              },
              LabelDetection: {
                shape: "S1r"
              },
              ValueDetection: {
                shape: "S1r"
              },
              PageNumber: {
                type: "integer"
              },
              Currency: {
                type: "structure",
                members: {
                  Code: {},
                  Confidence: {
                    type: "float"
                  }
                }
              },
              GroupProperties: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Types: {
                      type: "list",
                      member: {}
                    },
                    Id: {}
                  }
                }
              }
            }
          }
        },
        S1r: {
          type: "structure",
          members: {
            Text: {},
            Geometry: {
              shape: "S12"
            },
            Confidence: {
              type: "float"
            }
          }
        },
        S24: {
          type: "structure",
          members: {
            DocumentIndex: {
              type: "integer"
            },
            IdentityDocumentFields: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Type: {
                    shape: "S27"
                  },
                  ValueDetection: {
                    shape: "S27"
                  }
                }
              }
            },
            Blocks: {
              shape: "Sw"
            }
          }
        },
        S27: {
          type: "structure",
          required: [
            "Text"
          ],
          members: {
            Text: {},
            NormalizedValue: {
              type: "structure",
              members: {
                Value: {},
                ValueType: {}
              }
            },
            Confidence: {
              type: "float"
            }
          }
        },
        S2f: {
          type: "map",
          key: {},
          value: {}
        },
        S2k: {
          type: "structure",
          members: {
            ManifestS3Object: {
              shape: "S4"
            }
          }
        },
        S2m: {
          type: "structure",
          required: [
            "S3Bucket"
          ],
          members: {
            S3Bucket: {},
            S3Prefix: {}
          }
        },
        S33: {
          type: "structure",
          members: {
            F1Score: {
              type: "float"
            },
            Precision: {
              type: "float"
            },
            Recall: {
              type: "float"
            }
          }
        },
        S3a: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ErrorCode: {},
              Pages: {
                type: "list",
                member: {
                  type: "integer"
                }
              }
            }
          }
        },
        S3o: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Value: {},
              Confidence: {
                type: "float"
              }
            }
          }
        },
        S3v: {
          type: "structure",
          members: {
            Text: {},
            SelectionStatus: {},
            Geometry: {
              shape: "S12"
            },
            Confidence: {
              type: "float"
            }
          }
        },
        S4o: {
          type: "structure",
          members: {
            S3Object: {
              shape: "S4"
            }
          }
        },
        S4q: {
          type: "structure",
          required: [
            "SNSTopicArn",
            "RoleArn"
          ],
          members: {
            SNSTopicArn: {},
            RoleArn: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/textract-2018-06-27.paginators.json
var require_textract_2018_06_27_paginators = __commonJS({
  "node_modules/aws-sdk/apis/textract-2018-06-27.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAdapterVersions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AdapterVersions"
        },
        ListAdapters: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Adapters"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/textract.js
var require_textract = __commonJS({
  "node_modules/aws-sdk/clients/textract.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["textract"] = {};
    AWS2.Textract = Service.defineService("textract", ["2018-06-27"]);
    Object.defineProperty(apiLoader.services["textract"], "2018-06-27", {
      get: function get() {
        var model = require_textract_2018_06_27_min();
        model.paginators = require_textract_2018_06_27_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Textract;
  }
});

// node_modules/aws-sdk/apis/managedblockchain-2018-09-24.min.json
var require_managedblockchain_2018_09_24_min = __commonJS({
  "node_modules/aws-sdk/apis/managedblockchain-2018-09-24.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-09-24",
        endpointPrefix: "managedblockchain",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "ManagedBlockchain",
        serviceFullName: "Amazon Managed Blockchain",
        serviceId: "ManagedBlockchain",
        signatureVersion: "v4",
        signingName: "managedblockchain",
        uid: "managedblockchain-2018-09-24"
      },
      operations: {
        CreateAccessor: {
          http: {
            requestUri: "/accessors"
          },
          input: {
            type: "structure",
            required: [
              "ClientRequestToken",
              "AccessorType"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              AccessorType: {},
              Tags: {
                shape: "S4"
              },
              NetworkType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AccessorId: {},
              BillingToken: {},
              NetworkType: {}
            }
          }
        },
        CreateMember: {
          http: {
            requestUri: "/networks/{networkId}/members"
          },
          input: {
            type: "structure",
            required: [
              "ClientRequestToken",
              "InvitationId",
              "NetworkId",
              "MemberConfiguration"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              InvitationId: {},
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              },
              MemberConfiguration: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MemberId: {}
            }
          }
        },
        CreateNetwork: {
          http: {
            requestUri: "/networks"
          },
          input: {
            type: "structure",
            required: [
              "ClientRequestToken",
              "Name",
              "Framework",
              "FrameworkVersion",
              "VotingPolicy",
              "MemberConfiguration"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              Name: {},
              Description: {},
              Framework: {},
              FrameworkVersion: {},
              FrameworkConfiguration: {
                type: "structure",
                members: {
                  Fabric: {
                    type: "structure",
                    required: [
                      "Edition"
                    ],
                    members: {
                      Edition: {}
                    }
                  }
                }
              },
              VotingPolicy: {
                shape: "Sx"
              },
              MemberConfiguration: {
                shape: "Sc"
              },
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkId: {},
              MemberId: {}
            }
          }
        },
        CreateNode: {
          http: {
            requestUri: "/networks/{networkId}/nodes"
          },
          input: {
            type: "structure",
            required: [
              "ClientRequestToken",
              "NetworkId",
              "NodeConfiguration"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              },
              MemberId: {},
              NodeConfiguration: {
                type: "structure",
                required: [
                  "InstanceType"
                ],
                members: {
                  InstanceType: {},
                  AvailabilityZone: {},
                  LogPublishingConfiguration: {
                    shape: "S17"
                  },
                  StateDB: {}
                }
              },
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NodeId: {}
            }
          }
        },
        CreateProposal: {
          http: {
            requestUri: "/networks/{networkId}/proposals"
          },
          input: {
            type: "structure",
            required: [
              "ClientRequestToken",
              "NetworkId",
              "MemberId",
              "Actions"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              },
              MemberId: {},
              Actions: {
                shape: "S1c"
              },
              Description: {},
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProposalId: {}
            }
          }
        },
        DeleteAccessor: {
          http: {
            method: "DELETE",
            requestUri: "/accessors/{AccessorId}"
          },
          input: {
            type: "structure",
            required: [
              "AccessorId"
            ],
            members: {
              AccessorId: {
                location: "uri",
                locationName: "AccessorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteMember: {
          http: {
            method: "DELETE",
            requestUri: "/networks/{networkId}/members/{memberId}"
          },
          input: {
            type: "structure",
            required: [
              "NetworkId",
              "MemberId"
            ],
            members: {
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              },
              MemberId: {
                location: "uri",
                locationName: "memberId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteNode: {
          http: {
            method: "DELETE",
            requestUri: "/networks/{networkId}/nodes/{nodeId}"
          },
          input: {
            type: "structure",
            required: [
              "NetworkId",
              "NodeId"
            ],
            members: {
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              },
              MemberId: {
                location: "querystring",
                locationName: "memberId"
              },
              NodeId: {
                location: "uri",
                locationName: "nodeId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetAccessor: {
          http: {
            method: "GET",
            requestUri: "/accessors/{AccessorId}"
          },
          input: {
            type: "structure",
            required: [
              "AccessorId"
            ],
            members: {
              AccessorId: {
                location: "uri",
                locationName: "AccessorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Accessor: {
                type: "structure",
                members: {
                  Id: {},
                  Type: {},
                  BillingToken: {},
                  Status: {},
                  CreationDate: {
                    shape: "S1t"
                  },
                  Arn: {},
                  Tags: {
                    shape: "S1u"
                  },
                  NetworkType: {}
                }
              }
            }
          }
        },
        GetMember: {
          http: {
            method: "GET",
            requestUri: "/networks/{networkId}/members/{memberId}"
          },
          input: {
            type: "structure",
            required: [
              "NetworkId",
              "MemberId"
            ],
            members: {
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              },
              MemberId: {
                location: "uri",
                locationName: "memberId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Member: {
                type: "structure",
                members: {
                  NetworkId: {},
                  Id: {},
                  Name: {},
                  Description: {},
                  FrameworkAttributes: {
                    type: "structure",
                    members: {
                      Fabric: {
                        type: "structure",
                        members: {
                          AdminUsername: {},
                          CaEndpoint: {}
                        }
                      }
                    }
                  },
                  LogPublishingConfiguration: {
                    shape: "Sj"
                  },
                  Status: {},
                  CreationDate: {
                    shape: "S1t"
                  },
                  Tags: {
                    shape: "S1u"
                  },
                  Arn: {},
                  KmsKeyArn: {}
                }
              }
            }
          }
        },
        GetNetwork: {
          http: {
            method: "GET",
            requestUri: "/networks/{networkId}"
          },
          input: {
            type: "structure",
            required: [
              "NetworkId"
            ],
            members: {
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Network: {
                type: "structure",
                members: {
                  Id: {},
                  Name: {},
                  Description: {},
                  Framework: {},
                  FrameworkVersion: {},
                  FrameworkAttributes: {
                    type: "structure",
                    members: {
                      Fabric: {
                        type: "structure",
                        members: {
                          OrderingServiceEndpoint: {},
                          Edition: {}
                        }
                      },
                      Ethereum: {
                        type: "structure",
                        members: {
                          ChainId: {}
                        }
                      }
                    }
                  },
                  VpcEndpointServiceName: {},
                  VotingPolicy: {
                    shape: "Sx"
                  },
                  Status: {},
                  CreationDate: {
                    shape: "S1t"
                  },
                  Tags: {
                    shape: "S1u"
                  },
                  Arn: {}
                }
              }
            }
          }
        },
        GetNode: {
          http: {
            method: "GET",
            requestUri: "/networks/{networkId}/nodes/{nodeId}"
          },
          input: {
            type: "structure",
            required: [
              "NetworkId",
              "NodeId"
            ],
            members: {
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              },
              MemberId: {
                location: "querystring",
                locationName: "memberId"
              },
              NodeId: {
                location: "uri",
                locationName: "nodeId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Node: {
                type: "structure",
                members: {
                  NetworkId: {},
                  MemberId: {},
                  Id: {},
                  InstanceType: {},
                  AvailabilityZone: {},
                  FrameworkAttributes: {
                    type: "structure",
                    members: {
                      Fabric: {
                        type: "structure",
                        members: {
                          PeerEndpoint: {},
                          PeerEventEndpoint: {}
                        }
                      },
                      Ethereum: {
                        type: "structure",
                        members: {
                          HttpEndpoint: {},
                          WebSocketEndpoint: {}
                        }
                      }
                    }
                  },
                  LogPublishingConfiguration: {
                    shape: "S17"
                  },
                  StateDB: {},
                  Status: {},
                  CreationDate: {
                    shape: "S1t"
                  },
                  Tags: {
                    shape: "S1u"
                  },
                  Arn: {},
                  KmsKeyArn: {}
                }
              }
            }
          }
        },
        GetProposal: {
          http: {
            method: "GET",
            requestUri: "/networks/{networkId}/proposals/{proposalId}"
          },
          input: {
            type: "structure",
            required: [
              "NetworkId",
              "ProposalId"
            ],
            members: {
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              },
              ProposalId: {
                location: "uri",
                locationName: "proposalId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Proposal: {
                type: "structure",
                members: {
                  ProposalId: {},
                  NetworkId: {},
                  Description: {},
                  Actions: {
                    shape: "S1c"
                  },
                  ProposedByMemberId: {},
                  ProposedByMemberName: {},
                  Status: {},
                  CreationDate: {
                    shape: "S1t"
                  },
                  ExpirationDate: {
                    shape: "S1t"
                  },
                  YesVoteCount: {
                    type: "integer"
                  },
                  NoVoteCount: {
                    type: "integer"
                  },
                  OutstandingVoteCount: {
                    type: "integer"
                  },
                  Tags: {
                    shape: "S1u"
                  },
                  Arn: {}
                }
              }
            }
          }
        },
        ListAccessors: {
          http: {
            method: "GET",
            requestUri: "/accessors"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              NetworkType: {
                location: "querystring",
                locationName: "networkType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Accessors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Type: {},
                    Status: {},
                    CreationDate: {
                      shape: "S1t"
                    },
                    Arn: {},
                    NetworkType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListInvitations: {
          http: {
            method: "GET",
            requestUri: "/invitations"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Invitations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InvitationId: {},
                    CreationDate: {
                      shape: "S1t"
                    },
                    ExpirationDate: {
                      shape: "S1t"
                    },
                    Status: {},
                    NetworkSummary: {
                      shape: "S2x"
                    },
                    Arn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListMembers: {
          http: {
            method: "GET",
            requestUri: "/networks/{networkId}/members"
          },
          input: {
            type: "structure",
            required: [
              "NetworkId"
            ],
            members: {
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              },
              Name: {
                location: "querystring",
                locationName: "name"
              },
              Status: {
                location: "querystring",
                locationName: "status"
              },
              IsOwned: {
                location: "querystring",
                locationName: "isOwned",
                type: "boolean"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Members: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Name: {},
                    Description: {},
                    Status: {},
                    CreationDate: {
                      shape: "S1t"
                    },
                    IsOwned: {
                      type: "boolean"
                    },
                    Arn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListNetworks: {
          http: {
            method: "GET",
            requestUri: "/networks"
          },
          input: {
            type: "structure",
            members: {
              Name: {
                location: "querystring",
                locationName: "name"
              },
              Framework: {
                location: "querystring",
                locationName: "framework"
              },
              Status: {
                location: "querystring",
                locationName: "status"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Networks: {
                type: "list",
                member: {
                  shape: "S2x"
                }
              },
              NextToken: {}
            }
          }
        },
        ListNodes: {
          http: {
            method: "GET",
            requestUri: "/networks/{networkId}/nodes"
          },
          input: {
            type: "structure",
            required: [
              "NetworkId"
            ],
            members: {
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              },
              MemberId: {
                location: "querystring",
                locationName: "memberId"
              },
              Status: {
                location: "querystring",
                locationName: "status"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Nodes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Status: {},
                    CreationDate: {
                      shape: "S1t"
                    },
                    AvailabilityZone: {},
                    InstanceType: {},
                    Arn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListProposalVotes: {
          http: {
            method: "GET",
            requestUri: "/networks/{networkId}/proposals/{proposalId}/votes"
          },
          input: {
            type: "structure",
            required: [
              "NetworkId",
              "ProposalId"
            ],
            members: {
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              },
              ProposalId: {
                location: "uri",
                locationName: "proposalId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProposalVotes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Vote: {},
                    MemberName: {},
                    MemberId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListProposals: {
          http: {
            method: "GET",
            requestUri: "/networks/{networkId}/proposals"
          },
          input: {
            type: "structure",
            required: [
              "NetworkId"
            ],
            members: {
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Proposals: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ProposalId: {},
                    Description: {},
                    ProposedByMemberId: {},
                    ProposedByMemberName: {},
                    Status: {},
                    CreationDate: {
                      shape: "S1t"
                    },
                    ExpirationDate: {
                      shape: "S1t"
                    },
                    Arn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S1u"
              }
            }
          }
        },
        RejectInvitation: {
          http: {
            method: "DELETE",
            requestUri: "/invitations/{invitationId}"
          },
          input: {
            type: "structure",
            required: [
              "InvitationId"
            ],
            members: {
              InvitationId: {
                location: "uri",
                locationName: "invitationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateMember: {
          http: {
            method: "PATCH",
            requestUri: "/networks/{networkId}/members/{memberId}"
          },
          input: {
            type: "structure",
            required: [
              "NetworkId",
              "MemberId"
            ],
            members: {
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              },
              MemberId: {
                location: "uri",
                locationName: "memberId"
              },
              LogPublishingConfiguration: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateNode: {
          http: {
            method: "PATCH",
            requestUri: "/networks/{networkId}/nodes/{nodeId}"
          },
          input: {
            type: "structure",
            required: [
              "NetworkId",
              "NodeId"
            ],
            members: {
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              },
              MemberId: {},
              NodeId: {
                location: "uri",
                locationName: "nodeId"
              },
              LogPublishingConfiguration: {
                shape: "S17"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        VoteOnProposal: {
          http: {
            requestUri: "/networks/{networkId}/proposals/{proposalId}/votes"
          },
          input: {
            type: "structure",
            required: [
              "NetworkId",
              "ProposalId",
              "VoterMemberId",
              "Vote"
            ],
            members: {
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              },
              ProposalId: {
                location: "uri",
                locationName: "proposalId"
              },
              VoterMemberId: {},
              Vote: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S4: {
          type: "map",
          key: {},
          value: {}
        },
        Sc: {
          type: "structure",
          required: [
            "Name",
            "FrameworkConfiguration"
          ],
          members: {
            Name: {},
            Description: {},
            FrameworkConfiguration: {
              type: "structure",
              members: {
                Fabric: {
                  type: "structure",
                  required: [
                    "AdminUsername",
                    "AdminPassword"
                  ],
                  members: {
                    AdminUsername: {},
                    AdminPassword: {
                      type: "string",
                      sensitive: true
                    }
                  }
                }
              }
            },
            LogPublishingConfiguration: {
              shape: "Sj"
            },
            Tags: {
              shape: "S4"
            },
            KmsKeyArn: {}
          }
        },
        Sj: {
          type: "structure",
          members: {
            Fabric: {
              type: "structure",
              members: {
                CaLogs: {
                  shape: "Sl"
                }
              }
            }
          }
        },
        Sl: {
          type: "structure",
          members: {
            Cloudwatch: {
              type: "structure",
              members: {
                Enabled: {
                  type: "boolean"
                }
              }
            }
          }
        },
        Sx: {
          type: "structure",
          members: {
            ApprovalThresholdPolicy: {
              type: "structure",
              members: {
                ThresholdPercentage: {
                  type: "integer"
                },
                ProposalDurationInHours: {
                  type: "integer"
                },
                ThresholdComparator: {}
              }
            }
          }
        },
        S17: {
          type: "structure",
          members: {
            Fabric: {
              type: "structure",
              members: {
                ChaincodeLogs: {
                  shape: "Sl"
                },
                PeerLogs: {
                  shape: "Sl"
                }
              }
            }
          }
        },
        S1c: {
          type: "structure",
          members: {
            Invitations: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Principal"
                ],
                members: {
                  Principal: {}
                }
              }
            },
            Removals: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "MemberId"
                ],
                members: {
                  MemberId: {}
                }
              }
            }
          }
        },
        S1t: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S1u: {
          type: "map",
          key: {},
          value: {}
        },
        S2x: {
          type: "structure",
          members: {
            Id: {},
            Name: {},
            Description: {},
            Framework: {},
            FrameworkVersion: {},
            Status: {},
            CreationDate: {
              shape: "S1t"
            },
            Arn: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/managedblockchain-2018-09-24.paginators.json
var require_managedblockchain_2018_09_24_paginators = __commonJS({
  "node_modules/aws-sdk/apis/managedblockchain-2018-09-24.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAccessors: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Accessors"
        },
        ListInvitations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMembers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListNetworks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListNodes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListProposalVotes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListProposals: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/managedblockchain.js
var require_managedblockchain = __commonJS({
  "node_modules/aws-sdk/clients/managedblockchain.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["managedblockchain"] = {};
    AWS2.ManagedBlockchain = Service.defineService("managedblockchain", ["2018-09-24"]);
    Object.defineProperty(apiLoader.services["managedblockchain"], "2018-09-24", {
      get: function get() {
        var model = require_managedblockchain_2018_09_24_min();
        model.paginators = require_managedblockchain_2018_09_24_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ManagedBlockchain;
  }
});

// node_modules/aws-sdk/apis/mediapackage-vod-2018-11-07.min.json
var require_mediapackage_vod_2018_11_07_min = __commonJS({
  "node_modules/aws-sdk/apis/mediapackage-vod-2018-11-07.min.json"(exports2, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2018-11-07",
        endpointPrefix: "mediapackage-vod",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "MediaPackage Vod",
        serviceFullName: "AWS Elemental MediaPackage VOD",
        serviceId: "MediaPackage Vod",
        signatureVersion: "v4",
        signingName: "mediapackage-vod",
        uid: "mediapackage-vod-2018-11-07"
      },
      operations: {
        ConfigureLogs: {
          http: {
            method: "PUT",
            requestUri: "/packaging_groups/{id}/configure_logs",
            responseCode: 200
          },
          input: {
            members: {
              EgressAccessLogs: {
                locationName: "egressAccessLogs",
                shape: "S2"
              },
              Id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              Authorization: {
                locationName: "authorization",
                shape: "S5"
              },
              CreatedAt: {
                locationName: "createdAt"
              },
              DomainName: {
                locationName: "domainName"
              },
              EgressAccessLogs: {
                locationName: "egressAccessLogs",
                shape: "S2"
              },
              Id: {
                locationName: "id"
              },
              Tags: {
                locationName: "tags",
                shape: "S6"
              }
            },
            type: "structure"
          }
        },
        CreateAsset: {
          http: {
            requestUri: "/assets",
            responseCode: 200
          },
          input: {
            members: {
              Id: {
                locationName: "id"
              },
              PackagingGroupId: {
                locationName: "packagingGroupId"
              },
              ResourceId: {
                locationName: "resourceId"
              },
              SourceArn: {
                locationName: "sourceArn"
              },
              SourceRoleArn: {
                locationName: "sourceRoleArn"
              },
              Tags: {
                locationName: "tags",
                shape: "S6"
              }
            },
            required: [
              "SourceArn",
              "Id",
              "PackagingGroupId",
              "SourceRoleArn"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              CreatedAt: {
                locationName: "createdAt"
              },
              EgressEndpoints: {
                locationName: "egressEndpoints",
                shape: "S9"
              },
              Id: {
                locationName: "id"
              },
              PackagingGroupId: {
                locationName: "packagingGroupId"
              },
              ResourceId: {
                locationName: "resourceId"
              },
              SourceArn: {
                locationName: "sourceArn"
              },
              SourceRoleArn: {
                locationName: "sourceRoleArn"
              },
              Tags: {
                locationName: "tags",
                shape: "S6"
              }
            },
            type: "structure"
          }
        },
        CreatePackagingConfiguration: {
          http: {
            requestUri: "/packaging_configurations",
            responseCode: 200
          },
          input: {
            members: {
              CmafPackage: {
                locationName: "cmafPackage",
                shape: "Sc"
              },
              DashPackage: {
                locationName: "dashPackage",
                shape: "Sq"
              },
              HlsPackage: {
                locationName: "hlsPackage",
                shape: "S10"
              },
              Id: {
                locationName: "id"
              },
              MssPackage: {
                locationName: "mssPackage",
                shape: "S13"
              },
              PackagingGroupId: {
                locationName: "packagingGroupId"
              },
              Tags: {
                locationName: "tags",
                shape: "S6"
              }
            },
            required: [
              "Id",
              "PackagingGroupId"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              CmafPackage: {
                locationName: "cmafPackage",
                shape: "Sc"
              },
              CreatedAt: {
                locationName: "createdAt"
              },
              DashPackage: {
                locationName: "dashPackage",
                shape: "Sq"
              },
              HlsPackage: {
                locationName: "hlsPackage",
                shape: "S10"
              },
              Id: {
                locationName: "id"
              },
              MssPackage: {
                locationName: "mssPackage",
                shape: "S13"
              },
              PackagingGroupId: {
                locationName: "packagingGroupId"
              },
              Tags: {
                locationName: "tags",
                shape: "S6"
              }
            },
            type: "structure"
          }
        },
        CreatePackagingGroup: {
          http: {
            requestUri: "/packaging_groups",
            responseCode: 200
          },
          input: {
            members: {
              Authorization: {
                locationName: "authorization",
                shape: "S5"
              },
              EgressAccessLogs: {
                locationName: "egressAccessLogs",
                shape: "S2"
              },
              Id: {
                locationName: "id"
              },
              Tags: {
                locationName: "tags",
                shape: "S6"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              Authorization: {
                locationName: "authorization",
                shape: "S5"
              },
              CreatedAt: {
                locationName: "createdAt"
              },
              DomainName: {
                locationName: "domainName"
              },
              EgressAccessLogs: {
                locationName: "egressAccessLogs",
                shape: "S2"
              },
              Id: {
                locationName: "id"
              },
              Tags: {
                locationName: "tags",
                shape: "S6"
              }
            },
            type: "structure"
          }
        },
        DeleteAsset: {
          http: {
            method: "DELETE",
            requestUri: "/assets/{id}",
            responseCode: 202
          },
          input: {
            members: {
              Id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {},
            type: "structure"
          }
        },
        DeletePackagingConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/packaging_configurations/{id}",
            responseCode: 202
          },
          input: {
            members: {
              Id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {},
            type: "structure"
          }
        },
        DeletePackagingGroup: {
          http: {
            method: "DELETE",
            requestUri: "/packaging_groups/{id}",
            responseCode: 202
          },
          input: {
            members: {
              Id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {},
            type: "structure"
          }
        },
        DescribeAsset: {
          http: {
            method: "GET",
            requestUri: "/assets/{id}",
            responseCode: 200
          },
          input: {
            members: {
              Id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              CreatedAt: {
                locationName: "createdAt"
              },
              EgressEndpoints: {
                locationName: "egressEndpoints",
                shape: "S9"
              },
              Id: {
                locationName: "id"
              },
              PackagingGroupId: {
                locationName: "packagingGroupId"
              },
              ResourceId: {
                locationName: "resourceId"
              },
              SourceArn: {
                locationName: "sourceArn"
              },
              SourceRoleArn: {
                locationName: "sourceRoleArn"
              },
              Tags: {
                locationName: "tags",
                shape: "S6"
              }
            },
            type: "structure"
          }
        },
        DescribePackagingConfiguration: {
          http: {
            method: "GET",
            requestUri: "/packaging_configurations/{id}",
            responseCode: 200
          },
          input: {
            members: {
              Id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              CmafPackage: {
                locationName: "cmafPackage",
                shape: "Sc"
              },
              CreatedAt: {
                locationName: "createdAt"
              },
              DashPackage: {
                locationName: "dashPackage",
                shape: "Sq"
              },
              HlsPackage: {
                locationName: "hlsPackage",
                shape: "S10"
              },
              Id: {
                locationName: "id"
              },
              MssPackage: {
                locationName: "mssPackage",
                shape: "S13"
              },
              PackagingGroupId: {
                locationName: "packagingGroupId"
              },
              Tags: {
                locationName: "tags",
                shape: "S6"
              }
            },
            type: "structure"
          }
        },
        DescribePackagingGroup: {
          http: {
            method: "GET",
            requestUri: "/packaging_groups/{id}",
            responseCode: 200
          },
          input: {
            members: {
              Id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              ApproximateAssetCount: {
                locationName: "approximateAssetCount",
                type: "integer"
              },
              Arn: {
                locationName: "arn"
              },
              Authorization: {
                locationName: "authorization",
                shape: "S5"
              },
              CreatedAt: {
                locationName: "createdAt"
              },
              DomainName: {
                locationName: "domainName"
              },
              EgressAccessLogs: {
                locationName: "egressAccessLogs",
                shape: "S2"
              },
              Id: {
                locationName: "id"
              },
              Tags: {
                locationName: "tags",
                shape: "S6"
              }
            },
            type: "structure"
          }
        },
        ListAssets: {
          http: {
            method: "GET",
            requestUri: "/assets",
            responseCode: 200
          },
          input: {
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              PackagingGroupId: {
                location: "querystring",
                locationName: "packagingGroupId"
              }
            },
            type: "structure"
          },
          output: {
            members: {
              Assets: {
                locationName: "assets",
                member: {
                  members: {
                    Arn: {
                      locationName: "arn"
                    },
                    CreatedAt: {
                      locationName: "createdAt"
                    },
                    Id: {
                      locationName: "id"
                    },
                    PackagingGroupId: {
                      locationName: "packagingGroupId"
                    },
                    ResourceId: {
                      locationName: "resourceId"
                    },
                    SourceArn: {
                      locationName: "sourceArn"
                    },
                    SourceRoleArn: {
                      locationName: "sourceRoleArn"
                    },
                    Tags: {
                      locationName: "tags",
                      shape: "S6"
                    }
                  },
                  type: "structure"
                },
                type: "list"
              },
              NextToken: {
                locationName: "nextToken"
              }
            },
            type: "structure"
          }
        },
        ListPackagingConfigurations: {
          http: {
            method: "GET",
            requestUri: "/packaging_configurations",
            responseCode: 200
          },
          input: {
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              PackagingGroupId: {
                location: "querystring",
                locationName: "packagingGroupId"
              }
            },
            type: "structure"
          },
          output: {
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              PackagingConfigurations: {
                locationName: "packagingConfigurations",
                member: {
                  members: {
                    Arn: {
                      locationName: "arn"
                    },
                    CmafPackage: {
                      locationName: "cmafPackage",
                      shape: "Sc"
                    },
                    CreatedAt: {
                      locationName: "createdAt"
                    },
                    DashPackage: {
                      locationName: "dashPackage",
                      shape: "Sq"
                    },
                    HlsPackage: {
                      locationName: "hlsPackage",
                      shape: "S10"
                    },
                    Id: {
                      locationName: "id"
                    },
                    MssPackage: {
                      locationName: "mssPackage",
                      shape: "S13"
                    },
                    PackagingGroupId: {
                      locationName: "packagingGroupId"
                    },
                    Tags: {
                      locationName: "tags",
                      shape: "S6"
                    }
                  },
                  type: "structure"
                },
                type: "list"
              }
            },
            type: "structure"
          }
        },
        ListPackagingGroups: {
          http: {
            method: "GET",
            requestUri: "/packaging_groups",
            responseCode: 200
          },
          input: {
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            type: "structure"
          },
          output: {
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              PackagingGroups: {
                locationName: "packagingGroups",
                member: {
                  members: {
                    ApproximateAssetCount: {
                      locationName: "approximateAssetCount",
                      type: "integer"
                    },
                    Arn: {
                      locationName: "arn"
                    },
                    Authorization: {
                      locationName: "authorization",
                      shape: "S5"
                    },
                    CreatedAt: {
                      locationName: "createdAt"
                    },
                    DomainName: {
                      locationName: "domainName"
                    },
                    EgressAccessLogs: {
                      locationName: "egressAccessLogs",
                      shape: "S2"
                    },
                    Id: {
                      locationName: "id"
                    },
                    Tags: {
                      locationName: "tags",
                      shape: "S6"
                    }
                  },
                  type: "structure"
                },
                type: "list"
              }
            },
            type: "structure"
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resource-arn}",
            responseCode: 200
          },
          input: {
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              }
            },
            required: [
              "ResourceArn"
            ],
            type: "structure"
          },
          output: {
            members: {
              Tags: {
                locationName: "tags",
                shape: "S21"
              }
            },
            type: "structure"
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              Tags: {
                locationName: "tags",
                shape: "S21"
              }
            },
            required: [
              "ResourceArn",
              "Tags"
            ],
            type: "structure"
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                shape: "Si"
              }
            },
            required: [
              "TagKeys",
              "ResourceArn"
            ],
            type: "structure"
          }
        },
        UpdatePackagingGroup: {
          http: {
            method: "PUT",
            requestUri: "/packaging_groups/{id}",
            responseCode: 200
          },
          input: {
            members: {
              Authorization: {
                locationName: "authorization",
                shape: "S5"
              },
              Id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              ApproximateAssetCount: {
                locationName: "approximateAssetCount",
                type: "integer"
              },
              Arn: {
                locationName: "arn"
              },
              Authorization: {
                locationName: "authorization",
                shape: "S5"
              },
              CreatedAt: {
                locationName: "createdAt"
              },
              DomainName: {
                locationName: "domainName"
              },
              EgressAccessLogs: {
                locationName: "egressAccessLogs",
                shape: "S2"
              },
              Id: {
                locationName: "id"
              },
              Tags: {
                locationName: "tags",
                shape: "S6"
              }
            },
            type: "structure"
          }
        }
      },
      shapes: {
        S2: {
          members: {
            LogGroupName: {
              locationName: "logGroupName"
            }
          },
          type: "structure"
        },
        S5: {
          members: {
            CdnIdentifierSecret: {
              locationName: "cdnIdentifierSecret"
            },
            SecretsRoleArn: {
              locationName: "secretsRoleArn"
            }
          },
          required: [
            "SecretsRoleArn",
            "CdnIdentifierSecret"
          ],
          type: "structure"
        },
        S6: {
          key: {},
          type: "map",
          value: {}
        },
        S9: {
          member: {
            members: {
              PackagingConfigurationId: {
                locationName: "packagingConfigurationId"
              },
              Status: {
                locationName: "status"
              },
              Url: {
                locationName: "url"
              }
            },
            type: "structure"
          },
          type: "list"
        },
        Sc: {
          members: {
            Encryption: {
              locationName: "encryption",
              members: {
                ConstantInitializationVector: {
                  locationName: "constantInitializationVector"
                },
                SpekeKeyProvider: {
                  locationName: "spekeKeyProvider",
                  shape: "Se"
                }
              },
              required: [
                "SpekeKeyProvider"
              ],
              type: "structure"
            },
            HlsManifests: {
              locationName: "hlsManifests",
              shape: "Sj"
            },
            IncludeEncoderConfigurationInSegments: {
              locationName: "includeEncoderConfigurationInSegments",
              type: "boolean"
            },
            SegmentDurationSeconds: {
              locationName: "segmentDurationSeconds",
              type: "integer"
            }
          },
          required: [
            "HlsManifests"
          ],
          type: "structure"
        },
        Se: {
          members: {
            EncryptionContractConfiguration: {
              locationName: "encryptionContractConfiguration",
              members: {
                PresetSpeke20Audio: {
                  locationName: "presetSpeke20Audio"
                },
                PresetSpeke20Video: {
                  locationName: "presetSpeke20Video"
                }
              },
              required: [
                "PresetSpeke20Audio",
                "PresetSpeke20Video"
              ],
              type: "structure"
            },
            RoleArn: {
              locationName: "roleArn"
            },
            SystemIds: {
              locationName: "systemIds",
              shape: "Si"
            },
            Url: {
              locationName: "url"
            }
          },
          required: [
            "SystemIds",
            "Url",
            "RoleArn"
          ],
          type: "structure"
        },
        Si: {
          member: {},
          type: "list"
        },
        Sj: {
          member: {
            members: {
              AdMarkers: {
                locationName: "adMarkers"
              },
              IncludeIframeOnlyStream: {
                locationName: "includeIframeOnlyStream",
                type: "boolean"
              },
              ManifestName: {
                locationName: "manifestName"
              },
              ProgramDateTimeIntervalSeconds: {
                locationName: "programDateTimeIntervalSeconds",
                type: "integer"
              },
              RepeatExtXKey: {
                locationName: "repeatExtXKey",
                type: "boolean"
              },
              StreamSelection: {
                locationName: "streamSelection",
                shape: "So"
              }
            },
            type: "structure"
          },
          type: "list"
        },
        So: {
          members: {
            MaxVideoBitsPerSecond: {
              locationName: "maxVideoBitsPerSecond",
              type: "integer"
            },
            MinVideoBitsPerSecond: {
              locationName: "minVideoBitsPerSecond",
              type: "integer"
            },
            StreamOrder: {
              locationName: "streamOrder"
            }
          },
          type: "structure"
        },
        Sq: {
          members: {
            DashManifests: {
              locationName: "dashManifests",
              member: {
                members: {
                  ManifestLayout: {
                    locationName: "manifestLayout"
                  },
                  ManifestName: {
                    locationName: "manifestName"
                  },
                  MinBufferTimeSeconds: {
                    locationName: "minBufferTimeSeconds",
                    type: "integer"
                  },
                  Profile: {
                    locationName: "profile"
                  },
                  ScteMarkersSource: {
                    locationName: "scteMarkersSource"
                  },
                  StreamSelection: {
                    locationName: "streamSelection",
                    shape: "So"
                  }
                },
                type: "structure"
              },
              type: "list"
            },
            Encryption: {
              locationName: "encryption",
              members: {
                SpekeKeyProvider: {
                  locationName: "spekeKeyProvider",
                  shape: "Se"
                }
              },
              required: [
                "SpekeKeyProvider"
              ],
              type: "structure"
            },
            IncludeEncoderConfigurationInSegments: {
              locationName: "includeEncoderConfigurationInSegments",
              type: "boolean"
            },
            IncludeIframeOnlyStream: {
              locationName: "includeIframeOnlyStream",
              type: "boolean"
            },
            PeriodTriggers: {
              locationName: "periodTriggers",
              member: {},
              type: "list"
            },
            SegmentDurationSeconds: {
              locationName: "segmentDurationSeconds",
              type: "integer"
            },
            SegmentTemplateFormat: {
              locationName: "segmentTemplateFormat"
            }
          },
          required: [
            "DashManifests"
          ],
          type: "structure"
        },
        S10: {
          members: {
            Encryption: {
              locationName: "encryption",
              members: {
                ConstantInitializationVector: {
                  locationName: "constantInitializationVector"
                },
                EncryptionMethod: {
                  locationName: "encryptionMethod"
                },
                SpekeKeyProvider: {
                  locationName: "spekeKeyProvider",
                  shape: "Se"
                }
              },
              required: [
                "SpekeKeyProvider"
              ],
              type: "structure"
            },
            HlsManifests: {
              locationName: "hlsManifests",
              shape: "Sj"
            },
            IncludeDvbSubtitles: {
              locationName: "includeDvbSubtitles",
              type: "boolean"
            },
            SegmentDurationSeconds: {
              locationName: "segmentDurationSeconds",
              type: "integer"
            },
            UseAudioRenditionGroup: {
              locationName: "useAudioRenditionGroup",
              type: "boolean"
            }
          },
          required: [
            "HlsManifests"
          ],
          type: "structure"
        },
        S13: {
          members: {
            Encryption: {
              locationName: "encryption",
              members: {
                SpekeKeyProvider: {
                  locationName: "spekeKeyProvider",
                  shape: "Se"
                }
              },
              required: [
                "SpekeKeyProvider"
              ],
              type: "structure"
            },
            MssManifests: {
              locationName: "mssManifests",
              member: {
                members: {
                  ManifestName: {
                    locationName: "manifestName"
                  },
                  StreamSelection: {
                    locationName: "streamSelection",
                    shape: "So"
                  }
                },
                type: "structure"
              },
              type: "list"
            },
            SegmentDurationSeconds: {
              locationName: "segmentDurationSeconds",
              type: "integer"
            }
          },
          required: [
            "MssManifests"
          ],
          type: "structure"
        },
        S21: {
          key: {},
          type: "map",
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/mediapackage-vod-2018-11-07.paginators.json
var require_mediapackage_vod_2018_11_07_paginators = __commonJS({
  "node_modules/aws-sdk/apis/mediapackage-vod-2018-11-07.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAssets: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Assets"
        },
        ListPackagingConfigurations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PackagingConfigurations"
        },
        ListPackagingGroups: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PackagingGroups"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/mediapackagevod.js
var require_mediapackagevod = __commonJS({
  "node_modules/aws-sdk/clients/mediapackagevod.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["mediapackagevod"] = {};
    AWS2.MediaPackageVod = Service.defineService("mediapackagevod", ["2018-11-07"]);
    Object.defineProperty(apiLoader.services["mediapackagevod"], "2018-11-07", {
      get: function get() {
        var model = require_mediapackage_vod_2018_11_07_min();
        model.paginators = require_mediapackage_vod_2018_11_07_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.MediaPackageVod;
  }
});

// node_modules/aws-sdk/apis/groundstation-2019-05-23.min.json
var require_groundstation_2019_05_23_min = __commonJS({
  "node_modules/aws-sdk/apis/groundstation-2019-05-23.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-05-23",
        endpointPrefix: "groundstation",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Ground Station",
        serviceId: "GroundStation",
        signatureVersion: "v4",
        signingName: "groundstation",
        uid: "groundstation-2019-05-23"
      },
      operations: {
        CancelContact: {
          http: {
            method: "DELETE",
            requestUri: "/contact/{contactId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "contactId"
            ],
            members: {
              contactId: {
                location: "uri",
                locationName: "contactId"
              }
            }
          },
          output: {
            shape: "S3"
          },
          idempotent: true
        },
        CreateConfig: {
          http: {
            requestUri: "/config",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "configData",
              "name"
            ],
            members: {
              configData: {
                shape: "S5"
              },
              name: {},
              tags: {
                shape: "Sy"
              }
            }
          },
          output: {
            shape: "Sz"
          }
        },
        CreateDataflowEndpointGroup: {
          http: {
            requestUri: "/dataflowEndpointGroup",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "endpointDetails"
            ],
            members: {
              contactPostPassDurationSeconds: {
                type: "integer"
              },
              contactPrePassDurationSeconds: {
                type: "integer"
              },
              endpointDetails: {
                shape: "S13"
              },
              tags: {
                shape: "Sy"
              }
            }
          },
          output: {
            shape: "S1p"
          }
        },
        CreateEphemeris: {
          http: {
            requestUri: "/ephemeris",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "satelliteId"
            ],
            members: {
              enabled: {
                type: "boolean"
              },
              ephemeris: {
                type: "structure",
                members: {
                  oem: {
                    type: "structure",
                    members: {
                      oemData: {},
                      s3Object: {
                        shape: "S1u"
                      }
                    }
                  },
                  tle: {
                    type: "structure",
                    members: {
                      s3Object: {
                        shape: "S1u"
                      },
                      tleData: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "tleLine1",
                            "tleLine2",
                            "validTimeRange"
                          ],
                          members: {
                            tleLine1: {},
                            tleLine2: {},
                            validTimeRange: {
                              type: "structure",
                              required: [
                                "endTime",
                                "startTime"
                              ],
                              members: {
                                endTime: {
                                  type: "timestamp"
                                },
                                startTime: {
                                  type: "timestamp"
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                },
                union: true
              },
              expirationTime: {
                type: "timestamp"
              },
              kmsKeyArn: {},
              name: {},
              priority: {
                type: "integer"
              },
              satelliteId: {},
              tags: {
                shape: "Sy"
              }
            }
          },
          output: {
            shape: "S27"
          }
        },
        CreateMissionProfile: {
          http: {
            requestUri: "/missionprofile",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "dataflowEdges",
              "minimumViableContactDurationSeconds",
              "name",
              "trackingConfigArn"
            ],
            members: {
              contactPostPassDurationSeconds: {
                type: "integer"
              },
              contactPrePassDurationSeconds: {
                type: "integer"
              },
              dataflowEdges: {
                shape: "S2a"
              },
              minimumViableContactDurationSeconds: {
                type: "integer"
              },
              name: {},
              streamsKmsKey: {
                shape: "S2d"
              },
              streamsKmsRole: {},
              tags: {
                shape: "Sy"
              },
              trackingConfigArn: {}
            }
          },
          output: {
            shape: "S2g"
          }
        },
        DeleteConfig: {
          http: {
            method: "DELETE",
            requestUri: "/config/{configType}/{configId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "configId",
              "configType"
            ],
            members: {
              configId: {
                location: "uri",
                locationName: "configId"
              },
              configType: {
                location: "uri",
                locationName: "configType"
              }
            }
          },
          output: {
            shape: "Sz"
          },
          idempotent: true
        },
        DeleteDataflowEndpointGroup: {
          http: {
            method: "DELETE",
            requestUri: "/dataflowEndpointGroup/{dataflowEndpointGroupId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "dataflowEndpointGroupId"
            ],
            members: {
              dataflowEndpointGroupId: {
                location: "uri",
                locationName: "dataflowEndpointGroupId"
              }
            }
          },
          output: {
            shape: "S1p"
          },
          idempotent: true
        },
        DeleteEphemeris: {
          http: {
            method: "DELETE",
            requestUri: "/ephemeris/{ephemerisId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ephemerisId"
            ],
            members: {
              ephemerisId: {
                location: "uri",
                locationName: "ephemerisId"
              }
            }
          },
          output: {
            shape: "S27"
          },
          idempotent: true
        },
        DeleteMissionProfile: {
          http: {
            method: "DELETE",
            requestUri: "/missionprofile/{missionProfileId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "missionProfileId"
            ],
            members: {
              missionProfileId: {
                location: "uri",
                locationName: "missionProfileId"
              }
            }
          },
          output: {
            shape: "S2g"
          },
          idempotent: true
        },
        DescribeContact: {
          http: {
            method: "GET",
            requestUri: "/contact/{contactId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "contactId"
            ],
            members: {
              contactId: {
                location: "uri",
                locationName: "contactId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              contactId: {},
              contactStatus: {},
              dataflowList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    destination: {
                      type: "structure",
                      members: {
                        configDetails: {
                          shape: "S2r"
                        },
                        configId: {},
                        configType: {},
                        dataflowDestinationRegion: {}
                      }
                    },
                    errorMessage: {},
                    source: {
                      type: "structure",
                      members: {
                        configDetails: {
                          shape: "S2r"
                        },
                        configId: {},
                        configType: {},
                        dataflowSourceRegion: {}
                      }
                    }
                  }
                }
              },
              endTime: {
                type: "timestamp"
              },
              errorMessage: {},
              groundStation: {},
              maximumElevation: {
                shape: "S2v"
              },
              missionProfileArn: {},
              postPassEndTime: {
                type: "timestamp"
              },
              prePassStartTime: {
                type: "timestamp"
              },
              region: {},
              satelliteArn: {},
              startTime: {
                type: "timestamp"
              },
              tags: {
                shape: "Sy"
              }
            }
          }
        },
        DescribeEphemeris: {
          http: {
            method: "GET",
            requestUri: "/ephemeris/{ephemerisId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ephemerisId"
            ],
            members: {
              ephemerisId: {
                location: "uri",
                locationName: "ephemerisId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              creationTime: {
                type: "timestamp"
              },
              enabled: {
                type: "boolean"
              },
              ephemerisId: {},
              invalidReason: {},
              name: {},
              priority: {
                type: "integer"
              },
              satelliteId: {},
              status: {},
              suppliedData: {
                type: "structure",
                members: {
                  oem: {
                    shape: "S35"
                  },
                  tle: {
                    shape: "S35"
                  }
                },
                union: true
              },
              tags: {
                shape: "Sy"
              }
            }
          }
        },
        GetAgentConfiguration: {
          http: {
            method: "GET",
            requestUri: "/agent/{agentId}/configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "agentId"
            ],
            members: {
              agentId: {
                location: "uri",
                locationName: "agentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              agentId: {},
              taskingDocument: {}
            }
          }
        },
        GetConfig: {
          http: {
            method: "GET",
            requestUri: "/config/{configType}/{configId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "configId",
              "configType"
            ],
            members: {
              configId: {
                location: "uri",
                locationName: "configId"
              },
              configType: {
                location: "uri",
                locationName: "configType"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "configArn",
              "configData",
              "configId",
              "name"
            ],
            members: {
              configArn: {},
              configData: {
                shape: "S5"
              },
              configId: {},
              configType: {},
              name: {},
              tags: {
                shape: "Sy"
              }
            }
          }
        },
        GetDataflowEndpointGroup: {
          http: {
            method: "GET",
            requestUri: "/dataflowEndpointGroup/{dataflowEndpointGroupId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "dataflowEndpointGroupId"
            ],
            members: {
              dataflowEndpointGroupId: {
                location: "uri",
                locationName: "dataflowEndpointGroupId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              contactPostPassDurationSeconds: {
                type: "integer"
              },
              contactPrePassDurationSeconds: {
                type: "integer"
              },
              dataflowEndpointGroupArn: {},
              dataflowEndpointGroupId: {},
              endpointsDetails: {
                shape: "S13"
              },
              tags: {
                shape: "Sy"
              }
            }
          }
        },
        GetMinuteUsage: {
          http: {
            requestUri: "/minute-usage",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "month",
              "year"
            ],
            members: {
              month: {
                type: "integer"
              },
              year: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              estimatedMinutesRemaining: {
                type: "integer"
              },
              isReservedMinutesCustomer: {
                type: "boolean"
              },
              totalReservedMinuteAllocation: {
                type: "integer"
              },
              totalScheduledMinutes: {
                type: "integer"
              },
              upcomingMinutesScheduled: {
                type: "integer"
              }
            }
          }
        },
        GetMissionProfile: {
          http: {
            method: "GET",
            requestUri: "/missionprofile/{missionProfileId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "missionProfileId"
            ],
            members: {
              missionProfileId: {
                location: "uri",
                locationName: "missionProfileId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              contactPostPassDurationSeconds: {
                type: "integer"
              },
              contactPrePassDurationSeconds: {
                type: "integer"
              },
              dataflowEdges: {
                shape: "S2a"
              },
              minimumViableContactDurationSeconds: {
                type: "integer"
              },
              missionProfileArn: {},
              missionProfileId: {},
              name: {},
              region: {},
              streamsKmsKey: {
                shape: "S2d"
              },
              streamsKmsRole: {},
              tags: {
                shape: "Sy"
              },
              trackingConfigArn: {}
            }
          }
        },
        GetSatellite: {
          http: {
            method: "GET",
            requestUri: "/satellite/{satelliteId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "satelliteId"
            ],
            members: {
              satelliteId: {
                location: "uri",
                locationName: "satelliteId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              currentEphemeris: {
                shape: "S3m"
              },
              groundStations: {
                shape: "S3o"
              },
              noradSatelliteID: {
                type: "integer"
              },
              satelliteArn: {},
              satelliteId: {}
            }
          }
        },
        ListConfigs: {
          http: {
            method: "GET",
            requestUri: "/config",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              configList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    configArn: {},
                    configId: {},
                    configType: {},
                    name: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListContacts: {
          http: {
            requestUri: "/contacts",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "endTime",
              "startTime",
              "statusList"
            ],
            members: {
              endTime: {
                type: "timestamp"
              },
              groundStation: {},
              maxResults: {
                type: "integer"
              },
              missionProfileArn: {},
              nextToken: {},
              satelliteArn: {},
              startTime: {
                type: "timestamp"
              },
              statusList: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              contactList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    contactId: {},
                    contactStatus: {},
                    endTime: {
                      type: "timestamp"
                    },
                    errorMessage: {},
                    groundStation: {},
                    maximumElevation: {
                      shape: "S2v"
                    },
                    missionProfileArn: {},
                    postPassEndTime: {
                      type: "timestamp"
                    },
                    prePassStartTime: {
                      type: "timestamp"
                    },
                    region: {},
                    satelliteArn: {},
                    startTime: {
                      type: "timestamp"
                    },
                    tags: {
                      shape: "Sy"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDataflowEndpointGroups: {
          http: {
            method: "GET",
            requestUri: "/dataflowEndpointGroup",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              dataflowEndpointGroupList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    dataflowEndpointGroupArn: {},
                    dataflowEndpointGroupId: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListEphemerides: {
          http: {
            requestUri: "/ephemerides",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "endTime",
              "satelliteId",
              "startTime"
            ],
            members: {
              endTime: {
                type: "timestamp"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              satelliteId: {},
              startTime: {
                type: "timestamp"
              },
              statusList: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ephemerides: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    creationTime: {
                      type: "timestamp"
                    },
                    enabled: {
                      type: "boolean"
                    },
                    ephemerisId: {},
                    name: {},
                    priority: {
                      type: "integer"
                    },
                    sourceS3Object: {
                      shape: "S1u"
                    },
                    status: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListGroundStations: {
          http: {
            method: "GET",
            requestUri: "/groundstation",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              satelliteId: {
                location: "querystring",
                locationName: "satelliteId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              groundStationList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    groundStationId: {},
                    groundStationName: {},
                    region: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListMissionProfiles: {
          http: {
            method: "GET",
            requestUri: "/missionprofile",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              missionProfileList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    missionProfileArn: {},
                    missionProfileId: {},
                    name: {},
                    region: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSatellites: {
          http: {
            method: "GET",
            requestUri: "/satellite",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              satellites: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    currentEphemeris: {
                      shape: "S3m"
                    },
                    groundStations: {
                      shape: "S3o"
                    },
                    noradSatelliteID: {
                      type: "integer"
                    },
                    satelliteArn: {},
                    satelliteId: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sy"
              }
            }
          }
        },
        RegisterAgent: {
          http: {
            requestUri: "/agent",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "agentDetails",
              "discoveryData"
            ],
            members: {
              agentDetails: {
                type: "structure",
                required: [
                  "agentVersion",
                  "componentVersions",
                  "instanceId",
                  "instanceType"
                ],
                members: {
                  agentCpuCores: {
                    shape: "S4s"
                  },
                  agentVersion: {},
                  componentVersions: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "componentType",
                        "versions"
                      ],
                      members: {
                        componentType: {},
                        versions: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  },
                  instanceId: {},
                  instanceType: {},
                  reservedCpuCores: {
                    shape: "S4s"
                  }
                }
              },
              discoveryData: {
                type: "structure",
                required: [
                  "capabilityArns",
                  "privateIpAddresses",
                  "publicIpAddresses"
                ],
                members: {
                  capabilityArns: {
                    type: "list",
                    member: {}
                  },
                  privateIpAddresses: {
                    shape: "S53"
                  },
                  publicIpAddresses: {
                    shape: "S53"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              agentId: {}
            }
          }
        },
        ReserveContact: {
          http: {
            requestUri: "/contact",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "endTime",
              "groundStation",
              "missionProfileArn",
              "satelliteArn",
              "startTime"
            ],
            members: {
              endTime: {
                type: "timestamp"
              },
              groundStation: {},
              missionProfileArn: {},
              satelliteArn: {},
              startTime: {
                type: "timestamp"
              },
              tags: {
                shape: "Sy"
              }
            }
          },
          output: {
            shape: "S3"
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sy"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateAgentStatus: {
          http: {
            method: "PUT",
            requestUri: "/agent/{agentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "agentId",
              "aggregateStatus",
              "componentStatuses",
              "taskId"
            ],
            members: {
              agentId: {
                location: "uri",
                locationName: "agentId"
              },
              aggregateStatus: {
                type: "structure",
                required: [
                  "status"
                ],
                members: {
                  signatureMap: {
                    type: "map",
                    key: {},
                    value: {
                      type: "boolean"
                    }
                  },
                  status: {}
                }
              },
              componentStatuses: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "capabilityArn",
                    "componentType",
                    "dataflowId",
                    "status"
                  ],
                  members: {
                    bytesReceived: {
                      type: "long"
                    },
                    bytesSent: {
                      type: "long"
                    },
                    capabilityArn: {},
                    componentType: {},
                    dataflowId: {},
                    packetsDropped: {
                      type: "long"
                    },
                    status: {}
                  }
                }
              },
              taskId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "agentId"
            ],
            members: {
              agentId: {}
            }
          },
          idempotent: true
        },
        UpdateConfig: {
          http: {
            method: "PUT",
            requestUri: "/config/{configType}/{configId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "configData",
              "configId",
              "configType",
              "name"
            ],
            members: {
              configData: {
                shape: "S5"
              },
              configId: {
                location: "uri",
                locationName: "configId"
              },
              configType: {
                location: "uri",
                locationName: "configType"
              },
              name: {}
            }
          },
          output: {
            shape: "Sz"
          },
          idempotent: true
        },
        UpdateEphemeris: {
          http: {
            method: "PUT",
            requestUri: "/ephemeris/{ephemerisId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "enabled",
              "ephemerisId"
            ],
            members: {
              enabled: {
                type: "boolean"
              },
              ephemerisId: {
                location: "uri",
                locationName: "ephemerisId"
              },
              name: {},
              priority: {
                type: "integer"
              }
            }
          },
          output: {
            shape: "S27"
          },
          idempotent: true
        },
        UpdateMissionProfile: {
          http: {
            method: "PUT",
            requestUri: "/missionprofile/{missionProfileId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "missionProfileId"
            ],
            members: {
              contactPostPassDurationSeconds: {
                type: "integer"
              },
              contactPrePassDurationSeconds: {
                type: "integer"
              },
              dataflowEdges: {
                shape: "S2a"
              },
              minimumViableContactDurationSeconds: {
                type: "integer"
              },
              missionProfileId: {
                location: "uri",
                locationName: "missionProfileId"
              },
              name: {},
              streamsKmsKey: {
                shape: "S2d"
              },
              streamsKmsRole: {},
              trackingConfigArn: {}
            }
          },
          output: {
            shape: "S2g"
          },
          idempotent: true
        }
      },
      shapes: {
        S3: {
          type: "structure",
          members: {
            contactId: {}
          }
        },
        S5: {
          type: "structure",
          members: {
            antennaDownlinkConfig: {
              type: "structure",
              required: [
                "spectrumConfig"
              ],
              members: {
                spectrumConfig: {
                  shape: "S7"
                }
              }
            },
            antennaDownlinkDemodDecodeConfig: {
              type: "structure",
              required: [
                "decodeConfig",
                "demodulationConfig",
                "spectrumConfig"
              ],
              members: {
                decodeConfig: {
                  type: "structure",
                  required: [
                    "unvalidatedJSON"
                  ],
                  members: {
                    unvalidatedJSON: {}
                  }
                },
                demodulationConfig: {
                  type: "structure",
                  required: [
                    "unvalidatedJSON"
                  ],
                  members: {
                    unvalidatedJSON: {}
                  }
                },
                spectrumConfig: {
                  shape: "S7"
                }
              }
            },
            antennaUplinkConfig: {
              type: "structure",
              required: [
                "spectrumConfig",
                "targetEirp"
              ],
              members: {
                spectrumConfig: {
                  type: "structure",
                  required: [
                    "centerFrequency"
                  ],
                  members: {
                    centerFrequency: {
                      shape: "Sb"
                    },
                    polarization: {}
                  }
                },
                targetEirp: {
                  type: "structure",
                  required: [
                    "units",
                    "value"
                  ],
                  members: {
                    units: {},
                    value: {
                      type: "double"
                    }
                  }
                },
                transmitDisabled: {
                  type: "boolean"
                }
              }
            },
            dataflowEndpointConfig: {
              type: "structure",
              required: [
                "dataflowEndpointName"
              ],
              members: {
                dataflowEndpointName: {},
                dataflowEndpointRegion: {}
              }
            },
            s3RecordingConfig: {
              type: "structure",
              required: [
                "bucketArn",
                "roleArn"
              ],
              members: {
                bucketArn: {},
                prefix: {},
                roleArn: {}
              }
            },
            trackingConfig: {
              type: "structure",
              required: [
                "autotrack"
              ],
              members: {
                autotrack: {}
              }
            },
            uplinkEchoConfig: {
              type: "structure",
              required: [
                "antennaUplinkConfigArn",
                "enabled"
              ],
              members: {
                antennaUplinkConfigArn: {},
                enabled: {
                  type: "boolean"
                }
              }
            }
          },
          union: true
        },
        S7: {
          type: "structure",
          required: [
            "bandwidth",
            "centerFrequency"
          ],
          members: {
            bandwidth: {
              type: "structure",
              required: [
                "units",
                "value"
              ],
              members: {
                units: {},
                value: {
                  type: "double"
                }
              }
            },
            centerFrequency: {
              shape: "Sb"
            },
            polarization: {}
          }
        },
        Sb: {
          type: "structure",
          required: [
            "units",
            "value"
          ],
          members: {
            units: {},
            value: {
              type: "double"
            }
          }
        },
        Sy: {
          type: "map",
          key: {},
          value: {}
        },
        Sz: {
          type: "structure",
          members: {
            configArn: {},
            configId: {},
            configType: {}
          }
        },
        S13: {
          type: "list",
          member: {
            shape: "S14"
          }
        },
        S14: {
          type: "structure",
          members: {
            awsGroundStationAgentEndpoint: {
              type: "structure",
              required: [
                "egressAddress",
                "ingressAddress",
                "name"
              ],
              members: {
                agentStatus: {},
                auditResults: {},
                egressAddress: {
                  type: "structure",
                  required: [
                    "socketAddress"
                  ],
                  members: {
                    mtu: {
                      type: "integer"
                    },
                    socketAddress: {
                      shape: "S1a"
                    }
                  }
                },
                ingressAddress: {
                  type: "structure",
                  required: [
                    "socketAddress"
                  ],
                  members: {
                    mtu: {
                      type: "integer"
                    },
                    socketAddress: {
                      type: "structure",
                      required: [
                        "name",
                        "portRange"
                      ],
                      members: {
                        name: {},
                        portRange: {
                          type: "structure",
                          required: [
                            "maximum",
                            "minimum"
                          ],
                          members: {
                            maximum: {
                              type: "integer"
                            },
                            minimum: {
                              type: "integer"
                            }
                          }
                        }
                      }
                    }
                  }
                },
                name: {}
              }
            },
            endpoint: {
              type: "structure",
              members: {
                address: {
                  shape: "S1a"
                },
                mtu: {
                  type: "integer"
                },
                name: {},
                status: {}
              }
            },
            healthReasons: {
              type: "list",
              member: {}
            },
            healthStatus: {},
            securityDetails: {
              type: "structure",
              required: [
                "roleArn",
                "securityGroupIds",
                "subnetIds"
              ],
              members: {
                roleArn: {},
                securityGroupIds: {
                  type: "list",
                  member: {}
                },
                subnetIds: {
                  type: "list",
                  member: {}
                }
              }
            }
          }
        },
        S1a: {
          type: "structure",
          required: [
            "name",
            "port"
          ],
          members: {
            name: {},
            port: {
              type: "integer"
            }
          }
        },
        S1p: {
          type: "structure",
          members: {
            dataflowEndpointGroupId: {}
          }
        },
        S1u: {
          type: "structure",
          members: {
            bucket: {},
            key: {},
            version: {}
          }
        },
        S27: {
          type: "structure",
          members: {
            ephemerisId: {}
          }
        },
        S2a: {
          type: "list",
          member: {
            type: "list",
            member: {}
          }
        },
        S2d: {
          type: "structure",
          members: {
            kmsAliasArn: {},
            kmsAliasName: {},
            kmsKeyArn: {}
          },
          union: true
        },
        S2g: {
          type: "structure",
          members: {
            missionProfileId: {}
          }
        },
        S2r: {
          type: "structure",
          members: {
            antennaDemodDecodeDetails: {
              type: "structure",
              members: {
                outputNode: {}
              }
            },
            endpointDetails: {
              shape: "S14"
            },
            s3RecordingDetails: {
              type: "structure",
              members: {
                bucketArn: {},
                keyTemplate: {}
              }
            }
          },
          union: true
        },
        S2v: {
          type: "structure",
          required: [
            "unit",
            "value"
          ],
          members: {
            unit: {},
            value: {
              type: "double"
            }
          }
        },
        S35: {
          type: "structure",
          members: {
            ephemerisData: {},
            sourceS3Object: {
              shape: "S1u"
            }
          }
        },
        S3m: {
          type: "structure",
          required: [
            "source"
          ],
          members: {
            ephemerisId: {},
            epoch: {
              type: "timestamp"
            },
            name: {},
            source: {}
          }
        },
        S3o: {
          type: "list",
          member: {}
        },
        S4s: {
          type: "list",
          member: {
            type: "integer"
          }
        },
        S53: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/groundstation-2019-05-23.paginators.json
var require_groundstation_2019_05_23_paginators = __commonJS({
  "node_modules/aws-sdk/apis/groundstation-2019-05-23.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListConfigs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "configList"
        },
        ListContacts: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "contactList"
        },
        ListDataflowEndpointGroups: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "dataflowEndpointGroupList"
        },
        ListEphemerides: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "ephemerides"
        },
        ListGroundStations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "groundStationList"
        },
        ListMissionProfiles: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "missionProfileList"
        },
        ListSatellites: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "satellites"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/groundstation-2019-05-23.waiters2.json
var require_groundstation_2019_05_23_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/groundstation-2019-05-23.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        ContactScheduled: {
          description: "Waits until a contact has been scheduled",
          delay: 5,
          maxAttempts: 180,
          operation: "DescribeContact",
          acceptors: [{
            matcher: "path",
            argument: "contactStatus",
            state: "failure",
            expected: "FAILED_TO_SCHEDULE"
          }, {
            matcher: "path",
            argument: "contactStatus",
            state: "success",
            expected: "SCHEDULED"
          }]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/groundstation.js
var require_groundstation = __commonJS({
  "node_modules/aws-sdk/clients/groundstation.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["groundstation"] = {};
    AWS2.GroundStation = Service.defineService("groundstation", ["2019-05-23"]);
    Object.defineProperty(apiLoader.services["groundstation"], "2019-05-23", {
      get: function get() {
        var model = require_groundstation_2019_05_23_min();
        model.paginators = require_groundstation_2019_05_23_paginators().pagination;
        model.waiters = require_groundstation_2019_05_23_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.GroundStation;
  }
});

// node_modules/aws-sdk/apis/iotthingsgraph-2018-09-06.min.json
var require_iotthingsgraph_2018_09_06_min = __commonJS({
  "node_modules/aws-sdk/apis/iotthingsgraph-2018-09-06.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-09-06",
        endpointPrefix: "iotthingsgraph",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS IoT Things Graph",
        serviceId: "IoTThingsGraph",
        signatureVersion: "v4",
        signingName: "iotthingsgraph",
        targetPrefix: "IotThingsGraphFrontEndService",
        uid: "iotthingsgraph-2018-09-06"
      },
      operations: {
        AssociateEntityToThing: {
          input: {
            type: "structure",
            required: [
              "thingName",
              "entityId"
            ],
            members: {
              thingName: {},
              entityId: {},
              namespaceVersion: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        CreateFlowTemplate: {
          input: {
            type: "structure",
            required: [
              "definition"
            ],
            members: {
              definition: {
                shape: "S7"
              },
              compatibleNamespaceVersion: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              summary: {
                shape: "Sb"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        CreateSystemInstance: {
          input: {
            type: "structure",
            required: [
              "definition",
              "target"
            ],
            members: {
              tags: {
                shape: "Sf"
              },
              definition: {
                shape: "S7"
              },
              target: {},
              greengrassGroupName: {},
              s3BucketName: {},
              metricsConfiguration: {
                shape: "Sm"
              },
              flowActionsRoleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              summary: {
                shape: "Sq"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        CreateSystemTemplate: {
          input: {
            type: "structure",
            required: [
              "definition"
            ],
            members: {
              definition: {
                shape: "S7"
              },
              compatibleNamespaceVersion: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              summary: {
                shape: "Sw"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        DeleteFlowTemplate: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        DeleteNamespace: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              namespaceArn: {},
              namespaceName: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        DeleteSystemInstance: {
          input: {
            type: "structure",
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        DeleteSystemTemplate: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        DeploySystemInstance: {
          input: {
            type: "structure",
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "summary"
            ],
            members: {
              summary: {
                shape: "Sq"
              },
              greengrassDeploymentId: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        DeprecateFlowTemplate: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        DeprecateSystemTemplate: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        DescribeNamespace: {
          input: {
            type: "structure",
            members: {
              namespaceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              namespaceArn: {},
              namespaceName: {},
              trackingNamespaceName: {},
              trackingNamespaceVersion: {
                type: "long"
              },
              namespaceVersion: {
                type: "long"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        DissociateEntityFromThing: {
          input: {
            type: "structure",
            required: [
              "thingName",
              "entityType"
            ],
            members: {
              thingName: {},
              entityType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        GetEntities: {
          input: {
            type: "structure",
            required: [
              "ids"
            ],
            members: {
              ids: {
                type: "list",
                member: {}
              },
              namespaceVersion: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              descriptions: {
                shape: "S1l"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        GetFlowTemplate: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {},
              revisionNumber: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              description: {
                type: "structure",
                members: {
                  summary: {
                    shape: "Sb"
                  },
                  definition: {
                    shape: "S7"
                  },
                  validatedNamespaceVersion: {
                    type: "long"
                  }
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        GetFlowTemplateRevisions: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              summaries: {
                shape: "S1u"
              },
              nextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        GetNamespaceDeletionStatus: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              namespaceArn: {},
              namespaceName: {},
              status: {},
              errorCode: {},
              errorMessage: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        GetSystemInstance: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              description: {
                type: "structure",
                members: {
                  summary: {
                    shape: "Sq"
                  },
                  definition: {
                    shape: "S7"
                  },
                  s3BucketName: {},
                  metricsConfiguration: {
                    shape: "Sm"
                  },
                  validatedNamespaceVersion: {
                    type: "long"
                  },
                  validatedDependencyRevisions: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        id: {},
                        revisionNumber: {
                          type: "long"
                        }
                      }
                    }
                  },
                  flowActionsRoleArn: {}
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        GetSystemTemplate: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {},
              revisionNumber: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              description: {
                type: "structure",
                members: {
                  summary: {
                    shape: "Sw"
                  },
                  definition: {
                    shape: "S7"
                  },
                  validatedNamespaceVersion: {
                    type: "long"
                  }
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        GetSystemTemplateRevisions: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              summaries: {
                shape: "S2a"
              },
              nextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        GetUploadStatus: {
          input: {
            type: "structure",
            required: [
              "uploadId"
            ],
            members: {
              uploadId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "uploadId",
              "uploadStatus",
              "createdDate"
            ],
            members: {
              uploadId: {},
              uploadStatus: {},
              namespaceArn: {},
              namespaceName: {},
              namespaceVersion: {
                type: "long"
              },
              failureReason: {
                type: "list",
                member: {}
              },
              createdDate: {
                type: "timestamp"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        ListFlowExecutionMessages: {
          input: {
            type: "structure",
            required: [
              "flowExecutionId"
            ],
            members: {
              flowExecutionId: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              messages: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    messageId: {},
                    eventType: {},
                    timestamp: {
                      type: "timestamp"
                    },
                    payload: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              maxResults: {
                type: "integer"
              },
              resourceArn: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sf"
              },
              nextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        SearchEntities: {
          input: {
            type: "structure",
            required: [
              "entityTypes"
            ],
            members: {
              entityTypes: {
                type: "list",
                member: {}
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    value: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              namespaceVersion: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              descriptions: {
                shape: "S1l"
              },
              nextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        SearchFlowExecutions: {
          input: {
            type: "structure",
            required: [
              "systemInstanceId"
            ],
            members: {
              systemInstanceId: {},
              flowExecutionId: {},
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              summaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    flowExecutionId: {},
                    status: {},
                    systemInstanceId: {},
                    flowTemplateId: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    updatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        SearchFlowTemplates: {
          input: {
            type: "structure",
            members: {
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "value"
                  ],
                  members: {
                    name: {},
                    value: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              summaries: {
                shape: "S1u"
              },
              nextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        SearchSystemInstances: {
          input: {
            type: "structure",
            members: {
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    value: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              summaries: {
                type: "list",
                member: {
                  shape: "Sq"
                }
              },
              nextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        SearchSystemTemplates: {
          input: {
            type: "structure",
            members: {
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "value"
                  ],
                  members: {
                    name: {},
                    value: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              summaries: {
                shape: "S2a"
              },
              nextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        SearchThings: {
          input: {
            type: "structure",
            required: [
              "entityId"
            ],
            members: {
              entityId: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              namespaceVersion: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              things: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    thingArn: {},
                    thingName: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        UndeploySystemInstance: {
          input: {
            type: "structure",
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              summary: {
                shape: "Sq"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        UpdateFlowTemplate: {
          input: {
            type: "structure",
            required: [
              "id",
              "definition"
            ],
            members: {
              id: {},
              definition: {
                shape: "S7"
              },
              compatibleNamespaceVersion: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              summary: {
                shape: "Sb"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        UpdateSystemTemplate: {
          input: {
            type: "structure",
            required: [
              "id",
              "definition"
            ],
            members: {
              id: {},
              definition: {
                shape: "S7"
              },
              compatibleNamespaceVersion: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              summary: {
                shape: "Sw"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        },
        UploadEntityDefinitions: {
          input: {
            type: "structure",
            members: {
              document: {
                shape: "S7"
              },
              syncWithPublicNamespace: {
                type: "boolean"
              },
              deprecateExistingEntities: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "uploadId"
            ],
            members: {
              uploadId: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "since: 2022-08-30"
        }
      },
      shapes: {
        S7: {
          type: "structure",
          required: [
            "language",
            "text"
          ],
          members: {
            language: {},
            text: {}
          }
        },
        Sb: {
          type: "structure",
          members: {
            id: {},
            arn: {},
            revisionNumber: {
              type: "long"
            },
            createdAt: {
              type: "timestamp"
            }
          }
        },
        Sf: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        Sm: {
          type: "structure",
          members: {
            cloudMetricEnabled: {
              type: "boolean"
            },
            metricRuleRoleArn: {}
          }
        },
        Sq: {
          type: "structure",
          members: {
            id: {},
            arn: {},
            status: {},
            target: {},
            greengrassGroupName: {},
            createdAt: {
              type: "timestamp"
            },
            updatedAt: {
              type: "timestamp"
            },
            greengrassGroupId: {},
            greengrassGroupVersionId: {}
          }
        },
        Sw: {
          type: "structure",
          members: {
            id: {},
            arn: {},
            revisionNumber: {
              type: "long"
            },
            createdAt: {
              type: "timestamp"
            }
          }
        },
        S1l: {
          type: "list",
          member: {
            type: "structure",
            members: {
              id: {},
              arn: {},
              type: {},
              createdAt: {
                type: "timestamp"
              },
              definition: {
                shape: "S7"
              }
            }
          }
        },
        S1u: {
          type: "list",
          member: {
            shape: "Sb"
          }
        },
        S2a: {
          type: "list",
          member: {
            shape: "Sw"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iotthingsgraph-2018-09-06.paginators.json
var require_iotthingsgraph_2018_09_06_paginators = __commonJS({
  "node_modules/aws-sdk/apis/iotthingsgraph-2018-09-06.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetFlowTemplateRevisions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "summaries"
        },
        GetSystemTemplateRevisions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "summaries"
        },
        ListFlowExecutionMessages: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "messages"
        },
        ListTagsForResource: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "tags"
        },
        SearchEntities: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "descriptions"
        },
        SearchFlowExecutions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "summaries"
        },
        SearchFlowTemplates: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "summaries"
        },
        SearchSystemInstances: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "summaries"
        },
        SearchSystemTemplates: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "summaries"
        },
        SearchThings: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "things"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/iotthingsgraph.js
var require_iotthingsgraph = __commonJS({
  "node_modules/aws-sdk/clients/iotthingsgraph.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["iotthingsgraph"] = {};
    AWS2.IoTThingsGraph = Service.defineService("iotthingsgraph", ["2018-09-06"]);
    Object.defineProperty(apiLoader.services["iotthingsgraph"], "2018-09-06", {
      get: function get() {
        var model = require_iotthingsgraph_2018_09_06_min();
        model.paginators = require_iotthingsgraph_2018_09_06_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.IoTThingsGraph;
  }
});

// node_modules/aws-sdk/apis/iotevents-2018-07-27.min.json
var require_iotevents_2018_07_27_min = __commonJS({
  "node_modules/aws-sdk/apis/iotevents-2018-07-27.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-07-27",
        endpointPrefix: "iotevents",
        protocol: "rest-json",
        serviceFullName: "AWS IoT Events",
        serviceId: "IoT Events",
        signatureVersion: "v4",
        signingName: "iotevents",
        uid: "iotevents-2018-07-27"
      },
      operations: {
        CreateAlarmModel: {
          http: {
            requestUri: "/alarm-models"
          },
          input: {
            type: "structure",
            required: [
              "alarmModelName",
              "roleArn",
              "alarmRule"
            ],
            members: {
              alarmModelName: {},
              alarmModelDescription: {},
              roleArn: {},
              tags: {
                shape: "S5"
              },
              key: {},
              severity: {
                type: "integer"
              },
              alarmRule: {
                shape: "Sb"
              },
              alarmNotification: {
                shape: "Sg"
              },
              alarmEventActions: {
                shape: "S13"
              },
              alarmCapabilities: {
                shape: "S23"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              creationTime: {
                type: "timestamp"
              },
              alarmModelArn: {},
              alarmModelVersion: {},
              lastUpdateTime: {
                type: "timestamp"
              },
              status: {}
            }
          }
        },
        CreateDetectorModel: {
          http: {
            requestUri: "/detector-models"
          },
          input: {
            type: "structure",
            required: [
              "detectorModelName",
              "detectorModelDefinition",
              "roleArn"
            ],
            members: {
              detectorModelName: {},
              detectorModelDefinition: {
                shape: "S2f"
              },
              detectorModelDescription: {},
              key: {},
              roleArn: {},
              tags: {
                shape: "S5"
              },
              evaluationMethod: {}
            }
          },
          output: {
            type: "structure",
            members: {
              detectorModelConfiguration: {
                shape: "S35"
              }
            }
          }
        },
        CreateInput: {
          http: {
            requestUri: "/inputs",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "inputName",
              "inputDefinition"
            ],
            members: {
              inputName: {},
              inputDescription: {},
              inputDefinition: {
                shape: "S3b"
              },
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              inputConfiguration: {
                shape: "S3f"
              }
            }
          }
        },
        DeleteAlarmModel: {
          http: {
            method: "DELETE",
            requestUri: "/alarm-models/{alarmModelName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "alarmModelName"
            ],
            members: {
              alarmModelName: {
                location: "uri",
                locationName: "alarmModelName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDetectorModel: {
          http: {
            method: "DELETE",
            requestUri: "/detector-models/{detectorModelName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "detectorModelName"
            ],
            members: {
              detectorModelName: {
                location: "uri",
                locationName: "detectorModelName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteInput: {
          http: {
            method: "DELETE",
            requestUri: "/inputs/{inputName}"
          },
          input: {
            type: "structure",
            required: [
              "inputName"
            ],
            members: {
              inputName: {
                location: "uri",
                locationName: "inputName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeAlarmModel: {
          http: {
            method: "GET",
            requestUri: "/alarm-models/{alarmModelName}"
          },
          input: {
            type: "structure",
            required: [
              "alarmModelName"
            ],
            members: {
              alarmModelName: {
                location: "uri",
                locationName: "alarmModelName"
              },
              alarmModelVersion: {
                location: "querystring",
                locationName: "version"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              creationTime: {
                type: "timestamp"
              },
              alarmModelArn: {},
              alarmModelVersion: {},
              lastUpdateTime: {
                type: "timestamp"
              },
              status: {},
              statusMessage: {},
              alarmModelName: {},
              alarmModelDescription: {},
              roleArn: {},
              key: {},
              severity: {
                type: "integer"
              },
              alarmRule: {
                shape: "Sb"
              },
              alarmNotification: {
                shape: "Sg"
              },
              alarmEventActions: {
                shape: "S13"
              },
              alarmCapabilities: {
                shape: "S23"
              }
            }
          }
        },
        DescribeDetectorModel: {
          http: {
            method: "GET",
            requestUri: "/detector-models/{detectorModelName}"
          },
          input: {
            type: "structure",
            required: [
              "detectorModelName"
            ],
            members: {
              detectorModelName: {
                location: "uri",
                locationName: "detectorModelName"
              },
              detectorModelVersion: {
                location: "querystring",
                locationName: "version"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              detectorModel: {
                type: "structure",
                members: {
                  detectorModelDefinition: {
                    shape: "S2f"
                  },
                  detectorModelConfiguration: {
                    shape: "S35"
                  }
                }
              }
            }
          }
        },
        DescribeDetectorModelAnalysis: {
          http: {
            method: "GET",
            requestUri: "/analysis/detector-models/{analysisId}"
          },
          input: {
            type: "structure",
            required: [
              "analysisId"
            ],
            members: {
              analysisId: {
                location: "uri",
                locationName: "analysisId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              status: {}
            }
          }
        },
        DescribeInput: {
          http: {
            method: "GET",
            requestUri: "/inputs/{inputName}"
          },
          input: {
            type: "structure",
            required: [
              "inputName"
            ],
            members: {
              inputName: {
                location: "uri",
                locationName: "inputName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              input: {
                type: "structure",
                members: {
                  inputConfiguration: {
                    shape: "S3f"
                  },
                  inputDefinition: {
                    shape: "S3b"
                  }
                }
              }
            }
          }
        },
        DescribeLoggingOptions: {
          http: {
            method: "GET",
            requestUri: "/logging"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              loggingOptions: {
                shape: "S43"
              }
            }
          }
        },
        GetDetectorModelAnalysisResults: {
          http: {
            method: "GET",
            requestUri: "/analysis/detector-models/{analysisId}/results"
          },
          input: {
            type: "structure",
            required: [
              "analysisId"
            ],
            members: {
              analysisId: {
                location: "uri",
                locationName: "analysisId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              analysisResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    type: {},
                    level: {},
                    message: {},
                    locations: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          path: {}
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAlarmModelVersions: {
          http: {
            method: "GET",
            requestUri: "/alarm-models/{alarmModelName}/versions"
          },
          input: {
            type: "structure",
            required: [
              "alarmModelName"
            ],
            members: {
              alarmModelName: {
                location: "uri",
                locationName: "alarmModelName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              alarmModelVersionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    alarmModelName: {},
                    alarmModelArn: {},
                    alarmModelVersion: {},
                    roleArn: {},
                    creationTime: {
                      type: "timestamp"
                    },
                    lastUpdateTime: {
                      type: "timestamp"
                    },
                    status: {},
                    statusMessage: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAlarmModels: {
          http: {
            method: "GET",
            requestUri: "/alarm-models"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              alarmModelSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    creationTime: {
                      type: "timestamp"
                    },
                    alarmModelDescription: {},
                    alarmModelName: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDetectorModelVersions: {
          http: {
            method: "GET",
            requestUri: "/detector-models/{detectorModelName}/versions"
          },
          input: {
            type: "structure",
            required: [
              "detectorModelName"
            ],
            members: {
              detectorModelName: {
                location: "uri",
                locationName: "detectorModelName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              detectorModelVersionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    detectorModelName: {},
                    detectorModelVersion: {},
                    detectorModelArn: {},
                    roleArn: {},
                    creationTime: {
                      type: "timestamp"
                    },
                    lastUpdateTime: {
                      type: "timestamp"
                    },
                    status: {},
                    evaluationMethod: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDetectorModels: {
          http: {
            method: "GET",
            requestUri: "/detector-models"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              detectorModelSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    detectorModelName: {},
                    detectorModelDescription: {},
                    creationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListInputRoutings: {
          http: {
            requestUri: "/input-routings"
          },
          input: {
            type: "structure",
            required: [
              "inputIdentifier"
            ],
            members: {
              inputIdentifier: {
                type: "structure",
                members: {
                  iotEventsInputIdentifier: {
                    type: "structure",
                    required: [
                      "inputName"
                    ],
                    members: {
                      inputName: {}
                    }
                  },
                  iotSiteWiseInputIdentifier: {
                    type: "structure",
                    members: {
                      iotSiteWiseAssetModelPropertyIdentifier: {
                        type: "structure",
                        required: [
                          "assetModelId",
                          "propertyId"
                        ],
                        members: {
                          assetModelId: {},
                          propertyId: {}
                        }
                      }
                    }
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              routedResources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    arn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListInputs: {
          http: {
            method: "GET",
            requestUri: "/inputs"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              inputSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    inputName: {},
                    inputDescription: {},
                    inputArn: {},
                    creationTime: {
                      type: "timestamp"
                    },
                    lastUpdateTime: {
                      type: "timestamp"
                    },
                    status: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S5"
              }
            }
          }
        },
        PutLoggingOptions: {
          http: {
            method: "PUT",
            requestUri: "/logging"
          },
          input: {
            type: "structure",
            required: [
              "loggingOptions"
            ],
            members: {
              loggingOptions: {
                shape: "S43"
              }
            }
          }
        },
        StartDetectorModelAnalysis: {
          http: {
            requestUri: "/analysis/detector-models/"
          },
          input: {
            type: "structure",
            required: [
              "detectorModelDefinition"
            ],
            members: {
              detectorModelDefinition: {
                shape: "S2f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              analysisId: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAlarmModel: {
          http: {
            requestUri: "/alarm-models/{alarmModelName}"
          },
          input: {
            type: "structure",
            required: [
              "alarmModelName",
              "roleArn",
              "alarmRule"
            ],
            members: {
              alarmModelName: {
                location: "uri",
                locationName: "alarmModelName"
              },
              alarmModelDescription: {},
              roleArn: {},
              severity: {
                type: "integer"
              },
              alarmRule: {
                shape: "Sb"
              },
              alarmNotification: {
                shape: "Sg"
              },
              alarmEventActions: {
                shape: "S13"
              },
              alarmCapabilities: {
                shape: "S23"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              creationTime: {
                type: "timestamp"
              },
              alarmModelArn: {},
              alarmModelVersion: {},
              lastUpdateTime: {
                type: "timestamp"
              },
              status: {}
            }
          }
        },
        UpdateDetectorModel: {
          http: {
            requestUri: "/detector-models/{detectorModelName}"
          },
          input: {
            type: "structure",
            required: [
              "detectorModelName",
              "detectorModelDefinition",
              "roleArn"
            ],
            members: {
              detectorModelName: {
                location: "uri",
                locationName: "detectorModelName"
              },
              detectorModelDefinition: {
                shape: "S2f"
              },
              detectorModelDescription: {},
              roleArn: {},
              evaluationMethod: {}
            }
          },
          output: {
            type: "structure",
            members: {
              detectorModelConfiguration: {
                shape: "S35"
              }
            }
          }
        },
        UpdateInput: {
          http: {
            method: "PUT",
            requestUri: "/inputs/{inputName}"
          },
          input: {
            type: "structure",
            required: [
              "inputName",
              "inputDefinition"
            ],
            members: {
              inputName: {
                location: "uri",
                locationName: "inputName"
              },
              inputDescription: {},
              inputDefinition: {
                shape: "S3b"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              inputConfiguration: {
                shape: "S3f"
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        Sb: {
          type: "structure",
          members: {
            simpleRule: {
              type: "structure",
              required: [
                "inputProperty",
                "comparisonOperator",
                "threshold"
              ],
              members: {
                inputProperty: {},
                comparisonOperator: {},
                threshold: {}
              }
            }
          }
        },
        Sg: {
          type: "structure",
          members: {
            notificationActions: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "action"
                ],
                members: {
                  action: {
                    type: "structure",
                    members: {
                      lambdaAction: {
                        shape: "Sk"
                      }
                    }
                  },
                  smsConfigurations: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "recipients"
                      ],
                      members: {
                        senderId: {},
                        additionalMessage: {},
                        recipients: {
                          shape: "Ss"
                        }
                      }
                    }
                  },
                  emailConfigurations: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "from",
                        "recipients"
                      ],
                      members: {
                        from: {},
                        content: {
                          type: "structure",
                          members: {
                            subject: {},
                            additionalMessage: {}
                          }
                        },
                        recipients: {
                          type: "structure",
                          members: {
                            to: {
                              shape: "Ss"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sk: {
          type: "structure",
          required: [
            "functionArn"
          ],
          members: {
            functionArn: {},
            payload: {
              shape: "Sl"
            }
          }
        },
        Sl: {
          type: "structure",
          required: [
            "contentExpression",
            "type"
          ],
          members: {
            contentExpression: {},
            type: {}
          }
        },
        Ss: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ssoIdentity: {
                type: "structure",
                required: [
                  "identityStoreId"
                ],
                members: {
                  identityStoreId: {},
                  userId: {}
                }
              }
            }
          }
        },
        S13: {
          type: "structure",
          members: {
            alarmActions: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  sns: {
                    shape: "S16"
                  },
                  iotTopicPublish: {
                    shape: "S17"
                  },
                  lambda: {
                    shape: "Sk"
                  },
                  iotEvents: {
                    shape: "S19"
                  },
                  sqs: {
                    shape: "S1b"
                  },
                  firehose: {
                    shape: "S1e"
                  },
                  dynamoDB: {
                    shape: "S1h"
                  },
                  dynamoDBv2: {
                    shape: "S1n"
                  },
                  iotSiteWise: {
                    shape: "S1o"
                  }
                }
              }
            }
          }
        },
        S16: {
          type: "structure",
          required: [
            "targetArn"
          ],
          members: {
            targetArn: {},
            payload: {
              shape: "Sl"
            }
          }
        },
        S17: {
          type: "structure",
          required: [
            "mqttTopic"
          ],
          members: {
            mqttTopic: {},
            payload: {
              shape: "Sl"
            }
          }
        },
        S19: {
          type: "structure",
          required: [
            "inputName"
          ],
          members: {
            inputName: {},
            payload: {
              shape: "Sl"
            }
          }
        },
        S1b: {
          type: "structure",
          required: [
            "queueUrl"
          ],
          members: {
            queueUrl: {},
            useBase64: {
              type: "boolean"
            },
            payload: {
              shape: "Sl"
            }
          }
        },
        S1e: {
          type: "structure",
          required: [
            "deliveryStreamName"
          ],
          members: {
            deliveryStreamName: {},
            separator: {},
            payload: {
              shape: "Sl"
            }
          }
        },
        S1h: {
          type: "structure",
          required: [
            "hashKeyField",
            "hashKeyValue",
            "tableName"
          ],
          members: {
            hashKeyType: {},
            hashKeyField: {},
            hashKeyValue: {},
            rangeKeyType: {},
            rangeKeyField: {},
            rangeKeyValue: {},
            operation: {},
            payloadField: {},
            tableName: {},
            payload: {
              shape: "Sl"
            }
          }
        },
        S1n: {
          type: "structure",
          required: [
            "tableName"
          ],
          members: {
            tableName: {},
            payload: {
              shape: "Sl"
            }
          }
        },
        S1o: {
          type: "structure",
          members: {
            entryId: {},
            assetId: {},
            propertyId: {},
            propertyAlias: {},
            propertyValue: {
              type: "structure",
              members: {
                value: {
                  type: "structure",
                  members: {
                    stringValue: {},
                    integerValue: {},
                    doubleValue: {},
                    booleanValue: {}
                  }
                },
                timestamp: {
                  type: "structure",
                  required: [
                    "timeInSeconds"
                  ],
                  members: {
                    timeInSeconds: {},
                    offsetInNanos: {}
                  }
                },
                quality: {}
              }
            }
          }
        },
        S23: {
          type: "structure",
          members: {
            initializationConfiguration: {
              type: "structure",
              required: [
                "disabledOnInitialization"
              ],
              members: {
                disabledOnInitialization: {
                  type: "boolean"
                }
              }
            },
            acknowledgeFlow: {
              type: "structure",
              required: [
                "enabled"
              ],
              members: {
                enabled: {
                  type: "boolean"
                }
              }
            }
          }
        },
        S2f: {
          type: "structure",
          required: [
            "states",
            "initialStateName"
          ],
          members: {
            states: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "stateName"
                ],
                members: {
                  stateName: {},
                  onInput: {
                    type: "structure",
                    members: {
                      events: {
                        shape: "S2k"
                      },
                      transitionEvents: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "eventName",
                            "condition",
                            "nextState"
                          ],
                          members: {
                            eventName: {},
                            condition: {},
                            actions: {
                              shape: "S2o"
                            },
                            nextState: {}
                          }
                        }
                      }
                    }
                  },
                  onEnter: {
                    type: "structure",
                    members: {
                      events: {
                        shape: "S2k"
                      }
                    }
                  },
                  onExit: {
                    type: "structure",
                    members: {
                      events: {
                        shape: "S2k"
                      }
                    }
                  }
                }
              }
            },
            initialStateName: {}
          }
        },
        S2k: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "eventName"
            ],
            members: {
              eventName: {},
              condition: {},
              actions: {
                shape: "S2o"
              }
            }
          }
        },
        S2o: {
          type: "list",
          member: {
            type: "structure",
            members: {
              setVariable: {
                type: "structure",
                required: [
                  "variableName",
                  "value"
                ],
                members: {
                  variableName: {},
                  value: {}
                }
              },
              sns: {
                shape: "S16"
              },
              iotTopicPublish: {
                shape: "S17"
              },
              setTimer: {
                type: "structure",
                required: [
                  "timerName"
                ],
                members: {
                  timerName: {},
                  seconds: {
                    deprecated: true,
                    deprecatedMessage: "seconds is deprecated. You can use durationExpression for SetTimerAction. The value of seconds can be used as a string expression for durationExpression.",
                    type: "integer"
                  },
                  durationExpression: {}
                }
              },
              clearTimer: {
                type: "structure",
                required: [
                  "timerName"
                ],
                members: {
                  timerName: {}
                }
              },
              resetTimer: {
                type: "structure",
                required: [
                  "timerName"
                ],
                members: {
                  timerName: {}
                }
              },
              lambda: {
                shape: "Sk"
              },
              iotEvents: {
                shape: "S19"
              },
              sqs: {
                shape: "S1b"
              },
              firehose: {
                shape: "S1e"
              },
              dynamoDB: {
                shape: "S1h"
              },
              dynamoDBv2: {
                shape: "S1n"
              },
              iotSiteWise: {
                shape: "S1o"
              }
            }
          }
        },
        S35: {
          type: "structure",
          members: {
            detectorModelName: {},
            detectorModelVersion: {},
            detectorModelDescription: {},
            detectorModelArn: {},
            roleArn: {},
            creationTime: {
              type: "timestamp"
            },
            lastUpdateTime: {
              type: "timestamp"
            },
            status: {},
            key: {},
            evaluationMethod: {}
          }
        },
        S3b: {
          type: "structure",
          required: [
            "attributes"
          ],
          members: {
            attributes: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "jsonPath"
                ],
                members: {
                  jsonPath: {}
                }
              }
            }
          }
        },
        S3f: {
          type: "structure",
          required: [
            "inputName",
            "inputArn",
            "creationTime",
            "lastUpdateTime",
            "status"
          ],
          members: {
            inputName: {},
            inputDescription: {},
            inputArn: {},
            creationTime: {
              type: "timestamp"
            },
            lastUpdateTime: {
              type: "timestamp"
            },
            status: {}
          }
        },
        S43: {
          type: "structure",
          required: [
            "roleArn",
            "level",
            "enabled"
          ],
          members: {
            roleArn: {},
            level: {},
            enabled: {
              type: "boolean"
            },
            detectorDebugOptions: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "detectorModelName"
                ],
                members: {
                  detectorModelName: {},
                  keyValue: {}
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iotevents-2018-07-27.paginators.json
var require_iotevents_2018_07_27_paginators = __commonJS({
  "node_modules/aws-sdk/apis/iotevents-2018-07-27.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/iotevents.js
var require_iotevents = __commonJS({
  "node_modules/aws-sdk/clients/iotevents.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["iotevents"] = {};
    AWS2.IoTEvents = Service.defineService("iotevents", ["2018-07-27"]);
    Object.defineProperty(apiLoader.services["iotevents"], "2018-07-27", {
      get: function get() {
        var model = require_iotevents_2018_07_27_min();
        model.paginators = require_iotevents_2018_07_27_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.IoTEvents;
  }
});

// node_modules/aws-sdk/apis/iotevents-data-2018-10-23.min.json
var require_iotevents_data_2018_10_23_min = __commonJS({
  "node_modules/aws-sdk/apis/iotevents-data-2018-10-23.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-10-23",
        endpointPrefix: "data.iotevents",
        protocol: "rest-json",
        serviceFullName: "AWS IoT Events Data",
        serviceId: "IoT Events Data",
        signatureVersion: "v4",
        signingName: "ioteventsdata",
        uid: "iotevents-data-2018-10-23"
      },
      operations: {
        BatchAcknowledgeAlarm: {
          http: {
            requestUri: "/alarms/acknowledge",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "acknowledgeActionRequests"
            ],
            members: {
              acknowledgeActionRequests: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "requestId",
                    "alarmModelName"
                  ],
                  members: {
                    requestId: {},
                    alarmModelName: {},
                    keyValue: {},
                    note: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errorEntries: {
                shape: "S9"
              }
            }
          }
        },
        BatchDeleteDetector: {
          http: {
            requestUri: "/detectors/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "detectors"
            ],
            members: {
              detectors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "messageId",
                    "detectorModelName"
                  ],
                  members: {
                    messageId: {},
                    detectorModelName: {},
                    keyValue: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              batchDeleteDetectorErrorEntries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    messageId: {},
                    errorCode: {},
                    errorMessage: {}
                  }
                }
              }
            }
          }
        },
        BatchDisableAlarm: {
          http: {
            requestUri: "/alarms/disable",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "disableActionRequests"
            ],
            members: {
              disableActionRequests: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "requestId",
                    "alarmModelName"
                  ],
                  members: {
                    requestId: {},
                    alarmModelName: {},
                    keyValue: {},
                    note: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errorEntries: {
                shape: "S9"
              }
            }
          }
        },
        BatchEnableAlarm: {
          http: {
            requestUri: "/alarms/enable",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "enableActionRequests"
            ],
            members: {
              enableActionRequests: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "requestId",
                    "alarmModelName"
                  ],
                  members: {
                    requestId: {},
                    alarmModelName: {},
                    keyValue: {},
                    note: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errorEntries: {
                shape: "S9"
              }
            }
          }
        },
        BatchPutMessage: {
          http: {
            requestUri: "/inputs/messages",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "messages"
            ],
            members: {
              messages: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "messageId",
                    "inputName",
                    "payload"
                  ],
                  members: {
                    messageId: {},
                    inputName: {},
                    payload: {
                      type: "blob"
                    },
                    timestamp: {
                      type: "structure",
                      members: {
                        timeInMillis: {
                          type: "long"
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BatchPutMessageErrorEntries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    messageId: {},
                    errorCode: {},
                    errorMessage: {}
                  }
                }
              }
            }
          }
        },
        BatchResetAlarm: {
          http: {
            requestUri: "/alarms/reset",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "resetActionRequests"
            ],
            members: {
              resetActionRequests: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "requestId",
                    "alarmModelName"
                  ],
                  members: {
                    requestId: {},
                    alarmModelName: {},
                    keyValue: {},
                    note: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errorEntries: {
                shape: "S9"
              }
            }
          }
        },
        BatchSnoozeAlarm: {
          http: {
            requestUri: "/alarms/snooze",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "snoozeActionRequests"
            ],
            members: {
              snoozeActionRequests: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "requestId",
                    "alarmModelName",
                    "snoozeDuration"
                  ],
                  members: {
                    requestId: {},
                    alarmModelName: {},
                    keyValue: {},
                    note: {},
                    snoozeDuration: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errorEntries: {
                shape: "S9"
              }
            }
          }
        },
        BatchUpdateDetector: {
          http: {
            requestUri: "/detectors",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "detectors"
            ],
            members: {
              detectors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "messageId",
                    "detectorModelName",
                    "state"
                  ],
                  members: {
                    messageId: {},
                    detectorModelName: {},
                    keyValue: {},
                    state: {
                      type: "structure",
                      required: [
                        "stateName",
                        "variables",
                        "timers"
                      ],
                      members: {
                        stateName: {},
                        variables: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "name",
                              "value"
                            ],
                            members: {
                              name: {},
                              value: {}
                            }
                          }
                        },
                        timers: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "name",
                              "seconds"
                            ],
                            members: {
                              name: {},
                              seconds: {
                                type: "integer"
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              batchUpdateDetectorErrorEntries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    messageId: {},
                    errorCode: {},
                    errorMessage: {}
                  }
                }
              }
            }
          }
        },
        DescribeAlarm: {
          http: {
            method: "GET",
            requestUri: "/alarms/{alarmModelName}/keyValues/"
          },
          input: {
            type: "structure",
            required: [
              "alarmModelName"
            ],
            members: {
              alarmModelName: {
                location: "uri",
                locationName: "alarmModelName"
              },
              keyValue: {
                location: "querystring",
                locationName: "keyValue"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              alarm: {
                type: "structure",
                members: {
                  alarmModelName: {},
                  alarmModelVersion: {},
                  keyValue: {},
                  alarmState: {
                    type: "structure",
                    members: {
                      stateName: {},
                      ruleEvaluation: {
                        type: "structure",
                        members: {
                          simpleRuleEvaluation: {
                            type: "structure",
                            members: {
                              inputPropertyValue: {},
                              operator: {},
                              thresholdValue: {}
                            }
                          }
                        }
                      },
                      customerAction: {
                        type: "structure",
                        members: {
                          actionName: {},
                          snoozeActionConfiguration: {
                            type: "structure",
                            members: {
                              snoozeDuration: {
                                type: "integer"
                              },
                              note: {}
                            }
                          },
                          enableActionConfiguration: {
                            type: "structure",
                            members: {
                              note: {}
                            }
                          },
                          disableActionConfiguration: {
                            type: "structure",
                            members: {
                              note: {}
                            }
                          },
                          acknowledgeActionConfiguration: {
                            type: "structure",
                            members: {
                              note: {}
                            }
                          },
                          resetActionConfiguration: {
                            type: "structure",
                            members: {
                              note: {}
                            }
                          }
                        }
                      },
                      systemEvent: {
                        type: "structure",
                        members: {
                          eventType: {},
                          stateChangeConfiguration: {
                            type: "structure",
                            members: {
                              triggerType: {}
                            }
                          }
                        }
                      }
                    }
                  },
                  severity: {
                    type: "integer"
                  },
                  creationTime: {
                    type: "timestamp"
                  },
                  lastUpdateTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        DescribeDetector: {
          http: {
            method: "GET",
            requestUri: "/detectors/{detectorModelName}/keyValues/"
          },
          input: {
            type: "structure",
            required: [
              "detectorModelName"
            ],
            members: {
              detectorModelName: {
                location: "uri",
                locationName: "detectorModelName"
              },
              keyValue: {
                location: "querystring",
                locationName: "keyValue"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              detector: {
                type: "structure",
                members: {
                  detectorModelName: {},
                  keyValue: {},
                  detectorModelVersion: {},
                  state: {
                    type: "structure",
                    required: [
                      "stateName",
                      "variables",
                      "timers"
                    ],
                    members: {
                      stateName: {},
                      variables: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "name",
                            "value"
                          ],
                          members: {
                            name: {},
                            value: {}
                          }
                        }
                      },
                      timers: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "name",
                            "timestamp"
                          ],
                          members: {
                            name: {},
                            timestamp: {
                              type: "timestamp"
                            }
                          }
                        }
                      }
                    }
                  },
                  creationTime: {
                    type: "timestamp"
                  },
                  lastUpdateTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        ListAlarms: {
          http: {
            method: "GET",
            requestUri: "/alarms/{alarmModelName}"
          },
          input: {
            type: "structure",
            required: [
              "alarmModelName"
            ],
            members: {
              alarmModelName: {
                location: "uri",
                locationName: "alarmModelName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              alarmSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    alarmModelName: {},
                    alarmModelVersion: {},
                    keyValue: {},
                    stateName: {},
                    creationTime: {
                      type: "timestamp"
                    },
                    lastUpdateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDetectors: {
          http: {
            method: "GET",
            requestUri: "/detectors/{detectorModelName}"
          },
          input: {
            type: "structure",
            required: [
              "detectorModelName"
            ],
            members: {
              detectorModelName: {
                location: "uri",
                locationName: "detectorModelName"
              },
              stateName: {
                location: "querystring",
                locationName: "stateName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              detectorSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    detectorModelName: {},
                    keyValue: {},
                    detectorModelVersion: {},
                    state: {
                      type: "structure",
                      members: {
                        stateName: {}
                      }
                    },
                    creationTime: {
                      type: "timestamp"
                    },
                    lastUpdateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        }
      },
      shapes: {
        S9: {
          type: "list",
          member: {
            type: "structure",
            members: {
              requestId: {},
              errorCode: {},
              errorMessage: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iotevents-data-2018-10-23.paginators.json
var require_iotevents_data_2018_10_23_paginators = __commonJS({
  "node_modules/aws-sdk/apis/iotevents-data-2018-10-23.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/ioteventsdata.js
var require_ioteventsdata = __commonJS({
  "node_modules/aws-sdk/clients/ioteventsdata.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["ioteventsdata"] = {};
    AWS2.IoTEventsData = Service.defineService("ioteventsdata", ["2018-10-23"]);
    Object.defineProperty(apiLoader.services["ioteventsdata"], "2018-10-23", {
      get: function get() {
        var model = require_iotevents_data_2018_10_23_min();
        model.paginators = require_iotevents_data_2018_10_23_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.IoTEventsData;
  }
});

// node_modules/aws-sdk/apis/personalize-2018-05-22.min.json
var require_personalize_2018_05_22_min = __commonJS({
  "node_modules/aws-sdk/apis/personalize-2018-05-22.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-05-22",
        endpointPrefix: "personalize",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Personalize",
        serviceId: "Personalize",
        signatureVersion: "v4",
        signingName: "personalize",
        targetPrefix: "AmazonPersonalize",
        uid: "personalize-2018-05-22"
      },
      operations: {
        CreateBatchInferenceJob: {
          input: {
            type: "structure",
            required: [
              "jobName",
              "solutionVersionArn",
              "jobInput",
              "jobOutput",
              "roleArn"
            ],
            members: {
              jobName: {},
              solutionVersionArn: {},
              filterArn: {},
              numResults: {
                type: "integer"
              },
              jobInput: {
                shape: "S5"
              },
              jobOutput: {
                shape: "S9"
              },
              roleArn: {},
              batchInferenceJobConfig: {
                shape: "Sb"
              },
              tags: {
                shape: "Sf"
              },
              batchInferenceJobMode: {},
              themeGenerationConfig: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              batchInferenceJobArn: {}
            }
          }
        },
        CreateBatchSegmentJob: {
          input: {
            type: "structure",
            required: [
              "jobName",
              "solutionVersionArn",
              "jobInput",
              "jobOutput",
              "roleArn"
            ],
            members: {
              jobName: {},
              solutionVersionArn: {},
              filterArn: {},
              numResults: {
                type: "integer"
              },
              jobInput: {
                shape: "Sp"
              },
              jobOutput: {
                shape: "Sq"
              },
              roleArn: {},
              tags: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              batchSegmentJobArn: {}
            }
          }
        },
        CreateCampaign: {
          input: {
            type: "structure",
            required: [
              "name",
              "solutionVersionArn"
            ],
            members: {
              name: {},
              solutionVersionArn: {},
              minProvisionedTPS: {
                type: "integer"
              },
              campaignConfig: {
                shape: "Su"
              },
              tags: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              campaignArn: {}
            }
          },
          idempotent: true
        },
        CreateDataset: {
          input: {
            type: "structure",
            required: [
              "name",
              "schemaArn",
              "datasetGroupArn",
              "datasetType"
            ],
            members: {
              name: {},
              schemaArn: {},
              datasetGroupArn: {},
              datasetType: {},
              tags: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datasetArn: {}
            }
          },
          idempotent: true
        },
        CreateDatasetExportJob: {
          input: {
            type: "structure",
            required: [
              "jobName",
              "datasetArn",
              "roleArn",
              "jobOutput"
            ],
            members: {
              jobName: {},
              datasetArn: {},
              ingestionMode: {},
              roleArn: {},
              jobOutput: {
                shape: "S12"
              },
              tags: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datasetExportJobArn: {}
            }
          },
          idempotent: true
        },
        CreateDatasetGroup: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              roleArn: {},
              kmsKeyArn: {},
              domain: {},
              tags: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datasetGroupArn: {},
              domain: {}
            }
          }
        },
        CreateDatasetImportJob: {
          input: {
            type: "structure",
            required: [
              "jobName",
              "datasetArn",
              "dataSource",
              "roleArn"
            ],
            members: {
              jobName: {},
              datasetArn: {},
              dataSource: {
                shape: "S18"
              },
              roleArn: {},
              tags: {
                shape: "Sf"
              },
              importMode: {},
              publishAttributionMetricsToS3: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datasetImportJobArn: {}
            }
          }
        },
        CreateEventTracker: {
          input: {
            type: "structure",
            required: [
              "name",
              "datasetGroupArn"
            ],
            members: {
              name: {},
              datasetGroupArn: {},
              tags: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              eventTrackerArn: {},
              trackingId: {}
            }
          },
          idempotent: true
        },
        CreateFilter: {
          input: {
            type: "structure",
            required: [
              "name",
              "datasetGroupArn",
              "filterExpression"
            ],
            members: {
              name: {},
              datasetGroupArn: {},
              filterExpression: {
                shape: "S1f"
              },
              tags: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              filterArn: {}
            }
          }
        },
        CreateMetricAttribution: {
          input: {
            type: "structure",
            required: [
              "name",
              "datasetGroupArn",
              "metrics",
              "metricsOutputConfig"
            ],
            members: {
              name: {},
              datasetGroupArn: {},
              metrics: {
                shape: "S1i"
              },
              metricsOutputConfig: {
                shape: "S1n"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              metricAttributionArn: {}
            }
          }
        },
        CreateRecommender: {
          input: {
            type: "structure",
            required: [
              "name",
              "datasetGroupArn",
              "recipeArn"
            ],
            members: {
              name: {},
              datasetGroupArn: {},
              recipeArn: {},
              recommenderConfig: {
                shape: "S1q"
              },
              tags: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              recommenderArn: {}
            }
          },
          idempotent: true
        },
        CreateSchema: {
          input: {
            type: "structure",
            required: [
              "name",
              "schema"
            ],
            members: {
              name: {},
              schema: {},
              domain: {}
            }
          },
          output: {
            type: "structure",
            members: {
              schemaArn: {}
            }
          },
          idempotent: true
        },
        CreateSolution: {
          input: {
            type: "structure",
            required: [
              "name",
              "datasetGroupArn"
            ],
            members: {
              name: {},
              performHPO: {
                type: "boolean"
              },
              performAutoML: {
                type: "boolean"
              },
              recipeArn: {},
              datasetGroupArn: {},
              eventType: {},
              solutionConfig: {
                shape: "S20"
              },
              tags: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              solutionArn: {}
            }
          }
        },
        CreateSolutionVersion: {
          input: {
            type: "structure",
            required: [
              "solutionArn"
            ],
            members: {
              name: {},
              solutionArn: {},
              trainingMode: {},
              tags: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              solutionVersionArn: {}
            }
          }
        },
        DeleteCampaign: {
          input: {
            type: "structure",
            required: [
              "campaignArn"
            ],
            members: {
              campaignArn: {}
            }
          },
          idempotent: true
        },
        DeleteDataset: {
          input: {
            type: "structure",
            required: [
              "datasetArn"
            ],
            members: {
              datasetArn: {}
            }
          },
          idempotent: true
        },
        DeleteDatasetGroup: {
          input: {
            type: "structure",
            required: [
              "datasetGroupArn"
            ],
            members: {
              datasetGroupArn: {}
            }
          },
          idempotent: true
        },
        DeleteEventTracker: {
          input: {
            type: "structure",
            required: [
              "eventTrackerArn"
            ],
            members: {
              eventTrackerArn: {}
            }
          },
          idempotent: true
        },
        DeleteFilter: {
          input: {
            type: "structure",
            required: [
              "filterArn"
            ],
            members: {
              filterArn: {}
            }
          }
        },
        DeleteMetricAttribution: {
          input: {
            type: "structure",
            required: [
              "metricAttributionArn"
            ],
            members: {
              metricAttributionArn: {}
            }
          },
          idempotent: true
        },
        DeleteRecommender: {
          input: {
            type: "structure",
            required: [
              "recommenderArn"
            ],
            members: {
              recommenderArn: {}
            }
          },
          idempotent: true
        },
        DeleteSchema: {
          input: {
            type: "structure",
            required: [
              "schemaArn"
            ],
            members: {
              schemaArn: {}
            }
          },
          idempotent: true
        },
        DeleteSolution: {
          input: {
            type: "structure",
            required: [
              "solutionArn"
            ],
            members: {
              solutionArn: {}
            }
          },
          idempotent: true
        },
        DescribeAlgorithm: {
          input: {
            type: "structure",
            required: [
              "algorithmArn"
            ],
            members: {
              algorithmArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              algorithm: {
                type: "structure",
                members: {
                  name: {},
                  algorithmArn: {},
                  algorithmImage: {
                    type: "structure",
                    required: [
                      "dockerURI"
                    ],
                    members: {
                      name: {},
                      dockerURI: {}
                    }
                  },
                  defaultHyperParameters: {
                    shape: "Sc"
                  },
                  defaultHyperParameterRanges: {
                    type: "structure",
                    members: {
                      integerHyperParameterRanges: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            name: {},
                            minValue: {
                              type: "integer"
                            },
                            maxValue: {
                              type: "integer"
                            },
                            isTunable: {
                              type: "boolean"
                            }
                          }
                        }
                      },
                      continuousHyperParameterRanges: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            name: {},
                            minValue: {
                              type: "double"
                            },
                            maxValue: {
                              type: "double"
                            },
                            isTunable: {
                              type: "boolean"
                            }
                          }
                        }
                      },
                      categoricalHyperParameterRanges: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            name: {},
                            values: {
                              shape: "S2j"
                            },
                            isTunable: {
                              type: "boolean"
                            }
                          }
                        }
                      }
                    }
                  },
                  defaultResourceConfig: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  trainingInputMode: {},
                  roleArn: {},
                  creationDateTime: {
                    type: "timestamp"
                  },
                  lastUpdatedDateTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          idempotent: true
        },
        DescribeBatchInferenceJob: {
          input: {
            type: "structure",
            required: [
              "batchInferenceJobArn"
            ],
            members: {
              batchInferenceJobArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              batchInferenceJob: {
                type: "structure",
                members: {
                  jobName: {},
                  batchInferenceJobArn: {},
                  filterArn: {},
                  failureReason: {},
                  solutionVersionArn: {},
                  numResults: {
                    type: "integer"
                  },
                  jobInput: {
                    shape: "S5"
                  },
                  jobOutput: {
                    shape: "S9"
                  },
                  batchInferenceJobConfig: {
                    shape: "Sb"
                  },
                  roleArn: {},
                  batchInferenceJobMode: {},
                  themeGenerationConfig: {
                    shape: "Sk"
                  },
                  status: {},
                  creationDateTime: {
                    type: "timestamp"
                  },
                  lastUpdatedDateTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          idempotent: true
        },
        DescribeBatchSegmentJob: {
          input: {
            type: "structure",
            required: [
              "batchSegmentJobArn"
            ],
            members: {
              batchSegmentJobArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              batchSegmentJob: {
                type: "structure",
                members: {
                  jobName: {},
                  batchSegmentJobArn: {},
                  filterArn: {},
                  failureReason: {},
                  solutionVersionArn: {},
                  numResults: {
                    type: "integer"
                  },
                  jobInput: {
                    shape: "Sp"
                  },
                  jobOutput: {
                    shape: "Sq"
                  },
                  roleArn: {},
                  status: {},
                  creationDateTime: {
                    type: "timestamp"
                  },
                  lastUpdatedDateTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          idempotent: true
        },
        DescribeCampaign: {
          input: {
            type: "structure",
            required: [
              "campaignArn"
            ],
            members: {
              campaignArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              campaign: {
                type: "structure",
                members: {
                  name: {},
                  campaignArn: {},
                  solutionVersionArn: {},
                  minProvisionedTPS: {
                    type: "integer"
                  },
                  campaignConfig: {
                    shape: "Su"
                  },
                  status: {},
                  failureReason: {},
                  creationDateTime: {
                    type: "timestamp"
                  },
                  lastUpdatedDateTime: {
                    type: "timestamp"
                  },
                  latestCampaignUpdate: {
                    type: "structure",
                    members: {
                      solutionVersionArn: {},
                      minProvisionedTPS: {
                        type: "integer"
                      },
                      campaignConfig: {
                        shape: "Su"
                      },
                      status: {},
                      failureReason: {},
                      creationDateTime: {
                        type: "timestamp"
                      },
                      lastUpdatedDateTime: {
                        type: "timestamp"
                      }
                    }
                  }
                }
              }
            }
          },
          idempotent: true
        },
        DescribeDataset: {
          input: {
            type: "structure",
            required: [
              "datasetArn"
            ],
            members: {
              datasetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              dataset: {
                type: "structure",
                members: {
                  name: {},
                  datasetArn: {},
                  datasetGroupArn: {},
                  datasetType: {},
                  schemaArn: {},
                  status: {},
                  creationDateTime: {
                    type: "timestamp"
                  },
                  lastUpdatedDateTime: {
                    type: "timestamp"
                  },
                  latestDatasetUpdate: {
                    type: "structure",
                    members: {
                      schemaArn: {},
                      status: {},
                      failureReason: {},
                      creationDateTime: {
                        type: "timestamp"
                      },
                      lastUpdatedDateTime: {
                        type: "timestamp"
                      }
                    }
                  },
                  trackingId: {}
                }
              }
            }
          },
          idempotent: true
        },
        DescribeDatasetExportJob: {
          input: {
            type: "structure",
            required: [
              "datasetExportJobArn"
            ],
            members: {
              datasetExportJobArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              datasetExportJob: {
                type: "structure",
                members: {
                  jobName: {},
                  datasetExportJobArn: {},
                  datasetArn: {},
                  ingestionMode: {},
                  roleArn: {},
                  status: {},
                  jobOutput: {
                    shape: "S12"
                  },
                  creationDateTime: {
                    type: "timestamp"
                  },
                  lastUpdatedDateTime: {
                    type: "timestamp"
                  },
                  failureReason: {}
                }
              }
            }
          },
          idempotent: true
        },
        DescribeDatasetGroup: {
          input: {
            type: "structure",
            required: [
              "datasetGroupArn"
            ],
            members: {
              datasetGroupArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              datasetGroup: {
                type: "structure",
                members: {
                  name: {},
                  datasetGroupArn: {},
                  status: {},
                  roleArn: {},
                  kmsKeyArn: {},
                  creationDateTime: {
                    type: "timestamp"
                  },
                  lastUpdatedDateTime: {
                    type: "timestamp"
                  },
                  failureReason: {},
                  domain: {}
                }
              }
            }
          },
          idempotent: true
        },
        DescribeDatasetImportJob: {
          input: {
            type: "structure",
            required: [
              "datasetImportJobArn"
            ],
            members: {
              datasetImportJobArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              datasetImportJob: {
                type: "structure",
                members: {
                  jobName: {},
                  datasetImportJobArn: {},
                  datasetArn: {},
                  dataSource: {
                    shape: "S18"
                  },
                  roleArn: {},
                  status: {},
                  creationDateTime: {
                    type: "timestamp"
                  },
                  lastUpdatedDateTime: {
                    type: "timestamp"
                  },
                  failureReason: {},
                  importMode: {},
                  publishAttributionMetricsToS3: {
                    type: "boolean"
                  }
                }
              }
            }
          },
          idempotent: true
        },
        DescribeEventTracker: {
          input: {
            type: "structure",
            required: [
              "eventTrackerArn"
            ],
            members: {
              eventTrackerArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              eventTracker: {
                type: "structure",
                members: {
                  name: {},
                  eventTrackerArn: {},
                  accountId: {},
                  trackingId: {},
                  datasetGroupArn: {},
                  status: {},
                  creationDateTime: {
                    type: "timestamp"
                  },
                  lastUpdatedDateTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          idempotent: true
        },
        DescribeFeatureTransformation: {
          input: {
            type: "structure",
            required: [
              "featureTransformationArn"
            ],
            members: {
              featureTransformationArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              featureTransformation: {
                type: "structure",
                members: {
                  name: {},
                  featureTransformationArn: {},
                  defaultParameters: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  creationDateTime: {
                    type: "timestamp"
                  },
                  lastUpdatedDateTime: {
                    type: "timestamp"
                  },
                  status: {}
                }
              }
            }
          },
          idempotent: true
        },
        DescribeFilter: {
          input: {
            type: "structure",
            required: [
              "filterArn"
            ],
            members: {
              filterArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              filter: {
                type: "structure",
                members: {
                  name: {},
                  filterArn: {},
                  creationDateTime: {
                    type: "timestamp"
                  },
                  lastUpdatedDateTime: {
                    type: "timestamp"
                  },
                  datasetGroupArn: {},
                  failureReason: {},
                  filterExpression: {
                    shape: "S1f"
                  },
                  status: {}
                }
              }
            }
          },
          idempotent: true
        },
        DescribeMetricAttribution: {
          input: {
            type: "structure",
            required: [
              "metricAttributionArn"
            ],
            members: {
              metricAttributionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              metricAttribution: {
                type: "structure",
                members: {
                  name: {},
                  metricAttributionArn: {},
                  datasetGroupArn: {},
                  metricsOutputConfig: {
                    shape: "S1n"
                  },
                  status: {},
                  creationDateTime: {
                    type: "timestamp"
                  },
                  lastUpdatedDateTime: {
                    type: "timestamp"
                  },
                  failureReason: {}
                }
              }
            }
          }
        },
        DescribeRecipe: {
          input: {
            type: "structure",
            required: [
              "recipeArn"
            ],
            members: {
              recipeArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              recipe: {
                type: "structure",
                members: {
                  name: {},
                  recipeArn: {},
                  algorithmArn: {},
                  featureTransformationArn: {},
                  status: {},
                  description: {},
                  creationDateTime: {
                    type: "timestamp"
                  },
                  recipeType: {},
                  lastUpdatedDateTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          idempotent: true
        },
        DescribeRecommender: {
          input: {
            type: "structure",
            required: [
              "recommenderArn"
            ],
            members: {
              recommenderArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              recommender: {
                type: "structure",
                members: {
                  recommenderArn: {},
                  datasetGroupArn: {},
                  name: {},
                  recipeArn: {},
                  recommenderConfig: {
                    shape: "S1q"
                  },
                  creationDateTime: {
                    type: "timestamp"
                  },
                  lastUpdatedDateTime: {
                    type: "timestamp"
                  },
                  status: {},
                  failureReason: {},
                  latestRecommenderUpdate: {
                    type: "structure",
                    members: {
                      recommenderConfig: {
                        shape: "S1q"
                      },
                      creationDateTime: {
                        type: "timestamp"
                      },
                      lastUpdatedDateTime: {
                        type: "timestamp"
                      },
                      status: {},
                      failureReason: {}
                    }
                  },
                  modelMetrics: {
                    shape: "S4w"
                  }
                }
              }
            }
          },
          idempotent: true
        },
        DescribeSchema: {
          input: {
            type: "structure",
            required: [
              "schemaArn"
            ],
            members: {
              schemaArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              schema: {
                type: "structure",
                members: {
                  name: {},
                  schemaArn: {},
                  schema: {},
                  creationDateTime: {
                    type: "timestamp"
                  },
                  lastUpdatedDateTime: {
                    type: "timestamp"
                  },
                  domain: {}
                }
              }
            }
          },
          idempotent: true
        },
        DescribeSolution: {
          input: {
            type: "structure",
            required: [
              "solutionArn"
            ],
            members: {
              solutionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              solution: {
                type: "structure",
                members: {
                  name: {},
                  solutionArn: {},
                  performHPO: {
                    type: "boolean"
                  },
                  performAutoML: {
                    type: "boolean"
                  },
                  recipeArn: {},
                  datasetGroupArn: {},
                  eventType: {},
                  solutionConfig: {
                    shape: "S20"
                  },
                  autoMLResult: {
                    type: "structure",
                    members: {
                      bestRecipeArn: {}
                    }
                  },
                  status: {},
                  creationDateTime: {
                    type: "timestamp"
                  },
                  lastUpdatedDateTime: {
                    type: "timestamp"
                  },
                  latestSolutionVersion: {
                    shape: "S56"
                  }
                }
              }
            }
          },
          idempotent: true
        },
        DescribeSolutionVersion: {
          input: {
            type: "structure",
            required: [
              "solutionVersionArn"
            ],
            members: {
              solutionVersionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              solutionVersion: {
                type: "structure",
                members: {
                  name: {},
                  solutionVersionArn: {},
                  solutionArn: {},
                  performHPO: {
                    type: "boolean"
                  },
                  performAutoML: {
                    type: "boolean"
                  },
                  recipeArn: {},
                  eventType: {},
                  datasetGroupArn: {},
                  solutionConfig: {
                    shape: "S20"
                  },
                  trainingHours: {
                    type: "double"
                  },
                  trainingMode: {},
                  tunedHPOParams: {
                    type: "structure",
                    members: {
                      algorithmHyperParameters: {
                        shape: "Sc"
                      }
                    }
                  },
                  status: {},
                  failureReason: {},
                  creationDateTime: {
                    type: "timestamp"
                  },
                  lastUpdatedDateTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          idempotent: true
        },
        GetSolutionMetrics: {
          input: {
            type: "structure",
            required: [
              "solutionVersionArn"
            ],
            members: {
              solutionVersionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              solutionVersionArn: {},
              metrics: {
                shape: "S4w"
              }
            }
          }
        },
        ListBatchInferenceJobs: {
          input: {
            type: "structure",
            members: {
              solutionVersionArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              batchInferenceJobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    batchInferenceJobArn: {},
                    jobName: {},
                    status: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    failureReason: {},
                    solutionVersionArn: {},
                    batchInferenceJobMode: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListBatchSegmentJobs: {
          input: {
            type: "structure",
            members: {
              solutionVersionArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              batchSegmentJobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    batchSegmentJobArn: {},
                    jobName: {},
                    status: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    failureReason: {},
                    solutionVersionArn: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListCampaigns: {
          input: {
            type: "structure",
            members: {
              solutionArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              campaigns: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    campaignArn: {},
                    status: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    failureReason: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListDatasetExportJobs: {
          input: {
            type: "structure",
            members: {
              datasetArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datasetExportJobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    datasetExportJobArn: {},
                    jobName: {},
                    status: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    failureReason: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListDatasetGroups: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datasetGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    datasetGroupArn: {},
                    status: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    failureReason: {},
                    domain: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListDatasetImportJobs: {
          input: {
            type: "structure",
            members: {
              datasetArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datasetImportJobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    datasetImportJobArn: {},
                    jobName: {},
                    status: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    failureReason: {},
                    importMode: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListDatasets: {
          input: {
            type: "structure",
            members: {
              datasetGroupArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datasets: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    datasetArn: {},
                    datasetType: {},
                    status: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListEventTrackers: {
          input: {
            type: "structure",
            members: {
              datasetGroupArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              eventTrackers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    eventTrackerArn: {},
                    status: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListFilters: {
          input: {
            type: "structure",
            members: {
              datasetGroupArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    filterArn: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    datasetGroupArn: {},
                    failureReason: {},
                    status: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListMetricAttributionMetrics: {
          input: {
            type: "structure",
            members: {
              metricAttributionArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              metrics: {
                shape: "S1i"
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListMetricAttributions: {
          input: {
            type: "structure",
            members: {
              datasetGroupArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              metricAttributions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    metricAttributionArn: {},
                    status: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    failureReason: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListRecipes: {
          input: {
            type: "structure",
            members: {
              recipeProvider: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              domain: {}
            }
          },
          output: {
            type: "structure",
            members: {
              recipes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    recipeArn: {},
                    status: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    domain: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListRecommenders: {
          input: {
            type: "structure",
            members: {
              datasetGroupArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              recommenders: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    recommenderArn: {},
                    datasetGroupArn: {},
                    recipeArn: {},
                    recommenderConfig: {
                      shape: "S1q"
                    },
                    status: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListSchemas: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              schemas: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    schemaArn: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    domain: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListSolutionVersions: {
          input: {
            type: "structure",
            members: {
              solutionArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              solutionVersions: {
                type: "list",
                member: {
                  shape: "S56"
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListSolutions: {
          input: {
            type: "structure",
            members: {
              datasetGroupArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              solutions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    solutionArn: {},
                    status: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    recipeArn: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sf"
              }
            }
          }
        },
        StartRecommender: {
          input: {
            type: "structure",
            required: [
              "recommenderArn"
            ],
            members: {
              recommenderArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              recommenderArn: {}
            }
          },
          idempotent: true
        },
        StopRecommender: {
          input: {
            type: "structure",
            required: [
              "recommenderArn"
            ],
            members: {
              recommenderArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              recommenderArn: {}
            }
          },
          idempotent: true
        },
        StopSolutionVersionCreation: {
          input: {
            type: "structure",
            required: [
              "solutionVersionArn"
            ],
            members: {
              solutionVersionArn: {}
            }
          },
          idempotent: true
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateCampaign: {
          input: {
            type: "structure",
            required: [
              "campaignArn"
            ],
            members: {
              campaignArn: {},
              solutionVersionArn: {},
              minProvisionedTPS: {
                type: "integer"
              },
              campaignConfig: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              campaignArn: {}
            }
          },
          idempotent: true
        },
        UpdateDataset: {
          input: {
            type: "structure",
            required: [
              "datasetArn",
              "schemaArn"
            ],
            members: {
              datasetArn: {},
              schemaArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              datasetArn: {}
            }
          },
          idempotent: true
        },
        UpdateMetricAttribution: {
          input: {
            type: "structure",
            members: {
              addMetrics: {
                shape: "S1i"
              },
              removeMetrics: {
                type: "list",
                member: {}
              },
              metricsOutputConfig: {
                shape: "S1n"
              },
              metricAttributionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              metricAttributionArn: {}
            }
          }
        },
        UpdateRecommender: {
          input: {
            type: "structure",
            required: [
              "recommenderArn",
              "recommenderConfig"
            ],
            members: {
              recommenderArn: {},
              recommenderConfig: {
                shape: "S1q"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              recommenderArn: {}
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S5: {
          type: "structure",
          required: [
            "s3DataSource"
          ],
          members: {
            s3DataSource: {
              shape: "S6"
            }
          }
        },
        S6: {
          type: "structure",
          required: [
            "path"
          ],
          members: {
            path: {},
            kmsKeyArn: {}
          }
        },
        S9: {
          type: "structure",
          required: [
            "s3DataDestination"
          ],
          members: {
            s3DataDestination: {
              shape: "S6"
            }
          }
        },
        Sb: {
          type: "structure",
          members: {
            itemExplorationConfig: {
              shape: "Sc"
            }
          }
        },
        Sc: {
          type: "map",
          key: {},
          value: {}
        },
        Sf: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "tagKey",
              "tagValue"
            ],
            members: {
              tagKey: {},
              tagValue: {}
            }
          }
        },
        Sk: {
          type: "structure",
          required: [
            "fieldsForThemeGeneration"
          ],
          members: {
            fieldsForThemeGeneration: {
              type: "structure",
              required: [
                "itemName"
              ],
              members: {
                itemName: {}
              }
            }
          }
        },
        Sp: {
          type: "structure",
          required: [
            "s3DataSource"
          ],
          members: {
            s3DataSource: {
              shape: "S6"
            }
          }
        },
        Sq: {
          type: "structure",
          required: [
            "s3DataDestination"
          ],
          members: {
            s3DataDestination: {
              shape: "S6"
            }
          }
        },
        Su: {
          type: "structure",
          members: {
            itemExplorationConfig: {
              shape: "Sc"
            },
            enableMetadataWithRecommendations: {
              type: "boolean"
            }
          }
        },
        S12: {
          type: "structure",
          required: [
            "s3DataDestination"
          ],
          members: {
            s3DataDestination: {
              shape: "S6"
            }
          }
        },
        S18: {
          type: "structure",
          members: {
            dataLocation: {}
          }
        },
        S1f: {
          type: "string",
          sensitive: true
        },
        S1i: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "eventType",
              "metricName",
              "expression"
            ],
            members: {
              eventType: {},
              metricName: {},
              expression: {}
            }
          }
        },
        S1n: {
          type: "structure",
          required: [
            "roleArn"
          ],
          members: {
            s3DataDestination: {
              shape: "S6"
            },
            roleArn: {}
          }
        },
        S1q: {
          type: "structure",
          members: {
            itemExplorationConfig: {
              shape: "Sc"
            },
            minRecommendationRequestsPerSecond: {
              type: "integer"
            },
            trainingDataConfig: {
              shape: "S1r"
            },
            enableMetadataWithRecommendations: {
              type: "boolean"
            }
          }
        },
        S1r: {
          type: "structure",
          members: {
            excludedDatasetColumns: {
              type: "map",
              key: {},
              value: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S20: {
          type: "structure",
          members: {
            eventValueThreshold: {},
            hpoConfig: {
              type: "structure",
              members: {
                hpoObjective: {
                  type: "structure",
                  members: {
                    type: {},
                    metricName: {},
                    metricRegex: {}
                  }
                },
                hpoResourceConfig: {
                  type: "structure",
                  members: {
                    maxNumberOfTrainingJobs: {},
                    maxParallelTrainingJobs: {}
                  }
                },
                algorithmHyperParameterRanges: {
                  type: "structure",
                  members: {
                    integerHyperParameterRanges: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          minValue: {
                            type: "integer"
                          },
                          maxValue: {
                            type: "integer"
                          }
                        }
                      }
                    },
                    continuousHyperParameterRanges: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          minValue: {
                            type: "double"
                          },
                          maxValue: {
                            type: "double"
                          }
                        }
                      }
                    },
                    categoricalHyperParameterRanges: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          values: {
                            shape: "S2j"
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            algorithmHyperParameters: {
              shape: "Sc"
            },
            featureTransformationParameters: {
              type: "map",
              key: {},
              value: {}
            },
            autoMLConfig: {
              type: "structure",
              members: {
                metricName: {},
                recipeList: {
                  type: "list",
                  member: {}
                }
              }
            },
            optimizationObjective: {
              type: "structure",
              members: {
                itemAttribute: {},
                objectiveSensitivity: {}
              }
            },
            trainingDataConfig: {
              shape: "S1r"
            }
          }
        },
        S2j: {
          type: "list",
          member: {}
        },
        S4w: {
          type: "map",
          key: {},
          value: {
            type: "double"
          }
        },
        S56: {
          type: "structure",
          members: {
            solutionVersionArn: {},
            status: {},
            creationDateTime: {
              type: "timestamp"
            },
            lastUpdatedDateTime: {
              type: "timestamp"
            },
            failureReason: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/personalize-2018-05-22.paginators.json
var require_personalize_2018_05_22_paginators = __commonJS({
  "node_modules/aws-sdk/apis/personalize-2018-05-22.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListBatchInferenceJobs: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "batchInferenceJobs"
        },
        ListBatchSegmentJobs: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "batchSegmentJobs"
        },
        ListCampaigns: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "campaigns"
        },
        ListDatasetExportJobs: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "datasetExportJobs"
        },
        ListDatasetGroups: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "datasetGroups"
        },
        ListDatasetImportJobs: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "datasetImportJobs"
        },
        ListDatasets: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "datasets"
        },
        ListEventTrackers: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "eventTrackers"
        },
        ListFilters: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "Filters"
        },
        ListMetricAttributionMetrics: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "metrics"
        },
        ListMetricAttributions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "metricAttributions"
        },
        ListRecipes: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "recipes"
        },
        ListRecommenders: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "recommenders"
        },
        ListSchemas: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "schemas"
        },
        ListSolutionVersions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "solutionVersions"
        },
        ListSolutions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "solutions"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/personalize.js
var require_personalize = __commonJS({
  "node_modules/aws-sdk/clients/personalize.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["personalize"] = {};
    AWS2.Personalize = Service.defineService("personalize", ["2018-05-22"]);
    Object.defineProperty(apiLoader.services["personalize"], "2018-05-22", {
      get: function get() {
        var model = require_personalize_2018_05_22_min();
        model.paginators = require_personalize_2018_05_22_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Personalize;
  }
});

// node_modules/aws-sdk/apis/personalize-events-2018-03-22.min.json
var require_personalize_events_2018_03_22_min = __commonJS({
  "node_modules/aws-sdk/apis/personalize-events-2018-03-22.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-03-22",
        endpointPrefix: "personalize-events",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Personalize Events",
        serviceId: "Personalize Events",
        signatureVersion: "v4",
        signingName: "personalize",
        uid: "personalize-events-2018-03-22"
      },
      operations: {
        PutActionInteractions: {
          http: {
            requestUri: "/action-interactions"
          },
          input: {
            type: "structure",
            required: [
              "trackingId",
              "actionInteractions"
            ],
            members: {
              trackingId: {},
              actionInteractions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "actionId",
                    "sessionId",
                    "timestamp",
                    "eventType"
                  ],
                  members: {
                    actionId: {
                      shape: "S5"
                    },
                    userId: {
                      shape: "S6"
                    },
                    sessionId: {},
                    timestamp: {
                      type: "timestamp"
                    },
                    eventType: {},
                    eventId: {},
                    recommendationId: {},
                    impression: {
                      type: "list",
                      member: {
                        shape: "S5"
                      }
                    },
                    properties: {
                      jsonvalue: true,
                      type: "string",
                      sensitive: true
                    }
                  }
                }
              }
            }
          }
        },
        PutActions: {
          http: {
            requestUri: "/actions"
          },
          input: {
            type: "structure",
            required: [
              "datasetArn",
              "actions"
            ],
            members: {
              datasetArn: {},
              actions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "actionId"
                  ],
                  members: {
                    actionId: {},
                    properties: {
                      jsonvalue: true,
                      type: "string",
                      sensitive: true
                    }
                  }
                }
              }
            }
          }
        },
        PutEvents: {
          http: {
            requestUri: "/events"
          },
          input: {
            type: "structure",
            required: [
              "trackingId",
              "sessionId",
              "eventList"
            ],
            members: {
              trackingId: {},
              userId: {
                shape: "S6"
              },
              sessionId: {},
              eventList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "eventType",
                    "sentAt"
                  ],
                  members: {
                    eventId: {},
                    eventType: {},
                    eventValue: {
                      type: "float"
                    },
                    itemId: {
                      shape: "Sk"
                    },
                    properties: {
                      jsonvalue: true,
                      type: "string",
                      sensitive: true
                    },
                    sentAt: {
                      type: "timestamp"
                    },
                    recommendationId: {},
                    impression: {
                      type: "list",
                      member: {
                        shape: "Sk"
                      }
                    },
                    metricAttribution: {
                      type: "structure",
                      required: [
                        "eventAttributionSource"
                      ],
                      members: {
                        eventAttributionSource: {}
                      }
                    }
                  },
                  sensitive: true
                }
              }
            }
          }
        },
        PutItems: {
          http: {
            requestUri: "/items"
          },
          input: {
            type: "structure",
            required: [
              "datasetArn",
              "items"
            ],
            members: {
              datasetArn: {},
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "itemId"
                  ],
                  members: {
                    itemId: {},
                    properties: {
                      jsonvalue: true,
                      type: "string",
                      sensitive: true
                    }
                  }
                }
              }
            }
          }
        },
        PutUsers: {
          http: {
            requestUri: "/users"
          },
          input: {
            type: "structure",
            required: [
              "datasetArn",
              "users"
            ],
            members: {
              datasetArn: {},
              users: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "userId"
                  ],
                  members: {
                    userId: {},
                    properties: {
                      jsonvalue: true,
                      type: "string",
                      sensitive: true
                    }
                  }
                }
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "string",
          sensitive: true
        },
        S6: {
          type: "string",
          sensitive: true
        },
        Sk: {
          type: "string",
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/personalize-events-2018-03-22.paginators.json
var require_personalize_events_2018_03_22_paginators = __commonJS({
  "node_modules/aws-sdk/apis/personalize-events-2018-03-22.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/personalizeevents.js
var require_personalizeevents = __commonJS({
  "node_modules/aws-sdk/clients/personalizeevents.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["personalizeevents"] = {};
    AWS2.PersonalizeEvents = Service.defineService("personalizeevents", ["2018-03-22"]);
    Object.defineProperty(apiLoader.services["personalizeevents"], "2018-03-22", {
      get: function get() {
        var model = require_personalize_events_2018_03_22_min();
        model.paginators = require_personalize_events_2018_03_22_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.PersonalizeEvents;
  }
});

// node_modules/aws-sdk/apis/personalize-runtime-2018-05-22.min.json
var require_personalize_runtime_2018_05_22_min = __commonJS({
  "node_modules/aws-sdk/apis/personalize-runtime-2018-05-22.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-05-22",
        endpointPrefix: "personalize-runtime",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Personalize Runtime",
        serviceId: "Personalize Runtime",
        signatureVersion: "v4",
        signingName: "personalize",
        uid: "personalize-runtime-2018-05-22"
      },
      operations: {
        GetActionRecommendations: {
          http: {
            requestUri: "/action-recommendations"
          },
          input: {
            type: "structure",
            members: {
              campaignArn: {},
              userId: {},
              numResults: {
                type: "integer"
              },
              filterArn: {},
              filterValues: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              actionList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    actionId: {},
                    score: {
                      type: "double"
                    }
                  }
                }
              },
              recommendationId: {}
            }
          },
          idempotent: true
        },
        GetPersonalizedRanking: {
          http: {
            requestUri: "/personalize-ranking"
          },
          input: {
            type: "structure",
            required: [
              "campaignArn",
              "inputList",
              "userId"
            ],
            members: {
              campaignArn: {},
              inputList: {
                type: "list",
                member: {}
              },
              userId: {},
              context: {
                shape: "Sh"
              },
              filterArn: {},
              filterValues: {
                shape: "S5"
              },
              metadataColumns: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              personalizedRanking: {
                shape: "Sp"
              },
              recommendationId: {}
            }
          },
          idempotent: true
        },
        GetRecommendations: {
          http: {
            requestUri: "/recommendations"
          },
          input: {
            type: "structure",
            members: {
              campaignArn: {},
              itemId: {},
              userId: {},
              numResults: {
                type: "integer"
              },
              context: {
                shape: "Sh"
              },
              filterArn: {},
              filterValues: {
                shape: "S5"
              },
              recommenderArn: {},
              promotions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    percentPromotedItems: {
                      type: "integer"
                    },
                    filterArn: {},
                    filterValues: {
                      shape: "S5"
                    }
                  }
                }
              },
              metadataColumns: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              itemList: {
                shape: "Sp"
              },
              recommendationId: {}
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S5: {
          type: "map",
          key: {},
          value: {
            type: "string",
            sensitive: true
          }
        },
        Sh: {
          type: "map",
          key: {},
          value: {
            type: "string",
            sensitive: true
          }
        },
        Sk: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {}
          }
        },
        Sp: {
          type: "list",
          member: {
            type: "structure",
            members: {
              itemId: {},
              score: {
                type: "double"
              },
              promotionName: {},
              metadata: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/personalize-runtime-2018-05-22.paginators.json
var require_personalize_runtime_2018_05_22_paginators = __commonJS({
  "node_modules/aws-sdk/apis/personalize-runtime-2018-05-22.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/personalizeruntime.js
var require_personalizeruntime = __commonJS({
  "node_modules/aws-sdk/clients/personalizeruntime.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["personalizeruntime"] = {};
    AWS2.PersonalizeRuntime = Service.defineService("personalizeruntime", ["2018-05-22"]);
    Object.defineProperty(apiLoader.services["personalizeruntime"], "2018-05-22", {
      get: function get() {
        var model = require_personalize_runtime_2018_05_22_min();
        model.paginators = require_personalize_runtime_2018_05_22_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.PersonalizeRuntime;
  }
});

// node_modules/aws-sdk/apis/application-insights-2018-11-25.min.json
var require_application_insights_2018_11_25_min = __commonJS({
  "node_modules/aws-sdk/apis/application-insights-2018-11-25.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-11-25",
        endpointPrefix: "applicationinsights",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Application Insights",
        serviceFullName: "Amazon CloudWatch Application Insights",
        serviceId: "Application Insights",
        signatureVersion: "v4",
        signingName: "applicationinsights",
        targetPrefix: "EC2WindowsBarleyService",
        uid: "application-insights-2018-11-25"
      },
      operations: {
        AddWorkload: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName",
              "ComponentName",
              "WorkloadConfiguration"
            ],
            members: {
              ResourceGroupName: {},
              ComponentName: {},
              WorkloadConfiguration: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              WorkloadConfiguration: {
                shape: "S4"
              }
            }
          }
        },
        CreateApplication: {
          input: {
            type: "structure",
            members: {
              ResourceGroupName: {},
              OpsCenterEnabled: {
                type: "boolean"
              },
              CWEMonitorEnabled: {
                type: "boolean"
              },
              OpsItemSNSTopicArn: {},
              Tags: {
                shape: "Se"
              },
              AutoConfigEnabled: {
                type: "boolean"
              },
              AutoCreate: {
                type: "boolean"
              },
              GroupingType: {},
              AttachMissingPermission: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationInfo: {
                shape: "Sn"
              }
            }
          }
        },
        CreateComponent: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName",
              "ComponentName",
              "ResourceList"
            ],
            members: {
              ResourceGroupName: {},
              ComponentName: {},
              ResourceList: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateLogPattern: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName",
              "PatternSetName",
              "PatternName",
              "Pattern",
              "Rank"
            ],
            members: {
              ResourceGroupName: {},
              PatternSetName: {},
              PatternName: {},
              Pattern: {},
              Rank: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LogPattern: {
                shape: "S13"
              },
              ResourceGroupName: {}
            }
          }
        },
        DeleteApplication: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName"
            ],
            members: {
              ResourceGroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteComponent: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName",
              "ComponentName"
            ],
            members: {
              ResourceGroupName: {},
              ComponentName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteLogPattern: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName",
              "PatternSetName",
              "PatternName"
            ],
            members: {
              ResourceGroupName: {},
              PatternSetName: {},
              PatternName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeApplication: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName"
            ],
            members: {
              ResourceGroupName: {},
              AccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationInfo: {
                shape: "Sn"
              }
            }
          }
        },
        DescribeComponent: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName",
              "ComponentName"
            ],
            members: {
              ResourceGroupName: {},
              ComponentName: {},
              AccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationComponent: {
                shape: "S1e"
              },
              ResourceList: {
                shape: "Su"
              }
            }
          }
        },
        DescribeComponentConfiguration: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName",
              "ComponentName"
            ],
            members: {
              ResourceGroupName: {},
              ComponentName: {},
              AccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Monitor: {
                type: "boolean"
              },
              Tier: {},
              ComponentConfiguration: {}
            }
          }
        },
        DescribeComponentConfigurationRecommendation: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName",
              "ComponentName",
              "Tier"
            ],
            members: {
              ResourceGroupName: {},
              ComponentName: {},
              Tier: {},
              WorkloadName: {},
              RecommendationType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ComponentConfiguration: {}
            }
          }
        },
        DescribeLogPattern: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName",
              "PatternSetName",
              "PatternName"
            ],
            members: {
              ResourceGroupName: {},
              PatternSetName: {},
              PatternName: {},
              AccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceGroupName: {},
              AccountId: {},
              LogPattern: {
                shape: "S13"
              }
            }
          }
        },
        DescribeObservation: {
          input: {
            type: "structure",
            required: [
              "ObservationId"
            ],
            members: {
              ObservationId: {},
              AccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Observation: {
                shape: "S1w"
              }
            }
          }
        },
        DescribeProblem: {
          input: {
            type: "structure",
            required: [
              "ProblemId"
            ],
            members: {
              ProblemId: {},
              AccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Problem: {
                shape: "S38"
              }
            }
          }
        },
        DescribeProblemObservations: {
          input: {
            type: "structure",
            required: [
              "ProblemId"
            ],
            members: {
              ProblemId: {},
              AccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RelatedObservations: {
                type: "structure",
                members: {
                  ObservationList: {
                    type: "list",
                    member: {
                      shape: "S1w"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeWorkload: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName",
              "ComponentName",
              "WorkloadId"
            ],
            members: {
              ResourceGroupName: {},
              ComponentName: {},
              WorkloadId: {},
              AccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              WorkloadRemarks: {},
              WorkloadConfiguration: {
                shape: "S4"
              }
            }
          }
        },
        ListApplications: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              AccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationInfoList: {
                type: "list",
                member: {
                  shape: "Sn"
                }
              },
              NextToken: {}
            }
          }
        },
        ListComponents: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName"
            ],
            members: {
              ResourceGroupName: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              AccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationComponentList: {
                type: "list",
                member: {
                  shape: "S1e"
                }
              },
              NextToken: {}
            }
          }
        },
        ListConfigurationHistory: {
          input: {
            type: "structure",
            members: {
              ResourceGroupName: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              EventStatus: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              AccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EventList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceGroupName: {},
                    AccountId: {},
                    MonitoredResourceARN: {},
                    EventStatus: {},
                    EventResourceType: {},
                    EventTime: {
                      type: "timestamp"
                    },
                    EventDetail: {},
                    EventResourceName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListLogPatternSets: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName"
            ],
            members: {
              ResourceGroupName: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              AccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceGroupName: {},
              AccountId: {},
              LogPatternSets: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListLogPatterns: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName"
            ],
            members: {
              ResourceGroupName: {},
              PatternSetName: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              AccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceGroupName: {},
              AccountId: {},
              LogPatterns: {
                type: "list",
                member: {
                  shape: "S13"
                }
              },
              NextToken: {}
            }
          }
        },
        ListProblems: {
          input: {
            type: "structure",
            members: {
              AccountId: {},
              ResourceGroupName: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              ComponentName: {},
              Visibility: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProblemList: {
                type: "list",
                member: {
                  shape: "S38"
                }
              },
              NextToken: {},
              ResourceGroupName: {},
              AccountId: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Se"
              }
            }
          }
        },
        ListWorkloads: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName",
              "ComponentName"
            ],
            members: {
              ResourceGroupName: {},
              ComponentName: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              AccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WorkloadId: {},
                    ComponentName: {},
                    WorkloadName: {},
                    Tier: {},
                    WorkloadRemarks: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        RemoveWorkload: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName",
              "ComponentName",
              "WorkloadId"
            ],
            members: {
              ResourceGroupName: {},
              ComponentName: {},
              WorkloadId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateApplication: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName"
            ],
            members: {
              ResourceGroupName: {},
              OpsCenterEnabled: {
                type: "boolean"
              },
              CWEMonitorEnabled: {
                type: "boolean"
              },
              OpsItemSNSTopicArn: {},
              RemoveSNSTopic: {
                type: "boolean"
              },
              AutoConfigEnabled: {
                type: "boolean"
              },
              AttachMissingPermission: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationInfo: {
                shape: "Sn"
              }
            }
          }
        },
        UpdateComponent: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName",
              "ComponentName"
            ],
            members: {
              ResourceGroupName: {},
              ComponentName: {},
              NewComponentName: {},
              ResourceList: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateComponentConfiguration: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName",
              "ComponentName"
            ],
            members: {
              ResourceGroupName: {},
              ComponentName: {},
              Monitor: {
                type: "boolean"
              },
              Tier: {},
              ComponentConfiguration: {},
              AutoConfigEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateLogPattern: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName",
              "PatternSetName",
              "PatternName"
            ],
            members: {
              ResourceGroupName: {},
              PatternSetName: {},
              PatternName: {},
              Pattern: {},
              Rank: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceGroupName: {},
              LogPattern: {
                shape: "S13"
              }
            }
          }
        },
        UpdateProblem: {
          input: {
            type: "structure",
            required: [
              "ProblemId"
            ],
            members: {
              ProblemId: {},
              UpdateStatus: {},
              Visibility: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateWorkload: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName",
              "ComponentName",
              "WorkloadConfiguration"
            ],
            members: {
              ResourceGroupName: {},
              ComponentName: {},
              WorkloadId: {},
              WorkloadConfiguration: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              WorkloadConfiguration: {
                shape: "S4"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            WorkloadName: {},
            Tier: {},
            Configuration: {}
          }
        },
        Se: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sn: {
          type: "structure",
          members: {
            AccountId: {},
            ResourceGroupName: {},
            LifeCycle: {},
            OpsItemSNSTopicArn: {},
            OpsCenterEnabled: {
              type: "boolean"
            },
            CWEMonitorEnabled: {
              type: "boolean"
            },
            Remarks: {},
            AutoConfigEnabled: {
              type: "boolean"
            },
            DiscoveryType: {},
            AttachMissingPermission: {
              type: "boolean"
            }
          }
        },
        Su: {
          type: "list",
          member: {}
        },
        S13: {
          type: "structure",
          members: {
            PatternSetName: {},
            PatternName: {},
            Pattern: {},
            Rank: {
              type: "integer"
            }
          }
        },
        S1e: {
          type: "structure",
          members: {
            ComponentName: {},
            ComponentRemarks: {},
            ResourceType: {},
            OsType: {},
            Tier: {},
            Monitor: {
              type: "boolean"
            },
            DetectedWorkload: {
              type: "map",
              key: {},
              value: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        S1w: {
          type: "structure",
          members: {
            Id: {},
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            SourceType: {},
            SourceARN: {},
            LogGroup: {},
            LineTime: {
              type: "timestamp"
            },
            LogText: {},
            LogFilter: {},
            MetricNamespace: {},
            MetricName: {},
            Unit: {},
            Value: {
              type: "double"
            },
            CloudWatchEventId: {},
            CloudWatchEventSource: {},
            CloudWatchEventDetailType: {},
            HealthEventArn: {},
            HealthService: {},
            HealthEventTypeCode: {},
            HealthEventTypeCategory: {},
            HealthEventDescription: {},
            CodeDeployDeploymentId: {},
            CodeDeployDeploymentGroup: {},
            CodeDeployState: {},
            CodeDeployApplication: {},
            CodeDeployInstanceGroupId: {},
            Ec2State: {},
            RdsEventCategories: {},
            RdsEventMessage: {},
            S3EventName: {},
            StatesExecutionArn: {},
            StatesArn: {},
            StatesStatus: {},
            StatesInput: {},
            EbsEvent: {},
            EbsResult: {},
            EbsCause: {},
            EbsRequestId: {},
            XRayFaultPercent: {
              type: "integer"
            },
            XRayThrottlePercent: {
              type: "integer"
            },
            XRayErrorPercent: {
              type: "integer"
            },
            XRayRequestCount: {
              type: "integer"
            },
            XRayRequestAverageLatency: {
              type: "long"
            },
            XRayNodeName: {},
            XRayNodeType: {}
          }
        },
        S38: {
          type: "structure",
          members: {
            Id: {},
            Title: {},
            Insights: {},
            Status: {},
            AffectedResource: {},
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            SeverityLevel: {},
            AccountId: {},
            ResourceGroupName: {},
            Feedback: {
              type: "map",
              key: {},
              value: {}
            },
            RecurringCount: {
              type: "long"
            },
            LastRecurrenceTime: {
              type: "timestamp"
            },
            Visibility: {},
            ResolutionMethod: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/application-insights-2018-11-25.paginators.json
var require_application_insights_2018_11_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/application-insights-2018-11-25.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListApplications: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListComponents: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListConfigurationHistory: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListLogPatternSets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListLogPatterns: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListProblems: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListWorkloads: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/applicationinsights.js
var require_applicationinsights = __commonJS({
  "node_modules/aws-sdk/clients/applicationinsights.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["applicationinsights"] = {};
    AWS2.ApplicationInsights = Service.defineService("applicationinsights", ["2018-11-25"]);
    Object.defineProperty(apiLoader.services["applicationinsights"], "2018-11-25", {
      get: function get() {
        var model = require_application_insights_2018_11_25_min();
        model.paginators = require_application_insights_2018_11_25_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ApplicationInsights;
  }
});

// node_modules/aws-sdk/apis/service-quotas-2019-06-24.min.json
var require_service_quotas_2019_06_24_min = __commonJS({
  "node_modules/aws-sdk/apis/service-quotas-2019-06-24.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-06-24",
        endpointPrefix: "servicequotas",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Service Quotas",
        serviceId: "Service Quotas",
        signatureVersion: "v4",
        targetPrefix: "ServiceQuotasV20190624",
        uid: "service-quotas-2019-06-24"
      },
      operations: {
        AssociateServiceQuotaTemplate: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteServiceQuotaIncreaseRequestFromTemplate: {
          input: {
            type: "structure",
            required: [
              "ServiceCode",
              "QuotaCode",
              "AwsRegion"
            ],
            members: {
              ServiceCode: {},
              QuotaCode: {},
              AwsRegion: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateServiceQuotaTemplate: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetAWSDefaultServiceQuota: {
          input: {
            type: "structure",
            required: [
              "ServiceCode",
              "QuotaCode"
            ],
            members: {
              ServiceCode: {},
              QuotaCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Quota: {
                shape: "Sc"
              }
            }
          }
        },
        GetAssociationForServiceQuotaTemplate: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              ServiceQuotaTemplateAssociationStatus: {}
            }
          }
        },
        GetRequestedServiceQuotaChange: {
          input: {
            type: "structure",
            required: [
              "RequestId"
            ],
            members: {
              RequestId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RequestedQuota: {
                shape: "S18"
              }
            }
          }
        },
        GetServiceQuota: {
          input: {
            type: "structure",
            required: [
              "ServiceCode",
              "QuotaCode"
            ],
            members: {
              ServiceCode: {},
              QuotaCode: {},
              ContextId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Quota: {
                shape: "Sc"
              }
            }
          }
        },
        GetServiceQuotaIncreaseRequestFromTemplate: {
          input: {
            type: "structure",
            required: [
              "ServiceCode",
              "QuotaCode",
              "AwsRegion"
            ],
            members: {
              ServiceCode: {},
              QuotaCode: {},
              AwsRegion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceQuotaIncreaseRequestInTemplate: {
                shape: "S1h"
              }
            }
          }
        },
        ListAWSDefaultServiceQuotas: {
          input: {
            type: "structure",
            required: [
              "ServiceCode"
            ],
            members: {
              ServiceCode: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Quotas: {
                shape: "S1m"
              }
            }
          }
        },
        ListRequestedServiceQuotaChangeHistory: {
          input: {
            type: "structure",
            members: {
              ServiceCode: {},
              Status: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              QuotaRequestedAtLevel: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              RequestedQuotas: {
                shape: "S1p"
              }
            }
          }
        },
        ListRequestedServiceQuotaChangeHistoryByQuota: {
          input: {
            type: "structure",
            required: [
              "ServiceCode",
              "QuotaCode"
            ],
            members: {
              ServiceCode: {},
              QuotaCode: {},
              Status: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              QuotaRequestedAtLevel: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              RequestedQuotas: {
                shape: "S1p"
              }
            }
          }
        },
        ListServiceQuotaIncreaseRequestsInTemplate: {
          input: {
            type: "structure",
            members: {
              ServiceCode: {},
              AwsRegion: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceQuotaIncreaseRequestInTemplateList: {
                type: "list",
                member: {
                  shape: "S1h"
                }
              },
              NextToken: {}
            }
          }
        },
        ListServiceQuotas: {
          input: {
            type: "structure",
            required: [
              "ServiceCode"
            ],
            members: {
              ServiceCode: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              QuotaCode: {},
              QuotaAppliedAtLevel: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Quotas: {
                shape: "S1m"
              }
            }
          }
        },
        ListServices: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Services: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ServiceCode: {},
                    ServiceName: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                type: "list",
                member: {
                  shape: "S25"
                }
              }
            }
          }
        },
        PutServiceQuotaIncreaseRequestIntoTemplate: {
          input: {
            type: "structure",
            required: [
              "QuotaCode",
              "ServiceCode",
              "AwsRegion",
              "DesiredValue"
            ],
            members: {
              QuotaCode: {},
              ServiceCode: {},
              AwsRegion: {},
              DesiredValue: {
                type: "double"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceQuotaIncreaseRequestInTemplate: {
                shape: "S1h"
              }
            }
          }
        },
        RequestServiceQuotaIncrease: {
          input: {
            type: "structure",
            required: [
              "ServiceCode",
              "QuotaCode",
              "DesiredValue"
            ],
            members: {
              ServiceCode: {},
              QuotaCode: {},
              DesiredValue: {
                type: "double"
              },
              ContextId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RequestedQuota: {
                shape: "S18"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                type: "list",
                member: {
                  shape: "S25"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        Sc: {
          type: "structure",
          members: {
            ServiceCode: {},
            ServiceName: {},
            QuotaArn: {},
            QuotaCode: {},
            QuotaName: {},
            Value: {
              type: "double"
            },
            Unit: {},
            Adjustable: {
              type: "boolean"
            },
            GlobalQuota: {
              type: "boolean"
            },
            UsageMetric: {
              type: "structure",
              members: {
                MetricNamespace: {},
                MetricName: {},
                MetricDimensions: {
                  type: "map",
                  key: {},
                  value: {}
                },
                MetricStatisticRecommendation: {}
              }
            },
            Period: {
              type: "structure",
              members: {
                PeriodValue: {
                  type: "integer"
                },
                PeriodUnit: {}
              }
            },
            ErrorReason: {
              type: "structure",
              members: {
                ErrorCode: {},
                ErrorMessage: {}
              }
            },
            QuotaAppliedAtLevel: {},
            QuotaContext: {
              shape: "Sy"
            }
          }
        },
        Sy: {
          type: "structure",
          members: {
            ContextScope: {},
            ContextScopeType: {},
            ContextId: {}
          }
        },
        S18: {
          type: "structure",
          members: {
            Id: {},
            CaseId: {},
            ServiceCode: {},
            ServiceName: {},
            QuotaCode: {},
            QuotaName: {},
            DesiredValue: {
              type: "double"
            },
            Status: {},
            Created: {
              type: "timestamp"
            },
            LastUpdated: {
              type: "timestamp"
            },
            Requester: {},
            QuotaArn: {},
            GlobalQuota: {
              type: "boolean"
            },
            Unit: {},
            QuotaRequestedAtLevel: {},
            QuotaContext: {
              shape: "Sy"
            }
          }
        },
        S1h: {
          type: "structure",
          members: {
            ServiceCode: {},
            ServiceName: {},
            QuotaCode: {},
            QuotaName: {},
            DesiredValue: {
              type: "double"
            },
            AwsRegion: {},
            Unit: {},
            GlobalQuota: {
              type: "boolean"
            }
          }
        },
        S1m: {
          type: "list",
          member: {
            shape: "Sc"
          }
        },
        S1p: {
          type: "list",
          member: {
            shape: "S18"
          }
        },
        S25: {
          type: "structure",
          required: [
            "Key",
            "Value"
          ],
          members: {
            Key: {},
            Value: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/service-quotas-2019-06-24.paginators.json
var require_service_quotas_2019_06_24_paginators = __commonJS({
  "node_modules/aws-sdk/apis/service-quotas-2019-06-24.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAWSDefaultServiceQuotas: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Quotas"
        },
        ListRequestedServiceQuotaChangeHistory: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "RequestedQuotas"
        },
        ListRequestedServiceQuotaChangeHistoryByQuota: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "RequestedQuotas"
        },
        ListServiceQuotaIncreaseRequestsInTemplate: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ServiceQuotaIncreaseRequestInTemplateList"
        },
        ListServiceQuotas: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Quotas"
        },
        ListServices: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Services"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/servicequotas.js
var require_servicequotas = __commonJS({
  "node_modules/aws-sdk/clients/servicequotas.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["servicequotas"] = {};
    AWS2.ServiceQuotas = Service.defineService("servicequotas", ["2019-06-24"]);
    Object.defineProperty(apiLoader.services["servicequotas"], "2019-06-24", {
      get: function get() {
        var model = require_service_quotas_2019_06_24_min();
        model.paginators = require_service_quotas_2019_06_24_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ServiceQuotas;
  }
});

// node_modules/aws-sdk/apis/ec2-instance-connect-2018-04-02.min.json
var require_ec2_instance_connect_2018_04_02_min = __commonJS({
  "node_modules/aws-sdk/apis/ec2-instance-connect-2018-04-02.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-04-02",
        endpointPrefix: "ec2-instance-connect",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "EC2 Instance Connect",
        serviceFullName: "AWS EC2 Instance Connect",
        serviceId: "EC2 Instance Connect",
        signatureVersion: "v4",
        targetPrefix: "AWSEC2InstanceConnectService",
        uid: "ec2-instance-connect-2018-04-02"
      },
      operations: {
        SendSSHPublicKey: {
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "InstanceOSUser",
              "SSHPublicKey"
            ],
            members: {
              InstanceId: {},
              InstanceOSUser: {},
              SSHPublicKey: {},
              AvailabilityZone: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Success: {
                type: "boolean"
              }
            }
          }
        },
        SendSerialConsoleSSHPublicKey: {
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "SSHPublicKey"
            ],
            members: {
              InstanceId: {},
              SerialPort: {
                type: "integer"
              },
              SSHPublicKey: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Success: {
                type: "boolean"
              }
            }
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/apis/ec2-instance-connect-2018-04-02.paginators.json
var require_ec2_instance_connect_2018_04_02_paginators = __commonJS({
  "node_modules/aws-sdk/apis/ec2-instance-connect-2018-04-02.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/ec2instanceconnect.js
var require_ec2instanceconnect = __commonJS({
  "node_modules/aws-sdk/clients/ec2instanceconnect.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["ec2instanceconnect"] = {};
    AWS2.EC2InstanceConnect = Service.defineService("ec2instanceconnect", ["2018-04-02"]);
    Object.defineProperty(apiLoader.services["ec2instanceconnect"], "2018-04-02", {
      get: function get() {
        var model = require_ec2_instance_connect_2018_04_02_min();
        model.paginators = require_ec2_instance_connect_2018_04_02_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.EC2InstanceConnect;
  }
});

// node_modules/aws-sdk/lib/services/eventbridge.js
var require_eventbridge = __commonJS({
  "node_modules/aws-sdk/lib/services/eventbridge.js"() {
    "use strict";
    var AWS2 = require_core();
    AWS2.util.update(AWS2.EventBridge.prototype, {
      /**
       * @api private
       */
      setupRequestListeners: function setupRequestListeners(request) {
        if (request.operation === "putEvents") {
          var params = request.params || {};
          if (params.EndpointId !== void 0) {
            throw new AWS2.util.error(new Error(), {
              code: "InvalidParameter",
              message: "EndpointId is not supported in current SDK.\nYou should consider switching to V3(https://github.com/aws/aws-sdk-js-v3)."
            });
          }
        }
      }
    });
  }
});

// node_modules/aws-sdk/apis/eventbridge-2015-10-07.min.json
var require_eventbridge_2015_10_07_min = __commonJS({
  "node_modules/aws-sdk/apis/eventbridge-2015-10-07.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-10-07",
        endpointPrefix: "events",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon EventBridge",
        serviceId: "EventBridge",
        signatureVersion: "v4",
        targetPrefix: "AWSEvents",
        uid: "eventbridge-2015-10-07"
      },
      operations: {
        ActivateEventSource: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        CancelReplay: {
          input: {
            type: "structure",
            required: [
              "ReplayName"
            ],
            members: {
              ReplayName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplayArn: {},
              State: {},
              StateReason: {}
            }
          }
        },
        CreateApiDestination: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ConnectionArn",
              "InvocationEndpoint",
              "HttpMethod"
            ],
            members: {
              Name: {},
              Description: {},
              ConnectionArn: {},
              InvocationEndpoint: {},
              HttpMethod: {},
              InvocationRateLimitPerSecond: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApiDestinationArn: {},
              ApiDestinationState: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              }
            }
          }
        },
        CreateArchive: {
          input: {
            type: "structure",
            required: [
              "ArchiveName",
              "EventSourceArn"
            ],
            members: {
              ArchiveName: {},
              EventSourceArn: {},
              Description: {},
              EventPattern: {},
              RetentionDays: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ArchiveArn: {},
              State: {},
              StateReason: {},
              CreationTime: {
                type: "timestamp"
              }
            }
          }
        },
        CreateConnection: {
          input: {
            type: "structure",
            required: [
              "Name",
              "AuthorizationType",
              "AuthParameters"
            ],
            members: {
              Name: {},
              Description: {},
              AuthorizationType: {},
              AuthParameters: {
                type: "structure",
                members: {
                  BasicAuthParameters: {
                    type: "structure",
                    required: [
                      "Username",
                      "Password"
                    ],
                    members: {
                      Username: {},
                      Password: {
                        shape: "S11"
                      }
                    }
                  },
                  OAuthParameters: {
                    type: "structure",
                    required: [
                      "ClientParameters",
                      "AuthorizationEndpoint",
                      "HttpMethod"
                    ],
                    members: {
                      ClientParameters: {
                        type: "structure",
                        required: [
                          "ClientID",
                          "ClientSecret"
                        ],
                        members: {
                          ClientID: {},
                          ClientSecret: {
                            shape: "S11"
                          }
                        }
                      },
                      AuthorizationEndpoint: {},
                      HttpMethod: {},
                      OAuthHttpParameters: {
                        shape: "S15"
                      }
                    }
                  },
                  ApiKeyAuthParameters: {
                    type: "structure",
                    required: [
                      "ApiKeyName",
                      "ApiKeyValue"
                    ],
                    members: {
                      ApiKeyName: {},
                      ApiKeyValue: {
                        shape: "S11"
                      }
                    }
                  },
                  InvocationHttpParameters: {
                    shape: "S15"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionArn: {},
              ConnectionState: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              }
            }
          }
        },
        CreateEndpoint: {
          input: {
            type: "structure",
            required: [
              "Name",
              "RoutingConfig",
              "EventBuses"
            ],
            members: {
              Name: {},
              Description: {},
              RoutingConfig: {
                shape: "S1p"
              },
              ReplicationConfig: {
                shape: "S1v"
              },
              EventBuses: {
                shape: "S1x"
              },
              RoleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Arn: {},
              RoutingConfig: {
                shape: "S1p"
              },
              ReplicationConfig: {
                shape: "S1v"
              },
              EventBuses: {
                shape: "S1x"
              },
              RoleArn: {},
              State: {}
            }
          }
        },
        CreateEventBus: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              EventSourceName: {},
              Tags: {
                shape: "S26"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventBusArn: {}
            }
          }
        },
        CreatePartnerEventSource: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Account"
            ],
            members: {
              Name: {},
              Account: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EventSourceArn: {}
            }
          }
        },
        DeactivateEventSource: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        DeauthorizeConnection: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionArn: {},
              ConnectionState: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastAuthorizedTime: {
                type: "timestamp"
              }
            }
          }
        },
        DeleteApiDestination: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteArchive: {
          input: {
            type: "structure",
            required: [
              "ArchiveName"
            ],
            members: {
              ArchiveName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteConnection: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionArn: {},
              ConnectionState: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastAuthorizedTime: {
                type: "timestamp"
              }
            }
          }
        },
        DeleteEndpoint: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteEventBus: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        DeletePartnerEventSource: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Account"
            ],
            members: {
              Name: {},
              Account: {}
            }
          }
        },
        DeleteRule: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              EventBusName: {},
              Force: {
                type: "boolean"
              }
            }
          }
        },
        DescribeApiDestination: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApiDestinationArn: {},
              Name: {},
              Description: {},
              ApiDestinationState: {},
              ConnectionArn: {},
              InvocationEndpoint: {},
              HttpMethod: {},
              InvocationRateLimitPerSecond: {
                type: "integer"
              },
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeArchive: {
          input: {
            type: "structure",
            required: [
              "ArchiveName"
            ],
            members: {
              ArchiveName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ArchiveArn: {},
              ArchiveName: {},
              EventSourceArn: {},
              Description: {},
              EventPattern: {},
              State: {},
              StateReason: {},
              RetentionDays: {
                type: "integer"
              },
              SizeBytes: {
                type: "long"
              },
              EventCount: {
                type: "long"
              },
              CreationTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeConnection: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionArn: {},
              Name: {},
              Description: {},
              ConnectionState: {},
              StateReason: {},
              AuthorizationType: {},
              SecretArn: {},
              AuthParameters: {
                type: "structure",
                members: {
                  BasicAuthParameters: {
                    type: "structure",
                    members: {
                      Username: {}
                    }
                  },
                  OAuthParameters: {
                    type: "structure",
                    members: {
                      ClientParameters: {
                        type: "structure",
                        members: {
                          ClientID: {}
                        }
                      },
                      AuthorizationEndpoint: {},
                      HttpMethod: {},
                      OAuthHttpParameters: {
                        shape: "S15"
                      }
                    }
                  },
                  ApiKeyAuthParameters: {
                    type: "structure",
                    members: {
                      ApiKeyName: {}
                    }
                  },
                  InvocationHttpParameters: {
                    shape: "S15"
                  }
                }
              },
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastAuthorizedTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeEndpoint: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              HomeRegion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Description: {},
              Arn: {},
              RoutingConfig: {
                shape: "S1p"
              },
              ReplicationConfig: {
                shape: "S1v"
              },
              EventBuses: {
                shape: "S1x"
              },
              RoleArn: {},
              EndpointId: {},
              EndpointUrl: {},
              State: {},
              StateReason: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeEventBus: {
          input: {
            type: "structure",
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Arn: {},
              Policy: {}
            }
          }
        },
        DescribeEventSource: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreatedBy: {},
              CreationTime: {
                type: "timestamp"
              },
              ExpirationTime: {
                type: "timestamp"
              },
              Name: {},
              State: {}
            }
          }
        },
        DescribePartnerEventSource: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Name: {}
            }
          }
        },
        DescribeReplay: {
          input: {
            type: "structure",
            required: [
              "ReplayName"
            ],
            members: {
              ReplayName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplayName: {},
              ReplayArn: {},
              Description: {},
              State: {},
              StateReason: {},
              EventSourceArn: {},
              Destination: {
                shape: "S3o"
              },
              EventStartTime: {
                type: "timestamp"
              },
              EventEndTime: {
                type: "timestamp"
              },
              EventLastReplayedTime: {
                type: "timestamp"
              },
              ReplayStartTime: {
                type: "timestamp"
              },
              ReplayEndTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeRule: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              EventBusName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Arn: {},
              EventPattern: {},
              ScheduleExpression: {},
              State: {},
              Description: {},
              RoleArn: {},
              ManagedBy: {},
              EventBusName: {},
              CreatedBy: {}
            }
          }
        },
        DisableRule: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              EventBusName: {}
            }
          }
        },
        EnableRule: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              EventBusName: {}
            }
          }
        },
        ListApiDestinations: {
          input: {
            type: "structure",
            members: {
              NamePrefix: {},
              ConnectionArn: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApiDestinations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApiDestinationArn: {},
                    Name: {},
                    ApiDestinationState: {},
                    ConnectionArn: {},
                    InvocationEndpoint: {},
                    HttpMethod: {},
                    InvocationRateLimitPerSecond: {
                      type: "integer"
                    },
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListArchives: {
          input: {
            type: "structure",
            members: {
              NamePrefix: {},
              EventSourceArn: {},
              State: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Archives: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ArchiveName: {},
                    EventSourceArn: {},
                    State: {},
                    StateReason: {},
                    RetentionDays: {
                      type: "integer"
                    },
                    SizeBytes: {
                      type: "long"
                    },
                    EventCount: {
                      type: "long"
                    },
                    CreationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListConnections: {
          input: {
            type: "structure",
            members: {
              NamePrefix: {},
              ConnectionState: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Connections: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ConnectionArn: {},
                    Name: {},
                    ConnectionState: {},
                    StateReason: {},
                    AuthorizationType: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    LastAuthorizedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEndpoints: {
          input: {
            type: "structure",
            members: {
              NamePrefix: {},
              HomeRegion: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Endpoints: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Description: {},
                    Arn: {},
                    RoutingConfig: {
                      shape: "S1p"
                    },
                    ReplicationConfig: {
                      shape: "S1v"
                    },
                    EventBuses: {
                      shape: "S1x"
                    },
                    RoleArn: {},
                    EndpointId: {},
                    EndpointUrl: {},
                    State: {},
                    StateReason: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEventBuses: {
          input: {
            type: "structure",
            members: {
              NamePrefix: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventBuses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Arn: {},
                    Policy: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEventSources: {
          input: {
            type: "structure",
            members: {
              NamePrefix: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventSources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    CreatedBy: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    ExpirationTime: {
                      type: "timestamp"
                    },
                    Name: {},
                    State: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPartnerEventSourceAccounts: {
          input: {
            type: "structure",
            required: [
              "EventSourceName"
            ],
            members: {
              EventSourceName: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PartnerEventSourceAccounts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Account: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    ExpirationTime: {
                      type: "timestamp"
                    },
                    State: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPartnerEventSources: {
          input: {
            type: "structure",
            required: [
              "NamePrefix"
            ],
            members: {
              NamePrefix: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PartnerEventSources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Name: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListReplays: {
          input: {
            type: "structure",
            members: {
              NamePrefix: {},
              State: {},
              EventSourceArn: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Replays: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ReplayName: {},
                    EventSourceArn: {},
                    State: {},
                    StateReason: {},
                    EventStartTime: {
                      type: "timestamp"
                    },
                    EventEndTime: {
                      type: "timestamp"
                    },
                    EventLastReplayedTime: {
                      type: "timestamp"
                    },
                    ReplayStartTime: {
                      type: "timestamp"
                    },
                    ReplayEndTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListRuleNamesByTarget: {
          input: {
            type: "structure",
            required: [
              "TargetArn"
            ],
            members: {
              TargetArn: {},
              EventBusName: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RuleNames: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListRules: {
          input: {
            type: "structure",
            members: {
              NamePrefix: {},
              EventBusName: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Rules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Arn: {},
                    EventPattern: {},
                    State: {},
                    Description: {},
                    ScheduleExpression: {},
                    RoleArn: {},
                    ManagedBy: {},
                    EventBusName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S26"
              }
            }
          }
        },
        ListTargetsByRule: {
          input: {
            type: "structure",
            required: [
              "Rule"
            ],
            members: {
              Rule: {},
              EventBusName: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Targets: {
                shape: "S5h"
              },
              NextToken: {}
            }
          }
        },
        PutEvents: {
          input: {
            type: "structure",
            required: [
              "Entries"
            ],
            members: {
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Time: {
                      type: "timestamp"
                    },
                    Source: {},
                    Resources: {
                      shape: "S7i"
                    },
                    DetailType: {},
                    Detail: {},
                    EventBusName: {},
                    TraceHeader: {}
                  }
                }
              },
              EndpointId: {
                contextParam: {
                  name: "EndpointId"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedEntryCount: {
                type: "integer"
              },
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EventId: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        PutPartnerEvents: {
          input: {
            type: "structure",
            required: [
              "Entries"
            ],
            members: {
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Time: {
                      type: "timestamp"
                    },
                    Source: {},
                    Resources: {
                      shape: "S7i"
                    },
                    DetailType: {},
                    Detail: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedEntryCount: {
                type: "integer"
              },
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EventId: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        PutPermission: {
          input: {
            type: "structure",
            members: {
              EventBusName: {},
              Action: {},
              Principal: {},
              StatementId: {},
              Condition: {
                type: "structure",
                required: [
                  "Type",
                  "Key",
                  "Value"
                ],
                members: {
                  Type: {},
                  Key: {},
                  Value: {}
                }
              },
              Policy: {}
            }
          }
        },
        PutRule: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              ScheduleExpression: {},
              EventPattern: {},
              State: {},
              Description: {},
              RoleArn: {},
              Tags: {
                shape: "S26"
              },
              EventBusName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RuleArn: {}
            }
          }
        },
        PutTargets: {
          input: {
            type: "structure",
            required: [
              "Rule",
              "Targets"
            ],
            members: {
              Rule: {},
              EventBusName: {},
              Targets: {
                shape: "S5h"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedEntryCount: {
                type: "integer"
              },
              FailedEntries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TargetId: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        RemovePermission: {
          input: {
            type: "structure",
            members: {
              StatementId: {},
              RemoveAllPermissions: {
                type: "boolean"
              },
              EventBusName: {}
            }
          }
        },
        RemoveTargets: {
          input: {
            type: "structure",
            required: [
              "Rule",
              "Ids"
            ],
            members: {
              Rule: {},
              EventBusName: {},
              Ids: {
                type: "list",
                member: {}
              },
              Force: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedEntryCount: {
                type: "integer"
              },
              FailedEntries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TargetId: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        StartReplay: {
          input: {
            type: "structure",
            required: [
              "ReplayName",
              "EventSourceArn",
              "EventStartTime",
              "EventEndTime",
              "Destination"
            ],
            members: {
              ReplayName: {},
              Description: {},
              EventSourceArn: {},
              EventStartTime: {
                type: "timestamp"
              },
              EventEndTime: {
                type: "timestamp"
              },
              Destination: {
                shape: "S3o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReplayArn: {},
              State: {},
              StateReason: {},
              ReplayStartTime: {
                type: "timestamp"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S26"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TestEventPattern: {
          input: {
            type: "structure",
            required: [
              "EventPattern",
              "Event"
            ],
            members: {
              EventPattern: {},
              Event: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Result: {
                type: "boolean"
              }
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateApiDestination: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Description: {},
              ConnectionArn: {},
              InvocationEndpoint: {},
              HttpMethod: {},
              InvocationRateLimitPerSecond: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApiDestinationArn: {},
              ApiDestinationState: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              }
            }
          }
        },
        UpdateArchive: {
          input: {
            type: "structure",
            required: [
              "ArchiveName"
            ],
            members: {
              ArchiveName: {},
              Description: {},
              EventPattern: {},
              RetentionDays: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ArchiveArn: {},
              State: {},
              StateReason: {},
              CreationTime: {
                type: "timestamp"
              }
            }
          }
        },
        UpdateConnection: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Description: {},
              AuthorizationType: {},
              AuthParameters: {
                type: "structure",
                members: {
                  BasicAuthParameters: {
                    type: "structure",
                    members: {
                      Username: {},
                      Password: {
                        shape: "S11"
                      }
                    }
                  },
                  OAuthParameters: {
                    type: "structure",
                    members: {
                      ClientParameters: {
                        type: "structure",
                        members: {
                          ClientID: {},
                          ClientSecret: {
                            shape: "S11"
                          }
                        }
                      },
                      AuthorizationEndpoint: {},
                      HttpMethod: {},
                      OAuthHttpParameters: {
                        shape: "S15"
                      }
                    }
                  },
                  ApiKeyAuthParameters: {
                    type: "structure",
                    members: {
                      ApiKeyName: {},
                      ApiKeyValue: {
                        shape: "S11"
                      }
                    }
                  },
                  InvocationHttpParameters: {
                    shape: "S15"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionArn: {},
              ConnectionState: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastAuthorizedTime: {
                type: "timestamp"
              }
            }
          }
        },
        UpdateEndpoint: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Description: {},
              RoutingConfig: {
                shape: "S1p"
              },
              ReplicationConfig: {
                shape: "S1v"
              },
              EventBuses: {
                shape: "S1x"
              },
              RoleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Arn: {},
              RoutingConfig: {
                shape: "S1p"
              },
              ReplicationConfig: {
                shape: "S1v"
              },
              EventBuses: {
                shape: "S1x"
              },
              RoleArn: {},
              EndpointId: {},
              EndpointUrl: {},
              State: {}
            }
          }
        }
      },
      shapes: {
        S11: {
          type: "string",
          sensitive: true
        },
        S15: {
          type: "structure",
          members: {
            HeaderParameters: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Key: {},
                  Value: {
                    type: "string",
                    sensitive: true
                  },
                  IsValueSecret: {
                    type: "boolean"
                  }
                }
              }
            },
            QueryStringParameters: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Key: {},
                  Value: {
                    type: "string",
                    sensitive: true
                  },
                  IsValueSecret: {
                    type: "boolean"
                  }
                }
              }
            },
            BodyParameters: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Key: {},
                  Value: {
                    type: "string",
                    sensitive: true
                  },
                  IsValueSecret: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        S1p: {
          type: "structure",
          required: [
            "FailoverConfig"
          ],
          members: {
            FailoverConfig: {
              type: "structure",
              required: [
                "Primary",
                "Secondary"
              ],
              members: {
                Primary: {
                  type: "structure",
                  required: [
                    "HealthCheck"
                  ],
                  members: {
                    HealthCheck: {}
                  }
                },
                Secondary: {
                  type: "structure",
                  required: [
                    "Route"
                  ],
                  members: {
                    Route: {}
                  }
                }
              }
            }
          }
        },
        S1v: {
          type: "structure",
          members: {
            State: {}
          }
        },
        S1x: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "EventBusArn"
            ],
            members: {
              EventBusArn: {}
            }
          }
        },
        S26: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S3o: {
          type: "structure",
          required: [
            "Arn"
          ],
          members: {
            Arn: {},
            FilterArns: {
              type: "list",
              member: {}
            }
          }
        },
        S5h: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Id",
              "Arn"
            ],
            members: {
              Id: {},
              Arn: {},
              RoleArn: {},
              Input: {},
              InputPath: {},
              InputTransformer: {
                type: "structure",
                required: [
                  "InputTemplate"
                ],
                members: {
                  InputPathsMap: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  InputTemplate: {}
                }
              },
              KinesisParameters: {
                type: "structure",
                required: [
                  "PartitionKeyPath"
                ],
                members: {
                  PartitionKeyPath: {}
                }
              },
              RunCommandParameters: {
                type: "structure",
                required: [
                  "RunCommandTargets"
                ],
                members: {
                  RunCommandTargets: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Key",
                        "Values"
                      ],
                      members: {
                        Key: {},
                        Values: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  }
                }
              },
              EcsParameters: {
                type: "structure",
                required: [
                  "TaskDefinitionArn"
                ],
                members: {
                  TaskDefinitionArn: {},
                  TaskCount: {
                    type: "integer"
                  },
                  LaunchType: {},
                  NetworkConfiguration: {
                    type: "structure",
                    members: {
                      awsvpcConfiguration: {
                        type: "structure",
                        required: [
                          "Subnets"
                        ],
                        members: {
                          Subnets: {
                            shape: "S63"
                          },
                          SecurityGroups: {
                            shape: "S63"
                          },
                          AssignPublicIp: {}
                        }
                      }
                    }
                  },
                  PlatformVersion: {},
                  Group: {},
                  CapacityProviderStrategy: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "capacityProvider"
                      ],
                      members: {
                        capacityProvider: {},
                        weight: {
                          type: "integer"
                        },
                        base: {
                          type: "integer"
                        }
                      }
                    }
                  },
                  EnableECSManagedTags: {
                    type: "boolean"
                  },
                  EnableExecuteCommand: {
                    type: "boolean"
                  },
                  PlacementConstraints: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        type: {},
                        expression: {}
                      }
                    }
                  },
                  PlacementStrategy: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        type: {},
                        field: {}
                      }
                    }
                  },
                  PropagateTags: {},
                  ReferenceId: {},
                  Tags: {
                    shape: "S26"
                  }
                }
              },
              BatchParameters: {
                type: "structure",
                required: [
                  "JobDefinition",
                  "JobName"
                ],
                members: {
                  JobDefinition: {},
                  JobName: {},
                  ArrayProperties: {
                    type: "structure",
                    members: {
                      Size: {
                        type: "integer"
                      }
                    }
                  },
                  RetryStrategy: {
                    type: "structure",
                    members: {
                      Attempts: {
                        type: "integer"
                      }
                    }
                  }
                }
              },
              SqsParameters: {
                type: "structure",
                members: {
                  MessageGroupId: {}
                }
              },
              HttpParameters: {
                type: "structure",
                members: {
                  PathParameterValues: {
                    type: "list",
                    member: {}
                  },
                  HeaderParameters: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  QueryStringParameters: {
                    type: "map",
                    key: {},
                    value: {}
                  }
                }
              },
              RedshiftDataParameters: {
                type: "structure",
                required: [
                  "Database"
                ],
                members: {
                  SecretManagerArn: {},
                  Database: {},
                  DbUser: {},
                  Sql: {
                    shape: "S71"
                  },
                  StatementName: {},
                  WithEvent: {
                    type: "boolean"
                  },
                  Sqls: {
                    type: "list",
                    member: {
                      shape: "S71"
                    },
                    sensitive: true
                  }
                }
              },
              SageMakerPipelineParameters: {
                type: "structure",
                members: {
                  PipelineParameterList: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Name",
                        "Value"
                      ],
                      members: {
                        Name: {},
                        Value: {}
                      }
                    }
                  }
                }
              },
              DeadLetterConfig: {
                type: "structure",
                members: {
                  Arn: {}
                }
              },
              RetryPolicy: {
                type: "structure",
                members: {
                  MaximumRetryAttempts: {
                    type: "integer"
                  },
                  MaximumEventAgeInSeconds: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        S63: {
          type: "list",
          member: {}
        },
        S71: {
          type: "string",
          sensitive: true
        },
        S7i: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/eventbridge-2015-10-07.paginators.json
var require_eventbridge_2015_10_07_paginators = __commonJS({
  "node_modules/aws-sdk/apis/eventbridge-2015-10-07.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/eventbridge.js
var require_eventbridge2 = __commonJS({
  "node_modules/aws-sdk/clients/eventbridge.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["eventbridge"] = {};
    AWS2.EventBridge = Service.defineService("eventbridge", ["2015-10-07"]);
    require_eventbridge();
    Object.defineProperty(apiLoader.services["eventbridge"], "2015-10-07", {
      get: function get() {
        var model = require_eventbridge_2015_10_07_min();
        model.paginators = require_eventbridge_2015_10_07_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.EventBridge;
  }
});

// node_modules/aws-sdk/apis/lakeformation-2017-03-31.min.json
var require_lakeformation_2017_03_31_min = __commonJS({
  "node_modules/aws-sdk/apis/lakeformation-2017-03-31.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-03-31",
        endpointPrefix: "lakeformation",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Lake Formation",
        serviceId: "LakeFormation",
        signatureVersion: "v4",
        signingName: "lakeformation",
        uid: "lakeformation-2017-03-31"
      },
      operations: {
        AddLFTagsToResource: {
          http: {
            requestUri: "/AddLFTagsToResource"
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "LFTags"
            ],
            members: {
              CatalogId: {},
              Resource: {
                shape: "S3"
              },
              LFTags: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Failures: {
                shape: "Sq"
              }
            }
          }
        },
        AssumeDecoratedRoleWithSAML: {
          http: {
            requestUri: "/AssumeDecoratedRoleWithSAML"
          },
          input: {
            type: "structure",
            required: [
              "SAMLAssertion",
              "RoleArn",
              "PrincipalArn"
            ],
            members: {
              SAMLAssertion: {},
              RoleArn: {},
              PrincipalArn: {},
              DurationSeconds: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccessKeyId: {},
              SecretAccessKey: {},
              SessionToken: {},
              Expiration: {
                type: "timestamp"
              }
            }
          }
        },
        BatchGrantPermissions: {
          http: {
            requestUri: "/BatchGrantPermissions"
          },
          input: {
            type: "structure",
            required: [
              "Entries"
            ],
            members: {
              CatalogId: {},
              Entries: {
                shape: "S15"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Failures: {
                shape: "S1d"
              }
            }
          }
        },
        BatchRevokePermissions: {
          http: {
            requestUri: "/BatchRevokePermissions"
          },
          input: {
            type: "structure",
            required: [
              "Entries"
            ],
            members: {
              CatalogId: {},
              Entries: {
                shape: "S15"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Failures: {
                shape: "S1d"
              }
            }
          }
        },
        CancelTransaction: {
          http: {
            requestUri: "/CancelTransaction"
          },
          input: {
            type: "structure",
            required: [
              "TransactionId"
            ],
            members: {
              TransactionId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CommitTransaction: {
          http: {
            requestUri: "/CommitTransaction"
          },
          input: {
            type: "structure",
            required: [
              "TransactionId"
            ],
            members: {
              TransactionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TransactionStatus: {}
            }
          }
        },
        CreateDataCellsFilter: {
          http: {
            requestUri: "/CreateDataCellsFilter"
          },
          input: {
            type: "structure",
            required: [
              "TableData"
            ],
            members: {
              TableData: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateLFTag: {
          http: {
            requestUri: "/CreateLFTag"
          },
          input: {
            type: "structure",
            required: [
              "TagKey",
              "TagValues"
            ],
            members: {
              CatalogId: {},
              TagKey: {},
              TagValues: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateLakeFormationIdentityCenterConfiguration: {
          http: {
            requestUri: "/CreateLakeFormationIdentityCenterConfiguration"
          },
          input: {
            type: "structure",
            members: {
              CatalogId: {},
              InstanceArn: {},
              ExternalFiltering: {
                shape: "S1y"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationArn: {}
            }
          }
        },
        CreateLakeFormationOptIn: {
          http: {
            requestUri: "/CreateLakeFormationOptIn"
          },
          input: {
            type: "structure",
            required: [
              "Principal",
              "Resource"
            ],
            members: {
              Principal: {
                shape: "S18"
              },
              Resource: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDataCellsFilter: {
          http: {
            requestUri: "/DeleteDataCellsFilter"
          },
          input: {
            type: "structure",
            members: {
              TableCatalogId: {},
              DatabaseName: {},
              TableName: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteLFTag: {
          http: {
            requestUri: "/DeleteLFTag"
          },
          input: {
            type: "structure",
            required: [
              "TagKey"
            ],
            members: {
              CatalogId: {},
              TagKey: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteLakeFormationIdentityCenterConfiguration: {
          http: {
            requestUri: "/DeleteLakeFormationIdentityCenterConfiguration"
          },
          input: {
            type: "structure",
            members: {
              CatalogId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteLakeFormationOptIn: {
          http: {
            requestUri: "/DeleteLakeFormationOptIn"
          },
          input: {
            type: "structure",
            required: [
              "Principal",
              "Resource"
            ],
            members: {
              Principal: {
                shape: "S18"
              },
              Resource: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteObjectsOnCancel: {
          http: {
            requestUri: "/DeleteObjectsOnCancel"
          },
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "TransactionId",
              "Objects"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              TransactionId: {},
              Objects: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Uri"
                  ],
                  members: {
                    Uri: {},
                    ETag: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeregisterResource: {
          http: {
            requestUri: "/DeregisterResource"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeLakeFormationIdentityCenterConfiguration: {
          http: {
            requestUri: "/DescribeLakeFormationIdentityCenterConfiguration"
          },
          input: {
            type: "structure",
            members: {
              CatalogId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CatalogId: {},
              InstanceArn: {},
              ApplicationArn: {},
              ExternalFiltering: {
                shape: "S1y"
              }
            }
          }
        },
        DescribeResource: {
          http: {
            requestUri: "/DescribeResource"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceInfo: {
                shape: "S2q"
              }
            }
          }
        },
        DescribeTransaction: {
          http: {
            requestUri: "/DescribeTransaction"
          },
          input: {
            type: "structure",
            required: [
              "TransactionId"
            ],
            members: {
              TransactionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TransactionDescription: {
                shape: "S2v"
              }
            }
          }
        },
        ExtendTransaction: {
          http: {
            requestUri: "/ExtendTransaction"
          },
          input: {
            type: "structure",
            members: {
              TransactionId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetDataCellsFilter: {
          http: {
            requestUri: "/GetDataCellsFilter"
          },
          input: {
            type: "structure",
            required: [
              "TableCatalogId",
              "DatabaseName",
              "TableName",
              "Name"
            ],
            members: {
              TableCatalogId: {},
              DatabaseName: {},
              TableName: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DataCellsFilter: {
                shape: "S1o"
              }
            }
          }
        },
        GetDataLakeSettings: {
          http: {
            requestUri: "/GetDataLakeSettings"
          },
          input: {
            type: "structure",
            members: {
              CatalogId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DataLakeSettings: {
                shape: "S33"
              }
            }
          }
        },
        GetEffectivePermissionsForPath: {
          http: {
            requestUri: "/GetEffectivePermissionsForPath"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              CatalogId: {},
              ResourceArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Permissions: {
                shape: "S3g"
              },
              NextToken: {}
            }
          }
        },
        GetLFTag: {
          http: {
            requestUri: "/GetLFTag"
          },
          input: {
            type: "structure",
            required: [
              "TagKey"
            ],
            members: {
              CatalogId: {},
              TagKey: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CatalogId: {},
              TagKey: {},
              TagValues: {
                shape: "Sg"
              }
            }
          }
        },
        GetQueryState: {
          http: {
            requestUri: "/GetQueryState",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "QueryId"
            ],
            members: {
              QueryId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "State"
            ],
            members: {
              Error: {},
              State: {}
            }
          },
          endpoint: {
            hostPrefix: "query-"
          }
        },
        GetQueryStatistics: {
          http: {
            requestUri: "/GetQueryStatistics",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "QueryId"
            ],
            members: {
              QueryId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ExecutionStatistics: {
                type: "structure",
                members: {
                  AverageExecutionTimeMillis: {
                    type: "long"
                  },
                  DataScannedBytes: {
                    type: "long"
                  },
                  WorkUnitsExecutedCount: {
                    type: "long"
                  }
                }
              },
              PlanningStatistics: {
                type: "structure",
                members: {
                  EstimatedDataToScanBytes: {
                    type: "long"
                  },
                  PlanningTimeMillis: {
                    type: "long"
                  },
                  QueueTimeMillis: {
                    type: "long"
                  },
                  WorkUnitsGeneratedCount: {
                    type: "long"
                  }
                }
              },
              QuerySubmissionTime: {
                type: "timestamp",
                timestampFormat: "iso8601"
              }
            }
          },
          endpoint: {
            hostPrefix: "query-"
          }
        },
        GetResourceLFTags: {
          http: {
            requestUri: "/GetResourceLFTags"
          },
          input: {
            type: "structure",
            required: [
              "Resource"
            ],
            members: {
              CatalogId: {},
              Resource: {
                shape: "S3"
              },
              ShowAssignedLFTags: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LFTagOnDatabase: {
                shape: "Sn"
              },
              LFTagsOnTable: {
                shape: "Sn"
              },
              LFTagsOnColumns: {
                shape: "S44"
              }
            }
          }
        },
        GetTableObjects: {
          http: {
            requestUri: "/GetTableObjects"
          },
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              TransactionId: {},
              QueryAsOfTime: {
                type: "timestamp"
              },
              PartitionPredicate: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Objects: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PartitionValues: {
                      shape: "S4b"
                    },
                    Objects: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Uri: {},
                          ETag: {},
                          Size: {
                            type: "long"
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetTemporaryGluePartitionCredentials: {
          http: {
            requestUri: "/GetTemporaryGluePartitionCredentials"
          },
          input: {
            type: "structure",
            required: [
              "TableArn",
              "Partition"
            ],
            members: {
              TableArn: {},
              Partition: {
                type: "structure",
                required: [
                  "Values"
                ],
                members: {
                  Values: {
                    type: "list",
                    member: {}
                  }
                }
              },
              Permissions: {
                shape: "S1a"
              },
              DurationSeconds: {
                type: "integer"
              },
              AuditContext: {
                shape: "S4k"
              },
              SupportedPermissionTypes: {
                shape: "S4m"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccessKeyId: {},
              SecretAccessKey: {},
              SessionToken: {},
              Expiration: {
                type: "timestamp"
              }
            }
          }
        },
        GetTemporaryGlueTableCredentials: {
          http: {
            requestUri: "/GetTemporaryGlueTableCredentials"
          },
          input: {
            type: "structure",
            required: [
              "TableArn"
            ],
            members: {
              TableArn: {},
              Permissions: {
                shape: "S1a"
              },
              DurationSeconds: {
                type: "integer"
              },
              AuditContext: {
                shape: "S4k"
              },
              SupportedPermissionTypes: {
                shape: "S4m"
              },
              S3Path: {},
              QuerySessionContext: {
                type: "structure",
                members: {
                  QueryId: {},
                  QueryStartTime: {
                    type: "timestamp"
                  },
                  ClusterId: {},
                  QueryAuthorizationId: {},
                  AdditionalContext: {
                    type: "map",
                    key: {},
                    value: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccessKeyId: {},
              SecretAccessKey: {},
              SessionToken: {},
              Expiration: {
                type: "timestamp"
              },
              VendedS3Path: {
                type: "list",
                member: {}
              }
            }
          }
        },
        GetWorkUnitResults: {
          http: {
            requestUri: "/GetWorkUnitResults",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "QueryId",
              "WorkUnitId",
              "WorkUnitToken"
            ],
            members: {
              QueryId: {},
              WorkUnitId: {
                type: "long"
              },
              WorkUnitToken: {
                type: "string",
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResultStream: {
                type: "blob",
                streaming: true
              }
            },
            payload: "ResultStream"
          },
          endpoint: {
            hostPrefix: "data-"
          }
        },
        GetWorkUnits: {
          http: {
            requestUri: "/GetWorkUnits",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "QueryId"
            ],
            members: {
              NextToken: {},
              PageSize: {
                type: "integer"
              },
              QueryId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "QueryId",
              "WorkUnitRanges"
            ],
            members: {
              NextToken: {},
              QueryId: {},
              WorkUnitRanges: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "WorkUnitIdMax",
                    "WorkUnitIdMin",
                    "WorkUnitToken"
                  ],
                  members: {
                    WorkUnitIdMax: {
                      type: "long"
                    },
                    WorkUnitIdMin: {
                      type: "long"
                    },
                    WorkUnitToken: {}
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "query-"
          }
        },
        GrantPermissions: {
          http: {
            requestUri: "/GrantPermissions"
          },
          input: {
            type: "structure",
            required: [
              "Principal",
              "Resource",
              "Permissions"
            ],
            members: {
              CatalogId: {},
              Principal: {
                shape: "S18"
              },
              Resource: {
                shape: "S3"
              },
              Permissions: {
                shape: "S1a"
              },
              PermissionsWithGrantOption: {
                shape: "S1a"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ListDataCellsFilter: {
          http: {
            requestUri: "/ListDataCellsFilter"
          },
          input: {
            type: "structure",
            members: {
              Table: {
                shape: "S7"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataCellsFilters: {
                type: "list",
                member: {
                  shape: "S1o"
                }
              },
              NextToken: {}
            }
          }
        },
        ListLFTags: {
          http: {
            requestUri: "/ListLFTags"
          },
          input: {
            type: "structure",
            members: {
              CatalogId: {},
              ResourceShareType: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LFTags: {
                shape: "Sn"
              },
              NextToken: {}
            }
          }
        },
        ListLakeFormationOptIns: {
          http: {
            requestUri: "/ListLakeFormationOptIns"
          },
          input: {
            type: "structure",
            members: {
              Principal: {
                shape: "S18"
              },
              Resource: {
                shape: "S3"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LakeFormationOptInsInfoList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Resource: {
                      shape: "S3"
                    },
                    Principal: {
                      shape: "S18"
                    },
                    LastModified: {
                      type: "timestamp"
                    },
                    LastUpdatedBy: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPermissions: {
          http: {
            requestUri: "/ListPermissions"
          },
          input: {
            type: "structure",
            members: {
              CatalogId: {},
              Principal: {
                shape: "S18"
              },
              ResourceType: {},
              Resource: {
                shape: "S3"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              IncludeRelated: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PrincipalResourcePermissions: {
                shape: "S3g"
              },
              NextToken: {}
            }
          }
        },
        ListResources: {
          http: {
            requestUri: "/ListResources"
          },
          input: {
            type: "structure",
            members: {
              FilterConditionList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Field: {},
                    ComparisonOperator: {},
                    StringValueList: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceInfoList: {
                type: "list",
                member: {
                  shape: "S2q"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTableStorageOptimizers: {
          http: {
            requestUri: "/ListTableStorageOptimizers"
          },
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              StorageOptimizerType: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StorageOptimizerList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StorageOptimizerType: {},
                    Config: {
                      shape: "S68"
                    },
                    ErrorMessage: {},
                    Warnings: {},
                    LastRunDetails: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTransactions: {
          http: {
            requestUri: "/ListTransactions"
          },
          input: {
            type: "structure",
            members: {
              CatalogId: {},
              StatusFilter: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Transactions: {
                type: "list",
                member: {
                  shape: "S2v"
                }
              },
              NextToken: {}
            }
          }
        },
        PutDataLakeSettings: {
          http: {
            requestUri: "/PutDataLakeSettings"
          },
          input: {
            type: "structure",
            required: [
              "DataLakeSettings"
            ],
            members: {
              CatalogId: {},
              DataLakeSettings: {
                shape: "S33"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RegisterResource: {
          http: {
            requestUri: "/RegisterResource"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              UseServiceLinkedRole: {
                type: "boolean"
              },
              RoleArn: {},
              WithFederation: {
                type: "boolean"
              },
              HybridAccessEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RemoveLFTagsFromResource: {
          http: {
            requestUri: "/RemoveLFTagsFromResource"
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "LFTags"
            ],
            members: {
              CatalogId: {},
              Resource: {
                shape: "S3"
              },
              LFTags: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Failures: {
                shape: "Sq"
              }
            }
          }
        },
        RevokePermissions: {
          http: {
            requestUri: "/RevokePermissions"
          },
          input: {
            type: "structure",
            required: [
              "Principal",
              "Resource",
              "Permissions"
            ],
            members: {
              CatalogId: {},
              Principal: {
                shape: "S18"
              },
              Resource: {
                shape: "S3"
              },
              Permissions: {
                shape: "S1a"
              },
              PermissionsWithGrantOption: {
                shape: "S1a"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SearchDatabasesByLFTags: {
          http: {
            requestUri: "/SearchDatabasesByLFTags"
          },
          input: {
            type: "structure",
            required: [
              "Expression"
            ],
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              CatalogId: {},
              Expression: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              DatabaseList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Database: {
                      shape: "S5"
                    },
                    LFTags: {
                      shape: "Sn"
                    }
                  }
                }
              }
            }
          }
        },
        SearchTablesByLFTags: {
          http: {
            requestUri: "/SearchTablesByLFTags"
          },
          input: {
            type: "structure",
            required: [
              "Expression"
            ],
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              CatalogId: {},
              Expression: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              TableList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Table: {
                      shape: "S7"
                    },
                    LFTagOnDatabase: {
                      shape: "Sn"
                    },
                    LFTagsOnTable: {
                      shape: "Sn"
                    },
                    LFTagsOnColumns: {
                      shape: "S44"
                    }
                  }
                }
              }
            }
          }
        },
        StartQueryPlanning: {
          http: {
            requestUri: "/StartQueryPlanning",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "QueryPlanningContext",
              "QueryString"
            ],
            members: {
              QueryPlanningContext: {
                type: "structure",
                required: [
                  "DatabaseName"
                ],
                members: {
                  CatalogId: {},
                  DatabaseName: {},
                  QueryAsOfTime: {
                    type: "timestamp"
                  },
                  QueryParameters: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  TransactionId: {}
                }
              },
              QueryString: {
                type: "string",
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "QueryId"
            ],
            members: {
              QueryId: {}
            }
          },
          endpoint: {
            hostPrefix: "query-"
          }
        },
        StartTransaction: {
          http: {
            requestUri: "/StartTransaction"
          },
          input: {
            type: "structure",
            members: {
              TransactionType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TransactionId: {}
            }
          }
        },
        UpdateDataCellsFilter: {
          http: {
            requestUri: "/UpdateDataCellsFilter"
          },
          input: {
            type: "structure",
            required: [
              "TableData"
            ],
            members: {
              TableData: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateLFTag: {
          http: {
            requestUri: "/UpdateLFTag"
          },
          input: {
            type: "structure",
            required: [
              "TagKey"
            ],
            members: {
              CatalogId: {},
              TagKey: {},
              TagValuesToDelete: {
                shape: "Sg"
              },
              TagValuesToAdd: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateLakeFormationIdentityCenterConfiguration: {
          http: {
            requestUri: "/UpdateLakeFormationIdentityCenterConfiguration"
          },
          input: {
            type: "structure",
            members: {
              CatalogId: {},
              ApplicationStatus: {},
              ExternalFiltering: {
                shape: "S1y"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateResource: {
          http: {
            requestUri: "/UpdateResource"
          },
          input: {
            type: "structure",
            required: [
              "RoleArn",
              "ResourceArn"
            ],
            members: {
              RoleArn: {},
              ResourceArn: {},
              WithFederation: {
                type: "boolean"
              },
              HybridAccessEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateTableObjects: {
          http: {
            requestUri: "/UpdateTableObjects"
          },
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "WriteOperations"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              TransactionId: {},
              WriteOperations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AddObject: {
                      type: "structure",
                      required: [
                        "Uri",
                        "ETag",
                        "Size"
                      ],
                      members: {
                        Uri: {},
                        ETag: {},
                        Size: {
                          type: "long"
                        },
                        PartitionValues: {
                          shape: "S4b"
                        }
                      }
                    },
                    DeleteObject: {
                      type: "structure",
                      required: [
                        "Uri"
                      ],
                      members: {
                        Uri: {},
                        ETag: {},
                        PartitionValues: {
                          shape: "S4b"
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateTableStorageOptimizer: {
          http: {
            requestUri: "/UpdateTableStorageOptimizer"
          },
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "StorageOptimizerConfig"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              StorageOptimizerConfig: {
                type: "map",
                key: {},
                value: {
                  shape: "S68"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Result: {}
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          members: {
            Catalog: {
              type: "structure",
              members: {}
            },
            Database: {
              shape: "S5"
            },
            Table: {
              shape: "S7"
            },
            TableWithColumns: {
              type: "structure",
              required: [
                "DatabaseName",
                "Name"
              ],
              members: {
                CatalogId: {},
                DatabaseName: {},
                Name: {},
                ColumnNames: {
                  shape: "Sa"
                },
                ColumnWildcard: {
                  shape: "Sb"
                }
              }
            },
            DataLocation: {
              type: "structure",
              required: [
                "ResourceArn"
              ],
              members: {
                CatalogId: {},
                ResourceArn: {}
              }
            },
            DataCellsFilter: {
              type: "structure",
              members: {
                TableCatalogId: {},
                DatabaseName: {},
                TableName: {},
                Name: {}
              }
            },
            LFTag: {
              type: "structure",
              required: [
                "TagKey",
                "TagValues"
              ],
              members: {
                CatalogId: {},
                TagKey: {},
                TagValues: {
                  shape: "Sg"
                }
              }
            },
            LFTagPolicy: {
              type: "structure",
              required: [
                "ResourceType",
                "Expression"
              ],
              members: {
                CatalogId: {},
                ResourceType: {},
                Expression: {
                  shape: "Sk"
                }
              }
            }
          }
        },
        S5: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            CatalogId: {},
            Name: {}
          }
        },
        S7: {
          type: "structure",
          required: [
            "DatabaseName"
          ],
          members: {
            CatalogId: {},
            DatabaseName: {},
            Name: {},
            TableWildcard: {
              type: "structure",
              members: {}
            }
          }
        },
        Sa: {
          type: "list",
          member: {}
        },
        Sb: {
          type: "structure",
          members: {
            ExcludedColumnNames: {
              shape: "Sa"
            }
          }
        },
        Sg: {
          type: "list",
          member: {}
        },
        Sk: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "TagKey",
              "TagValues"
            ],
            members: {
              TagKey: {},
              TagValues: {
                shape: "Sg"
              }
            }
          }
        },
        Sn: {
          type: "list",
          member: {
            shape: "So"
          }
        },
        So: {
          type: "structure",
          required: [
            "TagKey",
            "TagValues"
          ],
          members: {
            CatalogId: {},
            TagKey: {},
            TagValues: {
              shape: "Sg"
            }
          }
        },
        Sq: {
          type: "list",
          member: {
            type: "structure",
            members: {
              LFTag: {
                shape: "So"
              },
              Error: {
                shape: "Ss"
              }
            }
          }
        },
        Ss: {
          type: "structure",
          members: {
            ErrorCode: {},
            ErrorMessage: {}
          }
        },
        S15: {
          type: "list",
          member: {
            shape: "S16"
          }
        },
        S16: {
          type: "structure",
          required: [
            "Id"
          ],
          members: {
            Id: {},
            Principal: {
              shape: "S18"
            },
            Resource: {
              shape: "S3"
            },
            Permissions: {
              shape: "S1a"
            },
            PermissionsWithGrantOption: {
              shape: "S1a"
            }
          }
        },
        S18: {
          type: "structure",
          members: {
            DataLakePrincipalIdentifier: {}
          }
        },
        S1a: {
          type: "list",
          member: {}
        },
        S1d: {
          type: "list",
          member: {
            type: "structure",
            members: {
              RequestEntry: {
                shape: "S16"
              },
              Error: {
                shape: "Ss"
              }
            }
          }
        },
        S1o: {
          type: "structure",
          required: [
            "TableCatalogId",
            "DatabaseName",
            "TableName",
            "Name"
          ],
          members: {
            TableCatalogId: {},
            DatabaseName: {},
            TableName: {},
            Name: {},
            RowFilter: {
              type: "structure",
              members: {
                FilterExpression: {},
                AllRowsWildcard: {
                  type: "structure",
                  members: {}
                }
              }
            },
            ColumnNames: {
              shape: "Sa"
            },
            ColumnWildcard: {
              shape: "Sb"
            },
            VersionId: {}
          }
        },
        S1y: {
          type: "structure",
          required: [
            "Status",
            "AuthorizedTargets"
          ],
          members: {
            Status: {},
            AuthorizedTargets: {
              type: "list",
              member: {}
            }
          }
        },
        S2q: {
          type: "structure",
          members: {
            ResourceArn: {},
            RoleArn: {},
            LastModified: {
              type: "timestamp"
            },
            WithFederation: {
              type: "boolean"
            },
            HybridAccessEnabled: {
              type: "boolean"
            }
          }
        },
        S2v: {
          type: "structure",
          members: {
            TransactionId: {},
            TransactionStatus: {},
            TransactionStartTime: {
              type: "timestamp"
            },
            TransactionEndTime: {
              type: "timestamp"
            }
          }
        },
        S33: {
          type: "structure",
          members: {
            DataLakeAdmins: {
              shape: "S34"
            },
            ReadOnlyAdmins: {
              shape: "S34"
            },
            CreateDatabaseDefaultPermissions: {
              shape: "S35"
            },
            CreateTableDefaultPermissions: {
              shape: "S35"
            },
            Parameters: {
              type: "map",
              key: {},
              value: {}
            },
            TrustedResourceOwners: {
              type: "list",
              member: {}
            },
            AllowExternalDataFiltering: {
              type: "boolean"
            },
            AllowFullTableExternalDataAccess: {
              type: "boolean"
            },
            ExternalDataFilteringAllowList: {
              shape: "S34"
            },
            AuthorizedSessionTagValueList: {
              type: "list",
              member: {}
            }
          }
        },
        S34: {
          type: "list",
          member: {
            shape: "S18"
          }
        },
        S35: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Principal: {
                shape: "S18"
              },
              Permissions: {
                shape: "S1a"
              }
            }
          }
        },
        S3g: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Principal: {
                shape: "S18"
              },
              Resource: {
                shape: "S3"
              },
              Permissions: {
                shape: "S1a"
              },
              PermissionsWithGrantOption: {
                shape: "S1a"
              },
              AdditionalDetails: {
                type: "structure",
                members: {
                  ResourceShare: {
                    type: "list",
                    member: {}
                  }
                }
              },
              LastUpdated: {
                type: "timestamp"
              },
              LastUpdatedBy: {}
            }
          }
        },
        S44: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              LFTags: {
                shape: "Sn"
              }
            }
          }
        },
        S4b: {
          type: "list",
          member: {}
        },
        S4k: {
          type: "structure",
          members: {
            AdditionalAuditContext: {}
          }
        },
        S4m: {
          type: "list",
          member: {}
        },
        S68: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/lakeformation-2017-03-31.paginators.json
var require_lakeformation_2017_03_31_paginators = __commonJS({
  "node_modules/aws-sdk/apis/lakeformation-2017-03-31.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetEffectivePermissionsForPath: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetTableObjects: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetWorkUnits: {
          input_token: "NextToken",
          limit_key: "PageSize",
          output_token: "NextToken",
          result_key: "WorkUnitRanges"
        },
        ListDataCellsFilter: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "DataCellsFilters"
        },
        ListLFTags: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "LFTags"
        },
        ListLakeFormationOptIns: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListPermissions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListResources: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListTableStorageOptimizers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListTransactions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        SearchDatabasesByLFTags: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "DatabaseList"
        },
        SearchTablesByLFTags: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TableList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/lakeformation.js
var require_lakeformation = __commonJS({
  "node_modules/aws-sdk/clients/lakeformation.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["lakeformation"] = {};
    AWS2.LakeFormation = Service.defineService("lakeformation", ["2017-03-31"]);
    Object.defineProperty(apiLoader.services["lakeformation"], "2017-03-31", {
      get: function get() {
        var model = require_lakeformation_2017_03_31_min();
        model.paginators = require_lakeformation_2017_03_31_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.LakeFormation;
  }
});

// node_modules/aws-sdk/apis/forecast-2018-06-26.min.json
var require_forecast_2018_06_26_min = __commonJS({
  "node_modules/aws-sdk/apis/forecast-2018-06-26.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-06-26",
        endpointPrefix: "forecast",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Forecast Service",
        serviceId: "forecast",
        signatureVersion: "v4",
        signingName: "forecast",
        targetPrefix: "AmazonForecast",
        uid: "forecast-2018-06-26"
      },
      operations: {
        CreateAutoPredictor: {
          input: {
            type: "structure",
            required: [
              "PredictorName"
            ],
            members: {
              PredictorName: {},
              ForecastHorizon: {
                type: "integer"
              },
              ForecastTypes: {
                shape: "S4"
              },
              ForecastDimensions: {
                shape: "S6"
              },
              ForecastFrequency: {},
              DataConfig: {
                shape: "S8"
              },
              EncryptionConfig: {
                shape: "Si"
              },
              ReferencePredictorArn: {},
              OptimizationMetric: {},
              ExplainPredictor: {
                type: "boolean"
              },
              Tags: {
                shape: "Sm"
              },
              MonitorConfig: {
                type: "structure",
                required: [
                  "MonitorName"
                ],
                members: {
                  MonitorName: {}
                }
              },
              TimeAlignmentBoundary: {
                shape: "Sr"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PredictorArn: {}
            }
          }
        },
        CreateDataset: {
          input: {
            type: "structure",
            required: [
              "DatasetName",
              "Domain",
              "DatasetType",
              "Schema"
            ],
            members: {
              DatasetName: {},
              Domain: {},
              DatasetType: {},
              DataFrequency: {},
              Schema: {
                shape: "S10"
              },
              EncryptionConfig: {
                shape: "Si"
              },
              Tags: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetArn: {}
            }
          }
        },
        CreateDatasetGroup: {
          input: {
            type: "structure",
            required: [
              "DatasetGroupName",
              "Domain"
            ],
            members: {
              DatasetGroupName: {},
              Domain: {},
              DatasetArns: {
                shape: "S16"
              },
              Tags: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetGroupArn: {}
            }
          }
        },
        CreateDatasetImportJob: {
          input: {
            type: "structure",
            required: [
              "DatasetImportJobName",
              "DatasetArn",
              "DataSource"
            ],
            members: {
              DatasetImportJobName: {},
              DatasetArn: {},
              DataSource: {
                shape: "S19"
              },
              TimestampFormat: {},
              TimeZone: {},
              UseGeolocationForTimeZone: {
                type: "boolean"
              },
              GeolocationFormat: {},
              Tags: {
                shape: "Sm"
              },
              Format: {},
              ImportMode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetImportJobArn: {}
            }
          }
        },
        CreateExplainability: {
          input: {
            type: "structure",
            required: [
              "ExplainabilityName",
              "ResourceArn",
              "ExplainabilityConfig"
            ],
            members: {
              ExplainabilityName: {},
              ResourceArn: {},
              ExplainabilityConfig: {
                shape: "S1k"
              },
              DataSource: {
                shape: "S19"
              },
              Schema: {
                shape: "S10"
              },
              EnableVisualization: {
                type: "boolean"
              },
              StartDateTime: {},
              EndDateTime: {},
              Tags: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ExplainabilityArn: {}
            }
          }
        },
        CreateExplainabilityExport: {
          input: {
            type: "structure",
            required: [
              "ExplainabilityExportName",
              "ExplainabilityArn",
              "Destination"
            ],
            members: {
              ExplainabilityExportName: {},
              ExplainabilityArn: {},
              Destination: {
                shape: "S1q"
              },
              Tags: {
                shape: "Sm"
              },
              Format: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ExplainabilityExportArn: {}
            }
          }
        },
        CreateForecast: {
          input: {
            type: "structure",
            required: [
              "ForecastName",
              "PredictorArn"
            ],
            members: {
              ForecastName: {},
              PredictorArn: {},
              ForecastTypes: {
                shape: "S4"
              },
              Tags: {
                shape: "Sm"
              },
              TimeSeriesSelector: {
                shape: "S1t"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ForecastArn: {}
            }
          }
        },
        CreateForecastExportJob: {
          input: {
            type: "structure",
            required: [
              "ForecastExportJobName",
              "ForecastArn",
              "Destination"
            ],
            members: {
              ForecastExportJobName: {},
              ForecastArn: {},
              Destination: {
                shape: "S1q"
              },
              Tags: {
                shape: "Sm"
              },
              Format: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ForecastExportJobArn: {}
            }
          }
        },
        CreateMonitor: {
          input: {
            type: "structure",
            required: [
              "MonitorName",
              "ResourceArn"
            ],
            members: {
              MonitorName: {},
              ResourceArn: {},
              Tags: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MonitorArn: {}
            }
          }
        },
        CreatePredictor: {
          input: {
            type: "structure",
            required: [
              "PredictorName",
              "ForecastHorizon",
              "InputDataConfig",
              "FeaturizationConfig"
            ],
            members: {
              PredictorName: {},
              AlgorithmArn: {},
              ForecastHorizon: {
                type: "integer"
              },
              ForecastTypes: {
                shape: "S4"
              },
              PerformAutoML: {
                type: "boolean"
              },
              AutoMLOverrideStrategy: {},
              PerformHPO: {
                type: "boolean"
              },
              TrainingParameters: {
                shape: "S22"
              },
              EvaluationParameters: {
                shape: "S25"
              },
              HPOConfig: {
                shape: "S26"
              },
              InputDataConfig: {
                shape: "S2g"
              },
              FeaturizationConfig: {
                shape: "S2j"
              },
              EncryptionConfig: {
                shape: "Si"
              },
              Tags: {
                shape: "Sm"
              },
              OptimizationMetric: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PredictorArn: {}
            }
          }
        },
        CreatePredictorBacktestExportJob: {
          input: {
            type: "structure",
            required: [
              "PredictorBacktestExportJobName",
              "PredictorArn",
              "Destination"
            ],
            members: {
              PredictorBacktestExportJobName: {},
              PredictorArn: {},
              Destination: {
                shape: "S1q"
              },
              Tags: {
                shape: "Sm"
              },
              Format: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PredictorBacktestExportJobArn: {}
            }
          }
        },
        CreateWhatIfAnalysis: {
          input: {
            type: "structure",
            required: [
              "WhatIfAnalysisName",
              "ForecastArn"
            ],
            members: {
              WhatIfAnalysisName: {},
              ForecastArn: {},
              TimeSeriesSelector: {
                shape: "S1t"
              },
              Tags: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WhatIfAnalysisArn: {}
            }
          }
        },
        CreateWhatIfForecast: {
          input: {
            type: "structure",
            required: [
              "WhatIfForecastName",
              "WhatIfAnalysisArn"
            ],
            members: {
              WhatIfForecastName: {},
              WhatIfAnalysisArn: {},
              TimeSeriesTransformations: {
                shape: "S2w"
              },
              TimeSeriesReplacementsDataSource: {
                shape: "S34"
              },
              Tags: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WhatIfForecastArn: {}
            }
          }
        },
        CreateWhatIfForecastExport: {
          input: {
            type: "structure",
            required: [
              "WhatIfForecastExportName",
              "WhatIfForecastArns",
              "Destination"
            ],
            members: {
              WhatIfForecastExportName: {},
              WhatIfForecastArns: {
                shape: "S38"
              },
              Destination: {
                shape: "S1q"
              },
              Tags: {
                shape: "Sm"
              },
              Format: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WhatIfForecastExportArn: {}
            }
          }
        },
        DeleteDataset: {
          input: {
            type: "structure",
            required: [
              "DatasetArn"
            ],
            members: {
              DatasetArn: {}
            }
          },
          idempotent: true
        },
        DeleteDatasetGroup: {
          input: {
            type: "structure",
            required: [
              "DatasetGroupArn"
            ],
            members: {
              DatasetGroupArn: {}
            }
          },
          idempotent: true
        },
        DeleteDatasetImportJob: {
          input: {
            type: "structure",
            required: [
              "DatasetImportJobArn"
            ],
            members: {
              DatasetImportJobArn: {}
            }
          },
          idempotent: true
        },
        DeleteExplainability: {
          input: {
            type: "structure",
            required: [
              "ExplainabilityArn"
            ],
            members: {
              ExplainabilityArn: {}
            }
          },
          idempotent: true
        },
        DeleteExplainabilityExport: {
          input: {
            type: "structure",
            required: [
              "ExplainabilityExportArn"
            ],
            members: {
              ExplainabilityExportArn: {}
            }
          },
          idempotent: true
        },
        DeleteForecast: {
          input: {
            type: "structure",
            required: [
              "ForecastArn"
            ],
            members: {
              ForecastArn: {}
            }
          },
          idempotent: true
        },
        DeleteForecastExportJob: {
          input: {
            type: "structure",
            required: [
              "ForecastExportJobArn"
            ],
            members: {
              ForecastExportJobArn: {}
            }
          },
          idempotent: true
        },
        DeleteMonitor: {
          input: {
            type: "structure",
            required: [
              "MonitorArn"
            ],
            members: {
              MonitorArn: {}
            }
          },
          idempotent: true
        },
        DeletePredictor: {
          input: {
            type: "structure",
            required: [
              "PredictorArn"
            ],
            members: {
              PredictorArn: {}
            }
          },
          idempotent: true
        },
        DeletePredictorBacktestExportJob: {
          input: {
            type: "structure",
            required: [
              "PredictorBacktestExportJobArn"
            ],
            members: {
              PredictorBacktestExportJobArn: {}
            }
          },
          idempotent: true
        },
        DeleteResourceTree: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          idempotent: true
        },
        DeleteWhatIfAnalysis: {
          input: {
            type: "structure",
            required: [
              "WhatIfAnalysisArn"
            ],
            members: {
              WhatIfAnalysisArn: {}
            }
          },
          idempotent: true
        },
        DeleteWhatIfForecast: {
          input: {
            type: "structure",
            required: [
              "WhatIfForecastArn"
            ],
            members: {
              WhatIfForecastArn: {}
            }
          },
          idempotent: true
        },
        DeleteWhatIfForecastExport: {
          input: {
            type: "structure",
            required: [
              "WhatIfForecastExportArn"
            ],
            members: {
              WhatIfForecastExportArn: {}
            }
          },
          idempotent: true
        },
        DescribeAutoPredictor: {
          input: {
            type: "structure",
            required: [
              "PredictorArn"
            ],
            members: {
              PredictorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PredictorArn: {},
              PredictorName: {},
              ForecastHorizon: {
                type: "integer"
              },
              ForecastTypes: {
                shape: "S4"
              },
              ForecastFrequency: {},
              ForecastDimensions: {
                shape: "S6"
              },
              DatasetImportJobArns: {
                shape: "S16"
              },
              DataConfig: {
                shape: "S8"
              },
              EncryptionConfig: {
                shape: "Si"
              },
              ReferencePredictorSummary: {
                shape: "S3q"
              },
              EstimatedTimeRemainingInMinutes: {
                type: "long"
              },
              Status: {},
              Message: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModificationTime: {
                type: "timestamp"
              },
              OptimizationMetric: {},
              ExplainabilityInfo: {
                type: "structure",
                members: {
                  ExplainabilityArn: {},
                  Status: {}
                }
              },
              MonitorInfo: {
                type: "structure",
                members: {
                  MonitorArn: {},
                  Status: {}
                }
              },
              TimeAlignmentBoundary: {
                shape: "Sr"
              }
            }
          },
          idempotent: true
        },
        DescribeDataset: {
          input: {
            type: "structure",
            required: [
              "DatasetArn"
            ],
            members: {
              DatasetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetArn: {},
              DatasetName: {},
              Domain: {},
              DatasetType: {},
              DataFrequency: {},
              Schema: {
                shape: "S10"
              },
              EncryptionConfig: {
                shape: "Si"
              },
              Status: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModificationTime: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        DescribeDatasetGroup: {
          input: {
            type: "structure",
            required: [
              "DatasetGroupArn"
            ],
            members: {
              DatasetGroupArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetGroupName: {},
              DatasetGroupArn: {},
              DatasetArns: {
                shape: "S16"
              },
              Domain: {},
              Status: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModificationTime: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        DescribeDatasetImportJob: {
          input: {
            type: "structure",
            required: [
              "DatasetImportJobArn"
            ],
            members: {
              DatasetImportJobArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetImportJobName: {},
              DatasetImportJobArn: {},
              DatasetArn: {},
              TimestampFormat: {},
              TimeZone: {},
              UseGeolocationForTimeZone: {
                type: "boolean"
              },
              GeolocationFormat: {},
              DataSource: {
                shape: "S19"
              },
              EstimatedTimeRemainingInMinutes: {
                type: "long"
              },
              FieldStatistics: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    Count: {
                      type: "integer"
                    },
                    CountDistinct: {
                      type: "integer"
                    },
                    CountNull: {
                      type: "integer"
                    },
                    CountNan: {
                      type: "integer"
                    },
                    Min: {},
                    Max: {},
                    Avg: {
                      type: "double"
                    },
                    Stddev: {
                      type: "double"
                    },
                    CountLong: {
                      type: "long"
                    },
                    CountDistinctLong: {
                      type: "long"
                    },
                    CountNullLong: {
                      type: "long"
                    },
                    CountNanLong: {
                      type: "long"
                    }
                  }
                }
              },
              DataSize: {
                type: "double"
              },
              Status: {},
              Message: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModificationTime: {
                type: "timestamp"
              },
              Format: {},
              ImportMode: {}
            }
          },
          idempotent: true
        },
        DescribeExplainability: {
          input: {
            type: "structure",
            required: [
              "ExplainabilityArn"
            ],
            members: {
              ExplainabilityArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ExplainabilityArn: {},
              ExplainabilityName: {},
              ResourceArn: {},
              ExplainabilityConfig: {
                shape: "S1k"
              },
              EnableVisualization: {
                type: "boolean"
              },
              DataSource: {
                shape: "S19"
              },
              Schema: {
                shape: "S10"
              },
              StartDateTime: {},
              EndDateTime: {},
              EstimatedTimeRemainingInMinutes: {
                type: "long"
              },
              Message: {},
              Status: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModificationTime: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        DescribeExplainabilityExport: {
          input: {
            type: "structure",
            required: [
              "ExplainabilityExportArn"
            ],
            members: {
              ExplainabilityExportArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ExplainabilityExportArn: {},
              ExplainabilityExportName: {},
              ExplainabilityArn: {},
              Destination: {
                shape: "S1q"
              },
              Message: {},
              Status: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModificationTime: {
                type: "timestamp"
              },
              Format: {}
            }
          },
          idempotent: true
        },
        DescribeForecast: {
          input: {
            type: "structure",
            required: [
              "ForecastArn"
            ],
            members: {
              ForecastArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ForecastArn: {},
              ForecastName: {},
              ForecastTypes: {
                shape: "S4"
              },
              PredictorArn: {},
              DatasetGroupArn: {},
              EstimatedTimeRemainingInMinutes: {
                type: "long"
              },
              Status: {},
              Message: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModificationTime: {
                type: "timestamp"
              },
              TimeSeriesSelector: {
                shape: "S1t"
              }
            }
          },
          idempotent: true
        },
        DescribeForecastExportJob: {
          input: {
            type: "structure",
            required: [
              "ForecastExportJobArn"
            ],
            members: {
              ForecastExportJobArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ForecastExportJobArn: {},
              ForecastExportJobName: {},
              ForecastArn: {},
              Destination: {
                shape: "S1q"
              },
              Message: {},
              Status: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModificationTime: {
                type: "timestamp"
              },
              Format: {}
            }
          },
          idempotent: true
        },
        DescribeMonitor: {
          input: {
            type: "structure",
            required: [
              "MonitorArn"
            ],
            members: {
              MonitorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MonitorName: {},
              MonitorArn: {},
              ResourceArn: {},
              Status: {},
              LastEvaluationTime: {
                type: "timestamp"
              },
              LastEvaluationState: {},
              Baseline: {
                type: "structure",
                members: {
                  PredictorBaseline: {
                    type: "structure",
                    members: {
                      BaselineMetrics: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            Name: {},
                            Value: {
                              type: "double"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              Message: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModificationTime: {
                type: "timestamp"
              },
              EstimatedEvaluationTimeRemainingInMinutes: {
                type: "long"
              }
            }
          },
          idempotent: true
        },
        DescribePredictor: {
          input: {
            type: "structure",
            required: [
              "PredictorArn"
            ],
            members: {
              PredictorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PredictorArn: {},
              PredictorName: {},
              AlgorithmArn: {},
              AutoMLAlgorithmArns: {
                shape: "S16"
              },
              ForecastHorizon: {
                type: "integer"
              },
              ForecastTypes: {
                shape: "S4"
              },
              PerformAutoML: {
                type: "boolean"
              },
              AutoMLOverrideStrategy: {},
              PerformHPO: {
                type: "boolean"
              },
              TrainingParameters: {
                shape: "S22"
              },
              EvaluationParameters: {
                shape: "S25"
              },
              HPOConfig: {
                shape: "S26"
              },
              InputDataConfig: {
                shape: "S2g"
              },
              FeaturizationConfig: {
                shape: "S2j"
              },
              EncryptionConfig: {
                shape: "Si"
              },
              PredictorExecutionDetails: {
                type: "structure",
                members: {
                  PredictorExecutions: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        AlgorithmArn: {},
                        TestWindows: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              TestWindowStart: {
                                type: "timestamp"
                              },
                              TestWindowEnd: {
                                type: "timestamp"
                              },
                              Status: {},
                              Message: {}
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              EstimatedTimeRemainingInMinutes: {
                type: "long"
              },
              IsAutoPredictor: {
                type: "boolean"
              },
              DatasetImportJobArns: {
                shape: "S16"
              },
              Status: {},
              Message: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModificationTime: {
                type: "timestamp"
              },
              OptimizationMetric: {}
            }
          },
          idempotent: true
        },
        DescribePredictorBacktestExportJob: {
          input: {
            type: "structure",
            required: [
              "PredictorBacktestExportJobArn"
            ],
            members: {
              PredictorBacktestExportJobArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PredictorBacktestExportJobArn: {},
              PredictorBacktestExportJobName: {},
              PredictorArn: {},
              Destination: {
                shape: "S1q"
              },
              Message: {},
              Status: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModificationTime: {
                type: "timestamp"
              },
              Format: {}
            }
          },
          idempotent: true
        },
        DescribeWhatIfAnalysis: {
          input: {
            type: "structure",
            required: [
              "WhatIfAnalysisArn"
            ],
            members: {
              WhatIfAnalysisArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WhatIfAnalysisName: {},
              WhatIfAnalysisArn: {},
              ForecastArn: {},
              EstimatedTimeRemainingInMinutes: {
                type: "long"
              },
              Status: {},
              Message: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModificationTime: {
                type: "timestamp"
              },
              TimeSeriesSelector: {
                shape: "S1t"
              }
            }
          },
          idempotent: true
        },
        DescribeWhatIfForecast: {
          input: {
            type: "structure",
            required: [
              "WhatIfForecastArn"
            ],
            members: {
              WhatIfForecastArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WhatIfForecastName: {},
              WhatIfForecastArn: {},
              WhatIfAnalysisArn: {},
              EstimatedTimeRemainingInMinutes: {
                type: "long"
              },
              Status: {},
              Message: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModificationTime: {
                type: "timestamp"
              },
              TimeSeriesTransformations: {
                shape: "S2w"
              },
              TimeSeriesReplacementsDataSource: {
                shape: "S34"
              },
              ForecastTypes: {
                shape: "S4"
              }
            }
          },
          idempotent: true
        },
        DescribeWhatIfForecastExport: {
          input: {
            type: "structure",
            required: [
              "WhatIfForecastExportArn"
            ],
            members: {
              WhatIfForecastExportArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WhatIfForecastExportArn: {},
              WhatIfForecastExportName: {},
              WhatIfForecastArns: {
                type: "list",
                member: {}
              },
              Destination: {
                shape: "S1q"
              },
              Message: {},
              Status: {},
              CreationTime: {
                type: "timestamp"
              },
              EstimatedTimeRemainingInMinutes: {
                type: "long"
              },
              LastModificationTime: {
                type: "timestamp"
              },
              Format: {}
            }
          },
          idempotent: true
        },
        GetAccuracyMetrics: {
          input: {
            type: "structure",
            required: [
              "PredictorArn"
            ],
            members: {
              PredictorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PredictorEvaluationResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AlgorithmArn: {},
                    TestWindows: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          TestWindowStart: {
                            type: "timestamp"
                          },
                          TestWindowEnd: {
                            type: "timestamp"
                          },
                          ItemCount: {
                            type: "integer"
                          },
                          EvaluationType: {},
                          Metrics: {
                            type: "structure",
                            members: {
                              RMSE: {
                                deprecated: true,
                                deprecatedMessage: "This property is deprecated, please refer to ErrorMetrics for both RMSE and WAPE",
                                type: "double"
                              },
                              WeightedQuantileLosses: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    Quantile: {
                                      type: "double"
                                    },
                                    LossValue: {
                                      type: "double"
                                    }
                                  }
                                }
                              },
                              ErrorMetrics: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    ForecastType: {},
                                    WAPE: {
                                      type: "double"
                                    },
                                    RMSE: {
                                      type: "double"
                                    },
                                    MASE: {
                                      type: "double"
                                    },
                                    MAPE: {
                                      type: "double"
                                    }
                                  }
                                }
                              },
                              AverageWeightedQuantileLoss: {
                                type: "double"
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              IsAutoPredictor: {
                type: "boolean"
              },
              AutoMLOverrideStrategy: {},
              OptimizationMetric: {}
            }
          },
          idempotent: true
        },
        ListDatasetGroups: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DatasetGroupArn: {},
                    DatasetGroupName: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModificationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListDatasetImportJobs: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S5m"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetImportJobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DatasetImportJobArn: {},
                    DatasetImportJobName: {},
                    DataSource: {
                      shape: "S19"
                    },
                    Status: {},
                    Message: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModificationTime: {
                      type: "timestamp"
                    },
                    ImportMode: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListDatasets: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Datasets: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DatasetArn: {},
                    DatasetName: {},
                    DatasetType: {},
                    Domain: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModificationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListExplainabilities: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S5m"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Explainabilities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ExplainabilityArn: {},
                    ExplainabilityName: {},
                    ResourceArn: {},
                    ExplainabilityConfig: {
                      shape: "S1k"
                    },
                    Status: {},
                    Message: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModificationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListExplainabilityExports: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S5m"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ExplainabilityExports: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ExplainabilityExportArn: {},
                    ExplainabilityExportName: {},
                    Destination: {
                      shape: "S1q"
                    },
                    Status: {},
                    Message: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModificationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListForecastExportJobs: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S5m"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ForecastExportJobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ForecastExportJobArn: {},
                    ForecastExportJobName: {},
                    Destination: {
                      shape: "S1q"
                    },
                    Status: {},
                    Message: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModificationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListForecasts: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S5m"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Forecasts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ForecastArn: {},
                    ForecastName: {},
                    PredictorArn: {},
                    CreatedUsingAutoPredictor: {
                      type: "boolean"
                    },
                    DatasetGroupArn: {},
                    Status: {},
                    Message: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModificationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListMonitorEvaluations: {
          input: {
            type: "structure",
            required: [
              "MonitorArn"
            ],
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              MonitorArn: {},
              Filters: {
                shape: "S5m"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              PredictorMonitorEvaluations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceArn: {},
                    MonitorArn: {},
                    EvaluationTime: {
                      type: "timestamp"
                    },
                    EvaluationState: {},
                    WindowStartDatetime: {
                      type: "timestamp"
                    },
                    WindowEndDatetime: {
                      type: "timestamp"
                    },
                    PredictorEvent: {
                      type: "structure",
                      members: {
                        Detail: {},
                        Datetime: {
                          type: "timestamp"
                        }
                      }
                    },
                    MonitorDataSource: {
                      type: "structure",
                      members: {
                        DatasetImportJobArn: {},
                        ForecastArn: {},
                        PredictorArn: {}
                      }
                    },
                    MetricResults: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          MetricName: {},
                          MetricValue: {
                            type: "double"
                          }
                        }
                      }
                    },
                    NumItemsEvaluated: {
                      type: "long"
                    },
                    Message: {}
                  }
                }
              }
            }
          },
          idempotent: true
        },
        ListMonitors: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S5m"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Monitors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MonitorArn: {},
                    MonitorName: {},
                    ResourceArn: {},
                    Status: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModificationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListPredictorBacktestExportJobs: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S5m"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PredictorBacktestExportJobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PredictorBacktestExportJobArn: {},
                    PredictorBacktestExportJobName: {},
                    Destination: {
                      shape: "S1q"
                    },
                    Status: {},
                    Message: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModificationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListPredictors: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S5m"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Predictors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PredictorArn: {},
                    PredictorName: {},
                    DatasetGroupArn: {},
                    IsAutoPredictor: {
                      type: "boolean"
                    },
                    ReferencePredictorSummary: {
                      shape: "S3q"
                    },
                    Status: {},
                    Message: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModificationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sm"
              }
            }
          }
        },
        ListWhatIfAnalyses: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S5m"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WhatIfAnalyses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WhatIfAnalysisArn: {},
                    WhatIfAnalysisName: {},
                    ForecastArn: {},
                    Status: {},
                    Message: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModificationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListWhatIfForecastExports: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S5m"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WhatIfForecastExports: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WhatIfForecastExportArn: {},
                    WhatIfForecastArns: {
                      shape: "S38"
                    },
                    WhatIfForecastExportName: {},
                    Destination: {
                      shape: "S1q"
                    },
                    Status: {},
                    Message: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModificationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListWhatIfForecasts: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S5m"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WhatIfForecasts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WhatIfForecastArn: {},
                    WhatIfForecastName: {},
                    WhatIfAnalysisArn: {},
                    Status: {},
                    Message: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModificationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ResumeResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          idempotent: true
        },
        StopResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          idempotent: true
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {
                  shape: "So"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDatasetGroup: {
          input: {
            type: "structure",
            required: [
              "DatasetGroupArn",
              "DatasetArns"
            ],
            members: {
              DatasetGroupArn: {},
              DatasetArns: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        }
      },
      shapes: {
        S4: {
          type: "list",
          member: {}
        },
        S6: {
          type: "list",
          member: {}
        },
        S8: {
          type: "structure",
          required: [
            "DatasetGroupArn"
          ],
          members: {
            DatasetGroupArn: {},
            AttributeConfigs: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "AttributeName",
                  "Transformations"
                ],
                members: {
                  AttributeName: {},
                  Transformations: {
                    type: "map",
                    key: {},
                    value: {}
                  }
                }
              }
            },
            AdditionalDatasets: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name"
                ],
                members: {
                  Name: {},
                  Configuration: {
                    type: "map",
                    key: {},
                    value: {
                      shape: "Sh"
                    }
                  }
                }
              }
            }
          }
        },
        Sh: {
          type: "list",
          member: {}
        },
        Si: {
          type: "structure",
          required: [
            "RoleArn",
            "KMSKeyArn"
          ],
          members: {
            RoleArn: {},
            KMSKeyArn: {}
          }
        },
        Sm: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {
                shape: "So"
              },
              Value: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        So: {
          type: "string",
          sensitive: true
        },
        Sr: {
          type: "structure",
          members: {
            Month: {},
            DayOfMonth: {
              type: "integer"
            },
            DayOfWeek: {},
            Hour: {
              type: "integer"
            }
          }
        },
        S10: {
          type: "structure",
          members: {
            Attributes: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  AttributeName: {},
                  AttributeType: {}
                }
              }
            }
          }
        },
        S16: {
          type: "list",
          member: {}
        },
        S19: {
          type: "structure",
          required: [
            "S3Config"
          ],
          members: {
            S3Config: {
              shape: "S1a"
            }
          }
        },
        S1a: {
          type: "structure",
          required: [
            "Path",
            "RoleArn"
          ],
          members: {
            Path: {},
            RoleArn: {},
            KMSKeyArn: {}
          }
        },
        S1k: {
          type: "structure",
          required: [
            "TimeSeriesGranularity",
            "TimePointGranularity"
          ],
          members: {
            TimeSeriesGranularity: {},
            TimePointGranularity: {}
          }
        },
        S1q: {
          type: "structure",
          required: [
            "S3Config"
          ],
          members: {
            S3Config: {
              shape: "S1a"
            }
          }
        },
        S1t: {
          type: "structure",
          members: {
            TimeSeriesIdentifiers: {
              type: "structure",
              members: {
                DataSource: {
                  shape: "S19"
                },
                Schema: {
                  shape: "S10"
                },
                Format: {}
              }
            }
          }
        },
        S22: {
          type: "map",
          key: {},
          value: {}
        },
        S25: {
          type: "structure",
          members: {
            NumberOfBacktestWindows: {
              type: "integer"
            },
            BackTestWindowOffset: {
              type: "integer"
            }
          }
        },
        S26: {
          type: "structure",
          members: {
            ParameterRanges: {
              type: "structure",
              members: {
                CategoricalParameterRanges: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "Name",
                      "Values"
                    ],
                    members: {
                      Name: {},
                      Values: {
                        shape: "Sh"
                      }
                    }
                  }
                },
                ContinuousParameterRanges: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "Name",
                      "MaxValue",
                      "MinValue"
                    ],
                    members: {
                      Name: {},
                      MaxValue: {
                        type: "double"
                      },
                      MinValue: {
                        type: "double"
                      },
                      ScalingType: {}
                    }
                  }
                },
                IntegerParameterRanges: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "Name",
                      "MaxValue",
                      "MinValue"
                    ],
                    members: {
                      Name: {},
                      MaxValue: {
                        type: "integer"
                      },
                      MinValue: {
                        type: "integer"
                      },
                      ScalingType: {}
                    }
                  }
                }
              }
            }
          }
        },
        S2g: {
          type: "structure",
          required: [
            "DatasetGroupArn"
          ],
          members: {
            DatasetGroupArn: {},
            SupplementaryFeatures: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name",
                  "Value"
                ],
                members: {
                  Name: {},
                  Value: {}
                }
              }
            }
          }
        },
        S2j: {
          type: "structure",
          required: [
            "ForecastFrequency"
          ],
          members: {
            ForecastFrequency: {},
            ForecastDimensions: {
              shape: "S6"
            },
            Featurizations: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "AttributeName"
                ],
                members: {
                  AttributeName: {},
                  FeaturizationPipeline: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "FeaturizationMethodName"
                      ],
                      members: {
                        FeaturizationMethodName: {},
                        FeaturizationMethodParameters: {
                          type: "map",
                          key: {},
                          value: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S2w: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Action: {
                type: "structure",
                required: [
                  "AttributeName",
                  "Operation",
                  "Value"
                ],
                members: {
                  AttributeName: {},
                  Operation: {},
                  Value: {
                    type: "double"
                  }
                }
              },
              TimeSeriesConditions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AttributeName",
                    "AttributeValue",
                    "Condition"
                  ],
                  members: {
                    AttributeName: {},
                    AttributeValue: {},
                    Condition: {}
                  }
                }
              }
            }
          }
        },
        S34: {
          type: "structure",
          required: [
            "S3Config",
            "Schema"
          ],
          members: {
            S3Config: {
              shape: "S1a"
            },
            Schema: {
              shape: "S10"
            },
            Format: {},
            TimestampFormat: {}
          }
        },
        S38: {
          type: "list",
          member: {}
        },
        S3q: {
          type: "structure",
          members: {
            Arn: {},
            State: {}
          }
        },
        S5m: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value",
              "Condition"
            ],
            members: {
              Key: {},
              Value: {},
              Condition: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/forecast-2018-06-26.paginators.json
var require_forecast_2018_06_26_paginators = __commonJS({
  "node_modules/aws-sdk/apis/forecast-2018-06-26.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListDatasetGroups: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "DatasetGroups"
        },
        ListDatasetImportJobs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "DatasetImportJobs"
        },
        ListDatasets: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Datasets"
        },
        ListExplainabilities: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Explainabilities"
        },
        ListExplainabilityExports: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ExplainabilityExports"
        },
        ListForecastExportJobs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ForecastExportJobs"
        },
        ListForecasts: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Forecasts"
        },
        ListMonitorEvaluations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PredictorMonitorEvaluations"
        },
        ListMonitors: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Monitors"
        },
        ListPredictorBacktestExportJobs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PredictorBacktestExportJobs"
        },
        ListPredictors: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Predictors"
        },
        ListWhatIfAnalyses: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "WhatIfAnalyses"
        },
        ListWhatIfForecastExports: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "WhatIfForecastExports"
        },
        ListWhatIfForecasts: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "WhatIfForecasts"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/forecastservice.js
var require_forecastservice = __commonJS({
  "node_modules/aws-sdk/clients/forecastservice.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["forecastservice"] = {};
    AWS2.ForecastService = Service.defineService("forecastservice", ["2018-06-26"]);
    Object.defineProperty(apiLoader.services["forecastservice"], "2018-06-26", {
      get: function get() {
        var model = require_forecast_2018_06_26_min();
        model.paginators = require_forecast_2018_06_26_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ForecastService;
  }
});

// node_modules/aws-sdk/apis/forecastquery-2018-06-26.min.json
var require_forecastquery_2018_06_26_min = __commonJS({
  "node_modules/aws-sdk/apis/forecastquery-2018-06-26.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-06-26",
        endpointPrefix: "forecastquery",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Forecast Query Service",
        serviceId: "forecastquery",
        signatureVersion: "v4",
        signingName: "forecast",
        targetPrefix: "AmazonForecastRuntime",
        uid: "forecastquery-2018-06-26"
      },
      operations: {
        QueryForecast: {
          input: {
            type: "structure",
            required: [
              "ForecastArn",
              "Filters"
            ],
            members: {
              ForecastArn: {},
              StartDate: {},
              EndDate: {},
              Filters: {
                shape: "S4"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Forecast: {
                shape: "S9"
              }
            }
          }
        },
        QueryWhatIfForecast: {
          input: {
            type: "structure",
            required: [
              "WhatIfForecastArn",
              "Filters"
            ],
            members: {
              WhatIfForecastArn: {},
              StartDate: {},
              EndDate: {},
              Filters: {
                shape: "S4"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Forecast: {
                shape: "S9"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "map",
          key: {},
          value: {}
        },
        S9: {
          type: "structure",
          members: {
            Predictions: {
              type: "map",
              key: {},
              value: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Timestamp: {},
                    Value: {
                      type: "double"
                    }
                  }
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/forecastquery-2018-06-26.paginators.json
var require_forecastquery_2018_06_26_paginators = __commonJS({
  "node_modules/aws-sdk/apis/forecastquery-2018-06-26.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/forecastqueryservice.js
var require_forecastqueryservice = __commonJS({
  "node_modules/aws-sdk/clients/forecastqueryservice.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["forecastqueryservice"] = {};
    AWS2.ForecastQueryService = Service.defineService("forecastqueryservice", ["2018-06-26"]);
    Object.defineProperty(apiLoader.services["forecastqueryservice"], "2018-06-26", {
      get: function get() {
        var model = require_forecastquery_2018_06_26_min();
        model.paginators = require_forecastquery_2018_06_26_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ForecastQueryService;
  }
});

// node_modules/aws-sdk/apis/qldb-2019-01-02.min.json
var require_qldb_2019_01_02_min = __commonJS({
  "node_modules/aws-sdk/apis/qldb-2019-01-02.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-01-02",
        endpointPrefix: "qldb",
        jsonVersion: "1.0",
        protocol: "rest-json",
        serviceAbbreviation: "QLDB",
        serviceFullName: "Amazon QLDB",
        serviceId: "QLDB",
        signatureVersion: "v4",
        signingName: "qldb",
        uid: "qldb-2019-01-02"
      },
      operations: {
        CancelJournalKinesisStream: {
          http: {
            method: "DELETE",
            requestUri: "/ledgers/{name}/journal-kinesis-streams/{streamId}"
          },
          input: {
            type: "structure",
            required: [
              "LedgerName",
              "StreamId"
            ],
            members: {
              LedgerName: {
                location: "uri",
                locationName: "name"
              },
              StreamId: {
                location: "uri",
                locationName: "streamId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamId: {}
            }
          }
        },
        CreateLedger: {
          http: {
            requestUri: "/ledgers"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "PermissionsMode"
            ],
            members: {
              Name: {},
              Tags: {
                shape: "S6"
              },
              PermissionsMode: {},
              DeletionProtection: {
                type: "boolean"
              },
              KmsKey: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Arn: {},
              State: {},
              CreationDateTime: {
                type: "timestamp"
              },
              PermissionsMode: {},
              DeletionProtection: {
                type: "boolean"
              },
              KmsKeyArn: {}
            }
          }
        },
        DeleteLedger: {
          http: {
            method: "DELETE",
            requestUri: "/ledgers/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          }
        },
        DescribeJournalKinesisStream: {
          http: {
            method: "GET",
            requestUri: "/ledgers/{name}/journal-kinesis-streams/{streamId}"
          },
          input: {
            type: "structure",
            required: [
              "LedgerName",
              "StreamId"
            ],
            members: {
              LedgerName: {
                location: "uri",
                locationName: "name"
              },
              StreamId: {
                location: "uri",
                locationName: "streamId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Stream: {
                shape: "Sj"
              }
            }
          }
        },
        DescribeJournalS3Export: {
          http: {
            method: "GET",
            requestUri: "/ledgers/{name}/journal-s3-exports/{exportId}"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "ExportId"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              ExportId: {
                location: "uri",
                locationName: "exportId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ExportDescription"
            ],
            members: {
              ExportDescription: {
                shape: "Sr"
              }
            }
          }
        },
        DescribeLedger: {
          http: {
            method: "GET",
            requestUri: "/ledgers/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Arn: {},
              State: {},
              CreationDateTime: {
                type: "timestamp"
              },
              PermissionsMode: {},
              DeletionProtection: {
                type: "boolean"
              },
              EncryptionDescription: {
                shape: "S11"
              }
            }
          }
        },
        ExportJournalToS3: {
          http: {
            requestUri: "/ledgers/{name}/journal-s3-exports"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "InclusiveStartTime",
              "ExclusiveEndTime",
              "S3ExportConfiguration",
              "RoleArn"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              InclusiveStartTime: {
                type: "timestamp"
              },
              ExclusiveEndTime: {
                type: "timestamp"
              },
              S3ExportConfiguration: {
                shape: "St"
              },
              RoleArn: {},
              OutputFormat: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ExportId"
            ],
            members: {
              ExportId: {}
            }
          }
        },
        GetBlock: {
          http: {
            requestUri: "/ledgers/{name}/block"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "BlockAddress"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              BlockAddress: {
                shape: "S16"
              },
              DigestTipAddress: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Block"
            ],
            members: {
              Block: {
                shape: "S16"
              },
              Proof: {
                shape: "S16"
              }
            }
          }
        },
        GetDigest: {
          http: {
            requestUri: "/ledgers/{name}/digest"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Digest",
              "DigestTipAddress"
            ],
            members: {
              Digest: {
                type: "blob"
              },
              DigestTipAddress: {
                shape: "S16"
              }
            }
          }
        },
        GetRevision: {
          http: {
            requestUri: "/ledgers/{name}/revision"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "BlockAddress",
              "DocumentId"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              BlockAddress: {
                shape: "S16"
              },
              DocumentId: {},
              DigestTipAddress: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Revision"
            ],
            members: {
              Proof: {
                shape: "S16"
              },
              Revision: {
                shape: "S16"
              }
            }
          }
        },
        ListJournalKinesisStreamsForLedger: {
          http: {
            method: "GET",
            requestUri: "/ledgers/{name}/journal-kinesis-streams"
          },
          input: {
            type: "structure",
            required: [
              "LedgerName"
            ],
            members: {
              LedgerName: {
                location: "uri",
                locationName: "name"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max_results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next_token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Streams: {
                type: "list",
                member: {
                  shape: "Sj"
                }
              },
              NextToken: {}
            }
          }
        },
        ListJournalS3Exports: {
          http: {
            method: "GET",
            requestUri: "/journal-s3-exports"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "max_results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next_token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JournalS3Exports: {
                shape: "S1l"
              },
              NextToken: {}
            }
          }
        },
        ListJournalS3ExportsForLedger: {
          http: {
            method: "GET",
            requestUri: "/ledgers/{name}/journal-s3-exports"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max_results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next_token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JournalS3Exports: {
                shape: "S1l"
              },
              NextToken: {}
            }
          }
        },
        ListLedgers: {
          http: {
            method: "GET",
            requestUri: "/ledgers"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "max_results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next_token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Ledgers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    State: {},
                    CreationDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S6"
              }
            }
          }
        },
        StreamJournalToKinesis: {
          http: {
            requestUri: "/ledgers/{name}/journal-kinesis-streams"
          },
          input: {
            type: "structure",
            required: [
              "LedgerName",
              "RoleArn",
              "InclusiveStartTime",
              "KinesisConfiguration",
              "StreamName"
            ],
            members: {
              LedgerName: {
                location: "uri",
                locationName: "name"
              },
              RoleArn: {},
              Tags: {
                shape: "S6"
              },
              InclusiveStartTime: {
                type: "timestamp"
              },
              ExclusiveEndTime: {
                type: "timestamp"
              },
              KinesisConfiguration: {
                shape: "Sl"
              },
              StreamName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StreamId: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              Tags: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateLedger: {
          http: {
            method: "PATCH",
            requestUri: "/ledgers/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              DeletionProtection: {
                type: "boolean"
              },
              KmsKey: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Arn: {},
              State: {},
              CreationDateTime: {
                type: "timestamp"
              },
              DeletionProtection: {
                type: "boolean"
              },
              EncryptionDescription: {
                shape: "S11"
              }
            }
          }
        },
        UpdateLedgerPermissionsMode: {
          http: {
            method: "PATCH",
            requestUri: "/ledgers/{name}/permissions-mode"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "PermissionsMode"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              PermissionsMode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Arn: {},
              PermissionsMode: {}
            }
          }
        }
      },
      shapes: {
        S6: {
          type: "map",
          key: {},
          value: {}
        },
        Sj: {
          type: "structure",
          required: [
            "LedgerName",
            "RoleArn",
            "StreamId",
            "Status",
            "KinesisConfiguration",
            "StreamName"
          ],
          members: {
            LedgerName: {},
            CreationTime: {
              type: "timestamp"
            },
            InclusiveStartTime: {
              type: "timestamp"
            },
            ExclusiveEndTime: {
              type: "timestamp"
            },
            RoleArn: {},
            StreamId: {},
            Arn: {},
            Status: {},
            KinesisConfiguration: {
              shape: "Sl"
            },
            ErrorCause: {},
            StreamName: {}
          }
        },
        Sl: {
          type: "structure",
          required: [
            "StreamArn"
          ],
          members: {
            StreamArn: {},
            AggregationEnabled: {
              type: "boolean"
            }
          }
        },
        Sr: {
          type: "structure",
          required: [
            "LedgerName",
            "ExportId",
            "ExportCreationTime",
            "Status",
            "InclusiveStartTime",
            "ExclusiveEndTime",
            "S3ExportConfiguration",
            "RoleArn"
          ],
          members: {
            LedgerName: {},
            ExportId: {},
            ExportCreationTime: {
              type: "timestamp"
            },
            Status: {},
            InclusiveStartTime: {
              type: "timestamp"
            },
            ExclusiveEndTime: {
              type: "timestamp"
            },
            S3ExportConfiguration: {
              shape: "St"
            },
            RoleArn: {},
            OutputFormat: {}
          }
        },
        St: {
          type: "structure",
          required: [
            "Bucket",
            "Prefix",
            "EncryptionConfiguration"
          ],
          members: {
            Bucket: {},
            Prefix: {},
            EncryptionConfiguration: {
              type: "structure",
              required: [
                "ObjectEncryptionType"
              ],
              members: {
                ObjectEncryptionType: {},
                KmsKeyArn: {}
              }
            }
          }
        },
        S11: {
          type: "structure",
          required: [
            "KmsKeyArn",
            "EncryptionStatus"
          ],
          members: {
            KmsKeyArn: {},
            EncryptionStatus: {},
            InaccessibleKmsKeyDateTime: {
              type: "timestamp"
            }
          }
        },
        S16: {
          type: "structure",
          members: {
            IonText: {
              type: "string",
              sensitive: true
            }
          },
          sensitive: true
        },
        S1l: {
          type: "list",
          member: {
            shape: "Sr"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/qldb-2019-01-02.paginators.json
var require_qldb_2019_01_02_paginators = __commonJS({
  "node_modules/aws-sdk/apis/qldb-2019-01-02.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListJournalKinesisStreamsForLedger: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListJournalS3Exports: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListJournalS3ExportsForLedger: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListLedgers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/qldb.js
var require_qldb = __commonJS({
  "node_modules/aws-sdk/clients/qldb.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["qldb"] = {};
    AWS2.QLDB = Service.defineService("qldb", ["2019-01-02"]);
    Object.defineProperty(apiLoader.services["qldb"], "2019-01-02", {
      get: function get() {
        var model = require_qldb_2019_01_02_min();
        model.paginators = require_qldb_2019_01_02_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.QLDB;
  }
});

// node_modules/aws-sdk/apis/qldb-session-2019-07-11.min.json
var require_qldb_session_2019_07_11_min = __commonJS({
  "node_modules/aws-sdk/apis/qldb-session-2019-07-11.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-07-11",
        endpointPrefix: "session.qldb",
        jsonVersion: "1.0",
        protocol: "json",
        serviceAbbreviation: "QLDB Session",
        serviceFullName: "Amazon QLDB Session",
        serviceId: "QLDB Session",
        signatureVersion: "v4",
        signingName: "qldb",
        targetPrefix: "QLDBSession",
        uid: "qldb-session-2019-07-11"
      },
      operations: {
        SendCommand: {
          input: {
            type: "structure",
            members: {
              SessionToken: {},
              StartSession: {
                type: "structure",
                required: [
                  "LedgerName"
                ],
                members: {
                  LedgerName: {}
                }
              },
              StartTransaction: {
                type: "structure",
                members: {}
              },
              EndSession: {
                type: "structure",
                members: {}
              },
              CommitTransaction: {
                type: "structure",
                required: [
                  "TransactionId",
                  "CommitDigest"
                ],
                members: {
                  TransactionId: {},
                  CommitDigest: {
                    type: "blob"
                  }
                }
              },
              AbortTransaction: {
                type: "structure",
                members: {}
              },
              ExecuteStatement: {
                type: "structure",
                required: [
                  "TransactionId",
                  "Statement"
                ],
                members: {
                  TransactionId: {},
                  Statement: {},
                  Parameters: {
                    type: "list",
                    member: {
                      shape: "Se"
                    }
                  }
                }
              },
              FetchPage: {
                type: "structure",
                required: [
                  "TransactionId",
                  "NextPageToken"
                ],
                members: {
                  TransactionId: {},
                  NextPageToken: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StartSession: {
                type: "structure",
                members: {
                  SessionToken: {},
                  TimingInformation: {
                    shape: "Sl"
                  }
                }
              },
              StartTransaction: {
                type: "structure",
                members: {
                  TransactionId: {},
                  TimingInformation: {
                    shape: "Sl"
                  }
                }
              },
              EndSession: {
                type: "structure",
                members: {
                  TimingInformation: {
                    shape: "Sl"
                  }
                }
              },
              CommitTransaction: {
                type: "structure",
                members: {
                  TransactionId: {},
                  CommitDigest: {
                    type: "blob"
                  },
                  TimingInformation: {
                    shape: "Sl"
                  },
                  ConsumedIOs: {
                    shape: "Sq"
                  }
                }
              },
              AbortTransaction: {
                type: "structure",
                members: {
                  TimingInformation: {
                    shape: "Sl"
                  }
                }
              },
              ExecuteStatement: {
                type: "structure",
                members: {
                  FirstPage: {
                    shape: "Sv"
                  },
                  TimingInformation: {
                    shape: "Sl"
                  },
                  ConsumedIOs: {
                    shape: "Sq"
                  }
                }
              },
              FetchPage: {
                type: "structure",
                members: {
                  Page: {
                    shape: "Sv"
                  },
                  TimingInformation: {
                    shape: "Sl"
                  },
                  ConsumedIOs: {
                    shape: "Sq"
                  }
                }
              }
            }
          }
        }
      },
      shapes: {
        Se: {
          type: "structure",
          members: {
            IonBinary: {
              type: "blob"
            },
            IonText: {}
          }
        },
        Sl: {
          type: "structure",
          members: {
            ProcessingTimeMilliseconds: {
              type: "long"
            }
          }
        },
        Sq: {
          type: "structure",
          members: {
            ReadIOs: {
              type: "long"
            },
            WriteIOs: {
              type: "long"
            }
          }
        },
        Sv: {
          type: "structure",
          members: {
            Values: {
              type: "list",
              member: {
                shape: "Se"
              }
            },
            NextPageToken: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/qldb-session-2019-07-11.paginators.json
var require_qldb_session_2019_07_11_paginators = __commonJS({
  "node_modules/aws-sdk/apis/qldb-session-2019-07-11.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/qldbsession.js
var require_qldbsession = __commonJS({
  "node_modules/aws-sdk/clients/qldbsession.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["qldbsession"] = {};
    AWS2.QLDBSession = Service.defineService("qldbsession", ["2019-07-11"]);
    Object.defineProperty(apiLoader.services["qldbsession"], "2019-07-11", {
      get: function get() {
        var model = require_qldb_session_2019_07_11_min();
        model.paginators = require_qldb_session_2019_07_11_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.QLDBSession;
  }
});

// node_modules/aws-sdk/apis/workmailmessageflow-2019-05-01.min.json
var require_workmailmessageflow_2019_05_01_min = __commonJS({
  "node_modules/aws-sdk/apis/workmailmessageflow-2019-05-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-05-01",
        endpointPrefix: "workmailmessageflow",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon WorkMail Message Flow",
        serviceId: "WorkMailMessageFlow",
        signatureVersion: "v4",
        uid: "workmailmessageflow-2019-05-01"
      },
      operations: {
        GetRawMessageContent: {
          http: {
            method: "GET",
            requestUri: "/messages/{messageId}"
          },
          input: {
            type: "structure",
            required: [
              "messageId"
            ],
            members: {
              messageId: {
                location: "uri",
                locationName: "messageId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "messageContent"
            ],
            members: {
              messageContent: {
                type: "blob",
                streaming: true
              }
            },
            payload: "messageContent"
          }
        },
        PutRawMessageContent: {
          http: {
            requestUri: "/messages/{messageId}"
          },
          input: {
            type: "structure",
            required: [
              "messageId",
              "content"
            ],
            members: {
              messageId: {
                location: "uri",
                locationName: "messageId"
              },
              content: {
                type: "structure",
                required: [
                  "s3Reference"
                ],
                members: {
                  s3Reference: {
                    type: "structure",
                    required: [
                      "bucket",
                      "key"
                    ],
                    members: {
                      bucket: {},
                      key: {},
                      objectVersion: {}
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/apis/workmailmessageflow-2019-05-01.paginators.json
var require_workmailmessageflow_2019_05_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/workmailmessageflow-2019-05-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/workmailmessageflow.js
var require_workmailmessageflow = __commonJS({
  "node_modules/aws-sdk/clients/workmailmessageflow.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["workmailmessageflow"] = {};
    AWS2.WorkMailMessageFlow = Service.defineService("workmailmessageflow", ["2019-05-01"]);
    Object.defineProperty(apiLoader.services["workmailmessageflow"], "2019-05-01", {
      get: function get() {
        var model = require_workmailmessageflow_2019_05_01_min();
        model.paginators = require_workmailmessageflow_2019_05_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.WorkMailMessageFlow;
  }
});

// node_modules/aws-sdk/apis/codestar-notifications-2019-10-15.min.json
var require_codestar_notifications_2019_10_15_min = __commonJS({
  "node_modules/aws-sdk/apis/codestar-notifications-2019-10-15.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-10-15",
        endpointPrefix: "codestar-notifications",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS CodeStar Notifications",
        serviceId: "codestar notifications",
        signatureVersion: "v4",
        signingName: "codestar-notifications",
        uid: "codestar-notifications-2019-10-15"
      },
      operations: {
        CreateNotificationRule: {
          http: {
            requestUri: "/createNotificationRule"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "EventTypeIds",
              "Resource",
              "Targets",
              "DetailType"
            ],
            members: {
              Name: {
                shape: "S2"
              },
              EventTypeIds: {
                shape: "S3"
              },
              Resource: {},
              Targets: {
                shape: "S6"
              },
              DetailType: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sc"
              },
              Status: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {}
            }
          }
        },
        DeleteNotificationRule: {
          http: {
            requestUri: "/deleteNotificationRule"
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {}
            }
          }
        },
        DeleteTarget: {
          http: {
            requestUri: "/deleteTarget"
          },
          input: {
            type: "structure",
            required: [
              "TargetAddress"
            ],
            members: {
              TargetAddress: {
                shape: "S9"
              },
              ForceUnsubscribeAll: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeNotificationRule: {
          http: {
            requestUri: "/describeNotificationRule"
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {},
              Name: {
                shape: "S2"
              },
              EventTypes: {
                shape: "Sp"
              },
              Resource: {},
              Targets: {
                shape: "Su"
              },
              DetailType: {},
              CreatedBy: {},
              Status: {},
              CreatedTimestamp: {
                type: "timestamp"
              },
              LastModifiedTimestamp: {
                type: "timestamp"
              },
              Tags: {
                shape: "Sc"
              }
            }
          }
        },
        ListEventTypes: {
          http: {
            requestUri: "/listEventTypes"
          },
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Value"
                  ],
                  members: {
                    Name: {},
                    Value: {}
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventTypes: {
                shape: "Sp"
              },
              NextToken: {}
            }
          }
        },
        ListNotificationRules: {
          http: {
            requestUri: "/listNotificationRules"
          },
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Value"
                  ],
                  members: {
                    Name: {},
                    Value: {}
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              NotificationRules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            requestUri: "/listTagsForResource"
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sc"
              }
            }
          }
        },
        ListTargets: {
          http: {
            requestUri: "/listTargets"
          },
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Value"
                  ],
                  members: {
                    Name: {},
                    Value: {}
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Targets: {
                shape: "Su"
              },
              NextToken: {}
            }
          }
        },
        Subscribe: {
          http: {
            requestUri: "/subscribe"
          },
          input: {
            type: "structure",
            required: [
              "Arn",
              "Target"
            ],
            members: {
              Arn: {},
              Target: {
                shape: "S7"
              },
              ClientRequestToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tagResource"
          },
          input: {
            type: "structure",
            required: [
              "Arn",
              "Tags"
            ],
            members: {
              Arn: {},
              Tags: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sc"
              }
            }
          }
        },
        Unsubscribe: {
          http: {
            requestUri: "/unsubscribe"
          },
          input: {
            type: "structure",
            required: [
              "Arn",
              "TargetAddress"
            ],
            members: {
              Arn: {},
              TargetAddress: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {}
            }
          }
        },
        UntagResource: {
          http: {
            requestUri: "/untagResource/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "Arn",
              "TagKeys"
            ],
            members: {
              Arn: {
                location: "uri",
                locationName: "resourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateNotificationRule: {
          http: {
            requestUri: "/updateNotificationRule"
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {},
              Name: {
                shape: "S2"
              },
              Status: {},
              EventTypeIds: {
                shape: "S3"
              },
              Targets: {
                shape: "S6"
              },
              DetailType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S2: {
          type: "string",
          sensitive: true
        },
        S3: {
          type: "list",
          member: {}
        },
        S6: {
          type: "list",
          member: {
            shape: "S7"
          }
        },
        S7: {
          type: "structure",
          members: {
            TargetType: {},
            TargetAddress: {
              shape: "S9"
            }
          }
        },
        S9: {
          type: "string",
          sensitive: true
        },
        Sc: {
          type: "map",
          key: {},
          value: {}
        },
        Sp: {
          type: "list",
          member: {
            type: "structure",
            members: {
              EventTypeId: {},
              ServiceName: {},
              EventTypeName: {},
              ResourceType: {}
            }
          }
        },
        Su: {
          type: "list",
          member: {
            type: "structure",
            members: {
              TargetAddress: {
                shape: "S9"
              },
              TargetType: {},
              TargetStatus: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/codestar-notifications-2019-10-15.paginators.json
var require_codestar_notifications_2019_10_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/codestar-notifications-2019-10-15.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListEventTypes: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "EventTypes"
        },
        ListNotificationRules: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "NotificationRules"
        },
        ListTargets: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Targets"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/codestarnotifications.js
var require_codestarnotifications = __commonJS({
  "node_modules/aws-sdk/clients/codestarnotifications.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["codestarnotifications"] = {};
    AWS2.CodeStarNotifications = Service.defineService("codestarnotifications", ["2019-10-15"]);
    Object.defineProperty(apiLoader.services["codestarnotifications"], "2019-10-15", {
      get: function get() {
        var model = require_codestar_notifications_2019_10_15_min();
        model.paginators = require_codestar_notifications_2019_10_15_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CodeStarNotifications;
  }
});

// node_modules/aws-sdk/apis/savingsplans-2019-06-28.min.json
var require_savingsplans_2019_06_28_min = __commonJS({
  "node_modules/aws-sdk/apis/savingsplans-2019-06-28.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-06-28",
        endpointPrefix: "savingsplans",
        globalEndpoint: "savingsplans.amazonaws.com",
        jsonVersion: "1.0",
        protocol: "rest-json",
        serviceAbbreviation: "AWSSavingsPlans",
        serviceFullName: "AWS Savings Plans",
        serviceId: "savingsplans",
        signatureVersion: "v4",
        uid: "savingsplans-2019-06-28"
      },
      operations: {
        CreateSavingsPlan: {
          http: {
            requestUri: "/CreateSavingsPlan"
          },
          input: {
            type: "structure",
            required: [
              "savingsPlanOfferingId",
              "commitment"
            ],
            members: {
              savingsPlanOfferingId: {},
              commitment: {},
              upfrontPaymentAmount: {},
              purchaseTime: {
                type: "timestamp"
              },
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              savingsPlanId: {}
            }
          }
        },
        DeleteQueuedSavingsPlan: {
          http: {
            requestUri: "/DeleteQueuedSavingsPlan"
          },
          input: {
            type: "structure",
            required: [
              "savingsPlanId"
            ],
            members: {
              savingsPlanId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeSavingsPlanRates: {
          http: {
            requestUri: "/DescribeSavingsPlanRates"
          },
          input: {
            type: "structure",
            required: [
              "savingsPlanId"
            ],
            members: {
              savingsPlanId: {},
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    values: {
                      shape: "Sh"
                    }
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              savingsPlanId: {},
              searchResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    rate: {},
                    currency: {},
                    unit: {},
                    productType: {},
                    serviceCode: {},
                    usageType: {},
                    operation: {},
                    properties: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          value: {}
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeSavingsPlans: {
          http: {
            requestUri: "/DescribeSavingsPlans"
          },
          input: {
            type: "structure",
            members: {
              savingsPlanArns: {
                type: "list",
                member: {}
              },
              savingsPlanIds: {
                type: "list",
                member: {}
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              states: {
                type: "list",
                member: {}
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    values: {
                      shape: "Sh"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              savingsPlans: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    offeringId: {},
                    savingsPlanId: {},
                    savingsPlanArn: {},
                    description: {},
                    start: {},
                    end: {},
                    state: {},
                    region: {},
                    ec2InstanceFamily: {},
                    savingsPlanType: {},
                    paymentOption: {},
                    productTypes: {
                      shape: "S1e"
                    },
                    currency: {},
                    commitment: {},
                    upfrontPaymentAmount: {},
                    recurringPaymentAmount: {},
                    termDurationInSeconds: {
                      type: "long"
                    },
                    tags: {
                      shape: "S6"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeSavingsPlansOfferingRates: {
          http: {
            requestUri: "/DescribeSavingsPlansOfferingRates"
          },
          input: {
            type: "structure",
            members: {
              savingsPlanOfferingIds: {
                shape: "S1h"
              },
              savingsPlanPaymentOptions: {
                shape: "S1j"
              },
              savingsPlanTypes: {
                shape: "S1k"
              },
              products: {
                shape: "S1e"
              },
              serviceCodes: {
                type: "list",
                member: {}
              },
              usageTypes: {
                type: "list",
                member: {}
              },
              operations: {
                type: "list",
                member: {}
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    values: {
                      shape: "S1r"
                    }
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              searchResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    savingsPlanOffering: {
                      type: "structure",
                      members: {
                        offeringId: {},
                        paymentOption: {},
                        planType: {},
                        durationSeconds: {
                          type: "long"
                        },
                        currency: {},
                        planDescription: {}
                      }
                    },
                    rate: {},
                    unit: {},
                    productType: {},
                    serviceCode: {},
                    usageType: {},
                    operation: {},
                    properties: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          value: {}
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeSavingsPlansOfferings: {
          http: {
            requestUri: "/DescribeSavingsPlansOfferings"
          },
          input: {
            type: "structure",
            members: {
              offeringIds: {
                shape: "S1h"
              },
              paymentOptions: {
                shape: "S1j"
              },
              productType: {},
              planTypes: {
                shape: "S1k"
              },
              durations: {
                type: "list",
                member: {
                  type: "long"
                }
              },
              currencies: {
                type: "list",
                member: {}
              },
              descriptions: {
                type: "list",
                member: {}
              },
              serviceCodes: {
                type: "list",
                member: {}
              },
              usageTypes: {
                type: "list",
                member: {}
              },
              operations: {
                type: "list",
                member: {}
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    values: {
                      shape: "S1r"
                    }
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              searchResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    offeringId: {},
                    productTypes: {
                      shape: "S1e"
                    },
                    planType: {},
                    description: {},
                    paymentOption: {},
                    durationSeconds: {
                      type: "long"
                    },
                    currency: {},
                    serviceCode: {},
                    usageType: {},
                    operation: {},
                    properties: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          value: {}
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            requestUri: "/ListTagsForResource"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S6"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/TagResource"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            requestUri: "/UntagResource"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S6: {
          type: "map",
          key: {},
          value: {}
        },
        Sh: {
          type: "list",
          member: {}
        },
        S1e: {
          type: "list",
          member: {}
        },
        S1h: {
          type: "list",
          member: {}
        },
        S1j: {
          type: "list",
          member: {}
        },
        S1k: {
          type: "list",
          member: {}
        },
        S1r: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/savingsplans-2019-06-28.paginators.json
var require_savingsplans_2019_06_28_paginators = __commonJS({
  "node_modules/aws-sdk/apis/savingsplans-2019-06-28.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/savingsplans.js
var require_savingsplans = __commonJS({
  "node_modules/aws-sdk/clients/savingsplans.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["savingsplans"] = {};
    AWS2.SavingsPlans = Service.defineService("savingsplans", ["2019-06-28"]);
    Object.defineProperty(apiLoader.services["savingsplans"], "2019-06-28", {
      get: function get() {
        var model = require_savingsplans_2019_06_28_min();
        model.paginators = require_savingsplans_2019_06_28_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.SavingsPlans;
  }
});

// node_modules/aws-sdk/apis/sso-2019-06-10.min.json
var require_sso_2019_06_10_min = __commonJS({
  "node_modules/aws-sdk/apis/sso-2019-06-10.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-06-10",
        endpointPrefix: "portal.sso",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "SSO",
        serviceFullName: "AWS Single Sign-On",
        serviceId: "SSO",
        signatureVersion: "v4",
        signingName: "awsssoportal",
        uid: "sso-2019-06-10"
      },
      operations: {
        GetRoleCredentials: {
          http: {
            method: "GET",
            requestUri: "/federation/credentials"
          },
          input: {
            type: "structure",
            required: [
              "roleName",
              "accountId",
              "accessToken"
            ],
            members: {
              roleName: {
                location: "querystring",
                locationName: "role_name"
              },
              accountId: {
                location: "querystring",
                locationName: "account_id"
              },
              accessToken: {
                shape: "S4",
                location: "header",
                locationName: "x-amz-sso_bearer_token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              roleCredentials: {
                type: "structure",
                members: {
                  accessKeyId: {},
                  secretAccessKey: {
                    type: "string",
                    sensitive: true
                  },
                  sessionToken: {
                    type: "string",
                    sensitive: true
                  },
                  expiration: {
                    type: "long"
                  }
                }
              }
            }
          },
          authtype: "none"
        },
        ListAccountRoles: {
          http: {
            method: "GET",
            requestUri: "/assignment/roles"
          },
          input: {
            type: "structure",
            required: [
              "accessToken",
              "accountId"
            ],
            members: {
              nextToken: {
                location: "querystring",
                locationName: "next_token"
              },
              maxResults: {
                location: "querystring",
                locationName: "max_result",
                type: "integer"
              },
              accessToken: {
                shape: "S4",
                location: "header",
                locationName: "x-amz-sso_bearer_token"
              },
              accountId: {
                location: "querystring",
                locationName: "account_id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              roleList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    roleName: {},
                    accountId: {}
                  }
                }
              }
            }
          },
          authtype: "none"
        },
        ListAccounts: {
          http: {
            method: "GET",
            requestUri: "/assignment/accounts"
          },
          input: {
            type: "structure",
            required: [
              "accessToken"
            ],
            members: {
              nextToken: {
                location: "querystring",
                locationName: "next_token"
              },
              maxResults: {
                location: "querystring",
                locationName: "max_result",
                type: "integer"
              },
              accessToken: {
                shape: "S4",
                location: "header",
                locationName: "x-amz-sso_bearer_token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              accountList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    accountId: {},
                    accountName: {},
                    emailAddress: {}
                  }
                }
              }
            }
          },
          authtype: "none"
        },
        Logout: {
          http: {
            requestUri: "/logout"
          },
          input: {
            type: "structure",
            required: [
              "accessToken"
            ],
            members: {
              accessToken: {
                shape: "S4",
                location: "header",
                locationName: "x-amz-sso_bearer_token"
              }
            }
          },
          authtype: "none"
        }
      },
      shapes: {
        S4: {
          type: "string",
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/sso-2019-06-10.paginators.json
var require_sso_2019_06_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/sso-2019-06-10.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAccountRoles: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "roleList"
        },
        ListAccounts: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "accountList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/sso.js
var require_sso = __commonJS({
  "node_modules/aws-sdk/clients/sso.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["sso"] = {};
    AWS2.SSO = Service.defineService("sso", ["2019-06-10"]);
    Object.defineProperty(apiLoader.services["sso"], "2019-06-10", {
      get: function get() {
        var model = require_sso_2019_06_10_min();
        model.paginators = require_sso_2019_06_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.SSO;
  }
});

// node_modules/aws-sdk/apis/sso-oidc-2019-06-10.min.json
var require_sso_oidc_2019_06_10_min = __commonJS({
  "node_modules/aws-sdk/apis/sso-oidc-2019-06-10.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-06-10",
        endpointPrefix: "oidc",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "SSO OIDC",
        serviceFullName: "AWS SSO OIDC",
        serviceId: "SSO OIDC",
        signatureVersion: "v4",
        signingName: "sso-oauth",
        uid: "sso-oidc-2019-06-10"
      },
      operations: {
        CreateToken: {
          http: {
            requestUri: "/token"
          },
          input: {
            type: "structure",
            required: [
              "clientId",
              "clientSecret",
              "grantType"
            ],
            members: {
              clientId: {},
              clientSecret: {
                shape: "S3"
              },
              grantType: {},
              deviceCode: {},
              code: {},
              refreshToken: {
                shape: "S7"
              },
              scope: {
                shape: "S8"
              },
              redirectUri: {}
            }
          },
          output: {
            type: "structure",
            members: {
              accessToken: {
                shape: "Sc"
              },
              tokenType: {},
              expiresIn: {
                type: "integer"
              },
              refreshToken: {
                shape: "S7"
              },
              idToken: {
                shape: "Sf"
              }
            }
          },
          authtype: "none"
        },
        CreateTokenWithIAM: {
          http: {
            requestUri: "/token?aws_iam=t"
          },
          input: {
            type: "structure",
            required: [
              "clientId",
              "grantType"
            ],
            members: {
              clientId: {},
              grantType: {},
              code: {},
              refreshToken: {
                shape: "S7"
              },
              assertion: {
                type: "string",
                sensitive: true
              },
              scope: {
                shape: "S8"
              },
              redirectUri: {},
              subjectToken: {
                type: "string",
                sensitive: true
              },
              subjectTokenType: {},
              requestedTokenType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              accessToken: {
                shape: "Sc"
              },
              tokenType: {},
              expiresIn: {
                type: "integer"
              },
              refreshToken: {
                shape: "S7"
              },
              idToken: {
                shape: "Sf"
              },
              issuedTokenType: {},
              scope: {
                shape: "S8"
              }
            }
          }
        },
        RegisterClient: {
          http: {
            requestUri: "/client/register"
          },
          input: {
            type: "structure",
            required: [
              "clientName",
              "clientType"
            ],
            members: {
              clientName: {},
              clientType: {},
              scopes: {
                shape: "S8"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              clientId: {},
              clientSecret: {
                shape: "S3"
              },
              clientIdIssuedAt: {
                type: "long"
              },
              clientSecretExpiresAt: {
                type: "long"
              },
              authorizationEndpoint: {},
              tokenEndpoint: {}
            }
          },
          authtype: "none"
        },
        StartDeviceAuthorization: {
          http: {
            requestUri: "/device_authorization"
          },
          input: {
            type: "structure",
            required: [
              "clientId",
              "clientSecret",
              "startUrl"
            ],
            members: {
              clientId: {},
              clientSecret: {
                shape: "S3"
              },
              startUrl: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deviceCode: {},
              userCode: {},
              verificationUri: {},
              verificationUriComplete: {},
              expiresIn: {
                type: "integer"
              },
              interval: {
                type: "integer"
              }
            }
          },
          authtype: "none"
        }
      },
      shapes: {
        S3: {
          type: "string",
          sensitive: true
        },
        S7: {
          type: "string",
          sensitive: true
        },
        S8: {
          type: "list",
          member: {}
        },
        Sc: {
          type: "string",
          sensitive: true
        },
        Sf: {
          type: "string",
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/sso-oidc-2019-06-10.paginators.json
var require_sso_oidc_2019_06_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/sso-oidc-2019-06-10.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/ssooidc.js
var require_ssooidc = __commonJS({
  "node_modules/aws-sdk/clients/ssooidc.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["ssooidc"] = {};
    AWS2.SSOOIDC = Service.defineService("ssooidc", ["2019-06-10"]);
    Object.defineProperty(apiLoader.services["ssooidc"], "2019-06-10", {
      get: function get() {
        var model = require_sso_oidc_2019_06_10_min();
        model.paginators = require_sso_oidc_2019_06_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.SSOOIDC;
  }
});

// node_modules/aws-sdk/apis/marketplace-catalog-2018-09-17.min.json
var require_marketplace_catalog_2018_09_17_min = __commonJS({
  "node_modules/aws-sdk/apis/marketplace-catalog-2018-09-17.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-09-17",
        endpointPrefix: "catalog.marketplace",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "AWS Marketplace Catalog",
        serviceFullName: "AWS Marketplace Catalog Service",
        serviceId: "Marketplace Catalog",
        signatureVersion: "v4",
        signingName: "aws-marketplace",
        uid: "marketplace-catalog-2018-09-17"
      },
      operations: {
        BatchDescribeEntities: {
          http: {
            requestUri: "/BatchDescribeEntities"
          },
          input: {
            type: "structure",
            required: [
              "EntityRequestList"
            ],
            members: {
              EntityRequestList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Catalog",
                    "EntityId"
                  ],
                  members: {
                    Catalog: {},
                    EntityId: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EntityDetails: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    EntityType: {},
                    EntityArn: {},
                    EntityIdentifier: {},
                    LastModifiedDate: {},
                    DetailsDocument: {
                      shape: "Sd"
                    }
                  }
                }
              },
              Errors: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        CancelChangeSet: {
          http: {
            method: "PATCH",
            requestUri: "/CancelChangeSet"
          },
          input: {
            type: "structure",
            required: [
              "Catalog",
              "ChangeSetId"
            ],
            members: {
              Catalog: {
                location: "querystring",
                locationName: "catalog"
              },
              ChangeSetId: {
                location: "querystring",
                locationName: "changeSetId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeSetId: {},
              ChangeSetArn: {}
            }
          }
        },
        DeleteResourcePolicy: {
          http: {
            method: "DELETE",
            requestUri: "/DeleteResourcePolicy"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeChangeSet: {
          http: {
            method: "GET",
            requestUri: "/DescribeChangeSet"
          },
          input: {
            type: "structure",
            required: [
              "Catalog",
              "ChangeSetId"
            ],
            members: {
              Catalog: {
                location: "querystring",
                locationName: "catalog"
              },
              ChangeSetId: {
                location: "querystring",
                locationName: "changeSetId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeSetId: {},
              ChangeSetArn: {},
              ChangeSetName: {},
              StartTime: {},
              EndTime: {},
              Status: {},
              FailureCode: {},
              FailureDescription: {},
              ChangeSet: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ChangeType: {},
                    Entity: {
                      shape: "Sx"
                    },
                    Details: {},
                    DetailsDocument: {
                      shape: "Sd"
                    },
                    ErrorDetailList: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ErrorCode: {},
                          ErrorMessage: {}
                        }
                      }
                    },
                    ChangeName: {}
                  }
                }
              }
            }
          }
        },
        DescribeEntity: {
          http: {
            method: "GET",
            requestUri: "/DescribeEntity"
          },
          input: {
            type: "structure",
            required: [
              "Catalog",
              "EntityId"
            ],
            members: {
              Catalog: {
                location: "querystring",
                locationName: "catalog"
              },
              EntityId: {
                location: "querystring",
                locationName: "entityId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EntityType: {},
              EntityIdentifier: {},
              EntityArn: {},
              LastModifiedDate: {},
              Details: {},
              DetailsDocument: {
                shape: "Sd"
              }
            }
          }
        },
        GetResourcePolicy: {
          http: {
            method: "GET",
            requestUri: "/GetResourcePolicy"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {}
            }
          }
        },
        ListChangeSets: {
          http: {
            requestUri: "/ListChangeSets"
          },
          input: {
            type: "structure",
            required: [
              "Catalog"
            ],
            members: {
              Catalog: {},
              FilterList: {
                shape: "S19"
              },
              Sort: {
                shape: "S1e"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeSetSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ChangeSetId: {},
                    ChangeSetArn: {},
                    ChangeSetName: {},
                    StartTime: {},
                    EndTime: {},
                    Status: {},
                    EntityIdList: {
                      type: "list",
                      member: {}
                    },
                    FailureCode: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEntities: {
          http: {
            requestUri: "/ListEntities"
          },
          input: {
            type: "structure",
            required: [
              "Catalog",
              "EntityType"
            ],
            members: {
              Catalog: {},
              EntityType: {},
              FilterList: {
                shape: "S19"
              },
              Sort: {
                shape: "S1e"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              OwnershipType: {},
              EntityTypeFilters: {
                type: "structure",
                members: {
                  DataProductFilters: {
                    type: "structure",
                    members: {
                      EntityId: {
                        type: "structure",
                        members: {
                          ValueList: {
                            type: "list",
                            member: {}
                          }
                        }
                      },
                      ProductTitle: {
                        type: "structure",
                        members: {
                          ValueList: {
                            type: "list",
                            member: {}
                          },
                          WildCardValue: {}
                        }
                      },
                      Visibility: {
                        type: "structure",
                        members: {
                          ValueList: {
                            type: "list",
                            member: {}
                          }
                        }
                      },
                      LastModifiedDate: {
                        type: "structure",
                        members: {
                          DateRange: {
                            type: "structure",
                            members: {
                              AfterValue: {},
                              BeforeValue: {}
                            }
                          }
                        }
                      }
                    }
                  },
                  SaaSProductFilters: {
                    type: "structure",
                    members: {
                      EntityId: {
                        type: "structure",
                        members: {
                          ValueList: {
                            type: "list",
                            member: {}
                          }
                        }
                      },
                      ProductTitle: {
                        type: "structure",
                        members: {
                          ValueList: {
                            type: "list",
                            member: {}
                          },
                          WildCardValue: {}
                        }
                      },
                      Visibility: {
                        type: "structure",
                        members: {
                          ValueList: {
                            type: "list",
                            member: {}
                          }
                        }
                      },
                      LastModifiedDate: {
                        type: "structure",
                        members: {
                          DateRange: {
                            type: "structure",
                            members: {
                              AfterValue: {},
                              BeforeValue: {}
                            }
                          }
                        }
                      }
                    }
                  },
                  AmiProductFilters: {
                    type: "structure",
                    members: {
                      EntityId: {
                        type: "structure",
                        members: {
                          ValueList: {
                            type: "list",
                            member: {}
                          }
                        }
                      },
                      LastModifiedDate: {
                        type: "structure",
                        members: {
                          DateRange: {
                            type: "structure",
                            members: {
                              AfterValue: {},
                              BeforeValue: {}
                            }
                          }
                        }
                      },
                      ProductTitle: {
                        type: "structure",
                        members: {
                          ValueList: {
                            type: "list",
                            member: {}
                          },
                          WildCardValue: {}
                        }
                      },
                      Visibility: {
                        type: "structure",
                        members: {
                          ValueList: {
                            type: "list",
                            member: {}
                          }
                        }
                      }
                    }
                  },
                  OfferFilters: {
                    type: "structure",
                    members: {
                      EntityId: {
                        type: "structure",
                        members: {
                          ValueList: {
                            type: "list",
                            member: {}
                          }
                        }
                      },
                      Name: {
                        type: "structure",
                        members: {
                          ValueList: {
                            type: "list",
                            member: {}
                          },
                          WildCardValue: {}
                        }
                      },
                      ProductId: {
                        type: "structure",
                        members: {
                          ValueList: {
                            type: "list",
                            member: {}
                          }
                        }
                      },
                      ReleaseDate: {
                        type: "structure",
                        members: {
                          DateRange: {
                            type: "structure",
                            members: {
                              AfterValue: {},
                              BeforeValue: {}
                            }
                          }
                        }
                      },
                      AvailabilityEndDate: {
                        type: "structure",
                        members: {
                          DateRange: {
                            type: "structure",
                            members: {
                              AfterValue: {},
                              BeforeValue: {}
                            }
                          }
                        }
                      },
                      BuyerAccounts: {
                        type: "structure",
                        members: {
                          WildCardValue: {}
                        }
                      },
                      State: {
                        type: "structure",
                        members: {
                          ValueList: {
                            type: "list",
                            member: {}
                          }
                        }
                      },
                      Targeting: {
                        type: "structure",
                        members: {
                          ValueList: {
                            type: "list",
                            member: {}
                          }
                        }
                      },
                      LastModifiedDate: {
                        type: "structure",
                        members: {
                          DateRange: {
                            type: "structure",
                            members: {
                              AfterValue: {},
                              BeforeValue: {}
                            }
                          }
                        }
                      }
                    }
                  },
                  ContainerProductFilters: {
                    type: "structure",
                    members: {
                      EntityId: {
                        type: "structure",
                        members: {
                          ValueList: {
                            type: "list",
                            member: {}
                          }
                        }
                      },
                      LastModifiedDate: {
                        type: "structure",
                        members: {
                          DateRange: {
                            type: "structure",
                            members: {
                              AfterValue: {},
                              BeforeValue: {}
                            }
                          }
                        }
                      },
                      ProductTitle: {
                        type: "structure",
                        members: {
                          ValueList: {
                            type: "list",
                            member: {}
                          },
                          WildCardValue: {}
                        }
                      },
                      Visibility: {
                        type: "structure",
                        members: {
                          ValueList: {
                            type: "list",
                            member: {}
                          }
                        }
                      }
                    }
                  },
                  ResaleAuthorizationFilters: {
                    type: "structure",
                    members: {
                      EntityId: {
                        type: "structure",
                        members: {
                          ValueList: {
                            type: "list",
                            member: {}
                          }
                        }
                      },
                      Name: {
                        type: "structure",
                        members: {
                          ValueList: {
                            type: "list",
                            member: {}
                          },
                          WildCardValue: {}
                        }
                      },
                      ProductId: {
                        type: "structure",
                        members: {
                          ValueList: {
                            type: "list",
                            member: {}
                          },
                          WildCardValue: {}
                        }
                      },
                      CreatedDate: {
                        type: "structure",
                        members: {
                          DateRange: {
                            type: "structure",
                            members: {
                              AfterValue: {},
                              BeforeValue: {}
                            }
                          },
                          ValueList: {
                            type: "list",
                            member: {}
                          }
                        }
                      },
                      AvailabilityEndDate: {
                        type: "structure",
                        members: {
                          DateRange: {
                            type: "structure",
                            members: {
                              AfterValue: {},
                              BeforeValue: {}
                            }
                          },
                          ValueList: {
                            type: "list",
                            member: {}
                          }
                        }
                      },
                      ManufacturerAccountId: {
                        type: "structure",
                        members: {
                          ValueList: {
                            type: "list",
                            member: {}
                          },
                          WildCardValue: {}
                        }
                      },
                      ProductName: {
                        type: "structure",
                        members: {
                          ValueList: {
                            type: "list",
                            member: {}
                          },
                          WildCardValue: {}
                        }
                      },
                      ManufacturerLegalName: {
                        type: "structure",
                        members: {
                          ValueList: {
                            type: "list",
                            member: {}
                          },
                          WildCardValue: {}
                        }
                      },
                      ResellerAccountID: {
                        type: "structure",
                        members: {
                          ValueList: {
                            type: "list",
                            member: {}
                          },
                          WildCardValue: {}
                        }
                      },
                      ResellerLegalName: {
                        type: "structure",
                        members: {
                          ValueList: {
                            type: "list",
                            member: {}
                          },
                          WildCardValue: {}
                        }
                      },
                      Status: {
                        type: "structure",
                        members: {
                          ValueList: {
                            type: "list",
                            member: {}
                          }
                        }
                      },
                      OfferExtendedStatus: {
                        type: "structure",
                        members: {
                          ValueList: {
                            type: "list",
                            member: {}
                          }
                        }
                      },
                      LastModifiedDate: {
                        type: "structure",
                        members: {
                          DateRange: {
                            type: "structure",
                            members: {
                              AfterValue: {},
                              BeforeValue: {}
                            }
                          }
                        }
                      }
                    }
                  }
                },
                union: true
              },
              EntityTypeSort: {
                type: "structure",
                members: {
                  DataProductSort: {
                    type: "structure",
                    members: {
                      SortBy: {},
                      SortOrder: {}
                    }
                  },
                  SaaSProductSort: {
                    type: "structure",
                    members: {
                      SortBy: {},
                      SortOrder: {}
                    }
                  },
                  AmiProductSort: {
                    type: "structure",
                    members: {
                      SortBy: {},
                      SortOrder: {}
                    }
                  },
                  OfferSort: {
                    type: "structure",
                    members: {
                      SortBy: {},
                      SortOrder: {}
                    }
                  },
                  ContainerProductSort: {
                    type: "structure",
                    members: {
                      SortBy: {},
                      SortOrder: {}
                    }
                  },
                  ResaleAuthorizationSort: {
                    type: "structure",
                    members: {
                      SortBy: {},
                      SortOrder: {}
                    }
                  }
                },
                union: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EntitySummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    EntityType: {},
                    EntityId: {},
                    EntityArn: {},
                    LastModifiedDate: {},
                    Visibility: {},
                    AmiProductSummary: {
                      type: "structure",
                      members: {
                        ProductTitle: {},
                        Visibility: {}
                      }
                    },
                    ContainerProductSummary: {
                      type: "structure",
                      members: {
                        ProductTitle: {},
                        Visibility: {}
                      }
                    },
                    DataProductSummary: {
                      type: "structure",
                      members: {
                        ProductTitle: {},
                        Visibility: {}
                      }
                    },
                    SaaSProductSummary: {
                      type: "structure",
                      members: {
                        ProductTitle: {},
                        Visibility: {}
                      }
                    },
                    OfferSummary: {
                      type: "structure",
                      members: {
                        Name: {},
                        ProductId: {},
                        ReleaseDate: {},
                        AvailabilityEndDate: {},
                        BuyerAccounts: {
                          type: "list",
                          member: {}
                        },
                        State: {},
                        Targeting: {
                          type: "list",
                          member: {}
                        }
                      }
                    },
                    ResaleAuthorizationSummary: {
                      type: "structure",
                      members: {
                        Name: {},
                        ProductId: {},
                        ProductName: {},
                        ManufacturerAccountId: {},
                        ManufacturerLegalName: {},
                        ResellerAccountID: {},
                        ResellerLegalName: {},
                        Status: {},
                        OfferExtendedStatus: {},
                        CreatedDate: {},
                        AvailabilityEndDate: {}
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            requestUri: "/ListTagsForResource"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S5u"
              }
            }
          }
        },
        PutResourcePolicy: {
          http: {
            requestUri: "/PutResourcePolicy"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Policy"
            ],
            members: {
              ResourceArn: {},
              Policy: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartChangeSet: {
          http: {
            requestUri: "/StartChangeSet"
          },
          input: {
            type: "structure",
            required: [
              "Catalog",
              "ChangeSet"
            ],
            members: {
              Catalog: {},
              ChangeSet: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ChangeType",
                    "Entity"
                  ],
                  members: {
                    ChangeType: {},
                    Entity: {
                      shape: "Sx"
                    },
                    EntityTags: {
                      shape: "S5u"
                    },
                    Details: {},
                    DetailsDocument: {
                      shape: "Sd"
                    },
                    ChangeName: {}
                  }
                }
              },
              ChangeSetName: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              ChangeSetTags: {
                shape: "S5u"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeSetId: {},
              ChangeSetArn: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/TagResource"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S5u"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            requestUri: "/UntagResource"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        Sd: {
          type: "structure",
          members: {},
          document: true
        },
        Sx: {
          type: "structure",
          required: [
            "Type"
          ],
          members: {
            Type: {},
            Identifier: {}
          }
        },
        S19: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              ValueList: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S1e: {
          type: "structure",
          members: {
            SortBy: {},
            SortOrder: {}
          }
        },
        S5u: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/marketplace-catalog-2018-09-17.paginators.json
var require_marketplace_catalog_2018_09_17_paginators = __commonJS({
  "node_modules/aws-sdk/apis/marketplace-catalog-2018-09-17.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListChangeSets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ChangeSetSummaryList"
        },
        ListEntities: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "EntitySummaryList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/marketplacecatalog.js
var require_marketplacecatalog = __commonJS({
  "node_modules/aws-sdk/clients/marketplacecatalog.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["marketplacecatalog"] = {};
    AWS2.MarketplaceCatalog = Service.defineService("marketplacecatalog", ["2018-09-17"]);
    Object.defineProperty(apiLoader.services["marketplacecatalog"], "2018-09-17", {
      get: function get() {
        var model = require_marketplace_catalog_2018_09_17_min();
        model.paginators = require_marketplace_catalog_2018_09_17_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.MarketplaceCatalog;
  }
});

// node_modules/aws-sdk/apis/dataexchange-2017-07-25.min.json
var require_dataexchange_2017_07_25_min = __commonJS({
  "node_modules/aws-sdk/apis/dataexchange-2017-07-25.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-07-25",
        endpointPrefix: "dataexchange",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Data Exchange",
        serviceId: "DataExchange",
        signatureVersion: "v4",
        signingName: "dataexchange",
        uid: "dataexchange-2017-07-25"
      },
      operations: {
        CancelJob: {
          http: {
            method: "DELETE",
            requestUri: "/v1/jobs/{JobId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {
                location: "uri",
                locationName: "JobId"
              }
            }
          }
        },
        CreateDataSet: {
          http: {
            requestUri: "/v1/data-sets",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AssetType",
              "Description",
              "Name"
            ],
            members: {
              AssetType: {},
              Description: {},
              Name: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              AssetType: {},
              CreatedAt: {
                shape: "Sa"
              },
              Description: {},
              Id: {},
              Name: {},
              Origin: {},
              OriginDetails: {
                shape: "Sd"
              },
              SourceId: {},
              Tags: {
                shape: "S7"
              },
              UpdatedAt: {
                shape: "Sa"
              }
            }
          }
        },
        CreateEventAction: {
          http: {
            requestUri: "/v1/event-actions",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Action",
              "Event"
            ],
            members: {
              Action: {
                shape: "Sf"
              },
              Event: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Action: {
                shape: "Sf"
              },
              Arn: {},
              CreatedAt: {
                shape: "Sa"
              },
              Event: {
                shape: "Sk"
              },
              Id: {},
              UpdatedAt: {
                shape: "Sa"
              }
            }
          }
        },
        CreateJob: {
          http: {
            requestUri: "/v1/jobs",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Details",
              "Type"
            ],
            members: {
              Details: {
                type: "structure",
                members: {
                  ExportAssetToSignedUrl: {
                    type: "structure",
                    required: [
                      "AssetId",
                      "DataSetId",
                      "RevisionId"
                    ],
                    members: {
                      AssetId: {},
                      DataSetId: {},
                      RevisionId: {}
                    }
                  },
                  ExportAssetsToS3: {
                    type: "structure",
                    required: [
                      "AssetDestinations",
                      "DataSetId",
                      "RevisionId"
                    ],
                    members: {
                      AssetDestinations: {
                        shape: "Sr"
                      },
                      DataSetId: {},
                      Encryption: {
                        shape: "Sh"
                      },
                      RevisionId: {}
                    }
                  },
                  ExportRevisionsToS3: {
                    type: "structure",
                    required: [
                      "DataSetId",
                      "RevisionDestinations"
                    ],
                    members: {
                      DataSetId: {},
                      Encryption: {
                        shape: "Sh"
                      },
                      RevisionDestinations: {
                        shape: "Su"
                      }
                    }
                  },
                  ImportAssetFromSignedUrl: {
                    type: "structure",
                    required: [
                      "AssetName",
                      "DataSetId",
                      "Md5Hash",
                      "RevisionId"
                    ],
                    members: {
                      AssetName: {},
                      DataSetId: {},
                      Md5Hash: {},
                      RevisionId: {}
                    }
                  },
                  ImportAssetsFromS3: {
                    type: "structure",
                    required: [
                      "AssetSources",
                      "DataSetId",
                      "RevisionId"
                    ],
                    members: {
                      AssetSources: {
                        shape: "S10"
                      },
                      DataSetId: {},
                      RevisionId: {}
                    }
                  },
                  ImportAssetsFromRedshiftDataShares: {
                    type: "structure",
                    required: [
                      "AssetSources",
                      "DataSetId",
                      "RevisionId"
                    ],
                    members: {
                      AssetSources: {
                        shape: "S13"
                      },
                      DataSetId: {},
                      RevisionId: {}
                    }
                  },
                  ImportAssetFromApiGatewayApi: {
                    type: "structure",
                    required: [
                      "ApiId",
                      "ApiName",
                      "ApiSpecificationMd5Hash",
                      "DataSetId",
                      "ProtocolType",
                      "RevisionId",
                      "Stage"
                    ],
                    members: {
                      ApiDescription: {},
                      ApiId: {},
                      ApiKey: {},
                      ApiName: {},
                      ApiSpecificationMd5Hash: {},
                      DataSetId: {},
                      ProtocolType: {},
                      RevisionId: {},
                      Stage: {}
                    }
                  },
                  CreateS3DataAccessFromS3Bucket: {
                    type: "structure",
                    required: [
                      "AssetSource",
                      "DataSetId",
                      "RevisionId"
                    ],
                    members: {
                      AssetSource: {
                        shape: "S19"
                      },
                      DataSetId: {},
                      RevisionId: {}
                    }
                  },
                  ImportAssetsFromLakeFormationTagPolicy: {
                    type: "structure",
                    required: [
                      "CatalogId",
                      "RoleArn",
                      "DataSetId",
                      "RevisionId"
                    ],
                    members: {
                      CatalogId: {},
                      Database: {
                        shape: "S1g"
                      },
                      Table: {
                        shape: "S1n"
                      },
                      RoleArn: {},
                      DataSetId: {},
                      RevisionId: {}
                    }
                  }
                }
              },
              Type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreatedAt: {
                shape: "Sa"
              },
              Details: {
                shape: "S1t"
              },
              Errors: {
                shape: "S23"
              },
              Id: {},
              State: {},
              Type: {},
              UpdatedAt: {
                shape: "Sa"
              }
            }
          }
        },
        CreateRevision: {
          http: {
            requestUri: "/v1/data-sets/{DataSetId}/revisions",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DataSetId"
            ],
            members: {
              Comment: {},
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Comment: {},
              CreatedAt: {
                shape: "Sa"
              },
              DataSetId: {},
              Finalized: {
                type: "boolean"
              },
              Id: {},
              SourceId: {},
              Tags: {
                shape: "S7"
              },
              UpdatedAt: {
                shape: "Sa"
              },
              RevocationComment: {},
              Revoked: {
                type: "boolean"
              },
              RevokedAt: {
                shape: "Sa"
              }
            }
          }
        },
        DeleteAsset: {
          http: {
            method: "DELETE",
            requestUri: "/v1/data-sets/{DataSetId}/revisions/{RevisionId}/assets/{AssetId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AssetId",
              "DataSetId",
              "RevisionId"
            ],
            members: {
              AssetId: {
                location: "uri",
                locationName: "AssetId"
              },
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              RevisionId: {
                location: "uri",
                locationName: "RevisionId"
              }
            }
          }
        },
        DeleteDataSet: {
          http: {
            method: "DELETE",
            requestUri: "/v1/data-sets/{DataSetId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "DataSetId"
            ],
            members: {
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              }
            }
          }
        },
        DeleteEventAction: {
          http: {
            method: "DELETE",
            requestUri: "/v1/event-actions/{EventActionId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "EventActionId"
            ],
            members: {
              EventActionId: {
                location: "uri",
                locationName: "EventActionId"
              }
            }
          }
        },
        DeleteRevision: {
          http: {
            method: "DELETE",
            requestUri: "/v1/data-sets/{DataSetId}/revisions/{RevisionId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "DataSetId",
              "RevisionId"
            ],
            members: {
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              RevisionId: {
                location: "uri",
                locationName: "RevisionId"
              }
            }
          }
        },
        GetAsset: {
          http: {
            method: "GET",
            requestUri: "/v1/data-sets/{DataSetId}/revisions/{RevisionId}/assets/{AssetId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AssetId",
              "DataSetId",
              "RevisionId"
            ],
            members: {
              AssetId: {
                location: "uri",
                locationName: "AssetId"
              },
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              RevisionId: {
                location: "uri",
                locationName: "RevisionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              AssetDetails: {
                shape: "S2n"
              },
              AssetType: {},
              CreatedAt: {
                shape: "Sa"
              },
              DataSetId: {},
              Id: {},
              Name: {},
              RevisionId: {},
              SourceId: {},
              UpdatedAt: {
                shape: "Sa"
              }
            }
          }
        },
        GetDataSet: {
          http: {
            method: "GET",
            requestUri: "/v1/data-sets/{DataSetId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DataSetId"
            ],
            members: {
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              AssetType: {},
              CreatedAt: {
                shape: "Sa"
              },
              Description: {},
              Id: {},
              Name: {},
              Origin: {},
              OriginDetails: {
                shape: "Sd"
              },
              SourceId: {},
              Tags: {
                shape: "S7"
              },
              UpdatedAt: {
                shape: "Sa"
              }
            }
          }
        },
        GetEventAction: {
          http: {
            method: "GET",
            requestUri: "/v1/event-actions/{EventActionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "EventActionId"
            ],
            members: {
              EventActionId: {
                location: "uri",
                locationName: "EventActionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Action: {
                shape: "Sf"
              },
              Arn: {},
              CreatedAt: {
                shape: "Sa"
              },
              Event: {
                shape: "Sk"
              },
              Id: {},
              UpdatedAt: {
                shape: "Sa"
              }
            }
          }
        },
        GetJob: {
          http: {
            method: "GET",
            requestUri: "/v1/jobs/{JobId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {
                location: "uri",
                locationName: "JobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreatedAt: {
                shape: "Sa"
              },
              Details: {
                shape: "S1t"
              },
              Errors: {
                shape: "S23"
              },
              Id: {},
              State: {},
              Type: {},
              UpdatedAt: {
                shape: "Sa"
              }
            }
          }
        },
        GetRevision: {
          http: {
            method: "GET",
            requestUri: "/v1/data-sets/{DataSetId}/revisions/{RevisionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DataSetId",
              "RevisionId"
            ],
            members: {
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              RevisionId: {
                location: "uri",
                locationName: "RevisionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Comment: {},
              CreatedAt: {
                shape: "Sa"
              },
              DataSetId: {},
              Finalized: {
                type: "boolean"
              },
              Id: {},
              SourceId: {},
              Tags: {
                shape: "S7"
              },
              UpdatedAt: {
                shape: "Sa"
              },
              RevocationComment: {},
              Revoked: {
                type: "boolean"
              },
              RevokedAt: {
                shape: "Sa"
              }
            }
          }
        },
        ListDataSetRevisions: {
          http: {
            method: "GET",
            requestUri: "/v1/data-sets/{DataSetId}/revisions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DataSetId"
            ],
            members: {
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Revisions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Arn",
                    "CreatedAt",
                    "DataSetId",
                    "Id",
                    "UpdatedAt"
                  ],
                  members: {
                    Arn: {},
                    Comment: {},
                    CreatedAt: {
                      shape: "Sa"
                    },
                    DataSetId: {},
                    Finalized: {
                      type: "boolean"
                    },
                    Id: {},
                    SourceId: {},
                    UpdatedAt: {
                      shape: "Sa"
                    },
                    RevocationComment: {},
                    Revoked: {
                      type: "boolean"
                    },
                    RevokedAt: {
                      shape: "Sa"
                    }
                  }
                }
              }
            }
          }
        },
        ListDataSets: {
          http: {
            method: "GET",
            requestUri: "/v1/data-sets",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              Origin: {
                location: "querystring",
                locationName: "origin"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Arn",
                    "AssetType",
                    "CreatedAt",
                    "Description",
                    "Id",
                    "Name",
                    "Origin",
                    "UpdatedAt"
                  ],
                  members: {
                    Arn: {},
                    AssetType: {},
                    CreatedAt: {
                      shape: "Sa"
                    },
                    Description: {},
                    Id: {},
                    Name: {},
                    Origin: {},
                    OriginDetails: {
                      shape: "Sd"
                    },
                    SourceId: {},
                    UpdatedAt: {
                      shape: "Sa"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEventActions: {
          http: {
            method: "GET",
            requestUri: "/v1/event-actions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              EventSourceId: {
                location: "querystring",
                locationName: "eventSourceId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventActions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "Arn",
                    "CreatedAt",
                    "Event",
                    "Id",
                    "UpdatedAt"
                  ],
                  members: {
                    Action: {
                      shape: "Sf"
                    },
                    Arn: {},
                    CreatedAt: {
                      shape: "Sa"
                    },
                    Event: {
                      shape: "Sk"
                    },
                    Id: {},
                    UpdatedAt: {
                      shape: "Sa"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListJobs: {
          http: {
            method: "GET",
            requestUri: "/v1/jobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DataSetId: {
                location: "querystring",
                locationName: "dataSetId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              RevisionId: {
                location: "querystring",
                locationName: "revisionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Jobs: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Arn",
                    "CreatedAt",
                    "Details",
                    "Id",
                    "State",
                    "Type",
                    "UpdatedAt"
                  ],
                  members: {
                    Arn: {},
                    CreatedAt: {
                      shape: "Sa"
                    },
                    Details: {
                      shape: "S1t"
                    },
                    Errors: {
                      shape: "S23"
                    },
                    Id: {},
                    State: {},
                    Type: {},
                    UpdatedAt: {
                      shape: "Sa"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListRevisionAssets: {
          http: {
            method: "GET",
            requestUri: "/v1/data-sets/{DataSetId}/revisions/{RevisionId}/assets",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DataSetId",
              "RevisionId"
            ],
            members: {
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              RevisionId: {
                location: "uri",
                locationName: "RevisionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Assets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Arn",
                    "AssetDetails",
                    "AssetType",
                    "CreatedAt",
                    "DataSetId",
                    "Id",
                    "Name",
                    "RevisionId",
                    "UpdatedAt"
                  ],
                  members: {
                    Arn: {},
                    AssetDetails: {
                      shape: "S2n"
                    },
                    AssetType: {},
                    CreatedAt: {
                      shape: "Sa"
                    },
                    DataSetId: {},
                    Id: {},
                    Name: {},
                    RevisionId: {},
                    SourceId: {},
                    UpdatedAt: {
                      shape: "Sa"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S7",
                locationName: "tags"
              }
            }
          }
        },
        RevokeRevision: {
          http: {
            requestUri: "/v1/data-sets/{DataSetId}/revisions/{RevisionId}/revoke",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DataSetId",
              "RevisionId",
              "RevocationComment"
            ],
            members: {
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              RevisionId: {
                location: "uri",
                locationName: "RevisionId"
              },
              RevocationComment: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Comment: {},
              CreatedAt: {
                shape: "Sa"
              },
              DataSetId: {},
              Finalized: {
                type: "boolean"
              },
              Id: {},
              SourceId: {},
              UpdatedAt: {
                shape: "Sa"
              },
              RevocationComment: {},
              Revoked: {
                type: "boolean"
              },
              RevokedAt: {
                shape: "Sa"
              }
            }
          }
        },
        SendApiAsset: {
          http: {
            requestUri: "/v1",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AssetId",
              "DataSetId",
              "RevisionId"
            ],
            members: {
              Body: {},
              QueryStringParameters: {
                shape: "S7",
                location: "querystring"
              },
              AssetId: {
                location: "header",
                locationName: "x-amzn-dataexchange-asset-id"
              },
              DataSetId: {
                location: "header",
                locationName: "x-amzn-dataexchange-data-set-id"
              },
              RequestHeaders: {
                shape: "S7",
                location: "headers",
                locationName: "x-amzn-dataexchange-header-"
              },
              Method: {
                location: "header",
                locationName: "x-amzn-dataexchange-http-method"
              },
              Path: {
                location: "header",
                locationName: "x-amzn-dataexchange-path"
              },
              RevisionId: {
                location: "header",
                locationName: "x-amzn-dataexchange-revision-id"
              }
            },
            payload: "Body"
          },
          output: {
            type: "structure",
            members: {
              Body: {},
              ResponseHeaders: {
                shape: "S7",
                location: "headers",
                locationName: ""
              }
            },
            payload: "Body"
          },
          endpoint: {
            hostPrefix: "api-fulfill."
          }
        },
        SendDataSetNotification: {
          http: {
            requestUri: "/v1/data-sets/{DataSetId}/notification",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "DataSetId",
              "Type"
            ],
            members: {
              Scope: {
                type: "structure",
                members: {
                  LakeFormationTagPolicies: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Database: {},
                        Table: {}
                      }
                    }
                  },
                  RedshiftDataShares: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Arn",
                        "Database"
                      ],
                      members: {
                        Arn: {},
                        Database: {},
                        Function: {},
                        Table: {},
                        Schema: {},
                        View: {}
                      }
                    }
                  },
                  S3DataAccesses: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        KeyPrefixes: {
                          shape: "S1a"
                        },
                        Keys: {
                          shape: "S1a"
                        }
                      }
                    }
                  }
                }
              },
              ClientToken: {
                idempotencyToken: true
              },
              Comment: {},
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              Details: {
                type: "structure",
                members: {
                  DataUpdate: {
                    type: "structure",
                    members: {
                      DataUpdatedAt: {
                        shape: "Sa"
                      }
                    }
                  },
                  Deprecation: {
                    type: "structure",
                    required: [
                      "DeprecationAt"
                    ],
                    members: {
                      DeprecationAt: {
                        shape: "Sa"
                      }
                    }
                  },
                  SchemaChange: {
                    type: "structure",
                    required: [
                      "SchemaChangeAt"
                    ],
                    members: {
                      Changes: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "Name",
                            "Type"
                          ],
                          members: {
                            Name: {},
                            Type: {},
                            Description: {}
                          }
                        }
                      },
                      SchemaChangeAt: {
                        shape: "Sa"
                      }
                    }
                  }
                }
              },
              Type: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartJob: {
          http: {
            method: "PATCH",
            requestUri: "/v1/jobs/{JobId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {
                location: "uri",
                locationName: "JobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{ResourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "S7",
                locationName: "tags"
              }
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              TagKeys: {
                shape: "S1a",
                location: "querystring",
                locationName: "tagKeys"
              }
            }
          },
          idempotent: true
        },
        UpdateAsset: {
          http: {
            method: "PATCH",
            requestUri: "/v1/data-sets/{DataSetId}/revisions/{RevisionId}/assets/{AssetId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AssetId",
              "DataSetId",
              "Name",
              "RevisionId"
            ],
            members: {
              AssetId: {
                location: "uri",
                locationName: "AssetId"
              },
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              Name: {},
              RevisionId: {
                location: "uri",
                locationName: "RevisionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              AssetDetails: {
                shape: "S2n"
              },
              AssetType: {},
              CreatedAt: {
                shape: "Sa"
              },
              DataSetId: {},
              Id: {},
              Name: {},
              RevisionId: {},
              SourceId: {},
              UpdatedAt: {
                shape: "Sa"
              }
            }
          }
        },
        UpdateDataSet: {
          http: {
            method: "PATCH",
            requestUri: "/v1/data-sets/{DataSetId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DataSetId"
            ],
            members: {
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              Description: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              AssetType: {},
              CreatedAt: {
                shape: "Sa"
              },
              Description: {},
              Id: {},
              Name: {},
              Origin: {},
              OriginDetails: {
                shape: "Sd"
              },
              SourceId: {},
              UpdatedAt: {
                shape: "Sa"
              }
            }
          }
        },
        UpdateEventAction: {
          http: {
            method: "PATCH",
            requestUri: "/v1/event-actions/{EventActionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "EventActionId"
            ],
            members: {
              Action: {
                shape: "Sf"
              },
              EventActionId: {
                location: "uri",
                locationName: "EventActionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Action: {
                shape: "Sf"
              },
              Arn: {},
              CreatedAt: {
                shape: "Sa"
              },
              Event: {
                shape: "Sk"
              },
              Id: {},
              UpdatedAt: {
                shape: "Sa"
              }
            }
          }
        },
        UpdateRevision: {
          http: {
            method: "PATCH",
            requestUri: "/v1/data-sets/{DataSetId}/revisions/{RevisionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DataSetId",
              "RevisionId"
            ],
            members: {
              Comment: {},
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              Finalized: {
                type: "boolean"
              },
              RevisionId: {
                location: "uri",
                locationName: "RevisionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Comment: {},
              CreatedAt: {
                shape: "Sa"
              },
              DataSetId: {},
              Finalized: {
                type: "boolean"
              },
              Id: {},
              SourceId: {},
              UpdatedAt: {
                shape: "Sa"
              },
              RevocationComment: {},
              Revoked: {
                type: "boolean"
              },
              RevokedAt: {
                shape: "Sa"
              }
            }
          }
        }
      },
      shapes: {
        S7: {
          type: "map",
          key: {},
          value: {}
        },
        Sa: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        Sd: {
          type: "structure",
          members: {
            ProductId: {}
          }
        },
        Sf: {
          type: "structure",
          members: {
            ExportRevisionToS3: {
              type: "structure",
              required: [
                "RevisionDestination"
              ],
              members: {
                Encryption: {
                  shape: "Sh"
                },
                RevisionDestination: {
                  type: "structure",
                  required: [
                    "Bucket"
                  ],
                  members: {
                    Bucket: {},
                    KeyPattern: {}
                  }
                }
              }
            }
          }
        },
        Sh: {
          type: "structure",
          required: [
            "Type"
          ],
          members: {
            KmsKeyArn: {},
            Type: {}
          }
        },
        Sk: {
          type: "structure",
          members: {
            RevisionPublished: {
              type: "structure",
              required: [
                "DataSetId"
              ],
              members: {
                DataSetId: {}
              }
            }
          }
        },
        Sr: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AssetId",
              "Bucket"
            ],
            members: {
              AssetId: {},
              Bucket: {},
              Key: {}
            }
          }
        },
        Su: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Bucket",
              "RevisionId"
            ],
            members: {
              Bucket: {},
              KeyPattern: {},
              RevisionId: {}
            }
          }
        },
        S10: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Bucket",
              "Key"
            ],
            members: {
              Bucket: {},
              Key: {}
            }
          }
        },
        S13: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "DataShareArn"
            ],
            members: {
              DataShareArn: {}
            }
          }
        },
        S19: {
          type: "structure",
          required: [
            "Bucket"
          ],
          members: {
            Bucket: {},
            KeyPrefixes: {
              shape: "S1a"
            },
            Keys: {
              shape: "S1a"
            },
            KmsKeysToGrant: {
              shape: "S1b"
            }
          }
        },
        S1a: {
          type: "list",
          member: {}
        },
        S1b: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "KmsKeyArn"
            ],
            members: {
              KmsKeyArn: {}
            }
          }
        },
        S1g: {
          type: "structure",
          required: [
            "Expression",
            "Permissions"
          ],
          members: {
            Expression: {
              shape: "S1h"
            },
            Permissions: {
              type: "list",
              member: {}
            }
          }
        },
        S1h: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "TagKey",
              "TagValues"
            ],
            members: {
              TagKey: {},
              TagValues: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S1n: {
          type: "structure",
          required: [
            "Expression",
            "Permissions"
          ],
          members: {
            Expression: {
              shape: "S1h"
            },
            Permissions: {
              type: "list",
              member: {}
            }
          }
        },
        S1t: {
          type: "structure",
          members: {
            ExportAssetToSignedUrl: {
              type: "structure",
              required: [
                "AssetId",
                "DataSetId",
                "RevisionId"
              ],
              members: {
                AssetId: {},
                DataSetId: {},
                RevisionId: {},
                SignedUrl: {},
                SignedUrlExpiresAt: {
                  shape: "Sa"
                }
              }
            },
            ExportAssetsToS3: {
              type: "structure",
              required: [
                "AssetDestinations",
                "DataSetId",
                "RevisionId"
              ],
              members: {
                AssetDestinations: {
                  shape: "Sr"
                },
                DataSetId: {},
                Encryption: {
                  shape: "Sh"
                },
                RevisionId: {}
              }
            },
            ExportRevisionsToS3: {
              type: "structure",
              required: [
                "DataSetId",
                "RevisionDestinations"
              ],
              members: {
                DataSetId: {},
                Encryption: {
                  shape: "Sh"
                },
                RevisionDestinations: {
                  shape: "Su"
                },
                EventActionArn: {}
              }
            },
            ImportAssetFromSignedUrl: {
              type: "structure",
              required: [
                "AssetName",
                "DataSetId",
                "RevisionId"
              ],
              members: {
                AssetName: {},
                DataSetId: {},
                Md5Hash: {},
                RevisionId: {},
                SignedUrl: {},
                SignedUrlExpiresAt: {
                  shape: "Sa"
                }
              }
            },
            ImportAssetsFromS3: {
              type: "structure",
              required: [
                "AssetSources",
                "DataSetId",
                "RevisionId"
              ],
              members: {
                AssetSources: {
                  shape: "S10"
                },
                DataSetId: {},
                RevisionId: {}
              }
            },
            ImportAssetsFromRedshiftDataShares: {
              type: "structure",
              required: [
                "AssetSources",
                "DataSetId",
                "RevisionId"
              ],
              members: {
                AssetSources: {
                  shape: "S13"
                },
                DataSetId: {},
                RevisionId: {}
              }
            },
            ImportAssetFromApiGatewayApi: {
              type: "structure",
              required: [
                "ApiId",
                "ApiName",
                "ApiSpecificationMd5Hash",
                "ApiSpecificationUploadUrl",
                "ApiSpecificationUploadUrlExpiresAt",
                "DataSetId",
                "ProtocolType",
                "RevisionId",
                "Stage"
              ],
              members: {
                ApiDescription: {},
                ApiId: {},
                ApiKey: {},
                ApiName: {},
                ApiSpecificationMd5Hash: {},
                ApiSpecificationUploadUrl: {},
                ApiSpecificationUploadUrlExpiresAt: {
                  shape: "Sa"
                },
                DataSetId: {},
                ProtocolType: {},
                RevisionId: {},
                Stage: {}
              }
            },
            CreateS3DataAccessFromS3Bucket: {
              type: "structure",
              required: [
                "AssetSource",
                "DataSetId",
                "RevisionId"
              ],
              members: {
                AssetSource: {
                  shape: "S19"
                },
                DataSetId: {},
                RevisionId: {}
              }
            },
            ImportAssetsFromLakeFormationTagPolicy: {
              type: "structure",
              required: [
                "CatalogId",
                "RoleArn",
                "DataSetId",
                "RevisionId"
              ],
              members: {
                CatalogId: {},
                Database: {
                  shape: "S1g"
                },
                Table: {
                  shape: "S1n"
                },
                RoleArn: {},
                DataSetId: {},
                RevisionId: {}
              }
            }
          }
        },
        S23: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Code",
              "Message"
            ],
            members: {
              Code: {},
              Details: {
                type: "structure",
                members: {
                  ImportAssetFromSignedUrlJobErrorDetails: {
                    type: "structure",
                    required: [
                      "AssetName"
                    ],
                    members: {
                      AssetName: {}
                    }
                  },
                  ImportAssetsFromS3JobErrorDetails: {
                    shape: "S10"
                  }
                }
              },
              LimitName: {},
              LimitValue: {
                type: "double"
              },
              Message: {},
              ResourceId: {},
              ResourceType: {}
            }
          }
        },
        S2n: {
          type: "structure",
          members: {
            S3SnapshotAsset: {
              type: "structure",
              required: [
                "Size"
              ],
              members: {
                Size: {
                  type: "double"
                }
              }
            },
            RedshiftDataShareAsset: {
              type: "structure",
              required: [
                "Arn"
              ],
              members: {
                Arn: {}
              }
            },
            ApiGatewayApiAsset: {
              type: "structure",
              members: {
                ApiDescription: {},
                ApiEndpoint: {},
                ApiId: {},
                ApiKey: {},
                ApiName: {},
                ApiSpecificationDownloadUrl: {},
                ApiSpecificationDownloadUrlExpiresAt: {
                  shape: "Sa"
                },
                ProtocolType: {},
                Stage: {}
              }
            },
            S3DataAccessAsset: {
              type: "structure",
              required: [
                "Bucket"
              ],
              members: {
                Bucket: {},
                KeyPrefixes: {
                  shape: "S1a"
                },
                Keys: {
                  shape: "S1a"
                },
                S3AccessPointAlias: {},
                S3AccessPointArn: {},
                KmsKeysToGrant: {
                  shape: "S1b"
                }
              }
            },
            LakeFormationDataPermissionAsset: {
              type: "structure",
              required: [
                "LakeFormationDataPermissionDetails",
                "LakeFormationDataPermissionType",
                "Permissions"
              ],
              members: {
                LakeFormationDataPermissionDetails: {
                  type: "structure",
                  members: {
                    LFTagPolicy: {
                      type: "structure",
                      required: [
                        "CatalogId",
                        "ResourceType",
                        "ResourceDetails"
                      ],
                      members: {
                        CatalogId: {},
                        ResourceType: {},
                        ResourceDetails: {
                          type: "structure",
                          members: {
                            Database: {
                              type: "structure",
                              required: [
                                "Expression"
                              ],
                              members: {
                                Expression: {
                                  shape: "S1h"
                                }
                              }
                            },
                            Table: {
                              type: "structure",
                              required: [
                                "Expression"
                              ],
                              members: {
                                Expression: {
                                  shape: "S1h"
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                },
                LakeFormationDataPermissionType: {},
                Permissions: {
                  type: "list",
                  member: {}
                },
                RoleArn: {}
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/dataexchange-2017-07-25.paginators.json
var require_dataexchange_2017_07_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/dataexchange-2017-07-25.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListDataSetRevisions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Revisions"
        },
        ListDataSets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "DataSets"
        },
        ListEventActions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "EventActions"
        },
        ListJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Jobs"
        },
        ListRevisionAssets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Assets"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/dataexchange-2017-07-25.waiters2.json
var require_dataexchange_2017_07_25_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/dataexchange-2017-07-25.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {}
    };
  }
});

// node_modules/aws-sdk/clients/dataexchange.js
var require_dataexchange = __commonJS({
  "node_modules/aws-sdk/clients/dataexchange.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["dataexchange"] = {};
    AWS2.DataExchange = Service.defineService("dataexchange", ["2017-07-25"]);
    Object.defineProperty(apiLoader.services["dataexchange"], "2017-07-25", {
      get: function get() {
        var model = require_dataexchange_2017_07_25_min();
        model.paginators = require_dataexchange_2017_07_25_paginators().pagination;
        model.waiters = require_dataexchange_2017_07_25_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.DataExchange;
  }
});

// node_modules/aws-sdk/apis/sesv2-2019-09-27.min.json
var require_sesv2_2019_09_27_min = __commonJS({
  "node_modules/aws-sdk/apis/sesv2-2019-09-27.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-09-27",
        endpointPrefix: "email",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Amazon SES V2",
        serviceFullName: "Amazon Simple Email Service",
        serviceId: "SESv2",
        signatureVersion: "v4",
        signingName: "ses",
        uid: "sesv2-2019-09-27"
      },
      operations: {
        BatchGetMetricData: {
          http: {
            requestUri: "/v2/email/metrics/batch"
          },
          input: {
            type: "structure",
            required: [
              "Queries"
            ],
            members: {
              Queries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Id",
                    "Namespace",
                    "Metric",
                    "StartDate",
                    "EndDate"
                  ],
                  members: {
                    Id: {},
                    Namespace: {},
                    Metric: {},
                    Dimensions: {
                      type: "map",
                      key: {},
                      value: {}
                    },
                    StartDate: {
                      type: "timestamp"
                    },
                    EndDate: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Results: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Timestamps: {
                      type: "list",
                      member: {
                        type: "timestamp"
                      }
                    },
                    Values: {
                      type: "list",
                      member: {
                        type: "long"
                      }
                    }
                  }
                }
              },
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Code: {},
                    Message: {}
                  }
                }
              }
            }
          }
        },
        CancelExportJob: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/export-jobs/{JobId}/cancel"
          },
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {
                location: "uri",
                locationName: "JobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateConfigurationSet: {
          http: {
            requestUri: "/v2/email/configuration-sets"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {},
              TrackingOptions: {
                shape: "Sq"
              },
              DeliveryOptions: {
                shape: "Ss"
              },
              ReputationOptions: {
                shape: "Sv"
              },
              SendingOptions: {
                shape: "Sy"
              },
              Tags: {
                shape: "Sz"
              },
              SuppressionOptions: {
                shape: "S13"
              },
              VdmOptions: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateConfigurationSetEventDestination: {
          http: {
            requestUri: "/v2/email/configuration-sets/{ConfigurationSetName}/event-destinations"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName",
              "EventDestinationName",
              "EventDestination"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              EventDestinationName: {},
              EventDestination: {
                shape: "S1d"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateContact: {
          http: {
            requestUri: "/v2/email/contact-lists/{ContactListName}/contacts"
          },
          input: {
            type: "structure",
            required: [
              "ContactListName",
              "EmailAddress"
            ],
            members: {
              ContactListName: {
                location: "uri",
                locationName: "ContactListName"
              },
              EmailAddress: {},
              TopicPreferences: {
                shape: "S1u"
              },
              UnsubscribeAll: {
                type: "boolean"
              },
              AttributesData: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateContactList: {
          http: {
            requestUri: "/v2/email/contact-lists"
          },
          input: {
            type: "structure",
            required: [
              "ContactListName"
            ],
            members: {
              ContactListName: {},
              Topics: {
                shape: "S22"
              },
              Description: {},
              Tags: {
                shape: "Sz"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateCustomVerificationEmailTemplate: {
          http: {
            requestUri: "/v2/email/custom-verification-email-templates"
          },
          input: {
            type: "structure",
            required: [
              "TemplateName",
              "FromEmailAddress",
              "TemplateSubject",
              "TemplateContent",
              "SuccessRedirectionURL",
              "FailureRedirectionURL"
            ],
            members: {
              TemplateName: {},
              FromEmailAddress: {},
              TemplateSubject: {},
              TemplateContent: {},
              SuccessRedirectionURL: {},
              FailureRedirectionURL: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateDedicatedIpPool: {
          http: {
            requestUri: "/v2/email/dedicated-ip-pools"
          },
          input: {
            type: "structure",
            required: [
              "PoolName"
            ],
            members: {
              PoolName: {},
              Tags: {
                shape: "Sz"
              },
              ScalingMode: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateDeliverabilityTestReport: {
          http: {
            requestUri: "/v2/email/deliverability-dashboard/test"
          },
          input: {
            type: "structure",
            required: [
              "FromEmailAddress",
              "Content"
            ],
            members: {
              ReportName: {},
              FromEmailAddress: {},
              Content: {
                shape: "S2j"
              },
              Tags: {
                shape: "Sz"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ReportId",
              "DeliverabilityTestStatus"
            ],
            members: {
              ReportId: {},
              DeliverabilityTestStatus: {}
            }
          }
        },
        CreateEmailIdentity: {
          http: {
            requestUri: "/v2/email/identities"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity"
            ],
            members: {
              EmailIdentity: {},
              Tags: {
                shape: "Sz"
              },
              DkimSigningAttributes: {
                shape: "S2y"
              },
              ConfigurationSetName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityType: {},
              VerifiedForSendingStatus: {
                type: "boolean"
              },
              DkimAttributes: {
                shape: "S34"
              }
            }
          }
        },
        CreateEmailIdentityPolicy: {
          http: {
            requestUri: "/v2/email/identities/{EmailIdentity}/policies/{PolicyName}"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity",
              "PolicyName",
              "Policy"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              },
              PolicyName: {
                location: "uri",
                locationName: "PolicyName"
              },
              Policy: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateEmailTemplate: {
          http: {
            requestUri: "/v2/email/templates"
          },
          input: {
            type: "structure",
            required: [
              "TemplateName",
              "TemplateContent"
            ],
            members: {
              TemplateName: {},
              TemplateContent: {
                shape: "S3e"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateExportJob: {
          http: {
            requestUri: "/v2/email/export-jobs"
          },
          input: {
            type: "structure",
            required: [
              "ExportDataSource",
              "ExportDestination"
            ],
            members: {
              ExportDataSource: {
                shape: "S3j"
              },
              ExportDestination: {
                shape: "S43"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          }
        },
        CreateImportJob: {
          http: {
            requestUri: "/v2/email/import-jobs"
          },
          input: {
            type: "structure",
            required: [
              "ImportDestination",
              "ImportDataSource"
            ],
            members: {
              ImportDestination: {
                shape: "S48"
              },
              ImportDataSource: {
                shape: "S4d"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          }
        },
        DeleteConfigurationSet: {
          http: {
            method: "DELETE",
            requestUri: "/v2/email/configuration-sets/{ConfigurationSetName}"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteConfigurationSetEventDestination: {
          http: {
            method: "DELETE",
            requestUri: "/v2/email/configuration-sets/{ConfigurationSetName}/event-destinations/{EventDestinationName}"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName",
              "EventDestinationName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              EventDestinationName: {
                location: "uri",
                locationName: "EventDestinationName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteContact: {
          http: {
            method: "DELETE",
            requestUri: "/v2/email/contact-lists/{ContactListName}/contacts/{EmailAddress}"
          },
          input: {
            type: "structure",
            required: [
              "ContactListName",
              "EmailAddress"
            ],
            members: {
              ContactListName: {
                location: "uri",
                locationName: "ContactListName"
              },
              EmailAddress: {
                location: "uri",
                locationName: "EmailAddress"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteContactList: {
          http: {
            method: "DELETE",
            requestUri: "/v2/email/contact-lists/{ContactListName}"
          },
          input: {
            type: "structure",
            required: [
              "ContactListName"
            ],
            members: {
              ContactListName: {
                location: "uri",
                locationName: "ContactListName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteCustomVerificationEmailTemplate: {
          http: {
            method: "DELETE",
            requestUri: "/v2/email/custom-verification-email-templates/{TemplateName}"
          },
          input: {
            type: "structure",
            required: [
              "TemplateName"
            ],
            members: {
              TemplateName: {
                location: "uri",
                locationName: "TemplateName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDedicatedIpPool: {
          http: {
            method: "DELETE",
            requestUri: "/v2/email/dedicated-ip-pools/{PoolName}"
          },
          input: {
            type: "structure",
            required: [
              "PoolName"
            ],
            members: {
              PoolName: {
                location: "uri",
                locationName: "PoolName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteEmailIdentity: {
          http: {
            method: "DELETE",
            requestUri: "/v2/email/identities/{EmailIdentity}"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteEmailIdentityPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/v2/email/identities/{EmailIdentity}/policies/{PolicyName}"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity",
              "PolicyName"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              },
              PolicyName: {
                location: "uri",
                locationName: "PolicyName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteEmailTemplate: {
          http: {
            method: "DELETE",
            requestUri: "/v2/email/templates/{TemplateName}"
          },
          input: {
            type: "structure",
            required: [
              "TemplateName"
            ],
            members: {
              TemplateName: {
                location: "uri",
                locationName: "TemplateName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSuppressedDestination: {
          http: {
            method: "DELETE",
            requestUri: "/v2/email/suppression/addresses/{EmailAddress}"
          },
          input: {
            type: "structure",
            required: [
              "EmailAddress"
            ],
            members: {
              EmailAddress: {
                location: "uri",
                locationName: "EmailAddress"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetAccount: {
          http: {
            method: "GET",
            requestUri: "/v2/email/account"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              DedicatedIpAutoWarmupEnabled: {
                type: "boolean"
              },
              EnforcementStatus: {},
              ProductionAccessEnabled: {
                type: "boolean"
              },
              SendQuota: {
                type: "structure",
                members: {
                  Max24HourSend: {
                    type: "double"
                  },
                  MaxSendRate: {
                    type: "double"
                  },
                  SentLast24Hours: {
                    type: "double"
                  }
                }
              },
              SendingEnabled: {
                type: "boolean"
              },
              SuppressionAttributes: {
                type: "structure",
                members: {
                  SuppressedReasons: {
                    shape: "S14"
                  }
                }
              },
              Details: {
                type: "structure",
                members: {
                  MailType: {},
                  WebsiteURL: {
                    shape: "S59"
                  },
                  ContactLanguage: {},
                  UseCaseDescription: {
                    shape: "S5b"
                  },
                  AdditionalContactEmailAddresses: {
                    shape: "S5c"
                  },
                  ReviewDetails: {
                    type: "structure",
                    members: {
                      Status: {},
                      CaseId: {}
                    }
                  }
                }
              },
              VdmAttributes: {
                shape: "S5h"
              }
            }
          }
        },
        GetBlacklistReports: {
          http: {
            method: "GET",
            requestUri: "/v2/email/deliverability-dashboard/blacklist-report"
          },
          input: {
            type: "structure",
            required: [
              "BlacklistItemNames"
            ],
            members: {
              BlacklistItemNames: {
                location: "querystring",
                locationName: "BlacklistItemNames",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "BlacklistReport"
            ],
            members: {
              BlacklistReport: {
                type: "map",
                key: {},
                value: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      RblName: {},
                      ListingTime: {
                        type: "timestamp"
                      },
                      Description: {}
                    }
                  }
                }
              }
            }
          }
        },
        GetConfigurationSet: {
          http: {
            method: "GET",
            requestUri: "/v2/email/configuration-sets/{ConfigurationSetName}"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationSetName: {},
              TrackingOptions: {
                shape: "Sq"
              },
              DeliveryOptions: {
                shape: "Ss"
              },
              ReputationOptions: {
                shape: "Sv"
              },
              SendingOptions: {
                shape: "Sy"
              },
              Tags: {
                shape: "Sz"
              },
              SuppressionOptions: {
                shape: "S13"
              },
              VdmOptions: {
                shape: "S16"
              }
            }
          }
        },
        GetConfigurationSetEventDestinations: {
          http: {
            method: "GET",
            requestUri: "/v2/email/configuration-sets/{ConfigurationSetName}/event-destinations"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventDestinations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "MatchingEventTypes"
                  ],
                  members: {
                    Name: {},
                    Enabled: {
                      type: "boolean"
                    },
                    MatchingEventTypes: {
                      shape: "S1e"
                    },
                    KinesisFirehoseDestination: {
                      shape: "S1g"
                    },
                    CloudWatchDestination: {
                      shape: "S1i"
                    },
                    SnsDestination: {
                      shape: "S1o"
                    },
                    PinpointDestination: {
                      shape: "S1p"
                    }
                  }
                }
              }
            }
          }
        },
        GetContact: {
          http: {
            method: "GET",
            requestUri: "/v2/email/contact-lists/{ContactListName}/contacts/{EmailAddress}"
          },
          input: {
            type: "structure",
            required: [
              "ContactListName",
              "EmailAddress"
            ],
            members: {
              ContactListName: {
                location: "uri",
                locationName: "ContactListName"
              },
              EmailAddress: {
                location: "uri",
                locationName: "EmailAddress"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContactListName: {},
              EmailAddress: {},
              TopicPreferences: {
                shape: "S1u"
              },
              TopicDefaultPreferences: {
                shape: "S1u"
              },
              UnsubscribeAll: {
                type: "boolean"
              },
              AttributesData: {},
              CreatedTimestamp: {
                type: "timestamp"
              },
              LastUpdatedTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        GetContactList: {
          http: {
            method: "GET",
            requestUri: "/v2/email/contact-lists/{ContactListName}"
          },
          input: {
            type: "structure",
            required: [
              "ContactListName"
            ],
            members: {
              ContactListName: {
                location: "uri",
                locationName: "ContactListName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContactListName: {},
              Topics: {
                shape: "S22"
              },
              Description: {},
              CreatedTimestamp: {
                type: "timestamp"
              },
              LastUpdatedTimestamp: {
                type: "timestamp"
              },
              Tags: {
                shape: "Sz"
              }
            }
          }
        },
        GetCustomVerificationEmailTemplate: {
          http: {
            method: "GET",
            requestUri: "/v2/email/custom-verification-email-templates/{TemplateName}"
          },
          input: {
            type: "structure",
            required: [
              "TemplateName"
            ],
            members: {
              TemplateName: {
                location: "uri",
                locationName: "TemplateName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplateName: {},
              FromEmailAddress: {},
              TemplateSubject: {},
              TemplateContent: {},
              SuccessRedirectionURL: {},
              FailureRedirectionURL: {}
            }
          }
        },
        GetDedicatedIp: {
          http: {
            method: "GET",
            requestUri: "/v2/email/dedicated-ips/{IP}"
          },
          input: {
            type: "structure",
            required: [
              "Ip"
            ],
            members: {
              Ip: {
                location: "uri",
                locationName: "IP"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DedicatedIp: {
                shape: "S68"
              }
            }
          }
        },
        GetDedicatedIpPool: {
          http: {
            method: "GET",
            requestUri: "/v2/email/dedicated-ip-pools/{PoolName}"
          },
          input: {
            type: "structure",
            required: [
              "PoolName"
            ],
            members: {
              PoolName: {
                location: "uri",
                locationName: "PoolName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DedicatedIpPool: {
                type: "structure",
                required: [
                  "PoolName",
                  "ScalingMode"
                ],
                members: {
                  PoolName: {},
                  ScalingMode: {}
                }
              }
            }
          }
        },
        GetDedicatedIps: {
          http: {
            method: "GET",
            requestUri: "/v2/email/dedicated-ips"
          },
          input: {
            type: "structure",
            members: {
              PoolName: {
                location: "querystring",
                locationName: "PoolName"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DedicatedIps: {
                type: "list",
                member: {
                  shape: "S68"
                }
              },
              NextToken: {}
            }
          }
        },
        GetDeliverabilityDashboardOptions: {
          http: {
            method: "GET",
            requestUri: "/v2/email/deliverability-dashboard"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "DashboardEnabled"
            ],
            members: {
              DashboardEnabled: {
                type: "boolean"
              },
              SubscriptionExpiryDate: {
                type: "timestamp"
              },
              AccountStatus: {},
              ActiveSubscribedDomains: {
                shape: "S6m"
              },
              PendingExpirationSubscribedDomains: {
                shape: "S6m"
              }
            }
          }
        },
        GetDeliverabilityTestReport: {
          http: {
            method: "GET",
            requestUri: "/v2/email/deliverability-dashboard/test-reports/{ReportId}"
          },
          input: {
            type: "structure",
            required: [
              "ReportId"
            ],
            members: {
              ReportId: {
                location: "uri",
                locationName: "ReportId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DeliverabilityTestReport",
              "OverallPlacement",
              "IspPlacements"
            ],
            members: {
              DeliverabilityTestReport: {
                shape: "S6u"
              },
              OverallPlacement: {
                shape: "S6w"
              },
              IspPlacements: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    IspName: {},
                    PlacementStatistics: {
                      shape: "S6w"
                    }
                  }
                }
              },
              Message: {},
              Tags: {
                shape: "Sz"
              }
            }
          }
        },
        GetDomainDeliverabilityCampaign: {
          http: {
            method: "GET",
            requestUri: "/v2/email/deliverability-dashboard/campaigns/{CampaignId}"
          },
          input: {
            type: "structure",
            required: [
              "CampaignId"
            ],
            members: {
              CampaignId: {
                location: "uri",
                locationName: "CampaignId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainDeliverabilityCampaign"
            ],
            members: {
              DomainDeliverabilityCampaign: {
                shape: "S74"
              }
            }
          }
        },
        GetDomainStatisticsReport: {
          http: {
            method: "GET",
            requestUri: "/v2/email/deliverability-dashboard/statistics-report/{Domain}"
          },
          input: {
            type: "structure",
            required: [
              "Domain",
              "StartDate",
              "EndDate"
            ],
            members: {
              Domain: {
                location: "uri",
                locationName: "Domain"
              },
              StartDate: {
                location: "querystring",
                locationName: "StartDate",
                type: "timestamp"
              },
              EndDate: {
                location: "querystring",
                locationName: "EndDate",
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "OverallVolume",
              "DailyVolumes"
            ],
            members: {
              OverallVolume: {
                type: "structure",
                members: {
                  VolumeStatistics: {
                    shape: "S7e"
                  },
                  ReadRatePercent: {
                    type: "double"
                  },
                  DomainIspPlacements: {
                    shape: "S7f"
                  }
                }
              },
              DailyVolumes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StartDate: {
                      type: "timestamp"
                    },
                    VolumeStatistics: {
                      shape: "S7e"
                    },
                    DomainIspPlacements: {
                      shape: "S7f"
                    }
                  }
                }
              }
            }
          }
        },
        GetEmailIdentity: {
          http: {
            method: "GET",
            requestUri: "/v2/email/identities/{EmailIdentity}"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityType: {},
              FeedbackForwardingStatus: {
                type: "boolean"
              },
              VerifiedForSendingStatus: {
                type: "boolean"
              },
              DkimAttributes: {
                shape: "S34"
              },
              MailFromAttributes: {
                type: "structure",
                required: [
                  "MailFromDomain",
                  "MailFromDomainStatus",
                  "BehaviorOnMxFailure"
                ],
                members: {
                  MailFromDomain: {},
                  MailFromDomainStatus: {},
                  BehaviorOnMxFailure: {}
                }
              },
              Policies: {
                shape: "S7p"
              },
              Tags: {
                shape: "Sz"
              },
              ConfigurationSetName: {},
              VerificationStatus: {},
              VerificationInfo: {
                type: "structure",
                members: {
                  LastCheckedTimestamp: {
                    type: "timestamp"
                  },
                  LastSuccessTimestamp: {
                    type: "timestamp"
                  },
                  ErrorType: {},
                  SOARecord: {
                    type: "structure",
                    members: {
                      PrimaryNameServer: {},
                      AdminEmail: {},
                      SerialNumber: {
                        type: "long"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetEmailIdentityPolicies: {
          http: {
            method: "GET",
            requestUri: "/v2/email/identities/{EmailIdentity}/policies"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policies: {
                shape: "S7p"
              }
            }
          }
        },
        GetEmailTemplate: {
          http: {
            method: "GET",
            requestUri: "/v2/email/templates/{TemplateName}"
          },
          input: {
            type: "structure",
            required: [
              "TemplateName"
            ],
            members: {
              TemplateName: {
                location: "uri",
                locationName: "TemplateName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TemplateName",
              "TemplateContent"
            ],
            members: {
              TemplateName: {},
              TemplateContent: {
                shape: "S3e"
              }
            }
          }
        },
        GetExportJob: {
          http: {
            method: "GET",
            requestUri: "/v2/email/export-jobs/{JobId}"
          },
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {
                location: "uri",
                locationName: "JobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              ExportSourceType: {},
              JobStatus: {},
              ExportDestination: {
                shape: "S43"
              },
              ExportDataSource: {
                shape: "S3j"
              },
              CreatedTimestamp: {
                type: "timestamp"
              },
              CompletedTimestamp: {
                type: "timestamp"
              },
              FailureInfo: {
                shape: "S85"
              },
              Statistics: {
                type: "structure",
                members: {
                  ProcessedRecordsCount: {
                    type: "integer"
                  },
                  ExportedRecordsCount: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        GetImportJob: {
          http: {
            method: "GET",
            requestUri: "/v2/email/import-jobs/{JobId}"
          },
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {
                location: "uri",
                locationName: "JobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              ImportDestination: {
                shape: "S48"
              },
              ImportDataSource: {
                shape: "S4d"
              },
              FailureInfo: {
                shape: "S85"
              },
              JobStatus: {},
              CreatedTimestamp: {
                type: "timestamp"
              },
              CompletedTimestamp: {
                type: "timestamp"
              },
              ProcessedRecordsCount: {
                type: "integer"
              },
              FailedRecordsCount: {
                type: "integer"
              }
            }
          }
        },
        GetMessageInsights: {
          http: {
            method: "GET",
            requestUri: "/v2/email/insights/{MessageId}/"
          },
          input: {
            type: "structure",
            required: [
              "MessageId"
            ],
            members: {
              MessageId: {
                location: "uri",
                locationName: "MessageId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MessageId: {},
              FromEmailAddress: {
                shape: "S3t"
              },
              Subject: {
                shape: "S3v"
              },
              EmailTags: {
                shape: "S8h"
              },
              Insights: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Destination: {
                      shape: "S3t"
                    },
                    Isp: {},
                    Events: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Timestamp: {
                            type: "timestamp"
                          },
                          Type: {},
                          Details: {
                            type: "structure",
                            members: {
                              Bounce: {
                                type: "structure",
                                members: {
                                  BounceType: {},
                                  BounceSubType: {},
                                  DiagnosticCode: {}
                                }
                              },
                              Complaint: {
                                type: "structure",
                                members: {
                                  ComplaintSubType: {},
                                  ComplaintFeedbackType: {}
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetSuppressedDestination: {
          http: {
            method: "GET",
            requestUri: "/v2/email/suppression/addresses/{EmailAddress}"
          },
          input: {
            type: "structure",
            required: [
              "EmailAddress"
            ],
            members: {
              EmailAddress: {
                location: "uri",
                locationName: "EmailAddress"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "SuppressedDestination"
            ],
            members: {
              SuppressedDestination: {
                type: "structure",
                required: [
                  "EmailAddress",
                  "Reason",
                  "LastUpdateTime"
                ],
                members: {
                  EmailAddress: {},
                  Reason: {},
                  LastUpdateTime: {
                    type: "timestamp"
                  },
                  Attributes: {
                    type: "structure",
                    members: {
                      MessageId: {},
                      FeedbackId: {}
                    }
                  }
                }
              }
            }
          }
        },
        ListConfigurationSets: {
          http: {
            method: "GET",
            requestUri: "/v2/email/configuration-sets"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationSets: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListContactLists: {
          http: {
            method: "GET",
            requestUri: "/v2/email/contact-lists"
          },
          input: {
            type: "structure",
            members: {
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContactLists: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ContactListName: {},
                    LastUpdatedTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListContacts: {
          http: {
            method: "GET",
            requestUri: "/v2/email/contact-lists/{ContactListName}/contacts"
          },
          input: {
            type: "structure",
            required: [
              "ContactListName"
            ],
            members: {
              ContactListName: {
                location: "uri",
                locationName: "ContactListName"
              },
              Filter: {
                type: "structure",
                members: {
                  FilteredStatus: {},
                  TopicFilter: {
                    type: "structure",
                    members: {
                      TopicName: {},
                      UseDefaultIfPreferenceUnavailable: {
                        type: "boolean"
                      }
                    }
                  }
                }
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Contacts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EmailAddress: {},
                    TopicPreferences: {
                      shape: "S1u"
                    },
                    TopicDefaultPreferences: {
                      shape: "S1u"
                    },
                    UnsubscribeAll: {
                      type: "boolean"
                    },
                    LastUpdatedTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListCustomVerificationEmailTemplates: {
          http: {
            method: "GET",
            requestUri: "/v2/email/custom-verification-email-templates"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CustomVerificationEmailTemplates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TemplateName: {},
                    FromEmailAddress: {},
                    TemplateSubject: {},
                    SuccessRedirectionURL: {},
                    FailureRedirectionURL: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDedicatedIpPools: {
          http: {
            method: "GET",
            requestUri: "/v2/email/dedicated-ip-pools"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DedicatedIpPools: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListDeliverabilityTestReports: {
          http: {
            method: "GET",
            requestUri: "/v2/email/deliverability-dashboard/test-reports"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DeliverabilityTestReports"
            ],
            members: {
              DeliverabilityTestReports: {
                type: "list",
                member: {
                  shape: "S6u"
                }
              },
              NextToken: {}
            }
          }
        },
        ListDomainDeliverabilityCampaigns: {
          http: {
            method: "GET",
            requestUri: "/v2/email/deliverability-dashboard/domains/{SubscribedDomain}/campaigns"
          },
          input: {
            type: "structure",
            required: [
              "StartDate",
              "EndDate",
              "SubscribedDomain"
            ],
            members: {
              StartDate: {
                location: "querystring",
                locationName: "StartDate",
                type: "timestamp"
              },
              EndDate: {
                location: "querystring",
                locationName: "EndDate",
                type: "timestamp"
              },
              SubscribedDomain: {
                location: "uri",
                locationName: "SubscribedDomain"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainDeliverabilityCampaigns"
            ],
            members: {
              DomainDeliverabilityCampaigns: {
                type: "list",
                member: {
                  shape: "S74"
                }
              },
              NextToken: {}
            }
          }
        },
        ListEmailIdentities: {
          http: {
            method: "GET",
            requestUri: "/v2/email/identities"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EmailIdentities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    IdentityType: {},
                    IdentityName: {},
                    SendingEnabled: {
                      type: "boolean"
                    },
                    VerificationStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEmailTemplates: {
          http: {
            method: "GET",
            requestUri: "/v2/email/templates"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplatesMetadata: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TemplateName: {},
                    CreatedTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListExportJobs: {
          http: {
            requestUri: "/v2/email/list-export-jobs"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {},
              PageSize: {
                type: "integer"
              },
              ExportSourceType: {},
              JobStatus: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ExportJobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    JobId: {},
                    ExportSourceType: {},
                    JobStatus: {},
                    CreatedTimestamp: {
                      type: "timestamp"
                    },
                    CompletedTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListImportJobs: {
          http: {
            method: "GET",
            requestUri: "/v2/email/import-jobs"
          },
          input: {
            type: "structure",
            members: {
              ImportDestinationType: {},
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ImportJobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    JobId: {},
                    ImportDestination: {
                      shape: "S48"
                    },
                    JobStatus: {},
                    CreatedTimestamp: {
                      type: "timestamp"
                    },
                    ProcessedRecordsCount: {
                      type: "integer"
                    },
                    FailedRecordsCount: {
                      type: "integer"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListRecommendations: {
          http: {
            requestUri: "/v2/email/vdm/recommendations"
          },
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "map",
                key: {},
                value: {}
              },
              NextToken: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Recommendations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceArn: {},
                    Type: {},
                    Description: {},
                    Status: {},
                    CreatedTimestamp: {
                      type: "timestamp"
                    },
                    LastUpdatedTimestamp: {
                      type: "timestamp"
                    },
                    Impact: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSuppressedDestinations: {
          http: {
            method: "GET",
            requestUri: "/v2/email/suppression/addresses"
          },
          input: {
            type: "structure",
            members: {
              Reasons: {
                shape: "S14",
                location: "querystring",
                locationName: "Reason"
              },
              StartDate: {
                location: "querystring",
                locationName: "StartDate",
                type: "timestamp"
              },
              EndDate: {
                location: "querystring",
                locationName: "EndDate",
                type: "timestamp"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SuppressedDestinationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "EmailAddress",
                    "Reason",
                    "LastUpdateTime"
                  ],
                  members: {
                    EmailAddress: {},
                    Reason: {},
                    LastUpdateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/v2/email/tags"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "querystring",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "Sz"
              }
            }
          }
        },
        PutAccountDedicatedIpWarmupAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/account/dedicated-ips/warmup"
          },
          input: {
            type: "structure",
            members: {
              AutoWarmupEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutAccountDetails: {
          http: {
            requestUri: "/v2/email/account/details"
          },
          input: {
            type: "structure",
            required: [
              "MailType",
              "WebsiteURL",
              "UseCaseDescription"
            ],
            members: {
              MailType: {},
              WebsiteURL: {
                shape: "S59"
              },
              ContactLanguage: {},
              UseCaseDescription: {
                shape: "S5b"
              },
              AdditionalContactEmailAddresses: {
                shape: "S5c"
              },
              ProductionAccessEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutAccountSendingAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/account/sending"
          },
          input: {
            type: "structure",
            members: {
              SendingEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutAccountSuppressionAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/account/suppression"
          },
          input: {
            type: "structure",
            members: {
              SuppressedReasons: {
                shape: "S14"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutAccountVdmAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/account/vdm"
          },
          input: {
            type: "structure",
            required: [
              "VdmAttributes"
            ],
            members: {
              VdmAttributes: {
                shape: "S5h"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutConfigurationSetDeliveryOptions: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/configuration-sets/{ConfigurationSetName}/delivery-options"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              TlsPolicy: {},
              SendingPoolName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutConfigurationSetReputationOptions: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/configuration-sets/{ConfigurationSetName}/reputation-options"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              ReputationMetricsEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutConfigurationSetSendingOptions: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/configuration-sets/{ConfigurationSetName}/sending"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              SendingEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutConfigurationSetSuppressionOptions: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/configuration-sets/{ConfigurationSetName}/suppression-options"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              SuppressedReasons: {
                shape: "S14"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutConfigurationSetTrackingOptions: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/configuration-sets/{ConfigurationSetName}/tracking-options"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              CustomRedirectDomain: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutConfigurationSetVdmOptions: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/configuration-sets/{ConfigurationSetName}/vdm-options"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              VdmOptions: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutDedicatedIpInPool: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/dedicated-ips/{IP}/pool"
          },
          input: {
            type: "structure",
            required: [
              "Ip",
              "DestinationPoolName"
            ],
            members: {
              Ip: {
                location: "uri",
                locationName: "IP"
              },
              DestinationPoolName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutDedicatedIpPoolScalingAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/dedicated-ip-pools/{PoolName}/scaling"
          },
          input: {
            type: "structure",
            required: [
              "PoolName",
              "ScalingMode"
            ],
            members: {
              PoolName: {
                location: "uri",
                locationName: "PoolName"
              },
              ScalingMode: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        PutDedicatedIpWarmupAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/dedicated-ips/{IP}/warmup"
          },
          input: {
            type: "structure",
            required: [
              "Ip",
              "WarmupPercentage"
            ],
            members: {
              Ip: {
                location: "uri",
                locationName: "IP"
              },
              WarmupPercentage: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutDeliverabilityDashboardOption: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/deliverability-dashboard"
          },
          input: {
            type: "structure",
            required: [
              "DashboardEnabled"
            ],
            members: {
              DashboardEnabled: {
                type: "boolean"
              },
              SubscribedDomains: {
                shape: "S6m"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutEmailIdentityConfigurationSetAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/identities/{EmailIdentity}/configuration-set"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              },
              ConfigurationSetName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutEmailIdentityDkimAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/identities/{EmailIdentity}/dkim"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              },
              SigningEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutEmailIdentityDkimSigningAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v1/email/identities/{EmailIdentity}/dkim/signing"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity",
              "SigningAttributesOrigin"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              },
              SigningAttributesOrigin: {},
              SigningAttributes: {
                shape: "S2y"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DkimStatus: {},
              DkimTokens: {
                shape: "S36"
              }
            }
          }
        },
        PutEmailIdentityFeedbackAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/identities/{EmailIdentity}/feedback"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              },
              EmailForwardingEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutEmailIdentityMailFromAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/identities/{EmailIdentity}/mail-from"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              },
              MailFromDomain: {},
              BehaviorOnMxFailure: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutSuppressedDestination: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/suppression/addresses"
          },
          input: {
            type: "structure",
            required: [
              "EmailAddress",
              "Reason"
            ],
            members: {
              EmailAddress: {},
              Reason: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SendBulkEmail: {
          http: {
            requestUri: "/v2/email/outbound-bulk-emails"
          },
          input: {
            type: "structure",
            required: [
              "DefaultContent",
              "BulkEmailEntries"
            ],
            members: {
              FromEmailAddress: {},
              FromEmailAddressIdentityArn: {},
              ReplyToAddresses: {
                shape: "Sc0"
              },
              FeedbackForwardingEmailAddress: {},
              FeedbackForwardingEmailAddressIdentityArn: {},
              DefaultEmailTags: {
                shape: "S8h"
              },
              DefaultContent: {
                type: "structure",
                members: {
                  Template: {
                    shape: "S2r"
                  }
                }
              },
              BulkEmailEntries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Destination"
                  ],
                  members: {
                    Destination: {
                      shape: "Sc4"
                    },
                    ReplacementTags: {
                      shape: "S8h"
                    },
                    ReplacementEmailContent: {
                      type: "structure",
                      members: {
                        ReplacementTemplate: {
                          type: "structure",
                          members: {
                            ReplacementTemplateData: {}
                          }
                        }
                      }
                    }
                  }
                }
              },
              ConfigurationSetName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "BulkEmailEntryResults"
            ],
            members: {
              BulkEmailEntryResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Status: {},
                    Error: {},
                    MessageId: {}
                  }
                }
              }
            }
          }
        },
        SendCustomVerificationEmail: {
          http: {
            requestUri: "/v2/email/outbound-custom-verification-emails"
          },
          input: {
            type: "structure",
            required: [
              "EmailAddress",
              "TemplateName"
            ],
            members: {
              EmailAddress: {},
              TemplateName: {},
              ConfigurationSetName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MessageId: {}
            }
          }
        },
        SendEmail: {
          http: {
            requestUri: "/v2/email/outbound-emails"
          },
          input: {
            type: "structure",
            required: [
              "Content"
            ],
            members: {
              FromEmailAddress: {},
              FromEmailAddressIdentityArn: {},
              Destination: {
                shape: "Sc4"
              },
              ReplyToAddresses: {
                shape: "Sc0"
              },
              FeedbackForwardingEmailAddress: {},
              FeedbackForwardingEmailAddressIdentityArn: {},
              Content: {
                shape: "S2j"
              },
              EmailTags: {
                shape: "S8h"
              },
              ConfigurationSetName: {},
              ListManagementOptions: {
                type: "structure",
                required: [
                  "ContactListName"
                ],
                members: {
                  ContactListName: {},
                  TopicName: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MessageId: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/v2/email/tags"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "Sz"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TestRenderEmailTemplate: {
          http: {
            requestUri: "/v2/email/templates/{TemplateName}/render"
          },
          input: {
            type: "structure",
            required: [
              "TemplateName",
              "TemplateData"
            ],
            members: {
              TemplateName: {
                location: "uri",
                locationName: "TemplateName"
              },
              TemplateData: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "RenderedTemplate"
            ],
            members: {
              RenderedTemplate: {}
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/v2/email/tags"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "querystring",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "TagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateConfigurationSetEventDestination: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/configuration-sets/{ConfigurationSetName}/event-destinations/{EventDestinationName}"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName",
              "EventDestinationName",
              "EventDestination"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              EventDestinationName: {
                location: "uri",
                locationName: "EventDestinationName"
              },
              EventDestination: {
                shape: "S1d"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateContact: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/contact-lists/{ContactListName}/contacts/{EmailAddress}"
          },
          input: {
            type: "structure",
            required: [
              "ContactListName",
              "EmailAddress"
            ],
            members: {
              ContactListName: {
                location: "uri",
                locationName: "ContactListName"
              },
              EmailAddress: {
                location: "uri",
                locationName: "EmailAddress"
              },
              TopicPreferences: {
                shape: "S1u"
              },
              UnsubscribeAll: {
                type: "boolean"
              },
              AttributesData: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateContactList: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/contact-lists/{ContactListName}"
          },
          input: {
            type: "structure",
            required: [
              "ContactListName"
            ],
            members: {
              ContactListName: {
                location: "uri",
                locationName: "ContactListName"
              },
              Topics: {
                shape: "S22"
              },
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateCustomVerificationEmailTemplate: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/custom-verification-email-templates/{TemplateName}"
          },
          input: {
            type: "structure",
            required: [
              "TemplateName",
              "FromEmailAddress",
              "TemplateSubject",
              "TemplateContent",
              "SuccessRedirectionURL",
              "FailureRedirectionURL"
            ],
            members: {
              TemplateName: {
                location: "uri",
                locationName: "TemplateName"
              },
              FromEmailAddress: {},
              TemplateSubject: {},
              TemplateContent: {},
              SuccessRedirectionURL: {},
              FailureRedirectionURL: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateEmailIdentityPolicy: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/identities/{EmailIdentity}/policies/{PolicyName}"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity",
              "PolicyName",
              "Policy"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              },
              PolicyName: {
                location: "uri",
                locationName: "PolicyName"
              },
              Policy: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateEmailTemplate: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/templates/{TemplateName}"
          },
          input: {
            type: "structure",
            required: [
              "TemplateName",
              "TemplateContent"
            ],
            members: {
              TemplateName: {
                location: "uri",
                locationName: "TemplateName"
              },
              TemplateContent: {
                shape: "S3e"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        Sq: {
          type: "structure",
          required: [
            "CustomRedirectDomain"
          ],
          members: {
            CustomRedirectDomain: {}
          }
        },
        Ss: {
          type: "structure",
          members: {
            TlsPolicy: {},
            SendingPoolName: {}
          }
        },
        Sv: {
          type: "structure",
          members: {
            ReputationMetricsEnabled: {
              type: "boolean"
            },
            LastFreshStart: {
              type: "timestamp"
            }
          }
        },
        Sy: {
          type: "structure",
          members: {
            SendingEnabled: {
              type: "boolean"
            }
          }
        },
        Sz: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S13: {
          type: "structure",
          members: {
            SuppressedReasons: {
              shape: "S14"
            }
          }
        },
        S14: {
          type: "list",
          member: {}
        },
        S16: {
          type: "structure",
          members: {
            DashboardOptions: {
              type: "structure",
              members: {
                EngagementMetrics: {}
              }
            },
            GuardianOptions: {
              type: "structure",
              members: {
                OptimizedSharedDelivery: {}
              }
            }
          }
        },
        S1d: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            MatchingEventTypes: {
              shape: "S1e"
            },
            KinesisFirehoseDestination: {
              shape: "S1g"
            },
            CloudWatchDestination: {
              shape: "S1i"
            },
            SnsDestination: {
              shape: "S1o"
            },
            PinpointDestination: {
              shape: "S1p"
            }
          }
        },
        S1e: {
          type: "list",
          member: {}
        },
        S1g: {
          type: "structure",
          required: [
            "IamRoleArn",
            "DeliveryStreamArn"
          ],
          members: {
            IamRoleArn: {},
            DeliveryStreamArn: {}
          }
        },
        S1i: {
          type: "structure",
          required: [
            "DimensionConfigurations"
          ],
          members: {
            DimensionConfigurations: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "DimensionName",
                  "DimensionValueSource",
                  "DefaultDimensionValue"
                ],
                members: {
                  DimensionName: {},
                  DimensionValueSource: {},
                  DefaultDimensionValue: {}
                }
              }
            }
          }
        },
        S1o: {
          type: "structure",
          required: [
            "TopicArn"
          ],
          members: {
            TopicArn: {}
          }
        },
        S1p: {
          type: "structure",
          members: {
            ApplicationArn: {}
          }
        },
        S1u: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "TopicName",
              "SubscriptionStatus"
            ],
            members: {
              TopicName: {},
              SubscriptionStatus: {}
            }
          }
        },
        S22: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "TopicName",
              "DisplayName",
              "DefaultSubscriptionStatus"
            ],
            members: {
              TopicName: {},
              DisplayName: {},
              Description: {},
              DefaultSubscriptionStatus: {}
            }
          }
        },
        S2j: {
          type: "structure",
          members: {
            Simple: {
              type: "structure",
              required: [
                "Subject",
                "Body"
              ],
              members: {
                Subject: {
                  shape: "S2l"
                },
                Body: {
                  type: "structure",
                  members: {
                    Text: {
                      shape: "S2l"
                    },
                    Html: {
                      shape: "S2l"
                    }
                  }
                }
              }
            },
            Raw: {
              type: "structure",
              required: [
                "Data"
              ],
              members: {
                Data: {
                  type: "blob"
                }
              }
            },
            Template: {
              shape: "S2r"
            }
          }
        },
        S2l: {
          type: "structure",
          required: [
            "Data"
          ],
          members: {
            Data: {},
            Charset: {}
          }
        },
        S2r: {
          type: "structure",
          members: {
            TemplateName: {},
            TemplateArn: {},
            TemplateData: {}
          }
        },
        S2y: {
          type: "structure",
          members: {
            DomainSigningSelector: {},
            DomainSigningPrivateKey: {
              type: "string",
              sensitive: true
            },
            NextSigningKeyLength: {}
          }
        },
        S34: {
          type: "structure",
          members: {
            SigningEnabled: {
              type: "boolean"
            },
            Status: {},
            Tokens: {
              shape: "S36"
            },
            SigningAttributesOrigin: {},
            NextSigningKeyLength: {},
            CurrentSigningKeyLength: {},
            LastKeyGenerationTimestamp: {
              type: "timestamp"
            }
          }
        },
        S36: {
          type: "list",
          member: {}
        },
        S3e: {
          type: "structure",
          members: {
            Subject: {},
            Text: {},
            Html: {}
          }
        },
        S3j: {
          type: "structure",
          members: {
            MetricsDataSource: {
              type: "structure",
              required: [
                "Dimensions",
                "Namespace",
                "Metrics",
                "StartDate",
                "EndDate"
              ],
              members: {
                Dimensions: {
                  type: "map",
                  key: {},
                  value: {
                    type: "list",
                    member: {}
                  }
                },
                Namespace: {},
                Metrics: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      Name: {},
                      Aggregation: {}
                    }
                  }
                },
                StartDate: {
                  type: "timestamp"
                },
                EndDate: {
                  type: "timestamp"
                }
              }
            },
            MessageInsightsDataSource: {
              type: "structure",
              required: [
                "StartDate",
                "EndDate"
              ],
              members: {
                StartDate: {
                  type: "timestamp"
                },
                EndDate: {
                  type: "timestamp"
                },
                Include: {
                  shape: "S3r"
                },
                Exclude: {
                  shape: "S3r"
                },
                MaxResults: {
                  type: "integer"
                }
              }
            }
          }
        },
        S3r: {
          type: "structure",
          members: {
            FromEmailAddress: {
              shape: "S3s"
            },
            Destination: {
              shape: "S3s"
            },
            Subject: {
              type: "list",
              member: {
                shape: "S3v"
              }
            },
            Isp: {
              type: "list",
              member: {}
            },
            LastDeliveryEvent: {
              type: "list",
              member: {}
            },
            LastEngagementEvent: {
              type: "list",
              member: {}
            }
          }
        },
        S3s: {
          type: "list",
          member: {
            shape: "S3t"
          }
        },
        S3t: {
          type: "string",
          sensitive: true
        },
        S3v: {
          type: "string",
          sensitive: true
        },
        S43: {
          type: "structure",
          required: [
            "DataFormat"
          ],
          members: {
            DataFormat: {},
            S3Url: {}
          }
        },
        S48: {
          type: "structure",
          members: {
            SuppressionListDestination: {
              type: "structure",
              required: [
                "SuppressionListImportAction"
              ],
              members: {
                SuppressionListImportAction: {}
              }
            },
            ContactListDestination: {
              type: "structure",
              required: [
                "ContactListName",
                "ContactListImportAction"
              ],
              members: {
                ContactListName: {},
                ContactListImportAction: {}
              }
            }
          }
        },
        S4d: {
          type: "structure",
          required: [
            "S3Url",
            "DataFormat"
          ],
          members: {
            S3Url: {},
            DataFormat: {}
          }
        },
        S59: {
          type: "string",
          sensitive: true
        },
        S5b: {
          type: "string",
          sensitive: true
        },
        S5c: {
          type: "list",
          member: {
            type: "string",
            sensitive: true
          },
          sensitive: true
        },
        S5h: {
          type: "structure",
          required: [
            "VdmEnabled"
          ],
          members: {
            VdmEnabled: {},
            DashboardAttributes: {
              type: "structure",
              members: {
                EngagementMetrics: {}
              }
            },
            GuardianAttributes: {
              type: "structure",
              members: {
                OptimizedSharedDelivery: {}
              }
            }
          }
        },
        S68: {
          type: "structure",
          required: [
            "Ip",
            "WarmupStatus",
            "WarmupPercentage"
          ],
          members: {
            Ip: {},
            WarmupStatus: {},
            WarmupPercentage: {
              type: "integer"
            },
            PoolName: {}
          }
        },
        S6m: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Domain: {},
              SubscriptionStartDate: {
                type: "timestamp"
              },
              InboxPlacementTrackingOption: {
                type: "structure",
                members: {
                  Global: {
                    type: "boolean"
                  },
                  TrackedIsps: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          }
        },
        S6u: {
          type: "structure",
          members: {
            ReportId: {},
            ReportName: {},
            Subject: {},
            FromEmailAddress: {},
            CreateDate: {
              type: "timestamp"
            },
            DeliverabilityTestStatus: {}
          }
        },
        S6w: {
          type: "structure",
          members: {
            InboxPercentage: {
              type: "double"
            },
            SpamPercentage: {
              type: "double"
            },
            MissingPercentage: {
              type: "double"
            },
            SpfPercentage: {
              type: "double"
            },
            DkimPercentage: {
              type: "double"
            }
          }
        },
        S74: {
          type: "structure",
          members: {
            CampaignId: {},
            ImageUrl: {},
            Subject: {},
            FromAddress: {},
            SendingIps: {
              type: "list",
              member: {}
            },
            FirstSeenDateTime: {
              type: "timestamp"
            },
            LastSeenDateTime: {
              type: "timestamp"
            },
            InboxCount: {
              type: "long"
            },
            SpamCount: {
              type: "long"
            },
            ReadRate: {
              type: "double"
            },
            DeleteRate: {
              type: "double"
            },
            ReadDeleteRate: {
              type: "double"
            },
            ProjectedVolume: {
              type: "long"
            },
            Esps: {
              type: "list",
              member: {}
            }
          }
        },
        S7e: {
          type: "structure",
          members: {
            InboxRawCount: {
              type: "long"
            },
            SpamRawCount: {
              type: "long"
            },
            ProjectedInbox: {
              type: "long"
            },
            ProjectedSpam: {
              type: "long"
            }
          }
        },
        S7f: {
          type: "list",
          member: {
            type: "structure",
            members: {
              IspName: {},
              InboxRawCount: {
                type: "long"
              },
              SpamRawCount: {
                type: "long"
              },
              InboxPercentage: {
                type: "double"
              },
              SpamPercentage: {
                type: "double"
              }
            }
          }
        },
        S7p: {
          type: "map",
          key: {},
          value: {}
        },
        S85: {
          type: "structure",
          members: {
            FailedRecordsS3Url: {},
            ErrorMessage: {}
          }
        },
        S8h: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Value"
            ],
            members: {
              Name: {},
              Value: {}
            }
          }
        },
        Sc0: {
          type: "list",
          member: {}
        },
        Sc4: {
          type: "structure",
          members: {
            ToAddresses: {
              shape: "Sc0"
            },
            CcAddresses: {
              shape: "Sc0"
            },
            BccAddresses: {
              shape: "Sc0"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/sesv2-2019-09-27.paginators.json
var require_sesv2_2019_09_27_paginators = __commonJS({
  "node_modules/aws-sdk/apis/sesv2-2019-09-27.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetDedicatedIps: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListConfigurationSets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListContactLists: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListContacts: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListCustomVerificationEmailTemplates: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListDedicatedIpPools: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListDeliverabilityTestReports: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListDomainDeliverabilityCampaigns: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListEmailIdentities: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListEmailTemplates: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListExportJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListImportJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListRecommendations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListSuppressedDestinations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/sesv2.js
var require_sesv2 = __commonJS({
  "node_modules/aws-sdk/clients/sesv2.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["sesv2"] = {};
    AWS2.SESV2 = Service.defineService("sesv2", ["2019-09-27"]);
    Object.defineProperty(apiLoader.services["sesv2"], "2019-09-27", {
      get: function get() {
        var model = require_sesv2_2019_09_27_min();
        model.paginators = require_sesv2_2019_09_27_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.SESV2;
  }
});

// node_modules/aws-sdk/apis/migrationhub-config-2019-06-30.min.json
var require_migrationhub_config_2019_06_30_min = __commonJS({
  "node_modules/aws-sdk/apis/migrationhub-config-2019-06-30.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-06-30",
        endpointPrefix: "migrationhub-config",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Migration Hub Config",
        serviceId: "MigrationHub Config",
        signatureVersion: "v4",
        signingName: "mgh",
        targetPrefix: "AWSMigrationHubMultiAccountService",
        uid: "migrationhub-config-2019-06-30"
      },
      operations: {
        CreateHomeRegionControl: {
          input: {
            type: "structure",
            required: [
              "HomeRegion",
              "Target"
            ],
            members: {
              HomeRegion: {},
              Target: {
                shape: "S3"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HomeRegionControl: {
                shape: "S8"
              }
            }
          }
        },
        DeleteHomeRegionControl: {
          input: {
            type: "structure",
            required: [
              "ControlId"
            ],
            members: {
              ControlId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeHomeRegionControls: {
          input: {
            type: "structure",
            members: {
              ControlId: {},
              HomeRegion: {},
              Target: {
                shape: "S3"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              HomeRegionControls: {
                type: "list",
                member: {
                  shape: "S8"
                }
              },
              NextToken: {}
            }
          }
        },
        GetHomeRegion: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              HomeRegion: {}
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          required: [
            "Type"
          ],
          members: {
            Type: {},
            Id: {}
          }
        },
        S8: {
          type: "structure",
          members: {
            ControlId: {},
            HomeRegion: {},
            Target: {
              shape: "S3"
            },
            RequestedTime: {
              type: "timestamp"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/migrationhub-config-2019-06-30.paginators.json
var require_migrationhub_config_2019_06_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/migrationhub-config-2019-06-30.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeHomeRegionControls: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/migrationhubconfig.js
var require_migrationhubconfig = __commonJS({
  "node_modules/aws-sdk/clients/migrationhubconfig.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["migrationhubconfig"] = {};
    AWS2.MigrationHubConfig = Service.defineService("migrationhubconfig", ["2019-06-30"]);
    Object.defineProperty(apiLoader.services["migrationhubconfig"], "2019-06-30", {
      get: function get() {
        var model = require_migrationhub_config_2019_06_30_min();
        model.paginators = require_migrationhub_config_2019_06_30_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.MigrationHubConfig;
  }
});

// node_modules/aws-sdk/apis/connectparticipant-2018-09-07.min.json
var require_connectparticipant_2018_09_07_min = __commonJS({
  "node_modules/aws-sdk/apis/connectparticipant-2018-09-07.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-09-07",
        endpointPrefix: "participant.connect",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Amazon Connect Participant",
        serviceFullName: "Amazon Connect Participant Service",
        serviceId: "ConnectParticipant",
        signatureVersion: "v4",
        signingName: "execute-api",
        uid: "connectparticipant-2018-09-07"
      },
      operations: {
        CompleteAttachmentUpload: {
          http: {
            requestUri: "/participant/complete-attachment-upload"
          },
          input: {
            type: "structure",
            required: [
              "AttachmentIds",
              "ClientToken",
              "ConnectionToken"
            ],
            members: {
              AttachmentIds: {
                type: "list",
                member: {}
              },
              ClientToken: {
                idempotencyToken: true
              },
              ConnectionToken: {
                location: "header",
                locationName: "X-Amz-Bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateParticipantConnection: {
          http: {
            requestUri: "/participant/connection"
          },
          input: {
            type: "structure",
            required: [
              "ParticipantToken"
            ],
            members: {
              Type: {
                type: "list",
                member: {}
              },
              ParticipantToken: {
                location: "header",
                locationName: "X-Amz-Bearer"
              },
              ConnectParticipant: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Websocket: {
                type: "structure",
                members: {
                  Url: {},
                  ConnectionExpiry: {}
                }
              },
              ConnectionCredentials: {
                type: "structure",
                members: {
                  ConnectionToken: {},
                  Expiry: {}
                }
              }
            }
          }
        },
        DescribeView: {
          http: {
            method: "GET",
            requestUri: "/participant/views/{ViewToken}"
          },
          input: {
            type: "structure",
            required: [
              "ViewToken",
              "ConnectionToken"
            ],
            members: {
              ViewToken: {
                location: "uri",
                locationName: "ViewToken"
              },
              ConnectionToken: {
                location: "header",
                locationName: "X-Amz-Bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              View: {
                type: "structure",
                members: {
                  Id: {},
                  Arn: {},
                  Name: {
                    type: "string",
                    sensitive: true
                  },
                  Version: {
                    type: "integer"
                  },
                  Content: {
                    type: "structure",
                    members: {
                      InputSchema: {
                        type: "string",
                        sensitive: true
                      },
                      Template: {
                        type: "string",
                        sensitive: true
                      },
                      Actions: {
                        type: "list",
                        member: {
                          type: "string",
                          sensitive: true
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DisconnectParticipant: {
          http: {
            requestUri: "/participant/disconnect"
          },
          input: {
            type: "structure",
            required: [
              "ConnectionToken"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              ConnectionToken: {
                location: "header",
                locationName: "X-Amz-Bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetAttachment: {
          http: {
            requestUri: "/participant/attachment"
          },
          input: {
            type: "structure",
            required: [
              "AttachmentId",
              "ConnectionToken"
            ],
            members: {
              AttachmentId: {},
              ConnectionToken: {
                location: "header",
                locationName: "X-Amz-Bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Url: {},
              UrlExpiry: {}
            }
          }
        },
        GetTranscript: {
          http: {
            requestUri: "/participant/transcript"
          },
          input: {
            type: "structure",
            required: [
              "ConnectionToken"
            ],
            members: {
              ContactId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              ScanDirection: {},
              SortOrder: {},
              StartPosition: {
                type: "structure",
                members: {
                  Id: {},
                  AbsoluteTime: {},
                  MostRecent: {
                    type: "integer"
                  }
                }
              },
              ConnectionToken: {
                location: "header",
                locationName: "X-Amz-Bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InitialContactId: {},
              Transcript: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AbsoluteTime: {},
                    Content: {},
                    ContentType: {},
                    Id: {},
                    Type: {},
                    ParticipantId: {},
                    DisplayName: {},
                    ParticipantRole: {},
                    Attachments: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ContentType: {},
                          AttachmentId: {},
                          AttachmentName: {},
                          Status: {}
                        }
                      }
                    },
                    MessageMetadata: {
                      type: "structure",
                      members: {
                        MessageId: {},
                        Receipts: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              DeliveredTimestamp: {},
                              ReadTimestamp: {},
                              RecipientParticipantId: {}
                            }
                          }
                        }
                      }
                    },
                    RelatedContactId: {},
                    ContactId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        SendEvent: {
          http: {
            requestUri: "/participant/event"
          },
          input: {
            type: "structure",
            required: [
              "ContentType",
              "ConnectionToken"
            ],
            members: {
              ContentType: {},
              Content: {},
              ClientToken: {
                idempotencyToken: true
              },
              ConnectionToken: {
                location: "header",
                locationName: "X-Amz-Bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {},
              AbsoluteTime: {}
            }
          }
        },
        SendMessage: {
          http: {
            requestUri: "/participant/message"
          },
          input: {
            type: "structure",
            required: [
              "ContentType",
              "Content",
              "ConnectionToken"
            ],
            members: {
              ContentType: {},
              Content: {},
              ClientToken: {
                idempotencyToken: true
              },
              ConnectionToken: {
                location: "header",
                locationName: "X-Amz-Bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {},
              AbsoluteTime: {}
            }
          }
        },
        StartAttachmentUpload: {
          http: {
            requestUri: "/participant/start-attachment-upload"
          },
          input: {
            type: "structure",
            required: [
              "ContentType",
              "AttachmentSizeInBytes",
              "AttachmentName",
              "ClientToken",
              "ConnectionToken"
            ],
            members: {
              ContentType: {},
              AttachmentSizeInBytes: {
                type: "long"
              },
              AttachmentName: {},
              ClientToken: {
                idempotencyToken: true
              },
              ConnectionToken: {
                location: "header",
                locationName: "X-Amz-Bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AttachmentId: {},
              UploadMetadata: {
                type: "structure",
                members: {
                  Url: {},
                  UrlExpiry: {},
                  HeadersToInclude: {
                    type: "map",
                    key: {},
                    value: {}
                  }
                }
              }
            }
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/apis/connectparticipant-2018-09-07.paginators.json
var require_connectparticipant_2018_09_07_paginators = __commonJS({
  "node_modules/aws-sdk/apis/connectparticipant-2018-09-07.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetTranscript: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/connectparticipant.js
var require_connectparticipant = __commonJS({
  "node_modules/aws-sdk/clients/connectparticipant.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["connectparticipant"] = {};
    AWS2.ConnectParticipant = Service.defineService("connectparticipant", ["2018-09-07"]);
    Object.defineProperty(apiLoader.services["connectparticipant"], "2018-09-07", {
      get: function get() {
        var model = require_connectparticipant_2018_09_07_min();
        model.paginators = require_connectparticipant_2018_09_07_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ConnectParticipant;
  }
});

// node_modules/aws-sdk/apis/appconfig-2019-10-09.min.json
var require_appconfig_2019_10_09_min = __commonJS({
  "node_modules/aws-sdk/apis/appconfig-2019-10-09.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-10-09",
        endpointPrefix: "appconfig",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "AppConfig",
        serviceFullName: "Amazon AppConfig",
        serviceId: "AppConfig",
        signatureVersion: "v4",
        signingName: "appconfig",
        uid: "appconfig-2019-10-09"
      },
      operations: {
        CreateApplication: {
          http: {
            requestUri: "/applications",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Description: {},
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            shape: "S7"
          }
        },
        CreateConfigurationProfile: {
          http: {
            requestUri: "/applications/{ApplicationId}/configurationprofiles",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "Name",
              "LocationUri"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              Name: {},
              Description: {},
              LocationUri: {},
              RetrievalRoleArn: {},
              Validators: {
                shape: "Sd"
              },
              Tags: {
                shape: "S4"
              },
              Type: {},
              KmsKeyIdentifier: {}
            }
          },
          output: {
            shape: "Sj"
          }
        },
        CreateDeploymentStrategy: {
          http: {
            requestUri: "/deploymentstrategies",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "DeploymentDurationInMinutes",
              "GrowthFactor"
            ],
            members: {
              Name: {},
              Description: {},
              DeploymentDurationInMinutes: {
                type: "integer"
              },
              FinalBakeTimeInMinutes: {
                type: "integer"
              },
              GrowthFactor: {
                type: "float"
              },
              GrowthType: {},
              ReplicateTo: {},
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            shape: "Sq"
          }
        },
        CreateEnvironment: {
          http: {
            requestUri: "/applications/{ApplicationId}/environments",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "Name"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              Name: {},
              Description: {},
              Monitors: {
                shape: "St"
              },
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            shape: "Sw"
          }
        },
        CreateExtension: {
          http: {
            requestUri: "/extensions",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "Actions"
            ],
            members: {
              Name: {},
              Description: {},
              Actions: {
                shape: "S10"
              },
              Parameters: {
                shape: "S14"
              },
              Tags: {
                shape: "S4"
              },
              LatestVersionNumber: {
                location: "header",
                locationName: "Latest-Version-Number",
                type: "integer"
              }
            }
          },
          output: {
            shape: "S18"
          }
        },
        CreateExtensionAssociation: {
          http: {
            requestUri: "/extensionassociations",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ExtensionIdentifier",
              "ResourceIdentifier"
            ],
            members: {
              ExtensionIdentifier: {},
              ExtensionVersionNumber: {
                type: "integer"
              },
              ResourceIdentifier: {},
              Parameters: {
                shape: "S1b"
              },
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            shape: "S1c"
          }
        },
        CreateHostedConfigurationVersion: {
          http: {
            requestUri: "/applications/{ApplicationId}/configurationprofiles/{ConfigurationProfileId}/hostedconfigurationversions",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "ConfigurationProfileId",
              "Content",
              "ContentType"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              ConfigurationProfileId: {
                location: "uri",
                locationName: "ConfigurationProfileId"
              },
              Description: {
                location: "header",
                locationName: "Description"
              },
              Content: {
                shape: "S1e"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              LatestVersionNumber: {
                location: "header",
                locationName: "Latest-Version-Number",
                type: "integer"
              },
              VersionLabel: {
                location: "header",
                locationName: "VersionLabel"
              }
            },
            payload: "Content"
          },
          output: {
            shape: "S1h"
          }
        },
        DeleteApplication: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{ApplicationId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              }
            }
          }
        },
        DeleteConfigurationProfile: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{ApplicationId}/configurationprofiles/{ConfigurationProfileId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "ConfigurationProfileId"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              ConfigurationProfileId: {
                location: "uri",
                locationName: "ConfigurationProfileId"
              }
            }
          }
        },
        DeleteDeploymentStrategy: {
          http: {
            method: "DELETE",
            requestUri: "/deployementstrategies/{DeploymentStrategyId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "DeploymentStrategyId"
            ],
            members: {
              DeploymentStrategyId: {
                location: "uri",
                locationName: "DeploymentStrategyId"
              }
            }
          }
        },
        DeleteEnvironment: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{ApplicationId}/environments/{EnvironmentId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "EnvironmentId"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              EnvironmentId: {
                location: "uri",
                locationName: "EnvironmentId"
              }
            }
          }
        },
        DeleteExtension: {
          http: {
            method: "DELETE",
            requestUri: "/extensions/{ExtensionIdentifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ExtensionIdentifier"
            ],
            members: {
              ExtensionIdentifier: {
                location: "uri",
                locationName: "ExtensionIdentifier"
              },
              VersionNumber: {
                location: "querystring",
                locationName: "version",
                type: "integer"
              }
            }
          }
        },
        DeleteExtensionAssociation: {
          http: {
            method: "DELETE",
            requestUri: "/extensionassociations/{ExtensionAssociationId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ExtensionAssociationId"
            ],
            members: {
              ExtensionAssociationId: {
                location: "uri",
                locationName: "ExtensionAssociationId"
              }
            }
          }
        },
        DeleteHostedConfigurationVersion: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{ApplicationId}/configurationprofiles/{ConfigurationProfileId}/hostedconfigurationversions/{VersionNumber}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "ConfigurationProfileId",
              "VersionNumber"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              ConfigurationProfileId: {
                location: "uri",
                locationName: "ConfigurationProfileId"
              },
              VersionNumber: {
                location: "uri",
                locationName: "VersionNumber",
                type: "integer"
              }
            }
          }
        },
        GetApplication: {
          http: {
            method: "GET",
            requestUri: "/applications/{ApplicationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              }
            }
          },
          output: {
            shape: "S7"
          }
        },
        GetConfiguration: {
          http: {
            method: "GET",
            requestUri: "/applications/{Application}/environments/{Environment}/configurations/{Configuration}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Application",
              "Environment",
              "Configuration",
              "ClientId"
            ],
            members: {
              Application: {
                location: "uri",
                locationName: "Application"
              },
              Environment: {
                location: "uri",
                locationName: "Environment"
              },
              Configuration: {
                location: "uri",
                locationName: "Configuration"
              },
              ClientId: {
                location: "querystring",
                locationName: "client_id"
              },
              ClientConfigurationVersion: {
                location: "querystring",
                locationName: "client_configuration_version"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Content: {
                shape: "S1e"
              },
              ConfigurationVersion: {
                location: "header",
                locationName: "Configuration-Version"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              }
            },
            payload: "Content"
          },
          deprecated: true,
          deprecatedMessage: "This API has been deprecated in favor of the GetLatestConfiguration API used in conjunction with StartConfigurationSession."
        },
        GetConfigurationProfile: {
          http: {
            method: "GET",
            requestUri: "/applications/{ApplicationId}/configurationprofiles/{ConfigurationProfileId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "ConfigurationProfileId"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              ConfigurationProfileId: {
                location: "uri",
                locationName: "ConfigurationProfileId"
              }
            }
          },
          output: {
            shape: "Sj"
          }
        },
        GetDeployment: {
          http: {
            method: "GET",
            requestUri: "/applications/{ApplicationId}/environments/{EnvironmentId}/deployments/{DeploymentNumber}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "EnvironmentId",
              "DeploymentNumber"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              EnvironmentId: {
                location: "uri",
                locationName: "EnvironmentId"
              },
              DeploymentNumber: {
                location: "uri",
                locationName: "DeploymentNumber",
                type: "integer"
              }
            }
          },
          output: {
            shape: "S1y"
          }
        },
        GetDeploymentStrategy: {
          http: {
            method: "GET",
            requestUri: "/deploymentstrategies/{DeploymentStrategyId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DeploymentStrategyId"
            ],
            members: {
              DeploymentStrategyId: {
                location: "uri",
                locationName: "DeploymentStrategyId"
              }
            }
          },
          output: {
            shape: "Sq"
          }
        },
        GetEnvironment: {
          http: {
            method: "GET",
            requestUri: "/applications/{ApplicationId}/environments/{EnvironmentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "EnvironmentId"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              EnvironmentId: {
                location: "uri",
                locationName: "EnvironmentId"
              }
            }
          },
          output: {
            shape: "Sw"
          }
        },
        GetExtension: {
          http: {
            method: "GET",
            requestUri: "/extensions/{ExtensionIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ExtensionIdentifier"
            ],
            members: {
              ExtensionIdentifier: {
                location: "uri",
                locationName: "ExtensionIdentifier"
              },
              VersionNumber: {
                location: "querystring",
                locationName: "version_number",
                type: "integer"
              }
            }
          },
          output: {
            shape: "S18"
          }
        },
        GetExtensionAssociation: {
          http: {
            method: "GET",
            requestUri: "/extensionassociations/{ExtensionAssociationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ExtensionAssociationId"
            ],
            members: {
              ExtensionAssociationId: {
                location: "uri",
                locationName: "ExtensionAssociationId"
              }
            }
          },
          output: {
            shape: "S1c"
          }
        },
        GetHostedConfigurationVersion: {
          http: {
            method: "GET",
            requestUri: "/applications/{ApplicationId}/configurationprofiles/{ConfigurationProfileId}/hostedconfigurationversions/{VersionNumber}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "ConfigurationProfileId",
              "VersionNumber"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              ConfigurationProfileId: {
                location: "uri",
                locationName: "ConfigurationProfileId"
              },
              VersionNumber: {
                location: "uri",
                locationName: "VersionNumber",
                type: "integer"
              }
            }
          },
          output: {
            shape: "S1h"
          }
        },
        ListApplications: {
          http: {
            method: "GET",
            requestUri: "/applications",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "max_results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next_token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  shape: "S7"
                }
              },
              NextToken: {}
            }
          }
        },
        ListConfigurationProfiles: {
          http: {
            method: "GET",
            requestUri: "/applications/{ApplicationId}/configurationprofiles",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max_results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next_token"
              },
              Type: {
                location: "querystring",
                locationName: "type"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApplicationId: {},
                    Id: {},
                    Name: {},
                    LocationUri: {},
                    ValidatorTypes: {
                      type: "list",
                      member: {}
                    },
                    Type: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDeploymentStrategies: {
          http: {
            method: "GET",
            requestUri: "/deploymentstrategies",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "max_results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next_token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  shape: "Sq"
                }
              },
              NextToken: {}
            }
          }
        },
        ListDeployments: {
          http: {
            method: "GET",
            requestUri: "/applications/{ApplicationId}/environments/{EnvironmentId}/deployments",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "EnvironmentId"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              EnvironmentId: {
                location: "uri",
                locationName: "EnvironmentId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max_results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next_token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DeploymentNumber: {
                      type: "integer"
                    },
                    ConfigurationName: {},
                    ConfigurationVersion: {},
                    DeploymentDurationInMinutes: {
                      type: "integer"
                    },
                    GrowthType: {},
                    GrowthFactor: {
                      type: "float"
                    },
                    FinalBakeTimeInMinutes: {
                      type: "integer"
                    },
                    State: {},
                    PercentageComplete: {
                      type: "float"
                    },
                    StartedAt: {
                      shape: "S26"
                    },
                    CompletedAt: {
                      shape: "S26"
                    },
                    VersionLabel: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEnvironments: {
          http: {
            method: "GET",
            requestUri: "/applications/{ApplicationId}/environments",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max_results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next_token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  shape: "Sw"
                }
              },
              NextToken: {}
            }
          }
        },
        ListExtensionAssociations: {
          http: {
            method: "GET",
            requestUri: "/extensionassociations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceIdentifier: {
                location: "querystring",
                locationName: "resource_identifier"
              },
              ExtensionIdentifier: {
                location: "querystring",
                locationName: "extension_identifier"
              },
              ExtensionVersionNumber: {
                location: "querystring",
                locationName: "extension_version_number",
                type: "integer"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max_results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next_token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    ExtensionArn: {},
                    ResourceArn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListExtensions: {
          http: {
            method: "GET",
            requestUri: "/extensions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "max_results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next_token"
              },
              Name: {
                location: "querystring",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Name: {},
                    VersionNumber: {
                      type: "integer"
                    },
                    Arn: {},
                    Description: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListHostedConfigurationVersions: {
          http: {
            method: "GET",
            requestUri: "/applications/{ApplicationId}/configurationprofiles/{ConfigurationProfileId}/hostedconfigurationversions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "ConfigurationProfileId"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              ConfigurationProfileId: {
                location: "uri",
                locationName: "ConfigurationProfileId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max_results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next_token"
              },
              VersionLabel: {
                location: "querystring",
                locationName: "version_label"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApplicationId: {},
                    ConfigurationProfileId: {},
                    VersionNumber: {
                      type: "integer"
                    },
                    Description: {},
                    ContentType: {},
                    VersionLabel: {},
                    KmsKeyArn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S4"
              }
            }
          }
        },
        StartDeployment: {
          http: {
            requestUri: "/applications/{ApplicationId}/environments/{EnvironmentId}/deployments",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "EnvironmentId",
              "DeploymentStrategyId",
              "ConfigurationProfileId",
              "ConfigurationVersion"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              EnvironmentId: {
                location: "uri",
                locationName: "EnvironmentId"
              },
              DeploymentStrategyId: {},
              ConfigurationProfileId: {},
              ConfigurationVersion: {},
              Description: {},
              Tags: {
                shape: "S4"
              },
              KmsKeyIdentifier: {}
            }
          },
          output: {
            shape: "S1y"
          }
        },
        StopDeployment: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{ApplicationId}/environments/{EnvironmentId}/deployments/{DeploymentNumber}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "EnvironmentId",
              "DeploymentNumber"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              EnvironmentId: {
                location: "uri",
                locationName: "EnvironmentId"
              },
              DeploymentNumber: {
                location: "uri",
                locationName: "DeploymentNumber",
                type: "integer"
              }
            }
          },
          output: {
            shape: "S1y"
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{ResourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "S4"
              }
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          }
        },
        UpdateApplication: {
          http: {
            method: "PATCH",
            requestUri: "/applications/{ApplicationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              Name: {},
              Description: {}
            }
          },
          output: {
            shape: "S7"
          }
        },
        UpdateConfigurationProfile: {
          http: {
            method: "PATCH",
            requestUri: "/applications/{ApplicationId}/configurationprofiles/{ConfigurationProfileId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "ConfigurationProfileId"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              ConfigurationProfileId: {
                location: "uri",
                locationName: "ConfigurationProfileId"
              },
              Name: {},
              Description: {},
              RetrievalRoleArn: {},
              Validators: {
                shape: "Sd"
              },
              KmsKeyIdentifier: {}
            }
          },
          output: {
            shape: "Sj"
          }
        },
        UpdateDeploymentStrategy: {
          http: {
            method: "PATCH",
            requestUri: "/deploymentstrategies/{DeploymentStrategyId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DeploymentStrategyId"
            ],
            members: {
              DeploymentStrategyId: {
                location: "uri",
                locationName: "DeploymentStrategyId"
              },
              Description: {},
              DeploymentDurationInMinutes: {
                type: "integer"
              },
              FinalBakeTimeInMinutes: {
                type: "integer"
              },
              GrowthFactor: {
                type: "float"
              },
              GrowthType: {}
            }
          },
          output: {
            shape: "Sq"
          }
        },
        UpdateEnvironment: {
          http: {
            method: "PATCH",
            requestUri: "/applications/{ApplicationId}/environments/{EnvironmentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "EnvironmentId"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              EnvironmentId: {
                location: "uri",
                locationName: "EnvironmentId"
              },
              Name: {},
              Description: {},
              Monitors: {
                shape: "St"
              }
            }
          },
          output: {
            shape: "Sw"
          }
        },
        UpdateExtension: {
          http: {
            method: "PATCH",
            requestUri: "/extensions/{ExtensionIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ExtensionIdentifier"
            ],
            members: {
              ExtensionIdentifier: {
                location: "uri",
                locationName: "ExtensionIdentifier"
              },
              Description: {},
              Actions: {
                shape: "S10"
              },
              Parameters: {
                shape: "S14"
              },
              VersionNumber: {
                type: "integer"
              }
            }
          },
          output: {
            shape: "S18"
          }
        },
        UpdateExtensionAssociation: {
          http: {
            method: "PATCH",
            requestUri: "/extensionassociations/{ExtensionAssociationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ExtensionAssociationId"
            ],
            members: {
              ExtensionAssociationId: {
                location: "uri",
                locationName: "ExtensionAssociationId"
              },
              Parameters: {
                shape: "S1b"
              }
            }
          },
          output: {
            shape: "S1c"
          }
        },
        ValidateConfiguration: {
          http: {
            requestUri: "/applications/{ApplicationId}/configurationprofiles/{ConfigurationProfileId}/validators",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "ConfigurationProfileId",
              "ConfigurationVersion"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              ConfigurationProfileId: {
                location: "uri",
                locationName: "ConfigurationProfileId"
              },
              ConfigurationVersion: {
                location: "querystring",
                locationName: "configuration_version"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "map",
          key: {},
          value: {}
        },
        S7: {
          type: "structure",
          members: {
            Id: {},
            Name: {},
            Description: {}
          }
        },
        Sd: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Type",
              "Content"
            ],
            members: {
              Type: {},
              Content: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        Sj: {
          type: "structure",
          members: {
            ApplicationId: {},
            Id: {},
            Name: {},
            Description: {},
            LocationUri: {},
            RetrievalRoleArn: {},
            Validators: {
              shape: "Sd"
            },
            Type: {},
            KmsKeyArn: {},
            KmsKeyIdentifier: {}
          }
        },
        Sq: {
          type: "structure",
          members: {
            Id: {},
            Name: {},
            Description: {},
            DeploymentDurationInMinutes: {
              type: "integer"
            },
            GrowthType: {},
            GrowthFactor: {
              type: "float"
            },
            FinalBakeTimeInMinutes: {
              type: "integer"
            },
            ReplicateTo: {}
          }
        },
        St: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AlarmArn"
            ],
            members: {
              AlarmArn: {},
              AlarmRoleArn: {}
            }
          }
        },
        Sw: {
          type: "structure",
          members: {
            ApplicationId: {},
            Id: {},
            Name: {},
            Description: {},
            State: {},
            Monitors: {
              shape: "St"
            }
          }
        },
        S10: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {
              type: "structure",
              members: {
                Name: {},
                Description: {},
                Uri: {},
                RoleArn: {}
              }
            }
          }
        },
        S14: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              Description: {},
              Required: {
                type: "boolean"
              }
            }
          }
        },
        S18: {
          type: "structure",
          members: {
            Id: {},
            Name: {},
            VersionNumber: {
              type: "integer"
            },
            Arn: {},
            Description: {},
            Actions: {
              shape: "S10"
            },
            Parameters: {
              shape: "S14"
            }
          }
        },
        S1b: {
          type: "map",
          key: {},
          value: {}
        },
        S1c: {
          type: "structure",
          members: {
            Id: {},
            ExtensionArn: {},
            ResourceArn: {},
            Arn: {},
            Parameters: {
              shape: "S1b"
            },
            ExtensionVersionNumber: {
              type: "integer"
            }
          }
        },
        S1e: {
          type: "blob",
          sensitive: true
        },
        S1h: {
          type: "structure",
          members: {
            ApplicationId: {
              location: "header",
              locationName: "Application-Id"
            },
            ConfigurationProfileId: {
              location: "header",
              locationName: "Configuration-Profile-Id"
            },
            VersionNumber: {
              location: "header",
              locationName: "Version-Number",
              type: "integer"
            },
            Description: {
              location: "header",
              locationName: "Description"
            },
            Content: {
              shape: "S1e"
            },
            ContentType: {
              location: "header",
              locationName: "Content-Type"
            },
            VersionLabel: {
              location: "header",
              locationName: "VersionLabel"
            },
            KmsKeyArn: {
              location: "header",
              locationName: "KmsKeyArn"
            }
          },
          payload: "Content"
        },
        S1y: {
          type: "structure",
          members: {
            ApplicationId: {},
            EnvironmentId: {},
            DeploymentStrategyId: {},
            ConfigurationProfileId: {},
            DeploymentNumber: {
              type: "integer"
            },
            ConfigurationName: {},
            ConfigurationLocationUri: {},
            ConfigurationVersion: {},
            Description: {},
            DeploymentDurationInMinutes: {
              type: "integer"
            },
            GrowthType: {},
            GrowthFactor: {
              type: "float"
            },
            FinalBakeTimeInMinutes: {
              type: "integer"
            },
            State: {},
            EventLog: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  EventType: {},
                  TriggeredBy: {},
                  Description: {},
                  ActionInvocations: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        ExtensionIdentifier: {},
                        ActionName: {},
                        Uri: {},
                        RoleArn: {},
                        ErrorMessage: {},
                        ErrorCode: {},
                        InvocationId: {}
                      }
                    }
                  },
                  OccurredAt: {
                    shape: "S26"
                  }
                }
              }
            },
            PercentageComplete: {
              type: "float"
            },
            StartedAt: {
              shape: "S26"
            },
            CompletedAt: {
              shape: "S26"
            },
            AppliedExtensions: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  ExtensionId: {},
                  ExtensionAssociationId: {},
                  VersionNumber: {
                    type: "integer"
                  },
                  Parameters: {
                    shape: "S1b"
                  }
                }
              }
            },
            KmsKeyArn: {},
            KmsKeyIdentifier: {},
            VersionLabel: {}
          }
        },
        S26: {
          type: "timestamp",
          timestampFormat: "iso8601"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/appconfig-2019-10-09.paginators.json
var require_appconfig_2019_10_09_paginators = __commonJS({
  "node_modules/aws-sdk/apis/appconfig-2019-10-09.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListApplications: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Items"
        },
        ListConfigurationProfiles: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Items"
        },
        ListDeploymentStrategies: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Items"
        },
        ListDeployments: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Items"
        },
        ListEnvironments: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Items"
        },
        ListExtensionAssociations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Items"
        },
        ListExtensions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Items"
        },
        ListHostedConfigurationVersions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/appconfig.js
var require_appconfig = __commonJS({
  "node_modules/aws-sdk/clients/appconfig.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["appconfig"] = {};
    AWS2.AppConfig = Service.defineService("appconfig", ["2019-10-09"]);
    Object.defineProperty(apiLoader.services["appconfig"], "2019-10-09", {
      get: function get() {
        var model = require_appconfig_2019_10_09_min();
        model.paginators = require_appconfig_2019_10_09_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.AppConfig;
  }
});

// node_modules/aws-sdk/apis/iotsecuretunneling-2018-10-05.min.json
var require_iotsecuretunneling_2018_10_05_min = __commonJS({
  "node_modules/aws-sdk/apis/iotsecuretunneling-2018-10-05.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-10-05",
        endpointPrefix: "api.tunneling.iot",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS IoT Secure Tunneling",
        serviceId: "IoTSecureTunneling",
        signatureVersion: "v4",
        signingName: "IoTSecuredTunneling",
        targetPrefix: "IoTSecuredTunneling",
        uid: "iotsecuretunneling-2018-10-05"
      },
      operations: {
        CloseTunnel: {
          input: {
            type: "structure",
            required: [
              "tunnelId"
            ],
            members: {
              tunnelId: {},
              delete: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeTunnel: {
          input: {
            type: "structure",
            required: [
              "tunnelId"
            ],
            members: {
              tunnelId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tunnel: {
                type: "structure",
                members: {
                  tunnelId: {},
                  tunnelArn: {},
                  status: {},
                  sourceConnectionState: {
                    shape: "Sa"
                  },
                  destinationConnectionState: {
                    shape: "Sa"
                  },
                  description: {},
                  destinationConfig: {
                    shape: "Se"
                  },
                  timeoutConfig: {
                    shape: "Si"
                  },
                  tags: {
                    shape: "Sk"
                  },
                  createdAt: {
                    type: "timestamp"
                  },
                  lastUpdatedAt: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sk"
              }
            }
          }
        },
        ListTunnels: {
          input: {
            type: "structure",
            members: {
              thingName: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tunnelSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    tunnelId: {},
                    tunnelArn: {},
                    status: {},
                    description: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        OpenTunnel: {
          input: {
            type: "structure",
            members: {
              description: {},
              tags: {
                shape: "Sk"
              },
              destinationConfig: {
                shape: "Se"
              },
              timeoutConfig: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tunnelId: {},
              tunnelArn: {},
              sourceAccessToken: {
                shape: "Sz"
              },
              destinationAccessToken: {
                shape: "Sz"
              }
            }
          }
        },
        RotateTunnelAccessToken: {
          input: {
            type: "structure",
            required: [
              "tunnelId",
              "clientMode"
            ],
            members: {
              tunnelId: {},
              clientMode: {},
              destinationConfig: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tunnelArn: {},
              sourceAccessToken: {
                shape: "Sz"
              },
              destinationAccessToken: {
                shape: "Sz"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        Sa: {
          type: "structure",
          members: {
            status: {},
            lastUpdatedAt: {
              type: "timestamp"
            }
          }
        },
        Se: {
          type: "structure",
          required: [
            "services"
          ],
          members: {
            thingName: {},
            services: {
              type: "list",
              member: {}
            }
          }
        },
        Si: {
          type: "structure",
          members: {
            maxLifetimeTimeoutMinutes: {
              type: "integer"
            }
          }
        },
        Sk: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        Sz: {
          type: "string",
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iotsecuretunneling-2018-10-05.paginators.json
var require_iotsecuretunneling_2018_10_05_paginators = __commonJS({
  "node_modules/aws-sdk/apis/iotsecuretunneling-2018-10-05.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListTunnels: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/iotsecuretunneling.js
var require_iotsecuretunneling = __commonJS({
  "node_modules/aws-sdk/clients/iotsecuretunneling.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["iotsecuretunneling"] = {};
    AWS2.IoTSecureTunneling = Service.defineService("iotsecuretunneling", ["2018-10-05"]);
    Object.defineProperty(apiLoader.services["iotsecuretunneling"], "2018-10-05", {
      get: function get() {
        var model = require_iotsecuretunneling_2018_10_05_min();
        model.paginators = require_iotsecuretunneling_2018_10_05_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.IoTSecureTunneling;
  }
});

// node_modules/aws-sdk/apis/wafv2-2019-07-29.min.json
var require_wafv2_2019_07_29_min = __commonJS({
  "node_modules/aws-sdk/apis/wafv2-2019-07-29.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-07-29",
        endpointPrefix: "wafv2",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "WAFV2",
        serviceFullName: "AWS WAFV2",
        serviceId: "WAFV2",
        signatureVersion: "v4",
        targetPrefix: "AWSWAF_20190729",
        uid: "wafv2-2019-07-29"
      },
      operations: {
        AssociateWebACL: {
          input: {
            type: "structure",
            required: [
              "WebACLArn",
              "ResourceArn"
            ],
            members: {
              WebACLArn: {},
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CheckCapacity: {
          input: {
            type: "structure",
            required: [
              "Scope",
              "Rules"
            ],
            members: {
              Scope: {},
              Rules: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Capacity: {
                type: "long"
              }
            }
          }
        },
        CreateAPIKey: {
          input: {
            type: "structure",
            required: [
              "Scope",
              "TokenDomains"
            ],
            members: {
              Scope: {},
              TokenDomains: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              APIKey: {}
            }
          }
        },
        CreateIPSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "IPAddressVersion",
              "Addresses"
            ],
            members: {
              Name: {},
              Scope: {},
              Description: {},
              IPAddressVersion: {},
              Addresses: {
                shape: "S4n"
              },
              Tags: {
                shape: "S4p"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Summary: {
                shape: "S4u"
              }
            }
          }
        },
        CreateRegexPatternSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "RegularExpressionList"
            ],
            members: {
              Name: {},
              Scope: {},
              Description: {},
              RegularExpressionList: {
                shape: "S4y"
              },
              Tags: {
                shape: "S4p"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Summary: {
                shape: "S51"
              }
            }
          }
        },
        CreateRuleGroup: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "Capacity",
              "VisibilityConfig"
            ],
            members: {
              Name: {},
              Scope: {},
              Capacity: {
                type: "long"
              },
              Description: {},
              Rules: {
                shape: "S6"
              },
              VisibilityConfig: {
                shape: "S47"
              },
              Tags: {
                shape: "S4p"
              },
              CustomResponseBodies: {
                shape: "S54"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Summary: {
                shape: "S59"
              }
            }
          }
        },
        CreateWebACL: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "DefaultAction",
              "VisibilityConfig"
            ],
            members: {
              Name: {},
              Scope: {},
              DefaultAction: {
                shape: "S5b"
              },
              Description: {},
              Rules: {
                shape: "S6"
              },
              VisibilityConfig: {
                shape: "S47"
              },
              Tags: {
                shape: "S4p"
              },
              CustomResponseBodies: {
                shape: "S54"
              },
              CaptchaConfig: {
                shape: "S49"
              },
              ChallengeConfig: {
                shape: "S4c"
              },
              TokenDomains: {
                shape: "S5c"
              },
              AssociationConfig: {
                shape: "S5d"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Summary: {
                shape: "S5j"
              }
            }
          }
        },
        DeleteFirewallManagerRuleGroups: {
          input: {
            type: "structure",
            required: [
              "WebACLArn",
              "WebACLLockToken"
            ],
            members: {
              WebACLArn: {},
              WebACLLockToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextWebACLLockToken: {}
            }
          }
        },
        DeleteIPSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "Id",
              "LockToken"
            ],
            members: {
              Name: {},
              Scope: {},
              Id: {},
              LockToken: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteLoggingConfiguration: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeletePermissionPolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRegexPatternSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "Id",
              "LockToken"
            ],
            members: {
              Name: {},
              Scope: {},
              Id: {},
              LockToken: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRuleGroup: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "Id",
              "LockToken"
            ],
            members: {
              Name: {},
              Scope: {},
              Id: {},
              LockToken: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteWebACL: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "Id",
              "LockToken"
            ],
            members: {
              Name: {},
              Scope: {},
              Id: {},
              LockToken: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeAllManagedProducts: {
          input: {
            type: "structure",
            required: [
              "Scope"
            ],
            members: {
              Scope: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ManagedProducts: {
                shape: "S60"
              }
            }
          }
        },
        DescribeManagedProductsByVendor: {
          input: {
            type: "structure",
            required: [
              "VendorName",
              "Scope"
            ],
            members: {
              VendorName: {},
              Scope: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ManagedProducts: {
                shape: "S60"
              }
            }
          }
        },
        DescribeManagedRuleGroup: {
          input: {
            type: "structure",
            required: [
              "VendorName",
              "Name",
              "Scope"
            ],
            members: {
              VendorName: {},
              Name: {},
              Scope: {},
              VersionName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VersionName: {},
              SnsTopicArn: {},
              Capacity: {
                type: "long"
              },
              Rules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Action: {
                      shape: "S1q"
                    }
                  }
                }
              },
              LabelNamespace: {},
              AvailableLabels: {
                shape: "S6c"
              },
              ConsumedLabels: {
                shape: "S6c"
              }
            }
          }
        },
        DisassociateWebACL: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GenerateMobileSdkReleaseUrl: {
          input: {
            type: "structure",
            required: [
              "Platform",
              "ReleaseVersion"
            ],
            members: {
              Platform: {},
              ReleaseVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Url: {}
            }
          }
        },
        GetDecryptedAPIKey: {
          input: {
            type: "structure",
            required: [
              "Scope",
              "APIKey"
            ],
            members: {
              Scope: {},
              APIKey: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TokenDomains: {
                shape: "S5c"
              },
              CreationTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        GetIPSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "Id"
            ],
            members: {
              Name: {},
              Scope: {},
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IPSet: {
                type: "structure",
                required: [
                  "Name",
                  "Id",
                  "ARN",
                  "IPAddressVersion",
                  "Addresses"
                ],
                members: {
                  Name: {},
                  Id: {},
                  ARN: {},
                  Description: {},
                  IPAddressVersion: {},
                  Addresses: {
                    shape: "S4n"
                  }
                }
              },
              LockToken: {}
            }
          }
        },
        GetLoggingConfiguration: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LoggingConfiguration: {
                shape: "S6s"
              }
            }
          }
        },
        GetManagedRuleSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "Id"
            ],
            members: {
              Name: {},
              Scope: {},
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ManagedRuleSet: {
                type: "structure",
                required: [
                  "Name",
                  "Id",
                  "ARN"
                ],
                members: {
                  Name: {},
                  Id: {},
                  ARN: {},
                  Description: {},
                  PublishedVersions: {
                    type: "map",
                    key: {},
                    value: {
                      type: "structure",
                      members: {
                        AssociatedRuleGroupArn: {},
                        Capacity: {
                          type: "long"
                        },
                        ForecastedLifetime: {
                          type: "integer"
                        },
                        PublishTimestamp: {
                          type: "timestamp"
                        },
                        LastUpdateTimestamp: {
                          type: "timestamp"
                        },
                        ExpiryTimestamp: {
                          type: "timestamp"
                        }
                      }
                    }
                  },
                  RecommendedVersion: {},
                  LabelNamespace: {}
                }
              },
              LockToken: {}
            }
          }
        },
        GetMobileSdkRelease: {
          input: {
            type: "structure",
            required: [
              "Platform",
              "ReleaseVersion"
            ],
            members: {
              Platform: {},
              ReleaseVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MobileSdkRelease: {
                type: "structure",
                members: {
                  ReleaseVersion: {},
                  Timestamp: {
                    type: "timestamp"
                  },
                  ReleaseNotes: {},
                  Tags: {
                    shape: "S4p"
                  }
                }
              }
            }
          }
        },
        GetPermissionPolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {}
            }
          }
        },
        GetRateBasedStatementManagedKeys: {
          input: {
            type: "structure",
            required: [
              "Scope",
              "WebACLName",
              "WebACLId",
              "RuleName"
            ],
            members: {
              Scope: {},
              WebACLName: {},
              WebACLId: {},
              RuleGroupRuleName: {},
              RuleName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ManagedKeysIPV4: {
                shape: "S7k"
              },
              ManagedKeysIPV6: {
                shape: "S7k"
              }
            }
          }
        },
        GetRegexPatternSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "Id"
            ],
            members: {
              Name: {},
              Scope: {},
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RegexPatternSet: {
                type: "structure",
                members: {
                  Name: {},
                  Id: {},
                  ARN: {},
                  Description: {},
                  RegularExpressionList: {
                    shape: "S4y"
                  }
                }
              },
              LockToken: {}
            }
          }
        },
        GetRuleGroup: {
          input: {
            type: "structure",
            members: {
              Name: {},
              Scope: {},
              Id: {},
              ARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RuleGroup: {
                type: "structure",
                required: [
                  "Name",
                  "Id",
                  "Capacity",
                  "ARN",
                  "VisibilityConfig"
                ],
                members: {
                  Name: {},
                  Id: {},
                  Capacity: {
                    type: "long"
                  },
                  ARN: {},
                  Description: {},
                  Rules: {
                    shape: "S6"
                  },
                  VisibilityConfig: {
                    shape: "S47"
                  },
                  LabelNamespace: {},
                  CustomResponseBodies: {
                    shape: "S54"
                  },
                  AvailableLabels: {
                    shape: "S6c"
                  },
                  ConsumedLabels: {
                    shape: "S6c"
                  }
                }
              },
              LockToken: {}
            }
          }
        },
        GetSampledRequests: {
          input: {
            type: "structure",
            required: [
              "WebAclArn",
              "RuleMetricName",
              "Scope",
              "TimeWindow",
              "MaxItems"
            ],
            members: {
              WebAclArn: {},
              RuleMetricName: {},
              Scope: {},
              TimeWindow: {
                shape: "S7s"
              },
              MaxItems: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SampledRequests: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Request",
                    "Weight"
                  ],
                  members: {
                    Request: {
                      type: "structure",
                      members: {
                        ClientIP: {},
                        Country: {},
                        URI: {},
                        Method: {},
                        HTTPVersion: {},
                        Headers: {
                          shape: "S83"
                        }
                      }
                    },
                    Weight: {
                      type: "long"
                    },
                    Timestamp: {
                      type: "timestamp"
                    },
                    Action: {},
                    RuleNameWithinRuleGroup: {},
                    RequestHeadersInserted: {
                      shape: "S83"
                    },
                    ResponseCodeSent: {
                      type: "integer"
                    },
                    Labels: {
                      shape: "S44"
                    },
                    CaptchaResponse: {
                      type: "structure",
                      members: {
                        ResponseCode: {
                          type: "integer"
                        },
                        SolveTimestamp: {
                          type: "long"
                        },
                        FailureReason: {}
                      }
                    },
                    ChallengeResponse: {
                      type: "structure",
                      members: {
                        ResponseCode: {
                          type: "integer"
                        },
                        SolveTimestamp: {
                          type: "long"
                        },
                        FailureReason: {}
                      }
                    },
                    OverriddenAction: {}
                  }
                }
              },
              PopulationSize: {
                type: "long"
              },
              TimeWindow: {
                shape: "S7s"
              }
            }
          }
        },
        GetWebACL: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "Id"
            ],
            members: {
              Name: {},
              Scope: {},
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WebACL: {
                shape: "S8h"
              },
              LockToken: {},
              ApplicationIntegrationURL: {}
            }
          }
        },
        GetWebACLForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WebACL: {
                shape: "S8h"
              }
            }
          }
        },
        ListAPIKeys: {
          input: {
            type: "structure",
            required: [
              "Scope"
            ],
            members: {
              Scope: {},
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              APIKeySummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TokenDomains: {
                      shape: "S5c"
                    },
                    APIKey: {},
                    CreationTimestamp: {
                      type: "timestamp"
                    },
                    Version: {
                      type: "integer"
                    }
                  }
                }
              },
              ApplicationIntegrationURL: {}
            }
          }
        },
        ListAvailableManagedRuleGroupVersions: {
          input: {
            type: "structure",
            required: [
              "VendorName",
              "Name",
              "Scope"
            ],
            members: {
              VendorName: {},
              Name: {},
              Scope: {},
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              Versions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    LastUpdateTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              CurrentDefaultVersion: {}
            }
          }
        },
        ListAvailableManagedRuleGroups: {
          input: {
            type: "structure",
            required: [
              "Scope"
            ],
            members: {
              Scope: {},
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              ManagedRuleGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    VendorName: {},
                    Name: {},
                    VersioningSupported: {
                      type: "boolean"
                    },
                    Description: {}
                  }
                }
              }
            }
          }
        },
        ListIPSets: {
          input: {
            type: "structure",
            required: [
              "Scope"
            ],
            members: {
              Scope: {},
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              IPSets: {
                type: "list",
                member: {
                  shape: "S4u"
                }
              }
            }
          }
        },
        ListLoggingConfigurations: {
          input: {
            type: "structure",
            required: [
              "Scope"
            ],
            members: {
              Scope: {},
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LoggingConfigurations: {
                type: "list",
                member: {
                  shape: "S6s"
                }
              },
              NextMarker: {}
            }
          }
        },
        ListManagedRuleSets: {
          input: {
            type: "structure",
            required: [
              "Scope"
            ],
            members: {
              Scope: {},
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              ManagedRuleSets: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Id: {},
                    Description: {},
                    LockToken: {},
                    ARN: {},
                    LabelNamespace: {}
                  }
                }
              }
            }
          }
        },
        ListMobileSdkReleases: {
          input: {
            type: "structure",
            required: [
              "Platform"
            ],
            members: {
              Platform: {},
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReleaseSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ReleaseVersion: {},
                    Timestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextMarker: {}
            }
          }
        },
        ListRegexPatternSets: {
          input: {
            type: "structure",
            required: [
              "Scope"
            ],
            members: {
              Scope: {},
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              RegexPatternSets: {
                type: "list",
                member: {
                  shape: "S51"
                }
              }
            }
          }
        },
        ListResourcesForWebACL: {
          input: {
            type: "structure",
            required: [
              "WebACLArn"
            ],
            members: {
              WebACLArn: {},
              ResourceType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceArns: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ListRuleGroups: {
          input: {
            type: "structure",
            required: [
              "Scope"
            ],
            members: {
              Scope: {},
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              RuleGroups: {
                type: "list",
                member: {
                  shape: "S59"
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              },
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              TagInfoForResource: {
                type: "structure",
                members: {
                  ResourceARN: {},
                  TagList: {
                    shape: "S4p"
                  }
                }
              }
            }
          }
        },
        ListWebACLs: {
          input: {
            type: "structure",
            required: [
              "Scope"
            ],
            members: {
              Scope: {},
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              WebACLs: {
                type: "list",
                member: {
                  shape: "S5j"
                }
              }
            }
          }
        },
        PutLoggingConfiguration: {
          input: {
            type: "structure",
            required: [
              "LoggingConfiguration"
            ],
            members: {
              LoggingConfiguration: {
                shape: "S6s"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LoggingConfiguration: {
                shape: "S6s"
              }
            }
          }
        },
        PutManagedRuleSetVersions: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "Id",
              "LockToken"
            ],
            members: {
              Name: {},
              Scope: {},
              Id: {},
              LockToken: {},
              RecommendedVersion: {},
              VersionsToPublish: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    AssociatedRuleGroupArn: {},
                    ForecastedLifetime: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextLockToken: {}
            }
          }
        },
        PutPermissionPolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Policy"
            ],
            members: {
              ResourceArn: {},
              Policy: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S4p"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateIPSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "Id",
              "Addresses",
              "LockToken"
            ],
            members: {
              Name: {},
              Scope: {},
              Id: {},
              Description: {},
              Addresses: {
                shape: "S4n"
              },
              LockToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextLockToken: {}
            }
          }
        },
        UpdateManagedRuleSetVersionExpiryDate: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "Id",
              "LockToken",
              "VersionToExpire",
              "ExpiryTimestamp"
            ],
            members: {
              Name: {},
              Scope: {},
              Id: {},
              LockToken: {},
              VersionToExpire: {},
              ExpiryTimestamp: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ExpiringVersion: {},
              ExpiryTimestamp: {
                type: "timestamp"
              },
              NextLockToken: {}
            }
          }
        },
        UpdateRegexPatternSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "Id",
              "RegularExpressionList",
              "LockToken"
            ],
            members: {
              Name: {},
              Scope: {},
              Id: {},
              Description: {},
              RegularExpressionList: {
                shape: "S4y"
              },
              LockToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextLockToken: {}
            }
          }
        },
        UpdateRuleGroup: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "Id",
              "VisibilityConfig",
              "LockToken"
            ],
            members: {
              Name: {},
              Scope: {},
              Id: {},
              Description: {},
              Rules: {
                shape: "S6"
              },
              VisibilityConfig: {
                shape: "S47"
              },
              LockToken: {},
              CustomResponseBodies: {
                shape: "S54"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextLockToken: {}
            }
          }
        },
        UpdateWebACL: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "Id",
              "DefaultAction",
              "VisibilityConfig",
              "LockToken"
            ],
            members: {
              Name: {},
              Scope: {},
              Id: {},
              DefaultAction: {
                shape: "S5b"
              },
              Description: {},
              Rules: {
                shape: "S6"
              },
              VisibilityConfig: {
                shape: "S47"
              },
              LockToken: {},
              CustomResponseBodies: {
                shape: "S54"
              },
              CaptchaConfig: {
                shape: "S49"
              },
              ChallengeConfig: {
                shape: "S4c"
              },
              TokenDomains: {
                shape: "S5c"
              },
              AssociationConfig: {
                shape: "S5d"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextLockToken: {}
            }
          }
        }
      },
      shapes: {
        S6: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Priority",
              "Statement",
              "VisibilityConfig"
            ],
            members: {
              Name: {},
              Priority: {
                type: "integer"
              },
              Statement: {
                shape: "Sa"
              },
              Action: {
                shape: "S1q"
              },
              OverrideAction: {
                shape: "S42"
              },
              RuleLabels: {
                shape: "S44"
              },
              VisibilityConfig: {
                shape: "S47"
              },
              CaptchaConfig: {
                shape: "S49"
              },
              ChallengeConfig: {
                shape: "S4c"
              }
            }
          }
        },
        Sa: {
          type: "structure",
          members: {
            ByteMatchStatement: {
              type: "structure",
              required: [
                "SearchString",
                "FieldToMatch",
                "TextTransformations",
                "PositionalConstraint"
              ],
              members: {
                SearchString: {
                  type: "blob"
                },
                FieldToMatch: {
                  shape: "Sd"
                },
                TextTransformations: {
                  shape: "S15"
                },
                PositionalConstraint: {}
              }
            },
            SqliMatchStatement: {
              type: "structure",
              required: [
                "FieldToMatch",
                "TextTransformations"
              ],
              members: {
                FieldToMatch: {
                  shape: "Sd"
                },
                TextTransformations: {
                  shape: "S15"
                },
                SensitivityLevel: {}
              }
            },
            XssMatchStatement: {
              type: "structure",
              required: [
                "FieldToMatch",
                "TextTransformations"
              ],
              members: {
                FieldToMatch: {
                  shape: "Sd"
                },
                TextTransformations: {
                  shape: "S15"
                }
              }
            },
            SizeConstraintStatement: {
              type: "structure",
              required: [
                "FieldToMatch",
                "ComparisonOperator",
                "Size",
                "TextTransformations"
              ],
              members: {
                FieldToMatch: {
                  shape: "Sd"
                },
                ComparisonOperator: {},
                Size: {
                  type: "long"
                },
                TextTransformations: {
                  shape: "S15"
                }
              }
            },
            GeoMatchStatement: {
              type: "structure",
              members: {
                CountryCodes: {
                  type: "list",
                  member: {}
                },
                ForwardedIPConfig: {
                  shape: "S1j"
                }
              }
            },
            RuleGroupReferenceStatement: {
              shape: "S1l"
            },
            IPSetReferenceStatement: {
              type: "structure",
              required: [
                "ARN"
              ],
              members: {
                ARN: {},
                IPSetForwardedIPConfig: {
                  type: "structure",
                  required: [
                    "HeaderName",
                    "FallbackBehavior",
                    "Position"
                  ],
                  members: {
                    HeaderName: {},
                    FallbackBehavior: {},
                    Position: {}
                  }
                }
              }
            },
            RegexPatternSetReferenceStatement: {
              type: "structure",
              required: [
                "ARN",
                "FieldToMatch",
                "TextTransformations"
              ],
              members: {
                ARN: {},
                FieldToMatch: {
                  shape: "Sd"
                },
                TextTransformations: {
                  shape: "S15"
                }
              }
            },
            RateBasedStatement: {
              type: "structure",
              required: [
                "Limit",
                "AggregateKeyType"
              ],
              members: {
                Limit: {
                  type: "long"
                },
                AggregateKeyType: {},
                ScopeDownStatement: {
                  shape: "Sa"
                },
                ForwardedIPConfig: {
                  shape: "S1j"
                },
                CustomKeys: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      Header: {
                        type: "structure",
                        required: [
                          "Name",
                          "TextTransformations"
                        ],
                        members: {
                          Name: {},
                          TextTransformations: {
                            shape: "S15"
                          }
                        }
                      },
                      Cookie: {
                        type: "structure",
                        required: [
                          "Name",
                          "TextTransformations"
                        ],
                        members: {
                          Name: {},
                          TextTransformations: {
                            shape: "S15"
                          }
                        }
                      },
                      QueryArgument: {
                        type: "structure",
                        required: [
                          "Name",
                          "TextTransformations"
                        ],
                        members: {
                          Name: {},
                          TextTransformations: {
                            shape: "S15"
                          }
                        }
                      },
                      QueryString: {
                        type: "structure",
                        required: [
                          "TextTransformations"
                        ],
                        members: {
                          TextTransformations: {
                            shape: "S15"
                          }
                        }
                      },
                      HTTPMethod: {
                        type: "structure",
                        members: {}
                      },
                      ForwardedIP: {
                        type: "structure",
                        members: {}
                      },
                      IP: {
                        type: "structure",
                        members: {}
                      },
                      LabelNamespace: {
                        type: "structure",
                        required: [
                          "Namespace"
                        ],
                        members: {
                          Namespace: {}
                        }
                      },
                      UriPath: {
                        type: "structure",
                        required: [
                          "TextTransformations"
                        ],
                        members: {
                          TextTransformations: {
                            shape: "S15"
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            AndStatement: {
              type: "structure",
              required: [
                "Statements"
              ],
              members: {
                Statements: {
                  shape: "S2n"
                }
              }
            },
            OrStatement: {
              type: "structure",
              required: [
                "Statements"
              ],
              members: {
                Statements: {
                  shape: "S2n"
                }
              }
            },
            NotStatement: {
              type: "structure",
              required: [
                "Statement"
              ],
              members: {
                Statement: {
                  shape: "Sa"
                }
              }
            },
            ManagedRuleGroupStatement: {
              shape: "S2q"
            },
            LabelMatchStatement: {
              type: "structure",
              required: [
                "Scope",
                "Key"
              ],
              members: {
                Scope: {},
                Key: {}
              }
            },
            RegexMatchStatement: {
              type: "structure",
              required: [
                "RegexString",
                "FieldToMatch",
                "TextTransformations"
              ],
              members: {
                RegexString: {},
                FieldToMatch: {
                  shape: "Sd"
                },
                TextTransformations: {
                  shape: "S15"
                }
              }
            }
          }
        },
        Sd: {
          type: "structure",
          members: {
            SingleHeader: {
              type: "structure",
              required: [
                "Name"
              ],
              members: {
                Name: {}
              }
            },
            SingleQueryArgument: {
              type: "structure",
              required: [
                "Name"
              ],
              members: {
                Name: {}
              }
            },
            AllQueryArguments: {
              type: "structure",
              members: {}
            },
            UriPath: {
              type: "structure",
              members: {}
            },
            QueryString: {
              type: "structure",
              members: {}
            },
            Body: {
              type: "structure",
              members: {
                OversizeHandling: {}
              }
            },
            Method: {
              type: "structure",
              members: {}
            },
            JsonBody: {
              type: "structure",
              required: [
                "MatchPattern",
                "MatchScope"
              ],
              members: {
                MatchPattern: {
                  type: "structure",
                  members: {
                    All: {
                      shape: "Sp"
                    },
                    IncludedPaths: {
                      type: "list",
                      member: {}
                    }
                  }
                },
                MatchScope: {},
                InvalidFallbackBehavior: {},
                OversizeHandling: {}
              }
            },
            Headers: {
              type: "structure",
              required: [
                "MatchPattern",
                "MatchScope",
                "OversizeHandling"
              ],
              members: {
                MatchPattern: {
                  type: "structure",
                  members: {
                    All: {
                      shape: "Sp"
                    },
                    IncludedHeaders: {
                      shape: "Sw"
                    },
                    ExcludedHeaders: {
                      shape: "Sw"
                    }
                  }
                },
                MatchScope: {},
                OversizeHandling: {}
              }
            },
            Cookies: {
              type: "structure",
              required: [
                "MatchPattern",
                "MatchScope",
                "OversizeHandling"
              ],
              members: {
                MatchPattern: {
                  type: "structure",
                  members: {
                    All: {
                      shape: "Sp"
                    },
                    IncludedCookies: {
                      shape: "S10"
                    },
                    ExcludedCookies: {
                      shape: "S10"
                    }
                  }
                },
                MatchScope: {},
                OversizeHandling: {}
              }
            },
            HeaderOrder: {
              type: "structure",
              required: [
                "OversizeHandling"
              ],
              members: {
                OversizeHandling: {}
              }
            },
            JA3Fingerprint: {
              type: "structure",
              required: [
                "FallbackBehavior"
              ],
              members: {
                FallbackBehavior: {}
              }
            }
          }
        },
        Sp: {
          type: "structure",
          members: {}
        },
        Sw: {
          type: "list",
          member: {}
        },
        S10: {
          type: "list",
          member: {}
        },
        S15: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Priority",
              "Type"
            ],
            members: {
              Priority: {
                type: "integer"
              },
              Type: {}
            }
          }
        },
        S1j: {
          type: "structure",
          required: [
            "HeaderName",
            "FallbackBehavior"
          ],
          members: {
            HeaderName: {},
            FallbackBehavior: {}
          }
        },
        S1l: {
          type: "structure",
          required: [
            "ARN"
          ],
          members: {
            ARN: {},
            ExcludedRules: {
              shape: "S1m"
            },
            RuleActionOverrides: {
              shape: "S1o"
            }
          }
        },
        S1m: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        S1o: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "ActionToUse"
            ],
            members: {
              Name: {},
              ActionToUse: {
                shape: "S1q"
              }
            }
          }
        },
        S1q: {
          type: "structure",
          members: {
            Block: {
              shape: "S1r"
            },
            Allow: {
              shape: "S1y"
            },
            Count: {
              shape: "S20"
            },
            Captcha: {
              type: "structure",
              members: {
                CustomRequestHandling: {
                  shape: "S1z"
                }
              }
            },
            Challenge: {
              type: "structure",
              members: {
                CustomRequestHandling: {
                  shape: "S1z"
                }
              }
            }
          }
        },
        S1r: {
          type: "structure",
          members: {
            CustomResponse: {
              type: "structure",
              required: [
                "ResponseCode"
              ],
              members: {
                ResponseCode: {
                  type: "integer"
                },
                CustomResponseBodyKey: {},
                ResponseHeaders: {
                  shape: "S1u"
                }
              }
            }
          }
        },
        S1u: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Value"
            ],
            members: {
              Name: {},
              Value: {}
            }
          }
        },
        S1y: {
          type: "structure",
          members: {
            CustomRequestHandling: {
              shape: "S1z"
            }
          }
        },
        S1z: {
          type: "structure",
          required: [
            "InsertHeaders"
          ],
          members: {
            InsertHeaders: {
              shape: "S1u"
            }
          }
        },
        S20: {
          type: "structure",
          members: {
            CustomRequestHandling: {
              shape: "S1z"
            }
          }
        },
        S2n: {
          type: "list",
          member: {
            shape: "Sa"
          }
        },
        S2q: {
          type: "structure",
          required: [
            "VendorName",
            "Name"
          ],
          members: {
            VendorName: {},
            Name: {},
            Version: {},
            ExcludedRules: {
              shape: "S1m"
            },
            ScopeDownStatement: {
              shape: "Sa"
            },
            ManagedRuleGroupConfigs: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  LoginPath: {
                    deprecated: true,
                    deprecatedMessage: "Deprecated. Use AWSManagedRulesATPRuleSet LoginPath"
                  },
                  PayloadType: {
                    deprecated: true,
                    deprecatedMessage: "Deprecated. Use AWSManagedRulesATPRuleSet RequestInspection PayloadType"
                  },
                  UsernameField: {
                    shape: "S2x",
                    deprecated: true,
                    deprecatedMessage: "Deprecated. Use AWSManagedRulesATPRuleSet RequestInspection UsernameField"
                  },
                  PasswordField: {
                    shape: "S2z",
                    deprecated: true,
                    deprecatedMessage: "Deprecated. Use AWSManagedRulesATPRuleSet RequestInspection PasswordField"
                  },
                  AWSManagedRulesBotControlRuleSet: {
                    type: "structure",
                    required: [
                      "InspectionLevel"
                    ],
                    members: {
                      InspectionLevel: {},
                      EnableMachineLearning: {
                        type: "boolean"
                      }
                    }
                  },
                  AWSManagedRulesATPRuleSet: {
                    type: "structure",
                    required: [
                      "LoginPath"
                    ],
                    members: {
                      LoginPath: {},
                      RequestInspection: {
                        type: "structure",
                        required: [
                          "PayloadType",
                          "UsernameField",
                          "PasswordField"
                        ],
                        members: {
                          PayloadType: {},
                          UsernameField: {
                            shape: "S2x"
                          },
                          PasswordField: {
                            shape: "S2z"
                          }
                        }
                      },
                      ResponseInspection: {
                        shape: "S36"
                      },
                      EnableRegexInPath: {
                        type: "boolean"
                      }
                    }
                  },
                  AWSManagedRulesACFPRuleSet: {
                    type: "structure",
                    required: [
                      "CreationPath",
                      "RegistrationPagePath",
                      "RequestInspection"
                    ],
                    members: {
                      CreationPath: {},
                      RegistrationPagePath: {},
                      RequestInspection: {
                        type: "structure",
                        required: [
                          "PayloadType"
                        ],
                        members: {
                          PayloadType: {},
                          UsernameField: {
                            shape: "S2x"
                          },
                          PasswordField: {
                            shape: "S2z"
                          },
                          EmailField: {
                            type: "structure",
                            required: [
                              "Identifier"
                            ],
                            members: {
                              Identifier: {}
                            }
                          },
                          PhoneNumberFields: {
                            type: "list",
                            member: {
                              type: "structure",
                              required: [
                                "Identifier"
                              ],
                              members: {
                                Identifier: {}
                              }
                            }
                          },
                          AddressFields: {
                            type: "list",
                            member: {
                              type: "structure",
                              required: [
                                "Identifier"
                              ],
                              members: {
                                Identifier: {}
                              }
                            }
                          }
                        }
                      },
                      ResponseInspection: {
                        shape: "S36"
                      },
                      EnableRegexInPath: {
                        type: "boolean"
                      }
                    }
                  }
                }
              }
            },
            RuleActionOverrides: {
              shape: "S1o"
            }
          }
        },
        S2x: {
          type: "structure",
          required: [
            "Identifier"
          ],
          members: {
            Identifier: {}
          }
        },
        S2z: {
          type: "structure",
          required: [
            "Identifier"
          ],
          members: {
            Identifier: {}
          }
        },
        S36: {
          type: "structure",
          members: {
            StatusCode: {
              type: "structure",
              required: [
                "SuccessCodes",
                "FailureCodes"
              ],
              members: {
                SuccessCodes: {
                  type: "list",
                  member: {
                    type: "integer"
                  }
                },
                FailureCodes: {
                  type: "list",
                  member: {
                    type: "integer"
                  }
                }
              }
            },
            Header: {
              type: "structure",
              required: [
                "Name",
                "SuccessValues",
                "FailureValues"
              ],
              members: {
                Name: {},
                SuccessValues: {
                  type: "list",
                  member: {}
                },
                FailureValues: {
                  type: "list",
                  member: {}
                }
              }
            },
            BodyContains: {
              type: "structure",
              required: [
                "SuccessStrings",
                "FailureStrings"
              ],
              members: {
                SuccessStrings: {
                  type: "list",
                  member: {}
                },
                FailureStrings: {
                  type: "list",
                  member: {}
                }
              }
            },
            Json: {
              type: "structure",
              required: [
                "Identifier",
                "SuccessValues",
                "FailureValues"
              ],
              members: {
                Identifier: {},
                SuccessValues: {
                  type: "list",
                  member: {}
                },
                FailureValues: {
                  type: "list",
                  member: {}
                }
              }
            }
          }
        },
        S42: {
          type: "structure",
          members: {
            Count: {
              shape: "S20"
            },
            None: {
              type: "structure",
              members: {}
            }
          }
        },
        S44: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        S47: {
          type: "structure",
          required: [
            "SampledRequestsEnabled",
            "CloudWatchMetricsEnabled",
            "MetricName"
          ],
          members: {
            SampledRequestsEnabled: {
              type: "boolean"
            },
            CloudWatchMetricsEnabled: {
              type: "boolean"
            },
            MetricName: {}
          }
        },
        S49: {
          type: "structure",
          members: {
            ImmunityTimeProperty: {
              shape: "S4a"
            }
          }
        },
        S4a: {
          type: "structure",
          required: [
            "ImmunityTime"
          ],
          members: {
            ImmunityTime: {
              type: "long"
            }
          }
        },
        S4c: {
          type: "structure",
          members: {
            ImmunityTimeProperty: {
              shape: "S4a"
            }
          }
        },
        S4n: {
          type: "list",
          member: {}
        },
        S4p: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S4u: {
          type: "structure",
          members: {
            Name: {},
            Id: {},
            Description: {},
            LockToken: {},
            ARN: {}
          }
        },
        S4y: {
          type: "list",
          member: {
            type: "structure",
            members: {
              RegexString: {}
            }
          }
        },
        S51: {
          type: "structure",
          members: {
            Name: {},
            Id: {},
            Description: {},
            LockToken: {},
            ARN: {}
          }
        },
        S54: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "ContentType",
              "Content"
            ],
            members: {
              ContentType: {},
              Content: {}
            }
          }
        },
        S59: {
          type: "structure",
          members: {
            Name: {},
            Id: {},
            Description: {},
            LockToken: {},
            ARN: {}
          }
        },
        S5b: {
          type: "structure",
          members: {
            Block: {
              shape: "S1r"
            },
            Allow: {
              shape: "S1y"
            }
          }
        },
        S5c: {
          type: "list",
          member: {}
        },
        S5d: {
          type: "structure",
          members: {
            RequestBody: {
              type: "map",
              key: {},
              value: {
                type: "structure",
                required: [
                  "DefaultSizeInspectionLimit"
                ],
                members: {
                  DefaultSizeInspectionLimit: {}
                }
              }
            }
          }
        },
        S5j: {
          type: "structure",
          members: {
            Name: {},
            Id: {},
            Description: {},
            LockToken: {},
            ARN: {}
          }
        },
        S60: {
          type: "list",
          member: {
            type: "structure",
            members: {
              VendorName: {},
              ManagedRuleSetName: {},
              ProductId: {},
              ProductLink: {},
              ProductTitle: {},
              ProductDescription: {},
              SnsTopicArn: {},
              IsVersioningSupported: {
                type: "boolean"
              },
              IsAdvancedManagedRuleSet: {
                type: "boolean"
              }
            }
          }
        },
        S6c: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {}
            }
          }
        },
        S6s: {
          type: "structure",
          required: [
            "ResourceArn",
            "LogDestinationConfigs"
          ],
          members: {
            ResourceArn: {},
            LogDestinationConfigs: {
              type: "list",
              member: {}
            },
            RedactedFields: {
              type: "list",
              member: {
                shape: "Sd"
              }
            },
            ManagedByFirewallManager: {
              type: "boolean"
            },
            LoggingFilter: {
              type: "structure",
              required: [
                "Filters",
                "DefaultBehavior"
              ],
              members: {
                Filters: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "Behavior",
                      "Requirement",
                      "Conditions"
                    ],
                    members: {
                      Behavior: {},
                      Requirement: {},
                      Conditions: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            ActionCondition: {
                              type: "structure",
                              required: [
                                "Action"
                              ],
                              members: {
                                Action: {}
                              }
                            },
                            LabelNameCondition: {
                              type: "structure",
                              required: [
                                "LabelName"
                              ],
                              members: {
                                LabelName: {}
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                },
                DefaultBehavior: {}
              }
            }
          }
        },
        S7k: {
          type: "structure",
          members: {
            IPAddressVersion: {},
            Addresses: {
              shape: "S4n"
            }
          }
        },
        S7s: {
          type: "structure",
          required: [
            "StartTime",
            "EndTime"
          ],
          members: {
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            }
          }
        },
        S83: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Value: {}
            }
          }
        },
        S8h: {
          type: "structure",
          required: [
            "Name",
            "Id",
            "ARN",
            "DefaultAction",
            "VisibilityConfig"
          ],
          members: {
            Name: {},
            Id: {},
            ARN: {},
            DefaultAction: {
              shape: "S5b"
            },
            Description: {},
            Rules: {
              shape: "S6"
            },
            VisibilityConfig: {
              shape: "S47"
            },
            Capacity: {
              type: "long"
            },
            PreProcessFirewallManagerRuleGroups: {
              shape: "S8i"
            },
            PostProcessFirewallManagerRuleGroups: {
              shape: "S8i"
            },
            ManagedByFirewallManager: {
              type: "boolean"
            },
            LabelNamespace: {},
            CustomResponseBodies: {
              shape: "S54"
            },
            CaptchaConfig: {
              shape: "S49"
            },
            ChallengeConfig: {
              shape: "S4c"
            },
            TokenDomains: {
              shape: "S5c"
            },
            AssociationConfig: {
              shape: "S5d"
            }
          }
        },
        S8i: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Priority",
              "FirewallManagerStatement",
              "OverrideAction",
              "VisibilityConfig"
            ],
            members: {
              Name: {},
              Priority: {
                type: "integer"
              },
              FirewallManagerStatement: {
                type: "structure",
                members: {
                  ManagedRuleGroupStatement: {
                    shape: "S2q"
                  },
                  RuleGroupReferenceStatement: {
                    shape: "S1l"
                  }
                }
              },
              OverrideAction: {
                shape: "S42"
              },
              VisibilityConfig: {
                shape: "S47"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/wafv2-2019-07-29.paginators.json
var require_wafv2_2019_07_29_paginators = __commonJS({
  "node_modules/aws-sdk/apis/wafv2-2019-07-29.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/wafv2.js
var require_wafv2 = __commonJS({
  "node_modules/aws-sdk/clients/wafv2.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["wafv2"] = {};
    AWS2.WAFV2 = Service.defineService("wafv2", ["2019-07-29"]);
    Object.defineProperty(apiLoader.services["wafv2"], "2019-07-29", {
      get: function get() {
        var model = require_wafv2_2019_07_29_min();
        model.paginators = require_wafv2_2019_07_29_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.WAFV2;
  }
});

// node_modules/aws-sdk/apis/elastic-inference-2017-07-25.min.json
var require_elastic_inference_2017_07_25_min = __commonJS({
  "node_modules/aws-sdk/apis/elastic-inference-2017-07-25.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-07-25",
        endpointPrefix: "api.elastic-inference",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Amazon Elastic Inference",
        serviceFullName: "Amazon Elastic  Inference",
        serviceId: "Elastic Inference",
        signatureVersion: "v4",
        signingName: "elastic-inference",
        uid: "elastic-inference-2017-07-25"
      },
      operations: {
        DescribeAcceleratorOfferings: {
          http: {
            requestUri: "/describe-accelerator-offerings"
          },
          input: {
            type: "structure",
            required: [
              "locationType"
            ],
            members: {
              locationType: {},
              acceleratorTypes: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              acceleratorTypeOfferings: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    acceleratorType: {},
                    locationType: {},
                    location: {}
                  }
                }
              }
            }
          }
        },
        DescribeAcceleratorTypes: {
          http: {
            method: "GET",
            requestUri: "/describe-accelerator-types"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              acceleratorTypes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    acceleratorTypeName: {},
                    memoryInfo: {
                      type: "structure",
                      members: {
                        sizeInMiB: {
                          type: "integer"
                        }
                      }
                    },
                    throughputInfo: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          key: {},
                          value: {
                            type: "integer"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeAccelerators: {
          http: {
            requestUri: "/describe-accelerators"
          },
          input: {
            type: "structure",
            members: {
              acceleratorIds: {
                type: "list",
                member: {}
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              acceleratorSet: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    acceleratorHealth: {
                      type: "structure",
                      members: {
                        status: {}
                      }
                    },
                    acceleratorType: {},
                    acceleratorId: {},
                    availabilityZone: {},
                    attachedResource: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S13"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S13"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S13: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/elastic-inference-2017-07-25.paginators.json
var require_elastic_inference_2017_07_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/elastic-inference-2017-07-25.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeAccelerators: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "acceleratorSet"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/elasticinference.js
var require_elasticinference = __commonJS({
  "node_modules/aws-sdk/clients/elasticinference.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["elasticinference"] = {};
    AWS2.ElasticInference = Service.defineService("elasticinference", ["2017-07-25"]);
    Object.defineProperty(apiLoader.services["elasticinference"], "2017-07-25", {
      get: function get() {
        var model = require_elastic_inference_2017_07_25_min();
        model.paginators = require_elastic_inference_2017_07_25_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ElasticInference;
  }
});

// node_modules/aws-sdk/apis/imagebuilder-2019-12-02.min.json
var require_imagebuilder_2019_12_02_min = __commonJS({
  "node_modules/aws-sdk/apis/imagebuilder-2019-12-02.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-12-02",
        endpointPrefix: "imagebuilder",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "imagebuilder",
        serviceFullName: "EC2 Image Builder",
        serviceId: "imagebuilder",
        signatureVersion: "v4",
        signingName: "imagebuilder",
        uid: "imagebuilder-2019-12-02"
      },
      operations: {
        CancelImageCreation: {
          http: {
            method: "PUT",
            requestUri: "/CancelImageCreation"
          },
          input: {
            type: "structure",
            required: [
              "imageBuildVersionArn",
              "clientToken"
            ],
            members: {
              imageBuildVersionArn: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              clientToken: {},
              imageBuildVersionArn: {}
            }
          }
        },
        CancelLifecycleExecution: {
          http: {
            method: "PUT",
            requestUri: "/CancelLifecycleExecution"
          },
          input: {
            type: "structure",
            required: [
              "lifecycleExecutionId",
              "clientToken"
            ],
            members: {
              lifecycleExecutionId: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              lifecycleExecutionId: {}
            }
          }
        },
        CreateComponent: {
          http: {
            method: "PUT",
            requestUri: "/CreateComponent"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "semanticVersion",
              "platform",
              "clientToken"
            ],
            members: {
              name: {},
              semanticVersion: {},
              description: {},
              changeDescription: {},
              platform: {},
              supportedOsVersions: {
                shape: "Sd"
              },
              data: {},
              uri: {},
              kmsKeyId: {},
              tags: {
                shape: "Sh"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              clientToken: {},
              componentBuildVersionArn: {}
            }
          }
        },
        CreateContainerRecipe: {
          http: {
            method: "PUT",
            requestUri: "/CreateContainerRecipe"
          },
          input: {
            type: "structure",
            required: [
              "containerType",
              "name",
              "semanticVersion",
              "components",
              "parentImage",
              "targetRepository",
              "clientToken"
            ],
            members: {
              containerType: {},
              name: {},
              description: {},
              semanticVersion: {},
              components: {
                shape: "So"
              },
              instanceConfiguration: {
                shape: "Sw"
              },
              dockerfileTemplateData: {},
              dockerfileTemplateUri: {},
              platformOverride: {},
              imageOsVersionOverride: {},
              parentImage: {},
              tags: {
                shape: "Sh"
              },
              workingDirectory: {},
              targetRepository: {
                shape: "S17"
              },
              kmsKeyId: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              clientToken: {},
              containerRecipeArn: {}
            }
          }
        },
        CreateDistributionConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/CreateDistributionConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "distributions",
              "clientToken"
            ],
            members: {
              name: {},
              description: {},
              distributions: {
                shape: "S1c"
              },
              tags: {
                shape: "Sh"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              clientToken: {},
              distributionConfigurationArn: {}
            }
          }
        },
        CreateImage: {
          http: {
            method: "PUT",
            requestUri: "/CreateImage"
          },
          input: {
            type: "structure",
            required: [
              "infrastructureConfigurationArn",
              "clientToken"
            ],
            members: {
              imageRecipeArn: {},
              containerRecipeArn: {},
              distributionConfigurationArn: {},
              infrastructureConfigurationArn: {},
              imageTestsConfiguration: {
                shape: "S28"
              },
              enhancedImageMetadataEnabled: {
                type: "boolean"
              },
              tags: {
                shape: "Sh"
              },
              clientToken: {
                idempotencyToken: true
              },
              imageScanningConfiguration: {
                shape: "S2a"
              },
              workflows: {
                shape: "S2c"
              },
              executionRole: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              clientToken: {},
              imageBuildVersionArn: {}
            }
          }
        },
        CreateImagePipeline: {
          http: {
            method: "PUT",
            requestUri: "/CreateImagePipeline"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "infrastructureConfigurationArn",
              "clientToken"
            ],
            members: {
              name: {},
              description: {},
              imageRecipeArn: {},
              containerRecipeArn: {},
              infrastructureConfigurationArn: {},
              distributionConfigurationArn: {},
              imageTestsConfiguration: {
                shape: "S28"
              },
              enhancedImageMetadataEnabled: {
                type: "boolean"
              },
              schedule: {
                shape: "S2p"
              },
              status: {},
              tags: {
                shape: "Sh"
              },
              clientToken: {
                idempotencyToken: true
              },
              imageScanningConfiguration: {
                shape: "S2a"
              },
              workflows: {
                shape: "S2c"
              },
              executionRole: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              clientToken: {},
              imagePipelineArn: {}
            }
          }
        },
        CreateImageRecipe: {
          http: {
            method: "PUT",
            requestUri: "/CreateImageRecipe"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "semanticVersion",
              "components",
              "parentImage",
              "clientToken"
            ],
            members: {
              name: {},
              description: {},
              semanticVersion: {},
              components: {
                shape: "So"
              },
              parentImage: {},
              blockDeviceMappings: {
                shape: "Sx"
              },
              tags: {
                shape: "Sh"
              },
              workingDirectory: {},
              additionalInstanceConfiguration: {
                shape: "S2w"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              clientToken: {},
              imageRecipeArn: {}
            }
          }
        },
        CreateInfrastructureConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/CreateInfrastructureConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "instanceProfileName",
              "clientToken"
            ],
            members: {
              name: {},
              description: {},
              instanceTypes: {
                shape: "S31"
              },
              instanceProfileName: {},
              securityGroupIds: {
                shape: "S34"
              },
              subnetId: {},
              logging: {
                shape: "S35"
              },
              keyPair: {},
              terminateInstanceOnFailure: {
                type: "boolean"
              },
              snsTopicArn: {},
              resourceTags: {
                shape: "S38"
              },
              instanceMetadataOptions: {
                shape: "S39"
              },
              tags: {
                shape: "Sh"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              clientToken: {},
              infrastructureConfigurationArn: {}
            }
          }
        },
        CreateLifecyclePolicy: {
          http: {
            method: "PUT",
            requestUri: "/CreateLifecyclePolicy"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "executionRole",
              "resourceType",
              "policyDetails",
              "resourceSelection",
              "clientToken"
            ],
            members: {
              name: {},
              description: {},
              status: {},
              executionRole: {},
              resourceType: {},
              policyDetails: {
                shape: "S3g"
              },
              resourceSelection: {
                shape: "S3u"
              },
              tags: {
                shape: "Sh"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              clientToken: {},
              lifecyclePolicyArn: {}
            }
          }
        },
        CreateWorkflow: {
          http: {
            method: "PUT",
            requestUri: "/CreateWorkflow"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "semanticVersion",
              "clientToken",
              "type"
            ],
            members: {
              name: {},
              semanticVersion: {},
              description: {},
              changeDescription: {},
              data: {},
              uri: {},
              kmsKeyId: {},
              tags: {
                shape: "Sh"
              },
              clientToken: {
                idempotencyToken: true
              },
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              clientToken: {},
              workflowBuildVersionArn: {}
            }
          }
        },
        DeleteComponent: {
          http: {
            method: "DELETE",
            requestUri: "/DeleteComponent"
          },
          input: {
            type: "structure",
            required: [
              "componentBuildVersionArn"
            ],
            members: {
              componentBuildVersionArn: {
                location: "querystring",
                locationName: "componentBuildVersionArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              componentBuildVersionArn: {}
            }
          }
        },
        DeleteContainerRecipe: {
          http: {
            method: "DELETE",
            requestUri: "/DeleteContainerRecipe"
          },
          input: {
            type: "structure",
            required: [
              "containerRecipeArn"
            ],
            members: {
              containerRecipeArn: {
                location: "querystring",
                locationName: "containerRecipeArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              containerRecipeArn: {}
            }
          }
        },
        DeleteDistributionConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/DeleteDistributionConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "distributionConfigurationArn"
            ],
            members: {
              distributionConfigurationArn: {
                location: "querystring",
                locationName: "distributionConfigurationArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              distributionConfigurationArn: {}
            }
          }
        },
        DeleteImage: {
          http: {
            method: "DELETE",
            requestUri: "/DeleteImage"
          },
          input: {
            type: "structure",
            required: [
              "imageBuildVersionArn"
            ],
            members: {
              imageBuildVersionArn: {
                location: "querystring",
                locationName: "imageBuildVersionArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              imageBuildVersionArn: {}
            }
          }
        },
        DeleteImagePipeline: {
          http: {
            method: "DELETE",
            requestUri: "/DeleteImagePipeline"
          },
          input: {
            type: "structure",
            required: [
              "imagePipelineArn"
            ],
            members: {
              imagePipelineArn: {
                location: "querystring",
                locationName: "imagePipelineArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              imagePipelineArn: {}
            }
          }
        },
        DeleteImageRecipe: {
          http: {
            method: "DELETE",
            requestUri: "/DeleteImageRecipe"
          },
          input: {
            type: "structure",
            required: [
              "imageRecipeArn"
            ],
            members: {
              imageRecipeArn: {
                location: "querystring",
                locationName: "imageRecipeArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              imageRecipeArn: {}
            }
          }
        },
        DeleteInfrastructureConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/DeleteInfrastructureConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "infrastructureConfigurationArn"
            ],
            members: {
              infrastructureConfigurationArn: {
                location: "querystring",
                locationName: "infrastructureConfigurationArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              infrastructureConfigurationArn: {}
            }
          }
        },
        DeleteLifecyclePolicy: {
          http: {
            method: "DELETE",
            requestUri: "/DeleteLifecyclePolicy"
          },
          input: {
            type: "structure",
            required: [
              "lifecyclePolicyArn"
            ],
            members: {
              lifecyclePolicyArn: {
                location: "querystring",
                locationName: "lifecyclePolicyArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              lifecyclePolicyArn: {}
            }
          }
        },
        DeleteWorkflow: {
          http: {
            method: "DELETE",
            requestUri: "/DeleteWorkflow"
          },
          input: {
            type: "structure",
            required: [
              "workflowBuildVersionArn"
            ],
            members: {
              workflowBuildVersionArn: {
                location: "querystring",
                locationName: "workflowBuildVersionArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              workflowBuildVersionArn: {}
            }
          }
        },
        GetComponent: {
          http: {
            method: "GET",
            requestUri: "/GetComponent"
          },
          input: {
            type: "structure",
            required: [
              "componentBuildVersionArn"
            ],
            members: {
              componentBuildVersionArn: {
                location: "querystring",
                locationName: "componentBuildVersionArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              component: {
                type: "structure",
                members: {
                  arn: {},
                  name: {},
                  version: {},
                  description: {},
                  changeDescription: {},
                  type: {},
                  platform: {},
                  supportedOsVersions: {
                    shape: "Sd"
                  },
                  state: {
                    shape: "S4r"
                  },
                  parameters: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "name",
                        "type"
                      ],
                      members: {
                        name: {},
                        type: {},
                        defaultValue: {
                          shape: "Su"
                        },
                        description: {}
                      }
                    }
                  },
                  owner: {},
                  data: {},
                  kmsKeyId: {},
                  encrypted: {
                    type: "boolean"
                  },
                  dateCreated: {},
                  tags: {
                    shape: "Sh"
                  },
                  publisher: {},
                  obfuscate: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        GetComponentPolicy: {
          http: {
            method: "GET",
            requestUri: "/GetComponentPolicy"
          },
          input: {
            type: "structure",
            required: [
              "componentArn"
            ],
            members: {
              componentArn: {
                location: "querystring",
                locationName: "componentArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              policy: {}
            }
          }
        },
        GetContainerRecipe: {
          http: {
            method: "GET",
            requestUri: "/GetContainerRecipe"
          },
          input: {
            type: "structure",
            required: [
              "containerRecipeArn"
            ],
            members: {
              containerRecipeArn: {
                location: "querystring",
                locationName: "containerRecipeArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              containerRecipe: {
                shape: "S54"
              }
            }
          }
        },
        GetContainerRecipePolicy: {
          http: {
            method: "GET",
            requestUri: "/GetContainerRecipePolicy"
          },
          input: {
            type: "structure",
            required: [
              "containerRecipeArn"
            ],
            members: {
              containerRecipeArn: {
                location: "querystring",
                locationName: "containerRecipeArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              policy: {}
            }
          }
        },
        GetDistributionConfiguration: {
          http: {
            method: "GET",
            requestUri: "/GetDistributionConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "distributionConfigurationArn"
            ],
            members: {
              distributionConfigurationArn: {
                location: "querystring",
                locationName: "distributionConfigurationArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              distributionConfiguration: {
                shape: "S5a"
              }
            }
          }
        },
        GetImage: {
          http: {
            method: "GET",
            requestUri: "/GetImage"
          },
          input: {
            type: "structure",
            required: [
              "imageBuildVersionArn"
            ],
            members: {
              imageBuildVersionArn: {
                location: "querystring",
                locationName: "imageBuildVersionArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              image: {
                type: "structure",
                members: {
                  arn: {},
                  type: {},
                  name: {},
                  version: {},
                  platform: {},
                  enhancedImageMetadataEnabled: {
                    type: "boolean"
                  },
                  osVersion: {},
                  state: {
                    shape: "S5h"
                  },
                  imageRecipe: {
                    shape: "S5j"
                  },
                  containerRecipe: {
                    shape: "S54"
                  },
                  sourcePipelineName: {},
                  sourcePipelineArn: {},
                  infrastructureConfiguration: {
                    shape: "S5l"
                  },
                  distributionConfiguration: {
                    shape: "S5a"
                  },
                  imageTestsConfiguration: {
                    shape: "S28"
                  },
                  dateCreated: {},
                  outputResources: {
                    shape: "S5m"
                  },
                  tags: {
                    shape: "Sh"
                  },
                  buildType: {},
                  imageSource: {},
                  scanState: {
                    type: "structure",
                    members: {
                      status: {},
                      reason: {}
                    }
                  },
                  imageScanningConfiguration: {
                    shape: "S2a"
                  },
                  deprecationTime: {
                    type: "timestamp"
                  },
                  lifecycleExecutionId: {},
                  executionRole: {},
                  workflows: {
                    shape: "S2c"
                  }
                }
              }
            }
          }
        },
        GetImagePipeline: {
          http: {
            method: "GET",
            requestUri: "/GetImagePipeline"
          },
          input: {
            type: "structure",
            required: [
              "imagePipelineArn"
            ],
            members: {
              imagePipelineArn: {
                location: "querystring",
                locationName: "imagePipelineArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              imagePipeline: {
                shape: "S5y"
              }
            }
          }
        },
        GetImagePolicy: {
          http: {
            method: "GET",
            requestUri: "/GetImagePolicy"
          },
          input: {
            type: "structure",
            required: [
              "imageArn"
            ],
            members: {
              imageArn: {
                location: "querystring",
                locationName: "imageArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              policy: {}
            }
          }
        },
        GetImageRecipe: {
          http: {
            method: "GET",
            requestUri: "/GetImageRecipe"
          },
          input: {
            type: "structure",
            required: [
              "imageRecipeArn"
            ],
            members: {
              imageRecipeArn: {
                location: "querystring",
                locationName: "imageRecipeArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              imageRecipe: {
                shape: "S5j"
              }
            }
          }
        },
        GetImageRecipePolicy: {
          http: {
            method: "GET",
            requestUri: "/GetImageRecipePolicy"
          },
          input: {
            type: "structure",
            required: [
              "imageRecipeArn"
            ],
            members: {
              imageRecipeArn: {
                location: "querystring",
                locationName: "imageRecipeArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              policy: {}
            }
          }
        },
        GetInfrastructureConfiguration: {
          http: {
            method: "GET",
            requestUri: "/GetInfrastructureConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "infrastructureConfigurationArn"
            ],
            members: {
              infrastructureConfigurationArn: {
                location: "querystring",
                locationName: "infrastructureConfigurationArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              infrastructureConfiguration: {
                shape: "S5l"
              }
            }
          }
        },
        GetLifecycleExecution: {
          http: {
            method: "GET",
            requestUri: "/GetLifecycleExecution"
          },
          input: {
            type: "structure",
            required: [
              "lifecycleExecutionId"
            ],
            members: {
              lifecycleExecutionId: {
                location: "querystring",
                locationName: "lifecycleExecutionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              lifecycleExecution: {
                shape: "S69"
              }
            }
          }
        },
        GetLifecyclePolicy: {
          http: {
            method: "GET",
            requestUri: "/GetLifecyclePolicy"
          },
          input: {
            type: "structure",
            required: [
              "lifecyclePolicyArn"
            ],
            members: {
              lifecyclePolicyArn: {
                location: "querystring",
                locationName: "lifecyclePolicyArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              lifecyclePolicy: {
                type: "structure",
                members: {
                  arn: {},
                  name: {},
                  description: {},
                  status: {},
                  executionRole: {},
                  resourceType: {},
                  policyDetails: {
                    shape: "S3g"
                  },
                  resourceSelection: {
                    shape: "S3u"
                  },
                  dateCreated: {
                    type: "timestamp"
                  },
                  dateUpdated: {
                    type: "timestamp"
                  },
                  dateLastRun: {
                    type: "timestamp"
                  },
                  tags: {
                    shape: "Sh"
                  }
                }
              }
            }
          }
        },
        GetWorkflow: {
          http: {
            method: "GET",
            requestUri: "/GetWorkflow"
          },
          input: {
            type: "structure",
            required: [
              "workflowBuildVersionArn"
            ],
            members: {
              workflowBuildVersionArn: {
                location: "querystring",
                locationName: "workflowBuildVersionArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              workflow: {
                type: "structure",
                members: {
                  arn: {},
                  name: {},
                  version: {},
                  description: {},
                  changeDescription: {},
                  type: {},
                  state: {
                    shape: "S6j"
                  },
                  owner: {},
                  data: {},
                  kmsKeyId: {},
                  dateCreated: {},
                  tags: {
                    shape: "Sh"
                  },
                  parameters: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "name",
                        "type"
                      ],
                      members: {
                        name: {},
                        type: {},
                        defaultValue: {
                          shape: "S2i"
                        },
                        description: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetWorkflowExecution: {
          http: {
            method: "GET",
            requestUri: "/GetWorkflowExecution"
          },
          input: {
            type: "structure",
            required: [
              "workflowExecutionId"
            ],
            members: {
              workflowExecutionId: {
                location: "querystring",
                locationName: "workflowExecutionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              workflowBuildVersionArn: {},
              workflowExecutionId: {},
              imageBuildVersionArn: {},
              type: {},
              status: {},
              message: {},
              totalStepCount: {
                type: "integer"
              },
              totalStepsSucceeded: {
                type: "integer"
              },
              totalStepsFailed: {
                type: "integer"
              },
              totalStepsSkipped: {
                type: "integer"
              },
              startTime: {},
              endTime: {},
              parallelGroup: {}
            }
          }
        },
        GetWorkflowStepExecution: {
          http: {
            method: "GET",
            requestUri: "/GetWorkflowStepExecution"
          },
          input: {
            type: "structure",
            required: [
              "stepExecutionId"
            ],
            members: {
              stepExecutionId: {
                location: "querystring",
                locationName: "stepExecutionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              stepExecutionId: {},
              workflowBuildVersionArn: {},
              workflowExecutionId: {},
              imageBuildVersionArn: {},
              name: {},
              description: {},
              action: {},
              status: {},
              rollbackStatus: {},
              message: {},
              inputs: {},
              outputs: {},
              startTime: {},
              endTime: {},
              onFailure: {},
              timeoutSeconds: {
                type: "integer"
              }
            }
          }
        },
        ImportComponent: {
          http: {
            method: "PUT",
            requestUri: "/ImportComponent"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "semanticVersion",
              "type",
              "format",
              "platform",
              "clientToken"
            ],
            members: {
              name: {},
              semanticVersion: {},
              description: {},
              changeDescription: {},
              type: {},
              format: {},
              platform: {},
              data: {},
              uri: {},
              kmsKeyId: {},
              tags: {
                shape: "Sh"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              clientToken: {},
              componentBuildVersionArn: {}
            }
          }
        },
        ImportVmImage: {
          http: {
            method: "PUT",
            requestUri: "/ImportVmImage"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "semanticVersion",
              "platform",
              "vmImportTaskId",
              "clientToken"
            ],
            members: {
              name: {},
              semanticVersion: {},
              description: {},
              platform: {},
              osVersion: {},
              vmImportTaskId: {},
              tags: {
                shape: "Sh"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              imageArn: {},
              clientToken: {}
            }
          }
        },
        ListComponentBuildVersions: {
          http: {
            requestUri: "/ListComponentBuildVersions"
          },
          input: {
            type: "structure",
            required: [
              "componentVersionArn"
            ],
            members: {
              componentVersionArn: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              componentSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    name: {},
                    version: {},
                    platform: {},
                    supportedOsVersions: {
                      shape: "Sd"
                    },
                    state: {
                      shape: "S4r"
                    },
                    type: {},
                    owner: {},
                    description: {},
                    changeDescription: {},
                    dateCreated: {},
                    tags: {
                      shape: "Sh"
                    },
                    publisher: {},
                    obfuscate: {
                      type: "boolean"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListComponents: {
          http: {
            requestUri: "/ListComponents"
          },
          input: {
            type: "structure",
            members: {
              owner: {},
              filters: {
                shape: "S7m"
              },
              byName: {
                type: "boolean"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              componentVersionList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    name: {},
                    version: {},
                    description: {},
                    platform: {},
                    supportedOsVersions: {
                      shape: "Sd"
                    },
                    type: {},
                    owner: {},
                    dateCreated: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListContainerRecipes: {
          http: {
            requestUri: "/ListContainerRecipes"
          },
          input: {
            type: "structure",
            members: {
              owner: {},
              filters: {
                shape: "S7m"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              containerRecipeSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    containerType: {},
                    name: {},
                    platform: {},
                    owner: {},
                    parentImage: {},
                    dateCreated: {},
                    tags: {
                      shape: "Sh"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDistributionConfigurations: {
          http: {
            requestUri: "/ListDistributionConfigurations"
          },
          input: {
            type: "structure",
            members: {
              filters: {
                shape: "S7m"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              distributionConfigurationSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    name: {},
                    description: {},
                    dateCreated: {},
                    dateUpdated: {},
                    tags: {
                      shape: "Sh"
                    },
                    regions: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListImageBuildVersions: {
          http: {
            requestUri: "/ListImageBuildVersions"
          },
          input: {
            type: "structure",
            required: [
              "imageVersionArn"
            ],
            members: {
              imageVersionArn: {},
              filters: {
                shape: "S7m"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              imageSummaryList: {
                shape: "S86"
              },
              nextToken: {}
            }
          }
        },
        ListImagePackages: {
          http: {
            requestUri: "/ListImagePackages"
          },
          input: {
            type: "structure",
            required: [
              "imageBuildVersionArn"
            ],
            members: {
              imageBuildVersionArn: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              imagePackageList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    packageName: {},
                    packageVersion: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListImagePipelineImages: {
          http: {
            requestUri: "/ListImagePipelineImages"
          },
          input: {
            type: "structure",
            required: [
              "imagePipelineArn"
            ],
            members: {
              imagePipelineArn: {},
              filters: {
                shape: "S7m"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              imageSummaryList: {
                shape: "S86"
              },
              nextToken: {}
            }
          }
        },
        ListImagePipelines: {
          http: {
            requestUri: "/ListImagePipelines"
          },
          input: {
            type: "structure",
            members: {
              filters: {
                shape: "S7m"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              imagePipelineList: {
                type: "list",
                member: {
                  shape: "S5y"
                }
              },
              nextToken: {}
            }
          }
        },
        ListImageRecipes: {
          http: {
            requestUri: "/ListImageRecipes"
          },
          input: {
            type: "structure",
            members: {
              owner: {},
              filters: {
                shape: "S7m"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              imageRecipeSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    name: {},
                    platform: {},
                    owner: {},
                    parentImage: {},
                    dateCreated: {},
                    tags: {
                      shape: "Sh"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListImageScanFindingAggregations: {
          http: {
            requestUri: "/ListImageScanFindingAggregations"
          },
          input: {
            type: "structure",
            members: {
              filter: {
                shape: "S7n"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              aggregationType: {},
              responses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    accountAggregation: {
                      type: "structure",
                      members: {
                        accountId: {},
                        severityCounts: {
                          shape: "S8q"
                        }
                      }
                    },
                    imageAggregation: {
                      type: "structure",
                      members: {
                        imageBuildVersionArn: {},
                        severityCounts: {
                          shape: "S8q"
                        }
                      }
                    },
                    imagePipelineAggregation: {
                      type: "structure",
                      members: {
                        imagePipelineArn: {},
                        severityCounts: {
                          shape: "S8q"
                        }
                      }
                    },
                    vulnerabilityIdAggregation: {
                      type: "structure",
                      members: {
                        vulnerabilityId: {},
                        severityCounts: {
                          shape: "S8q"
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListImageScanFindings: {
          http: {
            requestUri: "/ListImageScanFindings"
          },
          input: {
            type: "structure",
            members: {
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              findings: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    awsAccountId: {},
                    imageBuildVersionArn: {},
                    imagePipelineArn: {},
                    type: {},
                    description: {},
                    title: {},
                    remediation: {
                      type: "structure",
                      members: {
                        recommendation: {
                          type: "structure",
                          members: {
                            text: {},
                            url: {}
                          }
                        }
                      }
                    },
                    severity: {},
                    firstObservedAt: {
                      type: "timestamp"
                    },
                    updatedAt: {
                      type: "timestamp"
                    },
                    inspectorScore: {
                      type: "double"
                    },
                    inspectorScoreDetails: {
                      type: "structure",
                      members: {
                        adjustedCvss: {
                          type: "structure",
                          members: {
                            scoreSource: {},
                            cvssSource: {},
                            version: {},
                            score: {
                              type: "double"
                            },
                            scoringVector: {},
                            adjustments: {
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  metric: {},
                                  reason: {}
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    packageVulnerabilityDetails: {
                      type: "structure",
                      required: [
                        "vulnerabilityId"
                      ],
                      members: {
                        vulnerabilityId: {},
                        vulnerablePackages: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              name: {},
                              version: {},
                              sourceLayerHash: {},
                              epoch: {
                                type: "integer"
                              },
                              release: {},
                              arch: {},
                              packageManager: {},
                              filePath: {},
                              fixedInVersion: {},
                              remediation: {}
                            }
                          }
                        },
                        source: {},
                        cvss: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              baseScore: {
                                type: "double"
                              },
                              scoringVector: {},
                              version: {},
                              source: {}
                            }
                          }
                        },
                        relatedVulnerabilities: {
                          type: "list",
                          member: {}
                        },
                        sourceUrl: {},
                        vendorSeverity: {},
                        vendorCreatedAt: {
                          type: "timestamp"
                        },
                        vendorUpdatedAt: {
                          type: "timestamp"
                        },
                        referenceUrls: {
                          type: "list",
                          member: {}
                        }
                      }
                    },
                    fixAvailable: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListImages: {
          http: {
            requestUri: "/ListImages"
          },
          input: {
            type: "structure",
            members: {
              owner: {},
              filters: {
                shape: "S7m"
              },
              byName: {
                type: "boolean"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              includeDeprecated: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              imageVersionList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    name: {},
                    type: {},
                    version: {},
                    platform: {},
                    osVersion: {},
                    owner: {},
                    dateCreated: {},
                    buildType: {},
                    imageSource: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListInfrastructureConfigurations: {
          http: {
            requestUri: "/ListInfrastructureConfigurations"
          },
          input: {
            type: "structure",
            members: {
              filters: {
                shape: "S7m"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              infrastructureConfigurationSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    name: {},
                    description: {},
                    dateCreated: {},
                    dateUpdated: {},
                    resourceTags: {
                      shape: "S38"
                    },
                    tags: {
                      shape: "Sh"
                    },
                    instanceTypes: {
                      shape: "S31"
                    },
                    instanceProfileName: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListLifecycleExecutionResources: {
          http: {
            requestUri: "/ListLifecycleExecutionResources"
          },
          input: {
            type: "structure",
            required: [
              "lifecycleExecutionId"
            ],
            members: {
              lifecycleExecutionId: {},
              parentResourceId: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              lifecycleExecutionId: {},
              lifecycleExecutionState: {
                shape: "S6b"
              },
              resources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    accountId: {},
                    resourceId: {},
                    state: {
                      shape: "S9w"
                    },
                    action: {
                      type: "structure",
                      members: {
                        name: {},
                        reason: {}
                      }
                    },
                    region: {},
                    snapshots: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          snapshotId: {},
                          state: {
                            shape: "S9w"
                          }
                        }
                      }
                    },
                    imageUris: {
                      shape: "S1j"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListLifecycleExecutions: {
          http: {
            requestUri: "/ListLifecycleExecutions"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              lifecycleExecutions: {
                type: "list",
                member: {
                  shape: "S69"
                }
              },
              nextToken: {}
            }
          }
        },
        ListLifecyclePolicies: {
          http: {
            requestUri: "/ListLifecyclePolicies"
          },
          input: {
            type: "structure",
            members: {
              filters: {
                shape: "S7m"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              lifecyclePolicySummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    name: {},
                    description: {},
                    status: {},
                    executionRole: {},
                    resourceType: {},
                    dateCreated: {
                      type: "timestamp"
                    },
                    dateUpdated: {
                      type: "timestamp"
                    },
                    dateLastRun: {
                      type: "timestamp"
                    },
                    tags: {
                      shape: "Sh"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sh"
              }
            }
          }
        },
        ListWaitingWorkflowSteps: {
          http: {
            requestUri: "/ListWaitingWorkflowSteps"
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              steps: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    stepExecutionId: {},
                    imageBuildVersionArn: {},
                    workflowExecutionId: {},
                    workflowBuildVersionArn: {},
                    name: {},
                    action: {},
                    startTime: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListWorkflowBuildVersions: {
          http: {
            requestUri: "/ListWorkflowBuildVersions"
          },
          input: {
            type: "structure",
            required: [
              "workflowVersionArn"
            ],
            members: {
              workflowVersionArn: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              workflowSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    name: {},
                    version: {},
                    description: {},
                    changeDescription: {},
                    type: {},
                    owner: {},
                    state: {
                      shape: "S6j"
                    },
                    dateCreated: {},
                    tags: {
                      shape: "Sh"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListWorkflowExecutions: {
          http: {
            requestUri: "/ListWorkflowExecutions"
          },
          input: {
            type: "structure",
            required: [
              "imageBuildVersionArn"
            ],
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              imageBuildVersionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              workflowExecutions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    workflowBuildVersionArn: {},
                    workflowExecutionId: {},
                    type: {},
                    status: {},
                    message: {},
                    totalStepCount: {
                      type: "integer"
                    },
                    totalStepsSucceeded: {
                      type: "integer"
                    },
                    totalStepsFailed: {
                      type: "integer"
                    },
                    totalStepsSkipped: {
                      type: "integer"
                    },
                    startTime: {},
                    endTime: {},
                    parallelGroup: {}
                  }
                }
              },
              imageBuildVersionArn: {},
              message: {},
              nextToken: {}
            }
          }
        },
        ListWorkflowStepExecutions: {
          http: {
            requestUri: "/ListWorkflowStepExecutions"
          },
          input: {
            type: "structure",
            required: [
              "workflowExecutionId"
            ],
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              workflowExecutionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              steps: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    stepExecutionId: {},
                    name: {},
                    description: {},
                    action: {},
                    status: {},
                    rollbackStatus: {},
                    message: {},
                    inputs: {},
                    outputs: {},
                    startTime: {},
                    endTime: {}
                  }
                }
              },
              workflowBuildVersionArn: {},
              workflowExecutionId: {},
              imageBuildVersionArn: {},
              message: {},
              nextToken: {}
            }
          }
        },
        ListWorkflows: {
          http: {
            requestUri: "/ListWorkflows"
          },
          input: {
            type: "structure",
            members: {
              owner: {},
              filters: {
                shape: "S7m"
              },
              byName: {
                type: "boolean"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              workflowVersionList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    name: {},
                    version: {},
                    description: {},
                    type: {},
                    owner: {},
                    dateCreated: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        PutComponentPolicy: {
          http: {
            method: "PUT",
            requestUri: "/PutComponentPolicy"
          },
          input: {
            type: "structure",
            required: [
              "componentArn",
              "policy"
            ],
            members: {
              componentArn: {},
              policy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              componentArn: {}
            }
          }
        },
        PutContainerRecipePolicy: {
          http: {
            method: "PUT",
            requestUri: "/PutContainerRecipePolicy"
          },
          input: {
            type: "structure",
            required: [
              "containerRecipeArn",
              "policy"
            ],
            members: {
              containerRecipeArn: {},
              policy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              containerRecipeArn: {}
            }
          }
        },
        PutImagePolicy: {
          http: {
            method: "PUT",
            requestUri: "/PutImagePolicy"
          },
          input: {
            type: "structure",
            required: [
              "imageArn",
              "policy"
            ],
            members: {
              imageArn: {},
              policy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              imageArn: {}
            }
          }
        },
        PutImageRecipePolicy: {
          http: {
            method: "PUT",
            requestUri: "/PutImageRecipePolicy"
          },
          input: {
            type: "structure",
            required: [
              "imageRecipeArn",
              "policy"
            ],
            members: {
              imageRecipeArn: {},
              policy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              imageRecipeArn: {}
            }
          }
        },
        SendWorkflowStepAction: {
          http: {
            method: "PUT",
            requestUri: "/SendWorkflowStepAction"
          },
          input: {
            type: "structure",
            required: [
              "stepExecutionId",
              "imageBuildVersionArn",
              "action",
              "clientToken"
            ],
            members: {
              stepExecutionId: {},
              imageBuildVersionArn: {},
              action: {},
              reason: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              stepExecutionId: {},
              imageBuildVersionArn: {},
              clientToken: {}
            }
          }
        },
        StartImagePipelineExecution: {
          http: {
            method: "PUT",
            requestUri: "/StartImagePipelineExecution"
          },
          input: {
            type: "structure",
            required: [
              "imagePipelineArn",
              "clientToken"
            ],
            members: {
              imagePipelineArn: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              clientToken: {},
              imageBuildVersionArn: {}
            }
          }
        },
        StartResourceStateUpdate: {
          http: {
            method: "PUT",
            requestUri: "/StartResourceStateUpdate"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "state",
              "clientToken"
            ],
            members: {
              resourceArn: {},
              state: {
                type: "structure",
                members: {
                  status: {}
                }
              },
              executionRole: {},
              includeResources: {
                type: "structure",
                members: {
                  amis: {
                    type: "boolean"
                  },
                  snapshots: {
                    type: "boolean"
                  },
                  containers: {
                    type: "boolean"
                  }
                }
              },
              exclusionRules: {
                type: "structure",
                members: {
                  amis: {
                    shape: "S3r"
                  }
                }
              },
              updateAt: {
                type: "timestamp"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              lifecycleExecutionId: {},
              resourceArn: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sh"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDistributionConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/UpdateDistributionConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "distributionConfigurationArn",
              "distributions",
              "clientToken"
            ],
            members: {
              distributionConfigurationArn: {},
              description: {},
              distributions: {
                shape: "S1c"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              clientToken: {},
              distributionConfigurationArn: {}
            }
          }
        },
        UpdateImagePipeline: {
          http: {
            method: "PUT",
            requestUri: "/UpdateImagePipeline"
          },
          input: {
            type: "structure",
            required: [
              "imagePipelineArn",
              "infrastructureConfigurationArn",
              "clientToken"
            ],
            members: {
              imagePipelineArn: {},
              description: {},
              imageRecipeArn: {},
              containerRecipeArn: {},
              infrastructureConfigurationArn: {},
              distributionConfigurationArn: {},
              imageTestsConfiguration: {
                shape: "S28"
              },
              enhancedImageMetadataEnabled: {
                type: "boolean"
              },
              schedule: {
                shape: "S2p"
              },
              status: {},
              clientToken: {
                idempotencyToken: true
              },
              imageScanningConfiguration: {
                shape: "S2a"
              },
              workflows: {
                shape: "S2c"
              },
              executionRole: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              clientToken: {},
              imagePipelineArn: {}
            }
          }
        },
        UpdateInfrastructureConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/UpdateInfrastructureConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "infrastructureConfigurationArn",
              "instanceProfileName",
              "clientToken"
            ],
            members: {
              infrastructureConfigurationArn: {},
              description: {},
              instanceTypes: {
                shape: "S31"
              },
              instanceProfileName: {},
              securityGroupIds: {
                shape: "S34"
              },
              subnetId: {},
              logging: {
                shape: "S35"
              },
              keyPair: {},
              terminateInstanceOnFailure: {
                type: "boolean"
              },
              snsTopicArn: {},
              clientToken: {
                idempotencyToken: true
              },
              resourceTags: {
                shape: "S38"
              },
              instanceMetadataOptions: {
                shape: "S39"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              clientToken: {},
              infrastructureConfigurationArn: {}
            }
          }
        },
        UpdateLifecyclePolicy: {
          http: {
            method: "PUT",
            requestUri: "/UpdateLifecyclePolicy"
          },
          input: {
            type: "structure",
            required: [
              "lifecyclePolicyArn",
              "executionRole",
              "resourceType",
              "policyDetails",
              "resourceSelection",
              "clientToken"
            ],
            members: {
              lifecyclePolicyArn: {},
              description: {},
              status: {},
              executionRole: {},
              resourceType: {},
              policyDetails: {
                shape: "S3g"
              },
              resourceSelection: {
                shape: "S3u"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              lifecyclePolicyArn: {}
            }
          }
        }
      },
      shapes: {
        Sd: {
          type: "list",
          member: {}
        },
        Sh: {
          type: "map",
          key: {},
          value: {}
        },
        So: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "componentArn"
            ],
            members: {
              componentArn: {},
              parameters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "value"
                  ],
                  members: {
                    name: {},
                    value: {
                      shape: "Su"
                    }
                  }
                }
              }
            }
          }
        },
        Su: {
          type: "list",
          member: {}
        },
        Sw: {
          type: "structure",
          members: {
            image: {},
            blockDeviceMappings: {
              shape: "Sx"
            }
          }
        },
        Sx: {
          type: "list",
          member: {
            type: "structure",
            members: {
              deviceName: {},
              ebs: {
                type: "structure",
                members: {
                  encrypted: {
                    type: "boolean"
                  },
                  deleteOnTermination: {
                    type: "boolean"
                  },
                  iops: {
                    type: "integer"
                  },
                  kmsKeyId: {},
                  snapshotId: {},
                  volumeSize: {
                    type: "integer"
                  },
                  volumeType: {},
                  throughput: {
                    type: "integer"
                  }
                }
              },
              virtualName: {},
              noDevice: {}
            }
          }
        },
        S17: {
          type: "structure",
          required: [
            "service",
            "repositoryName"
          ],
          members: {
            service: {},
            repositoryName: {}
          }
        },
        S1c: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "region"
            ],
            members: {
              region: {},
              amiDistributionConfiguration: {
                type: "structure",
                members: {
                  name: {},
                  description: {},
                  targetAccountIds: {
                    shape: "S1g"
                  },
                  amiTags: {
                    shape: "Sh"
                  },
                  kmsKeyId: {},
                  launchPermission: {
                    type: "structure",
                    members: {
                      userIds: {
                        shape: "S1g"
                      },
                      userGroups: {
                        shape: "S1j"
                      },
                      organizationArns: {
                        type: "list",
                        member: {}
                      },
                      organizationalUnitArns: {
                        type: "list",
                        member: {}
                      }
                    }
                  }
                }
              },
              containerDistributionConfiguration: {
                type: "structure",
                required: [
                  "targetRepository"
                ],
                members: {
                  description: {},
                  containerTags: {
                    shape: "S1j"
                  },
                  targetRepository: {
                    shape: "S17"
                  }
                }
              },
              licenseConfigurationArns: {
                type: "list",
                member: {}
              },
              launchTemplateConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "launchTemplateId"
                  ],
                  members: {
                    launchTemplateId: {},
                    accountId: {},
                    setDefaultVersion: {
                      type: "boolean"
                    }
                  }
                }
              },
              s3ExportConfiguration: {
                type: "structure",
                required: [
                  "roleName",
                  "diskImageFormat",
                  "s3Bucket"
                ],
                members: {
                  roleName: {},
                  diskImageFormat: {},
                  s3Bucket: {},
                  s3Prefix: {}
                }
              },
              fastLaunchConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "enabled"
                  ],
                  members: {
                    enabled: {
                      type: "boolean"
                    },
                    snapshotConfiguration: {
                      type: "structure",
                      members: {
                        targetResourceCount: {
                          type: "integer"
                        }
                      }
                    },
                    maxParallelLaunches: {
                      type: "integer"
                    },
                    launchTemplate: {
                      type: "structure",
                      members: {
                        launchTemplateId: {},
                        launchTemplateName: {},
                        launchTemplateVersion: {}
                      }
                    },
                    accountId: {}
                  }
                }
              }
            }
          }
        },
        S1g: {
          type: "list",
          member: {}
        },
        S1j: {
          type: "list",
          member: {}
        },
        S28: {
          type: "structure",
          members: {
            imageTestsEnabled: {
              type: "boolean"
            },
            timeoutMinutes: {
              type: "integer"
            }
          }
        },
        S2a: {
          type: "structure",
          members: {
            imageScanningEnabled: {
              type: "boolean"
            },
            ecrConfiguration: {
              type: "structure",
              members: {
                repositoryName: {},
                containerTags: {
                  shape: "S1j"
                }
              }
            }
          }
        },
        S2c: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "workflowArn"
            ],
            members: {
              workflowArn: {},
              parameters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "value"
                  ],
                  members: {
                    name: {},
                    value: {
                      shape: "S2i"
                    }
                  }
                }
              },
              parallelGroup: {},
              onFailure: {}
            }
          }
        },
        S2i: {
          type: "list",
          member: {}
        },
        S2p: {
          type: "structure",
          members: {
            scheduleExpression: {},
            timezone: {},
            pipelineExecutionStartCondition: {}
          }
        },
        S2w: {
          type: "structure",
          members: {
            systemsManagerAgent: {
              type: "structure",
              members: {
                uninstallAfterBuild: {
                  type: "boolean"
                }
              }
            },
            userDataOverride: {}
          }
        },
        S31: {
          type: "list",
          member: {}
        },
        S34: {
          type: "list",
          member: {}
        },
        S35: {
          type: "structure",
          members: {
            s3Logs: {
              type: "structure",
              members: {
                s3BucketName: {},
                s3KeyPrefix: {}
              }
            }
          }
        },
        S38: {
          type: "map",
          key: {},
          value: {}
        },
        S39: {
          type: "structure",
          members: {
            httpTokens: {},
            httpPutResponseHopLimit: {
              type: "integer"
            }
          }
        },
        S3g: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "action",
              "filter"
            ],
            members: {
              action: {
                type: "structure",
                required: [
                  "type"
                ],
                members: {
                  type: {},
                  includeResources: {
                    type: "structure",
                    members: {
                      amis: {
                        type: "boolean"
                      },
                      snapshots: {
                        type: "boolean"
                      },
                      containers: {
                        type: "boolean"
                      }
                    }
                  }
                }
              },
              filter: {
                type: "structure",
                required: [
                  "type",
                  "value"
                ],
                members: {
                  type: {},
                  value: {
                    type: "integer"
                  },
                  unit: {},
                  retainAtLeast: {
                    type: "integer"
                  }
                }
              },
              exclusionRules: {
                type: "structure",
                members: {
                  tagMap: {
                    shape: "Sh"
                  },
                  amis: {
                    shape: "S3r"
                  }
                }
              }
            }
          }
        },
        S3r: {
          type: "structure",
          members: {
            isPublic: {
              type: "boolean"
            },
            regions: {
              shape: "S1j"
            },
            sharedAccounts: {
              shape: "S1g"
            },
            lastLaunched: {
              type: "structure",
              required: [
                "value",
                "unit"
              ],
              members: {
                value: {
                  type: "integer"
                },
                unit: {}
              }
            },
            tagMap: {
              shape: "Sh"
            }
          }
        },
        S3u: {
          type: "structure",
          members: {
            recipes: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "name",
                  "semanticVersion"
                ],
                members: {
                  name: {},
                  semanticVersion: {}
                }
              }
            },
            tagMap: {
              shape: "Sh"
            }
          }
        },
        S4r: {
          type: "structure",
          members: {
            status: {},
            reason: {}
          }
        },
        S54: {
          type: "structure",
          members: {
            arn: {},
            containerType: {},
            name: {},
            description: {},
            platform: {},
            owner: {},
            version: {},
            components: {
              shape: "So"
            },
            instanceConfiguration: {
              shape: "Sw"
            },
            dockerfileTemplateData: {},
            kmsKeyId: {},
            encrypted: {
              type: "boolean"
            },
            parentImage: {},
            dateCreated: {},
            tags: {
              shape: "Sh"
            },
            workingDirectory: {},
            targetRepository: {
              shape: "S17"
            }
          }
        },
        S5a: {
          type: "structure",
          required: [
            "timeoutMinutes"
          ],
          members: {
            arn: {},
            name: {},
            description: {},
            distributions: {
              shape: "S1c"
            },
            timeoutMinutes: {
              type: "integer"
            },
            dateCreated: {},
            dateUpdated: {},
            tags: {
              shape: "Sh"
            }
          }
        },
        S5h: {
          type: "structure",
          members: {
            status: {},
            reason: {}
          }
        },
        S5j: {
          type: "structure",
          members: {
            arn: {},
            type: {},
            name: {},
            description: {},
            platform: {},
            owner: {},
            version: {},
            components: {
              shape: "So"
            },
            parentImage: {},
            blockDeviceMappings: {
              shape: "Sx"
            },
            dateCreated: {},
            tags: {
              shape: "Sh"
            },
            workingDirectory: {},
            additionalInstanceConfiguration: {
              shape: "S2w"
            }
          }
        },
        S5l: {
          type: "structure",
          members: {
            arn: {},
            name: {},
            description: {},
            instanceTypes: {
              shape: "S31"
            },
            instanceProfileName: {},
            securityGroupIds: {
              shape: "S34"
            },
            subnetId: {},
            logging: {
              shape: "S35"
            },
            keyPair: {},
            terminateInstanceOnFailure: {
              type: "boolean"
            },
            snsTopicArn: {},
            dateCreated: {},
            dateUpdated: {},
            resourceTags: {
              shape: "S38"
            },
            instanceMetadataOptions: {
              shape: "S39"
            },
            tags: {
              shape: "Sh"
            }
          }
        },
        S5m: {
          type: "structure",
          members: {
            amis: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  region: {},
                  image: {},
                  name: {},
                  description: {},
                  state: {
                    shape: "S5h"
                  },
                  accountId: {}
                }
              }
            },
            containers: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  region: {},
                  imageUris: {
                    shape: "S1j"
                  }
                }
              }
            }
          }
        },
        S5y: {
          type: "structure",
          members: {
            arn: {},
            name: {},
            description: {},
            platform: {},
            enhancedImageMetadataEnabled: {
              type: "boolean"
            },
            imageRecipeArn: {},
            containerRecipeArn: {},
            infrastructureConfigurationArn: {},
            distributionConfigurationArn: {},
            imageTestsConfiguration: {
              shape: "S28"
            },
            schedule: {
              shape: "S2p"
            },
            status: {},
            dateCreated: {},
            dateUpdated: {},
            dateLastRun: {},
            dateNextRun: {},
            tags: {
              shape: "Sh"
            },
            imageScanningConfiguration: {
              shape: "S2a"
            },
            executionRole: {},
            workflows: {
              shape: "S2c"
            }
          }
        },
        S69: {
          type: "structure",
          members: {
            lifecycleExecutionId: {},
            lifecyclePolicyArn: {},
            resourcesImpactedSummary: {
              type: "structure",
              members: {
                hasImpactedResources: {
                  type: "boolean"
                }
              }
            },
            state: {
              shape: "S6b"
            },
            startTime: {
              type: "timestamp"
            },
            endTime: {
              type: "timestamp"
            }
          }
        },
        S6b: {
          type: "structure",
          members: {
            status: {},
            reason: {}
          }
        },
        S6j: {
          type: "structure",
          members: {
            status: {},
            reason: {}
          }
        },
        S7m: {
          type: "list",
          member: {
            shape: "S7n"
          }
        },
        S7n: {
          type: "structure",
          members: {
            name: {},
            values: {
              type: "list",
              member: {}
            }
          }
        },
        S86: {
          type: "list",
          member: {
            type: "structure",
            members: {
              arn: {},
              name: {},
              type: {},
              version: {},
              platform: {},
              osVersion: {},
              state: {
                shape: "S5h"
              },
              owner: {},
              dateCreated: {},
              outputResources: {
                shape: "S5m"
              },
              tags: {
                shape: "Sh"
              },
              buildType: {},
              imageSource: {},
              deprecationTime: {
                type: "timestamp"
              },
              lifecycleExecutionId: {}
            }
          }
        },
        S8q: {
          type: "structure",
          members: {
            all: {
              type: "long"
            },
            critical: {
              type: "long"
            },
            high: {
              type: "long"
            },
            medium: {
              type: "long"
            }
          }
        },
        S9w: {
          type: "structure",
          members: {
            status: {},
            reason: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/imagebuilder-2019-12-02.paginators.json
var require_imagebuilder_2019_12_02_paginators = __commonJS({
  "node_modules/aws-sdk/apis/imagebuilder-2019-12-02.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListComponentBuildVersions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "componentSummaryList"
        },
        ListComponents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "componentVersionList"
        },
        ListContainerRecipes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "containerRecipeSummaryList"
        },
        ListDistributionConfigurations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "distributionConfigurationSummaryList"
        },
        ListImageBuildVersions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "imageSummaryList"
        },
        ListImagePackages: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "imagePackageList"
        },
        ListImagePipelineImages: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "imageSummaryList"
        },
        ListImagePipelines: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "imagePipelineList"
        },
        ListImageRecipes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "imageRecipeSummaryList"
        },
        ListImageScanFindingAggregations: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "responses"
        },
        ListImageScanFindings: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "findings"
        },
        ListImages: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "imageVersionList"
        },
        ListInfrastructureConfigurations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "infrastructureConfigurationSummaryList"
        },
        ListLifecycleExecutionResources: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "resources"
        },
        ListLifecycleExecutions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "lifecycleExecutions"
        },
        ListLifecyclePolicies: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "lifecyclePolicySummaryList"
        },
        ListWaitingWorkflowSteps: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "steps"
        },
        ListWorkflowBuildVersions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "workflowSummaryList"
        },
        ListWorkflowExecutions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "workflowExecutions"
        },
        ListWorkflowStepExecutions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "steps"
        },
        ListWorkflows: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "workflowVersionList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/imagebuilder.js
var require_imagebuilder = __commonJS({
  "node_modules/aws-sdk/clients/imagebuilder.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["imagebuilder"] = {};
    AWS2.Imagebuilder = Service.defineService("imagebuilder", ["2019-12-02"]);
    Object.defineProperty(apiLoader.services["imagebuilder"], "2019-12-02", {
      get: function get() {
        var model = require_imagebuilder_2019_12_02_min();
        model.paginators = require_imagebuilder_2019_12_02_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Imagebuilder;
  }
});

// node_modules/aws-sdk/apis/schemas-2019-12-02.min.json
var require_schemas_2019_12_02_min = __commonJS({
  "node_modules/aws-sdk/apis/schemas-2019-12-02.min.json"(exports2, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2019-12-02",
        endpointPrefix: "schemas",
        signingName: "schemas",
        serviceFullName: "Schemas",
        serviceId: "schemas",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "schemas-2019-12-02",
        signatureVersion: "v4"
      },
      operations: {
        CreateDiscoverer: {
          http: {
            requestUri: "/v1/discoverers",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              Description: {},
              SourceArn: {},
              CrossAccount: {
                type: "boolean"
              },
              Tags: {
                shape: "S5",
                locationName: "tags"
              }
            },
            required: [
              "SourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Description: {},
              DiscovererArn: {},
              DiscovererId: {},
              SourceArn: {},
              State: {},
              CrossAccount: {
                type: "boolean"
              },
              Tags: {
                shape: "S5",
                locationName: "tags"
              }
            }
          }
        },
        CreateRegistry: {
          http: {
            requestUri: "/v1/registries/name/{registryName}",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              Description: {},
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              },
              Tags: {
                shape: "S5",
                locationName: "tags"
              }
            },
            required: [
              "RegistryName"
            ]
          },
          output: {
            type: "structure",
            members: {
              Description: {},
              RegistryArn: {},
              RegistryName: {},
              Tags: {
                shape: "S5",
                locationName: "tags"
              }
            }
          }
        },
        CreateSchema: {
          http: {
            requestUri: "/v1/registries/name/{registryName}/schemas/name/{schemaName}",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              Content: {},
              Description: {},
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              },
              SchemaName: {
                location: "uri",
                locationName: "schemaName"
              },
              Tags: {
                shape: "S5",
                locationName: "tags"
              },
              Type: {}
            },
            required: [
              "RegistryName",
              "SchemaName",
              "Type",
              "Content"
            ]
          },
          output: {
            type: "structure",
            members: {
              Description: {},
              LastModified: {
                shape: "Sf"
              },
              SchemaArn: {},
              SchemaName: {},
              SchemaVersion: {},
              Tags: {
                shape: "S5",
                locationName: "tags"
              },
              Type: {},
              VersionCreatedDate: {
                shape: "Sf"
              }
            }
          }
        },
        DeleteDiscoverer: {
          http: {
            method: "DELETE",
            requestUri: "/v1/discoverers/id/{discovererId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              DiscovererId: {
                location: "uri",
                locationName: "discovererId"
              }
            },
            required: [
              "DiscovererId"
            ]
          }
        },
        DeleteRegistry: {
          http: {
            method: "DELETE",
            requestUri: "/v1/registries/name/{registryName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              }
            },
            required: [
              "RegistryName"
            ]
          }
        },
        DeleteResourcePolicy: {
          http: {
            method: "DELETE",
            requestUri: "/v1/policy",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              RegistryName: {
                location: "querystring",
                locationName: "registryName"
              }
            }
          }
        },
        DeleteSchema: {
          http: {
            method: "DELETE",
            requestUri: "/v1/registries/name/{registryName}/schemas/name/{schemaName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              },
              SchemaName: {
                location: "uri",
                locationName: "schemaName"
              }
            },
            required: [
              "RegistryName",
              "SchemaName"
            ]
          }
        },
        DeleteSchemaVersion: {
          http: {
            method: "DELETE",
            requestUri: "/v1/registries/name/{registryName}/schemas/name/{schemaName}/version/{schemaVersion}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              },
              SchemaName: {
                location: "uri",
                locationName: "schemaName"
              },
              SchemaVersion: {
                location: "uri",
                locationName: "schemaVersion"
              }
            },
            required: [
              "SchemaVersion",
              "RegistryName",
              "SchemaName"
            ]
          }
        },
        DescribeCodeBinding: {
          http: {
            method: "GET",
            requestUri: "/v1/registries/name/{registryName}/schemas/name/{schemaName}/language/{language}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Language: {
                location: "uri",
                locationName: "language"
              },
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              },
              SchemaName: {
                location: "uri",
                locationName: "schemaName"
              },
              SchemaVersion: {
                location: "querystring",
                locationName: "schemaVersion"
              }
            },
            required: [
              "RegistryName",
              "SchemaName",
              "Language"
            ]
          },
          output: {
            type: "structure",
            members: {
              CreationDate: {
                shape: "Sf"
              },
              LastModified: {
                shape: "Sf"
              },
              SchemaVersion: {},
              Status: {}
            }
          }
        },
        DescribeDiscoverer: {
          http: {
            method: "GET",
            requestUri: "/v1/discoverers/id/{discovererId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DiscovererId: {
                location: "uri",
                locationName: "discovererId"
              }
            },
            required: [
              "DiscovererId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Description: {},
              DiscovererArn: {},
              DiscovererId: {},
              SourceArn: {},
              State: {},
              CrossAccount: {
                type: "boolean"
              },
              Tags: {
                shape: "S5",
                locationName: "tags"
              }
            }
          }
        },
        DescribeRegistry: {
          http: {
            method: "GET",
            requestUri: "/v1/registries/name/{registryName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              }
            },
            required: [
              "RegistryName"
            ]
          },
          output: {
            type: "structure",
            members: {
              Description: {},
              RegistryArn: {},
              RegistryName: {},
              Tags: {
                shape: "S5",
                locationName: "tags"
              }
            }
          }
        },
        DescribeSchema: {
          http: {
            method: "GET",
            requestUri: "/v1/registries/name/{registryName}/schemas/name/{schemaName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              },
              SchemaName: {
                location: "uri",
                locationName: "schemaName"
              },
              SchemaVersion: {
                location: "querystring",
                locationName: "schemaVersion"
              }
            },
            required: [
              "RegistryName",
              "SchemaName"
            ]
          },
          output: {
            type: "structure",
            members: {
              Content: {},
              Description: {},
              LastModified: {
                shape: "Sf"
              },
              SchemaArn: {},
              SchemaName: {},
              SchemaVersion: {},
              Tags: {
                shape: "S5",
                locationName: "tags"
              },
              Type: {},
              VersionCreatedDate: {
                shape: "Sf"
              }
            }
          }
        },
        ExportSchema: {
          http: {
            method: "GET",
            requestUri: "/v1/registries/name/{registryName}/schemas/name/{schemaName}/export",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              },
              SchemaName: {
                location: "uri",
                locationName: "schemaName"
              },
              SchemaVersion: {
                location: "querystring",
                locationName: "schemaVersion"
              },
              Type: {
                location: "querystring",
                locationName: "type"
              }
            },
            required: [
              "RegistryName",
              "SchemaName",
              "Type"
            ]
          },
          output: {
            type: "structure",
            members: {
              Content: {},
              SchemaArn: {},
              SchemaName: {},
              SchemaVersion: {},
              Type: {}
            }
          }
        },
        GetCodeBindingSource: {
          http: {
            method: "GET",
            requestUri: "/v1/registries/name/{registryName}/schemas/name/{schemaName}/language/{language}/source",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Language: {
                location: "uri",
                locationName: "language"
              },
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              },
              SchemaName: {
                location: "uri",
                locationName: "schemaName"
              },
              SchemaVersion: {
                location: "querystring",
                locationName: "schemaVersion"
              }
            },
            required: [
              "RegistryName",
              "SchemaName",
              "Language"
            ]
          },
          output: {
            type: "structure",
            members: {
              Body: {
                type: "blob"
              }
            },
            payload: "Body"
          }
        },
        GetDiscoveredSchema: {
          http: {
            requestUri: "/v1/discover",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Events: {
                type: "list",
                member: {}
              },
              Type: {}
            },
            required: [
              "Type",
              "Events"
            ]
          },
          output: {
            type: "structure",
            members: {
              Content: {}
            }
          }
        },
        GetResourcePolicy: {
          http: {
            method: "GET",
            requestUri: "/v1/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              RegistryName: {
                location: "querystring",
                locationName: "registryName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {
                jsonvalue: true
              },
              RevisionId: {}
            }
          }
        },
        ListDiscoverers: {
          http: {
            method: "GET",
            requestUri: "/v1/discoverers",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DiscovererIdPrefix: {
                location: "querystring",
                locationName: "discovererIdPrefix"
              },
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              SourceArnPrefix: {
                location: "querystring",
                locationName: "sourceArnPrefix"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Discoverers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DiscovererArn: {},
                    DiscovererId: {},
                    SourceArn: {},
                    State: {},
                    CrossAccount: {
                      type: "boolean"
                    },
                    Tags: {
                      shape: "S5",
                      locationName: "tags"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListRegistries: {
          http: {
            method: "GET",
            requestUri: "/v1/registries",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              RegistryNamePrefix: {
                location: "querystring",
                locationName: "registryNamePrefix"
              },
              Scope: {
                location: "querystring",
                locationName: "scope"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Registries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RegistryArn: {},
                    RegistryName: {},
                    Tags: {
                      shape: "S5",
                      locationName: "tags"
                    }
                  }
                }
              }
            }
          }
        },
        ListSchemaVersions: {
          http: {
            method: "GET",
            requestUri: "/v1/registries/name/{registryName}/schemas/name/{schemaName}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              },
              SchemaName: {
                location: "uri",
                locationName: "schemaName"
              }
            },
            required: [
              "RegistryName",
              "SchemaName"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              SchemaVersions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SchemaArn: {},
                    SchemaName: {},
                    SchemaVersion: {},
                    Type: {}
                  }
                }
              }
            }
          }
        },
        ListSchemas: {
          http: {
            method: "GET",
            requestUri: "/v1/registries/name/{registryName}/schemas",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              },
              SchemaNamePrefix: {
                location: "querystring",
                locationName: "schemaNamePrefix"
              }
            },
            required: [
              "RegistryName"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Schemas: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LastModified: {
                      shape: "Sf"
                    },
                    SchemaArn: {},
                    SchemaName: {},
                    Tags: {
                      shape: "S5",
                      locationName: "tags"
                    },
                    VersionCount: {
                      type: "long"
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resource-arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              }
            },
            required: [
              "ResourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S5",
                locationName: "tags"
              }
            }
          }
        },
        PutCodeBinding: {
          http: {
            requestUri: "/v1/registries/name/{registryName}/schemas/name/{schemaName}/language/{language}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              Language: {
                location: "uri",
                locationName: "language"
              },
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              },
              SchemaName: {
                location: "uri",
                locationName: "schemaName"
              },
              SchemaVersion: {
                location: "querystring",
                locationName: "schemaVersion"
              }
            },
            required: [
              "RegistryName",
              "SchemaName",
              "Language"
            ]
          },
          output: {
            type: "structure",
            members: {
              CreationDate: {
                shape: "Sf"
              },
              LastModified: {
                shape: "Sf"
              },
              SchemaVersion: {},
              Status: {}
            }
          }
        },
        PutResourcePolicy: {
          http: {
            method: "PUT",
            requestUri: "/v1/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Policy: {
                jsonvalue: true
              },
              RegistryName: {
                location: "querystring",
                locationName: "registryName"
              },
              RevisionId: {}
            },
            required: [
              "Policy"
            ]
          },
          output: {
            type: "structure",
            members: {
              Policy: {
                jsonvalue: true
              },
              RevisionId: {}
            }
          }
        },
        SearchSchemas: {
          http: {
            method: "GET",
            requestUri: "/v1/registries/name/{registryName}/schemas/search",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Keywords: {
                location: "querystring",
                locationName: "keywords"
              },
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              }
            },
            required: [
              "RegistryName",
              "Keywords"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Schemas: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RegistryName: {},
                    SchemaArn: {},
                    SchemaName: {},
                    SchemaVersions: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          CreatedDate: {
                            shape: "Sf"
                          },
                          SchemaVersion: {},
                          Type: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        StartDiscoverer: {
          http: {
            requestUri: "/v1/discoverers/id/{discovererId}/start",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DiscovererId: {
                location: "uri",
                locationName: "discovererId"
              }
            },
            required: [
              "DiscovererId"
            ]
          },
          output: {
            type: "structure",
            members: {
              DiscovererId: {},
              State: {}
            }
          }
        },
        StopDiscoverer: {
          http: {
            requestUri: "/v1/discoverers/id/{discovererId}/stop",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DiscovererId: {
                location: "uri",
                locationName: "discovererId"
              }
            },
            required: [
              "DiscovererId"
            ]
          },
          output: {
            type: "structure",
            members: {
              DiscovererId: {},
              State: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              Tags: {
                shape: "S5",
                locationName: "tags"
              }
            },
            required: [
              "ResourceArn",
              "Tags"
            ]
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            },
            required: [
              "TagKeys",
              "ResourceArn"
            ]
          }
        },
        UpdateDiscoverer: {
          http: {
            method: "PUT",
            requestUri: "/v1/discoverers/id/{discovererId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Description: {},
              DiscovererId: {
                location: "uri",
                locationName: "discovererId"
              },
              CrossAccount: {
                type: "boolean"
              }
            },
            required: [
              "DiscovererId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Description: {},
              DiscovererArn: {},
              DiscovererId: {},
              SourceArn: {},
              State: {},
              CrossAccount: {
                type: "boolean"
              },
              Tags: {
                shape: "S5",
                locationName: "tags"
              }
            }
          }
        },
        UpdateRegistry: {
          http: {
            method: "PUT",
            requestUri: "/v1/registries/name/{registryName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Description: {},
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              }
            },
            required: [
              "RegistryName"
            ]
          },
          output: {
            type: "structure",
            members: {
              Description: {},
              RegistryArn: {},
              RegistryName: {},
              Tags: {
                shape: "S5",
                locationName: "tags"
              }
            }
          }
        },
        UpdateSchema: {
          http: {
            method: "PUT",
            requestUri: "/v1/registries/name/{registryName}/schemas/name/{schemaName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClientTokenId: {
                idempotencyToken: true
              },
              Content: {},
              Description: {},
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              },
              SchemaName: {
                location: "uri",
                locationName: "schemaName"
              },
              Type: {}
            },
            required: [
              "RegistryName",
              "SchemaName"
            ]
          },
          output: {
            type: "structure",
            members: {
              Description: {},
              LastModified: {
                shape: "Sf"
              },
              SchemaArn: {},
              SchemaName: {},
              SchemaVersion: {},
              Tags: {
                shape: "S5",
                locationName: "tags"
              },
              Type: {},
              VersionCreatedDate: {
                shape: "Sf"
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "map",
          key: {},
          value: {}
        },
        Sf: {
          type: "timestamp",
          timestampFormat: "iso8601"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/schemas-2019-12-02.paginators.json
var require_schemas_2019_12_02_paginators = __commonJS({
  "node_modules/aws-sdk/apis/schemas-2019-12-02.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListDiscoverers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "Discoverers"
        },
        ListRegistries: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "Registries"
        },
        ListSchemaVersions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "SchemaVersions"
        },
        ListSchemas: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "Schemas"
        },
        SearchSchemas: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "Schemas"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/schemas-2019-12-02.waiters2.json
var require_schemas_2019_12_02_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/schemas-2019-12-02.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        CodeBindingExists: {
          description: "Wait until code binding is generated",
          delay: 2,
          operation: "DescribeCodeBinding",
          maxAttempts: 30,
          acceptors: [
            {
              expected: "CREATE_COMPLETE",
              matcher: "path",
              state: "success",
              argument: "Status"
            },
            {
              expected: "CREATE_IN_PROGRESS",
              matcher: "path",
              state: "retry",
              argument: "Status"
            },
            {
              expected: "CREATE_FAILED",
              matcher: "path",
              state: "failure",
              argument: "Status"
            },
            {
              matcher: "error",
              expected: "NotFoundException",
              state: "failure"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/schemas.js
var require_schemas = __commonJS({
  "node_modules/aws-sdk/clients/schemas.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["schemas"] = {};
    AWS2.Schemas = Service.defineService("schemas", ["2019-12-02"]);
    Object.defineProperty(apiLoader.services["schemas"], "2019-12-02", {
      get: function get() {
        var model = require_schemas_2019_12_02_min();
        model.paginators = require_schemas_2019_12_02_paginators().pagination;
        model.waiters = require_schemas_2019_12_02_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Schemas;
  }
});

// node_modules/aws-sdk/apis/accessanalyzer-2019-11-01.min.json
var require_accessanalyzer_2019_11_01_min = __commonJS({
  "node_modules/aws-sdk/apis/accessanalyzer-2019-11-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-11-01",
        endpointPrefix: "access-analyzer",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Access Analyzer",
        serviceId: "AccessAnalyzer",
        signatureVersion: "v4",
        signingName: "access-analyzer",
        uid: "accessanalyzer-2019-11-01"
      },
      operations: {
        ApplyArchiveRule: {
          http: {
            method: "PUT",
            requestUri: "/archive-rule",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerArn",
              "ruleName"
            ],
            members: {
              analyzerArn: {},
              ruleName: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          idempotent: true
        },
        CancelPolicyGeneration: {
          http: {
            method: "PUT",
            requestUri: "/policy/generation/{jobId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        CheckAccessNotGranted: {
          http: {
            requestUri: "/policy/check-access-not-granted",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "policyDocument",
              "access",
              "policyType"
            ],
            members: {
              policyDocument: {
                shape: "S9"
              },
              access: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "actions"
                  ],
                  members: {
                    actions: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              policyType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              result: {},
              message: {},
              reasons: {
                shape: "Sh"
              }
            }
          }
        },
        CheckNoNewAccess: {
          http: {
            requestUri: "/policy/check-no-new-access",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "newPolicyDocument",
              "existingPolicyDocument",
              "policyType"
            ],
            members: {
              newPolicyDocument: {
                shape: "S9"
              },
              existingPolicyDocument: {
                shape: "S9"
              },
              policyType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              result: {},
              message: {},
              reasons: {
                shape: "Sh"
              }
            }
          }
        },
        CreateAccessPreview: {
          http: {
            method: "PUT",
            requestUri: "/access-preview",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerArn",
              "configurations"
            ],
            members: {
              analyzerArn: {},
              configurations: {
                shape: "So"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          idempotent: true
        },
        CreateAnalyzer: {
          http: {
            method: "PUT",
            requestUri: "/analyzer",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerName",
              "type"
            ],
            members: {
              analyzerName: {},
              type: {},
              archiveRules: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ruleName",
                    "filter"
                  ],
                  members: {
                    ruleName: {},
                    filter: {
                      shape: "S2t"
                    }
                  }
                }
              },
              tags: {
                shape: "S2w"
              },
              clientToken: {
                idempotencyToken: true
              },
              configuration: {
                shape: "S2x"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {}
            }
          },
          idempotent: true
        },
        CreateArchiveRule: {
          http: {
            method: "PUT",
            requestUri: "/analyzer/{analyzerName}/archive-rule",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerName",
              "ruleName",
              "filter"
            ],
            members: {
              analyzerName: {
                location: "uri",
                locationName: "analyzerName"
              },
              ruleName: {},
              filter: {
                shape: "S2t"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          idempotent: true
        },
        DeleteAnalyzer: {
          http: {
            method: "DELETE",
            requestUri: "/analyzer/{analyzerName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerName"
            ],
            members: {
              analyzerName: {
                location: "uri",
                locationName: "analyzerName"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          idempotent: true
        },
        DeleteArchiveRule: {
          http: {
            method: "DELETE",
            requestUri: "/analyzer/{analyzerName}/archive-rule/{ruleName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerName",
              "ruleName"
            ],
            members: {
              analyzerName: {
                location: "uri",
                locationName: "analyzerName"
              },
              ruleName: {
                location: "uri",
                locationName: "ruleName"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          idempotent: true
        },
        GetAccessPreview: {
          http: {
            method: "GET",
            requestUri: "/access-preview/{accessPreviewId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "accessPreviewId",
              "analyzerArn"
            ],
            members: {
              accessPreviewId: {
                location: "uri",
                locationName: "accessPreviewId"
              },
              analyzerArn: {
                location: "querystring",
                locationName: "analyzerArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "accessPreview"
            ],
            members: {
              accessPreview: {
                type: "structure",
                required: [
                  "id",
                  "analyzerArn",
                  "configurations",
                  "createdAt",
                  "status"
                ],
                members: {
                  id: {},
                  analyzerArn: {},
                  configurations: {
                    shape: "So"
                  },
                  createdAt: {
                    shape: "S36"
                  },
                  status: {},
                  statusReason: {
                    shape: "S38"
                  }
                }
              }
            }
          }
        },
        GetAnalyzedResource: {
          http: {
            method: "GET",
            requestUri: "/analyzed-resource",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerArn",
              "resourceArn"
            ],
            members: {
              analyzerArn: {
                location: "querystring",
                locationName: "analyzerArn"
              },
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resource: {
                type: "structure",
                required: [
                  "resourceArn",
                  "resourceType",
                  "createdAt",
                  "analyzedAt",
                  "updatedAt",
                  "isPublic",
                  "resourceOwnerAccount"
                ],
                members: {
                  resourceArn: {},
                  resourceType: {},
                  createdAt: {
                    shape: "S36"
                  },
                  analyzedAt: {
                    shape: "S36"
                  },
                  updatedAt: {
                    shape: "S36"
                  },
                  isPublic: {
                    type: "boolean"
                  },
                  actions: {
                    shape: "S3f"
                  },
                  sharedVia: {
                    type: "list",
                    member: {}
                  },
                  status: {},
                  resourceOwnerAccount: {},
                  error: {}
                }
              }
            }
          }
        },
        GetAnalyzer: {
          http: {
            method: "GET",
            requestUri: "/analyzer/{analyzerName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerName"
            ],
            members: {
              analyzerName: {
                location: "uri",
                locationName: "analyzerName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "analyzer"
            ],
            members: {
              analyzer: {
                shape: "S3k"
              }
            }
          }
        },
        GetArchiveRule: {
          http: {
            method: "GET",
            requestUri: "/analyzer/{analyzerName}/archive-rule/{ruleName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerName",
              "ruleName"
            ],
            members: {
              analyzerName: {
                location: "uri",
                locationName: "analyzerName"
              },
              ruleName: {
                location: "uri",
                locationName: "ruleName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "archiveRule"
            ],
            members: {
              archiveRule: {
                shape: "S3q"
              }
            }
          }
        },
        GetFinding: {
          http: {
            method: "GET",
            requestUri: "/finding/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerArn",
              "id"
            ],
            members: {
              analyzerArn: {
                location: "querystring",
                locationName: "analyzerArn"
              },
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              finding: {
                type: "structure",
                required: [
                  "id",
                  "resourceType",
                  "condition",
                  "createdAt",
                  "analyzedAt",
                  "updatedAt",
                  "status",
                  "resourceOwnerAccount"
                ],
                members: {
                  id: {},
                  principal: {
                    shape: "S3v"
                  },
                  action: {
                    shape: "S3f"
                  },
                  resource: {},
                  isPublic: {
                    type: "boolean"
                  },
                  resourceType: {},
                  condition: {
                    shape: "S3w"
                  },
                  createdAt: {
                    shape: "S36"
                  },
                  analyzedAt: {
                    shape: "S36"
                  },
                  updatedAt: {
                    shape: "S36"
                  },
                  status: {},
                  resourceOwnerAccount: {},
                  error: {},
                  sources: {
                    shape: "S3x"
                  }
                }
              }
            }
          }
        },
        GetFindingV2: {
          http: {
            method: "GET",
            requestUri: "/findingv2/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerArn",
              "id"
            ],
            members: {
              analyzerArn: {
                location: "querystring",
                locationName: "analyzerArn"
              },
              id: {
                location: "uri",
                locationName: "id"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "analyzedAt",
              "createdAt",
              "id",
              "resourceType",
              "resourceOwnerAccount",
              "status",
              "updatedAt",
              "findingDetails"
            ],
            members: {
              analyzedAt: {
                shape: "S36"
              },
              createdAt: {
                shape: "S36"
              },
              error: {},
              id: {},
              nextToken: {},
              resource: {},
              resourceType: {},
              resourceOwnerAccount: {},
              status: {},
              updatedAt: {
                shape: "S36"
              },
              findingDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    externalAccessDetails: {
                      type: "structure",
                      required: [
                        "condition"
                      ],
                      members: {
                        action: {
                          shape: "S3f"
                        },
                        condition: {
                          shape: "S3w"
                        },
                        isPublic: {
                          type: "boolean"
                        },
                        principal: {
                          shape: "S3v"
                        },
                        sources: {
                          shape: "S3x"
                        }
                      }
                    },
                    unusedPermissionDetails: {
                      type: "structure",
                      required: [
                        "serviceNamespace"
                      ],
                      members: {
                        actions: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "action"
                            ],
                            members: {
                              action: {},
                              lastAccessed: {
                                shape: "S36"
                              }
                            }
                          }
                        },
                        serviceNamespace: {},
                        lastAccessed: {
                          shape: "S36"
                        }
                      }
                    },
                    unusedIamUserAccessKeyDetails: {
                      type: "structure",
                      required: [
                        "accessKeyId"
                      ],
                      members: {
                        accessKeyId: {},
                        lastAccessed: {
                          shape: "S36"
                        }
                      }
                    },
                    unusedIamRoleDetails: {
                      type: "structure",
                      members: {
                        lastAccessed: {
                          shape: "S36"
                        }
                      }
                    },
                    unusedIamUserPasswordDetails: {
                      type: "structure",
                      members: {
                        lastAccessed: {
                          shape: "S36"
                        }
                      }
                    }
                  },
                  union: true
                }
              },
              findingType: {}
            }
          }
        },
        GetGeneratedPolicy: {
          http: {
            method: "GET",
            requestUri: "/policy/generation/{jobId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              includeResourcePlaceholders: {
                location: "querystring",
                locationName: "includeResourcePlaceholders",
                type: "boolean"
              },
              includeServiceLevelTemplate: {
                location: "querystring",
                locationName: "includeServiceLevelTemplate",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobDetails",
              "generatedPolicyResult"
            ],
            members: {
              jobDetails: {
                type: "structure",
                required: [
                  "jobId",
                  "status",
                  "startedOn"
                ],
                members: {
                  jobId: {},
                  status: {},
                  startedOn: {
                    shape: "S36"
                  },
                  completedOn: {
                    shape: "S36"
                  },
                  jobError: {
                    type: "structure",
                    required: [
                      "code",
                      "message"
                    ],
                    members: {
                      code: {},
                      message: {}
                    }
                  }
                }
              },
              generatedPolicyResult: {
                type: "structure",
                required: [
                  "properties"
                ],
                members: {
                  properties: {
                    type: "structure",
                    required: [
                      "principalArn"
                    ],
                    members: {
                      isComplete: {
                        type: "boolean"
                      },
                      principalArn: {},
                      cloudTrailProperties: {
                        type: "structure",
                        required: [
                          "trailProperties",
                          "startTime",
                          "endTime"
                        ],
                        members: {
                          trailProperties: {
                            type: "list",
                            member: {
                              type: "structure",
                              required: [
                                "cloudTrailArn"
                              ],
                              members: {
                                cloudTrailArn: {},
                                regions: {
                                  shape: "S4r"
                                },
                                allRegions: {
                                  type: "boolean"
                                }
                              }
                            }
                          },
                          startTime: {
                            shape: "S36"
                          },
                          endTime: {
                            shape: "S36"
                          }
                        }
                      }
                    }
                  },
                  generatedPolicies: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "policy"
                      ],
                      members: {
                        policy: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        ListAccessPreviewFindings: {
          http: {
            requestUri: "/access-preview/{accessPreviewId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "accessPreviewId",
              "analyzerArn"
            ],
            members: {
              accessPreviewId: {
                location: "uri",
                locationName: "accessPreviewId"
              },
              analyzerArn: {},
              filter: {
                shape: "S2t"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "findings"
            ],
            members: {
              findings: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "resourceType",
                    "createdAt",
                    "changeType",
                    "status",
                    "resourceOwnerAccount"
                  ],
                  members: {
                    id: {},
                    existingFindingId: {},
                    existingFindingStatus: {},
                    principal: {
                      shape: "S3v"
                    },
                    action: {
                      shape: "S3f"
                    },
                    condition: {
                      shape: "S3w"
                    },
                    resource: {},
                    isPublic: {
                      type: "boolean"
                    },
                    resourceType: {},
                    createdAt: {
                      shape: "S36"
                    },
                    changeType: {},
                    status: {},
                    resourceOwnerAccount: {},
                    error: {},
                    sources: {
                      shape: "S3x"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAccessPreviews: {
          http: {
            method: "GET",
            requestUri: "/access-preview",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerArn"
            ],
            members: {
              analyzerArn: {
                location: "querystring",
                locationName: "analyzerArn"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "accessPreviews"
            ],
            members: {
              accessPreviews: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "analyzerArn",
                    "createdAt",
                    "status"
                  ],
                  members: {
                    id: {},
                    analyzerArn: {},
                    createdAt: {
                      shape: "S36"
                    },
                    status: {},
                    statusReason: {
                      shape: "S38"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAnalyzedResources: {
          http: {
            requestUri: "/analyzed-resource",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerArn"
            ],
            members: {
              analyzerArn: {},
              resourceType: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "analyzedResources"
            ],
            members: {
              analyzedResources: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "resourceArn",
                    "resourceOwnerAccount",
                    "resourceType"
                  ],
                  members: {
                    resourceArn: {},
                    resourceOwnerAccount: {},
                    resourceType: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAnalyzers: {
          http: {
            method: "GET",
            requestUri: "/analyzer",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              type: {
                location: "querystring",
                locationName: "type"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "analyzers"
            ],
            members: {
              analyzers: {
                type: "list",
                member: {
                  shape: "S3k"
                }
              },
              nextToken: {}
            }
          }
        },
        ListArchiveRules: {
          http: {
            method: "GET",
            requestUri: "/analyzer/{analyzerName}/archive-rule",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerName"
            ],
            members: {
              analyzerName: {
                location: "uri",
                locationName: "analyzerName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "archiveRules"
            ],
            members: {
              archiveRules: {
                type: "list",
                member: {
                  shape: "S3q"
                }
              },
              nextToken: {}
            }
          }
        },
        ListFindings: {
          http: {
            requestUri: "/finding",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerArn"
            ],
            members: {
              analyzerArn: {},
              filter: {
                shape: "S2t"
              },
              sort: {
                shape: "S5f"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "findings"
            ],
            members: {
              findings: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "resourceType",
                    "condition",
                    "createdAt",
                    "analyzedAt",
                    "updatedAt",
                    "status",
                    "resourceOwnerAccount"
                  ],
                  members: {
                    id: {},
                    principal: {
                      shape: "S3v"
                    },
                    action: {
                      shape: "S3f"
                    },
                    resource: {},
                    isPublic: {
                      type: "boolean"
                    },
                    resourceType: {},
                    condition: {
                      shape: "S3w"
                    },
                    createdAt: {
                      shape: "S36"
                    },
                    analyzedAt: {
                      shape: "S36"
                    },
                    updatedAt: {
                      shape: "S36"
                    },
                    status: {},
                    resourceOwnerAccount: {},
                    error: {},
                    sources: {
                      shape: "S3x"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListFindingsV2: {
          http: {
            requestUri: "/findingv2",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerArn"
            ],
            members: {
              analyzerArn: {},
              filter: {
                shape: "S2t"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              sort: {
                shape: "S5f"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "findings"
            ],
            members: {
              findings: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "analyzedAt",
                    "createdAt",
                    "id",
                    "resourceType",
                    "resourceOwnerAccount",
                    "status",
                    "updatedAt"
                  ],
                  members: {
                    analyzedAt: {
                      shape: "S36"
                    },
                    createdAt: {
                      shape: "S36"
                    },
                    error: {},
                    id: {},
                    resource: {},
                    resourceType: {},
                    resourceOwnerAccount: {},
                    status: {},
                    updatedAt: {
                      shape: "S36"
                    },
                    findingType: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListPolicyGenerations: {
          http: {
            method: "GET",
            requestUri: "/policy/generation",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              principalArn: {
                location: "querystring",
                locationName: "principalArn"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "policyGenerations"
            ],
            members: {
              policyGenerations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "jobId",
                    "principalArn",
                    "status",
                    "startedOn"
                  ],
                  members: {
                    jobId: {},
                    principalArn: {},
                    status: {},
                    startedOn: {
                      shape: "S36"
                    },
                    completedOn: {
                      shape: "S36"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S2w"
              }
            }
          }
        },
        StartPolicyGeneration: {
          http: {
            method: "PUT",
            requestUri: "/policy/generation",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "policyGenerationDetails"
            ],
            members: {
              policyGenerationDetails: {
                type: "structure",
                required: [
                  "principalArn"
                ],
                members: {
                  principalArn: {}
                }
              },
              cloudTrailDetails: {
                type: "structure",
                required: [
                  "trails",
                  "accessRole",
                  "startTime"
                ],
                members: {
                  trails: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "cloudTrailArn"
                      ],
                      members: {
                        cloudTrailArn: {},
                        regions: {
                          shape: "S4r"
                        },
                        allRegions: {
                          type: "boolean"
                        }
                      }
                    }
                  },
                  accessRole: {},
                  startTime: {
                    shape: "S36"
                  },
                  endTime: {
                    shape: "S36"
                  }
                }
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {}
            }
          },
          idempotent: true
        },
        StartResourceScan: {
          http: {
            requestUri: "/resource/scan",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerArn",
              "resourceArn"
            ],
            members: {
              analyzerArn: {},
              resourceArn: {},
              resourceOwnerAccount: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S2w"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateArchiveRule: {
          http: {
            method: "PUT",
            requestUri: "/analyzer/{analyzerName}/archive-rule/{ruleName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerName",
              "ruleName",
              "filter"
            ],
            members: {
              analyzerName: {
                location: "uri",
                locationName: "analyzerName"
              },
              ruleName: {
                location: "uri",
                locationName: "ruleName"
              },
              filter: {
                shape: "S2t"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          idempotent: true
        },
        UpdateFindings: {
          http: {
            method: "PUT",
            requestUri: "/finding",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerArn",
              "status"
            ],
            members: {
              analyzerArn: {},
              status: {},
              ids: {
                type: "list",
                member: {}
              },
              resourceArn: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          idempotent: true
        },
        ValidatePolicy: {
          http: {
            requestUri: "/policy/validation",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "policyDocument",
              "policyType"
            ],
            members: {
              locale: {},
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              policyDocument: {},
              policyType: {},
              validatePolicyResourceType: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "findings"
            ],
            members: {
              findings: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "findingDetails",
                    "findingType",
                    "issueCode",
                    "learnMoreLink",
                    "locations"
                  ],
                  members: {
                    findingDetails: {},
                    findingType: {},
                    issueCode: {},
                    learnMoreLink: {},
                    locations: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "path",
                          "span"
                        ],
                        members: {
                          path: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                index: {
                                  type: "integer"
                                },
                                key: {},
                                substring: {
                                  type: "structure",
                                  required: [
                                    "start",
                                    "length"
                                  ],
                                  members: {
                                    start: {
                                      type: "integer"
                                    },
                                    length: {
                                      type: "integer"
                                    }
                                  }
                                },
                                value: {}
                              },
                              union: true
                            }
                          },
                          span: {
                            type: "structure",
                            required: [
                              "start",
                              "end"
                            ],
                            members: {
                              start: {
                                shape: "S6t"
                              },
                              end: {
                                shape: "S6t"
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        }
      },
      shapes: {
        S9: {
          type: "string",
          sensitive: true
        },
        Sh: {
          type: "list",
          member: {
            type: "structure",
            members: {
              description: {},
              statementIndex: {
                type: "integer"
              },
              statementId: {}
            }
          }
        },
        So: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              ebsSnapshot: {
                type: "structure",
                members: {
                  userIds: {
                    type: "list",
                    member: {}
                  },
                  groups: {
                    type: "list",
                    member: {}
                  },
                  kmsKeyId: {}
                }
              },
              ecrRepository: {
                type: "structure",
                members: {
                  repositoryPolicy: {}
                }
              },
              iamRole: {
                type: "structure",
                members: {
                  trustPolicy: {}
                }
              },
              efsFileSystem: {
                type: "structure",
                members: {
                  fileSystemPolicy: {}
                }
              },
              kmsKey: {
                type: "structure",
                members: {
                  keyPolicies: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  grants: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "operations",
                        "granteePrincipal",
                        "issuingAccount"
                      ],
                      members: {
                        operations: {
                          type: "list",
                          member: {}
                        },
                        granteePrincipal: {},
                        retiringPrincipal: {},
                        constraints: {
                          type: "structure",
                          members: {
                            encryptionContextEquals: {
                              shape: "S1e"
                            },
                            encryptionContextSubset: {
                              shape: "S1e"
                            }
                          }
                        },
                        issuingAccount: {}
                      }
                    }
                  }
                }
              },
              rdsDbClusterSnapshot: {
                type: "structure",
                members: {
                  attributes: {
                    type: "map",
                    key: {},
                    value: {
                      type: "structure",
                      members: {
                        accountIds: {
                          type: "list",
                          member: {}
                        }
                      },
                      union: true
                    }
                  },
                  kmsKeyId: {}
                }
              },
              rdsDbSnapshot: {
                type: "structure",
                members: {
                  attributes: {
                    type: "map",
                    key: {},
                    value: {
                      type: "structure",
                      members: {
                        accountIds: {
                          type: "list",
                          member: {}
                        }
                      },
                      union: true
                    }
                  },
                  kmsKeyId: {}
                }
              },
              secretsManagerSecret: {
                type: "structure",
                members: {
                  kmsKeyId: {},
                  secretPolicy: {}
                }
              },
              s3Bucket: {
                type: "structure",
                members: {
                  bucketPolicy: {},
                  bucketAclGrants: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "permission",
                        "grantee"
                      ],
                      members: {
                        permission: {},
                        grantee: {
                          type: "structure",
                          members: {
                            id: {},
                            uri: {}
                          },
                          union: true
                        }
                      }
                    }
                  },
                  bucketPublicAccessBlock: {
                    shape: "S27"
                  },
                  accessPoints: {
                    type: "map",
                    key: {},
                    value: {
                      type: "structure",
                      members: {
                        accessPointPolicy: {},
                        publicAccessBlock: {
                          shape: "S27"
                        },
                        networkOrigin: {
                          type: "structure",
                          members: {
                            vpcConfiguration: {
                              type: "structure",
                              required: [
                                "vpcId"
                              ],
                              members: {
                                vpcId: {}
                              }
                            },
                            internetConfiguration: {
                              type: "structure",
                              members: {}
                            }
                          },
                          union: true
                        }
                      }
                    }
                  }
                }
              },
              snsTopic: {
                type: "structure",
                members: {
                  topicPolicy: {}
                }
              },
              sqsQueue: {
                type: "structure",
                members: {
                  queuePolicy: {}
                }
              },
              s3ExpressDirectoryBucket: {
                type: "structure",
                members: {
                  bucketPolicy: {}
                }
              }
            },
            union: true
          }
        },
        S1e: {
          type: "map",
          key: {},
          value: {}
        },
        S27: {
          type: "structure",
          required: [
            "ignorePublicAcls",
            "restrictPublicBuckets"
          ],
          members: {
            ignorePublicAcls: {
              type: "boolean"
            },
            restrictPublicBuckets: {
              type: "boolean"
            }
          }
        },
        S2t: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              eq: {
                shape: "S2v"
              },
              neq: {
                shape: "S2v"
              },
              contains: {
                shape: "S2v"
              },
              exists: {
                type: "boolean"
              }
            }
          }
        },
        S2v: {
          type: "list",
          member: {}
        },
        S2w: {
          type: "map",
          key: {},
          value: {}
        },
        S2x: {
          type: "structure",
          members: {
            unusedAccess: {
              type: "structure",
              members: {
                unusedAccessAge: {
                  type: "integer"
                }
              }
            }
          },
          union: true
        },
        S36: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S38: {
          type: "structure",
          required: [
            "code"
          ],
          members: {
            code: {}
          }
        },
        S3f: {
          type: "list",
          member: {}
        },
        S3k: {
          type: "structure",
          required: [
            "arn",
            "name",
            "type",
            "createdAt",
            "status"
          ],
          members: {
            arn: {},
            name: {},
            type: {},
            createdAt: {
              shape: "S36"
            },
            lastResourceAnalyzed: {},
            lastResourceAnalyzedAt: {
              shape: "S36"
            },
            tags: {
              shape: "S2w"
            },
            status: {},
            statusReason: {
              type: "structure",
              required: [
                "code"
              ],
              members: {
                code: {}
              }
            },
            configuration: {
              shape: "S2x"
            }
          }
        },
        S3q: {
          type: "structure",
          required: [
            "ruleName",
            "filter",
            "createdAt",
            "updatedAt"
          ],
          members: {
            ruleName: {},
            filter: {
              shape: "S2t"
            },
            createdAt: {
              shape: "S36"
            },
            updatedAt: {
              shape: "S36"
            }
          }
        },
        S3v: {
          type: "map",
          key: {},
          value: {}
        },
        S3w: {
          type: "map",
          key: {},
          value: {}
        },
        S3x: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "type"
            ],
            members: {
              type: {},
              detail: {
                type: "structure",
                members: {
                  accessPointArn: {},
                  accessPointAccount: {}
                }
              }
            }
          }
        },
        S4r: {
          type: "list",
          member: {}
        },
        S5f: {
          type: "structure",
          members: {
            attributeName: {},
            orderBy: {}
          }
        },
        S6t: {
          type: "structure",
          required: [
            "line",
            "column",
            "offset"
          ],
          members: {
            line: {
              type: "integer"
            },
            column: {
              type: "integer"
            },
            offset: {
              type: "integer"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/accessanalyzer-2019-11-01.paginators.json
var require_accessanalyzer_2019_11_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/accessanalyzer-2019-11-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetFindingV2: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "findingDetails"
        },
        ListAccessPreviewFindings: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "findings"
        },
        ListAccessPreviews: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "accessPreviews"
        },
        ListAnalyzedResources: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "analyzedResources"
        },
        ListAnalyzers: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "analyzers"
        },
        ListArchiveRules: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "archiveRules"
        },
        ListFindings: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "findings"
        },
        ListFindingsV2: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "findings"
        },
        ListPolicyGenerations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "policyGenerations"
        },
        ValidatePolicy: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "findings"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/accessanalyzer.js
var require_accessanalyzer = __commonJS({
  "node_modules/aws-sdk/clients/accessanalyzer.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["accessanalyzer"] = {};
    AWS2.AccessAnalyzer = Service.defineService("accessanalyzer", ["2019-11-01"]);
    Object.defineProperty(apiLoader.services["accessanalyzer"], "2019-11-01", {
      get: function get() {
        var model = require_accessanalyzer_2019_11_01_min();
        model.paginators = require_accessanalyzer_2019_11_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.AccessAnalyzer;
  }
});

// node_modules/aws-sdk/apis/codeguru-reviewer-2019-09-19.min.json
var require_codeguru_reviewer_2019_09_19_min = __commonJS({
  "node_modules/aws-sdk/apis/codeguru-reviewer-2019-09-19.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-09-19",
        endpointPrefix: "codeguru-reviewer",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "CodeGuruReviewer",
        serviceFullName: "Amazon CodeGuru Reviewer",
        serviceId: "CodeGuru Reviewer",
        signatureVersion: "v4",
        signingName: "codeguru-reviewer",
        uid: "codeguru-reviewer-2019-09-19"
      },
      operations: {
        AssociateRepository: {
          http: {
            requestUri: "/associations"
          },
          input: {
            type: "structure",
            required: [
              "Repository"
            ],
            members: {
              Repository: {
                type: "structure",
                members: {
                  CodeCommit: {
                    type: "structure",
                    required: [
                      "Name"
                    ],
                    members: {
                      Name: {}
                    }
                  },
                  Bitbucket: {
                    shape: "S5"
                  },
                  GitHubEnterpriseServer: {
                    shape: "S5"
                  },
                  S3Bucket: {
                    type: "structure",
                    required: [
                      "Name",
                      "BucketName"
                    ],
                    members: {
                      Name: {},
                      BucketName: {}
                    }
                  }
                }
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sb"
              },
              KMSKeyDetails: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RepositoryAssociation: {
                shape: "Si"
              },
              Tags: {
                shape: "Sb"
              }
            }
          }
        },
        CreateCodeReview: {
          http: {
            requestUri: "/codereviews"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "RepositoryAssociationArn",
              "Type"
            ],
            members: {
              Name: {},
              RepositoryAssociationArn: {},
              Type: {
                type: "structure",
                required: [
                  "RepositoryAnalysis"
                ],
                members: {
                  RepositoryAnalysis: {
                    type: "structure",
                    members: {
                      RepositoryHead: {
                        shape: "Sy"
                      },
                      SourceCodeType: {
                        shape: "S10"
                      }
                    }
                  },
                  AnalysisTypes: {
                    shape: "S1c"
                  }
                }
              },
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CodeReview: {
                shape: "S1f"
              }
            }
          }
        },
        DescribeCodeReview: {
          http: {
            method: "GET",
            requestUri: "/codereviews/{CodeReviewArn}"
          },
          input: {
            type: "structure",
            required: [
              "CodeReviewArn"
            ],
            members: {
              CodeReviewArn: {
                location: "uri",
                locationName: "CodeReviewArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CodeReview: {
                shape: "S1f"
              }
            }
          }
        },
        DescribeRecommendationFeedback: {
          http: {
            method: "GET",
            requestUri: "/feedback/{CodeReviewArn}"
          },
          input: {
            type: "structure",
            required: [
              "CodeReviewArn",
              "RecommendationId"
            ],
            members: {
              CodeReviewArn: {
                location: "uri",
                locationName: "CodeReviewArn"
              },
              RecommendationId: {
                location: "querystring",
                locationName: "RecommendationId"
              },
              UserId: {
                location: "querystring",
                locationName: "UserId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RecommendationFeedback: {
                type: "structure",
                members: {
                  CodeReviewArn: {},
                  RecommendationId: {},
                  Reactions: {
                    shape: "S1u"
                  },
                  UserId: {},
                  CreatedTimeStamp: {
                    type: "timestamp"
                  },
                  LastUpdatedTimeStamp: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        DescribeRepositoryAssociation: {
          http: {
            method: "GET",
            requestUri: "/associations/{AssociationArn}"
          },
          input: {
            type: "structure",
            required: [
              "AssociationArn"
            ],
            members: {
              AssociationArn: {
                location: "uri",
                locationName: "AssociationArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RepositoryAssociation: {
                shape: "Si"
              },
              Tags: {
                shape: "Sb"
              }
            }
          }
        },
        DisassociateRepository: {
          http: {
            method: "DELETE",
            requestUri: "/associations/{AssociationArn}"
          },
          input: {
            type: "structure",
            required: [
              "AssociationArn"
            ],
            members: {
              AssociationArn: {
                location: "uri",
                locationName: "AssociationArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RepositoryAssociation: {
                shape: "Si"
              },
              Tags: {
                shape: "Sb"
              }
            }
          }
        },
        ListCodeReviews: {
          http: {
            method: "GET",
            requestUri: "/codereviews"
          },
          input: {
            type: "structure",
            required: [
              "Type"
            ],
            members: {
              ProviderTypes: {
                shape: "S21",
                location: "querystring",
                locationName: "ProviderTypes"
              },
              States: {
                location: "querystring",
                locationName: "States",
                type: "list",
                member: {}
              },
              RepositoryNames: {
                location: "querystring",
                locationName: "RepositoryNames",
                type: "list",
                member: {}
              },
              Type: {
                location: "querystring",
                locationName: "Type"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CodeReviewSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    CodeReviewArn: {},
                    RepositoryName: {},
                    Owner: {},
                    ProviderType: {},
                    State: {},
                    CreatedTimeStamp: {
                      type: "timestamp"
                    },
                    LastUpdatedTimeStamp: {
                      type: "timestamp"
                    },
                    Type: {},
                    PullRequestId: {},
                    MetricsSummary: {
                      type: "structure",
                      members: {
                        MeteredLinesOfCodeCount: {
                          type: "long"
                        },
                        SuppressedLinesOfCodeCount: {
                          type: "long"
                        },
                        FindingsCount: {
                          type: "long"
                        }
                      }
                    },
                    SourceCodeType: {
                      shape: "S10"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListRecommendationFeedback: {
          http: {
            method: "GET",
            requestUri: "/feedback/{CodeReviewArn}/RecommendationFeedback"
          },
          input: {
            type: "structure",
            required: [
              "CodeReviewArn"
            ],
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              CodeReviewArn: {
                location: "uri",
                locationName: "CodeReviewArn"
              },
              UserIds: {
                location: "querystring",
                locationName: "UserIds",
                type: "list",
                member: {}
              },
              RecommendationIds: {
                location: "querystring",
                locationName: "RecommendationIds",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RecommendationFeedbackSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RecommendationId: {},
                    Reactions: {
                      shape: "S1u"
                    },
                    UserId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListRecommendations: {
          http: {
            method: "GET",
            requestUri: "/codereviews/{CodeReviewArn}/Recommendations"
          },
          input: {
            type: "structure",
            required: [
              "CodeReviewArn"
            ],
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              CodeReviewArn: {
                location: "uri",
                locationName: "CodeReviewArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RecommendationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FilePath: {},
                    RecommendationId: {},
                    StartLine: {
                      type: "integer"
                    },
                    EndLine: {
                      type: "integer"
                    },
                    Description: {},
                    RecommendationCategory: {},
                    RuleMetadata: {
                      type: "structure",
                      members: {
                        RuleId: {},
                        RuleName: {},
                        ShortDescription: {},
                        LongDescription: {},
                        RuleTags: {
                          type: "list",
                          member: {}
                        }
                      }
                    },
                    Severity: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListRepositoryAssociations: {
          http: {
            method: "GET",
            requestUri: "/associations"
          },
          input: {
            type: "structure",
            members: {
              ProviderTypes: {
                shape: "S21",
                location: "querystring",
                locationName: "ProviderType"
              },
              States: {
                location: "querystring",
                locationName: "State",
                type: "list",
                member: {}
              },
              Names: {
                location: "querystring",
                locationName: "Name",
                type: "list",
                member: {}
              },
              Owners: {
                location: "querystring",
                locationName: "Owner",
                type: "list",
                member: {}
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RepositoryAssociationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AssociationArn: {},
                    ConnectionArn: {},
                    LastUpdatedTimeStamp: {
                      type: "timestamp"
                    },
                    AssociationId: {},
                    Name: {},
                    Owner: {},
                    ProviderType: {},
                    State: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sb"
              }
            }
          }
        },
        PutRecommendationFeedback: {
          http: {
            method: "PUT",
            requestUri: "/feedback"
          },
          input: {
            type: "structure",
            required: [
              "CodeReviewArn",
              "RecommendationId",
              "Reactions"
            ],
            members: {
              CodeReviewArn: {},
              RecommendationId: {},
              Reactions: {
                shape: "S1u"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "Tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "TagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          required: [
            "Name",
            "ConnectionArn",
            "Owner"
          ],
          members: {
            Name: {},
            ConnectionArn: {},
            Owner: {}
          }
        },
        Sb: {
          type: "map",
          key: {},
          value: {}
        },
        Se: {
          type: "structure",
          members: {
            KMSKeyId: {},
            EncryptionOption: {}
          }
        },
        Si: {
          type: "structure",
          members: {
            AssociationId: {},
            AssociationArn: {},
            ConnectionArn: {},
            Name: {},
            Owner: {},
            ProviderType: {},
            State: {},
            StateReason: {},
            LastUpdatedTimeStamp: {
              type: "timestamp"
            },
            CreatedTimeStamp: {
              type: "timestamp"
            },
            KMSKeyDetails: {
              shape: "Se"
            },
            S3RepositoryDetails: {
              shape: "Sp"
            }
          }
        },
        Sp: {
          type: "structure",
          members: {
            BucketName: {},
            CodeArtifacts: {
              type: "structure",
              required: [
                "SourceCodeArtifactsObjectKey"
              ],
              members: {
                SourceCodeArtifactsObjectKey: {},
                BuildArtifactsObjectKey: {}
              }
            }
          }
        },
        Sy: {
          type: "structure",
          required: [
            "BranchName"
          ],
          members: {
            BranchName: {}
          }
        },
        S10: {
          type: "structure",
          members: {
            CommitDiff: {
              type: "structure",
              members: {
                SourceCommit: {},
                DestinationCommit: {},
                MergeBaseCommit: {}
              }
            },
            RepositoryHead: {
              shape: "Sy"
            },
            BranchDiff: {
              type: "structure",
              required: [
                "SourceBranchName",
                "DestinationBranchName"
              ],
              members: {
                SourceBranchName: {},
                DestinationBranchName: {}
              }
            },
            S3BucketRepository: {
              type: "structure",
              required: [
                "Name"
              ],
              members: {
                Name: {},
                Details: {
                  shape: "Sp"
                }
              }
            },
            RequestMetadata: {
              type: "structure",
              members: {
                RequestId: {},
                Requester: {},
                EventInfo: {
                  type: "structure",
                  members: {
                    Name: {},
                    State: {}
                  }
                },
                VendorName: {}
              }
            }
          }
        },
        S1c: {
          type: "list",
          member: {}
        },
        S1f: {
          type: "structure",
          members: {
            Name: {},
            CodeReviewArn: {},
            RepositoryName: {},
            Owner: {},
            ProviderType: {},
            State: {},
            StateReason: {},
            CreatedTimeStamp: {
              type: "timestamp"
            },
            LastUpdatedTimeStamp: {
              type: "timestamp"
            },
            Type: {},
            PullRequestId: {},
            SourceCodeType: {
              shape: "S10"
            },
            AssociationArn: {},
            Metrics: {
              type: "structure",
              members: {
                MeteredLinesOfCodeCount: {
                  type: "long"
                },
                SuppressedLinesOfCodeCount: {
                  type: "long"
                },
                FindingsCount: {
                  type: "long"
                }
              }
            },
            AnalysisTypes: {
              shape: "S1c"
            },
            ConfigFileState: {}
          }
        },
        S1u: {
          type: "list",
          member: {}
        },
        S21: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/codeguru-reviewer-2019-09-19.paginators.json
var require_codeguru_reviewer_2019_09_19_paginators = __commonJS({
  "node_modules/aws-sdk/apis/codeguru-reviewer-2019-09-19.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListCodeReviews: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListRecommendationFeedback: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListRecommendations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListRepositoryAssociations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "RepositoryAssociationSummaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/codeguru-reviewer-2019-09-19.waiters2.json
var require_codeguru_reviewer_2019_09_19_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/codeguru-reviewer-2019-09-19.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        RepositoryAssociationSucceeded: {
          description: "Wait until a repository association is complete.",
          operation: "DescribeRepositoryAssociation",
          delay: 10,
          maxAttempts: 30,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "RepositoryAssociation.State",
              expected: "Associated"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "RepositoryAssociation.State",
              expected: "Failed"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "RepositoryAssociation.State",
              expected: "Associating"
            }
          ]
        },
        CodeReviewCompleted: {
          description: "Wait until a code review is complete.",
          operation: "DescribeCodeReview",
          delay: 10,
          maxAttempts: 180,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "CodeReview.State",
              expected: "Completed"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "CodeReview.State",
              expected: "Failed"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "CodeReview.State",
              expected: "Pending"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/codegurureviewer.js
var require_codegurureviewer = __commonJS({
  "node_modules/aws-sdk/clients/codegurureviewer.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["codegurureviewer"] = {};
    AWS2.CodeGuruReviewer = Service.defineService("codegurureviewer", ["2019-09-19"]);
    Object.defineProperty(apiLoader.services["codegurureviewer"], "2019-09-19", {
      get: function get() {
        var model = require_codeguru_reviewer_2019_09_19_min();
        model.paginators = require_codeguru_reviewer_2019_09_19_paginators().pagination;
        model.waiters = require_codeguru_reviewer_2019_09_19_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CodeGuruReviewer;
  }
});

// node_modules/aws-sdk/apis/codeguruprofiler-2019-07-18.min.json
var require_codeguruprofiler_2019_07_18_min = __commonJS({
  "node_modules/aws-sdk/apis/codeguruprofiler-2019-07-18.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-07-18",
        endpointPrefix: "codeguru-profiler",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon CodeGuru Profiler",
        serviceId: "CodeGuruProfiler",
        signatureVersion: "v4",
        signingName: "codeguru-profiler",
        uid: "codeguruprofiler-2019-07-18"
      },
      operations: {
        AddNotificationChannels: {
          http: {
            requestUri: "/profilingGroups/{profilingGroupName}/notificationConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "channels",
              "profilingGroupName"
            ],
            members: {
              channels: {
                shape: "S2"
              },
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              notificationConfiguration: {
                shape: "Sa"
              }
            }
          }
        },
        BatchGetFrameMetricData: {
          http: {
            requestUri: "/profilingGroups/{profilingGroupName}/frames/-/metrics",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "profilingGroupName"
            ],
            members: {
              endTime: {
                shape: "Sc",
                location: "querystring",
                locationName: "endTime"
              },
              frameMetrics: {
                type: "list",
                member: {
                  shape: "Se"
                }
              },
              period: {
                location: "querystring",
                locationName: "period"
              },
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              },
              startTime: {
                shape: "Sc",
                location: "querystring",
                locationName: "startTime"
              },
              targetResolution: {
                location: "querystring",
                locationName: "targetResolution"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "endTime",
              "endTimes",
              "frameMetricData",
              "resolution",
              "startTime",
              "unprocessedEndTimes"
            ],
            members: {
              endTime: {
                shape: "Sc"
              },
              endTimes: {
                shape: "Sl"
              },
              frameMetricData: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "frameMetric",
                    "values"
                  ],
                  members: {
                    frameMetric: {
                      shape: "Se"
                    },
                    values: {
                      type: "list",
                      member: {
                        type: "double"
                      }
                    }
                  }
                }
              },
              resolution: {},
              startTime: {
                shape: "Sc"
              },
              unprocessedEndTimes: {
                type: "map",
                key: {},
                value: {
                  shape: "Sl"
                }
              }
            }
          }
        },
        ConfigureAgent: {
          http: {
            requestUri: "/profilingGroups/{profilingGroupName}/configureAgent",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "profilingGroupName"
            ],
            members: {
              fleetInstanceId: {},
              metadata: {
                type: "map",
                key: {},
                value: {}
              },
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "configuration"
            ],
            members: {
              configuration: {
                type: "structure",
                required: [
                  "periodInSeconds",
                  "shouldProfile"
                ],
                members: {
                  agentParameters: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  periodInSeconds: {
                    type: "integer"
                  },
                  shouldProfile: {
                    type: "boolean"
                  }
                }
              }
            },
            payload: "configuration"
          }
        },
        CreateProfilingGroup: {
          http: {
            requestUri: "/profilingGroups",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "clientToken",
              "profilingGroupName"
            ],
            members: {
              agentOrchestrationConfig: {
                shape: "S13"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              },
              computePlatform: {},
              profilingGroupName: {},
              tags: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "profilingGroup"
            ],
            members: {
              profilingGroup: {
                shape: "S18"
              }
            },
            payload: "profilingGroup"
          },
          idempotent: true
        },
        DeleteProfilingGroup: {
          http: {
            method: "DELETE",
            requestUri: "/profilingGroups/{profilingGroupName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "profilingGroupName"
            ],
            members: {
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DescribeProfilingGroup: {
          http: {
            method: "GET",
            requestUri: "/profilingGroups/{profilingGroupName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "profilingGroupName"
            ],
            members: {
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "profilingGroup"
            ],
            members: {
              profilingGroup: {
                shape: "S18"
              }
            },
            payload: "profilingGroup"
          }
        },
        GetFindingsReportAccountSummary: {
          http: {
            method: "GET",
            requestUri: "/internal/findingsReports",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              dailyReportsOnly: {
                location: "querystring",
                locationName: "dailyReportsOnly",
                type: "boolean"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "reportSummaries"
            ],
            members: {
              nextToken: {},
              reportSummaries: {
                shape: "S1k"
              }
            }
          }
        },
        GetNotificationConfiguration: {
          http: {
            method: "GET",
            requestUri: "/profilingGroups/{profilingGroupName}/notificationConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "profilingGroupName"
            ],
            members: {
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "notificationConfiguration"
            ],
            members: {
              notificationConfiguration: {
                shape: "Sa"
              }
            }
          }
        },
        GetPolicy: {
          http: {
            method: "GET",
            requestUri: "/profilingGroups/{profilingGroupName}/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "profilingGroupName"
            ],
            members: {
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "policy",
              "revisionId"
            ],
            members: {
              policy: {},
              revisionId: {}
            }
          }
        },
        GetProfile: {
          http: {
            method: "GET",
            requestUri: "/profilingGroups/{profilingGroupName}/profile",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "profilingGroupName"
            ],
            members: {
              accept: {
                location: "header",
                locationName: "Accept"
              },
              endTime: {
                shape: "Sc",
                location: "querystring",
                locationName: "endTime"
              },
              maxDepth: {
                location: "querystring",
                locationName: "maxDepth",
                type: "integer"
              },
              period: {
                location: "querystring",
                locationName: "period"
              },
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              },
              startTime: {
                shape: "Sc",
                location: "querystring",
                locationName: "startTime"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "contentType",
              "profile"
            ],
            members: {
              contentEncoding: {
                location: "header",
                locationName: "Content-Encoding"
              },
              contentType: {
                location: "header",
                locationName: "Content-Type"
              },
              profile: {
                type: "blob"
              }
            },
            payload: "profile"
          }
        },
        GetRecommendations: {
          http: {
            method: "GET",
            requestUri: "/internal/profilingGroups/{profilingGroupName}/recommendations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "endTime",
              "profilingGroupName",
              "startTime"
            ],
            members: {
              endTime: {
                shape: "Sc",
                location: "querystring",
                locationName: "endTime"
              },
              locale: {
                location: "querystring",
                locationName: "locale"
              },
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              },
              startTime: {
                shape: "Sc",
                location: "querystring",
                locationName: "startTime"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "anomalies",
              "profileEndTime",
              "profileStartTime",
              "profilingGroupName",
              "recommendations"
            ],
            members: {
              anomalies: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "instances",
                    "metric",
                    "reason"
                  ],
                  members: {
                    instances: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "id",
                          "startTime"
                        ],
                        members: {
                          endTime: {
                            shape: "Sc"
                          },
                          id: {},
                          startTime: {
                            shape: "Sc"
                          },
                          userFeedback: {
                            type: "structure",
                            required: [
                              "type"
                            ],
                            members: {
                              type: {}
                            }
                          }
                        }
                      }
                    },
                    metric: {
                      type: "structure",
                      required: [
                        "frameName",
                        "threadStates",
                        "type"
                      ],
                      members: {
                        frameName: {},
                        threadStates: {
                          shape: "S26"
                        },
                        type: {}
                      }
                    },
                    reason: {}
                  }
                }
              },
              profileEndTime: {
                shape: "Sc"
              },
              profileStartTime: {
                shape: "Sc"
              },
              profilingGroupName: {},
              recommendations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "allMatchesCount",
                    "allMatchesSum",
                    "endTime",
                    "pattern",
                    "startTime",
                    "topMatches"
                  ],
                  members: {
                    allMatchesCount: {
                      type: "integer"
                    },
                    allMatchesSum: {
                      type: "double"
                    },
                    endTime: {
                      shape: "Sc"
                    },
                    pattern: {
                      type: "structure",
                      members: {
                        countersToAggregate: {
                          shape: "S26"
                        },
                        description: {},
                        id: {},
                        name: {},
                        resolutionSteps: {},
                        targetFrames: {
                          type: "list",
                          member: {
                            type: "list",
                            member: {}
                          }
                        },
                        thresholdPercent: {
                          type: "double"
                        }
                      }
                    },
                    startTime: {
                      shape: "Sc"
                    },
                    topMatches: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          frameAddress: {},
                          targetFramesIndex: {
                            type: "integer"
                          },
                          thresholdBreachValue: {
                            type: "double"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        ListFindingsReports: {
          http: {
            method: "GET",
            requestUri: "/internal/profilingGroups/{profilingGroupName}/findingsReports",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "endTime",
              "profilingGroupName",
              "startTime"
            ],
            members: {
              dailyReportsOnly: {
                location: "querystring",
                locationName: "dailyReportsOnly",
                type: "boolean"
              },
              endTime: {
                shape: "Sc",
                location: "querystring",
                locationName: "endTime"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              },
              startTime: {
                shape: "Sc",
                location: "querystring",
                locationName: "startTime"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "findingsReportSummaries"
            ],
            members: {
              findingsReportSummaries: {
                shape: "S1k"
              },
              nextToken: {}
            }
          }
        },
        ListProfileTimes: {
          http: {
            method: "GET",
            requestUri: "/profilingGroups/{profilingGroupName}/profileTimes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "endTime",
              "period",
              "profilingGroupName",
              "startTime"
            ],
            members: {
              endTime: {
                shape: "Sc",
                location: "querystring",
                locationName: "endTime"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              orderBy: {
                location: "querystring",
                locationName: "orderBy"
              },
              period: {
                location: "querystring",
                locationName: "period"
              },
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              },
              startTime: {
                shape: "Sc",
                location: "querystring",
                locationName: "startTime"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "profileTimes"
            ],
            members: {
              nextToken: {},
              profileTimes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    start: {
                      shape: "Sc"
                    }
                  }
                }
              }
            }
          }
        },
        ListProfilingGroups: {
          http: {
            method: "GET",
            requestUri: "/profilingGroups",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              includeDescription: {
                location: "querystring",
                locationName: "includeDescription",
                type: "boolean"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "profilingGroupNames"
            ],
            members: {
              nextToken: {},
              profilingGroupNames: {
                type: "list",
                member: {}
              },
              profilingGroups: {
                type: "list",
                member: {
                  shape: "S18"
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S16"
              }
            }
          }
        },
        PostAgentProfile: {
          http: {
            requestUri: "/profilingGroups/{profilingGroupName}/agentProfile",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "agentProfile",
              "contentType",
              "profilingGroupName"
            ],
            members: {
              agentProfile: {
                type: "blob"
              },
              contentType: {
                location: "header",
                locationName: "Content-Type"
              },
              profileToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "profileToken"
              },
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              }
            },
            payload: "agentProfile"
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutPermission: {
          http: {
            method: "PUT",
            requestUri: "/profilingGroups/{profilingGroupName}/policy/{actionGroup}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "actionGroup",
              "principals",
              "profilingGroupName"
            ],
            members: {
              actionGroup: {
                location: "uri",
                locationName: "actionGroup"
              },
              principals: {
                type: "list",
                member: {}
              },
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              },
              revisionId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "policy",
              "revisionId"
            ],
            members: {
              policy: {},
              revisionId: {}
            }
          },
          idempotent: true
        },
        RemoveNotificationChannel: {
          http: {
            method: "DELETE",
            requestUri: "/profilingGroups/{profilingGroupName}/notificationConfiguration/{channelId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "channelId",
              "profilingGroupName"
            ],
            members: {
              channelId: {
                location: "uri",
                locationName: "channelId"
              },
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              notificationConfiguration: {
                shape: "Sa"
              }
            }
          },
          idempotent: true
        },
        RemovePermission: {
          http: {
            method: "DELETE",
            requestUri: "/profilingGroups/{profilingGroupName}/policy/{actionGroup}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "actionGroup",
              "profilingGroupName",
              "revisionId"
            ],
            members: {
              actionGroup: {
                location: "uri",
                locationName: "actionGroup"
              },
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              },
              revisionId: {
                location: "querystring",
                locationName: "revisionId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "policy",
              "revisionId"
            ],
            members: {
              policy: {},
              revisionId: {}
            }
          }
        },
        SubmitFeedback: {
          http: {
            requestUri: "/internal/profilingGroups/{profilingGroupName}/anomalies/{anomalyInstanceId}/feedback",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "anomalyInstanceId",
              "profilingGroupName",
              "type"
            ],
            members: {
              anomalyInstanceId: {
                location: "uri",
                locationName: "anomalyInstanceId"
              },
              comment: {},
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              },
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateProfilingGroup: {
          http: {
            method: "PUT",
            requestUri: "/profilingGroups/{profilingGroupName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "agentOrchestrationConfig",
              "profilingGroupName"
            ],
            members: {
              agentOrchestrationConfig: {
                shape: "S13"
              },
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "profilingGroup"
            ],
            members: {
              profilingGroup: {
                shape: "S18"
              }
            },
            payload: "profilingGroup"
          },
          idempotent: true
        }
      },
      shapes: {
        S2: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "eventPublishers",
              "uri"
            ],
            members: {
              eventPublishers: {
                type: "list",
                member: {}
              },
              id: {},
              uri: {}
            }
          }
        },
        Sa: {
          type: "structure",
          members: {
            channels: {
              shape: "S2"
            }
          }
        },
        Sc: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        Se: {
          type: "structure",
          required: [
            "frameName",
            "threadStates",
            "type"
          ],
          members: {
            frameName: {},
            threadStates: {
              type: "list",
              member: {}
            },
            type: {}
          }
        },
        Sl: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "value"
            ],
            members: {
              value: {
                shape: "Sc"
              }
            }
          }
        },
        S13: {
          type: "structure",
          required: [
            "profilingEnabled"
          ],
          members: {
            profilingEnabled: {
              type: "boolean"
            }
          }
        },
        S16: {
          type: "map",
          key: {},
          value: {}
        },
        S18: {
          type: "structure",
          members: {
            agentOrchestrationConfig: {
              shape: "S13"
            },
            arn: {},
            computePlatform: {},
            createdAt: {
              shape: "Sc"
            },
            name: {},
            profilingStatus: {
              type: "structure",
              members: {
                latestAgentOrchestratedAt: {
                  shape: "Sc"
                },
                latestAgentProfileReportedAt: {
                  shape: "Sc"
                },
                latestAggregatedProfile: {
                  type: "structure",
                  members: {
                    period: {},
                    start: {
                      shape: "Sc"
                    }
                  }
                }
              }
            },
            tags: {
              shape: "S16"
            },
            updatedAt: {
              shape: "Sc"
            }
          }
        },
        S1k: {
          type: "list",
          member: {
            type: "structure",
            members: {
              id: {},
              profileEndTime: {
                shape: "Sc"
              },
              profileStartTime: {
                shape: "Sc"
              },
              profilingGroupName: {},
              totalNumberOfFindings: {
                type: "integer"
              }
            }
          }
        },
        S26: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/codeguruprofiler-2019-07-18.paginators.json
var require_codeguruprofiler_2019_07_18_paginators = __commonJS({
  "node_modules/aws-sdk/apis/codeguruprofiler-2019-07-18.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetFindingsReportAccountSummary: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListFindingsReports: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListProfileTimes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "profileTimes"
        },
        ListProfilingGroups: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/codeguruprofiler.js
var require_codeguruprofiler = __commonJS({
  "node_modules/aws-sdk/clients/codeguruprofiler.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["codeguruprofiler"] = {};
    AWS2.CodeGuruProfiler = Service.defineService("codeguruprofiler", ["2019-07-18"]);
    Object.defineProperty(apiLoader.services["codeguruprofiler"], "2019-07-18", {
      get: function get() {
        var model = require_codeguruprofiler_2019_07_18_min();
        model.paginators = require_codeguruprofiler_2019_07_18_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CodeGuruProfiler;
  }
});

// node_modules/aws-sdk/apis/compute-optimizer-2019-11-01.min.json
var require_compute_optimizer_2019_11_01_min = __commonJS({
  "node_modules/aws-sdk/apis/compute-optimizer-2019-11-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-11-01",
        endpointPrefix: "compute-optimizer",
        jsonVersion: "1.0",
        protocol: "json",
        serviceFullName: "AWS Compute Optimizer",
        serviceId: "Compute Optimizer",
        signatureVersion: "v4",
        signingName: "compute-optimizer",
        targetPrefix: "ComputeOptimizerService",
        uid: "compute-optimizer-2019-11-01"
      },
      operations: {
        DeleteRecommendationPreferences: {
          input: {
            type: "structure",
            required: [
              "resourceType",
              "recommendationPreferenceNames"
            ],
            members: {
              resourceType: {},
              scope: {
                shape: "S3"
              },
              recommendationPreferenceNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeRecommendationExportJobs: {
          input: {
            type: "structure",
            members: {
              jobIds: {
                type: "list",
                member: {}
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    values: {
                      shape: "Sf"
                    }
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              recommendationExportJobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    jobId: {},
                    destination: {
                      type: "structure",
                      members: {
                        s3: {
                          shape: "Sn"
                        }
                      }
                    },
                    resourceType: {},
                    status: {},
                    creationTimestamp: {
                      type: "timestamp"
                    },
                    lastUpdatedTimestamp: {
                      type: "timestamp"
                    },
                    failureReason: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ExportAutoScalingGroupRecommendations: {
          input: {
            type: "structure",
            required: [
              "s3DestinationConfig"
            ],
            members: {
              accountIds: {
                shape: "Sw"
              },
              filters: {
                shape: "Sy"
              },
              fieldsToExport: {
                type: "list",
                member: {}
              },
              s3DestinationConfig: {
                shape: "S13"
              },
              fileFormat: {},
              includeMemberAccounts: {
                type: "boolean"
              },
              recommendationPreferences: {
                shape: "S17"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobId: {},
              s3Destination: {
                shape: "Sn"
              }
            }
          }
        },
        ExportEBSVolumeRecommendations: {
          input: {
            type: "structure",
            required: [
              "s3DestinationConfig"
            ],
            members: {
              accountIds: {
                shape: "Sw"
              },
              filters: {
                shape: "S1c"
              },
              fieldsToExport: {
                type: "list",
                member: {}
              },
              s3DestinationConfig: {
                shape: "S13"
              },
              fileFormat: {},
              includeMemberAccounts: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobId: {},
              s3Destination: {
                shape: "Sn"
              }
            }
          }
        },
        ExportEC2InstanceRecommendations: {
          input: {
            type: "structure",
            required: [
              "s3DestinationConfig"
            ],
            members: {
              accountIds: {
                shape: "Sw"
              },
              filters: {
                shape: "Sy"
              },
              fieldsToExport: {
                type: "list",
                member: {}
              },
              s3DestinationConfig: {
                shape: "S13"
              },
              fileFormat: {},
              includeMemberAccounts: {
                type: "boolean"
              },
              recommendationPreferences: {
                shape: "S17"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobId: {},
              s3Destination: {
                shape: "Sn"
              }
            }
          }
        },
        ExportECSServiceRecommendations: {
          input: {
            type: "structure",
            required: [
              "s3DestinationConfig"
            ],
            members: {
              accountIds: {
                shape: "Sw"
              },
              filters: {
                shape: "S1n"
              },
              fieldsToExport: {
                type: "list",
                member: {}
              },
              s3DestinationConfig: {
                shape: "S13"
              },
              fileFormat: {},
              includeMemberAccounts: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobId: {},
              s3Destination: {
                shape: "Sn"
              }
            }
          }
        },
        ExportLambdaFunctionRecommendations: {
          input: {
            type: "structure",
            required: [
              "s3DestinationConfig"
            ],
            members: {
              accountIds: {
                shape: "Sw"
              },
              filters: {
                shape: "S1u"
              },
              fieldsToExport: {
                type: "list",
                member: {}
              },
              s3DestinationConfig: {
                shape: "S13"
              },
              fileFormat: {},
              includeMemberAccounts: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobId: {},
              s3Destination: {
                shape: "Sn"
              }
            }
          }
        },
        ExportLicenseRecommendations: {
          input: {
            type: "structure",
            required: [
              "s3DestinationConfig"
            ],
            members: {
              accountIds: {
                shape: "Sw"
              },
              filters: {
                shape: "S21"
              },
              fieldsToExport: {
                type: "list",
                member: {}
              },
              s3DestinationConfig: {
                shape: "S13"
              },
              fileFormat: {},
              includeMemberAccounts: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobId: {},
              s3Destination: {
                shape: "Sn"
              }
            }
          }
        },
        GetAutoScalingGroupRecommendations: {
          input: {
            type: "structure",
            members: {
              accountIds: {
                shape: "Sw"
              },
              autoScalingGroupArns: {
                type: "list",
                member: {}
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filters: {
                shape: "Sy"
              },
              recommendationPreferences: {
                shape: "S17"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              autoScalingGroupRecommendations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    accountId: {},
                    autoScalingGroupArn: {},
                    autoScalingGroupName: {},
                    finding: {},
                    utilizationMetrics: {
                      shape: "S2f"
                    },
                    lookBackPeriodInDays: {
                      type: "double"
                    },
                    currentConfiguration: {
                      shape: "S2l"
                    },
                    recommendationOptions: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          configuration: {
                            shape: "S2l"
                          },
                          projectedUtilizationMetrics: {
                            shape: "S2s"
                          },
                          performanceRisk: {
                            type: "double"
                          },
                          rank: {
                            type: "integer"
                          },
                          savingsOpportunity: {
                            shape: "S2v"
                          },
                          migrationEffort: {},
                          instanceGpuInfo: {
                            shape: "S31"
                          },
                          savingsOpportunityAfterDiscounts: {
                            type: "structure",
                            members: {
                              savingsOpportunityPercentage: {
                                type: "double"
                              },
                              estimatedMonthlySavings: {
                                type: "structure",
                                members: {
                                  currency: {},
                                  value: {
                                    type: "double"
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    lastRefreshTimestamp: {
                      type: "timestamp"
                    },
                    currentPerformanceRisk: {},
                    effectiveRecommendationPreferences: {
                      shape: "S3a"
                    },
                    inferredWorkloadTypes: {
                      shape: "S3t"
                    },
                    currentInstanceGpuInfo: {
                      shape: "S31"
                    }
                  }
                }
              },
              errors: {
                shape: "S3v"
              }
            }
          }
        },
        GetEBSVolumeRecommendations: {
          input: {
            type: "structure",
            members: {
              volumeArns: {
                type: "list",
                member: {}
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filters: {
                shape: "S1c"
              },
              accountIds: {
                shape: "Sw"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              volumeRecommendations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    volumeArn: {},
                    accountId: {},
                    currentConfiguration: {
                      shape: "S46"
                    },
                    finding: {},
                    utilizationMetrics: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          statistic: {},
                          value: {
                            type: "double"
                          }
                        }
                      }
                    },
                    lookBackPeriodInDays: {
                      type: "double"
                    },
                    volumeRecommendationOptions: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          configuration: {
                            shape: "S46"
                          },
                          performanceRisk: {
                            type: "double"
                          },
                          rank: {
                            type: "integer"
                          },
                          savingsOpportunity: {
                            shape: "S2v"
                          },
                          savingsOpportunityAfterDiscounts: {
                            type: "structure",
                            members: {
                              savingsOpportunityPercentage: {
                                type: "double"
                              },
                              estimatedMonthlySavings: {
                                type: "structure",
                                members: {
                                  currency: {},
                                  value: {
                                    type: "double"
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    lastRefreshTimestamp: {
                      type: "timestamp"
                    },
                    currentPerformanceRisk: {},
                    tags: {
                      shape: "S4m"
                    },
                    effectiveRecommendationPreferences: {
                      type: "structure",
                      members: {
                        savingsEstimationMode: {
                          type: "structure",
                          members: {
                            source: {}
                          }
                        }
                      }
                    }
                  }
                }
              },
              errors: {
                shape: "S3v"
              }
            }
          }
        },
        GetEC2InstanceRecommendations: {
          input: {
            type: "structure",
            members: {
              instanceArns: {
                type: "list",
                member: {}
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filters: {
                shape: "Sy"
              },
              accountIds: {
                shape: "Sw"
              },
              recommendationPreferences: {
                shape: "S17"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              instanceRecommendations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    instanceArn: {},
                    accountId: {},
                    instanceName: {},
                    currentInstanceType: {},
                    finding: {},
                    findingReasonCodes: {
                      type: "list",
                      member: {}
                    },
                    utilizationMetrics: {
                      shape: "S2f"
                    },
                    lookBackPeriodInDays: {
                      type: "double"
                    },
                    recommendationOptions: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          instanceType: {},
                          projectedUtilizationMetrics: {
                            shape: "S2s"
                          },
                          platformDifferences: {
                            type: "list",
                            member: {}
                          },
                          performanceRisk: {
                            type: "double"
                          },
                          rank: {
                            type: "integer"
                          },
                          savingsOpportunity: {
                            shape: "S2v"
                          },
                          migrationEffort: {},
                          instanceGpuInfo: {
                            shape: "S31"
                          },
                          savingsOpportunityAfterDiscounts: {
                            type: "structure",
                            members: {
                              savingsOpportunityPercentage: {
                                type: "double"
                              },
                              estimatedMonthlySavings: {
                                type: "structure",
                                members: {
                                  currency: {},
                                  value: {
                                    type: "double"
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    recommendationSources: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          recommendationSourceArn: {},
                          recommendationSourceType: {}
                        }
                      }
                    },
                    lastRefreshTimestamp: {
                      type: "timestamp"
                    },
                    currentPerformanceRisk: {},
                    effectiveRecommendationPreferences: {
                      shape: "S3a"
                    },
                    inferredWorkloadTypes: {
                      shape: "S3t"
                    },
                    instanceState: {},
                    tags: {
                      shape: "S4m"
                    },
                    externalMetricStatus: {
                      type: "structure",
                      members: {
                        statusCode: {},
                        statusReason: {}
                      }
                    },
                    currentInstanceGpuInfo: {
                      shape: "S31"
                    },
                    idle: {}
                  }
                }
              },
              errors: {
                shape: "S3v"
              }
            }
          }
        },
        GetEC2RecommendationProjectedMetrics: {
          input: {
            type: "structure",
            required: [
              "instanceArn",
              "stat",
              "period",
              "startTime",
              "endTime"
            ],
            members: {
              instanceArn: {},
              stat: {},
              period: {
                type: "integer"
              },
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              recommendationPreferences: {
                shape: "S17"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              recommendedOptionProjectedMetrics: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    recommendedInstanceType: {},
                    rank: {
                      type: "integer"
                    },
                    projectedMetrics: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          timestamps: {
                            shape: "S5r"
                          },
                          values: {
                            shape: "S5s"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetECSServiceRecommendationProjectedMetrics: {
          input: {
            type: "structure",
            required: [
              "serviceArn",
              "stat",
              "period",
              "startTime",
              "endTime"
            ],
            members: {
              serviceArn: {},
              stat: {},
              period: {
                type: "integer"
              },
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              recommendedOptionProjectedMetrics: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    recommendedCpuUnits: {
                      type: "integer"
                    },
                    recommendedMemorySize: {
                      type: "integer"
                    },
                    projectedMetrics: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          timestamps: {
                            shape: "S5r"
                          },
                          upperBoundValues: {
                            shape: "S5s"
                          },
                          lowerBoundValues: {
                            shape: "S5s"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetECSServiceRecommendations: {
          input: {
            type: "structure",
            members: {
              serviceArns: {
                type: "list",
                member: {}
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filters: {
                shape: "S1n"
              },
              accountIds: {
                shape: "Sw"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              ecsServiceRecommendations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    serviceArn: {},
                    accountId: {},
                    currentServiceConfiguration: {
                      type: "structure",
                      members: {
                        memory: {
                          type: "integer"
                        },
                        cpu: {
                          type: "integer"
                        },
                        containerConfigurations: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              containerName: {},
                              memorySizeConfiguration: {
                                shape: "S6e"
                              },
                              cpu: {
                                type: "integer"
                              }
                            }
                          }
                        },
                        autoScalingConfiguration: {},
                        taskDefinitionArn: {}
                      }
                    },
                    utilizationMetrics: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          statistic: {},
                          value: {
                            type: "double"
                          }
                        }
                      }
                    },
                    lookbackPeriodInDays: {
                      type: "double"
                    },
                    launchType: {},
                    lastRefreshTimestamp: {
                      type: "timestamp"
                    },
                    finding: {},
                    findingReasonCodes: {
                      type: "list",
                      member: {}
                    },
                    serviceRecommendationOptions: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          memory: {
                            type: "integer"
                          },
                          cpu: {
                            type: "integer"
                          },
                          savingsOpportunity: {
                            shape: "S2v"
                          },
                          projectedUtilizationMetrics: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                name: {},
                                statistic: {},
                                lowerBoundValue: {
                                  type: "double"
                                },
                                upperBoundValue: {
                                  type: "double"
                                }
                              }
                            }
                          },
                          containerRecommendations: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                containerName: {},
                                memorySizeConfiguration: {
                                  shape: "S6e"
                                },
                                cpu: {
                                  type: "integer"
                                }
                              }
                            }
                          },
                          savingsOpportunityAfterDiscounts: {
                            type: "structure",
                            members: {
                              savingsOpportunityPercentage: {
                                type: "double"
                              },
                              estimatedMonthlySavings: {
                                type: "structure",
                                members: {
                                  currency: {},
                                  value: {
                                    type: "double"
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    currentPerformanceRisk: {},
                    tags: {
                      shape: "S4m"
                    },
                    effectiveRecommendationPreferences: {
                      type: "structure",
                      members: {
                        savingsEstimationMode: {
                          type: "structure",
                          members: {
                            source: {}
                          }
                        }
                      }
                    }
                  }
                }
              },
              errors: {
                shape: "S3v"
              }
            }
          }
        },
        GetEffectiveRecommendationPreferences: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              enhancedInfrastructureMetrics: {},
              externalMetricsPreference: {
                shape: "S3d"
              },
              lookBackPeriod: {},
              utilizationPreferences: {
                shape: "S3g"
              },
              preferredResources: {
                shape: "S3m"
              }
            }
          }
        },
        GetEnrollmentStatus: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              status: {},
              statusReason: {},
              memberAccountsEnrolled: {
                type: "boolean"
              },
              lastUpdatedTimestamp: {
                type: "timestamp"
              },
              numberOfMemberAccountsOptedIn: {
                type: "integer"
              }
            }
          }
        },
        GetEnrollmentStatusesForOrganization: {
          input: {
            type: "structure",
            members: {
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    values: {
                      shape: "Sf"
                    }
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              accountEnrollmentStatuses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    accountId: {},
                    status: {},
                    statusReason: {},
                    lastUpdatedTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetLambdaFunctionRecommendations: {
          input: {
            type: "structure",
            members: {
              functionArns: {
                type: "list",
                member: {}
              },
              accountIds: {
                shape: "Sw"
              },
              filters: {
                shape: "S1u"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              lambdaFunctionRecommendations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    functionArn: {},
                    functionVersion: {},
                    accountId: {},
                    currentMemorySize: {
                      type: "integer"
                    },
                    numberOfInvocations: {
                      type: "long"
                    },
                    utilizationMetrics: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          statistic: {},
                          value: {
                            type: "double"
                          }
                        }
                      }
                    },
                    lookbackPeriodInDays: {
                      type: "double"
                    },
                    lastRefreshTimestamp: {
                      type: "timestamp"
                    },
                    finding: {},
                    findingReasonCodes: {
                      type: "list",
                      member: {}
                    },
                    memorySizeRecommendationOptions: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          rank: {
                            type: "integer"
                          },
                          memorySize: {
                            type: "integer"
                          },
                          projectedUtilizationMetrics: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                name: {},
                                statistic: {},
                                value: {
                                  type: "double"
                                }
                              }
                            }
                          },
                          savingsOpportunity: {
                            shape: "S2v"
                          },
                          savingsOpportunityAfterDiscounts: {
                            type: "structure",
                            members: {
                              savingsOpportunityPercentage: {
                                type: "double"
                              },
                              estimatedMonthlySavings: {
                                type: "structure",
                                members: {
                                  currency: {},
                                  value: {
                                    type: "double"
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    currentPerformanceRisk: {},
                    tags: {
                      shape: "S4m"
                    },
                    effectiveRecommendationPreferences: {
                      type: "structure",
                      members: {
                        savingsEstimationMode: {
                          type: "structure",
                          members: {
                            source: {}
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetLicenseRecommendations: {
          input: {
            type: "structure",
            members: {
              resourceArns: {
                type: "list",
                member: {}
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filters: {
                shape: "S21"
              },
              accountIds: {
                shape: "Sw"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              licenseRecommendations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    resourceArn: {},
                    accountId: {},
                    currentLicenseConfiguration: {
                      type: "structure",
                      members: {
                        numberOfCores: {
                          type: "integer"
                        },
                        instanceType: {},
                        operatingSystem: {},
                        licenseEdition: {},
                        licenseName: {},
                        licenseModel: {},
                        licenseVersion: {},
                        metricsSource: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              provider: {},
                              providerArn: {}
                            }
                          }
                        }
                      }
                    },
                    lookbackPeriodInDays: {
                      type: "double"
                    },
                    lastRefreshTimestamp: {
                      type: "timestamp"
                    },
                    finding: {},
                    findingReasonCodes: {
                      type: "list",
                      member: {}
                    },
                    licenseRecommendationOptions: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          rank: {
                            type: "integer"
                          },
                          operatingSystem: {},
                          licenseEdition: {},
                          licenseModel: {},
                          savingsOpportunity: {
                            shape: "S2v"
                          }
                        }
                      }
                    },
                    tags: {
                      shape: "S4m"
                    }
                  }
                }
              },
              errors: {
                shape: "S3v"
              }
            }
          }
        },
        GetRecommendationPreferences: {
          input: {
            type: "structure",
            required: [
              "resourceType"
            ],
            members: {
              resourceType: {},
              scope: {
                shape: "S3"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              recommendationPreferencesDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    scope: {
                      shape: "S3"
                    },
                    resourceType: {},
                    enhancedInfrastructureMetrics: {},
                    inferredWorkloadTypes: {},
                    externalMetricsPreference: {
                      shape: "S3d"
                    },
                    lookBackPeriod: {},
                    utilizationPreferences: {
                      shape: "S3g"
                    },
                    preferredResources: {
                      shape: "S3m"
                    },
                    savingsEstimationMode: {}
                  }
                }
              }
            }
          }
        },
        GetRecommendationSummaries: {
          input: {
            type: "structure",
            members: {
              accountIds: {
                shape: "Sw"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              recommendationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    summaries: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          value: {
                            type: "double"
                          },
                          reasonCodeSummaries: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                name: {},
                                value: {
                                  type: "double"
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    recommendationResourceType: {},
                    accountId: {},
                    savingsOpportunity: {
                      shape: "S2v"
                    },
                    currentPerformanceRiskRatings: {
                      type: "structure",
                      members: {
                        high: {
                          type: "long"
                        },
                        medium: {
                          type: "long"
                        },
                        low: {
                          type: "long"
                        },
                        veryLow: {
                          type: "long"
                        }
                      }
                    },
                    inferredWorkloadSavings: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          inferredWorkloadTypes: {
                            shape: "S3t"
                          },
                          estimatedMonthlySavings: {
                            shape: "S2x"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        PutRecommendationPreferences: {
          input: {
            type: "structure",
            required: [
              "resourceType"
            ],
            members: {
              resourceType: {},
              scope: {
                shape: "S3"
              },
              enhancedInfrastructureMetrics: {},
              inferredWorkloadTypes: {},
              externalMetricsPreference: {
                shape: "S3d"
              },
              lookBackPeriod: {},
              utilizationPreferences: {
                shape: "S3g"
              },
              preferredResources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    includeList: {
                      shape: "S3p"
                    },
                    excludeList: {
                      shape: "S3p"
                    }
                  }
                }
              },
              savingsEstimationMode: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateEnrollmentStatus: {
          input: {
            type: "structure",
            required: [
              "status"
            ],
            members: {
              status: {},
              includeMemberAccounts: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              status: {},
              statusReason: {}
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          members: {
            name: {},
            value: {}
          }
        },
        Sf: {
          type: "list",
          member: {}
        },
        Sn: {
          type: "structure",
          members: {
            bucket: {},
            key: {},
            metadataKey: {}
          }
        },
        Sw: {
          type: "list",
          member: {}
        },
        Sy: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              values: {
                shape: "Sf"
              }
            }
          }
        },
        S13: {
          type: "structure",
          members: {
            bucket: {},
            keyPrefix: {}
          }
        },
        S17: {
          type: "structure",
          members: {
            cpuVendorArchitectures: {
              shape: "S18"
            }
          }
        },
        S18: {
          type: "list",
          member: {}
        },
        S1c: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              values: {
                shape: "Sf"
              }
            }
          }
        },
        S1n: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              values: {
                shape: "Sf"
              }
            }
          }
        },
        S1u: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              values: {
                shape: "Sf"
              }
            }
          }
        },
        S21: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              values: {
                shape: "Sf"
              }
            }
          }
        },
        S2f: {
          type: "list",
          member: {
            shape: "S2g"
          }
        },
        S2g: {
          type: "structure",
          members: {
            name: {},
            statistic: {},
            value: {
              type: "double"
            }
          }
        },
        S2l: {
          type: "structure",
          members: {
            desiredCapacity: {
              type: "integer"
            },
            minSize: {
              type: "integer"
            },
            maxSize: {
              type: "integer"
            },
            instanceType: {}
          }
        },
        S2s: {
          type: "list",
          member: {
            shape: "S2g"
          }
        },
        S2v: {
          type: "structure",
          members: {
            savingsOpportunityPercentage: {
              type: "double"
            },
            estimatedMonthlySavings: {
              shape: "S2x"
            }
          }
        },
        S2x: {
          type: "structure",
          members: {
            currency: {},
            value: {
              type: "double"
            }
          }
        },
        S31: {
          type: "structure",
          members: {
            gpus: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  gpuCount: {
                    type: "integer"
                  },
                  gpuMemorySizeInMiB: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        S3a: {
          type: "structure",
          members: {
            cpuVendorArchitectures: {
              shape: "S18"
            },
            enhancedInfrastructureMetrics: {},
            inferredWorkloadTypes: {},
            externalMetricsPreference: {
              shape: "S3d"
            },
            lookBackPeriod: {},
            utilizationPreferences: {
              shape: "S3g"
            },
            preferredResources: {
              shape: "S3m"
            },
            savingsEstimationMode: {
              type: "structure",
              members: {
                source: {}
              }
            }
          }
        },
        S3d: {
          type: "structure",
          members: {
            source: {}
          }
        },
        S3g: {
          type: "list",
          member: {
            type: "structure",
            members: {
              metricName: {},
              metricParameters: {
                type: "structure",
                members: {
                  threshold: {},
                  headroom: {}
                }
              }
            }
          }
        },
        S3m: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              includeList: {
                shape: "S3p"
              },
              effectiveIncludeList: {
                shape: "S3p"
              },
              excludeList: {
                shape: "S3p"
              }
            }
          }
        },
        S3p: {
          type: "list",
          member: {}
        },
        S3t: {
          type: "list",
          member: {}
        },
        S3v: {
          type: "list",
          member: {
            type: "structure",
            members: {
              identifier: {},
              code: {},
              message: {}
            }
          }
        },
        S46: {
          type: "structure",
          members: {
            volumeType: {},
            volumeSize: {
              type: "integer"
            },
            volumeBaselineIOPS: {
              type: "integer"
            },
            volumeBurstIOPS: {
              type: "integer"
            },
            volumeBaselineThroughput: {
              type: "integer"
            },
            volumeBurstThroughput: {
              type: "integer"
            },
            rootVolume: {
              type: "boolean"
            }
          }
        },
        S4m: {
          type: "list",
          member: {
            type: "structure",
            members: {
              key: {},
              value: {}
            }
          }
        },
        S5r: {
          type: "list",
          member: {
            type: "timestamp"
          }
        },
        S5s: {
          type: "list",
          member: {
            type: "double"
          }
        },
        S6e: {
          type: "structure",
          members: {
            memory: {
              type: "integer"
            },
            memoryReservation: {
              type: "integer"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/compute-optimizer-2019-11-01.paginators.json
var require_compute_optimizer_2019_11_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/compute-optimizer-2019-11-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeRecommendationExportJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "recommendationExportJobs"
        },
        GetEnrollmentStatusesForOrganization: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "accountEnrollmentStatuses"
        },
        GetLambdaFunctionRecommendations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "lambdaFunctionRecommendations"
        },
        GetRecommendationPreferences: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "recommendationPreferencesDetails"
        },
        GetRecommendationSummaries: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "recommendationSummaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/computeoptimizer.js
var require_computeoptimizer = __commonJS({
  "node_modules/aws-sdk/clients/computeoptimizer.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["computeoptimizer"] = {};
    AWS2.ComputeOptimizer = Service.defineService("computeoptimizer", ["2019-11-01"]);
    Object.defineProperty(apiLoader.services["computeoptimizer"], "2019-11-01", {
      get: function get() {
        var model = require_compute_optimizer_2019_11_01_min();
        model.paginators = require_compute_optimizer_2019_11_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ComputeOptimizer;
  }
});

// node_modules/aws-sdk/apis/frauddetector-2019-11-15.min.json
var require_frauddetector_2019_11_15_min = __commonJS({
  "node_modules/aws-sdk/apis/frauddetector-2019-11-15.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-11-15",
        endpointPrefix: "frauddetector",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Fraud Detector",
        serviceId: "FraudDetector",
        signatureVersion: "v4",
        targetPrefix: "AWSHawksNestServiceFacade",
        uid: "frauddetector-2019-11-15"
      },
      operations: {
        BatchCreateVariable: {
          input: {
            type: "structure",
            required: [
              "variableEntries"
            ],
            members: {
              variableEntries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    dataType: {},
                    dataSource: {},
                    defaultValue: {},
                    description: {},
                    variableType: {}
                  }
                }
              },
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    code: {
                      type: "integer"
                    },
                    message: {}
                  }
                }
              }
            }
          }
        },
        BatchGetVariable: {
          input: {
            type: "structure",
            required: [
              "names"
            ],
            members: {
              names: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              variables: {
                shape: "Sg"
              },
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    code: {
                      type: "integer"
                    },
                    message: {}
                  }
                }
              }
            }
          }
        },
        CancelBatchImportJob: {
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CancelBatchPredictionJob: {
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateBatchImportJob: {
          input: {
            type: "structure",
            required: [
              "jobId",
              "inputPath",
              "outputPath",
              "eventTypeName",
              "iamRoleArn"
            ],
            members: {
              jobId: {},
              inputPath: {},
              outputPath: {},
              eventTypeName: {},
              iamRoleArn: {},
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateBatchPredictionJob: {
          input: {
            type: "structure",
            required: [
              "jobId",
              "inputPath",
              "outputPath",
              "eventTypeName",
              "detectorName",
              "iamRoleArn"
            ],
            members: {
              jobId: {},
              inputPath: {},
              outputPath: {},
              eventTypeName: {},
              detectorName: {},
              detectorVersion: {},
              iamRoleArn: {},
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateDetectorVersion: {
          input: {
            type: "structure",
            required: [
              "detectorId",
              "rules"
            ],
            members: {
              detectorId: {},
              description: {},
              externalModelEndpoints: {
                shape: "S12"
              },
              rules: {
                shape: "S13"
              },
              modelVersions: {
                shape: "S15"
              },
              ruleExecutionMode: {},
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              detectorId: {},
              detectorVersionId: {},
              status: {}
            }
          }
        },
        CreateList: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              elements: {
                shape: "S1f"
              },
              variableType: {},
              description: {},
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateModel: {
          input: {
            type: "structure",
            required: [
              "modelId",
              "modelType",
              "eventTypeName"
            ],
            members: {
              modelId: {},
              modelType: {},
              description: {},
              eventTypeName: {},
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateModelVersion: {
          input: {
            type: "structure",
            required: [
              "modelId",
              "modelType",
              "trainingDataSource",
              "trainingDataSchema"
            ],
            members: {
              modelId: {},
              modelType: {},
              trainingDataSource: {},
              trainingDataSchema: {
                shape: "S1n"
              },
              externalEventsDetail: {
                shape: "S1r"
              },
              ingestedEventsDetail: {
                shape: "S1s"
              },
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              modelId: {},
              modelType: {},
              modelVersionNumber: {},
              status: {}
            }
          }
        },
        CreateRule: {
          input: {
            type: "structure",
            required: [
              "ruleId",
              "detectorId",
              "expression",
              "language",
              "outcomes"
            ],
            members: {
              ruleId: {},
              detectorId: {},
              description: {},
              expression: {
                shape: "S1w"
              },
              language: {},
              outcomes: {
                shape: "S1y"
              },
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              rule: {
                shape: "S14"
              }
            }
          }
        },
        CreateVariable: {
          input: {
            type: "structure",
            required: [
              "name",
              "dataType",
              "dataSource",
              "defaultValue"
            ],
            members: {
              name: {},
              dataType: {},
              dataSource: {},
              defaultValue: {},
              description: {},
              variableType: {},
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteBatchImportJob: {
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteBatchPredictionJob: {
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDetector: {
          input: {
            type: "structure",
            required: [
              "detectorId"
            ],
            members: {
              detectorId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDetectorVersion: {
          input: {
            type: "structure",
            required: [
              "detectorId",
              "detectorVersionId"
            ],
            members: {
              detectorId: {},
              detectorVersionId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteEntityType: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteEvent: {
          input: {
            type: "structure",
            required: [
              "eventId",
              "eventTypeName"
            ],
            members: {
              eventId: {},
              eventTypeName: {},
              deleteAuditHistory: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteEventType: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteEventsByEventType: {
          input: {
            type: "structure",
            required: [
              "eventTypeName"
            ],
            members: {
              eventTypeName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              eventTypeName: {},
              eventsDeletionStatus: {}
            }
          }
        },
        DeleteExternalModel: {
          input: {
            type: "structure",
            required: [
              "modelEndpoint"
            ],
            members: {
              modelEndpoint: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteLabel: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteList: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteModel: {
          input: {
            type: "structure",
            required: [
              "modelId",
              "modelType"
            ],
            members: {
              modelId: {},
              modelType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteModelVersion: {
          input: {
            type: "structure",
            required: [
              "modelId",
              "modelType",
              "modelVersionNumber"
            ],
            members: {
              modelId: {},
              modelType: {},
              modelVersionNumber: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteOutcome: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRule: {
          input: {
            type: "structure",
            required: [
              "rule"
            ],
            members: {
              rule: {
                shape: "S14"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteVariable: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeDetector: {
          input: {
            type: "structure",
            required: [
              "detectorId"
            ],
            members: {
              detectorId: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              detectorId: {},
              detectorVersionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    detectorVersionId: {},
                    status: {},
                    description: {},
                    lastUpdatedTime: {}
                  }
                }
              },
              nextToken: {},
              arn: {}
            }
          }
        },
        DescribeModelVersions: {
          input: {
            type: "structure",
            members: {
              modelId: {},
              modelVersionNumber: {},
              modelType: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              modelVersionDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    modelId: {},
                    modelType: {},
                    modelVersionNumber: {},
                    status: {},
                    trainingDataSource: {},
                    trainingDataSchema: {
                      shape: "S1n"
                    },
                    externalEventsDetail: {
                      shape: "S1r"
                    },
                    ingestedEventsDetail: {
                      shape: "S1s"
                    },
                    trainingResult: {
                      type: "structure",
                      members: {
                        dataValidationMetrics: {
                          shape: "S3b"
                        },
                        trainingMetrics: {
                          type: "structure",
                          members: {
                            auc: {
                              type: "float"
                            },
                            metricDataPoints: {
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  fpr: {
                                    type: "float"
                                  },
                                  precision: {
                                    type: "float"
                                  },
                                  tpr: {
                                    type: "float"
                                  },
                                  threshold: {
                                    type: "float"
                                  }
                                }
                              }
                            }
                          }
                        },
                        variableImportanceMetrics: {
                          shape: "S3k"
                        }
                      }
                    },
                    lastUpdatedTime: {},
                    createdTime: {},
                    arn: {},
                    trainingResultV2: {
                      type: "structure",
                      members: {
                        dataValidationMetrics: {
                          shape: "S3b"
                        },
                        trainingMetricsV2: {
                          type: "structure",
                          members: {
                            ofi: {
                              type: "structure",
                              members: {
                                metricDataPoints: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      fpr: {
                                        type: "float"
                                      },
                                      precision: {
                                        type: "float"
                                      },
                                      tpr: {
                                        type: "float"
                                      },
                                      threshold: {
                                        type: "float"
                                      }
                                    }
                                  }
                                },
                                modelPerformance: {
                                  type: "structure",
                                  members: {
                                    auc: {
                                      type: "float"
                                    },
                                    uncertaintyRange: {
                                      shape: "S3t"
                                    }
                                  }
                                }
                              }
                            },
                            tfi: {
                              type: "structure",
                              members: {
                                metricDataPoints: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      fpr: {
                                        type: "float"
                                      },
                                      precision: {
                                        type: "float"
                                      },
                                      tpr: {
                                        type: "float"
                                      },
                                      threshold: {
                                        type: "float"
                                      }
                                    }
                                  }
                                },
                                modelPerformance: {
                                  type: "structure",
                                  members: {
                                    auc: {
                                      type: "float"
                                    },
                                    uncertaintyRange: {
                                      shape: "S3t"
                                    }
                                  }
                                }
                              }
                            },
                            ati: {
                              type: "structure",
                              members: {
                                metricDataPoints: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      cr: {
                                        type: "float"
                                      },
                                      adr: {
                                        type: "float"
                                      },
                                      threshold: {
                                        type: "float"
                                      },
                                      atodr: {
                                        type: "float"
                                      }
                                    }
                                  }
                                },
                                modelPerformance: {
                                  type: "structure",
                                  members: {
                                    asi: {
                                      type: "float"
                                    }
                                  }
                                }
                              }
                            }
                          }
                        },
                        variableImportanceMetrics: {
                          shape: "S3k"
                        },
                        aggregatedVariablesImportanceMetrics: {
                          type: "structure",
                          members: {
                            logOddsMetrics: {
                              type: "list",
                              member: {
                                type: "structure",
                                required: [
                                  "variableNames",
                                  "aggregatedVariablesImportance"
                                ],
                                members: {
                                  variableNames: {
                                    shape: "S12"
                                  },
                                  aggregatedVariablesImportance: {
                                    type: "float"
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetBatchImportJobs: {
          input: {
            type: "structure",
            members: {
              jobId: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              batchImports: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    jobId: {},
                    status: {},
                    failureReason: {},
                    startTime: {},
                    completionTime: {},
                    inputPath: {},
                    outputPath: {},
                    eventTypeName: {},
                    iamRoleArn: {},
                    arn: {},
                    processedRecordsCount: {
                      type: "integer"
                    },
                    failedRecordsCount: {
                      type: "integer"
                    },
                    totalRecordsCount: {
                      type: "integer"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetBatchPredictionJobs: {
          input: {
            type: "structure",
            members: {
              jobId: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              batchPredictions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    jobId: {},
                    status: {},
                    failureReason: {},
                    startTime: {},
                    completionTime: {},
                    lastHeartbeatTime: {},
                    inputPath: {},
                    outputPath: {},
                    eventTypeName: {},
                    detectorName: {},
                    detectorVersion: {},
                    iamRoleArn: {},
                    arn: {},
                    processedRecordsCount: {
                      type: "integer"
                    },
                    totalRecordsCount: {
                      type: "integer"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetDeleteEventsByEventTypeStatus: {
          input: {
            type: "structure",
            required: [
              "eventTypeName"
            ],
            members: {
              eventTypeName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              eventTypeName: {},
              eventsDeletionStatus: {}
            }
          }
        },
        GetDetectorVersion: {
          input: {
            type: "structure",
            required: [
              "detectorId",
              "detectorVersionId"
            ],
            members: {
              detectorId: {},
              detectorVersionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              detectorId: {},
              detectorVersionId: {},
              description: {},
              externalModelEndpoints: {
                shape: "S12"
              },
              modelVersions: {
                shape: "S15"
              },
              rules: {
                shape: "S13"
              },
              status: {},
              lastUpdatedTime: {},
              createdTime: {},
              ruleExecutionMode: {},
              arn: {}
            }
          }
        },
        GetDetectors: {
          input: {
            type: "structure",
            members: {
              detectorId: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              detectors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    detectorId: {},
                    description: {},
                    eventTypeName: {},
                    lastUpdatedTime: {},
                    createdTime: {},
                    arn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetEntityTypes: {
          input: {
            type: "structure",
            members: {
              name: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              entityTypes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    description: {},
                    lastUpdatedTime: {},
                    createdTime: {},
                    arn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetEvent: {
          input: {
            type: "structure",
            required: [
              "eventId",
              "eventTypeName"
            ],
            members: {
              eventId: {},
              eventTypeName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              event: {
                type: "structure",
                members: {
                  eventId: {},
                  eventTypeName: {},
                  eventTimestamp: {},
                  eventVariables: {
                    type: "map",
                    key: {},
                    value: {
                      type: "string",
                      sensitive: true
                    }
                  },
                  currentLabel: {},
                  labelTimestamp: {},
                  entities: {
                    shape: "S51"
                  }
                }
              }
            }
          }
        },
        GetEventPrediction: {
          input: {
            type: "structure",
            required: [
              "detectorId",
              "eventId",
              "eventTypeName",
              "entities",
              "eventTimestamp",
              "eventVariables"
            ],
            members: {
              detectorId: {},
              detectorVersionId: {},
              eventId: {},
              eventTypeName: {},
              entities: {
                shape: "S51"
              },
              eventTimestamp: {},
              eventVariables: {
                shape: "S56"
              },
              externalModelEndpointDataBlobs: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    byteBuffer: {
                      type: "blob"
                    },
                    contentType: {}
                  }
                },
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              modelScores: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    modelVersion: {
                      shape: "S16"
                    },
                    scores: {
                      type: "map",
                      key: {},
                      value: {
                        type: "float"
                      }
                    }
                  }
                }
              },
              ruleResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ruleId: {},
                    outcomes: {
                      shape: "S12"
                    }
                  }
                }
              },
              externalModelOutputs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    externalModel: {
                      type: "structure",
                      members: {
                        modelEndpoint: {},
                        modelSource: {}
                      }
                    },
                    outputs: {
                      type: "map",
                      key: {},
                      value: {}
                    }
                  }
                }
              }
            }
          }
        },
        GetEventPredictionMetadata: {
          input: {
            type: "structure",
            required: [
              "eventId",
              "eventTypeName",
              "detectorId",
              "detectorVersionId",
              "predictionTimestamp"
            ],
            members: {
              eventId: {},
              eventTypeName: {},
              detectorId: {},
              detectorVersionId: {},
              predictionTimestamp: {}
            }
          },
          output: {
            type: "structure",
            members: {
              eventId: {},
              eventTypeName: {},
              entityId: {},
              entityType: {},
              eventTimestamp: {},
              detectorId: {},
              detectorVersionId: {},
              detectorVersionStatus: {},
              eventVariables: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {
                      shape: "S5s"
                    },
                    value: {
                      shape: "S5s"
                    },
                    source: {
                      shape: "S5s"
                    }
                  }
                }
              },
              rules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ruleId: {},
                    ruleVersion: {},
                    expression: {
                      shape: "S5s"
                    },
                    expressionWithValues: {
                      shape: "S5s"
                    },
                    outcomes: {
                      shape: "S12"
                    },
                    evaluated: {
                      type: "boolean"
                    },
                    matched: {
                      type: "boolean"
                    }
                  }
                }
              },
              ruleExecutionMode: {},
              outcomes: {
                shape: "S12"
              },
              evaluatedModelVersions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    modelId: {},
                    modelVersion: {},
                    modelType: {},
                    evaluations: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          outputVariableName: {},
                          evaluationScore: {},
                          predictionExplanations: {
                            type: "structure",
                            members: {
                              variableImpactExplanations: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    eventVariableName: {},
                                    relativeImpact: {},
                                    logOddsImpact: {
                                      type: "float"
                                    }
                                  }
                                }
                              },
                              aggregatedVariablesImpactExplanations: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    eventVariableNames: {
                                      shape: "S12"
                                    },
                                    relativeImpact: {},
                                    logOddsImpact: {
                                      type: "float"
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              evaluatedExternalModels: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    modelEndpoint: {},
                    useEventVariables: {
                      type: "boolean"
                    },
                    inputVariables: {
                      shape: "S67"
                    },
                    outputVariables: {
                      shape: "S67"
                    }
                  }
                }
              },
              predictionTimestamp: {}
            }
          }
        },
        GetEventTypes: {
          input: {
            type: "structure",
            members: {
              name: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              eventTypes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    description: {},
                    eventVariables: {
                      shape: "S12"
                    },
                    labels: {
                      shape: "S12"
                    },
                    entityTypes: {
                      shape: "S1y"
                    },
                    eventIngestion: {},
                    ingestedEventStatistics: {
                      type: "structure",
                      members: {
                        numberOfEvents: {
                          type: "long"
                        },
                        eventDataSizeInBytes: {
                          type: "long"
                        },
                        leastRecentEvent: {},
                        mostRecentEvent: {},
                        lastUpdatedTime: {}
                      }
                    },
                    lastUpdatedTime: {},
                    createdTime: {},
                    arn: {},
                    eventOrchestration: {
                      shape: "S6g"
                    }
                  },
                  sensitive: true
                }
              },
              nextToken: {}
            }
          }
        },
        GetExternalModels: {
          input: {
            type: "structure",
            members: {
              modelEndpoint: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              externalModels: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    modelEndpoint: {},
                    modelSource: {},
                    invokeModelEndpointRoleArn: {},
                    inputConfiguration: {
                      shape: "S6m"
                    },
                    outputConfiguration: {
                      shape: "S6q"
                    },
                    modelEndpointStatus: {},
                    lastUpdatedTime: {},
                    createdTime: {},
                    arn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetKMSEncryptionKey: {
          output: {
            type: "structure",
            members: {
              kmsKey: {
                type: "structure",
                members: {
                  kmsEncryptionKeyArn: {}
                }
              }
            }
          }
        },
        GetLabels: {
          input: {
            type: "structure",
            members: {
              name: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              labels: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    description: {},
                    lastUpdatedTime: {},
                    createdTime: {},
                    arn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetListElements: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              elements: {
                shape: "S1f"
              },
              nextToken: {}
            }
          }
        },
        GetListsMetadata: {
          input: {
            type: "structure",
            members: {
              name: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              lists: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name"
                  ],
                  members: {
                    name: {},
                    description: {},
                    variableType: {},
                    createdTime: {},
                    updatedTime: {},
                    arn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetModelVersion: {
          input: {
            type: "structure",
            required: [
              "modelId",
              "modelType",
              "modelVersionNumber"
            ],
            members: {
              modelId: {},
              modelType: {},
              modelVersionNumber: {}
            }
          },
          output: {
            type: "structure",
            members: {
              modelId: {},
              modelType: {},
              modelVersionNumber: {},
              trainingDataSource: {},
              trainingDataSchema: {
                shape: "S1n"
              },
              externalEventsDetail: {
                shape: "S1r"
              },
              ingestedEventsDetail: {
                shape: "S1s"
              },
              status: {},
              arn: {}
            }
          }
        },
        GetModels: {
          input: {
            type: "structure",
            members: {
              modelId: {},
              modelType: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              models: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    modelId: {},
                    modelType: {},
                    description: {},
                    eventTypeName: {},
                    createdTime: {},
                    lastUpdatedTime: {},
                    arn: {}
                  }
                }
              }
            }
          }
        },
        GetOutcomes: {
          input: {
            type: "structure",
            members: {
              name: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              outcomes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    description: {},
                    lastUpdatedTime: {},
                    createdTime: {},
                    arn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetRules: {
          input: {
            type: "structure",
            required: [
              "detectorId"
            ],
            members: {
              ruleId: {},
              detectorId: {},
              ruleVersion: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ruleDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ruleId: {},
                    description: {},
                    detectorId: {},
                    ruleVersion: {},
                    expression: {
                      shape: "S1w"
                    },
                    language: {},
                    outcomes: {
                      shape: "S1y"
                    },
                    lastUpdatedTime: {},
                    createdTime: {},
                    arn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetVariables: {
          input: {
            type: "structure",
            members: {
              name: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              variables: {
                shape: "Sg"
              },
              nextToken: {}
            }
          }
        },
        ListEventPredictions: {
          input: {
            type: "structure",
            members: {
              eventId: {
                shape: "S7w"
              },
              eventType: {
                shape: "S7w"
              },
              detectorId: {
                shape: "S7w"
              },
              detectorVersionId: {
                shape: "S7w"
              },
              predictionTimeRange: {
                type: "structure",
                required: [
                  "startTime",
                  "endTime"
                ],
                members: {
                  startTime: {},
                  endTime: {}
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              eventPredictionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    eventId: {},
                    eventTypeName: {},
                    eventTimestamp: {},
                    predictionTimestamp: {},
                    detectorId: {},
                    detectorVersionId: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceARN"
            ],
            members: {
              resourceARN: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S5"
              },
              nextToken: {}
            }
          }
        },
        PutDetector: {
          input: {
            type: "structure",
            required: [
              "detectorId",
              "eventTypeName"
            ],
            members: {
              detectorId: {},
              description: {},
              eventTypeName: {},
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutEntityType: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              description: {},
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutEventType: {
          input: {
            type: "structure",
            required: [
              "name",
              "eventVariables",
              "entityTypes"
            ],
            members: {
              name: {},
              description: {},
              eventVariables: {
                shape: "S1y"
              },
              labels: {
                shape: "S12"
              },
              entityTypes: {
                shape: "S1y"
              },
              eventIngestion: {},
              tags: {
                shape: "S5"
              },
              eventOrchestration: {
                shape: "S6g"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutExternalModel: {
          input: {
            type: "structure",
            required: [
              "modelEndpoint",
              "modelSource",
              "invokeModelEndpointRoleArn",
              "inputConfiguration",
              "outputConfiguration",
              "modelEndpointStatus"
            ],
            members: {
              modelEndpoint: {},
              modelSource: {},
              invokeModelEndpointRoleArn: {},
              inputConfiguration: {
                shape: "S6m"
              },
              outputConfiguration: {
                shape: "S6q"
              },
              modelEndpointStatus: {},
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutKMSEncryptionKey: {
          input: {
            type: "structure",
            required: [
              "kmsEncryptionKeyArn"
            ],
            members: {
              kmsEncryptionKeyArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutLabel: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              description: {},
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutOutcome: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              description: {},
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SendEvent: {
          input: {
            type: "structure",
            required: [
              "eventId",
              "eventTypeName",
              "eventTimestamp",
              "eventVariables",
              "entities"
            ],
            members: {
              eventId: {},
              eventTypeName: {},
              eventTimestamp: {},
              eventVariables: {
                shape: "S56"
              },
              assignedLabel: {},
              labelTimestamp: {},
              entities: {
                shape: "S51"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "resourceARN",
              "tags"
            ],
            members: {
              resourceARN: {},
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "resourceARN",
              "tagKeys"
            ],
            members: {
              resourceARN: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDetectorVersion: {
          input: {
            type: "structure",
            required: [
              "detectorId",
              "detectorVersionId",
              "externalModelEndpoints",
              "rules"
            ],
            members: {
              detectorId: {},
              detectorVersionId: {},
              externalModelEndpoints: {
                shape: "S12"
              },
              rules: {
                shape: "S13"
              },
              description: {},
              modelVersions: {
                shape: "S15"
              },
              ruleExecutionMode: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDetectorVersionMetadata: {
          input: {
            type: "structure",
            required: [
              "detectorId",
              "detectorVersionId",
              "description"
            ],
            members: {
              detectorId: {},
              detectorVersionId: {},
              description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDetectorVersionStatus: {
          input: {
            type: "structure",
            required: [
              "detectorId",
              "detectorVersionId",
              "status"
            ],
            members: {
              detectorId: {},
              detectorVersionId: {},
              status: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateEventLabel: {
          input: {
            type: "structure",
            required: [
              "eventId",
              "eventTypeName",
              "assignedLabel",
              "labelTimestamp"
            ],
            members: {
              eventId: {},
              eventTypeName: {},
              assignedLabel: {},
              labelTimestamp: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateList: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              elements: {
                shape: "S1f"
              },
              description: {},
              updateMode: {},
              variableType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateModel: {
          input: {
            type: "structure",
            required: [
              "modelId",
              "modelType"
            ],
            members: {
              modelId: {},
              modelType: {},
              description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateModelVersion: {
          input: {
            type: "structure",
            required: [
              "modelId",
              "modelType",
              "majorVersionNumber"
            ],
            members: {
              modelId: {},
              modelType: {},
              majorVersionNumber: {},
              externalEventsDetail: {
                shape: "S1r"
              },
              ingestedEventsDetail: {
                shape: "S1s"
              },
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              modelId: {},
              modelType: {},
              modelVersionNumber: {},
              status: {}
            }
          }
        },
        UpdateModelVersionStatus: {
          input: {
            type: "structure",
            required: [
              "modelId",
              "modelType",
              "modelVersionNumber",
              "status"
            ],
            members: {
              modelId: {},
              modelType: {},
              modelVersionNumber: {},
              status: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateRuleMetadata: {
          input: {
            type: "structure",
            required: [
              "rule",
              "description"
            ],
            members: {
              rule: {
                shape: "S14"
              },
              description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateRuleVersion: {
          input: {
            type: "structure",
            required: [
              "rule",
              "expression",
              "language",
              "outcomes"
            ],
            members: {
              rule: {
                shape: "S14"
              },
              description: {},
              expression: {
                shape: "S1w"
              },
              language: {},
              outcomes: {
                shape: "S1y"
              },
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              rule: {
                shape: "S14"
              }
            }
          }
        },
        UpdateVariable: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              defaultValue: {},
              description: {},
              variableType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S5: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        Sg: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              dataType: {},
              dataSource: {},
              defaultValue: {},
              description: {},
              variableType: {},
              lastUpdatedTime: {},
              createdTime: {},
              arn: {}
            }
          }
        },
        S12: {
          type: "list",
          member: {}
        },
        S13: {
          type: "list",
          member: {
            shape: "S14"
          }
        },
        S14: {
          type: "structure",
          required: [
            "detectorId",
            "ruleId",
            "ruleVersion"
          ],
          members: {
            detectorId: {},
            ruleId: {},
            ruleVersion: {}
          }
        },
        S15: {
          type: "list",
          member: {
            shape: "S16"
          }
        },
        S16: {
          type: "structure",
          required: [
            "modelId",
            "modelType",
            "modelVersionNumber"
          ],
          members: {
            modelId: {},
            modelType: {},
            modelVersionNumber: {},
            arn: {}
          }
        },
        S1f: {
          type: "list",
          member: {
            type: "string",
            sensitive: true
          }
        },
        S1n: {
          type: "structure",
          required: [
            "modelVariables"
          ],
          members: {
            modelVariables: {
              shape: "S12"
            },
            labelSchema: {
              type: "structure",
              members: {
                labelMapper: {
                  type: "map",
                  key: {},
                  value: {
                    shape: "S12"
                  }
                },
                unlabeledEventsTreatment: {}
              }
            }
          }
        },
        S1r: {
          type: "structure",
          required: [
            "dataLocation",
            "dataAccessRoleArn"
          ],
          members: {
            dataLocation: {},
            dataAccessRoleArn: {}
          }
        },
        S1s: {
          type: "structure",
          required: [
            "ingestedEventsTimeWindow"
          ],
          members: {
            ingestedEventsTimeWindow: {
              type: "structure",
              required: [
                "startTime",
                "endTime"
              ],
              members: {
                startTime: {},
                endTime: {}
              }
            }
          }
        },
        S1w: {
          type: "string",
          sensitive: true
        },
        S1y: {
          type: "list",
          member: {}
        },
        S3b: {
          type: "structure",
          members: {
            fileLevelMessages: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  title: {},
                  content: {},
                  type: {}
                }
              }
            },
            fieldLevelMessages: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  fieldName: {},
                  identifier: {},
                  title: {},
                  content: {},
                  type: {}
                }
              }
            }
          }
        },
        S3k: {
          type: "structure",
          members: {
            logOddsMetrics: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "variableName",
                  "variableType",
                  "variableImportance"
                ],
                members: {
                  variableName: {},
                  variableType: {},
                  variableImportance: {
                    type: "float"
                  }
                }
              }
            }
          }
        },
        S3t: {
          type: "structure",
          required: [
            "lowerBoundValue",
            "upperBoundValue"
          ],
          members: {
            lowerBoundValue: {
              type: "float"
            },
            upperBoundValue: {
              type: "float"
            }
          }
        },
        S51: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "entityType",
              "entityId"
            ],
            members: {
              entityType: {},
              entityId: {}
            },
            sensitive: true
          }
        },
        S56: {
          type: "map",
          key: {},
          value: {
            type: "string",
            sensitive: true
          }
        },
        S5s: {
          type: "string",
          sensitive: true
        },
        S67: {
          type: "map",
          key: {},
          value: {},
          sensitive: true
        },
        S6g: {
          type: "structure",
          required: [
            "eventBridgeEnabled"
          ],
          members: {
            eventBridgeEnabled: {
              type: "boolean"
            }
          }
        },
        S6m: {
          type: "structure",
          required: [
            "useEventVariables"
          ],
          members: {
            eventTypeName: {},
            format: {},
            useEventVariables: {
              type: "boolean"
            },
            jsonInputTemplate: {},
            csvInputTemplate: {}
          }
        },
        S6q: {
          type: "structure",
          required: [
            "format"
          ],
          members: {
            format: {},
            jsonKeyToVariableMap: {
              type: "map",
              key: {},
              value: {}
            },
            csvIndexToVariableMap: {
              type: "map",
              key: {},
              value: {}
            }
          }
        },
        S7w: {
          type: "structure",
          members: {
            value: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/frauddetector-2019-11-15.paginators.json
var require_frauddetector_2019_11_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/frauddetector-2019-11-15.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeModelVersions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetBatchImportJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetBatchPredictionJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetDetectors: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetEntityTypes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetEventTypes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetExternalModels: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetLabels: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetListElements: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetListsMetadata: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetModels: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetOutcomes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetRules: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetVariables: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListEventPredictions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListTagsForResource: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/frauddetector.js
var require_frauddetector = __commonJS({
  "node_modules/aws-sdk/clients/frauddetector.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["frauddetector"] = {};
    AWS2.FraudDetector = Service.defineService("frauddetector", ["2019-11-15"]);
    Object.defineProperty(apiLoader.services["frauddetector"], "2019-11-15", {
      get: function get() {
        var model = require_frauddetector_2019_11_15_min();
        model.paginators = require_frauddetector_2019_11_15_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.FraudDetector;
  }
});

// node_modules/aws-sdk/apis/kendra-2019-02-03.min.json
var require_kendra_2019_02_03_min = __commonJS({
  "node_modules/aws-sdk/apis/kendra-2019-02-03.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-02-03",
        endpointPrefix: "kendra",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "kendra",
        serviceFullName: "AWSKendraFrontendService",
        serviceId: "kendra",
        signatureVersion: "v4",
        signingName: "kendra",
        targetPrefix: "AWSKendraFrontendService",
        uid: "kendra-2019-02-03"
      },
      operations: {
        AssociateEntitiesToExperience: {
          input: {
            type: "structure",
            required: [
              "Id",
              "IndexId",
              "EntityList"
            ],
            members: {
              Id: {},
              IndexId: {},
              EntityList: {
                type: "list",
                member: {
                  shape: "S5"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedEntityList: {
                type: "list",
                member: {
                  shape: "Sa"
                }
              }
            }
          }
        },
        AssociatePersonasToEntities: {
          input: {
            type: "structure",
            required: [
              "Id",
              "IndexId",
              "Personas"
            ],
            members: {
              Id: {},
              IndexId: {},
              Personas: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "EntityId",
                    "Persona"
                  ],
                  members: {
                    EntityId: {},
                    Persona: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedEntityList: {
                shape: "Sh"
              }
            }
          }
        },
        BatchDeleteDocument: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "DocumentIdList"
            ],
            members: {
              IndexId: {},
              DocumentIdList: {
                type: "list",
                member: {}
              },
              DataSourceSyncJobMetricTarget: {
                type: "structure",
                required: [
                  "DataSourceId"
                ],
                members: {
                  DataSourceId: {},
                  DataSourceSyncJobId: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedDocuments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        BatchDeleteFeaturedResultsSet: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "FeaturedResultsSetIds"
            ],
            members: {
              IndexId: {},
              FeaturedResultsSetIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Errors"
            ],
            members: {
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Id",
                    "ErrorCode",
                    "ErrorMessage"
                  ],
                  members: {
                    Id: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        BatchGetDocumentStatus: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "DocumentInfoList"
            ],
            members: {
              IndexId: {},
              DocumentInfoList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "DocumentId"
                  ],
                  members: {
                    DocumentId: {},
                    Attributes: {
                      shape: "S11"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DocumentId: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              },
              DocumentStatusList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DocumentId: {},
                    DocumentStatus: {},
                    FailureCode: {},
                    FailureReason: {}
                  }
                }
              }
            }
          }
        },
        BatchPutDocument: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "Documents"
            ],
            members: {
              IndexId: {},
              RoleArn: {},
              Documents: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Id"
                  ],
                  members: {
                    Id: {},
                    Title: {},
                    Blob: {
                      type: "blob"
                    },
                    S3Path: {
                      shape: "S1m"
                    },
                    Attributes: {
                      shape: "S11"
                    },
                    AccessControlList: {
                      shape: "S1p"
                    },
                    HierarchicalAccessControlList: {
                      shape: "S1u"
                    },
                    ContentType: {},
                    AccessControlConfigurationId: {}
                  }
                }
              },
              CustomDocumentEnrichmentConfiguration: {
                shape: "S1y"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedDocuments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        ClearQuerySuggestions: {
          input: {
            type: "structure",
            required: [
              "IndexId"
            ],
            members: {
              IndexId: {}
            }
          }
        },
        CreateAccessControlConfiguration: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "Name"
            ],
            members: {
              IndexId: {},
              Name: {},
              Description: {},
              AccessControlList: {
                shape: "S1p"
              },
              HierarchicalAccessControlList: {
                shape: "S1u"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          }
        },
        CreateDataSource: {
          input: {
            type: "structure",
            required: [
              "Name",
              "IndexId",
              "Type"
            ],
            members: {
              Name: {},
              IndexId: {},
              Type: {},
              Configuration: {
                shape: "S2j"
              },
              VpcConfiguration: {
                shape: "S2u"
              },
              Description: {},
              Schedule: {},
              RoleArn: {},
              Tags: {
                shape: "S6r"
              },
              ClientToken: {
                idempotencyToken: true
              },
              LanguageCode: {},
              CustomDocumentEnrichmentConfiguration: {
                shape: "S1y"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          }
        },
        CreateExperience: {
          input: {
            type: "structure",
            required: [
              "Name",
              "IndexId"
            ],
            members: {
              Name: {},
              IndexId: {},
              RoleArn: {},
              Configuration: {
                shape: "S6z"
              },
              Description: {},
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          }
        },
        CreateFaq: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "Name",
              "S3Path",
              "RoleArn"
            ],
            members: {
              IndexId: {},
              Name: {},
              Description: {},
              S3Path: {
                shape: "S1m"
              },
              RoleArn: {},
              Tags: {
                shape: "S6r"
              },
              FileFormat: {},
              ClientToken: {
                idempotencyToken: true
              },
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {}
            }
          }
        },
        CreateFeaturedResultsSet: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "FeaturedResultsSetName"
            ],
            members: {
              IndexId: {},
              FeaturedResultsSetName: {},
              Description: {},
              ClientToken: {},
              Status: {},
              QueryTexts: {
                shape: "S7f"
              },
              FeaturedDocuments: {
                shape: "S7h"
              },
              Tags: {
                shape: "S6r"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FeaturedResultsSet: {
                shape: "S7k"
              }
            }
          }
        },
        CreateIndex: {
          input: {
            type: "structure",
            required: [
              "Name",
              "RoleArn"
            ],
            members: {
              Name: {},
              Edition: {},
              RoleArn: {},
              ServerSideEncryptionConfiguration: {
                shape: "S7o"
              },
              Description: {},
              ClientToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S6r"
              },
              UserTokenConfigurations: {
                shape: "S7q"
              },
              UserContextPolicy: {},
              UserGroupResolutionConfiguration: {
                shape: "S80"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {}
            }
          }
        },
        CreateQuerySuggestionsBlockList: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "Name",
              "SourceS3Path",
              "RoleArn"
            ],
            members: {
              IndexId: {},
              Name: {},
              Description: {},
              SourceS3Path: {
                shape: "S1m"
              },
              ClientToken: {
                idempotencyToken: true
              },
              RoleArn: {},
              Tags: {
                shape: "S6r"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {}
            }
          }
        },
        CreateThesaurus: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "Name",
              "RoleArn",
              "SourceS3Path"
            ],
            members: {
              IndexId: {},
              Name: {},
              Description: {},
              RoleArn: {},
              Tags: {
                shape: "S6r"
              },
              SourceS3Path: {
                shape: "S1m"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {}
            }
          }
        },
        DeleteAccessControlConfiguration: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "Id"
            ],
            members: {
              IndexId: {},
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDataSource: {
          input: {
            type: "structure",
            required: [
              "Id",
              "IndexId"
            ],
            members: {
              Id: {},
              IndexId: {}
            }
          }
        },
        DeleteExperience: {
          input: {
            type: "structure",
            required: [
              "Id",
              "IndexId"
            ],
            members: {
              Id: {},
              IndexId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteFaq: {
          input: {
            type: "structure",
            required: [
              "Id",
              "IndexId"
            ],
            members: {
              Id: {},
              IndexId: {}
            }
          }
        },
        DeleteIndex: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          }
        },
        DeletePrincipalMapping: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "GroupId"
            ],
            members: {
              IndexId: {},
              DataSourceId: {},
              GroupId: {},
              OrderingId: {
                type: "long"
              }
            }
          }
        },
        DeleteQuerySuggestionsBlockList: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "Id"
            ],
            members: {
              IndexId: {},
              Id: {}
            }
          }
        },
        DeleteThesaurus: {
          input: {
            type: "structure",
            required: [
              "Id",
              "IndexId"
            ],
            members: {
              Id: {},
              IndexId: {}
            }
          }
        },
        DescribeAccessControlConfiguration: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "Id"
            ],
            members: {
              IndexId: {},
              Id: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Description: {},
              ErrorMessage: {},
              AccessControlList: {
                shape: "S1p"
              },
              HierarchicalAccessControlList: {
                shape: "S1u"
              }
            }
          }
        },
        DescribeDataSource: {
          input: {
            type: "structure",
            required: [
              "Id",
              "IndexId"
            ],
            members: {
              Id: {},
              IndexId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {},
              IndexId: {},
              Name: {},
              Type: {},
              Configuration: {
                shape: "S2j"
              },
              VpcConfiguration: {
                shape: "S2u"
              },
              CreatedAt: {
                type: "timestamp"
              },
              UpdatedAt: {
                type: "timestamp"
              },
              Description: {},
              Status: {},
              Schedule: {},
              RoleArn: {},
              ErrorMessage: {},
              LanguageCode: {},
              CustomDocumentEnrichmentConfiguration: {
                shape: "S1y"
              }
            }
          }
        },
        DescribeExperience: {
          input: {
            type: "structure",
            required: [
              "Id",
              "IndexId"
            ],
            members: {
              Id: {},
              IndexId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {},
              IndexId: {},
              Name: {},
              Endpoints: {
                shape: "S8u"
              },
              Configuration: {
                shape: "S6z"
              },
              CreatedAt: {
                type: "timestamp"
              },
              UpdatedAt: {
                type: "timestamp"
              },
              Description: {},
              Status: {},
              RoleArn: {},
              ErrorMessage: {}
            }
          }
        },
        DescribeFaq: {
          input: {
            type: "structure",
            required: [
              "Id",
              "IndexId"
            ],
            members: {
              Id: {},
              IndexId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {},
              IndexId: {},
              Name: {},
              Description: {},
              CreatedAt: {
                type: "timestamp"
              },
              UpdatedAt: {
                type: "timestamp"
              },
              S3Path: {
                shape: "S1m"
              },
              Status: {},
              RoleArn: {},
              ErrorMessage: {},
              FileFormat: {},
              LanguageCode: {}
            }
          }
        },
        DescribeFeaturedResultsSet: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "FeaturedResultsSetId"
            ],
            members: {
              IndexId: {},
              FeaturedResultsSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FeaturedResultsSetId: {},
              FeaturedResultsSetName: {},
              Description: {},
              Status: {},
              QueryTexts: {
                shape: "S7f"
              },
              FeaturedDocumentsWithMetadata: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Title: {},
                    URI: {}
                  }
                }
              },
              FeaturedDocumentsMissing: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {}
                  }
                }
              },
              LastUpdatedTimestamp: {
                type: "long"
              },
              CreationTimestamp: {
                type: "long"
              }
            }
          }
        },
        DescribeIndex: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Id: {},
              Edition: {},
              RoleArn: {},
              ServerSideEncryptionConfiguration: {
                shape: "S7o"
              },
              Status: {},
              Description: {},
              CreatedAt: {
                type: "timestamp"
              },
              UpdatedAt: {
                type: "timestamp"
              },
              DocumentMetadataConfigurations: {
                shape: "S9b"
              },
              IndexStatistics: {
                type: "structure",
                required: [
                  "FaqStatistics",
                  "TextDocumentStatistics"
                ],
                members: {
                  FaqStatistics: {
                    type: "structure",
                    required: [
                      "IndexedQuestionAnswersCount"
                    ],
                    members: {
                      IndexedQuestionAnswersCount: {
                        type: "integer"
                      }
                    }
                  },
                  TextDocumentStatistics: {
                    type: "structure",
                    required: [
                      "IndexedTextDocumentsCount",
                      "IndexedTextBytes"
                    ],
                    members: {
                      IndexedTextDocumentsCount: {
                        type: "integer"
                      },
                      IndexedTextBytes: {
                        type: "long"
                      }
                    }
                  }
                }
              },
              ErrorMessage: {},
              CapacityUnits: {
                shape: "S9t"
              },
              UserTokenConfigurations: {
                shape: "S7q"
              },
              UserContextPolicy: {},
              UserGroupResolutionConfiguration: {
                shape: "S80"
              }
            }
          }
        },
        DescribePrincipalMapping: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "GroupId"
            ],
            members: {
              IndexId: {},
              DataSourceId: {},
              GroupId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IndexId: {},
              DataSourceId: {},
              GroupId: {},
              GroupOrderingIdSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Status: {},
                    LastUpdatedAt: {
                      type: "timestamp"
                    },
                    ReceivedAt: {
                      type: "timestamp"
                    },
                    OrderingId: {
                      type: "long"
                    },
                    FailureReason: {}
                  }
                }
              }
            }
          }
        },
        DescribeQuerySuggestionsBlockList: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "Id"
            ],
            members: {
              IndexId: {},
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IndexId: {},
              Id: {},
              Name: {},
              Description: {},
              Status: {},
              ErrorMessage: {},
              CreatedAt: {
                type: "timestamp"
              },
              UpdatedAt: {
                type: "timestamp"
              },
              SourceS3Path: {
                shape: "S1m"
              },
              ItemCount: {
                type: "integer"
              },
              FileSizeBytes: {
                type: "long"
              },
              RoleArn: {}
            }
          }
        },
        DescribeQuerySuggestionsConfig: {
          input: {
            type: "structure",
            required: [
              "IndexId"
            ],
            members: {
              IndexId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Mode: {},
              Status: {},
              QueryLogLookBackWindowInDays: {
                type: "integer"
              },
              IncludeQueriesWithoutUserInformation: {
                type: "boolean"
              },
              MinimumNumberOfQueryingUsers: {
                type: "integer"
              },
              MinimumQueryCount: {
                type: "integer"
              },
              LastSuggestionsBuildTime: {
                type: "timestamp"
              },
              LastClearTime: {
                type: "timestamp"
              },
              TotalSuggestionsCount: {
                type: "integer"
              },
              AttributeSuggestionsConfig: {
                type: "structure",
                members: {
                  SuggestableConfigList: {
                    shape: "Sae"
                  },
                  AttributeSuggestionsMode: {}
                }
              }
            }
          }
        },
        DescribeThesaurus: {
          input: {
            type: "structure",
            required: [
              "Id",
              "IndexId"
            ],
            members: {
              Id: {},
              IndexId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {},
              IndexId: {},
              Name: {},
              Description: {},
              Status: {},
              ErrorMessage: {},
              CreatedAt: {
                type: "timestamp"
              },
              UpdatedAt: {
                type: "timestamp"
              },
              RoleArn: {},
              SourceS3Path: {
                shape: "S1m"
              },
              FileSizeBytes: {
                type: "long"
              },
              TermCount: {
                type: "long"
              },
              SynonymRuleCount: {
                type: "long"
              }
            }
          }
        },
        DisassociateEntitiesFromExperience: {
          input: {
            type: "structure",
            required: [
              "Id",
              "IndexId",
              "EntityList"
            ],
            members: {
              Id: {},
              IndexId: {},
              EntityList: {
                type: "list",
                member: {
                  shape: "S5"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedEntityList: {
                shape: "Sh"
              }
            }
          }
        },
        DisassociatePersonasFromEntities: {
          input: {
            type: "structure",
            required: [
              "Id",
              "IndexId",
              "EntityIds"
            ],
            members: {
              Id: {},
              IndexId: {},
              EntityIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedEntityList: {
                shape: "Sh"
              }
            }
          }
        },
        GetQuerySuggestions: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "QueryText"
            ],
            members: {
              IndexId: {},
              QueryText: {},
              MaxSuggestionsCount: {
                type: "integer"
              },
              SuggestionTypes: {
                type: "list",
                member: {}
              },
              AttributeSuggestionsConfig: {
                type: "structure",
                members: {
                  SuggestionAttributes: {
                    shape: "Sav"
                  },
                  AdditionalResponseAttributes: {
                    shape: "Sav"
                  },
                  AttributeFilter: {
                    shape: "Saw"
                  },
                  UserContext: {
                    shape: "Say"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              QuerySuggestionsId: {},
              Suggestions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Value: {
                      type: "structure",
                      members: {
                        Text: {
                          type: "structure",
                          members: {
                            Text: {},
                            Highlights: {
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  BeginOffset: {
                                    type: "integer"
                                  },
                                  EndOffset: {
                                    type: "integer"
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    SourceDocuments: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          DocumentId: {},
                          SuggestionAttributes: {
                            shape: "Sav"
                          },
                          AdditionalAttributes: {
                            shape: "S11"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetSnapshots: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "Interval",
              "MetricType"
            ],
            members: {
              IndexId: {},
              Interval: {},
              MetricType: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SnapShotTimeFilter: {
                shape: "Sbj"
              },
              SnapshotsDataHeader: {
                type: "list",
                member: {}
              },
              SnapshotsData: {
                type: "list",
                member: {
                  type: "list",
                  member: {}
                }
              },
              NextToken: {}
            }
          }
        },
        ListAccessControlConfigurations: {
          input: {
            type: "structure",
            required: [
              "IndexId"
            ],
            members: {
              IndexId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "AccessControlConfigurations"
            ],
            members: {
              NextToken: {},
              AccessControlConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Id"
                  ],
                  members: {
                    Id: {}
                  }
                }
              }
            }
          }
        },
        ListDataSourceSyncJobs: {
          input: {
            type: "structure",
            required: [
              "Id",
              "IndexId"
            ],
            members: {
              Id: {},
              IndexId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              StartTimeFilter: {
                shape: "Sbj"
              },
              StatusFilter: {}
            }
          },
          output: {
            type: "structure",
            members: {
              History: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ExecutionId: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    Status: {},
                    ErrorMessage: {},
                    ErrorCode: {},
                    DataSourceErrorCode: {},
                    Metrics: {
                      type: "structure",
                      members: {
                        DocumentsAdded: {},
                        DocumentsModified: {},
                        DocumentsDeleted: {},
                        DocumentsFailed: {},
                        DocumentsScanned: {}
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDataSources: {
          input: {
            type: "structure",
            required: [
              "IndexId"
            ],
            members: {
              IndexId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SummaryItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Id: {},
                    Type: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    UpdatedAt: {
                      type: "timestamp"
                    },
                    Status: {},
                    LanguageCode: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEntityPersonas: {
          input: {
            type: "structure",
            required: [
              "Id",
              "IndexId"
            ],
            members: {
              Id: {},
              IndexId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SummaryItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EntityId: {},
                    Persona: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    UpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListExperienceEntities: {
          input: {
            type: "structure",
            required: [
              "Id",
              "IndexId"
            ],
            members: {
              Id: {},
              IndexId: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SummaryItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EntityId: {},
                    EntityType: {},
                    DisplayData: {
                      type: "structure",
                      members: {
                        UserName: {
                          shape: "Scf"
                        },
                        GroupName: {
                          shape: "Scf"
                        },
                        IdentifiedUserName: {
                          shape: "Scf"
                        },
                        FirstName: {
                          shape: "Scf"
                        },
                        LastName: {
                          shape: "Scf"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListExperiences: {
          input: {
            type: "structure",
            required: [
              "IndexId"
            ],
            members: {
              IndexId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SummaryItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Id: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    Status: {},
                    Endpoints: {
                      shape: "S8u"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListFaqs: {
          input: {
            type: "structure",
            required: [
              "IndexId"
            ],
            members: {
              IndexId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              FaqSummaryItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Name: {},
                    Status: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    UpdatedAt: {
                      type: "timestamp"
                    },
                    FileFormat: {},
                    LanguageCode: {}
                  }
                }
              }
            }
          }
        },
        ListFeaturedResultsSets: {
          input: {
            type: "structure",
            required: [
              "IndexId"
            ],
            members: {
              IndexId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FeaturedResultsSetSummaryItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FeaturedResultsSetId: {},
                    FeaturedResultsSetName: {},
                    Status: {},
                    LastUpdatedTimestamp: {
                      type: "long"
                    },
                    CreationTimestamp: {
                      type: "long"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListGroupsOlderThanOrderingId: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "OrderingId"
            ],
            members: {
              IndexId: {},
              DataSourceId: {},
              OrderingId: {
                type: "long"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GroupsSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    GroupId: {},
                    OrderingId: {
                      type: "long"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListIndices: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IndexConfigurationSummaryItems: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "CreatedAt",
                    "UpdatedAt",
                    "Status"
                  ],
                  members: {
                    Name: {},
                    Id: {},
                    Edition: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    UpdatedAt: {
                      type: "timestamp"
                    },
                    Status: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListQuerySuggestionsBlockLists: {
          input: {
            type: "structure",
            required: [
              "IndexId"
            ],
            members: {
              IndexId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BlockListSummaryItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Name: {},
                    Status: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    UpdatedAt: {
                      type: "timestamp"
                    },
                    ItemCount: {
                      type: "integer"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S6r"
              }
            }
          }
        },
        ListThesauri: {
          input: {
            type: "structure",
            required: [
              "IndexId"
            ],
            members: {
              IndexId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ThesaurusSummaryItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Name: {},
                    Status: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    UpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        PutPrincipalMapping: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "GroupId",
              "GroupMembers"
            ],
            members: {
              IndexId: {},
              DataSourceId: {},
              GroupId: {},
              GroupMembers: {
                type: "structure",
                members: {
                  MemberGroups: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "GroupId"
                      ],
                      members: {
                        GroupId: {},
                        DataSourceId: {}
                      }
                    }
                  },
                  MemberUsers: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "UserId"
                      ],
                      members: {
                        UserId: {}
                      }
                    }
                  },
                  S3PathforGroupMembers: {
                    shape: "S1m"
                  }
                }
              },
              OrderingId: {
                type: "long"
              },
              RoleArn: {}
            }
          }
        },
        Query: {
          input: {
            type: "structure",
            required: [
              "IndexId"
            ],
            members: {
              IndexId: {},
              QueryText: {},
              AttributeFilter: {
                shape: "Saw"
              },
              Facets: {
                shape: "Sdq"
              },
              RequestedDocumentAttributes: {
                shape: "Sav"
              },
              QueryResultTypeFilter: {},
              DocumentRelevanceOverrideConfigurations: {
                shape: "Sdu"
              },
              PageNumber: {
                type: "integer"
              },
              PageSize: {
                type: "integer"
              },
              SortingConfiguration: {
                shape: "Sdw"
              },
              SortingConfigurations: {
                shape: "Sdy"
              },
              UserContext: {
                shape: "Say"
              },
              VisitorId: {},
              SpellCorrectionConfiguration: {
                type: "structure",
                required: [
                  "IncludeQuerySpellCheckSuggestions"
                ],
                members: {
                  IncludeQuerySpellCheckSuggestions: {
                    type: "boolean"
                  }
                }
              },
              CollapseConfiguration: {
                type: "structure",
                required: [
                  "DocumentAttributeKey"
                ],
                members: {
                  DocumentAttributeKey: {},
                  SortingConfigurations: {
                    shape: "Sdy"
                  },
                  MissingAttributeKeyStrategy: {},
                  Expand: {
                    type: "boolean"
                  },
                  ExpandConfiguration: {
                    type: "structure",
                    members: {
                      MaxResultItemsToExpand: {
                        type: "integer"
                      },
                      MaxExpandedResultsPerItem: {
                        type: "integer"
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              QueryId: {},
              ResultItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Type: {},
                    Format: {},
                    AdditionalAttributes: {
                      shape: "Se9"
                    },
                    DocumentId: {},
                    DocumentTitle: {
                      shape: "Sed"
                    },
                    DocumentExcerpt: {
                      shape: "Sed"
                    },
                    DocumentURI: {},
                    DocumentAttributes: {
                      shape: "S11"
                    },
                    ScoreAttributes: {
                      shape: "Seh"
                    },
                    FeedbackToken: {},
                    TableExcerpt: {
                      type: "structure",
                      members: {
                        Rows: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              Cells: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    Value: {},
                                    TopAnswer: {
                                      type: "boolean"
                                    },
                                    Highlighted: {
                                      type: "boolean"
                                    },
                                    Header: {
                                      type: "boolean"
                                    }
                                  }
                                }
                              }
                            }
                          }
                        },
                        TotalNumberOfRows: {
                          type: "integer"
                        }
                      }
                    },
                    CollapsedResultDetail: {
                      type: "structure",
                      required: [
                        "DocumentAttribute"
                      ],
                      members: {
                        DocumentAttribute: {
                          shape: "S12"
                        },
                        ExpandedResults: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              Id: {},
                              DocumentId: {},
                              DocumentTitle: {
                                shape: "Sed"
                              },
                              DocumentExcerpt: {
                                shape: "Sed"
                              },
                              DocumentURI: {},
                              DocumentAttributes: {
                                shape: "S11"
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              FacetResults: {
                shape: "Ses"
              },
              TotalNumberOfResults: {
                type: "integer"
              },
              Warnings: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Message: {},
                    Code: {}
                  }
                }
              },
              SpellCorrectedQueries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SuggestedQueryText: {},
                    Corrections: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          BeginOffset: {
                            type: "integer"
                          },
                          EndOffset: {
                            type: "integer"
                          },
                          Term: {},
                          CorrectedTerm: {}
                        }
                      }
                    }
                  }
                }
              },
              FeaturedResultsItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Type: {},
                    AdditionalAttributes: {
                      shape: "Se9"
                    },
                    DocumentId: {},
                    DocumentTitle: {
                      shape: "Sed"
                    },
                    DocumentExcerpt: {
                      shape: "Sed"
                    },
                    DocumentURI: {},
                    DocumentAttributes: {
                      shape: "S11"
                    },
                    FeedbackToken: {}
                  }
                }
              }
            }
          }
        },
        Retrieve: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "QueryText"
            ],
            members: {
              IndexId: {},
              QueryText: {},
              AttributeFilter: {
                shape: "Saw"
              },
              RequestedDocumentAttributes: {
                shape: "Sav"
              },
              DocumentRelevanceOverrideConfigurations: {
                shape: "Sdu"
              },
              PageNumber: {
                type: "integer"
              },
              PageSize: {
                type: "integer"
              },
              UserContext: {
                shape: "Say"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              QueryId: {},
              ResultItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    DocumentId: {},
                    DocumentTitle: {},
                    Content: {},
                    DocumentURI: {},
                    DocumentAttributes: {
                      shape: "S11"
                    },
                    ScoreAttributes: {
                      shape: "Seh"
                    }
                  }
                }
              }
            }
          }
        },
        StartDataSourceSyncJob: {
          input: {
            type: "structure",
            required: [
              "Id",
              "IndexId"
            ],
            members: {
              Id: {},
              IndexId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ExecutionId: {}
            }
          }
        },
        StopDataSourceSyncJob: {
          input: {
            type: "structure",
            required: [
              "Id",
              "IndexId"
            ],
            members: {
              Id: {},
              IndexId: {}
            }
          }
        },
        SubmitFeedback: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "QueryId"
            ],
            members: {
              IndexId: {},
              QueryId: {},
              ClickFeedbackItems: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ResultId",
                    "ClickTime"
                  ],
                  members: {
                    ResultId: {},
                    ClickTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              RelevanceFeedbackItems: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ResultId",
                    "RelevanceValue"
                  ],
                  members: {
                    ResultId: {},
                    RelevanceValue: {}
                  }
                }
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S6r"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAccessControlConfiguration: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "Id"
            ],
            members: {
              IndexId: {},
              Id: {},
              Name: {},
              Description: {},
              AccessControlList: {
                shape: "S1p"
              },
              HierarchicalAccessControlList: {
                shape: "S1u"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDataSource: {
          input: {
            type: "structure",
            required: [
              "Id",
              "IndexId"
            ],
            members: {
              Id: {},
              Name: {},
              IndexId: {},
              Configuration: {
                shape: "S2j"
              },
              VpcConfiguration: {
                shape: "S2u"
              },
              Description: {},
              Schedule: {},
              RoleArn: {},
              LanguageCode: {},
              CustomDocumentEnrichmentConfiguration: {
                shape: "S1y"
              }
            }
          }
        },
        UpdateExperience: {
          input: {
            type: "structure",
            required: [
              "Id",
              "IndexId"
            ],
            members: {
              Id: {},
              Name: {},
              IndexId: {},
              RoleArn: {},
              Configuration: {
                shape: "S6z"
              },
              Description: {}
            }
          }
        },
        UpdateFeaturedResultsSet: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "FeaturedResultsSetId"
            ],
            members: {
              IndexId: {},
              FeaturedResultsSetId: {},
              FeaturedResultsSetName: {},
              Description: {},
              Status: {},
              QueryTexts: {
                shape: "S7f"
              },
              FeaturedDocuments: {
                shape: "S7h"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FeaturedResultsSet: {
                shape: "S7k"
              }
            }
          }
        },
        UpdateIndex: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {},
              Name: {},
              RoleArn: {},
              Description: {},
              DocumentMetadataConfigurationUpdates: {
                shape: "S9b"
              },
              CapacityUnits: {
                shape: "S9t"
              },
              UserTokenConfigurations: {
                shape: "S7q"
              },
              UserContextPolicy: {},
              UserGroupResolutionConfiguration: {
                shape: "S80"
              }
            }
          }
        },
        UpdateQuerySuggestionsBlockList: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "Id"
            ],
            members: {
              IndexId: {},
              Id: {},
              Name: {},
              Description: {},
              SourceS3Path: {
                shape: "S1m"
              },
              RoleArn: {}
            }
          }
        },
        UpdateQuerySuggestionsConfig: {
          input: {
            type: "structure",
            required: [
              "IndexId"
            ],
            members: {
              IndexId: {},
              Mode: {},
              QueryLogLookBackWindowInDays: {
                type: "integer"
              },
              IncludeQueriesWithoutUserInformation: {
                type: "boolean"
              },
              MinimumNumberOfQueryingUsers: {
                type: "integer"
              },
              MinimumQueryCount: {
                type: "integer"
              },
              AttributeSuggestionsConfig: {
                type: "structure",
                members: {
                  SuggestableConfigList: {
                    shape: "Sae"
                  },
                  AttributeSuggestionsMode: {}
                }
              }
            }
          }
        },
        UpdateThesaurus: {
          input: {
            type: "structure",
            required: [
              "Id",
              "IndexId"
            ],
            members: {
              Id: {},
              Name: {},
              IndexId: {},
              Description: {},
              RoleArn: {},
              SourceS3Path: {
                shape: "S1m"
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          required: [
            "EntityId",
            "EntityType"
          ],
          members: {
            EntityId: {},
            EntityType: {}
          }
        },
        Sa: {
          type: "structure",
          members: {
            EntityId: {},
            ErrorMessage: {}
          }
        },
        Sh: {
          type: "list",
          member: {
            shape: "Sa"
          }
        },
        S11: {
          type: "list",
          member: {
            shape: "S12"
          }
        },
        S12: {
          type: "structure",
          required: [
            "Key",
            "Value"
          ],
          members: {
            Key: {},
            Value: {
              shape: "S14"
            }
          }
        },
        S14: {
          type: "structure",
          members: {
            StringValue: {},
            StringListValue: {
              type: "list",
              member: {}
            },
            LongValue: {
              type: "long"
            },
            DateValue: {
              type: "timestamp"
            }
          }
        },
        S1m: {
          type: "structure",
          required: [
            "Bucket",
            "Key"
          ],
          members: {
            Bucket: {},
            Key: {}
          }
        },
        S1p: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Type",
              "Access"
            ],
            members: {
              Name: {},
              Type: {},
              Access: {},
              DataSourceId: {}
            }
          }
        },
        S1u: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "PrincipalList"
            ],
            members: {
              PrincipalList: {
                shape: "S1p"
              }
            }
          }
        },
        S1y: {
          type: "structure",
          members: {
            InlineConfigurations: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Condition: {
                    shape: "S21"
                  },
                  Target: {
                    type: "structure",
                    members: {
                      TargetDocumentAttributeKey: {},
                      TargetDocumentAttributeValueDeletion: {
                        type: "boolean"
                      },
                      TargetDocumentAttributeValue: {
                        shape: "S14"
                      }
                    }
                  },
                  DocumentContentDeletion: {
                    type: "boolean"
                  }
                }
              }
            },
            PreExtractionHookConfiguration: {
              shape: "S25"
            },
            PostExtractionHookConfiguration: {
              shape: "S25"
            },
            RoleArn: {}
          }
        },
        S21: {
          type: "structure",
          required: [
            "ConditionDocumentAttributeKey",
            "Operator"
          ],
          members: {
            ConditionDocumentAttributeKey: {},
            Operator: {},
            ConditionOnValue: {
              shape: "S14"
            }
          }
        },
        S25: {
          type: "structure",
          required: [
            "LambdaArn",
            "S3Bucket"
          ],
          members: {
            InvocationCondition: {
              shape: "S21"
            },
            LambdaArn: {},
            S3Bucket: {}
          }
        },
        S2j: {
          type: "structure",
          members: {
            S3Configuration: {
              type: "structure",
              required: [
                "BucketName"
              ],
              members: {
                BucketName: {},
                InclusionPrefixes: {
                  shape: "S2l"
                },
                InclusionPatterns: {
                  shape: "S2l"
                },
                ExclusionPatterns: {
                  shape: "S2l"
                },
                DocumentsMetadataConfiguration: {
                  type: "structure",
                  members: {
                    S3Prefix: {}
                  }
                },
                AccessControlListConfiguration: {
                  type: "structure",
                  members: {
                    KeyPath: {}
                  }
                }
              }
            },
            SharePointConfiguration: {
              type: "structure",
              required: [
                "SharePointVersion",
                "Urls",
                "SecretArn"
              ],
              members: {
                SharePointVersion: {},
                Urls: {
                  type: "list",
                  member: {}
                },
                SecretArn: {},
                CrawlAttachments: {
                  type: "boolean"
                },
                UseChangeLog: {
                  type: "boolean"
                },
                InclusionPatterns: {
                  shape: "S2l"
                },
                ExclusionPatterns: {
                  shape: "S2l"
                },
                VpcConfiguration: {
                  shape: "S2u"
                },
                FieldMappings: {
                  shape: "S2z"
                },
                DocumentTitleFieldName: {},
                DisableLocalGroups: {
                  type: "boolean"
                },
                SslCertificateS3Path: {
                  shape: "S1m"
                },
                AuthenticationType: {},
                ProxyConfiguration: {
                  shape: "S35"
                }
              }
            },
            DatabaseConfiguration: {
              type: "structure",
              required: [
                "DatabaseEngineType",
                "ConnectionConfiguration",
                "ColumnConfiguration"
              ],
              members: {
                DatabaseEngineType: {},
                ConnectionConfiguration: {
                  type: "structure",
                  required: [
                    "DatabaseHost",
                    "DatabasePort",
                    "DatabaseName",
                    "TableName",
                    "SecretArn"
                  ],
                  members: {
                    DatabaseHost: {},
                    DatabasePort: {
                      type: "integer"
                    },
                    DatabaseName: {},
                    TableName: {},
                    SecretArn: {}
                  }
                },
                VpcConfiguration: {
                  shape: "S2u"
                },
                ColumnConfiguration: {
                  type: "structure",
                  required: [
                    "DocumentIdColumnName",
                    "DocumentDataColumnName",
                    "ChangeDetectingColumns"
                  ],
                  members: {
                    DocumentIdColumnName: {},
                    DocumentDataColumnName: {},
                    DocumentTitleColumnName: {},
                    FieldMappings: {
                      shape: "S2z"
                    },
                    ChangeDetectingColumns: {
                      type: "list",
                      member: {}
                    }
                  }
                },
                AclConfiguration: {
                  type: "structure",
                  required: [
                    "AllowedGroupsColumnName"
                  ],
                  members: {
                    AllowedGroupsColumnName: {}
                  }
                },
                SqlConfiguration: {
                  type: "structure",
                  members: {
                    QueryIdentifiersEnclosingOption: {}
                  }
                }
              }
            },
            SalesforceConfiguration: {
              type: "structure",
              required: [
                "ServerUrl",
                "SecretArn"
              ],
              members: {
                ServerUrl: {},
                SecretArn: {},
                StandardObjectConfigurations: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "Name",
                      "DocumentDataFieldName"
                    ],
                    members: {
                      Name: {},
                      DocumentDataFieldName: {},
                      DocumentTitleFieldName: {},
                      FieldMappings: {
                        shape: "S2z"
                      }
                    }
                  }
                },
                KnowledgeArticleConfiguration: {
                  type: "structure",
                  required: [
                    "IncludedStates"
                  ],
                  members: {
                    IncludedStates: {
                      type: "list",
                      member: {}
                    },
                    StandardKnowledgeArticleTypeConfiguration: {
                      type: "structure",
                      required: [
                        "DocumentDataFieldName"
                      ],
                      members: {
                        DocumentDataFieldName: {},
                        DocumentTitleFieldName: {},
                        FieldMappings: {
                          shape: "S2z"
                        }
                      }
                    },
                    CustomKnowledgeArticleTypeConfigurations: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "Name",
                          "DocumentDataFieldName"
                        ],
                        members: {
                          Name: {},
                          DocumentDataFieldName: {},
                          DocumentTitleFieldName: {},
                          FieldMappings: {
                            shape: "S2z"
                          }
                        }
                      }
                    }
                  }
                },
                ChatterFeedConfiguration: {
                  type: "structure",
                  required: [
                    "DocumentDataFieldName"
                  ],
                  members: {
                    DocumentDataFieldName: {},
                    DocumentTitleFieldName: {},
                    FieldMappings: {
                      shape: "S2z"
                    },
                    IncludeFilterTypes: {
                      type: "list",
                      member: {}
                    }
                  }
                },
                CrawlAttachments: {
                  type: "boolean"
                },
                StandardObjectAttachmentConfiguration: {
                  type: "structure",
                  members: {
                    DocumentTitleFieldName: {},
                    FieldMappings: {
                      shape: "S2z"
                    }
                  }
                },
                IncludeAttachmentFilePatterns: {
                  shape: "S2l"
                },
                ExcludeAttachmentFilePatterns: {
                  shape: "S2l"
                }
              }
            },
            OneDriveConfiguration: {
              type: "structure",
              required: [
                "TenantDomain",
                "SecretArn",
                "OneDriveUsers"
              ],
              members: {
                TenantDomain: {},
                SecretArn: {},
                OneDriveUsers: {
                  type: "structure",
                  members: {
                    OneDriveUserList: {
                      type: "list",
                      member: {}
                    },
                    OneDriveUserS3Path: {
                      shape: "S1m"
                    }
                  }
                },
                InclusionPatterns: {
                  shape: "S2l"
                },
                ExclusionPatterns: {
                  shape: "S2l"
                },
                FieldMappings: {
                  shape: "S2z"
                },
                DisableLocalGroups: {
                  type: "boolean"
                }
              }
            },
            ServiceNowConfiguration: {
              type: "structure",
              required: [
                "HostUrl",
                "SecretArn",
                "ServiceNowBuildVersion"
              ],
              members: {
                HostUrl: {},
                SecretArn: {},
                ServiceNowBuildVersion: {},
                KnowledgeArticleConfiguration: {
                  type: "structure",
                  required: [
                    "DocumentDataFieldName"
                  ],
                  members: {
                    CrawlAttachments: {
                      type: "boolean"
                    },
                    IncludeAttachmentFilePatterns: {
                      shape: "S2l"
                    },
                    ExcludeAttachmentFilePatterns: {
                      shape: "S2l"
                    },
                    DocumentDataFieldName: {},
                    DocumentTitleFieldName: {},
                    FieldMappings: {
                      shape: "S2z"
                    },
                    FilterQuery: {}
                  }
                },
                ServiceCatalogConfiguration: {
                  type: "structure",
                  required: [
                    "DocumentDataFieldName"
                  ],
                  members: {
                    CrawlAttachments: {
                      type: "boolean"
                    },
                    IncludeAttachmentFilePatterns: {
                      shape: "S2l"
                    },
                    ExcludeAttachmentFilePatterns: {
                      shape: "S2l"
                    },
                    DocumentDataFieldName: {},
                    DocumentTitleFieldName: {},
                    FieldMappings: {
                      shape: "S2z"
                    }
                  }
                },
                AuthenticationType: {}
              }
            },
            ConfluenceConfiguration: {
              type: "structure",
              required: [
                "ServerUrl",
                "SecretArn",
                "Version"
              ],
              members: {
                ServerUrl: {},
                SecretArn: {},
                Version: {},
                SpaceConfiguration: {
                  type: "structure",
                  members: {
                    CrawlPersonalSpaces: {
                      type: "boolean"
                    },
                    CrawlArchivedSpaces: {
                      type: "boolean"
                    },
                    IncludeSpaces: {
                      shape: "S4f"
                    },
                    ExcludeSpaces: {
                      shape: "S4f"
                    },
                    SpaceFieldMappings: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          DataSourceFieldName: {},
                          DateFieldFormat: {},
                          IndexFieldName: {}
                        }
                      }
                    }
                  }
                },
                PageConfiguration: {
                  type: "structure",
                  members: {
                    PageFieldMappings: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          DataSourceFieldName: {},
                          DateFieldFormat: {},
                          IndexFieldName: {}
                        }
                      }
                    }
                  }
                },
                BlogConfiguration: {
                  type: "structure",
                  members: {
                    BlogFieldMappings: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          DataSourceFieldName: {},
                          DateFieldFormat: {},
                          IndexFieldName: {}
                        }
                      }
                    }
                  }
                },
                AttachmentConfiguration: {
                  type: "structure",
                  members: {
                    CrawlAttachments: {
                      type: "boolean"
                    },
                    AttachmentFieldMappings: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          DataSourceFieldName: {},
                          DateFieldFormat: {},
                          IndexFieldName: {}
                        }
                      }
                    }
                  }
                },
                VpcConfiguration: {
                  shape: "S2u"
                },
                InclusionPatterns: {
                  shape: "S2l"
                },
                ExclusionPatterns: {
                  shape: "S2l"
                },
                ProxyConfiguration: {
                  shape: "S35"
                },
                AuthenticationType: {}
              }
            },
            GoogleDriveConfiguration: {
              type: "structure",
              required: [
                "SecretArn"
              ],
              members: {
                SecretArn: {},
                InclusionPatterns: {
                  shape: "S2l"
                },
                ExclusionPatterns: {
                  shape: "S2l"
                },
                FieldMappings: {
                  shape: "S2z"
                },
                ExcludeMimeTypes: {
                  type: "list",
                  member: {}
                },
                ExcludeUserAccounts: {
                  type: "list",
                  member: {}
                },
                ExcludeSharedDrives: {
                  type: "list",
                  member: {}
                }
              }
            },
            WebCrawlerConfiguration: {
              type: "structure",
              required: [
                "Urls"
              ],
              members: {
                Urls: {
                  type: "structure",
                  members: {
                    SeedUrlConfiguration: {
                      type: "structure",
                      required: [
                        "SeedUrls"
                      ],
                      members: {
                        SeedUrls: {
                          type: "list",
                          member: {}
                        },
                        WebCrawlerMode: {}
                      }
                    },
                    SiteMapsConfiguration: {
                      type: "structure",
                      required: [
                        "SiteMaps"
                      ],
                      members: {
                        SiteMaps: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  }
                },
                CrawlDepth: {
                  type: "integer"
                },
                MaxLinksPerPage: {
                  type: "integer"
                },
                MaxContentSizePerPageInMegaBytes: {
                  type: "float"
                },
                MaxUrlsPerMinuteCrawlRate: {
                  type: "integer"
                },
                UrlInclusionPatterns: {
                  shape: "S2l"
                },
                UrlExclusionPatterns: {
                  shape: "S2l"
                },
                ProxyConfiguration: {
                  shape: "S35"
                },
                AuthenticationConfiguration: {
                  type: "structure",
                  members: {
                    BasicAuthentication: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "Host",
                          "Port",
                          "Credentials"
                        ],
                        members: {
                          Host: {},
                          Port: {
                            type: "integer"
                          },
                          Credentials: {}
                        }
                      }
                    }
                  }
                }
              }
            },
            WorkDocsConfiguration: {
              type: "structure",
              required: [
                "OrganizationId"
              ],
              members: {
                OrganizationId: {},
                CrawlComments: {
                  type: "boolean"
                },
                UseChangeLog: {
                  type: "boolean"
                },
                InclusionPatterns: {
                  shape: "S2l"
                },
                ExclusionPatterns: {
                  shape: "S2l"
                },
                FieldMappings: {
                  shape: "S2z"
                }
              }
            },
            FsxConfiguration: {
              type: "structure",
              required: [
                "FileSystemId",
                "FileSystemType",
                "VpcConfiguration"
              ],
              members: {
                FileSystemId: {},
                FileSystemType: {},
                VpcConfiguration: {
                  shape: "S2u"
                },
                SecretArn: {},
                InclusionPatterns: {
                  shape: "S2l"
                },
                ExclusionPatterns: {
                  shape: "S2l"
                },
                FieldMappings: {
                  shape: "S2z"
                }
              }
            },
            SlackConfiguration: {
              type: "structure",
              required: [
                "TeamId",
                "SecretArn",
                "SlackEntityList",
                "SinceCrawlDate"
              ],
              members: {
                TeamId: {},
                SecretArn: {},
                VpcConfiguration: {
                  shape: "S2u"
                },
                SlackEntityList: {
                  type: "list",
                  member: {}
                },
                UseChangeLog: {
                  type: "boolean"
                },
                CrawlBotMessage: {
                  type: "boolean"
                },
                ExcludeArchived: {
                  type: "boolean"
                },
                SinceCrawlDate: {},
                LookBackPeriod: {
                  type: "integer"
                },
                PrivateChannelFilter: {
                  type: "list",
                  member: {}
                },
                PublicChannelFilter: {
                  type: "list",
                  member: {}
                },
                InclusionPatterns: {
                  shape: "S2l"
                },
                ExclusionPatterns: {
                  shape: "S2l"
                },
                FieldMappings: {
                  shape: "S2z"
                }
              }
            },
            BoxConfiguration: {
              type: "structure",
              required: [
                "EnterpriseId",
                "SecretArn"
              ],
              members: {
                EnterpriseId: {},
                SecretArn: {},
                UseChangeLog: {
                  type: "boolean"
                },
                CrawlComments: {
                  type: "boolean"
                },
                CrawlTasks: {
                  type: "boolean"
                },
                CrawlWebLinks: {
                  type: "boolean"
                },
                FileFieldMappings: {
                  shape: "S2z"
                },
                TaskFieldMappings: {
                  shape: "S2z"
                },
                CommentFieldMappings: {
                  shape: "S2z"
                },
                WebLinkFieldMappings: {
                  shape: "S2z"
                },
                InclusionPatterns: {
                  shape: "S2l"
                },
                ExclusionPatterns: {
                  shape: "S2l"
                },
                VpcConfiguration: {
                  shape: "S2u"
                }
              }
            },
            QuipConfiguration: {
              type: "structure",
              required: [
                "Domain",
                "SecretArn"
              ],
              members: {
                Domain: {},
                SecretArn: {},
                CrawlFileComments: {
                  type: "boolean"
                },
                CrawlChatRooms: {
                  type: "boolean"
                },
                CrawlAttachments: {
                  type: "boolean"
                },
                FolderIds: {
                  type: "list",
                  member: {}
                },
                ThreadFieldMappings: {
                  shape: "S2z"
                },
                MessageFieldMappings: {
                  shape: "S2z"
                },
                AttachmentFieldMappings: {
                  shape: "S2z"
                },
                InclusionPatterns: {
                  shape: "S2l"
                },
                ExclusionPatterns: {
                  shape: "S2l"
                },
                VpcConfiguration: {
                  shape: "S2u"
                }
              }
            },
            JiraConfiguration: {
              type: "structure",
              required: [
                "JiraAccountUrl",
                "SecretArn"
              ],
              members: {
                JiraAccountUrl: {},
                SecretArn: {},
                UseChangeLog: {
                  type: "boolean"
                },
                Project: {
                  type: "list",
                  member: {}
                },
                IssueType: {
                  type: "list",
                  member: {}
                },
                Status: {
                  type: "list",
                  member: {}
                },
                IssueSubEntityFilter: {
                  type: "list",
                  member: {}
                },
                AttachmentFieldMappings: {
                  shape: "S2z"
                },
                CommentFieldMappings: {
                  shape: "S2z"
                },
                IssueFieldMappings: {
                  shape: "S2z"
                },
                ProjectFieldMappings: {
                  shape: "S2z"
                },
                WorkLogFieldMappings: {
                  shape: "S2z"
                },
                InclusionPatterns: {
                  shape: "S2l"
                },
                ExclusionPatterns: {
                  shape: "S2l"
                },
                VpcConfiguration: {
                  shape: "S2u"
                }
              }
            },
            GitHubConfiguration: {
              type: "structure",
              required: [
                "SecretArn"
              ],
              members: {
                SaaSConfiguration: {
                  type: "structure",
                  required: [
                    "OrganizationName",
                    "HostUrl"
                  ],
                  members: {
                    OrganizationName: {},
                    HostUrl: {}
                  }
                },
                OnPremiseConfiguration: {
                  type: "structure",
                  required: [
                    "HostUrl",
                    "OrganizationName",
                    "SslCertificateS3Path"
                  ],
                  members: {
                    HostUrl: {},
                    OrganizationName: {},
                    SslCertificateS3Path: {
                      shape: "S1m"
                    }
                  }
                },
                Type: {},
                SecretArn: {},
                UseChangeLog: {
                  type: "boolean"
                },
                GitHubDocumentCrawlProperties: {
                  type: "structure",
                  members: {
                    CrawlRepositoryDocuments: {
                      type: "boolean"
                    },
                    CrawlIssue: {
                      type: "boolean"
                    },
                    CrawlIssueComment: {
                      type: "boolean"
                    },
                    CrawlIssueCommentAttachment: {
                      type: "boolean"
                    },
                    CrawlPullRequest: {
                      type: "boolean"
                    },
                    CrawlPullRequestComment: {
                      type: "boolean"
                    },
                    CrawlPullRequestCommentAttachment: {
                      type: "boolean"
                    }
                  }
                },
                RepositoryFilter: {
                  type: "list",
                  member: {}
                },
                InclusionFolderNamePatterns: {
                  shape: "S6i"
                },
                InclusionFileTypePatterns: {
                  shape: "S6i"
                },
                InclusionFileNamePatterns: {
                  shape: "S6i"
                },
                ExclusionFolderNamePatterns: {
                  shape: "S6i"
                },
                ExclusionFileTypePatterns: {
                  shape: "S6i"
                },
                ExclusionFileNamePatterns: {
                  shape: "S6i"
                },
                VpcConfiguration: {
                  shape: "S2u"
                },
                GitHubRepositoryConfigurationFieldMappings: {
                  shape: "S2z"
                },
                GitHubCommitConfigurationFieldMappings: {
                  shape: "S2z"
                },
                GitHubIssueDocumentConfigurationFieldMappings: {
                  shape: "S2z"
                },
                GitHubIssueCommentConfigurationFieldMappings: {
                  shape: "S2z"
                },
                GitHubIssueAttachmentConfigurationFieldMappings: {
                  shape: "S2z"
                },
                GitHubPullRequestCommentConfigurationFieldMappings: {
                  shape: "S2z"
                },
                GitHubPullRequestDocumentConfigurationFieldMappings: {
                  shape: "S2z"
                },
                GitHubPullRequestDocumentAttachmentConfigurationFieldMappings: {
                  shape: "S2z"
                }
              }
            },
            AlfrescoConfiguration: {
              deprecated: true,
              deprecatedMessage: "Deprecated AlfrescoConfiguration in favor of TemplateConfiguration",
              type: "structure",
              required: [
                "SiteUrl",
                "SiteId",
                "SecretArn",
                "SslCertificateS3Path"
              ],
              members: {
                SiteUrl: {},
                SiteId: {},
                SecretArn: {},
                SslCertificateS3Path: {
                  shape: "S1m"
                },
                CrawlSystemFolders: {
                  type: "boolean"
                },
                CrawlComments: {
                  type: "boolean"
                },
                EntityFilter: {
                  type: "list",
                  member: {}
                },
                DocumentLibraryFieldMappings: {
                  shape: "S2z"
                },
                BlogFieldMappings: {
                  shape: "S2z"
                },
                WikiFieldMappings: {
                  shape: "S2z"
                },
                InclusionPatterns: {
                  shape: "S2l"
                },
                ExclusionPatterns: {
                  shape: "S2l"
                },
                VpcConfiguration: {
                  shape: "S2u"
                }
              }
            },
            TemplateConfiguration: {
              type: "structure",
              members: {
                Template: {
                  type: "structure",
                  members: {},
                  document: true
                }
              }
            }
          }
        },
        S2l: {
          type: "list",
          member: {}
        },
        S2u: {
          type: "structure",
          required: [
            "SubnetIds",
            "SecurityGroupIds"
          ],
          members: {
            SubnetIds: {
              type: "list",
              member: {}
            },
            SecurityGroupIds: {
              type: "list",
              member: {}
            }
          }
        },
        S2z: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "DataSourceFieldName",
              "IndexFieldName"
            ],
            members: {
              DataSourceFieldName: {},
              DateFieldFormat: {},
              IndexFieldName: {}
            }
          }
        },
        S35: {
          type: "structure",
          required: [
            "Host",
            "Port"
          ],
          members: {
            Host: {},
            Port: {
              type: "integer"
            },
            Credentials: {}
          }
        },
        S4f: {
          type: "list",
          member: {}
        },
        S6i: {
          type: "list",
          member: {}
        },
        S6r: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S6z: {
          type: "structure",
          members: {
            ContentSourceConfiguration: {
              type: "structure",
              members: {
                DataSourceIds: {
                  type: "list",
                  member: {}
                },
                FaqIds: {
                  type: "list",
                  member: {}
                },
                DirectPutContent: {
                  type: "boolean"
                }
              }
            },
            UserIdentityConfiguration: {
              type: "structure",
              members: {
                IdentityAttributeName: {}
              }
            }
          }
        },
        S7f: {
          type: "list",
          member: {}
        },
        S7h: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Id: {}
            }
          }
        },
        S7k: {
          type: "structure",
          members: {
            FeaturedResultsSetId: {},
            FeaturedResultsSetName: {},
            Description: {},
            Status: {},
            QueryTexts: {
              shape: "S7f"
            },
            FeaturedDocuments: {
              shape: "S7h"
            },
            LastUpdatedTimestamp: {
              type: "long"
            },
            CreationTimestamp: {
              type: "long"
            }
          }
        },
        S7o: {
          type: "structure",
          members: {
            KmsKeyId: {
              type: "string",
              sensitive: true
            }
          }
        },
        S7q: {
          type: "list",
          member: {
            type: "structure",
            members: {
              JwtTokenTypeConfiguration: {
                type: "structure",
                required: [
                  "KeyLocation"
                ],
                members: {
                  KeyLocation: {},
                  URL: {},
                  SecretManagerArn: {},
                  UserNameAttributeField: {},
                  GroupAttributeField: {},
                  Issuer: {},
                  ClaimRegex: {}
                }
              },
              JsonTokenTypeConfiguration: {
                type: "structure",
                required: [
                  "UserNameAttributeField",
                  "GroupAttributeField"
                ],
                members: {
                  UserNameAttributeField: {},
                  GroupAttributeField: {}
                }
              }
            }
          }
        },
        S80: {
          type: "structure",
          required: [
            "UserGroupResolutionMode"
          ],
          members: {
            UserGroupResolutionMode: {}
          }
        },
        S8u: {
          type: "list",
          member: {
            type: "structure",
            members: {
              EndpointType: {},
              Endpoint: {}
            }
          }
        },
        S9b: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Type"
            ],
            members: {
              Name: {},
              Type: {},
              Relevance: {
                shape: "S9f"
              },
              Search: {
                type: "structure",
                members: {
                  Facetable: {
                    type: "boolean"
                  },
                  Searchable: {
                    type: "boolean"
                  },
                  Displayable: {
                    type: "boolean"
                  },
                  Sortable: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        S9f: {
          type: "structure",
          members: {
            Freshness: {
              type: "boolean"
            },
            Importance: {
              type: "integer"
            },
            Duration: {},
            RankOrder: {},
            ValueImportanceMap: {
              type: "map",
              key: {},
              value: {
                type: "integer"
              }
            }
          }
        },
        S9t: {
          type: "structure",
          required: [
            "StorageCapacityUnits",
            "QueryCapacityUnits"
          ],
          members: {
            StorageCapacityUnits: {
              type: "integer"
            },
            QueryCapacityUnits: {
              type: "integer"
            }
          }
        },
        Sae: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AttributeName: {},
              Suggestable: {
                type: "boolean"
              }
            }
          }
        },
        Sav: {
          type: "list",
          member: {}
        },
        Saw: {
          type: "structure",
          members: {
            AndAllFilters: {
              shape: "Sax"
            },
            OrAllFilters: {
              shape: "Sax"
            },
            NotFilter: {
              shape: "Saw"
            },
            EqualsTo: {
              shape: "S12"
            },
            ContainsAll: {
              shape: "S12"
            },
            ContainsAny: {
              shape: "S12"
            },
            GreaterThan: {
              shape: "S12"
            },
            GreaterThanOrEquals: {
              shape: "S12"
            },
            LessThan: {
              shape: "S12"
            },
            LessThanOrEquals: {
              shape: "S12"
            }
          }
        },
        Sax: {
          type: "list",
          member: {
            shape: "Saw"
          }
        },
        Say: {
          type: "structure",
          members: {
            Token: {},
            UserId: {},
            Groups: {
              type: "list",
              member: {}
            },
            DataSourceGroups: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "GroupId",
                  "DataSourceId"
                ],
                members: {
                  GroupId: {},
                  DataSourceId: {}
                }
              }
            }
          }
        },
        Sbj: {
          type: "structure",
          members: {
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            }
          }
        },
        Scf: {
          type: "string",
          sensitive: true
        },
        Sdq: {
          type: "list",
          member: {
            type: "structure",
            members: {
              DocumentAttributeKey: {},
              Facets: {
                shape: "Sdq"
              },
              MaxResults: {
                type: "integer"
              }
            }
          }
        },
        Sdu: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Relevance"
            ],
            members: {
              Name: {},
              Relevance: {
                shape: "S9f"
              }
            }
          }
        },
        Sdw: {
          type: "structure",
          required: [
            "DocumentAttributeKey",
            "SortOrder"
          ],
          members: {
            DocumentAttributeKey: {},
            SortOrder: {}
          }
        },
        Sdy: {
          type: "list",
          member: {
            shape: "Sdw"
          }
        },
        Se9: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "ValueType",
              "Value"
            ],
            members: {
              Key: {},
              ValueType: {},
              Value: {
                type: "structure",
                members: {
                  TextWithHighlightsValue: {
                    shape: "Sed"
                  }
                }
              }
            }
          }
        },
        Sed: {
          type: "structure",
          members: {
            Text: {},
            Highlights: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "BeginOffset",
                  "EndOffset"
                ],
                members: {
                  BeginOffset: {
                    type: "integer"
                  },
                  EndOffset: {
                    type: "integer"
                  },
                  TopAnswer: {
                    type: "boolean"
                  },
                  Type: {}
                }
              }
            }
          }
        },
        Seh: {
          type: "structure",
          members: {
            ScoreConfidence: {}
          }
        },
        Ses: {
          type: "list",
          member: {
            type: "structure",
            members: {
              DocumentAttributeKey: {},
              DocumentAttributeValueType: {},
              DocumentAttributeValueCountPairs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DocumentAttributeValue: {
                      shape: "S14"
                    },
                    Count: {
                      type: "integer"
                    },
                    FacetResults: {
                      shape: "Ses"
                    }
                  }
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/kendra-2019-02-03.paginators.json
var require_kendra_2019_02_03_paginators = __commonJS({
  "node_modules/aws-sdk/apis/kendra-2019-02-03.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetSnapshots: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAccessControlConfigurations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDataSourceSyncJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDataSources: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListEntityPersonas: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListExperienceEntities: {
          input_token: "NextToken",
          output_token: "NextToken"
        },
        ListExperiences: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListFaqs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListGroupsOlderThanOrderingId: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListIndices: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListQuerySuggestionsBlockLists: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListThesauri: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/kendra.js
var require_kendra = __commonJS({
  "node_modules/aws-sdk/clients/kendra.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["kendra"] = {};
    AWS2.Kendra = Service.defineService("kendra", ["2019-02-03"]);
    Object.defineProperty(apiLoader.services["kendra"], "2019-02-03", {
      get: function get() {
        var model = require_kendra_2019_02_03_min();
        model.paginators = require_kendra_2019_02_03_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Kendra;
  }
});

// node_modules/aws-sdk/apis/networkmanager-2019-07-05.min.json
var require_networkmanager_2019_07_05_min = __commonJS({
  "node_modules/aws-sdk/apis/networkmanager-2019-07-05.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-07-05",
        endpointPrefix: "networkmanager",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "NetworkManager",
        serviceFullName: "AWS Network Manager",
        serviceId: "NetworkManager",
        signatureVersion: "v4",
        signingName: "networkmanager",
        uid: "networkmanager-2019-07-05"
      },
      operations: {
        AcceptAttachment: {
          http: {
            requestUri: "/attachments/{attachmentId}/accept"
          },
          input: {
            type: "structure",
            required: [
              "AttachmentId"
            ],
            members: {
              AttachmentId: {
                location: "uri",
                locationName: "attachmentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attachment: {
                shape: "S4"
              }
            }
          }
        },
        AssociateConnectPeer: {
          http: {
            requestUri: "/global-networks/{globalNetworkId}/connect-peer-associations"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "ConnectPeerId",
              "DeviceId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              ConnectPeerId: {},
              DeviceId: {},
              LinkId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectPeerAssociation: {
                shape: "Sq"
              }
            }
          }
        },
        AssociateCustomerGateway: {
          http: {
            requestUri: "/global-networks/{globalNetworkId}/customer-gateway-associations"
          },
          input: {
            type: "structure",
            required: [
              "CustomerGatewayArn",
              "GlobalNetworkId",
              "DeviceId"
            ],
            members: {
              CustomerGatewayArn: {},
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              DeviceId: {},
              LinkId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CustomerGatewayAssociation: {
                shape: "Sv"
              }
            }
          }
        },
        AssociateLink: {
          http: {
            requestUri: "/global-networks/{globalNetworkId}/link-associations"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "DeviceId",
              "LinkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              DeviceId: {},
              LinkId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LinkAssociation: {
                shape: "Sz"
              }
            }
          }
        },
        AssociateTransitGatewayConnectPeer: {
          http: {
            requestUri: "/global-networks/{globalNetworkId}/transit-gateway-connect-peer-associations"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "TransitGatewayConnectPeerArn",
              "DeviceId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              TransitGatewayConnectPeerArn: {},
              DeviceId: {},
              LinkId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayConnectPeerAssociation: {
                shape: "S14"
              }
            }
          }
        },
        CreateConnectAttachment: {
          http: {
            requestUri: "/connect-attachments"
          },
          input: {
            type: "structure",
            required: [
              "CoreNetworkId",
              "EdgeLocation",
              "TransportAttachmentId",
              "Options"
            ],
            members: {
              CoreNetworkId: {},
              EdgeLocation: {},
              TransportAttachmentId: {},
              Options: {
                shape: "S17"
              },
              Tags: {
                shape: "Se"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectAttachment: {
                shape: "S1b"
              }
            }
          }
        },
        CreateConnectPeer: {
          http: {
            requestUri: "/connect-peers"
          },
          input: {
            type: "structure",
            required: [
              "ConnectAttachmentId",
              "PeerAddress"
            ],
            members: {
              ConnectAttachmentId: {},
              CoreNetworkAddress: {},
              PeerAddress: {},
              BgpOptions: {
                type: "structure",
                members: {
                  PeerAsn: {
                    type: "long"
                  }
                }
              },
              InsideCidrBlocks: {
                shape: "S1g"
              },
              Tags: {
                shape: "Se"
              },
              ClientToken: {
                idempotencyToken: true
              },
              SubnetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectPeer: {
                shape: "S1j"
              }
            }
          }
        },
        CreateConnection: {
          http: {
            requestUri: "/global-networks/{globalNetworkId}/connections"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "DeviceId",
              "ConnectedDeviceId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              DeviceId: {},
              ConnectedDeviceId: {},
              LinkId: {},
              ConnectedLinkId: {},
              Description: {},
              Tags: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Connection: {
                shape: "S1q"
              }
            }
          }
        },
        CreateCoreNetwork: {
          http: {
            requestUri: "/core-networks"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId"
            ],
            members: {
              GlobalNetworkId: {},
              Description: {},
              Tags: {
                shape: "Se"
              },
              PolicyDocument: {},
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CoreNetwork: {
                shape: "S1x"
              }
            }
          }
        },
        CreateDevice: {
          http: {
            requestUri: "/global-networks/{globalNetworkId}/devices"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              AWSLocation: {
                shape: "S25"
              },
              Description: {},
              Type: {},
              Vendor: {},
              Model: {},
              SerialNumber: {},
              Location: {
                shape: "S26"
              },
              SiteId: {},
              Tags: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Device: {
                shape: "S29"
              }
            }
          }
        },
        CreateGlobalNetwork: {
          http: {
            requestUri: "/global-networks"
          },
          input: {
            type: "structure",
            members: {
              Description: {},
              Tags: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GlobalNetwork: {
                shape: "S2e"
              }
            }
          }
        },
        CreateLink: {
          http: {
            requestUri: "/global-networks/{globalNetworkId}/links"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "Bandwidth",
              "SiteId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              Description: {},
              Type: {},
              Bandwidth: {
                shape: "S2i"
              },
              Provider: {},
              SiteId: {},
              Tags: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Link: {
                shape: "S2k"
              }
            }
          }
        },
        CreateSite: {
          http: {
            requestUri: "/global-networks/{globalNetworkId}/sites"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              Description: {},
              Location: {
                shape: "S26"
              },
              Tags: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Site: {
                shape: "S2p"
              }
            }
          }
        },
        CreateSiteToSiteVpnAttachment: {
          http: {
            requestUri: "/site-to-site-vpn-attachments"
          },
          input: {
            type: "structure",
            required: [
              "CoreNetworkId",
              "VpnConnectionArn"
            ],
            members: {
              CoreNetworkId: {},
              VpnConnectionArn: {},
              Tags: {
                shape: "Se"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SiteToSiteVpnAttachment: {
                shape: "S2v"
              }
            }
          }
        },
        CreateTransitGatewayPeering: {
          http: {
            requestUri: "/transit-gateway-peerings"
          },
          input: {
            type: "structure",
            required: [
              "CoreNetworkId",
              "TransitGatewayArn"
            ],
            members: {
              CoreNetworkId: {},
              TransitGatewayArn: {},
              Tags: {
                shape: "Se"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayPeering: {
                shape: "S2z"
              }
            }
          }
        },
        CreateTransitGatewayRouteTableAttachment: {
          http: {
            requestUri: "/transit-gateway-route-table-attachments"
          },
          input: {
            type: "structure",
            required: [
              "PeeringId",
              "TransitGatewayRouteTableArn"
            ],
            members: {
              PeeringId: {},
              TransitGatewayRouteTableArn: {},
              Tags: {
                shape: "Se"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayRouteTableAttachment: {
                shape: "S38"
              }
            }
          }
        },
        CreateVpcAttachment: {
          http: {
            requestUri: "/vpc-attachments"
          },
          input: {
            type: "structure",
            required: [
              "CoreNetworkId",
              "VpcArn",
              "SubnetArns"
            ],
            members: {
              CoreNetworkId: {},
              VpcArn: {},
              SubnetArns: {
                shape: "S3b"
              },
              Options: {
                shape: "S3c"
              },
              Tags: {
                shape: "Se"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpcAttachment: {
                shape: "S3f"
              }
            }
          }
        },
        DeleteAttachment: {
          http: {
            method: "DELETE",
            requestUri: "/attachments/{attachmentId}"
          },
          input: {
            type: "structure",
            required: [
              "AttachmentId"
            ],
            members: {
              AttachmentId: {
                location: "uri",
                locationName: "attachmentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attachment: {
                shape: "S4"
              }
            }
          }
        },
        DeleteConnectPeer: {
          http: {
            method: "DELETE",
            requestUri: "/connect-peers/{connectPeerId}"
          },
          input: {
            type: "structure",
            required: [
              "ConnectPeerId"
            ],
            members: {
              ConnectPeerId: {
                location: "uri",
                locationName: "connectPeerId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectPeer: {
                shape: "S1j"
              }
            }
          }
        },
        DeleteConnection: {
          http: {
            method: "DELETE",
            requestUri: "/global-networks/{globalNetworkId}/connections/{connectionId}"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "ConnectionId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              ConnectionId: {
                location: "uri",
                locationName: "connectionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Connection: {
                shape: "S1q"
              }
            }
          }
        },
        DeleteCoreNetwork: {
          http: {
            method: "DELETE",
            requestUri: "/core-networks/{coreNetworkId}"
          },
          input: {
            type: "structure",
            required: [
              "CoreNetworkId"
            ],
            members: {
              CoreNetworkId: {
                location: "uri",
                locationName: "coreNetworkId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CoreNetwork: {
                shape: "S1x"
              }
            }
          }
        },
        DeleteCoreNetworkPolicyVersion: {
          http: {
            method: "DELETE",
            requestUri: "/core-networks/{coreNetworkId}/core-network-policy-versions/{policyVersionId}"
          },
          input: {
            type: "structure",
            required: [
              "CoreNetworkId",
              "PolicyVersionId"
            ],
            members: {
              CoreNetworkId: {
                location: "uri",
                locationName: "coreNetworkId"
              },
              PolicyVersionId: {
                location: "uri",
                locationName: "policyVersionId",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CoreNetworkPolicy: {
                shape: "S3q"
              }
            }
          }
        },
        DeleteDevice: {
          http: {
            method: "DELETE",
            requestUri: "/global-networks/{globalNetworkId}/devices/{deviceId}"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "DeviceId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              DeviceId: {
                location: "uri",
                locationName: "deviceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Device: {
                shape: "S29"
              }
            }
          }
        },
        DeleteGlobalNetwork: {
          http: {
            method: "DELETE",
            requestUri: "/global-networks/{globalNetworkId}"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GlobalNetwork: {
                shape: "S2e"
              }
            }
          }
        },
        DeleteLink: {
          http: {
            method: "DELETE",
            requestUri: "/global-networks/{globalNetworkId}/links/{linkId}"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "LinkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              LinkId: {
                location: "uri",
                locationName: "linkId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Link: {
                shape: "S2k"
              }
            }
          }
        },
        DeletePeering: {
          http: {
            method: "DELETE",
            requestUri: "/peerings/{peeringId}"
          },
          input: {
            type: "structure",
            required: [
              "PeeringId"
            ],
            members: {
              PeeringId: {
                location: "uri",
                locationName: "peeringId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Peering: {
                shape: "S30"
              }
            }
          }
        },
        DeleteResourcePolicy: {
          http: {
            method: "DELETE",
            requestUri: "/resource-policy/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSite: {
          http: {
            method: "DELETE",
            requestUri: "/global-networks/{globalNetworkId}/sites/{siteId}"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "SiteId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              SiteId: {
                location: "uri",
                locationName: "siteId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Site: {
                shape: "S2p"
              }
            }
          }
        },
        DeregisterTransitGateway: {
          http: {
            method: "DELETE",
            requestUri: "/global-networks/{globalNetworkId}/transit-gateway-registrations/{transitGatewayArn}"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "TransitGatewayArn"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              TransitGatewayArn: {
                location: "uri",
                locationName: "transitGatewayArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayRegistration: {
                shape: "S4a"
              }
            }
          }
        },
        DescribeGlobalNetworks: {
          http: {
            method: "GET",
            requestUri: "/global-networks"
          },
          input: {
            type: "structure",
            members: {
              GlobalNetworkIds: {
                location: "querystring",
                locationName: "globalNetworkIds",
                type: "list",
                member: {}
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GlobalNetworks: {
                type: "list",
                member: {
                  shape: "S2e"
                }
              },
              NextToken: {}
            }
          }
        },
        DisassociateConnectPeer: {
          http: {
            method: "DELETE",
            requestUri: "/global-networks/{globalNetworkId}/connect-peer-associations/{connectPeerId}"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "ConnectPeerId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              ConnectPeerId: {
                location: "uri",
                locationName: "connectPeerId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectPeerAssociation: {
                shape: "Sq"
              }
            }
          }
        },
        DisassociateCustomerGateway: {
          http: {
            method: "DELETE",
            requestUri: "/global-networks/{globalNetworkId}/customer-gateway-associations/{customerGatewayArn}"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "CustomerGatewayArn"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              CustomerGatewayArn: {
                location: "uri",
                locationName: "customerGatewayArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CustomerGatewayAssociation: {
                shape: "Sv"
              }
            }
          }
        },
        DisassociateLink: {
          http: {
            method: "DELETE",
            requestUri: "/global-networks/{globalNetworkId}/link-associations"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "DeviceId",
              "LinkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              DeviceId: {
                location: "querystring",
                locationName: "deviceId"
              },
              LinkId: {
                location: "querystring",
                locationName: "linkId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LinkAssociation: {
                shape: "Sz"
              }
            }
          }
        },
        DisassociateTransitGatewayConnectPeer: {
          http: {
            method: "DELETE",
            requestUri: "/global-networks/{globalNetworkId}/transit-gateway-connect-peer-associations/{transitGatewayConnectPeerArn}"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "TransitGatewayConnectPeerArn"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              TransitGatewayConnectPeerArn: {
                location: "uri",
                locationName: "transitGatewayConnectPeerArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayConnectPeerAssociation: {
                shape: "S14"
              }
            }
          }
        },
        ExecuteCoreNetworkChangeSet: {
          http: {
            requestUri: "/core-networks/{coreNetworkId}/core-network-change-sets/{policyVersionId}/execute"
          },
          input: {
            type: "structure",
            required: [
              "CoreNetworkId",
              "PolicyVersionId"
            ],
            members: {
              CoreNetworkId: {
                location: "uri",
                locationName: "coreNetworkId"
              },
              PolicyVersionId: {
                location: "uri",
                locationName: "policyVersionId",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetConnectAttachment: {
          http: {
            method: "GET",
            requestUri: "/connect-attachments/{attachmentId}"
          },
          input: {
            type: "structure",
            required: [
              "AttachmentId"
            ],
            members: {
              AttachmentId: {
                location: "uri",
                locationName: "attachmentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectAttachment: {
                shape: "S1b"
              }
            }
          }
        },
        GetConnectPeer: {
          http: {
            method: "GET",
            requestUri: "/connect-peers/{connectPeerId}"
          },
          input: {
            type: "structure",
            required: [
              "ConnectPeerId"
            ],
            members: {
              ConnectPeerId: {
                location: "uri",
                locationName: "connectPeerId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectPeer: {
                shape: "S1j"
              }
            }
          }
        },
        GetConnectPeerAssociations: {
          http: {
            method: "GET",
            requestUri: "/global-networks/{globalNetworkId}/connect-peer-associations"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              ConnectPeerIds: {
                location: "querystring",
                locationName: "connectPeerIds",
                type: "list",
                member: {}
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectPeerAssociations: {
                type: "list",
                member: {
                  shape: "Sq"
                }
              },
              NextToken: {}
            }
          }
        },
        GetConnections: {
          http: {
            method: "GET",
            requestUri: "/global-networks/{globalNetworkId}/connections"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              ConnectionIds: {
                location: "querystring",
                locationName: "connectionIds",
                type: "list",
                member: {}
              },
              DeviceId: {
                location: "querystring",
                locationName: "deviceId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Connections: {
                type: "list",
                member: {
                  shape: "S1q"
                }
              },
              NextToken: {}
            }
          }
        },
        GetCoreNetwork: {
          http: {
            method: "GET",
            requestUri: "/core-networks/{coreNetworkId}"
          },
          input: {
            type: "structure",
            required: [
              "CoreNetworkId"
            ],
            members: {
              CoreNetworkId: {
                location: "uri",
                locationName: "coreNetworkId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CoreNetwork: {
                shape: "S1x"
              }
            }
          }
        },
        GetCoreNetworkChangeEvents: {
          http: {
            method: "GET",
            requestUri: "/core-networks/{coreNetworkId}/core-network-change-events/{policyVersionId}"
          },
          input: {
            type: "structure",
            required: [
              "CoreNetworkId",
              "PolicyVersionId"
            ],
            members: {
              CoreNetworkId: {
                location: "uri",
                locationName: "coreNetworkId"
              },
              PolicyVersionId: {
                location: "uri",
                locationName: "policyVersionId",
                type: "integer"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CoreNetworkChangeEvents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    Action: {},
                    IdentifierPath: {},
                    EventTime: {
                      type: "timestamp"
                    },
                    Status: {},
                    Values: {
                      type: "structure",
                      members: {
                        EdgeLocation: {},
                        SegmentName: {},
                        AttachmentId: {},
                        Cidr: {}
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetCoreNetworkChangeSet: {
          http: {
            method: "GET",
            requestUri: "/core-networks/{coreNetworkId}/core-network-change-sets/{policyVersionId}"
          },
          input: {
            type: "structure",
            required: [
              "CoreNetworkId",
              "PolicyVersionId"
            ],
            members: {
              CoreNetworkId: {
                location: "uri",
                locationName: "coreNetworkId"
              },
              PolicyVersionId: {
                location: "uri",
                locationName: "policyVersionId",
                type: "integer"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CoreNetworkChanges: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    Action: {},
                    Identifier: {},
                    PreviousValues: {
                      shape: "S5j"
                    },
                    NewValues: {
                      shape: "S5j"
                    },
                    IdentifierPath: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetCoreNetworkPolicy: {
          http: {
            method: "GET",
            requestUri: "/core-networks/{coreNetworkId}/core-network-policy"
          },
          input: {
            type: "structure",
            required: [
              "CoreNetworkId"
            ],
            members: {
              CoreNetworkId: {
                location: "uri",
                locationName: "coreNetworkId"
              },
              PolicyVersionId: {
                location: "querystring",
                locationName: "policyVersionId",
                type: "integer"
              },
              Alias: {
                location: "querystring",
                locationName: "alias"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CoreNetworkPolicy: {
                shape: "S3q"
              }
            }
          }
        },
        GetCustomerGatewayAssociations: {
          http: {
            method: "GET",
            requestUri: "/global-networks/{globalNetworkId}/customer-gateway-associations"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              CustomerGatewayArns: {
                location: "querystring",
                locationName: "customerGatewayArns",
                type: "list",
                member: {}
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CustomerGatewayAssociations: {
                type: "list",
                member: {
                  shape: "Sv"
                }
              },
              NextToken: {}
            }
          }
        },
        GetDevices: {
          http: {
            method: "GET",
            requestUri: "/global-networks/{globalNetworkId}/devices"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              DeviceIds: {
                location: "querystring",
                locationName: "deviceIds",
                type: "list",
                member: {}
              },
              SiteId: {
                location: "querystring",
                locationName: "siteId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Devices: {
                type: "list",
                member: {
                  shape: "S29"
                }
              },
              NextToken: {}
            }
          }
        },
        GetLinkAssociations: {
          http: {
            method: "GET",
            requestUri: "/global-networks/{globalNetworkId}/link-associations"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              DeviceId: {
                location: "querystring",
                locationName: "deviceId"
              },
              LinkId: {
                location: "querystring",
                locationName: "linkId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LinkAssociations: {
                type: "list",
                member: {
                  shape: "Sz"
                }
              },
              NextToken: {}
            }
          }
        },
        GetLinks: {
          http: {
            method: "GET",
            requestUri: "/global-networks/{globalNetworkId}/links"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              LinkIds: {
                location: "querystring",
                locationName: "linkIds",
                type: "list",
                member: {}
              },
              SiteId: {
                location: "querystring",
                locationName: "siteId"
              },
              Type: {
                location: "querystring",
                locationName: "type"
              },
              Provider: {
                location: "querystring",
                locationName: "provider"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Links: {
                type: "list",
                member: {
                  shape: "S2k"
                }
              },
              NextToken: {}
            }
          }
        },
        GetNetworkResourceCounts: {
          http: {
            method: "GET",
            requestUri: "/global-networks/{globalNetworkId}/network-resource-count"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkResourceCounts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceType: {},
                    Count: {
                      type: "integer"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetNetworkResourceRelationships: {
          http: {
            method: "GET",
            requestUri: "/global-networks/{globalNetworkId}/network-resource-relationships"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              CoreNetworkId: {
                location: "querystring",
                locationName: "coreNetworkId"
              },
              RegisteredGatewayArn: {
                location: "querystring",
                locationName: "registeredGatewayArn"
              },
              AwsRegion: {
                location: "querystring",
                locationName: "awsRegion"
              },
              AccountId: {
                location: "querystring",
                locationName: "accountId"
              },
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              },
              ResourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Relationships: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    From: {},
                    To: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetNetworkResources: {
          http: {
            method: "GET",
            requestUri: "/global-networks/{globalNetworkId}/network-resources"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              CoreNetworkId: {
                location: "querystring",
                locationName: "coreNetworkId"
              },
              RegisteredGatewayArn: {
                location: "querystring",
                locationName: "registeredGatewayArn"
              },
              AwsRegion: {
                location: "querystring",
                locationName: "awsRegion"
              },
              AccountId: {
                location: "querystring",
                locationName: "accountId"
              },
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              },
              ResourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkResources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RegisteredGatewayArn: {},
                    CoreNetworkId: {},
                    AwsRegion: {},
                    AccountId: {},
                    ResourceType: {},
                    ResourceId: {},
                    ResourceArn: {},
                    Definition: {},
                    DefinitionTimestamp: {
                      type: "timestamp"
                    },
                    Tags: {
                      shape: "Se"
                    },
                    Metadata: {
                      shape: "S6d"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetNetworkRoutes: {
          http: {
            requestUri: "/global-networks/{globalNetworkId}/network-routes"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "RouteTableIdentifier"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              RouteTableIdentifier: {
                type: "structure",
                members: {
                  TransitGatewayRouteTableArn: {},
                  CoreNetworkSegmentEdge: {
                    shape: "S6g"
                  }
                }
              },
              ExactCidrMatches: {
                shape: "S1g"
              },
              LongestPrefixMatches: {
                shape: "S1g"
              },
              SubnetOfMatches: {
                shape: "S1g"
              },
              SupernetOfMatches: {
                shape: "S1g"
              },
              PrefixListIds: {
                shape: "S1g"
              },
              States: {
                type: "list",
                member: {}
              },
              Types: {
                type: "list",
                member: {}
              },
              DestinationFilters: {
                type: "map",
                key: {},
                value: {
                  type: "list",
                  member: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RouteTableArn: {},
              CoreNetworkSegmentEdge: {
                shape: "S6g"
              },
              RouteTableType: {},
              RouteTableTimestamp: {
                type: "timestamp"
              },
              NetworkRoutes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DestinationCidrBlock: {},
                    Destinations: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          CoreNetworkAttachmentId: {},
                          TransitGatewayAttachmentId: {},
                          SegmentName: {},
                          EdgeLocation: {},
                          ResourceType: {},
                          ResourceId: {}
                        }
                      }
                    },
                    PrefixListId: {},
                    State: {},
                    Type: {}
                  }
                }
              }
            }
          }
        },
        GetNetworkTelemetry: {
          http: {
            method: "GET",
            requestUri: "/global-networks/{globalNetworkId}/network-telemetry"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              CoreNetworkId: {
                location: "querystring",
                locationName: "coreNetworkId"
              },
              RegisteredGatewayArn: {
                location: "querystring",
                locationName: "registeredGatewayArn"
              },
              AwsRegion: {
                location: "querystring",
                locationName: "awsRegion"
              },
              AccountId: {
                location: "querystring",
                locationName: "accountId"
              },
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              },
              ResourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkTelemetry: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RegisteredGatewayArn: {},
                    CoreNetworkId: {},
                    AwsRegion: {},
                    AccountId: {},
                    ResourceType: {},
                    ResourceId: {},
                    ResourceArn: {},
                    Address: {},
                    Health: {
                      type: "structure",
                      members: {
                        Type: {},
                        Status: {},
                        Timestamp: {
                          type: "timestamp"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetResourcePolicy: {
          http: {
            method: "GET",
            requestUri: "/resource-policy/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyDocument: {
                jsonvalue: true
              }
            }
          }
        },
        GetRouteAnalysis: {
          http: {
            method: "GET",
            requestUri: "/global-networks/{globalNetworkId}/route-analyses/{routeAnalysisId}"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "RouteAnalysisId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              RouteAnalysisId: {
                location: "uri",
                locationName: "routeAnalysisId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RouteAnalysis: {
                shape: "S78"
              }
            }
          }
        },
        GetSiteToSiteVpnAttachment: {
          http: {
            method: "GET",
            requestUri: "/site-to-site-vpn-attachments/{attachmentId}"
          },
          input: {
            type: "structure",
            required: [
              "AttachmentId"
            ],
            members: {
              AttachmentId: {
                location: "uri",
                locationName: "attachmentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SiteToSiteVpnAttachment: {
                shape: "S2v"
              }
            }
          }
        },
        GetSites: {
          http: {
            method: "GET",
            requestUri: "/global-networks/{globalNetworkId}/sites"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              SiteIds: {
                location: "querystring",
                locationName: "siteIds",
                type: "list",
                member: {}
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Sites: {
                type: "list",
                member: {
                  shape: "S2p"
                }
              },
              NextToken: {}
            }
          }
        },
        GetTransitGatewayConnectPeerAssociations: {
          http: {
            method: "GET",
            requestUri: "/global-networks/{globalNetworkId}/transit-gateway-connect-peer-associations"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              TransitGatewayConnectPeerArns: {
                location: "querystring",
                locationName: "transitGatewayConnectPeerArns",
                type: "list",
                member: {}
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayConnectPeerAssociations: {
                type: "list",
                member: {
                  shape: "S14"
                }
              },
              NextToken: {}
            }
          }
        },
        GetTransitGatewayPeering: {
          http: {
            method: "GET",
            requestUri: "/transit-gateway-peerings/{peeringId}"
          },
          input: {
            type: "structure",
            required: [
              "PeeringId"
            ],
            members: {
              PeeringId: {
                location: "uri",
                locationName: "peeringId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayPeering: {
                shape: "S2z"
              }
            }
          }
        },
        GetTransitGatewayRegistrations: {
          http: {
            method: "GET",
            requestUri: "/global-networks/{globalNetworkId}/transit-gateway-registrations"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              TransitGatewayArns: {
                location: "querystring",
                locationName: "transitGatewayArns",
                type: "list",
                member: {}
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayRegistrations: {
                type: "list",
                member: {
                  shape: "S4a"
                }
              },
              NextToken: {}
            }
          }
        },
        GetTransitGatewayRouteTableAttachment: {
          http: {
            method: "GET",
            requestUri: "/transit-gateway-route-table-attachments/{attachmentId}"
          },
          input: {
            type: "structure",
            required: [
              "AttachmentId"
            ],
            members: {
              AttachmentId: {
                location: "uri",
                locationName: "attachmentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayRouteTableAttachment: {
                shape: "S38"
              }
            }
          }
        },
        GetVpcAttachment: {
          http: {
            method: "GET",
            requestUri: "/vpc-attachments/{attachmentId}"
          },
          input: {
            type: "structure",
            required: [
              "AttachmentId"
            ],
            members: {
              AttachmentId: {
                location: "uri",
                locationName: "attachmentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpcAttachment: {
                shape: "S3f"
              }
            }
          }
        },
        ListAttachments: {
          http: {
            method: "GET",
            requestUri: "/attachments"
          },
          input: {
            type: "structure",
            members: {
              CoreNetworkId: {
                location: "querystring",
                locationName: "coreNetworkId"
              },
              AttachmentType: {
                location: "querystring",
                locationName: "attachmentType"
              },
              EdgeLocation: {
                location: "querystring",
                locationName: "edgeLocation"
              },
              State: {
                location: "querystring",
                locationName: "state"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attachments: {
                type: "list",
                member: {
                  shape: "S4"
                }
              },
              NextToken: {}
            }
          }
        },
        ListConnectPeers: {
          http: {
            method: "GET",
            requestUri: "/connect-peers"
          },
          input: {
            type: "structure",
            members: {
              CoreNetworkId: {
                location: "querystring",
                locationName: "coreNetworkId"
              },
              ConnectAttachmentId: {
                location: "querystring",
                locationName: "connectAttachmentId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectPeers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CoreNetworkId: {},
                    ConnectAttachmentId: {},
                    ConnectPeerId: {},
                    EdgeLocation: {},
                    ConnectPeerState: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    Tags: {
                      shape: "Se"
                    },
                    SubnetArn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListCoreNetworkPolicyVersions: {
          http: {
            method: "GET",
            requestUri: "/core-networks/{coreNetworkId}/core-network-policy-versions"
          },
          input: {
            type: "structure",
            required: [
              "CoreNetworkId"
            ],
            members: {
              CoreNetworkId: {
                location: "uri",
                locationName: "coreNetworkId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CoreNetworkPolicyVersions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CoreNetworkId: {},
                    PolicyVersionId: {
                      type: "integer"
                    },
                    Alias: {},
                    Description: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    ChangeSetState: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListCoreNetworks: {
          http: {
            method: "GET",
            requestUri: "/core-networks"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CoreNetworks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CoreNetworkId: {},
                    CoreNetworkArn: {},
                    GlobalNetworkId: {},
                    OwnerAccountId: {},
                    State: {},
                    Description: {},
                    Tags: {
                      shape: "Se"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListOrganizationServiceAccessStatus: {
          http: {
            method: "GET",
            requestUri: "/organizations/service-access"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationStatus: {
                shape: "S8n"
              },
              NextToken: {}
            }
          }
        },
        ListPeerings: {
          http: {
            method: "GET",
            requestUri: "/peerings"
          },
          input: {
            type: "structure",
            members: {
              CoreNetworkId: {
                location: "querystring",
                locationName: "coreNetworkId"
              },
              PeeringType: {
                location: "querystring",
                locationName: "peeringType"
              },
              EdgeLocation: {
                location: "querystring",
                locationName: "edgeLocation"
              },
              State: {
                location: "querystring",
                locationName: "state"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Peerings: {
                type: "list",
                member: {
                  shape: "S30"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TagList: {
                shape: "Se"
              }
            }
          }
        },
        PutCoreNetworkPolicy: {
          http: {
            requestUri: "/core-networks/{coreNetworkId}/core-network-policy"
          },
          input: {
            type: "structure",
            required: [
              "CoreNetworkId",
              "PolicyDocument"
            ],
            members: {
              CoreNetworkId: {
                location: "uri",
                locationName: "coreNetworkId"
              },
              PolicyDocument: {
                jsonvalue: true
              },
              Description: {},
              LatestVersionId: {
                type: "integer"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CoreNetworkPolicy: {
                shape: "S3q"
              }
            }
          }
        },
        PutResourcePolicy: {
          http: {
            requestUri: "/resource-policy/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "PolicyDocument",
              "ResourceArn"
            ],
            members: {
              PolicyDocument: {
                jsonvalue: true
              },
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RegisterTransitGateway: {
          http: {
            requestUri: "/global-networks/{globalNetworkId}/transit-gateway-registrations"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "TransitGatewayArn"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              TransitGatewayArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayRegistration: {
                shape: "S4a"
              }
            }
          }
        },
        RejectAttachment: {
          http: {
            requestUri: "/attachments/{attachmentId}/reject"
          },
          input: {
            type: "structure",
            required: [
              "AttachmentId"
            ],
            members: {
              AttachmentId: {
                location: "uri",
                locationName: "attachmentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attachment: {
                shape: "S4"
              }
            }
          }
        },
        RestoreCoreNetworkPolicyVersion: {
          http: {
            requestUri: "/core-networks/{coreNetworkId}/core-network-policy-versions/{policyVersionId}/restore"
          },
          input: {
            type: "structure",
            required: [
              "CoreNetworkId",
              "PolicyVersionId"
            ],
            members: {
              CoreNetworkId: {
                location: "uri",
                locationName: "coreNetworkId"
              },
              PolicyVersionId: {
                location: "uri",
                locationName: "policyVersionId",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CoreNetworkPolicy: {
                shape: "S3q"
              }
            }
          }
        },
        StartOrganizationServiceAccessUpdate: {
          http: {
            requestUri: "/organizations/service-access"
          },
          input: {
            type: "structure",
            required: [
              "Action"
            ],
            members: {
              Action: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationStatus: {
                shape: "S8n"
              }
            }
          }
        },
        StartRouteAnalysis: {
          http: {
            requestUri: "/global-networks/{globalNetworkId}/route-analyses"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "Source",
              "Destination"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              Source: {
                shape: "S9d"
              },
              Destination: {
                shape: "S9d"
              },
              IncludeReturnPath: {
                type: "boolean"
              },
              UseMiddleboxes: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RouteAnalysis: {
                shape: "S78"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              Tags: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateConnection: {
          http: {
            method: "PATCH",
            requestUri: "/global-networks/{globalNetworkId}/connections/{connectionId}"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "ConnectionId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              ConnectionId: {
                location: "uri",
                locationName: "connectionId"
              },
              LinkId: {},
              ConnectedLinkId: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Connection: {
                shape: "S1q"
              }
            }
          }
        },
        UpdateCoreNetwork: {
          http: {
            method: "PATCH",
            requestUri: "/core-networks/{coreNetworkId}"
          },
          input: {
            type: "structure",
            required: [
              "CoreNetworkId"
            ],
            members: {
              CoreNetworkId: {
                location: "uri",
                locationName: "coreNetworkId"
              },
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CoreNetwork: {
                shape: "S1x"
              }
            }
          }
        },
        UpdateDevice: {
          http: {
            method: "PATCH",
            requestUri: "/global-networks/{globalNetworkId}/devices/{deviceId}"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "DeviceId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              DeviceId: {
                location: "uri",
                locationName: "deviceId"
              },
              AWSLocation: {
                shape: "S25"
              },
              Description: {},
              Type: {},
              Vendor: {},
              Model: {},
              SerialNumber: {},
              Location: {
                shape: "S26"
              },
              SiteId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Device: {
                shape: "S29"
              }
            }
          }
        },
        UpdateGlobalNetwork: {
          http: {
            method: "PATCH",
            requestUri: "/global-networks/{globalNetworkId}"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GlobalNetwork: {
                shape: "S2e"
              }
            }
          }
        },
        UpdateLink: {
          http: {
            method: "PATCH",
            requestUri: "/global-networks/{globalNetworkId}/links/{linkId}"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "LinkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              LinkId: {
                location: "uri",
                locationName: "linkId"
              },
              Description: {},
              Type: {},
              Bandwidth: {
                shape: "S2i"
              },
              Provider: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Link: {
                shape: "S2k"
              }
            }
          }
        },
        UpdateNetworkResourceMetadata: {
          http: {
            method: "PATCH",
            requestUri: "/global-networks/{globalNetworkId}/network-resources/{resourceArn}/metadata"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "ResourceArn",
              "Metadata"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              Metadata: {
                shape: "S6d"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceArn: {},
              Metadata: {
                shape: "S6d"
              }
            }
          }
        },
        UpdateSite: {
          http: {
            method: "PATCH",
            requestUri: "/global-networks/{globalNetworkId}/sites/{siteId}"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "SiteId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              SiteId: {
                location: "uri",
                locationName: "siteId"
              },
              Description: {},
              Location: {
                shape: "S26"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Site: {
                shape: "S2p"
              }
            }
          }
        },
        UpdateVpcAttachment: {
          http: {
            method: "PATCH",
            requestUri: "/vpc-attachments/{attachmentId}"
          },
          input: {
            type: "structure",
            required: [
              "AttachmentId"
            ],
            members: {
              AttachmentId: {
                location: "uri",
                locationName: "attachmentId"
              },
              AddSubnetArns: {
                shape: "S3b"
              },
              RemoveSubnetArns: {
                shape: "S3b"
              },
              Options: {
                shape: "S3c"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpcAttachment: {
                shape: "S3f"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            CoreNetworkId: {},
            CoreNetworkArn: {},
            AttachmentId: {},
            OwnerAccountId: {},
            AttachmentType: {},
            State: {},
            EdgeLocation: {},
            ResourceArn: {},
            AttachmentPolicyRuleNumber: {
              type: "integer"
            },
            SegmentName: {},
            Tags: {
              shape: "Se"
            },
            ProposedSegmentChange: {
              type: "structure",
              members: {
                Tags: {
                  shape: "Se"
                },
                AttachmentPolicyRuleNumber: {
                  type: "integer"
                },
                SegmentName: {}
              }
            },
            CreatedAt: {
              type: "timestamp"
            },
            UpdatedAt: {
              type: "timestamp"
            }
          }
        },
        Se: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sq: {
          type: "structure",
          members: {
            ConnectPeerId: {},
            GlobalNetworkId: {},
            DeviceId: {},
            LinkId: {},
            State: {}
          }
        },
        Sv: {
          type: "structure",
          members: {
            CustomerGatewayArn: {},
            GlobalNetworkId: {},
            DeviceId: {},
            LinkId: {},
            State: {}
          }
        },
        Sz: {
          type: "structure",
          members: {
            GlobalNetworkId: {},
            DeviceId: {},
            LinkId: {},
            LinkAssociationState: {}
          }
        },
        S14: {
          type: "structure",
          members: {
            TransitGatewayConnectPeerArn: {},
            GlobalNetworkId: {},
            DeviceId: {},
            LinkId: {},
            State: {}
          }
        },
        S17: {
          type: "structure",
          members: {
            Protocol: {}
          }
        },
        S1b: {
          type: "structure",
          members: {
            Attachment: {
              shape: "S4"
            },
            TransportAttachmentId: {},
            Options: {
              shape: "S17"
            }
          }
        },
        S1g: {
          type: "list",
          member: {}
        },
        S1j: {
          type: "structure",
          members: {
            CoreNetworkId: {},
            ConnectAttachmentId: {},
            ConnectPeerId: {},
            EdgeLocation: {},
            State: {},
            CreatedAt: {
              type: "timestamp"
            },
            Configuration: {
              type: "structure",
              members: {
                CoreNetworkAddress: {},
                PeerAddress: {},
                InsideCidrBlocks: {
                  shape: "S1g"
                },
                Protocol: {},
                BgpConfigurations: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      CoreNetworkAsn: {
                        type: "long"
                      },
                      PeerAsn: {
                        type: "long"
                      },
                      CoreNetworkAddress: {},
                      PeerAddress: {}
                    }
                  }
                }
              }
            },
            Tags: {
              shape: "Se"
            },
            SubnetArn: {}
          }
        },
        S1q: {
          type: "structure",
          members: {
            ConnectionId: {},
            ConnectionArn: {},
            GlobalNetworkId: {},
            DeviceId: {},
            ConnectedDeviceId: {},
            LinkId: {},
            ConnectedLinkId: {},
            Description: {},
            CreatedAt: {
              type: "timestamp"
            },
            State: {},
            Tags: {
              shape: "Se"
            }
          }
        },
        S1x: {
          type: "structure",
          members: {
            GlobalNetworkId: {},
            CoreNetworkId: {},
            CoreNetworkArn: {},
            Description: {},
            CreatedAt: {
              type: "timestamp"
            },
            State: {},
            Segments: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Name: {},
                  EdgeLocations: {
                    shape: "S21"
                  },
                  SharedSegments: {
                    shape: "S1g"
                  }
                }
              }
            },
            Edges: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  EdgeLocation: {},
                  Asn: {
                    type: "long"
                  },
                  InsideCidrBlocks: {
                    shape: "S1g"
                  }
                }
              }
            },
            Tags: {
              shape: "Se"
            }
          }
        },
        S21: {
          type: "list",
          member: {}
        },
        S25: {
          type: "structure",
          members: {
            Zone: {},
            SubnetArn: {}
          }
        },
        S26: {
          type: "structure",
          members: {
            Address: {},
            Latitude: {},
            Longitude: {}
          },
          sensitive: true
        },
        S29: {
          type: "structure",
          members: {
            DeviceId: {},
            DeviceArn: {},
            GlobalNetworkId: {},
            AWSLocation: {
              shape: "S25"
            },
            Description: {},
            Type: {},
            Vendor: {},
            Model: {},
            SerialNumber: {},
            Location: {
              shape: "S26"
            },
            SiteId: {},
            CreatedAt: {
              type: "timestamp"
            },
            State: {},
            Tags: {
              shape: "Se"
            }
          }
        },
        S2e: {
          type: "structure",
          members: {
            GlobalNetworkId: {},
            GlobalNetworkArn: {},
            Description: {},
            CreatedAt: {
              type: "timestamp"
            },
            State: {},
            Tags: {
              shape: "Se"
            }
          }
        },
        S2i: {
          type: "structure",
          members: {
            UploadSpeed: {
              type: "integer"
            },
            DownloadSpeed: {
              type: "integer"
            }
          }
        },
        S2k: {
          type: "structure",
          members: {
            LinkId: {},
            LinkArn: {},
            GlobalNetworkId: {},
            SiteId: {},
            Description: {},
            Type: {},
            Bandwidth: {
              shape: "S2i"
            },
            Provider: {},
            CreatedAt: {
              type: "timestamp"
            },
            State: {},
            Tags: {
              shape: "Se"
            }
          }
        },
        S2p: {
          type: "structure",
          members: {
            SiteId: {},
            SiteArn: {},
            GlobalNetworkId: {},
            Description: {},
            Location: {
              shape: "S26"
            },
            CreatedAt: {
              type: "timestamp"
            },
            State: {},
            Tags: {
              shape: "Se"
            }
          }
        },
        S2v: {
          type: "structure",
          members: {
            Attachment: {
              shape: "S4"
            },
            VpnConnectionArn: {}
          }
        },
        S2z: {
          type: "structure",
          members: {
            Peering: {
              shape: "S30"
            },
            TransitGatewayArn: {},
            TransitGatewayPeeringAttachmentId: {}
          }
        },
        S30: {
          type: "structure",
          members: {
            CoreNetworkId: {},
            CoreNetworkArn: {},
            PeeringId: {},
            OwnerAccountId: {},
            PeeringType: {},
            State: {},
            EdgeLocation: {},
            ResourceArn: {},
            Tags: {
              shape: "Se"
            },
            CreatedAt: {
              type: "timestamp"
            }
          }
        },
        S38: {
          type: "structure",
          members: {
            Attachment: {
              shape: "S4"
            },
            PeeringId: {},
            TransitGatewayRouteTableArn: {}
          }
        },
        S3b: {
          type: "list",
          member: {}
        },
        S3c: {
          type: "structure",
          members: {
            Ipv6Support: {
              type: "boolean"
            },
            ApplianceModeSupport: {
              type: "boolean"
            }
          }
        },
        S3f: {
          type: "structure",
          members: {
            Attachment: {
              shape: "S4"
            },
            SubnetArns: {
              shape: "S3b"
            },
            Options: {
              shape: "S3c"
            }
          }
        },
        S3q: {
          type: "structure",
          members: {
            CoreNetworkId: {},
            PolicyVersionId: {
              type: "integer"
            },
            Alias: {},
            Description: {},
            CreatedAt: {
              type: "timestamp"
            },
            ChangeSetState: {},
            PolicyErrors: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "ErrorCode",
                  "Message"
                ],
                members: {
                  ErrorCode: {},
                  Message: {},
                  Path: {}
                }
              }
            },
            PolicyDocument: {
              jsonvalue: true
            }
          }
        },
        S4a: {
          type: "structure",
          members: {
            GlobalNetworkId: {},
            TransitGatewayArn: {},
            State: {
              type: "structure",
              members: {
                Code: {},
                Message: {}
              }
            }
          }
        },
        S5j: {
          type: "structure",
          members: {
            SegmentName: {},
            EdgeLocations: {
              shape: "S21"
            },
            Asn: {
              type: "long"
            },
            Cidr: {},
            DestinationIdentifier: {},
            InsideCidrBlocks: {
              shape: "S1g"
            },
            SharedSegments: {
              shape: "S1g"
            }
          }
        },
        S6d: {
          type: "map",
          key: {},
          value: {}
        },
        S6g: {
          type: "structure",
          members: {
            CoreNetworkId: {},
            SegmentName: {},
            EdgeLocation: {}
          }
        },
        S78: {
          type: "structure",
          members: {
            GlobalNetworkId: {},
            OwnerAccountId: {},
            RouteAnalysisId: {},
            StartTimestamp: {
              type: "timestamp"
            },
            Status: {},
            Source: {
              shape: "S7a"
            },
            Destination: {
              shape: "S7a"
            },
            IncludeReturnPath: {
              type: "boolean"
            },
            UseMiddleboxes: {
              type: "boolean"
            },
            ForwardPath: {
              shape: "S7c"
            },
            ReturnPath: {
              shape: "S7c"
            }
          }
        },
        S7a: {
          type: "structure",
          members: {
            TransitGatewayAttachmentArn: {},
            TransitGatewayArn: {},
            IpAddress: {}
          }
        },
        S7c: {
          type: "structure",
          members: {
            CompletionStatus: {
              type: "structure",
              members: {
                ResultCode: {},
                ReasonCode: {},
                ReasonContext: {
                  type: "map",
                  key: {},
                  value: {}
                }
              }
            },
            Path: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Sequence: {
                    type: "integer"
                  },
                  Resource: {
                    type: "structure",
                    members: {
                      RegisteredGatewayArn: {},
                      ResourceArn: {},
                      ResourceType: {},
                      Definition: {},
                      NameTag: {},
                      IsMiddlebox: {
                        type: "boolean"
                      }
                    }
                  },
                  DestinationCidrBlock: {}
                }
              }
            }
          }
        },
        S8n: {
          type: "structure",
          members: {
            OrganizationId: {},
            OrganizationAwsServiceAccessStatus: {},
            SLRDeploymentStatus: {},
            AccountStatusList: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  AccountId: {},
                  SLRDeploymentStatus: {}
                }
              }
            }
          }
        },
        S9d: {
          type: "structure",
          members: {
            TransitGatewayAttachmentArn: {},
            IpAddress: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/networkmanager-2019-07-05.paginators.json
var require_networkmanager_2019_07_05_paginators = __commonJS({
  "node_modules/aws-sdk/apis/networkmanager-2019-07-05.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeGlobalNetworks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "GlobalNetworks"
        },
        GetConnectPeerAssociations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ConnectPeerAssociations"
        },
        GetConnections: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Connections"
        },
        GetCoreNetworkChangeEvents: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "CoreNetworkChangeEvents"
        },
        GetCoreNetworkChangeSet: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "CoreNetworkChanges"
        },
        GetCustomerGatewayAssociations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "CustomerGatewayAssociations"
        },
        GetDevices: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Devices"
        },
        GetLinkAssociations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "LinkAssociations"
        },
        GetLinks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Links"
        },
        GetNetworkResourceCounts: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "NetworkResourceCounts"
        },
        GetNetworkResourceRelationships: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Relationships"
        },
        GetNetworkResources: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "NetworkResources"
        },
        GetNetworkTelemetry: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "NetworkTelemetry"
        },
        GetSites: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Sites"
        },
        GetTransitGatewayConnectPeerAssociations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "TransitGatewayConnectPeerAssociations"
        },
        GetTransitGatewayRegistrations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "TransitGatewayRegistrations"
        },
        ListAttachments: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Attachments"
        },
        ListConnectPeers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ConnectPeers"
        },
        ListCoreNetworkPolicyVersions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "CoreNetworkPolicyVersions"
        },
        ListCoreNetworks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "CoreNetworks"
        },
        ListPeerings: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Peerings"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/networkmanager.js
var require_networkmanager = __commonJS({
  "node_modules/aws-sdk/clients/networkmanager.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["networkmanager"] = {};
    AWS2.NetworkManager = Service.defineService("networkmanager", ["2019-07-05"]);
    Object.defineProperty(apiLoader.services["networkmanager"], "2019-07-05", {
      get: function get() {
        var model = require_networkmanager_2019_07_05_min();
        model.paginators = require_networkmanager_2019_07_05_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.NetworkManager;
  }
});

// node_modules/aws-sdk/apis/outposts-2019-12-03.min.json
var require_outposts_2019_12_03_min = __commonJS({
  "node_modules/aws-sdk/apis/outposts-2019-12-03.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-12-03",
        endpointPrefix: "outposts",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Outposts",
        serviceFullName: "AWS Outposts",
        serviceId: "Outposts",
        signatureVersion: "v4",
        signingName: "outposts",
        uid: "outposts-2019-12-03"
      },
      operations: {
        CancelOrder: {
          http: {
            requestUri: "/orders/{OrderId}/cancel"
          },
          input: {
            type: "structure",
            required: [
              "OrderId"
            ],
            members: {
              OrderId: {
                location: "uri",
                locationName: "OrderId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateOrder: {
          http: {
            requestUri: "/orders"
          },
          input: {
            type: "structure",
            required: [
              "OutpostIdentifier",
              "LineItems",
              "PaymentOption"
            ],
            members: {
              OutpostIdentifier: {},
              LineItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CatalogItemId: {},
                    Quantity: {
                      type: "integer"
                    }
                  }
                }
              },
              PaymentOption: {},
              PaymentTerm: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Order: {
                shape: "Sd"
              }
            }
          }
        },
        CreateOutpost: {
          http: {
            requestUri: "/outposts"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "SiteId"
            ],
            members: {
              Name: {},
              Description: {},
              SiteId: {},
              AvailabilityZone: {},
              AvailabilityZoneId: {},
              Tags: {
                shape: "S10"
              },
              SupportedHardwareType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Outpost: {
                shape: "S15"
              }
            }
          }
        },
        CreateSite: {
          http: {
            requestUri: "/sites"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Description: {},
              Notes: {},
              Tags: {
                shape: "S10"
              },
              OperatingAddress: {
                shape: "S1f"
              },
              ShippingAddress: {
                shape: "S1f"
              },
              RackPhysicalProperties: {
                shape: "S1r"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Site: {
                shape: "S22"
              }
            }
          }
        },
        DeleteOutpost: {
          http: {
            method: "DELETE",
            requestUri: "/outposts/{OutpostId}"
          },
          input: {
            type: "structure",
            required: [
              "OutpostId"
            ],
            members: {
              OutpostId: {
                location: "uri",
                locationName: "OutpostId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSite: {
          http: {
            method: "DELETE",
            requestUri: "/sites/{SiteId}"
          },
          input: {
            type: "structure",
            required: [
              "SiteId"
            ],
            members: {
              SiteId: {
                location: "uri",
                locationName: "SiteId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetCatalogItem: {
          http: {
            method: "GET",
            requestUri: "/catalog/item/{CatalogItemId}"
          },
          input: {
            type: "structure",
            required: [
              "CatalogItemId"
            ],
            members: {
              CatalogItemId: {
                location: "uri",
                locationName: "CatalogItemId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CatalogItem: {
                shape: "S2a"
              }
            }
          }
        },
        GetConnection: {
          http: {
            method: "GET",
            requestUri: "/connections/{ConnectionId}"
          },
          input: {
            type: "structure",
            required: [
              "ConnectionId"
            ],
            members: {
              ConnectionId: {
                location: "uri",
                locationName: "ConnectionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionId: {},
              ConnectionDetails: {
                type: "structure",
                members: {
                  ClientPublicKey: {},
                  ServerPublicKey: {},
                  ServerEndpoint: {},
                  ClientTunnelAddress: {},
                  ServerTunnelAddress: {},
                  AllowedIps: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          }
        },
        GetOrder: {
          http: {
            method: "GET",
            requestUri: "/orders/{OrderId}"
          },
          input: {
            type: "structure",
            required: [
              "OrderId"
            ],
            members: {
              OrderId: {
                location: "uri",
                locationName: "OrderId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Order: {
                shape: "Sd"
              }
            }
          }
        },
        GetOutpost: {
          http: {
            method: "GET",
            requestUri: "/outposts/{OutpostId}"
          },
          input: {
            type: "structure",
            required: [
              "OutpostId"
            ],
            members: {
              OutpostId: {
                location: "uri",
                locationName: "OutpostId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Outpost: {
                shape: "S15"
              }
            }
          }
        },
        GetOutpostInstanceTypes: {
          http: {
            method: "GET",
            requestUri: "/outposts/{OutpostId}/instanceTypes"
          },
          input: {
            type: "structure",
            required: [
              "OutpostId"
            ],
            members: {
              OutpostId: {
                location: "uri",
                locationName: "OutpostId"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceTypes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InstanceType: {}
                  }
                }
              },
              NextToken: {},
              OutpostId: {},
              OutpostArn: {}
            }
          }
        },
        GetSite: {
          http: {
            method: "GET",
            requestUri: "/sites/{SiteId}"
          },
          input: {
            type: "structure",
            required: [
              "SiteId"
            ],
            members: {
              SiteId: {
                location: "uri",
                locationName: "SiteId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Site: {
                shape: "S22"
              }
            }
          }
        },
        GetSiteAddress: {
          http: {
            method: "GET",
            requestUri: "/sites/{SiteId}/address"
          },
          input: {
            type: "structure",
            required: [
              "SiteId",
              "AddressType"
            ],
            members: {
              SiteId: {
                location: "uri",
                locationName: "SiteId"
              },
              AddressType: {
                location: "querystring",
                locationName: "AddressType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SiteId: {},
              AddressType: {},
              Address: {
                shape: "S1f"
              }
            }
          }
        },
        ListAssets: {
          http: {
            method: "GET",
            requestUri: "/outposts/{OutpostId}/assets"
          },
          input: {
            type: "structure",
            required: [
              "OutpostIdentifier"
            ],
            members: {
              OutpostIdentifier: {
                location: "uri",
                locationName: "OutpostId"
              },
              HostIdFilter: {
                location: "querystring",
                locationName: "HostIdFilter",
                type: "list",
                member: {}
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              StatusFilter: {
                location: "querystring",
                locationName: "StatusFilter",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Assets: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AssetId: {},
                    RackId: {},
                    AssetType: {},
                    ComputeAttributes: {
                      type: "structure",
                      members: {
                        HostId: {},
                        State: {},
                        InstanceFamilies: {
                          type: "list",
                          member: {}
                        }
                      }
                    },
                    AssetLocation: {
                      type: "structure",
                      members: {
                        RackElevation: {
                          type: "float"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListCatalogItems: {
          http: {
            method: "GET",
            requestUri: "/catalog/items"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              ItemClassFilter: {
                location: "querystring",
                locationName: "ItemClassFilter",
                type: "list",
                member: {}
              },
              SupportedStorageFilter: {
                shape: "S2l",
                location: "querystring",
                locationName: "SupportedStorageFilter"
              },
              EC2FamilyFilter: {
                location: "querystring",
                locationName: "EC2FamilyFilter",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CatalogItems: {
                type: "list",
                member: {
                  shape: "S2a"
                }
              },
              NextToken: {}
            }
          }
        },
        ListOrders: {
          http: {
            method: "GET",
            requestUri: "/list-orders"
          },
          input: {
            type: "structure",
            members: {
              OutpostIdentifierFilter: {
                location: "querystring",
                locationName: "OutpostIdentifierFilter"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Orders: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    OutpostId: {},
                    OrderId: {},
                    OrderType: {},
                    Status: {},
                    LineItemCountsByStatus: {
                      type: "map",
                      key: {},
                      value: {
                        type: "integer"
                      }
                    },
                    OrderSubmissionDate: {
                      type: "timestamp"
                    },
                    OrderFulfilledDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListOutposts: {
          http: {
            method: "GET",
            requestUri: "/outposts"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              LifeCycleStatusFilter: {
                location: "querystring",
                locationName: "LifeCycleStatusFilter",
                type: "list",
                member: {}
              },
              AvailabilityZoneFilter: {
                location: "querystring",
                locationName: "AvailabilityZoneFilter",
                type: "list",
                member: {}
              },
              AvailabilityZoneIdFilter: {
                location: "querystring",
                locationName: "AvailabilityZoneIdFilter",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Outposts: {
                type: "list",
                member: {
                  shape: "S15"
                }
              },
              NextToken: {}
            }
          }
        },
        ListSites: {
          http: {
            method: "GET",
            requestUri: "/sites"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              OperatingAddressCountryCodeFilter: {
                location: "querystring",
                locationName: "OperatingAddressCountryCodeFilter",
                type: "list",
                member: {}
              },
              OperatingAddressStateOrRegionFilter: {
                location: "querystring",
                locationName: "OperatingAddressStateOrRegionFilter",
                type: "list",
                member: {}
              },
              OperatingAddressCityFilter: {
                location: "querystring",
                locationName: "OperatingAddressCityFilter",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Sites: {
                type: "list",
                member: {
                  shape: "S22"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{ResourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S10"
              }
            }
          }
        },
        StartConnection: {
          http: {
            requestUri: "/connections"
          },
          input: {
            type: "structure",
            required: [
              "DeviceSerialNumber",
              "AssetId",
              "ClientPublicKey",
              "NetworkInterfaceDeviceIndex"
            ],
            members: {
              DeviceSerialNumber: {},
              AssetId: {},
              ClientPublicKey: {},
              NetworkInterfaceDeviceIndex: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionId: {},
              UnderlayIpAddress: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{ResourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{ResourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateOutpost: {
          http: {
            method: "PATCH",
            requestUri: "/outposts/{OutpostId}"
          },
          input: {
            type: "structure",
            required: [
              "OutpostId"
            ],
            members: {
              OutpostId: {
                location: "uri",
                locationName: "OutpostId"
              },
              Name: {},
              Description: {},
              SupportedHardwareType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Outpost: {
                shape: "S15"
              }
            }
          }
        },
        UpdateSite: {
          http: {
            method: "PATCH",
            requestUri: "/sites/{SiteId}"
          },
          input: {
            type: "structure",
            required: [
              "SiteId"
            ],
            members: {
              SiteId: {
                location: "uri",
                locationName: "SiteId"
              },
              Name: {},
              Description: {},
              Notes: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Site: {
                shape: "S22"
              }
            }
          }
        },
        UpdateSiteAddress: {
          http: {
            method: "PUT",
            requestUri: "/sites/{SiteId}/address"
          },
          input: {
            type: "structure",
            required: [
              "SiteId",
              "AddressType",
              "Address"
            ],
            members: {
              SiteId: {
                location: "uri",
                locationName: "SiteId"
              },
              AddressType: {},
              Address: {
                shape: "S1f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AddressType: {},
              Address: {
                shape: "S1f"
              }
            }
          }
        },
        UpdateSiteRackPhysicalProperties: {
          http: {
            method: "PATCH",
            requestUri: "/sites/{SiteId}/rackPhysicalProperties"
          },
          input: {
            type: "structure",
            required: [
              "SiteId"
            ],
            members: {
              SiteId: {
                location: "uri",
                locationName: "SiteId"
              },
              PowerDrawKva: {},
              PowerPhase: {},
              PowerConnector: {},
              PowerFeedDrop: {},
              UplinkGbps: {},
              UplinkCount: {},
              FiberOpticCableType: {},
              OpticalStandard: {},
              MaximumSupportedWeightLbs: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Site: {
                shape: "S22"
              }
            }
          }
        }
      },
      shapes: {
        Sd: {
          type: "structure",
          members: {
            OutpostId: {},
            OrderId: {},
            Status: {},
            LineItems: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  CatalogItemId: {},
                  LineItemId: {},
                  Quantity: {
                    type: "integer"
                  },
                  Status: {},
                  ShipmentInformation: {
                    type: "structure",
                    members: {
                      ShipmentTrackingNumber: {},
                      ShipmentCarrier: {}
                    }
                  },
                  AssetInformationList: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        AssetId: {},
                        MacAddressList: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  },
                  PreviousLineItemId: {},
                  PreviousOrderId: {}
                }
              }
            },
            PaymentOption: {},
            OrderSubmissionDate: {
              type: "timestamp"
            },
            OrderFulfilledDate: {
              type: "timestamp"
            },
            PaymentTerm: {},
            OrderType: {}
          }
        },
        S10: {
          type: "map",
          key: {},
          value: {}
        },
        S15: {
          type: "structure",
          members: {
            OutpostId: {},
            OwnerId: {},
            OutpostArn: {},
            SiteId: {},
            Name: {},
            Description: {},
            LifeCycleStatus: {},
            AvailabilityZone: {},
            AvailabilityZoneId: {},
            Tags: {
              shape: "S10"
            },
            SiteArn: {},
            SupportedHardwareType: {}
          }
        },
        S1f: {
          type: "structure",
          required: [
            "AddressLine1",
            "City",
            "StateOrRegion",
            "PostalCode",
            "CountryCode"
          ],
          members: {
            ContactName: {},
            ContactPhoneNumber: {},
            AddressLine1: {},
            AddressLine2: {},
            AddressLine3: {},
            City: {},
            StateOrRegion: {},
            DistrictOrCounty: {},
            PostalCode: {},
            CountryCode: {},
            Municipality: {}
          }
        },
        S1r: {
          type: "structure",
          members: {
            PowerDrawKva: {},
            PowerPhase: {},
            PowerConnector: {},
            PowerFeedDrop: {},
            UplinkGbps: {},
            UplinkCount: {},
            FiberOpticCableType: {},
            OpticalStandard: {},
            MaximumSupportedWeightLbs: {}
          }
        },
        S22: {
          type: "structure",
          members: {
            SiteId: {},
            AccountId: {},
            Name: {},
            Description: {},
            Tags: {
              shape: "S10"
            },
            SiteArn: {},
            Notes: {},
            OperatingAddressCountryCode: {},
            OperatingAddressStateOrRegion: {},
            OperatingAddressCity: {},
            RackPhysicalProperties: {
              shape: "S1r"
            }
          }
        },
        S2a: {
          type: "structure",
          members: {
            CatalogItemId: {},
            ItemStatus: {},
            EC2Capacities: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Family: {},
                  MaxSize: {},
                  Quantity: {}
                }
              }
            },
            PowerKva: {
              type: "float"
            },
            WeightLbs: {
              type: "integer"
            },
            SupportedUplinkGbps: {
              type: "list",
              member: {
                type: "integer"
              }
            },
            SupportedStorage: {
              shape: "S2l"
            }
          }
        },
        S2l: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/outposts-2019-12-03.paginators.json
var require_outposts_2019_12_03_paginators = __commonJS({
  "node_modules/aws-sdk/apis/outposts-2019-12-03.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetOutpostInstanceTypes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "InstanceTypes"
        },
        ListAssets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Assets"
        },
        ListCatalogItems: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "CatalogItems"
        },
        ListOrders: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Orders"
        },
        ListOutposts: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Outposts"
        },
        ListSites: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Sites"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/outposts.js
var require_outposts = __commonJS({
  "node_modules/aws-sdk/clients/outposts.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["outposts"] = {};
    AWS2.Outposts = Service.defineService("outposts", ["2019-12-03"]);
    Object.defineProperty(apiLoader.services["outposts"], "2019-12-03", {
      get: function get() {
        var model = require_outposts_2019_12_03_min();
        model.paginators = require_outposts_2019_12_03_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Outposts;
  }
});

// node_modules/aws-sdk/apis/sagemaker-a2i-runtime-2019-11-07.min.json
var require_sagemaker_a2i_runtime_2019_11_07_min = __commonJS({
  "node_modules/aws-sdk/apis/sagemaker-a2i-runtime-2019-11-07.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-11-07",
        endpointPrefix: "a2i-runtime.sagemaker",
        protocol: "rest-json",
        serviceFullName: "Amazon Augmented AI Runtime",
        serviceId: "SageMaker A2I Runtime",
        signatureVersion: "v4",
        signingName: "sagemaker",
        uid: "sagemaker-a2i-runtime-2019-11-07"
      },
      operations: {
        DeleteHumanLoop: {
          http: {
            method: "DELETE",
            requestUri: "/human-loops/{HumanLoopName}"
          },
          input: {
            type: "structure",
            required: [
              "HumanLoopName"
            ],
            members: {
              HumanLoopName: {
                location: "uri",
                locationName: "HumanLoopName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeHumanLoop: {
          http: {
            method: "GET",
            requestUri: "/human-loops/{HumanLoopName}"
          },
          input: {
            type: "structure",
            required: [
              "HumanLoopName"
            ],
            members: {
              HumanLoopName: {
                location: "uri",
                locationName: "HumanLoopName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CreationTime",
              "HumanLoopStatus",
              "HumanLoopName",
              "HumanLoopArn",
              "FlowDefinitionArn"
            ],
            members: {
              CreationTime: {
                shape: "S6"
              },
              FailureReason: {},
              FailureCode: {},
              HumanLoopStatus: {},
              HumanLoopName: {},
              HumanLoopArn: {},
              FlowDefinitionArn: {},
              HumanLoopOutput: {
                type: "structure",
                required: [
                  "OutputS3Uri"
                ],
                members: {
                  OutputS3Uri: {}
                }
              }
            }
          }
        },
        ListHumanLoops: {
          http: {
            method: "GET",
            requestUri: "/human-loops"
          },
          input: {
            type: "structure",
            required: [
              "FlowDefinitionArn"
            ],
            members: {
              CreationTimeAfter: {
                shape: "S6",
                location: "querystring",
                locationName: "CreationTimeAfter"
              },
              CreationTimeBefore: {
                shape: "S6",
                location: "querystring",
                locationName: "CreationTimeBefore"
              },
              FlowDefinitionArn: {
                location: "querystring",
                locationName: "FlowDefinitionArn"
              },
              SortOrder: {
                location: "querystring",
                locationName: "SortOrder"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HumanLoopSummaries"
            ],
            members: {
              HumanLoopSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    HumanLoopName: {},
                    HumanLoopStatus: {},
                    CreationTime: {
                      shape: "S6"
                    },
                    FailureReason: {},
                    FlowDefinitionArn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        StartHumanLoop: {
          http: {
            requestUri: "/human-loops"
          },
          input: {
            type: "structure",
            required: [
              "HumanLoopName",
              "FlowDefinitionArn",
              "HumanLoopInput"
            ],
            members: {
              HumanLoopName: {},
              FlowDefinitionArn: {},
              HumanLoopInput: {
                type: "structure",
                required: [
                  "InputContent"
                ],
                members: {
                  InputContent: {}
                }
              },
              DataAttributes: {
                type: "structure",
                required: [
                  "ContentClassifiers"
                ],
                members: {
                  ContentClassifiers: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HumanLoopArn: {}
            }
          }
        },
        StopHumanLoop: {
          http: {
            requestUri: "/human-loops/stop"
          },
          input: {
            type: "structure",
            required: [
              "HumanLoopName"
            ],
            members: {
              HumanLoopName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S6: {
          type: "timestamp",
          timestampFormat: "iso8601"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/sagemaker-a2i-runtime-2019-11-07.paginators.json
var require_sagemaker_a2i_runtime_2019_11_07_paginators = __commonJS({
  "node_modules/aws-sdk/apis/sagemaker-a2i-runtime-2019-11-07.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListHumanLoops: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "HumanLoopSummaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/augmentedairuntime.js
var require_augmentedairuntime = __commonJS({
  "node_modules/aws-sdk/clients/augmentedairuntime.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["augmentedairuntime"] = {};
    AWS2.AugmentedAIRuntime = Service.defineService("augmentedairuntime", ["2019-11-07"]);
    Object.defineProperty(apiLoader.services["augmentedairuntime"], "2019-11-07", {
      get: function get() {
        var model = require_sagemaker_a2i_runtime_2019_11_07_min();
        model.paginators = require_sagemaker_a2i_runtime_2019_11_07_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.AugmentedAIRuntime;
  }
});

// node_modules/aws-sdk/apis/ebs-2019-11-02.min.json
var require_ebs_2019_11_02_min = __commonJS({
  "node_modules/aws-sdk/apis/ebs-2019-11-02.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-11-02",
        endpointPrefix: "ebs",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Amazon EBS",
        serviceFullName: "Amazon Elastic Block Store",
        serviceId: "EBS",
        signatureVersion: "v4",
        uid: "ebs-2019-11-02"
      },
      operations: {
        CompleteSnapshot: {
          http: {
            requestUri: "/snapshots/completion/{snapshotId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "SnapshotId",
              "ChangedBlocksCount"
            ],
            members: {
              SnapshotId: {
                location: "uri",
                locationName: "snapshotId"
              },
              ChangedBlocksCount: {
                location: "header",
                locationName: "x-amz-ChangedBlocksCount",
                type: "integer"
              },
              Checksum: {
                location: "header",
                locationName: "x-amz-Checksum"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-Checksum-Algorithm"
              },
              ChecksumAggregationMethod: {
                location: "header",
                locationName: "x-amz-Checksum-Aggregation-Method"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {}
            }
          }
        },
        GetSnapshotBlock: {
          http: {
            method: "GET",
            requestUri: "/snapshots/{snapshotId}/blocks/{blockIndex}"
          },
          input: {
            type: "structure",
            required: [
              "SnapshotId",
              "BlockIndex",
              "BlockToken"
            ],
            members: {
              SnapshotId: {
                location: "uri",
                locationName: "snapshotId"
              },
              BlockIndex: {
                location: "uri",
                locationName: "blockIndex",
                type: "integer"
              },
              BlockToken: {
                location: "querystring",
                locationName: "blockToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataLength: {
                location: "header",
                locationName: "x-amz-Data-Length",
                type: "integer"
              },
              BlockData: {
                shape: "Se"
              },
              Checksum: {
                location: "header",
                locationName: "x-amz-Checksum"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-Checksum-Algorithm"
              }
            },
            payload: "BlockData"
          }
        },
        ListChangedBlocks: {
          http: {
            method: "GET",
            requestUri: "/snapshots/{secondSnapshotId}/changedblocks"
          },
          input: {
            type: "structure",
            required: [
              "SecondSnapshotId"
            ],
            members: {
              FirstSnapshotId: {
                location: "querystring",
                locationName: "firstSnapshotId"
              },
              SecondSnapshotId: {
                location: "uri",
                locationName: "secondSnapshotId"
              },
              NextToken: {
                location: "querystring",
                locationName: "pageToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              StartingBlockIndex: {
                location: "querystring",
                locationName: "startingBlockIndex",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangedBlocks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    BlockIndex: {
                      type: "integer"
                    },
                    FirstBlockToken: {},
                    SecondBlockToken: {}
                  },
                  sensitive: true
                }
              },
              ExpiryTime: {
                type: "timestamp"
              },
              VolumeSize: {
                type: "long"
              },
              BlockSize: {
                type: "integer"
              },
              NextToken: {}
            }
          }
        },
        ListSnapshotBlocks: {
          http: {
            method: "GET",
            requestUri: "/snapshots/{snapshotId}/blocks"
          },
          input: {
            type: "structure",
            required: [
              "SnapshotId"
            ],
            members: {
              SnapshotId: {
                location: "uri",
                locationName: "snapshotId"
              },
              NextToken: {
                location: "querystring",
                locationName: "pageToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              StartingBlockIndex: {
                location: "querystring",
                locationName: "startingBlockIndex",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Blocks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    BlockIndex: {
                      type: "integer"
                    },
                    BlockToken: {}
                  }
                },
                sensitive: true
              },
              ExpiryTime: {
                type: "timestamp"
              },
              VolumeSize: {
                type: "long"
              },
              BlockSize: {
                type: "integer"
              },
              NextToken: {}
            }
          }
        },
        PutSnapshotBlock: {
          http: {
            method: "PUT",
            requestUri: "/snapshots/{snapshotId}/blocks/{blockIndex}",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "SnapshotId",
              "BlockIndex",
              "BlockData",
              "DataLength",
              "Checksum",
              "ChecksumAlgorithm"
            ],
            members: {
              SnapshotId: {
                location: "uri",
                locationName: "snapshotId"
              },
              BlockIndex: {
                location: "uri",
                locationName: "blockIndex",
                type: "integer"
              },
              BlockData: {
                shape: "Se"
              },
              DataLength: {
                location: "header",
                locationName: "x-amz-Data-Length",
                type: "integer"
              },
              Progress: {
                location: "header",
                locationName: "x-amz-Progress",
                type: "integer"
              },
              Checksum: {
                location: "header",
                locationName: "x-amz-Checksum"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-Checksum-Algorithm"
              }
            },
            payload: "BlockData"
          },
          output: {
            type: "structure",
            members: {
              Checksum: {
                location: "header",
                locationName: "x-amz-Checksum"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-Checksum-Algorithm"
              }
            }
          },
          authtype: "v4-unsigned-body"
        },
        StartSnapshot: {
          http: {
            requestUri: "/snapshots",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "VolumeSize"
            ],
            members: {
              VolumeSize: {
                type: "long"
              },
              ParentSnapshotId: {},
              Tags: {
                shape: "Sw"
              },
              Description: {},
              ClientToken: {
                idempotencyToken: true
              },
              Encrypted: {
                type: "boolean"
              },
              KmsKeyArn: {
                shape: "S13"
              },
              Timeout: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Description: {},
              SnapshotId: {},
              OwnerId: {},
              Status: {},
              StartTime: {
                type: "timestamp"
              },
              VolumeSize: {
                type: "long"
              },
              BlockSize: {
                type: "integer"
              },
              Tags: {
                shape: "Sw"
              },
              ParentSnapshotId: {},
              KmsKeyArn: {
                shape: "S13"
              },
              SseType: {}
            }
          }
        }
      },
      shapes: {
        Se: {
          type: "blob",
          sensitive: true,
          streaming: true
        },
        Sw: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S13: {
          type: "string",
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ebs-2019-11-02.paginators.json
var require_ebs_2019_11_02_paginators = __commonJS({
  "node_modules/aws-sdk/apis/ebs-2019-11-02.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListChangedBlocks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListSnapshotBlocks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/ebs.js
var require_ebs = __commonJS({
  "node_modules/aws-sdk/clients/ebs.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["ebs"] = {};
    AWS2.EBS = Service.defineService("ebs", ["2019-11-02"]);
    Object.defineProperty(apiLoader.services["ebs"], "2019-11-02", {
      get: function get() {
        var model = require_ebs_2019_11_02_min();
        model.paginators = require_ebs_2019_11_02_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.EBS;
  }
});

// node_modules/aws-sdk/apis/kinesis-video-signaling-2019-12-04.min.json
var require_kinesis_video_signaling_2019_12_04_min = __commonJS({
  "node_modules/aws-sdk/apis/kinesis-video-signaling-2019-12-04.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-12-04",
        endpointPrefix: "kinesisvideo",
        protocol: "rest-json",
        serviceAbbreviation: "Amazon Kinesis Video Signaling Channels",
        serviceFullName: "Amazon Kinesis Video Signaling Channels",
        serviceId: "Kinesis Video Signaling",
        signatureVersion: "v4",
        uid: "kinesis-video-signaling-2019-12-04"
      },
      operations: {
        GetIceServerConfig: {
          http: {
            requestUri: "/v1/get-ice-server-config"
          },
          input: {
            type: "structure",
            required: [
              "ChannelARN"
            ],
            members: {
              ChannelARN: {},
              ClientId: {},
              Service: {},
              Username: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IceServerList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Uris: {
                      type: "list",
                      member: {}
                    },
                    Username: {},
                    Password: {},
                    Ttl: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        SendAlexaOfferToMaster: {
          http: {
            requestUri: "/v1/send-alexa-offer-to-master"
          },
          input: {
            type: "structure",
            required: [
              "ChannelARN",
              "SenderClientId",
              "MessagePayload"
            ],
            members: {
              ChannelARN: {},
              SenderClientId: {},
              MessagePayload: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Answer: {}
            }
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/apis/kinesis-video-signaling-2019-12-04.paginators.json
var require_kinesis_video_signaling_2019_12_04_paginators = __commonJS({
  "node_modules/aws-sdk/apis/kinesis-video-signaling-2019-12-04.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/kinesisvideosignalingchannels.js
var require_kinesisvideosignalingchannels = __commonJS({
  "node_modules/aws-sdk/clients/kinesisvideosignalingchannels.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["kinesisvideosignalingchannels"] = {};
    AWS2.KinesisVideoSignalingChannels = Service.defineService("kinesisvideosignalingchannels", ["2019-12-04"]);
    Object.defineProperty(apiLoader.services["kinesisvideosignalingchannels"], "2019-12-04", {
      get: function get() {
        var model = require_kinesis_video_signaling_2019_12_04_min();
        model.paginators = require_kinesis_video_signaling_2019_12_04_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.KinesisVideoSignalingChannels;
  }
});

// node_modules/aws-sdk/apis/detective-2018-10-26.min.json
var require_detective_2018_10_26_min = __commonJS({
  "node_modules/aws-sdk/apis/detective-2018-10-26.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-10-26",
        endpointPrefix: "api.detective",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Detective",
        serviceId: "Detective",
        signatureVersion: "v4",
        signingName: "detective",
        uid: "detective-2018-10-26"
      },
      operations: {
        AcceptInvitation: {
          http: {
            method: "PUT",
            requestUri: "/invitation"
          },
          input: {
            type: "structure",
            required: [
              "GraphArn"
            ],
            members: {
              GraphArn: {}
            }
          }
        },
        BatchGetGraphMemberDatasources: {
          http: {
            requestUri: "/graph/datasources/get"
          },
          input: {
            type: "structure",
            required: [
              "GraphArn",
              "AccountIds"
            ],
            members: {
              GraphArn: {},
              AccountIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MemberDatasources: {
                shape: "S7"
              },
              UnprocessedAccounts: {
                shape: "Sf"
              }
            }
          }
        },
        BatchGetMembershipDatasources: {
          http: {
            requestUri: "/membership/datasources/get"
          },
          input: {
            type: "structure",
            required: [
              "GraphArns"
            ],
            members: {
              GraphArns: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MembershipDatasources: {
                shape: "S7"
              },
              UnprocessedGraphs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    GraphArn: {},
                    Reason: {}
                  }
                }
              }
            }
          }
        },
        CreateGraph: {
          http: {
            requestUri: "/graph"
          },
          input: {
            type: "structure",
            members: {
              Tags: {
                shape: "So"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GraphArn: {}
            }
          }
        },
        CreateMembers: {
          http: {
            requestUri: "/graph/members"
          },
          input: {
            type: "structure",
            required: [
              "GraphArn",
              "Accounts"
            ],
            members: {
              GraphArn: {},
              Message: {
                type: "string",
                sensitive: true
              },
              DisableEmailNotification: {
                type: "boolean"
              },
              Accounts: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AccountId",
                    "EmailAddress"
                  ],
                  members: {
                    AccountId: {},
                    EmailAddress: {
                      shape: "Sx"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Members: {
                shape: "Sz"
              },
              UnprocessedAccounts: {
                shape: "Sf"
              }
            }
          }
        },
        DeleteGraph: {
          http: {
            requestUri: "/graph/removal"
          },
          input: {
            type: "structure",
            required: [
              "GraphArn"
            ],
            members: {
              GraphArn: {}
            }
          }
        },
        DeleteMembers: {
          http: {
            requestUri: "/graph/members/removal"
          },
          input: {
            type: "structure",
            required: [
              "GraphArn",
              "AccountIds"
            ],
            members: {
              GraphArn: {},
              AccountIds: {
                shape: "S1b"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccountIds: {
                shape: "S1b"
              },
              UnprocessedAccounts: {
                shape: "Sf"
              }
            }
          }
        },
        DescribeOrganizationConfiguration: {
          http: {
            requestUri: "/orgs/describeOrganizationConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "GraphArn"
            ],
            members: {
              GraphArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AutoEnable: {
                type: "boolean"
              }
            }
          }
        },
        DisableOrganizationAdminAccount: {
          http: {
            requestUri: "/orgs/disableAdminAccount"
          }
        },
        DisassociateMembership: {
          http: {
            requestUri: "/membership/removal"
          },
          input: {
            type: "structure",
            required: [
              "GraphArn"
            ],
            members: {
              GraphArn: {}
            }
          }
        },
        EnableOrganizationAdminAccount: {
          http: {
            requestUri: "/orgs/enableAdminAccount"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {}
            }
          }
        },
        GetInvestigation: {
          http: {
            requestUri: "/investigations/getInvestigation"
          },
          input: {
            type: "structure",
            required: [
              "GraphArn",
              "InvestigationId"
            ],
            members: {
              GraphArn: {},
              InvestigationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GraphArn: {},
              InvestigationId: {},
              EntityArn: {},
              EntityType: {},
              CreatedTime: {
                shape: "Se"
              },
              ScopeStartTime: {
                shape: "Se"
              },
              ScopeEndTime: {
                shape: "Se"
              },
              Status: {},
              Severity: {},
              State: {}
            }
          }
        },
        GetMembers: {
          http: {
            requestUri: "/graph/members/get"
          },
          input: {
            type: "structure",
            required: [
              "GraphArn",
              "AccountIds"
            ],
            members: {
              GraphArn: {},
              AccountIds: {
                shape: "S1b"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MemberDetails: {
                shape: "Sz"
              },
              UnprocessedAccounts: {
                shape: "Sf"
              }
            }
          }
        },
        ListDatasourcePackages: {
          http: {
            requestUri: "/graph/datasources/list"
          },
          input: {
            type: "structure",
            required: [
              "GraphArn"
            ],
            members: {
              GraphArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DatasourcePackages: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    DatasourcePackageIngestState: {},
                    LastIngestStateChange: {
                      shape: "Sb"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListGraphs: {
          http: {
            requestUri: "/graphs/list"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GraphList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    CreatedTime: {
                      shape: "Se"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListIndicators: {
          http: {
            requestUri: "/investigations/listIndicators"
          },
          input: {
            type: "structure",
            required: [
              "GraphArn",
              "InvestigationId"
            ],
            members: {
              GraphArn: {},
              InvestigationId: {},
              IndicatorType: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GraphArn: {},
              InvestigationId: {},
              NextToken: {},
              Indicators: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    IndicatorType: {},
                    IndicatorDetail: {
                      type: "structure",
                      members: {
                        TTPsObservedDetail: {
                          type: "structure",
                          members: {
                            Tactic: {},
                            Technique: {},
                            Procedure: {},
                            IpAddress: {},
                            APIName: {},
                            APISuccessCount: {
                              type: "long"
                            },
                            APIFailureCount: {
                              type: "long"
                            }
                          }
                        },
                        ImpossibleTravelDetail: {
                          type: "structure",
                          members: {
                            StartingIpAddress: {},
                            EndingIpAddress: {},
                            StartingLocation: {},
                            EndingLocation: {},
                            HourlyTimeDelta: {
                              type: "integer"
                            }
                          }
                        },
                        FlaggedIpAddressDetail: {
                          type: "structure",
                          members: {
                            IpAddress: {},
                            Reason: {}
                          }
                        },
                        NewGeolocationDetail: {
                          type: "structure",
                          members: {
                            Location: {},
                            IpAddress: {},
                            IsNewForEntireAccount: {
                              type: "boolean"
                            }
                          }
                        },
                        NewAsoDetail: {
                          type: "structure",
                          members: {
                            Aso: {},
                            IsNewForEntireAccount: {
                              type: "boolean"
                            }
                          }
                        },
                        NewUserAgentDetail: {
                          type: "structure",
                          members: {
                            UserAgent: {},
                            IsNewForEntireAccount: {
                              type: "boolean"
                            }
                          }
                        },
                        RelatedFindingDetail: {
                          type: "structure",
                          members: {
                            Arn: {},
                            Type: {},
                            IpAddress: {}
                          }
                        },
                        RelatedFindingGroupDetail: {
                          type: "structure",
                          members: {
                            Id: {}
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        ListInvestigations: {
          http: {
            requestUri: "/investigations/listInvestigations"
          },
          input: {
            type: "structure",
            required: [
              "GraphArn"
            ],
            members: {
              GraphArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              FilterCriteria: {
                type: "structure",
                members: {
                  Severity: {
                    shape: "S2y"
                  },
                  Status: {
                    shape: "S2y"
                  },
                  State: {
                    shape: "S2y"
                  },
                  EntityArn: {
                    shape: "S2y"
                  },
                  CreatedTime: {
                    type: "structure",
                    required: [
                      "StartInclusive",
                      "EndInclusive"
                    ],
                    members: {
                      StartInclusive: {
                        shape: "Se"
                      },
                      EndInclusive: {
                        shape: "Se"
                      }
                    }
                  }
                }
              },
              SortCriteria: {
                type: "structure",
                members: {
                  Field: {},
                  SortOrder: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InvestigationDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InvestigationId: {},
                    Severity: {},
                    Status: {},
                    State: {},
                    CreatedTime: {
                      shape: "Se"
                    },
                    EntityArn: {},
                    EntityType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListInvitations: {
          http: {
            requestUri: "/invitations/list"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Invitations: {
                shape: "Sz"
              },
              NextToken: {}
            }
          }
        },
        ListMembers: {
          http: {
            requestUri: "/graph/members/list"
          },
          input: {
            type: "structure",
            required: [
              "GraphArn"
            ],
            members: {
              GraphArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MemberDetails: {
                shape: "Sz"
              },
              NextToken: {}
            }
          }
        },
        ListOrganizationAdminAccounts: {
          http: {
            requestUri: "/orgs/adminAccountslist"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Administrators: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AccountId: {},
                    GraphArn: {},
                    DelegationTime: {
                      shape: "Se"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "So"
              }
            }
          }
        },
        RejectInvitation: {
          http: {
            requestUri: "/invitation/removal"
          },
          input: {
            type: "structure",
            required: [
              "GraphArn"
            ],
            members: {
              GraphArn: {}
            }
          }
        },
        StartInvestigation: {
          http: {
            requestUri: "/investigations/startInvestigation"
          },
          input: {
            type: "structure",
            required: [
              "GraphArn",
              "EntityArn",
              "ScopeStartTime",
              "ScopeEndTime"
            ],
            members: {
              GraphArn: {},
              EntityArn: {},
              ScopeStartTime: {
                shape: "Se"
              },
              ScopeEndTime: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InvestigationId: {}
            }
          }
        },
        StartMonitoringMember: {
          http: {
            requestUri: "/graph/member/monitoringstate"
          },
          input: {
            type: "structure",
            required: [
              "GraphArn",
              "AccountId"
            ],
            members: {
              GraphArn: {},
              AccountId: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{ResourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "So"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDatasourcePackages: {
          http: {
            requestUri: "/graph/datasources/update"
          },
          input: {
            type: "structure",
            required: [
              "GraphArn",
              "DatasourcePackages"
            ],
            members: {
              GraphArn: {},
              DatasourcePackages: {
                type: "list",
                member: {}
              }
            }
          }
        },
        UpdateInvestigationState: {
          http: {
            requestUri: "/investigations/updateInvestigationState"
          },
          input: {
            type: "structure",
            required: [
              "GraphArn",
              "InvestigationId",
              "State"
            ],
            members: {
              GraphArn: {},
              InvestigationId: {},
              State: {}
            }
          }
        },
        UpdateOrganizationConfiguration: {
          http: {
            requestUri: "/orgs/updateOrganizationConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "GraphArn"
            ],
            members: {
              GraphArn: {},
              AutoEnable: {
                type: "boolean"
              }
            }
          }
        }
      },
      shapes: {
        S7: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AccountId: {},
              GraphArn: {},
              DatasourcePackageIngestHistory: {
                type: "map",
                key: {},
                value: {
                  shape: "Sb"
                }
              }
            }
          }
        },
        Sb: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              Timestamp: {
                shape: "Se"
              }
            }
          }
        },
        Se: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        Sf: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AccountId: {},
              Reason: {}
            }
          }
        },
        So: {
          type: "map",
          key: {},
          value: {}
        },
        Sx: {
          type: "string",
          sensitive: true
        },
        Sz: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AccountId: {},
              EmailAddress: {
                shape: "Sx"
              },
              GraphArn: {},
              MasterId: {
                deprecated: true,
                deprecatedMessage: "This property is deprecated. Use AdministratorId instead."
              },
              AdministratorId: {},
              Status: {},
              DisabledReason: {},
              InvitedTime: {
                shape: "Se"
              },
              UpdatedTime: {
                shape: "Se"
              },
              VolumeUsageInBytes: {
                deprecated: true,
                deprecatedMessage: "This property is deprecated. Use VolumeUsageByDatasourcePackage instead.",
                type: "long"
              },
              VolumeUsageUpdatedTime: {
                shape: "Se",
                deprecated: true,
                deprecatedMessage: "This property is deprecated. Use VolumeUsageByDatasourcePackage instead."
              },
              PercentOfGraphUtilization: {
                deprecated: true,
                deprecatedMessage: "This property is deprecated. Use VolumeUsageByDatasourcePackage instead.",
                type: "double"
              },
              PercentOfGraphUtilizationUpdatedTime: {
                shape: "Se",
                deprecated: true,
                deprecatedMessage: "This property is deprecated. Use VolumeUsageByDatasourcePackage instead."
              },
              InvitationType: {},
              VolumeUsageByDatasourcePackage: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    VolumeUsageInBytes: {
                      type: "long"
                    },
                    VolumeUsageUpdateTime: {
                      shape: "Se"
                    }
                  }
                }
              },
              DatasourcePackageIngestStates: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        S1b: {
          type: "list",
          member: {}
        },
        S2y: {
          type: "structure",
          required: [
            "Value"
          ],
          members: {
            Value: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/detective-2018-10-26.paginators.json
var require_detective_2018_10_26_paginators = __commonJS({
  "node_modules/aws-sdk/apis/detective-2018-10-26.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListDatasourcePackages: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListGraphs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListInvitations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMembers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListOrganizationAdminAccounts: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/detective.js
var require_detective = __commonJS({
  "node_modules/aws-sdk/clients/detective.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["detective"] = {};
    AWS2.Detective = Service.defineService("detective", ["2018-10-26"]);
    Object.defineProperty(apiLoader.services["detective"], "2018-10-26", {
      get: function get() {
        var model = require_detective_2018_10_26_min();
        model.paginators = require_detective_2018_10_26_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Detective;
  }
});

// node_modules/aws-sdk/apis/codestar-connections-2019-12-01.min.json
var require_codestar_connections_2019_12_01_min = __commonJS({
  "node_modules/aws-sdk/apis/codestar-connections-2019-12-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-12-01",
        endpointPrefix: "codestar-connections",
        jsonVersion: "1.0",
        protocol: "json",
        serviceFullName: "AWS CodeStar connections",
        serviceId: "CodeStar connections",
        signatureVersion: "v4",
        signingName: "codestar-connections",
        targetPrefix: "com.amazonaws.codestar.connections.CodeStar_connections_20191201",
        uid: "codestar-connections-2019-12-01"
      },
      operations: {
        CreateConnection: {
          input: {
            type: "structure",
            required: [
              "ConnectionName"
            ],
            members: {
              ProviderType: {},
              ConnectionName: {},
              Tags: {
                shape: "S4"
              },
              HostArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ConnectionArn"
            ],
            members: {
              ConnectionArn: {},
              Tags: {
                shape: "S4"
              }
            }
          }
        },
        CreateHost: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ProviderType",
              "ProviderEndpoint"
            ],
            members: {
              Name: {},
              ProviderType: {},
              ProviderEndpoint: {},
              VpcConfiguration: {
                shape: "Se"
              },
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HostArn: {},
              Tags: {
                shape: "S4"
              }
            }
          }
        },
        CreateRepositoryLink: {
          input: {
            type: "structure",
            required: [
              "ConnectionArn",
              "OwnerId",
              "RepositoryName"
            ],
            members: {
              ConnectionArn: {},
              OwnerId: {},
              RepositoryName: {},
              EncryptionKeyArn: {},
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "RepositoryLinkInfo"
            ],
            members: {
              RepositoryLinkInfo: {
                shape: "Sr"
              }
            }
          }
        },
        CreateSyncConfiguration: {
          input: {
            type: "structure",
            required: [
              "Branch",
              "ConfigFile",
              "RepositoryLinkId",
              "ResourceName",
              "RoleArn",
              "SyncType"
            ],
            members: {
              Branch: {},
              ConfigFile: {},
              RepositoryLinkId: {},
              ResourceName: {},
              RoleArn: {},
              SyncType: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "SyncConfiguration"
            ],
            members: {
              SyncConfiguration: {
                shape: "S11"
              }
            }
          }
        },
        DeleteConnection: {
          input: {
            type: "structure",
            required: [
              "ConnectionArn"
            ],
            members: {
              ConnectionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteHost: {
          input: {
            type: "structure",
            required: [
              "HostArn"
            ],
            members: {
              HostArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRepositoryLink: {
          input: {
            type: "structure",
            required: [
              "RepositoryLinkId"
            ],
            members: {
              RepositoryLinkId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSyncConfiguration: {
          input: {
            type: "structure",
            required: [
              "SyncType",
              "ResourceName"
            ],
            members: {
              SyncType: {},
              ResourceName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetConnection: {
          input: {
            type: "structure",
            required: [
              "ConnectionArn"
            ],
            members: {
              ConnectionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Connection: {
                shape: "S1c"
              }
            }
          }
        },
        GetHost: {
          input: {
            type: "structure",
            required: [
              "HostArn"
            ],
            members: {
              HostArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Status: {},
              ProviderType: {},
              ProviderEndpoint: {},
              VpcConfiguration: {
                shape: "Se"
              }
            }
          }
        },
        GetRepositoryLink: {
          input: {
            type: "structure",
            required: [
              "RepositoryLinkId"
            ],
            members: {
              RepositoryLinkId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "RepositoryLinkInfo"
            ],
            members: {
              RepositoryLinkInfo: {
                shape: "Sr"
              }
            }
          }
        },
        GetRepositorySyncStatus: {
          input: {
            type: "structure",
            required: [
              "Branch",
              "RepositoryLinkId",
              "SyncType"
            ],
            members: {
              Branch: {},
              RepositoryLinkId: {},
              SyncType: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "LatestSync"
            ],
            members: {
              LatestSync: {
                type: "structure",
                required: [
                  "StartedAt",
                  "Status",
                  "Events"
                ],
                members: {
                  StartedAt: {
                    type: "timestamp"
                  },
                  Status: {},
                  Events: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Event",
                        "Time",
                        "Type"
                      ],
                      members: {
                        Event: {},
                        ExternalId: {},
                        Time: {
                          type: "timestamp"
                        },
                        Type: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetResourceSyncStatus: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "SyncType"
            ],
            members: {
              ResourceName: {},
              SyncType: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "LatestSync"
            ],
            members: {
              DesiredState: {
                shape: "S1w"
              },
              LatestSuccessfulSync: {
                shape: "S1z"
              },
              LatestSync: {
                shape: "S1z"
              }
            }
          }
        },
        GetSyncBlockerSummary: {
          input: {
            type: "structure",
            required: [
              "SyncType",
              "ResourceName"
            ],
            members: {
              SyncType: {},
              ResourceName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "SyncBlockerSummary"
            ],
            members: {
              SyncBlockerSummary: {
                type: "structure",
                required: [
                  "ResourceName"
                ],
                members: {
                  ResourceName: {},
                  ParentResourceName: {},
                  LatestBlockers: {
                    type: "list",
                    member: {
                      shape: "S28"
                    }
                  }
                }
              }
            }
          }
        },
        GetSyncConfiguration: {
          input: {
            type: "structure",
            required: [
              "SyncType",
              "ResourceName"
            ],
            members: {
              SyncType: {},
              ResourceName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "SyncConfiguration"
            ],
            members: {
              SyncConfiguration: {
                shape: "S11"
              }
            }
          }
        },
        ListConnections: {
          input: {
            type: "structure",
            members: {
              ProviderTypeFilter: {},
              HostArnFilter: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Connections: {
                type: "list",
                member: {
                  shape: "S1c"
                }
              },
              NextToken: {}
            }
          }
        },
        ListHosts: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Hosts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    HostArn: {},
                    ProviderType: {},
                    ProviderEndpoint: {},
                    VpcConfiguration: {
                      shape: "Se"
                    },
                    Status: {},
                    StatusMessage: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListRepositoryLinks: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "RepositoryLinks"
            ],
            members: {
              RepositoryLinks: {
                type: "list",
                member: {
                  shape: "Sr"
                }
              },
              NextToken: {}
            }
          }
        },
        ListRepositorySyncDefinitions: {
          input: {
            type: "structure",
            required: [
              "RepositoryLinkId",
              "SyncType"
            ],
            members: {
              RepositoryLinkId: {},
              SyncType: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "RepositorySyncDefinitions"
            ],
            members: {
              RepositorySyncDefinitions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Branch",
                    "Directory",
                    "Parent",
                    "Target"
                  ],
                  members: {
                    Branch: {},
                    Directory: {},
                    Parent: {},
                    Target: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSyncConfigurations: {
          input: {
            type: "structure",
            required: [
              "RepositoryLinkId",
              "SyncType"
            ],
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              RepositoryLinkId: {},
              SyncType: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "SyncConfigurations"
            ],
            members: {
              SyncConfigurations: {
                type: "list",
                member: {
                  shape: "S11"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S4"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateHost: {
          input: {
            type: "structure",
            required: [
              "HostArn"
            ],
            members: {
              HostArn: {},
              ProviderEndpoint: {},
              VpcConfiguration: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateRepositoryLink: {
          input: {
            type: "structure",
            required: [
              "RepositoryLinkId"
            ],
            members: {
              ConnectionArn: {},
              EncryptionKeyArn: {},
              RepositoryLinkId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "RepositoryLinkInfo"
            ],
            members: {
              RepositoryLinkInfo: {
                shape: "Sr"
              }
            }
          }
        },
        UpdateSyncBlocker: {
          input: {
            type: "structure",
            required: [
              "Id",
              "SyncType",
              "ResourceName",
              "ResolvedReason"
            ],
            members: {
              Id: {},
              SyncType: {},
              ResourceName: {},
              ResolvedReason: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ResourceName",
              "SyncBlocker"
            ],
            members: {
              ResourceName: {},
              ParentResourceName: {},
              SyncBlocker: {
                shape: "S28"
              }
            }
          }
        },
        UpdateSyncConfiguration: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "SyncType"
            ],
            members: {
              Branch: {},
              ConfigFile: {},
              RepositoryLinkId: {},
              ResourceName: {},
              RoleArn: {},
              SyncType: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "SyncConfiguration"
            ],
            members: {
              SyncConfiguration: {
                shape: "S11"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Se: {
          type: "structure",
          required: [
            "VpcId",
            "SubnetIds",
            "SecurityGroupIds"
          ],
          members: {
            VpcId: {},
            SubnetIds: {
              type: "list",
              member: {}
            },
            SecurityGroupIds: {
              type: "list",
              member: {}
            },
            TlsCertificate: {}
          }
        },
        Sr: {
          type: "structure",
          required: [
            "ConnectionArn",
            "OwnerId",
            "ProviderType",
            "RepositoryLinkArn",
            "RepositoryLinkId",
            "RepositoryName"
          ],
          members: {
            ConnectionArn: {},
            EncryptionKeyArn: {},
            OwnerId: {},
            ProviderType: {},
            RepositoryLinkArn: {},
            RepositoryLinkId: {},
            RepositoryName: {}
          }
        },
        S11: {
          type: "structure",
          required: [
            "Branch",
            "OwnerId",
            "ProviderType",
            "RepositoryLinkId",
            "RepositoryName",
            "ResourceName",
            "RoleArn",
            "SyncType"
          ],
          members: {
            Branch: {},
            ConfigFile: {},
            OwnerId: {},
            ProviderType: {},
            RepositoryLinkId: {},
            RepositoryName: {},
            ResourceName: {},
            RoleArn: {},
            SyncType: {}
          }
        },
        S1c: {
          type: "structure",
          members: {
            ConnectionName: {},
            ConnectionArn: {},
            ProviderType: {},
            OwnerAccountId: {},
            ConnectionStatus: {},
            HostArn: {}
          }
        },
        S1w: {
          type: "structure",
          required: [
            "Branch",
            "Directory",
            "OwnerId",
            "RepositoryName",
            "ProviderType",
            "Sha"
          ],
          members: {
            Branch: {},
            Directory: {},
            OwnerId: {},
            RepositoryName: {},
            ProviderType: {},
            Sha: {}
          }
        },
        S1z: {
          type: "structure",
          required: [
            "Events",
            "InitialRevision",
            "StartedAt",
            "Status",
            "TargetRevision",
            "Target"
          ],
          members: {
            Events: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Event",
                  "Time",
                  "Type"
                ],
                members: {
                  Event: {},
                  ExternalId: {},
                  Time: {
                    type: "timestamp"
                  },
                  Type: {}
                }
              }
            },
            InitialRevision: {
              shape: "S1w"
            },
            StartedAt: {
              type: "timestamp"
            },
            Status: {},
            TargetRevision: {
              shape: "S1w"
            },
            Target: {}
          }
        },
        S28: {
          type: "structure",
          required: [
            "Id",
            "Type",
            "Status",
            "CreatedReason",
            "CreatedAt"
          ],
          members: {
            Id: {},
            Type: {},
            Status: {},
            CreatedReason: {},
            CreatedAt: {
              type: "timestamp"
            },
            Contexts: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Key",
                  "Value"
                ],
                members: {
                  Key: {},
                  Value: {}
                }
              }
            },
            ResolvedReason: {},
            ResolvedAt: {
              type: "timestamp"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/codestar-connections-2019-12-01.paginators.json
var require_codestar_connections_2019_12_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/codestar-connections-2019-12-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListConnections: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListHosts: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListRepositoryLinks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListSyncConfigurations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/codestarconnections.js
var require_codestarconnections = __commonJS({
  "node_modules/aws-sdk/clients/codestarconnections.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["codestarconnections"] = {};
    AWS2.CodeStarconnections = Service.defineService("codestarconnections", ["2019-12-01"]);
    Object.defineProperty(apiLoader.services["codestarconnections"], "2019-12-01", {
      get: function get() {
        var model = require_codestar_connections_2019_12_01_min();
        model.paginators = require_codestar_connections_2019_12_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CodeStarconnections;
  }
});

// node_modules/aws-sdk/apis/synthetics-2017-10-11.min.json
var require_synthetics_2017_10_11_min = __commonJS({
  "node_modules/aws-sdk/apis/synthetics-2017-10-11.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-10-11",
        endpointPrefix: "synthetics",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Synthetics",
        serviceFullName: "Synthetics",
        serviceId: "synthetics",
        signatureVersion: "v4",
        signingName: "synthetics",
        uid: "synthetics-2017-10-11"
      },
      operations: {
        AssociateResource: {
          http: {
            method: "PATCH",
            requestUri: "/group/{groupIdentifier}/associate"
          },
          input: {
            type: "structure",
            required: [
              "GroupIdentifier",
              "ResourceArn"
            ],
            members: {
              GroupIdentifier: {
                location: "uri",
                locationName: "groupIdentifier"
              },
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateCanary: {
          http: {
            requestUri: "/canary"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "Code",
              "ArtifactS3Location",
              "ExecutionRoleArn",
              "Schedule",
              "RuntimeVersion"
            ],
            members: {
              Name: {},
              Code: {
                shape: "S7"
              },
              ArtifactS3Location: {},
              ExecutionRoleArn: {},
              Schedule: {
                shape: "Sc"
              },
              RunConfig: {
                shape: "Se"
              },
              SuccessRetentionPeriodInDays: {
                type: "integer"
              },
              FailureRetentionPeriodInDays: {
                type: "integer"
              },
              RuntimeVersion: {},
              VpcConfig: {
                shape: "Sm"
              },
              Tags: {
                shape: "Sr"
              },
              ArtifactConfig: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Canary: {
                shape: "Sz"
              }
            }
          }
        },
        CreateGroup: {
          http: {
            requestUri: "/group"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Tags: {
                shape: "Sr"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Group: {
                shape: "S1l"
              }
            }
          }
        },
        DeleteCanary: {
          http: {
            method: "DELETE",
            requestUri: "/canary/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              DeleteLambda: {
                location: "querystring",
                locationName: "deleteLambda",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteGroup: {
          http: {
            method: "DELETE",
            requestUri: "/group/{groupIdentifier}"
          },
          input: {
            type: "structure",
            required: [
              "GroupIdentifier"
            ],
            members: {
              GroupIdentifier: {
                location: "uri",
                locationName: "groupIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeCanaries: {
          http: {
            requestUri: "/canaries"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Names: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Canaries: {
                type: "list",
                member: {
                  shape: "Sz"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeCanariesLastRun: {
          http: {
            requestUri: "/canaries/last-run"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Names: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CanariesLastRun: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CanaryName: {},
                    LastRun: {
                      shape: "S24"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeRuntimeVersions: {
          http: {
            requestUri: "/runtime-versions"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RuntimeVersions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    VersionName: {},
                    Description: {},
                    ReleaseDate: {
                      type: "timestamp"
                    },
                    DeprecationDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DisassociateResource: {
          http: {
            method: "PATCH",
            requestUri: "/group/{groupIdentifier}/disassociate"
          },
          input: {
            type: "structure",
            required: [
              "GroupIdentifier",
              "ResourceArn"
            ],
            members: {
              GroupIdentifier: {
                location: "uri",
                locationName: "groupIdentifier"
              },
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetCanary: {
          http: {
            method: "GET",
            requestUri: "/canary/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Canary: {
                shape: "Sz"
              }
            }
          }
        },
        GetCanaryRuns: {
          http: {
            requestUri: "/canary/{name}/runs"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CanaryRuns: {
                type: "list",
                member: {
                  shape: "S24"
                }
              },
              NextToken: {}
            }
          }
        },
        GetGroup: {
          http: {
            method: "GET",
            requestUri: "/group/{groupIdentifier}"
          },
          input: {
            type: "structure",
            required: [
              "GroupIdentifier"
            ],
            members: {
              GroupIdentifier: {
                location: "uri",
                locationName: "groupIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Group: {
                shape: "S1l"
              }
            }
          }
        },
        ListAssociatedGroups: {
          http: {
            requestUri: "/resource/{resourceArn}/groups"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Groups: {
                shape: "S2q"
              },
              NextToken: {}
            }
          }
        },
        ListGroupResources: {
          http: {
            requestUri: "/group/{groupIdentifier}/resources"
          },
          input: {
            type: "structure",
            required: [
              "GroupIdentifier"
            ],
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              GroupIdentifier: {
                location: "uri",
                locationName: "groupIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Resources: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListGroups: {
          http: {
            requestUri: "/groups"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Groups: {
                shape: "S2q"
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sr"
              }
            }
          }
        },
        StartCanary: {
          http: {
            requestUri: "/canary/{name}/start"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StopCanary: {
          http: {
            requestUri: "/canary/{name}/stop"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              Tags: {
                shape: "Sr"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateCanary: {
          http: {
            method: "PATCH",
            requestUri: "/canary/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              Code: {
                shape: "S7"
              },
              ExecutionRoleArn: {},
              RuntimeVersion: {},
              Schedule: {
                shape: "Sc"
              },
              RunConfig: {
                shape: "Se"
              },
              SuccessRetentionPeriodInDays: {
                type: "integer"
              },
              FailureRetentionPeriodInDays: {
                type: "integer"
              },
              VpcConfig: {
                shape: "Sm"
              },
              VisualReference: {
                type: "structure",
                required: [
                  "BaseCanaryRunId"
                ],
                members: {
                  BaseScreenshots: {
                    shape: "S1d"
                  },
                  BaseCanaryRunId: {}
                }
              },
              ArtifactS3Location: {},
              ArtifactConfig: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S7: {
          type: "structure",
          required: [
            "Handler"
          ],
          members: {
            S3Bucket: {},
            S3Key: {},
            S3Version: {},
            ZipFile: {
              type: "blob"
            },
            Handler: {}
          }
        },
        Sc: {
          type: "structure",
          required: [
            "Expression"
          ],
          members: {
            Expression: {},
            DurationInSeconds: {
              type: "long"
            }
          }
        },
        Se: {
          type: "structure",
          members: {
            TimeoutInSeconds: {
              type: "integer"
            },
            MemoryInMB: {
              type: "integer"
            },
            ActiveTracing: {
              type: "boolean"
            },
            EnvironmentVariables: {
              type: "map",
              key: {},
              value: {}
            }
          }
        },
        Sm: {
          type: "structure",
          members: {
            SubnetIds: {
              shape: "Sn"
            },
            SecurityGroupIds: {
              shape: "Sp"
            }
          }
        },
        Sn: {
          type: "list",
          member: {}
        },
        Sp: {
          type: "list",
          member: {}
        },
        Sr: {
          type: "map",
          key: {},
          value: {}
        },
        Su: {
          type: "structure",
          members: {
            S3Encryption: {
              shape: "Sv"
            }
          }
        },
        Sv: {
          type: "structure",
          members: {
            EncryptionMode: {},
            KmsKeyArn: {}
          }
        },
        Sz: {
          type: "structure",
          members: {
            Id: {},
            Name: {},
            Code: {
              type: "structure",
              members: {
                SourceLocationArn: {},
                Handler: {}
              }
            },
            ExecutionRoleArn: {},
            Schedule: {
              type: "structure",
              members: {
                Expression: {},
                DurationInSeconds: {
                  type: "long"
                }
              }
            },
            RunConfig: {
              type: "structure",
              members: {
                TimeoutInSeconds: {
                  type: "integer"
                },
                MemoryInMB: {
                  type: "integer"
                },
                ActiveTracing: {
                  type: "boolean"
                }
              }
            },
            SuccessRetentionPeriodInDays: {
              type: "integer"
            },
            FailureRetentionPeriodInDays: {
              type: "integer"
            },
            Status: {
              type: "structure",
              members: {
                State: {},
                StateReason: {},
                StateReasonCode: {}
              }
            },
            Timeline: {
              type: "structure",
              members: {
                Created: {
                  type: "timestamp"
                },
                LastModified: {
                  type: "timestamp"
                },
                LastStarted: {
                  type: "timestamp"
                },
                LastStopped: {
                  type: "timestamp"
                }
              }
            },
            ArtifactS3Location: {},
            EngineArn: {},
            RuntimeVersion: {},
            VpcConfig: {
              type: "structure",
              members: {
                VpcId: {},
                SubnetIds: {
                  shape: "Sn"
                },
                SecurityGroupIds: {
                  shape: "Sp"
                }
              }
            },
            VisualReference: {
              type: "structure",
              members: {
                BaseScreenshots: {
                  shape: "S1d"
                },
                BaseCanaryRunId: {}
              }
            },
            Tags: {
              shape: "Sr"
            },
            ArtifactConfig: {
              type: "structure",
              members: {
                S3Encryption: {
                  shape: "Sv"
                }
              }
            }
          }
        },
        S1d: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ScreenshotName"
            ],
            members: {
              ScreenshotName: {},
              IgnoreCoordinates: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S1l: {
          type: "structure",
          members: {
            Id: {},
            Name: {},
            Arn: {},
            Tags: {
              shape: "Sr"
            },
            CreatedTime: {
              type: "timestamp"
            },
            LastModifiedTime: {
              type: "timestamp"
            }
          }
        },
        S24: {
          type: "structure",
          members: {
            Id: {},
            Name: {},
            Status: {
              type: "structure",
              members: {
                State: {},
                StateReason: {},
                StateReasonCode: {}
              }
            },
            Timeline: {
              type: "structure",
              members: {
                Started: {
                  type: "timestamp"
                },
                Completed: {
                  type: "timestamp"
                }
              }
            },
            ArtifactS3Location: {}
          }
        },
        S2q: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Id: {},
              Name: {},
              Arn: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/synthetics-2017-10-11.paginators.json
var require_synthetics_2017_10_11_paginators = __commonJS({
  "node_modules/aws-sdk/apis/synthetics-2017-10-11.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeCanaries: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        DescribeCanariesLastRun: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        DescribeRuntimeVersions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetCanaryRuns: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListAssociatedGroups: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListGroupResources: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListGroups: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/synthetics.js
var require_synthetics = __commonJS({
  "node_modules/aws-sdk/clients/synthetics.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["synthetics"] = {};
    AWS2.Synthetics = Service.defineService("synthetics", ["2017-10-11"]);
    Object.defineProperty(apiLoader.services["synthetics"], "2017-10-11", {
      get: function get() {
        var model = require_synthetics_2017_10_11_min();
        model.paginators = require_synthetics_2017_10_11_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Synthetics;
  }
});

// node_modules/aws-sdk/apis/iotsitewise-2019-12-02.min.json
var require_iotsitewise_2019_12_02_min = __commonJS({
  "node_modules/aws-sdk/apis/iotsitewise-2019-12-02.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-12-02",
        endpointPrefix: "iotsitewise",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS IoT SiteWise",
        serviceId: "IoTSiteWise",
        signatureVersion: "v4",
        signingName: "iotsitewise",
        uid: "iotsitewise-2019-12-02"
      },
      operations: {
        AssociateAssets: {
          http: {
            requestUri: "/assets/{assetId}/associate"
          },
          input: {
            type: "structure",
            required: [
              "assetId",
              "hierarchyId",
              "childAssetId"
            ],
            members: {
              assetId: {
                location: "uri",
                locationName: "assetId"
              },
              hierarchyId: {},
              childAssetId: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        AssociateTimeSeriesToAssetProperty: {
          http: {
            requestUri: "/timeseries/associate/"
          },
          input: {
            type: "structure",
            required: [
              "alias",
              "assetId",
              "propertyId"
            ],
            members: {
              alias: {
                location: "querystring",
                locationName: "alias"
              },
              assetId: {
                location: "querystring",
                locationName: "assetId"
              },
              propertyId: {
                location: "querystring",
                locationName: "propertyId"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        BatchAssociateProjectAssets: {
          http: {
            requestUri: "/projects/{projectId}/assets/associate",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "projectId",
              "assetIds"
            ],
            members: {
              projectId: {
                location: "uri",
                locationName: "projectId"
              },
              assetIds: {
                shape: "S8"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errors: {
                type: "list",
                member: {
                  shape: "Sb"
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        BatchDisassociateProjectAssets: {
          http: {
            requestUri: "/projects/{projectId}/assets/disassociate",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "projectId",
              "assetIds"
            ],
            members: {
              projectId: {
                location: "uri",
                locationName: "projectId"
              },
              assetIds: {
                shape: "S8"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errors: {
                type: "list",
                member: {
                  shape: "Sb"
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        BatchGetAssetPropertyAggregates: {
          http: {
            requestUri: "/properties/batch/aggregates"
          },
          input: {
            type: "structure",
            required: [
              "entries"
            ],
            members: {
              entries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "entryId",
                    "aggregateTypes",
                    "resolution",
                    "startDate",
                    "endDate"
                  ],
                  members: {
                    entryId: {},
                    assetId: {},
                    propertyId: {},
                    propertyAlias: {},
                    aggregateTypes: {
                      shape: "Sm"
                    },
                    resolution: {},
                    startDate: {
                      type: "timestamp"
                    },
                    endDate: {
                      type: "timestamp"
                    },
                    qualities: {
                      shape: "Sq"
                    },
                    timeOrdering: {}
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "errorEntries",
              "successEntries",
              "skippedEntries"
            ],
            members: {
              errorEntries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "errorCode",
                    "errorMessage",
                    "entryId"
                  ],
                  members: {
                    errorCode: {},
                    errorMessage: {},
                    entryId: {}
                  }
                }
              },
              successEntries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "entryId",
                    "aggregatedValues"
                  ],
                  members: {
                    entryId: {},
                    aggregatedValues: {
                      shape: "S12"
                    }
                  }
                }
              },
              skippedEntries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "entryId",
                    "completionStatus"
                  ],
                  members: {
                    entryId: {},
                    completionStatus: {},
                    errorInfo: {
                      type: "structure",
                      required: [
                        "errorCode",
                        "errorTimestamp"
                      ],
                      members: {
                        errorCode: {},
                        errorTimestamp: {
                          type: "timestamp"
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "data."
          }
        },
        BatchGetAssetPropertyValue: {
          http: {
            requestUri: "/properties/batch/latest"
          },
          input: {
            type: "structure",
            required: [
              "entries"
            ],
            members: {
              entries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "entryId"
                  ],
                  members: {
                    entryId: {},
                    assetId: {},
                    propertyId: {},
                    propertyAlias: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "errorEntries",
              "successEntries",
              "skippedEntries"
            ],
            members: {
              errorEntries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "errorCode",
                    "errorMessage",
                    "entryId"
                  ],
                  members: {
                    errorCode: {},
                    errorMessage: {},
                    entryId: {}
                  }
                }
              },
              successEntries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "entryId"
                  ],
                  members: {
                    entryId: {},
                    assetPropertyValue: {
                      shape: "S1j"
                    }
                  }
                }
              },
              skippedEntries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "entryId",
                    "completionStatus"
                  ],
                  members: {
                    entryId: {},
                    completionStatus: {},
                    errorInfo: {
                      type: "structure",
                      required: [
                        "errorCode",
                        "errorTimestamp"
                      ],
                      members: {
                        errorCode: {},
                        errorTimestamp: {
                          type: "timestamp"
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "data."
          }
        },
        BatchGetAssetPropertyValueHistory: {
          http: {
            requestUri: "/properties/batch/history"
          },
          input: {
            type: "structure",
            required: [
              "entries"
            ],
            members: {
              entries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "entryId"
                  ],
                  members: {
                    entryId: {},
                    assetId: {},
                    propertyId: {},
                    propertyAlias: {},
                    startDate: {
                      type: "timestamp"
                    },
                    endDate: {
                      type: "timestamp"
                    },
                    qualities: {
                      shape: "Sq"
                    },
                    timeOrdering: {}
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "errorEntries",
              "successEntries",
              "skippedEntries"
            ],
            members: {
              errorEntries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "errorCode",
                    "errorMessage",
                    "entryId"
                  ],
                  members: {
                    errorCode: {},
                    errorMessage: {},
                    entryId: {}
                  }
                }
              },
              successEntries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "entryId",
                    "assetPropertyValueHistory"
                  ],
                  members: {
                    entryId: {},
                    assetPropertyValueHistory: {
                      shape: "S25"
                    }
                  }
                }
              },
              skippedEntries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "entryId",
                    "completionStatus"
                  ],
                  members: {
                    entryId: {},
                    completionStatus: {},
                    errorInfo: {
                      type: "structure",
                      required: [
                        "errorCode",
                        "errorTimestamp"
                      ],
                      members: {
                        errorCode: {},
                        errorTimestamp: {
                          type: "timestamp"
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "data."
          }
        },
        BatchPutAssetPropertyValue: {
          http: {
            requestUri: "/properties"
          },
          input: {
            type: "structure",
            required: [
              "entries"
            ],
            members: {
              entries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "entryId",
                    "propertyValues"
                  ],
                  members: {
                    entryId: {},
                    assetId: {},
                    propertyId: {},
                    propertyAlias: {},
                    propertyValues: {
                      type: "list",
                      member: {
                        shape: "S1j"
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "errorEntries"
            ],
            members: {
              errorEntries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "entryId",
                    "errors"
                  ],
                  members: {
                    entryId: {},
                    errors: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "errorCode",
                          "errorMessage",
                          "timestamps"
                        ],
                        members: {
                          errorCode: {},
                          errorMessage: {},
                          timestamps: {
                            type: "list",
                            member: {
                              shape: "S1p"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "data."
          }
        },
        CreateAccessPolicy: {
          http: {
            requestUri: "/access-policies",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "accessPolicyIdentity",
              "accessPolicyResource",
              "accessPolicyPermission"
            ],
            members: {
              accessPolicyIdentity: {
                shape: "S2l"
              },
              accessPolicyResource: {
                shape: "S2s"
              },
              accessPolicyPermission: {},
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "S2w"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "accessPolicyId",
              "accessPolicyArn"
            ],
            members: {
              accessPolicyId: {},
              accessPolicyArn: {}
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        CreateAsset: {
          http: {
            requestUri: "/assets",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "assetName",
              "assetModelId"
            ],
            members: {
              assetName: {},
              assetModelId: {},
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "S2w"
              },
              assetDescription: {},
              assetId: {},
              assetExternalId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "assetId",
              "assetArn",
              "assetStatus"
            ],
            members: {
              assetId: {},
              assetArn: {},
              assetStatus: {
                shape: "S35"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        CreateAssetModel: {
          http: {
            requestUri: "/asset-models",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "assetModelName"
            ],
            members: {
              assetModelName: {},
              assetModelDescription: {},
              assetModelProperties: {
                shape: "S3e"
              },
              assetModelHierarchies: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "childAssetModelId"
                  ],
                  members: {
                    name: {},
                    childAssetModelId: {},
                    id: {},
                    externalId: {}
                  }
                }
              },
              assetModelCompositeModels: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "type"
                  ],
                  members: {
                    name: {},
                    description: {},
                    type: {},
                    properties: {
                      shape: "S3e"
                    },
                    id: {},
                    externalId: {}
                  }
                }
              },
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "S2w"
              },
              assetModelId: {},
              assetModelExternalId: {},
              assetModelType: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "assetModelId",
              "assetModelArn",
              "assetModelStatus"
            ],
            members: {
              assetModelId: {},
              assetModelArn: {},
              assetModelStatus: {
                shape: "S4c"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        CreateAssetModelCompositeModel: {
          http: {
            requestUri: "/asset-models/{assetModelId}/composite-models",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "assetModelId",
              "assetModelCompositeModelName",
              "assetModelCompositeModelType"
            ],
            members: {
              assetModelId: {
                location: "uri",
                locationName: "assetModelId"
              },
              parentAssetModelCompositeModelId: {},
              assetModelCompositeModelExternalId: {},
              assetModelCompositeModelId: {},
              assetModelCompositeModelDescription: {},
              assetModelCompositeModelName: {},
              assetModelCompositeModelType: {},
              clientToken: {
                idempotencyToken: true
              },
              composedAssetModelId: {},
              assetModelCompositeModelProperties: {
                shape: "S3e"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetModelCompositeModelId",
              "assetModelCompositeModelPath",
              "assetModelStatus"
            ],
            members: {
              assetModelCompositeModelId: {},
              assetModelCompositeModelPath: {
                shape: "S4g"
              },
              assetModelStatus: {
                shape: "S4c"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        CreateBulkImportJob: {
          http: {
            requestUri: "/jobs",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "jobName",
              "jobRoleArn",
              "files",
              "errorReportLocation",
              "jobConfiguration"
            ],
            members: {
              jobName: {},
              jobRoleArn: {},
              files: {
                shape: "S4j"
              },
              errorReportLocation: {
                shape: "S4n"
              },
              jobConfiguration: {
                shape: "S4o"
              },
              adaptiveIngestion: {
                type: "boolean"
              },
              deleteFilesAfterImport: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobId",
              "jobName",
              "jobStatus"
            ],
            members: {
              jobId: {},
              jobName: {},
              jobStatus: {}
            }
          },
          endpoint: {
            hostPrefix: "data."
          }
        },
        CreateDashboard: {
          http: {
            requestUri: "/dashboards",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "projectId",
              "dashboardName",
              "dashboardDefinition"
            ],
            members: {
              projectId: {},
              dashboardName: {},
              dashboardDescription: {},
              dashboardDefinition: {},
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "S2w"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "dashboardId",
              "dashboardArn"
            ],
            members: {
              dashboardId: {},
              dashboardArn: {}
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        CreateGateway: {
          http: {
            requestUri: "/20200301/gateways",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "gatewayName",
              "gatewayPlatform"
            ],
            members: {
              gatewayName: {},
              gatewayPlatform: {
                shape: "S52"
              },
              tags: {
                shape: "S2w"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "gatewayId",
              "gatewayArn"
            ],
            members: {
              gatewayId: {},
              gatewayArn: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        CreatePortal: {
          http: {
            requestUri: "/portals",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "portalName",
              "portalContactEmail",
              "roleArn"
            ],
            members: {
              portalName: {},
              portalDescription: {},
              portalContactEmail: {},
              clientToken: {
                idempotencyToken: true
              },
              portalLogoImageFile: {
                shape: "S59"
              },
              roleArn: {},
              tags: {
                shape: "S2w"
              },
              portalAuthMode: {},
              notificationSenderEmail: {},
              alarms: {
                shape: "S5d"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "portalId",
              "portalArn",
              "portalStartUrl",
              "portalStatus",
              "ssoApplicationId"
            ],
            members: {
              portalId: {},
              portalArn: {},
              portalStartUrl: {},
              portalStatus: {
                shape: "S5g"
              },
              ssoApplicationId: {}
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        CreateProject: {
          http: {
            requestUri: "/projects",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "portalId",
              "projectName"
            ],
            members: {
              portalId: {},
              projectName: {},
              projectDescription: {},
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "S2w"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "projectId",
              "projectArn"
            ],
            members: {
              projectId: {},
              projectArn: {}
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        DeleteAccessPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/access-policies/{accessPolicyId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "accessPolicyId"
            ],
            members: {
              accessPolicyId: {
                location: "uri",
                locationName: "accessPolicyId"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        DeleteAsset: {
          http: {
            method: "DELETE",
            requestUri: "/assets/{assetId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "assetId"
            ],
            members: {
              assetId: {
                location: "uri",
                locationName: "assetId"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetStatus"
            ],
            members: {
              assetStatus: {
                shape: "S35"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DeleteAssetModel: {
          http: {
            method: "DELETE",
            requestUri: "/asset-models/{assetModelId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "assetModelId"
            ],
            members: {
              assetModelId: {
                location: "uri",
                locationName: "assetModelId"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetModelStatus"
            ],
            members: {
              assetModelStatus: {
                shape: "S4c"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DeleteAssetModelCompositeModel: {
          http: {
            method: "DELETE",
            requestUri: "/asset-models/{assetModelId}/composite-models/{assetModelCompositeModelId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "assetModelId",
              "assetModelCompositeModelId"
            ],
            members: {
              assetModelId: {
                location: "uri",
                locationName: "assetModelId"
              },
              assetModelCompositeModelId: {
                location: "uri",
                locationName: "assetModelCompositeModelId"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetModelStatus"
            ],
            members: {
              assetModelStatus: {
                shape: "S4c"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DeleteDashboard: {
          http: {
            method: "DELETE",
            requestUri: "/dashboards/{dashboardId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "dashboardId"
            ],
            members: {
              dashboardId: {
                location: "uri",
                locationName: "dashboardId"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        DeleteGateway: {
          http: {
            method: "DELETE",
            requestUri: "/20200301/gateways/{gatewayId}"
          },
          input: {
            type: "structure",
            required: [
              "gatewayId"
            ],
            members: {
              gatewayId: {
                location: "uri",
                locationName: "gatewayId"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DeletePortal: {
          http: {
            method: "DELETE",
            requestUri: "/portals/{portalId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "portalId"
            ],
            members: {
              portalId: {
                location: "uri",
                locationName: "portalId"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "portalStatus"
            ],
            members: {
              portalStatus: {
                shape: "S5g"
              }
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        DeleteProject: {
          http: {
            method: "DELETE",
            requestUri: "/projects/{projectId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "projectId"
            ],
            members: {
              projectId: {
                location: "uri",
                locationName: "projectId"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        DeleteTimeSeries: {
          http: {
            requestUri: "/timeseries/delete/"
          },
          input: {
            type: "structure",
            members: {
              alias: {
                location: "querystring",
                locationName: "alias"
              },
              assetId: {
                location: "querystring",
                locationName: "assetId"
              },
              propertyId: {
                location: "querystring",
                locationName: "propertyId"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DescribeAccessPolicy: {
          http: {
            method: "GET",
            requestUri: "/access-policies/{accessPolicyId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "accessPolicyId"
            ],
            members: {
              accessPolicyId: {
                location: "uri",
                locationName: "accessPolicyId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "accessPolicyId",
              "accessPolicyArn",
              "accessPolicyIdentity",
              "accessPolicyResource",
              "accessPolicyPermission",
              "accessPolicyCreationDate",
              "accessPolicyLastUpdateDate"
            ],
            members: {
              accessPolicyId: {},
              accessPolicyArn: {},
              accessPolicyIdentity: {
                shape: "S2l"
              },
              accessPolicyResource: {
                shape: "S2s"
              },
              accessPolicyPermission: {},
              accessPolicyCreationDate: {
                type: "timestamp"
              },
              accessPolicyLastUpdateDate: {
                type: "timestamp"
              }
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        DescribeAction: {
          http: {
            method: "GET",
            requestUri: "/actions/{actionId}"
          },
          input: {
            type: "structure",
            required: [
              "actionId"
            ],
            members: {
              actionId: {
                location: "uri",
                locationName: "actionId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "actionId",
              "targetResource",
              "actionDefinitionId",
              "actionPayload",
              "executionTime"
            ],
            members: {
              actionId: {},
              targetResource: {
                shape: "S68"
              },
              actionDefinitionId: {},
              actionPayload: {
                shape: "S69"
              },
              executionTime: {
                type: "timestamp"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DescribeAsset: {
          http: {
            method: "GET",
            requestUri: "/assets/{assetId}"
          },
          input: {
            type: "structure",
            required: [
              "assetId"
            ],
            members: {
              assetId: {
                location: "uri",
                locationName: "assetId"
              },
              excludeProperties: {
                location: "querystring",
                locationName: "excludeProperties",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetId",
              "assetArn",
              "assetName",
              "assetModelId",
              "assetProperties",
              "assetHierarchies",
              "assetCreationDate",
              "assetLastUpdateDate",
              "assetStatus"
            ],
            members: {
              assetId: {},
              assetArn: {},
              assetName: {},
              assetModelId: {},
              assetProperties: {
                shape: "S6e"
              },
              assetHierarchies: {
                shape: "S6l"
              },
              assetCompositeModels: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "type",
                    "properties"
                  ],
                  members: {
                    name: {},
                    description: {},
                    type: {},
                    properties: {
                      shape: "S6e"
                    },
                    id: {},
                    externalId: {}
                  }
                }
              },
              assetCreationDate: {
                type: "timestamp"
              },
              assetLastUpdateDate: {
                type: "timestamp"
              },
              assetStatus: {
                shape: "S35"
              },
              assetDescription: {},
              assetCompositeModelSummaries: {
                shape: "S6p"
              },
              assetExternalId: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DescribeAssetCompositeModel: {
          http: {
            method: "GET",
            requestUri: "/assets/{assetId}/composite-models/{assetCompositeModelId}"
          },
          input: {
            type: "structure",
            required: [
              "assetId",
              "assetCompositeModelId"
            ],
            members: {
              assetId: {
                location: "uri",
                locationName: "assetId"
              },
              assetCompositeModelId: {
                location: "uri",
                locationName: "assetCompositeModelId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetId",
              "assetCompositeModelId",
              "assetCompositeModelPath",
              "assetCompositeModelName",
              "assetCompositeModelDescription",
              "assetCompositeModelType",
              "assetCompositeModelProperties",
              "assetCompositeModelSummaries"
            ],
            members: {
              assetId: {},
              assetCompositeModelId: {},
              assetCompositeModelExternalId: {},
              assetCompositeModelPath: {
                shape: "S6r"
              },
              assetCompositeModelName: {},
              assetCompositeModelDescription: {},
              assetCompositeModelType: {},
              assetCompositeModelProperties: {
                shape: "S6e"
              },
              assetCompositeModelSummaries: {
                shape: "S6p"
              },
              actionDefinitions: {
                shape: "S6v"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DescribeAssetModel: {
          http: {
            method: "GET",
            requestUri: "/asset-models/{assetModelId}"
          },
          input: {
            type: "structure",
            required: [
              "assetModelId"
            ],
            members: {
              assetModelId: {
                location: "uri",
                locationName: "assetModelId"
              },
              excludeProperties: {
                location: "querystring",
                locationName: "excludeProperties",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetModelId",
              "assetModelArn",
              "assetModelName",
              "assetModelDescription",
              "assetModelProperties",
              "assetModelHierarchies",
              "assetModelCreationDate",
              "assetModelLastUpdateDate",
              "assetModelStatus"
            ],
            members: {
              assetModelId: {},
              assetModelArn: {},
              assetModelName: {},
              assetModelDescription: {},
              assetModelProperties: {
                shape: "S6z"
              },
              assetModelHierarchies: {
                shape: "S71"
              },
              assetModelCompositeModels: {
                shape: "S73"
              },
              assetModelCreationDate: {
                type: "timestamp"
              },
              assetModelLastUpdateDate: {
                type: "timestamp"
              },
              assetModelStatus: {
                shape: "S4c"
              },
              assetModelType: {},
              assetModelCompositeModelSummaries: {
                shape: "S75"
              },
              assetModelExternalId: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DescribeAssetModelCompositeModel: {
          http: {
            method: "GET",
            requestUri: "/asset-models/{assetModelId}/composite-models/{assetModelCompositeModelId}"
          },
          input: {
            type: "structure",
            required: [
              "assetModelId",
              "assetModelCompositeModelId"
            ],
            members: {
              assetModelId: {
                location: "uri",
                locationName: "assetModelId"
              },
              assetModelCompositeModelId: {
                location: "uri",
                locationName: "assetModelCompositeModelId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetModelId",
              "assetModelCompositeModelId",
              "assetModelCompositeModelPath",
              "assetModelCompositeModelName",
              "assetModelCompositeModelDescription",
              "assetModelCompositeModelType",
              "assetModelCompositeModelProperties",
              "assetModelCompositeModelSummaries"
            ],
            members: {
              assetModelId: {},
              assetModelCompositeModelId: {},
              assetModelCompositeModelExternalId: {},
              assetModelCompositeModelPath: {
                shape: "S4g"
              },
              assetModelCompositeModelName: {},
              assetModelCompositeModelDescription: {},
              assetModelCompositeModelType: {},
              assetModelCompositeModelProperties: {
                shape: "S6z"
              },
              compositionDetails: {
                type: "structure",
                members: {
                  compositionRelationship: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        id: {}
                      }
                    }
                  }
                }
              },
              assetModelCompositeModelSummaries: {
                shape: "S75"
              },
              actionDefinitions: {
                shape: "S6v"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DescribeAssetProperty: {
          http: {
            method: "GET",
            requestUri: "/assets/{assetId}/properties/{propertyId}"
          },
          input: {
            type: "structure",
            required: [
              "assetId",
              "propertyId"
            ],
            members: {
              assetId: {
                location: "uri",
                locationName: "assetId"
              },
              propertyId: {
                location: "uri",
                locationName: "propertyId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetId",
              "assetName",
              "assetModelId"
            ],
            members: {
              assetId: {},
              assetName: {},
              assetModelId: {},
              assetProperty: {
                shape: "S7e"
              },
              compositeModel: {
                type: "structure",
                required: [
                  "name",
                  "type",
                  "assetProperty"
                ],
                members: {
                  name: {},
                  type: {},
                  assetProperty: {
                    shape: "S7e"
                  },
                  id: {},
                  externalId: {}
                }
              },
              assetExternalId: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DescribeBulkImportJob: {
          http: {
            method: "GET",
            requestUri: "/jobs/{jobId}"
          },
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobId",
              "jobName",
              "jobStatus",
              "jobRoleArn",
              "files",
              "errorReportLocation",
              "jobConfiguration",
              "jobCreationDate",
              "jobLastUpdateDate"
            ],
            members: {
              jobId: {},
              jobName: {},
              jobStatus: {},
              jobRoleArn: {},
              files: {
                shape: "S4j"
              },
              errorReportLocation: {
                shape: "S4n"
              },
              jobConfiguration: {
                shape: "S4o"
              },
              jobCreationDate: {
                type: "timestamp"
              },
              jobLastUpdateDate: {
                type: "timestamp"
              },
              adaptiveIngestion: {
                type: "boolean"
              },
              deleteFilesAfterImport: {
                type: "boolean"
              }
            }
          },
          endpoint: {
            hostPrefix: "data."
          }
        },
        DescribeDashboard: {
          http: {
            method: "GET",
            requestUri: "/dashboards/{dashboardId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "dashboardId"
            ],
            members: {
              dashboardId: {
                location: "uri",
                locationName: "dashboardId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "dashboardId",
              "dashboardArn",
              "dashboardName",
              "projectId",
              "dashboardDefinition",
              "dashboardCreationDate",
              "dashboardLastUpdateDate"
            ],
            members: {
              dashboardId: {},
              dashboardArn: {},
              dashboardName: {},
              projectId: {},
              dashboardDescription: {},
              dashboardDefinition: {},
              dashboardCreationDate: {
                type: "timestamp"
              },
              dashboardLastUpdateDate: {
                type: "timestamp"
              }
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        DescribeDefaultEncryptionConfiguration: {
          http: {
            method: "GET",
            requestUri: "/configuration/account/encryption"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "encryptionType",
              "configurationStatus"
            ],
            members: {
              encryptionType: {},
              kmsKeyArn: {},
              configurationStatus: {
                shape: "S7n"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DescribeGateway: {
          http: {
            method: "GET",
            requestUri: "/20200301/gateways/{gatewayId}"
          },
          input: {
            type: "structure",
            required: [
              "gatewayId"
            ],
            members: {
              gatewayId: {
                location: "uri",
                locationName: "gatewayId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "gatewayId",
              "gatewayName",
              "gatewayArn",
              "gatewayCapabilitySummaries",
              "creationDate",
              "lastUpdateDate"
            ],
            members: {
              gatewayId: {},
              gatewayName: {},
              gatewayArn: {},
              gatewayPlatform: {
                shape: "S52"
              },
              gatewayCapabilitySummaries: {
                shape: "S7s"
              },
              creationDate: {
                type: "timestamp"
              },
              lastUpdateDate: {
                type: "timestamp"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DescribeGatewayCapabilityConfiguration: {
          http: {
            method: "GET",
            requestUri: "/20200301/gateways/{gatewayId}/capability/{capabilityNamespace}"
          },
          input: {
            type: "structure",
            required: [
              "gatewayId",
              "capabilityNamespace"
            ],
            members: {
              gatewayId: {
                location: "uri",
                locationName: "gatewayId"
              },
              capabilityNamespace: {
                location: "uri",
                locationName: "capabilityNamespace"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "gatewayId",
              "capabilityNamespace",
              "capabilityConfiguration",
              "capabilitySyncStatus"
            ],
            members: {
              gatewayId: {},
              capabilityNamespace: {},
              capabilityConfiguration: {},
              capabilitySyncStatus: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DescribeLoggingOptions: {
          http: {
            method: "GET",
            requestUri: "/logging"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "loggingOptions"
            ],
            members: {
              loggingOptions: {
                shape: "S81"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DescribePortal: {
          http: {
            method: "GET",
            requestUri: "/portals/{portalId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "portalId"
            ],
            members: {
              portalId: {
                location: "uri",
                locationName: "portalId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "portalId",
              "portalArn",
              "portalName",
              "portalClientId",
              "portalStartUrl",
              "portalContactEmail",
              "portalStatus",
              "portalCreationDate",
              "portalLastUpdateDate"
            ],
            members: {
              portalId: {},
              portalArn: {},
              portalName: {},
              portalDescription: {},
              portalClientId: {},
              portalStartUrl: {},
              portalContactEmail: {},
              portalStatus: {
                shape: "S5g"
              },
              portalCreationDate: {
                type: "timestamp"
              },
              portalLastUpdateDate: {
                type: "timestamp"
              },
              portalLogoImageLocation: {
                type: "structure",
                required: [
                  "id",
                  "url"
                ],
                members: {
                  id: {},
                  url: {}
                }
              },
              roleArn: {},
              portalAuthMode: {},
              notificationSenderEmail: {},
              alarms: {
                shape: "S5d"
              }
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        DescribeProject: {
          http: {
            method: "GET",
            requestUri: "/projects/{projectId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "projectId"
            ],
            members: {
              projectId: {
                location: "uri",
                locationName: "projectId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "projectId",
              "projectArn",
              "projectName",
              "portalId",
              "projectCreationDate",
              "projectLastUpdateDate"
            ],
            members: {
              projectId: {},
              projectArn: {},
              projectName: {},
              portalId: {},
              projectDescription: {},
              projectCreationDate: {
                type: "timestamp"
              },
              projectLastUpdateDate: {
                type: "timestamp"
              }
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        DescribeStorageConfiguration: {
          http: {
            method: "GET",
            requestUri: "/configuration/account/storage"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "storageType",
              "configurationStatus"
            ],
            members: {
              storageType: {},
              multiLayerStorage: {
                shape: "S8c"
              },
              disassociatedDataStorage: {},
              retentionPeriod: {
                shape: "S8f"
              },
              configurationStatus: {
                shape: "S7n"
              },
              lastUpdateDate: {
                type: "timestamp"
              },
              warmTier: {},
              warmTierRetentionPeriod: {
                shape: "S8j"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DescribeTimeSeries: {
          http: {
            method: "GET",
            requestUri: "/timeseries/describe/"
          },
          input: {
            type: "structure",
            members: {
              alias: {
                location: "querystring",
                locationName: "alias"
              },
              assetId: {
                location: "querystring",
                locationName: "assetId"
              },
              propertyId: {
                location: "querystring",
                locationName: "propertyId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "timeSeriesId",
              "dataType",
              "timeSeriesCreationDate",
              "timeSeriesLastUpdateDate",
              "timeSeriesArn"
            ],
            members: {
              assetId: {},
              propertyId: {},
              alias: {},
              timeSeriesId: {},
              dataType: {},
              dataTypeSpec: {},
              timeSeriesCreationDate: {
                type: "timestamp"
              },
              timeSeriesLastUpdateDate: {
                type: "timestamp"
              },
              timeSeriesArn: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DisassociateAssets: {
          http: {
            requestUri: "/assets/{assetId}/disassociate"
          },
          input: {
            type: "structure",
            required: [
              "assetId",
              "hierarchyId",
              "childAssetId"
            ],
            members: {
              assetId: {
                location: "uri",
                locationName: "assetId"
              },
              hierarchyId: {},
              childAssetId: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DisassociateTimeSeriesFromAssetProperty: {
          http: {
            requestUri: "/timeseries/disassociate/"
          },
          input: {
            type: "structure",
            required: [
              "alias",
              "assetId",
              "propertyId"
            ],
            members: {
              alias: {
                location: "querystring",
                locationName: "alias"
              },
              assetId: {
                location: "querystring",
                locationName: "assetId"
              },
              propertyId: {
                location: "querystring",
                locationName: "propertyId"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ExecuteAction: {
          http: {
            requestUri: "/actions",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "targetResource",
              "actionDefinitionId",
              "actionPayload"
            ],
            members: {
              targetResource: {
                shape: "S68"
              },
              actionDefinitionId: {},
              actionPayload: {
                shape: "S69"
              },
              clientToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "actionId"
            ],
            members: {
              actionId: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ExecuteQuery: {
          http: {
            requestUri: "/queries/execution"
          },
          input: {
            type: "structure",
            required: [
              "queryStatement"
            ],
            members: {
              queryStatement: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              columns: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    type: {
                      type: "structure",
                      members: {
                        scalarType: {}
                      }
                    }
                  }
                }
              },
              rows: {
                type: "list",
                member: {
                  shape: "S91"
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "data."
          }
        },
        GetAssetPropertyAggregates: {
          http: {
            method: "GET",
            requestUri: "/properties/aggregates"
          },
          input: {
            type: "structure",
            required: [
              "aggregateTypes",
              "resolution",
              "startDate",
              "endDate"
            ],
            members: {
              assetId: {
                location: "querystring",
                locationName: "assetId"
              },
              propertyId: {
                location: "querystring",
                locationName: "propertyId"
              },
              propertyAlias: {
                location: "querystring",
                locationName: "propertyAlias"
              },
              aggregateTypes: {
                shape: "Sm",
                location: "querystring",
                locationName: "aggregateTypes"
              },
              resolution: {
                location: "querystring",
                locationName: "resolution"
              },
              qualities: {
                shape: "Sq",
                location: "querystring",
                locationName: "qualities"
              },
              startDate: {
                location: "querystring",
                locationName: "startDate",
                type: "timestamp"
              },
              endDate: {
                location: "querystring",
                locationName: "endDate",
                type: "timestamp"
              },
              timeOrdering: {
                location: "querystring",
                locationName: "timeOrdering"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "aggregatedValues"
            ],
            members: {
              aggregatedValues: {
                shape: "S12"
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "data."
          }
        },
        GetAssetPropertyValue: {
          http: {
            method: "GET",
            requestUri: "/properties/latest"
          },
          input: {
            type: "structure",
            members: {
              assetId: {
                location: "querystring",
                locationName: "assetId"
              },
              propertyId: {
                location: "querystring",
                locationName: "propertyId"
              },
              propertyAlias: {
                location: "querystring",
                locationName: "propertyAlias"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              propertyValue: {
                shape: "S1j"
              }
            }
          },
          endpoint: {
            hostPrefix: "data."
          }
        },
        GetAssetPropertyValueHistory: {
          http: {
            method: "GET",
            requestUri: "/properties/history"
          },
          input: {
            type: "structure",
            members: {
              assetId: {
                location: "querystring",
                locationName: "assetId"
              },
              propertyId: {
                location: "querystring",
                locationName: "propertyId"
              },
              propertyAlias: {
                location: "querystring",
                locationName: "propertyAlias"
              },
              startDate: {
                location: "querystring",
                locationName: "startDate",
                type: "timestamp"
              },
              endDate: {
                location: "querystring",
                locationName: "endDate",
                type: "timestamp"
              },
              qualities: {
                shape: "Sq",
                location: "querystring",
                locationName: "qualities"
              },
              timeOrdering: {
                location: "querystring",
                locationName: "timeOrdering"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetPropertyValueHistory"
            ],
            members: {
              assetPropertyValueHistory: {
                shape: "S25"
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "data."
          }
        },
        GetInterpolatedAssetPropertyValues: {
          http: {
            method: "GET",
            requestUri: "/properties/interpolated"
          },
          input: {
            type: "structure",
            required: [
              "startTimeInSeconds",
              "endTimeInSeconds",
              "quality",
              "intervalInSeconds",
              "type"
            ],
            members: {
              assetId: {
                location: "querystring",
                locationName: "assetId"
              },
              propertyId: {
                location: "querystring",
                locationName: "propertyId"
              },
              propertyAlias: {
                location: "querystring",
                locationName: "propertyAlias"
              },
              startTimeInSeconds: {
                location: "querystring",
                locationName: "startTimeInSeconds",
                type: "long"
              },
              startTimeOffsetInNanos: {
                location: "querystring",
                locationName: "startTimeOffsetInNanos",
                type: "integer"
              },
              endTimeInSeconds: {
                location: "querystring",
                locationName: "endTimeInSeconds",
                type: "long"
              },
              endTimeOffsetInNanos: {
                location: "querystring",
                locationName: "endTimeOffsetInNanos",
                type: "integer"
              },
              quality: {
                location: "querystring",
                locationName: "quality"
              },
              intervalInSeconds: {
                location: "querystring",
                locationName: "intervalInSeconds",
                type: "long"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              type: {
                location: "querystring",
                locationName: "type"
              },
              intervalWindowInSeconds: {
                location: "querystring",
                locationName: "intervalWindowInSeconds",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "interpolatedAssetPropertyValues"
            ],
            members: {
              interpolatedAssetPropertyValues: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "timestamp",
                    "value"
                  ],
                  members: {
                    timestamp: {
                      shape: "S1p"
                    },
                    value: {
                      shape: "S1k"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "data."
          }
        },
        ListAccessPolicies: {
          http: {
            method: "GET",
            requestUri: "/access-policies",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              identityType: {
                location: "querystring",
                locationName: "identityType"
              },
              identityId: {
                location: "querystring",
                locationName: "identityId"
              },
              resourceType: {
                location: "querystring",
                locationName: "resourceType"
              },
              resourceId: {
                location: "querystring",
                locationName: "resourceId"
              },
              iamArn: {
                location: "querystring",
                locationName: "iamArn"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "accessPolicySummaries"
            ],
            members: {
              accessPolicySummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "identity",
                    "resource",
                    "permission"
                  ],
                  members: {
                    id: {},
                    identity: {
                      shape: "S2l"
                    },
                    resource: {
                      shape: "S2s"
                    },
                    permission: {},
                    creationDate: {
                      type: "timestamp"
                    },
                    lastUpdateDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        ListActions: {
          http: {
            method: "GET",
            requestUri: "/actions"
          },
          input: {
            type: "structure",
            required: [
              "targetResourceType",
              "targetResourceId"
            ],
            members: {
              targetResourceType: {
                location: "querystring",
                locationName: "targetResourceType"
              },
              targetResourceId: {
                location: "querystring",
                locationName: "targetResourceId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "actionSummaries",
              "nextToken"
            ],
            members: {
              actionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    actionId: {},
                    actionDefinitionId: {},
                    targetResource: {
                      shape: "S68"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListAssetModelCompositeModels: {
          http: {
            method: "GET",
            requestUri: "/asset-models/{assetModelId}/composite-models"
          },
          input: {
            type: "structure",
            required: [
              "assetModelId"
            ],
            members: {
              assetModelId: {
                location: "uri",
                locationName: "assetModelId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetModelCompositeModelSummaries"
            ],
            members: {
              assetModelCompositeModelSummaries: {
                shape: "S75"
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListAssetModelProperties: {
          http: {
            method: "GET",
            requestUri: "/asset-models/{assetModelId}/properties"
          },
          input: {
            type: "structure",
            required: [
              "assetModelId"
            ],
            members: {
              assetModelId: {
                location: "uri",
                locationName: "assetModelId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              filter: {
                location: "querystring",
                locationName: "filter"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetModelPropertySummaries"
            ],
            members: {
              assetModelPropertySummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "dataType",
                    "type"
                  ],
                  members: {
                    id: {},
                    name: {},
                    dataType: {},
                    dataTypeSpec: {},
                    unit: {},
                    type: {
                      shape: "S3i"
                    },
                    assetModelCompositeModelId: {},
                    path: {
                      shape: "S3w"
                    },
                    externalId: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListAssetModels: {
          http: {
            method: "GET",
            requestUri: "/asset-models"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              assetModelTypes: {
                location: "querystring",
                locationName: "assetModelTypes",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetModelSummaries"
            ],
            members: {
              assetModelSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "arn",
                    "name",
                    "description",
                    "creationDate",
                    "lastUpdateDate",
                    "status"
                  ],
                  members: {
                    id: {},
                    arn: {},
                    name: {},
                    description: {},
                    creationDate: {
                      type: "timestamp"
                    },
                    lastUpdateDate: {
                      type: "timestamp"
                    },
                    status: {
                      shape: "S4c"
                    },
                    assetModelType: {},
                    externalId: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListAssetProperties: {
          http: {
            method: "GET",
            requestUri: "/assets/{assetId}/properties"
          },
          input: {
            type: "structure",
            required: [
              "assetId"
            ],
            members: {
              assetId: {
                location: "uri",
                locationName: "assetId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              filter: {
                location: "querystring",
                locationName: "filter"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetPropertySummaries"
            ],
            members: {
              assetPropertySummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id"
                  ],
                  members: {
                    id: {},
                    alias: {},
                    unit: {},
                    notification: {
                      shape: "S6g"
                    },
                    assetCompositeModelId: {},
                    path: {
                      shape: "S6j"
                    },
                    externalId: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListAssetRelationships: {
          http: {
            method: "GET",
            requestUri: "/assets/{assetId}/assetRelationships"
          },
          input: {
            type: "structure",
            required: [
              "assetId",
              "traversalType"
            ],
            members: {
              assetId: {
                location: "uri",
                locationName: "assetId"
              },
              traversalType: {
                location: "querystring",
                locationName: "traversalType"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetRelationshipSummaries"
            ],
            members: {
              assetRelationshipSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "relationshipType"
                  ],
                  members: {
                    hierarchyInfo: {
                      type: "structure",
                      members: {
                        parentAssetId: {},
                        childAssetId: {}
                      }
                    },
                    relationshipType: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListAssets: {
          http: {
            method: "GET",
            requestUri: "/assets"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              assetModelId: {
                location: "querystring",
                locationName: "assetModelId"
              },
              filter: {
                location: "querystring",
                locationName: "filter"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetSummaries"
            ],
            members: {
              assetSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "arn",
                    "name",
                    "assetModelId",
                    "creationDate",
                    "lastUpdateDate",
                    "status",
                    "hierarchies"
                  ],
                  members: {
                    id: {},
                    arn: {},
                    name: {},
                    assetModelId: {},
                    creationDate: {
                      type: "timestamp"
                    },
                    lastUpdateDate: {
                      type: "timestamp"
                    },
                    status: {
                      shape: "S35"
                    },
                    hierarchies: {
                      shape: "S6l"
                    },
                    description: {},
                    externalId: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListAssociatedAssets: {
          http: {
            method: "GET",
            requestUri: "/assets/{assetId}/hierarchies"
          },
          input: {
            type: "structure",
            required: [
              "assetId"
            ],
            members: {
              assetId: {
                location: "uri",
                locationName: "assetId"
              },
              hierarchyId: {
                location: "querystring",
                locationName: "hierarchyId"
              },
              traversalDirection: {
                location: "querystring",
                locationName: "traversalDirection"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetSummaries"
            ],
            members: {
              assetSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "arn",
                    "name",
                    "assetModelId",
                    "creationDate",
                    "lastUpdateDate",
                    "status",
                    "hierarchies"
                  ],
                  members: {
                    id: {},
                    arn: {},
                    name: {},
                    assetModelId: {},
                    creationDate: {
                      type: "timestamp"
                    },
                    lastUpdateDate: {
                      type: "timestamp"
                    },
                    status: {
                      shape: "S35"
                    },
                    hierarchies: {
                      shape: "S6l"
                    },
                    description: {},
                    externalId: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListBulkImportJobs: {
          http: {
            method: "GET",
            requestUri: "/jobs"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              filter: {
                location: "querystring",
                locationName: "filter"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobSummaries"
            ],
            members: {
              jobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "name",
                    "status"
                  ],
                  members: {
                    id: {},
                    name: {},
                    status: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "data."
          }
        },
        ListCompositionRelationships: {
          http: {
            method: "GET",
            requestUri: "/asset-models/{assetModelId}/composition-relationships"
          },
          input: {
            type: "structure",
            required: [
              "assetModelId"
            ],
            members: {
              assetModelId: {
                location: "uri",
                locationName: "assetModelId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "compositionRelationshipSummaries"
            ],
            members: {
              compositionRelationshipSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "assetModelId",
                    "assetModelCompositeModelId",
                    "assetModelCompositeModelType"
                  ],
                  members: {
                    assetModelId: {},
                    assetModelCompositeModelId: {},
                    assetModelCompositeModelType: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListDashboards: {
          http: {
            method: "GET",
            requestUri: "/dashboards",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "projectId"
            ],
            members: {
              projectId: {
                location: "querystring",
                locationName: "projectId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "dashboardSummaries"
            ],
            members: {
              dashboardSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "name"
                  ],
                  members: {
                    id: {},
                    name: {},
                    description: {},
                    creationDate: {
                      type: "timestamp"
                    },
                    lastUpdateDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        ListGateways: {
          http: {
            method: "GET",
            requestUri: "/20200301/gateways"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "gatewaySummaries"
            ],
            members: {
              gatewaySummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "gatewayId",
                    "gatewayName",
                    "creationDate",
                    "lastUpdateDate"
                  ],
                  members: {
                    gatewayId: {},
                    gatewayName: {},
                    gatewayPlatform: {
                      shape: "S52"
                    },
                    gatewayCapabilitySummaries: {
                      shape: "S7s"
                    },
                    creationDate: {
                      type: "timestamp"
                    },
                    lastUpdateDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListPortals: {
          http: {
            method: "GET",
            requestUri: "/portals",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              portalSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "name",
                    "startUrl",
                    "status"
                  ],
                  members: {
                    id: {},
                    name: {},
                    description: {},
                    startUrl: {},
                    creationDate: {
                      type: "timestamp"
                    },
                    lastUpdateDate: {
                      type: "timestamp"
                    },
                    roleArn: {},
                    status: {
                      shape: "S5g"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        ListProjectAssets: {
          http: {
            method: "GET",
            requestUri: "/projects/{projectId}/assets",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "projectId"
            ],
            members: {
              projectId: {
                location: "uri",
                locationName: "projectId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetIds"
            ],
            members: {
              assetIds: {
                type: "list",
                member: {}
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        ListProjects: {
          http: {
            method: "GET",
            requestUri: "/projects",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "portalId"
            ],
            members: {
              portalId: {
                location: "querystring",
                locationName: "portalId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "projectSummaries"
            ],
            members: {
              projectSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "name"
                  ],
                  members: {
                    id: {},
                    name: {},
                    description: {},
                    creationDate: {
                      type: "timestamp"
                    },
                    lastUpdateDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S2w"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListTimeSeries: {
          http: {
            method: "GET",
            requestUri: "/timeseries/"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              assetId: {
                location: "querystring",
                locationName: "assetId"
              },
              aliasPrefix: {
                location: "querystring",
                locationName: "aliasPrefix"
              },
              timeSeriesType: {
                location: "querystring",
                locationName: "timeSeriesType"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TimeSeriesSummaries"
            ],
            members: {
              TimeSeriesSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "timeSeriesId",
                    "dataType",
                    "timeSeriesCreationDate",
                    "timeSeriesLastUpdateDate",
                    "timeSeriesArn"
                  ],
                  members: {
                    assetId: {},
                    propertyId: {},
                    alias: {},
                    timeSeriesId: {},
                    dataType: {},
                    dataTypeSpec: {},
                    timeSeriesCreationDate: {
                      type: "timestamp"
                    },
                    timeSeriesLastUpdateDate: {
                      type: "timestamp"
                    },
                    timeSeriesArn: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        PutDefaultEncryptionConfiguration: {
          http: {
            requestUri: "/configuration/account/encryption"
          },
          input: {
            type: "structure",
            required: [
              "encryptionType"
            ],
            members: {
              encryptionType: {},
              kmsKeyId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "encryptionType",
              "configurationStatus"
            ],
            members: {
              encryptionType: {},
              kmsKeyArn: {},
              configurationStatus: {
                shape: "S7n"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        PutLoggingOptions: {
          http: {
            method: "PUT",
            requestUri: "/logging"
          },
          input: {
            type: "structure",
            required: [
              "loggingOptions"
            ],
            members: {
              loggingOptions: {
                shape: "S81"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        PutStorageConfiguration: {
          http: {
            requestUri: "/configuration/account/storage"
          },
          input: {
            type: "structure",
            required: [
              "storageType"
            ],
            members: {
              storageType: {},
              multiLayerStorage: {
                shape: "S8c"
              },
              disassociatedDataStorage: {},
              retentionPeriod: {
                shape: "S8f"
              },
              warmTier: {},
              warmTierRetentionPeriod: {
                shape: "S8j"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "storageType",
              "configurationStatus"
            ],
            members: {
              storageType: {},
              multiLayerStorage: {
                shape: "S8c"
              },
              disassociatedDataStorage: {},
              retentionPeriod: {
                shape: "S8f"
              },
              configurationStatus: {
                shape: "S7n"
              },
              warmTier: {},
              warmTierRetentionPeriod: {
                shape: "S8j"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S2w"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        UpdateAccessPolicy: {
          http: {
            method: "PUT",
            requestUri: "/access-policies/{accessPolicyId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "accessPolicyId",
              "accessPolicyIdentity",
              "accessPolicyResource",
              "accessPolicyPermission"
            ],
            members: {
              accessPolicyId: {
                location: "uri",
                locationName: "accessPolicyId"
              },
              accessPolicyIdentity: {
                shape: "S2l"
              },
              accessPolicyResource: {
                shape: "S2s"
              },
              accessPolicyPermission: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        UpdateAsset: {
          http: {
            method: "PUT",
            requestUri: "/assets/{assetId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "assetId",
              "assetName"
            ],
            members: {
              assetId: {
                location: "uri",
                locationName: "assetId"
              },
              assetName: {},
              clientToken: {
                idempotencyToken: true
              },
              assetDescription: {},
              assetExternalId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "assetStatus"
            ],
            members: {
              assetStatus: {
                shape: "S35"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        UpdateAssetModel: {
          http: {
            method: "PUT",
            requestUri: "/asset-models/{assetModelId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "assetModelId",
              "assetModelName"
            ],
            members: {
              assetModelId: {
                location: "uri",
                locationName: "assetModelId"
              },
              assetModelName: {},
              assetModelDescription: {},
              assetModelProperties: {
                shape: "S6z"
              },
              assetModelHierarchies: {
                shape: "S71"
              },
              assetModelCompositeModels: {
                shape: "S73"
              },
              clientToken: {
                idempotencyToken: true
              },
              assetModelExternalId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "assetModelStatus"
            ],
            members: {
              assetModelStatus: {
                shape: "S4c"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        UpdateAssetModelCompositeModel: {
          http: {
            method: "PUT",
            requestUri: "/asset-models/{assetModelId}/composite-models/{assetModelCompositeModelId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "assetModelId",
              "assetModelCompositeModelId",
              "assetModelCompositeModelName"
            ],
            members: {
              assetModelId: {
                location: "uri",
                locationName: "assetModelId"
              },
              assetModelCompositeModelId: {
                location: "uri",
                locationName: "assetModelCompositeModelId"
              },
              assetModelCompositeModelExternalId: {},
              assetModelCompositeModelDescription: {},
              assetModelCompositeModelName: {},
              clientToken: {
                idempotencyToken: true
              },
              assetModelCompositeModelProperties: {
                shape: "S6z"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetModelCompositeModelPath",
              "assetModelStatus"
            ],
            members: {
              assetModelCompositeModelPath: {
                shape: "S4g"
              },
              assetModelStatus: {
                shape: "S4c"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        UpdateAssetProperty: {
          http: {
            method: "PUT",
            requestUri: "/assets/{assetId}/properties/{propertyId}"
          },
          input: {
            type: "structure",
            required: [
              "assetId",
              "propertyId"
            ],
            members: {
              assetId: {
                location: "uri",
                locationName: "assetId"
              },
              propertyId: {
                location: "uri",
                locationName: "propertyId"
              },
              propertyAlias: {},
              propertyNotificationState: {},
              clientToken: {
                idempotencyToken: true
              },
              propertyUnit: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        UpdateDashboard: {
          http: {
            method: "PUT",
            requestUri: "/dashboards/{dashboardId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "dashboardId",
              "dashboardName",
              "dashboardDefinition"
            ],
            members: {
              dashboardId: {
                location: "uri",
                locationName: "dashboardId"
              },
              dashboardName: {},
              dashboardDescription: {},
              dashboardDefinition: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        UpdateGateway: {
          http: {
            method: "PUT",
            requestUri: "/20200301/gateways/{gatewayId}"
          },
          input: {
            type: "structure",
            required: [
              "gatewayId",
              "gatewayName"
            ],
            members: {
              gatewayId: {
                location: "uri",
                locationName: "gatewayId"
              },
              gatewayName: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        UpdateGatewayCapabilityConfiguration: {
          http: {
            requestUri: "/20200301/gateways/{gatewayId}/capability",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "gatewayId",
              "capabilityNamespace",
              "capabilityConfiguration"
            ],
            members: {
              gatewayId: {
                location: "uri",
                locationName: "gatewayId"
              },
              capabilityNamespace: {},
              capabilityConfiguration: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "capabilityNamespace",
              "capabilitySyncStatus"
            ],
            members: {
              capabilityNamespace: {},
              capabilitySyncStatus: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        UpdatePortal: {
          http: {
            method: "PUT",
            requestUri: "/portals/{portalId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "portalId",
              "portalName",
              "portalContactEmail",
              "roleArn"
            ],
            members: {
              portalId: {
                location: "uri",
                locationName: "portalId"
              },
              portalName: {},
              portalDescription: {},
              portalContactEmail: {},
              portalLogoImage: {
                type: "structure",
                members: {
                  id: {},
                  file: {
                    shape: "S59"
                  }
                }
              },
              roleArn: {},
              clientToken: {
                idempotencyToken: true
              },
              notificationSenderEmail: {},
              alarms: {
                shape: "S5d"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "portalStatus"
            ],
            members: {
              portalStatus: {
                shape: "S5g"
              }
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        UpdateProject: {
          http: {
            method: "PUT",
            requestUri: "/projects/{projectId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "projectId",
              "projectName"
            ],
            members: {
              projectId: {
                location: "uri",
                locationName: "projectId"
              },
              projectName: {},
              projectDescription: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        }
      },
      shapes: {
        S8: {
          type: "list",
          member: {}
        },
        Sb: {
          type: "structure",
          required: [
            "assetId",
            "code",
            "message"
          ],
          members: {
            assetId: {},
            code: {},
            message: {}
          }
        },
        Sm: {
          type: "list",
          member: {}
        },
        Sq: {
          type: "list",
          member: {}
        },
        S12: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "timestamp",
              "value"
            ],
            members: {
              timestamp: {
                type: "timestamp"
              },
              quality: {},
              value: {
                type: "structure",
                members: {
                  average: {
                    type: "double"
                  },
                  count: {
                    type: "double"
                  },
                  maximum: {
                    type: "double"
                  },
                  minimum: {
                    type: "double"
                  },
                  sum: {
                    type: "double"
                  },
                  standardDeviation: {
                    type: "double"
                  }
                }
              }
            }
          }
        },
        S1j: {
          type: "structure",
          required: [
            "value",
            "timestamp"
          ],
          members: {
            value: {
              shape: "S1k"
            },
            timestamp: {
              shape: "S1p"
            },
            quality: {}
          }
        },
        S1k: {
          type: "structure",
          members: {
            stringValue: {},
            integerValue: {
              type: "integer"
            },
            doubleValue: {
              type: "double"
            },
            booleanValue: {
              type: "boolean"
            }
          }
        },
        S1p: {
          type: "structure",
          required: [
            "timeInSeconds"
          ],
          members: {
            timeInSeconds: {
              type: "long"
            },
            offsetInNanos: {
              type: "integer"
            }
          }
        },
        S25: {
          type: "list",
          member: {
            shape: "S1j"
          }
        },
        S2l: {
          type: "structure",
          members: {
            user: {
              type: "structure",
              required: [
                "id"
              ],
              members: {
                id: {}
              }
            },
            group: {
              type: "structure",
              required: [
                "id"
              ],
              members: {
                id: {}
              }
            },
            iamUser: {
              type: "structure",
              required: [
                "arn"
              ],
              members: {
                arn: {}
              }
            },
            iamRole: {
              type: "structure",
              required: [
                "arn"
              ],
              members: {
                arn: {}
              }
            }
          }
        },
        S2s: {
          type: "structure",
          members: {
            portal: {
              type: "structure",
              required: [
                "id"
              ],
              members: {
                id: {}
              }
            },
            project: {
              type: "structure",
              required: [
                "id"
              ],
              members: {
                id: {}
              }
            }
          }
        },
        S2w: {
          type: "map",
          key: {},
          value: {}
        },
        S35: {
          type: "structure",
          required: [
            "state"
          ],
          members: {
            state: {},
            error: {
              shape: "S37"
            }
          }
        },
        S37: {
          type: "structure",
          required: [
            "code",
            "message"
          ],
          members: {
            code: {},
            message: {},
            details: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "code",
                  "message"
                ],
                members: {
                  code: {},
                  message: {}
                }
              }
            }
          }
        },
        S3e: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "dataType",
              "type"
            ],
            members: {
              name: {},
              dataType: {},
              dataTypeSpec: {},
              unit: {},
              type: {
                shape: "S3i"
              },
              id: {},
              externalId: {}
            }
          }
        },
        S3i: {
          type: "structure",
          members: {
            attribute: {
              type: "structure",
              members: {
                defaultValue: {}
              }
            },
            measurement: {
              type: "structure",
              members: {
                processingConfig: {
                  type: "structure",
                  required: [
                    "forwardingConfig"
                  ],
                  members: {
                    forwardingConfig: {
                      shape: "S3n"
                    }
                  }
                }
              }
            },
            transform: {
              type: "structure",
              required: [
                "expression",
                "variables"
              ],
              members: {
                expression: {},
                variables: {
                  shape: "S3r"
                },
                processingConfig: {
                  type: "structure",
                  required: [
                    "computeLocation"
                  ],
                  members: {
                    computeLocation: {},
                    forwardingConfig: {
                      shape: "S3n"
                    }
                  }
                }
              }
            },
            metric: {
              type: "structure",
              required: [
                "expression",
                "variables",
                "window"
              ],
              members: {
                expression: {},
                variables: {
                  shape: "S3r"
                },
                window: {
                  type: "structure",
                  members: {
                    tumbling: {
                      type: "structure",
                      required: [
                        "interval"
                      ],
                      members: {
                        interval: {},
                        offset: {}
                      }
                    }
                  }
                },
                processingConfig: {
                  type: "structure",
                  required: [
                    "computeLocation"
                  ],
                  members: {
                    computeLocation: {}
                  }
                }
              }
            }
          }
        },
        S3n: {
          type: "structure",
          required: [
            "state"
          ],
          members: {
            state: {}
          }
        },
        S3r: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "value"
            ],
            members: {
              name: {},
              value: {
                type: "structure",
                members: {
                  propertyId: {},
                  hierarchyId: {},
                  propertyPath: {
                    shape: "S3w"
                  }
                }
              }
            }
          }
        },
        S3w: {
          type: "list",
          member: {
            type: "structure",
            members: {
              id: {},
              name: {}
            }
          }
        },
        S4c: {
          type: "structure",
          required: [
            "state"
          ],
          members: {
            state: {},
            error: {
              shape: "S37"
            }
          }
        },
        S4g: {
          type: "list",
          member: {
            type: "structure",
            members: {
              id: {},
              name: {}
            }
          }
        },
        S4j: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "bucket",
              "key"
            ],
            members: {
              bucket: {},
              key: {},
              versionId: {}
            }
          }
        },
        S4n: {
          type: "structure",
          required: [
            "bucket",
            "prefix"
          ],
          members: {
            bucket: {},
            prefix: {}
          }
        },
        S4o: {
          type: "structure",
          required: [
            "fileFormat"
          ],
          members: {
            fileFormat: {
              type: "structure",
              members: {
                csv: {
                  type: "structure",
                  required: [
                    "columnNames"
                  ],
                  members: {
                    columnNames: {
                      type: "list",
                      member: {}
                    }
                  }
                },
                parquet: {
                  type: "structure",
                  members: {}
                }
              }
            }
          }
        },
        S52: {
          type: "structure",
          members: {
            greengrass: {
              type: "structure",
              required: [
                "groupArn"
              ],
              members: {
                groupArn: {}
              }
            },
            greengrassV2: {
              type: "structure",
              required: [
                "coreDeviceThingName"
              ],
              members: {
                coreDeviceThingName: {}
              }
            }
          }
        },
        S59: {
          type: "structure",
          required: [
            "data",
            "type"
          ],
          members: {
            data: {
              type: "blob"
            },
            type: {}
          }
        },
        S5d: {
          type: "structure",
          required: [
            "alarmRoleArn"
          ],
          members: {
            alarmRoleArn: {},
            notificationLambdaArn: {}
          }
        },
        S5g: {
          type: "structure",
          required: [
            "state"
          ],
          members: {
            state: {},
            error: {
              type: "structure",
              members: {
                code: {},
                message: {}
              }
            }
          }
        },
        S68: {
          type: "structure",
          required: [
            "assetId"
          ],
          members: {
            assetId: {}
          }
        },
        S69: {
          type: "structure",
          required: [
            "stringValue"
          ],
          members: {
            stringValue: {}
          }
        },
        S6e: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "id",
              "name",
              "dataType"
            ],
            members: {
              id: {},
              name: {},
              alias: {},
              notification: {
                shape: "S6g"
              },
              dataType: {},
              dataTypeSpec: {},
              unit: {},
              path: {
                shape: "S6j"
              },
              externalId: {}
            }
          }
        },
        S6g: {
          type: "structure",
          required: [
            "topic",
            "state"
          ],
          members: {
            topic: {},
            state: {}
          }
        },
        S6j: {
          type: "list",
          member: {
            type: "structure",
            members: {
              id: {},
              name: {}
            }
          }
        },
        S6l: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              id: {},
              name: {},
              externalId: {}
            }
          }
        },
        S6p: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "id",
              "name",
              "type",
              "description",
              "path"
            ],
            members: {
              id: {},
              externalId: {},
              name: {},
              type: {},
              description: {},
              path: {
                shape: "S6r"
              }
            }
          }
        },
        S6r: {
          type: "list",
          member: {
            type: "structure",
            members: {
              id: {},
              name: {}
            }
          }
        },
        S6v: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "actionDefinitionId",
              "actionName",
              "actionType"
            ],
            members: {
              actionDefinitionId: {},
              actionName: {},
              actionType: {}
            }
          }
        },
        S6z: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "dataType",
              "type"
            ],
            members: {
              id: {},
              name: {},
              dataType: {},
              dataTypeSpec: {},
              unit: {},
              type: {
                shape: "S3i"
              },
              path: {
                shape: "S3w"
              },
              externalId: {}
            }
          }
        },
        S71: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "childAssetModelId"
            ],
            members: {
              id: {},
              name: {},
              childAssetModelId: {},
              externalId: {}
            }
          }
        },
        S73: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "type"
            ],
            members: {
              name: {},
              description: {},
              type: {},
              properties: {
                shape: "S6z"
              },
              id: {},
              externalId: {}
            }
          }
        },
        S75: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "id",
              "name",
              "type"
            ],
            members: {
              id: {},
              externalId: {},
              name: {},
              type: {},
              description: {},
              path: {
                shape: "S4g"
              }
            }
          }
        },
        S7e: {
          type: "structure",
          required: [
            "id",
            "name",
            "dataType"
          ],
          members: {
            id: {},
            name: {},
            alias: {},
            notification: {
              shape: "S6g"
            },
            dataType: {},
            unit: {},
            type: {
              shape: "S3i"
            },
            path: {
              shape: "S6j"
            },
            externalId: {}
          }
        },
        S7n: {
          type: "structure",
          required: [
            "state"
          ],
          members: {
            state: {},
            error: {
              type: "structure",
              required: [
                "code",
                "message"
              ],
              members: {
                code: {},
                message: {}
              }
            }
          }
        },
        S7s: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "capabilityNamespace",
              "capabilitySyncStatus"
            ],
            members: {
              capabilityNamespace: {},
              capabilitySyncStatus: {}
            }
          }
        },
        S81: {
          type: "structure",
          required: [
            "level"
          ],
          members: {
            level: {}
          }
        },
        S8c: {
          type: "structure",
          required: [
            "customerManagedS3Storage"
          ],
          members: {
            customerManagedS3Storage: {
              type: "structure",
              required: [
                "s3ResourceArn",
                "roleArn"
              ],
              members: {
                s3ResourceArn: {},
                roleArn: {}
              }
            }
          }
        },
        S8f: {
          type: "structure",
          members: {
            numberOfDays: {
              type: "integer"
            },
            unlimited: {
              type: "boolean"
            }
          }
        },
        S8j: {
          type: "structure",
          members: {
            numberOfDays: {
              type: "integer"
            },
            unlimited: {
              type: "boolean"
            }
          }
        },
        S91: {
          type: "structure",
          required: [
            "data"
          ],
          members: {
            data: {
              shape: "S92"
            }
          }
        },
        S92: {
          type: "list",
          member: {
            type: "structure",
            members: {
              scalarValue: {},
              arrayValue: {
                shape: "S92"
              },
              rowValue: {
                shape: "S91"
              },
              nullValue: {
                type: "boolean"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iotsitewise-2019-12-02.paginators.json
var require_iotsitewise_2019_12_02_paginators = __commonJS({
  "node_modules/aws-sdk/apis/iotsitewise-2019-12-02.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        BatchGetAssetPropertyAggregates: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        BatchGetAssetPropertyValue: {
          input_token: "nextToken",
          output_token: "nextToken"
        },
        BatchGetAssetPropertyValueHistory: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ExecuteQuery: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "rows"
        },
        GetAssetPropertyAggregates: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "aggregatedValues"
        },
        GetAssetPropertyValueHistory: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "assetPropertyValueHistory"
        },
        GetInterpolatedAssetPropertyValues: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "interpolatedAssetPropertyValues"
        },
        ListAccessPolicies: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "accessPolicySummaries"
        },
        ListActions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "actionSummaries"
        },
        ListAssetModelCompositeModels: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "assetModelCompositeModelSummaries"
        },
        ListAssetModelProperties: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "assetModelPropertySummaries"
        },
        ListAssetModels: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "assetModelSummaries"
        },
        ListAssetProperties: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "assetPropertySummaries"
        },
        ListAssetRelationships: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "assetRelationshipSummaries"
        },
        ListAssets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "assetSummaries"
        },
        ListAssociatedAssets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "assetSummaries"
        },
        ListBulkImportJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "jobSummaries"
        },
        ListCompositionRelationships: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "compositionRelationshipSummaries"
        },
        ListDashboards: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "dashboardSummaries"
        },
        ListGateways: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "gatewaySummaries"
        },
        ListPortals: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "portalSummaries"
        },
        ListProjectAssets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "assetIds"
        },
        ListProjects: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "projectSummaries"
        },
        ListTimeSeries: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "TimeSeriesSummaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iotsitewise-2019-12-02.waiters2.json
var require_iotsitewise_2019_12_02_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/iotsitewise-2019-12-02.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        AssetModelNotExists: {
          delay: 3,
          maxAttempts: 20,
          operation: "DescribeAssetModel",
          acceptors: [
            {
              state: "success",
              matcher: "error",
              expected: "ResourceNotFoundException"
            }
          ]
        },
        AssetModelActive: {
          delay: 3,
          maxAttempts: 20,
          operation: "DescribeAssetModel",
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "assetModelStatus.state",
              expected: "ACTIVE"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "assetModelStatus.state",
              expected: "FAILED"
            }
          ]
        },
        AssetNotExists: {
          delay: 3,
          maxAttempts: 20,
          operation: "DescribeAsset",
          acceptors: [
            {
              state: "success",
              matcher: "error",
              expected: "ResourceNotFoundException"
            }
          ]
        },
        AssetActive: {
          delay: 3,
          maxAttempts: 20,
          operation: "DescribeAsset",
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "assetStatus.state",
              expected: "ACTIVE"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "assetStatus.state",
              expected: "FAILED"
            }
          ]
        },
        PortalNotExists: {
          delay: 3,
          maxAttempts: 20,
          operation: "DescribePortal",
          acceptors: [
            {
              state: "success",
              matcher: "error",
              expected: "ResourceNotFoundException"
            }
          ]
        },
        PortalActive: {
          delay: 3,
          maxAttempts: 20,
          operation: "DescribePortal",
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "portalStatus.state",
              expected: "ACTIVE"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/iotsitewise.js
var require_iotsitewise = __commonJS({
  "node_modules/aws-sdk/clients/iotsitewise.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["iotsitewise"] = {};
    AWS2.IoTSiteWise = Service.defineService("iotsitewise", ["2019-12-02"]);
    Object.defineProperty(apiLoader.services["iotsitewise"], "2019-12-02", {
      get: function get() {
        var model = require_iotsitewise_2019_12_02_min();
        model.paginators = require_iotsitewise_2019_12_02_paginators().pagination;
        model.waiters = require_iotsitewise_2019_12_02_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.IoTSiteWise;
  }
});

// node_modules/aws-sdk/apis/macie2-2020-01-01.min.json
var require_macie2_2020_01_01_min = __commonJS({
  "node_modules/aws-sdk/apis/macie2-2020-01-01.min.json"(exports2, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2020-01-01",
        endpointPrefix: "macie2",
        signingName: "macie2",
        serviceFullName: "Amazon Macie 2",
        serviceId: "Macie2",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "macie2-2020-01-01",
        signatureVersion: "v4"
      },
      operations: {
        AcceptInvitation: {
          http: {
            requestUri: "/invitations/accept",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              administratorAccountId: {
                locationName: "administratorAccountId"
              },
              invitationId: {
                locationName: "invitationId"
              },
              masterAccount: {
                locationName: "masterAccount"
              }
            },
            required: [
              "invitationId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        BatchGetCustomDataIdentifiers: {
          http: {
            requestUri: "/custom-data-identifiers/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ids: {
                shape: "S5",
                locationName: "ids"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              customDataIdentifiers: {
                locationName: "customDataIdentifiers",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {
                      locationName: "arn"
                    },
                    createdAt: {
                      shape: "S9",
                      locationName: "createdAt"
                    },
                    deleted: {
                      locationName: "deleted",
                      type: "boolean"
                    },
                    description: {
                      locationName: "description"
                    },
                    id: {
                      locationName: "id"
                    },
                    name: {
                      locationName: "name"
                    }
                  }
                }
              },
              notFoundIdentifierIds: {
                shape: "S5",
                locationName: "notFoundIdentifierIds"
              }
            }
          }
        },
        CreateAllowList: {
          http: {
            requestUri: "/allow-lists",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              clientToken: {
                locationName: "clientToken",
                idempotencyToken: true
              },
              criteria: {
                shape: "Sc",
                locationName: "criteria"
              },
              description: {
                locationName: "description"
              },
              name: {
                locationName: "name"
              },
              tags: {
                shape: "Si",
                locationName: "tags"
              }
            },
            required: [
              "criteria",
              "clientToken",
              "name"
            ]
          },
          output: {
            type: "structure",
            members: {
              arn: {
                locationName: "arn"
              },
              id: {
                locationName: "id"
              }
            }
          }
        },
        CreateClassificationJob: {
          http: {
            requestUri: "/jobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              allowListIds: {
                shape: "S5",
                locationName: "allowListIds"
              },
              clientToken: {
                locationName: "clientToken",
                idempotencyToken: true
              },
              customDataIdentifierIds: {
                shape: "S5",
                locationName: "customDataIdentifierIds"
              },
              description: {
                locationName: "description"
              },
              initialRun: {
                locationName: "initialRun",
                type: "boolean"
              },
              jobType: {
                locationName: "jobType"
              },
              managedDataIdentifierIds: {
                shape: "S5",
                locationName: "managedDataIdentifierIds"
              },
              managedDataIdentifierSelector: {
                locationName: "managedDataIdentifierSelector"
              },
              name: {
                locationName: "name"
              },
              s3JobDefinition: {
                shape: "Sp",
                locationName: "s3JobDefinition"
              },
              samplingPercentage: {
                locationName: "samplingPercentage",
                type: "integer"
              },
              scheduleFrequency: {
                shape: "S1d",
                locationName: "scheduleFrequency"
              },
              tags: {
                shape: "Si",
                locationName: "tags"
              }
            },
            required: [
              "s3JobDefinition",
              "jobType",
              "clientToken",
              "name"
            ]
          },
          output: {
            type: "structure",
            members: {
              jobArn: {
                locationName: "jobArn"
              },
              jobId: {
                locationName: "jobId"
              }
            }
          }
        },
        CreateCustomDataIdentifier: {
          http: {
            requestUri: "/custom-data-identifiers",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              clientToken: {
                locationName: "clientToken",
                idempotencyToken: true
              },
              description: {
                locationName: "description"
              },
              ignoreWords: {
                shape: "S5",
                locationName: "ignoreWords"
              },
              keywords: {
                shape: "S5",
                locationName: "keywords"
              },
              maximumMatchDistance: {
                locationName: "maximumMatchDistance",
                type: "integer"
              },
              name: {
                locationName: "name"
              },
              regex: {
                locationName: "regex"
              },
              severityLevels: {
                shape: "S1k",
                locationName: "severityLevels"
              },
              tags: {
                shape: "Si",
                locationName: "tags"
              }
            },
            required: [
              "regex",
              "name"
            ]
          },
          output: {
            type: "structure",
            members: {
              customDataIdentifierId: {
                locationName: "customDataIdentifierId"
              }
            }
          }
        },
        CreateFindingsFilter: {
          http: {
            requestUri: "/findingsfilters",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              action: {
                locationName: "action"
              },
              clientToken: {
                locationName: "clientToken",
                idempotencyToken: true
              },
              description: {
                locationName: "description"
              },
              findingCriteria: {
                shape: "S1r",
                locationName: "findingCriteria"
              },
              name: {
                locationName: "name"
              },
              position: {
                locationName: "position",
                type: "integer"
              },
              tags: {
                shape: "Si",
                locationName: "tags"
              }
            },
            required: [
              "action",
              "findingCriteria",
              "name"
            ]
          },
          output: {
            type: "structure",
            members: {
              arn: {
                locationName: "arn"
              },
              id: {
                locationName: "id"
              }
            }
          }
        },
        CreateInvitations: {
          http: {
            requestUri: "/invitations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              accountIds: {
                shape: "S5",
                locationName: "accountIds"
              },
              disableEmailNotification: {
                locationName: "disableEmailNotification",
                type: "boolean"
              },
              message: {
                locationName: "message"
              }
            },
            required: [
              "accountIds"
            ]
          },
          output: {
            type: "structure",
            members: {
              unprocessedAccounts: {
                shape: "S1x",
                locationName: "unprocessedAccounts"
              }
            }
          }
        },
        CreateMember: {
          http: {
            requestUri: "/members",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              account: {
                locationName: "account",
                type: "structure",
                members: {
                  accountId: {
                    locationName: "accountId"
                  },
                  email: {
                    locationName: "email"
                  }
                },
                required: [
                  "email",
                  "accountId"
                ]
              },
              tags: {
                shape: "Si",
                locationName: "tags"
              }
            },
            required: [
              "account"
            ]
          },
          output: {
            type: "structure",
            members: {
              arn: {
                locationName: "arn"
              }
            }
          }
        },
        CreateSampleFindings: {
          http: {
            requestUri: "/findings/sample",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              findingTypes: {
                locationName: "findingTypes",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeclineInvitations: {
          http: {
            requestUri: "/invitations/decline",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              accountIds: {
                shape: "S5",
                locationName: "accountIds"
              }
            },
            required: [
              "accountIds"
            ]
          },
          output: {
            type: "structure",
            members: {
              unprocessedAccounts: {
                shape: "S1x",
                locationName: "unprocessedAccounts"
              }
            }
          }
        },
        DeleteAllowList: {
          http: {
            method: "DELETE",
            requestUri: "/allow-lists/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              ignoreJobChecks: {
                location: "querystring",
                locationName: "ignoreJobChecks"
              }
            },
            required: [
              "id"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteCustomDataIdentifier: {
          http: {
            method: "DELETE",
            requestUri: "/custom-data-identifiers/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "id"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteFindingsFilter: {
          http: {
            method: "DELETE",
            requestUri: "/findingsfilters/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "id"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteInvitations: {
          http: {
            requestUri: "/invitations/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              accountIds: {
                shape: "S5",
                locationName: "accountIds"
              }
            },
            required: [
              "accountIds"
            ]
          },
          output: {
            type: "structure",
            members: {
              unprocessedAccounts: {
                shape: "S1x",
                locationName: "unprocessedAccounts"
              }
            }
          }
        },
        DeleteMember: {
          http: {
            method: "DELETE",
            requestUri: "/members/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "id"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeBuckets: {
          http: {
            requestUri: "/datasources/s3",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              criteria: {
                locationName: "criteria",
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    eq: {
                      shape: "S5",
                      locationName: "eq"
                    },
                    gt: {
                      locationName: "gt",
                      type: "long"
                    },
                    gte: {
                      locationName: "gte",
                      type: "long"
                    },
                    lt: {
                      locationName: "lt",
                      type: "long"
                    },
                    lte: {
                      locationName: "lte",
                      type: "long"
                    },
                    neq: {
                      shape: "S5",
                      locationName: "neq"
                    },
                    prefix: {
                      locationName: "prefix"
                    }
                  }
                }
              },
              maxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                locationName: "nextToken"
              },
              sortCriteria: {
                locationName: "sortCriteria",
                type: "structure",
                members: {
                  attributeName: {
                    locationName: "attributeName"
                  },
                  orderBy: {
                    locationName: "orderBy"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              buckets: {
                locationName: "buckets",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    accountId: {
                      locationName: "accountId"
                    },
                    allowsUnencryptedObjectUploads: {
                      locationName: "allowsUnencryptedObjectUploads"
                    },
                    bucketArn: {
                      locationName: "bucketArn"
                    },
                    bucketCreatedAt: {
                      shape: "S9",
                      locationName: "bucketCreatedAt"
                    },
                    bucketName: {
                      locationName: "bucketName"
                    },
                    classifiableObjectCount: {
                      locationName: "classifiableObjectCount",
                      type: "long"
                    },
                    classifiableSizeInBytes: {
                      locationName: "classifiableSizeInBytes",
                      type: "long"
                    },
                    errorCode: {
                      locationName: "errorCode"
                    },
                    errorMessage: {
                      locationName: "errorMessage"
                    },
                    jobDetails: {
                      shape: "S2t",
                      locationName: "jobDetails"
                    },
                    lastAutomatedDiscoveryTime: {
                      shape: "S9",
                      locationName: "lastAutomatedDiscoveryTime"
                    },
                    lastUpdated: {
                      shape: "S9",
                      locationName: "lastUpdated"
                    },
                    objectCount: {
                      locationName: "objectCount",
                      type: "long"
                    },
                    objectCountByEncryptionType: {
                      shape: "S2w",
                      locationName: "objectCountByEncryptionType"
                    },
                    publicAccess: {
                      shape: "S2x",
                      locationName: "publicAccess"
                    },
                    region: {
                      locationName: "region"
                    },
                    replicationDetails: {
                      locationName: "replicationDetails",
                      type: "structure",
                      members: {
                        replicated: {
                          locationName: "replicated",
                          type: "boolean"
                        },
                        replicatedExternally: {
                          locationName: "replicatedExternally",
                          type: "boolean"
                        },
                        replicationAccounts: {
                          shape: "S5",
                          locationName: "replicationAccounts"
                        }
                      }
                    },
                    sensitivityScore: {
                      locationName: "sensitivityScore",
                      type: "integer"
                    },
                    serverSideEncryption: {
                      locationName: "serverSideEncryption",
                      type: "structure",
                      members: {
                        kmsMasterKeyId: {
                          locationName: "kmsMasterKeyId"
                        },
                        type: {
                          locationName: "type"
                        }
                      }
                    },
                    sharedAccess: {
                      locationName: "sharedAccess"
                    },
                    sizeInBytes: {
                      locationName: "sizeInBytes",
                      type: "long"
                    },
                    sizeInBytesCompressed: {
                      locationName: "sizeInBytesCompressed",
                      type: "long"
                    },
                    tags: {
                      locationName: "tags",
                      type: "list",
                      member: {
                        shape: "S3a"
                      }
                    },
                    unclassifiableObjectCount: {
                      shape: "S3b",
                      locationName: "unclassifiableObjectCount"
                    },
                    unclassifiableObjectSizeInBytes: {
                      shape: "S3b",
                      locationName: "unclassifiableObjectSizeInBytes"
                    },
                    versioning: {
                      locationName: "versioning",
                      type: "boolean"
                    }
                  }
                }
              },
              nextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeClassificationJob: {
          http: {
            method: "GET",
            requestUri: "/jobs/{jobId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              }
            },
            required: [
              "jobId"
            ]
          },
          output: {
            type: "structure",
            members: {
              allowListIds: {
                shape: "S5",
                locationName: "allowListIds"
              },
              clientToken: {
                locationName: "clientToken",
                idempotencyToken: true
              },
              createdAt: {
                shape: "S9",
                locationName: "createdAt"
              },
              customDataIdentifierIds: {
                shape: "S5",
                locationName: "customDataIdentifierIds"
              },
              description: {
                locationName: "description"
              },
              initialRun: {
                locationName: "initialRun",
                type: "boolean"
              },
              jobArn: {
                locationName: "jobArn"
              },
              jobId: {
                locationName: "jobId"
              },
              jobStatus: {
                locationName: "jobStatus"
              },
              jobType: {
                locationName: "jobType"
              },
              lastRunErrorStatus: {
                shape: "S3f",
                locationName: "lastRunErrorStatus"
              },
              lastRunTime: {
                shape: "S9",
                locationName: "lastRunTime"
              },
              managedDataIdentifierIds: {
                shape: "S5",
                locationName: "managedDataIdentifierIds"
              },
              managedDataIdentifierSelector: {
                locationName: "managedDataIdentifierSelector"
              },
              name: {
                locationName: "name"
              },
              s3JobDefinition: {
                shape: "Sp",
                locationName: "s3JobDefinition"
              },
              samplingPercentage: {
                locationName: "samplingPercentage",
                type: "integer"
              },
              scheduleFrequency: {
                shape: "S1d",
                locationName: "scheduleFrequency"
              },
              statistics: {
                locationName: "statistics",
                type: "structure",
                members: {
                  approximateNumberOfObjectsToProcess: {
                    locationName: "approximateNumberOfObjectsToProcess",
                    type: "double"
                  },
                  numberOfRuns: {
                    locationName: "numberOfRuns",
                    type: "double"
                  }
                }
              },
              tags: {
                shape: "Si",
                locationName: "tags"
              },
              userPausedDetails: {
                shape: "S3j",
                locationName: "userPausedDetails"
              }
            }
          }
        },
        DescribeOrganizationConfiguration: {
          http: {
            method: "GET",
            requestUri: "/admin/configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              autoEnable: {
                locationName: "autoEnable",
                type: "boolean"
              },
              maxAccountLimitReached: {
                locationName: "maxAccountLimitReached",
                type: "boolean"
              }
            }
          }
        },
        DisableMacie: {
          http: {
            method: "DELETE",
            requestUri: "/macie",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisableOrganizationAdminAccount: {
          http: {
            method: "DELETE",
            requestUri: "/admin",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              adminAccountId: {
                location: "querystring",
                locationName: "adminAccountId"
              }
            },
            required: [
              "adminAccountId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateFromAdministratorAccount: {
          http: {
            requestUri: "/administrator/disassociate",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateFromMasterAccount: {
          http: {
            requestUri: "/master/disassociate",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateMember: {
          http: {
            requestUri: "/members/disassociate/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "id"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        EnableMacie: {
          http: {
            requestUri: "/macie",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              clientToken: {
                locationName: "clientToken",
                idempotencyToken: true
              },
              findingPublishingFrequency: {
                locationName: "findingPublishingFrequency"
              },
              status: {
                locationName: "status"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        EnableOrganizationAdminAccount: {
          http: {
            requestUri: "/admin",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              adminAccountId: {
                locationName: "adminAccountId"
              },
              clientToken: {
                locationName: "clientToken",
                idempotencyToken: true
              }
            },
            required: [
              "adminAccountId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetAdministratorAccount: {
          http: {
            method: "GET",
            requestUri: "/administrator",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              administrator: {
                shape: "S44",
                locationName: "administrator"
              }
            }
          }
        },
        GetAllowList: {
          http: {
            method: "GET",
            requestUri: "/allow-lists/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "id"
            ]
          },
          output: {
            type: "structure",
            members: {
              arn: {
                locationName: "arn"
              },
              createdAt: {
                shape: "S9",
                locationName: "createdAt"
              },
              criteria: {
                shape: "Sc",
                locationName: "criteria"
              },
              description: {
                locationName: "description"
              },
              id: {
                locationName: "id"
              },
              name: {
                locationName: "name"
              },
              status: {
                locationName: "status",
                type: "structure",
                members: {
                  code: {
                    locationName: "code"
                  },
                  description: {
                    locationName: "description"
                  }
                },
                required: [
                  "code"
                ]
              },
              tags: {
                shape: "Si",
                locationName: "tags"
              },
              updatedAt: {
                shape: "S9",
                locationName: "updatedAt"
              }
            }
          }
        },
        GetAutomatedDiscoveryConfiguration: {
          http: {
            method: "GET",
            requestUri: "/automated-discovery/configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              classificationScopeId: {
                locationName: "classificationScopeId"
              },
              disabledAt: {
                shape: "S4d",
                locationName: "disabledAt"
              },
              firstEnabledAt: {
                shape: "S4d",
                locationName: "firstEnabledAt"
              },
              lastUpdatedAt: {
                shape: "S4d",
                locationName: "lastUpdatedAt"
              },
              sensitivityInspectionTemplateId: {
                locationName: "sensitivityInspectionTemplateId"
              },
              status: {
                locationName: "status"
              }
            }
          }
        },
        GetBucketStatistics: {
          http: {
            requestUri: "/datasources/s3/statistics",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              accountId: {
                locationName: "accountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              bucketCount: {
                locationName: "bucketCount",
                type: "long"
              },
              bucketCountByEffectivePermission: {
                locationName: "bucketCountByEffectivePermission",
                type: "structure",
                members: {
                  publiclyAccessible: {
                    locationName: "publiclyAccessible",
                    type: "long"
                  },
                  publiclyReadable: {
                    locationName: "publiclyReadable",
                    type: "long"
                  },
                  publiclyWritable: {
                    locationName: "publiclyWritable",
                    type: "long"
                  },
                  unknown: {
                    locationName: "unknown",
                    type: "long"
                  }
                }
              },
              bucketCountByEncryptionType: {
                locationName: "bucketCountByEncryptionType",
                type: "structure",
                members: {
                  kmsManaged: {
                    locationName: "kmsManaged",
                    type: "long"
                  },
                  s3Managed: {
                    locationName: "s3Managed",
                    type: "long"
                  },
                  unencrypted: {
                    locationName: "unencrypted",
                    type: "long"
                  },
                  unknown: {
                    locationName: "unknown",
                    type: "long"
                  }
                }
              },
              bucketCountByObjectEncryptionRequirement: {
                locationName: "bucketCountByObjectEncryptionRequirement",
                type: "structure",
                members: {
                  allowsUnencryptedObjectUploads: {
                    locationName: "allowsUnencryptedObjectUploads",
                    type: "long"
                  },
                  deniesUnencryptedObjectUploads: {
                    locationName: "deniesUnencryptedObjectUploads",
                    type: "long"
                  },
                  unknown: {
                    locationName: "unknown",
                    type: "long"
                  }
                }
              },
              bucketCountBySharedAccessType: {
                locationName: "bucketCountBySharedAccessType",
                type: "structure",
                members: {
                  external: {
                    locationName: "external",
                    type: "long"
                  },
                  internal: {
                    locationName: "internal",
                    type: "long"
                  },
                  notShared: {
                    locationName: "notShared",
                    type: "long"
                  },
                  unknown: {
                    locationName: "unknown",
                    type: "long"
                  }
                }
              },
              bucketStatisticsBySensitivity: {
                locationName: "bucketStatisticsBySensitivity",
                type: "structure",
                members: {
                  classificationError: {
                    shape: "S4n",
                    locationName: "classificationError"
                  },
                  notClassified: {
                    shape: "S4n",
                    locationName: "notClassified"
                  },
                  notSensitive: {
                    shape: "S4n",
                    locationName: "notSensitive"
                  },
                  sensitive: {
                    shape: "S4n",
                    locationName: "sensitive"
                  }
                }
              },
              classifiableObjectCount: {
                locationName: "classifiableObjectCount",
                type: "long"
              },
              classifiableSizeInBytes: {
                locationName: "classifiableSizeInBytes",
                type: "long"
              },
              lastUpdated: {
                shape: "S9",
                locationName: "lastUpdated"
              },
              objectCount: {
                locationName: "objectCount",
                type: "long"
              },
              sizeInBytes: {
                locationName: "sizeInBytes",
                type: "long"
              },
              sizeInBytesCompressed: {
                locationName: "sizeInBytesCompressed",
                type: "long"
              },
              unclassifiableObjectCount: {
                shape: "S3b",
                locationName: "unclassifiableObjectCount"
              },
              unclassifiableObjectSizeInBytes: {
                shape: "S3b",
                locationName: "unclassifiableObjectSizeInBytes"
              }
            }
          }
        },
        GetClassificationExportConfiguration: {
          http: {
            method: "GET",
            requestUri: "/classification-export-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              configuration: {
                shape: "S4q",
                locationName: "configuration"
              }
            }
          }
        },
        GetClassificationScope: {
          http: {
            method: "GET",
            requestUri: "/classification-scopes/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "id"
            ]
          },
          output: {
            type: "structure",
            members: {
              id: {
                locationName: "id"
              },
              name: {
                locationName: "name"
              },
              s3: {
                locationName: "s3",
                type: "structure",
                members: {
                  excludes: {
                    locationName: "excludes",
                    type: "structure",
                    members: {
                      bucketNames: {
                        shape: "S4x",
                        locationName: "bucketNames"
                      }
                    },
                    required: [
                      "bucketNames"
                    ]
                  }
                },
                required: [
                  "excludes"
                ]
              }
            }
          }
        },
        GetCustomDataIdentifier: {
          http: {
            method: "GET",
            requestUri: "/custom-data-identifiers/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "id"
            ]
          },
          output: {
            type: "structure",
            members: {
              arn: {
                locationName: "arn"
              },
              createdAt: {
                shape: "S9",
                locationName: "createdAt"
              },
              deleted: {
                locationName: "deleted",
                type: "boolean"
              },
              description: {
                locationName: "description"
              },
              id: {
                locationName: "id"
              },
              ignoreWords: {
                shape: "S5",
                locationName: "ignoreWords"
              },
              keywords: {
                shape: "S5",
                locationName: "keywords"
              },
              maximumMatchDistance: {
                locationName: "maximumMatchDistance",
                type: "integer"
              },
              name: {
                locationName: "name"
              },
              regex: {
                locationName: "regex"
              },
              severityLevels: {
                shape: "S1k",
                locationName: "severityLevels"
              },
              tags: {
                shape: "Si",
                locationName: "tags"
              }
            }
          }
        },
        GetFindingStatistics: {
          http: {
            requestUri: "/findings/statistics",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              findingCriteria: {
                shape: "S1r",
                locationName: "findingCriteria"
              },
              groupBy: {
                locationName: "groupBy"
              },
              size: {
                locationName: "size",
                type: "integer"
              },
              sortCriteria: {
                locationName: "sortCriteria",
                type: "structure",
                members: {
                  attributeName: {
                    locationName: "attributeName"
                  },
                  orderBy: {
                    locationName: "orderBy"
                  }
                }
              }
            },
            required: [
              "groupBy"
            ]
          },
          output: {
            type: "structure",
            members: {
              countsByGroup: {
                locationName: "countsByGroup",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    count: {
                      locationName: "count",
                      type: "long"
                    },
                    groupKey: {
                      locationName: "groupKey"
                    }
                  }
                }
              }
            }
          }
        },
        GetFindings: {
          http: {
            requestUri: "/findings/describe",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              findingIds: {
                shape: "S5",
                locationName: "findingIds"
              },
              sortCriteria: {
                shape: "S59",
                locationName: "sortCriteria"
              }
            },
            required: [
              "findingIds"
            ]
          },
          output: {
            type: "structure",
            members: {
              findings: {
                locationName: "findings",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    accountId: {
                      locationName: "accountId"
                    },
                    archived: {
                      locationName: "archived",
                      type: "boolean"
                    },
                    category: {
                      locationName: "category"
                    },
                    classificationDetails: {
                      locationName: "classificationDetails",
                      type: "structure",
                      members: {
                        detailedResultsLocation: {
                          locationName: "detailedResultsLocation"
                        },
                        jobArn: {
                          locationName: "jobArn"
                        },
                        jobId: {
                          locationName: "jobId"
                        },
                        originType: {
                          locationName: "originType"
                        },
                        result: {
                          locationName: "result",
                          type: "structure",
                          members: {
                            additionalOccurrences: {
                              locationName: "additionalOccurrences",
                              type: "boolean"
                            },
                            customDataIdentifiers: {
                              locationName: "customDataIdentifiers",
                              type: "structure",
                              members: {
                                detections: {
                                  locationName: "detections",
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      arn: {
                                        locationName: "arn"
                                      },
                                      count: {
                                        locationName: "count",
                                        type: "long"
                                      },
                                      name: {
                                        locationName: "name"
                                      },
                                      occurrences: {
                                        shape: "S5k",
                                        locationName: "occurrences"
                                      }
                                    }
                                  }
                                },
                                totalCount: {
                                  locationName: "totalCount",
                                  type: "long"
                                }
                              }
                            },
                            mimeType: {
                              locationName: "mimeType"
                            },
                            sensitiveData: {
                              locationName: "sensitiveData",
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  category: {
                                    locationName: "category"
                                  },
                                  detections: {
                                    locationName: "detections",
                                    type: "list",
                                    member: {
                                      type: "structure",
                                      members: {
                                        count: {
                                          locationName: "count",
                                          type: "long"
                                        },
                                        occurrences: {
                                          shape: "S5k",
                                          locationName: "occurrences"
                                        },
                                        type: {
                                          locationName: "type"
                                        }
                                      }
                                    }
                                  },
                                  totalCount: {
                                    locationName: "totalCount",
                                    type: "long"
                                  }
                                }
                              }
                            },
                            sizeClassified: {
                              locationName: "sizeClassified",
                              type: "long"
                            },
                            status: {
                              locationName: "status",
                              type: "structure",
                              members: {
                                code: {
                                  locationName: "code"
                                },
                                reason: {
                                  locationName: "reason"
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    count: {
                      locationName: "count",
                      type: "long"
                    },
                    createdAt: {
                      shape: "S9",
                      locationName: "createdAt"
                    },
                    description: {
                      locationName: "description"
                    },
                    id: {
                      locationName: "id"
                    },
                    partition: {
                      locationName: "partition"
                    },
                    policyDetails: {
                      locationName: "policyDetails",
                      type: "structure",
                      members: {
                        action: {
                          locationName: "action",
                          type: "structure",
                          members: {
                            actionType: {
                              locationName: "actionType"
                            },
                            apiCallDetails: {
                              locationName: "apiCallDetails",
                              type: "structure",
                              members: {
                                api: {
                                  locationName: "api"
                                },
                                apiServiceName: {
                                  locationName: "apiServiceName"
                                },
                                firstSeen: {
                                  shape: "S9",
                                  locationName: "firstSeen"
                                },
                                lastSeen: {
                                  shape: "S9",
                                  locationName: "lastSeen"
                                }
                              }
                            }
                          }
                        },
                        actor: {
                          locationName: "actor",
                          type: "structure",
                          members: {
                            domainDetails: {
                              locationName: "domainDetails",
                              type: "structure",
                              members: {
                                domainName: {
                                  locationName: "domainName"
                                }
                              }
                            },
                            ipAddressDetails: {
                              locationName: "ipAddressDetails",
                              type: "structure",
                              members: {
                                ipAddressV4: {
                                  locationName: "ipAddressV4"
                                },
                                ipCity: {
                                  locationName: "ipCity",
                                  type: "structure",
                                  members: {
                                    name: {
                                      locationName: "name"
                                    }
                                  }
                                },
                                ipCountry: {
                                  locationName: "ipCountry",
                                  type: "structure",
                                  members: {
                                    code: {
                                      locationName: "code"
                                    },
                                    name: {
                                      locationName: "name"
                                    }
                                  }
                                },
                                ipGeoLocation: {
                                  locationName: "ipGeoLocation",
                                  type: "structure",
                                  members: {
                                    lat: {
                                      locationName: "lat",
                                      type: "double"
                                    },
                                    lon: {
                                      locationName: "lon",
                                      type: "double"
                                    }
                                  }
                                },
                                ipOwner: {
                                  locationName: "ipOwner",
                                  type: "structure",
                                  members: {
                                    asn: {
                                      locationName: "asn"
                                    },
                                    asnOrg: {
                                      locationName: "asnOrg"
                                    },
                                    isp: {
                                      locationName: "isp"
                                    },
                                    org: {
                                      locationName: "org"
                                    }
                                  }
                                }
                              }
                            },
                            userIdentity: {
                              locationName: "userIdentity",
                              type: "structure",
                              members: {
                                assumedRole: {
                                  locationName: "assumedRole",
                                  type: "structure",
                                  members: {
                                    accessKeyId: {
                                      locationName: "accessKeyId"
                                    },
                                    accountId: {
                                      locationName: "accountId"
                                    },
                                    arn: {
                                      locationName: "arn"
                                    },
                                    principalId: {
                                      locationName: "principalId"
                                    },
                                    sessionContext: {
                                      shape: "S6c",
                                      locationName: "sessionContext"
                                    }
                                  }
                                },
                                awsAccount: {
                                  locationName: "awsAccount",
                                  type: "structure",
                                  members: {
                                    accountId: {
                                      locationName: "accountId"
                                    },
                                    principalId: {
                                      locationName: "principalId"
                                    }
                                  }
                                },
                                awsService: {
                                  locationName: "awsService",
                                  type: "structure",
                                  members: {
                                    invokedBy: {
                                      locationName: "invokedBy"
                                    }
                                  }
                                },
                                federatedUser: {
                                  locationName: "federatedUser",
                                  type: "structure",
                                  members: {
                                    accessKeyId: {
                                      locationName: "accessKeyId"
                                    },
                                    accountId: {
                                      locationName: "accountId"
                                    },
                                    arn: {
                                      locationName: "arn"
                                    },
                                    principalId: {
                                      locationName: "principalId"
                                    },
                                    sessionContext: {
                                      shape: "S6c",
                                      locationName: "sessionContext"
                                    }
                                  }
                                },
                                iamUser: {
                                  locationName: "iamUser",
                                  type: "structure",
                                  members: {
                                    accountId: {
                                      locationName: "accountId"
                                    },
                                    arn: {
                                      locationName: "arn"
                                    },
                                    principalId: {
                                      locationName: "principalId"
                                    },
                                    userName: {
                                      locationName: "userName"
                                    }
                                  }
                                },
                                root: {
                                  locationName: "root",
                                  type: "structure",
                                  members: {
                                    accountId: {
                                      locationName: "accountId"
                                    },
                                    arn: {
                                      locationName: "arn"
                                    },
                                    principalId: {
                                      locationName: "principalId"
                                    }
                                  }
                                },
                                type: {
                                  locationName: "type"
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    region: {
                      locationName: "region"
                    },
                    resourcesAffected: {
                      locationName: "resourcesAffected",
                      type: "structure",
                      members: {
                        s3Bucket: {
                          locationName: "s3Bucket",
                          type: "structure",
                          members: {
                            allowsUnencryptedObjectUploads: {
                              locationName: "allowsUnencryptedObjectUploads"
                            },
                            arn: {
                              locationName: "arn"
                            },
                            createdAt: {
                              shape: "S9",
                              locationName: "createdAt"
                            },
                            defaultServerSideEncryption: {
                              shape: "S6n",
                              locationName: "defaultServerSideEncryption"
                            },
                            name: {
                              locationName: "name"
                            },
                            owner: {
                              locationName: "owner",
                              type: "structure",
                              members: {
                                displayName: {
                                  locationName: "displayName"
                                },
                                id: {
                                  locationName: "id"
                                }
                              }
                            },
                            publicAccess: {
                              shape: "S2x",
                              locationName: "publicAccess"
                            },
                            tags: {
                              shape: "S6q",
                              locationName: "tags"
                            }
                          }
                        },
                        s3Object: {
                          locationName: "s3Object",
                          type: "structure",
                          members: {
                            bucketArn: {
                              locationName: "bucketArn"
                            },
                            eTag: {
                              locationName: "eTag"
                            },
                            extension: {
                              locationName: "extension"
                            },
                            key: {
                              locationName: "key"
                            },
                            lastModified: {
                              shape: "S9",
                              locationName: "lastModified"
                            },
                            path: {
                              locationName: "path"
                            },
                            publicAccess: {
                              locationName: "publicAccess",
                              type: "boolean"
                            },
                            serverSideEncryption: {
                              shape: "S6n",
                              locationName: "serverSideEncryption"
                            },
                            size: {
                              locationName: "size",
                              type: "long"
                            },
                            storageClass: {
                              locationName: "storageClass"
                            },
                            tags: {
                              shape: "S6q",
                              locationName: "tags"
                            },
                            versionId: {
                              locationName: "versionId"
                            }
                          }
                        }
                      }
                    },
                    sample: {
                      locationName: "sample",
                      type: "boolean"
                    },
                    schemaVersion: {
                      locationName: "schemaVersion"
                    },
                    severity: {
                      locationName: "severity",
                      type: "structure",
                      members: {
                        description: {
                          locationName: "description"
                        },
                        score: {
                          locationName: "score",
                          type: "long"
                        }
                      }
                    },
                    title: {
                      locationName: "title"
                    },
                    type: {
                      locationName: "type"
                    },
                    updatedAt: {
                      shape: "S9",
                      locationName: "updatedAt"
                    }
                  }
                }
              }
            }
          }
        },
        GetFindingsFilter: {
          http: {
            method: "GET",
            requestUri: "/findingsfilters/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "id"
            ]
          },
          output: {
            type: "structure",
            members: {
              action: {
                locationName: "action"
              },
              arn: {
                locationName: "arn"
              },
              description: {
                locationName: "description"
              },
              findingCriteria: {
                shape: "S1r",
                locationName: "findingCriteria"
              },
              id: {
                locationName: "id"
              },
              name: {
                locationName: "name"
              },
              position: {
                locationName: "position",
                type: "integer"
              },
              tags: {
                shape: "Si",
                locationName: "tags"
              }
            }
          }
        },
        GetFindingsPublicationConfiguration: {
          http: {
            method: "GET",
            requestUri: "/findings-publication-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              securityHubConfiguration: {
                shape: "S6z",
                locationName: "securityHubConfiguration"
              }
            }
          }
        },
        GetInvitationsCount: {
          http: {
            method: "GET",
            requestUri: "/invitations/count",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              invitationsCount: {
                locationName: "invitationsCount",
                type: "long"
              }
            }
          }
        },
        GetMacieSession: {
          http: {
            method: "GET",
            requestUri: "/macie",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              createdAt: {
                shape: "S9",
                locationName: "createdAt"
              },
              findingPublishingFrequency: {
                locationName: "findingPublishingFrequency"
              },
              serviceRole: {
                locationName: "serviceRole"
              },
              status: {
                locationName: "status"
              },
              updatedAt: {
                shape: "S9",
                locationName: "updatedAt"
              }
            }
          }
        },
        GetMasterAccount: {
          http: {
            method: "GET",
            requestUri: "/master",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              master: {
                shape: "S44",
                locationName: "master"
              }
            }
          }
        },
        GetMember: {
          http: {
            method: "GET",
            requestUri: "/members/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "id"
            ]
          },
          output: {
            type: "structure",
            members: {
              accountId: {
                locationName: "accountId"
              },
              administratorAccountId: {
                locationName: "administratorAccountId"
              },
              arn: {
                locationName: "arn"
              },
              email: {
                locationName: "email"
              },
              invitedAt: {
                shape: "S9",
                locationName: "invitedAt"
              },
              masterAccountId: {
                locationName: "masterAccountId"
              },
              relationshipStatus: {
                locationName: "relationshipStatus"
              },
              tags: {
                shape: "Si",
                locationName: "tags"
              },
              updatedAt: {
                shape: "S9",
                locationName: "updatedAt"
              }
            }
          }
        },
        GetResourceProfile: {
          http: {
            method: "GET",
            requestUri: "/resource-profiles",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              }
            },
            required: [
              "resourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              profileUpdatedAt: {
                shape: "S9",
                locationName: "profileUpdatedAt"
              },
              sensitivityScore: {
                locationName: "sensitivityScore",
                type: "integer"
              },
              sensitivityScoreOverridden: {
                locationName: "sensitivityScoreOverridden",
                type: "boolean"
              },
              statistics: {
                locationName: "statistics",
                type: "structure",
                members: {
                  totalBytesClassified: {
                    locationName: "totalBytesClassified",
                    type: "long"
                  },
                  totalDetections: {
                    locationName: "totalDetections",
                    type: "long"
                  },
                  totalDetectionsSuppressed: {
                    locationName: "totalDetectionsSuppressed",
                    type: "long"
                  },
                  totalItemsClassified: {
                    locationName: "totalItemsClassified",
                    type: "long"
                  },
                  totalItemsSensitive: {
                    locationName: "totalItemsSensitive",
                    type: "long"
                  },
                  totalItemsSkipped: {
                    locationName: "totalItemsSkipped",
                    type: "long"
                  },
                  totalItemsSkippedInvalidEncryption: {
                    locationName: "totalItemsSkippedInvalidEncryption",
                    type: "long"
                  },
                  totalItemsSkippedInvalidKms: {
                    locationName: "totalItemsSkippedInvalidKms",
                    type: "long"
                  },
                  totalItemsSkippedPermissionDenied: {
                    locationName: "totalItemsSkippedPermissionDenied",
                    type: "long"
                  }
                }
              }
            }
          }
        },
        GetRevealConfiguration: {
          http: {
            method: "GET",
            requestUri: "/reveal-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              configuration: {
                shape: "S7d",
                locationName: "configuration"
              },
              retrievalConfiguration: {
                shape: "S7g",
                locationName: "retrievalConfiguration"
              }
            }
          }
        },
        GetSensitiveDataOccurrences: {
          http: {
            method: "GET",
            requestUri: "/findings/{findingId}/reveal",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              findingId: {
                location: "uri",
                locationName: "findingId"
              }
            },
            required: [
              "findingId"
            ]
          },
          output: {
            type: "structure",
            members: {
              error: {
                locationName: "error"
              },
              sensitiveDataOccurrences: {
                locationName: "sensitiveDataOccurrences",
                type: "map",
                key: {},
                value: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      value: {
                        locationName: "value"
                      }
                    },
                    required: [
                      "value"
                    ]
                  }
                }
              },
              status: {
                locationName: "status"
              }
            }
          }
        },
        GetSensitiveDataOccurrencesAvailability: {
          http: {
            method: "GET",
            requestUri: "/findings/{findingId}/reveal/availability",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              findingId: {
                location: "uri",
                locationName: "findingId"
              }
            },
            required: [
              "findingId"
            ]
          },
          output: {
            type: "structure",
            members: {
              code: {
                locationName: "code"
              },
              reasons: {
                locationName: "reasons",
                type: "list",
                member: {}
              }
            }
          }
        },
        GetSensitivityInspectionTemplate: {
          http: {
            method: "GET",
            requestUri: "/templates/sensitivity-inspections/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "id"
            ]
          },
          output: {
            type: "structure",
            members: {
              description: {
                locationName: "description"
              },
              excludes: {
                shape: "S7x",
                locationName: "excludes"
              },
              includes: {
                shape: "S7y",
                locationName: "includes"
              },
              name: {
                locationName: "name"
              },
              sensitivityInspectionTemplateId: {
                locationName: "sensitivityInspectionTemplateId"
              }
            }
          }
        },
        GetUsageStatistics: {
          http: {
            requestUri: "/usage/statistics",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              filterBy: {
                locationName: "filterBy",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    comparator: {
                      locationName: "comparator"
                    },
                    key: {
                      locationName: "key"
                    },
                    values: {
                      shape: "S5",
                      locationName: "values"
                    }
                  }
                }
              },
              maxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                locationName: "nextToken"
              },
              sortBy: {
                locationName: "sortBy",
                type: "structure",
                members: {
                  key: {
                    locationName: "key"
                  },
                  orderBy: {
                    locationName: "orderBy"
                  }
                }
              },
              timeRange: {
                locationName: "timeRange"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {
                locationName: "nextToken"
              },
              records: {
                locationName: "records",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    accountId: {
                      locationName: "accountId"
                    },
                    automatedDiscoveryFreeTrialStartDate: {
                      shape: "S9",
                      locationName: "automatedDiscoveryFreeTrialStartDate"
                    },
                    freeTrialStartDate: {
                      shape: "S9",
                      locationName: "freeTrialStartDate"
                    },
                    usage: {
                      locationName: "usage",
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          currency: {
                            locationName: "currency"
                          },
                          estimatedCost: {
                            locationName: "estimatedCost"
                          },
                          serviceLimit: {
                            locationName: "serviceLimit",
                            type: "structure",
                            members: {
                              isServiceLimited: {
                                locationName: "isServiceLimited",
                                type: "boolean"
                              },
                              unit: {
                                locationName: "unit"
                              },
                              value: {
                                locationName: "value",
                                type: "long"
                              }
                            }
                          },
                          type: {
                            locationName: "type"
                          }
                        }
                      }
                    }
                  }
                }
              },
              timeRange: {
                locationName: "timeRange"
              }
            }
          }
        },
        GetUsageTotals: {
          http: {
            method: "GET",
            requestUri: "/usage",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              timeRange: {
                location: "querystring",
                locationName: "timeRange"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              timeRange: {
                locationName: "timeRange"
              },
              usageTotals: {
                locationName: "usageTotals",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    currency: {
                      locationName: "currency"
                    },
                    estimatedCost: {
                      locationName: "estimatedCost"
                    },
                    type: {
                      locationName: "type"
                    }
                  }
                }
              }
            }
          }
        },
        ListAllowLists: {
          http: {
            method: "GET",
            requestUri: "/allow-lists",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              allowLists: {
                locationName: "allowLists",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {
                      locationName: "arn"
                    },
                    createdAt: {
                      shape: "S9",
                      locationName: "createdAt"
                    },
                    description: {
                      locationName: "description"
                    },
                    id: {
                      locationName: "id"
                    },
                    name: {
                      locationName: "name"
                    },
                    updatedAt: {
                      shape: "S9",
                      locationName: "updatedAt"
                    }
                  }
                }
              },
              nextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListClassificationJobs: {
          http: {
            requestUri: "/jobs/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              filterCriteria: {
                locationName: "filterCriteria",
                type: "structure",
                members: {
                  excludes: {
                    shape: "S8r",
                    locationName: "excludes"
                  },
                  includes: {
                    shape: "S8r",
                    locationName: "includes"
                  }
                }
              },
              maxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                locationName: "nextToken"
              },
              sortCriteria: {
                locationName: "sortCriteria",
                type: "structure",
                members: {
                  attributeName: {
                    locationName: "attributeName"
                  },
                  orderBy: {
                    locationName: "orderBy"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                locationName: "items",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    bucketCriteria: {
                      shape: "Sq",
                      locationName: "bucketCriteria"
                    },
                    bucketDefinitions: {
                      shape: "S10",
                      locationName: "bucketDefinitions"
                    },
                    createdAt: {
                      shape: "S9",
                      locationName: "createdAt"
                    },
                    jobId: {
                      locationName: "jobId"
                    },
                    jobStatus: {
                      locationName: "jobStatus"
                    },
                    jobType: {
                      locationName: "jobType"
                    },
                    lastRunErrorStatus: {
                      shape: "S3f",
                      locationName: "lastRunErrorStatus"
                    },
                    name: {
                      locationName: "name"
                    },
                    userPausedDetails: {
                      shape: "S3j",
                      locationName: "userPausedDetails"
                    }
                  }
                }
              },
              nextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListClassificationScopes: {
          http: {
            method: "GET",
            requestUri: "/classification-scopes",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              name: {
                location: "querystring",
                locationName: "name"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              classificationScopes: {
                locationName: "classificationScopes",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {
                      locationName: "id"
                    },
                    name: {
                      locationName: "name"
                    }
                  }
                }
              },
              nextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListCustomDataIdentifiers: {
          http: {
            requestUri: "/custom-data-identifiers/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                locationName: "items",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {
                      locationName: "arn"
                    },
                    createdAt: {
                      shape: "S9",
                      locationName: "createdAt"
                    },
                    description: {
                      locationName: "description"
                    },
                    id: {
                      locationName: "id"
                    },
                    name: {
                      locationName: "name"
                    }
                  }
                }
              },
              nextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListFindings: {
          http: {
            requestUri: "/findings",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              findingCriteria: {
                shape: "S1r",
                locationName: "findingCriteria"
              },
              maxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                locationName: "nextToken"
              },
              sortCriteria: {
                shape: "S59",
                locationName: "sortCriteria"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              findingIds: {
                shape: "S5",
                locationName: "findingIds"
              },
              nextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListFindingsFilters: {
          http: {
            method: "GET",
            requestUri: "/findingsfilters",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              findingsFilterListItems: {
                locationName: "findingsFilterListItems",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    action: {
                      locationName: "action"
                    },
                    arn: {
                      locationName: "arn"
                    },
                    id: {
                      locationName: "id"
                    },
                    name: {
                      locationName: "name"
                    },
                    tags: {
                      shape: "Si",
                      locationName: "tags"
                    }
                  }
                }
              },
              nextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListInvitations: {
          http: {
            method: "GET",
            requestUri: "/invitations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              invitations: {
                locationName: "invitations",
                type: "list",
                member: {
                  shape: "S44"
                }
              },
              nextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListManagedDataIdentifiers: {
          http: {
            requestUri: "/managed-data-identifiers/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                locationName: "items",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    category: {
                      locationName: "category"
                    },
                    id: {
                      locationName: "id"
                    }
                  }
                }
              },
              nextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListMembers: {
          http: {
            method: "GET",
            requestUri: "/members",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              onlyAssociated: {
                location: "querystring",
                locationName: "onlyAssociated"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              members: {
                locationName: "members",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    accountId: {
                      locationName: "accountId"
                    },
                    administratorAccountId: {
                      locationName: "administratorAccountId"
                    },
                    arn: {
                      locationName: "arn"
                    },
                    email: {
                      locationName: "email"
                    },
                    invitedAt: {
                      shape: "S9",
                      locationName: "invitedAt"
                    },
                    masterAccountId: {
                      locationName: "masterAccountId"
                    },
                    relationshipStatus: {
                      locationName: "relationshipStatus"
                    },
                    tags: {
                      shape: "Si",
                      locationName: "tags"
                    },
                    updatedAt: {
                      shape: "S9",
                      locationName: "updatedAt"
                    }
                  }
                }
              },
              nextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListOrganizationAdminAccounts: {
          http: {
            method: "GET",
            requestUri: "/admin",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              adminAccounts: {
                locationName: "adminAccounts",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    accountId: {
                      locationName: "accountId"
                    },
                    status: {
                      locationName: "status"
                    }
                  }
                }
              },
              nextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListResourceProfileArtifacts: {
          http: {
            method: "GET",
            requestUri: "/resource-profiles/artifacts",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              }
            },
            required: [
              "resourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              artifacts: {
                locationName: "artifacts",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {
                      locationName: "arn"
                    },
                    classificationResultStatus: {
                      locationName: "classificationResultStatus"
                    },
                    sensitive: {
                      locationName: "sensitive",
                      type: "boolean"
                    }
                  },
                  required: [
                    "classificationResultStatus",
                    "arn"
                  ]
                }
              },
              nextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListResourceProfileDetections: {
          http: {
            method: "GET",
            requestUri: "/resource-profiles/detections",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              }
            },
            required: [
              "resourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              detections: {
                locationName: "detections",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {
                      locationName: "arn"
                    },
                    count: {
                      locationName: "count",
                      type: "long"
                    },
                    id: {
                      locationName: "id"
                    },
                    name: {
                      locationName: "name"
                    },
                    suppressed: {
                      locationName: "suppressed",
                      type: "boolean"
                    },
                    type: {
                      locationName: "type"
                    }
                  }
                }
              },
              nextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListSensitivityInspectionTemplates: {
          http: {
            method: "GET",
            requestUri: "/templates/sensitivity-inspections",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {
                locationName: "nextToken"
              },
              sensitivityInspectionTemplates: {
                locationName: "sensitivityInspectionTemplates",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {
                      locationName: "id"
                    },
                    name: {
                      locationName: "name"
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            },
            required: [
              "resourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Si",
                locationName: "tags"
              }
            }
          }
        },
        PutClassificationExportConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/classification-export-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              configuration: {
                shape: "S4q",
                locationName: "configuration"
              }
            },
            required: [
              "configuration"
            ]
          },
          output: {
            type: "structure",
            members: {
              configuration: {
                shape: "S4q",
                locationName: "configuration"
              }
            }
          }
        },
        PutFindingsPublicationConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/findings-publication-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              clientToken: {
                locationName: "clientToken",
                idempotencyToken: true
              },
              securityHubConfiguration: {
                shape: "S6z",
                locationName: "securityHubConfiguration"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SearchResources: {
          http: {
            requestUri: "/datasources/search-resources",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              bucketCriteria: {
                locationName: "bucketCriteria",
                type: "structure",
                members: {
                  excludes: {
                    shape: "Saf",
                    locationName: "excludes"
                  },
                  includes: {
                    shape: "Saf",
                    locationName: "includes"
                  }
                }
              },
              maxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                locationName: "nextToken"
              },
              sortCriteria: {
                locationName: "sortCriteria",
                type: "structure",
                members: {
                  attributeName: {
                    locationName: "attributeName"
                  },
                  orderBy: {
                    locationName: "orderBy"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              matchingResources: {
                locationName: "matchingResources",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    matchingBucket: {
                      locationName: "matchingBucket",
                      type: "structure",
                      members: {
                        accountId: {
                          locationName: "accountId"
                        },
                        bucketName: {
                          locationName: "bucketName"
                        },
                        classifiableObjectCount: {
                          locationName: "classifiableObjectCount",
                          type: "long"
                        },
                        classifiableSizeInBytes: {
                          locationName: "classifiableSizeInBytes",
                          type: "long"
                        },
                        errorCode: {
                          locationName: "errorCode"
                        },
                        errorMessage: {
                          locationName: "errorMessage"
                        },
                        jobDetails: {
                          shape: "S2t",
                          locationName: "jobDetails"
                        },
                        lastAutomatedDiscoveryTime: {
                          shape: "S9",
                          locationName: "lastAutomatedDiscoveryTime"
                        },
                        objectCount: {
                          locationName: "objectCount",
                          type: "long"
                        },
                        objectCountByEncryptionType: {
                          shape: "S2w",
                          locationName: "objectCountByEncryptionType"
                        },
                        sensitivityScore: {
                          locationName: "sensitivityScore",
                          type: "integer"
                        },
                        sizeInBytes: {
                          locationName: "sizeInBytes",
                          type: "long"
                        },
                        sizeInBytesCompressed: {
                          locationName: "sizeInBytesCompressed",
                          type: "long"
                        },
                        unclassifiableObjectCount: {
                          shape: "S3b",
                          locationName: "unclassifiableObjectCount"
                        },
                        unclassifiableObjectSizeInBytes: {
                          shape: "S3b",
                          locationName: "unclassifiableObjectSizeInBytes"
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Si",
                locationName: "tags"
              }
            },
            required: [
              "resourceArn",
              "tags"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TestCustomDataIdentifier: {
          http: {
            requestUri: "/custom-data-identifiers/test",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ignoreWords: {
                shape: "S5",
                locationName: "ignoreWords"
              },
              keywords: {
                shape: "S5",
                locationName: "keywords"
              },
              maximumMatchDistance: {
                locationName: "maximumMatchDistance",
                type: "integer"
              },
              regex: {
                locationName: "regex"
              },
              sampleText: {
                locationName: "sampleText"
              }
            },
            required: [
              "regex",
              "sampleText"
            ]
          },
          output: {
            type: "structure",
            members: {
              matchCount: {
                locationName: "matchCount",
                type: "integer"
              }
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                shape: "S5",
                location: "querystring",
                locationName: "tagKeys"
              }
            },
            required: [
              "tagKeys",
              "resourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAllowList: {
          http: {
            method: "PUT",
            requestUri: "/allow-lists/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              criteria: {
                shape: "Sc",
                locationName: "criteria"
              },
              description: {
                locationName: "description"
              },
              id: {
                location: "uri",
                locationName: "id"
              },
              name: {
                locationName: "name"
              }
            },
            required: [
              "id",
              "criteria",
              "name"
            ]
          },
          output: {
            type: "structure",
            members: {
              arn: {
                locationName: "arn"
              },
              id: {
                locationName: "id"
              }
            }
          }
        },
        UpdateAutomatedDiscoveryConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/automated-discovery/configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              status: {
                locationName: "status"
              }
            },
            required: [
              "status"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateClassificationJob: {
          http: {
            method: "PATCH",
            requestUri: "/jobs/{jobId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              jobStatus: {
                locationName: "jobStatus"
              }
            },
            required: [
              "jobId",
              "jobStatus"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateClassificationScope: {
          http: {
            method: "PATCH",
            requestUri: "/classification-scopes/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              s3: {
                locationName: "s3",
                type: "structure",
                members: {
                  excludes: {
                    locationName: "excludes",
                    type: "structure",
                    members: {
                      bucketNames: {
                        shape: "S4x",
                        locationName: "bucketNames"
                      },
                      operation: {
                        locationName: "operation"
                      }
                    },
                    required: [
                      "bucketNames",
                      "operation"
                    ]
                  }
                },
                required: [
                  "excludes"
                ]
              }
            },
            required: [
              "id"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateFindingsFilter: {
          http: {
            method: "PATCH",
            requestUri: "/findingsfilters/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              action: {
                locationName: "action"
              },
              clientToken: {
                locationName: "clientToken",
                idempotencyToken: true
              },
              description: {
                locationName: "description"
              },
              findingCriteria: {
                shape: "S1r",
                locationName: "findingCriteria"
              },
              id: {
                location: "uri",
                locationName: "id"
              },
              name: {
                locationName: "name"
              },
              position: {
                locationName: "position",
                type: "integer"
              }
            },
            required: [
              "id"
            ]
          },
          output: {
            type: "structure",
            members: {
              arn: {
                locationName: "arn"
              },
              id: {
                locationName: "id"
              }
            }
          }
        },
        UpdateMacieSession: {
          http: {
            method: "PATCH",
            requestUri: "/macie",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              findingPublishingFrequency: {
                locationName: "findingPublishingFrequency"
              },
              status: {
                locationName: "status"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateMemberSession: {
          http: {
            method: "PATCH",
            requestUri: "/macie/members/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              status: {
                locationName: "status"
              }
            },
            required: [
              "id",
              "status"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateOrganizationConfiguration: {
          http: {
            method: "PATCH",
            requestUri: "/admin/configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              autoEnable: {
                locationName: "autoEnable",
                type: "boolean"
              }
            },
            required: [
              "autoEnable"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateResourceProfile: {
          http: {
            method: "PATCH",
            requestUri: "/resource-profiles",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              sensitivityScoreOverride: {
                locationName: "sensitivityScoreOverride",
                type: "integer"
              }
            },
            required: [
              "resourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateResourceProfileDetections: {
          http: {
            method: "PATCH",
            requestUri: "/resource-profiles/detections",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              suppressDataIdentifiers: {
                locationName: "suppressDataIdentifiers",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {
                      locationName: "id"
                    },
                    type: {
                      locationName: "type"
                    }
                  }
                }
              }
            },
            required: [
              "resourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateRevealConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/reveal-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              configuration: {
                shape: "S7d",
                locationName: "configuration"
              },
              retrievalConfiguration: {
                locationName: "retrievalConfiguration",
                type: "structure",
                members: {
                  retrievalMode: {
                    locationName: "retrievalMode"
                  },
                  roleName: {
                    locationName: "roleName"
                  }
                },
                required: [
                  "retrievalMode"
                ]
              }
            },
            required: [
              "configuration"
            ]
          },
          output: {
            type: "structure",
            members: {
              configuration: {
                shape: "S7d",
                locationName: "configuration"
              },
              retrievalConfiguration: {
                shape: "S7g",
                locationName: "retrievalConfiguration"
              }
            }
          }
        },
        UpdateSensitivityInspectionTemplate: {
          http: {
            method: "PUT",
            requestUri: "/templates/sensitivity-inspections/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              description: {
                locationName: "description"
              },
              excludes: {
                shape: "S7x",
                locationName: "excludes"
              },
              id: {
                location: "uri",
                locationName: "id"
              },
              includes: {
                shape: "S7y",
                locationName: "includes"
              }
            },
            required: [
              "id"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S5: {
          type: "list",
          member: {}
        },
        S9: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        Sc: {
          type: "structure",
          members: {
            regex: {
              locationName: "regex"
            },
            s3WordsList: {
              locationName: "s3WordsList",
              type: "structure",
              members: {
                bucketName: {
                  locationName: "bucketName"
                },
                objectKey: {
                  locationName: "objectKey"
                }
              },
              required: [
                "bucketName",
                "objectKey"
              ]
            }
          }
        },
        Si: {
          type: "map",
          key: {},
          value: {}
        },
        Sp: {
          type: "structure",
          members: {
            bucketCriteria: {
              shape: "Sq",
              locationName: "bucketCriteria"
            },
            bucketDefinitions: {
              shape: "S10",
              locationName: "bucketDefinitions"
            },
            scoping: {
              locationName: "scoping",
              type: "structure",
              members: {
                excludes: {
                  shape: "S13",
                  locationName: "excludes"
                },
                includes: {
                  shape: "S13",
                  locationName: "includes"
                }
              }
            }
          }
        },
        Sq: {
          type: "structure",
          members: {
            excludes: {
              shape: "Sr",
              locationName: "excludes"
            },
            includes: {
              shape: "Sr",
              locationName: "includes"
            }
          }
        },
        Sr: {
          type: "structure",
          members: {
            and: {
              locationName: "and",
              type: "list",
              member: {
                type: "structure",
                members: {
                  simpleCriterion: {
                    locationName: "simpleCriterion",
                    type: "structure",
                    members: {
                      comparator: {
                        locationName: "comparator"
                      },
                      key: {
                        locationName: "key"
                      },
                      values: {
                        shape: "S5",
                        locationName: "values"
                      }
                    }
                  },
                  tagCriterion: {
                    locationName: "tagCriterion",
                    type: "structure",
                    members: {
                      comparator: {
                        locationName: "comparator"
                      },
                      tagValues: {
                        locationName: "tagValues",
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            key: {
                              locationName: "key"
                            },
                            value: {
                              locationName: "value"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S10: {
          type: "list",
          member: {
            type: "structure",
            members: {
              accountId: {
                locationName: "accountId"
              },
              buckets: {
                shape: "S5",
                locationName: "buckets"
              }
            },
            required: [
              "accountId",
              "buckets"
            ]
          }
        },
        S13: {
          type: "structure",
          members: {
            and: {
              locationName: "and",
              type: "list",
              member: {
                type: "structure",
                members: {
                  simpleScopeTerm: {
                    locationName: "simpleScopeTerm",
                    type: "structure",
                    members: {
                      comparator: {
                        locationName: "comparator"
                      },
                      key: {
                        locationName: "key"
                      },
                      values: {
                        shape: "S5",
                        locationName: "values"
                      }
                    }
                  },
                  tagScopeTerm: {
                    locationName: "tagScopeTerm",
                    type: "structure",
                    members: {
                      comparator: {
                        locationName: "comparator"
                      },
                      key: {
                        locationName: "key"
                      },
                      tagValues: {
                        locationName: "tagValues",
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            key: {
                              locationName: "key"
                            },
                            value: {
                              locationName: "value"
                            }
                          }
                        }
                      },
                      target: {
                        locationName: "target"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S1d: {
          type: "structure",
          members: {
            dailySchedule: {
              locationName: "dailySchedule",
              type: "structure",
              members: {}
            },
            monthlySchedule: {
              locationName: "monthlySchedule",
              type: "structure",
              members: {
                dayOfMonth: {
                  locationName: "dayOfMonth",
                  type: "integer"
                }
              }
            },
            weeklySchedule: {
              locationName: "weeklySchedule",
              type: "structure",
              members: {
                dayOfWeek: {
                  locationName: "dayOfWeek"
                }
              }
            }
          }
        },
        S1k: {
          type: "list",
          member: {
            type: "structure",
            members: {
              occurrencesThreshold: {
                locationName: "occurrencesThreshold",
                type: "long"
              },
              severity: {
                locationName: "severity"
              }
            },
            required: [
              "occurrencesThreshold",
              "severity"
            ]
          }
        },
        S1r: {
          type: "structure",
          members: {
            criterion: {
              locationName: "criterion",
              type: "map",
              key: {},
              value: {
                type: "structure",
                members: {
                  eq: {
                    shape: "S5",
                    locationName: "eq"
                  },
                  eqExactMatch: {
                    shape: "S5",
                    locationName: "eqExactMatch"
                  },
                  gt: {
                    locationName: "gt",
                    type: "long"
                  },
                  gte: {
                    locationName: "gte",
                    type: "long"
                  },
                  lt: {
                    locationName: "lt",
                    type: "long"
                  },
                  lte: {
                    locationName: "lte",
                    type: "long"
                  },
                  neq: {
                    shape: "S5",
                    locationName: "neq"
                  }
                }
              }
            }
          }
        },
        S1x: {
          type: "list",
          member: {
            type: "structure",
            members: {
              accountId: {
                locationName: "accountId"
              },
              errorCode: {
                locationName: "errorCode"
              },
              errorMessage: {
                locationName: "errorMessage"
              }
            }
          }
        },
        S2t: {
          type: "structure",
          members: {
            isDefinedInJob: {
              locationName: "isDefinedInJob"
            },
            isMonitoredByJob: {
              locationName: "isMonitoredByJob"
            },
            lastJobId: {
              locationName: "lastJobId"
            },
            lastJobRunTime: {
              shape: "S9",
              locationName: "lastJobRunTime"
            }
          }
        },
        S2w: {
          type: "structure",
          members: {
            customerManaged: {
              locationName: "customerManaged",
              type: "long"
            },
            kmsManaged: {
              locationName: "kmsManaged",
              type: "long"
            },
            s3Managed: {
              locationName: "s3Managed",
              type: "long"
            },
            unencrypted: {
              locationName: "unencrypted",
              type: "long"
            },
            unknown: {
              locationName: "unknown",
              type: "long"
            }
          }
        },
        S2x: {
          type: "structure",
          members: {
            effectivePermission: {
              locationName: "effectivePermission"
            },
            permissionConfiguration: {
              locationName: "permissionConfiguration",
              type: "structure",
              members: {
                accountLevelPermissions: {
                  locationName: "accountLevelPermissions",
                  type: "structure",
                  members: {
                    blockPublicAccess: {
                      shape: "S31",
                      locationName: "blockPublicAccess"
                    }
                  }
                },
                bucketLevelPermissions: {
                  locationName: "bucketLevelPermissions",
                  type: "structure",
                  members: {
                    accessControlList: {
                      locationName: "accessControlList",
                      type: "structure",
                      members: {
                        allowsPublicReadAccess: {
                          locationName: "allowsPublicReadAccess",
                          type: "boolean"
                        },
                        allowsPublicWriteAccess: {
                          locationName: "allowsPublicWriteAccess",
                          type: "boolean"
                        }
                      }
                    },
                    blockPublicAccess: {
                      shape: "S31",
                      locationName: "blockPublicAccess"
                    },
                    bucketPolicy: {
                      locationName: "bucketPolicy",
                      type: "structure",
                      members: {
                        allowsPublicReadAccess: {
                          locationName: "allowsPublicReadAccess",
                          type: "boolean"
                        },
                        allowsPublicWriteAccess: {
                          locationName: "allowsPublicWriteAccess",
                          type: "boolean"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S31: {
          type: "structure",
          members: {
            blockPublicAcls: {
              locationName: "blockPublicAcls",
              type: "boolean"
            },
            blockPublicPolicy: {
              locationName: "blockPublicPolicy",
              type: "boolean"
            },
            ignorePublicAcls: {
              locationName: "ignorePublicAcls",
              type: "boolean"
            },
            restrictPublicBuckets: {
              locationName: "restrictPublicBuckets",
              type: "boolean"
            }
          }
        },
        S3a: {
          type: "structure",
          members: {
            key: {
              locationName: "key"
            },
            value: {
              locationName: "value"
            }
          }
        },
        S3b: {
          type: "structure",
          members: {
            fileType: {
              locationName: "fileType",
              type: "long"
            },
            storageClass: {
              locationName: "storageClass",
              type: "long"
            },
            total: {
              locationName: "total",
              type: "long"
            }
          }
        },
        S3f: {
          type: "structure",
          members: {
            code: {
              locationName: "code"
            }
          }
        },
        S3j: {
          type: "structure",
          members: {
            jobExpiresAt: {
              shape: "S9",
              locationName: "jobExpiresAt"
            },
            jobImminentExpirationHealthEventArn: {
              locationName: "jobImminentExpirationHealthEventArn"
            },
            jobPausedAt: {
              shape: "S9",
              locationName: "jobPausedAt"
            }
          }
        },
        S44: {
          type: "structure",
          members: {
            accountId: {
              locationName: "accountId"
            },
            invitationId: {
              locationName: "invitationId"
            },
            invitedAt: {
              shape: "S9",
              locationName: "invitedAt"
            },
            relationshipStatus: {
              locationName: "relationshipStatus"
            }
          }
        },
        S4d: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S4n: {
          type: "structure",
          members: {
            classifiableSizeInBytes: {
              locationName: "classifiableSizeInBytes",
              type: "long"
            },
            publiclyAccessibleCount: {
              locationName: "publiclyAccessibleCount",
              type: "long"
            },
            totalCount: {
              locationName: "totalCount",
              type: "long"
            },
            totalSizeInBytes: {
              locationName: "totalSizeInBytes",
              type: "long"
            }
          }
        },
        S4q: {
          type: "structure",
          members: {
            s3Destination: {
              locationName: "s3Destination",
              type: "structure",
              members: {
                bucketName: {
                  locationName: "bucketName"
                },
                keyPrefix: {
                  locationName: "keyPrefix"
                },
                kmsKeyArn: {
                  locationName: "kmsKeyArn"
                }
              },
              required: [
                "bucketName",
                "kmsKeyArn"
              ]
            }
          }
        },
        S4x: {
          type: "list",
          member: {}
        },
        S59: {
          type: "structure",
          members: {
            attributeName: {
              locationName: "attributeName"
            },
            orderBy: {
              locationName: "orderBy"
            }
          }
        },
        S5k: {
          type: "structure",
          members: {
            cells: {
              locationName: "cells",
              type: "list",
              member: {
                type: "structure",
                members: {
                  cellReference: {
                    locationName: "cellReference"
                  },
                  column: {
                    locationName: "column",
                    type: "long"
                  },
                  columnName: {
                    locationName: "columnName"
                  },
                  row: {
                    locationName: "row",
                    type: "long"
                  }
                }
              }
            },
            lineRanges: {
              shape: "S5n",
              locationName: "lineRanges"
            },
            offsetRanges: {
              shape: "S5n",
              locationName: "offsetRanges"
            },
            pages: {
              locationName: "pages",
              type: "list",
              member: {
                type: "structure",
                members: {
                  lineRange: {
                    shape: "S5o",
                    locationName: "lineRange"
                  },
                  offsetRange: {
                    shape: "S5o",
                    locationName: "offsetRange"
                  },
                  pageNumber: {
                    locationName: "pageNumber",
                    type: "long"
                  }
                }
              }
            },
            records: {
              locationName: "records",
              type: "list",
              member: {
                type: "structure",
                members: {
                  jsonPath: {
                    locationName: "jsonPath"
                  },
                  recordIndex: {
                    locationName: "recordIndex",
                    type: "long"
                  }
                }
              }
            }
          }
        },
        S5n: {
          type: "list",
          member: {
            shape: "S5o"
          }
        },
        S5o: {
          type: "structure",
          members: {
            end: {
              locationName: "end",
              type: "long"
            },
            start: {
              locationName: "start",
              type: "long"
            },
            startColumn: {
              locationName: "startColumn",
              type: "long"
            }
          }
        },
        S6c: {
          type: "structure",
          members: {
            attributes: {
              locationName: "attributes",
              type: "structure",
              members: {
                creationDate: {
                  shape: "S9",
                  locationName: "creationDate"
                },
                mfaAuthenticated: {
                  locationName: "mfaAuthenticated",
                  type: "boolean"
                }
              }
            },
            sessionIssuer: {
              locationName: "sessionIssuer",
              type: "structure",
              members: {
                accountId: {
                  locationName: "accountId"
                },
                arn: {
                  locationName: "arn"
                },
                principalId: {
                  locationName: "principalId"
                },
                type: {
                  locationName: "type"
                },
                userName: {
                  locationName: "userName"
                }
              }
            }
          }
        },
        S6n: {
          type: "structure",
          members: {
            encryptionType: {
              locationName: "encryptionType"
            },
            kmsMasterKeyId: {
              locationName: "kmsMasterKeyId"
            }
          }
        },
        S6q: {
          type: "list",
          member: {
            shape: "S3a"
          }
        },
        S6z: {
          type: "structure",
          members: {
            publishClassificationFindings: {
              locationName: "publishClassificationFindings",
              type: "boolean"
            },
            publishPolicyFindings: {
              locationName: "publishPolicyFindings",
              type: "boolean"
            }
          },
          required: [
            "publishPolicyFindings",
            "publishClassificationFindings"
          ]
        },
        S7d: {
          type: "structure",
          members: {
            kmsKeyId: {
              locationName: "kmsKeyId"
            },
            status: {
              locationName: "status"
            }
          },
          required: [
            "status"
          ]
        },
        S7g: {
          type: "structure",
          members: {
            externalId: {
              locationName: "externalId"
            },
            retrievalMode: {
              locationName: "retrievalMode"
            },
            roleName: {
              locationName: "roleName"
            }
          },
          required: [
            "retrievalMode"
          ]
        },
        S7x: {
          type: "structure",
          members: {
            managedDataIdentifierIds: {
              shape: "S5",
              locationName: "managedDataIdentifierIds"
            }
          }
        },
        S7y: {
          type: "structure",
          members: {
            allowListIds: {
              shape: "S5",
              locationName: "allowListIds"
            },
            customDataIdentifierIds: {
              shape: "S5",
              locationName: "customDataIdentifierIds"
            },
            managedDataIdentifierIds: {
              shape: "S5",
              locationName: "managedDataIdentifierIds"
            }
          }
        },
        S8r: {
          type: "list",
          member: {
            type: "structure",
            members: {
              comparator: {
                locationName: "comparator"
              },
              key: {
                locationName: "key"
              },
              values: {
                shape: "S5",
                locationName: "values"
              }
            }
          }
        },
        Saf: {
          type: "structure",
          members: {
            and: {
              locationName: "and",
              type: "list",
              member: {
                type: "structure",
                members: {
                  simpleCriterion: {
                    locationName: "simpleCriterion",
                    type: "structure",
                    members: {
                      comparator: {
                        locationName: "comparator"
                      },
                      key: {
                        locationName: "key"
                      },
                      values: {
                        shape: "S5",
                        locationName: "values"
                      }
                    }
                  },
                  tagCriterion: {
                    locationName: "tagCriterion",
                    type: "structure",
                    members: {
                      comparator: {
                        locationName: "comparator"
                      },
                      tagValues: {
                        locationName: "tagValues",
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            key: {
                              locationName: "key"
                            },
                            value: {
                              locationName: "value"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/macie2-2020-01-01.paginators.json
var require_macie2_2020_01_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/macie2-2020-01-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeBuckets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "buckets"
        },
        GetUsageStatistics: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "records"
        },
        ListClassificationJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListClassificationScopes: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "classificationScopes"
        },
        ListCustomDataIdentifiers: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListFindings: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "findingIds"
        },
        ListFindingsFilters: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "findingsFilterListItems"
        },
        ListInvitations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "invitations"
        },
        ListMembers: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "members"
        },
        ListOrganizationAdminAccounts: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "adminAccounts"
        },
        SearchResources: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "matchingResources"
        },
        ListAllowLists: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "allowLists"
        },
        ListManagedDataIdentifiers: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "items"
        },
        ListResourceProfileDetections: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "detections"
        },
        ListSensitivityInspectionTemplates: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "sensitivityInspectionTemplates"
        },
        ListResourceProfileArtifacts: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "artifacts"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/macie2-2020-01-01.waiters2.json
var require_macie2_2020_01_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/macie2-2020-01-01.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        FindingRevealed: {
          description: "Wait until the sensitive data occurrences are ready.",
          delay: 2,
          maxAttempts: 60,
          operation: "GetSensitiveDataOccurrences",
          acceptors: [
            {
              matcher: "path",
              argument: "status",
              state: "success",
              expected: "SUCCESS"
            },
            {
              matcher: "path",
              argument: "status",
              state: "success",
              expected: "ERROR"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/macie2.js
var require_macie2 = __commonJS({
  "node_modules/aws-sdk/clients/macie2.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["macie2"] = {};
    AWS2.Macie2 = Service.defineService("macie2", ["2020-01-01"]);
    Object.defineProperty(apiLoader.services["macie2"], "2020-01-01", {
      get: function get() {
        var model = require_macie2_2020_01_01_min();
        model.paginators = require_macie2_2020_01_01_paginators().pagination;
        model.waiters = require_macie2_2020_01_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Macie2;
  }
});

// node_modules/aws-sdk/apis/codeartifact-2018-09-22.min.json
var require_codeartifact_2018_09_22_min = __commonJS({
  "node_modules/aws-sdk/apis/codeartifact-2018-09-22.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-09-22",
        endpointPrefix: "codeartifact",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "CodeArtifact",
        serviceId: "codeartifact",
        signatureVersion: "v4",
        signingName: "codeartifact",
        uid: "codeartifact-2018-09-22"
      },
      operations: {
        AssociateExternalConnection: {
          http: {
            requestUri: "/v1/repository/external-connection"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository",
              "externalConnection"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              externalConnection: {
                location: "querystring",
                locationName: "external-connection"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repository: {
                shape: "S7"
              }
            }
          }
        },
        CopyPackageVersions: {
          http: {
            requestUri: "/v1/package/versions/copy"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "sourceRepository",
              "destinationRepository",
              "format",
              "package"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              sourceRepository: {
                location: "querystring",
                locationName: "source-repository"
              },
              destinationRepository: {
                location: "querystring",
                locationName: "destination-repository"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              package: {
                location: "querystring",
                locationName: "package"
              },
              versions: {
                shape: "Sk"
              },
              versionRevisions: {
                shape: "Sm"
              },
              allowOverwrite: {
                type: "boolean"
              },
              includeFromUpstream: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              successfulVersions: {
                shape: "Sq"
              },
              failedVersions: {
                shape: "Su"
              }
            }
          }
        },
        CreateDomain: {
          http: {
            requestUri: "/v1/domain"
          },
          input: {
            type: "structure",
            required: [
              "domain"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              encryptionKey: {},
              tags: {
                shape: "Sz"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              domain: {
                shape: "S14"
              }
            }
          }
        },
        CreateRepository: {
          http: {
            requestUri: "/v1/repository"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              description: {},
              upstreams: {
                shape: "S19"
              },
              tags: {
                shape: "Sz"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repository: {
                shape: "S7"
              }
            }
          }
        },
        DeleteDomain: {
          http: {
            method: "DELETE",
            requestUri: "/v1/domain"
          },
          input: {
            type: "structure",
            required: [
              "domain"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              domain: {
                shape: "S14"
              }
            }
          }
        },
        DeleteDomainPermissionsPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/v1/domain/permissions/policy"
          },
          input: {
            type: "structure",
            required: [
              "domain"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              policyRevision: {
                location: "querystring",
                locationName: "policy-revision"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              policy: {
                shape: "S1h"
              }
            }
          }
        },
        DeletePackage: {
          http: {
            method: "DELETE",
            requestUri: "/v1/package"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository",
              "format",
              "package"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              package: {
                location: "querystring",
                locationName: "package"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              deletedPackage: {
                shape: "S1l"
              }
            }
          }
        },
        DeletePackageVersions: {
          http: {
            requestUri: "/v1/package/versions/delete"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository",
              "format",
              "package",
              "versions"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              package: {
                location: "querystring",
                locationName: "package"
              },
              versions: {
                shape: "Sk"
              },
              expectedStatus: {}
            }
          },
          output: {
            type: "structure",
            members: {
              successfulVersions: {
                shape: "Sq"
              },
              failedVersions: {
                shape: "Su"
              }
            }
          }
        },
        DeleteRepository: {
          http: {
            method: "DELETE",
            requestUri: "/v1/repository"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repository: {
                shape: "S7"
              }
            }
          }
        },
        DeleteRepositoryPermissionsPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/v1/repository/permissions/policies"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              policyRevision: {
                location: "querystring",
                locationName: "policy-revision"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              policy: {
                shape: "S1h"
              }
            }
          }
        },
        DescribeDomain: {
          http: {
            method: "GET",
            requestUri: "/v1/domain"
          },
          input: {
            type: "structure",
            required: [
              "domain"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              domain: {
                shape: "S14"
              }
            }
          }
        },
        DescribePackage: {
          http: {
            method: "GET",
            requestUri: "/v1/package"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository",
              "format",
              "package"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              package: {
                location: "querystring",
                locationName: "package"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "package"
            ],
            members: {
              package: {
                type: "structure",
                members: {
                  format: {},
                  namespace: {},
                  name: {},
                  originConfiguration: {
                    shape: "S1m"
                  }
                }
              }
            }
          }
        },
        DescribePackageVersion: {
          http: {
            method: "GET",
            requestUri: "/v1/package/version"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository",
              "format",
              "package",
              "packageVersion"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              package: {
                location: "querystring",
                locationName: "package"
              },
              packageVersion: {
                location: "querystring",
                locationName: "version"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "packageVersion"
            ],
            members: {
              packageVersion: {
                type: "structure",
                members: {
                  format: {},
                  namespace: {},
                  packageName: {},
                  displayName: {},
                  version: {},
                  summary: {},
                  homePage: {},
                  sourceCodeRepository: {},
                  publishedTime: {
                    type: "timestamp"
                  },
                  licenses: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        name: {},
                        url: {}
                      }
                    }
                  },
                  revision: {},
                  status: {},
                  origin: {
                    shape: "S27"
                  }
                }
              }
            }
          }
        },
        DescribeRepository: {
          http: {
            method: "GET",
            requestUri: "/v1/repository"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repository: {
                shape: "S7"
              }
            }
          }
        },
        DisassociateExternalConnection: {
          http: {
            method: "DELETE",
            requestUri: "/v1/repository/external-connection"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository",
              "externalConnection"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              externalConnection: {
                location: "querystring",
                locationName: "external-connection"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repository: {
                shape: "S7"
              }
            }
          }
        },
        DisposePackageVersions: {
          http: {
            requestUri: "/v1/package/versions/dispose"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository",
              "format",
              "package",
              "versions"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              package: {
                location: "querystring",
                locationName: "package"
              },
              versions: {
                shape: "Sk"
              },
              versionRevisions: {
                shape: "Sm"
              },
              expectedStatus: {}
            }
          },
          output: {
            type: "structure",
            members: {
              successfulVersions: {
                shape: "Sq"
              },
              failedVersions: {
                shape: "Su"
              }
            }
          }
        },
        GetAuthorizationToken: {
          http: {
            requestUri: "/v1/authorization-token"
          },
          input: {
            type: "structure",
            required: [
              "domain"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              durationSeconds: {
                location: "querystring",
                locationName: "duration",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              authorizationToken: {},
              expiration: {
                type: "timestamp"
              }
            }
          }
        },
        GetDomainPermissionsPolicy: {
          http: {
            method: "GET",
            requestUri: "/v1/domain/permissions/policy"
          },
          input: {
            type: "structure",
            required: [
              "domain"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              policy: {
                shape: "S1h"
              }
            }
          }
        },
        GetPackageVersionAsset: {
          http: {
            method: "GET",
            requestUri: "/v1/package/version/asset"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository",
              "format",
              "package",
              "packageVersion",
              "asset"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              package: {
                location: "querystring",
                locationName: "package"
              },
              packageVersion: {
                location: "querystring",
                locationName: "version"
              },
              asset: {
                location: "querystring",
                locationName: "asset"
              },
              packageVersionRevision: {
                location: "querystring",
                locationName: "revision"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              asset: {
                shape: "S2o"
              },
              assetName: {
                location: "header",
                locationName: "X-AssetName"
              },
              packageVersion: {
                location: "header",
                locationName: "X-PackageVersion"
              },
              packageVersionRevision: {
                location: "header",
                locationName: "X-PackageVersionRevision"
              }
            },
            payload: "asset"
          }
        },
        GetPackageVersionReadme: {
          http: {
            method: "GET",
            requestUri: "/v1/package/version/readme"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository",
              "format",
              "package",
              "packageVersion"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              package: {
                location: "querystring",
                locationName: "package"
              },
              packageVersion: {
                location: "querystring",
                locationName: "version"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              format: {},
              namespace: {},
              package: {},
              version: {},
              versionRevision: {},
              readme: {}
            }
          }
        },
        GetRepositoryEndpoint: {
          http: {
            method: "GET",
            requestUri: "/v1/repository/endpoint"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository",
              "format"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              format: {
                location: "querystring",
                locationName: "format"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repositoryEndpoint: {}
            }
          }
        },
        GetRepositoryPermissionsPolicy: {
          http: {
            method: "GET",
            requestUri: "/v1/repository/permissions/policy"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              policy: {
                shape: "S1h"
              }
            }
          }
        },
        ListDomains: {
          http: {
            requestUri: "/v1/domains"
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              domains: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    owner: {},
                    arn: {},
                    status: {},
                    createdTime: {
                      type: "timestamp"
                    },
                    encryptionKey: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListPackageVersionAssets: {
          http: {
            requestUri: "/v1/package/version/assets"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository",
              "format",
              "package",
              "packageVersion"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              package: {
                location: "querystring",
                locationName: "package"
              },
              packageVersion: {
                location: "querystring",
                locationName: "version"
              },
              maxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              format: {},
              namespace: {},
              package: {},
              version: {},
              versionRevision: {},
              nextToken: {},
              assets: {
                type: "list",
                member: {
                  shape: "S35"
                }
              }
            }
          }
        },
        ListPackageVersionDependencies: {
          http: {
            requestUri: "/v1/package/version/dependencies"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository",
              "format",
              "package",
              "packageVersion"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              package: {
                location: "querystring",
                locationName: "package"
              },
              packageVersion: {
                location: "querystring",
                locationName: "version"
              },
              nextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              format: {},
              namespace: {},
              package: {},
              version: {},
              versionRevision: {},
              nextToken: {},
              dependencies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    namespace: {},
                    package: {},
                    dependencyType: {},
                    versionRequirement: {}
                  }
                }
              }
            }
          }
        },
        ListPackageVersions: {
          http: {
            requestUri: "/v1/package/versions"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository",
              "format",
              "package"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              package: {
                location: "querystring",
                locationName: "package"
              },
              status: {
                location: "querystring",
                locationName: "status"
              },
              sortBy: {
                location: "querystring",
                locationName: "sortBy"
              },
              maxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              originType: {
                location: "querystring",
                locationName: "originType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              defaultDisplayVersion: {},
              format: {},
              namespace: {},
              package: {},
              versions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "version",
                    "status"
                  ],
                  members: {
                    version: {},
                    revision: {},
                    status: {},
                    origin: {
                      shape: "S27"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListPackages: {
          http: {
            requestUri: "/v1/packages"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              packagePrefix: {
                location: "querystring",
                locationName: "package-prefix"
              },
              maxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              publish: {
                location: "querystring",
                locationName: "publish"
              },
              upstream: {
                location: "querystring",
                locationName: "upstream"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              packages: {
                type: "list",
                member: {
                  shape: "S1l"
                }
              },
              nextToken: {}
            }
          }
        },
        ListRepositories: {
          http: {
            requestUri: "/v1/repositories"
          },
          input: {
            type: "structure",
            members: {
              repositoryPrefix: {
                location: "querystring",
                locationName: "repository-prefix"
              },
              maxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repositories: {
                shape: "S3r"
              },
              nextToken: {}
            }
          }
        },
        ListRepositoriesInDomain: {
          http: {
            requestUri: "/v1/domain/repositories"
          },
          input: {
            type: "structure",
            required: [
              "domain"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              administratorAccount: {
                location: "querystring",
                locationName: "administrator-account"
              },
              repositoryPrefix: {
                location: "querystring",
                locationName: "repository-prefix"
              },
              maxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repositories: {
                shape: "S3r"
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            requestUri: "/v1/tags"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sz"
              }
            }
          }
        },
        PublishPackageVersion: {
          http: {
            requestUri: "/v1/package/version/publish"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository",
              "format",
              "package",
              "packageVersion",
              "assetContent",
              "assetName",
              "assetSHA256"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              package: {
                location: "querystring",
                locationName: "package"
              },
              packageVersion: {
                location: "querystring",
                locationName: "version"
              },
              assetContent: {
                shape: "S2o"
              },
              assetName: {
                location: "querystring",
                locationName: "asset"
              },
              assetSHA256: {
                location: "header",
                locationName: "x-amz-content-sha256"
              },
              unfinished: {
                location: "querystring",
                locationName: "unfinished",
                type: "boolean"
              }
            },
            payload: "assetContent"
          },
          output: {
            type: "structure",
            members: {
              format: {},
              namespace: {},
              package: {},
              version: {},
              versionRevision: {},
              status: {},
              asset: {
                shape: "S35"
              }
            }
          }
        },
        PutDomainPermissionsPolicy: {
          http: {
            method: "PUT",
            requestUri: "/v1/domain/permissions/policy"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "policyDocument"
            ],
            members: {
              domain: {},
              domainOwner: {},
              policyRevision: {},
              policyDocument: {}
            }
          },
          output: {
            type: "structure",
            members: {
              policy: {
                shape: "S1h"
              }
            }
          }
        },
        PutPackageOriginConfiguration: {
          http: {
            requestUri: "/v1/package"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository",
              "format",
              "package",
              "restrictions"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              package: {
                location: "querystring",
                locationName: "package"
              },
              restrictions: {
                shape: "S1n"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              originConfiguration: {
                shape: "S1m"
              }
            }
          }
        },
        PutRepositoryPermissionsPolicy: {
          http: {
            method: "PUT",
            requestUri: "/v1/repository/permissions/policy"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository",
              "policyDocument"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              policyRevision: {},
              policyDocument: {}
            }
          },
          output: {
            type: "structure",
            members: {
              policy: {
                shape: "S1h"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/v1/tag"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sz"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            requestUri: "/v1/untag"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdatePackageVersionsStatus: {
          http: {
            requestUri: "/v1/package/versions/update_status"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository",
              "format",
              "package",
              "versions",
              "targetStatus"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              package: {
                location: "querystring",
                locationName: "package"
              },
              versions: {
                shape: "Sk"
              },
              versionRevisions: {
                shape: "Sm"
              },
              expectedStatus: {},
              targetStatus: {}
            }
          },
          output: {
            type: "structure",
            members: {
              successfulVersions: {
                shape: "Sq"
              },
              failedVersions: {
                shape: "Su"
              }
            }
          }
        },
        UpdateRepository: {
          http: {
            method: "PUT",
            requestUri: "/v1/repository"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              description: {},
              upstreams: {
                shape: "S19"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repository: {
                shape: "S7"
              }
            }
          }
        }
      },
      shapes: {
        S7: {
          type: "structure",
          members: {
            name: {},
            administratorAccount: {},
            domainName: {},
            domainOwner: {},
            arn: {},
            description: {},
            upstreams: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  repositoryName: {}
                }
              }
            },
            externalConnections: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  externalConnectionName: {},
                  packageFormat: {},
                  status: {}
                }
              }
            },
            createdTime: {
              type: "timestamp"
            }
          }
        },
        Sk: {
          type: "list",
          member: {}
        },
        Sm: {
          type: "map",
          key: {},
          value: {}
        },
        Sq: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              revision: {},
              status: {}
            }
          }
        },
        Su: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              errorCode: {},
              errorMessage: {}
            }
          }
        },
        Sz: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        S14: {
          type: "structure",
          members: {
            name: {},
            owner: {},
            arn: {},
            status: {},
            createdTime: {
              type: "timestamp"
            },
            encryptionKey: {},
            repositoryCount: {
              type: "integer"
            },
            assetSizeBytes: {
              type: "long"
            },
            s3BucketArn: {}
          }
        },
        S19: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              repositoryName: {}
            }
          }
        },
        S1h: {
          type: "structure",
          members: {
            resourceArn: {},
            revision: {},
            document: {}
          }
        },
        S1l: {
          type: "structure",
          members: {
            format: {},
            namespace: {},
            package: {},
            originConfiguration: {
              shape: "S1m"
            }
          }
        },
        S1m: {
          type: "structure",
          members: {
            restrictions: {
              shape: "S1n"
            }
          }
        },
        S1n: {
          type: "structure",
          required: [
            "publish",
            "upstream"
          ],
          members: {
            publish: {},
            upstream: {}
          }
        },
        S27: {
          type: "structure",
          members: {
            domainEntryPoint: {
              type: "structure",
              members: {
                repositoryName: {},
                externalConnectionName: {}
              }
            },
            originType: {}
          }
        },
        S2o: {
          type: "blob",
          streaming: true
        },
        S35: {
          type: "structure",
          required: [
            "name"
          ],
          members: {
            name: {},
            size: {
              type: "long"
            },
            hashes: {
              type: "map",
              key: {},
              value: {}
            }
          }
        },
        S3r: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              administratorAccount: {},
              domainName: {},
              domainOwner: {},
              arn: {},
              description: {},
              createdTime: {
                type: "timestamp"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/codeartifact-2018-09-22.paginators.json
var require_codeartifact_2018_09_22_paginators = __commonJS({
  "node_modules/aws-sdk/apis/codeartifact-2018-09-22.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListDomains: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "domains"
        },
        ListPackageVersionAssets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "assets"
        },
        ListPackageVersions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "versions"
        },
        ListPackages: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "packages"
        },
        ListRepositories: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "repositories"
        },
        ListRepositoriesInDomain: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "repositories"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/codeartifact.js
var require_codeartifact = __commonJS({
  "node_modules/aws-sdk/clients/codeartifact.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["codeartifact"] = {};
    AWS2.CodeArtifact = Service.defineService("codeartifact", ["2018-09-22"]);
    Object.defineProperty(apiLoader.services["codeartifact"], "2018-09-22", {
      get: function get() {
        var model = require_codeartifact_2018_09_22_min();
        model.paginators = require_codeartifact_2018_09_22_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CodeArtifact;
  }
});

// node_modules/aws-sdk/apis/honeycode-2020-03-01.min.json
var require_honeycode_2020_03_01_min = __commonJS({
  "node_modules/aws-sdk/apis/honeycode-2020-03-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-03-01",
        endpointPrefix: "honeycode",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Honeycode",
        serviceFullName: "Amazon Honeycode",
        serviceId: "Honeycode",
        signatureVersion: "v4",
        signingName: "honeycode",
        uid: "honeycode-2020-03-01"
      },
      operations: {
        BatchCreateTableRows: {
          http: {
            requestUri: "/workbooks/{workbookId}/tables/{tableId}/rows/batchcreate"
          },
          input: {
            type: "structure",
            required: [
              "workbookId",
              "tableId",
              "rowsToCreate"
            ],
            members: {
              workbookId: {
                location: "uri",
                locationName: "workbookId"
              },
              tableId: {
                location: "uri",
                locationName: "tableId"
              },
              rowsToCreate: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "batchItemId",
                    "cellsToCreate"
                  ],
                  members: {
                    batchItemId: {},
                    cellsToCreate: {
                      shape: "S6"
                    }
                  }
                }
              },
              clientRequestToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "workbookCursor",
              "createdRows"
            ],
            members: {
              workbookCursor: {
                type: "long"
              },
              createdRows: {
                type: "map",
                key: {},
                value: {}
              },
              failedBatchItems: {
                shape: "Sf"
              }
            }
          }
        },
        BatchDeleteTableRows: {
          http: {
            requestUri: "/workbooks/{workbookId}/tables/{tableId}/rows/batchdelete"
          },
          input: {
            type: "structure",
            required: [
              "workbookId",
              "tableId",
              "rowIds"
            ],
            members: {
              workbookId: {
                location: "uri",
                locationName: "workbookId"
              },
              tableId: {
                location: "uri",
                locationName: "tableId"
              },
              rowIds: {
                shape: "Sj"
              },
              clientRequestToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "workbookCursor"
            ],
            members: {
              workbookCursor: {
                type: "long"
              },
              failedBatchItems: {
                shape: "Sf"
              }
            }
          }
        },
        BatchUpdateTableRows: {
          http: {
            requestUri: "/workbooks/{workbookId}/tables/{tableId}/rows/batchupdate"
          },
          input: {
            type: "structure",
            required: [
              "workbookId",
              "tableId",
              "rowsToUpdate"
            ],
            members: {
              workbookId: {
                location: "uri",
                locationName: "workbookId"
              },
              tableId: {
                location: "uri",
                locationName: "tableId"
              },
              rowsToUpdate: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "rowId",
                    "cellsToUpdate"
                  ],
                  members: {
                    rowId: {},
                    cellsToUpdate: {
                      shape: "S6"
                    }
                  }
                }
              },
              clientRequestToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "workbookCursor"
            ],
            members: {
              workbookCursor: {
                type: "long"
              },
              failedBatchItems: {
                shape: "Sf"
              }
            }
          }
        },
        BatchUpsertTableRows: {
          http: {
            requestUri: "/workbooks/{workbookId}/tables/{tableId}/rows/batchupsert"
          },
          input: {
            type: "structure",
            required: [
              "workbookId",
              "tableId",
              "rowsToUpsert"
            ],
            members: {
              workbookId: {
                location: "uri",
                locationName: "workbookId"
              },
              tableId: {
                location: "uri",
                locationName: "tableId"
              },
              rowsToUpsert: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "batchItemId",
                    "filter",
                    "cellsToUpdate"
                  ],
                  members: {
                    batchItemId: {},
                    filter: {
                      shape: "Ss"
                    },
                    cellsToUpdate: {
                      shape: "S6"
                    }
                  }
                }
              },
              clientRequestToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "rows",
              "workbookCursor"
            ],
            members: {
              rows: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  required: [
                    "rowIds",
                    "upsertAction"
                  ],
                  members: {
                    rowIds: {
                      shape: "Sj"
                    },
                    upsertAction: {}
                  }
                }
              },
              workbookCursor: {
                type: "long"
              },
              failedBatchItems: {
                shape: "Sf"
              }
            }
          }
        },
        DescribeTableDataImportJob: {
          http: {
            method: "GET",
            requestUri: "/workbooks/{workbookId}/tables/{tableId}/import/{jobId}"
          },
          input: {
            type: "structure",
            required: [
              "workbookId",
              "tableId",
              "jobId"
            ],
            members: {
              workbookId: {
                location: "uri",
                locationName: "workbookId"
              },
              tableId: {
                location: "uri",
                locationName: "tableId"
              },
              jobId: {
                location: "uri",
                locationName: "jobId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobStatus",
              "message",
              "jobMetadata"
            ],
            members: {
              jobStatus: {},
              message: {},
              jobMetadata: {
                type: "structure",
                required: [
                  "submitter",
                  "submitTime",
                  "importOptions",
                  "dataSource"
                ],
                members: {
                  submitter: {
                    type: "structure",
                    members: {
                      email: {
                        type: "string",
                        sensitive: true
                      },
                      userArn: {}
                    }
                  },
                  submitTime: {
                    type: "timestamp"
                  },
                  importOptions: {
                    shape: "S18"
                  },
                  dataSource: {
                    shape: "S1i"
                  }
                }
              },
              errorCode: {}
            }
          }
        },
        GetScreenData: {
          http: {
            requestUri: "/screendata"
          },
          input: {
            type: "structure",
            required: [
              "workbookId",
              "appId",
              "screenId"
            ],
            members: {
              workbookId: {},
              appId: {},
              screenId: {},
              variables: {
                shape: "S1n"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "results",
              "workbookCursor"
            ],
            members: {
              results: {
                type: "map",
                key: {
                  shape: "S1v"
                },
                value: {
                  type: "structure",
                  required: [
                    "headers",
                    "rows"
                  ],
                  members: {
                    headers: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "name",
                          "format"
                        ],
                        members: {
                          name: {
                            shape: "S1v"
                          },
                          format: {}
                        }
                      }
                    },
                    rows: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "dataItems"
                        ],
                        members: {
                          rowId: {},
                          dataItems: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                overrideFormat: {},
                                rawValue: {},
                                formattedValue: {}
                              },
                              sensitive: true
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              workbookCursor: {
                type: "long"
              },
              nextToken: {}
            }
          }
        },
        InvokeScreenAutomation: {
          http: {
            requestUri: "/workbooks/{workbookId}/apps/{appId}/screens/{screenId}/automations/{automationId}"
          },
          input: {
            type: "structure",
            required: [
              "workbookId",
              "appId",
              "screenId",
              "screenAutomationId"
            ],
            members: {
              workbookId: {
                location: "uri",
                locationName: "workbookId"
              },
              appId: {
                location: "uri",
                locationName: "appId"
              },
              screenId: {
                location: "uri",
                locationName: "screenId"
              },
              screenAutomationId: {
                location: "uri",
                locationName: "automationId"
              },
              variables: {
                shape: "S1n"
              },
              rowId: {},
              clientRequestToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "workbookCursor"
            ],
            members: {
              workbookCursor: {
                type: "long"
              }
            }
          }
        },
        ListTableColumns: {
          http: {
            method: "GET",
            requestUri: "/workbooks/{workbookId}/tables/{tableId}/columns"
          },
          input: {
            type: "structure",
            required: [
              "workbookId",
              "tableId"
            ],
            members: {
              workbookId: {
                location: "uri",
                locationName: "workbookId"
              },
              tableId: {
                location: "uri",
                locationName: "tableId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "tableColumns"
            ],
            members: {
              tableColumns: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    tableColumnId: {},
                    tableColumnName: {},
                    format: {}
                  }
                }
              },
              nextToken: {},
              workbookCursor: {
                type: "long"
              }
            }
          }
        },
        ListTableRows: {
          http: {
            requestUri: "/workbooks/{workbookId}/tables/{tableId}/rows/list"
          },
          input: {
            type: "structure",
            required: [
              "workbookId",
              "tableId"
            ],
            members: {
              workbookId: {
                location: "uri",
                locationName: "workbookId"
              },
              tableId: {
                location: "uri",
                locationName: "tableId"
              },
              rowIds: {
                shape: "Sj"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "columnIds",
              "rows",
              "workbookCursor"
            ],
            members: {
              columnIds: {
                shape: "S2e"
              },
              rows: {
                shape: "S2f"
              },
              rowIdsNotFound: {
                shape: "Sj"
              },
              nextToken: {},
              workbookCursor: {
                type: "long"
              }
            }
          }
        },
        ListTables: {
          http: {
            method: "GET",
            requestUri: "/workbooks/{workbookId}/tables"
          },
          input: {
            type: "structure",
            required: [
              "workbookId"
            ],
            members: {
              workbookId: {
                location: "uri",
                locationName: "workbookId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "tables"
            ],
            members: {
              tables: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    tableId: {},
                    tableName: {}
                  }
                }
              },
              nextToken: {},
              workbookCursor: {
                type: "long"
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S2s"
              }
            }
          }
        },
        QueryTableRows: {
          http: {
            requestUri: "/workbooks/{workbookId}/tables/{tableId}/rows/query"
          },
          input: {
            type: "structure",
            required: [
              "workbookId",
              "tableId",
              "filterFormula"
            ],
            members: {
              workbookId: {
                location: "uri",
                locationName: "workbookId"
              },
              tableId: {
                location: "uri",
                locationName: "tableId"
              },
              filterFormula: {
                shape: "Ss"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "columnIds",
              "rows",
              "workbookCursor"
            ],
            members: {
              columnIds: {
                shape: "S2e"
              },
              rows: {
                shape: "S2f"
              },
              nextToken: {},
              workbookCursor: {
                type: "long"
              }
            }
          }
        },
        StartTableDataImportJob: {
          http: {
            requestUri: "/workbooks/{workbookId}/tables/{tableId}/import"
          },
          input: {
            type: "structure",
            required: [
              "workbookId",
              "dataSource",
              "dataFormat",
              "destinationTableId",
              "importOptions",
              "clientRequestToken"
            ],
            members: {
              workbookId: {
                location: "uri",
                locationName: "workbookId"
              },
              dataSource: {
                shape: "S1i"
              },
              dataFormat: {},
              destinationTableId: {
                location: "uri",
                locationName: "tableId"
              },
              importOptions: {
                shape: "S18"
              },
              clientRequestToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "jobId",
              "jobStatus"
            ],
            members: {
              jobId: {},
              jobStatus: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S2s"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S6: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              fact: {
                shape: "S8"
              },
              facts: {
                type: "list",
                member: {
                  shape: "S8"
                }
              }
            }
          }
        },
        S8: {
          type: "string",
          sensitive: true
        },
        Sf: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "id",
              "errorMessage"
            ],
            members: {
              id: {},
              errorMessage: {}
            }
          }
        },
        Sj: {
          type: "list",
          member: {}
        },
        Ss: {
          type: "structure",
          required: [
            "formula"
          ],
          members: {
            formula: {
              shape: "St"
            },
            contextRowId: {}
          }
        },
        St: {
          type: "string",
          sensitive: true
        },
        S18: {
          type: "structure",
          members: {
            destinationOptions: {
              type: "structure",
              members: {
                columnMap: {
                  type: "map",
                  key: {},
                  value: {
                    type: "structure",
                    members: {
                      columnIndex: {
                        type: "integer"
                      }
                    }
                  }
                }
              }
            },
            delimitedTextOptions: {
              type: "structure",
              required: [
                "delimiter"
              ],
              members: {
                delimiter: {},
                hasHeaderRow: {
                  type: "boolean"
                },
                ignoreEmptyRows: {
                  type: "boolean"
                },
                dataCharacterEncoding: {}
              }
            }
          }
        },
        S1i: {
          type: "structure",
          required: [
            "dataSourceConfig"
          ],
          members: {
            dataSourceConfig: {
              type: "structure",
              members: {
                dataSourceUrl: {
                  type: "string",
                  sensitive: true
                }
              }
            }
          }
        },
        S1n: {
          type: "map",
          key: {
            type: "string",
            sensitive: true
          },
          value: {
            type: "structure",
            required: [
              "rawValue"
            ],
            members: {
              rawValue: {}
            },
            sensitive: true
          },
          sensitive: true
        },
        S1v: {
          type: "string",
          sensitive: true
        },
        S2e: {
          type: "list",
          member: {}
        },
        S2f: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "rowId",
              "cells"
            ],
            members: {
              rowId: {},
              cells: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    formula: {
                      shape: "St"
                    },
                    format: {},
                    rawValue: {},
                    formattedValue: {},
                    formattedValues: {
                      type: "list",
                      member: {}
                    }
                  },
                  sensitive: true
                }
              }
            }
          }
        },
        S2s: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/honeycode-2020-03-01.paginators.json
var require_honeycode_2020_03_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/honeycode-2020-03-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListTableColumns: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "tableColumns"
        },
        ListTableRows: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "rows"
        },
        ListTables: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "tables"
        },
        QueryTableRows: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "rows"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/honeycode.js
var require_honeycode = __commonJS({
  "node_modules/aws-sdk/clients/honeycode.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["honeycode"] = {};
    AWS2.Honeycode = Service.defineService("honeycode", ["2020-03-01"]);
    Object.defineProperty(apiLoader.services["honeycode"], "2020-03-01", {
      get: function get() {
        var model = require_honeycode_2020_03_01_min();
        model.paginators = require_honeycode_2020_03_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Honeycode;
  }
});

// node_modules/aws-sdk/apis/ivs-2020-07-14.min.json
var require_ivs_2020_07_14_min = __commonJS({
  "node_modules/aws-sdk/apis/ivs-2020-07-14.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-07-14",
        endpointPrefix: "ivs",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Amazon IVS",
        serviceFullName: "Amazon Interactive Video Service",
        serviceId: "ivs",
        signatureVersion: "v4",
        signingName: "ivs",
        uid: "ivs-2020-07-14"
      },
      operations: {
        BatchGetChannel: {
          http: {
            requestUri: "/BatchGetChannel",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arns"
            ],
            members: {
              arns: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              channels: {
                type: "list",
                member: {
                  shape: "S6"
                }
              },
              errors: {
                shape: "Sj"
              }
            }
          }
        },
        BatchGetStreamKey: {
          http: {
            requestUri: "/BatchGetStreamKey",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arns"
            ],
            members: {
              arns: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errors: {
                shape: "Sj"
              },
              streamKeys: {
                type: "list",
                member: {
                  shape: "St"
                }
              }
            }
          }
        },
        BatchStartViewerSessionRevocation: {
          http: {
            requestUri: "/BatchStartViewerSessionRevocation",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "viewerSessions"
            ],
            members: {
              viewerSessions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "channelArn",
                    "viewerId"
                  ],
                  members: {
                    channelArn: {},
                    viewerId: {},
                    viewerSessionVersionsLessThanOrEqualTo: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "channelArn",
                    "viewerId"
                  ],
                  members: {
                    channelArn: {},
                    code: {},
                    message: {},
                    viewerId: {}
                  }
                }
              }
            }
          }
        },
        CreateChannel: {
          http: {
            requestUri: "/CreateChannel",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              authorized: {
                type: "boolean"
              },
              insecureIngest: {
                type: "boolean"
              },
              latencyMode: {},
              name: {},
              preset: {},
              recordingConfigurationArn: {},
              tags: {
                shape: "Sf"
              },
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              channel: {
                shape: "S6"
              },
              streamKey: {
                shape: "St"
              }
            }
          }
        },
        CreateRecordingConfiguration: {
          http: {
            requestUri: "/CreateRecordingConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "destinationConfiguration"
            ],
            members: {
              destinationConfiguration: {
                shape: "S17"
              },
              name: {},
              recordingReconnectWindowSeconds: {
                type: "integer"
              },
              renditionConfiguration: {
                shape: "S1c"
              },
              tags: {
                shape: "Sf"
              },
              thumbnailConfiguration: {
                shape: "S1g"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              recordingConfiguration: {
                shape: "S1n"
              }
            }
          }
        },
        CreateStreamKey: {
          http: {
            requestUri: "/CreateStreamKey",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "channelArn"
            ],
            members: {
              channelArn: {},
              tags: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              streamKey: {
                shape: "St"
              }
            }
          }
        },
        DeleteChannel: {
          http: {
            requestUri: "/DeleteChannel",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          }
        },
        DeletePlaybackKeyPair: {
          http: {
            requestUri: "/DeletePlaybackKeyPair",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRecordingConfiguration: {
          http: {
            requestUri: "/DeleteRecordingConfiguration",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          }
        },
        DeleteStreamKey: {
          http: {
            requestUri: "/DeleteStreamKey",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          }
        },
        GetChannel: {
          http: {
            requestUri: "/GetChannel",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              channel: {
                shape: "S6"
              }
            }
          }
        },
        GetPlaybackKeyPair: {
          http: {
            requestUri: "/GetPlaybackKeyPair",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              keyPair: {
                shape: "S22"
              }
            }
          }
        },
        GetRecordingConfiguration: {
          http: {
            requestUri: "/GetRecordingConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              recordingConfiguration: {
                shape: "S1n"
              }
            }
          }
        },
        GetStream: {
          http: {
            requestUri: "/GetStream",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "channelArn"
            ],
            members: {
              channelArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              stream: {
                type: "structure",
                members: {
                  channelArn: {},
                  health: {},
                  playbackUrl: {},
                  startTime: {
                    shape: "S2b"
                  },
                  state: {},
                  streamId: {},
                  viewerCount: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        GetStreamKey: {
          http: {
            requestUri: "/GetStreamKey",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              streamKey: {
                shape: "St"
              }
            }
          }
        },
        GetStreamSession: {
          http: {
            requestUri: "/GetStreamSession",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "channelArn"
            ],
            members: {
              channelArn: {},
              streamId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              streamSession: {
                type: "structure",
                members: {
                  channel: {
                    shape: "S6"
                  },
                  endTime: {
                    shape: "S2k"
                  },
                  ingestConfiguration: {
                    type: "structure",
                    members: {
                      audio: {
                        type: "structure",
                        members: {
                          channels: {
                            type: "long"
                          },
                          codec: {},
                          sampleRate: {
                            type: "long"
                          },
                          targetBitrate: {
                            type: "long"
                          }
                        }
                      },
                      video: {
                        type: "structure",
                        members: {
                          avcLevel: {},
                          avcProfile: {},
                          codec: {},
                          encoder: {},
                          targetBitrate: {
                            type: "long"
                          },
                          targetFramerate: {
                            type: "long"
                          },
                          videoHeight: {
                            type: "long"
                          },
                          videoWidth: {
                            type: "long"
                          }
                        }
                      }
                    }
                  },
                  recordingConfiguration: {
                    shape: "S1n"
                  },
                  startTime: {
                    shape: "S2k"
                  },
                  streamId: {},
                  truncatedEvents: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        eventTime: {
                          shape: "S2k"
                        },
                        name: {},
                        type: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        ImportPlaybackKeyPair: {
          http: {
            requestUri: "/ImportPlaybackKeyPair",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "publicKeyMaterial"
            ],
            members: {
              name: {},
              publicKeyMaterial: {},
              tags: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              keyPair: {
                shape: "S22"
              }
            }
          }
        },
        ListChannels: {
          http: {
            requestUri: "/ListChannels",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              filterByName: {},
              filterByRecordingConfigurationArn: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "channels"
            ],
            members: {
              channels: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    authorized: {
                      type: "boolean"
                    },
                    insecureIngest: {
                      type: "boolean"
                    },
                    latencyMode: {},
                    name: {},
                    preset: {},
                    recordingConfigurationArn: {},
                    tags: {
                      shape: "Sf"
                    },
                    type: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListPlaybackKeyPairs: {
          http: {
            requestUri: "/ListPlaybackKeyPairs",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "keyPairs"
            ],
            members: {
              keyPairs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    name: {},
                    tags: {
                      shape: "Sf"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListRecordingConfigurations: {
          http: {
            requestUri: "/ListRecordingConfigurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "recordingConfigurations"
            ],
            members: {
              nextToken: {},
              recordingConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "destinationConfiguration",
                    "state"
                  ],
                  members: {
                    arn: {},
                    destinationConfiguration: {
                      shape: "S17"
                    },
                    name: {},
                    state: {},
                    tags: {
                      shape: "Sf"
                    }
                  }
                }
              }
            }
          }
        },
        ListStreamKeys: {
          http: {
            requestUri: "/ListStreamKeys",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "channelArn"
            ],
            members: {
              channelArn: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "streamKeys"
            ],
            members: {
              nextToken: {},
              streamKeys: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    channelArn: {},
                    tags: {
                      shape: "Sf"
                    }
                  }
                }
              }
            }
          }
        },
        ListStreamSessions: {
          http: {
            requestUri: "/ListStreamSessions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "channelArn"
            ],
            members: {
              channelArn: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "streamSessions"
            ],
            members: {
              nextToken: {},
              streamSessions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    endTime: {
                      shape: "S2k"
                    },
                    hasErrorEvent: {
                      type: "boolean"
                    },
                    startTime: {
                      shape: "S2k"
                    },
                    streamId: {}
                  }
                }
              }
            }
          }
        },
        ListStreams: {
          http: {
            requestUri: "/ListStreams",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              filterBy: {
                type: "structure",
                members: {
                  health: {}
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "streams"
            ],
            members: {
              nextToken: {},
              streams: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    channelArn: {},
                    health: {},
                    startTime: {
                      shape: "S2b"
                    },
                    state: {},
                    streamId: {},
                    viewerCount: {
                      type: "long"
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "tags"
            ],
            members: {
              tags: {
                shape: "Sf"
              }
            }
          }
        },
        PutMetadata: {
          http: {
            requestUri: "/PutMetadata",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "channelArn",
              "metadata"
            ],
            members: {
              channelArn: {},
              metadata: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        StartViewerSessionRevocation: {
          http: {
            requestUri: "/StartViewerSessionRevocation",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "channelArn",
              "viewerId"
            ],
            members: {
              channelArn: {},
              viewerId: {},
              viewerSessionVersionsLessThanOrEqualTo: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StopStream: {
          http: {
            requestUri: "/StopStream",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "channelArn"
            ],
            members: {
              channelArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateChannel: {
          http: {
            requestUri: "/UpdateChannel",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              authorized: {
                type: "boolean"
              },
              insecureIngest: {
                type: "boolean"
              },
              latencyMode: {},
              name: {},
              preset: {},
              recordingConfigurationArn: {},
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              channel: {
                shape: "S6"
              }
            }
          }
        }
      },
      shapes: {
        S6: {
          type: "structure",
          members: {
            arn: {},
            authorized: {
              type: "boolean"
            },
            ingestEndpoint: {},
            insecureIngest: {
              type: "boolean"
            },
            latencyMode: {},
            name: {},
            playbackUrl: {},
            preset: {},
            recordingConfigurationArn: {},
            tags: {
              shape: "Sf"
            },
            type: {}
          }
        },
        Sf: {
          type: "map",
          key: {},
          value: {}
        },
        Sj: {
          type: "list",
          member: {
            type: "structure",
            members: {
              arn: {},
              code: {},
              message: {}
            }
          }
        },
        St: {
          type: "structure",
          members: {
            arn: {},
            channelArn: {},
            tags: {
              shape: "Sf"
            },
            value: {
              type: "string",
              sensitive: true
            }
          }
        },
        S17: {
          type: "structure",
          members: {
            s3: {
              type: "structure",
              required: [
                "bucketName"
              ],
              members: {
                bucketName: {}
              }
            }
          }
        },
        S1c: {
          type: "structure",
          members: {
            renditionSelection: {},
            renditions: {
              type: "list",
              member: {}
            }
          }
        },
        S1g: {
          type: "structure",
          members: {
            recordingMode: {},
            resolution: {},
            storage: {
              type: "list",
              member: {}
            },
            targetIntervalSeconds: {
              type: "long"
            }
          }
        },
        S1n: {
          type: "structure",
          required: [
            "arn",
            "destinationConfiguration",
            "state"
          ],
          members: {
            arn: {},
            destinationConfiguration: {
              shape: "S17"
            },
            name: {},
            recordingReconnectWindowSeconds: {
              type: "integer"
            },
            renditionConfiguration: {
              shape: "S1c"
            },
            state: {},
            tags: {
              shape: "Sf"
            },
            thumbnailConfiguration: {
              shape: "S1g"
            }
          }
        },
        S22: {
          type: "structure",
          members: {
            arn: {},
            fingerprint: {},
            name: {},
            tags: {
              shape: "Sf"
            }
          }
        },
        S2b: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S2k: {
          type: "timestamp",
          timestampFormat: "iso8601"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ivs-2020-07-14.paginators.json
var require_ivs_2020_07_14_paginators = __commonJS({
  "node_modules/aws-sdk/apis/ivs-2020-07-14.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListChannels: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListPlaybackKeyPairs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListRecordingConfigurations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListStreamKeys: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListStreamSessions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListStreams: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/ivs.js
var require_ivs = __commonJS({
  "node_modules/aws-sdk/clients/ivs.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["ivs"] = {};
    AWS2.IVS = Service.defineService("ivs", ["2020-07-14"]);
    Object.defineProperty(apiLoader.services["ivs"], "2020-07-14", {
      get: function get() {
        var model = require_ivs_2020_07_14_min();
        model.paginators = require_ivs_2020_07_14_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.IVS;
  }
});

// node_modules/aws-sdk/apis/braket-2019-09-01.min.json
var require_braket_2019_09_01_min = __commonJS({
  "node_modules/aws-sdk/apis/braket-2019-09-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-09-01",
        endpointPrefix: "braket",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Braket",
        serviceId: "Braket",
        signatureVersion: "v4",
        signingName: "braket",
        uid: "braket-2019-09-01"
      },
      operations: {
        CancelJob: {
          http: {
            method: "PUT",
            requestUri: "/job/{jobArn}/cancel",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "jobArn"
            ],
            members: {
              jobArn: {
                location: "uri",
                locationName: "jobArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "cancellationStatus",
              "jobArn"
            ],
            members: {
              cancellationStatus: {},
              jobArn: {}
            }
          },
          idempotent: true
        },
        CancelQuantumTask: {
          http: {
            method: "PUT",
            requestUri: "/quantum-task/{quantumTaskArn}/cancel",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "clientToken",
              "quantumTaskArn"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              quantumTaskArn: {
                location: "uri",
                locationName: "quantumTaskArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "cancellationStatus",
              "quantumTaskArn"
            ],
            members: {
              cancellationStatus: {},
              quantumTaskArn: {}
            }
          },
          idempotent: true
        },
        CreateJob: {
          http: {
            requestUri: "/job",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "algorithmSpecification",
              "clientToken",
              "deviceConfig",
              "instanceConfig",
              "jobName",
              "outputDataConfig",
              "roleArn"
            ],
            members: {
              algorithmSpecification: {
                shape: "Sa"
              },
              associations: {
                type: "list",
                member: {
                  shape: "Si"
                }
              },
              checkpointConfig: {
                shape: "Sl"
              },
              clientToken: {
                idempotencyToken: true
              },
              deviceConfig: {
                shape: "Sn"
              },
              hyperParameters: {
                shape: "Sp"
              },
              inputDataConfig: {
                type: "list",
                member: {
                  shape: "Ss"
                }
              },
              instanceConfig: {
                shape: "Sw"
              },
              jobName: {},
              outputDataConfig: {
                shape: "S11"
              },
              roleArn: {},
              stoppingCondition: {
                shape: "S14"
              },
              tags: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobArn"
            ],
            members: {
              jobArn: {}
            }
          }
        },
        CreateQuantumTask: {
          http: {
            requestUri: "/quantum-task",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "action",
              "clientToken",
              "deviceArn",
              "outputS3Bucket",
              "outputS3KeyPrefix",
              "shots"
            ],
            members: {
              action: {
                jsonvalue: true
              },
              associations: {
                type: "list",
                member: {
                  shape: "Si"
                }
              },
              clientToken: {
                idempotencyToken: true
              },
              deviceArn: {},
              deviceParameters: {
                jsonvalue: true
              },
              jobToken: {},
              outputS3Bucket: {},
              outputS3KeyPrefix: {},
              shots: {
                type: "long"
              },
              tags: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "quantumTaskArn"
            ],
            members: {
              quantumTaskArn: {}
            }
          }
        },
        GetDevice: {
          http: {
            method: "GET",
            requestUri: "/device/{deviceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "deviceArn"
            ],
            members: {
              deviceArn: {
                location: "uri",
                locationName: "deviceArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "deviceArn",
              "deviceCapabilities",
              "deviceName",
              "deviceStatus",
              "deviceType",
              "providerName"
            ],
            members: {
              deviceArn: {},
              deviceCapabilities: {
                jsonvalue: true
              },
              deviceName: {},
              deviceQueueInfo: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "queue",
                    "queueSize"
                  ],
                  members: {
                    queue: {},
                    queuePriority: {},
                    queueSize: {}
                  }
                }
              },
              deviceStatus: {},
              deviceType: {},
              providerName: {}
            }
          }
        },
        GetJob: {
          http: {
            method: "GET",
            requestUri: "/job/{jobArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "jobArn"
            ],
            members: {
              additionalAttributeNames: {
                location: "querystring",
                locationName: "additionalAttributeNames",
                type: "list",
                member: {}
              },
              jobArn: {
                location: "uri",
                locationName: "jobArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "algorithmSpecification",
              "createdAt",
              "instanceConfig",
              "jobArn",
              "jobName",
              "outputDataConfig",
              "roleArn",
              "status"
            ],
            members: {
              algorithmSpecification: {
                shape: "Sa"
              },
              associations: {
                shape: "S1u"
              },
              billableDuration: {
                type: "integer"
              },
              checkpointConfig: {
                shape: "Sl"
              },
              createdAt: {
                shape: "S1w"
              },
              deviceConfig: {
                shape: "Sn"
              },
              endedAt: {
                shape: "S1w"
              },
              events: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    eventType: {},
                    message: {},
                    timeOfEvent: {
                      shape: "S1w"
                    }
                  }
                }
              },
              failureReason: {},
              hyperParameters: {
                shape: "Sp"
              },
              inputDataConfig: {
                type: "list",
                member: {
                  shape: "Ss"
                }
              },
              instanceConfig: {
                shape: "Sw"
              },
              jobArn: {},
              jobName: {},
              outputDataConfig: {
                shape: "S11"
              },
              queueInfo: {
                type: "structure",
                required: [
                  "position",
                  "queue"
                ],
                members: {
                  message: {},
                  position: {},
                  queue: {}
                }
              },
              roleArn: {},
              startedAt: {
                shape: "S1w"
              },
              status: {},
              stoppingCondition: {
                shape: "S14"
              },
              tags: {
                shape: "S16"
              }
            }
          }
        },
        GetQuantumTask: {
          http: {
            method: "GET",
            requestUri: "/quantum-task/{quantumTaskArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "quantumTaskArn"
            ],
            members: {
              additionalAttributeNames: {
                location: "querystring",
                locationName: "additionalAttributeNames",
                type: "list",
                member: {}
              },
              quantumTaskArn: {
                location: "uri",
                locationName: "quantumTaskArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "createdAt",
              "deviceArn",
              "deviceParameters",
              "outputS3Bucket",
              "outputS3Directory",
              "quantumTaskArn",
              "shots",
              "status"
            ],
            members: {
              associations: {
                shape: "S1u"
              },
              createdAt: {
                shape: "S1w"
              },
              deviceArn: {},
              deviceParameters: {
                jsonvalue: true
              },
              endedAt: {
                shape: "S1w"
              },
              failureReason: {},
              jobArn: {},
              outputS3Bucket: {},
              outputS3Directory: {},
              quantumTaskArn: {},
              queueInfo: {
                type: "structure",
                required: [
                  "position",
                  "queue"
                ],
                members: {
                  message: {},
                  position: {},
                  queue: {},
                  queuePriority: {}
                }
              },
              shots: {
                type: "long"
              },
              status: {},
              tags: {
                shape: "S16"
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S16"
              }
            }
          }
        },
        SearchDevices: {
          http: {
            requestUri: "/devices",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "filters"
            ],
            members: {
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "values"
                  ],
                  members: {
                    name: {},
                    values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "devices"
            ],
            members: {
              devices: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "deviceArn",
                    "deviceName",
                    "deviceStatus",
                    "deviceType",
                    "providerName"
                  ],
                  members: {
                    deviceArn: {},
                    deviceName: {},
                    deviceStatus: {},
                    deviceType: {},
                    providerName: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        SearchJobs: {
          http: {
            requestUri: "/jobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "filters"
            ],
            members: {
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "operator",
                    "values"
                  ],
                  members: {
                    name: {},
                    operator: {},
                    values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "jobs"
            ],
            members: {
              jobs: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "createdAt",
                    "device",
                    "jobArn",
                    "jobName",
                    "status"
                  ],
                  members: {
                    createdAt: {
                      shape: "S1w"
                    },
                    device: {},
                    endedAt: {
                      shape: "S1w"
                    },
                    jobArn: {},
                    jobName: {},
                    startedAt: {
                      shape: "S1w"
                    },
                    status: {},
                    tags: {
                      shape: "S16"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        SearchQuantumTasks: {
          http: {
            requestUri: "/quantum-tasks",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "filters"
            ],
            members: {
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "operator",
                    "values"
                  ],
                  members: {
                    name: {},
                    operator: {},
                    values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "quantumTasks"
            ],
            members: {
              nextToken: {},
              quantumTasks: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "createdAt",
                    "deviceArn",
                    "outputS3Bucket",
                    "outputS3Directory",
                    "quantumTaskArn",
                    "shots",
                    "status"
                  ],
                  members: {
                    createdAt: {
                      shape: "S1w"
                    },
                    deviceArn: {},
                    endedAt: {
                      shape: "S1w"
                    },
                    outputS3Bucket: {},
                    outputS3Directory: {},
                    quantumTaskArn: {},
                    shots: {
                      type: "long"
                    },
                    status: {},
                    tags: {
                      shape: "S16"
                    }
                  }
                }
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        }
      },
      shapes: {
        Sa: {
          type: "structure",
          members: {
            containerImage: {
              type: "structure",
              required: [
                "uri"
              ],
              members: {
                uri: {}
              }
            },
            scriptModeConfig: {
              type: "structure",
              required: [
                "entryPoint",
                "s3Uri"
              ],
              members: {
                compressionType: {},
                entryPoint: {},
                s3Uri: {}
              }
            }
          }
        },
        Si: {
          type: "structure",
          required: [
            "arn",
            "type"
          ],
          members: {
            arn: {},
            type: {}
          }
        },
        Sl: {
          type: "structure",
          required: [
            "s3Uri"
          ],
          members: {
            localPath: {},
            s3Uri: {}
          }
        },
        Sn: {
          type: "structure",
          required: [
            "device"
          ],
          members: {
            device: {}
          }
        },
        Sp: {
          type: "map",
          key: {},
          value: {}
        },
        Ss: {
          type: "structure",
          required: [
            "channelName",
            "dataSource"
          ],
          members: {
            channelName: {},
            contentType: {},
            dataSource: {
              type: "structure",
              required: [
                "s3DataSource"
              ],
              members: {
                s3DataSource: {
                  type: "structure",
                  required: [
                    "s3Uri"
                  ],
                  members: {
                    s3Uri: {}
                  }
                }
              }
            }
          }
        },
        Sw: {
          type: "structure",
          required: [
            "instanceType",
            "volumeSizeInGb"
          ],
          members: {
            instanceCount: {
              type: "integer"
            },
            instanceType: {},
            volumeSizeInGb: {
              type: "integer"
            }
          }
        },
        S11: {
          type: "structure",
          required: [
            "s3Path"
          ],
          members: {
            kmsKeyId: {},
            s3Path: {}
          }
        },
        S14: {
          type: "structure",
          members: {
            maxRuntimeInSeconds: {
              type: "integer"
            }
          }
        },
        S16: {
          type: "map",
          key: {},
          value: {}
        },
        S1u: {
          type: "list",
          member: {
            shape: "Si"
          }
        },
        S1w: {
          type: "timestamp",
          timestampFormat: "iso8601"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/braket-2019-09-01.paginators.json
var require_braket_2019_09_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/braket-2019-09-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        SearchDevices: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "devices"
        },
        SearchJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "jobs"
        },
        SearchQuantumTasks: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "quantumTasks"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/braket.js
var require_braket = __commonJS({
  "node_modules/aws-sdk/clients/braket.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["braket"] = {};
    AWS2.Braket = Service.defineService("braket", ["2019-09-01"]);
    Object.defineProperty(apiLoader.services["braket"], "2019-09-01", {
      get: function get() {
        var model = require_braket_2019_09_01_min();
        model.paginators = require_braket_2019_09_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Braket;
  }
});

// node_modules/aws-sdk/apis/identitystore-2020-06-15.min.json
var require_identitystore_2020_06_15_min = __commonJS({
  "node_modules/aws-sdk/apis/identitystore-2020-06-15.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-06-15",
        endpointPrefix: "identitystore",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "IdentityStore",
        serviceFullName: "AWS SSO Identity Store",
        serviceId: "identitystore",
        signatureVersion: "v4",
        signingName: "identitystore",
        targetPrefix: "AWSIdentityStore",
        uid: "identitystore-2020-06-15"
      },
      operations: {
        CreateGroup: {
          input: {
            type: "structure",
            required: [
              "IdentityStoreId"
            ],
            members: {
              IdentityStoreId: {},
              DisplayName: {
                shape: "S3"
              },
              Description: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "GroupId",
              "IdentityStoreId"
            ],
            members: {
              GroupId: {},
              IdentityStoreId: {}
            }
          }
        },
        CreateGroupMembership: {
          input: {
            type: "structure",
            required: [
              "IdentityStoreId",
              "GroupId",
              "MemberId"
            ],
            members: {
              IdentityStoreId: {},
              GroupId: {},
              MemberId: {
                shape: "S8"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "MembershipId",
              "IdentityStoreId"
            ],
            members: {
              MembershipId: {},
              IdentityStoreId: {}
            }
          }
        },
        CreateUser: {
          input: {
            type: "structure",
            required: [
              "IdentityStoreId"
            ],
            members: {
              IdentityStoreId: {},
              UserName: {
                shape: "Sb"
              },
              Name: {
                shape: "Sc"
              },
              DisplayName: {
                shape: "S4"
              },
              NickName: {
                shape: "S4"
              },
              ProfileUrl: {
                shape: "S4"
              },
              Emails: {
                shape: "Sd"
              },
              Addresses: {
                shape: "Sg"
              },
              PhoneNumbers: {
                shape: "Si"
              },
              UserType: {
                shape: "S4"
              },
              Title: {
                shape: "S4"
              },
              PreferredLanguage: {
                shape: "S4"
              },
              Locale: {
                shape: "S4"
              },
              Timezone: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UserId",
              "IdentityStoreId"
            ],
            members: {
              UserId: {},
              IdentityStoreId: {}
            }
          }
        },
        DeleteGroup: {
          input: {
            type: "structure",
            required: [
              "IdentityStoreId",
              "GroupId"
            ],
            members: {
              IdentityStoreId: {},
              GroupId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteGroupMembership: {
          input: {
            type: "structure",
            required: [
              "IdentityStoreId",
              "MembershipId"
            ],
            members: {
              IdentityStoreId: {},
              MembershipId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteUser: {
          input: {
            type: "structure",
            required: [
              "IdentityStoreId",
              "UserId"
            ],
            members: {
              IdentityStoreId: {},
              UserId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DescribeGroup: {
          input: {
            type: "structure",
            required: [
              "IdentityStoreId",
              "GroupId"
            ],
            members: {
              IdentityStoreId: {},
              GroupId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "GroupId",
              "IdentityStoreId"
            ],
            members: {
              GroupId: {},
              DisplayName: {
                shape: "S3"
              },
              ExternalIds: {
                shape: "St"
              },
              Description: {
                shape: "S4"
              },
              IdentityStoreId: {}
            }
          }
        },
        DescribeGroupMembership: {
          input: {
            type: "structure",
            required: [
              "IdentityStoreId",
              "MembershipId"
            ],
            members: {
              IdentityStoreId: {},
              MembershipId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "IdentityStoreId",
              "MembershipId",
              "GroupId",
              "MemberId"
            ],
            members: {
              IdentityStoreId: {},
              MembershipId: {},
              GroupId: {},
              MemberId: {
                shape: "S8"
              }
            }
          }
        },
        DescribeUser: {
          input: {
            type: "structure",
            required: [
              "IdentityStoreId",
              "UserId"
            ],
            members: {
              IdentityStoreId: {},
              UserId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "UserId",
              "IdentityStoreId"
            ],
            members: {
              UserName: {
                shape: "Sb"
              },
              UserId: {},
              ExternalIds: {
                shape: "St"
              },
              Name: {
                shape: "Sc"
              },
              DisplayName: {
                shape: "S4"
              },
              NickName: {
                shape: "S4"
              },
              ProfileUrl: {
                shape: "S4"
              },
              Emails: {
                shape: "Sd"
              },
              Addresses: {
                shape: "Sg"
              },
              PhoneNumbers: {
                shape: "Si"
              },
              UserType: {
                shape: "S4"
              },
              Title: {
                shape: "S4"
              },
              PreferredLanguage: {
                shape: "S4"
              },
              Locale: {
                shape: "S4"
              },
              Timezone: {
                shape: "S4"
              },
              IdentityStoreId: {}
            }
          }
        },
        GetGroupId: {
          input: {
            type: "structure",
            required: [
              "IdentityStoreId",
              "AlternateIdentifier"
            ],
            members: {
              IdentityStoreId: {},
              AlternateIdentifier: {
                shape: "S12"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "GroupId",
              "IdentityStoreId"
            ],
            members: {
              GroupId: {},
              IdentityStoreId: {}
            }
          }
        },
        GetGroupMembershipId: {
          input: {
            type: "structure",
            required: [
              "IdentityStoreId",
              "GroupId",
              "MemberId"
            ],
            members: {
              IdentityStoreId: {},
              GroupId: {},
              MemberId: {
                shape: "S8"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "MembershipId",
              "IdentityStoreId"
            ],
            members: {
              MembershipId: {},
              IdentityStoreId: {}
            }
          }
        },
        GetUserId: {
          input: {
            type: "structure",
            required: [
              "IdentityStoreId",
              "AlternateIdentifier"
            ],
            members: {
              IdentityStoreId: {},
              AlternateIdentifier: {
                shape: "S12"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UserId",
              "IdentityStoreId"
            ],
            members: {
              UserId: {},
              IdentityStoreId: {}
            }
          }
        },
        IsMemberInGroups: {
          input: {
            type: "structure",
            required: [
              "IdentityStoreId",
              "MemberId",
              "GroupIds"
            ],
            members: {
              IdentityStoreId: {},
              MemberId: {
                shape: "S8"
              },
              GroupIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Results"
            ],
            members: {
              Results: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    GroupId: {},
                    MemberId: {
                      shape: "S8"
                    },
                    MembershipExists: {
                      shape: "Sf"
                    }
                  }
                }
              }
            }
          }
        },
        ListGroupMemberships: {
          input: {
            type: "structure",
            required: [
              "IdentityStoreId",
              "GroupId"
            ],
            members: {
              IdentityStoreId: {},
              GroupId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "GroupMemberships"
            ],
            members: {
              GroupMemberships: {
                shape: "S1k"
              },
              NextToken: {}
            }
          }
        },
        ListGroupMembershipsForMember: {
          input: {
            type: "structure",
            required: [
              "IdentityStoreId",
              "MemberId"
            ],
            members: {
              IdentityStoreId: {},
              MemberId: {
                shape: "S8"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "GroupMemberships"
            ],
            members: {
              GroupMemberships: {
                shape: "S1k"
              },
              NextToken: {}
            }
          }
        },
        ListGroups: {
          input: {
            type: "structure",
            required: [
              "IdentityStoreId"
            ],
            members: {
              IdentityStoreId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "S1p",
                deprecated: true,
                deprecatedMessage: "Using filters with ListGroups API is deprecated, please use GetGroupId API instead."
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Groups"
            ],
            members: {
              Groups: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "GroupId",
                    "IdentityStoreId"
                  ],
                  members: {
                    GroupId: {},
                    DisplayName: {
                      shape: "S3"
                    },
                    ExternalIds: {
                      shape: "St"
                    },
                    Description: {
                      shape: "S4"
                    },
                    IdentityStoreId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListUsers: {
          input: {
            type: "structure",
            required: [
              "IdentityStoreId"
            ],
            members: {
              IdentityStoreId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "S1p",
                deprecated: true,
                deprecatedMessage: "Using filters with ListUsers API is deprecated, please use GetGroupId API instead."
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Users"
            ],
            members: {
              Users: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "UserId",
                    "IdentityStoreId"
                  ],
                  members: {
                    UserName: {
                      shape: "Sb"
                    },
                    UserId: {},
                    ExternalIds: {
                      shape: "St"
                    },
                    Name: {
                      shape: "Sc"
                    },
                    DisplayName: {
                      shape: "S4"
                    },
                    NickName: {
                      shape: "S4"
                    },
                    ProfileUrl: {
                      shape: "S4"
                    },
                    Emails: {
                      shape: "Sd"
                    },
                    Addresses: {
                      shape: "Sg"
                    },
                    PhoneNumbers: {
                      shape: "Si"
                    },
                    UserType: {
                      shape: "S4"
                    },
                    Title: {
                      shape: "S4"
                    },
                    PreferredLanguage: {
                      shape: "S4"
                    },
                    Locale: {
                      shape: "S4"
                    },
                    Timezone: {
                      shape: "S4"
                    },
                    IdentityStoreId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        UpdateGroup: {
          input: {
            type: "structure",
            required: [
              "IdentityStoreId",
              "GroupId",
              "Operations"
            ],
            members: {
              IdentityStoreId: {},
              GroupId: {},
              Operations: {
                shape: "S1z"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateUser: {
          input: {
            type: "structure",
            required: [
              "IdentityStoreId",
              "UserId",
              "Operations"
            ],
            members: {
              IdentityStoreId: {},
              UserId: {},
              Operations: {
                shape: "S1z"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S3: {
          type: "string",
          sensitive: true
        },
        S4: {
          type: "string",
          sensitive: true
        },
        S8: {
          type: "structure",
          members: {
            UserId: {}
          },
          union: true
        },
        Sb: {
          type: "string",
          sensitive: true
        },
        Sc: {
          type: "structure",
          members: {
            Formatted: {
              shape: "S4"
            },
            FamilyName: {
              shape: "S4"
            },
            GivenName: {
              shape: "S4"
            },
            MiddleName: {
              shape: "S4"
            },
            HonorificPrefix: {
              shape: "S4"
            },
            HonorificSuffix: {
              shape: "S4"
            }
          }
        },
        Sd: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Value: {
                shape: "S4"
              },
              Type: {
                shape: "S4"
              },
              Primary: {
                shape: "Sf"
              }
            }
          }
        },
        Sf: {
          type: "boolean",
          sensitive: true
        },
        Sg: {
          type: "list",
          member: {
            type: "structure",
            members: {
              StreetAddress: {
                shape: "S4"
              },
              Locality: {
                shape: "S4"
              },
              Region: {
                shape: "S4"
              },
              PostalCode: {
                shape: "S4"
              },
              Country: {
                shape: "S4"
              },
              Formatted: {
                shape: "S4"
              },
              Type: {
                shape: "S4"
              },
              Primary: {
                shape: "Sf"
              }
            }
          }
        },
        Si: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Value: {
                shape: "S4"
              },
              Type: {
                shape: "S4"
              },
              Primary: {
                shape: "Sf"
              }
            }
          }
        },
        St: {
          type: "list",
          member: {
            shape: "Su"
          }
        },
        Su: {
          type: "structure",
          required: [
            "Issuer",
            "Id"
          ],
          members: {
            Issuer: {
              type: "string",
              sensitive: true
            },
            Id: {
              type: "string",
              sensitive: true
            }
          }
        },
        S12: {
          type: "structure",
          members: {
            ExternalId: {
              shape: "Su"
            },
            UniqueAttribute: {
              type: "structure",
              required: [
                "AttributePath",
                "AttributeValue"
              ],
              members: {
                AttributePath: {},
                AttributeValue: {
                  shape: "S15"
                }
              }
            }
          },
          union: true
        },
        S15: {
          type: "structure",
          members: {},
          document: true
        },
        S1k: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "IdentityStoreId"
            ],
            members: {
              IdentityStoreId: {},
              MembershipId: {},
              GroupId: {},
              MemberId: {
                shape: "S8"
              }
            }
          }
        },
        S1p: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AttributePath",
              "AttributeValue"
            ],
            members: {
              AttributePath: {},
              AttributeValue: {
                shape: "S4"
              }
            }
          }
        },
        S1z: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AttributePath"
            ],
            members: {
              AttributePath: {},
              AttributeValue: {
                shape: "S15"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/identitystore-2020-06-15.paginators.json
var require_identitystore_2020_06_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/identitystore-2020-06-15.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListGroupMemberships: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "GroupMemberships"
        },
        ListGroupMembershipsForMember: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "GroupMemberships"
        },
        ListGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Groups"
        },
        ListUsers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Users"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/identitystore.js
var require_identitystore = __commonJS({
  "node_modules/aws-sdk/clients/identitystore.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["identitystore"] = {};
    AWS2.IdentityStore = Service.defineService("identitystore", ["2020-06-15"]);
    Object.defineProperty(apiLoader.services["identitystore"], "2020-06-15", {
      get: function get() {
        var model = require_identitystore_2020_06_15_min();
        model.paginators = require_identitystore_2020_06_15_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.IdentityStore;
  }
});

// node_modules/aws-sdk/apis/appflow-2020-08-23.min.json
var require_appflow_2020_08_23_min = __commonJS({
  "node_modules/aws-sdk/apis/appflow-2020-08-23.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-08-23",
        endpointPrefix: "appflow",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Appflow",
        serviceId: "Appflow",
        signatureVersion: "v4",
        signingName: "appflow",
        uid: "appflow-2020-08-23"
      },
      operations: {
        CancelFlowExecutions: {
          http: {
            requestUri: "/cancel-flow-executions"
          },
          input: {
            type: "structure",
            required: [
              "flowName"
            ],
            members: {
              flowName: {},
              executionIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              invalidExecutions: {
                shape: "S3"
              }
            }
          }
        },
        CreateConnectorProfile: {
          http: {
            requestUri: "/create-connector-profile"
          },
          input: {
            type: "structure",
            required: [
              "connectorProfileName",
              "connectorType",
              "connectionMode",
              "connectorProfileConfig"
            ],
            members: {
              connectorProfileName: {},
              kmsArn: {},
              connectorType: {},
              connectorLabel: {},
              connectionMode: {},
              connectorProfileConfig: {
                shape: "Sc"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              connectorProfileArn: {}
            }
          }
        },
        CreateFlow: {
          http: {
            requestUri: "/create-flow"
          },
          input: {
            type: "structure",
            required: [
              "flowName",
              "triggerConfig",
              "sourceFlowConfig",
              "destinationFlowConfigList",
              "tasks"
            ],
            members: {
              flowName: {},
              description: {},
              kmsArn: {},
              triggerConfig: {
                shape: "S3d"
              },
              sourceFlowConfig: {
                shape: "S3n"
              },
              destinationFlowConfigList: {
                shape: "S4n"
              },
              tasks: {
                shape: "S5n"
              },
              tags: {
                shape: "S6d"
              },
              metadataCatalogConfig: {
                shape: "S6g"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              flowArn: {},
              flowStatus: {}
            }
          }
        },
        DeleteConnectorProfile: {
          http: {
            requestUri: "/delete-connector-profile"
          },
          input: {
            type: "structure",
            required: [
              "connectorProfileName"
            ],
            members: {
              connectorProfileName: {},
              forceDelete: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteFlow: {
          http: {
            requestUri: "/delete-flow"
          },
          input: {
            type: "structure",
            required: [
              "flowName"
            ],
            members: {
              flowName: {},
              forceDelete: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeConnector: {
          http: {
            requestUri: "/describe-connector"
          },
          input: {
            type: "structure",
            required: [
              "connectorType"
            ],
            members: {
              connectorType: {},
              connectorLabel: {}
            }
          },
          output: {
            type: "structure",
            members: {
              connectorConfiguration: {
                shape: "S6u"
              }
            }
          }
        },
        DescribeConnectorEntity: {
          http: {
            requestUri: "/describe-connector-entity"
          },
          input: {
            type: "structure",
            required: [
              "connectorEntityName"
            ],
            members: {
              connectorEntityName: {},
              connectorType: {},
              connectorProfileName: {},
              apiVersion: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "connectorEntityFields"
            ],
            members: {
              connectorEntityFields: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "identifier"
                  ],
                  members: {
                    identifier: {},
                    parentIdentifier: {},
                    label: {},
                    isPrimaryKey: {
                      type: "boolean"
                    },
                    defaultValue: {},
                    isDeprecated: {
                      type: "boolean"
                    },
                    supportedFieldTypeDetails: {
                      type: "structure",
                      required: [
                        "v1"
                      ],
                      members: {
                        v1: {
                          type: "structure",
                          required: [
                            "fieldType",
                            "filterOperators"
                          ],
                          members: {
                            fieldType: {},
                            filterOperators: {
                              type: "list",
                              member: {}
                            },
                            supportedValues: {
                              type: "list",
                              member: {}
                            },
                            valueRegexPattern: {},
                            supportedDateFormat: {},
                            fieldValueRange: {
                              shape: "S94"
                            },
                            fieldLengthRange: {
                              shape: "S94"
                            }
                          }
                        }
                      }
                    },
                    description: {},
                    sourceProperties: {
                      type: "structure",
                      members: {
                        isRetrievable: {
                          type: "boolean"
                        },
                        isQueryable: {
                          type: "boolean"
                        },
                        isTimestampFieldForIncrementalQueries: {
                          type: "boolean"
                        }
                      }
                    },
                    destinationProperties: {
                      type: "structure",
                      members: {
                        isCreatable: {
                          type: "boolean"
                        },
                        isNullable: {
                          type: "boolean"
                        },
                        isUpsertable: {
                          type: "boolean"
                        },
                        isUpdatable: {
                          type: "boolean"
                        },
                        isDefaultedOnCreate: {
                          type: "boolean"
                        },
                        supportedWriteOperations: {
                          shape: "S8k"
                        }
                      }
                    },
                    customProperties: {
                      shape: "S4g"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeConnectorProfiles: {
          http: {
            requestUri: "/describe-connector-profiles"
          },
          input: {
            type: "structure",
            members: {
              connectorProfileNames: {
                type: "list",
                member: {}
              },
              connectorType: {},
              connectorLabel: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              connectorProfileDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    connectorProfileArn: {},
                    connectorProfileName: {},
                    connectorType: {},
                    connectorLabel: {},
                    connectionMode: {},
                    credentialsArn: {},
                    connectorProfileProperties: {
                      shape: "Sd"
                    },
                    createdAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    privateConnectionProvisioningState: {
                      type: "structure",
                      members: {
                        status: {},
                        failureMessage: {},
                        failureCause: {}
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeConnectors: {
          http: {
            requestUri: "/describe-connectors"
          },
          input: {
            type: "structure",
            members: {
              connectorTypes: {
                shape: "S6v"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              connectorConfigurations: {
                type: "map",
                key: {},
                value: {
                  shape: "S6u"
                }
              },
              connectors: {
                shape: "S9m"
              },
              nextToken: {}
            }
          }
        },
        DescribeFlow: {
          http: {
            requestUri: "/describe-flow"
          },
          input: {
            type: "structure",
            required: [
              "flowName"
            ],
            members: {
              flowName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              flowArn: {},
              description: {},
              flowName: {},
              kmsArn: {},
              flowStatus: {},
              flowStatusMessage: {},
              sourceFlowConfig: {
                shape: "S3n"
              },
              destinationFlowConfigList: {
                shape: "S4n"
              },
              lastRunExecutionDetails: {
                shape: "S9s"
              },
              triggerConfig: {
                shape: "S3d"
              },
              tasks: {
                shape: "S5n"
              },
              createdAt: {
                type: "timestamp"
              },
              lastUpdatedAt: {
                type: "timestamp"
              },
              createdBy: {},
              lastUpdatedBy: {},
              tags: {
                shape: "S6d"
              },
              metadataCatalogConfig: {
                shape: "S6g"
              },
              lastRunMetadataCatalogDetails: {
                shape: "S9x"
              },
              schemaVersion: {
                type: "long"
              }
            }
          }
        },
        DescribeFlowExecutionRecords: {
          http: {
            requestUri: "/describe-flow-execution-records"
          },
          input: {
            type: "structure",
            required: [
              "flowName"
            ],
            members: {
              flowName: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              flowExecutions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    executionId: {},
                    executionStatus: {},
                    executionResult: {
                      type: "structure",
                      members: {
                        errorInfo: {
                          type: "structure",
                          members: {
                            putFailuresCount: {
                              type: "long"
                            },
                            executionMessage: {}
                          }
                        },
                        bytesProcessed: {
                          type: "long"
                        },
                        bytesWritten: {
                          type: "long"
                        },
                        recordsProcessed: {
                          type: "long"
                        },
                        numParallelProcesses: {
                          type: "long"
                        },
                        maxPageSize: {
                          type: "long"
                        }
                      }
                    },
                    startedAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    dataPullStartTime: {
                      type: "timestamp"
                    },
                    dataPullEndTime: {
                      type: "timestamp"
                    },
                    metadataCatalogDetails: {
                      shape: "S9x"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListConnectorEntities: {
          http: {
            requestUri: "/list-connector-entities"
          },
          input: {
            type: "structure",
            members: {
              connectorProfileName: {},
              connectorType: {},
              entitiesPath: {},
              apiVersion: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "connectorEntityMap"
            ],
            members: {
              connectorEntityMap: {
                type: "map",
                key: {},
                value: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "name"
                    ],
                    members: {
                      name: {},
                      label: {},
                      hasNestedEntities: {
                        type: "boolean"
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListConnectors: {
          http: {
            requestUri: "/list-connectors"
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              connectors: {
                shape: "S9m"
              },
              nextToken: {}
            }
          }
        },
        ListFlows: {
          http: {
            requestUri: "/list-flows"
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              flows: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    flowArn: {},
                    description: {},
                    flowName: {},
                    flowStatus: {},
                    sourceConnectorType: {},
                    sourceConnectorLabel: {},
                    destinationConnectorType: {},
                    destinationConnectorLabel: {},
                    triggerType: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    createdBy: {},
                    lastUpdatedBy: {},
                    tags: {
                      shape: "S6d"
                    },
                    lastRunExecutionDetails: {
                      shape: "S9s"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S6d"
              }
            }
          }
        },
        RegisterConnector: {
          http: {
            requestUri: "/register-connector"
          },
          input: {
            type: "structure",
            members: {
              connectorLabel: {},
              description: {},
              connectorProvisioningType: {},
              connectorProvisioningConfig: {
                shape: "S8m"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              connectorArn: {}
            }
          }
        },
        ResetConnectorMetadataCache: {
          http: {
            requestUri: "/reset-connector-metadata-cache"
          },
          input: {
            type: "structure",
            members: {
              connectorProfileName: {},
              connectorType: {},
              connectorEntityName: {},
              entitiesPath: {},
              apiVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartFlow: {
          http: {
            requestUri: "/start-flow"
          },
          input: {
            type: "structure",
            required: [
              "flowName"
            ],
            members: {
              flowName: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              flowArn: {},
              flowStatus: {},
              executionId: {}
            }
          }
        },
        StopFlow: {
          http: {
            requestUri: "/stop-flow"
          },
          input: {
            type: "structure",
            required: [
              "flowName"
            ],
            members: {
              flowName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              flowArn: {},
              flowStatus: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S6d"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UnregisterConnector: {
          http: {
            requestUri: "/unregister-connector"
          },
          input: {
            type: "structure",
            required: [
              "connectorLabel"
            ],
            members: {
              connectorLabel: {},
              forceDelete: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateConnectorProfile: {
          http: {
            requestUri: "/update-connector-profile"
          },
          input: {
            type: "structure",
            required: [
              "connectorProfileName",
              "connectionMode",
              "connectorProfileConfig"
            ],
            members: {
              connectorProfileName: {},
              connectionMode: {},
              connectorProfileConfig: {
                shape: "Sc"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              connectorProfileArn: {}
            }
          }
        },
        UpdateConnectorRegistration: {
          http: {
            requestUri: "/update-connector-registration"
          },
          input: {
            type: "structure",
            required: [
              "connectorLabel"
            ],
            members: {
              connectorLabel: {},
              description: {},
              connectorProvisioningConfig: {
                shape: "S8m"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              connectorArn: {}
            }
          }
        },
        UpdateFlow: {
          http: {
            requestUri: "/update-flow"
          },
          input: {
            type: "structure",
            required: [
              "flowName",
              "triggerConfig",
              "sourceFlowConfig",
              "destinationFlowConfigList",
              "tasks"
            ],
            members: {
              flowName: {},
              description: {},
              triggerConfig: {
                shape: "S3d"
              },
              sourceFlowConfig: {
                shape: "S3n"
              },
              destinationFlowConfigList: {
                shape: "S4n"
              },
              tasks: {
                shape: "S5n"
              },
              metadataCatalogConfig: {
                shape: "S6g"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              flowStatus: {}
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {}
        },
        Sc: {
          type: "structure",
          required: [
            "connectorProfileProperties"
          ],
          members: {
            connectorProfileProperties: {
              shape: "Sd"
            },
            connectorProfileCredentials: {
              type: "structure",
              members: {
                Amplitude: {
                  type: "structure",
                  required: [
                    "apiKey",
                    "secretKey"
                  ],
                  members: {
                    apiKey: {
                      shape: "S1x"
                    },
                    secretKey: {
                      type: "string",
                      sensitive: true
                    }
                  }
                },
                Datadog: {
                  type: "structure",
                  required: [
                    "apiKey",
                    "applicationKey"
                  ],
                  members: {
                    apiKey: {
                      shape: "S1x"
                    },
                    applicationKey: {}
                  }
                },
                Dynatrace: {
                  type: "structure",
                  required: [
                    "apiToken"
                  ],
                  members: {
                    apiToken: {}
                  }
                },
                GoogleAnalytics: {
                  type: "structure",
                  required: [
                    "clientId",
                    "clientSecret"
                  ],
                  members: {
                    clientId: {},
                    clientSecret: {
                      shape: "S25"
                    },
                    accessToken: {
                      shape: "S26"
                    },
                    refreshToken: {},
                    oAuthRequest: {
                      shape: "S28"
                    }
                  }
                },
                Honeycode: {
                  type: "structure",
                  members: {
                    accessToken: {
                      shape: "S26"
                    },
                    refreshToken: {},
                    oAuthRequest: {
                      shape: "S28"
                    }
                  }
                },
                InforNexus: {
                  type: "structure",
                  required: [
                    "accessKeyId",
                    "userId",
                    "secretAccessKey",
                    "datakey"
                  ],
                  members: {
                    accessKeyId: {
                      type: "string",
                      sensitive: true
                    },
                    userId: {},
                    secretAccessKey: {},
                    datakey: {}
                  }
                },
                Marketo: {
                  type: "structure",
                  required: [
                    "clientId",
                    "clientSecret"
                  ],
                  members: {
                    clientId: {},
                    clientSecret: {
                      shape: "S25"
                    },
                    accessToken: {
                      shape: "S26"
                    },
                    oAuthRequest: {
                      shape: "S28"
                    }
                  }
                },
                Redshift: {
                  type: "structure",
                  members: {
                    username: {},
                    password: {
                      shape: "S2j"
                    }
                  }
                },
                Salesforce: {
                  type: "structure",
                  members: {
                    accessToken: {
                      shape: "S26"
                    },
                    refreshToken: {},
                    oAuthRequest: {
                      shape: "S28"
                    },
                    clientCredentialsArn: {
                      shape: "S2l"
                    },
                    oAuth2GrantType: {},
                    jwtToken: {
                      type: "string",
                      sensitive: true
                    }
                  }
                },
                ServiceNow: {
                  type: "structure",
                  members: {
                    username: {},
                    password: {
                      shape: "S2j"
                    },
                    oAuth2Credentials: {
                      shape: "S2o"
                    }
                  }
                },
                Singular: {
                  type: "structure",
                  required: [
                    "apiKey"
                  ],
                  members: {
                    apiKey: {
                      shape: "S1x"
                    }
                  }
                },
                Slack: {
                  type: "structure",
                  required: [
                    "clientId",
                    "clientSecret"
                  ],
                  members: {
                    clientId: {},
                    clientSecret: {
                      shape: "S25"
                    },
                    accessToken: {
                      shape: "S26"
                    },
                    oAuthRequest: {
                      shape: "S28"
                    }
                  }
                },
                Snowflake: {
                  type: "structure",
                  required: [
                    "username",
                    "password"
                  ],
                  members: {
                    username: {},
                    password: {
                      shape: "S2j"
                    }
                  }
                },
                Trendmicro: {
                  type: "structure",
                  required: [
                    "apiSecretKey"
                  ],
                  members: {
                    apiSecretKey: {
                      shape: "S2t"
                    }
                  }
                },
                Veeva: {
                  type: "structure",
                  required: [
                    "username",
                    "password"
                  ],
                  members: {
                    username: {},
                    password: {
                      shape: "S2j"
                    }
                  }
                },
                Zendesk: {
                  type: "structure",
                  required: [
                    "clientId",
                    "clientSecret"
                  ],
                  members: {
                    clientId: {},
                    clientSecret: {
                      shape: "S25"
                    },
                    accessToken: {
                      shape: "S26"
                    },
                    oAuthRequest: {
                      shape: "S28"
                    }
                  }
                },
                SAPOData: {
                  type: "structure",
                  members: {
                    basicAuthCredentials: {
                      shape: "S2x"
                    },
                    oAuthCredentials: {
                      type: "structure",
                      required: [
                        "clientId",
                        "clientSecret"
                      ],
                      members: {
                        clientId: {},
                        clientSecret: {
                          shape: "S25"
                        },
                        accessToken: {
                          shape: "S26"
                        },
                        refreshToken: {},
                        oAuthRequest: {
                          shape: "S28"
                        }
                      }
                    }
                  }
                },
                CustomConnector: {
                  type: "structure",
                  required: [
                    "authenticationType"
                  ],
                  members: {
                    authenticationType: {},
                    basic: {
                      shape: "S2x"
                    },
                    oauth2: {
                      shape: "S2o"
                    },
                    apiKey: {
                      type: "structure",
                      required: [
                        "apiKey"
                      ],
                      members: {
                        apiKey: {
                          shape: "S1x"
                        },
                        apiSecretKey: {
                          shape: "S2t"
                        }
                      }
                    },
                    custom: {
                      type: "structure",
                      required: [
                        "customAuthenticationType"
                      ],
                      members: {
                        customAuthenticationType: {},
                        credentialsMap: {
                          type: "map",
                          key: {
                            type: "string",
                            sensitive: true
                          },
                          value: {
                            type: "string",
                            sensitive: true
                          }
                        }
                      }
                    }
                  }
                },
                Pardot: {
                  type: "structure",
                  members: {
                    accessToken: {
                      shape: "S26"
                    },
                    refreshToken: {},
                    oAuthRequest: {
                      shape: "S28"
                    },
                    clientCredentialsArn: {
                      shape: "S2l"
                    }
                  }
                }
              }
            }
          }
        },
        Sd: {
          type: "structure",
          members: {
            Amplitude: {
              type: "structure",
              members: {}
            },
            Datadog: {
              type: "structure",
              required: [
                "instanceUrl"
              ],
              members: {
                instanceUrl: {}
              }
            },
            Dynatrace: {
              type: "structure",
              required: [
                "instanceUrl"
              ],
              members: {
                instanceUrl: {}
              }
            },
            GoogleAnalytics: {
              type: "structure",
              members: {}
            },
            Honeycode: {
              type: "structure",
              members: {}
            },
            InforNexus: {
              type: "structure",
              required: [
                "instanceUrl"
              ],
              members: {
                instanceUrl: {}
              }
            },
            Marketo: {
              type: "structure",
              required: [
                "instanceUrl"
              ],
              members: {
                instanceUrl: {}
              }
            },
            Redshift: {
              type: "structure",
              required: [
                "bucketName",
                "roleArn"
              ],
              members: {
                databaseUrl: {},
                bucketName: {},
                bucketPrefix: {},
                roleArn: {},
                dataApiRoleArn: {},
                isRedshiftServerless: {
                  type: "boolean"
                },
                clusterIdentifier: {},
                workgroupName: {},
                databaseName: {}
              }
            },
            Salesforce: {
              type: "structure",
              members: {
                instanceUrl: {},
                isSandboxEnvironment: {
                  type: "boolean"
                },
                usePrivateLinkForMetadataAndAuthorization: {
                  type: "boolean"
                }
              }
            },
            ServiceNow: {
              type: "structure",
              required: [
                "instanceUrl"
              ],
              members: {
                instanceUrl: {}
              }
            },
            Singular: {
              type: "structure",
              members: {}
            },
            Slack: {
              type: "structure",
              required: [
                "instanceUrl"
              ],
              members: {
                instanceUrl: {}
              }
            },
            Snowflake: {
              type: "structure",
              required: [
                "warehouse",
                "stage",
                "bucketName"
              ],
              members: {
                warehouse: {},
                stage: {},
                bucketName: {},
                bucketPrefix: {},
                privateLinkServiceName: {},
                accountName: {},
                region: {}
              }
            },
            Trendmicro: {
              type: "structure",
              members: {}
            },
            Veeva: {
              type: "structure",
              required: [
                "instanceUrl"
              ],
              members: {
                instanceUrl: {}
              }
            },
            Zendesk: {
              type: "structure",
              required: [
                "instanceUrl"
              ],
              members: {
                instanceUrl: {}
              }
            },
            SAPOData: {
              type: "structure",
              required: [
                "applicationHostUrl",
                "applicationServicePath",
                "portNumber",
                "clientNumber"
              ],
              members: {
                applicationHostUrl: {},
                applicationServicePath: {},
                portNumber: {
                  type: "integer"
                },
                clientNumber: {},
                logonLanguage: {},
                privateLinkServiceName: {},
                oAuthProperties: {
                  type: "structure",
                  required: [
                    "tokenUrl",
                    "authCodeUrl",
                    "oAuthScopes"
                  ],
                  members: {
                    tokenUrl: {},
                    authCodeUrl: {},
                    oAuthScopes: {
                      shape: "S1i"
                    }
                  }
                },
                disableSSO: {
                  type: "boolean"
                }
              }
            },
            CustomConnector: {
              type: "structure",
              members: {
                profileProperties: {
                  type: "map",
                  key: {},
                  value: {}
                },
                oAuth2Properties: {
                  type: "structure",
                  required: [
                    "tokenUrl",
                    "oAuth2GrantType"
                  ],
                  members: {
                    tokenUrl: {},
                    oAuth2GrantType: {},
                    tokenUrlCustomProperties: {
                      type: "map",
                      key: {},
                      value: {}
                    }
                  }
                }
              }
            },
            Pardot: {
              type: "structure",
              members: {
                instanceUrl: {},
                isSandboxEnvironment: {
                  type: "boolean"
                },
                businessUnitId: {}
              }
            }
          }
        },
        S1i: {
          type: "list",
          member: {}
        },
        S1x: {
          type: "string",
          sensitive: true
        },
        S25: {
          type: "string",
          sensitive: true
        },
        S26: {
          type: "string",
          sensitive: true
        },
        S28: {
          type: "structure",
          members: {
            authCode: {},
            redirectUri: {}
          }
        },
        S2j: {
          type: "string",
          sensitive: true
        },
        S2l: {
          type: "string",
          sensitive: true
        },
        S2o: {
          type: "structure",
          members: {
            clientId: {},
            clientSecret: {
              shape: "S25"
            },
            accessToken: {
              shape: "S26"
            },
            refreshToken: {},
            oAuthRequest: {
              shape: "S28"
            }
          }
        },
        S2t: {
          type: "string",
          sensitive: true
        },
        S2x: {
          type: "structure",
          required: [
            "username",
            "password"
          ],
          members: {
            username: {},
            password: {
              shape: "S2j"
            }
          }
        },
        S3d: {
          type: "structure",
          required: [
            "triggerType"
          ],
          members: {
            triggerType: {},
            triggerProperties: {
              type: "structure",
              members: {
                Scheduled: {
                  type: "structure",
                  required: [
                    "scheduleExpression"
                  ],
                  members: {
                    scheduleExpression: {},
                    dataPullMode: {},
                    scheduleStartTime: {
                      type: "timestamp"
                    },
                    scheduleEndTime: {
                      type: "timestamp"
                    },
                    timezone: {},
                    scheduleOffset: {
                      type: "long"
                    },
                    firstExecutionFrom: {
                      type: "timestamp"
                    },
                    flowErrorDeactivationThreshold: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        S3n: {
          type: "structure",
          required: [
            "connectorType",
            "sourceConnectorProperties"
          ],
          members: {
            connectorType: {},
            apiVersion: {},
            connectorProfileName: {},
            sourceConnectorProperties: {
              type: "structure",
              members: {
                Amplitude: {
                  type: "structure",
                  required: [
                    "object"
                  ],
                  members: {
                    object: {}
                  }
                },
                Datadog: {
                  type: "structure",
                  required: [
                    "object"
                  ],
                  members: {
                    object: {}
                  }
                },
                Dynatrace: {
                  type: "structure",
                  required: [
                    "object"
                  ],
                  members: {
                    object: {}
                  }
                },
                GoogleAnalytics: {
                  type: "structure",
                  required: [
                    "object"
                  ],
                  members: {
                    object: {}
                  }
                },
                InforNexus: {
                  type: "structure",
                  required: [
                    "object"
                  ],
                  members: {
                    object: {}
                  }
                },
                Marketo: {
                  type: "structure",
                  required: [
                    "object"
                  ],
                  members: {
                    object: {}
                  }
                },
                S3: {
                  type: "structure",
                  required: [
                    "bucketName"
                  ],
                  members: {
                    bucketName: {},
                    bucketPrefix: {},
                    s3InputFormatConfig: {
                      type: "structure",
                      members: {
                        s3InputFileType: {}
                      }
                    }
                  }
                },
                Salesforce: {
                  type: "structure",
                  required: [
                    "object"
                  ],
                  members: {
                    object: {},
                    enableDynamicFieldUpdate: {
                      type: "boolean"
                    },
                    includeDeletedRecords: {
                      type: "boolean"
                    },
                    dataTransferApi: {}
                  }
                },
                ServiceNow: {
                  type: "structure",
                  required: [
                    "object"
                  ],
                  members: {
                    object: {}
                  }
                },
                Singular: {
                  type: "structure",
                  required: [
                    "object"
                  ],
                  members: {
                    object: {}
                  }
                },
                Slack: {
                  type: "structure",
                  required: [
                    "object"
                  ],
                  members: {
                    object: {}
                  }
                },
                Trendmicro: {
                  type: "structure",
                  required: [
                    "object"
                  ],
                  members: {
                    object: {}
                  }
                },
                Veeva: {
                  type: "structure",
                  required: [
                    "object"
                  ],
                  members: {
                    object: {},
                    documentType: {},
                    includeSourceFiles: {
                      type: "boolean"
                    },
                    includeRenditions: {
                      type: "boolean"
                    },
                    includeAllVersions: {
                      type: "boolean"
                    }
                  }
                },
                Zendesk: {
                  type: "structure",
                  required: [
                    "object"
                  ],
                  members: {
                    object: {}
                  }
                },
                SAPOData: {
                  type: "structure",
                  members: {
                    objectPath: {},
                    parallelismConfig: {
                      type: "structure",
                      required: [
                        "maxParallelism"
                      ],
                      members: {
                        maxParallelism: {
                          type: "integer"
                        }
                      }
                    },
                    paginationConfig: {
                      type: "structure",
                      required: [
                        "maxPageSize"
                      ],
                      members: {
                        maxPageSize: {
                          type: "integer"
                        }
                      }
                    }
                  }
                },
                CustomConnector: {
                  type: "structure",
                  required: [
                    "entityName"
                  ],
                  members: {
                    entityName: {},
                    customProperties: {
                      shape: "S4g"
                    },
                    dataTransferApi: {
                      shape: "S4h"
                    }
                  }
                },
                Pardot: {
                  type: "structure",
                  required: [
                    "object"
                  ],
                  members: {
                    object: {}
                  }
                }
              }
            },
            incrementalPullConfig: {
              type: "structure",
              members: {
                datetimeTypeFieldName: {}
              }
            }
          }
        },
        S4g: {
          type: "map",
          key: {},
          value: {}
        },
        S4h: {
          type: "structure",
          members: {
            Name: {},
            Type: {}
          }
        },
        S4n: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "connectorType",
              "destinationConnectorProperties"
            ],
            members: {
              connectorType: {},
              apiVersion: {},
              connectorProfileName: {},
              destinationConnectorProperties: {
                type: "structure",
                members: {
                  Redshift: {
                    type: "structure",
                    required: [
                      "object",
                      "intermediateBucketName"
                    ],
                    members: {
                      object: {},
                      intermediateBucketName: {},
                      bucketPrefix: {},
                      errorHandlingConfig: {
                        shape: "S4r"
                      }
                    }
                  },
                  S3: {
                    type: "structure",
                    required: [
                      "bucketName"
                    ],
                    members: {
                      bucketName: {},
                      bucketPrefix: {},
                      s3OutputFormatConfig: {
                        type: "structure",
                        members: {
                          fileType: {},
                          prefixConfig: {
                            shape: "S4v"
                          },
                          aggregationConfig: {
                            shape: "S50"
                          },
                          preserveSourceDataTyping: {
                            type: "boolean"
                          }
                        }
                      }
                    }
                  },
                  Salesforce: {
                    type: "structure",
                    required: [
                      "object"
                    ],
                    members: {
                      object: {},
                      idFieldNames: {
                        shape: "S55"
                      },
                      errorHandlingConfig: {
                        shape: "S4r"
                      },
                      writeOperationType: {},
                      dataTransferApi: {}
                    }
                  },
                  Snowflake: {
                    type: "structure",
                    required: [
                      "object",
                      "intermediateBucketName"
                    ],
                    members: {
                      object: {},
                      intermediateBucketName: {},
                      bucketPrefix: {},
                      errorHandlingConfig: {
                        shape: "S4r"
                      }
                    }
                  },
                  EventBridge: {
                    type: "structure",
                    required: [
                      "object"
                    ],
                    members: {
                      object: {},
                      errorHandlingConfig: {
                        shape: "S4r"
                      }
                    }
                  },
                  LookoutMetrics: {
                    type: "structure",
                    members: {}
                  },
                  Upsolver: {
                    type: "structure",
                    required: [
                      "bucketName",
                      "s3OutputFormatConfig"
                    ],
                    members: {
                      bucketName: {},
                      bucketPrefix: {},
                      s3OutputFormatConfig: {
                        type: "structure",
                        required: [
                          "prefixConfig"
                        ],
                        members: {
                          fileType: {},
                          prefixConfig: {
                            shape: "S4v"
                          },
                          aggregationConfig: {
                            shape: "S50"
                          }
                        }
                      }
                    }
                  },
                  Honeycode: {
                    type: "structure",
                    required: [
                      "object"
                    ],
                    members: {
                      object: {},
                      errorHandlingConfig: {
                        shape: "S4r"
                      }
                    }
                  },
                  CustomerProfiles: {
                    type: "structure",
                    required: [
                      "domainName"
                    ],
                    members: {
                      domainName: {},
                      objectTypeName: {}
                    }
                  },
                  Zendesk: {
                    type: "structure",
                    required: [
                      "object"
                    ],
                    members: {
                      object: {},
                      idFieldNames: {
                        shape: "S55"
                      },
                      errorHandlingConfig: {
                        shape: "S4r"
                      },
                      writeOperationType: {}
                    }
                  },
                  Marketo: {
                    type: "structure",
                    required: [
                      "object"
                    ],
                    members: {
                      object: {},
                      errorHandlingConfig: {
                        shape: "S4r"
                      }
                    }
                  },
                  CustomConnector: {
                    type: "structure",
                    required: [
                      "entityName"
                    ],
                    members: {
                      entityName: {},
                      errorHandlingConfig: {
                        shape: "S4r"
                      },
                      writeOperationType: {},
                      idFieldNames: {
                        shape: "S55"
                      },
                      customProperties: {
                        shape: "S4g"
                      }
                    }
                  },
                  SAPOData: {
                    type: "structure",
                    required: [
                      "objectPath"
                    ],
                    members: {
                      objectPath: {},
                      successResponseHandlingConfig: {
                        type: "structure",
                        members: {
                          bucketPrefix: {},
                          bucketName: {}
                        }
                      },
                      idFieldNames: {
                        shape: "S55"
                      },
                      errorHandlingConfig: {
                        shape: "S4r"
                      },
                      writeOperationType: {}
                    }
                  }
                }
              }
            }
          }
        },
        S4r: {
          type: "structure",
          members: {
            failOnFirstDestinationError: {
              type: "boolean"
            },
            bucketPrefix: {},
            bucketName: {}
          }
        },
        S4v: {
          type: "structure",
          members: {
            prefixType: {},
            prefixFormat: {},
            pathPrefixHierarchy: {
              type: "list",
              member: {}
            }
          }
        },
        S50: {
          type: "structure",
          members: {
            aggregationType: {},
            targetFileSize: {
              type: "long"
            }
          }
        },
        S55: {
          type: "list",
          member: {}
        },
        S5n: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "sourceFields",
              "taskType"
            ],
            members: {
              sourceFields: {
                type: "list",
                member: {}
              },
              connectorOperator: {
                type: "structure",
                members: {
                  Amplitude: {},
                  Datadog: {},
                  Dynatrace: {},
                  GoogleAnalytics: {},
                  InforNexus: {},
                  Marketo: {},
                  S3: {},
                  Salesforce: {},
                  ServiceNow: {},
                  Singular: {},
                  Slack: {},
                  Trendmicro: {},
                  Veeva: {},
                  Zendesk: {},
                  SAPOData: {},
                  CustomConnector: {},
                  Pardot: {}
                }
              },
              destinationField: {},
              taskType: {},
              taskProperties: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        S6d: {
          type: "map",
          key: {},
          value: {}
        },
        S6g: {
          type: "structure",
          members: {
            glueDataCatalog: {
              type: "structure",
              required: [
                "roleArn",
                "databaseName",
                "tablePrefix"
              ],
              members: {
                roleArn: {},
                databaseName: {},
                tablePrefix: {}
              }
            }
          }
        },
        S6u: {
          type: "structure",
          members: {
            canUseAsSource: {
              type: "boolean"
            },
            canUseAsDestination: {
              type: "boolean"
            },
            supportedDestinationConnectors: {
              shape: "S6v"
            },
            supportedSchedulingFrequencies: {
              type: "list",
              member: {}
            },
            isPrivateLinkEnabled: {
              type: "boolean"
            },
            isPrivateLinkEndpointUrlRequired: {
              type: "boolean"
            },
            supportedTriggerTypes: {
              type: "list",
              member: {}
            },
            connectorMetadata: {
              type: "structure",
              members: {
                Amplitude: {
                  type: "structure",
                  members: {}
                },
                Datadog: {
                  type: "structure",
                  members: {}
                },
                Dynatrace: {
                  type: "structure",
                  members: {}
                },
                GoogleAnalytics: {
                  type: "structure",
                  members: {
                    oAuthScopes: {
                      shape: "S1i"
                    }
                  }
                },
                InforNexus: {
                  type: "structure",
                  members: {}
                },
                Marketo: {
                  type: "structure",
                  members: {}
                },
                Redshift: {
                  type: "structure",
                  members: {}
                },
                S3: {
                  type: "structure",
                  members: {}
                },
                Salesforce: {
                  type: "structure",
                  members: {
                    oAuthScopes: {
                      shape: "S1i"
                    },
                    dataTransferApis: {
                      type: "list",
                      member: {}
                    },
                    oauth2GrantTypesSupported: {
                      shape: "S7a"
                    }
                  }
                },
                ServiceNow: {
                  type: "structure",
                  members: {}
                },
                Singular: {
                  type: "structure",
                  members: {}
                },
                Slack: {
                  type: "structure",
                  members: {
                    oAuthScopes: {
                      shape: "S1i"
                    }
                  }
                },
                Snowflake: {
                  type: "structure",
                  members: {
                    supportedRegions: {
                      type: "list",
                      member: {}
                    }
                  }
                },
                Trendmicro: {
                  type: "structure",
                  members: {}
                },
                Veeva: {
                  type: "structure",
                  members: {}
                },
                Zendesk: {
                  type: "structure",
                  members: {
                    oAuthScopes: {
                      shape: "S1i"
                    }
                  }
                },
                EventBridge: {
                  type: "structure",
                  members: {}
                },
                Upsolver: {
                  type: "structure",
                  members: {}
                },
                CustomerProfiles: {
                  type: "structure",
                  members: {}
                },
                Honeycode: {
                  type: "structure",
                  members: {
                    oAuthScopes: {
                      shape: "S1i"
                    }
                  }
                },
                SAPOData: {
                  type: "structure",
                  members: {}
                },
                Pardot: {
                  type: "structure",
                  members: {}
                }
              }
            },
            connectorType: {},
            connectorLabel: {},
            connectorDescription: {},
            connectorOwner: {},
            connectorName: {},
            connectorVersion: {},
            connectorArn: {},
            connectorModes: {
              shape: "S7u"
            },
            authenticationConfig: {
              type: "structure",
              members: {
                isBasicAuthSupported: {
                  type: "boolean"
                },
                isApiKeyAuthSupported: {
                  type: "boolean"
                },
                isOAuth2Supported: {
                  type: "boolean"
                },
                isCustomAuthSupported: {
                  type: "boolean"
                },
                oAuth2Defaults: {
                  type: "structure",
                  members: {
                    oauthScopes: {
                      shape: "S1i"
                    },
                    tokenUrls: {
                      type: "list",
                      member: {}
                    },
                    authCodeUrls: {
                      type: "list",
                      member: {}
                    },
                    oauth2GrantTypesSupported: {
                      shape: "S7a"
                    },
                    oauth2CustomProperties: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          key: {},
                          isRequired: {
                            type: "boolean"
                          },
                          label: {},
                          description: {},
                          isSensitiveField: {
                            type: "boolean"
                          },
                          connectorSuppliedValues: {
                            shape: "S84"
                          },
                          type: {}
                        }
                      }
                    }
                  }
                },
                customAuthConfigs: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      customAuthenticationType: {},
                      authParameters: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            key: {},
                            isRequired: {
                              type: "boolean"
                            },
                            label: {},
                            description: {},
                            isSensitiveField: {
                              type: "boolean"
                            },
                            connectorSuppliedValues: {
                              shape: "S84"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            connectorRuntimeSettings: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  key: {},
                  dataType: {},
                  isRequired: {
                    type: "boolean"
                  },
                  label: {},
                  description: {},
                  scope: {},
                  connectorSuppliedValueOptions: {
                    type: "list",
                    member: {}
                  }
                }
              }
            },
            supportedApiVersions: {
              type: "list",
              member: {}
            },
            supportedOperators: {
              type: "list",
              member: {}
            },
            supportedWriteOperations: {
              shape: "S8k"
            },
            connectorProvisioningType: {},
            connectorProvisioningConfig: {
              shape: "S8m"
            },
            logoURL: {},
            registeredAt: {
              type: "timestamp"
            },
            registeredBy: {},
            supportedDataTransferTypes: {
              shape: "S8q"
            },
            supportedDataTransferApis: {
              type: "list",
              member: {
                shape: "S4h"
              }
            }
          }
        },
        S6v: {
          type: "list",
          member: {}
        },
        S7a: {
          type: "list",
          member: {}
        },
        S7u: {
          type: "list",
          member: {}
        },
        S84: {
          type: "list",
          member: {}
        },
        S8k: {
          type: "list",
          member: {}
        },
        S8m: {
          type: "structure",
          members: {
            lambda: {
              type: "structure",
              required: [
                "lambdaArn"
              ],
              members: {
                lambdaArn: {}
              }
            }
          }
        },
        S8q: {
          type: "list",
          member: {}
        },
        S94: {
          type: "structure",
          members: {
            maximum: {
              type: "double"
            },
            minimum: {
              type: "double"
            }
          }
        },
        S9m: {
          type: "list",
          member: {
            type: "structure",
            members: {
              connectorDescription: {},
              connectorName: {},
              connectorOwner: {},
              connectorVersion: {},
              applicationType: {},
              connectorType: {},
              connectorLabel: {},
              registeredAt: {
                type: "timestamp"
              },
              registeredBy: {},
              connectorProvisioningType: {},
              connectorModes: {
                shape: "S7u"
              },
              supportedDataTransferTypes: {
                shape: "S8q"
              }
            }
          }
        },
        S9s: {
          type: "structure",
          members: {
            mostRecentExecutionMessage: {},
            mostRecentExecutionTime: {
              type: "timestamp"
            },
            mostRecentExecutionStatus: {}
          }
        },
        S9x: {
          type: "list",
          member: {
            type: "structure",
            members: {
              catalogType: {},
              tableName: {},
              tableRegistrationOutput: {
                shape: "Sa0"
              },
              partitionRegistrationOutput: {
                shape: "Sa0"
              }
            }
          }
        },
        Sa0: {
          type: "structure",
          members: {
            message: {},
            result: {},
            status: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/appflow-2020-08-23.paginators.json
var require_appflow_2020_08_23_paginators = __commonJS({
  "node_modules/aws-sdk/apis/appflow-2020-08-23.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeConnectorProfiles: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        DescribeConnectors: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        DescribeFlowExecutionRecords: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListConnectors: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListFlows: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/appflow.js
var require_appflow = __commonJS({
  "node_modules/aws-sdk/clients/appflow.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["appflow"] = {};
    AWS2.Appflow = Service.defineService("appflow", ["2020-08-23"]);
    Object.defineProperty(apiLoader.services["appflow"], "2020-08-23", {
      get: function get() {
        var model = require_appflow_2020_08_23_min();
        model.paginators = require_appflow_2020_08_23_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Appflow;
  }
});

// node_modules/aws-sdk/apis/redshift-data-2019-12-20.min.json
var require_redshift_data_2019_12_20_min = __commonJS({
  "node_modules/aws-sdk/apis/redshift-data-2019-12-20.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-12-20",
        endpointPrefix: "redshift-data",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Redshift Data API Service",
        serviceId: "Redshift Data",
        signatureVersion: "v4",
        signingName: "redshift-data",
        targetPrefix: "RedshiftData",
        uid: "redshift-data-2019-12-20"
      },
      operations: {
        BatchExecuteStatement: {
          input: {
            type: "structure",
            required: [
              "Database",
              "Sqls"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              ClusterIdentifier: {},
              Database: {},
              DbUser: {},
              SecretArn: {},
              Sqls: {
                type: "list",
                member: {}
              },
              StatementName: {},
              WithEvent: {
                type: "boolean"
              },
              WorkgroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ClusterIdentifier: {},
              CreatedAt: {
                type: "timestamp"
              },
              Database: {},
              DbUser: {},
              Id: {},
              SecretArn: {},
              WorkgroupName: {}
            }
          }
        },
        CancelStatement: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                type: "boolean"
              }
            }
          }
        },
        DescribeStatement: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              ClusterIdentifier: {},
              CreatedAt: {
                type: "timestamp"
              },
              Database: {},
              DbUser: {},
              Duration: {
                type: "long"
              },
              Error: {},
              HasResultSet: {
                type: "boolean"
              },
              Id: {},
              QueryParameters: {
                shape: "Sj"
              },
              QueryString: {},
              RedshiftPid: {
                type: "long"
              },
              RedshiftQueryId: {
                type: "long"
              },
              ResultRows: {
                type: "long"
              },
              ResultSize: {
                type: "long"
              },
              SecretArn: {},
              Status: {},
              SubStatements: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Id"
                  ],
                  members: {
                    CreatedAt: {
                      type: "timestamp"
                    },
                    Duration: {
                      type: "long"
                    },
                    Error: {},
                    HasResultSet: {
                      type: "boolean"
                    },
                    Id: {},
                    QueryString: {},
                    RedshiftQueryId: {
                      type: "long"
                    },
                    ResultRows: {
                      type: "long"
                    },
                    ResultSize: {
                      type: "long"
                    },
                    Status: {},
                    UpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              UpdatedAt: {
                type: "timestamp"
              },
              WorkgroupName: {}
            }
          }
        },
        DescribeTable: {
          input: {
            type: "structure",
            required: [
              "Database"
            ],
            members: {
              ClusterIdentifier: {},
              ConnectedDatabase: {},
              Database: {},
              DbUser: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Schema: {},
              SecretArn: {},
              Table: {},
              WorkgroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ColumnList: {
                type: "list",
                member: {
                  shape: "Sv"
                }
              },
              NextToken: {},
              TableName: {}
            }
          }
        },
        ExecuteStatement: {
          input: {
            type: "structure",
            required: [
              "Database",
              "Sql"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              ClusterIdentifier: {},
              Database: {},
              DbUser: {},
              Parameters: {
                shape: "Sj"
              },
              SecretArn: {},
              Sql: {},
              StatementName: {},
              WithEvent: {
                type: "boolean"
              },
              WorkgroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ClusterIdentifier: {},
              CreatedAt: {
                type: "timestamp"
              },
              Database: {},
              DbUser: {},
              Id: {},
              SecretArn: {},
              WorkgroupName: {}
            }
          }
        },
        GetStatementResult: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Records"
            ],
            members: {
              ColumnMetadata: {
                type: "list",
                member: {
                  shape: "Sv"
                }
              },
              NextToken: {},
              Records: {
                type: "list",
                member: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      blobValue: {
                        type: "blob"
                      },
                      booleanValue: {
                        type: "boolean"
                      },
                      doubleValue: {
                        type: "double"
                      },
                      isNull: {
                        type: "boolean"
                      },
                      longValue: {
                        type: "long"
                      },
                      stringValue: {}
                    },
                    union: true
                  }
                }
              },
              TotalNumRows: {
                type: "long"
              }
            }
          }
        },
        ListDatabases: {
          input: {
            type: "structure",
            required: [
              "Database"
            ],
            members: {
              ClusterIdentifier: {},
              Database: {},
              DbUser: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              SecretArn: {},
              WorkgroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Databases: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListSchemas: {
          input: {
            type: "structure",
            required: [
              "Database"
            ],
            members: {
              ClusterIdentifier: {},
              ConnectedDatabase: {},
              Database: {},
              DbUser: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              SchemaPattern: {},
              SecretArn: {},
              WorkgroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Schemas: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ListStatements: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              RoleLevel: {
                type: "boolean"
              },
              StatementName: {},
              Status: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Statements"
            ],
            members: {
              NextToken: {},
              Statements: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Id"
                  ],
                  members: {
                    CreatedAt: {
                      type: "timestamp"
                    },
                    Id: {},
                    IsBatchStatement: {
                      type: "boolean"
                    },
                    QueryParameters: {
                      shape: "Sj"
                    },
                    QueryString: {},
                    QueryStrings: {
                      type: "list",
                      member: {}
                    },
                    SecretArn: {},
                    StatementName: {},
                    Status: {},
                    UpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListTables: {
          input: {
            type: "structure",
            required: [
              "Database"
            ],
            members: {
              ClusterIdentifier: {},
              ConnectedDatabase: {},
              Database: {},
              DbUser: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              SchemaPattern: {},
              SecretArn: {},
              TablePattern: {},
              WorkgroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Tables: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    schema: {},
                    type: {}
                  }
                }
              }
            }
          }
        }
      },
      shapes: {
        Sj: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "value"
            ],
            members: {
              name: {},
              value: {}
            }
          }
        },
        Sv: {
          type: "structure",
          members: {
            columnDefault: {},
            isCaseSensitive: {
              type: "boolean"
            },
            isCurrency: {
              type: "boolean"
            },
            isSigned: {
              type: "boolean"
            },
            label: {},
            length: {
              type: "integer"
            },
            name: {},
            nullable: {
              type: "integer"
            },
            precision: {
              type: "integer"
            },
            scale: {
              type: "integer"
            },
            schemaName: {},
            tableName: {},
            typeName: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/redshift-data-2019-12-20.paginators.json
var require_redshift_data_2019_12_20_paginators = __commonJS({
  "node_modules/aws-sdk/apis/redshift-data-2019-12-20.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeTable: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ColumnList"
        },
        GetStatementResult: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Records"
        },
        ListDatabases: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Databases"
        },
        ListSchemas: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Schemas"
        },
        ListStatements: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Statements"
        },
        ListTables: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Tables"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/redshiftdata.js
var require_redshiftdata = __commonJS({
  "node_modules/aws-sdk/clients/redshiftdata.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["redshiftdata"] = {};
    AWS2.RedshiftData = Service.defineService("redshiftdata", ["2019-12-20"]);
    Object.defineProperty(apiLoader.services["redshiftdata"], "2019-12-20", {
      get: function get() {
        var model = require_redshift_data_2019_12_20_min();
        model.paginators = require_redshift_data_2019_12_20_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.RedshiftData;
  }
});

// node_modules/aws-sdk/apis/sso-admin-2020-07-20.min.json
var require_sso_admin_2020_07_20_min = __commonJS({
  "node_modules/aws-sdk/apis/sso-admin-2020-07-20.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-07-20",
        endpointPrefix: "sso",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "SSO Admin",
        serviceFullName: "AWS Single Sign-On Admin",
        serviceId: "SSO Admin",
        signatureVersion: "v4",
        signingName: "sso",
        targetPrefix: "SWBExternalService",
        uid: "sso-admin-2020-07-20"
      },
      operations: {
        AttachCustomerManagedPolicyReferenceToPermissionSet: {
          input: {
            type: "structure",
            required: [
              "CustomerManagedPolicyReference",
              "InstanceArn",
              "PermissionSetArn"
            ],
            members: {
              CustomerManagedPolicyReference: {
                shape: "S2"
              },
              InstanceArn: {},
              PermissionSetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AttachManagedPolicyToPermissionSet: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "ManagedPolicyArn",
              "PermissionSetArn"
            ],
            members: {
              InstanceArn: {},
              ManagedPolicyArn: {},
              PermissionSetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateAccountAssignment: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "PermissionSetArn",
              "PrincipalId",
              "PrincipalType",
              "TargetId",
              "TargetType"
            ],
            members: {
              InstanceArn: {},
              PermissionSetArn: {},
              PrincipalId: {},
              PrincipalType: {},
              TargetId: {},
              TargetType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AccountAssignmentCreationStatus: {
                shape: "Sh"
              }
            }
          }
        },
        CreateApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationProviderArn",
              "InstanceArn",
              "Name"
            ],
            members: {
              ApplicationProviderArn: {},
              ClientToken: {
                idempotencyToken: true
              },
              Description: {},
              InstanceArn: {},
              Name: {},
              PortalOptions: {
                shape: "Sr"
              },
              Status: {},
              Tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationArn: {}
            }
          }
        },
        CreateApplicationAssignment: {
          input: {
            type: "structure",
            required: [
              "ApplicationArn",
              "PrincipalId",
              "PrincipalType"
            ],
            members: {
              ApplicationArn: {},
              PrincipalId: {},
              PrincipalType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateInstance: {
          input: {
            type: "structure",
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              Name: {},
              Tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceArn: {}
            }
          }
        },
        CreateInstanceAccessControlAttributeConfiguration: {
          input: {
            type: "structure",
            required: [
              "InstanceAccessControlAttributeConfiguration",
              "InstanceArn"
            ],
            members: {
              InstanceAccessControlAttributeConfiguration: {
                shape: "S18"
              },
              InstanceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreatePermissionSet: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "Name"
            ],
            members: {
              Description: {},
              InstanceArn: {},
              Name: {},
              RelayState: {},
              SessionDuration: {},
              Tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PermissionSet: {
                shape: "S1m"
              }
            }
          }
        },
        CreateTrustedTokenIssuer: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "Name",
              "TrustedTokenIssuerConfiguration",
              "TrustedTokenIssuerType"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              InstanceArn: {},
              Name: {},
              Tags: {
                shape: "Sx"
              },
              TrustedTokenIssuerConfiguration: {
                shape: "S1p"
              },
              TrustedTokenIssuerType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrustedTokenIssuerArn: {}
            }
          }
        },
        DeleteAccountAssignment: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "PermissionSetArn",
              "PrincipalId",
              "PrincipalType",
              "TargetId",
              "TargetType"
            ],
            members: {
              InstanceArn: {},
              PermissionSetArn: {},
              PrincipalId: {},
              PrincipalType: {},
              TargetId: {},
              TargetType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AccountAssignmentDeletionStatus: {
                shape: "Sh"
              }
            }
          }
        },
        DeleteApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationArn"
            ],
            members: {
              ApplicationArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteApplicationAccessScope: {
          input: {
            type: "structure",
            required: [
              "ApplicationArn",
              "Scope"
            ],
            members: {
              ApplicationArn: {},
              Scope: {}
            }
          },
          idempotent: true
        },
        DeleteApplicationAssignment: {
          input: {
            type: "structure",
            required: [
              "ApplicationArn",
              "PrincipalId",
              "PrincipalType"
            ],
            members: {
              ApplicationArn: {},
              PrincipalId: {},
              PrincipalType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteApplicationAuthenticationMethod: {
          input: {
            type: "structure",
            required: [
              "ApplicationArn",
              "AuthenticationMethodType"
            ],
            members: {
              ApplicationArn: {},
              AuthenticationMethodType: {}
            }
          },
          idempotent: true
        },
        DeleteApplicationGrant: {
          input: {
            type: "structure",
            required: [
              "ApplicationArn",
              "GrantType"
            ],
            members: {
              ApplicationArn: {},
              GrantType: {}
            }
          },
          idempotent: true
        },
        DeleteInlinePolicyFromPermissionSet: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "PermissionSetArn"
            ],
            members: {
              InstanceArn: {},
              PermissionSetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteInstance: {
          input: {
            type: "structure",
            required: [
              "InstanceArn"
            ],
            members: {
              InstanceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteInstanceAccessControlAttributeConfiguration: {
          input: {
            type: "structure",
            required: [
              "InstanceArn"
            ],
            members: {
              InstanceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeletePermissionSet: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "PermissionSetArn"
            ],
            members: {
              InstanceArn: {},
              PermissionSetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeletePermissionsBoundaryFromPermissionSet: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "PermissionSetArn"
            ],
            members: {
              InstanceArn: {},
              PermissionSetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteTrustedTokenIssuer: {
          input: {
            type: "structure",
            required: [
              "TrustedTokenIssuerArn"
            ],
            members: {
              TrustedTokenIssuerArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeAccountAssignmentCreationStatus: {
          input: {
            type: "structure",
            required: [
              "AccountAssignmentCreationRequestId",
              "InstanceArn"
            ],
            members: {
              AccountAssignmentCreationRequestId: {},
              InstanceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AccountAssignmentCreationStatus: {
                shape: "Sh"
              }
            }
          }
        },
        DescribeAccountAssignmentDeletionStatus: {
          input: {
            type: "structure",
            required: [
              "AccountAssignmentDeletionRequestId",
              "InstanceArn"
            ],
            members: {
              AccountAssignmentDeletionRequestId: {},
              InstanceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AccountAssignmentDeletionStatus: {
                shape: "Sh"
              }
            }
          }
        },
        DescribeApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationArn"
            ],
            members: {
              ApplicationArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationAccount: {},
              ApplicationArn: {},
              ApplicationProviderArn: {},
              CreatedDate: {
                type: "timestamp"
              },
              Description: {},
              InstanceArn: {},
              Name: {},
              PortalOptions: {
                shape: "Sr"
              },
              Status: {}
            }
          }
        },
        DescribeApplicationAssignment: {
          input: {
            type: "structure",
            required: [
              "ApplicationArn",
              "PrincipalId",
              "PrincipalType"
            ],
            members: {
              ApplicationArn: {},
              PrincipalId: {},
              PrincipalType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationArn: {},
              PrincipalId: {},
              PrincipalType: {}
            }
          }
        },
        DescribeApplicationProvider: {
          input: {
            type: "structure",
            required: [
              "ApplicationProviderArn"
            ],
            members: {
              ApplicationProviderArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ApplicationProviderArn"
            ],
            members: {
              ApplicationProviderArn: {},
              DisplayData: {
                shape: "S2x"
              },
              FederationProtocol: {},
              ResourceServerConfig: {
                shape: "S31"
              }
            }
          }
        },
        DescribeInstance: {
          input: {
            type: "structure",
            required: [
              "InstanceArn"
            ],
            members: {
              InstanceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CreatedDate: {
                type: "timestamp"
              },
              IdentityStoreId: {},
              InstanceArn: {},
              Name: {},
              OwnerAccountId: {},
              Status: {}
            }
          }
        },
        DescribeInstanceAccessControlAttributeConfiguration: {
          input: {
            type: "structure",
            required: [
              "InstanceArn"
            ],
            members: {
              InstanceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceAccessControlAttributeConfiguration: {
                shape: "S18"
              },
              Status: {},
              StatusReason: {}
            }
          }
        },
        DescribePermissionSet: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "PermissionSetArn"
            ],
            members: {
              InstanceArn: {},
              PermissionSetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PermissionSet: {
                shape: "S1m"
              }
            }
          }
        },
        DescribePermissionSetProvisioningStatus: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "ProvisionPermissionSetRequestId"
            ],
            members: {
              InstanceArn: {},
              ProvisionPermissionSetRequestId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PermissionSetProvisioningStatus: {
                shape: "S3h"
              }
            }
          }
        },
        DescribeTrustedTokenIssuer: {
          input: {
            type: "structure",
            required: [
              "TrustedTokenIssuerArn"
            ],
            members: {
              TrustedTokenIssuerArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              TrustedTokenIssuerArn: {},
              TrustedTokenIssuerConfiguration: {
                shape: "S1p"
              },
              TrustedTokenIssuerType: {}
            }
          }
        },
        DetachCustomerManagedPolicyReferenceFromPermissionSet: {
          input: {
            type: "structure",
            required: [
              "CustomerManagedPolicyReference",
              "InstanceArn",
              "PermissionSetArn"
            ],
            members: {
              CustomerManagedPolicyReference: {
                shape: "S2"
              },
              InstanceArn: {},
              PermissionSetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DetachManagedPolicyFromPermissionSet: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "ManagedPolicyArn",
              "PermissionSetArn"
            ],
            members: {
              InstanceArn: {},
              ManagedPolicyArn: {},
              PermissionSetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetApplicationAccessScope: {
          input: {
            type: "structure",
            required: [
              "ApplicationArn",
              "Scope"
            ],
            members: {
              ApplicationArn: {},
              Scope: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Scope"
            ],
            members: {
              AuthorizedTargets: {
                shape: "S3q"
              },
              Scope: {}
            }
          }
        },
        GetApplicationAssignmentConfiguration: {
          input: {
            type: "structure",
            required: [
              "ApplicationArn"
            ],
            members: {
              ApplicationArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "AssignmentRequired"
            ],
            members: {
              AssignmentRequired: {
                type: "boolean"
              }
            }
          }
        },
        GetApplicationAuthenticationMethod: {
          input: {
            type: "structure",
            required: [
              "ApplicationArn",
              "AuthenticationMethodType"
            ],
            members: {
              ApplicationArn: {},
              AuthenticationMethodType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AuthenticationMethod: {
                shape: "S3x"
              }
            }
          }
        },
        GetApplicationGrant: {
          input: {
            type: "structure",
            required: [
              "ApplicationArn",
              "GrantType"
            ],
            members: {
              ApplicationArn: {},
              GrantType: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Grant"
            ],
            members: {
              Grant: {
                shape: "S42"
              }
            }
          }
        },
        GetInlinePolicyForPermissionSet: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "PermissionSetArn"
            ],
            members: {
              InstanceArn: {},
              PermissionSetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InlinePolicy: {}
            }
          }
        },
        GetPermissionsBoundaryForPermissionSet: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "PermissionSetArn"
            ],
            members: {
              InstanceArn: {},
              PermissionSetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PermissionsBoundary: {
                shape: "S4i"
              }
            }
          }
        },
        ListAccountAssignmentCreationStatus: {
          input: {
            type: "structure",
            required: [
              "InstanceArn"
            ],
            members: {
              Filter: {
                shape: "S4k"
              },
              InstanceArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AccountAssignmentsCreationStatus: {
                shape: "S4o"
              },
              NextToken: {}
            }
          }
        },
        ListAccountAssignmentDeletionStatus: {
          input: {
            type: "structure",
            required: [
              "InstanceArn"
            ],
            members: {
              Filter: {
                shape: "S4k"
              },
              InstanceArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AccountAssignmentsDeletionStatus: {
                shape: "S4o"
              },
              NextToken: {}
            }
          }
        },
        ListAccountAssignments: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "InstanceArn",
              "PermissionSetArn"
            ],
            members: {
              AccountId: {},
              InstanceArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              PermissionSetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AccountAssignments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AccountId: {},
                    PermissionSetArn: {},
                    PrincipalId: {},
                    PrincipalType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListAccountAssignmentsForPrincipal: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "PrincipalId",
              "PrincipalType"
            ],
            members: {
              Filter: {
                type: "structure",
                members: {
                  AccountId: {}
                }
              },
              InstanceArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              PrincipalId: {},
              PrincipalType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AccountAssignments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AccountId: {},
                    PermissionSetArn: {},
                    PrincipalId: {},
                    PrincipalType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListAccountsForProvisionedPermissionSet: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "PermissionSetArn"
            ],
            members: {
              InstanceArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              PermissionSetArn: {},
              ProvisioningStatus: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AccountIds: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListApplicationAccessScopes: {
          input: {
            type: "structure",
            required: [
              "ApplicationArn"
            ],
            members: {
              ApplicationArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Scopes"
            ],
            members: {
              NextToken: {},
              Scopes: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Scope"
                  ],
                  members: {
                    AuthorizedTargets: {
                      shape: "S3q"
                    },
                    Scope: {}
                  }
                }
              }
            }
          }
        },
        ListApplicationAssignments: {
          input: {
            type: "structure",
            required: [
              "ApplicationArn"
            ],
            members: {
              ApplicationArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationAssignments: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ApplicationArn",
                    "PrincipalId",
                    "PrincipalType"
                  ],
                  members: {
                    ApplicationArn: {},
                    PrincipalId: {},
                    PrincipalType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListApplicationAssignmentsForPrincipal: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "PrincipalId",
              "PrincipalType"
            ],
            members: {
              Filter: {
                type: "structure",
                members: {
                  ApplicationArn: {}
                }
              },
              InstanceArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              PrincipalId: {},
              PrincipalType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationAssignments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApplicationArn: {},
                    PrincipalId: {},
                    PrincipalType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListApplicationAuthenticationMethods: {
          input: {
            type: "structure",
            required: [
              "ApplicationArn"
            ],
            members: {
              ApplicationArn: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AuthenticationMethods: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AuthenticationMethod: {
                      shape: "S3x"
                    },
                    AuthenticationMethodType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListApplicationGrants: {
          input: {
            type: "structure",
            required: [
              "ApplicationArn"
            ],
            members: {
              ApplicationArn: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Grants"
            ],
            members: {
              Grants: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Grant",
                    "GrantType"
                  ],
                  members: {
                    Grant: {
                      shape: "S42"
                    },
                    GrantType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListApplicationProviders: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationProviders: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ApplicationProviderArn"
                  ],
                  members: {
                    ApplicationProviderArn: {},
                    DisplayData: {
                      shape: "S2x"
                    },
                    FederationProtocol: {},
                    ResourceServerConfig: {
                      shape: "S31"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListApplications: {
          input: {
            type: "structure",
            required: [
              "InstanceArn"
            ],
            members: {
              Filter: {
                type: "structure",
                members: {
                  ApplicationAccount: {},
                  ApplicationProvider: {}
                }
              },
              InstanceArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Applications: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApplicationAccount: {},
                    ApplicationArn: {},
                    ApplicationProviderArn: {},
                    CreatedDate: {
                      type: "timestamp"
                    },
                    Description: {},
                    InstanceArn: {},
                    Name: {},
                    PortalOptions: {
                      shape: "Sr"
                    },
                    Status: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListCustomerManagedPolicyReferencesInPermissionSet: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "PermissionSetArn"
            ],
            members: {
              InstanceArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              PermissionSetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CustomerManagedPolicyReferences: {
                type: "list",
                member: {
                  shape: "S2"
                }
              },
              NextToken: {}
            }
          }
        },
        ListInstances: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Instances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreatedDate: {
                      type: "timestamp"
                    },
                    IdentityStoreId: {},
                    InstanceArn: {},
                    Name: {},
                    OwnerAccountId: {},
                    Status: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListManagedPoliciesInPermissionSet: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "PermissionSetArn"
            ],
            members: {
              InstanceArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              PermissionSetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AttachedManagedPolicies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Name: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPermissionSetProvisioningStatus: {
          input: {
            type: "structure",
            required: [
              "InstanceArn"
            ],
            members: {
              Filter: {
                shape: "S4k"
              },
              InstanceArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              PermissionSetsProvisioningStatus: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreatedDate: {
                      type: "timestamp"
                    },
                    RequestId: {},
                    Status: {}
                  }
                }
              }
            }
          }
        },
        ListPermissionSets: {
          input: {
            type: "structure",
            required: [
              "InstanceArn"
            ],
            members: {
              InstanceArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              PermissionSets: {
                shape: "S6h"
              }
            }
          }
        },
        ListPermissionSetsProvisionedToAccount: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "InstanceArn"
            ],
            members: {
              AccountId: {},
              InstanceArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              ProvisioningStatus: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              PermissionSets: {
                shape: "S6h"
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              InstanceArn: {},
              NextToken: {},
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Tags: {
                shape: "Sx"
              }
            }
          }
        },
        ListTrustedTokenIssuers: {
          input: {
            type: "structure",
            required: [
              "InstanceArn"
            ],
            members: {
              InstanceArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              TrustedTokenIssuers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    TrustedTokenIssuerArn: {},
                    TrustedTokenIssuerType: {}
                  }
                }
              }
            }
          }
        },
        ProvisionPermissionSet: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "PermissionSetArn",
              "TargetType"
            ],
            members: {
              InstanceArn: {},
              PermissionSetArn: {},
              TargetId: {},
              TargetType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PermissionSetProvisioningStatus: {
                shape: "S3h"
              }
            }
          }
        },
        PutApplicationAccessScope: {
          input: {
            type: "structure",
            required: [
              "ApplicationArn",
              "Scope"
            ],
            members: {
              ApplicationArn: {},
              AuthorizedTargets: {
                shape: "S3q"
              },
              Scope: {}
            }
          },
          idempotent: true
        },
        PutApplicationAssignmentConfiguration: {
          input: {
            type: "structure",
            required: [
              "ApplicationArn",
              "AssignmentRequired"
            ],
            members: {
              ApplicationArn: {},
              AssignmentRequired: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        PutApplicationAuthenticationMethod: {
          input: {
            type: "structure",
            required: [
              "ApplicationArn",
              "AuthenticationMethod",
              "AuthenticationMethodType"
            ],
            members: {
              ApplicationArn: {},
              AuthenticationMethod: {
                shape: "S3x"
              },
              AuthenticationMethodType: {}
            }
          },
          idempotent: true
        },
        PutApplicationGrant: {
          input: {
            type: "structure",
            required: [
              "ApplicationArn",
              "Grant",
              "GrantType"
            ],
            members: {
              ApplicationArn: {},
              Grant: {
                shape: "S42"
              },
              GrantType: {}
            }
          },
          idempotent: true
        },
        PutInlinePolicyToPermissionSet: {
          input: {
            type: "structure",
            required: [
              "InlinePolicy",
              "InstanceArn",
              "PermissionSetArn"
            ],
            members: {
              InlinePolicy: {},
              InstanceArn: {},
              PermissionSetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutPermissionsBoundaryToPermissionSet: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "PermissionSetArn",
              "PermissionsBoundary"
            ],
            members: {
              InstanceArn: {},
              PermissionSetArn: {},
              PermissionsBoundary: {
                shape: "S4i"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              InstanceArn: {},
              ResourceArn: {},
              Tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              InstanceArn: {},
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationArn"
            ],
            members: {
              ApplicationArn: {},
              Description: {},
              Name: {},
              PortalOptions: {
                type: "structure",
                members: {
                  SignInOptions: {
                    shape: "Ss"
                  }
                }
              },
              Status: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateInstance: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "Name"
            ],
            members: {
              InstanceArn: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateInstanceAccessControlAttributeConfiguration: {
          input: {
            type: "structure",
            required: [
              "InstanceAccessControlAttributeConfiguration",
              "InstanceArn"
            ],
            members: {
              InstanceAccessControlAttributeConfiguration: {
                shape: "S18"
              },
              InstanceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdatePermissionSet: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "PermissionSetArn"
            ],
            members: {
              Description: {},
              InstanceArn: {},
              PermissionSetArn: {},
              RelayState: {},
              SessionDuration: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateTrustedTokenIssuer: {
          input: {
            type: "structure",
            required: [
              "TrustedTokenIssuerArn"
            ],
            members: {
              Name: {},
              TrustedTokenIssuerArn: {},
              TrustedTokenIssuerConfiguration: {
                type: "structure",
                members: {
                  OidcJwtConfiguration: {
                    type: "structure",
                    members: {
                      ClaimAttributePath: {},
                      IdentityStoreAttributePath: {},
                      JwksRetrievalOption: {}
                    }
                  }
                },
                union: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            Path: {}
          }
        },
        Sh: {
          type: "structure",
          members: {
            CreatedDate: {
              type: "timestamp"
            },
            FailureReason: {},
            PermissionSetArn: {},
            PrincipalId: {},
            PrincipalType: {},
            RequestId: {},
            Status: {},
            TargetId: {},
            TargetType: {}
          }
        },
        Sr: {
          type: "structure",
          members: {
            SignInOptions: {
              shape: "Ss"
            },
            Visibility: {}
          }
        },
        Ss: {
          type: "structure",
          required: [
            "Origin"
          ],
          members: {
            ApplicationUrl: {},
            Origin: {}
          }
        },
        Sx: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S18: {
          type: "structure",
          required: [
            "AccessControlAttributes"
          ],
          members: {
            AccessControlAttributes: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Key",
                  "Value"
                ],
                members: {
                  Key: {},
                  Value: {
                    type: "structure",
                    required: [
                      "Source"
                    ],
                    members: {
                      Source: {
                        type: "list",
                        member: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S1m: {
          type: "structure",
          members: {
            CreatedDate: {
              type: "timestamp"
            },
            Description: {},
            Name: {},
            PermissionSetArn: {},
            RelayState: {},
            SessionDuration: {}
          }
        },
        S1p: {
          type: "structure",
          members: {
            OidcJwtConfiguration: {
              type: "structure",
              required: [
                "ClaimAttributePath",
                "IdentityStoreAttributePath",
                "IssuerUrl",
                "JwksRetrievalOption"
              ],
              members: {
                ClaimAttributePath: {},
                IdentityStoreAttributePath: {},
                IssuerUrl: {},
                JwksRetrievalOption: {}
              }
            }
          },
          union: true
        },
        S2x: {
          type: "structure",
          members: {
            Description: {},
            DisplayName: {},
            IconUrl: {}
          }
        },
        S31: {
          type: "structure",
          members: {
            Scopes: {
              type: "map",
              key: {},
              value: {
                type: "structure",
                members: {
                  DetailedTitle: {},
                  LongDescription: {}
                }
              }
            }
          }
        },
        S3h: {
          type: "structure",
          members: {
            AccountId: {},
            CreatedDate: {
              type: "timestamp"
            },
            FailureReason: {},
            PermissionSetArn: {},
            RequestId: {},
            Status: {}
          }
        },
        S3q: {
          type: "list",
          member: {}
        },
        S3x: {
          type: "structure",
          members: {
            Iam: {
              type: "structure",
              required: [
                "ActorPolicy"
              ],
              members: {
                ActorPolicy: {
                  type: "structure",
                  members: {},
                  document: true
                }
              }
            }
          },
          union: true
        },
        S42: {
          type: "structure",
          members: {
            AuthorizationCode: {
              type: "structure",
              members: {
                RedirectUris: {
                  type: "list",
                  member: {}
                }
              }
            },
            JwtBearer: {
              type: "structure",
              members: {
                AuthorizedTokenIssuers: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      AuthorizedAudiences: {
                        type: "list",
                        member: {}
                      },
                      TrustedTokenIssuerArn: {}
                    }
                  }
                }
              }
            },
            RefreshToken: {
              type: "structure",
              members: {}
            },
            TokenExchange: {
              type: "structure",
              members: {}
            }
          },
          union: true
        },
        S4i: {
          type: "structure",
          members: {
            CustomerManagedPolicyReference: {
              shape: "S2"
            },
            ManagedPolicyArn: {}
          }
        },
        S4k: {
          type: "structure",
          members: {
            Status: {}
          }
        },
        S4o: {
          type: "list",
          member: {
            type: "structure",
            members: {
              CreatedDate: {
                type: "timestamp"
              },
              RequestId: {},
              Status: {}
            }
          }
        },
        S6h: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/sso-admin-2020-07-20.paginators.json
var require_sso_admin_2020_07_20_paginators = __commonJS({
  "node_modules/aws-sdk/apis/sso-admin-2020-07-20.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAccountAssignmentCreationStatus: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AccountAssignmentsCreationStatus"
        },
        ListAccountAssignmentDeletionStatus: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AccountAssignmentsDeletionStatus"
        },
        ListAccountAssignments: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AccountAssignments"
        },
        ListAccountAssignmentsForPrincipal: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AccountAssignments"
        },
        ListAccountsForProvisionedPermissionSet: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AccountIds"
        },
        ListApplicationAccessScopes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Scopes"
        },
        ListApplicationAssignments: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ApplicationAssignments"
        },
        ListApplicationAssignmentsForPrincipal: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ApplicationAssignments"
        },
        ListApplicationAuthenticationMethods: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "AuthenticationMethods"
        },
        ListApplicationGrants: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Grants"
        },
        ListApplicationProviders: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ApplicationProviders"
        },
        ListApplications: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Applications"
        },
        ListCustomerManagedPolicyReferencesInPermissionSet: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "CustomerManagedPolicyReferences"
        },
        ListInstances: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Instances"
        },
        ListManagedPoliciesInPermissionSet: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AttachedManagedPolicies"
        },
        ListPermissionSetProvisioningStatus: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "PermissionSetsProvisioningStatus"
        },
        ListPermissionSets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "PermissionSets"
        },
        ListPermissionSetsProvisionedToAccount: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "PermissionSets"
        },
        ListTagsForResource: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Tags"
        },
        ListTrustedTokenIssuers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "TrustedTokenIssuers"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/ssoadmin.js
var require_ssoadmin = __commonJS({
  "node_modules/aws-sdk/clients/ssoadmin.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["ssoadmin"] = {};
    AWS2.SSOAdmin = Service.defineService("ssoadmin", ["2020-07-20"]);
    Object.defineProperty(apiLoader.services["ssoadmin"], "2020-07-20", {
      get: function get() {
        var model = require_sso_admin_2020_07_20_min();
        model.paginators = require_sso_admin_2020_07_20_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.SSOAdmin;
  }
});

// node_modules/aws-sdk/apis/timestream-query-2018-11-01.min.json
var require_timestream_query_2018_11_01_min = __commonJS({
  "node_modules/aws-sdk/apis/timestream-query-2018-11-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-11-01",
        endpointPrefix: "query.timestream",
        jsonVersion: "1.0",
        protocol: "json",
        serviceAbbreviation: "Timestream Query",
        serviceFullName: "Amazon Timestream Query",
        serviceId: "Timestream Query",
        signatureVersion: "v4",
        signingName: "timestream",
        targetPrefix: "Timestream_20181101",
        uid: "timestream-query-2018-11-01"
      },
      operations: {
        CancelQuery: {
          input: {
            type: "structure",
            required: [
              "QueryId"
            ],
            members: {
              QueryId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CancellationMessage: {}
            }
          },
          endpointdiscovery: {
            required: true
          },
          idempotent: true
        },
        CreateScheduledQuery: {
          input: {
            type: "structure",
            required: [
              "Name",
              "QueryString",
              "ScheduleConfiguration",
              "NotificationConfiguration",
              "ScheduledQueryExecutionRoleArn",
              "ErrorReportConfiguration"
            ],
            members: {
              Name: {},
              QueryString: {
                shape: "S7"
              },
              ScheduleConfiguration: {
                shape: "S8"
              },
              NotificationConfiguration: {
                shape: "Sa"
              },
              TargetConfiguration: {
                shape: "Sd"
              },
              ClientToken: {
                shape: "Sr",
                idempotencyToken: true
              },
              ScheduledQueryExecutionRoleArn: {},
              Tags: {
                shape: "Ss"
              },
              KmsKeyId: {},
              ErrorReportConfiguration: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {}
            }
          },
          endpointdiscovery: {
            required: true
          },
          idempotent: true
        },
        DeleteScheduledQuery: {
          input: {
            type: "structure",
            required: [
              "ScheduledQueryArn"
            ],
            members: {
              ScheduledQueryArn: {}
            }
          },
          endpointdiscovery: {
            required: true
          },
          idempotent: true
        },
        DescribeEndpoints: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "Endpoints"
            ],
            members: {
              Endpoints: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Address",
                    "CachePeriodInMinutes"
                  ],
                  members: {
                    Address: {},
                    CachePeriodInMinutes: {
                      type: "long"
                    }
                  }
                }
              }
            }
          },
          endpointoperation: true
        },
        DescribeScheduledQuery: {
          input: {
            type: "structure",
            required: [
              "ScheduledQueryArn"
            ],
            members: {
              ScheduledQueryArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ScheduledQuery"
            ],
            members: {
              ScheduledQuery: {
                type: "structure",
                required: [
                  "Arn",
                  "Name",
                  "QueryString",
                  "State",
                  "ScheduleConfiguration",
                  "NotificationConfiguration"
                ],
                members: {
                  Arn: {},
                  Name: {},
                  QueryString: {
                    shape: "S7"
                  },
                  CreationTime: {
                    type: "timestamp"
                  },
                  State: {},
                  PreviousInvocationTime: {
                    type: "timestamp"
                  },
                  NextInvocationTime: {
                    type: "timestamp"
                  },
                  ScheduleConfiguration: {
                    shape: "S8"
                  },
                  NotificationConfiguration: {
                    shape: "Sa"
                  },
                  TargetConfiguration: {
                    shape: "Sd"
                  },
                  ScheduledQueryExecutionRoleArn: {},
                  KmsKeyId: {},
                  ErrorReportConfiguration: {
                    shape: "Sx"
                  },
                  LastRunSummary: {
                    shape: "S1e"
                  },
                  RecentlyFailedRuns: {
                    type: "list",
                    member: {
                      shape: "S1e"
                    }
                  }
                }
              }
            }
          },
          endpointdiscovery: {
            required: true
          }
        },
        ExecuteScheduledQuery: {
          input: {
            type: "structure",
            required: [
              "ScheduledQueryArn",
              "InvocationTime"
            ],
            members: {
              ScheduledQueryArn: {},
              InvocationTime: {
                type: "timestamp"
              },
              ClientToken: {
                shape: "Sr",
                idempotencyToken: true
              }
            }
          },
          endpointdiscovery: {
            required: true
          },
          idempotent: true
        },
        ListScheduledQueries: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ScheduledQueries"
            ],
            members: {
              ScheduledQueries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Arn",
                    "Name",
                    "State"
                  ],
                  members: {
                    Arn: {},
                    Name: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    State: {},
                    PreviousInvocationTime: {
                      type: "timestamp"
                    },
                    NextInvocationTime: {
                      type: "timestamp"
                    },
                    ErrorReportConfiguration: {
                      shape: "Sx"
                    },
                    TargetDestination: {
                      type: "structure",
                      members: {
                        TimestreamDestination: {
                          type: "structure",
                          members: {
                            DatabaseName: {},
                            TableName: {}
                          }
                        }
                      }
                    },
                    LastRunStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          endpointdiscovery: {
            required: true
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "Ss"
              },
              NextToken: {}
            }
          },
          endpointdiscovery: {
            required: true
          }
        },
        PrepareQuery: {
          input: {
            type: "structure",
            required: [
              "QueryString"
            ],
            members: {
              QueryString: {
                shape: "S7"
              },
              ValidateOnly: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "QueryString",
              "Columns",
              "Parameters"
            ],
            members: {
              QueryString: {
                shape: "S7"
              },
              Columns: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Type: {
                      shape: "S24"
                    },
                    DatabaseName: {},
                    TableName: {},
                    Aliased: {
                      type: "boolean"
                    }
                  }
                }
              },
              Parameters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Type"
                  ],
                  members: {
                    Name: {},
                    Type: {
                      shape: "S24"
                    }
                  }
                }
              }
            }
          },
          endpointdiscovery: {
            required: true
          },
          idempotent: true
        },
        Query: {
          input: {
            type: "structure",
            required: [
              "QueryString"
            ],
            members: {
              QueryString: {
                shape: "S7"
              },
              ClientToken: {
                idempotencyToken: true,
                type: "string",
                sensitive: true
              },
              NextToken: {},
              MaxRows: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "QueryId",
              "Rows",
              "ColumnInfo"
            ],
            members: {
              QueryId: {},
              NextToken: {},
              Rows: {
                type: "list",
                member: {
                  shape: "S2g"
                }
              },
              ColumnInfo: {
                shape: "S27"
              },
              QueryStatus: {
                type: "structure",
                members: {
                  ProgressPercentage: {
                    type: "double"
                  },
                  CumulativeBytesScanned: {
                    type: "long"
                  },
                  CumulativeBytesMetered: {
                    type: "long"
                  }
                }
              }
            }
          },
          endpointdiscovery: {
            required: true
          },
          idempotent: true
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "Ss"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpointdiscovery: {
            required: true
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpointdiscovery: {
            required: true
          }
        },
        UpdateScheduledQuery: {
          input: {
            type: "structure",
            required: [
              "ScheduledQueryArn",
              "State"
            ],
            members: {
              ScheduledQueryArn: {},
              State: {}
            }
          },
          endpointdiscovery: {
            required: true
          }
        }
      },
      shapes: {
        S7: {
          type: "string",
          sensitive: true
        },
        S8: {
          type: "structure",
          required: [
            "ScheduleExpression"
          ],
          members: {
            ScheduleExpression: {}
          }
        },
        Sa: {
          type: "structure",
          required: [
            "SnsConfiguration"
          ],
          members: {
            SnsConfiguration: {
              type: "structure",
              required: [
                "TopicArn"
              ],
              members: {
                TopicArn: {}
              }
            }
          }
        },
        Sd: {
          type: "structure",
          required: [
            "TimestreamConfiguration"
          ],
          members: {
            TimestreamConfiguration: {
              type: "structure",
              required: [
                "DatabaseName",
                "TableName",
                "TimeColumn",
                "DimensionMappings"
              ],
              members: {
                DatabaseName: {},
                TableName: {},
                TimeColumn: {},
                DimensionMappings: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "Name",
                      "DimensionValueType"
                    ],
                    members: {
                      Name: {},
                      DimensionValueType: {}
                    }
                  }
                },
                MultiMeasureMappings: {
                  type: "structure",
                  required: [
                    "MultiMeasureAttributeMappings"
                  ],
                  members: {
                    TargetMultiMeasureName: {},
                    MultiMeasureAttributeMappings: {
                      shape: "Sl"
                    }
                  }
                },
                MixedMeasureMappings: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "MeasureValueType"
                    ],
                    members: {
                      MeasureName: {},
                      SourceColumn: {},
                      TargetMeasureName: {},
                      MeasureValueType: {},
                      MultiMeasureAttributeMappings: {
                        shape: "Sl"
                      }
                    }
                  }
                },
                MeasureNameColumn: {}
              }
            }
          }
        },
        Sl: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "SourceColumn",
              "MeasureValueType"
            ],
            members: {
              SourceColumn: {},
              TargetMultiMeasureAttributeName: {},
              MeasureValueType: {}
            }
          }
        },
        Sr: {
          type: "string",
          sensitive: true
        },
        Ss: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sx: {
          type: "structure",
          required: [
            "S3Configuration"
          ],
          members: {
            S3Configuration: {
              type: "structure",
              required: [
                "BucketName"
              ],
              members: {
                BucketName: {},
                ObjectKeyPrefix: {},
                EncryptionOption: {}
              }
            }
          }
        },
        S1e: {
          type: "structure",
          members: {
            InvocationTime: {
              type: "timestamp"
            },
            TriggerTime: {
              type: "timestamp"
            },
            RunStatus: {},
            ExecutionStats: {
              type: "structure",
              members: {
                ExecutionTimeInMillis: {
                  type: "long"
                },
                DataWrites: {
                  type: "long"
                },
                BytesMetered: {
                  type: "long"
                },
                RecordsIngested: {
                  type: "long"
                },
                QueryResultRows: {
                  type: "long"
                }
              }
            },
            ErrorReportLocation: {
              type: "structure",
              members: {
                S3ReportLocation: {
                  type: "structure",
                  members: {
                    BucketName: {},
                    ObjectKey: {}
                  }
                }
              }
            },
            FailureReason: {}
          }
        },
        S24: {
          type: "structure",
          members: {
            ScalarType: {},
            ArrayColumnInfo: {
              shape: "S26"
            },
            TimeSeriesMeasureValueColumnInfo: {
              shape: "S26"
            },
            RowColumnInfo: {
              shape: "S27"
            }
          }
        },
        S26: {
          type: "structure",
          required: [
            "Type"
          ],
          members: {
            Name: {},
            Type: {
              shape: "S24"
            }
          }
        },
        S27: {
          type: "list",
          member: {
            shape: "S26"
          }
        },
        S2g: {
          type: "structure",
          required: [
            "Data"
          ],
          members: {
            Data: {
              shape: "S2h"
            }
          }
        },
        S2h: {
          type: "list",
          member: {
            shape: "S2i"
          }
        },
        S2i: {
          type: "structure",
          members: {
            ScalarValue: {},
            TimeSeriesValue: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Time",
                  "Value"
                ],
                members: {
                  Time: {},
                  Value: {
                    shape: "S2i"
                  }
                }
              }
            },
            ArrayValue: {
              shape: "S2h"
            },
            RowValue: {
              shape: "S2g"
            },
            NullValue: {
              type: "boolean"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/timestream-query-2018-11-01.paginators.json
var require_timestream_query_2018_11_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/timestream-query-2018-11-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListScheduledQueries: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ScheduledQueries"
        },
        ListTagsForResource: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Tags"
        },
        Query: {
          input_token: "NextToken",
          limit_key: "MaxRows",
          non_aggregate_keys: [
            "ColumnInfo",
            "QueryId",
            "QueryStatus"
          ],
          output_token: "NextToken",
          result_key: "Rows"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/timestreamquery.js
var require_timestreamquery = __commonJS({
  "node_modules/aws-sdk/clients/timestreamquery.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["timestreamquery"] = {};
    AWS2.TimestreamQuery = Service.defineService("timestreamquery", ["2018-11-01"]);
    Object.defineProperty(apiLoader.services["timestreamquery"], "2018-11-01", {
      get: function get() {
        var model = require_timestream_query_2018_11_01_min();
        model.paginators = require_timestream_query_2018_11_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.TimestreamQuery;
  }
});

// node_modules/aws-sdk/apis/timestream-write-2018-11-01.min.json
var require_timestream_write_2018_11_01_min = __commonJS({
  "node_modules/aws-sdk/apis/timestream-write-2018-11-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-11-01",
        endpointPrefix: "ingest.timestream",
        jsonVersion: "1.0",
        protocol: "json",
        serviceAbbreviation: "Timestream Write",
        serviceFullName: "Amazon Timestream Write",
        serviceId: "Timestream Write",
        signatureVersion: "v4",
        signingName: "timestream",
        targetPrefix: "Timestream_20181101",
        uid: "timestream-write-2018-11-01"
      },
      operations: {
        CreateBatchLoadTask: {
          input: {
            type: "structure",
            required: [
              "DataSourceConfiguration",
              "ReportConfiguration",
              "TargetDatabaseName",
              "TargetTableName"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true,
                type: "string",
                sensitive: true
              },
              DataModelConfiguration: {
                shape: "S3"
              },
              DataSourceConfiguration: {
                shape: "Sk"
              },
              ReportConfiguration: {
                shape: "Sq"
              },
              TargetDatabaseName: {},
              TargetTableName: {},
              RecordVersion: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TaskId"
            ],
            members: {
              TaskId: {}
            }
          },
          endpointdiscovery: {
            required: true
          }
        },
        CreateDatabase: {
          input: {
            type: "structure",
            required: [
              "DatabaseName"
            ],
            members: {
              DatabaseName: {},
              KmsKeyId: {},
              Tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Database: {
                shape: "S15"
              }
            }
          },
          endpointdiscovery: {
            required: true
          }
        },
        CreateTable: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName"
            ],
            members: {
              DatabaseName: {},
              TableName: {},
              RetentionProperties: {
                shape: "S1b"
              },
              Tags: {
                shape: "S10"
              },
              MagneticStoreWriteProperties: {
                shape: "S1e"
              },
              Schema: {
                shape: "S1h"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Table: {
                shape: "S1n"
              }
            }
          },
          endpointdiscovery: {
            required: true
          }
        },
        DeleteDatabase: {
          input: {
            type: "structure",
            required: [
              "DatabaseName"
            ],
            members: {
              DatabaseName: {}
            }
          },
          endpointdiscovery: {
            required: true
          }
        },
        DeleteTable: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName"
            ],
            members: {
              DatabaseName: {},
              TableName: {}
            }
          },
          endpointdiscovery: {
            required: true
          }
        },
        DescribeBatchLoadTask: {
          input: {
            type: "structure",
            required: [
              "TaskId"
            ],
            members: {
              TaskId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "BatchLoadTaskDescription"
            ],
            members: {
              BatchLoadTaskDescription: {
                type: "structure",
                members: {
                  TaskId: {},
                  ErrorMessage: {},
                  DataSourceConfiguration: {
                    shape: "Sk"
                  },
                  ProgressReport: {
                    type: "structure",
                    members: {
                      RecordsProcessed: {
                        type: "long"
                      },
                      RecordsIngested: {
                        type: "long"
                      },
                      ParseFailures: {
                        type: "long"
                      },
                      RecordIngestionFailures: {
                        type: "long"
                      },
                      FileFailures: {
                        type: "long"
                      },
                      BytesMetered: {
                        type: "long"
                      }
                    }
                  },
                  ReportConfiguration: {
                    shape: "Sq"
                  },
                  DataModelConfiguration: {
                    shape: "S3"
                  },
                  TargetDatabaseName: {},
                  TargetTableName: {},
                  TaskStatus: {},
                  RecordVersion: {
                    type: "long"
                  },
                  CreationTime: {
                    type: "timestamp"
                  },
                  LastUpdatedTime: {
                    type: "timestamp"
                  },
                  ResumableUntil: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          endpointdiscovery: {
            required: true
          }
        },
        DescribeDatabase: {
          input: {
            type: "structure",
            required: [
              "DatabaseName"
            ],
            members: {
              DatabaseName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Database: {
                shape: "S15"
              }
            }
          },
          endpointdiscovery: {
            required: true
          }
        },
        DescribeEndpoints: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "Endpoints"
            ],
            members: {
              Endpoints: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Address",
                    "CachePeriodInMinutes"
                  ],
                  members: {
                    Address: {},
                    CachePeriodInMinutes: {
                      type: "long"
                    }
                  }
                }
              }
            }
          },
          endpointoperation: true
        },
        DescribeTable: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName"
            ],
            members: {
              DatabaseName: {},
              TableName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Table: {
                shape: "S1n"
              }
            }
          },
          endpointdiscovery: {
            required: true
          }
        },
        ListBatchLoadTasks: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              TaskStatus: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              BatchLoadTasks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TaskId: {},
                    TaskStatus: {},
                    DatabaseName: {},
                    TableName: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastUpdatedTime: {
                      type: "timestamp"
                    },
                    ResumableUntil: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          },
          endpointdiscovery: {
            required: true
          }
        },
        ListDatabases: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Databases: {
                type: "list",
                member: {
                  shape: "S15"
                }
              },
              NextToken: {}
            }
          },
          endpointdiscovery: {
            required: true
          }
        },
        ListTables: {
          input: {
            type: "structure",
            members: {
              DatabaseName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tables: {
                type: "list",
                member: {
                  shape: "S1n"
                }
              },
              NextToken: {}
            }
          },
          endpointdiscovery: {
            required: true
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S10"
              }
            }
          },
          endpointdiscovery: {
            required: true
          }
        },
        ResumeBatchLoadTask: {
          input: {
            type: "structure",
            required: [
              "TaskId"
            ],
            members: {
              TaskId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpointdiscovery: {
            required: true
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpointdiscovery: {
            required: true
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpointdiscovery: {
            required: true
          }
        },
        UpdateDatabase: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "KmsKeyId"
            ],
            members: {
              DatabaseName: {},
              KmsKeyId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Database: {
                shape: "S15"
              }
            }
          },
          endpointdiscovery: {
            required: true
          }
        },
        UpdateTable: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName"
            ],
            members: {
              DatabaseName: {},
              TableName: {},
              RetentionProperties: {
                shape: "S1b"
              },
              MagneticStoreWriteProperties: {
                shape: "S1e"
              },
              Schema: {
                shape: "S1h"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Table: {
                shape: "S1n"
              }
            }
          },
          endpointdiscovery: {
            required: true
          }
        },
        WriteRecords: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "Records"
            ],
            members: {
              DatabaseName: {},
              TableName: {},
              CommonAttributes: {
                shape: "S2v"
              },
              Records: {
                type: "list",
                member: {
                  shape: "S2v"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RecordsIngested: {
                type: "structure",
                members: {
                  Total: {
                    type: "integer"
                  },
                  MemoryStore: {
                    type: "integer"
                  },
                  MagneticStore: {
                    type: "integer"
                  }
                }
              }
            }
          },
          endpointdiscovery: {
            required: true
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          members: {
            DataModel: {
              type: "structure",
              required: [
                "DimensionMappings"
              ],
              members: {
                TimeColumn: {},
                TimeUnit: {},
                DimensionMappings: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      SourceColumn: {},
                      DestinationColumn: {}
                    }
                  }
                },
                MultiMeasureMappings: {
                  type: "structure",
                  required: [
                    "MultiMeasureAttributeMappings"
                  ],
                  members: {
                    TargetMultiMeasureName: {},
                    MultiMeasureAttributeMappings: {
                      shape: "Sb"
                    }
                  }
                },
                MixedMeasureMappings: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "MeasureValueType"
                    ],
                    members: {
                      MeasureName: {},
                      SourceColumn: {},
                      TargetMeasureName: {},
                      MeasureValueType: {},
                      MultiMeasureAttributeMappings: {
                        shape: "Sb"
                      }
                    }
                  }
                },
                MeasureNameColumn: {}
              }
            },
            DataModelS3Configuration: {
              type: "structure",
              members: {
                BucketName: {},
                ObjectKey: {}
              }
            }
          }
        },
        Sb: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "SourceColumn"
            ],
            members: {
              SourceColumn: {},
              TargetMultiMeasureAttributeName: {},
              MeasureValueType: {}
            }
          }
        },
        Sk: {
          type: "structure",
          required: [
            "DataSourceS3Configuration",
            "DataFormat"
          ],
          members: {
            DataSourceS3Configuration: {
              type: "structure",
              required: [
                "BucketName"
              ],
              members: {
                BucketName: {},
                ObjectKeyPrefix: {}
              }
            },
            CsvConfiguration: {
              type: "structure",
              members: {
                ColumnSeparator: {},
                EscapeChar: {},
                QuoteChar: {},
                NullValue: {},
                TrimWhiteSpace: {
                  type: "boolean"
                }
              }
            },
            DataFormat: {}
          }
        },
        Sq: {
          type: "structure",
          members: {
            ReportS3Configuration: {
              type: "structure",
              required: [
                "BucketName"
              ],
              members: {
                BucketName: {},
                ObjectKeyPrefix: {},
                EncryptionOption: {},
                KmsKeyId: {}
              }
            }
          }
        },
        S10: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S15: {
          type: "structure",
          members: {
            Arn: {},
            DatabaseName: {},
            TableCount: {
              type: "long"
            },
            KmsKeyId: {},
            CreationTime: {
              type: "timestamp"
            },
            LastUpdatedTime: {
              type: "timestamp"
            }
          }
        },
        S1b: {
          type: "structure",
          required: [
            "MemoryStoreRetentionPeriodInHours",
            "MagneticStoreRetentionPeriodInDays"
          ],
          members: {
            MemoryStoreRetentionPeriodInHours: {
              type: "long"
            },
            MagneticStoreRetentionPeriodInDays: {
              type: "long"
            }
          }
        },
        S1e: {
          type: "structure",
          required: [
            "EnableMagneticStoreWrites"
          ],
          members: {
            EnableMagneticStoreWrites: {
              type: "boolean"
            },
            MagneticStoreRejectedDataLocation: {
              type: "structure",
              members: {
                S3Configuration: {
                  type: "structure",
                  members: {
                    BucketName: {},
                    ObjectKeyPrefix: {},
                    EncryptionOption: {},
                    KmsKeyId: {}
                  }
                }
              }
            }
          }
        },
        S1h: {
          type: "structure",
          members: {
            CompositePartitionKey: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Type"
                ],
                members: {
                  Type: {},
                  Name: {},
                  EnforcementInRecord: {}
                }
              }
            }
          }
        },
        S1n: {
          type: "structure",
          members: {
            Arn: {},
            TableName: {},
            DatabaseName: {},
            TableStatus: {},
            RetentionProperties: {
              shape: "S1b"
            },
            CreationTime: {
              type: "timestamp"
            },
            LastUpdatedTime: {
              type: "timestamp"
            },
            MagneticStoreWriteProperties: {
              shape: "S1e"
            },
            Schema: {
              shape: "S1h"
            }
          }
        },
        S2v: {
          type: "structure",
          members: {
            Dimensions: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name",
                  "Value"
                ],
                members: {
                  Name: {},
                  Value: {},
                  DimensionValueType: {}
                }
              }
            },
            MeasureName: {},
            MeasureValue: {},
            MeasureValueType: {},
            Time: {},
            TimeUnit: {},
            Version: {
              type: "long"
            },
            MeasureValues: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name",
                  "Value",
                  "Type"
                ],
                members: {
                  Name: {},
                  Value: {},
                  Type: {}
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/timestream-write-2018-11-01.paginators.json
var require_timestream_write_2018_11_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/timestream-write-2018-11-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListBatchLoadTasks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDatabases: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListTables: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/timestreamwrite.js
var require_timestreamwrite = __commonJS({
  "node_modules/aws-sdk/clients/timestreamwrite.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["timestreamwrite"] = {};
    AWS2.TimestreamWrite = Service.defineService("timestreamwrite", ["2018-11-01"]);
    Object.defineProperty(apiLoader.services["timestreamwrite"], "2018-11-01", {
      get: function get() {
        var model = require_timestream_write_2018_11_01_min();
        model.paginators = require_timestream_write_2018_11_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.TimestreamWrite;
  }
});

// node_modules/aws-sdk/apis/s3outposts-2017-07-25.min.json
var require_s3outposts_2017_07_25_min = __commonJS({
  "node_modules/aws-sdk/apis/s3outposts-2017-07-25.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-07-25",
        endpointPrefix: "s3-outposts",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Amazon S3 Outposts",
        serviceFullName: "Amazon S3 on Outposts",
        serviceId: "S3Outposts",
        signatureVersion: "v4",
        signingName: "s3-outposts",
        uid: "s3outposts-2017-07-25"
      },
      operations: {
        CreateEndpoint: {
          http: {
            requestUri: "/S3Outposts/CreateEndpoint"
          },
          input: {
            type: "structure",
            required: [
              "OutpostId",
              "SubnetId",
              "SecurityGroupId"
            ],
            members: {
              OutpostId: {},
              SubnetId: {},
              SecurityGroupId: {},
              AccessType: {},
              CustomerOwnedIpv4Pool: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EndpointArn: {}
            }
          }
        },
        DeleteEndpoint: {
          http: {
            method: "DELETE",
            requestUri: "/S3Outposts/DeleteEndpoint"
          },
          input: {
            type: "structure",
            required: [
              "EndpointId",
              "OutpostId"
            ],
            members: {
              EndpointId: {
                location: "querystring",
                locationName: "endpointId"
              },
              OutpostId: {
                location: "querystring",
                locationName: "outpostId"
              }
            }
          }
        },
        ListEndpoints: {
          http: {
            method: "GET",
            requestUri: "/S3Outposts/ListEndpoints"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Endpoints: {
                shape: "Sf"
              },
              NextToken: {}
            }
          }
        },
        ListOutpostsWithS3: {
          http: {
            method: "GET",
            requestUri: "/S3Outposts/ListOutpostsWithS3"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Outposts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    OutpostArn: {},
                    S3OutpostArn: {},
                    OutpostId: {},
                    OwnerId: {},
                    CapacityInBytes: {
                      type: "long"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSharedEndpoints: {
          http: {
            method: "GET",
            requestUri: "/S3Outposts/ListSharedEndpoints"
          },
          input: {
            type: "structure",
            required: [
              "OutpostId"
            ],
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              OutpostId: {
                location: "querystring",
                locationName: "outpostId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Endpoints: {
                shape: "Sf"
              },
              NextToken: {}
            }
          }
        }
      },
      shapes: {
        Sf: {
          type: "list",
          member: {
            type: "structure",
            members: {
              EndpointArn: {},
              OutpostsId: {},
              CidrBlock: {},
              Status: {},
              CreationTime: {
                type: "timestamp"
              },
              NetworkInterfaces: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    NetworkInterfaceId: {}
                  }
                }
              },
              VpcId: {},
              SubnetId: {},
              SecurityGroupId: {},
              AccessType: {},
              CustomerOwnedIpv4Pool: {},
              FailedReason: {
                type: "structure",
                members: {
                  ErrorCode: {},
                  Message: {}
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/s3outposts-2017-07-25.paginators.json
var require_s3outposts_2017_07_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/s3outposts-2017-07-25.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListEndpoints: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Endpoints"
        },
        ListOutpostsWithS3: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Outposts"
        },
        ListSharedEndpoints: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Endpoints"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/s3outposts.js
var require_s3outposts = __commonJS({
  "node_modules/aws-sdk/clients/s3outposts.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["s3outposts"] = {};
    AWS2.S3Outposts = Service.defineService("s3outposts", ["2017-07-25"]);
    Object.defineProperty(apiLoader.services["s3outposts"], "2017-07-25", {
      get: function get() {
        var model = require_s3outposts_2017_07_25_min();
        model.paginators = require_s3outposts_2017_07_25_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.S3Outposts;
  }
});

// node_modules/aws-sdk/apis/databrew-2017-07-25.min.json
var require_databrew_2017_07_25_min = __commonJS({
  "node_modules/aws-sdk/apis/databrew-2017-07-25.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-07-25",
        endpointPrefix: "databrew",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Glue DataBrew",
        serviceId: "DataBrew",
        signatureVersion: "v4",
        signingName: "databrew",
        uid: "databrew-2017-07-25"
      },
      operations: {
        BatchDeleteRecipeVersion: {
          http: {
            requestUri: "/recipes/{name}/batchDeleteRecipeVersion"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "RecipeVersions"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              RecipeVersions: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ErrorCode: {},
                    ErrorMessage: {},
                    RecipeVersion: {}
                  }
                }
              }
            }
          }
        },
        CreateDataset: {
          http: {
            requestUri: "/datasets"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "Input"
            ],
            members: {
              Name: {},
              Format: {},
              FormatOptions: {
                shape: "Sd"
              },
              Input: {
                shape: "So"
              },
              PathOptions: {
                shape: "S13"
              },
              Tags: {
                shape: "S1m"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        CreateProfileJob: {
          http: {
            requestUri: "/profileJobs"
          },
          input: {
            type: "structure",
            required: [
              "DatasetName",
              "Name",
              "OutputLocation",
              "RoleArn"
            ],
            members: {
              DatasetName: {},
              EncryptionKeyArn: {},
              EncryptionMode: {},
              Name: {},
              LogSubscription: {},
              MaxCapacity: {
                type: "integer"
              },
              MaxRetries: {
                type: "integer"
              },
              OutputLocation: {
                shape: "Sp"
              },
              Configuration: {
                shape: "S1x"
              },
              ValidationConfigurations: {
                shape: "S2g"
              },
              RoleArn: {},
              Tags: {
                shape: "S1m"
              },
              Timeout: {
                type: "integer"
              },
              JobSample: {
                shape: "S2k"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        CreateProject: {
          http: {
            requestUri: "/projects"
          },
          input: {
            type: "structure",
            required: [
              "DatasetName",
              "Name",
              "RecipeName",
              "RoleArn"
            ],
            members: {
              DatasetName: {},
              Name: {},
              RecipeName: {},
              Sample: {
                shape: "S2q"
              },
              RoleArn: {},
              Tags: {
                shape: "S1m"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        CreateRecipe: {
          http: {
            requestUri: "/recipes"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "Steps"
            ],
            members: {
              Description: {},
              Name: {},
              Steps: {
                shape: "S2w"
              },
              Tags: {
                shape: "S1m"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        CreateRecipeJob: {
          http: {
            requestUri: "/recipeJobs"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "RoleArn"
            ],
            members: {
              DatasetName: {},
              EncryptionKeyArn: {},
              EncryptionMode: {},
              Name: {},
              LogSubscription: {},
              MaxCapacity: {
                type: "integer"
              },
              MaxRetries: {
                type: "integer"
              },
              Outputs: {
                shape: "S36"
              },
              DataCatalogOutputs: {
                shape: "S3f"
              },
              DatabaseOutputs: {
                shape: "S3j"
              },
              ProjectName: {},
              RecipeReference: {
                shape: "S3m"
              },
              RoleArn: {},
              Tags: {
                shape: "S1m"
              },
              Timeout: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        CreateRuleset: {
          http: {
            requestUri: "/rulesets"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "TargetArn",
              "Rules"
            ],
            members: {
              Name: {},
              Description: {},
              TargetArn: {},
              Rules: {
                shape: "S3r"
              },
              Tags: {
                shape: "S1m"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        CreateSchedule: {
          http: {
            requestUri: "/schedules"
          },
          input: {
            type: "structure",
            required: [
              "CronExpression",
              "Name"
            ],
            members: {
              JobNames: {
                shape: "S41"
              },
              CronExpression: {},
              Tags: {
                shape: "S1m"
              },
              Name: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        DeleteDataset: {
          http: {
            method: "DELETE",
            requestUri: "/datasets/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        DeleteJob: {
          http: {
            method: "DELETE",
            requestUri: "/jobs/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        DeleteProject: {
          http: {
            method: "DELETE",
            requestUri: "/projects/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        DeleteRecipeVersion: {
          http: {
            method: "DELETE",
            requestUri: "/recipes/{name}/recipeVersion/{recipeVersion}"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "RecipeVersion"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              RecipeVersion: {
                location: "uri",
                locationName: "recipeVersion"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name",
              "RecipeVersion"
            ],
            members: {
              Name: {},
              RecipeVersion: {}
            }
          }
        },
        DeleteRuleset: {
          http: {
            method: "DELETE",
            requestUri: "/rulesets/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        DeleteSchedule: {
          http: {
            method: "DELETE",
            requestUri: "/schedules/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        DescribeDataset: {
          http: {
            method: "GET",
            requestUri: "/datasets/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name",
              "Input"
            ],
            members: {
              CreatedBy: {},
              CreateDate: {
                type: "timestamp"
              },
              Name: {},
              Format: {},
              FormatOptions: {
                shape: "Sd"
              },
              Input: {
                shape: "So"
              },
              LastModifiedDate: {
                type: "timestamp"
              },
              LastModifiedBy: {},
              Source: {},
              PathOptions: {
                shape: "S13"
              },
              Tags: {
                shape: "S1m"
              },
              ResourceArn: {}
            }
          }
        },
        DescribeJob: {
          http: {
            method: "GET",
            requestUri: "/jobs/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              CreateDate: {
                type: "timestamp"
              },
              CreatedBy: {},
              DatasetName: {},
              EncryptionKeyArn: {},
              EncryptionMode: {},
              Name: {},
              Type: {},
              LastModifiedBy: {},
              LastModifiedDate: {
                type: "timestamp"
              },
              LogSubscription: {},
              MaxCapacity: {
                type: "integer"
              },
              MaxRetries: {
                type: "integer"
              },
              Outputs: {
                shape: "S36"
              },
              DataCatalogOutputs: {
                shape: "S3f"
              },
              DatabaseOutputs: {
                shape: "S3j"
              },
              ProjectName: {},
              ProfileConfiguration: {
                shape: "S1x"
              },
              ValidationConfigurations: {
                shape: "S2g"
              },
              RecipeReference: {
                shape: "S3m"
              },
              ResourceArn: {},
              RoleArn: {},
              Tags: {
                shape: "S1m"
              },
              Timeout: {
                type: "integer"
              },
              JobSample: {
                shape: "S2k"
              }
            }
          }
        },
        DescribeJobRun: {
          http: {
            method: "GET",
            requestUri: "/jobs/{name}/jobRun/{runId}"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "RunId"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              RunId: {
                location: "uri",
                locationName: "runId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "JobName"
            ],
            members: {
              Attempt: {
                type: "integer"
              },
              CompletedOn: {
                type: "timestamp"
              },
              DatasetName: {},
              ErrorMessage: {},
              ExecutionTime: {
                type: "integer"
              },
              JobName: {},
              ProfileConfiguration: {
                shape: "S1x"
              },
              ValidationConfigurations: {
                shape: "S2g"
              },
              RunId: {},
              State: {},
              LogSubscription: {},
              LogGroupName: {},
              Outputs: {
                shape: "S36"
              },
              DataCatalogOutputs: {
                shape: "S3f"
              },
              DatabaseOutputs: {
                shape: "S3j"
              },
              RecipeReference: {
                shape: "S3m"
              },
              StartedBy: {},
              StartedOn: {
                type: "timestamp"
              },
              JobSample: {
                shape: "S2k"
              }
            }
          }
        },
        DescribeProject: {
          http: {
            method: "GET",
            requestUri: "/projects/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              CreateDate: {
                type: "timestamp"
              },
              CreatedBy: {},
              DatasetName: {},
              LastModifiedDate: {
                type: "timestamp"
              },
              LastModifiedBy: {},
              Name: {},
              RecipeName: {},
              ResourceArn: {},
              Sample: {
                shape: "S2q"
              },
              RoleArn: {},
              Tags: {
                shape: "S1m"
              },
              SessionStatus: {},
              OpenedBy: {},
              OpenDate: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeRecipe: {
          http: {
            method: "GET",
            requestUri: "/recipes/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              RecipeVersion: {
                location: "querystring",
                locationName: "recipeVersion"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              CreatedBy: {},
              CreateDate: {
                type: "timestamp"
              },
              LastModifiedBy: {},
              LastModifiedDate: {
                type: "timestamp"
              },
              ProjectName: {},
              PublishedBy: {},
              PublishedDate: {
                type: "timestamp"
              },
              Description: {},
              Name: {},
              Steps: {
                shape: "S2w"
              },
              Tags: {
                shape: "S1m"
              },
              ResourceArn: {},
              RecipeVersion: {}
            }
          }
        },
        DescribeRuleset: {
          http: {
            method: "GET",
            requestUri: "/rulesets/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Description: {},
              TargetArn: {},
              Rules: {
                shape: "S3r"
              },
              CreateDate: {
                type: "timestamp"
              },
              CreatedBy: {},
              LastModifiedBy: {},
              LastModifiedDate: {
                type: "timestamp"
              },
              ResourceArn: {},
              Tags: {
                shape: "S1m"
              }
            }
          }
        },
        DescribeSchedule: {
          http: {
            method: "GET",
            requestUri: "/schedules/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              CreateDate: {
                type: "timestamp"
              },
              CreatedBy: {},
              JobNames: {
                shape: "S41"
              },
              LastModifiedBy: {},
              LastModifiedDate: {
                type: "timestamp"
              },
              ResourceArn: {},
              CronExpression: {},
              Tags: {
                shape: "S1m"
              },
              Name: {}
            }
          }
        },
        ListDatasets: {
          http: {
            method: "GET",
            requestUri: "/datasets"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Datasets"
            ],
            members: {
              Datasets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Input"
                  ],
                  members: {
                    AccountId: {},
                    CreatedBy: {},
                    CreateDate: {
                      type: "timestamp"
                    },
                    Name: {},
                    Format: {},
                    FormatOptions: {
                      shape: "Sd"
                    },
                    Input: {
                      shape: "So"
                    },
                    LastModifiedDate: {
                      type: "timestamp"
                    },
                    LastModifiedBy: {},
                    Source: {},
                    PathOptions: {
                      shape: "S13"
                    },
                    Tags: {
                      shape: "S1m"
                    },
                    ResourceArn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListJobRuns: {
          http: {
            method: "GET",
            requestUri: "/jobs/{name}/jobRuns"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "JobRuns"
            ],
            members: {
              JobRuns: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Attempt: {
                      type: "integer"
                    },
                    CompletedOn: {
                      type: "timestamp"
                    },
                    DatasetName: {},
                    ErrorMessage: {},
                    ExecutionTime: {
                      type: "integer"
                    },
                    JobName: {},
                    RunId: {},
                    State: {},
                    LogSubscription: {},
                    LogGroupName: {},
                    Outputs: {
                      shape: "S36"
                    },
                    DataCatalogOutputs: {
                      shape: "S3f"
                    },
                    DatabaseOutputs: {
                      shape: "S3j"
                    },
                    RecipeReference: {
                      shape: "S3m"
                    },
                    StartedBy: {},
                    StartedOn: {
                      type: "timestamp"
                    },
                    JobSample: {
                      shape: "S2k"
                    },
                    ValidationConfigurations: {
                      shape: "S2g"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListJobs: {
          http: {
            method: "GET",
            requestUri: "/jobs"
          },
          input: {
            type: "structure",
            members: {
              DatasetName: {
                location: "querystring",
                locationName: "datasetName"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              ProjectName: {
                location: "querystring",
                locationName: "projectName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Jobs"
            ],
            members: {
              Jobs: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name"
                  ],
                  members: {
                    AccountId: {},
                    CreatedBy: {},
                    CreateDate: {
                      type: "timestamp"
                    },
                    DatasetName: {},
                    EncryptionKeyArn: {},
                    EncryptionMode: {},
                    Name: {},
                    Type: {},
                    LastModifiedBy: {},
                    LastModifiedDate: {
                      type: "timestamp"
                    },
                    LogSubscription: {},
                    MaxCapacity: {
                      type: "integer"
                    },
                    MaxRetries: {
                      type: "integer"
                    },
                    Outputs: {
                      shape: "S36"
                    },
                    DataCatalogOutputs: {
                      shape: "S3f"
                    },
                    DatabaseOutputs: {
                      shape: "S3j"
                    },
                    ProjectName: {},
                    RecipeReference: {
                      shape: "S3m"
                    },
                    ResourceArn: {},
                    RoleArn: {},
                    Timeout: {
                      type: "integer"
                    },
                    Tags: {
                      shape: "S1m"
                    },
                    JobSample: {
                      shape: "S2k"
                    },
                    ValidationConfigurations: {
                      shape: "S2g"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListProjects: {
          http: {
            method: "GET",
            requestUri: "/projects"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Projects"
            ],
            members: {
              Projects: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "RecipeName"
                  ],
                  members: {
                    AccountId: {},
                    CreateDate: {
                      type: "timestamp"
                    },
                    CreatedBy: {},
                    DatasetName: {},
                    LastModifiedDate: {
                      type: "timestamp"
                    },
                    LastModifiedBy: {},
                    Name: {},
                    RecipeName: {},
                    ResourceArn: {},
                    Sample: {
                      shape: "S2q"
                    },
                    Tags: {
                      shape: "S1m"
                    },
                    RoleArn: {},
                    OpenedBy: {},
                    OpenDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListRecipeVersions: {
          http: {
            method: "GET",
            requestUri: "/recipeVersions"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              Name: {
                location: "querystring",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Recipes"
            ],
            members: {
              NextToken: {},
              Recipes: {
                shape: "S5v"
              }
            }
          }
        },
        ListRecipes: {
          http: {
            method: "GET",
            requestUri: "/recipes"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              RecipeVersion: {
                location: "querystring",
                locationName: "recipeVersion"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Recipes"
            ],
            members: {
              Recipes: {
                shape: "S5v"
              },
              NextToken: {}
            }
          }
        },
        ListRulesets: {
          http: {
            method: "GET",
            requestUri: "/rulesets"
          },
          input: {
            type: "structure",
            members: {
              TargetArn: {
                location: "querystring",
                locationName: "targetArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Rulesets"
            ],
            members: {
              Rulesets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "TargetArn"
                  ],
                  members: {
                    AccountId: {},
                    CreatedBy: {},
                    CreateDate: {
                      type: "timestamp"
                    },
                    Description: {},
                    LastModifiedBy: {},
                    LastModifiedDate: {
                      type: "timestamp"
                    },
                    Name: {},
                    ResourceArn: {},
                    RuleCount: {
                      type: "integer"
                    },
                    Tags: {
                      shape: "S1m"
                    },
                    TargetArn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSchedules: {
          http: {
            method: "GET",
            requestUri: "/schedules"
          },
          input: {
            type: "structure",
            members: {
              JobName: {
                location: "querystring",
                locationName: "jobName"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Schedules"
            ],
            members: {
              Schedules: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name"
                  ],
                  members: {
                    AccountId: {},
                    CreatedBy: {},
                    CreateDate: {
                      type: "timestamp"
                    },
                    JobNames: {
                      shape: "S41"
                    },
                    LastModifiedBy: {},
                    LastModifiedDate: {
                      type: "timestamp"
                    },
                    ResourceArn: {},
                    CronExpression: {},
                    Tags: {
                      shape: "S1m"
                    },
                    Name: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{ResourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S1m"
              }
            }
          }
        },
        PublishRecipe: {
          http: {
            requestUri: "/recipes/{name}/publishRecipe"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Description: {},
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        SendProjectSessionAction: {
          http: {
            method: "PUT",
            requestUri: "/projects/{name}/sendProjectSessionAction"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Preview: {
                type: "boolean"
              },
              Name: {
                location: "uri",
                locationName: "name"
              },
              RecipeStep: {
                shape: "S2x"
              },
              StepIndex: {
                type: "integer"
              },
              ClientSessionId: {
                shape: "S6f"
              },
              ViewFrame: {
                type: "structure",
                required: [
                  "StartColumnIndex"
                ],
                members: {
                  StartColumnIndex: {
                    type: "integer"
                  },
                  ColumnRange: {
                    type: "integer"
                  },
                  HiddenColumns: {
                    type: "list",
                    member: {}
                  },
                  StartRowIndex: {
                    type: "integer"
                  },
                  RowRange: {
                    type: "integer"
                  },
                  Analytics: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Result: {},
              Name: {},
              ActionId: {
                type: "integer"
              }
            }
          }
        },
        StartJobRun: {
          http: {
            requestUri: "/jobs/{name}/startJobRun"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "RunId"
            ],
            members: {
              RunId: {}
            }
          }
        },
        StartProjectSession: {
          http: {
            method: "PUT",
            requestUri: "/projects/{name}/startProjectSession"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              AssumeControl: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              ClientSessionId: {
                shape: "S6f"
              }
            }
          }
        },
        StopJobRun: {
          http: {
            requestUri: "/jobs/{name}/jobRun/{runId}/stopJobRun"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "RunId"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              RunId: {
                location: "uri",
                locationName: "runId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "RunId"
            ],
            members: {
              RunId: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{ResourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "S1m"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{ResourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDataset: {
          http: {
            method: "PUT",
            requestUri: "/datasets/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "Input"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              Format: {},
              FormatOptions: {
                shape: "Sd"
              },
              Input: {
                shape: "So"
              },
              PathOptions: {
                shape: "S13"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        UpdateProfileJob: {
          http: {
            method: "PUT",
            requestUri: "/profileJobs/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "OutputLocation",
              "RoleArn"
            ],
            members: {
              Configuration: {
                shape: "S1x"
              },
              EncryptionKeyArn: {},
              EncryptionMode: {},
              Name: {
                location: "uri",
                locationName: "name"
              },
              LogSubscription: {},
              MaxCapacity: {
                type: "integer"
              },
              MaxRetries: {
                type: "integer"
              },
              OutputLocation: {
                shape: "Sp"
              },
              ValidationConfigurations: {
                shape: "S2g"
              },
              RoleArn: {},
              Timeout: {
                type: "integer"
              },
              JobSample: {
                shape: "S2k"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        UpdateProject: {
          http: {
            method: "PUT",
            requestUri: "/projects/{name}"
          },
          input: {
            type: "structure",
            required: [
              "RoleArn",
              "Name"
            ],
            members: {
              Sample: {
                shape: "S2q"
              },
              RoleArn: {},
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              LastModifiedDate: {
                type: "timestamp"
              },
              Name: {}
            }
          }
        },
        UpdateRecipe: {
          http: {
            method: "PUT",
            requestUri: "/recipes/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Description: {},
              Name: {
                location: "uri",
                locationName: "name"
              },
              Steps: {
                shape: "S2w"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        UpdateRecipeJob: {
          http: {
            method: "PUT",
            requestUri: "/recipeJobs/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "RoleArn"
            ],
            members: {
              EncryptionKeyArn: {},
              EncryptionMode: {},
              Name: {
                location: "uri",
                locationName: "name"
              },
              LogSubscription: {},
              MaxCapacity: {
                type: "integer"
              },
              MaxRetries: {
                type: "integer"
              },
              Outputs: {
                shape: "S36"
              },
              DataCatalogOutputs: {
                shape: "S3f"
              },
              DatabaseOutputs: {
                shape: "S3j"
              },
              RoleArn: {},
              Timeout: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        UpdateRuleset: {
          http: {
            method: "PUT",
            requestUri: "/rulesets/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "Rules"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              Description: {},
              Rules: {
                shape: "S3r"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        UpdateSchedule: {
          http: {
            method: "PUT",
            requestUri: "/schedules/{name}"
          },
          input: {
            type: "structure",
            required: [
              "CronExpression",
              "Name"
            ],
            members: {
              JobNames: {
                shape: "S41"
              },
              CronExpression: {},
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        }
      },
      shapes: {
        Sd: {
          type: "structure",
          members: {
            Json: {
              type: "structure",
              members: {
                MultiLine: {
                  type: "boolean"
                }
              }
            },
            Excel: {
              type: "structure",
              members: {
                SheetNames: {
                  type: "list",
                  member: {}
                },
                SheetIndexes: {
                  type: "list",
                  member: {
                    type: "integer"
                  }
                },
                HeaderRow: {
                  type: "boolean"
                }
              }
            },
            Csv: {
              type: "structure",
              members: {
                Delimiter: {},
                HeaderRow: {
                  type: "boolean"
                }
              }
            }
          }
        },
        So: {
          type: "structure",
          members: {
            S3InputDefinition: {
              shape: "Sp"
            },
            DataCatalogInputDefinition: {
              type: "structure",
              required: [
                "DatabaseName",
                "TableName"
              ],
              members: {
                CatalogId: {},
                DatabaseName: {},
                TableName: {},
                TempDirectory: {
                  shape: "Sp"
                }
              }
            },
            DatabaseInputDefinition: {
              type: "structure",
              required: [
                "GlueConnectionName"
              ],
              members: {
                GlueConnectionName: {},
                DatabaseTableName: {},
                TempDirectory: {
                  shape: "Sp"
                },
                QueryString: {}
              }
            },
            Metadata: {
              type: "structure",
              members: {
                SourceArn: {}
              }
            }
          }
        },
        Sp: {
          type: "structure",
          required: [
            "Bucket"
          ],
          members: {
            Bucket: {},
            Key: {},
            BucketOwner: {}
          }
        },
        S13: {
          type: "structure",
          members: {
            LastModifiedDateCondition: {
              shape: "S14"
            },
            FilesLimit: {
              type: "structure",
              required: [
                "MaxFiles"
              ],
              members: {
                MaxFiles: {
                  type: "integer"
                },
                OrderedBy: {},
                Order: {}
              }
            },
            Parameters: {
              type: "map",
              key: {},
              value: {
                type: "structure",
                required: [
                  "Name",
                  "Type"
                ],
                members: {
                  Name: {},
                  Type: {},
                  DatetimeOptions: {
                    type: "structure",
                    required: [
                      "Format"
                    ],
                    members: {
                      Format: {},
                      TimezoneOffset: {},
                      LocaleCode: {}
                    }
                  },
                  CreateColumn: {
                    type: "boolean"
                  },
                  Filter: {
                    shape: "S14"
                  }
                }
              }
            }
          }
        },
        S14: {
          type: "structure",
          required: [
            "Expression",
            "ValuesMap"
          ],
          members: {
            Expression: {},
            ValuesMap: {
              shape: "S16"
            }
          }
        },
        S16: {
          type: "map",
          key: {},
          value: {}
        },
        S1m: {
          type: "map",
          key: {},
          value: {}
        },
        S1x: {
          type: "structure",
          members: {
            DatasetStatisticsConfiguration: {
              shape: "S1y"
            },
            ProfileColumns: {
              shape: "S26"
            },
            ColumnStatisticsConfigurations: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Statistics"
                ],
                members: {
                  Selectors: {
                    shape: "S26"
                  },
                  Statistics: {
                    shape: "S1y"
                  }
                }
              }
            },
            EntityDetectorConfiguration: {
              type: "structure",
              required: [
                "EntityTypes"
              ],
              members: {
                EntityTypes: {
                  type: "list",
                  member: {}
                },
                AllowedStatistics: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "Statistics"
                    ],
                    members: {
                      Statistics: {
                        shape: "S1z"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S1y: {
          type: "structure",
          members: {
            IncludedStatistics: {
              shape: "S1z"
            },
            Overrides: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Statistic",
                  "Parameters"
                ],
                members: {
                  Statistic: {},
                  Parameters: {
                    shape: "S23"
                  }
                }
              }
            }
          }
        },
        S1z: {
          type: "list",
          member: {}
        },
        S23: {
          type: "map",
          key: {},
          value: {}
        },
        S26: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Regex: {},
              Name: {}
            }
          }
        },
        S2g: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "RulesetArn"
            ],
            members: {
              RulesetArn: {},
              ValidationMode: {}
            }
          }
        },
        S2k: {
          type: "structure",
          members: {
            Mode: {},
            Size: {
              type: "long"
            }
          }
        },
        S2q: {
          type: "structure",
          required: [
            "Type"
          ],
          members: {
            Size: {
              type: "integer"
            },
            Type: {}
          }
        },
        S2w: {
          type: "list",
          member: {
            shape: "S2x"
          }
        },
        S2x: {
          type: "structure",
          required: [
            "Action"
          ],
          members: {
            Action: {
              type: "structure",
              required: [
                "Operation"
              ],
              members: {
                Operation: {},
                Parameters: {
                  shape: "S23"
                }
              }
            },
            ConditionExpressions: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Condition",
                  "TargetColumn"
                ],
                members: {
                  Condition: {},
                  Value: {},
                  TargetColumn: {}
                }
              }
            }
          }
        },
        S36: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Location"
            ],
            members: {
              CompressionFormat: {},
              Format: {},
              PartitionColumns: {
                type: "list",
                member: {}
              },
              Location: {
                shape: "Sp"
              },
              Overwrite: {
                type: "boolean"
              },
              FormatOptions: {
                type: "structure",
                members: {
                  Csv: {
                    type: "structure",
                    members: {
                      Delimiter: {}
                    }
                  }
                }
              },
              MaxOutputFiles: {
                type: "integer"
              }
            }
          }
        },
        S3f: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              S3Options: {
                type: "structure",
                required: [
                  "Location"
                ],
                members: {
                  Location: {
                    shape: "Sp"
                  }
                }
              },
              DatabaseOptions: {
                shape: "S3i"
              },
              Overwrite: {
                type: "boolean"
              }
            }
          }
        },
        S3i: {
          type: "structure",
          required: [
            "TableName"
          ],
          members: {
            TempDirectory: {
              shape: "Sp"
            },
            TableName: {}
          }
        },
        S3j: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "GlueConnectionName",
              "DatabaseOptions"
            ],
            members: {
              GlueConnectionName: {},
              DatabaseOptions: {
                shape: "S3i"
              },
              DatabaseOutputMode: {}
            }
          }
        },
        S3m: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            RecipeVersion: {}
          }
        },
        S3r: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "CheckExpression"
            ],
            members: {
              Name: {},
              Disabled: {
                type: "boolean"
              },
              CheckExpression: {},
              SubstitutionMap: {
                shape: "S16"
              },
              Threshold: {
                type: "structure",
                required: [
                  "Value"
                ],
                members: {
                  Value: {
                    type: "double"
                  },
                  Type: {},
                  Unit: {}
                }
              },
              ColumnSelectors: {
                shape: "S26"
              }
            }
          }
        },
        S41: {
          type: "list",
          member: {}
        },
        S5v: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              CreatedBy: {},
              CreateDate: {
                type: "timestamp"
              },
              LastModifiedBy: {},
              LastModifiedDate: {
                type: "timestamp"
              },
              ProjectName: {},
              PublishedBy: {},
              PublishedDate: {
                type: "timestamp"
              },
              Description: {},
              Name: {},
              ResourceArn: {},
              Steps: {
                shape: "S2w"
              },
              Tags: {
                shape: "S1m"
              },
              RecipeVersion: {}
            }
          }
        },
        S6f: {
          type: "string",
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/databrew-2017-07-25.paginators.json
var require_databrew_2017_07_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/databrew-2017-07-25.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListDatasets: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Datasets"
        },
        ListJobRuns: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "JobRuns"
        },
        ListJobs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Jobs"
        },
        ListProjects: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Projects"
        },
        ListRecipeVersions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Recipes"
        },
        ListRecipes: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Recipes"
        },
        ListRulesets: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Rulesets"
        },
        ListSchedules: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Schedules"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/databrew.js
var require_databrew = __commonJS({
  "node_modules/aws-sdk/clients/databrew.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["databrew"] = {};
    AWS2.DataBrew = Service.defineService("databrew", ["2017-07-25"]);
    Object.defineProperty(apiLoader.services["databrew"], "2017-07-25", {
      get: function get() {
        var model = require_databrew_2017_07_25_min();
        model.paginators = require_databrew_2017_07_25_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.DataBrew;
  }
});

// node_modules/aws-sdk/apis/servicecatalog-appregistry-2020-06-24.min.json
var require_servicecatalog_appregistry_2020_06_24_min = __commonJS({
  "node_modules/aws-sdk/apis/servicecatalog-appregistry-2020-06-24.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-06-24",
        endpointPrefix: "servicecatalog-appregistry",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "AppRegistry",
        serviceFullName: "AWS Service Catalog App Registry",
        serviceId: "Service Catalog AppRegistry",
        signatureVersion: "v4",
        signingName: "servicecatalog",
        uid: "AWS242AppRegistry-2020-06-24"
      },
      operations: {
        AssociateAttributeGroup: {
          http: {
            method: "PUT",
            requestUri: "/applications/{application}/attribute-groups/{attributeGroup}"
          },
          input: {
            type: "structure",
            required: [
              "application",
              "attributeGroup"
            ],
            members: {
              application: {
                location: "uri",
                locationName: "application"
              },
              attributeGroup: {
                location: "uri",
                locationName: "attributeGroup"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applicationArn: {},
              attributeGroupArn: {}
            }
          }
        },
        AssociateResource: {
          http: {
            method: "PUT",
            requestUri: "/applications/{application}/resources/{resourceType}/{resource}"
          },
          input: {
            type: "structure",
            required: [
              "application",
              "resourceType",
              "resource"
            ],
            members: {
              application: {
                location: "uri",
                locationName: "application"
              },
              resourceType: {
                location: "uri",
                locationName: "resourceType"
              },
              resource: {
                location: "uri",
                locationName: "resource"
              },
              options: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applicationArn: {},
              resourceArn: {},
              options: {
                shape: "Sa"
              }
            }
          }
        },
        CreateApplication: {
          http: {
            requestUri: "/applications",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "name",
              "clientToken"
            ],
            members: {
              name: {},
              description: {},
              tags: {
                shape: "Sh"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              application: {
                shape: "Sm"
              }
            }
          }
        },
        CreateAttributeGroup: {
          http: {
            requestUri: "/attribute-groups",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "name",
              "attributes",
              "clientToken"
            ],
            members: {
              name: {},
              description: {},
              attributes: {},
              tags: {
                shape: "Sh"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              attributeGroup: {
                shape: "St"
              }
            }
          }
        },
        DeleteApplication: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{application}"
          },
          input: {
            type: "structure",
            required: [
              "application"
            ],
            members: {
              application: {
                location: "uri",
                locationName: "application"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              application: {
                shape: "Sx"
              }
            }
          }
        },
        DeleteAttributeGroup: {
          http: {
            method: "DELETE",
            requestUri: "/attribute-groups/{attributeGroup}"
          },
          input: {
            type: "structure",
            required: [
              "attributeGroup"
            ],
            members: {
              attributeGroup: {
                location: "uri",
                locationName: "attributeGroup"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              attributeGroup: {
                shape: "S10"
              }
            }
          }
        },
        DisassociateAttributeGroup: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{application}/attribute-groups/{attributeGroup}"
          },
          input: {
            type: "structure",
            required: [
              "application",
              "attributeGroup"
            ],
            members: {
              application: {
                location: "uri",
                locationName: "application"
              },
              attributeGroup: {
                location: "uri",
                locationName: "attributeGroup"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applicationArn: {},
              attributeGroupArn: {}
            }
          }
        },
        DisassociateResource: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{application}/resources/{resourceType}/{resource}"
          },
          input: {
            type: "structure",
            required: [
              "application",
              "resourceType",
              "resource"
            ],
            members: {
              application: {
                location: "uri",
                locationName: "application"
              },
              resourceType: {
                location: "uri",
                locationName: "resourceType"
              },
              resource: {
                location: "uri",
                locationName: "resource"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applicationArn: {},
              resourceArn: {}
            }
          }
        },
        GetApplication: {
          http: {
            method: "GET",
            requestUri: "/applications/{application}"
          },
          input: {
            type: "structure",
            required: [
              "application"
            ],
            members: {
              application: {
                location: "uri",
                locationName: "application"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              arn: {},
              name: {},
              description: {},
              creationTime: {
                shape: "So"
              },
              lastUpdateTime: {
                shape: "So"
              },
              associatedResourceCount: {
                type: "integer"
              },
              tags: {
                shape: "Sh"
              },
              integrations: {
                type: "structure",
                members: {
                  resourceGroup: {
                    shape: "S1a"
                  },
                  applicationTagResourceGroup: {
                    shape: "S1a"
                  }
                }
              },
              applicationTag: {
                shape: "Sp"
              }
            }
          }
        },
        GetAssociatedResource: {
          http: {
            method: "GET",
            requestUri: "/applications/{application}/resources/{resourceType}/{resource}"
          },
          input: {
            type: "structure",
            required: [
              "application",
              "resourceType",
              "resource"
            ],
            members: {
              application: {
                location: "uri",
                locationName: "application"
              },
              resourceType: {
                location: "uri",
                locationName: "resourceType"
              },
              resource: {
                location: "uri",
                locationName: "resource"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              resourceTagStatus: {
                location: "querystring",
                locationName: "resourceTagStatus",
                type: "list",
                member: {}
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resource: {
                type: "structure",
                members: {
                  name: {},
                  arn: {},
                  associationTime: {
                    shape: "So"
                  },
                  integrations: {
                    type: "structure",
                    members: {
                      resourceGroup: {
                        shape: "S1a"
                      }
                    }
                  }
                }
              },
              options: {
                shape: "Sa"
              },
              applicationTagResult: {
                type: "structure",
                members: {
                  applicationTagStatus: {},
                  errorMessage: {},
                  resources: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        resourceArn: {},
                        errorMessage: {},
                        status: {},
                        resourceType: {}
                      }
                    }
                  },
                  nextToken: {}
                }
              }
            }
          },
          idempotent: true
        },
        GetAttributeGroup: {
          http: {
            method: "GET",
            requestUri: "/attribute-groups/{attributeGroup}"
          },
          input: {
            type: "structure",
            required: [
              "attributeGroup"
            ],
            members: {
              attributeGroup: {
                location: "uri",
                locationName: "attributeGroup"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              arn: {},
              name: {},
              description: {},
              attributes: {},
              creationTime: {
                shape: "So"
              },
              lastUpdateTime: {
                shape: "So"
              },
              tags: {
                shape: "Sh"
              },
              createdBy: {}
            }
          }
        },
        GetConfiguration: {
          http: {
            method: "GET",
            requestUri: "/configuration"
          },
          output: {
            type: "structure",
            members: {
              configuration: {
                shape: "S1u"
              }
            }
          }
        },
        ListApplications: {
          http: {
            method: "GET",
            requestUri: "/applications"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applications: {
                type: "list",
                member: {
                  shape: "Sx"
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListAssociatedAttributeGroups: {
          http: {
            method: "GET",
            requestUri: "/applications/{application}/attribute-groups"
          },
          input: {
            type: "structure",
            required: [
              "application"
            ],
            members: {
              application: {
                location: "uri",
                locationName: "application"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              attributeGroups: {
                type: "list",
                member: {}
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListAssociatedResources: {
          http: {
            method: "GET",
            requestUri: "/applications/{application}/resources"
          },
          input: {
            type: "structure",
            required: [
              "application"
            ],
            members: {
              application: {
                location: "uri",
                locationName: "application"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    arn: {},
                    resourceType: {},
                    resourceDetails: {
                      type: "structure",
                      members: {
                        tagValue: {}
                      }
                    },
                    options: {
                      shape: "Sa"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListAttributeGroups: {
          http: {
            method: "GET",
            requestUri: "/attribute-groups"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              attributeGroups: {
                type: "list",
                member: {
                  shape: "S10"
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListAttributeGroupsForApplication: {
          http: {
            method: "GET",
            requestUri: "/applications/{application}/attribute-group-details"
          },
          input: {
            type: "structure",
            required: [
              "application"
            ],
            members: {
              application: {
                location: "uri",
                locationName: "application"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              attributeGroupsDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    arn: {},
                    name: {},
                    createdBy: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sh"
              }
            }
          }
        },
        PutConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/configuration"
          },
          input: {
            type: "structure",
            required: [
              "configuration"
            ],
            members: {
              configuration: {
                shape: "S1u"
              }
            }
          }
        },
        SyncResource: {
          http: {
            requestUri: "/sync/{resourceType}/{resource}"
          },
          input: {
            type: "structure",
            required: [
              "resourceType",
              "resource"
            ],
            members: {
              resourceType: {
                location: "uri",
                locationName: "resourceType"
              },
              resource: {
                location: "uri",
                locationName: "resource"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applicationArn: {},
              resourceArn: {},
              actionTaken: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sh"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateApplication: {
          http: {
            method: "PATCH",
            requestUri: "/applications/{application}"
          },
          input: {
            type: "structure",
            required: [
              "application"
            ],
            members: {
              application: {
                location: "uri",
                locationName: "application"
              },
              name: {
                deprecated: true,
                deprecatedMessage: "Name update for application is deprecated."
              },
              description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              application: {
                shape: "Sm"
              }
            }
          }
        },
        UpdateAttributeGroup: {
          http: {
            method: "PATCH",
            requestUri: "/attribute-groups/{attributeGroup}"
          },
          input: {
            type: "structure",
            required: [
              "attributeGroup"
            ],
            members: {
              attributeGroup: {
                location: "uri",
                locationName: "attributeGroup"
              },
              name: {
                deprecated: true,
                deprecatedMessage: "Name update for attribute group is deprecated."
              },
              description: {},
              attributes: {}
            }
          },
          output: {
            type: "structure",
            members: {
              attributeGroup: {
                shape: "St"
              }
            }
          }
        }
      },
      shapes: {
        Sa: {
          type: "list",
          member: {}
        },
        Sh: {
          type: "map",
          key: {},
          value: {}
        },
        Sm: {
          type: "structure",
          members: {
            id: {},
            arn: {},
            name: {},
            description: {},
            creationTime: {
              shape: "So"
            },
            lastUpdateTime: {
              shape: "So"
            },
            tags: {
              shape: "Sh"
            },
            applicationTag: {
              shape: "Sp"
            }
          }
        },
        So: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        Sp: {
          type: "map",
          key: {},
          value: {}
        },
        St: {
          type: "structure",
          members: {
            id: {},
            arn: {},
            name: {},
            description: {},
            creationTime: {
              shape: "So"
            },
            lastUpdateTime: {
              shape: "So"
            },
            tags: {
              shape: "Sh"
            }
          }
        },
        Sx: {
          type: "structure",
          members: {
            id: {},
            arn: {},
            name: {},
            description: {},
            creationTime: {
              shape: "So"
            },
            lastUpdateTime: {
              shape: "So"
            }
          }
        },
        S10: {
          type: "structure",
          members: {
            id: {},
            arn: {},
            name: {},
            description: {},
            creationTime: {
              shape: "So"
            },
            lastUpdateTime: {
              shape: "So"
            },
            createdBy: {}
          }
        },
        S1a: {
          type: "structure",
          members: {
            state: {},
            arn: {},
            errorMessage: {}
          }
        },
        S1u: {
          type: "structure",
          members: {
            tagQueryConfiguration: {
              type: "structure",
              members: {
                tagKey: {}
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/servicecatalog-appregistry-2020-06-24.paginators.json
var require_servicecatalog_appregistry_2020_06_24_paginators = __commonJS({
  "node_modules/aws-sdk/apis/servicecatalog-appregistry-2020-06-24.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListApplications: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "applications"
        },
        ListAssociatedAttributeGroups: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "attributeGroups"
        },
        ListAssociatedResources: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "resources"
        },
        ListAttributeGroups: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "attributeGroups"
        },
        ListAttributeGroupsForApplication: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "attributeGroupsDetails"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/servicecatalogappregistry.js
var require_servicecatalogappregistry = __commonJS({
  "node_modules/aws-sdk/clients/servicecatalogappregistry.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["servicecatalogappregistry"] = {};
    AWS2.ServiceCatalogAppRegistry = Service.defineService("servicecatalogappregistry", ["2020-06-24"]);
    Object.defineProperty(apiLoader.services["servicecatalogappregistry"], "2020-06-24", {
      get: function get() {
        var model = require_servicecatalog_appregistry_2020_06_24_min();
        model.paginators = require_servicecatalog_appregistry_2020_06_24_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ServiceCatalogAppRegistry;
  }
});

// node_modules/aws-sdk/apis/network-firewall-2020-11-12.min.json
var require_network_firewall_2020_11_12_min = __commonJS({
  "node_modules/aws-sdk/apis/network-firewall-2020-11-12.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-11-12",
        endpointPrefix: "network-firewall",
        jsonVersion: "1.0",
        protocol: "json",
        serviceAbbreviation: "Network Firewall",
        serviceFullName: "AWS Network Firewall",
        serviceId: "Network Firewall",
        signatureVersion: "v4",
        signingName: "network-firewall",
        targetPrefix: "NetworkFirewall_20201112",
        uid: "network-firewall-2020-11-12"
      },
      operations: {
        AssociateFirewallPolicy: {
          input: {
            type: "structure",
            required: [
              "FirewallPolicyArn"
            ],
            members: {
              UpdateToken: {},
              FirewallArn: {},
              FirewallName: {},
              FirewallPolicyArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallArn: {},
              FirewallName: {},
              FirewallPolicyArn: {},
              UpdateToken: {}
            }
          }
        },
        AssociateSubnets: {
          input: {
            type: "structure",
            required: [
              "SubnetMappings"
            ],
            members: {
              UpdateToken: {},
              FirewallArn: {},
              FirewallName: {},
              SubnetMappings: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallArn: {},
              FirewallName: {},
              SubnetMappings: {
                shape: "S7"
              },
              UpdateToken: {}
            }
          }
        },
        CreateFirewall: {
          input: {
            type: "structure",
            required: [
              "FirewallName",
              "FirewallPolicyArn",
              "VpcId",
              "SubnetMappings"
            ],
            members: {
              FirewallName: {},
              FirewallPolicyArn: {},
              VpcId: {},
              SubnetMappings: {
                shape: "S7"
              },
              DeleteProtection: {
                type: "boolean"
              },
              SubnetChangeProtection: {
                type: "boolean"
              },
              FirewallPolicyChangeProtection: {
                type: "boolean"
              },
              Description: {},
              Tags: {
                shape: "Sg"
              },
              EncryptionConfiguration: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Firewall: {
                shape: "So"
              },
              FirewallStatus: {
                shape: "Sq"
              }
            }
          }
        },
        CreateFirewallPolicy: {
          input: {
            type: "structure",
            required: [
              "FirewallPolicyName",
              "FirewallPolicy"
            ],
            members: {
              FirewallPolicyName: {},
              FirewallPolicy: {
                shape: "S1b"
              },
              Description: {},
              Tags: {
                shape: "Sg"
              },
              DryRun: {
                type: "boolean"
              },
              EncryptionConfiguration: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UpdateToken",
              "FirewallPolicyResponse"
            ],
            members: {
              UpdateToken: {},
              FirewallPolicyResponse: {
                shape: "S23"
              }
            }
          }
        },
        CreateRuleGroup: {
          input: {
            type: "structure",
            required: [
              "RuleGroupName",
              "Type",
              "Capacity"
            ],
            members: {
              RuleGroupName: {},
              RuleGroup: {
                shape: "S29"
              },
              Rules: {},
              Type: {},
              Description: {},
              Capacity: {
                type: "integer"
              },
              Tags: {
                shape: "Sg"
              },
              DryRun: {
                type: "boolean"
              },
              EncryptionConfiguration: {
                shape: "Sk"
              },
              SourceMetadata: {
                shape: "S3l"
              },
              AnalyzeRuleGroup: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UpdateToken",
              "RuleGroupResponse"
            ],
            members: {
              UpdateToken: {},
              RuleGroupResponse: {
                shape: "S3n"
              }
            }
          }
        },
        CreateTLSInspectionConfiguration: {
          input: {
            type: "structure",
            required: [
              "TLSInspectionConfigurationName",
              "TLSInspectionConfiguration"
            ],
            members: {
              TLSInspectionConfigurationName: {},
              TLSInspectionConfiguration: {
                shape: "S3t"
              },
              Description: {},
              Tags: {
                shape: "Sg"
              },
              EncryptionConfiguration: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UpdateToken",
              "TLSInspectionConfigurationResponse"
            ],
            members: {
              UpdateToken: {},
              TLSInspectionConfigurationResponse: {
                shape: "S43"
              }
            }
          }
        },
        DeleteFirewall: {
          input: {
            type: "structure",
            members: {
              FirewallName: {},
              FirewallArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Firewall: {
                shape: "So"
              },
              FirewallStatus: {
                shape: "Sq"
              }
            }
          }
        },
        DeleteFirewallPolicy: {
          input: {
            type: "structure",
            members: {
              FirewallPolicyName: {},
              FirewallPolicyArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "FirewallPolicyResponse"
            ],
            members: {
              FirewallPolicyResponse: {
                shape: "S23"
              }
            }
          }
        },
        DeleteResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRuleGroup: {
          input: {
            type: "structure",
            members: {
              RuleGroupName: {},
              RuleGroupArn: {},
              Type: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "RuleGroupResponse"
            ],
            members: {
              RuleGroupResponse: {
                shape: "S3n"
              }
            }
          }
        },
        DeleteTLSInspectionConfiguration: {
          input: {
            type: "structure",
            members: {
              TLSInspectionConfigurationArn: {},
              TLSInspectionConfigurationName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "TLSInspectionConfigurationResponse"
            ],
            members: {
              TLSInspectionConfigurationResponse: {
                shape: "S43"
              }
            }
          }
        },
        DescribeFirewall: {
          input: {
            type: "structure",
            members: {
              FirewallName: {},
              FirewallArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UpdateToken: {},
              Firewall: {
                shape: "So"
              },
              FirewallStatus: {
                shape: "Sq"
              }
            }
          }
        },
        DescribeFirewallPolicy: {
          input: {
            type: "structure",
            members: {
              FirewallPolicyName: {},
              FirewallPolicyArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "UpdateToken",
              "FirewallPolicyResponse"
            ],
            members: {
              UpdateToken: {},
              FirewallPolicyResponse: {
                shape: "S23"
              },
              FirewallPolicy: {
                shape: "S1b"
              }
            }
          }
        },
        DescribeLoggingConfiguration: {
          input: {
            type: "structure",
            members: {
              FirewallArn: {},
              FirewallName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallArn: {},
              LoggingConfiguration: {
                shape: "S4n"
              }
            }
          }
        },
        DescribeResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {}
            }
          }
        },
        DescribeRuleGroup: {
          input: {
            type: "structure",
            members: {
              RuleGroupName: {},
              RuleGroupArn: {},
              Type: {},
              AnalyzeRuleGroup: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UpdateToken",
              "RuleGroupResponse"
            ],
            members: {
              UpdateToken: {},
              RuleGroup: {
                shape: "S29"
              },
              RuleGroupResponse: {
                shape: "S3n"
              }
            }
          }
        },
        DescribeRuleGroupMetadata: {
          input: {
            type: "structure",
            members: {
              RuleGroupName: {},
              RuleGroupArn: {},
              Type: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "RuleGroupArn",
              "RuleGroupName"
            ],
            members: {
              RuleGroupArn: {},
              RuleGroupName: {},
              Description: {},
              Type: {},
              Capacity: {
                type: "integer"
              },
              StatefulRuleOptions: {
                shape: "S3j"
              },
              LastModifiedTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeTLSInspectionConfiguration: {
          input: {
            type: "structure",
            members: {
              TLSInspectionConfigurationArn: {},
              TLSInspectionConfigurationName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "UpdateToken",
              "TLSInspectionConfigurationResponse"
            ],
            members: {
              UpdateToken: {},
              TLSInspectionConfiguration: {
                shape: "S3t"
              },
              TLSInspectionConfigurationResponse: {
                shape: "S43"
              }
            }
          }
        },
        DisassociateSubnets: {
          input: {
            type: "structure",
            required: [
              "SubnetIds"
            ],
            members: {
              UpdateToken: {},
              FirewallArn: {},
              FirewallName: {},
              SubnetIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallArn: {},
              FirewallName: {},
              SubnetMappings: {
                shape: "S7"
              },
              UpdateToken: {}
            }
          }
        },
        ListFirewallPolicies: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              FirewallPolicies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Arn: {}
                  }
                }
              }
            }
          }
        },
        ListFirewalls: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              VpcIds: {
                type: "list",
                member: {}
              },
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Firewalls: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FirewallName: {},
                    FirewallArn: {}
                  }
                }
              }
            }
          }
        },
        ListRuleGroups: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Scope: {},
              ManagedType: {},
              Type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              RuleGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Arn: {}
                  }
                }
              }
            }
          }
        },
        ListTLSInspectionConfigurations: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              TLSInspectionConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Arn: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Tags: {
                shape: "Sg"
              }
            }
          }
        },
        PutResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Policy"
            ],
            members: {
              ResourceArn: {},
              Policy: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateFirewallDeleteProtection: {
          input: {
            type: "structure",
            required: [
              "DeleteProtection"
            ],
            members: {
              UpdateToken: {},
              FirewallArn: {},
              FirewallName: {},
              DeleteProtection: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallArn: {},
              FirewallName: {},
              DeleteProtection: {
                type: "boolean"
              },
              UpdateToken: {}
            }
          }
        },
        UpdateFirewallDescription: {
          input: {
            type: "structure",
            members: {
              UpdateToken: {},
              FirewallArn: {},
              FirewallName: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallArn: {},
              FirewallName: {},
              Description: {},
              UpdateToken: {}
            }
          }
        },
        UpdateFirewallEncryptionConfiguration: {
          input: {
            type: "structure",
            members: {
              UpdateToken: {},
              FirewallArn: {},
              FirewallName: {},
              EncryptionConfiguration: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallArn: {},
              FirewallName: {},
              UpdateToken: {},
              EncryptionConfiguration: {
                shape: "Sk"
              }
            }
          }
        },
        UpdateFirewallPolicy: {
          input: {
            type: "structure",
            required: [
              "UpdateToken",
              "FirewallPolicy"
            ],
            members: {
              UpdateToken: {},
              FirewallPolicyArn: {},
              FirewallPolicyName: {},
              FirewallPolicy: {
                shape: "S1b"
              },
              Description: {},
              DryRun: {
                type: "boolean"
              },
              EncryptionConfiguration: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UpdateToken",
              "FirewallPolicyResponse"
            ],
            members: {
              UpdateToken: {},
              FirewallPolicyResponse: {
                shape: "S23"
              }
            }
          }
        },
        UpdateFirewallPolicyChangeProtection: {
          input: {
            type: "structure",
            required: [
              "FirewallPolicyChangeProtection"
            ],
            members: {
              UpdateToken: {},
              FirewallArn: {},
              FirewallName: {},
              FirewallPolicyChangeProtection: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UpdateToken: {},
              FirewallArn: {},
              FirewallName: {},
              FirewallPolicyChangeProtection: {
                type: "boolean"
              }
            }
          }
        },
        UpdateLoggingConfiguration: {
          input: {
            type: "structure",
            members: {
              FirewallArn: {},
              FirewallName: {},
              LoggingConfiguration: {
                shape: "S4n"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallArn: {},
              FirewallName: {},
              LoggingConfiguration: {
                shape: "S4n"
              }
            }
          }
        },
        UpdateRuleGroup: {
          input: {
            type: "structure",
            required: [
              "UpdateToken"
            ],
            members: {
              UpdateToken: {},
              RuleGroupArn: {},
              RuleGroupName: {},
              RuleGroup: {
                shape: "S29"
              },
              Rules: {},
              Type: {},
              Description: {},
              DryRun: {
                type: "boolean"
              },
              EncryptionConfiguration: {
                shape: "Sk"
              },
              SourceMetadata: {
                shape: "S3l"
              },
              AnalyzeRuleGroup: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UpdateToken",
              "RuleGroupResponse"
            ],
            members: {
              UpdateToken: {},
              RuleGroupResponse: {
                shape: "S3n"
              }
            }
          }
        },
        UpdateSubnetChangeProtection: {
          input: {
            type: "structure",
            required: [
              "SubnetChangeProtection"
            ],
            members: {
              UpdateToken: {},
              FirewallArn: {},
              FirewallName: {},
              SubnetChangeProtection: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UpdateToken: {},
              FirewallArn: {},
              FirewallName: {},
              SubnetChangeProtection: {
                type: "boolean"
              }
            }
          }
        },
        UpdateTLSInspectionConfiguration: {
          input: {
            type: "structure",
            required: [
              "TLSInspectionConfiguration",
              "UpdateToken"
            ],
            members: {
              TLSInspectionConfigurationArn: {},
              TLSInspectionConfigurationName: {},
              TLSInspectionConfiguration: {
                shape: "S3t"
              },
              Description: {},
              EncryptionConfiguration: {
                shape: "Sk"
              },
              UpdateToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "UpdateToken",
              "TLSInspectionConfigurationResponse"
            ],
            members: {
              UpdateToken: {},
              TLSInspectionConfigurationResponse: {
                shape: "S43"
              }
            }
          }
        }
      },
      shapes: {
        S7: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "SubnetId"
            ],
            members: {
              SubnetId: {},
              IPAddressType: {}
            }
          }
        },
        Sg: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sk: {
          type: "structure",
          required: [
            "Type"
          ],
          members: {
            KeyId: {},
            Type: {}
          }
        },
        So: {
          type: "structure",
          required: [
            "FirewallPolicyArn",
            "VpcId",
            "SubnetMappings",
            "FirewallId"
          ],
          members: {
            FirewallName: {},
            FirewallArn: {},
            FirewallPolicyArn: {},
            VpcId: {},
            SubnetMappings: {
              shape: "S7"
            },
            DeleteProtection: {
              type: "boolean"
            },
            SubnetChangeProtection: {
              type: "boolean"
            },
            FirewallPolicyChangeProtection: {
              type: "boolean"
            },
            Description: {},
            FirewallId: {},
            Tags: {
              shape: "Sg"
            },
            EncryptionConfiguration: {
              shape: "Sk"
            }
          }
        },
        Sq: {
          type: "structure",
          required: [
            "Status",
            "ConfigurationSyncStateSummary"
          ],
          members: {
            Status: {},
            ConfigurationSyncStateSummary: {},
            SyncStates: {
              type: "map",
              key: {},
              value: {
                type: "structure",
                members: {
                  Attachment: {
                    type: "structure",
                    members: {
                      SubnetId: {},
                      EndpointId: {},
                      Status: {},
                      StatusMessage: {}
                    }
                  },
                  Config: {
                    type: "map",
                    key: {},
                    value: {
                      type: "structure",
                      members: {
                        SyncStatus: {},
                        UpdateToken: {}
                      }
                    }
                  }
                }
              }
            },
            CapacityUsageSummary: {
              type: "structure",
              members: {
                CIDRs: {
                  type: "structure",
                  members: {
                    AvailableCIDRCount: {
                      type: "integer"
                    },
                    UtilizedCIDRCount: {
                      type: "integer"
                    },
                    IPSetReferences: {
                      type: "map",
                      key: {},
                      value: {
                        type: "structure",
                        members: {
                          ResolvedCIDRCount: {
                            type: "integer"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S1b: {
          type: "structure",
          required: [
            "StatelessDefaultActions",
            "StatelessFragmentDefaultActions"
          ],
          members: {
            StatelessRuleGroupReferences: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "ResourceArn",
                  "Priority"
                ],
                members: {
                  ResourceArn: {},
                  Priority: {
                    type: "integer"
                  }
                }
              }
            },
            StatelessDefaultActions: {
              shape: "S1f"
            },
            StatelessFragmentDefaultActions: {
              shape: "S1f"
            },
            StatelessCustomActions: {
              shape: "S1g"
            },
            StatefulRuleGroupReferences: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "ResourceArn"
                ],
                members: {
                  ResourceArn: {},
                  Priority: {
                    type: "integer"
                  },
                  Override: {
                    type: "structure",
                    members: {
                      Action: {}
                    }
                  }
                }
              }
            },
            StatefulDefaultActions: {
              type: "list",
              member: {}
            },
            StatefulEngineOptions: {
              type: "structure",
              members: {
                RuleOrder: {},
                StreamExceptionPolicy: {}
              }
            },
            TLSInspectionConfigurationArn: {},
            PolicyVariables: {
              type: "structure",
              members: {
                RuleVariables: {
                  shape: "S1x"
                }
              }
            }
          }
        },
        S1f: {
          type: "list",
          member: {}
        },
        S1g: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ActionName",
              "ActionDefinition"
            ],
            members: {
              ActionName: {},
              ActionDefinition: {
                type: "structure",
                members: {
                  PublishMetricAction: {
                    type: "structure",
                    required: [
                      "Dimensions"
                    ],
                    members: {
                      Dimensions: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "Value"
                          ],
                          members: {
                            Value: {}
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S1x: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "Definition"
            ],
            members: {
              Definition: {
                shape: "S20"
              }
            }
          }
        },
        S20: {
          type: "list",
          member: {}
        },
        S23: {
          type: "structure",
          required: [
            "FirewallPolicyName",
            "FirewallPolicyArn",
            "FirewallPolicyId"
          ],
          members: {
            FirewallPolicyName: {},
            FirewallPolicyArn: {},
            FirewallPolicyId: {},
            Description: {},
            FirewallPolicyStatus: {},
            Tags: {
              shape: "Sg"
            },
            ConsumedStatelessRuleCapacity: {
              type: "integer"
            },
            ConsumedStatefulRuleCapacity: {
              type: "integer"
            },
            NumberOfAssociations: {
              type: "integer"
            },
            EncryptionConfiguration: {
              shape: "Sk"
            },
            LastModifiedTime: {
              type: "timestamp"
            }
          }
        },
        S29: {
          type: "structure",
          required: [
            "RulesSource"
          ],
          members: {
            RuleVariables: {
              type: "structure",
              members: {
                IPSets: {
                  shape: "S1x"
                },
                PortSets: {
                  type: "map",
                  key: {},
                  value: {
                    type: "structure",
                    members: {
                      Definition: {
                        shape: "S20"
                      }
                    }
                  }
                }
              }
            },
            ReferenceSets: {
              type: "structure",
              members: {
                IPSetReferences: {
                  type: "map",
                  key: {},
                  value: {
                    type: "structure",
                    members: {
                      ReferenceArn: {}
                    }
                  }
                }
              }
            },
            RulesSource: {
              type: "structure",
              members: {
                RulesString: {},
                RulesSourceList: {
                  type: "structure",
                  required: [
                    "Targets",
                    "TargetTypes",
                    "GeneratedRulesType"
                  ],
                  members: {
                    Targets: {
                      type: "list",
                      member: {}
                    },
                    TargetTypes: {
                      type: "list",
                      member: {}
                    },
                    GeneratedRulesType: {}
                  }
                },
                StatefulRules: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "Action",
                      "Header",
                      "RuleOptions"
                    ],
                    members: {
                      Action: {},
                      Header: {
                        type: "structure",
                        required: [
                          "Protocol",
                          "Source",
                          "SourcePort",
                          "Direction",
                          "Destination",
                          "DestinationPort"
                        ],
                        members: {
                          Protocol: {},
                          Source: {},
                          SourcePort: {},
                          Direction: {},
                          Destination: {},
                          DestinationPort: {}
                        }
                      },
                      RuleOptions: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "Keyword"
                          ],
                          members: {
                            Keyword: {},
                            Settings: {
                              type: "list",
                              member: {}
                            }
                          }
                        }
                      }
                    }
                  }
                },
                StatelessRulesAndCustomActions: {
                  type: "structure",
                  required: [
                    "StatelessRules"
                  ],
                  members: {
                    StatelessRules: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "RuleDefinition",
                          "Priority"
                        ],
                        members: {
                          RuleDefinition: {
                            type: "structure",
                            required: [
                              "MatchAttributes",
                              "Actions"
                            ],
                            members: {
                              MatchAttributes: {
                                type: "structure",
                                members: {
                                  Sources: {
                                    shape: "S37"
                                  },
                                  Destinations: {
                                    shape: "S37"
                                  },
                                  SourcePorts: {
                                    shape: "S3a"
                                  },
                                  DestinationPorts: {
                                    shape: "S3a"
                                  },
                                  Protocols: {
                                    shape: "S3d"
                                  },
                                  TCPFlags: {
                                    type: "list",
                                    member: {
                                      type: "structure",
                                      required: [
                                        "Flags"
                                      ],
                                      members: {
                                        Flags: {
                                          shape: "S3h"
                                        },
                                        Masks: {
                                          shape: "S3h"
                                        }
                                      }
                                    }
                                  }
                                }
                              },
                              Actions: {
                                shape: "S1f"
                              }
                            }
                          },
                          Priority: {
                            type: "integer"
                          }
                        }
                      }
                    },
                    CustomActions: {
                      shape: "S1g"
                    }
                  }
                }
              }
            },
            StatefulRuleOptions: {
              shape: "S3j"
            }
          }
        },
        S37: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AddressDefinition"
            ],
            members: {
              AddressDefinition: {}
            }
          }
        },
        S3a: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "FromPort",
              "ToPort"
            ],
            members: {
              FromPort: {
                type: "integer"
              },
              ToPort: {
                type: "integer"
              }
            }
          }
        },
        S3d: {
          type: "list",
          member: {
            type: "integer"
          }
        },
        S3h: {
          type: "list",
          member: {}
        },
        S3j: {
          type: "structure",
          members: {
            RuleOrder: {}
          }
        },
        S3l: {
          type: "structure",
          members: {
            SourceArn: {},
            SourceUpdateToken: {}
          }
        },
        S3n: {
          type: "structure",
          required: [
            "RuleGroupArn",
            "RuleGroupName",
            "RuleGroupId"
          ],
          members: {
            RuleGroupArn: {},
            RuleGroupName: {},
            RuleGroupId: {},
            Description: {},
            Type: {},
            Capacity: {
              type: "integer"
            },
            RuleGroupStatus: {},
            Tags: {
              shape: "Sg"
            },
            ConsumedCapacity: {
              type: "integer"
            },
            NumberOfAssociations: {
              type: "integer"
            },
            EncryptionConfiguration: {
              shape: "Sk"
            },
            SourceMetadata: {
              shape: "S3l"
            },
            SnsTopic: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            AnalysisResults: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  IdentifiedRuleIds: {
                    type: "list",
                    member: {}
                  },
                  IdentifiedType: {},
                  AnalysisDetail: {}
                }
              }
            }
          }
        },
        S3t: {
          type: "structure",
          members: {
            ServerCertificateConfigurations: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  ServerCertificates: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        ResourceArn: {}
                      }
                    }
                  },
                  Scopes: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Sources: {
                          shape: "S37"
                        },
                        Destinations: {
                          shape: "S37"
                        },
                        SourcePorts: {
                          shape: "S3a"
                        },
                        DestinationPorts: {
                          shape: "S3a"
                        },
                        Protocols: {
                          shape: "S3d"
                        }
                      }
                    }
                  },
                  CertificateAuthorityArn: {},
                  CheckCertificateRevocationStatus: {
                    type: "structure",
                    members: {
                      RevokedStatusAction: {},
                      UnknownStatusAction: {}
                    }
                  }
                }
              }
            }
          }
        },
        S43: {
          type: "structure",
          required: [
            "TLSInspectionConfigurationArn",
            "TLSInspectionConfigurationName",
            "TLSInspectionConfigurationId"
          ],
          members: {
            TLSInspectionConfigurationArn: {},
            TLSInspectionConfigurationName: {},
            TLSInspectionConfigurationId: {},
            TLSInspectionConfigurationStatus: {},
            Description: {},
            Tags: {
              shape: "Sg"
            },
            LastModifiedTime: {
              type: "timestamp"
            },
            NumberOfAssociations: {
              type: "integer"
            },
            EncryptionConfiguration: {
              shape: "Sk"
            },
            Certificates: {
              type: "list",
              member: {
                shape: "S45"
              }
            },
            CertificateAuthority: {
              shape: "S45"
            }
          }
        },
        S45: {
          type: "structure",
          members: {
            CertificateArn: {},
            CertificateSerial: {},
            Status: {},
            StatusMessage: {}
          }
        },
        S4n: {
          type: "structure",
          required: [
            "LogDestinationConfigs"
          ],
          members: {
            LogDestinationConfigs: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "LogType",
                  "LogDestinationType",
                  "LogDestination"
                ],
                members: {
                  LogType: {},
                  LogDestinationType: {},
                  LogDestination: {
                    type: "map",
                    key: {},
                    value: {}
                  }
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/network-firewall-2020-11-12.paginators.json
var require_network_firewall_2020_11_12_paginators = __commonJS({
  "node_modules/aws-sdk/apis/network-firewall-2020-11-12.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListFirewallPolicies: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "FirewallPolicies"
        },
        ListFirewalls: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Firewalls"
        },
        ListRuleGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "RuleGroups"
        },
        ListTLSInspectionConfigurations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "TLSInspectionConfigurations"
        },
        ListTagsForResource: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Tags"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/networkfirewall.js
var require_networkfirewall = __commonJS({
  "node_modules/aws-sdk/clients/networkfirewall.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["networkfirewall"] = {};
    AWS2.NetworkFirewall = Service.defineService("networkfirewall", ["2020-11-12"]);
    Object.defineProperty(apiLoader.services["networkfirewall"], "2020-11-12", {
      get: function get() {
        var model = require_network_firewall_2020_11_12_min();
        model.paginators = require_network_firewall_2020_11_12_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.NetworkFirewall;
  }
});

// node_modules/aws-sdk/apis/mwaa-2020-07-01.min.json
var require_mwaa_2020_07_01_min = __commonJS({
  "node_modules/aws-sdk/apis/mwaa-2020-07-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-07-01",
        endpointPrefix: "airflow",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AmazonMWAA",
        serviceId: "MWAA",
        signatureVersion: "v4",
        signingName: "airflow",
        uid: "mwaa-2020-07-01"
      },
      operations: {
        CreateCliToken: {
          http: {
            requestUri: "/clitoken/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CliToken: {
                shape: "S4"
              },
              WebServerHostname: {}
            }
          },
          endpoint: {
            hostPrefix: "env."
          }
        },
        CreateEnvironment: {
          http: {
            method: "PUT",
            requestUri: "/environments/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DagS3Path",
              "ExecutionRoleArn",
              "Name",
              "NetworkConfiguration",
              "SourceBucketArn"
            ],
            members: {
              AirflowConfigurationOptions: {
                shape: "S7"
              },
              AirflowVersion: {},
              DagS3Path: {},
              EndpointManagement: {},
              EnvironmentClass: {},
              ExecutionRoleArn: {},
              KmsKey: {},
              LoggingConfiguration: {
                shape: "Sg"
              },
              MaxWorkers: {
                type: "integer"
              },
              MinWorkers: {
                type: "integer"
              },
              Name: {
                location: "uri",
                locationName: "Name"
              },
              NetworkConfiguration: {
                shape: "Sm"
              },
              PluginsS3ObjectVersion: {},
              PluginsS3Path: {},
              RequirementsS3ObjectVersion: {},
              RequirementsS3Path: {},
              Schedulers: {
                type: "integer"
              },
              SourceBucketArn: {},
              StartupScriptS3ObjectVersion: {},
              StartupScriptS3Path: {},
              Tags: {
                shape: "Su"
              },
              WebserverAccessMode: {},
              WeeklyMaintenanceWindowStart: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          },
          idempotent: true
        },
        CreateWebLoginToken: {
          http: {
            requestUri: "/webtoken/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WebServerHostname: {},
              WebToken: {
                shape: "S4"
              }
            }
          },
          endpoint: {
            hostPrefix: "env."
          },
          idempotent: true
        },
        DeleteEnvironment: {
          http: {
            method: "DELETE",
            requestUri: "/environments/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "api."
          },
          idempotent: true
        },
        GetEnvironment: {
          http: {
            method: "GET",
            requestUri: "/environments/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Environment: {
                type: "structure",
                members: {
                  AirflowConfigurationOptions: {
                    shape: "S7"
                  },
                  AirflowVersion: {},
                  Arn: {},
                  CeleryExecutorQueue: {},
                  CreatedAt: {
                    type: "timestamp"
                  },
                  DagS3Path: {},
                  DatabaseVpcEndpointService: {},
                  EndpointManagement: {},
                  EnvironmentClass: {},
                  ExecutionRoleArn: {},
                  KmsKey: {},
                  LastUpdate: {
                    type: "structure",
                    members: {
                      CreatedAt: {
                        type: "timestamp"
                      },
                      Error: {
                        type: "structure",
                        members: {
                          ErrorCode: {},
                          ErrorMessage: {}
                        }
                      },
                      Source: {},
                      Status: {}
                    }
                  },
                  LoggingConfiguration: {
                    type: "structure",
                    members: {
                      DagProcessingLogs: {
                        shape: "S1j"
                      },
                      SchedulerLogs: {
                        shape: "S1j"
                      },
                      TaskLogs: {
                        shape: "S1j"
                      },
                      WebserverLogs: {
                        shape: "S1j"
                      },
                      WorkerLogs: {
                        shape: "S1j"
                      }
                    }
                  },
                  MaxWorkers: {
                    type: "integer"
                  },
                  MinWorkers: {
                    type: "integer"
                  },
                  Name: {},
                  NetworkConfiguration: {
                    shape: "Sm"
                  },
                  PluginsS3ObjectVersion: {},
                  PluginsS3Path: {},
                  RequirementsS3ObjectVersion: {},
                  RequirementsS3Path: {},
                  Schedulers: {
                    type: "integer"
                  },
                  ServiceRoleArn: {},
                  SourceBucketArn: {},
                  StartupScriptS3ObjectVersion: {},
                  StartupScriptS3Path: {},
                  Status: {},
                  Tags: {
                    shape: "Su"
                  },
                  WebserverAccessMode: {},
                  WebserverUrl: {},
                  WebserverVpcEndpointService: {},
                  WeeklyMaintenanceWindowStart: {}
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListEnvironments: {
          http: {
            method: "GET",
            requestUri: "/environments",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Environments"
            ],
            members: {
              Environments: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Su"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        PublishMetrics: {
          http: {
            requestUri: "/metrics/environments/{EnvironmentName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "EnvironmentName",
              "MetricData"
            ],
            members: {
              EnvironmentName: {
                location: "uri",
                locationName: "EnvironmentName"
              },
              MetricData: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "MetricName",
                    "Timestamp"
                  ],
                  members: {
                    Dimensions: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "Name",
                          "Value"
                        ],
                        members: {
                          Name: {},
                          Value: {}
                        },
                        deprecated: true,
                        deprecatedMessage: "This type is for internal use and not meant for public use. Data set for this type will be ignored."
                      },
                      deprecated: true,
                      deprecatedMessage: "This type is for internal use and not meant for public use. Data set for this type will be ignored."
                    },
                    MetricName: {},
                    StatisticValues: {
                      type: "structure",
                      members: {
                        Maximum: {
                          type: "double"
                        },
                        Minimum: {
                          type: "double"
                        },
                        SampleCount: {
                          type: "integer"
                        },
                        Sum: {
                          type: "double"
                        }
                      },
                      deprecated: true,
                      deprecatedMessage: "This type is for internal use and not meant for public use. Data set for this type will be ignored."
                    },
                    Timestamp: {
                      type: "timestamp"
                    },
                    Unit: {},
                    Value: {
                      type: "double"
                    }
                  },
                  deprecated: true,
                  deprecatedMessage: "This type is for internal use and not meant for public use. Data set for this type will be ignored."
                },
                deprecated: true,
                deprecatedMessage: "This type is for internal use and not meant for public use. Data set for this type will be ignored."
              }
            },
            deprecated: true,
            deprecatedMessage: "This type is for internal use and not meant for public use. Data set for this type will be ignored."
          },
          output: {
            type: "structure",
            members: {},
            deprecated: true,
            deprecatedMessage: "This type is for internal use and not meant for public use. Data set for this type will be ignored."
          },
          deprecated: true,
          deprecatedMessage: "This API is for internal use and not meant for public use, and is no longer available.",
          endpoint: {
            hostPrefix: "ops."
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "tagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "api."
          },
          idempotent: true
        },
        UpdateEnvironment: {
          http: {
            method: "PATCH",
            requestUri: "/environments/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              AirflowConfigurationOptions: {
                shape: "S7"
              },
              AirflowVersion: {},
              DagS3Path: {},
              EnvironmentClass: {},
              ExecutionRoleArn: {},
              LoggingConfiguration: {
                shape: "Sg"
              },
              MaxWorkers: {
                type: "integer"
              },
              MinWorkers: {
                type: "integer"
              },
              Name: {
                location: "uri",
                locationName: "Name"
              },
              NetworkConfiguration: {
                type: "structure",
                required: [
                  "SecurityGroupIds"
                ],
                members: {
                  SecurityGroupIds: {
                    shape: "Sn"
                  }
                }
              },
              PluginsS3ObjectVersion: {},
              PluginsS3Path: {},
              RequirementsS3ObjectVersion: {},
              RequirementsS3Path: {},
              Schedulers: {
                type: "integer"
              },
              SourceBucketArn: {},
              StartupScriptS3ObjectVersion: {},
              StartupScriptS3Path: {},
              WebserverAccessMode: {},
              WeeklyMaintenanceWindowStart: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        }
      },
      shapes: {
        S4: {
          type: "string",
          sensitive: true
        },
        S7: {
          type: "map",
          key: {},
          value: {
            type: "string",
            sensitive: true
          },
          sensitive: true
        },
        Sg: {
          type: "structure",
          members: {
            DagProcessingLogs: {
              shape: "Sh"
            },
            SchedulerLogs: {
              shape: "Sh"
            },
            TaskLogs: {
              shape: "Sh"
            },
            WebserverLogs: {
              shape: "Sh"
            },
            WorkerLogs: {
              shape: "Sh"
            }
          }
        },
        Sh: {
          type: "structure",
          required: [
            "Enabled",
            "LogLevel"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            LogLevel: {}
          }
        },
        Sm: {
          type: "structure",
          members: {
            SecurityGroupIds: {
              shape: "Sn"
            },
            SubnetIds: {
              type: "list",
              member: {}
            }
          }
        },
        Sn: {
          type: "list",
          member: {}
        },
        Su: {
          type: "map",
          key: {},
          value: {}
        },
        S1j: {
          type: "structure",
          members: {
            CloudWatchLogGroupArn: {},
            Enabled: {
              type: "boolean"
            },
            LogLevel: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/mwaa-2020-07-01.paginators.json
var require_mwaa_2020_07_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/mwaa-2020-07-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListEnvironments: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Environments"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/mwaa.js
var require_mwaa = __commonJS({
  "node_modules/aws-sdk/clients/mwaa.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["mwaa"] = {};
    AWS2.MWAA = Service.defineService("mwaa", ["2020-07-01"]);
    Object.defineProperty(apiLoader.services["mwaa"], "2020-07-01", {
      get: function get() {
        var model = require_mwaa_2020_07_01_min();
        model.paginators = require_mwaa_2020_07_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.MWAA;
  }
});

// node_modules/aws-sdk/apis/amplifybackend-2020-08-11.min.json
var require_amplifybackend_2020_08_11_min = __commonJS({
  "node_modules/aws-sdk/apis/amplifybackend-2020-08-11.min.json"(exports2, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2020-08-11",
        endpointPrefix: "amplifybackend",
        signingName: "amplifybackend",
        serviceFullName: "AmplifyBackend",
        serviceId: "AmplifyBackend",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "amplifybackend-2020-08-11",
        signatureVersion: "v4"
      },
      operations: {
        CloneBackend: {
          http: {
            requestUri: "/backend/{appId}/environments/{backendEnvironmentName}/clone",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              },
              TargetEnvironmentName: {
                locationName: "targetEnvironmentName"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName",
              "TargetEnvironmentName"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              Error: {
                locationName: "error"
              },
              JobId: {
                locationName: "jobId"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        CreateBackend: {
          http: {
            requestUri: "/backend",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              AppName: {
                locationName: "appName"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              ResourceConfig: {
                locationName: "resourceConfig",
                type: "structure",
                members: {}
              },
              ResourceName: {
                locationName: "resourceName"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName",
              "AppName"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              Error: {
                locationName: "error"
              },
              JobId: {
                locationName: "jobId"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        CreateBackendAPI: {
          http: {
            requestUri: "/backend/{appId}/api",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              ResourceConfig: {
                shape: "S8",
                locationName: "resourceConfig"
              },
              ResourceName: {
                locationName: "resourceName"
              }
            },
            required: [
              "AppId",
              "ResourceName",
              "BackendEnvironmentName",
              "ResourceConfig"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              Error: {
                locationName: "error"
              },
              JobId: {
                locationName: "jobId"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        CreateBackendAuth: {
          http: {
            requestUri: "/backend/{appId}/auth",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              ResourceConfig: {
                shape: "Si",
                locationName: "resourceConfig"
              },
              ResourceName: {
                locationName: "resourceName"
              }
            },
            required: [
              "AppId",
              "ResourceName",
              "BackendEnvironmentName",
              "ResourceConfig"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              Error: {
                locationName: "error"
              },
              JobId: {
                locationName: "jobId"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        CreateBackendConfig: {
          http: {
            requestUri: "/backend/{appId}/config",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendManagerAppId: {
                locationName: "backendManagerAppId"
              }
            },
            required: [
              "AppId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              JobId: {
                locationName: "jobId"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        CreateBackendStorage: {
          http: {
            requestUri: "/backend/{appId}/storage",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              ResourceConfig: {
                locationName: "resourceConfig",
                type: "structure",
                members: {
                  BucketName: {
                    locationName: "bucketName"
                  },
                  Permissions: {
                    shape: "S1h",
                    locationName: "permissions"
                  },
                  ServiceName: {
                    locationName: "serviceName"
                  }
                },
                required: [
                  "ServiceName",
                  "Permissions"
                ]
              },
              ResourceName: {
                locationName: "resourceName"
              }
            },
            required: [
              "AppId",
              "ResourceName",
              "BackendEnvironmentName",
              "ResourceConfig"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              JobId: {
                locationName: "jobId"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        CreateToken: {
          http: {
            requestUri: "/backend/{appId}/challenge",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              }
            },
            required: [
              "AppId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              ChallengeCode: {
                locationName: "challengeCode"
              },
              SessionId: {
                locationName: "sessionId"
              },
              Ttl: {
                locationName: "ttl"
              }
            }
          }
        },
        DeleteBackend: {
          http: {
            requestUri: "/backend/{appId}/environments/{backendEnvironmentName}/remove",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              Error: {
                locationName: "error"
              },
              JobId: {
                locationName: "jobId"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        DeleteBackendAPI: {
          http: {
            requestUri: "/backend/{appId}/api/{backendEnvironmentName}/remove",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              },
              ResourceConfig: {
                shape: "S8",
                locationName: "resourceConfig"
              },
              ResourceName: {
                locationName: "resourceName"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName",
              "ResourceName"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              Error: {
                locationName: "error"
              },
              JobId: {
                locationName: "jobId"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        DeleteBackendAuth: {
          http: {
            requestUri: "/backend/{appId}/auth/{backendEnvironmentName}/remove",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              },
              ResourceName: {
                locationName: "resourceName"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName",
              "ResourceName"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              Error: {
                locationName: "error"
              },
              JobId: {
                locationName: "jobId"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        DeleteBackendStorage: {
          http: {
            requestUri: "/backend/{appId}/storage/{backendEnvironmentName}/remove",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              },
              ResourceName: {
                locationName: "resourceName"
              },
              ServiceName: {
                locationName: "serviceName"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName",
              "ServiceName",
              "ResourceName"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              JobId: {
                locationName: "jobId"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        DeleteToken: {
          http: {
            requestUri: "/backend/{appId}/challenge/{sessionId}/remove",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              SessionId: {
                location: "uri",
                locationName: "sessionId"
              }
            },
            required: [
              "SessionId",
              "AppId"
            ]
          },
          output: {
            type: "structure",
            members: {
              IsSuccess: {
                locationName: "isSuccess",
                type: "boolean"
              }
            }
          }
        },
        GenerateBackendAPIModels: {
          http: {
            requestUri: "/backend/{appId}/api/{backendEnvironmentName}/generateModels",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              },
              ResourceName: {
                locationName: "resourceName"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName",
              "ResourceName"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              Error: {
                locationName: "error"
              },
              JobId: {
                locationName: "jobId"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        GetBackend: {
          http: {
            requestUri: "/backend/{appId}/details",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              }
            },
            required: [
              "AppId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AmplifyFeatureFlags: {
                locationName: "amplifyFeatureFlags"
              },
              AmplifyMetaConfig: {
                locationName: "amplifyMetaConfig"
              },
              AppId: {
                locationName: "appId"
              },
              AppName: {
                locationName: "appName"
              },
              BackendEnvironmentList: {
                shape: "S11",
                locationName: "backendEnvironmentList"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              Error: {
                locationName: "error"
              }
            }
          }
        },
        GetBackendAPI: {
          http: {
            requestUri: "/backend/{appId}/api/{backendEnvironmentName}/details",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              },
              ResourceConfig: {
                shape: "S8",
                locationName: "resourceConfig"
              },
              ResourceName: {
                locationName: "resourceName"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName",
              "ResourceName"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              Error: {
                locationName: "error"
              },
              ResourceConfig: {
                shape: "S8",
                locationName: "resourceConfig"
              },
              ResourceName: {
                locationName: "resourceName"
              }
            }
          }
        },
        GetBackendAPIModels: {
          http: {
            requestUri: "/backend/{appId}/api/{backendEnvironmentName}/getModels",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              },
              ResourceName: {
                locationName: "resourceName"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName",
              "ResourceName"
            ]
          },
          output: {
            type: "structure",
            members: {
              Models: {
                locationName: "models"
              },
              Status: {
                locationName: "status"
              },
              ModelIntrospectionSchema: {
                locationName: "modelIntrospectionSchema"
              }
            }
          }
        },
        GetBackendAuth: {
          http: {
            requestUri: "/backend/{appId}/auth/{backendEnvironmentName}/details",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              },
              ResourceName: {
                locationName: "resourceName"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName",
              "ResourceName"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              Error: {
                locationName: "error"
              },
              ResourceConfig: {
                shape: "Si",
                locationName: "resourceConfig"
              },
              ResourceName: {
                locationName: "resourceName"
              }
            }
          }
        },
        GetBackendJob: {
          http: {
            method: "GET",
            requestUri: "/backend/{appId}/job/{backendEnvironmentName}/{jobId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              },
              JobId: {
                location: "uri",
                locationName: "jobId"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName",
              "JobId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              CreateTime: {
                locationName: "createTime"
              },
              Error: {
                locationName: "error"
              },
              JobId: {
                locationName: "jobId"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              },
              UpdateTime: {
                locationName: "updateTime"
              }
            }
          }
        },
        GetBackendStorage: {
          http: {
            requestUri: "/backend/{appId}/storage/{backendEnvironmentName}/details",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              },
              ResourceName: {
                locationName: "resourceName"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName",
              "ResourceName"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              ResourceConfig: {
                locationName: "resourceConfig",
                type: "structure",
                members: {
                  BucketName: {
                    locationName: "bucketName"
                  },
                  Imported: {
                    locationName: "imported",
                    type: "boolean"
                  },
                  Permissions: {
                    shape: "S1h",
                    locationName: "permissions"
                  },
                  ServiceName: {
                    locationName: "serviceName"
                  }
                },
                required: [
                  "ServiceName",
                  "Imported"
                ]
              },
              ResourceName: {
                locationName: "resourceName"
              }
            }
          }
        },
        GetToken: {
          http: {
            method: "GET",
            requestUri: "/backend/{appId}/challenge/{sessionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              SessionId: {
                location: "uri",
                locationName: "sessionId"
              }
            },
            required: [
              "SessionId",
              "AppId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              ChallengeCode: {
                locationName: "challengeCode"
              },
              SessionId: {
                locationName: "sessionId"
              },
              Ttl: {
                locationName: "ttl"
              }
            }
          }
        },
        ImportBackendAuth: {
          http: {
            requestUri: "/backend/{appId}/auth/{backendEnvironmentName}/import",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              },
              IdentityPoolId: {
                locationName: "identityPoolId"
              },
              NativeClientId: {
                locationName: "nativeClientId"
              },
              UserPoolId: {
                locationName: "userPoolId"
              },
              WebClientId: {
                locationName: "webClientId"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName",
              "UserPoolId",
              "NativeClientId",
              "WebClientId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              Error: {
                locationName: "error"
              },
              JobId: {
                locationName: "jobId"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        ImportBackendStorage: {
          http: {
            requestUri: "/backend/{appId}/storage/{backendEnvironmentName}/import",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              },
              BucketName: {
                locationName: "bucketName"
              },
              ServiceName: {
                locationName: "serviceName"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName",
              "ServiceName"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              JobId: {
                locationName: "jobId"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        ListBackendJobs: {
          http: {
            requestUri: "/backend/{appId}/job/{backendEnvironmentName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              },
              JobId: {
                locationName: "jobId"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName"
            ]
          },
          output: {
            type: "structure",
            members: {
              Jobs: {
                locationName: "jobs",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AppId: {
                      locationName: "appId"
                    },
                    BackendEnvironmentName: {
                      locationName: "backendEnvironmentName"
                    },
                    CreateTime: {
                      locationName: "createTime"
                    },
                    Error: {
                      locationName: "error"
                    },
                    JobId: {
                      locationName: "jobId"
                    },
                    Operation: {
                      locationName: "operation"
                    },
                    Status: {
                      locationName: "status"
                    },
                    UpdateTime: {
                      locationName: "updateTime"
                    }
                  },
                  required: [
                    "AppId",
                    "BackendEnvironmentName"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListS3Buckets: {
          http: {
            requestUri: "/s3Buckets",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Buckets: {
                locationName: "buckets",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreationDate: {
                      locationName: "creationDate"
                    },
                    Name: {
                      locationName: "name"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        RemoveAllBackends: {
          http: {
            requestUri: "/backend/{appId}/remove",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              CleanAmplifyApp: {
                locationName: "cleanAmplifyApp",
                type: "boolean"
              }
            },
            required: [
              "AppId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              Error: {
                locationName: "error"
              },
              JobId: {
                locationName: "jobId"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        RemoveBackendConfig: {
          http: {
            requestUri: "/backend/{appId}/config/remove",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              }
            },
            required: [
              "AppId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Error: {
                locationName: "error"
              }
            }
          }
        },
        UpdateBackendAPI: {
          http: {
            requestUri: "/backend/{appId}/api/{backendEnvironmentName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              },
              ResourceConfig: {
                shape: "S8",
                locationName: "resourceConfig"
              },
              ResourceName: {
                locationName: "resourceName"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName",
              "ResourceName"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              Error: {
                locationName: "error"
              },
              JobId: {
                locationName: "jobId"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        UpdateBackendAuth: {
          http: {
            requestUri: "/backend/{appId}/auth/{backendEnvironmentName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              },
              ResourceConfig: {
                locationName: "resourceConfig",
                type: "structure",
                members: {
                  AuthResources: {
                    locationName: "authResources"
                  },
                  IdentityPoolConfigs: {
                    locationName: "identityPoolConfigs",
                    type: "structure",
                    members: {
                      UnauthenticatedLogin: {
                        locationName: "unauthenticatedLogin",
                        type: "boolean"
                      }
                    }
                  },
                  Service: {
                    locationName: "service"
                  },
                  UserPoolConfigs: {
                    locationName: "userPoolConfigs",
                    type: "structure",
                    members: {
                      ForgotPassword: {
                        locationName: "forgotPassword",
                        type: "structure",
                        members: {
                          DeliveryMethod: {
                            locationName: "deliveryMethod"
                          },
                          EmailSettings: {
                            shape: "Sq",
                            locationName: "emailSettings"
                          },
                          SmsSettings: {
                            shape: "Sr",
                            locationName: "smsSettings"
                          }
                        }
                      },
                      Mfa: {
                        locationName: "mfa",
                        type: "structure",
                        members: {
                          MFAMode: {},
                          Settings: {
                            shape: "Su",
                            locationName: "settings"
                          }
                        }
                      },
                      OAuth: {
                        locationName: "oAuth",
                        type: "structure",
                        members: {
                          DomainPrefix: {
                            locationName: "domainPrefix"
                          },
                          OAuthGrantType: {
                            locationName: "oAuthGrantType"
                          },
                          OAuthScopes: {
                            shape: "Sz",
                            locationName: "oAuthScopes"
                          },
                          RedirectSignInURIs: {
                            shape: "S11",
                            locationName: "redirectSignInURIs"
                          },
                          RedirectSignOutURIs: {
                            shape: "S11",
                            locationName: "redirectSignOutURIs"
                          },
                          SocialProviderSettings: {
                            shape: "S12",
                            locationName: "socialProviderSettings"
                          }
                        }
                      },
                      PasswordPolicy: {
                        locationName: "passwordPolicy",
                        type: "structure",
                        members: {
                          AdditionalConstraints: {
                            shape: "S16",
                            locationName: "additionalConstraints"
                          },
                          MinimumLength: {
                            locationName: "minimumLength",
                            type: "double"
                          }
                        }
                      },
                      VerificationMessage: {
                        locationName: "verificationMessage",
                        type: "structure",
                        members: {
                          DeliveryMethod: {
                            locationName: "deliveryMethod"
                          },
                          EmailSettings: {
                            shape: "Sq",
                            locationName: "emailSettings"
                          },
                          SmsSettings: {
                            shape: "Sr",
                            locationName: "smsSettings"
                          }
                        },
                        required: [
                          "DeliveryMethod"
                        ]
                      }
                    }
                  }
                },
                required: [
                  "AuthResources",
                  "UserPoolConfigs",
                  "Service"
                ]
              },
              ResourceName: {
                locationName: "resourceName"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName",
              "ResourceName",
              "ResourceConfig"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              Error: {
                locationName: "error"
              },
              JobId: {
                locationName: "jobId"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        UpdateBackendConfig: {
          http: {
            requestUri: "/backend/{appId}/config/update",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              LoginAuthConfig: {
                shape: "S3c",
                locationName: "loginAuthConfig"
              }
            },
            required: [
              "AppId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendManagerAppId: {
                locationName: "backendManagerAppId"
              },
              Error: {
                locationName: "error"
              },
              LoginAuthConfig: {
                shape: "S3c",
                locationName: "loginAuthConfig"
              }
            }
          }
        },
        UpdateBackendJob: {
          http: {
            requestUri: "/backend/{appId}/job/{backendEnvironmentName}/{jobId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              },
              JobId: {
                location: "uri",
                locationName: "jobId"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName",
              "JobId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              CreateTime: {
                locationName: "createTime"
              },
              Error: {
                locationName: "error"
              },
              JobId: {
                locationName: "jobId"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              },
              UpdateTime: {
                locationName: "updateTime"
              }
            }
          }
        },
        UpdateBackendStorage: {
          http: {
            requestUri: "/backend/{appId}/storage/{backendEnvironmentName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              },
              ResourceConfig: {
                locationName: "resourceConfig",
                type: "structure",
                members: {
                  Permissions: {
                    shape: "S1h",
                    locationName: "permissions"
                  },
                  ServiceName: {
                    locationName: "serviceName"
                  }
                },
                required: [
                  "ServiceName",
                  "Permissions"
                ]
              },
              ResourceName: {
                locationName: "resourceName"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName",
              "ResourceName",
              "ResourceConfig"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              JobId: {
                locationName: "jobId"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        }
      },
      shapes: {
        S8: {
          type: "structure",
          members: {
            AdditionalAuthTypes: {
              locationName: "additionalAuthTypes",
              type: "list",
              member: {
                shape: "Sa"
              }
            },
            ApiName: {
              locationName: "apiName"
            },
            ConflictResolution: {
              locationName: "conflictResolution",
              type: "structure",
              members: {
                ResolutionStrategy: {
                  locationName: "resolutionStrategy"
                }
              }
            },
            DefaultAuthType: {
              shape: "Sa",
              locationName: "defaultAuthType"
            },
            Service: {
              locationName: "service"
            },
            TransformSchema: {
              locationName: "transformSchema"
            }
          }
        },
        Sa: {
          type: "structure",
          members: {
            Mode: {
              locationName: "mode"
            },
            Settings: {
              locationName: "settings",
              type: "structure",
              members: {
                CognitoUserPoolId: {
                  locationName: "cognitoUserPoolId"
                },
                Description: {
                  locationName: "description"
                },
                ExpirationTime: {
                  locationName: "expirationTime",
                  type: "double"
                },
                OpenIDAuthTTL: {
                  locationName: "openIDAuthTTL"
                },
                OpenIDClientId: {
                  locationName: "openIDClientId"
                },
                OpenIDIatTTL: {
                  locationName: "openIDIatTTL"
                },
                OpenIDIssueURL: {
                  locationName: "openIDIssueURL"
                },
                OpenIDProviderName: {
                  locationName: "openIDProviderName"
                }
              }
            }
          }
        },
        Si: {
          type: "structure",
          members: {
            AuthResources: {
              locationName: "authResources"
            },
            IdentityPoolConfigs: {
              locationName: "identityPoolConfigs",
              type: "structure",
              members: {
                IdentityPoolName: {
                  locationName: "identityPoolName"
                },
                UnauthenticatedLogin: {
                  locationName: "unauthenticatedLogin",
                  type: "boolean"
                }
              },
              required: [
                "UnauthenticatedLogin",
                "IdentityPoolName"
              ]
            },
            Service: {
              locationName: "service"
            },
            UserPoolConfigs: {
              locationName: "userPoolConfigs",
              type: "structure",
              members: {
                ForgotPassword: {
                  locationName: "forgotPassword",
                  type: "structure",
                  members: {
                    DeliveryMethod: {
                      locationName: "deliveryMethod"
                    },
                    EmailSettings: {
                      shape: "Sq",
                      locationName: "emailSettings"
                    },
                    SmsSettings: {
                      shape: "Sr",
                      locationName: "smsSettings"
                    }
                  },
                  required: [
                    "DeliveryMethod"
                  ]
                },
                Mfa: {
                  locationName: "mfa",
                  type: "structure",
                  members: {
                    MFAMode: {},
                    Settings: {
                      shape: "Su",
                      locationName: "settings"
                    }
                  },
                  required: [
                    "MFAMode"
                  ]
                },
                OAuth: {
                  locationName: "oAuth",
                  type: "structure",
                  members: {
                    DomainPrefix: {
                      locationName: "domainPrefix"
                    },
                    OAuthGrantType: {
                      locationName: "oAuthGrantType"
                    },
                    OAuthScopes: {
                      shape: "Sz",
                      locationName: "oAuthScopes"
                    },
                    RedirectSignInURIs: {
                      shape: "S11",
                      locationName: "redirectSignInURIs"
                    },
                    RedirectSignOutURIs: {
                      shape: "S11",
                      locationName: "redirectSignOutURIs"
                    },
                    SocialProviderSettings: {
                      shape: "S12",
                      locationName: "socialProviderSettings"
                    }
                  },
                  required: [
                    "RedirectSignOutURIs",
                    "RedirectSignInURIs",
                    "OAuthGrantType",
                    "OAuthScopes"
                  ]
                },
                PasswordPolicy: {
                  locationName: "passwordPolicy",
                  type: "structure",
                  members: {
                    AdditionalConstraints: {
                      shape: "S16",
                      locationName: "additionalConstraints"
                    },
                    MinimumLength: {
                      locationName: "minimumLength",
                      type: "double"
                    }
                  },
                  required: [
                    "MinimumLength"
                  ]
                },
                RequiredSignUpAttributes: {
                  locationName: "requiredSignUpAttributes",
                  type: "list",
                  member: {}
                },
                SignInMethod: {
                  locationName: "signInMethod"
                },
                UserPoolName: {
                  locationName: "userPoolName"
                },
                VerificationMessage: {
                  locationName: "verificationMessage",
                  type: "structure",
                  members: {
                    DeliveryMethod: {
                      locationName: "deliveryMethod"
                    },
                    EmailSettings: {
                      shape: "Sq",
                      locationName: "emailSettings"
                    },
                    SmsSettings: {
                      shape: "Sr",
                      locationName: "smsSettings"
                    }
                  },
                  required: [
                    "DeliveryMethod"
                  ]
                }
              },
              required: [
                "RequiredSignUpAttributes",
                "SignInMethod",
                "UserPoolName"
              ]
            }
          },
          required: [
            "AuthResources",
            "UserPoolConfigs",
            "Service"
          ]
        },
        Sq: {
          type: "structure",
          sensitive: true,
          members: {
            EmailMessage: {
              locationName: "emailMessage"
            },
            EmailSubject: {
              locationName: "emailSubject"
            }
          }
        },
        Sr: {
          type: "structure",
          sensitive: true,
          members: {
            SmsMessage: {
              locationName: "smsMessage"
            }
          }
        },
        Su: {
          type: "structure",
          members: {
            MfaTypes: {
              locationName: "mfaTypes",
              type: "list",
              member: {}
            },
            SmsMessage: {
              locationName: "smsMessage"
            }
          }
        },
        Sz: {
          type: "list",
          member: {}
        },
        S11: {
          type: "list",
          member: {}
        },
        S12: {
          type: "structure",
          members: {
            Facebook: {
              shape: "S13"
            },
            Google: {
              shape: "S13"
            },
            LoginWithAmazon: {
              shape: "S13"
            },
            SignInWithApple: {
              type: "structure",
              sensitive: true,
              members: {
                ClientId: {
                  locationName: "client_id"
                },
                KeyId: {
                  locationName: "key_id"
                },
                PrivateKey: {
                  locationName: "private_key"
                },
                TeamId: {
                  locationName: "team_id"
                }
              }
            }
          }
        },
        S13: {
          type: "structure",
          sensitive: true,
          members: {
            ClientId: {
              locationName: "client_id"
            },
            ClientSecret: {
              locationName: "client_secret"
            }
          }
        },
        S16: {
          type: "list",
          member: {}
        },
        S1h: {
          type: "structure",
          members: {
            Authenticated: {
              locationName: "authenticated",
              type: "list",
              member: {}
            },
            UnAuthenticated: {
              locationName: "unAuthenticated",
              type: "list",
              member: {}
            }
          },
          required: [
            "Authenticated"
          ]
        },
        S3c: {
          type: "structure",
          members: {
            AwsCognitoIdentityPoolId: {
              locationName: "aws_cognito_identity_pool_id"
            },
            AwsCognitoRegion: {
              locationName: "aws_cognito_region"
            },
            AwsUserPoolsId: {
              locationName: "aws_user_pools_id"
            },
            AwsUserPoolsWebClientId: {
              locationName: "aws_user_pools_web_client_id"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/amplifybackend-2020-08-11.paginators.json
var require_amplifybackend_2020_08_11_paginators = __commonJS({
  "node_modules/aws-sdk/apis/amplifybackend-2020-08-11.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListBackendJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Jobs"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/amplifybackend.js
var require_amplifybackend = __commonJS({
  "node_modules/aws-sdk/clients/amplifybackend.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["amplifybackend"] = {};
    AWS2.AmplifyBackend = Service.defineService("amplifybackend", ["2020-08-11"]);
    Object.defineProperty(apiLoader.services["amplifybackend"], "2020-08-11", {
      get: function get() {
        var model = require_amplifybackend_2020_08_11_min();
        model.paginators = require_amplifybackend_2020_08_11_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.AmplifyBackend;
  }
});

// node_modules/aws-sdk/apis/appintegrations-2020-07-29.min.json
var require_appintegrations_2020_07_29_min = __commonJS({
  "node_modules/aws-sdk/apis/appintegrations-2020-07-29.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-07-29",
        endpointPrefix: "app-integrations",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon AppIntegrations Service",
        serviceId: "AppIntegrations",
        signatureVersion: "v4",
        signingName: "app-integrations",
        uid: "appintegrations-2020-07-29"
      },
      operations: {
        CreateApplication: {
          http: {
            requestUri: "/applications"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "Namespace",
              "ApplicationSourceConfig"
            ],
            members: {
              Name: {},
              Namespace: {},
              Description: {},
              ApplicationSourceConfig: {
                shape: "S5"
              },
              Subscriptions: {
                shape: "Sa",
                deprecated: true,
                deprecatedMessage: "Subscriptions has been replaced with Permissions"
              },
              Publications: {
                shape: "Sd",
                deprecated: true,
                deprecatedMessage: "Publications has been replaced with Permissions"
              },
              ClientToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sh"
              },
              Permissions: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Id: {}
            }
          }
        },
        CreateDataIntegration: {
          http: {
            requestUri: "/dataIntegrations"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "KmsKey",
              "SourceURI"
            ],
            members: {
              Name: {},
              Description: {},
              KmsKey: {},
              SourceURI: {},
              ScheduleConfig: {
                shape: "St"
              },
              Tags: {
                shape: "Sh"
              },
              ClientToken: {
                idempotencyToken: true
              },
              FileConfiguration: {
                shape: "Sv"
              },
              ObjectConfiguration: {
                shape: "S11"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Id: {},
              Name: {},
              Description: {},
              KmsKey: {},
              SourceURI: {},
              ScheduleConfiguration: {
                shape: "St"
              },
              Tags: {
                shape: "Sh"
              },
              ClientToken: {},
              FileConfiguration: {
                shape: "Sv"
              },
              ObjectConfiguration: {
                shape: "S11"
              }
            }
          }
        },
        CreateEventIntegration: {
          http: {
            requestUri: "/eventIntegrations"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "EventFilter",
              "EventBridgeBus"
            ],
            members: {
              Name: {},
              Description: {},
              EventFilter: {
                shape: "S14"
              },
              EventBridgeBus: {},
              ClientToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sh"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventIntegrationArn: {}
            }
          }
        },
        DeleteApplication: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{ApplicationIdentifier}"
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {
                location: "uri",
                locationName: "ApplicationIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDataIntegration: {
          http: {
            method: "DELETE",
            requestUri: "/dataIntegrations/{Identifier}"
          },
          input: {
            type: "structure",
            required: [
              "DataIntegrationIdentifier"
            ],
            members: {
              DataIntegrationIdentifier: {
                location: "uri",
                locationName: "Identifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteEventIntegration: {
          http: {
            method: "DELETE",
            requestUri: "/eventIntegrations/{Name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetApplication: {
          http: {
            method: "GET",
            requestUri: "/applications/{ApplicationIdentifier}"
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {
                location: "uri",
                locationName: "ApplicationIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Id: {},
              Name: {},
              Namespace: {},
              Description: {},
              ApplicationSourceConfig: {
                shape: "S5"
              },
              Subscriptions: {
                shape: "Sa",
                deprecated: true,
                deprecatedMessage: "Subscriptions has been replaced with Permissions"
              },
              Publications: {
                shape: "Sd",
                deprecated: true,
                deprecatedMessage: "Publications has been replaced with Permissions"
              },
              CreatedTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              Tags: {
                shape: "Sh"
              },
              Permissions: {
                shape: "Sk"
              }
            }
          }
        },
        GetDataIntegration: {
          http: {
            method: "GET",
            requestUri: "/dataIntegrations/{Identifier}"
          },
          input: {
            type: "structure",
            required: [
              "Identifier"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "Identifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Id: {},
              Name: {},
              Description: {},
              KmsKey: {},
              SourceURI: {},
              ScheduleConfiguration: {
                shape: "St"
              },
              Tags: {
                shape: "Sh"
              },
              FileConfiguration: {
                shape: "Sv"
              },
              ObjectConfiguration: {
                shape: "S11"
              }
            }
          }
        },
        GetEventIntegration: {
          http: {
            method: "GET",
            requestUri: "/eventIntegrations/{Name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Description: {},
              EventIntegrationArn: {},
              EventBridgeBus: {},
              EventFilter: {
                shape: "S14"
              },
              Tags: {
                shape: "Sh"
              }
            }
          }
        },
        ListApplicationAssociations: {
          http: {
            method: "GET",
            requestUri: "/applications/{ApplicationIdentifier}/associations"
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationIdentifier"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationAssociations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApplicationAssociationArn: {},
                    ApplicationArn: {},
                    ClientId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListApplications: {
          http: {
            method: "GET",
            requestUri: "/applications"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Applications: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Id: {},
                    Name: {},
                    Namespace: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDataIntegrationAssociations: {
          http: {
            method: "GET",
            requestUri: "/dataIntegrations/{Identifier}/associations"
          },
          input: {
            type: "structure",
            required: [
              "DataIntegrationIdentifier"
            ],
            members: {
              DataIntegrationIdentifier: {
                location: "uri",
                locationName: "Identifier"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataIntegrationAssociations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DataIntegrationAssociationArn: {},
                    DataIntegrationArn: {},
                    ClientId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDataIntegrations: {
          http: {
            method: "GET",
            requestUri: "/dataIntegrations"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataIntegrations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Name: {},
                    SourceURI: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEventIntegrationAssociations: {
          http: {
            method: "GET",
            requestUri: "/eventIntegrations/{Name}/associations"
          },
          input: {
            type: "structure",
            required: [
              "EventIntegrationName"
            ],
            members: {
              EventIntegrationName: {
                location: "uri",
                locationName: "Name"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventIntegrationAssociations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EventIntegrationAssociationArn: {},
                    EventIntegrationAssociationId: {},
                    EventIntegrationName: {},
                    ClientId: {},
                    EventBridgeRuleName: {},
                    ClientAssociationMetadata: {
                      type: "map",
                      key: {},
                      value: {}
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEventIntegrations: {
          http: {
            method: "GET",
            requestUri: "/eventIntegrations"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventIntegrations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EventIntegrationArn: {},
                    Name: {},
                    Description: {},
                    EventFilter: {
                      shape: "S14"
                    },
                    EventBridgeBus: {},
                    Tags: {
                      shape: "Sh"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sh"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sh"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateApplication: {
          http: {
            method: "PATCH",
            requestUri: "/applications/{ApplicationIdentifier}"
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {
                location: "uri",
                locationName: "ApplicationIdentifier"
              },
              Name: {},
              Description: {},
              ApplicationSourceConfig: {
                shape: "S5"
              },
              Subscriptions: {
                shape: "Sa",
                deprecated: true,
                deprecatedMessage: "Subscriptions has been replaced with Permissions"
              },
              Publications: {
                shape: "Sd",
                deprecated: true,
                deprecatedMessage: "Publications has been replaced with Permissions"
              },
              Permissions: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDataIntegration: {
          http: {
            method: "PATCH",
            requestUri: "/dataIntegrations/{Identifier}"
          },
          input: {
            type: "structure",
            required: [
              "Identifier"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "Identifier"
              },
              Name: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateEventIntegration: {
          http: {
            method: "PATCH",
            requestUri: "/eventIntegrations/{Name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              },
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          members: {
            ExternalUrlConfig: {
              type: "structure",
              required: [
                "AccessUrl"
              ],
              members: {
                AccessUrl: {},
                ApprovedOrigins: {
                  type: "list",
                  member: {}
                }
              }
            }
          }
        },
        Sa: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Event"
            ],
            members: {
              Event: {},
              Description: {}
            }
          }
        },
        Sd: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Event",
              "Schema"
            ],
            members: {
              Event: {},
              Schema: {},
              Description: {}
            }
          }
        },
        Sh: {
          type: "map",
          key: {},
          value: {}
        },
        Sk: {
          type: "list",
          member: {}
        },
        St: {
          type: "structure",
          required: [
            "ScheduleExpression"
          ],
          members: {
            FirstExecutionFrom: {},
            Object: {},
            ScheduleExpression: {}
          }
        },
        Sv: {
          type: "structure",
          required: [
            "Folders"
          ],
          members: {
            Folders: {
              type: "list",
              member: {}
            },
            Filters: {
              shape: "Sy"
            }
          }
        },
        Sy: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {}
          }
        },
        S11: {
          type: "map",
          key: {},
          value: {
            shape: "Sy"
          }
        },
        S14: {
          type: "structure",
          required: [
            "Source"
          ],
          members: {
            Source: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/appintegrations-2020-07-29.paginators.json
var require_appintegrations_2020_07_29_paginators = __commonJS({
  "node_modules/aws-sdk/apis/appintegrations-2020-07-29.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListApplicationAssociations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ApplicationAssociations"
        },
        ListApplications: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Applications"
        },
        ListDataIntegrationAssociations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "DataIntegrationAssociations"
        },
        ListDataIntegrations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "DataIntegrations"
        },
        ListEventIntegrationAssociations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "EventIntegrationAssociations"
        },
        ListEventIntegrations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "EventIntegrations"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/appintegrations.js
var require_appintegrations = __commonJS({
  "node_modules/aws-sdk/clients/appintegrations.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["appintegrations"] = {};
    AWS2.AppIntegrations = Service.defineService("appintegrations", ["2020-07-29"]);
    Object.defineProperty(apiLoader.services["appintegrations"], "2020-07-29", {
      get: function get() {
        var model = require_appintegrations_2020_07_29_min();
        model.paginators = require_appintegrations_2020_07_29_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.AppIntegrations;
  }
});

// node_modules/aws-sdk/apis/connect-contact-lens-2020-08-21.min.json
var require_connect_contact_lens_2020_08_21_min = __commonJS({
  "node_modules/aws-sdk/apis/connect-contact-lens-2020-08-21.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-08-21",
        endpointPrefix: "contact-lens",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Amazon Connect Contact Lens",
        serviceFullName: "Amazon Connect Contact Lens",
        serviceId: "Connect Contact Lens",
        signatureVersion: "v4",
        signingName: "connect",
        uid: "connect-contact-lens-2020-08-21"
      },
      operations: {
        ListRealtimeContactAnalysisSegments: {
          http: {
            requestUri: "/realtime-contact-analysis/analysis-segments"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactId"
            ],
            members: {
              InstanceId: {},
              ContactId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Segments"
            ],
            members: {
              Segments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Transcript: {
                      type: "structure",
                      required: [
                        "Id",
                        "ParticipantId",
                        "ParticipantRole",
                        "Content",
                        "BeginOffsetMillis",
                        "EndOffsetMillis",
                        "Sentiment"
                      ],
                      members: {
                        Id: {},
                        ParticipantId: {},
                        ParticipantRole: {},
                        Content: {},
                        BeginOffsetMillis: {
                          type: "integer"
                        },
                        EndOffsetMillis: {
                          type: "integer"
                        },
                        Sentiment: {},
                        IssuesDetected: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "CharacterOffsets"
                            ],
                            members: {
                              CharacterOffsets: {
                                type: "structure",
                                required: [
                                  "BeginOffsetChar",
                                  "EndOffsetChar"
                                ],
                                members: {
                                  BeginOffsetChar: {
                                    type: "integer"
                                  },
                                  EndOffsetChar: {
                                    type: "integer"
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    Categories: {
                      type: "structure",
                      required: [
                        "MatchedCategories",
                        "MatchedDetails"
                      ],
                      members: {
                        MatchedCategories: {
                          type: "list",
                          member: {}
                        },
                        MatchedDetails: {
                          type: "map",
                          key: {},
                          value: {
                            type: "structure",
                            required: [
                              "PointsOfInterest"
                            ],
                            members: {
                              PointsOfInterest: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  required: [
                                    "BeginOffsetMillis",
                                    "EndOffsetMillis"
                                  ],
                                  members: {
                                    BeginOffsetMillis: {
                                      type: "integer"
                                    },
                                    EndOffsetMillis: {
                                      type: "integer"
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/apis/connect-contact-lens-2020-08-21.paginators.json
var require_connect_contact_lens_2020_08_21_paginators = __commonJS({
  "node_modules/aws-sdk/apis/connect-contact-lens-2020-08-21.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListRealtimeContactAnalysisSegments: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/connectcontactlens.js
var require_connectcontactlens = __commonJS({
  "node_modules/aws-sdk/clients/connectcontactlens.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["connectcontactlens"] = {};
    AWS2.ConnectContactLens = Service.defineService("connectcontactlens", ["2020-08-21"]);
    Object.defineProperty(apiLoader.services["connectcontactlens"], "2020-08-21", {
      get: function get() {
        var model = require_connect_contact_lens_2020_08_21_min();
        model.paginators = require_connect_contact_lens_2020_08_21_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ConnectContactLens;
  }
});

// node_modules/aws-sdk/apis/devops-guru-2020-12-01.min.json
var require_devops_guru_2020_12_01_min = __commonJS({
  "node_modules/aws-sdk/apis/devops-guru-2020-12-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-12-01",
        endpointPrefix: "devops-guru",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon DevOps Guru",
        serviceId: "DevOps Guru",
        signatureVersion: "v4",
        signingName: "devops-guru",
        uid: "devops-guru-2020-12-01"
      },
      operations: {
        AddNotificationChannel: {
          http: {
            method: "PUT",
            requestUri: "/channels",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Config"
            ],
            members: {
              Config: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          }
        },
        DeleteInsight: {
          http: {
            method: "DELETE",
            requestUri: "/insights/{Id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeAccountHealth: {
          http: {
            method: "GET",
            requestUri: "/accounts/health",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "OpenReactiveInsights",
              "OpenProactiveInsights",
              "MetricsAnalyzed",
              "ResourceHours"
            ],
            members: {
              OpenReactiveInsights: {
                type: "integer"
              },
              OpenProactiveInsights: {
                type: "integer"
              },
              MetricsAnalyzed: {
                type: "integer"
              },
              ResourceHours: {
                type: "long"
              },
              AnalyzedResourceCount: {
                type: "long"
              }
            }
          }
        },
        DescribeAccountOverview: {
          http: {
            requestUri: "/accounts/overview",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FromTime"
            ],
            members: {
              FromTime: {
                type: "timestamp"
              },
              ToTime: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ReactiveInsights",
              "ProactiveInsights",
              "MeanTimeToRecoverInMilliseconds"
            ],
            members: {
              ReactiveInsights: {
                type: "integer"
              },
              ProactiveInsights: {
                type: "integer"
              },
              MeanTimeToRecoverInMilliseconds: {
                type: "long"
              }
            }
          }
        },
        DescribeAnomaly: {
          http: {
            method: "GET",
            requestUri: "/anomalies/{Id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              AccountId: {
                location: "querystring",
                locationName: "AccountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProactiveAnomaly: {
                type: "structure",
                members: {
                  Id: {},
                  Severity: {},
                  Status: {},
                  UpdateTime: {
                    type: "timestamp"
                  },
                  AnomalyTimeRange: {
                    shape: "Sz"
                  },
                  AnomalyReportedTimeRange: {
                    shape: "S10"
                  },
                  PredictionTimeRange: {
                    shape: "S11"
                  },
                  SourceDetails: {
                    shape: "S12"
                  },
                  AssociatedInsightId: {},
                  ResourceCollection: {
                    shape: "S27"
                  },
                  Limit: {
                    type: "double"
                  },
                  SourceMetadata: {
                    shape: "S2h"
                  },
                  AnomalyResources: {
                    shape: "S2l"
                  },
                  Description: {}
                }
              },
              ReactiveAnomaly: {
                type: "structure",
                members: {
                  Id: {},
                  Severity: {},
                  Status: {},
                  AnomalyTimeRange: {
                    shape: "Sz"
                  },
                  AnomalyReportedTimeRange: {
                    shape: "S10"
                  },
                  SourceDetails: {
                    shape: "S12"
                  },
                  AssociatedInsightId: {},
                  ResourceCollection: {
                    shape: "S27"
                  },
                  Type: {},
                  Name: {},
                  Description: {},
                  CausalAnomalyId: {},
                  AnomalyResources: {
                    shape: "S2l"
                  }
                }
              }
            }
          }
        },
        DescribeEventSourcesConfig: {
          http: {
            requestUri: "/event-sources",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              EventSources: {
                shape: "S2t"
              }
            }
          }
        },
        DescribeFeedback: {
          http: {
            requestUri: "/feedback",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              InsightId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InsightFeedback: {
                shape: "S2y"
              }
            }
          }
        },
        DescribeInsight: {
          http: {
            method: "GET",
            requestUri: "/insights/{Id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              AccountId: {
                location: "querystring",
                locationName: "AccountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProactiveInsight: {
                type: "structure",
                members: {
                  Id: {},
                  Name: {},
                  Severity: {},
                  Status: {},
                  InsightTimeRange: {
                    shape: "S35"
                  },
                  PredictionTimeRange: {
                    shape: "S11"
                  },
                  ResourceCollection: {
                    shape: "S27"
                  },
                  SsmOpsItemId: {},
                  Description: {}
                }
              },
              ReactiveInsight: {
                type: "structure",
                members: {
                  Id: {},
                  Name: {},
                  Severity: {},
                  Status: {},
                  InsightTimeRange: {
                    shape: "S35"
                  },
                  ResourceCollection: {
                    shape: "S27"
                  },
                  SsmOpsItemId: {},
                  Description: {}
                }
              }
            }
          }
        },
        DescribeOrganizationHealth: {
          http: {
            requestUri: "/organization/health",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AccountIds: {
                shape: "S3a"
              },
              OrganizationalUnitIds: {
                shape: "S3b"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "OpenReactiveInsights",
              "OpenProactiveInsights",
              "MetricsAnalyzed",
              "ResourceHours"
            ],
            members: {
              OpenReactiveInsights: {
                type: "integer"
              },
              OpenProactiveInsights: {
                type: "integer"
              },
              MetricsAnalyzed: {
                type: "integer"
              },
              ResourceHours: {
                type: "long"
              }
            }
          }
        },
        DescribeOrganizationOverview: {
          http: {
            requestUri: "/organization/overview",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FromTime"
            ],
            members: {
              FromTime: {
                type: "timestamp"
              },
              ToTime: {
                type: "timestamp"
              },
              AccountIds: {
                shape: "S3a"
              },
              OrganizationalUnitIds: {
                shape: "S3b"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ReactiveInsights",
              "ProactiveInsights"
            ],
            members: {
              ReactiveInsights: {
                type: "integer"
              },
              ProactiveInsights: {
                type: "integer"
              }
            }
          }
        },
        DescribeOrganizationResourceCollectionHealth: {
          http: {
            requestUri: "/organization/health/resource-collection",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "OrganizationResourceCollectionType"
            ],
            members: {
              OrganizationResourceCollectionType: {},
              AccountIds: {
                shape: "S3a"
              },
              OrganizationalUnitIds: {
                shape: "S3b"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFormation: {
                shape: "S3l"
              },
              Service: {
                shape: "S3o"
              },
              Account: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AccountId: {},
                    Insight: {
                      type: "structure",
                      members: {
                        OpenProactiveInsights: {
                          type: "integer"
                        },
                        OpenReactiveInsights: {
                          type: "integer"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {},
              Tags: {
                shape: "S3v"
              }
            }
          }
        },
        DescribeResourceCollectionHealth: {
          http: {
            method: "GET",
            requestUri: "/accounts/health/resource-collection/{ResourceCollectionType}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceCollectionType"
            ],
            members: {
              ResourceCollectionType: {
                location: "uri",
                locationName: "ResourceCollectionType"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFormation: {
                shape: "S3l"
              },
              Service: {
                shape: "S3o"
              },
              NextToken: {},
              Tags: {
                shape: "S3v"
              }
            }
          }
        },
        DescribeServiceIntegration: {
          http: {
            method: "GET",
            requestUri: "/service-integrations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              ServiceIntegration: {
                type: "structure",
                members: {
                  OpsCenter: {
                    type: "structure",
                    members: {
                      OptInStatus: {}
                    }
                  },
                  LogsAnomalyDetection: {
                    type: "structure",
                    members: {
                      OptInStatus: {}
                    }
                  },
                  KMSServerSideEncryption: {
                    type: "structure",
                    members: {
                      KMSKeyId: {},
                      OptInStatus: {},
                      Type: {}
                    }
                  }
                }
              }
            }
          }
        },
        GetCostEstimation: {
          http: {
            method: "GET",
            requestUri: "/cost-estimation",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceCollection: {
                shape: "S4b"
              },
              Status: {},
              Costs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    State: {},
                    Count: {
                      type: "integer"
                    },
                    UnitCost: {
                      type: "double"
                    },
                    Cost: {
                      type: "double"
                    }
                  }
                }
              },
              TimeRange: {
                type: "structure",
                members: {
                  StartTime: {
                    type: "timestamp"
                  },
                  EndTime: {
                    type: "timestamp"
                  }
                }
              },
              TotalCost: {
                type: "double"
              },
              NextToken: {}
            }
          }
        },
        GetResourceCollection: {
          http: {
            method: "GET",
            requestUri: "/resource-collections/{ResourceCollectionType}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceCollectionType"
            ],
            members: {
              ResourceCollectionType: {
                location: "uri",
                locationName: "ResourceCollectionType"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceCollection: {
                type: "structure",
                members: {
                  CloudFormation: {
                    type: "structure",
                    members: {
                      StackNames: {
                        shape: "S29"
                      }
                    }
                  },
                  Tags: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "AppBoundaryKey",
                        "TagValues"
                      ],
                      members: {
                        AppBoundaryKey: {},
                        TagValues: {
                          shape: "S2e"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListAnomaliesForInsight: {
          http: {
            requestUri: "/anomalies/insight/{InsightId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "InsightId"
            ],
            members: {
              InsightId: {
                location: "uri",
                locationName: "InsightId"
              },
              StartTimeRange: {
                shape: "S4v"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              AccountId: {},
              Filters: {
                type: "structure",
                members: {
                  ServiceCollection: {
                    shape: "S4y"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProactiveAnomalies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Severity: {},
                    Status: {},
                    UpdateTime: {
                      type: "timestamp"
                    },
                    AnomalyTimeRange: {
                      shape: "Sz"
                    },
                    AnomalyReportedTimeRange: {
                      shape: "S10"
                    },
                    PredictionTimeRange: {
                      shape: "S11"
                    },
                    SourceDetails: {
                      shape: "S12"
                    },
                    AssociatedInsightId: {},
                    ResourceCollection: {
                      shape: "S27"
                    },
                    Limit: {
                      type: "double"
                    },
                    SourceMetadata: {
                      shape: "S2h"
                    },
                    AnomalyResources: {
                      shape: "S2l"
                    },
                    Description: {}
                  }
                }
              },
              ReactiveAnomalies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Severity: {},
                    Status: {},
                    AnomalyTimeRange: {
                      shape: "Sz"
                    },
                    AnomalyReportedTimeRange: {
                      shape: "S10"
                    },
                    SourceDetails: {
                      shape: "S12"
                    },
                    AssociatedInsightId: {},
                    ResourceCollection: {
                      shape: "S27"
                    },
                    Type: {},
                    Name: {},
                    Description: {},
                    CausalAnomalyId: {},
                    AnomalyResources: {
                      shape: "S2l"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListAnomalousLogGroups: {
          http: {
            requestUri: "/list-log-anomalies",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "InsightId"
            ],
            members: {
              InsightId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "InsightId",
              "AnomalousLogGroups"
            ],
            members: {
              InsightId: {},
              AnomalousLogGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LogGroupName: {},
                    ImpactStartTime: {
                      type: "timestamp"
                    },
                    ImpactEndTime: {
                      type: "timestamp"
                    },
                    NumberOfLogLinesScanned: {
                      type: "integer"
                    },
                    LogAnomalyShowcases: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          LogAnomalyClasses: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                LogStreamName: {},
                                LogAnomalyType: {},
                                LogAnomalyToken: {},
                                LogEventId: {},
                                Explanation: {},
                                NumberOfLogLinesOccurrences: {
                                  type: "integer"
                                },
                                LogEventTimestamp: {
                                  type: "timestamp"
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEvents: {
          http: {
            requestUri: "/events",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Filters"
            ],
            members: {
              Filters: {
                type: "structure",
                members: {
                  InsightId: {},
                  EventTimeRange: {
                    type: "structure",
                    required: [
                      "FromTime",
                      "ToTime"
                    ],
                    members: {
                      FromTime: {
                        type: "timestamp"
                      },
                      ToTime: {
                        type: "timestamp"
                      }
                    }
                  },
                  EventClass: {},
                  EventSource: {},
                  DataSource: {},
                  ResourceCollection: {
                    shape: "S27"
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              AccountId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Events"
            ],
            members: {
              Events: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceCollection: {
                      shape: "S27"
                    },
                    Id: {},
                    Time: {
                      type: "timestamp"
                    },
                    EventSource: {},
                    Name: {},
                    DataSource: {},
                    EventClass: {},
                    Resources: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Type: {},
                          Name: {},
                          Arn: {}
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListInsights: {
          http: {
            requestUri: "/insights",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "StatusFilter"
            ],
            members: {
              StatusFilter: {
                shape: "S64"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProactiveInsights: {
                shape: "S6c"
              },
              ReactiveInsights: {
                shape: "S6g"
              },
              NextToken: {}
            }
          }
        },
        ListMonitoredResources: {
          http: {
            requestUri: "/monitoredResources",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "structure",
                required: [
                  "ResourcePermission",
                  "ResourceTypeFilters"
                ],
                members: {
                  ResourcePermission: {},
                  ResourceTypeFilters: {
                    type: "list",
                    member: {}
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "MonitoredResourceIdentifiers"
            ],
            members: {
              MonitoredResourceIdentifiers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MonitoredResourceName: {},
                    Type: {},
                    ResourcePermission: {},
                    LastUpdated: {
                      type: "timestamp"
                    },
                    ResourceCollection: {
                      shape: "S27"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListNotificationChannels: {
          http: {
            requestUri: "/channels",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Channels: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Config: {
                      shape: "S2"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListOrganizationInsights: {
          http: {
            requestUri: "/organization/insights",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "StatusFilter"
            ],
            members: {
              StatusFilter: {
                shape: "S64"
              },
              MaxResults: {
                type: "integer"
              },
              AccountIds: {
                type: "list",
                member: {}
              },
              OrganizationalUnitIds: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProactiveInsights: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    AccountId: {},
                    OrganizationalUnitId: {},
                    Name: {},
                    Severity: {},
                    Status: {},
                    InsightTimeRange: {
                      shape: "S35"
                    },
                    PredictionTimeRange: {
                      shape: "S11"
                    },
                    ResourceCollection: {
                      shape: "S27"
                    },
                    ServiceCollection: {
                      shape: "S4y"
                    }
                  }
                }
              },
              ReactiveInsights: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    AccountId: {},
                    OrganizationalUnitId: {},
                    Name: {},
                    Severity: {},
                    Status: {},
                    InsightTimeRange: {
                      shape: "S35"
                    },
                    ResourceCollection: {
                      shape: "S27"
                    },
                    ServiceCollection: {
                      shape: "S4y"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListRecommendations: {
          http: {
            requestUri: "/recommendations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "InsightId"
            ],
            members: {
              InsightId: {},
              NextToken: {},
              Locale: {},
              AccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Recommendations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Description: {},
                    Link: {},
                    Name: {},
                    Reason: {},
                    RelatedEvents: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Name: {},
                          Resources: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Name: {},
                                Type: {}
                              }
                            }
                          }
                        }
                      }
                    },
                    RelatedAnomalies: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Resources: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Name: {},
                                Type: {}
                              }
                            }
                          },
                          SourceDetails: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                CloudWatchMetrics: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      MetricName: {},
                                      Namespace: {}
                                    }
                                  }
                                }
                              }
                            }
                          },
                          AnomalyId: {}
                        }
                      }
                    },
                    Category: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        PutFeedback: {
          http: {
            method: "PUT",
            requestUri: "/feedback",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              InsightFeedback: {
                shape: "S2y"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RemoveNotificationChannel: {
          http: {
            method: "DELETE",
            requestUri: "/channels/{Id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SearchInsights: {
          http: {
            requestUri: "/insights/search",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "StartTimeRange",
              "Type"
            ],
            members: {
              StartTimeRange: {
                shape: "S4v"
              },
              Filters: {
                type: "structure",
                members: {
                  Severities: {
                    shape: "S6"
                  },
                  Statuses: {
                    shape: "S83"
                  },
                  ResourceCollection: {
                    shape: "S27"
                  },
                  ServiceCollection: {
                    shape: "S4y"
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProactiveInsights: {
                shape: "S6c"
              },
              ReactiveInsights: {
                shape: "S6g"
              },
              NextToken: {}
            }
          }
        },
        SearchOrganizationInsights: {
          http: {
            requestUri: "/organization/insights/search",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountIds",
              "StartTimeRange",
              "Type"
            ],
            members: {
              AccountIds: {
                type: "list",
                member: {}
              },
              StartTimeRange: {
                shape: "S4v"
              },
              Filters: {
                type: "structure",
                members: {
                  Severities: {
                    shape: "S6"
                  },
                  Statuses: {
                    shape: "S83"
                  },
                  ResourceCollection: {
                    shape: "S27"
                  },
                  ServiceCollection: {
                    shape: "S4y"
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProactiveInsights: {
                shape: "S6c"
              },
              ReactiveInsights: {
                shape: "S6g"
              },
              NextToken: {}
            }
          }
        },
        StartCostEstimation: {
          http: {
            method: "PUT",
            requestUri: "/cost-estimation",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceCollection"
            ],
            members: {
              ResourceCollection: {
                shape: "S4b"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateEventSourcesConfig: {
          http: {
            method: "PUT",
            requestUri: "/event-sources",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              EventSources: {
                shape: "S2t"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateResourceCollection: {
          http: {
            method: "PUT",
            requestUri: "/resource-collections",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Action",
              "ResourceCollection"
            ],
            members: {
              Action: {},
              ResourceCollection: {
                type: "structure",
                members: {
                  CloudFormation: {
                    type: "structure",
                    members: {
                      StackNames: {
                        type: "list",
                        member: {}
                      }
                    }
                  },
                  Tags: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "AppBoundaryKey",
                        "TagValues"
                      ],
                      members: {
                        AppBoundaryKey: {},
                        TagValues: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateServiceIntegration: {
          http: {
            method: "PUT",
            requestUri: "/service-integrations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ServiceIntegration"
            ],
            members: {
              ServiceIntegration: {
                type: "structure",
                members: {
                  OpsCenter: {
                    type: "structure",
                    members: {
                      OptInStatus: {}
                    }
                  },
                  LogsAnomalyDetection: {
                    type: "structure",
                    members: {
                      OptInStatus: {}
                    }
                  },
                  KMSServerSideEncryption: {
                    type: "structure",
                    members: {
                      KMSKeyId: {},
                      OptInStatus: {},
                      Type: {}
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          required: [
            "Sns"
          ],
          members: {
            Sns: {
              type: "structure",
              members: {
                TopicArn: {}
              }
            },
            Filters: {
              type: "structure",
              members: {
                Severities: {
                  shape: "S6"
                },
                MessageTypes: {
                  type: "list",
                  member: {}
                }
              }
            }
          }
        },
        S6: {
          type: "list",
          member: {}
        },
        Sz: {
          type: "structure",
          required: [
            "StartTime"
          ],
          members: {
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            }
          }
        },
        S10: {
          type: "structure",
          required: [
            "OpenTime"
          ],
          members: {
            OpenTime: {
              type: "timestamp"
            },
            CloseTime: {
              type: "timestamp"
            }
          }
        },
        S11: {
          type: "structure",
          required: [
            "StartTime"
          ],
          members: {
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            }
          }
        },
        S12: {
          type: "structure",
          members: {
            CloudWatchMetrics: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  MetricName: {},
                  Namespace: {},
                  Dimensions: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {},
                        Value: {}
                      }
                    }
                  },
                  Stat: {},
                  Unit: {},
                  Period: {
                    type: "integer"
                  },
                  MetricDataSummary: {
                    type: "structure",
                    members: {
                      TimestampMetricValuePairList: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            Timestamp: {
                              type: "timestamp"
                            },
                            MetricValue: {
                              type: "double"
                            }
                          }
                        }
                      },
                      StatusCode: {}
                    }
                  }
                }
              }
            },
            PerformanceInsightsMetrics: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  MetricDisplayName: {},
                  Unit: {},
                  MetricQuery: {
                    shape: "S1n"
                  },
                  ReferenceData: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {},
                        ComparisonValues: {
                          type: "structure",
                          members: {
                            ReferenceScalar: {
                              type: "structure",
                              members: {
                                Value: {
                                  type: "double"
                                }
                              }
                            },
                            ReferenceMetric: {
                              type: "structure",
                              members: {
                                MetricQuery: {
                                  shape: "S1n"
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  },
                  StatsAtAnomaly: {
                    shape: "S24"
                  },
                  StatsAtBaseline: {
                    shape: "S24"
                  }
                }
              }
            }
          }
        },
        S1n: {
          type: "structure",
          members: {
            Metric: {},
            GroupBy: {
              type: "structure",
              members: {
                Group: {},
                Dimensions: {
                  type: "list",
                  member: {}
                },
                Limit: {
                  type: "integer"
                }
              }
            },
            Filter: {
              type: "map",
              key: {},
              value: {}
            }
          }
        },
        S24: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Type: {},
              Value: {
                type: "double"
              }
            }
          }
        },
        S27: {
          type: "structure",
          members: {
            CloudFormation: {
              type: "structure",
              members: {
                StackNames: {
                  shape: "S29"
                }
              }
            },
            Tags: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "AppBoundaryKey",
                  "TagValues"
                ],
                members: {
                  AppBoundaryKey: {},
                  TagValues: {
                    shape: "S2e"
                  }
                }
              }
            }
          }
        },
        S29: {
          type: "list",
          member: {}
        },
        S2e: {
          type: "list",
          member: {}
        },
        S2h: {
          type: "structure",
          members: {
            Source: {},
            SourceResourceName: {},
            SourceResourceType: {}
          }
        },
        S2l: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Type: {}
            }
          }
        },
        S2t: {
          type: "structure",
          members: {
            AmazonCodeGuruProfiler: {
              type: "structure",
              members: {
                Status: {}
              }
            }
          }
        },
        S2y: {
          type: "structure",
          members: {
            Id: {},
            Feedback: {}
          }
        },
        S35: {
          type: "structure",
          required: [
            "StartTime"
          ],
          members: {
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            }
          }
        },
        S3a: {
          type: "list",
          member: {}
        },
        S3b: {
          type: "list",
          member: {}
        },
        S3l: {
          type: "list",
          member: {
            type: "structure",
            members: {
              StackName: {},
              Insight: {
                shape: "S3n"
              },
              AnalyzedResourceCount: {
                type: "long"
              }
            }
          }
        },
        S3n: {
          type: "structure",
          members: {
            OpenProactiveInsights: {
              type: "integer"
            },
            OpenReactiveInsights: {
              type: "integer"
            },
            MeanTimeToRecoverInMilliseconds: {
              type: "long"
            }
          }
        },
        S3o: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ServiceName: {},
              Insight: {
                type: "structure",
                members: {
                  OpenProactiveInsights: {
                    type: "integer"
                  },
                  OpenReactiveInsights: {
                    type: "integer"
                  }
                }
              },
              AnalyzedResourceCount: {
                type: "long"
              }
            }
          }
        },
        S3v: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AppBoundaryKey: {},
              TagValue: {},
              Insight: {
                shape: "S3n"
              },
              AnalyzedResourceCount: {
                type: "long"
              }
            }
          }
        },
        S4b: {
          type: "structure",
          members: {
            CloudFormation: {
              type: "structure",
              members: {
                StackNames: {
                  type: "list",
                  member: {}
                }
              }
            },
            Tags: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "AppBoundaryKey",
                  "TagValues"
                ],
                members: {
                  AppBoundaryKey: {},
                  TagValues: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          }
        },
        S4v: {
          type: "structure",
          members: {
            FromTime: {
              type: "timestamp"
            },
            ToTime: {
              type: "timestamp"
            }
          }
        },
        S4y: {
          type: "structure",
          members: {
            ServiceNames: {
              type: "list",
              member: {}
            }
          }
        },
        S64: {
          type: "structure",
          members: {
            Ongoing: {
              type: "structure",
              required: [
                "Type"
              ],
              members: {
                Type: {}
              }
            },
            Closed: {
              type: "structure",
              required: [
                "Type",
                "EndTimeRange"
              ],
              members: {
                Type: {},
                EndTimeRange: {
                  type: "structure",
                  members: {
                    FromTime: {
                      type: "timestamp"
                    },
                    ToTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            },
            Any: {
              type: "structure",
              required: [
                "Type",
                "StartTimeRange"
              ],
              members: {
                Type: {},
                StartTimeRange: {
                  shape: "S4v"
                }
              }
            }
          }
        },
        S6c: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Id: {},
              Name: {},
              Severity: {},
              Status: {},
              InsightTimeRange: {
                shape: "S35"
              },
              PredictionTimeRange: {
                shape: "S11"
              },
              ResourceCollection: {
                shape: "S27"
              },
              ServiceCollection: {
                shape: "S4y"
              },
              AssociatedResourceArns: {
                shape: "S6e"
              }
            }
          }
        },
        S6e: {
          type: "list",
          member: {}
        },
        S6g: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Id: {},
              Name: {},
              Severity: {},
              Status: {},
              InsightTimeRange: {
                shape: "S35"
              },
              ResourceCollection: {
                shape: "S27"
              },
              ServiceCollection: {
                shape: "S4y"
              },
              AssociatedResourceArns: {
                shape: "S6e"
              }
            }
          }
        },
        S83: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/devops-guru-2020-12-01.paginators.json
var require_devops_guru_2020_12_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/devops-guru-2020-12-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeOrganizationResourceCollectionHealth: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: [
            "CloudFormation",
            "Account",
            "Service",
            "Tags"
          ]
        },
        DescribeResourceCollectionHealth: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: [
            "CloudFormation",
            "Service",
            "Tags"
          ]
        },
        GetCostEstimation: {
          input_token: "NextToken",
          non_aggregate_keys: [
            "Status",
            "TotalCost",
            "TimeRange",
            "ResourceCollection"
          ],
          output_token: "NextToken",
          result_key: [
            "Costs"
          ]
        },
        GetResourceCollection: {
          input_token: "NextToken",
          non_aggregate_keys: [
            "ResourceCollection"
          ],
          output_token: "NextToken",
          result_key: [
            "ResourceCollection.CloudFormation.StackNames",
            "ResourceCollection.Tags"
          ]
        },
        ListAnomaliesForInsight: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: [
            "ReactiveAnomalies",
            "ProactiveAnomalies"
          ]
        },
        ListAnomalousLogGroups: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: [
            "InsightId",
            "AnomalousLogGroups"
          ]
        },
        ListEvents: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Events"
        },
        ListInsights: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: [
            "ProactiveInsights",
            "ReactiveInsights"
          ]
        },
        ListMonitoredResources: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: [
            "MonitoredResourceIdentifiers"
          ]
        },
        ListNotificationChannels: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Channels"
        },
        ListOrganizationInsights: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: [
            "ProactiveInsights",
            "ReactiveInsights"
          ]
        },
        ListRecommendations: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Recommendations"
        },
        SearchInsights: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: [
            "ProactiveInsights",
            "ReactiveInsights"
          ]
        },
        SearchOrganizationInsights: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: [
            "ProactiveInsights",
            "ReactiveInsights"
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/devopsguru.js
var require_devopsguru = __commonJS({
  "node_modules/aws-sdk/clients/devopsguru.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["devopsguru"] = {};
    AWS2.DevOpsGuru = Service.defineService("devopsguru", ["2020-12-01"]);
    Object.defineProperty(apiLoader.services["devopsguru"], "2020-12-01", {
      get: function get() {
        var model = require_devops_guru_2020_12_01_min();
        model.paginators = require_devops_guru_2020_12_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.DevOpsGuru;
  }
});

// node_modules/aws-sdk/apis/ecr-public-2020-10-30.min.json
var require_ecr_public_2020_10_30_min = __commonJS({
  "node_modules/aws-sdk/apis/ecr-public-2020-10-30.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-10-30",
        endpointPrefix: "api.ecr-public",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Amazon ECR Public",
        serviceFullName: "Amazon Elastic Container Registry Public",
        serviceId: "ECR PUBLIC",
        signatureVersion: "v4",
        signingName: "ecr-public",
        targetPrefix: "SpencerFrontendService",
        uid: "ecr-public-2020-10-30"
      },
      operations: {
        BatchCheckLayerAvailability: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "layerDigests"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              layerDigests: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              layers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    layerDigest: {},
                    layerAvailability: {},
                    layerSize: {
                      type: "long"
                    },
                    mediaType: {}
                  }
                }
              },
              failures: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    layerDigest: {},
                    failureCode: {},
                    failureReason: {}
                  }
                }
              }
            }
          }
        },
        BatchDeleteImage: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "imageIds"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              imageIds: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              imageIds: {
                shape: "Si"
              },
              failures: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    imageId: {
                      shape: "Sj"
                    },
                    failureCode: {},
                    failureReason: {}
                  }
                }
              }
            }
          }
        },
        CompleteLayerUpload: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "uploadId",
              "layerDigests"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              uploadId: {},
              layerDigests: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              uploadId: {},
              layerDigest: {}
            }
          }
        },
        CreateRepository: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              repositoryName: {},
              catalogData: {
                shape: "Sx"
              },
              tags: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repository: {
                shape: "S1b"
              },
              catalogData: {
                shape: "S1f"
              }
            }
          }
        },
        DeleteRepository: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              force: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repository: {
                shape: "S1b"
              }
            }
          }
        },
        DeleteRepositoryPolicy: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              policyText: {}
            }
          }
        },
        DescribeImageTags: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              imageTagDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    imageTag: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    imageDetail: {
                      type: "structure",
                      members: {
                        imageDigest: {},
                        imageSizeInBytes: {
                          type: "long"
                        },
                        imagePushedAt: {
                          type: "timestamp"
                        },
                        imageManifestMediaType: {},
                        artifactMediaType: {}
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeImages: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              imageIds: {
                shape: "Si"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              imageDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    registryId: {},
                    repositoryName: {},
                    imageDigest: {},
                    imageTags: {
                      type: "list",
                      member: {}
                    },
                    imageSizeInBytes: {
                      type: "long"
                    },
                    imagePushedAt: {
                      type: "timestamp"
                    },
                    imageManifestMediaType: {},
                    artifactMediaType: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeRegistries: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "registries"
            ],
            members: {
              registries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "registryId",
                    "registryArn",
                    "registryUri",
                    "verified",
                    "aliases"
                  ],
                  members: {
                    registryId: {},
                    registryArn: {},
                    registryUri: {},
                    verified: {
                      type: "boolean"
                    },
                    aliases: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "name",
                          "status",
                          "primaryRegistryAlias",
                          "defaultRegistryAlias"
                        ],
                        members: {
                          name: {},
                          status: {},
                          primaryRegistryAlias: {
                            type: "boolean"
                          },
                          defaultRegistryAlias: {
                            type: "boolean"
                          }
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeRepositories: {
          input: {
            type: "structure",
            members: {
              registryId: {},
              repositoryNames: {
                type: "list",
                member: {}
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repositories: {
                type: "list",
                member: {
                  shape: "S1b"
                }
              },
              nextToken: {}
            }
          }
        },
        GetAuthorizationToken: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              authorizationData: {
                type: "structure",
                members: {
                  authorizationToken: {},
                  expiresAt: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        GetRegistryCatalogData: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "registryCatalogData"
            ],
            members: {
              registryCatalogData: {
                shape: "S2o"
              }
            }
          }
        },
        GetRepositoryCatalogData: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              catalogData: {
                shape: "S1f"
              }
            }
          }
        },
        GetRepositoryPolicy: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              policyText: {}
            }
          }
        },
        InitiateLayerUpload: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              uploadId: {},
              partSize: {
                type: "long"
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S16"
              }
            }
          }
        },
        PutImage: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "imageManifest"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              imageManifest: {},
              imageManifestMediaType: {},
              imageTag: {},
              imageDigest: {}
            }
          },
          output: {
            type: "structure",
            members: {
              image: {
                type: "structure",
                members: {
                  registryId: {},
                  repositoryName: {},
                  imageId: {
                    shape: "Sj"
                  },
                  imageManifest: {},
                  imageManifestMediaType: {}
                }
              }
            }
          }
        },
        PutRegistryCatalogData: {
          input: {
            type: "structure",
            members: {
              displayName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "registryCatalogData"
            ],
            members: {
              registryCatalogData: {
                shape: "S2o"
              }
            }
          }
        },
        PutRepositoryCatalogData: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "catalogData"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              catalogData: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              catalogData: {
                shape: "S1f"
              }
            }
          }
        },
        SetRepositoryPolicy: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "policyText"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              policyText: {},
              force: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              policyText: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UploadLayerPart: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "uploadId",
              "partFirstByte",
              "partLastByte",
              "layerPartBlob"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              uploadId: {},
              partFirstByte: {
                type: "long"
              },
              partLastByte: {
                type: "long"
              },
              layerPartBlob: {
                type: "blob"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              uploadId: {},
              lastByteReceived: {
                type: "long"
              }
            }
          }
        }
      },
      shapes: {
        Si: {
          type: "list",
          member: {
            shape: "Sj"
          }
        },
        Sj: {
          type: "structure",
          members: {
            imageDigest: {},
            imageTag: {}
          }
        },
        Sx: {
          type: "structure",
          members: {
            description: {},
            architectures: {
              shape: "Sz"
            },
            operatingSystems: {
              shape: "S11"
            },
            logoImageBlob: {
              type: "blob"
            },
            aboutText: {},
            usageText: {}
          }
        },
        Sz: {
          type: "list",
          member: {}
        },
        S11: {
          type: "list",
          member: {}
        },
        S16: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S1b: {
          type: "structure",
          members: {
            repositoryArn: {},
            registryId: {},
            repositoryName: {},
            repositoryUri: {},
            createdAt: {
              type: "timestamp"
            }
          }
        },
        S1f: {
          type: "structure",
          members: {
            description: {},
            architectures: {
              shape: "Sz"
            },
            operatingSystems: {
              shape: "S11"
            },
            logoUrl: {},
            aboutText: {},
            usageText: {},
            marketplaceCertified: {
              type: "boolean"
            }
          }
        },
        S2o: {
          type: "structure",
          members: {
            displayName: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ecr-public-2020-10-30.paginators.json
var require_ecr_public_2020_10_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/ecr-public-2020-10-30.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeImageTags: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "imageTagDetails"
        },
        DescribeImages: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "imageDetails"
        },
        DescribeRegistries: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "registries"
        },
        DescribeRepositories: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "repositories"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/ecrpublic.js
var require_ecrpublic = __commonJS({
  "node_modules/aws-sdk/clients/ecrpublic.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["ecrpublic"] = {};
    AWS2.ECRPUBLIC = Service.defineService("ecrpublic", ["2020-10-30"]);
    Object.defineProperty(apiLoader.services["ecrpublic"], "2020-10-30", {
      get: function get() {
        var model = require_ecr_public_2020_10_30_min();
        model.paginators = require_ecr_public_2020_10_30_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ECRPUBLIC;
  }
});

// node_modules/aws-sdk/apis/lookoutvision-2020-11-20.min.json
var require_lookoutvision_2020_11_20_min = __commonJS({
  "node_modules/aws-sdk/apis/lookoutvision-2020-11-20.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-11-20",
        endpointPrefix: "lookoutvision",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Lookout for Vision",
        serviceId: "LookoutVision",
        signatureVersion: "v4",
        signingName: "lookoutvision",
        uid: "lookoutvision-2020-11-20"
      },
      operations: {
        CreateDataset: {
          http: {
            requestUri: "/2020-11-20/projects/{projectName}/datasets",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "ProjectName",
              "DatasetType"
            ],
            members: {
              ProjectName: {
                location: "uri",
                locationName: "projectName"
              },
              DatasetType: {},
              DatasetSource: {
                type: "structure",
                members: {
                  GroundTruthManifest: {
                    type: "structure",
                    members: {
                      S3Object: {
                        type: "structure",
                        required: [
                          "Bucket",
                          "Key"
                        ],
                        members: {
                          Bucket: {},
                          Key: {},
                          VersionId: {}
                        }
                      }
                    }
                  }
                }
              },
              ClientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amzn-Client-Token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetMetadata: {
                shape: "Sc"
              }
            }
          }
        },
        CreateModel: {
          http: {
            requestUri: "/2020-11-20/projects/{projectName}/models",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "ProjectName",
              "OutputConfig"
            ],
            members: {
              ProjectName: {
                location: "uri",
                locationName: "projectName"
              },
              Description: {},
              ClientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              OutputConfig: {
                shape: "Si"
              },
              KmsKeyId: {},
              Tags: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ModelMetadata: {
                shape: "Sr"
              }
            }
          }
        },
        CreateProject: {
          http: {
            requestUri: "/2020-11-20/projects"
          },
          input: {
            type: "structure",
            required: [
              "ProjectName"
            ],
            members: {
              ProjectName: {},
              ClientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amzn-Client-Token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProjectMetadata: {
                shape: "S10"
              }
            }
          }
        },
        DeleteDataset: {
          http: {
            method: "DELETE",
            requestUri: "/2020-11-20/projects/{projectName}/datasets/{datasetType}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "ProjectName",
              "DatasetType"
            ],
            members: {
              ProjectName: {
                location: "uri",
                locationName: "projectName"
              },
              DatasetType: {
                location: "uri",
                locationName: "datasetType"
              },
              ClientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amzn-Client-Token"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteModel: {
          http: {
            method: "DELETE",
            requestUri: "/2020-11-20/projects/{projectName}/models/{modelVersion}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "ProjectName",
              "ModelVersion"
            ],
            members: {
              ProjectName: {
                location: "uri",
                locationName: "projectName"
              },
              ModelVersion: {
                location: "uri",
                locationName: "modelVersion"
              },
              ClientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amzn-Client-Token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ModelArn: {}
            }
          }
        },
        DeleteProject: {
          http: {
            method: "DELETE",
            requestUri: "/2020-11-20/projects/{projectName}"
          },
          input: {
            type: "structure",
            required: [
              "ProjectName"
            ],
            members: {
              ProjectName: {
                location: "uri",
                locationName: "projectName"
              },
              ClientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amzn-Client-Token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProjectArn: {}
            }
          }
        },
        DescribeDataset: {
          http: {
            method: "GET",
            requestUri: "/2020-11-20/projects/{projectName}/datasets/{datasetType}"
          },
          input: {
            type: "structure",
            required: [
              "ProjectName",
              "DatasetType"
            ],
            members: {
              ProjectName: {
                location: "uri",
                locationName: "projectName"
              },
              DatasetType: {
                location: "uri",
                locationName: "datasetType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetDescription: {
                type: "structure",
                members: {
                  ProjectName: {},
                  DatasetType: {},
                  CreationTimestamp: {
                    type: "timestamp"
                  },
                  LastUpdatedTimestamp: {
                    type: "timestamp"
                  },
                  Status: {},
                  StatusMessage: {},
                  ImageStats: {
                    type: "structure",
                    members: {
                      Total: {
                        type: "integer"
                      },
                      Labeled: {
                        type: "integer"
                      },
                      Normal: {
                        type: "integer"
                      },
                      Anomaly: {
                        type: "integer"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeModel: {
          http: {
            method: "GET",
            requestUri: "/2020-11-20/projects/{projectName}/models/{modelVersion}"
          },
          input: {
            type: "structure",
            required: [
              "ProjectName",
              "ModelVersion"
            ],
            members: {
              ProjectName: {
                location: "uri",
                locationName: "projectName"
              },
              ModelVersion: {
                location: "uri",
                locationName: "modelVersion"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ModelDescription: {
                type: "structure",
                members: {
                  ModelVersion: {},
                  ModelArn: {},
                  CreationTimestamp: {
                    type: "timestamp"
                  },
                  Description: {},
                  Status: {},
                  StatusMessage: {},
                  Performance: {
                    shape: "Sw"
                  },
                  OutputConfig: {
                    shape: "Si"
                  },
                  EvaluationManifest: {
                    shape: "S1h"
                  },
                  EvaluationResult: {
                    shape: "S1h"
                  },
                  EvaluationEndTimestamp: {
                    type: "timestamp"
                  },
                  KmsKeyId: {},
                  MinInferenceUnits: {
                    type: "integer"
                  },
                  MaxInferenceUnits: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        DescribeModelPackagingJob: {
          http: {
            method: "GET",
            requestUri: "/2020-11-20/projects/{projectName}/modelpackagingjobs/{jobName}"
          },
          input: {
            type: "structure",
            required: [
              "ProjectName",
              "JobName"
            ],
            members: {
              ProjectName: {
                location: "uri",
                locationName: "projectName"
              },
              JobName: {
                location: "uri",
                locationName: "jobName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ModelPackagingDescription: {
                type: "structure",
                members: {
                  JobName: {},
                  ProjectName: {},
                  ModelVersion: {},
                  ModelPackagingConfiguration: {
                    shape: "S1n"
                  },
                  ModelPackagingJobDescription: {},
                  ModelPackagingMethod: {},
                  ModelPackagingOutputDetails: {
                    type: "structure",
                    members: {
                      Greengrass: {
                        type: "structure",
                        members: {
                          ComponentVersionArn: {},
                          ComponentName: {},
                          ComponentVersion: {}
                        }
                      }
                    }
                  },
                  Status: {},
                  StatusMessage: {},
                  CreationTimestamp: {
                    type: "timestamp"
                  },
                  LastUpdatedTimestamp: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        DescribeProject: {
          http: {
            method: "GET",
            requestUri: "/2020-11-20/projects/{projectName}"
          },
          input: {
            type: "structure",
            required: [
              "ProjectName"
            ],
            members: {
              ProjectName: {
                location: "uri",
                locationName: "projectName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProjectDescription: {
                type: "structure",
                members: {
                  ProjectArn: {},
                  ProjectName: {},
                  CreationTimestamp: {
                    type: "timestamp"
                  },
                  Datasets: {
                    type: "list",
                    member: {
                      shape: "Sc"
                    }
                  }
                }
              }
            }
          }
        },
        DetectAnomalies: {
          http: {
            requestUri: "/2020-11-20/projects/{projectName}/models/{modelVersion}/detect"
          },
          input: {
            type: "structure",
            required: [
              "ProjectName",
              "ModelVersion",
              "Body",
              "ContentType"
            ],
            members: {
              ProjectName: {
                location: "uri",
                locationName: "projectName"
              },
              ModelVersion: {
                location: "uri",
                locationName: "modelVersion"
              },
              Body: {
                type: "blob",
                requiresLength: true,
                streaming: true
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              }
            },
            payload: "Body"
          },
          output: {
            type: "structure",
            members: {
              DetectAnomalyResult: {
                type: "structure",
                members: {
                  Source: {
                    type: "structure",
                    members: {
                      Type: {}
                    }
                  },
                  IsAnomalous: {
                    type: "boolean"
                  },
                  Confidence: {
                    type: "float"
                  },
                  Anomalies: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {},
                        PixelAnomaly: {
                          type: "structure",
                          members: {
                            TotalPercentageArea: {
                              type: "float"
                            },
                            Color: {}
                          }
                        }
                      }
                    }
                  },
                  AnomalyMask: {
                    type: "blob"
                  }
                }
              }
            }
          }
        },
        ListDatasetEntries: {
          http: {
            method: "GET",
            requestUri: "/2020-11-20/projects/{projectName}/datasets/{datasetType}/entries"
          },
          input: {
            type: "structure",
            required: [
              "ProjectName",
              "DatasetType"
            ],
            members: {
              ProjectName: {
                location: "uri",
                locationName: "projectName"
              },
              DatasetType: {
                location: "uri",
                locationName: "datasetType"
              },
              Labeled: {
                location: "querystring",
                locationName: "labeled",
                type: "boolean"
              },
              AnomalyClass: {
                location: "querystring",
                locationName: "anomalyClass"
              },
              BeforeCreationDate: {
                location: "querystring",
                locationName: "createdBefore",
                type: "timestamp"
              },
              AfterCreationDate: {
                location: "querystring",
                locationName: "createdAfter",
                type: "timestamp"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              SourceRefContains: {
                location: "querystring",
                locationName: "sourceRefContains"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetEntries: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListModelPackagingJobs: {
          http: {
            method: "GET",
            requestUri: "/2020-11-20/projects/{projectName}/modelpackagingjobs"
          },
          input: {
            type: "structure",
            required: [
              "ProjectName"
            ],
            members: {
              ProjectName: {
                location: "uri",
                locationName: "projectName"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ModelPackagingJobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    JobName: {},
                    ProjectName: {},
                    ModelVersion: {},
                    ModelPackagingJobDescription: {},
                    ModelPackagingMethod: {},
                    Status: {},
                    StatusMessage: {},
                    CreationTimestamp: {
                      type: "timestamp"
                    },
                    LastUpdatedTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListModels: {
          http: {
            method: "GET",
            requestUri: "/2020-11-20/projects/{projectName}/models"
          },
          input: {
            type: "structure",
            required: [
              "ProjectName"
            ],
            members: {
              ProjectName: {
                location: "uri",
                locationName: "projectName"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Models: {
                type: "list",
                member: {
                  shape: "Sr"
                }
              },
              NextToken: {}
            }
          }
        },
        ListProjects: {
          http: {
            method: "GET",
            requestUri: "/2020-11-20/projects"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Projects: {
                type: "list",
                member: {
                  shape: "S10"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/2020-11-20/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sm"
              }
            }
          }
        },
        StartModel: {
          http: {
            requestUri: "/2020-11-20/projects/{projectName}/models/{modelVersion}/start",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "ProjectName",
              "ModelVersion",
              "MinInferenceUnits"
            ],
            members: {
              ProjectName: {
                location: "uri",
                locationName: "projectName"
              },
              ModelVersion: {
                location: "uri",
                locationName: "modelVersion"
              },
              MinInferenceUnits: {
                type: "integer"
              },
              ClientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              MaxInferenceUnits: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {}
            }
          }
        },
        StartModelPackagingJob: {
          http: {
            requestUri: "/2020-11-20/projects/{projectName}/modelpackagingjobs"
          },
          input: {
            type: "structure",
            required: [
              "ProjectName",
              "ModelVersion",
              "Configuration"
            ],
            members: {
              ProjectName: {
                location: "uri",
                locationName: "projectName"
              },
              ModelVersion: {},
              JobName: {},
              Configuration: {
                shape: "S1n"
              },
              Description: {},
              ClientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amzn-Client-Token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobName: {}
            }
          }
        },
        StopModel: {
          http: {
            requestUri: "/2020-11-20/projects/{projectName}/models/{modelVersion}/stop",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "ProjectName",
              "ModelVersion"
            ],
            members: {
              ProjectName: {
                location: "uri",
                locationName: "projectName"
              },
              ModelVersion: {
                location: "uri",
                locationName: "modelVersion"
              },
              ClientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amzn-Client-Token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/2020-11-20/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              Tags: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/2020-11-20/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDatasetEntries: {
          http: {
            method: "PATCH",
            requestUri: "/2020-11-20/projects/{projectName}/datasets/{datasetType}/entries",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "ProjectName",
              "DatasetType",
              "Changes"
            ],
            members: {
              ProjectName: {
                location: "uri",
                locationName: "projectName"
              },
              DatasetType: {
                location: "uri",
                locationName: "datasetType"
              },
              Changes: {
                type: "blob"
              },
              ClientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amzn-Client-Token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {}
            }
          }
        }
      },
      shapes: {
        Sc: {
          type: "structure",
          members: {
            DatasetType: {},
            CreationTimestamp: {
              type: "timestamp"
            },
            Status: {},
            StatusMessage: {}
          }
        },
        Si: {
          type: "structure",
          required: [
            "S3Location"
          ],
          members: {
            S3Location: {
              shape: "Sj"
            }
          }
        },
        Sj: {
          type: "structure",
          required: [
            "Bucket"
          ],
          members: {
            Bucket: {},
            Prefix: {}
          }
        },
        Sm: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sr: {
          type: "structure",
          members: {
            CreationTimestamp: {
              type: "timestamp"
            },
            ModelVersion: {},
            ModelArn: {},
            Description: {},
            Status: {},
            StatusMessage: {},
            Performance: {
              shape: "Sw"
            }
          }
        },
        Sw: {
          type: "structure",
          members: {
            F1Score: {
              type: "float"
            },
            Recall: {
              type: "float"
            },
            Precision: {
              type: "float"
            }
          }
        },
        S10: {
          type: "structure",
          members: {
            ProjectArn: {},
            ProjectName: {},
            CreationTimestamp: {
              type: "timestamp"
            }
          }
        },
        S1h: {
          type: "structure",
          required: [
            "Bucket",
            "Key"
          ],
          members: {
            Bucket: {},
            Key: {}
          }
        },
        S1n: {
          type: "structure",
          required: [
            "Greengrass"
          ],
          members: {
            Greengrass: {
              type: "structure",
              required: [
                "S3OutputLocation",
                "ComponentName"
              ],
              members: {
                CompilerOptions: {},
                TargetDevice: {},
                TargetPlatform: {
                  type: "structure",
                  required: [
                    "Os",
                    "Arch"
                  ],
                  members: {
                    Os: {},
                    Arch: {},
                    Accelerator: {}
                  }
                },
                S3OutputLocation: {
                  shape: "Sj"
                },
                ComponentName: {},
                ComponentVersion: {},
                ComponentDescription: {},
                Tags: {
                  shape: "Sm"
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/lookoutvision-2020-11-20.paginators.json
var require_lookoutvision_2020_11_20_paginators = __commonJS({
  "node_modules/aws-sdk/apis/lookoutvision-2020-11-20.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListDatasetEntries: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "DatasetEntries"
        },
        ListModelPackagingJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ModelPackagingJobs"
        },
        ListModels: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Models"
        },
        ListProjects: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Projects"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/lookoutvision.js
var require_lookoutvision = __commonJS({
  "node_modules/aws-sdk/clients/lookoutvision.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["lookoutvision"] = {};
    AWS2.LookoutVision = Service.defineService("lookoutvision", ["2020-11-20"]);
    Object.defineProperty(apiLoader.services["lookoutvision"], "2020-11-20", {
      get: function get() {
        var model = require_lookoutvision_2020_11_20_min();
        model.paginators = require_lookoutvision_2020_11_20_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.LookoutVision;
  }
});

// node_modules/aws-sdk/apis/sagemaker-featurestore-runtime-2020-07-01.min.json
var require_sagemaker_featurestore_runtime_2020_07_01_min = __commonJS({
  "node_modules/aws-sdk/apis/sagemaker-featurestore-runtime-2020-07-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-07-01",
        endpointPrefix: "featurestore-runtime.sagemaker",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon SageMaker Feature Store Runtime",
        serviceId: "SageMaker FeatureStore Runtime",
        signatureVersion: "v4",
        signingName: "sagemaker",
        uid: "sagemaker-featurestore-runtime-2020-07-01"
      },
      operations: {
        BatchGetRecord: {
          http: {
            requestUri: "/BatchGetRecord"
          },
          input: {
            type: "structure",
            required: [
              "Identifiers"
            ],
            members: {
              Identifiers: {
                type: "list",
                member: {
                  shape: "S3"
                }
              },
              ExpirationTimeResponse: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Records",
              "Errors",
              "UnprocessedIdentifiers"
            ],
            members: {
              Records: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "FeatureGroupName",
                    "RecordIdentifierValueAsString",
                    "Record"
                  ],
                  members: {
                    FeatureGroupName: {},
                    RecordIdentifierValueAsString: {},
                    Record: {
                      shape: "Sd"
                    },
                    ExpiresAt: {}
                  }
                }
              },
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "FeatureGroupName",
                    "RecordIdentifierValueAsString",
                    "ErrorCode",
                    "ErrorMessage"
                  ],
                  members: {
                    FeatureGroupName: {},
                    RecordIdentifierValueAsString: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              },
              UnprocessedIdentifiers: {
                type: "list",
                member: {
                  shape: "S3"
                }
              }
            }
          }
        },
        DeleteRecord: {
          http: {
            method: "DELETE",
            requestUri: "/FeatureGroup/{FeatureGroupName}"
          },
          input: {
            type: "structure",
            required: [
              "FeatureGroupName",
              "RecordIdentifierValueAsString",
              "EventTime"
            ],
            members: {
              FeatureGroupName: {
                location: "uri",
                locationName: "FeatureGroupName"
              },
              RecordIdentifierValueAsString: {
                location: "querystring",
                locationName: "RecordIdentifierValueAsString"
              },
              EventTime: {
                location: "querystring",
                locationName: "EventTime"
              },
              TargetStores: {
                shape: "Sm",
                location: "querystring",
                locationName: "TargetStores"
              },
              DeletionMode: {
                location: "querystring",
                locationName: "DeletionMode"
              }
            }
          }
        },
        GetRecord: {
          http: {
            method: "GET",
            requestUri: "/FeatureGroup/{FeatureGroupName}"
          },
          input: {
            type: "structure",
            required: [
              "FeatureGroupName",
              "RecordIdentifierValueAsString"
            ],
            members: {
              FeatureGroupName: {
                location: "uri",
                locationName: "FeatureGroupName"
              },
              RecordIdentifierValueAsString: {
                location: "querystring",
                locationName: "RecordIdentifierValueAsString"
              },
              FeatureNames: {
                shape: "S7",
                location: "querystring",
                locationName: "FeatureName"
              },
              ExpirationTimeResponse: {
                location: "querystring",
                locationName: "ExpirationTimeResponse"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Record: {
                shape: "Sd"
              },
              ExpiresAt: {}
            }
          }
        },
        PutRecord: {
          http: {
            method: "PUT",
            requestUri: "/FeatureGroup/{FeatureGroupName}"
          },
          input: {
            type: "structure",
            required: [
              "FeatureGroupName",
              "Record"
            ],
            members: {
              FeatureGroupName: {
                location: "uri",
                locationName: "FeatureGroupName"
              },
              Record: {
                shape: "Sd"
              },
              TargetStores: {
                shape: "Sm"
              },
              TtlDuration: {
                type: "structure",
                required: [
                  "Unit",
                  "Value"
                ],
                members: {
                  Unit: {},
                  Value: {
                    type: "integer"
                  }
                }
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          required: [
            "FeatureGroupName",
            "RecordIdentifiersValueAsString"
          ],
          members: {
            FeatureGroupName: {},
            RecordIdentifiersValueAsString: {
              type: "list",
              member: {}
            },
            FeatureNames: {
              shape: "S7"
            }
          }
        },
        S7: {
          type: "list",
          member: {}
        },
        Sd: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "FeatureName"
            ],
            members: {
              FeatureName: {},
              ValueAsString: {},
              ValueAsStringList: {
                type: "list",
                member: {}
              }
            }
          }
        },
        Sm: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/sagemaker-featurestore-runtime-2020-07-01.paginators.json
var require_sagemaker_featurestore_runtime_2020_07_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/sagemaker-featurestore-runtime-2020-07-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/sagemakerfeaturestoreruntime.js
var require_sagemakerfeaturestoreruntime = __commonJS({
  "node_modules/aws-sdk/clients/sagemakerfeaturestoreruntime.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["sagemakerfeaturestoreruntime"] = {};
    AWS2.SageMakerFeatureStoreRuntime = Service.defineService("sagemakerfeaturestoreruntime", ["2020-07-01"]);
    Object.defineProperty(apiLoader.services["sagemakerfeaturestoreruntime"], "2020-07-01", {
      get: function get() {
        var model = require_sagemaker_featurestore_runtime_2020_07_01_min();
        model.paginators = require_sagemaker_featurestore_runtime_2020_07_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.SageMakerFeatureStoreRuntime;
  }
});

// node_modules/aws-sdk/apis/customer-profiles-2020-08-15.min.json
var require_customer_profiles_2020_08_15_min = __commonJS({
  "node_modules/aws-sdk/apis/customer-profiles-2020-08-15.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-08-15",
        endpointPrefix: "profile",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Customer Profiles",
        serviceFullName: "Amazon Connect Customer Profiles",
        serviceId: "Customer Profiles",
        signatureVersion: "v4",
        signingName: "profile",
        uid: "customer-profiles-2020-08-15"
      },
      operations: {
        AddProfileKey: {
          http: {
            requestUri: "/domains/{DomainName}/profiles/keys"
          },
          input: {
            type: "structure",
            required: [
              "ProfileId",
              "KeyName",
              "Values",
              "DomainName"
            ],
            members: {
              ProfileId: {},
              KeyName: {},
              Values: {
                shape: "S4"
              },
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KeyName: {},
              Values: {
                shape: "S4"
              }
            }
          }
        },
        CreateCalculatedAttributeDefinition: {
          http: {
            requestUri: "/domains/{DomainName}/calculated-attributes/{CalculatedAttributeName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "CalculatedAttributeName",
              "AttributeDetails",
              "Statistic"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              CalculatedAttributeName: {
                location: "uri",
                locationName: "CalculatedAttributeName"
              },
              DisplayName: {},
              Description: {
                shape: "Sa"
              },
              AttributeDetails: {
                shape: "Sb"
              },
              Conditions: {
                shape: "Sf"
              },
              Statistic: {
                shape: "Sm"
              },
              Tags: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CalculatedAttributeName: {},
              DisplayName: {},
              Description: {
                shape: "Sa"
              },
              AttributeDetails: {
                shape: "Sb"
              },
              Conditions: {
                shape: "Sf"
              },
              Statistic: {
                shape: "Sm"
              },
              CreatedAt: {
                type: "timestamp"
              },
              LastUpdatedAt: {
                type: "timestamp"
              },
              Tags: {
                shape: "Sn"
              }
            }
          }
        },
        CreateDomain: {
          http: {
            requestUri: "/domains/{DomainName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "DefaultExpirationDays"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              DefaultExpirationDays: {
                type: "integer"
              },
              DefaultEncryptionKey: {},
              DeadLetterQueueUrl: {},
              Matching: {
                shape: "Sw"
              },
              RuleBasedMatching: {
                shape: "S1c"
              },
              Tags: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainName",
              "DefaultExpirationDays",
              "CreatedAt",
              "LastUpdatedAt"
            ],
            members: {
              DomainName: {},
              DefaultExpirationDays: {
                type: "integer"
              },
              DefaultEncryptionKey: {},
              DeadLetterQueueUrl: {},
              Matching: {
                shape: "S1o"
              },
              RuleBasedMatching: {
                shape: "S1p"
              },
              CreatedAt: {
                type: "timestamp"
              },
              LastUpdatedAt: {
                type: "timestamp"
              },
              Tags: {
                shape: "Sn"
              }
            }
          }
        },
        CreateEventStream: {
          http: {
            requestUri: "/domains/{DomainName}/event-streams/{EventStreamName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Uri",
              "EventStreamName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              Uri: {},
              EventStreamName: {
                location: "uri",
                locationName: "EventStreamName"
              },
              Tags: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EventStreamArn"
            ],
            members: {
              EventStreamArn: {},
              Tags: {
                shape: "Sn"
              }
            }
          }
        },
        CreateIntegrationWorkflow: {
          http: {
            requestUri: "/domains/{DomainName}/workflows/integrations"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "WorkflowType",
              "IntegrationConfig",
              "ObjectTypeName",
              "RoleArn"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              WorkflowType: {},
              IntegrationConfig: {
                type: "structure",
                members: {
                  AppflowIntegration: {
                    type: "structure",
                    required: [
                      "FlowDefinition"
                    ],
                    members: {
                      FlowDefinition: {
                        shape: "S1x"
                      },
                      Batches: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "StartTime",
                            "EndTime"
                          ],
                          members: {
                            StartTime: {
                              type: "timestamp"
                            },
                            EndTime: {
                              type: "timestamp"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              ObjectTypeName: {},
              RoleArn: {},
              Tags: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "WorkflowId",
              "Message"
            ],
            members: {
              WorkflowId: {},
              Message: {}
            }
          }
        },
        CreateProfile: {
          http: {
            requestUri: "/domains/{DomainName}/profiles"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              AccountNumber: {
                shape: "S39"
              },
              AdditionalInformation: {
                shape: "S3a"
              },
              PartyType: {
                shape: "S3b"
              },
              BusinessName: {
                shape: "S39"
              },
              FirstName: {
                shape: "S39"
              },
              MiddleName: {
                shape: "S39"
              },
              LastName: {
                shape: "S39"
              },
              BirthDate: {
                shape: "S39"
              },
              Gender: {
                shape: "S3c"
              },
              PhoneNumber: {
                shape: "S39"
              },
              MobilePhoneNumber: {
                shape: "S39"
              },
              HomePhoneNumber: {
                shape: "S39"
              },
              BusinessPhoneNumber: {
                shape: "S39"
              },
              EmailAddress: {
                shape: "S39"
              },
              PersonalEmailAddress: {
                shape: "S39"
              },
              BusinessEmailAddress: {
                shape: "S39"
              },
              Address: {
                shape: "S3d"
              },
              ShippingAddress: {
                shape: "S3d"
              },
              MailingAddress: {
                shape: "S3d"
              },
              BillingAddress: {
                shape: "S3d"
              },
              Attributes: {
                shape: "S3e"
              },
              PartyTypeString: {
                shape: "S39"
              },
              GenderString: {
                shape: "S39"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ProfileId"
            ],
            members: {
              ProfileId: {}
            }
          }
        },
        DeleteCalculatedAttributeDefinition: {
          http: {
            method: "DELETE",
            requestUri: "/domains/{DomainName}/calculated-attributes/{CalculatedAttributeName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "CalculatedAttributeName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              CalculatedAttributeName: {
                location: "uri",
                locationName: "CalculatedAttributeName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDomain: {
          http: {
            method: "DELETE",
            requestUri: "/domains/{DomainName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Message"
            ],
            members: {
              Message: {}
            }
          }
        },
        DeleteEventStream: {
          http: {
            method: "DELETE",
            requestUri: "/domains/{DomainName}/event-streams/{EventStreamName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "EventStreamName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              EventStreamName: {
                location: "uri",
                locationName: "EventStreamName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteIntegration: {
          http: {
            requestUri: "/domains/{DomainName}/integrations/delete"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Uri"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              Uri: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Message"
            ],
            members: {
              Message: {}
            }
          }
        },
        DeleteProfile: {
          http: {
            requestUri: "/domains/{DomainName}/profiles/delete"
          },
          input: {
            type: "structure",
            required: [
              "ProfileId",
              "DomainName"
            ],
            members: {
              ProfileId: {},
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Message: {}
            }
          }
        },
        DeleteProfileKey: {
          http: {
            requestUri: "/domains/{DomainName}/profiles/keys/delete"
          },
          input: {
            type: "structure",
            required: [
              "ProfileId",
              "KeyName",
              "Values",
              "DomainName"
            ],
            members: {
              ProfileId: {},
              KeyName: {},
              Values: {
                shape: "S4"
              },
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Message: {}
            }
          }
        },
        DeleteProfileObject: {
          http: {
            requestUri: "/domains/{DomainName}/profiles/objects/delete"
          },
          input: {
            type: "structure",
            required: [
              "ProfileId",
              "ProfileObjectUniqueKey",
              "ObjectTypeName",
              "DomainName"
            ],
            members: {
              ProfileId: {},
              ProfileObjectUniqueKey: {},
              ObjectTypeName: {},
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Message: {}
            }
          }
        },
        DeleteProfileObjectType: {
          http: {
            method: "DELETE",
            requestUri: "/domains/{DomainName}/object-types/{ObjectTypeName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "ObjectTypeName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              ObjectTypeName: {
                location: "uri",
                locationName: "ObjectTypeName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Message"
            ],
            members: {
              Message: {}
            }
          }
        },
        DeleteWorkflow: {
          http: {
            method: "DELETE",
            requestUri: "/domains/{DomainName}/workflows/{WorkflowId}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "WorkflowId"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              WorkflowId: {
                location: "uri",
                locationName: "WorkflowId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DetectProfileObjectType: {
          http: {
            requestUri: "/domains/{DomainName}/detect/object-types"
          },
          input: {
            type: "structure",
            required: [
              "Objects",
              "DomainName"
            ],
            members: {
              Objects: {
                type: "list",
                member: {
                  shape: "S41"
                },
                sensitive: true
              },
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DetectedProfileObjectTypes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SourceLastUpdatedTimestampFormat: {},
                    Fields: {
                      shape: "S45"
                    },
                    Keys: {
                      shape: "S49"
                    }
                  }
                }
              }
            }
          }
        },
        GetAutoMergingPreview: {
          http: {
            requestUri: "/domains/{DomainName}/identity-resolution-jobs/auto-merging-preview"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Consolidation",
              "ConflictResolution"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              Consolidation: {
                shape: "S12"
              },
              ConflictResolution: {
                shape: "S15"
              },
              MinAllowedConfidenceScoreForMerging: {
                type: "double"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              NumberOfMatchesInSample: {
                type: "long"
              },
              NumberOfProfilesInSample: {
                type: "long"
              },
              NumberOfProfilesWillBeMerged: {
                type: "long"
              }
            }
          }
        },
        GetCalculatedAttributeDefinition: {
          http: {
            method: "GET",
            requestUri: "/domains/{DomainName}/calculated-attributes/{CalculatedAttributeName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "CalculatedAttributeName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              CalculatedAttributeName: {
                location: "uri",
                locationName: "CalculatedAttributeName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CalculatedAttributeName: {},
              DisplayName: {},
              Description: {
                shape: "Sa"
              },
              CreatedAt: {
                type: "timestamp"
              },
              LastUpdatedAt: {
                type: "timestamp"
              },
              Statistic: {
                shape: "Sm"
              },
              Conditions: {
                shape: "Sf"
              },
              AttributeDetails: {
                shape: "Sb"
              },
              Tags: {
                shape: "Sn"
              }
            }
          }
        },
        GetCalculatedAttributeForProfile: {
          http: {
            method: "GET",
            requestUri: "/domains/{DomainName}/profile/{ProfileId}/calculated-attributes/{CalculatedAttributeName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "ProfileId",
              "CalculatedAttributeName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              ProfileId: {
                location: "uri",
                locationName: "ProfileId"
              },
              CalculatedAttributeName: {
                location: "uri",
                locationName: "CalculatedAttributeName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CalculatedAttributeName: {},
              DisplayName: {},
              IsDataPartial: {},
              Value: {}
            }
          }
        },
        GetDomain: {
          http: {
            method: "GET",
            requestUri: "/domains/{DomainName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainName",
              "CreatedAt",
              "LastUpdatedAt"
            ],
            members: {
              DomainName: {},
              DefaultExpirationDays: {
                type: "integer"
              },
              DefaultEncryptionKey: {},
              DeadLetterQueueUrl: {},
              Stats: {
                type: "structure",
                members: {
                  ProfileCount: {
                    type: "long"
                  },
                  MeteringProfileCount: {
                    type: "long"
                  },
                  ObjectCount: {
                    type: "long"
                  },
                  TotalSize: {
                    type: "long"
                  }
                }
              },
              Matching: {
                shape: "S1o"
              },
              RuleBasedMatching: {
                shape: "S1p"
              },
              CreatedAt: {
                type: "timestamp"
              },
              LastUpdatedAt: {
                type: "timestamp"
              },
              Tags: {
                shape: "Sn"
              }
            }
          }
        },
        GetEventStream: {
          http: {
            method: "GET",
            requestUri: "/domains/{DomainName}/event-streams/{EventStreamName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "EventStreamName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              EventStreamName: {
                location: "uri",
                locationName: "EventStreamName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainName",
              "EventStreamArn",
              "CreatedAt",
              "State",
              "DestinationDetails"
            ],
            members: {
              DomainName: {},
              EventStreamArn: {},
              CreatedAt: {
                type: "timestamp"
              },
              State: {},
              StoppedSince: {
                type: "timestamp"
              },
              DestinationDetails: {
                type: "structure",
                required: [
                  "Uri",
                  "Status"
                ],
                members: {
                  Uri: {},
                  Status: {},
                  UnhealthySince: {
                    type: "timestamp"
                  },
                  Message: {}
                }
              },
              Tags: {
                shape: "Sn"
              }
            }
          }
        },
        GetIdentityResolutionJob: {
          http: {
            method: "GET",
            requestUri: "/domains/{DomainName}/identity-resolution-jobs/{JobId}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "JobId"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              JobId: {
                location: "uri",
                locationName: "JobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainName: {},
              JobId: {},
              Status: {},
              Message: {},
              JobStartTime: {
                type: "timestamp"
              },
              JobEndTime: {
                type: "timestamp"
              },
              LastUpdatedAt: {
                type: "timestamp"
              },
              JobExpirationTime: {
                type: "timestamp"
              },
              AutoMerging: {
                shape: "S11"
              },
              ExportingLocation: {
                shape: "S4y"
              },
              JobStats: {
                shape: "S51"
              }
            }
          }
        },
        GetIntegration: {
          http: {
            requestUri: "/domains/{DomainName}/integrations"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Uri"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              Uri: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainName",
              "Uri",
              "CreatedAt",
              "LastUpdatedAt"
            ],
            members: {
              DomainName: {},
              Uri: {},
              ObjectTypeName: {},
              CreatedAt: {
                type: "timestamp"
              },
              LastUpdatedAt: {
                type: "timestamp"
              },
              Tags: {
                shape: "Sn"
              },
              ObjectTypeNames: {
                shape: "S54"
              },
              WorkflowId: {},
              IsUnstructured: {
                type: "boolean"
              }
            }
          }
        },
        GetMatches: {
          http: {
            method: "GET",
            requestUri: "/domains/{DomainName}/matches"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              MatchGenerationDate: {
                type: "timestamp"
              },
              PotentialMatches: {
                type: "integer"
              },
              Matches: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MatchId: {},
                    ProfileIds: {
                      shape: "S5c"
                    },
                    ConfidenceScore: {
                      type: "double"
                    }
                  }
                }
              }
            }
          }
        },
        GetProfileObjectType: {
          http: {
            method: "GET",
            requestUri: "/domains/{DomainName}/object-types/{ObjectTypeName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "ObjectTypeName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              ObjectTypeName: {
                location: "uri",
                locationName: "ObjectTypeName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ObjectTypeName",
              "Description"
            ],
            members: {
              ObjectTypeName: {},
              Description: {
                shape: "Sa"
              },
              TemplateId: {},
              ExpirationDays: {
                type: "integer"
              },
              EncryptionKey: {},
              AllowProfileCreation: {
                type: "boolean"
              },
              SourceLastUpdatedTimestampFormat: {},
              Fields: {
                shape: "S45"
              },
              Keys: {
                shape: "S49"
              },
              CreatedAt: {
                type: "timestamp"
              },
              LastUpdatedAt: {
                type: "timestamp"
              },
              Tags: {
                shape: "Sn"
              }
            }
          }
        },
        GetProfileObjectTypeTemplate: {
          http: {
            method: "GET",
            requestUri: "/templates/{TemplateId}"
          },
          input: {
            type: "structure",
            required: [
              "TemplateId"
            ],
            members: {
              TemplateId: {
                location: "uri",
                locationName: "TemplateId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplateId: {},
              SourceName: {},
              SourceObject: {},
              AllowProfileCreation: {
                type: "boolean"
              },
              SourceLastUpdatedTimestampFormat: {},
              Fields: {
                shape: "S45"
              },
              Keys: {
                shape: "S49"
              }
            }
          }
        },
        GetSimilarProfiles: {
          http: {
            requestUri: "/domains/{DomainName}/matches"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "MatchType",
              "SearchKey",
              "SearchValue"
            ],
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              MatchType: {},
              SearchKey: {},
              SearchValue: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProfileIds: {
                shape: "S5c"
              },
              MatchId: {},
              MatchType: {},
              RuleLevel: {
                type: "integer"
              },
              ConfidenceScore: {
                type: "double"
              },
              NextToken: {}
            }
          }
        },
        GetWorkflow: {
          http: {
            method: "GET",
            requestUri: "/domains/{DomainName}/workflows/{WorkflowId}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "WorkflowId"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              WorkflowId: {
                location: "uri",
                locationName: "WorkflowId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkflowId: {},
              WorkflowType: {},
              Status: {},
              ErrorDescription: {},
              StartDate: {
                type: "timestamp"
              },
              LastUpdatedAt: {
                type: "timestamp"
              },
              Attributes: {
                type: "structure",
                members: {
                  AppflowIntegration: {
                    type: "structure",
                    required: [
                      "SourceConnectorType",
                      "ConnectorProfileName"
                    ],
                    members: {
                      SourceConnectorType: {},
                      ConnectorProfileName: {},
                      RoleArn: {}
                    }
                  }
                }
              },
              Metrics: {
                type: "structure",
                members: {
                  AppflowIntegration: {
                    type: "structure",
                    required: [
                      "RecordsProcessed",
                      "StepsCompleted",
                      "TotalSteps"
                    ],
                    members: {
                      RecordsProcessed: {
                        type: "long"
                      },
                      StepsCompleted: {
                        type: "long"
                      },
                      TotalSteps: {
                        type: "long"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetWorkflowSteps: {
          http: {
            method: "GET",
            requestUri: "/domains/{DomainName}/workflows/{WorkflowId}/steps"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "WorkflowId"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              WorkflowId: {
                location: "uri",
                locationName: "WorkflowId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkflowId: {},
              WorkflowType: {},
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AppflowIntegration: {
                      type: "structure",
                      required: [
                        "FlowName",
                        "Status",
                        "ExecutionMessage",
                        "RecordsProcessed",
                        "BatchRecordsStartTime",
                        "BatchRecordsEndTime",
                        "CreatedAt",
                        "LastUpdatedAt"
                      ],
                      members: {
                        FlowName: {},
                        Status: {},
                        ExecutionMessage: {},
                        RecordsProcessed: {
                          type: "long"
                        },
                        BatchRecordsStartTime: {},
                        BatchRecordsEndTime: {},
                        CreatedAt: {
                          type: "timestamp"
                        },
                        LastUpdatedAt: {
                          type: "timestamp"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListAccountIntegrations: {
          http: {
            requestUri: "/integrations"
          },
          input: {
            type: "structure",
            required: [
              "Uri"
            ],
            members: {
              Uri: {},
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              IncludeHidden: {
                location: "querystring",
                locationName: "include-hidden",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                shape: "S60"
              },
              NextToken: {}
            }
          }
        },
        ListCalculatedAttributeDefinitions: {
          http: {
            method: "GET",
            requestUri: "/domains/{DomainName}/calculated-attributes"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CalculatedAttributeName: {},
                    DisplayName: {},
                    Description: {
                      shape: "Sa"
                    },
                    CreatedAt: {
                      type: "timestamp"
                    },
                    LastUpdatedAt: {
                      type: "timestamp"
                    },
                    Tags: {
                      shape: "Sn"
                    }
                  }
                },
                sensitive: true
              },
              NextToken: {}
            }
          }
        },
        ListCalculatedAttributesForProfile: {
          http: {
            method: "GET",
            requestUri: "/domains/{DomainName}/profile/{ProfileId}/calculated-attributes"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "ProfileId"
            ],
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              ProfileId: {
                location: "uri",
                locationName: "ProfileId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CalculatedAttributeName: {},
                    DisplayName: {},
                    IsDataPartial: {},
                    Value: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDomains: {
          http: {
            method: "GET",
            requestUri: "/domains"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "DomainName",
                    "CreatedAt",
                    "LastUpdatedAt"
                  ],
                  members: {
                    DomainName: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    LastUpdatedAt: {
                      type: "timestamp"
                    },
                    Tags: {
                      shape: "Sn"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEventStreams: {
          http: {
            method: "GET",
            requestUri: "/domains/{DomainName}/event-streams"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "DomainName",
                    "EventStreamName",
                    "EventStreamArn",
                    "State"
                  ],
                  members: {
                    DomainName: {},
                    EventStreamName: {},
                    EventStreamArn: {},
                    State: {},
                    StoppedSince: {
                      type: "timestamp"
                    },
                    DestinationSummary: {
                      type: "structure",
                      required: [
                        "Uri",
                        "Status"
                      ],
                      members: {
                        Uri: {},
                        Status: {},
                        UnhealthySince: {
                          type: "timestamp"
                        }
                      }
                    },
                    Tags: {
                      shape: "Sn"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListIdentityResolutionJobs: {
          http: {
            method: "GET",
            requestUri: "/domains/{DomainName}/identity-resolution-jobs"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityResolutionJobsList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DomainName: {},
                    JobId: {},
                    Status: {},
                    JobStartTime: {
                      type: "timestamp"
                    },
                    JobEndTime: {
                      type: "timestamp"
                    },
                    JobStats: {
                      shape: "S51"
                    },
                    ExportingLocation: {
                      shape: "S4y"
                    },
                    Message: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListIntegrations: {
          http: {
            method: "GET",
            requestUri: "/domains/{DomainName}/integrations"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              IncludeHidden: {
                location: "querystring",
                locationName: "include-hidden",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                shape: "S60"
              },
              NextToken: {}
            }
          }
        },
        ListProfileObjectTypeTemplates: {
          http: {
            method: "GET",
            requestUri: "/templates"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TemplateId: {},
                    SourceName: {},
                    SourceObject: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListProfileObjectTypes: {
          http: {
            method: "GET",
            requestUri: "/domains/{DomainName}/object-types"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ObjectTypeName",
                    "Description"
                  ],
                  members: {
                    ObjectTypeName: {},
                    Description: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    LastUpdatedAt: {
                      type: "timestamp"
                    },
                    Tags: {
                      shape: "Sn"
                    }
                  }
                },
                sensitive: true
              },
              NextToken: {}
            }
          }
        },
        ListProfileObjects: {
          http: {
            requestUri: "/domains/{DomainName}/profiles/objects"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "ObjectTypeName",
              "ProfileId"
            ],
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              ObjectTypeName: {},
              ProfileId: {},
              ObjectFilter: {
                type: "structure",
                required: [
                  "KeyName",
                  "Values"
                ],
                members: {
                  KeyName: {},
                  Values: {
                    shape: "S4"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ObjectTypeName: {},
                    ProfileObjectUniqueKey: {},
                    Object: {
                      shape: "S41"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListRuleBasedMatches: {
          http: {
            method: "GET",
            requestUri: "/domains/{DomainName}/profiles/ruleBasedMatches"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MatchIds: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sn"
              }
            }
          }
        },
        ListWorkflows: {
          http: {
            requestUri: "/domains/{DomainName}/workflows"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              WorkflowType: {},
              Status: {},
              QueryStartDate: {
                type: "timestamp"
              },
              QueryEndDate: {
                type: "timestamp"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "WorkflowType",
                    "WorkflowId",
                    "Status",
                    "StatusDescription",
                    "CreatedAt",
                    "LastUpdatedAt"
                  ],
                  members: {
                    WorkflowType: {},
                    WorkflowId: {},
                    Status: {},
                    StatusDescription: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    LastUpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        MergeProfiles: {
          http: {
            requestUri: "/domains/{DomainName}/profiles/objects/merge"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "MainProfileId",
              "ProfileIdsToBeMerged"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              MainProfileId: {},
              ProfileIdsToBeMerged: {
                type: "list",
                member: {}
              },
              FieldSourceProfileIds: {
                type: "structure",
                members: {
                  AccountNumber: {},
                  AdditionalInformation: {},
                  PartyType: {},
                  BusinessName: {},
                  FirstName: {},
                  MiddleName: {},
                  LastName: {},
                  BirthDate: {},
                  Gender: {},
                  PhoneNumber: {},
                  MobilePhoneNumber: {},
                  HomePhoneNumber: {},
                  BusinessPhoneNumber: {},
                  EmailAddress: {},
                  PersonalEmailAddress: {},
                  BusinessEmailAddress: {},
                  Address: {},
                  ShippingAddress: {},
                  MailingAddress: {},
                  BillingAddress: {},
                  Attributes: {
                    type: "map",
                    key: {},
                    value: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Message: {}
            }
          }
        },
        PutIntegration: {
          http: {
            method: "PUT",
            requestUri: "/domains/{DomainName}/integrations"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              Uri: {},
              ObjectTypeName: {},
              Tags: {
                shape: "Sn"
              },
              FlowDefinition: {
                shape: "S1x"
              },
              ObjectTypeNames: {
                shape: "S54"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainName",
              "Uri",
              "CreatedAt",
              "LastUpdatedAt"
            ],
            members: {
              DomainName: {},
              Uri: {},
              ObjectTypeName: {},
              CreatedAt: {
                type: "timestamp"
              },
              LastUpdatedAt: {
                type: "timestamp"
              },
              Tags: {
                shape: "Sn"
              },
              ObjectTypeNames: {
                shape: "S54"
              },
              WorkflowId: {},
              IsUnstructured: {
                type: "boolean"
              }
            }
          }
        },
        PutProfileObject: {
          http: {
            method: "PUT",
            requestUri: "/domains/{DomainName}/profiles/objects"
          },
          input: {
            type: "structure",
            required: [
              "ObjectTypeName",
              "Object",
              "DomainName"
            ],
            members: {
              ObjectTypeName: {},
              Object: {
                shape: "S41"
              },
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProfileObjectUniqueKey: {}
            }
          }
        },
        PutProfileObjectType: {
          http: {
            method: "PUT",
            requestUri: "/domains/{DomainName}/object-types/{ObjectTypeName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "ObjectTypeName",
              "Description"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              ObjectTypeName: {
                location: "uri",
                locationName: "ObjectTypeName"
              },
              Description: {
                shape: "Sa"
              },
              TemplateId: {},
              ExpirationDays: {
                type: "integer"
              },
              EncryptionKey: {},
              AllowProfileCreation: {
                type: "boolean"
              },
              SourceLastUpdatedTimestampFormat: {},
              Fields: {
                shape: "S45"
              },
              Keys: {
                shape: "S49"
              },
              Tags: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ObjectTypeName",
              "Description"
            ],
            members: {
              ObjectTypeName: {},
              Description: {
                shape: "Sa"
              },
              TemplateId: {},
              ExpirationDays: {
                type: "integer"
              },
              EncryptionKey: {},
              AllowProfileCreation: {
                type: "boolean"
              },
              SourceLastUpdatedTimestampFormat: {},
              Fields: {
                shape: "S45"
              },
              Keys: {
                shape: "S49"
              },
              CreatedAt: {
                type: "timestamp"
              },
              LastUpdatedAt: {
                type: "timestamp"
              },
              Tags: {
                shape: "Sn"
              }
            }
          }
        },
        SearchProfiles: {
          http: {
            requestUri: "/domains/{DomainName}/profiles/search"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "KeyName",
              "Values"
            ],
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              KeyName: {},
              Values: {
                shape: "S4"
              },
              AdditionalSearchKeys: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "KeyName",
                    "Values"
                  ],
                  members: {
                    KeyName: {},
                    Values: {
                      shape: "S4"
                    }
                  }
                }
              },
              LogicalOperator: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ProfileId: {},
                    AccountNumber: {
                      shape: "S39"
                    },
                    AdditionalInformation: {
                      shape: "S3a"
                    },
                    PartyType: {
                      shape: "S3b"
                    },
                    BusinessName: {
                      shape: "S39"
                    },
                    FirstName: {
                      shape: "S39"
                    },
                    MiddleName: {
                      shape: "S39"
                    },
                    LastName: {
                      shape: "S39"
                    },
                    BirthDate: {
                      shape: "S39"
                    },
                    Gender: {
                      shape: "S3c"
                    },
                    PhoneNumber: {
                      shape: "S39"
                    },
                    MobilePhoneNumber: {
                      shape: "S39"
                    },
                    HomePhoneNumber: {
                      shape: "S39"
                    },
                    BusinessPhoneNumber: {
                      shape: "S39"
                    },
                    EmailAddress: {
                      shape: "S39"
                    },
                    PersonalEmailAddress: {
                      shape: "S39"
                    },
                    BusinessEmailAddress: {
                      shape: "S39"
                    },
                    Address: {
                      shape: "S3d"
                    },
                    ShippingAddress: {
                      shape: "S3d"
                    },
                    MailingAddress: {
                      shape: "S3d"
                    },
                    BillingAddress: {
                      shape: "S3d"
                    },
                    Attributes: {
                      shape: "S3e"
                    },
                    FoundByItems: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          KeyName: {},
                          Values: {
                            shape: "S4"
                          }
                        }
                      }
                    },
                    PartyTypeString: {
                      shape: "S39"
                    },
                    GenderString: {
                      shape: "S39"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateCalculatedAttributeDefinition: {
          http: {
            method: "PUT",
            requestUri: "/domains/{DomainName}/calculated-attributes/{CalculatedAttributeName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "CalculatedAttributeName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              CalculatedAttributeName: {
                location: "uri",
                locationName: "CalculatedAttributeName"
              },
              DisplayName: {},
              Description: {
                shape: "Sa"
              },
              Conditions: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CalculatedAttributeName: {},
              DisplayName: {},
              Description: {
                shape: "Sa"
              },
              CreatedAt: {
                type: "timestamp"
              },
              LastUpdatedAt: {
                type: "timestamp"
              },
              Statistic: {
                shape: "Sm"
              },
              Conditions: {
                shape: "Sf"
              },
              AttributeDetails: {
                shape: "Sb"
              },
              Tags: {
                shape: "Sn"
              }
            }
          }
        },
        UpdateDomain: {
          http: {
            method: "PUT",
            requestUri: "/domains/{DomainName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              DefaultExpirationDays: {
                type: "integer"
              },
              DefaultEncryptionKey: {},
              DeadLetterQueueUrl: {},
              Matching: {
                shape: "Sw"
              },
              RuleBasedMatching: {
                shape: "S1c"
              },
              Tags: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainName",
              "CreatedAt",
              "LastUpdatedAt"
            ],
            members: {
              DomainName: {},
              DefaultExpirationDays: {
                type: "integer"
              },
              DefaultEncryptionKey: {},
              DeadLetterQueueUrl: {},
              Matching: {
                shape: "S1o"
              },
              RuleBasedMatching: {
                shape: "S1p"
              },
              CreatedAt: {
                type: "timestamp"
              },
              LastUpdatedAt: {
                type: "timestamp"
              },
              Tags: {
                shape: "Sn"
              }
            }
          }
        },
        UpdateProfile: {
          http: {
            method: "PUT",
            requestUri: "/domains/{DomainName}/profiles"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "ProfileId"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              ProfileId: {},
              AdditionalInformation: {
                type: "string",
                sensitive: true
              },
              AccountNumber: {
                shape: "S87"
              },
              PartyType: {
                shape: "S3b"
              },
              BusinessName: {
                shape: "S87"
              },
              FirstName: {
                shape: "S87"
              },
              MiddleName: {
                shape: "S87"
              },
              LastName: {
                shape: "S87"
              },
              BirthDate: {
                shape: "S87"
              },
              Gender: {
                shape: "S3c"
              },
              PhoneNumber: {
                shape: "S87"
              },
              MobilePhoneNumber: {
                shape: "S87"
              },
              HomePhoneNumber: {
                shape: "S87"
              },
              BusinessPhoneNumber: {
                shape: "S87"
              },
              EmailAddress: {
                shape: "S87"
              },
              PersonalEmailAddress: {
                shape: "S87"
              },
              BusinessEmailAddress: {
                shape: "S87"
              },
              Address: {
                shape: "S88"
              },
              ShippingAddress: {
                shape: "S88"
              },
              MailingAddress: {
                shape: "S88"
              },
              BillingAddress: {
                shape: "S88"
              },
              Attributes: {
                type: "map",
                key: {},
                value: {},
                sensitive: true
              },
              PartyTypeString: {
                shape: "S87"
              },
              GenderString: {
                shape: "S87"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ProfileId"
            ],
            members: {
              ProfileId: {}
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "list",
          member: {}
        },
        Sa: {
          type: "string",
          sensitive: true
        },
        Sb: {
          type: "structure",
          required: [
            "Attributes",
            "Expression"
          ],
          members: {
            Attributes: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name"
                ],
                members: {
                  Name: {}
                }
              }
            },
            Expression: {}
          },
          sensitive: true
        },
        Sf: {
          type: "structure",
          members: {
            Range: {
              type: "structure",
              required: [
                "Value",
                "Unit"
              ],
              members: {
                Value: {
                  type: "integer"
                },
                Unit: {}
              }
            },
            ObjectCount: {
              type: "integer"
            },
            Threshold: {
              type: "structure",
              required: [
                "Value",
                "Operator"
              ],
              members: {
                Value: {},
                Operator: {}
              }
            }
          },
          sensitive: true
        },
        Sm: {
          type: "string",
          sensitive: true
        },
        Sn: {
          type: "map",
          key: {},
          value: {}
        },
        Sw: {
          type: "structure",
          required: [
            "Enabled"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            JobSchedule: {
              shape: "Sy"
            },
            AutoMerging: {
              shape: "S11"
            },
            ExportingConfig: {
              shape: "S18"
            }
          }
        },
        Sy: {
          type: "structure",
          required: [
            "DayOfTheWeek",
            "Time"
          ],
          members: {
            DayOfTheWeek: {},
            Time: {}
          }
        },
        S11: {
          type: "structure",
          required: [
            "Enabled"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Consolidation: {
              shape: "S12"
            },
            ConflictResolution: {
              shape: "S15"
            },
            MinAllowedConfidenceScoreForMerging: {
              type: "double"
            }
          }
        },
        S12: {
          type: "structure",
          required: [
            "MatchingAttributesList"
          ],
          members: {
            MatchingAttributesList: {
              type: "list",
              member: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S15: {
          type: "structure",
          required: [
            "ConflictResolvingModel"
          ],
          members: {
            ConflictResolvingModel: {},
            SourceName: {}
          }
        },
        S18: {
          type: "structure",
          members: {
            S3Exporting: {
              type: "structure",
              required: [
                "S3BucketName"
              ],
              members: {
                S3BucketName: {},
                S3KeyName: {}
              }
            }
          }
        },
        S1c: {
          type: "structure",
          required: [
            "Enabled"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            MatchingRules: {
              shape: "S1d"
            },
            MaxAllowedRuleLevelForMerging: {
              type: "integer"
            },
            MaxAllowedRuleLevelForMatching: {
              type: "integer"
            },
            AttributeTypesSelector: {
              shape: "S1i"
            },
            ConflictResolution: {
              shape: "S15"
            },
            ExportingConfig: {
              shape: "S18"
            }
          }
        },
        S1d: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Rule"
            ],
            members: {
              Rule: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S1i: {
          type: "structure",
          required: [
            "AttributeMatchingModel"
          ],
          members: {
            AttributeMatchingModel: {},
            Address: {
              type: "list",
              member: {}
            },
            PhoneNumber: {
              type: "list",
              member: {}
            },
            EmailAddress: {
              type: "list",
              member: {}
            }
          }
        },
        S1o: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            JobSchedule: {
              shape: "Sy"
            },
            AutoMerging: {
              shape: "S11"
            },
            ExportingConfig: {
              shape: "S18"
            }
          }
        },
        S1p: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            MatchingRules: {
              shape: "S1d"
            },
            Status: {},
            MaxAllowedRuleLevelForMerging: {
              type: "integer"
            },
            MaxAllowedRuleLevelForMatching: {
              type: "integer"
            },
            AttributeTypesSelector: {
              shape: "S1i"
            },
            ConflictResolution: {
              shape: "S15"
            },
            ExportingConfig: {
              shape: "S18"
            }
          }
        },
        S1x: {
          type: "structure",
          required: [
            "FlowName",
            "KmsArn",
            "SourceFlowConfig",
            "Tasks",
            "TriggerConfig"
          ],
          members: {
            Description: {},
            FlowName: {},
            KmsArn: {},
            SourceFlowConfig: {
              type: "structure",
              required: [
                "ConnectorType",
                "SourceConnectorProperties"
              ],
              members: {
                ConnectorProfileName: {},
                ConnectorType: {},
                IncrementalPullConfig: {
                  type: "structure",
                  members: {
                    DatetimeTypeFieldName: {}
                  }
                },
                SourceConnectorProperties: {
                  type: "structure",
                  members: {
                    Marketo: {
                      type: "structure",
                      required: [
                        "Object"
                      ],
                      members: {
                        Object: {}
                      }
                    },
                    S3: {
                      type: "structure",
                      required: [
                        "BucketName"
                      ],
                      members: {
                        BucketName: {},
                        BucketPrefix: {}
                      }
                    },
                    Salesforce: {
                      type: "structure",
                      required: [
                        "Object"
                      ],
                      members: {
                        Object: {},
                        EnableDynamicFieldUpdate: {
                          type: "boolean"
                        },
                        IncludeDeletedRecords: {
                          type: "boolean"
                        }
                      }
                    },
                    ServiceNow: {
                      type: "structure",
                      required: [
                        "Object"
                      ],
                      members: {
                        Object: {}
                      }
                    },
                    Zendesk: {
                      type: "structure",
                      required: [
                        "Object"
                      ],
                      members: {
                        Object: {}
                      }
                    }
                  }
                }
              }
            },
            Tasks: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "SourceFields",
                  "TaskType"
                ],
                members: {
                  ConnectorOperator: {
                    type: "structure",
                    members: {
                      Marketo: {},
                      S3: {},
                      Salesforce: {},
                      ServiceNow: {},
                      Zendesk: {}
                    }
                  },
                  DestinationField: {},
                  SourceFields: {
                    type: "list",
                    member: {}
                  },
                  TaskProperties: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  TaskType: {}
                }
              }
            },
            TriggerConfig: {
              type: "structure",
              required: [
                "TriggerType"
              ],
              members: {
                TriggerType: {},
                TriggerProperties: {
                  type: "structure",
                  members: {
                    Scheduled: {
                      type: "structure",
                      required: [
                        "ScheduleExpression"
                      ],
                      members: {
                        ScheduleExpression: {},
                        DataPullMode: {},
                        ScheduleStartTime: {
                          type: "timestamp"
                        },
                        ScheduleEndTime: {
                          type: "timestamp"
                        },
                        Timezone: {},
                        ScheduleOffset: {
                          type: "long"
                        },
                        FirstExecutionFrom: {
                          type: "timestamp"
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          sensitive: true
        },
        S39: {
          type: "string",
          sensitive: true
        },
        S3a: {
          type: "string",
          sensitive: true
        },
        S3b: {
          type: "string",
          deprecated: true,
          sensitive: true
        },
        S3c: {
          type: "string",
          deprecated: true,
          sensitive: true
        },
        S3d: {
          type: "structure",
          members: {
            Address1: {},
            Address2: {},
            Address3: {},
            Address4: {},
            City: {},
            County: {},
            State: {},
            Province: {},
            Country: {},
            PostalCode: {}
          },
          sensitive: true
        },
        S3e: {
          type: "map",
          key: {},
          value: {},
          sensitive: true
        },
        S41: {
          type: "string",
          sensitive: true
        },
        S45: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              Source: {},
              Target: {},
              ContentType: {}
            }
          },
          sensitive: true
        },
        S49: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {
              type: "structure",
              members: {
                StandardIdentifiers: {
                  type: "list",
                  member: {}
                },
                FieldNames: {
                  type: "list",
                  member: {}
                }
              }
            }
          },
          sensitive: true
        },
        S4y: {
          type: "structure",
          members: {
            S3Exporting: {
              type: "structure",
              members: {
                S3BucketName: {},
                S3KeyName: {}
              }
            }
          }
        },
        S51: {
          type: "structure",
          members: {
            NumberOfProfilesReviewed: {
              type: "long"
            },
            NumberOfMatchesFound: {
              type: "long"
            },
            NumberOfMergesDone: {
              type: "long"
            }
          }
        },
        S54: {
          type: "map",
          key: {},
          value: {}
        },
        S5c: {
          type: "list",
          member: {}
        },
        S60: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "DomainName",
              "Uri",
              "CreatedAt",
              "LastUpdatedAt"
            ],
            members: {
              DomainName: {},
              Uri: {},
              ObjectTypeName: {},
              CreatedAt: {
                type: "timestamp"
              },
              LastUpdatedAt: {
                type: "timestamp"
              },
              Tags: {
                shape: "Sn"
              },
              ObjectTypeNames: {
                shape: "S54"
              },
              WorkflowId: {},
              IsUnstructured: {
                type: "boolean"
              }
            }
          }
        },
        S87: {
          type: "string",
          sensitive: true
        },
        S88: {
          type: "structure",
          members: {
            Address1: {},
            Address2: {},
            Address3: {},
            Address4: {},
            City: {},
            County: {},
            State: {},
            Province: {},
            Country: {},
            PostalCode: {}
          },
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/customer-profiles-2020-08-15.paginators.json
var require_customer_profiles_2020_08_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/customer-profiles-2020-08-15.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListEventStreams: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/customerprofiles.js
var require_customerprofiles = __commonJS({
  "node_modules/aws-sdk/clients/customerprofiles.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["customerprofiles"] = {};
    AWS2.CustomerProfiles = Service.defineService("customerprofiles", ["2020-08-15"]);
    Object.defineProperty(apiLoader.services["customerprofiles"], "2020-08-15", {
      get: function get() {
        var model = require_customer_profiles_2020_08_15_min();
        model.paginators = require_customer_profiles_2020_08_15_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CustomerProfiles;
  }
});

// node_modules/aws-sdk/apis/auditmanager-2017-07-25.min.json
var require_auditmanager_2017_07_25_min = __commonJS({
  "node_modules/aws-sdk/apis/auditmanager-2017-07-25.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-07-25",
        endpointPrefix: "auditmanager",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Audit Manager",
        serviceId: "AuditManager",
        signatureVersion: "v4",
        signingName: "auditmanager",
        uid: "auditmanager-2017-07-25"
      },
      operations: {
        AssociateAssessmentReportEvidenceFolder: {
          http: {
            method: "PUT",
            requestUri: "/assessments/{assessmentId}/associateToAssessmentReport"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId",
              "evidenceFolderId"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              evidenceFolderId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        BatchAssociateAssessmentReportEvidence: {
          http: {
            method: "PUT",
            requestUri: "/assessments/{assessmentId}/batchAssociateToAssessmentReport"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId",
              "evidenceFolderId",
              "evidenceIds"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              evidenceFolderId: {},
              evidenceIds: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              evidenceIds: {
                shape: "S5"
              },
              errors: {
                shape: "S7"
              }
            }
          }
        },
        BatchCreateDelegationByAssessment: {
          http: {
            requestUri: "/assessments/{assessmentId}/delegations"
          },
          input: {
            type: "structure",
            required: [
              "createDelegationRequests",
              "assessmentId"
            ],
            members: {
              createDelegationRequests: {
                type: "list",
                member: {
                  shape: "Sd"
                },
                sensitive: true
              },
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              delegations: {
                shape: "Sj"
              },
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    createDelegationRequest: {
                      shape: "Sd"
                    },
                    errorCode: {},
                    errorMessage: {}
                  }
                },
                sensitive: true
              }
            }
          }
        },
        BatchDeleteDelegationByAssessment: {
          http: {
            method: "PUT",
            requestUri: "/assessments/{assessmentId}/delegations"
          },
          input: {
            type: "structure",
            required: [
              "delegationIds",
              "assessmentId"
            ],
            members: {
              delegationIds: {
                type: "list",
                member: {}
              },
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    delegationId: {},
                    errorCode: {},
                    errorMessage: {}
                  }
                },
                sensitive: true
              }
            }
          }
        },
        BatchDisassociateAssessmentReportEvidence: {
          http: {
            method: "PUT",
            requestUri: "/assessments/{assessmentId}/batchDisassociateFromAssessmentReport"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId",
              "evidenceFolderId",
              "evidenceIds"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              evidenceFolderId: {},
              evidenceIds: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              evidenceIds: {
                shape: "S5"
              },
              errors: {
                shape: "S7"
              }
            }
          }
        },
        BatchImportEvidenceToAssessmentControl: {
          http: {
            requestUri: "/assessments/{assessmentId}/controlSets/{controlSetId}/controls/{controlId}/evidence"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId",
              "controlSetId",
              "controlId",
              "manualEvidence"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              controlSetId: {
                location: "uri",
                locationName: "controlSetId"
              },
              controlId: {
                location: "uri",
                locationName: "controlId"
              },
              manualEvidence: {
                type: "list",
                member: {
                  shape: "S10"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    manualEvidence: {
                      shape: "S10"
                    },
                    errorCode: {},
                    errorMessage: {}
                  }
                }
              }
            }
          }
        },
        CreateAssessment: {
          http: {
            requestUri: "/assessments"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "assessmentReportsDestination",
              "scope",
              "roles",
              "frameworkId"
            ],
            members: {
              name: {
                shape: "Sl"
              },
              description: {
                shape: "S18"
              },
              assessmentReportsDestination: {
                shape: "S19"
              },
              scope: {
                shape: "S1b"
              },
              roles: {
                shape: "S1k"
              },
              frameworkId: {},
              tags: {
                shape: "S1m"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              assessment: {
                shape: "S1q"
              }
            }
          }
        },
        CreateAssessmentFramework: {
          http: {
            requestUri: "/assessmentFrameworks"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "controlSets"
            ],
            members: {
              name: {},
              description: {},
              complianceType: {
                shape: "S1t"
              },
              controlSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name"
                  ],
                  members: {
                    name: {},
                    controls: {
                      shape: "S2l"
                    }
                  }
                }
              },
              tags: {
                shape: "S1m"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              framework: {
                shape: "S2o"
              }
            }
          }
        },
        CreateAssessmentReport: {
          http: {
            requestUri: "/assessments/{assessmentId}/reports"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "assessmentId"
            ],
            members: {
              name: {},
              description: {
                shape: "S3d"
              },
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              queryStatement: {}
            }
          },
          output: {
            type: "structure",
            members: {
              assessmentReport: {
                type: "structure",
                members: {
                  id: {},
                  name: {},
                  description: {
                    shape: "S3d"
                  },
                  awsAccountId: {},
                  assessmentId: {},
                  assessmentName: {
                    shape: "Sl"
                  },
                  author: {
                    shape: "S2b"
                  },
                  status: {},
                  creationTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        CreateControl: {
          http: {
            requestUri: "/controls"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "controlMappingSources"
            ],
            members: {
              name: {},
              description: {},
              testingInformation: {
                shape: "S2w"
              },
              actionPlanTitle: {
                shape: "S2x"
              },
              actionPlanInstructions: {
                shape: "S2y"
              },
              controlMappingSources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    sourceName: {},
                    sourceDescription: {},
                    sourceSetUpOption: {},
                    sourceType: {},
                    sourceKeyword: {
                      shape: "S35"
                    },
                    sourceFrequency: {},
                    troubleshootingText: {
                      shape: "S39"
                    }
                  }
                }
              },
              tags: {
                shape: "S1m"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              control: {
                shape: "S2u"
              }
            }
          }
        },
        DeleteAssessment: {
          http: {
            method: "DELETE",
            requestUri: "/assessments/{assessmentId}"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAssessmentFramework: {
          http: {
            method: "DELETE",
            requestUri: "/assessmentFrameworks/{frameworkId}"
          },
          input: {
            type: "structure",
            required: [
              "frameworkId"
            ],
            members: {
              frameworkId: {
                location: "uri",
                locationName: "frameworkId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAssessmentFrameworkShare: {
          http: {
            method: "DELETE",
            requestUri: "/assessmentFrameworkShareRequests/{requestId}"
          },
          input: {
            type: "structure",
            required: [
              "requestId",
              "requestType"
            ],
            members: {
              requestId: {
                location: "uri",
                locationName: "requestId"
              },
              requestType: {
                location: "querystring",
                locationName: "requestType"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAssessmentReport: {
          http: {
            method: "DELETE",
            requestUri: "/assessments/{assessmentId}/reports/{assessmentReportId}"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId",
              "assessmentReportId"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              assessmentReportId: {
                location: "uri",
                locationName: "assessmentReportId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteControl: {
          http: {
            method: "DELETE",
            requestUri: "/controls/{controlId}"
          },
          input: {
            type: "structure",
            required: [
              "controlId"
            ],
            members: {
              controlId: {
                location: "uri",
                locationName: "controlId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeregisterAccount: {
          http: {
            requestUri: "/account/deregisterAccount"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              status: {}
            }
          }
        },
        DeregisterOrganizationAdminAccount: {
          http: {
            requestUri: "/account/deregisterOrganizationAdminAccount"
          },
          input: {
            type: "structure",
            members: {
              adminAccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateAssessmentReportEvidenceFolder: {
          http: {
            method: "PUT",
            requestUri: "/assessments/{assessmentId}/disassociateFromAssessmentReport"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId",
              "evidenceFolderId"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              evidenceFolderId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetAccountStatus: {
          http: {
            method: "GET",
            requestUri: "/account/status"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              status: {}
            }
          }
        },
        GetAssessment: {
          http: {
            method: "GET",
            requestUri: "/assessments/{assessmentId}"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              assessment: {
                shape: "S1q"
              },
              userRole: {
                shape: "S1l"
              }
            }
          }
        },
        GetAssessmentFramework: {
          http: {
            method: "GET",
            requestUri: "/assessmentFrameworks/{frameworkId}"
          },
          input: {
            type: "structure",
            required: [
              "frameworkId"
            ],
            members: {
              frameworkId: {
                location: "uri",
                locationName: "frameworkId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              framework: {
                shape: "S2o"
              }
            }
          }
        },
        GetAssessmentReportUrl: {
          http: {
            method: "GET",
            requestUri: "/assessments/{assessmentId}/reports/{assessmentReportId}/url"
          },
          input: {
            type: "structure",
            required: [
              "assessmentReportId",
              "assessmentId"
            ],
            members: {
              assessmentReportId: {
                location: "uri",
                locationName: "assessmentReportId"
              },
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              preSignedUrl: {
                type: "structure",
                members: {
                  hyperlinkName: {},
                  link: {}
                }
              }
            }
          }
        },
        GetChangeLogs: {
          http: {
            method: "GET",
            requestUri: "/assessments/{assessmentId}/changelogs"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              controlSetId: {
                location: "querystring",
                locationName: "controlSetId"
              },
              controlId: {
                location: "querystring",
                locationName: "controlId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              changeLogs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    objectType: {},
                    objectName: {},
                    action: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    createdBy: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetControl: {
          http: {
            method: "GET",
            requestUri: "/controls/{controlId}"
          },
          input: {
            type: "structure",
            required: [
              "controlId"
            ],
            members: {
              controlId: {
                location: "uri",
                locationName: "controlId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              control: {
                shape: "S2u"
              }
            }
          }
        },
        GetDelegations: {
          http: {
            method: "GET",
            requestUri: "/delegations"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              delegations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    assessmentName: {
                      shape: "Sl"
                    },
                    assessmentId: {},
                    status: {},
                    roleArn: {},
                    creationTime: {
                      type: "timestamp"
                    },
                    controlSetName: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetEvidence: {
          http: {
            method: "GET",
            requestUri: "/assessments/{assessmentId}/controlSets/{controlSetId}/evidenceFolders/{evidenceFolderId}/evidence/{evidenceId}"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId",
              "controlSetId",
              "evidenceFolderId",
              "evidenceId"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              controlSetId: {
                location: "uri",
                locationName: "controlSetId"
              },
              evidenceFolderId: {
                location: "uri",
                locationName: "evidenceFolderId"
              },
              evidenceId: {
                location: "uri",
                locationName: "evidenceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              evidence: {
                shape: "S4v"
              }
            }
          }
        },
        GetEvidenceByEvidenceFolder: {
          http: {
            method: "GET",
            requestUri: "/assessments/{assessmentId}/controlSets/{controlSetId}/evidenceFolders/{evidenceFolderId}/evidence"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId",
              "controlSetId",
              "evidenceFolderId"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              controlSetId: {
                location: "uri",
                locationName: "controlSetId"
              },
              evidenceFolderId: {
                location: "uri",
                locationName: "evidenceFolderId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              evidence: {
                type: "list",
                member: {
                  shape: "S4v"
                }
              },
              nextToken: {}
            }
          }
        },
        GetEvidenceFileUploadUrl: {
          http: {
            method: "GET",
            requestUri: "/evidenceFileUploadUrl"
          },
          input: {
            type: "structure",
            required: [
              "fileName"
            ],
            members: {
              fileName: {
                shape: "S13",
                location: "querystring",
                locationName: "fileName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              evidenceFileName: {},
              uploadUrl: {}
            },
            sensitive: true
          }
        },
        GetEvidenceFolder: {
          http: {
            method: "GET",
            requestUri: "/assessments/{assessmentId}/controlSets/{controlSetId}/evidenceFolders/{evidenceFolderId}"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId",
              "controlSetId",
              "evidenceFolderId"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              controlSetId: {
                location: "uri",
                locationName: "controlSetId"
              },
              evidenceFolderId: {
                location: "uri",
                locationName: "evidenceFolderId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              evidenceFolder: {
                shape: "S5b"
              }
            }
          }
        },
        GetEvidenceFoldersByAssessment: {
          http: {
            method: "GET",
            requestUri: "/assessments/{assessmentId}/evidenceFolders"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              evidenceFolders: {
                shape: "S5f"
              },
              nextToken: {}
            }
          }
        },
        GetEvidenceFoldersByAssessmentControl: {
          http: {
            method: "GET",
            requestUri: "/assessments/{assessmentId}/evidenceFolders-by-assessment-control/{controlSetId}/{controlId}"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId",
              "controlSetId",
              "controlId"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              controlSetId: {
                location: "uri",
                locationName: "controlSetId"
              },
              controlId: {
                location: "uri",
                locationName: "controlId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              evidenceFolders: {
                shape: "S5f"
              },
              nextToken: {}
            }
          }
        },
        GetInsights: {
          http: {
            method: "GET",
            requestUri: "/insights"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              insights: {
                type: "structure",
                members: {
                  activeAssessmentsCount: {
                    type: "integer"
                  },
                  noncompliantEvidenceCount: {
                    type: "integer"
                  },
                  compliantEvidenceCount: {
                    type: "integer"
                  },
                  inconclusiveEvidenceCount: {
                    type: "integer"
                  },
                  assessmentControlsCountByNoncompliantEvidence: {
                    type: "integer"
                  },
                  totalAssessmentControlsCount: {
                    type: "integer"
                  },
                  lastUpdated: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        GetInsightsByAssessment: {
          http: {
            method: "GET",
            requestUri: "/insights/assessments/{assessmentId}"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              insights: {
                type: "structure",
                members: {
                  noncompliantEvidenceCount: {
                    type: "integer"
                  },
                  compliantEvidenceCount: {
                    type: "integer"
                  },
                  inconclusiveEvidenceCount: {
                    type: "integer"
                  },
                  assessmentControlsCountByNoncompliantEvidence: {
                    type: "integer"
                  },
                  totalAssessmentControlsCount: {
                    type: "integer"
                  },
                  lastUpdated: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        GetOrganizationAdminAccount: {
          http: {
            method: "GET",
            requestUri: "/account/organizationAdminAccount"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              adminAccountId: {},
              organizationId: {}
            }
          }
        },
        GetServicesInScope: {
          http: {
            method: "GET",
            requestUri: "/services"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              serviceMetadata: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    displayName: {},
                    description: {},
                    category: {}
                  }
                }
              }
            }
          }
        },
        GetSettings: {
          http: {
            method: "GET",
            requestUri: "/settings/{attribute}"
          },
          input: {
            type: "structure",
            required: [
              "attribute"
            ],
            members: {
              attribute: {
                location: "uri",
                locationName: "attribute"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              settings: {
                shape: "S5z"
              }
            }
          }
        },
        ListAssessmentControlInsightsByControlDomain: {
          http: {
            method: "GET",
            requestUri: "/insights/controls-by-assessment"
          },
          input: {
            type: "structure",
            required: [
              "controlDomainId",
              "assessmentId"
            ],
            members: {
              controlDomainId: {
                location: "querystring",
                locationName: "controlDomainId"
              },
              assessmentId: {
                location: "querystring",
                locationName: "assessmentId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              controlInsightsByAssessment: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    id: {},
                    evidenceInsights: {
                      shape: "S6f"
                    },
                    controlSetName: {},
                    lastUpdated: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAssessmentFrameworkShareRequests: {
          http: {
            method: "GET",
            requestUri: "/assessmentFrameworkShareRequests"
          },
          input: {
            type: "structure",
            required: [
              "requestType"
            ],
            members: {
              requestType: {
                location: "querystring",
                locationName: "requestType"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              assessmentFrameworkShareRequests: {
                type: "list",
                member: {
                  shape: "S6j"
                }
              },
              nextToken: {}
            }
          }
        },
        ListAssessmentFrameworks: {
          http: {
            method: "GET",
            requestUri: "/assessmentFrameworks"
          },
          input: {
            type: "structure",
            required: [
              "frameworkType"
            ],
            members: {
              frameworkType: {
                location: "querystring",
                locationName: "frameworkType"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              frameworkMetadataList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    id: {},
                    type: {},
                    name: {},
                    description: {},
                    logo: {},
                    complianceType: {
                      shape: "S1t"
                    },
                    controlsCount: {
                      type: "integer"
                    },
                    controlSetsCount: {
                      type: "integer"
                    },
                    createdAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAssessmentReports: {
          http: {
            method: "GET",
            requestUri: "/assessmentReports"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              assessmentReports: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    name: {},
                    description: {
                      shape: "S3d"
                    },
                    assessmentId: {},
                    assessmentName: {
                      shape: "Sl"
                    },
                    author: {
                      shape: "S2b"
                    },
                    status: {},
                    creationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAssessments: {
          http: {
            method: "GET",
            requestUri: "/assessments"
          },
          input: {
            type: "structure",
            members: {
              status: {
                location: "querystring",
                locationName: "status"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              assessmentMetadata: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {
                      shape: "Sl"
                    },
                    id: {},
                    complianceType: {
                      shape: "S1t"
                    },
                    status: {},
                    roles: {
                      shape: "S1k"
                    },
                    delegations: {
                      shape: "Sj"
                    },
                    creationTime: {
                      type: "timestamp"
                    },
                    lastUpdated: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListControlDomainInsights: {
          http: {
            method: "GET",
            requestUri: "/insights/control-domains"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              controlDomainInsights: {
                shape: "S73"
              },
              nextToken: {}
            }
          }
        },
        ListControlDomainInsightsByAssessment: {
          http: {
            method: "GET",
            requestUri: "/insights/control-domains-by-assessment"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId"
            ],
            members: {
              assessmentId: {
                location: "querystring",
                locationName: "assessmentId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              controlDomainInsights: {
                shape: "S73"
              },
              nextToken: {}
            }
          }
        },
        ListControlInsightsByControlDomain: {
          http: {
            method: "GET",
            requestUri: "/insights/controls"
          },
          input: {
            type: "structure",
            required: [
              "controlDomainId"
            ],
            members: {
              controlDomainId: {
                location: "querystring",
                locationName: "controlDomainId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              controlInsightsMetadata: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    id: {},
                    evidenceInsights: {
                      shape: "S6f"
                    },
                    lastUpdated: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListControls: {
          http: {
            method: "GET",
            requestUri: "/controls"
          },
          input: {
            type: "structure",
            required: [
              "controlType"
            ],
            members: {
              controlType: {
                location: "querystring",
                locationName: "controlType"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              controlMetadataList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    id: {},
                    name: {},
                    controlSources: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListKeywordsForDataSource: {
          http: {
            method: "GET",
            requestUri: "/dataSourceKeywords"
          },
          input: {
            type: "structure",
            required: [
              "source"
            ],
            members: {
              source: {
                location: "querystring",
                locationName: "source"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              keywords: {
                type: "list",
                member: {}
              },
              nextToken: {}
            }
          }
        },
        ListNotifications: {
          http: {
            method: "GET",
            requestUri: "/notifications"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              notifications: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    assessmentId: {},
                    assessmentName: {
                      shape: "Sl"
                    },
                    controlSetId: {},
                    controlSetName: {},
                    description: {},
                    eventTime: {
                      type: "timestamp"
                    },
                    source: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S1m"
              }
            }
          }
        },
        RegisterAccount: {
          http: {
            requestUri: "/account/registerAccount"
          },
          input: {
            type: "structure",
            members: {
              kmsKey: {},
              delegatedAdminAccount: {}
            }
          },
          output: {
            type: "structure",
            members: {
              status: {}
            }
          }
        },
        RegisterOrganizationAdminAccount: {
          http: {
            requestUri: "/account/registerOrganizationAdminAccount"
          },
          input: {
            type: "structure",
            required: [
              "adminAccountId"
            ],
            members: {
              adminAccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              adminAccountId: {},
              organizationId: {}
            }
          }
        },
        StartAssessmentFrameworkShare: {
          http: {
            requestUri: "/assessmentFrameworks/{frameworkId}/shareRequests"
          },
          input: {
            type: "structure",
            required: [
              "frameworkId",
              "destinationAccount",
              "destinationRegion"
            ],
            members: {
              frameworkId: {
                location: "uri",
                locationName: "frameworkId"
              },
              destinationAccount: {},
              destinationRegion: {},
              comment: {}
            }
          },
          output: {
            type: "structure",
            members: {
              assessmentFrameworkShareRequest: {
                shape: "S6j"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S1m"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAssessment: {
          http: {
            method: "PUT",
            requestUri: "/assessments/{assessmentId}"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId",
              "scope"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              assessmentName: {
                shape: "Sl"
              },
              assessmentDescription: {
                shape: "S18"
              },
              scope: {
                shape: "S1b"
              },
              assessmentReportsDestination: {
                shape: "S19"
              },
              roles: {
                shape: "S1k"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              assessment: {
                shape: "S1q"
              }
            }
          }
        },
        UpdateAssessmentControl: {
          http: {
            method: "PUT",
            requestUri: "/assessments/{assessmentId}/controlSets/{controlSetId}/controls/{controlId}"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId",
              "controlSetId",
              "controlId"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              controlSetId: {
                location: "uri",
                locationName: "controlSetId"
              },
              controlId: {
                location: "uri",
                locationName: "controlId"
              },
              controlStatus: {},
              commentBody: {
                shape: "S2c"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              control: {
                shape: "S24"
              }
            }
          }
        },
        UpdateAssessmentControlSetStatus: {
          http: {
            method: "PUT",
            requestUri: "/assessments/{assessmentId}/controlSets/{controlSetId}/status"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId",
              "controlSetId",
              "status",
              "comment"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              controlSetId: {
                location: "uri",
                locationName: "controlSetId"
              },
              status: {},
              comment: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              controlSet: {
                shape: "S20"
              }
            }
          }
        },
        UpdateAssessmentFramework: {
          http: {
            method: "PUT",
            requestUri: "/assessmentFrameworks/{frameworkId}"
          },
          input: {
            type: "structure",
            required: [
              "frameworkId",
              "name",
              "controlSets"
            ],
            members: {
              frameworkId: {
                location: "uri",
                locationName: "frameworkId"
              },
              name: {},
              description: {},
              complianceType: {
                shape: "S1t"
              },
              controlSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "controls"
                  ],
                  members: {
                    id: {},
                    name: {},
                    controls: {
                      shape: "S2l"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              framework: {
                shape: "S2o"
              }
            }
          }
        },
        UpdateAssessmentFrameworkShare: {
          http: {
            method: "PUT",
            requestUri: "/assessmentFrameworkShareRequests/{requestId}"
          },
          input: {
            type: "structure",
            required: [
              "requestId",
              "requestType",
              "action"
            ],
            members: {
              requestId: {
                location: "uri",
                locationName: "requestId"
              },
              requestType: {},
              action: {}
            }
          },
          output: {
            type: "structure",
            members: {
              assessmentFrameworkShareRequest: {
                shape: "S6j"
              }
            }
          }
        },
        UpdateAssessmentStatus: {
          http: {
            method: "PUT",
            requestUri: "/assessments/{assessmentId}/status"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId",
              "status"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              status: {}
            }
          },
          output: {
            type: "structure",
            members: {
              assessment: {
                shape: "S1q"
              }
            }
          }
        },
        UpdateControl: {
          http: {
            method: "PUT",
            requestUri: "/controls/{controlId}"
          },
          input: {
            type: "structure",
            required: [
              "controlId",
              "name",
              "controlMappingSources"
            ],
            members: {
              controlId: {
                location: "uri",
                locationName: "controlId"
              },
              name: {},
              description: {},
              testingInformation: {
                shape: "S2w"
              },
              actionPlanTitle: {
                shape: "S2x"
              },
              actionPlanInstructions: {
                shape: "S2y"
              },
              controlMappingSources: {
                shape: "S2z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              control: {
                shape: "S2u"
              }
            }
          }
        },
        UpdateSettings: {
          http: {
            method: "PUT",
            requestUri: "/settings"
          },
          input: {
            type: "structure",
            members: {
              snsTopic: {},
              defaultAssessmentReportsDestination: {
                shape: "S19"
              },
              defaultProcessOwners: {
                shape: "S1k"
              },
              kmsKey: {},
              evidenceFinderEnabled: {
                type: "boolean"
              },
              deregistrationPolicy: {
                shape: "S67"
              },
              defaultExportDestination: {
                shape: "S69"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              settings: {
                shape: "S5z"
              }
            }
          }
        },
        ValidateAssessmentReportIntegrity: {
          http: {
            requestUri: "/assessmentReports/integrity"
          },
          input: {
            type: "structure",
            required: [
              "s3RelativePath"
            ],
            members: {
              s3RelativePath: {}
            }
          },
          output: {
            type: "structure",
            members: {
              signatureValid: {
                type: "boolean"
              },
              signatureAlgorithm: {},
              signatureDateTime: {},
              signatureKeyId: {},
              validationErrors: {
                type: "list",
                member: {}
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "list",
          member: {}
        },
        S7: {
          type: "list",
          member: {
            type: "structure",
            members: {
              evidenceId: {},
              errorCode: {},
              errorMessage: {}
            }
          }
        },
        Sd: {
          type: "structure",
          members: {
            comment: {
              shape: "Se"
            },
            controlSetId: {},
            roleArn: {},
            roleType: {}
          }
        },
        Se: {
          type: "string",
          sensitive: true
        },
        Sj: {
          type: "list",
          member: {
            type: "structure",
            members: {
              id: {},
              assessmentName: {
                shape: "Sl"
              },
              assessmentId: {},
              status: {},
              roleArn: {},
              roleType: {},
              creationTime: {
                type: "timestamp"
              },
              lastUpdated: {
                type: "timestamp"
              },
              controlSetId: {},
              comment: {
                shape: "Se"
              },
              createdBy: {
                shape: "So"
              }
            },
            sensitive: true
          }
        },
        Sl: {
          type: "string",
          sensitive: true
        },
        So: {
          type: "string",
          sensitive: true
        },
        S10: {
          type: "structure",
          members: {
            s3ResourcePath: {},
            textResponse: {
              type: "string",
              sensitive: true
            },
            evidenceFileName: {
              shape: "S13"
            }
          }
        },
        S13: {
          type: "string",
          sensitive: true
        },
        S18: {
          type: "string",
          sensitive: true
        },
        S19: {
          type: "structure",
          members: {
            destinationType: {},
            destination: {}
          },
          sensitive: true
        },
        S1b: {
          type: "structure",
          members: {
            awsAccounts: {
              type: "list",
              member: {
                shape: "S1d"
              },
              sensitive: true
            },
            awsServices: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  serviceName: {}
                }
              }
            }
          },
          sensitive: true
        },
        S1d: {
          type: "structure",
          members: {
            id: {},
            emailAddress: {
              type: "string",
              sensitive: true
            },
            name: {}
          }
        },
        S1k: {
          type: "list",
          member: {
            shape: "S1l"
          },
          sensitive: true
        },
        S1l: {
          type: "structure",
          required: [
            "roleType",
            "roleArn"
          ],
          members: {
            roleType: {},
            roleArn: {}
          }
        },
        S1m: {
          type: "map",
          key: {},
          value: {}
        },
        S1q: {
          type: "structure",
          members: {
            arn: {},
            awsAccount: {
              shape: "S1d"
            },
            metadata: {
              type: "structure",
              members: {
                name: {
                  shape: "Sl"
                },
                id: {},
                description: {
                  shape: "S18"
                },
                complianceType: {
                  shape: "S1t"
                },
                status: {},
                assessmentReportsDestination: {
                  shape: "S19"
                },
                scope: {
                  shape: "S1b"
                },
                roles: {
                  shape: "S1k"
                },
                delegations: {
                  shape: "Sj"
                },
                creationTime: {
                  type: "timestamp"
                },
                lastUpdated: {
                  type: "timestamp"
                }
              }
            },
            framework: {
              type: "structure",
              members: {
                id: {},
                arn: {},
                metadata: {
                  type: "structure",
                  members: {
                    name: {
                      shape: "Sl"
                    },
                    description: {},
                    logo: {},
                    complianceType: {
                      shape: "S1t"
                    }
                  }
                },
                controlSets: {
                  type: "list",
                  member: {
                    shape: "S20"
                  }
                }
              },
              sensitive: true
            },
            tags: {
              shape: "S1m"
            }
          }
        },
        S1t: {
          type: "string",
          sensitive: true
        },
        S20: {
          type: "structure",
          members: {
            id: {},
            description: {},
            status: {},
            roles: {
              shape: "S1k"
            },
            controls: {
              type: "list",
              member: {
                shape: "S24"
              }
            },
            delegations: {
              shape: "Sj"
            },
            systemEvidenceCount: {
              type: "integer"
            },
            manualEvidenceCount: {
              type: "integer"
            }
          }
        },
        S24: {
          type: "structure",
          members: {
            id: {},
            name: {},
            description: {},
            status: {},
            response: {},
            comments: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  authorName: {
                    shape: "S2b"
                  },
                  commentBody: {
                    shape: "S2c"
                  },
                  postedDate: {
                    type: "timestamp"
                  }
                }
              }
            },
            evidenceSources: {
              type: "list",
              member: {}
            },
            evidenceCount: {
              type: "integer"
            },
            assessmentReportEvidenceCount: {
              type: "integer"
            }
          }
        },
        S2b: {
          type: "string",
          sensitive: true
        },
        S2c: {
          type: "string",
          sensitive: true
        },
        S2l: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          }
        },
        S2o: {
          type: "structure",
          members: {
            arn: {},
            id: {},
            name: {},
            type: {},
            complianceType: {
              shape: "S1t"
            },
            description: {},
            logo: {},
            controlSources: {},
            controlSets: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  id: {},
                  name: {},
                  controls: {
                    type: "list",
                    member: {
                      shape: "S2u"
                    }
                  }
                }
              },
              sensitive: true
            },
            createdAt: {
              type: "timestamp"
            },
            lastUpdatedAt: {
              type: "timestamp"
            },
            createdBy: {
              shape: "So"
            },
            lastUpdatedBy: {
              shape: "S3a"
            },
            tags: {
              shape: "S1m"
            }
          }
        },
        S2u: {
          type: "structure",
          members: {
            arn: {},
            id: {},
            type: {},
            name: {},
            description: {},
            testingInformation: {
              shape: "S2w"
            },
            actionPlanTitle: {
              shape: "S2x"
            },
            actionPlanInstructions: {
              shape: "S2y"
            },
            controlSources: {},
            controlMappingSources: {
              shape: "S2z"
            },
            createdAt: {
              type: "timestamp"
            },
            lastUpdatedAt: {
              type: "timestamp"
            },
            createdBy: {
              shape: "So"
            },
            lastUpdatedBy: {
              shape: "S3a"
            },
            tags: {
              shape: "S1m"
            }
          }
        },
        S2w: {
          type: "string",
          sensitive: true
        },
        S2x: {
          type: "string",
          sensitive: true
        },
        S2y: {
          type: "string",
          sensitive: true
        },
        S2z: {
          type: "list",
          member: {
            type: "structure",
            members: {
              sourceId: {},
              sourceName: {},
              sourceDescription: {},
              sourceSetUpOption: {},
              sourceType: {},
              sourceKeyword: {
                shape: "S35"
              },
              sourceFrequency: {},
              troubleshootingText: {
                shape: "S39"
              }
            }
          }
        },
        S35: {
          type: "structure",
          members: {
            keywordInputType: {},
            keywordValue: {}
          }
        },
        S39: {
          type: "string",
          sensitive: true
        },
        S3a: {
          type: "string",
          sensitive: true
        },
        S3d: {
          type: "string",
          sensitive: true
        },
        S4v: {
          type: "structure",
          members: {
            dataSource: {},
            evidenceAwsAccountId: {},
            time: {
              type: "timestamp"
            },
            eventSource: {},
            eventName: {},
            evidenceByType: {},
            resourcesIncluded: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  arn: {},
                  value: {},
                  complianceCheck: {}
                }
              }
            },
            attributes: {
              type: "map",
              key: {},
              value: {}
            },
            iamId: {},
            complianceCheck: {},
            awsOrganization: {},
            awsAccountId: {},
            evidenceFolderId: {},
            id: {},
            assessmentReportSelection: {}
          }
        },
        S5b: {
          type: "structure",
          members: {
            name: {},
            date: {
              type: "timestamp"
            },
            assessmentId: {},
            controlSetId: {},
            controlId: {},
            id: {},
            dataSource: {},
            author: {},
            totalEvidence: {
              type: "integer"
            },
            assessmentReportSelectionCount: {
              type: "integer"
            },
            controlName: {},
            evidenceResourcesIncludedCount: {
              type: "integer"
            },
            evidenceByTypeConfigurationDataCount: {
              type: "integer"
            },
            evidenceByTypeManualCount: {
              type: "integer"
            },
            evidenceByTypeComplianceCheckCount: {
              type: "integer"
            },
            evidenceByTypeComplianceCheckIssuesCount: {
              type: "integer"
            },
            evidenceByTypeUserActivityCount: {
              type: "integer"
            },
            evidenceAwsServiceSourceCount: {
              type: "integer"
            }
          }
        },
        S5f: {
          type: "list",
          member: {
            shape: "S5b"
          }
        },
        S5z: {
          type: "structure",
          members: {
            isAwsOrgEnabled: {
              type: "boolean"
            },
            snsTopic: {
              type: "string",
              sensitive: true
            },
            defaultAssessmentReportsDestination: {
              shape: "S19"
            },
            defaultProcessOwners: {
              shape: "S1k"
            },
            kmsKey: {},
            evidenceFinderEnablement: {
              type: "structure",
              members: {
                eventDataStoreArn: {},
                enablementStatus: {},
                backfillStatus: {},
                error: {}
              }
            },
            deregistrationPolicy: {
              shape: "S67"
            },
            defaultExportDestination: {
              shape: "S69"
            }
          }
        },
        S67: {
          type: "structure",
          members: {
            deleteResources: {}
          }
        },
        S69: {
          type: "structure",
          members: {
            destinationType: {},
            destination: {}
          }
        },
        S6f: {
          type: "structure",
          members: {
            noncompliantEvidenceCount: {
              type: "integer"
            },
            compliantEvidenceCount: {
              type: "integer"
            },
            inconclusiveEvidenceCount: {
              type: "integer"
            }
          }
        },
        S6j: {
          type: "structure",
          members: {
            id: {},
            frameworkId: {},
            frameworkName: {},
            frameworkDescription: {},
            status: {},
            sourceAccount: {},
            destinationAccount: {},
            destinationRegion: {},
            expirationTime: {
              type: "timestamp"
            },
            creationTime: {
              type: "timestamp"
            },
            lastUpdated: {
              type: "timestamp"
            },
            comment: {},
            standardControlsCount: {
              type: "integer"
            },
            customControlsCount: {
              type: "integer"
            },
            complianceType: {
              shape: "S1t"
            }
          }
        },
        S73: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              id: {},
              controlsCountByNoncompliantEvidence: {
                type: "integer"
              },
              totalControlsCount: {
                type: "integer"
              },
              evidenceInsights: {
                shape: "S6f"
              },
              lastUpdated: {
                type: "timestamp"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/auditmanager-2017-07-25.paginators.json
var require_auditmanager_2017_07_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/auditmanager-2017-07-25.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetChangeLogs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetDelegations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetEvidenceByEvidenceFolder: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetEvidenceFoldersByAssessment: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetEvidenceFoldersByAssessmentControl: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListAssessmentControlInsightsByControlDomain: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListAssessmentFrameworkShareRequests: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListAssessmentFrameworks: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListAssessmentReports: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListAssessments: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListControlDomainInsights: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListControlDomainInsightsByAssessment: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListControlInsightsByControlDomain: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListControls: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListKeywordsForDataSource: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListNotifications: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/auditmanager.js
var require_auditmanager = __commonJS({
  "node_modules/aws-sdk/clients/auditmanager.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["auditmanager"] = {};
    AWS2.AuditManager = Service.defineService("auditmanager", ["2017-07-25"]);
    Object.defineProperty(apiLoader.services["auditmanager"], "2017-07-25", {
      get: function get() {
        var model = require_auditmanager_2017_07_25_min();
        model.paginators = require_auditmanager_2017_07_25_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.AuditManager;
  }
});

// node_modules/aws-sdk/apis/emr-containers-2020-10-01.min.json
var require_emr_containers_2020_10_01_min = __commonJS({
  "node_modules/aws-sdk/apis/emr-containers-2020-10-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-10-01",
        endpointPrefix: "emr-containers",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon EMR Containers",
        serviceId: "EMR containers",
        signatureVersion: "v4",
        signingName: "emr-containers",
        uid: "emr-containers-2020-10-01"
      },
      operations: {
        CancelJobRun: {
          http: {
            method: "DELETE",
            requestUri: "/virtualclusters/{virtualClusterId}/jobruns/{jobRunId}"
          },
          input: {
            type: "structure",
            required: [
              "id",
              "virtualClusterId"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "jobRunId"
              },
              virtualClusterId: {
                location: "uri",
                locationName: "virtualClusterId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              virtualClusterId: {}
            }
          }
        },
        CreateJobTemplate: {
          http: {
            requestUri: "/jobtemplates"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "clientToken",
              "jobTemplateData"
            ],
            members: {
              name: {},
              clientToken: {
                idempotencyToken: true
              },
              jobTemplateData: {
                shape: "S7"
              },
              tags: {
                shape: "Sx"
              },
              kmsKeyArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              name: {},
              arn: {},
              createdAt: {
                shape: "S13"
              }
            }
          }
        },
        CreateManagedEndpoint: {
          http: {
            requestUri: "/virtualclusters/{virtualClusterId}/endpoints"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "virtualClusterId",
              "type",
              "releaseLabel",
              "executionRoleArn",
              "clientToken"
            ],
            members: {
              name: {},
              virtualClusterId: {
                location: "uri",
                locationName: "virtualClusterId"
              },
              type: {},
              releaseLabel: {},
              executionRoleArn: {},
              certificateArn: {
                deprecated: true,
                deprecatedMessage: "Customer provided certificate-arn is deprecated and would be removed in future."
              },
              configurationOverrides: {
                shape: "S19"
              },
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              name: {},
              arn: {},
              virtualClusterId: {}
            }
          }
        },
        CreateVirtualCluster: {
          http: {
            requestUri: "/virtualclusters"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "containerProvider",
              "clientToken"
            ],
            members: {
              name: {},
              containerProvider: {
                shape: "S1l"
              },
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              name: {},
              arn: {}
            }
          }
        },
        DeleteJobTemplate: {
          http: {
            method: "DELETE",
            requestUri: "/jobtemplates/{templateId}"
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "templateId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              id: {}
            }
          }
        },
        DeleteManagedEndpoint: {
          http: {
            method: "DELETE",
            requestUri: "/virtualclusters/{virtualClusterId}/endpoints/{endpointId}"
          },
          input: {
            type: "structure",
            required: [
              "id",
              "virtualClusterId"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "endpointId"
              },
              virtualClusterId: {
                location: "uri",
                locationName: "virtualClusterId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              virtualClusterId: {}
            }
          }
        },
        DeleteVirtualCluster: {
          http: {
            method: "DELETE",
            requestUri: "/virtualclusters/{virtualClusterId}"
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "virtualClusterId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              id: {}
            }
          }
        },
        DescribeJobRun: {
          http: {
            method: "GET",
            requestUri: "/virtualclusters/{virtualClusterId}/jobruns/{jobRunId}"
          },
          input: {
            type: "structure",
            required: [
              "id",
              "virtualClusterId"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "jobRunId"
              },
              virtualClusterId: {
                location: "uri",
                locationName: "virtualClusterId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobRun: {
                shape: "S21"
              }
            }
          }
        },
        DescribeJobTemplate: {
          http: {
            method: "GET",
            requestUri: "/jobtemplates/{templateId}"
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "templateId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobTemplate: {
                shape: "S2b"
              }
            }
          }
        },
        DescribeManagedEndpoint: {
          http: {
            method: "GET",
            requestUri: "/virtualclusters/{virtualClusterId}/endpoints/{endpointId}"
          },
          input: {
            type: "structure",
            required: [
              "id",
              "virtualClusterId"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "endpointId"
              },
              virtualClusterId: {
                location: "uri",
                locationName: "virtualClusterId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              endpoint: {
                shape: "S2f"
              }
            }
          }
        },
        DescribeVirtualCluster: {
          http: {
            method: "GET",
            requestUri: "/virtualclusters/{virtualClusterId}"
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "virtualClusterId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              virtualCluster: {
                shape: "S2m"
              }
            }
          }
        },
        GetManagedEndpointSessionCredentials: {
          http: {
            requestUri: "/virtualclusters/{virtualClusterId}/endpoints/{endpointId}/credentials"
          },
          input: {
            type: "structure",
            required: [
              "executionRoleArn",
              "credentialType",
              "endpointIdentifier",
              "virtualClusterIdentifier"
            ],
            members: {
              endpointIdentifier: {
                location: "uri",
                locationName: "endpointId"
              },
              virtualClusterIdentifier: {
                location: "uri",
                locationName: "virtualClusterId"
              },
              executionRoleArn: {},
              credentialType: {},
              durationInSeconds: {
                type: "integer"
              },
              logContext: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              credentials: {
                type: "structure",
                members: {
                  token: {
                    type: "string",
                    sensitive: true
                  }
                },
                union: true
              },
              expiresAt: {
                shape: "S13"
              }
            }
          }
        },
        ListJobRuns: {
          http: {
            method: "GET",
            requestUri: "/virtualclusters/{virtualClusterId}/jobruns"
          },
          input: {
            type: "structure",
            required: [
              "virtualClusterId"
            ],
            members: {
              virtualClusterId: {
                location: "uri",
                locationName: "virtualClusterId"
              },
              createdBefore: {
                shape: "S13",
                location: "querystring",
                locationName: "createdBefore"
              },
              createdAfter: {
                shape: "S13",
                location: "querystring",
                locationName: "createdAfter"
              },
              name: {
                location: "querystring",
                locationName: "name"
              },
              states: {
                location: "querystring",
                locationName: "states",
                type: "list",
                member: {}
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobRuns: {
                type: "list",
                member: {
                  shape: "S21"
                }
              },
              nextToken: {}
            }
          }
        },
        ListJobTemplates: {
          http: {
            method: "GET",
            requestUri: "/jobtemplates"
          },
          input: {
            type: "structure",
            members: {
              createdAfter: {
                shape: "S13",
                location: "querystring",
                locationName: "createdAfter"
              },
              createdBefore: {
                shape: "S13",
                location: "querystring",
                locationName: "createdBefore"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              templates: {
                type: "list",
                member: {
                  shape: "S2b"
                }
              },
              nextToken: {}
            }
          }
        },
        ListManagedEndpoints: {
          http: {
            method: "GET",
            requestUri: "/virtualclusters/{virtualClusterId}/endpoints"
          },
          input: {
            type: "structure",
            required: [
              "virtualClusterId"
            ],
            members: {
              virtualClusterId: {
                location: "uri",
                locationName: "virtualClusterId"
              },
              createdBefore: {
                shape: "S13",
                location: "querystring",
                locationName: "createdBefore"
              },
              createdAfter: {
                shape: "S13",
                location: "querystring",
                locationName: "createdAfter"
              },
              types: {
                location: "querystring",
                locationName: "types",
                type: "list",
                member: {}
              },
              states: {
                location: "querystring",
                locationName: "states",
                type: "list",
                member: {}
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              endpoints: {
                type: "list",
                member: {
                  shape: "S2f"
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sx"
              }
            }
          }
        },
        ListVirtualClusters: {
          http: {
            method: "GET",
            requestUri: "/virtualclusters"
          },
          input: {
            type: "structure",
            members: {
              containerProviderId: {
                location: "querystring",
                locationName: "containerProviderId"
              },
              containerProviderType: {
                location: "querystring",
                locationName: "containerProviderType"
              },
              createdAfter: {
                shape: "S13",
                location: "querystring",
                locationName: "createdAfter"
              },
              createdBefore: {
                shape: "S13",
                location: "querystring",
                locationName: "createdBefore"
              },
              states: {
                location: "querystring",
                locationName: "states",
                type: "list",
                member: {}
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              virtualClusters: {
                type: "list",
                member: {
                  shape: "S2m"
                }
              },
              nextToken: {}
            }
          }
        },
        StartJobRun: {
          http: {
            requestUri: "/virtualclusters/{virtualClusterId}/jobruns"
          },
          input: {
            type: "structure",
            required: [
              "virtualClusterId",
              "clientToken"
            ],
            members: {
              name: {},
              virtualClusterId: {
                location: "uri",
                locationName: "virtualClusterId"
              },
              clientToken: {
                idempotencyToken: true
              },
              executionRoleArn: {},
              releaseLabel: {},
              jobDriver: {
                shape: "Sl"
              },
              configurationOverrides: {
                shape: "S19"
              },
              tags: {
                shape: "Sx"
              },
              jobTemplateId: {},
              jobTemplateParameters: {
                type: "map",
                key: {},
                value: {}
              },
              retryPolicyConfiguration: {
                shape: "S26"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              name: {},
              arn: {},
              virtualClusterId: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S7: {
          type: "structure",
          required: [
            "executionRoleArn",
            "releaseLabel",
            "jobDriver"
          ],
          members: {
            executionRoleArn: {},
            releaseLabel: {},
            configurationOverrides: {
              type: "structure",
              members: {
                applicationConfiguration: {
                  shape: "Sb"
                },
                monitoringConfiguration: {
                  type: "structure",
                  members: {
                    persistentAppUI: {},
                    cloudWatchMonitoringConfiguration: {
                      type: "structure",
                      members: {
                        logGroupName: {},
                        logStreamNamePrefix: {}
                      }
                    },
                    s3MonitoringConfiguration: {
                      type: "structure",
                      members: {
                        logUri: {}
                      }
                    }
                  }
                }
              }
            },
            jobDriver: {
              shape: "Sl"
            },
            parameterConfiguration: {
              type: "map",
              key: {},
              value: {
                type: "structure",
                members: {
                  type: {},
                  defaultValue: {}
                }
              }
            },
            jobTags: {
              shape: "Sx"
            }
          }
        },
        Sb: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "classification"
            ],
            members: {
              classification: {},
              properties: {
                type: "map",
                key: {},
                value: {},
                sensitive: true
              },
              configurations: {
                shape: "Sb"
              }
            }
          }
        },
        Sl: {
          type: "structure",
          members: {
            sparkSubmitJobDriver: {
              type: "structure",
              required: [
                "entryPoint"
              ],
              members: {
                entryPoint: {
                  shape: "Sn"
                },
                entryPointArguments: {
                  type: "list",
                  member: {
                    type: "string",
                    sensitive: true
                  }
                },
                sparkSubmitParameters: {
                  type: "string",
                  sensitive: true
                }
              }
            },
            sparkSqlJobDriver: {
              type: "structure",
              members: {
                entryPoint: {
                  shape: "Sn"
                },
                sparkSqlParameters: {
                  type: "string",
                  sensitive: true
                }
              }
            }
          }
        },
        Sn: {
          type: "string",
          sensitive: true
        },
        Sx: {
          type: "map",
          key: {},
          value: {}
        },
        S13: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S19: {
          type: "structure",
          members: {
            applicationConfiguration: {
              shape: "Sb"
            },
            monitoringConfiguration: {
              type: "structure",
              members: {
                persistentAppUI: {},
                cloudWatchMonitoringConfiguration: {
                  type: "structure",
                  required: [
                    "logGroupName"
                  ],
                  members: {
                    logGroupName: {},
                    logStreamNamePrefix: {}
                  }
                },
                s3MonitoringConfiguration: {
                  type: "structure",
                  required: [
                    "logUri"
                  ],
                  members: {
                    logUri: {}
                  }
                },
                containerLogRotationConfiguration: {
                  type: "structure",
                  required: [
                    "rotationSize",
                    "maxFilesToKeep"
                  ],
                  members: {
                    rotationSize: {},
                    maxFilesToKeep: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        S1l: {
          type: "structure",
          required: [
            "type",
            "id"
          ],
          members: {
            type: {},
            id: {},
            info: {
              type: "structure",
              members: {
                eksInfo: {
                  type: "structure",
                  members: {
                    namespace: {}
                  }
                }
              },
              union: true
            }
          }
        },
        S21: {
          type: "structure",
          members: {
            id: {},
            name: {},
            virtualClusterId: {},
            arn: {},
            state: {},
            clientToken: {},
            executionRoleArn: {},
            releaseLabel: {},
            configurationOverrides: {
              shape: "S19"
            },
            jobDriver: {
              shape: "Sl"
            },
            createdAt: {
              shape: "S13"
            },
            createdBy: {},
            finishedAt: {
              shape: "S13"
            },
            stateDetails: {},
            failureReason: {},
            tags: {
              shape: "Sx"
            },
            retryPolicyConfiguration: {
              shape: "S26"
            },
            retryPolicyExecution: {
              type: "structure",
              required: [
                "currentAttemptCount"
              ],
              members: {
                currentAttemptCount: {
                  type: "integer"
                }
              }
            }
          }
        },
        S26: {
          type: "structure",
          required: [
            "maxAttempts"
          ],
          members: {
            maxAttempts: {
              type: "integer"
            }
          }
        },
        S2b: {
          type: "structure",
          required: [
            "jobTemplateData"
          ],
          members: {
            name: {},
            id: {},
            arn: {},
            createdAt: {
              shape: "S13"
            },
            createdBy: {},
            tags: {
              shape: "Sx"
            },
            jobTemplateData: {
              shape: "S7"
            },
            kmsKeyArn: {},
            decryptionError: {}
          }
        },
        S2f: {
          type: "structure",
          members: {
            id: {},
            name: {},
            arn: {},
            virtualClusterId: {},
            type: {},
            state: {},
            releaseLabel: {},
            executionRoleArn: {},
            certificateArn: {
              deprecated: true,
              deprecatedMessage: "Customer provided certificate-arn is deprecated and would be removed in future."
            },
            certificateAuthority: {
              type: "structure",
              members: {
                certificateArn: {},
                certificateData: {}
              }
            },
            configurationOverrides: {
              shape: "S19"
            },
            serverUrl: {},
            createdAt: {
              shape: "S13"
            },
            securityGroup: {},
            subnetIds: {
              type: "list",
              member: {}
            },
            stateDetails: {},
            failureReason: {},
            tags: {
              shape: "Sx"
            }
          }
        },
        S2m: {
          type: "structure",
          members: {
            id: {},
            name: {},
            arn: {},
            state: {},
            containerProvider: {
              shape: "S1l"
            },
            createdAt: {
              shape: "S13"
            },
            tags: {
              shape: "Sx"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/emr-containers-2020-10-01.paginators.json
var require_emr_containers_2020_10_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/emr-containers-2020-10-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListJobRuns: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "jobRuns"
        },
        ListJobTemplates: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "templates"
        },
        ListManagedEndpoints: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "endpoints"
        },
        ListVirtualClusters: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "virtualClusters"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/emrcontainers.js
var require_emrcontainers = __commonJS({
  "node_modules/aws-sdk/clients/emrcontainers.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["emrcontainers"] = {};
    AWS2.EMRcontainers = Service.defineService("emrcontainers", ["2020-10-01"]);
    Object.defineProperty(apiLoader.services["emrcontainers"], "2020-10-01", {
      get: function get() {
        var model = require_emr_containers_2020_10_01_min();
        model.paginators = require_emr_containers_2020_10_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.EMRcontainers;
  }
});

// node_modules/aws-sdk/apis/healthlake-2017-07-01.min.json
var require_healthlake_2017_07_01_min = __commonJS({
  "node_modules/aws-sdk/apis/healthlake-2017-07-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-07-01",
        endpointPrefix: "healthlake",
        jsonVersion: "1.0",
        protocol: "json",
        serviceAbbreviation: "HealthLake",
        serviceFullName: "Amazon HealthLake",
        serviceId: "HealthLake",
        signatureVersion: "v4",
        signingName: "healthlake",
        targetPrefix: "HealthLake",
        uid: "healthlake-2017-07-01"
      },
      operations: {
        CreateFHIRDatastore: {
          input: {
            type: "structure",
            required: [
              "DatastoreTypeVersion"
            ],
            members: {
              DatastoreName: {},
              DatastoreTypeVersion: {},
              SseConfiguration: {
                shape: "S4"
              },
              PreloadDataConfig: {
                shape: "S8"
              },
              ClientToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sb"
              },
              IdentityProviderConfiguration: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DatastoreId",
              "DatastoreArn",
              "DatastoreStatus",
              "DatastoreEndpoint"
            ],
            members: {
              DatastoreId: {},
              DatastoreArn: {},
              DatastoreStatus: {},
              DatastoreEndpoint: {}
            }
          }
        },
        DeleteFHIRDatastore: {
          input: {
            type: "structure",
            required: [
              "DatastoreId"
            ],
            members: {
              DatastoreId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "DatastoreId",
              "DatastoreArn",
              "DatastoreStatus",
              "DatastoreEndpoint"
            ],
            members: {
              DatastoreId: {},
              DatastoreArn: {},
              DatastoreStatus: {},
              DatastoreEndpoint: {}
            }
          }
        },
        DescribeFHIRDatastore: {
          input: {
            type: "structure",
            required: [
              "DatastoreId"
            ],
            members: {
              DatastoreId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "DatastoreProperties"
            ],
            members: {
              DatastoreProperties: {
                shape: "St"
              }
            }
          }
        },
        DescribeFHIRExportJob: {
          input: {
            type: "structure",
            required: [
              "DatastoreId",
              "JobId"
            ],
            members: {
              DatastoreId: {},
              JobId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ExportJobProperties"
            ],
            members: {
              ExportJobProperties: {
                shape: "Sz"
              }
            }
          }
        },
        DescribeFHIRImportJob: {
          input: {
            type: "structure",
            required: [
              "DatastoreId",
              "JobId"
            ],
            members: {
              DatastoreId: {},
              JobId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ImportJobProperties"
            ],
            members: {
              ImportJobProperties: {
                shape: "S19"
              }
            }
          }
        },
        ListFHIRDatastores: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                members: {
                  DatastoreName: {},
                  DatastoreStatus: {},
                  CreatedBefore: {
                    type: "timestamp"
                  },
                  CreatedAfter: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DatastorePropertiesList"
            ],
            members: {
              DatastorePropertiesList: {
                type: "list",
                member: {
                  shape: "St"
                }
              },
              NextToken: {}
            }
          }
        },
        ListFHIRExportJobs: {
          input: {
            type: "structure",
            required: [
              "DatastoreId"
            ],
            members: {
              DatastoreId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              JobName: {},
              JobStatus: {},
              SubmittedBefore: {
                type: "timestamp"
              },
              SubmittedAfter: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ExportJobPropertiesList"
            ],
            members: {
              ExportJobPropertiesList: {
                type: "list",
                member: {
                  shape: "Sz"
                }
              },
              NextToken: {}
            }
          }
        },
        ListFHIRImportJobs: {
          input: {
            type: "structure",
            required: [
              "DatastoreId"
            ],
            members: {
              DatastoreId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              JobName: {},
              JobStatus: {},
              SubmittedBefore: {
                type: "timestamp"
              },
              SubmittedAfter: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ImportJobPropertiesList"
            ],
            members: {
              ImportJobPropertiesList: {
                type: "list",
                member: {
                  shape: "S19"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sb"
              }
            }
          }
        },
        StartFHIRExportJob: {
          input: {
            type: "structure",
            required: [
              "OutputDataConfig",
              "DatastoreId",
              "DataAccessRoleArn",
              "ClientToken"
            ],
            members: {
              JobName: {},
              OutputDataConfig: {
                shape: "S12"
              },
              DatastoreId: {},
              DataAccessRoleArn: {},
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "JobId",
              "JobStatus"
            ],
            members: {
              JobId: {},
              JobStatus: {},
              DatastoreId: {}
            }
          }
        },
        StartFHIRImportJob: {
          input: {
            type: "structure",
            required: [
              "InputDataConfig",
              "JobOutputDataConfig",
              "DatastoreId",
              "DataAccessRoleArn",
              "ClientToken"
            ],
            members: {
              JobName: {},
              InputDataConfig: {
                shape: "S1a"
              },
              JobOutputDataConfig: {
                shape: "S12"
              },
              DatastoreId: {},
              DataAccessRoleArn: {},
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "JobId",
              "JobStatus"
            ],
            members: {
              JobId: {},
              JobStatus: {},
              DatastoreId: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          required: [
            "KmsEncryptionConfig"
          ],
          members: {
            KmsEncryptionConfig: {
              type: "structure",
              required: [
                "CmkType"
              ],
              members: {
                CmkType: {},
                KmsKeyId: {}
              }
            }
          }
        },
        S8: {
          type: "structure",
          required: [
            "PreloadDataType"
          ],
          members: {
            PreloadDataType: {}
          }
        },
        Sb: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sf: {
          type: "structure",
          required: [
            "AuthorizationStrategy"
          ],
          members: {
            AuthorizationStrategy: {},
            FineGrainedAuthorizationEnabled: {
              type: "boolean"
            },
            Metadata: {},
            IdpLambdaArn: {}
          }
        },
        St: {
          type: "structure",
          required: [
            "DatastoreId",
            "DatastoreArn",
            "DatastoreStatus",
            "DatastoreTypeVersion",
            "DatastoreEndpoint"
          ],
          members: {
            DatastoreId: {},
            DatastoreArn: {},
            DatastoreName: {},
            DatastoreStatus: {},
            CreatedAt: {
              type: "timestamp"
            },
            DatastoreTypeVersion: {},
            DatastoreEndpoint: {},
            SseConfiguration: {
              shape: "S4"
            },
            PreloadDataConfig: {
              shape: "S8"
            },
            IdentityProviderConfiguration: {
              shape: "Sf"
            }
          }
        },
        Sz: {
          type: "structure",
          required: [
            "JobId",
            "JobStatus",
            "SubmitTime",
            "DatastoreId",
            "OutputDataConfig"
          ],
          members: {
            JobId: {},
            JobName: {},
            JobStatus: {},
            SubmitTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            DatastoreId: {},
            OutputDataConfig: {
              shape: "S12"
            },
            DataAccessRoleArn: {},
            Message: {}
          }
        },
        S12: {
          type: "structure",
          members: {
            S3Configuration: {
              type: "structure",
              required: [
                "S3Uri",
                "KmsKeyId"
              ],
              members: {
                S3Uri: {},
                KmsKeyId: {}
              }
            }
          },
          union: true
        },
        S19: {
          type: "structure",
          required: [
            "JobId",
            "JobStatus",
            "SubmitTime",
            "DatastoreId",
            "InputDataConfig"
          ],
          members: {
            JobId: {},
            JobName: {},
            JobStatus: {},
            SubmitTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            DatastoreId: {},
            InputDataConfig: {
              shape: "S1a"
            },
            JobOutputDataConfig: {
              shape: "S12"
            },
            DataAccessRoleArn: {},
            Message: {}
          }
        },
        S1a: {
          type: "structure",
          members: {
            S3Uri: {}
          },
          union: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/healthlake-2017-07-01.paginators.json
var require_healthlake_2017_07_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/healthlake-2017-07-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListFHIRDatastores: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListFHIRExportJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListFHIRImportJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/healthlake.js
var require_healthlake = __commonJS({
  "node_modules/aws-sdk/clients/healthlake.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["healthlake"] = {};
    AWS2.HealthLake = Service.defineService("healthlake", ["2017-07-01"]);
    Object.defineProperty(apiLoader.services["healthlake"], "2017-07-01", {
      get: function get() {
        var model = require_healthlake_2017_07_01_min();
        model.paginators = require_healthlake_2017_07_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.HealthLake;
  }
});

// node_modules/aws-sdk/apis/sagemaker-edge-2020-09-23.min.json
var require_sagemaker_edge_2020_09_23_min = __commonJS({
  "node_modules/aws-sdk/apis/sagemaker-edge-2020-09-23.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-09-23",
        endpointPrefix: "edge.sagemaker",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Sagemaker Edge Manager",
        serviceId: "Sagemaker Edge",
        signatureVersion: "v4",
        signingName: "sagemaker",
        uid: "sagemaker-edge-2020-09-23"
      },
      operations: {
        GetDeployments: {
          http: {
            requestUri: "/GetDeployments"
          },
          input: {
            type: "structure",
            required: [
              "DeviceName",
              "DeviceFleetName"
            ],
            members: {
              DeviceName: {},
              DeviceFleetName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Deployments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DeploymentName: {},
                    Type: {},
                    FailureHandlingPolicy: {},
                    Definitions: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ModelHandle: {},
                          S3Url: {},
                          Checksum: {
                            type: "structure",
                            members: {
                              Type: {},
                              Sum: {}
                            }
                          },
                          State: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetDeviceRegistration: {
          http: {
            requestUri: "/GetDeviceRegistration"
          },
          input: {
            type: "structure",
            required: [
              "DeviceName",
              "DeviceFleetName"
            ],
            members: {
              DeviceName: {},
              DeviceFleetName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DeviceRegistration: {},
              CacheTTL: {}
            }
          }
        },
        SendHeartbeat: {
          http: {
            requestUri: "/SendHeartbeat"
          },
          input: {
            type: "structure",
            required: [
              "AgentVersion",
              "DeviceName",
              "DeviceFleetName"
            ],
            members: {
              AgentMetrics: {
                shape: "Sm"
              },
              Models: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ModelName: {},
                    ModelVersion: {},
                    LatestSampleTime: {
                      type: "timestamp"
                    },
                    LatestInference: {
                      type: "timestamp"
                    },
                    ModelMetrics: {
                      shape: "Sm"
                    }
                  }
                }
              },
              AgentVersion: {},
              DeviceName: {},
              DeviceFleetName: {},
              DeploymentResult: {
                type: "structure",
                members: {
                  DeploymentName: {},
                  DeploymentStatus: {},
                  DeploymentStatusMessage: {},
                  DeploymentStartTime: {
                    type: "timestamp"
                  },
                  DeploymentEndTime: {
                    type: "timestamp"
                  },
                  DeploymentModels: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        ModelHandle: {},
                        ModelName: {},
                        ModelVersion: {},
                        DesiredState: {},
                        State: {},
                        Status: {},
                        StatusReason: {},
                        RollbackFailureReason: {}
                      }
                    }
                  }
                }
              }
            }
          }
        }
      },
      shapes: {
        Sm: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Dimension: {},
              MetricName: {},
              Value: {
                type: "double"
              },
              Timestamp: {
                type: "timestamp"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/sagemaker-edge-2020-09-23.paginators.json
var require_sagemaker_edge_2020_09_23_paginators = __commonJS({
  "node_modules/aws-sdk/apis/sagemaker-edge-2020-09-23.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/sagemakeredge.js
var require_sagemakeredge = __commonJS({
  "node_modules/aws-sdk/clients/sagemakeredge.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["sagemakeredge"] = {};
    AWS2.SagemakerEdge = Service.defineService("sagemakeredge", ["2020-09-23"]);
    Object.defineProperty(apiLoader.services["sagemakeredge"], "2020-09-23", {
      get: function get() {
        var model = require_sagemaker_edge_2020_09_23_min();
        model.paginators = require_sagemaker_edge_2020_09_23_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.SagemakerEdge;
  }
});

// node_modules/aws-sdk/apis/amp-2020-08-01.min.json
var require_amp_2020_08_01_min = __commonJS({
  "node_modules/aws-sdk/apis/amp-2020-08-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-08-01",
        endpointPrefix: "aps",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Prometheus Service",
        serviceId: "amp",
        signatureVersion: "v4",
        signingName: "aps",
        uid: "amp-2020-08-01"
      },
      operations: {
        CreateAlertManagerDefinition: {
          http: {
            requestUri: "/workspaces/{workspaceId}/alertmanager/definition",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "workspaceId",
              "data"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              data: {
                type: "blob"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "status"
            ],
            members: {
              status: {
                shape: "S6"
              }
            }
          },
          idempotent: true
        },
        CreateLoggingConfiguration: {
          http: {
            requestUri: "/workspaces/{workspaceId}/logging",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "workspaceId",
              "logGroupArn"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              logGroupArn: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "status"
            ],
            members: {
              status: {
                shape: "Sc"
              }
            }
          },
          idempotent: true
        },
        CreateRuleGroupsNamespace: {
          http: {
            requestUri: "/workspaces/{workspaceId}/rulegroupsnamespaces",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "workspaceId",
              "name",
              "data"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              name: {},
              data: {
                type: "blob"
              },
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "Sh"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "name",
              "arn",
              "status"
            ],
            members: {
              name: {},
              arn: {},
              status: {
                shape: "Sm"
              },
              tags: {
                shape: "Sh"
              }
            }
          },
          idempotent: true
        },
        CreateScraper: {
          http: {
            requestUri: "/scrapers",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "scrapeConfiguration",
              "source",
              "destination"
            ],
            members: {
              alias: {},
              scrapeConfiguration: {
                shape: "Sq"
              },
              source: {
                shape: "Ss"
              },
              destination: {
                shape: "Sz"
              },
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "Sh"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "scraperId",
              "arn",
              "status"
            ],
            members: {
              scraperId: {},
              arn: {},
              status: {
                shape: "S15"
              },
              tags: {
                shape: "Sh"
              }
            }
          },
          idempotent: true
        },
        CreateWorkspace: {
          http: {
            requestUri: "/workspaces",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              alias: {},
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "Sh"
              },
              kmsKeyArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "workspaceId",
              "arn",
              "status"
            ],
            members: {
              workspaceId: {},
              arn: {},
              status: {
                shape: "S1b"
              },
              tags: {
                shape: "Sh"
              },
              kmsKeyArn: {}
            }
          },
          idempotent: true
        },
        DeleteAlertManagerDefinition: {
          http: {
            method: "DELETE",
            requestUri: "/workspaces/{workspaceId}/alertmanager/definition",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          idempotent: true
        },
        DeleteLoggingConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/workspaces/{workspaceId}/logging",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          idempotent: true
        },
        DeleteRuleGroupsNamespace: {
          http: {
            method: "DELETE",
            requestUri: "/workspaces/{workspaceId}/rulegroupsnamespaces/{name}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "workspaceId",
              "name"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              name: {
                location: "uri",
                locationName: "name"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          idempotent: true
        },
        DeleteScraper: {
          http: {
            method: "DELETE",
            requestUri: "/scrapers/{scraperId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "scraperId"
            ],
            members: {
              scraperId: {
                location: "uri",
                locationName: "scraperId"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "scraperId",
              "status"
            ],
            members: {
              scraperId: {},
              status: {
                shape: "S15"
              }
            }
          },
          idempotent: true
        },
        DeleteWorkspace: {
          http: {
            method: "DELETE",
            requestUri: "/workspaces/{workspaceId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          idempotent: true
        },
        DescribeAlertManagerDefinition: {
          http: {
            method: "GET",
            requestUri: "/workspaces/{workspaceId}/alertmanager/definition",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "alertManagerDefinition"
            ],
            members: {
              alertManagerDefinition: {
                type: "structure",
                required: [
                  "status",
                  "data",
                  "createdAt",
                  "modifiedAt"
                ],
                members: {
                  status: {
                    shape: "S6"
                  },
                  data: {
                    type: "blob"
                  },
                  createdAt: {
                    type: "timestamp"
                  },
                  modifiedAt: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        DescribeLoggingConfiguration: {
          http: {
            method: "GET",
            requestUri: "/workspaces/{workspaceId}/logging",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "loggingConfiguration"
            ],
            members: {
              loggingConfiguration: {
                type: "structure",
                required: [
                  "status",
                  "workspace",
                  "logGroupArn",
                  "createdAt",
                  "modifiedAt"
                ],
                members: {
                  status: {
                    shape: "Sc"
                  },
                  workspace: {},
                  logGroupArn: {},
                  createdAt: {
                    type: "timestamp"
                  },
                  modifiedAt: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        DescribeRuleGroupsNamespace: {
          http: {
            method: "GET",
            requestUri: "/workspaces/{workspaceId}/rulegroupsnamespaces/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId",
              "name"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ruleGroupsNamespace"
            ],
            members: {
              ruleGroupsNamespace: {
                type: "structure",
                required: [
                  "arn",
                  "name",
                  "status",
                  "data",
                  "createdAt",
                  "modifiedAt"
                ],
                members: {
                  arn: {},
                  name: {},
                  status: {
                    shape: "Sm"
                  },
                  data: {
                    type: "blob"
                  },
                  createdAt: {
                    type: "timestamp"
                  },
                  modifiedAt: {
                    type: "timestamp"
                  },
                  tags: {
                    shape: "Sh"
                  }
                }
              }
            }
          }
        },
        DescribeScraper: {
          http: {
            method: "GET",
            requestUri: "/scrapers/{scraperId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "scraperId"
            ],
            members: {
              scraperId: {
                location: "uri",
                locationName: "scraperId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "scraper"
            ],
            members: {
              scraper: {
                type: "structure",
                required: [
                  "scraperId",
                  "arn",
                  "roleArn",
                  "status",
                  "createdAt",
                  "lastModifiedAt",
                  "scrapeConfiguration",
                  "source",
                  "destination"
                ],
                members: {
                  alias: {},
                  scraperId: {},
                  arn: {},
                  roleArn: {},
                  status: {
                    shape: "S15"
                  },
                  createdAt: {
                    type: "timestamp"
                  },
                  lastModifiedAt: {
                    type: "timestamp"
                  },
                  tags: {
                    shape: "Sh"
                  },
                  statusReason: {},
                  scrapeConfiguration: {
                    shape: "Sq"
                  },
                  source: {
                    shape: "Ss"
                  },
                  destination: {
                    shape: "Sz"
                  }
                }
              }
            }
          }
        },
        DescribeWorkspace: {
          http: {
            method: "GET",
            requestUri: "/workspaces/{workspaceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "workspace"
            ],
            members: {
              workspace: {
                type: "structure",
                required: [
                  "workspaceId",
                  "arn",
                  "status",
                  "createdAt"
                ],
                members: {
                  workspaceId: {},
                  alias: {},
                  arn: {},
                  status: {
                    shape: "S1b"
                  },
                  prometheusEndpoint: {},
                  createdAt: {
                    type: "timestamp"
                  },
                  tags: {
                    shape: "Sh"
                  },
                  kmsKeyArn: {}
                }
              }
            }
          }
        },
        GetDefaultScraperConfiguration: {
          http: {
            method: "GET",
            requestUri: "/scraperconfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "configuration"
            ],
            members: {
              configuration: {
                type: "blob"
              }
            }
          }
        },
        ListRuleGroupsNamespaces: {
          http: {
            method: "GET",
            requestUri: "/workspaces/{workspaceId}/rulegroupsnamespaces",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              name: {
                location: "querystring",
                locationName: "name"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ruleGroupsNamespaces"
            ],
            members: {
              ruleGroupsNamespaces: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "name",
                    "status",
                    "createdAt",
                    "modifiedAt"
                  ],
                  members: {
                    arn: {},
                    name: {},
                    status: {
                      shape: "Sm"
                    },
                    createdAt: {
                      type: "timestamp"
                    },
                    modifiedAt: {
                      type: "timestamp"
                    },
                    tags: {
                      shape: "Sh"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListScrapers: {
          http: {
            method: "GET",
            requestUri: "/scrapers",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              filters: {
                location: "querystring",
                type: "map",
                key: {},
                value: {
                  type: "list",
                  member: {}
                }
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "scrapers"
            ],
            members: {
              scrapers: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "scraperId",
                    "arn",
                    "roleArn",
                    "status",
                    "createdAt",
                    "lastModifiedAt",
                    "source",
                    "destination"
                  ],
                  members: {
                    alias: {},
                    scraperId: {},
                    arn: {},
                    roleArn: {},
                    status: {
                      shape: "S15"
                    },
                    createdAt: {
                      type: "timestamp"
                    },
                    lastModifiedAt: {
                      type: "timestamp"
                    },
                    tags: {
                      shape: "Sh"
                    },
                    statusReason: {},
                    source: {
                      shape: "Ss"
                    },
                    destination: {
                      shape: "Sz"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sh"
              }
            }
          }
        },
        ListWorkspaces: {
          http: {
            method: "GET",
            requestUri: "/workspaces",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              alias: {
                location: "querystring",
                locationName: "alias"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "workspaces"
            ],
            members: {
              workspaces: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "workspaceId",
                    "arn",
                    "status",
                    "createdAt"
                  ],
                  members: {
                    workspaceId: {},
                    alias: {},
                    arn: {},
                    status: {
                      shape: "S1b"
                    },
                    createdAt: {
                      type: "timestamp"
                    },
                    tags: {
                      shape: "Sh"
                    },
                    kmsKeyArn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        PutAlertManagerDefinition: {
          http: {
            method: "PUT",
            requestUri: "/workspaces/{workspaceId}/alertmanager/definition",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "workspaceId",
              "data"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              data: {
                type: "blob"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "status"
            ],
            members: {
              status: {
                shape: "S6"
              }
            }
          },
          idempotent: true
        },
        PutRuleGroupsNamespace: {
          http: {
            method: "PUT",
            requestUri: "/workspaces/{workspaceId}/rulegroupsnamespaces/{name}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "workspaceId",
              "name",
              "data"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              name: {
                location: "uri",
                locationName: "name"
              },
              data: {
                type: "blob"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "name",
              "arn",
              "status"
            ],
            members: {
              name: {},
              arn: {},
              status: {
                shape: "Sm"
              },
              tags: {
                shape: "Sh"
              }
            }
          },
          idempotent: true
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sh"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateLoggingConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/workspaces/{workspaceId}/logging",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "workspaceId",
              "logGroupArn"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              logGroupArn: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "status"
            ],
            members: {
              status: {
                shape: "Sc"
              }
            }
          },
          idempotent: true
        },
        UpdateWorkspaceAlias: {
          http: {
            requestUri: "/workspaces/{workspaceId}/alias",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              alias: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S6: {
          type: "structure",
          required: [
            "statusCode"
          ],
          members: {
            statusCode: {},
            statusReason: {}
          }
        },
        Sc: {
          type: "structure",
          required: [
            "statusCode"
          ],
          members: {
            statusCode: {},
            statusReason: {}
          }
        },
        Sh: {
          type: "map",
          key: {},
          value: {}
        },
        Sm: {
          type: "structure",
          required: [
            "statusCode"
          ],
          members: {
            statusCode: {},
            statusReason: {}
          }
        },
        Sq: {
          type: "structure",
          members: {
            configurationBlob: {
              type: "blob"
            }
          },
          union: true
        },
        Ss: {
          type: "structure",
          members: {
            eksConfiguration: {
              type: "structure",
              required: [
                "clusterArn",
                "subnetIds"
              ],
              members: {
                clusterArn: {},
                securityGroupIds: {
                  type: "list",
                  member: {}
                },
                subnetIds: {
                  type: "list",
                  member: {}
                }
              }
            }
          },
          union: true
        },
        Sz: {
          type: "structure",
          members: {
            ampConfiguration: {
              type: "structure",
              required: [
                "workspaceArn"
              ],
              members: {
                workspaceArn: {}
              }
            }
          },
          union: true
        },
        S15: {
          type: "structure",
          required: [
            "statusCode"
          ],
          members: {
            statusCode: {}
          }
        },
        S1b: {
          type: "structure",
          required: [
            "statusCode"
          ],
          members: {
            statusCode: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/amp-2020-08-01.paginators.json
var require_amp_2020_08_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/amp-2020-08-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListRuleGroupsNamespaces: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "ruleGroupsNamespaces"
        },
        ListScrapers: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "scrapers"
        },
        ListWorkspaces: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "workspaces"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/amp-2020-08-01.waiters2.json
var require_amp_2020_08_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/amp-2020-08-01.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        ScraperActive: {
          description: "Wait until a scraper reaches ACTIVE status",
          delay: 2,
          maxAttempts: 60,
          operation: "DescribeScraper",
          acceptors: [{
            matcher: "path",
            argument: "scraper.status.statusCode",
            state: "success",
            expected: "ACTIVE"
          }, {
            matcher: "path",
            argument: "scraper.status.statusCode",
            state: "failure",
            expected: "CREATION_FAILED"
          }]
        },
        ScraperDeleted: {
          description: "Wait until a scraper reaches DELETED status",
          delay: 2,
          maxAttempts: 60,
          operation: "DescribeScraper",
          acceptors: [{
            matcher: "error",
            state: "success",
            expected: "ResourceNotFoundException"
          }, {
            matcher: "path",
            argument: "scraper.status.statusCode",
            state: "failure",
            expected: "DELETION_FAILED"
          }]
        },
        WorkspaceActive: {
          description: "Wait until a workspace reaches ACTIVE status",
          delay: 2,
          maxAttempts: 60,
          operation: "DescribeWorkspace",
          acceptors: [{
            matcher: "path",
            argument: "workspace.status.statusCode",
            state: "success",
            expected: "ACTIVE"
          }, {
            matcher: "path",
            argument: "workspace.status.statusCode",
            state: "retry",
            expected: "UPDATING"
          }, {
            matcher: "path",
            argument: "workspace.status.statusCode",
            state: "retry",
            expected: "CREATING"
          }]
        },
        WorkspaceDeleted: {
          description: "Wait until a workspace reaches DELETED status",
          delay: 2,
          maxAttempts: 60,
          operation: "DescribeWorkspace",
          acceptors: [{
            matcher: "error",
            state: "success",
            expected: "ResourceNotFoundException"
          }, {
            matcher: "path",
            argument: "workspace.status.statusCode",
            state: "retry",
            expected: "DELETING"
          }]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/amp.js
var require_amp = __commonJS({
  "node_modules/aws-sdk/clients/amp.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["amp"] = {};
    AWS2.Amp = Service.defineService("amp", ["2020-08-01"]);
    Object.defineProperty(apiLoader.services["amp"], "2020-08-01", {
      get: function get() {
        var model = require_amp_2020_08_01_min();
        model.paginators = require_amp_2020_08_01_paginators().pagination;
        model.waiters = require_amp_2020_08_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Amp;
  }
});

// node_modules/aws-sdk/apis/greengrassv2-2020-11-30.min.json
var require_greengrassv2_2020_11_30_min = __commonJS({
  "node_modules/aws-sdk/apis/greengrassv2-2020-11-30.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-11-30",
        endpointPrefix: "greengrass",
        protocol: "rest-json",
        serviceAbbreviation: "AWS GreengrassV2",
        serviceFullName: "AWS IoT Greengrass V2",
        serviceId: "GreengrassV2",
        signatureVersion: "v4",
        uid: "greengrassv2-2020-11-30"
      },
      operations: {
        AssociateServiceRoleToAccount: {
          http: {
            method: "PUT",
            requestUri: "/greengrass/servicerole",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "roleArn"
            ],
            members: {
              roleArn: {
                locationName: "RoleArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              associatedAt: {
                locationName: "AssociatedAt"
              }
            }
          }
        },
        BatchAssociateClientDeviceWithCoreDevice: {
          http: {
            requestUri: "/greengrass/v2/coreDevices/{coreDeviceThingName}/associateClientDevices",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "coreDeviceThingName"
            ],
            members: {
              entries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "thingName"
                  ],
                  members: {
                    thingName: {}
                  }
                }
              },
              coreDeviceThingName: {
                location: "uri",
                locationName: "coreDeviceThingName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errorEntries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    thingName: {},
                    code: {},
                    message: {}
                  }
                }
              }
            }
          }
        },
        BatchDisassociateClientDeviceFromCoreDevice: {
          http: {
            requestUri: "/greengrass/v2/coreDevices/{coreDeviceThingName}/disassociateClientDevices",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "coreDeviceThingName"
            ],
            members: {
              entries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "thingName"
                  ],
                  members: {
                    thingName: {}
                  }
                }
              },
              coreDeviceThingName: {
                location: "uri",
                locationName: "coreDeviceThingName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errorEntries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    thingName: {},
                    code: {},
                    message: {}
                  }
                }
              }
            }
          }
        },
        CancelDeployment: {
          http: {
            requestUri: "/greengrass/v2/deployments/{deploymentId}/cancel"
          },
          input: {
            type: "structure",
            required: [
              "deploymentId"
            ],
            members: {
              deploymentId: {
                location: "uri",
                locationName: "deploymentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              message: {}
            }
          }
        },
        CreateComponentVersion: {
          http: {
            requestUri: "/greengrass/v2/createComponentVersion",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              inlineRecipe: {
                type: "blob"
              },
              lambdaFunction: {
                type: "structure",
                required: [
                  "lambdaArn"
                ],
                members: {
                  lambdaArn: {},
                  componentName: {},
                  componentVersion: {},
                  componentPlatforms: {
                    shape: "Sp"
                  },
                  componentDependencies: {
                    type: "map",
                    key: {},
                    value: {
                      type: "structure",
                      members: {
                        versionRequirement: {},
                        dependencyType: {}
                      }
                    }
                  },
                  componentLambdaParameters: {
                    type: "structure",
                    members: {
                      eventSources: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "topic",
                            "type"
                          ],
                          members: {
                            topic: {},
                            type: {}
                          }
                        }
                      },
                      maxQueueSize: {
                        type: "integer"
                      },
                      maxInstancesCount: {
                        type: "integer"
                      },
                      maxIdleTimeInSeconds: {
                        type: "integer"
                      },
                      timeoutInSeconds: {
                        type: "integer"
                      },
                      statusTimeoutInSeconds: {
                        type: "integer"
                      },
                      pinned: {
                        type: "boolean"
                      },
                      inputPayloadEncodingType: {},
                      execArgs: {
                        type: "list",
                        member: {}
                      },
                      environmentVariables: {
                        type: "map",
                        key: {},
                        value: {}
                      },
                      linuxProcessParams: {
                        type: "structure",
                        members: {
                          isolationMode: {},
                          containerParams: {
                            type: "structure",
                            members: {
                              memorySizeInKB: {
                                type: "integer"
                              },
                              mountROSysfs: {
                                type: "boolean"
                              },
                              volumes: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  required: [
                                    "sourcePath",
                                    "destinationPath"
                                  ],
                                  members: {
                                    sourcePath: {},
                                    destinationPath: {},
                                    permission: {},
                                    addGroupOwner: {
                                      type: "boolean"
                                    }
                                  }
                                }
                              },
                              devices: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  required: [
                                    "path"
                                  ],
                                  members: {
                                    path: {},
                                    permission: {},
                                    addGroupOwner: {
                                      type: "boolean"
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              tags: {
                shape: "S1f"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "componentName",
              "componentVersion",
              "creationTimestamp",
              "status"
            ],
            members: {
              arn: {},
              componentName: {},
              componentVersion: {},
              creationTimestamp: {
                type: "timestamp"
              },
              status: {
                shape: "S1m"
              }
            }
          }
        },
        CreateDeployment: {
          http: {
            requestUri: "/greengrass/v2/deployments",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "targetArn"
            ],
            members: {
              targetArn: {},
              deploymentName: {},
              components: {
                shape: "S1t"
              },
              iotJobConfiguration: {
                shape: "S23"
              },
              deploymentPolicies: {
                shape: "S2k"
              },
              parentTargetArn: {},
              tags: {
                shape: "S1f"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              deploymentId: {},
              iotJobId: {},
              iotJobArn: {}
            }
          }
        },
        DeleteComponent: {
          http: {
            method: "DELETE",
            requestUri: "/greengrass/v2/components/{arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {
                location: "uri",
                locationName: "arn"
              }
            }
          }
        },
        DeleteCoreDevice: {
          http: {
            method: "DELETE",
            requestUri: "/greengrass/v2/coreDevices/{coreDeviceThingName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "coreDeviceThingName"
            ],
            members: {
              coreDeviceThingName: {
                location: "uri",
                locationName: "coreDeviceThingName"
              }
            }
          }
        },
        DeleteDeployment: {
          http: {
            method: "DELETE",
            requestUri: "/greengrass/v2/deployments/{deploymentId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "deploymentId"
            ],
            members: {
              deploymentId: {
                location: "uri",
                locationName: "deploymentId"
              }
            }
          }
        },
        DescribeComponent: {
          http: {
            method: "GET",
            requestUri: "/greengrass/v2/components/{arn}/metadata"
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {
                location: "uri",
                locationName: "arn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              componentName: {},
              componentVersion: {},
              creationTimestamp: {
                type: "timestamp"
              },
              publisher: {},
              description: {},
              status: {
                shape: "S1m"
              },
              platforms: {
                shape: "Sp"
              },
              tags: {
                shape: "S1f"
              }
            }
          }
        },
        DisassociateServiceRoleFromAccount: {
          http: {
            method: "DELETE",
            requestUri: "/greengrass/servicerole",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              disassociatedAt: {
                locationName: "DisassociatedAt"
              }
            }
          }
        },
        GetComponent: {
          http: {
            method: "GET",
            requestUri: "/greengrass/v2/components/{arn}"
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              recipeOutputFormat: {
                location: "querystring",
                locationName: "recipeOutputFormat"
              },
              arn: {
                location: "uri",
                locationName: "arn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "recipeOutputFormat",
              "recipe"
            ],
            members: {
              recipeOutputFormat: {},
              recipe: {
                type: "blob"
              },
              tags: {
                shape: "S1f"
              }
            }
          }
        },
        GetComponentVersionArtifact: {
          http: {
            method: "GET",
            requestUri: "/greengrass/v2/components/{arn}/artifacts/{artifactName+}"
          },
          input: {
            type: "structure",
            required: [
              "arn",
              "artifactName"
            ],
            members: {
              arn: {
                location: "uri",
                locationName: "arn"
              },
              artifactName: {
                location: "uri",
                locationName: "artifactName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "preSignedUrl"
            ],
            members: {
              preSignedUrl: {}
            }
          }
        },
        GetConnectivityInfo: {
          http: {
            method: "GET",
            requestUri: "/greengrass/things/{thingName}/connectivityInfo",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "thingName"
            ],
            members: {
              thingName: {
                location: "uri",
                locationName: "thingName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              connectivityInfo: {
                shape: "S39",
                locationName: "ConnectivityInfo"
              },
              message: {
                locationName: "Message"
              }
            }
          }
        },
        GetCoreDevice: {
          http: {
            method: "GET",
            requestUri: "/greengrass/v2/coreDevices/{coreDeviceThingName}"
          },
          input: {
            type: "structure",
            required: [
              "coreDeviceThingName"
            ],
            members: {
              coreDeviceThingName: {
                location: "uri",
                locationName: "coreDeviceThingName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              coreDeviceThingName: {},
              coreVersion: {},
              platform: {},
              architecture: {},
              status: {},
              lastStatusUpdateTimestamp: {
                type: "timestamp"
              },
              tags: {
                shape: "S1f"
              }
            }
          }
        },
        GetDeployment: {
          http: {
            method: "GET",
            requestUri: "/greengrass/v2/deployments/{deploymentId}"
          },
          input: {
            type: "structure",
            required: [
              "deploymentId"
            ],
            members: {
              deploymentId: {
                location: "uri",
                locationName: "deploymentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              targetArn: {},
              revisionId: {},
              deploymentId: {},
              deploymentName: {},
              deploymentStatus: {},
              iotJobId: {},
              iotJobArn: {},
              components: {
                shape: "S1t"
              },
              deploymentPolicies: {
                shape: "S2k"
              },
              iotJobConfiguration: {
                shape: "S23"
              },
              creationTimestamp: {
                type: "timestamp"
              },
              isLatestForTarget: {
                type: "boolean"
              },
              parentTargetArn: {},
              tags: {
                shape: "S1f"
              }
            }
          }
        },
        GetServiceRoleForAccount: {
          http: {
            method: "GET",
            requestUri: "/greengrass/servicerole",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              associatedAt: {
                locationName: "AssociatedAt"
              },
              roleArn: {
                locationName: "RoleArn"
              }
            }
          }
        },
        ListClientDevicesAssociatedWithCoreDevice: {
          http: {
            method: "GET",
            requestUri: "/greengrass/v2/coreDevices/{coreDeviceThingName}/associatedClientDevices",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "coreDeviceThingName"
            ],
            members: {
              coreDeviceThingName: {
                location: "uri",
                locationName: "coreDeviceThingName"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              associatedClientDevices: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    thingName: {},
                    associationTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListComponentVersions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/v2/components/{arn}/versions"
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {
                location: "uri",
                locationName: "arn"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              componentVersions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    componentName: {},
                    componentVersion: {},
                    arn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListComponents: {
          http: {
            method: "GET",
            requestUri: "/greengrass/v2/components"
          },
          input: {
            type: "structure",
            members: {
              scope: {
                location: "querystring",
                locationName: "scope"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              components: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    componentName: {},
                    latestVersion: {
                      type: "structure",
                      members: {
                        arn: {},
                        componentVersion: {},
                        creationTimestamp: {
                          type: "timestamp"
                        },
                        description: {},
                        publisher: {},
                        platforms: {
                          shape: "Sp"
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListCoreDevices: {
          http: {
            method: "GET",
            requestUri: "/greengrass/v2/coreDevices"
          },
          input: {
            type: "structure",
            members: {
              thingGroupArn: {
                location: "querystring",
                locationName: "thingGroupArn"
              },
              status: {
                location: "querystring",
                locationName: "status"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              coreDevices: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    coreDeviceThingName: {},
                    status: {},
                    lastStatusUpdateTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDeployments: {
          http: {
            method: "GET",
            requestUri: "/greengrass/v2/deployments"
          },
          input: {
            type: "structure",
            members: {
              targetArn: {
                location: "querystring",
                locationName: "targetArn"
              },
              historyFilter: {
                location: "querystring",
                locationName: "historyFilter"
              },
              parentTargetArn: {
                location: "querystring",
                locationName: "parentTargetArn"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              deployments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    targetArn: {},
                    revisionId: {},
                    deploymentId: {},
                    deploymentName: {},
                    creationTimestamp: {
                      type: "timestamp"
                    },
                    deploymentStatus: {},
                    isLatestForTarget: {
                      type: "boolean"
                    },
                    parentTargetArn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListEffectiveDeployments: {
          http: {
            method: "GET",
            requestUri: "/greengrass/v2/coreDevices/{coreDeviceThingName}/effectiveDeployments"
          },
          input: {
            type: "structure",
            required: [
              "coreDeviceThingName"
            ],
            members: {
              coreDeviceThingName: {
                location: "uri",
                locationName: "coreDeviceThingName"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              effectiveDeployments: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "deploymentId",
                    "deploymentName",
                    "targetArn",
                    "coreDeviceExecutionStatus",
                    "creationTimestamp",
                    "modifiedTimestamp"
                  ],
                  members: {
                    deploymentId: {},
                    deploymentName: {},
                    iotJobId: {},
                    iotJobArn: {},
                    description: {},
                    targetArn: {},
                    coreDeviceExecutionStatus: {},
                    reason: {},
                    creationTimestamp: {
                      type: "timestamp"
                    },
                    modifiedTimestamp: {
                      type: "timestamp"
                    },
                    statusDetails: {
                      type: "structure",
                      members: {
                        errorStack: {
                          type: "list",
                          member: {}
                        },
                        errorTypes: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListInstalledComponents: {
          http: {
            method: "GET",
            requestUri: "/greengrass/v2/coreDevices/{coreDeviceThingName}/installedComponents"
          },
          input: {
            type: "structure",
            required: [
              "coreDeviceThingName"
            ],
            members: {
              coreDeviceThingName: {
                location: "uri",
                locationName: "coreDeviceThingName"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              topologyFilter: {
                location: "querystring",
                locationName: "topologyFilter"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              installedComponents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    componentName: {},
                    componentVersion: {},
                    lifecycleState: {},
                    lifecycleStateDetails: {},
                    isRoot: {
                      type: "boolean"
                    },
                    lastStatusChangeTimestamp: {
                      type: "timestamp"
                    },
                    lastReportedTimestamp: {
                      type: "timestamp"
                    },
                    lastInstallationSource: {},
                    lifecycleStatusCodes: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S1f"
              }
            }
          }
        },
        ResolveComponentCandidates: {
          http: {
            requestUri: "/greengrass/v2/resolveComponentCandidates"
          },
          input: {
            type: "structure",
            members: {
              platform: {
                shape: "Sq"
              },
              componentCandidates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    componentName: {},
                    componentVersion: {},
                    versionRequirements: {
                      type: "map",
                      key: {},
                      value: {}
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resolvedComponentVersions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    componentName: {},
                    componentVersion: {},
                    recipe: {
                      type: "blob"
                    },
                    vendorGuidance: {},
                    message: {}
                  }
                }
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S1f"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateConnectivityInfo: {
          http: {
            method: "PUT",
            requestUri: "/greengrass/things/{thingName}/connectivityInfo",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "thingName",
              "connectivityInfo"
            ],
            members: {
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              connectivityInfo: {
                shape: "S39",
                locationName: "ConnectivityInfo"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              version: {
                locationName: "Version"
              },
              message: {
                locationName: "Message"
              }
            }
          }
        }
      },
      shapes: {
        Sp: {
          type: "list",
          member: {
            shape: "Sq"
          }
        },
        Sq: {
          type: "structure",
          members: {
            name: {},
            attributes: {
              type: "map",
              key: {},
              value: {}
            }
          }
        },
        S1f: {
          type: "map",
          key: {},
          value: {}
        },
        S1m: {
          type: "structure",
          members: {
            componentState: {},
            message: {},
            errors: {
              type: "map",
              key: {},
              value: {}
            },
            vendorGuidance: {},
            vendorGuidanceMessage: {}
          }
        },
        S1t: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              componentVersion: {},
              configurationUpdate: {
                type: "structure",
                members: {
                  merge: {},
                  reset: {
                    type: "list",
                    member: {}
                  }
                }
              },
              runWith: {
                type: "structure",
                members: {
                  posixUser: {},
                  systemResourceLimits: {
                    type: "structure",
                    members: {
                      memory: {
                        type: "long"
                      },
                      cpus: {
                        type: "double"
                      }
                    }
                  },
                  windowsUser: {}
                }
              }
            }
          }
        },
        S23: {
          type: "structure",
          members: {
            jobExecutionsRolloutConfig: {
              type: "structure",
              members: {
                exponentialRate: {
                  type: "structure",
                  required: [
                    "baseRatePerMinute",
                    "incrementFactor",
                    "rateIncreaseCriteria"
                  ],
                  members: {
                    baseRatePerMinute: {
                      type: "integer"
                    },
                    incrementFactor: {
                      type: "double"
                    },
                    rateIncreaseCriteria: {
                      type: "structure",
                      members: {
                        numberOfNotifiedThings: {
                          type: "integer"
                        },
                        numberOfSucceededThings: {
                          type: "integer"
                        }
                      }
                    }
                  }
                },
                maximumPerMinute: {
                  type: "integer"
                }
              }
            },
            abortConfig: {
              type: "structure",
              required: [
                "criteriaList"
              ],
              members: {
                criteriaList: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "failureType",
                      "action",
                      "thresholdPercentage",
                      "minNumberOfExecutedThings"
                    ],
                    members: {
                      failureType: {},
                      action: {},
                      thresholdPercentage: {
                        type: "double"
                      },
                      minNumberOfExecutedThings: {
                        type: "integer"
                      }
                    }
                  }
                }
              }
            },
            timeoutConfig: {
              type: "structure",
              members: {
                inProgressTimeoutInMinutes: {
                  type: "long"
                }
              }
            }
          }
        },
        S2k: {
          type: "structure",
          members: {
            failureHandlingPolicy: {},
            componentUpdatePolicy: {
              type: "structure",
              members: {
                timeoutInSeconds: {
                  type: "integer"
                },
                action: {}
              }
            },
            configurationValidationPolicy: {
              type: "structure",
              members: {
                timeoutInSeconds: {
                  type: "integer"
                }
              }
            }
          }
        },
        S39: {
          type: "list",
          member: {
            type: "structure",
            members: {
              id: {
                locationName: "Id"
              },
              hostAddress: {
                locationName: "HostAddress"
              },
              portNumber: {
                locationName: "PortNumber",
                type: "integer"
              },
              metadata: {
                locationName: "Metadata"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/greengrassv2-2020-11-30.paginators.json
var require_greengrassv2_2020_11_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/greengrassv2-2020-11-30.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListClientDevicesAssociatedWithCoreDevice: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "associatedClientDevices"
        },
        ListComponentVersions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "componentVersions"
        },
        ListComponents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "components"
        },
        ListCoreDevices: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "coreDevices"
        },
        ListDeployments: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "deployments"
        },
        ListEffectiveDeployments: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "effectiveDeployments"
        },
        ListInstalledComponents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "installedComponents"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/greengrassv2.js
var require_greengrassv2 = __commonJS({
  "node_modules/aws-sdk/clients/greengrassv2.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["greengrassv2"] = {};
    AWS2.GreengrassV2 = Service.defineService("greengrassv2", ["2020-11-30"]);
    Object.defineProperty(apiLoader.services["greengrassv2"], "2020-11-30", {
      get: function get() {
        var model = require_greengrassv2_2020_11_30_min();
        model.paginators = require_greengrassv2_2020_11_30_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.GreengrassV2;
  }
});

// node_modules/aws-sdk/apis/iotdeviceadvisor-2020-09-18.min.json
var require_iotdeviceadvisor_2020_09_18_min = __commonJS({
  "node_modules/aws-sdk/apis/iotdeviceadvisor-2020-09-18.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-09-18",
        endpointPrefix: "api.iotdeviceadvisor",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "AWSIoTDeviceAdvisor",
        serviceFullName: "AWS IoT Core Device Advisor",
        serviceId: "IotDeviceAdvisor",
        signatureVersion: "v4",
        signingName: "iotdeviceadvisor",
        uid: "iotdeviceadvisor-2020-09-18"
      },
      operations: {
        CreateSuiteDefinition: {
          http: {
            requestUri: "/suiteDefinitions"
          },
          input: {
            type: "structure",
            required: [
              "suiteDefinitionConfiguration"
            ],
            members: {
              suiteDefinitionConfiguration: {
                shape: "S2"
              },
              tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              suiteDefinitionId: {},
              suiteDefinitionArn: {},
              suiteDefinitionName: {},
              createdAt: {
                type: "timestamp"
              }
            }
          }
        },
        DeleteSuiteDefinition: {
          http: {
            method: "DELETE",
            requestUri: "/suiteDefinitions/{suiteDefinitionId}"
          },
          input: {
            type: "structure",
            required: [
              "suiteDefinitionId"
            ],
            members: {
              suiteDefinitionId: {
                location: "uri",
                locationName: "suiteDefinitionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetEndpoint: {
          http: {
            method: "GET",
            requestUri: "/endpoint"
          },
          input: {
            type: "structure",
            members: {
              thingArn: {
                location: "querystring",
                locationName: "thingArn"
              },
              certificateArn: {
                location: "querystring",
                locationName: "certificateArn"
              },
              deviceRoleArn: {
                location: "querystring",
                locationName: "deviceRoleArn"
              },
              authenticationMethod: {
                location: "querystring",
                locationName: "authenticationMethod"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              endpoint: {}
            }
          }
        },
        GetSuiteDefinition: {
          http: {
            method: "GET",
            requestUri: "/suiteDefinitions/{suiteDefinitionId}"
          },
          input: {
            type: "structure",
            required: [
              "suiteDefinitionId"
            ],
            members: {
              suiteDefinitionId: {
                location: "uri",
                locationName: "suiteDefinitionId"
              },
              suiteDefinitionVersion: {
                location: "querystring",
                locationName: "suiteDefinitionVersion"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              suiteDefinitionId: {},
              suiteDefinitionArn: {},
              suiteDefinitionVersion: {},
              latestVersion: {},
              suiteDefinitionConfiguration: {
                shape: "S2"
              },
              createdAt: {
                type: "timestamp"
              },
              lastModifiedAt: {
                type: "timestamp"
              },
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        GetSuiteRun: {
          http: {
            method: "GET",
            requestUri: "/suiteDefinitions/{suiteDefinitionId}/suiteRuns/{suiteRunId}"
          },
          input: {
            type: "structure",
            required: [
              "suiteDefinitionId",
              "suiteRunId"
            ],
            members: {
              suiteDefinitionId: {
                location: "uri",
                locationName: "suiteDefinitionId"
              },
              suiteRunId: {
                location: "uri",
                locationName: "suiteRunId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              suiteDefinitionId: {},
              suiteDefinitionVersion: {},
              suiteRunId: {},
              suiteRunArn: {},
              suiteRunConfiguration: {
                shape: "Ss"
              },
              testResult: {
                type: "structure",
                members: {
                  groups: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        groupId: {},
                        groupName: {},
                        tests: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              testCaseRunId: {},
                              testCaseDefinitionId: {},
                              testCaseDefinitionName: {},
                              status: {},
                              startTime: {
                                type: "timestamp"
                              },
                              endTime: {
                                type: "timestamp"
                              },
                              logUrl: {},
                              warnings: {},
                              failure: {},
                              testScenarios: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    testCaseScenarioId: {},
                                    testCaseScenarioType: {},
                                    status: {},
                                    failure: {},
                                    systemMessage: {}
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              status: {},
              errorReason: {},
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        GetSuiteRunReport: {
          http: {
            method: "GET",
            requestUri: "/suiteDefinitions/{suiteDefinitionId}/suiteRuns/{suiteRunId}/report"
          },
          input: {
            type: "structure",
            required: [
              "suiteDefinitionId",
              "suiteRunId"
            ],
            members: {
              suiteDefinitionId: {
                location: "uri",
                locationName: "suiteDefinitionId"
              },
              suiteRunId: {
                location: "uri",
                locationName: "suiteRunId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              qualificationReportDownloadUrl: {}
            }
          }
        },
        ListSuiteDefinitions: {
          http: {
            method: "GET",
            requestUri: "/suiteDefinitions"
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              suiteDefinitionInformationList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    suiteDefinitionId: {},
                    suiteDefinitionName: {},
                    defaultDevices: {
                      shape: "S4"
                    },
                    intendedForQualification: {
                      type: "boolean"
                    },
                    isLongDurationTest: {
                      type: "boolean"
                    },
                    protocol: {},
                    createdAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSuiteRuns: {
          http: {
            method: "GET",
            requestUri: "/suiteRuns"
          },
          input: {
            type: "structure",
            members: {
              suiteDefinitionId: {
                location: "querystring",
                locationName: "suiteDefinitionId"
              },
              suiteDefinitionVersion: {
                location: "querystring",
                locationName: "suiteDefinitionVersion"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              suiteRunsList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    suiteDefinitionId: {},
                    suiteDefinitionVersion: {},
                    suiteDefinitionName: {},
                    suiteRunId: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    startedAt: {
                      type: "timestamp"
                    },
                    endAt: {
                      type: "timestamp"
                    },
                    status: {},
                    passed: {
                      type: "integer"
                    },
                    failed: {
                      type: "integer"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        StartSuiteRun: {
          http: {
            requestUri: "/suiteDefinitions/{suiteDefinitionId}/suiteRuns"
          },
          input: {
            type: "structure",
            required: [
              "suiteDefinitionId",
              "suiteRunConfiguration"
            ],
            members: {
              suiteDefinitionId: {
                location: "uri",
                locationName: "suiteDefinitionId"
              },
              suiteDefinitionVersion: {},
              suiteRunConfiguration: {
                shape: "Ss"
              },
              tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              suiteRunId: {},
              suiteRunArn: {},
              createdAt: {
                type: "timestamp"
              },
              endpoint: {}
            }
          }
        },
        StopSuiteRun: {
          http: {
            requestUri: "/suiteDefinitions/{suiteDefinitionId}/suiteRuns/{suiteRunId}/stop"
          },
          input: {
            type: "structure",
            required: [
              "suiteDefinitionId",
              "suiteRunId"
            ],
            members: {
              suiteDefinitionId: {
                location: "uri",
                locationName: "suiteDefinitionId"
              },
              suiteRunId: {
                location: "uri",
                locationName: "suiteRunId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateSuiteDefinition: {
          http: {
            method: "PATCH",
            requestUri: "/suiteDefinitions/{suiteDefinitionId}"
          },
          input: {
            type: "structure",
            required: [
              "suiteDefinitionId",
              "suiteDefinitionConfiguration"
            ],
            members: {
              suiteDefinitionId: {
                location: "uri",
                locationName: "suiteDefinitionId"
              },
              suiteDefinitionConfiguration: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              suiteDefinitionId: {},
              suiteDefinitionArn: {},
              suiteDefinitionName: {},
              suiteDefinitionVersion: {},
              createdAt: {
                type: "timestamp"
              },
              lastUpdatedAt: {
                type: "timestamp"
              }
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          required: [
            "suiteDefinitionName",
            "rootGroup",
            "devicePermissionRoleArn"
          ],
          members: {
            suiteDefinitionName: {},
            devices: {
              shape: "S4"
            },
            intendedForQualification: {
              type: "boolean"
            },
            isLongDurationTest: {
              type: "boolean"
            },
            rootGroup: {},
            devicePermissionRoleArn: {},
            protocol: {}
          }
        },
        S4: {
          type: "list",
          member: {
            shape: "S5"
          }
        },
        S5: {
          type: "structure",
          members: {
            thingArn: {},
            certificateArn: {},
            deviceRoleArn: {}
          }
        },
        Sb: {
          type: "map",
          key: {},
          value: {}
        },
        Ss: {
          type: "structure",
          required: [
            "primaryDevice"
          ],
          members: {
            primaryDevice: {
              shape: "S5"
            },
            selectedTestList: {
              type: "list",
              member: {}
            },
            parallelRun: {
              type: "boolean"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iotdeviceadvisor-2020-09-18.paginators.json
var require_iotdeviceadvisor_2020_09_18_paginators = __commonJS({
  "node_modules/aws-sdk/apis/iotdeviceadvisor-2020-09-18.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListSuiteDefinitions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListSuiteRuns: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/iotdeviceadvisor.js
var require_iotdeviceadvisor = __commonJS({
  "node_modules/aws-sdk/clients/iotdeviceadvisor.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["iotdeviceadvisor"] = {};
    AWS2.IotDeviceAdvisor = Service.defineService("iotdeviceadvisor", ["2020-09-18"]);
    Object.defineProperty(apiLoader.services["iotdeviceadvisor"], "2020-09-18", {
      get: function get() {
        var model = require_iotdeviceadvisor_2020_09_18_min();
        model.paginators = require_iotdeviceadvisor_2020_09_18_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.IotDeviceAdvisor;
  }
});

// node_modules/aws-sdk/apis/iotfleethub-2020-11-03.min.json
var require_iotfleethub_2020_11_03_min = __commonJS({
  "node_modules/aws-sdk/apis/iotfleethub-2020-11-03.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-11-03",
        endpointPrefix: "api.fleethub.iot",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS IoT Fleet Hub",
        serviceId: "IoTFleetHub",
        signatureVersion: "v4",
        signingName: "iotfleethub",
        uid: "iotfleethub-2020-11-03"
      },
      operations: {
        CreateApplication: {
          http: {
            requestUri: "/applications",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "applicationName",
              "roleArn"
            ],
            members: {
              applicationName: {},
              applicationDescription: {},
              clientToken: {
                idempotencyToken: true
              },
              roleArn: {},
              tags: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "applicationId",
              "applicationArn"
            ],
            members: {
              applicationId: {},
              applicationArn: {}
            }
          }
        },
        DeleteApplication: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{applicationId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeApplication: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "applicationId",
              "applicationArn",
              "applicationName",
              "applicationUrl",
              "applicationState",
              "applicationCreationDate",
              "applicationLastUpdateDate",
              "roleArn"
            ],
            members: {
              applicationId: {},
              applicationArn: {},
              applicationName: {},
              applicationDescription: {},
              applicationUrl: {},
              applicationState: {},
              applicationCreationDate: {
                type: "long"
              },
              applicationLastUpdateDate: {
                type: "long"
              },
              roleArn: {},
              ssoClientId: {},
              errorMessage: {},
              tags: {
                shape: "S6"
              }
            }
          }
        },
        ListApplications: {
          http: {
            method: "GET",
            requestUri: "/applications",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applicationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "applicationId",
                    "applicationName",
                    "applicationUrl"
                  ],
                  members: {
                    applicationId: {},
                    applicationName: {},
                    applicationDescription: {},
                    applicationUrl: {},
                    applicationCreationDate: {
                      type: "long"
                    },
                    applicationLastUpdateDate: {
                      type: "long"
                    },
                    applicationState: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S6"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateApplication: {
          http: {
            method: "PATCH",
            requestUri: "/applications/{applicationId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              applicationName: {},
              applicationDescription: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S6: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iotfleethub-2020-11-03.paginators.json
var require_iotfleethub_2020_11_03_paginators = __commonJS({
  "node_modules/aws-sdk/apis/iotfleethub-2020-11-03.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListApplications: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "applicationSummaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/iotfleethub.js
var require_iotfleethub = __commonJS({
  "node_modules/aws-sdk/clients/iotfleethub.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["iotfleethub"] = {};
    AWS2.IoTFleetHub = Service.defineService("iotfleethub", ["2020-11-03"]);
    Object.defineProperty(apiLoader.services["iotfleethub"], "2020-11-03", {
      get: function get() {
        var model = require_iotfleethub_2020_11_03_min();
        model.paginators = require_iotfleethub_2020_11_03_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.IoTFleetHub;
  }
});

// node_modules/aws-sdk/apis/iotwireless-2020-11-22.min.json
var require_iotwireless_2020_11_22_min = __commonJS({
  "node_modules/aws-sdk/apis/iotwireless-2020-11-22.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-11-22",
        endpointPrefix: "api.iotwireless",
        protocol: "rest-json",
        serviceFullName: "AWS IoT Wireless",
        serviceId: "IoT Wireless",
        signatureVersion: "v4",
        signingName: "iotwireless",
        uid: "iotwireless-2020-11-22"
      },
      operations: {
        AssociateAwsAccountWithPartnerAccount: {
          http: {
            requestUri: "/partner-accounts"
          },
          input: {
            type: "structure",
            required: [
              "Sidewalk"
            ],
            members: {
              Sidewalk: {
                shape: "S2"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Sidewalk: {
                shape: "S2"
              },
              Arn: {}
            }
          }
        },
        AssociateMulticastGroupWithFuotaTask: {
          http: {
            method: "PUT",
            requestUri: "/fuota-tasks/{Id}/multicast-group",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id",
              "MulticastGroupId"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              MulticastGroupId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateWirelessDeviceWithFuotaTask: {
          http: {
            method: "PUT",
            requestUri: "/fuota-tasks/{Id}/wireless-device",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id",
              "WirelessDeviceId"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              WirelessDeviceId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateWirelessDeviceWithMulticastGroup: {
          http: {
            method: "PUT",
            requestUri: "/multicast-groups/{Id}/wireless-device",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id",
              "WirelessDeviceId"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              WirelessDeviceId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateWirelessDeviceWithThing: {
          http: {
            method: "PUT",
            requestUri: "/wireless-devices/{Id}/thing",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id",
              "ThingArn"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              ThingArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateWirelessGatewayWithCertificate: {
          http: {
            method: "PUT",
            requestUri: "/wireless-gateways/{Id}/certificate"
          },
          input: {
            type: "structure",
            required: [
              "Id",
              "IotCertificateId"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IotCertificateId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IotCertificateId: {}
            }
          }
        },
        AssociateWirelessGatewayWithThing: {
          http: {
            method: "PUT",
            requestUri: "/wireless-gateways/{Id}/thing",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id",
              "ThingArn"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              ThingArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CancelMulticastGroupSession: {
          http: {
            method: "DELETE",
            requestUri: "/multicast-groups/{Id}/session",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateDestination: {
          http: {
            requestUri: "/destinations",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "ExpressionType",
              "Expression",
              "RoleArn"
            ],
            members: {
              Name: {},
              ExpressionType: {},
              Expression: {},
              Description: {},
              RoleArn: {},
              Tags: {
                shape: "S6"
              },
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Name: {}
            }
          }
        },
        CreateDeviceProfile: {
          http: {
            requestUri: "/device-profiles",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              Name: {},
              LoRaWAN: {
                shape: "S16"
              },
              Tags: {
                shape: "S6"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              Sidewalk: {
                type: "structure",
                members: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Id: {}
            }
          }
        },
        CreateFuotaTask: {
          http: {
            requestUri: "/fuota-tasks",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FirmwareUpdateImage",
              "FirmwareUpdateRole"
            ],
            members: {
              Name: {},
              Description: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              LoRaWAN: {
                shape: "S1x"
              },
              FirmwareUpdateImage: {},
              FirmwareUpdateRole: {},
              Tags: {
                shape: "S6"
              },
              RedundancyPercent: {
                type: "integer"
              },
              FragmentSizeBytes: {
                type: "integer"
              },
              FragmentIntervalMS: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Id: {}
            }
          }
        },
        CreateMulticastGroup: {
          http: {
            requestUri: "/multicast-groups",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "LoRaWAN"
            ],
            members: {
              Name: {},
              Description: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              LoRaWAN: {
                shape: "S28"
              },
              Tags: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Id: {}
            }
          }
        },
        CreateNetworkAnalyzerConfiguration: {
          http: {
            requestUri: "/network-analyzer-configurations",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              TraceContent: {
                shape: "S2e"
              },
              WirelessDevices: {
                shape: "S2i"
              },
              WirelessGateways: {
                shape: "S2j"
              },
              Description: {},
              Tags: {
                shape: "S6"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              MulticastGroups: {
                shape: "S2k"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Name: {}
            }
          }
        },
        CreateServiceProfile: {
          http: {
            requestUri: "/service-profiles",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              Name: {},
              LoRaWAN: {
                type: "structure",
                members: {
                  AddGwMetadata: {
                    type: "boolean"
                  },
                  DrMin: {
                    type: "integer"
                  },
                  DrMax: {
                    type: "integer"
                  },
                  PrAllowed: {
                    type: "boolean"
                  },
                  RaAllowed: {
                    type: "boolean"
                  }
                }
              },
              Tags: {
                shape: "S6"
              },
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Id: {}
            }
          }
        },
        CreateWirelessDevice: {
          http: {
            requestUri: "/wireless-devices",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Type",
              "DestinationName"
            ],
            members: {
              Type: {},
              Name: {},
              Description: {},
              DestinationName: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              LoRaWAN: {
                shape: "S31"
              },
              Tags: {
                shape: "S6"
              },
              Positioning: {},
              Sidewalk: {
                type: "structure",
                members: {
                  DeviceProfileId: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Id: {}
            }
          }
        },
        CreateWirelessGateway: {
          http: {
            requestUri: "/wireless-gateways",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "LoRaWAN"
            ],
            members: {
              Name: {},
              Description: {},
              LoRaWAN: {
                shape: "S3x"
              },
              Tags: {
                shape: "S6"
              },
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Id: {}
            }
          }
        },
        CreateWirelessGatewayTask: {
          http: {
            requestUri: "/wireless-gateways/{Id}/tasks",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Id",
              "WirelessGatewayTaskDefinitionId"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              WirelessGatewayTaskDefinitionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WirelessGatewayTaskDefinitionId: {},
              Status: {}
            }
          }
        },
        CreateWirelessGatewayTaskDefinition: {
          http: {
            requestUri: "/wireless-gateway-task-definitions",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AutoCreateTasks"
            ],
            members: {
              AutoCreateTasks: {
                type: "boolean"
              },
              Name: {},
              Update: {
                shape: "S4j"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {},
              Arn: {}
            }
          }
        },
        DeleteDestination: {
          http: {
            method: "DELETE",
            requestUri: "/destinations/{Name}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDeviceProfile: {
          http: {
            method: "DELETE",
            requestUri: "/device-profiles/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteFuotaTask: {
          http: {
            method: "DELETE",
            requestUri: "/fuota-tasks/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteMulticastGroup: {
          http: {
            method: "DELETE",
            requestUri: "/multicast-groups/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteNetworkAnalyzerConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/network-analyzer-configurations/{ConfigurationName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationName"
            ],
            members: {
              ConfigurationName: {
                location: "uri",
                locationName: "ConfigurationName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteQueuedMessages: {
          http: {
            method: "DELETE",
            requestUri: "/wireless-devices/{Id}/data",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id",
              "MessageId"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              MessageId: {
                location: "querystring",
                locationName: "messageId"
              },
              WirelessDeviceType: {
                location: "querystring",
                locationName: "WirelessDeviceType"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteServiceProfile: {
          http: {
            method: "DELETE",
            requestUri: "/service-profiles/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteWirelessDevice: {
          http: {
            method: "DELETE",
            requestUri: "/wireless-devices/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteWirelessDeviceImportTask: {
          http: {
            method: "DELETE",
            requestUri: "/wireless_device_import_task/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteWirelessGateway: {
          http: {
            method: "DELETE",
            requestUri: "/wireless-gateways/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteWirelessGatewayTask: {
          http: {
            method: "DELETE",
            requestUri: "/wireless-gateways/{Id}/tasks",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteWirelessGatewayTaskDefinition: {
          http: {
            method: "DELETE",
            requestUri: "/wireless-gateway-task-definitions/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeregisterWirelessDevice: {
          http: {
            method: "PATCH",
            requestUri: "/wireless-devices/{Identifier}/deregister"
          },
          input: {
            type: "structure",
            required: [
              "Identifier"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "Identifier"
              },
              WirelessDeviceType: {
                location: "querystring",
                locationName: "WirelessDeviceType"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateAwsAccountFromPartnerAccount: {
          http: {
            method: "DELETE",
            requestUri: "/partner-accounts/{PartnerAccountId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "PartnerAccountId",
              "PartnerType"
            ],
            members: {
              PartnerAccountId: {
                location: "uri",
                locationName: "PartnerAccountId"
              },
              PartnerType: {
                location: "querystring",
                locationName: "partnerType"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateMulticastGroupFromFuotaTask: {
          http: {
            method: "DELETE",
            requestUri: "/fuota-tasks/{Id}/multicast-groups/{MulticastGroupId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id",
              "MulticastGroupId"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              MulticastGroupId: {
                location: "uri",
                locationName: "MulticastGroupId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateWirelessDeviceFromFuotaTask: {
          http: {
            method: "DELETE",
            requestUri: "/fuota-tasks/{Id}/wireless-devices/{WirelessDeviceId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id",
              "WirelessDeviceId"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              WirelessDeviceId: {
                location: "uri",
                locationName: "WirelessDeviceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateWirelessDeviceFromMulticastGroup: {
          http: {
            method: "DELETE",
            requestUri: "/multicast-groups/{Id}/wireless-devices/{WirelessDeviceId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id",
              "WirelessDeviceId"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              WirelessDeviceId: {
                location: "uri",
                locationName: "WirelessDeviceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateWirelessDeviceFromThing: {
          http: {
            method: "DELETE",
            requestUri: "/wireless-devices/{Id}/thing",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateWirelessGatewayFromCertificate: {
          http: {
            method: "DELETE",
            requestUri: "/wireless-gateways/{Id}/certificate",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateWirelessGatewayFromThing: {
          http: {
            method: "DELETE",
            requestUri: "/wireless-gateways/{Id}/thing",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetDestination: {
          http: {
            method: "GET",
            requestUri: "/destinations/{Name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Name: {},
              Expression: {},
              ExpressionType: {},
              Description: {},
              RoleArn: {}
            }
          }
        },
        GetDeviceProfile: {
          http: {
            method: "GET",
            requestUri: "/device-profiles/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Name: {},
              Id: {},
              LoRaWAN: {
                shape: "S16"
              },
              Sidewalk: {
                type: "structure",
                members: {
                  ApplicationServerPublicKey: {
                    type: "string",
                    sensitive: true
                  },
                  QualificationStatus: {
                    type: "boolean"
                  },
                  DakCertificateMetadata: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "CertificateId"
                      ],
                      members: {
                        CertificateId: {},
                        MaxAllowedSignature: {
                          type: "integer"
                        },
                        FactorySupport: {
                          type: "boolean"
                        },
                        ApId: {},
                        DeviceTypeId: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetEventConfigurationByResourceTypes: {
          http: {
            method: "GET",
            requestUri: "/event-configurations-resource-types"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              DeviceRegistrationState: {
                shape: "S6j"
              },
              Proximity: {
                shape: "S6m"
              },
              Join: {
                shape: "S6n"
              },
              ConnectionStatus: {
                shape: "S6p"
              },
              MessageDeliveryStatus: {
                shape: "S6r"
              }
            }
          }
        },
        GetFuotaTask: {
          http: {
            method: "GET",
            requestUri: "/fuota-tasks/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Id: {},
              Status: {},
              Name: {},
              Description: {},
              LoRaWAN: {
                type: "structure",
                members: {
                  RfRegion: {},
                  StartTime: {
                    shape: "S6w"
                  }
                }
              },
              FirmwareUpdateImage: {},
              FirmwareUpdateRole: {},
              CreatedAt: {
                type: "timestamp"
              },
              RedundancyPercent: {
                type: "integer"
              },
              FragmentSizeBytes: {
                type: "integer"
              },
              FragmentIntervalMS: {
                type: "integer"
              }
            }
          }
        },
        GetLogLevelsByResourceTypes: {
          http: {
            method: "GET",
            requestUri: "/log-levels",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              DefaultLogLevel: {},
              WirelessGatewayLogOptions: {
                shape: "S70"
              },
              WirelessDeviceLogOptions: {
                shape: "S76"
              }
            }
          }
        },
        GetMulticastGroup: {
          http: {
            method: "GET",
            requestUri: "/multicast-groups/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Id: {},
              Name: {},
              Description: {},
              Status: {},
              LoRaWAN: {
                type: "structure",
                members: {
                  RfRegion: {},
                  DlClass: {},
                  NumberOfDevicesRequested: {
                    type: "integer"
                  },
                  NumberOfDevicesInGroup: {
                    type: "integer"
                  }
                }
              },
              CreatedAt: {
                type: "timestamp"
              }
            }
          }
        },
        GetMulticastGroupSession: {
          http: {
            method: "GET",
            requestUri: "/multicast-groups/{Id}/session"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LoRaWAN: {
                shape: "S7j"
              }
            }
          }
        },
        GetNetworkAnalyzerConfiguration: {
          http: {
            method: "GET",
            requestUri: "/network-analyzer-configurations/{ConfigurationName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationName"
            ],
            members: {
              ConfigurationName: {
                location: "uri",
                locationName: "ConfigurationName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TraceContent: {
                shape: "S2e"
              },
              WirelessDevices: {
                shape: "S2i"
              },
              WirelessGateways: {
                shape: "S2j"
              },
              Description: {},
              Arn: {},
              Name: {},
              MulticastGroups: {
                shape: "S2k"
              }
            }
          }
        },
        GetPartnerAccount: {
          http: {
            method: "GET",
            requestUri: "/partner-accounts/{PartnerAccountId}"
          },
          input: {
            type: "structure",
            required: [
              "PartnerAccountId",
              "PartnerType"
            ],
            members: {
              PartnerAccountId: {
                location: "uri",
                locationName: "PartnerAccountId"
              },
              PartnerType: {
                location: "querystring",
                locationName: "partnerType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Sidewalk: {
                shape: "S7s"
              },
              AccountLinked: {
                type: "boolean"
              }
            }
          }
        },
        GetPosition: {
          http: {
            method: "GET",
            requestUri: "/positions/{ResourceIdentifier}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceIdentifier",
              "ResourceType"
            ],
            members: {
              ResourceIdentifier: {
                location: "uri",
                locationName: "ResourceIdentifier"
              },
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              }
            },
            deprecated: true,
            deprecatedMessage: "This operation is no longer supported."
          },
          output: {
            type: "structure",
            members: {
              Position: {
                shape: "S7z"
              },
              Accuracy: {
                type: "structure",
                members: {
                  HorizontalAccuracy: {
                    type: "float"
                  },
                  VerticalAccuracy: {
                    type: "float"
                  }
                }
              },
              SolverType: {},
              SolverProvider: {},
              SolverVersion: {},
              Timestamp: {}
            },
            deprecated: true,
            deprecatedMessage: "This operation is no longer supported."
          },
          deprecated: true,
          deprecatedMessage: "This operation is no longer supported."
        },
        GetPositionConfiguration: {
          http: {
            method: "GET",
            requestUri: "/position-configurations/{ResourceIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceIdentifier",
              "ResourceType"
            ],
            members: {
              ResourceIdentifier: {
                location: "uri",
                locationName: "ResourceIdentifier"
              },
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              }
            },
            deprecated: true,
            deprecatedMessage: "This operation is no longer supported."
          },
          output: {
            type: "structure",
            members: {
              Solvers: {
                shape: "S8a"
              },
              Destination: {}
            },
            deprecated: true,
            deprecatedMessage: "This operation is no longer supported."
          },
          deprecated: true,
          deprecatedMessage: "This operation is no longer supported."
        },
        GetPositionEstimate: {
          http: {
            requestUri: "/position-estimate"
          },
          input: {
            type: "structure",
            members: {
              WiFiAccessPoints: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "MacAddress",
                    "Rss"
                  ],
                  members: {
                    MacAddress: {},
                    Rss: {
                      type: "integer"
                    }
                  }
                }
              },
              CellTowers: {
                type: "structure",
                members: {
                  Gsm: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Mcc",
                        "Mnc",
                        "Lac",
                        "GeranCid"
                      ],
                      members: {
                        Mcc: {
                          type: "integer"
                        },
                        Mnc: {
                          type: "integer"
                        },
                        Lac: {
                          type: "integer"
                        },
                        GeranCid: {
                          type: "integer"
                        },
                        GsmLocalId: {
                          type: "structure",
                          required: [
                            "Bsic",
                            "Bcch"
                          ],
                          members: {
                            Bsic: {
                              type: "integer"
                            },
                            Bcch: {
                              type: "integer"
                            }
                          }
                        },
                        GsmTimingAdvance: {
                          type: "integer"
                        },
                        RxLevel: {
                          type: "integer"
                        },
                        GsmNmr: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "Bsic",
                              "Bcch"
                            ],
                            members: {
                              Bsic: {
                                type: "integer"
                              },
                              Bcch: {
                                type: "integer"
                              },
                              RxLevel: {
                                type: "integer"
                              },
                              GlobalIdentity: {
                                type: "structure",
                                required: [
                                  "Lac",
                                  "GeranCid"
                                ],
                                members: {
                                  Lac: {
                                    type: "integer"
                                  },
                                  GeranCid: {
                                    type: "integer"
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  },
                  Wcdma: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Mcc",
                        "Mnc",
                        "UtranCid"
                      ],
                      members: {
                        Mcc: {
                          type: "integer"
                        },
                        Mnc: {
                          type: "integer"
                        },
                        Lac: {
                          type: "integer"
                        },
                        UtranCid: {
                          type: "integer"
                        },
                        WcdmaLocalId: {
                          type: "structure",
                          required: [
                            "Uarfcndl",
                            "Psc"
                          ],
                          members: {
                            Uarfcndl: {
                              type: "integer"
                            },
                            Psc: {
                              type: "integer"
                            }
                          }
                        },
                        Rscp: {
                          type: "integer"
                        },
                        PathLoss: {
                          type: "integer"
                        },
                        WcdmaNmr: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "Uarfcndl",
                              "Psc",
                              "UtranCid"
                            ],
                            members: {
                              Uarfcndl: {
                                type: "integer"
                              },
                              Psc: {
                                type: "integer"
                              },
                              UtranCid: {
                                type: "integer"
                              },
                              Rscp: {
                                type: "integer"
                              },
                              PathLoss: {
                                type: "integer"
                              }
                            }
                          }
                        }
                      }
                    }
                  },
                  Tdscdma: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Mcc",
                        "Mnc",
                        "UtranCid"
                      ],
                      members: {
                        Mcc: {
                          type: "integer"
                        },
                        Mnc: {
                          type: "integer"
                        },
                        Lac: {
                          type: "integer"
                        },
                        UtranCid: {
                          type: "integer"
                        },
                        TdscdmaLocalId: {
                          type: "structure",
                          required: [
                            "Uarfcn",
                            "CellParams"
                          ],
                          members: {
                            Uarfcn: {
                              type: "integer"
                            },
                            CellParams: {
                              type: "integer"
                            }
                          }
                        },
                        TdscdmaTimingAdvance: {
                          type: "integer"
                        },
                        Rscp: {
                          type: "integer"
                        },
                        PathLoss: {
                          type: "integer"
                        },
                        TdscdmaNmr: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "Uarfcn",
                              "CellParams"
                            ],
                            members: {
                              Uarfcn: {
                                type: "integer"
                              },
                              CellParams: {
                                type: "integer"
                              },
                              UtranCid: {
                                type: "integer"
                              },
                              Rscp: {
                                type: "integer"
                              },
                              PathLoss: {
                                type: "integer"
                              }
                            }
                          }
                        }
                      }
                    }
                  },
                  Lte: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Mcc",
                        "Mnc",
                        "EutranCid"
                      ],
                      members: {
                        Mcc: {
                          type: "integer"
                        },
                        Mnc: {
                          type: "integer"
                        },
                        EutranCid: {
                          type: "integer"
                        },
                        Tac: {
                          type: "integer"
                        },
                        LteLocalId: {
                          type: "structure",
                          required: [
                            "Pci",
                            "Earfcn"
                          ],
                          members: {
                            Pci: {
                              type: "integer"
                            },
                            Earfcn: {
                              type: "integer"
                            }
                          }
                        },
                        LteTimingAdvance: {
                          type: "integer"
                        },
                        Rsrp: {
                          type: "integer"
                        },
                        Rsrq: {
                          type: "float"
                        },
                        NrCapable: {
                          type: "boolean"
                        },
                        LteNmr: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "Pci",
                              "Earfcn",
                              "EutranCid"
                            ],
                            members: {
                              Pci: {
                                type: "integer"
                              },
                              Earfcn: {
                                type: "integer"
                              },
                              EutranCid: {
                                type: "integer"
                              },
                              Rsrp: {
                                type: "integer"
                              },
                              Rsrq: {
                                type: "float"
                              }
                            }
                          }
                        }
                      }
                    }
                  },
                  Cdma: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "SystemId",
                        "NetworkId",
                        "BaseStationId"
                      ],
                      members: {
                        SystemId: {
                          type: "integer"
                        },
                        NetworkId: {
                          type: "integer"
                        },
                        BaseStationId: {
                          type: "integer"
                        },
                        RegistrationZone: {
                          type: "integer"
                        },
                        CdmaLocalId: {
                          type: "structure",
                          required: [
                            "PnOffset",
                            "CdmaChannel"
                          ],
                          members: {
                            PnOffset: {
                              type: "integer"
                            },
                            CdmaChannel: {
                              type: "integer"
                            }
                          }
                        },
                        PilotPower: {
                          type: "integer"
                        },
                        BaseLat: {
                          type: "float"
                        },
                        BaseLng: {
                          type: "float"
                        },
                        CdmaNmr: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "PnOffset",
                              "CdmaChannel"
                            ],
                            members: {
                              PnOffset: {
                                type: "integer"
                              },
                              CdmaChannel: {
                                type: "integer"
                              },
                              PilotPower: {
                                type: "integer"
                              },
                              BaseStationId: {
                                type: "integer"
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              Ip: {
                type: "structure",
                required: [
                  "IpAddress"
                ],
                members: {
                  IpAddress: {}
                }
              },
              Gnss: {
                type: "structure",
                required: [
                  "Payload"
                ],
                members: {
                  Payload: {},
                  CaptureTime: {
                    type: "float"
                  },
                  CaptureTimeAccuracy: {
                    type: "float"
                  },
                  AssistPosition: {
                    type: "list",
                    member: {
                      type: "float"
                    }
                  },
                  AssistAltitude: {
                    type: "float"
                  },
                  Use2DSolver: {
                    type: "boolean"
                  }
                }
              },
              Timestamp: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GeoJsonPayload: {
                type: "blob"
              }
            },
            payload: "GeoJsonPayload"
          }
        },
        GetResourceEventConfiguration: {
          http: {
            method: "GET",
            requestUri: "/event-configurations/{Identifier}"
          },
          input: {
            type: "structure",
            required: [
              "Identifier",
              "IdentifierType"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "Identifier"
              },
              IdentifierType: {
                location: "querystring",
                locationName: "identifierType"
              },
              PartnerType: {
                location: "querystring",
                locationName: "partnerType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeviceRegistrationState: {
                shape: "San"
              },
              Proximity: {
                shape: "Sap"
              },
              Join: {
                shape: "Saq"
              },
              ConnectionStatus: {
                shape: "Sas"
              },
              MessageDeliveryStatus: {
                shape: "Sau"
              }
            }
          }
        },
        GetResourceLogLevel: {
          http: {
            method: "GET",
            requestUri: "/log-levels/{ResourceIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceIdentifier",
              "ResourceType"
            ],
            members: {
              ResourceIdentifier: {
                location: "uri",
                locationName: "ResourceIdentifier"
              },
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LogLevel: {}
            }
          }
        },
        GetResourcePosition: {
          http: {
            method: "GET",
            requestUri: "/resource-positions/{ResourceIdentifier}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceIdentifier",
              "ResourceType"
            ],
            members: {
              ResourceIdentifier: {
                location: "uri",
                locationName: "ResourceIdentifier"
              },
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GeoJsonPayload: {
                type: "blob"
              }
            },
            payload: "GeoJsonPayload"
          }
        },
        GetServiceEndpoint: {
          http: {
            method: "GET",
            requestUri: "/service-endpoint"
          },
          input: {
            type: "structure",
            members: {
              ServiceType: {
                location: "querystring",
                locationName: "serviceType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceType: {},
              ServiceEndpoint: {},
              ServerTrust: {}
            }
          }
        },
        GetServiceProfile: {
          http: {
            method: "GET",
            requestUri: "/service-profiles/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Name: {},
              Id: {},
              LoRaWAN: {
                type: "structure",
                members: {
                  UlRate: {
                    type: "integer"
                  },
                  UlBucketSize: {
                    type: "integer"
                  },
                  UlRatePolicy: {},
                  DlRate: {
                    type: "integer"
                  },
                  DlBucketSize: {
                    type: "integer"
                  },
                  DlRatePolicy: {},
                  AddGwMetadata: {
                    type: "boolean"
                  },
                  DevStatusReqFreq: {
                    type: "integer"
                  },
                  ReportDevStatusBattery: {
                    type: "boolean"
                  },
                  ReportDevStatusMargin: {
                    type: "boolean"
                  },
                  DrMin: {
                    type: "integer"
                  },
                  DrMax: {
                    type: "integer"
                  },
                  ChannelMask: {},
                  PrAllowed: {
                    type: "boolean"
                  },
                  HrAllowed: {
                    type: "boolean"
                  },
                  RaAllowed: {
                    type: "boolean"
                  },
                  NwkGeoLoc: {
                    type: "boolean"
                  },
                  TargetPer: {
                    type: "integer"
                  },
                  MinGwDiversity: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        GetWirelessDevice: {
          http: {
            method: "GET",
            requestUri: "/wireless-devices/{Identifier}"
          },
          input: {
            type: "structure",
            required: [
              "Identifier",
              "IdentifierType"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "Identifier"
              },
              IdentifierType: {
                location: "querystring",
                locationName: "identifierType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Type: {},
              Name: {},
              Description: {},
              DestinationName: {},
              Id: {},
              Arn: {},
              ThingName: {},
              ThingArn: {},
              LoRaWAN: {
                shape: "S31"
              },
              Sidewalk: {
                type: "structure",
                members: {
                  AmazonId: {},
                  SidewalkId: {},
                  SidewalkManufacturingSn: {},
                  DeviceCertificates: {
                    shape: "Sbw"
                  },
                  PrivateKeys: {
                    type: "list",
                    member: {
                      shape: "Sbx"
                    }
                  },
                  DeviceProfileId: {},
                  CertificateId: {},
                  Status: {}
                }
              },
              Positioning: {}
            }
          }
        },
        GetWirelessDeviceImportTask: {
          http: {
            method: "GET",
            requestUri: "/wireless_device_import_task/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {},
              Arn: {},
              DestinationName: {},
              Sidewalk: {
                shape: "Sc5"
              },
              CreationTime: {
                shape: "Sc9"
              },
              Status: {},
              StatusReason: {},
              InitializedImportedDeviceCount: {
                type: "long"
              },
              PendingImportedDeviceCount: {
                type: "long"
              },
              OnboardedImportedDeviceCount: {
                type: "long"
              },
              FailedImportedDeviceCount: {
                type: "long"
              }
            }
          }
        },
        GetWirelessDeviceStatistics: {
          http: {
            method: "GET",
            requestUri: "/wireless-devices/{Id}/statistics",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "WirelessDeviceId"
            ],
            members: {
              WirelessDeviceId: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WirelessDeviceId: {},
              LastUplinkReceivedAt: {},
              LoRaWAN: {
                type: "structure",
                members: {
                  DevEui: {},
                  FPort: {
                    type: "integer"
                  },
                  DataRate: {
                    type: "integer"
                  },
                  Frequency: {
                    type: "integer"
                  },
                  Timestamp: {},
                  Gateways: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        GatewayEui: {},
                        Snr: {
                          type: "double"
                        },
                        Rssi: {
                          type: "double"
                        }
                      }
                    }
                  }
                }
              },
              Sidewalk: {
                type: "structure",
                members: {
                  Rssi: {
                    type: "integer"
                  },
                  BatteryLevel: {},
                  Event: {},
                  DeviceState: {}
                }
              }
            }
          }
        },
        GetWirelessGateway: {
          http: {
            method: "GET",
            requestUri: "/wireless-gateways/{Identifier}"
          },
          input: {
            type: "structure",
            required: [
              "Identifier",
              "IdentifierType"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "Identifier"
              },
              IdentifierType: {
                location: "querystring",
                locationName: "identifierType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Id: {},
              Description: {},
              LoRaWAN: {
                shape: "S3x"
              },
              Arn: {},
              ThingName: {},
              ThingArn: {}
            }
          }
        },
        GetWirelessGatewayCertificate: {
          http: {
            method: "GET",
            requestUri: "/wireless-gateways/{Id}/certificate"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IotCertificateId: {},
              LoRaWANNetworkServerCertificateId: {}
            }
          }
        },
        GetWirelessGatewayFirmwareInformation: {
          http: {
            method: "GET",
            requestUri: "/wireless-gateways/{Id}/firmware-information"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LoRaWAN: {
                type: "structure",
                members: {
                  CurrentVersion: {
                    shape: "S4o"
                  }
                }
              }
            }
          }
        },
        GetWirelessGatewayStatistics: {
          http: {
            method: "GET",
            requestUri: "/wireless-gateways/{Id}/statistics",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "WirelessGatewayId"
            ],
            members: {
              WirelessGatewayId: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WirelessGatewayId: {},
              LastUplinkReceivedAt: {},
              ConnectionStatus: {}
            }
          }
        },
        GetWirelessGatewayTask: {
          http: {
            method: "GET",
            requestUri: "/wireless-gateways/{Id}/tasks"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WirelessGatewayId: {},
              WirelessGatewayTaskDefinitionId: {},
              LastUplinkReceivedAt: {},
              TaskCreatedAt: {},
              Status: {}
            }
          }
        },
        GetWirelessGatewayTaskDefinition: {
          http: {
            method: "GET",
            requestUri: "/wireless-gateway-task-definitions/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AutoCreateTasks: {
                type: "boolean"
              },
              Name: {},
              Update: {
                shape: "S4j"
              },
              Arn: {}
            }
          }
        },
        ListDestinations: {
          http: {
            method: "GET",
            requestUri: "/destinations"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              DestinationList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Name: {},
                    ExpressionType: {},
                    Expression: {},
                    Description: {},
                    RoleArn: {}
                  }
                }
              }
            }
          }
        },
        ListDeviceProfiles: {
          http: {
            method: "GET",
            requestUri: "/device-profiles"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              DeviceProfileType: {
                location: "querystring",
                locationName: "deviceProfileType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              DeviceProfileList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Name: {},
                    Id: {}
                  }
                }
              }
            }
          }
        },
        ListDevicesForWirelessDeviceImportTask: {
          http: {
            method: "GET",
            requestUri: "/wireless_device_import_task"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "querystring",
                locationName: "id"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              Status: {
                location: "querystring",
                locationName: "status"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              DestinationName: {},
              ImportedWirelessDeviceList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Sidewalk: {
                      type: "structure",
                      members: {
                        SidewalkManufacturingSn: {},
                        OnboardingStatus: {},
                        OnboardingStatusReason: {},
                        LastUpdateTime: {
                          type: "timestamp",
                          timestampFormat: "iso8601"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        ListEventConfigurations: {
          http: {
            method: "GET",
            requestUri: "/event-configurations"
          },
          input: {
            type: "structure",
            required: [
              "ResourceType"
            ],
            members: {
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              EventConfigurationsList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Identifier: {},
                    IdentifierType: {},
                    PartnerType: {},
                    Events: {
                      type: "structure",
                      members: {
                        DeviceRegistrationState: {
                          shape: "San"
                        },
                        Proximity: {
                          shape: "Sap"
                        },
                        Join: {
                          shape: "Saq"
                        },
                        ConnectionStatus: {
                          shape: "Sas"
                        },
                        MessageDeliveryStatus: {
                          shape: "Sau"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        ListFuotaTasks: {
          http: {
            method: "GET",
            requestUri: "/fuota-tasks"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              FuotaTaskList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListMulticastGroups: {
          http: {
            method: "GET",
            requestUri: "/multicast-groups"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              MulticastGroupList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListMulticastGroupsByFuotaTask: {
          http: {
            method: "GET",
            requestUri: "/fuota-tasks/{Id}/multicast-groups"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              MulticastGroupList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {}
                  }
                }
              }
            }
          }
        },
        ListNetworkAnalyzerConfigurations: {
          http: {
            method: "GET",
            requestUri: "/network-analyzer-configurations"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              NetworkAnalyzerConfigurationList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListPartnerAccounts: {
          http: {
            method: "GET",
            requestUri: "/partner-accounts"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Sidewalk: {
                type: "list",
                member: {
                  shape: "S7s"
                }
              }
            }
          }
        },
        ListPositionConfigurations: {
          http: {
            method: "GET",
            requestUri: "/position-configurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            deprecated: true,
            deprecatedMessage: "This operation is no longer supported."
          },
          output: {
            type: "structure",
            members: {
              PositionConfigurationList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceIdentifier: {},
                    ResourceType: {},
                    Solvers: {
                      shape: "S8a"
                    },
                    Destination: {}
                  }
                }
              },
              NextToken: {}
            },
            deprecated: true,
            deprecatedMessage: "This operation is no longer supported."
          },
          deprecated: true,
          deprecatedMessage: "This operation is no longer supported."
        },
        ListQueuedMessages: {
          http: {
            method: "GET",
            requestUri: "/wireless-devices/{Id}/data"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              WirelessDeviceType: {
                location: "querystring",
                locationName: "WirelessDeviceType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              DownlinkQueueMessagesList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MessageId: {},
                    TransmitMode: {
                      type: "integer"
                    },
                    ReceivedAt: {},
                    LoRaWAN: {
                      shape: "Sek"
                    }
                  }
                }
              }
            }
          }
        },
        ListServiceProfiles: {
          http: {
            method: "GET",
            requestUri: "/service-profiles"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ServiceProfileList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Name: {},
                    Id: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S6"
              }
            }
          }
        },
        ListWirelessDeviceImportTasks: {
          http: {
            method: "GET",
            requestUri: "/wireless_device_import_tasks"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              WirelessDeviceImportTaskList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    DestinationName: {},
                    Sidewalk: {
                      shape: "Sc5"
                    },
                    CreationTime: {
                      shape: "Sc9"
                    },
                    Status: {},
                    StatusReason: {},
                    InitializedImportedDeviceCount: {
                      type: "long"
                    },
                    PendingImportedDeviceCount: {
                      type: "long"
                    },
                    OnboardedImportedDeviceCount: {
                      type: "long"
                    },
                    FailedImportedDeviceCount: {
                      type: "long"
                    }
                  }
                }
              }
            }
          }
        },
        ListWirelessDevices: {
          http: {
            method: "GET",
            requestUri: "/wireless-devices"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              DestinationName: {
                location: "querystring",
                locationName: "destinationName"
              },
              DeviceProfileId: {
                location: "querystring",
                locationName: "deviceProfileId"
              },
              ServiceProfileId: {
                location: "querystring",
                locationName: "serviceProfileId"
              },
              WirelessDeviceType: {
                location: "querystring",
                locationName: "wirelessDeviceType"
              },
              FuotaTaskId: {
                location: "querystring",
                locationName: "fuotaTaskId"
              },
              MulticastGroupId: {
                location: "querystring",
                locationName: "multicastGroupId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              WirelessDeviceList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Id: {},
                    Type: {},
                    Name: {},
                    DestinationName: {},
                    LastUplinkReceivedAt: {},
                    LoRaWAN: {
                      type: "structure",
                      members: {
                        DevEui: {}
                      }
                    },
                    Sidewalk: {
                      type: "structure",
                      members: {
                        AmazonId: {},
                        SidewalkId: {},
                        SidewalkManufacturingSn: {},
                        DeviceCertificates: {
                          shape: "Sbw"
                        },
                        DeviceProfileId: {},
                        Status: {}
                      }
                    },
                    FuotaDeviceStatus: {},
                    MulticastDeviceStatus: {},
                    McGroupId: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        ListWirelessGatewayTaskDefinitions: {
          http: {
            method: "GET",
            requestUri: "/wireless-gateway-task-definitions"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              TaskDefinitionType: {
                location: "querystring",
                locationName: "taskDefinitionType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              TaskDefinitions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    LoRaWAN: {
                      type: "structure",
                      members: {
                        CurrentVersion: {
                          shape: "S4o"
                        },
                        UpdateVersion: {
                          shape: "S4o"
                        }
                      }
                    },
                    Arn: {}
                  }
                }
              }
            }
          }
        },
        ListWirelessGateways: {
          http: {
            method: "GET",
            requestUri: "/wireless-gateways"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              WirelessGatewayList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Id: {},
                    Name: {},
                    Description: {},
                    LoRaWAN: {
                      shape: "S3x"
                    },
                    LastUplinkReceivedAt: {}
                  }
                }
              }
            }
          }
        },
        PutPositionConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/position-configurations/{ResourceIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceIdentifier",
              "ResourceType"
            ],
            members: {
              ResourceIdentifier: {
                location: "uri",
                locationName: "ResourceIdentifier"
              },
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              },
              Solvers: {
                type: "structure",
                members: {
                  SemtechGnss: {
                    type: "structure",
                    required: [
                      "Status",
                      "Fec"
                    ],
                    members: {
                      Status: {},
                      Fec: {}
                    }
                  }
                }
              },
              Destination: {}
            },
            deprecated: true,
            deprecatedMessage: "This operation is no longer supported."
          },
          output: {
            type: "structure",
            members: {},
            deprecated: true,
            deprecatedMessage: "This operation is no longer supported."
          },
          deprecated: true,
          deprecatedMessage: "This operation is no longer supported."
        },
        PutResourceLogLevel: {
          http: {
            method: "PUT",
            requestUri: "/log-levels/{ResourceIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceIdentifier",
              "ResourceType",
              "LogLevel"
            ],
            members: {
              ResourceIdentifier: {
                location: "uri",
                locationName: "ResourceIdentifier"
              },
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              },
              LogLevel: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ResetAllResourceLogLevels: {
          http: {
            method: "DELETE",
            requestUri: "/log-levels",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ResetResourceLogLevel: {
          http: {
            method: "DELETE",
            requestUri: "/log-levels/{ResourceIdentifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceIdentifier",
              "ResourceType"
            ],
            members: {
              ResourceIdentifier: {
                location: "uri",
                locationName: "ResourceIdentifier"
              },
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SendDataToMulticastGroup: {
          http: {
            requestUri: "/multicast-groups/{Id}/data",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Id",
              "PayloadData",
              "WirelessMetadata"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              PayloadData: {},
              WirelessMetadata: {
                type: "structure",
                members: {
                  LoRaWAN: {
                    type: "structure",
                    members: {
                      FPort: {
                        type: "integer"
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MessageId: {}
            }
          }
        },
        SendDataToWirelessDevice: {
          http: {
            requestUri: "/wireless-devices/{Id}/data",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "Id",
              "TransmitMode",
              "PayloadData"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              TransmitMode: {
                type: "integer"
              },
              PayloadData: {},
              WirelessMetadata: {
                type: "structure",
                members: {
                  LoRaWAN: {
                    shape: "Sek"
                  },
                  Sidewalk: {
                    type: "structure",
                    members: {
                      Seq: {
                        type: "integer"
                      },
                      MessageType: {},
                      AckModeRetryDurationSecs: {
                        type: "integer"
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MessageId: {}
            }
          }
        },
        StartBulkAssociateWirelessDeviceWithMulticastGroup: {
          http: {
            method: "PATCH",
            requestUri: "/multicast-groups/{Id}/bulk",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              QueryString: {},
              Tags: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartBulkDisassociateWirelessDeviceFromMulticastGroup: {
          http: {
            requestUri: "/multicast-groups/{Id}/bulk",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              QueryString: {},
              Tags: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartFuotaTask: {
          http: {
            method: "PUT",
            requestUri: "/fuota-tasks/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              LoRaWAN: {
                type: "structure",
                members: {
                  StartTime: {
                    shape: "S6w"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartMulticastGroupSession: {
          http: {
            method: "PUT",
            requestUri: "/multicast-groups/{Id}/session",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id",
              "LoRaWAN"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              LoRaWAN: {
                shape: "S7j"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartSingleWirelessDeviceImportTask: {
          http: {
            requestUri: "/wireless_single_device_import_task",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DestinationName",
              "Sidewalk"
            ],
            members: {
              DestinationName: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              DeviceName: {},
              Tags: {
                shape: "S6"
              },
              Sidewalk: {
                type: "structure",
                members: {
                  SidewalkManufacturingSn: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {},
              Arn: {}
            }
          }
        },
        StartWirelessDeviceImportTask: {
          http: {
            requestUri: "/wireless_device_import_task",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DestinationName",
              "Sidewalk"
            ],
            members: {
              DestinationName: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S6"
              },
              Sidewalk: {
                type: "structure",
                members: {
                  DeviceCreationFile: {},
                  Role: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {},
              Arn: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              Tags: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TestWirelessDevice: {
          http: {
            requestUri: "/wireless-devices/{Id}/test",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Result: {}
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDestination: {
          http: {
            method: "PATCH",
            requestUri: "/destinations/{Name}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              },
              ExpressionType: {},
              Expression: {},
              Description: {},
              RoleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateEventConfigurationByResourceTypes: {
          http: {
            method: "PATCH",
            requestUri: "/event-configurations-resource-types",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              DeviceRegistrationState: {
                shape: "S6j"
              },
              Proximity: {
                shape: "S6m"
              },
              Join: {
                shape: "S6n"
              },
              ConnectionStatus: {
                shape: "S6p"
              },
              MessageDeliveryStatus: {
                shape: "S6r"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateFuotaTask: {
          http: {
            method: "PATCH",
            requestUri: "/fuota-tasks/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              Name: {},
              Description: {},
              LoRaWAN: {
                shape: "S1x"
              },
              FirmwareUpdateImage: {},
              FirmwareUpdateRole: {},
              RedundancyPercent: {
                type: "integer"
              },
              FragmentSizeBytes: {
                type: "integer"
              },
              FragmentIntervalMS: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateLogLevelsByResourceTypes: {
          http: {
            requestUri: "/log-levels",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DefaultLogLevel: {},
              WirelessDeviceLogOptions: {
                shape: "S76"
              },
              WirelessGatewayLogOptions: {
                shape: "S70"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateMulticastGroup: {
          http: {
            method: "PATCH",
            requestUri: "/multicast-groups/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              Name: {},
              Description: {},
              LoRaWAN: {
                shape: "S28"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateNetworkAnalyzerConfiguration: {
          http: {
            method: "PATCH",
            requestUri: "/network-analyzer-configurations/{ConfigurationName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationName"
            ],
            members: {
              ConfigurationName: {
                location: "uri",
                locationName: "ConfigurationName"
              },
              TraceContent: {
                shape: "S2e"
              },
              WirelessDevicesToAdd: {
                shape: "S2i"
              },
              WirelessDevicesToRemove: {
                shape: "S2i"
              },
              WirelessGatewaysToAdd: {
                shape: "S2j"
              },
              WirelessGatewaysToRemove: {
                shape: "S2j"
              },
              Description: {},
              MulticastGroupsToAdd: {
                shape: "S2k"
              },
              MulticastGroupsToRemove: {
                shape: "S2k"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdatePartnerAccount: {
          http: {
            method: "PATCH",
            requestUri: "/partner-accounts/{PartnerAccountId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Sidewalk",
              "PartnerAccountId",
              "PartnerType"
            ],
            members: {
              Sidewalk: {
                type: "structure",
                members: {
                  AppServerPrivateKey: {
                    shape: "S4"
                  }
                }
              },
              PartnerAccountId: {
                location: "uri",
                locationName: "PartnerAccountId"
              },
              PartnerType: {
                location: "querystring",
                locationName: "partnerType"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdatePosition: {
          http: {
            method: "PATCH",
            requestUri: "/positions/{ResourceIdentifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceIdentifier",
              "ResourceType",
              "Position"
            ],
            members: {
              ResourceIdentifier: {
                location: "uri",
                locationName: "ResourceIdentifier"
              },
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              },
              Position: {
                shape: "S7z"
              }
            },
            deprecated: true,
            deprecatedMessage: "This operation is no longer supported."
          },
          output: {
            type: "structure",
            members: {},
            deprecated: true,
            deprecatedMessage: "This operation is no longer supported."
          },
          deprecated: true,
          deprecatedMessage: "This operation is no longer supported."
        },
        UpdateResourceEventConfiguration: {
          http: {
            method: "PATCH",
            requestUri: "/event-configurations/{Identifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Identifier",
              "IdentifierType"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "Identifier"
              },
              IdentifierType: {
                location: "querystring",
                locationName: "identifierType"
              },
              PartnerType: {
                location: "querystring",
                locationName: "partnerType"
              },
              DeviceRegistrationState: {
                shape: "San"
              },
              Proximity: {
                shape: "Sap"
              },
              Join: {
                shape: "Saq"
              },
              ConnectionStatus: {
                shape: "Sas"
              },
              MessageDeliveryStatus: {
                shape: "Sau"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateResourcePosition: {
          http: {
            method: "PATCH",
            requestUri: "/resource-positions/{ResourceIdentifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceIdentifier",
              "ResourceType"
            ],
            members: {
              ResourceIdentifier: {
                location: "uri",
                locationName: "ResourceIdentifier"
              },
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              },
              GeoJsonPayload: {
                type: "blob"
              }
            },
            payload: "GeoJsonPayload"
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateWirelessDevice: {
          http: {
            method: "PATCH",
            requestUri: "/wireless-devices/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              DestinationName: {},
              Name: {},
              Description: {},
              LoRaWAN: {
                type: "structure",
                members: {
                  DeviceProfileId: {},
                  ServiceProfileId: {},
                  AbpV1_1: {
                    type: "structure",
                    members: {
                      FCntStart: {
                        type: "integer"
                      }
                    }
                  },
                  AbpV1_0_x: {
                    type: "structure",
                    members: {
                      FCntStart: {
                        type: "integer"
                      }
                    }
                  },
                  FPorts: {
                    type: "structure",
                    members: {
                      Positioning: {
                        shape: "S3n"
                      },
                      Applications: {
                        shape: "S3o"
                      }
                    }
                  }
                }
              },
              Positioning: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateWirelessDeviceImportTask: {
          http: {
            method: "PATCH",
            requestUri: "/wireless_device_import_task/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id",
              "Sidewalk"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              Sidewalk: {
                type: "structure",
                members: {
                  DeviceCreationFile: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateWirelessGateway: {
          http: {
            method: "PATCH",
            requestUri: "/wireless-gateways/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              Name: {},
              Description: {},
              JoinEuiFilters: {
                shape: "S3z"
              },
              NetIdFilters: {
                shape: "S41"
              },
              MaxEirp: {
                type: "float"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          members: {
            AmazonId: {},
            AppServerPrivateKey: {
              shape: "S4"
            }
          }
        },
        S4: {
          type: "string",
          sensitive: true
        },
        S6: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S16: {
          type: "structure",
          members: {
            SupportsClassB: {
              type: "boolean"
            },
            ClassBTimeout: {
              type: "integer"
            },
            PingSlotPeriod: {
              type: "integer"
            },
            PingSlotDr: {
              type: "integer"
            },
            PingSlotFreq: {
              type: "integer"
            },
            SupportsClassC: {
              type: "boolean"
            },
            ClassCTimeout: {
              type: "integer"
            },
            MacVersion: {},
            RegParamsRevision: {},
            RxDelay1: {
              type: "integer"
            },
            RxDrOffset1: {
              type: "integer"
            },
            RxDataRate2: {
              type: "integer"
            },
            RxFreq2: {
              type: "integer"
            },
            FactoryPresetFreqsList: {
              type: "list",
              member: {
                type: "integer"
              }
            },
            MaxEirp: {
              type: "integer"
            },
            MaxDutyCycle: {
              type: "integer"
            },
            RfRegion: {},
            SupportsJoin: {
              type: "boolean"
            },
            Supports32BitFCnt: {
              type: "boolean"
            }
          }
        },
        S1x: {
          type: "structure",
          members: {
            RfRegion: {}
          }
        },
        S28: {
          type: "structure",
          members: {
            RfRegion: {},
            DlClass: {}
          }
        },
        S2e: {
          type: "structure",
          members: {
            WirelessDeviceFrameInfo: {},
            LogLevel: {},
            MulticastFrameInfo: {}
          }
        },
        S2i: {
          type: "list",
          member: {}
        },
        S2j: {
          type: "list",
          member: {}
        },
        S2k: {
          type: "list",
          member: {}
        },
        S31: {
          type: "structure",
          members: {
            DevEui: {},
            DeviceProfileId: {},
            ServiceProfileId: {},
            OtaaV1_1: {
              type: "structure",
              members: {
                AppKey: {},
                NwkKey: {},
                JoinEui: {}
              }
            },
            OtaaV1_0_x: {
              type: "structure",
              members: {
                AppKey: {},
                AppEui: {},
                JoinEui: {},
                GenAppKey: {}
              }
            },
            AbpV1_1: {
              type: "structure",
              members: {
                DevAddr: {},
                SessionKeys: {
                  type: "structure",
                  members: {
                    FNwkSIntKey: {},
                    SNwkSIntKey: {},
                    NwkSEncKey: {},
                    AppSKey: {}
                  }
                },
                FCntStart: {
                  type: "integer"
                }
              }
            },
            AbpV1_0_x: {
              type: "structure",
              members: {
                DevAddr: {},
                SessionKeys: {
                  type: "structure",
                  members: {
                    NwkSKey: {},
                    AppSKey: {}
                  }
                },
                FCntStart: {
                  type: "integer"
                }
              }
            },
            FPorts: {
              type: "structure",
              members: {
                Fuota: {
                  type: "integer"
                },
                Multicast: {
                  type: "integer"
                },
                ClockSync: {
                  type: "integer"
                },
                Positioning: {
                  shape: "S3n"
                },
                Applications: {
                  shape: "S3o"
                }
              }
            }
          }
        },
        S3n: {
          type: "structure",
          members: {
            ClockSync: {
              type: "integer"
            },
            Stream: {
              type: "integer"
            },
            Gnss: {
              type: "integer"
            }
          }
        },
        S3o: {
          type: "list",
          member: {
            type: "structure",
            members: {
              FPort: {
                type: "integer"
              },
              Type: {},
              DestinationName: {}
            }
          }
        },
        S3x: {
          type: "structure",
          members: {
            GatewayEui: {},
            RfRegion: {},
            JoinEuiFilters: {
              shape: "S3z"
            },
            NetIdFilters: {
              shape: "S41"
            },
            SubBands: {
              type: "list",
              member: {
                type: "integer"
              }
            },
            Beaconing: {
              type: "structure",
              members: {
                DataRate: {
                  type: "integer"
                },
                Frequencies: {
                  type: "list",
                  member: {
                    type: "integer"
                  }
                }
              }
            },
            MaxEirp: {
              type: "float"
            }
          }
        },
        S3z: {
          type: "list",
          member: {
            type: "list",
            member: {}
          }
        },
        S41: {
          type: "list",
          member: {}
        },
        S4j: {
          type: "structure",
          members: {
            UpdateDataSource: {},
            UpdateDataRole: {},
            LoRaWAN: {
              type: "structure",
              members: {
                UpdateSignature: {},
                SigKeyCrc: {
                  type: "long"
                },
                CurrentVersion: {
                  shape: "S4o"
                },
                UpdateVersion: {
                  shape: "S4o"
                }
              }
            }
          }
        },
        S4o: {
          type: "structure",
          members: {
            PackageVersion: {},
            Model: {},
            Station: {}
          }
        },
        S6j: {
          type: "structure",
          members: {
            Sidewalk: {
              shape: "S6k"
            }
          }
        },
        S6k: {
          type: "structure",
          members: {
            WirelessDeviceEventTopic: {}
          }
        },
        S6m: {
          type: "structure",
          members: {
            Sidewalk: {
              shape: "S6k"
            }
          }
        },
        S6n: {
          type: "structure",
          members: {
            LoRaWAN: {
              type: "structure",
              members: {
                WirelessDeviceEventTopic: {}
              }
            }
          }
        },
        S6p: {
          type: "structure",
          members: {
            LoRaWAN: {
              type: "structure",
              members: {
                WirelessGatewayEventTopic: {}
              }
            }
          }
        },
        S6r: {
          type: "structure",
          members: {
            Sidewalk: {
              shape: "S6k"
            }
          }
        },
        S6w: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S70: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Type",
              "LogLevel"
            ],
            members: {
              Type: {},
              LogLevel: {},
              Events: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Event",
                    "LogLevel"
                  ],
                  members: {
                    Event: {},
                    LogLevel: {}
                  }
                }
              }
            }
          }
        },
        S76: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Type",
              "LogLevel"
            ],
            members: {
              Type: {},
              LogLevel: {},
              Events: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Event",
                    "LogLevel"
                  ],
                  members: {
                    Event: {},
                    LogLevel: {}
                  }
                }
              }
            }
          }
        },
        S7j: {
          type: "structure",
          members: {
            DlDr: {
              type: "integer"
            },
            DlFreq: {
              type: "integer"
            },
            SessionStartTime: {
              type: "timestamp",
              timestampFormat: "iso8601"
            },
            SessionTimeout: {
              type: "integer"
            },
            PingSlotPeriod: {
              type: "integer"
            }
          }
        },
        S7s: {
          type: "structure",
          members: {
            AmazonId: {},
            Fingerprint: {
              type: "string",
              sensitive: true
            },
            Arn: {}
          }
        },
        S7z: {
          type: "list",
          member: {
            type: "float"
          }
        },
        S8a: {
          type: "structure",
          members: {
            SemtechGnss: {
              type: "structure",
              members: {
                Provider: {},
                Type: {},
                Status: {},
                Fec: {}
              }
            }
          }
        },
        San: {
          type: "structure",
          members: {
            Sidewalk: {
              shape: "Sao"
            },
            WirelessDeviceIdEventTopic: {}
          }
        },
        Sao: {
          type: "structure",
          members: {
            AmazonIdEventTopic: {}
          }
        },
        Sap: {
          type: "structure",
          members: {
            Sidewalk: {
              shape: "Sao"
            },
            WirelessDeviceIdEventTopic: {}
          }
        },
        Saq: {
          type: "structure",
          members: {
            LoRaWAN: {
              type: "structure",
              members: {
                DevEuiEventTopic: {}
              }
            },
            WirelessDeviceIdEventTopic: {}
          }
        },
        Sas: {
          type: "structure",
          members: {
            LoRaWAN: {
              type: "structure",
              members: {
                GatewayEuiEventTopic: {}
              }
            },
            WirelessGatewayIdEventTopic: {}
          }
        },
        Sau: {
          type: "structure",
          members: {
            Sidewalk: {
              shape: "Sao"
            },
            WirelessDeviceIdEventTopic: {}
          }
        },
        Sbw: {
          type: "list",
          member: {
            shape: "Sbx"
          }
        },
        Sbx: {
          type: "structure",
          required: [
            "SigningAlg",
            "Value"
          ],
          members: {
            SigningAlg: {},
            Value: {}
          }
        },
        Sc5: {
          type: "structure",
          members: {
            DeviceCreationFileList: {
              type: "list",
              member: {}
            },
            Role: {}
          }
        },
        Sc9: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        Sek: {
          type: "structure",
          members: {
            FPort: {
              type: "integer"
            },
            ParticipatingGateways: {
              type: "structure",
              required: [
                "DownlinkMode",
                "GatewayList",
                "TransmissionInterval"
              ],
              members: {
                DownlinkMode: {},
                GatewayList: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "GatewayId",
                      "DownlinkFrequency"
                    ],
                    members: {
                      GatewayId: {},
                      DownlinkFrequency: {
                        type: "integer"
                      }
                    }
                  }
                },
                TransmissionInterval: {
                  type: "integer"
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iotwireless-2020-11-22.paginators.json
var require_iotwireless_2020_11_22_paginators = __commonJS({
  "node_modules/aws-sdk/apis/iotwireless-2020-11-22.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListDestinations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDeviceProfiles: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListFuotaTasks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMulticastGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMulticastGroupsByFuotaTask: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListNetworkAnalyzerConfigurations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListPositionConfigurations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListQueuedMessages: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListServiceProfiles: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListWirelessDevices: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListWirelessGateways: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/iotwireless.js
var require_iotwireless = __commonJS({
  "node_modules/aws-sdk/clients/iotwireless.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["iotwireless"] = {};
    AWS2.IoTWireless = Service.defineService("iotwireless", ["2020-11-22"]);
    Object.defineProperty(apiLoader.services["iotwireless"], "2020-11-22", {
      get: function get() {
        var model = require_iotwireless_2020_11_22_min();
        model.paginators = require_iotwireless_2020_11_22_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.IoTWireless;
  }
});

// node_modules/aws-sdk/apis/location-2020-11-19.min.json
var require_location_2020_11_19_min = __commonJS({
  "node_modules/aws-sdk/apis/location-2020-11-19.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-11-19",
        endpointPrefix: "geo",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Location Service",
        serviceId: "Location",
        signatureVersion: "v4",
        signingName: "geo",
        uid: "location-2020-11-19"
      },
      operations: {
        AssociateTrackerConsumer: {
          http: {
            requestUri: "/tracking/v0/trackers/{TrackerName}/consumers",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ConsumerArn",
              "TrackerName"
            ],
            members: {
              ConsumerArn: {},
              TrackerName: {
                location: "uri",
                locationName: "TrackerName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "cp.tracking."
          }
        },
        BatchDeleteDevicePositionHistory: {
          http: {
            requestUri: "/tracking/v0/trackers/{TrackerName}/delete-positions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DeviceIds",
              "TrackerName"
            ],
            members: {
              DeviceIds: {
                type: "list",
                member: {}
              },
              TrackerName: {
                location: "uri",
                locationName: "TrackerName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Errors"
            ],
            members: {
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "DeviceId",
                    "Error"
                  ],
                  members: {
                    DeviceId: {},
                    Error: {
                      shape: "Sb"
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "tracking."
          }
        },
        BatchDeleteGeofence: {
          http: {
            requestUri: "/geofencing/v0/collections/{CollectionName}/delete-geofences",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CollectionName",
              "GeofenceIds"
            ],
            members: {
              CollectionName: {
                location: "uri",
                locationName: "CollectionName"
              },
              GeofenceIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Errors"
            ],
            members: {
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Error",
                    "GeofenceId"
                  ],
                  members: {
                    Error: {
                      shape: "Sb"
                    },
                    GeofenceId: {}
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "geofencing."
          }
        },
        BatchEvaluateGeofences: {
          http: {
            requestUri: "/geofencing/v0/collections/{CollectionName}/positions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CollectionName",
              "DevicePositionUpdates"
            ],
            members: {
              CollectionName: {
                location: "uri",
                locationName: "CollectionName"
              },
              DevicePositionUpdates: {
                type: "list",
                member: {
                  shape: "Sl"
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Errors"
            ],
            members: {
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "DeviceId",
                    "Error",
                    "SampleTime"
                  ],
                  members: {
                    DeviceId: {},
                    Error: {
                      shape: "Sb"
                    },
                    SampleTime: {
                      shape: "St"
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "geofencing."
          }
        },
        BatchGetDevicePosition: {
          http: {
            requestUri: "/tracking/v0/trackers/{TrackerName}/get-positions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DeviceIds",
              "TrackerName"
            ],
            members: {
              DeviceIds: {
                type: "list",
                member: {}
              },
              TrackerName: {
                location: "uri",
                locationName: "TrackerName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DevicePositions",
              "Errors"
            ],
            members: {
              DevicePositions: {
                shape: "S11"
              },
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "DeviceId",
                    "Error"
                  ],
                  members: {
                    DeviceId: {},
                    Error: {
                      shape: "Sb"
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "tracking."
          }
        },
        BatchPutGeofence: {
          http: {
            requestUri: "/geofencing/v0/collections/{CollectionName}/put-geofences",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CollectionName",
              "Entries"
            ],
            members: {
              CollectionName: {
                location: "uri",
                locationName: "CollectionName"
              },
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "GeofenceId",
                    "Geometry"
                  ],
                  members: {
                    GeofenceId: {},
                    GeofenceProperties: {
                      shape: "Sq"
                    },
                    Geometry: {
                      shape: "S18"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Errors",
              "Successes"
            ],
            members: {
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Error",
                    "GeofenceId"
                  ],
                  members: {
                    Error: {
                      shape: "Sb"
                    },
                    GeofenceId: {}
                  }
                }
              },
              Successes: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "CreateTime",
                    "GeofenceId",
                    "UpdateTime"
                  ],
                  members: {
                    CreateTime: {
                      shape: "St"
                    },
                    GeofenceId: {},
                    UpdateTime: {
                      shape: "St"
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "geofencing."
          }
        },
        BatchUpdateDevicePosition: {
          http: {
            requestUri: "/tracking/v0/trackers/{TrackerName}/positions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "TrackerName",
              "Updates"
            ],
            members: {
              TrackerName: {
                location: "uri",
                locationName: "TrackerName"
              },
              Updates: {
                type: "list",
                member: {
                  shape: "Sl"
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Errors"
            ],
            members: {
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "DeviceId",
                    "Error",
                    "SampleTime"
                  ],
                  members: {
                    DeviceId: {},
                    Error: {
                      shape: "Sb"
                    },
                    SampleTime: {
                      shape: "St"
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "tracking."
          }
        },
        CalculateRoute: {
          http: {
            requestUri: "/routes/v0/calculators/{CalculatorName}/calculate/route",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CalculatorName",
              "DeparturePosition",
              "DestinationPosition"
            ],
            members: {
              ArrivalTime: {
                shape: "St"
              },
              CalculatorName: {
                location: "uri",
                locationName: "CalculatorName"
              },
              CarModeOptions: {
                shape: "S1n"
              },
              DepartNow: {
                type: "boolean"
              },
              DeparturePosition: {
                shape: "So"
              },
              DepartureTime: {
                shape: "St"
              },
              DestinationPosition: {
                shape: "So"
              },
              DistanceUnit: {},
              IncludeLegGeometry: {
                type: "boolean"
              },
              Key: {
                shape: "S1q",
                location: "querystring",
                locationName: "key"
              },
              OptimizeFor: {},
              TravelMode: {},
              TruckModeOptions: {
                shape: "S1t"
              },
              WaypointPositions: {
                type: "list",
                member: {
                  shape: "So"
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Legs",
              "Summary"
            ],
            members: {
              Legs: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Distance",
                    "DurationSeconds",
                    "EndPosition",
                    "StartPosition",
                    "Steps"
                  ],
                  members: {
                    Distance: {
                      type: "double"
                    },
                    DurationSeconds: {
                      type: "double"
                    },
                    EndPosition: {
                      shape: "So"
                    },
                    Geometry: {
                      type: "structure",
                      members: {
                        LineString: {
                          type: "list",
                          member: {
                            shape: "So"
                          }
                        }
                      }
                    },
                    StartPosition: {
                      shape: "So"
                    },
                    Steps: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "Distance",
                          "DurationSeconds",
                          "EndPosition",
                          "StartPosition"
                        ],
                        members: {
                          Distance: {
                            type: "double"
                          },
                          DurationSeconds: {
                            type: "double"
                          },
                          EndPosition: {
                            shape: "So"
                          },
                          GeometryOffset: {
                            type: "integer"
                          },
                          StartPosition: {
                            shape: "So"
                          }
                        }
                      }
                    }
                  }
                }
              },
              Summary: {
                type: "structure",
                required: [
                  "DataSource",
                  "Distance",
                  "DistanceUnit",
                  "DurationSeconds",
                  "RouteBBox"
                ],
                members: {
                  DataSource: {},
                  Distance: {
                    type: "double"
                  },
                  DistanceUnit: {},
                  DurationSeconds: {
                    type: "double"
                  },
                  RouteBBox: {
                    shape: "S2i"
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "routes."
          }
        },
        CalculateRouteMatrix: {
          http: {
            requestUri: "/routes/v0/calculators/{CalculatorName}/calculate/route-matrix",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CalculatorName",
              "DeparturePositions",
              "DestinationPositions"
            ],
            members: {
              CalculatorName: {
                location: "uri",
                locationName: "CalculatorName"
              },
              CarModeOptions: {
                shape: "S1n"
              },
              DepartNow: {
                type: "boolean"
              },
              DeparturePositions: {
                type: "list",
                member: {
                  shape: "So"
                }
              },
              DepartureTime: {
                shape: "St"
              },
              DestinationPositions: {
                type: "list",
                member: {
                  shape: "So"
                }
              },
              DistanceUnit: {},
              Key: {
                shape: "S1q",
                location: "querystring",
                locationName: "key"
              },
              TravelMode: {},
              TruckModeOptions: {
                shape: "S1t"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "RouteMatrix",
              "Summary"
            ],
            members: {
              RouteMatrix: {
                type: "list",
                member: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      Distance: {
                        type: "double"
                      },
                      DurationSeconds: {
                        type: "double"
                      },
                      Error: {
                        type: "structure",
                        required: [
                          "Code"
                        ],
                        members: {
                          Code: {},
                          Message: {}
                        }
                      }
                    }
                  }
                }
              },
              SnappedDeparturePositions: {
                type: "list",
                member: {
                  shape: "So"
                }
              },
              SnappedDestinationPositions: {
                type: "list",
                member: {
                  shape: "So"
                }
              },
              Summary: {
                type: "structure",
                required: [
                  "DataSource",
                  "DistanceUnit",
                  "ErrorCount",
                  "RouteCount"
                ],
                members: {
                  DataSource: {},
                  DistanceUnit: {},
                  ErrorCount: {
                    type: "integer"
                  },
                  RouteCount: {
                    type: "integer"
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "routes."
          }
        },
        CreateGeofenceCollection: {
          http: {
            requestUri: "/geofencing/v0/collections",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CollectionName"
            ],
            members: {
              CollectionName: {},
              Description: {},
              KmsKeyId: {},
              PricingPlan: {
                deprecated: true,
                deprecatedMessage: "Deprecated. If included, the only allowed value is RequestBasedUsage."
              },
              PricingPlanDataSource: {
                deprecated: true,
                deprecatedMessage: "Deprecated. No longer allowed."
              },
              Tags: {
                shape: "S33"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CollectionArn",
              "CollectionName",
              "CreateTime"
            ],
            members: {
              CollectionArn: {},
              CollectionName: {},
              CreateTime: {
                shape: "St"
              }
            }
          },
          endpoint: {
            hostPrefix: "cp.geofencing."
          },
          idempotent: true
        },
        CreateKey: {
          http: {
            requestUri: "/metadata/v0/keys",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "KeyName",
              "Restrictions"
            ],
            members: {
              Description: {},
              ExpireTime: {
                shape: "St"
              },
              KeyName: {},
              NoExpiry: {
                type: "boolean"
              },
              Restrictions: {
                shape: "S38"
              },
              Tags: {
                shape: "S33"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CreateTime",
              "Key",
              "KeyArn",
              "KeyName"
            ],
            members: {
              CreateTime: {
                shape: "St"
              },
              Key: {
                shape: "S1q"
              },
              KeyArn: {},
              KeyName: {}
            }
          },
          endpoint: {
            hostPrefix: "cp.metadata."
          },
          idempotent: true
        },
        CreateMap: {
          http: {
            requestUri: "/maps/v0/maps",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Configuration",
              "MapName"
            ],
            members: {
              Configuration: {
                shape: "S3h"
              },
              Description: {},
              MapName: {},
              PricingPlan: {
                deprecated: true,
                deprecatedMessage: "Deprecated. If included, the only allowed value is RequestBasedUsage."
              },
              Tags: {
                shape: "S33"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CreateTime",
              "MapArn",
              "MapName"
            ],
            members: {
              CreateTime: {
                shape: "St"
              },
              MapArn: {},
              MapName: {}
            }
          },
          endpoint: {
            hostPrefix: "cp.maps."
          },
          idempotent: true
        },
        CreatePlaceIndex: {
          http: {
            requestUri: "/places/v0/indexes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DataSource",
              "IndexName"
            ],
            members: {
              DataSource: {},
              DataSourceConfiguration: {
                shape: "S3m"
              },
              Description: {},
              IndexName: {},
              PricingPlan: {
                deprecated: true,
                deprecatedMessage: "Deprecated. If included, the only allowed value is RequestBasedUsage."
              },
              Tags: {
                shape: "S33"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CreateTime",
              "IndexArn",
              "IndexName"
            ],
            members: {
              CreateTime: {
                shape: "St"
              },
              IndexArn: {},
              IndexName: {}
            }
          },
          endpoint: {
            hostPrefix: "cp.places."
          },
          idempotent: true
        },
        CreateRouteCalculator: {
          http: {
            requestUri: "/routes/v0/calculators",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CalculatorName",
              "DataSource"
            ],
            members: {
              CalculatorName: {},
              DataSource: {},
              Description: {},
              PricingPlan: {
                deprecated: true,
                deprecatedMessage: "Deprecated. If included, the only allowed value is RequestBasedUsage."
              },
              Tags: {
                shape: "S33"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CalculatorArn",
              "CalculatorName",
              "CreateTime"
            ],
            members: {
              CalculatorArn: {},
              CalculatorName: {},
              CreateTime: {
                shape: "St"
              }
            }
          },
          endpoint: {
            hostPrefix: "cp.routes."
          },
          idempotent: true
        },
        CreateTracker: {
          http: {
            requestUri: "/tracking/v0/trackers",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "TrackerName"
            ],
            members: {
              Description: {},
              EventBridgeEnabled: {
                type: "boolean"
              },
              KmsKeyEnableGeospatialQueries: {
                type: "boolean"
              },
              KmsKeyId: {},
              PositionFiltering: {},
              PricingPlan: {
                deprecated: true,
                deprecatedMessage: "Deprecated. If included, the only allowed value is RequestBasedUsage."
              },
              PricingPlanDataSource: {
                deprecated: true,
                deprecatedMessage: "Deprecated. No longer allowed."
              },
              Tags: {
                shape: "S33"
              },
              TrackerName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "CreateTime",
              "TrackerArn",
              "TrackerName"
            ],
            members: {
              CreateTime: {
                shape: "St"
              },
              TrackerArn: {},
              TrackerName: {}
            }
          },
          endpoint: {
            hostPrefix: "cp.tracking."
          },
          idempotent: true
        },
        DeleteGeofenceCollection: {
          http: {
            method: "DELETE",
            requestUri: "/geofencing/v0/collections/{CollectionName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CollectionName"
            ],
            members: {
              CollectionName: {
                location: "uri",
                locationName: "CollectionName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "cp.geofencing."
          },
          idempotent: true
        },
        DeleteKey: {
          http: {
            method: "DELETE",
            requestUri: "/metadata/v0/keys/{KeyName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "KeyName"
            ],
            members: {
              ForceDelete: {
                location: "querystring",
                locationName: "forceDelete",
                type: "boolean"
              },
              KeyName: {
                location: "uri",
                locationName: "KeyName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "cp.metadata."
          },
          idempotent: true
        },
        DeleteMap: {
          http: {
            method: "DELETE",
            requestUri: "/maps/v0/maps/{MapName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MapName"
            ],
            members: {
              MapName: {
                location: "uri",
                locationName: "MapName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "cp.maps."
          },
          idempotent: true
        },
        DeletePlaceIndex: {
          http: {
            method: "DELETE",
            requestUri: "/places/v0/indexes/{IndexName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IndexName"
            ],
            members: {
              IndexName: {
                location: "uri",
                locationName: "IndexName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "cp.places."
          },
          idempotent: true
        },
        DeleteRouteCalculator: {
          http: {
            method: "DELETE",
            requestUri: "/routes/v0/calculators/{CalculatorName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CalculatorName"
            ],
            members: {
              CalculatorName: {
                location: "uri",
                locationName: "CalculatorName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "cp.routes."
          },
          idempotent: true
        },
        DeleteTracker: {
          http: {
            method: "DELETE",
            requestUri: "/tracking/v0/trackers/{TrackerName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "TrackerName"
            ],
            members: {
              TrackerName: {
                location: "uri",
                locationName: "TrackerName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "cp.tracking."
          },
          idempotent: true
        },
        DescribeGeofenceCollection: {
          http: {
            method: "GET",
            requestUri: "/geofencing/v0/collections/{CollectionName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CollectionName"
            ],
            members: {
              CollectionName: {
                location: "uri",
                locationName: "CollectionName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CollectionArn",
              "CollectionName",
              "CreateTime",
              "Description",
              "UpdateTime"
            ],
            members: {
              CollectionArn: {},
              CollectionName: {},
              CreateTime: {
                shape: "St"
              },
              Description: {},
              GeofenceCount: {
                type: "integer"
              },
              KmsKeyId: {},
              PricingPlan: {
                deprecated: true,
                deprecatedMessage: "Deprecated. Always returns RequestBasedUsage."
              },
              PricingPlanDataSource: {
                deprecated: true,
                deprecatedMessage: "Deprecated. Unused."
              },
              Tags: {
                shape: "S33"
              },
              UpdateTime: {
                shape: "St"
              }
            }
          },
          endpoint: {
            hostPrefix: "cp.geofencing."
          }
        },
        DescribeKey: {
          http: {
            method: "GET",
            requestUri: "/metadata/v0/keys/{KeyName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "KeyName"
            ],
            members: {
              KeyName: {
                location: "uri",
                locationName: "KeyName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CreateTime",
              "ExpireTime",
              "Key",
              "KeyArn",
              "KeyName",
              "Restrictions",
              "UpdateTime"
            ],
            members: {
              CreateTime: {
                shape: "St"
              },
              Description: {},
              ExpireTime: {
                shape: "St"
              },
              Key: {
                shape: "S1q"
              },
              KeyArn: {},
              KeyName: {},
              Restrictions: {
                shape: "S38"
              },
              Tags: {
                shape: "S33"
              },
              UpdateTime: {
                shape: "St"
              }
            }
          },
          endpoint: {
            hostPrefix: "cp.metadata."
          }
        },
        DescribeMap: {
          http: {
            method: "GET",
            requestUri: "/maps/v0/maps/{MapName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MapName"
            ],
            members: {
              MapName: {
                location: "uri",
                locationName: "MapName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Configuration",
              "CreateTime",
              "DataSource",
              "Description",
              "MapArn",
              "MapName",
              "UpdateTime"
            ],
            members: {
              Configuration: {
                shape: "S3h"
              },
              CreateTime: {
                shape: "St"
              },
              DataSource: {},
              Description: {},
              MapArn: {},
              MapName: {},
              PricingPlan: {
                deprecated: true,
                deprecatedMessage: "Deprecated. Always returns RequestBasedUsage."
              },
              Tags: {
                shape: "S33"
              },
              UpdateTime: {
                shape: "St"
              }
            }
          },
          endpoint: {
            hostPrefix: "cp.maps."
          }
        },
        DescribePlaceIndex: {
          http: {
            method: "GET",
            requestUri: "/places/v0/indexes/{IndexName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IndexName"
            ],
            members: {
              IndexName: {
                location: "uri",
                locationName: "IndexName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CreateTime",
              "DataSource",
              "DataSourceConfiguration",
              "Description",
              "IndexArn",
              "IndexName",
              "UpdateTime"
            ],
            members: {
              CreateTime: {
                shape: "St"
              },
              DataSource: {},
              DataSourceConfiguration: {
                shape: "S3m"
              },
              Description: {},
              IndexArn: {},
              IndexName: {},
              PricingPlan: {
                deprecated: true,
                deprecatedMessage: "Deprecated. Always returns RequestBasedUsage."
              },
              Tags: {
                shape: "S33"
              },
              UpdateTime: {
                shape: "St"
              }
            }
          },
          endpoint: {
            hostPrefix: "cp.places."
          }
        },
        DescribeRouteCalculator: {
          http: {
            method: "GET",
            requestUri: "/routes/v0/calculators/{CalculatorName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CalculatorName"
            ],
            members: {
              CalculatorName: {
                location: "uri",
                locationName: "CalculatorName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CalculatorArn",
              "CalculatorName",
              "CreateTime",
              "DataSource",
              "Description",
              "UpdateTime"
            ],
            members: {
              CalculatorArn: {},
              CalculatorName: {},
              CreateTime: {
                shape: "St"
              },
              DataSource: {},
              Description: {},
              PricingPlan: {
                deprecated: true,
                deprecatedMessage: "Deprecated. Always returns RequestBasedUsage."
              },
              Tags: {
                shape: "S33"
              },
              UpdateTime: {
                shape: "St"
              }
            }
          },
          endpoint: {
            hostPrefix: "cp.routes."
          }
        },
        DescribeTracker: {
          http: {
            method: "GET",
            requestUri: "/tracking/v0/trackers/{TrackerName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "TrackerName"
            ],
            members: {
              TrackerName: {
                location: "uri",
                locationName: "TrackerName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CreateTime",
              "Description",
              "TrackerArn",
              "TrackerName",
              "UpdateTime"
            ],
            members: {
              CreateTime: {
                shape: "St"
              },
              Description: {},
              EventBridgeEnabled: {
                type: "boolean"
              },
              KmsKeyEnableGeospatialQueries: {
                type: "boolean"
              },
              KmsKeyId: {},
              PositionFiltering: {},
              PricingPlan: {
                deprecated: true,
                deprecatedMessage: "Deprecated. Always returns RequestBasedUsage."
              },
              PricingPlanDataSource: {
                deprecated: true,
                deprecatedMessage: "Deprecated. Unused."
              },
              Tags: {
                shape: "S33"
              },
              TrackerArn: {},
              TrackerName: {},
              UpdateTime: {
                shape: "St"
              }
            }
          },
          endpoint: {
            hostPrefix: "cp.tracking."
          }
        },
        DisassociateTrackerConsumer: {
          http: {
            method: "DELETE",
            requestUri: "/tracking/v0/trackers/{TrackerName}/consumers/{ConsumerArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ConsumerArn",
              "TrackerName"
            ],
            members: {
              ConsumerArn: {
                location: "uri",
                locationName: "ConsumerArn"
              },
              TrackerName: {
                location: "uri",
                locationName: "TrackerName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "cp.tracking."
          }
        },
        GetDevicePosition: {
          http: {
            method: "GET",
            requestUri: "/tracking/v0/trackers/{TrackerName}/devices/{DeviceId}/positions/latest",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DeviceId",
              "TrackerName"
            ],
            members: {
              DeviceId: {
                location: "uri",
                locationName: "DeviceId"
              },
              TrackerName: {
                location: "uri",
                locationName: "TrackerName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Position",
              "ReceivedTime",
              "SampleTime"
            ],
            members: {
              Accuracy: {
                shape: "Sm"
              },
              DeviceId: {},
              Position: {
                shape: "So"
              },
              PositionProperties: {
                shape: "Sq"
              },
              ReceivedTime: {
                shape: "St"
              },
              SampleTime: {
                shape: "St"
              }
            }
          },
          endpoint: {
            hostPrefix: "tracking."
          }
        },
        GetDevicePositionHistory: {
          http: {
            requestUri: "/tracking/v0/trackers/{TrackerName}/devices/{DeviceId}/list-positions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DeviceId",
              "TrackerName"
            ],
            members: {
              DeviceId: {
                location: "uri",
                locationName: "DeviceId"
              },
              EndTimeExclusive: {
                shape: "St"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              StartTimeInclusive: {
                shape: "St"
              },
              TrackerName: {
                location: "uri",
                locationName: "TrackerName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DevicePositions"
            ],
            members: {
              DevicePositions: {
                shape: "S11"
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "tracking."
          }
        },
        GetGeofence: {
          http: {
            method: "GET",
            requestUri: "/geofencing/v0/collections/{CollectionName}/geofences/{GeofenceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CollectionName",
              "GeofenceId"
            ],
            members: {
              CollectionName: {
                location: "uri",
                locationName: "CollectionName"
              },
              GeofenceId: {
                location: "uri",
                locationName: "GeofenceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CreateTime",
              "GeofenceId",
              "Geometry",
              "Status",
              "UpdateTime"
            ],
            members: {
              CreateTime: {
                shape: "St"
              },
              GeofenceId: {},
              GeofenceProperties: {
                shape: "Sq"
              },
              Geometry: {
                shape: "S18"
              },
              Status: {},
              UpdateTime: {
                shape: "St"
              }
            }
          },
          endpoint: {
            hostPrefix: "geofencing."
          }
        },
        GetMapGlyphs: {
          http: {
            method: "GET",
            requestUri: "/maps/v0/maps/{MapName}/glyphs/{FontStack}/{FontUnicodeRange}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FontStack",
              "FontUnicodeRange",
              "MapName"
            ],
            members: {
              FontStack: {
                location: "uri",
                locationName: "FontStack"
              },
              FontUnicodeRange: {
                location: "uri",
                locationName: "FontUnicodeRange"
              },
              Key: {
                shape: "S1q",
                location: "querystring",
                locationName: "key"
              },
              MapName: {
                location: "uri",
                locationName: "MapName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Blob: {
                type: "blob"
              },
              CacheControl: {
                location: "header",
                locationName: "Cache-Control"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              }
            },
            payload: "Blob"
          },
          endpoint: {
            hostPrefix: "maps."
          }
        },
        GetMapSprites: {
          http: {
            method: "GET",
            requestUri: "/maps/v0/maps/{MapName}/sprites/{FileName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FileName",
              "MapName"
            ],
            members: {
              FileName: {
                location: "uri",
                locationName: "FileName"
              },
              Key: {
                shape: "S1q",
                location: "querystring",
                locationName: "key"
              },
              MapName: {
                location: "uri",
                locationName: "MapName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Blob: {
                type: "blob"
              },
              CacheControl: {
                location: "header",
                locationName: "Cache-Control"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              }
            },
            payload: "Blob"
          },
          endpoint: {
            hostPrefix: "maps."
          }
        },
        GetMapStyleDescriptor: {
          http: {
            method: "GET",
            requestUri: "/maps/v0/maps/{MapName}/style-descriptor",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MapName"
            ],
            members: {
              Key: {
                shape: "S1q",
                location: "querystring",
                locationName: "key"
              },
              MapName: {
                location: "uri",
                locationName: "MapName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Blob: {
                type: "blob"
              },
              CacheControl: {
                location: "header",
                locationName: "Cache-Control"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              }
            },
            payload: "Blob"
          },
          endpoint: {
            hostPrefix: "maps."
          }
        },
        GetMapTile: {
          http: {
            method: "GET",
            requestUri: "/maps/v0/maps/{MapName}/tiles/{Z}/{X}/{Y}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MapName",
              "X",
              "Y",
              "Z"
            ],
            members: {
              Key: {
                shape: "S1q",
                location: "querystring",
                locationName: "key"
              },
              MapName: {
                location: "uri",
                locationName: "MapName"
              },
              X: {
                location: "uri",
                locationName: "X"
              },
              Y: {
                location: "uri",
                locationName: "Y"
              },
              Z: {
                location: "uri",
                locationName: "Z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Blob: {
                type: "blob"
              },
              CacheControl: {
                location: "header",
                locationName: "Cache-Control"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              }
            },
            payload: "Blob"
          },
          endpoint: {
            hostPrefix: "maps."
          }
        },
        GetPlace: {
          http: {
            method: "GET",
            requestUri: "/places/v0/indexes/{IndexName}/places/{PlaceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IndexName",
              "PlaceId"
            ],
            members: {
              IndexName: {
                location: "uri",
                locationName: "IndexName"
              },
              Key: {
                shape: "S1q",
                location: "querystring",
                locationName: "key"
              },
              Language: {
                location: "querystring",
                locationName: "language"
              },
              PlaceId: {
                location: "uri",
                locationName: "PlaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Place"
            ],
            members: {
              Place: {
                shape: "S5b"
              }
            }
          },
          endpoint: {
            hostPrefix: "places."
          }
        },
        ListDevicePositions: {
          http: {
            requestUri: "/tracking/v0/trackers/{TrackerName}/list-positions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "TrackerName"
            ],
            members: {
              FilterGeometry: {
                type: "structure",
                members: {
                  Polygon: {
                    shape: "S1a"
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              TrackerName: {
                location: "uri",
                locationName: "TrackerName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Entries"
            ],
            members: {
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "DeviceId",
                    "Position",
                    "SampleTime"
                  ],
                  members: {
                    Accuracy: {
                      shape: "Sm"
                    },
                    DeviceId: {},
                    Position: {
                      shape: "So"
                    },
                    PositionProperties: {
                      shape: "Sq"
                    },
                    SampleTime: {
                      shape: "St"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "tracking."
          }
        },
        ListGeofenceCollections: {
          http: {
            requestUri: "/geofencing/v0/list-collections",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Entries"
            ],
            members: {
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "CollectionName",
                    "CreateTime",
                    "Description",
                    "UpdateTime"
                  ],
                  members: {
                    CollectionName: {},
                    CreateTime: {
                      shape: "St"
                    },
                    Description: {},
                    PricingPlan: {
                      deprecated: true,
                      deprecatedMessage: "Deprecated. Always returns RequestBasedUsage."
                    },
                    PricingPlanDataSource: {
                      deprecated: true,
                      deprecatedMessage: "Deprecated. Unused."
                    },
                    UpdateTime: {
                      shape: "St"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "cp.geofencing."
          }
        },
        ListGeofences: {
          http: {
            requestUri: "/geofencing/v0/collections/{CollectionName}/list-geofences",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CollectionName"
            ],
            members: {
              CollectionName: {
                location: "uri",
                locationName: "CollectionName"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Entries"
            ],
            members: {
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "CreateTime",
                    "GeofenceId",
                    "Geometry",
                    "Status",
                    "UpdateTime"
                  ],
                  members: {
                    CreateTime: {
                      shape: "St"
                    },
                    GeofenceId: {},
                    GeofenceProperties: {
                      shape: "Sq"
                    },
                    Geometry: {
                      shape: "S18"
                    },
                    Status: {},
                    UpdateTime: {
                      shape: "St"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "geofencing."
          }
        },
        ListKeys: {
          http: {
            requestUri: "/metadata/v0/list-keys",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                members: {
                  KeyStatus: {}
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Entries"
            ],
            members: {
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "CreateTime",
                    "ExpireTime",
                    "KeyName",
                    "Restrictions",
                    "UpdateTime"
                  ],
                  members: {
                    CreateTime: {
                      shape: "St"
                    },
                    Description: {},
                    ExpireTime: {
                      shape: "St"
                    },
                    KeyName: {},
                    Restrictions: {
                      shape: "S38"
                    },
                    UpdateTime: {
                      shape: "St"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "cp.metadata."
          }
        },
        ListMaps: {
          http: {
            requestUri: "/maps/v0/list-maps",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Entries"
            ],
            members: {
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "CreateTime",
                    "DataSource",
                    "Description",
                    "MapName",
                    "UpdateTime"
                  ],
                  members: {
                    CreateTime: {
                      shape: "St"
                    },
                    DataSource: {},
                    Description: {},
                    MapName: {},
                    PricingPlan: {
                      deprecated: true,
                      deprecatedMessage: "Deprecated. Always returns RequestBasedUsage."
                    },
                    UpdateTime: {
                      shape: "St"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "cp.maps."
          }
        },
        ListPlaceIndexes: {
          http: {
            requestUri: "/places/v0/list-indexes",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Entries"
            ],
            members: {
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "CreateTime",
                    "DataSource",
                    "Description",
                    "IndexName",
                    "UpdateTime"
                  ],
                  members: {
                    CreateTime: {
                      shape: "St"
                    },
                    DataSource: {},
                    Description: {},
                    IndexName: {},
                    PricingPlan: {
                      deprecated: true,
                      deprecatedMessage: "Deprecated. Always returns RequestBasedUsage."
                    },
                    UpdateTime: {
                      shape: "St"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "cp.places."
          }
        },
        ListRouteCalculators: {
          http: {
            requestUri: "/routes/v0/list-calculators",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Entries"
            ],
            members: {
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "CalculatorName",
                    "CreateTime",
                    "DataSource",
                    "Description",
                    "UpdateTime"
                  ],
                  members: {
                    CalculatorName: {},
                    CreateTime: {
                      shape: "St"
                    },
                    DataSource: {},
                    Description: {},
                    PricingPlan: {
                      deprecated: true,
                      deprecatedMessage: "Deprecated. Always returns RequestBasedUsage."
                    },
                    UpdateTime: {
                      shape: "St"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "cp.routes."
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S33"
              }
            }
          },
          endpoint: {
            hostPrefix: "cp.metadata."
          }
        },
        ListTrackerConsumers: {
          http: {
            requestUri: "/tracking/v0/trackers/{TrackerName}/list-consumers",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "TrackerName"
            ],
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              TrackerName: {
                location: "uri",
                locationName: "TrackerName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ConsumerArns"
            ],
            members: {
              ConsumerArns: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "cp.tracking."
          }
        },
        ListTrackers: {
          http: {
            requestUri: "/tracking/v0/list-trackers",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Entries"
            ],
            members: {
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "CreateTime",
                    "Description",
                    "TrackerName",
                    "UpdateTime"
                  ],
                  members: {
                    CreateTime: {
                      shape: "St"
                    },
                    Description: {},
                    PricingPlan: {
                      deprecated: true,
                      deprecatedMessage: "Deprecated. Always returns RequestBasedUsage."
                    },
                    PricingPlanDataSource: {
                      deprecated: true,
                      deprecatedMessage: "Deprecated. Unused."
                    },
                    TrackerName: {},
                    UpdateTime: {
                      shape: "St"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "cp.tracking."
          }
        },
        PutGeofence: {
          http: {
            method: "PUT",
            requestUri: "/geofencing/v0/collections/{CollectionName}/geofences/{GeofenceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CollectionName",
              "GeofenceId",
              "Geometry"
            ],
            members: {
              CollectionName: {
                location: "uri",
                locationName: "CollectionName"
              },
              GeofenceId: {
                location: "uri",
                locationName: "GeofenceId"
              },
              GeofenceProperties: {
                shape: "Sq"
              },
              Geometry: {
                shape: "S18"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CreateTime",
              "GeofenceId",
              "UpdateTime"
            ],
            members: {
              CreateTime: {
                shape: "St"
              },
              GeofenceId: {},
              UpdateTime: {
                shape: "St"
              }
            }
          },
          endpoint: {
            hostPrefix: "geofencing."
          }
        },
        SearchPlaceIndexForPosition: {
          http: {
            requestUri: "/places/v0/indexes/{IndexName}/search/position",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IndexName",
              "Position"
            ],
            members: {
              IndexName: {
                location: "uri",
                locationName: "IndexName"
              },
              Key: {
                shape: "S1q",
                location: "querystring",
                locationName: "key"
              },
              Language: {},
              MaxResults: {
                type: "integer"
              },
              Position: {
                shape: "So"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Results",
              "Summary"
            ],
            members: {
              Results: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Distance",
                    "Place"
                  ],
                  members: {
                    Distance: {
                      type: "double"
                    },
                    Place: {
                      shape: "S5b"
                    },
                    PlaceId: {}
                  }
                }
              },
              Summary: {
                type: "structure",
                required: [
                  "DataSource",
                  "Position"
                ],
                members: {
                  DataSource: {},
                  Language: {},
                  MaxResults: {
                    type: "integer"
                  },
                  Position: {
                    shape: "So"
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "places."
          }
        },
        SearchPlaceIndexForSuggestions: {
          http: {
            requestUri: "/places/v0/indexes/{IndexName}/search/suggestions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IndexName",
              "Text"
            ],
            members: {
              BiasPosition: {
                shape: "So"
              },
              FilterBBox: {
                shape: "S2i"
              },
              FilterCategories: {
                shape: "S76"
              },
              FilterCountries: {
                shape: "S77"
              },
              IndexName: {
                location: "uri",
                locationName: "IndexName"
              },
              Key: {
                shape: "S1q",
                location: "querystring",
                locationName: "key"
              },
              Language: {},
              MaxResults: {
                type: "integer"
              },
              Text: {
                type: "string",
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Results",
              "Summary"
            ],
            members: {
              Results: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Text"
                  ],
                  members: {
                    Categories: {
                      shape: "S5c"
                    },
                    PlaceId: {},
                    SupplementalCategories: {
                      shape: "S5f"
                    },
                    Text: {}
                  }
                }
              },
              Summary: {
                type: "structure",
                required: [
                  "DataSource",
                  "Text"
                ],
                members: {
                  BiasPosition: {
                    shape: "So"
                  },
                  DataSource: {},
                  FilterBBox: {
                    shape: "S2i"
                  },
                  FilterCategories: {
                    shape: "S76"
                  },
                  FilterCountries: {
                    shape: "S77"
                  },
                  Language: {},
                  MaxResults: {
                    type: "integer"
                  },
                  Text: {
                    shape: "S7f"
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "places."
          }
        },
        SearchPlaceIndexForText: {
          http: {
            requestUri: "/places/v0/indexes/{IndexName}/search/text",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IndexName",
              "Text"
            ],
            members: {
              BiasPosition: {
                shape: "So"
              },
              FilterBBox: {
                shape: "S2i"
              },
              FilterCategories: {
                shape: "S76"
              },
              FilterCountries: {
                shape: "S77"
              },
              IndexName: {
                location: "uri",
                locationName: "IndexName"
              },
              Key: {
                shape: "S1q",
                location: "querystring",
                locationName: "key"
              },
              Language: {},
              MaxResults: {
                type: "integer"
              },
              Text: {
                type: "string",
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Results",
              "Summary"
            ],
            members: {
              Results: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Place"
                  ],
                  members: {
                    Distance: {
                      type: "double"
                    },
                    Place: {
                      shape: "S5b"
                    },
                    PlaceId: {},
                    Relevance: {
                      type: "double"
                    }
                  }
                }
              },
              Summary: {
                type: "structure",
                required: [
                  "DataSource",
                  "Text"
                ],
                members: {
                  BiasPosition: {
                    shape: "So"
                  },
                  DataSource: {},
                  FilterBBox: {
                    shape: "S2i"
                  },
                  FilterCategories: {
                    shape: "S76"
                  },
                  FilterCountries: {
                    shape: "S77"
                  },
                  Language: {},
                  MaxResults: {
                    type: "integer"
                  },
                  ResultBBox: {
                    shape: "S2i"
                  },
                  Text: {
                    shape: "S7f"
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "places."
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "S33"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "cp.metadata."
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "cp.metadata."
          },
          idempotent: true
        },
        UpdateGeofenceCollection: {
          http: {
            method: "PATCH",
            requestUri: "/geofencing/v0/collections/{CollectionName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CollectionName"
            ],
            members: {
              CollectionName: {
                location: "uri",
                locationName: "CollectionName"
              },
              Description: {},
              PricingPlan: {
                deprecated: true,
                deprecatedMessage: "Deprecated. If included, the only allowed value is RequestBasedUsage."
              },
              PricingPlanDataSource: {
                deprecated: true,
                deprecatedMessage: "Deprecated. No longer allowed."
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CollectionArn",
              "CollectionName",
              "UpdateTime"
            ],
            members: {
              CollectionArn: {},
              CollectionName: {},
              UpdateTime: {
                shape: "St"
              }
            }
          },
          endpoint: {
            hostPrefix: "cp.geofencing."
          },
          idempotent: true
        },
        UpdateKey: {
          http: {
            method: "PATCH",
            requestUri: "/metadata/v0/keys/{KeyName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "KeyName"
            ],
            members: {
              Description: {},
              ExpireTime: {
                shape: "St"
              },
              ForceUpdate: {
                type: "boolean"
              },
              KeyName: {
                location: "uri",
                locationName: "KeyName"
              },
              NoExpiry: {
                type: "boolean"
              },
              Restrictions: {
                shape: "S38"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "KeyArn",
              "KeyName",
              "UpdateTime"
            ],
            members: {
              KeyArn: {},
              KeyName: {},
              UpdateTime: {
                shape: "St"
              }
            }
          },
          endpoint: {
            hostPrefix: "cp.metadata."
          },
          idempotent: true
        },
        UpdateMap: {
          http: {
            method: "PATCH",
            requestUri: "/maps/v0/maps/{MapName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MapName"
            ],
            members: {
              ConfigurationUpdate: {
                type: "structure",
                members: {
                  PoliticalView: {}
                }
              },
              Description: {},
              MapName: {
                location: "uri",
                locationName: "MapName"
              },
              PricingPlan: {
                deprecated: true,
                deprecatedMessage: "Deprecated. If included, the only allowed value is RequestBasedUsage."
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "MapArn",
              "MapName",
              "UpdateTime"
            ],
            members: {
              MapArn: {},
              MapName: {},
              UpdateTime: {
                shape: "St"
              }
            }
          },
          endpoint: {
            hostPrefix: "cp.maps."
          },
          idempotent: true
        },
        UpdatePlaceIndex: {
          http: {
            method: "PATCH",
            requestUri: "/places/v0/indexes/{IndexName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IndexName"
            ],
            members: {
              DataSourceConfiguration: {
                shape: "S3m"
              },
              Description: {},
              IndexName: {
                location: "uri",
                locationName: "IndexName"
              },
              PricingPlan: {
                deprecated: true,
                deprecatedMessage: "Deprecated. If included, the only allowed value is RequestBasedUsage."
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "IndexArn",
              "IndexName",
              "UpdateTime"
            ],
            members: {
              IndexArn: {},
              IndexName: {},
              UpdateTime: {
                shape: "St"
              }
            }
          },
          endpoint: {
            hostPrefix: "cp.places."
          },
          idempotent: true
        },
        UpdateRouteCalculator: {
          http: {
            method: "PATCH",
            requestUri: "/routes/v0/calculators/{CalculatorName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CalculatorName"
            ],
            members: {
              CalculatorName: {
                location: "uri",
                locationName: "CalculatorName"
              },
              Description: {},
              PricingPlan: {
                deprecated: true,
                deprecatedMessage: "Deprecated. If included, the only allowed value is RequestBasedUsage."
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CalculatorArn",
              "CalculatorName",
              "UpdateTime"
            ],
            members: {
              CalculatorArn: {},
              CalculatorName: {},
              UpdateTime: {
                shape: "St"
              }
            }
          },
          endpoint: {
            hostPrefix: "cp.routes."
          },
          idempotent: true
        },
        UpdateTracker: {
          http: {
            method: "PATCH",
            requestUri: "/tracking/v0/trackers/{TrackerName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "TrackerName"
            ],
            members: {
              Description: {},
              EventBridgeEnabled: {
                type: "boolean"
              },
              KmsKeyEnableGeospatialQueries: {
                type: "boolean"
              },
              PositionFiltering: {},
              PricingPlan: {
                deprecated: true,
                deprecatedMessage: "Deprecated. If included, the only allowed value is RequestBasedUsage."
              },
              PricingPlanDataSource: {
                deprecated: true,
                deprecatedMessage: "Deprecated. No longer allowed."
              },
              TrackerName: {
                location: "uri",
                locationName: "TrackerName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TrackerArn",
              "TrackerName",
              "UpdateTime"
            ],
            members: {
              TrackerArn: {},
              TrackerName: {},
              UpdateTime: {
                shape: "St"
              }
            }
          },
          endpoint: {
            hostPrefix: "cp.tracking."
          },
          idempotent: true
        }
      },
      shapes: {
        Sb: {
          type: "structure",
          members: {
            Code: {},
            Message: {}
          }
        },
        Sl: {
          type: "structure",
          required: [
            "DeviceId",
            "Position",
            "SampleTime"
          ],
          members: {
            Accuracy: {
              shape: "Sm"
            },
            DeviceId: {},
            Position: {
              shape: "So"
            },
            PositionProperties: {
              shape: "Sq"
            },
            SampleTime: {
              shape: "St"
            }
          }
        },
        Sm: {
          type: "structure",
          required: [
            "Horizontal"
          ],
          members: {
            Horizontal: {
              type: "double"
            }
          }
        },
        So: {
          type: "list",
          member: {
            type: "double"
          },
          sensitive: true
        },
        Sq: {
          type: "map",
          key: {},
          value: {},
          sensitive: true
        },
        St: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S11: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Position",
              "ReceivedTime",
              "SampleTime"
            ],
            members: {
              Accuracy: {
                shape: "Sm"
              },
              DeviceId: {},
              Position: {
                shape: "So"
              },
              PositionProperties: {
                shape: "Sq"
              },
              ReceivedTime: {
                shape: "St"
              },
              SampleTime: {
                shape: "St"
              }
            }
          }
        },
        S18: {
          type: "structure",
          members: {
            Circle: {
              type: "structure",
              required: [
                "Center",
                "Radius"
              ],
              members: {
                Center: {
                  shape: "So"
                },
                Radius: {
                  type: "double"
                }
              },
              sensitive: true
            },
            Polygon: {
              shape: "S1a"
            }
          }
        },
        S1a: {
          type: "list",
          member: {
            type: "list",
            member: {
              shape: "So"
            }
          }
        },
        S1n: {
          type: "structure",
          members: {
            AvoidFerries: {
              type: "boolean"
            },
            AvoidTolls: {
              type: "boolean"
            }
          }
        },
        S1q: {
          type: "string",
          sensitive: true
        },
        S1t: {
          type: "structure",
          members: {
            AvoidFerries: {
              type: "boolean"
            },
            AvoidTolls: {
              type: "boolean"
            },
            Dimensions: {
              type: "structure",
              members: {
                Height: {
                  type: "double"
                },
                Length: {
                  type: "double"
                },
                Unit: {},
                Width: {
                  type: "double"
                }
              }
            },
            Weight: {
              type: "structure",
              members: {
                Total: {
                  type: "double"
                },
                Unit: {}
              }
            }
          }
        },
        S2i: {
          type: "list",
          member: {
            type: "double"
          },
          sensitive: true
        },
        S33: {
          type: "map",
          key: {},
          value: {}
        },
        S38: {
          type: "structure",
          required: [
            "AllowActions",
            "AllowResources"
          ],
          members: {
            AllowActions: {
              type: "list",
              member: {}
            },
            AllowReferers: {
              type: "list",
              member: {}
            },
            AllowResources: {
              type: "list",
              member: {}
            }
          }
        },
        S3h: {
          type: "structure",
          required: [
            "Style"
          ],
          members: {
            PoliticalView: {},
            Style: {}
          }
        },
        S3m: {
          type: "structure",
          members: {
            IntendedUse: {}
          }
        },
        S5b: {
          type: "structure",
          required: [
            "Geometry"
          ],
          members: {
            AddressNumber: {},
            Categories: {
              shape: "S5c"
            },
            Country: {},
            Geometry: {
              type: "structure",
              members: {
                Point: {
                  shape: "So"
                }
              }
            },
            Interpolated: {
              type: "boolean"
            },
            Label: {},
            Municipality: {},
            Neighborhood: {},
            PostalCode: {},
            Region: {},
            Street: {},
            SubMunicipality: {},
            SubRegion: {},
            SupplementalCategories: {
              shape: "S5f"
            },
            TimeZone: {
              type: "structure",
              required: [
                "Name"
              ],
              members: {
                Name: {},
                Offset: {
                  type: "integer"
                }
              }
            },
            UnitNumber: {},
            UnitType: {}
          }
        },
        S5c: {
          type: "list",
          member: {}
        },
        S5f: {
          type: "list",
          member: {}
        },
        S76: {
          type: "list",
          member: {}
        },
        S77: {
          type: "list",
          member: {}
        },
        S7f: {
          type: "string",
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/location-2020-11-19.paginators.json
var require_location_2020_11_19_paginators = __commonJS({
  "node_modules/aws-sdk/apis/location-2020-11-19.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetDevicePositionHistory: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "DevicePositions"
        },
        ListDevicePositions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Entries"
        },
        ListGeofenceCollections: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Entries"
        },
        ListGeofences: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Entries"
        },
        ListKeys: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Entries"
        },
        ListMaps: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Entries"
        },
        ListPlaceIndexes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Entries"
        },
        ListRouteCalculators: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Entries"
        },
        ListTrackerConsumers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ConsumerArns"
        },
        ListTrackers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Entries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/location.js
var require_location = __commonJS({
  "node_modules/aws-sdk/clients/location.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["location"] = {};
    AWS2.Location = Service.defineService("location", ["2020-11-19"]);
    Object.defineProperty(apiLoader.services["location"], "2020-11-19", {
      get: function get() {
        var model = require_location_2020_11_19_min();
        model.paginators = require_location_2020_11_19_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Location;
  }
});

// node_modules/aws-sdk/apis/wellarchitected-2020-03-31.min.json
var require_wellarchitected_2020_03_31_min = __commonJS({
  "node_modules/aws-sdk/apis/wellarchitected-2020-03-31.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-03-31",
        endpointPrefix: "wellarchitected",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Well-Architected",
        serviceFullName: "AWS Well-Architected Tool",
        serviceId: "WellArchitected",
        signatureVersion: "v4",
        signingName: "wellarchitected",
        uid: "wellarchitected-2020-03-31"
      },
      operations: {
        AssociateLenses: {
          http: {
            method: "PATCH",
            requestUri: "/workloads/{WorkloadId}/associateLenses"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "LensAliases"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              LensAliases: {
                shape: "S3"
              }
            }
          }
        },
        AssociateProfiles: {
          http: {
            method: "PATCH",
            requestUri: "/workloads/{WorkloadId}/associateProfiles"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "ProfileArns"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              ProfileArns: {
                shape: "S6"
              }
            }
          }
        },
        CreateLensShare: {
          http: {
            requestUri: "/lenses/{LensAlias}/shares"
          },
          input: {
            type: "structure",
            required: [
              "LensAlias",
              "SharedWith",
              "ClientRequestToken"
            ],
            members: {
              LensAlias: {
                location: "uri",
                locationName: "LensAlias"
              },
              SharedWith: {},
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ShareId: {}
            }
          }
        },
        CreateLensVersion: {
          http: {
            requestUri: "/lenses/{LensAlias}/versions"
          },
          input: {
            type: "structure",
            required: [
              "LensAlias",
              "LensVersion",
              "ClientRequestToken"
            ],
            members: {
              LensAlias: {
                location: "uri",
                locationName: "LensAlias"
              },
              LensVersion: {},
              IsMajorVersion: {
                type: "boolean"
              },
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LensArn: {},
              LensVersion: {}
            }
          }
        },
        CreateMilestone: {
          http: {
            requestUri: "/workloads/{WorkloadId}/milestones"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "MilestoneName",
              "ClientRequestToken"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              MilestoneName: {},
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              MilestoneNumber: {
                type: "integer"
              }
            }
          }
        },
        CreateProfile: {
          http: {
            requestUri: "/profiles"
          },
          input: {
            type: "structure",
            required: [
              "ProfileName",
              "ProfileDescription",
              "ProfileQuestions",
              "ClientRequestToken"
            ],
            members: {
              ProfileName: {},
              ProfileDescription: {},
              ProfileQuestions: {
                shape: "Sp"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProfileArn: {},
              ProfileVersion: {}
            }
          }
        },
        CreateProfileShare: {
          http: {
            requestUri: "/profiles/{ProfileArn}/shares"
          },
          input: {
            type: "structure",
            required: [
              "ProfileArn",
              "SharedWith",
              "ClientRequestToken"
            ],
            members: {
              ProfileArn: {
                location: "uri",
                locationName: "ProfileArn"
              },
              SharedWith: {},
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ShareId: {},
              ProfileArn: {}
            }
          }
        },
        CreateReviewTemplate: {
          http: {
            requestUri: "/reviewTemplates"
          },
          input: {
            type: "structure",
            required: [
              "TemplateName",
              "Description",
              "Lenses",
              "ClientRequestToken"
            ],
            members: {
              TemplateName: {},
              Description: {},
              Lenses: {
                shape: "S14"
              },
              Notes: {},
              Tags: {
                shape: "Su"
              },
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplateArn: {}
            }
          }
        },
        CreateTemplateShare: {
          http: {
            requestUri: "/templates/shares/{TemplateArn}"
          },
          input: {
            type: "structure",
            required: [
              "TemplateArn",
              "SharedWith",
              "ClientRequestToken"
            ],
            members: {
              TemplateArn: {
                location: "uri",
                locationName: "TemplateArn"
              },
              SharedWith: {},
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplateArn: {},
              ShareId: {}
            }
          }
        },
        CreateWorkload: {
          http: {
            requestUri: "/workloads"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadName",
              "Description",
              "Environment",
              "Lenses",
              "ClientRequestToken"
            ],
            members: {
              WorkloadName: {},
              Description: {},
              Environment: {},
              AccountIds: {
                shape: "S1e"
              },
              AwsRegions: {
                shape: "S1g"
              },
              NonAwsRegions: {
                shape: "S1i"
              },
              PillarPriorities: {
                shape: "S1k"
              },
              ArchitecturalDesign: {},
              ReviewOwner: {},
              IndustryType: {},
              Industry: {},
              Lenses: {
                shape: "S1q"
              },
              Notes: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Su"
              },
              DiscoveryConfig: {
                shape: "S1r"
              },
              Applications: {
                shape: "S1v"
              },
              ProfileArns: {
                type: "list",
                member: {}
              },
              ReviewTemplateArns: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              WorkloadArn: {}
            }
          }
        },
        CreateWorkloadShare: {
          http: {
            requestUri: "/workloads/{WorkloadId}/shares"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "SharedWith",
              "PermissionType",
              "ClientRequestToken"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              SharedWith: {},
              PermissionType: {},
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              ShareId: {}
            }
          }
        },
        DeleteLens: {
          http: {
            method: "DELETE",
            requestUri: "/lenses/{LensAlias}"
          },
          input: {
            type: "structure",
            required: [
              "LensAlias",
              "ClientRequestToken",
              "LensStatus"
            ],
            members: {
              LensAlias: {
                location: "uri",
                locationName: "LensAlias"
              },
              ClientRequestToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "ClientRequestToken"
              },
              LensStatus: {
                location: "querystring",
                locationName: "LensStatus"
              }
            }
          }
        },
        DeleteLensShare: {
          http: {
            method: "DELETE",
            requestUri: "/lenses/{LensAlias}/shares/{ShareId}"
          },
          input: {
            type: "structure",
            required: [
              "ShareId",
              "LensAlias",
              "ClientRequestToken"
            ],
            members: {
              ShareId: {
                location: "uri",
                locationName: "ShareId"
              },
              LensAlias: {
                location: "uri",
                locationName: "LensAlias"
              },
              ClientRequestToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "ClientRequestToken"
              }
            }
          }
        },
        DeleteProfile: {
          http: {
            method: "DELETE",
            requestUri: "/profiles/{ProfileArn}"
          },
          input: {
            type: "structure",
            required: [
              "ProfileArn",
              "ClientRequestToken"
            ],
            members: {
              ProfileArn: {
                location: "uri",
                locationName: "ProfileArn"
              },
              ClientRequestToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "ClientRequestToken"
              }
            }
          }
        },
        DeleteProfileShare: {
          http: {
            method: "DELETE",
            requestUri: "/profiles/{ProfileArn}/shares/{ShareId}"
          },
          input: {
            type: "structure",
            required: [
              "ShareId",
              "ProfileArn",
              "ClientRequestToken"
            ],
            members: {
              ShareId: {
                location: "uri",
                locationName: "ShareId"
              },
              ProfileArn: {
                location: "uri",
                locationName: "ProfileArn"
              },
              ClientRequestToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "ClientRequestToken"
              }
            }
          }
        },
        DeleteReviewTemplate: {
          http: {
            method: "DELETE",
            requestUri: "/reviewTemplates/{TemplateArn}"
          },
          input: {
            type: "structure",
            required: [
              "TemplateArn",
              "ClientRequestToken"
            ],
            members: {
              TemplateArn: {
                location: "uri",
                locationName: "TemplateArn"
              },
              ClientRequestToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "ClientRequestToken"
              }
            }
          }
        },
        DeleteTemplateShare: {
          http: {
            method: "DELETE",
            requestUri: "/templates/shares/{TemplateArn}/{ShareId}"
          },
          input: {
            type: "structure",
            required: [
              "ShareId",
              "TemplateArn",
              "ClientRequestToken"
            ],
            members: {
              ShareId: {
                location: "uri",
                locationName: "ShareId"
              },
              TemplateArn: {
                location: "uri",
                locationName: "TemplateArn"
              },
              ClientRequestToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "ClientRequestToken"
              }
            }
          }
        },
        DeleteWorkload: {
          http: {
            method: "DELETE",
            requestUri: "/workloads/{WorkloadId}"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "ClientRequestToken"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              ClientRequestToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "ClientRequestToken"
              }
            }
          }
        },
        DeleteWorkloadShare: {
          http: {
            method: "DELETE",
            requestUri: "/workloads/{WorkloadId}/shares/{ShareId}"
          },
          input: {
            type: "structure",
            required: [
              "ShareId",
              "WorkloadId",
              "ClientRequestToken"
            ],
            members: {
              ShareId: {
                location: "uri",
                locationName: "ShareId"
              },
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              ClientRequestToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "ClientRequestToken"
              }
            }
          }
        },
        DisassociateLenses: {
          http: {
            method: "PATCH",
            requestUri: "/workloads/{WorkloadId}/disassociateLenses"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "LensAliases"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              LensAliases: {
                shape: "S3"
              }
            }
          }
        },
        DisassociateProfiles: {
          http: {
            method: "PATCH",
            requestUri: "/workloads/{WorkloadId}/disassociateProfiles"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "ProfileArns"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              ProfileArns: {
                shape: "S6"
              }
            }
          }
        },
        ExportLens: {
          http: {
            method: "GET",
            requestUri: "/lenses/{LensAlias}/export"
          },
          input: {
            type: "structure",
            required: [
              "LensAlias"
            ],
            members: {
              LensAlias: {
                location: "uri",
                locationName: "LensAlias"
              },
              LensVersion: {
                location: "querystring",
                locationName: "LensVersion"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LensJSON: {}
            }
          }
        },
        GetAnswer: {
          http: {
            method: "GET",
            requestUri: "/workloads/{WorkloadId}/lensReviews/{LensAlias}/answers/{QuestionId}"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "LensAlias",
              "QuestionId"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              LensAlias: {
                location: "uri",
                locationName: "LensAlias"
              },
              QuestionId: {
                location: "uri",
                locationName: "QuestionId"
              },
              MilestoneNumber: {
                location: "querystring",
                locationName: "MilestoneNumber",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              MilestoneNumber: {
                type: "integer"
              },
              LensAlias: {},
              LensArn: {},
              Answer: {
                shape: "S2k"
              }
            }
          }
        },
        GetConsolidatedReport: {
          http: {
            method: "GET",
            requestUri: "/consolidatedReport"
          },
          input: {
            type: "structure",
            required: [
              "Format"
            ],
            members: {
              Format: {
                location: "querystring",
                locationName: "Format"
              },
              IncludeSharedResources: {
                location: "querystring",
                locationName: "IncludeSharedResources",
                type: "boolean"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Metrics: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MetricType: {},
                    RiskCounts: {
                      shape: "S3j"
                    },
                    WorkloadId: {},
                    WorkloadName: {},
                    WorkloadArn: {},
                    UpdatedAt: {
                      type: "timestamp"
                    },
                    Lenses: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          LensArn: {},
                          Pillars: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                PillarId: {},
                                RiskCounts: {
                                  shape: "S3j"
                                },
                                Questions: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      QuestionId: {},
                                      Risk: {},
                                      BestPractices: {
                                        type: "list",
                                        member: {
                                          type: "structure",
                                          members: {
                                            ChoiceId: {},
                                            ChoiceTitle: {}
                                          }
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          },
                          RiskCounts: {
                            shape: "S3j"
                          }
                        }
                      }
                    },
                    LensesAppliedCount: {
                      type: "integer"
                    }
                  }
                }
              },
              NextToken: {},
              Base64String: {}
            }
          }
        },
        GetLens: {
          http: {
            method: "GET",
            requestUri: "/lenses/{LensAlias}"
          },
          input: {
            type: "structure",
            required: [
              "LensAlias"
            ],
            members: {
              LensAlias: {
                location: "uri",
                locationName: "LensAlias"
              },
              LensVersion: {
                location: "querystring",
                locationName: "LensVersion"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Lens: {
                type: "structure",
                members: {
                  LensArn: {},
                  LensVersion: {},
                  Name: {},
                  Description: {},
                  Owner: {},
                  ShareInvitationId: {},
                  Tags: {
                    shape: "Su"
                  }
                }
              }
            }
          }
        },
        GetLensReview: {
          http: {
            method: "GET",
            requestUri: "/workloads/{WorkloadId}/lensReviews/{LensAlias}"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "LensAlias"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              LensAlias: {
                location: "uri",
                locationName: "LensAlias"
              },
              MilestoneNumber: {
                location: "querystring",
                locationName: "MilestoneNumber",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              MilestoneNumber: {
                type: "integer"
              },
              LensReview: {
                shape: "S45"
              }
            }
          }
        },
        GetLensReviewReport: {
          http: {
            method: "GET",
            requestUri: "/workloads/{WorkloadId}/lensReviews/{LensAlias}/report"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "LensAlias"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              LensAlias: {
                location: "uri",
                locationName: "LensAlias"
              },
              MilestoneNumber: {
                location: "querystring",
                locationName: "MilestoneNumber",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              MilestoneNumber: {
                type: "integer"
              },
              LensReviewReport: {
                type: "structure",
                members: {
                  LensAlias: {},
                  LensArn: {},
                  Base64String: {}
                }
              }
            }
          }
        },
        GetLensVersionDifference: {
          http: {
            method: "GET",
            requestUri: "/lenses/{LensAlias}/versionDifference"
          },
          input: {
            type: "structure",
            required: [
              "LensAlias"
            ],
            members: {
              LensAlias: {
                location: "uri",
                locationName: "LensAlias"
              },
              BaseLensVersion: {
                location: "querystring",
                locationName: "BaseLensVersion"
              },
              TargetLensVersion: {
                location: "querystring",
                locationName: "TargetLensVersion"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LensAlias: {},
              LensArn: {},
              BaseLensVersion: {},
              TargetLensVersion: {},
              LatestLensVersion: {},
              VersionDifferences: {
                type: "structure",
                members: {
                  PillarDifferences: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        PillarId: {},
                        PillarName: {},
                        DifferenceStatus: {},
                        QuestionDifferences: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              QuestionId: {},
                              QuestionTitle: {},
                              DifferenceStatus: {}
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetMilestone: {
          http: {
            method: "GET",
            requestUri: "/workloads/{WorkloadId}/milestones/{MilestoneNumber}"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "MilestoneNumber"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              MilestoneNumber: {
                location: "uri",
                locationName: "MilestoneNumber",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              Milestone: {
                type: "structure",
                members: {
                  MilestoneNumber: {
                    type: "integer"
                  },
                  MilestoneName: {},
                  RecordedAt: {
                    type: "timestamp"
                  },
                  Workload: {
                    shape: "S4q"
                  }
                }
              }
            }
          }
        },
        GetProfile: {
          http: {
            method: "GET",
            requestUri: "/profiles/{ProfileArn}"
          },
          input: {
            type: "structure",
            required: [
              "ProfileArn"
            ],
            members: {
              ProfileArn: {
                location: "uri",
                locationName: "ProfileArn"
              },
              ProfileVersion: {
                location: "querystring",
                locationName: "ProfileVersion"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Profile: {
                shape: "S4v"
              }
            }
          }
        },
        GetProfileTemplate: {
          http: {
            method: "GET",
            requestUri: "/profileTemplate"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              ProfileTemplate: {
                type: "structure",
                members: {
                  TemplateName: {},
                  TemplateQuestions: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        QuestionId: {},
                        QuestionTitle: {},
                        QuestionDescription: {},
                        QuestionChoices: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              ChoiceId: {},
                              ChoiceTitle: {},
                              ChoiceDescription: {}
                            }
                          }
                        },
                        MinSelectedChoices: {
                          type: "integer"
                        },
                        MaxSelectedChoices: {
                          type: "integer"
                        }
                      }
                    }
                  },
                  CreatedAt: {
                    type: "timestamp"
                  },
                  UpdatedAt: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        GetReviewTemplate: {
          http: {
            method: "GET",
            requestUri: "/reviewTemplates/{TemplateArn}"
          },
          input: {
            type: "structure",
            required: [
              "TemplateArn"
            ],
            members: {
              TemplateArn: {
                location: "uri",
                locationName: "TemplateArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReviewTemplate: {
                shape: "S5c"
              }
            }
          }
        },
        GetReviewTemplateAnswer: {
          http: {
            method: "GET",
            requestUri: "/reviewTemplates/{TemplateArn}/lensReviews/{LensAlias}/answers/{QuestionId}"
          },
          input: {
            type: "structure",
            required: [
              "TemplateArn",
              "LensAlias",
              "QuestionId"
            ],
            members: {
              TemplateArn: {
                location: "uri",
                locationName: "TemplateArn"
              },
              LensAlias: {
                location: "uri",
                locationName: "LensAlias"
              },
              QuestionId: {
                location: "uri",
                locationName: "QuestionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplateArn: {},
              LensAlias: {},
              Answer: {
                shape: "S5i"
              }
            }
          }
        },
        GetReviewTemplateLensReview: {
          http: {
            method: "GET",
            requestUri: "/reviewTemplates/{TemplateArn}/lensReviews/{LensAlias}"
          },
          input: {
            type: "structure",
            required: [
              "TemplateArn",
              "LensAlias"
            ],
            members: {
              TemplateArn: {
                location: "uri",
                locationName: "TemplateArn"
              },
              LensAlias: {
                location: "uri",
                locationName: "LensAlias"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplateArn: {},
              LensReview: {
                shape: "S5m"
              }
            }
          }
        },
        GetWorkload: {
          http: {
            method: "GET",
            requestUri: "/workloads/{WorkloadId}"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Workload: {
                shape: "S4q"
              }
            }
          }
        },
        ImportLens: {
          http: {
            method: "PUT",
            requestUri: "/importLens"
          },
          input: {
            type: "structure",
            required: [
              "JSONString",
              "ClientRequestToken"
            ],
            members: {
              LensAlias: {},
              JSONString: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LensArn: {},
              Status: {}
            }
          }
        },
        ListAnswers: {
          http: {
            method: "GET",
            requestUri: "/workloads/{WorkloadId}/lensReviews/{LensAlias}/answers"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "LensAlias"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              LensAlias: {
                location: "uri",
                locationName: "LensAlias"
              },
              PillarId: {
                location: "querystring",
                locationName: "PillarId"
              },
              MilestoneNumber: {
                location: "querystring",
                locationName: "MilestoneNumber",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              QuestionPriority: {
                location: "querystring",
                locationName: "QuestionPriority"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              MilestoneNumber: {
                type: "integer"
              },
              LensAlias: {},
              LensArn: {},
              AnswerSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    QuestionId: {},
                    PillarId: {},
                    QuestionTitle: {},
                    Choices: {
                      shape: "S2q"
                    },
                    SelectedChoices: {
                      shape: "S31"
                    },
                    ChoiceAnswerSummaries: {
                      shape: "S60"
                    },
                    IsApplicable: {
                      type: "boolean"
                    },
                    Risk: {},
                    Reason: {},
                    QuestionType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListCheckDetails: {
          http: {
            requestUri: "/workloads/{WorkloadId}/checks"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "LensArn",
              "PillarId",
              "QuestionId",
              "ChoiceId"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              LensArn: {},
              PillarId: {},
              QuestionId: {},
              ChoiceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CheckDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Name: {},
                    Description: {},
                    Provider: {},
                    LensArn: {},
                    PillarId: {},
                    QuestionId: {},
                    ChoiceId: {},
                    Status: {},
                    AccountId: {},
                    FlaggedResources: {
                      type: "integer"
                    },
                    Reason: {},
                    UpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListCheckSummaries: {
          http: {
            requestUri: "/workloads/{WorkloadId}/checkSummaries"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "LensArn",
              "PillarId",
              "QuestionId",
              "ChoiceId"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              LensArn: {},
              PillarId: {},
              QuestionId: {},
              ChoiceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CheckSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Name: {},
                    Provider: {},
                    Description: {},
                    UpdatedAt: {
                      type: "timestamp"
                    },
                    LensArn: {},
                    PillarId: {},
                    QuestionId: {},
                    ChoiceId: {},
                    Status: {},
                    AccountSummary: {
                      type: "map",
                      key: {},
                      value: {
                        type: "integer"
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListLensReviewImprovements: {
          http: {
            method: "GET",
            requestUri: "/workloads/{WorkloadId}/lensReviews/{LensAlias}/improvements"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "LensAlias"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              LensAlias: {
                location: "uri",
                locationName: "LensAlias"
              },
              PillarId: {
                location: "querystring",
                locationName: "PillarId"
              },
              MilestoneNumber: {
                location: "querystring",
                locationName: "MilestoneNumber",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              QuestionPriority: {
                location: "querystring",
                locationName: "QuestionPriority"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              MilestoneNumber: {
                type: "integer"
              },
              LensAlias: {},
              LensArn: {},
              ImprovementSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    QuestionId: {},
                    PillarId: {},
                    QuestionTitle: {},
                    Risk: {},
                    ImprovementPlanUrl: {},
                    ImprovementPlans: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ChoiceId: {},
                          DisplayText: {},
                          ImprovementPlanUrl: {}
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListLensReviews: {
          http: {
            method: "GET",
            requestUri: "/workloads/{WorkloadId}/lensReviews"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              MilestoneNumber: {
                location: "querystring",
                locationName: "MilestoneNumber",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              MilestoneNumber: {
                type: "integer"
              },
              LensReviewSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LensAlias: {},
                    LensArn: {},
                    LensVersion: {},
                    LensName: {},
                    LensStatus: {},
                    UpdatedAt: {
                      type: "timestamp"
                    },
                    RiskCounts: {
                      shape: "S3j"
                    },
                    Profiles: {
                      shape: "S4a"
                    },
                    PrioritizedRiskCounts: {
                      shape: "S3j"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListLensShares: {
          http: {
            method: "GET",
            requestUri: "/lenses/{LensAlias}/shares"
          },
          input: {
            type: "structure",
            required: [
              "LensAlias"
            ],
            members: {
              LensAlias: {
                location: "uri",
                locationName: "LensAlias"
              },
              SharedWithPrefix: {
                location: "querystring",
                locationName: "SharedWithPrefix"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              Status: {
                location: "querystring",
                locationName: "Status"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LensShareSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ShareId: {},
                    SharedWith: {},
                    Status: {},
                    StatusMessage: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListLenses: {
          http: {
            method: "GET",
            requestUri: "/lenses"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              LensType: {
                location: "querystring",
                locationName: "LensType"
              },
              LensStatus: {
                location: "querystring",
                locationName: "LensStatus"
              },
              LensName: {
                location: "querystring",
                locationName: "LensName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LensSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LensArn: {},
                    LensAlias: {},
                    LensName: {},
                    LensType: {},
                    Description: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    UpdatedAt: {
                      type: "timestamp"
                    },
                    LensVersion: {},
                    Owner: {},
                    LensStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListMilestones: {
          http: {
            requestUri: "/workloads/{WorkloadId}/milestonesSummaries"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              MilestoneSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MilestoneNumber: {
                      type: "integer"
                    },
                    MilestoneName: {},
                    RecordedAt: {
                      type: "timestamp"
                    },
                    WorkloadSummary: {
                      shape: "S7d"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListNotifications: {
          http: {
            requestUri: "/notifications"
          },
          input: {
            type: "structure",
            members: {
              WorkloadId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NotificationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    LensUpgradeSummary: {
                      type: "structure",
                      members: {
                        WorkloadId: {},
                        WorkloadName: {},
                        LensAlias: {},
                        LensArn: {},
                        CurrentLensVersion: {},
                        LatestLensVersion: {},
                        ResourceArn: {},
                        ResourceName: {}
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListProfileNotifications: {
          http: {
            method: "GET",
            requestUri: "/profileNotifications/"
          },
          input: {
            type: "structure",
            members: {
              WorkloadId: {
                location: "querystring",
                locationName: "WorkloadId"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NotificationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CurrentProfileVersion: {},
                    LatestProfileVersion: {},
                    Type: {},
                    ProfileArn: {},
                    ProfileName: {},
                    WorkloadId: {},
                    WorkloadName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListProfileShares: {
          http: {
            method: "GET",
            requestUri: "/profiles/{ProfileArn}/shares"
          },
          input: {
            type: "structure",
            required: [
              "ProfileArn"
            ],
            members: {
              ProfileArn: {
                location: "uri",
                locationName: "ProfileArn"
              },
              SharedWithPrefix: {
                location: "querystring",
                locationName: "SharedWithPrefix"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              Status: {
                location: "querystring",
                locationName: "Status"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProfileShareSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ShareId: {},
                    SharedWith: {},
                    Status: {},
                    StatusMessage: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListProfiles: {
          http: {
            method: "GET",
            requestUri: "/profileSummaries"
          },
          input: {
            type: "structure",
            members: {
              ProfileNamePrefix: {
                location: "querystring",
                locationName: "ProfileNamePrefix"
              },
              ProfileOwnerType: {
                location: "querystring",
                locationName: "ProfileOwnerType"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProfileSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ProfileArn: {},
                    ProfileVersion: {},
                    ProfileName: {},
                    ProfileDescription: {},
                    Owner: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    UpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListReviewTemplateAnswers: {
          http: {
            method: "GET",
            requestUri: "/reviewTemplates/{TemplateArn}/lensReviews/{LensAlias}/answers"
          },
          input: {
            type: "structure",
            required: [
              "TemplateArn",
              "LensAlias"
            ],
            members: {
              TemplateArn: {
                location: "uri",
                locationName: "TemplateArn"
              },
              LensAlias: {
                location: "uri",
                locationName: "LensAlias"
              },
              PillarId: {
                location: "querystring",
                locationName: "PillarId"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplateArn: {},
              LensAlias: {},
              AnswerSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    QuestionId: {},
                    PillarId: {},
                    QuestionTitle: {},
                    Choices: {
                      shape: "S2q"
                    },
                    SelectedChoices: {
                      shape: "S31"
                    },
                    ChoiceAnswerSummaries: {
                      shape: "S60"
                    },
                    IsApplicable: {
                      type: "boolean"
                    },
                    AnswerStatus: {},
                    Reason: {},
                    QuestionType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListReviewTemplates: {
          http: {
            method: "GET",
            requestUri: "/reviewTemplates"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReviewTemplates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Description: {},
                    Lenses: {
                      shape: "S14"
                    },
                    Owner: {},
                    UpdatedAt: {
                      type: "timestamp"
                    },
                    TemplateArn: {},
                    TemplateName: {},
                    UpdateStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListShareInvitations: {
          http: {
            method: "GET",
            requestUri: "/shareInvitations"
          },
          input: {
            type: "structure",
            members: {
              WorkloadNamePrefix: {
                location: "querystring",
                locationName: "WorkloadNamePrefix"
              },
              LensNamePrefix: {
                location: "querystring",
                locationName: "LensNamePrefix"
              },
              ShareResourceType: {
                location: "querystring",
                locationName: "ShareResourceType"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              ProfileNamePrefix: {
                location: "querystring",
                locationName: "ProfileNamePrefix"
              },
              TemplateNamePrefix: {
                location: "querystring",
                locationName: "TemplateNamePrefix"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ShareInvitationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ShareInvitationId: {},
                    SharedBy: {},
                    SharedWith: {},
                    PermissionType: {},
                    ShareResourceType: {},
                    WorkloadName: {},
                    WorkloadId: {},
                    LensName: {},
                    LensArn: {},
                    ProfileName: {},
                    ProfileArn: {},
                    TemplateName: {},
                    TemplateArn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{WorkloadArn}"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadArn"
            ],
            members: {
              WorkloadArn: {
                location: "uri",
                locationName: "WorkloadArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Su"
              }
            }
          }
        },
        ListTemplateShares: {
          http: {
            method: "GET",
            requestUri: "/templates/shares/{TemplateArn}"
          },
          input: {
            type: "structure",
            required: [
              "TemplateArn"
            ],
            members: {
              TemplateArn: {
                location: "uri",
                locationName: "TemplateArn"
              },
              SharedWithPrefix: {
                location: "querystring",
                locationName: "SharedWithPrefix"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              Status: {
                location: "querystring",
                locationName: "Status"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplateArn: {},
              TemplateShareSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ShareId: {},
                    SharedWith: {},
                    Status: {},
                    StatusMessage: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListWorkloadShares: {
          http: {
            method: "GET",
            requestUri: "/workloads/{WorkloadId}/shares"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              SharedWithPrefix: {
                location: "querystring",
                locationName: "SharedWithPrefix"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              Status: {
                location: "querystring",
                locationName: "Status"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              WorkloadShareSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ShareId: {},
                    SharedWith: {},
                    PermissionType: {},
                    Status: {},
                    StatusMessage: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListWorkloads: {
          http: {
            requestUri: "/workloadsSummaries"
          },
          input: {
            type: "structure",
            members: {
              WorkloadNamePrefix: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadSummaries: {
                type: "list",
                member: {
                  shape: "S7d"
                }
              },
              NextToken: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{WorkloadArn}"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadArn",
              "Tags"
            ],
            members: {
              WorkloadArn: {
                location: "uri",
                locationName: "WorkloadArn"
              },
              Tags: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{WorkloadArn}"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadArn",
              "TagKeys"
            ],
            members: {
              WorkloadArn: {
                location: "uri",
                locationName: "WorkloadArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAnswer: {
          http: {
            method: "PATCH",
            requestUri: "/workloads/{WorkloadId}/lensReviews/{LensAlias}/answers/{QuestionId}"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "LensAlias",
              "QuestionId"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              LensAlias: {
                location: "uri",
                locationName: "LensAlias"
              },
              QuestionId: {
                location: "uri",
                locationName: "QuestionId"
              },
              SelectedChoices: {
                shape: "S31"
              },
              ChoiceUpdates: {
                shape: "S95"
              },
              Notes: {},
              IsApplicable: {
                type: "boolean"
              },
              Reason: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              LensAlias: {},
              LensArn: {},
              Answer: {
                shape: "S2k"
              }
            }
          }
        },
        UpdateGlobalSettings: {
          http: {
            method: "PATCH",
            requestUri: "/global-settings"
          },
          input: {
            type: "structure",
            members: {
              OrganizationSharingStatus: {},
              DiscoveryIntegrationStatus: {}
            }
          }
        },
        UpdateLensReview: {
          http: {
            method: "PATCH",
            requestUri: "/workloads/{WorkloadId}/lensReviews/{LensAlias}"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "LensAlias"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              LensAlias: {
                location: "uri",
                locationName: "LensAlias"
              },
              LensNotes: {},
              PillarNotes: {
                shape: "S9c"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              LensReview: {
                shape: "S45"
              }
            }
          }
        },
        UpdateProfile: {
          http: {
            method: "PATCH",
            requestUri: "/profiles/{ProfileArn}"
          },
          input: {
            type: "structure",
            required: [
              "ProfileArn"
            ],
            members: {
              ProfileArn: {
                location: "uri",
                locationName: "ProfileArn"
              },
              ProfileDescription: {},
              ProfileQuestions: {
                shape: "Sp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Profile: {
                shape: "S4v"
              }
            }
          }
        },
        UpdateReviewTemplate: {
          http: {
            method: "PATCH",
            requestUri: "/reviewTemplates/{TemplateArn}"
          },
          input: {
            type: "structure",
            required: [
              "TemplateArn"
            ],
            members: {
              TemplateArn: {
                location: "uri",
                locationName: "TemplateArn"
              },
              TemplateName: {},
              Description: {},
              Notes: {},
              LensesToAssociate: {
                shape: "S9h"
              },
              LensesToDisassociate: {
                shape: "S9h"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReviewTemplate: {
                shape: "S5c"
              }
            }
          }
        },
        UpdateReviewTemplateAnswer: {
          http: {
            method: "PATCH",
            requestUri: "/reviewTemplates/{TemplateArn}/lensReviews/{LensAlias}/answers/{QuestionId}"
          },
          input: {
            type: "structure",
            required: [
              "TemplateArn",
              "LensAlias",
              "QuestionId"
            ],
            members: {
              TemplateArn: {
                location: "uri",
                locationName: "TemplateArn"
              },
              LensAlias: {
                location: "uri",
                locationName: "LensAlias"
              },
              QuestionId: {
                location: "uri",
                locationName: "QuestionId"
              },
              SelectedChoices: {
                shape: "S31"
              },
              ChoiceUpdates: {
                shape: "S95"
              },
              Notes: {},
              IsApplicable: {
                type: "boolean"
              },
              Reason: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TemplateArn: {},
              LensAlias: {},
              Answer: {
                shape: "S5i"
              }
            }
          }
        },
        UpdateReviewTemplateLensReview: {
          http: {
            method: "PATCH",
            requestUri: "/reviewTemplates/{TemplateArn}/lensReviews/{LensAlias}"
          },
          input: {
            type: "structure",
            required: [
              "TemplateArn",
              "LensAlias"
            ],
            members: {
              TemplateArn: {
                location: "uri",
                locationName: "TemplateArn"
              },
              LensAlias: {
                location: "uri",
                locationName: "LensAlias"
              },
              LensNotes: {},
              PillarNotes: {
                shape: "S9c"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplateArn: {},
              LensReview: {
                shape: "S5m"
              }
            }
          }
        },
        UpdateShareInvitation: {
          http: {
            method: "PATCH",
            requestUri: "/shareInvitations/{ShareInvitationId}"
          },
          input: {
            type: "structure",
            required: [
              "ShareInvitationId",
              "ShareInvitationAction"
            ],
            members: {
              ShareInvitationId: {
                location: "uri",
                locationName: "ShareInvitationId"
              },
              ShareInvitationAction: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ShareInvitation: {
                type: "structure",
                members: {
                  ShareInvitationId: {},
                  ShareResourceType: {},
                  WorkloadId: {},
                  LensAlias: {},
                  LensArn: {},
                  ProfileArn: {},
                  TemplateArn: {}
                }
              }
            }
          }
        },
        UpdateWorkload: {
          http: {
            method: "PATCH",
            requestUri: "/workloads/{WorkloadId}"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              WorkloadName: {},
              Description: {},
              Environment: {},
              AccountIds: {
                shape: "S1e"
              },
              AwsRegions: {
                shape: "S1g"
              },
              NonAwsRegions: {
                shape: "S1i"
              },
              PillarPriorities: {
                shape: "S1k"
              },
              ArchitecturalDesign: {},
              ReviewOwner: {},
              IsReviewOwnerUpdateAcknowledged: {
                type: "boolean"
              },
              IndustryType: {},
              Industry: {},
              Notes: {},
              ImprovementStatus: {},
              DiscoveryConfig: {
                shape: "S1r"
              },
              Applications: {
                shape: "S1v"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Workload: {
                shape: "S4q"
              }
            }
          }
        },
        UpdateWorkloadShare: {
          http: {
            method: "PATCH",
            requestUri: "/workloads/{WorkloadId}/shares/{ShareId}"
          },
          input: {
            type: "structure",
            required: [
              "ShareId",
              "WorkloadId",
              "PermissionType"
            ],
            members: {
              ShareId: {
                location: "uri",
                locationName: "ShareId"
              },
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              PermissionType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              WorkloadShare: {
                type: "structure",
                members: {
                  ShareId: {},
                  SharedBy: {},
                  SharedWith: {},
                  PermissionType: {},
                  Status: {},
                  WorkloadName: {},
                  WorkloadId: {}
                }
              }
            }
          }
        },
        UpgradeLensReview: {
          http: {
            method: "PUT",
            requestUri: "/workloads/{WorkloadId}/lensReviews/{LensAlias}/upgrade"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "LensAlias",
              "MilestoneName"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              LensAlias: {
                location: "uri",
                locationName: "LensAlias"
              },
              MilestoneName: {},
              ClientRequestToken: {}
            }
          }
        },
        UpgradeProfileVersion: {
          http: {
            method: "PUT",
            requestUri: "/workloads/{WorkloadId}/profiles/{ProfileArn}/upgrade"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "ProfileArn"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              ProfileArn: {
                location: "uri",
                locationName: "ProfileArn"
              },
              MilestoneName: {},
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          }
        },
        UpgradeReviewTemplateLensReview: {
          http: {
            method: "PUT",
            requestUri: "/reviewTemplates/{TemplateArn}/lensReviews/{LensAlias}/upgrade"
          },
          input: {
            type: "structure",
            required: [
              "TemplateArn",
              "LensAlias"
            ],
            members: {
              TemplateArn: {
                location: "uri",
                locationName: "TemplateArn"
              },
              LensAlias: {
                location: "uri",
                locationName: "LensAlias"
              },
              ClientRequestToken: {}
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {}
        },
        S6: {
          type: "list",
          member: {}
        },
        Sp: {
          type: "list",
          member: {
            type: "structure",
            members: {
              QuestionId: {},
              SelectedChoiceIds: {
                type: "list",
                member: {}
              }
            }
          }
        },
        Su: {
          type: "map",
          key: {},
          value: {}
        },
        S14: {
          type: "list",
          member: {}
        },
        S1e: {
          type: "list",
          member: {}
        },
        S1g: {
          type: "list",
          member: {}
        },
        S1i: {
          type: "list",
          member: {}
        },
        S1k: {
          type: "list",
          member: {}
        },
        S1q: {
          type: "list",
          member: {}
        },
        S1r: {
          type: "structure",
          members: {
            TrustedAdvisorIntegrationStatus: {},
            WorkloadResourceDefinition: {
              type: "list",
              member: {}
            }
          }
        },
        S1v: {
          type: "list",
          member: {}
        },
        S2k: {
          type: "structure",
          members: {
            QuestionId: {},
            PillarId: {},
            QuestionTitle: {},
            QuestionDescription: {},
            ImprovementPlanUrl: {},
            HelpfulResourceUrl: {},
            HelpfulResourceDisplayText: {},
            Choices: {
              shape: "S2q"
            },
            SelectedChoices: {
              shape: "S31"
            },
            ChoiceAnswers: {
              shape: "S32"
            },
            IsApplicable: {
              type: "boolean"
            },
            Risk: {},
            Notes: {},
            Reason: {}
          }
        },
        S2q: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ChoiceId: {},
              Title: {},
              Description: {},
              HelpfulResource: {
                shape: "S2u"
              },
              ImprovementPlan: {
                shape: "S2u"
              },
              AdditionalResources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    Content: {
                      type: "list",
                      member: {
                        shape: "S2u"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S2u: {
          type: "structure",
          members: {
            DisplayText: {},
            Url: {}
          }
        },
        S31: {
          type: "list",
          member: {}
        },
        S32: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ChoiceId: {},
              Status: {},
              Reason: {},
              Notes: {}
            }
          }
        },
        S3j: {
          type: "map",
          key: {},
          value: {
            type: "integer"
          }
        },
        S45: {
          type: "structure",
          members: {
            LensAlias: {},
            LensArn: {},
            LensVersion: {},
            LensName: {},
            LensStatus: {},
            PillarReviewSummaries: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  PillarId: {},
                  PillarName: {},
                  Notes: {},
                  RiskCounts: {
                    shape: "S3j"
                  },
                  PrioritizedRiskCounts: {
                    shape: "S3j"
                  }
                }
              }
            },
            UpdatedAt: {
              type: "timestamp"
            },
            Notes: {},
            RiskCounts: {
              shape: "S3j"
            },
            NextToken: {},
            Profiles: {
              shape: "S4a"
            },
            PrioritizedRiskCounts: {
              shape: "S3j"
            }
          }
        },
        S4a: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ProfileArn: {},
              ProfileVersion: {}
            }
          }
        },
        S4q: {
          type: "structure",
          members: {
            WorkloadId: {},
            WorkloadArn: {},
            WorkloadName: {},
            Description: {},
            Environment: {},
            UpdatedAt: {
              type: "timestamp"
            },
            AccountIds: {
              shape: "S1e"
            },
            AwsRegions: {
              shape: "S1g"
            },
            NonAwsRegions: {
              shape: "S1i"
            },
            ArchitecturalDesign: {},
            ReviewOwner: {},
            ReviewRestrictionDate: {
              type: "timestamp"
            },
            IsReviewOwnerUpdateAcknowledged: {
              type: "boolean"
            },
            IndustryType: {},
            Industry: {},
            Notes: {},
            ImprovementStatus: {},
            RiskCounts: {
              shape: "S3j"
            },
            PillarPriorities: {
              shape: "S1k"
            },
            Lenses: {
              shape: "S1q"
            },
            Owner: {},
            ShareInvitationId: {},
            Tags: {
              shape: "Su"
            },
            DiscoveryConfig: {
              shape: "S1r"
            },
            Applications: {
              shape: "S1v"
            },
            Profiles: {
              shape: "S4a"
            },
            PrioritizedRiskCounts: {
              shape: "S3j"
            }
          }
        },
        S4v: {
          type: "structure",
          members: {
            ProfileArn: {},
            ProfileVersion: {},
            ProfileName: {},
            ProfileDescription: {},
            ProfileQuestions: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  QuestionId: {},
                  QuestionTitle: {},
                  QuestionDescription: {},
                  QuestionChoices: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        ChoiceId: {},
                        ChoiceTitle: {},
                        ChoiceDescription: {}
                      }
                    }
                  },
                  SelectedChoiceIds: {
                    type: "list",
                    member: {}
                  },
                  MinSelectedChoices: {
                    type: "integer"
                  },
                  MaxSelectedChoices: {
                    type: "integer"
                  }
                }
              }
            },
            Owner: {},
            CreatedAt: {
              type: "timestamp"
            },
            UpdatedAt: {
              type: "timestamp"
            },
            ShareInvitationId: {},
            Tags: {
              shape: "Su"
            }
          }
        },
        S5c: {
          type: "structure",
          members: {
            Description: {},
            Lenses: {
              shape: "S14"
            },
            Notes: {},
            QuestionCounts: {
              shape: "S5d"
            },
            Owner: {},
            UpdatedAt: {
              type: "timestamp"
            },
            TemplateArn: {},
            TemplateName: {},
            Tags: {
              shape: "Su"
            },
            UpdateStatus: {},
            ShareInvitationId: {}
          }
        },
        S5d: {
          type: "map",
          key: {},
          value: {
            type: "integer"
          }
        },
        S5i: {
          type: "structure",
          members: {
            QuestionId: {},
            PillarId: {},
            QuestionTitle: {},
            QuestionDescription: {},
            ImprovementPlanUrl: {},
            HelpfulResourceUrl: {},
            HelpfulResourceDisplayText: {},
            Choices: {
              shape: "S2q"
            },
            SelectedChoices: {
              shape: "S31"
            },
            ChoiceAnswers: {
              shape: "S32"
            },
            IsApplicable: {
              type: "boolean"
            },
            AnswerStatus: {},
            Notes: {},
            Reason: {}
          }
        },
        S5m: {
          type: "structure",
          members: {
            LensAlias: {},
            LensArn: {},
            LensVersion: {},
            LensName: {},
            LensStatus: {},
            PillarReviewSummaries: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  PillarId: {},
                  PillarName: {},
                  Notes: {},
                  QuestionCounts: {
                    shape: "S5d"
                  }
                }
              }
            },
            UpdatedAt: {
              type: "timestamp"
            },
            Notes: {},
            QuestionCounts: {
              shape: "S5d"
            },
            NextToken: {}
          }
        },
        S60: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ChoiceId: {},
              Status: {},
              Reason: {}
            }
          }
        },
        S7d: {
          type: "structure",
          members: {
            WorkloadId: {},
            WorkloadArn: {},
            WorkloadName: {},
            Owner: {},
            UpdatedAt: {
              type: "timestamp"
            },
            Lenses: {
              shape: "S1q"
            },
            RiskCounts: {
              shape: "S3j"
            },
            ImprovementStatus: {},
            Profiles: {
              shape: "S4a"
            },
            PrioritizedRiskCounts: {
              shape: "S3j"
            }
          }
        },
        S95: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "Status"
            ],
            members: {
              Status: {},
              Reason: {},
              Notes: {}
            }
          }
        },
        S9c: {
          type: "map",
          key: {},
          value: {}
        },
        S9h: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/wellarchitected-2020-03-31.paginators.json
var require_wellarchitected_2020_03_31_paginators = __commonJS({
  "node_modules/aws-sdk/apis/wellarchitected-2020-03-31.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetConsolidatedReport: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAnswers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListCheckDetails: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListCheckSummaries: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListLensReviewImprovements: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListLensReviews: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListLensShares: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListLenses: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMilestones: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListNotifications: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListProfileNotifications: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListProfileShares: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListProfiles: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListReviewTemplateAnswers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListReviewTemplates: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListShareInvitations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListTemplateShares: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListWorkloadShares: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListWorkloads: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/wellarchitected.js
var require_wellarchitected = __commonJS({
  "node_modules/aws-sdk/clients/wellarchitected.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["wellarchitected"] = {};
    AWS2.WellArchitected = Service.defineService("wellarchitected", ["2020-03-31"]);
    Object.defineProperty(apiLoader.services["wellarchitected"], "2020-03-31", {
      get: function get() {
        var model = require_wellarchitected_2020_03_31_min();
        model.paginators = require_wellarchitected_2020_03_31_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.WellArchitected;
  }
});

// node_modules/aws-sdk/apis/models.lex.v2-2020-08-07.min.json
var require_models_lex_v2_2020_08_07_min = __commonJS({
  "node_modules/aws-sdk/apis/models.lex.v2-2020-08-07.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-08-07",
        endpointPrefix: "models-v2-lex",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Lex Models V2",
        serviceFullName: "Amazon Lex Model Building V2",
        serviceId: "Lex Models V2",
        signatureVersion: "v4",
        signingName: "lex",
        uid: "models.lex.v2-2020-08-07"
      },
      operations: {
        BatchCreateCustomVocabularyItem: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/customvocabulary/DEFAULT/batchcreate",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion",
              "localeId",
              "customVocabularyItemList"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              customVocabularyItemList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "phrase"
                  ],
                  members: {
                    phrase: {},
                    weight: {
                      type: "integer"
                    },
                    displayAs: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeId: {},
              errors: {
                shape: "Sa"
              },
              resources: {
                shape: "Sf"
              }
            }
          }
        },
        BatchDeleteCustomVocabularyItem: {
          http: {
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/customvocabulary/DEFAULT/batchdelete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion",
              "localeId",
              "customVocabularyItemList"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              customVocabularyItemList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "itemId"
                  ],
                  members: {
                    itemId: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeId: {},
              errors: {
                shape: "Sa"
              },
              resources: {
                shape: "Sf"
              }
            }
          }
        },
        BatchUpdateCustomVocabularyItem: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/customvocabulary/DEFAULT/batchupdate",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion",
              "localeId",
              "customVocabularyItemList"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              customVocabularyItemList: {
                type: "list",
                member: {
                  shape: "Sg"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeId: {},
              errors: {
                shape: "Sa"
              },
              resources: {
                shape: "Sf"
              }
            }
          }
        },
        BuildBotLocale: {
          http: {
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeId: {},
              botLocaleStatus: {},
              lastBuildSubmittedDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        CreateBot: {
          http: {
            method: "PUT",
            requestUri: "/bots/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "botName",
              "roleArn",
              "dataPrivacy",
              "idleSessionTTLInSeconds"
            ],
            members: {
              botName: {},
              description: {},
              roleArn: {},
              dataPrivacy: {
                shape: "Sx"
              },
              idleSessionTTLInSeconds: {
                type: "integer"
              },
              botTags: {
                shape: "S10"
              },
              testBotAliasTags: {
                shape: "S10"
              },
              botType: {},
              botMembers: {
                shape: "S14"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botName: {},
              description: {},
              roleArn: {},
              dataPrivacy: {
                shape: "Sx"
              },
              idleSessionTTLInSeconds: {
                type: "integer"
              },
              botStatus: {},
              creationDateTime: {
                type: "timestamp"
              },
              botTags: {
                shape: "S10"
              },
              testBotAliasTags: {
                shape: "S10"
              },
              botType: {},
              botMembers: {
                shape: "S14"
              }
            }
          }
        },
        CreateBotAlias: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botId}/botaliases/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "botAliasName",
              "botId"
            ],
            members: {
              botAliasName: {},
              description: {},
              botVersion: {},
              botAliasLocaleSettings: {
                shape: "S1c"
              },
              conversationLogSettings: {
                shape: "S1j"
              },
              sentimentAnalysisSettings: {
                shape: "S1x"
              },
              botId: {
                location: "uri",
                locationName: "botId"
              },
              tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botAliasId: {},
              botAliasName: {},
              description: {},
              botVersion: {},
              botAliasLocaleSettings: {
                shape: "S1c"
              },
              conversationLogSettings: {
                shape: "S1j"
              },
              sentimentAnalysisSettings: {
                shape: "S1x"
              },
              botAliasStatus: {},
              botId: {},
              creationDateTime: {
                type: "timestamp"
              },
              tags: {
                shape: "S10"
              }
            }
          }
        },
        CreateBotLocale: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion",
              "localeId",
              "nluIntentConfidenceThreshold"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {},
              description: {},
              nluIntentConfidenceThreshold: {
                type: "double"
              },
              voiceSettings: {
                shape: "S22"
              },
              generativeAISettings: {
                shape: "S25"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeName: {},
              localeId: {},
              description: {},
              nluIntentConfidenceThreshold: {
                type: "double"
              },
              voiceSettings: {
                shape: "S22"
              },
              botLocaleStatus: {},
              creationDateTime: {
                type: "timestamp"
              },
              generativeAISettings: {
                shape: "S25"
              }
            }
          }
        },
        CreateBotVersion: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botId}/botversions/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersionLocaleSpecification"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              description: {},
              botVersionLocaleSpecification: {
                shape: "S2h"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              description: {},
              botVersion: {},
              botVersionLocaleSpecification: {
                shape: "S2h"
              },
              botStatus: {},
              creationDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        CreateExport: {
          http: {
            method: "PUT",
            requestUri: "/exports/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "resourceSpecification",
              "fileFormat"
            ],
            members: {
              resourceSpecification: {
                shape: "S2l"
              },
              fileFormat: {},
              filePassword: {
                shape: "S2r"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              exportId: {},
              resourceSpecification: {
                shape: "S2l"
              },
              fileFormat: {},
              exportStatus: {},
              creationDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        CreateIntent: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/intents/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "intentName",
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              intentName: {},
              description: {},
              parentIntentSignature: {},
              sampleUtterances: {
                shape: "S2w"
              },
              dialogCodeHook: {
                shape: "S2z"
              },
              fulfillmentCodeHook: {
                shape: "S30"
              },
              intentConfirmationSetting: {
                shape: "S48"
              },
              intentClosingSetting: {
                shape: "S4q"
              },
              inputContexts: {
                shape: "S4r"
              },
              outputContexts: {
                shape: "S4t"
              },
              kendraConfiguration: {
                shape: "S4x"
              },
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              initialResponseSetting: {
                shape: "S50"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              intentId: {},
              intentName: {},
              description: {},
              parentIntentSignature: {},
              sampleUtterances: {
                shape: "S2w"
              },
              dialogCodeHook: {
                shape: "S2z"
              },
              fulfillmentCodeHook: {
                shape: "S30"
              },
              intentConfirmationSetting: {
                shape: "S48"
              },
              intentClosingSetting: {
                shape: "S4q"
              },
              inputContexts: {
                shape: "S4r"
              },
              outputContexts: {
                shape: "S4t"
              },
              kendraConfiguration: {
                shape: "S4x"
              },
              botId: {},
              botVersion: {},
              localeId: {},
              creationDateTime: {
                type: "timestamp"
              },
              initialResponseSetting: {
                shape: "S50"
              }
            }
          }
        },
        CreateResourcePolicy: {
          http: {
            requestUri: "/policy/{resourceArn}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "policy"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              policy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              resourceArn: {},
              revisionId: {}
            }
          }
        },
        CreateResourcePolicyStatement: {
          http: {
            requestUri: "/policy/{resourceArn}/statements/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "statementId",
              "effect",
              "principal",
              "action"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              statementId: {},
              effect: {},
              principal: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    service: {},
                    arn: {}
                  }
                }
              },
              action: {
                type: "list",
                member: {}
              },
              condition: {
                type: "map",
                key: {},
                value: {
                  type: "map",
                  key: {},
                  value: {}
                }
              },
              expectedRevisionId: {
                location: "querystring",
                locationName: "expectedRevisionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resourceArn: {},
              revisionId: {}
            }
          }
        },
        CreateSlot: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/intents/{intentId}/slots/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "slotName",
              "valueElicitationSetting",
              "botId",
              "botVersion",
              "localeId",
              "intentId"
            ],
            members: {
              slotName: {},
              description: {},
              slotTypeId: {},
              valueElicitationSetting: {
                shape: "S5n"
              },
              obfuscationSetting: {
                shape: "S60"
              },
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              intentId: {
                location: "uri",
                locationName: "intentId"
              },
              multipleValuesSetting: {
                shape: "S62"
              },
              subSlotSetting: {
                shape: "S63"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              slotId: {},
              slotName: {},
              description: {},
              slotTypeId: {},
              valueElicitationSetting: {
                shape: "S5n"
              },
              obfuscationSetting: {
                shape: "S60"
              },
              botId: {},
              botVersion: {},
              localeId: {},
              intentId: {},
              creationDateTime: {
                type: "timestamp"
              },
              multipleValuesSetting: {
                shape: "S62"
              },
              subSlotSetting: {
                shape: "S63"
              }
            }
          }
        },
        CreateSlotType: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/slottypes/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "slotTypeName",
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              slotTypeName: {},
              description: {},
              slotTypeValues: {
                shape: "S6a"
              },
              valueSelectionSetting: {
                shape: "S6f"
              },
              parentSlotTypeSignature: {},
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              externalSourceSetting: {
                shape: "S6m"
              },
              compositeSlotTypeSetting: {
                shape: "S6r"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              slotTypeId: {},
              slotTypeName: {},
              description: {},
              slotTypeValues: {
                shape: "S6a"
              },
              valueSelectionSetting: {
                shape: "S6f"
              },
              parentSlotTypeSignature: {},
              botId: {},
              botVersion: {},
              localeId: {},
              creationDateTime: {
                type: "timestamp"
              },
              externalSourceSetting: {
                shape: "S6m"
              },
              compositeSlotTypeSetting: {
                shape: "S6r"
              }
            }
          }
        },
        CreateTestSetDiscrepancyReport: {
          http: {
            requestUri: "/testsets/{testSetId}/testsetdiscrepancy",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "testSetId",
              "target"
            ],
            members: {
              testSetId: {
                location: "uri",
                locationName: "testSetId"
              },
              target: {
                shape: "S6w"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              testSetDiscrepancyReportId: {},
              creationDateTime: {
                type: "timestamp"
              },
              testSetId: {},
              target: {
                shape: "S6w"
              }
            }
          }
        },
        CreateUploadUrl: {
          http: {
            requestUri: "/createuploadurl/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              importId: {},
              uploadUrl: {}
            }
          }
        },
        DeleteBot: {
          http: {
            method: "DELETE",
            requestUri: "/bots/{botId}/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "botId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              skipResourceInUseCheck: {
                location: "querystring",
                locationName: "skipResourceInUseCheck",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botStatus: {}
            }
          }
        },
        DeleteBotAlias: {
          http: {
            method: "DELETE",
            requestUri: "/bots/{botId}/botaliases/{botAliasId}/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "botAliasId",
              "botId"
            ],
            members: {
              botAliasId: {
                location: "uri",
                locationName: "botAliasId"
              },
              botId: {
                location: "uri",
                locationName: "botId"
              },
              skipResourceInUseCheck: {
                location: "querystring",
                locationName: "skipResourceInUseCheck",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botAliasId: {},
              botId: {},
              botAliasStatus: {}
            }
          }
        },
        DeleteBotLocale: {
          http: {
            method: "DELETE",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeId: {},
              botLocaleStatus: {}
            }
          }
        },
        DeleteBotVersion: {
          http: {
            method: "DELETE",
            requestUri: "/bots/{botId}/botversions/{botVersion}/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              skipResourceInUseCheck: {
                location: "querystring",
                locationName: "skipResourceInUseCheck",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              botStatus: {}
            }
          }
        },
        DeleteCustomVocabulary: {
          http: {
            method: "DELETE",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/customvocabulary",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeId: {},
              customVocabularyStatus: {}
            }
          }
        },
        DeleteExport: {
          http: {
            method: "DELETE",
            requestUri: "/exports/{exportId}/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "exportId"
            ],
            members: {
              exportId: {
                location: "uri",
                locationName: "exportId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              exportId: {},
              exportStatus: {}
            }
          }
        },
        DeleteImport: {
          http: {
            method: "DELETE",
            requestUri: "/imports/{importId}/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "importId"
            ],
            members: {
              importId: {
                location: "uri",
                locationName: "importId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              importId: {},
              importStatus: {}
            }
          }
        },
        DeleteIntent: {
          http: {
            method: "DELETE",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/intents/{intentId}/",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "intentId",
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              intentId: {
                location: "uri",
                locationName: "intentId"
              },
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              }
            }
          }
        },
        DeleteResourcePolicy: {
          http: {
            method: "DELETE",
            requestUri: "/policy/{resourceArn}/",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              expectedRevisionId: {
                location: "querystring",
                locationName: "expectedRevisionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resourceArn: {},
              revisionId: {}
            }
          }
        },
        DeleteResourcePolicyStatement: {
          http: {
            method: "DELETE",
            requestUri: "/policy/{resourceArn}/statements/{statementId}/",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "statementId"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              statementId: {
                location: "uri",
                locationName: "statementId"
              },
              expectedRevisionId: {
                location: "querystring",
                locationName: "expectedRevisionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resourceArn: {},
              revisionId: {}
            }
          }
        },
        DeleteSlot: {
          http: {
            method: "DELETE",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/intents/{intentId}/slots/{slotId}/",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "slotId",
              "botId",
              "botVersion",
              "localeId",
              "intentId"
            ],
            members: {
              slotId: {
                location: "uri",
                locationName: "slotId"
              },
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              intentId: {
                location: "uri",
                locationName: "intentId"
              }
            }
          }
        },
        DeleteSlotType: {
          http: {
            method: "DELETE",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/slottypes/{slotTypeId}/",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "slotTypeId",
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              slotTypeId: {
                location: "uri",
                locationName: "slotTypeId"
              },
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              skipResourceInUseCheck: {
                location: "querystring",
                locationName: "skipResourceInUseCheck",
                type: "boolean"
              }
            }
          }
        },
        DeleteTestSet: {
          http: {
            method: "DELETE",
            requestUri: "/testsets/{testSetId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "testSetId"
            ],
            members: {
              testSetId: {
                location: "uri",
                locationName: "testSetId"
              }
            }
          },
          idempotent: true
        },
        DeleteUtterances: {
          http: {
            method: "DELETE",
            requestUri: "/bots/{botId}/utterances/",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "botId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              localeId: {
                location: "querystring",
                locationName: "localeId"
              },
              sessionId: {
                location: "querystring",
                locationName: "sessionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeBot: {
          http: {
            method: "GET",
            requestUri: "/bots/{botId}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botName: {},
              description: {},
              roleArn: {},
              dataPrivacy: {
                shape: "Sx"
              },
              idleSessionTTLInSeconds: {
                type: "integer"
              },
              botStatus: {},
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              },
              botType: {},
              botMembers: {
                shape: "S14"
              },
              failureReasons: {
                shape: "S7w"
              }
            }
          }
        },
        DescribeBotAlias: {
          http: {
            method: "GET",
            requestUri: "/bots/{botId}/botaliases/{botAliasId}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botAliasId",
              "botId"
            ],
            members: {
              botAliasId: {
                location: "uri",
                locationName: "botAliasId"
              },
              botId: {
                location: "uri",
                locationName: "botId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botAliasId: {},
              botAliasName: {},
              description: {},
              botVersion: {},
              botAliasLocaleSettings: {
                shape: "S1c"
              },
              conversationLogSettings: {
                shape: "S1j"
              },
              sentimentAnalysisSettings: {
                shape: "S1x"
              },
              botAliasHistoryEvents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    botVersion: {},
                    startDate: {
                      type: "timestamp"
                    },
                    endDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              botAliasStatus: {},
              botId: {},
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              },
              parentBotNetworks: {
                shape: "S82"
              }
            }
          }
        },
        DescribeBotLocale: {
          http: {
            method: "GET",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeId: {},
              localeName: {},
              description: {},
              nluIntentConfidenceThreshold: {
                type: "double"
              },
              voiceSettings: {
                shape: "S22"
              },
              intentsCount: {
                type: "integer"
              },
              slotTypesCount: {
                type: "integer"
              },
              botLocaleStatus: {},
              failureReasons: {
                shape: "S7w"
              },
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              },
              lastBuildSubmittedDateTime: {
                type: "timestamp"
              },
              botLocaleHistoryEvents: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "event",
                    "eventDate"
                  ],
                  members: {
                    event: {},
                    eventDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              recommendedActions: {
                shape: "S8a"
              },
              generativeAISettings: {
                shape: "S25"
              }
            }
          }
        },
        DescribeBotRecommendation: {
          http: {
            method: "GET",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/botrecommendations/{botRecommendationId}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion",
              "localeId",
              "botRecommendationId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              botRecommendationId: {
                location: "uri",
                locationName: "botRecommendationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeId: {},
              botRecommendationStatus: {},
              botRecommendationId: {},
              failureReasons: {
                shape: "S7w"
              },
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              },
              transcriptSourceSetting: {
                shape: "S8f"
              },
              encryptionSetting: {
                shape: "S8o"
              },
              botRecommendationResults: {
                type: "structure",
                members: {
                  botLocaleExportUrl: {},
                  associatedTranscriptsUrl: {},
                  statistics: {
                    type: "structure",
                    members: {
                      intents: {
                        type: "structure",
                        members: {
                          discoveredIntentCount: {
                            type: "integer"
                          }
                        }
                      },
                      slotTypes: {
                        type: "structure",
                        members: {
                          discoveredSlotTypeCount: {
                            type: "integer"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeBotResourceGeneration: {
          http: {
            method: "GET",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/generations/{generationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion",
              "localeId",
              "generationId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              generationId: {
                location: "uri",
                locationName: "generationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeId: {},
              generationId: {},
              failureReasons: {
                shape: "S7w"
              },
              generationStatus: {},
              generationInputPrompt: {},
              generatedBotLocaleUrl: {},
              creationDateTime: {
                type: "timestamp"
              },
              modelArn: {},
              lastUpdatedDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeBotVersion: {
          http: {
            method: "GET",
            requestUri: "/bots/{botId}/botversions/{botVersion}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botName: {},
              botVersion: {},
              description: {},
              roleArn: {},
              dataPrivacy: {
                shape: "Sx"
              },
              idleSessionTTLInSeconds: {
                type: "integer"
              },
              botStatus: {},
              failureReasons: {
                shape: "S7w"
              },
              creationDateTime: {
                type: "timestamp"
              },
              parentBotNetworks: {
                shape: "S82"
              },
              botType: {},
              botMembers: {
                shape: "S14"
              }
            }
          }
        },
        DescribeCustomVocabularyMetadata: {
          http: {
            method: "GET",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/customvocabulary/DEFAULT/metadata",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeId: {},
              customVocabularyStatus: {},
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeExport: {
          http: {
            method: "GET",
            requestUri: "/exports/{exportId}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "exportId"
            ],
            members: {
              exportId: {
                location: "uri",
                locationName: "exportId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              exportId: {},
              resourceSpecification: {
                shape: "S2l"
              },
              fileFormat: {},
              exportStatus: {},
              failureReasons: {
                shape: "S7w"
              },
              downloadUrl: {},
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeImport: {
          http: {
            method: "GET",
            requestUri: "/imports/{importId}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "importId"
            ],
            members: {
              importId: {
                location: "uri",
                locationName: "importId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              importId: {},
              resourceSpecification: {
                shape: "S97"
              },
              importedResourceId: {},
              importedResourceName: {},
              mergeStrategy: {},
              importStatus: {},
              failureReasons: {
                shape: "S7w"
              },
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeIntent: {
          http: {
            method: "GET",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/intents/{intentId}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "intentId",
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              intentId: {
                location: "uri",
                locationName: "intentId"
              },
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              intentId: {},
              intentName: {},
              description: {},
              parentIntentSignature: {},
              sampleUtterances: {
                shape: "S2w"
              },
              dialogCodeHook: {
                shape: "S2z"
              },
              fulfillmentCodeHook: {
                shape: "S30"
              },
              slotPriorities: {
                shape: "S9j"
              },
              intentConfirmationSetting: {
                shape: "S48"
              },
              intentClosingSetting: {
                shape: "S4q"
              },
              inputContexts: {
                shape: "S4r"
              },
              outputContexts: {
                shape: "S4t"
              },
              kendraConfiguration: {
                shape: "S4x"
              },
              botId: {},
              botVersion: {},
              localeId: {},
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              },
              initialResponseSetting: {
                shape: "S50"
              }
            }
          }
        },
        DescribeResourcePolicy: {
          http: {
            method: "GET",
            requestUri: "/policy/{resourceArn}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resourceArn: {},
              policy: {},
              revisionId: {}
            }
          }
        },
        DescribeSlot: {
          http: {
            method: "GET",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/intents/{intentId}/slots/{slotId}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "slotId",
              "botId",
              "botVersion",
              "localeId",
              "intentId"
            ],
            members: {
              slotId: {
                location: "uri",
                locationName: "slotId"
              },
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              intentId: {
                location: "uri",
                locationName: "intentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              slotId: {},
              slotName: {},
              description: {},
              slotTypeId: {},
              valueElicitationSetting: {
                shape: "S5n"
              },
              obfuscationSetting: {
                shape: "S60"
              },
              botId: {},
              botVersion: {},
              localeId: {},
              intentId: {},
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              },
              multipleValuesSetting: {
                shape: "S62"
              },
              subSlotSetting: {
                shape: "S63"
              }
            }
          }
        },
        DescribeSlotType: {
          http: {
            method: "GET",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/slottypes/{slotTypeId}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "slotTypeId",
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              slotTypeId: {
                location: "uri",
                locationName: "slotTypeId"
              },
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              slotTypeId: {},
              slotTypeName: {},
              description: {},
              slotTypeValues: {
                shape: "S6a"
              },
              valueSelectionSetting: {
                shape: "S6f"
              },
              parentSlotTypeSignature: {},
              botId: {},
              botVersion: {},
              localeId: {},
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              },
              externalSourceSetting: {
                shape: "S6m"
              },
              compositeSlotTypeSetting: {
                shape: "S6r"
              }
            }
          }
        },
        DescribeTestExecution: {
          http: {
            method: "GET",
            requestUri: "/testexecutions/{testExecutionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "testExecutionId"
            ],
            members: {
              testExecutionId: {
                location: "uri",
                locationName: "testExecutionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              testExecutionId: {},
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              },
              testExecutionStatus: {},
              testSetId: {},
              testSetName: {},
              target: {
                shape: "S9v"
              },
              apiMode: {},
              testExecutionModality: {},
              failureReasons: {
                shape: "S7w"
              }
            }
          }
        },
        DescribeTestSet: {
          http: {
            method: "GET",
            requestUri: "/testsets/{testSetId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "testSetId"
            ],
            members: {
              testSetId: {
                location: "uri",
                locationName: "testSetId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              testSetId: {},
              testSetName: {},
              description: {},
              modality: {},
              status: {},
              roleArn: {},
              numTurns: {
                type: "integer"
              },
              storageLocation: {
                shape: "S9c"
              },
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeTestSetDiscrepancyReport: {
          http: {
            method: "GET",
            requestUri: "/testsetdiscrepancy/{testSetDiscrepancyReportId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "testSetDiscrepancyReportId"
            ],
            members: {
              testSetDiscrepancyReportId: {
                location: "uri",
                locationName: "testSetDiscrepancyReportId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              testSetDiscrepancyReportId: {},
              testSetId: {},
              creationDateTime: {
                type: "timestamp"
              },
              target: {
                shape: "S6w"
              },
              testSetDiscrepancyReportStatus: {},
              lastUpdatedDataTime: {
                type: "timestamp"
              },
              testSetDiscrepancyTopErrors: {
                type: "structure",
                required: [
                  "intentDiscrepancies",
                  "slotDiscrepancies"
                ],
                members: {
                  intentDiscrepancies: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "intentName",
                        "errorMessage"
                      ],
                      members: {
                        intentName: {},
                        errorMessage: {}
                      }
                    }
                  },
                  slotDiscrepancies: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "intentName",
                        "slotName",
                        "errorMessage"
                      ],
                      members: {
                        intentName: {},
                        slotName: {},
                        errorMessage: {}
                      }
                    }
                  }
                }
              },
              testSetDiscrepancyRawOutputUrl: {},
              failureReasons: {
                shape: "S7w"
              }
            }
          }
        },
        DescribeTestSetGeneration: {
          http: {
            method: "GET",
            requestUri: "/testsetgenerations/{testSetGenerationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "testSetGenerationId"
            ],
            members: {
              testSetGenerationId: {
                location: "uri",
                locationName: "testSetGenerationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              testSetGenerationId: {},
              testSetGenerationStatus: {},
              failureReasons: {
                shape: "S7w"
              },
              testSetId: {},
              testSetName: {},
              description: {},
              storageLocation: {
                shape: "S9c"
              },
              generationDataSource: {
                shape: "Sad"
              },
              roleArn: {},
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        GenerateBotElement: {
          http: {
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/generate",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "intentId",
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              intentId: {},
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeId: {},
              intentId: {},
              sampleUtterances: {
                shape: "S2w"
              }
            }
          }
        },
        GetTestExecutionArtifactsUrl: {
          http: {
            method: "GET",
            requestUri: "/testexecutions/{testExecutionId}/artifacturl",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "testExecutionId"
            ],
            members: {
              testExecutionId: {
                location: "uri",
                locationName: "testExecutionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              testExecutionId: {},
              downloadArtifactsUrl: {}
            }
          }
        },
        ListAggregatedUtterances: {
          http: {
            requestUri: "/bots/{botId}/aggregatedutterances/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "localeId",
              "aggregationDuration"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botAliasId: {},
              botVersion: {},
              localeId: {},
              aggregationDuration: {
                shape: "Sam"
              },
              sortBy: {
                type: "structure",
                required: [
                  "attribute",
                  "order"
                ],
                members: {
                  attribute: {},
                  order: {}
                }
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "values",
                    "operator"
                  ],
                  members: {
                    name: {},
                    values: {
                      shape: "Saw"
                    },
                    operator: {}
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botAliasId: {},
              botVersion: {},
              localeId: {},
              aggregationDuration: {
                shape: "Sam"
              },
              aggregationWindowStartTime: {
                type: "timestamp"
              },
              aggregationWindowEndTime: {
                type: "timestamp"
              },
              aggregationLastRefreshedDateTime: {
                type: "timestamp"
              },
              aggregatedUtterancesSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    utterance: {},
                    hitCount: {
                      type: "integer"
                    },
                    missedCount: {
                      type: "integer"
                    },
                    utteranceFirstRecordedInAggregationDuration: {
                      type: "timestamp"
                    },
                    utteranceLastRecordedInAggregationDuration: {
                      type: "timestamp"
                    },
                    containsDataFromDeletedResources: {
                      type: "boolean"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListBotAliases: {
          http: {
            requestUri: "/bots/{botId}/botaliases/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              botAliasSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    botAliasId: {},
                    botAliasName: {},
                    description: {},
                    botVersion: {},
                    botAliasStatus: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {},
              botId: {}
            }
          }
        },
        ListBotLocales: {
          http: {
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              sortBy: {
                type: "structure",
                required: [
                  "attribute",
                  "order"
                ],
                members: {
                  attribute: {},
                  order: {}
                }
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "values",
                    "operator"
                  ],
                  members: {
                    name: {},
                    values: {
                      shape: "Saw"
                    },
                    operator: {}
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              nextToken: {},
              botLocaleSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    localeId: {},
                    localeName: {},
                    description: {},
                    botLocaleStatus: {},
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    lastBuildSubmittedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListBotRecommendations: {
          http: {
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/botrecommendations/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeId: {},
              botRecommendationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "botRecommendationStatus",
                    "botRecommendationId"
                  ],
                  members: {
                    botRecommendationStatus: {},
                    botRecommendationId: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListBotResourceGenerations: {
          http: {
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/generations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              sortBy: {
                type: "structure",
                required: [
                  "attribute",
                  "order"
                ],
                members: {
                  attribute: {},
                  order: {}
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeId: {},
              generationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    generationId: {},
                    generationStatus: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListBotVersions: {
          http: {
            requestUri: "/bots/{botId}/botversions/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              sortBy: {
                type: "structure",
                required: [
                  "attribute",
                  "order"
                ],
                members: {
                  attribute: {},
                  order: {}
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    botName: {},
                    botVersion: {},
                    description: {},
                    botStatus: {},
                    creationDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListBots: {
          http: {
            requestUri: "/bots/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              sortBy: {
                type: "structure",
                required: [
                  "attribute",
                  "order"
                ],
                members: {
                  attribute: {},
                  order: {}
                }
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "values",
                    "operator"
                  ],
                  members: {
                    name: {},
                    values: {
                      shape: "Saw"
                    },
                    operator: {}
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              botSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    botId: {},
                    botName: {},
                    description: {},
                    botStatus: {},
                    latestBotVersion: {},
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    botType: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListBuiltInIntents: {
          http: {
            requestUri: "/builtins/locales/{localeId}/intents/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "localeId"
            ],
            members: {
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              sortBy: {
                type: "structure",
                required: [
                  "attribute",
                  "order"
                ],
                members: {
                  attribute: {},
                  order: {}
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              builtInIntentSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    intentSignature: {},
                    description: {}
                  }
                }
              },
              nextToken: {},
              localeId: {}
            }
          }
        },
        ListBuiltInSlotTypes: {
          http: {
            requestUri: "/builtins/locales/{localeId}/slottypes/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "localeId"
            ],
            members: {
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              sortBy: {
                type: "structure",
                required: [
                  "attribute",
                  "order"
                ],
                members: {
                  attribute: {},
                  order: {}
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              builtInSlotTypeSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    slotTypeSignature: {},
                    description: {}
                  }
                }
              },
              nextToken: {},
              localeId: {}
            }
          }
        },
        ListCustomVocabularyItems: {
          http: {
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/customvocabulary/DEFAULT/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeId: {},
              customVocabularyItems: {
                shape: "Sf"
              },
              nextToken: {}
            }
          }
        },
        ListExports: {
          http: {
            requestUri: "/exports/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              sortBy: {
                type: "structure",
                required: [
                  "attribute",
                  "order"
                ],
                members: {
                  attribute: {},
                  order: {}
                }
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "values",
                    "operator"
                  ],
                  members: {
                    name: {},
                    values: {
                      shape: "Saw"
                    },
                    operator: {}
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              localeId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              exportSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    exportId: {},
                    resourceSpecification: {
                      shape: "S2l"
                    },
                    fileFormat: {},
                    exportStatus: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {},
              localeId: {}
            }
          }
        },
        ListImports: {
          http: {
            requestUri: "/imports/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              sortBy: {
                type: "structure",
                required: [
                  "attribute",
                  "order"
                ],
                members: {
                  attribute: {},
                  order: {}
                }
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "values",
                    "operator"
                  ],
                  members: {
                    name: {},
                    values: {
                      shape: "Saw"
                    },
                    operator: {}
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              localeId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              importSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    importId: {},
                    importedResourceId: {},
                    importedResourceName: {},
                    importStatus: {},
                    mergeStrategy: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    importedResourceType: {}
                  }
                }
              },
              nextToken: {},
              localeId: {}
            }
          }
        },
        ListIntentMetrics: {
          http: {
            requestUri: "/bots/{botId}/analytics/intentmetrics",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "startDateTime",
              "endDateTime",
              "metrics"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              startDateTime: {
                type: "timestamp"
              },
              endDateTime: {
                type: "timestamp"
              },
              metrics: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "statistic"
                  ],
                  members: {
                    name: {},
                    statistic: {},
                    order: {}
                  }
                }
              },
              binBy: {
                shape: "Sdg"
              },
              groupBy: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name"
                  ],
                  members: {
                    name: {}
                  }
                }
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "operator",
                    "values"
                  ],
                  members: {
                    name: {},
                    operator: {},
                    values: {
                      shape: "Sdr"
                    }
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              results: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    binKeys: {
                      shape: "Sdw"
                    },
                    groupByKeys: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          value: {}
                        }
                      }
                    },
                    metricsResults: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          statistic: {},
                          value: {
                            type: "double"
                          }
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListIntentPaths: {
          http: {
            requestUri: "/bots/{botId}/analytics/intentpaths",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "startDateTime",
              "endDateTime",
              "intentPath"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              startDateTime: {
                type: "timestamp"
              },
              endDateTime: {
                type: "timestamp"
              },
              intentPath: {},
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "operator",
                    "values"
                  ],
                  members: {
                    name: {},
                    operator: {},
                    values: {
                      shape: "Sdr"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nodeSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    intentName: {},
                    intentPath: {},
                    intentCount: {
                      type: "integer"
                    },
                    intentLevel: {
                      type: "integer"
                    },
                    nodeType: {}
                  }
                }
              }
            }
          }
        },
        ListIntentStageMetrics: {
          http: {
            requestUri: "/bots/{botId}/analytics/intentstagemetrics",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "startDateTime",
              "endDateTime",
              "metrics"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              startDateTime: {
                type: "timestamp"
              },
              endDateTime: {
                type: "timestamp"
              },
              metrics: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "statistic"
                  ],
                  members: {
                    name: {},
                    statistic: {},
                    order: {}
                  }
                }
              },
              binBy: {
                shape: "Sdg"
              },
              groupBy: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name"
                  ],
                  members: {
                    name: {}
                  }
                }
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "operator",
                    "values"
                  ],
                  members: {
                    name: {},
                    operator: {},
                    values: {
                      shape: "Sdr"
                    }
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              results: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    binKeys: {
                      shape: "Sdw"
                    },
                    groupByKeys: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          value: {}
                        }
                      }
                    },
                    metricsResults: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          statistic: {},
                          value: {
                            type: "double"
                          }
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListIntents: {
          http: {
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/intents/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              sortBy: {
                type: "structure",
                required: [
                  "attribute",
                  "order"
                ],
                members: {
                  attribute: {},
                  order: {}
                }
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "values",
                    "operator"
                  ],
                  members: {
                    name: {},
                    values: {
                      shape: "Saw"
                    },
                    operator: {}
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeId: {},
              intentSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    intentId: {},
                    intentName: {},
                    description: {},
                    parentIntentSignature: {},
                    inputContexts: {
                      shape: "S4r"
                    },
                    outputContexts: {
                      shape: "S4t"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListRecommendedIntents: {
          http: {
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/botrecommendations/{botRecommendationId}/intents",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion",
              "localeId",
              "botRecommendationId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              botRecommendationId: {
                location: "uri",
                locationName: "botRecommendationId"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeId: {},
              botRecommendationId: {},
              summaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    intentId: {},
                    intentName: {},
                    sampleUtterancesCount: {
                      type: "integer"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSessionAnalyticsData: {
          http: {
            requestUri: "/bots/{botId}/analytics/sessions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "startDateTime",
              "endDateTime"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              startDateTime: {
                type: "timestamp"
              },
              endDateTime: {
                type: "timestamp"
              },
              sortBy: {
                type: "structure",
                required: [
                  "name",
                  "order"
                ],
                members: {
                  name: {},
                  order: {}
                }
              },
              filters: {
                shape: "Sff"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              nextToken: {},
              sessions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    botAliasId: {},
                    botVersion: {},
                    localeId: {},
                    channel: {},
                    sessionId: {},
                    conversationStartTime: {
                      type: "timestamp"
                    },
                    conversationEndTime: {
                      type: "timestamp"
                    },
                    conversationDurationSeconds: {
                      type: "long"
                    },
                    conversationEndState: {},
                    mode: {},
                    numberOfTurns: {
                      type: "long"
                    },
                    invokedIntentSamples: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          intentName: {}
                        }
                      }
                    },
                    originatingRequestId: {}
                  }
                }
              }
            }
          }
        },
        ListSessionMetrics: {
          http: {
            requestUri: "/bots/{botId}/analytics/sessionmetrics",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "startDateTime",
              "endDateTime",
              "metrics"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              startDateTime: {
                type: "timestamp"
              },
              endDateTime: {
                type: "timestamp"
              },
              metrics: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "statistic"
                  ],
                  members: {
                    name: {},
                    statistic: {},
                    order: {}
                  }
                }
              },
              binBy: {
                shape: "Sdg"
              },
              groupBy: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name"
                  ],
                  members: {
                    name: {}
                  }
                }
              },
              filters: {
                shape: "Sff"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              results: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    binKeys: {
                      shape: "Sdw"
                    },
                    groupByKeys: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          value: {}
                        }
                      }
                    },
                    metricsResults: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          statistic: {},
                          value: {
                            type: "double"
                          }
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSlotTypes: {
          http: {
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/slottypes/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              sortBy: {
                type: "structure",
                required: [
                  "attribute",
                  "order"
                ],
                members: {
                  attribute: {},
                  order: {}
                }
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "values",
                    "operator"
                  ],
                  members: {
                    name: {},
                    values: {
                      shape: "Saw"
                    },
                    operator: {}
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeId: {},
              slotTypeSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    slotTypeId: {},
                    slotTypeName: {},
                    description: {},
                    parentSlotTypeSignature: {},
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    slotTypeCategory: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSlots: {
          http: {
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/intents/{intentId}/slots/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion",
              "localeId",
              "intentId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              intentId: {
                location: "uri",
                locationName: "intentId"
              },
              sortBy: {
                type: "structure",
                required: [
                  "attribute",
                  "order"
                ],
                members: {
                  attribute: {},
                  order: {}
                }
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "values",
                    "operator"
                  ],
                  members: {
                    name: {},
                    values: {
                      shape: "Saw"
                    },
                    operator: {}
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeId: {},
              intentId: {},
              slotSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    slotId: {},
                    slotName: {},
                    description: {},
                    slotConstraint: {},
                    slotTypeId: {},
                    valueElicitationPromptSpecification: {
                      shape: "S49"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceARN}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceARN"
            ],
            members: {
              resourceARN: {
                location: "uri",
                locationName: "resourceARN"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S10"
              }
            }
          }
        },
        ListTestExecutionResultItems: {
          http: {
            requestUri: "/testexecutions/{testExecutionId}/results",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "testExecutionId",
              "resultFilterBy"
            ],
            members: {
              testExecutionId: {
                location: "uri",
                locationName: "testExecutionId"
              },
              resultFilterBy: {
                type: "structure",
                required: [
                  "resultTypeFilter"
                ],
                members: {
                  resultTypeFilter: {},
                  conversationLevelTestResultsFilterBy: {
                    type: "structure",
                    members: {
                      endToEndResult: {}
                    }
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              testExecutionResults: {
                type: "structure",
                members: {
                  overallTestResults: {
                    type: "structure",
                    required: [
                      "items"
                    ],
                    members: {
                      items: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "multiTurnConversation",
                            "totalResultCount",
                            "endToEndResultCounts"
                          ],
                          members: {
                            multiTurnConversation: {
                              type: "boolean"
                            },
                            totalResultCount: {
                              type: "integer"
                            },
                            speechTranscriptionResultCounts: {
                              shape: "Sh4"
                            },
                            endToEndResultCounts: {
                              shape: "Sh4"
                            }
                          }
                        }
                      }
                    }
                  },
                  conversationLevelTestResults: {
                    type: "structure",
                    required: [
                      "items"
                    ],
                    members: {
                      items: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "conversationId",
                            "endToEndResult",
                            "intentClassificationResults",
                            "slotResolutionResults"
                          ],
                          members: {
                            conversationId: {},
                            endToEndResult: {},
                            speechTranscriptionResult: {},
                            intentClassificationResults: {
                              type: "list",
                              member: {
                                type: "structure",
                                required: [
                                  "intentName",
                                  "matchResult"
                                ],
                                members: {
                                  intentName: {},
                                  matchResult: {}
                                }
                              }
                            },
                            slotResolutionResults: {
                              type: "list",
                              member: {
                                type: "structure",
                                required: [
                                  "intentName",
                                  "slotName",
                                  "matchResult"
                                ],
                                members: {
                                  intentName: {},
                                  slotName: {},
                                  matchResult: {}
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  },
                  intentClassificationTestResults: {
                    type: "structure",
                    required: [
                      "items"
                    ],
                    members: {
                      items: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "intentName",
                            "multiTurnConversation",
                            "resultCounts"
                          ],
                          members: {
                            intentName: {},
                            multiTurnConversation: {
                              type: "boolean"
                            },
                            resultCounts: {
                              type: "structure",
                              required: [
                                "totalResultCount",
                                "intentMatchResultCounts"
                              ],
                              members: {
                                totalResultCount: {
                                  type: "integer"
                                },
                                speechTranscriptionResultCounts: {
                                  shape: "Sh4"
                                },
                                intentMatchResultCounts: {
                                  shape: "Sh4"
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  },
                  intentLevelSlotResolutionTestResults: {
                    type: "structure",
                    required: [
                      "items"
                    ],
                    members: {
                      items: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "intentName",
                            "multiTurnConversation",
                            "slotResolutionResults"
                          ],
                          members: {
                            intentName: {},
                            multiTurnConversation: {
                              type: "boolean"
                            },
                            slotResolutionResults: {
                              type: "list",
                              member: {
                                type: "structure",
                                required: [
                                  "slotName",
                                  "resultCounts"
                                ],
                                members: {
                                  slotName: {},
                                  resultCounts: {
                                    type: "structure",
                                    required: [
                                      "totalResultCount",
                                      "slotMatchResultCounts"
                                    ],
                                    members: {
                                      totalResultCount: {
                                        type: "integer"
                                      },
                                      speechTranscriptionResultCounts: {
                                        shape: "Sh4"
                                      },
                                      slotMatchResultCounts: {
                                        shape: "Sh4"
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  },
                  utteranceLevelTestResults: {
                    type: "structure",
                    required: [
                      "items"
                    ],
                    members: {
                      items: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "recordNumber",
                            "turnResult"
                          ],
                          members: {
                            recordNumber: {
                              type: "long"
                            },
                            conversationId: {},
                            turnResult: {
                              type: "structure",
                              members: {
                                agent: {
                                  type: "structure",
                                  required: [
                                    "expectedAgentPrompt"
                                  ],
                                  members: {
                                    expectedAgentPrompt: {},
                                    actualAgentPrompt: {},
                                    errorDetails: {
                                      shape: "Shv"
                                    },
                                    actualElicitedSlot: {},
                                    actualIntent: {}
                                  }
                                },
                                user: {
                                  type: "structure",
                                  required: [
                                    "input",
                                    "expectedOutput"
                                  ],
                                  members: {
                                    input: {
                                      shape: "Shx"
                                    },
                                    expectedOutput: {
                                      shape: "Sid"
                                    },
                                    actualOutput: {
                                      shape: "Sid"
                                    },
                                    errorDetails: {
                                      shape: "Shv"
                                    },
                                    endToEndResult: {},
                                    intentMatchResult: {},
                                    slotMatchResult: {},
                                    speechTranscriptionResult: {},
                                    conversationLevelResult: {
                                      type: "structure",
                                      required: [
                                        "endToEndResult"
                                      ],
                                      members: {
                                        endToEndResult: {},
                                        speechTranscriptionResult: {}
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTestExecutions: {
          http: {
            requestUri: "/testexecutions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              sortBy: {
                type: "structure",
                required: [
                  "attribute",
                  "order"
                ],
                members: {
                  attribute: {},
                  order: {}
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              testExecutions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    testExecutionId: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    testExecutionStatus: {},
                    testSetId: {},
                    testSetName: {},
                    target: {
                      shape: "S9v"
                    },
                    apiMode: {},
                    testExecutionModality: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTestSetRecords: {
          http: {
            requestUri: "/testsets/{testSetId}/records",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "testSetId"
            ],
            members: {
              testSetId: {
                location: "uri",
                locationName: "testSetId"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              testSetRecords: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "recordNumber",
                    "turnSpecification"
                  ],
                  members: {
                    recordNumber: {
                      type: "long"
                    },
                    conversationId: {},
                    turnNumber: {
                      type: "integer"
                    },
                    turnSpecification: {
                      type: "structure",
                      members: {
                        agentTurn: {
                          type: "structure",
                          required: [
                            "agentPrompt"
                          ],
                          members: {
                            agentPrompt: {}
                          }
                        },
                        userTurn: {
                          type: "structure",
                          required: [
                            "input",
                            "expected"
                          ],
                          members: {
                            input: {
                              shape: "Shx"
                            },
                            expected: {
                              shape: "Sid"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTestSets: {
          http: {
            requestUri: "/testsets",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              sortBy: {
                type: "structure",
                required: [
                  "attribute",
                  "order"
                ],
                members: {
                  attribute: {},
                  order: {}
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              testSets: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    testSetId: {},
                    testSetName: {},
                    description: {},
                    modality: {},
                    status: {},
                    roleArn: {},
                    numTurns: {
                      type: "integer"
                    },
                    storageLocation: {
                      shape: "S9c"
                    },
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListUtteranceAnalyticsData: {
          http: {
            requestUri: "/bots/{botId}/analytics/utterances",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "startDateTime",
              "endDateTime"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              startDateTime: {
                type: "timestamp"
              },
              endDateTime: {
                type: "timestamp"
              },
              sortBy: {
                type: "structure",
                required: [
                  "name",
                  "order"
                ],
                members: {
                  name: {},
                  order: {}
                }
              },
              filters: {
                shape: "Sj6"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              nextToken: {},
              utterances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    botAliasId: {},
                    botVersion: {},
                    localeId: {},
                    sessionId: {},
                    channel: {},
                    mode: {},
                    conversationStartTime: {
                      type: "timestamp"
                    },
                    conversationEndTime: {
                      type: "timestamp"
                    },
                    utterance: {},
                    utteranceTimestamp: {
                      type: "timestamp"
                    },
                    audioVoiceDurationMillis: {
                      type: "long"
                    },
                    utteranceUnderstood: {
                      type: "boolean"
                    },
                    inputType: {},
                    outputType: {},
                    associatedIntentName: {},
                    associatedSlotName: {},
                    intentState: {},
                    dialogActionType: {},
                    botResponseAudioVoiceId: {},
                    slotsFilledInSession: {},
                    utteranceRequestId: {},
                    botResponses: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          content: {},
                          contentType: {},
                          imageResponseCard: {
                            shape: "S3c"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        ListUtteranceMetrics: {
          http: {
            requestUri: "/bots/{botId}/analytics/utterancemetrics",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "startDateTime",
              "endDateTime",
              "metrics"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              startDateTime: {
                type: "timestamp"
              },
              endDateTime: {
                type: "timestamp"
              },
              metrics: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "statistic"
                  ],
                  members: {
                    name: {},
                    statistic: {},
                    order: {}
                  }
                }
              },
              binBy: {
                shape: "Sdg"
              },
              groupBy: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name"
                  ],
                  members: {
                    name: {}
                  }
                }
              },
              attributes: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name"
                  ],
                  members: {
                    name: {}
                  }
                }
              },
              filters: {
                shape: "Sj6"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              results: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    binKeys: {
                      shape: "Sdw"
                    },
                    groupByKeys: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          value: {}
                        }
                      }
                    },
                    metricsResults: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          statistic: {},
                          value: {
                            type: "double"
                          }
                        }
                      }
                    },
                    attributeResults: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          lastUsedIntent: {}
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        SearchAssociatedTranscripts: {
          http: {
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/botrecommendations/{botRecommendationId}/associatedtranscripts",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion",
              "localeId",
              "botRecommendationId",
              "filters"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              botRecommendationId: {
                location: "uri",
                locationName: "botRecommendationId"
              },
              searchOrder: {},
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "values"
                  ],
                  members: {
                    name: {},
                    values: {
                      shape: "Saw"
                    }
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextIndex: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeId: {},
              botRecommendationId: {},
              nextIndex: {
                type: "integer"
              },
              associatedTranscripts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    transcript: {}
                  }
                }
              },
              totalResults: {
                type: "integer"
              }
            }
          }
        },
        StartBotRecommendation: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/botrecommendations/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion",
              "localeId",
              "transcriptSourceSetting"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              transcriptSourceSetting: {
                shape: "S8f"
              },
              encryptionSetting: {
                shape: "S8o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeId: {},
              botRecommendationStatus: {},
              botRecommendationId: {},
              creationDateTime: {
                type: "timestamp"
              },
              transcriptSourceSetting: {
                shape: "S8f"
              },
              encryptionSetting: {
                shape: "S8o"
              }
            }
          }
        },
        StartBotResourceGeneration: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/startgeneration",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "generationInputPrompt",
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              generationInputPrompt: {},
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              generationInputPrompt: {},
              generationId: {},
              botId: {},
              botVersion: {},
              localeId: {},
              generationStatus: {},
              creationDateTime: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        StartImport: {
          http: {
            method: "PUT",
            requestUri: "/imports/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "importId",
              "resourceSpecification",
              "mergeStrategy"
            ],
            members: {
              importId: {},
              resourceSpecification: {
                shape: "S97"
              },
              mergeStrategy: {},
              filePassword: {
                shape: "S2r"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              importId: {},
              resourceSpecification: {
                shape: "S97"
              },
              mergeStrategy: {},
              importStatus: {},
              creationDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        StartTestExecution: {
          http: {
            requestUri: "/testsets/{testSetId}/testexecutions",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "testSetId",
              "target",
              "apiMode"
            ],
            members: {
              testSetId: {
                location: "uri",
                locationName: "testSetId"
              },
              target: {
                shape: "S9v"
              },
              apiMode: {},
              testExecutionModality: {}
            }
          },
          output: {
            type: "structure",
            members: {
              testExecutionId: {},
              creationDateTime: {
                type: "timestamp"
              },
              testSetId: {},
              target: {
                shape: "S9v"
              },
              apiMode: {},
              testExecutionModality: {}
            }
          }
        },
        StartTestSetGeneration: {
          http: {
            method: "PUT",
            requestUri: "/testsetgenerations",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "testSetName",
              "storageLocation",
              "generationDataSource",
              "roleArn"
            ],
            members: {
              testSetName: {},
              description: {},
              storageLocation: {
                shape: "S9c"
              },
              generationDataSource: {
                shape: "Sad"
              },
              roleArn: {},
              testSetTags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              testSetGenerationId: {},
              creationDateTime: {
                type: "timestamp"
              },
              testSetGenerationStatus: {},
              testSetName: {},
              description: {},
              storageLocation: {
                shape: "S9c"
              },
              generationDataSource: {
                shape: "Sad"
              },
              roleArn: {},
              testSetTags: {
                shape: "S10"
              }
            }
          },
          idempotent: true
        },
        StopBotRecommendation: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/botrecommendations/{botRecommendationId}/stopbotrecommendation",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion",
              "localeId",
              "botRecommendationId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              botRecommendationId: {
                location: "uri",
                locationName: "botRecommendationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeId: {},
              botRecommendationStatus: {},
              botRecommendationId: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceARN}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceARN",
              "tags"
            ],
            members: {
              resourceARN: {
                location: "uri",
                locationName: "resourceARN"
              },
              tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceARN}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceARN",
              "tagKeys"
            ],
            members: {
              resourceARN: {
                location: "uri",
                locationName: "resourceARN"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateBot: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botId}/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botName",
              "roleArn",
              "dataPrivacy",
              "idleSessionTTLInSeconds"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botName: {},
              description: {},
              roleArn: {},
              dataPrivacy: {
                shape: "Sx"
              },
              idleSessionTTLInSeconds: {
                type: "integer"
              },
              botType: {},
              botMembers: {
                shape: "S14"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botName: {},
              description: {},
              roleArn: {},
              dataPrivacy: {
                shape: "Sx"
              },
              idleSessionTTLInSeconds: {
                type: "integer"
              },
              botStatus: {},
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              },
              botType: {},
              botMembers: {
                shape: "S14"
              }
            }
          }
        },
        UpdateBotAlias: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botId}/botaliases/{botAliasId}/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "botAliasId",
              "botAliasName",
              "botId"
            ],
            members: {
              botAliasId: {
                location: "uri",
                locationName: "botAliasId"
              },
              botAliasName: {},
              description: {},
              botVersion: {},
              botAliasLocaleSettings: {
                shape: "S1c"
              },
              conversationLogSettings: {
                shape: "S1j"
              },
              sentimentAnalysisSettings: {
                shape: "S1x"
              },
              botId: {
                location: "uri",
                locationName: "botId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botAliasId: {},
              botAliasName: {},
              description: {},
              botVersion: {},
              botAliasLocaleSettings: {
                shape: "S1c"
              },
              conversationLogSettings: {
                shape: "S1j"
              },
              sentimentAnalysisSettings: {
                shape: "S1x"
              },
              botAliasStatus: {},
              botId: {},
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        UpdateBotLocale: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion",
              "localeId",
              "nluIntentConfidenceThreshold"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              description: {},
              nluIntentConfidenceThreshold: {
                type: "double"
              },
              voiceSettings: {
                shape: "S22"
              },
              generativeAISettings: {
                shape: "S25"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeId: {},
              localeName: {},
              description: {},
              nluIntentConfidenceThreshold: {
                type: "double"
              },
              voiceSettings: {
                shape: "S22"
              },
              botLocaleStatus: {},
              failureReasons: {
                shape: "S7w"
              },
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              },
              recommendedActions: {
                shape: "S8a"
              },
              generativeAISettings: {
                shape: "S25"
              }
            }
          }
        },
        UpdateBotRecommendation: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/botrecommendations/{botRecommendationId}/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion",
              "localeId",
              "botRecommendationId",
              "encryptionSetting"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              botRecommendationId: {
                location: "uri",
                locationName: "botRecommendationId"
              },
              encryptionSetting: {
                shape: "S8o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeId: {},
              botRecommendationStatus: {},
              botRecommendationId: {},
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              },
              transcriptSourceSetting: {
                shape: "S8f"
              },
              encryptionSetting: {
                shape: "S8o"
              }
            }
          }
        },
        UpdateExport: {
          http: {
            method: "PUT",
            requestUri: "/exports/{exportId}/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "exportId"
            ],
            members: {
              exportId: {
                location: "uri",
                locationName: "exportId"
              },
              filePassword: {
                shape: "S2r"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              exportId: {},
              resourceSpecification: {
                shape: "S2l"
              },
              fileFormat: {},
              exportStatus: {},
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        UpdateIntent: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/intents/{intentId}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "intentId",
              "intentName",
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              intentId: {
                location: "uri",
                locationName: "intentId"
              },
              intentName: {},
              description: {},
              parentIntentSignature: {},
              sampleUtterances: {
                shape: "S2w"
              },
              dialogCodeHook: {
                shape: "S2z"
              },
              fulfillmentCodeHook: {
                shape: "S30"
              },
              slotPriorities: {
                shape: "S9j"
              },
              intentConfirmationSetting: {
                shape: "S48"
              },
              intentClosingSetting: {
                shape: "S4q"
              },
              inputContexts: {
                shape: "S4r"
              },
              outputContexts: {
                shape: "S4t"
              },
              kendraConfiguration: {
                shape: "S4x"
              },
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              initialResponseSetting: {
                shape: "S50"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              intentId: {},
              intentName: {},
              description: {},
              parentIntentSignature: {},
              sampleUtterances: {
                shape: "S2w"
              },
              dialogCodeHook: {
                shape: "S2z"
              },
              fulfillmentCodeHook: {
                shape: "S30"
              },
              slotPriorities: {
                shape: "S9j"
              },
              intentConfirmationSetting: {
                shape: "S48"
              },
              intentClosingSetting: {
                shape: "S4q"
              },
              inputContexts: {
                shape: "S4r"
              },
              outputContexts: {
                shape: "S4t"
              },
              kendraConfiguration: {
                shape: "S4x"
              },
              botId: {},
              botVersion: {},
              localeId: {},
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              },
              initialResponseSetting: {
                shape: "S50"
              }
            }
          }
        },
        UpdateResourcePolicy: {
          http: {
            method: "PUT",
            requestUri: "/policy/{resourceArn}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "policy"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              policy: {},
              expectedRevisionId: {
                location: "querystring",
                locationName: "expectedRevisionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resourceArn: {},
              revisionId: {}
            }
          }
        },
        UpdateSlot: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/intents/{intentId}/slots/{slotId}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "slotId",
              "slotName",
              "valueElicitationSetting",
              "botId",
              "botVersion",
              "localeId",
              "intentId"
            ],
            members: {
              slotId: {
                location: "uri",
                locationName: "slotId"
              },
              slotName: {},
              description: {},
              slotTypeId: {},
              valueElicitationSetting: {
                shape: "S5n"
              },
              obfuscationSetting: {
                shape: "S60"
              },
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              intentId: {
                location: "uri",
                locationName: "intentId"
              },
              multipleValuesSetting: {
                shape: "S62"
              },
              subSlotSetting: {
                shape: "S63"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              slotId: {},
              slotName: {},
              description: {},
              slotTypeId: {},
              valueElicitationSetting: {
                shape: "S5n"
              },
              obfuscationSetting: {
                shape: "S60"
              },
              botId: {},
              botVersion: {},
              localeId: {},
              intentId: {},
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              },
              multipleValuesSetting: {
                shape: "S62"
              },
              subSlotSetting: {
                shape: "S63"
              }
            }
          }
        },
        UpdateSlotType: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/slottypes/{slotTypeId}/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "slotTypeId",
              "slotTypeName",
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              slotTypeId: {
                location: "uri",
                locationName: "slotTypeId"
              },
              slotTypeName: {},
              description: {},
              slotTypeValues: {
                shape: "S6a"
              },
              valueSelectionSetting: {
                shape: "S6f"
              },
              parentSlotTypeSignature: {},
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              externalSourceSetting: {
                shape: "S6m"
              },
              compositeSlotTypeSetting: {
                shape: "S6r"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              slotTypeId: {},
              slotTypeName: {},
              description: {},
              slotTypeValues: {
                shape: "S6a"
              },
              valueSelectionSetting: {
                shape: "S6f"
              },
              parentSlotTypeSignature: {},
              botId: {},
              botVersion: {},
              localeId: {},
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              },
              externalSourceSetting: {
                shape: "S6m"
              },
              compositeSlotTypeSetting: {
                shape: "S6r"
              }
            }
          }
        },
        UpdateTestSet: {
          http: {
            method: "PUT",
            requestUri: "/testsets/{testSetId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "testSetId",
              "testSetName"
            ],
            members: {
              testSetId: {
                location: "uri",
                locationName: "testSetId"
              },
              testSetName: {},
              description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              testSetId: {},
              testSetName: {},
              description: {},
              modality: {},
              status: {},
              roleArn: {},
              numTurns: {
                type: "integer"
              },
              storageLocation: {
                shape: "S9c"
              },
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        }
      },
      shapes: {
        Sa: {
          type: "list",
          member: {
            type: "structure",
            members: {
              itemId: {},
              errorMessage: {},
              errorCode: {}
            }
          }
        },
        Sf: {
          type: "list",
          member: {
            shape: "Sg"
          }
        },
        Sg: {
          type: "structure",
          required: [
            "itemId",
            "phrase"
          ],
          members: {
            itemId: {},
            phrase: {},
            weight: {
              type: "integer"
            },
            displayAs: {}
          }
        },
        Sx: {
          type: "structure",
          required: [
            "childDirected"
          ],
          members: {
            childDirected: {
              type: "boolean"
            }
          }
        },
        S10: {
          type: "map",
          key: {},
          value: {}
        },
        S14: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "botMemberId",
              "botMemberName",
              "botMemberAliasId",
              "botMemberAliasName",
              "botMemberVersion"
            ],
            members: {
              botMemberId: {},
              botMemberName: {},
              botMemberAliasId: {},
              botMemberAliasName: {},
              botMemberVersion: {}
            }
          }
        },
        S1c: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "enabled"
            ],
            members: {
              enabled: {
                type: "boolean"
              },
              codeHookSpecification: {
                type: "structure",
                required: [
                  "lambdaCodeHook"
                ],
                members: {
                  lambdaCodeHook: {
                    type: "structure",
                    required: [
                      "lambdaARN",
                      "codeHookInterfaceVersion"
                    ],
                    members: {
                      lambdaARN: {},
                      codeHookInterfaceVersion: {}
                    }
                  }
                }
              }
            }
          }
        },
        S1j: {
          type: "structure",
          members: {
            textLogSettings: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "enabled",
                  "destination"
                ],
                members: {
                  enabled: {
                    type: "boolean"
                  },
                  destination: {
                    type: "structure",
                    required: [
                      "cloudWatch"
                    ],
                    members: {
                      cloudWatch: {
                        type: "structure",
                        required: [
                          "cloudWatchLogGroupArn",
                          "logPrefix"
                        ],
                        members: {
                          cloudWatchLogGroupArn: {},
                          logPrefix: {}
                        }
                      }
                    }
                  },
                  selectiveLoggingEnabled: {
                    type: "boolean"
                  }
                }
              }
            },
            audioLogSettings: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "enabled",
                  "destination"
                ],
                members: {
                  enabled: {
                    type: "boolean"
                  },
                  destination: {
                    type: "structure",
                    required: [
                      "s3Bucket"
                    ],
                    members: {
                      s3Bucket: {
                        type: "structure",
                        required: [
                          "s3BucketArn",
                          "logPrefix"
                        ],
                        members: {
                          kmsKeyArn: {},
                          s3BucketArn: {},
                          logPrefix: {}
                        }
                      }
                    }
                  },
                  selectiveLoggingEnabled: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        S1x: {
          type: "structure",
          required: [
            "detectSentiment"
          ],
          members: {
            detectSentiment: {
              type: "boolean"
            }
          }
        },
        S22: {
          type: "structure",
          required: [
            "voiceId"
          ],
          members: {
            voiceId: {},
            engine: {}
          }
        },
        S25: {
          type: "structure",
          members: {
            runtimeSettings: {
              type: "structure",
              members: {
                slotResolutionImprovement: {
                  type: "structure",
                  required: [
                    "enabled"
                  ],
                  members: {
                    enabled: {
                      type: "boolean"
                    },
                    bedrockModelSpecification: {
                      shape: "S29"
                    }
                  }
                }
              }
            },
            buildtimeSettings: {
              type: "structure",
              members: {
                descriptiveBotBuilder: {
                  type: "structure",
                  required: [
                    "enabled"
                  ],
                  members: {
                    enabled: {
                      type: "boolean"
                    },
                    bedrockModelSpecification: {
                      shape: "S29"
                    }
                  }
                },
                sampleUtteranceGeneration: {
                  type: "structure",
                  required: [
                    "enabled"
                  ],
                  members: {
                    enabled: {
                      type: "boolean"
                    },
                    bedrockModelSpecification: {
                      shape: "S29"
                    }
                  }
                }
              }
            }
          }
        },
        S29: {
          type: "structure",
          required: [
            "modelArn"
          ],
          members: {
            modelArn: {}
          }
        },
        S2h: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "sourceBotVersion"
            ],
            members: {
              sourceBotVersion: {}
            }
          }
        },
        S2l: {
          type: "structure",
          members: {
            botExportSpecification: {
              type: "structure",
              required: [
                "botId",
                "botVersion"
              ],
              members: {
                botId: {},
                botVersion: {}
              }
            },
            botLocaleExportSpecification: {
              type: "structure",
              required: [
                "botId",
                "botVersion",
                "localeId"
              ],
              members: {
                botId: {},
                botVersion: {},
                localeId: {}
              }
            },
            customVocabularyExportSpecification: {
              type: "structure",
              required: [
                "botId",
                "botVersion",
                "localeId"
              ],
              members: {
                botId: {},
                botVersion: {},
                localeId: {}
              }
            },
            testSetExportSpecification: {
              type: "structure",
              required: [
                "testSetId"
              ],
              members: {
                testSetId: {}
              }
            }
          }
        },
        S2r: {
          type: "string",
          sensitive: true
        },
        S2w: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "utterance"
            ],
            members: {
              utterance: {}
            }
          }
        },
        S2z: {
          type: "structure",
          required: [
            "enabled"
          ],
          members: {
            enabled: {
              type: "boolean"
            }
          }
        },
        S30: {
          type: "structure",
          required: [
            "enabled"
          ],
          members: {
            enabled: {
              type: "boolean"
            },
            postFulfillmentStatusSpecification: {
              type: "structure",
              members: {
                successResponse: {
                  shape: "S32"
                },
                failureResponse: {
                  shape: "S32"
                },
                timeoutResponse: {
                  shape: "S32"
                },
                successNextStep: {
                  shape: "S3k"
                },
                successConditional: {
                  shape: "S3w"
                },
                failureNextStep: {
                  shape: "S3k"
                },
                failureConditional: {
                  shape: "S3w"
                },
                timeoutNextStep: {
                  shape: "S3k"
                },
                timeoutConditional: {
                  shape: "S3w"
                }
              }
            },
            fulfillmentUpdatesSpecification: {
              type: "structure",
              required: [
                "active"
              ],
              members: {
                active: {
                  type: "boolean"
                },
                startResponse: {
                  type: "structure",
                  required: [
                    "delayInSeconds",
                    "messageGroups"
                  ],
                  members: {
                    delayInSeconds: {
                      type: "integer"
                    },
                    messageGroups: {
                      shape: "S33"
                    },
                    allowInterrupt: {
                      type: "boolean"
                    }
                  }
                },
                updateResponse: {
                  type: "structure",
                  required: [
                    "frequencyInSeconds",
                    "messageGroups"
                  ],
                  members: {
                    frequencyInSeconds: {
                      type: "integer"
                    },
                    messageGroups: {
                      shape: "S33"
                    },
                    allowInterrupt: {
                      type: "boolean"
                    }
                  }
                },
                timeoutInSeconds: {
                  type: "integer"
                }
              }
            },
            active: {
              type: "boolean"
            }
          }
        },
        S32: {
          type: "structure",
          required: [
            "messageGroups"
          ],
          members: {
            messageGroups: {
              shape: "S33"
            },
            allowInterrupt: {
              type: "boolean"
            }
          }
        },
        S33: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "message"
            ],
            members: {
              message: {
                shape: "S35"
              },
              variations: {
                type: "list",
                member: {
                  shape: "S35"
                }
              }
            }
          }
        },
        S35: {
          type: "structure",
          members: {
            plainTextMessage: {
              type: "structure",
              required: [
                "value"
              ],
              members: {
                value: {}
              }
            },
            customPayload: {
              type: "structure",
              required: [
                "value"
              ],
              members: {
                value: {}
              }
            },
            ssmlMessage: {
              type: "structure",
              required: [
                "value"
              ],
              members: {
                value: {}
              }
            },
            imageResponseCard: {
              shape: "S3c"
            }
          }
        },
        S3c: {
          type: "structure",
          required: [
            "title"
          ],
          members: {
            title: {},
            subtitle: {},
            imageUrl: {},
            buttons: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "text",
                  "value"
                ],
                members: {
                  text: {},
                  value: {}
                }
              }
            }
          }
        },
        S3k: {
          type: "structure",
          members: {
            dialogAction: {
              type: "structure",
              required: [
                "type"
              ],
              members: {
                type: {},
                slotToElicit: {},
                suppressNextMessage: {
                  type: "boolean"
                }
              }
            },
            intent: {
              type: "structure",
              members: {
                name: {},
                slots: {
                  type: "map",
                  key: {},
                  value: {
                    shape: "S3p"
                  }
                }
              }
            },
            sessionAttributes: {
              shape: "S3u"
            }
          }
        },
        S3p: {
          type: "structure",
          members: {
            shape: {},
            value: {
              type: "structure",
              members: {
                interpretedValue: {}
              }
            },
            values: {
              type: "list",
              member: {
                shape: "S3p"
              }
            }
          }
        },
        S3u: {
          type: "map",
          key: {},
          value: {}
        },
        S3w: {
          type: "structure",
          required: [
            "active",
            "conditionalBranches",
            "defaultBranch"
          ],
          members: {
            active: {
              type: "boolean"
            },
            conditionalBranches: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "name",
                  "condition",
                  "nextStep"
                ],
                members: {
                  name: {},
                  condition: {
                    type: "structure",
                    required: [
                      "expressionString"
                    ],
                    members: {
                      expressionString: {}
                    }
                  },
                  nextStep: {
                    shape: "S3k"
                  },
                  response: {
                    shape: "S32"
                  }
                }
              }
            },
            defaultBranch: {
              type: "structure",
              members: {
                nextStep: {
                  shape: "S3k"
                },
                response: {
                  shape: "S32"
                }
              }
            }
          }
        },
        S48: {
          type: "structure",
          required: [
            "promptSpecification"
          ],
          members: {
            promptSpecification: {
              shape: "S49"
            },
            declinationResponse: {
              shape: "S32"
            },
            active: {
              type: "boolean"
            },
            confirmationResponse: {
              shape: "S32"
            },
            confirmationNextStep: {
              shape: "S3k"
            },
            confirmationConditional: {
              shape: "S3w"
            },
            declinationNextStep: {
              shape: "S3k"
            },
            declinationConditional: {
              shape: "S3w"
            },
            failureResponse: {
              shape: "S32"
            },
            failureNextStep: {
              shape: "S3k"
            },
            failureConditional: {
              shape: "S3w"
            },
            codeHook: {
              shape: "S4n"
            },
            elicitationCodeHook: {
              shape: "S4p"
            }
          }
        },
        S49: {
          type: "structure",
          required: [
            "messageGroups",
            "maxRetries"
          ],
          members: {
            messageGroups: {
              shape: "S33"
            },
            maxRetries: {
              type: "integer"
            },
            allowInterrupt: {
              type: "boolean"
            },
            messageSelectionStrategy: {},
            promptAttemptsSpecification: {
              type: "map",
              key: {},
              value: {
                type: "structure",
                required: [
                  "allowedInputTypes"
                ],
                members: {
                  allowInterrupt: {
                    type: "boolean"
                  },
                  allowedInputTypes: {
                    type: "structure",
                    required: [
                      "allowAudioInput",
                      "allowDTMFInput"
                    ],
                    members: {
                      allowAudioInput: {
                        type: "boolean"
                      },
                      allowDTMFInput: {
                        type: "boolean"
                      }
                    }
                  },
                  audioAndDTMFInputSpecification: {
                    type: "structure",
                    required: [
                      "startTimeoutMs"
                    ],
                    members: {
                      startTimeoutMs: {
                        type: "integer"
                      },
                      audioSpecification: {
                        type: "structure",
                        required: [
                          "maxLengthMs",
                          "endTimeoutMs"
                        ],
                        members: {
                          maxLengthMs: {
                            type: "integer"
                          },
                          endTimeoutMs: {
                            type: "integer"
                          }
                        }
                      },
                      dtmfSpecification: {
                        type: "structure",
                        required: [
                          "maxLength",
                          "endTimeoutMs",
                          "deletionCharacter",
                          "endCharacter"
                        ],
                        members: {
                          maxLength: {
                            type: "integer"
                          },
                          endTimeoutMs: {
                            type: "integer"
                          },
                          deletionCharacter: {},
                          endCharacter: {}
                        }
                      }
                    }
                  },
                  textInputSpecification: {
                    type: "structure",
                    required: [
                      "startTimeoutMs"
                    ],
                    members: {
                      startTimeoutMs: {
                        type: "integer"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S4n: {
          type: "structure",
          required: [
            "enableCodeHookInvocation",
            "active",
            "postCodeHookSpecification"
          ],
          members: {
            enableCodeHookInvocation: {
              type: "boolean"
            },
            active: {
              type: "boolean"
            },
            invocationLabel: {},
            postCodeHookSpecification: {
              type: "structure",
              members: {
                successResponse: {
                  shape: "S32"
                },
                successNextStep: {
                  shape: "S3k"
                },
                successConditional: {
                  shape: "S3w"
                },
                failureResponse: {
                  shape: "S32"
                },
                failureNextStep: {
                  shape: "S3k"
                },
                failureConditional: {
                  shape: "S3w"
                },
                timeoutResponse: {
                  shape: "S32"
                },
                timeoutNextStep: {
                  shape: "S3k"
                },
                timeoutConditional: {
                  shape: "S3w"
                }
              }
            }
          }
        },
        S4p: {
          type: "structure",
          required: [
            "enableCodeHookInvocation"
          ],
          members: {
            enableCodeHookInvocation: {
              type: "boolean"
            },
            invocationLabel: {}
          }
        },
        S4q: {
          type: "structure",
          members: {
            closingResponse: {
              shape: "S32"
            },
            active: {
              type: "boolean"
            },
            nextStep: {
              shape: "S3k"
            },
            conditional: {
              shape: "S3w"
            }
          }
        },
        S4r: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          }
        },
        S4t: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "timeToLiveInSeconds",
              "turnsToLive"
            ],
            members: {
              name: {},
              timeToLiveInSeconds: {
                type: "integer"
              },
              turnsToLive: {
                type: "integer"
              }
            }
          }
        },
        S4x: {
          type: "structure",
          required: [
            "kendraIndex"
          ],
          members: {
            kendraIndex: {},
            queryFilterStringEnabled: {
              type: "boolean"
            },
            queryFilterString: {}
          }
        },
        S50: {
          type: "structure",
          members: {
            initialResponse: {
              shape: "S32"
            },
            nextStep: {
              shape: "S3k"
            },
            conditional: {
              shape: "S3w"
            },
            codeHook: {
              shape: "S4n"
            }
          }
        },
        S5n: {
          type: "structure",
          required: [
            "slotConstraint"
          ],
          members: {
            defaultValueSpecification: {
              shape: "S5o"
            },
            slotConstraint: {},
            promptSpecification: {
              shape: "S49"
            },
            sampleUtterances: {
              shape: "S2w"
            },
            waitAndContinueSpecification: {
              shape: "S5t"
            },
            slotCaptureSetting: {
              type: "structure",
              members: {
                captureResponse: {
                  shape: "S32"
                },
                captureNextStep: {
                  shape: "S3k"
                },
                captureConditional: {
                  shape: "S3w"
                },
                failureResponse: {
                  shape: "S32"
                },
                failureNextStep: {
                  shape: "S3k"
                },
                failureConditional: {
                  shape: "S3w"
                },
                codeHook: {
                  shape: "S4n"
                },
                elicitationCodeHook: {
                  shape: "S4p"
                }
              }
            },
            slotResolutionSetting: {
              type: "structure",
              required: [
                "slotResolutionStrategy"
              ],
              members: {
                slotResolutionStrategy: {}
              }
            }
          }
        },
        S5o: {
          type: "structure",
          required: [
            "defaultValueList"
          ],
          members: {
            defaultValueList: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "defaultValue"
                ],
                members: {
                  defaultValue: {}
                }
              }
            }
          }
        },
        S5t: {
          type: "structure",
          required: [
            "waitingResponse",
            "continueResponse"
          ],
          members: {
            waitingResponse: {
              shape: "S32"
            },
            continueResponse: {
              shape: "S32"
            },
            stillWaitingResponse: {
              type: "structure",
              required: [
                "messageGroups",
                "frequencyInSeconds",
                "timeoutInSeconds"
              ],
              members: {
                messageGroups: {
                  shape: "S33"
                },
                frequencyInSeconds: {
                  type: "integer"
                },
                timeoutInSeconds: {
                  type: "integer"
                },
                allowInterrupt: {
                  type: "boolean"
                }
              }
            },
            active: {
              type: "boolean"
            }
          }
        },
        S60: {
          type: "structure",
          required: [
            "obfuscationSettingType"
          ],
          members: {
            obfuscationSettingType: {}
          }
        },
        S62: {
          type: "structure",
          members: {
            allowMultipleValues: {
              type: "boolean"
            }
          }
        },
        S63: {
          type: "structure",
          members: {
            expression: {},
            slotSpecifications: {
              type: "map",
              key: {},
              value: {
                type: "structure",
                required: [
                  "slotTypeId",
                  "valueElicitationSetting"
                ],
                members: {
                  slotTypeId: {},
                  valueElicitationSetting: {
                    type: "structure",
                    required: [
                      "promptSpecification"
                    ],
                    members: {
                      defaultValueSpecification: {
                        shape: "S5o"
                      },
                      promptSpecification: {
                        shape: "S49"
                      },
                      sampleUtterances: {
                        shape: "S2w"
                      },
                      waitAndContinueSpecification: {
                        shape: "S5t"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S6a: {
          type: "list",
          member: {
            type: "structure",
            members: {
              sampleValue: {
                shape: "S6c"
              },
              synonyms: {
                type: "list",
                member: {
                  shape: "S6c"
                }
              }
            }
          }
        },
        S6c: {
          type: "structure",
          required: [
            "value"
          ],
          members: {
            value: {}
          }
        },
        S6f: {
          type: "structure",
          required: [
            "resolutionStrategy"
          ],
          members: {
            resolutionStrategy: {},
            regexFilter: {
              type: "structure",
              required: [
                "pattern"
              ],
              members: {
                pattern: {}
              }
            },
            advancedRecognitionSetting: {
              type: "structure",
              members: {
                audioRecognitionStrategy: {}
              }
            }
          }
        },
        S6m: {
          type: "structure",
          members: {
            grammarSlotTypeSetting: {
              type: "structure",
              members: {
                source: {
                  type: "structure",
                  required: [
                    "s3BucketName",
                    "s3ObjectKey"
                  ],
                  members: {
                    s3BucketName: {},
                    s3ObjectKey: {},
                    kmsKeyArn: {}
                  }
                }
              }
            }
          }
        },
        S6r: {
          type: "structure",
          members: {
            subSlots: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "name",
                  "slotTypeId"
                ],
                members: {
                  name: {},
                  slotTypeId: {}
                }
              }
            }
          }
        },
        S6w: {
          type: "structure",
          members: {
            botAliasTarget: {
              type: "structure",
              required: [
                "botId",
                "botAliasId",
                "localeId"
              ],
              members: {
                botId: {},
                botAliasId: {},
                localeId: {}
              }
            }
          }
        },
        S7w: {
          type: "list",
          member: {}
        },
        S82: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "botId",
              "botVersion"
            ],
            members: {
              botId: {},
              botVersion: {}
            }
          }
        },
        S8a: {
          type: "list",
          member: {}
        },
        S8f: {
          type: "structure",
          members: {
            s3BucketTranscriptSource: {
              type: "structure",
              required: [
                "s3BucketName",
                "transcriptFormat"
              ],
              members: {
                s3BucketName: {},
                pathFormat: {
                  type: "structure",
                  members: {
                    objectPrefixes: {
                      type: "list",
                      member: {}
                    }
                  }
                },
                transcriptFormat: {},
                transcriptFilter: {
                  type: "structure",
                  members: {
                    lexTranscriptFilter: {
                      type: "structure",
                      members: {
                        dateRangeFilter: {
                          type: "structure",
                          required: [
                            "startDateTime",
                            "endDateTime"
                          ],
                          members: {
                            startDateTime: {
                              type: "timestamp"
                            },
                            endDateTime: {
                              type: "timestamp"
                            }
                          }
                        }
                      }
                    }
                  }
                },
                kmsKeyArn: {}
              }
            }
          }
        },
        S8o: {
          type: "structure",
          members: {
            kmsKeyArn: {},
            botLocaleExportPassword: {
              shape: "S8p"
            },
            associatedTranscriptsPassword: {
              shape: "S8p"
            }
          }
        },
        S8p: {
          type: "string",
          sensitive: true
        },
        S97: {
          type: "structure",
          members: {
            botImportSpecification: {
              type: "structure",
              required: [
                "botName",
                "roleArn",
                "dataPrivacy"
              ],
              members: {
                botName: {},
                roleArn: {},
                dataPrivacy: {
                  shape: "Sx"
                },
                idleSessionTTLInSeconds: {
                  type: "integer"
                },
                botTags: {
                  shape: "S10"
                },
                testBotAliasTags: {
                  shape: "S10"
                }
              }
            },
            botLocaleImportSpecification: {
              type: "structure",
              required: [
                "botId",
                "botVersion",
                "localeId"
              ],
              members: {
                botId: {},
                botVersion: {},
                localeId: {},
                nluIntentConfidenceThreshold: {
                  type: "double"
                },
                voiceSettings: {
                  shape: "S22"
                }
              }
            },
            customVocabularyImportSpecification: {
              type: "structure",
              required: [
                "botId",
                "botVersion",
                "localeId"
              ],
              members: {
                botId: {},
                botVersion: {},
                localeId: {}
              }
            },
            testSetImportResourceSpecification: {
              type: "structure",
              required: [
                "testSetName",
                "roleArn",
                "storageLocation",
                "importInputLocation",
                "modality"
              ],
              members: {
                testSetName: {},
                description: {},
                roleArn: {},
                storageLocation: {
                  shape: "S9c"
                },
                importInputLocation: {
                  type: "structure",
                  required: [
                    "s3BucketName",
                    "s3Path"
                  ],
                  members: {
                    s3BucketName: {},
                    s3Path: {}
                  }
                },
                modality: {},
                testSetTags: {
                  shape: "S10"
                }
              }
            }
          }
        },
        S9c: {
          type: "structure",
          required: [
            "s3BucketName",
            "s3Path"
          ],
          members: {
            s3BucketName: {},
            s3Path: {},
            kmsKeyArn: {}
          }
        },
        S9j: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "priority",
              "slotId"
            ],
            members: {
              priority: {
                type: "integer"
              },
              slotId: {}
            }
          }
        },
        S9v: {
          type: "structure",
          members: {
            botAliasTarget: {
              type: "structure",
              required: [
                "botId",
                "botAliasId",
                "localeId"
              ],
              members: {
                botId: {},
                botAliasId: {},
                localeId: {}
              }
            }
          }
        },
        Sad: {
          type: "structure",
          members: {
            conversationLogsDataSource: {
              type: "structure",
              required: [
                "botId",
                "botAliasId",
                "localeId",
                "filter"
              ],
              members: {
                botId: {},
                botAliasId: {},
                localeId: {},
                filter: {
                  type: "structure",
                  required: [
                    "startTime",
                    "endTime",
                    "inputMode"
                  ],
                  members: {
                    startTime: {
                      type: "timestamp"
                    },
                    endTime: {
                      type: "timestamp"
                    },
                    inputMode: {}
                  }
                }
              }
            }
          }
        },
        Sam: {
          type: "structure",
          required: [
            "relativeAggregationDuration"
          ],
          members: {
            relativeAggregationDuration: {
              type: "structure",
              required: [
                "timeDimension",
                "timeValue"
              ],
              members: {
                timeDimension: {},
                timeValue: {
                  type: "integer"
                }
              }
            }
          }
        },
        Saw: {
          type: "list",
          member: {}
        },
        Sdg: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "interval"
            ],
            members: {
              name: {},
              interval: {},
              order: {}
            }
          }
        },
        Sdr: {
          type: "list",
          member: {}
        },
        Sdw: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              value: {
                type: "long"
              }
            }
          }
        },
        Sff: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "operator",
              "values"
            ],
            members: {
              name: {},
              operator: {},
              values: {
                shape: "Sdr"
              }
            }
          }
        },
        Sh4: {
          type: "map",
          key: {},
          value: {
            type: "integer"
          }
        },
        Shv: {
          type: "structure",
          required: [
            "errorCode",
            "errorMessage"
          ],
          members: {
            errorCode: {},
            errorMessage: {}
          }
        },
        Shx: {
          type: "structure",
          required: [
            "utteranceInput"
          ],
          members: {
            utteranceInput: {
              type: "structure",
              members: {
                textInput: {},
                audioInput: {
                  type: "structure",
                  required: [
                    "audioFileS3Location"
                  ],
                  members: {
                    audioFileS3Location: {}
                  }
                }
              }
            },
            requestAttributes: {
              shape: "S3u"
            },
            sessionState: {
              type: "structure",
              members: {
                sessionAttributes: {
                  shape: "S3u"
                },
                activeContexts: {
                  shape: "Si3"
                },
                runtimeHints: {
                  type: "structure",
                  members: {
                    slotHints: {
                      type: "map",
                      key: {},
                      value: {
                        shape: "Si8"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Si3: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          }
        },
        Si8: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              runtimeHintValues: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "phrase"
                  ],
                  members: {
                    phrase: {}
                  }
                }
              },
              subSlotHints: {
                shape: "Si8"
              }
            }
          }
        },
        Sid: {
          type: "structure",
          required: [
            "intent"
          ],
          members: {
            intent: {
              type: "structure",
              required: [
                "name"
              ],
              members: {
                name: {},
                slots: {
                  shape: "Sif"
                }
              }
            },
            activeContexts: {
              shape: "Si3"
            },
            transcript: {}
          }
        },
        Sif: {
          type: "map",
          key: {},
          value: {
            shape: "Sig"
          }
        },
        Sig: {
          type: "structure",
          members: {
            value: {},
            values: {
              type: "list",
              member: {
                shape: "Sig"
              }
            },
            subSlots: {
              shape: "Sif"
            }
          }
        },
        Sj6: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "operator",
              "values"
            ],
            members: {
              name: {},
              operator: {},
              values: {
                shape: "Sdr"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/models.lex.v2-2020-08-07.paginators.json
var require_models_lex_v2_2020_08_07_paginators = __commonJS({
  "node_modules/aws-sdk/apis/models.lex.v2-2020-08-07.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAggregatedUtterances: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListBotAliases: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListBotLocales: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListBotRecommendations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListBotResourceGenerations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListBotVersions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListBots: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListBuiltInIntents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListBuiltInSlotTypes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListCustomVocabularyItems: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListExports: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListImports: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListIntentMetrics: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListIntentStageMetrics: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListIntents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListRecommendedIntents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListSessionAnalyticsData: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListSessionMetrics: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListSlotTypes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListSlots: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListTestExecutionResultItems: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListTestExecutions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListTestSetRecords: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListTestSets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListUtteranceAnalyticsData: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListUtteranceMetrics: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/models.lex.v2-2020-08-07.waiters2.json
var require_models_lex_v2_2020_08_07_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/models.lex.v2-2020-08-07.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        BotAvailable: {
          delay: 10,
          operation: "DescribeBot",
          maxAttempts: 35,
          description: "Wait until a bot is available",
          acceptors: [
            {
              expected: "Available",
              matcher: "path",
              state: "success",
              argument: "botStatus"
            },
            {
              expected: "Deleting",
              matcher: "path",
              state: "failure",
              argument: "botStatus"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "botStatus"
            },
            {
              expected: "Inactive",
              matcher: "path",
              state: "failure",
              argument: "botStatus"
            }
          ]
        },
        BotAliasAvailable: {
          delay: 10,
          operation: "DescribeBotAlias",
          maxAttempts: 35,
          description: "Wait until a bot alias is available",
          acceptors: [
            {
              expected: "Available",
              matcher: "path",
              state: "success",
              argument: "botAliasStatus"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "botAliasStatus"
            },
            {
              expected: "Deleting",
              matcher: "path",
              state: "failure",
              argument: "botAliasStatus"
            }
          ]
        },
        BotExportCompleted: {
          delay: 10,
          operation: "DescribeExport",
          maxAttempts: 35,
          description: "Wait until a bot has been exported",
          acceptors: [
            {
              expected: "Completed",
              matcher: "path",
              state: "success",
              argument: "exportStatus"
            },
            {
              expected: "Deleting",
              matcher: "path",
              state: "failure",
              argument: "exportStatus"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "exportStatus"
            }
          ]
        },
        BotImportCompleted: {
          delay: 10,
          operation: "DescribeImport",
          maxAttempts: 35,
          description: "Wait until a bot has been imported",
          acceptors: [
            {
              expected: "Completed",
              matcher: "path",
              state: "success",
              argument: "importStatus"
            },
            {
              expected: "Deleting",
              matcher: "path",
              state: "failure",
              argument: "importStatus"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "importStatus"
            }
          ]
        },
        BotLocaleBuilt: {
          delay: 10,
          operation: "DescribeBotLocale",
          maxAttempts: 35,
          description: "Wait until a bot locale is built",
          acceptors: [
            {
              expected: "Built",
              matcher: "path",
              state: "success",
              argument: "botLocaleStatus"
            },
            {
              expected: "Deleting",
              matcher: "path",
              state: "failure",
              argument: "botLocaleStatus"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "botLocaleStatus"
            },
            {
              expected: "NotBuilt",
              matcher: "path",
              state: "failure",
              argument: "botLocaleStatus"
            }
          ]
        },
        BotLocaleExpressTestingAvailable: {
          delay: 10,
          operation: "DescribeBotLocale",
          maxAttempts: 35,
          description: "Wait until a bot locale build is ready for express testing",
          acceptors: [
            {
              expected: "Built",
              matcher: "path",
              state: "success",
              argument: "botLocaleStatus"
            },
            {
              expected: "ReadyExpressTesting",
              matcher: "path",
              state: "success",
              argument: "botLocaleStatus"
            },
            {
              expected: "Deleting",
              matcher: "path",
              state: "failure",
              argument: "botLocaleStatus"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "botLocaleStatus"
            },
            {
              expected: "NotBuilt",
              matcher: "path",
              state: "failure",
              argument: "botLocaleStatus"
            }
          ]
        },
        BotVersionAvailable: {
          delay: 10,
          operation: "DescribeBotVersion",
          maxAttempts: 35,
          description: "Wait until a bot version is available",
          acceptors: [
            {
              expected: "Available",
              matcher: "path",
              state: "success",
              argument: "botStatus"
            },
            {
              expected: "Deleting",
              matcher: "path",
              state: "failure",
              argument: "botStatus"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "botStatus"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 404
            }
          ]
        },
        BotLocaleCreated: {
          delay: 10,
          operation: "DescribeBotLocale",
          maxAttempts: 35,
          description: "Wait unit a bot locale is created",
          acceptors: [
            {
              expected: "Built",
              matcher: "path",
              state: "success",
              argument: "botLocaleStatus"
            },
            {
              expected: "ReadyExpressTesting",
              matcher: "path",
              state: "success",
              argument: "botLocaleStatus"
            },
            {
              expected: "NotBuilt",
              matcher: "path",
              state: "success",
              argument: "botLocaleStatus"
            },
            {
              expected: "Deleting",
              matcher: "path",
              state: "failure",
              argument: "botLocaleStatus"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "botLocaleStatus"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/lexmodelsv2.js
var require_lexmodelsv2 = __commonJS({
  "node_modules/aws-sdk/clients/lexmodelsv2.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["lexmodelsv2"] = {};
    AWS2.LexModelsV2 = Service.defineService("lexmodelsv2", ["2020-08-07"]);
    Object.defineProperty(apiLoader.services["lexmodelsv2"], "2020-08-07", {
      get: function get() {
        var model = require_models_lex_v2_2020_08_07_min();
        model.paginators = require_models_lex_v2_2020_08_07_paginators().pagination;
        model.waiters = require_models_lex_v2_2020_08_07_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.LexModelsV2;
  }
});

// node_modules/aws-sdk/apis/runtime.lex.v2-2020-08-07.min.json
var require_runtime_lex_v2_2020_08_07_min = __commonJS({
  "node_modules/aws-sdk/apis/runtime.lex.v2-2020-08-07.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-08-07",
        endpointPrefix: "runtime-v2-lex",
        jsonVersion: "1.1",
        protocol: "rest-json",
        protocolSettings: {
          h2: "eventstream"
        },
        serviceAbbreviation: "Lex Runtime V2",
        serviceFullName: "Amazon Lex Runtime V2",
        serviceId: "Lex Runtime V2",
        signatureVersion: "v4",
        signingName: "lex",
        uid: "runtime.lex.v2-2020-08-07"
      },
      operations: {
        DeleteSession: {
          http: {
            method: "DELETE",
            requestUri: "/bots/{botId}/botAliases/{botAliasId}/botLocales/{localeId}/sessions/{sessionId}"
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botAliasId",
              "sessionId",
              "localeId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botAliasId: {
                location: "uri",
                locationName: "botAliasId"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              sessionId: {
                location: "uri",
                locationName: "sessionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botAliasId: {},
              localeId: {},
              sessionId: {}
            }
          }
        },
        GetSession: {
          http: {
            method: "GET",
            requestUri: "/bots/{botId}/botAliases/{botAliasId}/botLocales/{localeId}/sessions/{sessionId}"
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botAliasId",
              "localeId",
              "sessionId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botAliasId: {
                location: "uri",
                locationName: "botAliasId"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              sessionId: {
                location: "uri",
                locationName: "sessionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              sessionId: {},
              messages: {
                shape: "Sa"
              },
              interpretations: {
                shape: "Sl"
              },
              sessionState: {
                shape: "S12"
              }
            }
          }
        },
        PutSession: {
          http: {
            requestUri: "/bots/{botId}/botAliases/{botAliasId}/botLocales/{localeId}/sessions/{sessionId}"
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botAliasId",
              "localeId",
              "sessionState",
              "sessionId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botAliasId: {
                location: "uri",
                locationName: "botAliasId"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              sessionId: {
                location: "uri",
                locationName: "sessionId"
              },
              messages: {
                shape: "Sa"
              },
              sessionState: {
                shape: "S12"
              },
              requestAttributes: {
                shape: "S1f"
              },
              responseContentType: {
                location: "header",
                locationName: "ResponseContentType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              contentType: {
                location: "header",
                locationName: "Content-Type"
              },
              messages: {
                location: "header",
                locationName: "x-amz-lex-messages"
              },
              sessionState: {
                location: "header",
                locationName: "x-amz-lex-session-state"
              },
              requestAttributes: {
                location: "header",
                locationName: "x-amz-lex-request-attributes"
              },
              sessionId: {
                location: "header",
                locationName: "x-amz-lex-session-id"
              },
              audioStream: {
                shape: "S1r"
              }
            },
            payload: "audioStream"
          }
        },
        RecognizeText: {
          http: {
            requestUri: "/bots/{botId}/botAliases/{botAliasId}/botLocales/{localeId}/sessions/{sessionId}/text"
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botAliasId",
              "localeId",
              "text",
              "sessionId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botAliasId: {
                location: "uri",
                locationName: "botAliasId"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              sessionId: {
                location: "uri",
                locationName: "sessionId"
              },
              text: {
                shape: "Sc"
              },
              sessionState: {
                shape: "S12"
              },
              requestAttributes: {
                shape: "S1f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              messages: {
                shape: "Sa"
              },
              sessionState: {
                shape: "S12"
              },
              interpretations: {
                shape: "Sl"
              },
              requestAttributes: {
                shape: "S1f"
              },
              sessionId: {},
              recognizedBotMember: {
                type: "structure",
                required: [
                  "botId"
                ],
                members: {
                  botId: {},
                  botName: {}
                }
              }
            }
          }
        },
        RecognizeUtterance: {
          http: {
            requestUri: "/bots/{botId}/botAliases/{botAliasId}/botLocales/{localeId}/sessions/{sessionId}/utterance"
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botAliasId",
              "localeId",
              "requestContentType",
              "sessionId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botAliasId: {
                location: "uri",
                locationName: "botAliasId"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              sessionId: {
                location: "uri",
                locationName: "sessionId"
              },
              sessionState: {
                shape: "S1w",
                location: "header",
                locationName: "x-amz-lex-session-state"
              },
              requestAttributes: {
                shape: "S1w",
                location: "header",
                locationName: "x-amz-lex-request-attributes"
              },
              requestContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              responseContentType: {
                location: "header",
                locationName: "Response-Content-Type"
              },
              inputStream: {
                shape: "S1r"
              }
            },
            payload: "inputStream"
          },
          output: {
            type: "structure",
            members: {
              inputMode: {
                location: "header",
                locationName: "x-amz-lex-input-mode"
              },
              contentType: {
                location: "header",
                locationName: "Content-Type"
              },
              messages: {
                location: "header",
                locationName: "x-amz-lex-messages"
              },
              interpretations: {
                location: "header",
                locationName: "x-amz-lex-interpretations"
              },
              sessionState: {
                location: "header",
                locationName: "x-amz-lex-session-state"
              },
              requestAttributes: {
                location: "header",
                locationName: "x-amz-lex-request-attributes"
              },
              sessionId: {
                location: "header",
                locationName: "x-amz-lex-session-id"
              },
              inputTranscript: {
                location: "header",
                locationName: "x-amz-lex-input-transcript"
              },
              audioStream: {
                shape: "S1r"
              },
              recognizedBotMember: {
                location: "header",
                locationName: "x-amz-lex-recognized-bot-member"
              }
            },
            payload: "audioStream"
          },
          authtype: "v4-unsigned-body"
        }
      },
      shapes: {
        Sa: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "contentType"
            ],
            members: {
              content: {
                shape: "Sc"
              },
              contentType: {},
              imageResponseCard: {
                type: "structure",
                required: [
                  "title"
                ],
                members: {
                  title: {},
                  subtitle: {},
                  imageUrl: {},
                  buttons: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "text",
                        "value"
                      ],
                      members: {
                        text: {},
                        value: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sc: {
          type: "string",
          sensitive: true
        },
        Sl: {
          type: "list",
          member: {
            type: "structure",
            members: {
              nluConfidence: {
                type: "structure",
                members: {
                  score: {
                    type: "double"
                  }
                }
              },
              sentimentResponse: {
                type: "structure",
                members: {
                  sentiment: {},
                  sentimentScore: {
                    type: "structure",
                    members: {
                      positive: {
                        type: "double"
                      },
                      negative: {
                        type: "double"
                      },
                      neutral: {
                        type: "double"
                      },
                      mixed: {
                        type: "double"
                      }
                    }
                  }
                }
              },
              intent: {
                shape: "Ss"
              },
              interpretationSource: {}
            }
          }
        },
        Ss: {
          type: "structure",
          required: [
            "name"
          ],
          members: {
            name: {},
            slots: {
              shape: "St"
            },
            state: {},
            confirmationState: {}
          }
        },
        St: {
          type: "map",
          key: {},
          value: {
            shape: "Su"
          }
        },
        Su: {
          type: "structure",
          members: {
            value: {
              type: "structure",
              required: [
                "interpretedValue"
              ],
              members: {
                originalValue: {},
                interpretedValue: {},
                resolvedValues: {
                  type: "list",
                  member: {}
                }
              }
            },
            shape: {},
            values: {
              type: "list",
              member: {
                shape: "Su"
              }
            },
            subSlots: {
              shape: "St"
            }
          }
        },
        S12: {
          type: "structure",
          members: {
            dialogAction: {
              type: "structure",
              required: [
                "type"
              ],
              members: {
                type: {},
                slotToElicit: {},
                slotElicitationStyle: {},
                subSlotToElicit: {
                  shape: "S16"
                }
              }
            },
            intent: {
              shape: "Ss"
            },
            activeContexts: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "name",
                  "timeToLive",
                  "contextAttributes"
                ],
                members: {
                  name: {},
                  timeToLive: {
                    type: "structure",
                    required: [
                      "timeToLiveInSeconds",
                      "turnsToLive"
                    ],
                    members: {
                      timeToLiveInSeconds: {
                        type: "integer"
                      },
                      turnsToLive: {
                        type: "integer"
                      }
                    }
                  },
                  contextAttributes: {
                    type: "map",
                    key: {},
                    value: {
                      shape: "Sc"
                    }
                  }
                }
              }
            },
            sessionAttributes: {
              shape: "S1f"
            },
            originatingRequestId: {},
            runtimeHints: {
              type: "structure",
              members: {
                slotHints: {
                  type: "map",
                  key: {},
                  value: {
                    shape: "S1k"
                  }
                }
              }
            }
          }
        },
        S16: {
          type: "structure",
          required: [
            "name"
          ],
          members: {
            name: {},
            subSlotToElicit: {
              shape: "S16"
            }
          }
        },
        S1f: {
          type: "map",
          key: {},
          value: {}
        },
        S1k: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              runtimeHintValues: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "phrase"
                  ],
                  members: {
                    phrase: {}
                  }
                }
              },
              subSlotHints: {
                shape: "S1k"
              }
            }
          }
        },
        S1r: {
          type: "blob",
          streaming: true
        },
        S1w: {
          type: "string",
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/runtime.lex.v2-2020-08-07.paginators.json
var require_runtime_lex_v2_2020_08_07_paginators = __commonJS({
  "node_modules/aws-sdk/apis/runtime.lex.v2-2020-08-07.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/lexruntimev2.js
var require_lexruntimev2 = __commonJS({
  "node_modules/aws-sdk/clients/lexruntimev2.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["lexruntimev2"] = {};
    AWS2.LexRuntimeV2 = Service.defineService("lexruntimev2", ["2020-08-07"]);
    Object.defineProperty(apiLoader.services["lexruntimev2"], "2020-08-07", {
      get: function get() {
        var model = require_runtime_lex_v2_2020_08_07_min();
        model.paginators = require_runtime_lex_v2_2020_08_07_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.LexRuntimeV2;
  }
});

// node_modules/aws-sdk/apis/fis-2020-12-01.min.json
var require_fis_2020_12_01_min = __commonJS({
  "node_modules/aws-sdk/apis/fis-2020-12-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-12-01",
        endpointPrefix: "fis",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "FIS",
        serviceFullName: "AWS Fault Injection Simulator",
        serviceId: "fis",
        signatureVersion: "v4",
        signingName: "fis",
        uid: "fis-2020-12-01"
      },
      operations: {
        CreateExperimentTemplate: {
          http: {
            requestUri: "/experimentTemplates",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "clientToken",
              "description",
              "stopConditions",
              "actions",
              "roleArn"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              description: {},
              stopConditions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "source"
                  ],
                  members: {
                    source: {},
                    value: {}
                  }
                }
              },
              targets: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  required: [
                    "resourceType",
                    "selectionMode"
                  ],
                  members: {
                    resourceType: {},
                    resourceArns: {
                      shape: "Sc"
                    },
                    resourceTags: {
                      shape: "Se"
                    },
                    filters: {
                      shape: "Sh"
                    },
                    selectionMode: {},
                    parameters: {
                      shape: "Sn"
                    }
                  }
                }
              },
              actions: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  required: [
                    "actionId"
                  ],
                  members: {
                    actionId: {},
                    description: {},
                    parameters: {
                      shape: "Sv"
                    },
                    targets: {
                      shape: "Sy"
                    },
                    startAfter: {
                      shape: "S10"
                    }
                  }
                }
              },
              roleArn: {},
              tags: {
                shape: "Se"
              },
              logConfiguration: {
                type: "structure",
                required: [
                  "logSchemaVersion"
                ],
                members: {
                  cloudWatchLogsConfiguration: {
                    shape: "S14"
                  },
                  s3Configuration: {
                    shape: "S16"
                  },
                  logSchemaVersion: {
                    type: "integer"
                  }
                }
              },
              experimentOptions: {
                type: "structure",
                members: {
                  accountTargeting: {},
                  emptyTargetResolutionMode: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              experimentTemplate: {
                shape: "S1e"
              }
            }
          }
        },
        CreateTargetAccountConfiguration: {
          http: {
            requestUri: "/experimentTemplates/{id}/targetAccountConfigurations/{accountId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "experimentTemplateId",
              "accountId",
              "roleArn"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              experimentTemplateId: {
                location: "uri",
                locationName: "id"
              },
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              roleArn: {},
              description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              targetAccountConfiguration: {
                shape: "S1z"
              }
            }
          }
        },
        DeleteExperimentTemplate: {
          http: {
            method: "DELETE",
            requestUri: "/experimentTemplates/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              experimentTemplate: {
                shape: "S1e"
              }
            }
          }
        },
        DeleteTargetAccountConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/experimentTemplates/{id}/targetAccountConfigurations/{accountId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "experimentTemplateId",
              "accountId"
            ],
            members: {
              experimentTemplateId: {
                location: "uri",
                locationName: "id"
              },
              accountId: {
                location: "uri",
                locationName: "accountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              targetAccountConfiguration: {
                shape: "S1z"
              }
            }
          }
        },
        GetAction: {
          http: {
            method: "GET",
            requestUri: "/actions/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              action: {
                type: "structure",
                members: {
                  id: {},
                  description: {},
                  parameters: {
                    type: "map",
                    key: {},
                    value: {
                      type: "structure",
                      members: {
                        description: {},
                        required: {
                          type: "boolean"
                        }
                      }
                    }
                  },
                  targets: {
                    shape: "S2d"
                  },
                  tags: {
                    shape: "Se"
                  }
                }
              }
            }
          }
        },
        GetExperiment: {
          http: {
            method: "GET",
            requestUri: "/experiments/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              experiment: {
                shape: "S2j"
              }
            }
          }
        },
        GetExperimentTargetAccountConfiguration: {
          http: {
            method: "GET",
            requestUri: "/experiments/{id}/targetAccountConfigurations/{accountId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "experimentId",
              "accountId"
            ],
            members: {
              experimentId: {
                location: "uri",
                locationName: "id"
              },
              accountId: {
                location: "uri",
                locationName: "accountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              targetAccountConfiguration: {
                type: "structure",
                members: {
                  roleArn: {},
                  accountId: {},
                  description: {}
                }
              }
            }
          }
        },
        GetExperimentTemplate: {
          http: {
            method: "GET",
            requestUri: "/experimentTemplates/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              experimentTemplate: {
                shape: "S1e"
              }
            }
          }
        },
        GetTargetAccountConfiguration: {
          http: {
            method: "GET",
            requestUri: "/experimentTemplates/{id}/targetAccountConfigurations/{accountId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "experimentTemplateId",
              "accountId"
            ],
            members: {
              experimentTemplateId: {
                location: "uri",
                locationName: "id"
              },
              accountId: {
                location: "uri",
                locationName: "accountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              targetAccountConfiguration: {
                shape: "S1z"
              }
            }
          }
        },
        GetTargetResourceType: {
          http: {
            method: "GET",
            requestUri: "/targetResourceTypes/{resourceType}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceType"
            ],
            members: {
              resourceType: {
                location: "uri",
                locationName: "resourceType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              targetResourceType: {
                type: "structure",
                members: {
                  resourceType: {},
                  description: {},
                  parameters: {
                    type: "map",
                    key: {},
                    value: {
                      type: "structure",
                      members: {
                        description: {},
                        required: {
                          type: "boolean"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        ListActions: {
          http: {
            method: "GET",
            requestUri: "/actions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              actions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    description: {},
                    targets: {
                      shape: "S2d"
                    },
                    tags: {
                      shape: "Se"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListExperimentResolvedTargets: {
          http: {
            method: "GET",
            requestUri: "/experiments/{id}/resolvedTargets",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "experimentId"
            ],
            members: {
              experimentId: {
                location: "uri",
                locationName: "id"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              targetName: {
                location: "querystring",
                locationName: "targetName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resolvedTargets: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    resourceType: {},
                    targetName: {},
                    targetInformation: {
                      type: "map",
                      key: {},
                      value: {}
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListExperimentTargetAccountConfigurations: {
          http: {
            method: "GET",
            requestUri: "/experiments/{id}/targetAccountConfigurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "experimentId"
            ],
            members: {
              experimentId: {
                location: "uri",
                locationName: "id"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              targetAccountConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    roleArn: {},
                    accountId: {},
                    description: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListExperimentTemplates: {
          http: {
            method: "GET",
            requestUri: "/experimentTemplates",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              experimentTemplates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    description: {},
                    creationTime: {
                      type: "timestamp"
                    },
                    lastUpdateTime: {
                      type: "timestamp"
                    },
                    tags: {
                      shape: "Se"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListExperiments: {
          http: {
            method: "GET",
            requestUri: "/experiments",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              experiments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    experimentTemplateId: {},
                    state: {
                      shape: "S2k"
                    },
                    creationTime: {
                      type: "timestamp"
                    },
                    tags: {
                      shape: "Se"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Se"
              }
            }
          }
        },
        ListTargetAccountConfigurations: {
          http: {
            method: "GET",
            requestUri: "/experimentTemplates/{id}/targetAccountConfigurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "experimentTemplateId"
            ],
            members: {
              experimentTemplateId: {
                location: "uri",
                locationName: "id"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              targetAccountConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    roleArn: {},
                    accountId: {},
                    description: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTargetResourceTypes: {
          http: {
            method: "GET",
            requestUri: "/targetResourceTypes",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              targetResourceTypes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    resourceType: {},
                    description: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        StartExperiment: {
          http: {
            requestUri: "/experiments",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "clientToken",
              "experimentTemplateId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              experimentTemplateId: {},
              tags: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              experiment: {
                shape: "S2j"
              }
            }
          }
        },
        StopExperiment: {
          http: {
            method: "DELETE",
            requestUri: "/experiments/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              experiment: {
                shape: "S2j"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateExperimentTemplate: {
          http: {
            method: "PATCH",
            requestUri: "/experimentTemplates/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              description: {},
              stopConditions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "source"
                  ],
                  members: {
                    source: {},
                    value: {}
                  }
                }
              },
              targets: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  required: [
                    "resourceType",
                    "selectionMode"
                  ],
                  members: {
                    resourceType: {},
                    resourceArns: {
                      shape: "Sc"
                    },
                    resourceTags: {
                      shape: "Se"
                    },
                    filters: {
                      shape: "Sh"
                    },
                    selectionMode: {},
                    parameters: {
                      shape: "Sn"
                    }
                  }
                }
              },
              actions: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    actionId: {},
                    description: {},
                    parameters: {
                      shape: "Sv"
                    },
                    targets: {
                      shape: "Sy"
                    },
                    startAfter: {
                      shape: "S10"
                    }
                  }
                }
              },
              roleArn: {},
              logConfiguration: {
                type: "structure",
                members: {
                  cloudWatchLogsConfiguration: {
                    shape: "S14"
                  },
                  s3Configuration: {
                    shape: "S16"
                  },
                  logSchemaVersion: {
                    type: "integer"
                  }
                }
              },
              experimentOptions: {
                type: "structure",
                members: {
                  emptyTargetResolutionMode: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              experimentTemplate: {
                shape: "S1e"
              }
            }
          }
        },
        UpdateTargetAccountConfiguration: {
          http: {
            method: "PATCH",
            requestUri: "/experimentTemplates/{id}/targetAccountConfigurations/{accountId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "experimentTemplateId",
              "accountId"
            ],
            members: {
              experimentTemplateId: {
                location: "uri",
                locationName: "id"
              },
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              roleArn: {},
              description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              targetAccountConfiguration: {
                shape: "S1z"
              }
            }
          }
        }
      },
      shapes: {
        Sc: {
          type: "list",
          member: {}
        },
        Se: {
          type: "map",
          key: {},
          value: {}
        },
        Sh: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "path",
              "values"
            ],
            members: {
              path: {},
              values: {
                shape: "Sk"
              }
            }
          }
        },
        Sk: {
          type: "list",
          member: {}
        },
        Sn: {
          type: "map",
          key: {},
          value: {}
        },
        Sv: {
          type: "map",
          key: {},
          value: {}
        },
        Sy: {
          type: "map",
          key: {},
          value: {}
        },
        S10: {
          type: "list",
          member: {}
        },
        S14: {
          type: "structure",
          required: [
            "logGroupArn"
          ],
          members: {
            logGroupArn: {}
          }
        },
        S16: {
          type: "structure",
          required: [
            "bucketName"
          ],
          members: {
            bucketName: {},
            prefix: {}
          }
        },
        S1e: {
          type: "structure",
          members: {
            id: {},
            description: {},
            targets: {
              type: "map",
              key: {},
              value: {
                type: "structure",
                members: {
                  resourceType: {},
                  resourceArns: {
                    shape: "Sc"
                  },
                  resourceTags: {
                    shape: "Se"
                  },
                  filters: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        path: {},
                        values: {
                          shape: "Sk"
                        }
                      }
                    }
                  },
                  selectionMode: {},
                  parameters: {
                    shape: "Sn"
                  }
                }
              }
            },
            actions: {
              type: "map",
              key: {},
              value: {
                type: "structure",
                members: {
                  actionId: {},
                  description: {},
                  parameters: {
                    shape: "Sv"
                  },
                  targets: {
                    shape: "Sy"
                  },
                  startAfter: {
                    shape: "S10"
                  }
                }
              }
            },
            stopConditions: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  source: {},
                  value: {}
                }
              }
            },
            creationTime: {
              type: "timestamp"
            },
            lastUpdateTime: {
              type: "timestamp"
            },
            roleArn: {},
            tags: {
              shape: "Se"
            },
            logConfiguration: {
              type: "structure",
              members: {
                cloudWatchLogsConfiguration: {
                  type: "structure",
                  members: {
                    logGroupArn: {}
                  }
                },
                s3Configuration: {
                  type: "structure",
                  members: {
                    bucketName: {},
                    prefix: {}
                  }
                },
                logSchemaVersion: {
                  type: "integer"
                }
              }
            },
            experimentOptions: {
              type: "structure",
              members: {
                accountTargeting: {},
                emptyTargetResolutionMode: {}
              }
            },
            targetAccountConfigurationsCount: {
              type: "long"
            }
          }
        },
        S1z: {
          type: "structure",
          members: {
            roleArn: {},
            accountId: {},
            description: {}
          }
        },
        S2d: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              resourceType: {}
            }
          }
        },
        S2j: {
          type: "structure",
          members: {
            id: {},
            experimentTemplateId: {},
            roleArn: {},
            state: {
              shape: "S2k"
            },
            targets: {
              type: "map",
              key: {},
              value: {
                type: "structure",
                members: {
                  resourceType: {},
                  resourceArns: {
                    shape: "Sc"
                  },
                  resourceTags: {
                    shape: "Se"
                  },
                  filters: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        path: {},
                        values: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  },
                  selectionMode: {},
                  parameters: {
                    type: "map",
                    key: {},
                    value: {}
                  }
                }
              }
            },
            actions: {
              type: "map",
              key: {},
              value: {
                type: "structure",
                members: {
                  actionId: {},
                  description: {},
                  parameters: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  targets: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  startAfter: {
                    type: "list",
                    member: {}
                  },
                  state: {
                    type: "structure",
                    members: {
                      status: {},
                      reason: {}
                    }
                  },
                  startTime: {
                    type: "timestamp"
                  },
                  endTime: {
                    type: "timestamp"
                  }
                }
              }
            },
            stopConditions: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  source: {},
                  value: {}
                }
              }
            },
            creationTime: {
              type: "timestamp"
            },
            startTime: {
              type: "timestamp"
            },
            endTime: {
              type: "timestamp"
            },
            tags: {
              shape: "Se"
            },
            logConfiguration: {
              type: "structure",
              members: {
                cloudWatchLogsConfiguration: {
                  type: "structure",
                  members: {
                    logGroupArn: {}
                  }
                },
                s3Configuration: {
                  type: "structure",
                  members: {
                    bucketName: {},
                    prefix: {}
                  }
                },
                logSchemaVersion: {
                  type: "integer"
                }
              }
            },
            experimentOptions: {
              type: "structure",
              members: {
                accountTargeting: {},
                emptyTargetResolutionMode: {}
              }
            },
            targetAccountConfigurationsCount: {
              type: "long"
            }
          }
        },
        S2k: {
          type: "structure",
          members: {
            status: {},
            reason: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/fis-2020-12-01.paginators.json
var require_fis_2020_12_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/fis-2020-12-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListActions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListExperimentResolvedTargets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListExperimentTemplates: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListExperiments: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListTargetAccountConfigurations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListTargetResourceTypes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/fis.js
var require_fis = __commonJS({
  "node_modules/aws-sdk/clients/fis.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["fis"] = {};
    AWS2.Fis = Service.defineService("fis", ["2020-12-01"]);
    Object.defineProperty(apiLoader.services["fis"], "2020-12-01", {
      get: function get() {
        var model = require_fis_2020_12_01_min();
        model.paginators = require_fis_2020_12_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Fis;
  }
});

// node_modules/aws-sdk/apis/lookoutmetrics-2017-07-25.min.json
var require_lookoutmetrics_2017_07_25_min = __commonJS({
  "node_modules/aws-sdk/apis/lookoutmetrics-2017-07-25.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-07-25",
        endpointPrefix: "lookoutmetrics",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "LookoutMetrics",
        serviceFullName: "Amazon Lookout for Metrics",
        serviceId: "LookoutMetrics",
        signatureVersion: "v4",
        signingName: "lookoutmetrics",
        uid: "lookoutmetrics-2017-07-25"
      },
      operations: {
        ActivateAnomalyDetector: {
          http: {
            requestUri: "/ActivateAnomalyDetector"
          },
          input: {
            type: "structure",
            required: [
              "AnomalyDetectorArn"
            ],
            members: {
              AnomalyDetectorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        BackTestAnomalyDetector: {
          http: {
            requestUri: "/BackTestAnomalyDetector"
          },
          input: {
            type: "structure",
            required: [
              "AnomalyDetectorArn"
            ],
            members: {
              AnomalyDetectorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateAlert: {
          http: {
            requestUri: "/CreateAlert"
          },
          input: {
            type: "structure",
            required: [
              "AlertName",
              "AnomalyDetectorArn",
              "Action"
            ],
            members: {
              AlertName: {},
              AlertSensitivityThreshold: {
                type: "integer"
              },
              AlertDescription: {},
              AnomalyDetectorArn: {},
              Action: {
                shape: "Sa"
              },
              Tags: {
                shape: "Se"
              },
              AlertFilters: {
                shape: "Sh"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AlertArn: {}
            }
          }
        },
        CreateAnomalyDetector: {
          http: {
            requestUri: "/CreateAnomalyDetector"
          },
          input: {
            type: "structure",
            required: [
              "AnomalyDetectorName",
              "AnomalyDetectorConfig"
            ],
            members: {
              AnomalyDetectorName: {},
              AnomalyDetectorDescription: {},
              AnomalyDetectorConfig: {
                shape: "St"
              },
              KmsKeyArn: {},
              Tags: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AnomalyDetectorArn: {}
            }
          }
        },
        CreateMetricSet: {
          http: {
            requestUri: "/CreateMetricSet"
          },
          input: {
            type: "structure",
            required: [
              "AnomalyDetectorArn",
              "MetricSetName",
              "MetricList",
              "MetricSource"
            ],
            members: {
              AnomalyDetectorArn: {},
              MetricSetName: {},
              MetricSetDescription: {},
              MetricList: {
                shape: "S10"
              },
              Offset: {
                type: "integer"
              },
              TimestampColumn: {
                shape: "S15"
              },
              DimensionList: {
                shape: "S17"
              },
              MetricSetFrequency: {},
              MetricSource: {
                shape: "S18"
              },
              Timezone: {},
              Tags: {
                shape: "Se"
              },
              DimensionFilterList: {
                shape: "S2e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MetricSetArn: {}
            }
          }
        },
        DeactivateAnomalyDetector: {
          http: {
            requestUri: "/DeactivateAnomalyDetector"
          },
          input: {
            type: "structure",
            required: [
              "AnomalyDetectorArn"
            ],
            members: {
              AnomalyDetectorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAlert: {
          http: {
            requestUri: "/DeleteAlert"
          },
          input: {
            type: "structure",
            required: [
              "AlertArn"
            ],
            members: {
              AlertArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAnomalyDetector: {
          http: {
            requestUri: "/DeleteAnomalyDetector"
          },
          input: {
            type: "structure",
            required: [
              "AnomalyDetectorArn"
            ],
            members: {
              AnomalyDetectorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeAlert: {
          http: {
            requestUri: "/DescribeAlert"
          },
          input: {
            type: "structure",
            required: [
              "AlertArn"
            ],
            members: {
              AlertArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Alert: {
                type: "structure",
                members: {
                  Action: {
                    shape: "Sa"
                  },
                  AlertDescription: {},
                  AlertArn: {},
                  AnomalyDetectorArn: {},
                  AlertName: {},
                  AlertSensitivityThreshold: {
                    type: "integer"
                  },
                  AlertType: {},
                  AlertStatus: {},
                  LastModificationTime: {
                    type: "timestamp"
                  },
                  CreationTime: {
                    type: "timestamp"
                  },
                  AlertFilters: {
                    shape: "Sh"
                  }
                }
              }
            }
          }
        },
        DescribeAnomalyDetectionExecutions: {
          http: {
            requestUri: "/DescribeAnomalyDetectionExecutions"
          },
          input: {
            type: "structure",
            required: [
              "AnomalyDetectorArn"
            ],
            members: {
              AnomalyDetectorArn: {},
              Timestamp: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ExecutionList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Timestamp: {},
                    Status: {},
                    FailureReason: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeAnomalyDetector: {
          http: {
            requestUri: "/DescribeAnomalyDetector"
          },
          input: {
            type: "structure",
            required: [
              "AnomalyDetectorArn"
            ],
            members: {
              AnomalyDetectorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AnomalyDetectorArn: {},
              AnomalyDetectorName: {},
              AnomalyDetectorDescription: {},
              AnomalyDetectorConfig: {
                type: "structure",
                members: {
                  AnomalyDetectorFrequency: {}
                }
              },
              CreationTime: {
                type: "timestamp"
              },
              LastModificationTime: {
                type: "timestamp"
              },
              Status: {},
              FailureReason: {},
              KmsKeyArn: {},
              FailureType: {}
            }
          }
        },
        DescribeMetricSet: {
          http: {
            requestUri: "/DescribeMetricSet"
          },
          input: {
            type: "structure",
            required: [
              "MetricSetArn"
            ],
            members: {
              MetricSetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MetricSetArn: {},
              AnomalyDetectorArn: {},
              MetricSetName: {},
              MetricSetDescription: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModificationTime: {
                type: "timestamp"
              },
              Offset: {
                type: "integer"
              },
              MetricList: {
                shape: "S10"
              },
              TimestampColumn: {
                shape: "S15"
              },
              DimensionList: {
                shape: "S17"
              },
              MetricSetFrequency: {},
              Timezone: {},
              MetricSource: {
                shape: "S18"
              },
              DimensionFilterList: {
                shape: "S2e"
              }
            }
          }
        },
        DetectMetricSetConfig: {
          http: {
            requestUri: "/DetectMetricSetConfig"
          },
          input: {
            type: "structure",
            required: [
              "AnomalyDetectorArn",
              "AutoDetectionMetricSource"
            ],
            members: {
              AnomalyDetectorArn: {},
              AutoDetectionMetricSource: {
                type: "structure",
                members: {
                  S3SourceConfig: {
                    type: "structure",
                    members: {
                      TemplatedPathList: {
                        shape: "S1a"
                      },
                      HistoricalDataPathList: {
                        shape: "S1c"
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DetectedMetricSetConfig: {
                type: "structure",
                members: {
                  Offset: {
                    shape: "S3i"
                  },
                  MetricSetFrequency: {
                    shape: "S3i"
                  },
                  MetricSource: {
                    type: "structure",
                    members: {
                      S3SourceConfig: {
                        type: "structure",
                        members: {
                          FileFormatDescriptor: {
                            type: "structure",
                            members: {
                              CsvFormatDescriptor: {
                                type: "structure",
                                members: {
                                  FileCompression: {
                                    shape: "S3i"
                                  },
                                  Charset: {
                                    shape: "S3i"
                                  },
                                  ContainsHeader: {
                                    shape: "S3i"
                                  },
                                  Delimiter: {
                                    shape: "S3i"
                                  },
                                  HeaderList: {
                                    shape: "S3i"
                                  },
                                  QuoteSymbol: {
                                    shape: "S3i"
                                  }
                                }
                              },
                              JsonFormatDescriptor: {
                                type: "structure",
                                members: {
                                  FileCompression: {
                                    shape: "S3i"
                                  },
                                  Charset: {
                                    shape: "S3i"
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetAnomalyGroup: {
          http: {
            requestUri: "/GetAnomalyGroup"
          },
          input: {
            type: "structure",
            required: [
              "AnomalyGroupId",
              "AnomalyDetectorArn"
            ],
            members: {
              AnomalyGroupId: {},
              AnomalyDetectorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AnomalyGroup: {
                type: "structure",
                members: {
                  StartTime: {},
                  EndTime: {},
                  AnomalyGroupId: {},
                  AnomalyGroupScore: {
                    type: "double"
                  },
                  PrimaryMetricName: {},
                  MetricLevelImpactList: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        MetricName: {},
                        NumTimeSeries: {
                          type: "integer"
                        },
                        ContributionMatrix: {
                          type: "structure",
                          members: {
                            DimensionContributionList: {
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  DimensionName: {},
                                  DimensionValueContributionList: {
                                    type: "list",
                                    member: {
                                      type: "structure",
                                      members: {
                                        DimensionValue: {},
                                        ContributionScore: {
                                          type: "double"
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetDataQualityMetrics: {
          http: {
            requestUri: "/GetDataQualityMetrics"
          },
          input: {
            type: "structure",
            required: [
              "AnomalyDetectorArn"
            ],
            members: {
              AnomalyDetectorArn: {},
              MetricSetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AnomalyDetectorDataQualityMetricList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StartTimestamp: {
                      type: "timestamp"
                    },
                    MetricSetDataQualityMetricList: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          MetricSetArn: {},
                          DataQualityMetricList: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                MetricType: {},
                                MetricDescription: {},
                                RelatedColumnName: {},
                                MetricValue: {
                                  type: "double"
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetFeedback: {
          http: {
            requestUri: "/GetFeedback"
          },
          input: {
            type: "structure",
            required: [
              "AnomalyDetectorArn",
              "AnomalyGroupTimeSeriesFeedback"
            ],
            members: {
              AnomalyDetectorArn: {},
              AnomalyGroupTimeSeriesFeedback: {
                type: "structure",
                required: [
                  "AnomalyGroupId"
                ],
                members: {
                  AnomalyGroupId: {},
                  TimeSeriesId: {}
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AnomalyGroupTimeSeriesFeedback: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TimeSeriesId: {},
                    IsAnomaly: {
                      type: "boolean"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetSampleData: {
          http: {
            requestUri: "/GetSampleData"
          },
          input: {
            type: "structure",
            members: {
              S3SourceConfig: {
                type: "structure",
                required: [
                  "RoleArn",
                  "FileFormatDescriptor"
                ],
                members: {
                  RoleArn: {},
                  TemplatedPathList: {
                    shape: "S1a"
                  },
                  HistoricalDataPathList: {
                    shape: "S1c"
                  },
                  FileFormatDescriptor: {
                    shape: "S1e"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HeaderValues: {
                type: "list",
                member: {}
              },
              SampleRows: {
                type: "list",
                member: {
                  type: "list",
                  member: {}
                }
              }
            }
          }
        },
        ListAlerts: {
          http: {
            requestUri: "/ListAlerts"
          },
          input: {
            type: "structure",
            members: {
              AnomalyDetectorArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AlertSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AlertArn: {},
                    AnomalyDetectorArn: {},
                    AlertName: {},
                    AlertSensitivityThreshold: {
                      type: "integer"
                    },
                    AlertType: {},
                    AlertStatus: {},
                    LastModificationTime: {
                      type: "timestamp"
                    },
                    CreationTime: {
                      type: "timestamp"
                    },
                    Tags: {
                      shape: "Se"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListAnomalyDetectors: {
          http: {
            requestUri: "/ListAnomalyDetectors"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AnomalyDetectorSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AnomalyDetectorArn: {},
                    AnomalyDetectorName: {},
                    AnomalyDetectorDescription: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModificationTime: {
                      type: "timestamp"
                    },
                    Status: {},
                    Tags: {
                      shape: "Se"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListAnomalyGroupRelatedMetrics: {
          http: {
            requestUri: "/ListAnomalyGroupRelatedMetrics"
          },
          input: {
            type: "structure",
            required: [
              "AnomalyDetectorArn",
              "AnomalyGroupId"
            ],
            members: {
              AnomalyDetectorArn: {},
              AnomalyGroupId: {},
              RelationshipTypeFilter: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InterMetricImpactList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MetricName: {},
                    AnomalyGroupId: {},
                    RelationshipType: {},
                    ContributionPercentage: {
                      type: "double"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListAnomalyGroupSummaries: {
          http: {
            requestUri: "/ListAnomalyGroupSummaries"
          },
          input: {
            type: "structure",
            required: [
              "AnomalyDetectorArn",
              "SensitivityThreshold"
            ],
            members: {
              AnomalyDetectorArn: {},
              SensitivityThreshold: {
                type: "integer"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AnomalyGroupSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StartTime: {},
                    EndTime: {},
                    AnomalyGroupId: {},
                    AnomalyGroupScore: {
                      type: "double"
                    },
                    PrimaryMetricName: {}
                  }
                }
              },
              AnomalyGroupStatistics: {
                type: "structure",
                members: {
                  EvaluationStartDate: {},
                  TotalCount: {
                    type: "integer"
                  },
                  ItemizedMetricStatsList: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        MetricName: {},
                        OccurrenceCount: {
                          type: "integer"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListAnomalyGroupTimeSeries: {
          http: {
            requestUri: "/ListAnomalyGroupTimeSeries"
          },
          input: {
            type: "structure",
            required: [
              "AnomalyDetectorArn",
              "AnomalyGroupId",
              "MetricName"
            ],
            members: {
              AnomalyDetectorArn: {},
              AnomalyGroupId: {},
              MetricName: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AnomalyGroupId: {},
              MetricName: {},
              TimestampList: {
                type: "list",
                member: {}
              },
              NextToken: {},
              TimeSeriesList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "TimeSeriesId",
                    "DimensionList",
                    "MetricValueList"
                  ],
                  members: {
                    TimeSeriesId: {},
                    DimensionList: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "DimensionName",
                          "DimensionValue"
                        ],
                        members: {
                          DimensionName: {},
                          DimensionValue: {}
                        }
                      }
                    },
                    MetricValueList: {
                      type: "list",
                      member: {
                        type: "double"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        ListMetricSets: {
          http: {
            requestUri: "/ListMetricSets"
          },
          input: {
            type: "structure",
            members: {
              AnomalyDetectorArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MetricSetSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MetricSetArn: {},
                    AnomalyDetectorArn: {},
                    MetricSetDescription: {},
                    MetricSetName: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModificationTime: {
                      type: "timestamp"
                    },
                    Tags: {
                      shape: "Se"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Se",
                locationName: "Tags"
              }
            }
          }
        },
        PutFeedback: {
          http: {
            requestUri: "/PutFeedback"
          },
          input: {
            type: "structure",
            required: [
              "AnomalyDetectorArn",
              "AnomalyGroupTimeSeriesFeedback"
            ],
            members: {
              AnomalyDetectorArn: {},
              AnomalyGroupTimeSeriesFeedback: {
                type: "structure",
                required: [
                  "AnomalyGroupId",
                  "TimeSeriesId",
                  "IsAnomaly"
                ],
                members: {
                  AnomalyGroupId: {},
                  TimeSeriesId: {},
                  IsAnomaly: {
                    type: "boolean"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              Tags: {
                shape: "Se",
                locationName: "tags"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAlert: {
          http: {
            requestUri: "/UpdateAlert"
          },
          input: {
            type: "structure",
            required: [
              "AlertArn"
            ],
            members: {
              AlertArn: {},
              AlertDescription: {},
              AlertSensitivityThreshold: {
                type: "integer"
              },
              Action: {
                shape: "Sa"
              },
              AlertFilters: {
                shape: "Sh"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AlertArn: {}
            }
          }
        },
        UpdateAnomalyDetector: {
          http: {
            requestUri: "/UpdateAnomalyDetector"
          },
          input: {
            type: "structure",
            required: [
              "AnomalyDetectorArn"
            ],
            members: {
              AnomalyDetectorArn: {},
              KmsKeyArn: {},
              AnomalyDetectorDescription: {},
              AnomalyDetectorConfig: {
                shape: "St"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AnomalyDetectorArn: {}
            }
          }
        },
        UpdateMetricSet: {
          http: {
            requestUri: "/UpdateMetricSet"
          },
          input: {
            type: "structure",
            required: [
              "MetricSetArn"
            ],
            members: {
              MetricSetArn: {},
              MetricSetDescription: {},
              MetricList: {
                shape: "S10"
              },
              Offset: {
                type: "integer"
              },
              TimestampColumn: {
                shape: "S15"
              },
              DimensionList: {
                shape: "S17"
              },
              MetricSetFrequency: {},
              MetricSource: {
                shape: "S18"
              },
              DimensionFilterList: {
                shape: "S2e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MetricSetArn: {}
            }
          }
        }
      },
      shapes: {
        Sa: {
          type: "structure",
          members: {
            SNSConfiguration: {
              type: "structure",
              required: [
                "RoleArn",
                "SnsTopicArn"
              ],
              members: {
                RoleArn: {},
                SnsTopicArn: {},
                SnsFormat: {}
              }
            },
            LambdaConfiguration: {
              type: "structure",
              required: [
                "RoleArn",
                "LambdaArn"
              ],
              members: {
                RoleArn: {},
                LambdaArn: {}
              }
            }
          }
        },
        Se: {
          type: "map",
          key: {},
          value: {}
        },
        Sh: {
          type: "structure",
          members: {
            MetricList: {
              type: "list",
              member: {}
            },
            DimensionFilterList: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  DimensionName: {},
                  DimensionValueList: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          }
        },
        St: {
          type: "structure",
          members: {
            AnomalyDetectorFrequency: {}
          }
        },
        S10: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "MetricName",
              "AggregationFunction"
            ],
            members: {
              MetricName: {},
              AggregationFunction: {},
              Namespace: {}
            }
          }
        },
        S15: {
          type: "structure",
          members: {
            ColumnName: {},
            ColumnFormat: {}
          }
        },
        S17: {
          type: "list",
          member: {}
        },
        S18: {
          type: "structure",
          members: {
            S3SourceConfig: {
              type: "structure",
              members: {
                RoleArn: {},
                TemplatedPathList: {
                  shape: "S1a"
                },
                HistoricalDataPathList: {
                  shape: "S1c"
                },
                FileFormatDescriptor: {
                  shape: "S1e"
                }
              }
            },
            AppFlowConfig: {
              type: "structure",
              members: {
                RoleArn: {},
                FlowName: {}
              }
            },
            CloudWatchConfig: {
              type: "structure",
              members: {
                RoleArn: {},
                BackTestConfiguration: {
                  shape: "S1r"
                }
              }
            },
            RDSSourceConfig: {
              type: "structure",
              members: {
                DBInstanceIdentifier: {},
                DatabaseHost: {},
                DatabasePort: {
                  type: "integer"
                },
                SecretManagerArn: {},
                DatabaseName: {},
                TableName: {},
                RoleArn: {},
                VpcConfiguration: {
                  shape: "S1z"
                }
              }
            },
            RedshiftSourceConfig: {
              type: "structure",
              members: {
                ClusterIdentifier: {},
                DatabaseHost: {},
                DatabasePort: {
                  type: "integer"
                },
                SecretManagerArn: {},
                DatabaseName: {},
                TableName: {},
                RoleArn: {},
                VpcConfiguration: {
                  shape: "S1z"
                }
              }
            },
            AthenaSourceConfig: {
              type: "structure",
              members: {
                RoleArn: {},
                DatabaseName: {},
                DataCatalog: {},
                TableName: {},
                WorkGroupName: {},
                S3ResultsPath: {},
                BackTestConfiguration: {
                  shape: "S1r"
                }
              }
            }
          }
        },
        S1a: {
          type: "list",
          member: {}
        },
        S1c: {
          type: "list",
          member: {}
        },
        S1e: {
          type: "structure",
          members: {
            CsvFormatDescriptor: {
              type: "structure",
              members: {
                FileCompression: {},
                Charset: {},
                ContainsHeader: {
                  type: "boolean"
                },
                Delimiter: {},
                HeaderList: {
                  type: "list",
                  member: {}
                },
                QuoteSymbol: {}
              }
            },
            JsonFormatDescriptor: {
              type: "structure",
              members: {
                FileCompression: {},
                Charset: {}
              }
            }
          }
        },
        S1r: {
          type: "structure",
          required: [
            "RunBackTestMode"
          ],
          members: {
            RunBackTestMode: {
              type: "boolean"
            }
          }
        },
        S1z: {
          type: "structure",
          required: [
            "SubnetIdList",
            "SecurityGroupIdList"
          ],
          members: {
            SubnetIdList: {
              type: "list",
              member: {}
            },
            SecurityGroupIdList: {
              type: "list",
              member: {}
            }
          }
        },
        S2e: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              FilterList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DimensionValue: {},
                    FilterOperation: {}
                  }
                }
              }
            }
          }
        },
        S3i: {
          type: "structure",
          members: {
            Value: {
              type: "structure",
              members: {
                S: {},
                N: {},
                B: {},
                SS: {
                  type: "list",
                  member: {}
                },
                NS: {
                  type: "list",
                  member: {}
                },
                BS: {
                  type: "list",
                  member: {}
                }
              }
            },
            Confidence: {},
            Message: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/lookoutmetrics-2017-07-25.paginators.json
var require_lookoutmetrics_2017_07_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/lookoutmetrics-2017-07-25.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeAnomalyDetectionExecutions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        GetFeedback: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAlerts: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAnomalyDetectors: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAnomalyGroupRelatedMetrics: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAnomalyGroupSummaries: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAnomalyGroupTimeSeries: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMetricSets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/lookoutmetrics.js
var require_lookoutmetrics = __commonJS({
  "node_modules/aws-sdk/clients/lookoutmetrics.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["lookoutmetrics"] = {};
    AWS2.LookoutMetrics = Service.defineService("lookoutmetrics", ["2017-07-25"]);
    Object.defineProperty(apiLoader.services["lookoutmetrics"], "2017-07-25", {
      get: function get() {
        var model = require_lookoutmetrics_2017_07_25_min();
        model.paginators = require_lookoutmetrics_2017_07_25_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.LookoutMetrics;
  }
});

// node_modules/aws-sdk/apis/mgn-2020-02-26.min.json
var require_mgn_2020_02_26_min = __commonJS({
  "node_modules/aws-sdk/apis/mgn-2020-02-26.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-02-26",
        endpointPrefix: "mgn",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "mgn",
        serviceFullName: "Application Migration Service",
        serviceId: "mgn",
        signatureVersion: "v4",
        signingName: "mgn",
        uid: "mgn-2020-02-26"
      },
      operations: {
        ArchiveApplication: {
          http: {
            requestUri: "/ArchiveApplication",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationID"
            ],
            members: {
              accountID: {},
              applicationID: {}
            }
          },
          output: {
            shape: "S4"
          }
        },
        ArchiveWave: {
          http: {
            requestUri: "/ArchiveWave",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "waveID"
            ],
            members: {
              accountID: {},
              waveID: {}
            }
          },
          output: {
            shape: "Sj"
          }
        },
        AssociateApplications: {
          http: {
            requestUri: "/AssociateApplications",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationIDs",
              "waveID"
            ],
            members: {
              accountID: {},
              applicationIDs: {
                shape: "Sq"
              },
              waveID: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        AssociateSourceServers: {
          http: {
            requestUri: "/AssociateSourceServers",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationID",
              "sourceServerIDs"
            ],
            members: {
              accountID: {},
              applicationID: {},
              sourceServerIDs: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        ChangeServerLifeCycleState: {
          http: {
            requestUri: "/ChangeServerLifeCycleState",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "lifeCycle",
              "sourceServerID"
            ],
            members: {
              accountID: {},
              lifeCycle: {
                type: "structure",
                required: [
                  "state"
                ],
                members: {
                  state: {}
                }
              },
              sourceServerID: {}
            }
          },
          output: {
            shape: "Sz"
          }
        },
        CreateApplication: {
          http: {
            requestUri: "/CreateApplication",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              accountID: {},
              description: {},
              name: {},
              tags: {
                shape: "Se"
              }
            }
          },
          output: {
            shape: "S4"
          },
          idempotent: true
        },
        CreateConnector: {
          http: {
            requestUri: "/CreateConnector",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "name",
              "ssmInstanceID"
            ],
            members: {
              name: {},
              ssmCommandConfig: {
                shape: "S2b"
              },
              ssmInstanceID: {},
              tags: {
                shape: "Se"
              }
            }
          },
          output: {
            shape: "S2f"
          },
          idempotent: true
        },
        CreateLaunchConfigurationTemplate: {
          http: {
            requestUri: "/CreateLaunchConfigurationTemplate",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              associatePublicIpAddress: {
                type: "boolean"
              },
              bootMode: {},
              copyPrivateIp: {
                type: "boolean"
              },
              copyTags: {
                type: "boolean"
              },
              enableMapAutoTagging: {
                type: "boolean"
              },
              largeVolumeConf: {
                shape: "S2j"
              },
              launchDisposition: {},
              licensing: {
                shape: "S2o"
              },
              mapAutoTaggingMpeID: {},
              postLaunchActions: {
                shape: "S2p"
              },
              smallVolumeConf: {
                shape: "S2j"
              },
              smallVolumeMaxSize: {
                type: "long"
              },
              tags: {
                shape: "Se"
              },
              targetInstanceTypeRightSizingMethod: {}
            }
          },
          output: {
            shape: "S36"
          }
        },
        CreateReplicationConfigurationTemplate: {
          http: {
            requestUri: "/CreateReplicationConfigurationTemplate",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "associateDefaultSecurityGroup",
              "bandwidthThrottling",
              "createPublicIP",
              "dataPlaneRouting",
              "defaultLargeStagingDiskType",
              "ebsEncryption",
              "replicationServerInstanceType",
              "replicationServersSecurityGroupsIDs",
              "stagingAreaSubnetId",
              "stagingAreaTags",
              "useDedicatedReplicationServer"
            ],
            members: {
              associateDefaultSecurityGroup: {
                type: "boolean"
              },
              bandwidthThrottling: {
                type: "long"
              },
              createPublicIP: {
                type: "boolean"
              },
              dataPlaneRouting: {},
              defaultLargeStagingDiskType: {},
              ebsEncryption: {},
              ebsEncryptionKeyArn: {},
              replicationServerInstanceType: {},
              replicationServersSecurityGroupsIDs: {
                shape: "S3e"
              },
              stagingAreaSubnetId: {},
              stagingAreaTags: {
                shape: "Se"
              },
              tags: {
                shape: "Se"
              },
              useDedicatedReplicationServer: {
                type: "boolean"
              },
              useFipsEndpoint: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S3h"
          }
        },
        CreateWave: {
          http: {
            requestUri: "/CreateWave",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              accountID: {},
              description: {},
              name: {},
              tags: {
                shape: "Se"
              }
            }
          },
          output: {
            shape: "Sj"
          },
          idempotent: true
        },
        DeleteApplication: {
          http: {
            requestUri: "/DeleteApplication",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "applicationID"
            ],
            members: {
              accountID: {},
              applicationID: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteConnector: {
          http: {
            requestUri: "/DeleteConnector",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "connectorID"
            ],
            members: {
              connectorID: {}
            }
          },
          idempotent: true
        },
        DeleteJob: {
          http: {
            requestUri: "/DeleteJob",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "jobID"
            ],
            members: {
              accountID: {},
              jobID: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteLaunchConfigurationTemplate: {
          http: {
            requestUri: "/DeleteLaunchConfigurationTemplate",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "launchConfigurationTemplateID"
            ],
            members: {
              launchConfigurationTemplateID: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteReplicationConfigurationTemplate: {
          http: {
            requestUri: "/DeleteReplicationConfigurationTemplate",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "replicationConfigurationTemplateID"
            ],
            members: {
              replicationConfigurationTemplateID: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteSourceServer: {
          http: {
            requestUri: "/DeleteSourceServer",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              accountID: {},
              sourceServerID: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteVcenterClient: {
          http: {
            requestUri: "/DeleteVcenterClient",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "vcenterClientID"
            ],
            members: {
              vcenterClientID: {}
            }
          },
          idempotent: true
        },
        DeleteWave: {
          http: {
            requestUri: "/DeleteWave",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "waveID"
            ],
            members: {
              accountID: {},
              waveID: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DescribeJobLogItems: {
          http: {
            requestUri: "/DescribeJobLogItems",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "jobID"
            ],
            members: {
              accountID: {},
              jobID: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    event: {},
                    eventData: {
                      type: "structure",
                      members: {
                        conversionServerID: {},
                        rawError: {},
                        sourceServerID: {},
                        targetInstanceID: {}
                      }
                    },
                    logDateTime: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeJobs: {
          http: {
            requestUri: "/DescribeJobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              accountID: {},
              filters: {
                type: "structure",
                members: {
                  fromDate: {},
                  jobIDs: {
                    type: "list",
                    member: {}
                  },
                  toDate: {}
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  shape: "S4b"
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeLaunchConfigurationTemplates: {
          http: {
            requestUri: "/DescribeLaunchConfigurationTemplates",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              launchConfigurationTemplateIDs: {
                type: "list",
                member: {}
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  shape: "S36"
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeReplicationConfigurationTemplates: {
          http: {
            requestUri: "/DescribeReplicationConfigurationTemplates",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              replicationConfigurationTemplateIDs: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  shape: "S3h"
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeSourceServers: {
          http: {
            requestUri: "/DescribeSourceServers",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              accountID: {},
              filters: {
                type: "structure",
                members: {
                  applicationIDs: {
                    type: "list",
                    member: {}
                  },
                  isArchived: {
                    type: "boolean"
                  },
                  lifeCycleStates: {
                    type: "list",
                    member: {}
                  },
                  replicationTypes: {
                    type: "list",
                    member: {}
                  },
                  sourceServerIDs: {
                    type: "list",
                    member: {}
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  shape: "Sz"
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeVcenterClients: {
          http: {
            method: "GET",
            requestUri: "/DescribeVcenterClients",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    datacenterName: {},
                    hostname: {},
                    lastSeenDatetime: {},
                    sourceServerTags: {
                      shape: "Se"
                    },
                    tags: {
                      shape: "Se"
                    },
                    vcenterClientID: {},
                    vcenterUUID: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DisassociateApplications: {
          http: {
            requestUri: "/DisassociateApplications",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationIDs",
              "waveID"
            ],
            members: {
              accountID: {},
              applicationIDs: {
                shape: "Sq"
              },
              waveID: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DisassociateSourceServers: {
          http: {
            requestUri: "/DisassociateSourceServers",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationID",
              "sourceServerIDs"
            ],
            members: {
              accountID: {},
              applicationID: {},
              sourceServerIDs: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DisconnectFromService: {
          http: {
            requestUri: "/DisconnectFromService",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              accountID: {},
              sourceServerID: {}
            }
          },
          output: {
            shape: "Sz"
          }
        },
        FinalizeCutover: {
          http: {
            requestUri: "/FinalizeCutover",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              accountID: {},
              sourceServerID: {}
            }
          },
          output: {
            shape: "Sz"
          }
        },
        GetLaunchConfiguration: {
          http: {
            requestUri: "/GetLaunchConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              accountID: {},
              sourceServerID: {}
            }
          },
          output: {
            shape: "S5f"
          }
        },
        GetReplicationConfiguration: {
          http: {
            requestUri: "/GetReplicationConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              accountID: {},
              sourceServerID: {}
            }
          },
          output: {
            shape: "S5i"
          }
        },
        InitializeService: {
          http: {
            requestUri: "/InitializeService",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ListApplications: {
          http: {
            requestUri: "/ListApplications",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              accountID: {},
              filters: {
                type: "structure",
                members: {
                  applicationIDs: {
                    type: "list",
                    member: {}
                  },
                  isArchived: {
                    type: "boolean"
                  },
                  waveIDs: {
                    shape: "S5r"
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  shape: "S4"
                }
              },
              nextToken: {}
            }
          }
        },
        ListConnectors: {
          http: {
            requestUri: "/ListConnectors",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              filters: {
                type: "structure",
                members: {
                  connectorIDs: {
                    type: "list",
                    member: {}
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  shape: "S2f"
                }
              },
              nextToken: {}
            }
          }
        },
        ListExportErrors: {
          http: {
            requestUri: "/ListExportErrors",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "exportID"
            ],
            members: {
              exportID: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    errorData: {
                      type: "structure",
                      members: {
                        rawError: {}
                      }
                    },
                    errorDateTime: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListExports: {
          http: {
            requestUri: "/ListExports",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              filters: {
                type: "structure",
                members: {
                  exportIDs: {
                    type: "list",
                    member: {}
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  shape: "S6a"
                }
              },
              nextToken: {}
            }
          }
        },
        ListImportErrors: {
          http: {
            requestUri: "/ListImportErrors",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "importID"
            ],
            members: {
              importID: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    errorData: {
                      type: "structure",
                      members: {
                        accountID: {},
                        applicationID: {},
                        ec2LaunchTemplateID: {},
                        rawError: {},
                        rowNumber: {
                          type: "long"
                        },
                        sourceServerID: {},
                        waveID: {}
                      }
                    },
                    errorDateTime: {},
                    errorType: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListImports: {
          http: {
            requestUri: "/ListImports",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              filters: {
                type: "structure",
                members: {
                  importIDs: {
                    type: "list",
                    member: {}
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  shape: "S6r"
                }
              },
              nextToken: {}
            }
          }
        },
        ListManagedAccounts: {
          http: {
            requestUri: "/ListManagedAccounts",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "items"
            ],
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    accountId: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSourceServerActions: {
          http: {
            requestUri: "/ListSourceServerActions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              accountID: {},
              filters: {
                type: "structure",
                members: {
                  actionIDs: {
                    shape: "S74"
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              sourceServerID: {}
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  shape: "S78"
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Se"
              }
            }
          }
        },
        ListTemplateActions: {
          http: {
            requestUri: "/ListTemplateActions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "launchConfigurationTemplateID"
            ],
            members: {
              filters: {
                type: "structure",
                members: {
                  actionIDs: {
                    shape: "S74"
                  }
                }
              },
              launchConfigurationTemplateID: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  shape: "S7k"
                }
              },
              nextToken: {}
            }
          }
        },
        ListWaves: {
          http: {
            requestUri: "/ListWaves",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              accountID: {},
              filters: {
                type: "structure",
                members: {
                  isArchived: {
                    type: "boolean"
                  },
                  waveIDs: {
                    shape: "S5r"
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  shape: "Sj"
                }
              },
              nextToken: {}
            }
          }
        },
        MarkAsArchived: {
          http: {
            requestUri: "/MarkAsArchived",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              accountID: {},
              sourceServerID: {}
            }
          },
          output: {
            shape: "Sz"
          }
        },
        PauseReplication: {
          http: {
            requestUri: "/PauseReplication",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              accountID: {},
              sourceServerID: {}
            }
          },
          output: {
            shape: "Sz"
          }
        },
        PutSourceServerAction: {
          http: {
            requestUri: "/PutSourceServerAction",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "actionID",
              "actionName",
              "documentIdentifier",
              "order",
              "sourceServerID"
            ],
            members: {
              accountID: {},
              actionID: {},
              actionName: {},
              active: {
                type: "boolean"
              },
              category: {},
              description: {},
              documentIdentifier: {},
              documentVersion: {},
              externalParameters: {
                shape: "S2u"
              },
              mustSucceedForCutover: {
                type: "boolean"
              },
              order: {
                type: "integer"
              },
              parameters: {
                shape: "S2y"
              },
              sourceServerID: {},
              timeoutSeconds: {
                type: "integer"
              }
            }
          },
          output: {
            shape: "S78"
          }
        },
        PutTemplateAction: {
          http: {
            requestUri: "/PutTemplateAction",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "actionID",
              "actionName",
              "documentIdentifier",
              "launchConfigurationTemplateID",
              "order"
            ],
            members: {
              actionID: {},
              actionName: {},
              active: {
                type: "boolean"
              },
              category: {},
              description: {},
              documentIdentifier: {},
              documentVersion: {},
              externalParameters: {
                shape: "S2u"
              },
              launchConfigurationTemplateID: {},
              mustSucceedForCutover: {
                type: "boolean"
              },
              operatingSystem: {},
              order: {
                type: "integer"
              },
              parameters: {
                shape: "S2y"
              },
              timeoutSeconds: {
                type: "integer"
              }
            }
          },
          output: {
            shape: "S7k"
          }
        },
        RemoveSourceServerAction: {
          http: {
            requestUri: "/RemoveSourceServerAction",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "actionID",
              "sourceServerID"
            ],
            members: {
              accountID: {},
              actionID: {},
              sourceServerID: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RemoveTemplateAction: {
          http: {
            requestUri: "/RemoveTemplateAction",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "actionID",
              "launchConfigurationTemplateID"
            ],
            members: {
              actionID: {},
              launchConfigurationTemplateID: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ResumeReplication: {
          http: {
            requestUri: "/ResumeReplication",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              accountID: {},
              sourceServerID: {}
            }
          },
          output: {
            shape: "Sz"
          }
        },
        RetryDataReplication: {
          http: {
            requestUri: "/RetryDataReplication",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              accountID: {},
              sourceServerID: {}
            }
          },
          output: {
            shape: "Sz"
          }
        },
        StartCutover: {
          http: {
            requestUri: "/StartCutover",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "sourceServerIDs"
            ],
            members: {
              accountID: {},
              sourceServerIDs: {
                type: "list",
                member: {}
              },
              tags: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              job: {
                shape: "S4b"
              }
            }
          }
        },
        StartExport: {
          http: {
            requestUri: "/StartExport",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "s3Bucket",
              "s3Key"
            ],
            members: {
              s3Bucket: {},
              s3BucketOwner: {},
              s3Key: {}
            }
          },
          output: {
            type: "structure",
            members: {
              exportTask: {
                shape: "S6a"
              }
            }
          }
        },
        StartImport: {
          http: {
            requestUri: "/StartImport",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "s3BucketSource"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              s3BucketSource: {
                shape: "S6s"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              importTask: {
                shape: "S6r"
              }
            }
          }
        },
        StartReplication: {
          http: {
            requestUri: "/StartReplication",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              accountID: {},
              sourceServerID: {}
            }
          },
          output: {
            shape: "Sz"
          }
        },
        StartTest: {
          http: {
            requestUri: "/StartTest",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "sourceServerIDs"
            ],
            members: {
              accountID: {},
              sourceServerIDs: {
                type: "list",
                member: {}
              },
              tags: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              job: {
                shape: "S4b"
              }
            }
          }
        },
        StopReplication: {
          http: {
            requestUri: "/StopReplication",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              accountID: {},
              sourceServerID: {}
            }
          },
          output: {
            shape: "Sz"
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Se"
              }
            }
          },
          idempotent: true
        },
        TerminateTargetInstances: {
          http: {
            requestUri: "/TerminateTargetInstances",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "sourceServerIDs"
            ],
            members: {
              accountID: {},
              sourceServerIDs: {
                type: "list",
                member: {}
              },
              tags: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              job: {
                shape: "S4b"
              }
            }
          }
        },
        UnarchiveApplication: {
          http: {
            requestUri: "/UnarchiveApplication",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationID"
            ],
            members: {
              accountID: {},
              applicationID: {}
            }
          },
          output: {
            shape: "S4"
          }
        },
        UnarchiveWave: {
          http: {
            requestUri: "/UnarchiveWave",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "waveID"
            ],
            members: {
              accountID: {},
              waveID: {}
            }
          },
          output: {
            shape: "Sj"
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {},
                sensitive: true
              }
            }
          },
          idempotent: true
        },
        UpdateApplication: {
          http: {
            requestUri: "/UpdateApplication",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationID"
            ],
            members: {
              accountID: {},
              applicationID: {},
              description: {},
              name: {}
            }
          },
          output: {
            shape: "S4"
          },
          idempotent: true
        },
        UpdateConnector: {
          http: {
            requestUri: "/UpdateConnector",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "connectorID"
            ],
            members: {
              connectorID: {},
              name: {},
              ssmCommandConfig: {
                shape: "S2b"
              }
            }
          },
          output: {
            shape: "S2f"
          },
          idempotent: true
        },
        UpdateLaunchConfiguration: {
          http: {
            requestUri: "/UpdateLaunchConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              accountID: {},
              bootMode: {},
              copyPrivateIp: {
                type: "boolean"
              },
              copyTags: {
                type: "boolean"
              },
              enableMapAutoTagging: {
                type: "boolean"
              },
              launchDisposition: {},
              licensing: {
                shape: "S2o"
              },
              mapAutoTaggingMpeID: {},
              name: {},
              postLaunchActions: {
                shape: "S2p"
              },
              sourceServerID: {},
              targetInstanceTypeRightSizingMethod: {}
            }
          },
          output: {
            shape: "S5f"
          },
          idempotent: true
        },
        UpdateLaunchConfigurationTemplate: {
          http: {
            requestUri: "/UpdateLaunchConfigurationTemplate",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "launchConfigurationTemplateID"
            ],
            members: {
              associatePublicIpAddress: {
                type: "boolean"
              },
              bootMode: {},
              copyPrivateIp: {
                type: "boolean"
              },
              copyTags: {
                type: "boolean"
              },
              enableMapAutoTagging: {
                type: "boolean"
              },
              largeVolumeConf: {
                shape: "S2j"
              },
              launchConfigurationTemplateID: {},
              launchDisposition: {},
              licensing: {
                shape: "S2o"
              },
              mapAutoTaggingMpeID: {},
              postLaunchActions: {
                shape: "S2p"
              },
              smallVolumeConf: {
                shape: "S2j"
              },
              smallVolumeMaxSize: {
                type: "long"
              },
              targetInstanceTypeRightSizingMethod: {}
            }
          },
          output: {
            shape: "S36"
          }
        },
        UpdateReplicationConfiguration: {
          http: {
            requestUri: "/UpdateReplicationConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              accountID: {},
              associateDefaultSecurityGroup: {
                type: "boolean"
              },
              bandwidthThrottling: {
                type: "long"
              },
              createPublicIP: {
                type: "boolean"
              },
              dataPlaneRouting: {},
              defaultLargeStagingDiskType: {},
              ebsEncryption: {},
              ebsEncryptionKeyArn: {},
              name: {},
              replicatedDisks: {
                shape: "S5j"
              },
              replicationServerInstanceType: {},
              replicationServersSecurityGroupsIDs: {
                shape: "S3e"
              },
              sourceServerID: {},
              stagingAreaSubnetId: {},
              stagingAreaTags: {
                shape: "Se"
              },
              useDedicatedReplicationServer: {
                type: "boolean"
              },
              useFipsEndpoint: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S5i"
          },
          idempotent: true
        },
        UpdateReplicationConfigurationTemplate: {
          http: {
            requestUri: "/UpdateReplicationConfigurationTemplate",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "replicationConfigurationTemplateID"
            ],
            members: {
              arn: {},
              associateDefaultSecurityGroup: {
                type: "boolean"
              },
              bandwidthThrottling: {
                type: "long"
              },
              createPublicIP: {
                type: "boolean"
              },
              dataPlaneRouting: {},
              defaultLargeStagingDiskType: {},
              ebsEncryption: {},
              ebsEncryptionKeyArn: {},
              replicationConfigurationTemplateID: {},
              replicationServerInstanceType: {},
              replicationServersSecurityGroupsIDs: {
                shape: "S3e"
              },
              stagingAreaSubnetId: {},
              stagingAreaTags: {
                shape: "Se"
              },
              useDedicatedReplicationServer: {
                type: "boolean"
              },
              useFipsEndpoint: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S3h"
          }
        },
        UpdateSourceServer: {
          http: {
            requestUri: "/UpdateSourceServer",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              accountID: {},
              connectorAction: {
                shape: "S10"
              },
              sourceServerID: {}
            }
          },
          output: {
            shape: "Sz"
          },
          idempotent: true
        },
        UpdateSourceServerReplicationType: {
          http: {
            requestUri: "/UpdateSourceServerReplicationType",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "replicationType",
              "sourceServerID"
            ],
            members: {
              accountID: {},
              replicationType: {},
              sourceServerID: {}
            }
          },
          output: {
            shape: "Sz"
          }
        },
        UpdateWave: {
          http: {
            requestUri: "/UpdateWave",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "waveID"
            ],
            members: {
              accountID: {},
              description: {},
              name: {},
              waveID: {}
            }
          },
          output: {
            shape: "Sj"
          },
          idempotent: true
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            applicationAggregatedStatus: {
              type: "structure",
              members: {
                healthStatus: {},
                lastUpdateDateTime: {},
                progressStatus: {},
                totalSourceServers: {
                  type: "long"
                }
              }
            },
            applicationID: {},
            arn: {},
            creationDateTime: {},
            description: {},
            isArchived: {
              type: "boolean"
            },
            lastModifiedDateTime: {},
            name: {},
            tags: {
              shape: "Se"
            },
            waveID: {}
          }
        },
        Se: {
          type: "map",
          key: {},
          value: {},
          sensitive: true
        },
        Sj: {
          type: "structure",
          members: {
            arn: {},
            creationDateTime: {},
            description: {},
            isArchived: {
              type: "boolean"
            },
            lastModifiedDateTime: {},
            name: {},
            tags: {
              shape: "Se"
            },
            waveAggregatedStatus: {
              type: "structure",
              members: {
                healthStatus: {},
                lastUpdateDateTime: {},
                progressStatus: {},
                replicationStartedDateTime: {},
                totalApplications: {
                  type: "long"
                }
              }
            },
            waveID: {}
          }
        },
        Sq: {
          type: "list",
          member: {}
        },
        Sz: {
          type: "structure",
          members: {
            applicationID: {},
            arn: {},
            connectorAction: {
              shape: "S10"
            },
            dataReplicationInfo: {
              type: "structure",
              members: {
                dataReplicationError: {
                  type: "structure",
                  members: {
                    error: {},
                    rawError: {}
                  }
                },
                dataReplicationInitiation: {
                  type: "structure",
                  members: {
                    nextAttemptDateTime: {},
                    startDateTime: {},
                    steps: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          status: {}
                        }
                      }
                    }
                  }
                },
                dataReplicationState: {},
                etaDateTime: {},
                lagDuration: {},
                lastSnapshotDateTime: {},
                replicatedDisks: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      backloggedStorageBytes: {
                        type: "long"
                      },
                      deviceName: {},
                      replicatedStorageBytes: {
                        type: "long"
                      },
                      rescannedStorageBytes: {
                        type: "long"
                      },
                      totalStorageBytes: {
                        type: "long"
                      }
                    }
                  }
                }
              }
            },
            fqdnForActionFramework: {},
            isArchived: {
              type: "boolean"
            },
            launchedInstance: {
              type: "structure",
              members: {
                ec2InstanceID: {},
                firstBoot: {},
                jobID: {}
              }
            },
            lifeCycle: {
              type: "structure",
              members: {
                addedToServiceDateTime: {},
                elapsedReplicationDuration: {},
                firstByteDateTime: {},
                lastCutover: {
                  type: "structure",
                  members: {
                    finalized: {
                      type: "structure",
                      members: {
                        apiCallDateTime: {}
                      }
                    },
                    initiated: {
                      type: "structure",
                      members: {
                        apiCallDateTime: {},
                        jobID: {}
                      }
                    },
                    reverted: {
                      type: "structure",
                      members: {
                        apiCallDateTime: {}
                      }
                    }
                  }
                },
                lastSeenByServiceDateTime: {},
                lastTest: {
                  type: "structure",
                  members: {
                    finalized: {
                      type: "structure",
                      members: {
                        apiCallDateTime: {}
                      }
                    },
                    initiated: {
                      type: "structure",
                      members: {
                        apiCallDateTime: {},
                        jobID: {}
                      }
                    },
                    reverted: {
                      type: "structure",
                      members: {
                        apiCallDateTime: {}
                      }
                    }
                  }
                },
                state: {}
              }
            },
            replicationType: {},
            sourceProperties: {
              type: "structure",
              members: {
                cpus: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      cores: {
                        type: "long"
                      },
                      modelName: {}
                    }
                  }
                },
                disks: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      bytes: {
                        type: "long"
                      },
                      deviceName: {}
                    }
                  }
                },
                identificationHints: {
                  type: "structure",
                  members: {
                    awsInstanceID: {},
                    fqdn: {},
                    hostname: {},
                    vmPath: {},
                    vmWareUuid: {}
                  }
                },
                lastUpdatedDateTime: {},
                networkInterfaces: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      ips: {
                        type: "list",
                        member: {}
                      },
                      isPrimary: {
                        type: "boolean"
                      },
                      macAddress: {}
                    }
                  }
                },
                os: {
                  type: "structure",
                  members: {
                    fullString: {}
                  }
                },
                ramBytes: {
                  type: "long"
                },
                recommendedInstanceType: {}
              }
            },
            sourceServerID: {},
            tags: {
              shape: "Se"
            },
            userProvidedID: {},
            vcenterClientID: {}
          }
        },
        S10: {
          type: "structure",
          members: {
            connectorArn: {},
            credentialsSecretArn: {}
          }
        },
        S2b: {
          type: "structure",
          required: [
            "cloudWatchOutputEnabled",
            "s3OutputEnabled"
          ],
          members: {
            cloudWatchLogGroupName: {},
            cloudWatchOutputEnabled: {
              type: "boolean"
            },
            outputS3BucketName: {},
            s3OutputEnabled: {
              type: "boolean"
            }
          }
        },
        S2f: {
          type: "structure",
          members: {
            arn: {},
            connectorID: {},
            name: {},
            ssmCommandConfig: {
              shape: "S2b"
            },
            ssmInstanceID: {},
            tags: {
              shape: "Se"
            }
          }
        },
        S2j: {
          type: "structure",
          members: {
            iops: {
              type: "long"
            },
            throughput: {
              type: "long"
            },
            volumeType: {}
          }
        },
        S2o: {
          type: "structure",
          members: {
            osByol: {
              type: "boolean"
            }
          }
        },
        S2p: {
          type: "structure",
          members: {
            cloudWatchLogGroupName: {},
            deployment: {},
            s3LogBucket: {},
            s3OutputKeyPrefix: {},
            ssmDocuments: {
              type: "list",
              member: {
                shape: "S2t"
              }
            }
          }
        },
        S2t: {
          type: "structure",
          required: [
            "actionName",
            "ssmDocumentName"
          ],
          members: {
            actionName: {},
            externalParameters: {
              shape: "S2u"
            },
            mustSucceedForCutover: {
              type: "boolean"
            },
            parameters: {
              shape: "S2y"
            },
            ssmDocumentName: {},
            timeoutSeconds: {
              type: "integer"
            }
          }
        },
        S2u: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              dynamicPath: {}
            },
            union: true
          }
        },
        S2y: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {
              type: "structure",
              required: [
                "parameterName",
                "parameterType"
              ],
              members: {
                parameterName: {},
                parameterType: {}
              }
            }
          }
        },
        S36: {
          type: "structure",
          required: [
            "launchConfigurationTemplateID"
          ],
          members: {
            arn: {},
            associatePublicIpAddress: {
              type: "boolean"
            },
            bootMode: {},
            copyPrivateIp: {
              type: "boolean"
            },
            copyTags: {
              type: "boolean"
            },
            ec2LaunchTemplateID: {},
            enableMapAutoTagging: {
              type: "boolean"
            },
            largeVolumeConf: {
              shape: "S2j"
            },
            launchConfigurationTemplateID: {},
            launchDisposition: {},
            licensing: {
              shape: "S2o"
            },
            mapAutoTaggingMpeID: {},
            postLaunchActions: {
              shape: "S2p"
            },
            smallVolumeConf: {
              shape: "S2j"
            },
            smallVolumeMaxSize: {
              type: "long"
            },
            tags: {
              shape: "Se"
            },
            targetInstanceTypeRightSizingMethod: {}
          }
        },
        S3e: {
          type: "list",
          member: {}
        },
        S3h: {
          type: "structure",
          required: [
            "replicationConfigurationTemplateID"
          ],
          members: {
            arn: {},
            associateDefaultSecurityGroup: {
              type: "boolean"
            },
            bandwidthThrottling: {
              type: "long"
            },
            createPublicIP: {
              type: "boolean"
            },
            dataPlaneRouting: {},
            defaultLargeStagingDiskType: {},
            ebsEncryption: {},
            ebsEncryptionKeyArn: {},
            replicationConfigurationTemplateID: {},
            replicationServerInstanceType: {},
            replicationServersSecurityGroupsIDs: {
              shape: "S3e"
            },
            stagingAreaSubnetId: {},
            stagingAreaTags: {
              shape: "Se"
            },
            tags: {
              shape: "Se"
            },
            useDedicatedReplicationServer: {
              type: "boolean"
            },
            useFipsEndpoint: {
              type: "boolean"
            }
          }
        },
        S4b: {
          type: "structure",
          required: [
            "jobID"
          ],
          members: {
            arn: {},
            creationDateTime: {},
            endDateTime: {},
            initiatedBy: {},
            jobID: {},
            participatingServers: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "sourceServerID"
                ],
                members: {
                  launchStatus: {},
                  launchedEc2InstanceID: {},
                  postLaunchActionsStatus: {
                    type: "structure",
                    members: {
                      postLaunchActionsLaunchStatusList: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            executionID: {},
                            executionStatus: {},
                            failureReason: {},
                            ssmDocument: {
                              shape: "S2t"
                            },
                            ssmDocumentType: {}
                          }
                        }
                      },
                      ssmAgentDiscoveryDatetime: {}
                    }
                  },
                  sourceServerID: {}
                }
              }
            },
            status: {},
            tags: {
              shape: "Se"
            },
            type: {}
          }
        },
        S5f: {
          type: "structure",
          members: {
            bootMode: {},
            copyPrivateIp: {
              type: "boolean"
            },
            copyTags: {
              type: "boolean"
            },
            ec2LaunchTemplateID: {},
            enableMapAutoTagging: {
              type: "boolean"
            },
            launchDisposition: {},
            licensing: {
              shape: "S2o"
            },
            mapAutoTaggingMpeID: {},
            name: {},
            postLaunchActions: {
              shape: "S2p"
            },
            sourceServerID: {},
            targetInstanceTypeRightSizingMethod: {}
          }
        },
        S5i: {
          type: "structure",
          members: {
            associateDefaultSecurityGroup: {
              type: "boolean"
            },
            bandwidthThrottling: {
              type: "long"
            },
            createPublicIP: {
              type: "boolean"
            },
            dataPlaneRouting: {},
            defaultLargeStagingDiskType: {},
            ebsEncryption: {},
            ebsEncryptionKeyArn: {},
            name: {},
            replicatedDisks: {
              shape: "S5j"
            },
            replicationServerInstanceType: {},
            replicationServersSecurityGroupsIDs: {
              shape: "S3e"
            },
            sourceServerID: {},
            stagingAreaSubnetId: {},
            stagingAreaTags: {
              shape: "Se"
            },
            useDedicatedReplicationServer: {
              type: "boolean"
            },
            useFipsEndpoint: {
              type: "boolean"
            }
          }
        },
        S5j: {
          type: "list",
          member: {
            type: "structure",
            members: {
              deviceName: {},
              iops: {
                type: "long"
              },
              isBootDisk: {
                type: "boolean"
              },
              stagingDiskType: {},
              throughput: {
                type: "long"
              }
            }
          }
        },
        S5r: {
          type: "list",
          member: {}
        },
        S6a: {
          type: "structure",
          members: {
            creationDateTime: {},
            endDateTime: {},
            exportID: {},
            progressPercentage: {
              type: "float"
            },
            s3Bucket: {},
            s3BucketOwner: {},
            s3Key: {},
            status: {},
            summary: {
              type: "structure",
              members: {
                applicationsCount: {
                  type: "long"
                },
                serversCount: {
                  type: "long"
                },
                wavesCount: {
                  type: "long"
                }
              }
            }
          }
        },
        S6r: {
          type: "structure",
          members: {
            creationDateTime: {},
            endDateTime: {},
            importID: {},
            progressPercentage: {
              type: "float"
            },
            s3BucketSource: {
              shape: "S6s"
            },
            status: {},
            summary: {
              type: "structure",
              members: {
                applications: {
                  type: "structure",
                  members: {
                    createdCount: {
                      type: "long"
                    },
                    modifiedCount: {
                      type: "long"
                    }
                  }
                },
                servers: {
                  type: "structure",
                  members: {
                    createdCount: {
                      type: "long"
                    },
                    modifiedCount: {
                      type: "long"
                    }
                  }
                },
                waves: {
                  type: "structure",
                  members: {
                    createdCount: {
                      type: "long"
                    },
                    modifiedCount: {
                      type: "long"
                    }
                  }
                }
              }
            }
          }
        },
        S6s: {
          type: "structure",
          required: [
            "s3Bucket",
            "s3Key"
          ],
          members: {
            s3Bucket: {},
            s3BucketOwner: {},
            s3Key: {}
          }
        },
        S74: {
          type: "list",
          member: {}
        },
        S78: {
          type: "structure",
          members: {
            actionID: {},
            actionName: {},
            active: {
              type: "boolean"
            },
            category: {},
            description: {},
            documentIdentifier: {},
            documentVersion: {},
            externalParameters: {
              shape: "S2u"
            },
            mustSucceedForCutover: {
              type: "boolean"
            },
            order: {
              type: "integer"
            },
            parameters: {
              shape: "S2y"
            },
            timeoutSeconds: {
              type: "integer"
            }
          }
        },
        S7k: {
          type: "structure",
          members: {
            actionID: {},
            actionName: {},
            active: {
              type: "boolean"
            },
            category: {},
            description: {},
            documentIdentifier: {},
            documentVersion: {},
            externalParameters: {
              shape: "S2u"
            },
            mustSucceedForCutover: {
              type: "boolean"
            },
            operatingSystem: {},
            order: {
              type: "integer"
            },
            parameters: {
              shape: "S2y"
            },
            timeoutSeconds: {
              type: "integer"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/mgn-2020-02-26.paginators.json
var require_mgn_2020_02_26_paginators = __commonJS({
  "node_modules/aws-sdk/apis/mgn-2020-02-26.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeJobLogItems: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        DescribeJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        DescribeLaunchConfigurationTemplates: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        DescribeReplicationConfigurationTemplates: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        DescribeSourceServers: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        DescribeVcenterClients: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListApplications: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListConnectors: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListExportErrors: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListExports: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListImportErrors: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListImports: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListManagedAccounts: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListSourceServerActions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListTemplateActions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListWaves: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/mgn.js
var require_mgn = __commonJS({
  "node_modules/aws-sdk/clients/mgn.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["mgn"] = {};
    AWS2.Mgn = Service.defineService("mgn", ["2020-02-26"]);
    Object.defineProperty(apiLoader.services["mgn"], "2020-02-26", {
      get: function get() {
        var model = require_mgn_2020_02_26_min();
        model.paginators = require_mgn_2020_02_26_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Mgn;
  }
});

// node_modules/aws-sdk/apis/lookoutequipment-2020-12-15.min.json
var require_lookoutequipment_2020_12_15_min = __commonJS({
  "node_modules/aws-sdk/apis/lookoutequipment-2020-12-15.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-12-15",
        endpointPrefix: "lookoutequipment",
        jsonVersion: "1.0",
        protocol: "json",
        serviceAbbreviation: "LookoutEquipment",
        serviceFullName: "Amazon Lookout for Equipment",
        serviceId: "LookoutEquipment",
        signatureVersion: "v4",
        targetPrefix: "AWSLookoutEquipmentFrontendService",
        uid: "lookoutequipment-2020-12-15"
      },
      operations: {
        CreateDataset: {
          input: {
            type: "structure",
            required: [
              "DatasetName",
              "ClientToken"
            ],
            members: {
              DatasetName: {},
              DatasetSchema: {
                shape: "S3"
              },
              ServerSideKmsKeyId: {},
              ClientToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetName: {},
              DatasetArn: {},
              Status: {}
            }
          }
        },
        CreateInferenceScheduler: {
          input: {
            type: "structure",
            required: [
              "ModelName",
              "InferenceSchedulerName",
              "DataUploadFrequency",
              "DataInputConfiguration",
              "DataOutputConfiguration",
              "RoleArn",
              "ClientToken"
            ],
            members: {
              ModelName: {},
              InferenceSchedulerName: {},
              DataDelayOffsetInMinutes: {
                type: "long"
              },
              DataUploadFrequency: {},
              DataInputConfiguration: {
                shape: "Sj"
              },
              DataOutputConfiguration: {
                shape: "Sr"
              },
              RoleArn: {},
              ServerSideKmsKeyId: {},
              ClientToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InferenceSchedulerArn: {},
              InferenceSchedulerName: {},
              Status: {}
            }
          }
        },
        CreateLabel: {
          input: {
            type: "structure",
            required: [
              "LabelGroupName",
              "StartTime",
              "EndTime",
              "Rating",
              "ClientToken"
            ],
            members: {
              LabelGroupName: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Rating: {},
              FaultCode: {},
              Notes: {},
              Equipment: {},
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LabelId: {}
            }
          }
        },
        CreateLabelGroup: {
          input: {
            type: "structure",
            required: [
              "LabelGroupName",
              "ClientToken"
            ],
            members: {
              LabelGroupName: {},
              FaultCodes: {
                shape: "S17"
              },
              ClientToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LabelGroupName: {},
              LabelGroupArn: {}
            }
          }
        },
        CreateModel: {
          input: {
            type: "structure",
            required: [
              "ModelName",
              "DatasetName",
              "ClientToken"
            ],
            members: {
              ModelName: {},
              DatasetName: {},
              DatasetSchema: {
                shape: "S3"
              },
              LabelsInputConfiguration: {
                shape: "S1c"
              },
              ClientToken: {
                idempotencyToken: true
              },
              TrainingDataStartTime: {
                type: "timestamp"
              },
              TrainingDataEndTime: {
                type: "timestamp"
              },
              EvaluationDataStartTime: {
                type: "timestamp"
              },
              EvaluationDataEndTime: {
                type: "timestamp"
              },
              RoleArn: {},
              DataPreProcessingConfiguration: {
                shape: "S1e"
              },
              ServerSideKmsKeyId: {},
              Tags: {
                shape: "S7"
              },
              OffCondition: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ModelArn: {},
              Status: {}
            }
          }
        },
        CreateRetrainingScheduler: {
          input: {
            type: "structure",
            required: [
              "ModelName",
              "RetrainingFrequency",
              "LookbackWindow",
              "ClientToken"
            ],
            members: {
              ModelName: {},
              RetrainingStartDate: {
                type: "timestamp"
              },
              RetrainingFrequency: {},
              LookbackWindow: {},
              PromoteMode: {},
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ModelName: {},
              ModelArn: {},
              Status: {}
            }
          }
        },
        DeleteDataset: {
          input: {
            type: "structure",
            required: [
              "DatasetName"
            ],
            members: {
              DatasetName: {}
            }
          }
        },
        DeleteInferenceScheduler: {
          input: {
            type: "structure",
            required: [
              "InferenceSchedulerName"
            ],
            members: {
              InferenceSchedulerName: {}
            }
          }
        },
        DeleteLabel: {
          input: {
            type: "structure",
            required: [
              "LabelGroupName",
              "LabelId"
            ],
            members: {
              LabelGroupName: {},
              LabelId: {}
            }
          }
        },
        DeleteLabelGroup: {
          input: {
            type: "structure",
            required: [
              "LabelGroupName"
            ],
            members: {
              LabelGroupName: {}
            }
          }
        },
        DeleteModel: {
          input: {
            type: "structure",
            required: [
              "ModelName"
            ],
            members: {
              ModelName: {}
            }
          }
        },
        DeleteResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          }
        },
        DeleteRetrainingScheduler: {
          input: {
            type: "structure",
            required: [
              "ModelName"
            ],
            members: {
              ModelName: {}
            }
          }
        },
        DescribeDataIngestionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              DatasetArn: {},
              IngestionInputConfiguration: {
                shape: "S22"
              },
              RoleArn: {},
              CreatedAt: {
                type: "timestamp"
              },
              Status: {},
              FailedReason: {},
              DataQualitySummary: {
                shape: "S27"
              },
              IngestedFilesSummary: {
                shape: "S2g"
              },
              StatusDetail: {},
              IngestedDataSize: {
                type: "long"
              },
              DataStartTime: {
                type: "timestamp"
              },
              DataEndTime: {
                type: "timestamp"
              },
              SourceDatasetArn: {}
            }
          }
        },
        DescribeDataset: {
          input: {
            type: "structure",
            required: [
              "DatasetName"
            ],
            members: {
              DatasetName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetName: {},
              DatasetArn: {},
              CreatedAt: {
                type: "timestamp"
              },
              LastUpdatedAt: {
                type: "timestamp"
              },
              Status: {},
              Schema: {
                jsonvalue: true
              },
              ServerSideKmsKeyId: {},
              IngestionInputConfiguration: {
                shape: "S22"
              },
              DataQualitySummary: {
                shape: "S27"
              },
              IngestedFilesSummary: {
                shape: "S2g"
              },
              RoleArn: {},
              DataStartTime: {
                type: "timestamp"
              },
              DataEndTime: {
                type: "timestamp"
              },
              SourceDatasetArn: {}
            }
          }
        },
        DescribeInferenceScheduler: {
          input: {
            type: "structure",
            required: [
              "InferenceSchedulerName"
            ],
            members: {
              InferenceSchedulerName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ModelArn: {},
              ModelName: {},
              InferenceSchedulerName: {},
              InferenceSchedulerArn: {},
              Status: {},
              DataDelayOffsetInMinutes: {
                type: "long"
              },
              DataUploadFrequency: {},
              CreatedAt: {
                type: "timestamp"
              },
              UpdatedAt: {
                type: "timestamp"
              },
              DataInputConfiguration: {
                shape: "Sj"
              },
              DataOutputConfiguration: {
                shape: "Sr"
              },
              RoleArn: {},
              ServerSideKmsKeyId: {},
              LatestInferenceResult: {}
            }
          }
        },
        DescribeLabel: {
          input: {
            type: "structure",
            required: [
              "LabelGroupName",
              "LabelId"
            ],
            members: {
              LabelGroupName: {},
              LabelId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LabelGroupName: {},
              LabelGroupArn: {},
              LabelId: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Rating: {},
              FaultCode: {},
              Notes: {},
              Equipment: {},
              CreatedAt: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeLabelGroup: {
          input: {
            type: "structure",
            required: [
              "LabelGroupName"
            ],
            members: {
              LabelGroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LabelGroupName: {},
              LabelGroupArn: {},
              FaultCodes: {
                shape: "S17"
              },
              CreatedAt: {
                type: "timestamp"
              },
              UpdatedAt: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeModel: {
          input: {
            type: "structure",
            required: [
              "ModelName"
            ],
            members: {
              ModelName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ModelName: {},
              ModelArn: {},
              DatasetName: {},
              DatasetArn: {},
              Schema: {
                jsonvalue: true
              },
              LabelsInputConfiguration: {
                shape: "S1c"
              },
              TrainingDataStartTime: {
                type: "timestamp"
              },
              TrainingDataEndTime: {
                type: "timestamp"
              },
              EvaluationDataStartTime: {
                type: "timestamp"
              },
              EvaluationDataEndTime: {
                type: "timestamp"
              },
              RoleArn: {},
              DataPreProcessingConfiguration: {
                shape: "S1e"
              },
              Status: {},
              TrainingExecutionStartTime: {
                type: "timestamp"
              },
              TrainingExecutionEndTime: {
                type: "timestamp"
              },
              FailedReason: {},
              ModelMetrics: {
                jsonvalue: true
              },
              LastUpdatedTime: {
                type: "timestamp"
              },
              CreatedAt: {
                type: "timestamp"
              },
              ServerSideKmsKeyId: {},
              OffCondition: {},
              SourceModelVersionArn: {},
              ImportJobStartTime: {
                type: "timestamp"
              },
              ImportJobEndTime: {
                type: "timestamp"
              },
              ActiveModelVersion: {
                type: "long"
              },
              ActiveModelVersionArn: {},
              ModelVersionActivatedAt: {
                type: "timestamp"
              },
              PreviousActiveModelVersion: {
                type: "long"
              },
              PreviousActiveModelVersionArn: {},
              PreviousModelVersionActivatedAt: {
                type: "timestamp"
              },
              PriorModelMetrics: {
                jsonvalue: true
              },
              LatestScheduledRetrainingFailedReason: {},
              LatestScheduledRetrainingStatus: {},
              LatestScheduledRetrainingModelVersion: {
                type: "long"
              },
              LatestScheduledRetrainingStartTime: {
                type: "timestamp"
              },
              LatestScheduledRetrainingAvailableDataInDays: {
                type: "integer"
              },
              NextScheduledRetrainingStartDate: {
                type: "timestamp"
              },
              AccumulatedInferenceDataStartTime: {
                type: "timestamp"
              },
              AccumulatedInferenceDataEndTime: {
                type: "timestamp"
              },
              RetrainingSchedulerStatus: {}
            }
          }
        },
        DescribeModelVersion: {
          input: {
            type: "structure",
            required: [
              "ModelName",
              "ModelVersion"
            ],
            members: {
              ModelName: {},
              ModelVersion: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ModelName: {},
              ModelArn: {},
              ModelVersion: {
                type: "long"
              },
              ModelVersionArn: {},
              Status: {},
              SourceType: {},
              DatasetName: {},
              DatasetArn: {},
              Schema: {},
              LabelsInputConfiguration: {
                shape: "S1c"
              },
              TrainingDataStartTime: {
                type: "timestamp"
              },
              TrainingDataEndTime: {
                type: "timestamp"
              },
              EvaluationDataStartTime: {
                type: "timestamp"
              },
              EvaluationDataEndTime: {
                type: "timestamp"
              },
              RoleArn: {},
              DataPreProcessingConfiguration: {
                shape: "S1e"
              },
              TrainingExecutionStartTime: {
                type: "timestamp"
              },
              TrainingExecutionEndTime: {
                type: "timestamp"
              },
              FailedReason: {},
              ModelMetrics: {},
              LastUpdatedTime: {
                type: "timestamp"
              },
              CreatedAt: {
                type: "timestamp"
              },
              ServerSideKmsKeyId: {},
              OffCondition: {},
              SourceModelVersionArn: {},
              ImportJobStartTime: {
                type: "timestamp"
              },
              ImportJobEndTime: {
                type: "timestamp"
              },
              ImportedDataSizeInBytes: {
                type: "long"
              },
              PriorModelMetrics: {},
              RetrainingAvailableDataInDays: {
                type: "integer"
              },
              AutoPromotionResult: {},
              AutoPromotionResultReason: {}
            }
          }
        },
        DescribeResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyRevisionId: {},
              ResourcePolicy: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeRetrainingScheduler: {
          input: {
            type: "structure",
            required: [
              "ModelName"
            ],
            members: {
              ModelName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ModelName: {},
              ModelArn: {},
              RetrainingStartDate: {
                type: "timestamp"
              },
              RetrainingFrequency: {},
              LookbackWindow: {},
              Status: {},
              PromoteMode: {},
              CreatedAt: {
                type: "timestamp"
              },
              UpdatedAt: {
                type: "timestamp"
              }
            }
          }
        },
        ImportDataset: {
          input: {
            type: "structure",
            required: [
              "SourceDatasetArn",
              "ClientToken"
            ],
            members: {
              SourceDatasetArn: {},
              DatasetName: {},
              ClientToken: {
                idempotencyToken: true
              },
              ServerSideKmsKeyId: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetName: {},
              DatasetArn: {},
              Status: {},
              JobId: {}
            }
          }
        },
        ImportModelVersion: {
          input: {
            type: "structure",
            required: [
              "SourceModelVersionArn",
              "DatasetName",
              "ClientToken"
            ],
            members: {
              SourceModelVersionArn: {},
              ModelName: {},
              DatasetName: {},
              LabelsInputConfiguration: {
                shape: "S1c"
              },
              ClientToken: {
                idempotencyToken: true
              },
              RoleArn: {},
              ServerSideKmsKeyId: {},
              Tags: {
                shape: "S7"
              },
              InferenceDataImportStrategy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ModelName: {},
              ModelArn: {},
              ModelVersionArn: {},
              ModelVersion: {
                type: "long"
              },
              Status: {}
            }
          }
        },
        ListDataIngestionJobs: {
          input: {
            type: "structure",
            members: {
              DatasetName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Status: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              DataIngestionJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    JobId: {},
                    DatasetName: {},
                    DatasetArn: {},
                    IngestionInputConfiguration: {
                      shape: "S22"
                    },
                    Status: {}
                  }
                }
              }
            }
          }
        },
        ListDatasets: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              DatasetNameBeginsWith: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              DatasetSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DatasetName: {},
                    DatasetArn: {},
                    Status: {},
                    CreatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListInferenceEvents: {
          input: {
            type: "structure",
            required: [
              "InferenceSchedulerName",
              "IntervalStartTime",
              "IntervalEndTime"
            ],
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              InferenceSchedulerName: {},
              IntervalStartTime: {
                type: "timestamp"
              },
              IntervalEndTime: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              InferenceEventSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InferenceSchedulerArn: {},
                    InferenceSchedulerName: {},
                    EventStartTime: {
                      type: "timestamp"
                    },
                    EventEndTime: {
                      type: "timestamp"
                    },
                    Diagnostics: {},
                    EventDurationInSeconds: {
                      type: "long"
                    }
                  }
                }
              }
            }
          }
        },
        ListInferenceExecutions: {
          input: {
            type: "structure",
            required: [
              "InferenceSchedulerName"
            ],
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              InferenceSchedulerName: {},
              DataStartTimeAfter: {
                type: "timestamp"
              },
              DataEndTimeBefore: {
                type: "timestamp"
              },
              Status: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              InferenceExecutionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ModelName: {},
                    ModelArn: {},
                    InferenceSchedulerName: {},
                    InferenceSchedulerArn: {},
                    ScheduledStartTime: {
                      type: "timestamp"
                    },
                    DataStartTime: {
                      type: "timestamp"
                    },
                    DataEndTime: {
                      type: "timestamp"
                    },
                    DataInputConfiguration: {
                      shape: "Sj"
                    },
                    DataOutputConfiguration: {
                      shape: "Sr"
                    },
                    CustomerResultObject: {
                      shape: "S2i"
                    },
                    Status: {},
                    FailedReason: {},
                    ModelVersion: {
                      type: "long"
                    },
                    ModelVersionArn: {}
                  }
                }
              }
            }
          }
        },
        ListInferenceSchedulers: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              InferenceSchedulerNameBeginsWith: {},
              ModelName: {},
              Status: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              InferenceSchedulerSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ModelName: {},
                    ModelArn: {},
                    InferenceSchedulerName: {},
                    InferenceSchedulerArn: {},
                    Status: {},
                    DataDelayOffsetInMinutes: {
                      type: "long"
                    },
                    DataUploadFrequency: {},
                    LatestInferenceResult: {}
                  }
                }
              }
            }
          }
        },
        ListLabelGroups: {
          input: {
            type: "structure",
            members: {
              LabelGroupNameBeginsWith: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              LabelGroupSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LabelGroupName: {},
                    LabelGroupArn: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    UpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListLabels: {
          input: {
            type: "structure",
            required: [
              "LabelGroupName"
            ],
            members: {
              LabelGroupName: {},
              IntervalStartTime: {
                type: "timestamp"
              },
              IntervalEndTime: {
                type: "timestamp"
              },
              FaultCode: {},
              Equipment: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              LabelSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LabelGroupName: {},
                    LabelId: {},
                    LabelGroupArn: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    Rating: {},
                    FaultCode: {},
                    Equipment: {},
                    CreatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListModelVersions: {
          input: {
            type: "structure",
            required: [
              "ModelName"
            ],
            members: {
              ModelName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Status: {},
              SourceType: {},
              CreatedAtEndTime: {
                type: "timestamp"
              },
              CreatedAtStartTime: {
                type: "timestamp"
              },
              MaxModelVersion: {
                type: "long"
              },
              MinModelVersion: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ModelVersionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ModelName: {},
                    ModelArn: {},
                    ModelVersion: {
                      type: "long"
                    },
                    ModelVersionArn: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    Status: {},
                    SourceType: {}
                  }
                }
              }
            }
          }
        },
        ListModels: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Status: {},
              ModelNameBeginsWith: {},
              DatasetNameBeginsWith: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ModelSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ModelName: {},
                    ModelArn: {},
                    DatasetName: {},
                    DatasetArn: {},
                    Status: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    ActiveModelVersion: {
                      type: "long"
                    },
                    ActiveModelVersionArn: {},
                    LatestScheduledRetrainingStatus: {},
                    LatestScheduledRetrainingModelVersion: {
                      type: "long"
                    },
                    LatestScheduledRetrainingStartTime: {
                      type: "timestamp"
                    },
                    NextScheduledRetrainingStartDate: {
                      type: "timestamp"
                    },
                    RetrainingSchedulerStatus: {}
                  }
                }
              }
            }
          }
        },
        ListRetrainingSchedulers: {
          input: {
            type: "structure",
            members: {
              ModelNameBeginsWith: {},
              Status: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RetrainingSchedulerSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ModelName: {},
                    ModelArn: {},
                    Status: {},
                    RetrainingStartDate: {
                      type: "timestamp"
                    },
                    RetrainingFrequency: {},
                    LookbackWindow: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSensorStatistics: {
          input: {
            type: "structure",
            required: [
              "DatasetName"
            ],
            members: {
              DatasetName: {},
              IngestionJobId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SensorStatisticsSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ComponentName: {},
                    SensorName: {},
                    DataExists: {
                      type: "boolean"
                    },
                    MissingValues: {
                      shape: "S4w"
                    },
                    InvalidValues: {
                      shape: "S4w"
                    },
                    InvalidDateEntries: {
                      shape: "S4w"
                    },
                    DuplicateTimestamps: {
                      shape: "S4w"
                    },
                    CategoricalValues: {
                      type: "structure",
                      required: [
                        "Status"
                      ],
                      members: {
                        Status: {},
                        NumberOfCategory: {
                          type: "integer"
                        }
                      }
                    },
                    MultipleOperatingModes: {
                      type: "structure",
                      required: [
                        "Status"
                      ],
                      members: {
                        Status: {}
                      }
                    },
                    LargeTimestampGaps: {
                      type: "structure",
                      required: [
                        "Status"
                      ],
                      members: {
                        Status: {},
                        NumberOfLargeTimestampGaps: {
                          type: "integer"
                        },
                        MaxTimestampGapInDays: {
                          type: "integer"
                        }
                      }
                    },
                    MonotonicValues: {
                      type: "structure",
                      required: [
                        "Status"
                      ],
                      members: {
                        Status: {},
                        Monotonicity: {}
                      }
                    },
                    DataStartTime: {
                      type: "timestamp"
                    },
                    DataEndTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S7"
              }
            }
          }
        },
        PutResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "ResourcePolicy",
              "ClientToken"
            ],
            members: {
              ResourceArn: {},
              ResourcePolicy: {},
              PolicyRevisionId: {},
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceArn: {},
              PolicyRevisionId: {}
            }
          }
        },
        StartDataIngestionJob: {
          input: {
            type: "structure",
            required: [
              "DatasetName",
              "IngestionInputConfiguration",
              "RoleArn",
              "ClientToken"
            ],
            members: {
              DatasetName: {},
              IngestionInputConfiguration: {
                shape: "S22"
              },
              RoleArn: {},
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              Status: {}
            }
          }
        },
        StartInferenceScheduler: {
          input: {
            type: "structure",
            required: [
              "InferenceSchedulerName"
            ],
            members: {
              InferenceSchedulerName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ModelArn: {},
              ModelName: {},
              InferenceSchedulerName: {},
              InferenceSchedulerArn: {},
              Status: {}
            }
          }
        },
        StartRetrainingScheduler: {
          input: {
            type: "structure",
            required: [
              "ModelName"
            ],
            members: {
              ModelName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ModelName: {},
              ModelArn: {},
              Status: {}
            }
          }
        },
        StopInferenceScheduler: {
          input: {
            type: "structure",
            required: [
              "InferenceSchedulerName"
            ],
            members: {
              InferenceSchedulerName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ModelArn: {},
              ModelName: {},
              InferenceSchedulerName: {},
              InferenceSchedulerArn: {},
              Status: {}
            }
          }
        },
        StopRetrainingScheduler: {
          input: {
            type: "structure",
            required: [
              "ModelName"
            ],
            members: {
              ModelName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ModelName: {},
              ModelArn: {},
              Status: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateActiveModelVersion: {
          input: {
            type: "structure",
            required: [
              "ModelName",
              "ModelVersion"
            ],
            members: {
              ModelName: {},
              ModelVersion: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ModelName: {},
              ModelArn: {},
              CurrentActiveVersion: {
                type: "long"
              },
              PreviousActiveVersion: {
                type: "long"
              },
              CurrentActiveVersionArn: {},
              PreviousActiveVersionArn: {}
            }
          }
        },
        UpdateInferenceScheduler: {
          input: {
            type: "structure",
            required: [
              "InferenceSchedulerName"
            ],
            members: {
              InferenceSchedulerName: {},
              DataDelayOffsetInMinutes: {
                type: "long"
              },
              DataUploadFrequency: {},
              DataInputConfiguration: {
                shape: "Sj"
              },
              DataOutputConfiguration: {
                shape: "Sr"
              },
              RoleArn: {}
            }
          }
        },
        UpdateLabelGroup: {
          input: {
            type: "structure",
            required: [
              "LabelGroupName"
            ],
            members: {
              LabelGroupName: {},
              FaultCodes: {
                shape: "S17"
              }
            }
          }
        },
        UpdateModel: {
          input: {
            type: "structure",
            required: [
              "ModelName"
            ],
            members: {
              ModelName: {},
              LabelsInputConfiguration: {
                shape: "S1c"
              },
              RoleArn: {}
            }
          }
        },
        UpdateRetrainingScheduler: {
          input: {
            type: "structure",
            required: [
              "ModelName"
            ],
            members: {
              ModelName: {},
              RetrainingStartDate: {
                type: "timestamp"
              },
              RetrainingFrequency: {},
              LookbackWindow: {},
              PromoteMode: {}
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          members: {
            InlineDataSchema: {
              jsonvalue: true
            }
          }
        },
        S7: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sj: {
          type: "structure",
          members: {
            S3InputConfiguration: {
              type: "structure",
              required: [
                "Bucket"
              ],
              members: {
                Bucket: {},
                Prefix: {}
              }
            },
            InputTimeZoneOffset: {},
            InferenceInputNameConfiguration: {
              type: "structure",
              members: {
                TimestampFormat: {},
                ComponentTimestampDelimiter: {}
              }
            }
          }
        },
        Sr: {
          type: "structure",
          required: [
            "S3OutputConfiguration"
          ],
          members: {
            S3OutputConfiguration: {
              type: "structure",
              required: [
                "Bucket"
              ],
              members: {
                Bucket: {},
                Prefix: {}
              }
            },
            KmsKeyId: {}
          }
        },
        S17: {
          type: "list",
          member: {}
        },
        S1c: {
          type: "structure",
          members: {
            S3InputConfiguration: {
              type: "structure",
              required: [
                "Bucket"
              ],
              members: {
                Bucket: {},
                Prefix: {}
              }
            },
            LabelGroupName: {}
          }
        },
        S1e: {
          type: "structure",
          members: {
            TargetSamplingRate: {}
          }
        },
        S22: {
          type: "structure",
          required: [
            "S3InputConfiguration"
          ],
          members: {
            S3InputConfiguration: {
              type: "structure",
              required: [
                "Bucket"
              ],
              members: {
                Bucket: {},
                Prefix: {},
                KeyPattern: {}
              }
            }
          }
        },
        S27: {
          type: "structure",
          required: [
            "InsufficientSensorData",
            "MissingSensorData",
            "InvalidSensorData",
            "UnsupportedTimestamps",
            "DuplicateTimestamps"
          ],
          members: {
            InsufficientSensorData: {
              type: "structure",
              required: [
                "MissingCompleteSensorData",
                "SensorsWithShortDateRange"
              ],
              members: {
                MissingCompleteSensorData: {
                  type: "structure",
                  required: [
                    "AffectedSensorCount"
                  ],
                  members: {
                    AffectedSensorCount: {
                      type: "integer"
                    }
                  }
                },
                SensorsWithShortDateRange: {
                  type: "structure",
                  required: [
                    "AffectedSensorCount"
                  ],
                  members: {
                    AffectedSensorCount: {
                      type: "integer"
                    }
                  }
                }
              }
            },
            MissingSensorData: {
              type: "structure",
              required: [
                "AffectedSensorCount",
                "TotalNumberOfMissingValues"
              ],
              members: {
                AffectedSensorCount: {
                  type: "integer"
                },
                TotalNumberOfMissingValues: {
                  type: "integer"
                }
              }
            },
            InvalidSensorData: {
              type: "structure",
              required: [
                "AffectedSensorCount",
                "TotalNumberOfInvalidValues"
              ],
              members: {
                AffectedSensorCount: {
                  type: "integer"
                },
                TotalNumberOfInvalidValues: {
                  type: "integer"
                }
              }
            },
            UnsupportedTimestamps: {
              type: "structure",
              required: [
                "TotalNumberOfUnsupportedTimestamps"
              ],
              members: {
                TotalNumberOfUnsupportedTimestamps: {
                  type: "integer"
                }
              }
            },
            DuplicateTimestamps: {
              type: "structure",
              required: [
                "TotalNumberOfDuplicateTimestamps"
              ],
              members: {
                TotalNumberOfDuplicateTimestamps: {
                  type: "integer"
                }
              }
            }
          }
        },
        S2g: {
          type: "structure",
          required: [
            "TotalNumberOfFiles",
            "IngestedNumberOfFiles"
          ],
          members: {
            TotalNumberOfFiles: {
              type: "integer"
            },
            IngestedNumberOfFiles: {
              type: "integer"
            },
            DiscardedFiles: {
              type: "list",
              member: {
                shape: "S2i"
              }
            }
          }
        },
        S2i: {
          type: "structure",
          required: [
            "Bucket",
            "Key"
          ],
          members: {
            Bucket: {},
            Key: {}
          }
        },
        S4w: {
          type: "structure",
          required: [
            "Count",
            "Percentage"
          ],
          members: {
            Count: {
              type: "integer"
            },
            Percentage: {
              type: "float"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/lookoutequipment-2020-12-15.paginators.json
var require_lookoutequipment_2020_12_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/lookoutequipment-2020-12-15.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListDataIngestionJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDatasets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListInferenceEvents: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListInferenceExecutions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListInferenceSchedulers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListLabelGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListLabels: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListModelVersions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListModels: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListRetrainingSchedulers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListSensorStatistics: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/lookoutequipment.js
var require_lookoutequipment = __commonJS({
  "node_modules/aws-sdk/clients/lookoutequipment.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["lookoutequipment"] = {};
    AWS2.LookoutEquipment = Service.defineService("lookoutequipment", ["2020-12-15"]);
    Object.defineProperty(apiLoader.services["lookoutequipment"], "2020-12-15", {
      get: function get() {
        var model = require_lookoutequipment_2020_12_15_min();
        model.paginators = require_lookoutequipment_2020_12_15_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.LookoutEquipment;
  }
});

// node_modules/aws-sdk/apis/nimble-2020-08-01.min.json
var require_nimble_2020_08_01_min = __commonJS({
  "node_modules/aws-sdk/apis/nimble-2020-08-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-08-01",
        endpointPrefix: "nimble",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AmazonNimbleStudio",
        serviceId: "nimble",
        signatureVersion: "v4",
        signingName: "nimble",
        uid: "nimble-2020-08-01"
      },
      operations: {
        AcceptEulas: {
          http: {
            requestUri: "/2020-08-01/studios/{studioId}/eula-acceptances",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "studioId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amz-Client-Token"
              },
              eulaIds: {
                shape: "S3"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              eulaAcceptances: {
                shape: "S6"
              }
            }
          }
        },
        CreateLaunchProfile: {
          http: {
            requestUri: "/2020-08-01/studios/{studioId}/launch-profiles",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ec2SubnetIds",
              "launchProfileProtocolVersions",
              "name",
              "streamConfiguration",
              "studioComponentIds",
              "studioId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amz-Client-Token"
              },
              description: {
                shape: "Sc"
              },
              ec2SubnetIds: {
                shape: "Sd"
              },
              launchProfileProtocolVersions: {
                shape: "Sf"
              },
              name: {
                shape: "Sh"
              },
              streamConfiguration: {
                shape: "Si"
              },
              studioComponentIds: {
                shape: "S15"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              },
              tags: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              launchProfile: {
                shape: "S18"
              }
            }
          }
        },
        CreateStreamingImage: {
          http: {
            requestUri: "/2020-08-01/studios/{studioId}/streaming-images",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ec2ImageId",
              "name",
              "studioId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amz-Client-Token"
              },
              description: {
                shape: "S1k"
              },
              ec2ImageId: {},
              name: {
                shape: "S1m"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              },
              tags: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              streamingImage: {
                shape: "S1o"
              }
            }
          }
        },
        CreateStreamingSession: {
          http: {
            requestUri: "/2020-08-01/studios/{studioId}/streaming-sessions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "launchProfileId",
              "studioId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amz-Client-Token"
              },
              ec2InstanceType: {},
              launchProfileId: {},
              ownedBy: {},
              streamingImageId: {},
              studioId: {
                location: "uri",
                locationName: "studioId"
              },
              tags: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              session: {
                shape: "S1y"
              }
            }
          }
        },
        CreateStreamingSessionStream: {
          http: {
            requestUri: "/2020-08-01/studios/{studioId}/streaming-sessions/{sessionId}/streams",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sessionId",
              "studioId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amz-Client-Token"
              },
              expirationInSeconds: {
                type: "integer"
              },
              sessionId: {
                location: "uri",
                locationName: "sessionId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              stream: {
                shape: "S26"
              }
            }
          },
          idempotent: true
        },
        CreateStudio: {
          http: {
            requestUri: "/2020-08-01/studios",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "adminRoleArn",
              "displayName",
              "studioName",
              "userRoleArn"
            ],
            members: {
              adminRoleArn: {},
              clientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amz-Client-Token"
              },
              displayName: {
                shape: "S2c"
              },
              studioEncryptionConfiguration: {
                shape: "S2d"
              },
              studioName: {},
              tags: {
                shape: "S16"
              },
              userRoleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              studio: {
                shape: "S2i"
              }
            }
          }
        },
        CreateStudioComponent: {
          http: {
            requestUri: "/2020-08-01/studios/{studioId}/studio-components",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "studioId",
              "type"
            ],
            members: {
              clientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amz-Client-Token"
              },
              configuration: {
                shape: "S2n"
              },
              description: {
                shape: "S30"
              },
              ec2SecurityGroupIds: {
                shape: "S31"
              },
              initializationScripts: {
                shape: "S33"
              },
              name: {
                shape: "S38"
              },
              runtimeRoleArn: {},
              scriptParameters: {
                shape: "S39"
              },
              secureInitializationRoleArn: {},
              studioId: {
                location: "uri",
                locationName: "studioId"
              },
              subtype: {},
              tags: {
                shape: "S16"
              },
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              studioComponent: {
                shape: "S3g"
              }
            }
          }
        },
        DeleteLaunchProfile: {
          http: {
            method: "DELETE",
            requestUri: "/2020-08-01/studios/{studioId}/launch-profiles/{launchProfileId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "launchProfileId",
              "studioId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amz-Client-Token"
              },
              launchProfileId: {
                location: "uri",
                locationName: "launchProfileId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              launchProfile: {
                shape: "S18"
              }
            }
          },
          idempotent: true
        },
        DeleteLaunchProfileMember: {
          http: {
            method: "DELETE",
            requestUri: "/2020-08-01/studios/{studioId}/launch-profiles/{launchProfileId}/membership/{principalId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "launchProfileId",
              "principalId",
              "studioId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amz-Client-Token"
              },
              launchProfileId: {
                location: "uri",
                locationName: "launchProfileId"
              },
              principalId: {
                location: "uri",
                locationName: "principalId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteStreamingImage: {
          http: {
            method: "DELETE",
            requestUri: "/2020-08-01/studios/{studioId}/streaming-images/{streamingImageId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "streamingImageId",
              "studioId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amz-Client-Token"
              },
              streamingImageId: {
                location: "uri",
                locationName: "streamingImageId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              streamingImage: {
                shape: "S1o"
              }
            }
          },
          idempotent: true
        },
        DeleteStreamingSession: {
          http: {
            method: "DELETE",
            requestUri: "/2020-08-01/studios/{studioId}/streaming-sessions/{sessionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sessionId",
              "studioId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amz-Client-Token"
              },
              sessionId: {
                location: "uri",
                locationName: "sessionId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              session: {
                shape: "S1y"
              }
            }
          },
          idempotent: true
        },
        DeleteStudio: {
          http: {
            method: "DELETE",
            requestUri: "/2020-08-01/studios/{studioId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "studioId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amz-Client-Token"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "studio"
            ],
            members: {
              studio: {
                shape: "S2i"
              }
            }
          },
          idempotent: true
        },
        DeleteStudioComponent: {
          http: {
            method: "DELETE",
            requestUri: "/2020-08-01/studios/{studioId}/studio-components/{studioComponentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "studioComponentId",
              "studioId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amz-Client-Token"
              },
              studioComponentId: {
                location: "uri",
                locationName: "studioComponentId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              studioComponent: {
                shape: "S3g"
              }
            }
          },
          idempotent: true
        },
        DeleteStudioMember: {
          http: {
            method: "DELETE",
            requestUri: "/2020-08-01/studios/{studioId}/membership/{principalId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "principalId",
              "studioId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amz-Client-Token"
              },
              principalId: {
                location: "uri",
                locationName: "principalId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        GetEula: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/eulas/{eulaId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "eulaId"
            ],
            members: {
              eulaId: {
                location: "uri",
                locationName: "eulaId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              eula: {
                shape: "S40"
              }
            }
          }
        },
        GetLaunchProfile: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/launch-profiles/{launchProfileId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "launchProfileId",
              "studioId"
            ],
            members: {
              launchProfileId: {
                location: "uri",
                locationName: "launchProfileId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              launchProfile: {
                shape: "S18"
              }
            }
          }
        },
        GetLaunchProfileDetails: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/launch-profiles/{launchProfileId}/details",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "launchProfileId",
              "studioId"
            ],
            members: {
              launchProfileId: {
                location: "uri",
                locationName: "launchProfileId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              launchProfile: {
                shape: "S18"
              },
              streamingImages: {
                shape: "S46"
              },
              studioComponentSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    createdAt: {
                      shape: "S8"
                    },
                    createdBy: {},
                    description: {
                      shape: "S30"
                    },
                    name: {
                      shape: "S38"
                    },
                    studioComponentId: {},
                    subtype: {},
                    type: {},
                    updatedAt: {
                      shape: "S8"
                    },
                    updatedBy: {}
                  }
                }
              }
            }
          }
        },
        GetLaunchProfileInitialization: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/launch-profiles/{launchProfileId}/init",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "launchProfileId",
              "launchProfileProtocolVersions",
              "launchPurpose",
              "platform",
              "studioId"
            ],
            members: {
              launchProfileId: {
                location: "uri",
                locationName: "launchProfileId"
              },
              launchProfileProtocolVersions: {
                shape: "S4a",
                location: "querystring",
                locationName: "launchProfileProtocolVersions"
              },
              launchPurpose: {
                location: "querystring",
                locationName: "launchPurpose"
              },
              platform: {
                location: "querystring",
                locationName: "platform"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              launchProfileInitialization: {
                type: "structure",
                members: {
                  activeDirectory: {
                    type: "structure",
                    members: {
                      computerAttributes: {
                        shape: "S2p"
                      },
                      directoryId: {},
                      directoryName: {},
                      dnsIpAddresses: {
                        type: "list",
                        member: {}
                      },
                      organizationalUnitDistinguishedName: {},
                      studioComponentId: {},
                      studioComponentName: {
                        shape: "S38"
                      }
                    }
                  },
                  ec2SecurityGroupIds: {
                    type: "list",
                    member: {}
                  },
                  launchProfileId: {},
                  launchProfileProtocolVersion: {},
                  launchPurpose: {},
                  name: {
                    shape: "Sh"
                  },
                  platform: {},
                  systemInitializationScripts: {
                    shape: "S4i"
                  },
                  userInitializationScripts: {
                    shape: "S4i"
                  }
                }
              }
            }
          }
        },
        GetLaunchProfileMember: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/launch-profiles/{launchProfileId}/membership/{principalId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "launchProfileId",
              "principalId",
              "studioId"
            ],
            members: {
              launchProfileId: {
                location: "uri",
                locationName: "launchProfileId"
              },
              principalId: {
                location: "uri",
                locationName: "principalId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              member: {
                shape: "S4m"
              }
            }
          }
        },
        GetStreamingImage: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/streaming-images/{streamingImageId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "streamingImageId",
              "studioId"
            ],
            members: {
              streamingImageId: {
                location: "uri",
                locationName: "streamingImageId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              streamingImage: {
                shape: "S1o"
              }
            }
          }
        },
        GetStreamingSession: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/streaming-sessions/{sessionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sessionId",
              "studioId"
            ],
            members: {
              sessionId: {
                location: "uri",
                locationName: "sessionId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              session: {
                shape: "S1y"
              }
            }
          }
        },
        GetStreamingSessionBackup: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/streaming-session-backups/{backupId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "backupId",
              "studioId"
            ],
            members: {
              backupId: {
                location: "uri",
                locationName: "backupId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              streamingSessionBackup: {
                shape: "S4u"
              }
            }
          }
        },
        GetStreamingSessionStream: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/streaming-sessions/{sessionId}/streams/{streamId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sessionId",
              "streamId",
              "studioId"
            ],
            members: {
              sessionId: {
                location: "uri",
                locationName: "sessionId"
              },
              streamId: {
                location: "uri",
                locationName: "streamId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              stream: {
                shape: "S26"
              }
            }
          }
        },
        GetStudio: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "studioId"
            ],
            members: {
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "studio"
            ],
            members: {
              studio: {
                shape: "S2i"
              }
            }
          }
        },
        GetStudioComponent: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/studio-components/{studioComponentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "studioComponentId",
              "studioId"
            ],
            members: {
              studioComponentId: {
                location: "uri",
                locationName: "studioComponentId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              studioComponent: {
                shape: "S3g"
              }
            }
          }
        },
        GetStudioMember: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/membership/{principalId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "principalId",
              "studioId"
            ],
            members: {
              principalId: {
                location: "uri",
                locationName: "principalId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              member: {
                shape: "S53"
              }
            }
          }
        },
        ListEulaAcceptances: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/eula-acceptances",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "studioId"
            ],
            members: {
              eulaIds: {
                shape: "S4a",
                location: "querystring",
                locationName: "eulaIds"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              eulaAcceptances: {
                shape: "S6"
              },
              nextToken: {}
            }
          }
        },
        ListEulas: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/eulas",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              eulaIds: {
                shape: "S4a",
                location: "querystring",
                locationName: "eulaIds"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              eulas: {
                type: "list",
                member: {
                  shape: "S40"
                }
              },
              nextToken: {}
            }
          }
        },
        ListLaunchProfileMembers: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/launch-profiles/{launchProfileId}/membership",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "launchProfileId",
              "studioId"
            ],
            members: {
              launchProfileId: {
                location: "uri",
                locationName: "launchProfileId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              members: {
                type: "list",
                member: {
                  shape: "S4m"
                }
              },
              nextToken: {}
            }
          }
        },
        ListLaunchProfiles: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/launch-profiles",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "studioId"
            ],
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              principalId: {
                location: "querystring",
                locationName: "principalId"
              },
              states: {
                location: "querystring",
                locationName: "states",
                type: "list",
                member: {}
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              launchProfiles: {
                type: "list",
                member: {
                  shape: "S18"
                }
              },
              nextToken: {}
            }
          }
        },
        ListStreamingImages: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/streaming-images",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "studioId"
            ],
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              owner: {
                location: "querystring",
                locationName: "owner"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              streamingImages: {
                shape: "S46"
              }
            }
          }
        },
        ListStreamingSessionBackups: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/streaming-session-backups",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "studioId"
            ],
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              ownedBy: {
                location: "querystring",
                locationName: "ownedBy"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              streamingSessionBackups: {
                type: "list",
                member: {
                  shape: "S4u"
                }
              }
            }
          }
        },
        ListStreamingSessions: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/streaming-sessions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "studioId"
            ],
            members: {
              createdBy: {
                location: "querystring",
                locationName: "createdBy"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              ownedBy: {
                location: "querystring",
                locationName: "ownedBy"
              },
              sessionIds: {
                location: "querystring",
                locationName: "sessionIds"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              sessions: {
                type: "list",
                member: {
                  shape: "S1y"
                }
              }
            }
          }
        },
        ListStudioComponents: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/studio-components",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "studioId"
            ],
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              states: {
                location: "querystring",
                locationName: "states",
                type: "list",
                member: {}
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              },
              types: {
                location: "querystring",
                locationName: "types",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              studioComponents: {
                type: "list",
                member: {
                  shape: "S3g"
                }
              }
            }
          }
        },
        ListStudioMembers: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/membership",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "studioId"
            ],
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              members: {
                type: "list",
                member: {
                  shape: "S53"
                }
              },
              nextToken: {}
            }
          }
        },
        ListStudios: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "studios"
            ],
            members: {
              nextToken: {},
              studios: {
                type: "list",
                member: {
                  shape: "S2i"
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S16"
              }
            }
          }
        },
        PutLaunchProfileMembers: {
          http: {
            requestUri: "/2020-08-01/studios/{studioId}/launch-profiles/{launchProfileId}/membership",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "identityStoreId",
              "launchProfileId",
              "members",
              "studioId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amz-Client-Token"
              },
              identityStoreId: {},
              launchProfileId: {
                location: "uri",
                locationName: "launchProfileId"
              },
              members: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "persona",
                    "principalId"
                  ],
                  members: {
                    persona: {},
                    principalId: {}
                  }
                }
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutStudioMembers: {
          http: {
            requestUri: "/2020-08-01/studios/{studioId}/membership",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "identityStoreId",
              "members",
              "studioId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amz-Client-Token"
              },
              identityStoreId: {},
              members: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "persona",
                    "principalId"
                  ],
                  members: {
                    persona: {},
                    principalId: {}
                  }
                }
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartStreamingSession: {
          http: {
            requestUri: "/2020-08-01/studios/{studioId}/streaming-sessions/{sessionId}/start",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sessionId",
              "studioId"
            ],
            members: {
              backupId: {},
              clientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amz-Client-Token"
              },
              sessionId: {
                location: "uri",
                locationName: "sessionId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              session: {
                shape: "S1y"
              }
            }
          },
          idempotent: true
        },
        StartStudioSSOConfigurationRepair: {
          http: {
            method: "PUT",
            requestUri: "/2020-08-01/studios/{studioId}/sso-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "studioId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amz-Client-Token"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "studio"
            ],
            members: {
              studio: {
                shape: "S2i"
              }
            }
          },
          idempotent: true
        },
        StopStreamingSession: {
          http: {
            requestUri: "/2020-08-01/studios/{studioId}/streaming-sessions/{sessionId}/stop",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sessionId",
              "studioId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amz-Client-Token"
              },
              sessionId: {
                location: "uri",
                locationName: "sessionId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              },
              volumeRetentionMode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              session: {
                shape: "S1y"
              }
            }
          },
          idempotent: true
        },
        TagResource: {
          http: {
            requestUri: "/2020-08-01/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/2020-08-01/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                shape: "S4a",
                location: "querystring",
                locationName: "tagKeys"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateLaunchProfile: {
          http: {
            method: "PATCH",
            requestUri: "/2020-08-01/studios/{studioId}/launch-profiles/{launchProfileId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "launchProfileId",
              "studioId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amz-Client-Token"
              },
              description: {
                shape: "Sc"
              },
              launchProfileId: {
                location: "uri",
                locationName: "launchProfileId"
              },
              launchProfileProtocolVersions: {
                shape: "Sf"
              },
              name: {
                shape: "Sh"
              },
              streamConfiguration: {
                shape: "Si"
              },
              studioComponentIds: {
                shape: "S15"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              launchProfile: {
                shape: "S18"
              }
            }
          }
        },
        UpdateLaunchProfileMember: {
          http: {
            method: "PATCH",
            requestUri: "/2020-08-01/studios/{studioId}/launch-profiles/{launchProfileId}/membership/{principalId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "launchProfileId",
              "persona",
              "principalId",
              "studioId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amz-Client-Token"
              },
              launchProfileId: {
                location: "uri",
                locationName: "launchProfileId"
              },
              persona: {},
              principalId: {
                location: "uri",
                locationName: "principalId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              member: {
                shape: "S4m"
              }
            }
          }
        },
        UpdateStreamingImage: {
          http: {
            method: "PATCH",
            requestUri: "/2020-08-01/studios/{studioId}/streaming-images/{streamingImageId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "streamingImageId",
              "studioId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amz-Client-Token"
              },
              description: {
                shape: "S1k"
              },
              name: {
                shape: "S1m"
              },
              streamingImageId: {
                location: "uri",
                locationName: "streamingImageId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              streamingImage: {
                shape: "S1o"
              }
            }
          }
        },
        UpdateStudio: {
          http: {
            method: "PATCH",
            requestUri: "/2020-08-01/studios/{studioId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "studioId"
            ],
            members: {
              adminRoleArn: {},
              clientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amz-Client-Token"
              },
              displayName: {
                shape: "S2c"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              },
              userRoleArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "studio"
            ],
            members: {
              studio: {
                shape: "S2i"
              }
            }
          }
        },
        UpdateStudioComponent: {
          http: {
            method: "PATCH",
            requestUri: "/2020-08-01/studios/{studioId}/studio-components/{studioComponentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "studioComponentId",
              "studioId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amz-Client-Token"
              },
              configuration: {
                shape: "S2n"
              },
              description: {
                shape: "S30"
              },
              ec2SecurityGroupIds: {
                shape: "S31"
              },
              initializationScripts: {
                shape: "S33"
              },
              name: {
                shape: "S38"
              },
              runtimeRoleArn: {},
              scriptParameters: {
                shape: "S39"
              },
              secureInitializationRoleArn: {},
              studioComponentId: {
                location: "uri",
                locationName: "studioComponentId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              },
              subtype: {},
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              studioComponent: {
                shape: "S3g"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {}
        },
        S6: {
          type: "list",
          member: {
            type: "structure",
            members: {
              acceptedAt: {
                shape: "S8"
              },
              acceptedBy: {},
              accepteeId: {},
              eulaAcceptanceId: {},
              eulaId: {}
            }
          }
        },
        S8: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        Sc: {
          type: "string",
          sensitive: true
        },
        Sd: {
          type: "list",
          member: {}
        },
        Sf: {
          type: "list",
          member: {}
        },
        Sh: {
          type: "string",
          sensitive: true
        },
        Si: {
          type: "structure",
          required: [
            "clipboardMode",
            "ec2InstanceTypes",
            "streamingImageIds"
          ],
          members: {
            automaticTerminationMode: {},
            clipboardMode: {},
            ec2InstanceTypes: {
              shape: "Sl"
            },
            maxSessionLengthInMinutes: {
              type: "integer"
            },
            maxStoppedSessionLengthInMinutes: {
              type: "integer"
            },
            sessionBackup: {
              shape: "Sp"
            },
            sessionPersistenceMode: {},
            sessionStorage: {
              shape: "St"
            },
            streamingImageIds: {
              shape: "Sz"
            },
            volumeConfiguration: {
              shape: "S11"
            }
          }
        },
        Sl: {
          type: "list",
          member: {}
        },
        Sp: {
          type: "structure",
          members: {
            maxBackupsToRetain: {
              type: "integer"
            },
            mode: {}
          }
        },
        St: {
          type: "structure",
          required: [
            "mode"
          ],
          members: {
            mode: {
              type: "list",
              member: {}
            },
            root: {
              type: "structure",
              members: {
                linux: {
                  type: "string",
                  sensitive: true
                },
                windows: {
                  type: "string",
                  sensitive: true
                }
              }
            }
          }
        },
        Sz: {
          type: "list",
          member: {}
        },
        S11: {
          type: "structure",
          members: {
            iops: {
              type: "integer"
            },
            size: {
              type: "integer"
            },
            throughput: {
              type: "integer"
            }
          }
        },
        S15: {
          type: "list",
          member: {}
        },
        S16: {
          type: "map",
          key: {},
          value: {}
        },
        S18: {
          type: "structure",
          members: {
            arn: {},
            createdAt: {
              shape: "S8"
            },
            createdBy: {},
            description: {
              shape: "Sc"
            },
            ec2SubnetIds: {
              shape: "Sd"
            },
            launchProfileId: {},
            launchProfileProtocolVersions: {
              shape: "Sf"
            },
            name: {
              shape: "Sh"
            },
            state: {},
            statusCode: {},
            statusMessage: {},
            streamConfiguration: {
              type: "structure",
              required: [
                "clipboardMode",
                "ec2InstanceTypes",
                "streamingImageIds"
              ],
              members: {
                automaticTerminationMode: {},
                clipboardMode: {},
                ec2InstanceTypes: {
                  shape: "Sl"
                },
                maxSessionLengthInMinutes: {
                  type: "integer"
                },
                maxStoppedSessionLengthInMinutes: {
                  type: "integer"
                },
                sessionBackup: {
                  shape: "Sp"
                },
                sessionPersistenceMode: {},
                sessionStorage: {
                  shape: "St"
                },
                streamingImageIds: {
                  shape: "Sz"
                },
                volumeConfiguration: {
                  shape: "S11"
                }
              }
            },
            studioComponentIds: {
              shape: "S15"
            },
            tags: {
              shape: "S16"
            },
            updatedAt: {
              shape: "S8"
            },
            updatedBy: {},
            validationResults: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "state",
                  "statusCode",
                  "statusMessage",
                  "type"
                ],
                members: {
                  state: {},
                  statusCode: {},
                  statusMessage: {},
                  type: {}
                }
              }
            }
          }
        },
        S1k: {
          type: "string",
          sensitive: true
        },
        S1m: {
          type: "string",
          sensitive: true
        },
        S1o: {
          type: "structure",
          members: {
            arn: {},
            description: {
              shape: "S1k"
            },
            ec2ImageId: {},
            encryptionConfiguration: {
              type: "structure",
              required: [
                "keyType"
              ],
              members: {
                keyArn: {},
                keyType: {}
              }
            },
            eulaIds: {
              shape: "S3"
            },
            name: {
              shape: "S1m"
            },
            owner: {},
            platform: {},
            state: {},
            statusCode: {},
            statusMessage: {},
            streamingImageId: {},
            tags: {
              shape: "S16"
            }
          }
        },
        S1y: {
          type: "structure",
          members: {
            arn: {},
            automaticTerminationMode: {},
            backupMode: {},
            createdAt: {
              shape: "S8"
            },
            createdBy: {},
            ec2InstanceType: {},
            launchProfileId: {},
            maxBackupsToRetain: {
              type: "integer"
            },
            ownedBy: {},
            sessionId: {},
            sessionPersistenceMode: {},
            startedAt: {
              shape: "S8"
            },
            startedBy: {},
            startedFromBackupId: {},
            state: {},
            statusCode: {},
            statusMessage: {},
            stopAt: {
              shape: "S8"
            },
            stoppedAt: {
              shape: "S8"
            },
            stoppedBy: {},
            streamingImageId: {},
            tags: {
              shape: "S16"
            },
            terminateAt: {
              shape: "S8"
            },
            updatedAt: {
              shape: "S8"
            },
            updatedBy: {},
            volumeConfiguration: {
              shape: "S11"
            },
            volumeRetentionMode: {}
          }
        },
        S26: {
          type: "structure",
          members: {
            createdAt: {
              shape: "S8"
            },
            createdBy: {},
            expiresAt: {
              shape: "S8"
            },
            ownedBy: {},
            state: {},
            statusCode: {},
            streamId: {},
            url: {
              shape: "S29"
            }
          }
        },
        S29: {
          type: "string",
          sensitive: true
        },
        S2c: {
          type: "string",
          sensitive: true
        },
        S2d: {
          type: "structure",
          required: [
            "keyType"
          ],
          members: {
            keyArn: {},
            keyType: {}
          }
        },
        S2i: {
          type: "structure",
          members: {
            adminRoleArn: {},
            arn: {},
            createdAt: {
              shape: "S8"
            },
            displayName: {
              shape: "S2c"
            },
            homeRegion: {},
            ssoClientId: {},
            state: {},
            statusCode: {},
            statusMessage: {},
            studioEncryptionConfiguration: {
              shape: "S2d"
            },
            studioId: {},
            studioName: {},
            studioUrl: {},
            tags: {
              shape: "S16"
            },
            updatedAt: {
              shape: "S8"
            },
            userRoleArn: {}
          }
        },
        S2n: {
          type: "structure",
          members: {
            activeDirectoryConfiguration: {
              type: "structure",
              members: {
                computerAttributes: {
                  shape: "S2p"
                },
                directoryId: {},
                organizationalUnitDistinguishedName: {}
              }
            },
            computeFarmConfiguration: {
              type: "structure",
              members: {
                activeDirectoryUser: {},
                endpoint: {
                  shape: "S29"
                }
              }
            },
            licenseServiceConfiguration: {
              type: "structure",
              members: {
                endpoint: {
                  shape: "S29"
                }
              }
            },
            sharedFileSystemConfiguration: {
              type: "structure",
              members: {
                endpoint: {
                  shape: "S29"
                },
                fileSystemId: {},
                linuxMountPoint: {
                  type: "string",
                  sensitive: true
                },
                shareName: {
                  shape: "S29"
                },
                windowsMountDrive: {}
              }
            }
          },
          union: true
        },
        S2p: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              value: {}
            }
          },
          sensitive: true
        },
        S30: {
          type: "string",
          sensitive: true
        },
        S31: {
          type: "list",
          member: {}
        },
        S33: {
          type: "list",
          member: {
            type: "structure",
            members: {
              launchProfileProtocolVersion: {},
              platform: {},
              runContext: {},
              script: {
                shape: "S37"
              }
            }
          }
        },
        S37: {
          type: "string",
          sensitive: true
        },
        S38: {
          type: "string",
          sensitive: true
        },
        S39: {
          type: "list",
          member: {
            type: "structure",
            members: {
              key: {},
              value: {}
            }
          },
          sensitive: true
        },
        S3g: {
          type: "structure",
          members: {
            arn: {},
            configuration: {
              shape: "S2n"
            },
            createdAt: {
              shape: "S8"
            },
            createdBy: {},
            description: {
              shape: "S30"
            },
            ec2SecurityGroupIds: {
              shape: "S31"
            },
            initializationScripts: {
              shape: "S33"
            },
            name: {
              shape: "S38"
            },
            runtimeRoleArn: {},
            scriptParameters: {
              shape: "S39"
            },
            secureInitializationRoleArn: {},
            state: {},
            statusCode: {},
            statusMessage: {},
            studioComponentId: {},
            subtype: {},
            tags: {
              shape: "S16"
            },
            type: {},
            updatedAt: {
              shape: "S8"
            },
            updatedBy: {}
          }
        },
        S40: {
          type: "structure",
          members: {
            content: {},
            createdAt: {
              shape: "S8"
            },
            eulaId: {},
            name: {},
            updatedAt: {
              shape: "S8"
            }
          }
        },
        S46: {
          type: "list",
          member: {
            shape: "S1o"
          }
        },
        S4a: {
          type: "list",
          member: {}
        },
        S4i: {
          type: "list",
          member: {
            type: "structure",
            members: {
              runtimeRoleArn: {},
              script: {
                shape: "S37"
              },
              secureInitializationRoleArn: {},
              studioComponentId: {},
              studioComponentName: {
                shape: "S38"
              }
            }
          }
        },
        S4m: {
          type: "structure",
          members: {
            identityStoreId: {},
            persona: {},
            principalId: {},
            sid: {}
          }
        },
        S4u: {
          type: "structure",
          members: {
            arn: {},
            backupId: {},
            createdAt: {
              shape: "S8"
            },
            launchProfileId: {},
            ownedBy: {},
            sessionId: {},
            state: {},
            statusCode: {},
            statusMessage: {},
            tags: {
              shape: "S16"
            }
          }
        },
        S53: {
          type: "structure",
          members: {
            identityStoreId: {},
            persona: {},
            principalId: {},
            sid: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/nimble-2020-08-01.paginators.json
var require_nimble_2020_08_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/nimble-2020-08-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListEulaAcceptances: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "eulaAcceptances"
        },
        ListEulas: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "eulas"
        },
        ListLaunchProfileMembers: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "members"
        },
        ListLaunchProfiles: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "launchProfiles"
        },
        ListStreamingImages: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "streamingImages"
        },
        ListStreamingSessionBackups: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "streamingSessionBackups"
        },
        ListStreamingSessions: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "sessions"
        },
        ListStudioComponents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "studioComponents"
        },
        ListStudioMembers: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "members"
        },
        ListStudios: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "studios"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/nimble-2020-08-01.waiters2.json
var require_nimble_2020_08_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/nimble-2020-08-01.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        LaunchProfileDeleted: {
          description: "Wait until a LaunchProfile is Deleted. Use this after invoking DeleteLaunchProfile",
          delay: 5,
          maxAttempts: 150,
          operation: "GetLaunchProfile",
          acceptors: [{
            matcher: "path",
            argument: "launchProfile.state",
            state: "success",
            expected: "DELETED"
          }, {
            matcher: "path",
            argument: "launchProfile.state",
            state: "failure",
            expected: "DELETE_FAILED"
          }]
        },
        LaunchProfileReady: {
          description: "Wait until a LaunchProfile is Ready. Use this after invoking CreateLaunchProfile or UpdateLaunchProfile",
          delay: 5,
          maxAttempts: 150,
          operation: "GetLaunchProfile",
          acceptors: [{
            matcher: "path",
            argument: "launchProfile.state",
            state: "success",
            expected: "READY"
          }, {
            matcher: "path",
            argument: "launchProfile.state",
            state: "failure",
            expected: "CREATE_FAILED"
          }, {
            matcher: "path",
            argument: "launchProfile.state",
            state: "failure",
            expected: "UPDATE_FAILED"
          }]
        },
        StreamingImageDeleted: {
          description: "Wait until a StreamingImage Deleted. Use this after invoking DeleteStreamingImage",
          delay: 2,
          maxAttempts: 60,
          operation: "GetStreamingImage",
          acceptors: [{
            matcher: "path",
            argument: "streamingImage.state",
            state: "success",
            expected: "DELETED"
          }, {
            matcher: "path",
            argument: "streamingImage.state",
            state: "failure",
            expected: "DELETE_FAILED"
          }]
        },
        StreamingImageReady: {
          description: "Wait until a StreamingImage is Ready. Use this after invoking CreateStreamingImage or UpdateStreamingImage",
          delay: 2,
          maxAttempts: 60,
          operation: "GetStreamingImage",
          acceptors: [{
            matcher: "path",
            argument: "streamingImage.state",
            state: "success",
            expected: "READY"
          }, {
            matcher: "path",
            argument: "streamingImage.state",
            state: "failure",
            expected: "CREATE_FAILED"
          }, {
            matcher: "path",
            argument: "streamingImage.state",
            state: "failure",
            expected: "UPDATE_FAILED"
          }]
        },
        StreamingSessionDeleted: {
          description: "Wait until a StreamingSessionDeleted. Use this after invoking DeleteStreamingSession",
          delay: 5,
          maxAttempts: 180,
          operation: "GetStreamingSession",
          acceptors: [{
            matcher: "path",
            argument: "session.state",
            state: "success",
            expected: "DELETED"
          }, {
            matcher: "path",
            argument: "session.state",
            state: "failure",
            expected: "DELETE_FAILED"
          }]
        },
        StreamingSessionReady: {
          description: "Wait until a StreamingSession is ready. Use this after invoking CreateStreamingSession, StartStreamingSession",
          delay: 10,
          maxAttempts: 180,
          operation: "GetStreamingSession",
          acceptors: [{
            matcher: "path",
            argument: "session.state",
            state: "success",
            expected: "READY"
          }, {
            matcher: "path",
            argument: "session.state",
            state: "failure",
            expected: "CREATE_FAILED"
          }, {
            matcher: "path",
            argument: "session.state",
            state: "failure",
            expected: "START_FAILED"
          }]
        },
        StreamingSessionStopped: {
          description: "Wait until a StreamingSessionStopped. Use this after invoking StopStreamingSession",
          delay: 5,
          maxAttempts: 180,
          operation: "GetStreamingSession",
          acceptors: [{
            matcher: "path",
            argument: "session.state",
            state: "success",
            expected: "STOPPED"
          }, {
            matcher: "path",
            argument: "session.state",
            state: "failure",
            expected: "STOP_FAILED"
          }]
        },
        StreamingSessionStreamReady: {
          description: "Wait until a StreamingSessionStream is ready. Use this after invoking CreateStreamingSessionStream",
          delay: 5,
          maxAttempts: 30,
          operation: "GetStreamingSessionStream",
          acceptors: [{
            matcher: "path",
            argument: "stream.state",
            state: "success",
            expected: "READY"
          }, {
            matcher: "path",
            argument: "stream.state",
            state: "failure",
            expected: "CREATE_FAILED"
          }]
        },
        StudioComponentDeleted: {
          description: "Wait until a StudioComponent Deleted. Use this after invoking DeleteStudioComponent",
          delay: 1,
          maxAttempts: 120,
          operation: "GetStudioComponent",
          acceptors: [{
            matcher: "path",
            argument: "studioComponent.state",
            state: "success",
            expected: "DELETED"
          }, {
            matcher: "path",
            argument: "studioComponent.state",
            state: "failure",
            expected: "DELETE_FAILED"
          }]
        },
        StudioComponentReady: {
          description: "Wait until a StudioComponent is Ready. Use this after invoking CreateStudioComponent or UpdateStudioComponent",
          delay: 2,
          maxAttempts: 60,
          operation: "GetStudioComponent",
          acceptors: [{
            matcher: "path",
            argument: "studioComponent.state",
            state: "success",
            expected: "READY"
          }, {
            matcher: "path",
            argument: "studioComponent.state",
            state: "failure",
            expected: "CREATE_FAILED"
          }, {
            matcher: "path",
            argument: "studioComponent.state",
            state: "failure",
            expected: "UPDATE_FAILED"
          }]
        },
        StudioDeleted: {
          description: "Wait until a Studio is Deleted. Use this after invoking DeleteStudio.",
          delay: 2,
          maxAttempts: 60,
          operation: "GetStudio",
          acceptors: [{
            matcher: "path",
            argument: "studio.state",
            state: "success",
            expected: "DELETED"
          }, {
            matcher: "path",
            argument: "studio.state",
            state: "failure",
            expected: "DELETE_FAILED"
          }]
        },
        StudioReady: {
          description: "Wait until a Studio is Ready. Use this after invoking CreateStudio, UpdateStudio, or StartStudioSSOConfigurationRepair",
          delay: 2,
          maxAttempts: 60,
          operation: "GetStudio",
          acceptors: [{
            matcher: "path",
            argument: "studio.state",
            state: "success",
            expected: "READY"
          }, {
            matcher: "path",
            argument: "studio.state",
            state: "failure",
            expected: "CREATE_FAILED"
          }, {
            matcher: "path",
            argument: "studio.state",
            state: "failure",
            expected: "UPDATE_FAILED"
          }]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/nimble.js
var require_nimble = __commonJS({
  "node_modules/aws-sdk/clients/nimble.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["nimble"] = {};
    AWS2.Nimble = Service.defineService("nimble", ["2020-08-01"]);
    Object.defineProperty(apiLoader.services["nimble"], "2020-08-01", {
      get: function get() {
        var model = require_nimble_2020_08_01_min();
        model.paginators = require_nimble_2020_08_01_paginators().pagination;
        model.waiters = require_nimble_2020_08_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Nimble;
  }
});

// node_modules/aws-sdk/apis/finspace-2021-03-12.min.json
var require_finspace_2021_03_12_min = __commonJS({
  "node_modules/aws-sdk/apis/finspace-2021-03-12.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-03-12",
        endpointPrefix: "finspace",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "finspace",
        serviceFullName: "FinSpace User Environment Management service",
        serviceId: "finspace",
        signatureVersion: "v4",
        signingName: "finspace",
        uid: "finspace-2021-03-12"
      },
      operations: {
        CreateEnvironment: {
          http: {
            requestUri: "/environment"
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              description: {},
              kmsKeyId: {},
              tags: {
                shape: "S5"
              },
              federationMode: {},
              federationParameters: {
                shape: "S9"
              },
              superuserParameters: {
                type: "structure",
                required: [
                  "emailAddress",
                  "firstName",
                  "lastName"
                ],
                members: {
                  emailAddress: {
                    type: "string",
                    sensitive: true
                  },
                  firstName: {},
                  lastName: {}
                }
              },
              dataBundles: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              environmentId: {},
              environmentArn: {},
              environmentUrl: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        CreateKxChangeset: {
          http: {
            requestUri: "/kx/environments/{environmentId}/databases/{databaseName}/changesets"
          },
          input: {
            type: "structure",
            required: [
              "environmentId",
              "databaseName",
              "changeRequests",
              "clientToken"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              databaseName: {
                location: "uri",
                locationName: "databaseName"
              },
              changeRequests: {
                shape: "Ss"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              changesetId: {},
              databaseName: {},
              environmentId: {},
              changeRequests: {
                shape: "Ss"
              },
              createdTimestamp: {
                type: "timestamp"
              },
              lastModifiedTimestamp: {
                type: "timestamp"
              },
              status: {},
              errorInfo: {
                shape: "S12"
              }
            }
          }
        },
        CreateKxCluster: {
          http: {
            requestUri: "/kx/environments/{environmentId}/clusters"
          },
          input: {
            type: "structure",
            required: [
              "environmentId",
              "clusterName",
              "clusterType",
              "releaseLabel",
              "vpcConfiguration",
              "azMode"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              clusterName: {},
              clusterType: {},
              tickerplantLogConfiguration: {
                shape: "S1a"
              },
              databases: {
                shape: "S1d"
              },
              cacheStorageConfigurations: {
                shape: "S1q"
              },
              autoScalingConfiguration: {
                shape: "S1t"
              },
              clusterDescription: {},
              capacityConfiguration: {
                shape: "S1z"
              },
              releaseLabel: {},
              vpcConfiguration: {
                shape: "S22"
              },
              initializationScript: {},
              commandLineArguments: {
                shape: "S2a"
              },
              code: {
                shape: "S2e"
              },
              executionRole: {},
              savedownStorageConfiguration: {
                shape: "S2j"
              },
              azMode: {},
              availabilityZoneId: {},
              tags: {
                shape: "S5"
              },
              scalingGroupConfiguration: {
                shape: "S2o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              environmentId: {},
              status: {},
              statusReason: {},
              clusterName: {},
              clusterType: {},
              tickerplantLogConfiguration: {
                shape: "S1a"
              },
              volumes: {
                shape: "S2w"
              },
              databases: {
                shape: "S1d"
              },
              cacheStorageConfigurations: {
                shape: "S1q"
              },
              autoScalingConfiguration: {
                shape: "S1t"
              },
              clusterDescription: {},
              capacityConfiguration: {
                shape: "S1z"
              },
              releaseLabel: {},
              vpcConfiguration: {
                shape: "S22"
              },
              initializationScript: {},
              commandLineArguments: {
                shape: "S2a"
              },
              code: {
                shape: "S2e"
              },
              executionRole: {},
              lastModifiedTimestamp: {
                type: "timestamp"
              },
              savedownStorageConfiguration: {
                shape: "S2j"
              },
              azMode: {},
              availabilityZoneId: {},
              createdTimestamp: {
                type: "timestamp"
              },
              scalingGroupConfiguration: {
                shape: "S2o"
              }
            }
          }
        },
        CreateKxDatabase: {
          http: {
            requestUri: "/kx/environments/{environmentId}/databases"
          },
          input: {
            type: "structure",
            required: [
              "environmentId",
              "databaseName",
              "clientToken"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              databaseName: {},
              description: {},
              tags: {
                shape: "S5"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              databaseName: {},
              databaseArn: {},
              environmentId: {},
              description: {},
              createdTimestamp: {
                type: "timestamp"
              },
              lastModifiedTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        CreateKxDataview: {
          http: {
            requestUri: "/kx/environments/{environmentId}/databases/{databaseName}/dataviews"
          },
          input: {
            type: "structure",
            required: [
              "environmentId",
              "databaseName",
              "dataviewName",
              "azMode",
              "clientToken"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              databaseName: {
                location: "uri",
                locationName: "databaseName"
              },
              dataviewName: {},
              azMode: {},
              availabilityZoneId: {},
              changesetId: {},
              segmentConfigurations: {
                shape: "S1m"
              },
              autoUpdate: {
                type: "boolean"
              },
              description: {},
              tags: {
                shape: "S5"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              dataviewName: {},
              databaseName: {},
              environmentId: {},
              azMode: {},
              availabilityZoneId: {},
              changesetId: {},
              segmentConfigurations: {
                shape: "S1m"
              },
              description: {},
              autoUpdate: {
                type: "boolean"
              },
              createdTimestamp: {
                type: "timestamp"
              },
              lastModifiedTimestamp: {
                type: "timestamp"
              },
              status: {}
            }
          }
        },
        CreateKxEnvironment: {
          http: {
            requestUri: "/kx/environments"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "kmsKeyId"
            ],
            members: {
              name: {},
              description: {},
              kmsKeyId: {},
              tags: {
                shape: "S5"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              status: {},
              environmentId: {},
              description: {},
              environmentArn: {},
              kmsKeyId: {},
              creationTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        CreateKxScalingGroup: {
          http: {
            requestUri: "/kx/environments/{environmentId}/scalingGroups"
          },
          input: {
            type: "structure",
            required: [
              "clientToken",
              "environmentId",
              "scalingGroupName",
              "hostType",
              "availabilityZoneId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              scalingGroupName: {},
              hostType: {},
              availabilityZoneId: {},
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              environmentId: {},
              scalingGroupName: {},
              hostType: {},
              availabilityZoneId: {},
              status: {},
              lastModifiedTimestamp: {
                type: "timestamp"
              },
              createdTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        CreateKxUser: {
          http: {
            requestUri: "/kx/environments/{environmentId}/users"
          },
          input: {
            type: "structure",
            required: [
              "environmentId",
              "userName",
              "iamRole"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              userName: {},
              iamRole: {},
              tags: {
                shape: "S5"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              userName: {},
              userArn: {},
              environmentId: {},
              iamRole: {}
            }
          }
        },
        CreateKxVolume: {
          http: {
            requestUri: "/kx/environments/{environmentId}/kxvolumes"
          },
          input: {
            type: "structure",
            required: [
              "environmentId",
              "volumeType",
              "volumeName",
              "azMode",
              "availabilityZoneIds"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              volumeType: {},
              volumeName: {},
              description: {},
              nas1Configuration: {
                shape: "S3m"
              },
              azMode: {},
              availabilityZoneIds: {
                shape: "S3p"
              },
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              environmentId: {},
              volumeName: {},
              volumeType: {},
              volumeArn: {},
              nas1Configuration: {
                shape: "S3m"
              },
              status: {},
              statusReason: {},
              azMode: {},
              description: {},
              availabilityZoneIds: {
                shape: "S3p"
              },
              createdTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        DeleteEnvironment: {
          http: {
            method: "DELETE",
            requestUri: "/environment/{environmentId}"
          },
          input: {
            type: "structure",
            required: [
              "environmentId"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        DeleteKxCluster: {
          http: {
            method: "DELETE",
            requestUri: "/kx/environments/{environmentId}/clusters/{clusterName}"
          },
          input: {
            type: "structure",
            required: [
              "environmentId",
              "clusterName"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              clusterName: {
                location: "uri",
                locationName: "clusterName"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteKxDatabase: {
          http: {
            method: "DELETE",
            requestUri: "/kx/environments/{environmentId}/databases/{databaseName}"
          },
          input: {
            type: "structure",
            required: [
              "environmentId",
              "databaseName",
              "clientToken"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              databaseName: {
                location: "uri",
                locationName: "databaseName"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteKxDataview: {
          http: {
            method: "DELETE",
            requestUri: "/kx/environments/{environmentId}/databases/{databaseName}/dataviews/{dataviewName}"
          },
          input: {
            type: "structure",
            required: [
              "environmentId",
              "databaseName",
              "dataviewName",
              "clientToken"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              databaseName: {
                location: "uri",
                locationName: "databaseName"
              },
              dataviewName: {
                location: "uri",
                locationName: "dataviewName"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteKxEnvironment: {
          http: {
            method: "DELETE",
            requestUri: "/kx/environments/{environmentId}"
          },
          input: {
            type: "structure",
            required: [
              "environmentId"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteKxScalingGroup: {
          http: {
            method: "DELETE",
            requestUri: "/kx/environments/{environmentId}/scalingGroups/{scalingGroupName}"
          },
          input: {
            type: "structure",
            required: [
              "environmentId",
              "scalingGroupName"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              scalingGroupName: {
                location: "uri",
                locationName: "scalingGroupName"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteKxUser: {
          http: {
            method: "DELETE",
            requestUri: "/kx/environments/{environmentId}/users/{userName}"
          },
          input: {
            type: "structure",
            required: [
              "userName",
              "environmentId"
            ],
            members: {
              userName: {
                location: "uri",
                locationName: "userName"
              },
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteKxVolume: {
          http: {
            method: "DELETE",
            requestUri: "/kx/environments/{environmentId}/kxvolumes/{volumeName}"
          },
          input: {
            type: "structure",
            required: [
              "environmentId",
              "volumeName"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              volumeName: {
                location: "uri",
                locationName: "volumeName"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetEnvironment: {
          http: {
            method: "GET",
            requestUri: "/environment/{environmentId}"
          },
          input: {
            type: "structure",
            required: [
              "environmentId"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              environment: {
                shape: "S4c"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        GetKxChangeset: {
          http: {
            method: "GET",
            requestUri: "/kx/environments/{environmentId}/databases/{databaseName}/changesets/{changesetId}"
          },
          input: {
            type: "structure",
            required: [
              "environmentId",
              "databaseName",
              "changesetId"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              databaseName: {
                location: "uri",
                locationName: "databaseName"
              },
              changesetId: {
                location: "uri",
                locationName: "changesetId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              changesetId: {},
              databaseName: {},
              environmentId: {},
              changeRequests: {
                shape: "Ss"
              },
              createdTimestamp: {
                type: "timestamp"
              },
              activeFromTimestamp: {
                type: "timestamp"
              },
              lastModifiedTimestamp: {
                type: "timestamp"
              },
              status: {},
              errorInfo: {
                shape: "S12"
              }
            }
          }
        },
        GetKxCluster: {
          http: {
            method: "GET",
            requestUri: "/kx/environments/{environmentId}/clusters/{clusterName}"
          },
          input: {
            type: "structure",
            required: [
              "environmentId",
              "clusterName"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              clusterName: {
                location: "uri",
                locationName: "clusterName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              status: {},
              statusReason: {},
              clusterName: {},
              clusterType: {},
              tickerplantLogConfiguration: {
                shape: "S1a"
              },
              volumes: {
                shape: "S2w"
              },
              databases: {
                shape: "S1d"
              },
              cacheStorageConfigurations: {
                shape: "S1q"
              },
              autoScalingConfiguration: {
                shape: "S1t"
              },
              clusterDescription: {},
              capacityConfiguration: {
                shape: "S1z"
              },
              releaseLabel: {},
              vpcConfiguration: {
                shape: "S22"
              },
              initializationScript: {},
              commandLineArguments: {
                shape: "S2a"
              },
              code: {
                shape: "S2e"
              },
              executionRole: {},
              lastModifiedTimestamp: {
                type: "timestamp"
              },
              savedownStorageConfiguration: {
                shape: "S2j"
              },
              azMode: {},
              availabilityZoneId: {},
              createdTimestamp: {
                type: "timestamp"
              },
              scalingGroupConfiguration: {
                shape: "S2o"
              }
            }
          }
        },
        GetKxConnectionString: {
          http: {
            method: "GET",
            requestUri: "/kx/environments/{environmentId}/connectionString"
          },
          input: {
            type: "structure",
            required: [
              "userArn",
              "environmentId",
              "clusterName"
            ],
            members: {
              userArn: {
                location: "querystring",
                locationName: "userArn"
              },
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              clusterName: {
                location: "querystring",
                locationName: "clusterName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              signedConnectionString: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        GetKxDatabase: {
          http: {
            method: "GET",
            requestUri: "/kx/environments/{environmentId}/databases/{databaseName}"
          },
          input: {
            type: "structure",
            required: [
              "environmentId",
              "databaseName"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              databaseName: {
                location: "uri",
                locationName: "databaseName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              databaseName: {},
              databaseArn: {},
              environmentId: {},
              description: {},
              createdTimestamp: {
                type: "timestamp"
              },
              lastModifiedTimestamp: {
                type: "timestamp"
              },
              lastCompletedChangesetId: {},
              numBytes: {
                type: "long"
              },
              numChangesets: {
                type: "integer"
              },
              numFiles: {
                type: "integer"
              }
            }
          }
        },
        GetKxDataview: {
          http: {
            method: "GET",
            requestUri: "/kx/environments/{environmentId}/databases/{databaseName}/dataviews/{dataviewName}"
          },
          input: {
            type: "structure",
            required: [
              "environmentId",
              "databaseName",
              "dataviewName"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              databaseName: {
                location: "uri",
                locationName: "databaseName"
              },
              dataviewName: {
                location: "uri",
                locationName: "dataviewName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              databaseName: {},
              dataviewName: {},
              azMode: {},
              availabilityZoneId: {},
              changesetId: {},
              segmentConfigurations: {
                shape: "S1m"
              },
              activeVersions: {
                shape: "S4s"
              },
              description: {},
              autoUpdate: {
                type: "boolean"
              },
              environmentId: {},
              createdTimestamp: {
                type: "timestamp"
              },
              lastModifiedTimestamp: {
                type: "timestamp"
              },
              status: {},
              statusReason: {}
            }
          }
        },
        GetKxEnvironment: {
          http: {
            method: "GET",
            requestUri: "/kx/environments/{environmentId}"
          },
          input: {
            type: "structure",
            required: [
              "environmentId"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              environmentId: {},
              awsAccountId: {},
              status: {},
              tgwStatus: {},
              dnsStatus: {},
              errorMessage: {},
              description: {},
              environmentArn: {},
              kmsKeyId: {},
              dedicatedServiceAccountId: {},
              transitGatewayConfiguration: {
                shape: "S51"
              },
              customDNSConfiguration: {
                shape: "S5e"
              },
              creationTimestamp: {
                type: "timestamp"
              },
              updateTimestamp: {
                type: "timestamp"
              },
              availabilityZoneIds: {
                shape: "S3p"
              },
              certificateAuthorityArn: {}
            }
          }
        },
        GetKxScalingGroup: {
          http: {
            method: "GET",
            requestUri: "/kx/environments/{environmentId}/scalingGroups/{scalingGroupName}"
          },
          input: {
            type: "structure",
            required: [
              "environmentId",
              "scalingGroupName"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              scalingGroupName: {
                location: "uri",
                locationName: "scalingGroupName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              scalingGroupName: {},
              scalingGroupArn: {},
              hostType: {},
              clusters: {
                shape: "S5m"
              },
              availabilityZoneId: {},
              status: {},
              statusReason: {},
              lastModifiedTimestamp: {
                type: "timestamp"
              },
              createdTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        GetKxUser: {
          http: {
            method: "GET",
            requestUri: "/kx/environments/{environmentId}/users/{userName}"
          },
          input: {
            type: "structure",
            required: [
              "userName",
              "environmentId"
            ],
            members: {
              userName: {
                location: "uri",
                locationName: "userName"
              },
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              userName: {},
              userArn: {},
              environmentId: {},
              iamRole: {}
            }
          }
        },
        GetKxVolume: {
          http: {
            method: "GET",
            requestUri: "/kx/environments/{environmentId}/kxvolumes/{volumeName}"
          },
          input: {
            type: "structure",
            required: [
              "environmentId",
              "volumeName"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              volumeName: {
                location: "uri",
                locationName: "volumeName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              environmentId: {},
              volumeName: {},
              volumeType: {},
              volumeArn: {},
              nas1Configuration: {
                shape: "S3m"
              },
              status: {},
              statusReason: {},
              createdTimestamp: {
                type: "timestamp"
              },
              description: {},
              azMode: {},
              availabilityZoneIds: {
                shape: "S3p"
              },
              lastModifiedTimestamp: {
                type: "timestamp"
              },
              attachedClusters: {
                shape: "S5r"
              }
            }
          }
        },
        ListEnvironments: {
          http: {
            method: "GET",
            requestUri: "/environment"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              environments: {
                type: "list",
                member: {
                  shape: "S4c"
                }
              },
              nextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        ListKxChangesets: {
          http: {
            method: "GET",
            requestUri: "/kx/environments/{environmentId}/databases/{databaseName}/changesets"
          },
          input: {
            type: "structure",
            required: [
              "environmentId",
              "databaseName"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              databaseName: {
                location: "uri",
                locationName: "databaseName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              kxChangesets: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    changesetId: {},
                    createdTimestamp: {
                      type: "timestamp"
                    },
                    activeFromTimestamp: {
                      type: "timestamp"
                    },
                    lastModifiedTimestamp: {
                      type: "timestamp"
                    },
                    status: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListKxClusterNodes: {
          http: {
            method: "GET",
            requestUri: "/kx/environments/{environmentId}/clusters/{clusterName}/nodes"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "environmentId"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              clusterName: {
                location: "uri",
                locationName: "clusterName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nodes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    nodeId: {},
                    availabilityZoneId: {},
                    launchTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListKxClusters: {
          http: {
            method: "GET",
            requestUri: "/kx/environments/{environmentId}/clusters"
          },
          input: {
            type: "structure",
            required: [
              "environmentId"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              clusterType: {
                location: "querystring",
                locationName: "clusterType"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              kxClusterSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    status: {},
                    statusReason: {},
                    clusterName: {},
                    clusterType: {},
                    clusterDescription: {},
                    releaseLabel: {},
                    volumes: {
                      shape: "S2w"
                    },
                    initializationScript: {},
                    executionRole: {},
                    azMode: {},
                    availabilityZoneId: {},
                    lastModifiedTimestamp: {
                      type: "timestamp"
                    },
                    createdTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListKxDatabases: {
          http: {
            method: "GET",
            requestUri: "/kx/environments/{environmentId}/databases"
          },
          input: {
            type: "structure",
            required: [
              "environmentId"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              kxDatabases: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    databaseName: {},
                    createdTimestamp: {
                      type: "timestamp"
                    },
                    lastModifiedTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListKxDataviews: {
          http: {
            method: "GET",
            requestUri: "/kx/environments/{environmentId}/databases/{databaseName}/dataviews"
          },
          input: {
            type: "structure",
            required: [
              "environmentId",
              "databaseName"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              databaseName: {
                location: "uri",
                locationName: "databaseName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              kxDataviews: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    environmentId: {},
                    databaseName: {},
                    dataviewName: {},
                    azMode: {},
                    availabilityZoneId: {},
                    changesetId: {},
                    segmentConfigurations: {
                      shape: "S1m"
                    },
                    activeVersions: {
                      shape: "S4s"
                    },
                    status: {},
                    description: {},
                    autoUpdate: {
                      type: "boolean"
                    },
                    createdTimestamp: {
                      type: "timestamp"
                    },
                    lastModifiedTimestamp: {
                      type: "timestamp"
                    },
                    statusReason: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListKxEnvironments: {
          http: {
            method: "GET",
            requestUri: "/kx/environments"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              environments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    environmentId: {},
                    awsAccountId: {},
                    status: {},
                    tgwStatus: {},
                    dnsStatus: {},
                    errorMessage: {},
                    description: {},
                    environmentArn: {},
                    kmsKeyId: {},
                    dedicatedServiceAccountId: {},
                    transitGatewayConfiguration: {
                      shape: "S51"
                    },
                    customDNSConfiguration: {
                      shape: "S5e"
                    },
                    creationTimestamp: {
                      type: "timestamp"
                    },
                    updateTimestamp: {
                      type: "timestamp"
                    },
                    availabilityZoneIds: {
                      shape: "S3p"
                    },
                    certificateAuthorityArn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListKxScalingGroups: {
          http: {
            method: "GET",
            requestUri: "/kx/environments/{environmentId}/scalingGroups"
          },
          input: {
            type: "structure",
            required: [
              "environmentId"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              scalingGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    scalingGroupName: {},
                    hostType: {},
                    clusters: {
                      shape: "S5m"
                    },
                    availabilityZoneId: {},
                    status: {},
                    statusReason: {},
                    lastModifiedTimestamp: {
                      type: "timestamp"
                    },
                    createdTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListKxUsers: {
          http: {
            method: "GET",
            requestUri: "/kx/environments/{environmentId}/users"
          },
          input: {
            type: "structure",
            required: [
              "environmentId"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              users: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    userArn: {},
                    userName: {},
                    iamRole: {},
                    createTimestamp: {
                      type: "timestamp"
                    },
                    updateTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListKxVolumes: {
          http: {
            method: "GET",
            requestUri: "/kx/environments/{environmentId}/kxvolumes"
          },
          input: {
            type: "structure",
            required: [
              "environmentId"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              volumeType: {
                location: "querystring",
                locationName: "volumeType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              kxVolumeSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    volumeName: {},
                    volumeType: {},
                    status: {},
                    description: {},
                    statusReason: {},
                    azMode: {},
                    availabilityZoneIds: {
                      shape: "S3p"
                    },
                    createdTimestamp: {
                      type: "timestamp"
                    },
                    lastModifiedTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S5"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateEnvironment: {
          http: {
            method: "PUT",
            requestUri: "/environment/{environmentId}"
          },
          input: {
            type: "structure",
            required: [
              "environmentId"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              name: {},
              description: {},
              federationMode: {},
              federationParameters: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              environment: {
                shape: "S4c"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        UpdateKxClusterCodeConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/kx/environments/{environmentId}/clusters/{clusterName}/configuration/code"
          },
          input: {
            type: "structure",
            required: [
              "environmentId",
              "clusterName",
              "code"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              clusterName: {
                location: "uri",
                locationName: "clusterName"
              },
              clientToken: {
                idempotencyToken: true
              },
              code: {
                shape: "S2e"
              },
              initializationScript: {},
              commandLineArguments: {
                shape: "S2a"
              },
              deploymentConfiguration: {
                type: "structure",
                required: [
                  "deploymentStrategy"
                ],
                members: {
                  deploymentStrategy: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateKxClusterDatabases: {
          http: {
            method: "PUT",
            requestUri: "/kx/environments/{environmentId}/clusters/{clusterName}/configuration/databases"
          },
          input: {
            type: "structure",
            required: [
              "environmentId",
              "clusterName",
              "databases"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              clusterName: {
                location: "uri",
                locationName: "clusterName"
              },
              clientToken: {
                idempotencyToken: true
              },
              databases: {
                shape: "S1d"
              },
              deploymentConfiguration: {
                type: "structure",
                required: [
                  "deploymentStrategy"
                ],
                members: {
                  deploymentStrategy: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateKxDatabase: {
          http: {
            method: "PUT",
            requestUri: "/kx/environments/{environmentId}/databases/{databaseName}"
          },
          input: {
            type: "structure",
            required: [
              "environmentId",
              "databaseName",
              "clientToken"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              databaseName: {
                location: "uri",
                locationName: "databaseName"
              },
              description: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              databaseName: {},
              environmentId: {},
              description: {},
              lastModifiedTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        UpdateKxDataview: {
          http: {
            method: "PUT",
            requestUri: "/kx/environments/{environmentId}/databases/{databaseName}/dataviews/{dataviewName}"
          },
          input: {
            type: "structure",
            required: [
              "environmentId",
              "databaseName",
              "dataviewName",
              "clientToken"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              databaseName: {
                location: "uri",
                locationName: "databaseName"
              },
              dataviewName: {
                location: "uri",
                locationName: "dataviewName"
              },
              description: {},
              changesetId: {},
              segmentConfigurations: {
                shape: "S1m"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              environmentId: {},
              databaseName: {},
              dataviewName: {},
              azMode: {},
              availabilityZoneId: {},
              changesetId: {},
              segmentConfigurations: {
                shape: "S1m"
              },
              activeVersions: {
                shape: "S4s"
              },
              status: {},
              autoUpdate: {
                type: "boolean"
              },
              description: {},
              createdTimestamp: {
                type: "timestamp"
              },
              lastModifiedTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        UpdateKxEnvironment: {
          http: {
            method: "PUT",
            requestUri: "/kx/environments/{environmentId}"
          },
          input: {
            type: "structure",
            required: [
              "environmentId"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              name: {},
              description: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              environmentId: {},
              awsAccountId: {},
              status: {},
              tgwStatus: {},
              dnsStatus: {},
              errorMessage: {},
              description: {},
              environmentArn: {},
              kmsKeyId: {},
              dedicatedServiceAccountId: {},
              transitGatewayConfiguration: {
                shape: "S51"
              },
              customDNSConfiguration: {
                shape: "S5e"
              },
              creationTimestamp: {
                type: "timestamp"
              },
              updateTimestamp: {
                type: "timestamp"
              },
              availabilityZoneIds: {
                shape: "S3p"
              }
            }
          }
        },
        UpdateKxEnvironmentNetwork: {
          http: {
            method: "PUT",
            requestUri: "/kx/environments/{environmentId}/network"
          },
          input: {
            type: "structure",
            required: [
              "environmentId"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              transitGatewayConfiguration: {
                shape: "S51"
              },
              customDNSConfiguration: {
                shape: "S5e"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              environmentId: {},
              awsAccountId: {},
              status: {},
              tgwStatus: {},
              dnsStatus: {},
              errorMessage: {},
              description: {},
              environmentArn: {},
              kmsKeyId: {},
              dedicatedServiceAccountId: {},
              transitGatewayConfiguration: {
                shape: "S51"
              },
              customDNSConfiguration: {
                shape: "S5e"
              },
              creationTimestamp: {
                type: "timestamp"
              },
              updateTimestamp: {
                type: "timestamp"
              },
              availabilityZoneIds: {
                shape: "S3p"
              }
            }
          }
        },
        UpdateKxUser: {
          http: {
            method: "PUT",
            requestUri: "/kx/environments/{environmentId}/users/{userName}"
          },
          input: {
            type: "structure",
            required: [
              "environmentId",
              "userName",
              "iamRole"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              userName: {
                location: "uri",
                locationName: "userName"
              },
              iamRole: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              userName: {},
              userArn: {},
              environmentId: {},
              iamRole: {}
            }
          }
        },
        UpdateKxVolume: {
          http: {
            method: "PATCH",
            requestUri: "/kx/environments/{environmentId}/kxvolumes/{volumeName}"
          },
          input: {
            type: "structure",
            required: [
              "environmentId",
              "volumeName"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              volumeName: {
                location: "uri",
                locationName: "volumeName"
              },
              description: {},
              clientToken: {
                idempotencyToken: true
              },
              nas1Configuration: {
                shape: "S3m"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              environmentId: {},
              volumeName: {},
              volumeType: {},
              volumeArn: {},
              nas1Configuration: {
                shape: "S3m"
              },
              status: {},
              description: {},
              statusReason: {},
              createdTimestamp: {
                type: "timestamp"
              },
              azMode: {},
              availabilityZoneIds: {
                shape: "S3p"
              },
              lastModifiedTimestamp: {
                type: "timestamp"
              },
              attachedClusters: {
                shape: "S5r"
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "map",
          key: {},
          value: {}
        },
        S9: {
          type: "structure",
          members: {
            samlMetadataDocument: {},
            samlMetadataURL: {},
            applicationCallBackURL: {},
            federationURN: {},
            federationProviderName: {},
            attributeMap: {
              type: "map",
              key: {},
              value: {}
            }
          }
        },
        Ss: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "changeType",
              "dbPath"
            ],
            members: {
              changeType: {},
              s3Path: {},
              dbPath: {}
            }
          }
        },
        S12: {
          type: "structure",
          members: {
            errorMessage: {},
            errorType: {}
          }
        },
        S1a: {
          type: "structure",
          members: {
            tickerplantLogVolumes: {
              type: "list",
              member: {}
            }
          }
        },
        S1d: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "databaseName"
            ],
            members: {
              databaseName: {},
              cacheConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "cacheType",
                    "dbPaths"
                  ],
                  members: {
                    cacheType: {},
                    dbPaths: {
                      type: "list",
                      member: {}
                    },
                    dataviewName: {}
                  }
                }
              },
              changesetId: {},
              dataviewName: {},
              dataviewConfiguration: {
                type: "structure",
                members: {
                  dataviewName: {},
                  dataviewVersionId: {},
                  changesetId: {},
                  segmentConfigurations: {
                    shape: "S1m"
                  }
                }
              }
            }
          }
        },
        S1m: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "dbPaths",
              "volumeName"
            ],
            members: {
              dbPaths: {
                type: "list",
                member: {}
              },
              volumeName: {}
            }
          }
        },
        S1q: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "type",
              "size"
            ],
            members: {
              type: {},
              size: {
                type: "integer"
              }
            }
          }
        },
        S1t: {
          type: "structure",
          members: {
            minNodeCount: {
              type: "integer"
            },
            maxNodeCount: {
              type: "integer"
            },
            autoScalingMetric: {},
            metricTarget: {
              type: "double"
            },
            scaleInCooldownSeconds: {
              type: "double"
            },
            scaleOutCooldownSeconds: {
              type: "double"
            }
          }
        },
        S1z: {
          type: "structure",
          members: {
            nodeType: {},
            nodeCount: {
              type: "integer"
            }
          }
        },
        S22: {
          type: "structure",
          members: {
            vpcId: {},
            securityGroupIds: {
              type: "list",
              member: {}
            },
            subnetIds: {
              type: "list",
              member: {}
            },
            ipAddressType: {}
          }
        },
        S2a: {
          type: "list",
          member: {
            type: "structure",
            members: {
              key: {},
              value: {}
            }
          }
        },
        S2e: {
          type: "structure",
          members: {
            s3Bucket: {},
            s3Key: {},
            s3ObjectVersion: {}
          }
        },
        S2j: {
          type: "structure",
          members: {
            type: {},
            size: {
              type: "integer"
            },
            volumeName: {}
          }
        },
        S2o: {
          type: "structure",
          required: [
            "scalingGroupName",
            "memoryReservation",
            "nodeCount"
          ],
          members: {
            scalingGroupName: {},
            memoryLimit: {
              type: "integer"
            },
            memoryReservation: {
              type: "integer"
            },
            nodeCount: {
              type: "integer"
            },
            cpu: {
              type: "double"
            }
          }
        },
        S2w: {
          type: "list",
          member: {
            type: "structure",
            members: {
              volumeName: {},
              volumeType: {}
            }
          }
        },
        S3m: {
          type: "structure",
          members: {
            type: {},
            size: {
              type: "integer"
            }
          }
        },
        S3p: {
          type: "list",
          member: {}
        },
        S4c: {
          type: "structure",
          members: {
            name: {},
            environmentId: {},
            awsAccountId: {},
            status: {},
            environmentUrl: {},
            description: {},
            environmentArn: {},
            sageMakerStudioDomainUrl: {},
            kmsKeyId: {},
            dedicatedServiceAccountId: {},
            federationMode: {},
            federationParameters: {
              shape: "S9"
            }
          }
        },
        S4s: {
          type: "list",
          member: {
            type: "structure",
            members: {
              changesetId: {},
              segmentConfigurations: {
                shape: "S1m"
              },
              attachedClusters: {
                type: "list",
                member: {}
              },
              createdTimestamp: {
                type: "timestamp"
              },
              versionId: {}
            }
          }
        },
        S51: {
          type: "structure",
          required: [
            "transitGatewayID",
            "routableCIDRSpace"
          ],
          members: {
            transitGatewayID: {},
            routableCIDRSpace: {},
            attachmentNetworkAclConfiguration: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "ruleNumber",
                  "protocol",
                  "ruleAction",
                  "cidrBlock"
                ],
                members: {
                  ruleNumber: {
                    type: "integer"
                  },
                  protocol: {},
                  ruleAction: {},
                  portRange: {
                    type: "structure",
                    required: [
                      "from",
                      "to"
                    ],
                    members: {
                      from: {
                        type: "integer"
                      },
                      to: {
                        type: "integer"
                      }
                    }
                  },
                  icmpTypeCode: {
                    type: "structure",
                    required: [
                      "type",
                      "code"
                    ],
                    members: {
                      type: {
                        type: "integer"
                      },
                      code: {
                        type: "integer"
                      }
                    }
                  },
                  cidrBlock: {}
                }
              }
            }
          }
        },
        S5e: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "customDNSServerName",
              "customDNSServerIP"
            ],
            members: {
              customDNSServerName: {},
              customDNSServerIP: {}
            }
          }
        },
        S5m: {
          type: "list",
          member: {}
        },
        S5r: {
          type: "list",
          member: {
            type: "structure",
            members: {
              clusterName: {},
              clusterType: {},
              clusterStatus: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/finspace-2021-03-12.paginators.json
var require_finspace_2021_03_12_paginators = __commonJS({
  "node_modules/aws-sdk/apis/finspace-2021-03-12.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListKxChangesets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListKxClusterNodes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListKxDatabases: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListKxDataviews: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListKxEnvironments: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "environments"
        },
        ListKxScalingGroups: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/finspace.js
var require_finspace = __commonJS({
  "node_modules/aws-sdk/clients/finspace.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["finspace"] = {};
    AWS2.Finspace = Service.defineService("finspace", ["2021-03-12"]);
    Object.defineProperty(apiLoader.services["finspace"], "2021-03-12", {
      get: function get() {
        var model = require_finspace_2021_03_12_min();
        model.paginators = require_finspace_2021_03_12_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Finspace;
  }
});

// node_modules/aws-sdk/apis/finspace-data-2020-07-13.min.json
var require_finspace_data_2020_07_13_min = __commonJS({
  "node_modules/aws-sdk/apis/finspace-data-2020-07-13.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-07-13",
        endpointPrefix: "finspace-api",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "FinSpace Data",
        serviceFullName: "FinSpace Public API",
        serviceId: "finspace data",
        signatureVersion: "v4",
        signingName: "finspace-api",
        uid: "finspace-2020-07-13"
      },
      operations: {
        AssociateUserToPermissionGroup: {
          http: {
            requestUri: "/permission-group/{permissionGroupId}/users/{userId}"
          },
          input: {
            type: "structure",
            required: [
              "permissionGroupId",
              "userId"
            ],
            members: {
              permissionGroupId: {
                location: "uri",
                locationName: "permissionGroupId"
              },
              userId: {
                location: "uri",
                locationName: "userId"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              statusCode: {
                location: "statusCode",
                type: "integer"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        CreateChangeset: {
          http: {
            requestUri: "/datasets/{datasetId}/changesetsv2"
          },
          input: {
            type: "structure",
            required: [
              "datasetId",
              "changeType",
              "sourceParams",
              "formatParams"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              datasetId: {
                location: "uri",
                locationName: "datasetId"
              },
              changeType: {},
              sourceParams: {
                shape: "Sa"
              },
              formatParams: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datasetId: {},
              changesetId: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        CreateDataView: {
          http: {
            requestUri: "/datasets/{datasetId}/dataviewsv2"
          },
          input: {
            type: "structure",
            required: [
              "datasetId",
              "destinationTypeParams"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              datasetId: {
                location: "uri",
                locationName: "datasetId"
              },
              autoUpdate: {
                type: "boolean"
              },
              sortColumns: {
                shape: "Si"
              },
              partitionColumns: {
                shape: "Sk"
              },
              asOfTimestamp: {
                type: "long"
              },
              destinationTypeParams: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datasetId: {},
              dataViewId: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        CreateDataset: {
          http: {
            requestUri: "/datasetsv2"
          },
          input: {
            type: "structure",
            required: [
              "datasetTitle",
              "kind",
              "permissionGroupParams"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              datasetTitle: {},
              kind: {},
              datasetDescription: {},
              ownerInfo: {
                shape: "Sw"
              },
              permissionGroupParams: {
                type: "structure",
                members: {
                  permissionGroupId: {},
                  datasetPermissions: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        permission: {}
                      }
                    }
                  }
                }
              },
              alias: {},
              schemaDefinition: {
                shape: "S15"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datasetId: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        CreatePermissionGroup: {
          http: {
            requestUri: "/permission-group"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "applicationPermissions"
            ],
            members: {
              name: {
                shape: "S1f"
              },
              description: {
                shape: "S1g"
              },
              applicationPermissions: {
                shape: "S1h"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              permissionGroupId: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        CreateUser: {
          http: {
            requestUri: "/user"
          },
          input: {
            type: "structure",
            required: [
              "emailAddress",
              "type"
            ],
            members: {
              emailAddress: {
                shape: "Sz"
              },
              type: {},
              firstName: {
                shape: "S1m"
              },
              lastName: {
                shape: "S1n"
              },
              apiAccess: {},
              apiAccessPrincipalArn: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              userId: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        DeleteDataset: {
          http: {
            method: "DELETE",
            requestUri: "/datasetsv2/{datasetId}"
          },
          input: {
            type: "structure",
            required: [
              "datasetId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              },
              datasetId: {
                location: "uri",
                locationName: "datasetId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datasetId: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        DeletePermissionGroup: {
          http: {
            method: "DELETE",
            requestUri: "/permission-group/{permissionGroupId}"
          },
          input: {
            type: "structure",
            required: [
              "permissionGroupId"
            ],
            members: {
              permissionGroupId: {
                location: "uri",
                locationName: "permissionGroupId"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              permissionGroupId: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        DisableUser: {
          http: {
            requestUri: "/user/{userId}/disable"
          },
          input: {
            type: "structure",
            required: [
              "userId"
            ],
            members: {
              userId: {
                location: "uri",
                locationName: "userId"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              userId: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        DisassociateUserFromPermissionGroup: {
          http: {
            method: "DELETE",
            requestUri: "/permission-group/{permissionGroupId}/users/{userId}"
          },
          input: {
            type: "structure",
            required: [
              "permissionGroupId",
              "userId"
            ],
            members: {
              permissionGroupId: {
                location: "uri",
                locationName: "permissionGroupId"
              },
              userId: {
                location: "uri",
                locationName: "userId"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              statusCode: {
                location: "statusCode",
                type: "integer"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        EnableUser: {
          http: {
            requestUri: "/user/{userId}/enable"
          },
          input: {
            type: "structure",
            required: [
              "userId"
            ],
            members: {
              userId: {
                location: "uri",
                locationName: "userId"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              userId: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        GetChangeset: {
          http: {
            method: "GET",
            requestUri: "/datasets/{datasetId}/changesetsv2/{changesetId}"
          },
          input: {
            type: "structure",
            required: [
              "datasetId",
              "changesetId"
            ],
            members: {
              datasetId: {
                location: "uri",
                locationName: "datasetId"
              },
              changesetId: {
                location: "uri",
                locationName: "changesetId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              changesetId: {},
              changesetArn: {},
              datasetId: {},
              changeType: {},
              sourceParams: {
                shape: "Sa"
              },
              formatParams: {
                shape: "Sd"
              },
              createTime: {
                type: "long"
              },
              status: {},
              errorInfo: {
                shape: "S25"
              },
              activeUntilTimestamp: {
                type: "long"
              },
              activeFromTimestamp: {
                type: "long"
              },
              updatesChangesetId: {},
              updatedByChangesetId: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        GetDataView: {
          http: {
            method: "GET",
            requestUri: "/datasets/{datasetId}/dataviewsv2/{dataviewId}"
          },
          input: {
            type: "structure",
            required: [
              "dataViewId",
              "datasetId"
            ],
            members: {
              dataViewId: {
                location: "uri",
                locationName: "dataviewId"
              },
              datasetId: {
                location: "uri",
                locationName: "datasetId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              autoUpdate: {
                type: "boolean"
              },
              partitionColumns: {
                shape: "Sk"
              },
              datasetId: {},
              asOfTimestamp: {
                type: "long"
              },
              errorInfo: {
                shape: "S2a"
              },
              lastModifiedTime: {
                type: "long"
              },
              createTime: {
                type: "long"
              },
              sortColumns: {
                shape: "Si"
              },
              dataViewId: {},
              dataViewArn: {},
              destinationTypeParams: {
                shape: "Sm"
              },
              status: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        GetDataset: {
          http: {
            method: "GET",
            requestUri: "/datasetsv2/{datasetId}"
          },
          input: {
            type: "structure",
            required: [
              "datasetId"
            ],
            members: {
              datasetId: {
                location: "uri",
                locationName: "datasetId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datasetId: {},
              datasetArn: {},
              datasetTitle: {},
              kind: {},
              datasetDescription: {},
              createTime: {
                type: "long"
              },
              lastModifiedTime: {
                type: "long"
              },
              schemaDefinition: {
                shape: "S15"
              },
              alias: {},
              status: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        GetExternalDataViewAccessDetails: {
          http: {
            requestUri: "/datasets/{datasetId}/dataviewsv2/{dataviewId}/external-access-details"
          },
          input: {
            type: "structure",
            required: [
              "dataViewId",
              "datasetId"
            ],
            members: {
              dataViewId: {
                location: "uri",
                locationName: "dataviewId"
              },
              datasetId: {
                location: "uri",
                locationName: "datasetId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              credentials: {
                type: "structure",
                members: {
                  accessKeyId: {},
                  secretAccessKey: {
                    type: "string",
                    sensitive: true
                  },
                  sessionToken: {
                    type: "string",
                    sensitive: true
                  },
                  expiration: {
                    type: "long"
                  }
                },
                sensitive: true
              },
              s3Location: {
                type: "structure",
                required: [
                  "bucket",
                  "key"
                ],
                members: {
                  bucket: {},
                  key: {}
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        GetPermissionGroup: {
          http: {
            method: "GET",
            requestUri: "/permission-group/{permissionGroupId}"
          },
          input: {
            type: "structure",
            required: [
              "permissionGroupId"
            ],
            members: {
              permissionGroupId: {
                location: "uri",
                locationName: "permissionGroupId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              permissionGroup: {
                shape: "S2s"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        GetProgrammaticAccessCredentials: {
          http: {
            method: "GET",
            requestUri: "/credentials/programmatic"
          },
          input: {
            type: "structure",
            required: [
              "environmentId"
            ],
            members: {
              durationInMinutes: {
                location: "querystring",
                locationName: "durationInMinutes",
                type: "long"
              },
              environmentId: {
                location: "querystring",
                locationName: "environmentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              credentials: {
                type: "structure",
                members: {
                  accessKeyId: {},
                  secretAccessKey: {},
                  sessionToken: {}
                },
                sensitive: true
              },
              durationInMinutes: {
                type: "long"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        GetUser: {
          http: {
            method: "GET",
            requestUri: "/user/{userId}"
          },
          input: {
            type: "structure",
            required: [
              "userId"
            ],
            members: {
              userId: {
                location: "uri",
                locationName: "userId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              userId: {},
              status: {},
              firstName: {
                shape: "S1m"
              },
              lastName: {
                shape: "S1n"
              },
              emailAddress: {
                shape: "Sz"
              },
              type: {},
              apiAccess: {},
              apiAccessPrincipalArn: {},
              createTime: {
                type: "long"
              },
              lastEnabledTime: {
                type: "long"
              },
              lastDisabledTime: {
                type: "long"
              },
              lastModifiedTime: {
                type: "long"
              },
              lastLoginTime: {
                type: "long"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        GetWorkingLocation: {
          http: {
            requestUri: "/workingLocationV1"
          },
          input: {
            type: "structure",
            members: {
              locationType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              s3Uri: {},
              s3Path: {},
              s3Bucket: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        ListChangesets: {
          http: {
            method: "GET",
            requestUri: "/datasets/{datasetId}/changesetsv2"
          },
          input: {
            type: "structure",
            required: [
              "datasetId"
            ],
            members: {
              datasetId: {
                location: "uri",
                locationName: "datasetId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              changesets: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    changesetId: {},
                    changesetArn: {},
                    datasetId: {},
                    changeType: {},
                    sourceParams: {
                      shape: "Sa"
                    },
                    formatParams: {
                      shape: "Sd"
                    },
                    createTime: {
                      type: "long"
                    },
                    status: {},
                    errorInfo: {
                      shape: "S25"
                    },
                    activeUntilTimestamp: {
                      type: "long"
                    },
                    activeFromTimestamp: {
                      type: "long"
                    },
                    updatesChangesetId: {},
                    updatedByChangesetId: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        ListDataViews: {
          http: {
            method: "GET",
            requestUri: "/datasets/{datasetId}/dataviewsv2"
          },
          input: {
            type: "structure",
            required: [
              "datasetId"
            ],
            members: {
              datasetId: {
                location: "uri",
                locationName: "datasetId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              dataViews: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    dataViewId: {},
                    dataViewArn: {},
                    datasetId: {},
                    asOfTimestamp: {
                      type: "long"
                    },
                    partitionColumns: {
                      shape: "Sk"
                    },
                    sortColumns: {
                      shape: "Si"
                    },
                    status: {},
                    errorInfo: {
                      shape: "S2a"
                    },
                    destinationTypeProperties: {
                      shape: "Sm"
                    },
                    autoUpdate: {
                      type: "boolean"
                    },
                    createTime: {
                      type: "long"
                    },
                    lastModifiedTime: {
                      type: "long"
                    }
                  }
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        ListDatasets: {
          http: {
            method: "GET",
            requestUri: "/datasetsv2"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datasets: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    datasetId: {},
                    datasetArn: {},
                    datasetTitle: {},
                    kind: {},
                    datasetDescription: {},
                    ownerInfo: {
                      shape: "Sw"
                    },
                    createTime: {
                      type: "long"
                    },
                    lastModifiedTime: {
                      type: "long"
                    },
                    schemaDefinition: {
                      shape: "S15"
                    },
                    alias: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        ListPermissionGroups: {
          http: {
            method: "GET",
            requestUri: "/permission-group"
          },
          input: {
            type: "structure",
            required: [
              "maxResults"
            ],
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              permissionGroups: {
                type: "list",
                member: {
                  shape: "S2s"
                }
              },
              nextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        ListPermissionGroupsByUser: {
          http: {
            method: "GET",
            requestUri: "/user/{userId}/permission-groups"
          },
          input: {
            type: "structure",
            required: [
              "userId",
              "maxResults"
            ],
            members: {
              userId: {
                location: "uri",
                locationName: "userId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              permissionGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    permissionGroupId: {},
                    name: {
                      shape: "S1f"
                    },
                    membershipStatus: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        ListUsers: {
          http: {
            method: "GET",
            requestUri: "/user"
          },
          input: {
            type: "structure",
            required: [
              "maxResults"
            ],
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              users: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    userId: {},
                    status: {},
                    firstName: {
                      shape: "S1m"
                    },
                    lastName: {
                      shape: "S1n"
                    },
                    emailAddress: {
                      shape: "Sz"
                    },
                    type: {},
                    apiAccess: {},
                    apiAccessPrincipalArn: {},
                    createTime: {
                      type: "long"
                    },
                    lastEnabledTime: {
                      type: "long"
                    },
                    lastDisabledTime: {
                      type: "long"
                    },
                    lastModifiedTime: {
                      type: "long"
                    },
                    lastLoginTime: {
                      type: "long"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        ListUsersByPermissionGroup: {
          http: {
            method: "GET",
            requestUri: "/permission-group/{permissionGroupId}/users"
          },
          input: {
            type: "structure",
            required: [
              "permissionGroupId",
              "maxResults"
            ],
            members: {
              permissionGroupId: {
                location: "uri",
                locationName: "permissionGroupId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              users: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    userId: {},
                    status: {},
                    firstName: {
                      shape: "S1m"
                    },
                    lastName: {
                      shape: "S1n"
                    },
                    emailAddress: {
                      shape: "Sz"
                    },
                    type: {},
                    apiAccess: {},
                    apiAccessPrincipalArn: {},
                    membershipStatus: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        ResetUserPassword: {
          http: {
            requestUri: "/user/{userId}/password"
          },
          input: {
            type: "structure",
            required: [
              "userId"
            ],
            members: {
              userId: {
                location: "uri",
                locationName: "userId"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              userId: {},
              temporaryPassword: {
                type: "string",
                sensitive: true
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        UpdateChangeset: {
          http: {
            method: "PUT",
            requestUri: "/datasets/{datasetId}/changesetsv2/{changesetId}"
          },
          input: {
            type: "structure",
            required: [
              "datasetId",
              "changesetId",
              "sourceParams",
              "formatParams"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              datasetId: {
                location: "uri",
                locationName: "datasetId"
              },
              changesetId: {
                location: "uri",
                locationName: "changesetId"
              },
              sourceParams: {
                shape: "Sa"
              },
              formatParams: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              changesetId: {},
              datasetId: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        UpdateDataset: {
          http: {
            method: "PUT",
            requestUri: "/datasetsv2/{datasetId}"
          },
          input: {
            type: "structure",
            required: [
              "datasetId",
              "datasetTitle",
              "kind"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              datasetId: {
                location: "uri",
                locationName: "datasetId"
              },
              datasetTitle: {},
              kind: {},
              datasetDescription: {},
              alias: {},
              schemaDefinition: {
                shape: "S15"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datasetId: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        UpdatePermissionGroup: {
          http: {
            method: "PUT",
            requestUri: "/permission-group/{permissionGroupId}"
          },
          input: {
            type: "structure",
            required: [
              "permissionGroupId"
            ],
            members: {
              permissionGroupId: {
                location: "uri",
                locationName: "permissionGroupId"
              },
              name: {
                shape: "S1f"
              },
              description: {
                shape: "S1g"
              },
              applicationPermissions: {
                shape: "S1h"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              permissionGroupId: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        },
        UpdateUser: {
          http: {
            method: "PUT",
            requestUri: "/user/{userId}"
          },
          input: {
            type: "structure",
            required: [
              "userId"
            ],
            members: {
              userId: {
                location: "uri",
                locationName: "userId"
              },
              type: {},
              firstName: {
                shape: "S1m"
              },
              lastName: {
                shape: "S1n"
              },
              apiAccess: {},
              apiAccessPrincipalArn: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              userId: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This method will be discontinued."
        }
      },
      shapes: {
        Sa: {
          type: "map",
          key: {},
          value: {}
        },
        Sd: {
          type: "map",
          key: {},
          value: {}
        },
        Si: {
          type: "list",
          member: {}
        },
        Sk: {
          type: "list",
          member: {}
        },
        Sm: {
          type: "structure",
          required: [
            "destinationType"
          ],
          members: {
            destinationType: {},
            s3DestinationExportFileFormat: {},
            s3DestinationExportFileFormatOptions: {
              type: "map",
              key: {},
              value: {}
            }
          }
        },
        Sw: {
          type: "structure",
          members: {
            name: {},
            phoneNumber: {},
            email: {
              shape: "Sz"
            }
          }
        },
        Sz: {
          type: "string",
          sensitive: true
        },
        S15: {
          type: "structure",
          members: {
            tabularSchemaConfig: {
              type: "structure",
              members: {
                columns: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      dataType: {},
                      columnName: {},
                      columnDescription: {}
                    }
                  }
                },
                primaryKeyColumns: {
                  type: "list",
                  member: {}
                }
              }
            }
          }
        },
        S1f: {
          type: "string",
          sensitive: true
        },
        S1g: {
          type: "string",
          sensitive: true
        },
        S1h: {
          type: "list",
          member: {}
        },
        S1m: {
          type: "string",
          sensitive: true
        },
        S1n: {
          type: "string",
          sensitive: true
        },
        S25: {
          type: "structure",
          members: {
            errorMessage: {},
            errorCategory: {}
          }
        },
        S2a: {
          type: "structure",
          members: {
            errorMessage: {},
            errorCategory: {}
          }
        },
        S2s: {
          type: "structure",
          members: {
            permissionGroupId: {},
            name: {
              shape: "S1f"
            },
            description: {
              shape: "S1g"
            },
            applicationPermissions: {
              shape: "S1h"
            },
            createTime: {
              type: "long"
            },
            lastModifiedTime: {
              type: "long"
            },
            membershipStatus: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/finspace-data-2020-07-13.paginators.json
var require_finspace_data_2020_07_13_paginators = __commonJS({
  "node_modules/aws-sdk/apis/finspace-data-2020-07-13.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListChangesets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "changesets"
        },
        ListDataViews: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "dataViews"
        },
        ListDatasets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "datasets"
        },
        ListPermissionGroups: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "permissionGroups"
        },
        ListUsers: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "users"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/finspacedata.js
var require_finspacedata = __commonJS({
  "node_modules/aws-sdk/clients/finspacedata.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["finspacedata"] = {};
    AWS2.Finspacedata = Service.defineService("finspacedata", ["2020-07-13"]);
    Object.defineProperty(apiLoader.services["finspacedata"], "2020-07-13", {
      get: function get() {
        var model = require_finspace_data_2020_07_13_min();
        model.paginators = require_finspace_data_2020_07_13_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Finspacedata;
  }
});

// node_modules/aws-sdk/apis/ssm-contacts-2021-05-03.min.json
var require_ssm_contacts_2021_05_03_min = __commonJS({
  "node_modules/aws-sdk/apis/ssm-contacts-2021-05-03.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-05-03",
        endpointPrefix: "ssm-contacts",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "SSM Contacts",
        serviceFullName: "AWS Systems Manager Incident Manager Contacts",
        serviceId: "SSM Contacts",
        signatureVersion: "v4",
        signingName: "ssm-contacts",
        targetPrefix: "SSMContacts",
        uid: "ssm-contacts-2021-05-03"
      },
      operations: {
        AcceptPage: {
          input: {
            type: "structure",
            required: [
              "PageId",
              "AcceptType",
              "AcceptCode"
            ],
            members: {
              PageId: {},
              ContactChannelId: {},
              AcceptType: {},
              Note: {},
              AcceptCode: {},
              AcceptCodeValidation: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ActivateContactChannel: {
          input: {
            type: "structure",
            required: [
              "ContactChannelId",
              "ActivationCode"
            ],
            members: {
              ContactChannelId: {},
              ActivationCode: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateContact: {
          input: {
            type: "structure",
            required: [
              "Alias",
              "Type",
              "Plan"
            ],
            members: {
              Alias: {},
              DisplayName: {},
              Type: {},
              Plan: {
                shape: "Sf"
              },
              Tags: {
                shape: "Sq"
              },
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ContactArn"
            ],
            members: {
              ContactArn: {}
            }
          }
        },
        CreateContactChannel: {
          input: {
            type: "structure",
            required: [
              "ContactId",
              "Name",
              "Type",
              "DeliveryAddress"
            ],
            members: {
              ContactId: {},
              Name: {},
              Type: {},
              DeliveryAddress: {
                shape: "Sz"
              },
              DeferActivation: {
                type: "boolean"
              },
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ContactChannelArn"
            ],
            members: {
              ContactChannelArn: {}
            }
          }
        },
        CreateRotation: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ContactIds",
              "TimeZoneId",
              "Recurrence"
            ],
            members: {
              Name: {},
              ContactIds: {
                shape: "S15"
              },
              StartTime: {
                type: "timestamp"
              },
              TimeZoneId: {},
              Recurrence: {
                shape: "S18"
              },
              Tags: {
                shape: "Sq"
              },
              IdempotencyToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "RotationArn"
            ],
            members: {
              RotationArn: {}
            }
          }
        },
        CreateRotationOverride: {
          input: {
            type: "structure",
            required: [
              "RotationId",
              "NewContactIds",
              "StartTime",
              "EndTime"
            ],
            members: {
              RotationId: {},
              NewContactIds: {
                type: "list",
                member: {}
              },
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              IdempotencyToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "RotationOverrideId"
            ],
            members: {
              RotationOverrideId: {}
            }
          }
        },
        DeactivateContactChannel: {
          input: {
            type: "structure",
            required: [
              "ContactChannelId"
            ],
            members: {
              ContactChannelId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteContact: {
          input: {
            type: "structure",
            required: [
              "ContactId"
            ],
            members: {
              ContactId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteContactChannel: {
          input: {
            type: "structure",
            required: [
              "ContactChannelId"
            ],
            members: {
              ContactChannelId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRotation: {
          input: {
            type: "structure",
            required: [
              "RotationId"
            ],
            members: {
              RotationId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRotationOverride: {
          input: {
            type: "structure",
            required: [
              "RotationId",
              "RotationOverrideId"
            ],
            members: {
              RotationId: {},
              RotationOverrideId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeEngagement: {
          input: {
            type: "structure",
            required: [
              "EngagementId"
            ],
            members: {
              EngagementId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ContactArn",
              "EngagementArn",
              "Sender",
              "Subject",
              "Content"
            ],
            members: {
              ContactArn: {},
              EngagementArn: {},
              Sender: {},
              Subject: {},
              Content: {},
              PublicSubject: {},
              PublicContent: {},
              IncidentId: {},
              StartTime: {
                type: "timestamp"
              },
              StopTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribePage: {
          input: {
            type: "structure",
            required: [
              "PageId"
            ],
            members: {
              PageId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "PageArn",
              "EngagementArn",
              "ContactArn",
              "Sender",
              "Subject",
              "Content"
            ],
            members: {
              PageArn: {},
              EngagementArn: {},
              ContactArn: {},
              Sender: {},
              Subject: {},
              Content: {},
              PublicSubject: {},
              PublicContent: {},
              IncidentId: {},
              SentTime: {
                type: "timestamp"
              },
              ReadTime: {
                type: "timestamp"
              },
              DeliveryTime: {
                type: "timestamp"
              }
            }
          }
        },
        GetContact: {
          input: {
            type: "structure",
            required: [
              "ContactId"
            ],
            members: {
              ContactId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ContactArn",
              "Alias",
              "Type",
              "Plan"
            ],
            members: {
              ContactArn: {},
              Alias: {},
              DisplayName: {},
              Type: {},
              Plan: {
                shape: "Sf"
              }
            }
          }
        },
        GetContactChannel: {
          input: {
            type: "structure",
            required: [
              "ContactChannelId"
            ],
            members: {
              ContactChannelId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ContactArn",
              "ContactChannelArn",
              "Name",
              "Type",
              "DeliveryAddress"
            ],
            members: {
              ContactArn: {},
              ContactChannelArn: {},
              Name: {},
              Type: {},
              DeliveryAddress: {
                shape: "Sz"
              },
              ActivationStatus: {}
            }
          }
        },
        GetContactPolicy: {
          input: {
            type: "structure",
            required: [
              "ContactArn"
            ],
            members: {
              ContactArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ContactArn: {},
              Policy: {}
            }
          }
        },
        GetRotation: {
          input: {
            type: "structure",
            required: [
              "RotationId"
            ],
            members: {
              RotationId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "RotationArn",
              "Name",
              "ContactIds",
              "StartTime",
              "TimeZoneId",
              "Recurrence"
            ],
            members: {
              RotationArn: {},
              Name: {},
              ContactIds: {
                shape: "S15"
              },
              StartTime: {
                type: "timestamp"
              },
              TimeZoneId: {},
              Recurrence: {
                shape: "S18"
              }
            }
          }
        },
        GetRotationOverride: {
          input: {
            type: "structure",
            required: [
              "RotationId",
              "RotationOverrideId"
            ],
            members: {
              RotationId: {},
              RotationOverrideId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RotationOverrideId: {},
              RotationArn: {},
              NewContactIds: {
                shape: "Sp"
              },
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              CreateTime: {
                type: "timestamp"
              }
            }
          }
        },
        ListContactChannels: {
          input: {
            type: "structure",
            required: [
              "ContactId"
            ],
            members: {
              ContactId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ContactChannels"
            ],
            members: {
              NextToken: {},
              ContactChannels: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ContactChannelArn",
                    "ContactArn",
                    "Name",
                    "DeliveryAddress",
                    "ActivationStatus"
                  ],
                  members: {
                    ContactChannelArn: {},
                    ContactArn: {},
                    Name: {},
                    Type: {},
                    DeliveryAddress: {
                      shape: "Sz"
                    },
                    ActivationStatus: {}
                  }
                }
              }
            }
          }
        },
        ListContacts: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              AliasPrefix: {},
              Type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Contacts: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ContactArn",
                    "Alias",
                    "Type"
                  ],
                  members: {
                    ContactArn: {},
                    Alias: {},
                    DisplayName: {},
                    Type: {}
                  }
                }
              }
            }
          }
        },
        ListEngagements: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              IncidentId: {},
              TimeRangeValue: {
                type: "structure",
                members: {
                  StartTime: {
                    type: "timestamp"
                  },
                  EndTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Engagements"
            ],
            members: {
              NextToken: {},
              Engagements: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "EngagementArn",
                    "ContactArn",
                    "Sender"
                  ],
                  members: {
                    EngagementArn: {},
                    ContactArn: {},
                    Sender: {},
                    IncidentId: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    StopTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListPageReceipts: {
          input: {
            type: "structure",
            required: [
              "PageId"
            ],
            members: {
              PageId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Receipts: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ReceiptType",
                    "ReceiptTime"
                  ],
                  members: {
                    ContactChannelArn: {},
                    ReceiptType: {},
                    ReceiptInfo: {},
                    ReceiptTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListPageResolutions: {
          input: {
            type: "structure",
            required: [
              "PageId"
            ],
            members: {
              NextToken: {},
              PageId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "PageResolutions"
            ],
            members: {
              NextToken: {},
              PageResolutions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ContactArn",
                    "Type"
                  ],
                  members: {
                    ContactArn: {},
                    Type: {},
                    StageIndex: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        ListPagesByContact: {
          input: {
            type: "structure",
            required: [
              "ContactId"
            ],
            members: {
              ContactId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Pages"
            ],
            members: {
              NextToken: {},
              Pages: {
                shape: "S3g"
              }
            }
          }
        },
        ListPagesByEngagement: {
          input: {
            type: "structure",
            required: [
              "EngagementId"
            ],
            members: {
              EngagementId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Pages"
            ],
            members: {
              NextToken: {},
              Pages: {
                shape: "S3g"
              }
            }
          }
        },
        ListPreviewRotationShifts: {
          input: {
            type: "structure",
            required: [
              "EndTime",
              "Members",
              "TimeZoneId",
              "Recurrence"
            ],
            members: {
              RotationStartTime: {
                type: "timestamp"
              },
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Members: {
                type: "list",
                member: {}
              },
              TimeZoneId: {},
              Recurrence: {
                shape: "S18"
              },
              Overrides: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    NewMembers: {
                      type: "list",
                      member: {}
                    },
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RotationShifts: {
                shape: "S3r"
              },
              NextToken: {}
            }
          }
        },
        ListRotationOverrides: {
          input: {
            type: "structure",
            required: [
              "RotationId",
              "StartTime",
              "EndTime"
            ],
            members: {
              RotationId: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RotationOverrides: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "RotationOverrideId",
                    "NewContactIds",
                    "StartTime",
                    "EndTime",
                    "CreateTime"
                  ],
                  members: {
                    RotationOverrideId: {},
                    NewContactIds: {
                      shape: "Sp"
                    },
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    CreateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListRotationShifts: {
          input: {
            type: "structure",
            required: [
              "RotationId",
              "EndTime"
            ],
            members: {
              RotationId: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RotationShifts: {
                shape: "S3r"
              },
              NextToken: {}
            }
          }
        },
        ListRotations: {
          input: {
            type: "structure",
            members: {
              RotationNamePrefix: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Rotations"
            ],
            members: {
              NextToken: {},
              Rotations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "RotationArn",
                    "Name"
                  ],
                  members: {
                    RotationArn: {},
                    Name: {},
                    ContactIds: {
                      shape: "Sp"
                    },
                    StartTime: {
                      type: "timestamp"
                    },
                    TimeZoneId: {},
                    Recurrence: {
                      shape: "S18"
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sq"
              }
            }
          }
        },
        PutContactPolicy: {
          input: {
            type: "structure",
            required: [
              "ContactArn",
              "Policy"
            ],
            members: {
              ContactArn: {},
              Policy: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SendActivationCode: {
          input: {
            type: "structure",
            required: [
              "ContactChannelId"
            ],
            members: {
              ContactChannelId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartEngagement: {
          input: {
            type: "structure",
            required: [
              "ContactId",
              "Sender",
              "Subject",
              "Content"
            ],
            members: {
              ContactId: {},
              Sender: {},
              Subject: {},
              Content: {},
              PublicSubject: {},
              PublicContent: {},
              IncidentId: {},
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EngagementArn"
            ],
            members: {
              EngagementArn: {}
            }
          }
        },
        StopEngagement: {
          input: {
            type: "structure",
            required: [
              "EngagementId"
            ],
            members: {
              EngagementId: {},
              Reason: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateContact: {
          input: {
            type: "structure",
            required: [
              "ContactId"
            ],
            members: {
              ContactId: {},
              DisplayName: {},
              Plan: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateContactChannel: {
          input: {
            type: "structure",
            required: [
              "ContactChannelId"
            ],
            members: {
              ContactChannelId: {},
              Name: {},
              DeliveryAddress: {
                shape: "Sz"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateRotation: {
          input: {
            type: "structure",
            required: [
              "RotationId",
              "Recurrence"
            ],
            members: {
              RotationId: {},
              ContactIds: {
                shape: "S15"
              },
              StartTime: {
                type: "timestamp"
              },
              TimeZoneId: {},
              Recurrence: {
                shape: "S18"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        Sf: {
          type: "structure",
          members: {
            Stages: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "DurationInMinutes",
                  "Targets"
                ],
                members: {
                  DurationInMinutes: {
                    type: "integer"
                  },
                  Targets: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        ChannelTargetInfo: {
                          type: "structure",
                          required: [
                            "ContactChannelId"
                          ],
                          members: {
                            ContactChannelId: {},
                            RetryIntervalInMinutes: {
                              type: "integer"
                            }
                          }
                        },
                        ContactTargetInfo: {
                          type: "structure",
                          required: [
                            "IsEssential"
                          ],
                          members: {
                            ContactId: {},
                            IsEssential: {
                              type: "boolean"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            RotationIds: {
              shape: "Sp"
            }
          }
        },
        Sp: {
          type: "list",
          member: {}
        },
        Sq: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sz: {
          type: "structure",
          members: {
            SimpleAddress: {}
          }
        },
        S15: {
          type: "list",
          member: {}
        },
        S18: {
          type: "structure",
          required: [
            "NumberOfOnCalls",
            "RecurrenceMultiplier"
          ],
          members: {
            MonthlySettings: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "DayOfMonth",
                  "HandOffTime"
                ],
                members: {
                  DayOfMonth: {
                    type: "integer"
                  },
                  HandOffTime: {
                    shape: "S1c"
                  }
                }
              }
            },
            WeeklySettings: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "DayOfWeek",
                  "HandOffTime"
                ],
                members: {
                  DayOfWeek: {},
                  HandOffTime: {
                    shape: "S1c"
                  }
                }
              }
            },
            DailySettings: {
              type: "list",
              member: {
                shape: "S1c"
              }
            },
            NumberOfOnCalls: {
              type: "integer"
            },
            ShiftCoverages: {
              type: "map",
              key: {},
              value: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Start: {
                      shape: "S1c"
                    },
                    End: {
                      shape: "S1c"
                    }
                  }
                }
              }
            },
            RecurrenceMultiplier: {
              type: "integer"
            }
          }
        },
        S1c: {
          type: "structure",
          required: [
            "HourOfDay",
            "MinuteOfHour"
          ],
          members: {
            HourOfDay: {
              type: "integer"
            },
            MinuteOfHour: {
              type: "integer"
            }
          }
        },
        S3g: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "PageArn",
              "EngagementArn",
              "ContactArn",
              "Sender"
            ],
            members: {
              PageArn: {},
              EngagementArn: {},
              ContactArn: {},
              Sender: {},
              IncidentId: {},
              SentTime: {
                type: "timestamp"
              },
              DeliveryTime: {
                type: "timestamp"
              },
              ReadTime: {
                type: "timestamp"
              }
            }
          }
        },
        S3r: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "StartTime",
              "EndTime"
            ],
            members: {
              ContactIds: {
                shape: "Sp"
              },
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Type: {},
              ShiftDetails: {
                type: "structure",
                required: [
                  "OverriddenContactIds"
                ],
                members: {
                  OverriddenContactIds: {
                    shape: "Sp"
                  }
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ssm-contacts-2021-05-03.paginators.json
var require_ssm_contacts_2021_05_03_paginators = __commonJS({
  "node_modules/aws-sdk/apis/ssm-contacts-2021-05-03.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListContactChannels: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ContactChannels"
        },
        ListContacts: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Contacts"
        },
        ListEngagements: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Engagements"
        },
        ListPageReceipts: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Receipts"
        },
        ListPageResolutions: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "PageResolutions"
        },
        ListPagesByContact: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Pages"
        },
        ListPagesByEngagement: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Pages"
        },
        ListPreviewRotationShifts: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "RotationShifts"
        },
        ListRotationOverrides: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "RotationOverrides"
        },
        ListRotationShifts: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "RotationShifts"
        },
        ListRotations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Rotations"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/ssmcontacts.js
var require_ssmcontacts = __commonJS({
  "node_modules/aws-sdk/clients/ssmcontacts.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["ssmcontacts"] = {};
    AWS2.SSMContacts = Service.defineService("ssmcontacts", ["2021-05-03"]);
    Object.defineProperty(apiLoader.services["ssmcontacts"], "2021-05-03", {
      get: function get() {
        var model = require_ssm_contacts_2021_05_03_min();
        model.paginators = require_ssm_contacts_2021_05_03_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.SSMContacts;
  }
});

// node_modules/aws-sdk/apis/ssm-incidents-2018-05-10.min.json
var require_ssm_incidents_2018_05_10_min = __commonJS({
  "node_modules/aws-sdk/apis/ssm-incidents-2018-05-10.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-05-10",
        endpointPrefix: "ssm-incidents",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "SSM Incidents",
        serviceFullName: "AWS Systems Manager Incident Manager",
        serviceId: "SSM Incidents",
        signatureVersion: "v4",
        signingName: "ssm-incidents",
        uid: "ssm-incidents-2018-05-10"
      },
      operations: {
        BatchGetIncidentFindings: {
          http: {
            requestUri: "/batchGetIncidentFindings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "findingIds",
              "incidentRecordArn"
            ],
            members: {
              findingIds: {
                type: "list",
                member: {}
              },
              incidentRecordArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "errors",
              "findings"
            ],
            members: {
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "code",
                    "findingId",
                    "message"
                  ],
                  members: {
                    code: {},
                    findingId: {},
                    message: {}
                  }
                }
              },
              findings: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "creationTime",
                    "id",
                    "lastModifiedTime"
                  ],
                  members: {
                    creationTime: {
                      type: "timestamp"
                    },
                    details: {
                      type: "structure",
                      members: {
                        cloudFormationStackUpdate: {
                          type: "structure",
                          required: [
                            "stackArn",
                            "startTime"
                          ],
                          members: {
                            endTime: {
                              type: "timestamp"
                            },
                            stackArn: {},
                            startTime: {
                              type: "timestamp"
                            }
                          }
                        },
                        codeDeployDeployment: {
                          type: "structure",
                          required: [
                            "deploymentGroupArn",
                            "deploymentId",
                            "startTime"
                          ],
                          members: {
                            deploymentGroupArn: {},
                            deploymentId: {},
                            endTime: {
                              type: "timestamp"
                            },
                            startTime: {
                              type: "timestamp"
                            }
                          }
                        }
                      },
                      union: true
                    },
                    id: {},
                    lastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        CreateReplicationSet: {
          http: {
            requestUri: "/createReplicationSet",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "regions"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              regions: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    sseKmsKeyId: {}
                  }
                }
              },
              tags: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          }
        },
        CreateResponsePlan: {
          http: {
            requestUri: "/createResponsePlan",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "incidentTemplate",
              "name"
            ],
            members: {
              actions: {
                shape: "Sr"
              },
              chatChannel: {
                shape: "S16"
              },
              clientToken: {
                idempotencyToken: true
              },
              displayName: {},
              engagements: {
                shape: "S1b"
              },
              incidentTemplate: {
                shape: "S1d"
              },
              integrations: {
                shape: "S1k"
              },
              name: {},
              tags: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          idempotent: true
        },
        CreateTimelineEvent: {
          http: {
            requestUri: "/createTimelineEvent",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "eventData",
              "eventTime",
              "eventType",
              "incidentRecordArn"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              eventData: {},
              eventReferences: {
                shape: "S1v"
              },
              eventTime: {
                type: "timestamp"
              },
              eventType: {},
              incidentRecordArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "eventId",
              "incidentRecordArn"
            ],
            members: {
              eventId: {},
              incidentRecordArn: {}
            }
          },
          idempotent: true
        },
        DeleteIncidentRecord: {
          http: {
            requestUri: "/deleteIncidentRecord",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteReplicationSet: {
          http: {
            requestUri: "/deleteReplicationSet",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {
                location: "querystring",
                locationName: "arn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteResourcePolicy: {
          http: {
            requestUri: "/deleteResourcePolicy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "policyId",
              "resourceArn"
            ],
            members: {
              policyId: {},
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteResponsePlan: {
          http: {
            requestUri: "/deleteResponsePlan",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteTimelineEvent: {
          http: {
            requestUri: "/deleteTimelineEvent",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "eventId",
              "incidentRecordArn"
            ],
            members: {
              eventId: {},
              incidentRecordArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        GetIncidentRecord: {
          http: {
            method: "GET",
            requestUri: "/getIncidentRecord",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {
                location: "querystring",
                locationName: "arn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "incidentRecord"
            ],
            members: {
              incidentRecord: {
                type: "structure",
                required: [
                  "arn",
                  "creationTime",
                  "dedupeString",
                  "impact",
                  "incidentRecordSource",
                  "lastModifiedBy",
                  "lastModifiedTime",
                  "status",
                  "title"
                ],
                members: {
                  arn: {},
                  automationExecutions: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        ssmExecutionArn: {}
                      },
                      union: true
                    }
                  },
                  chatChannel: {
                    shape: "S16"
                  },
                  creationTime: {
                    type: "timestamp"
                  },
                  dedupeString: {},
                  impact: {
                    type: "integer"
                  },
                  incidentRecordSource: {
                    shape: "S2h"
                  },
                  lastModifiedBy: {},
                  lastModifiedTime: {
                    type: "timestamp"
                  },
                  notificationTargets: {
                    shape: "S1g"
                  },
                  resolvedTime: {
                    type: "timestamp"
                  },
                  status: {},
                  summary: {},
                  title: {}
                }
              }
            }
          }
        },
        GetReplicationSet: {
          http: {
            method: "GET",
            requestUri: "/getReplicationSet",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {
                location: "querystring",
                locationName: "arn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "replicationSet"
            ],
            members: {
              replicationSet: {
                type: "structure",
                required: [
                  "createdBy",
                  "createdTime",
                  "deletionProtected",
                  "lastModifiedBy",
                  "lastModifiedTime",
                  "regionMap",
                  "status"
                ],
                members: {
                  arn: {},
                  createdBy: {},
                  createdTime: {
                    type: "timestamp"
                  },
                  deletionProtected: {
                    type: "boolean"
                  },
                  lastModifiedBy: {},
                  lastModifiedTime: {
                    type: "timestamp"
                  },
                  regionMap: {
                    type: "map",
                    key: {},
                    value: {
                      type: "structure",
                      required: [
                        "status",
                        "statusUpdateDateTime"
                      ],
                      members: {
                        sseKmsKeyId: {},
                        status: {},
                        statusMessage: {},
                        statusUpdateDateTime: {
                          type: "timestamp"
                        }
                      }
                    }
                  },
                  status: {}
                }
              }
            }
          }
        },
        GetResourcePolicies: {
          http: {
            requestUri: "/getResourcePolicies",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "resourcePolicies"
            ],
            members: {
              nextToken: {},
              resourcePolicies: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "policyDocument",
                    "policyId",
                    "ramResourceShareRegion"
                  ],
                  members: {
                    policyDocument: {},
                    policyId: {},
                    ramResourceShareRegion: {}
                  }
                }
              }
            }
          }
        },
        GetResponsePlan: {
          http: {
            method: "GET",
            requestUri: "/getResponsePlan",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {
                location: "querystring",
                locationName: "arn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "incidentTemplate",
              "name"
            ],
            members: {
              actions: {
                shape: "Sr"
              },
              arn: {},
              chatChannel: {
                shape: "S16"
              },
              displayName: {},
              engagements: {
                shape: "S1b"
              },
              incidentTemplate: {
                shape: "S1d"
              },
              integrations: {
                shape: "S1k"
              },
              name: {}
            }
          }
        },
        GetTimelineEvent: {
          http: {
            method: "GET",
            requestUri: "/getTimelineEvent",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "eventId",
              "incidentRecordArn"
            ],
            members: {
              eventId: {
                location: "querystring",
                locationName: "eventId"
              },
              incidentRecordArn: {
                location: "querystring",
                locationName: "incidentRecordArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "event"
            ],
            members: {
              event: {
                type: "structure",
                required: [
                  "eventData",
                  "eventId",
                  "eventTime",
                  "eventType",
                  "eventUpdatedTime",
                  "incidentRecordArn"
                ],
                members: {
                  eventData: {},
                  eventId: {},
                  eventReferences: {
                    shape: "S1v"
                  },
                  eventTime: {
                    type: "timestamp"
                  },
                  eventType: {},
                  eventUpdatedTime: {
                    type: "timestamp"
                  },
                  incidentRecordArn: {}
                }
              }
            }
          }
        },
        ListIncidentFindings: {
          http: {
            requestUri: "/listIncidentFindings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "incidentRecordArn"
            ],
            members: {
              incidentRecordArn: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "findings"
            ],
            members: {
              findings: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "lastModifiedTime"
                  ],
                  members: {
                    id: {},
                    lastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListIncidentRecords: {
          http: {
            requestUri: "/listIncidentRecords",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              filters: {
                shape: "S3b"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "incidentRecordSummaries"
            ],
            members: {
              incidentRecordSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "creationTime",
                    "impact",
                    "incidentRecordSource",
                    "status",
                    "title"
                  ],
                  members: {
                    arn: {},
                    creationTime: {
                      type: "timestamp"
                    },
                    impact: {
                      type: "integer"
                    },
                    incidentRecordSource: {
                      shape: "S2h"
                    },
                    resolvedTime: {
                      type: "timestamp"
                    },
                    status: {},
                    title: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListRelatedItems: {
          http: {
            requestUri: "/listRelatedItems",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "incidentRecordArn"
            ],
            members: {
              incidentRecordArn: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "relatedItems"
            ],
            members: {
              nextToken: {},
              relatedItems: {
                shape: "S3p"
              }
            }
          }
        },
        ListReplicationSets: {
          http: {
            requestUri: "/listReplicationSets",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "replicationSetArns"
            ],
            members: {
              nextToken: {},
              replicationSetArns: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ListResponsePlans: {
          http: {
            requestUri: "/listResponsePlans",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "responsePlanSummaries"
            ],
            members: {
              nextToken: {},
              responsePlanSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "name"
                  ],
                  members: {
                    arn: {},
                    displayName: {},
                    name: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "tags"
            ],
            members: {
              tags: {
                shape: "Sm"
              }
            }
          }
        },
        ListTimelineEvents: {
          http: {
            requestUri: "/listTimelineEvents",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "incidentRecordArn"
            ],
            members: {
              filters: {
                shape: "S3b"
              },
              incidentRecordArn: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              sortBy: {},
              sortOrder: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "eventSummaries"
            ],
            members: {
              eventSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "eventId",
                    "eventTime",
                    "eventType",
                    "eventUpdatedTime",
                    "incidentRecordArn"
                  ],
                  members: {
                    eventId: {},
                    eventReferences: {
                      shape: "S1v"
                    },
                    eventTime: {
                      type: "timestamp"
                    },
                    eventType: {},
                    eventUpdatedTime: {
                      type: "timestamp"
                    },
                    incidentRecordArn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        PutResourcePolicy: {
          http: {
            requestUri: "/putResourcePolicy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "policy",
              "resourceArn"
            ],
            members: {
              policy: {},
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "policyId"
            ],
            members: {
              policyId: {}
            }
          }
        },
        StartIncident: {
          http: {
            requestUri: "/startIncident",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "responsePlanArn"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              impact: {
                type: "integer"
              },
              relatedItems: {
                shape: "S3p"
              },
              responsePlanArn: {},
              title: {},
              triggerDetails: {
                type: "structure",
                required: [
                  "source",
                  "timestamp"
                ],
                members: {
                  rawData: {},
                  source: {},
                  timestamp: {
                    type: "timestamp"
                  },
                  triggerArn: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "incidentRecordArn"
            ],
            members: {
              incidentRecordArn: {}
            }
          },
          idempotent: true
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateDeletionProtection: {
          http: {
            requestUri: "/updateDeletionProtection",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "arn",
              "deletionProtected"
            ],
            members: {
              arn: {},
              clientToken: {
                idempotencyToken: true
              },
              deletionProtected: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateIncidentRecord: {
          http: {
            requestUri: "/updateIncidentRecord",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              chatChannel: {
                shape: "S16"
              },
              clientToken: {
                idempotencyToken: true
              },
              impact: {
                type: "integer"
              },
              notificationTargets: {
                shape: "S1g"
              },
              status: {},
              summary: {},
              title: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateRelatedItems: {
          http: {
            requestUri: "/updateRelatedItems",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "incidentRecordArn",
              "relatedItemsUpdate"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              incidentRecordArn: {},
              relatedItemsUpdate: {
                type: "structure",
                members: {
                  itemToAdd: {
                    shape: "S3q"
                  },
                  itemToRemove: {
                    shape: "S3r"
                  }
                },
                union: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateReplicationSet: {
          http: {
            requestUri: "/updateReplicationSet",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "actions",
              "arn"
            ],
            members: {
              actions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    addRegionAction: {
                      type: "structure",
                      required: [
                        "regionName"
                      ],
                      members: {
                        regionName: {},
                        sseKmsKeyId: {}
                      }
                    },
                    deleteRegionAction: {
                      type: "structure",
                      required: [
                        "regionName"
                      ],
                      members: {
                        regionName: {}
                      }
                    }
                  },
                  union: true
                }
              },
              arn: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateResponsePlan: {
          http: {
            requestUri: "/updateResponsePlan",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              actions: {
                shape: "Sr"
              },
              arn: {},
              chatChannel: {
                shape: "S16"
              },
              clientToken: {
                idempotencyToken: true
              },
              displayName: {},
              engagements: {
                shape: "S1b"
              },
              incidentTemplateDedupeString: {},
              incidentTemplateImpact: {
                type: "integer"
              },
              incidentTemplateNotificationTargets: {
                shape: "S1g"
              },
              incidentTemplateSummary: {},
              incidentTemplateTags: {
                type: "map",
                key: {},
                value: {}
              },
              incidentTemplateTitle: {},
              integrations: {
                shape: "S1k"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateTimelineEvent: {
          http: {
            requestUri: "/updateTimelineEvent",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "eventId",
              "incidentRecordArn"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              eventData: {},
              eventId: {},
              eventReferences: {
                shape: "S1v"
              },
              eventTime: {
                type: "timestamp"
              },
              eventType: {},
              incidentRecordArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        }
      },
      shapes: {
        Sm: {
          type: "map",
          key: {},
          value: {}
        },
        Sr: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ssmAutomation: {
                type: "structure",
                required: [
                  "documentName",
                  "roleArn"
                ],
                members: {
                  documentName: {},
                  documentVersion: {},
                  dynamicParameters: {
                    type: "map",
                    key: {},
                    value: {
                      type: "structure",
                      members: {
                        variable: {}
                      },
                      union: true
                    }
                  },
                  parameters: {
                    type: "map",
                    key: {},
                    value: {
                      type: "list",
                      member: {}
                    }
                  },
                  roleArn: {},
                  targetAccount: {}
                }
              }
            },
            union: true
          }
        },
        S16: {
          type: "structure",
          members: {
            chatbotSns: {
              type: "list",
              member: {}
            },
            empty: {
              type: "structure",
              members: {}
            }
          },
          union: true
        },
        S1b: {
          type: "list",
          member: {}
        },
        S1d: {
          type: "structure",
          required: [
            "impact",
            "title"
          ],
          members: {
            dedupeString: {},
            impact: {
              type: "integer"
            },
            incidentTags: {
              shape: "Sm"
            },
            notificationTargets: {
              shape: "S1g"
            },
            summary: {},
            title: {}
          }
        },
        S1g: {
          type: "list",
          member: {
            type: "structure",
            members: {
              snsTopicArn: {}
            },
            union: true
          }
        },
        S1k: {
          type: "list",
          member: {
            type: "structure",
            members: {
              pagerDutyConfiguration: {
                type: "structure",
                required: [
                  "name",
                  "pagerDutyIncidentConfiguration",
                  "secretId"
                ],
                members: {
                  name: {},
                  pagerDutyIncidentConfiguration: {
                    type: "structure",
                    required: [
                      "serviceId"
                    ],
                    members: {
                      serviceId: {}
                    }
                  },
                  secretId: {}
                }
              }
            },
            union: true
          }
        },
        S1v: {
          type: "list",
          member: {
            type: "structure",
            members: {
              relatedItemId: {},
              resource: {}
            },
            union: true
          }
        },
        S2h: {
          type: "structure",
          required: [
            "createdBy",
            "source"
          ],
          members: {
            createdBy: {},
            invokedBy: {},
            resourceArn: {},
            source: {}
          }
        },
        S3b: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "condition",
              "key"
            ],
            members: {
              condition: {
                type: "structure",
                members: {
                  after: {
                    type: "timestamp"
                  },
                  before: {
                    type: "timestamp"
                  },
                  equals: {
                    type: "structure",
                    members: {
                      integerValues: {
                        type: "list",
                        member: {
                          type: "integer"
                        }
                      },
                      stringValues: {
                        type: "list",
                        member: {}
                      }
                    },
                    union: true
                  }
                },
                union: true
              },
              key: {}
            }
          }
        },
        S3p: {
          type: "list",
          member: {
            shape: "S3q"
          }
        },
        S3q: {
          type: "structure",
          required: [
            "identifier"
          ],
          members: {
            generatedId: {},
            identifier: {
              shape: "S3r"
            },
            title: {}
          }
        },
        S3r: {
          type: "structure",
          required: [
            "type",
            "value"
          ],
          members: {
            type: {},
            value: {
              type: "structure",
              members: {
                arn: {},
                metricDefinition: {},
                pagerDutyIncidentDetail: {
                  type: "structure",
                  required: [
                    "id"
                  ],
                  members: {
                    autoResolve: {
                      type: "boolean"
                    },
                    id: {},
                    secretId: {}
                  }
                },
                url: {}
              },
              union: true
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ssm-incidents-2018-05-10.paginators.json
var require_ssm_incidents_2018_05_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/ssm-incidents-2018-05-10.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetResourcePolicies: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "resourcePolicies"
        },
        ListIncidentFindings: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "findings"
        },
        ListIncidentRecords: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "incidentRecordSummaries"
        },
        ListRelatedItems: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "relatedItems"
        },
        ListReplicationSets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "replicationSetArns"
        },
        ListResponsePlans: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "responsePlanSummaries"
        },
        ListTimelineEvents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "eventSummaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ssm-incidents-2018-05-10.waiters2.json
var require_ssm_incidents_2018_05_10_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/ssm-incidents-2018-05-10.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        WaitForReplicationSetActive: {
          description: "Wait for a replication set to become ACTIVE",
          delay: 30,
          maxAttempts: 5,
          operation: "GetReplicationSet",
          acceptors: [{
            matcher: "path",
            argument: "replicationSet.status",
            state: "success",
            expected: "ACTIVE"
          }, {
            matcher: "path",
            argument: "replicationSet.status",
            state: "retry",
            expected: "CREATING"
          }, {
            matcher: "path",
            argument: "replicationSet.status",
            state: "retry",
            expected: "UPDATING"
          }, {
            matcher: "path",
            argument: "replicationSet.status",
            state: "failure",
            expected: "FAILED"
          }]
        },
        WaitForReplicationSetDeleted: {
          description: "Wait for a replication set to be deleted",
          delay: 30,
          maxAttempts: 5,
          operation: "GetReplicationSet",
          acceptors: [{
            matcher: "error",
            state: "success",
            expected: "ResourceNotFoundException"
          }, {
            matcher: "path",
            argument: "replicationSet.status",
            state: "retry",
            expected: "DELETING"
          }, {
            matcher: "path",
            argument: "replicationSet.status",
            state: "failure",
            expected: "FAILED"
          }]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/ssmincidents.js
var require_ssmincidents = __commonJS({
  "node_modules/aws-sdk/clients/ssmincidents.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["ssmincidents"] = {};
    AWS2.SSMIncidents = Service.defineService("ssmincidents", ["2018-05-10"]);
    Object.defineProperty(apiLoader.services["ssmincidents"], "2018-05-10", {
      get: function get() {
        var model = require_ssm_incidents_2018_05_10_min();
        model.paginators = require_ssm_incidents_2018_05_10_paginators().pagination;
        model.waiters = require_ssm_incidents_2018_05_10_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.SSMIncidents;
  }
});

// node_modules/aws-sdk/apis/applicationcostprofiler-2020-09-10.min.json
var require_applicationcostprofiler_2020_09_10_min = __commonJS({
  "node_modules/aws-sdk/apis/applicationcostprofiler-2020-09-10.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-09-10",
        endpointPrefix: "application-cost-profiler",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Application Cost Profiler",
        serviceId: "ApplicationCostProfiler",
        signatureVersion: "v4",
        signingName: "application-cost-profiler",
        uid: "AWSApplicationCostProfiler-2020-09-10"
      },
      operations: {
        DeleteReportDefinition: {
          http: {
            method: "DELETE",
            requestUri: "/reportDefinition/{reportId}"
          },
          input: {
            type: "structure",
            required: [
              "reportId"
            ],
            members: {
              reportId: {
                location: "uri",
                locationName: "reportId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              reportId: {}
            }
          }
        },
        GetReportDefinition: {
          http: {
            method: "GET",
            requestUri: "/reportDefinition/{reportId}"
          },
          input: {
            type: "structure",
            required: [
              "reportId"
            ],
            members: {
              reportId: {
                location: "uri",
                locationName: "reportId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "reportId",
              "reportDescription",
              "reportFrequency",
              "format",
              "destinationS3Location",
              "createdAt",
              "lastUpdated"
            ],
            members: {
              reportId: {},
              reportDescription: {},
              reportFrequency: {},
              format: {},
              destinationS3Location: {
                shape: "S9"
              },
              createdAt: {
                type: "timestamp"
              },
              lastUpdated: {
                type: "timestamp"
              }
            }
          }
        },
        ImportApplicationUsage: {
          http: {
            requestUri: "/importApplicationUsage"
          },
          input: {
            type: "structure",
            required: [
              "sourceS3Location"
            ],
            members: {
              sourceS3Location: {
                type: "structure",
                required: [
                  "bucket",
                  "key"
                ],
                members: {
                  bucket: {},
                  key: {},
                  region: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "importId"
            ],
            members: {
              importId: {}
            }
          }
        },
        ListReportDefinitions: {
          http: {
            method: "GET",
            requestUri: "/reportDefinition"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              reportDefinitions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    reportId: {},
                    reportDescription: {},
                    reportFrequency: {},
                    format: {},
                    destinationS3Location: {
                      shape: "S9"
                    },
                    createdAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        PutReportDefinition: {
          http: {
            requestUri: "/reportDefinition"
          },
          input: {
            type: "structure",
            required: [
              "reportId",
              "reportDescription",
              "reportFrequency",
              "format",
              "destinationS3Location"
            ],
            members: {
              reportId: {},
              reportDescription: {},
              reportFrequency: {},
              format: {},
              destinationS3Location: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              reportId: {}
            }
          }
        },
        UpdateReportDefinition: {
          http: {
            method: "PUT",
            requestUri: "/reportDefinition/{reportId}"
          },
          input: {
            type: "structure",
            required: [
              "reportId",
              "reportDescription",
              "reportFrequency",
              "format",
              "destinationS3Location"
            ],
            members: {
              reportId: {
                location: "uri",
                locationName: "reportId"
              },
              reportDescription: {},
              reportFrequency: {},
              format: {},
              destinationS3Location: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              reportId: {}
            }
          }
        }
      },
      shapes: {
        S9: {
          type: "structure",
          required: [
            "bucket",
            "prefix"
          ],
          members: {
            bucket: {},
            prefix: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/applicationcostprofiler-2020-09-10.paginators.json
var require_applicationcostprofiler_2020_09_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/applicationcostprofiler-2020-09-10.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListReportDefinitions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "reportDefinitions"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/applicationcostprofiler.js
var require_applicationcostprofiler = __commonJS({
  "node_modules/aws-sdk/clients/applicationcostprofiler.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["applicationcostprofiler"] = {};
    AWS2.ApplicationCostProfiler = Service.defineService("applicationcostprofiler", ["2020-09-10"]);
    Object.defineProperty(apiLoader.services["applicationcostprofiler"], "2020-09-10", {
      get: function get() {
        var model = require_applicationcostprofiler_2020_09_10_min();
        model.paginators = require_applicationcostprofiler_2020_09_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ApplicationCostProfiler;
  }
});

// node_modules/aws-sdk/apis/apprunner-2020-05-15.min.json
var require_apprunner_2020_05_15_min = __commonJS({
  "node_modules/aws-sdk/apis/apprunner-2020-05-15.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-05-15",
        endpointPrefix: "apprunner",
        jsonVersion: "1.0",
        protocol: "json",
        serviceFullName: "AWS App Runner",
        serviceId: "AppRunner",
        signatureVersion: "v4",
        signingName: "apprunner",
        targetPrefix: "AppRunner",
        uid: "apprunner-2020-05-15"
      },
      operations: {
        AssociateCustomDomain: {
          input: {
            type: "structure",
            required: [
              "ServiceArn",
              "DomainName"
            ],
            members: {
              ServiceArn: {},
              DomainName: {},
              EnableWWWSubdomain: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DNSTarget",
              "ServiceArn",
              "CustomDomain",
              "VpcDNSTargets"
            ],
            members: {
              DNSTarget: {},
              ServiceArn: {},
              CustomDomain: {
                shape: "S7"
              },
              VpcDNSTargets: {
                shape: "Sc"
              }
            }
          }
        },
        CreateAutoScalingConfiguration: {
          input: {
            type: "structure",
            required: [
              "AutoScalingConfigurationName"
            ],
            members: {
              AutoScalingConfigurationName: {},
              MaxConcurrency: {
                type: "integer"
              },
              MinSize: {
                type: "integer"
              },
              MaxSize: {
                type: "integer"
              },
              Tags: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "AutoScalingConfiguration"
            ],
            members: {
              AutoScalingConfiguration: {
                shape: "So"
              }
            }
          }
        },
        CreateConnection: {
          input: {
            type: "structure",
            required: [
              "ConnectionName",
              "ProviderType"
            ],
            members: {
              ConnectionName: {},
              ProviderType: {},
              Tags: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Connection"
            ],
            members: {
              Connection: {
                shape: "S12"
              }
            }
          }
        },
        CreateObservabilityConfiguration: {
          input: {
            type: "structure",
            required: [
              "ObservabilityConfigurationName"
            ],
            members: {
              ObservabilityConfigurationName: {},
              TraceConfiguration: {
                shape: "S16"
              },
              Tags: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ObservabilityConfiguration"
            ],
            members: {
              ObservabilityConfiguration: {
                shape: "S19"
              }
            }
          }
        },
        CreateService: {
          input: {
            type: "structure",
            required: [
              "ServiceName",
              "SourceConfiguration"
            ],
            members: {
              ServiceName: {},
              SourceConfiguration: {
                shape: "S1f"
              },
              InstanceConfiguration: {
                shape: "S22"
              },
              Tags: {
                shape: "Sj"
              },
              EncryptionConfiguration: {
                shape: "S25"
              },
              HealthCheckConfiguration: {
                shape: "S27"
              },
              AutoScalingConfigurationArn: {},
              NetworkConfiguration: {
                shape: "S2e"
              },
              ObservabilityConfiguration: {
                shape: "S2j"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Service",
              "OperationId"
            ],
            members: {
              Service: {
                shape: "S2l"
              },
              OperationId: {}
            }
          }
        },
        CreateVpcConnector: {
          input: {
            type: "structure",
            required: [
              "VpcConnectorName",
              "Subnets"
            ],
            members: {
              VpcConnectorName: {},
              Subnets: {
                shape: "S2s"
              },
              SecurityGroups: {
                shape: "S2s"
              },
              Tags: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "VpcConnector"
            ],
            members: {
              VpcConnector: {
                shape: "S2u"
              }
            }
          }
        },
        CreateVpcIngressConnection: {
          input: {
            type: "structure",
            required: [
              "ServiceArn",
              "VpcIngressConnectionName",
              "IngressVpcConfiguration"
            ],
            members: {
              ServiceArn: {},
              VpcIngressConnectionName: {},
              IngressVpcConfiguration: {
                shape: "S2y"
              },
              Tags: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "VpcIngressConnection"
            ],
            members: {
              VpcIngressConnection: {
                shape: "S30"
              }
            }
          }
        },
        DeleteAutoScalingConfiguration: {
          input: {
            type: "structure",
            required: [
              "AutoScalingConfigurationArn"
            ],
            members: {
              AutoScalingConfigurationArn: {},
              DeleteAllRevisions: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "AutoScalingConfiguration"
            ],
            members: {
              AutoScalingConfiguration: {
                shape: "So"
              }
            }
          }
        },
        DeleteConnection: {
          input: {
            type: "structure",
            required: [
              "ConnectionArn"
            ],
            members: {
              ConnectionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Connection: {
                shape: "S12"
              }
            }
          }
        },
        DeleteObservabilityConfiguration: {
          input: {
            type: "structure",
            required: [
              "ObservabilityConfigurationArn"
            ],
            members: {
              ObservabilityConfigurationArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ObservabilityConfiguration"
            ],
            members: {
              ObservabilityConfiguration: {
                shape: "S19"
              }
            }
          }
        },
        DeleteService: {
          input: {
            type: "structure",
            required: [
              "ServiceArn"
            ],
            members: {
              ServiceArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Service",
              "OperationId"
            ],
            members: {
              Service: {
                shape: "S2l"
              },
              OperationId: {}
            }
          }
        },
        DeleteVpcConnector: {
          input: {
            type: "structure",
            required: [
              "VpcConnectorArn"
            ],
            members: {
              VpcConnectorArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "VpcConnector"
            ],
            members: {
              VpcConnector: {
                shape: "S2u"
              }
            }
          }
        },
        DeleteVpcIngressConnection: {
          input: {
            type: "structure",
            required: [
              "VpcIngressConnectionArn"
            ],
            members: {
              VpcIngressConnectionArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "VpcIngressConnection"
            ],
            members: {
              VpcIngressConnection: {
                shape: "S30"
              }
            }
          }
        },
        DescribeAutoScalingConfiguration: {
          input: {
            type: "structure",
            required: [
              "AutoScalingConfigurationArn"
            ],
            members: {
              AutoScalingConfigurationArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "AutoScalingConfiguration"
            ],
            members: {
              AutoScalingConfiguration: {
                shape: "So"
              }
            }
          }
        },
        DescribeCustomDomains: {
          input: {
            type: "structure",
            required: [
              "ServiceArn"
            ],
            members: {
              ServiceArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DNSTarget",
              "ServiceArn",
              "CustomDomains",
              "VpcDNSTargets"
            ],
            members: {
              DNSTarget: {},
              ServiceArn: {},
              CustomDomains: {
                type: "list",
                member: {
                  shape: "S7"
                }
              },
              VpcDNSTargets: {
                shape: "Sc"
              },
              NextToken: {}
            }
          }
        },
        DescribeObservabilityConfiguration: {
          input: {
            type: "structure",
            required: [
              "ObservabilityConfigurationArn"
            ],
            members: {
              ObservabilityConfigurationArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ObservabilityConfiguration"
            ],
            members: {
              ObservabilityConfiguration: {
                shape: "S19"
              }
            }
          }
        },
        DescribeService: {
          input: {
            type: "structure",
            required: [
              "ServiceArn"
            ],
            members: {
              ServiceArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Service"
            ],
            members: {
              Service: {
                shape: "S2l"
              }
            }
          }
        },
        DescribeVpcConnector: {
          input: {
            type: "structure",
            required: [
              "VpcConnectorArn"
            ],
            members: {
              VpcConnectorArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "VpcConnector"
            ],
            members: {
              VpcConnector: {
                shape: "S2u"
              }
            }
          }
        },
        DescribeVpcIngressConnection: {
          input: {
            type: "structure",
            required: [
              "VpcIngressConnectionArn"
            ],
            members: {
              VpcIngressConnectionArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "VpcIngressConnection"
            ],
            members: {
              VpcIngressConnection: {
                shape: "S30"
              }
            }
          }
        },
        DisassociateCustomDomain: {
          input: {
            type: "structure",
            required: [
              "ServiceArn",
              "DomainName"
            ],
            members: {
              ServiceArn: {},
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "DNSTarget",
              "ServiceArn",
              "CustomDomain",
              "VpcDNSTargets"
            ],
            members: {
              DNSTarget: {},
              ServiceArn: {},
              CustomDomain: {
                shape: "S7"
              },
              VpcDNSTargets: {
                shape: "Sc"
              }
            }
          }
        },
        ListAutoScalingConfigurations: {
          input: {
            type: "structure",
            members: {
              AutoScalingConfigurationName: {},
              LatestOnly: {
                type: "boolean"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "AutoScalingConfigurationSummaryList"
            ],
            members: {
              AutoScalingConfigurationSummaryList: {
                type: "list",
                member: {
                  shape: "S2o"
                }
              },
              NextToken: {}
            }
          }
        },
        ListConnections: {
          input: {
            type: "structure",
            members: {
              ConnectionName: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ConnectionSummaryList"
            ],
            members: {
              ConnectionSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ConnectionName: {},
                    ConnectionArn: {},
                    ProviderType: {},
                    Status: {},
                    CreatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListObservabilityConfigurations: {
          input: {
            type: "structure",
            members: {
              ObservabilityConfigurationName: {},
              LatestOnly: {
                type: "boolean"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ObservabilityConfigurationSummaryList"
            ],
            members: {
              ObservabilityConfigurationSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ObservabilityConfigurationArn: {},
                    ObservabilityConfigurationName: {},
                    ObservabilityConfigurationRevision: {
                      type: "integer"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListOperations: {
          input: {
            type: "structure",
            required: [
              "ServiceArn"
            ],
            members: {
              ServiceArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OperationSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Type: {},
                    Status: {},
                    TargetArn: {},
                    StartedAt: {
                      type: "timestamp"
                    },
                    EndedAt: {
                      type: "timestamp"
                    },
                    UpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListServices: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ServiceSummaryList"
            ],
            members: {
              ServiceSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ServiceName: {},
                    ServiceId: {},
                    ServiceArn: {},
                    ServiceUrl: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    UpdatedAt: {
                      type: "timestamp"
                    },
                    Status: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListServicesForAutoScalingConfiguration: {
          input: {
            type: "structure",
            required: [
              "AutoScalingConfigurationArn"
            ],
            members: {
              AutoScalingConfigurationArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ServiceArnList"
            ],
            members: {
              ServiceArnList: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sj"
              }
            }
          }
        },
        ListVpcConnectors: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "VpcConnectors"
            ],
            members: {
              VpcConnectors: {
                type: "list",
                member: {
                  shape: "S2u"
                }
              },
              NextToken: {}
            }
          }
        },
        ListVpcIngressConnections: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                members: {
                  ServiceArn: {},
                  VpcEndpointId: {}
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "VpcIngressConnectionSummaryList"
            ],
            members: {
              VpcIngressConnectionSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    VpcIngressConnectionArn: {},
                    ServiceArn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        PauseService: {
          input: {
            type: "structure",
            required: [
              "ServiceArn"
            ],
            members: {
              ServiceArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Service"
            ],
            members: {
              Service: {
                shape: "S2l"
              },
              OperationId: {}
            }
          }
        },
        ResumeService: {
          input: {
            type: "structure",
            required: [
              "ServiceArn"
            ],
            members: {
              ServiceArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Service"
            ],
            members: {
              Service: {
                shape: "S2l"
              },
              OperationId: {}
            }
          }
        },
        StartDeployment: {
          input: {
            type: "structure",
            required: [
              "ServiceArn"
            ],
            members: {
              ServiceArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "OperationId"
            ],
            members: {
              OperationId: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDefaultAutoScalingConfiguration: {
          input: {
            type: "structure",
            required: [
              "AutoScalingConfigurationArn"
            ],
            members: {
              AutoScalingConfigurationArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "AutoScalingConfiguration"
            ],
            members: {
              AutoScalingConfiguration: {
                shape: "So"
              }
            }
          }
        },
        UpdateService: {
          input: {
            type: "structure",
            required: [
              "ServiceArn"
            ],
            members: {
              ServiceArn: {},
              SourceConfiguration: {
                shape: "S1f"
              },
              InstanceConfiguration: {
                shape: "S22"
              },
              AutoScalingConfigurationArn: {},
              HealthCheckConfiguration: {
                shape: "S27"
              },
              NetworkConfiguration: {
                shape: "S2e"
              },
              ObservabilityConfiguration: {
                shape: "S2j"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Service",
              "OperationId"
            ],
            members: {
              Service: {
                shape: "S2l"
              },
              OperationId: {}
            }
          }
        },
        UpdateVpcIngressConnection: {
          input: {
            type: "structure",
            required: [
              "VpcIngressConnectionArn",
              "IngressVpcConfiguration"
            ],
            members: {
              VpcIngressConnectionArn: {},
              IngressVpcConfiguration: {
                shape: "S2y"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "VpcIngressConnection"
            ],
            members: {
              VpcIngressConnection: {
                shape: "S30"
              }
            }
          }
        }
      },
      shapes: {
        S7: {
          type: "structure",
          required: [
            "DomainName",
            "EnableWWWSubdomain",
            "Status"
          ],
          members: {
            DomainName: {},
            EnableWWWSubdomain: {
              type: "boolean"
            },
            CertificateValidationRecords: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Name: {},
                  Type: {},
                  Value: {},
                  Status: {}
                }
              }
            },
            Status: {}
          }
        },
        Sc: {
          type: "list",
          member: {
            type: "structure",
            members: {
              VpcIngressConnectionArn: {},
              VpcId: {},
              DomainName: {}
            }
          }
        },
        Sj: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        So: {
          type: "structure",
          members: {
            AutoScalingConfigurationArn: {},
            AutoScalingConfigurationName: {},
            AutoScalingConfigurationRevision: {
              type: "integer"
            },
            Latest: {
              type: "boolean"
            },
            Status: {},
            MaxConcurrency: {
              type: "integer"
            },
            MinSize: {
              type: "integer"
            },
            MaxSize: {
              type: "integer"
            },
            CreatedAt: {
              type: "timestamp"
            },
            DeletedAt: {
              type: "timestamp"
            },
            HasAssociatedService: {
              type: "boolean"
            },
            IsDefault: {
              type: "boolean"
            }
          }
        },
        S12: {
          type: "structure",
          members: {
            ConnectionName: {},
            ConnectionArn: {},
            ProviderType: {},
            Status: {},
            CreatedAt: {
              type: "timestamp"
            }
          }
        },
        S16: {
          type: "structure",
          required: [
            "Vendor"
          ],
          members: {
            Vendor: {}
          }
        },
        S19: {
          type: "structure",
          members: {
            ObservabilityConfigurationArn: {},
            ObservabilityConfigurationName: {},
            TraceConfiguration: {
              shape: "S16"
            },
            ObservabilityConfigurationRevision: {
              type: "integer"
            },
            Latest: {
              type: "boolean"
            },
            Status: {},
            CreatedAt: {
              type: "timestamp"
            },
            DeletedAt: {
              type: "timestamp"
            }
          }
        },
        S1f: {
          type: "structure",
          members: {
            CodeRepository: {
              type: "structure",
              required: [
                "RepositoryUrl",
                "SourceCodeVersion"
              ],
              members: {
                RepositoryUrl: {},
                SourceCodeVersion: {
                  type: "structure",
                  required: [
                    "Type",
                    "Value"
                  ],
                  members: {
                    Type: {},
                    Value: {}
                  }
                },
                CodeConfiguration: {
                  type: "structure",
                  required: [
                    "ConfigurationSource"
                  ],
                  members: {
                    ConfigurationSource: {},
                    CodeConfigurationValues: {
                      type: "structure",
                      required: [
                        "Runtime"
                      ],
                      members: {
                        Runtime: {},
                        BuildCommand: {
                          type: "string",
                          sensitive: true
                        },
                        StartCommand: {
                          shape: "S1o"
                        },
                        Port: {},
                        RuntimeEnvironmentVariables: {
                          shape: "S1p"
                        },
                        RuntimeEnvironmentSecrets: {
                          shape: "S1s"
                        }
                      }
                    }
                  }
                },
                SourceDirectory: {}
              }
            },
            ImageRepository: {
              type: "structure",
              required: [
                "ImageIdentifier",
                "ImageRepositoryType"
              ],
              members: {
                ImageIdentifier: {},
                ImageConfiguration: {
                  type: "structure",
                  members: {
                    RuntimeEnvironmentVariables: {
                      shape: "S1p"
                    },
                    StartCommand: {
                      shape: "S1o"
                    },
                    Port: {},
                    RuntimeEnvironmentSecrets: {
                      shape: "S1s"
                    }
                  }
                },
                ImageRepositoryType: {}
              }
            },
            AutoDeploymentsEnabled: {
              type: "boolean"
            },
            AuthenticationConfiguration: {
              type: "structure",
              members: {
                ConnectionArn: {},
                AccessRoleArn: {}
              }
            }
          }
        },
        S1o: {
          type: "string",
          sensitive: true
        },
        S1p: {
          type: "map",
          key: {
            type: "string",
            sensitive: true
          },
          value: {
            type: "string",
            sensitive: true
          }
        },
        S1s: {
          type: "map",
          key: {
            type: "string",
            sensitive: true
          },
          value: {
            type: "string",
            sensitive: true
          }
        },
        S22: {
          type: "structure",
          members: {
            Cpu: {},
            Memory: {},
            InstanceRoleArn: {}
          }
        },
        S25: {
          type: "structure",
          required: [
            "KmsKey"
          ],
          members: {
            KmsKey: {}
          }
        },
        S27: {
          type: "structure",
          members: {
            Protocol: {},
            Path: {},
            Interval: {
              type: "integer"
            },
            Timeout: {
              type: "integer"
            },
            HealthyThreshold: {
              type: "integer"
            },
            UnhealthyThreshold: {
              type: "integer"
            }
          }
        },
        S2e: {
          type: "structure",
          members: {
            EgressConfiguration: {
              type: "structure",
              members: {
                EgressType: {},
                VpcConnectorArn: {}
              }
            },
            IngressConfiguration: {
              type: "structure",
              members: {
                IsPubliclyAccessible: {
                  type: "boolean"
                }
              }
            },
            IpAddressType: {}
          }
        },
        S2j: {
          type: "structure",
          required: [
            "ObservabilityEnabled"
          ],
          members: {
            ObservabilityEnabled: {
              type: "boolean"
            },
            ObservabilityConfigurationArn: {}
          }
        },
        S2l: {
          type: "structure",
          required: [
            "ServiceName",
            "ServiceId",
            "ServiceArn",
            "CreatedAt",
            "UpdatedAt",
            "Status",
            "SourceConfiguration",
            "InstanceConfiguration",
            "AutoScalingConfigurationSummary",
            "NetworkConfiguration"
          ],
          members: {
            ServiceName: {},
            ServiceId: {},
            ServiceArn: {},
            ServiceUrl: {},
            CreatedAt: {
              type: "timestamp"
            },
            UpdatedAt: {
              type: "timestamp"
            },
            DeletedAt: {
              type: "timestamp"
            },
            Status: {},
            SourceConfiguration: {
              shape: "S1f"
            },
            InstanceConfiguration: {
              shape: "S22"
            },
            EncryptionConfiguration: {
              shape: "S25"
            },
            HealthCheckConfiguration: {
              shape: "S27"
            },
            AutoScalingConfigurationSummary: {
              shape: "S2o"
            },
            NetworkConfiguration: {
              shape: "S2e"
            },
            ObservabilityConfiguration: {
              shape: "S2j"
            }
          }
        },
        S2o: {
          type: "structure",
          members: {
            AutoScalingConfigurationArn: {},
            AutoScalingConfigurationName: {},
            AutoScalingConfigurationRevision: {
              type: "integer"
            },
            Status: {},
            CreatedAt: {
              type: "timestamp"
            },
            HasAssociatedService: {
              type: "boolean"
            },
            IsDefault: {
              type: "boolean"
            }
          }
        },
        S2s: {
          type: "list",
          member: {}
        },
        S2u: {
          type: "structure",
          members: {
            VpcConnectorName: {},
            VpcConnectorArn: {},
            VpcConnectorRevision: {
              type: "integer"
            },
            Subnets: {
              shape: "S2s"
            },
            SecurityGroups: {
              shape: "S2s"
            },
            Status: {},
            CreatedAt: {
              type: "timestamp"
            },
            DeletedAt: {
              type: "timestamp"
            }
          }
        },
        S2y: {
          type: "structure",
          members: {
            VpcId: {},
            VpcEndpointId: {}
          }
        },
        S30: {
          type: "structure",
          members: {
            VpcIngressConnectionArn: {},
            VpcIngressConnectionName: {},
            ServiceArn: {},
            Status: {},
            AccountId: {},
            DomainName: {},
            IngressVpcConfiguration: {
              shape: "S2y"
            },
            CreatedAt: {
              type: "timestamp"
            },
            DeletedAt: {
              type: "timestamp"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/apprunner-2020-05-15.paginators.json
var require_apprunner_2020_05_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/apprunner-2020-05-15.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeCustomDomains: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAutoScalingConfigurations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListConnections: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListObservabilityConfigurations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListOperations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListServices: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListServicesForAutoScalingConfiguration: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListVpcConnectors: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListVpcIngressConnections: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/apprunner.js
var require_apprunner = __commonJS({
  "node_modules/aws-sdk/clients/apprunner.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["apprunner"] = {};
    AWS2.AppRunner = Service.defineService("apprunner", ["2020-05-15"]);
    Object.defineProperty(apiLoader.services["apprunner"], "2020-05-15", {
      get: function get() {
        var model = require_apprunner_2020_05_15_min();
        model.paginators = require_apprunner_2020_05_15_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.AppRunner;
  }
});

// node_modules/aws-sdk/apis/proton-2020-07-20.min.json
var require_proton_2020_07_20_min = __commonJS({
  "node_modules/aws-sdk/apis/proton-2020-07-20.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-07-20",
        endpointPrefix: "proton",
        jsonVersion: "1.0",
        protocol: "json",
        serviceFullName: "AWS Proton",
        serviceId: "Proton",
        signatureVersion: "v4",
        signingName: "proton",
        targetPrefix: "AwsProton20200720",
        uid: "proton-2020-07-20"
      },
      operations: {
        AcceptEnvironmentAccountConnection: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "environmentAccountConnection"
            ],
            members: {
              environmentAccountConnection: {
                shape: "S4"
              }
            }
          },
          idempotent: true
        },
        CancelComponentDeployment: {
          input: {
            type: "structure",
            required: [
              "componentName"
            ],
            members: {
              componentName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "component"
            ],
            members: {
              component: {
                shape: "Se"
              }
            }
          }
        },
        CancelEnvironmentDeployment: {
          input: {
            type: "structure",
            required: [
              "environmentName"
            ],
            members: {
              environmentName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "environment"
            ],
            members: {
              environment: {
                shape: "So"
              }
            }
          }
        },
        CancelServiceInstanceDeployment: {
          input: {
            type: "structure",
            required: [
              "serviceInstanceName",
              "serviceName"
            ],
            members: {
              serviceInstanceName: {},
              serviceName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "serviceInstance"
            ],
            members: {
              serviceInstance: {
                shape: "Sz"
              }
            }
          }
        },
        CancelServicePipelineDeployment: {
          input: {
            type: "structure",
            required: [
              "serviceName"
            ],
            members: {
              serviceName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "pipeline"
            ],
            members: {
              pipeline: {
                shape: "S13"
              }
            }
          }
        },
        CreateComponent: {
          input: {
            type: "structure",
            required: [
              "manifest",
              "name",
              "templateFile"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              description: {
                shape: "Si"
              },
              environmentName: {},
              manifest: {
                type: "string",
                sensitive: true
              },
              name: {},
              serviceInstanceName: {},
              serviceName: {},
              serviceSpec: {
                shape: "Sl"
              },
              tags: {
                shape: "S17"
              },
              templateFile: {
                shape: "S1b"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "component"
            ],
            members: {
              component: {
                shape: "Se"
              }
            }
          },
          idempotent: true
        },
        CreateEnvironment: {
          input: {
            type: "structure",
            required: [
              "name",
              "spec",
              "templateMajorVersion",
              "templateName"
            ],
            members: {
              codebuildRoleArn: {},
              componentRoleArn: {},
              description: {
                shape: "Si"
              },
              environmentAccountConnectionId: {},
              name: {},
              protonServiceRoleArn: {},
              provisioningRepository: {
                shape: "S1e"
              },
              spec: {
                shape: "Sl"
              },
              tags: {
                shape: "S17"
              },
              templateMajorVersion: {},
              templateMinorVersion: {},
              templateName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "environment"
            ],
            members: {
              environment: {
                shape: "So"
              }
            }
          },
          idempotent: true
        },
        CreateEnvironmentAccountConnection: {
          input: {
            type: "structure",
            required: [
              "environmentName",
              "managementAccountId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              codebuildRoleArn: {},
              componentRoleArn: {},
              environmentName: {},
              managementAccountId: {},
              roleArn: {},
              tags: {
                shape: "S17"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "environmentAccountConnection"
            ],
            members: {
              environmentAccountConnection: {
                shape: "S4"
              }
            }
          },
          idempotent: true
        },
        CreateEnvironmentTemplate: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              description: {
                shape: "Si"
              },
              displayName: {
                shape: "S1j"
              },
              encryptionKey: {},
              name: {},
              provisioning: {},
              tags: {
                shape: "S17"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "environmentTemplate"
            ],
            members: {
              environmentTemplate: {
                shape: "S1l"
              }
            }
          },
          idempotent: true
        },
        CreateEnvironmentTemplateVersion: {
          input: {
            type: "structure",
            required: [
              "source",
              "templateName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              description: {
                shape: "Si"
              },
              majorVersion: {},
              source: {
                shape: "S1p"
              },
              tags: {
                shape: "S17"
              },
              templateName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "environmentTemplateVersion"
            ],
            members: {
              environmentTemplateVersion: {
                shape: "S1u"
              }
            }
          },
          idempotent: true
        },
        CreateRepository: {
          input: {
            type: "structure",
            required: [
              "connectionArn",
              "name",
              "provider"
            ],
            members: {
              connectionArn: {},
              encryptionKey: {},
              name: {},
              provider: {},
              tags: {
                shape: "S17"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "repository"
            ],
            members: {
              repository: {
                shape: "S20"
              }
            }
          },
          idempotent: true
        },
        CreateService: {
          input: {
            type: "structure",
            required: [
              "name",
              "spec",
              "templateMajorVersion",
              "templateName"
            ],
            members: {
              branchName: {},
              description: {
                shape: "Si"
              },
              name: {},
              repositoryConnectionArn: {},
              repositoryId: {},
              spec: {
                shape: "Sl"
              },
              tags: {
                shape: "S17"
              },
              templateMajorVersion: {},
              templateMinorVersion: {},
              templateName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "service"
            ],
            members: {
              service: {
                shape: "S24"
              }
            }
          },
          idempotent: true
        },
        CreateServiceInstance: {
          input: {
            type: "structure",
            required: [
              "name",
              "serviceName",
              "spec"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              name: {},
              serviceName: {},
              spec: {
                shape: "Sl"
              },
              tags: {
                shape: "S17"
              },
              templateMajorVersion: {},
              templateMinorVersion: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "serviceInstance"
            ],
            members: {
              serviceInstance: {
                shape: "Sz"
              }
            }
          },
          idempotent: true
        },
        CreateServiceSyncConfig: {
          input: {
            type: "structure",
            required: [
              "branch",
              "filePath",
              "repositoryName",
              "repositoryProvider",
              "serviceName"
            ],
            members: {
              branch: {},
              filePath: {},
              repositoryName: {},
              repositoryProvider: {},
              serviceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              serviceSyncConfig: {
                shape: "S2c"
              }
            }
          },
          idempotent: true
        },
        CreateServiceTemplate: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              description: {
                shape: "Si"
              },
              displayName: {
                shape: "S1j"
              },
              encryptionKey: {},
              name: {},
              pipelineProvisioning: {},
              tags: {
                shape: "S17"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "serviceTemplate"
            ],
            members: {
              serviceTemplate: {
                shape: "S2f"
              }
            }
          },
          idempotent: true
        },
        CreateServiceTemplateVersion: {
          input: {
            type: "structure",
            required: [
              "compatibleEnvironmentTemplates",
              "source",
              "templateName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              compatibleEnvironmentTemplates: {
                shape: "S2i"
              },
              description: {
                shape: "Si"
              },
              majorVersion: {},
              source: {
                shape: "S1p"
              },
              supportedComponentSources: {
                shape: "S2k"
              },
              tags: {
                shape: "S17"
              },
              templateName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "serviceTemplateVersion"
            ],
            members: {
              serviceTemplateVersion: {
                shape: "S2n"
              }
            }
          },
          idempotent: true
        },
        CreateTemplateSyncConfig: {
          input: {
            type: "structure",
            required: [
              "branch",
              "repositoryName",
              "repositoryProvider",
              "templateName",
              "templateType"
            ],
            members: {
              branch: {},
              repositoryName: {},
              repositoryProvider: {},
              subdirectory: {},
              templateName: {},
              templateType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              templateSyncConfig: {
                shape: "S2v"
              }
            }
          },
          idempotent: true
        },
        DeleteComponent: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              component: {
                shape: "Se"
              }
            }
          },
          idempotent: true
        },
        DeleteDeployment: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deployment: {
                shape: "S30"
              }
            }
          },
          idempotent: true
        },
        DeleteEnvironment: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              environment: {
                shape: "So"
              }
            }
          },
          idempotent: true
        },
        DeleteEnvironmentAccountConnection: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              environmentAccountConnection: {
                shape: "S4"
              }
            }
          },
          idempotent: true
        },
        DeleteEnvironmentTemplate: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              environmentTemplate: {
                shape: "S1l"
              }
            }
          },
          idempotent: true
        },
        DeleteEnvironmentTemplateVersion: {
          input: {
            type: "structure",
            required: [
              "majorVersion",
              "minorVersion",
              "templateName"
            ],
            members: {
              majorVersion: {},
              minorVersion: {},
              templateName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              environmentTemplateVersion: {
                shape: "S1u"
              }
            }
          },
          idempotent: true
        },
        DeleteRepository: {
          input: {
            type: "structure",
            required: [
              "name",
              "provider"
            ],
            members: {
              name: {},
              provider: {}
            }
          },
          output: {
            type: "structure",
            members: {
              repository: {
                shape: "S20"
              }
            }
          },
          idempotent: true
        },
        DeleteService: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              service: {
                shape: "S24"
              }
            }
          },
          idempotent: true
        },
        DeleteServiceSyncConfig: {
          input: {
            type: "structure",
            required: [
              "serviceName"
            ],
            members: {
              serviceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              serviceSyncConfig: {
                shape: "S2c"
              }
            }
          },
          idempotent: true
        },
        DeleteServiceTemplate: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              serviceTemplate: {
                shape: "S2f"
              }
            }
          },
          idempotent: true
        },
        DeleteServiceTemplateVersion: {
          input: {
            type: "structure",
            required: [
              "majorVersion",
              "minorVersion",
              "templateName"
            ],
            members: {
              majorVersion: {},
              minorVersion: {},
              templateName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              serviceTemplateVersion: {
                shape: "S2n"
              }
            }
          },
          idempotent: true
        },
        DeleteTemplateSyncConfig: {
          input: {
            type: "structure",
            required: [
              "templateName",
              "templateType"
            ],
            members: {
              templateName: {},
              templateType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              templateSyncConfig: {
                shape: "S2v"
              }
            }
          },
          idempotent: true
        },
        GetAccountSettings: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              accountSettings: {
                shape: "S3w"
              }
            }
          }
        },
        GetComponent: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              component: {
                shape: "Se"
              }
            }
          }
        },
        GetDeployment: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              componentName: {},
              environmentName: {},
              id: {},
              serviceInstanceName: {},
              serviceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deployment: {
                shape: "S30"
              }
            }
          }
        },
        GetEnvironment: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "environment"
            ],
            members: {
              environment: {
                shape: "So"
              }
            }
          }
        },
        GetEnvironmentAccountConnection: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "environmentAccountConnection"
            ],
            members: {
              environmentAccountConnection: {
                shape: "S4"
              }
            }
          }
        },
        GetEnvironmentTemplate: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "environmentTemplate"
            ],
            members: {
              environmentTemplate: {
                shape: "S1l"
              }
            }
          }
        },
        GetEnvironmentTemplateVersion: {
          input: {
            type: "structure",
            required: [
              "majorVersion",
              "minorVersion",
              "templateName"
            ],
            members: {
              majorVersion: {},
              minorVersion: {},
              templateName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "environmentTemplateVersion"
            ],
            members: {
              environmentTemplateVersion: {
                shape: "S1u"
              }
            }
          }
        },
        GetRepository: {
          input: {
            type: "structure",
            required: [
              "name",
              "provider"
            ],
            members: {
              name: {},
              provider: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "repository"
            ],
            members: {
              repository: {
                shape: "S20"
              }
            }
          }
        },
        GetRepositorySyncStatus: {
          input: {
            type: "structure",
            required: [
              "branch",
              "repositoryName",
              "repositoryProvider",
              "syncType"
            ],
            members: {
              branch: {},
              repositoryName: {},
              repositoryProvider: {},
              syncType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              latestSync: {
                type: "structure",
                required: [
                  "events",
                  "startedAt",
                  "status"
                ],
                members: {
                  events: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "event",
                        "time",
                        "type"
                      ],
                      members: {
                        event: {},
                        externalId: {},
                        time: {
                          type: "timestamp"
                        },
                        type: {}
                      }
                    }
                  },
                  startedAt: {
                    type: "timestamp"
                  },
                  status: {}
                }
              }
            }
          }
        },
        GetResourcesSummary: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "counts"
            ],
            members: {
              counts: {
                type: "structure",
                members: {
                  components: {
                    shape: "S4m"
                  },
                  environmentTemplates: {
                    shape: "S4m"
                  },
                  environments: {
                    shape: "S4m"
                  },
                  pipelines: {
                    shape: "S4m"
                  },
                  serviceInstances: {
                    shape: "S4m"
                  },
                  serviceTemplates: {
                    shape: "S4m"
                  },
                  services: {
                    shape: "S4m"
                  }
                }
              }
            }
          }
        },
        GetService: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              service: {
                shape: "S24"
              }
            }
          }
        },
        GetServiceInstance: {
          input: {
            type: "structure",
            required: [
              "name",
              "serviceName"
            ],
            members: {
              name: {},
              serviceName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "serviceInstance"
            ],
            members: {
              serviceInstance: {
                shape: "Sz"
              }
            }
          }
        },
        GetServiceInstanceSyncStatus: {
          input: {
            type: "structure",
            required: [
              "serviceInstanceName",
              "serviceName"
            ],
            members: {
              serviceInstanceName: {},
              serviceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              desiredState: {
                shape: "S4u"
              },
              latestSuccessfulSync: {
                shape: "S4w"
              },
              latestSync: {
                shape: "S4w"
              }
            }
          }
        },
        GetServiceSyncBlockerSummary: {
          input: {
            type: "structure",
            required: [
              "serviceName"
            ],
            members: {
              serviceInstanceName: {},
              serviceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              serviceSyncBlockerSummary: {
                type: "structure",
                required: [
                  "serviceName"
                ],
                members: {
                  latestBlockers: {
                    type: "list",
                    member: {
                      shape: "S54"
                    }
                  },
                  serviceInstanceName: {},
                  serviceName: {}
                }
              }
            }
          }
        },
        GetServiceSyncConfig: {
          input: {
            type: "structure",
            required: [
              "serviceName"
            ],
            members: {
              serviceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              serviceSyncConfig: {
                shape: "S2c"
              }
            }
          }
        },
        GetServiceTemplate: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "serviceTemplate"
            ],
            members: {
              serviceTemplate: {
                shape: "S2f"
              }
            }
          }
        },
        GetServiceTemplateVersion: {
          input: {
            type: "structure",
            required: [
              "majorVersion",
              "minorVersion",
              "templateName"
            ],
            members: {
              majorVersion: {},
              minorVersion: {},
              templateName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "serviceTemplateVersion"
            ],
            members: {
              serviceTemplateVersion: {
                shape: "S2n"
              }
            }
          }
        },
        GetTemplateSyncConfig: {
          input: {
            type: "structure",
            required: [
              "templateName",
              "templateType"
            ],
            members: {
              templateName: {},
              templateType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              templateSyncConfig: {
                shape: "S2v"
              }
            }
          }
        },
        GetTemplateSyncStatus: {
          input: {
            type: "structure",
            required: [
              "templateName",
              "templateType",
              "templateVersion"
            ],
            members: {
              templateName: {},
              templateType: {},
              templateVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              desiredState: {
                shape: "S4u"
              },
              latestSuccessfulSync: {
                shape: "S4w"
              },
              latestSync: {
                shape: "S4w"
              }
            }
          }
        },
        ListComponentOutputs: {
          input: {
            type: "structure",
            required: [
              "componentName"
            ],
            members: {
              componentName: {},
              deploymentId: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "outputs"
            ],
            members: {
              nextToken: {},
              outputs: {
                shape: "S5m"
              }
            }
          }
        },
        ListComponentProvisionedResources: {
          input: {
            type: "structure",
            required: [
              "componentName"
            ],
            members: {
              componentName: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "provisionedResources"
            ],
            members: {
              nextToken: {},
              provisionedResources: {
                shape: "S5s"
              }
            }
          }
        },
        ListComponents: {
          input: {
            type: "structure",
            members: {
              environmentName: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              serviceInstanceName: {},
              serviceName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "components"
            ],
            members: {
              components: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "deploymentStatus",
                    "environmentName",
                    "lastModifiedAt",
                    "name"
                  ],
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    deploymentStatus: {},
                    deploymentStatusMessage: {
                      shape: "Sh"
                    },
                    environmentName: {},
                    lastAttemptedDeploymentId: {},
                    lastDeploymentAttemptedAt: {
                      type: "timestamp"
                    },
                    lastDeploymentSucceededAt: {
                      type: "timestamp"
                    },
                    lastModifiedAt: {
                      type: "timestamp"
                    },
                    lastSucceededDeploymentId: {},
                    name: {},
                    serviceInstanceName: {},
                    serviceName: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDeployments: {
          input: {
            type: "structure",
            members: {
              componentName: {},
              environmentName: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              serviceInstanceName: {},
              serviceName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "deployments"
            ],
            members: {
              deployments: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "deploymentStatus",
                    "environmentName",
                    "id",
                    "lastModifiedAt",
                    "targetArn",
                    "targetResourceCreatedAt",
                    "targetResourceType"
                  ],
                  members: {
                    arn: {},
                    completedAt: {
                      type: "timestamp"
                    },
                    componentName: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    deploymentStatus: {},
                    environmentName: {},
                    id: {},
                    lastAttemptedDeploymentId: {},
                    lastModifiedAt: {
                      type: "timestamp"
                    },
                    lastSucceededDeploymentId: {},
                    serviceInstanceName: {},
                    serviceName: {},
                    targetArn: {},
                    targetResourceCreatedAt: {
                      type: "timestamp"
                    },
                    targetResourceType: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListEnvironmentAccountConnections: {
          input: {
            type: "structure",
            required: [
              "requestedBy"
            ],
            members: {
              environmentName: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              requestedBy: {},
              statuses: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "environmentAccountConnections"
            ],
            members: {
              environmentAccountConnections: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "environmentAccountId",
                    "environmentName",
                    "id",
                    "lastModifiedAt",
                    "managementAccountId",
                    "requestedAt",
                    "roleArn",
                    "status"
                  ],
                  members: {
                    arn: {},
                    componentRoleArn: {},
                    environmentAccountId: {},
                    environmentName: {},
                    id: {},
                    lastModifiedAt: {
                      type: "timestamp"
                    },
                    managementAccountId: {},
                    requestedAt: {
                      type: "timestamp"
                    },
                    roleArn: {},
                    status: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListEnvironmentOutputs: {
          input: {
            type: "structure",
            required: [
              "environmentName"
            ],
            members: {
              deploymentId: {},
              environmentName: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "outputs"
            ],
            members: {
              nextToken: {},
              outputs: {
                shape: "S5m"
              }
            }
          }
        },
        ListEnvironmentProvisionedResources: {
          input: {
            type: "structure",
            required: [
              "environmentName"
            ],
            members: {
              environmentName: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "provisionedResources"
            ],
            members: {
              nextToken: {},
              provisionedResources: {
                shape: "S5s"
              }
            }
          }
        },
        ListEnvironmentTemplateVersions: {
          input: {
            type: "structure",
            required: [
              "templateName"
            ],
            members: {
              majorVersion: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              templateName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "templateVersions"
            ],
            members: {
              nextToken: {},
              templateVersions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "lastModifiedAt",
                    "majorVersion",
                    "minorVersion",
                    "status",
                    "templateName"
                  ],
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    description: {
                      shape: "Si"
                    },
                    lastModifiedAt: {
                      type: "timestamp"
                    },
                    majorVersion: {},
                    minorVersion: {},
                    recommendedMinorVersion: {},
                    status: {},
                    statusMessage: {
                      shape: "Sh"
                    },
                    templateName: {}
                  }
                }
              }
            }
          }
        },
        ListEnvironmentTemplates: {
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "templates"
            ],
            members: {
              nextToken: {},
              templates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "lastModifiedAt",
                    "name"
                  ],
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    description: {
                      shape: "Si"
                    },
                    displayName: {
                      shape: "S1j"
                    },
                    lastModifiedAt: {
                      type: "timestamp"
                    },
                    name: {},
                    provisioning: {},
                    recommendedVersion: {}
                  }
                }
              }
            }
          }
        },
        ListEnvironments: {
          input: {
            type: "structure",
            members: {
              environmentTemplates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "majorVersion",
                    "templateName"
                  ],
                  members: {
                    majorVersion: {},
                    templateName: {}
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "environments"
            ],
            members: {
              environments: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "deploymentStatus",
                    "lastDeploymentAttemptedAt",
                    "lastDeploymentSucceededAt",
                    "name",
                    "templateMajorVersion",
                    "templateMinorVersion",
                    "templateName"
                  ],
                  members: {
                    arn: {},
                    componentRoleArn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    deploymentStatus: {},
                    deploymentStatusMessage: {
                      shape: "Sh"
                    },
                    description: {
                      shape: "Si"
                    },
                    environmentAccountConnectionId: {},
                    environmentAccountId: {},
                    lastAttemptedDeploymentId: {},
                    lastDeploymentAttemptedAt: {
                      type: "timestamp"
                    },
                    lastDeploymentSucceededAt: {
                      type: "timestamp"
                    },
                    lastSucceededDeploymentId: {},
                    name: {},
                    protonServiceRoleArn: {},
                    provisioning: {},
                    templateMajorVersion: {},
                    templateMinorVersion: {},
                    templateName: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListRepositories: {
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "repositories"
            ],
            members: {
              nextToken: {},
              repositories: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "connectionArn",
                    "name",
                    "provider"
                  ],
                  members: {
                    arn: {},
                    connectionArn: {},
                    name: {},
                    provider: {}
                  }
                }
              }
            }
          }
        },
        ListRepositorySyncDefinitions: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "repositoryProvider",
              "syncType"
            ],
            members: {
              nextToken: {},
              repositoryName: {},
              repositoryProvider: {},
              syncType: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "syncDefinitions"
            ],
            members: {
              nextToken: {},
              syncDefinitions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "branch",
                    "directory",
                    "parent",
                    "target"
                  ],
                  members: {
                    branch: {},
                    directory: {},
                    parent: {},
                    target: {}
                  }
                }
              }
            }
          }
        },
        ListServiceInstanceOutputs: {
          input: {
            type: "structure",
            required: [
              "serviceInstanceName",
              "serviceName"
            ],
            members: {
              deploymentId: {},
              nextToken: {},
              serviceInstanceName: {},
              serviceName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "outputs"
            ],
            members: {
              nextToken: {},
              outputs: {
                shape: "S5m"
              }
            }
          }
        },
        ListServiceInstanceProvisionedResources: {
          input: {
            type: "structure",
            required: [
              "serviceInstanceName",
              "serviceName"
            ],
            members: {
              nextToken: {},
              serviceInstanceName: {},
              serviceName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "provisionedResources"
            ],
            members: {
              nextToken: {},
              provisionedResources: {
                shape: "S5s"
              }
            }
          }
        },
        ListServiceInstances: {
          input: {
            type: "structure",
            members: {
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    key: {},
                    value: {}
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              serviceName: {},
              sortBy: {},
              sortOrder: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "serviceInstances"
            ],
            members: {
              nextToken: {},
              serviceInstances: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "deploymentStatus",
                    "environmentName",
                    "lastDeploymentAttemptedAt",
                    "lastDeploymentSucceededAt",
                    "name",
                    "serviceName",
                    "templateMajorVersion",
                    "templateMinorVersion",
                    "templateName"
                  ],
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    deploymentStatus: {},
                    deploymentStatusMessage: {
                      shape: "Sh"
                    },
                    environmentName: {},
                    lastAttemptedDeploymentId: {},
                    lastDeploymentAttemptedAt: {
                      type: "timestamp"
                    },
                    lastDeploymentSucceededAt: {
                      type: "timestamp"
                    },
                    lastSucceededDeploymentId: {},
                    name: {},
                    serviceName: {},
                    templateMajorVersion: {},
                    templateMinorVersion: {},
                    templateName: {}
                  }
                }
              }
            }
          }
        },
        ListServicePipelineOutputs: {
          input: {
            type: "structure",
            required: [
              "serviceName"
            ],
            members: {
              deploymentId: {},
              nextToken: {},
              serviceName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "outputs"
            ],
            members: {
              nextToken: {},
              outputs: {
                shape: "S5m"
              }
            }
          }
        },
        ListServicePipelineProvisionedResources: {
          input: {
            type: "structure",
            required: [
              "serviceName"
            ],
            members: {
              nextToken: {},
              serviceName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "provisionedResources"
            ],
            members: {
              nextToken: {},
              provisionedResources: {
                shape: "S5s"
              }
            }
          }
        },
        ListServiceTemplateVersions: {
          input: {
            type: "structure",
            required: [
              "templateName"
            ],
            members: {
              majorVersion: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              templateName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "templateVersions"
            ],
            members: {
              nextToken: {},
              templateVersions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "lastModifiedAt",
                    "majorVersion",
                    "minorVersion",
                    "status",
                    "templateName"
                  ],
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    description: {
                      shape: "Si"
                    },
                    lastModifiedAt: {
                      type: "timestamp"
                    },
                    majorVersion: {},
                    minorVersion: {},
                    recommendedMinorVersion: {},
                    status: {},
                    statusMessage: {
                      shape: "Sh"
                    },
                    templateName: {}
                  }
                }
              }
            }
          }
        },
        ListServiceTemplates: {
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "templates"
            ],
            members: {
              nextToken: {},
              templates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "lastModifiedAt",
                    "name"
                  ],
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    description: {
                      shape: "Si"
                    },
                    displayName: {
                      shape: "S1j"
                    },
                    lastModifiedAt: {
                      type: "timestamp"
                    },
                    name: {},
                    pipelineProvisioning: {},
                    recommendedVersion: {}
                  }
                }
              }
            }
          }
        },
        ListServices: {
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "services"
            ],
            members: {
              nextToken: {},
              services: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "lastModifiedAt",
                    "name",
                    "status",
                    "templateName"
                  ],
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    description: {
                      shape: "Si"
                    },
                    lastModifiedAt: {
                      type: "timestamp"
                    },
                    name: {},
                    status: {},
                    statusMessage: {
                      shape: "Sh"
                    },
                    templateName: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "tags"
            ],
            members: {
              nextToken: {},
              tags: {
                shape: "S17"
              }
            }
          }
        },
        NotifyResourceDeploymentStatusChange: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              deploymentId: {},
              outputs: {
                type: "list",
                member: {
                  shape: "S5n"
                }
              },
              resourceArn: {},
              status: {},
              statusMessage: {
                type: "string",
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RejectEnvironmentAccountConnection: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "environmentAccountConnection"
            ],
            members: {
              environmentAccountConnection: {
                shape: "S4"
              }
            }
          },
          idempotent: true
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "S17"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateAccountSettings: {
          input: {
            type: "structure",
            members: {
              deletePipelineProvisioningRepository: {
                type: "boolean"
              },
              pipelineCodebuildRoleArn: {},
              pipelineProvisioningRepository: {
                shape: "S1e"
              },
              pipelineServiceRoleArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "accountSettings"
            ],
            members: {
              accountSettings: {
                shape: "S3w"
              }
            }
          }
        },
        UpdateComponent: {
          input: {
            type: "structure",
            required: [
              "deploymentType",
              "name"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              deploymentType: {},
              description: {
                shape: "Si"
              },
              name: {},
              serviceInstanceName: {},
              serviceName: {},
              serviceSpec: {
                shape: "Sl"
              },
              templateFile: {
                shape: "S1b"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "component"
            ],
            members: {
              component: {
                shape: "Se"
              }
            }
          }
        },
        UpdateEnvironment: {
          input: {
            type: "structure",
            required: [
              "deploymentType",
              "name"
            ],
            members: {
              codebuildRoleArn: {},
              componentRoleArn: {},
              deploymentType: {},
              description: {
                shape: "Si"
              },
              environmentAccountConnectionId: {},
              name: {},
              protonServiceRoleArn: {},
              provisioningRepository: {
                shape: "S1e"
              },
              spec: {
                shape: "Sl"
              },
              templateMajorVersion: {},
              templateMinorVersion: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "environment"
            ],
            members: {
              environment: {
                shape: "So"
              }
            }
          }
        },
        UpdateEnvironmentAccountConnection: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              codebuildRoleArn: {},
              componentRoleArn: {},
              id: {},
              roleArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "environmentAccountConnection"
            ],
            members: {
              environmentAccountConnection: {
                shape: "S4"
              }
            }
          },
          idempotent: true
        },
        UpdateEnvironmentTemplate: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              description: {
                shape: "Si"
              },
              displayName: {
                shape: "S1j"
              },
              name: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "environmentTemplate"
            ],
            members: {
              environmentTemplate: {
                shape: "S1l"
              }
            }
          }
        },
        UpdateEnvironmentTemplateVersion: {
          input: {
            type: "structure",
            required: [
              "majorVersion",
              "minorVersion",
              "templateName"
            ],
            members: {
              description: {
                shape: "Si"
              },
              majorVersion: {},
              minorVersion: {},
              status: {},
              templateName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "environmentTemplateVersion"
            ],
            members: {
              environmentTemplateVersion: {
                shape: "S1u"
              }
            }
          }
        },
        UpdateService: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              description: {
                shape: "Si"
              },
              name: {},
              spec: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "service"
            ],
            members: {
              service: {
                shape: "S24"
              }
            }
          }
        },
        UpdateServiceInstance: {
          input: {
            type: "structure",
            required: [
              "deploymentType",
              "name",
              "serviceName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              deploymentType: {},
              name: {},
              serviceName: {},
              spec: {
                shape: "Sl"
              },
              templateMajorVersion: {},
              templateMinorVersion: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "serviceInstance"
            ],
            members: {
              serviceInstance: {
                shape: "Sz"
              }
            }
          }
        },
        UpdateServicePipeline: {
          input: {
            type: "structure",
            required: [
              "deploymentType",
              "serviceName",
              "spec"
            ],
            members: {
              deploymentType: {},
              serviceName: {},
              spec: {
                shape: "Sl"
              },
              templateMajorVersion: {},
              templateMinorVersion: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "pipeline"
            ],
            members: {
              pipeline: {
                shape: "S13"
              }
            }
          }
        },
        UpdateServiceSyncBlocker: {
          input: {
            type: "structure",
            required: [
              "id",
              "resolvedReason"
            ],
            members: {
              id: {},
              resolvedReason: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "serviceName",
              "serviceSyncBlocker"
            ],
            members: {
              serviceInstanceName: {},
              serviceName: {},
              serviceSyncBlocker: {
                shape: "S54"
              }
            }
          }
        },
        UpdateServiceSyncConfig: {
          input: {
            type: "structure",
            required: [
              "branch",
              "filePath",
              "repositoryName",
              "repositoryProvider",
              "serviceName"
            ],
            members: {
              branch: {},
              filePath: {},
              repositoryName: {},
              repositoryProvider: {},
              serviceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              serviceSyncConfig: {
                shape: "S2c"
              }
            }
          }
        },
        UpdateServiceTemplate: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              description: {
                shape: "Si"
              },
              displayName: {
                shape: "S1j"
              },
              name: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "serviceTemplate"
            ],
            members: {
              serviceTemplate: {
                shape: "S2f"
              }
            }
          }
        },
        UpdateServiceTemplateVersion: {
          input: {
            type: "structure",
            required: [
              "majorVersion",
              "minorVersion",
              "templateName"
            ],
            members: {
              compatibleEnvironmentTemplates: {
                shape: "S2i"
              },
              description: {
                shape: "Si"
              },
              majorVersion: {},
              minorVersion: {},
              status: {},
              supportedComponentSources: {
                shape: "S2k"
              },
              templateName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "serviceTemplateVersion"
            ],
            members: {
              serviceTemplateVersion: {
                shape: "S2n"
              }
            }
          }
        },
        UpdateTemplateSyncConfig: {
          input: {
            type: "structure",
            required: [
              "branch",
              "repositoryName",
              "repositoryProvider",
              "templateName",
              "templateType"
            ],
            members: {
              branch: {},
              repositoryName: {},
              repositoryProvider: {},
              subdirectory: {},
              templateName: {},
              templateType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              templateSyncConfig: {
                shape: "S2v"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          required: [
            "arn",
            "environmentAccountId",
            "environmentName",
            "id",
            "lastModifiedAt",
            "managementAccountId",
            "requestedAt",
            "roleArn",
            "status"
          ],
          members: {
            arn: {},
            codebuildRoleArn: {},
            componentRoleArn: {},
            environmentAccountId: {},
            environmentName: {},
            id: {},
            lastModifiedAt: {
              type: "timestamp"
            },
            managementAccountId: {},
            requestedAt: {
              type: "timestamp"
            },
            roleArn: {},
            status: {}
          }
        },
        Se: {
          type: "structure",
          required: [
            "arn",
            "createdAt",
            "deploymentStatus",
            "environmentName",
            "lastModifiedAt",
            "name"
          ],
          members: {
            arn: {},
            createdAt: {
              type: "timestamp"
            },
            deploymentStatus: {},
            deploymentStatusMessage: {
              shape: "Sh"
            },
            description: {
              shape: "Si"
            },
            environmentName: {},
            lastAttemptedDeploymentId: {},
            lastClientRequestToken: {},
            lastDeploymentAttemptedAt: {
              type: "timestamp"
            },
            lastDeploymentSucceededAt: {
              type: "timestamp"
            },
            lastModifiedAt: {
              type: "timestamp"
            },
            lastSucceededDeploymentId: {},
            name: {},
            serviceInstanceName: {},
            serviceName: {},
            serviceSpec: {
              shape: "Sl"
            }
          }
        },
        Sh: {
          type: "string",
          sensitive: true
        },
        Si: {
          type: "string",
          sensitive: true
        },
        Sl: {
          type: "string",
          sensitive: true
        },
        So: {
          type: "structure",
          required: [
            "arn",
            "createdAt",
            "deploymentStatus",
            "lastDeploymentAttemptedAt",
            "lastDeploymentSucceededAt",
            "name",
            "templateMajorVersion",
            "templateMinorVersion",
            "templateName"
          ],
          members: {
            arn: {},
            codebuildRoleArn: {},
            componentRoleArn: {},
            createdAt: {
              type: "timestamp"
            },
            deploymentStatus: {},
            deploymentStatusMessage: {
              shape: "Sh"
            },
            description: {
              shape: "Si"
            },
            environmentAccountConnectionId: {},
            environmentAccountId: {},
            lastAttemptedDeploymentId: {},
            lastDeploymentAttemptedAt: {
              type: "timestamp"
            },
            lastDeploymentSucceededAt: {
              type: "timestamp"
            },
            lastSucceededDeploymentId: {},
            name: {},
            protonServiceRoleArn: {},
            provisioning: {},
            provisioningRepository: {
              shape: "Sr"
            },
            spec: {
              shape: "Sl"
            },
            templateMajorVersion: {},
            templateMinorVersion: {},
            templateName: {}
          }
        },
        Sr: {
          type: "structure",
          required: [
            "arn",
            "branch",
            "name",
            "provider"
          ],
          members: {
            arn: {},
            branch: {},
            name: {},
            provider: {}
          }
        },
        Sz: {
          type: "structure",
          required: [
            "arn",
            "createdAt",
            "deploymentStatus",
            "environmentName",
            "lastDeploymentAttemptedAt",
            "lastDeploymentSucceededAt",
            "name",
            "serviceName",
            "templateMajorVersion",
            "templateMinorVersion",
            "templateName"
          ],
          members: {
            arn: {},
            createdAt: {
              type: "timestamp"
            },
            deploymentStatus: {},
            deploymentStatusMessage: {
              shape: "Sh"
            },
            environmentName: {},
            lastAttemptedDeploymentId: {},
            lastClientRequestToken: {},
            lastDeploymentAttemptedAt: {
              type: "timestamp"
            },
            lastDeploymentSucceededAt: {
              type: "timestamp"
            },
            lastSucceededDeploymentId: {},
            name: {},
            serviceName: {},
            spec: {
              shape: "Sl"
            },
            templateMajorVersion: {},
            templateMinorVersion: {},
            templateName: {}
          }
        },
        S13: {
          type: "structure",
          required: [
            "arn",
            "createdAt",
            "deploymentStatus",
            "lastDeploymentAttemptedAt",
            "lastDeploymentSucceededAt",
            "templateMajorVersion",
            "templateMinorVersion",
            "templateName"
          ],
          members: {
            arn: {},
            createdAt: {
              type: "timestamp"
            },
            deploymentStatus: {},
            deploymentStatusMessage: {
              shape: "Sh"
            },
            lastAttemptedDeploymentId: {},
            lastDeploymentAttemptedAt: {
              type: "timestamp"
            },
            lastDeploymentSucceededAt: {
              type: "timestamp"
            },
            lastSucceededDeploymentId: {},
            spec: {
              shape: "Sl"
            },
            templateMajorVersion: {},
            templateMinorVersion: {},
            templateName: {}
          }
        },
        S17: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        S1b: {
          type: "string",
          sensitive: true
        },
        S1e: {
          type: "structure",
          required: [
            "branch",
            "name",
            "provider"
          ],
          members: {
            branch: {},
            name: {},
            provider: {}
          }
        },
        S1j: {
          type: "string",
          sensitive: true
        },
        S1l: {
          type: "structure",
          required: [
            "arn",
            "createdAt",
            "lastModifiedAt",
            "name"
          ],
          members: {
            arn: {},
            createdAt: {
              type: "timestamp"
            },
            description: {
              shape: "Si"
            },
            displayName: {
              shape: "S1j"
            },
            encryptionKey: {},
            lastModifiedAt: {
              type: "timestamp"
            },
            name: {},
            provisioning: {},
            recommendedVersion: {}
          }
        },
        S1p: {
          type: "structure",
          members: {
            s3: {
              type: "structure",
              required: [
                "bucket",
                "key"
              ],
              members: {
                bucket: {},
                key: {}
              }
            }
          },
          union: true
        },
        S1u: {
          type: "structure",
          required: [
            "arn",
            "createdAt",
            "lastModifiedAt",
            "majorVersion",
            "minorVersion",
            "status",
            "templateName"
          ],
          members: {
            arn: {},
            createdAt: {
              type: "timestamp"
            },
            description: {
              shape: "Si"
            },
            lastModifiedAt: {
              type: "timestamp"
            },
            majorVersion: {},
            minorVersion: {},
            recommendedMinorVersion: {},
            schema: {
              shape: "S1w"
            },
            status: {},
            statusMessage: {
              shape: "Sh"
            },
            templateName: {}
          }
        },
        S1w: {
          type: "string",
          sensitive: true
        },
        S20: {
          type: "structure",
          required: [
            "arn",
            "connectionArn",
            "name",
            "provider"
          ],
          members: {
            arn: {},
            connectionArn: {},
            encryptionKey: {},
            name: {},
            provider: {}
          }
        },
        S24: {
          type: "structure",
          required: [
            "arn",
            "createdAt",
            "lastModifiedAt",
            "name",
            "spec",
            "status",
            "templateName"
          ],
          members: {
            arn: {},
            branchName: {},
            createdAt: {
              type: "timestamp"
            },
            description: {
              shape: "Si"
            },
            lastModifiedAt: {
              type: "timestamp"
            },
            name: {},
            pipeline: {
              shape: "S13"
            },
            repositoryConnectionArn: {},
            repositoryId: {},
            spec: {
              shape: "Sl"
            },
            status: {},
            statusMessage: {
              shape: "Sh"
            },
            templateName: {}
          }
        },
        S2c: {
          type: "structure",
          required: [
            "branch",
            "filePath",
            "repositoryName",
            "repositoryProvider",
            "serviceName"
          ],
          members: {
            branch: {},
            filePath: {},
            repositoryName: {},
            repositoryProvider: {},
            serviceName: {}
          }
        },
        S2f: {
          type: "structure",
          required: [
            "arn",
            "createdAt",
            "lastModifiedAt",
            "name"
          ],
          members: {
            arn: {},
            createdAt: {
              type: "timestamp"
            },
            description: {
              shape: "Si"
            },
            displayName: {
              shape: "S1j"
            },
            encryptionKey: {},
            lastModifiedAt: {
              type: "timestamp"
            },
            name: {},
            pipelineProvisioning: {},
            recommendedVersion: {}
          }
        },
        S2i: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "majorVersion",
              "templateName"
            ],
            members: {
              majorVersion: {},
              templateName: {}
            }
          }
        },
        S2k: {
          type: "list",
          member: {}
        },
        S2n: {
          type: "structure",
          required: [
            "arn",
            "compatibleEnvironmentTemplates",
            "createdAt",
            "lastModifiedAt",
            "majorVersion",
            "minorVersion",
            "status",
            "templateName"
          ],
          members: {
            arn: {},
            compatibleEnvironmentTemplates: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "majorVersion",
                  "templateName"
                ],
                members: {
                  majorVersion: {},
                  templateName: {}
                }
              }
            },
            createdAt: {
              type: "timestamp"
            },
            description: {
              shape: "Si"
            },
            lastModifiedAt: {
              type: "timestamp"
            },
            majorVersion: {},
            minorVersion: {},
            recommendedMinorVersion: {},
            schema: {
              shape: "S1w"
            },
            status: {},
            statusMessage: {
              shape: "Sh"
            },
            supportedComponentSources: {
              shape: "S2k"
            },
            templateName: {}
          }
        },
        S2v: {
          type: "structure",
          required: [
            "branch",
            "repositoryName",
            "repositoryProvider",
            "templateName",
            "templateType"
          ],
          members: {
            branch: {},
            repositoryName: {},
            repositoryProvider: {},
            subdirectory: {},
            templateName: {},
            templateType: {}
          }
        },
        S30: {
          type: "structure",
          required: [
            "arn",
            "createdAt",
            "deploymentStatus",
            "environmentName",
            "id",
            "lastModifiedAt",
            "targetArn",
            "targetResourceCreatedAt",
            "targetResourceType"
          ],
          members: {
            arn: {},
            completedAt: {
              type: "timestamp"
            },
            componentName: {},
            createdAt: {
              type: "timestamp"
            },
            deploymentStatus: {},
            deploymentStatusMessage: {
              shape: "Sh"
            },
            environmentName: {},
            id: {},
            initialState: {
              shape: "S32"
            },
            lastAttemptedDeploymentId: {},
            lastModifiedAt: {
              type: "timestamp"
            },
            lastSucceededDeploymentId: {},
            serviceInstanceName: {},
            serviceName: {},
            targetArn: {},
            targetResourceCreatedAt: {
              type: "timestamp"
            },
            targetResourceType: {},
            targetState: {
              shape: "S32"
            }
          }
        },
        S32: {
          type: "structure",
          members: {
            component: {
              type: "structure",
              members: {
                serviceInstanceName: {},
                serviceName: {},
                serviceSpec: {
                  shape: "Sl"
                },
                templateFile: {
                  shape: "S1b"
                }
              }
            },
            environment: {
              type: "structure",
              required: [
                "templateMajorVersion",
                "templateMinorVersion",
                "templateName"
              ],
              members: {
                spec: {
                  shape: "Sl"
                },
                templateMajorVersion: {},
                templateMinorVersion: {},
                templateName: {}
              }
            },
            serviceInstance: {
              type: "structure",
              required: [
                "spec",
                "templateMajorVersion",
                "templateMinorVersion",
                "templateName"
              ],
              members: {
                lastSuccessfulComponentDeploymentIds: {
                  type: "list",
                  member: {}
                },
                lastSuccessfulEnvironmentDeploymentId: {},
                lastSuccessfulServicePipelineDeploymentId: {},
                spec: {
                  shape: "Sl"
                },
                templateMajorVersion: {},
                templateMinorVersion: {},
                templateName: {}
              }
            },
            servicePipeline: {
              type: "structure",
              required: [
                "templateMajorVersion",
                "templateMinorVersion",
                "templateName"
              ],
              members: {
                spec: {
                  shape: "Sl"
                },
                templateMajorVersion: {},
                templateMinorVersion: {},
                templateName: {}
              }
            }
          },
          union: true
        },
        S3w: {
          type: "structure",
          members: {
            pipelineCodebuildRoleArn: {},
            pipelineProvisioningRepository: {
              shape: "Sr"
            },
            pipelineServiceRoleArn: {}
          }
        },
        S4m: {
          type: "structure",
          required: [
            "total"
          ],
          members: {
            behindMajor: {
              type: "integer"
            },
            behindMinor: {
              type: "integer"
            },
            failed: {
              type: "integer"
            },
            total: {
              type: "integer"
            },
            upToDate: {
              type: "integer"
            }
          }
        },
        S4u: {
          type: "structure",
          required: [
            "branch",
            "directory",
            "repositoryName",
            "repositoryProvider",
            "sha"
          ],
          members: {
            branch: {},
            directory: {},
            repositoryName: {},
            repositoryProvider: {},
            sha: {}
          }
        },
        S4w: {
          type: "structure",
          required: [
            "events",
            "initialRevision",
            "startedAt",
            "status",
            "target",
            "targetRevision"
          ],
          members: {
            events: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "event",
                  "time",
                  "type"
                ],
                members: {
                  event: {},
                  externalId: {},
                  time: {
                    type: "timestamp"
                  },
                  type: {}
                }
              }
            },
            initialRevision: {
              shape: "S4u"
            },
            startedAt: {
              type: "timestamp"
            },
            status: {},
            target: {},
            targetRevision: {
              shape: "S4u"
            }
          }
        },
        S54: {
          type: "structure",
          required: [
            "createdAt",
            "createdReason",
            "id",
            "status",
            "type"
          ],
          members: {
            contexts: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "key",
                  "value"
                ],
                members: {
                  key: {},
                  value: {}
                }
              }
            },
            createdAt: {
              type: "timestamp"
            },
            createdReason: {},
            id: {},
            resolvedAt: {
              type: "timestamp"
            },
            resolvedReason: {},
            status: {},
            type: {}
          }
        },
        S5m: {
          type: "list",
          member: {
            shape: "S5n"
          }
        },
        S5n: {
          type: "structure",
          members: {
            key: {},
            valueString: {}
          },
          sensitive: true
        },
        S5s: {
          type: "list",
          member: {
            type: "structure",
            members: {
              identifier: {},
              name: {},
              provisioningEngine: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/proton-2020-07-20.paginators.json
var require_proton_2020_07_20_paginators = __commonJS({
  "node_modules/aws-sdk/apis/proton-2020-07-20.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListComponentOutputs: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "outputs"
        },
        ListComponentProvisionedResources: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "provisionedResources"
        },
        ListComponents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "components"
        },
        ListDeployments: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "deployments"
        },
        ListEnvironmentAccountConnections: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "environmentAccountConnections"
        },
        ListEnvironmentOutputs: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "outputs"
        },
        ListEnvironmentProvisionedResources: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "provisionedResources"
        },
        ListEnvironmentTemplateVersions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "templateVersions"
        },
        ListEnvironmentTemplates: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "templates"
        },
        ListEnvironments: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "environments"
        },
        ListRepositories: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "repositories"
        },
        ListRepositorySyncDefinitions: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "syncDefinitions"
        },
        ListServiceInstanceOutputs: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "outputs"
        },
        ListServiceInstanceProvisionedResources: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "provisionedResources"
        },
        ListServiceInstances: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "serviceInstances"
        },
        ListServicePipelineOutputs: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "outputs"
        },
        ListServicePipelineProvisionedResources: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "provisionedResources"
        },
        ListServiceTemplateVersions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "templateVersions"
        },
        ListServiceTemplates: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "templates"
        },
        ListServices: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "services"
        },
        ListTagsForResource: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "tags"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/proton-2020-07-20.waiters2.json
var require_proton_2020_07_20_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/proton-2020-07-20.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        ComponentDeleted: {
          description: "Wait until a Component is deleted. Use this after invoking DeleteComponent",
          delay: 5,
          maxAttempts: 999,
          operation: "GetComponent",
          acceptors: [{
            matcher: "error",
            state: "success",
            expected: "ResourceNotFoundException"
          }, {
            matcher: "path",
            argument: "component.deploymentStatus",
            state: "failure",
            expected: "DELETE_FAILED"
          }]
        },
        ComponentDeployed: {
          description: "Wait until a Component is deployed. Use this after invoking CreateComponent or UpdateComponent",
          delay: 5,
          maxAttempts: 999,
          operation: "GetComponent",
          acceptors: [{
            matcher: "path",
            argument: "component.deploymentStatus",
            state: "success",
            expected: "SUCCEEDED"
          }, {
            matcher: "path",
            argument: "component.deploymentStatus",
            state: "failure",
            expected: "FAILED"
          }]
        },
        EnvironmentDeployed: {
          description: "Wait until an Environment is deployed. Use this after invoking CreateEnvironment or UpdateEnvironment",
          delay: 5,
          maxAttempts: 999,
          operation: "GetEnvironment",
          acceptors: [{
            matcher: "path",
            argument: "environment.deploymentStatus",
            state: "success",
            expected: "SUCCEEDED"
          }, {
            matcher: "path",
            argument: "environment.deploymentStatus",
            state: "failure",
            expected: "FAILED"
          }]
        },
        EnvironmentTemplateVersionRegistered: {
          description: "Wait until an EnvironmentTemplateVersion is registered. Use this after invoking CreateEnvironmentTemplateVersion",
          delay: 2,
          maxAttempts: 150,
          operation: "GetEnvironmentTemplateVersion",
          acceptors: [{
            matcher: "path",
            argument: "environmentTemplateVersion.status",
            state: "success",
            expected: "DRAFT"
          }, {
            matcher: "path",
            argument: "environmentTemplateVersion.status",
            state: "success",
            expected: "PUBLISHED"
          }, {
            matcher: "path",
            argument: "environmentTemplateVersion.status",
            state: "failure",
            expected: "REGISTRATION_FAILED"
          }]
        },
        ServiceCreated: {
          description: "Wait until an Service has deployed its instances and possibly pipeline. Use this after invoking CreateService",
          delay: 5,
          maxAttempts: 999,
          operation: "GetService",
          acceptors: [{
            matcher: "path",
            argument: "service.status",
            state: "success",
            expected: "ACTIVE"
          }, {
            matcher: "path",
            argument: "service.status",
            state: "failure",
            expected: "CREATE_FAILED_CLEANUP_COMPLETE"
          }, {
            matcher: "path",
            argument: "service.status",
            state: "failure",
            expected: "CREATE_FAILED_CLEANUP_FAILED"
          }, {
            matcher: "path",
            argument: "service.status",
            state: "failure",
            expected: "CREATE_FAILED"
          }]
        },
        ServiceDeleted: {
          description: "Wait until a Service, its instances, and possibly pipeline have been deleted after DeleteService is invoked",
          delay: 5,
          maxAttempts: 999,
          operation: "GetService",
          acceptors: [{
            matcher: "error",
            state: "success",
            expected: "ResourceNotFoundException"
          }, {
            matcher: "path",
            argument: "service.status",
            state: "failure",
            expected: "DELETE_FAILED"
          }]
        },
        ServiceInstanceDeployed: {
          description: "Wait until a ServiceInstance is deployed. Use this after invoking CreateService or UpdateServiceInstance",
          delay: 5,
          maxAttempts: 999,
          operation: "GetServiceInstance",
          acceptors: [{
            matcher: "path",
            argument: "serviceInstance.deploymentStatus",
            state: "success",
            expected: "SUCCEEDED"
          }, {
            matcher: "path",
            argument: "serviceInstance.deploymentStatus",
            state: "failure",
            expected: "FAILED"
          }]
        },
        ServicePipelineDeployed: {
          description: "Wait until an ServicePipeline is deployed. Use this after invoking CreateService or UpdateServicePipeline",
          delay: 10,
          maxAttempts: 360,
          operation: "GetService",
          acceptors: [{
            matcher: "path",
            argument: "service.pipeline.deploymentStatus",
            state: "success",
            expected: "SUCCEEDED"
          }, {
            matcher: "path",
            argument: "service.pipeline.deploymentStatus",
            state: "failure",
            expected: "FAILED"
          }]
        },
        ServiceTemplateVersionRegistered: {
          description: "Wait until a ServiceTemplateVersion is registered. Use this after invoking CreateServiceTemplateVersion",
          delay: 2,
          maxAttempts: 150,
          operation: "GetServiceTemplateVersion",
          acceptors: [{
            matcher: "path",
            argument: "serviceTemplateVersion.status",
            state: "success",
            expected: "DRAFT"
          }, {
            matcher: "path",
            argument: "serviceTemplateVersion.status",
            state: "success",
            expected: "PUBLISHED"
          }, {
            matcher: "path",
            argument: "serviceTemplateVersion.status",
            state: "failure",
            expected: "REGISTRATION_FAILED"
          }]
        },
        ServiceUpdated: {
          description: "Wait until a Service, its instances, and possibly pipeline have been deployed after UpdateService is invoked",
          delay: 5,
          maxAttempts: 999,
          operation: "GetService",
          acceptors: [{
            matcher: "path",
            argument: "service.status",
            state: "success",
            expected: "ACTIVE"
          }, {
            matcher: "path",
            argument: "service.status",
            state: "failure",
            expected: "UPDATE_FAILED_CLEANUP_COMPLETE"
          }, {
            matcher: "path",
            argument: "service.status",
            state: "failure",
            expected: "UPDATE_FAILED_CLEANUP_FAILED"
          }, {
            matcher: "path",
            argument: "service.status",
            state: "failure",
            expected: "UPDATE_FAILED"
          }, {
            matcher: "path",
            argument: "service.status",
            state: "failure",
            expected: "UPDATE_COMPLETE_CLEANUP_FAILED"
          }]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/proton.js
var require_proton = __commonJS({
  "node_modules/aws-sdk/clients/proton.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["proton"] = {};
    AWS2.Proton = Service.defineService("proton", ["2020-07-20"]);
    Object.defineProperty(apiLoader.services["proton"], "2020-07-20", {
      get: function get() {
        var model = require_proton_2020_07_20_min();
        model.paginators = require_proton_2020_07_20_paginators().pagination;
        model.waiters = require_proton_2020_07_20_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Proton;
  }
});

// node_modules/aws-sdk/apis/route53-recovery-cluster-2019-12-02.min.json
var require_route53_recovery_cluster_2019_12_02_min = __commonJS({
  "node_modules/aws-sdk/apis/route53-recovery-cluster-2019-12-02.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-12-02",
        endpointPrefix: "route53-recovery-cluster",
        jsonVersion: "1.0",
        protocol: "json",
        serviceFullName: "Route53 Recovery Cluster",
        serviceId: "Route53 Recovery Cluster",
        signatureVersion: "v4",
        signingName: "route53-recovery-cluster",
        targetPrefix: "ToggleCustomerAPI",
        uid: "route53-recovery-cluster-2019-12-02"
      },
      operations: {
        GetRoutingControlState: {
          input: {
            type: "structure",
            required: [
              "RoutingControlArn"
            ],
            members: {
              RoutingControlArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "RoutingControlArn",
              "RoutingControlState"
            ],
            members: {
              RoutingControlArn: {},
              RoutingControlState: {},
              RoutingControlName: {}
            }
          }
        },
        ListRoutingControls: {
          input: {
            type: "structure",
            members: {
              ControlPanelArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "RoutingControls"
            ],
            members: {
              RoutingControls: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ControlPanelArn: {},
                    ControlPanelName: {},
                    RoutingControlArn: {},
                    RoutingControlName: {},
                    RoutingControlState: {},
                    Owner: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        UpdateRoutingControlState: {
          input: {
            type: "structure",
            required: [
              "RoutingControlArn",
              "RoutingControlState"
            ],
            members: {
              RoutingControlArn: {},
              RoutingControlState: {},
              SafetyRulesToOverride: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateRoutingControlStates: {
          input: {
            type: "structure",
            required: [
              "UpdateRoutingControlStateEntries"
            ],
            members: {
              UpdateRoutingControlStateEntries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "RoutingControlArn",
                    "RoutingControlState"
                  ],
                  members: {
                    RoutingControlArn: {},
                    RoutingControlState: {}
                  }
                }
              },
              SafetyRulesToOverride: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        Sf: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/route53-recovery-cluster-2019-12-02.paginators.json
var require_route53_recovery_cluster_2019_12_02_paginators = __commonJS({
  "node_modules/aws-sdk/apis/route53-recovery-cluster-2019-12-02.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListRoutingControls: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "RoutingControls"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/route53recoverycluster.js
var require_route53recoverycluster = __commonJS({
  "node_modules/aws-sdk/clients/route53recoverycluster.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["route53recoverycluster"] = {};
    AWS2.Route53RecoveryCluster = Service.defineService("route53recoverycluster", ["2019-12-02"]);
    Object.defineProperty(apiLoader.services["route53recoverycluster"], "2019-12-02", {
      get: function get() {
        var model = require_route53_recovery_cluster_2019_12_02_min();
        model.paginators = require_route53_recovery_cluster_2019_12_02_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Route53RecoveryCluster;
  }
});

// node_modules/aws-sdk/apis/route53-recovery-control-config-2020-11-02.min.json
var require_route53_recovery_control_config_2020_11_02_min = __commonJS({
  "node_modules/aws-sdk/apis/route53-recovery-control-config-2020-11-02.min.json"(exports2, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2020-11-02",
        endpointPrefix: "route53-recovery-control-config",
        signingName: "route53-recovery-control-config",
        serviceFullName: "AWS Route53 Recovery Control Config",
        serviceId: "Route53 Recovery Control Config",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "route53-recovery-control-config-2020-11-02",
        signatureVersion: "v4"
      },
      operations: {
        CreateCluster: {
          http: {
            requestUri: "/cluster",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              ClusterName: {},
              Tags: {
                shape: "S3"
              }
            },
            required: [
              "ClusterName"
            ]
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                shape: "S7"
              }
            }
          }
        },
        CreateControlPanel: {
          http: {
            requestUri: "/controlpanel",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              ClusterArn: {},
              ControlPanelName: {},
              Tags: {
                shape: "S3"
              }
            },
            required: [
              "ClusterArn",
              "ControlPanelName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ControlPanel: {
                shape: "Sh"
              }
            }
          }
        },
        CreateRoutingControl: {
          http: {
            requestUri: "/routingcontrol",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              ClusterArn: {},
              ControlPanelArn: {},
              RoutingControlName: {}
            },
            required: [
              "ClusterArn",
              "RoutingControlName"
            ]
          },
          output: {
            type: "structure",
            members: {
              RoutingControl: {
                shape: "Sm"
              }
            }
          }
        },
        CreateSafetyRule: {
          http: {
            requestUri: "/safetyrule",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AssertionRule: {
                type: "structure",
                members: {
                  AssertedControls: {
                    shape: "Sp"
                  },
                  ControlPanelArn: {},
                  Name: {},
                  RuleConfig: {
                    shape: "Sq"
                  },
                  WaitPeriodMs: {
                    type: "integer"
                  }
                },
                required: [
                  "ControlPanelArn",
                  "AssertedControls",
                  "RuleConfig",
                  "WaitPeriodMs",
                  "Name"
                ]
              },
              ClientToken: {
                idempotencyToken: true
              },
              GatingRule: {
                type: "structure",
                members: {
                  ControlPanelArn: {},
                  GatingControls: {
                    shape: "Sp"
                  },
                  Name: {},
                  RuleConfig: {
                    shape: "Sq"
                  },
                  TargetControls: {
                    shape: "Sp"
                  },
                  WaitPeriodMs: {
                    type: "integer"
                  }
                },
                required: [
                  "TargetControls",
                  "ControlPanelArn",
                  "GatingControls",
                  "RuleConfig",
                  "WaitPeriodMs",
                  "Name"
                ]
              },
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssertionRule: {
                shape: "Su"
              },
              GatingRule: {
                shape: "Sv"
              }
            }
          }
        },
        DeleteCluster: {
          http: {
            method: "DELETE",
            requestUri: "/cluster/{ClusterArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "ClusterArn"
              }
            },
            required: [
              "ClusterArn"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteControlPanel: {
          http: {
            method: "DELETE",
            requestUri: "/controlpanel/{ControlPanelArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ControlPanelArn: {
                location: "uri",
                locationName: "ControlPanelArn"
              }
            },
            required: [
              "ControlPanelArn"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRoutingControl: {
          http: {
            method: "DELETE",
            requestUri: "/routingcontrol/{RoutingControlArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              RoutingControlArn: {
                location: "uri",
                locationName: "RoutingControlArn"
              }
            },
            required: [
              "RoutingControlArn"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSafetyRule: {
          http: {
            method: "DELETE",
            requestUri: "/safetyrule/{SafetyRuleArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              SafetyRuleArn: {
                location: "uri",
                locationName: "SafetyRuleArn"
              }
            },
            required: [
              "SafetyRuleArn"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeCluster: {
          http: {
            method: "GET",
            requestUri: "/cluster/{ClusterArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "ClusterArn"
              }
            },
            required: [
              "ClusterArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                shape: "S7"
              }
            }
          }
        },
        DescribeControlPanel: {
          http: {
            method: "GET",
            requestUri: "/controlpanel/{ControlPanelArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ControlPanelArn: {
                location: "uri",
                locationName: "ControlPanelArn"
              }
            },
            required: [
              "ControlPanelArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              ControlPanel: {
                shape: "Sh"
              }
            }
          }
        },
        DescribeRoutingControl: {
          http: {
            method: "GET",
            requestUri: "/routingcontrol/{RoutingControlArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              RoutingControlArn: {
                location: "uri",
                locationName: "RoutingControlArn"
              }
            },
            required: [
              "RoutingControlArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              RoutingControl: {
                shape: "Sm"
              }
            }
          }
        },
        DescribeSafetyRule: {
          http: {
            method: "GET",
            requestUri: "/safetyrule/{SafetyRuleArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              SafetyRuleArn: {
                location: "uri",
                locationName: "SafetyRuleArn"
              }
            },
            required: [
              "SafetyRuleArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              AssertionRule: {
                shape: "Su"
              },
              GatingRule: {
                shape: "Sv"
              }
            }
          }
        },
        GetResourcePolicy: {
          http: {
            method: "GET",
            requestUri: "/resourcePolicy/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            },
            required: [
              "ResourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Policy: {}
            }
          }
        },
        ListAssociatedRoute53HealthChecks: {
          http: {
            method: "GET",
            requestUri: "/routingcontrol/{RoutingControlArn}/associatedRoute53HealthChecks",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              RoutingControlArn: {
                location: "uri",
                locationName: "RoutingControlArn"
              }
            },
            required: [
              "RoutingControlArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              HealthCheckIds: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListClusters: {
          http: {
            method: "GET",
            requestUri: "/cluster",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Clusters: {
                type: "list",
                member: {
                  shape: "S7"
                }
              },
              NextToken: {}
            }
          }
        },
        ListControlPanels: {
          http: {
            method: "GET",
            requestUri: "/controlpanels",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "querystring",
                locationName: "ClusterArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ControlPanels: {
                type: "list",
                member: {
                  shape: "Sh"
                }
              },
              NextToken: {}
            }
          }
        },
        ListRoutingControls: {
          http: {
            method: "GET",
            requestUri: "/controlpanel/{ControlPanelArn}/routingcontrols",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ControlPanelArn: {
                location: "uri",
                locationName: "ControlPanelArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            },
            required: [
              "ControlPanelArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              RoutingControls: {
                type: "list",
                member: {
                  shape: "Sm"
                }
              }
            }
          }
        },
        ListSafetyRules: {
          http: {
            method: "GET",
            requestUri: "/controlpanel/{ControlPanelArn}/safetyrules",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ControlPanelArn: {
                location: "uri",
                locationName: "ControlPanelArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            },
            required: [
              "ControlPanelArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              SafetyRules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ASSERTION: {
                      shape: "Su"
                    },
                    GATING: {
                      shape: "Sv"
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            },
            required: [
              "ResourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S3"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "S3"
              }
            },
            required: [
              "ResourceArn",
              "Tags"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "TagKeys",
                type: "list",
                member: {}
              }
            },
            required: [
              "ResourceArn",
              "TagKeys"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateControlPanel: {
          http: {
            method: "PUT",
            requestUri: "/controlpanel",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ControlPanelArn: {},
              ControlPanelName: {}
            },
            required: [
              "ControlPanelArn",
              "ControlPanelName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ControlPanel: {
                shape: "Sh"
              }
            }
          }
        },
        UpdateRoutingControl: {
          http: {
            method: "PUT",
            requestUri: "/routingcontrol",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              RoutingControlArn: {},
              RoutingControlName: {}
            },
            required: [
              "RoutingControlName",
              "RoutingControlArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              RoutingControl: {
                shape: "Sm"
              }
            }
          }
        },
        UpdateSafetyRule: {
          http: {
            method: "PUT",
            requestUri: "/safetyrule",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AssertionRuleUpdate: {
                type: "structure",
                members: {
                  Name: {},
                  SafetyRuleArn: {},
                  WaitPeriodMs: {
                    type: "integer"
                  }
                },
                required: [
                  "SafetyRuleArn",
                  "WaitPeriodMs",
                  "Name"
                ]
              },
              GatingRuleUpdate: {
                type: "structure",
                members: {
                  Name: {},
                  SafetyRuleArn: {},
                  WaitPeriodMs: {
                    type: "integer"
                  }
                },
                required: [
                  "SafetyRuleArn",
                  "WaitPeriodMs",
                  "Name"
                ]
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssertionRule: {
                shape: "Su"
              },
              GatingRule: {
                shape: "Sv"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "map",
          key: {},
          value: {}
        },
        S7: {
          type: "structure",
          members: {
            ClusterArn: {},
            ClusterEndpoints: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Endpoint: {},
                  Region: {}
                }
              }
            },
            Name: {},
            Status: {},
            Owner: {}
          }
        },
        Sh: {
          type: "structure",
          members: {
            ClusterArn: {},
            ControlPanelArn: {},
            DefaultControlPanel: {
              type: "boolean"
            },
            Name: {},
            RoutingControlCount: {
              type: "integer"
            },
            Status: {},
            Owner: {}
          }
        },
        Sm: {
          type: "structure",
          members: {
            ControlPanelArn: {},
            Name: {},
            RoutingControlArn: {},
            Status: {},
            Owner: {}
          }
        },
        Sp: {
          type: "list",
          member: {}
        },
        Sq: {
          type: "structure",
          members: {
            Inverted: {
              type: "boolean"
            },
            Threshold: {
              type: "integer"
            },
            Type: {}
          },
          required: [
            "Type",
            "Inverted",
            "Threshold"
          ]
        },
        Su: {
          type: "structure",
          members: {
            AssertedControls: {
              shape: "Sp"
            },
            ControlPanelArn: {},
            Name: {},
            RuleConfig: {
              shape: "Sq"
            },
            SafetyRuleArn: {},
            Status: {},
            WaitPeriodMs: {
              type: "integer"
            },
            Owner: {}
          },
          required: [
            "Status",
            "ControlPanelArn",
            "SafetyRuleArn",
            "AssertedControls",
            "RuleConfig",
            "WaitPeriodMs",
            "Name"
          ]
        },
        Sv: {
          type: "structure",
          members: {
            ControlPanelArn: {},
            GatingControls: {
              shape: "Sp"
            },
            Name: {},
            RuleConfig: {
              shape: "Sq"
            },
            SafetyRuleArn: {},
            Status: {},
            TargetControls: {
              shape: "Sp"
            },
            WaitPeriodMs: {
              type: "integer"
            },
            Owner: {}
          },
          required: [
            "Status",
            "TargetControls",
            "ControlPanelArn",
            "SafetyRuleArn",
            "GatingControls",
            "RuleConfig",
            "WaitPeriodMs",
            "Name"
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/route53-recovery-control-config-2020-11-02.paginators.json
var require_route53_recovery_control_config_2020_11_02_paginators = __commonJS({
  "node_modules/aws-sdk/apis/route53-recovery-control-config-2020-11-02.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAssociatedRoute53HealthChecks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "HealthCheckIds"
        },
        ListClusters: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Clusters"
        },
        ListControlPanels: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ControlPanels"
        },
        ListRoutingControls: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "RoutingControls"
        },
        ListSafetyRules: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "SafetyRules"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/route53-recovery-control-config-2020-11-02.waiters2.json
var require_route53_recovery_control_config_2020_11_02_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/route53-recovery-control-config-2020-11-02.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        ClusterCreated: {
          description: "Wait until a cluster is created",
          operation: "DescribeCluster",
          delay: 5,
          maxAttempts: 26,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "Cluster.Status",
              expected: "DEPLOYED"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "Cluster.Status",
              expected: "PENDING"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            }
          ]
        },
        ClusterDeleted: {
          description: "Wait for a cluster to be deleted",
          operation: "DescribeCluster",
          delay: 5,
          maxAttempts: 26,
          acceptors: [
            {
              state: "success",
              matcher: "status",
              expected: 404
            },
            {
              state: "retry",
              matcher: "path",
              argument: "Cluster.Status",
              expected: "PENDING_DELETION"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            }
          ]
        },
        ControlPanelCreated: {
          description: "Wait until a control panel is created",
          operation: "DescribeControlPanel",
          delay: 5,
          maxAttempts: 26,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "ControlPanel.Status",
              expected: "DEPLOYED"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "ControlPanel.Status",
              expected: "PENDING"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            }
          ]
        },
        ControlPanelDeleted: {
          description: "Wait until a control panel is deleted",
          operation: "DescribeControlPanel",
          delay: 5,
          maxAttempts: 26,
          acceptors: [
            {
              state: "success",
              matcher: "status",
              expected: 404
            },
            {
              state: "retry",
              matcher: "path",
              argument: "ControlPanel.Status",
              expected: "PENDING_DELETION"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            }
          ]
        },
        RoutingControlCreated: {
          description: "Wait until a routing control is created",
          operation: "DescribeRoutingControl",
          delay: 5,
          maxAttempts: 26,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "RoutingControl.Status",
              expected: "DEPLOYED"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "RoutingControl.Status",
              expected: "PENDING"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            }
          ]
        },
        RoutingControlDeleted: {
          description: "Wait for a routing control to be deleted",
          operation: "DescribeRoutingControl",
          delay: 5,
          maxAttempts: 26,
          acceptors: [
            {
              state: "success",
              matcher: "status",
              expected: 404
            },
            {
              state: "retry",
              matcher: "path",
              argument: "RoutingControl.Status",
              expected: "PENDING_DELETION"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/route53recoverycontrolconfig.js
var require_route53recoverycontrolconfig = __commonJS({
  "node_modules/aws-sdk/clients/route53recoverycontrolconfig.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["route53recoverycontrolconfig"] = {};
    AWS2.Route53RecoveryControlConfig = Service.defineService("route53recoverycontrolconfig", ["2020-11-02"]);
    Object.defineProperty(apiLoader.services["route53recoverycontrolconfig"], "2020-11-02", {
      get: function get() {
        var model = require_route53_recovery_control_config_2020_11_02_min();
        model.paginators = require_route53_recovery_control_config_2020_11_02_paginators().pagination;
        model.waiters = require_route53_recovery_control_config_2020_11_02_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Route53RecoveryControlConfig;
  }
});

// node_modules/aws-sdk/apis/route53-recovery-readiness-2019-12-02.min.json
var require_route53_recovery_readiness_2019_12_02_min = __commonJS({
  "node_modules/aws-sdk/apis/route53-recovery-readiness-2019-12-02.min.json"(exports2, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2019-12-02",
        endpointPrefix: "route53-recovery-readiness",
        signingName: "route53-recovery-readiness",
        serviceFullName: "AWS Route53 Recovery Readiness",
        serviceId: "Route53 Recovery Readiness",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "route53-recovery-readiness-2019-12-02",
        signatureVersion: "v4"
      },
      operations: {
        CreateCell: {
          http: {
            requestUri: "/cells",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CellName: {
                locationName: "cellName"
              },
              Cells: {
                shape: "S3",
                locationName: "cells"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            },
            required: [
              "CellName"
            ]
          },
          output: {
            type: "structure",
            members: {
              CellArn: {
                locationName: "cellArn"
              },
              CellName: {
                locationName: "cellName"
              },
              Cells: {
                shape: "S3",
                locationName: "cells"
              },
              ParentReadinessScopes: {
                shape: "S3",
                locationName: "parentReadinessScopes"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            }
          }
        },
        CreateCrossAccountAuthorization: {
          http: {
            requestUri: "/crossaccountauthorizations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CrossAccountAuthorization: {
                locationName: "crossAccountAuthorization"
              }
            },
            required: [
              "CrossAccountAuthorization"
            ]
          },
          output: {
            type: "structure",
            members: {
              CrossAccountAuthorization: {
                locationName: "crossAccountAuthorization"
              }
            }
          }
        },
        CreateReadinessCheck: {
          http: {
            requestUri: "/readinesschecks",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ReadinessCheckName: {
                locationName: "readinessCheckName"
              },
              ResourceSetName: {
                locationName: "resourceSetName"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            },
            required: [
              "ResourceSetName",
              "ReadinessCheckName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ReadinessCheckArn: {
                locationName: "readinessCheckArn"
              },
              ReadinessCheckName: {
                locationName: "readinessCheckName"
              },
              ResourceSet: {
                locationName: "resourceSet"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            }
          }
        },
        CreateRecoveryGroup: {
          http: {
            requestUri: "/recoverygroups",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Cells: {
                shape: "S3",
                locationName: "cells"
              },
              RecoveryGroupName: {
                locationName: "recoveryGroupName"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            },
            required: [
              "RecoveryGroupName"
            ]
          },
          output: {
            type: "structure",
            members: {
              Cells: {
                shape: "S3",
                locationName: "cells"
              },
              RecoveryGroupArn: {
                locationName: "recoveryGroupArn"
              },
              RecoveryGroupName: {
                locationName: "recoveryGroupName"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            }
          }
        },
        CreateResourceSet: {
          http: {
            requestUri: "/resourcesets",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceSetName: {
                locationName: "resourceSetName"
              },
              ResourceSetType: {
                locationName: "resourceSetType"
              },
              Resources: {
                shape: "Sh",
                locationName: "resources"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            },
            required: [
              "ResourceSetType",
              "ResourceSetName",
              "Resources"
            ]
          },
          output: {
            type: "structure",
            members: {
              ResourceSetArn: {
                locationName: "resourceSetArn"
              },
              ResourceSetName: {
                locationName: "resourceSetName"
              },
              ResourceSetType: {
                locationName: "resourceSetType"
              },
              Resources: {
                shape: "Sh",
                locationName: "resources"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            }
          }
        },
        DeleteCell: {
          http: {
            method: "DELETE",
            requestUri: "/cells/{cellName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              CellName: {
                location: "uri",
                locationName: "cellName"
              }
            },
            required: [
              "CellName"
            ]
          }
        },
        DeleteCrossAccountAuthorization: {
          http: {
            method: "DELETE",
            requestUri: "/crossaccountauthorizations/{crossAccountAuthorization}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CrossAccountAuthorization: {
                location: "uri",
                locationName: "crossAccountAuthorization"
              }
            },
            required: [
              "CrossAccountAuthorization"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteReadinessCheck: {
          http: {
            method: "DELETE",
            requestUri: "/readinesschecks/{readinessCheckName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ReadinessCheckName: {
                location: "uri",
                locationName: "readinessCheckName"
              }
            },
            required: [
              "ReadinessCheckName"
            ]
          }
        },
        DeleteRecoveryGroup: {
          http: {
            method: "DELETE",
            requestUri: "/recoverygroups/{recoveryGroupName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              RecoveryGroupName: {
                location: "uri",
                locationName: "recoveryGroupName"
              }
            },
            required: [
              "RecoveryGroupName"
            ]
          }
        },
        DeleteResourceSet: {
          http: {
            method: "DELETE",
            requestUri: "/resourcesets/{resourceSetName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceSetName: {
                location: "uri",
                locationName: "resourceSetName"
              }
            },
            required: [
              "ResourceSetName"
            ]
          }
        },
        GetArchitectureRecommendations: {
          http: {
            method: "GET",
            requestUri: "/recoverygroups/{recoveryGroupName}/architectureRecommendations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              RecoveryGroupName: {
                location: "uri",
                locationName: "recoveryGroupName"
              }
            },
            required: [
              "RecoveryGroupName"
            ]
          },
          output: {
            type: "structure",
            members: {
              LastAuditTimestamp: {
                locationName: "lastAuditTimestamp",
                type: "timestamp",
                timestampFormat: "iso8601"
              },
              NextToken: {
                locationName: "nextToken"
              },
              Recommendations: {
                locationName: "recommendations",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RecommendationText: {
                      locationName: "recommendationText"
                    }
                  },
                  required: [
                    "RecommendationText"
                  ]
                }
              }
            }
          }
        },
        GetCell: {
          http: {
            method: "GET",
            requestUri: "/cells/{cellName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CellName: {
                location: "uri",
                locationName: "cellName"
              }
            },
            required: [
              "CellName"
            ]
          },
          output: {
            type: "structure",
            members: {
              CellArn: {
                locationName: "cellArn"
              },
              CellName: {
                locationName: "cellName"
              },
              Cells: {
                shape: "S3",
                locationName: "cells"
              },
              ParentReadinessScopes: {
                shape: "S3",
                locationName: "parentReadinessScopes"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            }
          }
        },
        GetCellReadinessSummary: {
          http: {
            method: "GET",
            requestUri: "/cellreadiness/{cellName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CellName: {
                location: "uri",
                locationName: "cellName"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "CellName"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Readiness: {
                locationName: "readiness"
              },
              ReadinessChecks: {
                shape: "S15",
                locationName: "readinessChecks"
              }
            }
          }
        },
        GetReadinessCheck: {
          http: {
            method: "GET",
            requestUri: "/readinesschecks/{readinessCheckName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ReadinessCheckName: {
                location: "uri",
                locationName: "readinessCheckName"
              }
            },
            required: [
              "ReadinessCheckName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ReadinessCheckArn: {
                locationName: "readinessCheckArn"
              },
              ReadinessCheckName: {
                locationName: "readinessCheckName"
              },
              ResourceSet: {
                locationName: "resourceSet"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            }
          }
        },
        GetReadinessCheckResourceStatus: {
          http: {
            method: "GET",
            requestUri: "/readinesschecks/{readinessCheckName}/resource/{resourceIdentifier}/status",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              ReadinessCheckName: {
                location: "uri",
                locationName: "readinessCheckName"
              },
              ResourceIdentifier: {
                location: "uri",
                locationName: "resourceIdentifier"
              }
            },
            required: [
              "ReadinessCheckName",
              "ResourceIdentifier"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Readiness: {
                locationName: "readiness"
              },
              Rules: {
                locationName: "rules",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LastCheckedTimestamp: {
                      shape: "S1d",
                      locationName: "lastCheckedTimestamp"
                    },
                    Messages: {
                      shape: "S1e",
                      locationName: "messages"
                    },
                    Readiness: {
                      locationName: "readiness"
                    },
                    RuleId: {
                      locationName: "ruleId"
                    }
                  },
                  required: [
                    "Messages",
                    "Readiness",
                    "RuleId",
                    "LastCheckedTimestamp"
                  ]
                }
              }
            }
          }
        },
        GetReadinessCheckStatus: {
          http: {
            method: "GET",
            requestUri: "/readinesschecks/{readinessCheckName}/status",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              ReadinessCheckName: {
                location: "uri",
                locationName: "readinessCheckName"
              }
            },
            required: [
              "ReadinessCheckName"
            ]
          },
          output: {
            type: "structure",
            members: {
              Messages: {
                shape: "S1e",
                locationName: "messages"
              },
              NextToken: {
                locationName: "nextToken"
              },
              Readiness: {
                locationName: "readiness"
              },
              Resources: {
                locationName: "resources",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ComponentId: {
                      locationName: "componentId"
                    },
                    LastCheckedTimestamp: {
                      shape: "S1d",
                      locationName: "lastCheckedTimestamp"
                    },
                    Readiness: {
                      locationName: "readiness"
                    },
                    ResourceArn: {
                      locationName: "resourceArn"
                    }
                  },
                  required: [
                    "Readiness",
                    "LastCheckedTimestamp"
                  ]
                }
              }
            }
          }
        },
        GetRecoveryGroup: {
          http: {
            method: "GET",
            requestUri: "/recoverygroups/{recoveryGroupName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              RecoveryGroupName: {
                location: "uri",
                locationName: "recoveryGroupName"
              }
            },
            required: [
              "RecoveryGroupName"
            ]
          },
          output: {
            type: "structure",
            members: {
              Cells: {
                shape: "S3",
                locationName: "cells"
              },
              RecoveryGroupArn: {
                locationName: "recoveryGroupArn"
              },
              RecoveryGroupName: {
                locationName: "recoveryGroupName"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            }
          }
        },
        GetRecoveryGroupReadinessSummary: {
          http: {
            method: "GET",
            requestUri: "/recoverygroupreadiness/{recoveryGroupName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              RecoveryGroupName: {
                location: "uri",
                locationName: "recoveryGroupName"
              }
            },
            required: [
              "RecoveryGroupName"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Readiness: {
                locationName: "readiness"
              },
              ReadinessChecks: {
                shape: "S15",
                locationName: "readinessChecks"
              }
            }
          }
        },
        GetResourceSet: {
          http: {
            method: "GET",
            requestUri: "/resourcesets/{resourceSetName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceSetName: {
                location: "uri",
                locationName: "resourceSetName"
              }
            },
            required: [
              "ResourceSetName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ResourceSetArn: {
                locationName: "resourceSetArn"
              },
              ResourceSetName: {
                locationName: "resourceSetName"
              },
              ResourceSetType: {
                locationName: "resourceSetType"
              },
              Resources: {
                shape: "Sh",
                locationName: "resources"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            }
          }
        },
        ListCells: {
          http: {
            method: "GET",
            requestUri: "/cells",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Cells: {
                locationName: "cells",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CellArn: {
                      locationName: "cellArn"
                    },
                    CellName: {
                      locationName: "cellName"
                    },
                    Cells: {
                      shape: "S3",
                      locationName: "cells"
                    },
                    ParentReadinessScopes: {
                      shape: "S3",
                      locationName: "parentReadinessScopes"
                    },
                    Tags: {
                      shape: "S4",
                      locationName: "tags"
                    }
                  },
                  required: [
                    "ParentReadinessScopes",
                    "CellArn",
                    "CellName",
                    "Cells"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListCrossAccountAuthorizations: {
          http: {
            method: "GET",
            requestUri: "/crossaccountauthorizations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CrossAccountAuthorizations: {
                locationName: "crossAccountAuthorizations",
                type: "list",
                member: {}
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListReadinessChecks: {
          http: {
            method: "GET",
            requestUri: "/readinesschecks",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              ReadinessChecks: {
                locationName: "readinessChecks",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ReadinessCheckArn: {
                      locationName: "readinessCheckArn"
                    },
                    ReadinessCheckName: {
                      locationName: "readinessCheckName"
                    },
                    ResourceSet: {
                      locationName: "resourceSet"
                    },
                    Tags: {
                      shape: "S4",
                      locationName: "tags"
                    }
                  },
                  required: [
                    "ReadinessCheckArn",
                    "ResourceSet"
                  ]
                }
              }
            }
          }
        },
        ListRecoveryGroups: {
          http: {
            method: "GET",
            requestUri: "/recoverygroups",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              RecoveryGroups: {
                locationName: "recoveryGroups",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Cells: {
                      shape: "S3",
                      locationName: "cells"
                    },
                    RecoveryGroupArn: {
                      locationName: "recoveryGroupArn"
                    },
                    RecoveryGroupName: {
                      locationName: "recoveryGroupName"
                    },
                    Tags: {
                      shape: "S4",
                      locationName: "tags"
                    }
                  },
                  required: [
                    "RecoveryGroupArn",
                    "RecoveryGroupName",
                    "Cells"
                  ]
                }
              }
            }
          }
        },
        ListResourceSets: {
          http: {
            method: "GET",
            requestUri: "/resourcesets",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              ResourceSets: {
                locationName: "resourceSets",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceSetArn: {
                      locationName: "resourceSetArn"
                    },
                    ResourceSetName: {
                      locationName: "resourceSetName"
                    },
                    ResourceSetType: {
                      locationName: "resourceSetType"
                    },
                    Resources: {
                      shape: "Sh",
                      locationName: "resources"
                    },
                    Tags: {
                      shape: "S4",
                      locationName: "tags"
                    }
                  },
                  required: [
                    "ResourceSetType",
                    "ResourceSetName",
                    "ResourceSetArn",
                    "Resources"
                  ]
                }
              }
            }
          }
        },
        ListRules: {
          http: {
            method: "GET",
            requestUri: "/rules",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Rules: {
                locationName: "rules",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceType: {
                      locationName: "resourceType"
                    },
                    RuleDescription: {
                      locationName: "ruleDescription"
                    },
                    RuleId: {
                      locationName: "ruleId"
                    }
                  },
                  required: [
                    "RuleDescription",
                    "RuleId",
                    "ResourceType"
                  ]
                }
              }
            }
          }
        },
        ListTagsForResources: {
          http: {
            method: "GET",
            requestUri: "/tags/{resource-arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              }
            },
            required: [
              "ResourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resource-arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            },
            required: [
              "ResourceArn",
              "Tags"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              TagKeys: {
                shape: "S3",
                location: "querystring",
                locationName: "tagKeys"
              }
            },
            required: [
              "TagKeys",
              "ResourceArn"
            ]
          }
        },
        UpdateCell: {
          http: {
            method: "PUT",
            requestUri: "/cells/{cellName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CellName: {
                location: "uri",
                locationName: "cellName"
              },
              Cells: {
                shape: "S3",
                locationName: "cells"
              }
            },
            required: [
              "CellName",
              "Cells"
            ]
          },
          output: {
            type: "structure",
            members: {
              CellArn: {
                locationName: "cellArn"
              },
              CellName: {
                locationName: "cellName"
              },
              Cells: {
                shape: "S3",
                locationName: "cells"
              },
              ParentReadinessScopes: {
                shape: "S3",
                locationName: "parentReadinessScopes"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            }
          }
        },
        UpdateReadinessCheck: {
          http: {
            method: "PUT",
            requestUri: "/readinesschecks/{readinessCheckName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ReadinessCheckName: {
                location: "uri",
                locationName: "readinessCheckName"
              },
              ResourceSetName: {
                locationName: "resourceSetName"
              }
            },
            required: [
              "ReadinessCheckName",
              "ResourceSetName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ReadinessCheckArn: {
                locationName: "readinessCheckArn"
              },
              ReadinessCheckName: {
                locationName: "readinessCheckName"
              },
              ResourceSet: {
                locationName: "resourceSet"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            }
          }
        },
        UpdateRecoveryGroup: {
          http: {
            method: "PUT",
            requestUri: "/recoverygroups/{recoveryGroupName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Cells: {
                shape: "S3",
                locationName: "cells"
              },
              RecoveryGroupName: {
                location: "uri",
                locationName: "recoveryGroupName"
              }
            },
            required: [
              "RecoveryGroupName",
              "Cells"
            ]
          },
          output: {
            type: "structure",
            members: {
              Cells: {
                shape: "S3",
                locationName: "cells"
              },
              RecoveryGroupArn: {
                locationName: "recoveryGroupArn"
              },
              RecoveryGroupName: {
                locationName: "recoveryGroupName"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            }
          }
        },
        UpdateResourceSet: {
          http: {
            method: "PUT",
            requestUri: "/resourcesets/{resourceSetName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceSetName: {
                location: "uri",
                locationName: "resourceSetName"
              },
              ResourceSetType: {
                locationName: "resourceSetType"
              },
              Resources: {
                shape: "Sh",
                locationName: "resources"
              }
            },
            required: [
              "ResourceSetName",
              "ResourceSetType",
              "Resources"
            ]
          },
          output: {
            type: "structure",
            members: {
              ResourceSetArn: {
                locationName: "resourceSetArn"
              },
              ResourceSetName: {
                locationName: "resourceSetName"
              },
              ResourceSetType: {
                locationName: "resourceSetType"
              },
              Resources: {
                shape: "Sh",
                locationName: "resources"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {}
        },
        S4: {
          type: "map",
          key: {},
          value: {}
        },
        Sh: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ComponentId: {
                locationName: "componentId"
              },
              DnsTargetResource: {
                locationName: "dnsTargetResource",
                type: "structure",
                members: {
                  DomainName: {
                    locationName: "domainName"
                  },
                  HostedZoneArn: {
                    locationName: "hostedZoneArn"
                  },
                  RecordSetId: {
                    locationName: "recordSetId"
                  },
                  RecordType: {
                    locationName: "recordType"
                  },
                  TargetResource: {
                    locationName: "targetResource",
                    type: "structure",
                    members: {
                      NLBResource: {
                        locationName: "nLBResource",
                        type: "structure",
                        members: {
                          Arn: {
                            locationName: "arn"
                          }
                        }
                      },
                      R53Resource: {
                        locationName: "r53Resource",
                        type: "structure",
                        members: {
                          DomainName: {
                            locationName: "domainName"
                          },
                          RecordSetId: {
                            locationName: "recordSetId"
                          }
                        }
                      }
                    }
                  }
                }
              },
              ReadinessScopes: {
                shape: "S3",
                locationName: "readinessScopes"
              },
              ResourceArn: {
                locationName: "resourceArn"
              }
            }
          }
        },
        S15: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Readiness: {
                locationName: "readiness"
              },
              ReadinessCheckName: {
                locationName: "readinessCheckName"
              }
            }
          }
        },
        S1d: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S1e: {
          type: "list",
          member: {
            type: "structure",
            members: {
              MessageText: {
                locationName: "messageText"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/route53-recovery-readiness-2019-12-02.paginators.json
var require_route53_recovery_readiness_2019_12_02_paginators = __commonJS({
  "node_modules/aws-sdk/apis/route53-recovery-readiness-2019-12-02.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListReadinessChecks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ReadinessChecks"
        },
        ListResourceSets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ResourceSets"
        },
        ListCells: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Cells"
        },
        ListRecoveryGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "RecoveryGroups"
        },
        ListRules: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Rules"
        },
        ListCrossAccountAuthorizations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "CrossAccountAuthorizations"
        },
        GetCellReadinessSummary: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ReadinessChecks",
          non_aggregate_keys: [
            "Readiness"
          ]
        },
        GetRecoveryGroupReadinessSummary: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ReadinessChecks",
          non_aggregate_keys: [
            "Readiness"
          ]
        },
        GetReadinessCheckStatus: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Resources",
          non_aggregate_keys: [
            "Readiness",
            "Messages"
          ]
        },
        GetReadinessCheckResourceStatus: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Rules",
          non_aggregate_keys: [
            "Readiness"
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/route53recoveryreadiness.js
var require_route53recoveryreadiness = __commonJS({
  "node_modules/aws-sdk/clients/route53recoveryreadiness.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["route53recoveryreadiness"] = {};
    AWS2.Route53RecoveryReadiness = Service.defineService("route53recoveryreadiness", ["2019-12-02"]);
    Object.defineProperty(apiLoader.services["route53recoveryreadiness"], "2019-12-02", {
      get: function get() {
        var model = require_route53_recovery_readiness_2019_12_02_min();
        model.paginators = require_route53_recovery_readiness_2019_12_02_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Route53RecoveryReadiness;
  }
});

// node_modules/aws-sdk/apis/chime-sdk-identity-2021-04-20.min.json
var require_chime_sdk_identity_2021_04_20_min = __commonJS({
  "node_modules/aws-sdk/apis/chime-sdk-identity-2021-04-20.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-04-20",
        endpointPrefix: "identity-chime",
        protocol: "rest-json",
        serviceFullName: "Amazon Chime SDK Identity",
        serviceId: "Chime SDK Identity",
        signatureVersion: "v4",
        signingName: "chime",
        uid: "chime-sdk-identity-2021-04-20"
      },
      operations: {
        CreateAppInstance: {
          http: {
            requestUri: "/app-instances",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "ClientRequestToken"
            ],
            members: {
              Name: {
                shape: "S2"
              },
              Metadata: {
                shape: "S3"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceArn: {}
            }
          }
        },
        CreateAppInstanceAdmin: {
          http: {
            requestUri: "/app-instances/{appInstanceArn}/admins",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceAdminArn",
              "AppInstanceArn"
            ],
            members: {
              AppInstanceAdminArn: {},
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceAdmin: {
                shape: "Sd"
              },
              AppInstanceArn: {}
            }
          }
        },
        CreateAppInstanceBot: {
          http: {
            requestUri: "/app-instance-bots",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn",
              "ClientRequestToken",
              "Configuration"
            ],
            members: {
              AppInstanceArn: {},
              Name: {
                shape: "Se"
              },
              Metadata: {
                shape: "S3"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S5"
              },
              Configuration: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceBotArn: {}
            }
          }
        },
        CreateAppInstanceUser: {
          http: {
            requestUri: "/app-instance-users",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn",
              "AppInstanceUserId",
              "Name",
              "ClientRequestToken"
            ],
            members: {
              AppInstanceArn: {},
              AppInstanceUserId: {
                type: "string",
                sensitive: true
              },
              Name: {
                shape: "Ss"
              },
              Metadata: {
                shape: "S3"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S5"
              },
              ExpirationSettings: {
                shape: "St"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceUserArn: {}
            }
          }
        },
        DeleteAppInstance: {
          http: {
            method: "DELETE",
            requestUri: "/app-instances/{appInstanceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              }
            }
          }
        },
        DeleteAppInstanceAdmin: {
          http: {
            method: "DELETE",
            requestUri: "/app-instances/{appInstanceArn}/admins/{appInstanceAdminArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceAdminArn",
              "AppInstanceArn"
            ],
            members: {
              AppInstanceAdminArn: {
                location: "uri",
                locationName: "appInstanceAdminArn"
              },
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              }
            }
          }
        },
        DeleteAppInstanceBot: {
          http: {
            method: "DELETE",
            requestUri: "/app-instance-bots/{appInstanceBotArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceBotArn"
            ],
            members: {
              AppInstanceBotArn: {
                location: "uri",
                locationName: "appInstanceBotArn"
              }
            }
          }
        },
        DeleteAppInstanceUser: {
          http: {
            method: "DELETE",
            requestUri: "/app-instance-users/{appInstanceUserArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceUserArn"
            ],
            members: {
              AppInstanceUserArn: {
                location: "uri",
                locationName: "appInstanceUserArn"
              }
            }
          }
        },
        DeregisterAppInstanceUserEndpoint: {
          http: {
            method: "DELETE",
            requestUri: "/app-instance-users/{appInstanceUserArn}/endpoints/{endpointId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceUserArn",
              "EndpointId"
            ],
            members: {
              AppInstanceUserArn: {
                location: "uri",
                locationName: "appInstanceUserArn"
              },
              EndpointId: {
                location: "uri",
                locationName: "endpointId"
              }
            }
          }
        },
        DescribeAppInstance: {
          http: {
            method: "GET",
            requestUri: "/app-instances/{appInstanceArn}"
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstance: {
                type: "structure",
                members: {
                  AppInstanceArn: {},
                  Name: {
                    shape: "S2"
                  },
                  CreatedTimestamp: {
                    type: "timestamp"
                  },
                  LastUpdatedTimestamp: {
                    type: "timestamp"
                  },
                  Metadata: {
                    shape: "S3"
                  }
                }
              }
            }
          }
        },
        DescribeAppInstanceAdmin: {
          http: {
            method: "GET",
            requestUri: "/app-instances/{appInstanceArn}/admins/{appInstanceAdminArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceAdminArn",
              "AppInstanceArn"
            ],
            members: {
              AppInstanceAdminArn: {
                location: "uri",
                locationName: "appInstanceAdminArn"
              },
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceAdmin: {
                type: "structure",
                members: {
                  Admin: {
                    shape: "Sd"
                  },
                  AppInstanceArn: {},
                  CreatedTimestamp: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        DescribeAppInstanceBot: {
          http: {
            method: "GET",
            requestUri: "/app-instance-bots/{appInstanceBotArn}"
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceBotArn"
            ],
            members: {
              AppInstanceBotArn: {
                location: "uri",
                locationName: "appInstanceBotArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceBot: {
                type: "structure",
                members: {
                  AppInstanceBotArn: {},
                  Name: {
                    shape: "Se"
                  },
                  Configuration: {
                    shape: "Sg"
                  },
                  CreatedTimestamp: {
                    type: "timestamp"
                  },
                  LastUpdatedTimestamp: {
                    type: "timestamp"
                  },
                  Metadata: {
                    shape: "S3"
                  }
                }
              }
            }
          }
        },
        DescribeAppInstanceUser: {
          http: {
            method: "GET",
            requestUri: "/app-instance-users/{appInstanceUserArn}"
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceUserArn"
            ],
            members: {
              AppInstanceUserArn: {
                location: "uri",
                locationName: "appInstanceUserArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceUser: {
                type: "structure",
                members: {
                  AppInstanceUserArn: {},
                  Name: {
                    shape: "Ss"
                  },
                  Metadata: {
                    shape: "S3"
                  },
                  CreatedTimestamp: {
                    type: "timestamp"
                  },
                  LastUpdatedTimestamp: {
                    type: "timestamp"
                  },
                  ExpirationSettings: {
                    shape: "St"
                  }
                }
              }
            }
          }
        },
        DescribeAppInstanceUserEndpoint: {
          http: {
            method: "GET",
            requestUri: "/app-instance-users/{appInstanceUserArn}/endpoints/{endpointId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceUserArn",
              "EndpointId"
            ],
            members: {
              AppInstanceUserArn: {
                location: "uri",
                locationName: "appInstanceUserArn"
              },
              EndpointId: {
                location: "uri",
                locationName: "endpointId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceUserEndpoint: {
                type: "structure",
                members: {
                  AppInstanceUserArn: {},
                  EndpointId: {},
                  Name: {
                    shape: "S1k"
                  },
                  Type: {},
                  ResourceArn: {},
                  EndpointAttributes: {
                    shape: "S1m"
                  },
                  CreatedTimestamp: {
                    type: "timestamp"
                  },
                  LastUpdatedTimestamp: {
                    type: "timestamp"
                  },
                  AllowMessages: {},
                  EndpointState: {
                    shape: "S1p"
                  }
                }
              }
            }
          }
        },
        GetAppInstanceRetentionSettings: {
          http: {
            method: "GET",
            requestUri: "/app-instances/{appInstanceArn}/retention-settings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceRetentionSettings: {
                shape: "S1u"
              },
              InitiateDeletionTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        ListAppInstanceAdmins: {
          http: {
            method: "GET",
            requestUri: "/app-instances/{appInstanceArn}/admins",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "S1z",
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceArn: {},
              AppInstanceAdmins: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Admin: {
                      shape: "Sd"
                    }
                  }
                }
              },
              NextToken: {
                shape: "S1z"
              }
            }
          }
        },
        ListAppInstanceBots: {
          http: {
            method: "GET",
            requestUri: "/app-instance-bots"
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn"
            ],
            members: {
              AppInstanceArn: {
                location: "querystring",
                locationName: "app-instance-arn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "S1z",
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceArn: {},
              AppInstanceBots: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AppInstanceBotArn: {},
                    Name: {
                      shape: "Se"
                    },
                    Metadata: {
                      shape: "S3"
                    }
                  }
                }
              },
              NextToken: {
                shape: "S1z"
              }
            }
          }
        },
        ListAppInstanceUserEndpoints: {
          http: {
            method: "GET",
            requestUri: "/app-instance-users/{appInstanceUserArn}/endpoints",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceUserArn"
            ],
            members: {
              AppInstanceUserArn: {
                shape: "S28",
                location: "uri",
                locationName: "appInstanceUserArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "S1z",
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceUserEndpoints: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AppInstanceUserArn: {},
                    EndpointId: {},
                    Name: {
                      shape: "S1k"
                    },
                    Type: {},
                    AllowMessages: {},
                    EndpointState: {
                      shape: "S1p"
                    }
                  }
                }
              },
              NextToken: {
                shape: "S1z"
              }
            }
          }
        },
        ListAppInstanceUsers: {
          http: {
            method: "GET",
            requestUri: "/app-instance-users"
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn"
            ],
            members: {
              AppInstanceArn: {
                location: "querystring",
                locationName: "app-instance-arn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "S1z",
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceArn: {},
              AppInstanceUsers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AppInstanceUserArn: {},
                    Name: {
                      shape: "Ss"
                    },
                    Metadata: {
                      shape: "S3"
                    }
                  }
                }
              },
              NextToken: {
                shape: "S1z"
              }
            }
          }
        },
        ListAppInstances: {
          http: {
            method: "GET",
            requestUri: "/app-instances"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "S1z",
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AppInstanceArn: {},
                    Name: {
                      shape: "S2"
                    },
                    Metadata: {
                      shape: "S3"
                    }
                  }
                }
              },
              NextToken: {
                shape: "S1z"
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {
                location: "querystring",
                locationName: "arn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S5"
              }
            }
          }
        },
        PutAppInstanceRetentionSettings: {
          http: {
            method: "PUT",
            requestUri: "/app-instances/{appInstanceArn}/retention-settings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn",
              "AppInstanceRetentionSettings"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              },
              AppInstanceRetentionSettings: {
                shape: "S1u"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceRetentionSettings: {
                shape: "S1u"
              },
              InitiateDeletionTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        PutAppInstanceUserExpirationSettings: {
          http: {
            method: "PUT",
            requestUri: "/app-instance-users/{appInstanceUserArn}/expiration-settings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceUserArn"
            ],
            members: {
              AppInstanceUserArn: {
                location: "uri",
                locationName: "appInstanceUserArn"
              },
              ExpirationSettings: {
                shape: "St"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceUserArn: {},
              ExpirationSettings: {
                shape: "St"
              }
            }
          }
        },
        RegisterAppInstanceUserEndpoint: {
          http: {
            requestUri: "/app-instance-users/{appInstanceUserArn}/endpoints",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceUserArn",
              "Type",
              "ResourceArn",
              "EndpointAttributes",
              "ClientRequestToken"
            ],
            members: {
              AppInstanceUserArn: {
                shape: "S28",
                location: "uri",
                locationName: "appInstanceUserArn"
              },
              Name: {
                shape: "S1k"
              },
              Type: {},
              ResourceArn: {},
              EndpointAttributes: {
                shape: "S1m"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              AllowMessages: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceUserArn: {},
              EndpointId: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags?operation=tag-resource",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S5"
              }
            }
          }
        },
        UntagResource: {
          http: {
            requestUri: "/tags?operation=untag-resource",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {
                  shape: "S7"
                }
              }
            }
          }
        },
        UpdateAppInstance: {
          http: {
            method: "PUT",
            requestUri: "/app-instances/{appInstanceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn",
              "Name",
              "Metadata"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              },
              Name: {
                shape: "S2"
              },
              Metadata: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceArn: {}
            }
          }
        },
        UpdateAppInstanceBot: {
          http: {
            method: "PUT",
            requestUri: "/app-instance-bots/{appInstanceBotArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceBotArn",
              "Name",
              "Metadata"
            ],
            members: {
              AppInstanceBotArn: {
                location: "uri",
                locationName: "appInstanceBotArn"
              },
              Name: {
                shape: "Se"
              },
              Metadata: {
                shape: "S3"
              },
              Configuration: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceBotArn: {}
            }
          }
        },
        UpdateAppInstanceUser: {
          http: {
            method: "PUT",
            requestUri: "/app-instance-users/{appInstanceUserArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceUserArn",
              "Name",
              "Metadata"
            ],
            members: {
              AppInstanceUserArn: {
                location: "uri",
                locationName: "appInstanceUserArn"
              },
              Name: {
                shape: "Ss"
              },
              Metadata: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceUserArn: {}
            }
          }
        },
        UpdateAppInstanceUserEndpoint: {
          http: {
            method: "PUT",
            requestUri: "/app-instance-users/{appInstanceUserArn}/endpoints/{endpointId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceUserArn",
              "EndpointId"
            ],
            members: {
              AppInstanceUserArn: {
                location: "uri",
                locationName: "appInstanceUserArn"
              },
              EndpointId: {
                location: "uri",
                locationName: "endpointId"
              },
              Name: {
                shape: "S1k"
              },
              AllowMessages: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceUserArn: {},
              EndpointId: {}
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "string",
          sensitive: true
        },
        S3: {
          type: "string",
          sensitive: true
        },
        S5: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {
                shape: "S7"
              },
              Value: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        S7: {
          type: "string",
          sensitive: true
        },
        Sd: {
          type: "structure",
          members: {
            Arn: {},
            Name: {
              shape: "Se"
            }
          }
        },
        Se: {
          type: "string",
          sensitive: true
        },
        Sg: {
          type: "structure",
          required: [
            "Lex"
          ],
          members: {
            Lex: {
              type: "structure",
              required: [
                "LexBotAliasArn",
                "LocaleId"
              ],
              members: {
                RespondsTo: {},
                InvokedBy: {
                  type: "structure",
                  required: [
                    "StandardMessages",
                    "TargetedMessages"
                  ],
                  members: {
                    StandardMessages: {},
                    TargetedMessages: {}
                  }
                },
                LexBotAliasArn: {},
                LocaleId: {},
                WelcomeIntent: {}
              }
            }
          }
        },
        Ss: {
          type: "string",
          sensitive: true
        },
        St: {
          type: "structure",
          required: [
            "ExpirationDays",
            "ExpirationCriterion"
          ],
          members: {
            ExpirationDays: {
              type: "integer"
            },
            ExpirationCriterion: {}
          }
        },
        S1k: {
          type: "string",
          sensitive: true
        },
        S1m: {
          type: "structure",
          required: [
            "DeviceToken"
          ],
          members: {
            DeviceToken: {
              shape: "S1n"
            },
            VoipDeviceToken: {
              shape: "S1n"
            }
          }
        },
        S1n: {
          type: "string",
          sensitive: true
        },
        S1p: {
          type: "structure",
          required: [
            "Status"
          ],
          members: {
            Status: {},
            StatusReason: {}
          }
        },
        S1u: {
          type: "structure",
          members: {
            ChannelRetentionSettings: {
              type: "structure",
              members: {
                RetentionDays: {
                  type: "integer"
                }
              }
            }
          }
        },
        S1z: {
          type: "string",
          sensitive: true
        },
        S28: {
          type: "string",
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/chime-sdk-identity-2021-04-20.paginators.json
var require_chime_sdk_identity_2021_04_20_paginators = __commonJS({
  "node_modules/aws-sdk/apis/chime-sdk-identity-2021-04-20.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAppInstanceAdmins: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAppInstanceBots: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAppInstanceUserEndpoints: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAppInstanceUsers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAppInstances: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/chimesdkidentity.js
var require_chimesdkidentity = __commonJS({
  "node_modules/aws-sdk/clients/chimesdkidentity.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["chimesdkidentity"] = {};
    AWS2.ChimeSDKIdentity = Service.defineService("chimesdkidentity", ["2021-04-20"]);
    Object.defineProperty(apiLoader.services["chimesdkidentity"], "2021-04-20", {
      get: function get() {
        var model = require_chime_sdk_identity_2021_04_20_min();
        model.paginators = require_chime_sdk_identity_2021_04_20_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ChimeSDKIdentity;
  }
});

// node_modules/aws-sdk/apis/chime-sdk-messaging-2021-05-15.min.json
var require_chime_sdk_messaging_2021_05_15_min = __commonJS({
  "node_modules/aws-sdk/apis/chime-sdk-messaging-2021-05-15.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-05-15",
        endpointPrefix: "messaging-chime",
        protocol: "rest-json",
        serviceFullName: "Amazon Chime SDK Messaging",
        serviceId: "Chime SDK Messaging",
        signatureVersion: "v4",
        signingName: "chime",
        uid: "chime-sdk-messaging-2021-05-15"
      },
      operations: {
        AssociateChannelFlow: {
          http: {
            method: "PUT",
            requestUri: "/channels/{channelArn}/channel-flow",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "ChannelFlowArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              ChannelFlowArn: {},
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          }
        },
        BatchCreateChannelMembership: {
          http: {
            requestUri: "/channels/{channelArn}/memberships?operation=batch-create",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MemberArns",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              Type: {},
              MemberArns: {
                type: "list",
                member: {}
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              },
              SubChannelId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BatchChannelMemberships: {
                type: "structure",
                members: {
                  InvitedBy: {
                    shape: "S9"
                  },
                  Type: {},
                  Members: {
                    type: "list",
                    member: {
                      shape: "S9"
                    }
                  },
                  ChannelArn: {},
                  SubChannelId: {}
                }
              },
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MemberArn: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        ChannelFlowCallback: {
          http: {
            requestUri: "/channels/{channelArn}?operation=channel-flow-callback",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CallbackId",
              "ChannelArn",
              "ChannelMessage"
            ],
            members: {
              CallbackId: {
                idempotencyToken: true
              },
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              DeleteResource: {
                type: "boolean"
              },
              ChannelMessage: {
                type: "structure",
                required: [
                  "MessageId"
                ],
                members: {
                  MessageId: {},
                  Content: {
                    shape: "Sl"
                  },
                  Metadata: {
                    shape: "Sm"
                  },
                  PushNotification: {
                    shape: "Sn"
                  },
                  MessageAttributes: {
                    shape: "Sr"
                  },
                  SubChannelId: {},
                  ContentType: {
                    shape: "Sw"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              CallbackId: {}
            }
          }
        },
        CreateChannel: {
          http: {
            requestUri: "/channels",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn",
              "Name",
              "ClientRequestToken",
              "ChimeBearer"
            ],
            members: {
              AppInstanceArn: {},
              Name: {
                shape: "Sz"
              },
              Mode: {},
              Privacy: {},
              Metadata: {
                shape: "Sm"
              },
              ClientRequestToken: {
                shape: "S12",
                idempotencyToken: true
              },
              Tags: {
                shape: "S13"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              },
              ChannelId: {
                type: "string",
                sensitive: true
              },
              MemberArns: {
                type: "list",
                member: {}
              },
              ModeratorArns: {
                type: "list",
                member: {}
              },
              ElasticChannelConfiguration: {
                shape: "S1a"
              },
              ExpirationSettings: {
                shape: "S1e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {}
            }
          }
        },
        CreateChannelBan: {
          http: {
            requestUri: "/channels/{channelArn}/bans",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MemberArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MemberArn: {},
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              Member: {
                shape: "S9"
              }
            }
          }
        },
        CreateChannelFlow: {
          http: {
            requestUri: "/channel-flows",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn",
              "Processors",
              "Name",
              "ClientRequestToken"
            ],
            members: {
              AppInstanceArn: {},
              Processors: {
                shape: "S1l"
              },
              Name: {
                shape: "Sz"
              },
              Tags: {
                shape: "S13"
              },
              ClientRequestToken: {
                shape: "S12",
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelFlowArn: {}
            }
          }
        },
        CreateChannelMembership: {
          http: {
            requestUri: "/channels/{channelArn}/memberships",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MemberArn",
              "Type",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MemberArn: {},
              Type: {},
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              },
              SubChannelId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              Member: {
                shape: "S9"
              },
              SubChannelId: {}
            }
          }
        },
        CreateChannelModerator: {
          http: {
            requestUri: "/channels/{channelArn}/moderators",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "ChannelModeratorArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              ChannelModeratorArn: {},
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              ChannelModerator: {
                shape: "S9"
              }
            }
          }
        },
        DeleteChannel: {
          http: {
            method: "DELETE",
            requestUri: "/channels/{channelArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          }
        },
        DeleteChannelBan: {
          http: {
            method: "DELETE",
            requestUri: "/channels/{channelArn}/bans/{memberArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MemberArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MemberArn: {
                location: "uri",
                locationName: "memberArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          }
        },
        DeleteChannelFlow: {
          http: {
            method: "DELETE",
            requestUri: "/channel-flows/{channelFlowArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ChannelFlowArn"
            ],
            members: {
              ChannelFlowArn: {
                location: "uri",
                locationName: "channelFlowArn"
              }
            }
          }
        },
        DeleteChannelMembership: {
          http: {
            method: "DELETE",
            requestUri: "/channels/{channelArn}/memberships/{memberArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MemberArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MemberArn: {
                location: "uri",
                locationName: "memberArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              },
              SubChannelId: {
                location: "querystring",
                locationName: "sub-channel-id"
              }
            }
          }
        },
        DeleteChannelMessage: {
          http: {
            method: "DELETE",
            requestUri: "/channels/{channelArn}/messages/{messageId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MessageId",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MessageId: {
                location: "uri",
                locationName: "messageId"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              },
              SubChannelId: {
                location: "querystring",
                locationName: "sub-channel-id"
              }
            }
          }
        },
        DeleteChannelModerator: {
          http: {
            method: "DELETE",
            requestUri: "/channels/{channelArn}/moderators/{channelModeratorArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "ChannelModeratorArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              ChannelModeratorArn: {
                location: "uri",
                locationName: "channelModeratorArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          }
        },
        DeleteMessagingStreamingConfigurations: {
          http: {
            method: "DELETE",
            requestUri: "/app-instances/{appInstanceArn}/streaming-configurations",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              }
            }
          }
        },
        DescribeChannel: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Channel: {
                type: "structure",
                members: {
                  Name: {
                    shape: "Sz"
                  },
                  ChannelArn: {},
                  Mode: {},
                  Privacy: {},
                  Metadata: {
                    shape: "Sm"
                  },
                  CreatedBy: {
                    shape: "S9"
                  },
                  CreatedTimestamp: {
                    type: "timestamp"
                  },
                  LastMessageTimestamp: {
                    type: "timestamp"
                  },
                  LastUpdatedTimestamp: {
                    type: "timestamp"
                  },
                  ChannelFlowArn: {},
                  ElasticChannelConfiguration: {
                    shape: "S1a"
                  },
                  ExpirationSettings: {
                    shape: "S1e"
                  }
                }
              }
            }
          }
        },
        DescribeChannelBan: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/bans/{memberArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MemberArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MemberArn: {
                location: "uri",
                locationName: "memberArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelBan: {
                type: "structure",
                members: {
                  Member: {
                    shape: "S9"
                  },
                  ChannelArn: {},
                  CreatedTimestamp: {
                    type: "timestamp"
                  },
                  CreatedBy: {
                    shape: "S9"
                  }
                }
              }
            }
          }
        },
        DescribeChannelFlow: {
          http: {
            method: "GET",
            requestUri: "/channel-flows/{channelFlowArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelFlowArn"
            ],
            members: {
              ChannelFlowArn: {
                location: "uri",
                locationName: "channelFlowArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelFlow: {
                type: "structure",
                members: {
                  ChannelFlowArn: {},
                  Processors: {
                    shape: "S1l"
                  },
                  Name: {
                    shape: "Sz"
                  },
                  CreatedTimestamp: {
                    type: "timestamp"
                  },
                  LastUpdatedTimestamp: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        DescribeChannelMembership: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/memberships/{memberArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MemberArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MemberArn: {
                location: "uri",
                locationName: "memberArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              },
              SubChannelId: {
                location: "querystring",
                locationName: "sub-channel-id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelMembership: {
                type: "structure",
                members: {
                  InvitedBy: {
                    shape: "S9"
                  },
                  Type: {},
                  Member: {
                    shape: "S9"
                  },
                  ChannelArn: {},
                  CreatedTimestamp: {
                    type: "timestamp"
                  },
                  LastUpdatedTimestamp: {
                    type: "timestamp"
                  },
                  SubChannelId: {}
                }
              }
            }
          }
        },
        DescribeChannelMembershipForAppInstanceUser: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}?scope=app-instance-user-membership",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "AppInstanceUserArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              AppInstanceUserArn: {
                location: "querystring",
                locationName: "app-instance-user-arn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelMembership: {
                shape: "S2k"
              }
            }
          }
        },
        DescribeChannelModeratedByAppInstanceUser: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}?scope=app-instance-user-moderated-channel",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "AppInstanceUserArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              AppInstanceUserArn: {
                location: "querystring",
                locationName: "app-instance-user-arn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Channel: {
                shape: "S2p"
              }
            }
          }
        },
        DescribeChannelModerator: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/moderators/{channelModeratorArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "ChannelModeratorArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              ChannelModeratorArn: {
                location: "uri",
                locationName: "channelModeratorArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelModerator: {
                type: "structure",
                members: {
                  Moderator: {
                    shape: "S9"
                  },
                  ChannelArn: {},
                  CreatedTimestamp: {
                    type: "timestamp"
                  },
                  CreatedBy: {
                    shape: "S9"
                  }
                }
              }
            }
          }
        },
        DisassociateChannelFlow: {
          http: {
            method: "DELETE",
            requestUri: "/channels/{channelArn}/channel-flow/{channelFlowArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "ChannelFlowArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              ChannelFlowArn: {
                location: "uri",
                locationName: "channelFlowArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          }
        },
        GetChannelMembershipPreferences: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/memberships/{memberArn}/preferences",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MemberArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MemberArn: {
                location: "uri",
                locationName: "memberArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              Member: {
                shape: "S9"
              },
              Preferences: {
                shape: "S2w"
              }
            }
          }
        },
        GetChannelMessage: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/messages/{messageId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MessageId",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MessageId: {
                location: "uri",
                locationName: "messageId"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              },
              SubChannelId: {
                location: "querystring",
                locationName: "sub-channel-id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelMessage: {
                type: "structure",
                members: {
                  ChannelArn: {},
                  MessageId: {},
                  Content: {
                    shape: "S33"
                  },
                  Metadata: {
                    shape: "Sm"
                  },
                  Type: {},
                  CreatedTimestamp: {
                    type: "timestamp"
                  },
                  LastEditedTimestamp: {
                    type: "timestamp"
                  },
                  LastUpdatedTimestamp: {
                    type: "timestamp"
                  },
                  Sender: {
                    shape: "S9"
                  },
                  Redacted: {
                    type: "boolean"
                  },
                  Persistence: {},
                  Status: {
                    shape: "S36"
                  },
                  MessageAttributes: {
                    shape: "Sr"
                  },
                  SubChannelId: {},
                  ContentType: {
                    shape: "Sw"
                  },
                  Target: {
                    shape: "S39"
                  }
                }
              }
            }
          }
        },
        GetChannelMessageStatus: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/messages/{messageId}?scope=message-status",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MessageId",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MessageId: {
                location: "uri",
                locationName: "messageId"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              },
              SubChannelId: {
                location: "querystring",
                locationName: "sub-channel-id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                shape: "S36"
              }
            }
          }
        },
        GetMessagingSessionEndpoint: {
          http: {
            method: "GET",
            requestUri: "/endpoints/messaging-session",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              Endpoint: {
                type: "structure",
                members: {
                  Url: {}
                }
              }
            }
          }
        },
        GetMessagingStreamingConfigurations: {
          http: {
            method: "GET",
            requestUri: "/app-instances/{appInstanceArn}/streaming-configurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingConfigurations: {
                shape: "S3j"
              }
            }
          }
        },
        ListChannelBans: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/bans",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "S3o",
                location: "querystring",
                locationName: "next-token"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              NextToken: {
                shape: "S3o"
              },
              ChannelBans: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Member: {
                      shape: "S9"
                    }
                  }
                }
              }
            }
          }
        },
        ListChannelFlows: {
          http: {
            method: "GET",
            requestUri: "/channel-flows",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn"
            ],
            members: {
              AppInstanceArn: {
                location: "querystring",
                locationName: "app-instance-arn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "S3o",
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelFlows: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ChannelFlowArn: {},
                    Name: {
                      shape: "Sz"
                    },
                    Processors: {
                      shape: "S1l"
                    }
                  }
                }
              },
              NextToken: {
                shape: "S3o"
              }
            }
          }
        },
        ListChannelMemberships: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/memberships",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              Type: {
                location: "querystring",
                locationName: "type"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "S3o",
                location: "querystring",
                locationName: "next-token"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              },
              SubChannelId: {
                location: "querystring",
                locationName: "sub-channel-id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              ChannelMemberships: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Member: {
                      shape: "S9"
                    }
                  }
                }
              },
              NextToken: {
                shape: "S3o"
              }
            }
          }
        },
        ListChannelMembershipsForAppInstanceUser: {
          http: {
            method: "GET",
            requestUri: "/channels?scope=app-instance-user-memberships",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChimeBearer"
            ],
            members: {
              AppInstanceUserArn: {
                location: "querystring",
                locationName: "app-instance-user-arn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "S3o",
                location: "querystring",
                locationName: "next-token"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelMemberships: {
                type: "list",
                member: {
                  shape: "S2k"
                }
              },
              NextToken: {
                shape: "S3o"
              }
            }
          }
        },
        ListChannelMessages: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/messages",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              SortOrder: {
                location: "querystring",
                locationName: "sort-order"
              },
              NotBefore: {
                location: "querystring",
                locationName: "not-before",
                type: "timestamp"
              },
              NotAfter: {
                location: "querystring",
                locationName: "not-after",
                type: "timestamp"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "S3o",
                location: "querystring",
                locationName: "next-token"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              },
              SubChannelId: {
                location: "querystring",
                locationName: "sub-channel-id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              NextToken: {
                shape: "S3o"
              },
              ChannelMessages: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MessageId: {},
                    Content: {
                      shape: "S33"
                    },
                    Metadata: {
                      shape: "Sm"
                    },
                    Type: {},
                    CreatedTimestamp: {
                      type: "timestamp"
                    },
                    LastUpdatedTimestamp: {
                      type: "timestamp"
                    },
                    LastEditedTimestamp: {
                      type: "timestamp"
                    },
                    Sender: {
                      shape: "S9"
                    },
                    Redacted: {
                      type: "boolean"
                    },
                    Status: {
                      shape: "S36"
                    },
                    MessageAttributes: {
                      shape: "Sr"
                    },
                    ContentType: {
                      shape: "Sw"
                    },
                    Target: {
                      shape: "S39"
                    }
                  }
                }
              },
              SubChannelId: {}
            }
          }
        },
        ListChannelModerators: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/moderators",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "S3o",
                location: "querystring",
                locationName: "next-token"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              NextToken: {
                shape: "S3o"
              },
              ChannelModerators: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Moderator: {
                      shape: "S9"
                    }
                  }
                }
              }
            }
          }
        },
        ListChannels: {
          http: {
            method: "GET",
            requestUri: "/channels",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn",
              "ChimeBearer"
            ],
            members: {
              AppInstanceArn: {
                location: "querystring",
                locationName: "app-instance-arn"
              },
              Privacy: {
                location: "querystring",
                locationName: "privacy"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "S3o",
                location: "querystring",
                locationName: "next-token"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Channels: {
                shape: "S4e"
              },
              NextToken: {
                shape: "S3o"
              }
            }
          }
        },
        ListChannelsAssociatedWithChannelFlow: {
          http: {
            method: "GET",
            requestUri: "/channels?scope=channel-flow-associations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelFlowArn"
            ],
            members: {
              ChannelFlowArn: {
                location: "querystring",
                locationName: "channel-flow-arn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "S3o",
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Channels: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {
                      shape: "Sz"
                    },
                    ChannelArn: {},
                    Mode: {},
                    Privacy: {},
                    Metadata: {
                      shape: "Sm"
                    }
                  }
                }
              },
              NextToken: {
                shape: "S3o"
              }
            }
          }
        },
        ListChannelsModeratedByAppInstanceUser: {
          http: {
            method: "GET",
            requestUri: "/channels?scope=app-instance-user-moderated-channels",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChimeBearer"
            ],
            members: {
              AppInstanceUserArn: {
                location: "querystring",
                locationName: "app-instance-user-arn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "S3o",
                location: "querystring",
                locationName: "next-token"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Channels: {
                type: "list",
                member: {
                  shape: "S2p"
                }
              },
              NextToken: {
                shape: "S3o"
              }
            }
          }
        },
        ListSubChannels: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/subchannels",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "S3o",
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              SubChannels: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SubChannelId: {},
                    MembershipCount: {
                      type: "integer"
                    }
                  }
                }
              },
              NextToken: {
                shape: "S3o"
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {
                location: "querystring",
                locationName: "arn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S13"
              }
            }
          }
        },
        PutChannelExpirationSettings: {
          http: {
            method: "PUT",
            requestUri: "/channels/{channelArn}/expiration-settings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              },
              ExpirationSettings: {
                shape: "S1e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              ExpirationSettings: {
                shape: "S1e"
              }
            }
          }
        },
        PutChannelMembershipPreferences: {
          http: {
            method: "PUT",
            requestUri: "/channels/{channelArn}/memberships/{memberArn}/preferences",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MemberArn",
              "ChimeBearer",
              "Preferences"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MemberArn: {
                location: "uri",
                locationName: "memberArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              },
              Preferences: {
                shape: "S2w"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              Member: {
                shape: "S9"
              },
              Preferences: {
                shape: "S2w"
              }
            }
          }
        },
        PutMessagingStreamingConfigurations: {
          http: {
            method: "PUT",
            requestUri: "/app-instances/{appInstanceArn}/streaming-configurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn",
              "StreamingConfigurations"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              },
              StreamingConfigurations: {
                shape: "S3j"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingConfigurations: {
                shape: "S3j"
              }
            }
          }
        },
        RedactChannelMessage: {
          http: {
            requestUri: "/channels/{channelArn}/messages/{messageId}?operation=redact",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MessageId",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MessageId: {
                location: "uri",
                locationName: "messageId"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              },
              SubChannelId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              MessageId: {},
              SubChannelId: {}
            }
          }
        },
        SearchChannels: {
          http: {
            requestUri: "/channels?operation=search",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Fields"
            ],
            members: {
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              },
              Fields: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key",
                    "Values",
                    "Operator"
                  ],
                  members: {
                    Key: {},
                    Values: {
                      type: "list",
                      member: {}
                    },
                    Operator: {}
                  }
                }
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "S3o",
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Channels: {
                shape: "S4e"
              },
              NextToken: {
                shape: "S3o"
              }
            }
          }
        },
        SendChannelMessage: {
          http: {
            requestUri: "/channels/{channelArn}/messages",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "Content",
              "Type",
              "Persistence",
              "ClientRequestToken",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              Content: {
                shape: "Sl"
              },
              Type: {},
              Persistence: {},
              Metadata: {
                shape: "Sm"
              },
              ClientRequestToken: {
                shape: "S12",
                idempotencyToken: true
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              },
              PushNotification: {
                shape: "Sn"
              },
              MessageAttributes: {
                shape: "Sr"
              },
              SubChannelId: {},
              ContentType: {
                shape: "Sw"
              },
              Target: {
                shape: "S39"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              MessageId: {},
              Status: {
                shape: "S36"
              },
              SubChannelId: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags?operation=tag-resource",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S13"
              }
            }
          }
        },
        UntagResource: {
          http: {
            requestUri: "/tags?operation=untag-resource",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {
                  shape: "S15"
                }
              }
            }
          }
        },
        UpdateChannel: {
          http: {
            method: "PUT",
            requestUri: "/channels/{channelArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              Name: {
                shape: "Sz"
              },
              Mode: {},
              Metadata: {
                shape: "Sm"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {}
            }
          }
        },
        UpdateChannelFlow: {
          http: {
            method: "PUT",
            requestUri: "/channel-flows/{channelFlowArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelFlowArn",
              "Processors",
              "Name"
            ],
            members: {
              ChannelFlowArn: {
                location: "uri",
                locationName: "channelFlowArn"
              },
              Processors: {
                shape: "S1l"
              },
              Name: {
                shape: "Sz"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelFlowArn: {}
            }
          }
        },
        UpdateChannelMessage: {
          http: {
            method: "PUT",
            requestUri: "/channels/{channelArn}/messages/{messageId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MessageId",
              "Content",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MessageId: {
                location: "uri",
                locationName: "messageId"
              },
              Content: {
                shape: "Sl"
              },
              Metadata: {
                shape: "Sm"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              },
              SubChannelId: {},
              ContentType: {
                shape: "Sw"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              MessageId: {},
              Status: {
                shape: "S36"
              },
              SubChannelId: {}
            }
          }
        },
        UpdateChannelReadMarker: {
          http: {
            method: "PUT",
            requestUri: "/channels/{channelArn}/readMarker",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {}
            }
          }
        }
      },
      shapes: {
        S9: {
          type: "structure",
          members: {
            Arn: {},
            Name: {
              type: "string",
              sensitive: true
            }
          }
        },
        Sl: {
          type: "string",
          sensitive: true
        },
        Sm: {
          type: "string",
          sensitive: true
        },
        Sn: {
          type: "structure",
          members: {
            Title: {
              type: "string",
              sensitive: true
            },
            Body: {
              type: "string",
              sensitive: true
            },
            Type: {}
          }
        },
        Sr: {
          type: "map",
          key: {
            type: "string",
            sensitive: true
          },
          value: {
            type: "structure",
            members: {
              StringValues: {
                type: "list",
                member: {
                  type: "string",
                  sensitive: true
                }
              }
            }
          }
        },
        Sw: {
          type: "string",
          sensitive: true
        },
        Sz: {
          type: "string",
          sensitive: true
        },
        S12: {
          type: "string",
          sensitive: true
        },
        S13: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {
                shape: "S15"
              },
              Value: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        S15: {
          type: "string",
          sensitive: true
        },
        S1a: {
          type: "structure",
          required: [
            "MaximumSubChannels",
            "TargetMembershipsPerSubChannel",
            "MinimumMembershipPercentage"
          ],
          members: {
            MaximumSubChannels: {
              type: "integer"
            },
            TargetMembershipsPerSubChannel: {
              type: "integer"
            },
            MinimumMembershipPercentage: {
              type: "integer"
            }
          }
        },
        S1e: {
          type: "structure",
          required: [
            "ExpirationDays",
            "ExpirationCriterion"
          ],
          members: {
            ExpirationDays: {
              type: "integer"
            },
            ExpirationCriterion: {}
          }
        },
        S1l: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Configuration",
              "ExecutionOrder",
              "FallbackAction"
            ],
            members: {
              Name: {
                shape: "Sz"
              },
              Configuration: {
                type: "structure",
                required: [
                  "Lambda"
                ],
                members: {
                  Lambda: {
                    type: "structure",
                    required: [
                      "ResourceArn",
                      "InvocationType"
                    ],
                    members: {
                      ResourceArn: {},
                      InvocationType: {}
                    }
                  }
                }
              },
              ExecutionOrder: {
                type: "integer"
              },
              FallbackAction: {}
            }
          }
        },
        S2k: {
          type: "structure",
          members: {
            ChannelSummary: {
              shape: "S2l"
            },
            AppInstanceUserMembershipSummary: {
              type: "structure",
              members: {
                Type: {},
                ReadMarkerTimestamp: {
                  type: "timestamp"
                },
                SubChannelId: {}
              }
            }
          }
        },
        S2l: {
          type: "structure",
          members: {
            Name: {
              shape: "Sz"
            },
            ChannelArn: {},
            Mode: {},
            Privacy: {},
            Metadata: {
              shape: "Sm"
            },
            LastMessageTimestamp: {
              type: "timestamp"
            }
          }
        },
        S2p: {
          type: "structure",
          members: {
            ChannelSummary: {
              shape: "S2l"
            }
          }
        },
        S2w: {
          type: "structure",
          members: {
            PushNotifications: {
              type: "structure",
              required: [
                "AllowNotifications"
              ],
              members: {
                AllowNotifications: {},
                FilterRule: {
                  type: "string",
                  sensitive: true
                }
              }
            }
          }
        },
        S33: {
          type: "string",
          sensitive: true
        },
        S36: {
          type: "structure",
          members: {
            Value: {},
            Detail: {}
          }
        },
        S39: {
          type: "list",
          member: {
            type: "structure",
            members: {
              MemberArn: {}
            }
          }
        },
        S3j: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "DataType",
              "ResourceArn"
            ],
            members: {
              DataType: {},
              ResourceArn: {}
            }
          }
        },
        S3o: {
          type: "string",
          sensitive: true
        },
        S4e: {
          type: "list",
          member: {
            shape: "S2l"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/chime-sdk-messaging-2021-05-15.paginators.json
var require_chime_sdk_messaging_2021_05_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/chime-sdk-messaging-2021-05-15.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListChannelBans: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListChannelFlows: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListChannelMemberships: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListChannelMembershipsForAppInstanceUser: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListChannelMessages: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListChannelModerators: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListChannels: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListChannelsAssociatedWithChannelFlow: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListChannelsModeratedByAppInstanceUser: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListSubChannels: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        SearchChannels: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/chimesdkmessaging.js
var require_chimesdkmessaging = __commonJS({
  "node_modules/aws-sdk/clients/chimesdkmessaging.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["chimesdkmessaging"] = {};
    AWS2.ChimeSDKMessaging = Service.defineService("chimesdkmessaging", ["2021-05-15"]);
    Object.defineProperty(apiLoader.services["chimesdkmessaging"], "2021-05-15", {
      get: function get() {
        var model = require_chime_sdk_messaging_2021_05_15_min();
        model.paginators = require_chime_sdk_messaging_2021_05_15_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ChimeSDKMessaging;
  }
});

// node_modules/aws-sdk/apis/snow-device-management-2021-08-04.min.json
var require_snow_device_management_2021_08_04_min = __commonJS({
  "node_modules/aws-sdk/apis/snow-device-management-2021-08-04.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-08-04",
        endpointPrefix: "snow-device-management",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Snow Device Management",
        serviceId: "Snow Device Management",
        signatureVersion: "v4",
        signingName: "snow-device-management",
        uid: "snow-device-management-2021-08-04"
      },
      operations: {
        CancelTask: {
          http: {
            requestUri: "/task/{taskId}/cancel",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "taskId"
            ],
            members: {
              taskId: {
                location: "uri",
                locationName: "taskId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskId: {}
            }
          }
        },
        CreateTask: {
          http: {
            requestUri: "/task",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "command",
              "targets"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              command: {
                type: "structure",
                members: {
                  reboot: {
                    type: "structure",
                    members: {}
                  },
                  unlock: {
                    type: "structure",
                    members: {}
                  }
                },
                union: true
              },
              description: {},
              tags: {
                shape: "Sb"
              },
              targets: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskArn: {},
              taskId: {}
            }
          }
        },
        DescribeDevice: {
          http: {
            requestUri: "/managed-device/{managedDeviceId}/describe",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "managedDeviceId"
            ],
            members: {
              managedDeviceId: {
                location: "uri",
                locationName: "managedDeviceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              associatedWithJob: {},
              deviceCapacities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    available: {
                      type: "long"
                    },
                    name: {},
                    total: {
                      type: "long"
                    },
                    unit: {},
                    used: {
                      type: "long"
                    }
                  }
                }
              },
              deviceState: {},
              deviceType: {},
              lastReachedOutAt: {
                type: "timestamp"
              },
              lastUpdatedAt: {
                type: "timestamp"
              },
              managedDeviceArn: {},
              managedDeviceId: {},
              physicalNetworkInterfaces: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    defaultGateway: {},
                    ipAddress: {},
                    ipAddressAssignment: {},
                    macAddress: {},
                    netmask: {},
                    physicalConnectorType: {},
                    physicalNetworkInterfaceId: {}
                  }
                }
              },
              software: {
                type: "structure",
                members: {
                  installState: {},
                  installedVersion: {},
                  installingVersion: {}
                }
              },
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        DescribeDeviceEc2Instances: {
          http: {
            requestUri: "/managed-device/{managedDeviceId}/resources/ec2/describe",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "instanceIds",
              "managedDeviceId"
            ],
            members: {
              instanceIds: {
                type: "list",
                member: {}
              },
              managedDeviceId: {
                location: "uri",
                locationName: "managedDeviceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              instances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    instance: {
                      type: "structure",
                      members: {
                        amiLaunchIndex: {
                          type: "integer"
                        },
                        blockDeviceMappings: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              deviceName: {},
                              ebs: {
                                type: "structure",
                                members: {
                                  attachTime: {
                                    type: "timestamp"
                                  },
                                  deleteOnTermination: {
                                    type: "boolean"
                                  },
                                  status: {},
                                  volumeId: {}
                                }
                              }
                            }
                          }
                        },
                        cpuOptions: {
                          type: "structure",
                          members: {
                            coreCount: {
                              type: "integer"
                            },
                            threadsPerCore: {
                              type: "integer"
                            }
                          }
                        },
                        createdAt: {
                          type: "timestamp"
                        },
                        imageId: {},
                        instanceId: {},
                        instanceType: {},
                        privateIpAddress: {},
                        publicIpAddress: {},
                        rootDeviceName: {},
                        securityGroups: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              groupId: {},
                              groupName: {}
                            }
                          }
                        },
                        state: {
                          type: "structure",
                          members: {
                            code: {
                              type: "integer"
                            },
                            name: {}
                          }
                        },
                        updatedAt: {
                          type: "timestamp"
                        }
                      }
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeExecution: {
          http: {
            requestUri: "/task/{taskId}/execution/{managedDeviceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "managedDeviceId",
              "taskId"
            ],
            members: {
              managedDeviceId: {
                location: "uri",
                locationName: "managedDeviceId"
              },
              taskId: {
                location: "uri",
                locationName: "taskId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              executionId: {},
              lastUpdatedAt: {
                type: "timestamp"
              },
              managedDeviceId: {},
              startedAt: {
                type: "timestamp"
              },
              state: {},
              taskId: {}
            }
          }
        },
        DescribeTask: {
          http: {
            requestUri: "/task/{taskId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "taskId"
            ],
            members: {
              taskId: {
                location: "uri",
                locationName: "taskId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              completedAt: {
                type: "timestamp"
              },
              createdAt: {
                type: "timestamp"
              },
              description: {},
              lastUpdatedAt: {
                type: "timestamp"
              },
              state: {},
              tags: {
                shape: "Sb"
              },
              targets: {
                shape: "Sc"
              },
              taskArn: {},
              taskId: {}
            }
          }
        },
        ListDeviceResources: {
          http: {
            method: "GET",
            requestUri: "/managed-device/{managedDeviceId}/resources",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "managedDeviceId"
            ],
            members: {
              managedDeviceId: {
                location: "uri",
                locationName: "managedDeviceId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              type: {
                location: "querystring",
                locationName: "type"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              resources: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "resourceType"
                  ],
                  members: {
                    arn: {},
                    id: {},
                    resourceType: {}
                  }
                }
              }
            }
          }
        },
        ListDevices: {
          http: {
            method: "GET",
            requestUri: "/managed-devices",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              jobId: {
                location: "querystring",
                locationName: "jobId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              devices: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    associatedWithJob: {},
                    managedDeviceArn: {},
                    managedDeviceId: {},
                    tags: {
                      shape: "Sb"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListExecutions: {
          http: {
            method: "GET",
            requestUri: "/executions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "taskId"
            ],
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              state: {
                location: "querystring",
                locationName: "state"
              },
              taskId: {
                location: "querystring",
                locationName: "taskId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              executions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    executionId: {},
                    managedDeviceId: {},
                    state: {},
                    taskId: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        ListTasks: {
          http: {
            method: "GET",
            requestUri: "/tasks",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              state: {
                location: "querystring",
                locationName: "state"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              tasks: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "taskId"
                  ],
                  members: {
                    state: {},
                    tags: {
                      shape: "Sb"
                    },
                    taskArn: {},
                    taskId: {}
                  }
                }
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          idempotent: true
        }
      },
      shapes: {
        Sb: {
          type: "map",
          key: {},
          value: {}
        },
        Sc: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/snow-device-management-2021-08-04.paginators.json
var require_snow_device_management_2021_08_04_paginators = __commonJS({
  "node_modules/aws-sdk/apis/snow-device-management-2021-08-04.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListDeviceResources: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "resources"
        },
        ListDevices: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "devices"
        },
        ListExecutions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "executions"
        },
        ListTasks: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "tasks"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/snowdevicemanagement.js
var require_snowdevicemanagement = __commonJS({
  "node_modules/aws-sdk/clients/snowdevicemanagement.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["snowdevicemanagement"] = {};
    AWS2.SnowDeviceManagement = Service.defineService("snowdevicemanagement", ["2021-08-04"]);
    Object.defineProperty(apiLoader.services["snowdevicemanagement"], "2021-08-04", {
      get: function get() {
        var model = require_snow_device_management_2021_08_04_min();
        model.paginators = require_snow_device_management_2021_08_04_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.SnowDeviceManagement;
  }
});

// node_modules/aws-sdk/apis/memorydb-2021-01-01.min.json
var require_memorydb_2021_01_01_min = __commonJS({
  "node_modules/aws-sdk/apis/memorydb-2021-01-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-01-01",
        endpointPrefix: "memory-db",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Amazon MemoryDB",
        serviceFullName: "Amazon MemoryDB",
        serviceId: "MemoryDB",
        signatureVersion: "v4",
        signingName: "memorydb",
        targetPrefix: "AmazonMemoryDB",
        uid: "memorydb-2021-01-01"
      },
      operations: {
        BatchUpdateCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterNames"
            ],
            members: {
              ClusterNames: {
                shape: "S2"
              },
              ServiceUpdate: {
                type: "structure",
                members: {
                  ServiceUpdateNameToApply: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProcessedClusters: {
                shape: "S6"
              },
              UnprocessedClusters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ClusterName: {},
                    ErrorType: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        CopySnapshot: {
          input: {
            type: "structure",
            required: [
              "SourceSnapshotName",
              "TargetSnapshotName"
            ],
            members: {
              SourceSnapshotName: {},
              TargetSnapshotName: {},
              TargetBucket: {},
              KmsKeyId: {},
              Tags: {
                shape: "Sz"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Snapshot: {
                shape: "S12"
              }
            }
          }
        },
        CreateACL: {
          input: {
            type: "structure",
            required: [
              "ACLName"
            ],
            members: {
              ACLName: {},
              UserNames: {
                shape: "S18"
              },
              Tags: {
                shape: "Sz"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ACL: {
                shape: "S1b"
              }
            }
          }
        },
        CreateCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterName",
              "NodeType",
              "ACLName"
            ],
            members: {
              ClusterName: {},
              NodeType: {},
              ParameterGroupName: {},
              Description: {},
              NumShards: {
                type: "integer"
              },
              NumReplicasPerShard: {
                type: "integer"
              },
              SubnetGroupName: {},
              SecurityGroupIds: {
                shape: "S1g"
              },
              MaintenanceWindow: {},
              Port: {
                type: "integer"
              },
              SnsTopicArn: {},
              TLSEnabled: {
                type: "boolean"
              },
              KmsKeyId: {},
              SnapshotArns: {
                type: "list",
                member: {}
              },
              SnapshotName: {},
              SnapshotRetentionLimit: {
                type: "integer"
              },
              Tags: {
                shape: "Sz"
              },
              SnapshotWindow: {},
              ACLName: {},
              EngineVersion: {},
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              DataTiering: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                shape: "S7"
              }
            }
          }
        },
        CreateParameterGroup: {
          input: {
            type: "structure",
            required: [
              "ParameterGroupName",
              "Family"
            ],
            members: {
              ParameterGroupName: {},
              Family: {},
              Description: {},
              Tags: {
                shape: "Sz"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ParameterGroup: {
                shape: "S1l"
              }
            }
          }
        },
        CreateSnapshot: {
          input: {
            type: "structure",
            required: [
              "ClusterName",
              "SnapshotName"
            ],
            members: {
              ClusterName: {},
              SnapshotName: {},
              KmsKeyId: {},
              Tags: {
                shape: "Sz"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Snapshot: {
                shape: "S12"
              }
            }
          }
        },
        CreateSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "SubnetGroupName",
              "SubnetIds"
            ],
            members: {
              SubnetGroupName: {},
              Description: {},
              SubnetIds: {
                shape: "S1p"
              },
              Tags: {
                shape: "Sz"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SubnetGroup: {
                shape: "S1r"
              }
            }
          }
        },
        CreateUser: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "AuthenticationMode",
              "AccessString"
            ],
            members: {
              UserName: {},
              AuthenticationMode: {
                shape: "S1w"
              },
              AccessString: {},
              Tags: {
                shape: "Sz"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                shape: "S21"
              }
            }
          }
        },
        DeleteACL: {
          input: {
            type: "structure",
            required: [
              "ACLName"
            ],
            members: {
              ACLName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ACL: {
                shape: "S1b"
              }
            }
          }
        },
        DeleteCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterName"
            ],
            members: {
              ClusterName: {},
              FinalSnapshotName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                shape: "S7"
              }
            }
          }
        },
        DeleteParameterGroup: {
          input: {
            type: "structure",
            required: [
              "ParameterGroupName"
            ],
            members: {
              ParameterGroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ParameterGroup: {
                shape: "S1l"
              }
            }
          }
        },
        DeleteSnapshot: {
          input: {
            type: "structure",
            required: [
              "SnapshotName"
            ],
            members: {
              SnapshotName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Snapshot: {
                shape: "S12"
              }
            }
          }
        },
        DeleteSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "SubnetGroupName"
            ],
            members: {
              SubnetGroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SubnetGroup: {
                shape: "S1r"
              }
            }
          }
        },
        DeleteUser: {
          input: {
            type: "structure",
            required: [
              "UserName"
            ],
            members: {
              UserName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                shape: "S21"
              }
            }
          }
        },
        DescribeACLs: {
          input: {
            type: "structure",
            members: {
              ACLName: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ACLs: {
                type: "list",
                member: {
                  shape: "S1b"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeClusters: {
          input: {
            type: "structure",
            members: {
              ClusterName: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              ShowShardDetails: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Clusters: {
                shape: "S6"
              }
            }
          }
        },
        DescribeEngineVersions: {
          input: {
            type: "structure",
            members: {
              EngineVersion: {},
              ParameterGroupFamily: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DefaultOnly: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              EngineVersions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EngineVersion: {},
                    EnginePatchVersion: {},
                    ParameterGroupFamily: {}
                  }
                }
              }
            }
          }
        },
        DescribeEvents: {
          input: {
            type: "structure",
            members: {
              SourceName: {},
              SourceType: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Duration: {
                type: "integer"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Events: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SourceName: {},
                    SourceType: {},
                    Message: {},
                    Date: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeParameterGroups: {
          input: {
            type: "structure",
            members: {
              ParameterGroupName: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ParameterGroups: {
                type: "list",
                member: {
                  shape: "S1l"
                }
              }
            }
          }
        },
        DescribeParameters: {
          input: {
            type: "structure",
            required: [
              "ParameterGroupName"
            ],
            members: {
              ParameterGroupName: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Parameters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Value: {},
                    Description: {},
                    DataType: {},
                    AllowedValues: {},
                    MinimumEngineVersion: {}
                  }
                }
              }
            }
          }
        },
        DescribeReservedNodes: {
          input: {
            type: "structure",
            members: {
              ReservationId: {},
              ReservedNodesOfferingId: {},
              NodeType: {},
              Duration: {},
              OfferingType: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ReservedNodes: {
                type: "list",
                member: {
                  shape: "S36"
                }
              }
            }
          }
        },
        DescribeReservedNodesOfferings: {
          input: {
            type: "structure",
            members: {
              ReservedNodesOfferingId: {},
              NodeType: {},
              Duration: {},
              OfferingType: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ReservedNodesOfferings: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ReservedNodesOfferingId: {},
                    NodeType: {},
                    Duration: {
                      type: "integer"
                    },
                    FixedPrice: {
                      type: "double"
                    },
                    OfferingType: {},
                    RecurringCharges: {
                      shape: "S37"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeServiceUpdates: {
          input: {
            type: "structure",
            members: {
              ServiceUpdateName: {},
              ClusterNames: {
                shape: "S2"
              },
              Status: {
                type: "list",
                member: {}
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ServiceUpdates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ClusterName: {},
                    ServiceUpdateName: {},
                    ReleaseDate: {
                      type: "timestamp"
                    },
                    Description: {},
                    Status: {},
                    Type: {},
                    NodesUpdated: {},
                    AutoUpdateStartDate: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeSnapshots: {
          input: {
            type: "structure",
            members: {
              ClusterName: {},
              SnapshotName: {},
              Source: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ShowDetail: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Snapshots: {
                type: "list",
                member: {
                  shape: "S12"
                }
              }
            }
          }
        },
        DescribeSubnetGroups: {
          input: {
            type: "structure",
            members: {
              SubnetGroupName: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              SubnetGroups: {
                type: "list",
                member: {
                  shape: "S1r"
                }
              }
            }
          }
        },
        DescribeUsers: {
          input: {
            type: "structure",
            members: {
              UserName: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Values"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Users: {
                type: "list",
                member: {
                  shape: "S21"
                }
              },
              NextToken: {}
            }
          }
        },
        FailoverShard: {
          input: {
            type: "structure",
            required: [
              "ClusterName",
              "ShardName"
            ],
            members: {
              ClusterName: {},
              ShardName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                shape: "S7"
              }
            }
          }
        },
        ListAllowedNodeTypeUpdates: {
          input: {
            type: "structure",
            required: [
              "ClusterName"
            ],
            members: {
              ClusterName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ScaleUpNodeTypes: {
                shape: "S41"
              },
              ScaleDownNodeTypes: {
                shape: "S41"
              }
            }
          }
        },
        ListTags: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TagList: {
                shape: "Sz"
              }
            }
          }
        },
        PurchaseReservedNodesOffering: {
          input: {
            type: "structure",
            required: [
              "ReservedNodesOfferingId"
            ],
            members: {
              ReservedNodesOfferingId: {},
              ReservationId: {},
              NodeCount: {
                type: "integer"
              },
              Tags: {
                shape: "Sz"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReservedNode: {
                shape: "S36"
              }
            }
          }
        },
        ResetParameterGroup: {
          input: {
            type: "structure",
            required: [
              "ParameterGroupName"
            ],
            members: {
              ParameterGroupName: {},
              AllParameters: {
                type: "boolean"
              },
              ParameterNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ParameterGroup: {
                shape: "S1l"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "Sz"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TagList: {
                shape: "Sz"
              }
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TagList: {
                shape: "Sz"
              }
            }
          }
        },
        UpdateACL: {
          input: {
            type: "structure",
            required: [
              "ACLName"
            ],
            members: {
              ACLName: {},
              UserNamesToAdd: {
                shape: "S18"
              },
              UserNamesToRemove: {
                shape: "S18"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ACL: {
                shape: "S1b"
              }
            }
          }
        },
        UpdateCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterName"
            ],
            members: {
              ClusterName: {},
              Description: {},
              SecurityGroupIds: {
                shape: "S1g"
              },
              MaintenanceWindow: {},
              SnsTopicArn: {},
              SnsTopicStatus: {},
              ParameterGroupName: {},
              SnapshotWindow: {},
              SnapshotRetentionLimit: {
                type: "integer"
              },
              NodeType: {},
              EngineVersion: {},
              ReplicaConfiguration: {
                type: "structure",
                members: {
                  ReplicaCount: {
                    type: "integer"
                  }
                }
              },
              ShardConfiguration: {
                type: "structure",
                members: {
                  ShardCount: {
                    type: "integer"
                  }
                }
              },
              ACLName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                shape: "S7"
              }
            }
          }
        },
        UpdateParameterGroup: {
          input: {
            type: "structure",
            required: [
              "ParameterGroupName",
              "ParameterNameValues"
            ],
            members: {
              ParameterGroupName: {},
              ParameterNameValues: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ParameterName: {},
                    ParameterValue: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ParameterGroup: {
                shape: "S1l"
              }
            }
          }
        },
        UpdateSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "SubnetGroupName"
            ],
            members: {
              SubnetGroupName: {},
              Description: {},
              SubnetIds: {
                shape: "S1p"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SubnetGroup: {
                shape: "S1r"
              }
            }
          }
        },
        UpdateUser: {
          input: {
            type: "structure",
            required: [
              "UserName"
            ],
            members: {
              UserName: {},
              AuthenticationMode: {
                shape: "S1w"
              },
              AccessString: {}
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                shape: "S21"
              }
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "list",
          member: {}
        },
        S6: {
          type: "list",
          member: {
            shape: "S7"
          }
        },
        S7: {
          type: "structure",
          members: {
            Name: {},
            Description: {},
            Status: {},
            PendingUpdates: {
              type: "structure",
              members: {
                Resharding: {
                  type: "structure",
                  members: {
                    SlotMigration: {
                      type: "structure",
                      members: {
                        ProgressPercentage: {
                          type: "double"
                        }
                      }
                    }
                  }
                },
                ACLs: {
                  type: "structure",
                  members: {
                    ACLToApply: {}
                  }
                },
                ServiceUpdates: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      ServiceUpdateName: {},
                      Status: {}
                    }
                  }
                }
              }
            },
            NumberOfShards: {
              type: "integer"
            },
            Shards: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Name: {},
                  Status: {},
                  Slots: {},
                  Nodes: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {},
                        Status: {},
                        AvailabilityZone: {},
                        CreateTime: {
                          type: "timestamp"
                        },
                        Endpoint: {
                          shape: "Sn"
                        }
                      }
                    }
                  },
                  NumberOfNodes: {
                    type: "integer"
                  }
                }
              }
            },
            AvailabilityMode: {},
            ClusterEndpoint: {
              shape: "Sn"
            },
            NodeType: {},
            EngineVersion: {},
            EnginePatchVersion: {},
            ParameterGroupName: {},
            ParameterGroupStatus: {},
            SecurityGroups: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  SecurityGroupId: {},
                  Status: {}
                }
              }
            },
            SubnetGroupName: {},
            TLSEnabled: {
              type: "boolean"
            },
            KmsKeyId: {},
            ARN: {},
            SnsTopicArn: {},
            SnsTopicStatus: {},
            SnapshotRetentionLimit: {
              type: "integer"
            },
            MaintenanceWindow: {},
            SnapshotWindow: {},
            ACLName: {},
            AutoMinorVersionUpgrade: {
              type: "boolean"
            },
            DataTiering: {}
          }
        },
        Sn: {
          type: "structure",
          members: {
            Address: {},
            Port: {
              type: "integer"
            }
          }
        },
        Sz: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S12: {
          type: "structure",
          members: {
            Name: {},
            Status: {},
            Source: {},
            KmsKeyId: {},
            ARN: {},
            ClusterConfiguration: {
              type: "structure",
              members: {
                Name: {},
                Description: {},
                NodeType: {},
                EngineVersion: {},
                MaintenanceWindow: {},
                TopicArn: {},
                Port: {
                  type: "integer"
                },
                ParameterGroupName: {},
                SubnetGroupName: {},
                VpcId: {},
                SnapshotRetentionLimit: {
                  type: "integer"
                },
                SnapshotWindow: {},
                NumShards: {
                  type: "integer"
                },
                Shards: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      Name: {},
                      Configuration: {
                        type: "structure",
                        members: {
                          Slots: {},
                          ReplicaCount: {
                            type: "integer"
                          }
                        }
                      },
                      Size: {},
                      SnapshotCreationTime: {
                        type: "timestamp"
                      }
                    }
                  }
                }
              }
            },
            DataTiering: {}
          }
        },
        S18: {
          type: "list",
          member: {}
        },
        S1b: {
          type: "structure",
          members: {
            Name: {},
            Status: {},
            UserNames: {
              shape: "S1c"
            },
            MinimumEngineVersion: {},
            PendingChanges: {
              type: "structure",
              members: {
                UserNamesToRemove: {
                  shape: "S1c"
                },
                UserNamesToAdd: {
                  shape: "S1c"
                }
              }
            },
            Clusters: {
              type: "list",
              member: {}
            },
            ARN: {}
          }
        },
        S1c: {
          type: "list",
          member: {}
        },
        S1g: {
          type: "list",
          member: {}
        },
        S1l: {
          type: "structure",
          members: {
            Name: {},
            Family: {},
            Description: {},
            ARN: {}
          }
        },
        S1p: {
          type: "list",
          member: {}
        },
        S1r: {
          type: "structure",
          members: {
            Name: {},
            Description: {},
            VpcId: {},
            Subnets: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Identifier: {},
                  AvailabilityZone: {
                    type: "structure",
                    members: {
                      Name: {}
                    }
                  }
                }
              }
            },
            ARN: {}
          }
        },
        S1w: {
          type: "structure",
          members: {
            Type: {},
            Passwords: {
              type: "list",
              member: {}
            }
          }
        },
        S21: {
          type: "structure",
          members: {
            Name: {},
            Status: {},
            AccessString: {},
            ACLNames: {
              type: "list",
              member: {}
            },
            MinimumEngineVersion: {},
            Authentication: {
              type: "structure",
              members: {
                Type: {},
                PasswordCount: {
                  type: "integer"
                }
              }
            },
            ARN: {}
          }
        },
        S36: {
          type: "structure",
          members: {
            ReservationId: {},
            ReservedNodesOfferingId: {},
            NodeType: {},
            StartTime: {
              type: "timestamp"
            },
            Duration: {
              type: "integer"
            },
            FixedPrice: {
              type: "double"
            },
            NodeCount: {
              type: "integer"
            },
            OfferingType: {},
            State: {},
            RecurringCharges: {
              shape: "S37"
            },
            ARN: {}
          }
        },
        S37: {
          type: "list",
          member: {
            type: "structure",
            members: {
              RecurringChargeAmount: {
                type: "double"
              },
              RecurringChargeFrequency: {}
            }
          }
        },
        S41: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/memorydb-2021-01-01.paginators.json
var require_memorydb_2021_01_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/memorydb-2021-01-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeACLs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ACLs"
        },
        DescribeClusters: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Clusters"
        },
        DescribeEngineVersions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "EngineVersions"
        },
        DescribeEvents: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Events"
        },
        DescribeParameterGroups: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ParameterGroups"
        },
        DescribeParameters: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Parameters"
        },
        DescribeReservedNodes: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ReservedNodes"
        },
        DescribeReservedNodesOfferings: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ReservedNodesOfferings"
        },
        DescribeServiceUpdates: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ServiceUpdates"
        },
        DescribeSnapshots: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Snapshots"
        },
        DescribeSubnetGroups: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "SubnetGroups"
        },
        DescribeUsers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Users"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/memorydb.js
var require_memorydb = __commonJS({
  "node_modules/aws-sdk/clients/memorydb.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["memorydb"] = {};
    AWS2.MemoryDB = Service.defineService("memorydb", ["2021-01-01"]);
    Object.defineProperty(apiLoader.services["memorydb"], "2021-01-01", {
      get: function get() {
        var model = require_memorydb_2021_01_01_min();
        model.paginators = require_memorydb_2021_01_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.MemoryDB;
  }
});

// node_modules/aws-sdk/apis/opensearch-2021-01-01.min.json
var require_opensearch_2021_01_01_min = __commonJS({
  "node_modules/aws-sdk/apis/opensearch-2021-01-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-01-01",
        endpointPrefix: "es",
        protocol: "rest-json",
        serviceFullName: "Amazon OpenSearch Service",
        serviceId: "OpenSearch",
        signatureVersion: "v4",
        uid: "opensearch-2021-01-01"
      },
      operations: {
        AcceptInboundConnection: {
          http: {
            method: "PUT",
            requestUri: "/2021-01-01/opensearch/cc/inboundConnection/{ConnectionId}/accept"
          },
          input: {
            type: "structure",
            required: [
              "ConnectionId"
            ],
            members: {
              ConnectionId: {
                location: "uri",
                locationName: "ConnectionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Connection: {
                shape: "S4"
              }
            }
          }
        },
        AddDataSource: {
          http: {
            requestUri: "/2021-01-01/opensearch/domain/{DomainName}/dataSource"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Name",
              "DataSourceType"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              Name: {},
              DataSourceType: {
                shape: "Sg"
              },
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Message: {}
            }
          }
        },
        AddTags: {
          http: {
            requestUri: "/2021-01-01/tags"
          },
          input: {
            type: "structure",
            required: [
              "ARN",
              "TagList"
            ],
            members: {
              ARN: {},
              TagList: {
                shape: "So"
              }
            }
          }
        },
        AssociatePackage: {
          http: {
            requestUri: "/2021-01-01/packages/associate/{PackageID}/{DomainName}"
          },
          input: {
            type: "structure",
            required: [
              "PackageID",
              "DomainName"
            ],
            members: {
              PackageID: {
                location: "uri",
                locationName: "PackageID"
              },
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainPackageDetails: {
                shape: "Sv"
              }
            }
          }
        },
        AuthorizeVpcEndpointAccess: {
          http: {
            requestUri: "/2021-01-01/opensearch/domain/{DomainName}/authorizeVpcEndpointAccess"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Account"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              Account: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "AuthorizedPrincipal"
            ],
            members: {
              AuthorizedPrincipal: {
                shape: "S18"
              }
            }
          }
        },
        CancelServiceSoftwareUpdate: {
          http: {
            requestUri: "/2021-01-01/opensearch/serviceSoftwareUpdate/cancel"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceSoftwareOptions: {
                shape: "S1c"
              }
            }
          }
        },
        CreateDomain: {
          http: {
            requestUri: "/2021-01-01/opensearch/domain"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              EngineVersion: {},
              ClusterConfig: {
                shape: "S1i"
              },
              EBSOptions: {
                shape: "S1o"
              },
              AccessPolicies: {},
              IPAddressType: {},
              SnapshotOptions: {
                shape: "S1s"
              },
              VPCOptions: {
                shape: "S1t"
              },
              CognitoOptions: {
                shape: "S1v"
              },
              EncryptionAtRestOptions: {
                shape: "S1y"
              },
              NodeToNodeEncryptionOptions: {
                shape: "S20"
              },
              AdvancedOptions: {
                shape: "S21"
              },
              LogPublishingOptions: {
                shape: "S22"
              },
              DomainEndpointOptions: {
                shape: "S26"
              },
              AdvancedSecurityOptions: {
                shape: "S29"
              },
              TagList: {
                shape: "So"
              },
              AutoTuneOptions: {
                type: "structure",
                members: {
                  DesiredState: {},
                  MaintenanceSchedules: {
                    shape: "S2k"
                  },
                  UseOffPeakWindow: {
                    type: "boolean"
                  }
                }
              },
              OffPeakWindowOptions: {
                shape: "S2q"
              },
              SoftwareUpdateOptions: {
                shape: "S2v"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainStatus: {
                shape: "S2x"
              }
            }
          }
        },
        CreateOutboundConnection: {
          http: {
            requestUri: "/2021-01-01/opensearch/cc/outboundConnection"
          },
          input: {
            type: "structure",
            required: [
              "LocalDomainInfo",
              "RemoteDomainInfo",
              "ConnectionAlias"
            ],
            members: {
              LocalDomainInfo: {
                shape: "S5"
              },
              RemoteDomainInfo: {
                shape: "S5"
              },
              ConnectionAlias: {},
              ConnectionMode: {},
              ConnectionProperties: {
                shape: "S3c"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocalDomainInfo: {
                shape: "S5"
              },
              RemoteDomainInfo: {
                shape: "S5"
              },
              ConnectionAlias: {},
              ConnectionStatus: {
                shape: "S3h"
              },
              ConnectionId: {},
              ConnectionMode: {},
              ConnectionProperties: {
                shape: "S3c"
              }
            }
          }
        },
        CreatePackage: {
          http: {
            requestUri: "/2021-01-01/packages"
          },
          input: {
            type: "structure",
            required: [
              "PackageName",
              "PackageType",
              "PackageSource"
            ],
            members: {
              PackageName: {},
              PackageType: {},
              PackageDescription: {},
              PackageSource: {
                shape: "S3l"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PackageDetails: {
                shape: "S3p"
              }
            }
          }
        },
        CreateVpcEndpoint: {
          http: {
            requestUri: "/2021-01-01/opensearch/vpcEndpoints"
          },
          input: {
            type: "structure",
            required: [
              "DomainArn",
              "VpcOptions"
            ],
            members: {
              DomainArn: {},
              VpcOptions: {
                shape: "S1t"
              },
              ClientToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "VpcEndpoint"
            ],
            members: {
              VpcEndpoint: {
                shape: "S43"
              }
            }
          }
        },
        DeleteDataSource: {
          http: {
            method: "DELETE",
            requestUri: "/2021-01-01/opensearch/domain/{DomainName}/dataSource/{DataSourceName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Name"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              Name: {
                location: "uri",
                locationName: "DataSourceName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Message: {}
            }
          }
        },
        DeleteDomain: {
          http: {
            method: "DELETE",
            requestUri: "/2021-01-01/opensearch/domain/{DomainName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainStatus: {
                shape: "S2x"
              }
            }
          }
        },
        DeleteInboundConnection: {
          http: {
            method: "DELETE",
            requestUri: "/2021-01-01/opensearch/cc/inboundConnection/{ConnectionId}"
          },
          input: {
            type: "structure",
            required: [
              "ConnectionId"
            ],
            members: {
              ConnectionId: {
                location: "uri",
                locationName: "ConnectionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Connection: {
                shape: "S4"
              }
            }
          }
        },
        DeleteOutboundConnection: {
          http: {
            method: "DELETE",
            requestUri: "/2021-01-01/opensearch/cc/outboundConnection/{ConnectionId}"
          },
          input: {
            type: "structure",
            required: [
              "ConnectionId"
            ],
            members: {
              ConnectionId: {
                location: "uri",
                locationName: "ConnectionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Connection: {
                shape: "S4e"
              }
            }
          }
        },
        DeletePackage: {
          http: {
            method: "DELETE",
            requestUri: "/2021-01-01/packages/{PackageID}"
          },
          input: {
            type: "structure",
            required: [
              "PackageID"
            ],
            members: {
              PackageID: {
                location: "uri",
                locationName: "PackageID"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PackageDetails: {
                shape: "S3p"
              }
            }
          }
        },
        DeleteVpcEndpoint: {
          http: {
            method: "DELETE",
            requestUri: "/2021-01-01/opensearch/vpcEndpoints/{VpcEndpointId}"
          },
          input: {
            type: "structure",
            required: [
              "VpcEndpointId"
            ],
            members: {
              VpcEndpointId: {
                location: "uri",
                locationName: "VpcEndpointId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "VpcEndpointSummary"
            ],
            members: {
              VpcEndpointSummary: {
                shape: "S4j"
              }
            }
          }
        },
        DescribeDomain: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/domain/{DomainName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainStatus"
            ],
            members: {
              DomainStatus: {
                shape: "S2x"
              }
            }
          }
        },
        DescribeDomainAutoTunes: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/domain/{DomainName}/autoTunes"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AutoTunes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AutoTuneType: {},
                    AutoTuneDetails: {
                      type: "structure",
                      members: {
                        ScheduledAutoTuneDetails: {
                          type: "structure",
                          members: {
                            Date: {
                              type: "timestamp"
                            },
                            ActionType: {},
                            Action: {},
                            Severity: {}
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeDomainChangeProgress: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/domain/{DomainName}/progress"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              ChangeId: {
                location: "querystring",
                locationName: "changeid"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeProgressStatus: {
                type: "structure",
                members: {
                  ChangeId: {},
                  StartTime: {
                    type: "timestamp"
                  },
                  Status: {},
                  PendingProperties: {
                    shape: "S1u"
                  },
                  CompletedProperties: {
                    shape: "S1u"
                  },
                  TotalNumberOfStages: {
                    type: "integer"
                  },
                  ChangeProgressStages: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {},
                        Status: {},
                        Description: {},
                        LastUpdated: {
                          type: "timestamp"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeDomainConfig: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/domain/{DomainName}/config"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainConfig"
            ],
            members: {
              DomainConfig: {
                shape: "S5c"
              }
            }
          }
        },
        DescribeDomainHealth: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/domain/{DomainName}/health"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainState: {},
              AvailabilityZoneCount: {},
              ActiveAvailabilityZoneCount: {},
              StandByAvailabilityZoneCount: {},
              DataNodeCount: {},
              DedicatedMaster: {
                type: "boolean"
              },
              MasterEligibleNodeCount: {},
              WarmNodeCount: {},
              MasterNode: {},
              ClusterHealth: {},
              TotalShards: {},
              TotalUnAssignedShards: {},
              EnvironmentInformation: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AvailabilityZoneInformation: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          AvailabilityZoneName: {},
                          ZoneStatus: {},
                          ConfiguredDataNodeCount: {},
                          AvailableDataNodeCount: {},
                          TotalShards: {},
                          TotalUnAssignedShards: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeDomainNodes: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/domain/{DomainName}/nodes"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainNodesStatusList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    NodeId: {},
                    NodeType: {},
                    AvailabilityZone: {},
                    InstanceType: {},
                    NodeStatus: {},
                    StorageType: {},
                    StorageVolumeType: {},
                    StorageSize: {}
                  }
                }
              }
            }
          }
        },
        DescribeDomains: {
          http: {
            requestUri: "/2021-01-01/opensearch/domain-info"
          },
          input: {
            type: "structure",
            required: [
              "DomainNames"
            ],
            members: {
              DomainNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainStatusList"
            ],
            members: {
              DomainStatusList: {
                type: "list",
                member: {
                  shape: "S2x"
                }
              }
            }
          }
        },
        DescribeDryRunProgress: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/domain/{DomainName}/dryRun"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              DryRunId: {
                location: "querystring",
                locationName: "dryRunId"
              },
              LoadDryRunConfig: {
                location: "querystring",
                locationName: "loadDryRunConfig",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DryRunProgressStatus: {
                shape: "S6t"
              },
              DryRunConfig: {
                shape: "S2x"
              },
              DryRunResults: {
                shape: "S6w"
              }
            }
          }
        },
        DescribeInboundConnections: {
          http: {
            requestUri: "/2021-01-01/opensearch/cc/inboundConnection/search"
          },
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S6z"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Connections: {
                type: "list",
                member: {
                  shape: "S4"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeInstanceTypeLimits: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/instanceTypeLimits/{EngineVersion}/{InstanceType}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceType",
              "EngineVersion"
            ],
            members: {
              DomainName: {
                location: "querystring",
                locationName: "domainName"
              },
              InstanceType: {
                location: "uri",
                locationName: "InstanceType"
              },
              EngineVersion: {
                location: "uri",
                locationName: "EngineVersion"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LimitsByRole: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    StorageTypes: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          StorageTypeName: {},
                          StorageSubTypeName: {},
                          StorageTypeLimits: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                LimitName: {},
                                LimitValues: {
                                  shape: "S7g"
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    InstanceLimits: {
                      type: "structure",
                      members: {
                        InstanceCountLimits: {
                          type: "structure",
                          members: {
                            MinimumInstanceCount: {
                              type: "integer"
                            },
                            MaximumInstanceCount: {
                              type: "integer"
                            }
                          }
                        }
                      }
                    },
                    AdditionalLimits: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          LimitName: {},
                          LimitValues: {
                            shape: "S7g"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeOutboundConnections: {
          http: {
            requestUri: "/2021-01-01/opensearch/cc/outboundConnection/search"
          },
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S6z"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Connections: {
                type: "list",
                member: {
                  shape: "S4e"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribePackages: {
          http: {
            requestUri: "/2021-01-01/packages/describe"
          },
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Value: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PackageDetailsList: {
                type: "list",
                member: {
                  shape: "S3p"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeReservedInstanceOfferings: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/reservedInstanceOfferings"
          },
          input: {
            type: "structure",
            members: {
              ReservedInstanceOfferingId: {
                location: "querystring",
                locationName: "offeringId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ReservedInstanceOfferings: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ReservedInstanceOfferingId: {},
                    InstanceType: {},
                    Duration: {
                      type: "integer"
                    },
                    FixedPrice: {
                      type: "double"
                    },
                    UsagePrice: {
                      type: "double"
                    },
                    CurrencyCode: {},
                    PaymentOption: {},
                    RecurringCharges: {
                      shape: "S86"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeReservedInstances: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/reservedInstances"
          },
          input: {
            type: "structure",
            members: {
              ReservedInstanceId: {
                location: "querystring",
                locationName: "reservationId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ReservedInstances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ReservationName: {},
                    ReservedInstanceId: {},
                    BillingSubscriptionId: {
                      type: "long"
                    },
                    ReservedInstanceOfferingId: {},
                    InstanceType: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    Duration: {
                      type: "integer"
                    },
                    FixedPrice: {
                      type: "double"
                    },
                    UsagePrice: {
                      type: "double"
                    },
                    CurrencyCode: {},
                    InstanceCount: {
                      type: "integer"
                    },
                    State: {},
                    PaymentOption: {},
                    RecurringCharges: {
                      shape: "S86"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeVpcEndpoints: {
          http: {
            requestUri: "/2021-01-01/opensearch/vpcEndpoints/describe"
          },
          input: {
            type: "structure",
            required: [
              "VpcEndpointIds"
            ],
            members: {
              VpcEndpointIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "VpcEndpoints",
              "VpcEndpointErrors"
            ],
            members: {
              VpcEndpoints: {
                type: "list",
                member: {
                  shape: "S43"
                }
              },
              VpcEndpointErrors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    VpcEndpointId: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        DissociatePackage: {
          http: {
            requestUri: "/2021-01-01/packages/dissociate/{PackageID}/{DomainName}"
          },
          input: {
            type: "structure",
            required: [
              "PackageID",
              "DomainName"
            ],
            members: {
              PackageID: {
                location: "uri",
                locationName: "PackageID"
              },
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainPackageDetails: {
                shape: "Sv"
              }
            }
          }
        },
        GetCompatibleVersions: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/compatibleVersions"
          },
          input: {
            type: "structure",
            members: {
              DomainName: {
                location: "querystring",
                locationName: "domainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CompatibleVersions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SourceVersion: {},
                    TargetVersions: {
                      shape: "S8r"
                    }
                  }
                }
              }
            }
          }
        },
        GetDataSource: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/domain/{DomainName}/dataSource/{DataSourceName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Name"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              Name: {
                location: "uri",
                locationName: "DataSourceName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataSourceType: {
                shape: "Sg"
              },
              Name: {},
              Description: {}
            }
          }
        },
        GetDomainMaintenanceStatus: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/domain/{DomainName}/domainMaintenance"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "MaintenanceId"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              MaintenanceId: {
                location: "querystring",
                locationName: "maintenanceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {},
              StatusMessage: {},
              NodeId: {},
              Action: {},
              CreatedAt: {
                type: "timestamp"
              },
              UpdatedAt: {
                type: "timestamp"
              }
            }
          }
        },
        GetPackageVersionHistory: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/packages/{PackageID}/history"
          },
          input: {
            type: "structure",
            required: [
              "PackageID"
            ],
            members: {
              PackageID: {
                location: "uri",
                locationName: "PackageID"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PackageID: {},
              PackageVersionHistoryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PackageVersion: {},
                    CommitMessage: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    PluginProperties: {
                      shape: "S3t"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetUpgradeHistory: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/upgradeDomain/{DomainName}/history"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UpgradeHistories: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    UpgradeName: {},
                    StartTimestamp: {
                      type: "timestamp"
                    },
                    UpgradeStatus: {},
                    StepsList: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          UpgradeStep: {},
                          UpgradeStepStatus: {},
                          Issues: {
                            type: "list",
                            member: {}
                          },
                          ProgressPercent: {
                            type: "double"
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetUpgradeStatus: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/upgradeDomain/{DomainName}/status"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UpgradeStep: {},
              StepStatus: {},
              UpgradeName: {}
            }
          }
        },
        ListDataSources: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/domain/{DomainName}/dataSource"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataSources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DataSourceType: {
                      shape: "Sg"
                    },
                    Name: {},
                    Description: {}
                  }
                }
              }
            }
          }
        },
        ListDomainMaintenances: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/domain/{DomainName}/domainMaintenances"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              Action: {
                location: "querystring",
                locationName: "action"
              },
              Status: {
                location: "querystring",
                locationName: "status"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainMaintenances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MaintenanceId: {},
                    DomainName: {},
                    Action: {},
                    NodeId: {},
                    Status: {},
                    StatusMessage: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    UpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDomainNames: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/domain"
          },
          input: {
            type: "structure",
            members: {
              EngineType: {
                location: "querystring",
                locationName: "engineType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainNames: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DomainName: {},
                    EngineType: {}
                  }
                }
              }
            }
          }
        },
        ListDomainsForPackage: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/packages/{PackageID}/domains"
          },
          input: {
            type: "structure",
            required: [
              "PackageID"
            ],
            members: {
              PackageID: {
                location: "uri",
                locationName: "PackageID"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainPackageDetailsList: {
                shape: "S9y"
              },
              NextToken: {}
            }
          }
        },
        ListInstanceTypeDetails: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/instanceTypeDetails/{EngineVersion}"
          },
          input: {
            type: "structure",
            required: [
              "EngineVersion"
            ],
            members: {
              EngineVersion: {
                location: "uri",
                locationName: "EngineVersion"
              },
              DomainName: {
                location: "querystring",
                locationName: "domainName"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              RetrieveAZs: {
                location: "querystring",
                locationName: "retrieveAZs",
                type: "boolean"
              },
              InstanceType: {
                location: "querystring",
                locationName: "instanceType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceTypeDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InstanceType: {},
                    EncryptionEnabled: {
                      type: "boolean"
                    },
                    CognitoEnabled: {
                      type: "boolean"
                    },
                    AppLogsEnabled: {
                      type: "boolean"
                    },
                    AdvancedSecurityEnabled: {
                      type: "boolean"
                    },
                    WarmEnabled: {
                      type: "boolean"
                    },
                    InstanceRole: {
                      type: "list",
                      member: {}
                    },
                    AvailabilityZones: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPackagesForDomain: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/domain/{DomainName}/packages"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainPackageDetailsList: {
                shape: "S9y"
              },
              NextToken: {}
            }
          }
        },
        ListScheduledActions: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/domain/{DomainName}/scheduledActions"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ScheduledActions: {
                type: "list",
                member: {
                  shape: "Sab"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTags: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/tags/"
          },
          input: {
            type: "structure",
            required: [
              "ARN"
            ],
            members: {
              ARN: {
                location: "querystring",
                locationName: "arn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TagList: {
                shape: "So"
              }
            }
          }
        },
        ListVersions: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/versions"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Versions: {
                shape: "S8r"
              },
              NextToken: {}
            }
          }
        },
        ListVpcEndpointAccess: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/domain/{DomainName}/listVpcEndpointAccess"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "AuthorizedPrincipalList",
              "NextToken"
            ],
            members: {
              AuthorizedPrincipalList: {
                type: "list",
                member: {
                  shape: "S18"
                }
              },
              NextToken: {}
            }
          }
        },
        ListVpcEndpoints: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/vpcEndpoints"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "VpcEndpointSummaryList",
              "NextToken"
            ],
            members: {
              VpcEndpointSummaryList: {
                shape: "Sap"
              },
              NextToken: {}
            }
          }
        },
        ListVpcEndpointsForDomain: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/domain/{DomainName}/vpcEndpoints"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "VpcEndpointSummaryList",
              "NextToken"
            ],
            members: {
              VpcEndpointSummaryList: {
                shape: "Sap"
              },
              NextToken: {}
            }
          }
        },
        PurchaseReservedInstanceOffering: {
          http: {
            requestUri: "/2021-01-01/opensearch/purchaseReservedInstanceOffering"
          },
          input: {
            type: "structure",
            required: [
              "ReservedInstanceOfferingId",
              "ReservationName"
            ],
            members: {
              ReservedInstanceOfferingId: {},
              ReservationName: {},
              InstanceCount: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReservedInstanceId: {},
              ReservationName: {}
            }
          }
        },
        RejectInboundConnection: {
          http: {
            method: "PUT",
            requestUri: "/2021-01-01/opensearch/cc/inboundConnection/{ConnectionId}/reject"
          },
          input: {
            type: "structure",
            required: [
              "ConnectionId"
            ],
            members: {
              ConnectionId: {
                location: "uri",
                locationName: "ConnectionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Connection: {
                shape: "S4"
              }
            }
          }
        },
        RemoveTags: {
          http: {
            requestUri: "/2021-01-01/tags-removal"
          },
          input: {
            type: "structure",
            required: [
              "ARN",
              "TagKeys"
            ],
            members: {
              ARN: {},
              TagKeys: {
                shape: "S1u"
              }
            }
          }
        },
        RevokeVpcEndpointAccess: {
          http: {
            requestUri: "/2021-01-01/opensearch/domain/{DomainName}/revokeVpcEndpointAccess"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Account"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              Account: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartDomainMaintenance: {
          http: {
            requestUri: "/2021-01-01/opensearch/domain/{DomainName}/domainMaintenance"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Action"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              Action: {},
              NodeId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MaintenanceId: {}
            }
          }
        },
        StartServiceSoftwareUpdate: {
          http: {
            requestUri: "/2021-01-01/opensearch/serviceSoftwareUpdate/start"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              ScheduleAt: {},
              DesiredStartTime: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceSoftwareOptions: {
                shape: "S1c"
              }
            }
          }
        },
        UpdateDataSource: {
          http: {
            method: "PUT",
            requestUri: "/2021-01-01/opensearch/domain/{DomainName}/dataSource/{DataSourceName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Name",
              "DataSourceType"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              Name: {
                location: "uri",
                locationName: "DataSourceName"
              },
              DataSourceType: {
                shape: "Sg"
              },
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Message: {}
            }
          }
        },
        UpdateDomainConfig: {
          http: {
            requestUri: "/2021-01-01/opensearch/domain/{DomainName}/config"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              ClusterConfig: {
                shape: "S1i"
              },
              EBSOptions: {
                shape: "S1o"
              },
              SnapshotOptions: {
                shape: "S1s"
              },
              VPCOptions: {
                shape: "S1t"
              },
              CognitoOptions: {
                shape: "S1v"
              },
              AdvancedOptions: {
                shape: "S21"
              },
              AccessPolicies: {},
              IPAddressType: {},
              LogPublishingOptions: {
                shape: "S22"
              },
              EncryptionAtRestOptions: {
                shape: "S1y"
              },
              DomainEndpointOptions: {
                shape: "S26"
              },
              NodeToNodeEncryptionOptions: {
                shape: "S20"
              },
              AdvancedSecurityOptions: {
                shape: "S29"
              },
              AutoTuneOptions: {
                shape: "S5v"
              },
              DryRun: {
                type: "boolean"
              },
              DryRunMode: {},
              OffPeakWindowOptions: {
                shape: "S2q"
              },
              SoftwareUpdateOptions: {
                shape: "S2v"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainConfig"
            ],
            members: {
              DomainConfig: {
                shape: "S5c"
              },
              DryRunResults: {
                shape: "S6w"
              },
              DryRunProgressStatus: {
                shape: "S6t"
              }
            }
          }
        },
        UpdatePackage: {
          http: {
            requestUri: "/2021-01-01/packages/update"
          },
          input: {
            type: "structure",
            required: [
              "PackageID",
              "PackageSource"
            ],
            members: {
              PackageID: {},
              PackageSource: {
                shape: "S3l"
              },
              PackageDescription: {},
              CommitMessage: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PackageDetails: {
                shape: "S3p"
              }
            }
          }
        },
        UpdateScheduledAction: {
          http: {
            method: "PUT",
            requestUri: "/2021-01-01/opensearch/domain/{DomainName}/scheduledAction/update"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "ActionID",
              "ActionType",
              "ScheduleAt"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              ActionID: {},
              ActionType: {},
              ScheduleAt: {},
              DesiredStartTime: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ScheduledAction: {
                shape: "Sab"
              }
            }
          }
        },
        UpdateVpcEndpoint: {
          http: {
            requestUri: "/2021-01-01/opensearch/vpcEndpoints/update"
          },
          input: {
            type: "structure",
            required: [
              "VpcEndpointId",
              "VpcOptions"
            ],
            members: {
              VpcEndpointId: {},
              VpcOptions: {
                shape: "S1t"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "VpcEndpoint"
            ],
            members: {
              VpcEndpoint: {
                shape: "S43"
              }
            }
          }
        },
        UpgradeDomain: {
          http: {
            requestUri: "/2021-01-01/opensearch/upgradeDomain"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "TargetVersion"
            ],
            members: {
              DomainName: {},
              TargetVersion: {},
              PerformCheckOnly: {
                type: "boolean"
              },
              AdvancedOptions: {
                shape: "S21"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UpgradeId: {},
              DomainName: {},
              TargetVersion: {},
              PerformCheckOnly: {
                type: "boolean"
              },
              AdvancedOptions: {
                shape: "S21"
              },
              ChangeProgressDetails: {
                shape: "S37"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            LocalDomainInfo: {
              shape: "S5"
            },
            RemoteDomainInfo: {
              shape: "S5"
            },
            ConnectionId: {},
            ConnectionStatus: {
              type: "structure",
              members: {
                StatusCode: {},
                Message: {}
              }
            },
            ConnectionMode: {}
          }
        },
        S5: {
          type: "structure",
          members: {
            AWSDomainInformation: {
              type: "structure",
              required: [
                "DomainName"
              ],
              members: {
                OwnerId: {},
                DomainName: {},
                Region: {}
              }
            }
          }
        },
        Sg: {
          type: "structure",
          members: {
            S3GlueDataCatalog: {
              type: "structure",
              members: {
                RoleArn: {}
              }
            }
          },
          union: true
        },
        So: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sv: {
          type: "structure",
          members: {
            PackageID: {},
            PackageName: {},
            PackageType: {},
            LastUpdated: {
              type: "timestamp"
            },
            DomainName: {},
            DomainPackageStatus: {},
            PackageVersion: {},
            ReferencePath: {},
            ErrorDetails: {
              shape: "S12"
            }
          }
        },
        S12: {
          type: "structure",
          members: {
            ErrorType: {},
            ErrorMessage: {}
          }
        },
        S18: {
          type: "structure",
          members: {
            PrincipalType: {},
            Principal: {}
          }
        },
        S1c: {
          type: "structure",
          members: {
            CurrentVersion: {},
            NewVersion: {},
            UpdateAvailable: {
              type: "boolean"
            },
            Cancellable: {
              type: "boolean"
            },
            UpdateStatus: {},
            Description: {},
            AutomatedUpdateDate: {
              type: "timestamp"
            },
            OptionalDeployment: {
              type: "boolean"
            }
          }
        },
        S1i: {
          type: "structure",
          members: {
            InstanceType: {},
            InstanceCount: {
              type: "integer"
            },
            DedicatedMasterEnabled: {
              type: "boolean"
            },
            ZoneAwarenessEnabled: {
              type: "boolean"
            },
            ZoneAwarenessConfig: {
              type: "structure",
              members: {
                AvailabilityZoneCount: {
                  type: "integer"
                }
              }
            },
            DedicatedMasterType: {},
            DedicatedMasterCount: {
              type: "integer"
            },
            WarmEnabled: {
              type: "boolean"
            },
            WarmType: {},
            WarmCount: {
              type: "integer"
            },
            ColdStorageOptions: {
              type: "structure",
              required: [
                "Enabled"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                }
              }
            },
            MultiAZWithStandbyEnabled: {
              type: "boolean"
            }
          }
        },
        S1o: {
          type: "structure",
          members: {
            EBSEnabled: {
              type: "boolean"
            },
            VolumeType: {},
            VolumeSize: {
              type: "integer"
            },
            Iops: {
              type: "integer"
            },
            Throughput: {
              type: "integer"
            }
          }
        },
        S1s: {
          type: "structure",
          members: {
            AutomatedSnapshotStartHour: {
              type: "integer"
            }
          }
        },
        S1t: {
          type: "structure",
          members: {
            SubnetIds: {
              shape: "S1u"
            },
            SecurityGroupIds: {
              shape: "S1u"
            }
          }
        },
        S1u: {
          type: "list",
          member: {}
        },
        S1v: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            UserPoolId: {},
            IdentityPoolId: {},
            RoleArn: {}
          }
        },
        S1y: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            KmsKeyId: {}
          }
        },
        S20: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            }
          }
        },
        S21: {
          type: "map",
          key: {},
          value: {}
        },
        S22: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              CloudWatchLogsLogGroupArn: {},
              Enabled: {
                type: "boolean"
              }
            }
          }
        },
        S26: {
          type: "structure",
          members: {
            EnforceHTTPS: {
              type: "boolean"
            },
            TLSSecurityPolicy: {},
            CustomEndpointEnabled: {
              type: "boolean"
            },
            CustomEndpoint: {},
            CustomEndpointCertificateArn: {}
          }
        },
        S29: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            InternalUserDatabaseEnabled: {
              type: "boolean"
            },
            MasterUserOptions: {
              type: "structure",
              members: {
                MasterUserARN: {},
                MasterUserName: {
                  shape: "S2b"
                },
                MasterUserPassword: {
                  type: "string",
                  sensitive: true
                }
              }
            },
            SAMLOptions: {
              type: "structure",
              members: {
                Enabled: {
                  type: "boolean"
                },
                Idp: {
                  shape: "S2e"
                },
                MasterUserName: {
                  shape: "S2b"
                },
                MasterBackendRole: {},
                SubjectKey: {},
                RolesKey: {},
                SessionTimeoutMinutes: {
                  type: "integer"
                }
              }
            },
            AnonymousAuthEnabled: {
              type: "boolean"
            }
          }
        },
        S2b: {
          type: "string",
          sensitive: true
        },
        S2e: {
          type: "structure",
          required: [
            "MetadataContent",
            "EntityId"
          ],
          members: {
            MetadataContent: {},
            EntityId: {}
          }
        },
        S2k: {
          type: "list",
          member: {
            type: "structure",
            members: {
              StartAt: {
                type: "timestamp"
              },
              Duration: {
                type: "structure",
                members: {
                  Value: {
                    type: "long"
                  },
                  Unit: {}
                }
              },
              CronExpressionForRecurrence: {}
            }
          }
        },
        S2q: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            OffPeakWindow: {
              type: "structure",
              members: {
                WindowStartTime: {
                  type: "structure",
                  required: [
                    "Hours",
                    "Minutes"
                  ],
                  members: {
                    Hours: {
                      type: "long"
                    },
                    Minutes: {
                      type: "long"
                    }
                  }
                }
              }
            }
          }
        },
        S2v: {
          type: "structure",
          members: {
            AutoSoftwareUpdateEnabled: {
              type: "boolean"
            }
          }
        },
        S2x: {
          type: "structure",
          required: [
            "DomainId",
            "DomainName",
            "ARN",
            "ClusterConfig"
          ],
          members: {
            DomainId: {},
            DomainName: {},
            ARN: {},
            Created: {
              type: "boolean"
            },
            Deleted: {
              type: "boolean"
            },
            Endpoint: {},
            EndpointV2: {},
            Endpoints: {
              type: "map",
              key: {},
              value: {}
            },
            Processing: {
              type: "boolean"
            },
            UpgradeProcessing: {
              type: "boolean"
            },
            EngineVersion: {},
            ClusterConfig: {
              shape: "S1i"
            },
            EBSOptions: {
              shape: "S1o"
            },
            AccessPolicies: {},
            IPAddressType: {},
            SnapshotOptions: {
              shape: "S1s"
            },
            VPCOptions: {
              shape: "S31"
            },
            CognitoOptions: {
              shape: "S1v"
            },
            EncryptionAtRestOptions: {
              shape: "S1y"
            },
            NodeToNodeEncryptionOptions: {
              shape: "S20"
            },
            AdvancedOptions: {
              shape: "S21"
            },
            LogPublishingOptions: {
              shape: "S22"
            },
            ServiceSoftwareOptions: {
              shape: "S1c"
            },
            DomainEndpointOptions: {
              shape: "S26"
            },
            AdvancedSecurityOptions: {
              shape: "S32"
            },
            AutoTuneOptions: {
              type: "structure",
              members: {
                State: {},
                ErrorMessage: {},
                UseOffPeakWindow: {
                  type: "boolean"
                }
              }
            },
            ChangeProgressDetails: {
              shape: "S37"
            },
            OffPeakWindowOptions: {
              shape: "S2q"
            },
            SoftwareUpdateOptions: {
              shape: "S2v"
            }
          }
        },
        S31: {
          type: "structure",
          members: {
            VPCId: {},
            SubnetIds: {
              shape: "S1u"
            },
            AvailabilityZones: {
              shape: "S1u"
            },
            SecurityGroupIds: {
              shape: "S1u"
            }
          }
        },
        S32: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            InternalUserDatabaseEnabled: {
              type: "boolean"
            },
            SAMLOptions: {
              type: "structure",
              members: {
                Enabled: {
                  type: "boolean"
                },
                Idp: {
                  shape: "S2e"
                },
                SubjectKey: {},
                RolesKey: {},
                SessionTimeoutMinutes: {
                  type: "integer"
                }
              }
            },
            AnonymousAuthDisableDate: {
              type: "timestamp"
            },
            AnonymousAuthEnabled: {
              type: "boolean"
            }
          }
        },
        S37: {
          type: "structure",
          members: {
            ChangeId: {},
            Message: {}
          }
        },
        S3c: {
          type: "structure",
          members: {
            Endpoint: {},
            CrossClusterSearch: {
              type: "structure",
              members: {
                SkipUnavailable: {}
              }
            }
          }
        },
        S3h: {
          type: "structure",
          members: {
            StatusCode: {},
            Message: {}
          }
        },
        S3l: {
          type: "structure",
          members: {
            S3BucketName: {},
            S3Key: {}
          }
        },
        S3p: {
          type: "structure",
          members: {
            PackageID: {},
            PackageName: {},
            PackageType: {},
            PackageDescription: {},
            PackageStatus: {},
            CreatedAt: {
              type: "timestamp"
            },
            LastUpdatedAt: {
              type: "timestamp"
            },
            AvailablePackageVersion: {},
            ErrorDetails: {
              shape: "S12"
            },
            EngineVersion: {},
            AvailablePluginProperties: {
              shape: "S3t"
            }
          }
        },
        S3t: {
          type: "structure",
          members: {
            Name: {},
            Description: {},
            Version: {},
            ClassName: {},
            UncompressedSizeInBytes: {
              type: "long"
            }
          }
        },
        S43: {
          type: "structure",
          members: {
            VpcEndpointId: {},
            VpcEndpointOwner: {},
            DomainArn: {},
            VpcOptions: {
              shape: "S31"
            },
            Status: {},
            Endpoint: {}
          }
        },
        S4e: {
          type: "structure",
          members: {
            LocalDomainInfo: {
              shape: "S5"
            },
            RemoteDomainInfo: {
              shape: "S5"
            },
            ConnectionId: {},
            ConnectionAlias: {},
            ConnectionStatus: {
              shape: "S3h"
            },
            ConnectionMode: {},
            ConnectionProperties: {
              shape: "S3c"
            }
          }
        },
        S4j: {
          type: "structure",
          members: {
            VpcEndpointId: {},
            VpcEndpointOwner: {},
            DomainArn: {},
            Status: {}
          }
        },
        S5c: {
          type: "structure",
          members: {
            EngineVersion: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {},
                Status: {
                  shape: "S5e"
                }
              }
            },
            ClusterConfig: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S1i"
                },
                Status: {
                  shape: "S5e"
                }
              }
            },
            EBSOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S1o"
                },
                Status: {
                  shape: "S5e"
                }
              }
            },
            AccessPolicies: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {},
                Status: {
                  shape: "S5e"
                }
              }
            },
            IPAddressType: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {},
                Status: {
                  shape: "S5e"
                }
              }
            },
            SnapshotOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S1s"
                },
                Status: {
                  shape: "S5e"
                }
              }
            },
            VPCOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S31"
                },
                Status: {
                  shape: "S5e"
                }
              }
            },
            CognitoOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S1v"
                },
                Status: {
                  shape: "S5e"
                }
              }
            },
            EncryptionAtRestOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S1y"
                },
                Status: {
                  shape: "S5e"
                }
              }
            },
            NodeToNodeEncryptionOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S20"
                },
                Status: {
                  shape: "S5e"
                }
              }
            },
            AdvancedOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S21"
                },
                Status: {
                  shape: "S5e"
                }
              }
            },
            LogPublishingOptions: {
              type: "structure",
              members: {
                Options: {
                  shape: "S22"
                },
                Status: {
                  shape: "S5e"
                }
              }
            },
            DomainEndpointOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S26"
                },
                Status: {
                  shape: "S5e"
                }
              }
            },
            AdvancedSecurityOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S32"
                },
                Status: {
                  shape: "S5e"
                }
              }
            },
            AutoTuneOptions: {
              type: "structure",
              members: {
                Options: {
                  shape: "S5v"
                },
                Status: {
                  type: "structure",
                  required: [
                    "CreationDate",
                    "UpdateDate",
                    "State"
                  ],
                  members: {
                    CreationDate: {
                      type: "timestamp"
                    },
                    UpdateDate: {
                      type: "timestamp"
                    },
                    UpdateVersion: {
                      type: "integer"
                    },
                    State: {},
                    ErrorMessage: {},
                    PendingDeletion: {
                      type: "boolean"
                    }
                  }
                }
              }
            },
            ChangeProgressDetails: {
              shape: "S37"
            },
            OffPeakWindowOptions: {
              type: "structure",
              members: {
                Options: {
                  shape: "S2q"
                },
                Status: {
                  shape: "S5e"
                }
              }
            },
            SoftwareUpdateOptions: {
              type: "structure",
              members: {
                Options: {
                  shape: "S2v"
                },
                Status: {
                  shape: "S5e"
                }
              }
            }
          }
        },
        S5e: {
          type: "structure",
          required: [
            "CreationDate",
            "UpdateDate",
            "State"
          ],
          members: {
            CreationDate: {
              type: "timestamp"
            },
            UpdateDate: {
              type: "timestamp"
            },
            UpdateVersion: {
              type: "integer"
            },
            State: {},
            PendingDeletion: {
              type: "boolean"
            }
          }
        },
        S5v: {
          type: "structure",
          members: {
            DesiredState: {},
            RollbackOnDisable: {},
            MaintenanceSchedules: {
              shape: "S2k"
            },
            UseOffPeakWindow: {
              type: "boolean"
            }
          }
        },
        S6t: {
          type: "structure",
          required: [
            "DryRunId",
            "DryRunStatus",
            "CreationDate",
            "UpdateDate"
          ],
          members: {
            DryRunId: {},
            DryRunStatus: {},
            CreationDate: {},
            UpdateDate: {},
            ValidationFailures: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Code: {},
                  Message: {}
                }
              }
            }
          }
        },
        S6w: {
          type: "structure",
          members: {
            DeploymentType: {},
            Message: {}
          }
        },
        S6z: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Values: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S7g: {
          type: "list",
          member: {}
        },
        S86: {
          type: "list",
          member: {
            type: "structure",
            members: {
              RecurringChargeAmount: {
                type: "double"
              },
              RecurringChargeFrequency: {}
            }
          }
        },
        S8r: {
          type: "list",
          member: {}
        },
        S9y: {
          type: "list",
          member: {
            shape: "Sv"
          }
        },
        Sab: {
          type: "structure",
          required: [
            "Id",
            "Type",
            "Severity",
            "ScheduledTime"
          ],
          members: {
            Id: {},
            Type: {},
            Severity: {},
            ScheduledTime: {
              type: "long"
            },
            Description: {},
            ScheduledBy: {},
            Status: {},
            Mandatory: {
              type: "boolean"
            },
            Cancellable: {
              type: "boolean"
            }
          }
        },
        Sap: {
          type: "list",
          member: {
            shape: "S4j"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/opensearch-2021-01-01.paginators.json
var require_opensearch_2021_01_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/opensearch-2021-01-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeDomainAutoTunes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeInboundConnections: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeOutboundConnections: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribePackages: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeReservedInstanceOfferings: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeReservedInstances: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        GetPackageVersionHistory: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        GetUpgradeHistory: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDomainMaintenances: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDomainsForPackage: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListInstanceTypeDetails: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListPackagesForDomain: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListScheduledActions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListVersions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/opensearch.js
var require_opensearch = __commonJS({
  "node_modules/aws-sdk/clients/opensearch.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["opensearch"] = {};
    AWS2.OpenSearch = Service.defineService("opensearch", ["2021-01-01"]);
    Object.defineProperty(apiLoader.services["opensearch"], "2021-01-01", {
      get: function get() {
        var model = require_opensearch_2021_01_01_min();
        model.paginators = require_opensearch_2021_01_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.OpenSearch;
  }
});

// node_modules/aws-sdk/apis/kafkaconnect-2021-09-14.min.json
var require_kafkaconnect_2021_09_14_min = __commonJS({
  "node_modules/aws-sdk/apis/kafkaconnect-2021-09-14.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-09-14",
        endpointPrefix: "kafkaconnect",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Kafka Connect",
        serviceFullName: "Managed Streaming for Kafka Connect",
        serviceId: "KafkaConnect",
        signatureVersion: "v4",
        signingName: "kafkaconnect",
        uid: "kafkaconnect-2021-09-14"
      },
      operations: {
        CreateConnector: {
          http: {
            requestUri: "/v1/connectors",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "capacity",
              "connectorConfiguration",
              "connectorName",
              "kafkaCluster",
              "kafkaClusterClientAuthentication",
              "kafkaClusterEncryptionInTransit",
              "kafkaConnectVersion",
              "plugins",
              "serviceExecutionRoleArn"
            ],
            members: {
              capacity: {
                type: "structure",
                members: {
                  autoScaling: {
                    type: "structure",
                    required: [
                      "maxWorkerCount",
                      "mcuCount",
                      "minWorkerCount"
                    ],
                    members: {
                      maxWorkerCount: {
                        type: "integer"
                      },
                      mcuCount: {
                        type: "integer"
                      },
                      minWorkerCount: {
                        type: "integer"
                      },
                      scaleInPolicy: {
                        type: "structure",
                        required: [
                          "cpuUtilizationPercentage"
                        ],
                        members: {
                          cpuUtilizationPercentage: {
                            type: "integer"
                          }
                        }
                      },
                      scaleOutPolicy: {
                        type: "structure",
                        required: [
                          "cpuUtilizationPercentage"
                        ],
                        members: {
                          cpuUtilizationPercentage: {
                            type: "integer"
                          }
                        }
                      }
                    }
                  },
                  provisionedCapacity: {
                    type: "structure",
                    required: [
                      "mcuCount",
                      "workerCount"
                    ],
                    members: {
                      mcuCount: {
                        type: "integer"
                      },
                      workerCount: {
                        type: "integer"
                      }
                    }
                  }
                }
              },
              connectorConfiguration: {
                shape: "Sa"
              },
              connectorDescription: {},
              connectorName: {},
              kafkaCluster: {
                type: "structure",
                required: [
                  "apacheKafkaCluster"
                ],
                members: {
                  apacheKafkaCluster: {
                    type: "structure",
                    required: [
                      "bootstrapServers",
                      "vpc"
                    ],
                    members: {
                      bootstrapServers: {},
                      vpc: {
                        type: "structure",
                        required: [
                          "subnets"
                        ],
                        members: {
                          securityGroups: {
                            shape: "Sh"
                          },
                          subnets: {
                            shape: "Sh"
                          }
                        }
                      }
                    }
                  }
                }
              },
              kafkaClusterClientAuthentication: {
                type: "structure",
                required: [
                  "authenticationType"
                ],
                members: {
                  authenticationType: {}
                }
              },
              kafkaClusterEncryptionInTransit: {
                type: "structure",
                required: [
                  "encryptionType"
                ],
                members: {
                  encryptionType: {}
                }
              },
              kafkaConnectVersion: {},
              logDelivery: {
                type: "structure",
                required: [
                  "workerLogDelivery"
                ],
                members: {
                  workerLogDelivery: {
                    type: "structure",
                    members: {
                      cloudWatchLogs: {
                        type: "structure",
                        required: [
                          "enabled"
                        ],
                        members: {
                          enabled: {
                            type: "boolean"
                          },
                          logGroup: {}
                        }
                      },
                      firehose: {
                        type: "structure",
                        required: [
                          "enabled"
                        ],
                        members: {
                          deliveryStream: {},
                          enabled: {
                            type: "boolean"
                          }
                        }
                      },
                      s3: {
                        type: "structure",
                        required: [
                          "enabled"
                        ],
                        members: {
                          bucket: {},
                          enabled: {
                            type: "boolean"
                          },
                          prefix: {}
                        }
                      }
                    }
                  }
                }
              },
              plugins: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "customPlugin"
                  ],
                  members: {
                    customPlugin: {
                      type: "structure",
                      required: [
                        "customPluginArn",
                        "revision"
                      ],
                      members: {
                        customPluginArn: {},
                        revision: {
                          type: "long"
                        }
                      }
                    }
                  }
                }
              },
              serviceExecutionRoleArn: {},
              workerConfiguration: {
                type: "structure",
                required: [
                  "revision",
                  "workerConfigurationArn"
                ],
                members: {
                  revision: {
                    type: "long"
                  },
                  workerConfigurationArn: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              connectorArn: {},
              connectorName: {},
              connectorState: {}
            }
          }
        },
        CreateCustomPlugin: {
          http: {
            requestUri: "/v1/custom-plugins",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "contentType",
              "location",
              "name"
            ],
            members: {
              contentType: {},
              description: {},
              location: {
                type: "structure",
                required: [
                  "s3Location"
                ],
                members: {
                  s3Location: {
                    type: "structure",
                    required: [
                      "bucketArn",
                      "fileKey"
                    ],
                    members: {
                      bucketArn: {},
                      fileKey: {},
                      objectVersion: {}
                    }
                  }
                }
              },
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              customPluginArn: {},
              customPluginState: {},
              name: {},
              revision: {
                type: "long"
              }
            }
          }
        },
        CreateWorkerConfiguration: {
          http: {
            requestUri: "/v1/worker-configurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "propertiesFileContent"
            ],
            members: {
              description: {},
              name: {},
              propertiesFileContent: {
                shape: "S17"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              creationTime: {
                shape: "S19"
              },
              latestRevision: {
                shape: "S1a"
              },
              name: {},
              workerConfigurationArn: {}
            }
          }
        },
        DeleteConnector: {
          http: {
            method: "DELETE",
            requestUri: "/v1/connectors/{connectorArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "connectorArn"
            ],
            members: {
              connectorArn: {
                location: "uri",
                locationName: "connectorArn"
              },
              currentVersion: {
                location: "querystring",
                locationName: "currentVersion"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              connectorArn: {},
              connectorState: {}
            }
          },
          idempotent: true
        },
        DeleteCustomPlugin: {
          http: {
            method: "DELETE",
            requestUri: "/v1/custom-plugins/{customPluginArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "customPluginArn"
            ],
            members: {
              customPluginArn: {
                location: "uri",
                locationName: "customPluginArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              customPluginArn: {},
              customPluginState: {}
            }
          },
          idempotent: true
        },
        DescribeConnector: {
          http: {
            method: "GET",
            requestUri: "/v1/connectors/{connectorArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "connectorArn"
            ],
            members: {
              connectorArn: {
                location: "uri",
                locationName: "connectorArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              capacity: {
                shape: "S1h"
              },
              connectorArn: {},
              connectorConfiguration: {
                shape: "Sa"
              },
              connectorDescription: {},
              connectorName: {},
              connectorState: {},
              creationTime: {
                shape: "S19"
              },
              currentVersion: {},
              kafkaCluster: {
                shape: "S1n"
              },
              kafkaClusterClientAuthentication: {
                shape: "S1q"
              },
              kafkaClusterEncryptionInTransit: {
                shape: "S1r"
              },
              kafkaConnectVersion: {},
              logDelivery: {
                shape: "S1s"
              },
              plugins: {
                shape: "S1x"
              },
              serviceExecutionRoleArn: {},
              stateDescription: {
                shape: "S20"
              },
              workerConfiguration: {
                shape: "S21"
              }
            }
          }
        },
        DescribeCustomPlugin: {
          http: {
            method: "GET",
            requestUri: "/v1/custom-plugins/{customPluginArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "customPluginArn"
            ],
            members: {
              customPluginArn: {
                location: "uri",
                locationName: "customPluginArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              creationTime: {
                shape: "S19"
              },
              customPluginArn: {},
              customPluginState: {},
              description: {},
              latestRevision: {
                shape: "S24"
              },
              name: {},
              stateDescription: {
                shape: "S20"
              }
            }
          }
        },
        DescribeWorkerConfiguration: {
          http: {
            method: "GET",
            requestUri: "/v1/worker-configurations/{workerConfigurationArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workerConfigurationArn"
            ],
            members: {
              workerConfigurationArn: {
                location: "uri",
                locationName: "workerConfigurationArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              creationTime: {
                shape: "S19"
              },
              description: {},
              latestRevision: {
                type: "structure",
                members: {
                  creationTime: {
                    shape: "S19"
                  },
                  description: {},
                  propertiesFileContent: {
                    shape: "S17"
                  },
                  revision: {
                    type: "long"
                  }
                }
              },
              name: {},
              workerConfigurationArn: {}
            }
          }
        },
        ListConnectors: {
          http: {
            method: "GET",
            requestUri: "/v1/connectors",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              connectorNamePrefix: {
                location: "querystring",
                locationName: "connectorNamePrefix"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              connectors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    capacity: {
                      shape: "S1h"
                    },
                    connectorArn: {},
                    connectorDescription: {},
                    connectorName: {},
                    connectorState: {},
                    creationTime: {
                      shape: "S19"
                    },
                    currentVersion: {},
                    kafkaCluster: {
                      shape: "S1n"
                    },
                    kafkaClusterClientAuthentication: {
                      shape: "S1q"
                    },
                    kafkaClusterEncryptionInTransit: {
                      shape: "S1r"
                    },
                    kafkaConnectVersion: {},
                    logDelivery: {
                      shape: "S1s"
                    },
                    plugins: {
                      shape: "S1x"
                    },
                    serviceExecutionRoleArn: {},
                    workerConfiguration: {
                      shape: "S21"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListCustomPlugins: {
          http: {
            method: "GET",
            requestUri: "/v1/custom-plugins",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              customPlugins: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    creationTime: {
                      shape: "S19"
                    },
                    customPluginArn: {},
                    customPluginState: {},
                    description: {},
                    latestRevision: {
                      shape: "S24"
                    },
                    name: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListWorkerConfigurations: {
          http: {
            method: "GET",
            requestUri: "/v1/worker-configurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              workerConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    creationTime: {
                      shape: "S19"
                    },
                    description: {},
                    latestRevision: {
                      shape: "S1a"
                    },
                    name: {},
                    workerConfigurationArn: {}
                  }
                }
              }
            }
          }
        },
        UpdateConnector: {
          http: {
            method: "PUT",
            requestUri: "/v1/connectors/{connectorArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "capacity",
              "connectorArn",
              "currentVersion"
            ],
            members: {
              capacity: {
                type: "structure",
                members: {
                  autoScaling: {
                    type: "structure",
                    required: [
                      "maxWorkerCount",
                      "mcuCount",
                      "minWorkerCount",
                      "scaleInPolicy",
                      "scaleOutPolicy"
                    ],
                    members: {
                      maxWorkerCount: {
                        type: "integer"
                      },
                      mcuCount: {
                        type: "integer"
                      },
                      minWorkerCount: {
                        type: "integer"
                      },
                      scaleInPolicy: {
                        type: "structure",
                        required: [
                          "cpuUtilizationPercentage"
                        ],
                        members: {
                          cpuUtilizationPercentage: {
                            type: "integer"
                          }
                        }
                      },
                      scaleOutPolicy: {
                        type: "structure",
                        required: [
                          "cpuUtilizationPercentage"
                        ],
                        members: {
                          cpuUtilizationPercentage: {
                            type: "integer"
                          }
                        }
                      }
                    }
                  },
                  provisionedCapacity: {
                    type: "structure",
                    required: [
                      "mcuCount",
                      "workerCount"
                    ],
                    members: {
                      mcuCount: {
                        type: "integer"
                      },
                      workerCount: {
                        type: "integer"
                      }
                    }
                  }
                }
              },
              connectorArn: {
                location: "uri",
                locationName: "connectorArn"
              },
              currentVersion: {
                location: "querystring",
                locationName: "currentVersion"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              connectorArn: {},
              connectorState: {}
            }
          },
          idempotent: true
        }
      },
      shapes: {
        Sa: {
          type: "map",
          key: {},
          value: {},
          sensitive: true
        },
        Sh: {
          type: "list",
          member: {}
        },
        S17: {
          type: "string",
          sensitive: true
        },
        S19: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S1a: {
          type: "structure",
          members: {
            creationTime: {
              shape: "S19"
            },
            description: {},
            revision: {
              type: "long"
            }
          }
        },
        S1h: {
          type: "structure",
          members: {
            autoScaling: {
              type: "structure",
              members: {
                maxWorkerCount: {
                  type: "integer"
                },
                mcuCount: {
                  type: "integer"
                },
                minWorkerCount: {
                  type: "integer"
                },
                scaleInPolicy: {
                  type: "structure",
                  members: {
                    cpuUtilizationPercentage: {
                      type: "integer"
                    }
                  }
                },
                scaleOutPolicy: {
                  type: "structure",
                  members: {
                    cpuUtilizationPercentage: {
                      type: "integer"
                    }
                  }
                }
              }
            },
            provisionedCapacity: {
              type: "structure",
              members: {
                mcuCount: {
                  type: "integer"
                },
                workerCount: {
                  type: "integer"
                }
              }
            }
          }
        },
        S1n: {
          type: "structure",
          members: {
            apacheKafkaCluster: {
              type: "structure",
              members: {
                bootstrapServers: {},
                vpc: {
                  type: "structure",
                  members: {
                    securityGroups: {
                      shape: "Sh"
                    },
                    subnets: {
                      shape: "Sh"
                    }
                  }
                }
              }
            }
          }
        },
        S1q: {
          type: "structure",
          members: {
            authenticationType: {}
          }
        },
        S1r: {
          type: "structure",
          members: {
            encryptionType: {}
          }
        },
        S1s: {
          type: "structure",
          members: {
            workerLogDelivery: {
              type: "structure",
              members: {
                cloudWatchLogs: {
                  type: "structure",
                  members: {
                    enabled: {
                      type: "boolean"
                    },
                    logGroup: {}
                  }
                },
                firehose: {
                  type: "structure",
                  members: {
                    deliveryStream: {},
                    enabled: {
                      type: "boolean"
                    }
                  }
                },
                s3: {
                  type: "structure",
                  members: {
                    bucket: {},
                    enabled: {
                      type: "boolean"
                    },
                    prefix: {}
                  }
                }
              }
            }
          }
        },
        S1x: {
          type: "list",
          member: {
            type: "structure",
            members: {
              customPlugin: {
                type: "structure",
                members: {
                  customPluginArn: {},
                  revision: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        S20: {
          type: "structure",
          members: {
            code: {},
            message: {}
          }
        },
        S21: {
          type: "structure",
          members: {
            revision: {
              type: "long"
            },
            workerConfigurationArn: {}
          }
        },
        S24: {
          type: "structure",
          members: {
            contentType: {},
            creationTime: {
              shape: "S19"
            },
            description: {},
            fileDescription: {
              type: "structure",
              members: {
                fileMd5: {},
                fileSize: {
                  type: "long"
                }
              }
            },
            location: {
              type: "structure",
              members: {
                s3Location: {
                  type: "structure",
                  members: {
                    bucketArn: {},
                    fileKey: {},
                    objectVersion: {}
                  }
                }
              }
            },
            revision: {
              type: "long"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/kafkaconnect-2021-09-14.paginators.json
var require_kafkaconnect_2021_09_14_paginators = __commonJS({
  "node_modules/aws-sdk/apis/kafkaconnect-2021-09-14.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListConnectors: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "connectors"
        },
        ListCustomPlugins: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "customPlugins"
        },
        ListWorkerConfigurations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "workerConfigurations"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/kafkaconnect.js
var require_kafkaconnect = __commonJS({
  "node_modules/aws-sdk/clients/kafkaconnect.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["kafkaconnect"] = {};
    AWS2.KafkaConnect = Service.defineService("kafkaconnect", ["2021-09-14"]);
    Object.defineProperty(apiLoader.services["kafkaconnect"], "2021-09-14", {
      get: function get() {
        var model = require_kafkaconnect_2021_09_14_min();
        model.paginators = require_kafkaconnect_2021_09_14_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.KafkaConnect;
  }
});

// node_modules/aws-sdk/apis/voice-id-2021-09-27.min.json
var require_voice_id_2021_09_27_min = __commonJS({
  "node_modules/aws-sdk/apis/voice-id-2021-09-27.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-09-27",
        endpointPrefix: "voiceid",
        jsonVersion: "1.0",
        protocol: "json",
        serviceFullName: "Amazon Voice ID",
        serviceId: "Voice ID",
        signatureVersion: "v4",
        signingName: "voiceid",
        targetPrefix: "VoiceID",
        uid: "voice-id-2021-09-27"
      },
      operations: {
        AssociateFraudster: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "FraudsterId",
              "WatchlistId"
            ],
            members: {
              DomainId: {},
              FraudsterId: {
                shape: "S3"
              },
              WatchlistId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Fraudster: {
                shape: "S6"
              }
            }
          }
        },
        CreateDomain: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ServerSideEncryptionConfiguration"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              Description: {
                shape: "Sc"
              },
              Name: {
                shape: "Sd"
              },
              ServerSideEncryptionConfiguration: {
                shape: "Se"
              },
              Tags: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Domain: {
                shape: "Sl"
              }
            }
          },
          idempotent: true
        },
        CreateWatchlist: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "Name"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              Description: {
                shape: "St"
              },
              DomainId: {},
              Name: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Watchlist: {
                shape: "Sw"
              }
            }
          },
          idempotent: true
        },
        DeleteDomain: {
          input: {
            type: "structure",
            required: [
              "DomainId"
            ],
            members: {
              DomainId: {}
            }
          },
          idempotent: true
        },
        DeleteFraudster: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "FraudsterId"
            ],
            members: {
              DomainId: {},
              FraudsterId: {
                shape: "S3"
              }
            }
          }
        },
        DeleteSpeaker: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "SpeakerId"
            ],
            members: {
              DomainId: {},
              SpeakerId: {
                shape: "S11"
              }
            }
          }
        },
        DeleteWatchlist: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "WatchlistId"
            ],
            members: {
              DomainId: {},
              WatchlistId: {}
            }
          }
        },
        DescribeDomain: {
          input: {
            type: "structure",
            required: [
              "DomainId"
            ],
            members: {
              DomainId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Domain: {
                shape: "Sl"
              }
            }
          }
        },
        DescribeFraudster: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "FraudsterId"
            ],
            members: {
              DomainId: {},
              FraudsterId: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Fraudster: {
                shape: "S6"
              }
            }
          }
        },
        DescribeFraudsterRegistrationJob: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "JobId"
            ],
            members: {
              DomainId: {},
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Job: {
                shape: "S1a"
              }
            }
          }
        },
        DescribeSpeaker: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "SpeakerId"
            ],
            members: {
              DomainId: {},
              SpeakerId: {
                shape: "S11"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Speaker: {
                shape: "S1q"
              }
            }
          }
        },
        DescribeSpeakerEnrollmentJob: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "JobId"
            ],
            members: {
              DomainId: {},
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Job: {
                shape: "S1w"
              }
            }
          }
        },
        DescribeWatchlist: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "WatchlistId"
            ],
            members: {
              DomainId: {},
              WatchlistId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Watchlist: {
                shape: "Sw"
              }
            }
          }
        },
        DisassociateFraudster: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "FraudsterId",
              "WatchlistId"
            ],
            members: {
              DomainId: {},
              FraudsterId: {
                shape: "S3"
              },
              WatchlistId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Fraudster: {
                shape: "S6"
              }
            }
          }
        },
        EvaluateSession: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "SessionNameOrId"
            ],
            members: {
              DomainId: {},
              SessionNameOrId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AuthenticationResult: {
                type: "structure",
                members: {
                  AudioAggregationEndedAt: {
                    type: "timestamp"
                  },
                  AudioAggregationStartedAt: {
                    type: "timestamp"
                  },
                  AuthenticationResultId: {},
                  Configuration: {
                    type: "structure",
                    required: [
                      "AcceptanceThreshold"
                    ],
                    members: {
                      AcceptanceThreshold: {
                        type: "integer"
                      }
                    }
                  },
                  CustomerSpeakerId: {
                    shape: "S1r"
                  },
                  Decision: {},
                  GeneratedSpeakerId: {},
                  Score: {
                    type: "integer"
                  }
                }
              },
              DomainId: {},
              FraudDetectionResult: {
                type: "structure",
                members: {
                  AudioAggregationEndedAt: {
                    type: "timestamp"
                  },
                  AudioAggregationStartedAt: {
                    type: "timestamp"
                  },
                  Configuration: {
                    type: "structure",
                    members: {
                      RiskThreshold: {
                        type: "integer"
                      },
                      WatchlistId: {}
                    }
                  },
                  Decision: {},
                  FraudDetectionResultId: {},
                  Reasons: {
                    type: "list",
                    member: {}
                  },
                  RiskDetails: {
                    type: "structure",
                    required: [
                      "KnownFraudsterRisk",
                      "VoiceSpoofingRisk"
                    ],
                    members: {
                      KnownFraudsterRisk: {
                        type: "structure",
                        required: [
                          "RiskScore"
                        ],
                        members: {
                          GeneratedFraudsterId: {},
                          RiskScore: {
                            type: "integer"
                          }
                        }
                      },
                      VoiceSpoofingRisk: {
                        type: "structure",
                        required: [
                          "RiskScore"
                        ],
                        members: {
                          RiskScore: {
                            type: "integer"
                          }
                        }
                      }
                    }
                  }
                }
              },
              SessionId: {},
              SessionName: {},
              StreamingStatus: {}
            }
          }
        },
        ListDomains: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DomainSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    Description: {
                      shape: "Sc"
                    },
                    DomainId: {},
                    DomainStatus: {},
                    Name: {
                      shape: "Sd"
                    },
                    ServerSideEncryptionConfiguration: {
                      shape: "Se"
                    },
                    ServerSideEncryptionUpdateDetails: {
                      shape: "So"
                    },
                    UpdatedAt: {
                      type: "timestamp"
                    },
                    WatchlistDetails: {
                      shape: "Sr"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListFraudsterRegistrationJobs: {
          input: {
            type: "structure",
            required: [
              "DomainId"
            ],
            members: {
              DomainId: {},
              JobStatus: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreatedAt: {
                      type: "timestamp"
                    },
                    DomainId: {},
                    EndedAt: {
                      type: "timestamp"
                    },
                    FailureDetails: {
                      shape: "S1c"
                    },
                    JobId: {},
                    JobName: {
                      shape: "S1g"
                    },
                    JobProgress: {
                      shape: "S1h"
                    },
                    JobStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListFraudsters: {
          input: {
            type: "structure",
            required: [
              "DomainId"
            ],
            members: {
              DomainId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              WatchlistId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FraudsterSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreatedAt: {
                      type: "timestamp"
                    },
                    DomainId: {},
                    GeneratedFraudsterId: {},
                    WatchlistIds: {
                      shape: "S9"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSpeakerEnrollmentJobs: {
          input: {
            type: "structure",
            required: [
              "DomainId"
            ],
            members: {
              DomainId: {},
              JobStatus: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreatedAt: {
                      type: "timestamp"
                    },
                    DomainId: {},
                    EndedAt: {
                      type: "timestamp"
                    },
                    FailureDetails: {
                      shape: "S1c"
                    },
                    JobId: {},
                    JobName: {
                      shape: "S1g"
                    },
                    JobProgress: {
                      shape: "S1h"
                    },
                    JobStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSpeakers: {
          input: {
            type: "structure",
            required: [
              "DomainId"
            ],
            members: {
              DomainId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              SpeakerSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreatedAt: {
                      type: "timestamp"
                    },
                    CustomerSpeakerId: {
                      shape: "S1r"
                    },
                    DomainId: {},
                    GeneratedSpeakerId: {},
                    LastAccessedAt: {
                      type: "timestamp"
                    },
                    Status: {},
                    UpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sg"
              }
            }
          }
        },
        ListWatchlists: {
          input: {
            type: "structure",
            required: [
              "DomainId"
            ],
            members: {
              DomainId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              WatchlistSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreatedAt: {
                      type: "timestamp"
                    },
                    DefaultWatchlist: {
                      type: "boolean"
                    },
                    Description: {
                      shape: "St"
                    },
                    DomainId: {},
                    Name: {
                      shape: "Su"
                    },
                    UpdatedAt: {
                      type: "timestamp"
                    },
                    WatchlistId: {}
                  }
                }
              }
            }
          }
        },
        OptOutSpeaker: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "SpeakerId"
            ],
            members: {
              DomainId: {},
              SpeakerId: {
                shape: "S11"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Speaker: {
                shape: "S1q"
              }
            }
          }
        },
        StartFraudsterRegistrationJob: {
          input: {
            type: "structure",
            required: [
              "DataAccessRoleArn",
              "DomainId",
              "InputDataConfig",
              "OutputDataConfig"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              DataAccessRoleArn: {},
              DomainId: {},
              InputDataConfig: {
                shape: "S1e"
              },
              JobName: {
                shape: "S1g"
              },
              OutputDataConfig: {
                shape: "S1k"
              },
              RegistrationConfig: {
                shape: "S1l"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Job: {
                shape: "S1a"
              }
            }
          },
          idempotent: true
        },
        StartSpeakerEnrollmentJob: {
          input: {
            type: "structure",
            required: [
              "DataAccessRoleArn",
              "DomainId",
              "InputDataConfig",
              "OutputDataConfig"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              DataAccessRoleArn: {},
              DomainId: {},
              EnrollmentConfig: {
                shape: "S1x"
              },
              InputDataConfig: {
                shape: "S1e"
              },
              JobName: {
                shape: "S1g"
              },
              OutputDataConfig: {
                shape: "S1k"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Job: {
                shape: "S1w"
              }
            }
          },
          idempotent: true
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {
                  shape: "Si"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDomain: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "Name",
              "ServerSideEncryptionConfiguration"
            ],
            members: {
              Description: {
                shape: "Sc"
              },
              DomainId: {},
              Name: {
                shape: "Sd"
              },
              ServerSideEncryptionConfiguration: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Domain: {
                shape: "Sl"
              }
            }
          }
        },
        UpdateWatchlist: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "WatchlistId"
            ],
            members: {
              Description: {
                shape: "St"
              },
              DomainId: {},
              Name: {
                shape: "Su"
              },
              WatchlistId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Watchlist: {
                shape: "Sw"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "string",
          sensitive: true
        },
        S6: {
          type: "structure",
          members: {
            CreatedAt: {
              type: "timestamp"
            },
            DomainId: {},
            GeneratedFraudsterId: {},
            WatchlistIds: {
              shape: "S9"
            }
          }
        },
        S9: {
          type: "list",
          member: {}
        },
        Sc: {
          type: "string",
          sensitive: true
        },
        Sd: {
          type: "string",
          sensitive: true
        },
        Se: {
          type: "structure",
          required: [
            "KmsKeyId"
          ],
          members: {
            KmsKeyId: {}
          }
        },
        Sg: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {
                shape: "Si"
              },
              Value: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        Si: {
          type: "string",
          sensitive: true
        },
        Sl: {
          type: "structure",
          members: {
            Arn: {},
            CreatedAt: {
              type: "timestamp"
            },
            Description: {
              shape: "Sc"
            },
            DomainId: {},
            DomainStatus: {},
            Name: {
              shape: "Sd"
            },
            ServerSideEncryptionConfiguration: {
              shape: "Se"
            },
            ServerSideEncryptionUpdateDetails: {
              shape: "So"
            },
            UpdatedAt: {
              type: "timestamp"
            },
            WatchlistDetails: {
              shape: "Sr"
            }
          }
        },
        So: {
          type: "structure",
          members: {
            Message: {},
            OldKmsKeyId: {},
            UpdateStatus: {}
          }
        },
        Sr: {
          type: "structure",
          required: [
            "DefaultWatchlistId"
          ],
          members: {
            DefaultWatchlistId: {}
          }
        },
        St: {
          type: "string",
          sensitive: true
        },
        Su: {
          type: "string",
          sensitive: true
        },
        Sw: {
          type: "structure",
          members: {
            CreatedAt: {
              type: "timestamp"
            },
            DefaultWatchlist: {
              type: "boolean"
            },
            Description: {
              shape: "St"
            },
            DomainId: {},
            Name: {
              shape: "Su"
            },
            UpdatedAt: {
              type: "timestamp"
            },
            WatchlistId: {}
          }
        },
        S11: {
          type: "string",
          sensitive: true
        },
        S1a: {
          type: "structure",
          members: {
            CreatedAt: {
              type: "timestamp"
            },
            DataAccessRoleArn: {},
            DomainId: {},
            EndedAt: {
              type: "timestamp"
            },
            FailureDetails: {
              shape: "S1c"
            },
            InputDataConfig: {
              shape: "S1e"
            },
            JobId: {},
            JobName: {
              shape: "S1g"
            },
            JobProgress: {
              shape: "S1h"
            },
            JobStatus: {},
            OutputDataConfig: {
              shape: "S1k"
            },
            RegistrationConfig: {
              shape: "S1l"
            }
          }
        },
        S1c: {
          type: "structure",
          members: {
            Message: {},
            StatusCode: {
              type: "integer"
            }
          }
        },
        S1e: {
          type: "structure",
          required: [
            "S3Uri"
          ],
          members: {
            S3Uri: {}
          }
        },
        S1g: {
          type: "string",
          sensitive: true
        },
        S1h: {
          type: "structure",
          members: {
            PercentComplete: {
              type: "integer"
            }
          }
        },
        S1k: {
          type: "structure",
          required: [
            "S3Uri"
          ],
          members: {
            KmsKeyId: {},
            S3Uri: {}
          }
        },
        S1l: {
          type: "structure",
          members: {
            DuplicateRegistrationAction: {},
            FraudsterSimilarityThreshold: {
              type: "integer"
            },
            WatchlistIds: {
              type: "list",
              member: {}
            }
          }
        },
        S1q: {
          type: "structure",
          members: {
            CreatedAt: {
              type: "timestamp"
            },
            CustomerSpeakerId: {
              shape: "S1r"
            },
            DomainId: {},
            GeneratedSpeakerId: {},
            LastAccessedAt: {
              type: "timestamp"
            },
            Status: {},
            UpdatedAt: {
              type: "timestamp"
            }
          }
        },
        S1r: {
          type: "string",
          sensitive: true
        },
        S1w: {
          type: "structure",
          members: {
            CreatedAt: {
              type: "timestamp"
            },
            DataAccessRoleArn: {},
            DomainId: {},
            EndedAt: {
              type: "timestamp"
            },
            EnrollmentConfig: {
              shape: "S1x"
            },
            FailureDetails: {
              shape: "S1c"
            },
            InputDataConfig: {
              shape: "S1e"
            },
            JobId: {},
            JobName: {
              shape: "S1g"
            },
            JobProgress: {
              shape: "S1h"
            },
            JobStatus: {},
            OutputDataConfig: {
              shape: "S1k"
            }
          }
        },
        S1x: {
          type: "structure",
          members: {
            ExistingEnrollmentAction: {},
            FraudDetectionConfig: {
              type: "structure",
              members: {
                FraudDetectionAction: {},
                RiskThreshold: {
                  type: "integer"
                },
                WatchlistIds: {
                  type: "list",
                  member: {}
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/voice-id-2021-09-27.paginators.json
var require_voice_id_2021_09_27_paginators = __commonJS({
  "node_modules/aws-sdk/apis/voice-id-2021-09-27.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListDomains: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "DomainSummaries"
        },
        ListFraudsterRegistrationJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "JobSummaries"
        },
        ListFraudsters: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "FraudsterSummaries"
        },
        ListSpeakerEnrollmentJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "JobSummaries"
        },
        ListSpeakers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "SpeakerSummaries"
        },
        ListWatchlists: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "WatchlistSummaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/voiceid.js
var require_voiceid = __commonJS({
  "node_modules/aws-sdk/clients/voiceid.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["voiceid"] = {};
    AWS2.VoiceID = Service.defineService("voiceid", ["2021-09-27"]);
    Object.defineProperty(apiLoader.services["voiceid"], "2021-09-27", {
      get: function get() {
        var model = require_voice_id_2021_09_27_min();
        model.paginators = require_voice_id_2021_09_27_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.VoiceID;
  }
});

// node_modules/aws-sdk/apis/wisdom-2020-10-19.min.json
var require_wisdom_2020_10_19_min = __commonJS({
  "node_modules/aws-sdk/apis/wisdom-2020-10-19.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-10-19",
        endpointPrefix: "wisdom",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Connect Wisdom Service",
        serviceId: "Wisdom",
        signatureVersion: "v4",
        signingName: "wisdom",
        uid: "wisdom-2020-10-19"
      },
      operations: {
        CreateAssistant: {
          http: {
            requestUri: "/assistants",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "type"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              description: {},
              name: {},
              serverSideEncryptionConfiguration: {
                shape: "S5"
              },
              tags: {
                shape: "S7"
              },
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              assistant: {
                shape: "Sc"
              }
            }
          },
          idempotent: true
        },
        CreateAssistantAssociation: {
          http: {
            requestUri: "/assistants/{assistantId}/associations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assistantId",
              "association",
              "associationType"
            ],
            members: {
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              },
              association: {
                type: "structure",
                members: {
                  knowledgeBaseId: {}
                },
                union: true
              },
              associationType: {},
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              assistantAssociation: {
                shape: "Sn"
              }
            }
          },
          idempotent: true
        },
        CreateContent: {
          http: {
            requestUri: "/knowledgeBases/{knowledgeBaseId}/contents",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId",
              "name",
              "uploadId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              metadata: {
                shape: "Sr"
              },
              name: {},
              overrideLinkOutUri: {},
              tags: {
                shape: "S7"
              },
              title: {},
              uploadId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              content: {
                shape: "Sw"
              }
            }
          },
          idempotent: true
        },
        CreateKnowledgeBase: {
          http: {
            requestUri: "/knowledgeBases",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseType",
              "name"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              description: {},
              knowledgeBaseType: {},
              name: {},
              renderingConfiguration: {
                shape: "S13"
              },
              serverSideEncryptionConfiguration: {
                shape: "S5"
              },
              sourceConfiguration: {
                shape: "S14"
              },
              tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              knowledgeBase: {
                shape: "S18"
              }
            }
          },
          idempotent: true
        },
        CreateQuickResponse: {
          http: {
            requestUri: "/knowledgeBases/{knowledgeBaseId}/quickResponses",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "content",
              "knowledgeBaseId",
              "name"
            ],
            members: {
              channels: {
                shape: "S1b"
              },
              clientToken: {
                idempotencyToken: true
              },
              content: {
                shape: "S1d"
              },
              contentType: {},
              description: {},
              groupingConfiguration: {
                shape: "S1h"
              },
              isActive: {
                type: "boolean"
              },
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              language: {},
              name: {},
              shortcutKey: {},
              tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              quickResponse: {
                shape: "S1q"
              }
            }
          },
          idempotent: true
        },
        CreateSession: {
          http: {
            requestUri: "/assistants/{assistantId}/sessions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assistantId",
              "name"
            ],
            members: {
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              },
              clientToken: {
                idempotencyToken: true
              },
              description: {},
              name: {},
              tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              session: {
                shape: "S1w"
              }
            }
          },
          idempotent: true
        },
        DeleteAssistant: {
          http: {
            method: "DELETE",
            requestUri: "/assistants/{assistantId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "assistantId"
            ],
            members: {
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteAssistantAssociation: {
          http: {
            method: "DELETE",
            requestUri: "/assistants/{assistantId}/associations/{assistantAssociationId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "assistantAssociationId",
              "assistantId"
            ],
            members: {
              assistantAssociationId: {
                location: "uri",
                locationName: "assistantAssociationId"
              },
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteContent: {
          http: {
            method: "DELETE",
            requestUri: "/knowledgeBases/{knowledgeBaseId}/contents/{contentId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "contentId",
              "knowledgeBaseId"
            ],
            members: {
              contentId: {
                location: "uri",
                locationName: "contentId"
              },
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteImportJob: {
          http: {
            method: "DELETE",
            requestUri: "/knowledgeBases/{knowledgeBaseId}/importJobs/{importJobId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "importJobId",
              "knowledgeBaseId"
            ],
            members: {
              importJobId: {
                location: "uri",
                locationName: "importJobId"
              },
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteKnowledgeBase: {
          http: {
            method: "DELETE",
            requestUri: "/knowledgeBases/{knowledgeBaseId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteQuickResponse: {
          http: {
            method: "DELETE",
            requestUri: "/knowledgeBases/{knowledgeBaseId}/quickResponses/{quickResponseId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId",
              "quickResponseId"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              quickResponseId: {
                location: "uri",
                locationName: "quickResponseId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        GetAssistant: {
          http: {
            method: "GET",
            requestUri: "/assistants/{assistantId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assistantId"
            ],
            members: {
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              assistant: {
                shape: "Sc"
              }
            }
          }
        },
        GetAssistantAssociation: {
          http: {
            method: "GET",
            requestUri: "/assistants/{assistantId}/associations/{assistantAssociationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assistantAssociationId",
              "assistantId"
            ],
            members: {
              assistantAssociationId: {
                location: "uri",
                locationName: "assistantAssociationId"
              },
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              assistantAssociation: {
                shape: "Sn"
              }
            }
          }
        },
        GetContent: {
          http: {
            method: "GET",
            requestUri: "/knowledgeBases/{knowledgeBaseId}/contents/{contentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "contentId",
              "knowledgeBaseId"
            ],
            members: {
              contentId: {
                location: "uri",
                locationName: "contentId"
              },
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              content: {
                shape: "Sw"
              }
            }
          }
        },
        GetContentSummary: {
          http: {
            method: "GET",
            requestUri: "/knowledgeBases/{knowledgeBaseId}/contents/{contentId}/summary",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "contentId",
              "knowledgeBaseId"
            ],
            members: {
              contentId: {
                location: "uri",
                locationName: "contentId"
              },
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              contentSummary: {
                shape: "S2i"
              }
            }
          }
        },
        GetImportJob: {
          http: {
            method: "GET",
            requestUri: "/knowledgeBases/{knowledgeBaseId}/importJobs/{importJobId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "importJobId",
              "knowledgeBaseId"
            ],
            members: {
              importJobId: {
                location: "uri",
                locationName: "importJobId"
              },
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              importJob: {
                shape: "S2l"
              }
            }
          }
        },
        GetKnowledgeBase: {
          http: {
            method: "GET",
            requestUri: "/knowledgeBases/{knowledgeBaseId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              knowledgeBase: {
                shape: "S18"
              }
            }
          }
        },
        GetQuickResponse: {
          http: {
            method: "GET",
            requestUri: "/knowledgeBases/{knowledgeBaseId}/quickResponses/{quickResponseId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId",
              "quickResponseId"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              quickResponseId: {
                location: "uri",
                locationName: "quickResponseId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              quickResponse: {
                shape: "S1q"
              }
            }
          }
        },
        GetRecommendations: {
          http: {
            method: "GET",
            requestUri: "/assistants/{assistantId}/sessions/{sessionId}/recommendations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assistantId",
              "sessionId"
            ],
            members: {
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              sessionId: {
                location: "uri",
                locationName: "sessionId"
              },
              waitTimeSeconds: {
                location: "querystring",
                locationName: "waitTimeSeconds",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "recommendations"
            ],
            members: {
              recommendations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "document",
                    "recommendationId"
                  ],
                  members: {
                    document: {
                      shape: "S32"
                    },
                    recommendationId: {},
                    relevanceLevel: {},
                    relevanceScore: {
                      type: "double"
                    },
                    type: {}
                  }
                }
              },
              triggers: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "data",
                    "id",
                    "recommendationIds",
                    "source",
                    "type"
                  ],
                  members: {
                    data: {
                      type: "structure",
                      members: {
                        query: {
                          type: "structure",
                          members: {
                            text: {
                              shape: "S3h"
                            }
                          }
                        }
                      },
                      union: true
                    },
                    id: {},
                    recommendationIds: {
                      shape: "S3i"
                    },
                    source: {},
                    type: {}
                  }
                }
              }
            }
          }
        },
        GetSession: {
          http: {
            method: "GET",
            requestUri: "/assistants/{assistantId}/sessions/{sessionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assistantId",
              "sessionId"
            ],
            members: {
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              },
              sessionId: {
                location: "uri",
                locationName: "sessionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              session: {
                shape: "S1w"
              }
            }
          }
        },
        ListAssistantAssociations: {
          http: {
            method: "GET",
            requestUri: "/assistants/{assistantId}/associations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assistantId"
            ],
            members: {
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assistantAssociationSummaries"
            ],
            members: {
              assistantAssociationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "assistantArn",
                    "assistantAssociationArn",
                    "assistantAssociationId",
                    "assistantId",
                    "associationData",
                    "associationType"
                  ],
                  members: {
                    assistantArn: {},
                    assistantAssociationArn: {},
                    assistantAssociationId: {},
                    assistantId: {},
                    associationData: {
                      shape: "So"
                    },
                    associationType: {},
                    tags: {
                      shape: "S7"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAssistants: {
          http: {
            method: "GET",
            requestUri: "/assistants",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assistantSummaries"
            ],
            members: {
              assistantSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "assistantArn",
                    "assistantId",
                    "name",
                    "status",
                    "type"
                  ],
                  members: {
                    assistantArn: {},
                    assistantId: {},
                    description: {},
                    integrationConfiguration: {
                      shape: "Sf"
                    },
                    name: {},
                    serverSideEncryptionConfiguration: {
                      shape: "S5"
                    },
                    status: {},
                    tags: {
                      shape: "S7"
                    },
                    type: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListContents: {
          http: {
            method: "GET",
            requestUri: "/knowledgeBases/{knowledgeBaseId}/contents",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "contentSummaries"
            ],
            members: {
              contentSummaries: {
                shape: "S3y"
              },
              nextToken: {}
            }
          }
        },
        ListImportJobs: {
          http: {
            method: "GET",
            requestUri: "/knowledgeBases/{knowledgeBaseId}/importJobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "importJobSummaries"
            ],
            members: {
              importJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "createdTime",
                    "importJobId",
                    "importJobType",
                    "knowledgeBaseArn",
                    "knowledgeBaseId",
                    "lastModifiedTime",
                    "status",
                    "uploadId"
                  ],
                  members: {
                    createdTime: {
                      shape: "S10"
                    },
                    externalSourceConfiguration: {
                      shape: "S2m"
                    },
                    importJobId: {},
                    importJobType: {},
                    knowledgeBaseArn: {},
                    knowledgeBaseId: {},
                    lastModifiedTime: {
                      shape: "S10"
                    },
                    metadata: {
                      shape: "Sr"
                    },
                    status: {},
                    uploadId: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListKnowledgeBases: {
          http: {
            method: "GET",
            requestUri: "/knowledgeBases",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "knowledgeBaseSummaries"
            ],
            members: {
              knowledgeBaseSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "knowledgeBaseArn",
                    "knowledgeBaseId",
                    "knowledgeBaseType",
                    "name",
                    "status"
                  ],
                  members: {
                    description: {},
                    knowledgeBaseArn: {},
                    knowledgeBaseId: {},
                    knowledgeBaseType: {},
                    name: {},
                    renderingConfiguration: {
                      shape: "S13"
                    },
                    serverSideEncryptionConfiguration: {
                      shape: "S5"
                    },
                    sourceConfiguration: {
                      shape: "S14"
                    },
                    status: {},
                    tags: {
                      shape: "S7"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListQuickResponses: {
          http: {
            method: "GET",
            requestUri: "/knowledgeBases/{knowledgeBaseId}/quickResponses",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "quickResponseSummaries"
            ],
            members: {
              nextToken: {},
              quickResponseSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "contentType",
                    "createdTime",
                    "knowledgeBaseArn",
                    "knowledgeBaseId",
                    "lastModifiedTime",
                    "name",
                    "quickResponseArn",
                    "quickResponseId",
                    "status"
                  ],
                  members: {
                    channels: {
                      shape: "S1b"
                    },
                    contentType: {},
                    createdTime: {
                      shape: "S10"
                    },
                    description: {},
                    isActive: {
                      type: "boolean"
                    },
                    knowledgeBaseArn: {},
                    knowledgeBaseId: {},
                    lastModifiedBy: {},
                    lastModifiedTime: {
                      shape: "S10"
                    },
                    name: {},
                    quickResponseArn: {},
                    quickResponseId: {},
                    status: {},
                    tags: {
                      shape: "S7"
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S7"
              }
            }
          }
        },
        NotifyRecommendationsReceived: {
          http: {
            requestUri: "/assistants/{assistantId}/sessions/{sessionId}/recommendations/notify",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assistantId",
              "recommendationIds",
              "sessionId"
            ],
            members: {
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              },
              recommendationIds: {
                shape: "S3i"
              },
              sessionId: {
                location: "uri",
                locationName: "sessionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    message: {},
                    recommendationId: {}
                  }
                }
              },
              recommendationIds: {
                shape: "S3i"
              }
            }
          },
          idempotent: true
        },
        QueryAssistant: {
          http: {
            requestUri: "/assistants/{assistantId}/query",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assistantId",
              "queryText"
            ],
            members: {
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              queryText: {
                shape: "S3h"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "results"
            ],
            members: {
              nextToken: {},
              results: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "document",
                    "resultId"
                  ],
                  members: {
                    document: {
                      shape: "S32"
                    },
                    relevanceScore: {
                      type: "double"
                    },
                    resultId: {}
                  }
                }
              }
            }
          }
        },
        RemoveKnowledgeBaseTemplateUri: {
          http: {
            method: "DELETE",
            requestUri: "/knowledgeBases/{knowledgeBaseId}/templateUri",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SearchContent: {
          http: {
            requestUri: "/knowledgeBases/{knowledgeBaseId}/search",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId",
              "searchExpression"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              searchExpression: {
                shape: "S4p"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "contentSummaries"
            ],
            members: {
              contentSummaries: {
                shape: "S3y"
              },
              nextToken: {}
            }
          }
        },
        SearchQuickResponses: {
          http: {
            requestUri: "/knowledgeBases/{knowledgeBaseId}/search/quickResponses",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId",
              "searchExpression"
            ],
            members: {
              attributes: {
                type: "map",
                key: {},
                value: {},
                sensitive: true
              },
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              searchExpression: {
                type: "structure",
                members: {
                  filters: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "name",
                        "operator"
                      ],
                      members: {
                        includeNoExistence: {
                          type: "boolean"
                        },
                        name: {},
                        operator: {},
                        values: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  },
                  orderOnField: {
                    type: "structure",
                    required: [
                      "name"
                    ],
                    members: {
                      name: {},
                      order: {}
                    }
                  },
                  queries: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "name",
                        "operator",
                        "values"
                      ],
                      members: {
                        allowFuzziness: {
                          type: "boolean"
                        },
                        name: {},
                        operator: {},
                        priority: {},
                        values: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "results"
            ],
            members: {
              nextToken: {},
              results: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "contentType",
                    "contents",
                    "createdTime",
                    "isActive",
                    "knowledgeBaseArn",
                    "knowledgeBaseId",
                    "lastModifiedTime",
                    "name",
                    "quickResponseArn",
                    "quickResponseId",
                    "status"
                  ],
                  members: {
                    attributesInterpolated: {
                      shape: "S5g"
                    },
                    attributesNotInterpolated: {
                      shape: "S5g"
                    },
                    channels: {
                      shape: "S1b"
                    },
                    contentType: {},
                    contents: {
                      shape: "S1r"
                    },
                    createdTime: {
                      shape: "S10"
                    },
                    description: {},
                    groupingConfiguration: {
                      shape: "S1h"
                    },
                    isActive: {
                      type: "boolean"
                    },
                    knowledgeBaseArn: {},
                    knowledgeBaseId: {},
                    language: {},
                    lastModifiedBy: {},
                    lastModifiedTime: {
                      shape: "S10"
                    },
                    name: {},
                    quickResponseArn: {},
                    quickResponseId: {},
                    shortcutKey: {},
                    status: {},
                    tags: {
                      shape: "S7"
                    }
                  }
                }
              }
            }
          }
        },
        SearchSessions: {
          http: {
            requestUri: "/assistants/{assistantId}/searchSessions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assistantId",
              "searchExpression"
            ],
            members: {
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              searchExpression: {
                shape: "S4p"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "sessionSummaries"
            ],
            members: {
              nextToken: {},
              sessionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "assistantArn",
                    "assistantId",
                    "sessionArn",
                    "sessionId"
                  ],
                  members: {
                    assistantArn: {},
                    assistantId: {},
                    sessionArn: {},
                    sessionId: {}
                  }
                }
              }
            }
          }
        },
        StartContentUpload: {
          http: {
            requestUri: "/knowledgeBases/{knowledgeBaseId}/upload",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "contentType",
              "knowledgeBaseId"
            ],
            members: {
              contentType: {},
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              presignedUrlTimeToLive: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "headersToInclude",
              "uploadId",
              "url",
              "urlExpiry"
            ],
            members: {
              headersToInclude: {
                type: "map",
                key: {},
                value: {}
              },
              uploadId: {},
              url: {
                shape: "Sz"
              },
              urlExpiry: {
                shape: "S10"
              }
            }
          }
        },
        StartImportJob: {
          http: {
            requestUri: "/knowledgeBases/{knowledgeBaseId}/importJobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "importJobType",
              "knowledgeBaseId",
              "uploadId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              externalSourceConfiguration: {
                shape: "S2m"
              },
              importJobType: {},
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              metadata: {
                shape: "Sr"
              },
              uploadId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              importJob: {
                shape: "S2l"
              }
            }
          },
          idempotent: true
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateContent: {
          http: {
            requestUri: "/knowledgeBases/{knowledgeBaseId}/contents/{contentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "contentId",
              "knowledgeBaseId"
            ],
            members: {
              contentId: {
                location: "uri",
                locationName: "contentId"
              },
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              metadata: {
                shape: "Sr"
              },
              overrideLinkOutUri: {},
              removeOverrideLinkOutUri: {
                type: "boolean"
              },
              revisionId: {},
              title: {},
              uploadId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              content: {
                shape: "Sw"
              }
            }
          }
        },
        UpdateKnowledgeBaseTemplateUri: {
          http: {
            requestUri: "/knowledgeBases/{knowledgeBaseId}/templateUri",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId",
              "templateUri"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              templateUri: {}
            }
          },
          output: {
            type: "structure",
            members: {
              knowledgeBase: {
                shape: "S18"
              }
            }
          }
        },
        UpdateQuickResponse: {
          http: {
            requestUri: "/knowledgeBases/{knowledgeBaseId}/quickResponses/{quickResponseId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId",
              "quickResponseId"
            ],
            members: {
              channels: {
                shape: "S1b"
              },
              content: {
                shape: "S1d"
              },
              contentType: {},
              description: {},
              groupingConfiguration: {
                shape: "S1h"
              },
              isActive: {
                type: "boolean"
              },
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              language: {},
              name: {},
              quickResponseId: {
                location: "uri",
                locationName: "quickResponseId"
              },
              removeDescription: {
                type: "boolean"
              },
              removeGroupingConfiguration: {
                type: "boolean"
              },
              removeShortcutKey: {
                type: "boolean"
              },
              shortcutKey: {}
            }
          },
          output: {
            type: "structure",
            members: {
              quickResponse: {
                shape: "S1q"
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          members: {
            kmsKeyId: {}
          }
        },
        S7: {
          type: "map",
          key: {},
          value: {}
        },
        Sc: {
          type: "structure",
          required: [
            "assistantArn",
            "assistantId",
            "name",
            "status",
            "type"
          ],
          members: {
            assistantArn: {},
            assistantId: {},
            description: {},
            integrationConfiguration: {
              shape: "Sf"
            },
            name: {},
            serverSideEncryptionConfiguration: {
              shape: "S5"
            },
            status: {},
            tags: {
              shape: "S7"
            },
            type: {}
          }
        },
        Sf: {
          type: "structure",
          members: {
            topicIntegrationArn: {}
          }
        },
        Sn: {
          type: "structure",
          required: [
            "assistantArn",
            "assistantAssociationArn",
            "assistantAssociationId",
            "assistantId",
            "associationData",
            "associationType"
          ],
          members: {
            assistantArn: {},
            assistantAssociationArn: {},
            assistantAssociationId: {},
            assistantId: {},
            associationData: {
              shape: "So"
            },
            associationType: {},
            tags: {
              shape: "S7"
            }
          }
        },
        So: {
          type: "structure",
          members: {
            knowledgeBaseAssociation: {
              type: "structure",
              members: {
                knowledgeBaseArn: {},
                knowledgeBaseId: {}
              }
            }
          },
          union: true
        },
        Sr: {
          type: "map",
          key: {},
          value: {}
        },
        Sw: {
          type: "structure",
          required: [
            "contentArn",
            "contentId",
            "contentType",
            "knowledgeBaseArn",
            "knowledgeBaseId",
            "metadata",
            "name",
            "revisionId",
            "status",
            "title",
            "url",
            "urlExpiry"
          ],
          members: {
            contentArn: {},
            contentId: {},
            contentType: {},
            knowledgeBaseArn: {},
            knowledgeBaseId: {},
            linkOutUri: {},
            metadata: {
              shape: "Sr"
            },
            name: {},
            revisionId: {},
            status: {},
            tags: {
              shape: "S7"
            },
            title: {},
            url: {
              shape: "Sz"
            },
            urlExpiry: {
              shape: "S10"
            }
          }
        },
        Sz: {
          type: "string",
          sensitive: true
        },
        S10: {
          type: "timestamp",
          timestampFormat: "unixTimestamp"
        },
        S13: {
          type: "structure",
          members: {
            templateUri: {}
          }
        },
        S14: {
          type: "structure",
          members: {
            appIntegrations: {
              type: "structure",
              required: [
                "appIntegrationArn"
              ],
              members: {
                appIntegrationArn: {},
                objectFields: {
                  type: "list",
                  member: {}
                }
              }
            }
          },
          union: true
        },
        S18: {
          type: "structure",
          required: [
            "knowledgeBaseArn",
            "knowledgeBaseId",
            "knowledgeBaseType",
            "name",
            "status"
          ],
          members: {
            description: {},
            knowledgeBaseArn: {},
            knowledgeBaseId: {},
            knowledgeBaseType: {},
            lastContentModificationTime: {
              shape: "S10"
            },
            name: {},
            renderingConfiguration: {
              shape: "S13"
            },
            serverSideEncryptionConfiguration: {
              shape: "S5"
            },
            sourceConfiguration: {
              shape: "S14"
            },
            status: {},
            tags: {
              shape: "S7"
            }
          }
        },
        S1b: {
          type: "list",
          member: {
            type: "string",
            sensitive: true
          }
        },
        S1d: {
          type: "structure",
          members: {
            content: {
              shape: "S1e"
            }
          },
          union: true
        },
        S1e: {
          type: "string",
          sensitive: true
        },
        S1h: {
          type: "structure",
          members: {
            criteria: {
              type: "string",
              sensitive: true
            },
            values: {
              type: "list",
              member: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        S1q: {
          type: "structure",
          required: [
            "contentType",
            "createdTime",
            "knowledgeBaseArn",
            "knowledgeBaseId",
            "lastModifiedTime",
            "name",
            "quickResponseArn",
            "quickResponseId",
            "status"
          ],
          members: {
            channels: {
              shape: "S1b"
            },
            contentType: {},
            contents: {
              shape: "S1r"
            },
            createdTime: {
              shape: "S10"
            },
            description: {},
            groupingConfiguration: {
              shape: "S1h"
            },
            isActive: {
              type: "boolean"
            },
            knowledgeBaseArn: {},
            knowledgeBaseId: {},
            language: {},
            lastModifiedBy: {},
            lastModifiedTime: {
              shape: "S10"
            },
            name: {},
            quickResponseArn: {},
            quickResponseId: {},
            shortcutKey: {},
            status: {},
            tags: {
              shape: "S7"
            }
          }
        },
        S1r: {
          type: "structure",
          members: {
            markdown: {
              shape: "S1s"
            },
            plainText: {
              shape: "S1s"
            }
          }
        },
        S1s: {
          type: "structure",
          members: {
            content: {
              shape: "S1e"
            }
          },
          union: true
        },
        S1w: {
          type: "structure",
          required: [
            "name",
            "sessionArn",
            "sessionId"
          ],
          members: {
            description: {},
            integrationConfiguration: {
              type: "structure",
              members: {
                topicIntegrationArn: {}
              }
            },
            name: {},
            sessionArn: {},
            sessionId: {},
            tags: {
              shape: "S7"
            }
          }
        },
        S2i: {
          type: "structure",
          required: [
            "contentArn",
            "contentId",
            "contentType",
            "knowledgeBaseArn",
            "knowledgeBaseId",
            "metadata",
            "name",
            "revisionId",
            "status",
            "title"
          ],
          members: {
            contentArn: {},
            contentId: {},
            contentType: {},
            knowledgeBaseArn: {},
            knowledgeBaseId: {},
            metadata: {
              shape: "Sr"
            },
            name: {},
            revisionId: {},
            status: {},
            tags: {
              shape: "S7"
            },
            title: {}
          }
        },
        S2l: {
          type: "structure",
          required: [
            "createdTime",
            "importJobId",
            "importJobType",
            "knowledgeBaseArn",
            "knowledgeBaseId",
            "lastModifiedTime",
            "status",
            "uploadId",
            "url",
            "urlExpiry"
          ],
          members: {
            createdTime: {
              shape: "S10"
            },
            externalSourceConfiguration: {
              shape: "S2m"
            },
            failedRecordReport: {
              shape: "Sz"
            },
            importJobId: {},
            importJobType: {},
            knowledgeBaseArn: {},
            knowledgeBaseId: {},
            lastModifiedTime: {
              shape: "S10"
            },
            metadata: {
              shape: "Sr"
            },
            status: {},
            uploadId: {},
            url: {
              shape: "Sz"
            },
            urlExpiry: {
              shape: "S10"
            }
          }
        },
        S2m: {
          type: "structure",
          required: [
            "configuration",
            "source"
          ],
          members: {
            configuration: {
              type: "structure",
              members: {
                connectConfiguration: {
                  type: "structure",
                  members: {
                    instanceId: {}
                  }
                }
              },
              union: true
            },
            source: {}
          }
        },
        S32: {
          type: "structure",
          required: [
            "contentReference"
          ],
          members: {
            contentReference: {
              type: "structure",
              members: {
                contentArn: {},
                contentId: {},
                knowledgeBaseArn: {},
                knowledgeBaseId: {}
              }
            },
            excerpt: {
              shape: "S34"
            },
            title: {
              shape: "S34"
            }
          }
        },
        S34: {
          type: "structure",
          members: {
            highlights: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  beginOffsetInclusive: {
                    type: "integer"
                  },
                  endOffsetExclusive: {
                    type: "integer"
                  }
                }
              }
            },
            text: {
              type: "string",
              sensitive: true
            }
          }
        },
        S3h: {
          type: "string",
          sensitive: true
        },
        S3i: {
          type: "list",
          member: {}
        },
        S3y: {
          type: "list",
          member: {
            shape: "S2i"
          }
        },
        S4p: {
          type: "structure",
          required: [
            "filters"
          ],
          members: {
            filters: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "field",
                  "operator",
                  "value"
                ],
                members: {
                  field: {},
                  operator: {},
                  value: {}
                }
              }
            }
          }
        },
        S5g: {
          type: "list",
          member: {},
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/wisdom-2020-10-19.paginators.json
var require_wisdom_2020_10_19_paginators = __commonJS({
  "node_modules/aws-sdk/apis/wisdom-2020-10-19.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAssistantAssociations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "assistantAssociationSummaries"
        },
        ListAssistants: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "assistantSummaries"
        },
        ListContents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "contentSummaries"
        },
        ListImportJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "importJobSummaries"
        },
        ListKnowledgeBases: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "knowledgeBaseSummaries"
        },
        ListQuickResponses: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "quickResponseSummaries"
        },
        QueryAssistant: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "results"
        },
        SearchContent: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "contentSummaries"
        },
        SearchQuickResponses: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "results"
        },
        SearchSessions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "sessionSummaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/wisdom.js
var require_wisdom = __commonJS({
  "node_modules/aws-sdk/clients/wisdom.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["wisdom"] = {};
    AWS2.Wisdom = Service.defineService("wisdom", ["2020-10-19"]);
    Object.defineProperty(apiLoader.services["wisdom"], "2020-10-19", {
      get: function get() {
        var model = require_wisdom_2020_10_19_min();
        model.paginators = require_wisdom_2020_10_19_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Wisdom;
  }
});

// node_modules/aws-sdk/apis/account-2021-02-01.min.json
var require_account_2021_02_01_min = __commonJS({
  "node_modules/aws-sdk/apis/account-2021-02-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-02-01",
        endpointPrefix: "account",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Account",
        serviceId: "Account",
        signatureVersion: "v4",
        signingName: "account",
        uid: "account-2021-02-01"
      },
      operations: {
        DeleteAlternateContact: {
          http: {
            requestUri: "/deleteAlternateContact",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AlternateContactType"
            ],
            members: {
              AccountId: {},
              AlternateContactType: {}
            }
          },
          idempotent: true
        },
        DisableRegion: {
          http: {
            requestUri: "/disableRegion",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "RegionName"
            ],
            members: {
              AccountId: {},
              RegionName: {}
            }
          }
        },
        EnableRegion: {
          http: {
            requestUri: "/enableRegion",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "RegionName"
            ],
            members: {
              AccountId: {},
              RegionName: {}
            }
          }
        },
        GetAlternateContact: {
          http: {
            requestUri: "/getAlternateContact",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AlternateContactType"
            ],
            members: {
              AccountId: {},
              AlternateContactType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AlternateContact: {
                type: "structure",
                members: {
                  AlternateContactType: {},
                  EmailAddress: {
                    shape: "Sa"
                  },
                  Name: {
                    shape: "Sb"
                  },
                  PhoneNumber: {
                    shape: "Sc"
                  },
                  Title: {
                    shape: "Sd"
                  }
                }
              }
            }
          }
        },
        GetContactInformation: {
          http: {
            requestUri: "/getContactInformation",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ContactInformation: {
                shape: "Sg"
              }
            }
          }
        },
        GetRegionOptStatus: {
          http: {
            requestUri: "/getRegionOptStatus",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "RegionName"
            ],
            members: {
              AccountId: {},
              RegionName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RegionName: {},
              RegionOptStatus: {}
            }
          }
        },
        ListRegions: {
          http: {
            requestUri: "/listRegions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AccountId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              RegionOptStatusContains: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Regions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RegionName: {},
                    RegionOptStatus: {}
                  }
                }
              }
            }
          }
        },
        PutAlternateContact: {
          http: {
            requestUri: "/putAlternateContact",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AlternateContactType",
              "EmailAddress",
              "Name",
              "PhoneNumber",
              "Title"
            ],
            members: {
              AccountId: {},
              AlternateContactType: {},
              EmailAddress: {
                shape: "Sa"
              },
              Name: {
                shape: "Sb"
              },
              PhoneNumber: {
                shape: "Sc"
              },
              Title: {
                shape: "Sd"
              }
            }
          },
          idempotent: true
        },
        PutContactInformation: {
          http: {
            requestUri: "/putContactInformation",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ContactInformation"
            ],
            members: {
              AccountId: {},
              ContactInformation: {
                shape: "Sg"
              }
            }
          },
          idempotent: true
        }
      },
      shapes: {
        Sa: {
          type: "string",
          sensitive: true
        },
        Sb: {
          type: "string",
          sensitive: true
        },
        Sc: {
          type: "string",
          sensitive: true
        },
        Sd: {
          type: "string",
          sensitive: true
        },
        Sg: {
          type: "structure",
          required: [
            "AddressLine1",
            "City",
            "CountryCode",
            "FullName",
            "PhoneNumber",
            "PostalCode"
          ],
          members: {
            AddressLine1: {
              shape: "Sh"
            },
            AddressLine2: {
              shape: "Sh"
            },
            AddressLine3: {
              shape: "Sh"
            },
            City: {
              type: "string",
              sensitive: true
            },
            CompanyName: {
              type: "string",
              sensitive: true
            },
            CountryCode: {
              type: "string",
              sensitive: true
            },
            DistrictOrCounty: {
              type: "string",
              sensitive: true
            },
            FullName: {
              type: "string",
              sensitive: true
            },
            PhoneNumber: {
              type: "string",
              sensitive: true
            },
            PostalCode: {
              type: "string",
              sensitive: true
            },
            StateOrRegion: {
              type: "string",
              sensitive: true
            },
            WebsiteUrl: {
              type: "string",
              sensitive: true
            }
          }
        },
        Sh: {
          type: "string",
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/account-2021-02-01.paginators.json
var require_account_2021_02_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/account-2021-02-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListRegions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Regions"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/account.js
var require_account = __commonJS({
  "node_modules/aws-sdk/clients/account.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["account"] = {};
    AWS2.Account = Service.defineService("account", ["2021-02-01"]);
    Object.defineProperty(apiLoader.services["account"], "2021-02-01", {
      get: function get() {
        var model = require_account_2021_02_01_min();
        model.paginators = require_account_2021_02_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Account;
  }
});

// node_modules/aws-sdk/apis/cloudcontrol-2021-09-30.min.json
var require_cloudcontrol_2021_09_30_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudcontrol-2021-09-30.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-09-30",
        endpointPrefix: "cloudcontrolapi",
        jsonVersion: "1.0",
        protocol: "json",
        serviceAbbreviation: "CloudControlApi",
        serviceFullName: "AWS Cloud Control API",
        serviceId: "CloudControl",
        signatureVersion: "v4",
        signingName: "cloudcontrolapi",
        targetPrefix: "CloudApiService",
        uid: "cloudcontrol-2021-09-30"
      },
      operations: {
        CancelResourceRequest: {
          input: {
            type: "structure",
            required: [
              "RequestToken"
            ],
            members: {
              RequestToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProgressEvent: {
                shape: "S4"
              }
            }
          },
          idempotent: true
        },
        CreateResource: {
          input: {
            type: "structure",
            required: [
              "TypeName",
              "DesiredState"
            ],
            members: {
              TypeName: {},
              TypeVersionId: {},
              RoleArn: {},
              ClientToken: {
                idempotencyToken: true
              },
              DesiredState: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProgressEvent: {
                shape: "S4"
              }
            }
          }
        },
        DeleteResource: {
          input: {
            type: "structure",
            required: [
              "TypeName",
              "Identifier"
            ],
            members: {
              TypeName: {},
              TypeVersionId: {},
              RoleArn: {},
              ClientToken: {
                idempotencyToken: true
              },
              Identifier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProgressEvent: {
                shape: "S4"
              }
            }
          }
        },
        GetResource: {
          input: {
            type: "structure",
            required: [
              "TypeName",
              "Identifier"
            ],
            members: {
              TypeName: {},
              TypeVersionId: {},
              RoleArn: {},
              Identifier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TypeName: {},
              ResourceDescription: {
                shape: "Sm"
              }
            }
          }
        },
        GetResourceRequestStatus: {
          input: {
            type: "structure",
            required: [
              "RequestToken"
            ],
            members: {
              RequestToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProgressEvent: {
                shape: "S4"
              }
            }
          }
        },
        ListResourceRequests: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              ResourceRequestStatusFilter: {
                type: "structure",
                members: {
                  Operations: {
                    type: "list",
                    member: {}
                  },
                  OperationStatuses: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceRequestStatusSummaries: {
                type: "list",
                member: {
                  shape: "S4"
                }
              },
              NextToken: {}
            }
          }
        },
        ListResources: {
          input: {
            type: "structure",
            required: [
              "TypeName"
            ],
            members: {
              TypeName: {},
              TypeVersionId: {},
              RoleArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ResourceModel: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TypeName: {},
              ResourceDescriptions: {
                type: "list",
                member: {
                  shape: "Sm"
                }
              },
              NextToken: {}
            }
          }
        },
        UpdateResource: {
          input: {
            type: "structure",
            required: [
              "TypeName",
              "Identifier",
              "PatchDocument"
            ],
            members: {
              TypeName: {},
              TypeVersionId: {},
              RoleArn: {},
              ClientToken: {
                idempotencyToken: true
              },
              Identifier: {},
              PatchDocument: {
                type: "string",
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProgressEvent: {
                shape: "S4"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            TypeName: {},
            Identifier: {},
            RequestToken: {},
            Operation: {},
            OperationStatus: {},
            EventTime: {
              type: "timestamp"
            },
            ResourceModel: {
              shape: "Sa"
            },
            StatusMessage: {},
            ErrorCode: {},
            RetryAfter: {
              type: "timestamp"
            }
          }
        },
        Sa: {
          type: "string",
          sensitive: true
        },
        Sm: {
          type: "structure",
          members: {
            Identifier: {},
            Properties: {
              shape: "Sa"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudcontrol-2021-09-30.paginators.json
var require_cloudcontrol_2021_09_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloudcontrol-2021-09-30.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListResourceRequests: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ResourceRequestStatusSummaries"
        },
        ListResources: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ResourceDescriptions"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudcontrol-2021-09-30.waiters2.json
var require_cloudcontrol_2021_09_30_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/cloudcontrol-2021-09-30.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        ResourceRequestSuccess: {
          description: "Wait until resource operation request is successful",
          delay: 5,
          maxAttempts: 24,
          operation: "GetResourceRequestStatus",
          acceptors: [{
            matcher: "path",
            argument: "ProgressEvent.OperationStatus",
            state: "success",
            expected: "SUCCESS"
          }, {
            matcher: "path",
            argument: "ProgressEvent.OperationStatus",
            state: "failure",
            expected: "FAILED"
          }, {
            matcher: "path",
            argument: "ProgressEvent.OperationStatus",
            state: "failure",
            expected: "CANCEL_COMPLETE"
          }]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/cloudcontrol.js
var require_cloudcontrol = __commonJS({
  "node_modules/aws-sdk/clients/cloudcontrol.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["cloudcontrol"] = {};
    AWS2.CloudControl = Service.defineService("cloudcontrol", ["2021-09-30"]);
    Object.defineProperty(apiLoader.services["cloudcontrol"], "2021-09-30", {
      get: function get() {
        var model = require_cloudcontrol_2021_09_30_min();
        model.paginators = require_cloudcontrol_2021_09_30_paginators().pagination;
        model.waiters = require_cloudcontrol_2021_09_30_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CloudControl;
  }
});

// node_modules/aws-sdk/apis/grafana-2020-08-18.min.json
var require_grafana_2020_08_18_min = __commonJS({
  "node_modules/aws-sdk/apis/grafana-2020-08-18.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-08-18",
        endpointPrefix: "grafana",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Managed Grafana",
        serviceId: "grafana",
        signatureVersion: "v4",
        signingName: "grafana",
        uid: "grafana-2020-08-18"
      },
      operations: {
        AssociateLicense: {
          http: {
            requestUri: "/workspaces/{workspaceId}/licenses/{licenseType}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "licenseType",
              "workspaceId"
            ],
            members: {
              licenseType: {
                location: "uri",
                locationName: "licenseType"
              },
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "workspace"
            ],
            members: {
              workspace: {
                shape: "S5"
              }
            }
          }
        },
        CreateWorkspace: {
          http: {
            requestUri: "/workspaces",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "accountAccessType",
              "authenticationProviders",
              "permissionType"
            ],
            members: {
              accountAccessType: {},
              authenticationProviders: {
                shape: "S8"
              },
              clientToken: {
                idempotencyToken: true
              },
              configuration: {
                jsonvalue: true
              },
              grafanaVersion: {},
              networkAccessControl: {
                shape: "Sj"
              },
              organizationRoleName: {
                shape: "Sq"
              },
              permissionType: {},
              stackSetName: {},
              tags: {
                shape: "Sw"
              },
              vpcConfiguration: {
                shape: "Sz"
              },
              workspaceDataSources: {
                shape: "Sc"
              },
              workspaceDescription: {
                shape: "Se"
              },
              workspaceName: {
                shape: "Si"
              },
              workspaceNotificationDestinations: {
                shape: "So"
              },
              workspaceOrganizationalUnits: {
                shape: "Sr"
              },
              workspaceRoleArn: {
                shape: "S14"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "workspace"
            ],
            members: {
              workspace: {
                shape: "S5"
              }
            }
          },
          idempotent: true
        },
        CreateWorkspaceApiKey: {
          http: {
            requestUri: "/workspaces/{workspaceId}/apikeys",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "keyName",
              "keyRole",
              "secondsToLive",
              "workspaceId"
            ],
            members: {
              keyName: {},
              keyRole: {},
              secondsToLive: {
                type: "integer"
              },
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "key",
              "keyName",
              "workspaceId"
            ],
            members: {
              key: {
                type: "string",
                sensitive: true
              },
              keyName: {},
              workspaceId: {}
            }
          }
        },
        DeleteWorkspace: {
          http: {
            method: "DELETE",
            requestUri: "/workspaces/{workspaceId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "workspace"
            ],
            members: {
              workspace: {
                shape: "S5"
              }
            }
          },
          idempotent: true
        },
        DeleteWorkspaceApiKey: {
          http: {
            method: "DELETE",
            requestUri: "/workspaces/{workspaceId}/apikeys/{keyName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "keyName",
              "workspaceId"
            ],
            members: {
              keyName: {
                location: "uri",
                locationName: "keyName"
              },
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "keyName",
              "workspaceId"
            ],
            members: {
              keyName: {},
              workspaceId: {}
            }
          }
        },
        DescribeWorkspace: {
          http: {
            method: "GET",
            requestUri: "/workspaces/{workspaceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "workspace"
            ],
            members: {
              workspace: {
                shape: "S5"
              }
            }
          }
        },
        DescribeWorkspaceAuthentication: {
          http: {
            method: "GET",
            requestUri: "/workspaces/{workspaceId}/authentication",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "authentication"
            ],
            members: {
              authentication: {
                shape: "S1n"
              }
            }
          }
        },
        DescribeWorkspaceConfiguration: {
          http: {
            method: "GET",
            requestUri: "/workspaces/{workspaceId}/configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "configuration"
            ],
            members: {
              configuration: {
                jsonvalue: true
              },
              grafanaVersion: {}
            }
          }
        },
        DisassociateLicense: {
          http: {
            method: "DELETE",
            requestUri: "/workspaces/{workspaceId}/licenses/{licenseType}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "licenseType",
              "workspaceId"
            ],
            members: {
              licenseType: {
                location: "uri",
                locationName: "licenseType"
              },
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "workspace"
            ],
            members: {
              workspace: {
                shape: "S5"
              }
            }
          }
        },
        ListPermissions: {
          http: {
            method: "GET",
            requestUri: "/workspaces/{workspaceId}/permissions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              groupId: {
                location: "querystring",
                locationName: "groupId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              userId: {
                location: "querystring",
                locationName: "userId"
              },
              userType: {
                location: "querystring",
                locationName: "userType"
              },
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "permissions"
            ],
            members: {
              nextToken: {},
              permissions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "role",
                    "user"
                  ],
                  members: {
                    role: {},
                    user: {
                      shape: "S2f"
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sw"
              }
            }
          }
        },
        ListVersions: {
          http: {
            method: "GET",
            requestUri: "/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              workspaceId: {
                location: "querystring",
                locationName: "workspace-id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              grafanaVersions: {
                type: "list",
                member: {}
              },
              nextToken: {}
            }
          }
        },
        ListWorkspaces: {
          http: {
            method: "GET",
            requestUri: "/workspaces",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "workspaces"
            ],
            members: {
              nextToken: {},
              workspaces: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "authentication",
                    "created",
                    "endpoint",
                    "grafanaVersion",
                    "id",
                    "modified",
                    "status"
                  ],
                  members: {
                    authentication: {
                      shape: "S7"
                    },
                    created: {
                      type: "timestamp"
                    },
                    description: {
                      shape: "Se"
                    },
                    endpoint: {},
                    grafanaVersion: {},
                    id: {},
                    modified: {
                      type: "timestamp"
                    },
                    name: {
                      shape: "Si"
                    },
                    notificationDestinations: {
                      shape: "So"
                    },
                    status: {},
                    tags: {
                      shape: "Sw"
                    }
                  }
                }
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sw"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdatePermissions: {
          http: {
            method: "PATCH",
            requestUri: "/workspaces/{workspaceId}/permissions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "updateInstructionBatch",
              "workspaceId"
            ],
            members: {
              updateInstructionBatch: {
                type: "list",
                member: {
                  shape: "S2y"
                }
              },
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "errors"
            ],
            members: {
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "causedBy",
                    "code",
                    "message"
                  ],
                  members: {
                    causedBy: {
                      shape: "S2y"
                    },
                    code: {
                      type: "integer"
                    },
                    message: {}
                  }
                }
              }
            }
          }
        },
        UpdateWorkspace: {
          http: {
            method: "PUT",
            requestUri: "/workspaces/{workspaceId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              accountAccessType: {},
              networkAccessControl: {
                shape: "Sj"
              },
              organizationRoleName: {
                shape: "Sq"
              },
              permissionType: {},
              removeNetworkAccessConfiguration: {
                type: "boolean"
              },
              removeVpcConfiguration: {
                type: "boolean"
              },
              stackSetName: {},
              vpcConfiguration: {
                shape: "Sz"
              },
              workspaceDataSources: {
                shape: "Sc"
              },
              workspaceDescription: {
                shape: "Se"
              },
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              workspaceName: {
                shape: "Si"
              },
              workspaceNotificationDestinations: {
                shape: "So"
              },
              workspaceOrganizationalUnits: {
                shape: "Sr"
              },
              workspaceRoleArn: {
                shape: "S14"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "workspace"
            ],
            members: {
              workspace: {
                shape: "S5"
              }
            }
          }
        },
        UpdateWorkspaceAuthentication: {
          http: {
            requestUri: "/workspaces/{workspaceId}/authentication",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "authenticationProviders",
              "workspaceId"
            ],
            members: {
              authenticationProviders: {
                shape: "S8"
              },
              samlConfiguration: {
                shape: "S1r"
              },
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "authentication"
            ],
            members: {
              authentication: {
                shape: "S1n"
              }
            }
          }
        },
        UpdateWorkspaceConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/workspaces/{workspaceId}/configuration",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "configuration",
              "workspaceId"
            ],
            members: {
              configuration: {
                jsonvalue: true
              },
              grafanaVersion: {},
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          required: [
            "authentication",
            "created",
            "dataSources",
            "endpoint",
            "grafanaVersion",
            "id",
            "modified",
            "status"
          ],
          members: {
            accountAccessType: {},
            authentication: {
              shape: "S7"
            },
            created: {
              type: "timestamp"
            },
            dataSources: {
              shape: "Sc"
            },
            description: {
              shape: "Se"
            },
            endpoint: {},
            freeTrialConsumed: {
              type: "boolean"
            },
            freeTrialExpiration: {
              type: "timestamp"
            },
            grafanaVersion: {},
            id: {},
            licenseExpiration: {
              type: "timestamp"
            },
            licenseType: {},
            modified: {
              type: "timestamp"
            },
            name: {
              shape: "Si"
            },
            networkAccessControl: {
              shape: "Sj"
            },
            notificationDestinations: {
              shape: "So"
            },
            organizationRoleName: {
              shape: "Sq"
            },
            organizationalUnits: {
              shape: "Sr"
            },
            permissionType: {},
            stackSetName: {},
            status: {},
            tags: {
              shape: "Sw"
            },
            vpcConfiguration: {
              shape: "Sz"
            },
            workspaceRoleArn: {
              shape: "S14"
            }
          }
        },
        S7: {
          type: "structure",
          required: [
            "providers"
          ],
          members: {
            providers: {
              shape: "S8"
            },
            samlConfigurationStatus: {}
          }
        },
        S8: {
          type: "list",
          member: {}
        },
        Sc: {
          type: "list",
          member: {}
        },
        Se: {
          type: "string",
          sensitive: true
        },
        Si: {
          type: "string",
          sensitive: true
        },
        Sj: {
          type: "structure",
          required: [
            "prefixListIds",
            "vpceIds"
          ],
          members: {
            prefixListIds: {
              type: "list",
              member: {}
            },
            vpceIds: {
              type: "list",
              member: {}
            }
          }
        },
        So: {
          type: "list",
          member: {}
        },
        Sq: {
          type: "string",
          sensitive: true
        },
        Sr: {
          type: "list",
          member: {},
          sensitive: true
        },
        Sw: {
          type: "map",
          key: {},
          value: {}
        },
        Sz: {
          type: "structure",
          required: [
            "securityGroupIds",
            "subnetIds"
          ],
          members: {
            securityGroupIds: {
              type: "list",
              member: {}
            },
            subnetIds: {
              type: "list",
              member: {}
            }
          }
        },
        S14: {
          type: "string",
          sensitive: true
        },
        S1n: {
          type: "structure",
          required: [
            "providers"
          ],
          members: {
            awsSso: {
              type: "structure",
              members: {
                ssoClientId: {}
              }
            },
            providers: {
              shape: "S8"
            },
            saml: {
              type: "structure",
              required: [
                "status"
              ],
              members: {
                configuration: {
                  shape: "S1r"
                },
                status: {}
              }
            }
          }
        },
        S1r: {
          type: "structure",
          required: [
            "idpMetadata"
          ],
          members: {
            allowedOrganizations: {
              type: "list",
              member: {}
            },
            assertionAttributes: {
              type: "structure",
              members: {
                email: {},
                groups: {},
                login: {},
                name: {},
                org: {},
                role: {}
              }
            },
            idpMetadata: {
              type: "structure",
              members: {
                url: {},
                xml: {}
              },
              union: true
            },
            loginValidityDuration: {
              type: "integer"
            },
            roleValues: {
              type: "structure",
              members: {
                admin: {
                  shape: "S20"
                },
                editor: {
                  shape: "S20"
                }
              }
            }
          }
        },
        S20: {
          type: "list",
          member: {},
          sensitive: true
        },
        S2f: {
          type: "structure",
          required: [
            "id",
            "type"
          ],
          members: {
            id: {},
            type: {}
          }
        },
        S2y: {
          type: "structure",
          required: [
            "action",
            "role",
            "users"
          ],
          members: {
            action: {},
            role: {},
            users: {
              type: "list",
              member: {
                shape: "S2f"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/grafana-2020-08-18.paginators.json
var require_grafana_2020_08_18_paginators = __commonJS({
  "node_modules/aws-sdk/apis/grafana-2020-08-18.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListPermissions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "permissions"
        },
        ListVersions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "grafanaVersions"
        },
        ListWorkspaces: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "workspaces"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/grafana.js
var require_grafana = __commonJS({
  "node_modules/aws-sdk/clients/grafana.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["grafana"] = {};
    AWS2.Grafana = Service.defineService("grafana", ["2020-08-18"]);
    Object.defineProperty(apiLoader.services["grafana"], "2020-08-18", {
      get: function get() {
        var model = require_grafana_2020_08_18_min();
        model.paginators = require_grafana_2020_08_18_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Grafana;
  }
});

// node_modules/aws-sdk/apis/panorama-2019-07-24.min.json
var require_panorama_2019_07_24_min = __commonJS({
  "node_modules/aws-sdk/apis/panorama-2019-07-24.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-07-24",
        endpointPrefix: "panorama",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Panorama",
        serviceFullName: "AWS Panorama",
        serviceId: "Panorama",
        signatureVersion: "v4",
        signingName: "panorama",
        uid: "panorama-2019-07-24"
      },
      operations: {
        CreateApplicationInstance: {
          http: {
            requestUri: "/application-instances",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DefaultRuntimeContextDevice",
              "ManifestPayload"
            ],
            members: {
              ApplicationInstanceIdToReplace: {},
              DefaultRuntimeContextDevice: {},
              Description: {},
              ManifestOverridesPayload: {
                shape: "S5"
              },
              ManifestPayload: {
                shape: "S7"
              },
              Name: {},
              RuntimeRoleArn: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ApplicationInstanceId"
            ],
            members: {
              ApplicationInstanceId: {}
            }
          }
        },
        CreateJobForDevices: {
          http: {
            requestUri: "/jobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DeviceIds",
              "JobType"
            ],
            members: {
              DeviceIds: {
                type: "list",
                member: {}
              },
              DeviceJobConfig: {
                type: "structure",
                members: {
                  OTAJobConfig: {
                    type: "structure",
                    required: [
                      "ImageVersion"
                    ],
                    members: {
                      AllowMajorVersionUpdate: {
                        type: "boolean"
                      },
                      ImageVersion: {}
                    }
                  }
                }
              },
              JobType: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Jobs"
            ],
            members: {
              Jobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DeviceId: {},
                    JobId: {}
                  }
                }
              }
            }
          }
        },
        CreateNodeFromTemplateJob: {
          http: {
            requestUri: "/packages/template-job",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "NodeName",
              "OutputPackageName",
              "OutputPackageVersion",
              "TemplateParameters",
              "TemplateType"
            ],
            members: {
              JobTags: {
                shape: "Ss"
              },
              NodeDescription: {},
              NodeName: {},
              OutputPackageName: {},
              OutputPackageVersion: {},
              TemplateParameters: {
                shape: "Sy"
              },
              TemplateType: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          }
        },
        CreatePackage: {
          http: {
            requestUri: "/packages",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "PackageName"
            ],
            members: {
              PackageName: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "StorageLocation"
            ],
            members: {
              Arn: {},
              PackageId: {},
              StorageLocation: {
                shape: "S17"
              }
            }
          }
        },
        CreatePackageImportJob: {
          http: {
            requestUri: "/packages/import-jobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ClientToken",
              "InputConfig",
              "JobType",
              "OutputConfig"
            ],
            members: {
              ClientToken: {},
              InputConfig: {
                shape: "S1c"
              },
              JobTags: {
                shape: "Ss"
              },
              JobType: {},
              OutputConfig: {
                shape: "S1j"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          }
        },
        DeleteDevice: {
          http: {
            method: "DELETE",
            requestUri: "/devices/{DeviceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DeviceId"
            ],
            members: {
              DeviceId: {
                location: "uri",
                locationName: "DeviceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeviceId: {}
            }
          }
        },
        DeletePackage: {
          http: {
            method: "DELETE",
            requestUri: "/packages/{PackageId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "PackageId"
            ],
            members: {
              ForceDelete: {
                location: "querystring",
                locationName: "ForceDelete",
                type: "boolean"
              },
              PackageId: {
                location: "uri",
                locationName: "PackageId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeregisterPackageVersion: {
          http: {
            method: "DELETE",
            requestUri: "/packages/{PackageId}/versions/{PackageVersion}/patch/{PatchVersion}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "PackageId",
              "PackageVersion",
              "PatchVersion"
            ],
            members: {
              OwnerAccount: {
                location: "querystring",
                locationName: "OwnerAccount"
              },
              PackageId: {
                location: "uri",
                locationName: "PackageId"
              },
              PackageVersion: {
                location: "uri",
                locationName: "PackageVersion"
              },
              PatchVersion: {
                location: "uri",
                locationName: "PatchVersion"
              },
              UpdatedLatestPatchVersion: {
                location: "querystring",
                locationName: "UpdatedLatestPatchVersion"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeApplicationInstance: {
          http: {
            method: "GET",
            requestUri: "/application-instances/{ApplicationInstanceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationInstanceId"
            ],
            members: {
              ApplicationInstanceId: {
                location: "uri",
                locationName: "ApplicationInstanceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationInstanceId: {},
              ApplicationInstanceIdToReplace: {},
              Arn: {},
              CreatedTime: {
                type: "timestamp"
              },
              DefaultRuntimeContextDevice: {},
              DefaultRuntimeContextDeviceName: {},
              Description: {},
              HealthStatus: {},
              LastUpdatedTime: {
                type: "timestamp"
              },
              Name: {},
              RuntimeContextStates: {
                shape: "S21"
              },
              RuntimeRoleArn: {},
              Status: {},
              StatusDescription: {},
              Tags: {
                shape: "Sb"
              }
            }
          }
        },
        DescribeApplicationInstanceDetails: {
          http: {
            method: "GET",
            requestUri: "/application-instances/{ApplicationInstanceId}/details",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationInstanceId"
            ],
            members: {
              ApplicationInstanceId: {
                location: "uri",
                locationName: "ApplicationInstanceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationInstanceId: {},
              ApplicationInstanceIdToReplace: {},
              CreatedTime: {
                type: "timestamp"
              },
              DefaultRuntimeContextDevice: {},
              Description: {},
              ManifestOverridesPayload: {
                shape: "S5"
              },
              ManifestPayload: {
                shape: "S7"
              },
              Name: {}
            }
          }
        },
        DescribeDevice: {
          http: {
            method: "GET",
            requestUri: "/devices/{DeviceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DeviceId"
            ],
            members: {
              DeviceId: {
                location: "uri",
                locationName: "DeviceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AlternateSoftwares: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Version: {}
                  }
                }
              },
              Arn: {},
              Brand: {},
              CreatedTime: {
                type: "timestamp"
              },
              CurrentNetworkingStatus: {
                type: "structure",
                members: {
                  Ethernet0Status: {
                    shape: "S2j"
                  },
                  Ethernet1Status: {
                    shape: "S2j"
                  },
                  LastUpdatedTime: {
                    type: "timestamp"
                  },
                  NtpStatus: {
                    type: "structure",
                    members: {
                      ConnectionStatus: {},
                      IpAddress: {},
                      NtpServerName: {}
                    }
                  }
                }
              },
              CurrentSoftware: {},
              Description: {},
              DeviceAggregatedStatus: {},
              DeviceConnectionStatus: {},
              DeviceId: {},
              LatestAlternateSoftware: {},
              LatestDeviceJob: {
                shape: "S2u"
              },
              LatestSoftware: {},
              LeaseExpirationTime: {
                type: "timestamp"
              },
              Name: {},
              NetworkingConfiguration: {
                shape: "S2y"
              },
              ProvisioningStatus: {},
              SerialNumber: {},
              Tags: {
                shape: "Sb"
              },
              Type: {}
            }
          }
        },
        DescribeDeviceJob: {
          http: {
            method: "GET",
            requestUri: "/jobs/{JobId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {
                location: "uri",
                locationName: "JobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CreatedTime: {
                type: "timestamp"
              },
              DeviceArn: {},
              DeviceId: {},
              DeviceName: {},
              DeviceType: {},
              ImageVersion: {},
              JobId: {},
              JobType: {},
              Status: {}
            }
          }
        },
        DescribeNode: {
          http: {
            method: "GET",
            requestUri: "/nodes/{NodeId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "NodeId"
            ],
            members: {
              NodeId: {
                location: "uri",
                locationName: "NodeId"
              },
              OwnerAccount: {
                location: "querystring",
                locationName: "OwnerAccount"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Category",
              "CreatedTime",
              "Description",
              "LastUpdatedTime",
              "Name",
              "NodeId",
              "NodeInterface",
              "OwnerAccount",
              "PackageId",
              "PackageName",
              "PackageVersion",
              "PatchVersion"
            ],
            members: {
              AssetName: {},
              Category: {},
              CreatedTime: {
                type: "timestamp"
              },
              Description: {},
              LastUpdatedTime: {
                type: "timestamp"
              },
              Name: {},
              NodeId: {},
              NodeInterface: {
                type: "structure",
                required: [
                  "Inputs",
                  "Outputs"
                ],
                members: {
                  Inputs: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        DefaultValue: {},
                        Description: {},
                        MaxConnections: {
                          type: "integer"
                        },
                        Name: {},
                        Type: {}
                      }
                    }
                  },
                  Outputs: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Description: {},
                        Name: {},
                        Type: {}
                      }
                    }
                  }
                }
              },
              OwnerAccount: {},
              PackageArn: {},
              PackageId: {},
              PackageName: {},
              PackageVersion: {},
              PatchVersion: {}
            }
          }
        },
        DescribeNodeFromTemplateJob: {
          http: {
            method: "GET",
            requestUri: "/packages/template-job/{JobId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {
                location: "uri",
                locationName: "JobId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CreatedTime",
              "JobId",
              "LastUpdatedTime",
              "NodeName",
              "OutputPackageName",
              "OutputPackageVersion",
              "Status",
              "StatusMessage",
              "TemplateParameters",
              "TemplateType"
            ],
            members: {
              CreatedTime: {
                type: "timestamp"
              },
              JobId: {},
              JobTags: {
                shape: "Ss"
              },
              LastUpdatedTime: {
                type: "timestamp"
              },
              NodeDescription: {},
              NodeName: {},
              OutputPackageName: {},
              OutputPackageVersion: {},
              Status: {},
              StatusMessage: {},
              TemplateParameters: {
                shape: "Sy"
              },
              TemplateType: {}
            }
          }
        },
        DescribePackage: {
          http: {
            method: "GET",
            requestUri: "/packages/metadata/{PackageId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "PackageId"
            ],
            members: {
              PackageId: {
                location: "uri",
                locationName: "PackageId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Arn",
              "CreatedTime",
              "PackageId",
              "PackageName",
              "StorageLocation",
              "Tags"
            ],
            members: {
              Arn: {},
              CreatedTime: {
                type: "timestamp"
              },
              PackageId: {},
              PackageName: {},
              ReadAccessPrincipalArns: {
                shape: "S3z"
              },
              StorageLocation: {
                shape: "S17"
              },
              Tags: {
                shape: "Sb"
              },
              WriteAccessPrincipalArns: {
                shape: "S3z"
              }
            }
          }
        },
        DescribePackageImportJob: {
          http: {
            method: "GET",
            requestUri: "/packages/import-jobs/{JobId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {
                location: "uri",
                locationName: "JobId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CreatedTime",
              "InputConfig",
              "JobId",
              "JobType",
              "LastUpdatedTime",
              "Output",
              "OutputConfig",
              "Status",
              "StatusMessage"
            ],
            members: {
              ClientToken: {},
              CreatedTime: {
                type: "timestamp"
              },
              InputConfig: {
                shape: "S1c"
              },
              JobId: {},
              JobTags: {
                shape: "Ss"
              },
              JobType: {},
              LastUpdatedTime: {
                type: "timestamp"
              },
              Output: {
                type: "structure",
                required: [
                  "OutputS3Location",
                  "PackageId",
                  "PackageVersion",
                  "PatchVersion"
                ],
                members: {
                  OutputS3Location: {
                    type: "structure",
                    required: [
                      "BucketName",
                      "ObjectKey"
                    ],
                    members: {
                      BucketName: {},
                      ObjectKey: {}
                    }
                  },
                  PackageId: {},
                  PackageVersion: {},
                  PatchVersion: {}
                }
              },
              OutputConfig: {
                shape: "S1j"
              },
              Status: {},
              StatusMessage: {}
            }
          }
        },
        DescribePackageVersion: {
          http: {
            method: "GET",
            requestUri: "/packages/metadata/{PackageId}/versions/{PackageVersion}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "PackageId",
              "PackageVersion"
            ],
            members: {
              OwnerAccount: {
                location: "querystring",
                locationName: "OwnerAccount"
              },
              PackageId: {
                location: "uri",
                locationName: "PackageId"
              },
              PackageVersion: {
                location: "uri",
                locationName: "PackageVersion"
              },
              PatchVersion: {
                location: "querystring",
                locationName: "PatchVersion"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "IsLatestPatch",
              "PackageId",
              "PackageName",
              "PackageVersion",
              "PatchVersion",
              "Status"
            ],
            members: {
              IsLatestPatch: {
                type: "boolean"
              },
              OwnerAccount: {},
              PackageArn: {},
              PackageId: {},
              PackageName: {},
              PackageVersion: {},
              PatchVersion: {},
              RegisteredTime: {
                type: "timestamp"
              },
              Status: {},
              StatusDescription: {}
            }
          }
        },
        ListApplicationInstanceDependencies: {
          http: {
            method: "GET",
            requestUri: "/application-instances/{ApplicationInstanceId}/package-dependencies",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationInstanceId"
            ],
            members: {
              ApplicationInstanceId: {
                location: "uri",
                locationName: "ApplicationInstanceId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              PackageObjects: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "PackageVersion",
                    "PatchVersion"
                  ],
                  members: {
                    Name: {},
                    PackageVersion: {},
                    PatchVersion: {}
                  }
                }
              }
            }
          }
        },
        ListApplicationInstanceNodeInstances: {
          http: {
            method: "GET",
            requestUri: "/application-instances/{ApplicationInstanceId}/node-instances",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationInstanceId"
            ],
            members: {
              ApplicationInstanceId: {
                location: "uri",
                locationName: "ApplicationInstanceId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              NodeInstances: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "CurrentStatus",
                    "NodeInstanceId"
                  ],
                  members: {
                    CurrentStatus: {},
                    NodeId: {},
                    NodeInstanceId: {},
                    NodeName: {},
                    PackageName: {},
                    PackagePatchVersion: {},
                    PackageVersion: {}
                  }
                }
              }
            }
          }
        },
        ListApplicationInstances: {
          http: {
            method: "GET",
            requestUri: "/application-instances",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeviceId: {
                location: "querystring",
                locationName: "deviceId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              StatusFilter: {
                location: "querystring",
                locationName: "statusFilter"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationInstances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApplicationInstanceId: {},
                    Arn: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    DefaultRuntimeContextDevice: {},
                    DefaultRuntimeContextDeviceName: {},
                    Description: {},
                    HealthStatus: {},
                    Name: {},
                    RuntimeContextStates: {
                      shape: "S21"
                    },
                    Status: {},
                    StatusDescription: {},
                    Tags: {
                      shape: "Sb"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDevices: {
          http: {
            method: "GET",
            requestUri: "/devices",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeviceAggregatedStatusFilter: {
                location: "querystring",
                locationName: "DeviceAggregatedStatusFilter"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NameFilter: {
                location: "querystring",
                locationName: "NameFilter"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              SortBy: {
                location: "querystring",
                locationName: "SortBy"
              },
              SortOrder: {
                location: "querystring",
                locationName: "SortOrder"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Devices"
            ],
            members: {
              Devices: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Brand: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    CurrentSoftware: {},
                    Description: {},
                    DeviceAggregatedStatus: {},
                    DeviceId: {},
                    LastUpdatedTime: {
                      type: "timestamp"
                    },
                    LatestDeviceJob: {
                      shape: "S2u"
                    },
                    LeaseExpirationTime: {
                      type: "timestamp"
                    },
                    Name: {},
                    ProvisioningStatus: {},
                    Tags: {
                      shape: "Sb"
                    },
                    Type: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDevicesJobs: {
          http: {
            method: "GET",
            requestUri: "/jobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeviceId: {
                location: "querystring",
                locationName: "DeviceId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeviceJobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreatedTime: {
                      type: "timestamp"
                    },
                    DeviceId: {},
                    DeviceName: {},
                    JobId: {},
                    JobType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListNodeFromTemplateJobs: {
          http: {
            method: "GET",
            requestUri: "/packages/template-job",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "NodeFromTemplateJobs"
            ],
            members: {
              NextToken: {},
              NodeFromTemplateJobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreatedTime: {
                      type: "timestamp"
                    },
                    JobId: {},
                    NodeName: {},
                    Status: {},
                    StatusMessage: {},
                    TemplateType: {}
                  }
                }
              }
            }
          }
        },
        ListNodes: {
          http: {
            method: "GET",
            requestUri: "/nodes",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Category: {
                location: "querystring",
                locationName: "category"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              OwnerAccount: {
                location: "querystring",
                locationName: "ownerAccount"
              },
              PackageName: {
                location: "querystring",
                locationName: "packageName"
              },
              PackageVersion: {
                location: "querystring",
                locationName: "packageVersion"
              },
              PatchVersion: {
                location: "querystring",
                locationName: "patchVersion"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Nodes: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Category",
                    "CreatedTime",
                    "Name",
                    "NodeId",
                    "PackageId",
                    "PackageName",
                    "PackageVersion",
                    "PatchVersion"
                  ],
                  members: {
                    Category: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    Description: {},
                    Name: {},
                    NodeId: {},
                    OwnerAccount: {},
                    PackageArn: {},
                    PackageId: {},
                    PackageName: {},
                    PackageVersion: {},
                    PatchVersion: {}
                  }
                }
              }
            }
          }
        },
        ListPackageImportJobs: {
          http: {
            method: "GET",
            requestUri: "/packages/import-jobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "PackageImportJobs"
            ],
            members: {
              NextToken: {},
              PackageImportJobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreatedTime: {
                      type: "timestamp"
                    },
                    JobId: {},
                    JobType: {},
                    LastUpdatedTime: {
                      type: "timestamp"
                    },
                    Status: {},
                    StatusMessage: {}
                  }
                }
              }
            }
          }
        },
        ListPackages: {
          http: {
            method: "GET",
            requestUri: "/packages",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Packages: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    PackageId: {},
                    PackageName: {},
                    Tags: {
                      shape: "Sb"
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sb"
              }
            }
          }
        },
        ProvisionDevice: {
          http: {
            requestUri: "/devices",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Description: {},
              Name: {},
              NetworkingConfiguration: {
                shape: "S2y"
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Arn",
              "Status"
            ],
            members: {
              Arn: {},
              Certificates: {
                type: "blob"
              },
              DeviceId: {},
              IotThingName: {},
              Status: {}
            }
          }
        },
        RegisterPackageVersion: {
          http: {
            method: "PUT",
            requestUri: "/packages/{PackageId}/versions/{PackageVersion}/patch/{PatchVersion}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "PackageId",
              "PackageVersion",
              "PatchVersion"
            ],
            members: {
              MarkLatest: {
                type: "boolean"
              },
              OwnerAccount: {},
              PackageId: {
                location: "uri",
                locationName: "PackageId"
              },
              PackageVersion: {
                location: "uri",
                locationName: "PackageVersion"
              },
              PatchVersion: {
                location: "uri",
                locationName: "PatchVersion"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RemoveApplicationInstance: {
          http: {
            method: "DELETE",
            requestUri: "/application-instances/{ApplicationInstanceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationInstanceId"
            ],
            members: {
              ApplicationInstanceId: {
                location: "uri",
                locationName: "ApplicationInstanceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SignalApplicationInstanceNodeInstances: {
          http: {
            method: "PUT",
            requestUri: "/application-instances/{ApplicationInstanceId}/node-signals",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationInstanceId",
              "NodeSignals"
            ],
            members: {
              ApplicationInstanceId: {
                location: "uri",
                locationName: "ApplicationInstanceId"
              },
              NodeSignals: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "NodeInstanceId",
                    "Signal"
                  ],
                  members: {
                    NodeInstanceId: {},
                    Signal: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ApplicationInstanceId"
            ],
            members: {
              ApplicationInstanceId: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDeviceMetadata: {
          http: {
            method: "PUT",
            requestUri: "/devices/{DeviceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DeviceId"
            ],
            members: {
              Description: {},
              DeviceId: {
                location: "uri",
                locationName: "DeviceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeviceId: {}
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          members: {
            PayloadData: {}
          },
          union: true
        },
        S7: {
          type: "structure",
          members: {
            PayloadData: {}
          },
          union: true
        },
        Sb: {
          type: "map",
          key: {},
          value: {}
        },
        Ss: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ResourceType",
              "Tags"
            ],
            members: {
              ResourceType: {},
              Tags: {
                shape: "Sb"
              }
            }
          }
        },
        Sy: {
          type: "map",
          key: {},
          value: {
            type: "string",
            sensitive: true
          }
        },
        S17: {
          type: "structure",
          required: [
            "BinaryPrefixLocation",
            "Bucket",
            "GeneratedPrefixLocation",
            "ManifestPrefixLocation",
            "RepoPrefixLocation"
          ],
          members: {
            BinaryPrefixLocation: {},
            Bucket: {},
            GeneratedPrefixLocation: {},
            ManifestPrefixLocation: {},
            RepoPrefixLocation: {}
          }
        },
        S1c: {
          type: "structure",
          members: {
            PackageVersionInputConfig: {
              type: "structure",
              required: [
                "S3Location"
              ],
              members: {
                S3Location: {
                  type: "structure",
                  required: [
                    "BucketName",
                    "ObjectKey"
                  ],
                  members: {
                    BucketName: {},
                    ObjectKey: {},
                    Region: {}
                  }
                }
              }
            }
          }
        },
        S1j: {
          type: "structure",
          members: {
            PackageVersionOutputConfig: {
              type: "structure",
              required: [
                "PackageName",
                "PackageVersion"
              ],
              members: {
                MarkLatest: {
                  type: "boolean"
                },
                PackageName: {},
                PackageVersion: {}
              }
            }
          }
        },
        S21: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "DesiredState",
              "DeviceReportedStatus",
              "DeviceReportedTime",
              "RuntimeContextName"
            ],
            members: {
              DesiredState: {},
              DeviceReportedStatus: {},
              DeviceReportedTime: {
                type: "timestamp"
              },
              RuntimeContextName: {}
            }
          }
        },
        S2j: {
          type: "structure",
          members: {
            ConnectionStatus: {},
            HwAddress: {},
            IpAddress: {}
          }
        },
        S2u: {
          type: "structure",
          members: {
            ImageVersion: {},
            JobType: {},
            Status: {}
          }
        },
        S2y: {
          type: "structure",
          members: {
            Ethernet0: {
              shape: "S2z"
            },
            Ethernet1: {
              shape: "S2z"
            },
            Ntp: {
              type: "structure",
              required: [
                "NtpServers"
              ],
              members: {
                NtpServers: {
                  type: "list",
                  member: {}
                }
              }
            }
          }
        },
        S2z: {
          type: "structure",
          required: [
            "ConnectionType"
          ],
          members: {
            ConnectionType: {},
            StaticIpConnectionInfo: {
              type: "structure",
              required: [
                "DefaultGateway",
                "Dns",
                "IpAddress",
                "Mask"
              ],
              members: {
                DefaultGateway: {},
                Dns: {
                  type: "list",
                  member: {}
                },
                IpAddress: {},
                Mask: {}
              }
            }
          }
        },
        S3z: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/panorama-2019-07-24.paginators.json
var require_panorama_2019_07_24_paginators = __commonJS({
  "node_modules/aws-sdk/apis/panorama-2019-07-24.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListApplicationInstanceDependencies: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListApplicationInstanceNodeInstances: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListApplicationInstances: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDevices: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDevicesJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListNodeFromTemplateJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListNodes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListPackageImportJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListPackages: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/panorama.js
var require_panorama = __commonJS({
  "node_modules/aws-sdk/clients/panorama.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["panorama"] = {};
    AWS2.Panorama = Service.defineService("panorama", ["2019-07-24"]);
    Object.defineProperty(apiLoader.services["panorama"], "2019-07-24", {
      get: function get() {
        var model = require_panorama_2019_07_24_min();
        model.paginators = require_panorama_2019_07_24_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Panorama;
  }
});

// node_modules/aws-sdk/apis/chime-sdk-meetings-2021-07-15.min.json
var require_chime_sdk_meetings_2021_07_15_min = __commonJS({
  "node_modules/aws-sdk/apis/chime-sdk-meetings-2021-07-15.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-07-15",
        endpointPrefix: "meetings-chime",
        protocol: "rest-json",
        serviceFullName: "Amazon Chime SDK Meetings",
        serviceId: "Chime SDK Meetings",
        signatureVersion: "v4",
        signingName: "chime",
        uid: "chime-sdk-meetings-2021-07-15"
      },
      operations: {
        BatchCreateAttendee: {
          http: {
            requestUri: "/meetings/{MeetingId}/attendees?operation=batch-create"
          },
          input: {
            type: "structure",
            required: [
              "MeetingId",
              "Attendees"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "MeetingId"
              },
              Attendees: {
                type: "list",
                member: {
                  shape: "S4"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attendees: {
                shape: "S9"
              },
              Errors: {
                shape: "Sc"
              }
            }
          }
        },
        BatchUpdateAttendeeCapabilitiesExcept: {
          http: {
            method: "PUT",
            requestUri: "/meetings/{MeetingId}/attendees/capabilities?operation=batch-update-except",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MeetingId",
              "ExcludedAttendeeIds",
              "Capabilities"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "MeetingId"
              },
              ExcludedAttendeeIds: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AttendeeId"
                  ],
                  members: {
                    AttendeeId: {}
                  }
                }
              },
              Capabilities: {
                shape: "S6"
              }
            }
          }
        },
        CreateAttendee: {
          http: {
            requestUri: "/meetings/{MeetingId}/attendees"
          },
          input: {
            type: "structure",
            required: [
              "MeetingId",
              "ExternalUserId"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "MeetingId"
              },
              ExternalUserId: {
                shape: "S5"
              },
              Capabilities: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attendee: {
                shape: "Sa"
              }
            }
          }
        },
        CreateMeeting: {
          http: {
            requestUri: "/meetings"
          },
          input: {
            type: "structure",
            required: [
              "ClientRequestToken",
              "MediaRegion",
              "ExternalMeetingId"
            ],
            members: {
              ClientRequestToken: {
                shape: "Sl",
                idempotencyToken: true
              },
              MediaRegion: {},
              MeetingHostId: {
                shape: "S5"
              },
              ExternalMeetingId: {
                shape: "Sn"
              },
              NotificationsConfiguration: {
                shape: "So"
              },
              MeetingFeatures: {
                shape: "Sq"
              },
              PrimaryMeetingId: {},
              TenantIds: {
                shape: "S10"
              },
              Tags: {
                shape: "S12"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Meeting: {
                shape: "S17"
              }
            }
          }
        },
        CreateMeetingWithAttendees: {
          http: {
            requestUri: "/meetings?operation=create-attendees"
          },
          input: {
            type: "structure",
            required: [
              "ClientRequestToken",
              "MediaRegion",
              "ExternalMeetingId",
              "Attendees"
            ],
            members: {
              ClientRequestToken: {
                shape: "Sl",
                idempotencyToken: true
              },
              MediaRegion: {},
              MeetingHostId: {
                shape: "S5"
              },
              ExternalMeetingId: {
                shape: "Sn"
              },
              MeetingFeatures: {
                shape: "Sq"
              },
              NotificationsConfiguration: {
                shape: "So"
              },
              Attendees: {
                type: "list",
                member: {
                  shape: "S4"
                }
              },
              PrimaryMeetingId: {},
              TenantIds: {
                shape: "S10"
              },
              Tags: {
                shape: "S12"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Meeting: {
                shape: "S17"
              },
              Attendees: {
                shape: "S9"
              },
              Errors: {
                shape: "Sc"
              }
            }
          }
        },
        DeleteAttendee: {
          http: {
            method: "DELETE",
            requestUri: "/meetings/{MeetingId}/attendees/{AttendeeId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "MeetingId",
              "AttendeeId"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "MeetingId"
              },
              AttendeeId: {
                location: "uri",
                locationName: "AttendeeId"
              }
            }
          }
        },
        DeleteMeeting: {
          http: {
            method: "DELETE",
            requestUri: "/meetings/{MeetingId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "MeetingId"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "MeetingId"
              }
            }
          }
        },
        GetAttendee: {
          http: {
            method: "GET",
            requestUri: "/meetings/{MeetingId}/attendees/{AttendeeId}"
          },
          input: {
            type: "structure",
            required: [
              "MeetingId",
              "AttendeeId"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "MeetingId"
              },
              AttendeeId: {
                location: "uri",
                locationName: "AttendeeId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attendee: {
                shape: "Sa"
              }
            }
          }
        },
        GetMeeting: {
          http: {
            method: "GET",
            requestUri: "/meetings/{MeetingId}"
          },
          input: {
            type: "structure",
            required: [
              "MeetingId"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "MeetingId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Meeting: {
                shape: "S17"
              }
            }
          }
        },
        ListAttendees: {
          http: {
            method: "GET",
            requestUri: "/meetings/{MeetingId}/attendees",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MeetingId"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "MeetingId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attendees: {
                shape: "S9"
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {
                location: "querystring",
                locationName: "arn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S12"
              }
            }
          }
        },
        StartMeetingTranscription: {
          http: {
            requestUri: "/meetings/{MeetingId}/transcription?operation=start",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MeetingId",
              "TranscriptionConfiguration"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "MeetingId"
              },
              TranscriptionConfiguration: {
                type: "structure",
                members: {
                  EngineTranscribeSettings: {
                    type: "structure",
                    members: {
                      LanguageCode: {},
                      VocabularyFilterMethod: {},
                      VocabularyFilterName: {},
                      VocabularyName: {},
                      Region: {},
                      EnablePartialResultsStabilization: {
                        type: "boolean"
                      },
                      PartialResultsStability: {},
                      ContentIdentificationType: {},
                      ContentRedactionType: {},
                      PiiEntityTypes: {},
                      LanguageModelName: {},
                      IdentifyLanguage: {
                        type: "boolean"
                      },
                      LanguageOptions: {},
                      PreferredLanguage: {},
                      VocabularyNames: {},
                      VocabularyFilterNames: {}
                    }
                  },
                  EngineTranscribeMedicalSettings: {
                    type: "structure",
                    required: [
                      "LanguageCode",
                      "Specialty",
                      "Type"
                    ],
                    members: {
                      LanguageCode: {},
                      Specialty: {},
                      Type: {},
                      VocabularyName: {},
                      Region: {},
                      ContentIdentificationType: {}
                    }
                  }
                }
              }
            }
          }
        },
        StopMeetingTranscription: {
          http: {
            requestUri: "/meetings/{MeetingId}/transcription?operation=stop",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MeetingId"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "MeetingId"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags?operation=tag-resource",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S12"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            requestUri: "/tags?operation=untag-resource",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAttendeeCapabilities: {
          http: {
            method: "PUT",
            requestUri: "/meetings/{MeetingId}/attendees/{AttendeeId}/capabilities"
          },
          input: {
            type: "structure",
            required: [
              "MeetingId",
              "AttendeeId",
              "Capabilities"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "MeetingId"
              },
              AttendeeId: {
                location: "uri",
                locationName: "AttendeeId"
              },
              Capabilities: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attendee: {
                shape: "Sa"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          required: [
            "ExternalUserId"
          ],
          members: {
            ExternalUserId: {
              shape: "S5"
            },
            Capabilities: {
              shape: "S6"
            }
          }
        },
        S5: {
          type: "string",
          sensitive: true
        },
        S6: {
          type: "structure",
          required: [
            "Audio",
            "Video",
            "Content"
          ],
          members: {
            Audio: {},
            Video: {},
            Content: {}
          }
        },
        S9: {
          type: "list",
          member: {
            shape: "Sa"
          }
        },
        Sa: {
          type: "structure",
          members: {
            ExternalUserId: {
              shape: "S5"
            },
            AttendeeId: {},
            JoinToken: {
              type: "string",
              sensitive: true
            },
            Capabilities: {
              shape: "S6"
            }
          }
        },
        Sc: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ExternalUserId: {
                shape: "S5"
              },
              ErrorCode: {},
              ErrorMessage: {}
            }
          }
        },
        Sl: {
          type: "string",
          sensitive: true
        },
        Sn: {
          type: "string",
          sensitive: true
        },
        So: {
          type: "structure",
          members: {
            LambdaFunctionArn: {
              shape: "Sp"
            },
            SnsTopicArn: {
              shape: "Sp"
            },
            SqsQueueArn: {
              shape: "Sp"
            }
          }
        },
        Sp: {
          type: "string",
          sensitive: true
        },
        Sq: {
          type: "structure",
          members: {
            Audio: {
              type: "structure",
              members: {
                EchoReduction: {}
              }
            },
            Video: {
              type: "structure",
              members: {
                MaxResolution: {}
              }
            },
            Content: {
              type: "structure",
              members: {
                MaxResolution: {}
              }
            },
            Attendee: {
              type: "structure",
              members: {
                MaxCount: {
                  type: "integer"
                }
              }
            }
          }
        },
        S10: {
          type: "list",
          member: {}
        },
        S12: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S17: {
          type: "structure",
          members: {
            MeetingId: {},
            MeetingHostId: {
              shape: "S5"
            },
            ExternalMeetingId: {
              shape: "Sn"
            },
            MediaRegion: {},
            MediaPlacement: {
              type: "structure",
              members: {
                AudioHostUrl: {},
                AudioFallbackUrl: {},
                SignalingUrl: {},
                TurnControlUrl: {},
                ScreenDataUrl: {},
                ScreenViewingUrl: {},
                ScreenSharingUrl: {},
                EventIngestionUrl: {}
              }
            },
            MeetingFeatures: {
              shape: "Sq"
            },
            PrimaryMeetingId: {},
            TenantIds: {
              shape: "S10"
            },
            MeetingArn: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/chime-sdk-meetings-2021-07-15.paginators.json
var require_chime_sdk_meetings_2021_07_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/chime-sdk-meetings-2021-07-15.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAttendees: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/chimesdkmeetings.js
var require_chimesdkmeetings = __commonJS({
  "node_modules/aws-sdk/clients/chimesdkmeetings.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["chimesdkmeetings"] = {};
    AWS2.ChimeSDKMeetings = Service.defineService("chimesdkmeetings", ["2021-07-15"]);
    Object.defineProperty(apiLoader.services["chimesdkmeetings"], "2021-07-15", {
      get: function get() {
        var model = require_chime_sdk_meetings_2021_07_15_min();
        model.paginators = require_chime_sdk_meetings_2021_07_15_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ChimeSDKMeetings;
  }
});

// node_modules/aws-sdk/apis/resiliencehub-2020-04-30.min.json
var require_resiliencehub_2020_04_30_min = __commonJS({
  "node_modules/aws-sdk/apis/resiliencehub-2020-04-30.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-04-30",
        endpointPrefix: "resiliencehub",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Resilience Hub",
        serviceId: "resiliencehub",
        signatureVersion: "v4",
        signingName: "resiliencehub",
        uid: "resiliencehub-2020-04-30"
      },
      operations: {
        AddDraftAppVersionResourceMappings: {
          http: {
            requestUri: "/add-draft-app-version-resource-mappings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appArn",
              "resourceMappings"
            ],
            members: {
              appArn: {},
              resourceMappings: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "appArn",
              "appVersion",
              "resourceMappings"
            ],
            members: {
              appArn: {},
              appVersion: {},
              resourceMappings: {
                shape: "S3"
              }
            }
          }
        },
        BatchUpdateRecommendationStatus: {
          http: {
            requestUri: "/batch-update-recommendation-status",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appArn",
              "requestEntries"
            ],
            members: {
              appArn: {},
              requestEntries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "entryId",
                    "excluded",
                    "item",
                    "referenceId"
                  ],
                  members: {
                    entryId: {},
                    excludeReason: {},
                    excluded: {
                      type: "boolean"
                    },
                    item: {
                      shape: "Sj"
                    },
                    referenceId: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "appArn",
              "failedEntries",
              "successfulEntries"
            ],
            members: {
              appArn: {},
              failedEntries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "entryId",
                    "errorMessage"
                  ],
                  members: {
                    entryId: {},
                    errorMessage: {}
                  }
                }
              },
              successfulEntries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "entryId",
                    "excluded",
                    "item",
                    "referenceId"
                  ],
                  members: {
                    entryId: {},
                    excludeReason: {},
                    excluded: {
                      type: "boolean"
                    },
                    item: {
                      shape: "Sj"
                    },
                    referenceId: {}
                  }
                }
              }
            }
          }
        },
        CreateApp: {
          http: {
            requestUri: "/create-app",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              assessmentSchedule: {},
              clientToken: {
                idempotencyToken: true
              },
              description: {},
              eventSubscriptions: {
                shape: "Sw"
              },
              name: {},
              permissionModel: {
                shape: "Sz"
              },
              policyArn: {},
              tags: {
                shape: "S14"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "app"
            ],
            members: {
              app: {
                shape: "S18"
              }
            }
          }
        },
        CreateAppVersionAppComponent: {
          http: {
            requestUri: "/create-app-version-app-component",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appArn",
              "name",
              "type"
            ],
            members: {
              additionalInfo: {
                shape: "S1g"
              },
              appArn: {},
              clientToken: {
                idempotencyToken: true
              },
              id: {},
              name: {},
              type: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "appArn",
              "appVersion"
            ],
            members: {
              appArn: {},
              appComponent: {
                shape: "S1l"
              },
              appVersion: {}
            }
          }
        },
        CreateAppVersionResource: {
          http: {
            requestUri: "/create-app-version-resource",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appArn",
              "appComponents",
              "logicalResourceId",
              "physicalResourceId",
              "resourceType"
            ],
            members: {
              additionalInfo: {
                shape: "S1g"
              },
              appArn: {},
              appComponents: {
                shape: "S1n"
              },
              awsAccountId: {},
              awsRegion: {},
              clientToken: {
                idempotencyToken: true
              },
              logicalResourceId: {
                shape: "S1o"
              },
              physicalResourceId: {},
              resourceName: {},
              resourceType: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "appArn",
              "appVersion"
            ],
            members: {
              appArn: {},
              appVersion: {},
              physicalResource: {
                shape: "S1r"
              }
            }
          }
        },
        CreateRecommendationTemplate: {
          http: {
            requestUri: "/create-recommendation-template",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assessmentArn",
              "name"
            ],
            members: {
              assessmentArn: {},
              bucketName: {},
              clientToken: {
                idempotencyToken: true
              },
              format: {},
              name: {},
              recommendationIds: {
                shape: "S1w"
              },
              recommendationTypes: {
                shape: "S1y"
              },
              tags: {
                shape: "S14"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              recommendationTemplate: {
                shape: "S21"
              }
            }
          }
        },
        CreateResiliencyPolicy: {
          http: {
            requestUri: "/create-resiliency-policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "policy",
              "policyName",
              "tier"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              dataLocationConstraint: {},
              policy: {
                shape: "S26"
              },
              policyDescription: {},
              policyName: {},
              tags: {
                shape: "S14"
              },
              tier: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "policy"
            ],
            members: {
              policy: {
                shape: "S2c"
              }
            }
          }
        },
        DeleteApp: {
          http: {
            requestUri: "/delete-app",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appArn"
            ],
            members: {
              appArn: {},
              clientToken: {
                idempotencyToken: true
              },
              forceDelete: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "appArn"
            ],
            members: {
              appArn: {}
            }
          }
        },
        DeleteAppAssessment: {
          http: {
            requestUri: "/delete-app-assessment",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assessmentArn"
            ],
            members: {
              assessmentArn: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assessmentArn",
              "assessmentStatus"
            ],
            members: {
              assessmentArn: {},
              assessmentStatus: {}
            }
          }
        },
        DeleteAppInputSource: {
          http: {
            requestUri: "/delete-app-input-source",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appArn"
            ],
            members: {
              appArn: {},
              clientToken: {
                idempotencyToken: true
              },
              eksSourceClusterNamespace: {
                shape: "S2k"
              },
              sourceArn: {},
              terraformSource: {
                shape: "S2m"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              appArn: {},
              appInputSource: {
                shape: "S2p"
              }
            }
          }
        },
        DeleteAppVersionAppComponent: {
          http: {
            requestUri: "/delete-app-version-app-component",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appArn",
              "id"
            ],
            members: {
              appArn: {},
              clientToken: {
                idempotencyToken: true
              },
              id: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "appArn",
              "appVersion"
            ],
            members: {
              appArn: {},
              appComponent: {
                shape: "S1l"
              },
              appVersion: {}
            }
          }
        },
        DeleteAppVersionResource: {
          http: {
            requestUri: "/delete-app-version-resource",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appArn"
            ],
            members: {
              appArn: {},
              awsAccountId: {},
              awsRegion: {},
              clientToken: {
                idempotencyToken: true
              },
              logicalResourceId: {
                shape: "S1o"
              },
              physicalResourceId: {},
              resourceName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "appArn",
              "appVersion"
            ],
            members: {
              appArn: {},
              appVersion: {},
              physicalResource: {
                shape: "S1r"
              }
            }
          }
        },
        DeleteRecommendationTemplate: {
          http: {
            requestUri: "/delete-recommendation-template",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "recommendationTemplateArn"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              recommendationTemplateArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "recommendationTemplateArn",
              "status"
            ],
            members: {
              recommendationTemplateArn: {},
              status: {}
            }
          }
        },
        DeleteResiliencyPolicy: {
          http: {
            requestUri: "/delete-resiliency-policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "policyArn"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              policyArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "policyArn"
            ],
            members: {
              policyArn: {}
            }
          }
        },
        DescribeApp: {
          http: {
            requestUri: "/describe-app",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appArn"
            ],
            members: {
              appArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "app"
            ],
            members: {
              app: {
                shape: "S18"
              }
            }
          }
        },
        DescribeAppAssessment: {
          http: {
            requestUri: "/describe-app-assessment",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assessmentArn"
            ],
            members: {
              assessmentArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "assessment"
            ],
            members: {
              assessment: {
                shape: "S33"
              }
            }
          }
        },
        DescribeAppVersion: {
          http: {
            requestUri: "/describe-app-version",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appArn",
              "appVersion"
            ],
            members: {
              appArn: {},
              appVersion: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "appArn",
              "appVersion"
            ],
            members: {
              additionalInfo: {
                shape: "S1g"
              },
              appArn: {},
              appVersion: {}
            }
          }
        },
        DescribeAppVersionAppComponent: {
          http: {
            requestUri: "/describe-app-version-app-component",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appArn",
              "appVersion",
              "id"
            ],
            members: {
              appArn: {},
              appVersion: {},
              id: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "appArn",
              "appVersion"
            ],
            members: {
              appArn: {},
              appComponent: {
                shape: "S1l"
              },
              appVersion: {}
            }
          }
        },
        DescribeAppVersionResource: {
          http: {
            requestUri: "/describe-app-version-resource",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appArn",
              "appVersion"
            ],
            members: {
              appArn: {},
              appVersion: {},
              awsAccountId: {},
              awsRegion: {},
              logicalResourceId: {
                shape: "S1o"
              },
              physicalResourceId: {},
              resourceName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "appArn",
              "appVersion"
            ],
            members: {
              appArn: {},
              appVersion: {},
              physicalResource: {
                shape: "S1r"
              }
            }
          }
        },
        DescribeAppVersionResourcesResolutionStatus: {
          http: {
            requestUri: "/describe-app-version-resources-resolution-status",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appArn",
              "appVersion"
            ],
            members: {
              appArn: {},
              appVersion: {},
              resolutionId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "appArn",
              "appVersion",
              "resolutionId",
              "status"
            ],
            members: {
              appArn: {},
              appVersion: {},
              errorMessage: {},
              resolutionId: {},
              status: {}
            }
          }
        },
        DescribeAppVersionTemplate: {
          http: {
            requestUri: "/describe-app-version-template",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appArn",
              "appVersion"
            ],
            members: {
              appArn: {},
              appVersion: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "appArn",
              "appTemplateBody",
              "appVersion"
            ],
            members: {
              appArn: {},
              appTemplateBody: {},
              appVersion: {}
            }
          }
        },
        DescribeDraftAppVersionResourcesImportStatus: {
          http: {
            requestUri: "/describe-draft-app-version-resources-import-status",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appArn"
            ],
            members: {
              appArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "appArn",
              "appVersion",
              "status",
              "statusChangeTime"
            ],
            members: {
              appArn: {},
              appVersion: {},
              errorMessage: {},
              status: {},
              statusChangeTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeResiliencyPolicy: {
          http: {
            requestUri: "/describe-resiliency-policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "policyArn"
            ],
            members: {
              policyArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "policy"
            ],
            members: {
              policy: {
                shape: "S2c"
              }
            }
          }
        },
        ImportResourcesToDraftAppVersion: {
          http: {
            requestUri: "/import-resources-to-draft-app-version",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appArn"
            ],
            members: {
              appArn: {},
              eksSources: {
                shape: "S43"
              },
              importStrategy: {},
              sourceArns: {
                shape: "S47"
              },
              terraformSources: {
                shape: "S48"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "appArn",
              "appVersion",
              "status"
            ],
            members: {
              appArn: {},
              appVersion: {},
              eksSources: {
                shape: "S43"
              },
              sourceArns: {
                shape: "S47"
              },
              status: {},
              terraformSources: {
                shape: "S48"
              }
            }
          }
        },
        ListAlarmRecommendations: {
          http: {
            requestUri: "/list-alarm-recommendations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assessmentArn"
            ],
            members: {
              assessmentArn: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "alarmRecommendations"
            ],
            members: {
              alarmRecommendations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "recommendationId",
                    "referenceId",
                    "type"
                  ],
                  members: {
                    appComponentName: {
                      deprecated: true,
                      deprecatedMessage: "An alarm recommendation can be attached to multiple Application Components, hence this property will be replaced by the new property 'appComponentNames'."
                    },
                    appComponentNames: {
                      shape: "S1n"
                    },
                    description: {},
                    items: {
                      shape: "S4h"
                    },
                    name: {},
                    prerequisite: {},
                    recommendationId: {},
                    recommendationStatus: {},
                    referenceId: {},
                    type: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAppAssessmentComplianceDrifts: {
          http: {
            requestUri: "/list-app-assessment-compliance-drifts",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assessmentArn"
            ],
            members: {
              assessmentArn: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "complianceDrifts"
            ],
            members: {
              complianceDrifts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    actualReferenceId: {},
                    actualValue: {
                      shape: "S34"
                    },
                    appId: {},
                    appVersion: {},
                    diffType: {},
                    driftType: {},
                    entityId: {},
                    entityType: {},
                    expectedReferenceId: {},
                    expectedValue: {
                      shape: "S34"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAppAssessments: {
          http: {
            method: "GET",
            requestUri: "/list-app-assessments",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              appArn: {
                location: "querystring",
                locationName: "appArn"
              },
              assessmentName: {
                location: "querystring",
                locationName: "assessmentName"
              },
              assessmentStatus: {
                location: "querystring",
                locationName: "assessmentStatus",
                type: "list",
                member: {}
              },
              complianceStatus: {
                location: "querystring",
                locationName: "complianceStatus"
              },
              invoker: {
                location: "querystring",
                locationName: "invoker"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              reverseOrder: {
                location: "querystring",
                locationName: "reverseOrder",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assessmentSummaries"
            ],
            members: {
              assessmentSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "assessmentArn",
                    "assessmentStatus"
                  ],
                  members: {
                    appArn: {},
                    appVersion: {},
                    assessmentArn: {},
                    assessmentName: {},
                    assessmentStatus: {},
                    complianceStatus: {},
                    cost: {
                      shape: "S37"
                    },
                    driftStatus: {},
                    endTime: {
                      type: "timestamp"
                    },
                    invoker: {},
                    message: {},
                    resiliencyScore: {
                      type: "double"
                    },
                    startTime: {
                      type: "timestamp"
                    },
                    versionName: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAppComponentCompliances: {
          http: {
            requestUri: "/list-app-component-compliances",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assessmentArn"
            ],
            members: {
              assessmentArn: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "componentCompliances"
            ],
            members: {
              componentCompliances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    appComponentName: {},
                    compliance: {
                      shape: "S34"
                    },
                    cost: {
                      shape: "S37"
                    },
                    message: {},
                    resiliencyScore: {
                      shape: "S3c"
                    },
                    status: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAppComponentRecommendations: {
          http: {
            requestUri: "/list-app-component-recommendations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assessmentArn"
            ],
            members: {
              assessmentArn: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "componentRecommendations"
            ],
            members: {
              componentRecommendations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "appComponentName",
                    "configRecommendations",
                    "recommendationStatus"
                  ],
                  members: {
                    appComponentName: {},
                    configRecommendations: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "name",
                          "optimizationType",
                          "referenceId"
                        ],
                        members: {
                          appComponentName: {},
                          compliance: {
                            shape: "S34"
                          },
                          cost: {
                            shape: "S37"
                          },
                          description: {},
                          haArchitecture: {},
                          name: {},
                          optimizationType: {},
                          recommendationCompliance: {
                            type: "map",
                            key: {},
                            value: {
                              type: "structure",
                              required: [
                                "expectedComplianceStatus"
                              ],
                              members: {
                                expectedComplianceStatus: {},
                                expectedRpoDescription: {},
                                expectedRpoInSecs: {
                                  type: "integer"
                                },
                                expectedRtoDescription: {},
                                expectedRtoInSecs: {
                                  type: "integer"
                                }
                              }
                            }
                          },
                          referenceId: {},
                          suggestedChanges: {
                            type: "list",
                            member: {}
                          }
                        }
                      }
                    },
                    recommendationStatus: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAppInputSources: {
          http: {
            requestUri: "/list-app-input-sources",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appArn",
              "appVersion"
            ],
            members: {
              appArn: {},
              appVersion: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "appInputSources"
            ],
            members: {
              appInputSources: {
                type: "list",
                member: {
                  shape: "S2p"
                }
              },
              nextToken: {}
            }
          }
        },
        ListAppVersionAppComponents: {
          http: {
            requestUri: "/list-app-version-app-components",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appArn",
              "appVersion"
            ],
            members: {
              appArn: {},
              appVersion: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "appArn",
              "appVersion"
            ],
            members: {
              appArn: {},
              appComponents: {
                shape: "S1s"
              },
              appVersion: {},
              nextToken: {}
            }
          }
        },
        ListAppVersionResourceMappings: {
          http: {
            requestUri: "/list-app-version-resource-mappings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appArn",
              "appVersion"
            ],
            members: {
              appArn: {},
              appVersion: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "resourceMappings"
            ],
            members: {
              nextToken: {},
              resourceMappings: {
                shape: "S3"
              }
            }
          }
        },
        ListAppVersionResources: {
          http: {
            requestUri: "/list-app-version-resources",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appArn",
              "appVersion"
            ],
            members: {
              appArn: {},
              appVersion: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              resolutionId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "physicalResources",
              "resolutionId"
            ],
            members: {
              nextToken: {},
              physicalResources: {
                type: "list",
                member: {
                  shape: "S1r"
                }
              },
              resolutionId: {}
            }
          }
        },
        ListAppVersions: {
          http: {
            requestUri: "/list-app-versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appArn"
            ],
            members: {
              appArn: {},
              endTime: {
                type: "timestamp"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              startTime: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "appVersions"
            ],
            members: {
              appVersions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "appVersion"
                  ],
                  members: {
                    appVersion: {},
                    creationTime: {
                      type: "timestamp"
                    },
                    identifier: {
                      type: "long"
                    },
                    versionName: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListApps: {
          http: {
            method: "GET",
            requestUri: "/list-apps",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              appArn: {
                location: "querystring",
                locationName: "appArn"
              },
              fromLastAssessmentTime: {
                location: "querystring",
                locationName: "fromLastAssessmentTime",
                type: "timestamp"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              name: {
                location: "querystring",
                locationName: "name"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              reverseOrder: {
                location: "querystring",
                locationName: "reverseOrder",
                type: "boolean"
              },
              toLastAssessmentTime: {
                location: "querystring",
                locationName: "toLastAssessmentTime",
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "appSummaries"
            ],
            members: {
              appSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "appArn",
                    "creationTime",
                    "name"
                  ],
                  members: {
                    appArn: {},
                    assessmentSchedule: {},
                    complianceStatus: {},
                    creationTime: {
                      type: "timestamp"
                    },
                    description: {},
                    driftStatus: {},
                    lastAppComplianceEvaluationTime: {
                      type: "timestamp"
                    },
                    name: {},
                    resiliencyScore: {
                      type: "double"
                    },
                    rpoInSecs: {
                      type: "integer"
                    },
                    rtoInSecs: {
                      type: "integer"
                    },
                    status: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListRecommendationTemplates: {
          http: {
            method: "GET",
            requestUri: "/list-recommendation-templates",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assessmentArn"
            ],
            members: {
              assessmentArn: {
                location: "querystring",
                locationName: "assessmentArn"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              name: {
                location: "querystring",
                locationName: "name"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              recommendationTemplateArn: {
                location: "querystring",
                locationName: "recommendationTemplateArn"
              },
              reverseOrder: {
                location: "querystring",
                locationName: "reverseOrder",
                type: "boolean"
              },
              status: {
                location: "querystring",
                locationName: "status",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              recommendationTemplates: {
                type: "list",
                member: {
                  shape: "S21"
                }
              }
            }
          }
        },
        ListResiliencyPolicies: {
          http: {
            method: "GET",
            requestUri: "/list-resiliency-policies",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              policyName: {
                location: "querystring",
                locationName: "policyName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "resiliencyPolicies"
            ],
            members: {
              nextToken: {},
              resiliencyPolicies: {
                shape: "S61"
              }
            }
          }
        },
        ListSopRecommendations: {
          http: {
            requestUri: "/list-sop-recommendations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assessmentArn"
            ],
            members: {
              assessmentArn: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "sopRecommendations"
            ],
            members: {
              nextToken: {},
              sopRecommendations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "recommendationId",
                    "referenceId",
                    "serviceType"
                  ],
                  members: {
                    appComponentName: {},
                    description: {},
                    items: {
                      shape: "S4h"
                    },
                    name: {},
                    prerequisite: {},
                    recommendationId: {},
                    recommendationStatus: {},
                    referenceId: {},
                    serviceType: {}
                  }
                }
              }
            }
          }
        },
        ListSuggestedResiliencyPolicies: {
          http: {
            method: "GET",
            requestUri: "/list-suggested-resiliency-policies",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "resiliencyPolicies"
            ],
            members: {
              nextToken: {},
              resiliencyPolicies: {
                shape: "S61"
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S14"
              }
            }
          }
        },
        ListTestRecommendations: {
          http: {
            requestUri: "/list-test-recommendations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assessmentArn"
            ],
            members: {
              assessmentArn: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "testRecommendations"
            ],
            members: {
              nextToken: {},
              testRecommendations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "referenceId"
                  ],
                  members: {
                    appComponentName: {},
                    dependsOnAlarms: {
                      type: "list",
                      member: {}
                    },
                    description: {},
                    intent: {},
                    items: {
                      shape: "S4h"
                    },
                    name: {},
                    prerequisite: {},
                    recommendationId: {},
                    recommendationStatus: {},
                    referenceId: {},
                    risk: {},
                    type: {}
                  }
                }
              }
            }
          }
        },
        ListUnsupportedAppVersionResources: {
          http: {
            requestUri: "/list-unsupported-app-version-resources",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appArn",
              "appVersion"
            ],
            members: {
              appArn: {},
              appVersion: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              resolutionId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "resolutionId",
              "unsupportedResources"
            ],
            members: {
              nextToken: {},
              resolutionId: {},
              unsupportedResources: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "logicalResourceId",
                    "physicalResourceId",
                    "resourceType"
                  ],
                  members: {
                    logicalResourceId: {
                      shape: "S1o"
                    },
                    physicalResourceId: {
                      shape: "S8"
                    },
                    resourceType: {},
                    unsupportedResourceStatus: {}
                  }
                }
              }
            }
          }
        },
        PublishAppVersion: {
          http: {
            requestUri: "/publish-app-version",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appArn"
            ],
            members: {
              appArn: {},
              versionName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "appArn"
            ],
            members: {
              appArn: {},
              appVersion: {},
              identifier: {
                type: "long"
              },
              versionName: {}
            }
          }
        },
        PutDraftAppVersionTemplate: {
          http: {
            requestUri: "/put-draft-app-version-template",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appArn",
              "appTemplateBody"
            ],
            members: {
              appArn: {},
              appTemplateBody: {}
            }
          },
          output: {
            type: "structure",
            members: {
              appArn: {},
              appVersion: {}
            }
          }
        },
        RemoveDraftAppVersionResourceMappings: {
          http: {
            requestUri: "/remove-draft-app-version-resource-mappings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appArn"
            ],
            members: {
              appArn: {},
              appRegistryAppNames: {
                shape: "S6s"
              },
              eksSourceNames: {
                shape: "S6t"
              },
              logicalStackNames: {
                shape: "S6t"
              },
              resourceGroupNames: {
                shape: "S6s"
              },
              resourceNames: {
                shape: "S6s"
              },
              terraformSourceNames: {
                shape: "S6t"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              appArn: {},
              appVersion: {}
            }
          }
        },
        ResolveAppVersionResources: {
          http: {
            requestUri: "/resolve-app-version-resources",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appArn",
              "appVersion"
            ],
            members: {
              appArn: {},
              appVersion: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "appArn",
              "appVersion",
              "resolutionId",
              "status"
            ],
            members: {
              appArn: {},
              appVersion: {},
              resolutionId: {},
              status: {}
            }
          }
        },
        StartAppAssessment: {
          http: {
            requestUri: "/start-app-assessment",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appArn",
              "appVersion",
              "assessmentName"
            ],
            members: {
              appArn: {},
              appVersion: {},
              assessmentName: {},
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "S14"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assessment"
            ],
            members: {
              assessment: {
                shape: "S33"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S14"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {},
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateApp: {
          http: {
            requestUri: "/update-app",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appArn"
            ],
            members: {
              appArn: {},
              assessmentSchedule: {},
              clearResiliencyPolicyArn: {
                type: "boolean"
              },
              description: {},
              eventSubscriptions: {
                shape: "Sw"
              },
              permissionModel: {
                shape: "Sz"
              },
              policyArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "app"
            ],
            members: {
              app: {
                shape: "S18"
              }
            }
          }
        },
        UpdateAppVersion: {
          http: {
            requestUri: "/update-app-version",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appArn"
            ],
            members: {
              additionalInfo: {
                shape: "S1g"
              },
              appArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "appArn",
              "appVersion"
            ],
            members: {
              additionalInfo: {
                shape: "S1g"
              },
              appArn: {},
              appVersion: {}
            }
          }
        },
        UpdateAppVersionAppComponent: {
          http: {
            requestUri: "/update-app-version-app-component",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appArn",
              "id"
            ],
            members: {
              additionalInfo: {
                shape: "S1g"
              },
              appArn: {},
              id: {},
              name: {},
              type: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "appArn",
              "appVersion"
            ],
            members: {
              appArn: {},
              appComponent: {
                shape: "S1l"
              },
              appVersion: {}
            }
          }
        },
        UpdateAppVersionResource: {
          http: {
            requestUri: "/update-app-version-resource",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appArn"
            ],
            members: {
              additionalInfo: {
                shape: "S1g"
              },
              appArn: {},
              appComponents: {
                shape: "S1n"
              },
              awsAccountId: {},
              awsRegion: {},
              excluded: {
                type: "boolean"
              },
              logicalResourceId: {
                shape: "S1o"
              },
              physicalResourceId: {},
              resourceName: {},
              resourceType: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "appArn",
              "appVersion"
            ],
            members: {
              appArn: {},
              appVersion: {},
              physicalResource: {
                shape: "S1r"
              }
            }
          }
        },
        UpdateResiliencyPolicy: {
          http: {
            requestUri: "/update-resiliency-policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "policyArn"
            ],
            members: {
              dataLocationConstraint: {},
              policy: {
                shape: "S26"
              },
              policyArn: {},
              policyDescription: {},
              policyName: {},
              tier: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "policy"
            ],
            members: {
              policy: {
                shape: "S2c"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "mappingType",
              "physicalResourceId"
            ],
            members: {
              appRegistryAppName: {},
              eksSourceName: {},
              logicalStackName: {},
              mappingType: {},
              physicalResourceId: {
                shape: "S8"
              },
              resourceGroupName: {},
              resourceName: {},
              terraformSourceName: {}
            }
          }
        },
        S8: {
          type: "structure",
          required: [
            "identifier",
            "type"
          ],
          members: {
            awsAccountId: {},
            awsRegion: {},
            identifier: {},
            type: {}
          }
        },
        Sj: {
          type: "structure",
          members: {
            resourceId: {},
            targetAccountId: {},
            targetRegion: {}
          }
        },
        Sw: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "eventType",
              "name"
            ],
            members: {
              eventType: {},
              name: {},
              snsTopicArn: {}
            }
          }
        },
        Sz: {
          type: "structure",
          required: [
            "type"
          ],
          members: {
            crossAccountRoleArns: {
              type: "list",
              member: {}
            },
            invokerRoleName: {},
            type: {}
          }
        },
        S14: {
          type: "map",
          key: {},
          value: {},
          sensitive: true
        },
        S18: {
          type: "structure",
          required: [
            "appArn",
            "creationTime",
            "name"
          ],
          members: {
            appArn: {},
            assessmentSchedule: {},
            complianceStatus: {},
            creationTime: {
              type: "timestamp"
            },
            description: {},
            driftStatus: {},
            eventSubscriptions: {
              shape: "Sw"
            },
            lastAppComplianceEvaluationTime: {
              type: "timestamp"
            },
            lastDriftEvaluationTime: {
              type: "timestamp"
            },
            lastResiliencyScoreEvaluationTime: {
              type: "timestamp"
            },
            name: {},
            permissionModel: {
              shape: "Sz"
            },
            policyArn: {},
            resiliencyScore: {
              type: "double"
            },
            rpoInSecs: {
              type: "integer"
            },
            rtoInSecs: {
              type: "integer"
            },
            status: {},
            tags: {
              shape: "S14"
            }
          }
        },
        S1g: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {}
          }
        },
        S1l: {
          type: "structure",
          required: [
            "name",
            "type"
          ],
          members: {
            additionalInfo: {
              shape: "S1g"
            },
            id: {},
            name: {},
            type: {}
          }
        },
        S1n: {
          type: "list",
          member: {}
        },
        S1o: {
          type: "structure",
          required: [
            "identifier"
          ],
          members: {
            eksSourceName: {},
            identifier: {},
            logicalStackName: {},
            resourceGroupName: {},
            terraformSourceName: {}
          }
        },
        S1r: {
          type: "structure",
          required: [
            "logicalResourceId",
            "physicalResourceId",
            "resourceType"
          ],
          members: {
            additionalInfo: {
              shape: "S1g"
            },
            appComponents: {
              shape: "S1s"
            },
            excluded: {
              type: "boolean"
            },
            logicalResourceId: {
              shape: "S1o"
            },
            parentResourceName: {},
            physicalResourceId: {
              shape: "S8"
            },
            resourceName: {},
            resourceType: {},
            sourceType: {}
          }
        },
        S1s: {
          type: "list",
          member: {
            shape: "S1l"
          }
        },
        S1w: {
          type: "list",
          member: {}
        },
        S1y: {
          type: "list",
          member: {}
        },
        S21: {
          type: "structure",
          required: [
            "assessmentArn",
            "format",
            "name",
            "recommendationTemplateArn",
            "recommendationTypes",
            "status"
          ],
          members: {
            appArn: {},
            assessmentArn: {},
            endTime: {
              type: "timestamp"
            },
            format: {},
            message: {},
            name: {},
            needsReplacements: {
              type: "boolean"
            },
            recommendationIds: {
              shape: "S1w"
            },
            recommendationTemplateArn: {},
            recommendationTypes: {
              shape: "S1y"
            },
            startTime: {
              type: "timestamp"
            },
            status: {},
            tags: {
              shape: "S14"
            },
            templatesLocation: {
              type: "structure",
              members: {
                bucket: {},
                prefix: {}
              }
            }
          }
        },
        S26: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "rpoInSecs",
              "rtoInSecs"
            ],
            members: {
              rpoInSecs: {
                type: "integer"
              },
              rtoInSecs: {
                type: "integer"
              }
            }
          }
        },
        S2c: {
          type: "structure",
          members: {
            creationTime: {
              type: "timestamp"
            },
            dataLocationConstraint: {},
            estimatedCostTier: {},
            policy: {
              shape: "S26"
            },
            policyArn: {},
            policyDescription: {},
            policyName: {},
            tags: {
              shape: "S14"
            },
            tier: {}
          }
        },
        S2k: {
          type: "structure",
          required: [
            "eksClusterArn",
            "namespace"
          ],
          members: {
            eksClusterArn: {},
            namespace: {}
          }
        },
        S2m: {
          type: "structure",
          required: [
            "s3StateFileUrl"
          ],
          members: {
            s3StateFileUrl: {}
          }
        },
        S2p: {
          type: "structure",
          required: [
            "importType"
          ],
          members: {
            eksSourceClusterNamespace: {
              shape: "S2k"
            },
            importType: {},
            resourceCount: {
              type: "integer"
            },
            sourceArn: {},
            sourceName: {},
            terraformSource: {
              shape: "S2m"
            }
          }
        },
        S33: {
          type: "structure",
          required: [
            "assessmentArn",
            "assessmentStatus",
            "invoker"
          ],
          members: {
            appArn: {},
            appVersion: {},
            assessmentArn: {},
            assessmentName: {},
            assessmentStatus: {},
            compliance: {
              shape: "S34"
            },
            complianceStatus: {},
            cost: {
              shape: "S37"
            },
            driftStatus: {},
            endTime: {
              type: "timestamp"
            },
            invoker: {},
            message: {},
            policy: {
              shape: "S2c"
            },
            resiliencyScore: {
              shape: "S3c"
            },
            resourceErrorsDetails: {
              type: "structure",
              members: {
                hasMoreErrors: {
                  type: "boolean"
                },
                resourceErrors: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      logicalResourceId: {},
                      physicalResourceId: {},
                      reason: {}
                    }
                  }
                }
              }
            },
            startTime: {
              type: "timestamp"
            },
            tags: {
              shape: "S14"
            },
            versionName: {}
          }
        },
        S34: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "complianceStatus"
            ],
            members: {
              achievableRpoInSecs: {
                type: "integer"
              },
              achievableRtoInSecs: {
                type: "integer"
              },
              complianceStatus: {},
              currentRpoInSecs: {
                type: "integer"
              },
              currentRtoInSecs: {
                type: "integer"
              },
              message: {},
              rpoDescription: {},
              rpoReferenceId: {},
              rtoDescription: {},
              rtoReferenceId: {}
            }
          }
        },
        S37: {
          type: "structure",
          required: [
            "amount",
            "currency",
            "frequency"
          ],
          members: {
            amount: {
              type: "double"
            },
            currency: {},
            frequency: {}
          }
        },
        S3c: {
          type: "structure",
          required: [
            "disruptionScore",
            "score"
          ],
          members: {
            componentScore: {
              type: "map",
              key: {},
              value: {
                type: "structure",
                members: {
                  excludedCount: {
                    type: "long"
                  },
                  outstandingCount: {
                    type: "long"
                  },
                  possibleScore: {
                    type: "double"
                  },
                  score: {
                    type: "double"
                  }
                }
              }
            },
            disruptionScore: {
              type: "map",
              key: {},
              value: {
                type: "double"
              }
            },
            score: {
              type: "double"
            }
          }
        },
        S43: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "eksClusterArn",
              "namespaces"
            ],
            members: {
              eksClusterArn: {},
              namespaces: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S47: {
          type: "list",
          member: {}
        },
        S48: {
          type: "list",
          member: {
            shape: "S2m"
          }
        },
        S4h: {
          type: "list",
          member: {
            type: "structure",
            members: {
              alreadyImplemented: {
                type: "boolean"
              },
              excludeReason: {},
              excluded: {
                type: "boolean"
              },
              resourceId: {},
              targetAccountId: {},
              targetRegion: {}
            }
          }
        },
        S61: {
          type: "list",
          member: {
            shape: "S2c"
          }
        },
        S6s: {
          type: "list",
          member: {}
        },
        S6t: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/resiliencehub-2020-04-30.paginators.json
var require_resiliencehub_2020_04_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/resiliencehub-2020-04-30.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAlarmRecommendations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListAppAssessmentComplianceDrifts: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListAppAssessments: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListAppComponentCompliances: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListAppComponentRecommendations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListAppInputSources: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListAppVersionAppComponents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListAppVersionResourceMappings: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListAppVersionResources: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListAppVersions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListApps: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListRecommendationTemplates: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListResiliencyPolicies: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListSopRecommendations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListSuggestedResiliencyPolicies: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListTestRecommendations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListUnsupportedAppVersionResources: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/resiliencehub.js
var require_resiliencehub = __commonJS({
  "node_modules/aws-sdk/clients/resiliencehub.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["resiliencehub"] = {};
    AWS2.Resiliencehub = Service.defineService("resiliencehub", ["2020-04-30"]);
    Object.defineProperty(apiLoader.services["resiliencehub"], "2020-04-30", {
      get: function get() {
        var model = require_resiliencehub_2020_04_30_min();
        model.paginators = require_resiliencehub_2020_04_30_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Resiliencehub;
  }
});

// node_modules/aws-sdk/apis/migrationhubstrategy-2020-02-19.min.json
var require_migrationhubstrategy_2020_02_19_min = __commonJS({
  "node_modules/aws-sdk/apis/migrationhubstrategy-2020-02-19.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-02-19",
        endpointPrefix: "migrationhub-strategy",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Migration Hub Strategy Recommendations",
        serviceId: "MigrationHubStrategy",
        signatureVersion: "v4",
        signingName: "migrationhub-strategy",
        uid: "migrationhubstrategy-2020-02-19"
      },
      operations: {
        GetApplicationComponentDetails: {
          http: {
            method: "GET",
            requestUri: "/get-applicationcomponent-details/{applicationComponentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationComponentId"
            ],
            members: {
              applicationComponentId: {
                location: "uri",
                locationName: "applicationComponentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applicationComponentDetail: {
                shape: "S4"
              },
              associatedApplications: {
                shape: "S1b"
              },
              associatedServerIds: {
                type: "list",
                member: {}
              },
              moreApplicationResource: {
                type: "boolean"
              }
            }
          }
        },
        GetApplicationComponentStrategies: {
          http: {
            method: "GET",
            requestUri: "/get-applicationcomponent-strategies/{applicationComponentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationComponentId"
            ],
            members: {
              applicationComponentId: {
                location: "uri",
                locationName: "applicationComponentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applicationComponentStrategies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    isPreferred: {
                      type: "boolean"
                    },
                    recommendation: {
                      shape: "Sq"
                    },
                    status: {}
                  }
                }
              }
            }
          }
        },
        GetAssessment: {
          http: {
            method: "GET",
            requestUri: "/get-assessment/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              assessmentTargets: {
                shape: "S1m"
              },
              dataCollectionDetails: {
                type: "structure",
                members: {
                  completionTime: {
                    type: "timestamp"
                  },
                  failed: {
                    type: "integer"
                  },
                  inProgress: {
                    type: "integer"
                  },
                  servers: {
                    type: "integer"
                  },
                  startTime: {
                    type: "timestamp"
                  },
                  status: {},
                  statusMessage: {},
                  success: {
                    type: "integer"
                  }
                }
              },
              id: {}
            }
          }
        },
        GetImportFileTask: {
          http: {
            method: "GET",
            requestUri: "/get-import-file-task/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              completionTime: {
                type: "timestamp"
              },
              id: {},
              importName: {},
              inputS3Bucket: {},
              inputS3Key: {},
              numberOfRecordsFailed: {
                type: "integer"
              },
              numberOfRecordsSuccess: {
                type: "integer"
              },
              startTime: {
                type: "timestamp"
              },
              status: {},
              statusReportS3Bucket: {},
              statusReportS3Key: {}
            }
          }
        },
        GetLatestAssessmentId: {
          http: {
            method: "GET",
            requestUri: "/get-latest-assessment-id",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              id: {}
            }
          }
        },
        GetPortfolioPreferences: {
          http: {
            method: "GET",
            requestUri: "/get-portfolio-preferences",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              applicationMode: {},
              applicationPreferences: {
                shape: "S23"
              },
              databasePreferences: {
                shape: "S2e"
              },
              prioritizeBusinessGoals: {
                shape: "S2q"
              }
            }
          }
        },
        GetPortfolioSummary: {
          http: {
            method: "GET",
            requestUri: "/get-portfolio-summary",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              assessmentSummary: {
                type: "structure",
                members: {
                  antipatternReportS3Object: {
                    shape: "S6"
                  },
                  antipatternReportStatus: {},
                  antipatternReportStatusMessage: {},
                  lastAnalyzedTimestamp: {
                    type: "timestamp"
                  },
                  listAntipatternSeveritySummary: {
                    shape: "Sk"
                  },
                  listApplicationComponentStatusSummary: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        count: {
                          type: "integer"
                        },
                        srcCodeOrDbAnalysisStatus: {}
                      }
                    }
                  },
                  listApplicationComponentStrategySummary: {
                    shape: "S2y"
                  },
                  listApplicationComponentSummary: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        appType: {},
                        count: {
                          type: "integer"
                        }
                      }
                    }
                  },
                  listServerStatusSummary: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        count: {
                          type: "integer"
                        },
                        runTimeAssessmentStatus: {}
                      }
                    }
                  },
                  listServerStrategySummary: {
                    shape: "S2y"
                  },
                  listServerSummary: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        ServerOsType: {},
                        count: {
                          type: "integer"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetRecommendationReportDetails: {
          http: {
            method: "GET",
            requestUri: "/get-recommendation-report-details/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              recommendationReportDetails: {
                type: "structure",
                members: {
                  completionTime: {
                    type: "timestamp"
                  },
                  s3Bucket: {},
                  s3Keys: {
                    type: "list",
                    member: {}
                  },
                  startTime: {
                    type: "timestamp"
                  },
                  status: {},
                  statusMessage: {}
                }
              }
            }
          }
        },
        GetServerDetails: {
          http: {
            method: "GET",
            requestUri: "/get-server-details/{serverId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "serverId"
            ],
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              serverId: {
                location: "uri",
                locationName: "serverId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              associatedApplications: {
                shape: "S1b"
              },
              nextToken: {},
              serverDetail: {
                shape: "S3k"
              }
            }
          }
        },
        GetServerStrategies: {
          http: {
            method: "GET",
            requestUri: "/get-server-strategies/{serverId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "serverId"
            ],
            members: {
              serverId: {
                location: "uri",
                locationName: "serverId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              serverStrategies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    isPreferred: {
                      type: "boolean"
                    },
                    numberOfApplicationComponents: {
                      type: "integer"
                    },
                    recommendation: {
                      shape: "Sq"
                    },
                    status: {}
                  }
                }
              }
            }
          }
        },
        ListAnalyzableServers: {
          http: {
            requestUri: "/list-analyzable-servers",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              sort: {}
            }
          },
          output: {
            type: "structure",
            members: {
              analyzableServers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    hostname: {},
                    ipAddress: {},
                    source: {},
                    vmId: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListApplicationComponents: {
          http: {
            requestUri: "/list-applicationcomponents",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              applicationComponentCriteria: {},
              filterValue: {},
              groupIdFilter: {
                shape: "S49"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              sort: {}
            }
          },
          output: {
            type: "structure",
            members: {
              applicationComponentInfos: {
                type: "list",
                member: {
                  shape: "S4"
                }
              },
              nextToken: {}
            }
          }
        },
        ListCollectors: {
          http: {
            method: "GET",
            requestUri: "/list-collectors",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Collectors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    collectorHealth: {},
                    collectorId: {},
                    collectorVersion: {},
                    configurationSummary: {
                      type: "structure",
                      members: {
                        ipAddressBasedRemoteInfoList: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              authType: {},
                              ipAddressConfigurationTimeStamp: {},
                              osType: {}
                            }
                          }
                        },
                        pipelineInfoList: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              pipelineConfigurationTimeStamp: {},
                              pipelineType: {}
                            }
                          }
                        },
                        remoteSourceCodeAnalysisServerInfo: {
                          type: "structure",
                          members: {
                            remoteSourceCodeAnalysisServerConfigurationTimestamp: {}
                          }
                        },
                        vcenterBasedRemoteInfoList: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              osType: {},
                              vcenterConfigurationTimeStamp: {}
                            }
                          }
                        },
                        versionControlInfoList: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              versionControlConfigurationTimeStamp: {},
                              versionControlType: {}
                            }
                          }
                        }
                      }
                    },
                    hostName: {},
                    ipAddress: {},
                    lastActivityTimeStamp: {},
                    registeredTimeStamp: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListImportFileTask: {
          http: {
            method: "GET",
            requestUri: "/list-import-file-task",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              taskInfos: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    completionTime: {
                      type: "timestamp"
                    },
                    id: {},
                    importName: {},
                    inputS3Bucket: {},
                    inputS3Key: {},
                    numberOfRecordsFailed: {
                      type: "integer"
                    },
                    numberOfRecordsSuccess: {
                      type: "integer"
                    },
                    startTime: {
                      type: "timestamp"
                    },
                    status: {},
                    statusReportS3Bucket: {},
                    statusReportS3Key: {}
                  }
                }
              }
            }
          }
        },
        ListServers: {
          http: {
            requestUri: "/list-servers",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              filterValue: {},
              groupIdFilter: {
                shape: "S49"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              serverCriteria: {},
              sort: {}
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              serverInfos: {
                type: "list",
                member: {
                  shape: "S3k"
                }
              }
            }
          }
        },
        PutPortfolioPreferences: {
          http: {
            requestUri: "/put-portfolio-preferences",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              applicationMode: {},
              applicationPreferences: {
                shape: "S23"
              },
              databasePreferences: {
                shape: "S2e"
              },
              prioritizeBusinessGoals: {
                shape: "S2q"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartAssessment: {
          http: {
            requestUri: "/start-assessment",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              assessmentDataSourceType: {},
              assessmentTargets: {
                shape: "S1m"
              },
              s3bucketForAnalysisData: {},
              s3bucketForReportData: {}
            }
          },
          output: {
            type: "structure",
            members: {
              assessmentId: {}
            }
          }
        },
        StartImportFileTask: {
          http: {
            requestUri: "/start-import-file-task",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "S3Bucket",
              "name",
              "s3key"
            ],
            members: {
              S3Bucket: {},
              dataSourceType: {},
              groupId: {
                shape: "S49"
              },
              name: {},
              s3bucketForReportData: {},
              s3key: {}
            }
          },
          output: {
            type: "structure",
            members: {
              id: {}
            }
          }
        },
        StartRecommendationReportGeneration: {
          http: {
            requestUri: "/start-recommendation-report-generation",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              groupIdFilter: {
                shape: "S49"
              },
              outputFormat: {}
            }
          },
          output: {
            type: "structure",
            members: {
              id: {}
            }
          }
        },
        StopAssessment: {
          http: {
            requestUri: "/stop-assessment",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assessmentId"
            ],
            members: {
              assessmentId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateApplicationComponentConfig: {
          http: {
            requestUri: "/update-applicationcomponent-config/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationComponentId"
            ],
            members: {
              appType: {},
              applicationComponentId: {},
              configureOnly: {
                type: "boolean"
              },
              inclusionStatus: {},
              secretsManagerKey: {
                type: "string",
                sensitive: true
              },
              sourceCodeList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    location: {},
                    projectName: {},
                    sourceVersion: {},
                    versionControl: {}
                  }
                }
              },
              strategyOption: {
                shape: "S5t"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateServerConfig: {
          http: {
            requestUri: "/update-server-config/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "serverId"
            ],
            members: {
              serverId: {},
              strategyOption: {
                shape: "S5t"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            analysisStatus: {},
            antipatternReportS3Object: {
              shape: "S6"
            },
            antipatternReportStatus: {},
            antipatternReportStatusMessage: {},
            appType: {},
            appUnitError: {
              type: "structure",
              members: {
                appUnitErrorCategory: {}
              }
            },
            associatedServerId: {},
            databaseConfigDetail: {
              type: "structure",
              members: {
                secretName: {}
              }
            },
            id: {},
            inclusionStatus: {},
            lastAnalyzedTimestamp: {
              type: "timestamp"
            },
            listAntipatternSeveritySummary: {
              shape: "Sk"
            },
            moreServerAssociationExists: {
              type: "boolean"
            },
            name: {},
            osDriver: {},
            osVersion: {},
            recommendationSet: {
              shape: "Sq"
            },
            resourceSubType: {},
            resultList: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  analysisStatus: {
                    type: "structure",
                    members: {
                      runtimeAnalysisStatus: {},
                      srcCodeOrDbAnalysisStatus: {}
                    },
                    union: true
                  },
                  analysisType: {},
                  antipatternReportResultList: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        analyzerName: {
                          type: "structure",
                          members: {
                            binaryAnalyzerName: {},
                            runTimeAnalyzerName: {},
                            sourceCodeAnalyzerName: {}
                          },
                          union: true
                        },
                        antiPatternReportS3Object: {
                          shape: "S6"
                        },
                        antipatternReportStatus: {},
                        antipatternReportStatusMessage: {}
                      }
                    }
                  },
                  statusMessage: {}
                }
              }
            },
            runtimeStatus: {},
            runtimeStatusMessage: {},
            sourceCodeRepositories: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  branch: {},
                  projectName: {},
                  repository: {},
                  versionControlType: {}
                }
              }
            },
            statusMessage: {}
          }
        },
        S6: {
          type: "structure",
          members: {
            s3Bucket: {},
            s3key: {}
          }
        },
        Sk: {
          type: "list",
          member: {
            type: "structure",
            members: {
              count: {
                type: "integer"
              },
              severity: {}
            }
          }
        },
        Sq: {
          type: "structure",
          members: {
            strategy: {},
            targetDestination: {},
            transformationTool: {
              type: "structure",
              members: {
                description: {},
                name: {},
                tranformationToolInstallationLink: {}
              }
            }
          }
        },
        S1b: {
          type: "list",
          member: {
            type: "structure",
            members: {
              id: {},
              name: {}
            }
          }
        },
        S1m: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "condition",
              "name",
              "values"
            ],
            members: {
              condition: {},
              name: {},
              values: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S23: {
          type: "structure",
          members: {
            managementPreference: {
              type: "structure",
              members: {
                awsManagedResources: {
                  type: "structure",
                  required: [
                    "targetDestination"
                  ],
                  members: {
                    targetDestination: {
                      type: "list",
                      member: {}
                    }
                  }
                },
                noPreference: {
                  type: "structure",
                  required: [
                    "targetDestination"
                  ],
                  members: {
                    targetDestination: {
                      type: "list",
                      member: {}
                    }
                  }
                },
                selfManageResources: {
                  type: "structure",
                  required: [
                    "targetDestination"
                  ],
                  members: {
                    targetDestination: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              union: true
            }
          }
        },
        S2e: {
          type: "structure",
          members: {
            databaseManagementPreference: {},
            databaseMigrationPreference: {
              type: "structure",
              members: {
                heterogeneous: {
                  type: "structure",
                  required: [
                    "targetDatabaseEngine"
                  ],
                  members: {
                    targetDatabaseEngine: {
                      type: "list",
                      member: {}
                    }
                  }
                },
                homogeneous: {
                  type: "structure",
                  members: {
                    targetDatabaseEngine: {
                      type: "list",
                      member: {}
                    }
                  }
                },
                noPreference: {
                  type: "structure",
                  required: [
                    "targetDatabaseEngine"
                  ],
                  members: {
                    targetDatabaseEngine: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              union: true
            }
          }
        },
        S2q: {
          type: "structure",
          members: {
            businessGoals: {
              type: "structure",
              members: {
                licenseCostReduction: {
                  type: "integer"
                },
                modernizeInfrastructureWithCloudNativeTechnologies: {
                  type: "integer"
                },
                reduceOperationalOverheadWithManagedServices: {
                  type: "integer"
                },
                speedOfMigration: {
                  type: "integer"
                }
              }
            }
          }
        },
        S2y: {
          type: "list",
          member: {
            type: "structure",
            members: {
              count: {
                type: "integer"
              },
              strategy: {}
            }
          }
        },
        S3k: {
          type: "structure",
          members: {
            antipatternReportS3Object: {
              shape: "S6"
            },
            antipatternReportStatus: {},
            antipatternReportStatusMessage: {},
            applicationComponentStrategySummary: {
              shape: "S2y"
            },
            dataCollectionStatus: {},
            id: {},
            lastAnalyzedTimestamp: {
              type: "timestamp"
            },
            listAntipatternSeveritySummary: {
              shape: "Sk"
            },
            name: {},
            recommendationSet: {
              shape: "Sq"
            },
            serverError: {
              type: "structure",
              members: {
                serverErrorCategory: {}
              }
            },
            serverType: {},
            statusMessage: {},
            systemInfo: {
              type: "structure",
              members: {
                cpuArchitecture: {},
                fileSystemType: {},
                networkInfoList: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "interfaceName",
                      "ipAddress",
                      "macAddress",
                      "netMask"
                    ],
                    members: {
                      interfaceName: {},
                      ipAddress: {},
                      macAddress: {},
                      netMask: {}
                    }
                  }
                },
                osInfo: {
                  type: "structure",
                  members: {
                    type: {},
                    version: {}
                  }
                }
              }
            }
          }
        },
        S49: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              value: {}
            }
          }
        },
        S5t: {
          type: "structure",
          members: {
            isPreferred: {
              type: "boolean"
            },
            strategy: {},
            targetDestination: {},
            toolName: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/migrationhubstrategy-2020-02-19.paginators.json
var require_migrationhubstrategy_2020_02_19_paginators = __commonJS({
  "node_modules/aws-sdk/apis/migrationhubstrategy-2020-02-19.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetServerDetails: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "associatedApplications"
        },
        ListAnalyzableServers: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "analyzableServers"
        },
        ListApplicationComponents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "applicationComponentInfos"
        },
        ListCollectors: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "Collectors"
        },
        ListImportFileTask: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "taskInfos"
        },
        ListServers: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "serverInfos"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/migrationhubstrategy.js
var require_migrationhubstrategy = __commonJS({
  "node_modules/aws-sdk/clients/migrationhubstrategy.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["migrationhubstrategy"] = {};
    AWS2.MigrationHubStrategy = Service.defineService("migrationhubstrategy", ["2020-02-19"]);
    Object.defineProperty(apiLoader.services["migrationhubstrategy"], "2020-02-19", {
      get: function get() {
        var model = require_migrationhubstrategy_2020_02_19_min();
        model.paginators = require_migrationhubstrategy_2020_02_19_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.MigrationHubStrategy;
  }
});

// node_modules/aws-sdk/apis/appconfigdata-2021-11-11.min.json
var require_appconfigdata_2021_11_11_min = __commonJS({
  "node_modules/aws-sdk/apis/appconfigdata-2021-11-11.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-11-11",
        endpointPrefix: "appconfigdata",
        jsonVersion: "1.0",
        protocol: "rest-json",
        serviceFullName: "AWS AppConfig Data",
        serviceId: "AppConfigData",
        signatureVersion: "v4",
        signingName: "appconfig",
        uid: "appconfigdata-2021-11-11"
      },
      operations: {
        GetLatestConfiguration: {
          http: {
            method: "GET",
            requestUri: "/configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationToken"
            ],
            members: {
              ConfigurationToken: {
                location: "querystring",
                locationName: "configuration_token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextPollConfigurationToken: {
                location: "header",
                locationName: "Next-Poll-Configuration-Token"
              },
              NextPollIntervalInSeconds: {
                location: "header",
                locationName: "Next-Poll-Interval-In-Seconds",
                type: "integer"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              Configuration: {
                type: "blob",
                sensitive: true
              },
              VersionLabel: {
                location: "header",
                locationName: "Version-Label"
              }
            },
            payload: "Configuration"
          }
        },
        StartConfigurationSession: {
          http: {
            requestUri: "/configurationsessions",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ApplicationIdentifier",
              "EnvironmentIdentifier",
              "ConfigurationProfileIdentifier"
            ],
            members: {
              ApplicationIdentifier: {},
              EnvironmentIdentifier: {},
              ConfigurationProfileIdentifier: {},
              RequiredMinimumPollIntervalInSeconds: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InitialConfigurationToken: {}
            }
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/apis/appconfigdata-2021-11-11.paginators.json
var require_appconfigdata_2021_11_11_paginators = __commonJS({
  "node_modules/aws-sdk/apis/appconfigdata-2021-11-11.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/appconfigdata.js
var require_appconfigdata = __commonJS({
  "node_modules/aws-sdk/clients/appconfigdata.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["appconfigdata"] = {};
    AWS2.AppConfigData = Service.defineService("appconfigdata", ["2021-11-11"]);
    Object.defineProperty(apiLoader.services["appconfigdata"], "2021-11-11", {
      get: function get() {
        var model = require_appconfigdata_2021_11_11_min();
        model.paginators = require_appconfigdata_2021_11_11_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.AppConfigData;
  }
});

// node_modules/aws-sdk/apis/drs-2020-02-26.min.json
var require_drs_2020_02_26_min = __commonJS({
  "node_modules/aws-sdk/apis/drs-2020-02-26.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-02-26",
        endpointPrefix: "drs",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "drs",
        serviceFullName: "Elastic Disaster Recovery Service",
        serviceId: "drs",
        signatureVersion: "v4",
        signingName: "drs",
        uid: "drs-2020-02-26"
      },
      operations: {
        AssociateSourceNetworkStack: {
          http: {
            requestUri: "/AssociateSourceNetworkStack",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "cfnStackName",
              "sourceNetworkID"
            ],
            members: {
              cfnStackName: {
                shape: "S2"
              },
              sourceNetworkID: {}
            }
          },
          output: {
            type: "structure",
            members: {
              job: {
                shape: "S5"
              }
            }
          }
        },
        CreateExtendedSourceServer: {
          http: {
            requestUri: "/CreateExtendedSourceServer",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "sourceServerArn"
            ],
            members: {
              sourceServerArn: {},
              tags: {
                shape: "S14"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              sourceServer: {
                shape: "S1b"
              }
            }
          }
        },
        CreateLaunchConfigurationTemplate: {
          http: {
            requestUri: "/CreateLaunchConfigurationTemplate",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              copyPrivateIp: {
                type: "boolean"
              },
              copyTags: {
                type: "boolean"
              },
              exportBucketArn: {},
              launchDisposition: {},
              launchIntoSourceInstance: {
                type: "boolean"
              },
              licensing: {
                shape: "S2i"
              },
              postLaunchEnabled: {
                type: "boolean"
              },
              tags: {
                shape: "S14"
              },
              targetInstanceTypeRightSizingMethod: {}
            }
          },
          output: {
            type: "structure",
            members: {
              launchConfigurationTemplate: {
                shape: "S2l"
              }
            }
          }
        },
        CreateReplicationConfigurationTemplate: {
          http: {
            requestUri: "/CreateReplicationConfigurationTemplate",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "associateDefaultSecurityGroup",
              "bandwidthThrottling",
              "createPublicIP",
              "dataPlaneRouting",
              "defaultLargeStagingDiskType",
              "ebsEncryption",
              "pitPolicy",
              "replicationServerInstanceType",
              "replicationServersSecurityGroupsIDs",
              "stagingAreaSubnetId",
              "stagingAreaTags",
              "useDedicatedReplicationServer"
            ],
            members: {
              associateDefaultSecurityGroup: {
                type: "boolean"
              },
              autoReplicateNewDisks: {
                type: "boolean"
              },
              bandwidthThrottling: {
                type: "long"
              },
              createPublicIP: {
                type: "boolean"
              },
              dataPlaneRouting: {},
              defaultLargeStagingDiskType: {},
              ebsEncryption: {},
              ebsEncryptionKeyArn: {},
              pitPolicy: {
                shape: "S2r"
              },
              replicationServerInstanceType: {},
              replicationServersSecurityGroupsIDs: {
                shape: "S2v"
              },
              stagingAreaSubnetId: {},
              stagingAreaTags: {
                shape: "S14"
              },
              tags: {
                shape: "S14"
              },
              useDedicatedReplicationServer: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S2y"
          }
        },
        CreateSourceNetwork: {
          http: {
            requestUri: "/CreateSourceNetwork",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "originAccountID",
              "originRegion",
              "vpcID"
            ],
            members: {
              originAccountID: {},
              originRegion: {},
              tags: {
                shape: "S14"
              },
              vpcID: {}
            }
          },
          output: {
            type: "structure",
            members: {
              sourceNetworkID: {}
            }
          }
        },
        DeleteJob: {
          http: {
            requestUri: "/DeleteJob",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "jobID"
            ],
            members: {
              jobID: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteLaunchAction: {
          http: {
            requestUri: "/DeleteLaunchAction",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "actionId",
              "resourceId"
            ],
            members: {
              actionId: {},
              resourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteLaunchConfigurationTemplate: {
          http: {
            requestUri: "/DeleteLaunchConfigurationTemplate",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "launchConfigurationTemplateID"
            ],
            members: {
              launchConfigurationTemplateID: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteRecoveryInstance: {
          http: {
            requestUri: "/DeleteRecoveryInstance",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "recoveryInstanceID"
            ],
            members: {
              recoveryInstanceID: {}
            }
          }
        },
        DeleteReplicationConfigurationTemplate: {
          http: {
            requestUri: "/DeleteReplicationConfigurationTemplate",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "replicationConfigurationTemplateID"
            ],
            members: {
              replicationConfigurationTemplateID: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteSourceNetwork: {
          http: {
            requestUri: "/DeleteSourceNetwork",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "sourceNetworkID"
            ],
            members: {
              sourceNetworkID: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteSourceServer: {
          http: {
            requestUri: "/DeleteSourceServer",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              sourceServerID: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DescribeJobLogItems: {
          http: {
            requestUri: "/DescribeJobLogItems",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "jobID"
            ],
            members: {
              jobID: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    event: {},
                    eventData: {
                      type: "structure",
                      members: {
                        conversionProperties: {
                          type: "structure",
                          members: {
                            dataTimestamp: {},
                            forceUefi: {
                              type: "boolean"
                            },
                            rootVolumeName: {},
                            volumeToConversionMap: {
                              type: "map",
                              key: {},
                              value: {
                                type: "map",
                                key: {},
                                value: {}
                              }
                            },
                            volumeToVolumeSize: {
                              type: "map",
                              key: {},
                              value: {
                                type: "long"
                              }
                            }
                          }
                        },
                        conversionServerID: {},
                        eventResourceData: {
                          type: "structure",
                          members: {
                            sourceNetworkData: {
                              type: "structure",
                              members: {
                                sourceNetworkID: {},
                                sourceVpc: {},
                                stackName: {},
                                targetVpc: {}
                              }
                            }
                          },
                          union: true
                        },
                        rawError: {},
                        sourceServerID: {},
                        targetInstanceID: {}
                      }
                    },
                    logDateTime: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeJobs: {
          http: {
            requestUri: "/DescribeJobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              filters: {
                type: "structure",
                members: {
                  fromDate: {},
                  jobIDs: {
                    type: "list",
                    member: {}
                  },
                  toDate: {}
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  shape: "S5"
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeLaunchConfigurationTemplates: {
          http: {
            requestUri: "/DescribeLaunchConfigurationTemplates",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              launchConfigurationTemplateIDs: {
                type: "list",
                member: {}
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  shape: "S2l"
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeRecoveryInstances: {
          http: {
            requestUri: "/DescribeRecoveryInstances",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              filters: {
                type: "structure",
                members: {
                  recoveryInstanceIDs: {
                    type: "list",
                    member: {}
                  },
                  sourceServerIDs: {
                    type: "list",
                    member: {}
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    agentVersion: {},
                    arn: {},
                    dataReplicationInfo: {
                      type: "structure",
                      members: {
                        dataReplicationError: {
                          type: "structure",
                          members: {
                            error: {},
                            rawError: {}
                          }
                        },
                        dataReplicationInitiation: {
                          type: "structure",
                          members: {
                            startDateTime: {},
                            steps: {
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  name: {},
                                  status: {}
                                }
                              }
                            }
                          }
                        },
                        dataReplicationState: {},
                        etaDateTime: {},
                        lagDuration: {},
                        replicatedDisks: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              backloggedStorageBytes: {
                                type: "long"
                              },
                              deviceName: {},
                              replicatedStorageBytes: {
                                type: "long"
                              },
                              rescannedStorageBytes: {
                                type: "long"
                              },
                              totalStorageBytes: {
                                type: "long"
                              }
                            }
                          }
                        },
                        stagingAvailabilityZone: {}
                      }
                    },
                    ec2InstanceID: {},
                    ec2InstanceState: {},
                    failback: {
                      type: "structure",
                      members: {
                        agentLastSeenByServiceDateTime: {},
                        elapsedReplicationDuration: {},
                        failbackClientID: {},
                        failbackClientLastSeenByServiceDateTime: {},
                        failbackInitiationTime: {},
                        failbackJobID: {},
                        failbackLaunchType: {},
                        failbackToOriginalServer: {
                          type: "boolean"
                        },
                        firstByteDateTime: {},
                        state: {}
                      }
                    },
                    isDrill: {
                      type: "boolean"
                    },
                    jobID: {},
                    originAvailabilityZone: {},
                    originEnvironment: {},
                    pointInTimeSnapshotDateTime: {},
                    recoveryInstanceID: {},
                    recoveryInstanceProperties: {
                      type: "structure",
                      members: {
                        cpus: {
                          shape: "S23"
                        },
                        disks: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              bytes: {
                                type: "long"
                              },
                              ebsVolumeID: {},
                              internalDeviceName: {}
                            }
                          }
                        },
                        identificationHints: {
                          shape: "S27"
                        },
                        lastUpdatedDateTime: {},
                        networkInterfaces: {
                          shape: "S29"
                        },
                        os: {
                          shape: "S2c"
                        },
                        ramBytes: {
                          type: "long"
                        }
                      }
                    },
                    sourceServerID: {},
                    tags: {
                      shape: "S14"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeRecoverySnapshots: {
          http: {
            requestUri: "/DescribeRecoverySnapshots",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              filters: {
                type: "structure",
                members: {
                  fromDateTime: {},
                  toDateTime: {}
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              order: {},
              sourceServerID: {}
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "expectedTimestamp",
                    "snapshotID",
                    "sourceServerID"
                  ],
                  members: {
                    ebsSnapshots: {
                      type: "list",
                      member: {}
                    },
                    expectedTimestamp: {},
                    snapshotID: {},
                    sourceServerID: {},
                    timestamp: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeReplicationConfigurationTemplates: {
          http: {
            requestUri: "/DescribeReplicationConfigurationTemplates",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              replicationConfigurationTemplateIDs: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  shape: "S2y"
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeSourceNetworks: {
          http: {
            requestUri: "/DescribeSourceNetworks",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              filters: {
                type: "structure",
                members: {
                  originAccountID: {},
                  originRegion: {},
                  sourceNetworkIDs: {
                    type: "list",
                    member: {}
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  shape: "S5d"
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeSourceServers: {
          http: {
            requestUri: "/DescribeSourceServers",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              filters: {
                type: "structure",
                members: {
                  hardwareId: {},
                  sourceServerIDs: {
                    type: "list",
                    member: {}
                  },
                  stagingAccountIDs: {
                    type: "list",
                    member: {}
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  shape: "S1b"
                }
              },
              nextToken: {}
            }
          }
        },
        DisconnectRecoveryInstance: {
          http: {
            requestUri: "/DisconnectRecoveryInstance",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "recoveryInstanceID"
            ],
            members: {
              recoveryInstanceID: {}
            }
          }
        },
        DisconnectSourceServer: {
          http: {
            requestUri: "/DisconnectSourceServer",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              sourceServerID: {}
            }
          },
          output: {
            shape: "S1b"
          }
        },
        ExportSourceNetworkCfnTemplate: {
          http: {
            requestUri: "/ExportSourceNetworkCfnTemplate",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceNetworkID"
            ],
            members: {
              sourceNetworkID: {}
            }
          },
          output: {
            type: "structure",
            members: {
              s3DestinationUrl: {}
            }
          }
        },
        GetFailbackReplicationConfiguration: {
          http: {
            requestUri: "/GetFailbackReplicationConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "recoveryInstanceID"
            ],
            members: {
              recoveryInstanceID: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "recoveryInstanceID"
            ],
            members: {
              bandwidthThrottling: {
                type: "long"
              },
              name: {},
              recoveryInstanceID: {},
              usePrivateIP: {
                type: "boolean"
              }
            }
          }
        },
        GetLaunchConfiguration: {
          http: {
            requestUri: "/GetLaunchConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              sourceServerID: {}
            }
          },
          output: {
            shape: "S5w"
          }
        },
        GetReplicationConfiguration: {
          http: {
            requestUri: "/GetReplicationConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              sourceServerID: {}
            }
          },
          output: {
            shape: "S60"
          }
        },
        InitializeService: {
          http: {
            requestUri: "/InitializeService",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ListExtensibleSourceServers: {
          http: {
            requestUri: "/ListExtensibleSourceServers",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "stagingAccountID"
            ],
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              stagingAccountID: {}
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    hostname: {},
                    tags: {
                      shape: "S14"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListLaunchActions: {
          http: {
            requestUri: "/ListLaunchActions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceId"
            ],
            members: {
              filters: {
                type: "structure",
                members: {
                  actionIds: {
                    type: "list",
                    member: {}
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              resourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  shape: "Sj"
                }
              },
              nextToken: {}
            }
          }
        },
        ListStagingAccounts: {
          http: {
            method: "GET",
            requestUri: "/ListStagingAccounts",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              accounts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    accountID: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S14"
              }
            }
          }
        },
        PutLaunchAction: {
          http: {
            requestUri: "/PutLaunchAction",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "actionCode",
              "actionId",
              "actionVersion",
              "active",
              "category",
              "description",
              "name",
              "optional",
              "order",
              "resourceId"
            ],
            members: {
              actionCode: {},
              actionId: {},
              actionVersion: {},
              active: {
                type: "boolean"
              },
              category: {},
              description: {},
              name: {},
              optional: {
                type: "boolean"
              },
              order: {
                type: "integer"
              },
              parameters: {
                shape: "Ss"
              },
              resourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              actionCode: {},
              actionId: {},
              actionVersion: {},
              active: {
                type: "boolean"
              },
              category: {},
              description: {},
              name: {},
              optional: {
                type: "boolean"
              },
              order: {
                type: "integer"
              },
              parameters: {
                shape: "Ss"
              },
              resourceId: {},
              type: {}
            }
          }
        },
        RetryDataReplication: {
          http: {
            requestUri: "/RetryDataReplication",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              sourceServerID: {}
            },
            deprecated: true,
            deprecatedMessage: "WARNING: RetryDataReplication is deprecated"
          },
          output: {
            shape: "S1b"
          },
          deprecated: true,
          deprecatedMessage: "WARNING: RetryDataReplication is deprecated"
        },
        ReverseReplication: {
          http: {
            requestUri: "/ReverseReplication",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "recoveryInstanceID"
            ],
            members: {
              recoveryInstanceID: {}
            }
          },
          output: {
            type: "structure",
            members: {
              reversedDirectionSourceServerArn: {}
            }
          }
        },
        StartFailbackLaunch: {
          http: {
            requestUri: "/StartFailbackLaunch",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "recoveryInstanceIDs"
            ],
            members: {
              recoveryInstanceIDs: {
                type: "list",
                member: {}
              },
              tags: {
                shape: "S14"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              job: {
                shape: "S5"
              }
            }
          }
        },
        StartRecovery: {
          http: {
            requestUri: "/StartRecovery",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "sourceServers"
            ],
            members: {
              isDrill: {
                type: "boolean"
              },
              sourceServers: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "sourceServerID"
                  ],
                  members: {
                    recoverySnapshotID: {},
                    sourceServerID: {}
                  }
                }
              },
              tags: {
                shape: "S14"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              job: {
                shape: "S5"
              }
            }
          }
        },
        StartReplication: {
          http: {
            requestUri: "/StartReplication",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              sourceServerID: {}
            }
          },
          output: {
            type: "structure",
            members: {
              sourceServer: {
                shape: "S1b"
              }
            }
          }
        },
        StartSourceNetworkRecovery: {
          http: {
            requestUri: "/StartSourceNetworkRecovery",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "sourceNetworks"
            ],
            members: {
              deployAsNew: {
                type: "boolean"
              },
              sourceNetworks: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "sourceNetworkID"
                  ],
                  members: {
                    cfnStackName: {
                      shape: "S2"
                    },
                    sourceNetworkID: {}
                  }
                }
              },
              tags: {
                shape: "S14"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              job: {
                shape: "S5"
              }
            }
          }
        },
        StartSourceNetworkReplication: {
          http: {
            requestUri: "/StartSourceNetworkReplication",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceNetworkID"
            ],
            members: {
              sourceNetworkID: {}
            }
          },
          output: {
            type: "structure",
            members: {
              sourceNetwork: {
                shape: "S5d"
              }
            }
          }
        },
        StopFailback: {
          http: {
            requestUri: "/StopFailback",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "recoveryInstanceID"
            ],
            members: {
              recoveryInstanceID: {}
            }
          }
        },
        StopReplication: {
          http: {
            requestUri: "/StopReplication",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              sourceServerID: {}
            }
          },
          output: {
            type: "structure",
            members: {
              sourceServer: {
                shape: "S1b"
              }
            }
          }
        },
        StopSourceNetworkReplication: {
          http: {
            requestUri: "/StopSourceNetworkReplication",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceNetworkID"
            ],
            members: {
              sourceNetworkID: {}
            }
          },
          output: {
            type: "structure",
            members: {
              sourceNetwork: {
                shape: "S5d"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S14"
              }
            }
          },
          idempotent: true
        },
        TerminateRecoveryInstances: {
          http: {
            requestUri: "/TerminateRecoveryInstances",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "recoveryInstanceIDs"
            ],
            members: {
              recoveryInstanceIDs: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              job: {
                shape: "S5"
              }
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {},
                sensitive: true
              }
            }
          },
          idempotent: true
        },
        UpdateFailbackReplicationConfiguration: {
          http: {
            requestUri: "/UpdateFailbackReplicationConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "recoveryInstanceID"
            ],
            members: {
              bandwidthThrottling: {
                type: "long"
              },
              name: {},
              recoveryInstanceID: {},
              usePrivateIP: {
                type: "boolean"
              }
            }
          }
        },
        UpdateLaunchConfiguration: {
          http: {
            requestUri: "/UpdateLaunchConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              copyPrivateIp: {
                type: "boolean"
              },
              copyTags: {
                type: "boolean"
              },
              launchDisposition: {},
              launchIntoInstanceProperties: {
                shape: "S5x"
              },
              licensing: {
                shape: "S2i"
              },
              name: {},
              postLaunchEnabled: {
                type: "boolean"
              },
              sourceServerID: {},
              targetInstanceTypeRightSizingMethod: {}
            }
          },
          output: {
            shape: "S5w"
          },
          idempotent: true
        },
        UpdateLaunchConfigurationTemplate: {
          http: {
            requestUri: "/UpdateLaunchConfigurationTemplate",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "launchConfigurationTemplateID"
            ],
            members: {
              copyPrivateIp: {
                type: "boolean"
              },
              copyTags: {
                type: "boolean"
              },
              exportBucketArn: {},
              launchConfigurationTemplateID: {},
              launchDisposition: {},
              launchIntoSourceInstance: {
                type: "boolean"
              },
              licensing: {
                shape: "S2i"
              },
              postLaunchEnabled: {
                type: "boolean"
              },
              targetInstanceTypeRightSizingMethod: {}
            }
          },
          output: {
            type: "structure",
            members: {
              launchConfigurationTemplate: {
                shape: "S2l"
              }
            }
          }
        },
        UpdateReplicationConfiguration: {
          http: {
            requestUri: "/UpdateReplicationConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              associateDefaultSecurityGroup: {
                type: "boolean"
              },
              autoReplicateNewDisks: {
                type: "boolean"
              },
              bandwidthThrottling: {
                type: "long"
              },
              createPublicIP: {
                type: "boolean"
              },
              dataPlaneRouting: {},
              defaultLargeStagingDiskType: {},
              ebsEncryption: {},
              ebsEncryptionKeyArn: {},
              name: {},
              pitPolicy: {
                shape: "S2r"
              },
              replicatedDisks: {
                shape: "S61"
              },
              replicationServerInstanceType: {},
              replicationServersSecurityGroupsIDs: {
                shape: "S2v"
              },
              sourceServerID: {},
              stagingAreaSubnetId: {},
              stagingAreaTags: {
                shape: "S14"
              },
              useDedicatedReplicationServer: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S60"
          },
          idempotent: true
        },
        UpdateReplicationConfigurationTemplate: {
          http: {
            requestUri: "/UpdateReplicationConfigurationTemplate",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "replicationConfigurationTemplateID"
            ],
            members: {
              arn: {},
              associateDefaultSecurityGroup: {
                type: "boolean"
              },
              autoReplicateNewDisks: {
                type: "boolean"
              },
              bandwidthThrottling: {
                type: "long"
              },
              createPublicIP: {
                type: "boolean"
              },
              dataPlaneRouting: {},
              defaultLargeStagingDiskType: {},
              ebsEncryption: {},
              ebsEncryptionKeyArn: {},
              pitPolicy: {
                shape: "S2r"
              },
              replicationConfigurationTemplateID: {},
              replicationServerInstanceType: {},
              replicationServersSecurityGroupsIDs: {
                shape: "S2v"
              },
              stagingAreaSubnetId: {},
              stagingAreaTags: {
                shape: "S14"
              },
              useDedicatedReplicationServer: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S2y"
          }
        }
      },
      shapes: {
        S2: {
          type: "string",
          sensitive: true
        },
        S5: {
          type: "structure",
          required: [
            "jobID"
          ],
          members: {
            arn: {},
            creationDateTime: {},
            endDateTime: {},
            initiatedBy: {},
            jobID: {},
            participatingResources: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  launchStatus: {},
                  participatingResourceID: {
                    type: "structure",
                    members: {
                      sourceNetworkID: {}
                    },
                    union: true
                  }
                }
              }
            },
            participatingServers: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  launchActionsStatus: {
                    type: "structure",
                    members: {
                      runs: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            action: {
                              shape: "Sj"
                            },
                            failureReason: {},
                            runId: {},
                            status: {}
                          }
                        }
                      },
                      ssmAgentDiscoveryDatetime: {}
                    }
                  },
                  launchStatus: {},
                  recoveryInstanceID: {},
                  sourceServerID: {}
                }
              }
            },
            status: {},
            tags: {
              shape: "S14"
            },
            type: {}
          }
        },
        Sj: {
          type: "structure",
          members: {
            actionCode: {},
            actionId: {},
            actionVersion: {},
            active: {
              type: "boolean"
            },
            category: {},
            description: {},
            name: {},
            optional: {
              type: "boolean"
            },
            order: {
              type: "integer"
            },
            parameters: {
              shape: "Ss"
            },
            type: {}
          }
        },
        Ss: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              type: {},
              value: {}
            }
          }
        },
        S14: {
          type: "map",
          key: {},
          value: {},
          sensitive: true
        },
        S1b: {
          type: "structure",
          members: {
            agentVersion: {},
            arn: {},
            dataReplicationInfo: {
              type: "structure",
              members: {
                dataReplicationError: {
                  type: "structure",
                  members: {
                    error: {},
                    rawError: {}
                  }
                },
                dataReplicationInitiation: {
                  type: "structure",
                  members: {
                    nextAttemptDateTime: {},
                    startDateTime: {},
                    steps: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          status: {}
                        }
                      }
                    }
                  }
                },
                dataReplicationState: {},
                etaDateTime: {},
                lagDuration: {},
                replicatedDisks: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      backloggedStorageBytes: {
                        type: "long"
                      },
                      deviceName: {},
                      replicatedStorageBytes: {
                        type: "long"
                      },
                      rescannedStorageBytes: {
                        type: "long"
                      },
                      totalStorageBytes: {
                        type: "long"
                      }
                    }
                  }
                },
                stagingAvailabilityZone: {}
              }
            },
            lastLaunchResult: {},
            lifeCycle: {
              type: "structure",
              members: {
                addedToServiceDateTime: {},
                elapsedReplicationDuration: {},
                firstByteDateTime: {},
                lastLaunch: {
                  type: "structure",
                  members: {
                    initiated: {
                      type: "structure",
                      members: {
                        apiCallDateTime: {},
                        jobID: {},
                        type: {}
                      }
                    },
                    status: {}
                  }
                },
                lastSeenByServiceDateTime: {}
              }
            },
            recoveryInstanceId: {},
            replicationDirection: {},
            reversedDirectionSourceServerArn: {},
            sourceCloudProperties: {
              type: "structure",
              members: {
                originAccountID: {},
                originAvailabilityZone: {},
                originRegion: {}
              }
            },
            sourceNetworkID: {},
            sourceProperties: {
              type: "structure",
              members: {
                cpus: {
                  shape: "S23"
                },
                disks: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      bytes: {
                        type: "long"
                      },
                      deviceName: {}
                    }
                  }
                },
                identificationHints: {
                  shape: "S27"
                },
                lastUpdatedDateTime: {},
                networkInterfaces: {
                  shape: "S29"
                },
                os: {
                  shape: "S2c"
                },
                ramBytes: {
                  type: "long"
                },
                recommendedInstanceType: {},
                supportsNitroInstances: {
                  type: "boolean"
                }
              }
            },
            sourceServerID: {},
            stagingArea: {
              type: "structure",
              members: {
                errorMessage: {},
                stagingAccountID: {},
                stagingSourceServerArn: {},
                status: {}
              }
            },
            tags: {
              shape: "S14"
            }
          }
        },
        S23: {
          type: "list",
          member: {
            type: "structure",
            members: {
              cores: {
                type: "long"
              },
              modelName: {}
            }
          }
        },
        S27: {
          type: "structure",
          members: {
            awsInstanceID: {},
            fqdn: {},
            hostname: {},
            vmWareUuid: {}
          }
        },
        S29: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ips: {
                type: "list",
                member: {}
              },
              isPrimary: {
                type: "boolean"
              },
              macAddress: {}
            }
          }
        },
        S2c: {
          type: "structure",
          members: {
            fullString: {}
          }
        },
        S2i: {
          type: "structure",
          members: {
            osByol: {
              type: "boolean"
            }
          }
        },
        S2l: {
          type: "structure",
          members: {
            arn: {},
            copyPrivateIp: {
              type: "boolean"
            },
            copyTags: {
              type: "boolean"
            },
            exportBucketArn: {},
            launchConfigurationTemplateID: {},
            launchDisposition: {},
            launchIntoSourceInstance: {
              type: "boolean"
            },
            licensing: {
              shape: "S2i"
            },
            postLaunchEnabled: {
              type: "boolean"
            },
            tags: {
              shape: "S14"
            },
            targetInstanceTypeRightSizingMethod: {}
          }
        },
        S2r: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "interval",
              "retentionDuration",
              "units"
            ],
            members: {
              enabled: {
                type: "boolean"
              },
              interval: {
                type: "integer"
              },
              retentionDuration: {
                type: "integer"
              },
              ruleID: {
                type: "long"
              },
              units: {}
            }
          }
        },
        S2v: {
          type: "list",
          member: {}
        },
        S2y: {
          type: "structure",
          required: [
            "replicationConfigurationTemplateID"
          ],
          members: {
            arn: {},
            associateDefaultSecurityGroup: {
              type: "boolean"
            },
            autoReplicateNewDisks: {
              type: "boolean"
            },
            bandwidthThrottling: {
              type: "long"
            },
            createPublicIP: {
              type: "boolean"
            },
            dataPlaneRouting: {},
            defaultLargeStagingDiskType: {},
            ebsEncryption: {},
            ebsEncryptionKeyArn: {},
            pitPolicy: {
              shape: "S2r"
            },
            replicationConfigurationTemplateID: {},
            replicationServerInstanceType: {},
            replicationServersSecurityGroupsIDs: {
              shape: "S2v"
            },
            stagingAreaSubnetId: {},
            stagingAreaTags: {
              shape: "S14"
            },
            tags: {
              shape: "S14"
            },
            useDedicatedReplicationServer: {
              type: "boolean"
            }
          }
        },
        S5d: {
          type: "structure",
          members: {
            arn: {},
            cfnStackName: {
              shape: "S2"
            },
            lastRecovery: {
              type: "structure",
              members: {
                apiCallDateTime: {
                  type: "timestamp",
                  timestampFormat: "iso8601"
                },
                jobID: {},
                lastRecoveryResult: {}
              }
            },
            launchedVpcID: {},
            replicationStatus: {},
            replicationStatusDetails: {
              type: "string",
              sensitive: true
            },
            sourceAccountID: {},
            sourceNetworkID: {},
            sourceRegion: {},
            sourceVpcID: {},
            tags: {
              shape: "S14"
            }
          }
        },
        S5w: {
          type: "structure",
          members: {
            copyPrivateIp: {
              type: "boolean"
            },
            copyTags: {
              type: "boolean"
            },
            ec2LaunchTemplateID: {},
            launchDisposition: {},
            launchIntoInstanceProperties: {
              shape: "S5x"
            },
            licensing: {
              shape: "S2i"
            },
            name: {},
            postLaunchEnabled: {
              type: "boolean"
            },
            sourceServerID: {},
            targetInstanceTypeRightSizingMethod: {}
          }
        },
        S5x: {
          type: "structure",
          members: {
            launchIntoEC2InstanceID: {}
          }
        },
        S60: {
          type: "structure",
          members: {
            associateDefaultSecurityGroup: {
              type: "boolean"
            },
            autoReplicateNewDisks: {
              type: "boolean"
            },
            bandwidthThrottling: {
              type: "long"
            },
            createPublicIP: {
              type: "boolean"
            },
            dataPlaneRouting: {},
            defaultLargeStagingDiskType: {},
            ebsEncryption: {},
            ebsEncryptionKeyArn: {},
            name: {},
            pitPolicy: {
              shape: "S2r"
            },
            replicatedDisks: {
              shape: "S61"
            },
            replicationServerInstanceType: {},
            replicationServersSecurityGroupsIDs: {
              shape: "S2v"
            },
            sourceServerID: {},
            stagingAreaSubnetId: {},
            stagingAreaTags: {
              shape: "S14"
            },
            useDedicatedReplicationServer: {
              type: "boolean"
            }
          }
        },
        S61: {
          type: "list",
          member: {
            type: "structure",
            members: {
              deviceName: {},
              iops: {
                type: "long"
              },
              isBootDisk: {
                type: "boolean"
              },
              optimizedStagingDiskType: {},
              stagingDiskType: {},
              throughput: {
                type: "long"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/drs-2020-02-26.paginators.json
var require_drs_2020_02_26_paginators = __commonJS({
  "node_modules/aws-sdk/apis/drs-2020-02-26.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeJobLogItems: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        DescribeJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        DescribeLaunchConfigurationTemplates: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        DescribeRecoveryInstances: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        DescribeRecoverySnapshots: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        DescribeReplicationConfigurationTemplates: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        DescribeSourceNetworks: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        DescribeSourceServers: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListExtensibleSourceServers: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListLaunchActions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListStagingAccounts: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "accounts"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/drs.js
var require_drs = __commonJS({
  "node_modules/aws-sdk/clients/drs.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["drs"] = {};
    AWS2.Drs = Service.defineService("drs", ["2020-02-26"]);
    Object.defineProperty(apiLoader.services["drs"], "2020-02-26", {
      get: function get() {
        var model = require_drs_2020_02_26_min();
        model.paginators = require_drs_2020_02_26_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Drs;
  }
});

// node_modules/aws-sdk/apis/migration-hub-refactor-spaces-2021-10-26.min.json
var require_migration_hub_refactor_spaces_2021_10_26_min = __commonJS({
  "node_modules/aws-sdk/apis/migration-hub-refactor-spaces-2021-10-26.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-10-26",
        endpointPrefix: "refactor-spaces",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Migration Hub Refactor Spaces",
        serviceId: "Migration Hub Refactor Spaces",
        signatureVersion: "v4",
        signingName: "refactor-spaces",
        uid: "migration-hub-refactor-spaces-2021-10-26"
      },
      operations: {
        CreateApplication: {
          http: {
            requestUri: "/environments/{EnvironmentIdentifier}/applications",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "EnvironmentIdentifier",
              "Name",
              "ProxyType",
              "VpcId"
            ],
            members: {
              ApiGatewayProxy: {
                shape: "S2"
              },
              ClientToken: {
                idempotencyToken: true
              },
              EnvironmentIdentifier: {
                location: "uri",
                locationName: "EnvironmentIdentifier"
              },
              Name: {},
              ProxyType: {},
              Tags: {
                shape: "S9"
              },
              VpcId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApiGatewayProxy: {
                shape: "S2"
              },
              ApplicationId: {},
              Arn: {},
              CreatedByAccountId: {},
              CreatedTime: {
                type: "timestamp"
              },
              EnvironmentId: {},
              LastUpdatedTime: {
                type: "timestamp"
              },
              Name: {},
              OwnerAccountId: {},
              ProxyType: {},
              State: {},
              Tags: {
                shape: "S9"
              },
              VpcId: {}
            }
          }
        },
        CreateEnvironment: {
          http: {
            requestUri: "/environments",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "NetworkFabricType"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              Description: {},
              Name: {},
              NetworkFabricType: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreatedTime: {
                type: "timestamp"
              },
              Description: {},
              EnvironmentId: {},
              LastUpdatedTime: {
                type: "timestamp"
              },
              Name: {},
              NetworkFabricType: {},
              OwnerAccountId: {},
              State: {},
              Tags: {
                shape: "S9"
              }
            }
          }
        },
        CreateRoute: {
          http: {
            requestUri: "/environments/{EnvironmentIdentifier}/applications/{ApplicationIdentifier}/routes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationIdentifier",
              "EnvironmentIdentifier",
              "RouteType",
              "ServiceIdentifier"
            ],
            members: {
              ApplicationIdentifier: {
                location: "uri",
                locationName: "ApplicationIdentifier"
              },
              ClientToken: {
                idempotencyToken: true
              },
              DefaultRoute: {
                type: "structure",
                members: {
                  ActivationState: {}
                }
              },
              EnvironmentIdentifier: {
                location: "uri",
                locationName: "EnvironmentIdentifier"
              },
              RouteType: {},
              ServiceIdentifier: {},
              Tags: {
                shape: "S9"
              },
              UriPathRoute: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationId: {},
              Arn: {},
              CreatedByAccountId: {},
              CreatedTime: {
                type: "timestamp"
              },
              LastUpdatedTime: {
                type: "timestamp"
              },
              OwnerAccountId: {},
              RouteId: {},
              RouteType: {},
              ServiceId: {},
              State: {},
              Tags: {
                shape: "S9"
              },
              UriPathRoute: {
                shape: "Su"
              }
            }
          }
        },
        CreateService: {
          http: {
            requestUri: "/environments/{EnvironmentIdentifier}/applications/{ApplicationIdentifier}/services",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationIdentifier",
              "EndpointType",
              "EnvironmentIdentifier",
              "Name"
            ],
            members: {
              ApplicationIdentifier: {
                location: "uri",
                locationName: "ApplicationIdentifier"
              },
              ClientToken: {
                idempotencyToken: true
              },
              Description: {},
              EndpointType: {},
              EnvironmentIdentifier: {
                location: "uri",
                locationName: "EnvironmentIdentifier"
              },
              LambdaEndpoint: {
                shape: "S14"
              },
              Name: {},
              Tags: {
                shape: "S9"
              },
              UrlEndpoint: {
                shape: "S17"
              },
              VpcId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationId: {},
              Arn: {},
              CreatedByAccountId: {},
              CreatedTime: {
                type: "timestamp"
              },
              Description: {},
              EndpointType: {},
              EnvironmentId: {},
              LambdaEndpoint: {
                shape: "S14"
              },
              LastUpdatedTime: {
                type: "timestamp"
              },
              Name: {},
              OwnerAccountId: {},
              ServiceId: {},
              State: {},
              Tags: {
                shape: "S9"
              },
              UrlEndpoint: {
                shape: "S17"
              },
              VpcId: {}
            }
          }
        },
        DeleteApplication: {
          http: {
            method: "DELETE",
            requestUri: "/environments/{EnvironmentIdentifier}/applications/{ApplicationIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationIdentifier",
              "EnvironmentIdentifier"
            ],
            members: {
              ApplicationIdentifier: {
                location: "uri",
                locationName: "ApplicationIdentifier"
              },
              EnvironmentIdentifier: {
                location: "uri",
                locationName: "EnvironmentIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationId: {},
              Arn: {},
              EnvironmentId: {},
              LastUpdatedTime: {
                type: "timestamp"
              },
              Name: {},
              State: {}
            }
          },
          idempotent: true
        },
        DeleteEnvironment: {
          http: {
            method: "DELETE",
            requestUri: "/environments/{EnvironmentIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "EnvironmentIdentifier"
            ],
            members: {
              EnvironmentIdentifier: {
                location: "uri",
                locationName: "EnvironmentIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              EnvironmentId: {},
              LastUpdatedTime: {
                type: "timestamp"
              },
              Name: {},
              State: {}
            }
          },
          idempotent: true
        },
        DeleteResourcePolicy: {
          http: {
            method: "DELETE",
            requestUri: "/resourcepolicy/{Identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Identifier"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "Identifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteRoute: {
          http: {
            method: "DELETE",
            requestUri: "/environments/{EnvironmentIdentifier}/applications/{ApplicationIdentifier}/routes/{RouteIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationIdentifier",
              "EnvironmentIdentifier",
              "RouteIdentifier"
            ],
            members: {
              ApplicationIdentifier: {
                location: "uri",
                locationName: "ApplicationIdentifier"
              },
              EnvironmentIdentifier: {
                location: "uri",
                locationName: "EnvironmentIdentifier"
              },
              RouteIdentifier: {
                location: "uri",
                locationName: "RouteIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationId: {},
              Arn: {},
              LastUpdatedTime: {
                type: "timestamp"
              },
              RouteId: {},
              ServiceId: {},
              State: {}
            }
          },
          idempotent: true
        },
        DeleteService: {
          http: {
            method: "DELETE",
            requestUri: "/environments/{EnvironmentIdentifier}/applications/{ApplicationIdentifier}/services/{ServiceIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationIdentifier",
              "EnvironmentIdentifier",
              "ServiceIdentifier"
            ],
            members: {
              ApplicationIdentifier: {
                location: "uri",
                locationName: "ApplicationIdentifier"
              },
              EnvironmentIdentifier: {
                location: "uri",
                locationName: "EnvironmentIdentifier"
              },
              ServiceIdentifier: {
                location: "uri",
                locationName: "ServiceIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationId: {},
              Arn: {},
              EnvironmentId: {},
              LastUpdatedTime: {
                type: "timestamp"
              },
              Name: {},
              ServiceId: {},
              State: {}
            }
          },
          idempotent: true
        },
        GetApplication: {
          http: {
            method: "GET",
            requestUri: "/environments/{EnvironmentIdentifier}/applications/{ApplicationIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationIdentifier",
              "EnvironmentIdentifier"
            ],
            members: {
              ApplicationIdentifier: {
                location: "uri",
                locationName: "ApplicationIdentifier"
              },
              EnvironmentIdentifier: {
                location: "uri",
                locationName: "EnvironmentIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApiGatewayProxy: {
                type: "structure",
                members: {
                  ApiGatewayId: {},
                  EndpointType: {},
                  NlbArn: {},
                  NlbName: {},
                  ProxyUrl: {},
                  StageName: {},
                  VpcLinkId: {}
                }
              },
              ApplicationId: {},
              Arn: {},
              CreatedByAccountId: {},
              CreatedTime: {
                type: "timestamp"
              },
              EnvironmentId: {},
              Error: {
                shape: "S1t"
              },
              LastUpdatedTime: {
                type: "timestamp"
              },
              Name: {},
              OwnerAccountId: {},
              ProxyType: {},
              State: {},
              Tags: {
                shape: "S9"
              },
              VpcId: {}
            }
          }
        },
        GetEnvironment: {
          http: {
            method: "GET",
            requestUri: "/environments/{EnvironmentIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "EnvironmentIdentifier"
            ],
            members: {
              EnvironmentIdentifier: {
                location: "uri",
                locationName: "EnvironmentIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreatedTime: {
                type: "timestamp"
              },
              Description: {},
              EnvironmentId: {},
              Error: {
                shape: "S1t"
              },
              LastUpdatedTime: {
                type: "timestamp"
              },
              Name: {},
              NetworkFabricType: {},
              OwnerAccountId: {},
              State: {},
              Tags: {
                shape: "S9"
              },
              TransitGatewayId: {}
            }
          }
        },
        GetResourcePolicy: {
          http: {
            method: "GET",
            requestUri: "/resourcepolicy/{Identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Identifier"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "Identifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {}
            }
          }
        },
        GetRoute: {
          http: {
            method: "GET",
            requestUri: "/environments/{EnvironmentIdentifier}/applications/{ApplicationIdentifier}/routes/{RouteIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationIdentifier",
              "EnvironmentIdentifier",
              "RouteIdentifier"
            ],
            members: {
              ApplicationIdentifier: {
                location: "uri",
                locationName: "ApplicationIdentifier"
              },
              EnvironmentIdentifier: {
                location: "uri",
                locationName: "EnvironmentIdentifier"
              },
              RouteIdentifier: {
                location: "uri",
                locationName: "RouteIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppendSourcePath: {
                type: "boolean"
              },
              ApplicationId: {},
              Arn: {},
              CreatedByAccountId: {},
              CreatedTime: {
                type: "timestamp"
              },
              EnvironmentId: {},
              Error: {
                shape: "S1t"
              },
              IncludeChildPaths: {
                type: "boolean"
              },
              LastUpdatedTime: {
                type: "timestamp"
              },
              Methods: {
                shape: "Sw"
              },
              OwnerAccountId: {},
              PathResourceToId: {
                shape: "S29"
              },
              RouteId: {},
              RouteType: {},
              ServiceId: {},
              SourcePath: {},
              State: {},
              Tags: {
                shape: "S9"
              }
            }
          }
        },
        GetService: {
          http: {
            method: "GET",
            requestUri: "/environments/{EnvironmentIdentifier}/applications/{ApplicationIdentifier}/services/{ServiceIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationIdentifier",
              "EnvironmentIdentifier",
              "ServiceIdentifier"
            ],
            members: {
              ApplicationIdentifier: {
                location: "uri",
                locationName: "ApplicationIdentifier"
              },
              EnvironmentIdentifier: {
                location: "uri",
                locationName: "EnvironmentIdentifier"
              },
              ServiceIdentifier: {
                location: "uri",
                locationName: "ServiceIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationId: {},
              Arn: {},
              CreatedByAccountId: {},
              CreatedTime: {
                type: "timestamp"
              },
              Description: {},
              EndpointType: {},
              EnvironmentId: {},
              Error: {
                shape: "S1t"
              },
              LambdaEndpoint: {
                type: "structure",
                members: {
                  Arn: {}
                }
              },
              LastUpdatedTime: {
                type: "timestamp"
              },
              Name: {},
              OwnerAccountId: {},
              ServiceId: {},
              State: {},
              Tags: {
                shape: "S9"
              },
              UrlEndpoint: {
                type: "structure",
                members: {
                  HealthUrl: {},
                  Url: {}
                }
              },
              VpcId: {}
            }
          }
        },
        ListApplications: {
          http: {
            method: "GET",
            requestUri: "/environments/{EnvironmentIdentifier}/applications",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "EnvironmentIdentifier"
            ],
            members: {
              EnvironmentIdentifier: {
                location: "uri",
                locationName: "EnvironmentIdentifier"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApiGatewayProxy: {
                      type: "structure",
                      members: {
                        ApiGatewayId: {},
                        EndpointType: {},
                        NlbArn: {},
                        NlbName: {},
                        ProxyUrl: {},
                        StageName: {},
                        VpcLinkId: {}
                      }
                    },
                    ApplicationId: {},
                    Arn: {},
                    CreatedByAccountId: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    EnvironmentId: {},
                    Error: {
                      shape: "S1t"
                    },
                    LastUpdatedTime: {
                      type: "timestamp"
                    },
                    Name: {},
                    OwnerAccountId: {},
                    ProxyType: {},
                    State: {},
                    Tags: {
                      shape: "S9"
                    },
                    VpcId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEnvironmentVpcs: {
          http: {
            method: "GET",
            requestUri: "/environments/{EnvironmentIdentifier}/vpcs",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "EnvironmentIdentifier"
            ],
            members: {
              EnvironmentIdentifier: {
                location: "uri",
                locationName: "EnvironmentIdentifier"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EnvironmentVpcList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AccountId: {},
                    CidrBlocks: {
                      type: "list",
                      member: {}
                    },
                    CreatedTime: {
                      type: "timestamp"
                    },
                    EnvironmentId: {},
                    LastUpdatedTime: {
                      type: "timestamp"
                    },
                    VpcId: {},
                    VpcName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEnvironments: {
          http: {
            method: "GET",
            requestUri: "/environments",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EnvironmentSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    Description: {},
                    EnvironmentId: {},
                    Error: {
                      shape: "S1t"
                    },
                    LastUpdatedTime: {
                      type: "timestamp"
                    },
                    Name: {},
                    NetworkFabricType: {},
                    OwnerAccountId: {},
                    State: {},
                    Tags: {
                      shape: "S9"
                    },
                    TransitGatewayId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListRoutes: {
          http: {
            method: "GET",
            requestUri: "/environments/{EnvironmentIdentifier}/applications/{ApplicationIdentifier}/routes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationIdentifier",
              "EnvironmentIdentifier"
            ],
            members: {
              ApplicationIdentifier: {
                location: "uri",
                locationName: "ApplicationIdentifier"
              },
              EnvironmentIdentifier: {
                location: "uri",
                locationName: "EnvironmentIdentifier"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              RouteSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AppendSourcePath: {
                      type: "boolean"
                    },
                    ApplicationId: {},
                    Arn: {},
                    CreatedByAccountId: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    EnvironmentId: {},
                    Error: {
                      shape: "S1t"
                    },
                    IncludeChildPaths: {
                      type: "boolean"
                    },
                    LastUpdatedTime: {
                      type: "timestamp"
                    },
                    Methods: {
                      shape: "Sw"
                    },
                    OwnerAccountId: {},
                    PathResourceToId: {
                      shape: "S29"
                    },
                    RouteId: {},
                    RouteType: {},
                    ServiceId: {},
                    SourcePath: {},
                    State: {},
                    Tags: {
                      shape: "S9"
                    }
                  }
                }
              }
            }
          }
        },
        ListServices: {
          http: {
            method: "GET",
            requestUri: "/environments/{EnvironmentIdentifier}/applications/{ApplicationIdentifier}/services",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationIdentifier",
              "EnvironmentIdentifier"
            ],
            members: {
              ApplicationIdentifier: {
                location: "uri",
                locationName: "ApplicationIdentifier"
              },
              EnvironmentIdentifier: {
                location: "uri",
                locationName: "EnvironmentIdentifier"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ServiceSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApplicationId: {},
                    Arn: {},
                    CreatedByAccountId: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    Description: {},
                    EndpointType: {},
                    EnvironmentId: {},
                    Error: {
                      shape: "S1t"
                    },
                    LambdaEndpoint: {
                      type: "structure",
                      members: {
                        Arn: {}
                      }
                    },
                    LastUpdatedTime: {
                      type: "timestamp"
                    },
                    Name: {},
                    OwnerAccountId: {},
                    ServiceId: {},
                    State: {},
                    Tags: {
                      shape: "S9"
                    },
                    UrlEndpoint: {
                      type: "structure",
                      members: {
                        HealthUrl: {},
                        Url: {}
                      }
                    },
                    VpcId: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S9"
              }
            }
          }
        },
        PutResourcePolicy: {
          http: {
            method: "PUT",
            requestUri: "/resourcepolicy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Policy",
              "ResourceArn"
            ],
            members: {
              Policy: {},
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        TagResource: {
          http: {
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {},
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateRoute: {
          http: {
            method: "PATCH",
            requestUri: "/environments/{EnvironmentIdentifier}/applications/{ApplicationIdentifier}/routes/{RouteIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ActivationState",
              "ApplicationIdentifier",
              "EnvironmentIdentifier",
              "RouteIdentifier"
            ],
            members: {
              ActivationState: {},
              ApplicationIdentifier: {
                location: "uri",
                locationName: "ApplicationIdentifier"
              },
              EnvironmentIdentifier: {
                location: "uri",
                locationName: "EnvironmentIdentifier"
              },
              RouteIdentifier: {
                location: "uri",
                locationName: "RouteIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationId: {},
              Arn: {},
              LastUpdatedTime: {
                type: "timestamp"
              },
              RouteId: {},
              ServiceId: {},
              State: {}
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          members: {
            EndpointType: {},
            StageName: {}
          }
        },
        S9: {
          type: "map",
          key: {},
          value: {},
          sensitive: true
        },
        Su: {
          type: "structure",
          required: [
            "ActivationState",
            "SourcePath"
          ],
          members: {
            ActivationState: {},
            AppendSourcePath: {
              type: "boolean"
            },
            IncludeChildPaths: {
              type: "boolean"
            },
            Methods: {
              shape: "Sw"
            },
            SourcePath: {}
          }
        },
        Sw: {
          type: "list",
          member: {}
        },
        S14: {
          type: "structure",
          required: [
            "Arn"
          ],
          members: {
            Arn: {}
          }
        },
        S17: {
          type: "structure",
          required: [
            "Url"
          ],
          members: {
            HealthUrl: {},
            Url: {}
          }
        },
        S1t: {
          type: "structure",
          members: {
            AccountId: {},
            AdditionalDetails: {
              type: "map",
              key: {},
              value: {}
            },
            Code: {},
            Message: {},
            ResourceIdentifier: {},
            ResourceType: {}
          }
        },
        S29: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/migration-hub-refactor-spaces-2021-10-26.paginators.json
var require_migration_hub_refactor_spaces_2021_10_26_paginators = __commonJS({
  "node_modules/aws-sdk/apis/migration-hub-refactor-spaces-2021-10-26.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListApplications: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ApplicationSummaryList"
        },
        ListEnvironmentVpcs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "EnvironmentVpcList"
        },
        ListEnvironments: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "EnvironmentSummaryList"
        },
        ListRoutes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "RouteSummaryList"
        },
        ListServices: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ServiceSummaryList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/migrationhubrefactorspaces.js
var require_migrationhubrefactorspaces = __commonJS({
  "node_modules/aws-sdk/clients/migrationhubrefactorspaces.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["migrationhubrefactorspaces"] = {};
    AWS2.MigrationHubRefactorSpaces = Service.defineService("migrationhubrefactorspaces", ["2021-10-26"]);
    Object.defineProperty(apiLoader.services["migrationhubrefactorspaces"], "2021-10-26", {
      get: function get() {
        var model = require_migration_hub_refactor_spaces_2021_10_26_min();
        model.paginators = require_migration_hub_refactor_spaces_2021_10_26_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.MigrationHubRefactorSpaces;
  }
});

// node_modules/aws-sdk/apis/evidently-2021-02-01.min.json
var require_evidently_2021_02_01_min = __commonJS({
  "node_modules/aws-sdk/apis/evidently-2021-02-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-02-01",
        endpointPrefix: "evidently",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon CloudWatch Evidently",
        serviceId: "Evidently",
        signatureVersion: "v4",
        signingName: "evidently",
        uid: "evidently-2021-02-01"
      },
      operations: {
        BatchEvaluateFeature: {
          http: {
            requestUri: "/projects/{project}/evaluations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "project",
              "requests"
            ],
            members: {
              project: {
                location: "uri",
                locationName: "project"
              },
              requests: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "entityId",
                    "feature"
                  ],
                  members: {
                    entityId: {},
                    evaluationContext: {
                      jsonvalue: true
                    },
                    feature: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              results: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "entityId",
                    "feature"
                  ],
                  members: {
                    details: {
                      jsonvalue: true
                    },
                    entityId: {},
                    feature: {},
                    project: {},
                    reason: {},
                    value: {
                      shape: "Sd"
                    },
                    variation: {}
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "dataplane."
          }
        },
        CreateExperiment: {
          http: {
            requestUri: "/projects/{project}/experiments",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "metricGoals",
              "name",
              "project",
              "treatments"
            ],
            members: {
              description: {},
              metricGoals: {
                shape: "Sk"
              },
              name: {},
              onlineAbConfig: {
                shape: "St"
              },
              project: {
                location: "uri",
                locationName: "project"
              },
              randomizationSalt: {},
              samplingRate: {
                type: "long"
              },
              segment: {},
              tags: {
                shape: "Sz"
              },
              treatments: {
                shape: "S12"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "experiment"
            ],
            members: {
              experiment: {
                shape: "S16"
              }
            }
          },
          idempotent: true
        },
        CreateFeature: {
          http: {
            requestUri: "/projects/{project}/features",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "project",
              "variations"
            ],
            members: {
              defaultVariation: {},
              description: {},
              entityOverrides: {
                shape: "S1n"
              },
              evaluationStrategy: {},
              name: {},
              project: {
                location: "uri",
                locationName: "project"
              },
              tags: {
                shape: "Sz"
              },
              variations: {
                shape: "S1p"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              feature: {
                shape: "S1s"
              }
            }
          }
        },
        CreateLaunch: {
          http: {
            requestUri: "/projects/{project}/launches",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "groups",
              "name",
              "project"
            ],
            members: {
              description: {},
              groups: {
                shape: "S23"
              },
              metricMonitors: {
                shape: "S26"
              },
              name: {},
              project: {
                location: "uri",
                locationName: "project"
              },
              randomizationSalt: {},
              scheduledSplitsConfig: {
                shape: "S29"
              },
              tags: {
                shape: "Sz"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "launch"
            ],
            members: {
              launch: {
                shape: "S2h"
              }
            }
          }
        },
        CreateProject: {
          http: {
            requestUri: "/projects",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              appConfigResource: {
                shape: "S2u"
              },
              dataDelivery: {
                type: "structure",
                members: {
                  cloudWatchLogs: {
                    shape: "S2x"
                  },
                  s3Destination: {
                    shape: "S2z"
                  }
                }
              },
              description: {},
              name: {},
              tags: {
                shape: "Sz"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "project"
            ],
            members: {
              project: {
                shape: "S34"
              }
            }
          }
        },
        CreateSegment: {
          http: {
            requestUri: "/segments",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "pattern"
            ],
            members: {
              description: {},
              name: {},
              pattern: {
                jsonvalue: true
              },
              tags: {
                shape: "Sz"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "segment"
            ],
            members: {
              segment: {
                shape: "S3e"
              }
            }
          }
        },
        DeleteExperiment: {
          http: {
            method: "DELETE",
            requestUri: "/projects/{project}/experiments/{experiment}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "experiment",
              "project"
            ],
            members: {
              experiment: {
                location: "uri",
                locationName: "experiment"
              },
              project: {
                location: "uri",
                locationName: "project"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteFeature: {
          http: {
            method: "DELETE",
            requestUri: "/projects/{project}/features/{feature}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "feature",
              "project"
            ],
            members: {
              feature: {
                location: "uri",
                locationName: "feature"
              },
              project: {
                location: "uri",
                locationName: "project"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteLaunch: {
          http: {
            method: "DELETE",
            requestUri: "/projects/{project}/launches/{launch}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "launch",
              "project"
            ],
            members: {
              launch: {
                location: "uri",
                locationName: "launch"
              },
              project: {
                location: "uri",
                locationName: "project"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteProject: {
          http: {
            method: "DELETE",
            requestUri: "/projects/{project}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "project"
            ],
            members: {
              project: {
                location: "uri",
                locationName: "project"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteSegment: {
          http: {
            method: "DELETE",
            requestUri: "/segments/{segment}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "segment"
            ],
            members: {
              segment: {
                location: "uri",
                locationName: "segment"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        EvaluateFeature: {
          http: {
            requestUri: "/projects/{project}/evaluations/{feature}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "entityId",
              "feature",
              "project"
            ],
            members: {
              entityId: {},
              evaluationContext: {
                jsonvalue: true
              },
              feature: {
                location: "uri",
                locationName: "feature"
              },
              project: {
                location: "uri",
                locationName: "project"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              details: {
                jsonvalue: true
              },
              reason: {},
              value: {
                shape: "Sd"
              },
              variation: {}
            }
          },
          endpoint: {
            hostPrefix: "dataplane."
          }
        },
        GetExperiment: {
          http: {
            method: "GET",
            requestUri: "/projects/{project}/experiments/{experiment}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "experiment",
              "project"
            ],
            members: {
              experiment: {
                location: "uri",
                locationName: "experiment"
              },
              project: {
                location: "uri",
                locationName: "project"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              experiment: {
                shape: "S16"
              }
            }
          }
        },
        GetExperimentResults: {
          http: {
            requestUri: "/projects/{project}/experiments/{experiment}/results",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "experiment",
              "metricNames",
              "project",
              "treatmentNames"
            ],
            members: {
              baseStat: {},
              endTime: {
                type: "timestamp"
              },
              experiment: {
                location: "uri",
                locationName: "experiment"
              },
              metricNames: {
                type: "list",
                member: {}
              },
              period: {
                type: "long"
              },
              project: {
                location: "uri",
                locationName: "project"
              },
              reportNames: {
                type: "list",
                member: {}
              },
              resultStats: {
                type: "list",
                member: {}
              },
              startTime: {
                type: "timestamp"
              },
              treatmentNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              details: {},
              reports: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    content: {
                      jsonvalue: true
                    },
                    metricName: {},
                    reportName: {},
                    treatmentName: {}
                  }
                }
              },
              resultsData: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    metricName: {},
                    resultStat: {},
                    treatmentName: {},
                    values: {
                      type: "list",
                      member: {
                        type: "double"
                      }
                    }
                  }
                }
              },
              timestamps: {
                type: "list",
                member: {
                  type: "timestamp"
                }
              }
            }
          }
        },
        GetFeature: {
          http: {
            method: "GET",
            requestUri: "/projects/{project}/features/{feature}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "feature",
              "project"
            ],
            members: {
              feature: {
                location: "uri",
                locationName: "feature"
              },
              project: {
                location: "uri",
                locationName: "project"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "feature"
            ],
            members: {
              feature: {
                shape: "S1s"
              }
            }
          }
        },
        GetLaunch: {
          http: {
            method: "GET",
            requestUri: "/projects/{project}/launches/{launch}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "launch",
              "project"
            ],
            members: {
              launch: {
                location: "uri",
                locationName: "launch"
              },
              project: {
                location: "uri",
                locationName: "project"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              launch: {
                shape: "S2h"
              }
            }
          }
        },
        GetProject: {
          http: {
            method: "GET",
            requestUri: "/projects/{project}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "project"
            ],
            members: {
              project: {
                location: "uri",
                locationName: "project"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "project"
            ],
            members: {
              project: {
                shape: "S34"
              }
            }
          }
        },
        GetSegment: {
          http: {
            method: "GET",
            requestUri: "/segments/{segment}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "segment"
            ],
            members: {
              segment: {
                location: "uri",
                locationName: "segment"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "segment"
            ],
            members: {
              segment: {
                shape: "S3e"
              }
            }
          }
        },
        ListExperiments: {
          http: {
            method: "GET",
            requestUri: "/projects/{project}/experiments",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "project"
            ],
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              project: {
                location: "uri",
                locationName: "project"
              },
              status: {
                location: "querystring",
                locationName: "status"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              experiments: {
                type: "list",
                member: {
                  shape: "S16"
                }
              },
              nextToken: {}
            }
          }
        },
        ListFeatures: {
          http: {
            method: "GET",
            requestUri: "/projects/{project}/features",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "project"
            ],
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              project: {
                location: "uri",
                locationName: "project"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              features: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdTime",
                    "evaluationStrategy",
                    "lastUpdatedTime",
                    "name",
                    "status"
                  ],
                  members: {
                    arn: {},
                    createdTime: {
                      type: "timestamp"
                    },
                    defaultVariation: {},
                    evaluationRules: {
                      shape: "S1u"
                    },
                    evaluationStrategy: {},
                    lastUpdatedTime: {
                      type: "timestamp"
                    },
                    name: {},
                    project: {},
                    status: {},
                    tags: {
                      shape: "Sz"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListLaunches: {
          http: {
            method: "GET",
            requestUri: "/projects/{project}/launches",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "project"
            ],
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              project: {
                location: "uri",
                locationName: "project"
              },
              status: {
                location: "querystring",
                locationName: "status"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              launches: {
                type: "list",
                member: {
                  shape: "S2h"
                }
              },
              nextToken: {}
            }
          }
        },
        ListProjects: {
          http: {
            method: "GET",
            requestUri: "/projects",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              projects: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdTime",
                    "lastUpdatedTime",
                    "name",
                    "status"
                  ],
                  members: {
                    activeExperimentCount: {
                      type: "long"
                    },
                    activeLaunchCount: {
                      type: "long"
                    },
                    arn: {},
                    createdTime: {
                      type: "timestamp"
                    },
                    description: {},
                    experimentCount: {
                      type: "long"
                    },
                    featureCount: {
                      type: "long"
                    },
                    lastUpdatedTime: {
                      type: "timestamp"
                    },
                    launchCount: {
                      type: "long"
                    },
                    name: {},
                    status: {},
                    tags: {
                      shape: "Sz"
                    }
                  }
                }
              }
            }
          }
        },
        ListSegmentReferences: {
          http: {
            method: "GET",
            requestUri: "/segments/{segment}/references",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "segment",
              "type"
            ],
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              segment: {
                location: "uri",
                locationName: "segment"
              },
              type: {
                location: "querystring",
                locationName: "type"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              referencedBy: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "type"
                  ],
                  members: {
                    arn: {},
                    endTime: {},
                    lastUpdatedOn: {},
                    name: {},
                    startTime: {},
                    status: {},
                    type: {}
                  }
                }
              }
            }
          }
        },
        ListSegments: {
          http: {
            method: "GET",
            requestUri: "/segments",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              segments: {
                type: "list",
                member: {
                  shape: "S3e"
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sz"
              }
            }
          }
        },
        PutProjectEvents: {
          http: {
            requestUri: "/events/projects/{project}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "events",
              "project"
            ],
            members: {
              events: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "data",
                    "timestamp",
                    "type"
                  ],
                  members: {
                    data: {
                      jsonvalue: true
                    },
                    timestamp: {
                      type: "timestamp"
                    },
                    type: {}
                  }
                }
              },
              project: {
                location: "uri",
                locationName: "project"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              eventResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    errorCode: {},
                    errorMessage: {},
                    eventId: {}
                  }
                }
              },
              failedEventCount: {
                type: "integer"
              }
            }
          },
          endpoint: {
            hostPrefix: "dataplane."
          }
        },
        StartExperiment: {
          http: {
            requestUri: "/projects/{project}/experiments/{experiment}/start",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analysisCompleteTime",
              "experiment",
              "project"
            ],
            members: {
              analysisCompleteTime: {
                type: "timestamp"
              },
              experiment: {
                location: "uri",
                locationName: "experiment"
              },
              project: {
                location: "uri",
                locationName: "project"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              startedTime: {
                type: "timestamp"
              }
            }
          }
        },
        StartLaunch: {
          http: {
            requestUri: "/projects/{project}/launches/{launch}/start",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "launch",
              "project"
            ],
            members: {
              launch: {
                location: "uri",
                locationName: "launch"
              },
              project: {
                location: "uri",
                locationName: "project"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "launch"
            ],
            members: {
              launch: {
                shape: "S2h"
              }
            }
          }
        },
        StopExperiment: {
          http: {
            requestUri: "/projects/{project}/experiments/{experiment}/cancel",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "experiment",
              "project"
            ],
            members: {
              desiredState: {},
              experiment: {
                location: "uri",
                locationName: "experiment"
              },
              project: {
                location: "uri",
                locationName: "project"
              },
              reason: {}
            }
          },
          output: {
            type: "structure",
            members: {
              endedTime: {
                type: "timestamp"
              }
            }
          }
        },
        StopLaunch: {
          http: {
            requestUri: "/projects/{project}/launches/{launch}/cancel",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "launch",
              "project"
            ],
            members: {
              desiredState: {},
              launch: {
                location: "uri",
                locationName: "launch"
              },
              project: {
                location: "uri",
                locationName: "project"
              },
              reason: {}
            }
          },
          output: {
            type: "structure",
            members: {
              endedTime: {
                type: "timestamp"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sz"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        TestSegmentPattern: {
          http: {
            requestUri: "/test-segment-pattern",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "pattern",
              "payload"
            ],
            members: {
              pattern: {
                jsonvalue: true
              },
              payload: {
                jsonvalue: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "match"
            ],
            members: {
              match: {
                type: "boolean"
              }
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateExperiment: {
          http: {
            method: "PATCH",
            requestUri: "/projects/{project}/experiments/{experiment}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "experiment",
              "project"
            ],
            members: {
              description: {},
              experiment: {
                location: "uri",
                locationName: "experiment"
              },
              metricGoals: {
                shape: "Sk"
              },
              onlineAbConfig: {
                shape: "St"
              },
              project: {
                location: "uri",
                locationName: "project"
              },
              randomizationSalt: {},
              removeSegment: {
                type: "boolean"
              },
              samplingRate: {
                type: "long"
              },
              segment: {},
              treatments: {
                shape: "S12"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "experiment"
            ],
            members: {
              experiment: {
                shape: "S16"
              }
            }
          }
        },
        UpdateFeature: {
          http: {
            method: "PATCH",
            requestUri: "/projects/{project}/features/{feature}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "feature",
              "project"
            ],
            members: {
              addOrUpdateVariations: {
                shape: "S1p"
              },
              defaultVariation: {},
              description: {},
              entityOverrides: {
                shape: "S1n"
              },
              evaluationStrategy: {},
              feature: {
                location: "uri",
                locationName: "feature"
              },
              project: {
                location: "uri",
                locationName: "project"
              },
              removeVariations: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "feature"
            ],
            members: {
              feature: {
                shape: "S1s"
              }
            }
          }
        },
        UpdateLaunch: {
          http: {
            method: "PATCH",
            requestUri: "/projects/{project}/launches/{launch}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "launch",
              "project"
            ],
            members: {
              description: {},
              groups: {
                shape: "S23"
              },
              launch: {
                location: "uri",
                locationName: "launch"
              },
              metricMonitors: {
                shape: "S26"
              },
              project: {
                location: "uri",
                locationName: "project"
              },
              randomizationSalt: {},
              scheduledSplitsConfig: {
                shape: "S29"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "launch"
            ],
            members: {
              launch: {
                shape: "S2h"
              }
            }
          }
        },
        UpdateProject: {
          http: {
            method: "PATCH",
            requestUri: "/projects/{project}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "project"
            ],
            members: {
              appConfigResource: {
                shape: "S2u"
              },
              description: {},
              project: {
                location: "uri",
                locationName: "project"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "project"
            ],
            members: {
              project: {
                shape: "S34"
              }
            }
          }
        },
        UpdateProjectDataDelivery: {
          http: {
            method: "PATCH",
            requestUri: "/projects/{project}/data-delivery",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "project"
            ],
            members: {
              cloudWatchLogs: {
                shape: "S2x"
              },
              project: {
                location: "uri",
                locationName: "project"
              },
              s3Destination: {
                shape: "S2z"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "project"
            ],
            members: {
              project: {
                shape: "S34"
              }
            }
          }
        }
      },
      shapes: {
        Sd: {
          type: "structure",
          members: {
            boolValue: {
              type: "boolean"
            },
            doubleValue: {
              type: "double"
            },
            longValue: {
              type: "long"
            },
            stringValue: {}
          },
          union: true
        },
        Sk: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "metricDefinition"
            ],
            members: {
              desiredChange: {},
              metricDefinition: {
                shape: "Sn"
              }
            }
          }
        },
        Sn: {
          type: "structure",
          required: [
            "entityIdKey",
            "name",
            "valueKey"
          ],
          members: {
            entityIdKey: {},
            eventPattern: {
              jsonvalue: true
            },
            name: {},
            unitLabel: {},
            valueKey: {}
          }
        },
        St: {
          type: "structure",
          members: {
            controlTreatmentName: {},
            treatmentWeights: {
              shape: "Sv"
            }
          }
        },
        Sv: {
          type: "map",
          key: {},
          value: {
            type: "long"
          }
        },
        Sz: {
          type: "map",
          key: {},
          value: {}
        },
        S12: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "feature",
              "name",
              "variation"
            ],
            members: {
              description: {},
              feature: {},
              name: {},
              variation: {}
            }
          }
        },
        S16: {
          type: "structure",
          required: [
            "arn",
            "createdTime",
            "lastUpdatedTime",
            "name",
            "status",
            "type"
          ],
          members: {
            arn: {},
            createdTime: {
              type: "timestamp"
            },
            description: {},
            execution: {
              type: "structure",
              members: {
                endedTime: {
                  type: "timestamp"
                },
                startedTime: {
                  type: "timestamp"
                }
              }
            },
            lastUpdatedTime: {
              type: "timestamp"
            },
            metricGoals: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "metricDefinition"
                ],
                members: {
                  desiredChange: {},
                  metricDefinition: {
                    shape: "S1c"
                  }
                }
              }
            },
            name: {},
            onlineAbDefinition: {
              type: "structure",
              members: {
                controlTreatmentName: {},
                treatmentWeights: {
                  shape: "Sv"
                }
              }
            },
            project: {},
            randomizationSalt: {},
            samplingRate: {
              type: "long"
            },
            schedule: {
              type: "structure",
              members: {
                analysisCompleteTime: {
                  type: "timestamp"
                }
              }
            },
            segment: {},
            status: {},
            statusReason: {},
            tags: {
              shape: "Sz"
            },
            treatments: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "name"
                ],
                members: {
                  description: {},
                  featureVariations: {
                    shape: "S1k"
                  },
                  name: {}
                }
              }
            },
            type: {}
          }
        },
        S1c: {
          type: "structure",
          members: {
            entityIdKey: {},
            eventPattern: {
              jsonvalue: true
            },
            name: {},
            unitLabel: {},
            valueKey: {}
          }
        },
        S1k: {
          type: "map",
          key: {},
          value: {}
        },
        S1n: {
          type: "map",
          key: {},
          value: {}
        },
        S1p: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "value"
            ],
            members: {
              name: {},
              value: {
                shape: "Sd"
              }
            }
          }
        },
        S1s: {
          type: "structure",
          required: [
            "arn",
            "createdTime",
            "evaluationStrategy",
            "lastUpdatedTime",
            "name",
            "status",
            "valueType",
            "variations"
          ],
          members: {
            arn: {},
            createdTime: {
              type: "timestamp"
            },
            defaultVariation: {},
            description: {},
            entityOverrides: {
              shape: "S1n"
            },
            evaluationRules: {
              shape: "S1u"
            },
            evaluationStrategy: {},
            lastUpdatedTime: {
              type: "timestamp"
            },
            name: {},
            project: {},
            status: {},
            tags: {
              shape: "Sz"
            },
            valueType: {},
            variations: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  name: {},
                  value: {
                    shape: "Sd"
                  }
                }
              }
            }
          }
        },
        S1u: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "type"
            ],
            members: {
              name: {},
              type: {}
            }
          }
        },
        S23: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "feature",
              "name",
              "variation"
            ],
            members: {
              description: {},
              feature: {},
              name: {},
              variation: {}
            }
          }
        },
        S26: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "metricDefinition"
            ],
            members: {
              metricDefinition: {
                shape: "Sn"
              }
            }
          }
        },
        S29: {
          type: "structure",
          required: [
            "steps"
          ],
          members: {
            steps: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "groupWeights",
                  "startTime"
                ],
                members: {
                  groupWeights: {
                    shape: "S2c"
                  },
                  segmentOverrides: {
                    shape: "S2d"
                  },
                  startTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        S2c: {
          type: "map",
          key: {},
          value: {
            type: "long"
          }
        },
        S2d: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "evaluationOrder",
              "segment",
              "weights"
            ],
            members: {
              evaluationOrder: {
                type: "long"
              },
              segment: {},
              weights: {
                shape: "S2c"
              }
            }
          }
        },
        S2h: {
          type: "structure",
          required: [
            "arn",
            "createdTime",
            "lastUpdatedTime",
            "name",
            "status",
            "type"
          ],
          members: {
            arn: {},
            createdTime: {
              type: "timestamp"
            },
            description: {},
            execution: {
              type: "structure",
              members: {
                endedTime: {
                  type: "timestamp"
                },
                startedTime: {
                  type: "timestamp"
                }
              }
            },
            groups: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "featureVariations",
                  "name"
                ],
                members: {
                  description: {},
                  featureVariations: {
                    shape: "S1k"
                  },
                  name: {}
                }
              }
            },
            lastUpdatedTime: {
              type: "timestamp"
            },
            metricMonitors: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "metricDefinition"
                ],
                members: {
                  metricDefinition: {
                    shape: "S1c"
                  }
                }
              }
            },
            name: {},
            project: {},
            randomizationSalt: {},
            scheduledSplitsDefinition: {
              type: "structure",
              members: {
                steps: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "startTime"
                    ],
                    members: {
                      groupWeights: {
                        shape: "S2c"
                      },
                      segmentOverrides: {
                        shape: "S2d"
                      },
                      startTime: {
                        type: "timestamp"
                      }
                    }
                  }
                }
              }
            },
            status: {},
            statusReason: {},
            tags: {
              shape: "Sz"
            },
            type: {}
          }
        },
        S2u: {
          type: "structure",
          members: {
            applicationId: {},
            environmentId: {}
          }
        },
        S2x: {
          type: "structure",
          members: {
            logGroup: {}
          }
        },
        S2z: {
          type: "structure",
          members: {
            bucket: {},
            prefix: {}
          }
        },
        S34: {
          type: "structure",
          required: [
            "arn",
            "createdTime",
            "lastUpdatedTime",
            "name",
            "status"
          ],
          members: {
            activeExperimentCount: {
              type: "long"
            },
            activeLaunchCount: {
              type: "long"
            },
            appConfigResource: {
              type: "structure",
              required: [
                "applicationId",
                "configurationProfileId",
                "environmentId"
              ],
              members: {
                applicationId: {},
                configurationProfileId: {},
                environmentId: {}
              }
            },
            arn: {},
            createdTime: {
              type: "timestamp"
            },
            dataDelivery: {
              type: "structure",
              members: {
                cloudWatchLogs: {
                  type: "structure",
                  members: {
                    logGroup: {}
                  }
                },
                s3Destination: {
                  type: "structure",
                  members: {
                    bucket: {},
                    prefix: {}
                  }
                }
              }
            },
            description: {},
            experimentCount: {
              type: "long"
            },
            featureCount: {
              type: "long"
            },
            lastUpdatedTime: {
              type: "timestamp"
            },
            launchCount: {
              type: "long"
            },
            name: {},
            status: {},
            tags: {
              shape: "Sz"
            }
          }
        },
        S3e: {
          type: "structure",
          required: [
            "arn",
            "createdTime",
            "lastUpdatedTime",
            "name",
            "pattern"
          ],
          members: {
            arn: {},
            createdTime: {
              type: "timestamp"
            },
            description: {},
            experimentCount: {
              type: "long"
            },
            lastUpdatedTime: {
              type: "timestamp"
            },
            launchCount: {
              type: "long"
            },
            name: {},
            pattern: {
              jsonvalue: true
            },
            tags: {
              shape: "Sz"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/evidently-2021-02-01.paginators.json
var require_evidently_2021_02_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/evidently-2021-02-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListExperiments: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "experiments"
        },
        ListFeatures: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "features"
        },
        ListLaunches: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "launches"
        },
        ListProjects: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "projects"
        },
        ListSegmentReferences: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "referencedBy"
        },
        ListSegments: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "segments"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/evidently.js
var require_evidently = __commonJS({
  "node_modules/aws-sdk/clients/evidently.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["evidently"] = {};
    AWS2.Evidently = Service.defineService("evidently", ["2021-02-01"]);
    Object.defineProperty(apiLoader.services["evidently"], "2021-02-01", {
      get: function get() {
        var model = require_evidently_2021_02_01_min();
        model.paginators = require_evidently_2021_02_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Evidently;
  }
});

// node_modules/aws-sdk/apis/inspector2-2020-06-08.min.json
var require_inspector2_2020_06_08_min = __commonJS({
  "node_modules/aws-sdk/apis/inspector2-2020-06-08.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-06-08",
        endpointPrefix: "inspector2",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Inspector2",
        serviceFullName: "Inspector2",
        serviceId: "Inspector2",
        signatureVersion: "v4",
        signingName: "inspector2",
        uid: "inspector2-2020-06-08"
      },
      operations: {
        AssociateMember: {
          http: {
            requestUri: "/members/associate",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "accountId"
            ],
            members: {
              accountId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "accountId"
            ],
            members: {
              accountId: {}
            }
          }
        },
        BatchGetAccountStatus: {
          http: {
            requestUri: "/status/batch/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              accountIds: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "accounts"
            ],
            members: {
              accounts: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "accountId",
                    "resourceState",
                    "state"
                  ],
                  members: {
                    accountId: {},
                    resourceState: {
                      type: "structure",
                      required: [
                        "ec2",
                        "ecr"
                      ],
                      members: {
                        ec2: {
                          shape: "Sa"
                        },
                        ecr: {
                          shape: "Sa"
                        },
                        lambda: {
                          shape: "Sa"
                        },
                        lambdaCode: {
                          shape: "Sa"
                        }
                      }
                    },
                    state: {
                      shape: "Sa"
                    }
                  }
                }
              },
              failedAccounts: {
                shape: "Se"
              }
            }
          }
        },
        BatchGetCodeSnippet: {
          http: {
            requestUri: "/codesnippet/batchget",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "findingArns"
            ],
            members: {
              findingArns: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              codeSnippetResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    codeSnippet: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "content",
                          "lineNumber"
                        ],
                        members: {
                          content: {},
                          lineNumber: {
                            type: "integer"
                          }
                        }
                      }
                    },
                    endLine: {
                      type: "integer"
                    },
                    findingArn: {},
                    startLine: {
                      type: "integer"
                    },
                    suggestedFixes: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          code: {},
                          description: {}
                        }
                      }
                    }
                  }
                }
              },
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "errorCode",
                    "errorMessage",
                    "findingArn"
                  ],
                  members: {
                    errorCode: {},
                    errorMessage: {},
                    findingArn: {}
                  }
                }
              }
            }
          }
        },
        BatchGetFindingDetails: {
          http: {
            requestUri: "/findings/details/batch/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "findingArns"
            ],
            members: {
              findingArns: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "errorCode",
                    "errorMessage",
                    "findingArn"
                  ],
                  members: {
                    errorCode: {},
                    errorMessage: {},
                    findingArn: {}
                  }
                }
              },
              findingDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    cisaData: {
                      shape: "S16"
                    },
                    cwes: {
                      shape: "S1a"
                    },
                    epssScore: {
                      type: "double"
                    },
                    evidences: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          evidenceDetail: {},
                          evidenceRule: {},
                          severity: {}
                        }
                      }
                    },
                    exploitObserved: {
                      shape: "S1i"
                    },
                    findingArn: {},
                    referenceUrls: {
                      shape: "S1l"
                    },
                    riskScore: {
                      type: "integer"
                    },
                    tools: {
                      type: "list",
                      member: {}
                    },
                    ttps: {
                      shape: "S1q"
                    }
                  }
                }
              }
            }
          }
        },
        BatchGetFreeTrialInfo: {
          http: {
            requestUri: "/freetrialinfo/batchget",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "accountIds"
            ],
            members: {
              accountIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "accounts",
              "failedAccounts"
            ],
            members: {
              accounts: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "accountId",
                    "freeTrialInfo"
                  ],
                  members: {
                    accountId: {},
                    freeTrialInfo: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "end",
                          "start",
                          "status",
                          "type"
                        ],
                        members: {
                          end: {
                            type: "timestamp"
                          },
                          start: {
                            type: "timestamp"
                          },
                          status: {},
                          type: {}
                        }
                      }
                    }
                  }
                }
              },
              failedAccounts: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "accountId",
                    "code",
                    "message"
                  ],
                  members: {
                    accountId: {},
                    code: {},
                    message: {}
                  }
                }
              }
            }
          }
        },
        BatchGetMemberEc2DeepInspectionStatus: {
          http: {
            requestUri: "/ec2deepinspectionstatus/member/batch/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              accountIds: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              accountIds: {
                shape: "S29"
              },
              failedAccountIds: {
                shape: "S2c"
              }
            }
          }
        },
        BatchUpdateMemberEc2DeepInspectionStatus: {
          http: {
            requestUri: "/ec2deepinspectionstatus/member/batch/update",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "accountIds"
            ],
            members: {
              accountIds: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "accountId",
                    "activateDeepInspection"
                  ],
                  members: {
                    accountId: {},
                    activateDeepInspection: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              accountIds: {
                shape: "S29"
              },
              failedAccountIds: {
                shape: "S2c"
              }
            }
          }
        },
        CancelFindingsReport: {
          http: {
            requestUri: "/reporting/cancel",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "reportId"
            ],
            members: {
              reportId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "reportId"
            ],
            members: {
              reportId: {}
            }
          }
        },
        CancelSbomExport: {
          http: {
            requestUri: "/sbomexport/cancel",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "reportId"
            ],
            members: {
              reportId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              reportId: {}
            }
          },
          idempotent: true
        },
        CreateFilter: {
          http: {
            requestUri: "/filters/create",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "action",
              "filterCriteria",
              "name"
            ],
            members: {
              action: {},
              description: {},
              filterCriteria: {
                shape: "S2r"
              },
              name: {},
              reason: {},
              tags: {
                shape: "S3c"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          }
        },
        CreateFindingsReport: {
          http: {
            requestUri: "/reporting/create",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "reportFormat",
              "s3Destination"
            ],
            members: {
              filterCriteria: {
                shape: "S2r"
              },
              reportFormat: {},
              s3Destination: {
                shape: "S3h"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              reportId: {}
            }
          }
        },
        CreateSbomExport: {
          http: {
            requestUri: "/sbomexport/create",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "reportFormat",
              "s3Destination"
            ],
            members: {
              reportFormat: {},
              resourceFilterCriteria: {
                shape: "S3l"
              },
              s3Destination: {
                shape: "S3h"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              reportId: {}
            }
          },
          idempotent: true
        },
        DeleteFilter: {
          http: {
            requestUri: "/filters/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          }
        },
        DescribeOrganizationConfiguration: {
          http: {
            requestUri: "/organizationconfiguration/describe",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              autoEnable: {
                shape: "S3y"
              },
              maxAccountLimitReached: {
                type: "boolean"
              }
            }
          }
        },
        Disable: {
          http: {
            requestUri: "/disable",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              accountIds: {
                shape: "S5"
              },
              resourceTypes: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "accounts"
            ],
            members: {
              accounts: {
                shape: "S43"
              },
              failedAccounts: {
                shape: "Se"
              }
            }
          }
        },
        DisableDelegatedAdminAccount: {
          http: {
            requestUri: "/delegatedadminaccounts/disable",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "delegatedAdminAccountId"
            ],
            members: {
              delegatedAdminAccountId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "delegatedAdminAccountId"
            ],
            members: {
              delegatedAdminAccountId: {}
            }
          }
        },
        DisassociateMember: {
          http: {
            requestUri: "/members/disassociate",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "accountId"
            ],
            members: {
              accountId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "accountId"
            ],
            members: {
              accountId: {}
            }
          }
        },
        Enable: {
          http: {
            requestUri: "/enable",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceTypes"
            ],
            members: {
              accountIds: {
                shape: "S5"
              },
              clientToken: {
                idempotencyToken: true
              },
              resourceTypes: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "accounts"
            ],
            members: {
              accounts: {
                shape: "S43"
              },
              failedAccounts: {
                shape: "Se"
              }
            }
          }
        },
        EnableDelegatedAdminAccount: {
          http: {
            requestUri: "/delegatedadminaccounts/enable",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "delegatedAdminAccountId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              delegatedAdminAccountId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "delegatedAdminAccountId"
            ],
            members: {
              delegatedAdminAccountId: {}
            }
          }
        },
        GetConfiguration: {
          http: {
            requestUri: "/configuration/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              ecrConfiguration: {
                type: "structure",
                members: {
                  rescanDurationState: {
                    type: "structure",
                    members: {
                      rescanDuration: {},
                      status: {},
                      updatedAt: {
                        type: "timestamp"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetDelegatedAdminAccount: {
          http: {
            requestUri: "/delegatedadminaccounts/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              delegatedAdmin: {
                type: "structure",
                members: {
                  accountId: {},
                  relationshipStatus: {}
                }
              }
            }
          }
        },
        GetEc2DeepInspectionConfiguration: {
          http: {
            requestUri: "/ec2deepinspectionconfiguration/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              errorMessage: {},
              orgPackagePaths: {
                shape: "S4s"
              },
              packagePaths: {
                shape: "S4s"
              },
              status: {}
            }
          }
        },
        GetEncryptionKey: {
          http: {
            method: "GET",
            requestUri: "/encryptionkey/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceType",
              "scanType"
            ],
            members: {
              resourceType: {
                location: "querystring",
                locationName: "resourceType"
              },
              scanType: {
                location: "querystring",
                locationName: "scanType"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "kmsKeyId"
            ],
            members: {
              kmsKeyId: {}
            }
          }
        },
        GetFindingsReportStatus: {
          http: {
            requestUri: "/reporting/status/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              reportId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              destination: {
                shape: "S3h"
              },
              errorCode: {},
              errorMessage: {},
              filterCriteria: {
                shape: "S2r"
              },
              reportId: {},
              status: {}
            }
          }
        },
        GetMember: {
          http: {
            requestUri: "/members/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "accountId"
            ],
            members: {
              accountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              member: {
                shape: "S56"
              }
            }
          }
        },
        GetSbomExport: {
          http: {
            requestUri: "/sbomexport/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "reportId"
            ],
            members: {
              reportId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              errorCode: {},
              errorMessage: {},
              filterCriteria: {
                shape: "S3l"
              },
              format: {},
              reportId: {},
              s3Destination: {
                shape: "S3h"
              },
              status: {}
            }
          },
          idempotent: true
        },
        ListAccountPermissions: {
          http: {
            requestUri: "/accountpermissions/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              service: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "permissions"
            ],
            members: {
              nextToken: {},
              permissions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "operation",
                    "service"
                  ],
                  members: {
                    operation: {},
                    service: {}
                  }
                }
              }
            }
          }
        },
        ListCoverage: {
          http: {
            requestUri: "/coverage/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              filterCriteria: {
                shape: "S5i"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              coveredResources: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "accountId",
                    "resourceId",
                    "resourceType",
                    "scanType"
                  ],
                  members: {
                    accountId: {},
                    lastScannedAt: {
                      type: "timestamp"
                    },
                    resourceId: {},
                    resourceMetadata: {
                      type: "structure",
                      members: {
                        ec2: {
                          type: "structure",
                          members: {
                            amiId: {},
                            platform: {},
                            tags: {
                              shape: "S3c"
                            }
                          }
                        },
                        ecrImage: {
                          type: "structure",
                          members: {
                            tags: {
                              type: "list",
                              member: {}
                            }
                          }
                        },
                        ecrRepository: {
                          type: "structure",
                          members: {
                            name: {},
                            scanFrequency: {}
                          }
                        },
                        lambdaFunction: {
                          type: "structure",
                          members: {
                            functionName: {},
                            functionTags: {
                              shape: "S3c"
                            },
                            layers: {
                              type: "list",
                              member: {}
                            },
                            runtime: {}
                          }
                        }
                      }
                    },
                    resourceType: {},
                    scanStatus: {
                      type: "structure",
                      required: [
                        "reason",
                        "statusCode"
                      ],
                      members: {
                        reason: {},
                        statusCode: {}
                      }
                    },
                    scanType: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListCoverageStatistics: {
          http: {
            requestUri: "/coverage/statistics/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              filterCriteria: {
                shape: "S5i"
              },
              groupBy: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "totalCounts"
            ],
            members: {
              countsByGroup: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    count: {
                      type: "long"
                    },
                    groupKey: {}
                  }
                }
              },
              nextToken: {},
              totalCounts: {
                type: "long"
              }
            }
          }
        },
        ListDelegatedAdminAccounts: {
          http: {
            requestUri: "/delegatedadminaccounts/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              delegatedAdminAccounts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    accountId: {},
                    status: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListFilters: {
          http: {
            requestUri: "/filters/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              action: {},
              arns: {
                type: "list",
                member: {}
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "filters"
            ],
            members: {
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "action",
                    "arn",
                    "createdAt",
                    "criteria",
                    "name",
                    "ownerId",
                    "updatedAt"
                  ],
                  members: {
                    action: {},
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    criteria: {
                      shape: "S2r"
                    },
                    description: {},
                    name: {},
                    ownerId: {},
                    reason: {},
                    tags: {
                      shape: "S3c"
                    },
                    updatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListFindingAggregations: {
          http: {
            requestUri: "/findings/aggregation/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "aggregationType"
            ],
            members: {
              accountIds: {
                shape: "S2s"
              },
              aggregationRequest: {
                type: "structure",
                members: {
                  accountAggregation: {
                    type: "structure",
                    members: {
                      findingType: {},
                      resourceType: {},
                      sortBy: {},
                      sortOrder: {}
                    }
                  },
                  amiAggregation: {
                    type: "structure",
                    members: {
                      amis: {
                        shape: "S2s"
                      },
                      sortBy: {},
                      sortOrder: {}
                    }
                  },
                  awsEcrContainerAggregation: {
                    type: "structure",
                    members: {
                      architectures: {
                        shape: "S2s"
                      },
                      imageShas: {
                        shape: "S2s"
                      },
                      imageTags: {
                        shape: "S2s"
                      },
                      repositories: {
                        shape: "S2s"
                      },
                      resourceIds: {
                        shape: "S2s"
                      },
                      sortBy: {},
                      sortOrder: {}
                    }
                  },
                  ec2InstanceAggregation: {
                    type: "structure",
                    members: {
                      amis: {
                        shape: "S2s"
                      },
                      instanceIds: {
                        shape: "S2s"
                      },
                      instanceTags: {
                        shape: "S33"
                      },
                      operatingSystems: {
                        shape: "S2s"
                      },
                      sortBy: {},
                      sortOrder: {}
                    }
                  },
                  findingTypeAggregation: {
                    type: "structure",
                    members: {
                      findingType: {},
                      resourceType: {},
                      sortBy: {},
                      sortOrder: {}
                    }
                  },
                  imageLayerAggregation: {
                    type: "structure",
                    members: {
                      layerHashes: {
                        shape: "S2s"
                      },
                      repositories: {
                        shape: "S2s"
                      },
                      resourceIds: {
                        shape: "S2s"
                      },
                      sortBy: {},
                      sortOrder: {}
                    }
                  },
                  lambdaFunctionAggregation: {
                    type: "structure",
                    members: {
                      functionNames: {
                        shape: "S2s"
                      },
                      functionTags: {
                        shape: "S33"
                      },
                      resourceIds: {
                        shape: "S2s"
                      },
                      runtimes: {
                        shape: "S2s"
                      },
                      sortBy: {},
                      sortOrder: {}
                    }
                  },
                  lambdaLayerAggregation: {
                    type: "structure",
                    members: {
                      functionNames: {
                        shape: "S2s"
                      },
                      layerArns: {
                        shape: "S2s"
                      },
                      resourceIds: {
                        shape: "S2s"
                      },
                      sortBy: {},
                      sortOrder: {}
                    }
                  },
                  packageAggregation: {
                    type: "structure",
                    members: {
                      packageNames: {
                        shape: "S2s"
                      },
                      sortBy: {},
                      sortOrder: {}
                    }
                  },
                  repositoryAggregation: {
                    type: "structure",
                    members: {
                      repositories: {
                        shape: "S2s"
                      },
                      sortBy: {},
                      sortOrder: {}
                    }
                  },
                  titleAggregation: {
                    type: "structure",
                    members: {
                      findingType: {},
                      resourceType: {},
                      sortBy: {},
                      sortOrder: {},
                      titles: {
                        shape: "S2s"
                      },
                      vulnerabilityIds: {
                        shape: "S2s"
                      }
                    }
                  }
                },
                union: true
              },
              aggregationType: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "aggregationType"
            ],
            members: {
              aggregationType: {},
              nextToken: {},
              responses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    accountAggregation: {
                      type: "structure",
                      members: {
                        accountId: {},
                        severityCounts: {
                          shape: "S7t"
                        }
                      }
                    },
                    amiAggregation: {
                      type: "structure",
                      required: [
                        "ami"
                      ],
                      members: {
                        accountId: {},
                        affectedInstances: {
                          type: "long"
                        },
                        ami: {},
                        severityCounts: {
                          shape: "S7t"
                        }
                      }
                    },
                    awsEcrContainerAggregation: {
                      type: "structure",
                      required: [
                        "resourceId"
                      ],
                      members: {
                        accountId: {},
                        architecture: {},
                        imageSha: {},
                        imageTags: {
                          type: "list",
                          member: {}
                        },
                        repository: {},
                        resourceId: {},
                        severityCounts: {
                          shape: "S7t"
                        }
                      }
                    },
                    ec2InstanceAggregation: {
                      type: "structure",
                      required: [
                        "instanceId"
                      ],
                      members: {
                        accountId: {},
                        ami: {},
                        instanceId: {},
                        instanceTags: {
                          shape: "S3c"
                        },
                        networkFindings: {
                          type: "long"
                        },
                        operatingSystem: {},
                        severityCounts: {
                          shape: "S7t"
                        }
                      }
                    },
                    findingTypeAggregation: {
                      type: "structure",
                      members: {
                        accountId: {},
                        severityCounts: {
                          shape: "S7t"
                        }
                      }
                    },
                    imageLayerAggregation: {
                      type: "structure",
                      required: [
                        "accountId",
                        "layerHash",
                        "repository",
                        "resourceId"
                      ],
                      members: {
                        accountId: {},
                        layerHash: {},
                        repository: {},
                        resourceId: {},
                        severityCounts: {
                          shape: "S7t"
                        }
                      }
                    },
                    lambdaFunctionAggregation: {
                      type: "structure",
                      required: [
                        "resourceId"
                      ],
                      members: {
                        accountId: {},
                        functionName: {},
                        lambdaTags: {
                          shape: "S3c"
                        },
                        lastModifiedAt: {
                          type: "timestamp"
                        },
                        resourceId: {},
                        runtime: {},
                        severityCounts: {
                          shape: "S7t"
                        }
                      }
                    },
                    lambdaLayerAggregation: {
                      type: "structure",
                      required: [
                        "accountId",
                        "functionName",
                        "layerArn",
                        "resourceId"
                      ],
                      members: {
                        accountId: {},
                        functionName: {},
                        layerArn: {},
                        resourceId: {},
                        severityCounts: {
                          shape: "S7t"
                        }
                      }
                    },
                    packageAggregation: {
                      type: "structure",
                      required: [
                        "packageName"
                      ],
                      members: {
                        accountId: {},
                        packageName: {},
                        severityCounts: {
                          shape: "S7t"
                        }
                      }
                    },
                    repositoryAggregation: {
                      type: "structure",
                      required: [
                        "repository"
                      ],
                      members: {
                        accountId: {},
                        affectedImages: {
                          type: "long"
                        },
                        repository: {},
                        severityCounts: {
                          shape: "S7t"
                        }
                      }
                    },
                    titleAggregation: {
                      type: "structure",
                      required: [
                        "title"
                      ],
                      members: {
                        accountId: {},
                        severityCounts: {
                          shape: "S7t"
                        },
                        title: {},
                        vulnerabilityId: {}
                      }
                    }
                  },
                  union: true
                }
              }
            }
          }
        },
        ListFindings: {
          http: {
            requestUri: "/findings/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              filterCriteria: {
                shape: "S2r"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              sortCriteria: {
                type: "structure",
                required: [
                  "field",
                  "sortOrder"
                ],
                members: {
                  field: {},
                  sortOrder: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              findings: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "awsAccountId",
                    "description",
                    "findingArn",
                    "firstObservedAt",
                    "lastObservedAt",
                    "remediation",
                    "resources",
                    "severity",
                    "status",
                    "type"
                  ],
                  members: {
                    awsAccountId: {},
                    codeVulnerabilityDetails: {
                      type: "structure",
                      required: [
                        "cwes",
                        "detectorId",
                        "detectorName",
                        "filePath"
                      ],
                      members: {
                        cwes: {
                          type: "list",
                          member: {}
                        },
                        detectorId: {},
                        detectorName: {},
                        detectorTags: {
                          type: "list",
                          member: {}
                        },
                        filePath: {
                          type: "structure",
                          required: [
                            "endLine",
                            "fileName",
                            "filePath",
                            "startLine"
                          ],
                          members: {
                            endLine: {
                              type: "integer"
                            },
                            fileName: {},
                            filePath: {},
                            startLine: {
                              type: "integer"
                            }
                          }
                        },
                        referenceUrls: {
                          type: "list",
                          member: {}
                        },
                        ruleId: {},
                        sourceLambdaLayerArn: {}
                      }
                    },
                    description: {},
                    epss: {
                      type: "structure",
                      members: {
                        score: {
                          type: "double"
                        }
                      }
                    },
                    exploitAvailable: {},
                    exploitabilityDetails: {
                      type: "structure",
                      members: {
                        lastKnownExploitAt: {
                          type: "timestamp"
                        }
                      }
                    },
                    findingArn: {},
                    firstObservedAt: {
                      type: "timestamp"
                    },
                    fixAvailable: {},
                    inspectorScore: {
                      type: "double"
                    },
                    inspectorScoreDetails: {
                      type: "structure",
                      members: {
                        adjustedCvss: {
                          type: "structure",
                          required: [
                            "score",
                            "scoreSource",
                            "scoringVector",
                            "version"
                          ],
                          members: {
                            adjustments: {
                              type: "list",
                              member: {
                                type: "structure",
                                required: [
                                  "metric",
                                  "reason"
                                ],
                                members: {
                                  metric: {},
                                  reason: {}
                                }
                              }
                            },
                            cvssSource: {},
                            score: {
                              type: "double"
                            },
                            scoreSource: {},
                            scoringVector: {},
                            version: {}
                          }
                        }
                      }
                    },
                    lastObservedAt: {
                      type: "timestamp"
                    },
                    networkReachabilityDetails: {
                      type: "structure",
                      required: [
                        "networkPath",
                        "openPortRange",
                        "protocol"
                      ],
                      members: {
                        networkPath: {
                          type: "structure",
                          members: {
                            steps: {
                              type: "list",
                              member: {
                                type: "structure",
                                required: [
                                  "componentId",
                                  "componentType"
                                ],
                                members: {
                                  componentId: {},
                                  componentType: {}
                                }
                              }
                            }
                          }
                        },
                        openPortRange: {
                          type: "structure",
                          required: [
                            "begin",
                            "end"
                          ],
                          members: {
                            begin: {
                              type: "integer"
                            },
                            end: {
                              type: "integer"
                            }
                          }
                        },
                        protocol: {}
                      }
                    },
                    packageVulnerabilityDetails: {
                      type: "structure",
                      required: [
                        "source",
                        "vulnerabilityId"
                      ],
                      members: {
                        cvss: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "baseScore",
                              "scoringVector",
                              "source",
                              "version"
                            ],
                            members: {
                              baseScore: {
                                type: "double"
                              },
                              scoringVector: {},
                              source: {},
                              version: {}
                            }
                          }
                        },
                        referenceUrls: {
                          type: "list",
                          member: {}
                        },
                        relatedVulnerabilities: {
                          type: "list",
                          member: {}
                        },
                        source: {},
                        sourceUrl: {},
                        vendorCreatedAt: {
                          type: "timestamp"
                        },
                        vendorSeverity: {},
                        vendorUpdatedAt: {
                          type: "timestamp"
                        },
                        vulnerabilityId: {},
                        vulnerablePackages: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "name",
                              "version"
                            ],
                            members: {
                              arch: {},
                              epoch: {
                                type: "integer"
                              },
                              filePath: {},
                              fixedInVersion: {},
                              name: {},
                              packageManager: {},
                              release: {},
                              remediation: {},
                              sourceLambdaLayerArn: {},
                              sourceLayerHash: {},
                              version: {}
                            }
                          }
                        }
                      }
                    },
                    remediation: {
                      type: "structure",
                      members: {
                        recommendation: {
                          type: "structure",
                          members: {
                            Url: {},
                            text: {}
                          }
                        }
                      }
                    },
                    resources: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "id",
                          "type"
                        ],
                        members: {
                          details: {
                            type: "structure",
                            members: {
                              awsEc2Instance: {
                                type: "structure",
                                members: {
                                  iamInstanceProfileArn: {},
                                  imageId: {},
                                  ipV4Addresses: {
                                    type: "list",
                                    member: {}
                                  },
                                  ipV6Addresses: {
                                    type: "list",
                                    member: {}
                                  },
                                  keyName: {},
                                  launchedAt: {
                                    type: "timestamp"
                                  },
                                  platform: {},
                                  subnetId: {},
                                  type: {},
                                  vpcId: {}
                                }
                              },
                              awsEcrContainerImage: {
                                type: "structure",
                                required: [
                                  "imageHash",
                                  "registry",
                                  "repositoryName"
                                ],
                                members: {
                                  architecture: {},
                                  author: {},
                                  imageHash: {},
                                  imageTags: {
                                    type: "list",
                                    member: {}
                                  },
                                  platform: {},
                                  pushedAt: {
                                    type: "timestamp"
                                  },
                                  registry: {},
                                  repositoryName: {}
                                }
                              },
                              awsLambdaFunction: {
                                type: "structure",
                                required: [
                                  "codeSha256",
                                  "executionRoleArn",
                                  "functionName",
                                  "runtime",
                                  "version"
                                ],
                                members: {
                                  architectures: {
                                    type: "list",
                                    member: {}
                                  },
                                  codeSha256: {},
                                  executionRoleArn: {},
                                  functionName: {},
                                  lastModifiedAt: {
                                    type: "timestamp"
                                  },
                                  layers: {
                                    type: "list",
                                    member: {}
                                  },
                                  packageType: {},
                                  runtime: {},
                                  version: {},
                                  vpcConfig: {
                                    type: "structure",
                                    members: {
                                      securityGroupIds: {
                                        type: "list",
                                        member: {}
                                      },
                                      subnetIds: {
                                        type: "list",
                                        member: {}
                                      },
                                      vpcId: {}
                                    }
                                  }
                                }
                              }
                            }
                          },
                          id: {},
                          partition: {},
                          region: {},
                          tags: {
                            shape: "S3c"
                          },
                          type: {}
                        }
                      }
                    },
                    severity: {},
                    status: {},
                    title: {},
                    type: {},
                    updatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListMembers: {
          http: {
            requestUri: "/members/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              onlyAssociated: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              members: {
                type: "list",
                member: {
                  shape: "S56"
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S3c"
              }
            }
          }
        },
        ListUsageTotals: {
          http: {
            requestUri: "/usage/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              accountIds: {
                type: "list",
                member: {}
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              totals: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    accountId: {},
                    usage: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          currency: {},
                          estimatedMonthlyCost: {
                            type: "double"
                          },
                          total: {
                            type: "double"
                          },
                          type: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        ResetEncryptionKey: {
          http: {
            method: "PUT",
            requestUri: "/encryptionkey/reset",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceType",
              "scanType"
            ],
            members: {
              resourceType: {},
              scanType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        SearchVulnerabilities: {
          http: {
            requestUri: "/vulnerabilities/search",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "filterCriteria"
            ],
            members: {
              filterCriteria: {
                type: "structure",
                required: [
                  "vulnerabilityIds"
                ],
                members: {
                  vulnerabilityIds: {
                    type: "list",
                    member: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "vulnerabilities"
            ],
            members: {
              nextToken: {},
              vulnerabilities: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id"
                  ],
                  members: {
                    atigData: {
                      type: "structure",
                      members: {
                        firstSeen: {
                          type: "timestamp"
                        },
                        lastSeen: {
                          type: "timestamp"
                        },
                        targets: {
                          type: "list",
                          member: {}
                        },
                        ttps: {
                          shape: "S1q"
                        }
                      }
                    },
                    cisaData: {
                      shape: "S16"
                    },
                    cvss2: {
                      type: "structure",
                      members: {
                        baseScore: {
                          type: "double"
                        },
                        scoringVector: {}
                      }
                    },
                    cvss3: {
                      type: "structure",
                      members: {
                        baseScore: {
                          type: "double"
                        },
                        scoringVector: {}
                      }
                    },
                    cwes: {
                      shape: "S1a"
                    },
                    description: {},
                    detectionPlatforms: {
                      type: "list",
                      member: {}
                    },
                    epss: {
                      type: "structure",
                      members: {
                        score: {
                          type: "double"
                        }
                      }
                    },
                    exploitObserved: {
                      shape: "S1i"
                    },
                    id: {},
                    referenceUrls: {
                      shape: "S1l"
                    },
                    relatedVulnerabilities: {
                      type: "list",
                      member: {}
                    },
                    source: {},
                    sourceUrl: {},
                    vendorCreatedAt: {
                      type: "timestamp"
                    },
                    vendorSeverity: {},
                    vendorUpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S3c"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateConfiguration: {
          http: {
            requestUri: "/configuration/update",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ecrConfiguration"
            ],
            members: {
              ecrConfiguration: {
                type: "structure",
                required: [
                  "rescanDuration"
                ],
                members: {
                  rescanDuration: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateEc2DeepInspectionConfiguration: {
          http: {
            requestUri: "/ec2deepinspectionconfiguration/update",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              activateDeepInspection: {
                type: "boolean"
              },
              packagePaths: {
                shape: "S4s"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errorMessage: {},
              orgPackagePaths: {
                shape: "S4s"
              },
              packagePaths: {
                shape: "S4s"
              },
              status: {}
            }
          }
        },
        UpdateEncryptionKey: {
          http: {
            method: "PUT",
            requestUri: "/encryptionkey/update",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "kmsKeyId",
              "resourceType",
              "scanType"
            ],
            members: {
              kmsKeyId: {},
              resourceType: {},
              scanType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateFilter: {
          http: {
            requestUri: "/filters/update",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "filterArn"
            ],
            members: {
              action: {},
              description: {},
              filterArn: {},
              filterCriteria: {
                shape: "S2r"
              },
              name: {},
              reason: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          }
        },
        UpdateOrgEc2DeepInspectionConfiguration: {
          http: {
            requestUri: "/ec2deepinspectionconfiguration/org/update",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "orgPackagePaths"
            ],
            members: {
              orgPackagePaths: {
                shape: "S4s"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateOrganizationConfiguration: {
          http: {
            requestUri: "/organizationconfiguration/update",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "autoEnable"
            ],
            members: {
              autoEnable: {
                shape: "S3y"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "autoEnable"
            ],
            members: {
              autoEnable: {
                shape: "S3y"
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "list",
          member: {}
        },
        Sa: {
          type: "structure",
          required: [
            "errorCode",
            "errorMessage",
            "status"
          ],
          members: {
            errorCode: {},
            errorMessage: {},
            status: {}
          }
        },
        Se: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "accountId",
              "errorCode",
              "errorMessage"
            ],
            members: {
              accountId: {},
              errorCode: {},
              errorMessage: {},
              resourceStatus: {
                shape: "Sg"
              },
              status: {}
            }
          }
        },
        Sg: {
          type: "structure",
          required: [
            "ec2",
            "ecr"
          ],
          members: {
            ec2: {},
            ecr: {},
            lambda: {},
            lambdaCode: {}
          }
        },
        S16: {
          type: "structure",
          members: {
            action: {},
            dateAdded: {
              type: "timestamp"
            },
            dateDue: {
              type: "timestamp"
            }
          }
        },
        S1a: {
          type: "list",
          member: {}
        },
        S1i: {
          type: "structure",
          members: {
            firstSeen: {
              type: "timestamp"
            },
            lastSeen: {
              type: "timestamp"
            }
          }
        },
        S1l: {
          type: "list",
          member: {}
        },
        S1q: {
          type: "list",
          member: {}
        },
        S29: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "accountId"
            ],
            members: {
              accountId: {},
              errorMessage: {},
              status: {}
            }
          }
        },
        S2c: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "accountId"
            ],
            members: {
              accountId: {},
              ec2ScanStatus: {},
              errorMessage: {}
            }
          }
        },
        S2r: {
          type: "structure",
          members: {
            awsAccountId: {
              shape: "S2s"
            },
            codeVulnerabilityDetectorName: {
              shape: "S2s"
            },
            codeVulnerabilityDetectorTags: {
              shape: "S2s"
            },
            codeVulnerabilityFilePath: {
              shape: "S2s"
            },
            componentId: {
              shape: "S2s"
            },
            componentType: {
              shape: "S2s"
            },
            ec2InstanceImageId: {
              shape: "S2s"
            },
            ec2InstanceSubnetId: {
              shape: "S2s"
            },
            ec2InstanceVpcId: {
              shape: "S2s"
            },
            ecrImageArchitecture: {
              shape: "S2s"
            },
            ecrImageHash: {
              shape: "S2s"
            },
            ecrImagePushedAt: {
              shape: "S2w"
            },
            ecrImageRegistry: {
              shape: "S2s"
            },
            ecrImageRepositoryName: {
              shape: "S2s"
            },
            ecrImageTags: {
              shape: "S2s"
            },
            epssScore: {
              shape: "S2y"
            },
            exploitAvailable: {
              shape: "S2s"
            },
            findingArn: {
              shape: "S2s"
            },
            findingStatus: {
              shape: "S2s"
            },
            findingType: {
              shape: "S2s"
            },
            firstObservedAt: {
              shape: "S2w"
            },
            fixAvailable: {
              shape: "S2s"
            },
            inspectorScore: {
              shape: "S2y"
            },
            lambdaFunctionExecutionRoleArn: {
              shape: "S2s"
            },
            lambdaFunctionLastModifiedAt: {
              shape: "S2w"
            },
            lambdaFunctionLayers: {
              shape: "S2s"
            },
            lambdaFunctionName: {
              shape: "S2s"
            },
            lambdaFunctionRuntime: {
              shape: "S2s"
            },
            lastObservedAt: {
              shape: "S2w"
            },
            networkProtocol: {
              shape: "S2s"
            },
            portRange: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  beginInclusive: {
                    type: "integer"
                  },
                  endInclusive: {
                    type: "integer"
                  }
                }
              }
            },
            relatedVulnerabilities: {
              shape: "S2s"
            },
            resourceId: {
              shape: "S2s"
            },
            resourceTags: {
              shape: "S33"
            },
            resourceType: {
              shape: "S2s"
            },
            severity: {
              shape: "S2s"
            },
            title: {
              shape: "S2s"
            },
            updatedAt: {
              shape: "S2w"
            },
            vendorSeverity: {
              shape: "S2s"
            },
            vulnerabilityId: {
              shape: "S2s"
            },
            vulnerabilitySource: {
              shape: "S2s"
            },
            vulnerablePackages: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  architecture: {
                    shape: "S2t"
                  },
                  epoch: {
                    shape: "S2z"
                  },
                  name: {
                    shape: "S2t"
                  },
                  release: {
                    shape: "S2t"
                  },
                  sourceLambdaLayerArn: {
                    shape: "S2t"
                  },
                  sourceLayerHash: {
                    shape: "S2t"
                  },
                  version: {
                    shape: "S2t"
                  }
                }
              }
            }
          }
        },
        S2s: {
          type: "list",
          member: {
            shape: "S2t"
          }
        },
        S2t: {
          type: "structure",
          required: [
            "comparison",
            "value"
          ],
          members: {
            comparison: {},
            value: {}
          }
        },
        S2w: {
          type: "list",
          member: {
            type: "structure",
            members: {
              endInclusive: {
                type: "timestamp"
              },
              startInclusive: {
                type: "timestamp"
              }
            }
          }
        },
        S2y: {
          type: "list",
          member: {
            shape: "S2z"
          }
        },
        S2z: {
          type: "structure",
          members: {
            lowerInclusive: {
              type: "double"
            },
            upperInclusive: {
              type: "double"
            }
          }
        },
        S33: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "comparison",
              "key"
            ],
            members: {
              comparison: {},
              key: {},
              value: {}
            }
          }
        },
        S3c: {
          type: "map",
          key: {},
          value: {}
        },
        S3h: {
          type: "structure",
          required: [
            "bucketName",
            "kmsKeyArn"
          ],
          members: {
            bucketName: {},
            keyPrefix: {},
            kmsKeyArn: {}
          }
        },
        S3l: {
          type: "structure",
          members: {
            accountId: {
              shape: "S3m"
            },
            ec2InstanceTags: {
              shape: "S3q"
            },
            ecrImageTags: {
              shape: "S3m"
            },
            ecrRepositoryName: {
              shape: "S3m"
            },
            lambdaFunctionName: {
              shape: "S3m"
            },
            lambdaFunctionTags: {
              shape: "S3q"
            },
            resourceId: {
              shape: "S3m"
            },
            resourceType: {
              shape: "S3m"
            }
          }
        },
        S3m: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "comparison",
              "value"
            ],
            members: {
              comparison: {},
              value: {}
            }
          }
        },
        S3q: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "comparison",
              "key"
            ],
            members: {
              comparison: {},
              key: {},
              value: {}
            }
          }
        },
        S3y: {
          type: "structure",
          required: [
            "ec2",
            "ecr"
          ],
          members: {
            ec2: {
              type: "boolean"
            },
            ecr: {
              type: "boolean"
            },
            lambda: {
              type: "boolean"
            },
            lambdaCode: {
              type: "boolean"
            }
          }
        },
        S43: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "accountId",
              "resourceStatus",
              "status"
            ],
            members: {
              accountId: {},
              resourceStatus: {
                shape: "Sg"
              },
              status: {}
            }
          }
        },
        S4s: {
          type: "list",
          member: {}
        },
        S56: {
          type: "structure",
          members: {
            accountId: {},
            delegatedAdminAccountId: {},
            relationshipStatus: {},
            updatedAt: {
              type: "timestamp"
            }
          }
        },
        S5i: {
          type: "structure",
          members: {
            accountId: {
              shape: "S5j"
            },
            ec2InstanceTags: {
              shape: "S5n"
            },
            ecrImageTags: {
              shape: "S5j"
            },
            ecrRepositoryName: {
              shape: "S5j"
            },
            lambdaFunctionName: {
              shape: "S5j"
            },
            lambdaFunctionRuntime: {
              shape: "S5j"
            },
            lambdaFunctionTags: {
              shape: "S5n"
            },
            lastScannedAt: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  endInclusive: {
                    type: "timestamp"
                  },
                  startInclusive: {
                    type: "timestamp"
                  }
                }
              }
            },
            resourceId: {
              shape: "S5j"
            },
            resourceType: {
              shape: "S5j"
            },
            scanStatusCode: {
              shape: "S5j"
            },
            scanStatusReason: {
              shape: "S5j"
            },
            scanType: {
              shape: "S5j"
            }
          }
        },
        S5j: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "comparison",
              "value"
            ],
            members: {
              comparison: {},
              value: {}
            }
          }
        },
        S5n: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "comparison",
              "key"
            ],
            members: {
              comparison: {},
              key: {},
              value: {}
            }
          }
        },
        S7t: {
          type: "structure",
          members: {
            all: {
              type: "long"
            },
            critical: {
              type: "long"
            },
            high: {
              type: "long"
            },
            medium: {
              type: "long"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/inspector2-2020-06-08.paginators.json
var require_inspector2_2020_06_08_paginators = __commonJS({
  "node_modules/aws-sdk/apis/inspector2-2020-06-08.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAccountPermissions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "permissions"
        },
        ListCoverage: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "coveredResources"
        },
        ListCoverageStatistics: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "countsByGroup"
        },
        ListDelegatedAdminAccounts: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "delegatedAdminAccounts"
        },
        ListFilters: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "filters"
        },
        ListFindingAggregations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "responses"
        },
        ListFindings: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "findings"
        },
        ListMembers: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "members"
        },
        ListUsageTotals: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "totals"
        },
        SearchVulnerabilities: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "vulnerabilities"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/inspector2.js
var require_inspector2 = __commonJS({
  "node_modules/aws-sdk/clients/inspector2.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["inspector2"] = {};
    AWS2.Inspector2 = Service.defineService("inspector2", ["2020-06-08"]);
    Object.defineProperty(apiLoader.services["inspector2"], "2020-06-08", {
      get: function get() {
        var model = require_inspector2_2020_06_08_min();
        model.paginators = require_inspector2_2020_06_08_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Inspector2;
  }
});

// node_modules/aws-sdk/apis/rbin-2021-06-15.min.json
var require_rbin_2021_06_15_min = __commonJS({
  "node_modules/aws-sdk/apis/rbin-2021-06-15.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-06-15",
        endpointPrefix: "rbin",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Recycle Bin",
        serviceId: "rbin",
        signatureVersion: "v4",
        signingName: "rbin",
        uid: "rbin-2021-06-15"
      },
      operations: {
        CreateRule: {
          http: {
            requestUri: "/rules",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "RetentionPeriod",
              "ResourceType"
            ],
            members: {
              RetentionPeriod: {
                shape: "S2"
              },
              Description: {},
              Tags: {
                shape: "S6"
              },
              ResourceType: {},
              ResourceTags: {
                shape: "Sb"
              },
              LockConfiguration: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Identifier: {},
              RetentionPeriod: {
                shape: "S2"
              },
              Description: {},
              Tags: {
                shape: "S6"
              },
              ResourceType: {},
              ResourceTags: {
                shape: "Sb"
              },
              Status: {},
              LockConfiguration: {
                shape: "Sf"
              },
              LockState: {},
              RuleArn: {}
            }
          }
        },
        DeleteRule: {
          http: {
            method: "DELETE",
            requestUri: "/rules/{identifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Identifier"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetRule: {
          http: {
            method: "GET",
            requestUri: "/rules/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Identifier"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Identifier: {},
              Description: {},
              ResourceType: {},
              RetentionPeriod: {
                shape: "S2"
              },
              ResourceTags: {
                shape: "Sb"
              },
              Status: {},
              LockConfiguration: {
                shape: "Sf"
              },
              LockState: {},
              LockEndTime: {
                type: "timestamp"
              },
              RuleArn: {}
            }
          }
        },
        ListRules: {
          http: {
            requestUri: "/list-rules",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceType"
            ],
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              ResourceType: {},
              ResourceTags: {
                shape: "Sb"
              },
              LockState: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Rules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Identifier: {},
                    Description: {},
                    RetentionPeriod: {
                      shape: "S2"
                    },
                    LockState: {},
                    RuleArn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S6"
              }
            }
          }
        },
        LockRule: {
          http: {
            method: "PATCH",
            requestUri: "/rules/{identifier}/lock",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Identifier",
              "LockConfiguration"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "identifier"
              },
              LockConfiguration: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Identifier: {},
              Description: {},
              ResourceType: {},
              RetentionPeriod: {
                shape: "S2"
              },
              ResourceTags: {
                shape: "Sb"
              },
              Status: {},
              LockConfiguration: {
                shape: "Sf"
              },
              LockState: {},
              RuleArn: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              Tags: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UnlockRule: {
          http: {
            method: "PATCH",
            requestUri: "/rules/{identifier}/unlock",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Identifier"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Identifier: {},
              Description: {},
              ResourceType: {},
              RetentionPeriod: {
                shape: "S2"
              },
              ResourceTags: {
                shape: "Sb"
              },
              Status: {},
              LockConfiguration: {
                shape: "Sf"
              },
              LockState: {},
              LockEndTime: {
                type: "timestamp"
              },
              RuleArn: {}
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateRule: {
          http: {
            method: "PATCH",
            requestUri: "/rules/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Identifier"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "identifier"
              },
              RetentionPeriod: {
                shape: "S2"
              },
              Description: {},
              ResourceType: {},
              ResourceTags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Identifier: {},
              RetentionPeriod: {
                shape: "S2"
              },
              Description: {},
              ResourceType: {},
              ResourceTags: {
                shape: "Sb"
              },
              Status: {},
              LockState: {},
              LockEndTime: {
                type: "timestamp"
              },
              RuleArn: {}
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          required: [
            "RetentionPeriodValue",
            "RetentionPeriodUnit"
          ],
          members: {
            RetentionPeriodValue: {
              type: "integer"
            },
            RetentionPeriodUnit: {}
          }
        },
        S6: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sb: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ResourceTagKey"
            ],
            members: {
              ResourceTagKey: {},
              ResourceTagValue: {}
            }
          }
        },
        Sf: {
          type: "structure",
          required: [
            "UnlockDelay"
          ],
          members: {
            UnlockDelay: {
              type: "structure",
              required: [
                "UnlockDelayValue",
                "UnlockDelayUnit"
              ],
              members: {
                UnlockDelayValue: {
                  type: "integer"
                },
                UnlockDelayUnit: {}
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/rbin-2021-06-15.paginators.json
var require_rbin_2021_06_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/rbin-2021-06-15.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListRules: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Rules"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/rbin.js
var require_rbin = __commonJS({
  "node_modules/aws-sdk/clients/rbin.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["rbin"] = {};
    AWS2.Rbin = Service.defineService("rbin", ["2021-06-15"]);
    Object.defineProperty(apiLoader.services["rbin"], "2021-06-15", {
      get: function get() {
        var model = require_rbin_2021_06_15_min();
        model.paginators = require_rbin_2021_06_15_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Rbin;
  }
});

// node_modules/aws-sdk/apis/rum-2018-05-10.min.json
var require_rum_2018_05_10_min = __commonJS({
  "node_modules/aws-sdk/apis/rum-2018-05-10.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-05-10",
        endpointPrefix: "rum",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "CloudWatch RUM",
        serviceId: "RUM",
        signatureVersion: "v4",
        signingName: "rum",
        uid: "rum-2018-05-10"
      },
      operations: {
        BatchCreateRumMetricDefinitions: {
          http: {
            requestUri: "/rummetrics/{AppMonitorName}/metrics",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppMonitorName",
              "Destination",
              "MetricDefinitions"
            ],
            members: {
              AppMonitorName: {
                location: "uri",
                locationName: "AppMonitorName"
              },
              Destination: {},
              DestinationArn: {},
              MetricDefinitions: {
                type: "list",
                member: {
                  shape: "S6"
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Errors"
            ],
            members: {
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ErrorCode",
                    "ErrorMessage",
                    "MetricDefinition"
                  ],
                  members: {
                    ErrorCode: {},
                    ErrorMessage: {},
                    MetricDefinition: {
                      shape: "S6"
                    }
                  }
                }
              },
              MetricDefinitions: {
                shape: "Sj"
              }
            }
          },
          idempotent: true
        },
        BatchDeleteRumMetricDefinitions: {
          http: {
            method: "DELETE",
            requestUri: "/rummetrics/{AppMonitorName}/metrics",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppMonitorName",
              "Destination",
              "MetricDefinitionIds"
            ],
            members: {
              AppMonitorName: {
                location: "uri",
                locationName: "AppMonitorName"
              },
              Destination: {
                location: "querystring",
                locationName: "destination"
              },
              DestinationArn: {
                location: "querystring",
                locationName: "destinationArn"
              },
              MetricDefinitionIds: {
                shape: "Sn",
                location: "querystring",
                locationName: "metricDefinitionIds"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Errors"
            ],
            members: {
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ErrorCode",
                    "ErrorMessage",
                    "MetricDefinitionId"
                  ],
                  members: {
                    ErrorCode: {},
                    ErrorMessage: {},
                    MetricDefinitionId: {}
                  }
                }
              },
              MetricDefinitionIds: {
                shape: "Sn"
              }
            }
          },
          idempotent: true
        },
        BatchGetRumMetricDefinitions: {
          http: {
            method: "GET",
            requestUri: "/rummetrics/{AppMonitorName}/metrics",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppMonitorName",
              "Destination"
            ],
            members: {
              AppMonitorName: {
                location: "uri",
                locationName: "AppMonitorName"
              },
              Destination: {
                location: "querystring",
                locationName: "destination"
              },
              DestinationArn: {
                location: "querystring",
                locationName: "destinationArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MetricDefinitions: {
                shape: "Sj"
              },
              NextToken: {}
            }
          }
        },
        CreateAppMonitor: {
          http: {
            requestUri: "/appmonitor",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Domain",
              "Name"
            ],
            members: {
              AppMonitorConfiguration: {
                shape: "Sv"
              },
              CustomEvents: {
                shape: "S15"
              },
              CwLogEnabled: {
                type: "boolean"
              },
              Domain: {},
              Name: {},
              Tags: {
                shape: "S18"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {}
            }
          },
          idempotent: true
        },
        DeleteAppMonitor: {
          http: {
            method: "DELETE",
            requestUri: "/appmonitor/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteRumMetricsDestination: {
          http: {
            method: "DELETE",
            requestUri: "/rummetrics/{AppMonitorName}/metricsdestination",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppMonitorName",
              "Destination"
            ],
            members: {
              AppMonitorName: {
                location: "uri",
                locationName: "AppMonitorName"
              },
              Destination: {
                location: "querystring",
                locationName: "destination"
              },
              DestinationArn: {
                location: "querystring",
                locationName: "destinationArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        GetAppMonitor: {
          http: {
            method: "GET",
            requestUri: "/appmonitor/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppMonitor: {
                type: "structure",
                members: {
                  AppMonitorConfiguration: {
                    shape: "Sv"
                  },
                  Created: {},
                  CustomEvents: {
                    shape: "S15"
                  },
                  DataStorage: {
                    type: "structure",
                    members: {
                      CwLog: {
                        type: "structure",
                        members: {
                          CwLogEnabled: {
                            type: "boolean"
                          },
                          CwLogGroup: {}
                        }
                      }
                    }
                  },
                  Domain: {},
                  Id: {},
                  LastModified: {},
                  Name: {},
                  State: {},
                  Tags: {
                    shape: "S18"
                  }
                }
              }
            }
          }
        },
        GetAppMonitorData: {
          http: {
            requestUri: "/appmonitor/{Name}/data",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "TimeRange"
            ],
            members: {
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              Name: {
                location: "uri",
                locationName: "Name"
              },
              NextToken: {},
              TimeRange: {
                type: "structure",
                required: [
                  "After"
                ],
                members: {
                  After: {
                    type: "long"
                  },
                  Before: {
                    type: "long"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Events: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListAppMonitors: {
          http: {
            requestUri: "/appmonitors",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppMonitorSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Created: {},
                    Id: {},
                    LastModified: {},
                    Name: {},
                    State: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListRumMetricsDestinations: {
          http: {
            method: "GET",
            requestUri: "/rummetrics/{AppMonitorName}/metricsdestination",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppMonitorName"
            ],
            members: {
              AppMonitorName: {
                location: "uri",
                locationName: "AppMonitorName"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Destinations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Destination: {},
                    DestinationArn: {},
                    IamRoleArn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S18"
              }
            }
          }
        },
        PutRumEvents: {
          http: {
            requestUri: "/appmonitors/{Id}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppMonitorDetails",
              "BatchId",
              "Id",
              "RumEvents",
              "UserDetails"
            ],
            members: {
              AppMonitorDetails: {
                type: "structure",
                members: {
                  id: {},
                  name: {},
                  version: {}
                }
              },
              BatchId: {},
              Id: {
                location: "uri",
                locationName: "Id"
              },
              RumEvents: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "details",
                    "id",
                    "timestamp",
                    "type"
                  ],
                  members: {
                    details: {
                      jsonvalue: true
                    },
                    id: {},
                    metadata: {
                      jsonvalue: true
                    },
                    timestamp: {
                      type: "timestamp"
                    },
                    type: {}
                  }
                }
              },
              UserDetails: {
                type: "structure",
                members: {
                  sessionId: {},
                  userId: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "dataplane."
          }
        },
        PutRumMetricsDestination: {
          http: {
            requestUri: "/rummetrics/{AppMonitorName}/metricsdestination",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppMonitorName",
              "Destination"
            ],
            members: {
              AppMonitorName: {
                location: "uri",
                locationName: "AppMonitorName"
              },
              Destination: {},
              DestinationArn: {},
              IamRoleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        TagResource: {
          http: {
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "S18"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateAppMonitor: {
          http: {
            method: "PATCH",
            requestUri: "/appmonitor/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              AppMonitorConfiguration: {
                shape: "Sv"
              },
              CustomEvents: {
                shape: "S15"
              },
              CwLogEnabled: {
                type: "boolean"
              },
              Domain: {},
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateRumMetricDefinition: {
          http: {
            method: "PATCH",
            requestUri: "/rummetrics/{AppMonitorName}/metrics",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppMonitorName",
              "Destination",
              "MetricDefinition",
              "MetricDefinitionId"
            ],
            members: {
              AppMonitorName: {
                location: "uri",
                locationName: "AppMonitorName"
              },
              Destination: {},
              DestinationArn: {},
              MetricDefinition: {
                shape: "S6"
              },
              MetricDefinitionId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        }
      },
      shapes: {
        S6: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            DimensionKeys: {
              shape: "S7"
            },
            EventPattern: {},
            Name: {},
            Namespace: {},
            UnitLabel: {},
            ValueKey: {}
          }
        },
        S7: {
          type: "map",
          key: {},
          value: {}
        },
        Sj: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "MetricDefinitionId",
              "Name"
            ],
            members: {
              DimensionKeys: {
                shape: "S7"
              },
              EventPattern: {},
              MetricDefinitionId: {},
              Name: {},
              Namespace: {},
              UnitLabel: {},
              ValueKey: {}
            }
          }
        },
        Sn: {
          type: "list",
          member: {}
        },
        Sv: {
          type: "structure",
          members: {
            AllowCookies: {
              type: "boolean"
            },
            EnableXRay: {
              type: "boolean"
            },
            ExcludedPages: {
              shape: "Sx"
            },
            FavoritePages: {
              type: "list",
              member: {}
            },
            GuestRoleArn: {},
            IdentityPoolId: {},
            IncludedPages: {
              shape: "Sx"
            },
            SessionSampleRate: {
              type: "double"
            },
            Telemetries: {
              type: "list",
              member: {}
            }
          }
        },
        Sx: {
          type: "list",
          member: {}
        },
        S15: {
          type: "structure",
          members: {
            Status: {}
          }
        },
        S18: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/rum-2018-05-10.paginators.json
var require_rum_2018_05_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/rum-2018-05-10.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        BatchGetRumMetricDefinitions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "MetricDefinitions"
        },
        GetAppMonitorData: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Events"
        },
        ListAppMonitors: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AppMonitorSummaries"
        },
        ListRumMetricsDestinations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Destinations"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/rum.js
var require_rum = __commonJS({
  "node_modules/aws-sdk/clients/rum.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["rum"] = {};
    AWS2.RUM = Service.defineService("rum", ["2018-05-10"]);
    Object.defineProperty(apiLoader.services["rum"], "2018-05-10", {
      get: function get() {
        var model = require_rum_2018_05_10_min();
        model.paginators = require_rum_2018_05_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.RUM;
  }
});

// node_modules/aws-sdk/apis/backup-gateway-2021-01-01.min.json
var require_backup_gateway_2021_01_01_min = __commonJS({
  "node_modules/aws-sdk/apis/backup-gateway-2021-01-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-01-01",
        endpointPrefix: "backup-gateway",
        jsonVersion: "1.0",
        protocol: "json",
        serviceFullName: "AWS Backup Gateway",
        serviceId: "Backup Gateway",
        signatureVersion: "v4",
        signingName: "backup-gateway",
        targetPrefix: "BackupOnPremises_v20210101",
        uid: "backup-gateway-2021-01-01"
      },
      operations: {
        AssociateGatewayToServer: {
          input: {
            type: "structure",
            required: [
              "GatewayArn",
              "ServerArn"
            ],
            members: {
              GatewayArn: {},
              ServerArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayArn: {}
            }
          }
        },
        CreateGateway: {
          input: {
            type: "structure",
            required: [
              "ActivationKey",
              "GatewayDisplayName",
              "GatewayType"
            ],
            members: {
              ActivationKey: {},
              GatewayDisplayName: {},
              GatewayType: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayArn: {}
            }
          }
        },
        DeleteGateway: {
          input: {
            type: "structure",
            required: [
              "GatewayArn"
            ],
            members: {
              GatewayArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayArn: {}
            }
          },
          idempotent: true
        },
        DeleteHypervisor: {
          input: {
            type: "structure",
            required: [
              "HypervisorArn"
            ],
            members: {
              HypervisorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              HypervisorArn: {}
            }
          },
          idempotent: true
        },
        DisassociateGatewayFromServer: {
          input: {
            type: "structure",
            required: [
              "GatewayArn"
            ],
            members: {
              GatewayArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayArn: {}
            }
          }
        },
        GetBandwidthRateLimitSchedule: {
          input: {
            type: "structure",
            required: [
              "GatewayArn"
            ],
            members: {
              GatewayArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BandwidthRateLimitIntervals: {
                shape: "Sm"
              },
              GatewayArn: {}
            }
          }
        },
        GetGateway: {
          input: {
            type: "structure",
            required: [
              "GatewayArn"
            ],
            members: {
              GatewayArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Gateway: {
                type: "structure",
                members: {
                  GatewayArn: {},
                  GatewayDisplayName: {},
                  GatewayType: {},
                  HypervisorId: {},
                  LastSeenTime: {
                    type: "timestamp"
                  },
                  MaintenanceStartTime: {
                    type: "structure",
                    required: [
                      "HourOfDay",
                      "MinuteOfHour"
                    ],
                    members: {
                      DayOfMonth: {
                        type: "integer"
                      },
                      DayOfWeek: {
                        type: "integer"
                      },
                      HourOfDay: {
                        type: "integer"
                      },
                      MinuteOfHour: {
                        type: "integer"
                      }
                    }
                  },
                  NextUpdateAvailabilityTime: {
                    type: "timestamp"
                  },
                  VpcEndpoint: {}
                }
              }
            }
          }
        },
        GetHypervisor: {
          input: {
            type: "structure",
            required: [
              "HypervisorArn"
            ],
            members: {
              HypervisorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Hypervisor: {
                type: "structure",
                members: {
                  Host: {},
                  HypervisorArn: {},
                  KmsKeyArn: {},
                  LastSuccessfulMetadataSyncTime: {
                    type: "timestamp"
                  },
                  LatestMetadataSyncStatus: {},
                  LatestMetadataSyncStatusMessage: {},
                  LogGroupArn: {},
                  Name: {},
                  State: {}
                }
              }
            }
          }
        },
        GetHypervisorPropertyMappings: {
          input: {
            type: "structure",
            required: [
              "HypervisorArn"
            ],
            members: {
              HypervisorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              HypervisorArn: {},
              IamRoleArn: {},
              VmwareToAwsTagMappings: {
                shape: "S1d"
              }
            }
          }
        },
        GetVirtualMachine: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VirtualMachine: {
                type: "structure",
                members: {
                  HostName: {},
                  HypervisorId: {},
                  LastBackupDate: {
                    type: "timestamp"
                  },
                  Name: {},
                  Path: {},
                  ResourceArn: {},
                  VmwareTags: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        VmwareCategory: {},
                        VmwareTagDescription: {},
                        VmwareTagName: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        ImportHypervisorConfiguration: {
          input: {
            type: "structure",
            required: [
              "Host",
              "Name"
            ],
            members: {
              Host: {},
              KmsKeyArn: {},
              Name: {},
              Password: {
                shape: "S1p"
              },
              Tags: {
                shape: "S9"
              },
              Username: {
                shape: "S1q"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HypervisorArn: {}
            }
          }
        },
        ListGateways: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Gateways: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    GatewayArn: {},
                    GatewayDisplayName: {},
                    GatewayType: {},
                    HypervisorId: {},
                    LastSeenTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListHypervisors: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Hypervisors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Host: {},
                    HypervisorArn: {},
                    KmsKeyArn: {},
                    Name: {},
                    State: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S9"
              }
            }
          }
        },
        ListVirtualMachines: {
          input: {
            type: "structure",
            members: {
              HypervisorArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              VirtualMachines: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    HostName: {},
                    HypervisorId: {},
                    LastBackupDate: {
                      type: "timestamp"
                    },
                    Name: {},
                    Path: {},
                    ResourceArn: {}
                  }
                }
              }
            }
          }
        },
        PutBandwidthRateLimitSchedule: {
          input: {
            type: "structure",
            required: [
              "BandwidthRateLimitIntervals",
              "GatewayArn"
            ],
            members: {
              BandwidthRateLimitIntervals: {
                shape: "Sm"
              },
              GatewayArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayArn: {}
            }
          },
          idempotent: true
        },
        PutHypervisorPropertyMappings: {
          input: {
            type: "structure",
            required: [
              "HypervisorArn",
              "IamRoleArn",
              "VmwareToAwsTagMappings"
            ],
            members: {
              HypervisorArn: {},
              IamRoleArn: {},
              VmwareToAwsTagMappings: {
                shape: "S1d"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HypervisorArn: {}
            }
          },
          idempotent: true
        },
        PutMaintenanceStartTime: {
          input: {
            type: "structure",
            required: [
              "GatewayArn",
              "HourOfDay",
              "MinuteOfHour"
            ],
            members: {
              DayOfMonth: {
                type: "integer"
              },
              DayOfWeek: {
                type: "integer"
              },
              GatewayArn: {},
              HourOfDay: {
                type: "integer"
              },
              MinuteOfHour: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayArn: {}
            }
          }
        },
        StartVirtualMachinesMetadataSync: {
          input: {
            type: "structure",
            required: [
              "HypervisorArn"
            ],
            members: {
              HypervisorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              HypervisorArn: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceARN: {}
            }
          }
        },
        TestHypervisorConfiguration: {
          input: {
            type: "structure",
            required: [
              "GatewayArn",
              "Host"
            ],
            members: {
              GatewayArn: {},
              Host: {},
              Password: {
                shape: "S1p"
              },
              Username: {
                shape: "S1q"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceARN: {}
            }
          }
        },
        UpdateGatewayInformation: {
          input: {
            type: "structure",
            required: [
              "GatewayArn"
            ],
            members: {
              GatewayArn: {},
              GatewayDisplayName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayArn: {}
            }
          }
        },
        UpdateGatewaySoftwareNow: {
          input: {
            type: "structure",
            required: [
              "GatewayArn"
            ],
            members: {
              GatewayArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayArn: {}
            }
          }
        },
        UpdateHypervisor: {
          input: {
            type: "structure",
            required: [
              "HypervisorArn"
            ],
            members: {
              Host: {},
              HypervisorArn: {},
              LogGroupArn: {},
              Name: {},
              Password: {
                shape: "S1p"
              },
              Username: {
                shape: "S1q"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HypervisorArn: {}
            }
          }
        }
      },
      shapes: {
        S9: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sm: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "DaysOfWeek",
              "EndHourOfDay",
              "EndMinuteOfHour",
              "StartHourOfDay",
              "StartMinuteOfHour"
            ],
            members: {
              AverageUploadRateLimitInBitsPerSec: {
                type: "long"
              },
              DaysOfWeek: {
                type: "list",
                member: {
                  type: "integer"
                }
              },
              EndHourOfDay: {
                type: "integer"
              },
              EndMinuteOfHour: {
                type: "integer"
              },
              StartHourOfDay: {
                type: "integer"
              },
              StartMinuteOfHour: {
                type: "integer"
              }
            }
          }
        },
        S1d: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AwsTagKey",
              "AwsTagValue",
              "VmwareCategory",
              "VmwareTagName"
            ],
            members: {
              AwsTagKey: {},
              AwsTagValue: {},
              VmwareCategory: {},
              VmwareTagName: {}
            }
          }
        },
        S1p: {
          type: "string",
          sensitive: true
        },
        S1q: {
          type: "string",
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/backup-gateway-2021-01-01.paginators.json
var require_backup_gateway_2021_01_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/backup-gateway-2021-01-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListGateways: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Gateways"
        },
        ListHypervisors: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Hypervisors"
        },
        ListVirtualMachines: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "VirtualMachines"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/backupgateway.js
var require_backupgateway = __commonJS({
  "node_modules/aws-sdk/clients/backupgateway.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["backupgateway"] = {};
    AWS2.BackupGateway = Service.defineService("backupgateway", ["2021-01-01"]);
    Object.defineProperty(apiLoader.services["backupgateway"], "2021-01-01", {
      get: function get() {
        var model = require_backup_gateway_2021_01_01_min();
        model.paginators = require_backup_gateway_2021_01_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.BackupGateway;
  }
});

// node_modules/aws-sdk/apis/iottwinmaker-2021-11-29.min.json
var require_iottwinmaker_2021_11_29_min = __commonJS({
  "node_modules/aws-sdk/apis/iottwinmaker-2021-11-29.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-11-29",
        endpointPrefix: "iottwinmaker",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS IoT TwinMaker",
        serviceId: "IoTTwinMaker",
        signatureVersion: "v4",
        signingName: "iottwinmaker",
        uid: "iottwinmaker-2021-11-29"
      },
      operations: {
        BatchPutPropertyValues: {
          http: {
            requestUri: "/workspaces/{workspaceId}/entity-properties",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId",
              "entries"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              entries: {
                type: "list",
                member: {
                  shape: "S4"
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "errorEntries"
            ],
            members: {
              errorEntries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "errors"
                  ],
                  members: {
                    errors: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "errorCode",
                          "errorMessage",
                          "entry"
                        ],
                        members: {
                          errorCode: {},
                          errorMessage: {},
                          entry: {
                            shape: "S4"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "data."
          }
        },
        CancelMetadataTransferJob: {
          http: {
            method: "PUT",
            requestUri: "/metadata-transfer-jobs/{metadataTransferJobId}/cancel",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "metadataTransferJobId"
            ],
            members: {
              metadataTransferJobId: {
                location: "uri",
                locationName: "metadataTransferJobId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "metadataTransferJobId",
              "arn",
              "updateDateTime",
              "status"
            ],
            members: {
              metadataTransferJobId: {},
              arn: {},
              updateDateTime: {
                type: "timestamp"
              },
              status: {
                shape: "Sw"
              },
              progress: {
                shape: "S11"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        CreateComponentType: {
          http: {
            requestUri: "/workspaces/{workspaceId}/component-types/{componentTypeId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId",
              "componentTypeId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              isSingleton: {
                type: "boolean"
              },
              componentTypeId: {
                location: "uri",
                locationName: "componentTypeId"
              },
              description: {},
              propertyDefinitions: {
                shape: "S15"
              },
              extendsFrom: {
                shape: "S1d"
              },
              functions: {
                shape: "S1e"
              },
              tags: {
                shape: "S1l"
              },
              propertyGroups: {
                shape: "S1o"
              },
              componentTypeName: {},
              compositeComponentTypes: {
                shape: "S1t"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "creationDateTime",
              "state"
            ],
            members: {
              arn: {},
              creationDateTime: {
                type: "timestamp"
              },
              state: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        CreateEntity: {
          http: {
            requestUri: "/workspaces/{workspaceId}/entities",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId",
              "entityName"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              entityId: {},
              entityName: {},
              description: {},
              components: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    description: {},
                    componentTypeId: {},
                    properties: {
                      shape: "S21"
                    },
                    propertyGroups: {
                      shape: "S24"
                    }
                  }
                }
              },
              compositeComponents: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    description: {},
                    properties: {
                      shape: "S21"
                    },
                    propertyGroups: {
                      shape: "S24"
                    }
                  }
                }
              },
              parentEntityId: {},
              tags: {
                shape: "S1l"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "entityId",
              "arn",
              "creationDateTime",
              "state"
            ],
            members: {
              entityId: {},
              arn: {},
              creationDateTime: {
                type: "timestamp"
              },
              state: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        CreateMetadataTransferJob: {
          http: {
            requestUri: "/metadata-transfer-jobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sources",
              "destination"
            ],
            members: {
              metadataTransferJobId: {},
              description: {},
              sources: {
                shape: "S2c"
              },
              destination: {
                shape: "S2t"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "metadataTransferJobId",
              "arn",
              "creationDateTime",
              "status"
            ],
            members: {
              metadataTransferJobId: {},
              arn: {},
              creationDateTime: {
                type: "timestamp"
              },
              status: {
                shape: "Sw"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        CreateScene: {
          http: {
            requestUri: "/workspaces/{workspaceId}/scenes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId",
              "sceneId",
              "contentLocation"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              sceneId: {},
              contentLocation: {},
              description: {},
              capabilities: {
                shape: "S31"
              },
              tags: {
                shape: "S1l"
              },
              sceneMetadata: {
                shape: "S33"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "creationDateTime"
            ],
            members: {
              arn: {},
              creationDateTime: {
                type: "timestamp"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        CreateSyncJob: {
          http: {
            requestUri: "/workspaces/{workspaceId}/sync-jobs/{syncSource}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId",
              "syncSource",
              "syncRole"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              syncSource: {
                location: "uri",
                locationName: "syncSource"
              },
              syncRole: {},
              tags: {
                shape: "S1l"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "creationDateTime",
              "state"
            ],
            members: {
              arn: {},
              creationDateTime: {
                type: "timestamp"
              },
              state: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        CreateWorkspace: {
          http: {
            requestUri: "/workspaces/{workspaceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              description: {},
              s3Location: {},
              role: {},
              tags: {
                shape: "S1l"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "creationDateTime"
            ],
            members: {
              arn: {},
              creationDateTime: {
                type: "timestamp"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DeleteComponentType: {
          http: {
            method: "DELETE",
            requestUri: "/workspaces/{workspaceId}/component-types/{componentTypeId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId",
              "componentTypeId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              componentTypeId: {
                location: "uri",
                locationName: "componentTypeId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "state"
            ],
            members: {
              state: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DeleteEntity: {
          http: {
            method: "DELETE",
            requestUri: "/workspaces/{workspaceId}/entities/{entityId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId",
              "entityId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              entityId: {
                location: "uri",
                locationName: "entityId"
              },
              isRecursive: {
                location: "querystring",
                locationName: "isRecursive",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "state"
            ],
            members: {
              state: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DeleteScene: {
          http: {
            method: "DELETE",
            requestUri: "/workspaces/{workspaceId}/scenes/{sceneId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId",
              "sceneId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              sceneId: {
                location: "uri",
                locationName: "sceneId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DeleteSyncJob: {
          http: {
            method: "DELETE",
            requestUri: "/workspaces/{workspaceId}/sync-jobs/{syncSource}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId",
              "syncSource"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              syncSource: {
                location: "uri",
                locationName: "syncSource"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "state"
            ],
            members: {
              state: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DeleteWorkspace: {
          http: {
            method: "DELETE",
            requestUri: "/workspaces/{workspaceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              message: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ExecuteQuery: {
          http: {
            requestUri: "/queries/execution",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId",
              "queryStatement"
            ],
            members: {
              workspaceId: {},
              queryStatement: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              columnDescriptions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    type: {}
                  }
                }
              },
              rows: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    rowData: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {},
                        document: true
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        GetComponentType: {
          http: {
            method: "GET",
            requestUri: "/workspaces/{workspaceId}/component-types/{componentTypeId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId",
              "componentTypeId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              componentTypeId: {
                location: "uri",
                locationName: "componentTypeId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "workspaceId",
              "componentTypeId",
              "creationDateTime",
              "updateDateTime",
              "arn"
            ],
            members: {
              workspaceId: {},
              isSingleton: {
                type: "boolean"
              },
              componentTypeId: {},
              description: {},
              propertyDefinitions: {
                type: "map",
                key: {},
                value: {
                  shape: "S45"
                }
              },
              extendsFrom: {
                shape: "S1d"
              },
              functions: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    requiredProperties: {
                      shape: "S1g"
                    },
                    scope: {},
                    implementedBy: {
                      shape: "S1i"
                    },
                    isInherited: {
                      type: "boolean"
                    }
                  }
                }
              },
              creationDateTime: {
                type: "timestamp"
              },
              updateDateTime: {
                type: "timestamp"
              },
              arn: {},
              isAbstract: {
                type: "boolean"
              },
              isSchemaInitialized: {
                type: "boolean"
              },
              status: {
                shape: "S48"
              },
              propertyGroups: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  required: [
                    "groupType",
                    "propertyNames",
                    "isInherited"
                  ],
                  members: {
                    groupType: {},
                    propertyNames: {
                      shape: "S1r"
                    },
                    isInherited: {
                      type: "boolean"
                    }
                  }
                }
              },
              syncSource: {},
              componentTypeName: {},
              compositeComponentTypes: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    componentTypeId: {},
                    isInherited: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        GetEntity: {
          http: {
            method: "GET",
            requestUri: "/workspaces/{workspaceId}/entities/{entityId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId",
              "entityId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              entityId: {
                location: "uri",
                locationName: "entityId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "entityId",
              "entityName",
              "arn",
              "status",
              "workspaceId",
              "parentEntityId",
              "hasChildEntities",
              "creationDateTime",
              "updateDateTime"
            ],
            members: {
              entityId: {},
              entityName: {},
              arn: {},
              status: {
                shape: "S48"
              },
              workspaceId: {},
              description: {},
              components: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    componentName: {},
                    description: {},
                    componentTypeId: {},
                    status: {
                      shape: "S48"
                    },
                    definedIn: {},
                    properties: {
                      type: "map",
                      key: {},
                      value: {
                        type: "structure",
                        members: {
                          definition: {
                            shape: "S45"
                          },
                          value: {
                            shape: "Se"
                          },
                          areAllPropertyValuesReturned: {
                            type: "boolean"
                          }
                        }
                      }
                    },
                    propertyGroups: {
                      shape: "S4j"
                    },
                    syncSource: {},
                    areAllPropertiesReturned: {
                      type: "boolean"
                    },
                    compositeComponents: {
                      type: "map",
                      key: {},
                      value: {
                        shape: "S4m"
                      }
                    },
                    areAllCompositeComponentsReturned: {
                      type: "boolean"
                    }
                  }
                }
              },
              parentEntityId: {},
              hasChildEntities: {
                type: "boolean"
              },
              creationDateTime: {
                type: "timestamp"
              },
              updateDateTime: {
                type: "timestamp"
              },
              syncSource: {},
              areAllComponentsReturned: {
                type: "boolean"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        GetMetadataTransferJob: {
          http: {
            method: "GET",
            requestUri: "/metadata-transfer-jobs/{metadataTransferJobId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "metadataTransferJobId"
            ],
            members: {
              metadataTransferJobId: {
                location: "uri",
                locationName: "metadataTransferJobId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "metadataTransferJobId",
              "arn",
              "sources",
              "destination",
              "metadataTransferJobRole",
              "creationDateTime",
              "updateDateTime",
              "status"
            ],
            members: {
              metadataTransferJobId: {},
              arn: {},
              description: {},
              sources: {
                shape: "S2c"
              },
              destination: {
                shape: "S2t"
              },
              metadataTransferJobRole: {},
              reportUrl: {},
              creationDateTime: {
                type: "timestamp"
              },
              updateDateTime: {
                type: "timestamp"
              },
              status: {
                shape: "Sw"
              },
              progress: {
                shape: "S11"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        GetPricingPlan: {
          http: {
            method: "GET",
            requestUri: "/pricingplan",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "currentPricingPlan"
            ],
            members: {
              currentPricingPlan: {
                shape: "S4r"
              },
              pendingPricingPlan: {
                shape: "S4r"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        GetPropertyValue: {
          http: {
            requestUri: "/workspaces/{workspaceId}/entity-properties/value",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "selectedProperties",
              "workspaceId"
            ],
            members: {
              componentName: {},
              componentPath: {},
              componentTypeId: {},
              entityId: {},
              selectedProperties: {
                shape: "S4z"
              },
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              propertyGroupName: {},
              tabularConditions: {
                type: "structure",
                members: {
                  orderBy: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "propertyName"
                      ],
                      members: {
                        order: {},
                        propertyName: {}
                      }
                    }
                  },
                  propertyFilters: {
                    shape: "S55"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              propertyValues: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  required: [
                    "propertyReference"
                  ],
                  members: {
                    propertyReference: {
                      shape: "S5"
                    },
                    propertyValue: {
                      shape: "Se"
                    }
                  }
                }
              },
              nextToken: {},
              tabularPropertyValues: {
                type: "list",
                member: {
                  type: "list",
                  member: {
                    type: "map",
                    key: {},
                    value: {
                      shape: "Se"
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "data."
          }
        },
        GetPropertyValueHistory: {
          http: {
            requestUri: "/workspaces/{workspaceId}/entity-properties/history",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId",
              "selectedProperties"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              entityId: {},
              componentName: {},
              componentPath: {},
              componentTypeId: {},
              selectedProperties: {
                shape: "S4z"
              },
              propertyFilters: {
                shape: "S55"
              },
              startDateTime: {
                deprecated: true,
                deprecatedMessage: "This field is deprecated and will throw an error in the future. Use startTime instead.",
                type: "timestamp"
              },
              endDateTime: {
                deprecated: true,
                deprecatedMessage: "This field is deprecated and will throw an error in the future. Use endTime instead.",
                type: "timestamp"
              },
              interpolation: {
                type: "structure",
                members: {
                  interpolationType: {},
                  intervalInSeconds: {
                    type: "long"
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              orderByTime: {},
              startTime: {},
              endTime: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "propertyValues"
            ],
            members: {
              propertyValues: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "entityPropertyReference"
                  ],
                  members: {
                    entityPropertyReference: {
                      shape: "S5"
                    },
                    values: {
                      type: "list",
                      member: {
                        shape: "Sc"
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "data."
          }
        },
        GetScene: {
          http: {
            method: "GET",
            requestUri: "/workspaces/{workspaceId}/scenes/{sceneId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId",
              "sceneId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              sceneId: {
                location: "uri",
                locationName: "sceneId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "workspaceId",
              "sceneId",
              "contentLocation",
              "arn",
              "creationDateTime",
              "updateDateTime"
            ],
            members: {
              workspaceId: {},
              sceneId: {},
              contentLocation: {},
              arn: {},
              creationDateTime: {
                type: "timestamp"
              },
              updateDateTime: {
                type: "timestamp"
              },
              description: {},
              capabilities: {
                shape: "S31"
              },
              sceneMetadata: {
                shape: "S33"
              },
              generatedSceneMetadata: {
                type: "map",
                key: {},
                value: {}
              },
              error: {
                type: "structure",
                members: {
                  code: {},
                  message: {}
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        GetSyncJob: {
          http: {
            method: "GET",
            requestUri: "/sync-jobs/{syncSource}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "syncSource"
            ],
            members: {
              syncSource: {
                location: "uri",
                locationName: "syncSource"
              },
              workspaceId: {
                location: "querystring",
                locationName: "workspace"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "workspaceId",
              "syncSource",
              "syncRole",
              "status",
              "creationDateTime",
              "updateDateTime"
            ],
            members: {
              arn: {},
              workspaceId: {},
              syncSource: {},
              syncRole: {},
              status: {
                shape: "S5t"
              },
              creationDateTime: {
                type: "timestamp"
              },
              updateDateTime: {
                type: "timestamp"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        GetWorkspace: {
          http: {
            method: "GET",
            requestUri: "/workspaces/{workspaceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "workspaceId",
              "arn",
              "creationDateTime",
              "updateDateTime"
            ],
            members: {
              workspaceId: {},
              arn: {},
              description: {},
              linkedServices: {
                shape: "S5x"
              },
              s3Location: {},
              role: {},
              creationDateTime: {
                type: "timestamp"
              },
              updateDateTime: {
                type: "timestamp"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListComponentTypes: {
          http: {
            requestUri: "/workspaces/{workspaceId}/component-types-list",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    extendsFrom: {},
                    namespace: {},
                    isAbstract: {
                      type: "boolean"
                    }
                  },
                  union: true
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "workspaceId",
              "componentTypeSummaries"
            ],
            members: {
              workspaceId: {},
              componentTypeSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "componentTypeId",
                    "creationDateTime",
                    "updateDateTime"
                  ],
                  members: {
                    arn: {},
                    componentTypeId: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    updateDateTime: {
                      type: "timestamp"
                    },
                    description: {},
                    status: {
                      shape: "S48"
                    },
                    componentTypeName: {}
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListComponents: {
          http: {
            requestUri: "/workspaces/{workspaceId}/entities/{entityId}/components-list",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId",
              "entityId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              entityId: {
                location: "uri",
                locationName: "entityId"
              },
              componentPath: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "componentSummaries"
            ],
            members: {
              componentSummaries: {
                type: "list",
                member: {
                  shape: "S4m"
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListEntities: {
          http: {
            requestUri: "/workspaces/{workspaceId}/entities-list",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    parentEntityId: {},
                    componentTypeId: {},
                    externalId: {}
                  },
                  union: true
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              entitySummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "entityId",
                    "entityName",
                    "arn",
                    "status",
                    "creationDateTime",
                    "updateDateTime"
                  ],
                  members: {
                    entityId: {},
                    entityName: {},
                    arn: {},
                    parentEntityId: {},
                    status: {
                      shape: "S48"
                    },
                    description: {},
                    hasChildEntities: {
                      type: "boolean"
                    },
                    creationDateTime: {
                      type: "timestamp"
                    },
                    updateDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListMetadataTransferJobs: {
          http: {
            requestUri: "/metadata-transfer-jobs-list",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceType",
              "destinationType"
            ],
            members: {
              sourceType: {},
              destinationType: {},
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    workspaceId: {},
                    state: {}
                  },
                  union: true
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "metadataTransferJobSummaries"
            ],
            members: {
              metadataTransferJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "metadataTransferJobId",
                    "arn",
                    "creationDateTime",
                    "updateDateTime",
                    "status"
                  ],
                  members: {
                    metadataTransferJobId: {},
                    arn: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    updateDateTime: {
                      type: "timestamp"
                    },
                    status: {
                      shape: "Sw"
                    },
                    progress: {
                      shape: "S11"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListProperties: {
          http: {
            requestUri: "/workspaces/{workspaceId}/properties-list",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId",
              "entityId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              componentName: {},
              componentPath: {},
              entityId: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "propertySummaries"
            ],
            members: {
              propertySummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "propertyName"
                  ],
                  members: {
                    definition: {
                      shape: "S45"
                    },
                    propertyName: {},
                    value: {
                      shape: "Se"
                    },
                    areAllPropertyValuesReturned: {
                      type: "boolean"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListScenes: {
          http: {
            requestUri: "/workspaces/{workspaceId}/scenes-list",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              sceneSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "sceneId",
                    "contentLocation",
                    "arn",
                    "creationDateTime",
                    "updateDateTime"
                  ],
                  members: {
                    sceneId: {},
                    contentLocation: {},
                    arn: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    updateDateTime: {
                      type: "timestamp"
                    },
                    description: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListSyncJobs: {
          http: {
            requestUri: "/workspaces/{workspaceId}/sync-jobs-list",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              syncJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    workspaceId: {},
                    syncSource: {},
                    status: {
                      shape: "S5t"
                    },
                    creationDateTime: {
                      type: "timestamp"
                    },
                    updateDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListSyncResources: {
          http: {
            requestUri: "/workspaces/{workspaceId}/sync-jobs/{syncSource}/resources-list",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId",
              "syncSource"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              syncSource: {
                location: "uri",
                locationName: "syncSource"
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    state: {},
                    resourceType: {},
                    resourceId: {},
                    externalId: {}
                  },
                  union: true
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              syncResources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    resourceType: {},
                    externalId: {},
                    resourceId: {},
                    status: {
                      type: "structure",
                      members: {
                        state: {},
                        error: {
                          shape: "Sy"
                        }
                      }
                    },
                    updateDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListTagsForResource: {
          http: {
            requestUri: "/tags-list",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceARN"
            ],
            members: {
              resourceARN: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S1l"
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListWorkspaces: {
          http: {
            requestUri: "/workspaces-list",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              workspaceSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "workspaceId",
                    "arn",
                    "creationDateTime",
                    "updateDateTime"
                  ],
                  members: {
                    workspaceId: {},
                    arn: {},
                    description: {},
                    linkedServices: {
                      shape: "S5x"
                    },
                    creationDateTime: {
                      type: "timestamp"
                    },
                    updateDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceARN",
              "tags"
            ],
            members: {
              resourceARN: {},
              tags: {
                shape: "S1l"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceARN",
              "tagKeys"
            ],
            members: {
              resourceARN: {
                location: "querystring",
                locationName: "resourceARN"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        UpdateComponentType: {
          http: {
            method: "PUT",
            requestUri: "/workspaces/{workspaceId}/component-types/{componentTypeId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId",
              "componentTypeId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              isSingleton: {
                type: "boolean"
              },
              componentTypeId: {
                location: "uri",
                locationName: "componentTypeId"
              },
              description: {},
              propertyDefinitions: {
                shape: "S15"
              },
              extendsFrom: {
                shape: "S1d"
              },
              functions: {
                shape: "S1e"
              },
              propertyGroups: {
                shape: "S1o"
              },
              componentTypeName: {},
              compositeComponentTypes: {
                shape: "S1t"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "workspaceId",
              "arn",
              "componentTypeId",
              "state"
            ],
            members: {
              workspaceId: {},
              arn: {},
              componentTypeId: {},
              state: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        UpdateEntity: {
          http: {
            method: "PUT",
            requestUri: "/workspaces/{workspaceId}/entities/{entityId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId",
              "entityId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              entityId: {
                location: "uri",
                locationName: "entityId"
              },
              entityName: {},
              description: {},
              componentUpdates: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    updateType: {},
                    description: {},
                    componentTypeId: {},
                    propertyUpdates: {
                      shape: "S21"
                    },
                    propertyGroupUpdates: {
                      shape: "S24"
                    }
                  }
                }
              },
              compositeComponentUpdates: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    updateType: {},
                    description: {},
                    propertyUpdates: {
                      shape: "S21"
                    },
                    propertyGroupUpdates: {
                      shape: "S24"
                    }
                  }
                }
              },
              parentEntityUpdate: {
                type: "structure",
                required: [
                  "updateType"
                ],
                members: {
                  updateType: {},
                  parentEntityId: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "updateDateTime",
              "state"
            ],
            members: {
              updateDateTime: {
                type: "timestamp"
              },
              state: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        UpdatePricingPlan: {
          http: {
            requestUri: "/pricingplan",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "pricingMode"
            ],
            members: {
              pricingMode: {},
              bundleNames: {
                shape: "S4t"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "currentPricingPlan"
            ],
            members: {
              currentPricingPlan: {
                shape: "S4r"
              },
              pendingPricingPlan: {
                shape: "S4r"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        UpdateScene: {
          http: {
            method: "PUT",
            requestUri: "/workspaces/{workspaceId}/scenes/{sceneId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId",
              "sceneId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              sceneId: {
                location: "uri",
                locationName: "sceneId"
              },
              contentLocation: {},
              description: {},
              capabilities: {
                shape: "S31"
              },
              sceneMetadata: {
                shape: "S33"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "updateDateTime"
            ],
            members: {
              updateDateTime: {
                type: "timestamp"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        UpdateWorkspace: {
          http: {
            method: "PUT",
            requestUri: "/workspaces/{workspaceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              description: {},
              role: {},
              s3Location: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "updateDateTime"
            ],
            members: {
              updateDateTime: {
                type: "timestamp"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          required: [
            "entityPropertyReference"
          ],
          members: {
            entityPropertyReference: {
              shape: "S5"
            },
            propertyValues: {
              type: "list",
              member: {
                shape: "Sc"
              }
            }
          }
        },
        S5: {
          type: "structure",
          required: [
            "propertyName"
          ],
          members: {
            componentName: {},
            componentPath: {},
            externalIdProperty: {
              type: "map",
              key: {},
              value: {}
            },
            entityId: {},
            propertyName: {}
          }
        },
        Sc: {
          type: "structure",
          required: [
            "value"
          ],
          members: {
            timestamp: {
              deprecated: true,
              deprecatedMessage: "This field is deprecated and will throw an error in the future. Use time instead.",
              type: "timestamp"
            },
            value: {
              shape: "Se"
            },
            time: {}
          }
        },
        Se: {
          type: "structure",
          members: {
            booleanValue: {
              type: "boolean"
            },
            doubleValue: {
              type: "double"
            },
            integerValue: {
              type: "integer"
            },
            longValue: {
              type: "long"
            },
            stringValue: {},
            listValue: {
              shape: "Sj"
            },
            mapValue: {
              type: "map",
              key: {},
              value: {
                shape: "Se"
              }
            },
            relationshipValue: {
              type: "structure",
              members: {
                targetEntityId: {},
                targetComponentName: {}
              }
            },
            expression: {}
          }
        },
        Sj: {
          type: "list",
          member: {
            shape: "Se"
          }
        },
        Sw: {
          type: "structure",
          members: {
            state: {},
            error: {
              shape: "Sy"
            },
            queuedPosition: {
              type: "integer"
            }
          }
        },
        Sy: {
          type: "structure",
          members: {
            code: {},
            message: {}
          }
        },
        S11: {
          type: "structure",
          members: {
            totalCount: {
              type: "integer"
            },
            succeededCount: {
              type: "integer"
            },
            skippedCount: {
              type: "integer"
            },
            failedCount: {
              type: "integer"
            }
          }
        },
        S15: {
          type: "map",
          key: {},
          value: {
            shape: "S16"
          }
        },
        S16: {
          type: "structure",
          members: {
            dataType: {
              shape: "S17"
            },
            isRequiredInEntity: {
              type: "boolean"
            },
            isExternalId: {
              type: "boolean"
            },
            isStoredExternally: {
              type: "boolean"
            },
            isTimeSeries: {
              type: "boolean"
            },
            defaultValue: {
              shape: "Se"
            },
            configuration: {
              shape: "S1a"
            },
            displayName: {}
          }
        },
        S17: {
          type: "structure",
          required: [
            "type"
          ],
          members: {
            type: {},
            nestedType: {
              shape: "S17"
            },
            allowedValues: {
              shape: "Sj"
            },
            unitOfMeasure: {},
            relationship: {
              type: "structure",
              members: {
                targetComponentTypeId: {},
                relationshipType: {}
              }
            }
          }
        },
        S1a: {
          type: "map",
          key: {},
          value: {}
        },
        S1d: {
          type: "list",
          member: {}
        },
        S1e: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              requiredProperties: {
                shape: "S1g"
              },
              scope: {},
              implementedBy: {
                shape: "S1i"
              }
            }
          }
        },
        S1g: {
          type: "list",
          member: {}
        },
        S1i: {
          type: "structure",
          members: {
            lambda: {
              type: "structure",
              required: [
                "arn"
              ],
              members: {
                arn: {}
              }
            },
            isNative: {
              type: "boolean"
            }
          }
        },
        S1l: {
          type: "map",
          key: {},
          value: {}
        },
        S1o: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              groupType: {},
              propertyNames: {
                shape: "S1r"
              }
            }
          }
        },
        S1r: {
          type: "list",
          member: {}
        },
        S1t: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              componentTypeId: {}
            }
          }
        },
        S21: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              definition: {
                shape: "S16"
              },
              value: {
                shape: "Se"
              },
              updateType: {}
            }
          }
        },
        S24: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              groupType: {},
              propertyNames: {
                shape: "S1r"
              },
              updateType: {}
            }
          }
        },
        S2c: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "type"
            ],
            members: {
              type: {},
              s3Configuration: {
                type: "structure",
                required: [
                  "location"
                ],
                members: {
                  location: {}
                }
              },
              iotSiteWiseConfiguration: {
                type: "structure",
                members: {
                  filters: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        filterByAssetModel: {
                          type: "structure",
                          members: {
                            assetModelId: {},
                            assetModelExternalId: {},
                            includeOffspring: {
                              type: "boolean"
                            },
                            includeAssets: {
                              type: "boolean"
                            }
                          }
                        },
                        filterByAsset: {
                          type: "structure",
                          members: {
                            assetId: {},
                            assetExternalId: {},
                            includeOffspring: {
                              type: "boolean"
                            },
                            includeAssetModel: {
                              type: "boolean"
                            }
                          }
                        }
                      },
                      union: true
                    }
                  }
                }
              },
              iotTwinMakerConfiguration: {
                type: "structure",
                required: [
                  "workspace"
                ],
                members: {
                  workspace: {},
                  filters: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        filterByComponentType: {
                          type: "structure",
                          required: [
                            "componentTypeId"
                          ],
                          members: {
                            componentTypeId: {}
                          }
                        },
                        filterByEntity: {
                          type: "structure",
                          required: [
                            "entityId"
                          ],
                          members: {
                            entityId: {}
                          }
                        }
                      },
                      union: true
                    }
                  }
                }
              }
            }
          }
        },
        S2t: {
          type: "structure",
          required: [
            "type"
          ],
          members: {
            type: {},
            s3Configuration: {
              type: "structure",
              required: [
                "location"
              ],
              members: {
                location: {}
              }
            },
            iotTwinMakerConfiguration: {
              type: "structure",
              required: [
                "workspace"
              ],
              members: {
                workspace: {}
              }
            }
          }
        },
        S31: {
          type: "list",
          member: {}
        },
        S33: {
          type: "map",
          key: {},
          value: {}
        },
        S45: {
          type: "structure",
          required: [
            "dataType",
            "isTimeSeries",
            "isRequiredInEntity",
            "isExternalId",
            "isStoredExternally",
            "isImported",
            "isFinal",
            "isInherited"
          ],
          members: {
            dataType: {
              shape: "S17"
            },
            isTimeSeries: {
              type: "boolean"
            },
            isRequiredInEntity: {
              type: "boolean"
            },
            isExternalId: {
              type: "boolean"
            },
            isStoredExternally: {
              type: "boolean"
            },
            isImported: {
              type: "boolean"
            },
            isFinal: {
              type: "boolean"
            },
            isInherited: {
              type: "boolean"
            },
            defaultValue: {
              shape: "Se"
            },
            configuration: {
              shape: "S1a"
            },
            displayName: {}
          }
        },
        S48: {
          type: "structure",
          members: {
            state: {},
            error: {
              shape: "Sy"
            }
          }
        },
        S4j: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "groupType",
              "propertyNames",
              "isInherited"
            ],
            members: {
              groupType: {},
              propertyNames: {
                shape: "S1r"
              },
              isInherited: {
                type: "boolean"
              }
            }
          }
        },
        S4m: {
          type: "structure",
          required: [
            "componentName",
            "componentTypeId",
            "status"
          ],
          members: {
            componentName: {},
            componentTypeId: {},
            definedIn: {},
            description: {},
            propertyGroups: {
              shape: "S4j"
            },
            status: {
              shape: "S48"
            },
            syncSource: {},
            componentPath: {}
          }
        },
        S4r: {
          type: "structure",
          required: [
            "effectiveDateTime",
            "pricingMode",
            "updateDateTime",
            "updateReason"
          ],
          members: {
            billableEntityCount: {
              type: "long"
            },
            bundleInformation: {
              type: "structure",
              required: [
                "bundleNames"
              ],
              members: {
                bundleNames: {
                  shape: "S4t"
                },
                pricingTier: {}
              }
            },
            effectiveDateTime: {
              type: "timestamp"
            },
            pricingMode: {},
            updateDateTime: {
              type: "timestamp"
            },
            updateReason: {}
          }
        },
        S4t: {
          type: "list",
          member: {}
        },
        S4z: {
          type: "list",
          member: {}
        },
        S55: {
          type: "list",
          member: {
            type: "structure",
            members: {
              propertyName: {},
              operator: {},
              value: {
                shape: "Se"
              }
            }
          }
        },
        S5t: {
          type: "structure",
          members: {
            state: {},
            error: {
              shape: "Sy"
            }
          }
        },
        S5x: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iottwinmaker-2021-11-29.paginators.json
var require_iottwinmaker_2021_11_29_paginators = __commonJS({
  "node_modules/aws-sdk/apis/iottwinmaker-2021-11-29.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ExecuteQuery: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetPropertyValue: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetPropertyValueHistory: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListComponentTypes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListComponents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListEntities: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListMetadataTransferJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListProperties: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListScenes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListSyncJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListSyncResources: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListWorkspaces: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iottwinmaker-2021-11-29.waiters2.json
var require_iottwinmaker_2021_11_29_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/iottwinmaker-2021-11-29.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {}
    };
  }
});

// node_modules/aws-sdk/clients/iottwinmaker.js
var require_iottwinmaker = __commonJS({
  "node_modules/aws-sdk/clients/iottwinmaker.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["iottwinmaker"] = {};
    AWS2.IoTTwinMaker = Service.defineService("iottwinmaker", ["2021-11-29"]);
    Object.defineProperty(apiLoader.services["iottwinmaker"], "2021-11-29", {
      get: function get() {
        var model = require_iottwinmaker_2021_11_29_min();
        model.paginators = require_iottwinmaker_2021_11_29_paginators().pagination;
        model.waiters = require_iottwinmaker_2021_11_29_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.IoTTwinMaker;
  }
});

// node_modules/aws-sdk/apis/workspaces-web-2020-07-08.min.json
var require_workspaces_web_2020_07_08_min = __commonJS({
  "node_modules/aws-sdk/apis/workspaces-web-2020-07-08.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-07-08",
        endpointPrefix: "workspaces-web",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon WorkSpaces Web",
        serviceId: "WorkSpaces Web",
        signatureVersion: "v4",
        signingName: "workspaces-web",
        uid: "workspaces-web-2020-07-08"
      },
      operations: {
        AssociateBrowserSettings: {
          http: {
            method: "PUT",
            requestUri: "/portals/{portalArn+}/browserSettings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "browserSettingsArn",
              "portalArn"
            ],
            members: {
              browserSettingsArn: {
                location: "querystring",
                locationName: "browserSettingsArn"
              },
              portalArn: {
                location: "uri",
                locationName: "portalArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "browserSettingsArn",
              "portalArn"
            ],
            members: {
              browserSettingsArn: {},
              portalArn: {}
            }
          },
          idempotent: true
        },
        AssociateIpAccessSettings: {
          http: {
            method: "PUT",
            requestUri: "/portals/{portalArn+}/ipAccessSettings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ipAccessSettingsArn",
              "portalArn"
            ],
            members: {
              ipAccessSettingsArn: {
                location: "querystring",
                locationName: "ipAccessSettingsArn"
              },
              portalArn: {
                location: "uri",
                locationName: "portalArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ipAccessSettingsArn",
              "portalArn"
            ],
            members: {
              ipAccessSettingsArn: {},
              portalArn: {}
            }
          },
          idempotent: true
        },
        AssociateNetworkSettings: {
          http: {
            method: "PUT",
            requestUri: "/portals/{portalArn+}/networkSettings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "networkSettingsArn",
              "portalArn"
            ],
            members: {
              networkSettingsArn: {
                location: "querystring",
                locationName: "networkSettingsArn"
              },
              portalArn: {
                location: "uri",
                locationName: "portalArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "networkSettingsArn",
              "portalArn"
            ],
            members: {
              networkSettingsArn: {},
              portalArn: {}
            }
          },
          idempotent: true
        },
        AssociateTrustStore: {
          http: {
            method: "PUT",
            requestUri: "/portals/{portalArn+}/trustStores",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "portalArn",
              "trustStoreArn"
            ],
            members: {
              portalArn: {
                location: "uri",
                locationName: "portalArn"
              },
              trustStoreArn: {
                location: "querystring",
                locationName: "trustStoreArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "portalArn",
              "trustStoreArn"
            ],
            members: {
              portalArn: {},
              trustStoreArn: {}
            }
          },
          idempotent: true
        },
        AssociateUserAccessLoggingSettings: {
          http: {
            method: "PUT",
            requestUri: "/portals/{portalArn+}/userAccessLoggingSettings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "portalArn",
              "userAccessLoggingSettingsArn"
            ],
            members: {
              portalArn: {
                location: "uri",
                locationName: "portalArn"
              },
              userAccessLoggingSettingsArn: {
                location: "querystring",
                locationName: "userAccessLoggingSettingsArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "portalArn",
              "userAccessLoggingSettingsArn"
            ],
            members: {
              portalArn: {},
              userAccessLoggingSettingsArn: {}
            }
          },
          idempotent: true
        },
        AssociateUserSettings: {
          http: {
            method: "PUT",
            requestUri: "/portals/{portalArn+}/userSettings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "portalArn",
              "userSettingsArn"
            ],
            members: {
              portalArn: {
                location: "uri",
                locationName: "portalArn"
              },
              userSettingsArn: {
                location: "querystring",
                locationName: "userSettingsArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "portalArn",
              "userSettingsArn"
            ],
            members: {
              portalArn: {},
              userSettingsArn: {}
            }
          },
          idempotent: true
        },
        CreateBrowserSettings: {
          http: {
            requestUri: "/browserSettings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "browserPolicy"
            ],
            members: {
              additionalEncryptionContext: {
                shape: "Sf"
              },
              browserPolicy: {
                shape: "Sh"
              },
              clientToken: {
                idempotencyToken: true
              },
              customerManagedKey: {},
              tags: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "browserSettingsArn"
            ],
            members: {
              browserSettingsArn: {}
            }
          }
        },
        CreateIdentityProvider: {
          http: {
            requestUri: "/identityProviders",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "identityProviderDetails",
              "identityProviderName",
              "identityProviderType",
              "portalArn"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              identityProviderDetails: {
                shape: "Sq"
              },
              identityProviderName: {
                shape: "Sr"
              },
              identityProviderType: {},
              portalArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "identityProviderArn"
            ],
            members: {
              identityProviderArn: {}
            }
          }
        },
        CreateIpAccessSettings: {
          http: {
            requestUri: "/ipAccessSettings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ipRules"
            ],
            members: {
              additionalEncryptionContext: {
                shape: "Sf"
              },
              clientToken: {
                idempotencyToken: true
              },
              customerManagedKey: {},
              description: {
                shape: "Sw"
              },
              displayName: {
                shape: "Sx"
              },
              ipRules: {
                shape: "Sy"
              },
              tags: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ipAccessSettingsArn"
            ],
            members: {
              ipAccessSettingsArn: {}
            }
          }
        },
        CreateNetworkSettings: {
          http: {
            requestUri: "/networkSettings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "securityGroupIds",
              "subnetIds",
              "vpcId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              securityGroupIds: {
                shape: "S13"
              },
              subnetIds: {
                shape: "S15"
              },
              tags: {
                shape: "Sk"
              },
              vpcId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "networkSettingsArn"
            ],
            members: {
              networkSettingsArn: {}
            }
          }
        },
        CreatePortal: {
          http: {
            requestUri: "/portals",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              additionalEncryptionContext: {
                shape: "Sf"
              },
              authenticationType: {},
              clientToken: {
                idempotencyToken: true
              },
              customerManagedKey: {},
              displayName: {
                shape: "Sx"
              },
              tags: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "portalArn",
              "portalEndpoint"
            ],
            members: {
              portalArn: {},
              portalEndpoint: {}
            }
          }
        },
        CreateTrustStore: {
          http: {
            requestUri: "/trustStores",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "certificateList"
            ],
            members: {
              certificateList: {
                shape: "S1e"
              },
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "trustStoreArn"
            ],
            members: {
              trustStoreArn: {}
            }
          }
        },
        CreateUserAccessLoggingSettings: {
          http: {
            requestUri: "/userAccessLoggingSettings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "kinesisStreamArn"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              kinesisStreamArn: {},
              tags: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "userAccessLoggingSettingsArn"
            ],
            members: {
              userAccessLoggingSettingsArn: {}
            }
          }
        },
        CreateUserSettings: {
          http: {
            requestUri: "/userSettings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "copyAllowed",
              "downloadAllowed",
              "pasteAllowed",
              "printAllowed",
              "uploadAllowed"
            ],
            members: {
              additionalEncryptionContext: {
                shape: "Sf"
              },
              clientToken: {
                idempotencyToken: true
              },
              cookieSynchronizationConfiguration: {
                shape: "S1l"
              },
              copyAllowed: {},
              customerManagedKey: {},
              disconnectTimeoutInMinutes: {
                type: "integer"
              },
              downloadAllowed: {},
              idleDisconnectTimeoutInMinutes: {
                type: "integer"
              },
              pasteAllowed: {},
              printAllowed: {},
              tags: {
                shape: "Sk"
              },
              uploadAllowed: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "userSettingsArn"
            ],
            members: {
              userSettingsArn: {}
            }
          }
        },
        DeleteBrowserSettings: {
          http: {
            method: "DELETE",
            requestUri: "/browserSettings/{browserSettingsArn+}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "browserSettingsArn"
            ],
            members: {
              browserSettingsArn: {
                location: "uri",
                locationName: "browserSettingsArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteIdentityProvider: {
          http: {
            method: "DELETE",
            requestUri: "/identityProviders/{identityProviderArn+}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "identityProviderArn"
            ],
            members: {
              identityProviderArn: {
                location: "uri",
                locationName: "identityProviderArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteIpAccessSettings: {
          http: {
            method: "DELETE",
            requestUri: "/ipAccessSettings/{ipAccessSettingsArn+}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ipAccessSettingsArn"
            ],
            members: {
              ipAccessSettingsArn: {
                location: "uri",
                locationName: "ipAccessSettingsArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteNetworkSettings: {
          http: {
            method: "DELETE",
            requestUri: "/networkSettings/{networkSettingsArn+}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "networkSettingsArn"
            ],
            members: {
              networkSettingsArn: {
                location: "uri",
                locationName: "networkSettingsArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeletePortal: {
          http: {
            method: "DELETE",
            requestUri: "/portals/{portalArn+}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "portalArn"
            ],
            members: {
              portalArn: {
                location: "uri",
                locationName: "portalArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteTrustStore: {
          http: {
            method: "DELETE",
            requestUri: "/trustStores/{trustStoreArn+}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "trustStoreArn"
            ],
            members: {
              trustStoreArn: {
                location: "uri",
                locationName: "trustStoreArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteUserAccessLoggingSettings: {
          http: {
            method: "DELETE",
            requestUri: "/userAccessLoggingSettings/{userAccessLoggingSettingsArn+}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "userAccessLoggingSettingsArn"
            ],
            members: {
              userAccessLoggingSettingsArn: {
                location: "uri",
                locationName: "userAccessLoggingSettingsArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteUserSettings: {
          http: {
            method: "DELETE",
            requestUri: "/userSettings/{userSettingsArn+}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "userSettingsArn"
            ],
            members: {
              userSettingsArn: {
                location: "uri",
                locationName: "userSettingsArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DisassociateBrowserSettings: {
          http: {
            method: "DELETE",
            requestUri: "/portals/{portalArn+}/browserSettings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "portalArn"
            ],
            members: {
              portalArn: {
                location: "uri",
                locationName: "portalArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DisassociateIpAccessSettings: {
          http: {
            method: "DELETE",
            requestUri: "/portals/{portalArn+}/ipAccessSettings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "portalArn"
            ],
            members: {
              portalArn: {
                location: "uri",
                locationName: "portalArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DisassociateNetworkSettings: {
          http: {
            method: "DELETE",
            requestUri: "/portals/{portalArn+}/networkSettings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "portalArn"
            ],
            members: {
              portalArn: {
                location: "uri",
                locationName: "portalArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DisassociateTrustStore: {
          http: {
            method: "DELETE",
            requestUri: "/portals/{portalArn+}/trustStores",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "portalArn"
            ],
            members: {
              portalArn: {
                location: "uri",
                locationName: "portalArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DisassociateUserAccessLoggingSettings: {
          http: {
            method: "DELETE",
            requestUri: "/portals/{portalArn+}/userAccessLoggingSettings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "portalArn"
            ],
            members: {
              portalArn: {
                location: "uri",
                locationName: "portalArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DisassociateUserSettings: {
          http: {
            method: "DELETE",
            requestUri: "/portals/{portalArn+}/userSettings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "portalArn"
            ],
            members: {
              portalArn: {
                location: "uri",
                locationName: "portalArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        GetBrowserSettings: {
          http: {
            method: "GET",
            requestUri: "/browserSettings/{browserSettingsArn+}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "browserSettingsArn"
            ],
            members: {
              browserSettingsArn: {
                location: "uri",
                locationName: "browserSettingsArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              browserSettings: {
                shape: "S2p"
              }
            }
          }
        },
        GetIdentityProvider: {
          http: {
            method: "GET",
            requestUri: "/identityProviders/{identityProviderArn+}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "identityProviderArn"
            ],
            members: {
              identityProviderArn: {
                location: "uri",
                locationName: "identityProviderArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              identityProvider: {
                shape: "S2t"
              }
            }
          }
        },
        GetIpAccessSettings: {
          http: {
            method: "GET",
            requestUri: "/ipAccessSettings/{ipAccessSettingsArn+}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ipAccessSettingsArn"
            ],
            members: {
              ipAccessSettingsArn: {
                location: "uri",
                locationName: "ipAccessSettingsArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ipAccessSettings: {
                shape: "S2w"
              }
            }
          }
        },
        GetNetworkSettings: {
          http: {
            method: "GET",
            requestUri: "/networkSettings/{networkSettingsArn+}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "networkSettingsArn"
            ],
            members: {
              networkSettingsArn: {
                location: "uri",
                locationName: "networkSettingsArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              networkSettings: {
                shape: "S30"
              }
            }
          }
        },
        GetPortal: {
          http: {
            method: "GET",
            requestUri: "/portals/{portalArn+}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "portalArn"
            ],
            members: {
              portalArn: {
                location: "uri",
                locationName: "portalArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              portal: {
                shape: "S33"
              }
            }
          }
        },
        GetPortalServiceProviderMetadata: {
          http: {
            method: "GET",
            requestUri: "/portalIdp/{portalArn+}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "portalArn"
            ],
            members: {
              portalArn: {
                location: "uri",
                locationName: "portalArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "portalArn"
            ],
            members: {
              portalArn: {},
              serviceProviderSamlMetadata: {}
            }
          }
        },
        GetTrustStore: {
          http: {
            method: "GET",
            requestUri: "/trustStores/{trustStoreArn+}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "trustStoreArn"
            ],
            members: {
              trustStoreArn: {
                location: "uri",
                locationName: "trustStoreArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              trustStore: {
                type: "structure",
                required: [
                  "trustStoreArn"
                ],
                members: {
                  associatedPortalArns: {
                    shape: "S2q"
                  },
                  trustStoreArn: {}
                }
              }
            }
          }
        },
        GetTrustStoreCertificate: {
          http: {
            method: "GET",
            requestUri: "/trustStores/{trustStoreArn+}/certificate",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "thumbprint",
              "trustStoreArn"
            ],
            members: {
              thumbprint: {
                location: "querystring",
                locationName: "thumbprint"
              },
              trustStoreArn: {
                location: "uri",
                locationName: "trustStoreArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "trustStoreArn"
            ],
            members: {
              certificate: {
                type: "structure",
                members: {
                  body: {
                    type: "blob"
                  },
                  issuer: {},
                  notValidAfter: {
                    type: "timestamp"
                  },
                  notValidBefore: {
                    type: "timestamp"
                  },
                  subject: {},
                  thumbprint: {}
                }
              },
              trustStoreArn: {}
            }
          }
        },
        GetUserAccessLoggingSettings: {
          http: {
            method: "GET",
            requestUri: "/userAccessLoggingSettings/{userAccessLoggingSettingsArn+}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "userAccessLoggingSettingsArn"
            ],
            members: {
              userAccessLoggingSettingsArn: {
                location: "uri",
                locationName: "userAccessLoggingSettingsArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              userAccessLoggingSettings: {
                shape: "S3l"
              }
            }
          }
        },
        GetUserSettings: {
          http: {
            method: "GET",
            requestUri: "/userSettings/{userSettingsArn+}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "userSettingsArn"
            ],
            members: {
              userSettingsArn: {
                location: "uri",
                locationName: "userSettingsArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              userSettings: {
                shape: "S3o"
              }
            }
          }
        },
        ListBrowserSettings: {
          http: {
            method: "GET",
            requestUri: "/browserSettings",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              browserSettings: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "browserSettingsArn"
                  ],
                  members: {
                    browserSettingsArn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListIdentityProviders: {
          http: {
            method: "GET",
            requestUri: "/portals/{portalArn+}/identityProviders",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "portalArn"
            ],
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              portalArn: {
                location: "uri",
                locationName: "portalArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              identityProviders: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "identityProviderArn"
                  ],
                  members: {
                    identityProviderArn: {},
                    identityProviderName: {
                      shape: "Sr"
                    },
                    identityProviderType: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListIpAccessSettings: {
          http: {
            method: "GET",
            requestUri: "/ipAccessSettings",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ipAccessSettings: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ipAccessSettingsArn"
                  ],
                  members: {
                    creationDate: {
                      type: "timestamp"
                    },
                    description: {
                      shape: "Sw"
                    },
                    displayName: {
                      shape: "Sx"
                    },
                    ipAccessSettingsArn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListNetworkSettings: {
          http: {
            method: "GET",
            requestUri: "/networkSettings",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              networkSettings: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "networkSettingsArn"
                  ],
                  members: {
                    networkSettingsArn: {},
                    vpcId: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListPortals: {
          http: {
            method: "GET",
            requestUri: "/portals",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              portals: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "portalArn"
                  ],
                  members: {
                    authenticationType: {},
                    browserSettingsArn: {},
                    browserType: {},
                    creationDate: {
                      type: "timestamp"
                    },
                    displayName: {
                      shape: "Sx"
                    },
                    ipAccessSettingsArn: {},
                    networkSettingsArn: {},
                    portalArn: {},
                    portalEndpoint: {},
                    portalStatus: {},
                    rendererType: {},
                    trustStoreArn: {},
                    userAccessLoggingSettingsArn: {},
                    userSettingsArn: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn+}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sk"
              }
            }
          }
        },
        ListTrustStoreCertificates: {
          http: {
            method: "GET",
            requestUri: "/trustStores/{trustStoreArn+}/certificates",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "trustStoreArn"
            ],
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              trustStoreArn: {
                location: "uri",
                locationName: "trustStoreArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "trustStoreArn"
            ],
            members: {
              certificateList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    issuer: {},
                    notValidAfter: {
                      type: "timestamp"
                    },
                    notValidBefore: {
                      type: "timestamp"
                    },
                    subject: {},
                    thumbprint: {}
                  }
                }
              },
              nextToken: {},
              trustStoreArn: {}
            }
          }
        },
        ListTrustStores: {
          http: {
            method: "GET",
            requestUri: "/trustStores",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              trustStores: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    trustStoreArn: {}
                  }
                }
              }
            }
          }
        },
        ListUserAccessLoggingSettings: {
          http: {
            method: "GET",
            requestUri: "/userAccessLoggingSettings",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              userAccessLoggingSettings: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "userAccessLoggingSettingsArn"
                  ],
                  members: {
                    kinesisStreamArn: {},
                    userAccessLoggingSettingsArn: {}
                  }
                }
              }
            }
          }
        },
        ListUserSettings: {
          http: {
            method: "GET",
            requestUri: "/userSettings",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              userSettings: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "userSettingsArn"
                  ],
                  members: {
                    cookieSynchronizationConfiguration: {
                      shape: "S1l"
                    },
                    copyAllowed: {},
                    disconnectTimeoutInMinutes: {
                      type: "integer"
                    },
                    downloadAllowed: {},
                    idleDisconnectTimeoutInMinutes: {
                      type: "integer"
                    },
                    pasteAllowed: {},
                    printAllowed: {},
                    uploadAllowed: {},
                    userSettingsArn: {}
                  }
                }
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn+}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn+}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {
                  shape: "Sm"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateBrowserSettings: {
          http: {
            method: "PATCH",
            requestUri: "/browserSettings/{browserSettingsArn+}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "browserSettingsArn"
            ],
            members: {
              browserPolicy: {
                shape: "Sh"
              },
              browserSettingsArn: {
                location: "uri",
                locationName: "browserSettingsArn"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "browserSettings"
            ],
            members: {
              browserSettings: {
                shape: "S2p"
              }
            }
          }
        },
        UpdateIdentityProvider: {
          http: {
            method: "PATCH",
            requestUri: "/identityProviders/{identityProviderArn+}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "identityProviderArn"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              identityProviderArn: {
                location: "uri",
                locationName: "identityProviderArn"
              },
              identityProviderDetails: {
                shape: "Sq"
              },
              identityProviderName: {
                shape: "Sr"
              },
              identityProviderType: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "identityProvider"
            ],
            members: {
              identityProvider: {
                shape: "S2t"
              }
            }
          }
        },
        UpdateIpAccessSettings: {
          http: {
            method: "PATCH",
            requestUri: "/ipAccessSettings/{ipAccessSettingsArn+}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ipAccessSettingsArn"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              description: {
                shape: "Sw"
              },
              displayName: {
                shape: "Sx"
              },
              ipAccessSettingsArn: {
                location: "uri",
                locationName: "ipAccessSettingsArn"
              },
              ipRules: {
                shape: "Sy"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ipAccessSettings"
            ],
            members: {
              ipAccessSettings: {
                shape: "S2w"
              }
            }
          }
        },
        UpdateNetworkSettings: {
          http: {
            method: "PATCH",
            requestUri: "/networkSettings/{networkSettingsArn+}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "networkSettingsArn"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              networkSettingsArn: {
                location: "uri",
                locationName: "networkSettingsArn"
              },
              securityGroupIds: {
                shape: "S13"
              },
              subnetIds: {
                shape: "S15"
              },
              vpcId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "networkSettings"
            ],
            members: {
              networkSettings: {
                shape: "S30"
              }
            }
          }
        },
        UpdatePortal: {
          http: {
            method: "PUT",
            requestUri: "/portals/{portalArn+}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "portalArn"
            ],
            members: {
              authenticationType: {},
              displayName: {
                shape: "Sx"
              },
              portalArn: {
                location: "uri",
                locationName: "portalArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              portal: {
                shape: "S33"
              }
            }
          },
          idempotent: true
        },
        UpdateTrustStore: {
          http: {
            method: "PATCH",
            requestUri: "/trustStores/{trustStoreArn+}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "trustStoreArn"
            ],
            members: {
              certificatesToAdd: {
                shape: "S1e"
              },
              certificatesToDelete: {
                type: "list",
                member: {}
              },
              clientToken: {
                idempotencyToken: true
              },
              trustStoreArn: {
                location: "uri",
                locationName: "trustStoreArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "trustStoreArn"
            ],
            members: {
              trustStoreArn: {}
            }
          }
        },
        UpdateUserAccessLoggingSettings: {
          http: {
            method: "PATCH",
            requestUri: "/userAccessLoggingSettings/{userAccessLoggingSettingsArn+}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "userAccessLoggingSettingsArn"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              kinesisStreamArn: {},
              userAccessLoggingSettingsArn: {
                location: "uri",
                locationName: "userAccessLoggingSettingsArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "userAccessLoggingSettings"
            ],
            members: {
              userAccessLoggingSettings: {
                shape: "S3l"
              }
            }
          }
        },
        UpdateUserSettings: {
          http: {
            method: "PATCH",
            requestUri: "/userSettings/{userSettingsArn+}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "userSettingsArn"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              cookieSynchronizationConfiguration: {
                shape: "S1l"
              },
              copyAllowed: {},
              disconnectTimeoutInMinutes: {
                type: "integer"
              },
              downloadAllowed: {},
              idleDisconnectTimeoutInMinutes: {
                type: "integer"
              },
              pasteAllowed: {},
              printAllowed: {},
              uploadAllowed: {},
              userSettingsArn: {
                location: "uri",
                locationName: "userSettingsArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "userSettings"
            ],
            members: {
              userSettings: {
                shape: "S3o"
              }
            }
          }
        }
      },
      shapes: {
        Sf: {
          type: "map",
          key: {},
          value: {}
        },
        Sh: {
          type: "string",
          sensitive: true
        },
        Sk: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {
                shape: "Sm"
              },
              Value: {
                type: "string",
                sensitive: true
              }
            },
            sensitive: true
          }
        },
        Sm: {
          type: "string",
          sensitive: true
        },
        Sq: {
          type: "map",
          key: {},
          value: {},
          sensitive: true
        },
        Sr: {
          type: "string",
          sensitive: true
        },
        Sw: {
          type: "string",
          sensitive: true
        },
        Sx: {
          type: "string",
          sensitive: true
        },
        Sy: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ipRange"
            ],
            members: {
              description: {
                shape: "Sw"
              },
              ipRange: {
                type: "string",
                sensitive: true
              }
            }
          },
          sensitive: true
        },
        S13: {
          type: "list",
          member: {}
        },
        S15: {
          type: "list",
          member: {}
        },
        S1e: {
          type: "list",
          member: {
            type: "blob"
          }
        },
        S1l: {
          type: "structure",
          required: [
            "allowlist"
          ],
          members: {
            allowlist: {
              shape: "S1m"
            },
            blocklist: {
              shape: "S1m"
            }
          },
          sensitive: true
        },
        S1m: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "domain"
            ],
            members: {
              domain: {},
              name: {},
              path: {}
            }
          }
        },
        S2p: {
          type: "structure",
          required: [
            "browserSettingsArn"
          ],
          members: {
            associatedPortalArns: {
              shape: "S2q"
            },
            browserPolicy: {
              shape: "Sh"
            },
            browserSettingsArn: {}
          }
        },
        S2q: {
          type: "list",
          member: {}
        },
        S2t: {
          type: "structure",
          required: [
            "identityProviderArn"
          ],
          members: {
            identityProviderArn: {},
            identityProviderDetails: {
              shape: "Sq"
            },
            identityProviderName: {
              shape: "Sr"
            },
            identityProviderType: {}
          }
        },
        S2w: {
          type: "structure",
          required: [
            "ipAccessSettingsArn"
          ],
          members: {
            associatedPortalArns: {
              shape: "S2q"
            },
            creationDate: {
              type: "timestamp"
            },
            description: {
              shape: "Sw"
            },
            displayName: {
              shape: "Sx"
            },
            ipAccessSettingsArn: {},
            ipRules: {
              shape: "Sy"
            }
          }
        },
        S30: {
          type: "structure",
          required: [
            "networkSettingsArn"
          ],
          members: {
            associatedPortalArns: {
              shape: "S2q"
            },
            networkSettingsArn: {},
            securityGroupIds: {
              shape: "S13"
            },
            subnetIds: {
              shape: "S15"
            },
            vpcId: {}
          }
        },
        S33: {
          type: "structure",
          required: [
            "portalArn"
          ],
          members: {
            authenticationType: {},
            browserSettingsArn: {},
            browserType: {},
            creationDate: {
              type: "timestamp"
            },
            displayName: {
              shape: "Sx"
            },
            ipAccessSettingsArn: {},
            networkSettingsArn: {},
            portalArn: {},
            portalEndpoint: {},
            portalStatus: {},
            rendererType: {},
            statusReason: {},
            trustStoreArn: {},
            userAccessLoggingSettingsArn: {},
            userSettingsArn: {}
          }
        },
        S3l: {
          type: "structure",
          required: [
            "userAccessLoggingSettingsArn"
          ],
          members: {
            associatedPortalArns: {
              shape: "S2q"
            },
            kinesisStreamArn: {},
            userAccessLoggingSettingsArn: {}
          }
        },
        S3o: {
          type: "structure",
          required: [
            "userSettingsArn"
          ],
          members: {
            associatedPortalArns: {
              shape: "S2q"
            },
            cookieSynchronizationConfiguration: {
              shape: "S1l"
            },
            copyAllowed: {},
            disconnectTimeoutInMinutes: {
              type: "integer"
            },
            downloadAllowed: {},
            idleDisconnectTimeoutInMinutes: {
              type: "integer"
            },
            pasteAllowed: {},
            printAllowed: {},
            uploadAllowed: {},
            userSettingsArn: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/workspaces-web-2020-07-08.paginators.json
var require_workspaces_web_2020_07_08_paginators = __commonJS({
  "node_modules/aws-sdk/apis/workspaces-web-2020-07-08.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListBrowserSettings: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListIdentityProviders: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListIpAccessSettings: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListNetworkSettings: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListPortals: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListTrustStoreCertificates: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListTrustStores: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListUserAccessLoggingSettings: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListUserSettings: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/workspacesweb.js
var require_workspacesweb = __commonJS({
  "node_modules/aws-sdk/clients/workspacesweb.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["workspacesweb"] = {};
    AWS2.WorkSpacesWeb = Service.defineService("workspacesweb", ["2020-07-08"]);
    Object.defineProperty(apiLoader.services["workspacesweb"], "2020-07-08", {
      get: function get() {
        var model = require_workspaces_web_2020_07_08_min();
        model.paginators = require_workspaces_web_2020_07_08_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.WorkSpacesWeb;
  }
});

// node_modules/aws-sdk/apis/amplifyuibuilder-2021-08-11.min.json
var require_amplifyuibuilder_2021_08_11_min = __commonJS({
  "node_modules/aws-sdk/apis/amplifyuibuilder-2021-08-11.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-08-11",
        endpointPrefix: "amplifyuibuilder",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Amplify UI Builder",
        serviceId: "AmplifyUIBuilder",
        signatureVersion: "v4",
        signingName: "amplifyuibuilder",
        uid: "amplifyuibuilder-2021-08-11"
      },
      operations: {
        CreateComponent: {
          http: {
            requestUri: "/app/{appId}/environment/{environmentName}/components",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "environmentName",
              "componentToCreate"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              environmentName: {
                location: "uri",
                locationName: "environmentName"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              },
              componentToCreate: {
                type: "structure",
                required: [
                  "name",
                  "componentType",
                  "properties",
                  "variants",
                  "overrides",
                  "bindingProperties"
                ],
                members: {
                  name: {},
                  sourceId: {},
                  componentType: {},
                  properties: {
                    shape: "S6"
                  },
                  children: {
                    shape: "Se"
                  },
                  variants: {
                    shape: "Sk"
                  },
                  overrides: {
                    shape: "Sn"
                  },
                  bindingProperties: {
                    shape: "Sp"
                  },
                  collectionProperties: {
                    shape: "Sv"
                  },
                  tags: {
                    shape: "S11"
                  },
                  events: {
                    shape: "Sg"
                  },
                  schemaVersion: {}
                }
              }
            },
            payload: "componentToCreate"
          },
          output: {
            type: "structure",
            members: {
              entity: {
                shape: "S15"
              }
            },
            payload: "entity"
          },
          idempotent: true
        },
        CreateForm: {
          http: {
            requestUri: "/app/{appId}/environment/{environmentName}/forms",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "environmentName",
              "formToCreate"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              environmentName: {
                location: "uri",
                locationName: "environmentName"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              },
              formToCreate: {
                type: "structure",
                required: [
                  "name",
                  "dataType",
                  "formActionType",
                  "fields",
                  "style",
                  "sectionalElements",
                  "schemaVersion"
                ],
                members: {
                  name: {},
                  dataType: {
                    shape: "S1b"
                  },
                  formActionType: {},
                  fields: {
                    shape: "S1e"
                  },
                  style: {
                    shape: "S20"
                  },
                  sectionalElements: {
                    shape: "S22"
                  },
                  schemaVersion: {},
                  cta: {
                    shape: "S24"
                  },
                  tags: {
                    shape: "S11"
                  },
                  labelDecorator: {}
                }
              }
            },
            payload: "formToCreate"
          },
          output: {
            type: "structure",
            members: {
              entity: {
                shape: "S29"
              }
            },
            payload: "entity"
          },
          idempotent: true
        },
        CreateTheme: {
          http: {
            requestUri: "/app/{appId}/environment/{environmentName}/themes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "environmentName",
              "themeToCreate"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              environmentName: {
                location: "uri",
                locationName: "environmentName"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              },
              themeToCreate: {
                type: "structure",
                required: [
                  "name",
                  "values"
                ],
                members: {
                  name: {},
                  values: {
                    shape: "S2d"
                  },
                  overrides: {
                    shape: "S2d"
                  },
                  tags: {
                    shape: "S11"
                  }
                }
              }
            },
            payload: "themeToCreate"
          },
          output: {
            type: "structure",
            members: {
              entity: {
                shape: "S2h"
              }
            },
            payload: "entity"
          },
          idempotent: true
        },
        DeleteComponent: {
          http: {
            method: "DELETE",
            requestUri: "/app/{appId}/environment/{environmentName}/components/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "environmentName",
              "id"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              environmentName: {
                location: "uri",
                locationName: "environmentName"
              },
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          idempotent: true
        },
        DeleteForm: {
          http: {
            method: "DELETE",
            requestUri: "/app/{appId}/environment/{environmentName}/forms/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "environmentName",
              "id"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              environmentName: {
                location: "uri",
                locationName: "environmentName"
              },
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          idempotent: true
        },
        DeleteTheme: {
          http: {
            method: "DELETE",
            requestUri: "/app/{appId}/environment/{environmentName}/themes/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "environmentName",
              "id"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              environmentName: {
                location: "uri",
                locationName: "environmentName"
              },
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          idempotent: true
        },
        ExchangeCodeForToken: {
          http: {
            requestUri: "/tokens/{provider}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "provider",
              "request"
            ],
            members: {
              provider: {
                location: "uri",
                locationName: "provider"
              },
              request: {
                type: "structure",
                required: [
                  "code",
                  "redirectUri"
                ],
                members: {
                  code: {
                    shape: "S2o"
                  },
                  redirectUri: {},
                  clientId: {
                    shape: "S2o"
                  }
                }
              }
            },
            payload: "request"
          },
          output: {
            type: "structure",
            required: [
              "accessToken",
              "expiresIn",
              "refreshToken"
            ],
            members: {
              accessToken: {
                shape: "S2o"
              },
              expiresIn: {
                type: "integer"
              },
              refreshToken: {
                shape: "S2o"
              }
            }
          }
        },
        ExportComponents: {
          http: {
            method: "GET",
            requestUri: "/export/app/{appId}/environment/{environmentName}/components",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "environmentName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              environmentName: {
                location: "uri",
                locationName: "environmentName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "entities"
            ],
            members: {
              entities: {
                type: "list",
                member: {
                  shape: "S15"
                }
              },
              nextToken: {}
            }
          }
        },
        ExportForms: {
          http: {
            method: "GET",
            requestUri: "/export/app/{appId}/environment/{environmentName}/forms",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "environmentName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              environmentName: {
                location: "uri",
                locationName: "environmentName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "entities"
            ],
            members: {
              entities: {
                type: "list",
                member: {
                  shape: "S29"
                }
              },
              nextToken: {}
            }
          }
        },
        ExportThemes: {
          http: {
            method: "GET",
            requestUri: "/export/app/{appId}/environment/{environmentName}/themes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "environmentName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              environmentName: {
                location: "uri",
                locationName: "environmentName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "entities"
            ],
            members: {
              entities: {
                type: "list",
                member: {
                  shape: "S2h"
                }
              },
              nextToken: {}
            }
          }
        },
        GetCodegenJob: {
          http: {
            method: "GET",
            requestUri: "/app/{appId}/environment/{environmentName}/codegen-jobs/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "environmentName",
              "id"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              environmentName: {
                location: "uri",
                locationName: "environmentName"
              },
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              job: {
                shape: "S32"
              }
            },
            payload: "job"
          }
        },
        GetComponent: {
          http: {
            method: "GET",
            requestUri: "/app/{appId}/environment/{environmentName}/components/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "environmentName",
              "id"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              environmentName: {
                location: "uri",
                locationName: "environmentName"
              },
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              component: {
                shape: "S15"
              }
            },
            payload: "component"
          }
        },
        GetForm: {
          http: {
            method: "GET",
            requestUri: "/app/{appId}/environment/{environmentName}/forms/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "environmentName",
              "id"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              environmentName: {
                location: "uri",
                locationName: "environmentName"
              },
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              form: {
                shape: "S29"
              }
            },
            payload: "form"
          }
        },
        GetMetadata: {
          http: {
            method: "GET",
            requestUri: "/app/{appId}/environment/{environmentName}/metadata",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "environmentName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              environmentName: {
                location: "uri",
                locationName: "environmentName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "features"
            ],
            members: {
              features: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        GetTheme: {
          http: {
            method: "GET",
            requestUri: "/app/{appId}/environment/{environmentName}/themes/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "environmentName",
              "id"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              environmentName: {
                location: "uri",
                locationName: "environmentName"
              },
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              theme: {
                shape: "S2h"
              }
            },
            payload: "theme"
          }
        },
        ListCodegenJobs: {
          http: {
            method: "GET",
            requestUri: "/app/{appId}/environment/{environmentName}/codegen-jobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "environmentName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              environmentName: {
                location: "uri",
                locationName: "environmentName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "entities"
            ],
            members: {
              entities: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "appId",
                    "environmentName",
                    "id"
                  ],
                  members: {
                    appId: {},
                    environmentName: {},
                    id: {},
                    createdAt: {
                      shape: "S17"
                    },
                    modifiedAt: {
                      shape: "S17"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListComponents: {
          http: {
            method: "GET",
            requestUri: "/app/{appId}/environment/{environmentName}/components",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "environmentName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              environmentName: {
                location: "uri",
                locationName: "environmentName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "entities"
            ],
            members: {
              entities: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "appId",
                    "environmentName",
                    "id",
                    "name",
                    "componentType"
                  ],
                  members: {
                    appId: {},
                    environmentName: {},
                    id: {},
                    name: {},
                    componentType: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListForms: {
          http: {
            method: "GET",
            requestUri: "/app/{appId}/environment/{environmentName}/forms",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "environmentName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              environmentName: {
                location: "uri",
                locationName: "environmentName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "entities"
            ],
            members: {
              entities: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "appId",
                    "dataType",
                    "environmentName",
                    "formActionType",
                    "id",
                    "name"
                  ],
                  members: {
                    appId: {},
                    dataType: {
                      shape: "S1b"
                    },
                    environmentName: {},
                    formActionType: {},
                    id: {},
                    name: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListThemes: {
          http: {
            method: "GET",
            requestUri: "/app/{appId}/environment/{environmentName}/themes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "environmentName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              environmentName: {
                location: "uri",
                locationName: "environmentName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "entities"
            ],
            members: {
              entities: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "appId",
                    "environmentName",
                    "id",
                    "name"
                  ],
                  members: {
                    appId: {},
                    environmentName: {},
                    id: {},
                    name: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        PutMetadataFlag: {
          http: {
            method: "PUT",
            requestUri: "/app/{appId}/environment/{environmentName}/metadata/features/{featureName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "environmentName",
              "featureName",
              "body"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              environmentName: {
                location: "uri",
                locationName: "environmentName"
              },
              featureName: {
                location: "uri",
                locationName: "featureName"
              },
              body: {
                type: "structure",
                required: [
                  "newValue"
                ],
                members: {
                  newValue: {}
                }
              }
            },
            payload: "body"
          }
        },
        RefreshToken: {
          http: {
            requestUri: "/tokens/{provider}/refresh",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "provider",
              "refreshTokenBody"
            ],
            members: {
              provider: {
                location: "uri",
                locationName: "provider"
              },
              refreshTokenBody: {
                type: "structure",
                required: [
                  "token"
                ],
                members: {
                  token: {
                    shape: "S2o"
                  },
                  clientId: {
                    shape: "S2o"
                  }
                }
              }
            },
            payload: "refreshTokenBody"
          },
          output: {
            type: "structure",
            required: [
              "accessToken",
              "expiresIn"
            ],
            members: {
              accessToken: {
                shape: "S2o"
              },
              expiresIn: {
                type: "integer"
              }
            }
          }
        },
        StartCodegenJob: {
          http: {
            requestUri: "/app/{appId}/environment/{environmentName}/codegen-jobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "environmentName",
              "codegenJobToCreate"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              environmentName: {
                location: "uri",
                locationName: "environmentName"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              },
              codegenJobToCreate: {
                type: "structure",
                required: [
                  "renderConfig"
                ],
                members: {
                  renderConfig: {
                    shape: "S33"
                  },
                  genericDataSchema: {
                    shape: "S3d"
                  },
                  autoGenerateForms: {
                    type: "boolean"
                  },
                  features: {
                    shape: "S3v"
                  },
                  tags: {
                    shape: "S11"
                  }
                }
              }
            },
            payload: "codegenJobToCreate"
          },
          output: {
            type: "structure",
            members: {
              entity: {
                shape: "S32"
              }
            },
            payload: "entity"
          }
        },
        UpdateComponent: {
          http: {
            method: "PATCH",
            requestUri: "/app/{appId}/environment/{environmentName}/components/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "environmentName",
              "id",
              "updatedComponent"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              environmentName: {
                location: "uri",
                locationName: "environmentName"
              },
              id: {
                location: "uri",
                locationName: "id"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              },
              updatedComponent: {
                type: "structure",
                members: {
                  id: {},
                  name: {},
                  sourceId: {},
                  componentType: {},
                  properties: {
                    shape: "S6"
                  },
                  children: {
                    shape: "Se"
                  },
                  variants: {
                    shape: "Sk"
                  },
                  overrides: {
                    shape: "Sn"
                  },
                  bindingProperties: {
                    shape: "Sp"
                  },
                  collectionProperties: {
                    shape: "Sv"
                  },
                  events: {
                    shape: "Sg"
                  },
                  schemaVersion: {}
                }
              }
            },
            payload: "updatedComponent"
          },
          output: {
            type: "structure",
            members: {
              entity: {
                shape: "S15"
              }
            },
            payload: "entity"
          },
          idempotent: true
        },
        UpdateForm: {
          http: {
            method: "PATCH",
            requestUri: "/app/{appId}/environment/{environmentName}/forms/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "environmentName",
              "id",
              "updatedForm"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              environmentName: {
                location: "uri",
                locationName: "environmentName"
              },
              id: {
                location: "uri",
                locationName: "id"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              },
              updatedForm: {
                type: "structure",
                members: {
                  name: {},
                  dataType: {
                    shape: "S1b"
                  },
                  formActionType: {},
                  fields: {
                    shape: "S1e"
                  },
                  style: {
                    shape: "S20"
                  },
                  sectionalElements: {
                    shape: "S22"
                  },
                  schemaVersion: {},
                  cta: {
                    shape: "S24"
                  },
                  labelDecorator: {}
                }
              }
            },
            payload: "updatedForm"
          },
          output: {
            type: "structure",
            members: {
              entity: {
                shape: "S29"
              }
            },
            payload: "entity"
          },
          idempotent: true
        },
        UpdateTheme: {
          http: {
            method: "PATCH",
            requestUri: "/app/{appId}/environment/{environmentName}/themes/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "environmentName",
              "id",
              "updatedTheme"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              environmentName: {
                location: "uri",
                locationName: "environmentName"
              },
              id: {
                location: "uri",
                locationName: "id"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              },
              updatedTheme: {
                type: "structure",
                required: [
                  "values"
                ],
                members: {
                  id: {},
                  name: {},
                  values: {
                    shape: "S2d"
                  },
                  overrides: {
                    shape: "S2d"
                  }
                }
              }
            },
            payload: "updatedTheme"
          },
          output: {
            type: "structure",
            members: {
              entity: {
                shape: "S2h"
              }
            },
            payload: "entity"
          },
          idempotent: true
        }
      },
      shapes: {
        S6: {
          type: "map",
          key: {},
          value: {
            shape: "S7"
          }
        },
        S7: {
          type: "structure",
          members: {
            value: {},
            bindingProperties: {
              shape: "S8"
            },
            collectionBindingProperties: {
              shape: "S8"
            },
            defaultValue: {},
            model: {},
            bindings: {
              type: "map",
              key: {},
              value: {
                type: "structure",
                required: [
                  "element",
                  "property"
                ],
                members: {
                  element: {},
                  property: {}
                }
              }
            },
            event: {},
            userAttribute: {},
            concat: {
              type: "list",
              member: {
                shape: "S7"
              }
            },
            condition: {
              type: "structure",
              members: {
                property: {},
                field: {},
                operator: {},
                operand: {},
                then: {
                  shape: "S7"
                },
                else: {
                  shape: "S7"
                },
                operandType: {}
              }
            },
            configured: {
              type: "boolean"
            },
            type: {},
            importedValue: {},
            componentName: {},
            property: {}
          }
        },
        S8: {
          type: "structure",
          required: [
            "property"
          ],
          members: {
            property: {},
            field: {}
          }
        },
        Se: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "componentType",
              "name",
              "properties"
            ],
            members: {
              componentType: {},
              name: {},
              properties: {
                shape: "S6"
              },
              children: {
                shape: "Se"
              },
              events: {
                shape: "Sg"
              },
              sourceId: {}
            }
          }
        },
        Sg: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              action: {},
              parameters: {
                type: "structure",
                members: {
                  type: {
                    shape: "S7"
                  },
                  url: {
                    shape: "S7"
                  },
                  anchor: {
                    shape: "S7"
                  },
                  target: {
                    shape: "S7"
                  },
                  global: {
                    shape: "S7"
                  },
                  model: {},
                  id: {
                    shape: "S7"
                  },
                  fields: {
                    shape: "S6"
                  },
                  state: {
                    type: "structure",
                    required: [
                      "componentName",
                      "property",
                      "set"
                    ],
                    members: {
                      componentName: {},
                      property: {},
                      set: {
                        shape: "S7"
                      }
                    }
                  }
                }
              },
              bindingEvent: {}
            }
          }
        },
        Sk: {
          type: "list",
          member: {
            type: "structure",
            members: {
              variantValues: {
                type: "map",
                key: {},
                value: {}
              },
              overrides: {
                shape: "Sn"
              }
            }
          }
        },
        Sn: {
          type: "map",
          key: {},
          value: {
            type: "map",
            key: {},
            value: {}
          }
        },
        Sp: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              type: {},
              bindingProperties: {
                type: "structure",
                members: {
                  model: {},
                  field: {},
                  predicates: {
                    shape: "Ss"
                  },
                  userAttribute: {},
                  bucket: {},
                  key: {},
                  defaultValue: {},
                  slotName: {}
                }
              },
              defaultValue: {}
            }
          }
        },
        Ss: {
          type: "list",
          member: {
            shape: "St"
          }
        },
        St: {
          type: "structure",
          members: {
            or: {
              shape: "Ss"
            },
            and: {
              shape: "Ss"
            },
            field: {},
            operator: {},
            operand: {},
            operandType: {}
          }
        },
        Sv: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "model"
            ],
            members: {
              model: {},
              sort: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "field",
                    "direction"
                  ],
                  members: {
                    field: {},
                    direction: {}
                  }
                }
              },
              predicate: {
                shape: "St"
              },
              identifiers: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S11: {
          type: "map",
          key: {},
          value: {}
        },
        S15: {
          type: "structure",
          required: [
            "appId",
            "environmentName",
            "id",
            "name",
            "componentType",
            "properties",
            "variants",
            "overrides",
            "bindingProperties",
            "createdAt"
          ],
          members: {
            appId: {},
            environmentName: {},
            sourceId: {},
            id: {},
            name: {},
            componentType: {},
            properties: {
              shape: "S6"
            },
            children: {
              shape: "Se"
            },
            variants: {
              shape: "Sk"
            },
            overrides: {
              shape: "Sn"
            },
            bindingProperties: {
              shape: "Sp"
            },
            collectionProperties: {
              shape: "Sv"
            },
            createdAt: {
              shape: "S17"
            },
            modifiedAt: {
              shape: "S17"
            },
            tags: {
              shape: "S11"
            },
            events: {
              shape: "Sg"
            },
            schemaVersion: {}
          }
        },
        S17: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S1b: {
          type: "structure",
          required: [
            "dataSourceType",
            "dataTypeName"
          ],
          members: {
            dataSourceType: {},
            dataTypeName: {}
          }
        },
        S1e: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              label: {},
              position: {
                shape: "S1g"
              },
              excluded: {
                type: "boolean"
              },
              inputType: {
                type: "structure",
                required: [
                  "type"
                ],
                members: {
                  type: {},
                  required: {
                    type: "boolean"
                  },
                  readOnly: {
                    type: "boolean"
                  },
                  placeholder: {},
                  defaultValue: {},
                  descriptiveText: {},
                  defaultChecked: {
                    type: "boolean"
                  },
                  defaultCountryCode: {},
                  valueMappings: {
                    type: "structure",
                    required: [
                      "values"
                    ],
                    members: {
                      values: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "value"
                          ],
                          members: {
                            displayValue: {
                              shape: "S1m"
                            },
                            value: {
                              shape: "S1m"
                            }
                          }
                        }
                      },
                      bindingProperties: {
                        type: "map",
                        key: {},
                        value: {
                          type: "structure",
                          members: {
                            type: {},
                            bindingProperties: {
                              type: "structure",
                              members: {
                                model: {}
                              }
                            }
                          }
                        }
                      }
                    }
                  },
                  name: {},
                  minValue: {
                    type: "float"
                  },
                  maxValue: {
                    type: "float"
                  },
                  step: {
                    type: "float"
                  },
                  value: {},
                  isArray: {
                    type: "boolean"
                  },
                  fileUploaderConfig: {
                    type: "structure",
                    required: [
                      "accessLevel",
                      "acceptedFileTypes"
                    ],
                    members: {
                      accessLevel: {},
                      acceptedFileTypes: {
                        shape: "S1v"
                      },
                      showThumbnails: {
                        type: "boolean"
                      },
                      isResumable: {
                        type: "boolean"
                      },
                      maxFileCount: {
                        type: "integer"
                      },
                      maxSize: {
                        type: "integer"
                      }
                    }
                  }
                }
              },
              validations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "type"
                  ],
                  members: {
                    type: {},
                    strValues: {
                      shape: "S1v"
                    },
                    numValues: {
                      type: "list",
                      member: {
                        type: "integer"
                      }
                    },
                    validationMessage: {}
                  }
                }
              }
            }
          }
        },
        S1g: {
          type: "structure",
          members: {
            fixed: {},
            rightOf: {},
            below: {}
          },
          union: true
        },
        S1m: {
          type: "structure",
          members: {
            value: {},
            bindingProperties: {
              type: "structure",
              required: [
                "property"
              ],
              members: {
                property: {},
                field: {}
              }
            },
            concat: {
              type: "list",
              member: {
                shape: "S1m"
              }
            }
          }
        },
        S1v: {
          type: "list",
          member: {}
        },
        S20: {
          type: "structure",
          members: {
            horizontalGap: {
              shape: "S21"
            },
            verticalGap: {
              shape: "S21"
            },
            outerPadding: {
              shape: "S21"
            }
          }
        },
        S21: {
          type: "structure",
          members: {
            tokenReference: {},
            value: {}
          },
          union: true
        },
        S22: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "type"
            ],
            members: {
              type: {},
              position: {
                shape: "S1g"
              },
              text: {},
              level: {
                type: "integer"
              },
              orientation: {},
              excluded: {
                type: "boolean"
              }
            }
          }
        },
        S24: {
          type: "structure",
          members: {
            position: {},
            clear: {
              shape: "S26"
            },
            cancel: {
              shape: "S26"
            },
            submit: {
              shape: "S26"
            }
          }
        },
        S26: {
          type: "structure",
          members: {
            excluded: {
              type: "boolean"
            },
            children: {},
            position: {
              shape: "S1g"
            }
          }
        },
        S29: {
          type: "structure",
          required: [
            "appId",
            "environmentName",
            "id",
            "name",
            "formActionType",
            "style",
            "dataType",
            "fields",
            "sectionalElements",
            "schemaVersion"
          ],
          members: {
            appId: {},
            environmentName: {},
            id: {},
            name: {},
            formActionType: {},
            style: {
              shape: "S20"
            },
            dataType: {
              shape: "S1b"
            },
            fields: {
              shape: "S1e"
            },
            sectionalElements: {
              shape: "S22"
            },
            schemaVersion: {},
            tags: {
              shape: "S11"
            },
            cta: {
              shape: "S24"
            },
            labelDecorator: {}
          }
        },
        S2d: {
          type: "list",
          member: {
            type: "structure",
            members: {
              key: {},
              value: {
                type: "structure",
                members: {
                  value: {},
                  children: {
                    shape: "S2d"
                  }
                }
              }
            }
          }
        },
        S2h: {
          type: "structure",
          required: [
            "appId",
            "environmentName",
            "id",
            "name",
            "createdAt",
            "values"
          ],
          members: {
            appId: {},
            environmentName: {},
            id: {},
            name: {},
            createdAt: {
              shape: "S17"
            },
            modifiedAt: {
              shape: "S17"
            },
            values: {
              shape: "S2d"
            },
            overrides: {
              shape: "S2d"
            },
            tags: {
              shape: "S11"
            }
          }
        },
        S2o: {
          type: "string",
          sensitive: true
        },
        S32: {
          type: "structure",
          required: [
            "id",
            "appId",
            "environmentName"
          ],
          members: {
            id: {},
            appId: {},
            environmentName: {},
            renderConfig: {
              shape: "S33"
            },
            genericDataSchema: {
              shape: "S3d"
            },
            autoGenerateForms: {
              type: "boolean"
            },
            features: {
              shape: "S3v"
            },
            status: {},
            statusMessage: {},
            asset: {
              type: "structure",
              members: {
                downloadUrl: {}
              }
            },
            tags: {
              shape: "S11"
            },
            createdAt: {
              shape: "S17"
            },
            modifiedAt: {
              shape: "S17"
            },
            dependencies: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  name: {},
                  supportedVersion: {},
                  isSemVer: {
                    type: "boolean"
                  },
                  reason: {}
                }
              }
            }
          }
        },
        S33: {
          type: "structure",
          members: {
            react: {
              type: "structure",
              members: {
                module: {},
                target: {},
                script: {},
                renderTypeDeclarations: {
                  type: "boolean"
                },
                inlineSourceMap: {
                  type: "boolean"
                },
                apiConfiguration: {
                  type: "structure",
                  members: {
                    graphQLConfig: {
                      type: "structure",
                      required: [
                        "typesFilePath",
                        "queriesFilePath",
                        "mutationsFilePath",
                        "subscriptionsFilePath",
                        "fragmentsFilePath"
                      ],
                      members: {
                        typesFilePath: {},
                        queriesFilePath: {},
                        mutationsFilePath: {},
                        subscriptionsFilePath: {},
                        fragmentsFilePath: {}
                      }
                    },
                    dataStoreConfig: {
                      type: "structure",
                      members: {}
                    },
                    noApiConfig: {
                      type: "structure",
                      members: {}
                    }
                  },
                  union: true
                },
                dependencies: {
                  type: "map",
                  key: {},
                  value: {}
                }
              }
            }
          },
          union: true
        },
        S3d: {
          type: "structure",
          required: [
            "dataSourceType",
            "models",
            "enums",
            "nonModels"
          ],
          members: {
            dataSourceType: {},
            models: {
              type: "map",
              key: {},
              value: {
                type: "structure",
                required: [
                  "fields",
                  "primaryKeys"
                ],
                members: {
                  fields: {
                    type: "map",
                    key: {},
                    value: {
                      shape: "S3i"
                    }
                  },
                  isJoinTable: {
                    type: "boolean"
                  },
                  primaryKeys: {
                    type: "list",
                    member: {}
                  }
                }
              }
            },
            enums: {
              type: "map",
              key: {},
              value: {
                type: "structure",
                required: [
                  "values"
                ],
                members: {
                  values: {
                    type: "list",
                    member: {}
                  }
                }
              }
            },
            nonModels: {
              type: "map",
              key: {},
              value: {
                type: "structure",
                required: [
                  "fields"
                ],
                members: {
                  fields: {
                    type: "map",
                    key: {},
                    value: {
                      shape: "S3i"
                    }
                  }
                }
              }
            }
          }
        },
        S3i: {
          type: "structure",
          required: [
            "dataType",
            "dataTypeValue",
            "required",
            "readOnly",
            "isArray"
          ],
          members: {
            dataType: {},
            dataTypeValue: {},
            required: {
              type: "boolean"
            },
            readOnly: {
              type: "boolean"
            },
            isArray: {
              type: "boolean"
            },
            relationship: {
              type: "structure",
              required: [
                "type",
                "relatedModelName"
              ],
              members: {
                type: {},
                relatedModelName: {},
                relatedModelFields: {
                  type: "list",
                  member: {}
                },
                canUnlinkAssociatedModel: {
                  type: "boolean"
                },
                relatedJoinFieldName: {},
                relatedJoinTableName: {},
                belongsToFieldOnRelatedModel: {},
                associatedFields: {
                  type: "list",
                  member: {}
                },
                isHasManyIndex: {
                  type: "boolean"
                }
              }
            }
          }
        },
        S3v: {
          type: "structure",
          members: {
            isRelationshipSupported: {
              type: "boolean"
            },
            isNonModelSupported: {
              type: "boolean"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/amplifyuibuilder-2021-08-11.paginators.json
var require_amplifyuibuilder_2021_08_11_paginators = __commonJS({
  "node_modules/aws-sdk/apis/amplifyuibuilder-2021-08-11.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ExportComponents: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "entities"
        },
        ExportForms: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "entities"
        },
        ExportThemes: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "entities"
        },
        ListCodegenJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "entities"
        },
        ListComponents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "entities"
        },
        ListForms: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "entities"
        },
        ListThemes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "entities"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/amplifyuibuilder-2021-08-11.waiters2.json
var require_amplifyuibuilder_2021_08_11_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/amplifyuibuilder-2021-08-11.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {}
    };
  }
});

// node_modules/aws-sdk/clients/amplifyuibuilder.js
var require_amplifyuibuilder = __commonJS({
  "node_modules/aws-sdk/clients/amplifyuibuilder.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["amplifyuibuilder"] = {};
    AWS2.AmplifyUIBuilder = Service.defineService("amplifyuibuilder", ["2021-08-11"]);
    Object.defineProperty(apiLoader.services["amplifyuibuilder"], "2021-08-11", {
      get: function get() {
        var model = require_amplifyuibuilder_2021_08_11_min();
        model.paginators = require_amplifyuibuilder_2021_08_11_paginators().pagination;
        model.waiters = require_amplifyuibuilder_2021_08_11_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.AmplifyUIBuilder;
  }
});

// node_modules/aws-sdk/apis/keyspaces-2022-02-10.min.json
var require_keyspaces_2022_02_10_min = __commonJS({
  "node_modules/aws-sdk/apis/keyspaces-2022-02-10.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2022-02-10",
        endpointPrefix: "cassandra",
        jsonVersion: "1.0",
        protocol: "json",
        serviceFullName: "Amazon Keyspaces",
        serviceId: "Keyspaces",
        signatureVersion: "v4",
        signingName: "cassandra",
        targetPrefix: "KeyspacesService",
        uid: "keyspaces-2022-02-10"
      },
      operations: {
        CreateKeyspace: {
          input: {
            type: "structure",
            required: [
              "keyspaceName"
            ],
            members: {
              keyspaceName: {},
              tags: {
                shape: "S3"
              },
              replicationSpecification: {
                type: "structure",
                required: [
                  "replicationStrategy"
                ],
                members: {
                  replicationStrategy: {},
                  regionList: {
                    shape: "S9"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {}
            }
          }
        },
        CreateTable: {
          input: {
            type: "structure",
            required: [
              "keyspaceName",
              "tableName",
              "schemaDefinition"
            ],
            members: {
              keyspaceName: {},
              tableName: {},
              schemaDefinition: {
                shape: "Sf"
              },
              comment: {
                shape: "Sq"
              },
              capacitySpecification: {
                shape: "Ss"
              },
              encryptionSpecification: {
                shape: "Sv"
              },
              pointInTimeRecovery: {
                shape: "Sy"
              },
              ttl: {
                shape: "S10"
              },
              defaultTimeToLive: {
                type: "integer"
              },
              tags: {
                shape: "S3"
              },
              clientSideTimestamps: {
                shape: "S13"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {}
            }
          }
        },
        DeleteKeyspace: {
          input: {
            type: "structure",
            required: [
              "keyspaceName"
            ],
            members: {
              keyspaceName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteTable: {
          input: {
            type: "structure",
            required: [
              "keyspaceName",
              "tableName"
            ],
            members: {
              keyspaceName: {},
              tableName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetKeyspace: {
          input: {
            type: "structure",
            required: [
              "keyspaceName"
            ],
            members: {
              keyspaceName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "keyspaceName",
              "resourceArn",
              "replicationStrategy"
            ],
            members: {
              keyspaceName: {},
              resourceArn: {},
              replicationStrategy: {},
              replicationRegions: {
                shape: "S9"
              }
            }
          }
        },
        GetTable: {
          input: {
            type: "structure",
            required: [
              "keyspaceName",
              "tableName"
            ],
            members: {
              keyspaceName: {},
              tableName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "keyspaceName",
              "tableName",
              "resourceArn"
            ],
            members: {
              keyspaceName: {},
              tableName: {},
              resourceArn: {},
              creationTimestamp: {
                type: "timestamp"
              },
              status: {},
              schemaDefinition: {
                shape: "Sf"
              },
              capacitySpecification: {
                type: "structure",
                required: [
                  "throughputMode"
                ],
                members: {
                  throughputMode: {},
                  readCapacityUnits: {
                    type: "long"
                  },
                  writeCapacityUnits: {
                    type: "long"
                  },
                  lastUpdateToPayPerRequestTimestamp: {
                    type: "timestamp"
                  }
                }
              },
              encryptionSpecification: {
                shape: "Sv"
              },
              pointInTimeRecovery: {
                type: "structure",
                required: [
                  "status"
                ],
                members: {
                  status: {},
                  earliestRestorableTimestamp: {
                    type: "timestamp"
                  }
                }
              },
              ttl: {
                shape: "S10"
              },
              defaultTimeToLive: {
                type: "integer"
              },
              comment: {
                shape: "Sq"
              },
              clientSideTimestamps: {
                shape: "S13"
              }
            }
          }
        },
        ListKeyspaces: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "keyspaces"
            ],
            members: {
              nextToken: {},
              keyspaces: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "keyspaceName",
                    "resourceArn",
                    "replicationStrategy"
                  ],
                  members: {
                    keyspaceName: {},
                    resourceArn: {},
                    replicationStrategy: {},
                    replicationRegions: {
                      shape: "S9"
                    }
                  }
                }
              }
            }
          }
        },
        ListTables: {
          input: {
            type: "structure",
            required: [
              "keyspaceName"
            ],
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              keyspaceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              tables: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "keyspaceName",
                    "tableName",
                    "resourceArn"
                  ],
                  members: {
                    keyspaceName: {},
                    tableName: {},
                    resourceArn: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              tags: {
                shape: "S3"
              }
            }
          }
        },
        RestoreTable: {
          input: {
            type: "structure",
            required: [
              "sourceKeyspaceName",
              "sourceTableName",
              "targetKeyspaceName",
              "targetTableName"
            ],
            members: {
              sourceKeyspaceName: {},
              sourceTableName: {},
              targetKeyspaceName: {},
              targetTableName: {},
              restoreTimestamp: {
                type: "timestamp"
              },
              capacitySpecificationOverride: {
                shape: "Ss"
              },
              encryptionSpecificationOverride: {
                shape: "Sv"
              },
              pointInTimeRecoveryOverride: {
                shape: "Sy"
              },
              tagsOverride: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "restoredTableARN"
            ],
            members: {
              restoredTableARN: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateTable: {
          input: {
            type: "structure",
            required: [
              "keyspaceName",
              "tableName"
            ],
            members: {
              keyspaceName: {},
              tableName: {},
              addColumns: {
                shape: "Sg"
              },
              capacitySpecification: {
                shape: "Ss"
              },
              encryptionSpecification: {
                shape: "Sv"
              },
              pointInTimeRecovery: {
                shape: "Sy"
              },
              ttl: {
                shape: "S10"
              },
              defaultTimeToLive: {
                type: "integer"
              },
              clientSideTimestamps: {
                shape: "S13"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {}
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        S9: {
          type: "list",
          member: {}
        },
        Sf: {
          type: "structure",
          required: [
            "allColumns",
            "partitionKeys"
          ],
          members: {
            allColumns: {
              shape: "Sg"
            },
            partitionKeys: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "name"
                ],
                members: {
                  name: {}
                }
              }
            },
            clusteringKeys: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "name",
                  "orderBy"
                ],
                members: {
                  name: {},
                  orderBy: {}
                }
              }
            },
            staticColumns: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "name"
                ],
                members: {
                  name: {}
                }
              }
            }
          }
        },
        Sg: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "type"
            ],
            members: {
              name: {},
              type: {}
            }
          }
        },
        Sq: {
          type: "structure",
          required: [
            "message"
          ],
          members: {
            message: {}
          }
        },
        Ss: {
          type: "structure",
          required: [
            "throughputMode"
          ],
          members: {
            throughputMode: {},
            readCapacityUnits: {
              type: "long"
            },
            writeCapacityUnits: {
              type: "long"
            }
          }
        },
        Sv: {
          type: "structure",
          required: [
            "type"
          ],
          members: {
            type: {},
            kmsKeyIdentifier: {}
          }
        },
        Sy: {
          type: "structure",
          required: [
            "status"
          ],
          members: {
            status: {}
          }
        },
        S10: {
          type: "structure",
          required: [
            "status"
          ],
          members: {
            status: {}
          }
        },
        S13: {
          type: "structure",
          required: [
            "status"
          ],
          members: {
            status: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/keyspaces-2022-02-10.paginators.json
var require_keyspaces_2022_02_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/keyspaces-2022-02-10.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListKeyspaces: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "keyspaces"
        },
        ListTables: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "tables"
        },
        ListTagsForResource: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "tags"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/keyspaces-2022-02-10.waiters2.json
var require_keyspaces_2022_02_10_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/keyspaces-2022-02-10.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {}
    };
  }
});

// node_modules/aws-sdk/clients/keyspaces.js
var require_keyspaces = __commonJS({
  "node_modules/aws-sdk/clients/keyspaces.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["keyspaces"] = {};
    AWS2.Keyspaces = Service.defineService("keyspaces", ["2022-02-10"]);
    Object.defineProperty(apiLoader.services["keyspaces"], "2022-02-10", {
      get: function get() {
        var model = require_keyspaces_2022_02_10_min();
        model.paginators = require_keyspaces_2022_02_10_paginators().pagination;
        model.waiters = require_keyspaces_2022_02_10_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Keyspaces;
  }
});

// node_modules/aws-sdk/apis/billingconductor-2021-07-30.min.json
var require_billingconductor_2021_07_30_min = __commonJS({
  "node_modules/aws-sdk/apis/billingconductor-2021-07-30.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-07-30",
        endpointPrefix: "billingconductor",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWSBillingConductor",
        serviceId: "billingconductor",
        signatureVersion: "v4",
        signingName: "billingconductor",
        uid: "billingconductor-2021-07-30"
      },
      operations: {
        AssociateAccounts: {
          http: {
            requestUri: "/associate-accounts",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Arn",
              "AccountIds"
            ],
            members: {
              Arn: {},
              AccountIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {}
            }
          },
          idempotent: true
        },
        AssociatePricingRules: {
          http: {
            method: "PUT",
            requestUri: "/associate-pricing-rules",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Arn",
              "PricingRuleArns"
            ],
            members: {
              Arn: {},
              PricingRuleArns: {
                shape: "S8"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {}
            }
          },
          idempotent: true
        },
        BatchAssociateResourcesToCustomLineItem: {
          http: {
            method: "PUT",
            requestUri: "/batch-associate-resources-to-custom-line-item",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "TargetArn",
              "ResourceArns"
            ],
            members: {
              TargetArn: {},
              ResourceArns: {
                type: "list",
                member: {}
              },
              BillingPeriodRange: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SuccessfullyAssociatedResources: {
                shape: "Si"
              },
              FailedAssociatedResources: {
                shape: "Si"
              }
            }
          },
          idempotent: true
        },
        BatchDisassociateResourcesFromCustomLineItem: {
          http: {
            method: "PUT",
            requestUri: "/batch-disassociate-resources-from-custom-line-item",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "TargetArn",
              "ResourceArns"
            ],
            members: {
              TargetArn: {},
              ResourceArns: {
                type: "list",
                member: {}
              },
              BillingPeriodRange: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SuccessfullyDisassociatedResources: {
                shape: "Sq"
              },
              FailedDisassociatedResources: {
                shape: "Sq"
              }
            }
          },
          idempotent: true
        },
        CreateBillingGroup: {
          http: {
            requestUri: "/create-billing-group",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "AccountGrouping",
              "ComputationPreference"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              Name: {
                shape: "Su"
              },
              AccountGrouping: {
                type: "structure",
                required: [
                  "LinkedAccountIds"
                ],
                members: {
                  LinkedAccountIds: {
                    shape: "S3"
                  },
                  AutoAssociate: {
                    type: "boolean"
                  }
                }
              },
              ComputationPreference: {
                shape: "Sx"
              },
              PrimaryAccountId: {},
              Description: {
                shape: "Sz"
              },
              Tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {}
            }
          },
          idempotent: true
        },
        CreateCustomLineItem: {
          http: {
            requestUri: "/create-custom-line-item",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "Description",
              "BillingGroupArn",
              "ChargeDetails"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              Name: {
                shape: "S15"
              },
              Description: {
                shape: "S16"
              },
              BillingGroupArn: {},
              BillingPeriodRange: {
                shape: "Sf"
              },
              Tags: {
                shape: "S10"
              },
              ChargeDetails: {
                type: "structure",
                required: [
                  "Type"
                ],
                members: {
                  Flat: {
                    type: "structure",
                    required: [
                      "ChargeValue"
                    ],
                    members: {
                      ChargeValue: {
                        type: "double"
                      }
                    }
                  },
                  Percentage: {
                    type: "structure",
                    required: [
                      "PercentageValue"
                    ],
                    members: {
                      PercentageValue: {
                        type: "double"
                      },
                      AssociatedValues: {
                        type: "list",
                        member: {}
                      }
                    }
                  },
                  Type: {},
                  LineItemFilters: {
                    shape: "S1e"
                  }
                }
              },
              AccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {}
            }
          }
        },
        CreatePricingPlan: {
          http: {
            requestUri: "/create-pricing-plan",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              Name: {
                shape: "S1m"
              },
              Description: {
                shape: "S1n"
              },
              PricingRuleArns: {
                type: "list",
                member: {}
              },
              Tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {}
            }
          },
          idempotent: true
        },
        CreatePricingRule: {
          http: {
            requestUri: "/create-pricing-rule",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "Type"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              Name: {
                shape: "S1r"
              },
              Description: {
                shape: "S1s"
              },
              Scope: {},
              Type: {},
              ModifierPercentage: {
                type: "double"
              },
              Service: {},
              Tags: {
                shape: "S10"
              },
              BillingEntity: {},
              Tiering: {
                type: "structure",
                required: [
                  "FreeTier"
                ],
                members: {
                  FreeTier: {
                    type: "structure",
                    required: [
                      "Activated"
                    ],
                    members: {
                      Activated: {
                        type: "boolean"
                      }
                    }
                  }
                }
              },
              UsageType: {},
              Operation: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {}
            }
          },
          idempotent: true
        },
        DeleteBillingGroup: {
          http: {
            requestUri: "/delete-billing-group",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {}
            }
          },
          idempotent: true
        },
        DeleteCustomLineItem: {
          http: {
            requestUri: "/delete-custom-line-item",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {},
              BillingPeriodRange: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {}
            }
          },
          idempotent: true
        },
        DeletePricingPlan: {
          http: {
            requestUri: "/delete-pricing-plan",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {}
            }
          },
          idempotent: true
        },
        DeletePricingRule: {
          http: {
            requestUri: "/delete-pricing-rule",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {}
            }
          },
          idempotent: true
        },
        DisassociateAccounts: {
          http: {
            requestUri: "/disassociate-accounts",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Arn",
              "AccountIds"
            ],
            members: {
              Arn: {},
              AccountIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {}
            }
          },
          idempotent: true
        },
        DisassociatePricingRules: {
          http: {
            method: "PUT",
            requestUri: "/disassociate-pricing-rules",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Arn",
              "PricingRuleArns"
            ],
            members: {
              Arn: {},
              PricingRuleArns: {
                shape: "S8"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {}
            }
          },
          idempotent: true
        },
        GetBillingGroupCostReport: {
          http: {
            requestUri: "/get-billing-group-cost-report",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {},
              BillingPeriodRange: {
                type: "structure",
                required: [
                  "InclusiveStartBillingPeriod",
                  "ExclusiveEndBillingPeriod"
                ],
                members: {
                  InclusiveStartBillingPeriod: {},
                  ExclusiveEndBillingPeriod: {}
                }
              },
              GroupBy: {
                type: "list",
                member: {}
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BillingGroupCostReportResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    AWSCost: {},
                    ProformaCost: {},
                    Margin: {},
                    MarginPercentage: {},
                    Currency: {},
                    Attributes: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Key: {},
                          Value: {}
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListAccountAssociations: {
          http: {
            requestUri: "/list-account-associations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BillingPeriod: {},
              Filters: {
                type: "structure",
                members: {
                  Association: {},
                  AccountId: {},
                  AccountIds: {
                    type: "list",
                    member: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LinkedAccounts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AccountId: {},
                    BillingGroupArn: {},
                    AccountName: {
                      type: "string",
                      sensitive: true
                    },
                    AccountEmail: {
                      type: "string",
                      sensitive: true
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListBillingGroupCostReports: {
          http: {
            requestUri: "/list-billing-group-cost-reports",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BillingPeriod: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                type: "structure",
                members: {
                  BillingGroupArns: {
                    shape: "S38"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BillingGroupCostReports: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    AWSCost: {},
                    ProformaCost: {},
                    Margin: {},
                    MarginPercentage: {},
                    Currency: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListBillingGroups: {
          http: {
            requestUri: "/list-billing-groups",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BillingPeriod: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                type: "structure",
                members: {
                  Arns: {
                    shape: "S38"
                  },
                  PricingPlan: {},
                  Statuses: {
                    type: "list",
                    member: {}
                  },
                  AutoAssociate: {
                    type: "boolean"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BillingGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {
                      shape: "Su"
                    },
                    Arn: {},
                    Description: {
                      shape: "Sz"
                    },
                    PrimaryAccountId: {},
                    ComputationPreference: {
                      shape: "Sx"
                    },
                    Size: {
                      type: "long"
                    },
                    CreationTime: {
                      type: "long"
                    },
                    LastModifiedTime: {
                      type: "long"
                    },
                    Status: {},
                    StatusReason: {},
                    AccountGrouping: {
                      type: "structure",
                      members: {
                        AutoAssociate: {
                          type: "boolean"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListCustomLineItemVersions: {
          http: {
            requestUri: "/list-custom-line-item-versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                type: "structure",
                members: {
                  BillingPeriodRange: {
                    type: "structure",
                    members: {
                      StartBillingPeriod: {},
                      EndBillingPeriod: {}
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CustomLineItemVersions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {
                      shape: "S15"
                    },
                    ChargeDetails: {
                      shape: "S3u"
                    },
                    CurrencyCode: {},
                    Description: {
                      shape: "S16"
                    },
                    ProductCode: {},
                    BillingGroupArn: {},
                    CreationTime: {
                      type: "long"
                    },
                    LastModifiedTime: {
                      type: "long"
                    },
                    AssociationSize: {
                      type: "long"
                    },
                    StartBillingPeriod: {},
                    EndBillingPeriod: {},
                    Arn: {},
                    StartTime: {
                      type: "long"
                    },
                    AccountId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListCustomLineItems: {
          http: {
            requestUri: "/list-custom-line-items",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BillingPeriod: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                type: "structure",
                members: {
                  Names: {
                    type: "list",
                    member: {
                      shape: "S15"
                    }
                  },
                  BillingGroups: {
                    shape: "S38"
                  },
                  Arns: {
                    type: "list",
                    member: {}
                  },
                  AccountIds: {
                    shape: "S3"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CustomLineItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Name: {
                      shape: "S15"
                    },
                    ChargeDetails: {
                      shape: "S3u"
                    },
                    CurrencyCode: {},
                    Description: {
                      shape: "S16"
                    },
                    ProductCode: {},
                    BillingGroupArn: {},
                    CreationTime: {
                      type: "long"
                    },
                    LastModifiedTime: {
                      type: "long"
                    },
                    AssociationSize: {
                      type: "long"
                    },
                    AccountId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPricingPlans: {
          http: {
            requestUri: "/list-pricing-plans",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BillingPeriod: {},
              Filters: {
                type: "structure",
                members: {
                  Arns: {
                    shape: "S49"
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BillingPeriod: {},
              PricingPlans: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {
                      shape: "S1m"
                    },
                    Arn: {},
                    Description: {
                      shape: "S1n"
                    },
                    Size: {
                      type: "long"
                    },
                    CreationTime: {
                      type: "long"
                    },
                    LastModifiedTime: {
                      type: "long"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPricingPlansAssociatedWithPricingRule: {
          http: {
            requestUri: "/list-pricing-plans-associated-with-pricing-rule",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "PricingRuleArn"
            ],
            members: {
              BillingPeriod: {},
              PricingRuleArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BillingPeriod: {},
              PricingRuleArn: {},
              PricingPlanArns: {
                shape: "S49"
              },
              NextToken: {}
            }
          }
        },
        ListPricingRules: {
          http: {
            requestUri: "/list-pricing-rules",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BillingPeriod: {},
              Filters: {
                type: "structure",
                members: {
                  Arns: {
                    shape: "S4k"
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BillingPeriod: {},
              PricingRules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {
                      shape: "S1r"
                    },
                    Arn: {},
                    Description: {
                      shape: "S1s"
                    },
                    Scope: {},
                    Type: {},
                    ModifierPercentage: {
                      type: "double"
                    },
                    Service: {},
                    AssociatedPricingPlanCount: {
                      type: "long"
                    },
                    CreationTime: {
                      type: "long"
                    },
                    LastModifiedTime: {
                      type: "long"
                    },
                    BillingEntity: {},
                    Tiering: {
                      type: "structure",
                      required: [
                        "FreeTier"
                      ],
                      members: {
                        FreeTier: {
                          type: "structure",
                          required: [
                            "Activated"
                          ],
                          members: {
                            Activated: {
                              type: "boolean"
                            }
                          }
                        }
                      }
                    },
                    UsageType: {},
                    Operation: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPricingRulesAssociatedToPricingPlan: {
          http: {
            requestUri: "/list-pricing-rules-associated-to-pricing-plan",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "PricingPlanArn"
            ],
            members: {
              BillingPeriod: {},
              PricingPlanArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BillingPeriod: {},
              PricingPlanArn: {},
              PricingRuleArns: {
                shape: "S4k"
              },
              NextToken: {}
            }
          }
        },
        ListResourcesAssociatedToCustomLineItem: {
          http: {
            requestUri: "/list-resources-associated-to-custom-line-item",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              BillingPeriod: {},
              Arn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                type: "structure",
                members: {
                  Relationship: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              AssociatedResources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Relationship: {},
                    EndBillingPeriod: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S10"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{ResourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateBillingGroup: {
          http: {
            requestUri: "/update-billing-group",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {},
              Name: {
                shape: "Su"
              },
              Status: {},
              ComputationPreference: {
                shape: "Sx"
              },
              Description: {
                shape: "Sz"
              },
              AccountGrouping: {
                shape: "S58"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Name: {
                shape: "Su"
              },
              Description: {
                shape: "Sz"
              },
              PrimaryAccountId: {},
              PricingPlanArn: {},
              Size: {
                type: "long"
              },
              LastModifiedTime: {
                type: "long"
              },
              Status: {},
              StatusReason: {},
              AccountGrouping: {
                shape: "S58"
              }
            }
          },
          idempotent: true
        },
        UpdateCustomLineItem: {
          http: {
            requestUri: "/update-custom-line-item",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {},
              Name: {
                shape: "S15"
              },
              Description: {
                shape: "S16"
              },
              ChargeDetails: {
                type: "structure",
                members: {
                  Flat: {
                    type: "structure",
                    required: [
                      "ChargeValue"
                    ],
                    members: {
                      ChargeValue: {
                        type: "double"
                      }
                    }
                  },
                  Percentage: {
                    type: "structure",
                    required: [
                      "PercentageValue"
                    ],
                    members: {
                      PercentageValue: {
                        type: "double"
                      }
                    }
                  },
                  LineItemFilters: {
                    shape: "S1e"
                  }
                }
              },
              BillingPeriodRange: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              BillingGroupArn: {},
              Name: {
                shape: "S15"
              },
              Description: {
                shape: "S16"
              },
              ChargeDetails: {
                shape: "S3u"
              },
              LastModifiedTime: {
                type: "long"
              },
              AssociationSize: {
                type: "long"
              }
            }
          },
          idempotent: true
        },
        UpdatePricingPlan: {
          http: {
            method: "PUT",
            requestUri: "/update-pricing-plan",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {},
              Name: {
                shape: "S1m"
              },
              Description: {
                shape: "S1n"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Name: {
                shape: "S1m"
              },
              Description: {
                shape: "S1n"
              },
              Size: {
                type: "long"
              },
              LastModifiedTime: {
                type: "long"
              }
            }
          },
          idempotent: true
        },
        UpdatePricingRule: {
          http: {
            method: "PUT",
            requestUri: "/update-pricing-rule",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {},
              Name: {
                shape: "S1r"
              },
              Description: {
                shape: "S1s"
              },
              Type: {},
              ModifierPercentage: {
                type: "double"
              },
              Tiering: {
                shape: "S5j"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Name: {
                shape: "S1r"
              },
              Description: {
                shape: "S1s"
              },
              Scope: {},
              Type: {},
              ModifierPercentage: {
                type: "double"
              },
              Service: {},
              AssociatedPricingPlanCount: {
                type: "long"
              },
              LastModifiedTime: {
                type: "long"
              },
              BillingEntity: {},
              Tiering: {
                shape: "S5j"
              },
              UsageType: {},
              Operation: {}
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {}
        },
        S8: {
          type: "list",
          member: {}
        },
        Sf: {
          type: "structure",
          required: [
            "InclusiveStartBillingPeriod"
          ],
          members: {
            InclusiveStartBillingPeriod: {},
            ExclusiveEndBillingPeriod: {}
          }
        },
        Si: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Arn: {},
              Error: {
                shape: "Sk"
              }
            }
          }
        },
        Sk: {
          type: "structure",
          members: {
            Message: {},
            Reason: {}
          }
        },
        Sq: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Arn: {},
              Error: {
                shape: "Sk"
              }
            }
          }
        },
        Su: {
          type: "string",
          sensitive: true
        },
        Sx: {
          type: "structure",
          required: [
            "PricingPlanArn"
          ],
          members: {
            PricingPlanArn: {}
          }
        },
        Sz: {
          type: "string",
          sensitive: true
        },
        S10: {
          type: "map",
          key: {},
          value: {}
        },
        S15: {
          type: "string",
          sensitive: true
        },
        S16: {
          type: "string",
          sensitive: true
        },
        S1e: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Attribute",
              "MatchOption",
              "Values"
            ],
            members: {
              Attribute: {},
              MatchOption: {},
              Values: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S1m: {
          type: "string",
          sensitive: true
        },
        S1n: {
          type: "string",
          sensitive: true
        },
        S1r: {
          type: "string",
          sensitive: true
        },
        S1s: {
          type: "string",
          sensitive: true
        },
        S38: {
          type: "list",
          member: {}
        },
        S3u: {
          type: "structure",
          required: [
            "Type"
          ],
          members: {
            Flat: {
              type: "structure",
              required: [
                "ChargeValue"
              ],
              members: {
                ChargeValue: {
                  type: "double"
                }
              }
            },
            Percentage: {
              type: "structure",
              required: [
                "PercentageValue"
              ],
              members: {
                PercentageValue: {
                  type: "double"
                }
              }
            },
            Type: {},
            LineItemFilters: {
              shape: "S1e"
            }
          }
        },
        S49: {
          type: "list",
          member: {}
        },
        S4k: {
          type: "list",
          member: {}
        },
        S58: {
          type: "structure",
          members: {
            AutoAssociate: {
              type: "boolean"
            }
          }
        },
        S5j: {
          type: "structure",
          required: [
            "FreeTier"
          ],
          members: {
            FreeTier: {
              type: "structure",
              required: [
                "Activated"
              ],
              members: {
                Activated: {
                  type: "boolean"
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/billingconductor-2021-07-30.paginators.json
var require_billingconductor_2021_07_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/billingconductor-2021-07-30.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAccountAssociations: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "LinkedAccounts"
        },
        ListBillingGroupCostReports: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "BillingGroupCostReports"
        },
        ListBillingGroups: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "BillingGroups"
        },
        ListCustomLineItems: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "CustomLineItems"
        },
        ListCustomLineItemVersions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "CustomLineItemVersions"
        },
        ListPricingPlans: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          non_aggregate_keys: ["BillingPeriod"],
          output_token: "NextToken",
          result_key: "PricingPlans"
        },
        ListPricingPlansAssociatedWithPricingRule: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          non_aggregate_keys: ["BillingPeriod", "PricingRuleArn"],
          output_token: "NextToken",
          result_key: "PricingPlanArns"
        },
        ListPricingRules: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          non_aggregate_keys: ["BillingPeriod"],
          output_token: "NextToken",
          result_key: "PricingRules"
        },
        ListPricingRulesAssociatedToPricingPlan: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          non_aggregate_keys: ["BillingPeriod", "PricingPlanArn"],
          output_token: "NextToken",
          result_key: "PricingRuleArns"
        },
        ListResourcesAssociatedToCustomLineItem: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          non_aggregate_keys: ["Arn"],
          output_token: "NextToken",
          result_key: "AssociatedResources"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/billingconductor-2021-07-30.waiters2.json
var require_billingconductor_2021_07_30_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/billingconductor-2021-07-30.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {}
    };
  }
});

// node_modules/aws-sdk/clients/billingconductor.js
var require_billingconductor = __commonJS({
  "node_modules/aws-sdk/clients/billingconductor.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["billingconductor"] = {};
    AWS2.Billingconductor = Service.defineService("billingconductor", ["2021-07-30"]);
    Object.defineProperty(apiLoader.services["billingconductor"], "2021-07-30", {
      get: function get() {
        var model = require_billingconductor_2021_07_30_min();
        model.paginators = require_billingconductor_2021_07_30_paginators().pagination;
        model.waiters = require_billingconductor_2021_07_30_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Billingconductor;
  }
});

// node_modules/aws-sdk/apis/pinpoint-sms-voice-v2-2022-03-31.min.json
var require_pinpoint_sms_voice_v2_2022_03_31_min = __commonJS({
  "node_modules/aws-sdk/apis/pinpoint-sms-voice-v2-2022-03-31.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2022-03-31",
        endpointPrefix: "sms-voice",
        jsonVersion: "1.0",
        protocol: "json",
        serviceFullName: "Amazon Pinpoint SMS Voice V2",
        serviceId: "Pinpoint SMS Voice V2",
        signatureVersion: "v4",
        signingName: "sms-voice",
        targetPrefix: "PinpointSMSVoiceV2",
        uid: "pinpoint-sms-voice-v2-2022-03-31"
      },
      operations: {
        AssociateOriginationIdentity: {
          input: {
            type: "structure",
            required: [
              "PoolId",
              "OriginationIdentity",
              "IsoCountryCode"
            ],
            members: {
              PoolId: {},
              OriginationIdentity: {},
              IsoCountryCode: {},
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PoolArn: {},
              PoolId: {},
              OriginationIdentityArn: {},
              OriginationIdentity: {},
              IsoCountryCode: {}
            }
          }
        },
        CreateConfigurationSet: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {},
              Tags: {
                shape: "Sa"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationSetArn: {},
              ConfigurationSetName: {},
              Tags: {
                shape: "Sa"
              },
              CreatedTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        CreateEventDestination: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName",
              "EventDestinationName",
              "MatchingEventTypes"
            ],
            members: {
              ConfigurationSetName: {},
              EventDestinationName: {},
              MatchingEventTypes: {
                shape: "Sj"
              },
              CloudWatchLogsDestination: {
                shape: "Sl"
              },
              KinesisFirehoseDestination: {
                shape: "So"
              },
              SnsDestination: {
                shape: "Sq"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationSetArn: {},
              ConfigurationSetName: {},
              EventDestination: {
                shape: "St"
              }
            }
          }
        },
        CreateOptOutList: {
          input: {
            type: "structure",
            required: [
              "OptOutListName"
            ],
            members: {
              OptOutListName: {},
              Tags: {
                shape: "Sa"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OptOutListArn: {},
              OptOutListName: {},
              Tags: {
                shape: "Sa"
              },
              CreatedTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        CreatePool: {
          input: {
            type: "structure",
            required: [
              "OriginationIdentity",
              "IsoCountryCode",
              "MessageType"
            ],
            members: {
              OriginationIdentity: {},
              IsoCountryCode: {},
              MessageType: {},
              DeletionProtectionEnabled: {
                type: "boolean"
              },
              Tags: {
                shape: "Sa"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PoolArn: {},
              PoolId: {},
              Status: {},
              MessageType: {},
              TwoWayEnabled: {
                type: "boolean"
              },
              TwoWayChannelArn: {},
              TwoWayChannelRole: {},
              SelfManagedOptOutsEnabled: {
                type: "boolean"
              },
              OptOutListName: {},
              SharedRoutesEnabled: {
                type: "boolean"
              },
              DeletionProtectionEnabled: {
                type: "boolean"
              },
              Tags: {
                shape: "Sa"
              },
              CreatedTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        CreateRegistration: {
          input: {
            type: "structure",
            required: [
              "RegistrationType"
            ],
            members: {
              RegistrationType: {},
              Tags: {
                shape: "Sa"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "RegistrationArn",
              "RegistrationId",
              "RegistrationType",
              "RegistrationStatus",
              "CurrentVersionNumber",
              "CreatedTimestamp"
            ],
            members: {
              RegistrationArn: {},
              RegistrationId: {},
              RegistrationType: {},
              RegistrationStatus: {},
              CurrentVersionNumber: {
                type: "long"
              },
              AdditionalAttributes: {
                shape: "S19"
              },
              Tags: {
                shape: "Sa"
              },
              CreatedTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        CreateRegistrationAssociation: {
          input: {
            type: "structure",
            required: [
              "RegistrationId",
              "ResourceId"
            ],
            members: {
              RegistrationId: {},
              ResourceId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "RegistrationArn",
              "RegistrationId",
              "RegistrationType",
              "ResourceArn",
              "ResourceId",
              "ResourceType"
            ],
            members: {
              RegistrationArn: {},
              RegistrationId: {},
              RegistrationType: {},
              ResourceArn: {},
              ResourceId: {},
              ResourceType: {},
              IsoCountryCode: {},
              PhoneNumber: {}
            }
          }
        },
        CreateRegistrationAttachment: {
          input: {
            type: "structure",
            members: {
              AttachmentBody: {
                type: "blob"
              },
              AttachmentUrl: {},
              Tags: {
                shape: "Sa"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "RegistrationAttachmentArn",
              "RegistrationAttachmentId",
              "AttachmentStatus",
              "CreatedTimestamp"
            ],
            members: {
              RegistrationAttachmentArn: {},
              RegistrationAttachmentId: {},
              AttachmentStatus: {},
              Tags: {
                shape: "Sa"
              },
              CreatedTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        CreateRegistrationVersion: {
          input: {
            type: "structure",
            required: [
              "RegistrationId"
            ],
            members: {
              RegistrationId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "RegistrationArn",
              "RegistrationId",
              "VersionNumber",
              "RegistrationVersionStatus",
              "RegistrationVersionStatusHistory"
            ],
            members: {
              RegistrationArn: {},
              RegistrationId: {},
              VersionNumber: {
                type: "long"
              },
              RegistrationVersionStatus: {},
              RegistrationVersionStatusHistory: {
                shape: "S1n"
              }
            }
          }
        },
        CreateVerifiedDestinationNumber: {
          input: {
            type: "structure",
            required: [
              "DestinationPhoneNumber"
            ],
            members: {
              DestinationPhoneNumber: {},
              Tags: {
                shape: "Sa"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "VerifiedDestinationNumberArn",
              "VerifiedDestinationNumberId",
              "DestinationPhoneNumber",
              "Status",
              "CreatedTimestamp"
            ],
            members: {
              VerifiedDestinationNumberArn: {},
              VerifiedDestinationNumberId: {},
              DestinationPhoneNumber: {},
              Status: {},
              Tags: {
                shape: "Sa"
              },
              CreatedTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        DeleteConfigurationSet: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationSetArn: {},
              ConfigurationSetName: {},
              EventDestinations: {
                shape: "S1t"
              },
              DefaultMessageType: {},
              DefaultSenderId: {},
              CreatedTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        DeleteDefaultMessageType: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationSetArn: {},
              ConfigurationSetName: {},
              MessageType: {}
            }
          }
        },
        DeleteDefaultSenderId: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationSetArn: {},
              ConfigurationSetName: {},
              SenderId: {}
            }
          }
        },
        DeleteEventDestination: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName",
              "EventDestinationName"
            ],
            members: {
              ConfigurationSetName: {},
              EventDestinationName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationSetArn: {},
              ConfigurationSetName: {},
              EventDestination: {
                shape: "St"
              }
            }
          }
        },
        DeleteKeyword: {
          input: {
            type: "structure",
            required: [
              "OriginationIdentity",
              "Keyword"
            ],
            members: {
              OriginationIdentity: {},
              Keyword: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OriginationIdentityArn: {},
              OriginationIdentity: {},
              Keyword: {},
              KeywordMessage: {},
              KeywordAction: {}
            }
          }
        },
        DeleteOptOutList: {
          input: {
            type: "structure",
            required: [
              "OptOutListName"
            ],
            members: {
              OptOutListName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OptOutListArn: {},
              OptOutListName: {},
              CreatedTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        DeleteOptedOutNumber: {
          input: {
            type: "structure",
            required: [
              "OptOutListName",
              "OptedOutNumber"
            ],
            members: {
              OptOutListName: {},
              OptedOutNumber: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OptOutListArn: {},
              OptOutListName: {},
              OptedOutNumber: {},
              OptedOutTimestamp: {
                type: "timestamp"
              },
              EndUserOptedOut: {
                type: "boolean"
              }
            }
          }
        },
        DeletePool: {
          input: {
            type: "structure",
            required: [
              "PoolId"
            ],
            members: {
              PoolId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PoolArn: {},
              PoolId: {},
              Status: {},
              MessageType: {},
              TwoWayEnabled: {
                type: "boolean"
              },
              TwoWayChannelArn: {},
              TwoWayChannelRole: {},
              SelfManagedOptOutsEnabled: {
                type: "boolean"
              },
              OptOutListName: {},
              SharedRoutesEnabled: {
                type: "boolean"
              },
              CreatedTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        DeleteRegistration: {
          input: {
            type: "structure",
            required: [
              "RegistrationId"
            ],
            members: {
              RegistrationId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "RegistrationArn",
              "RegistrationId",
              "RegistrationType",
              "RegistrationStatus",
              "CurrentVersionNumber",
              "CreatedTimestamp"
            ],
            members: {
              RegistrationArn: {},
              RegistrationId: {},
              RegistrationType: {},
              RegistrationStatus: {},
              CurrentVersionNumber: {
                type: "long"
              },
              ApprovedVersionNumber: {
                type: "long"
              },
              LatestDeniedVersionNumber: {
                type: "long"
              },
              AdditionalAttributes: {
                shape: "S19"
              },
              CreatedTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        DeleteRegistrationAttachment: {
          input: {
            type: "structure",
            required: [
              "RegistrationAttachmentId"
            ],
            members: {
              RegistrationAttachmentId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "RegistrationAttachmentArn",
              "RegistrationAttachmentId",
              "AttachmentStatus",
              "CreatedTimestamp"
            ],
            members: {
              RegistrationAttachmentArn: {},
              RegistrationAttachmentId: {},
              AttachmentStatus: {},
              AttachmentUploadErrorReason: {},
              CreatedTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        DeleteRegistrationFieldValue: {
          input: {
            type: "structure",
            required: [
              "RegistrationId",
              "FieldPath"
            ],
            members: {
              RegistrationId: {},
              FieldPath: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "RegistrationArn",
              "RegistrationId",
              "VersionNumber",
              "FieldPath"
            ],
            members: {
              RegistrationArn: {},
              RegistrationId: {},
              VersionNumber: {
                type: "long"
              },
              FieldPath: {},
              SelectChoices: {
                shape: "S2n"
              },
              TextValue: {},
              RegistrationAttachmentId: {}
            }
          }
        },
        DeleteTextMessageSpendLimitOverride: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              MonthlyLimit: {
                type: "long"
              }
            }
          }
        },
        DeleteVerifiedDestinationNumber: {
          input: {
            type: "structure",
            required: [
              "VerifiedDestinationNumberId"
            ],
            members: {
              VerifiedDestinationNumberId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "VerifiedDestinationNumberArn",
              "VerifiedDestinationNumberId",
              "DestinationPhoneNumber",
              "CreatedTimestamp"
            ],
            members: {
              VerifiedDestinationNumberArn: {},
              VerifiedDestinationNumberId: {},
              DestinationPhoneNumber: {},
              CreatedTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        DeleteVoiceMessageSpendLimitOverride: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              MonthlyLimit: {
                type: "long"
              }
            }
          }
        },
        DescribeAccountAttributes: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccountAttributes: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Value"
                  ],
                  members: {
                    Name: {},
                    Value: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeAccountLimits: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccountLimits: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Used",
                    "Max"
                  ],
                  members: {
                    Name: {},
                    Used: {
                      type: "long"
                    },
                    Max: {
                      type: "long"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeConfigurationSets: {
          input: {
            type: "structure",
            members: {
              ConfigurationSetNames: {
                type: "list",
                member: {}
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Values"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      shape: "S3g"
                    }
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ConfigurationSetArn",
                    "ConfigurationSetName",
                    "EventDestinations",
                    "CreatedTimestamp"
                  ],
                  members: {
                    ConfigurationSetArn: {},
                    ConfigurationSetName: {},
                    EventDestinations: {
                      shape: "S1t"
                    },
                    DefaultMessageType: {},
                    DefaultSenderId: {},
                    CreatedTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeKeywords: {
          input: {
            type: "structure",
            required: [
              "OriginationIdentity"
            ],
            members: {
              OriginationIdentity: {},
              Keywords: {
                type: "list",
                member: {}
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Values"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      shape: "S3g"
                    }
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OriginationIdentityArn: {},
              OriginationIdentity: {},
              Keywords: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Keyword",
                    "KeywordMessage",
                    "KeywordAction"
                  ],
                  members: {
                    Keyword: {},
                    KeywordMessage: {},
                    KeywordAction: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeOptOutLists: {
          input: {
            type: "structure",
            members: {
              OptOutListNames: {
                type: "list",
                member: {}
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OptOutLists: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "OptOutListArn",
                    "OptOutListName",
                    "CreatedTimestamp"
                  ],
                  members: {
                    OptOutListArn: {},
                    OptOutListName: {},
                    CreatedTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeOptedOutNumbers: {
          input: {
            type: "structure",
            required: [
              "OptOutListName"
            ],
            members: {
              OptOutListName: {},
              OptedOutNumbers: {
                type: "list",
                member: {}
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Values"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      shape: "S3g"
                    }
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OptOutListArn: {},
              OptOutListName: {},
              OptedOutNumbers: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "OptedOutNumber",
                    "OptedOutTimestamp",
                    "EndUserOptedOut"
                  ],
                  members: {
                    OptedOutNumber: {},
                    OptedOutTimestamp: {
                      type: "timestamp"
                    },
                    EndUserOptedOut: {
                      type: "boolean"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribePhoneNumbers: {
          input: {
            type: "structure",
            members: {
              PhoneNumberIds: {
                type: "list",
                member: {}
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Values"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      shape: "S3g"
                    }
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumbers: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "PhoneNumberArn",
                    "PhoneNumber",
                    "Status",
                    "IsoCountryCode",
                    "MessageType",
                    "NumberCapabilities",
                    "NumberType",
                    "MonthlyLeasingPrice",
                    "TwoWayEnabled",
                    "SelfManagedOptOutsEnabled",
                    "OptOutListName",
                    "DeletionProtectionEnabled",
                    "CreatedTimestamp"
                  ],
                  members: {
                    PhoneNumberArn: {},
                    PhoneNumberId: {},
                    PhoneNumber: {},
                    Status: {},
                    IsoCountryCode: {},
                    MessageType: {},
                    NumberCapabilities: {
                      shape: "S4g"
                    },
                    NumberType: {},
                    MonthlyLeasingPrice: {},
                    TwoWayEnabled: {
                      type: "boolean"
                    },
                    TwoWayChannelArn: {},
                    TwoWayChannelRole: {},
                    SelfManagedOptOutsEnabled: {
                      type: "boolean"
                    },
                    OptOutListName: {},
                    DeletionProtectionEnabled: {
                      type: "boolean"
                    },
                    PoolId: {},
                    RegistrationId: {},
                    CreatedTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribePools: {
          input: {
            type: "structure",
            members: {
              PoolIds: {
                type: "list",
                member: {}
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Values"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      shape: "S3g"
                    }
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Pools: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "PoolArn",
                    "PoolId",
                    "Status",
                    "MessageType",
                    "TwoWayEnabled",
                    "SelfManagedOptOutsEnabled",
                    "OptOutListName",
                    "SharedRoutesEnabled",
                    "DeletionProtectionEnabled",
                    "CreatedTimestamp"
                  ],
                  members: {
                    PoolArn: {},
                    PoolId: {},
                    Status: {},
                    MessageType: {},
                    TwoWayEnabled: {
                      type: "boolean"
                    },
                    TwoWayChannelArn: {},
                    TwoWayChannelRole: {},
                    SelfManagedOptOutsEnabled: {
                      type: "boolean"
                    },
                    OptOutListName: {},
                    SharedRoutesEnabled: {
                      type: "boolean"
                    },
                    DeletionProtectionEnabled: {
                      type: "boolean"
                    },
                    CreatedTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeRegistrationAttachments: {
          input: {
            type: "structure",
            members: {
              RegistrationAttachmentIds: {
                type: "list",
                member: {}
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Values"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      shape: "S3g"
                    }
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "RegistrationAttachments"
            ],
            members: {
              RegistrationAttachments: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "RegistrationAttachmentArn",
                    "RegistrationAttachmentId",
                    "AttachmentStatus",
                    "CreatedTimestamp"
                  ],
                  members: {
                    RegistrationAttachmentArn: {},
                    RegistrationAttachmentId: {},
                    AttachmentStatus: {},
                    AttachmentUploadErrorReason: {},
                    CreatedTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeRegistrationFieldDefinitions: {
          input: {
            type: "structure",
            required: [
              "RegistrationType"
            ],
            members: {
              RegistrationType: {},
              SectionPath: {},
              FieldPaths: {
                shape: "S51"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "RegistrationType",
              "RegistrationFieldDefinitions"
            ],
            members: {
              RegistrationType: {},
              RegistrationFieldDefinitions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "SectionPath",
                    "FieldPath",
                    "FieldType",
                    "FieldRequirement",
                    "DisplayHints"
                  ],
                  members: {
                    SectionPath: {},
                    FieldPath: {},
                    FieldType: {},
                    FieldRequirement: {},
                    SelectValidation: {
                      type: "structure",
                      required: [
                        "MinChoices",
                        "MaxChoices",
                        "Options"
                      ],
                      members: {
                        MinChoices: {
                          type: "integer"
                        },
                        MaxChoices: {
                          type: "integer"
                        },
                        Options: {
                          type: "list",
                          member: {}
                        }
                      }
                    },
                    TextValidation: {
                      type: "structure",
                      required: [
                        "MinLength",
                        "MaxLength",
                        "Pattern"
                      ],
                      members: {
                        MinLength: {
                          type: "integer"
                        },
                        MaxLength: {
                          type: "integer"
                        },
                        Pattern: {}
                      }
                    },
                    DisplayHints: {
                      type: "structure",
                      required: [
                        "Title",
                        "ShortDescription"
                      ],
                      members: {
                        Title: {},
                        ShortDescription: {},
                        LongDescription: {},
                        DocumentationTitle: {},
                        DocumentationLink: {},
                        SelectOptionDescriptions: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "Option"
                            ],
                            members: {
                              Option: {},
                              Title: {},
                              Description: {}
                            }
                          }
                        },
                        TextValidationDescription: {},
                        ExampleTextValue: {}
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeRegistrationFieldValues: {
          input: {
            type: "structure",
            required: [
              "RegistrationId"
            ],
            members: {
              RegistrationId: {},
              VersionNumber: {
                type: "long"
              },
              SectionPath: {},
              FieldPaths: {
                shape: "S51"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "RegistrationArn",
              "RegistrationId",
              "VersionNumber",
              "RegistrationFieldValues"
            ],
            members: {
              RegistrationArn: {},
              RegistrationId: {},
              VersionNumber: {
                type: "long"
              },
              RegistrationFieldValues: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "FieldPath"
                  ],
                  members: {
                    FieldPath: {},
                    SelectChoices: {
                      shape: "S2n"
                    },
                    TextValue: {},
                    RegistrationAttachmentId: {},
                    DeniedReason: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeRegistrationSectionDefinitions: {
          input: {
            type: "structure",
            required: [
              "RegistrationType"
            ],
            members: {
              RegistrationType: {},
              SectionPaths: {
                type: "list",
                member: {}
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "RegistrationType",
              "RegistrationSectionDefinitions"
            ],
            members: {
              RegistrationType: {},
              RegistrationSectionDefinitions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "SectionPath",
                    "DisplayHints"
                  ],
                  members: {
                    SectionPath: {},
                    DisplayHints: {
                      type: "structure",
                      required: [
                        "Title",
                        "ShortDescription"
                      ],
                      members: {
                        Title: {},
                        ShortDescription: {},
                        LongDescription: {},
                        DocumentationTitle: {},
                        DocumentationLink: {}
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeRegistrationTypeDefinitions: {
          input: {
            type: "structure",
            members: {
              RegistrationTypes: {
                type: "list",
                member: {}
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Values"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      shape: "S3g"
                    }
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "RegistrationTypeDefinitions"
            ],
            members: {
              RegistrationTypeDefinitions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "RegistrationType",
                    "DisplayHints"
                  ],
                  members: {
                    RegistrationType: {},
                    SupportedAssociations: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "ResourceType",
                          "AssociationBehavior",
                          "DisassociationBehavior"
                        ],
                        members: {
                          ResourceType: {},
                          IsoCountryCode: {},
                          AssociationBehavior: {},
                          DisassociationBehavior: {}
                        }
                      }
                    },
                    DisplayHints: {
                      type: "structure",
                      required: [
                        "Title"
                      ],
                      members: {
                        Title: {},
                        ShortDescription: {},
                        LongDescription: {},
                        DocumentationTitle: {},
                        DocumentationLink: {}
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeRegistrationVersions: {
          input: {
            type: "structure",
            required: [
              "RegistrationId"
            ],
            members: {
              RegistrationId: {},
              VersionNumbers: {
                type: "list",
                member: {
                  type: "long"
                }
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Values"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      shape: "S3g"
                    }
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "RegistrationArn",
              "RegistrationId",
              "RegistrationVersions"
            ],
            members: {
              RegistrationArn: {},
              RegistrationId: {},
              RegistrationVersions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "VersionNumber",
                    "RegistrationVersionStatus",
                    "RegistrationVersionStatusHistory"
                  ],
                  members: {
                    VersionNumber: {
                      type: "long"
                    },
                    RegistrationVersionStatus: {},
                    RegistrationVersionStatusHistory: {
                      shape: "S1n"
                    },
                    DeniedReasons: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "Reason",
                          "ShortDescription"
                        ],
                        members: {
                          Reason: {},
                          ShortDescription: {},
                          LongDescription: {},
                          DocumentationTitle: {},
                          DocumentationLink: {}
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeRegistrations: {
          input: {
            type: "structure",
            members: {
              RegistrationIds: {
                type: "list",
                member: {}
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Values"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      shape: "S3g"
                    }
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Registrations"
            ],
            members: {
              Registrations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "RegistrationArn",
                    "RegistrationId",
                    "RegistrationType",
                    "RegistrationStatus",
                    "CurrentVersionNumber",
                    "CreatedTimestamp"
                  ],
                  members: {
                    RegistrationArn: {},
                    RegistrationId: {},
                    RegistrationType: {},
                    RegistrationStatus: {},
                    CurrentVersionNumber: {
                      type: "long"
                    },
                    ApprovedVersionNumber: {
                      type: "long"
                    },
                    LatestDeniedVersionNumber: {
                      type: "long"
                    },
                    AdditionalAttributes: {
                      shape: "S19"
                    },
                    CreatedTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeSenderIds: {
          input: {
            type: "structure",
            members: {
              SenderIds: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "SenderId",
                    "IsoCountryCode"
                  ],
                  members: {
                    SenderId: {},
                    IsoCountryCode: {}
                  }
                }
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Values"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      shape: "S3g"
                    }
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SenderIds: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "SenderIdArn",
                    "SenderId",
                    "IsoCountryCode",
                    "MessageTypes",
                    "MonthlyLeasingPrice",
                    "DeletionProtectionEnabled",
                    "Registered"
                  ],
                  members: {
                    SenderIdArn: {},
                    SenderId: {},
                    IsoCountryCode: {},
                    MessageTypes: {
                      shape: "S6t"
                    },
                    MonthlyLeasingPrice: {},
                    DeletionProtectionEnabled: {
                      type: "boolean"
                    },
                    Registered: {
                      type: "boolean"
                    },
                    RegistrationId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeSpendLimits: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SpendLimits: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "EnforcedLimit",
                    "MaxLimit",
                    "Overridden"
                  ],
                  members: {
                    Name: {},
                    EnforcedLimit: {
                      type: "long"
                    },
                    MaxLimit: {
                      type: "long"
                    },
                    Overridden: {
                      type: "boolean"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeVerifiedDestinationNumbers: {
          input: {
            type: "structure",
            members: {
              VerifiedDestinationNumberIds: {
                type: "list",
                member: {}
              },
              DestinationPhoneNumbers: {
                type: "list",
                member: {}
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Values"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      shape: "S3g"
                    }
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "VerifiedDestinationNumbers"
            ],
            members: {
              VerifiedDestinationNumbers: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "VerifiedDestinationNumberArn",
                    "VerifiedDestinationNumberId",
                    "DestinationPhoneNumber",
                    "Status",
                    "CreatedTimestamp"
                  ],
                  members: {
                    VerifiedDestinationNumberArn: {},
                    VerifiedDestinationNumberId: {},
                    DestinationPhoneNumber: {},
                    Status: {},
                    CreatedTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DisassociateOriginationIdentity: {
          input: {
            type: "structure",
            required: [
              "PoolId",
              "OriginationIdentity",
              "IsoCountryCode"
            ],
            members: {
              PoolId: {},
              OriginationIdentity: {},
              IsoCountryCode: {},
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PoolArn: {},
              PoolId: {},
              OriginationIdentityArn: {},
              OriginationIdentity: {},
              IsoCountryCode: {}
            }
          }
        },
        DiscardRegistrationVersion: {
          input: {
            type: "structure",
            required: [
              "RegistrationId"
            ],
            members: {
              RegistrationId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "RegistrationArn",
              "RegistrationId",
              "VersionNumber",
              "RegistrationVersionStatus",
              "RegistrationVersionStatusHistory"
            ],
            members: {
              RegistrationArn: {},
              RegistrationId: {},
              VersionNumber: {
                type: "long"
              },
              RegistrationVersionStatus: {},
              RegistrationVersionStatusHistory: {
                shape: "S1n"
              }
            }
          }
        },
        ListPoolOriginationIdentities: {
          input: {
            type: "structure",
            required: [
              "PoolId"
            ],
            members: {
              PoolId: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Values"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      shape: "S3g"
                    }
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PoolArn: {},
              PoolId: {},
              OriginationIdentities: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "OriginationIdentityArn",
                    "OriginationIdentity",
                    "IsoCountryCode",
                    "NumberCapabilities"
                  ],
                  members: {
                    OriginationIdentityArn: {},
                    OriginationIdentity: {},
                    IsoCountryCode: {},
                    NumberCapabilities: {
                      shape: "S4g"
                    },
                    PhoneNumber: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListRegistrationAssociations: {
          input: {
            type: "structure",
            required: [
              "RegistrationId"
            ],
            members: {
              RegistrationId: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Values"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      shape: "S3g"
                    }
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "RegistrationArn",
              "RegistrationId",
              "RegistrationType",
              "RegistrationAssociations"
            ],
            members: {
              RegistrationArn: {},
              RegistrationId: {},
              RegistrationType: {},
              RegistrationAssociations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ResourceArn",
                    "ResourceId",
                    "ResourceType"
                  ],
                  members: {
                    ResourceArn: {},
                    ResourceId: {},
                    ResourceType: {},
                    IsoCountryCode: {},
                    PhoneNumber: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceArn: {},
              Tags: {
                shape: "Sa"
              }
            }
          }
        },
        PutKeyword: {
          input: {
            type: "structure",
            required: [
              "OriginationIdentity",
              "Keyword",
              "KeywordMessage"
            ],
            members: {
              OriginationIdentity: {},
              Keyword: {},
              KeywordMessage: {},
              KeywordAction: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OriginationIdentityArn: {},
              OriginationIdentity: {},
              Keyword: {},
              KeywordMessage: {},
              KeywordAction: {}
            }
          }
        },
        PutOptedOutNumber: {
          input: {
            type: "structure",
            required: [
              "OptOutListName",
              "OptedOutNumber"
            ],
            members: {
              OptOutListName: {},
              OptedOutNumber: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OptOutListArn: {},
              OptOutListName: {},
              OptedOutNumber: {},
              OptedOutTimestamp: {
                type: "timestamp"
              },
              EndUserOptedOut: {
                type: "boolean"
              }
            }
          }
        },
        PutRegistrationFieldValue: {
          input: {
            type: "structure",
            required: [
              "RegistrationId",
              "FieldPath"
            ],
            members: {
              RegistrationId: {},
              FieldPath: {},
              SelectChoices: {
                shape: "S2n"
              },
              TextValue: {},
              RegistrationAttachmentId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "RegistrationArn",
              "RegistrationId",
              "VersionNumber",
              "FieldPath"
            ],
            members: {
              RegistrationArn: {},
              RegistrationId: {},
              VersionNumber: {
                type: "long"
              },
              FieldPath: {},
              SelectChoices: {
                shape: "S2n"
              },
              TextValue: {},
              RegistrationAttachmentId: {}
            }
          }
        },
        ReleasePhoneNumber: {
          input: {
            type: "structure",
            required: [
              "PhoneNumberId"
            ],
            members: {
              PhoneNumberId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberArn: {},
              PhoneNumberId: {},
              PhoneNumber: {},
              Status: {},
              IsoCountryCode: {},
              MessageType: {},
              NumberCapabilities: {
                shape: "S4g"
              },
              NumberType: {},
              MonthlyLeasingPrice: {},
              TwoWayEnabled: {
                type: "boolean"
              },
              TwoWayChannelArn: {},
              TwoWayChannelRole: {},
              SelfManagedOptOutsEnabled: {
                type: "boolean"
              },
              OptOutListName: {},
              RegistrationId: {},
              CreatedTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        ReleaseSenderId: {
          input: {
            type: "structure",
            required: [
              "SenderId",
              "IsoCountryCode"
            ],
            members: {
              SenderId: {},
              IsoCountryCode: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "SenderIdArn",
              "SenderId",
              "IsoCountryCode",
              "MessageTypes",
              "MonthlyLeasingPrice",
              "Registered"
            ],
            members: {
              SenderIdArn: {},
              SenderId: {},
              IsoCountryCode: {},
              MessageTypes: {
                shape: "S6t"
              },
              MonthlyLeasingPrice: {},
              Registered: {
                type: "boolean"
              },
              RegistrationId: {}
            }
          }
        },
        RequestPhoneNumber: {
          input: {
            type: "structure",
            required: [
              "IsoCountryCode",
              "MessageType",
              "NumberCapabilities",
              "NumberType"
            ],
            members: {
              IsoCountryCode: {},
              MessageType: {},
              NumberCapabilities: {
                shape: "S4g"
              },
              NumberType: {},
              OptOutListName: {},
              PoolId: {},
              RegistrationId: {},
              DeletionProtectionEnabled: {
                type: "boolean"
              },
              Tags: {
                shape: "Sa"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberArn: {},
              PhoneNumberId: {},
              PhoneNumber: {},
              Status: {},
              IsoCountryCode: {},
              MessageType: {},
              NumberCapabilities: {
                shape: "S4g"
              },
              NumberType: {},
              MonthlyLeasingPrice: {},
              TwoWayEnabled: {
                type: "boolean"
              },
              TwoWayChannelArn: {},
              TwoWayChannelRole: {},
              SelfManagedOptOutsEnabled: {
                type: "boolean"
              },
              OptOutListName: {},
              DeletionProtectionEnabled: {
                type: "boolean"
              },
              PoolId: {},
              RegistrationId: {},
              Tags: {
                shape: "Sa"
              },
              CreatedTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        RequestSenderId: {
          input: {
            type: "structure",
            required: [
              "SenderId",
              "IsoCountryCode"
            ],
            members: {
              SenderId: {},
              IsoCountryCode: {},
              MessageTypes: {
                shape: "S6t"
              },
              DeletionProtectionEnabled: {
                type: "boolean"
              },
              Tags: {
                shape: "Sa"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "SenderIdArn",
              "SenderId",
              "IsoCountryCode",
              "MessageTypes",
              "MonthlyLeasingPrice",
              "DeletionProtectionEnabled",
              "Registered"
            ],
            members: {
              SenderIdArn: {},
              SenderId: {},
              IsoCountryCode: {},
              MessageTypes: {
                shape: "S6t"
              },
              MonthlyLeasingPrice: {},
              DeletionProtectionEnabled: {
                type: "boolean"
              },
              Registered: {
                type: "boolean"
              },
              Tags: {
                shape: "Sa"
              }
            }
          }
        },
        SendDestinationNumberVerificationCode: {
          input: {
            type: "structure",
            required: [
              "VerifiedDestinationNumberId",
              "VerificationChannel"
            ],
            members: {
              VerifiedDestinationNumberId: {},
              VerificationChannel: {},
              LanguageCode: {},
              OriginationIdentity: {},
              ConfigurationSetName: {},
              Context: {
                shape: "S8c"
              },
              DestinationCountryParameters: {
                shape: "S8f"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "MessageId"
            ],
            members: {
              MessageId: {}
            }
          }
        },
        SendTextMessage: {
          input: {
            type: "structure",
            required: [
              "DestinationPhoneNumber"
            ],
            members: {
              DestinationPhoneNumber: {},
              OriginationIdentity: {},
              MessageBody: {},
              MessageType: {},
              Keyword: {},
              ConfigurationSetName: {},
              MaxPrice: {},
              TimeToLive: {
                type: "integer"
              },
              Context: {
                shape: "S8c"
              },
              DestinationCountryParameters: {
                shape: "S8f"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MessageId: {}
            }
          }
        },
        SendVoiceMessage: {
          input: {
            type: "structure",
            required: [
              "DestinationPhoneNumber",
              "OriginationIdentity"
            ],
            members: {
              DestinationPhoneNumber: {},
              OriginationIdentity: {},
              MessageBody: {},
              MessageBodyTextType: {},
              VoiceId: {},
              ConfigurationSetName: {},
              MaxPricePerMinute: {},
              TimeToLive: {
                type: "integer"
              },
              Context: {
                shape: "S8c"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MessageId: {}
            }
          }
        },
        SetDefaultMessageType: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName",
              "MessageType"
            ],
            members: {
              ConfigurationSetName: {},
              MessageType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationSetArn: {},
              ConfigurationSetName: {},
              MessageType: {}
            }
          }
        },
        SetDefaultSenderId: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName",
              "SenderId"
            ],
            members: {
              ConfigurationSetName: {},
              SenderId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationSetArn: {},
              ConfigurationSetName: {},
              SenderId: {}
            }
          }
        },
        SetTextMessageSpendLimitOverride: {
          input: {
            type: "structure",
            required: [
              "MonthlyLimit"
            ],
            members: {
              MonthlyLimit: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MonthlyLimit: {
                type: "long"
              }
            }
          }
        },
        SetVoiceMessageSpendLimitOverride: {
          input: {
            type: "structure",
            required: [
              "MonthlyLimit"
            ],
            members: {
              MonthlyLimit: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MonthlyLimit: {
                type: "long"
              }
            }
          }
        },
        SubmitRegistrationVersion: {
          input: {
            type: "structure",
            required: [
              "RegistrationId"
            ],
            members: {
              RegistrationId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "RegistrationArn",
              "RegistrationId",
              "VersionNumber",
              "RegistrationVersionStatus",
              "RegistrationVersionStatusHistory"
            ],
            members: {
              RegistrationArn: {},
              RegistrationId: {},
              VersionNumber: {
                type: "long"
              },
              RegistrationVersionStatus: {},
              RegistrationVersionStatusHistory: {
                shape: "S1n"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                type: "list",
                member: {
                  shape: "Sb"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateEventDestination: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName",
              "EventDestinationName"
            ],
            members: {
              ConfigurationSetName: {},
              EventDestinationName: {},
              Enabled: {
                type: "boolean"
              },
              MatchingEventTypes: {
                shape: "Sj"
              },
              CloudWatchLogsDestination: {
                shape: "Sl"
              },
              KinesisFirehoseDestination: {
                shape: "So"
              },
              SnsDestination: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationSetArn: {},
              ConfigurationSetName: {},
              EventDestination: {
                shape: "St"
              }
            }
          }
        },
        UpdatePhoneNumber: {
          input: {
            type: "structure",
            required: [
              "PhoneNumberId"
            ],
            members: {
              PhoneNumberId: {},
              TwoWayEnabled: {
                type: "boolean"
              },
              TwoWayChannelArn: {},
              TwoWayChannelRole: {},
              SelfManagedOptOutsEnabled: {
                type: "boolean"
              },
              OptOutListName: {},
              DeletionProtectionEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberArn: {},
              PhoneNumberId: {},
              PhoneNumber: {},
              Status: {},
              IsoCountryCode: {},
              MessageType: {},
              NumberCapabilities: {
                shape: "S4g"
              },
              NumberType: {},
              MonthlyLeasingPrice: {},
              TwoWayEnabled: {
                type: "boolean"
              },
              TwoWayChannelArn: {},
              TwoWayChannelRole: {},
              SelfManagedOptOutsEnabled: {
                type: "boolean"
              },
              OptOutListName: {},
              DeletionProtectionEnabled: {
                type: "boolean"
              },
              RegistrationId: {},
              CreatedTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        UpdatePool: {
          input: {
            type: "structure",
            required: [
              "PoolId"
            ],
            members: {
              PoolId: {},
              TwoWayEnabled: {
                type: "boolean"
              },
              TwoWayChannelArn: {},
              TwoWayChannelRole: {},
              SelfManagedOptOutsEnabled: {
                type: "boolean"
              },
              OptOutListName: {},
              SharedRoutesEnabled: {
                type: "boolean"
              },
              DeletionProtectionEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PoolArn: {},
              PoolId: {},
              Status: {},
              MessageType: {},
              TwoWayEnabled: {
                type: "boolean"
              },
              TwoWayChannelArn: {},
              TwoWayChannelRole: {},
              SelfManagedOptOutsEnabled: {
                type: "boolean"
              },
              OptOutListName: {},
              SharedRoutesEnabled: {
                type: "boolean"
              },
              DeletionProtectionEnabled: {
                type: "boolean"
              },
              CreatedTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        UpdateSenderId: {
          input: {
            type: "structure",
            required: [
              "SenderId",
              "IsoCountryCode"
            ],
            members: {
              SenderId: {},
              IsoCountryCode: {},
              DeletionProtectionEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "SenderIdArn",
              "SenderId",
              "IsoCountryCode",
              "MessageTypes",
              "MonthlyLeasingPrice",
              "DeletionProtectionEnabled",
              "Registered"
            ],
            members: {
              SenderIdArn: {},
              SenderId: {},
              IsoCountryCode: {},
              MessageTypes: {
                shape: "S6t"
              },
              MonthlyLeasingPrice: {},
              DeletionProtectionEnabled: {
                type: "boolean"
              },
              Registered: {
                type: "boolean"
              },
              RegistrationId: {}
            }
          }
        },
        VerifyDestinationNumber: {
          input: {
            type: "structure",
            required: [
              "VerifiedDestinationNumberId",
              "VerificationCode"
            ],
            members: {
              VerifiedDestinationNumberId: {},
              VerificationCode: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "VerifiedDestinationNumberArn",
              "VerifiedDestinationNumberId",
              "DestinationPhoneNumber",
              "Status",
              "CreatedTimestamp"
            ],
            members: {
              VerifiedDestinationNumberArn: {},
              VerifiedDestinationNumberId: {},
              DestinationPhoneNumber: {},
              Status: {},
              CreatedTimestamp: {
                type: "timestamp"
              }
            }
          }
        }
      },
      shapes: {
        Sa: {
          type: "list",
          member: {
            shape: "Sb"
          }
        },
        Sb: {
          type: "structure",
          required: [
            "Key",
            "Value"
          ],
          members: {
            Key: {},
            Value: {}
          }
        },
        Sj: {
          type: "list",
          member: {}
        },
        Sl: {
          type: "structure",
          required: [
            "IamRoleArn",
            "LogGroupArn"
          ],
          members: {
            IamRoleArn: {},
            LogGroupArn: {}
          }
        },
        So: {
          type: "structure",
          required: [
            "IamRoleArn",
            "DeliveryStreamArn"
          ],
          members: {
            IamRoleArn: {},
            DeliveryStreamArn: {}
          }
        },
        Sq: {
          type: "structure",
          required: [
            "TopicArn"
          ],
          members: {
            TopicArn: {}
          }
        },
        St: {
          type: "structure",
          required: [
            "EventDestinationName",
            "Enabled",
            "MatchingEventTypes"
          ],
          members: {
            EventDestinationName: {},
            Enabled: {
              type: "boolean"
            },
            MatchingEventTypes: {
              shape: "Sj"
            },
            CloudWatchLogsDestination: {
              shape: "Sl"
            },
            KinesisFirehoseDestination: {
              shape: "So"
            },
            SnsDestination: {
              shape: "Sq"
            }
          }
        },
        S19: {
          type: "map",
          key: {},
          value: {}
        },
        S1n: {
          type: "structure",
          required: [
            "DraftTimestamp"
          ],
          members: {
            DraftTimestamp: {
              type: "timestamp"
            },
            SubmittedTimestamp: {
              type: "timestamp"
            },
            ReviewingTimestamp: {
              type: "timestamp"
            },
            ApprovedTimestamp: {
              type: "timestamp"
            },
            DiscardedTimestamp: {
              type: "timestamp"
            },
            DeniedTimestamp: {
              type: "timestamp"
            },
            RevokedTimestamp: {
              type: "timestamp"
            },
            ArchivedTimestamp: {
              type: "timestamp"
            }
          }
        },
        S1t: {
          type: "list",
          member: {
            shape: "St"
          }
        },
        S2n: {
          type: "list",
          member: {}
        },
        S3g: {
          type: "list",
          member: {}
        },
        S4g: {
          type: "list",
          member: {}
        },
        S51: {
          type: "list",
          member: {}
        },
        S6t: {
          type: "list",
          member: {}
        },
        S8c: {
          type: "map",
          key: {},
          value: {}
        },
        S8f: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/pinpoint-sms-voice-v2-2022-03-31.paginators.json
var require_pinpoint_sms_voice_v2_2022_03_31_paginators = __commonJS({
  "node_modules/aws-sdk/apis/pinpoint-sms-voice-v2-2022-03-31.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        DescribeAccountAttributes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AccountAttributes"
        },
        DescribeAccountLimits: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AccountLimits"
        },
        DescribeConfigurationSets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ConfigurationSets"
        },
        DescribeKeywords: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Keywords"
        },
        DescribeOptOutLists: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "OptOutLists"
        },
        DescribeOptedOutNumbers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "OptedOutNumbers"
        },
        DescribePhoneNumbers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "PhoneNumbers"
        },
        DescribePools: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Pools"
        },
        DescribeRegistrationAttachments: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "RegistrationAttachments"
        },
        DescribeRegistrationFieldDefinitions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "RegistrationFieldDefinitions"
        },
        DescribeRegistrationFieldValues: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "RegistrationFieldValues"
        },
        DescribeRegistrationSectionDefinitions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "RegistrationSectionDefinitions"
        },
        DescribeRegistrationTypeDefinitions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "RegistrationTypeDefinitions"
        },
        DescribeRegistrationVersions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "RegistrationVersions"
        },
        DescribeRegistrations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Registrations"
        },
        DescribeSenderIds: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "SenderIds"
        },
        DescribeSpendLimits: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "SpendLimits"
        },
        DescribeVerifiedDestinationNumbers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "VerifiedDestinationNumbers"
        },
        ListPoolOriginationIdentities: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "OriginationIdentities"
        },
        ListRegistrationAssociations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "RegistrationAssociations"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/pinpoint-sms-voice-v2-2022-03-31.waiters2.json
var require_pinpoint_sms_voice_v2_2022_03_31_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/pinpoint-sms-voice-v2-2022-03-31.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {}
    };
  }
});

// node_modules/aws-sdk/clients/pinpointsmsvoicev2.js
var require_pinpointsmsvoicev2 = __commonJS({
  "node_modules/aws-sdk/clients/pinpointsmsvoicev2.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["pinpointsmsvoicev2"] = {};
    AWS2.PinpointSMSVoiceV2 = Service.defineService("pinpointsmsvoicev2", ["2022-03-31"]);
    Object.defineProperty(apiLoader.services["pinpointsmsvoicev2"], "2022-03-31", {
      get: function get() {
        var model = require_pinpoint_sms_voice_v2_2022_03_31_min();
        model.paginators = require_pinpoint_sms_voice_v2_2022_03_31_paginators().pagination;
        model.waiters = require_pinpoint_sms_voice_v2_2022_03_31_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.PinpointSMSVoiceV2;
  }
});

// node_modules/aws-sdk/apis/ivschat-2020-07-14.min.json
var require_ivschat_2020_07_14_min = __commonJS({
  "node_modules/aws-sdk/apis/ivschat-2020-07-14.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-07-14",
        endpointPrefix: "ivschat",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "ivschat",
        serviceFullName: "Amazon Interactive Video Service Chat",
        serviceId: "ivschat",
        signatureVersion: "v4",
        signingName: "ivschat",
        uid: "ivschat-2020-07-14"
      },
      operations: {
        CreateChatToken: {
          http: {
            requestUri: "/CreateChatToken",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "roomIdentifier",
              "userId"
            ],
            members: {
              attributes: {
                type: "map",
                key: {},
                value: {},
                sensitive: true
              },
              capabilities: {
                type: "list",
                member: {}
              },
              roomIdentifier: {},
              sessionDurationInMinutes: {
                type: "integer"
              },
              userId: {
                shape: "S8"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              sessionExpirationTime: {
                shape: "Sa"
              },
              token: {
                type: "string",
                sensitive: true
              },
              tokenExpirationTime: {
                shape: "Sa"
              }
            }
          }
        },
        CreateLoggingConfiguration: {
          http: {
            requestUri: "/CreateLoggingConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "destinationConfiguration"
            ],
            members: {
              destinationConfiguration: {
                shape: "Sd"
              },
              name: {},
              tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              createTime: {
                shape: "Sa"
              },
              destinationConfiguration: {
                shape: "Sd"
              },
              id: {},
              name: {},
              state: {},
              tags: {
                shape: "Sl"
              },
              updateTime: {
                shape: "Sa"
              }
            }
          }
        },
        CreateRoom: {
          http: {
            requestUri: "/CreateRoom",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              loggingConfigurationIdentifiers: {
                shape: "St"
              },
              maximumMessageLength: {
                type: "integer"
              },
              maximumMessageRatePerSecond: {
                type: "integer"
              },
              messageReviewHandler: {
                shape: "Sx"
              },
              name: {},
              tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              createTime: {
                shape: "Sa"
              },
              id: {},
              loggingConfigurationIdentifiers: {
                shape: "St"
              },
              maximumMessageLength: {
                type: "integer"
              },
              maximumMessageRatePerSecond: {
                type: "integer"
              },
              messageReviewHandler: {
                shape: "Sx"
              },
              name: {},
              tags: {
                shape: "Sl"
              },
              updateTime: {
                shape: "Sa"
              }
            }
          }
        },
        DeleteLoggingConfiguration: {
          http: {
            requestUri: "/DeleteLoggingConfiguration",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "identifier"
            ],
            members: {
              identifier: {}
            }
          }
        },
        DeleteMessage: {
          http: {
            requestUri: "/DeleteMessage",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id",
              "roomIdentifier"
            ],
            members: {
              id: {},
              reason: {},
              roomIdentifier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              id: {}
            }
          }
        },
        DeleteRoom: {
          http: {
            requestUri: "/DeleteRoom",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "identifier"
            ],
            members: {
              identifier: {}
            }
          }
        },
        DisconnectUser: {
          http: {
            requestUri: "/DisconnectUser",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "roomIdentifier",
              "userId"
            ],
            members: {
              reason: {},
              roomIdentifier: {},
              userId: {
                shape: "S8"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetLoggingConfiguration: {
          http: {
            requestUri: "/GetLoggingConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "identifier"
            ],
            members: {
              identifier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              createTime: {
                shape: "Sa"
              },
              destinationConfiguration: {
                shape: "Sd"
              },
              id: {},
              name: {},
              state: {},
              tags: {
                shape: "Sl"
              },
              updateTime: {
                shape: "Sa"
              }
            }
          }
        },
        GetRoom: {
          http: {
            requestUri: "/GetRoom",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "identifier"
            ],
            members: {
              identifier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              createTime: {
                shape: "Sa"
              },
              id: {},
              loggingConfigurationIdentifiers: {
                shape: "St"
              },
              maximumMessageLength: {
                type: "integer"
              },
              maximumMessageRatePerSecond: {
                type: "integer"
              },
              messageReviewHandler: {
                shape: "Sx"
              },
              name: {},
              tags: {
                shape: "Sl"
              },
              updateTime: {
                shape: "Sa"
              }
            }
          }
        },
        ListLoggingConfigurations: {
          http: {
            requestUri: "/ListLoggingConfigurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "loggingConfigurations"
            ],
            members: {
              loggingConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    createTime: {
                      shape: "Sa"
                    },
                    destinationConfiguration: {
                      shape: "Sd"
                    },
                    id: {},
                    name: {},
                    state: {},
                    tags: {
                      shape: "Sl"
                    },
                    updateTime: {
                      shape: "Sa"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListRooms: {
          http: {
            requestUri: "/ListRooms",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              loggingConfigurationIdentifier: {},
              maxResults: {
                type: "integer"
              },
              messageReviewHandlerUri: {},
              name: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "rooms"
            ],
            members: {
              nextToken: {},
              rooms: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    createTime: {
                      shape: "Sa"
                    },
                    id: {},
                    loggingConfigurationIdentifiers: {
                      shape: "St"
                    },
                    messageReviewHandler: {
                      shape: "Sx"
                    },
                    name: {},
                    tags: {
                      shape: "Sl"
                    },
                    updateTime: {
                      shape: "Sa"
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "tags"
            ],
            members: {
              tags: {
                shape: "Sl"
              }
            }
          }
        },
        SendEvent: {
          http: {
            requestUri: "/SendEvent",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "eventName",
              "roomIdentifier"
            ],
            members: {
              attributes: {
                type: "map",
                key: {},
                value: {}
              },
              eventName: {},
              roomIdentifier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              id: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateLoggingConfiguration: {
          http: {
            requestUri: "/UpdateLoggingConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "identifier"
            ],
            members: {
              destinationConfiguration: {
                shape: "Sd"
              },
              identifier: {},
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              createTime: {
                shape: "Sa"
              },
              destinationConfiguration: {
                shape: "Sd"
              },
              id: {},
              name: {},
              state: {},
              tags: {
                shape: "Sl"
              },
              updateTime: {
                shape: "Sa"
              }
            }
          }
        },
        UpdateRoom: {
          http: {
            requestUri: "/UpdateRoom",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "identifier"
            ],
            members: {
              identifier: {},
              loggingConfigurationIdentifiers: {
                shape: "St"
              },
              maximumMessageLength: {
                type: "integer"
              },
              maximumMessageRatePerSecond: {
                type: "integer"
              },
              messageReviewHandler: {
                shape: "Sx"
              },
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              createTime: {
                shape: "Sa"
              },
              id: {},
              loggingConfigurationIdentifiers: {
                shape: "St"
              },
              maximumMessageLength: {
                type: "integer"
              },
              maximumMessageRatePerSecond: {
                type: "integer"
              },
              messageReviewHandler: {
                shape: "Sx"
              },
              name: {},
              tags: {
                shape: "Sl"
              },
              updateTime: {
                shape: "Sa"
              }
            }
          }
        }
      },
      shapes: {
        S8: {
          type: "string",
          sensitive: true
        },
        Sa: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        Sd: {
          type: "structure",
          members: {
            cloudWatchLogs: {
              type: "structure",
              required: [
                "logGroupName"
              ],
              members: {
                logGroupName: {}
              }
            },
            firehose: {
              type: "structure",
              required: [
                "deliveryStreamName"
              ],
              members: {
                deliveryStreamName: {}
              }
            },
            s3: {
              type: "structure",
              required: [
                "bucketName"
              ],
              members: {
                bucketName: {}
              }
            }
          },
          union: true
        },
        Sl: {
          type: "map",
          key: {},
          value: {}
        },
        St: {
          type: "list",
          member: {}
        },
        Sx: {
          type: "structure",
          members: {
            fallbackResult: {},
            uri: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ivschat-2020-07-14.paginators.json
var require_ivschat_2020_07_14_paginators = __commonJS({
  "node_modules/aws-sdk/apis/ivschat-2020-07-14.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListLoggingConfigurations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListRooms: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/ivschat.js
var require_ivschat = __commonJS({
  "node_modules/aws-sdk/clients/ivschat.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["ivschat"] = {};
    AWS2.Ivschat = Service.defineService("ivschat", ["2020-07-14"]);
    Object.defineProperty(apiLoader.services["ivschat"], "2020-07-14", {
      get: function get() {
        var model = require_ivschat_2020_07_14_min();
        model.paginators = require_ivschat_2020_07_14_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Ivschat;
  }
});

// node_modules/aws-sdk/apis/chime-sdk-media-pipelines-2021-07-15.min.json
var require_chime_sdk_media_pipelines_2021_07_15_min = __commonJS({
  "node_modules/aws-sdk/apis/chime-sdk-media-pipelines-2021-07-15.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-07-15",
        endpointPrefix: "media-pipelines-chime",
        protocol: "rest-json",
        serviceFullName: "Amazon Chime SDK Media Pipelines",
        serviceId: "Chime SDK Media Pipelines",
        signatureVersion: "v4",
        signingName: "chime",
        uid: "chime-sdk-media-pipelines-2021-07-15"
      },
      operations: {
        CreateMediaCapturePipeline: {
          http: {
            requestUri: "/sdk-media-capture-pipelines",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "SourceType",
              "SourceArn",
              "SinkType",
              "SinkArn"
            ],
            members: {
              SourceType: {},
              SourceArn: {
                shape: "S3"
              },
              SinkType: {},
              SinkArn: {
                shape: "S3"
              },
              ClientRequestToken: {
                shape: "S5",
                idempotencyToken: true
              },
              ChimeSdkMeetingConfiguration: {
                shape: "S6"
              },
              Tags: {
                shape: "S17"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MediaCapturePipeline: {
                shape: "S1c"
              }
            }
          }
        },
        CreateMediaConcatenationPipeline: {
          http: {
            requestUri: "/sdk-media-concatenation-pipelines",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Sources",
              "Sinks"
            ],
            members: {
              Sources: {
                shape: "S1h"
              },
              Sinks: {
                shape: "S1w"
              },
              ClientRequestToken: {
                shape: "S5",
                idempotencyToken: true
              },
              Tags: {
                shape: "S17"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MediaConcatenationPipeline: {
                shape: "S21"
              }
            }
          }
        },
        CreateMediaInsightsPipeline: {
          http: {
            requestUri: "/media-insights-pipelines",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "MediaInsightsPipelineConfigurationArn"
            ],
            members: {
              MediaInsightsPipelineConfigurationArn: {
                shape: "S3"
              },
              KinesisVideoStreamSourceRuntimeConfiguration: {
                shape: "S23"
              },
              MediaInsightsRuntimeMetadata: {
                shape: "S2g"
              },
              KinesisVideoStreamRecordingSourceRuntimeConfiguration: {
                shape: "S2j"
              },
              S3RecordingSinkRuntimeConfiguration: {
                shape: "S2q"
              },
              Tags: {
                shape: "S17"
              },
              ClientRequestToken: {
                shape: "S5",
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "MediaInsightsPipeline"
            ],
            members: {
              MediaInsightsPipeline: {
                shape: "S2t"
              }
            }
          }
        },
        CreateMediaInsightsPipelineConfiguration: {
          http: {
            requestUri: "/media-insights-pipeline-configurations",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "MediaInsightsPipelineConfigurationName",
              "ResourceAccessRoleArn",
              "Elements"
            ],
            members: {
              MediaInsightsPipelineConfigurationName: {},
              ResourceAccessRoleArn: {
                shape: "S3"
              },
              RealTimeAlertConfiguration: {
                shape: "S30"
              },
              Elements: {
                shape: "S3d"
              },
              Tags: {
                shape: "S17"
              },
              ClientRequestToken: {
                shape: "S5",
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MediaInsightsPipelineConfiguration: {
                shape: "S45"
              }
            }
          }
        },
        CreateMediaLiveConnectorPipeline: {
          http: {
            requestUri: "/sdk-media-live-connector-pipelines",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Sources",
              "Sinks"
            ],
            members: {
              Sources: {
                shape: "S47"
              },
              Sinks: {
                shape: "S4c"
              },
              ClientRequestToken: {
                shape: "S5",
                idempotencyToken: true
              },
              Tags: {
                shape: "S17"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MediaLiveConnectorPipeline: {
                shape: "S4k"
              }
            }
          }
        },
        CreateMediaPipelineKinesisVideoStreamPool: {
          http: {
            requestUri: "/media-pipeline-kinesis-video-stream-pools",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "StreamConfiguration",
              "PoolName"
            ],
            members: {
              StreamConfiguration: {
                shape: "S4m"
              },
              PoolName: {},
              ClientRequestToken: {
                shape: "S5",
                idempotencyToken: true
              },
              Tags: {
                shape: "S17"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KinesisVideoStreamPoolConfiguration: {
                shape: "S4r"
              }
            }
          }
        },
        CreateMediaStreamPipeline: {
          http: {
            requestUri: "/sdk-media-stream-pipelines",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Sources",
              "Sinks"
            ],
            members: {
              Sources: {
                shape: "S4w"
              },
              Sinks: {
                shape: "S4y"
              },
              ClientRequestToken: {
                shape: "S5",
                idempotencyToken: true
              },
              Tags: {
                shape: "S17"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MediaStreamPipeline: {
                shape: "S54"
              }
            }
          }
        },
        DeleteMediaCapturePipeline: {
          http: {
            method: "DELETE",
            requestUri: "/sdk-media-capture-pipelines/{mediaPipelineId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "MediaPipelineId"
            ],
            members: {
              MediaPipelineId: {
                location: "uri",
                locationName: "mediaPipelineId"
              }
            }
          }
        },
        DeleteMediaInsightsPipelineConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/media-insights-pipeline-configurations/{identifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Identifier"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          }
        },
        DeleteMediaPipeline: {
          http: {
            method: "DELETE",
            requestUri: "/sdk-media-pipelines/{mediaPipelineId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "MediaPipelineId"
            ],
            members: {
              MediaPipelineId: {
                location: "uri",
                locationName: "mediaPipelineId"
              }
            }
          }
        },
        DeleteMediaPipelineKinesisVideoStreamPool: {
          http: {
            method: "DELETE",
            requestUri: "/media-pipeline-kinesis-video-stream-pools/{identifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Identifier"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          }
        },
        GetMediaCapturePipeline: {
          http: {
            method: "GET",
            requestUri: "/sdk-media-capture-pipelines/{mediaPipelineId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MediaPipelineId"
            ],
            members: {
              MediaPipelineId: {
                location: "uri",
                locationName: "mediaPipelineId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MediaCapturePipeline: {
                shape: "S1c"
              }
            }
          }
        },
        GetMediaInsightsPipelineConfiguration: {
          http: {
            method: "GET",
            requestUri: "/media-insights-pipeline-configurations/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Identifier"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MediaInsightsPipelineConfiguration: {
                shape: "S45"
              }
            }
          }
        },
        GetMediaPipeline: {
          http: {
            method: "GET",
            requestUri: "/sdk-media-pipelines/{mediaPipelineId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MediaPipelineId"
            ],
            members: {
              MediaPipelineId: {
                location: "uri",
                locationName: "mediaPipelineId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MediaPipeline: {
                type: "structure",
                members: {
                  MediaCapturePipeline: {
                    shape: "S1c"
                  },
                  MediaLiveConnectorPipeline: {
                    shape: "S4k"
                  },
                  MediaConcatenationPipeline: {
                    shape: "S21"
                  },
                  MediaInsightsPipeline: {
                    shape: "S2t"
                  },
                  MediaStreamPipeline: {
                    shape: "S54"
                  }
                }
              }
            }
          }
        },
        GetMediaPipelineKinesisVideoStreamPool: {
          http: {
            method: "GET",
            requestUri: "/media-pipeline-kinesis-video-stream-pools/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Identifier"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KinesisVideoStreamPoolConfiguration: {
                shape: "S4r"
              }
            }
          }
        },
        GetSpeakerSearchTask: {
          http: {
            method: "GET",
            requestUri: "/media-insights-pipelines/{identifier}/speaker-search-tasks/{speakerSearchTaskId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Identifier",
              "SpeakerSearchTaskId"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "identifier"
              },
              SpeakerSearchTaskId: {
                location: "uri",
                locationName: "speakerSearchTaskId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SpeakerSearchTask: {
                shape: "S5k"
              }
            }
          }
        },
        GetVoiceToneAnalysisTask: {
          http: {
            method: "GET",
            requestUri: "/media-insights-pipelines/{identifier}/voice-tone-analysis-tasks/{voiceToneAnalysisTaskId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Identifier",
              "VoiceToneAnalysisTaskId"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "identifier"
              },
              VoiceToneAnalysisTaskId: {
                location: "uri",
                locationName: "voiceToneAnalysisTaskId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceToneAnalysisTask: {
                shape: "S5o"
              }
            }
          }
        },
        ListMediaCapturePipelines: {
          http: {
            method: "GET",
            requestUri: "/sdk-media-capture-pipelines",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MediaCapturePipelines: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MediaPipelineId: {},
                    MediaPipelineArn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListMediaInsightsPipelineConfigurations: {
          http: {
            method: "GET",
            requestUri: "/media-insights-pipeline-configurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MediaInsightsPipelineConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MediaInsightsPipelineConfigurationName: {},
                    MediaInsightsPipelineConfigurationId: {},
                    MediaInsightsPipelineConfigurationArn: {
                      shape: "S3"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListMediaPipelineKinesisVideoStreamPools: {
          http: {
            method: "GET",
            requestUri: "/media-pipeline-kinesis-video-stream-pools",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KinesisVideoStreamPools: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PoolName: {},
                    PoolId: {},
                    PoolArn: {
                      shape: "S3"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListMediaPipelines: {
          http: {
            method: "GET",
            requestUri: "/sdk-media-pipelines",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MediaPipelines: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MediaPipelineId: {},
                    MediaPipelineArn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {
                location: "querystring",
                locationName: "arn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S17"
              }
            }
          }
        },
        StartSpeakerSearchTask: {
          http: {
            requestUri: "/media-insights-pipelines/{identifier}/speaker-search-tasks?operation=start",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Identifier",
              "VoiceProfileDomainArn"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "identifier"
              },
              VoiceProfileDomainArn: {
                shape: "S3"
              },
              KinesisVideoStreamSourceTaskConfiguration: {
                shape: "S69"
              },
              ClientRequestToken: {
                shape: "S5",
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SpeakerSearchTask: {
                shape: "S5k"
              }
            }
          }
        },
        StartVoiceToneAnalysisTask: {
          http: {
            requestUri: "/media-insights-pipelines/{identifier}/voice-tone-analysis-tasks?operation=start",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Identifier",
              "LanguageCode"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "identifier"
              },
              LanguageCode: {},
              KinesisVideoStreamSourceTaskConfiguration: {
                shape: "S69"
              },
              ClientRequestToken: {
                shape: "S5",
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceToneAnalysisTask: {
                shape: "S5o"
              }
            }
          }
        },
        StopSpeakerSearchTask: {
          http: {
            requestUri: "/media-insights-pipelines/{identifier}/speaker-search-tasks/{speakerSearchTaskId}?operation=stop",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Identifier",
              "SpeakerSearchTaskId"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "identifier"
              },
              SpeakerSearchTaskId: {
                location: "uri",
                locationName: "speakerSearchTaskId"
              }
            }
          }
        },
        StopVoiceToneAnalysisTask: {
          http: {
            requestUri: "/media-insights-pipelines/{identifier}/voice-tone-analysis-tasks/{voiceToneAnalysisTaskId}?operation=stop",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Identifier",
              "VoiceToneAnalysisTaskId"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "identifier"
              },
              VoiceToneAnalysisTaskId: {
                location: "uri",
                locationName: "voiceToneAnalysisTaskId"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags?operation=tag-resource",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S17"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            requestUri: "/tags?operation=untag-resource",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateMediaInsightsPipelineConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/media-insights-pipeline-configurations/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Identifier",
              "ResourceAccessRoleArn",
              "Elements"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "identifier"
              },
              ResourceAccessRoleArn: {
                shape: "S3"
              },
              RealTimeAlertConfiguration: {
                shape: "S30"
              },
              Elements: {
                shape: "S3d"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MediaInsightsPipelineConfiguration: {
                shape: "S45"
              }
            }
          }
        },
        UpdateMediaInsightsPipelineStatus: {
          http: {
            method: "PUT",
            requestUri: "/media-insights-pipeline-status/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Identifier",
              "UpdateStatus"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "identifier"
              },
              UpdateStatus: {}
            }
          }
        },
        UpdateMediaPipelineKinesisVideoStreamPool: {
          http: {
            method: "PUT",
            requestUri: "/media-pipeline-kinesis-video-stream-pools/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Identifier"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "identifier"
              },
              StreamConfiguration: {
                type: "structure",
                members: {
                  DataRetentionInHours: {
                    type: "integer"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KinesisVideoStreamPoolConfiguration: {
                shape: "S4r"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "string",
          sensitive: true
        },
        S5: {
          type: "string",
          sensitive: true
        },
        S6: {
          type: "structure",
          members: {
            SourceConfiguration: {
              shape: "S7"
            },
            ArtifactsConfiguration: {
              type: "structure",
              required: [
                "Audio",
                "Video",
                "Content"
              ],
              members: {
                Audio: {
                  type: "structure",
                  required: [
                    "MuxType"
                  ],
                  members: {
                    MuxType: {}
                  }
                },
                Video: {
                  type: "structure",
                  required: [
                    "State"
                  ],
                  members: {
                    State: {},
                    MuxType: {}
                  }
                },
                Content: {
                  type: "structure",
                  required: [
                    "State"
                  ],
                  members: {
                    State: {},
                    MuxType: {}
                  }
                },
                CompositedVideo: {
                  shape: "Sl"
                }
              }
            }
          }
        },
        S7: {
          type: "structure",
          members: {
            SelectedVideoStreams: {
              type: "structure",
              members: {
                AttendeeIds: {
                  type: "list",
                  member: {}
                },
                ExternalUserIds: {
                  type: "list",
                  member: {
                    type: "string",
                    sensitive: true
                  }
                }
              }
            }
          }
        },
        Sl: {
          type: "structure",
          required: [
            "GridViewConfiguration"
          ],
          members: {
            Layout: {},
            Resolution: {},
            GridViewConfiguration: {
              type: "structure",
              required: [
                "ContentShareLayout"
              ],
              members: {
                ContentShareLayout: {},
                PresenterOnlyConfiguration: {
                  type: "structure",
                  members: {
                    PresenterPosition: {}
                  }
                },
                ActiveSpeakerOnlyConfiguration: {
                  type: "structure",
                  members: {
                    ActiveSpeakerPosition: {}
                  }
                },
                HorizontalLayoutConfiguration: {
                  type: "structure",
                  members: {
                    TileOrder: {},
                    TilePosition: {},
                    TileCount: {
                      type: "integer"
                    },
                    TileAspectRatio: {}
                  }
                },
                VerticalLayoutConfiguration: {
                  type: "structure",
                  members: {
                    TileOrder: {},
                    TilePosition: {},
                    TileCount: {
                      type: "integer"
                    },
                    TileAspectRatio: {}
                  }
                },
                VideoAttribute: {
                  type: "structure",
                  members: {
                    CornerRadius: {
                      type: "integer"
                    },
                    BorderColor: {},
                    HighlightColor: {},
                    BorderThickness: {
                      type: "integer"
                    }
                  }
                },
                CanvasOrientation: {}
              }
            }
          }
        },
        S17: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S1c: {
          type: "structure",
          members: {
            MediaPipelineId: {},
            MediaPipelineArn: {},
            SourceType: {},
            SourceArn: {
              shape: "S3"
            },
            Status: {},
            SinkType: {},
            SinkArn: {
              shape: "S3"
            },
            CreatedTimestamp: {
              shape: "S1f"
            },
            UpdatedTimestamp: {
              shape: "S1f"
            },
            ChimeSdkMeetingConfiguration: {
              shape: "S6"
            }
          }
        },
        S1f: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S1h: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Type",
              "MediaCapturePipelineSourceConfiguration"
            ],
            members: {
              Type: {},
              MediaCapturePipelineSourceConfiguration: {
                type: "structure",
                required: [
                  "MediaPipelineArn",
                  "ChimeSdkMeetingConfiguration"
                ],
                members: {
                  MediaPipelineArn: {
                    shape: "S3"
                  },
                  ChimeSdkMeetingConfiguration: {
                    type: "structure",
                    required: [
                      "ArtifactsConfiguration"
                    ],
                    members: {
                      ArtifactsConfiguration: {
                        type: "structure",
                        required: [
                          "Audio",
                          "Video",
                          "Content",
                          "DataChannel",
                          "TranscriptionMessages",
                          "MeetingEvents",
                          "CompositedVideo"
                        ],
                        members: {
                          Audio: {
                            type: "structure",
                            required: [
                              "State"
                            ],
                            members: {
                              State: {}
                            }
                          },
                          Video: {
                            type: "structure",
                            required: [
                              "State"
                            ],
                            members: {
                              State: {}
                            }
                          },
                          Content: {
                            type: "structure",
                            required: [
                              "State"
                            ],
                            members: {
                              State: {}
                            }
                          },
                          DataChannel: {
                            type: "structure",
                            required: [
                              "State"
                            ],
                            members: {
                              State: {}
                            }
                          },
                          TranscriptionMessages: {
                            type: "structure",
                            required: [
                              "State"
                            ],
                            members: {
                              State: {}
                            }
                          },
                          MeetingEvents: {
                            type: "structure",
                            required: [
                              "State"
                            ],
                            members: {
                              State: {}
                            }
                          },
                          CompositedVideo: {
                            type: "structure",
                            required: [
                              "State"
                            ],
                            members: {
                              State: {}
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S1w: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Type",
              "S3BucketSinkConfiguration"
            ],
            members: {
              Type: {},
              S3BucketSinkConfiguration: {
                type: "structure",
                required: [
                  "Destination"
                ],
                members: {
                  Destination: {
                    shape: "S3"
                  }
                }
              }
            }
          }
        },
        S21: {
          type: "structure",
          members: {
            MediaPipelineId: {},
            MediaPipelineArn: {},
            Sources: {
              shape: "S1h"
            },
            Sinks: {
              shape: "S1w"
            },
            Status: {},
            CreatedTimestamp: {
              shape: "S1f"
            },
            UpdatedTimestamp: {
              shape: "S1f"
            }
          }
        },
        S23: {
          type: "structure",
          required: [
            "Streams",
            "MediaEncoding",
            "MediaSampleRate"
          ],
          members: {
            Streams: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "StreamArn",
                  "StreamChannelDefinition"
                ],
                members: {
                  StreamArn: {},
                  FragmentNumber: {},
                  StreamChannelDefinition: {
                    type: "structure",
                    required: [
                      "NumberOfChannels"
                    ],
                    members: {
                      NumberOfChannels: {
                        type: "integer"
                      },
                      ChannelDefinitions: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "ChannelId"
                          ],
                          members: {
                            ChannelId: {
                              type: "integer"
                            },
                            ParticipantRole: {}
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            MediaEncoding: {},
            MediaSampleRate: {
              type: "integer"
            }
          }
        },
        S2g: {
          type: "map",
          key: {},
          value: {},
          sensitive: true
        },
        S2j: {
          type: "structure",
          required: [
            "Streams",
            "FragmentSelector"
          ],
          members: {
            Streams: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  StreamArn: {}
                }
              }
            },
            FragmentSelector: {
              type: "structure",
              required: [
                "FragmentSelectorType",
                "TimestampRange"
              ],
              members: {
                FragmentSelectorType: {},
                TimestampRange: {
                  type: "structure",
                  required: [
                    "StartTimestamp",
                    "EndTimestamp"
                  ],
                  members: {
                    StartTimestamp: {
                      type: "timestamp"
                    },
                    EndTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        S2q: {
          type: "structure",
          required: [
            "Destination",
            "RecordingFileFormat"
          ],
          members: {
            Destination: {
              shape: "S3"
            },
            RecordingFileFormat: {}
          }
        },
        S2t: {
          type: "structure",
          members: {
            MediaPipelineId: {},
            MediaPipelineArn: {
              shape: "S3"
            },
            MediaInsightsPipelineConfigurationArn: {
              shape: "S3"
            },
            Status: {},
            KinesisVideoStreamSourceRuntimeConfiguration: {
              shape: "S23"
            },
            MediaInsightsRuntimeMetadata: {
              shape: "S2g"
            },
            KinesisVideoStreamRecordingSourceRuntimeConfiguration: {
              shape: "S2j"
            },
            S3RecordingSinkRuntimeConfiguration: {
              shape: "S2q"
            },
            CreatedTimestamp: {
              shape: "S1f"
            },
            ElementStatuses: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Type: {},
                  Status: {}
                }
              }
            }
          }
        },
        S30: {
          type: "structure",
          members: {
            Disabled: {
              type: "boolean"
            },
            Rules: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Type"
                ],
                members: {
                  Type: {},
                  KeywordMatchConfiguration: {
                    type: "structure",
                    required: [
                      "RuleName",
                      "Keywords"
                    ],
                    members: {
                      RuleName: {},
                      Keywords: {
                        type: "list",
                        member: {}
                      },
                      Negate: {
                        type: "boolean"
                      }
                    }
                  },
                  SentimentConfiguration: {
                    type: "structure",
                    required: [
                      "RuleName",
                      "SentimentType",
                      "TimePeriod"
                    ],
                    members: {
                      RuleName: {},
                      SentimentType: {},
                      TimePeriod: {
                        type: "integer"
                      }
                    }
                  },
                  IssueDetectionConfiguration: {
                    type: "structure",
                    required: [
                      "RuleName"
                    ],
                    members: {
                      RuleName: {}
                    }
                  }
                }
              }
            }
          }
        },
        S3d: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Type"
            ],
            members: {
              Type: {},
              AmazonTranscribeCallAnalyticsProcessorConfiguration: {
                type: "structure",
                required: [
                  "LanguageCode"
                ],
                members: {
                  LanguageCode: {},
                  VocabularyName: {},
                  VocabularyFilterName: {},
                  VocabularyFilterMethod: {},
                  LanguageModelName: {},
                  EnablePartialResultsStabilization: {
                    type: "boolean"
                  },
                  PartialResultsStability: {},
                  ContentIdentificationType: {},
                  ContentRedactionType: {},
                  PiiEntityTypes: {},
                  FilterPartialResults: {
                    type: "boolean"
                  },
                  PostCallAnalyticsSettings: {
                    type: "structure",
                    required: [
                      "OutputLocation",
                      "DataAccessRoleArn"
                    ],
                    members: {
                      OutputLocation: {},
                      DataAccessRoleArn: {},
                      ContentRedactionOutput: {},
                      OutputEncryptionKMSKeyId: {}
                    }
                  },
                  CallAnalyticsStreamCategories: {
                    type: "list",
                    member: {}
                  }
                }
              },
              AmazonTranscribeProcessorConfiguration: {
                type: "structure",
                members: {
                  LanguageCode: {},
                  VocabularyName: {},
                  VocabularyFilterName: {},
                  VocabularyFilterMethod: {},
                  ShowSpeakerLabel: {
                    type: "boolean"
                  },
                  EnablePartialResultsStabilization: {
                    type: "boolean"
                  },
                  PartialResultsStability: {},
                  ContentIdentificationType: {},
                  ContentRedactionType: {},
                  PiiEntityTypes: {},
                  LanguageModelName: {},
                  FilterPartialResults: {
                    type: "boolean"
                  },
                  IdentifyLanguage: {
                    type: "boolean"
                  },
                  LanguageOptions: {},
                  PreferredLanguage: {},
                  VocabularyNames: {},
                  VocabularyFilterNames: {}
                }
              },
              KinesisDataStreamSinkConfiguration: {
                type: "structure",
                members: {
                  InsightsTarget: {
                    shape: "S3"
                  }
                }
              },
              S3RecordingSinkConfiguration: {
                type: "structure",
                members: {
                  Destination: {
                    shape: "S3"
                  },
                  RecordingFileFormat: {}
                }
              },
              VoiceAnalyticsProcessorConfiguration: {
                type: "structure",
                members: {
                  SpeakerSearchStatus: {},
                  VoiceToneAnalysisStatus: {}
                }
              },
              LambdaFunctionSinkConfiguration: {
                type: "structure",
                members: {
                  InsightsTarget: {
                    shape: "S3"
                  }
                }
              },
              SqsQueueSinkConfiguration: {
                type: "structure",
                members: {
                  InsightsTarget: {
                    shape: "S3"
                  }
                }
              },
              SnsTopicSinkConfiguration: {
                type: "structure",
                members: {
                  InsightsTarget: {
                    shape: "S3"
                  }
                }
              },
              VoiceEnhancementSinkConfiguration: {
                type: "structure",
                members: {
                  Disabled: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        S45: {
          type: "structure",
          members: {
            MediaInsightsPipelineConfigurationName: {},
            MediaInsightsPipelineConfigurationArn: {
              shape: "S3"
            },
            ResourceAccessRoleArn: {
              shape: "S3"
            },
            RealTimeAlertConfiguration: {
              shape: "S30"
            },
            Elements: {
              shape: "S3d"
            },
            MediaInsightsPipelineConfigurationId: {},
            CreatedTimestamp: {
              shape: "S1f"
            },
            UpdatedTimestamp: {
              shape: "S1f"
            }
          }
        },
        S47: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "SourceType",
              "ChimeSdkMeetingLiveConnectorConfiguration"
            ],
            members: {
              SourceType: {},
              ChimeSdkMeetingLiveConnectorConfiguration: {
                type: "structure",
                required: [
                  "Arn",
                  "MuxType"
                ],
                members: {
                  Arn: {
                    shape: "S3"
                  },
                  MuxType: {},
                  CompositedVideo: {
                    shape: "Sl"
                  },
                  SourceConfiguration: {
                    shape: "S7"
                  }
                }
              }
            }
          }
        },
        S4c: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "SinkType",
              "RTMPConfiguration"
            ],
            members: {
              SinkType: {},
              RTMPConfiguration: {
                type: "structure",
                required: [
                  "Url"
                ],
                members: {
                  Url: {
                    type: "string",
                    sensitive: true
                  },
                  AudioChannels: {},
                  AudioSampleRate: {}
                }
              }
            }
          }
        },
        S4k: {
          type: "structure",
          members: {
            Sources: {
              shape: "S47"
            },
            Sinks: {
              shape: "S4c"
            },
            MediaPipelineId: {},
            MediaPipelineArn: {},
            Status: {},
            CreatedTimestamp: {
              shape: "S1f"
            },
            UpdatedTimestamp: {
              shape: "S1f"
            }
          }
        },
        S4m: {
          type: "structure",
          required: [
            "Region"
          ],
          members: {
            Region: {},
            DataRetentionInHours: {
              type: "integer"
            }
          }
        },
        S4r: {
          type: "structure",
          members: {
            PoolArn: {
              shape: "S3"
            },
            PoolName: {},
            PoolId: {},
            PoolStatus: {},
            PoolSize: {
              type: "integer"
            },
            StreamConfiguration: {
              shape: "S4m"
            },
            CreatedTimestamp: {
              shape: "S1f"
            },
            UpdatedTimestamp: {
              shape: "S1f"
            }
          }
        },
        S4w: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "SourceType",
              "SourceArn"
            ],
            members: {
              SourceType: {},
              SourceArn: {
                shape: "S3"
              }
            }
          }
        },
        S4y: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "SinkArn",
              "SinkType",
              "ReservedStreamCapacity",
              "MediaStreamType"
            ],
            members: {
              SinkArn: {
                shape: "S3"
              },
              SinkType: {},
              ReservedStreamCapacity: {
                type: "integer"
              },
              MediaStreamType: {}
            }
          }
        },
        S54: {
          type: "structure",
          members: {
            MediaPipelineId: {},
            MediaPipelineArn: {},
            CreatedTimestamp: {
              shape: "S1f"
            },
            UpdatedTimestamp: {
              shape: "S1f"
            },
            Status: {},
            Sources: {
              shape: "S4w"
            },
            Sinks: {
              shape: "S4y"
            }
          }
        },
        S5k: {
          type: "structure",
          members: {
            SpeakerSearchTaskId: {},
            SpeakerSearchTaskStatus: {},
            CreatedTimestamp: {
              shape: "S1f"
            },
            UpdatedTimestamp: {
              shape: "S1f"
            }
          }
        },
        S5o: {
          type: "structure",
          members: {
            VoiceToneAnalysisTaskId: {},
            VoiceToneAnalysisTaskStatus: {},
            CreatedTimestamp: {
              shape: "S1f"
            },
            UpdatedTimestamp: {
              shape: "S1f"
            }
          }
        },
        S69: {
          type: "structure",
          required: [
            "StreamArn",
            "ChannelId"
          ],
          members: {
            StreamArn: {},
            ChannelId: {
              type: "integer"
            },
            FragmentNumber: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/chime-sdk-media-pipelines-2021-07-15.paginators.json
var require_chime_sdk_media_pipelines_2021_07_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/chime-sdk-media-pipelines-2021-07-15.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListMediaCapturePipelines: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMediaInsightsPipelineConfigurations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMediaPipelineKinesisVideoStreamPools: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMediaPipelines: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/chimesdkmediapipelines.js
var require_chimesdkmediapipelines = __commonJS({
  "node_modules/aws-sdk/clients/chimesdkmediapipelines.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["chimesdkmediapipelines"] = {};
    AWS2.ChimeSDKMediaPipelines = Service.defineService("chimesdkmediapipelines", ["2021-07-15"]);
    Object.defineProperty(apiLoader.services["chimesdkmediapipelines"], "2021-07-15", {
      get: function get() {
        var model = require_chime_sdk_media_pipelines_2021_07_15_min();
        model.paginators = require_chime_sdk_media_pipelines_2021_07_15_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ChimeSDKMediaPipelines;
  }
});

// node_modules/aws-sdk/apis/emr-serverless-2021-07-13.min.json
var require_emr_serverless_2021_07_13_min = __commonJS({
  "node_modules/aws-sdk/apis/emr-serverless-2021-07-13.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-07-13",
        endpointPrefix: "emr-serverless",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "EMR Serverless",
        serviceId: "EMR Serverless",
        signatureVersion: "v4",
        signingName: "emr-serverless",
        uid: "emr-serverless-2021-07-13"
      },
      operations: {
        CancelJobRun: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{applicationId}/jobruns/{jobRunId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "jobRunId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              jobRunId: {
                location: "uri",
                locationName: "jobRunId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "applicationId",
              "jobRunId"
            ],
            members: {
              applicationId: {},
              jobRunId: {}
            }
          },
          idempotent: true
        },
        CreateApplication: {
          http: {
            requestUri: "/applications",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "releaseLabel",
              "type",
              "clientToken"
            ],
            members: {
              name: {},
              releaseLabel: {},
              type: {},
              clientToken: {
                idempotencyToken: true
              },
              initialCapacity: {
                shape: "Sa"
              },
              maximumCapacity: {
                shape: "Si"
              },
              tags: {
                shape: "Sj"
              },
              autoStartConfiguration: {
                shape: "Sm"
              },
              autoStopConfiguration: {
                shape: "So"
              },
              networkConfiguration: {
                shape: "Sq"
              },
              architecture: {},
              imageConfiguration: {
                shape: "Sw"
              },
              workerTypeSpecifications: {
                shape: "Sy"
              },
              runtimeConfiguration: {
                shape: "S10"
              },
              monitoringConfiguration: {
                shape: "S14"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "applicationId",
              "arn"
            ],
            members: {
              applicationId: {},
              name: {},
              arn: {}
            }
          },
          idempotent: true
        },
        DeleteApplication: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{applicationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        GetApplication: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "application"
            ],
            members: {
              application: {
                shape: "S1l"
              }
            }
          }
        },
        GetDashboardForJobRun: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/jobruns/{jobRunId}/dashboard",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "jobRunId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              jobRunId: {
                location: "uri",
                locationName: "jobRunId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              url: {}
            }
          }
        },
        GetJobRun: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/jobruns/{jobRunId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "jobRunId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              jobRunId: {
                location: "uri",
                locationName: "jobRunId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobRun"
            ],
            members: {
              jobRun: {
                type: "structure",
                required: [
                  "applicationId",
                  "jobRunId",
                  "arn",
                  "createdBy",
                  "createdAt",
                  "updatedAt",
                  "executionRole",
                  "state",
                  "stateDetails",
                  "releaseLabel",
                  "jobDriver"
                ],
                members: {
                  applicationId: {},
                  jobRunId: {},
                  name: {},
                  arn: {},
                  createdBy: {},
                  createdAt: {
                    type: "timestamp"
                  },
                  updatedAt: {
                    type: "timestamp"
                  },
                  executionRole: {},
                  state: {},
                  stateDetails: {},
                  releaseLabel: {},
                  configurationOverrides: {
                    shape: "S23"
                  },
                  jobDriver: {
                    shape: "S24"
                  },
                  tags: {
                    shape: "Sj"
                  },
                  totalResourceUtilization: {
                    type: "structure",
                    members: {
                      vCPUHour: {
                        type: "double"
                      },
                      memoryGBHour: {
                        type: "double"
                      },
                      storageGBHour: {
                        type: "double"
                      }
                    }
                  },
                  networkConfiguration: {
                    shape: "Sq"
                  },
                  totalExecutionDurationSeconds: {
                    type: "integer"
                  },
                  executionTimeoutMinutes: {
                    type: "long"
                  },
                  billedResourceUtilization: {
                    type: "structure",
                    members: {
                      vCPUHour: {
                        type: "double"
                      },
                      memoryGBHour: {
                        type: "double"
                      },
                      storageGBHour: {
                        type: "double"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        ListApplications: {
          http: {
            method: "GET",
            requestUri: "/applications",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              states: {
                location: "querystring",
                locationName: "states",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "applications"
            ],
            members: {
              applications: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "arn",
                    "releaseLabel",
                    "type",
                    "state",
                    "createdAt",
                    "updatedAt"
                  ],
                  members: {
                    id: {},
                    name: {},
                    arn: {},
                    releaseLabel: {},
                    type: {},
                    state: {},
                    stateDetails: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    updatedAt: {
                      type: "timestamp"
                    },
                    architecture: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListJobRuns: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/jobruns",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              createdAtAfter: {
                location: "querystring",
                locationName: "createdAtAfter",
                type: "timestamp"
              },
              createdAtBefore: {
                location: "querystring",
                locationName: "createdAtBefore",
                type: "timestamp"
              },
              states: {
                location: "querystring",
                locationName: "states",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobRuns"
            ],
            members: {
              jobRuns: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "applicationId",
                    "id",
                    "arn",
                    "createdBy",
                    "createdAt",
                    "updatedAt",
                    "executionRole",
                    "state",
                    "stateDetails",
                    "releaseLabel"
                  ],
                  members: {
                    applicationId: {},
                    id: {},
                    name: {},
                    arn: {},
                    createdBy: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    updatedAt: {
                      type: "timestamp"
                    },
                    executionRole: {},
                    state: {},
                    stateDetails: {},
                    releaseLabel: {},
                    type: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sj"
              }
            }
          }
        },
        StartApplication: {
          http: {
            requestUri: "/applications/{applicationId}/start",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        StartJobRun: {
          http: {
            requestUri: "/applications/{applicationId}/jobruns",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "clientToken",
              "executionRoleArn"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              clientToken: {
                idempotencyToken: true
              },
              executionRoleArn: {},
              jobDriver: {
                shape: "S24"
              },
              configurationOverrides: {
                shape: "S23"
              },
              tags: {
                shape: "Sj"
              },
              executionTimeoutMinutes: {
                type: "long"
              },
              name: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "applicationId",
              "jobRunId",
              "arn"
            ],
            members: {
              applicationId: {},
              jobRunId: {},
              arn: {}
            }
          },
          idempotent: true
        },
        StopApplication: {
          http: {
            requestUri: "/applications/{applicationId}/stop",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateApplication: {
          http: {
            method: "PATCH",
            requestUri: "/applications/{applicationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "clientToken"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              clientToken: {
                idempotencyToken: true
              },
              initialCapacity: {
                shape: "Sa"
              },
              maximumCapacity: {
                shape: "Si"
              },
              autoStartConfiguration: {
                shape: "Sm"
              },
              autoStopConfiguration: {
                shape: "So"
              },
              networkConfiguration: {
                shape: "Sq"
              },
              architecture: {},
              imageConfiguration: {
                shape: "Sw"
              },
              workerTypeSpecifications: {
                shape: "Sy"
              },
              releaseLabel: {},
              runtimeConfiguration: {
                shape: "S10"
              },
              monitoringConfiguration: {
                shape: "S14"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "application"
            ],
            members: {
              application: {
                shape: "S1l"
              }
            }
          }
        }
      },
      shapes: {
        Sa: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "workerCount"
            ],
            members: {
              workerCount: {
                type: "long"
              },
              workerConfiguration: {
                type: "structure",
                required: [
                  "cpu",
                  "memory"
                ],
                members: {
                  cpu: {},
                  memory: {},
                  disk: {}
                }
              }
            }
          }
        },
        Si: {
          type: "structure",
          required: [
            "cpu",
            "memory"
          ],
          members: {
            cpu: {},
            memory: {},
            disk: {}
          }
        },
        Sj: {
          type: "map",
          key: {},
          value: {}
        },
        Sm: {
          type: "structure",
          members: {
            enabled: {
              type: "boolean"
            }
          }
        },
        So: {
          type: "structure",
          members: {
            enabled: {
              type: "boolean"
            },
            idleTimeoutMinutes: {
              type: "integer"
            }
          }
        },
        Sq: {
          type: "structure",
          members: {
            subnetIds: {
              type: "list",
              member: {}
            },
            securityGroupIds: {
              type: "list",
              member: {}
            }
          }
        },
        Sw: {
          type: "structure",
          members: {
            imageUri: {}
          }
        },
        Sy: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              imageConfiguration: {
                shape: "Sw"
              }
            }
          }
        },
        S10: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "classification"
            ],
            members: {
              classification: {},
              properties: {
                type: "map",
                key: {},
                value: {},
                sensitive: true
              },
              configurations: {
                shape: "S10"
              }
            }
          }
        },
        S14: {
          type: "structure",
          members: {
            s3MonitoringConfiguration: {
              type: "structure",
              members: {
                logUri: {},
                encryptionKeyArn: {}
              }
            },
            managedPersistenceMonitoringConfiguration: {
              type: "structure",
              members: {
                enabled: {
                  type: "boolean"
                },
                encryptionKeyArn: {}
              }
            },
            cloudWatchLoggingConfiguration: {
              type: "structure",
              required: [
                "enabled"
              ],
              members: {
                enabled: {
                  type: "boolean"
                },
                logGroupName: {},
                logStreamNamePrefix: {},
                encryptionKeyArn: {},
                logTypes: {
                  type: "map",
                  key: {},
                  value: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          }
        },
        S1l: {
          type: "structure",
          required: [
            "applicationId",
            "arn",
            "releaseLabel",
            "type",
            "state",
            "createdAt",
            "updatedAt"
          ],
          members: {
            applicationId: {},
            name: {},
            arn: {},
            releaseLabel: {},
            type: {},
            state: {},
            stateDetails: {},
            initialCapacity: {
              shape: "Sa"
            },
            maximumCapacity: {
              shape: "Si"
            },
            createdAt: {
              type: "timestamp"
            },
            updatedAt: {
              type: "timestamp"
            },
            tags: {
              shape: "Sj"
            },
            autoStartConfiguration: {
              shape: "Sm"
            },
            autoStopConfiguration: {
              shape: "So"
            },
            networkConfiguration: {
              shape: "Sq"
            },
            architecture: {},
            imageConfiguration: {
              shape: "S1p"
            },
            workerTypeSpecifications: {
              type: "map",
              key: {},
              value: {
                type: "structure",
                members: {
                  imageConfiguration: {
                    shape: "S1p"
                  }
                }
              }
            },
            runtimeConfiguration: {
              shape: "S10"
            },
            monitoringConfiguration: {
              shape: "S14"
            }
          }
        },
        S1p: {
          type: "structure",
          required: [
            "imageUri"
          ],
          members: {
            imageUri: {},
            resolvedImageDigest: {}
          }
        },
        S23: {
          type: "structure",
          members: {
            applicationConfiguration: {
              shape: "S10"
            },
            monitoringConfiguration: {
              shape: "S14"
            }
          }
        },
        S24: {
          type: "structure",
          members: {
            sparkSubmit: {
              type: "structure",
              required: [
                "entryPoint"
              ],
              members: {
                entryPoint: {
                  type: "string",
                  sensitive: true
                },
                entryPointArguments: {
                  type: "list",
                  member: {
                    type: "string",
                    sensitive: true
                  }
                },
                sparkSubmitParameters: {
                  type: "string",
                  sensitive: true
                }
              }
            },
            hive: {
              type: "structure",
              required: [
                "query"
              ],
              members: {
                query: {
                  type: "string",
                  sensitive: true
                },
                initQueryFile: {
                  type: "string",
                  sensitive: true
                },
                parameters: {
                  type: "string",
                  sensitive: true
                }
              }
            }
          },
          union: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/emr-serverless-2021-07-13.paginators.json
var require_emr_serverless_2021_07_13_paginators = __commonJS({
  "node_modules/aws-sdk/apis/emr-serverless-2021-07-13.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListApplications: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "applications"
        },
        ListJobRuns: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "jobRuns"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/emrserverless.js
var require_emrserverless = __commonJS({
  "node_modules/aws-sdk/clients/emrserverless.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["emrserverless"] = {};
    AWS2.EMRServerless = Service.defineService("emrserverless", ["2021-07-13"]);
    Object.defineProperty(apiLoader.services["emrserverless"], "2021-07-13", {
      get: function get() {
        var model = require_emr_serverless_2021_07_13_min();
        model.paginators = require_emr_serverless_2021_07_13_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.EMRServerless;
  }
});

// node_modules/aws-sdk/apis/m2-2021-04-28.min.json
var require_m2_2021_04_28_min = __commonJS({
  "node_modules/aws-sdk/apis/m2-2021-04-28.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-04-28",
        endpointPrefix: "m2",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWSMainframeModernization",
        serviceId: "m2",
        signatureVersion: "v4",
        signingName: "m2",
        uid: "m2-2021-04-28"
      },
      operations: {
        CancelBatchJobExecution: {
          http: {
            requestUri: "/applications/{applicationId}/batch-job-executions/{executionId}/cancel",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "executionId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              executionId: {
                location: "uri",
                locationName: "executionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateApplication: {
          http: {
            requestUri: "/applications",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "definition",
              "engineType",
              "name"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              definition: {
                shape: "S6"
              },
              description: {},
              engineType: {},
              kmsKeyId: {},
              name: {},
              roleArn: {},
              tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "applicationArn",
              "applicationId",
              "applicationVersion"
            ],
            members: {
              applicationArn: {},
              applicationId: {},
              applicationVersion: {
                type: "integer"
              }
            }
          },
          idempotent: true
        },
        CreateDataSetImportTask: {
          http: {
            requestUri: "/applications/{applicationId}/dataset-import-task",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "importConfig"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              clientToken: {
                idempotencyToken: true
              },
              importConfig: {
                type: "structure",
                members: {
                  dataSets: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "dataSet",
                        "externalLocation"
                      ],
                      members: {
                        dataSet: {
                          type: "structure",
                          required: [
                            "datasetName",
                            "datasetOrg",
                            "recordLength"
                          ],
                          members: {
                            datasetName: {},
                            datasetOrg: {
                              type: "structure",
                              members: {
                                gdg: {
                                  type: "structure",
                                  members: {
                                    limit: {
                                      type: "integer"
                                    },
                                    rollDisposition: {}
                                  }
                                },
                                po: {
                                  type: "structure",
                                  required: [
                                    "format",
                                    "memberFileExtensions"
                                  ],
                                  members: {
                                    encoding: {},
                                    format: {},
                                    memberFileExtensions: {
                                      type: "list",
                                      member: {}
                                    }
                                  }
                                },
                                ps: {
                                  type: "structure",
                                  required: [
                                    "format"
                                  ],
                                  members: {
                                    encoding: {},
                                    format: {}
                                  }
                                },
                                vsam: {
                                  type: "structure",
                                  required: [
                                    "format"
                                  ],
                                  members: {
                                    alternateKeys: {
                                      shape: "Sv"
                                    },
                                    compressed: {
                                      type: "boolean"
                                    },
                                    encoding: {},
                                    format: {},
                                    primaryKey: {
                                      shape: "Sy"
                                    }
                                  }
                                }
                              },
                              union: true
                            },
                            recordLength: {
                              type: "structure",
                              required: [
                                "max",
                                "min"
                              ],
                              members: {
                                max: {
                                  type: "integer"
                                },
                                min: {
                                  type: "integer"
                                }
                              }
                            },
                            relativePath: {},
                            storageType: {}
                          }
                        },
                        externalLocation: {
                          type: "structure",
                          members: {
                            s3Location: {}
                          },
                          union: true
                        }
                      }
                    }
                  },
                  s3Location: {}
                },
                union: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "taskId"
            ],
            members: {
              taskId: {}
            }
          },
          idempotent: true
        },
        CreateDeployment: {
          http: {
            requestUri: "/applications/{applicationId}/deployments",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "applicationVersion",
              "environmentId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              applicationVersion: {
                type: "integer"
              },
              clientToken: {
                idempotencyToken: true
              },
              environmentId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "deploymentId"
            ],
            members: {
              deploymentId: {}
            }
          },
          idempotent: true
        },
        CreateEnvironment: {
          http: {
            requestUri: "/environments",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "engineType",
              "instanceType",
              "name"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              description: {},
              engineType: {},
              engineVersion: {},
              highAvailabilityConfig: {
                shape: "S16"
              },
              instanceType: {},
              kmsKeyId: {},
              name: {},
              preferredMaintenanceWindow: {},
              publiclyAccessible: {
                type: "boolean"
              },
              securityGroupIds: {
                shape: "S19"
              },
              storageConfigurations: {
                shape: "S1a"
              },
              subnetIds: {
                shape: "S19"
              },
              tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "environmentId"
            ],
            members: {
              environmentId: {}
            }
          },
          idempotent: true
        },
        DeleteApplication: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{applicationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteApplicationFromEnvironment: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{applicationId}/environment/{environmentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "environmentId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteEnvironment: {
          http: {
            method: "DELETE",
            requestUri: "/environments/{environmentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "environmentId"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        GetApplication: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "applicationArn",
              "applicationId",
              "creationTime",
              "engineType",
              "latestVersion",
              "name",
              "status"
            ],
            members: {
              applicationArn: {},
              applicationId: {},
              creationTime: {
                type: "timestamp"
              },
              deployedVersion: {
                type: "structure",
                required: [
                  "applicationVersion",
                  "status"
                ],
                members: {
                  applicationVersion: {
                    type: "integer"
                  },
                  status: {},
                  statusReason: {}
                }
              },
              description: {},
              engineType: {},
              environmentId: {},
              kmsKeyId: {},
              lastStartTime: {
                type: "timestamp"
              },
              latestVersion: {
                shape: "S1r"
              },
              listenerArns: {
                shape: "S1t"
              },
              listenerPorts: {
                type: "list",
                member: {
                  type: "integer"
                }
              },
              loadBalancerDnsName: {},
              logGroups: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "logGroupName",
                    "logType"
                  ],
                  members: {
                    logGroupName: {},
                    logType: {}
                  }
                }
              },
              name: {},
              roleArn: {},
              status: {},
              statusReason: {},
              tags: {
                shape: "Sd"
              },
              targetGroupArns: {
                shape: "S1t"
              }
            }
          }
        },
        GetApplicationVersion: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/versions/{applicationVersion}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "applicationVersion"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              applicationVersion: {
                location: "uri",
                locationName: "applicationVersion",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "applicationVersion",
              "creationTime",
              "definitionContent",
              "name",
              "status"
            ],
            members: {
              applicationVersion: {
                type: "integer"
              },
              creationTime: {
                type: "timestamp"
              },
              definitionContent: {},
              description: {},
              name: {},
              status: {},
              statusReason: {}
            }
          }
        },
        GetBatchJobExecution: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/batch-job-executions/{executionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "executionId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              executionId: {
                location: "uri",
                locationName: "executionId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "applicationId",
              "executionId",
              "startTime",
              "status"
            ],
            members: {
              applicationId: {},
              batchJobIdentifier: {
                shape: "S24"
              },
              endTime: {
                type: "timestamp"
              },
              executionId: {},
              jobId: {},
              jobName: {},
              jobType: {},
              jobUser: {},
              returnCode: {},
              startTime: {
                type: "timestamp"
              },
              status: {},
              statusReason: {}
            }
          }
        },
        GetDataSetDetails: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/datasets/{dataSetName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "dataSetName"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              dataSetName: {
                location: "uri",
                locationName: "dataSetName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "dataSetName"
            ],
            members: {
              blocksize: {
                type: "integer"
              },
              creationTime: {
                type: "timestamp"
              },
              dataSetName: {},
              dataSetOrg: {
                type: "structure",
                members: {
                  gdg: {
                    type: "structure",
                    members: {
                      limit: {
                        type: "integer"
                      },
                      rollDisposition: {}
                    }
                  },
                  po: {
                    type: "structure",
                    required: [
                      "encoding",
                      "format"
                    ],
                    members: {
                      encoding: {},
                      format: {}
                    }
                  },
                  ps: {
                    type: "structure",
                    required: [
                      "encoding",
                      "format"
                    ],
                    members: {
                      encoding: {},
                      format: {}
                    }
                  },
                  vsam: {
                    type: "structure",
                    members: {
                      alternateKeys: {
                        shape: "Sv"
                      },
                      cacheAtStartup: {
                        type: "boolean"
                      },
                      compressed: {
                        type: "boolean"
                      },
                      encoding: {},
                      primaryKey: {
                        shape: "Sy"
                      },
                      recordFormat: {}
                    }
                  }
                },
                union: true
              },
              fileSize: {
                type: "long"
              },
              lastReferencedTime: {
                type: "timestamp"
              },
              lastUpdatedTime: {
                type: "timestamp"
              },
              location: {},
              recordLength: {
                type: "integer"
              }
            }
          }
        },
        GetDataSetImportTask: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/dataset-import-tasks/{taskId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "taskId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              taskId: {
                location: "uri",
                locationName: "taskId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "status",
              "taskId"
            ],
            members: {
              status: {},
              summary: {
                shape: "S2m"
              },
              taskId: {}
            }
          }
        },
        GetDeployment: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/deployments/{deploymentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "deploymentId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              deploymentId: {
                location: "uri",
                locationName: "deploymentId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "applicationId",
              "applicationVersion",
              "creationTime",
              "deploymentId",
              "environmentId",
              "status"
            ],
            members: {
              applicationId: {},
              applicationVersion: {
                type: "integer"
              },
              creationTime: {
                type: "timestamp"
              },
              deploymentId: {},
              environmentId: {},
              status: {},
              statusReason: {}
            }
          }
        },
        GetEnvironment: {
          http: {
            method: "GET",
            requestUri: "/environments/{environmentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "environmentId"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "creationTime",
              "engineType",
              "engineVersion",
              "environmentArn",
              "environmentId",
              "instanceType",
              "name",
              "securityGroupIds",
              "status",
              "subnetIds",
              "vpcId"
            ],
            members: {
              actualCapacity: {
                type: "integer"
              },
              creationTime: {
                type: "timestamp"
              },
              description: {},
              engineType: {},
              engineVersion: {},
              environmentArn: {},
              environmentId: {},
              highAvailabilityConfig: {
                shape: "S16"
              },
              instanceType: {},
              kmsKeyId: {},
              loadBalancerArn: {},
              name: {},
              pendingMaintenance: {
                type: "structure",
                members: {
                  engineVersion: {},
                  schedule: {
                    type: "structure",
                    members: {
                      endTime: {
                        type: "timestamp"
                      },
                      startTime: {
                        type: "timestamp"
                      }
                    }
                  }
                }
              },
              preferredMaintenanceWindow: {},
              publiclyAccessible: {
                type: "boolean"
              },
              securityGroupIds: {
                shape: "S19"
              },
              status: {},
              statusReason: {},
              storageConfigurations: {
                shape: "S1a"
              },
              subnetIds: {
                shape: "S19"
              },
              tags: {
                shape: "Sd"
              },
              vpcId: {}
            }
          }
        },
        GetSignedBluinsightsUrl: {
          http: {
            method: "GET",
            requestUri: "/signed-bi-url",
            responseCode: 200
          },
          output: {
            type: "structure",
            required: [
              "signedBiUrl"
            ],
            members: {
              signedBiUrl: {}
            }
          }
        },
        ListApplicationVersions: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "applicationVersions"
            ],
            members: {
              applicationVersions: {
                type: "list",
                member: {
                  shape: "S1r"
                }
              },
              nextToken: {}
            }
          }
        },
        ListApplications: {
          http: {
            method: "GET",
            requestUri: "/applications",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              environmentId: {
                location: "querystring",
                locationName: "environmentId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              names: {
                shape: "S31",
                location: "querystring",
                locationName: "names"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "applications"
            ],
            members: {
              applications: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "applicationArn",
                    "applicationId",
                    "applicationVersion",
                    "creationTime",
                    "engineType",
                    "name",
                    "status"
                  ],
                  members: {
                    applicationArn: {},
                    applicationId: {},
                    applicationVersion: {
                      type: "integer"
                    },
                    creationTime: {
                      type: "timestamp"
                    },
                    deploymentStatus: {},
                    description: {},
                    engineType: {},
                    environmentId: {},
                    lastStartTime: {
                      type: "timestamp"
                    },
                    name: {},
                    roleArn: {},
                    status: {},
                    versionStatus: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListBatchJobDefinitions: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/batch-job-definitions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              prefix: {
                location: "querystring",
                locationName: "prefix"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "batchJobDefinitions"
            ],
            members: {
              batchJobDefinitions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    fileBatchJobDefinition: {
                      type: "structure",
                      required: [
                        "fileName"
                      ],
                      members: {
                        fileName: {},
                        folderPath: {}
                      }
                    },
                    scriptBatchJobDefinition: {
                      type: "structure",
                      required: [
                        "scriptName"
                      ],
                      members: {
                        scriptName: {}
                      }
                    }
                  },
                  union: true
                }
              },
              nextToken: {}
            }
          }
        },
        ListBatchJobExecutions: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/batch-job-executions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              executionIds: {
                location: "querystring",
                locationName: "executionIds",
                type: "list",
                member: {}
              },
              jobName: {
                location: "querystring",
                locationName: "jobName"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              startedAfter: {
                location: "querystring",
                locationName: "startedAfter",
                type: "timestamp"
              },
              startedBefore: {
                location: "querystring",
                locationName: "startedBefore",
                type: "timestamp"
              },
              status: {
                location: "querystring",
                locationName: "status"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "batchJobExecutions"
            ],
            members: {
              batchJobExecutions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "applicationId",
                    "executionId",
                    "startTime",
                    "status"
                  ],
                  members: {
                    applicationId: {},
                    batchJobIdentifier: {
                      shape: "S24"
                    },
                    endTime: {
                      type: "timestamp"
                    },
                    executionId: {},
                    jobId: {},
                    jobName: {},
                    jobType: {},
                    returnCode: {},
                    startTime: {
                      type: "timestamp"
                    },
                    status: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDataSetImportHistory: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/dataset-import-tasks",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "dataSetImportTasks"
            ],
            members: {
              dataSetImportTasks: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "status",
                    "summary",
                    "taskId"
                  ],
                  members: {
                    status: {},
                    statusReason: {},
                    summary: {
                      shape: "S2m"
                    },
                    taskId: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDataSets: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/datasets",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nameFilter: {
                location: "querystring",
                locationName: "nameFilter"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              prefix: {
                location: "querystring",
                locationName: "prefix"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "dataSets"
            ],
            members: {
              dataSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "dataSetName"
                  ],
                  members: {
                    creationTime: {
                      type: "timestamp"
                    },
                    dataSetName: {},
                    dataSetOrg: {},
                    format: {},
                    lastReferencedTime: {
                      type: "timestamp"
                    },
                    lastUpdatedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDeployments: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/deployments",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "deployments"
            ],
            members: {
              deployments: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "applicationId",
                    "applicationVersion",
                    "creationTime",
                    "deploymentId",
                    "environmentId",
                    "status"
                  ],
                  members: {
                    applicationId: {},
                    applicationVersion: {
                      type: "integer"
                    },
                    creationTime: {
                      type: "timestamp"
                    },
                    deploymentId: {},
                    environmentId: {},
                    status: {},
                    statusReason: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListEngineVersions: {
          http: {
            method: "GET",
            requestUri: "/engine-versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              engineType: {
                location: "querystring",
                locationName: "engineType"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "engineVersions"
            ],
            members: {
              engineVersions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "engineType",
                    "engineVersion"
                  ],
                  members: {
                    engineType: {},
                    engineVersion: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListEnvironments: {
          http: {
            method: "GET",
            requestUri: "/environments",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              engineType: {
                location: "querystring",
                locationName: "engineType"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              names: {
                shape: "S31",
                location: "querystring",
                locationName: "names"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "environments"
            ],
            members: {
              environments: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "creationTime",
                    "engineType",
                    "engineVersion",
                    "environmentArn",
                    "environmentId",
                    "instanceType",
                    "name",
                    "status"
                  ],
                  members: {
                    creationTime: {
                      type: "timestamp"
                    },
                    engineType: {},
                    engineVersion: {},
                    environmentArn: {},
                    environmentId: {},
                    instanceType: {},
                    name: {},
                    status: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "tags"
            ],
            members: {
              tags: {
                shape: "Sd"
              }
            }
          }
        },
        StartApplication: {
          http: {
            requestUri: "/applications/{applicationId}/start",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartBatchJob: {
          http: {
            requestUri: "/applications/{applicationId}/batch-job",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "batchJobIdentifier"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              batchJobIdentifier: {
                shape: "S24"
              },
              jobParams: {
                type: "map",
                key: {},
                value: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "executionId"
            ],
            members: {
              executionId: {}
            }
          }
        },
        StopApplication: {
          http: {
            requestUri: "/applications/{applicationId}/stop",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              forceStop: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateApplication: {
          http: {
            method: "PATCH",
            requestUri: "/applications/{applicationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "currentApplicationVersion"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              currentApplicationVersion: {
                type: "integer"
              },
              definition: {
                shape: "S6"
              },
              description: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "applicationVersion"
            ],
            members: {
              applicationVersion: {
                type: "integer"
              }
            }
          }
        },
        UpdateEnvironment: {
          http: {
            method: "PATCH",
            requestUri: "/environments/{environmentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "environmentId"
            ],
            members: {
              applyDuringMaintenanceWindow: {
                type: "boolean"
              },
              desiredCapacity: {
                type: "integer"
              },
              engineVersion: {},
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              forceUpdate: {
                type: "boolean"
              },
              instanceType: {},
              preferredMaintenanceWindow: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "environmentId"
            ],
            members: {
              environmentId: {}
            }
          }
        }
      },
      shapes: {
        S6: {
          type: "structure",
          members: {
            content: {},
            s3Location: {}
          },
          union: true
        },
        Sd: {
          type: "map",
          key: {},
          value: {}
        },
        Sv: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "length",
              "offset"
            ],
            members: {
              allowDuplicates: {
                type: "boolean"
              },
              length: {
                type: "integer"
              },
              name: {},
              offset: {
                type: "integer"
              }
            }
          }
        },
        Sy: {
          type: "structure",
          required: [
            "length",
            "offset"
          ],
          members: {
            length: {
              type: "integer"
            },
            name: {},
            offset: {
              type: "integer"
            }
          }
        },
        S16: {
          type: "structure",
          required: [
            "desiredCapacity"
          ],
          members: {
            desiredCapacity: {
              type: "integer"
            }
          }
        },
        S19: {
          type: "list",
          member: {}
        },
        S1a: {
          type: "list",
          member: {
            type: "structure",
            members: {
              efs: {
                type: "structure",
                required: [
                  "fileSystemId",
                  "mountPoint"
                ],
                members: {
                  fileSystemId: {
                    locationName: "file-system-id"
                  },
                  mountPoint: {
                    locationName: "mount-point"
                  }
                }
              },
              fsx: {
                type: "structure",
                required: [
                  "fileSystemId",
                  "mountPoint"
                ],
                members: {
                  fileSystemId: {
                    locationName: "file-system-id"
                  },
                  mountPoint: {
                    locationName: "mount-point"
                  }
                }
              }
            },
            union: true
          }
        },
        S1r: {
          type: "structure",
          required: [
            "applicationVersion",
            "creationTime",
            "status"
          ],
          members: {
            applicationVersion: {
              type: "integer"
            },
            creationTime: {
              type: "timestamp"
            },
            status: {},
            statusReason: {}
          }
        },
        S1t: {
          type: "list",
          member: {}
        },
        S24: {
          type: "structure",
          members: {
            fileBatchJobIdentifier: {
              type: "structure",
              required: [
                "fileName"
              ],
              members: {
                fileName: {},
                folderPath: {}
              }
            },
            s3BatchJobIdentifier: {
              type: "structure",
              required: [
                "bucket",
                "identifier"
              ],
              members: {
                bucket: {},
                identifier: {
                  type: "structure",
                  members: {
                    fileName: {},
                    scriptName: {}
                  },
                  union: true
                },
                keyPrefix: {}
              }
            },
            scriptBatchJobIdentifier: {
              type: "structure",
              required: [
                "scriptName"
              ],
              members: {
                scriptName: {}
              }
            }
          },
          union: true
        },
        S2m: {
          type: "structure",
          required: [
            "failed",
            "inProgress",
            "pending",
            "succeeded",
            "total"
          ],
          members: {
            failed: {
              type: "integer"
            },
            inProgress: {
              type: "integer"
            },
            pending: {
              type: "integer"
            },
            succeeded: {
              type: "integer"
            },
            total: {
              type: "integer"
            }
          }
        },
        S31: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/m2-2021-04-28.paginators.json
var require_m2_2021_04_28_paginators = __commonJS({
  "node_modules/aws-sdk/apis/m2-2021-04-28.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListApplicationVersions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "applicationVersions"
        },
        ListApplications: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "applications"
        },
        ListBatchJobDefinitions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "batchJobDefinitions"
        },
        ListBatchJobExecutions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "batchJobExecutions"
        },
        ListDataSetImportHistory: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "dataSetImportTasks"
        },
        ListDataSets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "dataSets"
        },
        ListDeployments: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "deployments"
        },
        ListEngineVersions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "engineVersions"
        },
        ListEnvironments: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "environments"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/m2.js
var require_m2 = __commonJS({
  "node_modules/aws-sdk/clients/m2.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["m2"] = {};
    AWS2.M2 = Service.defineService("m2", ["2021-04-28"]);
    Object.defineProperty(apiLoader.services["m2"], "2021-04-28", {
      get: function get() {
        var model = require_m2_2021_04_28_min();
        model.paginators = require_m2_2021_04_28_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.M2;
  }
});

// node_modules/aws-sdk/apis/connectcampaigns-2021-01-30.min.json
var require_connectcampaigns_2021_01_30_min = __commonJS({
  "node_modules/aws-sdk/apis/connectcampaigns-2021-01-30.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-01-30",
        endpointPrefix: "connect-campaigns",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AmazonConnectCampaignService",
        serviceId: "ConnectCampaigns",
        signatureVersion: "v4",
        signingName: "connect-campaigns",
        uid: "connectcampaigns-2021-01-30"
      },
      operations: {
        CreateCampaign: {
          http: {
            method: "PUT",
            requestUri: "/campaigns",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "connectInstanceId",
              "dialerConfig",
              "outboundCallConfig"
            ],
            members: {
              name: {},
              connectInstanceId: {},
              dialerConfig: {
                shape: "S4"
              },
              outboundCallConfig: {
                shape: "Sa"
              },
              tags: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              arn: {},
              tags: {
                shape: "Sg"
              }
            }
          },
          idempotent: true
        },
        DeleteCampaign: {
          http: {
            method: "DELETE",
            requestUri: "/campaigns/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          idempotent: true
        },
        DeleteConnectInstanceConfig: {
          http: {
            method: "DELETE",
            requestUri: "/connect-instance/{connectInstanceId}/config",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "connectInstanceId"
            ],
            members: {
              connectInstanceId: {
                location: "uri",
                locationName: "connectInstanceId"
              }
            }
          },
          idempotent: true
        },
        DeleteInstanceOnboardingJob: {
          http: {
            method: "DELETE",
            requestUri: "/connect-instance/{connectInstanceId}/onboarding",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "connectInstanceId"
            ],
            members: {
              connectInstanceId: {
                location: "uri",
                locationName: "connectInstanceId"
              }
            }
          },
          idempotent: true
        },
        DescribeCampaign: {
          http: {
            method: "GET",
            requestUri: "/campaigns/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              campaign: {
                type: "structure",
                required: [
                  "id",
                  "arn",
                  "name",
                  "connectInstanceId",
                  "dialerConfig",
                  "outboundCallConfig"
                ],
                members: {
                  id: {},
                  arn: {},
                  name: {},
                  connectInstanceId: {},
                  dialerConfig: {
                    shape: "S4"
                  },
                  outboundCallConfig: {
                    shape: "Sa"
                  },
                  tags: {
                    shape: "Sg"
                  }
                }
              }
            }
          }
        },
        GetCampaignState: {
          http: {
            method: "GET",
            requestUri: "/campaigns/{id}/state",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              state: {}
            }
          }
        },
        GetCampaignStateBatch: {
          http: {
            requestUri: "/campaigns-state",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "campaignIds"
            ],
            members: {
              campaignIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              successfulRequests: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    campaignId: {},
                    state: {}
                  }
                }
              },
              failedRequests: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    campaignId: {},
                    failureCode: {}
                  }
                }
              }
            }
          }
        },
        GetConnectInstanceConfig: {
          http: {
            method: "GET",
            requestUri: "/connect-instance/{connectInstanceId}/config",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "connectInstanceId"
            ],
            members: {
              connectInstanceId: {
                location: "uri",
                locationName: "connectInstanceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              connectInstanceConfig: {
                type: "structure",
                required: [
                  "connectInstanceId",
                  "serviceLinkedRoleArn",
                  "encryptionConfig"
                ],
                members: {
                  connectInstanceId: {},
                  serviceLinkedRoleArn: {},
                  encryptionConfig: {
                    shape: "S17"
                  }
                }
              }
            }
          }
        },
        GetInstanceOnboardingJobStatus: {
          http: {
            method: "GET",
            requestUri: "/connect-instance/{connectInstanceId}/onboarding",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "connectInstanceId"
            ],
            members: {
              connectInstanceId: {
                location: "uri",
                locationName: "connectInstanceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              connectInstanceOnboardingJobStatus: {
                shape: "S1d"
              }
            }
          }
        },
        ListCampaigns: {
          http: {
            requestUri: "/campaigns-summary",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              filters: {
                type: "structure",
                members: {
                  instanceIdFilter: {
                    type: "structure",
                    required: [
                      "value",
                      "operator"
                    ],
                    members: {
                      value: {},
                      operator: {}
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              campaignSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "arn",
                    "name",
                    "connectInstanceId"
                  ],
                  members: {
                    id: {},
                    arn: {},
                    name: {},
                    connectInstanceId: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {
                location: "uri",
                locationName: "arn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sg"
              }
            }
          },
          idempotent: true
        },
        PauseCampaign: {
          http: {
            requestUri: "/campaigns/{id}/pause",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          }
        },
        PutDialRequestBatch: {
          http: {
            method: "PUT",
            requestUri: "/campaigns/{id}/dial-requests",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id",
              "dialRequests"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              dialRequests: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "clientToken",
                    "phoneNumber",
                    "expirationTime",
                    "attributes"
                  ],
                  members: {
                    clientToken: {},
                    phoneNumber: {
                      type: "string",
                      sensitive: true
                    },
                    expirationTime: {
                      type: "timestamp",
                      timestampFormat: "iso8601"
                    },
                    attributes: {
                      type: "map",
                      key: {},
                      value: {},
                      sensitive: true
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              successfulRequests: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    clientToken: {},
                    id: {}
                  }
                }
              },
              failedRequests: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    clientToken: {},
                    id: {},
                    failureCode: {}
                  }
                }
              }
            }
          },
          idempotent: true
        },
        ResumeCampaign: {
          http: {
            requestUri: "/campaigns/{id}/resume",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          }
        },
        StartCampaign: {
          http: {
            requestUri: "/campaigns/{id}/start",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          }
        },
        StartInstanceOnboardingJob: {
          http: {
            method: "PUT",
            requestUri: "/connect-instance/{connectInstanceId}/onboarding",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "connectInstanceId",
              "encryptionConfig"
            ],
            members: {
              connectInstanceId: {
                location: "uri",
                locationName: "connectInstanceId"
              },
              encryptionConfig: {
                shape: "S17"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              connectInstanceOnboardingJobStatus: {
                shape: "S1d"
              }
            }
          },
          idempotent: true
        },
        StopCampaign: {
          http: {
            requestUri: "/campaigns/{id}/stop",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn",
              "tags"
            ],
            members: {
              arn: {
                location: "uri",
                locationName: "arn"
              },
              tags: {
                shape: "Sg"
              }
            }
          },
          idempotent: true
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn",
              "tagKeys"
            ],
            members: {
              arn: {
                location: "uri",
                locationName: "arn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          idempotent: true
        },
        UpdateCampaignDialerConfig: {
          http: {
            requestUri: "/campaigns/{id}/dialer-config",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id",
              "dialerConfig"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              dialerConfig: {
                shape: "S4"
              }
            }
          },
          idempotent: true
        },
        UpdateCampaignName: {
          http: {
            requestUri: "/campaigns/{id}/name",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id",
              "name"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              name: {}
            }
          },
          idempotent: true
        },
        UpdateCampaignOutboundCallConfig: {
          http: {
            requestUri: "/campaigns/{id}/outbound-call-config",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              connectContactFlowId: {},
              connectSourcePhoneNumber: {},
              answerMachineDetectionConfig: {
                shape: "Se"
              }
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            progressiveDialerConfig: {
              type: "structure",
              required: [
                "bandwidthAllocation"
              ],
              members: {
                bandwidthAllocation: {
                  type: "double"
                },
                dialingCapacity: {
                  type: "double"
                }
              }
            },
            predictiveDialerConfig: {
              type: "structure",
              required: [
                "bandwidthAllocation"
              ],
              members: {
                bandwidthAllocation: {
                  type: "double"
                },
                dialingCapacity: {
                  type: "double"
                }
              }
            },
            agentlessDialerConfig: {
              type: "structure",
              members: {
                dialingCapacity: {
                  type: "double"
                }
              }
            }
          },
          union: true
        },
        Sa: {
          type: "structure",
          required: [
            "connectContactFlowId"
          ],
          members: {
            connectContactFlowId: {},
            connectSourcePhoneNumber: {},
            connectQueueId: {},
            answerMachineDetectionConfig: {
              shape: "Se"
            }
          }
        },
        Se: {
          type: "structure",
          required: [
            "enableAnswerMachineDetection"
          ],
          members: {
            enableAnswerMachineDetection: {
              type: "boolean"
            }
          }
        },
        Sg: {
          type: "map",
          key: {},
          value: {}
        },
        S17: {
          type: "structure",
          required: [
            "enabled"
          ],
          members: {
            enabled: {
              type: "boolean"
            },
            encryptionType: {},
            keyArn: {}
          }
        },
        S1d: {
          type: "structure",
          required: [
            "connectInstanceId",
            "status"
          ],
          members: {
            connectInstanceId: {},
            status: {},
            failureCode: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/connectcampaigns-2021-01-30.paginators.json
var require_connectcampaigns_2021_01_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/connectcampaigns-2021-01-30.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListCampaigns: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "campaignSummaryList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/connectcampaigns.js
var require_connectcampaigns = __commonJS({
  "node_modules/aws-sdk/clients/connectcampaigns.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["connectcampaigns"] = {};
    AWS2.ConnectCampaigns = Service.defineService("connectcampaigns", ["2021-01-30"]);
    Object.defineProperty(apiLoader.services["connectcampaigns"], "2021-01-30", {
      get: function get() {
        var model = require_connectcampaigns_2021_01_30_min();
        model.paginators = require_connectcampaigns_2021_01_30_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ConnectCampaigns;
  }
});

// node_modules/aws-sdk/apis/redshift-serverless-2021-04-21.min.json
var require_redshift_serverless_2021_04_21_min = __commonJS({
  "node_modules/aws-sdk/apis/redshift-serverless-2021-04-21.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-04-21",
        endpointPrefix: "redshift-serverless",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Redshift Serverless",
        serviceId: "Redshift Serverless",
        signatureVersion: "v4",
        signingName: "redshift-serverless",
        targetPrefix: "RedshiftServerless",
        uid: "redshift-serverless-2021-04-21"
      },
      operations: {
        ConvertRecoveryPointToSnapshot: {
          input: {
            type: "structure",
            required: [
              "recoveryPointId",
              "snapshotName"
            ],
            members: {
              recoveryPointId: {},
              retentionPeriod: {
                type: "integer"
              },
              snapshotName: {},
              tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              snapshot: {
                shape: "S9"
              }
            }
          }
        },
        CreateCustomDomainAssociation: {
          input: {
            type: "structure",
            required: [
              "customDomainCertificateArn",
              "customDomainName",
              "workgroupName"
            ],
            members: {
              customDomainCertificateArn: {},
              customDomainName: {},
              workgroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              customDomainCertificateArn: {},
              customDomainCertificateExpiryTime: {
                shape: "Se"
              },
              customDomainName: {},
              workgroupName: {}
            }
          }
        },
        CreateEndpointAccess: {
          input: {
            type: "structure",
            required: [
              "endpointName",
              "subnetIds",
              "workgroupName"
            ],
            members: {
              endpointName: {},
              ownerAccount: {},
              subnetIds: {
                shape: "Sn"
              },
              vpcSecurityGroupIds: {
                shape: "Sp"
              },
              workgroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              endpoint: {
                shape: "Ss"
              }
            }
          },
          idempotent: true
        },
        CreateNamespace: {
          input: {
            type: "structure",
            required: [
              "namespaceName"
            ],
            members: {
              adminPasswordSecretKmsKeyId: {},
              adminUserPassword: {
                shape: "Sz"
              },
              adminUsername: {
                shape: "S10"
              },
              dbName: {},
              defaultIamRoleArn: {},
              iamRoles: {
                shape: "S11"
              },
              kmsKeyId: {},
              logExports: {
                shape: "S13"
              },
              manageAdminPassword: {
                type: "boolean"
              },
              namespaceName: {},
              redshiftIdcApplicationArn: {},
              tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              namespace: {
                shape: "S19"
              }
            }
          },
          idempotent: true
        },
        CreateScheduledAction: {
          input: {
            type: "structure",
            required: [
              "namespaceName",
              "roleArn",
              "schedule",
              "scheduledActionName",
              "targetAction"
            ],
            members: {
              enabled: {
                type: "boolean"
              },
              endTime: {
                type: "timestamp"
              },
              namespaceName: {},
              roleArn: {},
              schedule: {
                shape: "S1d"
              },
              scheduledActionDescription: {},
              scheduledActionName: {},
              startTime: {
                type: "timestamp"
              },
              targetAction: {
                shape: "S1f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              scheduledAction: {
                shape: "S1j"
              }
            }
          },
          idempotent: true
        },
        CreateSnapshot: {
          input: {
            type: "structure",
            required: [
              "namespaceName",
              "snapshotName"
            ],
            members: {
              namespaceName: {},
              retentionPeriod: {
                type: "integer"
              },
              snapshotName: {},
              tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              snapshot: {
                shape: "S9"
              }
            }
          },
          idempotent: true
        },
        CreateSnapshotCopyConfiguration: {
          input: {
            type: "structure",
            required: [
              "destinationRegion",
              "namespaceName"
            ],
            members: {
              destinationKmsKeyId: {},
              destinationRegion: {},
              namespaceName: {},
              snapshotRetentionPeriod: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "snapshotCopyConfiguration"
            ],
            members: {
              snapshotCopyConfiguration: {
                shape: "S1q"
              }
            }
          },
          idempotent: true
        },
        CreateUsageLimit: {
          input: {
            type: "structure",
            required: [
              "amount",
              "resourceArn",
              "usageType"
            ],
            members: {
              amount: {
                type: "long"
              },
              breachAction: {},
              period: {},
              resourceArn: {},
              usageType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              usageLimit: {
                shape: "S1w"
              }
            }
          },
          idempotent: true
        },
        CreateWorkgroup: {
          input: {
            type: "structure",
            required: [
              "namespaceName",
              "workgroupName"
            ],
            members: {
              baseCapacity: {
                type: "integer"
              },
              configParameters: {
                shape: "S1y"
              },
              enhancedVpcRouting: {
                type: "boolean"
              },
              maxCapacity: {
                type: "integer"
              },
              namespaceName: {},
              port: {
                type: "integer"
              },
              publiclyAccessible: {
                type: "boolean"
              },
              securityGroupIds: {
                shape: "S22"
              },
              subnetIds: {
                shape: "Sn"
              },
              tags: {
                shape: "S4"
              },
              workgroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              workgroup: {
                shape: "S25"
              }
            }
          },
          idempotent: true
        },
        DeleteCustomDomainAssociation: {
          input: {
            type: "structure",
            required: [
              "customDomainName",
              "workgroupName"
            ],
            members: {
              customDomainName: {},
              workgroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteEndpointAccess: {
          input: {
            type: "structure",
            required: [
              "endpointName"
            ],
            members: {
              endpointName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              endpoint: {
                shape: "Ss"
              }
            }
          },
          idempotent: true
        },
        DeleteNamespace: {
          input: {
            type: "structure",
            required: [
              "namespaceName"
            ],
            members: {
              finalSnapshotName: {},
              finalSnapshotRetentionPeriod: {
                type: "integer"
              },
              namespaceName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "namespace"
            ],
            members: {
              namespace: {
                shape: "S19"
              }
            }
          },
          idempotent: true
        },
        DeleteResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteScheduledAction: {
          input: {
            type: "structure",
            required: [
              "scheduledActionName"
            ],
            members: {
              scheduledActionName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              scheduledAction: {
                shape: "S1j"
              }
            }
          },
          idempotent: true
        },
        DeleteSnapshot: {
          input: {
            type: "structure",
            required: [
              "snapshotName"
            ],
            members: {
              snapshotName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              snapshot: {
                shape: "S9"
              }
            }
          },
          idempotent: true
        },
        DeleteSnapshotCopyConfiguration: {
          input: {
            type: "structure",
            required: [
              "snapshotCopyConfigurationId"
            ],
            members: {
              snapshotCopyConfigurationId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "snapshotCopyConfiguration"
            ],
            members: {
              snapshotCopyConfiguration: {
                shape: "S1q"
              }
            }
          },
          idempotent: true
        },
        DeleteUsageLimit: {
          input: {
            type: "structure",
            required: [
              "usageLimitId"
            ],
            members: {
              usageLimitId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              usageLimit: {
                shape: "S1w"
              }
            }
          },
          idempotent: true
        },
        DeleteWorkgroup: {
          input: {
            type: "structure",
            required: [
              "workgroupName"
            ],
            members: {
              workgroupName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "workgroup"
            ],
            members: {
              workgroup: {
                shape: "S25"
              }
            }
          },
          idempotent: true
        },
        GetCredentials: {
          input: {
            type: "structure",
            members: {
              customDomainName: {},
              dbName: {},
              durationSeconds: {
                type: "integer"
              },
              workgroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              dbPassword: {
                shape: "Sz"
              },
              dbUser: {
                shape: "S10"
              },
              expiration: {
                type: "timestamp"
              },
              nextRefreshTime: {
                type: "timestamp"
              }
            }
          }
        },
        GetCustomDomainAssociation: {
          input: {
            type: "structure",
            required: [
              "customDomainName",
              "workgroupName"
            ],
            members: {
              customDomainName: {},
              workgroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              customDomainCertificateArn: {},
              customDomainCertificateExpiryTime: {
                shape: "Se"
              },
              customDomainName: {},
              workgroupName: {}
            }
          }
        },
        GetEndpointAccess: {
          input: {
            type: "structure",
            required: [
              "endpointName"
            ],
            members: {
              endpointName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              endpoint: {
                shape: "Ss"
              }
            }
          }
        },
        GetNamespace: {
          input: {
            type: "structure",
            required: [
              "namespaceName"
            ],
            members: {
              namespaceName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "namespace"
            ],
            members: {
              namespace: {
                shape: "S19"
              }
            }
          }
        },
        GetRecoveryPoint: {
          input: {
            type: "structure",
            required: [
              "recoveryPointId"
            ],
            members: {
              recoveryPointId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              recoveryPoint: {
                shape: "S33"
              }
            }
          }
        },
        GetResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              resourcePolicy: {
                shape: "S36"
              }
            }
          }
        },
        GetScheduledAction: {
          input: {
            type: "structure",
            required: [
              "scheduledActionName"
            ],
            members: {
              scheduledActionName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              scheduledAction: {
                shape: "S1j"
              }
            }
          }
        },
        GetSnapshot: {
          input: {
            type: "structure",
            members: {
              ownerAccount: {},
              snapshotArn: {},
              snapshotName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              snapshot: {
                shape: "S9"
              }
            }
          }
        },
        GetTableRestoreStatus: {
          input: {
            type: "structure",
            required: [
              "tableRestoreRequestId"
            ],
            members: {
              tableRestoreRequestId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tableRestoreStatus: {
                shape: "S3d"
              }
            }
          }
        },
        GetUsageLimit: {
          input: {
            type: "structure",
            required: [
              "usageLimitId"
            ],
            members: {
              usageLimitId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              usageLimit: {
                shape: "S1w"
              }
            }
          }
        },
        GetWorkgroup: {
          input: {
            type: "structure",
            required: [
              "workgroupName"
            ],
            members: {
              workgroupName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "workgroup"
            ],
            members: {
              workgroup: {
                shape: "S25"
              }
            }
          }
        },
        ListCustomDomainAssociations: {
          input: {
            type: "structure",
            members: {
              customDomainCertificateArn: {},
              customDomainName: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              associations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    customDomainCertificateArn: {},
                    customDomainCertificateExpiryTime: {
                      shape: "Se"
                    },
                    customDomainName: {},
                    workgroupName: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListEndpointAccess: {
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              ownerAccount: {},
              vpcId: {},
              workgroupName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "endpoints"
            ],
            members: {
              endpoints: {
                type: "list",
                member: {
                  shape: "Ss"
                }
              },
              nextToken: {}
            }
          }
        },
        ListNamespaces: {
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "namespaces"
            ],
            members: {
              namespaces: {
                type: "list",
                member: {
                  shape: "S19"
                }
              },
              nextToken: {}
            }
          }
        },
        ListRecoveryPoints: {
          input: {
            type: "structure",
            members: {
              endTime: {
                type: "timestamp"
              },
              maxResults: {
                type: "integer"
              },
              namespaceArn: {},
              namespaceName: {},
              nextToken: {},
              startTime: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              recoveryPoints: {
                type: "list",
                member: {
                  shape: "S33"
                }
              }
            }
          }
        },
        ListScheduledActions: {
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              namespaceName: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              scheduledActions: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ListSnapshotCopyConfigurations: {
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              namespaceName: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "snapshotCopyConfigurations"
            ],
            members: {
              nextToken: {},
              snapshotCopyConfigurations: {
                type: "list",
                member: {
                  shape: "S1q"
                }
              }
            }
          }
        },
        ListSnapshots: {
          input: {
            type: "structure",
            members: {
              endTime: {
                type: "timestamp"
              },
              maxResults: {
                type: "integer"
              },
              namespaceArn: {},
              namespaceName: {},
              nextToken: {},
              ownerAccount: {},
              startTime: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              snapshots: {
                type: "list",
                member: {
                  shape: "S9"
                }
              }
            }
          }
        },
        ListTableRestoreStatus: {
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              namespaceName: {},
              nextToken: {},
              workgroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              tableRestoreStatuses: {
                type: "list",
                member: {
                  shape: "S3d"
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S4"
              }
            }
          }
        },
        ListUsageLimits: {
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              resourceArn: {},
              usageType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              usageLimits: {
                type: "list",
                member: {
                  shape: "S1w"
                }
              }
            }
          }
        },
        ListWorkgroups: {
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              ownerAccount: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "workgroups"
            ],
            members: {
              nextToken: {},
              workgroups: {
                type: "list",
                member: {
                  shape: "S25"
                }
              }
            }
          }
        },
        PutResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "policy",
              "resourceArn"
            ],
            members: {
              policy: {},
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              resourcePolicy: {
                shape: "S36"
              }
            }
          }
        },
        RestoreFromRecoveryPoint: {
          input: {
            type: "structure",
            required: [
              "namespaceName",
              "recoveryPointId",
              "workgroupName"
            ],
            members: {
              namespaceName: {},
              recoveryPointId: {},
              workgroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              namespace: {
                shape: "S19"
              },
              recoveryPointId: {}
            }
          }
        },
        RestoreFromSnapshot: {
          input: {
            type: "structure",
            required: [
              "namespaceName",
              "workgroupName"
            ],
            members: {
              adminPasswordSecretKmsKeyId: {},
              manageAdminPassword: {
                type: "boolean"
              },
              namespaceName: {},
              ownerAccount: {},
              snapshotArn: {},
              snapshotName: {},
              workgroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              namespace: {
                shape: "S19"
              },
              ownerAccount: {},
              snapshotName: {}
            }
          },
          idempotent: true
        },
        RestoreTableFromRecoveryPoint: {
          input: {
            type: "structure",
            required: [
              "namespaceName",
              "newTableName",
              "recoveryPointId",
              "sourceDatabaseName",
              "sourceTableName",
              "workgroupName"
            ],
            members: {
              activateCaseSensitiveIdentifier: {
                type: "boolean"
              },
              namespaceName: {},
              newTableName: {},
              recoveryPointId: {},
              sourceDatabaseName: {},
              sourceSchemaName: {},
              sourceTableName: {},
              targetDatabaseName: {},
              targetSchemaName: {},
              workgroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tableRestoreStatus: {
                shape: "S3d"
              }
            }
          }
        },
        RestoreTableFromSnapshot: {
          input: {
            type: "structure",
            required: [
              "namespaceName",
              "newTableName",
              "snapshotName",
              "sourceDatabaseName",
              "sourceTableName",
              "workgroupName"
            ],
            members: {
              activateCaseSensitiveIdentifier: {
                type: "boolean"
              },
              namespaceName: {},
              newTableName: {},
              snapshotName: {},
              sourceDatabaseName: {},
              sourceSchemaName: {},
              sourceTableName: {},
              targetDatabaseName: {},
              targetSchemaName: {},
              workgroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tableRestoreStatus: {
                shape: "S3d"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateCustomDomainAssociation: {
          input: {
            type: "structure",
            required: [
              "customDomainCertificateArn",
              "customDomainName",
              "workgroupName"
            ],
            members: {
              customDomainCertificateArn: {},
              customDomainName: {},
              workgroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              customDomainCertificateArn: {},
              customDomainCertificateExpiryTime: {
                shape: "Se"
              },
              customDomainName: {},
              workgroupName: {}
            }
          }
        },
        UpdateEndpointAccess: {
          input: {
            type: "structure",
            required: [
              "endpointName"
            ],
            members: {
              endpointName: {},
              vpcSecurityGroupIds: {
                shape: "Sp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              endpoint: {
                shape: "Ss"
              }
            }
          }
        },
        UpdateNamespace: {
          input: {
            type: "structure",
            required: [
              "namespaceName"
            ],
            members: {
              adminPasswordSecretKmsKeyId: {},
              adminUserPassword: {
                shape: "Sz"
              },
              adminUsername: {
                shape: "S10"
              },
              defaultIamRoleArn: {},
              iamRoles: {
                shape: "S11"
              },
              kmsKeyId: {},
              logExports: {
                shape: "S13"
              },
              manageAdminPassword: {
                type: "boolean"
              },
              namespaceName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "namespace"
            ],
            members: {
              namespace: {
                shape: "S19"
              }
            }
          }
        },
        UpdateScheduledAction: {
          input: {
            type: "structure",
            required: [
              "scheduledActionName"
            ],
            members: {
              enabled: {
                type: "boolean"
              },
              endTime: {
                type: "timestamp"
              },
              roleArn: {},
              schedule: {
                shape: "S1d"
              },
              scheduledActionDescription: {},
              scheduledActionName: {},
              startTime: {
                type: "timestamp"
              },
              targetAction: {
                shape: "S1f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              scheduledAction: {
                shape: "S1j"
              }
            }
          },
          idempotent: true
        },
        UpdateSnapshot: {
          input: {
            type: "structure",
            required: [
              "snapshotName"
            ],
            members: {
              retentionPeriod: {
                type: "integer"
              },
              snapshotName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              snapshot: {
                shape: "S9"
              }
            }
          }
        },
        UpdateSnapshotCopyConfiguration: {
          input: {
            type: "structure",
            required: [
              "snapshotCopyConfigurationId"
            ],
            members: {
              snapshotCopyConfigurationId: {},
              snapshotRetentionPeriod: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "snapshotCopyConfiguration"
            ],
            members: {
              snapshotCopyConfiguration: {
                shape: "S1q"
              }
            }
          }
        },
        UpdateUsageLimit: {
          input: {
            type: "structure",
            required: [
              "usageLimitId"
            ],
            members: {
              amount: {
                type: "long"
              },
              breachAction: {},
              usageLimitId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              usageLimit: {
                shape: "S1w"
              }
            }
          }
        },
        UpdateWorkgroup: {
          input: {
            type: "structure",
            required: [
              "workgroupName"
            ],
            members: {
              baseCapacity: {
                type: "integer"
              },
              configParameters: {
                shape: "S1y"
              },
              enhancedVpcRouting: {
                type: "boolean"
              },
              maxCapacity: {
                type: "integer"
              },
              port: {
                type: "integer"
              },
              publiclyAccessible: {
                type: "boolean"
              },
              securityGroupIds: {
                shape: "S22"
              },
              subnetIds: {
                shape: "Sn"
              },
              workgroupName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "workgroup"
            ],
            members: {
              workgroup: {
                shape: "S25"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        S9: {
          type: "structure",
          members: {
            accountsWithProvisionedRestoreAccess: {
              shape: "Sa"
            },
            accountsWithRestoreAccess: {
              shape: "Sa"
            },
            actualIncrementalBackupSizeInMegaBytes: {
              type: "double"
            },
            adminPasswordSecretArn: {},
            adminPasswordSecretKmsKeyId: {},
            adminUsername: {},
            backupProgressInMegaBytes: {
              type: "double"
            },
            currentBackupRateInMegaBytesPerSecond: {
              type: "double"
            },
            elapsedTimeInSeconds: {
              type: "long"
            },
            estimatedSecondsToCompletion: {
              type: "long"
            },
            kmsKeyId: {},
            namespaceArn: {},
            namespaceName: {},
            ownerAccount: {},
            snapshotArn: {},
            snapshotCreateTime: {
              shape: "Se"
            },
            snapshotName: {},
            snapshotRemainingDays: {
              type: "integer"
            },
            snapshotRetentionPeriod: {
              type: "integer"
            },
            snapshotRetentionStartTime: {
              shape: "Se"
            },
            status: {},
            totalBackupSizeInMegaBytes: {
              type: "double"
            }
          }
        },
        Sa: {
          type: "list",
          member: {}
        },
        Se: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        Sn: {
          type: "list",
          member: {}
        },
        Sp: {
          type: "list",
          member: {}
        },
        Ss: {
          type: "structure",
          members: {
            address: {},
            endpointArn: {},
            endpointCreateTime: {
              shape: "Se"
            },
            endpointName: {},
            endpointStatus: {},
            port: {
              type: "integer"
            },
            subnetIds: {
              shape: "Sn"
            },
            vpcEndpoint: {
              shape: "St"
            },
            vpcSecurityGroups: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  status: {},
                  vpcSecurityGroupId: {}
                }
              }
            },
            workgroupName: {}
          }
        },
        St: {
          type: "structure",
          members: {
            networkInterfaces: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  availabilityZone: {},
                  networkInterfaceId: {},
                  privateIpAddress: {},
                  subnetId: {}
                }
              }
            },
            vpcEndpointId: {},
            vpcId: {}
          }
        },
        Sz: {
          type: "string",
          sensitive: true
        },
        S10: {
          type: "string",
          sensitive: true
        },
        S11: {
          type: "list",
          member: {}
        },
        S13: {
          type: "list",
          member: {}
        },
        S19: {
          type: "structure",
          members: {
            adminPasswordSecretArn: {},
            adminPasswordSecretKmsKeyId: {},
            adminUsername: {
              shape: "S10"
            },
            creationDate: {
              shape: "Se"
            },
            dbName: {},
            defaultIamRoleArn: {},
            iamRoles: {
              shape: "S11"
            },
            kmsKeyId: {},
            logExports: {
              shape: "S13"
            },
            namespaceArn: {},
            namespaceId: {},
            namespaceName: {},
            status: {}
          }
        },
        S1d: {
          type: "structure",
          members: {
            at: {
              type: "timestamp"
            },
            cron: {}
          },
          union: true
        },
        S1f: {
          type: "structure",
          members: {
            createSnapshot: {
              type: "structure",
              required: [
                "namespaceName",
                "snapshotNamePrefix"
              ],
              members: {
                namespaceName: {},
                retentionPeriod: {
                  type: "integer"
                },
                snapshotNamePrefix: {},
                tags: {
                  shape: "S4"
                }
              }
            }
          },
          union: true
        },
        S1j: {
          type: "structure",
          members: {
            endTime: {
              type: "timestamp"
            },
            namespaceName: {},
            nextInvocations: {
              type: "list",
              member: {
                type: "timestamp"
              }
            },
            roleArn: {},
            schedule: {
              shape: "S1d"
            },
            scheduledActionDescription: {},
            scheduledActionName: {},
            scheduledActionUuid: {},
            startTime: {
              type: "timestamp"
            },
            state: {},
            targetAction: {
              shape: "S1f"
            }
          }
        },
        S1q: {
          type: "structure",
          members: {
            destinationKmsKeyId: {},
            destinationRegion: {},
            namespaceName: {},
            snapshotCopyConfigurationArn: {},
            snapshotCopyConfigurationId: {},
            snapshotRetentionPeriod: {
              type: "integer"
            }
          }
        },
        S1w: {
          type: "structure",
          members: {
            amount: {
              type: "long"
            },
            breachAction: {},
            period: {},
            resourceArn: {},
            usageLimitArn: {},
            usageLimitId: {},
            usageType: {}
          }
        },
        S1y: {
          type: "list",
          member: {
            type: "structure",
            members: {
              parameterKey: {},
              parameterValue: {}
            }
          }
        },
        S22: {
          type: "list",
          member: {}
        },
        S25: {
          type: "structure",
          members: {
            baseCapacity: {
              type: "integer"
            },
            configParameters: {
              shape: "S1y"
            },
            creationDate: {
              shape: "Se"
            },
            crossAccountVpcs: {
              type: "list",
              member: {}
            },
            customDomainCertificateArn: {},
            customDomainCertificateExpiryTime: {
              shape: "Se"
            },
            customDomainName: {},
            endpoint: {
              type: "structure",
              members: {
                address: {},
                port: {
                  type: "integer"
                },
                vpcEndpoints: {
                  type: "list",
                  member: {
                    shape: "St"
                  }
                }
              }
            },
            enhancedVpcRouting: {
              type: "boolean"
            },
            maxCapacity: {
              type: "integer"
            },
            namespaceName: {},
            patchVersion: {},
            port: {
              type: "integer"
            },
            publiclyAccessible: {
              type: "boolean"
            },
            securityGroupIds: {
              shape: "S22"
            },
            status: {},
            subnetIds: {
              shape: "Sn"
            },
            workgroupArn: {},
            workgroupId: {},
            workgroupName: {},
            workgroupVersion: {}
          }
        },
        S33: {
          type: "structure",
          members: {
            namespaceArn: {},
            namespaceName: {},
            recoveryPointCreateTime: {
              shape: "Se"
            },
            recoveryPointId: {},
            totalSizeInMegaBytes: {
              type: "double"
            },
            workgroupName: {}
          }
        },
        S36: {
          type: "structure",
          members: {
            policy: {},
            resourceArn: {}
          }
        },
        S3d: {
          type: "structure",
          members: {
            message: {},
            namespaceName: {},
            newTableName: {},
            progressInMegaBytes: {
              type: "long"
            },
            recoveryPointId: {},
            requestTime: {
              type: "timestamp"
            },
            snapshotName: {},
            sourceDatabaseName: {},
            sourceSchemaName: {},
            sourceTableName: {},
            status: {},
            tableRestoreRequestId: {},
            targetDatabaseName: {},
            targetSchemaName: {},
            totalDataInMegaBytes: {
              type: "long"
            },
            workgroupName: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/redshift-serverless-2021-04-21.paginators.json
var require_redshift_serverless_2021_04_21_paginators = __commonJS({
  "node_modules/aws-sdk/apis/redshift-serverless-2021-04-21.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListCustomDomainAssociations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "associations"
        },
        ListEndpointAccess: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "endpoints"
        },
        ListNamespaces: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "namespaces"
        },
        ListRecoveryPoints: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "recoveryPoints"
        },
        ListScheduledActions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "scheduledActions"
        },
        ListSnapshotCopyConfigurations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "snapshotCopyConfigurations"
        },
        ListSnapshots: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "snapshots"
        },
        ListTableRestoreStatus: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "tableRestoreStatuses"
        },
        ListUsageLimits: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "usageLimits"
        },
        ListWorkgroups: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "workgroups"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/redshiftserverless.js
var require_redshiftserverless = __commonJS({
  "node_modules/aws-sdk/clients/redshiftserverless.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["redshiftserverless"] = {};
    AWS2.RedshiftServerless = Service.defineService("redshiftserverless", ["2021-04-21"]);
    Object.defineProperty(apiLoader.services["redshiftserverless"], "2021-04-21", {
      get: function get() {
        var model = require_redshift_serverless_2021_04_21_min();
        model.paginators = require_redshift_serverless_2021_04_21_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.RedshiftServerless;
  }
});

// node_modules/aws-sdk/apis/rolesanywhere-2018-05-10.min.json
var require_rolesanywhere_2018_05_10_min = __commonJS({
  "node_modules/aws-sdk/apis/rolesanywhere-2018-05-10.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-05-10",
        endpointPrefix: "rolesanywhere",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "IAM Roles Anywhere",
        serviceId: "RolesAnywhere",
        signatureVersion: "v4",
        signingName: "rolesanywhere",
        uid: "rolesanywhere-2018-05-10"
      },
      operations: {
        CreateProfile: {
          http: {
            requestUri: "/profiles",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "name",
              "roleArns"
            ],
            members: {
              durationSeconds: {
                type: "integer"
              },
              enabled: {
                type: "boolean"
              },
              managedPolicyArns: {
                shape: "S4"
              },
              name: {},
              requireInstanceProperties: {
                type: "boolean"
              },
              roleArns: {
                shape: "S7"
              },
              sessionPolicy: {},
              tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            shape: "Se"
          }
        },
        CreateTrustAnchor: {
          http: {
            requestUri: "/trustanchors",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "name",
              "source"
            ],
            members: {
              enabled: {
                type: "boolean"
              },
              name: {},
              notificationSettings: {
                shape: "Sl"
              },
              source: {
                shape: "Sq"
              },
              tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            shape: "Su"
          }
        },
        DeleteCrl: {
          http: {
            method: "DELETE",
            requestUri: "/crl/{crlId}",
            responseCode: 200
          },
          input: {
            shape: "S10"
          },
          output: {
            shape: "S11"
          },
          idempotent: true
        },
        DeleteProfile: {
          http: {
            method: "DELETE",
            requestUri: "/profile/{profileId}",
            responseCode: 200
          },
          input: {
            shape: "S14"
          },
          output: {
            shape: "Se"
          },
          idempotent: true
        },
        DeleteTrustAnchor: {
          http: {
            method: "DELETE",
            requestUri: "/trustanchor/{trustAnchorId}",
            responseCode: 200
          },
          input: {
            shape: "S15"
          },
          output: {
            shape: "Su"
          },
          idempotent: true
        },
        DisableCrl: {
          http: {
            requestUri: "/crl/{crlId}/disable",
            responseCode: 200
          },
          input: {
            shape: "S10"
          },
          output: {
            shape: "S11"
          }
        },
        DisableProfile: {
          http: {
            requestUri: "/profile/{profileId}/disable",
            responseCode: 200
          },
          input: {
            shape: "S14"
          },
          output: {
            shape: "Se"
          }
        },
        DisableTrustAnchor: {
          http: {
            requestUri: "/trustanchor/{trustAnchorId}/disable",
            responseCode: 200
          },
          input: {
            shape: "S15"
          },
          output: {
            shape: "Su"
          }
        },
        EnableCrl: {
          http: {
            requestUri: "/crl/{crlId}/enable",
            responseCode: 200
          },
          input: {
            shape: "S10"
          },
          output: {
            shape: "S11"
          }
        },
        EnableProfile: {
          http: {
            requestUri: "/profile/{profileId}/enable",
            responseCode: 200
          },
          input: {
            shape: "S14"
          },
          output: {
            shape: "Se"
          }
        },
        EnableTrustAnchor: {
          http: {
            requestUri: "/trustanchor/{trustAnchorId}/enable",
            responseCode: 200
          },
          input: {
            shape: "S15"
          },
          output: {
            shape: "Su"
          }
        },
        GetCrl: {
          http: {
            method: "GET",
            requestUri: "/crl/{crlId}",
            responseCode: 200
          },
          input: {
            shape: "S10"
          },
          output: {
            shape: "S11"
          }
        },
        GetProfile: {
          http: {
            method: "GET",
            requestUri: "/profile/{profileId}",
            responseCode: 200
          },
          input: {
            shape: "S14"
          },
          output: {
            shape: "Se"
          }
        },
        GetSubject: {
          http: {
            method: "GET",
            requestUri: "/subject/{subjectId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "subjectId"
            ],
            members: {
              subjectId: {
                location: "uri",
                locationName: "subjectId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              subject: {
                type: "structure",
                members: {
                  createdAt: {
                    shape: "Sg"
                  },
                  credentials: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        enabled: {
                          type: "boolean"
                        },
                        failed: {
                          type: "boolean"
                        },
                        issuer: {},
                        seenAt: {
                          shape: "Sg"
                        },
                        serialNumber: {},
                        x509CertificateData: {}
                      }
                    }
                  },
                  enabled: {
                    type: "boolean"
                  },
                  instanceProperties: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        failed: {
                          type: "boolean"
                        },
                        properties: {
                          type: "map",
                          key: {},
                          value: {}
                        },
                        seenAt: {
                          shape: "Sg"
                        }
                      }
                    }
                  },
                  lastSeenAt: {
                    shape: "Sg"
                  },
                  subjectArn: {},
                  subjectId: {},
                  updatedAt: {
                    shape: "Sg"
                  },
                  x509Subject: {}
                }
              }
            }
          }
        },
        GetTrustAnchor: {
          http: {
            method: "GET",
            requestUri: "/trustanchor/{trustAnchorId}",
            responseCode: 200
          },
          input: {
            shape: "S15"
          },
          output: {
            shape: "Su"
          }
        },
        ImportCrl: {
          http: {
            requestUri: "/crls",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "crlData",
              "name",
              "trustAnchorArn"
            ],
            members: {
              crlData: {
                type: "blob"
              },
              enabled: {
                type: "boolean"
              },
              name: {},
              tags: {
                shape: "Sa"
              },
              trustAnchorArn: {}
            }
          },
          output: {
            shape: "S11"
          }
        },
        ListCrls: {
          http: {
            method: "GET",
            requestUri: "/crls",
            responseCode: 200
          },
          input: {
            shape: "S1j"
          },
          output: {
            type: "structure",
            members: {
              crls: {
                type: "list",
                member: {
                  shape: "S12"
                }
              },
              nextToken: {}
            }
          }
        },
        ListProfiles: {
          http: {
            method: "GET",
            requestUri: "/profiles",
            responseCode: 200
          },
          input: {
            shape: "S1j"
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              profiles: {
                type: "list",
                member: {
                  shape: "Sf"
                }
              }
            }
          }
        },
        ListSubjects: {
          http: {
            method: "GET",
            requestUri: "/subjects",
            responseCode: 200
          },
          input: {
            shape: "S1j"
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              subjects: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    createdAt: {
                      shape: "Sg"
                    },
                    enabled: {
                      type: "boolean"
                    },
                    lastSeenAt: {
                      shape: "Sg"
                    },
                    subjectArn: {},
                    subjectId: {},
                    updatedAt: {
                      shape: "Sg"
                    },
                    x509Subject: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/ListTagsForResource",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sa"
              }
            }
          }
        },
        ListTrustAnchors: {
          http: {
            method: "GET",
            requestUri: "/trustanchors",
            responseCode: 200
          },
          input: {
            shape: "S1j"
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              trustAnchors: {
                type: "list",
                member: {
                  shape: "Sv"
                }
              }
            }
          }
        },
        PutNotificationSettings: {
          http: {
            method: "PATCH",
            requestUri: "/put-notifications-settings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "notificationSettings",
              "trustAnchorId"
            ],
            members: {
              notificationSettings: {
                shape: "Sl"
              },
              trustAnchorId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "trustAnchor"
            ],
            members: {
              trustAnchor: {
                shape: "Sv"
              }
            }
          }
        },
        ResetNotificationSettings: {
          http: {
            method: "PATCH",
            requestUri: "/reset-notifications-settings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "notificationSettingKeys",
              "trustAnchorId"
            ],
            members: {
              notificationSettingKeys: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "event"
                  ],
                  members: {
                    channel: {},
                    event: {}
                  }
                }
              },
              trustAnchorId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "trustAnchor"
            ],
            members: {
              trustAnchor: {
                shape: "Sv"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/TagResource",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            requestUri: "/UntagResource",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {
                  shape: "Sc"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateCrl: {
          http: {
            method: "PATCH",
            requestUri: "/crl/{crlId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "crlId"
            ],
            members: {
              crlData: {
                type: "blob"
              },
              crlId: {
                location: "uri",
                locationName: "crlId"
              },
              name: {}
            }
          },
          output: {
            shape: "S11"
          }
        },
        UpdateProfile: {
          http: {
            method: "PATCH",
            requestUri: "/profile/{profileId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "profileId"
            ],
            members: {
              durationSeconds: {
                type: "integer"
              },
              managedPolicyArns: {
                shape: "S4"
              },
              name: {},
              profileId: {
                location: "uri",
                locationName: "profileId"
              },
              roleArns: {
                shape: "S7"
              },
              sessionPolicy: {}
            }
          },
          output: {
            shape: "Se"
          },
          idempotent: true
        },
        UpdateTrustAnchor: {
          http: {
            method: "PATCH",
            requestUri: "/trustanchor/{trustAnchorId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "trustAnchorId"
            ],
            members: {
              name: {},
              source: {
                shape: "Sq"
              },
              trustAnchorId: {
                location: "uri",
                locationName: "trustAnchorId"
              }
            }
          },
          output: {
            shape: "Su"
          },
          idempotent: true
        }
      },
      shapes: {
        S4: {
          type: "list",
          member: {}
        },
        S7: {
          type: "list",
          member: {}
        },
        Sa: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {
                shape: "Sc"
              },
              value: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        Sc: {
          type: "string",
          sensitive: true
        },
        Se: {
          type: "structure",
          members: {
            profile: {
              shape: "Sf"
            }
          }
        },
        Sf: {
          type: "structure",
          members: {
            createdAt: {
              shape: "Sg"
            },
            createdBy: {},
            durationSeconds: {
              type: "integer"
            },
            enabled: {
              type: "boolean"
            },
            managedPolicyArns: {
              shape: "S4"
            },
            name: {},
            profileArn: {},
            profileId: {},
            requireInstanceProperties: {
              type: "boolean"
            },
            roleArns: {
              shape: "S7"
            },
            sessionPolicy: {},
            updatedAt: {
              shape: "Sg"
            }
          }
        },
        Sg: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        Sl: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "enabled",
              "event"
            ],
            members: {
              channel: {},
              enabled: {
                type: "boolean"
              },
              event: {},
              threshold: {
                type: "integer"
              }
            }
          }
        },
        Sq: {
          type: "structure",
          members: {
            sourceData: {
              type: "structure",
              members: {
                acmPcaArn: {},
                x509CertificateData: {}
              },
              union: true
            },
            sourceType: {}
          }
        },
        Su: {
          type: "structure",
          required: [
            "trustAnchor"
          ],
          members: {
            trustAnchor: {
              shape: "Sv"
            }
          }
        },
        Sv: {
          type: "structure",
          members: {
            createdAt: {
              shape: "Sg"
            },
            enabled: {
              type: "boolean"
            },
            name: {},
            notificationSettings: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "enabled",
                  "event"
                ],
                members: {
                  channel: {},
                  configuredBy: {},
                  enabled: {
                    type: "boolean"
                  },
                  event: {},
                  threshold: {
                    type: "integer"
                  }
                }
              }
            },
            source: {
              shape: "Sq"
            },
            trustAnchorArn: {},
            trustAnchorId: {},
            updatedAt: {
              shape: "Sg"
            }
          }
        },
        S10: {
          type: "structure",
          required: [
            "crlId"
          ],
          members: {
            crlId: {
              location: "uri",
              locationName: "crlId"
            }
          }
        },
        S11: {
          type: "structure",
          required: [
            "crl"
          ],
          members: {
            crl: {
              shape: "S12"
            }
          }
        },
        S12: {
          type: "structure",
          members: {
            createdAt: {
              shape: "Sg"
            },
            crlArn: {},
            crlData: {
              type: "blob"
            },
            crlId: {},
            enabled: {
              type: "boolean"
            },
            name: {},
            trustAnchorArn: {},
            updatedAt: {
              shape: "Sg"
            }
          }
        },
        S14: {
          type: "structure",
          required: [
            "profileId"
          ],
          members: {
            profileId: {
              location: "uri",
              locationName: "profileId"
            }
          }
        },
        S15: {
          type: "structure",
          required: [
            "trustAnchorId"
          ],
          members: {
            trustAnchorId: {
              location: "uri",
              locationName: "trustAnchorId"
            }
          }
        },
        S1j: {
          type: "structure",
          members: {
            nextToken: {
              location: "querystring",
              locationName: "nextToken"
            },
            pageSize: {
              location: "querystring",
              locationName: "pageSize",
              type: "integer"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/rolesanywhere-2018-05-10.paginators.json
var require_rolesanywhere_2018_05_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/rolesanywhere-2018-05-10.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListCrls: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "crls"
        },
        ListProfiles: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "profiles"
        },
        ListSubjects: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "subjects"
        },
        ListTrustAnchors: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "trustAnchors"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/rolesanywhere.js
var require_rolesanywhere = __commonJS({
  "node_modules/aws-sdk/clients/rolesanywhere.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["rolesanywhere"] = {};
    AWS2.RolesAnywhere = Service.defineService("rolesanywhere", ["2018-05-10"]);
    Object.defineProperty(apiLoader.services["rolesanywhere"], "2018-05-10", {
      get: function get() {
        var model = require_rolesanywhere_2018_05_10_min();
        model.paginators = require_rolesanywhere_2018_05_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.RolesAnywhere;
  }
});

// node_modules/aws-sdk/apis/license-manager-user-subscriptions-2018-05-10.min.json
var require_license_manager_user_subscriptions_2018_05_10_min = __commonJS({
  "node_modules/aws-sdk/apis/license-manager-user-subscriptions-2018-05-10.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-05-10",
        endpointPrefix: "license-manager-user-subscriptions",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS License Manager User Subscriptions",
        serviceId: "License Manager User Subscriptions",
        signatureVersion: "v4",
        signingName: "license-manager-user-subscriptions",
        uid: "license-manager-user-subscriptions-2018-05-10"
      },
      operations: {
        AssociateUser: {
          http: {
            requestUri: "/user/AssociateUser",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityProvider",
              "InstanceId",
              "Username"
            ],
            members: {
              Domain: {},
              IdentityProvider: {
                shape: "S3"
              },
              InstanceId: {},
              Username: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "InstanceUserSummary"
            ],
            members: {
              InstanceUserSummary: {
                shape: "S6"
              }
            }
          },
          idempotent: true
        },
        DeregisterIdentityProvider: {
          http: {
            requestUri: "/identity-provider/DeregisterIdentityProvider",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityProvider",
              "Product"
            ],
            members: {
              IdentityProvider: {
                shape: "S3"
              },
              Product: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "IdentityProviderSummary"
            ],
            members: {
              IdentityProviderSummary: {
                shape: "S9"
              }
            }
          },
          idempotent: true
        },
        DisassociateUser: {
          http: {
            requestUri: "/user/DisassociateUser",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityProvider",
              "InstanceId",
              "Username"
            ],
            members: {
              Domain: {},
              IdentityProvider: {
                shape: "S3"
              },
              InstanceId: {},
              Username: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "InstanceUserSummary"
            ],
            members: {
              InstanceUserSummary: {
                shape: "S6"
              }
            }
          },
          idempotent: true
        },
        ListIdentityProviders: {
          http: {
            requestUri: "/identity-provider/ListIdentityProviders",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "IdentityProviderSummaries"
            ],
            members: {
              IdentityProviderSummaries: {
                type: "list",
                member: {
                  shape: "S9"
                }
              },
              NextToken: {}
            }
          }
        },
        ListInstances: {
          http: {
            requestUri: "/instance/ListInstances",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Sl"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "InstanceId",
                    "Products",
                    "Status"
                  ],
                  members: {
                    InstanceId: {},
                    LastStatusCheckDate: {},
                    Products: {
                      type: "list",
                      member: {}
                    },
                    Status: {},
                    StatusMessage: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListProductSubscriptions: {
          http: {
            requestUri: "/user/ListProductSubscriptions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityProvider",
              "Product"
            ],
            members: {
              Filters: {
                shape: "Sl"
              },
              IdentityProvider: {
                shape: "S3"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Product: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ProductUserSummaries: {
                type: "list",
                member: {
                  shape: "Su"
                }
              }
            }
          }
        },
        ListUserAssociations: {
          http: {
            requestUri: "/user/ListUserAssociations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityProvider",
              "InstanceId"
            ],
            members: {
              Filters: {
                shape: "Sl"
              },
              IdentityProvider: {
                shape: "S3"
              },
              InstanceId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceUserSummaries: {
                type: "list",
                member: {
                  shape: "S6"
                }
              },
              NextToken: {}
            }
          }
        },
        RegisterIdentityProvider: {
          http: {
            requestUri: "/identity-provider/RegisterIdentityProvider",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityProvider",
              "Product"
            ],
            members: {
              IdentityProvider: {
                shape: "S3"
              },
              Product: {},
              Settings: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "IdentityProviderSummary"
            ],
            members: {
              IdentityProviderSummary: {
                shape: "S9"
              }
            }
          },
          idempotent: true
        },
        StartProductSubscription: {
          http: {
            requestUri: "/user/StartProductSubscription",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityProvider",
              "Product",
              "Username"
            ],
            members: {
              Domain: {},
              IdentityProvider: {
                shape: "S3"
              },
              Product: {},
              Username: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ProductUserSummary"
            ],
            members: {
              ProductUserSummary: {
                shape: "Su"
              }
            }
          }
        },
        StopProductSubscription: {
          http: {
            requestUri: "/user/StopProductSubscription",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityProvider",
              "Product",
              "Username"
            ],
            members: {
              Domain: {},
              IdentityProvider: {
                shape: "S3"
              },
              Product: {},
              Username: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ProductUserSummary"
            ],
            members: {
              ProductUserSummary: {
                shape: "Su"
              }
            }
          }
        },
        UpdateIdentityProviderSettings: {
          http: {
            requestUri: "/identity-provider/UpdateIdentityProviderSettings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityProvider",
              "Product",
              "UpdateSettings"
            ],
            members: {
              IdentityProvider: {
                shape: "S3"
              },
              Product: {},
              UpdateSettings: {
                type: "structure",
                required: [
                  "AddSubnets",
                  "RemoveSubnets"
                ],
                members: {
                  AddSubnets: {
                    shape: "S16"
                  },
                  RemoveSubnets: {
                    shape: "S16"
                  },
                  SecurityGroupId: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "IdentityProviderSummary"
            ],
            members: {
              IdentityProviderSummary: {
                shape: "S9"
              }
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S3: {
          type: "structure",
          members: {
            ActiveDirectoryIdentityProvider: {
              type: "structure",
              members: {
                DirectoryId: {}
              }
            }
          },
          union: true
        },
        S6: {
          type: "structure",
          required: [
            "IdentityProvider",
            "InstanceId",
            "Status",
            "Username"
          ],
          members: {
            AssociationDate: {},
            DisassociationDate: {},
            Domain: {},
            IdentityProvider: {
              shape: "S3"
            },
            InstanceId: {},
            Status: {},
            StatusMessage: {},
            Username: {}
          }
        },
        S9: {
          type: "structure",
          required: [
            "IdentityProvider",
            "Product",
            "Settings",
            "Status"
          ],
          members: {
            FailureMessage: {},
            IdentityProvider: {
              shape: "S3"
            },
            Product: {},
            Settings: {
              shape: "Sa"
            },
            Status: {}
          }
        },
        Sa: {
          type: "structure",
          required: [
            "SecurityGroupId",
            "Subnets"
          ],
          members: {
            SecurityGroupId: {},
            Subnets: {
              type: "list",
              member: {}
            }
          }
        },
        Sl: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Attribute: {},
              Operation: {},
              Value: {}
            }
          }
        },
        Su: {
          type: "structure",
          required: [
            "IdentityProvider",
            "Product",
            "Status",
            "Username"
          ],
          members: {
            Domain: {},
            IdentityProvider: {
              shape: "S3"
            },
            Product: {},
            Status: {},
            StatusMessage: {},
            SubscriptionEndDate: {},
            SubscriptionStartDate: {},
            Username: {}
          }
        },
        S16: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/license-manager-user-subscriptions-2018-05-10.paginators.json
var require_license_manager_user_subscriptions_2018_05_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/license-manager-user-subscriptions-2018-05-10.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListIdentityProviders: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "IdentityProviderSummaries"
        },
        ListInstances: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "InstanceSummaries"
        },
        ListProductSubscriptions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ProductUserSummaries"
        },
        ListUserAssociations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "InstanceUserSummaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/licensemanagerusersubscriptions.js
var require_licensemanagerusersubscriptions = __commonJS({
  "node_modules/aws-sdk/clients/licensemanagerusersubscriptions.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["licensemanagerusersubscriptions"] = {};
    AWS2.LicenseManagerUserSubscriptions = Service.defineService("licensemanagerusersubscriptions", ["2018-05-10"]);
    Object.defineProperty(apiLoader.services["licensemanagerusersubscriptions"], "2018-05-10", {
      get: function get() {
        var model = require_license_manager_user_subscriptions_2018_05_10_min();
        model.paginators = require_license_manager_user_subscriptions_2018_05_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.LicenseManagerUserSubscriptions;
  }
});

// node_modules/aws-sdk/apis/backupstorage-2018-04-10.min.json
var require_backupstorage_2018_04_10_min = __commonJS({
  "node_modules/aws-sdk/apis/backupstorage-2018-04-10.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-04-10",
        endpointPrefix: "backupstorage",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Backup Storage",
        serviceId: "BackupStorage",
        signatureVersion: "v4",
        signingName: "backup-storage",
        uid: "backupstorage-2018-04-10"
      },
      operations: {
        DeleteObject: {
          http: {
            method: "DELETE",
            requestUri: "/backup-jobs/{jobId}/object/{objectName}"
          },
          input: {
            type: "structure",
            required: [
              "BackupJobId",
              "ObjectName"
            ],
            members: {
              BackupJobId: {
                location: "uri",
                locationName: "jobId"
              },
              ObjectName: {
                location: "uri",
                locationName: "objectName"
              }
            }
          }
        },
        GetChunk: {
          http: {
            method: "GET",
            requestUri: "/restore-jobs/{jobId}/chunk/{chunkToken}"
          },
          input: {
            type: "structure",
            required: [
              "StorageJobId",
              "ChunkToken"
            ],
            members: {
              StorageJobId: {
                location: "uri",
                locationName: "jobId"
              },
              ChunkToken: {
                location: "uri",
                locationName: "chunkToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Data",
              "Length",
              "Checksum",
              "ChecksumAlgorithm"
            ],
            members: {
              Data: {
                shape: "S5"
              },
              Length: {
                location: "header",
                locationName: "x-amz-data-length",
                type: "long"
              },
              Checksum: {
                location: "header",
                locationName: "x-amz-checksum"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-checksum-algorithm"
              }
            },
            payload: "Data"
          }
        },
        GetObjectMetadata: {
          http: {
            method: "GET",
            requestUri: "/restore-jobs/{jobId}/object/{objectToken}/metadata"
          },
          input: {
            type: "structure",
            required: [
              "StorageJobId",
              "ObjectToken"
            ],
            members: {
              StorageJobId: {
                location: "uri",
                locationName: "jobId"
              },
              ObjectToken: {
                location: "uri",
                locationName: "objectToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MetadataString: {
                location: "header",
                locationName: "x-amz-metadata-string"
              },
              MetadataBlob: {
                shape: "S5"
              },
              MetadataBlobLength: {
                location: "header",
                locationName: "x-amz-data-length",
                type: "long"
              },
              MetadataBlobChecksum: {
                location: "header",
                locationName: "x-amz-checksum"
              },
              MetadataBlobChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-checksum-algorithm"
              }
            },
            payload: "MetadataBlob"
          }
        },
        ListChunks: {
          http: {
            method: "GET",
            requestUri: "/restore-jobs/{jobId}/chunks/{objectToken}/list"
          },
          input: {
            type: "structure",
            required: [
              "StorageJobId",
              "ObjectToken"
            ],
            members: {
              StorageJobId: {
                location: "uri",
                locationName: "jobId"
              },
              ObjectToken: {
                location: "uri",
                locationName: "objectToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ChunkList"
            ],
            members: {
              ChunkList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Index",
                    "Length",
                    "Checksum",
                    "ChecksumAlgorithm",
                    "ChunkToken"
                  ],
                  members: {
                    Index: {
                      type: "long"
                    },
                    Length: {
                      type: "long"
                    },
                    Checksum: {},
                    ChecksumAlgorithm: {},
                    ChunkToken: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListObjects: {
          http: {
            method: "GET",
            requestUri: "/restore-jobs/{jobId}/objects/list"
          },
          input: {
            type: "structure",
            required: [
              "StorageJobId"
            ],
            members: {
              StorageJobId: {
                location: "uri",
                locationName: "jobId"
              },
              StartingObjectName: {
                location: "querystring",
                locationName: "starting-object-name"
              },
              StartingObjectPrefix: {
                location: "querystring",
                locationName: "starting-object-prefix"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              CreatedBefore: {
                location: "querystring",
                locationName: "created-before",
                type: "timestamp"
              },
              CreatedAfter: {
                location: "querystring",
                locationName: "created-after",
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ObjectList"
            ],
            members: {
              ObjectList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "ObjectChecksum",
                    "ObjectChecksumAlgorithm",
                    "ObjectToken"
                  ],
                  members: {
                    Name: {},
                    ChunksCount: {
                      type: "long"
                    },
                    MetadataString: {},
                    ObjectChecksum: {},
                    ObjectChecksumAlgorithm: {},
                    ObjectToken: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        NotifyObjectComplete: {
          http: {
            method: "PUT",
            requestUri: "/backup-jobs/{jobId}/object/{uploadId}/complete"
          },
          input: {
            type: "structure",
            required: [
              "BackupJobId",
              "UploadId",
              "ObjectChecksum",
              "ObjectChecksumAlgorithm"
            ],
            members: {
              BackupJobId: {
                location: "uri",
                locationName: "jobId"
              },
              UploadId: {
                location: "uri",
                locationName: "uploadId"
              },
              ObjectChecksum: {
                location: "querystring",
                locationName: "checksum"
              },
              ObjectChecksumAlgorithm: {
                location: "querystring",
                locationName: "checksum-algorithm"
              },
              MetadataString: {
                location: "querystring",
                locationName: "metadata-string"
              },
              MetadataBlob: {
                shape: "S5"
              },
              MetadataBlobLength: {
                location: "querystring",
                locationName: "metadata-blob-length",
                type: "long"
              },
              MetadataBlobChecksum: {
                location: "querystring",
                locationName: "metadata-checksum"
              },
              MetadataBlobChecksumAlgorithm: {
                location: "querystring",
                locationName: "metadata-checksum-algorithm"
              }
            },
            payload: "MetadataBlob"
          },
          output: {
            type: "structure",
            required: [
              "ObjectChecksum",
              "ObjectChecksumAlgorithm"
            ],
            members: {
              ObjectChecksum: {},
              ObjectChecksumAlgorithm: {}
            }
          },
          authtype: "v4-unsigned-body"
        },
        PutChunk: {
          http: {
            method: "PUT",
            requestUri: "/backup-jobs/{jobId}/chunk/{uploadId}/{chunkIndex}"
          },
          input: {
            type: "structure",
            required: [
              "BackupJobId",
              "UploadId",
              "ChunkIndex",
              "Data",
              "Length",
              "Checksum",
              "ChecksumAlgorithm"
            ],
            members: {
              BackupJobId: {
                location: "uri",
                locationName: "jobId"
              },
              UploadId: {
                location: "uri",
                locationName: "uploadId"
              },
              ChunkIndex: {
                location: "uri",
                locationName: "chunkIndex",
                type: "long"
              },
              Data: {
                shape: "S5"
              },
              Length: {
                location: "querystring",
                locationName: "length",
                type: "long"
              },
              Checksum: {
                location: "querystring",
                locationName: "checksum"
              },
              ChecksumAlgorithm: {
                location: "querystring",
                locationName: "checksum-algorithm"
              }
            },
            payload: "Data"
          },
          output: {
            type: "structure",
            required: [
              "ChunkChecksum",
              "ChunkChecksumAlgorithm"
            ],
            members: {
              ChunkChecksum: {},
              ChunkChecksumAlgorithm: {}
            }
          },
          authtype: "v4-unsigned-body"
        },
        PutObject: {
          http: {
            method: "PUT",
            requestUri: "/backup-jobs/{jobId}/object/{objectName}/put-object"
          },
          input: {
            type: "structure",
            required: [
              "BackupJobId",
              "ObjectName"
            ],
            members: {
              BackupJobId: {
                location: "uri",
                locationName: "jobId"
              },
              ObjectName: {
                location: "uri",
                locationName: "objectName"
              },
              MetadataString: {
                location: "querystring",
                locationName: "metadata-string"
              },
              InlineChunk: {
                shape: "S5"
              },
              InlineChunkLength: {
                location: "querystring",
                locationName: "length",
                type: "long"
              },
              InlineChunkChecksum: {
                location: "querystring",
                locationName: "checksum"
              },
              InlineChunkChecksumAlgorithm: {
                location: "querystring",
                locationName: "checksum-algorithm"
              },
              ObjectChecksum: {
                location: "querystring",
                locationName: "object-checksum"
              },
              ObjectChecksumAlgorithm: {
                location: "querystring",
                locationName: "object-checksum-algorithm"
              },
              ThrowOnDuplicate: {
                location: "querystring",
                locationName: "throwOnDuplicate",
                type: "boolean"
              }
            },
            payload: "InlineChunk"
          },
          output: {
            type: "structure",
            required: [
              "InlineChunkChecksum",
              "InlineChunkChecksumAlgorithm",
              "ObjectChecksum",
              "ObjectChecksumAlgorithm"
            ],
            members: {
              InlineChunkChecksum: {},
              InlineChunkChecksumAlgorithm: {},
              ObjectChecksum: {},
              ObjectChecksumAlgorithm: {}
            }
          },
          authtype: "v4-unsigned-body"
        },
        StartObject: {
          http: {
            method: "PUT",
            requestUri: "/backup-jobs/{jobId}/object/{objectName}"
          },
          input: {
            type: "structure",
            required: [
              "BackupJobId",
              "ObjectName"
            ],
            members: {
              BackupJobId: {
                location: "uri",
                locationName: "jobId"
              },
              ObjectName: {
                location: "uri",
                locationName: "objectName"
              },
              ThrowOnDuplicate: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UploadId"
            ],
            members: {
              UploadId: {}
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "blob",
          streaming: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/backupstorage-2018-04-10.paginators.json
var require_backupstorage_2018_04_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/backupstorage-2018-04-10.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListChunks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListObjects: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/backupstorage.js
var require_backupstorage = __commonJS({
  "node_modules/aws-sdk/clients/backupstorage.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["backupstorage"] = {};
    AWS2.BackupStorage = Service.defineService("backupstorage", ["2018-04-10"]);
    Object.defineProperty(apiLoader.services["backupstorage"], "2018-04-10", {
      get: function get() {
        var model = require_backupstorage_2018_04_10_min();
        model.paginators = require_backupstorage_2018_04_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.BackupStorage;
  }
});

// node_modules/aws-sdk/apis/privatenetworks-2021-12-03.min.json
var require_privatenetworks_2021_12_03_min = __commonJS({
  "node_modules/aws-sdk/apis/privatenetworks-2021-12-03.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-12-03",
        endpointPrefix: "private-networks",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Private 5G",
        serviceId: "PrivateNetworks",
        signatureVersion: "v4",
        signingName: "private-networks",
        uid: "privatenetworks-2021-12-03"
      },
      operations: {
        AcknowledgeOrderReceipt: {
          http: {
            requestUri: "/v1/orders/acknowledge",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "orderArn"
            ],
            members: {
              orderArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "order"
            ],
            members: {
              order: {
                shape: "S4"
              }
            }
          }
        },
        ActivateDeviceIdentifier: {
          http: {
            requestUri: "/v1/device-identifiers/activate",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "deviceIdentifierArn"
            ],
            members: {
              clientToken: {},
              deviceIdentifierArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "deviceIdentifier"
            ],
            members: {
              deviceIdentifier: {
                shape: "Sm"
              },
              tags: {
                shape: "Sp"
              }
            }
          },
          idempotent: true
        },
        ActivateNetworkSite: {
          http: {
            requestUri: "/v1/network-sites/activate",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "networkSiteArn",
              "shippingAddress"
            ],
            members: {
              clientToken: {},
              commitmentConfiguration: {
                shape: "S9"
              },
              networkSiteArn: {},
              shippingAddress: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              networkSite: {
                shape: "Su"
              }
            }
          },
          idempotent: true
        },
        ConfigureAccessPoint: {
          http: {
            requestUri: "/v1/network-resources/configure",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "accessPointArn"
            ],
            members: {
              accessPointArn: {},
              cpiSecretKey: {
                type: "string",
                sensitive: true
              },
              cpiUserId: {
                type: "string",
                sensitive: true
              },
              cpiUserPassword: {
                type: "string",
                sensitive: true
              },
              cpiUsername: {
                type: "string",
                sensitive: true
              },
              position: {
                shape: "S19"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "accessPoint"
            ],
            members: {
              accessPoint: {
                shape: "S1e"
              }
            }
          },
          idempotent: true
        },
        CreateNetwork: {
          http: {
            requestUri: "/v1/networks",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "networkName"
            ],
            members: {
              clientToken: {},
              description: {},
              networkName: {},
              tags: {
                shape: "Sp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "network"
            ],
            members: {
              network: {
                shape: "S1n"
              },
              tags: {
                shape: "Sp"
              }
            }
          },
          idempotent: true
        },
        CreateNetworkSite: {
          http: {
            requestUri: "/v1/network-sites",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "networkArn",
              "networkSiteName"
            ],
            members: {
              availabilityZone: {},
              availabilityZoneId: {},
              clientToken: {},
              description: {},
              networkArn: {},
              networkSiteName: {},
              pendingPlan: {
                shape: "Sv"
              },
              tags: {
                shape: "Sp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              networkSite: {
                shape: "Su"
              },
              tags: {
                shape: "Sp"
              }
            }
          },
          idempotent: true
        },
        DeactivateDeviceIdentifier: {
          http: {
            requestUri: "/v1/device-identifiers/deactivate",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "deviceIdentifierArn"
            ],
            members: {
              clientToken: {},
              deviceIdentifierArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "deviceIdentifier"
            ],
            members: {
              deviceIdentifier: {
                shape: "Sm"
              }
            }
          },
          idempotent: true
        },
        DeleteNetwork: {
          http: {
            method: "DELETE",
            requestUri: "/v1/networks/{networkArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "networkArn"
            ],
            members: {
              clientToken: {
                location: "querystring",
                locationName: "clientToken"
              },
              networkArn: {
                location: "uri",
                locationName: "networkArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "network"
            ],
            members: {
              network: {
                shape: "S1n"
              }
            }
          },
          idempotent: true
        },
        DeleteNetworkSite: {
          http: {
            method: "DELETE",
            requestUri: "/v1/network-sites/{networkSiteArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "networkSiteArn"
            ],
            members: {
              clientToken: {
                location: "querystring",
                locationName: "clientToken"
              },
              networkSiteArn: {
                location: "uri",
                locationName: "networkSiteArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              networkSite: {
                shape: "Su"
              }
            }
          },
          idempotent: true
        },
        GetDeviceIdentifier: {
          http: {
            method: "GET",
            requestUri: "/v1/device-identifiers/{deviceIdentifierArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "deviceIdentifierArn"
            ],
            members: {
              deviceIdentifierArn: {
                location: "uri",
                locationName: "deviceIdentifierArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              deviceIdentifier: {
                shape: "Sm"
              },
              tags: {
                shape: "Sp"
              }
            }
          }
        },
        GetNetwork: {
          http: {
            method: "GET",
            requestUri: "/v1/networks/{networkArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "networkArn"
            ],
            members: {
              networkArn: {
                location: "uri",
                locationName: "networkArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "network"
            ],
            members: {
              network: {
                shape: "S1n"
              },
              tags: {
                shape: "Sp"
              }
            }
          }
        },
        GetNetworkResource: {
          http: {
            method: "GET",
            requestUri: "/v1/network-resources/{networkResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "networkResourceArn"
            ],
            members: {
              networkResourceArn: {
                location: "uri",
                locationName: "networkResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "networkResource"
            ],
            members: {
              networkResource: {
                shape: "S1e"
              },
              tags: {
                shape: "Sp"
              }
            }
          }
        },
        GetNetworkSite: {
          http: {
            method: "GET",
            requestUri: "/v1/network-sites/{networkSiteArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "networkSiteArn"
            ],
            members: {
              networkSiteArn: {
                location: "uri",
                locationName: "networkSiteArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              networkSite: {
                shape: "Su"
              },
              tags: {
                shape: "Sp"
              }
            }
          }
        },
        GetOrder: {
          http: {
            method: "GET",
            requestUri: "/v1/orders/{orderArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "orderArn"
            ],
            members: {
              orderArn: {
                location: "uri",
                locationName: "orderArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "order"
            ],
            members: {
              order: {
                shape: "S4"
              },
              tags: {
                shape: "Sp"
              }
            }
          }
        },
        ListDeviceIdentifiers: {
          http: {
            requestUri: "/v1/device-identifiers/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "networkArn"
            ],
            members: {
              filters: {
                type: "map",
                key: {},
                value: {
                  type: "list",
                  member: {}
                }
              },
              maxResults: {
                type: "integer"
              },
              networkArn: {},
              startToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deviceIdentifiers: {
                type: "list",
                member: {
                  shape: "Sm"
                }
              },
              nextToken: {}
            }
          }
        },
        ListNetworkResources: {
          http: {
            requestUri: "/v1/network-resources",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "networkArn"
            ],
            members: {
              filters: {
                type: "map",
                key: {},
                value: {
                  type: "list",
                  member: {}
                }
              },
              maxResults: {
                type: "integer"
              },
              networkArn: {},
              startToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              networkResources: {
                type: "list",
                member: {
                  shape: "S1e"
                }
              },
              nextToken: {}
            }
          }
        },
        ListNetworkSites: {
          http: {
            requestUri: "/v1/network-sites/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "networkArn"
            ],
            members: {
              filters: {
                type: "map",
                key: {},
                value: {
                  type: "list",
                  member: {}
                }
              },
              maxResults: {
                type: "integer"
              },
              networkArn: {},
              startToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              networkSites: {
                type: "list",
                member: {
                  shape: "Su"
                }
              },
              nextToken: {}
            }
          }
        },
        ListNetworks: {
          http: {
            requestUri: "/v1/networks/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              filters: {
                type: "map",
                key: {},
                value: {
                  type: "list",
                  member: {}
                }
              },
              maxResults: {
                type: "integer"
              },
              startToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              networks: {
                type: "list",
                member: {
                  shape: "S1n"
                }
              },
              nextToken: {}
            }
          }
        },
        ListOrders: {
          http: {
            requestUri: "/v1/orders/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "networkArn"
            ],
            members: {
              filters: {
                type: "map",
                key: {},
                value: {
                  type: "list",
                  member: {}
                }
              },
              maxResults: {
                type: "integer"
              },
              networkArn: {},
              startToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              orders: {
                type: "list",
                member: {
                  shape: "S4"
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sp"
              }
            }
          }
        },
        Ping: {
          http: {
            method: "GET",
            requestUri: "/ping",
            responseCode: 200
          },
          output: {
            type: "structure",
            members: {
              status: {}
            }
          }
        },
        StartNetworkResourceUpdate: {
          http: {
            requestUri: "/v1/network-resources/update",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "networkResourceArn",
              "updateType"
            ],
            members: {
              commitmentConfiguration: {
                shape: "S9"
              },
              networkResourceArn: {},
              returnReason: {},
              shippingAddress: {
                shape: "Se"
              },
              updateType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              networkResource: {
                shape: "S1e"
              }
            }
          },
          idempotent: true
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sp"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {},
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateNetworkSite: {
          http: {
            method: "PUT",
            requestUri: "/v1/network-sites/site",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "networkSiteArn"
            ],
            members: {
              clientToken: {},
              description: {},
              networkSiteArn: {}
            }
          },
          output: {
            shape: "S3k"
          },
          idempotent: true
        },
        UpdateNetworkSitePlan: {
          http: {
            method: "PUT",
            requestUri: "/v1/network-sites/plan",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "networkSiteArn",
              "pendingPlan"
            ],
            members: {
              clientToken: {},
              networkSiteArn: {},
              pendingPlan: {
                shape: "Sv"
              }
            }
          },
          output: {
            shape: "S3k"
          },
          idempotent: true
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            acknowledgmentStatus: {},
            createdAt: {
              shape: "S6"
            },
            networkArn: {},
            networkSiteArn: {},
            orderArn: {},
            orderedResources: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "count",
                  "type"
                ],
                members: {
                  commitmentConfiguration: {
                    shape: "S9"
                  },
                  count: {
                    type: "integer"
                  },
                  type: {}
                }
              }
            },
            shippingAddress: {
              shape: "Se"
            },
            trackingInformation: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  trackingNumber: {}
                }
              }
            }
          }
        },
        S6: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S9: {
          type: "structure",
          required: [
            "automaticRenewal",
            "commitmentLength"
          ],
          members: {
            automaticRenewal: {
              type: "boolean"
            },
            commitmentLength: {}
          }
        },
        Se: {
          type: "structure",
          required: [
            "city",
            "country",
            "name",
            "postalCode",
            "stateOrProvince",
            "street1"
          ],
          members: {
            city: {
              shape: "Sf"
            },
            company: {
              shape: "Sf"
            },
            country: {
              shape: "Sf"
            },
            emailAddress: {
              shape: "Sf"
            },
            name: {
              shape: "Sf"
            },
            phoneNumber: {
              shape: "Sf"
            },
            postalCode: {
              shape: "Sf"
            },
            stateOrProvince: {
              shape: "Sf"
            },
            street1: {
              shape: "Sf"
            },
            street2: {
              shape: "Sf"
            },
            street3: {
              shape: "Sf"
            }
          }
        },
        Sf: {
          type: "string",
          sensitive: true
        },
        Sm: {
          type: "structure",
          members: {
            createdAt: {
              shape: "S6"
            },
            deviceIdentifierArn: {},
            iccid: {},
            imsi: {
              type: "string",
              sensitive: true
            },
            networkArn: {},
            orderArn: {},
            status: {},
            trafficGroupArn: {},
            vendor: {}
          }
        },
        Sp: {
          type: "map",
          key: {},
          value: {},
          sensitive: true
        },
        Su: {
          type: "structure",
          required: [
            "networkArn",
            "networkSiteArn",
            "networkSiteName",
            "status"
          ],
          members: {
            availabilityZone: {},
            availabilityZoneId: {},
            createdAt: {
              shape: "S6"
            },
            currentPlan: {
              shape: "Sv"
            },
            description: {},
            networkArn: {},
            networkSiteArn: {},
            networkSiteName: {},
            pendingPlan: {
              shape: "Sv"
            },
            status: {},
            statusReason: {}
          }
        },
        Sv: {
          type: "structure",
          members: {
            options: {
              shape: "Sw"
            },
            resourceDefinitions: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "count",
                  "type"
                ],
                members: {
                  count: {
                    type: "integer"
                  },
                  options: {
                    shape: "Sw"
                  },
                  type: {}
                }
              }
            }
          }
        },
        Sw: {
          type: "list",
          member: {
            shape: "Sx"
          }
        },
        Sx: {
          type: "structure",
          required: [
            "name"
          ],
          members: {
            name: {},
            value: {}
          }
        },
        S19: {
          type: "structure",
          members: {
            elevation: {
              type: "double"
            },
            elevationReference: {},
            elevationUnit: {},
            latitude: {
              type: "double"
            },
            longitude: {
              type: "double"
            }
          }
        },
        S1e: {
          type: "structure",
          members: {
            attributes: {
              type: "list",
              member: {
                shape: "Sx"
              }
            },
            commitmentInformation: {
              type: "structure",
              required: [
                "commitmentConfiguration"
              ],
              members: {
                commitmentConfiguration: {
                  shape: "S9"
                },
                expiresOn: {
                  shape: "S6"
                },
                startAt: {
                  shape: "S6"
                }
              }
            },
            createdAt: {
              shape: "S6"
            },
            description: {},
            health: {},
            model: {},
            networkArn: {},
            networkResourceArn: {},
            networkSiteArn: {},
            orderArn: {},
            position: {
              shape: "S19"
            },
            returnInformation: {
              type: "structure",
              members: {
                replacementOrderArn: {},
                returnReason: {},
                shippingAddress: {
                  shape: "Se"
                },
                shippingLabel: {}
              }
            },
            serialNumber: {},
            status: {},
            statusReason: {},
            type: {},
            vendor: {}
          }
        },
        S1n: {
          type: "structure",
          required: [
            "networkArn",
            "networkName",
            "status"
          ],
          members: {
            createdAt: {
              shape: "S6"
            },
            description: {},
            networkArn: {},
            networkName: {},
            status: {},
            statusReason: {}
          }
        },
        S3k: {
          type: "structure",
          members: {
            networkSite: {
              shape: "Su"
            },
            tags: {
              shape: "Sp"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/privatenetworks-2021-12-03.paginators.json
var require_privatenetworks_2021_12_03_paginators = __commonJS({
  "node_modules/aws-sdk/apis/privatenetworks-2021-12-03.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListDeviceIdentifiers: {
          input_token: "startToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "deviceIdentifiers"
        },
        ListNetworkResources: {
          input_token: "startToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "networkResources"
        },
        ListNetworkSites: {
          input_token: "startToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "networkSites"
        },
        ListNetworks: {
          input_token: "startToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "networks"
        },
        ListOrders: {
          input_token: "startToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "orders"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/privatenetworks.js
var require_privatenetworks = __commonJS({
  "node_modules/aws-sdk/clients/privatenetworks.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["privatenetworks"] = {};
    AWS2.PrivateNetworks = Service.defineService("privatenetworks", ["2021-12-03"]);
    Object.defineProperty(apiLoader.services["privatenetworks"], "2021-12-03", {
      get: function get() {
        var model = require_privatenetworks_2021_12_03_min();
        model.paginators = require_privatenetworks_2021_12_03_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.PrivateNetworks;
  }
});

// node_modules/aws-sdk/apis/support-app-2021-08-20.min.json
var require_support_app_2021_08_20_min = __commonJS({
  "node_modules/aws-sdk/apis/support-app-2021-08-20.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-08-20",
        endpointPrefix: "supportapp",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "SupportApp",
        serviceFullName: "AWS Support App",
        serviceId: "Support App",
        signatureVersion: "v4",
        signingName: "supportapp",
        uid: "support-app-2021-08-20"
      },
      operations: {
        CreateSlackChannelConfiguration: {
          http: {
            requestUri: "/control/create-slack-channel-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "channelId",
              "channelRoleArn",
              "notifyOnCaseSeverity",
              "teamId"
            ],
            members: {
              channelId: {},
              channelName: {},
              channelRoleArn: {},
              notifyOnAddCorrespondenceToCase: {
                type: "boolean"
              },
              notifyOnCaseSeverity: {},
              notifyOnCreateOrReopenCase: {
                type: "boolean"
              },
              notifyOnResolveCase: {
                type: "boolean"
              },
              teamId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAccountAlias: {
          http: {
            requestUri: "/control/delete-account-alias",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSlackChannelConfiguration: {
          http: {
            requestUri: "/control/delete-slack-channel-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "channelId",
              "teamId"
            ],
            members: {
              channelId: {},
              teamId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSlackWorkspaceConfiguration: {
          http: {
            requestUri: "/control/delete-slack-workspace-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "teamId"
            ],
            members: {
              teamId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetAccountAlias: {
          http: {
            requestUri: "/control/get-account-alias",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              accountAlias: {}
            }
          }
        },
        ListSlackChannelConfigurations: {
          http: {
            requestUri: "/control/list-slack-channel-configurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "slackChannelConfigurations"
            ],
            members: {
              nextToken: {},
              slackChannelConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "channelId",
                    "teamId"
                  ],
                  members: {
                    channelId: {},
                    channelName: {},
                    channelRoleArn: {},
                    notifyOnAddCorrespondenceToCase: {
                      type: "boolean"
                    },
                    notifyOnCaseSeverity: {},
                    notifyOnCreateOrReopenCase: {
                      type: "boolean"
                    },
                    notifyOnResolveCase: {
                      type: "boolean"
                    },
                    teamId: {}
                  }
                }
              }
            }
          }
        },
        ListSlackWorkspaceConfigurations: {
          http: {
            requestUri: "/control/list-slack-workspace-configurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              slackWorkspaceConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "teamId"
                  ],
                  members: {
                    allowOrganizationMemberAccount: {
                      type: "boolean"
                    },
                    teamId: {},
                    teamName: {}
                  }
                }
              }
            }
          }
        },
        PutAccountAlias: {
          http: {
            requestUri: "/control/put-account-alias",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "accountAlias"
            ],
            members: {
              accountAlias: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RegisterSlackWorkspaceForOrganization: {
          http: {
            requestUri: "/control/register-slack-workspace-for-organization",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "teamId"
            ],
            members: {
              teamId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              accountType: {},
              teamId: {},
              teamName: {}
            }
          }
        },
        UpdateSlackChannelConfiguration: {
          http: {
            requestUri: "/control/update-slack-channel-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "channelId",
              "teamId"
            ],
            members: {
              channelId: {},
              channelName: {},
              channelRoleArn: {},
              notifyOnAddCorrespondenceToCase: {
                type: "boolean"
              },
              notifyOnCaseSeverity: {},
              notifyOnCreateOrReopenCase: {
                type: "boolean"
              },
              notifyOnResolveCase: {
                type: "boolean"
              },
              teamId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              channelId: {},
              channelName: {},
              channelRoleArn: {},
              notifyOnAddCorrespondenceToCase: {
                type: "boolean"
              },
              notifyOnCaseSeverity: {},
              notifyOnCreateOrReopenCase: {
                type: "boolean"
              },
              notifyOnResolveCase: {
                type: "boolean"
              },
              teamId: {}
            }
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/apis/support-app-2021-08-20.paginators.json
var require_support_app_2021_08_20_paginators = __commonJS({
  "node_modules/aws-sdk/apis/support-app-2021-08-20.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListSlackChannelConfigurations: {
          input_token: "nextToken",
          output_token: "nextToken"
        },
        ListSlackWorkspaceConfigurations: {
          input_token: "nextToken",
          output_token: "nextToken"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/supportapp.js
var require_supportapp = __commonJS({
  "node_modules/aws-sdk/clients/supportapp.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["supportapp"] = {};
    AWS2.SupportApp = Service.defineService("supportapp", ["2021-08-20"]);
    Object.defineProperty(apiLoader.services["supportapp"], "2021-08-20", {
      get: function get() {
        var model = require_support_app_2021_08_20_min();
        model.paginators = require_support_app_2021_08_20_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.SupportApp;
  }
});

// node_modules/aws-sdk/apis/controltower-2018-05-10.min.json
var require_controltower_2018_05_10_min = __commonJS({
  "node_modules/aws-sdk/apis/controltower-2018-05-10.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-05-10",
        endpointPrefix: "controltower",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Control Tower",
        serviceId: "ControlTower",
        signatureVersion: "v4",
        signingName: "controltower",
        uid: "controltower-2018-05-10"
      },
      operations: {
        CreateLandingZone: {
          http: {
            requestUri: "/create-landingzone",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "manifest",
              "version"
            ],
            members: {
              manifest: {
                shape: "S2"
              },
              tags: {
                shape: "S3"
              },
              version: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "operationIdentifier"
            ],
            members: {
              arn: {},
              operationIdentifier: {}
            }
          }
        },
        DeleteLandingZone: {
          http: {
            requestUri: "/delete-landingzone",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "landingZoneIdentifier"
            ],
            members: {
              landingZoneIdentifier: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "operationIdentifier"
            ],
            members: {
              operationIdentifier: {}
            }
          },
          idempotent: true
        },
        DisableControl: {
          http: {
            requestUri: "/disable-control",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "controlIdentifier",
              "targetIdentifier"
            ],
            members: {
              controlIdentifier: {},
              targetIdentifier: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "operationIdentifier"
            ],
            members: {
              operationIdentifier: {}
            }
          }
        },
        EnableControl: {
          http: {
            requestUri: "/enable-control",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "controlIdentifier",
              "targetIdentifier"
            ],
            members: {
              controlIdentifier: {},
              parameters: {
                shape: "Si"
              },
              tags: {
                shape: "S3"
              },
              targetIdentifier: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "operationIdentifier"
            ],
            members: {
              arn: {},
              operationIdentifier: {}
            }
          }
        },
        GetControlOperation: {
          http: {
            requestUri: "/get-control-operation",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "operationIdentifier"
            ],
            members: {
              operationIdentifier: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "controlOperation"
            ],
            members: {
              controlOperation: {
                type: "structure",
                members: {
                  endTime: {
                    shape: "Sp"
                  },
                  operationType: {},
                  startTime: {
                    shape: "Sp"
                  },
                  status: {},
                  statusMessage: {}
                }
              }
            }
          }
        },
        GetEnabledControl: {
          http: {
            requestUri: "/get-enabled-control",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "enabledControlIdentifier"
            ],
            members: {
              enabledControlIdentifier: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "enabledControlDetails"
            ],
            members: {
              enabledControlDetails: {
                type: "structure",
                members: {
                  arn: {},
                  controlIdentifier: {},
                  driftStatusSummary: {
                    shape: "Sv"
                  },
                  parameters: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "key",
                        "value"
                      ],
                      members: {
                        key: {},
                        value: {
                          shape: "Sk"
                        }
                      }
                    }
                  },
                  statusSummary: {
                    shape: "Sz"
                  },
                  targetIdentifier: {},
                  targetRegions: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        name: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetLandingZone: {
          http: {
            requestUri: "/get-landingzone",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "landingZoneIdentifier"
            ],
            members: {
              landingZoneIdentifier: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "landingZone"
            ],
            members: {
              landingZone: {
                type: "structure",
                required: [
                  "manifest",
                  "version"
                ],
                members: {
                  arn: {},
                  driftStatus: {
                    type: "structure",
                    members: {
                      status: {}
                    }
                  },
                  latestAvailableVersion: {},
                  manifest: {
                    shape: "S2"
                  },
                  status: {},
                  version: {}
                }
              }
            }
          }
        },
        GetLandingZoneOperation: {
          http: {
            requestUri: "/get-landingzone-operation",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "operationIdentifier"
            ],
            members: {
              operationIdentifier: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "operationDetails"
            ],
            members: {
              operationDetails: {
                type: "structure",
                members: {
                  endTime: {
                    shape: "S1d"
                  },
                  operationType: {},
                  startTime: {
                    shape: "S1d"
                  },
                  status: {},
                  statusMessage: {}
                }
              }
            }
          }
        },
        ListEnabledControls: {
          http: {
            requestUri: "/list-enabled-controls",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "targetIdentifier"
            ],
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              targetIdentifier: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "enabledControls"
            ],
            members: {
              enabledControls: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    controlIdentifier: {},
                    driftStatusSummary: {
                      shape: "Sv"
                    },
                    statusSummary: {
                      shape: "Sz"
                    },
                    targetIdentifier: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListLandingZones: {
          http: {
            requestUri: "/list-landingzones",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "landingZones"
            ],
            members: {
              landingZones: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "tags"
            ],
            members: {
              tags: {
                shape: "S3"
              }
            }
          }
        },
        ResetLandingZone: {
          http: {
            requestUri: "/reset-landingzone",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "landingZoneIdentifier"
            ],
            members: {
              landingZoneIdentifier: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "operationIdentifier"
            ],
            members: {
              operationIdentifier: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateEnabledControl: {
          http: {
            requestUri: "/update-enabled-control",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "enabledControlIdentifier",
              "parameters"
            ],
            members: {
              enabledControlIdentifier: {},
              parameters: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "operationIdentifier"
            ],
            members: {
              operationIdentifier: {}
            }
          }
        },
        UpdateLandingZone: {
          http: {
            requestUri: "/update-landingzone",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "landingZoneIdentifier",
              "manifest",
              "version"
            ],
            members: {
              landingZoneIdentifier: {},
              manifest: {
                shape: "S2"
              },
              version: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "operationIdentifier"
            ],
            members: {
              operationIdentifier: {}
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          members: {},
          document: true
        },
        S3: {
          type: "map",
          key: {},
          value: {}
        },
        Si: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {
                shape: "Sk"
              }
            }
          }
        },
        Sk: {
          type: "structure",
          members: {},
          document: true
        },
        Sp: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        Sv: {
          type: "structure",
          members: {
            driftStatus: {}
          }
        },
        Sz: {
          type: "structure",
          members: {
            lastOperationIdentifier: {},
            status: {}
          }
        },
        S1d: {
          type: "timestamp",
          timestampFormat: "iso8601"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/controltower-2018-05-10.paginators.json
var require_controltower_2018_05_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/controltower-2018-05-10.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListEnabledControls: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "enabledControls"
        },
        ListLandingZones: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "landingZones"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/controltower.js
var require_controltower = __commonJS({
  "node_modules/aws-sdk/clients/controltower.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["controltower"] = {};
    AWS2.ControlTower = Service.defineService("controltower", ["2018-05-10"]);
    Object.defineProperty(apiLoader.services["controltower"], "2018-05-10", {
      get: function get() {
        var model = require_controltower_2018_05_10_min();
        model.paginators = require_controltower_2018_05_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ControlTower;
  }
});

// node_modules/aws-sdk/apis/iotfleetwise-2021-06-17.min.json
var require_iotfleetwise_2021_06_17_min = __commonJS({
  "node_modules/aws-sdk/apis/iotfleetwise-2021-06-17.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-06-17",
        endpointPrefix: "iotfleetwise",
        jsonVersion: "1.0",
        protocol: "json",
        serviceFullName: "AWS IoT FleetWise",
        serviceId: "IoTFleetWise",
        signatureVersion: "v4",
        signingName: "iotfleetwise",
        targetPrefix: "IoTAutobahnControlPlane",
        uid: "iotfleetwise-2021-06-17"
      },
      operations: {
        AssociateVehicleFleet: {
          input: {
            type: "structure",
            required: [
              "vehicleName",
              "fleetId"
            ],
            members: {
              vehicleName: {},
              fleetId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        BatchCreateVehicle: {
          input: {
            type: "structure",
            required: [
              "vehicles"
            ],
            members: {
              vehicles: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "vehicleName",
                    "modelManifestArn",
                    "decoderManifestArn"
                  ],
                  members: {
                    vehicleName: {},
                    modelManifestArn: {},
                    decoderManifestArn: {},
                    attributes: {
                      shape: "S9"
                    },
                    associationBehavior: {},
                    tags: {
                      shape: "Sd"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              vehicles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    vehicleName: {},
                    arn: {},
                    thingArn: {}
                  }
                }
              },
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    vehicleName: {},
                    code: {},
                    message: {}
                  }
                }
              }
            }
          }
        },
        BatchUpdateVehicle: {
          input: {
            type: "structure",
            required: [
              "vehicles"
            ],
            members: {
              vehicles: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "vehicleName"
                  ],
                  members: {
                    vehicleName: {},
                    modelManifestArn: {},
                    decoderManifestArn: {},
                    attributes: {
                      shape: "S9"
                    },
                    attributeUpdateMode: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              vehicles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    vehicleName: {},
                    arn: {}
                  }
                }
              },
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    vehicleName: {},
                    code: {
                      type: "integer"
                    },
                    message: {}
                  }
                }
              }
            }
          }
        },
        CreateCampaign: {
          input: {
            type: "structure",
            required: [
              "name",
              "signalCatalogArn",
              "targetArn",
              "collectionScheme"
            ],
            members: {
              name: {},
              description: {},
              signalCatalogArn: {},
              targetArn: {},
              startTime: {
                type: "timestamp"
              },
              expiryTime: {
                type: "timestamp"
              },
              postTriggerCollectionDuration: {
                type: "long"
              },
              diagnosticsMode: {},
              spoolingMode: {},
              compression: {},
              priority: {
                type: "integer"
              },
              signalsToCollect: {
                shape: "S16"
              },
              collectionScheme: {
                shape: "S1a"
              },
              dataExtraDimensions: {
                shape: "S1h"
              },
              tags: {
                shape: "Sd"
              },
              dataDestinationConfigs: {
                shape: "S1j"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              arn: {}
            }
          },
          idempotent: true
        },
        CreateDecoderManifest: {
          input: {
            type: "structure",
            required: [
              "name",
              "modelManifestArn"
            ],
            members: {
              name: {},
              description: {},
              modelManifestArn: {},
              signalDecoders: {
                shape: "S1w"
              },
              networkInterfaces: {
                shape: "S2m"
              },
              tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "name",
              "arn"
            ],
            members: {
              name: {},
              arn: {}
            }
          },
          idempotent: true
        },
        CreateFleet: {
          input: {
            type: "structure",
            required: [
              "fleetId",
              "signalCatalogArn"
            ],
            members: {
              fleetId: {},
              description: {},
              signalCatalogArn: {},
              tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "arn"
            ],
            members: {
              id: {},
              arn: {}
            }
          },
          idempotent: true
        },
        CreateModelManifest: {
          input: {
            type: "structure",
            required: [
              "name",
              "nodes",
              "signalCatalogArn"
            ],
            members: {
              name: {},
              description: {},
              nodes: {
                shape: "S33"
              },
              signalCatalogArn: {},
              tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "name",
              "arn"
            ],
            members: {
              name: {},
              arn: {}
            }
          },
          idempotent: true
        },
        CreateSignalCatalog: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              description: {},
              nodes: {
                shape: "S36"
              },
              tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "name",
              "arn"
            ],
            members: {
              name: {},
              arn: {}
            }
          },
          idempotent: true
        },
        CreateVehicle: {
          input: {
            type: "structure",
            required: [
              "vehicleName",
              "modelManifestArn",
              "decoderManifestArn"
            ],
            members: {
              vehicleName: {},
              modelManifestArn: {},
              decoderManifestArn: {},
              attributes: {
                shape: "S9"
              },
              associationBehavior: {},
              tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              vehicleName: {},
              arn: {},
              thingArn: {}
            }
          },
          idempotent: true
        },
        DeleteCampaign: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              arn: {}
            }
          },
          idempotent: true
        },
        DeleteDecoderManifest: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "name",
              "arn"
            ],
            members: {
              name: {},
              arn: {}
            }
          },
          idempotent: true
        },
        DeleteFleet: {
          input: {
            type: "structure",
            required: [
              "fleetId"
            ],
            members: {
              fleetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              arn: {}
            }
          },
          idempotent: true
        },
        DeleteModelManifest: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "name",
              "arn"
            ],
            members: {
              name: {},
              arn: {}
            }
          },
          idempotent: true
        },
        DeleteSignalCatalog: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "name",
              "arn"
            ],
            members: {
              name: {},
              arn: {}
            }
          },
          idempotent: true
        },
        DeleteVehicle: {
          input: {
            type: "structure",
            required: [
              "vehicleName"
            ],
            members: {
              vehicleName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "vehicleName",
              "arn"
            ],
            members: {
              vehicleName: {},
              arn: {}
            }
          },
          idempotent: true
        },
        DisassociateVehicleFleet: {
          input: {
            type: "structure",
            required: [
              "vehicleName",
              "fleetId"
            ],
            members: {
              vehicleName: {},
              fleetId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetCampaign: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              arn: {},
              description: {},
              signalCatalogArn: {},
              targetArn: {},
              status: {},
              startTime: {
                type: "timestamp"
              },
              expiryTime: {
                type: "timestamp"
              },
              postTriggerCollectionDuration: {
                type: "long"
              },
              diagnosticsMode: {},
              spoolingMode: {},
              compression: {},
              priority: {
                type: "integer"
              },
              signalsToCollect: {
                shape: "S16"
              },
              collectionScheme: {
                shape: "S1a"
              },
              dataExtraDimensions: {
                shape: "S1h"
              },
              creationTime: {
                type: "timestamp"
              },
              lastModificationTime: {
                type: "timestamp"
              },
              dataDestinationConfigs: {
                shape: "S1j"
              }
            }
          }
        },
        GetDecoderManifest: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "name",
              "arn",
              "creationTime",
              "lastModificationTime"
            ],
            members: {
              name: {},
              arn: {},
              description: {},
              modelManifestArn: {},
              status: {},
              creationTime: {
                type: "timestamp"
              },
              lastModificationTime: {
                type: "timestamp"
              },
              message: {}
            }
          }
        },
        GetEncryptionConfiguration: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "encryptionStatus",
              "encryptionType"
            ],
            members: {
              kmsKeyId: {},
              encryptionStatus: {},
              encryptionType: {},
              errorMessage: {},
              creationTime: {
                type: "timestamp"
              },
              lastModificationTime: {
                type: "timestamp"
              }
            }
          }
        },
        GetFleet: {
          input: {
            type: "structure",
            required: [
              "fleetId"
            ],
            members: {
              fleetId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "arn",
              "signalCatalogArn",
              "creationTime",
              "lastModificationTime"
            ],
            members: {
              id: {},
              arn: {},
              description: {},
              signalCatalogArn: {},
              creationTime: {
                type: "timestamp"
              },
              lastModificationTime: {
                type: "timestamp"
              }
            }
          }
        },
        GetLoggingOptions: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "cloudWatchLogDelivery"
            ],
            members: {
              cloudWatchLogDelivery: {
                shape: "S4e"
              }
            }
          }
        },
        GetModelManifest: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "name",
              "arn",
              "creationTime",
              "lastModificationTime"
            ],
            members: {
              name: {},
              arn: {},
              description: {},
              signalCatalogArn: {},
              status: {},
              creationTime: {
                type: "timestamp"
              },
              lastModificationTime: {
                type: "timestamp"
              }
            }
          }
        },
        GetRegisterAccountStatus: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "customerAccountId",
              "accountStatus",
              "iamRegistrationResponse",
              "creationTime",
              "lastModificationTime"
            ],
            members: {
              customerAccountId: {},
              accountStatus: {},
              timestreamRegistrationResponse: {
                type: "structure",
                required: [
                  "timestreamDatabaseName",
                  "timestreamTableName",
                  "registrationStatus"
                ],
                members: {
                  timestreamDatabaseName: {},
                  timestreamTableName: {},
                  timestreamDatabaseArn: {},
                  timestreamTableArn: {},
                  registrationStatus: {},
                  errorMessage: {}
                }
              },
              iamRegistrationResponse: {
                type: "structure",
                required: [
                  "roleArn",
                  "registrationStatus"
                ],
                members: {
                  roleArn: {},
                  registrationStatus: {},
                  errorMessage: {}
                }
              },
              creationTime: {
                type: "timestamp"
              },
              lastModificationTime: {
                type: "timestamp"
              }
            }
          }
        },
        GetSignalCatalog: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "name",
              "arn",
              "creationTime",
              "lastModificationTime"
            ],
            members: {
              name: {},
              arn: {},
              description: {},
              nodeCounts: {
                type: "structure",
                members: {
                  totalNodes: {
                    type: "integer"
                  },
                  totalBranches: {
                    type: "integer"
                  },
                  totalSensors: {
                    type: "integer"
                  },
                  totalAttributes: {
                    type: "integer"
                  },
                  totalActuators: {
                    type: "integer"
                  },
                  totalStructs: {
                    type: "integer"
                  },
                  totalProperties: {
                    type: "integer"
                  }
                }
              },
              creationTime: {
                type: "timestamp"
              },
              lastModificationTime: {
                type: "timestamp"
              }
            }
          }
        },
        GetVehicle: {
          input: {
            type: "structure",
            required: [
              "vehicleName"
            ],
            members: {
              vehicleName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              vehicleName: {},
              arn: {},
              modelManifestArn: {},
              decoderManifestArn: {},
              attributes: {
                shape: "S9"
              },
              creationTime: {
                type: "timestamp"
              },
              lastModificationTime: {
                type: "timestamp"
              }
            }
          }
        },
        GetVehicleStatus: {
          input: {
            type: "structure",
            required: [
              "vehicleName"
            ],
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              vehicleName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              campaigns: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    campaignName: {},
                    vehicleName: {},
                    status: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ImportDecoderManifest: {
          input: {
            type: "structure",
            required: [
              "name",
              "networkFileDefinitions"
            ],
            members: {
              name: {},
              networkFileDefinitions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    canDbc: {
                      type: "structure",
                      required: [
                        "networkInterface",
                        "canDbcFiles"
                      ],
                      members: {
                        networkInterface: {},
                        canDbcFiles: {
                          type: "list",
                          member: {
                            type: "blob"
                          }
                        },
                        signalsMap: {
                          type: "map",
                          key: {},
                          value: {}
                        }
                      }
                    }
                  },
                  union: true
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "name",
              "arn"
            ],
            members: {
              name: {},
              arn: {}
            }
          }
        },
        ImportSignalCatalog: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              description: {},
              vss: {
                type: "structure",
                members: {
                  vssJson: {}
                },
                union: true
              },
              tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "name",
              "arn"
            ],
            members: {
              name: {},
              arn: {}
            }
          },
          idempotent: true
        },
        ListCampaigns: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              status: {}
            }
          },
          output: {
            type: "structure",
            members: {
              campaignSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "creationTime",
                    "lastModificationTime"
                  ],
                  members: {
                    arn: {},
                    name: {},
                    description: {},
                    signalCatalogArn: {},
                    targetArn: {},
                    status: {},
                    creationTime: {
                      type: "timestamp"
                    },
                    lastModificationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDecoderManifestNetworkInterfaces: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              networkInterfaces: {
                shape: "S2m"
              },
              nextToken: {}
            }
          }
        },
        ListDecoderManifestSignals: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              signalDecoders: {
                shape: "S1w"
              },
              nextToken: {}
            }
          }
        },
        ListDecoderManifests: {
          input: {
            type: "structure",
            members: {
              modelManifestArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              summaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "creationTime",
                    "lastModificationTime"
                  ],
                  members: {
                    name: {},
                    arn: {},
                    modelManifestArn: {},
                    description: {},
                    status: {},
                    creationTime: {
                      type: "timestamp"
                    },
                    lastModificationTime: {
                      type: "timestamp"
                    },
                    message: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListFleets: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              fleetSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "arn",
                    "signalCatalogArn",
                    "creationTime"
                  ],
                  members: {
                    id: {},
                    arn: {},
                    description: {},
                    signalCatalogArn: {},
                    creationTime: {
                      type: "timestamp"
                    },
                    lastModificationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListFleetsForVehicle: {
          input: {
            type: "structure",
            required: [
              "vehicleName"
            ],
            members: {
              vehicleName: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              fleets: {
                type: "list",
                member: {}
              },
              nextToken: {}
            }
          }
        },
        ListModelManifestNodes: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nodes: {
                shape: "S36"
              },
              nextToken: {}
            }
          }
        },
        ListModelManifests: {
          input: {
            type: "structure",
            members: {
              signalCatalogArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              summaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "creationTime",
                    "lastModificationTime"
                  ],
                  members: {
                    name: {},
                    arn: {},
                    signalCatalogArn: {},
                    description: {},
                    status: {},
                    creationTime: {
                      type: "timestamp"
                    },
                    lastModificationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSignalCatalogNodes: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nodes: {
                shape: "S36"
              },
              nextToken: {}
            }
          }
        },
        ListSignalCatalogs: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              summaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    arn: {},
                    creationTime: {
                      type: "timestamp"
                    },
                    lastModificationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sd"
              }
            }
          }
        },
        ListVehicles: {
          input: {
            type: "structure",
            members: {
              modelManifestArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              vehicleSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "vehicleName",
                    "arn",
                    "modelManifestArn",
                    "decoderManifestArn",
                    "creationTime",
                    "lastModificationTime"
                  ],
                  members: {
                    vehicleName: {},
                    arn: {},
                    modelManifestArn: {},
                    decoderManifestArn: {},
                    creationTime: {
                      type: "timestamp"
                    },
                    lastModificationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListVehiclesInFleet: {
          input: {
            type: "structure",
            required: [
              "fleetId"
            ],
            members: {
              fleetId: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              vehicles: {
                type: "list",
                member: {}
              },
              nextToken: {}
            }
          }
        },
        PutEncryptionConfiguration: {
          input: {
            type: "structure",
            required: [
              "encryptionType"
            ],
            members: {
              kmsKeyId: {},
              encryptionType: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "encryptionStatus",
              "encryptionType"
            ],
            members: {
              kmsKeyId: {},
              encryptionStatus: {},
              encryptionType: {}
            }
          }
        },
        PutLoggingOptions: {
          input: {
            type: "structure",
            required: [
              "cloudWatchLogDelivery"
            ],
            members: {
              cloudWatchLogDelivery: {
                shape: "S4e"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        RegisterAccount: {
          input: {
            type: "structure",
            members: {
              timestreamResources: {
                shape: "S6r",
                deprecated: true,
                deprecatedMessage: "Amazon Timestream metadata is now passed in the CreateCampaign API."
              },
              iamResources: {
                shape: "S6s",
                deprecated: true,
                deprecatedMessage: "iamResources is no longer used or needed as input"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "registerAccountStatus",
              "iamResources",
              "creationTime",
              "lastModificationTime"
            ],
            members: {
              registerAccountStatus: {},
              timestreamResources: {
                shape: "S6r"
              },
              iamResources: {
                shape: "S6s"
              },
              creationTime: {
                type: "timestamp"
              },
              lastModificationTime: {
                type: "timestamp"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateCampaign: {
          input: {
            type: "structure",
            required: [
              "name",
              "action"
            ],
            members: {
              name: {},
              description: {},
              dataExtraDimensions: {
                shape: "S1h"
              },
              action: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              name: {},
              status: {}
            }
          }
        },
        UpdateDecoderManifest: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              description: {},
              signalDecodersToAdd: {
                shape: "S1w"
              },
              signalDecodersToUpdate: {
                shape: "S1w"
              },
              signalDecodersToRemove: {
                type: "list",
                member: {}
              },
              networkInterfacesToAdd: {
                shape: "S2m"
              },
              networkInterfacesToUpdate: {
                shape: "S2m"
              },
              networkInterfacesToRemove: {
                type: "list",
                member: {}
              },
              status: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "name",
              "arn"
            ],
            members: {
              name: {},
              arn: {}
            }
          },
          idempotent: true
        },
        UpdateFleet: {
          input: {
            type: "structure",
            required: [
              "fleetId"
            ],
            members: {
              fleetId: {},
              description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              arn: {}
            }
          }
        },
        UpdateModelManifest: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              description: {},
              nodesToAdd: {
                shape: "S79"
              },
              nodesToRemove: {
                shape: "S79"
              },
              status: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "name",
              "arn"
            ],
            members: {
              name: {},
              arn: {}
            }
          },
          idempotent: true
        },
        UpdateSignalCatalog: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              description: {},
              nodesToAdd: {
                shape: "S36"
              },
              nodesToUpdate: {
                shape: "S36"
              },
              nodesToRemove: {
                shape: "S79"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "name",
              "arn"
            ],
            members: {
              name: {},
              arn: {}
            }
          },
          idempotent: true
        },
        UpdateVehicle: {
          input: {
            type: "structure",
            required: [
              "vehicleName"
            ],
            members: {
              vehicleName: {},
              modelManifestArn: {},
              decoderManifestArn: {},
              attributes: {
                shape: "S9"
              },
              attributeUpdateMode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              vehicleName: {},
              arn: {}
            }
          }
        }
      },
      shapes: {
        S9: {
          type: "map",
          key: {},
          value: {}
        },
        Sd: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S16: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              maxSampleCount: {
                type: "long"
              },
              minimumSamplingIntervalMs: {
                type: "long"
              }
            }
          }
        },
        S1a: {
          type: "structure",
          members: {
            timeBasedCollectionScheme: {
              type: "structure",
              required: [
                "periodMs"
              ],
              members: {
                periodMs: {
                  type: "long"
                }
              }
            },
            conditionBasedCollectionScheme: {
              type: "structure",
              required: [
                "expression"
              ],
              members: {
                expression: {},
                minimumTriggerIntervalMs: {
                  type: "long"
                },
                triggerMode: {},
                conditionLanguageVersion: {
                  type: "integer"
                }
              }
            }
          },
          union: true
        },
        S1h: {
          type: "list",
          member: {}
        },
        S1j: {
          type: "list",
          member: {
            type: "structure",
            members: {
              s3Config: {
                type: "structure",
                required: [
                  "bucketArn"
                ],
                members: {
                  bucketArn: {},
                  dataFormat: {},
                  storageCompressionFormat: {},
                  prefix: {}
                }
              },
              timestreamConfig: {
                type: "structure",
                required: [
                  "timestreamTableArn",
                  "executionRoleArn"
                ],
                members: {
                  timestreamTableArn: {},
                  executionRoleArn: {}
                }
              }
            },
            union: true
          }
        },
        S1w: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "fullyQualifiedName",
              "type",
              "interfaceId"
            ],
            members: {
              fullyQualifiedName: {},
              type: {},
              interfaceId: {},
              canSignal: {
                type: "structure",
                required: [
                  "messageId",
                  "isBigEndian",
                  "isSigned",
                  "startBit",
                  "offset",
                  "factor",
                  "length"
                ],
                members: {
                  messageId: {
                    type: "integer"
                  },
                  isBigEndian: {
                    type: "boolean"
                  },
                  isSigned: {
                    type: "boolean"
                  },
                  startBit: {
                    type: "integer"
                  },
                  offset: {
                    type: "double"
                  },
                  factor: {
                    type: "double"
                  },
                  length: {
                    type: "integer"
                  },
                  name: {}
                }
              },
              obdSignal: {
                type: "structure",
                required: [
                  "pidResponseLength",
                  "serviceMode",
                  "pid",
                  "scaling",
                  "offset",
                  "startByte",
                  "byteLength"
                ],
                members: {
                  pidResponseLength: {
                    type: "integer"
                  },
                  serviceMode: {
                    type: "integer"
                  },
                  pid: {
                    type: "integer"
                  },
                  scaling: {
                    type: "double"
                  },
                  offset: {
                    type: "double"
                  },
                  startByte: {
                    type: "integer"
                  },
                  byteLength: {
                    type: "integer"
                  },
                  bitRightShift: {
                    type: "integer"
                  },
                  bitMaskLength: {
                    type: "integer"
                  }
                }
              },
              messageSignal: {
                type: "structure",
                required: [
                  "topicName",
                  "structuredMessage"
                ],
                members: {
                  topicName: {},
                  structuredMessage: {
                    shape: "S2c"
                  }
                }
              }
            }
          }
        },
        S2c: {
          type: "structure",
          members: {
            primitiveMessageDefinition: {
              type: "structure",
              members: {
                ros2PrimitiveMessageDefinition: {
                  type: "structure",
                  required: [
                    "primitiveType"
                  ],
                  members: {
                    primitiveType: {},
                    offset: {
                      type: "double"
                    },
                    scaling: {
                      type: "double"
                    },
                    upperBound: {
                      type: "long"
                    }
                  }
                }
              },
              union: true
            },
            structuredMessageListDefinition: {
              type: "structure",
              required: [
                "name",
                "memberType",
                "listType"
              ],
              members: {
                name: {},
                memberType: {
                  shape: "S2c"
                },
                listType: {},
                capacity: {
                  type: "integer"
                }
              }
            },
            structuredMessageDefinition: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "fieldName",
                  "dataType"
                ],
                members: {
                  fieldName: {},
                  dataType: {
                    shape: "S2c"
                  }
                }
              }
            }
          },
          union: true
        },
        S2m: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "interfaceId",
              "type"
            ],
            members: {
              interfaceId: {},
              type: {},
              canInterface: {
                type: "structure",
                required: [
                  "name"
                ],
                members: {
                  name: {},
                  protocolName: {},
                  protocolVersion: {}
                }
              },
              obdInterface: {
                type: "structure",
                required: [
                  "name",
                  "requestMessageId"
                ],
                members: {
                  name: {},
                  requestMessageId: {
                    type: "integer"
                  },
                  obdStandard: {},
                  pidRequestIntervalSeconds: {
                    type: "integer"
                  },
                  dtcRequestIntervalSeconds: {
                    type: "integer"
                  },
                  useExtendedIds: {
                    type: "boolean"
                  },
                  hasTransmissionEcu: {
                    type: "boolean"
                  }
                }
              },
              vehicleMiddleware: {
                type: "structure",
                required: [
                  "name",
                  "protocolName"
                ],
                members: {
                  name: {},
                  protocolName: {}
                }
              }
            }
          }
        },
        S33: {
          type: "list",
          member: {}
        },
        S36: {
          type: "list",
          member: {
            type: "structure",
            members: {
              branch: {
                type: "structure",
                required: [
                  "fullyQualifiedName"
                ],
                members: {
                  fullyQualifiedName: {},
                  description: {},
                  deprecationMessage: {},
                  comment: {}
                }
              },
              sensor: {
                type: "structure",
                required: [
                  "fullyQualifiedName",
                  "dataType"
                ],
                members: {
                  fullyQualifiedName: {},
                  dataType: {},
                  description: {},
                  unit: {},
                  allowedValues: {
                    shape: "S33"
                  },
                  min: {
                    type: "double"
                  },
                  max: {
                    type: "double"
                  },
                  deprecationMessage: {},
                  comment: {},
                  structFullyQualifiedName: {}
                }
              },
              actuator: {
                type: "structure",
                required: [
                  "fullyQualifiedName",
                  "dataType"
                ],
                members: {
                  fullyQualifiedName: {},
                  dataType: {},
                  description: {},
                  unit: {},
                  allowedValues: {
                    shape: "S33"
                  },
                  min: {
                    type: "double"
                  },
                  max: {
                    type: "double"
                  },
                  assignedValue: {
                    deprecated: true,
                    deprecatedMessage: "assignedValue is no longer in use"
                  },
                  deprecationMessage: {},
                  comment: {},
                  structFullyQualifiedName: {}
                }
              },
              attribute: {
                type: "structure",
                required: [
                  "fullyQualifiedName",
                  "dataType"
                ],
                members: {
                  fullyQualifiedName: {},
                  dataType: {},
                  description: {},
                  unit: {},
                  allowedValues: {
                    shape: "S33"
                  },
                  min: {
                    type: "double"
                  },
                  max: {
                    type: "double"
                  },
                  assignedValue: {
                    deprecated: true,
                    deprecatedMessage: "assignedValue is no longer in use"
                  },
                  defaultValue: {},
                  deprecationMessage: {},
                  comment: {}
                }
              },
              struct: {
                type: "structure",
                required: [
                  "fullyQualifiedName"
                ],
                members: {
                  fullyQualifiedName: {},
                  description: {},
                  deprecationMessage: {},
                  comment: {}
                }
              },
              property: {
                type: "structure",
                required: [
                  "fullyQualifiedName",
                  "dataType"
                ],
                members: {
                  fullyQualifiedName: {},
                  dataType: {},
                  dataEncoding: {},
                  description: {},
                  deprecationMessage: {},
                  comment: {},
                  structFullyQualifiedName: {}
                }
              }
            },
            union: true
          }
        },
        S4e: {
          type: "structure",
          required: [
            "logType"
          ],
          members: {
            logType: {},
            logGroupName: {}
          }
        },
        S6r: {
          type: "structure",
          required: [
            "timestreamDatabaseName",
            "timestreamTableName"
          ],
          members: {
            timestreamDatabaseName: {},
            timestreamTableName: {}
          }
        },
        S6s: {
          type: "structure",
          required: [
            "roleArn"
          ],
          members: {
            roleArn: {}
          }
        },
        S79: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iotfleetwise-2021-06-17.paginators.json
var require_iotfleetwise_2021_06_17_paginators = __commonJS({
  "node_modules/aws-sdk/apis/iotfleetwise-2021-06-17.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetVehicleStatus: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "campaigns"
        },
        ListCampaigns: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "campaignSummaries"
        },
        ListDecoderManifestNetworkInterfaces: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "networkInterfaces"
        },
        ListDecoderManifestSignals: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "signalDecoders"
        },
        ListDecoderManifests: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "summaries"
        },
        ListFleets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "fleetSummaries"
        },
        ListFleetsForVehicle: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "fleets"
        },
        ListModelManifestNodes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "nodes"
        },
        ListModelManifests: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "summaries"
        },
        ListSignalCatalogNodes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "nodes"
        },
        ListSignalCatalogs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "summaries"
        },
        ListVehicles: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "vehicleSummaries"
        },
        ListVehiclesInFleet: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "vehicles"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iotfleetwise-2021-06-17.waiters2.json
var require_iotfleetwise_2021_06_17_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/iotfleetwise-2021-06-17.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {}
    };
  }
});

// node_modules/aws-sdk/clients/iotfleetwise.js
var require_iotfleetwise = __commonJS({
  "node_modules/aws-sdk/clients/iotfleetwise.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["iotfleetwise"] = {};
    AWS2.IoTFleetWise = Service.defineService("iotfleetwise", ["2021-06-17"]);
    Object.defineProperty(apiLoader.services["iotfleetwise"], "2021-06-17", {
      get: function get() {
        var model = require_iotfleetwise_2021_06_17_min();
        model.paginators = require_iotfleetwise_2021_06_17_paginators().pagination;
        model.waiters = require_iotfleetwise_2021_06_17_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.IoTFleetWise;
  }
});

// node_modules/aws-sdk/apis/migrationhuborchestrator-2021-08-28.min.json
var require_migrationhuborchestrator_2021_08_28_min = __commonJS({
  "node_modules/aws-sdk/apis/migrationhuborchestrator-2021-08-28.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-08-28",
        endpointPrefix: "migrationhub-orchestrator",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Migration Hub Orchestrator",
        serviceId: "MigrationHubOrchestrator",
        signatureVersion: "v4",
        signingName: "migrationhub-orchestrator",
        uid: "migrationhuborchestrator-2021-08-28"
      },
      operations: {
        CreateWorkflow: {
          http: {
            requestUri: "/migrationworkflow/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "templateId",
              "applicationConfigurationId",
              "inputParameters"
            ],
            members: {
              name: {},
              description: {},
              templateId: {},
              applicationConfigurationId: {},
              inputParameters: {
                shape: "S6"
              },
              stepTargets: {
                shape: "Sb"
              },
              tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              arn: {},
              name: {},
              description: {},
              templateId: {},
              adsApplicationConfigurationId: {},
              workflowInputs: {
                shape: "S6"
              },
              stepTargets: {
                shape: "Sb"
              },
              status: {},
              creationTime: {
                type: "timestamp"
              },
              tags: {
                shape: "Sd"
              }
            }
          }
        },
        CreateWorkflowStep: {
          http: {
            requestUri: "/workflowstep",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "stepGroupId",
              "workflowId",
              "stepActionType"
            ],
            members: {
              name: {},
              stepGroupId: {},
              workflowId: {},
              stepActionType: {},
              description: {},
              workflowStepAutomationConfiguration: {
                shape: "Sq"
              },
              stepTarget: {
                shape: "Sb"
              },
              outputs: {
                shape: "Sx"
              },
              previous: {
                shape: "Sb"
              },
              next: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              stepGroupId: {},
              workflowId: {},
              name: {}
            }
          }
        },
        CreateWorkflowStepGroup: {
          http: {
            requestUri: "/workflowstepgroups",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workflowId",
              "name"
            ],
            members: {
              workflowId: {},
              name: {},
              description: {},
              next: {
                shape: "Sb"
              },
              previous: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              workflowId: {},
              name: {},
              id: {},
              description: {},
              tools: {
                shape: "S18"
              },
              next: {
                shape: "Sb"
              },
              previous: {
                shape: "Sb"
              },
              creationTime: {
                type: "timestamp"
              }
            }
          }
        },
        DeleteWorkflow: {
          http: {
            method: "DELETE",
            requestUri: "/migrationworkflow/{id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              arn: {},
              status: {}
            }
          },
          idempotent: true
        },
        DeleteWorkflowStep: {
          http: {
            method: "DELETE",
            requestUri: "/workflowstep/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id",
              "stepGroupId",
              "workflowId"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              stepGroupId: {
                location: "querystring",
                locationName: "stepGroupId"
              },
              workflowId: {
                location: "querystring",
                locationName: "workflowId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteWorkflowStepGroup: {
          http: {
            method: "DELETE",
            requestUri: "/workflowstepgroup/{id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "workflowId",
              "id"
            ],
            members: {
              workflowId: {
                location: "querystring",
                locationName: "workflowId"
              },
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        GetTemplate: {
          http: {
            method: "GET",
            requestUri: "/migrationworkflowtemplate/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              name: {},
              description: {},
              inputs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    inputName: {},
                    dataType: {},
                    required: {
                      type: "boolean"
                    }
                  }
                }
              },
              tools: {
                shape: "S18"
              },
              status: {},
              creationTime: {
                type: "timestamp"
              }
            }
          }
        },
        GetTemplateStep: {
          http: {
            method: "GET",
            requestUri: "/templatestep/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id",
              "templateId",
              "stepGroupId"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              templateId: {
                location: "querystring",
                locationName: "templateId"
              },
              stepGroupId: {
                location: "querystring",
                locationName: "stepGroupId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              stepGroupId: {},
              templateId: {},
              name: {},
              description: {},
              stepActionType: {},
              creationTime: {},
              previous: {
                shape: "Sb"
              },
              next: {
                shape: "Sb"
              },
              outputs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    dataType: {},
                    required: {
                      type: "boolean"
                    }
                  }
                }
              },
              stepAutomationConfiguration: {
                type: "structure",
                members: {
                  scriptLocationS3Bucket: {},
                  scriptLocationS3Key: {
                    shape: "Ss"
                  },
                  command: {
                    shape: "Su"
                  },
                  runEnvironment: {},
                  targetType: {}
                }
              }
            }
          }
        },
        GetTemplateStepGroup: {
          http: {
            method: "GET",
            requestUri: "/templates/{templateId}/stepgroups/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "templateId",
              "id"
            ],
            members: {
              templateId: {
                location: "uri",
                locationName: "templateId"
              },
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              templateId: {},
              id: {},
              name: {},
              description: {},
              status: {},
              creationTime: {
                type: "timestamp"
              },
              lastModifiedTime: {
                type: "timestamp"
              },
              tools: {
                shape: "S18"
              },
              previous: {
                shape: "Sb"
              },
              next: {
                shape: "Sb"
              }
            }
          }
        },
        GetWorkflow: {
          http: {
            method: "GET",
            requestUri: "/migrationworkflow/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              arn: {},
              name: {},
              description: {},
              templateId: {},
              adsApplicationConfigurationId: {},
              adsApplicationName: {},
              status: {},
              statusMessage: {},
              creationTime: {
                type: "timestamp"
              },
              lastStartTime: {
                type: "timestamp"
              },
              lastStopTime: {
                type: "timestamp"
              },
              lastModifiedTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              tools: {
                shape: "S18"
              },
              totalSteps: {
                type: "integer"
              },
              completedSteps: {
                type: "integer"
              },
              workflowInputs: {
                shape: "S6"
              },
              tags: {
                shape: "Sd"
              },
              workflowBucket: {}
            }
          }
        },
        GetWorkflowStep: {
          http: {
            method: "GET",
            requestUri: "/workflowstep/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workflowId",
              "stepGroupId",
              "id"
            ],
            members: {
              workflowId: {
                location: "querystring",
                locationName: "workflowId"
              },
              stepGroupId: {
                location: "querystring",
                locationName: "stepGroupId"
              },
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              stepGroupId: {},
              workflowId: {},
              stepId: {},
              description: {},
              stepActionType: {},
              owner: {},
              workflowStepAutomationConfiguration: {
                shape: "Sq"
              },
              stepTarget: {
                shape: "Sb"
              },
              outputs: {
                type: "list",
                member: {
                  shape: "Sy"
                }
              },
              previous: {
                shape: "Sb"
              },
              next: {
                shape: "Sb"
              },
              status: {},
              statusMessage: {},
              scriptOutputLocation: {},
              creationTime: {
                type: "timestamp"
              },
              lastStartTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              noOfSrvCompleted: {
                type: "integer"
              },
              noOfSrvFailed: {
                type: "integer"
              },
              totalNoOfSrv: {
                type: "integer"
              }
            }
          }
        },
        GetWorkflowStepGroup: {
          http: {
            method: "GET",
            requestUri: "/workflowstepgroup/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id",
              "workflowId"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              workflowId: {
                location: "querystring",
                locationName: "workflowId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              workflowId: {},
              name: {},
              description: {},
              status: {},
              owner: {},
              creationTime: {
                type: "timestamp"
              },
              lastModifiedTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              tools: {
                shape: "S18"
              },
              previous: {
                shape: "Sb"
              },
              next: {
                shape: "Sb"
              }
            }
          }
        },
        ListPlugins: {
          http: {
            method: "GET",
            requestUri: "/plugins",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              plugins: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    pluginId: {},
                    hostname: {},
                    status: {},
                    ipAddress: {},
                    version: {},
                    registeredTime: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S2i"
              }
            }
          }
        },
        ListTemplateStepGroups: {
          http: {
            method: "GET",
            requestUri: "/templatestepgroups/{templateId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "templateId"
            ],
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              templateId: {
                location: "uri",
                locationName: "templateId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "templateStepGroupSummary"
            ],
            members: {
              nextToken: {},
              templateStepGroupSummary: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    name: {},
                    previous: {
                      shape: "Sb"
                    },
                    next: {
                      shape: "Sb"
                    }
                  }
                }
              }
            }
          }
        },
        ListTemplateSteps: {
          http: {
            method: "GET",
            requestUri: "/templatesteps",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "templateId",
              "stepGroupId"
            ],
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              templateId: {
                location: "querystring",
                locationName: "templateId"
              },
              stepGroupId: {
                location: "querystring",
                locationName: "stepGroupId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              templateStepSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    stepGroupId: {},
                    templateId: {},
                    name: {},
                    stepActionType: {},
                    targetType: {},
                    owner: {},
                    previous: {
                      shape: "Sb"
                    },
                    next: {
                      shape: "Sb"
                    }
                  }
                }
              }
            }
          }
        },
        ListTemplates: {
          http: {
            method: "GET",
            requestUri: "/migrationworkflowtemplates",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              name: {
                location: "querystring",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "templateSummary"
            ],
            members: {
              nextToken: {},
              templateSummary: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    name: {},
                    arn: {},
                    description: {}
                  }
                }
              }
            }
          }
        },
        ListWorkflowStepGroups: {
          http: {
            method: "GET",
            requestUri: "/workflowstepgroups",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workflowId"
            ],
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              workflowId: {
                location: "querystring",
                locationName: "workflowId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "workflowStepGroupsSummary"
            ],
            members: {
              nextToken: {},
              workflowStepGroupsSummary: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    name: {},
                    owner: {},
                    status: {},
                    previous: {
                      shape: "Sb"
                    },
                    next: {
                      shape: "Sb"
                    }
                  }
                }
              }
            }
          }
        },
        ListWorkflowSteps: {
          http: {
            method: "GET",
            requestUri: "/workflow/{workflowId}/workflowstepgroups/{stepGroupId}/workflowsteps",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workflowId",
              "stepGroupId"
            ],
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              workflowId: {
                location: "uri",
                locationName: "workflowId"
              },
              stepGroupId: {
                location: "uri",
                locationName: "stepGroupId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "workflowStepsSummary"
            ],
            members: {
              nextToken: {},
              workflowStepsSummary: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    stepId: {},
                    name: {},
                    stepActionType: {},
                    owner: {},
                    previous: {
                      shape: "Sb"
                    },
                    next: {
                      shape: "Sb"
                    },
                    status: {},
                    statusMessage: {},
                    noOfSrvCompleted: {
                      type: "integer"
                    },
                    noOfSrvFailed: {
                      type: "integer"
                    },
                    totalNoOfSrv: {
                      type: "integer"
                    },
                    description: {},
                    scriptLocation: {}
                  }
                }
              }
            }
          }
        },
        ListWorkflows: {
          http: {
            method: "GET",
            requestUri: "/migrationworkflows",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              templateId: {
                location: "querystring",
                locationName: "templateId"
              },
              adsApplicationConfigurationName: {
                location: "querystring",
                locationName: "adsApplicationConfigurationName"
              },
              status: {
                location: "querystring",
                locationName: "status"
              },
              name: {
                location: "querystring",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "migrationWorkflowSummary"
            ],
            members: {
              nextToken: {},
              migrationWorkflowSummary: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    name: {},
                    templateId: {},
                    adsApplicationConfigurationName: {},
                    status: {},
                    creationTime: {
                      type: "timestamp"
                    },
                    endTime: {
                      type: "timestamp"
                    },
                    statusMessage: {},
                    completedSteps: {
                      type: "integer"
                    },
                    totalSteps: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        RetryWorkflowStep: {
          http: {
            requestUri: "/retryworkflowstep/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workflowId",
              "stepGroupId",
              "id"
            ],
            members: {
              workflowId: {
                location: "querystring",
                locationName: "workflowId"
              },
              stepGroupId: {
                location: "querystring",
                locationName: "stepGroupId"
              },
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              stepGroupId: {},
              workflowId: {},
              id: {},
              status: {}
            }
          }
        },
        StartWorkflow: {
          http: {
            requestUri: "/migrationworkflow/{id}/start",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              arn: {},
              status: {},
              statusMessage: {},
              lastStartTime: {
                type: "timestamp"
              }
            }
          }
        },
        StopWorkflow: {
          http: {
            requestUri: "/migrationworkflow/{id}/stop",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              arn: {},
              status: {},
              statusMessage: {},
              lastStopTime: {
                type: "timestamp"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S2i"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateWorkflow: {
          http: {
            requestUri: "/migrationworkflow/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              name: {},
              description: {},
              inputParameters: {
                shape: "S6"
              },
              stepTargets: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              arn: {},
              name: {},
              description: {},
              templateId: {},
              adsApplicationConfigurationId: {},
              workflowInputs: {
                shape: "S6"
              },
              stepTargets: {
                shape: "Sb"
              },
              status: {},
              creationTime: {
                type: "timestamp"
              },
              lastModifiedTime: {
                type: "timestamp"
              },
              tags: {
                shape: "Sd"
              }
            }
          }
        },
        UpdateWorkflowStep: {
          http: {
            requestUri: "/workflowstep/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id",
              "stepGroupId",
              "workflowId"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              stepGroupId: {},
              workflowId: {},
              name: {},
              description: {},
              stepActionType: {},
              workflowStepAutomationConfiguration: {
                shape: "Sq"
              },
              stepTarget: {
                shape: "Sb"
              },
              outputs: {
                shape: "Sx"
              },
              previous: {
                shape: "Sb"
              },
              next: {
                shape: "Sb"
              },
              status: {}
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              stepGroupId: {},
              workflowId: {},
              name: {}
            }
          }
        },
        UpdateWorkflowStepGroup: {
          http: {
            requestUri: "/workflowstepgroup/{id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "workflowId",
              "id"
            ],
            members: {
              workflowId: {
                location: "querystring",
                locationName: "workflowId"
              },
              id: {
                location: "uri",
                locationName: "id"
              },
              name: {},
              description: {},
              next: {
                shape: "Sb"
              },
              previous: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              workflowId: {},
              name: {},
              id: {},
              description: {},
              tools: {
                shape: "S18"
              },
              next: {
                shape: "Sb"
              },
              previous: {
                shape: "Sb"
              },
              lastModifiedTime: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S6: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              integerValue: {
                type: "integer"
              },
              stringValue: {},
              listOfStringsValue: {
                shape: "Sb"
              },
              mapOfStringValue: {
                shape: "Sd"
              }
            },
            union: true
          },
          sensitive: true
        },
        Sb: {
          type: "list",
          member: {}
        },
        Sd: {
          type: "map",
          key: {},
          value: {}
        },
        Sq: {
          type: "structure",
          members: {
            scriptLocationS3Bucket: {},
            scriptLocationS3Key: {
              shape: "Ss"
            },
            command: {
              shape: "Su"
            },
            runEnvironment: {},
            targetType: {}
          }
        },
        Ss: {
          type: "structure",
          members: {
            linux: {},
            windows: {}
          }
        },
        Su: {
          type: "structure",
          members: {
            linux: {},
            windows: {}
          }
        },
        Sx: {
          type: "list",
          member: {
            shape: "Sy"
          }
        },
        Sy: {
          type: "structure",
          members: {
            name: {},
            dataType: {},
            required: {
              type: "boolean"
            },
            value: {
              type: "structure",
              members: {
                integerValue: {
                  type: "integer"
                },
                stringValue: {},
                listOfStringValue: {
                  shape: "Sb"
                }
              },
              union: true
            }
          }
        },
        S18: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              url: {}
            }
          }
        },
        S2i: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/migrationhuborchestrator-2021-08-28.paginators.json
var require_migrationhuborchestrator_2021_08_28_paginators = __commonJS({
  "node_modules/aws-sdk/apis/migrationhuborchestrator-2021-08-28.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListPlugins: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "plugins"
        },
        ListTemplateStepGroups: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "templateStepGroupSummary"
        },
        ListTemplateSteps: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "templateStepSummaryList"
        },
        ListTemplates: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "templateSummary"
        },
        ListWorkflowStepGroups: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "workflowStepGroupsSummary"
        },
        ListWorkflowSteps: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "workflowStepsSummary"
        },
        ListWorkflows: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "migrationWorkflowSummary"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/migrationhuborchestrator-2021-08-28.waiters2.json
var require_migrationhuborchestrator_2021_08_28_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/migrationhuborchestrator-2021-08-28.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {}
    };
  }
});

// node_modules/aws-sdk/clients/migrationhuborchestrator.js
var require_migrationhuborchestrator = __commonJS({
  "node_modules/aws-sdk/clients/migrationhuborchestrator.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["migrationhuborchestrator"] = {};
    AWS2.MigrationHubOrchestrator = Service.defineService("migrationhuborchestrator", ["2021-08-28"]);
    Object.defineProperty(apiLoader.services["migrationhuborchestrator"], "2021-08-28", {
      get: function get() {
        var model = require_migrationhuborchestrator_2021_08_28_min();
        model.paginators = require_migrationhuborchestrator_2021_08_28_paginators().pagination;
        model.waiters = require_migrationhuborchestrator_2021_08_28_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.MigrationHubOrchestrator;
  }
});

// node_modules/aws-sdk/apis/connectcases-2022-10-03.min.json
var require_connectcases_2022_10_03_min = __commonJS({
  "node_modules/aws-sdk/apis/connectcases-2022-10-03.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2022-10-03",
        endpointPrefix: "cases",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "ConnectCases",
        serviceFullName: "Amazon Connect Cases",
        serviceId: "ConnectCases",
        signatureVersion: "v4",
        signingName: "cases",
        uid: "connectcases-2022-10-03"
      },
      operations: {
        BatchGetField: {
          http: {
            requestUri: "/domains/{domainId}/fields-batch",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainId",
              "fields"
            ],
            members: {
              domainId: {
                location: "uri",
                locationName: "domainId"
              },
              fields: {
                type: "list",
                member: {
                  shape: "S4"
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "errors",
              "fields"
            ],
            members: {
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "errorCode",
                    "id"
                  ],
                  members: {
                    errorCode: {},
                    id: {},
                    message: {}
                  }
                }
              },
              fields: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "fieldArn",
                    "fieldId",
                    "name",
                    "namespace",
                    "type"
                  ],
                  members: {
                    description: {},
                    fieldArn: {},
                    fieldId: {},
                    name: {},
                    namespace: {},
                    tags: {
                      shape: "Sg"
                    },
                    type: {}
                  }
                }
              }
            }
          }
        },
        BatchPutFieldOptions: {
          http: {
            method: "PUT",
            requestUri: "/domains/{domainId}/fields/{fieldId}/options",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainId",
              "fieldId",
              "options"
            ],
            members: {
              domainId: {
                location: "uri",
                locationName: "domainId"
              },
              fieldId: {
                location: "uri",
                locationName: "fieldId"
              },
              options: {
                type: "list",
                member: {
                  shape: "Sk"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "errorCode",
                    "message",
                    "value"
                  ],
                  members: {
                    errorCode: {},
                    message: {},
                    value: {}
                  }
                }
              }
            }
          },
          idempotent: true
        },
        CreateCase: {
          http: {
            requestUri: "/domains/{domainId}/cases",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainId",
              "fields",
              "templateId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              domainId: {
                location: "uri",
                locationName: "domainId"
              },
              fields: {
                type: "list",
                member: {
                  shape: "Su"
                }
              },
              templateId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "caseArn",
              "caseId"
            ],
            members: {
              caseArn: {},
              caseId: {}
            }
          },
          idempotent: true
        },
        CreateDomain: {
          http: {
            requestUri: "/domains",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "domainArn",
              "domainId",
              "domainStatus"
            ],
            members: {
              domainArn: {},
              domainId: {},
              domainStatus: {}
            }
          },
          idempotent: true
        },
        CreateField: {
          http: {
            requestUri: "/domains/{domainId}/fields",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainId",
              "name",
              "type"
            ],
            members: {
              description: {},
              domainId: {
                location: "uri",
                locationName: "domainId"
              },
              name: {},
              type: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "fieldArn",
              "fieldId"
            ],
            members: {
              fieldArn: {},
              fieldId: {}
            }
          },
          idempotent: true
        },
        CreateLayout: {
          http: {
            requestUri: "/domains/{domainId}/layouts",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "content",
              "domainId",
              "name"
            ],
            members: {
              content: {
                shape: "S1b"
              },
              domainId: {
                location: "uri",
                locationName: "domainId"
              },
              name: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "layoutArn",
              "layoutId"
            ],
            members: {
              layoutArn: {},
              layoutId: {}
            }
          }
        },
        CreateRelatedItem: {
          http: {
            requestUri: "/domains/{domainId}/cases/{caseId}/related-items/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "caseId",
              "content",
              "domainId",
              "type"
            ],
            members: {
              caseId: {
                location: "uri",
                locationName: "caseId"
              },
              content: {
                type: "structure",
                members: {
                  comment: {
                    shape: "S1q"
                  },
                  contact: {
                    type: "structure",
                    required: [
                      "contactArn"
                    ],
                    members: {
                      contactArn: {}
                    }
                  }
                },
                union: true
              },
              domainId: {
                location: "uri",
                locationName: "domainId"
              },
              performedBy: {
                shape: "S1v"
              },
              type: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "relatedItemArn",
              "relatedItemId"
            ],
            members: {
              relatedItemArn: {},
              relatedItemId: {}
            }
          },
          idempotent: true
        },
        CreateTemplate: {
          http: {
            requestUri: "/domains/{domainId}/templates",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainId",
              "name"
            ],
            members: {
              description: {},
              domainId: {
                location: "uri",
                locationName: "domainId"
              },
              layoutConfiguration: {
                shape: "S23"
              },
              name: {},
              requiredFields: {
                shape: "S25"
              },
              status: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "templateArn",
              "templateId"
            ],
            members: {
              templateArn: {},
              templateId: {}
            }
          },
          idempotent: true
        },
        DeleteDomain: {
          http: {
            method: "DELETE",
            requestUri: "/domains/{domainId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainId"
            ],
            members: {
              domainId: {
                location: "uri",
                locationName: "domainId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        GetCase: {
          http: {
            requestUri: "/domains/{domainId}/cases/{caseId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "caseId",
              "domainId",
              "fields"
            ],
            members: {
              caseId: {
                location: "uri",
                locationName: "caseId"
              },
              domainId: {
                location: "uri",
                locationName: "domainId"
              },
              fields: {
                type: "list",
                member: {
                  shape: "S4"
                }
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "fields",
              "templateId"
            ],
            members: {
              fields: {
                type: "list",
                member: {
                  shape: "Su"
                }
              },
              nextToken: {},
              tags: {
                shape: "Sg"
              },
              templateId: {}
            }
          }
        },
        GetCaseEventConfiguration: {
          http: {
            requestUri: "/domains/{domainId}/case-event-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainId"
            ],
            members: {
              domainId: {
                location: "uri",
                locationName: "domainId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "eventBridge"
            ],
            members: {
              eventBridge: {
                shape: "S2j"
              }
            }
          }
        },
        GetDomain: {
          http: {
            requestUri: "/domains/{domainId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainId"
            ],
            members: {
              domainId: {
                location: "uri",
                locationName: "domainId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "createdTime",
              "domainArn",
              "domainId",
              "domainStatus",
              "name"
            ],
            members: {
              createdTime: {
                type: "timestamp",
                timestampFormat: "iso8601"
              },
              domainArn: {},
              domainId: {},
              domainStatus: {},
              name: {},
              tags: {
                shape: "Sg"
              }
            }
          }
        },
        GetLayout: {
          http: {
            requestUri: "/domains/{domainId}/layouts/{layoutId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainId",
              "layoutId"
            ],
            members: {
              domainId: {
                location: "uri",
                locationName: "domainId"
              },
              layoutId: {
                location: "uri",
                locationName: "layoutId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "content",
              "layoutArn",
              "layoutId",
              "name"
            ],
            members: {
              content: {
                shape: "S1b"
              },
              layoutArn: {},
              layoutId: {},
              name: {},
              tags: {
                shape: "Sg"
              }
            }
          }
        },
        GetTemplate: {
          http: {
            requestUri: "/domains/{domainId}/templates/{templateId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainId",
              "templateId"
            ],
            members: {
              domainId: {
                location: "uri",
                locationName: "domainId"
              },
              templateId: {
                location: "uri",
                locationName: "templateId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "name",
              "status",
              "templateArn",
              "templateId"
            ],
            members: {
              description: {},
              layoutConfiguration: {
                shape: "S23"
              },
              name: {},
              requiredFields: {
                shape: "S25"
              },
              status: {},
              tags: {
                shape: "Sg"
              },
              templateArn: {},
              templateId: {}
            }
          }
        },
        ListCasesForContact: {
          http: {
            requestUri: "/domains/{domainId}/list-cases-for-contact",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "contactArn",
              "domainId"
            ],
            members: {
              contactArn: {},
              domainId: {
                location: "uri",
                locationName: "domainId"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "cases"
            ],
            members: {
              cases: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "caseId",
                    "templateId"
                  ],
                  members: {
                    caseId: {},
                    templateId: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDomains: {
          http: {
            requestUri: "/domains-list",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "domains"
            ],
            members: {
              domains: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "domainArn",
                    "domainId",
                    "name"
                  ],
                  members: {
                    domainArn: {},
                    domainId: {},
                    name: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListFieldOptions: {
          http: {
            requestUri: "/domains/{domainId}/fields/{fieldId}/options-list",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainId",
              "fieldId"
            ],
            members: {
              domainId: {
                location: "uri",
                locationName: "domainId"
              },
              fieldId: {
                location: "uri",
                locationName: "fieldId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              values: {
                location: "querystring",
                locationName: "values",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "options"
            ],
            members: {
              nextToken: {},
              options: {
                type: "list",
                member: {
                  shape: "Sk"
                }
              }
            }
          }
        },
        ListFields: {
          http: {
            requestUri: "/domains/{domainId}/fields-list",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainId"
            ],
            members: {
              domainId: {
                location: "uri",
                locationName: "domainId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "fields"
            ],
            members: {
              fields: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "fieldArn",
                    "fieldId",
                    "name",
                    "namespace",
                    "type"
                  ],
                  members: {
                    fieldArn: {},
                    fieldId: {},
                    name: {},
                    namespace: {},
                    type: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListLayouts: {
          http: {
            requestUri: "/domains/{domainId}/layouts-list",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainId"
            ],
            members: {
              domainId: {
                location: "uri",
                locationName: "domainId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "layouts"
            ],
            members: {
              layouts: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "layoutArn",
                    "layoutId",
                    "name"
                  ],
                  members: {
                    layoutArn: {},
                    layoutId: {},
                    name: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {
                location: "uri",
                locationName: "arn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sg"
              }
            }
          },
          idempotent: true
        },
        ListTemplates: {
          http: {
            requestUri: "/domains/{domainId}/templates-list",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainId"
            ],
            members: {
              domainId: {
                location: "uri",
                locationName: "domainId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              status: {
                location: "querystring",
                locationName: "status",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "templates"
            ],
            members: {
              nextToken: {},
              templates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "status",
                    "templateArn",
                    "templateId"
                  ],
                  members: {
                    name: {},
                    status: {},
                    templateArn: {},
                    templateId: {}
                  }
                }
              }
            }
          }
        },
        PutCaseEventConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/domains/{domainId}/case-event-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainId",
              "eventBridge"
            ],
            members: {
              domainId: {
                location: "uri",
                locationName: "domainId"
              },
              eventBridge: {
                shape: "S2j"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SearchCases: {
          http: {
            requestUri: "/domains/{domainId}/cases-search",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainId"
            ],
            members: {
              domainId: {
                location: "uri",
                locationName: "domainId"
              },
              fields: {
                type: "list",
                member: {
                  shape: "S4"
                }
              },
              filter: {
                shape: "S3v"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              searchTerm: {},
              sorts: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "fieldId",
                    "sortOrder"
                  ],
                  members: {
                    fieldId: {},
                    sortOrder: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "cases"
            ],
            members: {
              cases: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "caseId",
                    "fields",
                    "templateId"
                  ],
                  members: {
                    caseId: {},
                    fields: {
                      type: "list",
                      member: {
                        shape: "Su"
                      }
                    },
                    tags: {
                      shape: "Sg"
                    },
                    templateId: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        SearchRelatedItems: {
          http: {
            requestUri: "/domains/{domainId}/cases/{caseId}/related-items-search",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "caseId",
              "domainId"
            ],
            members: {
              caseId: {
                location: "uri",
                locationName: "caseId"
              },
              domainId: {
                location: "uri",
                locationName: "domainId"
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    comment: {
                      type: "structure",
                      members: {}
                    },
                    contact: {
                      type: "structure",
                      members: {
                        channel: {
                          type: "list",
                          member: {}
                        },
                        contactArn: {}
                      }
                    }
                  },
                  union: true
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "relatedItems"
            ],
            members: {
              nextToken: {},
              relatedItems: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "associationTime",
                    "content",
                    "relatedItemId",
                    "type"
                  ],
                  members: {
                    associationTime: {
                      type: "timestamp",
                      timestampFormat: "iso8601"
                    },
                    content: {
                      type: "structure",
                      members: {
                        comment: {
                          shape: "S1q"
                        },
                        contact: {
                          type: "structure",
                          required: [
                            "channel",
                            "connectedToSystemTime",
                            "contactArn"
                          ],
                          members: {
                            channel: {},
                            connectedToSystemTime: {
                              type: "timestamp",
                              timestampFormat: "iso8601"
                            },
                            contactArn: {}
                          }
                        }
                      },
                      union: true
                    },
                    performedBy: {
                      shape: "S1v"
                    },
                    relatedItemId: {},
                    tags: {
                      shape: "Sg"
                    },
                    type: {}
                  }
                }
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn",
              "tags"
            ],
            members: {
              arn: {
                location: "uri",
                locationName: "arn"
              },
              tags: {
                shape: "Sg"
              }
            }
          },
          idempotent: true
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn",
              "tagKeys"
            ],
            members: {
              arn: {
                location: "uri",
                locationName: "arn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          idempotent: true
        },
        UpdateCase: {
          http: {
            method: "PUT",
            requestUri: "/domains/{domainId}/cases/{caseId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "caseId",
              "domainId",
              "fields"
            ],
            members: {
              caseId: {
                location: "uri",
                locationName: "caseId"
              },
              domainId: {
                location: "uri",
                locationName: "domainId"
              },
              fields: {
                type: "list",
                member: {
                  shape: "Su"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateField: {
          http: {
            method: "PUT",
            requestUri: "/domains/{domainId}/fields/{fieldId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainId",
              "fieldId"
            ],
            members: {
              description: {},
              domainId: {
                location: "uri",
                locationName: "domainId"
              },
              fieldId: {
                location: "uri",
                locationName: "fieldId"
              },
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateLayout: {
          http: {
            method: "PUT",
            requestUri: "/domains/{domainId}/layouts/{layoutId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainId",
              "layoutId"
            ],
            members: {
              content: {
                shape: "S1b"
              },
              domainId: {
                location: "uri",
                locationName: "domainId"
              },
              layoutId: {
                location: "uri",
                locationName: "layoutId"
              },
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateTemplate: {
          http: {
            method: "PUT",
            requestUri: "/domains/{domainId}/templates/{templateId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainId",
              "templateId"
            ],
            members: {
              description: {},
              domainId: {
                location: "uri",
                locationName: "domainId"
              },
              layoutConfiguration: {
                shape: "S23"
              },
              name: {},
              requiredFields: {
                shape: "S25"
              },
              status: {},
              templateId: {
                location: "uri",
                locationName: "templateId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        }
      },
      shapes: {
        S4: {
          type: "structure",
          required: [
            "id"
          ],
          members: {
            id: {}
          }
        },
        Sg: {
          type: "map",
          key: {},
          value: {}
        },
        Sk: {
          type: "structure",
          required: [
            "active",
            "name",
            "value"
          ],
          members: {
            active: {
              type: "boolean"
            },
            name: {},
            value: {}
          }
        },
        Su: {
          type: "structure",
          required: [
            "id",
            "value"
          ],
          members: {
            id: {},
            value: {
              type: "structure",
              members: {
                booleanValue: {
                  type: "boolean"
                },
                doubleValue: {
                  type: "double"
                },
                emptyValue: {
                  type: "structure",
                  members: {}
                },
                stringValue: {}
              },
              union: true
            }
          }
        },
        S1b: {
          type: "structure",
          members: {
            basic: {
              type: "structure",
              members: {
                moreInfo: {
                  shape: "S1d"
                },
                topPanel: {
                  shape: "S1d"
                }
              }
            }
          },
          union: true
        },
        S1d: {
          type: "structure",
          members: {
            sections: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  fieldGroup: {
                    type: "structure",
                    required: [
                      "fields"
                    ],
                    members: {
                      fields: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "id"
                          ],
                          members: {
                            id: {}
                          }
                        }
                      },
                      name: {}
                    }
                  }
                },
                union: true
              }
            }
          }
        },
        S1q: {
          type: "structure",
          required: [
            "body",
            "contentType"
          ],
          members: {
            body: {},
            contentType: {}
          }
        },
        S1v: {
          type: "structure",
          members: {
            userArn: {}
          },
          union: true
        },
        S23: {
          type: "structure",
          members: {
            defaultLayout: {}
          }
        },
        S25: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "fieldId"
            ],
            members: {
              fieldId: {}
            }
          }
        },
        S2j: {
          type: "structure",
          required: [
            "enabled"
          ],
          members: {
            enabled: {
              type: "boolean"
            },
            includedData: {
              type: "structure",
              members: {
                caseData: {
                  type: "structure",
                  required: [
                    "fields"
                  ],
                  members: {
                    fields: {
                      type: "list",
                      member: {
                        shape: "S4"
                      }
                    }
                  }
                },
                relatedItemData: {
                  type: "structure",
                  required: [
                    "includeContent"
                  ],
                  members: {
                    includeContent: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        S3v: {
          type: "structure",
          members: {
            andAll: {
              type: "list",
              member: {
                shape: "S3v"
              }
            },
            field: {
              type: "structure",
              members: {
                contains: {
                  shape: "Su"
                },
                equalTo: {
                  shape: "Su"
                },
                greaterThan: {
                  shape: "Su"
                },
                greaterThanOrEqualTo: {
                  shape: "Su"
                },
                lessThan: {
                  shape: "Su"
                },
                lessThanOrEqualTo: {
                  shape: "Su"
                }
              },
              union: true
            },
            not: {
              shape: "S3v"
            },
            orAll: {
              type: "list",
              member: {
                shape: "S3v"
              }
            }
          },
          union: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/connectcases-2022-10-03.paginators.json
var require_connectcases_2022_10_03_paginators = __commonJS({
  "node_modules/aws-sdk/apis/connectcases-2022-10-03.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetCase: {
          input_token: "nextToken",
          output_token: "nextToken"
        },
        ListCasesForContact: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListDomains: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListFieldOptions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListFields: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListLayouts: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListTemplates: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        SearchCases: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "cases"
        },
        SearchRelatedItems: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "relatedItems"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/connectcases.js
var require_connectcases = __commonJS({
  "node_modules/aws-sdk/clients/connectcases.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["connectcases"] = {};
    AWS2.ConnectCases = Service.defineService("connectcases", ["2022-10-03"]);
    Object.defineProperty(apiLoader.services["connectcases"], "2022-10-03", {
      get: function get() {
        var model = require_connectcases_2022_10_03_min();
        model.paginators = require_connectcases_2022_10_03_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ConnectCases;
  }
});

// node_modules/aws-sdk/apis/resource-explorer-2-2022-07-28.min.json
var require_resource_explorer_2_2022_07_28_min = __commonJS({
  "node_modules/aws-sdk/apis/resource-explorer-2-2022-07-28.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2022-07-28",
        endpointPrefix: "resource-explorer-2",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Resource Explorer",
        serviceId: "Resource Explorer 2",
        signatureVersion: "v4",
        signingName: "resource-explorer-2",
        uid: "resource-explorer-2-2022-07-28"
      },
      operations: {
        AssociateDefaultView: {
          http: {
            requestUri: "/AssociateDefaultView",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ViewArn"
            ],
            members: {
              ViewArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ViewArn: {}
            }
          },
          idempotent: true
        },
        BatchGetView: {
          http: {
            requestUri: "/BatchGetView",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ViewArns: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ErrorMessage",
                    "ViewArn"
                  ],
                  members: {
                    ErrorMessage: {},
                    ViewArn: {}
                  }
                }
              },
              Views: {
                type: "list",
                member: {
                  shape: "Sb"
                }
              }
            }
          }
        },
        CreateIndex: {
          http: {
            requestUri: "/CreateIndex",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreatedAt: {
                shape: "Sh"
              },
              State: {}
            }
          },
          idempotent: true
        },
        CreateView: {
          http: {
            requestUri: "/CreateView",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ViewName"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              Filters: {
                shape: "Sc"
              },
              IncludedProperties: {
                shape: "Se"
              },
              Scope: {},
              Tags: {
                shape: "Sj"
              },
              ViewName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              View: {
                shape: "Sb"
              }
            }
          }
        },
        DeleteIndex: {
          http: {
            requestUri: "/DeleteIndex",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              LastUpdatedAt: {
                shape: "Sh"
              },
              State: {}
            }
          },
          idempotent: true
        },
        DeleteView: {
          http: {
            requestUri: "/DeleteView",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ViewArn"
            ],
            members: {
              ViewArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ViewArn: {}
            }
          },
          idempotent: true
        },
        DisassociateDefaultView: {
          http: {
            requestUri: "/DisassociateDefaultView",
            responseCode: 200
          },
          idempotent: true
        },
        GetAccountLevelServiceConfiguration: {
          http: {
            requestUri: "/GetAccountLevelServiceConfiguration",
            responseCode: 200
          },
          output: {
            type: "structure",
            members: {
              OrgConfiguration: {
                type: "structure",
                required: [
                  "AWSServiceAccessStatus"
                ],
                members: {
                  AWSServiceAccessStatus: {},
                  ServiceLinkedRole: {}
                }
              }
            }
          }
        },
        GetDefaultView: {
          http: {
            requestUri: "/GetDefaultView",
            responseCode: 200
          },
          output: {
            type: "structure",
            members: {
              ViewArn: {}
            }
          }
        },
        GetIndex: {
          http: {
            requestUri: "/GetIndex",
            responseCode: 200
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreatedAt: {
                shape: "Sh"
              },
              LastUpdatedAt: {
                shape: "Sh"
              },
              ReplicatingFrom: {
                shape: "S11"
              },
              ReplicatingTo: {
                shape: "S11"
              },
              State: {},
              Tags: {
                shape: "Sj"
              },
              Type: {}
            }
          }
        },
        GetView: {
          http: {
            requestUri: "/GetView",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ViewArn"
            ],
            members: {
              ViewArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sj"
              },
              View: {
                shape: "Sb"
              }
            }
          }
        },
        ListIndexes: {
          http: {
            requestUri: "/ListIndexes",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Regions: {
                type: "list",
                member: {}
              },
              Type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Indexes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Region: {},
                    Type: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListIndexesForMembers: {
          http: {
            requestUri: "/ListIndexesForMembers",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountIdList"
            ],
            members: {
              AccountIdList: {
                type: "list",
                member: {}
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Indexes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AccountId: {},
                    Arn: {},
                    Region: {},
                    Type: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSupportedResourceTypes: {
          http: {
            requestUri: "/ListSupportedResourceTypes",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ResourceTypes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceType: {},
                    Service: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sj"
              }
            }
          }
        },
        ListViews: {
          http: {
            requestUri: "/ListViews",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Views: {
                type: "list",
                member: {}
              }
            }
          }
        },
        Search: {
          http: {
            requestUri: "/Search",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "QueryString"
            ],
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              QueryString: {
                type: "string",
                sensitive: true
              },
              ViewArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Count: {
                type: "structure",
                members: {
                  Complete: {
                    type: "boolean"
                  },
                  TotalResources: {
                    type: "long"
                  }
                }
              },
              NextToken: {},
              Resources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    LastReportedAt: {
                      shape: "Sh"
                    },
                    OwningAccountId: {},
                    Properties: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Data: {
                            type: "structure",
                            members: {},
                            document: true
                          },
                          LastReportedAt: {
                            shape: "Sh"
                          },
                          Name: {}
                        }
                      }
                    },
                    Region: {},
                    ResourceType: {},
                    Service: {}
                  }
                }
              },
              ViewArn: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              Tags: {
                shape: "Sj"
              },
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {},
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateIndexType: {
          http: {
            requestUri: "/UpdateIndexType",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Arn",
              "Type"
            ],
            members: {
              Arn: {},
              Type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              LastUpdatedAt: {
                shape: "Sh"
              },
              State: {},
              Type: {}
            }
          }
        },
        UpdateView: {
          http: {
            requestUri: "/UpdateView",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ViewArn"
            ],
            members: {
              Filters: {
                shape: "Sc"
              },
              IncludedProperties: {
                shape: "Se"
              },
              ViewArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              View: {
                shape: "Sb"
              }
            }
          }
        }
      },
      shapes: {
        Sb: {
          type: "structure",
          members: {
            Filters: {
              shape: "Sc"
            },
            IncludedProperties: {
              shape: "Se"
            },
            LastUpdatedAt: {
              shape: "Sh"
            },
            Owner: {},
            Scope: {},
            ViewArn: {}
          }
        },
        Sc: {
          type: "structure",
          required: [
            "FilterString"
          ],
          members: {
            FilterString: {}
          },
          sensitive: true
        },
        Se: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        Sh: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        Sj: {
          type: "map",
          key: {},
          value: {},
          sensitive: true
        },
        S11: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/resource-explorer-2-2022-07-28.paginators.json
var require_resource_explorer_2_2022_07_28_paginators = __commonJS({
  "node_modules/aws-sdk/apis/resource-explorer-2-2022-07-28.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListIndexes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Indexes"
        },
        ListIndexesForMembers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Indexes"
        },
        ListSupportedResourceTypes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ResourceTypes"
        },
        ListViews: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Views"
        },
        Search: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Resources"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/resourceexplorer2.js
var require_resourceexplorer2 = __commonJS({
  "node_modules/aws-sdk/clients/resourceexplorer2.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["resourceexplorer2"] = {};
    AWS2.ResourceExplorer2 = Service.defineService("resourceexplorer2", ["2022-07-28"]);
    Object.defineProperty(apiLoader.services["resourceexplorer2"], "2022-07-28", {
      get: function get() {
        var model = require_resource_explorer_2_2022_07_28_min();
        model.paginators = require_resource_explorer_2_2022_07_28_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ResourceExplorer2;
  }
});

// node_modules/aws-sdk/apis/scheduler-2021-06-30.min.json
var require_scheduler_2021_06_30_min = __commonJS({
  "node_modules/aws-sdk/apis/scheduler-2021-06-30.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-06-30",
        endpointPrefix: "scheduler",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon EventBridge Scheduler",
        serviceId: "Scheduler",
        signatureVersion: "v4",
        signingName: "scheduler",
        uid: "scheduler-2021-06-30"
      },
      operations: {
        CreateSchedule: {
          http: {
            requestUri: "/schedules/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FlexibleTimeWindow",
              "Name",
              "ScheduleExpression",
              "Target"
            ],
            members: {
              ActionAfterCompletion: {},
              ClientToken: {
                idempotencyToken: true
              },
              Description: {},
              EndDate: {
                type: "timestamp"
              },
              FlexibleTimeWindow: {
                shape: "S6"
              },
              GroupName: {},
              KmsKeyArn: {},
              Name: {
                location: "uri",
                locationName: "Name"
              },
              ScheduleExpression: {},
              ScheduleExpressionTimezone: {},
              StartDate: {
                type: "timestamp"
              },
              State: {},
              Target: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ScheduleArn"
            ],
            members: {
              ScheduleArn: {}
            }
          },
          idempotent: true
        },
        CreateScheduleGroup: {
          http: {
            requestUri: "/schedule-groups/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              Name: {
                location: "uri",
                locationName: "Name"
              },
              Tags: {
                shape: "S22"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ScheduleGroupArn"
            ],
            members: {
              ScheduleGroupArn: {}
            }
          },
          idempotent: true
        },
        DeleteSchedule: {
          http: {
            method: "DELETE",
            requestUri: "/schedules/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              },
              GroupName: {
                location: "querystring",
                locationName: "groupName"
              },
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteScheduleGroup: {
          http: {
            method: "DELETE",
            requestUri: "/schedule-groups/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              },
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        GetSchedule: {
          http: {
            method: "GET",
            requestUri: "/schedules/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              GroupName: {
                location: "querystring",
                locationName: "groupName"
              },
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ActionAfterCompletion: {},
              Arn: {},
              CreationDate: {
                type: "timestamp"
              },
              Description: {},
              EndDate: {
                type: "timestamp"
              },
              FlexibleTimeWindow: {
                shape: "S6"
              },
              GroupName: {},
              KmsKeyArn: {},
              LastModificationDate: {
                type: "timestamp"
              },
              Name: {},
              ScheduleExpression: {},
              ScheduleExpressionTimezone: {},
              StartDate: {
                type: "timestamp"
              },
              State: {},
              Target: {
                shape: "Sg"
              }
            }
          }
        },
        GetScheduleGroup: {
          http: {
            method: "GET",
            requestUri: "/schedule-groups/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationDate: {
                type: "timestamp"
              },
              LastModificationDate: {
                type: "timestamp"
              },
              Name: {},
              State: {}
            }
          }
        },
        ListScheduleGroups: {
          http: {
            method: "GET",
            requestUri: "/schedule-groups",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NamePrefix: {
                location: "querystring",
                locationName: "NamePrefix"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ScheduleGroups"
            ],
            members: {
              NextToken: {},
              ScheduleGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    CreationDate: {
                      type: "timestamp"
                    },
                    LastModificationDate: {
                      type: "timestamp"
                    },
                    Name: {},
                    State: {}
                  }
                }
              }
            }
          }
        },
        ListSchedules: {
          http: {
            method: "GET",
            requestUri: "/schedules",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              GroupName: {
                location: "querystring",
                locationName: "ScheduleGroup"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NamePrefix: {
                location: "querystring",
                locationName: "NamePrefix"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              State: {
                location: "querystring",
                locationName: "State"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Schedules"
            ],
            members: {
              NextToken: {},
              Schedules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    CreationDate: {
                      type: "timestamp"
                    },
                    GroupName: {},
                    LastModificationDate: {
                      type: "timestamp"
                    },
                    Name: {},
                    State: {},
                    Target: {
                      type: "structure",
                      required: [
                        "Arn"
                      ],
                      members: {
                        Arn: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S22"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "S22"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "TagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateSchedule: {
          http: {
            method: "PUT",
            requestUri: "/schedules/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FlexibleTimeWindow",
              "Name",
              "ScheduleExpression",
              "Target"
            ],
            members: {
              ActionAfterCompletion: {},
              ClientToken: {
                idempotencyToken: true
              },
              Description: {},
              EndDate: {
                type: "timestamp"
              },
              FlexibleTimeWindow: {
                shape: "S6"
              },
              GroupName: {},
              KmsKeyArn: {},
              Name: {
                location: "uri",
                locationName: "Name"
              },
              ScheduleExpression: {},
              ScheduleExpressionTimezone: {},
              StartDate: {
                type: "timestamp"
              },
              State: {},
              Target: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ScheduleArn"
            ],
            members: {
              ScheduleArn: {}
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S6: {
          type: "structure",
          required: [
            "Mode"
          ],
          members: {
            MaximumWindowInMinutes: {
              type: "integer"
            },
            Mode: {}
          }
        },
        Sg: {
          type: "structure",
          required: [
            "Arn",
            "RoleArn"
          ],
          members: {
            Arn: {},
            DeadLetterConfig: {
              type: "structure",
              members: {
                Arn: {}
              }
            },
            EcsParameters: {
              type: "structure",
              required: [
                "TaskDefinitionArn"
              ],
              members: {
                CapacityProviderStrategy: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "capacityProvider"
                    ],
                    members: {
                      base: {
                        type: "integer"
                      },
                      capacityProvider: {},
                      weight: {
                        type: "integer"
                      }
                    }
                  }
                },
                EnableECSManagedTags: {
                  type: "boolean"
                },
                EnableExecuteCommand: {
                  type: "boolean"
                },
                Group: {},
                LaunchType: {},
                NetworkConfiguration: {
                  type: "structure",
                  members: {
                    awsvpcConfiguration: {
                      type: "structure",
                      required: [
                        "Subnets"
                      ],
                      members: {
                        AssignPublicIp: {},
                        SecurityGroups: {
                          type: "list",
                          member: {}
                        },
                        Subnets: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  }
                },
                PlacementConstraints: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      expression: {},
                      type: {}
                    }
                  }
                },
                PlacementStrategy: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      field: {},
                      type: {}
                    }
                  }
                },
                PlatformVersion: {},
                PropagateTags: {},
                ReferenceId: {},
                Tags: {
                  type: "list",
                  member: {
                    type: "map",
                    key: {},
                    value: {}
                  }
                },
                TaskCount: {
                  type: "integer"
                },
                TaskDefinitionArn: {}
              }
            },
            EventBridgeParameters: {
              type: "structure",
              required: [
                "DetailType",
                "Source"
              ],
              members: {
                DetailType: {},
                Source: {}
              }
            },
            Input: {},
            KinesisParameters: {
              type: "structure",
              required: [
                "PartitionKey"
              ],
              members: {
                PartitionKey: {}
              }
            },
            RetryPolicy: {
              type: "structure",
              members: {
                MaximumEventAgeInSeconds: {
                  type: "integer"
                },
                MaximumRetryAttempts: {
                  type: "integer"
                }
              }
            },
            RoleArn: {},
            SageMakerPipelineParameters: {
              type: "structure",
              members: {
                PipelineParameterList: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "Name",
                      "Value"
                    ],
                    members: {
                      Name: {},
                      Value: {}
                    }
                  }
                }
              }
            },
            SqsParameters: {
              type: "structure",
              members: {
                MessageGroupId: {}
              }
            }
          }
        },
        S22: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/scheduler-2021-06-30.paginators.json
var require_scheduler_2021_06_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/scheduler-2021-06-30.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListScheduleGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ScheduleGroups"
        },
        ListSchedules: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Schedules"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/scheduler.js
var require_scheduler = __commonJS({
  "node_modules/aws-sdk/clients/scheduler.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["scheduler"] = {};
    AWS2.Scheduler = Service.defineService("scheduler", ["2021-06-30"]);
    Object.defineProperty(apiLoader.services["scheduler"], "2021-06-30", {
      get: function get() {
        var model = require_scheduler_2021_06_30_min();
        model.paginators = require_scheduler_2021_06_30_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Scheduler;
  }
});

// node_modules/aws-sdk/apis/chime-sdk-voice-2022-08-03.min.json
var require_chime_sdk_voice_2022_08_03_min = __commonJS({
  "node_modules/aws-sdk/apis/chime-sdk-voice-2022-08-03.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2022-08-03",
        endpointPrefix: "voice-chime",
        protocol: "rest-json",
        serviceFullName: "Amazon Chime SDK Voice",
        serviceId: "Chime SDK Voice",
        signatureVersion: "v4",
        signingName: "chime",
        uid: "chime-sdk-voice-2022-08-03"
      },
      operations: {
        AssociatePhoneNumbersWithVoiceConnector: {
          http: {
            requestUri: "/voice-connectors/{voiceConnectorId}?operation=associate-phone-numbers",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "E164PhoneNumbers"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              E164PhoneNumbers: {
                shape: "S3"
              },
              ForceAssociate: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberErrors: {
                shape: "S7"
              }
            }
          }
        },
        AssociatePhoneNumbersWithVoiceConnectorGroup: {
          http: {
            requestUri: "/voice-connector-groups/{voiceConnectorGroupId}?operation=associate-phone-numbers",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorGroupId",
              "E164PhoneNumbers"
            ],
            members: {
              VoiceConnectorGroupId: {
                location: "uri",
                locationName: "voiceConnectorGroupId"
              },
              E164PhoneNumbers: {
                shape: "S3"
              },
              ForceAssociate: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberErrors: {
                shape: "S7"
              }
            }
          }
        },
        BatchDeletePhoneNumber: {
          http: {
            requestUri: "/phone-numbers?operation=batch-delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "PhoneNumberIds"
            ],
            members: {
              PhoneNumberIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberErrors: {
                shape: "S7"
              }
            }
          }
        },
        BatchUpdatePhoneNumber: {
          http: {
            requestUri: "/phone-numbers?operation=batch-update",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "UpdatePhoneNumberRequestItems"
            ],
            members: {
              UpdatePhoneNumberRequestItems: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "PhoneNumberId"
                  ],
                  members: {
                    PhoneNumberId: {
                      shape: "S9"
                    },
                    ProductType: {},
                    CallingName: {
                      shape: "Sl"
                    },
                    Name: {
                      shape: "Sm"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberErrors: {
                shape: "S7"
              }
            }
          }
        },
        CreatePhoneNumberOrder: {
          http: {
            requestUri: "/phone-number-orders",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ProductType",
              "E164PhoneNumbers"
            ],
            members: {
              ProductType: {},
              E164PhoneNumbers: {
                shape: "S3"
              },
              Name: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberOrder: {
                shape: "Sq"
              }
            }
          }
        },
        CreateProxySession: {
          http: {
            requestUri: "/voice-connectors/{voiceConnectorId}/proxy-sessions",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ParticipantPhoneNumbers",
              "Capabilities",
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              ParticipantPhoneNumbers: {
                type: "list",
                member: {
                  shape: "S4"
                }
              },
              Name: {
                type: "string",
                sensitive: true
              },
              ExpiryMinutes: {
                type: "integer"
              },
              Capabilities: {
                shape: "S13"
              },
              NumberSelectionBehavior: {},
              GeoMatchLevel: {},
              GeoMatchParams: {
                shape: "S17"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProxySession: {
                shape: "S1b"
              }
            }
          }
        },
        CreateSipMediaApplication: {
          http: {
            requestUri: "/sip-media-applications",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AwsRegion",
              "Name",
              "Endpoints"
            ],
            members: {
              AwsRegion: {},
              Name: {},
              Endpoints: {
                shape: "S1i"
              },
              Tags: {
                shape: "S1l"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipMediaApplication: {
                shape: "S1q"
              }
            }
          }
        },
        CreateSipMediaApplicationCall: {
          http: {
            requestUri: "/sip-media-applications/{sipMediaApplicationId}/calls",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FromPhoneNumber",
              "ToPhoneNumber",
              "SipMediaApplicationId"
            ],
            members: {
              FromPhoneNumber: {
                shape: "S4"
              },
              ToPhoneNumber: {
                shape: "S4"
              },
              SipMediaApplicationId: {
                location: "uri",
                locationName: "sipMediaApplicationId"
              },
              SipHeaders: {
                type: "map",
                key: {
                  shape: "S1t"
                },
                value: {
                  shape: "S1t"
                }
              },
              ArgumentsMap: {
                type: "map",
                key: {
                  shape: "S1t"
                },
                value: {
                  shape: "S1t"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipMediaApplicationCall: {
                shape: "S1w"
              }
            }
          }
        },
        CreateSipRule: {
          http: {
            requestUri: "/sip-rules",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "TriggerType",
              "TriggerValue"
            ],
            members: {
              Name: {},
              TriggerType: {},
              TriggerValue: {},
              Disabled: {
                type: "boolean"
              },
              TargetApplications: {
                shape: "S20"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipRule: {
                shape: "S24"
              }
            }
          }
        },
        CreateVoiceConnector: {
          http: {
            requestUri: "/voice-connectors",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "RequireEncryption"
            ],
            members: {
              Name: {},
              AwsRegion: {},
              RequireEncryption: {
                type: "boolean"
              },
              Tags: {
                shape: "S1l"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceConnector: {
                shape: "S2a"
              }
            }
          }
        },
        CreateVoiceConnectorGroup: {
          http: {
            requestUri: "/voice-connector-groups",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              VoiceConnectorItems: {
                shape: "S2d"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceConnectorGroup: {
                shape: "S2h"
              }
            }
          }
        },
        CreateVoiceProfile: {
          http: {
            requestUri: "/voice-profiles",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "SpeakerSearchTaskId"
            ],
            members: {
              SpeakerSearchTaskId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceProfile: {
                shape: "S2l"
              }
            }
          }
        },
        CreateVoiceProfileDomain: {
          http: {
            requestUri: "/voice-profile-domains",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "ServerSideEncryptionConfiguration"
            ],
            members: {
              Name: {},
              Description: {},
              ServerSideEncryptionConfiguration: {
                shape: "S2q"
              },
              ClientRequestToken: {},
              Tags: {
                shape: "S1l"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceProfileDomain: {
                shape: "S2t"
              }
            }
          }
        },
        DeletePhoneNumber: {
          http: {
            method: "DELETE",
            requestUri: "/phone-numbers/{phoneNumberId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "PhoneNumberId"
            ],
            members: {
              PhoneNumberId: {
                shape: "S9",
                location: "uri",
                locationName: "phoneNumberId"
              }
            }
          }
        },
        DeleteProxySession: {
          http: {
            method: "DELETE",
            requestUri: "/voice-connectors/{voiceConnectorId}/proxy-sessions/{proxySessionId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "ProxySessionId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              ProxySessionId: {
                location: "uri",
                locationName: "proxySessionId"
              }
            }
          }
        },
        DeleteSipMediaApplication: {
          http: {
            method: "DELETE",
            requestUri: "/sip-media-applications/{sipMediaApplicationId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "SipMediaApplicationId"
            ],
            members: {
              SipMediaApplicationId: {
                location: "uri",
                locationName: "sipMediaApplicationId"
              }
            }
          }
        },
        DeleteSipRule: {
          http: {
            method: "DELETE",
            requestUri: "/sip-rules/{sipRuleId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "SipRuleId"
            ],
            members: {
              SipRuleId: {
                location: "uri",
                locationName: "sipRuleId"
              }
            }
          }
        },
        DeleteVoiceConnector: {
          http: {
            method: "DELETE",
            requestUri: "/voice-connectors/{voiceConnectorId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          }
        },
        DeleteVoiceConnectorEmergencyCallingConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/voice-connectors/{voiceConnectorId}/emergency-calling-configuration",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          }
        },
        DeleteVoiceConnectorGroup: {
          http: {
            method: "DELETE",
            requestUri: "/voice-connector-groups/{voiceConnectorGroupId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorGroupId"
            ],
            members: {
              VoiceConnectorGroupId: {
                location: "uri",
                locationName: "voiceConnectorGroupId"
              }
            }
          }
        },
        DeleteVoiceConnectorOrigination: {
          http: {
            method: "DELETE",
            requestUri: "/voice-connectors/{voiceConnectorId}/origination",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          }
        },
        DeleteVoiceConnectorProxy: {
          http: {
            method: "DELETE",
            requestUri: "/voice-connectors/{voiceConnectorId}/programmable-numbers/proxy",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          }
        },
        DeleteVoiceConnectorStreamingConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/voice-connectors/{voiceConnectorId}/streaming-configuration",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          }
        },
        DeleteVoiceConnectorTermination: {
          http: {
            method: "DELETE",
            requestUri: "/voice-connectors/{voiceConnectorId}/termination",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          }
        },
        DeleteVoiceConnectorTerminationCredentials: {
          http: {
            requestUri: "/voice-connectors/{voiceConnectorId}/termination/credentials?operation=delete",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Usernames",
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              Usernames: {
                shape: "S36"
              }
            }
          }
        },
        DeleteVoiceProfile: {
          http: {
            method: "DELETE",
            requestUri: "/voice-profiles/{VoiceProfileId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "VoiceProfileId"
            ],
            members: {
              VoiceProfileId: {
                location: "uri",
                locationName: "VoiceProfileId"
              }
            }
          }
        },
        DeleteVoiceProfileDomain: {
          http: {
            method: "DELETE",
            requestUri: "/voice-profile-domains/{VoiceProfileDomainId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "VoiceProfileDomainId"
            ],
            members: {
              VoiceProfileDomainId: {
                location: "uri",
                locationName: "VoiceProfileDomainId"
              }
            }
          }
        },
        DisassociatePhoneNumbersFromVoiceConnector: {
          http: {
            requestUri: "/voice-connectors/{voiceConnectorId}?operation=disassociate-phone-numbers",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "E164PhoneNumbers"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              E164PhoneNumbers: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberErrors: {
                shape: "S7"
              }
            }
          }
        },
        DisassociatePhoneNumbersFromVoiceConnectorGroup: {
          http: {
            requestUri: "/voice-connector-groups/{voiceConnectorGroupId}?operation=disassociate-phone-numbers",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorGroupId",
              "E164PhoneNumbers"
            ],
            members: {
              VoiceConnectorGroupId: {
                location: "uri",
                locationName: "voiceConnectorGroupId"
              },
              E164PhoneNumbers: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberErrors: {
                shape: "S7"
              }
            }
          }
        },
        GetGlobalSettings: {
          http: {
            method: "GET",
            requestUri: "/settings",
            responseCode: 200
          },
          output: {
            type: "structure",
            members: {
              VoiceConnector: {
                shape: "S3e"
              }
            }
          }
        },
        GetPhoneNumber: {
          http: {
            method: "GET",
            requestUri: "/phone-numbers/{phoneNumberId}"
          },
          input: {
            type: "structure",
            required: [
              "PhoneNumberId"
            ],
            members: {
              PhoneNumberId: {
                shape: "S9",
                location: "uri",
                locationName: "phoneNumberId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumber: {
                shape: "S3h"
              }
            }
          }
        },
        GetPhoneNumberOrder: {
          http: {
            method: "GET",
            requestUri: "/phone-number-orders/{phoneNumberOrderId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "PhoneNumberOrderId"
            ],
            members: {
              PhoneNumberOrderId: {
                location: "uri",
                locationName: "phoneNumberOrderId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberOrder: {
                shape: "Sq"
              }
            }
          }
        },
        GetPhoneNumberSettings: {
          http: {
            method: "GET",
            requestUri: "/settings/phone-number",
            responseCode: 200
          },
          output: {
            type: "structure",
            members: {
              CallingName: {
                shape: "Sl"
              },
              CallingNameUpdatedTimestamp: {
                shape: "Sx"
              }
            }
          }
        },
        GetProxySession: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}/proxy-sessions/{proxySessionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "ProxySessionId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              ProxySessionId: {
                location: "uri",
                locationName: "proxySessionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProxySession: {
                shape: "S1b"
              }
            }
          }
        },
        GetSipMediaApplication: {
          http: {
            method: "GET",
            requestUri: "/sip-media-applications/{sipMediaApplicationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SipMediaApplicationId"
            ],
            members: {
              SipMediaApplicationId: {
                location: "uri",
                locationName: "sipMediaApplicationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipMediaApplication: {
                shape: "S1q"
              }
            }
          }
        },
        GetSipMediaApplicationAlexaSkillConfiguration: {
          http: {
            method: "GET",
            requestUri: "/sip-media-applications/{sipMediaApplicationId}/alexa-skill-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SipMediaApplicationId"
            ],
            members: {
              SipMediaApplicationId: {
                location: "uri",
                locationName: "sipMediaApplicationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipMediaApplicationAlexaSkillConfiguration: {
                shape: "S3z"
              }
            }
          }
        },
        GetSipMediaApplicationLoggingConfiguration: {
          http: {
            method: "GET",
            requestUri: "/sip-media-applications/{sipMediaApplicationId}/logging-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SipMediaApplicationId"
            ],
            members: {
              SipMediaApplicationId: {
                location: "uri",
                locationName: "sipMediaApplicationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipMediaApplicationLoggingConfiguration: {
                shape: "S45"
              }
            }
          }
        },
        GetSipRule: {
          http: {
            method: "GET",
            requestUri: "/sip-rules/{sipRuleId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SipRuleId"
            ],
            members: {
              SipRuleId: {
                location: "uri",
                locationName: "sipRuleId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipRule: {
                shape: "S24"
              }
            }
          }
        },
        GetSpeakerSearchTask: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{VoiceConnectorId}/speaker-search-tasks/{SpeakerSearchTaskId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "SpeakerSearchTaskId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "VoiceConnectorId"
              },
              SpeakerSearchTaskId: {
                location: "uri",
                locationName: "SpeakerSearchTaskId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SpeakerSearchTask: {
                shape: "S4a"
              }
            }
          }
        },
        GetVoiceConnector: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceConnector: {
                shape: "S2a"
              }
            }
          }
        },
        GetVoiceConnectorEmergencyCallingConfiguration: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}/emergency-calling-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EmergencyCallingConfiguration: {
                shape: "S4k"
              }
            }
          }
        },
        GetVoiceConnectorGroup: {
          http: {
            method: "GET",
            requestUri: "/voice-connector-groups/{voiceConnectorGroupId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorGroupId"
            ],
            members: {
              VoiceConnectorGroupId: {
                location: "uri",
                locationName: "voiceConnectorGroupId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceConnectorGroup: {
                shape: "S2h"
              }
            }
          }
        },
        GetVoiceConnectorLoggingConfiguration: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}/logging-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LoggingConfiguration: {
                shape: "S4r"
              }
            }
          }
        },
        GetVoiceConnectorOrigination: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}/origination",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Origination: {
                shape: "S4u"
              }
            }
          }
        },
        GetVoiceConnectorProxy: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}/programmable-numbers/proxy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Proxy: {
                shape: "S53"
              }
            }
          }
        },
        GetVoiceConnectorStreamingConfiguration: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}/streaming-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingConfiguration: {
                shape: "S58"
              }
            }
          }
        },
        GetVoiceConnectorTermination: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}/termination",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Termination: {
                shape: "S5g"
              }
            }
          }
        },
        GetVoiceConnectorTerminationHealth: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}/termination/health",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TerminationHealth: {
                type: "structure",
                members: {
                  Timestamp: {
                    shape: "Sx"
                  },
                  Source: {}
                }
              }
            }
          }
        },
        GetVoiceProfile: {
          http: {
            method: "GET",
            requestUri: "/voice-profiles/{VoiceProfileId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceProfileId"
            ],
            members: {
              VoiceProfileId: {
                location: "uri",
                locationName: "VoiceProfileId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceProfile: {
                shape: "S2l"
              }
            }
          }
        },
        GetVoiceProfileDomain: {
          http: {
            method: "GET",
            requestUri: "/voice-profile-domains/{VoiceProfileDomainId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceProfileDomainId"
            ],
            members: {
              VoiceProfileDomainId: {
                location: "uri",
                locationName: "VoiceProfileDomainId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceProfileDomain: {
                shape: "S2t"
              }
            }
          }
        },
        GetVoiceToneAnalysisTask: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{VoiceConnectorId}/voice-tone-analysis-tasks/{VoiceToneAnalysisTaskId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "VoiceToneAnalysisTaskId",
              "IsCaller"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "VoiceConnectorId"
              },
              VoiceToneAnalysisTaskId: {
                location: "uri",
                locationName: "VoiceToneAnalysisTaskId"
              },
              IsCaller: {
                location: "querystring",
                locationName: "isCaller",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceToneAnalysisTask: {
                shape: "S5t"
              }
            }
          }
        },
        ListAvailableVoiceConnectorRegions: {
          http: {
            method: "GET",
            requestUri: "/voice-connector-regions",
            responseCode: 200
          },
          output: {
            type: "structure",
            members: {
              VoiceConnectorRegions: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ListPhoneNumberOrders: {
          http: {
            method: "GET",
            requestUri: "/phone-number-orders",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberOrders: {
                type: "list",
                member: {
                  shape: "Sq"
                }
              },
              NextToken: {}
            }
          }
        },
        ListPhoneNumbers: {
          http: {
            method: "GET",
            requestUri: "/phone-numbers"
          },
          input: {
            type: "structure",
            members: {
              Status: {
                location: "querystring",
                locationName: "status"
              },
              ProductType: {
                location: "querystring",
                locationName: "product-type"
              },
              FilterName: {
                location: "querystring",
                locationName: "filter-name"
              },
              FilterValue: {
                location: "querystring",
                locationName: "filter-value"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumbers: {
                type: "list",
                member: {
                  shape: "S3h"
                }
              },
              NextToken: {}
            }
          }
        },
        ListProxySessions: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}/proxy-sessions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              Status: {
                location: "querystring",
                locationName: "status"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProxySessions: {
                type: "list",
                member: {
                  shape: "S1b"
                }
              },
              NextToken: {}
            }
          }
        },
        ListSipMediaApplications: {
          http: {
            method: "GET",
            requestUri: "/sip-media-applications",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipMediaApplications: {
                type: "list",
                member: {
                  shape: "S1q"
                }
              },
              NextToken: {}
            }
          }
        },
        ListSipRules: {
          http: {
            method: "GET",
            requestUri: "/sip-rules",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              SipMediaApplicationId: {
                location: "querystring",
                locationName: "sip-media-application"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipRules: {
                type: "list",
                member: {
                  shape: "S24"
                }
              },
              NextToken: {}
            }
          }
        },
        ListSupportedPhoneNumberCountries: {
          http: {
            method: "GET",
            requestUri: "/phone-number-countries",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ProductType"
            ],
            members: {
              ProductType: {
                location: "querystring",
                locationName: "product-type"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberCountries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CountryCode: {},
                    SupportedPhoneNumberTypes: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags"
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {
                shape: "S2m",
                location: "querystring",
                locationName: "arn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S1l"
              }
            }
          }
        },
        ListVoiceConnectorGroups: {
          http: {
            method: "GET",
            requestUri: "/voice-connector-groups",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceConnectorGroups: {
                type: "list",
                member: {
                  shape: "S2h"
                }
              },
              NextToken: {}
            }
          }
        },
        ListVoiceConnectorTerminationCredentials: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}/termination/credentials",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Usernames: {
                shape: "S36"
              }
            }
          }
        },
        ListVoiceConnectors: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceConnectors: {
                type: "list",
                member: {
                  shape: "S2a"
                }
              },
              NextToken: {}
            }
          }
        },
        ListVoiceProfileDomains: {
          http: {
            method: "GET",
            requestUri: "/voice-profile-domains",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceProfileDomains: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    VoiceProfileDomainId: {},
                    VoiceProfileDomainArn: {
                      shape: "S2m"
                    },
                    Name: {},
                    Description: {},
                    CreatedTimestamp: {
                      shape: "Sx"
                    },
                    UpdatedTimestamp: {
                      shape: "Sx"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListVoiceProfiles: {
          http: {
            method: "GET",
            requestUri: "/voice-profiles",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceProfileDomainId"
            ],
            members: {
              VoiceProfileDomainId: {
                location: "querystring",
                locationName: "voice-profile-domain-id"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceProfiles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    VoiceProfileId: {},
                    VoiceProfileArn: {
                      shape: "S2m"
                    },
                    VoiceProfileDomainId: {},
                    CreatedTimestamp: {
                      shape: "Sx"
                    },
                    UpdatedTimestamp: {
                      shape: "Sx"
                    },
                    ExpirationTimestamp: {
                      shape: "Sx"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        PutSipMediaApplicationAlexaSkillConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/sip-media-applications/{sipMediaApplicationId}/alexa-skill-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SipMediaApplicationId"
            ],
            members: {
              SipMediaApplicationId: {
                location: "uri",
                locationName: "sipMediaApplicationId"
              },
              SipMediaApplicationAlexaSkillConfiguration: {
                shape: "S3z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipMediaApplicationAlexaSkillConfiguration: {
                shape: "S3z"
              }
            }
          }
        },
        PutSipMediaApplicationLoggingConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/sip-media-applications/{sipMediaApplicationId}/logging-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SipMediaApplicationId"
            ],
            members: {
              SipMediaApplicationId: {
                location: "uri",
                locationName: "sipMediaApplicationId"
              },
              SipMediaApplicationLoggingConfiguration: {
                shape: "S45"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipMediaApplicationLoggingConfiguration: {
                shape: "S45"
              }
            }
          }
        },
        PutVoiceConnectorEmergencyCallingConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/voice-connectors/{voiceConnectorId}/emergency-calling-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "EmergencyCallingConfiguration"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              EmergencyCallingConfiguration: {
                shape: "S4k"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EmergencyCallingConfiguration: {
                shape: "S4k"
              }
            }
          }
        },
        PutVoiceConnectorLoggingConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/voice-connectors/{voiceConnectorId}/logging-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "LoggingConfiguration"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              LoggingConfiguration: {
                shape: "S4r"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LoggingConfiguration: {
                shape: "S4r"
              }
            }
          }
        },
        PutVoiceConnectorOrigination: {
          http: {
            method: "PUT",
            requestUri: "/voice-connectors/{voiceConnectorId}/origination",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "Origination"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              Origination: {
                shape: "S4u"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Origination: {
                shape: "S4u"
              }
            }
          }
        },
        PutVoiceConnectorProxy: {
          http: {
            method: "PUT",
            requestUri: "/voice-connectors/{voiceConnectorId}/programmable-numbers/proxy"
          },
          input: {
            type: "structure",
            required: [
              "DefaultSessionExpiryMinutes",
              "PhoneNumberPoolCountries",
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              DefaultSessionExpiryMinutes: {
                type: "integer"
              },
              PhoneNumberPoolCountries: {
                type: "list",
                member: {}
              },
              FallBackPhoneNumber: {
                shape: "S4"
              },
              Disabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Proxy: {
                shape: "S53"
              }
            }
          }
        },
        PutVoiceConnectorStreamingConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/voice-connectors/{voiceConnectorId}/streaming-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "StreamingConfiguration"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              StreamingConfiguration: {
                shape: "S58"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingConfiguration: {
                shape: "S58"
              }
            }
          }
        },
        PutVoiceConnectorTermination: {
          http: {
            method: "PUT",
            requestUri: "/voice-connectors/{voiceConnectorId}/termination",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "Termination"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              Termination: {
                shape: "S5g"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Termination: {
                shape: "S5g"
              }
            }
          }
        },
        PutVoiceConnectorTerminationCredentials: {
          http: {
            requestUri: "/voice-connectors/{voiceConnectorId}/termination/credentials?operation=put",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              Credentials: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Username: {
                      shape: "S1t"
                    },
                    Password: {
                      shape: "S1t"
                    }
                  }
                }
              }
            }
          }
        },
        RestorePhoneNumber: {
          http: {
            requestUri: "/phone-numbers/{phoneNumberId}?operation=restore",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "PhoneNumberId"
            ],
            members: {
              PhoneNumberId: {
                shape: "S9",
                location: "uri",
                locationName: "phoneNumberId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumber: {
                shape: "S3h"
              }
            }
          }
        },
        SearchAvailablePhoneNumbers: {
          http: {
            method: "GET",
            requestUri: "/search?type=phone-numbers"
          },
          input: {
            type: "structure",
            members: {
              AreaCode: {
                location: "querystring",
                locationName: "area-code"
              },
              City: {
                location: "querystring",
                locationName: "city"
              },
              Country: {
                location: "querystring",
                locationName: "country"
              },
              State: {
                location: "querystring",
                locationName: "state"
              },
              TollFreePrefix: {
                location: "querystring",
                locationName: "toll-free-prefix"
              },
              PhoneNumberType: {
                location: "querystring",
                locationName: "phone-number-type"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              E164PhoneNumbers: {
                shape: "S3"
              },
              NextToken: {}
            }
          }
        },
        StartSpeakerSearchTask: {
          http: {
            requestUri: "/voice-connectors/{VoiceConnectorId}/speaker-search-tasks",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "TransactionId",
              "VoiceProfileDomainId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "VoiceConnectorId"
              },
              TransactionId: {},
              VoiceProfileDomainId: {},
              ClientRequestToken: {},
              CallLeg: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SpeakerSearchTask: {
                shape: "S4a"
              }
            }
          }
        },
        StartVoiceToneAnalysisTask: {
          http: {
            requestUri: "/voice-connectors/{VoiceConnectorId}/voice-tone-analysis-tasks",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "TransactionId",
              "LanguageCode"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "VoiceConnectorId"
              },
              TransactionId: {},
              LanguageCode: {},
              ClientRequestToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceToneAnalysisTask: {
                shape: "S5t"
              }
            }
          }
        },
        StopSpeakerSearchTask: {
          http: {
            requestUri: "/voice-connectors/{VoiceConnectorId}/speaker-search-tasks/{SpeakerSearchTaskId}?operation=stop",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "SpeakerSearchTaskId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "VoiceConnectorId"
              },
              SpeakerSearchTaskId: {
                location: "uri",
                locationName: "SpeakerSearchTaskId"
              }
            }
          }
        },
        StopVoiceToneAnalysisTask: {
          http: {
            requestUri: "/voice-connectors/{VoiceConnectorId}/voice-tone-analysis-tasks/{VoiceToneAnalysisTaskId}?operation=stop",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "VoiceToneAnalysisTaskId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "VoiceConnectorId"
              },
              VoiceToneAnalysisTaskId: {
                location: "uri",
                locationName: "VoiceToneAnalysisTaskId"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags?operation=tag-resource",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {
                shape: "S2m"
              },
              Tags: {
                shape: "S1l"
              }
            }
          }
        },
        UntagResource: {
          http: {
            requestUri: "/tags?operation=untag-resource",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {
                shape: "S2m"
              },
              TagKeys: {
                type: "list",
                member: {
                  shape: "S1n"
                }
              }
            }
          }
        },
        UpdateGlobalSettings: {
          http: {
            method: "PUT",
            requestUri: "/settings",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              VoiceConnector: {
                shape: "S3e"
              }
            }
          }
        },
        UpdatePhoneNumber: {
          http: {
            requestUri: "/phone-numbers/{phoneNumberId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "PhoneNumberId"
            ],
            members: {
              PhoneNumberId: {
                shape: "S9",
                location: "uri",
                locationName: "phoneNumberId"
              },
              ProductType: {},
              CallingName: {
                shape: "Sl"
              },
              Name: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumber: {
                shape: "S3h"
              }
            }
          }
        },
        UpdatePhoneNumberSettings: {
          http: {
            method: "PUT",
            requestUri: "/settings/phone-number",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "CallingName"
            ],
            members: {
              CallingName: {
                shape: "Sl"
              }
            }
          }
        },
        UpdateProxySession: {
          http: {
            requestUri: "/voice-connectors/{voiceConnectorId}/proxy-sessions/{proxySessionId}",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Capabilities",
              "VoiceConnectorId",
              "ProxySessionId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              ProxySessionId: {
                location: "uri",
                locationName: "proxySessionId"
              },
              Capabilities: {
                shape: "S13"
              },
              ExpiryMinutes: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProxySession: {
                shape: "S1b"
              }
            }
          }
        },
        UpdateSipMediaApplication: {
          http: {
            method: "PUT",
            requestUri: "/sip-media-applications/{sipMediaApplicationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SipMediaApplicationId"
            ],
            members: {
              SipMediaApplicationId: {
                location: "uri",
                locationName: "sipMediaApplicationId"
              },
              Name: {},
              Endpoints: {
                shape: "S1i"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipMediaApplication: {
                shape: "S1q"
              }
            }
          }
        },
        UpdateSipMediaApplicationCall: {
          http: {
            requestUri: "/sip-media-applications/{sipMediaApplicationId}/calls/{transactionId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "SipMediaApplicationId",
              "TransactionId",
              "Arguments"
            ],
            members: {
              SipMediaApplicationId: {
                location: "uri",
                locationName: "sipMediaApplicationId"
              },
              TransactionId: {
                location: "uri",
                locationName: "transactionId"
              },
              Arguments: {
                type: "map",
                key: {
                  shape: "S1t"
                },
                value: {
                  shape: "S1t"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipMediaApplicationCall: {
                shape: "S1w"
              }
            }
          }
        },
        UpdateSipRule: {
          http: {
            method: "PUT",
            requestUri: "/sip-rules/{sipRuleId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "SipRuleId",
              "Name"
            ],
            members: {
              SipRuleId: {
                location: "uri",
                locationName: "sipRuleId"
              },
              Name: {},
              Disabled: {
                type: "boolean"
              },
              TargetApplications: {
                shape: "S20"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipRule: {
                shape: "S24"
              }
            }
          }
        },
        UpdateVoiceConnector: {
          http: {
            method: "PUT",
            requestUri: "/voice-connectors/{voiceConnectorId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "Name",
              "RequireEncryption"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              Name: {},
              RequireEncryption: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceConnector: {
                shape: "S2a"
              }
            }
          }
        },
        UpdateVoiceConnectorGroup: {
          http: {
            method: "PUT",
            requestUri: "/voice-connector-groups/{voiceConnectorGroupId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorGroupId",
              "Name",
              "VoiceConnectorItems"
            ],
            members: {
              VoiceConnectorGroupId: {
                location: "uri",
                locationName: "voiceConnectorGroupId"
              },
              Name: {},
              VoiceConnectorItems: {
                shape: "S2d"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceConnectorGroup: {
                shape: "S2h"
              }
            }
          }
        },
        UpdateVoiceProfile: {
          http: {
            method: "PUT",
            requestUri: "/voice-profiles/{VoiceProfileId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceProfileId",
              "SpeakerSearchTaskId"
            ],
            members: {
              VoiceProfileId: {
                location: "uri",
                locationName: "VoiceProfileId"
              },
              SpeakerSearchTaskId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceProfile: {
                shape: "S2l"
              }
            }
          }
        },
        UpdateVoiceProfileDomain: {
          http: {
            method: "PUT",
            requestUri: "/voice-profile-domains/{VoiceProfileDomainId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceProfileDomainId"
            ],
            members: {
              VoiceProfileDomainId: {
                location: "uri",
                locationName: "VoiceProfileDomainId"
              },
              Name: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceProfileDomain: {
                shape: "S2t"
              }
            }
          }
        },
        ValidateE911Address: {
          http: {
            requestUri: "/emergency-calling/address",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "StreetNumber",
              "StreetInfo",
              "City",
              "State",
              "Country",
              "PostalCode"
            ],
            members: {
              AwsAccountId: {},
              StreetNumber: {
                shape: "S9"
              },
              StreetInfo: {
                shape: "S9"
              },
              City: {
                shape: "S9"
              },
              State: {
                shape: "S9"
              },
              Country: {
                shape: "S9"
              },
              PostalCode: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ValidationResult: {
                type: "integer"
              },
              AddressExternalId: {},
              Address: {
                type: "structure",
                members: {
                  streetName: {
                    shape: "S9"
                  },
                  streetSuffix: {
                    shape: "S9"
                  },
                  postDirectional: {
                    shape: "S9"
                  },
                  preDirectional: {
                    shape: "S9"
                  },
                  streetNumber: {
                    shape: "S9"
                  },
                  city: {
                    shape: "S9"
                  },
                  state: {
                    shape: "S9"
                  },
                  postalCode: {
                    shape: "S9"
                  },
                  postalCodePlus4: {
                    shape: "S9"
                  },
                  country: {
                    shape: "S9"
                  }
                }
              },
              CandidateAddressList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    streetInfo: {
                      shape: "S9"
                    },
                    streetNumber: {
                      shape: "S9"
                    },
                    city: {
                      shape: "S9"
                    },
                    state: {
                      shape: "S9"
                    },
                    postalCode: {
                      shape: "S9"
                    },
                    postalCodePlus4: {
                      shape: "S9"
                    },
                    country: {
                      shape: "S9"
                    }
                  }
                }
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {
            shape: "S4"
          }
        },
        S4: {
          type: "string",
          sensitive: true
        },
        S7: {
          type: "list",
          member: {
            type: "structure",
            members: {
              PhoneNumberId: {
                shape: "S9"
              },
              ErrorCode: {},
              ErrorMessage: {}
            }
          }
        },
        S9: {
          type: "string",
          sensitive: true
        },
        Sl: {
          type: "string",
          sensitive: true
        },
        Sm: {
          type: "string",
          sensitive: true
        },
        Sq: {
          type: "structure",
          members: {
            PhoneNumberOrderId: {},
            ProductType: {},
            Status: {},
            OrderType: {},
            OrderedPhoneNumbers: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  E164PhoneNumber: {
                    shape: "S4"
                  },
                  Status: {}
                }
              }
            },
            CreatedTimestamp: {
              shape: "Sx"
            },
            UpdatedTimestamp: {
              shape: "Sx"
            }
          }
        },
        Sx: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S13: {
          type: "list",
          member: {}
        },
        S17: {
          type: "structure",
          required: [
            "Country",
            "AreaCode"
          ],
          members: {
            Country: {},
            AreaCode: {}
          }
        },
        S1b: {
          type: "structure",
          members: {
            VoiceConnectorId: {},
            ProxySessionId: {},
            Name: {},
            Status: {},
            ExpiryMinutes: {
              type: "integer"
            },
            Capabilities: {
              shape: "S13"
            },
            CreatedTimestamp: {
              shape: "Sx"
            },
            UpdatedTimestamp: {
              shape: "Sx"
            },
            EndedTimestamp: {
              shape: "Sx"
            },
            Participants: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  PhoneNumber: {
                    shape: "S4"
                  },
                  ProxyPhoneNumber: {
                    shape: "S4"
                  }
                }
              }
            },
            NumberSelectionBehavior: {},
            GeoMatchLevel: {},
            GeoMatchParams: {
              shape: "S17"
            }
          }
        },
        S1i: {
          type: "list",
          member: {
            type: "structure",
            members: {
              LambdaArn: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        S1l: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {
                shape: "S1n"
              },
              Value: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        S1n: {
          type: "string",
          sensitive: true
        },
        S1q: {
          type: "structure",
          members: {
            SipMediaApplicationId: {},
            AwsRegion: {},
            Name: {},
            Endpoints: {
              shape: "S1i"
            },
            CreatedTimestamp: {
              shape: "Sx"
            },
            UpdatedTimestamp: {
              shape: "Sx"
            },
            SipMediaApplicationArn: {}
          }
        },
        S1t: {
          type: "string",
          sensitive: true
        },
        S1w: {
          type: "structure",
          members: {
            TransactionId: {}
          }
        },
        S20: {
          type: "list",
          member: {
            type: "structure",
            members: {
              SipMediaApplicationId: {},
              Priority: {
                type: "integer"
              },
              AwsRegion: {}
            }
          }
        },
        S24: {
          type: "structure",
          members: {
            SipRuleId: {},
            Name: {},
            Disabled: {
              type: "boolean"
            },
            TriggerType: {},
            TriggerValue: {},
            TargetApplications: {
              shape: "S20"
            },
            CreatedTimestamp: {
              shape: "Sx"
            },
            UpdatedTimestamp: {
              shape: "Sx"
            }
          }
        },
        S2a: {
          type: "structure",
          members: {
            VoiceConnectorId: {},
            AwsRegion: {},
            Name: {},
            OutboundHostName: {},
            RequireEncryption: {
              type: "boolean"
            },
            CreatedTimestamp: {
              shape: "Sx"
            },
            UpdatedTimestamp: {
              shape: "Sx"
            },
            VoiceConnectorArn: {}
          }
        },
        S2d: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "Priority"
            ],
            members: {
              VoiceConnectorId: {},
              Priority: {
                type: "integer"
              }
            }
          }
        },
        S2h: {
          type: "structure",
          members: {
            VoiceConnectorGroupId: {},
            Name: {},
            VoiceConnectorItems: {
              shape: "S2d"
            },
            CreatedTimestamp: {
              shape: "Sx"
            },
            UpdatedTimestamp: {
              shape: "Sx"
            },
            VoiceConnectorGroupArn: {}
          }
        },
        S2l: {
          type: "structure",
          members: {
            VoiceProfileId: {},
            VoiceProfileArn: {
              shape: "S2m"
            },
            VoiceProfileDomainId: {},
            CreatedTimestamp: {
              shape: "Sx"
            },
            UpdatedTimestamp: {
              shape: "Sx"
            },
            ExpirationTimestamp: {
              shape: "Sx"
            }
          }
        },
        S2m: {
          type: "string",
          sensitive: true
        },
        S2q: {
          type: "structure",
          required: [
            "KmsKeyArn"
          ],
          members: {
            KmsKeyArn: {
              shape: "S2m"
            }
          }
        },
        S2t: {
          type: "structure",
          members: {
            VoiceProfileDomainId: {},
            VoiceProfileDomainArn: {
              shape: "S2m"
            },
            Name: {},
            Description: {},
            ServerSideEncryptionConfiguration: {
              shape: "S2q"
            },
            CreatedTimestamp: {
              shape: "Sx"
            },
            UpdatedTimestamp: {
              shape: "Sx"
            }
          }
        },
        S36: {
          type: "list",
          member: {
            shape: "S1t"
          }
        },
        S3e: {
          type: "structure",
          members: {
            CdrBucket: {}
          }
        },
        S3h: {
          type: "structure",
          members: {
            PhoneNumberId: {
              shape: "S9"
            },
            E164PhoneNumber: {
              shape: "S4"
            },
            Country: {},
            Type: {},
            ProductType: {},
            Status: {},
            Capabilities: {
              type: "structure",
              members: {
                InboundCall: {
                  type: "boolean"
                },
                OutboundCall: {
                  type: "boolean"
                },
                InboundSMS: {
                  type: "boolean"
                },
                OutboundSMS: {
                  type: "boolean"
                },
                InboundMMS: {
                  type: "boolean"
                },
                OutboundMMS: {
                  type: "boolean"
                }
              }
            },
            Associations: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Value: {},
                  Name: {},
                  AssociatedTimestamp: {
                    shape: "Sx"
                  }
                }
              }
            },
            CallingName: {
              shape: "Sl"
            },
            CallingNameStatus: {},
            CreatedTimestamp: {
              shape: "Sx"
            },
            UpdatedTimestamp: {
              shape: "Sx"
            },
            DeletionTimestamp: {
              shape: "Sx"
            },
            OrderId: {},
            Name: {
              shape: "Sm"
            }
          }
        },
        S3z: {
          type: "structure",
          required: [
            "AlexaSkillStatus",
            "AlexaSkillIds"
          ],
          members: {
            AlexaSkillStatus: {},
            AlexaSkillIds: {
              type: "list",
              member: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        S45: {
          type: "structure",
          members: {
            EnableSipMediaApplicationMessageLogs: {
              type: "boolean"
            }
          }
        },
        S4a: {
          type: "structure",
          members: {
            SpeakerSearchTaskId: {},
            SpeakerSearchTaskStatus: {},
            CallDetails: {
              shape: "S4b"
            },
            SpeakerSearchDetails: {
              type: "structure",
              members: {
                Results: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      ConfidenceScore: {
                        type: "float"
                      },
                      VoiceProfileId: {}
                    }
                  }
                },
                VoiceprintGenerationStatus: {}
              }
            },
            CreatedTimestamp: {
              shape: "Sx"
            },
            UpdatedTimestamp: {
              shape: "Sx"
            },
            StartedTimestamp: {
              shape: "Sx"
            },
            StatusMessage: {}
          }
        },
        S4b: {
          type: "structure",
          members: {
            VoiceConnectorId: {},
            TransactionId: {},
            IsCaller: {
              type: "boolean"
            }
          }
        },
        S4k: {
          type: "structure",
          members: {
            DNIS: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "EmergencyPhoneNumber",
                  "CallingCountry"
                ],
                members: {
                  EmergencyPhoneNumber: {
                    shape: "S4"
                  },
                  TestPhoneNumber: {
                    shape: "S4"
                  },
                  CallingCountry: {}
                }
              }
            }
          }
        },
        S4r: {
          type: "structure",
          members: {
            EnableSIPLogs: {
              type: "boolean"
            },
            EnableMediaMetricLogs: {
              type: "boolean"
            }
          }
        },
        S4u: {
          type: "structure",
          members: {
            Routes: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Host: {},
                  Port: {
                    type: "integer"
                  },
                  Protocol: {},
                  Priority: {
                    type: "integer"
                  },
                  Weight: {
                    type: "integer"
                  }
                }
              }
            },
            Disabled: {
              type: "boolean"
            }
          }
        },
        S53: {
          type: "structure",
          members: {
            DefaultSessionExpiryMinutes: {
              type: "integer"
            },
            Disabled: {
              type: "boolean"
            },
            FallBackPhoneNumber: {
              shape: "S4"
            },
            PhoneNumberCountries: {
              shape: "S55"
            }
          }
        },
        S55: {
          type: "list",
          member: {}
        },
        S58: {
          type: "structure",
          required: [
            "DataRetentionInHours",
            "Disabled"
          ],
          members: {
            DataRetentionInHours: {
              type: "integer"
            },
            Disabled: {
              type: "boolean"
            },
            StreamingNotificationTargets: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  NotificationTarget: {}
                }
              }
            },
            MediaInsightsConfiguration: {
              type: "structure",
              members: {
                Disabled: {
                  type: "boolean"
                },
                ConfigurationArn: {
                  shape: "S2m"
                }
              }
            }
          }
        },
        S5g: {
          type: "structure",
          members: {
            CpsLimit: {
              type: "integer"
            },
            DefaultPhoneNumber: {
              shape: "S4"
            },
            CallingRegions: {
              type: "list",
              member: {}
            },
            CidrAllowedList: {
              shape: "S55"
            },
            Disabled: {
              type: "boolean"
            }
          }
        },
        S5t: {
          type: "structure",
          members: {
            VoiceToneAnalysisTaskId: {},
            VoiceToneAnalysisTaskStatus: {},
            CallDetails: {
              shape: "S4b"
            },
            CreatedTimestamp: {
              shape: "Sx"
            },
            UpdatedTimestamp: {
              shape: "Sx"
            },
            StartedTimestamp: {
              shape: "Sx"
            },
            StatusMessage: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/chime-sdk-voice-2022-08-03.paginators.json
var require_chime_sdk_voice_2022_08_03_paginators = __commonJS({
  "node_modules/aws-sdk/apis/chime-sdk-voice-2022-08-03.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListPhoneNumberOrders: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListPhoneNumbers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListProxySessions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListSipMediaApplications: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "SipMediaApplications"
        },
        ListSipRules: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "SipRules"
        },
        ListVoiceConnectorGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListVoiceConnectors: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListVoiceProfileDomains: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListVoiceProfiles: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        SearchAvailablePhoneNumbers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/chimesdkvoice.js
var require_chimesdkvoice = __commonJS({
  "node_modules/aws-sdk/clients/chimesdkvoice.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["chimesdkvoice"] = {};
    AWS2.ChimeSDKVoice = Service.defineService("chimesdkvoice", ["2022-08-03"]);
    Object.defineProperty(apiLoader.services["chimesdkvoice"], "2022-08-03", {
      get: function get() {
        var model = require_chime_sdk_voice_2022_08_03_min();
        model.paginators = require_chime_sdk_voice_2022_08_03_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ChimeSDKVoice;
  }
});

// node_modules/aws-sdk/apis/iot-roborunner-2018-05-10.min.json
var require_iot_roborunner_2018_05_10_min = __commonJS({
  "node_modules/aws-sdk/apis/iot-roborunner-2018-05-10.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-05-10",
        endpointPrefix: "iotroborunner",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS IoT RoboRunner",
        serviceId: "IoT RoboRunner",
        signatureVersion: "v4",
        signingName: "iotroborunner",
        uid: "iot-roborunner-2018-05-10"
      },
      operations: {
        CreateDestination: {
          http: {
            requestUri: "/createDestination",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "site"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              name: {},
              site: {},
              state: {},
              additionalFixedProperties: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "id",
              "createdAt",
              "updatedAt",
              "state"
            ],
            members: {
              arn: {},
              id: {},
              createdAt: {
                type: "timestamp"
              },
              updatedAt: {
                type: "timestamp"
              },
              state: {}
            }
          },
          idempotent: true
        },
        CreateSite: {
          http: {
            requestUri: "/createSite",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "countryCode"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              name: {},
              countryCode: {},
              description: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "id",
              "createdAt",
              "updatedAt"
            ],
            members: {
              arn: {},
              id: {},
              createdAt: {
                type: "timestamp"
              },
              updatedAt: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        CreateWorker: {
          http: {
            requestUri: "/createWorker",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "fleet"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              name: {},
              fleet: {},
              additionalTransientProperties: {},
              additionalFixedProperties: {},
              vendorProperties: {
                shape: "Sm"
              },
              position: {
                shape: "Sr"
              },
              orientation: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "id",
              "createdAt",
              "updatedAt",
              "site"
            ],
            members: {
              arn: {},
              id: {},
              createdAt: {
                type: "timestamp"
              },
              updatedAt: {
                type: "timestamp"
              },
              site: {}
            }
          },
          idempotent: true
        },
        CreateWorkerFleet: {
          http: {
            requestUri: "/createWorkerFleet",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "site"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              name: {},
              site: {},
              additionalFixedProperties: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "id",
              "createdAt",
              "updatedAt"
            ],
            members: {
              arn: {},
              id: {},
              createdAt: {
                type: "timestamp"
              },
              updatedAt: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        DeleteDestination: {
          http: {
            requestUri: "/deleteDestination",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSite: {
          http: {
            requestUri: "/deleteSite",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteWorker: {
          http: {
            requestUri: "/deleteWorker",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteWorkerFleet: {
          http: {
            requestUri: "/deleteWorkerFleet",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetDestination: {
          http: {
            method: "GET",
            requestUri: "/getDestination",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "querystring",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "id",
              "name",
              "site",
              "createdAt",
              "updatedAt",
              "state"
            ],
            members: {
              arn: {},
              id: {},
              name: {},
              site: {},
              createdAt: {
                type: "timestamp"
              },
              updatedAt: {
                type: "timestamp"
              },
              state: {},
              additionalFixedProperties: {}
            }
          }
        },
        GetSite: {
          http: {
            method: "GET",
            requestUri: "/getSite",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "querystring",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "id",
              "name",
              "countryCode",
              "createdAt",
              "updatedAt"
            ],
            members: {
              arn: {},
              id: {},
              name: {},
              countryCode: {},
              description: {},
              createdAt: {
                type: "timestamp"
              },
              updatedAt: {
                type: "timestamp"
              }
            }
          }
        },
        GetWorker: {
          http: {
            method: "GET",
            requestUri: "/getWorker",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "querystring",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "id",
              "fleet",
              "site",
              "createdAt",
              "updatedAt",
              "name"
            ],
            members: {
              arn: {},
              id: {},
              fleet: {},
              site: {},
              createdAt: {
                type: "timestamp"
              },
              updatedAt: {
                type: "timestamp"
              },
              name: {},
              additionalTransientProperties: {},
              additionalFixedProperties: {},
              vendorProperties: {
                shape: "Sm"
              },
              position: {
                shape: "Sr"
              },
              orientation: {
                shape: "Su"
              }
            }
          }
        },
        GetWorkerFleet: {
          http: {
            method: "GET",
            requestUri: "/getWorkerFleet",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "querystring",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "arn",
              "name",
              "site",
              "createdAt",
              "updatedAt"
            ],
            members: {
              id: {},
              arn: {},
              name: {},
              site: {},
              createdAt: {
                type: "timestamp"
              },
              updatedAt: {
                type: "timestamp"
              },
              additionalFixedProperties: {}
            }
          }
        },
        ListDestinations: {
          http: {
            method: "GET",
            requestUri: "/listDestinations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "site"
            ],
            members: {
              site: {
                location: "querystring",
                locationName: "site"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              state: {
                location: "querystring",
                locationName: "state"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              destinations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "id",
                    "name",
                    "site",
                    "createdAt",
                    "updatedAt",
                    "state"
                  ],
                  members: {
                    arn: {},
                    id: {},
                    name: {},
                    site: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    updatedAt: {
                      type: "timestamp"
                    },
                    state: {},
                    additionalFixedProperties: {}
                  }
                }
              }
            }
          }
        },
        ListSites: {
          http: {
            method: "GET",
            requestUri: "/listSites",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              sites: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "name",
                    "countryCode",
                    "createdAt"
                  ],
                  members: {
                    arn: {},
                    name: {},
                    countryCode: {},
                    createdAt: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListWorkerFleets: {
          http: {
            method: "GET",
            requestUri: "/listWorkerFleets",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "site"
            ],
            members: {
              site: {
                location: "querystring",
                locationName: "site"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              workerFleets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "id",
                    "name",
                    "site",
                    "createdAt",
                    "updatedAt"
                  ],
                  members: {
                    arn: {},
                    id: {},
                    name: {},
                    site: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    updatedAt: {
                      type: "timestamp"
                    },
                    additionalFixedProperties: {}
                  }
                }
              }
            }
          }
        },
        ListWorkers: {
          http: {
            method: "GET",
            requestUri: "/listWorkers",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "site"
            ],
            members: {
              site: {
                location: "querystring",
                locationName: "site"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              fleet: {
                location: "querystring",
                locationName: "fleet"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              workers: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "id",
                    "fleet",
                    "createdAt",
                    "updatedAt",
                    "name",
                    "site"
                  ],
                  members: {
                    arn: {},
                    id: {},
                    fleet: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    updatedAt: {
                      type: "timestamp"
                    },
                    name: {},
                    site: {},
                    additionalTransientProperties: {},
                    additionalFixedProperties: {},
                    vendorProperties: {
                      shape: "Sm"
                    },
                    position: {
                      shape: "Sr"
                    },
                    orientation: {
                      shape: "Su"
                    }
                  }
                }
              }
            }
          }
        },
        UpdateDestination: {
          http: {
            requestUri: "/updateDestination",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {},
              name: {},
              state: {},
              additionalFixedProperties: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "id",
              "name",
              "updatedAt",
              "state"
            ],
            members: {
              arn: {},
              id: {},
              name: {},
              updatedAt: {
                type: "timestamp"
              },
              state: {},
              additionalFixedProperties: {}
            }
          }
        },
        UpdateSite: {
          http: {
            requestUri: "/updateSite",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {},
              name: {},
              countryCode: {},
              description: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "id",
              "name",
              "updatedAt"
            ],
            members: {
              arn: {},
              id: {},
              name: {},
              countryCode: {},
              description: {},
              updatedAt: {
                type: "timestamp"
              }
            }
          }
        },
        UpdateWorker: {
          http: {
            requestUri: "/updateWorker",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {},
              name: {},
              additionalTransientProperties: {},
              additionalFixedProperties: {},
              vendorProperties: {
                shape: "Sm"
              },
              position: {
                shape: "Sr"
              },
              orientation: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "id",
              "fleet",
              "updatedAt",
              "name"
            ],
            members: {
              arn: {},
              id: {},
              fleet: {},
              updatedAt: {
                type: "timestamp"
              },
              name: {},
              additionalTransientProperties: {},
              additionalFixedProperties: {},
              orientation: {
                shape: "Su"
              },
              vendorProperties: {
                shape: "Sm"
              },
              position: {
                shape: "Sr"
              }
            }
          }
        },
        UpdateWorkerFleet: {
          http: {
            requestUri: "/updateWorkerFleet",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {},
              name: {},
              additionalFixedProperties: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "id",
              "name",
              "updatedAt"
            ],
            members: {
              arn: {},
              id: {},
              name: {},
              updatedAt: {
                type: "timestamp"
              },
              additionalFixedProperties: {}
            }
          }
        }
      },
      shapes: {
        Sm: {
          type: "structure",
          required: [
            "vendorWorkerId"
          ],
          members: {
            vendorWorkerId: {},
            vendorWorkerIpAddress: {},
            vendorAdditionalTransientProperties: {},
            vendorAdditionalFixedProperties: {}
          }
        },
        Sr: {
          type: "structure",
          members: {
            cartesianCoordinates: {
              type: "structure",
              required: [
                "x",
                "y"
              ],
              members: {
                x: {
                  type: "double"
                },
                y: {
                  type: "double"
                },
                z: {
                  type: "double"
                }
              }
            }
          },
          union: true
        },
        Su: {
          type: "structure",
          members: {
            degrees: {
              type: "double"
            }
          },
          union: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iot-roborunner-2018-05-10.paginators.json
var require_iot_roborunner_2018_05_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/iot-roborunner-2018-05-10.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListDestinations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "destinations"
        },
        ListSites: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "sites"
        },
        ListWorkerFleets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "workerFleets"
        },
        ListWorkers: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "workers"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/iotroborunner.js
var require_iotroborunner = __commonJS({
  "node_modules/aws-sdk/clients/iotroborunner.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["iotroborunner"] = {};
    AWS2.IoTRoboRunner = Service.defineService("iotroborunner", ["2018-05-10"]);
    Object.defineProperty(apiLoader.services["iotroborunner"], "2018-05-10", {
      get: function get() {
        var model = require_iot_roborunner_2018_05_10_min();
        model.paginators = require_iot_roborunner_2018_05_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.IoTRoboRunner;
  }
});

// node_modules/aws-sdk/apis/ssm-sap-2018-05-10.min.json
var require_ssm_sap_2018_05_10_min = __commonJS({
  "node_modules/aws-sdk/apis/ssm-sap-2018-05-10.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-05-10",
        endpointPrefix: "ssm-sap",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "SsmSap",
        serviceFullName: "AWS Systems Manager for SAP",
        serviceId: "Ssm Sap",
        signatureVersion: "v4",
        signingName: "ssm-sap",
        uid: "ssm-sap-2018-05-10"
      },
      operations: {
        DeleteResourcePermission: {
          http: {
            requestUri: "/delete-resource-permission",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ActionType: {},
              SourceResourceArn: {},
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {}
            }
          }
        },
        DeregisterApplication: {
          http: {
            requestUri: "/deregister-application",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId"
            ],
            members: {
              ApplicationId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetApplication: {
          http: {
            requestUri: "/get-application",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {},
              ApplicationArn: {},
              AppRegistryArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Application: {
                shape: "Sd"
              },
              Tags: {
                shape: "Sk"
              }
            }
          }
        },
        GetComponent: {
          http: {
            requestUri: "/get-component",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "ComponentId"
            ],
            members: {
              ApplicationId: {},
              ComponentId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Component: {
                type: "structure",
                members: {
                  ComponentId: {},
                  Sid: {},
                  SystemNumber: {},
                  ParentComponent: {},
                  ChildComponents: {
                    shape: "Sh"
                  },
                  ApplicationId: {},
                  ComponentType: {},
                  Status: {},
                  SapHostname: {},
                  SapFeature: {},
                  SapKernelVersion: {},
                  HdbVersion: {},
                  Resilience: {
                    type: "structure",
                    members: {
                      HsrTier: {},
                      HsrReplicationMode: {},
                      HsrOperationMode: {},
                      ClusterStatus: {},
                      EnqueueReplication: {
                        type: "boolean"
                      }
                    }
                  },
                  AssociatedHost: {
                    type: "structure",
                    members: {
                      Hostname: {},
                      Ec2InstanceId: {},
                      IpAddresses: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            IpAddress: {},
                            Primary: {
                              type: "boolean"
                            },
                            AllocationType: {}
                          }
                        }
                      },
                      OsVersion: {}
                    }
                  },
                  Databases: {
                    type: "list",
                    member: {}
                  },
                  Hosts: {
                    deprecated: true,
                    deprecatedMessage: "This shape is no longer used. Please use AssociatedHost.",
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        HostName: {},
                        HostIp: {},
                        EC2InstanceId: {},
                        InstanceId: {},
                        HostRole: {},
                        OsVersion: {}
                      }
                    }
                  },
                  PrimaryHost: {
                    deprecated: true,
                    deprecatedMessage: "This shape is no longer used. Please use AssociatedHost."
                  },
                  DatabaseConnection: {
                    type: "structure",
                    members: {
                      DatabaseConnectionMethod: {},
                      DatabaseArn: {},
                      ConnectionIp: {}
                    }
                  },
                  LastUpdated: {
                    type: "timestamp"
                  },
                  Arn: {}
                }
              },
              Tags: {
                shape: "Sk"
              }
            }
          }
        },
        GetDatabase: {
          http: {
            requestUri: "/get-database",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {},
              ComponentId: {},
              DatabaseId: {},
              DatabaseArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Database: {
                type: "structure",
                members: {
                  ApplicationId: {},
                  ComponentId: {},
                  Credentials: {
                    shape: "S1d"
                  },
                  DatabaseId: {},
                  DatabaseName: {},
                  DatabaseType: {},
                  Arn: {},
                  Status: {},
                  PrimaryHost: {},
                  SQLPort: {
                    type: "integer"
                  },
                  LastUpdated: {
                    type: "timestamp"
                  }
                }
              },
              Tags: {
                shape: "Sk"
              }
            }
          }
        },
        GetOperation: {
          http: {
            requestUri: "/get-operation",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "OperationId"
            ],
            members: {
              OperationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Operation: {
                shape: "S1o"
              }
            }
          }
        },
        GetResourcePermission: {
          http: {
            requestUri: "/get-resource-permission",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ActionType: {},
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {}
            }
          }
        },
        ListApplications: {
          http: {
            requestUri: "/list-applications",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S1z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Applications: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    DiscoveryStatus: {},
                    Type: {},
                    Arn: {},
                    Tags: {
                      shape: "Sk"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListComponents: {
          http: {
            requestUri: "/list-components",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Components: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApplicationId: {},
                    ComponentId: {},
                    ComponentType: {},
                    Tags: {
                      shape: "Sk"
                    },
                    Arn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDatabases: {
          http: {
            requestUri: "/list-databases",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {},
              ComponentId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Databases: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApplicationId: {},
                    ComponentId: {},
                    DatabaseId: {},
                    DatabaseType: {},
                    Arn: {},
                    Tags: {
                      shape: "Sk"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListOperations: {
          http: {
            requestUri: "/list-operations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId"
            ],
            members: {
              ApplicationId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "S1z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Operations: {
                type: "list",
                member: {
                  shape: "S1o"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sk"
              }
            }
          }
        },
        PutResourcePermission: {
          http: {
            requestUri: "/put-resource-permission",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ActionType",
              "SourceResourceArn",
              "ResourceArn"
            ],
            members: {
              ActionType: {},
              SourceResourceArn: {},
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {}
            }
          }
        },
        RegisterApplication: {
          http: {
            requestUri: "/register-application",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "ApplicationType",
              "Instances"
            ],
            members: {
              ApplicationId: {},
              ApplicationType: {},
              Instances: {
                type: "list",
                member: {}
              },
              SapInstanceNumber: {},
              Sid: {},
              Tags: {
                shape: "Sk"
              },
              Credentials: {
                shape: "S1d"
              },
              DatabaseArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Application: {
                shape: "Sd"
              },
              OperationId: {}
            }
          }
        },
        StartApplicationRefresh: {
          http: {
            requestUri: "/start-application-refresh",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId"
            ],
            members: {
              ApplicationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateApplicationSettings: {
          http: {
            requestUri: "/update-application-settings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId"
            ],
            members: {
              ApplicationId: {},
              CredentialsToAddOrUpdate: {
                shape: "S1d"
              },
              CredentialsToRemove: {
                shape: "S1d"
              },
              Backint: {
                type: "structure",
                required: [
                  "BackintMode",
                  "EnsureNoBackupInProcess"
                ],
                members: {
                  BackintMode: {},
                  EnsureNoBackupInProcess: {
                    type: "boolean"
                  }
                }
              },
              DatabaseArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Message: {},
              OperationIds: {
                type: "list",
                member: {}
              }
            }
          }
        }
      },
      shapes: {
        Sd: {
          type: "structure",
          members: {
            Id: {},
            Type: {},
            Arn: {},
            AppRegistryArn: {},
            Status: {},
            DiscoveryStatus: {},
            Components: {
              shape: "Sh"
            },
            LastUpdated: {
              type: "timestamp"
            },
            StatusMessage: {}
          }
        },
        Sh: {
          type: "list",
          member: {}
        },
        Sk: {
          type: "map",
          key: {},
          value: {}
        },
        S1d: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "DatabaseName",
              "CredentialType",
              "SecretId"
            ],
            members: {
              DatabaseName: {},
              CredentialType: {},
              SecretId: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        S1o: {
          type: "structure",
          members: {
            Id: {},
            Type: {},
            Status: {},
            StatusMessage: {},
            Properties: {
              type: "map",
              key: {},
              value: {}
            },
            ResourceType: {},
            ResourceId: {},
            ResourceArn: {},
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            LastUpdatedTime: {
              type: "timestamp"
            }
          }
        },
        S1z: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Value",
              "Operator"
            ],
            members: {
              Name: {},
              Value: {},
              Operator: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ssm-sap-2018-05-10.paginators.json
var require_ssm_sap_2018_05_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/ssm-sap-2018-05-10.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListApplications: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Applications"
        },
        ListComponents: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Components"
        },
        ListDatabases: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Databases"
        },
        ListOperations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Operations"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/ssmsap.js
var require_ssmsap = __commonJS({
  "node_modules/aws-sdk/clients/ssmsap.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["ssmsap"] = {};
    AWS2.SsmSap = Service.defineService("ssmsap", ["2018-05-10"]);
    Object.defineProperty(apiLoader.services["ssmsap"], "2018-05-10", {
      get: function get() {
        var model = require_ssm_sap_2018_05_10_min();
        model.paginators = require_ssm_sap_2018_05_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.SsmSap;
  }
});

// node_modules/aws-sdk/apis/oam-2022-06-10.min.json
var require_oam_2022_06_10_min = __commonJS({
  "node_modules/aws-sdk/apis/oam-2022-06-10.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2022-06-10",
        endpointPrefix: "oam",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "CloudWatch Observability Access Manager",
        serviceId: "OAM",
        signatureVersion: "v4",
        signingName: "oam",
        uid: "oam-2022-06-10"
      },
      operations: {
        CreateLink: {
          http: {
            requestUri: "/CreateLink",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "LabelTemplate",
              "ResourceTypes",
              "SinkIdentifier"
            ],
            members: {
              LabelTemplate: {},
              ResourceTypes: {
                shape: "S3"
              },
              SinkIdentifier: {},
              Tags: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Id: {},
              Label: {},
              LabelTemplate: {},
              ResourceTypes: {
                shape: "Sb"
              },
              SinkArn: {},
              Tags: {
                shape: "Sc"
              }
            }
          }
        },
        CreateSink: {
          http: {
            requestUri: "/CreateSink",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Tags: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Id: {},
              Name: {},
              Tags: {
                shape: "Sc"
              }
            }
          }
        },
        DeleteLink: {
          http: {
            requestUri: "/DeleteLink",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Identifier"
            ],
            members: {
              Identifier: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSink: {
          http: {
            requestUri: "/DeleteSink",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Identifier"
            ],
            members: {
              Identifier: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetLink: {
          http: {
            requestUri: "/GetLink",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Identifier"
            ],
            members: {
              Identifier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Id: {},
              Label: {},
              LabelTemplate: {},
              ResourceTypes: {
                shape: "Sb"
              },
              SinkArn: {},
              Tags: {
                shape: "Sc"
              }
            }
          }
        },
        GetSink: {
          http: {
            requestUri: "/GetSink",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Identifier"
            ],
            members: {
              Identifier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Id: {},
              Name: {},
              Tags: {
                shape: "Sc"
              }
            }
          }
        },
        GetSinkPolicy: {
          http: {
            requestUri: "/GetSinkPolicy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SinkIdentifier"
            ],
            members: {
              SinkIdentifier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SinkArn: {},
              SinkId: {},
              Policy: {}
            }
          }
        },
        ListAttachedLinks: {
          http: {
            requestUri: "/ListAttachedLinks",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SinkIdentifier"
            ],
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              SinkIdentifier: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Items"
            ],
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Label: {},
                    LinkArn: {},
                    ResourceTypes: {
                      shape: "Sb"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListLinks: {
          http: {
            requestUri: "/ListLinks",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Items"
            ],
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Id: {},
                    Label: {},
                    ResourceTypes: {
                      shape: "Sb"
                    },
                    SinkArn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSinks: {
          http: {
            requestUri: "/ListSinks",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Items"
            ],
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Id: {},
                    Name: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sc"
              }
            }
          }
        },
        PutSinkPolicy: {
          http: {
            requestUri: "/PutSinkPolicy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SinkIdentifier",
              "Policy"
            ],
            members: {
              SinkIdentifier: {},
              Policy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SinkArn: {},
              SinkId: {},
              Policy: {}
            }
          }
        },
        TagResource: {
          http: {
            method: "PUT",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateLink: {
          http: {
            requestUri: "/UpdateLink",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Identifier",
              "ResourceTypes"
            ],
            members: {
              Identifier: {},
              ResourceTypes: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Id: {},
              Label: {},
              LabelTemplate: {},
              ResourceTypes: {
                shape: "Sb"
              },
              SinkArn: {},
              Tags: {
                shape: "Sc"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {}
        },
        S6: {
          type: "map",
          key: {},
          value: {}
        },
        Sb: {
          type: "list",
          member: {}
        },
        Sc: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/oam-2022-06-10.paginators.json
var require_oam_2022_06_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/oam-2022-06-10.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAttachedLinks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Items"
        },
        ListLinks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Items"
        },
        ListSinks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/oam.js
var require_oam = __commonJS({
  "node_modules/aws-sdk/clients/oam.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["oam"] = {};
    AWS2.OAM = Service.defineService("oam", ["2022-06-10"]);
    Object.defineProperty(apiLoader.services["oam"], "2022-06-10", {
      get: function get() {
        var model = require_oam_2022_06_10_min();
        model.paginators = require_oam_2022_06_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.OAM;
  }
});

// node_modules/aws-sdk/apis/arc-zonal-shift-2022-10-30.min.json
var require_arc_zonal_shift_2022_10_30_min = __commonJS({
  "node_modules/aws-sdk/apis/arc-zonal-shift-2022-10-30.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2022-10-30",
        endpointPrefix: "arc-zonal-shift",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS ARC - Zonal Shift",
        serviceId: "ARC Zonal Shift",
        signatureVersion: "v4",
        signingName: "arc-zonal-shift",
        uid: "arc-zonal-shift-2022-10-30"
      },
      operations: {
        CancelZonalShift: {
          http: {
            method: "DELETE",
            requestUri: "/zonalshifts/{zonalShiftId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "zonalShiftId"
            ],
            members: {
              zonalShiftId: {
                location: "uri",
                locationName: "zonalShiftId"
              }
            }
          },
          output: {
            shape: "S3"
          }
        },
        CreatePracticeRunConfiguration: {
          http: {
            requestUri: "/configuration",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "outcomeAlarms",
              "resourceIdentifier"
            ],
            members: {
              blockedDates: {
                shape: "Sb"
              },
              blockedWindows: {
                shape: "Sd"
              },
              blockingAlarms: {
                shape: "Sf"
              },
              outcomeAlarms: {
                shape: "Sf"
              },
              resourceIdentifier: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "name",
              "practiceRunConfiguration",
              "zonalAutoshiftStatus"
            ],
            members: {
              arn: {},
              name: {},
              practiceRunConfiguration: {
                shape: "Sl"
              },
              zonalAutoshiftStatus: {}
            }
          }
        },
        DeletePracticeRunConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/configuration/{resourceIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceIdentifier"
            ],
            members: {
              resourceIdentifier: {
                location: "uri",
                locationName: "resourceIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "name",
              "zonalAutoshiftStatus"
            ],
            members: {
              arn: {},
              name: {},
              zonalAutoshiftStatus: {}
            }
          },
          idempotent: true
        },
        GetManagedResource: {
          http: {
            method: "GET",
            requestUri: "/managedresources/{resourceIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceIdentifier"
            ],
            members: {
              resourceIdentifier: {
                location: "uri",
                locationName: "resourceIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "appliedWeights",
              "zonalShifts"
            ],
            members: {
              appliedWeights: {
                shape: "Sr"
              },
              arn: {},
              autoshifts: {
                shape: "St"
              },
              name: {},
              practiceRunConfiguration: {
                shape: "Sl"
              },
              zonalAutoshiftStatus: {},
              zonalShifts: {
                shape: "Sw"
              }
            }
          }
        },
        ListAutoshifts: {
          http: {
            method: "GET",
            requestUri: "/autoshifts",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              status: {
                location: "querystring",
                locationName: "status"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "awayFrom",
                    "endTime",
                    "startTime",
                    "status"
                  ],
                  members: {
                    awayFrom: {},
                    endTime: {
                      type: "timestamp"
                    },
                    startTime: {
                      type: "timestamp"
                    },
                    status: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListManagedResources: {
          http: {
            method: "GET",
            requestUri: "/managedresources",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "items"
            ],
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "availabilityZones"
                  ],
                  members: {
                    appliedWeights: {
                      shape: "Sr"
                    },
                    arn: {},
                    autoshifts: {
                      shape: "St"
                    },
                    availabilityZones: {
                      type: "list",
                      member: {}
                    },
                    name: {},
                    practiceRunStatus: {},
                    zonalAutoshiftStatus: {},
                    zonalShifts: {
                      shape: "Sw"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListZonalShifts: {
          http: {
            method: "GET",
            requestUri: "/zonalshifts",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              resourceIdentifier: {
                location: "querystring",
                locationName: "resourceIdentifier"
              },
              status: {
                location: "querystring",
                locationName: "status"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "awayFrom",
                    "comment",
                    "expiryTime",
                    "resourceIdentifier",
                    "startTime",
                    "status",
                    "zonalShiftId"
                  ],
                  members: {
                    awayFrom: {},
                    comment: {},
                    expiryTime: {
                      type: "timestamp"
                    },
                    practiceRunOutcome: {},
                    resourceIdentifier: {},
                    startTime: {
                      type: "timestamp"
                    },
                    status: {},
                    zonalShiftId: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        StartZonalShift: {
          http: {
            requestUri: "/zonalshifts",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "awayFrom",
              "comment",
              "expiresIn",
              "resourceIdentifier"
            ],
            members: {
              awayFrom: {},
              comment: {},
              expiresIn: {},
              resourceIdentifier: {}
            }
          },
          output: {
            shape: "S3"
          }
        },
        UpdatePracticeRunConfiguration: {
          http: {
            method: "PATCH",
            requestUri: "/configuration/{resourceIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceIdentifier"
            ],
            members: {
              blockedDates: {
                shape: "Sb"
              },
              blockedWindows: {
                shape: "Sd"
              },
              blockingAlarms: {
                shape: "Sf"
              },
              outcomeAlarms: {
                shape: "Sf"
              },
              resourceIdentifier: {
                location: "uri",
                locationName: "resourceIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "name",
              "practiceRunConfiguration",
              "zonalAutoshiftStatus"
            ],
            members: {
              arn: {},
              name: {},
              practiceRunConfiguration: {
                shape: "Sl"
              },
              zonalAutoshiftStatus: {}
            }
          }
        },
        UpdateZonalAutoshiftConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/managedresources/{resourceIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceIdentifier",
              "zonalAutoshiftStatus"
            ],
            members: {
              resourceIdentifier: {
                location: "uri",
                locationName: "resourceIdentifier"
              },
              zonalAutoshiftStatus: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "resourceIdentifier",
              "zonalAutoshiftStatus"
            ],
            members: {
              resourceIdentifier: {},
              zonalAutoshiftStatus: {}
            }
          },
          idempotent: true
        },
        UpdateZonalShift: {
          http: {
            method: "PATCH",
            requestUri: "/zonalshifts/{zonalShiftId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "zonalShiftId"
            ],
            members: {
              comment: {},
              expiresIn: {},
              zonalShiftId: {
                location: "uri",
                locationName: "zonalShiftId"
              }
            }
          },
          output: {
            shape: "S3"
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          required: [
            "awayFrom",
            "comment",
            "expiryTime",
            "resourceIdentifier",
            "startTime",
            "status",
            "zonalShiftId"
          ],
          members: {
            awayFrom: {},
            comment: {},
            expiryTime: {
              type: "timestamp"
            },
            resourceIdentifier: {},
            startTime: {
              type: "timestamp"
            },
            status: {},
            zonalShiftId: {}
          }
        },
        Sb: {
          type: "list",
          member: {}
        },
        Sd: {
          type: "list",
          member: {}
        },
        Sf: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "alarmIdentifier",
              "type"
            ],
            members: {
              alarmIdentifier: {},
              type: {}
            }
          }
        },
        Sl: {
          type: "structure",
          required: [
            "outcomeAlarms"
          ],
          members: {
            blockedDates: {
              shape: "Sb"
            },
            blockedWindows: {
              shape: "Sd"
            },
            blockingAlarms: {
              shape: "Sf"
            },
            outcomeAlarms: {
              shape: "Sf"
            }
          }
        },
        Sr: {
          type: "map",
          key: {},
          value: {
            type: "float"
          }
        },
        St: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "appliedStatus",
              "awayFrom",
              "startTime"
            ],
            members: {
              appliedStatus: {},
              awayFrom: {},
              startTime: {
                type: "timestamp"
              }
            }
          }
        },
        Sw: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "appliedStatus",
              "awayFrom",
              "comment",
              "expiryTime",
              "resourceIdentifier",
              "startTime",
              "zonalShiftId"
            ],
            members: {
              appliedStatus: {},
              awayFrom: {},
              comment: {},
              expiryTime: {
                type: "timestamp"
              },
              practiceRunOutcome: {},
              resourceIdentifier: {},
              startTime: {
                type: "timestamp"
              },
              zonalShiftId: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/arc-zonal-shift-2022-10-30.paginators.json
var require_arc_zonal_shift_2022_10_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/arc-zonal-shift-2022-10-30.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAutoshifts: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListManagedResources: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListZonalShifts: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/arczonalshift.js
var require_arczonalshift = __commonJS({
  "node_modules/aws-sdk/clients/arczonalshift.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["arczonalshift"] = {};
    AWS2.ARCZonalShift = Service.defineService("arczonalshift", ["2022-10-30"]);
    Object.defineProperty(apiLoader.services["arczonalshift"], "2022-10-30", {
      get: function get() {
        var model = require_arc_zonal_shift_2022_10_30_min();
        model.paginators = require_arc_zonal_shift_2022_10_30_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ARCZonalShift;
  }
});

// node_modules/aws-sdk/apis/omics-2022-11-28.min.json
var require_omics_2022_11_28_min = __commonJS({
  "node_modules/aws-sdk/apis/omics-2022-11-28.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2022-11-28",
        endpointPrefix: "omics",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Omics",
        serviceId: "Omics",
        signatureVersion: "v4",
        signingName: "omics",
        uid: "omics-2022-11-28"
      },
      operations: {
        AbortMultipartReadSetUpload: {
          http: {
            method: "DELETE",
            requestUri: "/sequencestore/{sequenceStoreId}/upload/{uploadId}/abort",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sequenceStoreId",
              "uploadId"
            ],
            members: {
              sequenceStoreId: {
                location: "uri",
                locationName: "sequenceStoreId"
              },
              uploadId: {
                location: "uri",
                locationName: "uploadId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "control-storage-"
          }
        },
        AcceptShare: {
          http: {
            requestUri: "/share/{shareId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "shareId"
            ],
            members: {
              shareId: {
                location: "uri",
                locationName: "shareId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              status: {}
            }
          },
          endpoint: {
            hostPrefix: "analytics-"
          }
        },
        BatchDeleteReadSet: {
          http: {
            requestUri: "/sequencestore/{sequenceStoreId}/readset/batch/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ids",
              "sequenceStoreId"
            ],
            members: {
              ids: {
                type: "list",
                member: {}
              },
              sequenceStoreId: {
                location: "uri",
                locationName: "sequenceStoreId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "code",
                    "message"
                  ],
                  members: {
                    id: {},
                    code: {},
                    message: {}
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "control-storage-"
          },
          idempotent: true
        },
        CancelAnnotationImportJob: {
          http: {
            method: "DELETE",
            requestUri: "/import/annotation/{jobId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "analytics-"
          },
          idempotent: true
        },
        CancelRun: {
          http: {
            requestUri: "/run/{id}/cancel",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          endpoint: {
            hostPrefix: "workflows-"
          }
        },
        CancelVariantImportJob: {
          http: {
            method: "DELETE",
            requestUri: "/import/variant/{jobId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "analytics-"
          },
          idempotent: true
        },
        CompleteMultipartReadSetUpload: {
          http: {
            requestUri: "/sequencestore/{sequenceStoreId}/upload/{uploadId}/complete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sequenceStoreId",
              "uploadId",
              "parts"
            ],
            members: {
              sequenceStoreId: {
                location: "uri",
                locationName: "sequenceStoreId"
              },
              uploadId: {
                location: "uri",
                locationName: "uploadId"
              },
              parts: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "partNumber",
                    "partSource",
                    "checksum"
                  ],
                  members: {
                    partNumber: {
                      type: "integer"
                    },
                    partSource: {},
                    checksum: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "readSetId"
            ],
            members: {
              readSetId: {}
            }
          },
          endpoint: {
            hostPrefix: "storage-"
          }
        },
        CreateAnnotationStore: {
          http: {
            requestUri: "/annotationStore",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "storeFormat"
            ],
            members: {
              reference: {
                shape: "St"
              },
              name: {},
              description: {},
              tags: {
                shape: "Sx"
              },
              versionName: {},
              sseConfig: {
                shape: "S11"
              },
              storeFormat: {},
              storeOptions: {
                shape: "S15"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "status",
              "name",
              "versionName",
              "creationTime"
            ],
            members: {
              id: {},
              reference: {
                shape: "St"
              },
              storeFormat: {},
              storeOptions: {
                shape: "S15"
              },
              status: {},
              name: {},
              versionName: {},
              creationTime: {
                shape: "S1h"
              }
            }
          },
          endpoint: {
            hostPrefix: "analytics-"
          }
        },
        CreateAnnotationStoreVersion: {
          http: {
            requestUri: "/annotationStore/{name}/version",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "versionName"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              versionName: {},
              description: {},
              versionOptions: {
                shape: "S1j"
              },
              tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "versionName",
              "storeId",
              "name",
              "status",
              "creationTime"
            ],
            members: {
              id: {},
              versionName: {},
              storeId: {},
              versionOptions: {
                shape: "S1j"
              },
              name: {},
              status: {},
              creationTime: {
                shape: "S1h"
              }
            }
          },
          endpoint: {
            hostPrefix: "analytics-"
          }
        },
        CreateMultipartReadSetUpload: {
          http: {
            requestUri: "/sequencestore/{sequenceStoreId}/upload",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sequenceStoreId",
              "sourceFileType",
              "subjectId",
              "sampleId",
              "name"
            ],
            members: {
              sequenceStoreId: {
                location: "uri",
                locationName: "sequenceStoreId"
              },
              clientToken: {},
              sourceFileType: {},
              subjectId: {},
              sampleId: {},
              generatedFrom: {},
              referenceArn: {},
              name: {},
              description: {},
              tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "sequenceStoreId",
              "uploadId",
              "sourceFileType",
              "subjectId",
              "sampleId",
              "referenceArn",
              "creationTime"
            ],
            members: {
              sequenceStoreId: {},
              uploadId: {},
              sourceFileType: {},
              subjectId: {},
              sampleId: {},
              generatedFrom: {},
              referenceArn: {},
              name: {},
              description: {},
              tags: {
                shape: "Sx"
              },
              creationTime: {
                shape: "S1x"
              }
            }
          },
          endpoint: {
            hostPrefix: "control-storage-"
          }
        },
        CreateReferenceStore: {
          http: {
            requestUri: "/referencestore",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              description: {},
              sseConfig: {
                shape: "S11"
              },
              tags: {
                shape: "Sx"
              },
              clientToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "arn",
              "creationTime"
            ],
            members: {
              id: {},
              arn: {},
              name: {},
              description: {},
              sseConfig: {
                shape: "S11"
              },
              creationTime: {
                shape: "S1x"
              }
            }
          },
          endpoint: {
            hostPrefix: "control-storage-"
          }
        },
        CreateRunGroup: {
          http: {
            requestUri: "/runGroup",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "requestId"
            ],
            members: {
              name: {},
              maxCpus: {
                type: "integer"
              },
              maxRuns: {
                type: "integer"
              },
              maxDuration: {
                type: "integer"
              },
              tags: {
                shape: "Sx"
              },
              requestId: {
                idempotencyToken: true
              },
              maxGpus: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              id: {},
              tags: {
                shape: "Sx"
              }
            }
          },
          endpoint: {
            hostPrefix: "workflows-"
          }
        },
        CreateSequenceStore: {
          http: {
            requestUri: "/sequencestore",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              description: {},
              sseConfig: {
                shape: "S11"
              },
              tags: {
                shape: "Sx"
              },
              clientToken: {},
              fallbackLocation: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "arn",
              "creationTime"
            ],
            members: {
              id: {},
              arn: {},
              name: {},
              description: {},
              sseConfig: {
                shape: "S11"
              },
              creationTime: {
                shape: "S1x"
              },
              fallbackLocation: {}
            }
          },
          endpoint: {
            hostPrefix: "control-storage-"
          }
        },
        CreateShare: {
          http: {
            requestUri: "/share",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "principalSubscriber"
            ],
            members: {
              resourceArn: {},
              principalSubscriber: {},
              shareName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              shareId: {},
              status: {},
              shareName: {}
            }
          },
          endpoint: {
            hostPrefix: "analytics-"
          }
        },
        CreateVariantStore: {
          http: {
            requestUri: "/variantStore",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "reference"
            ],
            members: {
              reference: {
                shape: "St"
              },
              name: {},
              description: {},
              tags: {
                shape: "Sx"
              },
              sseConfig: {
                shape: "S11"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "status",
              "name",
              "creationTime"
            ],
            members: {
              id: {},
              reference: {
                shape: "St"
              },
              status: {},
              name: {},
              creationTime: {
                shape: "S1h"
              }
            }
          },
          endpoint: {
            hostPrefix: "analytics-"
          }
        },
        CreateWorkflow: {
          http: {
            requestUri: "/workflow",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "requestId"
            ],
            members: {
              name: {},
              description: {},
              engine: {},
              definitionZip: {
                type: "blob"
              },
              definitionUri: {},
              main: {},
              parameterTemplate: {
                shape: "S2w"
              },
              storageCapacity: {
                type: "integer"
              },
              tags: {
                shape: "Sx"
              },
              requestId: {
                idempotencyToken: true
              },
              accelerators: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              id: {},
              status: {},
              tags: {
                shape: "Sx"
              }
            }
          },
          endpoint: {
            hostPrefix: "workflows-"
          }
        },
        DeleteAnnotationStore: {
          http: {
            method: "DELETE",
            requestUri: "/annotationStore/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              force: {
                location: "querystring",
                locationName: "force",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "status"
            ],
            members: {
              status: {}
            }
          },
          endpoint: {
            hostPrefix: "analytics-"
          },
          idempotent: true
        },
        DeleteAnnotationStoreVersions: {
          http: {
            requestUri: "/annotationStore/{name}/versions/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "versions"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              versions: {
                type: "list",
                member: {}
              },
              force: {
                location: "querystring",
                locationName: "force",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "versionName",
                    "message"
                  ],
                  members: {
                    versionName: {},
                    message: {}
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "analytics-"
          },
          idempotent: true
        },
        DeleteReference: {
          http: {
            method: "DELETE",
            requestUri: "/referencestore/{referenceStoreId}/reference/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id",
              "referenceStoreId"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              referenceStoreId: {
                location: "uri",
                locationName: "referenceStoreId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "control-storage-"
          },
          idempotent: true
        },
        DeleteReferenceStore: {
          http: {
            method: "DELETE",
            requestUri: "/referencestore/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "control-storage-"
          },
          idempotent: true
        },
        DeleteRun: {
          http: {
            method: "DELETE",
            requestUri: "/run/{id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          endpoint: {
            hostPrefix: "workflows-"
          },
          idempotent: true
        },
        DeleteRunGroup: {
          http: {
            method: "DELETE",
            requestUri: "/runGroup/{id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          endpoint: {
            hostPrefix: "workflows-"
          },
          idempotent: true
        },
        DeleteSequenceStore: {
          http: {
            method: "DELETE",
            requestUri: "/sequencestore/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "control-storage-"
          },
          idempotent: true
        },
        DeleteShare: {
          http: {
            method: "DELETE",
            requestUri: "/share/{shareId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "shareId"
            ],
            members: {
              shareId: {
                location: "uri",
                locationName: "shareId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              status: {}
            }
          },
          endpoint: {
            hostPrefix: "analytics-"
          },
          idempotent: true
        },
        DeleteVariantStore: {
          http: {
            method: "DELETE",
            requestUri: "/variantStore/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              force: {
                location: "querystring",
                locationName: "force",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "status"
            ],
            members: {
              status: {}
            }
          },
          endpoint: {
            hostPrefix: "analytics-"
          },
          idempotent: true
        },
        DeleteWorkflow: {
          http: {
            method: "DELETE",
            requestUri: "/workflow/{id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          endpoint: {
            hostPrefix: "workflows-"
          },
          idempotent: true
        },
        GetAnnotationImportJob: {
          http: {
            method: "GET",
            requestUri: "/import/annotation/{jobId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "destinationName",
              "versionName",
              "roleArn",
              "status",
              "statusMessage",
              "creationTime",
              "updateTime",
              "completionTime",
              "items",
              "runLeftNormalization",
              "formatOptions"
            ],
            members: {
              id: {},
              destinationName: {},
              versionName: {},
              roleArn: {},
              status: {},
              statusMessage: {},
              creationTime: {
                shape: "S1h"
              },
              updateTime: {
                shape: "S3z"
              },
              completionTime: {
                shape: "S40"
              },
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "source",
                    "jobStatus"
                  ],
                  members: {
                    source: {},
                    jobStatus: {}
                  }
                }
              },
              runLeftNormalization: {
                type: "boolean"
              },
              formatOptions: {
                shape: "S45"
              },
              annotationFields: {
                shape: "S4i"
              }
            }
          },
          endpoint: {
            hostPrefix: "analytics-"
          }
        },
        GetAnnotationStore: {
          http: {
            method: "GET",
            requestUri: "/annotationStore/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "reference",
              "status",
              "storeArn",
              "name",
              "description",
              "sseConfig",
              "creationTime",
              "updateTime",
              "tags",
              "statusMessage",
              "storeSizeBytes",
              "numVersions"
            ],
            members: {
              id: {},
              reference: {
                shape: "St"
              },
              status: {},
              storeArn: {},
              name: {},
              description: {},
              sseConfig: {
                shape: "S11"
              },
              creationTime: {
                shape: "S1h"
              },
              updateTime: {
                shape: "S3z"
              },
              tags: {
                shape: "Sx"
              },
              storeOptions: {
                shape: "S15"
              },
              storeFormat: {},
              statusMessage: {},
              storeSizeBytes: {
                type: "long"
              },
              numVersions: {
                type: "integer"
              }
            }
          },
          endpoint: {
            hostPrefix: "analytics-"
          }
        },
        GetAnnotationStoreVersion: {
          http: {
            method: "GET",
            requestUri: "/annotationStore/{name}/version/{versionName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "versionName"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              versionName: {
                location: "uri",
                locationName: "versionName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "storeId",
              "id",
              "status",
              "versionArn",
              "name",
              "versionName",
              "description",
              "creationTime",
              "updateTime",
              "tags",
              "statusMessage",
              "versionSizeBytes"
            ],
            members: {
              storeId: {},
              id: {},
              status: {},
              versionArn: {},
              name: {},
              versionName: {},
              description: {},
              creationTime: {
                shape: "S1h"
              },
              updateTime: {
                shape: "S3z"
              },
              tags: {
                shape: "Sx"
              },
              versionOptions: {
                shape: "S1j"
              },
              statusMessage: {},
              versionSizeBytes: {
                type: "long"
              }
            }
          },
          endpoint: {
            hostPrefix: "analytics-"
          }
        },
        GetReadSet: {
          http: {
            method: "GET",
            requestUri: "/sequencestore/{sequenceStoreId}/readset/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id",
              "sequenceStoreId",
              "partNumber"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              sequenceStoreId: {
                location: "uri",
                locationName: "sequenceStoreId"
              },
              file: {
                location: "querystring",
                locationName: "file"
              },
              partNumber: {
                location: "querystring",
                locationName: "partNumber",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              payload: {
                type: "blob",
                streaming: true
              }
            },
            payload: "payload"
          },
          endpoint: {
            hostPrefix: "storage-"
          }
        },
        GetReadSetActivationJob: {
          http: {
            method: "GET",
            requestUri: "/sequencestore/{sequenceStoreId}/activationjob/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id",
              "sequenceStoreId"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              sequenceStoreId: {
                location: "uri",
                locationName: "sequenceStoreId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "sequenceStoreId",
              "status",
              "creationTime"
            ],
            members: {
              id: {},
              sequenceStoreId: {},
              status: {},
              statusMessage: {},
              creationTime: {
                shape: "S1x"
              },
              completionTime: {
                shape: "S1x"
              },
              sources: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "readSetId",
                    "status"
                  ],
                  members: {
                    readSetId: {},
                    status: {},
                    statusMessage: {}
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "control-storage-"
          }
        },
        GetReadSetExportJob: {
          http: {
            method: "GET",
            requestUri: "/sequencestore/{sequenceStoreId}/exportjob/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sequenceStoreId",
              "id"
            ],
            members: {
              sequenceStoreId: {
                location: "uri",
                locationName: "sequenceStoreId"
              },
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "sequenceStoreId",
              "destination",
              "status",
              "creationTime"
            ],
            members: {
              id: {},
              sequenceStoreId: {},
              destination: {},
              status: {},
              statusMessage: {},
              creationTime: {
                shape: "S1x"
              },
              completionTime: {
                shape: "S1x"
              },
              readSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "status"
                  ],
                  members: {
                    id: {},
                    status: {},
                    statusMessage: {}
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "control-storage-"
          }
        },
        GetReadSetImportJob: {
          http: {
            method: "GET",
            requestUri: "/sequencestore/{sequenceStoreId}/importjob/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id",
              "sequenceStoreId"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              sequenceStoreId: {
                location: "uri",
                locationName: "sequenceStoreId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "sequenceStoreId",
              "roleArn",
              "status",
              "creationTime",
              "sources"
            ],
            members: {
              id: {},
              sequenceStoreId: {},
              roleArn: {},
              status: {},
              statusMessage: {},
              creationTime: {
                shape: "S1x"
              },
              completionTime: {
                shape: "S1x"
              },
              sources: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "sourceFiles",
                    "sourceFileType",
                    "status",
                    "subjectId",
                    "sampleId"
                  ],
                  members: {
                    sourceFiles: {
                      shape: "S5j"
                    },
                    sourceFileType: {},
                    status: {},
                    statusMessage: {},
                    subjectId: {},
                    sampleId: {},
                    generatedFrom: {},
                    referenceArn: {},
                    name: {},
                    description: {},
                    tags: {
                      shape: "Sx"
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "control-storage-"
          }
        },
        GetReadSetMetadata: {
          http: {
            method: "GET",
            requestUri: "/sequencestore/{sequenceStoreId}/readset/{id}/metadata",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id",
              "sequenceStoreId"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              sequenceStoreId: {
                location: "uri",
                locationName: "sequenceStoreId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "arn",
              "sequenceStoreId",
              "status",
              "fileType",
              "creationTime"
            ],
            members: {
              id: {},
              arn: {},
              sequenceStoreId: {},
              subjectId: {},
              sampleId: {},
              status: {},
              name: {},
              description: {},
              fileType: {},
              creationTime: {
                shape: "S1x"
              },
              sequenceInformation: {
                shape: "S5p"
              },
              referenceArn: {},
              files: {
                type: "structure",
                members: {
                  source1: {
                    shape: "S5r"
                  },
                  source2: {
                    shape: "S5r"
                  },
                  index: {
                    shape: "S5r"
                  }
                }
              },
              statusMessage: {},
              creationType: {},
              etag: {
                shape: "S5x"
              }
            }
          },
          endpoint: {
            hostPrefix: "control-storage-"
          }
        },
        GetReference: {
          http: {
            method: "GET",
            requestUri: "/referencestore/{referenceStoreId}/reference/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id",
              "referenceStoreId",
              "partNumber"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              referenceStoreId: {
                location: "uri",
                locationName: "referenceStoreId"
              },
              range: {
                location: "header",
                locationName: "Range"
              },
              partNumber: {
                location: "querystring",
                locationName: "partNumber",
                type: "integer"
              },
              file: {
                location: "querystring",
                locationName: "file"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              payload: {
                type: "blob",
                streaming: true
              }
            },
            payload: "payload"
          },
          endpoint: {
            hostPrefix: "storage-"
          }
        },
        GetReferenceImportJob: {
          http: {
            method: "GET",
            requestUri: "/referencestore/{referenceStoreId}/importjob/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id",
              "referenceStoreId"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              referenceStoreId: {
                location: "uri",
                locationName: "referenceStoreId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "referenceStoreId",
              "roleArn",
              "status",
              "creationTime",
              "sources"
            ],
            members: {
              id: {},
              referenceStoreId: {},
              roleArn: {},
              status: {},
              statusMessage: {},
              creationTime: {
                shape: "S1x"
              },
              completionTime: {
                shape: "S1x"
              },
              sources: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "status"
                  ],
                  members: {
                    sourceFile: {},
                    status: {},
                    statusMessage: {},
                    name: {},
                    description: {},
                    tags: {
                      shape: "Sx"
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "control-storage-"
          }
        },
        GetReferenceMetadata: {
          http: {
            method: "GET",
            requestUri: "/referencestore/{referenceStoreId}/reference/{id}/metadata",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id",
              "referenceStoreId"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              referenceStoreId: {
                location: "uri",
                locationName: "referenceStoreId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "arn",
              "referenceStoreId",
              "md5",
              "creationTime",
              "updateTime"
            ],
            members: {
              id: {},
              arn: {},
              referenceStoreId: {},
              md5: {},
              status: {},
              name: {},
              description: {},
              creationTime: {
                shape: "S1x"
              },
              updateTime: {
                shape: "S1x"
              },
              files: {
                type: "structure",
                members: {
                  source: {
                    shape: "S5r"
                  },
                  index: {
                    shape: "S5r"
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "control-storage-"
          }
        },
        GetReferenceStore: {
          http: {
            method: "GET",
            requestUri: "/referencestore/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "arn",
              "creationTime"
            ],
            members: {
              id: {},
              arn: {},
              name: {},
              description: {},
              sseConfig: {
                shape: "S11"
              },
              creationTime: {
                shape: "S1x"
              }
            }
          },
          endpoint: {
            hostPrefix: "control-storage-"
          }
        },
        GetRun: {
          http: {
            method: "GET",
            requestUri: "/run/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              export: {
                location: "querystring",
                locationName: "export",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              id: {},
              status: {},
              workflowId: {},
              workflowType: {},
              runId: {},
              roleArn: {},
              name: {},
              runGroupId: {},
              priority: {
                type: "integer"
              },
              definition: {},
              digest: {},
              parameters: {
                shape: "S6v"
              },
              storageCapacity: {
                type: "integer"
              },
              outputUri: {},
              logLevel: {},
              resourceDigests: {
                type: "map",
                key: {},
                value: {}
              },
              startedBy: {},
              creationTime: {
                shape: "S73"
              },
              startTime: {
                shape: "S73"
              },
              stopTime: {
                shape: "S73"
              },
              statusMessage: {},
              tags: {
                shape: "Sx"
              },
              accelerators: {},
              retentionMode: {},
              failureReason: {},
              logLocation: {
                type: "structure",
                members: {
                  engineLogStream: {},
                  runLogStream: {}
                }
              },
              uuid: {},
              runOutputUri: {}
            }
          },
          endpoint: {
            hostPrefix: "workflows-"
          }
        },
        GetRunGroup: {
          http: {
            method: "GET",
            requestUri: "/runGroup/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              id: {},
              name: {},
              maxCpus: {
                type: "integer"
              },
              maxRuns: {
                type: "integer"
              },
              maxDuration: {
                type: "integer"
              },
              creationTime: {
                shape: "S7g"
              },
              tags: {
                shape: "Sx"
              },
              maxGpus: {
                type: "integer"
              }
            }
          },
          endpoint: {
            hostPrefix: "workflows-"
          }
        },
        GetRunTask: {
          http: {
            method: "GET",
            requestUri: "/run/{id}/task/{taskId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id",
              "taskId"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              taskId: {
                location: "uri",
                locationName: "taskId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskId: {},
              status: {},
              name: {},
              cpus: {
                type: "integer"
              },
              memory: {
                type: "integer"
              },
              creationTime: {
                shape: "S7p"
              },
              startTime: {
                shape: "S7p"
              },
              stopTime: {
                shape: "S7p"
              },
              statusMessage: {},
              logStream: {},
              gpus: {
                type: "integer"
              },
              instanceType: {},
              failureReason: {}
            }
          },
          endpoint: {
            hostPrefix: "workflows-"
          }
        },
        GetSequenceStore: {
          http: {
            method: "GET",
            requestUri: "/sequencestore/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "arn",
              "creationTime"
            ],
            members: {
              id: {},
              arn: {},
              name: {},
              description: {},
              sseConfig: {
                shape: "S11"
              },
              creationTime: {
                shape: "S1x"
              },
              fallbackLocation: {}
            }
          },
          endpoint: {
            hostPrefix: "control-storage-"
          }
        },
        GetShare: {
          http: {
            method: "GET",
            requestUri: "/share/{shareId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "shareId"
            ],
            members: {
              shareId: {
                location: "uri",
                locationName: "shareId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              share: {
                shape: "S7z"
              }
            }
          },
          endpoint: {
            hostPrefix: "analytics-"
          }
        },
        GetVariantImportJob: {
          http: {
            method: "GET",
            requestUri: "/import/variant/{jobId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "destinationName",
              "roleArn",
              "status",
              "statusMessage",
              "creationTime",
              "updateTime",
              "items",
              "runLeftNormalization"
            ],
            members: {
              id: {},
              destinationName: {},
              roleArn: {},
              status: {},
              statusMessage: {},
              creationTime: {
                shape: "S1h"
              },
              updateTime: {
                shape: "S3z"
              },
              completionTime: {
                shape: "S40"
              },
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "source",
                    "jobStatus"
                  ],
                  members: {
                    source: {},
                    jobStatus: {},
                    statusMessage: {}
                  }
                }
              },
              runLeftNormalization: {
                type: "boolean"
              },
              annotationFields: {
                shape: "S4i"
              }
            }
          },
          endpoint: {
            hostPrefix: "analytics-"
          }
        },
        GetVariantStore: {
          http: {
            method: "GET",
            requestUri: "/variantStore/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "reference",
              "status",
              "storeArn",
              "name",
              "description",
              "sseConfig",
              "creationTime",
              "updateTime",
              "tags",
              "statusMessage",
              "storeSizeBytes"
            ],
            members: {
              id: {},
              reference: {
                shape: "St"
              },
              status: {},
              storeArn: {},
              name: {},
              description: {},
              sseConfig: {
                shape: "S11"
              },
              creationTime: {
                shape: "S1h"
              },
              updateTime: {
                shape: "S3z"
              },
              tags: {
                shape: "Sx"
              },
              statusMessage: {},
              storeSizeBytes: {
                type: "long"
              }
            }
          },
          endpoint: {
            hostPrefix: "analytics-"
          }
        },
        GetWorkflow: {
          http: {
            method: "GET",
            requestUri: "/workflow/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              type: {
                location: "querystring",
                locationName: "type"
              },
              export: {
                location: "querystring",
                locationName: "export",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              id: {},
              status: {},
              type: {},
              name: {},
              description: {},
              engine: {},
              definition: {},
              main: {},
              digest: {},
              parameterTemplate: {
                shape: "S2w"
              },
              storageCapacity: {
                type: "integer"
              },
              creationTime: {
                shape: "S8b"
              },
              statusMessage: {},
              tags: {
                shape: "Sx"
              },
              metadata: {
                shape: "S8d"
              },
              accelerators: {}
            }
          },
          endpoint: {
            hostPrefix: "workflows-"
          }
        },
        ListAnnotationImportJobs: {
          http: {
            requestUri: "/import/annotations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              ids: {
                type: "list",
                member: {}
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              filter: {
                type: "structure",
                members: {
                  status: {},
                  storeName: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              annotationImportJobs: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "destinationName",
                    "versionName",
                    "roleArn",
                    "status",
                    "creationTime",
                    "updateTime"
                  ],
                  members: {
                    id: {},
                    destinationName: {},
                    versionName: {},
                    roleArn: {},
                    status: {},
                    creationTime: {
                      shape: "S1h"
                    },
                    updateTime: {
                      shape: "S3z"
                    },
                    completionTime: {
                      shape: "S40"
                    },
                    runLeftNormalization: {
                      type: "boolean"
                    },
                    annotationFields: {
                      shape: "S4i"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "analytics-"
          }
        },
        ListAnnotationStoreVersions: {
          http: {
            requestUri: "/annotationStore/{name}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              filter: {
                type: "structure",
                members: {
                  status: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              annotationStoreVersions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "storeId",
                    "id",
                    "status",
                    "versionArn",
                    "name",
                    "versionName",
                    "description",
                    "creationTime",
                    "updateTime",
                    "statusMessage",
                    "versionSizeBytes"
                  ],
                  members: {
                    storeId: {},
                    id: {},
                    status: {},
                    versionArn: {},
                    name: {},
                    versionName: {},
                    description: {},
                    creationTime: {
                      shape: "S1h"
                    },
                    updateTime: {
                      shape: "S3z"
                    },
                    statusMessage: {},
                    versionSizeBytes: {
                      type: "long"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "analytics-"
          }
        },
        ListAnnotationStores: {
          http: {
            requestUri: "/annotationStores",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ids: {
                type: "list",
                member: {}
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              filter: {
                type: "structure",
                members: {
                  status: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              annotationStores: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "reference",
                    "status",
                    "storeArn",
                    "name",
                    "storeFormat",
                    "description",
                    "sseConfig",
                    "creationTime",
                    "updateTime",
                    "statusMessage",
                    "storeSizeBytes"
                  ],
                  members: {
                    id: {},
                    reference: {
                      shape: "St"
                    },
                    status: {},
                    storeArn: {},
                    name: {},
                    storeFormat: {},
                    description: {},
                    sseConfig: {
                      shape: "S11"
                    },
                    creationTime: {
                      shape: "S1h"
                    },
                    updateTime: {
                      shape: "S3z"
                    },
                    statusMessage: {},
                    storeSizeBytes: {
                      type: "long"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "analytics-"
          }
        },
        ListMultipartReadSetUploads: {
          http: {
            requestUri: "/sequencestore/{sequenceStoreId}/uploads",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sequenceStoreId"
            ],
            members: {
              sequenceStoreId: {
                location: "uri",
                locationName: "sequenceStoreId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              uploads: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "sequenceStoreId",
                    "uploadId",
                    "sourceFileType",
                    "subjectId",
                    "sampleId",
                    "generatedFrom",
                    "referenceArn",
                    "creationTime"
                  ],
                  members: {
                    sequenceStoreId: {},
                    uploadId: {},
                    sourceFileType: {},
                    subjectId: {},
                    sampleId: {},
                    generatedFrom: {},
                    referenceArn: {},
                    name: {},
                    description: {},
                    tags: {
                      shape: "Sx"
                    },
                    creationTime: {
                      shape: "S1x"
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "control-storage-"
          }
        },
        ListReadSetActivationJobs: {
          http: {
            requestUri: "/sequencestore/{sequenceStoreId}/activationjobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sequenceStoreId"
            ],
            members: {
              sequenceStoreId: {
                location: "uri",
                locationName: "sequenceStoreId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              filter: {
                type: "structure",
                members: {
                  status: {},
                  createdAfter: {
                    shape: "S1x"
                  },
                  createdBefore: {
                    shape: "S1x"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              activationJobs: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "sequenceStoreId",
                    "status",
                    "creationTime"
                  ],
                  members: {
                    id: {},
                    sequenceStoreId: {},
                    status: {},
                    creationTime: {
                      shape: "S1x"
                    },
                    completionTime: {
                      shape: "S1x"
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "control-storage-"
          }
        },
        ListReadSetExportJobs: {
          http: {
            requestUri: "/sequencestore/{sequenceStoreId}/exportjobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sequenceStoreId"
            ],
            members: {
              sequenceStoreId: {
                location: "uri",
                locationName: "sequenceStoreId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              filter: {
                type: "structure",
                members: {
                  status: {},
                  createdAfter: {
                    shape: "S1x"
                  },
                  createdBefore: {
                    shape: "S1x"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              exportJobs: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "sequenceStoreId",
                    "destination",
                    "status",
                    "creationTime"
                  ],
                  members: {
                    id: {},
                    sequenceStoreId: {},
                    destination: {},
                    status: {},
                    creationTime: {
                      shape: "S1x"
                    },
                    completionTime: {
                      shape: "S1x"
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "control-storage-"
          }
        },
        ListReadSetImportJobs: {
          http: {
            requestUri: "/sequencestore/{sequenceStoreId}/importjobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sequenceStoreId"
            ],
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              sequenceStoreId: {
                location: "uri",
                locationName: "sequenceStoreId"
              },
              filter: {
                type: "structure",
                members: {
                  status: {},
                  createdAfter: {
                    shape: "S1x"
                  },
                  createdBefore: {
                    shape: "S1x"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              importJobs: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "sequenceStoreId",
                    "roleArn",
                    "status",
                    "creationTime"
                  ],
                  members: {
                    id: {},
                    sequenceStoreId: {},
                    roleArn: {},
                    status: {},
                    creationTime: {
                      shape: "S1x"
                    },
                    completionTime: {
                      shape: "S1x"
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "control-storage-"
          }
        },
        ListReadSetUploadParts: {
          http: {
            requestUri: "/sequencestore/{sequenceStoreId}/upload/{uploadId}/parts",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sequenceStoreId",
              "uploadId",
              "partSource"
            ],
            members: {
              sequenceStoreId: {
                location: "uri",
                locationName: "sequenceStoreId"
              },
              uploadId: {
                location: "uri",
                locationName: "uploadId"
              },
              partSource: {},
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              filter: {
                type: "structure",
                members: {
                  createdAfter: {
                    shape: "S1x"
                  },
                  createdBefore: {
                    shape: "S1x"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              parts: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "partNumber",
                    "partSize",
                    "partSource",
                    "checksum"
                  ],
                  members: {
                    partNumber: {
                      type: "integer"
                    },
                    partSize: {
                      type: "long"
                    },
                    partSource: {},
                    checksum: {},
                    creationTime: {
                      shape: "S1x"
                    },
                    lastUpdatedTime: {
                      shape: "S1x"
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "control-storage-"
          }
        },
        ListReadSets: {
          http: {
            requestUri: "/sequencestore/{sequenceStoreId}/readsets",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sequenceStoreId"
            ],
            members: {
              sequenceStoreId: {
                location: "uri",
                locationName: "sequenceStoreId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              filter: {
                type: "structure",
                members: {
                  name: {},
                  status: {},
                  referenceArn: {},
                  createdAfter: {
                    shape: "S1x"
                  },
                  createdBefore: {
                    shape: "S1x"
                  },
                  sampleId: {},
                  subjectId: {},
                  generatedFrom: {},
                  creationType: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "readSets"
            ],
            members: {
              nextToken: {},
              readSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "arn",
                    "sequenceStoreId",
                    "status",
                    "fileType",
                    "creationTime"
                  ],
                  members: {
                    id: {},
                    arn: {},
                    sequenceStoreId: {},
                    subjectId: {},
                    sampleId: {},
                    status: {},
                    name: {},
                    description: {},
                    referenceArn: {},
                    fileType: {},
                    sequenceInformation: {
                      shape: "S5p"
                    },
                    creationTime: {
                      shape: "S1x"
                    },
                    statusMessage: {},
                    creationType: {},
                    etag: {
                      shape: "S5x"
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "control-storage-"
          }
        },
        ListReferenceImportJobs: {
          http: {
            requestUri: "/referencestore/{referenceStoreId}/importjobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "referenceStoreId"
            ],
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              referenceStoreId: {
                location: "uri",
                locationName: "referenceStoreId"
              },
              filter: {
                type: "structure",
                members: {
                  status: {},
                  createdAfter: {
                    shape: "S1x"
                  },
                  createdBefore: {
                    shape: "S1x"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              importJobs: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "referenceStoreId",
                    "roleArn",
                    "status",
                    "creationTime"
                  ],
                  members: {
                    id: {},
                    referenceStoreId: {},
                    roleArn: {},
                    status: {},
                    creationTime: {
                      shape: "S1x"
                    },
                    completionTime: {
                      shape: "S1x"
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "control-storage-"
          }
        },
        ListReferenceStores: {
          http: {
            requestUri: "/referencestores",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              filter: {
                type: "structure",
                members: {
                  name: {},
                  createdAfter: {
                    shape: "S1x"
                  },
                  createdBefore: {
                    shape: "S1x"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "referenceStores"
            ],
            members: {
              nextToken: {},
              referenceStores: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "id",
                    "creationTime"
                  ],
                  members: {
                    arn: {},
                    id: {},
                    name: {},
                    description: {},
                    sseConfig: {
                      shape: "S11"
                    },
                    creationTime: {
                      shape: "S1x"
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "control-storage-"
          }
        },
        ListReferences: {
          http: {
            requestUri: "/referencestore/{referenceStoreId}/references",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "referenceStoreId"
            ],
            members: {
              referenceStoreId: {
                location: "uri",
                locationName: "referenceStoreId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              filter: {
                type: "structure",
                members: {
                  name: {},
                  md5: {},
                  createdAfter: {
                    shape: "S1x"
                  },
                  createdBefore: {
                    shape: "S1x"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "references"
            ],
            members: {
              nextToken: {},
              references: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "arn",
                    "referenceStoreId",
                    "md5",
                    "creationTime",
                    "updateTime"
                  ],
                  members: {
                    id: {},
                    arn: {},
                    referenceStoreId: {},
                    md5: {},
                    status: {},
                    name: {},
                    description: {},
                    creationTime: {
                      shape: "S1x"
                    },
                    updateTime: {
                      shape: "S1x"
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "control-storage-"
          }
        },
        ListRunGroups: {
          http: {
            method: "GET",
            requestUri: "/runGroup",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              name: {
                location: "querystring",
                locationName: "name"
              },
              startingToken: {
                location: "querystring",
                locationName: "startingToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    id: {},
                    name: {},
                    maxCpus: {
                      type: "integer"
                    },
                    maxRuns: {
                      type: "integer"
                    },
                    maxDuration: {
                      type: "integer"
                    },
                    creationTime: {
                      shape: "S7g"
                    },
                    maxGpus: {
                      type: "integer"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "workflows-"
          }
        },
        ListRunTasks: {
          http: {
            method: "GET",
            requestUri: "/run/{id}/task",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              status: {
                location: "querystring",
                locationName: "status"
              },
              startingToken: {
                location: "querystring",
                locationName: "startingToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    taskId: {},
                    status: {},
                    name: {},
                    cpus: {
                      type: "integer"
                    },
                    memory: {
                      type: "integer"
                    },
                    creationTime: {
                      shape: "S7p"
                    },
                    startTime: {
                      shape: "S7p"
                    },
                    stopTime: {
                      shape: "S7p"
                    },
                    gpus: {
                      type: "integer"
                    },
                    instanceType: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "workflows-"
          }
        },
        ListRuns: {
          http: {
            method: "GET",
            requestUri: "/run",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              name: {
                location: "querystring",
                locationName: "name"
              },
              runGroupId: {
                location: "querystring",
                locationName: "runGroupId"
              },
              startingToken: {
                location: "querystring",
                locationName: "startingToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              status: {
                location: "querystring",
                locationName: "status"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    id: {},
                    status: {},
                    workflowId: {},
                    name: {},
                    priority: {
                      type: "integer"
                    },
                    storageCapacity: {
                      type: "integer"
                    },
                    creationTime: {
                      shape: "S73"
                    },
                    startTime: {
                      shape: "S73"
                    },
                    stopTime: {
                      shape: "S73"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "workflows-"
          }
        },
        ListSequenceStores: {
          http: {
            requestUri: "/sequencestores",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              filter: {
                type: "structure",
                members: {
                  name: {},
                  createdAfter: {
                    shape: "S1x"
                  },
                  createdBefore: {
                    shape: "S1x"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "sequenceStores"
            ],
            members: {
              nextToken: {},
              sequenceStores: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "id",
                    "creationTime"
                  ],
                  members: {
                    arn: {},
                    id: {},
                    name: {},
                    description: {},
                    sseConfig: {
                      shape: "S11"
                    },
                    creationTime: {
                      shape: "S1x"
                    },
                    fallbackLocation: {}
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "control-storage-"
          }
        },
        ListShares: {
          http: {
            requestUri: "/shares",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceOwner"
            ],
            members: {
              resourceOwner: {},
              filter: {
                type: "structure",
                members: {
                  resourceArns: {
                    type: "list",
                    member: {}
                  },
                  status: {
                    type: "list",
                    member: {}
                  }
                }
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "shares"
            ],
            members: {
              shares: {
                type: "list",
                member: {
                  shape: "S7z"
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "analytics-"
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "tags"
            ],
            members: {
              tags: {
                shape: "Sx"
              }
            }
          },
          endpoint: {
            hostPrefix: "tags-"
          }
        },
        ListVariantImportJobs: {
          http: {
            requestUri: "/import/variants",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              ids: {
                type: "list",
                member: {}
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              filter: {
                type: "structure",
                members: {
                  status: {},
                  storeName: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              variantImportJobs: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "destinationName",
                    "roleArn",
                    "status",
                    "creationTime",
                    "updateTime"
                  ],
                  members: {
                    id: {},
                    destinationName: {},
                    roleArn: {},
                    status: {},
                    creationTime: {
                      shape: "S1h"
                    },
                    updateTime: {
                      shape: "S3z"
                    },
                    completionTime: {
                      shape: "S40"
                    },
                    runLeftNormalization: {
                      type: "boolean"
                    },
                    annotationFields: {
                      shape: "S4i"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "analytics-"
          }
        },
        ListVariantStores: {
          http: {
            requestUri: "/variantStores",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              ids: {
                type: "list",
                member: {}
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              filter: {
                type: "structure",
                members: {
                  status: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              variantStores: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "reference",
                    "status",
                    "storeArn",
                    "name",
                    "description",
                    "sseConfig",
                    "creationTime",
                    "updateTime",
                    "statusMessage",
                    "storeSizeBytes"
                  ],
                  members: {
                    id: {},
                    reference: {
                      shape: "St"
                    },
                    status: {},
                    storeArn: {},
                    name: {},
                    description: {},
                    sseConfig: {
                      shape: "S11"
                    },
                    creationTime: {
                      shape: "S1h"
                    },
                    updateTime: {
                      shape: "S3z"
                    },
                    statusMessage: {},
                    storeSizeBytes: {
                      type: "long"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "analytics-"
          }
        },
        ListWorkflows: {
          http: {
            method: "GET",
            requestUri: "/workflow",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              type: {
                location: "querystring",
                locationName: "type"
              },
              name: {
                location: "querystring",
                locationName: "name"
              },
              startingToken: {
                location: "querystring",
                locationName: "startingToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    id: {},
                    name: {},
                    status: {},
                    type: {},
                    digest: {},
                    creationTime: {
                      shape: "S8b"
                    },
                    metadata: {
                      shape: "S8d"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "workflows-"
          }
        },
        StartAnnotationImportJob: {
          http: {
            requestUri: "/import/annotation",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "destinationName",
              "roleArn",
              "items"
            ],
            members: {
              destinationName: {},
              roleArn: {},
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "source"
                  ],
                  members: {
                    source: {}
                  }
                }
              },
              versionName: {},
              formatOptions: {
                shape: "S45"
              },
              runLeftNormalization: {
                type: "boolean"
              },
              annotationFields: {
                shape: "S4i"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {}
            }
          },
          endpoint: {
            hostPrefix: "analytics-"
          }
        },
        StartReadSetActivationJob: {
          http: {
            requestUri: "/sequencestore/{sequenceStoreId}/activationjob",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sequenceStoreId",
              "sources"
            ],
            members: {
              sequenceStoreId: {
                location: "uri",
                locationName: "sequenceStoreId"
              },
              clientToken: {},
              sources: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "readSetId"
                  ],
                  members: {
                    readSetId: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "sequenceStoreId",
              "status",
              "creationTime"
            ],
            members: {
              id: {},
              sequenceStoreId: {},
              status: {},
              creationTime: {
                shape: "S1x"
              }
            }
          },
          endpoint: {
            hostPrefix: "control-storage-"
          }
        },
        StartReadSetExportJob: {
          http: {
            requestUri: "/sequencestore/{sequenceStoreId}/exportjob",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sequenceStoreId",
              "destination",
              "roleArn",
              "sources"
            ],
            members: {
              sequenceStoreId: {
                location: "uri",
                locationName: "sequenceStoreId"
              },
              destination: {},
              roleArn: {},
              clientToken: {},
              sources: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "readSetId"
                  ],
                  members: {
                    readSetId: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "sequenceStoreId",
              "destination",
              "status",
              "creationTime"
            ],
            members: {
              id: {},
              sequenceStoreId: {},
              destination: {},
              status: {},
              creationTime: {
                shape: "S1x"
              }
            }
          },
          endpoint: {
            hostPrefix: "control-storage-"
          }
        },
        StartReadSetImportJob: {
          http: {
            requestUri: "/sequencestore/{sequenceStoreId}/importjob",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sequenceStoreId",
              "roleArn",
              "sources"
            ],
            members: {
              sequenceStoreId: {
                location: "uri",
                locationName: "sequenceStoreId"
              },
              roleArn: {},
              clientToken: {},
              sources: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "sourceFiles",
                    "sourceFileType",
                    "subjectId",
                    "sampleId"
                  ],
                  members: {
                    sourceFiles: {
                      shape: "S5j"
                    },
                    sourceFileType: {},
                    subjectId: {},
                    sampleId: {},
                    generatedFrom: {},
                    referenceArn: {},
                    name: {},
                    description: {},
                    tags: {
                      shape: "Sx"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "sequenceStoreId",
              "roleArn",
              "status",
              "creationTime"
            ],
            members: {
              id: {},
              sequenceStoreId: {},
              roleArn: {},
              status: {},
              creationTime: {
                shape: "S1x"
              }
            }
          },
          endpoint: {
            hostPrefix: "control-storage-"
          }
        },
        StartReferenceImportJob: {
          http: {
            requestUri: "/referencestore/{referenceStoreId}/importjob",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "referenceStoreId",
              "roleArn",
              "sources"
            ],
            members: {
              referenceStoreId: {
                location: "uri",
                locationName: "referenceStoreId"
              },
              roleArn: {},
              clientToken: {},
              sources: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "sourceFile",
                    "name"
                  ],
                  members: {
                    sourceFile: {},
                    name: {},
                    description: {},
                    tags: {
                      shape: "Sx"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "referenceStoreId",
              "roleArn",
              "status",
              "creationTime"
            ],
            members: {
              id: {},
              referenceStoreId: {},
              roleArn: {},
              status: {},
              creationTime: {
                shape: "S1x"
              }
            }
          },
          endpoint: {
            hostPrefix: "control-storage-"
          }
        },
        StartRun: {
          http: {
            requestUri: "/run",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "roleArn",
              "requestId"
            ],
            members: {
              workflowId: {},
              workflowType: {},
              runId: {},
              roleArn: {},
              name: {},
              runGroupId: {},
              priority: {
                type: "integer"
              },
              parameters: {
                shape: "S6v"
              },
              storageCapacity: {
                type: "integer"
              },
              outputUri: {},
              logLevel: {},
              tags: {
                shape: "Sx"
              },
              requestId: {
                idempotencyToken: true
              },
              retentionMode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              id: {},
              status: {},
              tags: {
                shape: "Sx"
              },
              uuid: {},
              runOutputUri: {}
            }
          },
          endpoint: {
            hostPrefix: "workflows-"
          }
        },
        StartVariantImportJob: {
          http: {
            requestUri: "/import/variant",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "destinationName",
              "roleArn",
              "items"
            ],
            members: {
              destinationName: {},
              roleArn: {},
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "source"
                  ],
                  members: {
                    source: {}
                  }
                }
              },
              runLeftNormalization: {
                type: "boolean"
              },
              annotationFields: {
                shape: "S4i"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {}
            }
          },
          endpoint: {
            hostPrefix: "analytics-"
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                type: "map",
                key: {},
                value: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "tags-"
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "tags-"
          },
          idempotent: true
        },
        UpdateAnnotationStore: {
          http: {
            requestUri: "/annotationStore/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              description: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "reference",
              "status",
              "name",
              "description",
              "creationTime",
              "updateTime"
            ],
            members: {
              id: {},
              reference: {
                shape: "St"
              },
              status: {},
              name: {},
              description: {},
              creationTime: {
                shape: "S1h"
              },
              updateTime: {
                shape: "S3z"
              },
              storeOptions: {
                shape: "S15"
              },
              storeFormat: {}
            }
          },
          endpoint: {
            hostPrefix: "analytics-"
          }
        },
        UpdateAnnotationStoreVersion: {
          http: {
            requestUri: "/annotationStore/{name}/version/{versionName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "versionName"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              versionName: {
                location: "uri",
                locationName: "versionName"
              },
              description: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "storeId",
              "id",
              "status",
              "name",
              "versionName",
              "description",
              "creationTime",
              "updateTime"
            ],
            members: {
              storeId: {},
              id: {},
              status: {},
              name: {},
              versionName: {},
              description: {},
              creationTime: {
                shape: "S1h"
              },
              updateTime: {
                shape: "S3z"
              }
            }
          },
          endpoint: {
            hostPrefix: "analytics-"
          }
        },
        UpdateRunGroup: {
          http: {
            requestUri: "/runGroup/{id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              name: {},
              maxCpus: {
                type: "integer"
              },
              maxRuns: {
                type: "integer"
              },
              maxDuration: {
                type: "integer"
              },
              maxGpus: {
                type: "integer"
              }
            }
          },
          endpoint: {
            hostPrefix: "workflows-"
          }
        },
        UpdateVariantStore: {
          http: {
            requestUri: "/variantStore/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              description: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "reference",
              "status",
              "name",
              "description",
              "creationTime",
              "updateTime"
            ],
            members: {
              id: {},
              reference: {
                shape: "St"
              },
              status: {},
              name: {},
              description: {},
              creationTime: {
                shape: "S1h"
              },
              updateTime: {
                shape: "S3z"
              }
            }
          },
          endpoint: {
            hostPrefix: "analytics-"
          }
        },
        UpdateWorkflow: {
          http: {
            requestUri: "/workflow/{id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              name: {},
              description: {}
            }
          },
          endpoint: {
            hostPrefix: "workflows-"
          }
        },
        UploadReadSetPart: {
          http: {
            method: "PUT",
            requestUri: "/sequencestore/{sequenceStoreId}/upload/{uploadId}/part",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sequenceStoreId",
              "uploadId",
              "partSource",
              "partNumber",
              "payload"
            ],
            members: {
              sequenceStoreId: {
                location: "uri",
                locationName: "sequenceStoreId"
              },
              uploadId: {
                location: "uri",
                locationName: "uploadId"
              },
              partSource: {
                location: "querystring",
                locationName: "partSource"
              },
              partNumber: {
                location: "querystring",
                locationName: "partNumber",
                type: "integer"
              },
              payload: {
                type: "blob",
                requiresLength: true,
                streaming: true
              }
            },
            payload: "payload"
          },
          output: {
            type: "structure",
            required: [
              "checksum"
            ],
            members: {
              checksum: {}
            }
          },
          authtype: "v4-unsigned-body",
          endpoint: {
            hostPrefix: "storage-"
          }
        }
      },
      shapes: {
        St: {
          type: "structure",
          members: {
            referenceArn: {}
          },
          union: true
        },
        Sx: {
          type: "map",
          key: {},
          value: {}
        },
        S11: {
          type: "structure",
          required: [
            "type"
          ],
          members: {
            type: {},
            keyArn: {}
          }
        },
        S15: {
          type: "structure",
          members: {
            tsvStoreOptions: {
              type: "structure",
              members: {
                annotationType: {},
                formatToHeader: {
                  shape: "S18"
                },
                schema: {
                  type: "list",
                  member: {
                    shape: "S1c"
                  }
                }
              }
            }
          },
          union: true
        },
        S18: {
          type: "map",
          key: {},
          value: {}
        },
        S1c: {
          type: "map",
          key: {},
          value: {}
        },
        S1h: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S1j: {
          type: "structure",
          members: {
            tsvVersionOptions: {
              type: "structure",
              members: {
                annotationType: {},
                formatToHeader: {
                  shape: "S18"
                },
                schema: {
                  type: "list",
                  member: {
                    shape: "S1c"
                  }
                }
              }
            }
          },
          union: true
        },
        S1x: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S2w: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              description: {},
              optional: {
                type: "boolean"
              }
            }
          }
        },
        S3z: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S40: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S45: {
          type: "structure",
          members: {
            tsvOptions: {
              type: "structure",
              members: {
                readOptions: {
                  type: "structure",
                  members: {
                    sep: {},
                    encoding: {},
                    quote: {},
                    quoteAll: {
                      type: "boolean"
                    },
                    escape: {},
                    escapeQuotes: {
                      type: "boolean"
                    },
                    comment: {},
                    header: {
                      type: "boolean"
                    },
                    lineSep: {}
                  }
                }
              }
            },
            vcfOptions: {
              type: "structure",
              members: {
                ignoreQualField: {
                  type: "boolean"
                },
                ignoreFilterField: {
                  type: "boolean"
                }
              }
            }
          },
          union: true
        },
        S4i: {
          type: "map",
          key: {},
          value: {}
        },
        S5j: {
          type: "structure",
          required: [
            "source1"
          ],
          members: {
            source1: {},
            source2: {}
          }
        },
        S5p: {
          type: "structure",
          members: {
            totalReadCount: {
              type: "long"
            },
            totalBaseCount: {
              type: "long"
            },
            generatedFrom: {},
            alignment: {}
          }
        },
        S5r: {
          type: "structure",
          members: {
            totalParts: {
              type: "integer"
            },
            partSize: {
              type: "long"
            },
            contentLength: {
              type: "long"
            }
          }
        },
        S5x: {
          type: "structure",
          members: {
            algorithm: {},
            source1: {},
            source2: {}
          }
        },
        S6v: {
          type: "structure",
          members: {},
          document: true
        },
        S73: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S7g: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S7p: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S7z: {
          type: "structure",
          members: {
            shareId: {},
            resourceArn: {},
            principalSubscriber: {},
            ownerId: {},
            status: {},
            statusMessage: {},
            shareName: {},
            creationTime: {
              shape: "S1h"
            },
            updateTime: {
              shape: "S3z"
            }
          }
        },
        S8b: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S8d: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/omics-2022-11-28.paginators.json
var require_omics_2022_11_28_paginators = __commonJS({
  "node_modules/aws-sdk/apis/omics-2022-11-28.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAnnotationImportJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "annotationImportJobs"
        },
        ListAnnotationStoreVersions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "annotationStoreVersions"
        },
        ListAnnotationStores: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "annotationStores"
        },
        ListMultipartReadSetUploads: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "uploads"
        },
        ListReadSetActivationJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "activationJobs"
        },
        ListReadSetExportJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "exportJobs"
        },
        ListReadSetImportJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "importJobs"
        },
        ListReadSetUploadParts: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "parts"
        },
        ListReadSets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "readSets"
        },
        ListReferenceImportJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "importJobs"
        },
        ListReferenceStores: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "referenceStores"
        },
        ListReferences: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "references"
        },
        ListRunGroups: {
          input_token: "startingToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListRunTasks: {
          input_token: "startingToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListRuns: {
          input_token: "startingToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListSequenceStores: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "sequenceStores"
        },
        ListShares: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "shares"
        },
        ListVariantImportJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "variantImportJobs"
        },
        ListVariantStores: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "variantStores"
        },
        ListWorkflows: {
          input_token: "startingToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/omics-2022-11-28.waiters2.json
var require_omics_2022_11_28_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/omics-2022-11-28.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        AnnotationImportJobCreated: {
          description: "Wait until an annotation import is completed",
          delay: 30,
          maxAttempts: 20,
          operation: "GetAnnotationImportJob",
          acceptors: [{
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "SUBMITTED"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "IN_PROGRESS"
          }, {
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "FAILED"
          }, {
            matcher: "path",
            argument: "status",
            state: "success",
            expected: "CANCELLED"
          }, {
            matcher: "path",
            argument: "status",
            state: "success",
            expected: "COMPLETED"
          }]
        },
        AnnotationStoreCreated: {
          description: "Wait until an annotation store is created",
          delay: 30,
          maxAttempts: 20,
          operation: "GetAnnotationStore",
          acceptors: [{
            matcher: "path",
            argument: "status",
            state: "success",
            expected: "ACTIVE"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "CREATING"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "UPDATING"
          }, {
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "FAILED"
          }]
        },
        AnnotationStoreDeleted: {
          description: "Wait until an annotation store is deleted.",
          delay: 30,
          maxAttempts: 20,
          operation: "GetAnnotationStore",
          acceptors: [{
            matcher: "path",
            argument: "status",
            state: "success",
            expected: "DELETED"
          }, {
            matcher: "error",
            state: "success",
            expected: "ResourceNotFoundException"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "DELETING"
          }]
        },
        AnnotationStoreVersionCreated: {
          description: "Wait until an annotation store version is created",
          delay: 30,
          maxAttempts: 20,
          operation: "GetAnnotationStoreVersion",
          acceptors: [{
            matcher: "path",
            argument: "status",
            state: "success",
            expected: "ACTIVE"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "CREATING"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "UPDATING"
          }, {
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "FAILED"
          }]
        },
        AnnotationStoreVersionDeleted: {
          description: "Wait until an annotation store version is deleted.",
          delay: 30,
          maxAttempts: 20,
          operation: "GetAnnotationStoreVersion",
          acceptors: [{
            matcher: "path",
            argument: "status",
            state: "success",
            expected: "DELETED"
          }, {
            matcher: "error",
            state: "success",
            expected: "ResourceNotFoundException"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "DELETING"
          }]
        },
        ReadSetActivationJobCompleted: {
          description: "Wait until a job is completed.",
          delay: 30,
          maxAttempts: 20,
          operation: "GetReadSetActivationJob",
          acceptors: [{
            matcher: "path",
            argument: "status",
            state: "success",
            expected: "COMPLETED"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "SUBMITTED"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "IN_PROGRESS"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "CANCELLING"
          }, {
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "CANCELLED"
          }, {
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "FAILED"
          }, {
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "COMPLETED_WITH_FAILURES"
          }]
        },
        ReadSetExportJobCompleted: {
          description: "Wait until a job is completed.",
          delay: 30,
          maxAttempts: 20,
          operation: "GetReadSetExportJob",
          acceptors: [{
            matcher: "path",
            argument: "status",
            state: "success",
            expected: "COMPLETED"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "SUBMITTED"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "IN_PROGRESS"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "CANCELLING"
          }, {
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "CANCELLED"
          }, {
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "FAILED"
          }, {
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "COMPLETED_WITH_FAILURES"
          }]
        },
        ReadSetImportJobCompleted: {
          description: "Wait until a job is completed.",
          delay: 30,
          maxAttempts: 20,
          operation: "GetReadSetImportJob",
          acceptors: [{
            matcher: "path",
            argument: "status",
            state: "success",
            expected: "COMPLETED"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "SUBMITTED"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "IN_PROGRESS"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "CANCELLING"
          }, {
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "CANCELLED"
          }, {
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "FAILED"
          }, {
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "COMPLETED_WITH_FAILURES"
          }]
        },
        ReferenceImportJobCompleted: {
          description: "Wait until a job is completed.",
          delay: 30,
          maxAttempts: 20,
          operation: "GetReferenceImportJob",
          acceptors: [{
            matcher: "path",
            argument: "status",
            state: "success",
            expected: "COMPLETED"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "SUBMITTED"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "IN_PROGRESS"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "CANCELLING"
          }, {
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "CANCELLED"
          }, {
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "FAILED"
          }, {
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "COMPLETED_WITH_FAILURES"
          }]
        },
        RunCompleted: {
          description: "Wait until a run is completed.",
          delay: 30,
          maxAttempts: 20,
          operation: "GetRun",
          acceptors: [{
            matcher: "path",
            argument: "status",
            state: "success",
            expected: "COMPLETED"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "PENDING"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "STARTING"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "RUNNING"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "STOPPING"
          }, {
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "FAILED"
          }]
        },
        RunRunning: {
          description: "Wait until a run is running.",
          delay: 30,
          maxAttempts: 20,
          operation: "GetRun",
          acceptors: [{
            matcher: "path",
            argument: "status",
            state: "success",
            expected: "RUNNING"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "PENDING"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "STARTING"
          }, {
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "FAILED"
          }, {
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "CANCELLED"
          }]
        },
        TaskCompleted: {
          description: "Wait until a task is completed.",
          delay: 30,
          maxAttempts: 20,
          operation: "GetRunTask",
          acceptors: [{
            matcher: "path",
            argument: "status",
            state: "success",
            expected: "COMPLETED"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "PENDING"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "STARTING"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "RUNNING"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "STOPPING"
          }, {
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "FAILED"
          }]
        },
        TaskRunning: {
          description: "Wait until a task is running.",
          delay: 30,
          maxAttempts: 20,
          operation: "GetRunTask",
          acceptors: [{
            matcher: "path",
            argument: "status",
            state: "success",
            expected: "RUNNING"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "PENDING"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "STARTING"
          }, {
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "FAILED"
          }, {
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "CANCELLED"
          }]
        },
        VariantImportJobCreated: {
          description: "Wait until variant import is completed",
          delay: 30,
          maxAttempts: 20,
          operation: "GetVariantImportJob",
          acceptors: [{
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "SUBMITTED"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "IN_PROGRESS"
          }, {
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "FAILED"
          }, {
            matcher: "path",
            argument: "status",
            state: "success",
            expected: "CANCELLED"
          }, {
            matcher: "path",
            argument: "status",
            state: "success",
            expected: "COMPLETED"
          }]
        },
        VariantStoreCreated: {
          description: "Wait until a variant store is created",
          delay: 30,
          maxAttempts: 20,
          operation: "GetVariantStore",
          acceptors: [{
            matcher: "path",
            argument: "status",
            state: "success",
            expected: "ACTIVE"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "CREATING"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "UPDATING"
          }, {
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "FAILED"
          }]
        },
        VariantStoreDeleted: {
          description: "Wait until a variant store is deleted.",
          delay: 30,
          maxAttempts: 20,
          operation: "GetVariantStore",
          acceptors: [{
            matcher: "path",
            argument: "status",
            state: "success",
            expected: "DELETED"
          }, {
            matcher: "error",
            state: "success",
            expected: "ResourceNotFoundException"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "DELETING"
          }]
        },
        WorkflowActive: {
          description: "Wait until a workflow is active.",
          delay: 3,
          maxAttempts: 10,
          operation: "GetWorkflow",
          acceptors: [{
            matcher: "path",
            argument: "status",
            state: "success",
            expected: "ACTIVE"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "CREATING"
          }, {
            matcher: "path",
            argument: "status",
            state: "retry",
            expected: "UPDATING"
          }, {
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "FAILED"
          }]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/omics.js
var require_omics = __commonJS({
  "node_modules/aws-sdk/clients/omics.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["omics"] = {};
    AWS2.Omics = Service.defineService("omics", ["2022-11-28"]);
    Object.defineProperty(apiLoader.services["omics"], "2022-11-28", {
      get: function get() {
        var model = require_omics_2022_11_28_min();
        model.paginators = require_omics_2022_11_28_paginators().pagination;
        model.waiters = require_omics_2022_11_28_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Omics;
  }
});

// node_modules/aws-sdk/apis/opensearchserverless-2021-11-01.min.json
var require_opensearchserverless_2021_11_01_min = __commonJS({
  "node_modules/aws-sdk/apis/opensearchserverless-2021-11-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-11-01",
        endpointPrefix: "aoss",
        jsonVersion: "1.0",
        protocol: "json",
        serviceFullName: "OpenSearch Service Serverless",
        serviceId: "OpenSearchServerless",
        signatureVersion: "v4",
        signingName: "aoss",
        targetPrefix: "OpenSearchServerless",
        uid: "opensearchserverless-2021-11-01"
      },
      operations: {
        BatchGetCollection: {
          input: {
            type: "structure",
            members: {
              ids: {
                type: "list",
                member: {}
              },
              names: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              collectionDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    collectionEndpoint: {},
                    createdDate: {
                      type: "long"
                    },
                    dashboardEndpoint: {},
                    description: {},
                    id: {},
                    kmsKeyArn: {},
                    lastModifiedDate: {
                      type: "long"
                    },
                    name: {},
                    standbyReplicas: {},
                    status: {},
                    type: {}
                  }
                }
              },
              collectionErrorDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    errorCode: {},
                    errorMessage: {},
                    id: {},
                    name: {}
                  }
                }
              }
            }
          }
        },
        BatchGetEffectiveLifecyclePolicy: {
          input: {
            type: "structure",
            required: [
              "resourceIdentifiers"
            ],
            members: {
              resourceIdentifiers: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "resource",
                    "type"
                  ],
                  members: {
                    resource: {},
                    type: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              effectiveLifecyclePolicyDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    noMinRetentionPeriod: {
                      type: "boolean"
                    },
                    policyName: {},
                    resource: {},
                    resourceType: {},
                    retentionPeriod: {},
                    type: {}
                  }
                }
              },
              effectiveLifecyclePolicyErrorDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    errorCode: {},
                    errorMessage: {},
                    resource: {},
                    type: {}
                  }
                }
              }
            }
          }
        },
        BatchGetLifecyclePolicy: {
          input: {
            type: "structure",
            required: [
              "identifiers"
            ],
            members: {
              identifiers: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "type"
                  ],
                  members: {
                    name: {},
                    type: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              lifecyclePolicyDetails: {
                type: "list",
                member: {
                  shape: "Sz"
                }
              },
              lifecyclePolicyErrorDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    errorCode: {},
                    errorMessage: {},
                    name: {},
                    type: {}
                  }
                }
              }
            }
          }
        },
        BatchGetVpcEndpoint: {
          input: {
            type: "structure",
            required: [
              "ids"
            ],
            members: {
              ids: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              vpcEndpointDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    createdDate: {
                      type: "long"
                    },
                    id: {},
                    name: {},
                    securityGroupIds: {
                      shape: "S1c"
                    },
                    status: {},
                    subnetIds: {
                      shape: "S1f"
                    },
                    vpcId: {}
                  }
                }
              },
              vpcEndpointErrorDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    errorCode: {},
                    errorMessage: {},
                    id: {}
                  }
                }
              }
            }
          }
        },
        CreateAccessPolicy: {
          input: {
            type: "structure",
            required: [
              "name",
              "policy",
              "type"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              description: {},
              name: {},
              policy: {},
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              accessPolicyDetail: {
                shape: "S1p"
              }
            }
          },
          idempotent: true
        },
        CreateCollection: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              description: {},
              name: {},
              standbyReplicas: {},
              tags: {
                shape: "S1s"
              },
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              createCollectionDetail: {
                type: "structure",
                members: {
                  arn: {},
                  createdDate: {
                    type: "long"
                  },
                  description: {},
                  id: {},
                  kmsKeyArn: {},
                  lastModifiedDate: {
                    type: "long"
                  },
                  name: {},
                  standbyReplicas: {},
                  status: {},
                  type: {}
                }
              }
            }
          },
          idempotent: true
        },
        CreateLifecyclePolicy: {
          input: {
            type: "structure",
            required: [
              "name",
              "policy",
              "type"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              description: {},
              name: {},
              policy: {},
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              lifecyclePolicyDetail: {
                shape: "Sz"
              }
            }
          },
          idempotent: true
        },
        CreateSecurityConfig: {
          input: {
            type: "structure",
            required: [
              "name",
              "type"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              description: {},
              name: {},
              samlOptions: {
                shape: "S23"
              },
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              securityConfigDetail: {
                shape: "S2a"
              }
            }
          },
          idempotent: true
        },
        CreateSecurityPolicy: {
          input: {
            type: "structure",
            required: [
              "name",
              "policy",
              "type"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              description: {},
              name: {},
              policy: {},
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              securityPolicyDetail: {
                shape: "S2f"
              }
            }
          },
          idempotent: true
        },
        CreateVpcEndpoint: {
          input: {
            type: "structure",
            required: [
              "name",
              "subnetIds",
              "vpcId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              name: {},
              securityGroupIds: {
                shape: "S1c"
              },
              subnetIds: {
                shape: "S1f"
              },
              vpcId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              createVpcEndpointDetail: {
                type: "structure",
                members: {
                  id: {},
                  name: {},
                  status: {}
                }
              }
            }
          },
          idempotent: true
        },
        DeleteAccessPolicy: {
          input: {
            type: "structure",
            required: [
              "name",
              "type"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              name: {},
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteCollection: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deleteCollectionDetail: {
                type: "structure",
                members: {
                  id: {},
                  name: {},
                  status: {}
                }
              }
            }
          },
          idempotent: true
        },
        DeleteLifecyclePolicy: {
          input: {
            type: "structure",
            required: [
              "name",
              "type"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              name: {},
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteSecurityConfig: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteSecurityPolicy: {
          input: {
            type: "structure",
            required: [
              "name",
              "type"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              name: {},
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteVpcEndpoint: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deleteVpcEndpointDetail: {
                type: "structure",
                members: {
                  id: {},
                  name: {},
                  status: {}
                }
              }
            }
          },
          idempotent: true
        },
        GetAccessPolicy: {
          input: {
            type: "structure",
            required: [
              "name",
              "type"
            ],
            members: {
              name: {},
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              accessPolicyDetail: {
                shape: "S1p"
              }
            }
          }
        },
        GetAccountSettings: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              accountSettingsDetail: {
                shape: "S31"
              }
            }
          }
        },
        GetPoliciesStats: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              AccessPolicyStats: {
                type: "structure",
                members: {
                  DataPolicyCount: {
                    type: "long"
                  }
                }
              },
              LifecyclePolicyStats: {
                type: "structure",
                members: {
                  RetentionPolicyCount: {
                    type: "long"
                  }
                }
              },
              SecurityConfigStats: {
                type: "structure",
                members: {
                  SamlConfigCount: {
                    type: "long"
                  }
                }
              },
              SecurityPolicyStats: {
                type: "structure",
                members: {
                  EncryptionPolicyCount: {
                    type: "long"
                  },
                  NetworkPolicyCount: {
                    type: "long"
                  }
                }
              },
              TotalPolicyCount: {
                type: "long"
              }
            }
          }
        },
        GetSecurityConfig: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              securityConfigDetail: {
                shape: "S2a"
              }
            }
          }
        },
        GetSecurityPolicy: {
          input: {
            type: "structure",
            required: [
              "name",
              "type"
            ],
            members: {
              name: {},
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              securityPolicyDetail: {
                shape: "S2f"
              }
            }
          }
        },
        ListAccessPolicies: {
          input: {
            type: "structure",
            required: [
              "type"
            ],
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              resource: {
                type: "list",
                member: {}
              },
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              accessPolicySummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    createdDate: {
                      type: "long"
                    },
                    description: {},
                    lastModifiedDate: {
                      type: "long"
                    },
                    name: {},
                    policyVersion: {},
                    type: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListCollections: {
          input: {
            type: "structure",
            members: {
              collectionFilters: {
                type: "structure",
                members: {
                  name: {},
                  status: {}
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              collectionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    id: {},
                    name: {},
                    status: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListLifecyclePolicies: {
          input: {
            type: "structure",
            required: [
              "type"
            ],
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              resources: {
                type: "list",
                member: {}
              },
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              lifecyclePolicySummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    createdDate: {
                      type: "long"
                    },
                    description: {},
                    lastModifiedDate: {
                      type: "long"
                    },
                    name: {},
                    policyVersion: {},
                    type: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSecurityConfigs: {
          input: {
            type: "structure",
            required: [
              "type"
            ],
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              securityConfigSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    configVersion: {},
                    createdDate: {
                      type: "long"
                    },
                    description: {},
                    id: {},
                    lastModifiedDate: {
                      type: "long"
                    },
                    type: {}
                  }
                }
              }
            }
          }
        },
        ListSecurityPolicies: {
          input: {
            type: "structure",
            required: [
              "type"
            ],
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              resource: {
                type: "list",
                member: {}
              },
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              securityPolicySummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    createdDate: {
                      type: "long"
                    },
                    description: {},
                    lastModifiedDate: {
                      type: "long"
                    },
                    name: {},
                    policyVersion: {},
                    type: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S1s"
              }
            }
          }
        },
        ListVpcEndpoints: {
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              vpcEndpointFilters: {
                type: "structure",
                members: {
                  status: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              vpcEndpointSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    name: {},
                    status: {}
                  }
                }
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "S1s"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAccessPolicy: {
          input: {
            type: "structure",
            required: [
              "name",
              "policyVersion",
              "type"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              description: {},
              name: {},
              policy: {},
              policyVersion: {},
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              accessPolicyDetail: {
                shape: "S1p"
              }
            }
          },
          idempotent: true
        },
        UpdateAccountSettings: {
          input: {
            type: "structure",
            members: {
              capacityLimits: {
                shape: "S32"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              accountSettingsDetail: {
                shape: "S31"
              }
            }
          }
        },
        UpdateCollection: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              description: {},
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              updateCollectionDetail: {
                type: "structure",
                members: {
                  arn: {},
                  createdDate: {
                    type: "long"
                  },
                  description: {},
                  id: {},
                  lastModifiedDate: {
                    type: "long"
                  },
                  name: {},
                  status: {},
                  type: {}
                }
              }
            }
          },
          idempotent: true
        },
        UpdateLifecyclePolicy: {
          input: {
            type: "structure",
            required: [
              "name",
              "policyVersion",
              "type"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              description: {},
              name: {},
              policy: {},
              policyVersion: {},
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              lifecyclePolicyDetail: {
                shape: "Sz"
              }
            }
          },
          idempotent: true
        },
        UpdateSecurityConfig: {
          input: {
            type: "structure",
            required: [
              "configVersion",
              "id"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              configVersion: {},
              description: {},
              id: {},
              samlOptions: {
                shape: "S23"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              securityConfigDetail: {
                shape: "S2a"
              }
            }
          },
          idempotent: true
        },
        UpdateSecurityPolicy: {
          input: {
            type: "structure",
            required: [
              "name",
              "policyVersion",
              "type"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              description: {},
              name: {},
              policy: {},
              policyVersion: {},
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              securityPolicyDetail: {
                shape: "S2f"
              }
            }
          },
          idempotent: true
        },
        UpdateVpcEndpoint: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              addSecurityGroupIds: {
                shape: "S1c"
              },
              addSubnetIds: {
                shape: "S1f"
              },
              clientToken: {
                idempotencyToken: true
              },
              id: {},
              removeSecurityGroupIds: {
                shape: "S1c"
              },
              removeSubnetIds: {
                shape: "S1f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UpdateVpcEndpointDetail: {
                type: "structure",
                members: {
                  id: {},
                  lastModifiedDate: {
                    type: "long"
                  },
                  name: {},
                  securityGroupIds: {
                    shape: "S1c"
                  },
                  status: {},
                  subnetIds: {
                    shape: "S1f"
                  }
                }
              }
            }
          },
          idempotent: true
        }
      },
      shapes: {
        Sz: {
          type: "structure",
          members: {
            createdDate: {
              type: "long"
            },
            description: {},
            lastModifiedDate: {
              type: "long"
            },
            name: {},
            policy: {
              shape: "S11"
            },
            policyVersion: {},
            type: {}
          }
        },
        S11: {
          type: "structure",
          members: {},
          document: true
        },
        S1c: {
          type: "list",
          member: {}
        },
        S1f: {
          type: "list",
          member: {}
        },
        S1p: {
          type: "structure",
          members: {
            createdDate: {
              type: "long"
            },
            description: {},
            lastModifiedDate: {
              type: "long"
            },
            name: {},
            policy: {
              shape: "S11"
            },
            policyVersion: {},
            type: {}
          }
        },
        S1s: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        S23: {
          type: "structure",
          required: [
            "metadata"
          ],
          members: {
            groupAttribute: {},
            metadata: {},
            sessionTimeout: {
              type: "integer"
            },
            userAttribute: {}
          }
        },
        S2a: {
          type: "structure",
          members: {
            configVersion: {},
            createdDate: {
              type: "long"
            },
            description: {},
            id: {},
            lastModifiedDate: {
              type: "long"
            },
            samlOptions: {
              shape: "S23"
            },
            type: {}
          }
        },
        S2f: {
          type: "structure",
          members: {
            createdDate: {
              type: "long"
            },
            description: {},
            lastModifiedDate: {
              type: "long"
            },
            name: {},
            policy: {
              shape: "S11"
            },
            policyVersion: {},
            type: {}
          }
        },
        S31: {
          type: "structure",
          members: {
            capacityLimits: {
              shape: "S32"
            }
          }
        },
        S32: {
          type: "structure",
          members: {
            maxIndexingCapacityInOCU: {
              type: "integer"
            },
            maxSearchCapacityInOCU: {
              type: "integer"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/opensearchserverless-2021-11-01.paginators.json
var require_opensearchserverless_2021_11_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/opensearchserverless-2021-11-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAccessPolicies: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListCollections: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListLifecyclePolicies: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListSecurityConfigs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListSecurityPolicies: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListVpcEndpoints: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/opensearchserverless.js
var require_opensearchserverless = __commonJS({
  "node_modules/aws-sdk/clients/opensearchserverless.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["opensearchserverless"] = {};
    AWS2.OpenSearchServerless = Service.defineService("opensearchserverless", ["2021-11-01"]);
    Object.defineProperty(apiLoader.services["opensearchserverless"], "2021-11-01", {
      get: function get() {
        var model = require_opensearchserverless_2021_11_01_min();
        model.paginators = require_opensearchserverless_2021_11_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.OpenSearchServerless;
  }
});

// node_modules/aws-sdk/apis/securitylake-2018-05-10.min.json
var require_securitylake_2018_05_10_min = __commonJS({
  "node_modules/aws-sdk/apis/securitylake-2018-05-10.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-05-10",
        endpointPrefix: "securitylake",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Security Lake",
        serviceId: "SecurityLake",
        signatureVersion: "v4",
        signingName: "securitylake",
        uid: "securitylake-2018-05-10"
      },
      operations: {
        CreateAwsLogSource: {
          http: {
            requestUri: "/v1/datalake/logsources/aws",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sources"
            ],
            members: {
              sources: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              failed: {
                shape: "S4"
              }
            }
          }
        },
        CreateCustomLogSource: {
          http: {
            requestUri: "/v1/datalake/logsources/custom",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceName"
            ],
            members: {
              configuration: {
                type: "structure",
                required: [
                  "crawlerConfiguration",
                  "providerIdentity"
                ],
                members: {
                  crawlerConfiguration: {
                    type: "structure",
                    required: [
                      "roleArn"
                    ],
                    members: {
                      roleArn: {}
                    }
                  },
                  providerIdentity: {
                    shape: "Sf"
                  }
                }
              },
              eventClasses: {
                shape: "Si"
              },
              sourceName: {},
              sourceVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              source: {
                shape: "Sn"
              }
            }
          },
          idempotent: true
        },
        CreateDataLake: {
          http: {
            requestUri: "/v1/datalake",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "configurations",
              "metaStoreManagerRoleArn"
            ],
            members: {
              configurations: {
                shape: "St"
              },
              metaStoreManagerRoleArn: {},
              tags: {
                shape: "S15"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              dataLakes: {
                shape: "S1a"
              }
            }
          }
        },
        CreateDataLakeExceptionSubscription: {
          http: {
            requestUri: "/v1/datalake/exceptions/subscription",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "notificationEndpoint",
              "subscriptionProtocol"
            ],
            members: {
              exceptionTimeToLive: {
                type: "long"
              },
              notificationEndpoint: {},
              subscriptionProtocol: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateDataLakeOrganizationConfiguration: {
          http: {
            requestUri: "/v1/datalake/organization/configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "autoEnableNewAccount"
            ],
            members: {
              autoEnableNewAccount: {
                shape: "S1m"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateSubscriber: {
          http: {
            requestUri: "/v1/subscribers",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sources",
              "subscriberIdentity",
              "subscriberName"
            ],
            members: {
              accessTypes: {
                shape: "S1s"
              },
              sources: {
                shape: "S1u"
              },
              subscriberDescription: {},
              subscriberIdentity: {
                shape: "Sf"
              },
              subscriberName: {},
              tags: {
                shape: "S15"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              subscriber: {
                shape: "S1z"
              }
            }
          }
        },
        CreateSubscriberNotification: {
          http: {
            requestUri: "/v1/subscribers/{subscriberId}/notification",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "configuration",
              "subscriberId"
            ],
            members: {
              configuration: {
                shape: "S26"
              },
              subscriberId: {
                location: "uri",
                locationName: "subscriberId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              subscriberEndpoint: {}
            }
          }
        },
        DeleteAwsLogSource: {
          http: {
            requestUri: "/v1/datalake/logsources/aws/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sources"
            ],
            members: {
              sources: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              failed: {
                shape: "S4"
              }
            }
          }
        },
        DeleteCustomLogSource: {
          http: {
            method: "DELETE",
            requestUri: "/v1/datalake/logsources/custom/{sourceName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceName"
            ],
            members: {
              sourceName: {
                location: "uri",
                locationName: "sourceName"
              },
              sourceVersion: {
                location: "querystring",
                locationName: "sourceVersion"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteDataLake: {
          http: {
            requestUri: "/v1/datalake/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "regions"
            ],
            members: {
              regions: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteDataLakeExceptionSubscription: {
          http: {
            method: "DELETE",
            requestUri: "/v1/datalake/exceptions/subscription",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteDataLakeOrganizationConfiguration: {
          http: {
            requestUri: "/v1/datalake/organization/configuration/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "autoEnableNewAccount"
            ],
            members: {
              autoEnableNewAccount: {
                shape: "S1m"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSubscriber: {
          http: {
            method: "DELETE",
            requestUri: "/v1/subscribers/{subscriberId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "subscriberId"
            ],
            members: {
              subscriberId: {
                location: "uri",
                locationName: "subscriberId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteSubscriberNotification: {
          http: {
            method: "DELETE",
            requestUri: "/v1/subscribers/{subscriberId}/notification",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "subscriberId"
            ],
            members: {
              subscriberId: {
                location: "uri",
                locationName: "subscriberId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeregisterDataLakeDelegatedAdministrator: {
          http: {
            method: "DELETE",
            requestUri: "/v1/datalake/delegate",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        GetDataLakeExceptionSubscription: {
          http: {
            method: "GET",
            requestUri: "/v1/datalake/exceptions/subscription",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              exceptionTimeToLive: {
                type: "long"
              },
              notificationEndpoint: {},
              subscriptionProtocol: {}
            }
          }
        },
        GetDataLakeOrganizationConfiguration: {
          http: {
            method: "GET",
            requestUri: "/v1/datalake/organization/configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              autoEnableNewAccount: {
                shape: "S1m"
              }
            }
          }
        },
        GetDataLakeSources: {
          http: {
            requestUri: "/v1/datalake/sources",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              accounts: {
                shape: "S4"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              dataLakeArn: {},
              dataLakeSources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    account: {},
                    eventClasses: {
                      shape: "Si"
                    },
                    sourceName: {},
                    sourceStatuses: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          resource: {},
                          status: {}
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetSubscriber: {
          http: {
            method: "GET",
            requestUri: "/v1/subscribers/{subscriberId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "subscriberId"
            ],
            members: {
              subscriberId: {
                location: "uri",
                locationName: "subscriberId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              subscriber: {
                shape: "S1z"
              }
            }
          }
        },
        ListDataLakeExceptions: {
          http: {
            requestUri: "/v1/datalake/exceptions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              regions: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              exceptions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    exception: {},
                    region: {},
                    remediation: {},
                    timestamp: {
                      shape: "S20"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDataLakes: {
          http: {
            method: "GET",
            requestUri: "/v1/datalakes",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              regions: {
                shape: "S6",
                location: "querystring",
                locationName: "regions"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              dataLakes: {
                shape: "S1a"
              }
            }
          }
        },
        ListLogSources: {
          http: {
            requestUri: "/v1/datalake/logsources/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              accounts: {
                shape: "S4"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              regions: {
                shape: "S6"
              },
              sources: {
                shape: "S1u"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              sources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    account: {},
                    region: {},
                    sources: {
                      shape: "S1u"
                    }
                  }
                }
              }
            }
          }
        },
        ListSubscribers: {
          http: {
            method: "GET",
            requestUri: "/v1/subscribers",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              subscribers: {
                type: "list",
                member: {
                  shape: "S1z"
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/v1/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S15"
              }
            }
          }
        },
        RegisterDataLakeDelegatedAdministrator: {
          http: {
            requestUri: "/v1/datalake/delegate",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "accountId"
            ],
            members: {
              accountId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            requestUri: "/v1/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S15"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/v1/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateDataLake: {
          http: {
            method: "PUT",
            requestUri: "/v1/datalake",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "configurations"
            ],
            members: {
              configurations: {
                shape: "St"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              dataLakes: {
                shape: "S1a"
              }
            }
          },
          idempotent: true
        },
        UpdateDataLakeExceptionSubscription: {
          http: {
            method: "PUT",
            requestUri: "/v1/datalake/exceptions/subscription",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "notificationEndpoint",
              "subscriptionProtocol"
            ],
            members: {
              exceptionTimeToLive: {
                type: "long"
              },
              notificationEndpoint: {},
              subscriptionProtocol: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateSubscriber: {
          http: {
            method: "PUT",
            requestUri: "/v1/subscribers/{subscriberId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "subscriberId"
            ],
            members: {
              sources: {
                shape: "S1u"
              },
              subscriberDescription: {},
              subscriberId: {
                location: "uri",
                locationName: "subscriberId"
              },
              subscriberIdentity: {
                shape: "Sf"
              },
              subscriberName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              subscriber: {
                shape: "S1z"
              }
            }
          },
          idempotent: true
        },
        UpdateSubscriberNotification: {
          http: {
            method: "PUT",
            requestUri: "/v1/subscribers/{subscriberId}/notification",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "configuration",
              "subscriberId"
            ],
            members: {
              configuration: {
                shape: "S26"
              },
              subscriberId: {
                location: "uri",
                locationName: "subscriberId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              subscriberEndpoint: {}
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S2: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "regions",
              "sourceName"
            ],
            members: {
              accounts: {
                shape: "S4"
              },
              regions: {
                shape: "S6"
              },
              sourceName: {},
              sourceVersion: {}
            }
          }
        },
        S4: {
          type: "list",
          member: {}
        },
        S6: {
          type: "list",
          member: {}
        },
        Sf: {
          type: "structure",
          required: [
            "externalId",
            "principal"
          ],
          members: {
            externalId: {},
            principal: {}
          }
        },
        Si: {
          type: "list",
          member: {}
        },
        Sn: {
          type: "structure",
          members: {
            attributes: {
              type: "structure",
              members: {
                crawlerArn: {},
                databaseArn: {},
                tableArn: {}
              }
            },
            provider: {
              type: "structure",
              members: {
                location: {},
                roleArn: {}
              }
            },
            sourceName: {},
            sourceVersion: {}
          }
        },
        St: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "region"
            ],
            members: {
              encryptionConfiguration: {
                shape: "Sv"
              },
              lifecycleConfiguration: {
                shape: "Sx"
              },
              region: {},
              replicationConfiguration: {
                shape: "S14"
              }
            }
          }
        },
        Sv: {
          type: "structure",
          members: {
            kmsKeyId: {}
          }
        },
        Sx: {
          type: "structure",
          members: {
            expiration: {
              type: "structure",
              members: {
                days: {
                  type: "integer"
                }
              }
            },
            transitions: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  days: {
                    type: "integer"
                  },
                  storageClass: {}
                }
              }
            }
          }
        },
        S14: {
          type: "structure",
          members: {
            regions: {
              shape: "S6"
            },
            roleArn: {}
          }
        },
        S15: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        S1a: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "dataLakeArn",
              "region"
            ],
            members: {
              createStatus: {},
              dataLakeArn: {},
              encryptionConfiguration: {
                shape: "Sv"
              },
              lifecycleConfiguration: {
                shape: "Sx"
              },
              region: {},
              replicationConfiguration: {
                shape: "S14"
              },
              s3BucketArn: {},
              updateStatus: {
                type: "structure",
                members: {
                  exception: {
                    type: "structure",
                    members: {
                      code: {},
                      reason: {}
                    }
                  },
                  requestId: {},
                  status: {}
                }
              }
            }
          }
        },
        S1m: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "region",
              "sources"
            ],
            members: {
              region: {},
              sources: {
                type: "list",
                member: {
                  shape: "S1p"
                }
              }
            }
          }
        },
        S1p: {
          type: "structure",
          members: {
            sourceName: {},
            sourceVersion: {}
          }
        },
        S1s: {
          type: "list",
          member: {}
        },
        S1u: {
          type: "list",
          member: {
            type: "structure",
            members: {
              awsLogSource: {
                shape: "S1p"
              },
              customLogSource: {
                shape: "Sn"
              }
            },
            union: true
          }
        },
        S1z: {
          type: "structure",
          required: [
            "sources",
            "subscriberArn",
            "subscriberId",
            "subscriberIdentity",
            "subscriberName"
          ],
          members: {
            accessTypes: {
              shape: "S1s"
            },
            createdAt: {
              shape: "S20"
            },
            resourceShareArn: {},
            resourceShareName: {},
            roleArn: {},
            s3BucketArn: {},
            sources: {
              shape: "S1u"
            },
            subscriberArn: {},
            subscriberDescription: {},
            subscriberEndpoint: {},
            subscriberId: {},
            subscriberIdentity: {
              shape: "Sf"
            },
            subscriberName: {},
            subscriberStatus: {},
            updatedAt: {
              shape: "S20"
            }
          }
        },
        S20: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S26: {
          type: "structure",
          members: {
            httpsNotificationConfiguration: {
              type: "structure",
              required: [
                "endpoint",
                "targetRoleArn"
              ],
              members: {
                authorizationApiKeyName: {},
                authorizationApiKeyValue: {},
                endpoint: {},
                httpMethod: {},
                targetRoleArn: {}
              }
            },
            sqsNotificationConfiguration: {
              type: "structure",
              members: {}
            }
          },
          union: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/securitylake-2018-05-10.paginators.json
var require_securitylake_2018_05_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/securitylake-2018-05-10.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetDataLakeSources: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "dataLakeSources"
        },
        ListDataLakeExceptions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "exceptions"
        },
        ListLogSources: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "sources"
        },
        ListSubscribers: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "subscribers"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/securitylake.js
var require_securitylake = __commonJS({
  "node_modules/aws-sdk/clients/securitylake.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["securitylake"] = {};
    AWS2.SecurityLake = Service.defineService("securitylake", ["2018-05-10"]);
    Object.defineProperty(apiLoader.services["securitylake"], "2018-05-10", {
      get: function get() {
        var model = require_securitylake_2018_05_10_min();
        model.paginators = require_securitylake_2018_05_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.SecurityLake;
  }
});

// node_modules/aws-sdk/apis/simspaceweaver-2022-10-28.min.json
var require_simspaceweaver_2022_10_28_min = __commonJS({
  "node_modules/aws-sdk/apis/simspaceweaver-2022-10-28.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2022-10-28",
        endpointPrefix: "simspaceweaver",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS SimSpace Weaver",
        serviceId: "SimSpaceWeaver",
        signatureVersion: "v4",
        signingName: "simspaceweaver",
        uid: "simspaceweaver-2022-10-28"
      },
      operations: {
        CreateSnapshot: {
          http: {
            requestUri: "/createsnapshot",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Destination",
              "Simulation"
            ],
            members: {
              Destination: {
                type: "structure",
                required: [
                  "BucketName"
                ],
                members: {
                  BucketName: {},
                  ObjectKeyPrefix: {}
                }
              },
              Simulation: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteApp: {
          http: {
            method: "DELETE",
            requestUri: "/deleteapp",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "App",
              "Domain",
              "Simulation"
            ],
            members: {
              App: {
                location: "querystring",
                locationName: "app"
              },
              Domain: {
                location: "querystring",
                locationName: "domain"
              },
              Simulation: {
                location: "querystring",
                locationName: "simulation"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteSimulation: {
          http: {
            method: "DELETE",
            requestUri: "/deletesimulation",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Simulation"
            ],
            members: {
              Simulation: {
                location: "querystring",
                locationName: "simulation"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DescribeApp: {
          http: {
            method: "GET",
            requestUri: "/describeapp",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "App",
              "Domain",
              "Simulation"
            ],
            members: {
              App: {
                location: "querystring",
                locationName: "app"
              },
              Domain: {
                location: "querystring",
                locationName: "domain"
              },
              Simulation: {
                location: "querystring",
                locationName: "simulation"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Description: {},
              Domain: {},
              EndpointInfo: {
                type: "structure",
                members: {
                  Address: {},
                  IngressPortMappings: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Actual: {
                          type: "integer"
                        },
                        Declared: {
                          type: "integer"
                        }
                      }
                    }
                  }
                }
              },
              LaunchOverrides: {
                shape: "Sk"
              },
              Name: {},
              Simulation: {},
              Status: {},
              TargetStatus: {}
            }
          }
        },
        DescribeSimulation: {
          http: {
            method: "GET",
            requestUri: "/describesimulation",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Simulation"
            ],
            members: {
              Simulation: {
                location: "querystring",
                locationName: "simulation"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTime: {
                type: "timestamp"
              },
              Description: {},
              ExecutionId: {},
              LiveSimulationState: {
                type: "structure",
                members: {
                  Clocks: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Status: {},
                        TargetStatus: {}
                      }
                    }
                  },
                  Domains: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Lifecycle: {},
                        Name: {}
                      }
                    }
                  }
                }
              },
              LoggingConfiguration: {
                type: "structure",
                members: {
                  Destinations: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        CloudWatchLogsLogGroup: {
                          type: "structure",
                          members: {
                            LogGroupArn: {}
                          }
                        }
                      }
                    }
                  }
                }
              },
              MaximumDuration: {},
              Name: {},
              RoleArn: {},
              SchemaError: {
                deprecated: true,
                deprecatedMessage: "SchemaError is no longer used, check StartError instead."
              },
              SchemaS3Location: {
                shape: "S19"
              },
              SnapshotS3Location: {
                shape: "S19"
              },
              StartError: {},
              Status: {},
              TargetStatus: {}
            }
          }
        },
        ListApps: {
          http: {
            method: "GET",
            requestUri: "/listapps",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Simulation"
            ],
            members: {
              Domain: {
                location: "querystring",
                locationName: "domain"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              Simulation: {
                location: "querystring",
                locationName: "simulation"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Apps: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Domain: {},
                    Name: {},
                    Simulation: {},
                    Status: {},
                    TargetStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSimulations: {
          http: {
            method: "GET",
            requestUri: "/listsimulations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Simulations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    Name: {},
                    Status: {},
                    TargetStatus: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S1o"
              }
            }
          }
        },
        StartApp: {
          http: {
            requestUri: "/startapp",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Domain",
              "Name",
              "Simulation"
            ],
            members: {
              ClientToken: {
                shape: "S1s",
                idempotencyToken: true
              },
              Description: {},
              Domain: {},
              LaunchOverrides: {
                shape: "Sk"
              },
              Name: {},
              Simulation: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Domain: {},
              Name: {},
              Simulation: {}
            }
          }
        },
        StartClock: {
          http: {
            requestUri: "/startclock",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Simulation"
            ],
            members: {
              Simulation: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartSimulation: {
          http: {
            requestUri: "/startsimulation",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "RoleArn"
            ],
            members: {
              ClientToken: {
                shape: "S1s",
                idempotencyToken: true
              },
              Description: {},
              MaximumDuration: {},
              Name: {},
              RoleArn: {},
              SchemaS3Location: {
                shape: "S19"
              },
              SnapshotS3Location: {
                shape: "S19"
              },
              Tags: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTime: {
                type: "timestamp"
              },
              ExecutionId: {}
            }
          }
        },
        StopApp: {
          http: {
            requestUri: "/stopapp",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "App",
              "Domain",
              "Simulation"
            ],
            members: {
              App: {},
              Domain: {},
              Simulation: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StopClock: {
          http: {
            requestUri: "/stopclock",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Simulation"
            ],
            members: {
              Simulation: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StopSimulation: {
          http: {
            requestUri: "/stopsimulation",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Simulation"
            ],
            members: {
              Simulation: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        Sk: {
          type: "structure",
          members: {
            LaunchCommands: {
              type: "list",
              member: {}
            }
          }
        },
        S19: {
          type: "structure",
          required: [
            "BucketName",
            "ObjectKey"
          ],
          members: {
            BucketName: {},
            ObjectKey: {}
          }
        },
        S1o: {
          type: "map",
          key: {},
          value: {}
        },
        S1s: {
          type: "string",
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/simspaceweaver-2022-10-28.paginators.json
var require_simspaceweaver_2022_10_28_paginators = __commonJS({
  "node_modules/aws-sdk/apis/simspaceweaver-2022-10-28.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListApps: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListSimulations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/simspaceweaver.js
var require_simspaceweaver = __commonJS({
  "node_modules/aws-sdk/clients/simspaceweaver.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["simspaceweaver"] = {};
    AWS2.SimSpaceWeaver = Service.defineService("simspaceweaver", ["2022-10-28"]);
    Object.defineProperty(apiLoader.services["simspaceweaver"], "2022-10-28", {
      get: function get() {
        var model = require_simspaceweaver_2022_10_28_min();
        model.paginators = require_simspaceweaver_2022_10_28_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.SimSpaceWeaver;
  }
});

// node_modules/aws-sdk/apis/docdb-elastic-2022-11-28.min.json
var require_docdb_elastic_2022_11_28_min = __commonJS({
  "node_modules/aws-sdk/apis/docdb-elastic-2022-11-28.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2022-11-28",
        endpointPrefix: "docdb-elastic",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "DocDB Elastic",
        serviceFullName: "Amazon DocumentDB Elastic Clusters",
        serviceId: "DocDB Elastic",
        signatureVersion: "v4",
        signingName: "docdb-elastic",
        uid: "docdb-elastic-2022-11-28"
      },
      operations: {
        CreateCluster: {
          http: {
            requestUri: "/cluster",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "adminUserName",
              "adminUserPassword",
              "authType",
              "clusterName",
              "shardCapacity",
              "shardCount"
            ],
            members: {
              adminUserName: {},
              adminUserPassword: {
                shape: "S3"
              },
              authType: {},
              clientToken: {
                idempotencyToken: true
              },
              clusterName: {},
              kmsKeyId: {},
              preferredMaintenanceWindow: {},
              shardCapacity: {
                type: "integer"
              },
              shardCount: {
                type: "integer"
              },
              subnetIds: {
                shape: "S6"
              },
              tags: {
                shape: "S7"
              },
              vpcSecurityGroupIds: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "cluster"
            ],
            members: {
              cluster: {
                shape: "Sb"
              }
            }
          },
          idempotent: true
        },
        CreateClusterSnapshot: {
          http: {
            requestUri: "/cluster-snapshot",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "clusterArn",
              "snapshotName"
            ],
            members: {
              clusterArn: {},
              snapshotName: {},
              tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "snapshot"
            ],
            members: {
              snapshot: {
                shape: "Sg"
              }
            }
          },
          idempotent: true
        },
        DeleteCluster: {
          http: {
            method: "DELETE",
            requestUri: "/cluster/{clusterArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "clusterArn"
            ],
            members: {
              clusterArn: {
                location: "uri",
                locationName: "clusterArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "cluster"
            ],
            members: {
              cluster: {
                shape: "Sb"
              }
            }
          },
          idempotent: true
        },
        DeleteClusterSnapshot: {
          http: {
            method: "DELETE",
            requestUri: "/cluster-snapshot/{snapshotArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "snapshotArn"
            ],
            members: {
              snapshotArn: {
                location: "uri",
                locationName: "snapshotArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "snapshot"
            ],
            members: {
              snapshot: {
                shape: "Sg"
              }
            }
          },
          idempotent: true
        },
        GetCluster: {
          http: {
            method: "GET",
            requestUri: "/cluster/{clusterArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "clusterArn"
            ],
            members: {
              clusterArn: {
                location: "uri",
                locationName: "clusterArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "cluster"
            ],
            members: {
              cluster: {
                shape: "Sb"
              }
            }
          }
        },
        GetClusterSnapshot: {
          http: {
            method: "GET",
            requestUri: "/cluster-snapshot/{snapshotArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "snapshotArn"
            ],
            members: {
              snapshotArn: {
                location: "uri",
                locationName: "snapshotArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "snapshot"
            ],
            members: {
              snapshot: {
                shape: "Sg"
              }
            }
          }
        },
        ListClusterSnapshots: {
          http: {
            method: "GET",
            requestUri: "/cluster-snapshots",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              clusterArn: {
                location: "querystring",
                locationName: "clusterArn"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              snapshots: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "clusterArn",
                    "snapshotArn",
                    "snapshotCreationTime",
                    "snapshotName",
                    "status"
                  ],
                  members: {
                    clusterArn: {},
                    snapshotArn: {},
                    snapshotCreationTime: {},
                    snapshotName: {},
                    status: {}
                  }
                }
              }
            }
          }
        },
        ListClusters: {
          http: {
            method: "GET",
            requestUri: "/clusters",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              clusters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "clusterArn",
                    "clusterName",
                    "status"
                  ],
                  members: {
                    clusterArn: {},
                    clusterName: {},
                    status: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S7"
              }
            }
          }
        },
        RestoreClusterFromSnapshot: {
          http: {
            requestUri: "/cluster-snapshot/{snapshotArn}/restore",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "snapshotArn"
            ],
            members: {
              clusterName: {},
              kmsKeyId: {},
              snapshotArn: {
                location: "uri",
                locationName: "snapshotArn"
              },
              subnetIds: {
                shape: "S6"
              },
              tags: {
                shape: "S7"
              },
              vpcSecurityGroupIds: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "cluster"
            ],
            members: {
              cluster: {
                shape: "Sb"
              }
            }
          },
          idempotent: true
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateCluster: {
          http: {
            method: "PUT",
            requestUri: "/cluster/{clusterArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "clusterArn"
            ],
            members: {
              adminUserPassword: {
                shape: "S3"
              },
              authType: {},
              clientToken: {
                idempotencyToken: true
              },
              clusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              preferredMaintenanceWindow: {},
              shardCapacity: {
                type: "integer"
              },
              shardCount: {
                type: "integer"
              },
              subnetIds: {
                shape: "S6"
              },
              vpcSecurityGroupIds: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "cluster"
            ],
            members: {
              cluster: {
                shape: "Sb"
              }
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S3: {
          type: "string",
          sensitive: true
        },
        S6: {
          type: "list",
          member: {}
        },
        S7: {
          type: "map",
          key: {},
          value: {}
        },
        Sb: {
          type: "structure",
          required: [
            "adminUserName",
            "authType",
            "clusterArn",
            "clusterEndpoint",
            "clusterName",
            "createTime",
            "kmsKeyId",
            "preferredMaintenanceWindow",
            "shardCapacity",
            "shardCount",
            "status",
            "subnetIds",
            "vpcSecurityGroupIds"
          ],
          members: {
            adminUserName: {},
            authType: {},
            clusterArn: {},
            clusterEndpoint: {},
            clusterName: {},
            createTime: {},
            kmsKeyId: {},
            preferredMaintenanceWindow: {},
            shardCapacity: {
              type: "integer"
            },
            shardCount: {
              type: "integer"
            },
            status: {},
            subnetIds: {
              shape: "S6"
            },
            vpcSecurityGroupIds: {
              shape: "S6"
            }
          }
        },
        Sg: {
          type: "structure",
          required: [
            "adminUserName",
            "clusterArn",
            "clusterCreationTime",
            "kmsKeyId",
            "snapshotArn",
            "snapshotCreationTime",
            "snapshotName",
            "status",
            "subnetIds",
            "vpcSecurityGroupIds"
          ],
          members: {
            adminUserName: {},
            clusterArn: {},
            clusterCreationTime: {},
            kmsKeyId: {},
            snapshotArn: {},
            snapshotCreationTime: {},
            snapshotName: {},
            status: {},
            subnetIds: {
              shape: "S6"
            },
            vpcSecurityGroupIds: {
              shape: "S6"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/docdb-elastic-2022-11-28.paginators.json
var require_docdb_elastic_2022_11_28_paginators = __commonJS({
  "node_modules/aws-sdk/apis/docdb-elastic-2022-11-28.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListClusterSnapshots: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "snapshots"
        },
        ListClusters: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "clusters"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/docdbelastic.js
var require_docdbelastic = __commonJS({
  "node_modules/aws-sdk/clients/docdbelastic.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["docdbelastic"] = {};
    AWS2.DocDBElastic = Service.defineService("docdbelastic", ["2022-11-28"]);
    Object.defineProperty(apiLoader.services["docdbelastic"], "2022-11-28", {
      get: function get() {
        var model = require_docdb_elastic_2022_11_28_min();
        model.paginators = require_docdb_elastic_2022_11_28_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.DocDBElastic;
  }
});

// node_modules/aws-sdk/apis/sagemaker-geospatial-2020-05-27.min.json
var require_sagemaker_geospatial_2020_05_27_min = __commonJS({
  "node_modules/aws-sdk/apis/sagemaker-geospatial-2020-05-27.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-05-27",
        endpointPrefix: "sagemaker-geospatial",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon SageMaker geospatial capabilities",
        serviceId: "SageMaker Geospatial",
        signatureVersion: "v4",
        signingName: "sagemaker-geospatial",
        uid: "sagemaker-geospatial-2020-05-27"
      },
      operations: {
        DeleteEarthObservationJob: {
          http: {
            method: "DELETE",
            requestUri: "/earth-observation-jobs/{Arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {
                location: "uri",
                locationName: "Arn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteVectorEnrichmentJob: {
          http: {
            method: "DELETE",
            requestUri: "/vector-enrichment-jobs/{Arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {
                location: "uri",
                locationName: "Arn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        ExportEarthObservationJob: {
          http: {
            requestUri: "/export-earth-observation-job",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Arn",
              "ExecutionRoleArn",
              "OutputConfig"
            ],
            members: {
              Arn: {},
              ClientToken: {
                idempotencyToken: true
              },
              ExecutionRoleArn: {},
              ExportSourceImages: {
                type: "boolean"
              },
              OutputConfig: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Arn",
              "CreationTime",
              "ExecutionRoleArn",
              "ExportStatus",
              "OutputConfig"
            ],
            members: {
              Arn: {},
              CreationTime: {
                shape: "Sg"
              },
              ExecutionRoleArn: {},
              ExportSourceImages: {
                type: "boolean"
              },
              ExportStatus: {},
              OutputConfig: {
                shape: "Sb"
              }
            }
          }
        },
        ExportVectorEnrichmentJob: {
          http: {
            requestUri: "/export-vector-enrichment-jobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Arn",
              "ExecutionRoleArn",
              "OutputConfig"
            ],
            members: {
              Arn: {},
              ClientToken: {
                idempotencyToken: true
              },
              ExecutionRoleArn: {},
              OutputConfig: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Arn",
              "CreationTime",
              "ExecutionRoleArn",
              "ExportStatus",
              "OutputConfig"
            ],
            members: {
              Arn: {},
              CreationTime: {
                shape: "Sg"
              },
              ExecutionRoleArn: {},
              ExportStatus: {},
              OutputConfig: {
                shape: "Sk"
              }
            }
          }
        },
        GetEarthObservationJob: {
          http: {
            method: "GET",
            requestUri: "/earth-observation-jobs/{Arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {
                location: "uri",
                locationName: "Arn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Arn",
              "CreationTime",
              "DurationInSeconds",
              "InputConfig",
              "JobConfig",
              "Name",
              "Status"
            ],
            members: {
              Arn: {},
              CreationTime: {
                shape: "Sg"
              },
              DurationInSeconds: {
                type: "integer"
              },
              ErrorDetails: {
                type: "structure",
                members: {
                  Message: {},
                  Type: {}
                }
              },
              ExecutionRoleArn: {},
              ExportErrorDetails: {
                type: "structure",
                members: {
                  ExportResults: {
                    shape: "Sv"
                  },
                  ExportSourceImages: {
                    shape: "Sv"
                  }
                }
              },
              ExportStatus: {},
              InputConfig: {
                shape: "Sx"
              },
              JobConfig: {
                shape: "S1n"
              },
              KmsKeyId: {},
              Name: {},
              OutputBands: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "BandName",
                    "OutputDataType"
                  ],
                  members: {
                    BandName: {},
                    OutputDataType: {}
                  }
                }
              },
              Status: {},
              Tags: {
                shape: "S2i"
              }
            }
          }
        },
        GetRasterDataCollection: {
          http: {
            method: "GET",
            requestUri: "/raster-data-collection/{Arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {
                location: "uri",
                locationName: "Arn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Arn",
              "Description",
              "DescriptionPageUrl",
              "ImageSourceBands",
              "Name",
              "SupportedFilters",
              "Type"
            ],
            members: {
              Arn: {},
              Description: {},
              DescriptionPageUrl: {},
              ImageSourceBands: {
                type: "list",
                member: {}
              },
              Name: {},
              SupportedFilters: {
                shape: "S2m"
              },
              Tags: {
                shape: "S2i"
              },
              Type: {}
            }
          }
        },
        GetTile: {
          http: {
            method: "GET",
            requestUri: "/tile/{z}/{x}/{y}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Arn",
              "ImageAssets",
              "Target",
              "x",
              "y",
              "z"
            ],
            members: {
              Arn: {
                location: "querystring",
                locationName: "Arn"
              },
              ExecutionRoleArn: {
                location: "querystring",
                locationName: "ExecutionRoleArn"
              },
              ImageAssets: {
                shape: "S1t",
                location: "querystring",
                locationName: "ImageAssets"
              },
              ImageMask: {
                location: "querystring",
                locationName: "ImageMask",
                type: "boolean"
              },
              OutputDataType: {
                location: "querystring",
                locationName: "OutputDataType"
              },
              OutputFormat: {
                location: "querystring",
                locationName: "OutputFormat"
              },
              PropertyFilters: {
                location: "querystring",
                locationName: "PropertyFilters"
              },
              Target: {
                location: "querystring",
                locationName: "Target"
              },
              TimeRangeFilter: {
                location: "querystring",
                locationName: "TimeRangeFilter"
              },
              x: {
                location: "uri",
                locationName: "x",
                type: "integer"
              },
              y: {
                location: "uri",
                locationName: "y",
                type: "integer"
              },
              z: {
                location: "uri",
                locationName: "z",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BinaryFile: {
                type: "blob",
                streaming: true
              }
            },
            payload: "BinaryFile"
          }
        },
        GetVectorEnrichmentJob: {
          http: {
            method: "GET",
            requestUri: "/vector-enrichment-jobs/{Arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {
                location: "uri",
                locationName: "Arn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Arn",
              "CreationTime",
              "DurationInSeconds",
              "ExecutionRoleArn",
              "InputConfig",
              "JobConfig",
              "Name",
              "Status",
              "Type"
            ],
            members: {
              Arn: {},
              CreationTime: {
                shape: "Sg"
              },
              DurationInSeconds: {
                type: "integer"
              },
              ErrorDetails: {
                type: "structure",
                members: {
                  ErrorMessage: {},
                  ErrorType: {}
                }
              },
              ExecutionRoleArn: {},
              ExportErrorDetails: {
                type: "structure",
                members: {
                  Message: {},
                  Type: {}
                }
              },
              ExportStatus: {},
              InputConfig: {
                shape: "S2z"
              },
              JobConfig: {
                shape: "S32"
              },
              KmsKeyId: {},
              Name: {},
              Status: {},
              Tags: {
                shape: "S2i"
              },
              Type: {}
            }
          }
        },
        ListEarthObservationJobs: {
          http: {
            requestUri: "/list-earth-observation-jobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {
                shape: "S39"
              },
              SortBy: {},
              SortOrder: {},
              StatusEquals: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "EarthObservationJobSummaries"
            ],
            members: {
              EarthObservationJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Arn",
                    "CreationTime",
                    "DurationInSeconds",
                    "Name",
                    "OperationType",
                    "Status"
                  ],
                  members: {
                    Arn: {},
                    CreationTime: {
                      shape: "Sg"
                    },
                    DurationInSeconds: {
                      type: "integer"
                    },
                    Name: {},
                    OperationType: {},
                    Status: {},
                    Tags: {
                      shape: "S2i"
                    }
                  }
                }
              },
              NextToken: {
                shape: "S39"
              }
            }
          }
        },
        ListRasterDataCollections: {
          http: {
            method: "GET",
            requestUri: "/raster-data-collections",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                shape: "S39",
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "RasterDataCollectionSummaries"
            ],
            members: {
              NextToken: {
                shape: "S39"
              },
              RasterDataCollectionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Arn",
                    "Description",
                    "Name",
                    "SupportedFilters",
                    "Type"
                  ],
                  members: {
                    Arn: {},
                    Description: {},
                    DescriptionPageUrl: {},
                    Name: {},
                    SupportedFilters: {
                      shape: "S2m"
                    },
                    Tags: {
                      shape: "S2i"
                    },
                    Type: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S2i"
              }
            }
          }
        },
        ListVectorEnrichmentJobs: {
          http: {
            requestUri: "/list-vector-enrichment-jobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {
                shape: "S39"
              },
              SortBy: {},
              SortOrder: {},
              StatusEquals: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "VectorEnrichmentJobSummaries"
            ],
            members: {
              NextToken: {
                shape: "S39"
              },
              VectorEnrichmentJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Arn",
                    "CreationTime",
                    "DurationInSeconds",
                    "Name",
                    "Status",
                    "Type"
                  ],
                  members: {
                    Arn: {},
                    CreationTime: {
                      shape: "Sg"
                    },
                    DurationInSeconds: {
                      type: "integer"
                    },
                    Name: {},
                    Status: {},
                    Tags: {
                      shape: "S2i"
                    },
                    Type: {}
                  }
                }
              }
            }
          }
        },
        SearchRasterDataCollection: {
          http: {
            requestUri: "/search-raster-data-collection",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Arn",
              "RasterDataCollectionQuery"
            ],
            members: {
              Arn: {},
              NextToken: {
                shape: "S39"
              },
              RasterDataCollectionQuery: {
                type: "structure",
                required: [
                  "TimeRangeFilter"
                ],
                members: {
                  AreaOfInterest: {
                    shape: "Sz"
                  },
                  BandFilter: {
                    shape: "S1t"
                  },
                  PropertyFilters: {
                    shape: "S18"
                  },
                  TimeRangeFilter: {
                    shape: "S3t"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ApproximateResultCount"
            ],
            members: {
              ApproximateResultCount: {
                type: "integer"
              },
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "DateTime",
                    "Geometry",
                    "Id"
                  ],
                  members: {
                    Assets: {
                      type: "map",
                      key: {},
                      value: {
                        type: "structure",
                        members: {
                          Href: {}
                        }
                      }
                    },
                    DateTime: {
                      type: "timestamp"
                    },
                    Geometry: {
                      type: "structure",
                      required: [
                        "Coordinates",
                        "Type"
                      ],
                      members: {
                        Coordinates: {
                          shape: "S13"
                        },
                        Type: {}
                      }
                    },
                    Id: {},
                    Properties: {
                      type: "structure",
                      members: {
                        EoCloudCover: {
                          type: "float"
                        },
                        LandsatCloudCoverLand: {
                          type: "float"
                        },
                        Platform: {},
                        ViewOffNadir: {
                          type: "float"
                        },
                        ViewSunAzimuth: {
                          type: "float"
                        },
                        ViewSunElevation: {
                          type: "float"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {
                shape: "S39"
              }
            }
          }
        },
        StartEarthObservationJob: {
          http: {
            requestUri: "/earth-observation-jobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ExecutionRoleArn",
              "InputConfig",
              "JobConfig",
              "Name"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              ExecutionRoleArn: {},
              InputConfig: {
                type: "structure",
                members: {
                  PreviousEarthObservationJobArn: {},
                  RasterDataCollectionQuery: {
                    type: "structure",
                    required: [
                      "RasterDataCollectionArn",
                      "TimeRangeFilter"
                    ],
                    members: {
                      AreaOfInterest: {
                        shape: "Sz"
                      },
                      PropertyFilters: {
                        shape: "S18"
                      },
                      RasterDataCollectionArn: {},
                      TimeRangeFilter: {
                        shape: "S3t"
                      }
                    }
                  }
                }
              },
              JobConfig: {
                shape: "S1n"
              },
              KmsKeyId: {},
              Name: {},
              Tags: {
                shape: "S2i"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Arn",
              "CreationTime",
              "DurationInSeconds",
              "ExecutionRoleArn",
              "JobConfig",
              "Name",
              "Status"
            ],
            members: {
              Arn: {},
              CreationTime: {
                shape: "Sg"
              },
              DurationInSeconds: {
                type: "integer"
              },
              ExecutionRoleArn: {},
              InputConfig: {
                shape: "Sx"
              },
              JobConfig: {
                shape: "S1n"
              },
              KmsKeyId: {},
              Name: {},
              Status: {},
              Tags: {
                shape: "S2i"
              }
            }
          },
          idempotent: true
        },
        StartVectorEnrichmentJob: {
          http: {
            requestUri: "/vector-enrichment-jobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ExecutionRoleArn",
              "InputConfig",
              "JobConfig",
              "Name"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              ExecutionRoleArn: {},
              InputConfig: {
                shape: "S2z"
              },
              JobConfig: {
                shape: "S32"
              },
              KmsKeyId: {},
              Name: {},
              Tags: {
                shape: "S2i"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Arn",
              "CreationTime",
              "DurationInSeconds",
              "ExecutionRoleArn",
              "InputConfig",
              "JobConfig",
              "Name",
              "Status",
              "Type"
            ],
            members: {
              Arn: {},
              CreationTime: {
                shape: "Sg"
              },
              DurationInSeconds: {
                type: "integer"
              },
              ExecutionRoleArn: {},
              InputConfig: {
                shape: "S2z"
              },
              JobConfig: {
                shape: "S32"
              },
              KmsKeyId: {},
              Name: {},
              Status: {},
              Tags: {
                shape: "S2i"
              },
              Type: {}
            }
          },
          idempotent: true
        },
        StopEarthObservationJob: {
          http: {
            requestUri: "/earth-observation-jobs/stop",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StopVectorEnrichmentJob: {
          http: {
            requestUri: "/vector-enrichment-jobs/stop",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        TagResource: {
          http: {
            method: "PUT",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "S2i"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        Sb: {
          type: "structure",
          required: [
            "S3Data"
          ],
          members: {
            S3Data: {
              type: "structure",
              required: [
                "S3Uri"
              ],
              members: {
                KmsKeyId: {},
                S3Uri: {}
              }
            }
          }
        },
        Sg: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        Sk: {
          type: "structure",
          required: [
            "S3Data"
          ],
          members: {
            S3Data: {
              shape: "Sl"
            }
          }
        },
        Sl: {
          type: "structure",
          required: [
            "S3Uri"
          ],
          members: {
            KmsKeyId: {},
            S3Uri: {}
          }
        },
        Sv: {
          type: "structure",
          members: {
            Message: {},
            Type: {}
          }
        },
        Sx: {
          type: "structure",
          members: {
            PreviousEarthObservationJobArn: {},
            RasterDataCollectionQuery: {
              type: "structure",
              required: [
                "RasterDataCollectionArn",
                "RasterDataCollectionName",
                "TimeRangeFilter"
              ],
              members: {
                AreaOfInterest: {
                  shape: "Sz"
                },
                PropertyFilters: {
                  shape: "S18"
                },
                RasterDataCollectionArn: {},
                RasterDataCollectionName: {},
                TimeRangeFilter: {
                  type: "structure",
                  required: [
                    "EndTime",
                    "StartTime"
                  ],
                  members: {
                    EndTime: {
                      shape: "Sg"
                    },
                    StartTime: {
                      shape: "Sg"
                    }
                  },
                  sensitive: true
                }
              }
            }
          }
        },
        Sz: {
          type: "structure",
          members: {
            AreaOfInterestGeometry: {
              type: "structure",
              members: {
                MultiPolygonGeometry: {
                  type: "structure",
                  required: [
                    "Coordinates"
                  ],
                  members: {
                    Coordinates: {
                      type: "list",
                      member: {
                        shape: "S13"
                      }
                    }
                  }
                },
                PolygonGeometry: {
                  type: "structure",
                  required: [
                    "Coordinates"
                  ],
                  members: {
                    Coordinates: {
                      shape: "S13"
                    }
                  }
                }
              },
              union: true
            }
          },
          union: true
        },
        S13: {
          type: "list",
          member: {
            type: "list",
            member: {
              type: "list",
              member: {
                type: "double"
              },
              sensitive: true
            }
          }
        },
        S18: {
          type: "structure",
          members: {
            LogicalOperator: {},
            Properties: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Property"
                ],
                members: {
                  Property: {
                    type: "structure",
                    members: {
                      EoCloudCover: {
                        type: "structure",
                        required: [
                          "LowerBound",
                          "UpperBound"
                        ],
                        members: {
                          LowerBound: {
                            type: "float"
                          },
                          UpperBound: {
                            type: "float"
                          }
                        }
                      },
                      LandsatCloudCoverLand: {
                        type: "structure",
                        required: [
                          "LowerBound",
                          "UpperBound"
                        ],
                        members: {
                          LowerBound: {
                            type: "float"
                          },
                          UpperBound: {
                            type: "float"
                          }
                        }
                      },
                      Platform: {
                        type: "structure",
                        required: [
                          "Value"
                        ],
                        members: {
                          ComparisonOperator: {},
                          Value: {}
                        }
                      },
                      ViewOffNadir: {
                        type: "structure",
                        required: [
                          "LowerBound",
                          "UpperBound"
                        ],
                        members: {
                          LowerBound: {
                            type: "float"
                          },
                          UpperBound: {
                            type: "float"
                          }
                        }
                      },
                      ViewSunAzimuth: {
                        type: "structure",
                        required: [
                          "LowerBound",
                          "UpperBound"
                        ],
                        members: {
                          LowerBound: {
                            type: "float"
                          },
                          UpperBound: {
                            type: "float"
                          }
                        }
                      },
                      ViewSunElevation: {
                        type: "structure",
                        required: [
                          "LowerBound",
                          "UpperBound"
                        ],
                        members: {
                          LowerBound: {
                            type: "float"
                          },
                          UpperBound: {
                            type: "float"
                          }
                        }
                      }
                    },
                    union: true
                  }
                }
              }
            }
          }
        },
        S1n: {
          type: "structure",
          members: {
            BandMathConfig: {
              type: "structure",
              members: {
                CustomIndices: {
                  type: "structure",
                  members: {
                    Operations: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "Equation",
                          "Name"
                        ],
                        members: {
                          Equation: {},
                          Name: {},
                          OutputType: {}
                        }
                      }
                    }
                  }
                },
                PredefinedIndices: {
                  shape: "S1t"
                }
              }
            },
            CloudMaskingConfig: {
              type: "structure",
              members: {}
            },
            CloudRemovalConfig: {
              type: "structure",
              members: {
                AlgorithmName: {},
                InterpolationValue: {},
                TargetBands: {
                  shape: "S1t"
                }
              }
            },
            GeoMosaicConfig: {
              type: "structure",
              members: {
                AlgorithmName: {},
                TargetBands: {
                  shape: "S1t"
                }
              }
            },
            LandCoverSegmentationConfig: {
              type: "structure",
              members: {}
            },
            ResamplingConfig: {
              type: "structure",
              required: [
                "OutputResolution"
              ],
              members: {
                AlgorithmName: {},
                OutputResolution: {
                  type: "structure",
                  required: [
                    "UserDefined"
                  ],
                  members: {
                    UserDefined: {
                      shape: "S23"
                    }
                  }
                },
                TargetBands: {
                  shape: "S1t"
                }
              }
            },
            StackConfig: {
              type: "structure",
              members: {
                OutputResolution: {
                  type: "structure",
                  members: {
                    Predefined: {},
                    UserDefined: {
                      shape: "S23"
                    }
                  }
                },
                TargetBands: {
                  shape: "S1t"
                }
              }
            },
            TemporalStatisticsConfig: {
              type: "structure",
              required: [
                "Statistics"
              ],
              members: {
                GroupBy: {},
                Statistics: {
                  type: "list",
                  member: {}
                },
                TargetBands: {
                  shape: "S1t"
                }
              }
            },
            ZonalStatisticsConfig: {
              type: "structure",
              required: [
                "Statistics",
                "ZoneS3Path"
              ],
              members: {
                Statistics: {
                  type: "list",
                  member: {}
                },
                TargetBands: {
                  shape: "S1t"
                },
                ZoneS3Path: {},
                ZoneS3PathKmsKeyId: {}
              }
            }
          },
          union: true
        },
        S1t: {
          type: "list",
          member: {}
        },
        S23: {
          type: "structure",
          required: [
            "Unit",
            "Value"
          ],
          members: {
            Unit: {},
            Value: {
              type: "float"
            }
          }
        },
        S2i: {
          type: "map",
          key: {},
          value: {}
        },
        S2m: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Type"
            ],
            members: {
              Maximum: {
                type: "float"
              },
              Minimum: {
                type: "float"
              },
              Name: {},
              Type: {}
            }
          }
        },
        S2z: {
          type: "structure",
          required: [
            "DataSourceConfig",
            "DocumentType"
          ],
          members: {
            DataSourceConfig: {
              type: "structure",
              members: {
                S3Data: {
                  shape: "Sl"
                }
              },
              union: true
            },
            DocumentType: {}
          }
        },
        S32: {
          type: "structure",
          members: {
            MapMatchingConfig: {
              type: "structure",
              required: [
                "IdAttributeName",
                "TimestampAttributeName",
                "XAttributeName",
                "YAttributeName"
              ],
              members: {
                IdAttributeName: {},
                TimestampAttributeName: {},
                XAttributeName: {},
                YAttributeName: {}
              }
            },
            ReverseGeocodingConfig: {
              type: "structure",
              required: [
                "XAttributeName",
                "YAttributeName"
              ],
              members: {
                XAttributeName: {},
                YAttributeName: {}
              }
            }
          },
          union: true
        },
        S39: {
          type: "string",
          sensitive: true
        },
        S3t: {
          type: "structure",
          required: [
            "EndTime",
            "StartTime"
          ],
          members: {
            EndTime: {
              type: "timestamp"
            },
            StartTime: {
              type: "timestamp"
            }
          },
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/sagemaker-geospatial-2020-05-27.paginators.json
var require_sagemaker_geospatial_2020_05_27_paginators = __commonJS({
  "node_modules/aws-sdk/apis/sagemaker-geospatial-2020-05-27.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListEarthObservationJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "EarthObservationJobSummaries"
        },
        ListRasterDataCollections: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "RasterDataCollectionSummaries"
        },
        ListVectorEnrichmentJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "VectorEnrichmentJobSummaries"
        },
        SearchRasterDataCollection: {
          input_token: "NextToken",
          output_token: "NextToken"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/sagemakergeospatial.js
var require_sagemakergeospatial = __commonJS({
  "node_modules/aws-sdk/clients/sagemakergeospatial.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["sagemakergeospatial"] = {};
    AWS2.SageMakerGeospatial = Service.defineService("sagemakergeospatial", ["2020-05-27"]);
    Object.defineProperty(apiLoader.services["sagemakergeospatial"], "2020-05-27", {
      get: function get() {
        var model = require_sagemaker_geospatial_2020_05_27_min();
        model.paginators = require_sagemaker_geospatial_2020_05_27_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.SageMakerGeospatial;
  }
});

// node_modules/aws-sdk/apis/codecatalyst-2022-09-28.min.json
var require_codecatalyst_2022_09_28_min = __commonJS({
  "node_modules/aws-sdk/apis/codecatalyst-2022-09-28.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2022-09-28",
        endpointPrefix: "codecatalyst",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon CodeCatalyst",
        serviceId: "CodeCatalyst",
        signatureVersion: "bearer",
        signingName: "codecatalyst",
        uid: "codecatalyst-2022-09-28"
      },
      operations: {
        CreateAccessToken: {
          http: {
            method: "PUT",
            requestUri: "/v1/accessTokens",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              expiresTime: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "secret",
              "name",
              "expiresTime",
              "accessTokenId"
            ],
            members: {
              secret: {
                type: "string",
                sensitive: true
              },
              name: {},
              expiresTime: {
                shape: "S3"
              },
              accessTokenId: {}
            }
          }
        },
        CreateDevEnvironment: {
          http: {
            method: "PUT",
            requestUri: "/v1/spaces/{spaceName}/projects/{projectName}/devEnvironments",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "spaceName",
              "projectName",
              "instanceType",
              "persistentStorage"
            ],
            members: {
              spaceName: {
                location: "uri",
                locationName: "spaceName"
              },
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              repositories: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "repositoryName"
                  ],
                  members: {
                    repositoryName: {},
                    branchName: {}
                  }
                }
              },
              clientToken: {},
              alias: {},
              ides: {
                shape: "Sf"
              },
              instanceType: {},
              inactivityTimeoutMinutes: {
                type: "integer"
              },
              persistentStorage: {
                type: "structure",
                required: [
                  "sizeInGiB"
                ],
                members: {
                  sizeInGiB: {
                    type: "integer"
                  }
                }
              },
              vpcConnectionName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "spaceName",
              "projectName",
              "id"
            ],
            members: {
              spaceName: {},
              projectName: {},
              id: {},
              vpcConnectionName: {}
            }
          },
          idempotent: true
        },
        CreateProject: {
          http: {
            method: "PUT",
            requestUri: "/v1/spaces/{spaceName}/projects",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "spaceName",
              "displayName"
            ],
            members: {
              spaceName: {
                location: "uri",
                locationName: "spaceName"
              },
              displayName: {},
              description: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              spaceName: {},
              name: {},
              displayName: {},
              description: {}
            }
          },
          idempotent: true
        },
        CreateSourceRepository: {
          http: {
            method: "PUT",
            requestUri: "/v1/spaces/{spaceName}/projects/{projectName}/sourceRepositories/{name}",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "spaceName",
              "projectName",
              "name"
            ],
            members: {
              spaceName: {
                location: "uri",
                locationName: "spaceName"
              },
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              name: {
                location: "uri",
                locationName: "name"
              },
              description: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "spaceName",
              "projectName",
              "name"
            ],
            members: {
              spaceName: {},
              projectName: {},
              name: {},
              description: {}
            }
          },
          idempotent: true
        },
        CreateSourceRepositoryBranch: {
          http: {
            method: "PUT",
            requestUri: "/v1/spaces/{spaceName}/projects/{projectName}/sourceRepositories/{sourceRepositoryName}/branches/{name}",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "spaceName",
              "projectName",
              "sourceRepositoryName",
              "name"
            ],
            members: {
              spaceName: {
                location: "uri",
                locationName: "spaceName"
              },
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              sourceRepositoryName: {
                location: "uri",
                locationName: "sourceRepositoryName"
              },
              name: {
                location: "uri",
                locationName: "name"
              },
              headCommitId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ref: {},
              name: {},
              lastUpdatedTime: {
                shape: "S3"
              },
              headCommitId: {}
            }
          },
          idempotent: true
        },
        DeleteAccessToken: {
          http: {
            method: "DELETE",
            requestUri: "/v1/accessTokens/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteDevEnvironment: {
          http: {
            method: "DELETE",
            requestUri: "/v1/spaces/{spaceName}/projects/{projectName}/devEnvironments/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "spaceName",
              "projectName",
              "id"
            ],
            members: {
              spaceName: {
                location: "uri",
                locationName: "spaceName"
              },
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "spaceName",
              "projectName",
              "id"
            ],
            members: {
              spaceName: {},
              projectName: {},
              id: {}
            }
          },
          idempotent: true
        },
        DeleteProject: {
          http: {
            method: "DELETE",
            requestUri: "/v1/spaces/{spaceName}/projects/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "spaceName",
              "name"
            ],
            members: {
              spaceName: {
                location: "uri",
                locationName: "spaceName"
              },
              name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "spaceName",
              "name"
            ],
            members: {
              spaceName: {},
              name: {},
              displayName: {}
            }
          },
          idempotent: true
        },
        DeleteSourceRepository: {
          http: {
            method: "DELETE",
            requestUri: "/v1/spaces/{spaceName}/projects/{projectName}/sourceRepositories/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "spaceName",
              "projectName",
              "name"
            ],
            members: {
              spaceName: {
                location: "uri",
                locationName: "spaceName"
              },
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "spaceName",
              "projectName",
              "name"
            ],
            members: {
              spaceName: {},
              projectName: {},
              name: {}
            }
          },
          idempotent: true
        },
        DeleteSpace: {
          http: {
            method: "DELETE",
            requestUri: "/v1/spaces/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              displayName: {}
            }
          },
          idempotent: true
        },
        GetDevEnvironment: {
          http: {
            method: "GET",
            requestUri: "/v1/spaces/{spaceName}/projects/{projectName}/devEnvironments/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "spaceName",
              "projectName",
              "id"
            ],
            members: {
              spaceName: {
                location: "uri",
                locationName: "spaceName"
              },
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "spaceName",
              "projectName",
              "id",
              "lastUpdatedTime",
              "creatorId",
              "status",
              "repositories",
              "instanceType",
              "inactivityTimeoutMinutes",
              "persistentStorage"
            ],
            members: {
              spaceName: {},
              projectName: {},
              id: {},
              lastUpdatedTime: {
                shape: "S3"
              },
              creatorId: {},
              status: {},
              statusReason: {},
              repositories: {
                shape: "S1f"
              },
              alias: {},
              ides: {
                shape: "S1i"
              },
              instanceType: {},
              inactivityTimeoutMinutes: {
                type: "integer"
              },
              persistentStorage: {
                shape: "S1m"
              },
              vpcConnectionName: {}
            }
          }
        },
        GetProject: {
          http: {
            method: "GET",
            requestUri: "/v1/spaces/{spaceName}/projects/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "spaceName",
              "name"
            ],
            members: {
              spaceName: {
                location: "uri",
                locationName: "spaceName"
              },
              name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              spaceName: {},
              name: {},
              displayName: {},
              description: {}
            }
          }
        },
        GetSourceRepository: {
          http: {
            method: "GET",
            requestUri: "/v1/spaces/{spaceName}/projects/{projectName}/sourceRepositories/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "spaceName",
              "projectName",
              "name"
            ],
            members: {
              spaceName: {
                location: "uri",
                locationName: "spaceName"
              },
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "spaceName",
              "projectName",
              "name",
              "lastUpdatedTime",
              "createdTime"
            ],
            members: {
              spaceName: {},
              projectName: {},
              name: {},
              description: {},
              lastUpdatedTime: {
                shape: "S1s"
              },
              createdTime: {
                shape: "S1s"
              }
            }
          }
        },
        GetSourceRepositoryCloneUrls: {
          http: {
            method: "GET",
            requestUri: "/v1/spaces/{spaceName}/projects/{projectName}/sourceRepositories/{sourceRepositoryName}/cloneUrls",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "spaceName",
              "projectName",
              "sourceRepositoryName"
            ],
            members: {
              spaceName: {
                location: "uri",
                locationName: "spaceName"
              },
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              sourceRepositoryName: {
                location: "uri",
                locationName: "sourceRepositoryName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "https"
            ],
            members: {
              https: {}
            }
          }
        },
        GetSpace: {
          http: {
            method: "GET",
            requestUri: "/v1/spaces/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "name",
              "regionName"
            ],
            members: {
              name: {},
              regionName: {},
              displayName: {},
              description: {}
            }
          }
        },
        GetSubscription: {
          http: {
            method: "GET",
            requestUri: "/v1/spaces/{spaceName}/subscription",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "spaceName"
            ],
            members: {
              spaceName: {
                location: "uri",
                locationName: "spaceName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              subscriptionType: {},
              awsAccountName: {}
            }
          }
        },
        GetUserDetails: {
          http: {
            method: "GET",
            requestUri: "/userDetails",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              id: {
                location: "querystring",
                locationName: "id"
              },
              userName: {
                location: "querystring",
                locationName: "userName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              userId: {},
              userName: {},
              displayName: {},
              primaryEmail: {
                type: "structure",
                members: {
                  email: {},
                  verified: {
                    type: "boolean"
                  }
                }
              },
              version: {}
            }
          }
        },
        GetWorkflow: {
          http: {
            method: "GET",
            requestUri: "/v1/spaces/{spaceName}/projects/{projectName}/workflows/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "spaceName",
              "id",
              "projectName"
            ],
            members: {
              spaceName: {
                location: "uri",
                locationName: "spaceName"
              },
              id: {
                location: "uri",
                locationName: "id"
              },
              projectName: {
                location: "uri",
                locationName: "projectName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "spaceName",
              "projectName",
              "id",
              "name",
              "definition",
              "createdTime",
              "lastUpdatedTime",
              "runMode",
              "status"
            ],
            members: {
              spaceName: {},
              projectName: {},
              id: {},
              name: {},
              sourceRepositoryName: {},
              sourceBranchName: {},
              definition: {
                type: "structure",
                required: [
                  "path"
                ],
                members: {
                  path: {}
                }
              },
              createdTime: {
                shape: "S3"
              },
              lastUpdatedTime: {
                shape: "S3"
              },
              runMode: {},
              status: {}
            }
          }
        },
        GetWorkflowRun: {
          http: {
            method: "GET",
            requestUri: "/v1/spaces/{spaceName}/projects/{projectName}/workflowRuns/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "spaceName",
              "id",
              "projectName"
            ],
            members: {
              spaceName: {
                location: "uri",
                locationName: "spaceName"
              },
              id: {
                location: "uri",
                locationName: "id"
              },
              projectName: {
                location: "uri",
                locationName: "projectName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "spaceName",
              "projectName",
              "id",
              "workflowId",
              "status",
              "startTime",
              "lastUpdatedTime"
            ],
            members: {
              spaceName: {},
              projectName: {},
              id: {},
              workflowId: {},
              status: {},
              statusReasons: {
                shape: "S2g"
              },
              startTime: {
                shape: "S3"
              },
              endTime: {
                shape: "S3"
              },
              lastUpdatedTime: {
                shape: "S3"
              }
            }
          }
        },
        ListAccessTokens: {
          http: {
            requestUri: "/v1/accessTokens",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "items"
            ],
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "name"
                  ],
                  members: {
                    id: {},
                    name: {},
                    expiresTime: {
                      shape: "S3"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDevEnvironmentSessions: {
          http: {
            requestUri: "/v1/spaces/{spaceName}/projects/{projectName}/devEnvironments/{devEnvironmentId}/sessions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "spaceName",
              "projectName",
              "devEnvironmentId"
            ],
            members: {
              spaceName: {
                location: "uri",
                locationName: "spaceName"
              },
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              devEnvironmentId: {
                location: "uri",
                locationName: "devEnvironmentId"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "items"
            ],
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "spaceName",
                    "projectName",
                    "devEnvironmentId",
                    "startedTime",
                    "id"
                  ],
                  members: {
                    spaceName: {},
                    projectName: {},
                    devEnvironmentId: {},
                    startedTime: {
                      shape: "S3"
                    },
                    id: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDevEnvironments: {
          http: {
            requestUri: "/v1/spaces/{spaceName}/devEnvironments",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "spaceName"
            ],
            members: {
              spaceName: {
                location: "uri",
                locationName: "spaceName"
              },
              projectName: {},
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "key",
                    "values"
                  ],
                  members: {
                    key: {},
                    values: {
                      shape: "S2y"
                    },
                    comparisonOperator: {}
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "items"
            ],
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "lastUpdatedTime",
                    "creatorId",
                    "status",
                    "repositories",
                    "instanceType",
                    "inactivityTimeoutMinutes",
                    "persistentStorage"
                  ],
                  members: {
                    spaceName: {},
                    projectName: {},
                    id: {},
                    lastUpdatedTime: {
                      shape: "S3"
                    },
                    creatorId: {},
                    status: {},
                    statusReason: {},
                    repositories: {
                      shape: "S1f"
                    },
                    alias: {},
                    ides: {
                      shape: "S1i"
                    },
                    instanceType: {},
                    inactivityTimeoutMinutes: {
                      type: "integer"
                    },
                    persistentStorage: {
                      shape: "S1m"
                    },
                    vpcConnectionName: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListEventLogs: {
          http: {
            requestUri: "/v1/spaces/{spaceName}/eventLogs",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "spaceName",
              "startTime",
              "endTime"
            ],
            members: {
              spaceName: {
                location: "uri",
                locationName: "spaceName"
              },
              startTime: {
                shape: "S3"
              },
              endTime: {
                shape: "S3"
              },
              eventName: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "items"
            ],
            members: {
              nextToken: {},
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "eventName",
                    "eventType",
                    "eventCategory",
                    "eventSource",
                    "eventTime",
                    "operationType",
                    "userIdentity"
                  ],
                  members: {
                    id: {},
                    eventName: {},
                    eventType: {},
                    eventCategory: {},
                    eventSource: {},
                    eventTime: {
                      shape: "S3"
                    },
                    operationType: {},
                    userIdentity: {
                      type: "structure",
                      required: [
                        "userType",
                        "principalId"
                      ],
                      members: {
                        userType: {},
                        principalId: {},
                        userName: {},
                        awsAccountId: {}
                      }
                    },
                    projectInformation: {
                      type: "structure",
                      members: {
                        name: {},
                        projectId: {}
                      }
                    },
                    requestId: {},
                    requestPayload: {
                      shape: "S3g"
                    },
                    responsePayload: {
                      shape: "S3g"
                    },
                    errorCode: {},
                    sourceIpAddress: {},
                    userAgent: {}
                  }
                }
              }
            }
          }
        },
        ListProjects: {
          http: {
            requestUri: "/v1/spaces/{spaceName}/projects",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "spaceName"
            ],
            members: {
              spaceName: {
                location: "uri",
                locationName: "spaceName"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "key",
                    "values"
                  ],
                  members: {
                    key: {},
                    values: {
                      shape: "S2y"
                    },
                    comparisonOperator: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name"
                  ],
                  members: {
                    name: {},
                    displayName: {},
                    description: {}
                  }
                }
              }
            }
          }
        },
        ListSourceRepositories: {
          http: {
            requestUri: "/v1/spaces/{spaceName}/projects/{projectName}/sourceRepositories",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "spaceName",
              "projectName"
            ],
            members: {
              spaceName: {
                location: "uri",
                locationName: "spaceName"
              },
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "name",
                    "lastUpdatedTime",
                    "createdTime"
                  ],
                  members: {
                    id: {},
                    name: {},
                    description: {},
                    lastUpdatedTime: {
                      shape: "S1s"
                    },
                    createdTime: {
                      shape: "S1s"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSourceRepositoryBranches: {
          http: {
            requestUri: "/v1/spaces/{spaceName}/projects/{projectName}/sourceRepositories/{sourceRepositoryName}/branches",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "spaceName",
              "projectName",
              "sourceRepositoryName"
            ],
            members: {
              spaceName: {
                location: "uri",
                locationName: "spaceName"
              },
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              sourceRepositoryName: {
                location: "uri",
                locationName: "sourceRepositoryName"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "items"
            ],
            members: {
              nextToken: {},
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ref: {},
                    name: {},
                    lastUpdatedTime: {
                      shape: "S3"
                    },
                    headCommitId: {}
                  }
                }
              }
            }
          }
        },
        ListSpaces: {
          http: {
            requestUri: "/v1/spaces",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "regionName"
                  ],
                  members: {
                    name: {},
                    regionName: {},
                    displayName: {},
                    description: {}
                  }
                }
              }
            }
          }
        },
        ListWorkflowRuns: {
          http: {
            requestUri: "/v1/spaces/{spaceName}/projects/{projectName}/workflowRuns",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "spaceName",
              "projectName"
            ],
            members: {
              spaceName: {
                location: "uri",
                locationName: "spaceName"
              },
              workflowId: {
                location: "querystring",
                locationName: "workflowId"
              },
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              sortBy: {
                type: "list",
                member: {
                  type: "structure",
                  members: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "workflowId",
                    "workflowName",
                    "status",
                    "startTime",
                    "lastUpdatedTime"
                  ],
                  members: {
                    id: {},
                    workflowId: {},
                    workflowName: {},
                    status: {},
                    statusReasons: {
                      shape: "S2g"
                    },
                    startTime: {
                      shape: "S3"
                    },
                    endTime: {
                      shape: "S3"
                    },
                    lastUpdatedTime: {
                      shape: "S3"
                    }
                  }
                }
              }
            }
          }
        },
        ListWorkflows: {
          http: {
            requestUri: "/v1/spaces/{spaceName}/projects/{projectName}/workflows",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "spaceName",
              "projectName"
            ],
            members: {
              spaceName: {
                location: "uri",
                locationName: "spaceName"
              },
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              sortBy: {
                type: "list",
                member: {
                  type: "structure",
                  members: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "name",
                    "sourceRepositoryName",
                    "sourceBranchName",
                    "definition",
                    "createdTime",
                    "lastUpdatedTime",
                    "runMode",
                    "status"
                  ],
                  members: {
                    id: {},
                    name: {},
                    sourceRepositoryName: {},
                    sourceBranchName: {},
                    definition: {
                      type: "structure",
                      required: [
                        "path"
                      ],
                      members: {
                        path: {}
                      }
                    },
                    createdTime: {
                      shape: "S3"
                    },
                    lastUpdatedTime: {
                      shape: "S3"
                    },
                    runMode: {},
                    status: {}
                  }
                }
              }
            }
          }
        },
        StartDevEnvironment: {
          http: {
            method: "PUT",
            requestUri: "/v1/spaces/{spaceName}/projects/{projectName}/devEnvironments/{id}/start",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "spaceName",
              "projectName",
              "id"
            ],
            members: {
              spaceName: {
                location: "uri",
                locationName: "spaceName"
              },
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              id: {
                location: "uri",
                locationName: "id"
              },
              ides: {
                shape: "Sf"
              },
              instanceType: {},
              inactivityTimeoutMinutes: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "spaceName",
              "projectName",
              "id",
              "status"
            ],
            members: {
              spaceName: {},
              projectName: {},
              id: {},
              status: {}
            }
          },
          idempotent: true
        },
        StartDevEnvironmentSession: {
          http: {
            method: "PUT",
            requestUri: "/v1/spaces/{spaceName}/projects/{projectName}/devEnvironments/{id}/session",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "spaceName",
              "projectName",
              "id",
              "sessionConfiguration"
            ],
            members: {
              spaceName: {
                location: "uri",
                locationName: "spaceName"
              },
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              id: {
                location: "uri",
                locationName: "id"
              },
              sessionConfiguration: {
                type: "structure",
                required: [
                  "sessionType"
                ],
                members: {
                  sessionType: {},
                  executeCommandSessionConfiguration: {
                    type: "structure",
                    required: [
                      "command"
                    ],
                    members: {
                      command: {},
                      arguments: {
                        type: "list",
                        member: {}
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "accessDetails",
              "spaceName",
              "projectName",
              "id"
            ],
            members: {
              accessDetails: {
                type: "structure",
                required: [
                  "streamUrl",
                  "tokenValue"
                ],
                members: {
                  streamUrl: {
                    shape: "S53"
                  },
                  tokenValue: {
                    shape: "S53"
                  }
                },
                sensitive: true
              },
              sessionId: {},
              spaceName: {},
              projectName: {},
              id: {}
            }
          }
        },
        StartWorkflowRun: {
          http: {
            method: "PUT",
            requestUri: "/v1/spaces/{spaceName}/projects/{projectName}/workflowRuns",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "spaceName",
              "projectName",
              "workflowId"
            ],
            members: {
              spaceName: {
                location: "uri",
                locationName: "spaceName"
              },
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              workflowId: {
                location: "querystring",
                locationName: "workflowId"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "spaceName",
              "projectName",
              "id",
              "workflowId"
            ],
            members: {
              spaceName: {},
              projectName: {},
              id: {},
              workflowId: {}
            }
          },
          idempotent: true
        },
        StopDevEnvironment: {
          http: {
            method: "PUT",
            requestUri: "/v1/spaces/{spaceName}/projects/{projectName}/devEnvironments/{id}/stop",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "spaceName",
              "projectName",
              "id"
            ],
            members: {
              spaceName: {
                location: "uri",
                locationName: "spaceName"
              },
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "spaceName",
              "projectName",
              "id",
              "status"
            ],
            members: {
              spaceName: {},
              projectName: {},
              id: {},
              status: {}
            }
          },
          idempotent: true
        },
        StopDevEnvironmentSession: {
          http: {
            method: "DELETE",
            requestUri: "/v1/spaces/{spaceName}/projects/{projectName}/devEnvironments/{id}/session/{sessionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "spaceName",
              "projectName",
              "id",
              "sessionId"
            ],
            members: {
              spaceName: {
                location: "uri",
                locationName: "spaceName"
              },
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              id: {
                location: "uri",
                locationName: "id"
              },
              sessionId: {
                location: "uri",
                locationName: "sessionId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "spaceName",
              "projectName",
              "id",
              "sessionId"
            ],
            members: {
              spaceName: {},
              projectName: {},
              id: {},
              sessionId: {}
            }
          },
          idempotent: true
        },
        UpdateDevEnvironment: {
          http: {
            method: "PATCH",
            requestUri: "/v1/spaces/{spaceName}/projects/{projectName}/devEnvironments/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "spaceName",
              "projectName",
              "id"
            ],
            members: {
              spaceName: {
                location: "uri",
                locationName: "spaceName"
              },
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              id: {
                location: "uri",
                locationName: "id"
              },
              alias: {},
              ides: {
                shape: "Sf"
              },
              instanceType: {},
              inactivityTimeoutMinutes: {
                type: "integer"
              },
              clientToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "spaceName",
              "projectName"
            ],
            members: {
              id: {},
              spaceName: {},
              projectName: {},
              alias: {},
              ides: {
                shape: "Sf"
              },
              instanceType: {},
              inactivityTimeoutMinutes: {
                type: "integer"
              },
              clientToken: {}
            }
          },
          idempotent: true
        },
        UpdateProject: {
          http: {
            method: "PATCH",
            requestUri: "/v1/spaces/{spaceName}/projects/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "spaceName",
              "name"
            ],
            members: {
              spaceName: {
                location: "uri",
                locationName: "spaceName"
              },
              name: {
                location: "uri",
                locationName: "name"
              },
              description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              spaceName: {},
              name: {},
              displayName: {},
              description: {}
            }
          },
          idempotent: true
        },
        UpdateSpace: {
          http: {
            method: "PATCH",
            requestUri: "/v1/spaces/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              displayName: {},
              description: {}
            }
          },
          idempotent: true
        },
        VerifySession: {
          http: {
            method: "GET",
            requestUri: "/session",
            responseCode: 200
          },
          output: {
            type: "structure",
            members: {
              identity: {}
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        Sf: {
          type: "list",
          member: {
            type: "structure",
            members: {
              runtime: {},
              name: {}
            }
          }
        },
        S1f: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              repositoryName: {},
              branchName: {}
            }
          }
        },
        S1i: {
          type: "list",
          member: {
            type: "structure",
            members: {
              runtime: {},
              name: {}
            }
          }
        },
        S1m: {
          type: "structure",
          required: [
            "sizeInGiB"
          ],
          members: {
            sizeInGiB: {
              type: "integer"
            }
          }
        },
        S1s: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S2g: {
          type: "list",
          member: {
            type: "structure",
            members: {}
          }
        },
        S2y: {
          type: "list",
          member: {}
        },
        S3g: {
          type: "structure",
          members: {
            contentType: {},
            data: {}
          }
        },
        S53: {
          type: "string",
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/codecatalyst-2022-09-28.paginators.json
var require_codecatalyst_2022_09_28_paginators = __commonJS({
  "node_modules/aws-sdk/apis/codecatalyst-2022-09-28.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAccessTokens: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListDevEnvironmentSessions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListDevEnvironments: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListEventLogs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListProjects: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListSourceRepositories: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListSourceRepositoryBranches: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListSpaces: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "items"
        },
        ListWorkflowRuns: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListWorkflows: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/codecatalyst-2022-09-28.waiters2.json
var require_codecatalyst_2022_09_28_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/codecatalyst-2022-09-28.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {}
    };
  }
});

// node_modules/aws-sdk/clients/codecatalyst.js
var require_codecatalyst = __commonJS({
  "node_modules/aws-sdk/clients/codecatalyst.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["codecatalyst"] = {};
    AWS2.CodeCatalyst = Service.defineService("codecatalyst", ["2022-09-28"]);
    Object.defineProperty(apiLoader.services["codecatalyst"], "2022-09-28", {
      get: function get() {
        var model = require_codecatalyst_2022_09_28_min();
        model.paginators = require_codecatalyst_2022_09_28_paginators().pagination;
        model.waiters = require_codecatalyst_2022_09_28_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CodeCatalyst;
  }
});

// node_modules/aws-sdk/apis/pipes-2015-10-07.min.json
var require_pipes_2015_10_07_min = __commonJS({
  "node_modules/aws-sdk/apis/pipes-2015-10-07.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-10-07",
        endpointPrefix: "pipes",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon EventBridge Pipes",
        serviceId: "Pipes",
        signatureVersion: "v4",
        signingName: "pipes",
        uid: "pipes-2015-10-07"
      },
      operations: {
        CreatePipe: {
          http: {
            requestUri: "/v1/pipes/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "RoleArn",
              "Source",
              "Target"
            ],
            members: {
              Description: {
                shape: "S2"
              },
              DesiredState: {},
              Enrichment: {},
              EnrichmentParameters: {
                shape: "S5"
              },
              LogConfiguration: {
                shape: "Sg"
              },
              Name: {
                location: "uri",
                locationName: "Name"
              },
              RoleArn: {},
              Source: {},
              SourceParameters: {
                shape: "Sw"
              },
              Tags: {
                shape: "S1z"
              },
              Target: {},
              TargetParameters: {
                shape: "S22"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTime: {
                type: "timestamp"
              },
              CurrentState: {},
              DesiredState: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              Name: {}
            }
          },
          idempotent: true
        },
        DeletePipe: {
          http: {
            method: "DELETE",
            requestUri: "/v1/pipes/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTime: {
                type: "timestamp"
              },
              CurrentState: {},
              DesiredState: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              Name: {}
            }
          },
          idempotent: true
        },
        DescribePipe: {
          http: {
            method: "GET",
            requestUri: "/v1/pipes/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTime: {
                type: "timestamp"
              },
              CurrentState: {},
              Description: {
                shape: "S2"
              },
              DesiredState: {},
              Enrichment: {},
              EnrichmentParameters: {
                shape: "S5"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LogConfiguration: {
                type: "structure",
                members: {
                  CloudwatchLogsLogDestination: {
                    type: "structure",
                    members: {
                      LogGroupArn: {}
                    }
                  },
                  FirehoseLogDestination: {
                    type: "structure",
                    members: {
                      DeliveryStreamArn: {}
                    }
                  },
                  IncludeExecutionData: {
                    shape: "Sl"
                  },
                  Level: {},
                  S3LogDestination: {
                    type: "structure",
                    members: {
                      BucketName: {},
                      BucketOwner: {},
                      OutputFormat: {},
                      Prefix: {}
                    }
                  }
                }
              },
              Name: {},
              RoleArn: {},
              Source: {},
              SourceParameters: {
                shape: "Sw"
              },
              StateReason: {},
              Tags: {
                shape: "S1z"
              },
              Target: {},
              TargetParameters: {
                shape: "S22"
              }
            }
          }
        },
        ListPipes: {
          http: {
            method: "GET",
            requestUri: "/v1/pipes",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CurrentState: {
                location: "querystring",
                locationName: "CurrentState"
              },
              DesiredState: {
                location: "querystring",
                locationName: "DesiredState"
              },
              Limit: {
                location: "querystring",
                locationName: "Limit",
                type: "integer"
              },
              NamePrefix: {
                location: "querystring",
                locationName: "NamePrefix"
              },
              NextToken: {
                shape: "S51",
                location: "querystring",
                locationName: "NextToken"
              },
              SourcePrefix: {
                location: "querystring",
                locationName: "SourcePrefix"
              },
              TargetPrefix: {
                location: "querystring",
                locationName: "TargetPrefix"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                shape: "S51"
              },
              Pipes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    CurrentState: {},
                    DesiredState: {},
                    Enrichment: {},
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    Name: {},
                    Source: {},
                    StateReason: {},
                    Target: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S1z"
              }
            }
          }
        },
        StartPipe: {
          http: {
            requestUri: "/v1/pipes/{Name}/start",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTime: {
                type: "timestamp"
              },
              CurrentState: {},
              DesiredState: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              Name: {}
            }
          }
        },
        StopPipe: {
          http: {
            requestUri: "/v1/pipes/{Name}/stop",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTime: {
                type: "timestamp"
              },
              CurrentState: {},
              DesiredState: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              Name: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S1z"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdatePipe: {
          http: {
            method: "PUT",
            requestUri: "/v1/pipes/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "RoleArn"
            ],
            members: {
              Description: {
                shape: "S2"
              },
              DesiredState: {},
              Enrichment: {},
              EnrichmentParameters: {
                shape: "S5"
              },
              LogConfiguration: {
                shape: "Sg"
              },
              Name: {
                location: "uri",
                locationName: "Name"
              },
              RoleArn: {},
              SourceParameters: {
                type: "structure",
                members: {
                  ActiveMQBrokerParameters: {
                    type: "structure",
                    required: [
                      "Credentials"
                    ],
                    members: {
                      BatchSize: {
                        type: "integer"
                      },
                      Credentials: {
                        shape: "Sz"
                      },
                      MaximumBatchingWindowInSeconds: {
                        type: "integer"
                      }
                    }
                  },
                  DynamoDBStreamParameters: {
                    type: "structure",
                    members: {
                      BatchSize: {
                        type: "integer"
                      },
                      DeadLetterConfig: {
                        shape: "S14"
                      },
                      MaximumBatchingWindowInSeconds: {
                        type: "integer"
                      },
                      MaximumRecordAgeInSeconds: {
                        type: "integer"
                      },
                      MaximumRetryAttempts: {
                        type: "integer"
                      },
                      OnPartialBatchItemFailure: {},
                      ParallelizationFactor: {
                        type: "integer"
                      }
                    }
                  },
                  FilterCriteria: {
                    shape: "S1b"
                  },
                  KinesisStreamParameters: {
                    type: "structure",
                    members: {
                      BatchSize: {
                        type: "integer"
                      },
                      DeadLetterConfig: {
                        shape: "S14"
                      },
                      MaximumBatchingWindowInSeconds: {
                        type: "integer"
                      },
                      MaximumRecordAgeInSeconds: {
                        type: "integer"
                      },
                      MaximumRetryAttempts: {
                        type: "integer"
                      },
                      OnPartialBatchItemFailure: {},
                      ParallelizationFactor: {
                        type: "integer"
                      }
                    }
                  },
                  ManagedStreamingKafkaParameters: {
                    type: "structure",
                    members: {
                      BatchSize: {
                        type: "integer"
                      },
                      Credentials: {
                        shape: "S1k"
                      },
                      MaximumBatchingWindowInSeconds: {
                        type: "integer"
                      }
                    }
                  },
                  RabbitMQBrokerParameters: {
                    type: "structure",
                    required: [
                      "Credentials"
                    ],
                    members: {
                      BatchSize: {
                        type: "integer"
                      },
                      Credentials: {
                        shape: "Sz"
                      },
                      MaximumBatchingWindowInSeconds: {
                        type: "integer"
                      }
                    }
                  },
                  SelfManagedKafkaParameters: {
                    type: "structure",
                    members: {
                      BatchSize: {
                        type: "integer"
                      },
                      Credentials: {
                        shape: "S1r"
                      },
                      MaximumBatchingWindowInSeconds: {
                        type: "integer"
                      },
                      ServerRootCaCertificate: {},
                      Vpc: {
                        shape: "S1t"
                      }
                    }
                  },
                  SqsQueueParameters: {
                    type: "structure",
                    members: {
                      BatchSize: {
                        type: "integer"
                      },
                      MaximumBatchingWindowInSeconds: {
                        type: "integer"
                      }
                    }
                  }
                }
              },
              Target: {},
              TargetParameters: {
                shape: "S22"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTime: {
                type: "timestamp"
              },
              CurrentState: {},
              DesiredState: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              Name: {}
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S2: {
          type: "string",
          sensitive: true
        },
        S5: {
          type: "structure",
          members: {
            HttpParameters: {
              type: "structure",
              members: {
                HeaderParameters: {
                  shape: "S7"
                },
                PathParameterValues: {
                  shape: "Sa"
                },
                QueryStringParameters: {
                  shape: "Sc"
                }
              }
            },
            InputTemplate: {
              shape: "Sf"
            }
          }
        },
        S7: {
          type: "map",
          key: {},
          value: {
            type: "string",
            sensitive: true
          }
        },
        Sa: {
          type: "list",
          member: {
            type: "string",
            sensitive: true
          }
        },
        Sc: {
          type: "map",
          key: {},
          value: {
            type: "string",
            sensitive: true
          }
        },
        Sf: {
          type: "string",
          sensitive: true
        },
        Sg: {
          type: "structure",
          required: [
            "Level"
          ],
          members: {
            CloudwatchLogsLogDestination: {
              type: "structure",
              required: [
                "LogGroupArn"
              ],
              members: {
                LogGroupArn: {}
              }
            },
            FirehoseLogDestination: {
              type: "structure",
              required: [
                "DeliveryStreamArn"
              ],
              members: {
                DeliveryStreamArn: {}
              }
            },
            IncludeExecutionData: {
              shape: "Sl"
            },
            Level: {},
            S3LogDestination: {
              type: "structure",
              required: [
                "BucketName",
                "BucketOwner"
              ],
              members: {
                BucketName: {},
                BucketOwner: {},
                OutputFormat: {},
                Prefix: {}
              }
            }
          }
        },
        Sl: {
          type: "list",
          member: {}
        },
        Sw: {
          type: "structure",
          members: {
            ActiveMQBrokerParameters: {
              type: "structure",
              required: [
                "Credentials",
                "QueueName"
              ],
              members: {
                BatchSize: {
                  type: "integer"
                },
                Credentials: {
                  shape: "Sz"
                },
                MaximumBatchingWindowInSeconds: {
                  type: "integer"
                },
                QueueName: {
                  shape: "S12"
                }
              }
            },
            DynamoDBStreamParameters: {
              type: "structure",
              required: [
                "StartingPosition"
              ],
              members: {
                BatchSize: {
                  type: "integer"
                },
                DeadLetterConfig: {
                  shape: "S14"
                },
                MaximumBatchingWindowInSeconds: {
                  type: "integer"
                },
                MaximumRecordAgeInSeconds: {
                  type: "integer"
                },
                MaximumRetryAttempts: {
                  type: "integer"
                },
                OnPartialBatchItemFailure: {},
                ParallelizationFactor: {
                  type: "integer"
                },
                StartingPosition: {}
              }
            },
            FilterCriteria: {
              shape: "S1b"
            },
            KinesisStreamParameters: {
              type: "structure",
              required: [
                "StartingPosition"
              ],
              members: {
                BatchSize: {
                  type: "integer"
                },
                DeadLetterConfig: {
                  shape: "S14"
                },
                MaximumBatchingWindowInSeconds: {
                  type: "integer"
                },
                MaximumRecordAgeInSeconds: {
                  type: "integer"
                },
                MaximumRetryAttempts: {
                  type: "integer"
                },
                OnPartialBatchItemFailure: {},
                ParallelizationFactor: {
                  type: "integer"
                },
                StartingPosition: {},
                StartingPositionTimestamp: {
                  type: "timestamp"
                }
              }
            },
            ManagedStreamingKafkaParameters: {
              type: "structure",
              required: [
                "TopicName"
              ],
              members: {
                BatchSize: {
                  type: "integer"
                },
                ConsumerGroupID: {
                  shape: "S1j"
                },
                Credentials: {
                  shape: "S1k"
                },
                MaximumBatchingWindowInSeconds: {
                  type: "integer"
                },
                StartingPosition: {},
                TopicName: {
                  shape: "S1m"
                }
              }
            },
            RabbitMQBrokerParameters: {
              type: "structure",
              required: [
                "Credentials",
                "QueueName"
              ],
              members: {
                BatchSize: {
                  type: "integer"
                },
                Credentials: {
                  shape: "Sz"
                },
                MaximumBatchingWindowInSeconds: {
                  type: "integer"
                },
                QueueName: {
                  shape: "S12"
                },
                VirtualHost: {
                  shape: "S1j"
                }
              }
            },
            SelfManagedKafkaParameters: {
              type: "structure",
              required: [
                "TopicName"
              ],
              members: {
                AdditionalBootstrapServers: {
                  type: "list",
                  member: {
                    type: "string",
                    sensitive: true
                  }
                },
                BatchSize: {
                  type: "integer"
                },
                ConsumerGroupID: {
                  shape: "S1j"
                },
                Credentials: {
                  shape: "S1r"
                },
                MaximumBatchingWindowInSeconds: {
                  type: "integer"
                },
                ServerRootCaCertificate: {},
                StartingPosition: {},
                TopicName: {
                  shape: "S1m"
                },
                Vpc: {
                  shape: "S1t"
                }
              }
            },
            SqsQueueParameters: {
              type: "structure",
              members: {
                BatchSize: {
                  type: "integer"
                },
                MaximumBatchingWindowInSeconds: {
                  type: "integer"
                }
              }
            }
          }
        },
        Sz: {
          type: "structure",
          members: {
            BasicAuth: {}
          },
          union: true
        },
        S12: {
          type: "string",
          sensitive: true
        },
        S14: {
          type: "structure",
          members: {
            Arn: {}
          }
        },
        S1b: {
          type: "structure",
          members: {
            Filters: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Pattern: {
                    type: "string",
                    sensitive: true
                  }
                }
              }
            }
          }
        },
        S1j: {
          type: "string",
          sensitive: true
        },
        S1k: {
          type: "structure",
          members: {
            ClientCertificateTlsAuth: {},
            SaslScram512Auth: {}
          },
          union: true
        },
        S1m: {
          type: "string",
          sensitive: true
        },
        S1r: {
          type: "structure",
          members: {
            BasicAuth: {},
            ClientCertificateTlsAuth: {},
            SaslScram256Auth: {},
            SaslScram512Auth: {}
          },
          union: true
        },
        S1t: {
          type: "structure",
          members: {
            SecurityGroup: {
              type: "list",
              member: {
                type: "string",
                sensitive: true
              }
            },
            Subnets: {
              type: "list",
              member: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        S1z: {
          type: "map",
          key: {},
          value: {
            shape: "S21"
          }
        },
        S21: {
          type: "string",
          sensitive: true
        },
        S22: {
          type: "structure",
          members: {
            BatchJobParameters: {
              type: "structure",
              required: [
                "JobDefinition",
                "JobName"
              ],
              members: {
                ArrayProperties: {
                  type: "structure",
                  members: {
                    Size: {
                      type: "integer"
                    }
                  }
                },
                ContainerOverrides: {
                  type: "structure",
                  members: {
                    Command: {
                      shape: "S27"
                    },
                    Environment: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Name: {},
                          Value: {}
                        }
                      }
                    },
                    InstanceType: {},
                    ResourceRequirements: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "Type",
                          "Value"
                        ],
                        members: {
                          Type: {},
                          Value: {}
                        }
                      }
                    }
                  }
                },
                DependsOn: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      JobId: {},
                      Type: {}
                    }
                  }
                },
                JobDefinition: {},
                JobName: {},
                Parameters: {
                  type: "map",
                  key: {},
                  value: {}
                },
                RetryStrategy: {
                  type: "structure",
                  members: {
                    Attempts: {
                      type: "integer"
                    }
                  }
                }
              }
            },
            CloudWatchLogsParameters: {
              type: "structure",
              members: {
                LogStreamName: {},
                Timestamp: {}
              }
            },
            EcsTaskParameters: {
              type: "structure",
              required: [
                "TaskDefinitionArn"
              ],
              members: {
                CapacityProviderStrategy: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "capacityProvider"
                    ],
                    members: {
                      base: {
                        type: "integer"
                      },
                      capacityProvider: {
                        type: "string",
                        sensitive: true
                      },
                      weight: {
                        type: "integer"
                      }
                    }
                  }
                },
                EnableECSManagedTags: {
                  type: "boolean"
                },
                EnableExecuteCommand: {
                  type: "boolean"
                },
                Group: {},
                LaunchType: {},
                NetworkConfiguration: {
                  type: "structure",
                  members: {
                    awsvpcConfiguration: {
                      type: "structure",
                      required: [
                        "Subnets"
                      ],
                      members: {
                        AssignPublicIp: {},
                        SecurityGroups: {
                          type: "list",
                          member: {
                            type: "string",
                            sensitive: true
                          }
                        },
                        Subnets: {
                          type: "list",
                          member: {
                            type: "string",
                            sensitive: true
                          }
                        }
                      }
                    }
                  }
                },
                Overrides: {
                  type: "structure",
                  members: {
                    ContainerOverrides: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Command: {
                            shape: "S27"
                          },
                          Cpu: {
                            type: "integer"
                          },
                          Environment: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                name: {},
                                value: {}
                              }
                            }
                          },
                          EnvironmentFiles: {
                            type: "list",
                            member: {
                              type: "structure",
                              required: [
                                "type",
                                "value"
                              ],
                              members: {
                                type: {},
                                value: {}
                              }
                            }
                          },
                          Memory: {
                            type: "integer"
                          },
                          MemoryReservation: {
                            type: "integer"
                          },
                          Name: {},
                          ResourceRequirements: {
                            type: "list",
                            member: {
                              type: "structure",
                              required: [
                                "type",
                                "value"
                              ],
                              members: {
                                type: {},
                                value: {}
                              }
                            }
                          }
                        }
                      }
                    },
                    Cpu: {},
                    EphemeralStorage: {
                      type: "structure",
                      required: [
                        "sizeInGiB"
                      ],
                      members: {
                        sizeInGiB: {
                          type: "integer"
                        }
                      }
                    },
                    ExecutionRoleArn: {},
                    InferenceAcceleratorOverrides: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          deviceName: {},
                          deviceType: {}
                        }
                      }
                    },
                    Memory: {},
                    TaskRoleArn: {}
                  }
                },
                PlacementConstraints: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      expression: {
                        type: "string",
                        sensitive: true
                      },
                      type: {}
                    }
                  }
                },
                PlacementStrategy: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      field: {
                        type: "string",
                        sensitive: true
                      },
                      type: {}
                    }
                  }
                },
                PlatformVersion: {},
                PropagateTags: {},
                ReferenceId: {
                  type: "string",
                  sensitive: true
                },
                Tags: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "Key",
                      "Value"
                    ],
                    members: {
                      Key: {},
                      Value: {
                        shape: "S21"
                      }
                    }
                  }
                },
                TaskCount: {
                  type: "integer"
                },
                TaskDefinitionArn: {}
              }
            },
            EventBridgeEventBusParameters: {
              type: "structure",
              members: {
                DetailType: {
                  type: "string",
                  sensitive: true
                },
                EndpointId: {
                  type: "string",
                  sensitive: true
                },
                Resources: {
                  type: "list",
                  member: {}
                },
                Source: {
                  type: "string",
                  sensitive: true
                },
                Time: {}
              }
            },
            HttpParameters: {
              type: "structure",
              members: {
                HeaderParameters: {
                  shape: "S7"
                },
                PathParameterValues: {
                  shape: "Sa"
                },
                QueryStringParameters: {
                  shape: "Sc"
                }
              }
            },
            InputTemplate: {
              shape: "Sf"
            },
            KinesisStreamParameters: {
              type: "structure",
              required: [
                "PartitionKey"
              ],
              members: {
                PartitionKey: {
                  type: "string",
                  sensitive: true
                }
              }
            },
            LambdaFunctionParameters: {
              type: "structure",
              members: {
                InvocationType: {}
              }
            },
            RedshiftDataParameters: {
              type: "structure",
              required: [
                "Database",
                "Sqls"
              ],
              members: {
                Database: {
                  type: "string",
                  sensitive: true
                },
                DbUser: {
                  type: "string",
                  sensitive: true
                },
                SecretManagerArn: {},
                Sqls: {
                  type: "list",
                  member: {
                    type: "string",
                    sensitive: true
                  }
                },
                StatementName: {
                  type: "string",
                  sensitive: true
                },
                WithEvent: {
                  type: "boolean"
                }
              }
            },
            SageMakerPipelineParameters: {
              type: "structure",
              members: {
                PipelineParameterList: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "Name",
                      "Value"
                    ],
                    members: {
                      Name: {
                        type: "string",
                        sensitive: true
                      },
                      Value: {
                        type: "string",
                        sensitive: true
                      }
                    }
                  }
                }
              }
            },
            SqsQueueParameters: {
              type: "structure",
              members: {
                MessageDeduplicationId: {
                  type: "string",
                  sensitive: true
                },
                MessageGroupId: {
                  type: "string",
                  sensitive: true
                }
              }
            },
            StepFunctionStateMachineParameters: {
              type: "structure",
              members: {
                InvocationType: {}
              }
            }
          }
        },
        S27: {
          type: "list",
          member: {}
        },
        S51: {
          type: "string",
          sensitive: true
        }
      },
      xmlNamespace: "http://events.amazonaws.com/doc/2015-10-07"
    };
  }
});

// node_modules/aws-sdk/apis/pipes-2015-10-07.paginators.json
var require_pipes_2015_10_07_paginators = __commonJS({
  "node_modules/aws-sdk/apis/pipes-2015-10-07.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListPipes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "Pipes"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/pipes.js
var require_pipes = __commonJS({
  "node_modules/aws-sdk/clients/pipes.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["pipes"] = {};
    AWS2.Pipes = Service.defineService("pipes", ["2015-10-07"]);
    Object.defineProperty(apiLoader.services["pipes"], "2015-10-07", {
      get: function get() {
        var model = require_pipes_2015_10_07_min();
        model.paginators = require_pipes_2015_10_07_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Pipes;
  }
});

// node_modules/aws-sdk/apis/sagemaker-metrics-2022-09-30.min.json
var require_sagemaker_metrics_2022_09_30_min = __commonJS({
  "node_modules/aws-sdk/apis/sagemaker-metrics-2022-09-30.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2022-09-30",
        endpointPrefix: "metrics.sagemaker",
        protocol: "rest-json",
        serviceAbbreviation: "SageMaker Metrics",
        serviceFullName: "Amazon SageMaker Metrics Service",
        serviceId: "SageMaker Metrics",
        signatureVersion: "v4",
        signingName: "sagemaker",
        uid: "sagemaker-metrics-2022-09-30"
      },
      operations: {
        BatchPutMetrics: {
          http: {
            method: "PUT",
            requestUri: "/BatchPutMetrics"
          },
          input: {
            type: "structure",
            required: [
              "TrialComponentName",
              "MetricData"
            ],
            members: {
              TrialComponentName: {},
              MetricData: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "MetricName",
                    "Timestamp",
                    "Value"
                  ],
                  members: {
                    MetricName: {},
                    Timestamp: {
                      type: "timestamp"
                    },
                    Step: {
                      type: "integer"
                    },
                    Value: {
                      type: "double"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Code: {},
                    MetricIndex: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/apis/sagemaker-metrics-2022-09-30.paginators.json
var require_sagemaker_metrics_2022_09_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/sagemaker-metrics-2022-09-30.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/sagemakermetrics.js
var require_sagemakermetrics = __commonJS({
  "node_modules/aws-sdk/clients/sagemakermetrics.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["sagemakermetrics"] = {};
    AWS2.SageMakerMetrics = Service.defineService("sagemakermetrics", ["2022-09-30"]);
    Object.defineProperty(apiLoader.services["sagemakermetrics"], "2022-09-30", {
      get: function get() {
        var model = require_sagemaker_metrics_2022_09_30_min();
        model.paginators = require_sagemaker_metrics_2022_09_30_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.SageMakerMetrics;
  }
});

// node_modules/aws-sdk/apis/kinesis-video-webrtc-storage-2018-05-10.min.json
var require_kinesis_video_webrtc_storage_2018_05_10_min = __commonJS({
  "node_modules/aws-sdk/apis/kinesis-video-webrtc-storage-2018-05-10.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-05-10",
        endpointPrefix: "kinesisvideo",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Kinesis Video WebRTC Storage",
        serviceId: "Kinesis Video WebRTC Storage",
        signatureVersion: "v4",
        signingName: "kinesisvideo",
        uid: "kinesis-video-webrtc-storage-2018-05-10"
      },
      operations: {
        JoinStorageSession: {
          http: {
            requestUri: "/joinStorageSession",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "channelArn"
            ],
            members: {
              channelArn: {}
            }
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/apis/kinesis-video-webrtc-storage-2018-05-10.paginators.json
var require_kinesis_video_webrtc_storage_2018_05_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/kinesis-video-webrtc-storage-2018-05-10.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/kinesisvideowebrtcstorage.js
var require_kinesisvideowebrtcstorage = __commonJS({
  "node_modules/aws-sdk/clients/kinesisvideowebrtcstorage.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["kinesisvideowebrtcstorage"] = {};
    AWS2.KinesisVideoWebRTCStorage = Service.defineService("kinesisvideowebrtcstorage", ["2018-05-10"]);
    Object.defineProperty(apiLoader.services["kinesisvideowebrtcstorage"], "2018-05-10", {
      get: function get() {
        var model = require_kinesis_video_webrtc_storage_2018_05_10_min();
        model.paginators = require_kinesis_video_webrtc_storage_2018_05_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.KinesisVideoWebRTCStorage;
  }
});

// node_modules/aws-sdk/apis/license-manager-linux-subscriptions-2018-05-10.min.json
var require_license_manager_linux_subscriptions_2018_05_10_min = __commonJS({
  "node_modules/aws-sdk/apis/license-manager-linux-subscriptions-2018-05-10.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-05-10",
        endpointPrefix: "license-manager-linux-subscriptions",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS License Manager Linux Subscriptions",
        serviceId: "License Manager Linux Subscriptions",
        signatureVersion: "v4",
        signingName: "license-manager-linux-subscriptions",
        uid: "license-manager-linux-subscriptions-2018-05-10"
      },
      operations: {
        GetServiceSettings: {
          http: {
            requestUri: "/subscription/GetServiceSettings",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              HomeRegions: {
                shape: "S3"
              },
              LinuxSubscriptionsDiscovery: {},
              LinuxSubscriptionsDiscoverySettings: {
                shape: "S6"
              },
              Status: {},
              StatusMessage: {
                shape: "S9"
              }
            }
          },
          idempotent: true
        },
        ListLinuxSubscriptionInstances: {
          http: {
            requestUri: "/subscription/ListLinuxSubscriptionInstances",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Sc"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Instances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AccountID: {},
                    AmiId: {},
                    InstanceID: {},
                    InstanceType: {},
                    LastUpdatedTime: {},
                    ProductCode: {
                      type: "list",
                      member: {}
                    },
                    Region: {},
                    Status: {},
                    SubscriptionName: {},
                    UsageOperation: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListLinuxSubscriptions: {
          http: {
            requestUri: "/subscription/ListLinuxSubscriptions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Sc"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Subscriptions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InstanceCount: {
                      type: "long"
                    },
                    Name: {},
                    Type: {}
                  }
                }
              }
            }
          },
          idempotent: true
        },
        UpdateServiceSettings: {
          http: {
            requestUri: "/subscription/UpdateServiceSettings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "LinuxSubscriptionsDiscovery",
              "LinuxSubscriptionsDiscoverySettings"
            ],
            members: {
              AllowUpdate: {
                type: "boolean"
              },
              LinuxSubscriptionsDiscovery: {},
              LinuxSubscriptionsDiscoverySettings: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HomeRegions: {
                shape: "S3"
              },
              LinuxSubscriptionsDiscovery: {},
              LinuxSubscriptionsDiscoverySettings: {
                shape: "S6"
              },
              Status: {},
              StatusMessage: {
                shape: "S9"
              }
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {}
        },
        S6: {
          type: "structure",
          required: [
            "OrganizationIntegration",
            "SourceRegions"
          ],
          members: {
            OrganizationIntegration: {},
            SourceRegions: {
              shape: "S3"
            }
          }
        },
        S9: {
          type: "map",
          key: {},
          value: {}
        },
        Sc: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Operator: {},
              Values: {
                shape: "S3"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/license-manager-linux-subscriptions-2018-05-10.paginators.json
var require_license_manager_linux_subscriptions_2018_05_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/license-manager-linux-subscriptions-2018-05-10.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListLinuxSubscriptionInstances: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Instances"
        },
        ListLinuxSubscriptions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Subscriptions"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/licensemanagerlinuxsubscriptions.js
var require_licensemanagerlinuxsubscriptions = __commonJS({
  "node_modules/aws-sdk/clients/licensemanagerlinuxsubscriptions.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["licensemanagerlinuxsubscriptions"] = {};
    AWS2.LicenseManagerLinuxSubscriptions = Service.defineService("licensemanagerlinuxsubscriptions", ["2018-05-10"]);
    Object.defineProperty(apiLoader.services["licensemanagerlinuxsubscriptions"], "2018-05-10", {
      get: function get() {
        var model = require_license_manager_linux_subscriptions_2018_05_10_min();
        model.paginators = require_license_manager_linux_subscriptions_2018_05_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.LicenseManagerLinuxSubscriptions;
  }
});

// node_modules/aws-sdk/apis/kendra-ranking-2022-10-19.min.json
var require_kendra_ranking_2022_10_19_min = __commonJS({
  "node_modules/aws-sdk/apis/kendra-ranking-2022-10-19.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2022-10-19",
        endpointPrefix: "kendra-ranking",
        jsonVersion: "1.0",
        protocol: "json",
        serviceAbbreviation: "Kendra Ranking",
        serviceFullName: "Amazon Kendra Intelligent Ranking",
        serviceId: "Kendra Ranking",
        signatureVersion: "v4",
        signingName: "kendra-ranking",
        targetPrefix: "AWSKendraRerankingFrontendService",
        uid: "kendra-ranking-2022-10-19"
      },
      operations: {
        CreateRescoreExecutionPlan: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Description: {},
              CapacityUnits: {
                shape: "S4"
              },
              Tags: {
                shape: "S6"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Id",
              "Arn"
            ],
            members: {
              Id: {},
              Arn: {}
            }
          }
        },
        DeleteRescoreExecutionPlan: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          }
        },
        DescribeRescoreExecutionPlan: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {},
              Arn: {},
              Name: {},
              Description: {},
              CapacityUnits: {
                shape: "S4"
              },
              CreatedAt: {
                type: "timestamp"
              },
              UpdatedAt: {
                type: "timestamp"
              },
              Status: {},
              ErrorMessage: {}
            }
          }
        },
        ListRescoreExecutionPlans: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SummaryItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Id: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    UpdatedAt: {
                      type: "timestamp"
                    },
                    Status: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S6"
              }
            }
          }
        },
        Rescore: {
          input: {
            type: "structure",
            required: [
              "RescoreExecutionPlanId",
              "SearchQuery",
              "Documents"
            ],
            members: {
              RescoreExecutionPlanId: {},
              SearchQuery: {},
              Documents: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Id",
                    "OriginalScore"
                  ],
                  members: {
                    Id: {},
                    GroupId: {},
                    Title: {},
                    Body: {},
                    TokenizedTitle: {
                      type: "list",
                      member: {}
                    },
                    TokenizedBody: {
                      type: "list",
                      member: {}
                    },
                    OriginalScore: {
                      type: "float"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RescoreId: {},
              ResultItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DocumentId: {},
                    Score: {
                      type: "float"
                    }
                  }
                }
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateRescoreExecutionPlan: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {},
              Name: {},
              Description: {},
              CapacityUnits: {
                shape: "S4"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          required: [
            "RescoreCapacityUnits"
          ],
          members: {
            RescoreCapacityUnits: {
              type: "integer"
            }
          }
        },
        S6: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/kendra-ranking-2022-10-19.paginators.json
var require_kendra_ranking_2022_10_19_paginators = __commonJS({
  "node_modules/aws-sdk/apis/kendra-ranking-2022-10-19.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListRescoreExecutionPlans: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/kendraranking.js
var require_kendraranking = __commonJS({
  "node_modules/aws-sdk/clients/kendraranking.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["kendraranking"] = {};
    AWS2.KendraRanking = Service.defineService("kendraranking", ["2022-10-19"]);
    Object.defineProperty(apiLoader.services["kendraranking"], "2022-10-19", {
      get: function get() {
        var model = require_kendra_ranking_2022_10_19_min();
        model.paginators = require_kendra_ranking_2022_10_19_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.KendraRanking;
  }
});

// node_modules/aws-sdk/apis/cleanrooms-2022-02-17.min.json
var require_cleanrooms_2022_02_17_min = __commonJS({
  "node_modules/aws-sdk/apis/cleanrooms-2022-02-17.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2022-02-17",
        endpointPrefix: "cleanrooms",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Clean Rooms Service",
        serviceId: "CleanRooms",
        signatureVersion: "v4",
        signingName: "cleanrooms",
        uid: "cleanrooms-2022-02-17"
      },
      operations: {
        BatchGetCollaborationAnalysisTemplate: {
          http: {
            requestUri: "/collaborations/{collaborationIdentifier}/batch-analysistemplates",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "collaborationIdentifier",
              "analysisTemplateArns"
            ],
            members: {
              collaborationIdentifier: {
                location: "uri",
                locationName: "collaborationIdentifier"
              },
              analysisTemplateArns: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "collaborationAnalysisTemplates",
              "errors"
            ],
            members: {
              collaborationAnalysisTemplates: {
                type: "list",
                member: {
                  shape: "S7"
                }
              },
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "code",
                    "message"
                  ],
                  members: {
                    arn: {},
                    code: {},
                    message: {}
                  }
                }
              }
            }
          }
        },
        BatchGetSchema: {
          http: {
            requestUri: "/collaborations/{collaborationIdentifier}/batch-schema",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "collaborationIdentifier",
              "names"
            ],
            members: {
              collaborationIdentifier: {
                location: "uri",
                locationName: "collaborationIdentifier"
              },
              names: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "schemas",
              "errors"
            ],
            members: {
              schemas: {
                type: "list",
                member: {
                  shape: "Sx"
                }
              },
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "code",
                    "message"
                  ],
                  members: {
                    name: {},
                    code: {},
                    message: {}
                  }
                }
              }
            }
          }
        },
        CreateAnalysisTemplate: {
          http: {
            requestUri: "/memberships/{membershipIdentifier}/analysistemplates",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "membershipIdentifier",
              "name",
              "format",
              "source"
            ],
            members: {
              description: {},
              membershipIdentifier: {
                location: "uri",
                locationName: "membershipIdentifier"
              },
              name: {},
              format: {},
              source: {
                shape: "Sj"
              },
              tags: {
                shape: "S1b"
              },
              analysisParameters: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "analysisTemplate"
            ],
            members: {
              analysisTemplate: {
                shape: "S1f"
              }
            }
          }
        },
        CreateCollaboration: {
          http: {
            requestUri: "/collaborations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "members",
              "name",
              "description",
              "creatorMemberAbilities",
              "creatorDisplayName",
              "queryLogStatus"
            ],
            members: {
              members: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "accountId",
                    "memberAbilities",
                    "displayName"
                  ],
                  members: {
                    accountId: {},
                    memberAbilities: {
                      shape: "S1k"
                    },
                    displayName: {},
                    paymentConfiguration: {
                      shape: "S1n"
                    }
                  }
                }
              },
              name: {},
              description: {},
              creatorMemberAbilities: {
                shape: "S1k"
              },
              creatorDisplayName: {},
              dataEncryptionMetadata: {
                shape: "S1s"
              },
              queryLogStatus: {},
              tags: {
                shape: "S1b"
              },
              creatorPaymentConfiguration: {
                shape: "S1n"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "collaboration"
            ],
            members: {
              collaboration: {
                shape: "S1v"
              }
            }
          }
        },
        CreateConfiguredAudienceModelAssociation: {
          http: {
            requestUri: "/memberships/{membershipIdentifier}/configuredaudiencemodelassociations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "membershipIdentifier",
              "configuredAudienceModelArn",
              "configuredAudienceModelAssociationName",
              "manageResourcePolicies"
            ],
            members: {
              membershipIdentifier: {
                location: "uri",
                locationName: "membershipIdentifier"
              },
              configuredAudienceModelArn: {},
              configuredAudienceModelAssociationName: {},
              manageResourcePolicies: {
                type: "boolean"
              },
              tags: {
                shape: "S1b"
              },
              description: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "configuredAudienceModelAssociation"
            ],
            members: {
              configuredAudienceModelAssociation: {
                shape: "S21"
              }
            }
          }
        },
        CreateConfiguredTable: {
          http: {
            requestUri: "/configuredTables",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "tableReference",
              "allowedColumns",
              "analysisMethod"
            ],
            members: {
              name: {},
              description: {},
              tableReference: {
                shape: "S25"
              },
              allowedColumns: {
                shape: "S29"
              },
              analysisMethod: {},
              tags: {
                shape: "S1b"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "configuredTable"
            ],
            members: {
              configuredTable: {
                shape: "S2b"
              }
            }
          },
          idempotent: true
        },
        CreateConfiguredTableAnalysisRule: {
          http: {
            requestUri: "/configuredTables/{configuredTableIdentifier}/analysisRule",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "configuredTableIdentifier",
              "analysisRuleType",
              "analysisRulePolicy"
            ],
            members: {
              configuredTableIdentifier: {
                location: "uri",
                locationName: "configuredTableIdentifier"
              },
              analysisRuleType: {},
              analysisRulePolicy: {
                shape: "S2h"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "analysisRule"
            ],
            members: {
              analysisRule: {
                shape: "S39"
              }
            }
          },
          idempotent: true
        },
        CreateConfiguredTableAssociation: {
          http: {
            requestUri: "/memberships/{membershipIdentifier}/configuredTableAssociations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "membershipIdentifier",
              "configuredTableIdentifier",
              "roleArn"
            ],
            members: {
              name: {},
              description: {},
              membershipIdentifier: {
                location: "uri",
                locationName: "membershipIdentifier"
              },
              configuredTableIdentifier: {},
              roleArn: {},
              tags: {
                shape: "S1b"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "configuredTableAssociation"
            ],
            members: {
              configuredTableAssociation: {
                shape: "S3d"
              }
            }
          }
        },
        CreateMembership: {
          http: {
            requestUri: "/memberships",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "collaborationIdentifier",
              "queryLogStatus"
            ],
            members: {
              collaborationIdentifier: {},
              queryLogStatus: {},
              tags: {
                shape: "S1b"
              },
              defaultResultConfiguration: {
                shape: "S3h"
              },
              paymentConfiguration: {
                shape: "S3n"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "membership"
            ],
            members: {
              membership: {
                shape: "S3q"
              }
            }
          }
        },
        CreatePrivacyBudgetTemplate: {
          http: {
            requestUri: "/memberships/{membershipIdentifier}/privacybudgettemplates",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "membershipIdentifier",
              "autoRefresh",
              "privacyBudgetType",
              "parameters"
            ],
            members: {
              membershipIdentifier: {
                location: "uri",
                locationName: "membershipIdentifier"
              },
              autoRefresh: {},
              privacyBudgetType: {},
              parameters: {
                type: "structure",
                members: {
                  differentialPrivacy: {
                    type: "structure",
                    required: [
                      "epsilon",
                      "usersNoisePerQuery"
                    ],
                    members: {
                      epsilon: {
                        type: "integer"
                      },
                      usersNoisePerQuery: {
                        type: "integer"
                      }
                    }
                  }
                },
                union: true
              },
              tags: {
                shape: "S1b"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "privacyBudgetTemplate"
            ],
            members: {
              privacyBudgetTemplate: {
                shape: "S40"
              }
            }
          }
        },
        DeleteAnalysisTemplate: {
          http: {
            method: "DELETE",
            requestUri: "/memberships/{membershipIdentifier}/analysistemplates/{analysisTemplateIdentifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "membershipIdentifier",
              "analysisTemplateIdentifier"
            ],
            members: {
              membershipIdentifier: {
                location: "uri",
                locationName: "membershipIdentifier"
              },
              analysisTemplateIdentifier: {
                location: "uri",
                locationName: "analysisTemplateIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteCollaboration: {
          http: {
            method: "DELETE",
            requestUri: "/collaborations/{collaborationIdentifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "collaborationIdentifier"
            ],
            members: {
              collaborationIdentifier: {
                location: "uri",
                locationName: "collaborationIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteConfiguredAudienceModelAssociation: {
          http: {
            method: "DELETE",
            requestUri: "/memberships/{membershipIdentifier}/configuredaudiencemodelassociations/{configuredAudienceModelAssociationIdentifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "configuredAudienceModelAssociationIdentifier",
              "membershipIdentifier"
            ],
            members: {
              configuredAudienceModelAssociationIdentifier: {
                location: "uri",
                locationName: "configuredAudienceModelAssociationIdentifier"
              },
              membershipIdentifier: {
                location: "uri",
                locationName: "membershipIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteConfiguredTable: {
          http: {
            method: "DELETE",
            requestUri: "/configuredTables/{configuredTableIdentifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "configuredTableIdentifier"
            ],
            members: {
              configuredTableIdentifier: {
                location: "uri",
                locationName: "configuredTableIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteConfiguredTableAnalysisRule: {
          http: {
            method: "DELETE",
            requestUri: "/configuredTables/{configuredTableIdentifier}/analysisRule/{analysisRuleType}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "configuredTableIdentifier",
              "analysisRuleType"
            ],
            members: {
              configuredTableIdentifier: {
                location: "uri",
                locationName: "configuredTableIdentifier"
              },
              analysisRuleType: {
                location: "uri",
                locationName: "analysisRuleType"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteConfiguredTableAssociation: {
          http: {
            method: "DELETE",
            requestUri: "/memberships/{membershipIdentifier}/configuredTableAssociations/{configuredTableAssociationIdentifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "configuredTableAssociationIdentifier",
              "membershipIdentifier"
            ],
            members: {
              configuredTableAssociationIdentifier: {
                location: "uri",
                locationName: "configuredTableAssociationIdentifier"
              },
              membershipIdentifier: {
                location: "uri",
                locationName: "membershipIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteMember: {
          http: {
            method: "DELETE",
            requestUri: "/collaborations/{collaborationIdentifier}/member/{accountId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "collaborationIdentifier",
              "accountId"
            ],
            members: {
              collaborationIdentifier: {
                location: "uri",
                locationName: "collaborationIdentifier"
              },
              accountId: {
                location: "uri",
                locationName: "accountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteMembership: {
          http: {
            method: "DELETE",
            requestUri: "/memberships/{membershipIdentifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "membershipIdentifier"
            ],
            members: {
              membershipIdentifier: {
                location: "uri",
                locationName: "membershipIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeletePrivacyBudgetTemplate: {
          http: {
            method: "DELETE",
            requestUri: "/memberships/{membershipIdentifier}/privacybudgettemplates/{privacyBudgetTemplateIdentifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "membershipIdentifier",
              "privacyBudgetTemplateIdentifier"
            ],
            members: {
              membershipIdentifier: {
                location: "uri",
                locationName: "membershipIdentifier"
              },
              privacyBudgetTemplateIdentifier: {
                location: "uri",
                locationName: "privacyBudgetTemplateIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        GetAnalysisTemplate: {
          http: {
            method: "GET",
            requestUri: "/memberships/{membershipIdentifier}/analysistemplates/{analysisTemplateIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "membershipIdentifier",
              "analysisTemplateIdentifier"
            ],
            members: {
              membershipIdentifier: {
                location: "uri",
                locationName: "membershipIdentifier"
              },
              analysisTemplateIdentifier: {
                location: "uri",
                locationName: "analysisTemplateIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "analysisTemplate"
            ],
            members: {
              analysisTemplate: {
                shape: "S1f"
              }
            }
          }
        },
        GetCollaboration: {
          http: {
            method: "GET",
            requestUri: "/collaborations/{collaborationIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "collaborationIdentifier"
            ],
            members: {
              collaborationIdentifier: {
                location: "uri",
                locationName: "collaborationIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "collaboration"
            ],
            members: {
              collaboration: {
                shape: "S1v"
              }
            }
          }
        },
        GetCollaborationAnalysisTemplate: {
          http: {
            method: "GET",
            requestUri: "/collaborations/{collaborationIdentifier}/analysistemplates/{analysisTemplateArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "collaborationIdentifier",
              "analysisTemplateArn"
            ],
            members: {
              collaborationIdentifier: {
                location: "uri",
                locationName: "collaborationIdentifier"
              },
              analysisTemplateArn: {
                location: "uri",
                locationName: "analysisTemplateArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "collaborationAnalysisTemplate"
            ],
            members: {
              collaborationAnalysisTemplate: {
                shape: "S7"
              }
            }
          }
        },
        GetCollaborationConfiguredAudienceModelAssociation: {
          http: {
            method: "GET",
            requestUri: "/collaborations/{collaborationIdentifier}/configuredaudiencemodelassociations/{configuredAudienceModelAssociationIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "collaborationIdentifier",
              "configuredAudienceModelAssociationIdentifier"
            ],
            members: {
              collaborationIdentifier: {
                location: "uri",
                locationName: "collaborationIdentifier"
              },
              configuredAudienceModelAssociationIdentifier: {
                location: "uri",
                locationName: "configuredAudienceModelAssociationIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "collaborationConfiguredAudienceModelAssociation"
            ],
            members: {
              collaborationConfiguredAudienceModelAssociation: {
                type: "structure",
                required: [
                  "id",
                  "arn",
                  "collaborationId",
                  "collaborationArn",
                  "configuredAudienceModelArn",
                  "name",
                  "creatorAccountId",
                  "createTime",
                  "updateTime"
                ],
                members: {
                  id: {},
                  arn: {},
                  collaborationId: {},
                  collaborationArn: {},
                  configuredAudienceModelArn: {},
                  name: {},
                  description: {},
                  creatorAccountId: {},
                  createTime: {
                    type: "timestamp"
                  },
                  updateTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        GetCollaborationPrivacyBudgetTemplate: {
          http: {
            method: "GET",
            requestUri: "/collaborations/{collaborationIdentifier}/privacybudgettemplates/{privacyBudgetTemplateIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "collaborationIdentifier",
              "privacyBudgetTemplateIdentifier"
            ],
            members: {
              collaborationIdentifier: {
                location: "uri",
                locationName: "collaborationIdentifier"
              },
              privacyBudgetTemplateIdentifier: {
                location: "uri",
                locationName: "privacyBudgetTemplateIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "collaborationPrivacyBudgetTemplate"
            ],
            members: {
              collaborationPrivacyBudgetTemplate: {
                type: "structure",
                required: [
                  "id",
                  "arn",
                  "collaborationId",
                  "collaborationArn",
                  "creatorAccountId",
                  "createTime",
                  "updateTime",
                  "privacyBudgetType",
                  "autoRefresh",
                  "parameters"
                ],
                members: {
                  id: {},
                  arn: {},
                  collaborationId: {},
                  collaborationArn: {},
                  creatorAccountId: {},
                  createTime: {
                    type: "timestamp"
                  },
                  updateTime: {
                    type: "timestamp"
                  },
                  privacyBudgetType: {},
                  autoRefresh: {},
                  parameters: {
                    shape: "S43"
                  }
                }
              }
            }
          }
        },
        GetConfiguredAudienceModelAssociation: {
          http: {
            method: "GET",
            requestUri: "/memberships/{membershipIdentifier}/configuredaudiencemodelassociations/{configuredAudienceModelAssociationIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "configuredAudienceModelAssociationIdentifier",
              "membershipIdentifier"
            ],
            members: {
              configuredAudienceModelAssociationIdentifier: {
                location: "uri",
                locationName: "configuredAudienceModelAssociationIdentifier"
              },
              membershipIdentifier: {
                location: "uri",
                locationName: "membershipIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "configuredAudienceModelAssociation"
            ],
            members: {
              configuredAudienceModelAssociation: {
                shape: "S21"
              }
            }
          }
        },
        GetConfiguredTable: {
          http: {
            method: "GET",
            requestUri: "/configuredTables/{configuredTableIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "configuredTableIdentifier"
            ],
            members: {
              configuredTableIdentifier: {
                location: "uri",
                locationName: "configuredTableIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "configuredTable"
            ],
            members: {
              configuredTable: {
                shape: "S2b"
              }
            }
          }
        },
        GetConfiguredTableAnalysisRule: {
          http: {
            method: "GET",
            requestUri: "/configuredTables/{configuredTableIdentifier}/analysisRule/{analysisRuleType}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "configuredTableIdentifier",
              "analysisRuleType"
            ],
            members: {
              configuredTableIdentifier: {
                location: "uri",
                locationName: "configuredTableIdentifier"
              },
              analysisRuleType: {
                location: "uri",
                locationName: "analysisRuleType"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "analysisRule"
            ],
            members: {
              analysisRule: {
                shape: "S39"
              }
            }
          }
        },
        GetConfiguredTableAssociation: {
          http: {
            method: "GET",
            requestUri: "/memberships/{membershipIdentifier}/configuredTableAssociations/{configuredTableAssociationIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "configuredTableAssociationIdentifier",
              "membershipIdentifier"
            ],
            members: {
              configuredTableAssociationIdentifier: {
                location: "uri",
                locationName: "configuredTableAssociationIdentifier"
              },
              membershipIdentifier: {
                location: "uri",
                locationName: "membershipIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "configuredTableAssociation"
            ],
            members: {
              configuredTableAssociation: {
                shape: "S3d"
              }
            }
          }
        },
        GetMembership: {
          http: {
            method: "GET",
            requestUri: "/memberships/{membershipIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "membershipIdentifier"
            ],
            members: {
              membershipIdentifier: {
                location: "uri",
                locationName: "membershipIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "membership"
            ],
            members: {
              membership: {
                shape: "S3q"
              }
            }
          }
        },
        GetPrivacyBudgetTemplate: {
          http: {
            method: "GET",
            requestUri: "/memberships/{membershipIdentifier}/privacybudgettemplates/{privacyBudgetTemplateIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "membershipIdentifier",
              "privacyBudgetTemplateIdentifier"
            ],
            members: {
              membershipIdentifier: {
                location: "uri",
                locationName: "membershipIdentifier"
              },
              privacyBudgetTemplateIdentifier: {
                location: "uri",
                locationName: "privacyBudgetTemplateIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "privacyBudgetTemplate"
            ],
            members: {
              privacyBudgetTemplate: {
                shape: "S40"
              }
            }
          }
        },
        GetProtectedQuery: {
          http: {
            method: "GET",
            requestUri: "/memberships/{membershipIdentifier}/protectedQueries/{protectedQueryIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "membershipIdentifier",
              "protectedQueryIdentifier"
            ],
            members: {
              membershipIdentifier: {
                location: "uri",
                locationName: "membershipIdentifier"
              },
              protectedQueryIdentifier: {
                location: "uri",
                locationName: "protectedQueryIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "protectedQuery"
            ],
            members: {
              protectedQuery: {
                shape: "S5f"
              }
            }
          }
        },
        GetSchema: {
          http: {
            method: "GET",
            requestUri: "/collaborations/{collaborationIdentifier}/schemas/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "collaborationIdentifier",
              "name"
            ],
            members: {
              collaborationIdentifier: {
                location: "uri",
                locationName: "collaborationIdentifier"
              },
              name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "schema"
            ],
            members: {
              schema: {
                shape: "Sx"
              }
            }
          }
        },
        GetSchemaAnalysisRule: {
          http: {
            method: "GET",
            requestUri: "/collaborations/{collaborationIdentifier}/schemas/{name}/analysisRule/{type}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "collaborationIdentifier",
              "name",
              "type"
            ],
            members: {
              collaborationIdentifier: {
                location: "uri",
                locationName: "collaborationIdentifier"
              },
              name: {
                location: "uri",
                locationName: "name"
              },
              type: {
                location: "uri",
                locationName: "type"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "analysisRule"
            ],
            members: {
              analysisRule: {
                type: "structure",
                required: [
                  "collaborationId",
                  "type",
                  "name",
                  "createTime",
                  "updateTime",
                  "policy"
                ],
                members: {
                  collaborationId: {},
                  type: {},
                  name: {},
                  createTime: {
                    type: "timestamp"
                  },
                  updateTime: {
                    type: "timestamp"
                  },
                  policy: {
                    type: "structure",
                    members: {
                      v1: {
                        type: "structure",
                        members: {
                          list: {
                            shape: "S2j"
                          },
                          aggregation: {
                            shape: "S2p"
                          },
                          custom: {
                            shape: "S31"
                          }
                        },
                        union: true
                      }
                    },
                    union: true
                  }
                }
              }
            }
          }
        },
        ListAnalysisTemplates: {
          http: {
            method: "GET",
            requestUri: "/memberships/{membershipIdentifier}/analysistemplates",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "membershipIdentifier"
            ],
            members: {
              membershipIdentifier: {
                location: "uri",
                locationName: "membershipIdentifier"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "analysisTemplateSummaries"
            ],
            members: {
              nextToken: {},
              analysisTemplateSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createTime",
                    "id",
                    "name",
                    "updateTime",
                    "membershipArn",
                    "membershipId",
                    "collaborationArn",
                    "collaborationId"
                  ],
                  members: {
                    arn: {},
                    createTime: {
                      type: "timestamp"
                    },
                    id: {},
                    name: {},
                    updateTime: {
                      type: "timestamp"
                    },
                    membershipArn: {},
                    membershipId: {},
                    collaborationArn: {},
                    collaborationId: {},
                    description: {}
                  }
                }
              }
            }
          }
        },
        ListCollaborationAnalysisTemplates: {
          http: {
            method: "GET",
            requestUri: "/collaborations/{collaborationIdentifier}/analysistemplates",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "collaborationIdentifier"
            ],
            members: {
              collaborationIdentifier: {
                location: "uri",
                locationName: "collaborationIdentifier"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "collaborationAnalysisTemplateSummaries"
            ],
            members: {
              nextToken: {},
              collaborationAnalysisTemplateSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createTime",
                    "id",
                    "name",
                    "updateTime",
                    "collaborationArn",
                    "collaborationId",
                    "creatorAccountId"
                  ],
                  members: {
                    arn: {},
                    createTime: {
                      type: "timestamp"
                    },
                    id: {},
                    name: {},
                    updateTime: {
                      type: "timestamp"
                    },
                    collaborationArn: {},
                    collaborationId: {},
                    creatorAccountId: {},
                    description: {}
                  }
                }
              }
            }
          }
        },
        ListCollaborationConfiguredAudienceModelAssociations: {
          http: {
            method: "GET",
            requestUri: "/collaborations/{collaborationIdentifier}/configuredaudiencemodelassociations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "collaborationIdentifier"
            ],
            members: {
              collaborationIdentifier: {
                location: "uri",
                locationName: "collaborationIdentifier"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "collaborationConfiguredAudienceModelAssociationSummaries"
            ],
            members: {
              collaborationConfiguredAudienceModelAssociationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createTime",
                    "id",
                    "name",
                    "updateTime",
                    "collaborationArn",
                    "collaborationId",
                    "creatorAccountId"
                  ],
                  members: {
                    arn: {},
                    createTime: {
                      type: "timestamp"
                    },
                    id: {},
                    name: {},
                    updateTime: {
                      type: "timestamp"
                    },
                    collaborationArn: {},
                    collaborationId: {},
                    creatorAccountId: {},
                    description: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListCollaborationPrivacyBudgetTemplates: {
          http: {
            method: "GET",
            requestUri: "/collaborations/{collaborationIdentifier}/privacybudgettemplates",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "collaborationIdentifier"
            ],
            members: {
              collaborationIdentifier: {
                location: "uri",
                locationName: "collaborationIdentifier"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "collaborationPrivacyBudgetTemplateSummaries"
            ],
            members: {
              nextToken: {},
              collaborationPrivacyBudgetTemplateSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "arn",
                    "collaborationId",
                    "collaborationArn",
                    "creatorAccountId",
                    "privacyBudgetType",
                    "createTime",
                    "updateTime"
                  ],
                  members: {
                    id: {},
                    arn: {},
                    collaborationId: {},
                    collaborationArn: {},
                    creatorAccountId: {},
                    privacyBudgetType: {},
                    createTime: {
                      type: "timestamp"
                    },
                    updateTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListCollaborationPrivacyBudgets: {
          http: {
            method: "GET",
            requestUri: "/collaborations/{collaborationIdentifier}/privacybudgets",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "collaborationIdentifier",
              "privacyBudgetType"
            ],
            members: {
              collaborationIdentifier: {
                location: "uri",
                locationName: "collaborationIdentifier"
              },
              privacyBudgetType: {
                location: "querystring",
                locationName: "privacyBudgetType"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "collaborationPrivacyBudgetSummaries"
            ],
            members: {
              collaborationPrivacyBudgetSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "privacyBudgetTemplateId",
                    "privacyBudgetTemplateArn",
                    "collaborationId",
                    "collaborationArn",
                    "creatorAccountId",
                    "type",
                    "createTime",
                    "updateTime",
                    "budget"
                  ],
                  members: {
                    id: {},
                    privacyBudgetTemplateId: {},
                    privacyBudgetTemplateArn: {},
                    collaborationId: {},
                    collaborationArn: {},
                    creatorAccountId: {},
                    type: {},
                    createTime: {
                      type: "timestamp"
                    },
                    updateTime: {
                      type: "timestamp"
                    },
                    budget: {
                      shape: "S6u"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListCollaborations: {
          http: {
            method: "GET",
            requestUri: "/collaborations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              memberStatus: {
                location: "querystring",
                locationName: "memberStatus"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "collaborationList"
            ],
            members: {
              nextToken: {},
              collaborationList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "arn",
                    "name",
                    "creatorAccountId",
                    "creatorDisplayName",
                    "createTime",
                    "updateTime",
                    "memberStatus"
                  ],
                  members: {
                    id: {},
                    arn: {},
                    name: {},
                    creatorAccountId: {},
                    creatorDisplayName: {},
                    createTime: {
                      type: "timestamp"
                    },
                    updateTime: {
                      type: "timestamp"
                    },
                    memberStatus: {},
                    membershipId: {},
                    membershipArn: {}
                  }
                }
              }
            }
          }
        },
        ListConfiguredAudienceModelAssociations: {
          http: {
            method: "GET",
            requestUri: "/memberships/{membershipIdentifier}/configuredaudiencemodelassociations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "membershipIdentifier"
            ],
            members: {
              membershipIdentifier: {
                location: "uri",
                locationName: "membershipIdentifier"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "configuredAudienceModelAssociationSummaries"
            ],
            members: {
              configuredAudienceModelAssociationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "membershipId",
                    "membershipArn",
                    "collaborationArn",
                    "collaborationId",
                    "createTime",
                    "updateTime",
                    "id",
                    "arn",
                    "name",
                    "configuredAudienceModelArn"
                  ],
                  members: {
                    membershipId: {},
                    membershipArn: {},
                    collaborationArn: {},
                    collaborationId: {},
                    createTime: {
                      type: "timestamp"
                    },
                    updateTime: {
                      type: "timestamp"
                    },
                    id: {},
                    arn: {},
                    name: {},
                    configuredAudienceModelArn: {},
                    description: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListConfiguredTableAssociations: {
          http: {
            method: "GET",
            requestUri: "/memberships/{membershipIdentifier}/configuredTableAssociations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "membershipIdentifier"
            ],
            members: {
              membershipIdentifier: {
                location: "uri",
                locationName: "membershipIdentifier"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "configuredTableAssociationSummaries"
            ],
            members: {
              configuredTableAssociationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "configuredTableId",
                    "membershipId",
                    "membershipArn",
                    "name",
                    "createTime",
                    "updateTime",
                    "id",
                    "arn"
                  ],
                  members: {
                    configuredTableId: {},
                    membershipId: {},
                    membershipArn: {},
                    name: {},
                    createTime: {
                      type: "timestamp"
                    },
                    updateTime: {
                      type: "timestamp"
                    },
                    id: {},
                    arn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListConfiguredTables: {
          http: {
            method: "GET",
            requestUri: "/configuredTables",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "configuredTableSummaries"
            ],
            members: {
              configuredTableSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "arn",
                    "name",
                    "createTime",
                    "updateTime",
                    "analysisRuleTypes",
                    "analysisMethod"
                  ],
                  members: {
                    id: {},
                    arn: {},
                    name: {},
                    createTime: {
                      type: "timestamp"
                    },
                    updateTime: {
                      type: "timestamp"
                    },
                    analysisRuleTypes: {
                      shape: "S2d"
                    },
                    analysisMethod: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListMembers: {
          http: {
            method: "GET",
            requestUri: "/collaborations/{collaborationIdentifier}/members",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "collaborationIdentifier"
            ],
            members: {
              collaborationIdentifier: {
                location: "uri",
                locationName: "collaborationIdentifier"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "memberSummaries"
            ],
            members: {
              nextToken: {},
              memberSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "accountId",
                    "status",
                    "displayName",
                    "abilities",
                    "createTime",
                    "updateTime",
                    "paymentConfiguration"
                  ],
                  members: {
                    accountId: {},
                    status: {},
                    displayName: {},
                    abilities: {
                      shape: "S1k"
                    },
                    createTime: {
                      type: "timestamp"
                    },
                    updateTime: {
                      type: "timestamp"
                    },
                    membershipId: {},
                    membershipArn: {},
                    paymentConfiguration: {
                      shape: "S1n"
                    }
                  }
                }
              }
            }
          }
        },
        ListMemberships: {
          http: {
            method: "GET",
            requestUri: "/memberships",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              status: {
                location: "querystring",
                locationName: "status"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "membershipSummaries"
            ],
            members: {
              nextToken: {},
              membershipSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "arn",
                    "collaborationArn",
                    "collaborationId",
                    "collaborationCreatorAccountId",
                    "collaborationCreatorDisplayName",
                    "collaborationName",
                    "createTime",
                    "updateTime",
                    "status",
                    "memberAbilities",
                    "paymentConfiguration"
                  ],
                  members: {
                    id: {},
                    arn: {},
                    collaborationArn: {},
                    collaborationId: {},
                    collaborationCreatorAccountId: {},
                    collaborationCreatorDisplayName: {},
                    collaborationName: {},
                    createTime: {
                      type: "timestamp"
                    },
                    updateTime: {
                      type: "timestamp"
                    },
                    status: {},
                    memberAbilities: {
                      shape: "S1k"
                    },
                    paymentConfiguration: {
                      shape: "S3n"
                    }
                  }
                }
              }
            }
          }
        },
        ListPrivacyBudgetTemplates: {
          http: {
            method: "GET",
            requestUri: "/memberships/{membershipIdentifier}/privacybudgettemplates",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "membershipIdentifier"
            ],
            members: {
              membershipIdentifier: {
                location: "uri",
                locationName: "membershipIdentifier"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "privacyBudgetTemplateSummaries"
            ],
            members: {
              nextToken: {},
              privacyBudgetTemplateSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "arn",
                    "membershipId",
                    "membershipArn",
                    "collaborationId",
                    "collaborationArn",
                    "privacyBudgetType",
                    "createTime",
                    "updateTime"
                  ],
                  members: {
                    id: {},
                    arn: {},
                    membershipId: {},
                    membershipArn: {},
                    collaborationId: {},
                    collaborationArn: {},
                    privacyBudgetType: {},
                    createTime: {
                      type: "timestamp"
                    },
                    updateTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListPrivacyBudgets: {
          http: {
            method: "GET",
            requestUri: "/memberships/{membershipIdentifier}/privacybudgets",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "membershipIdentifier",
              "privacyBudgetType"
            ],
            members: {
              membershipIdentifier: {
                location: "uri",
                locationName: "membershipIdentifier"
              },
              privacyBudgetType: {
                location: "querystring",
                locationName: "privacyBudgetType"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "privacyBudgetSummaries"
            ],
            members: {
              privacyBudgetSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "privacyBudgetTemplateId",
                    "privacyBudgetTemplateArn",
                    "membershipId",
                    "membershipArn",
                    "collaborationId",
                    "collaborationArn",
                    "type",
                    "createTime",
                    "updateTime",
                    "budget"
                  ],
                  members: {
                    id: {},
                    privacyBudgetTemplateId: {},
                    privacyBudgetTemplateArn: {},
                    membershipId: {},
                    membershipArn: {},
                    collaborationId: {},
                    collaborationArn: {},
                    type: {},
                    createTime: {
                      type: "timestamp"
                    },
                    updateTime: {
                      type: "timestamp"
                    },
                    budget: {
                      shape: "S6u"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListProtectedQueries: {
          http: {
            method: "GET",
            requestUri: "/memberships/{membershipIdentifier}/protectedQueries",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "membershipIdentifier"
            ],
            members: {
              membershipIdentifier: {
                location: "uri",
                locationName: "membershipIdentifier"
              },
              status: {
                location: "querystring",
                locationName: "status"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "protectedQueries"
            ],
            members: {
              nextToken: {},
              protectedQueries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "membershipId",
                    "membershipArn",
                    "createTime",
                    "status"
                  ],
                  members: {
                    id: {},
                    membershipId: {},
                    membershipArn: {},
                    createTime: {
                      type: "timestamp"
                    },
                    status: {}
                  }
                }
              }
            }
          }
        },
        ListSchemas: {
          http: {
            method: "GET",
            requestUri: "/collaborations/{collaborationIdentifier}/schemas",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "collaborationIdentifier"
            ],
            members: {
              collaborationIdentifier: {
                location: "uri",
                locationName: "collaborationIdentifier"
              },
              schemaType: {
                location: "querystring",
                locationName: "schemaType"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "schemaSummaries"
            ],
            members: {
              schemaSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "type",
                    "creatorAccountId",
                    "createTime",
                    "updateTime",
                    "collaborationId",
                    "collaborationArn",
                    "analysisRuleTypes"
                  ],
                  members: {
                    name: {},
                    type: {},
                    creatorAccountId: {},
                    createTime: {
                      type: "timestamp"
                    },
                    updateTime: {
                      type: "timestamp"
                    },
                    collaborationId: {},
                    collaborationArn: {},
                    analysisRuleTypes: {
                      shape: "S12"
                    },
                    analysisMethod: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "tags"
            ],
            members: {
              tags: {
                shape: "S1b"
              }
            }
          }
        },
        PreviewPrivacyImpact: {
          http: {
            requestUri: "/memberships/{membershipIdentifier}/previewprivacyimpact",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "membershipIdentifier",
              "parameters"
            ],
            members: {
              membershipIdentifier: {
                location: "uri",
                locationName: "membershipIdentifier"
              },
              parameters: {
                type: "structure",
                members: {
                  differentialPrivacy: {
                    type: "structure",
                    required: [
                      "epsilon",
                      "usersNoisePerQuery"
                    ],
                    members: {
                      epsilon: {
                        type: "integer"
                      },
                      usersNoisePerQuery: {
                        type: "integer"
                      }
                    }
                  }
                },
                union: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "privacyImpact"
            ],
            members: {
              privacyImpact: {
                type: "structure",
                members: {
                  differentialPrivacy: {
                    type: "structure",
                    required: [
                      "aggregations"
                    ],
                    members: {
                      aggregations: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "type",
                            "maxCount"
                          ],
                          members: {
                            type: {},
                            maxCount: {
                              type: "integer"
                            }
                          }
                        }
                      }
                    }
                  }
                },
                union: true
              }
            }
          }
        },
        StartProtectedQuery: {
          http: {
            requestUri: "/memberships/{membershipIdentifier}/protectedQueries",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "type",
              "membershipIdentifier",
              "sqlParameters"
            ],
            members: {
              type: {},
              membershipIdentifier: {
                location: "uri",
                locationName: "membershipIdentifier"
              },
              sqlParameters: {
                shape: "S5g"
              },
              resultConfiguration: {
                shape: "S5k"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "protectedQuery"
            ],
            members: {
              protectedQuery: {
                shape: "S5f"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S1b"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAnalysisTemplate: {
          http: {
            method: "PATCH",
            requestUri: "/memberships/{membershipIdentifier}/analysistemplates/{analysisTemplateIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "membershipIdentifier",
              "analysisTemplateIdentifier"
            ],
            members: {
              membershipIdentifier: {
                location: "uri",
                locationName: "membershipIdentifier"
              },
              analysisTemplateIdentifier: {
                location: "uri",
                locationName: "analysisTemplateIdentifier"
              },
              description: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "analysisTemplate"
            ],
            members: {
              analysisTemplate: {
                shape: "S1f"
              }
            }
          }
        },
        UpdateCollaboration: {
          http: {
            method: "PATCH",
            requestUri: "/collaborations/{collaborationIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "collaborationIdentifier"
            ],
            members: {
              collaborationIdentifier: {
                location: "uri",
                locationName: "collaborationIdentifier"
              },
              name: {},
              description: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "collaboration"
            ],
            members: {
              collaboration: {
                shape: "S1v"
              }
            }
          }
        },
        UpdateConfiguredAudienceModelAssociation: {
          http: {
            method: "PATCH",
            requestUri: "/memberships/{membershipIdentifier}/configuredaudiencemodelassociations/{configuredAudienceModelAssociationIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "configuredAudienceModelAssociationIdentifier",
              "membershipIdentifier"
            ],
            members: {
              configuredAudienceModelAssociationIdentifier: {
                location: "uri",
                locationName: "configuredAudienceModelAssociationIdentifier"
              },
              membershipIdentifier: {
                location: "uri",
                locationName: "membershipIdentifier"
              },
              description: {},
              name: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "configuredAudienceModelAssociation"
            ],
            members: {
              configuredAudienceModelAssociation: {
                shape: "S21"
              }
            }
          }
        },
        UpdateConfiguredTable: {
          http: {
            method: "PATCH",
            requestUri: "/configuredTables/{configuredTableIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "configuredTableIdentifier"
            ],
            members: {
              configuredTableIdentifier: {
                location: "uri",
                locationName: "configuredTableIdentifier"
              },
              name: {},
              description: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "configuredTable"
            ],
            members: {
              configuredTable: {
                shape: "S2b"
              }
            }
          }
        },
        UpdateConfiguredTableAnalysisRule: {
          http: {
            method: "PATCH",
            requestUri: "/configuredTables/{configuredTableIdentifier}/analysisRule/{analysisRuleType}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "configuredTableIdentifier",
              "analysisRuleType",
              "analysisRulePolicy"
            ],
            members: {
              configuredTableIdentifier: {
                location: "uri",
                locationName: "configuredTableIdentifier"
              },
              analysisRuleType: {
                location: "uri",
                locationName: "analysisRuleType"
              },
              analysisRulePolicy: {
                shape: "S2h"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "analysisRule"
            ],
            members: {
              analysisRule: {
                shape: "S39"
              }
            }
          }
        },
        UpdateConfiguredTableAssociation: {
          http: {
            method: "PATCH",
            requestUri: "/memberships/{membershipIdentifier}/configuredTableAssociations/{configuredTableAssociationIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "configuredTableAssociationIdentifier",
              "membershipIdentifier"
            ],
            members: {
              configuredTableAssociationIdentifier: {
                location: "uri",
                locationName: "configuredTableAssociationIdentifier"
              },
              membershipIdentifier: {
                location: "uri",
                locationName: "membershipIdentifier"
              },
              description: {},
              roleArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "configuredTableAssociation"
            ],
            members: {
              configuredTableAssociation: {
                shape: "S3d"
              }
            }
          }
        },
        UpdateMembership: {
          http: {
            method: "PATCH",
            requestUri: "/memberships/{membershipIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "membershipIdentifier"
            ],
            members: {
              membershipIdentifier: {
                location: "uri",
                locationName: "membershipIdentifier"
              },
              queryLogStatus: {},
              defaultResultConfiguration: {
                shape: "S3h"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "membership"
            ],
            members: {
              membership: {
                shape: "S3q"
              }
            }
          }
        },
        UpdatePrivacyBudgetTemplate: {
          http: {
            method: "PATCH",
            requestUri: "/memberships/{membershipIdentifier}/privacybudgettemplates/{privacyBudgetTemplateIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "membershipIdentifier",
              "privacyBudgetTemplateIdentifier",
              "privacyBudgetType"
            ],
            members: {
              membershipIdentifier: {
                location: "uri",
                locationName: "membershipIdentifier"
              },
              privacyBudgetTemplateIdentifier: {
                location: "uri",
                locationName: "privacyBudgetTemplateIdentifier"
              },
              privacyBudgetType: {},
              parameters: {
                type: "structure",
                members: {
                  differentialPrivacy: {
                    type: "structure",
                    members: {
                      epsilon: {
                        type: "integer"
                      },
                      usersNoisePerQuery: {
                        type: "integer"
                      }
                    }
                  }
                },
                union: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "privacyBudgetTemplate"
            ],
            members: {
              privacyBudgetTemplate: {
                shape: "S40"
              }
            }
          }
        },
        UpdateProtectedQuery: {
          http: {
            method: "PATCH",
            requestUri: "/memberships/{membershipIdentifier}/protectedQueries/{protectedQueryIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "membershipIdentifier",
              "protectedQueryIdentifier",
              "targetStatus"
            ],
            members: {
              membershipIdentifier: {
                location: "uri",
                locationName: "membershipIdentifier"
              },
              protectedQueryIdentifier: {
                location: "uri",
                locationName: "protectedQueryIdentifier"
              },
              targetStatus: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "protectedQuery"
            ],
            members: {
              protectedQuery: {
                shape: "S5f"
              }
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S7: {
          type: "structure",
          required: [
            "id",
            "arn",
            "collaborationId",
            "collaborationArn",
            "creatorAccountId",
            "name",
            "createTime",
            "updateTime",
            "schema",
            "format",
            "source"
          ],
          members: {
            id: {},
            arn: {},
            collaborationId: {},
            collaborationArn: {},
            description: {},
            creatorAccountId: {},
            name: {},
            createTime: {
              type: "timestamp"
            },
            updateTime: {
              type: "timestamp"
            },
            schema: {
              shape: "Sf"
            },
            format: {},
            source: {
              shape: "Sj"
            },
            analysisParameters: {
              shape: "Sl"
            }
          }
        },
        Sf: {
          type: "structure",
          members: {
            referencedTables: {
              type: "list",
              member: {}
            }
          }
        },
        Sj: {
          type: "structure",
          members: {
            text: {}
          },
          sensitive: true,
          union: true
        },
        Sl: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "type"
            ],
            members: {
              name: {},
              type: {},
              defaultValue: {}
            },
            sensitive: true
          }
        },
        Sx: {
          type: "structure",
          required: [
            "columns",
            "partitionKeys",
            "analysisRuleTypes",
            "creatorAccountId",
            "name",
            "collaborationId",
            "collaborationArn",
            "description",
            "createTime",
            "updateTime",
            "type"
          ],
          members: {
            columns: {
              shape: "Sy"
            },
            partitionKeys: {
              shape: "Sy"
            },
            analysisRuleTypes: {
              shape: "S12"
            },
            analysisMethod: {},
            creatorAccountId: {},
            name: {},
            collaborationId: {},
            collaborationArn: {},
            description: {},
            createTime: {
              type: "timestamp"
            },
            updateTime: {
              type: "timestamp"
            },
            type: {}
          }
        },
        Sy: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "type"
            ],
            members: {
              name: {},
              type: {}
            }
          }
        },
        S12: {
          type: "list",
          member: {}
        },
        S1b: {
          type: "map",
          key: {},
          value: {}
        },
        S1f: {
          type: "structure",
          required: [
            "id",
            "arn",
            "collaborationId",
            "collaborationArn",
            "membershipId",
            "membershipArn",
            "name",
            "createTime",
            "updateTime",
            "schema",
            "format",
            "source"
          ],
          members: {
            id: {},
            arn: {},
            collaborationId: {},
            collaborationArn: {},
            membershipId: {},
            membershipArn: {},
            description: {},
            name: {},
            createTime: {
              type: "timestamp"
            },
            updateTime: {
              type: "timestamp"
            },
            schema: {
              shape: "Sf"
            },
            format: {},
            source: {
              shape: "Sj"
            },
            analysisParameters: {
              shape: "Sl"
            }
          }
        },
        S1k: {
          type: "list",
          member: {}
        },
        S1n: {
          type: "structure",
          required: [
            "queryCompute"
          ],
          members: {
            queryCompute: {
              type: "structure",
              required: [
                "isResponsible"
              ],
              members: {
                isResponsible: {
                  type: "boolean"
                }
              }
            }
          }
        },
        S1s: {
          type: "structure",
          required: [
            "allowCleartext",
            "allowDuplicates",
            "allowJoinsOnColumnsWithDifferentNames",
            "preserveNulls"
          ],
          members: {
            allowCleartext: {
              type: "boolean"
            },
            allowDuplicates: {
              type: "boolean"
            },
            allowJoinsOnColumnsWithDifferentNames: {
              type: "boolean"
            },
            preserveNulls: {
              type: "boolean"
            }
          }
        },
        S1v: {
          type: "structure",
          required: [
            "id",
            "arn",
            "name",
            "creatorAccountId",
            "creatorDisplayName",
            "createTime",
            "updateTime",
            "memberStatus",
            "queryLogStatus"
          ],
          members: {
            id: {},
            arn: {},
            name: {},
            description: {},
            creatorAccountId: {},
            creatorDisplayName: {},
            createTime: {
              type: "timestamp"
            },
            updateTime: {
              type: "timestamp"
            },
            memberStatus: {},
            membershipId: {},
            membershipArn: {},
            dataEncryptionMetadata: {
              shape: "S1s"
            },
            queryLogStatus: {}
          }
        },
        S21: {
          type: "structure",
          required: [
            "id",
            "arn",
            "configuredAudienceModelArn",
            "membershipId",
            "membershipArn",
            "collaborationId",
            "collaborationArn",
            "name",
            "manageResourcePolicies",
            "createTime",
            "updateTime"
          ],
          members: {
            id: {},
            arn: {},
            configuredAudienceModelArn: {},
            membershipId: {},
            membershipArn: {},
            collaborationId: {},
            collaborationArn: {},
            name: {},
            manageResourcePolicies: {
              type: "boolean"
            },
            description: {},
            createTime: {
              type: "timestamp"
            },
            updateTime: {
              type: "timestamp"
            }
          }
        },
        S25: {
          type: "structure",
          members: {
            glue: {
              type: "structure",
              required: [
                "tableName",
                "databaseName"
              ],
              members: {
                tableName: {},
                databaseName: {}
              }
            }
          },
          union: true
        },
        S29: {
          type: "list",
          member: {}
        },
        S2b: {
          type: "structure",
          required: [
            "id",
            "arn",
            "name",
            "tableReference",
            "createTime",
            "updateTime",
            "analysisRuleTypes",
            "analysisMethod",
            "allowedColumns"
          ],
          members: {
            id: {},
            arn: {},
            name: {},
            description: {},
            tableReference: {
              shape: "S25"
            },
            createTime: {
              type: "timestamp"
            },
            updateTime: {
              type: "timestamp"
            },
            analysisRuleTypes: {
              shape: "S2d"
            },
            analysisMethod: {},
            allowedColumns: {
              shape: "S29"
            }
          }
        },
        S2d: {
          type: "list",
          member: {}
        },
        S2h: {
          type: "structure",
          members: {
            v1: {
              type: "structure",
              members: {
                list: {
                  shape: "S2j"
                },
                aggregation: {
                  shape: "S2p"
                },
                custom: {
                  shape: "S31"
                }
              },
              union: true
            }
          },
          union: true
        },
        S2j: {
          type: "structure",
          required: [
            "joinColumns",
            "listColumns"
          ],
          members: {
            joinColumns: {
              type: "list",
              member: {}
            },
            allowedJoinOperators: {
              shape: "S2m"
            },
            listColumns: {
              shape: "S2o"
            }
          }
        },
        S2m: {
          type: "list",
          member: {}
        },
        S2o: {
          type: "list",
          member: {}
        },
        S2p: {
          type: "structure",
          required: [
            "aggregateColumns",
            "joinColumns",
            "dimensionColumns",
            "scalarFunctions",
            "outputConstraints"
          ],
          members: {
            aggregateColumns: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "columnNames",
                  "function"
                ],
                members: {
                  columnNames: {
                    type: "list",
                    member: {}
                  },
                  function: {}
                }
              }
            },
            joinColumns: {
              shape: "S2o"
            },
            joinRequired: {},
            allowedJoinOperators: {
              shape: "S2m"
            },
            dimensionColumns: {
              shape: "S2o"
            },
            scalarFunctions: {
              type: "list",
              member: {}
            },
            outputConstraints: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "columnName",
                  "minimum",
                  "type"
                ],
                members: {
                  columnName: {},
                  minimum: {
                    type: "integer"
                  },
                  type: {}
                }
              }
            }
          }
        },
        S31: {
          type: "structure",
          required: [
            "allowedAnalyses"
          ],
          members: {
            allowedAnalyses: {
              type: "list",
              member: {}
            },
            allowedAnalysisProviders: {
              type: "list",
              member: {}
            },
            differentialPrivacy: {
              type: "structure",
              required: [
                "columns"
              ],
              members: {
                columns: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "name"
                    ],
                    members: {
                      name: {}
                    }
                  }
                }
              }
            }
          }
        },
        S39: {
          type: "structure",
          required: [
            "configuredTableId",
            "configuredTableArn",
            "policy",
            "type",
            "createTime",
            "updateTime"
          ],
          members: {
            configuredTableId: {},
            configuredTableArn: {},
            policy: {
              shape: "S2h"
            },
            type: {},
            createTime: {
              type: "timestamp"
            },
            updateTime: {
              type: "timestamp"
            }
          }
        },
        S3d: {
          type: "structure",
          required: [
            "arn",
            "id",
            "configuredTableId",
            "configuredTableArn",
            "membershipId",
            "membershipArn",
            "roleArn",
            "name",
            "createTime",
            "updateTime"
          ],
          members: {
            arn: {},
            id: {},
            configuredTableId: {},
            configuredTableArn: {},
            membershipId: {},
            membershipArn: {},
            roleArn: {},
            name: {},
            description: {},
            createTime: {
              type: "timestamp"
            },
            updateTime: {
              type: "timestamp"
            }
          }
        },
        S3h: {
          type: "structure",
          required: [
            "outputConfiguration"
          ],
          members: {
            outputConfiguration: {
              type: "structure",
              members: {
                s3: {
                  shape: "S3j"
                }
              },
              union: true
            },
            roleArn: {}
          }
        },
        S3j: {
          type: "structure",
          required: [
            "resultFormat",
            "bucket"
          ],
          members: {
            resultFormat: {},
            bucket: {},
            keyPrefix: {}
          }
        },
        S3n: {
          type: "structure",
          required: [
            "queryCompute"
          ],
          members: {
            queryCompute: {
              type: "structure",
              required: [
                "isResponsible"
              ],
              members: {
                isResponsible: {
                  type: "boolean"
                }
              }
            }
          }
        },
        S3q: {
          type: "structure",
          required: [
            "id",
            "arn",
            "collaborationArn",
            "collaborationId",
            "collaborationCreatorAccountId",
            "collaborationCreatorDisplayName",
            "collaborationName",
            "createTime",
            "updateTime",
            "status",
            "memberAbilities",
            "queryLogStatus",
            "paymentConfiguration"
          ],
          members: {
            id: {},
            arn: {},
            collaborationArn: {},
            collaborationId: {},
            collaborationCreatorAccountId: {},
            collaborationCreatorDisplayName: {},
            collaborationName: {},
            createTime: {
              type: "timestamp"
            },
            updateTime: {
              type: "timestamp"
            },
            status: {},
            memberAbilities: {
              shape: "S1k"
            },
            queryLogStatus: {},
            defaultResultConfiguration: {
              shape: "S3h"
            },
            paymentConfiguration: {
              shape: "S3n"
            }
          }
        },
        S40: {
          type: "structure",
          required: [
            "id",
            "arn",
            "membershipId",
            "membershipArn",
            "collaborationId",
            "collaborationArn",
            "createTime",
            "updateTime",
            "privacyBudgetType",
            "autoRefresh",
            "parameters"
          ],
          members: {
            id: {},
            arn: {},
            membershipId: {},
            membershipArn: {},
            collaborationId: {},
            collaborationArn: {},
            createTime: {
              type: "timestamp"
            },
            updateTime: {
              type: "timestamp"
            },
            privacyBudgetType: {},
            autoRefresh: {},
            parameters: {
              shape: "S43"
            }
          }
        },
        S43: {
          type: "structure",
          members: {
            differentialPrivacy: {
              type: "structure",
              required: [
                "epsilon",
                "usersNoisePerQuery"
              ],
              members: {
                epsilon: {
                  type: "integer"
                },
                usersNoisePerQuery: {
                  type: "integer"
                }
              }
            }
          },
          union: true
        },
        S5f: {
          type: "structure",
          required: [
            "id",
            "membershipId",
            "membershipArn",
            "createTime",
            "status"
          ],
          members: {
            id: {},
            membershipId: {},
            membershipArn: {},
            createTime: {
              type: "timestamp"
            },
            sqlParameters: {
              shape: "S5g"
            },
            status: {},
            resultConfiguration: {
              shape: "S5k"
            },
            statistics: {
              type: "structure",
              members: {
                totalDurationInMillis: {
                  type: "long"
                }
              }
            },
            result: {
              type: "structure",
              required: [
                "output"
              ],
              members: {
                output: {
                  type: "structure",
                  members: {
                    s3: {
                      type: "structure",
                      required: [
                        "location"
                      ],
                      members: {
                        location: {}
                      }
                    },
                    memberList: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "accountId"
                        ],
                        members: {
                          accountId: {}
                        }
                      }
                    }
                  },
                  union: true
                }
              }
            },
            error: {
              type: "structure",
              required: [
                "message",
                "code"
              ],
              members: {
                message: {},
                code: {}
              }
            },
            differentialPrivacy: {
              type: "structure",
              required: [
                "sensitivityParameters"
              ],
              members: {
                sensitivityParameters: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "aggregationType",
                      "aggregationExpression",
                      "userContributionLimit"
                    ],
                    members: {
                      aggregationType: {},
                      aggregationExpression: {},
                      userContributionLimit: {
                        type: "integer"
                      },
                      minColumnValue: {
                        type: "float"
                      },
                      maxColumnValue: {
                        type: "float"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S5g: {
          type: "structure",
          members: {
            queryString: {},
            analysisTemplateArn: {},
            parameters: {
              type: "map",
              key: {},
              value: {}
            }
          },
          sensitive: true
        },
        S5k: {
          type: "structure",
          required: [
            "outputConfiguration"
          ],
          members: {
            outputConfiguration: {
              type: "structure",
              members: {
                s3: {
                  shape: "S3j"
                }
              },
              union: true
            }
          }
        },
        S6u: {
          type: "structure",
          members: {
            differentialPrivacy: {
              type: "structure",
              required: [
                "aggregations",
                "epsilon"
              ],
              members: {
                aggregations: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "type",
                      "maxCount",
                      "remainingCount"
                    ],
                    members: {
                      type: {},
                      maxCount: {
                        type: "integer"
                      },
                      remainingCount: {
                        type: "integer"
                      }
                    }
                  }
                },
                epsilon: {
                  type: "integer"
                }
              }
            }
          },
          union: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cleanrooms-2022-02-17.paginators.json
var require_cleanrooms_2022_02_17_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cleanrooms-2022-02-17.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAnalysisTemplates: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "analysisTemplateSummaries"
        },
        ListCollaborationAnalysisTemplates: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "collaborationAnalysisTemplateSummaries"
        },
        ListCollaborationConfiguredAudienceModelAssociations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "collaborationConfiguredAudienceModelAssociationSummaries"
        },
        ListCollaborationPrivacyBudgetTemplates: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "collaborationPrivacyBudgetTemplateSummaries"
        },
        ListCollaborationPrivacyBudgets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "collaborationPrivacyBudgetSummaries"
        },
        ListCollaborations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "collaborationList"
        },
        ListConfiguredAudienceModelAssociations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "configuredAudienceModelAssociationSummaries"
        },
        ListConfiguredTableAssociations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "configuredTableAssociationSummaries"
        },
        ListConfiguredTables: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "configuredTableSummaries"
        },
        ListMembers: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "memberSummaries"
        },
        ListMemberships: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "membershipSummaries"
        },
        ListPrivacyBudgetTemplates: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "privacyBudgetTemplateSummaries"
        },
        ListPrivacyBudgets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "privacyBudgetSummaries"
        },
        ListProtectedQueries: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "protectedQueries"
        },
        ListSchemas: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "schemaSummaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cleanrooms-2022-02-17.waiters2.json
var require_cleanrooms_2022_02_17_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/cleanrooms-2022-02-17.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {}
    };
  }
});

// node_modules/aws-sdk/clients/cleanrooms.js
var require_cleanrooms = __commonJS({
  "node_modules/aws-sdk/clients/cleanrooms.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["cleanrooms"] = {};
    AWS2.CleanRooms = Service.defineService("cleanrooms", ["2022-02-17"]);
    Object.defineProperty(apiLoader.services["cleanrooms"], "2022-02-17", {
      get: function get() {
        var model = require_cleanrooms_2022_02_17_min();
        model.paginators = require_cleanrooms_2022_02_17_paginators().pagination;
        model.waiters = require_cleanrooms_2022_02_17_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CleanRooms;
  }
});

// node_modules/aws-sdk/apis/cloudtrail-data-2021-08-11.min.json
var require_cloudtrail_data_2021_08_11_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudtrail-data-2021-08-11.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-08-11",
        endpointPrefix: "cloudtrail-data",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS CloudTrail Data Service",
        serviceId: "CloudTrail Data",
        signatureVersion: "v4",
        signingName: "cloudtrail-data",
        uid: "cloudtrail-data-2021-08-11"
      },
      operations: {
        PutAuditEvents: {
          http: {
            requestUri: "/PutAuditEvents",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "auditEvents",
              "channelArn"
            ],
            members: {
              auditEvents: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "eventData",
                    "id"
                  ],
                  members: {
                    eventData: {},
                    eventDataChecksum: {},
                    id: {}
                  }
                }
              },
              channelArn: {
                location: "querystring",
                locationName: "channelArn"
              },
              externalId: {
                location: "querystring",
                locationName: "externalId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "failed",
              "successful"
            ],
            members: {
              failed: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "errorCode",
                    "errorMessage",
                    "id"
                  ],
                  members: {
                    errorCode: {},
                    errorMessage: {},
                    id: {}
                  }
                }
              },
              successful: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "eventID",
                    "id"
                  ],
                  members: {
                    eventID: {},
                    id: {}
                  }
                }
              }
            }
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/apis/cloudtrail-data-2021-08-11.paginators.json
var require_cloudtrail_data_2021_08_11_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloudtrail-data-2021-08-11.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/cloudtraildata.js
var require_cloudtraildata = __commonJS({
  "node_modules/aws-sdk/clients/cloudtraildata.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["cloudtraildata"] = {};
    AWS2.CloudTrailData = Service.defineService("cloudtraildata", ["2021-08-11"]);
    Object.defineProperty(apiLoader.services["cloudtraildata"], "2021-08-11", {
      get: function get() {
        var model = require_cloudtrail_data_2021_08_11_min();
        model.paginators = require_cloudtrail_data_2021_08_11_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CloudTrailData;
  }
});

// node_modules/aws-sdk/apis/tnb-2008-10-21.min.json
var require_tnb_2008_10_21_min = __commonJS({
  "node_modules/aws-sdk/apis/tnb-2008-10-21.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2008-10-21",
        endpointPrefix: "tnb",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Telco Network Builder",
        serviceId: "tnb",
        signatureVersion: "v4",
        signingName: "tnb",
        uid: "tnb-2008-10-21"
      },
      operations: {
        CancelSolNetworkOperation: {
          http: {
            requestUri: "/sol/nslcm/v1/ns_lcm_op_occs/{nsLcmOpOccId}/cancel",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "nsLcmOpOccId"
            ],
            members: {
              nsLcmOpOccId: {
                location: "uri",
                locationName: "nsLcmOpOccId"
              }
            }
          }
        },
        CreateSolFunctionPackage: {
          http: {
            requestUri: "/sol/vnfpkgm/v1/vnf_packages",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "id",
              "onboardingState",
              "operationalState",
              "usageState"
            ],
            members: {
              arn: {},
              id: {},
              onboardingState: {},
              operationalState: {},
              tags: {
                shape: "S4"
              },
              usageState: {}
            }
          }
        },
        CreateSolNetworkInstance: {
          http: {
            requestUri: "/sol/nslcm/v1/ns_instances",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "nsName",
              "nsdInfoId"
            ],
            members: {
              nsDescription: {},
              nsName: {},
              nsdInfoId: {},
              tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "id",
              "nsInstanceName",
              "nsdInfoId"
            ],
            members: {
              arn: {},
              id: {},
              nsInstanceName: {},
              nsdInfoId: {},
              tags: {
                shape: "S4"
              }
            }
          }
        },
        CreateSolNetworkPackage: {
          http: {
            requestUri: "/sol/nsd/v1/ns_descriptors",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "id",
              "nsdOnboardingState",
              "nsdOperationalState",
              "nsdUsageState"
            ],
            members: {
              arn: {},
              id: {},
              nsdOnboardingState: {},
              nsdOperationalState: {},
              nsdUsageState: {},
              tags: {
                shape: "S4"
              }
            }
          }
        },
        DeleteSolFunctionPackage: {
          http: {
            method: "DELETE",
            requestUri: "/sol/vnfpkgm/v1/vnf_packages/{vnfPkgId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "vnfPkgId"
            ],
            members: {
              vnfPkgId: {
                location: "uri",
                locationName: "vnfPkgId"
              }
            }
          },
          idempotent: true
        },
        DeleteSolNetworkInstance: {
          http: {
            method: "DELETE",
            requestUri: "/sol/nslcm/v1/ns_instances/{nsInstanceId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "nsInstanceId"
            ],
            members: {
              nsInstanceId: {
                location: "uri",
                locationName: "nsInstanceId"
              }
            }
          },
          idempotent: true
        },
        DeleteSolNetworkPackage: {
          http: {
            method: "DELETE",
            requestUri: "/sol/nsd/v1/ns_descriptors/{nsdInfoId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "nsdInfoId"
            ],
            members: {
              nsdInfoId: {
                location: "uri",
                locationName: "nsdInfoId"
              }
            }
          },
          idempotent: true
        },
        GetSolFunctionInstance: {
          http: {
            method: "GET",
            requestUri: "/sol/vnflcm/v1/vnf_instances/{vnfInstanceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "vnfInstanceId"
            ],
            members: {
              vnfInstanceId: {
                location: "uri",
                locationName: "vnfInstanceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "id",
              "instantiationState",
              "metadata",
              "nsInstanceId",
              "vnfPkgId",
              "vnfdId"
            ],
            members: {
              arn: {},
              id: {},
              instantiatedVnfInfo: {
                type: "structure",
                members: {
                  vnfState: {},
                  vnfcResourceInfo: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        metadata: {
                          type: "structure",
                          members: {
                            cluster: {},
                            helmChart: {},
                            nodeGroup: {}
                          }
                        }
                      }
                    }
                  }
                }
              },
              instantiationState: {},
              metadata: {
                type: "structure",
                required: [
                  "createdAt",
                  "lastModified"
                ],
                members: {
                  createdAt: {
                    shape: "S15"
                  },
                  lastModified: {
                    shape: "S15"
                  }
                }
              },
              nsInstanceId: {},
              tags: {
                shape: "S4"
              },
              vnfPkgId: {},
              vnfProductName: {},
              vnfProvider: {},
              vnfdId: {},
              vnfdVersion: {}
            }
          }
        },
        GetSolFunctionPackage: {
          http: {
            method: "GET",
            requestUri: "/sol/vnfpkgm/v1/vnf_packages/{vnfPkgId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "vnfPkgId"
            ],
            members: {
              vnfPkgId: {
                location: "uri",
                locationName: "vnfPkgId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "id",
              "onboardingState",
              "operationalState",
              "usageState"
            ],
            members: {
              arn: {},
              id: {},
              metadata: {
                type: "structure",
                required: [
                  "createdAt",
                  "lastModified"
                ],
                members: {
                  createdAt: {
                    shape: "S15"
                  },
                  lastModified: {
                    shape: "S15"
                  },
                  vnfd: {
                    shape: "S1a"
                  }
                }
              },
              onboardingState: {},
              operationalState: {},
              tags: {
                shape: "S4"
              },
              usageState: {},
              vnfProductName: {},
              vnfProvider: {},
              vnfdId: {},
              vnfdVersion: {}
            }
          }
        },
        GetSolFunctionPackageContent: {
          http: {
            method: "GET",
            requestUri: "/sol/vnfpkgm/v1/vnf_packages/{vnfPkgId}/package_content",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "accept",
              "vnfPkgId"
            ],
            members: {
              accept: {
                location: "header",
                locationName: "Accept"
              },
              vnfPkgId: {
                location: "uri",
                locationName: "vnfPkgId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              contentType: {
                location: "header",
                locationName: "Content-Type"
              },
              packageContent: {
                type: "blob"
              }
            },
            payload: "packageContent"
          }
        },
        GetSolFunctionPackageDescriptor: {
          http: {
            method: "GET",
            requestUri: "/sol/vnfpkgm/v1/vnf_packages/{vnfPkgId}/vnfd",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "accept",
              "vnfPkgId"
            ],
            members: {
              accept: {
                location: "header",
                locationName: "Accept"
              },
              vnfPkgId: {
                location: "uri",
                locationName: "vnfPkgId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              contentType: {
                location: "header",
                locationName: "Content-Type"
              },
              vnfd: {
                type: "blob"
              }
            },
            payload: "vnfd"
          }
        },
        GetSolNetworkInstance: {
          http: {
            method: "GET",
            requestUri: "/sol/nslcm/v1/ns_instances/{nsInstanceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "nsInstanceId"
            ],
            members: {
              nsInstanceId: {
                location: "uri",
                locationName: "nsInstanceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "id",
              "metadata",
              "nsInstanceDescription",
              "nsInstanceName",
              "nsdId",
              "nsdInfoId"
            ],
            members: {
              arn: {},
              id: {},
              lcmOpInfo: {
                type: "structure",
                required: [
                  "nsLcmOpOccId"
                ],
                members: {
                  nsLcmOpOccId: {}
                }
              },
              metadata: {
                type: "structure",
                required: [
                  "createdAt",
                  "lastModified"
                ],
                members: {
                  createdAt: {
                    shape: "S15"
                  },
                  lastModified: {
                    shape: "S15"
                  }
                }
              },
              nsInstanceDescription: {},
              nsInstanceName: {},
              nsState: {},
              nsdId: {},
              nsdInfoId: {},
              tags: {
                shape: "S4"
              }
            }
          }
        },
        GetSolNetworkOperation: {
          http: {
            method: "GET",
            requestUri: "/sol/nslcm/v1/ns_lcm_op_occs/{nsLcmOpOccId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "nsLcmOpOccId"
            ],
            members: {
              nsLcmOpOccId: {
                location: "uri",
                locationName: "nsLcmOpOccId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              error: {
                shape: "S1t"
              },
              id: {},
              lcmOperationType: {},
              metadata: {
                type: "structure",
                required: [
                  "createdAt",
                  "lastModified"
                ],
                members: {
                  createdAt: {
                    shape: "S15"
                  },
                  lastModified: {
                    shape: "S15"
                  }
                }
              },
              nsInstanceId: {},
              operationState: {},
              tags: {
                shape: "S4"
              },
              tasks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    taskContext: {
                      type: "map",
                      key: {},
                      value: {}
                    },
                    taskEndTime: {
                      shape: "S15"
                    },
                    taskErrorDetails: {
                      type: "structure",
                      members: {
                        cause: {},
                        details: {}
                      }
                    },
                    taskName: {},
                    taskStartTime: {
                      shape: "S15"
                    },
                    taskStatus: {}
                  }
                }
              }
            }
          }
        },
        GetSolNetworkPackage: {
          http: {
            method: "GET",
            requestUri: "/sol/nsd/v1/ns_descriptors/{nsdInfoId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "nsdInfoId"
            ],
            members: {
              nsdInfoId: {
                location: "uri",
                locationName: "nsdInfoId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "id",
              "metadata",
              "nsdId",
              "nsdName",
              "nsdOnboardingState",
              "nsdOperationalState",
              "nsdUsageState",
              "nsdVersion",
              "vnfPkgIds"
            ],
            members: {
              arn: {},
              id: {},
              metadata: {
                type: "structure",
                required: [
                  "createdAt",
                  "lastModified"
                ],
                members: {
                  createdAt: {
                    shape: "S15"
                  },
                  lastModified: {
                    shape: "S15"
                  },
                  nsd: {
                    shape: "S27"
                  }
                }
              },
              nsdId: {},
              nsdName: {},
              nsdOnboardingState: {},
              nsdOperationalState: {},
              nsdUsageState: {},
              nsdVersion: {},
              tags: {
                shape: "S4"
              },
              vnfPkgIds: {
                shape: "S28"
              }
            }
          }
        },
        GetSolNetworkPackageContent: {
          http: {
            method: "GET",
            requestUri: "/sol/nsd/v1/ns_descriptors/{nsdInfoId}/nsd_content",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "accept",
              "nsdInfoId"
            ],
            members: {
              accept: {
                location: "header",
                locationName: "Accept"
              },
              nsdInfoId: {
                location: "uri",
                locationName: "nsdInfoId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              contentType: {
                location: "header",
                locationName: "Content-Type"
              },
              nsdContent: {
                type: "blob"
              }
            },
            payload: "nsdContent"
          }
        },
        GetSolNetworkPackageDescriptor: {
          http: {
            method: "GET",
            requestUri: "/sol/nsd/v1/ns_descriptors/{nsdInfoId}/nsd",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "nsdInfoId"
            ],
            members: {
              nsdInfoId: {
                location: "uri",
                locationName: "nsdInfoId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              contentType: {
                location: "header",
                locationName: "Content-Type"
              },
              nsd: {
                type: "blob"
              }
            },
            payload: "nsd"
          }
        },
        InstantiateSolNetworkInstance: {
          http: {
            requestUri: "/sol/nslcm/v1/ns_instances/{nsInstanceId}/instantiate",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "nsInstanceId"
            ],
            members: {
              additionalParamsForNs: {
                shape: "S2e"
              },
              dryRun: {
                location: "querystring",
                locationName: "dry_run",
                type: "boolean"
              },
              nsInstanceId: {
                location: "uri",
                locationName: "nsInstanceId"
              },
              tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "nsLcmOpOccId"
            ],
            members: {
              nsLcmOpOccId: {},
              tags: {
                shape: "S4"
              }
            }
          }
        },
        ListSolFunctionInstances: {
          http: {
            method: "GET",
            requestUri: "/sol/vnflcm/v1/vnf_instances",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "max_results",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextpage_opaque_marker"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              functionInstances: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "id",
                    "instantiationState",
                    "metadata",
                    "nsInstanceId",
                    "vnfPkgId"
                  ],
                  members: {
                    arn: {},
                    id: {},
                    instantiatedVnfInfo: {
                      type: "structure",
                      members: {
                        vnfState: {}
                      }
                    },
                    instantiationState: {},
                    metadata: {
                      type: "structure",
                      required: [
                        "createdAt",
                        "lastModified"
                      ],
                      members: {
                        createdAt: {
                          shape: "S15"
                        },
                        lastModified: {
                          shape: "S15"
                        }
                      }
                    },
                    nsInstanceId: {},
                    vnfPkgId: {},
                    vnfPkgName: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSolFunctionPackages: {
          http: {
            method: "GET",
            requestUri: "/sol/vnfpkgm/v1/vnf_packages",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "max_results",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextpage_opaque_marker"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "functionPackages"
            ],
            members: {
              functionPackages: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "id",
                    "onboardingState",
                    "operationalState",
                    "usageState"
                  ],
                  members: {
                    arn: {},
                    id: {},
                    metadata: {
                      type: "structure",
                      required: [
                        "createdAt",
                        "lastModified"
                      ],
                      members: {
                        createdAt: {
                          shape: "S15"
                        },
                        lastModified: {
                          shape: "S15"
                        }
                      }
                    },
                    onboardingState: {},
                    operationalState: {},
                    usageState: {},
                    vnfProductName: {},
                    vnfProvider: {},
                    vnfdId: {},
                    vnfdVersion: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSolNetworkInstances: {
          http: {
            method: "GET",
            requestUri: "/sol/nslcm/v1/ns_instances",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "max_results",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextpage_opaque_marker"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              networkInstances: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "id",
                    "metadata",
                    "nsInstanceDescription",
                    "nsInstanceName",
                    "nsState",
                    "nsdId",
                    "nsdInfoId"
                  ],
                  members: {
                    arn: {},
                    id: {},
                    metadata: {
                      type: "structure",
                      required: [
                        "createdAt",
                        "lastModified"
                      ],
                      members: {
                        createdAt: {
                          shape: "S15"
                        },
                        lastModified: {
                          shape: "S15"
                        }
                      }
                    },
                    nsInstanceDescription: {},
                    nsInstanceName: {},
                    nsState: {},
                    nsdId: {},
                    nsdInfoId: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSolNetworkOperations: {
          http: {
            method: "GET",
            requestUri: "/sol/nslcm/v1/ns_lcm_op_occs",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "max_results",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextpage_opaque_marker"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              networkOperations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "id",
                    "lcmOperationType",
                    "nsInstanceId",
                    "operationState"
                  ],
                  members: {
                    arn: {},
                    error: {
                      shape: "S1t"
                    },
                    id: {},
                    lcmOperationType: {},
                    metadata: {
                      type: "structure",
                      required: [
                        "createdAt",
                        "lastModified"
                      ],
                      members: {
                        createdAt: {
                          shape: "S15"
                        },
                        lastModified: {
                          shape: "S15"
                        }
                      }
                    },
                    nsInstanceId: {},
                    operationState: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSolNetworkPackages: {
          http: {
            method: "GET",
            requestUri: "/sol/nsd/v1/ns_descriptors",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "max_results",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextpage_opaque_marker"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "networkPackages"
            ],
            members: {
              networkPackages: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "id",
                    "metadata",
                    "nsdOnboardingState",
                    "nsdOperationalState",
                    "nsdUsageState"
                  ],
                  members: {
                    arn: {},
                    id: {},
                    metadata: {
                      type: "structure",
                      required: [
                        "createdAt",
                        "lastModified"
                      ],
                      members: {
                        createdAt: {
                          shape: "S15"
                        },
                        lastModified: {
                          shape: "S15"
                        }
                      }
                    },
                    nsdDesigner: {},
                    nsdId: {},
                    nsdInvariantId: {},
                    nsdName: {},
                    nsdOnboardingState: {},
                    nsdOperationalState: {},
                    nsdUsageState: {},
                    nsdVersion: {},
                    vnfPkgIds: {
                      shape: "S28"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "tags"
            ],
            members: {
              tags: {
                shape: "S4"
              }
            }
          }
        },
        PutSolFunctionPackageContent: {
          http: {
            method: "PUT",
            requestUri: "/sol/vnfpkgm/v1/vnf_packages/{vnfPkgId}/package_content",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "file",
              "vnfPkgId"
            ],
            members: {
              contentType: {
                location: "header",
                locationName: "Content-Type"
              },
              file: {
                type: "blob"
              },
              vnfPkgId: {
                location: "uri",
                locationName: "vnfPkgId"
              }
            },
            payload: "file"
          },
          output: {
            type: "structure",
            required: [
              "id",
              "metadata",
              "vnfProductName",
              "vnfProvider",
              "vnfdId",
              "vnfdVersion"
            ],
            members: {
              id: {},
              metadata: {
                type: "structure",
                members: {
                  vnfd: {
                    shape: "S1a"
                  }
                }
              },
              vnfProductName: {},
              vnfProvider: {},
              vnfdId: {},
              vnfdVersion: {}
            }
          },
          idempotent: true
        },
        PutSolNetworkPackageContent: {
          http: {
            method: "PUT",
            requestUri: "/sol/nsd/v1/ns_descriptors/{nsdInfoId}/nsd_content",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "file",
              "nsdInfoId"
            ],
            members: {
              contentType: {
                location: "header",
                locationName: "Content-Type"
              },
              file: {
                type: "blob"
              },
              nsdInfoId: {
                location: "uri",
                locationName: "nsdInfoId"
              }
            },
            payload: "file"
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "id",
              "metadata",
              "nsdId",
              "nsdName",
              "nsdVersion",
              "vnfPkgIds"
            ],
            members: {
              arn: {},
              id: {},
              metadata: {
                type: "structure",
                members: {
                  nsd: {
                    shape: "S27"
                  }
                }
              },
              nsdId: {},
              nsdName: {},
              nsdVersion: {},
              vnfPkgIds: {
                shape: "S28"
              }
            }
          },
          idempotent: true
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        TerminateSolNetworkInstance: {
          http: {
            requestUri: "/sol/nslcm/v1/ns_instances/{nsInstanceId}/terminate",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "nsInstanceId"
            ],
            members: {
              nsInstanceId: {
                location: "uri",
                locationName: "nsInstanceId"
              },
              tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nsLcmOpOccId: {},
              tags: {
                shape: "S4"
              }
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateSolFunctionPackage: {
          http: {
            method: "PATCH",
            requestUri: "/sol/vnfpkgm/v1/vnf_packages/{vnfPkgId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "operationalState",
              "vnfPkgId"
            ],
            members: {
              operationalState: {},
              vnfPkgId: {
                location: "uri",
                locationName: "vnfPkgId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "operationalState"
            ],
            members: {
              operationalState: {}
            }
          }
        },
        UpdateSolNetworkInstance: {
          http: {
            requestUri: "/sol/nslcm/v1/ns_instances/{nsInstanceId}/update",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "nsInstanceId",
              "updateType"
            ],
            members: {
              modifyVnfInfoData: {
                type: "structure",
                required: [
                  "vnfConfigurableProperties",
                  "vnfInstanceId"
                ],
                members: {
                  vnfConfigurableProperties: {
                    shape: "S2e"
                  },
                  vnfInstanceId: {}
                }
              },
              nsInstanceId: {
                location: "uri",
                locationName: "nsInstanceId"
              },
              tags: {
                shape: "S4"
              },
              updateType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              nsLcmOpOccId: {},
              tags: {
                shape: "S4"
              }
            }
          }
        },
        UpdateSolNetworkPackage: {
          http: {
            method: "PATCH",
            requestUri: "/sol/nsd/v1/ns_descriptors/{nsdInfoId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "nsdInfoId",
              "nsdOperationalState"
            ],
            members: {
              nsdInfoId: {
                location: "uri",
                locationName: "nsdInfoId"
              },
              nsdOperationalState: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "nsdOperationalState"
            ],
            members: {
              nsdOperationalState: {}
            }
          }
        },
        ValidateSolFunctionPackageContent: {
          http: {
            method: "PUT",
            requestUri: "/sol/vnfpkgm/v1/vnf_packages/{vnfPkgId}/package_content/validate",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "file",
              "vnfPkgId"
            ],
            members: {
              contentType: {
                location: "header",
                locationName: "Content-Type"
              },
              file: {
                type: "blob"
              },
              vnfPkgId: {
                location: "uri",
                locationName: "vnfPkgId"
              }
            },
            payload: "file"
          },
          output: {
            type: "structure",
            required: [
              "id",
              "metadata",
              "vnfProductName",
              "vnfProvider",
              "vnfdId",
              "vnfdVersion"
            ],
            members: {
              id: {},
              metadata: {
                type: "structure",
                members: {
                  vnfd: {
                    shape: "S1a"
                  }
                }
              },
              vnfProductName: {},
              vnfProvider: {},
              vnfdId: {},
              vnfdVersion: {}
            }
          },
          idempotent: true
        },
        ValidateSolNetworkPackageContent: {
          http: {
            method: "PUT",
            requestUri: "/sol/nsd/v1/ns_descriptors/{nsdInfoId}/nsd_content/validate",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "file",
              "nsdInfoId"
            ],
            members: {
              contentType: {
                location: "header",
                locationName: "Content-Type"
              },
              file: {
                type: "blob"
              },
              nsdInfoId: {
                location: "uri",
                locationName: "nsdInfoId"
              }
            },
            payload: "file"
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "id",
              "metadata",
              "nsdId",
              "nsdName",
              "nsdVersion",
              "vnfPkgIds"
            ],
            members: {
              arn: {},
              id: {},
              metadata: {
                type: "structure",
                members: {
                  nsd: {
                    shape: "S27"
                  }
                }
              },
              nsdId: {},
              nsdName: {},
              nsdVersion: {},
              vnfPkgIds: {
                shape: "S28"
              }
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S4: {
          type: "map",
          key: {},
          value: {},
          sensitive: true
        },
        S15: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S1a: {
          type: "structure",
          members: {
            overrides: {
              shape: "S1b"
            }
          }
        },
        S1b: {
          type: "list",
          member: {
            type: "structure",
            members: {
              defaultValue: {},
              name: {}
            }
          }
        },
        S1t: {
          type: "structure",
          required: [
            "detail"
          ],
          members: {
            detail: {},
            title: {}
          }
        },
        S27: {
          type: "structure",
          members: {
            overrides: {
              shape: "S1b"
            }
          }
        },
        S28: {
          type: "list",
          member: {}
        },
        S2e: {
          type: "structure",
          members: {},
          document: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/tnb-2008-10-21.paginators.json
var require_tnb_2008_10_21_paginators = __commonJS({
  "node_modules/aws-sdk/apis/tnb-2008-10-21.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListSolFunctionInstances: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "functionInstances"
        },
        ListSolFunctionPackages: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "functionPackages"
        },
        ListSolNetworkInstances: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "networkInstances"
        },
        ListSolNetworkOperations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "networkOperations"
        },
        ListSolNetworkPackages: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "networkPackages"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/tnb.js
var require_tnb = __commonJS({
  "node_modules/aws-sdk/clients/tnb.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["tnb"] = {};
    AWS2.Tnb = Service.defineService("tnb", ["2008-10-21"]);
    Object.defineProperty(apiLoader.services["tnb"], "2008-10-21", {
      get: function get() {
        var model = require_tnb_2008_10_21_min();
        model.paginators = require_tnb_2008_10_21_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Tnb;
  }
});

// node_modules/aws-sdk/apis/internetmonitor-2021-06-03.min.json
var require_internetmonitor_2021_06_03_min = __commonJS({
  "node_modules/aws-sdk/apis/internetmonitor-2021-06-03.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-06-03",
        endpointPrefix: "internetmonitor",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon CloudWatch Internet Monitor",
        serviceId: "InternetMonitor",
        signatureVersion: "v4",
        signingName: "internetmonitor",
        uid: "internetmonitor-2021-06-03"
      },
      operations: {
        CreateMonitor: {
          http: {
            requestUri: "/v20210603/Monitors",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MonitorName"
            ],
            members: {
              MonitorName: {},
              Resources: {
                shape: "S3"
              },
              ClientToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S6"
              },
              MaxCityNetworksToMonitor: {
                type: "integer"
              },
              InternetMeasurementsLogDelivery: {
                shape: "Sa"
              },
              TrafficPercentageToMonitor: {
                type: "integer"
              },
              HealthEventsConfig: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Arn",
              "Status"
            ],
            members: {
              Arn: {},
              Status: {}
            }
          },
          idempotent: true
        },
        DeleteMonitor: {
          http: {
            method: "DELETE",
            requestUri: "/v20210603/Monitors/{MonitorName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MonitorName"
            ],
            members: {
              MonitorName: {
                location: "uri",
                locationName: "MonitorName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        GetHealthEvent: {
          http: {
            method: "GET",
            requestUri: "/v20210603/Monitors/{MonitorName}/HealthEvents/{EventId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MonitorName",
              "EventId"
            ],
            members: {
              MonitorName: {
                location: "uri",
                locationName: "MonitorName"
              },
              EventId: {
                location: "uri",
                locationName: "EventId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EventArn",
              "EventId",
              "StartedAt",
              "LastUpdatedAt",
              "ImpactedLocations",
              "Status",
              "ImpactType"
            ],
            members: {
              EventArn: {},
              EventId: {},
              StartedAt: {
                shape: "Sr"
              },
              EndedAt: {
                shape: "Sr"
              },
              CreatedAt: {
                shape: "Sr"
              },
              LastUpdatedAt: {
                shape: "Sr"
              },
              ImpactedLocations: {
                shape: "Ss"
              },
              Status: {},
              PercentOfTotalTrafficImpacted: {
                type: "double"
              },
              ImpactType: {},
              HealthScoreThreshold: {
                type: "double"
              }
            }
          }
        },
        GetMonitor: {
          http: {
            method: "GET",
            requestUri: "/v20210603/Monitors/{MonitorName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MonitorName"
            ],
            members: {
              MonitorName: {
                location: "uri",
                locationName: "MonitorName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "MonitorName",
              "MonitorArn",
              "Resources",
              "Status",
              "CreatedAt",
              "ModifiedAt"
            ],
            members: {
              MonitorName: {},
              MonitorArn: {},
              Resources: {
                shape: "S3"
              },
              Status: {},
              CreatedAt: {
                shape: "Sr"
              },
              ModifiedAt: {
                shape: "Sr"
              },
              ProcessingStatus: {},
              ProcessingStatusInfo: {},
              Tags: {
                shape: "S6"
              },
              MaxCityNetworksToMonitor: {
                type: "integer"
              },
              InternetMeasurementsLogDelivery: {
                shape: "Sa"
              },
              TrafficPercentageToMonitor: {
                type: "integer"
              },
              HealthEventsConfig: {
                shape: "Sf"
              }
            }
          }
        },
        GetQueryResults: {
          http: {
            method: "GET",
            requestUri: "/v20210603/Monitors/{MonitorName}/Queries/{QueryId}/Results",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MonitorName",
              "QueryId"
            ],
            members: {
              MonitorName: {
                location: "uri",
                locationName: "MonitorName"
              },
              QueryId: {
                location: "uri",
                locationName: "QueryId"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Fields",
              "Data"
            ],
            members: {
              Fields: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Type: {}
                  }
                }
              },
              Data: {
                type: "list",
                member: {
                  type: "list",
                  member: {}
                }
              },
              NextToken: {}
            }
          }
        },
        GetQueryStatus: {
          http: {
            method: "GET",
            requestUri: "/v20210603/Monitors/{MonitorName}/Queries/{QueryId}/Status",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MonitorName",
              "QueryId"
            ],
            members: {
              MonitorName: {
                location: "uri",
                locationName: "MonitorName"
              },
              QueryId: {
                location: "uri",
                locationName: "QueryId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Status"
            ],
            members: {
              Status: {}
            }
          }
        },
        ListHealthEvents: {
          http: {
            method: "GET",
            requestUri: "/v20210603/Monitors/{MonitorName}/HealthEvents",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MonitorName"
            ],
            members: {
              MonitorName: {
                location: "uri",
                locationName: "MonitorName"
              },
              StartTime: {
                shape: "Sr",
                location: "querystring",
                locationName: "StartTime"
              },
              EndTime: {
                shape: "Sr",
                location: "querystring",
                locationName: "EndTime"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              EventStatus: {
                location: "querystring",
                locationName: "EventStatus"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HealthEvents"
            ],
            members: {
              HealthEvents: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "EventArn",
                    "EventId",
                    "StartedAt",
                    "LastUpdatedAt",
                    "ImpactedLocations",
                    "Status",
                    "ImpactType"
                  ],
                  members: {
                    EventArn: {},
                    EventId: {},
                    StartedAt: {
                      shape: "Sr"
                    },
                    EndedAt: {
                      shape: "Sr"
                    },
                    CreatedAt: {
                      shape: "Sr"
                    },
                    LastUpdatedAt: {
                      shape: "Sr"
                    },
                    ImpactedLocations: {
                      shape: "Ss"
                    },
                    Status: {},
                    PercentOfTotalTrafficImpacted: {
                      type: "double"
                    },
                    ImpactType: {},
                    HealthScoreThreshold: {
                      type: "double"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListMonitors: {
          http: {
            method: "GET",
            requestUri: "/v20210603/Monitors",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              MonitorStatus: {
                location: "querystring",
                locationName: "MonitorStatus"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Monitors"
            ],
            members: {
              Monitors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "MonitorName",
                    "MonitorArn",
                    "Status"
                  ],
                  members: {
                    MonitorName: {},
                    MonitorArn: {},
                    Status: {},
                    ProcessingStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S6"
              }
            }
          }
        },
        StartQuery: {
          http: {
            requestUri: "/v20210603/Monitors/{MonitorName}/Queries",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MonitorName",
              "StartTime",
              "EndTime",
              "QueryType"
            ],
            members: {
              MonitorName: {
                location: "uri",
                locationName: "MonitorName"
              },
              StartTime: {
                shape: "Sr"
              },
              EndTime: {
                shape: "Sr"
              },
              QueryType: {},
              FilterParameters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Field: {},
                    Operator: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "QueryId"
            ],
            members: {
              QueryId: {}
            }
          }
        },
        StopQuery: {
          http: {
            method: "DELETE",
            requestUri: "/v20210603/Monitors/{MonitorName}/Queries/{QueryId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MonitorName",
              "QueryId"
            ],
            members: {
              MonitorName: {
                location: "uri",
                locationName: "MonitorName"
              },
              QueryId: {
                location: "uri",
                locationName: "QueryId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{ResourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateMonitor: {
          http: {
            method: "PATCH",
            requestUri: "/v20210603/Monitors/{MonitorName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MonitorName"
            ],
            members: {
              MonitorName: {
                location: "uri",
                locationName: "MonitorName"
              },
              ResourcesToAdd: {
                shape: "S3"
              },
              ResourcesToRemove: {
                shape: "S3"
              },
              Status: {},
              ClientToken: {
                idempotencyToken: true
              },
              MaxCityNetworksToMonitor: {
                type: "integer"
              },
              InternetMeasurementsLogDelivery: {
                shape: "Sa"
              },
              TrafficPercentageToMonitor: {
                type: "integer"
              },
              HealthEventsConfig: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "MonitorArn",
              "Status"
            ],
            members: {
              MonitorArn: {},
              Status: {}
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {}
        },
        S6: {
          type: "map",
          key: {},
          value: {}
        },
        Sa: {
          type: "structure",
          members: {
            S3Config: {
              type: "structure",
              members: {
                BucketName: {},
                BucketPrefix: {},
                LogDeliveryStatus: {}
              }
            }
          }
        },
        Sf: {
          type: "structure",
          members: {
            AvailabilityScoreThreshold: {
              type: "double"
            },
            PerformanceScoreThreshold: {
              type: "double"
            },
            AvailabilityLocalHealthEventsConfig: {
              shape: "Sh"
            },
            PerformanceLocalHealthEventsConfig: {
              shape: "Sh"
            }
          }
        },
        Sh: {
          type: "structure",
          members: {
            Status: {},
            HealthScoreThreshold: {
              type: "double"
            },
            MinTrafficImpact: {
              type: "double"
            }
          }
        },
        Sr: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        Ss: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ASName",
              "ASNumber",
              "Country",
              "Status"
            ],
            members: {
              ASName: {},
              ASNumber: {
                type: "long"
              },
              Country: {},
              Subdivision: {},
              Metro: {},
              City: {},
              Latitude: {
                type: "double"
              },
              Longitude: {
                type: "double"
              },
              CountryCode: {},
              SubdivisionCode: {},
              ServiceLocation: {},
              Status: {},
              CausedBy: {
                type: "structure",
                required: [
                  "Networks",
                  "AsPath",
                  "NetworkEventType"
                ],
                members: {
                  Networks: {
                    shape: "Sy"
                  },
                  AsPath: {
                    shape: "Sy"
                  },
                  NetworkEventType: {}
                }
              },
              InternetHealth: {
                type: "structure",
                members: {
                  Availability: {
                    type: "structure",
                    members: {
                      ExperienceScore: {
                        type: "double"
                      },
                      PercentOfTotalTrafficImpacted: {
                        type: "double"
                      },
                      PercentOfClientLocationImpacted: {
                        type: "double"
                      }
                    }
                  },
                  Performance: {
                    type: "structure",
                    members: {
                      ExperienceScore: {
                        type: "double"
                      },
                      PercentOfTotalTrafficImpacted: {
                        type: "double"
                      },
                      PercentOfClientLocationImpacted: {
                        type: "double"
                      },
                      RoundTripTime: {
                        type: "structure",
                        members: {
                          P50: {
                            type: "double"
                          },
                          P90: {
                            type: "double"
                          },
                          P95: {
                            type: "double"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sy: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ASName",
              "ASNumber"
            ],
            members: {
              ASName: {},
              ASNumber: {
                type: "long"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/internetmonitor-2021-06-03.paginators.json
var require_internetmonitor_2021_06_03_paginators = __commonJS({
  "node_modules/aws-sdk/apis/internetmonitor-2021-06-03.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetQueryResults: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListHealthEvents: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "HealthEvents"
        },
        ListMonitors: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Monitors"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/internetmonitor-2021-06-03.waiters2.json
var require_internetmonitor_2021_06_03_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/internetmonitor-2021-06-03.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {}
    };
  }
});

// node_modules/aws-sdk/clients/internetmonitor.js
var require_internetmonitor = __commonJS({
  "node_modules/aws-sdk/clients/internetmonitor.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["internetmonitor"] = {};
    AWS2.InternetMonitor = Service.defineService("internetmonitor", ["2021-06-03"]);
    Object.defineProperty(apiLoader.services["internetmonitor"], "2021-06-03", {
      get: function get() {
        var model = require_internetmonitor_2021_06_03_min();
        model.paginators = require_internetmonitor_2021_06_03_paginators().pagination;
        model.waiters = require_internetmonitor_2021_06_03_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.InternetMonitor;
  }
});

// node_modules/aws-sdk/apis/ivs-realtime-2020-07-14.min.json
var require_ivs_realtime_2020_07_14_min = __commonJS({
  "node_modules/aws-sdk/apis/ivs-realtime-2020-07-14.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-07-14",
        endpointPrefix: "ivsrealtime",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "ivsrealtime",
        serviceFullName: "Amazon Interactive Video Service RealTime",
        serviceId: "IVS RealTime",
        signatureVersion: "v4",
        signingName: "ivs",
        uid: "ivs-realtime-2020-07-14"
      },
      operations: {
        CreateEncoderConfiguration: {
          http: {
            requestUri: "/CreateEncoderConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              name: {},
              tags: {
                shape: "S3"
              },
              video: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              encoderConfiguration: {
                shape: "Sc"
              }
            }
          }
        },
        CreateParticipantToken: {
          http: {
            requestUri: "/CreateParticipantToken",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "stageArn"
            ],
            members: {
              attributes: {
                shape: "Sf"
              },
              capabilities: {
                shape: "Sh"
              },
              duration: {
                type: "integer"
              },
              stageArn: {},
              userId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              participantToken: {
                shape: "Sn"
              }
            }
          }
        },
        CreateStage: {
          http: {
            requestUri: "/CreateStage",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              name: {},
              participantTokenConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    attributes: {
                      shape: "Sf"
                    },
                    capabilities: {
                      shape: "Sh"
                    },
                    duration: {
                      type: "integer"
                    },
                    userId: {}
                  }
                }
              },
              tags: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              participantTokens: {
                type: "list",
                member: {
                  shape: "Sn"
                }
              },
              stage: {
                shape: "Sx"
              }
            }
          }
        },
        CreateStorageConfiguration: {
          http: {
            requestUri: "/CreateStorageConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "s3"
            ],
            members: {
              name: {},
              s3: {
                shape: "S11"
              },
              tags: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              storageConfiguration: {
                shape: "S14"
              }
            }
          }
        },
        DeleteEncoderConfiguration: {
          http: {
            requestUri: "/DeleteEncoderConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteStage: {
          http: {
            requestUri: "/DeleteStage",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteStorageConfiguration: {
          http: {
            requestUri: "/DeleteStorageConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisconnectParticipant: {
          http: {
            requestUri: "/DisconnectParticipant",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "participantId",
              "stageArn"
            ],
            members: {
              participantId: {},
              reason: {},
              stageArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetComposition: {
          http: {
            requestUri: "/GetComposition",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              composition: {
                shape: "S1i"
              }
            }
          }
        },
        GetEncoderConfiguration: {
          http: {
            requestUri: "/GetEncoderConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              encoderConfiguration: {
                shape: "Sc"
              }
            }
          }
        },
        GetParticipant: {
          http: {
            requestUri: "/GetParticipant",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "participantId",
              "sessionId",
              "stageArn"
            ],
            members: {
              participantId: {},
              sessionId: {},
              stageArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              participant: {
                type: "structure",
                members: {
                  attributes: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  browserName: {},
                  browserVersion: {},
                  firstJoinTime: {
                    shape: "S1v"
                  },
                  ispName: {},
                  osName: {},
                  osVersion: {},
                  participantId: {},
                  published: {
                    type: "boolean"
                  },
                  sdkVersion: {},
                  state: {},
                  userId: {}
                }
              }
            }
          }
        },
        GetStage: {
          http: {
            requestUri: "/GetStage",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              stage: {
                shape: "Sx"
              }
            }
          }
        },
        GetStageSession: {
          http: {
            requestUri: "/GetStageSession",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sessionId",
              "stageArn"
            ],
            members: {
              sessionId: {},
              stageArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              stageSession: {
                type: "structure",
                members: {
                  endTime: {
                    shape: "S1v"
                  },
                  sessionId: {},
                  startTime: {
                    shape: "S1v"
                  }
                }
              }
            }
          }
        },
        GetStorageConfiguration: {
          http: {
            requestUri: "/GetStorageConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              storageConfiguration: {
                shape: "S14"
              }
            }
          }
        },
        ListCompositions: {
          http: {
            requestUri: "/ListCompositions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              filterByEncoderConfigurationArn: {},
              filterByStageArn: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "compositions"
            ],
            members: {
              compositions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "destinations",
                    "stageArn",
                    "state"
                  ],
                  members: {
                    arn: {},
                    destinations: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "id",
                          "state"
                        ],
                        members: {
                          endTime: {
                            shape: "S1v"
                          },
                          id: {},
                          startTime: {
                            shape: "S1v"
                          },
                          state: {}
                        }
                      }
                    },
                    endTime: {
                      shape: "S1v"
                    },
                    stageArn: {},
                    startTime: {
                      shape: "S1v"
                    },
                    state: {},
                    tags: {
                      shape: "S3"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListEncoderConfigurations: {
          http: {
            requestUri: "/ListEncoderConfigurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "encoderConfigurations"
            ],
            members: {
              encoderConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn"
                  ],
                  members: {
                    arn: {},
                    name: {},
                    tags: {
                      shape: "S3"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListParticipantEvents: {
          http: {
            requestUri: "/ListParticipantEvents",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "participantId",
              "sessionId",
              "stageArn"
            ],
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              participantId: {},
              sessionId: {},
              stageArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "events"
            ],
            members: {
              events: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    errorCode: {},
                    eventTime: {
                      shape: "S1v"
                    },
                    name: {},
                    participantId: {},
                    remoteParticipantId: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListParticipants: {
          http: {
            requestUri: "/ListParticipants",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sessionId",
              "stageArn"
            ],
            members: {
              filterByPublished: {
                type: "boolean"
              },
              filterByState: {},
              filterByUserId: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              sessionId: {},
              stageArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "participants"
            ],
            members: {
              nextToken: {},
              participants: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    firstJoinTime: {
                      shape: "S1v"
                    },
                    participantId: {},
                    published: {
                      type: "boolean"
                    },
                    state: {},
                    userId: {}
                  }
                }
              }
            }
          }
        },
        ListStageSessions: {
          http: {
            requestUri: "/ListStageSessions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "stageArn"
            ],
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              stageArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "stageSessions"
            ],
            members: {
              nextToken: {},
              stageSessions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    endTime: {
                      shape: "S1v"
                    },
                    sessionId: {},
                    startTime: {
                      shape: "S1v"
                    }
                  }
                }
              }
            }
          }
        },
        ListStages: {
          http: {
            requestUri: "/ListStages",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "stages"
            ],
            members: {
              nextToken: {},
              stages: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn"
                  ],
                  members: {
                    activeSessionId: {},
                    arn: {},
                    name: {},
                    tags: {
                      shape: "S3"
                    }
                  }
                }
              }
            }
          }
        },
        ListStorageConfigurations: {
          http: {
            requestUri: "/ListStorageConfigurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "storageConfigurations"
            ],
            members: {
              nextToken: {},
              storageConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn"
                  ],
                  members: {
                    arn: {},
                    name: {},
                    s3: {
                      shape: "S11"
                    },
                    tags: {
                      shape: "S3"
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "tags"
            ],
            members: {
              tags: {
                shape: "S3"
              }
            }
          }
        },
        StartComposition: {
          http: {
            requestUri: "/StartComposition",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "destinations",
              "stageArn"
            ],
            members: {
              destinations: {
                type: "list",
                member: {
                  shape: "S1l"
                }
              },
              idempotencyToken: {
                idempotencyToken: true
              },
              layout: {
                shape: "S1x"
              },
              stageArn: {},
              tags: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              composition: {
                shape: "S1i"
              }
            }
          }
        },
        StopComposition: {
          http: {
            requestUri: "/StopComposition",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateStage: {
          http: {
            requestUri: "/UpdateStage",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              stage: {
                shape: "Sx"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "map",
          key: {},
          value: {}
        },
        S6: {
          type: "structure",
          members: {
            bitrate: {
              type: "integer"
            },
            framerate: {
              type: "float"
            },
            height: {
              type: "integer"
            },
            width: {
              type: "integer"
            }
          }
        },
        Sc: {
          type: "structure",
          required: [
            "arn"
          ],
          members: {
            arn: {},
            name: {},
            tags: {
              shape: "S3"
            },
            video: {
              shape: "S6"
            }
          }
        },
        Sf: {
          type: "map",
          key: {},
          value: {}
        },
        Sh: {
          type: "list",
          member: {}
        },
        Sn: {
          type: "structure",
          members: {
            attributes: {
              shape: "Sf"
            },
            capabilities: {
              shape: "Sh"
            },
            duration: {
              type: "integer"
            },
            expirationTime: {
              type: "timestamp",
              timestampFormat: "iso8601"
            },
            participantId: {},
            token: {
              type: "string",
              sensitive: true
            },
            userId: {}
          }
        },
        Sx: {
          type: "structure",
          required: [
            "arn"
          ],
          members: {
            activeSessionId: {},
            arn: {},
            name: {},
            tags: {
              shape: "S3"
            }
          }
        },
        S11: {
          type: "structure",
          required: [
            "bucketName"
          ],
          members: {
            bucketName: {}
          }
        },
        S14: {
          type: "structure",
          required: [
            "arn"
          ],
          members: {
            arn: {},
            name: {},
            s3: {
              shape: "S11"
            },
            tags: {
              shape: "S3"
            }
          }
        },
        S1i: {
          type: "structure",
          required: [
            "arn",
            "destinations",
            "layout",
            "stageArn",
            "state"
          ],
          members: {
            arn: {},
            destinations: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "configuration",
                  "id",
                  "state"
                ],
                members: {
                  configuration: {
                    shape: "S1l"
                  },
                  detail: {
                    type: "structure",
                    members: {
                      s3: {
                        type: "structure",
                        required: [
                          "recordingPrefix"
                        ],
                        members: {
                          recordingPrefix: {}
                        }
                      }
                    }
                  },
                  endTime: {
                    shape: "S1v"
                  },
                  id: {},
                  startTime: {
                    shape: "S1v"
                  },
                  state: {}
                }
              }
            },
            endTime: {
              shape: "S1v"
            },
            layout: {
              shape: "S1x"
            },
            stageArn: {},
            startTime: {
              shape: "S1v"
            },
            state: {},
            tags: {
              shape: "S3"
            }
          }
        },
        S1l: {
          type: "structure",
          members: {
            channel: {
              type: "structure",
              required: [
                "channelArn"
              ],
              members: {
                channelArn: {},
                encoderConfigurationArn: {}
              }
            },
            name: {},
            s3: {
              type: "structure",
              required: [
                "encoderConfigurationArns",
                "storageConfigurationArn"
              ],
              members: {
                encoderConfigurationArns: {
                  type: "list",
                  member: {}
                },
                recordingConfiguration: {
                  type: "structure",
                  members: {
                    format: {}
                  }
                },
                storageConfigurationArn: {}
              }
            }
          }
        },
        S1v: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S1x: {
          type: "structure",
          members: {
            grid: {
              type: "structure",
              members: {
                featuredParticipantAttribute: {}
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ivs-realtime-2020-07-14.paginators.json
var require_ivs_realtime_2020_07_14_paginators = __commonJS({
  "node_modules/aws-sdk/apis/ivs-realtime-2020-07-14.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListCompositions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListEncoderConfigurations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListParticipantEvents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListParticipants: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListStageSessions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListStages: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListStorageConfigurations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/ivsrealtime.js
var require_ivsrealtime = __commonJS({
  "node_modules/aws-sdk/clients/ivsrealtime.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["ivsrealtime"] = {};
    AWS2.IVSRealTime = Service.defineService("ivsrealtime", ["2020-07-14"]);
    Object.defineProperty(apiLoader.services["ivsrealtime"], "2020-07-14", {
      get: function get() {
        var model = require_ivs_realtime_2020_07_14_min();
        model.paginators = require_ivs_realtime_2020_07_14_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.IVSRealTime;
  }
});

// node_modules/aws-sdk/apis/vpc-lattice-2022-11-30.min.json
var require_vpc_lattice_2022_11_30_min = __commonJS({
  "node_modules/aws-sdk/apis/vpc-lattice-2022-11-30.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2022-11-30",
        endpointPrefix: "vpc-lattice",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon VPC Lattice",
        serviceId: "VPC Lattice",
        signatureVersion: "v4",
        signingName: "vpc-lattice",
        uid: "vpc-lattice-2022-11-30"
      },
      operations: {
        BatchUpdateRule: {
          http: {
            method: "PATCH",
            requestUri: "/services/{serviceIdentifier}/listeners/{listenerIdentifier}/rules",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "listenerIdentifier",
              "rules",
              "serviceIdentifier"
            ],
            members: {
              listenerIdentifier: {
                location: "uri",
                locationName: "listenerIdentifier"
              },
              rules: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ruleIdentifier"
                  ],
                  members: {
                    action: {
                      shape: "S5"
                    },
                    match: {
                      shape: "Sd"
                    },
                    priority: {
                      type: "integer"
                    },
                    ruleIdentifier: {}
                  }
                }
              },
              serviceIdentifier: {
                location: "uri",
                locationName: "serviceIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              successful: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    action: {
                      shape: "S5"
                    },
                    arn: {},
                    id: {},
                    isDefault: {
                      type: "boolean"
                    },
                    match: {
                      shape: "Sd"
                    },
                    name: {},
                    priority: {
                      type: "integer"
                    }
                  }
                }
              },
              unsuccessful: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    failureCode: {},
                    failureMessage: {},
                    ruleIdentifier: {}
                  }
                }
              }
            }
          },
          idempotent: true
        },
        CreateAccessLogSubscription: {
          http: {
            requestUri: "/accesslogsubscriptions",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "destinationArn",
              "resourceIdentifier"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              destinationArn: {},
              resourceIdentifier: {},
              tags: {
                shape: "S19"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "destinationArn",
              "id",
              "resourceArn",
              "resourceId"
            ],
            members: {
              arn: {},
              destinationArn: {},
              id: {},
              resourceArn: {},
              resourceId: {}
            }
          },
          idempotent: true
        },
        CreateListener: {
          http: {
            requestUri: "/services/{serviceIdentifier}/listeners",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "defaultAction",
              "name",
              "protocol",
              "serviceIdentifier"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              defaultAction: {
                shape: "S5"
              },
              name: {},
              port: {
                type: "integer"
              },
              protocol: {},
              serviceIdentifier: {
                location: "uri",
                locationName: "serviceIdentifier"
              },
              tags: {
                shape: "S19"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              defaultAction: {
                shape: "S5"
              },
              id: {},
              name: {},
              port: {
                type: "integer"
              },
              protocol: {},
              serviceArn: {},
              serviceId: {}
            }
          },
          idempotent: true
        },
        CreateRule: {
          http: {
            requestUri: "/services/{serviceIdentifier}/listeners/{listenerIdentifier}/rules",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "action",
              "listenerIdentifier",
              "match",
              "name",
              "priority",
              "serviceIdentifier"
            ],
            members: {
              action: {
                shape: "S5"
              },
              clientToken: {
                idempotencyToken: true
              },
              listenerIdentifier: {
                location: "uri",
                locationName: "listenerIdentifier"
              },
              match: {
                shape: "Sd"
              },
              name: {},
              priority: {
                type: "integer"
              },
              serviceIdentifier: {
                location: "uri",
                locationName: "serviceIdentifier"
              },
              tags: {
                shape: "S19"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              action: {
                shape: "S5"
              },
              arn: {},
              id: {},
              match: {
                shape: "Sd"
              },
              name: {},
              priority: {
                type: "integer"
              }
            }
          },
          idempotent: true
        },
        CreateService: {
          http: {
            requestUri: "/services",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              authType: {},
              certificateArn: {},
              clientToken: {
                idempotencyToken: true
              },
              customDomainName: {},
              name: {},
              tags: {
                shape: "S19"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              authType: {},
              certificateArn: {},
              customDomainName: {},
              dnsEntry: {
                shape: "S1y"
              },
              id: {},
              name: {},
              status: {}
            }
          },
          idempotent: true
        },
        CreateServiceNetwork: {
          http: {
            requestUri: "/servicenetworks",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              authType: {},
              clientToken: {
                idempotencyToken: true
              },
              name: {},
              tags: {
                shape: "S19"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              authType: {},
              id: {},
              name: {}
            }
          },
          idempotent: true
        },
        CreateServiceNetworkServiceAssociation: {
          http: {
            requestUri: "/servicenetworkserviceassociations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "serviceIdentifier",
              "serviceNetworkIdentifier"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              serviceIdentifier: {},
              serviceNetworkIdentifier: {},
              tags: {
                shape: "S19"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              createdBy: {},
              customDomainName: {},
              dnsEntry: {
                shape: "S1y"
              },
              id: {},
              status: {}
            }
          },
          idempotent: true
        },
        CreateServiceNetworkVpcAssociation: {
          http: {
            requestUri: "/servicenetworkvpcassociations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "serviceNetworkIdentifier",
              "vpcIdentifier"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              securityGroupIds: {
                type: "list",
                member: {}
              },
              serviceNetworkIdentifier: {},
              tags: {
                shape: "S19"
              },
              vpcIdentifier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              createdBy: {},
              id: {},
              securityGroupIds: {
                shape: "S2k"
              },
              status: {}
            }
          },
          idempotent: true
        },
        CreateTargetGroup: {
          http: {
            requestUri: "/targetgroups",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "name",
              "type"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              config: {
                shape: "S2n"
              },
              name: {},
              tags: {
                shape: "S19"
              },
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              config: {
                shape: "S2n"
              },
              id: {},
              name: {},
              status: {},
              type: {}
            }
          },
          idempotent: true
        },
        DeleteAccessLogSubscription: {
          http: {
            method: "DELETE",
            requestUri: "/accesslogsubscriptions/{accessLogSubscriptionIdentifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "accessLogSubscriptionIdentifier"
            ],
            members: {
              accessLogSubscriptionIdentifier: {
                location: "uri",
                locationName: "accessLogSubscriptionIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteAuthPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/authpolicy/{resourceIdentifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceIdentifier"
            ],
            members: {
              resourceIdentifier: {
                location: "uri",
                locationName: "resourceIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteListener: {
          http: {
            method: "DELETE",
            requestUri: "/services/{serviceIdentifier}/listeners/{listenerIdentifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "listenerIdentifier",
              "serviceIdentifier"
            ],
            members: {
              listenerIdentifier: {
                location: "uri",
                locationName: "listenerIdentifier"
              },
              serviceIdentifier: {
                location: "uri",
                locationName: "serviceIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteResourcePolicy: {
          http: {
            method: "DELETE",
            requestUri: "/resourcepolicy/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteRule: {
          http: {
            method: "DELETE",
            requestUri: "/services/{serviceIdentifier}/listeners/{listenerIdentifier}/rules/{ruleIdentifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "listenerIdentifier",
              "ruleIdentifier",
              "serviceIdentifier"
            ],
            members: {
              listenerIdentifier: {
                location: "uri",
                locationName: "listenerIdentifier"
              },
              ruleIdentifier: {
                location: "uri",
                locationName: "ruleIdentifier"
              },
              serviceIdentifier: {
                location: "uri",
                locationName: "serviceIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteService: {
          http: {
            method: "DELETE",
            requestUri: "/services/{serviceIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "serviceIdentifier"
            ],
            members: {
              serviceIdentifier: {
                location: "uri",
                locationName: "serviceIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              id: {},
              name: {},
              status: {}
            }
          },
          idempotent: true
        },
        DeleteServiceNetwork: {
          http: {
            method: "DELETE",
            requestUri: "/servicenetworks/{serviceNetworkIdentifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "serviceNetworkIdentifier"
            ],
            members: {
              serviceNetworkIdentifier: {
                location: "uri",
                locationName: "serviceNetworkIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteServiceNetworkServiceAssociation: {
          http: {
            method: "DELETE",
            requestUri: "/servicenetworkserviceassociations/{serviceNetworkServiceAssociationIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "serviceNetworkServiceAssociationIdentifier"
            ],
            members: {
              serviceNetworkServiceAssociationIdentifier: {
                location: "uri",
                locationName: "serviceNetworkServiceAssociationIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              id: {},
              status: {}
            }
          },
          idempotent: true
        },
        DeleteServiceNetworkVpcAssociation: {
          http: {
            method: "DELETE",
            requestUri: "/servicenetworkvpcassociations/{serviceNetworkVpcAssociationIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "serviceNetworkVpcAssociationIdentifier"
            ],
            members: {
              serviceNetworkVpcAssociationIdentifier: {
                location: "uri",
                locationName: "serviceNetworkVpcAssociationIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              id: {},
              status: {}
            }
          },
          idempotent: true
        },
        DeleteTargetGroup: {
          http: {
            method: "DELETE",
            requestUri: "/targetgroups/{targetGroupIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "targetGroupIdentifier"
            ],
            members: {
              targetGroupIdentifier: {
                location: "uri",
                locationName: "targetGroupIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              id: {},
              status: {}
            }
          },
          idempotent: true
        },
        DeregisterTargets: {
          http: {
            requestUri: "/targetgroups/{targetGroupIdentifier}/deregistertargets",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "targetGroupIdentifier",
              "targets"
            ],
            members: {
              targetGroupIdentifier: {
                location: "uri",
                locationName: "targetGroupIdentifier"
              },
              targets: {
                type: "list",
                member: {
                  shape: "S3w"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              successful: {
                shape: "S3z"
              },
              unsuccessful: {
                shape: "S40"
              }
            }
          },
          idempotent: true
        },
        GetAccessLogSubscription: {
          http: {
            method: "GET",
            requestUri: "/accesslogsubscriptions/{accessLogSubscriptionIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "accessLogSubscriptionIdentifier"
            ],
            members: {
              accessLogSubscriptionIdentifier: {
                location: "uri",
                locationName: "accessLogSubscriptionIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "createdAt",
              "destinationArn",
              "id",
              "lastUpdatedAt",
              "resourceArn",
              "resourceId"
            ],
            members: {
              arn: {},
              createdAt: {
                shape: "S44"
              },
              destinationArn: {},
              id: {},
              lastUpdatedAt: {
                shape: "S44"
              },
              resourceArn: {},
              resourceId: {}
            }
          }
        },
        GetAuthPolicy: {
          http: {
            method: "GET",
            requestUri: "/authpolicy/{resourceIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceIdentifier"
            ],
            members: {
              resourceIdentifier: {
                location: "uri",
                locationName: "resourceIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              createdAt: {
                shape: "S44"
              },
              lastUpdatedAt: {
                shape: "S44"
              },
              policy: {},
              state: {}
            }
          }
        },
        GetListener: {
          http: {
            method: "GET",
            requestUri: "/services/{serviceIdentifier}/listeners/{listenerIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "listenerIdentifier",
              "serviceIdentifier"
            ],
            members: {
              listenerIdentifier: {
                location: "uri",
                locationName: "listenerIdentifier"
              },
              serviceIdentifier: {
                location: "uri",
                locationName: "serviceIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              createdAt: {
                shape: "S44"
              },
              defaultAction: {
                shape: "S5"
              },
              id: {},
              lastUpdatedAt: {
                shape: "S44"
              },
              name: {},
              port: {
                type: "integer"
              },
              protocol: {},
              serviceArn: {},
              serviceId: {}
            }
          }
        },
        GetResourcePolicy: {
          http: {
            method: "GET",
            requestUri: "/resourcepolicy/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              policy: {}
            }
          }
        },
        GetRule: {
          http: {
            method: "GET",
            requestUri: "/services/{serviceIdentifier}/listeners/{listenerIdentifier}/rules/{ruleIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "listenerIdentifier",
              "ruleIdentifier",
              "serviceIdentifier"
            ],
            members: {
              listenerIdentifier: {
                location: "uri",
                locationName: "listenerIdentifier"
              },
              ruleIdentifier: {
                location: "uri",
                locationName: "ruleIdentifier"
              },
              serviceIdentifier: {
                location: "uri",
                locationName: "serviceIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              action: {
                shape: "S5"
              },
              arn: {},
              createdAt: {
                shape: "S44"
              },
              id: {},
              isDefault: {
                type: "boolean"
              },
              lastUpdatedAt: {
                shape: "S44"
              },
              match: {
                shape: "Sd"
              },
              name: {},
              priority: {
                type: "integer"
              }
            }
          }
        },
        GetService: {
          http: {
            method: "GET",
            requestUri: "/services/{serviceIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "serviceIdentifier"
            ],
            members: {
              serviceIdentifier: {
                location: "uri",
                locationName: "serviceIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              authType: {},
              certificateArn: {},
              createdAt: {
                shape: "S44"
              },
              customDomainName: {},
              dnsEntry: {
                shape: "S1y"
              },
              failureCode: {},
              failureMessage: {},
              id: {},
              lastUpdatedAt: {
                shape: "S44"
              },
              name: {},
              status: {}
            }
          }
        },
        GetServiceNetwork: {
          http: {
            method: "GET",
            requestUri: "/servicenetworks/{serviceNetworkIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "serviceNetworkIdentifier"
            ],
            members: {
              serviceNetworkIdentifier: {
                location: "uri",
                locationName: "serviceNetworkIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              authType: {},
              createdAt: {
                shape: "S44"
              },
              id: {},
              lastUpdatedAt: {
                shape: "S44"
              },
              name: {},
              numberOfAssociatedServices: {
                type: "long"
              },
              numberOfAssociatedVPCs: {
                type: "long"
              }
            }
          }
        },
        GetServiceNetworkServiceAssociation: {
          http: {
            method: "GET",
            requestUri: "/servicenetworkserviceassociations/{serviceNetworkServiceAssociationIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "serviceNetworkServiceAssociationIdentifier"
            ],
            members: {
              serviceNetworkServiceAssociationIdentifier: {
                location: "uri",
                locationName: "serviceNetworkServiceAssociationIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              createdAt: {
                shape: "S44"
              },
              createdBy: {},
              customDomainName: {},
              dnsEntry: {
                shape: "S1y"
              },
              failureCode: {},
              failureMessage: {},
              id: {},
              serviceArn: {},
              serviceId: {},
              serviceName: {},
              serviceNetworkArn: {},
              serviceNetworkId: {},
              serviceNetworkName: {},
              status: {}
            }
          }
        },
        GetServiceNetworkVpcAssociation: {
          http: {
            method: "GET",
            requestUri: "/servicenetworkvpcassociations/{serviceNetworkVpcAssociationIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "serviceNetworkVpcAssociationIdentifier"
            ],
            members: {
              serviceNetworkVpcAssociationIdentifier: {
                location: "uri",
                locationName: "serviceNetworkVpcAssociationIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              createdAt: {
                shape: "S44"
              },
              createdBy: {},
              failureCode: {},
              failureMessage: {},
              id: {},
              lastUpdatedAt: {
                shape: "S44"
              },
              securityGroupIds: {
                shape: "S2k"
              },
              serviceNetworkArn: {},
              serviceNetworkId: {},
              serviceNetworkName: {},
              status: {},
              vpcId: {}
            }
          }
        },
        GetTargetGroup: {
          http: {
            method: "GET",
            requestUri: "/targetgroups/{targetGroupIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "targetGroupIdentifier"
            ],
            members: {
              targetGroupIdentifier: {
                location: "uri",
                locationName: "targetGroupIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              config: {
                shape: "S2n"
              },
              createdAt: {
                shape: "S44"
              },
              failureCode: {},
              failureMessage: {},
              id: {},
              lastUpdatedAt: {
                shape: "S44"
              },
              name: {},
              serviceArns: {
                shape: "S4r"
              },
              status: {},
              type: {}
            }
          }
        },
        ListAccessLogSubscriptions: {
          http: {
            method: "GET",
            requestUri: "/accesslogsubscriptions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceIdentifier"
            ],
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              resourceIdentifier: {
                location: "querystring",
                locationName: "resourceIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "items"
            ],
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "destinationArn",
                    "id",
                    "lastUpdatedAt",
                    "resourceArn",
                    "resourceId"
                  ],
                  members: {
                    arn: {},
                    createdAt: {
                      shape: "S44"
                    },
                    destinationArn: {},
                    id: {},
                    lastUpdatedAt: {
                      shape: "S44"
                    },
                    resourceArn: {},
                    resourceId: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListListeners: {
          http: {
            method: "GET",
            requestUri: "/services/{serviceIdentifier}/listeners",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "serviceIdentifier"
            ],
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              serviceIdentifier: {
                location: "uri",
                locationName: "serviceIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "items"
            ],
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    createdAt: {
                      shape: "S44"
                    },
                    id: {},
                    lastUpdatedAt: {
                      shape: "S44"
                    },
                    name: {},
                    port: {
                      type: "integer"
                    },
                    protocol: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListRules: {
          http: {
            method: "GET",
            requestUri: "/services/{serviceIdentifier}/listeners/{listenerIdentifier}/rules",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "listenerIdentifier",
              "serviceIdentifier"
            ],
            members: {
              listenerIdentifier: {
                location: "uri",
                locationName: "listenerIdentifier"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              serviceIdentifier: {
                location: "uri",
                locationName: "serviceIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "items"
            ],
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    createdAt: {
                      shape: "S44"
                    },
                    id: {},
                    isDefault: {
                      type: "boolean"
                    },
                    lastUpdatedAt: {
                      shape: "S44"
                    },
                    name: {},
                    priority: {
                      type: "integer"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListServiceNetworkServiceAssociations: {
          http: {
            method: "GET",
            requestUri: "/servicenetworkserviceassociations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              serviceIdentifier: {
                location: "querystring",
                locationName: "serviceIdentifier"
              },
              serviceNetworkIdentifier: {
                location: "querystring",
                locationName: "serviceNetworkIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "items"
            ],
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    createdAt: {
                      shape: "S44"
                    },
                    createdBy: {},
                    customDomainName: {},
                    dnsEntry: {
                      shape: "S1y"
                    },
                    id: {},
                    serviceArn: {},
                    serviceId: {},
                    serviceName: {},
                    serviceNetworkArn: {},
                    serviceNetworkId: {},
                    serviceNetworkName: {},
                    status: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListServiceNetworkVpcAssociations: {
          http: {
            method: "GET",
            requestUri: "/servicenetworkvpcassociations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              serviceNetworkIdentifier: {
                location: "querystring",
                locationName: "serviceNetworkIdentifier"
              },
              vpcIdentifier: {
                location: "querystring",
                locationName: "vpcIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "items"
            ],
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    createdAt: {
                      shape: "S44"
                    },
                    createdBy: {},
                    id: {},
                    lastUpdatedAt: {
                      shape: "S44"
                    },
                    serviceNetworkArn: {},
                    serviceNetworkId: {},
                    serviceNetworkName: {},
                    status: {},
                    vpcId: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListServiceNetworks: {
          http: {
            method: "GET",
            requestUri: "/servicenetworks",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "items"
            ],
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    createdAt: {
                      shape: "S44"
                    },
                    id: {},
                    lastUpdatedAt: {
                      shape: "S44"
                    },
                    name: {},
                    numberOfAssociatedServices: {
                      type: "long"
                    },
                    numberOfAssociatedVPCs: {
                      type: "long"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListServices: {
          http: {
            method: "GET",
            requestUri: "/services",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    createdAt: {
                      shape: "S44"
                    },
                    customDomainName: {},
                    dnsEntry: {
                      shape: "S1y"
                    },
                    id: {},
                    lastUpdatedAt: {
                      shape: "S44"
                    },
                    name: {},
                    status: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S19"
              }
            }
          }
        },
        ListTargetGroups: {
          http: {
            method: "GET",
            requestUri: "/targetgroups",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              targetGroupType: {
                location: "querystring",
                locationName: "targetGroupType"
              },
              vpcIdentifier: {
                location: "querystring",
                locationName: "vpcIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    createdAt: {
                      shape: "S44"
                    },
                    id: {},
                    ipAddressType: {},
                    lambdaEventStructureVersion: {},
                    lastUpdatedAt: {
                      shape: "S44"
                    },
                    name: {},
                    port: {
                      type: "integer"
                    },
                    protocol: {},
                    serviceArns: {
                      shape: "S4r"
                    },
                    status: {},
                    type: {},
                    vpcIdentifier: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTargets: {
          http: {
            requestUri: "/targetgroups/{targetGroupIdentifier}/listtargets",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "targetGroupIdentifier"
            ],
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              targetGroupIdentifier: {
                location: "uri",
                locationName: "targetGroupIdentifier"
              },
              targets: {
                type: "list",
                member: {
                  shape: "S3w"
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "items"
            ],
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    port: {
                      type: "integer"
                    },
                    reasonCode: {},
                    status: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        PutAuthPolicy: {
          http: {
            method: "PUT",
            requestUri: "/authpolicy/{resourceIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "policy",
              "resourceIdentifier"
            ],
            members: {
              policy: {},
              resourceIdentifier: {
                location: "uri",
                locationName: "resourceIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              policy: {},
              state: {}
            }
          }
        },
        PutResourcePolicy: {
          http: {
            method: "PUT",
            requestUri: "/resourcepolicy/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "policy",
              "resourceArn"
            ],
            members: {
              policy: {},
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        RegisterTargets: {
          http: {
            requestUri: "/targetgroups/{targetGroupIdentifier}/registertargets",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "targetGroupIdentifier",
              "targets"
            ],
            members: {
              targetGroupIdentifier: {
                location: "uri",
                locationName: "targetGroupIdentifier"
              },
              targets: {
                type: "list",
                member: {
                  shape: "S3w"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              successful: {
                shape: "S3z"
              },
              unsuccessful: {
                shape: "S40"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S19"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateAccessLogSubscription: {
          http: {
            method: "PATCH",
            requestUri: "/accesslogsubscriptions/{accessLogSubscriptionIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "accessLogSubscriptionIdentifier",
              "destinationArn"
            ],
            members: {
              accessLogSubscriptionIdentifier: {
                location: "uri",
                locationName: "accessLogSubscriptionIdentifier"
              },
              destinationArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "destinationArn",
              "id",
              "resourceArn",
              "resourceId"
            ],
            members: {
              arn: {},
              destinationArn: {},
              id: {},
              resourceArn: {},
              resourceId: {}
            }
          },
          idempotent: true
        },
        UpdateListener: {
          http: {
            method: "PATCH",
            requestUri: "/services/{serviceIdentifier}/listeners/{listenerIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "defaultAction",
              "listenerIdentifier",
              "serviceIdentifier"
            ],
            members: {
              defaultAction: {
                shape: "S5"
              },
              listenerIdentifier: {
                location: "uri",
                locationName: "listenerIdentifier"
              },
              serviceIdentifier: {
                location: "uri",
                locationName: "serviceIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              defaultAction: {
                shape: "S5"
              },
              id: {},
              name: {},
              port: {
                type: "integer"
              },
              protocol: {},
              serviceArn: {},
              serviceId: {}
            }
          },
          idempotent: true
        },
        UpdateRule: {
          http: {
            method: "PATCH",
            requestUri: "/services/{serviceIdentifier}/listeners/{listenerIdentifier}/rules/{ruleIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "listenerIdentifier",
              "ruleIdentifier",
              "serviceIdentifier"
            ],
            members: {
              action: {
                shape: "S5"
              },
              listenerIdentifier: {
                location: "uri",
                locationName: "listenerIdentifier"
              },
              match: {
                shape: "Sd"
              },
              priority: {
                type: "integer"
              },
              ruleIdentifier: {
                location: "uri",
                locationName: "ruleIdentifier"
              },
              serviceIdentifier: {
                location: "uri",
                locationName: "serviceIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              action: {
                shape: "S5"
              },
              arn: {},
              id: {},
              isDefault: {
                type: "boolean"
              },
              match: {
                shape: "Sd"
              },
              name: {},
              priority: {
                type: "integer"
              }
            }
          },
          idempotent: true
        },
        UpdateService: {
          http: {
            method: "PATCH",
            requestUri: "/services/{serviceIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "serviceIdentifier"
            ],
            members: {
              authType: {},
              certificateArn: {},
              serviceIdentifier: {
                location: "uri",
                locationName: "serviceIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              authType: {},
              certificateArn: {},
              customDomainName: {},
              id: {},
              name: {}
            }
          }
        },
        UpdateServiceNetwork: {
          http: {
            method: "PATCH",
            requestUri: "/servicenetworks/{serviceNetworkIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "authType",
              "serviceNetworkIdentifier"
            ],
            members: {
              authType: {},
              serviceNetworkIdentifier: {
                location: "uri",
                locationName: "serviceNetworkIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              authType: {},
              id: {},
              name: {}
            }
          },
          idempotent: true
        },
        UpdateServiceNetworkVpcAssociation: {
          http: {
            method: "PATCH",
            requestUri: "/servicenetworkvpcassociations/{serviceNetworkVpcAssociationIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "securityGroupIds",
              "serviceNetworkVpcAssociationIdentifier"
            ],
            members: {
              securityGroupIds: {
                type: "list",
                member: {}
              },
              serviceNetworkVpcAssociationIdentifier: {
                location: "uri",
                locationName: "serviceNetworkVpcAssociationIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              createdBy: {},
              id: {},
              securityGroupIds: {
                shape: "S2k"
              },
              status: {}
            }
          },
          idempotent: true
        },
        UpdateTargetGroup: {
          http: {
            method: "PATCH",
            requestUri: "/targetgroups/{targetGroupIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "healthCheck",
              "targetGroupIdentifier"
            ],
            members: {
              healthCheck: {
                shape: "S2o"
              },
              targetGroupIdentifier: {
                location: "uri",
                locationName: "targetGroupIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              config: {
                shape: "S2n"
              },
              id: {},
              name: {},
              status: {},
              type: {}
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S5: {
          type: "structure",
          members: {
            fixedResponse: {
              type: "structure",
              required: [
                "statusCode"
              ],
              members: {
                statusCode: {
                  type: "integer"
                }
              }
            },
            forward: {
              type: "structure",
              required: [
                "targetGroups"
              ],
              members: {
                targetGroups: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "targetGroupIdentifier"
                    ],
                    members: {
                      targetGroupIdentifier: {},
                      weight: {
                        type: "integer"
                      }
                    }
                  }
                }
              }
            }
          },
          union: true
        },
        Sd: {
          type: "structure",
          members: {
            httpMatch: {
              type: "structure",
              members: {
                headerMatches: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "match",
                      "name"
                    ],
                    members: {
                      caseSensitive: {
                        type: "boolean"
                      },
                      match: {
                        type: "structure",
                        members: {
                          contains: {},
                          exact: {},
                          prefix: {}
                        },
                        union: true
                      },
                      name: {}
                    }
                  }
                },
                method: {},
                pathMatch: {
                  type: "structure",
                  required: [
                    "match"
                  ],
                  members: {
                    caseSensitive: {
                      type: "boolean"
                    },
                    match: {
                      type: "structure",
                      members: {
                        exact: {},
                        prefix: {}
                      },
                      union: true
                    }
                  }
                }
              }
            }
          },
          union: true
        },
        S19: {
          type: "map",
          key: {},
          value: {}
        },
        S1y: {
          type: "structure",
          members: {
            domainName: {},
            hostedZoneId: {}
          }
        },
        S2k: {
          type: "list",
          member: {}
        },
        S2n: {
          type: "structure",
          members: {
            healthCheck: {
              shape: "S2o"
            },
            ipAddressType: {},
            lambdaEventStructureVersion: {},
            port: {
              type: "integer"
            },
            protocol: {},
            protocolVersion: {},
            vpcIdentifier: {}
          }
        },
        S2o: {
          type: "structure",
          members: {
            enabled: {
              type: "boolean"
            },
            healthCheckIntervalSeconds: {
              type: "integer"
            },
            healthCheckTimeoutSeconds: {
              type: "integer"
            },
            healthyThresholdCount: {
              type: "integer"
            },
            matcher: {
              type: "structure",
              members: {
                httpCode: {}
              },
              union: true
            },
            path: {},
            port: {
              type: "integer"
            },
            protocol: {},
            protocolVersion: {},
            unhealthyThresholdCount: {
              type: "integer"
            }
          }
        },
        S3w: {
          type: "structure",
          required: [
            "id"
          ],
          members: {
            id: {},
            port: {
              type: "integer"
            }
          }
        },
        S3z: {
          type: "list",
          member: {
            shape: "S3w"
          }
        },
        S40: {
          type: "list",
          member: {
            type: "structure",
            members: {
              failureCode: {},
              failureMessage: {},
              id: {},
              port: {
                type: "integer"
              }
            }
          }
        },
        S44: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S4r: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/vpc-lattice-2022-11-30.paginators.json
var require_vpc_lattice_2022_11_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/vpc-lattice-2022-11-30.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAccessLogSubscriptions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListListeners: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListRules: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListServiceNetworkServiceAssociations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListServiceNetworkVpcAssociations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListServiceNetworks: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListServices: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListTargetGroups: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListTargets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/vpclattice.js
var require_vpclattice = __commonJS({
  "node_modules/aws-sdk/clients/vpclattice.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["vpclattice"] = {};
    AWS2.VPCLattice = Service.defineService("vpclattice", ["2022-11-30"]);
    Object.defineProperty(apiLoader.services["vpclattice"], "2022-11-30", {
      get: function get() {
        var model = require_vpc_lattice_2022_11_30_min();
        model.paginators = require_vpc_lattice_2022_11_30_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.VPCLattice;
  }
});

// node_modules/aws-sdk/apis/osis-2022-01-01.min.json
var require_osis_2022_01_01_min = __commonJS({
  "node_modules/aws-sdk/apis/osis-2022-01-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2022-01-01",
        endpointPrefix: "osis",
        protocol: "rest-json",
        serviceFullName: "Amazon OpenSearch Ingestion",
        serviceId: "OSIS",
        signatureVersion: "v4",
        uid: "osis-2022-01-01"
      },
      operations: {
        CreatePipeline: {
          http: {
            requestUri: "/2022-01-01/osis/createPipeline"
          },
          input: {
            type: "structure",
            required: [
              "PipelineName",
              "MinUnits",
              "MaxUnits",
              "PipelineConfigurationBody"
            ],
            members: {
              PipelineName: {},
              MinUnits: {
                type: "integer"
              },
              MaxUnits: {
                type: "integer"
              },
              PipelineConfigurationBody: {},
              LogPublishingOptions: {
                shape: "S5"
              },
              VpcOptions: {
                shape: "S9"
              },
              BufferOptions: {
                shape: "Se"
              },
              EncryptionAtRestOptions: {
                shape: "Sf"
              },
              Tags: {
                shape: "Sh"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Pipeline: {
                shape: "Sm"
              }
            }
          }
        },
        DeletePipeline: {
          http: {
            method: "DELETE",
            requestUri: "/2022-01-01/osis/deletePipeline/{PipelineName}"
          },
          input: {
            type: "structure",
            required: [
              "PipelineName"
            ],
            members: {
              PipelineName: {
                location: "uri",
                locationName: "PipelineName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetPipeline: {
          http: {
            method: "GET",
            requestUri: "/2022-01-01/osis/getPipeline/{PipelineName}"
          },
          input: {
            type: "structure",
            required: [
              "PipelineName"
            ],
            members: {
              PipelineName: {
                location: "uri",
                locationName: "PipelineName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Pipeline: {
                shape: "Sm"
              }
            }
          }
        },
        GetPipelineBlueprint: {
          http: {
            method: "GET",
            requestUri: "/2022-01-01/osis/getPipelineBlueprint/{BlueprintName}"
          },
          input: {
            type: "structure",
            required: [
              "BlueprintName"
            ],
            members: {
              BlueprintName: {
                location: "uri",
                locationName: "BlueprintName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Blueprint: {
                type: "structure",
                members: {
                  BlueprintName: {},
                  PipelineConfigurationBody: {}
                }
              }
            }
          }
        },
        GetPipelineChangeProgress: {
          http: {
            method: "GET",
            requestUri: "/2022-01-01/osis/getPipelineChangeProgress/{PipelineName}"
          },
          input: {
            type: "structure",
            required: [
              "PipelineName"
            ],
            members: {
              PipelineName: {
                location: "uri",
                locationName: "PipelineName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeProgressStatuses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StartTime: {
                      type: "timestamp"
                    },
                    Status: {},
                    TotalNumberOfStages: {
                      type: "integer"
                    },
                    ChangeProgressStages: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Name: {},
                          Status: {},
                          Description: {},
                          LastUpdatedAt: {
                            type: "timestamp"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        ListPipelineBlueprints: {
          http: {
            requestUri: "/2022-01-01/osis/listPipelineBlueprints"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              Blueprints: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    BlueprintName: {}
                  }
                }
              }
            }
          }
        },
        ListPipelines: {
          http: {
            method: "GET",
            requestUri: "/2022-01-01/osis/listPipelines"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Pipelines: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Status: {},
                    StatusReason: {
                      shape: "Sq"
                    },
                    PipelineName: {},
                    PipelineArn: {},
                    MinUnits: {
                      type: "integer"
                    },
                    MaxUnits: {
                      type: "integer"
                    },
                    CreatedAt: {
                      type: "timestamp"
                    },
                    LastUpdatedAt: {
                      type: "timestamp"
                    },
                    Tags: {
                      shape: "Sh"
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/2022-01-01/osis/listTagsForResource/"
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {
                location: "querystring",
                locationName: "arn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sh"
              }
            }
          }
        },
        StartPipeline: {
          http: {
            method: "PUT",
            requestUri: "/2022-01-01/osis/startPipeline/{PipelineName}"
          },
          input: {
            type: "structure",
            required: [
              "PipelineName"
            ],
            members: {
              PipelineName: {
                location: "uri",
                locationName: "PipelineName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Pipeline: {
                shape: "Sm"
              }
            }
          }
        },
        StopPipeline: {
          http: {
            method: "PUT",
            requestUri: "/2022-01-01/osis/stopPipeline/{PipelineName}"
          },
          input: {
            type: "structure",
            required: [
              "PipelineName"
            ],
            members: {
              PipelineName: {
                location: "uri",
                locationName: "PipelineName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Pipeline: {
                shape: "Sm"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/2022-01-01/osis/tagResource/"
          },
          input: {
            type: "structure",
            required: [
              "Arn",
              "Tags"
            ],
            members: {
              Arn: {
                location: "querystring",
                locationName: "arn"
              },
              Tags: {
                shape: "Sh"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            requestUri: "/2022-01-01/osis/untagResource/"
          },
          input: {
            type: "structure",
            required: [
              "Arn",
              "TagKeys"
            ],
            members: {
              Arn: {
                location: "querystring",
                locationName: "arn"
              },
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdatePipeline: {
          http: {
            method: "PUT",
            requestUri: "/2022-01-01/osis/updatePipeline/{PipelineName}"
          },
          input: {
            type: "structure",
            required: [
              "PipelineName"
            ],
            members: {
              PipelineName: {
                location: "uri",
                locationName: "PipelineName"
              },
              MinUnits: {
                type: "integer"
              },
              MaxUnits: {
                type: "integer"
              },
              PipelineConfigurationBody: {},
              LogPublishingOptions: {
                shape: "S5"
              },
              BufferOptions: {
                shape: "Se"
              },
              EncryptionAtRestOptions: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Pipeline: {
                shape: "Sm"
              }
            }
          }
        },
        ValidatePipeline: {
          http: {
            requestUri: "/2022-01-01/osis/validatePipeline"
          },
          input: {
            type: "structure",
            required: [
              "PipelineConfigurationBody"
            ],
            members: {
              PipelineConfigurationBody: {}
            }
          },
          output: {
            type: "structure",
            members: {
              isValid: {
                type: "boolean"
              },
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Message: {}
                  }
                }
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          members: {
            IsLoggingEnabled: {
              type: "boolean"
            },
            CloudWatchLogDestination: {
              type: "structure",
              required: [
                "LogGroup"
              ],
              members: {
                LogGroup: {}
              }
            }
          }
        },
        S9: {
          type: "structure",
          required: [
            "SubnetIds"
          ],
          members: {
            SubnetIds: {
              type: "list",
              member: {}
            },
            SecurityGroupIds: {
              type: "list",
              member: {}
            }
          }
        },
        Se: {
          type: "structure",
          required: [
            "PersistentBufferEnabled"
          ],
          members: {
            PersistentBufferEnabled: {
              type: "boolean"
            }
          }
        },
        Sf: {
          type: "structure",
          required: [
            "KmsKeyArn"
          ],
          members: {
            KmsKeyArn: {}
          }
        },
        Sh: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sm: {
          type: "structure",
          members: {
            PipelineName: {},
            PipelineArn: {},
            MinUnits: {
              type: "integer"
            },
            MaxUnits: {
              type: "integer"
            },
            Status: {},
            StatusReason: {
              shape: "Sq"
            },
            PipelineConfigurationBody: {},
            CreatedAt: {
              type: "timestamp"
            },
            LastUpdatedAt: {
              type: "timestamp"
            },
            IngestEndpointUrls: {
              type: "list",
              member: {}
            },
            LogPublishingOptions: {
              shape: "S5"
            },
            VpcEndpoints: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  VpcEndpointId: {},
                  VpcId: {},
                  VpcOptions: {
                    shape: "S9"
                  }
                }
              }
            },
            BufferOptions: {
              shape: "Se"
            },
            EncryptionAtRestOptions: {
              shape: "Sf"
            },
            ServiceVpcEndpoints: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  ServiceName: {},
                  VpcEndpointId: {}
                }
              }
            },
            Tags: {
              shape: "Sh"
            }
          }
        },
        Sq: {
          type: "structure",
          members: {
            Description: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/osis-2022-01-01.paginators.json
var require_osis_2022_01_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/osis-2022-01-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListPipelines: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/osis.js
var require_osis = __commonJS({
  "node_modules/aws-sdk/clients/osis.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["osis"] = {};
    AWS2.OSIS = Service.defineService("osis", ["2022-01-01"]);
    Object.defineProperty(apiLoader.services["osis"], "2022-01-01", {
      get: function get() {
        var model = require_osis_2022_01_01_min();
        model.paginators = require_osis_2022_01_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.OSIS;
  }
});

// node_modules/aws-sdk/apis/mediapackagev2-2022-12-25.min.json
var require_mediapackagev2_2022_12_25_min = __commonJS({
  "node_modules/aws-sdk/apis/mediapackagev2-2022-12-25.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2022-12-25",
        endpointPrefix: "mediapackagev2",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "mediapackagev2",
        serviceFullName: "AWS Elemental MediaPackage v2",
        serviceId: "MediaPackageV2",
        signatureVersion: "v4",
        signingName: "mediapackagev2",
        uid: "mediapackagev2-2022-12-25"
      },
      operations: {
        CreateChannel: {
          http: {
            requestUri: "/channelGroup/{ChannelGroupName}/channel",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelGroupName",
              "ChannelName"
            ],
            members: {
              ChannelGroupName: {
                location: "uri",
                locationName: "ChannelGroupName"
              },
              ChannelName: {},
              ClientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "x-amzn-client-token"
              },
              Description: {},
              Tags: {
                shape: "S5",
                locationName: "tags"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Arn",
              "ChannelName",
              "ChannelGroupName",
              "CreatedAt",
              "ModifiedAt"
            ],
            members: {
              Arn: {},
              ChannelName: {},
              ChannelGroupName: {},
              CreatedAt: {
                type: "timestamp"
              },
              ModifiedAt: {
                type: "timestamp"
              },
              Description: {},
              IngestEndpoints: {
                shape: "Sb"
              },
              Tags: {
                shape: "S5"
              }
            }
          },
          idempotent: true
        },
        CreateChannelGroup: {
          http: {
            requestUri: "/channelGroup",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelGroupName"
            ],
            members: {
              ChannelGroupName: {},
              ClientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "x-amzn-client-token"
              },
              Description: {},
              Tags: {
                shape: "S5",
                locationName: "tags"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ChannelGroupName",
              "Arn",
              "EgressDomain",
              "CreatedAt",
              "ModifiedAt"
            ],
            members: {
              ChannelGroupName: {},
              Arn: {},
              EgressDomain: {},
              CreatedAt: {
                type: "timestamp"
              },
              ModifiedAt: {
                type: "timestamp"
              },
              Description: {},
              Tags: {
                shape: "S5"
              }
            }
          },
          idempotent: true
        },
        CreateOriginEndpoint: {
          http: {
            requestUri: "/channelGroup/{ChannelGroupName}/channel/{ChannelName}/originEndpoint",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelGroupName",
              "ChannelName",
              "OriginEndpointName",
              "ContainerType"
            ],
            members: {
              ChannelGroupName: {
                location: "uri",
                locationName: "ChannelGroupName"
              },
              ChannelName: {
                location: "uri",
                locationName: "ChannelName"
              },
              OriginEndpointName: {},
              ContainerType: {},
              Segment: {
                shape: "Sh"
              },
              ClientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "x-amzn-client-token"
              },
              Description: {},
              StartoverWindowSeconds: {
                type: "integer"
              },
              HlsManifests: {
                shape: "S14"
              },
              LowLatencyHlsManifests: {
                shape: "S1e"
              },
              Tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Arn",
              "ChannelGroupName",
              "ChannelName",
              "OriginEndpointName",
              "ContainerType",
              "Segment",
              "CreatedAt",
              "ModifiedAt"
            ],
            members: {
              Arn: {},
              ChannelGroupName: {},
              ChannelName: {},
              OriginEndpointName: {},
              ContainerType: {},
              Segment: {
                shape: "Sh"
              },
              CreatedAt: {
                type: "timestamp"
              },
              ModifiedAt: {
                type: "timestamp"
              },
              Description: {},
              StartoverWindowSeconds: {
                type: "integer"
              },
              HlsManifests: {
                shape: "S1k"
              },
              LowLatencyHlsManifests: {
                shape: "S1m"
              },
              Tags: {
                shape: "S5"
              }
            }
          },
          idempotent: true
        },
        DeleteChannel: {
          http: {
            method: "DELETE",
            requestUri: "/channelGroup/{ChannelGroupName}/channel/{ChannelName}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelGroupName",
              "ChannelName"
            ],
            members: {
              ChannelGroupName: {
                location: "uri",
                locationName: "ChannelGroupName"
              },
              ChannelName: {
                location: "uri",
                locationName: "ChannelName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteChannelGroup: {
          http: {
            method: "DELETE",
            requestUri: "/channelGroup/{ChannelGroupName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelGroupName"
            ],
            members: {
              ChannelGroupName: {
                location: "uri",
                locationName: "ChannelGroupName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteChannelPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/channelGroup/{ChannelGroupName}/channel/{ChannelName}/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelGroupName",
              "ChannelName"
            ],
            members: {
              ChannelGroupName: {
                location: "uri",
                locationName: "ChannelGroupName"
              },
              ChannelName: {
                location: "uri",
                locationName: "ChannelName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteOriginEndpoint: {
          http: {
            method: "DELETE",
            requestUri: "/channelGroup/{ChannelGroupName}/channel/{ChannelName}/originEndpoint/{OriginEndpointName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelGroupName",
              "ChannelName",
              "OriginEndpointName"
            ],
            members: {
              ChannelGroupName: {
                location: "uri",
                locationName: "ChannelGroupName"
              },
              ChannelName: {
                location: "uri",
                locationName: "ChannelName"
              },
              OriginEndpointName: {
                location: "uri",
                locationName: "OriginEndpointName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteOriginEndpointPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/channelGroup/{ChannelGroupName}/channel/{ChannelName}/originEndpoint/{OriginEndpointName}/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelGroupName",
              "ChannelName",
              "OriginEndpointName"
            ],
            members: {
              ChannelGroupName: {
                location: "uri",
                locationName: "ChannelGroupName"
              },
              ChannelName: {
                location: "uri",
                locationName: "ChannelName"
              },
              OriginEndpointName: {
                location: "uri",
                locationName: "OriginEndpointName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        GetChannel: {
          http: {
            method: "GET",
            requestUri: "/channelGroup/{ChannelGroupName}/channel/{ChannelName}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelGroupName",
              "ChannelName"
            ],
            members: {
              ChannelGroupName: {
                location: "uri",
                locationName: "ChannelGroupName"
              },
              ChannelName: {
                location: "uri",
                locationName: "ChannelName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Arn",
              "ChannelName",
              "ChannelGroupName",
              "CreatedAt",
              "ModifiedAt"
            ],
            members: {
              Arn: {},
              ChannelName: {},
              ChannelGroupName: {},
              CreatedAt: {
                type: "timestamp"
              },
              ModifiedAt: {
                type: "timestamp"
              },
              Description: {},
              IngestEndpoints: {
                shape: "Sb"
              },
              Tags: {
                shape: "S5"
              }
            }
          }
        },
        GetChannelGroup: {
          http: {
            method: "GET",
            requestUri: "/channelGroup/{ChannelGroupName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelGroupName"
            ],
            members: {
              ChannelGroupName: {
                location: "uri",
                locationName: "ChannelGroupName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ChannelGroupName",
              "Arn",
              "EgressDomain",
              "CreatedAt",
              "ModifiedAt"
            ],
            members: {
              ChannelGroupName: {},
              Arn: {},
              EgressDomain: {},
              CreatedAt: {
                type: "timestamp"
              },
              ModifiedAt: {
                type: "timestamp"
              },
              Description: {},
              Tags: {
                shape: "S5",
                locationName: "tags"
              }
            }
          }
        },
        GetChannelPolicy: {
          http: {
            method: "GET",
            requestUri: "/channelGroup/{ChannelGroupName}/channel/{ChannelName}/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelGroupName",
              "ChannelName"
            ],
            members: {
              ChannelGroupName: {
                location: "uri",
                locationName: "ChannelGroupName"
              },
              ChannelName: {
                location: "uri",
                locationName: "ChannelName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ChannelGroupName",
              "ChannelName",
              "Policy"
            ],
            members: {
              ChannelGroupName: {},
              ChannelName: {},
              Policy: {}
            }
          }
        },
        GetOriginEndpoint: {
          http: {
            method: "GET",
            requestUri: "/channelGroup/{ChannelGroupName}/channel/{ChannelName}/originEndpoint/{OriginEndpointName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelGroupName",
              "ChannelName",
              "OriginEndpointName"
            ],
            members: {
              ChannelGroupName: {
                location: "uri",
                locationName: "ChannelGroupName"
              },
              ChannelName: {
                location: "uri",
                locationName: "ChannelName"
              },
              OriginEndpointName: {
                location: "uri",
                locationName: "OriginEndpointName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Arn",
              "ChannelGroupName",
              "ChannelName",
              "OriginEndpointName",
              "ContainerType",
              "Segment",
              "CreatedAt",
              "ModifiedAt"
            ],
            members: {
              Arn: {},
              ChannelGroupName: {},
              ChannelName: {},
              OriginEndpointName: {},
              ContainerType: {},
              Segment: {
                shape: "Sh"
              },
              CreatedAt: {
                type: "timestamp"
              },
              ModifiedAt: {
                type: "timestamp"
              },
              Description: {},
              StartoverWindowSeconds: {
                type: "integer"
              },
              HlsManifests: {
                shape: "S1k"
              },
              LowLatencyHlsManifests: {
                shape: "S1m"
              },
              Tags: {
                shape: "S5"
              }
            }
          }
        },
        GetOriginEndpointPolicy: {
          http: {
            method: "GET",
            requestUri: "/channelGroup/{ChannelGroupName}/channel/{ChannelName}/originEndpoint/{OriginEndpointName}/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelGroupName",
              "ChannelName",
              "OriginEndpointName"
            ],
            members: {
              ChannelGroupName: {
                location: "uri",
                locationName: "ChannelGroupName"
              },
              ChannelName: {
                location: "uri",
                locationName: "ChannelName"
              },
              OriginEndpointName: {
                location: "uri",
                locationName: "OriginEndpointName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ChannelGroupName",
              "ChannelName",
              "OriginEndpointName",
              "Policy"
            ],
            members: {
              ChannelGroupName: {},
              ChannelName: {},
              OriginEndpointName: {},
              Policy: {}
            }
          }
        },
        ListChannelGroups: {
          http: {
            method: "GET",
            requestUri: "/channelGroup",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ChannelGroupName",
                    "Arn",
                    "CreatedAt",
                    "ModifiedAt"
                  ],
                  members: {
                    ChannelGroupName: {},
                    Arn: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    ModifiedAt: {
                      type: "timestamp"
                    },
                    Description: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListChannels: {
          http: {
            method: "GET",
            requestUri: "/channelGroup/{ChannelGroupName}/channel",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelGroupName"
            ],
            members: {
              ChannelGroupName: {
                location: "uri",
                locationName: "ChannelGroupName"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Arn",
                    "ChannelName",
                    "ChannelGroupName",
                    "CreatedAt",
                    "ModifiedAt"
                  ],
                  members: {
                    Arn: {},
                    ChannelName: {},
                    ChannelGroupName: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    ModifiedAt: {
                      type: "timestamp"
                    },
                    Description: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListOriginEndpoints: {
          http: {
            method: "GET",
            requestUri: "/channelGroup/{ChannelGroupName}/channel/{ChannelName}/originEndpoint",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelGroupName",
              "ChannelName"
            ],
            members: {
              ChannelGroupName: {
                location: "uri",
                locationName: "ChannelGroupName"
              },
              ChannelName: {
                location: "uri",
                locationName: "ChannelName"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Arn",
                    "ChannelGroupName",
                    "ChannelName",
                    "OriginEndpointName",
                    "ContainerType"
                  ],
                  members: {
                    Arn: {},
                    ChannelGroupName: {},
                    ChannelName: {},
                    OriginEndpointName: {},
                    ContainerType: {},
                    Description: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    ModifiedAt: {
                      type: "timestamp"
                    },
                    HlsManifests: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "ManifestName"
                        ],
                        members: {
                          ManifestName: {},
                          ChildManifestName: {},
                          Url: {}
                        }
                      }
                    },
                    LowLatencyHlsManifests: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "ManifestName"
                        ],
                        members: {
                          ManifestName: {},
                          ChildManifestName: {},
                          Url: {}
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S5",
                locationName: "tags"
              }
            }
          }
        },
        PutChannelPolicy: {
          http: {
            method: "PUT",
            requestUri: "/channelGroup/{ChannelGroupName}/channel/{ChannelName}/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelGroupName",
              "ChannelName",
              "Policy"
            ],
            members: {
              ChannelGroupName: {
                location: "uri",
                locationName: "ChannelGroupName"
              },
              ChannelName: {
                location: "uri",
                locationName: "ChannelName"
              },
              Policy: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        PutOriginEndpointPolicy: {
          http: {
            requestUri: "/channelGroup/{ChannelGroupName}/channel/{ChannelName}/originEndpoint/{OriginEndpointName}/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelGroupName",
              "ChannelName",
              "OriginEndpointName",
              "Policy"
            ],
            members: {
              ChannelGroupName: {
                location: "uri",
                locationName: "ChannelGroupName"
              },
              ChannelName: {
                location: "uri",
                locationName: "ChannelName"
              },
              OriginEndpointName: {
                location: "uri",
                locationName: "OriginEndpointName"
              },
              Policy: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        TagResource: {
          http: {
            requestUri: "/tags/{ResourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "S5",
                locationName: "tags"
              }
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          idempotent: true
        },
        UpdateChannel: {
          http: {
            method: "PUT",
            requestUri: "/channelGroup/{ChannelGroupName}/channel/{ChannelName}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelGroupName",
              "ChannelName"
            ],
            members: {
              ChannelGroupName: {
                location: "uri",
                locationName: "ChannelGroupName"
              },
              ChannelName: {
                location: "uri",
                locationName: "ChannelName"
              },
              Description: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Arn",
              "ChannelName",
              "ChannelGroupName",
              "CreatedAt",
              "ModifiedAt"
            ],
            members: {
              Arn: {},
              ChannelName: {},
              ChannelGroupName: {},
              CreatedAt: {
                type: "timestamp"
              },
              ModifiedAt: {
                type: "timestamp"
              },
              Description: {},
              IngestEndpoints: {
                shape: "Sb"
              },
              Tags: {
                shape: "S5",
                locationName: "tags"
              }
            }
          },
          idempotent: true
        },
        UpdateChannelGroup: {
          http: {
            method: "PUT",
            requestUri: "/channelGroup/{ChannelGroupName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelGroupName"
            ],
            members: {
              ChannelGroupName: {
                location: "uri",
                locationName: "ChannelGroupName"
              },
              Description: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ChannelGroupName",
              "Arn",
              "EgressDomain",
              "CreatedAt",
              "ModifiedAt"
            ],
            members: {
              ChannelGroupName: {},
              Arn: {},
              EgressDomain: {},
              CreatedAt: {
                type: "timestamp"
              },
              ModifiedAt: {
                type: "timestamp"
              },
              Description: {},
              Tags: {
                shape: "S5",
                locationName: "tags"
              }
            }
          },
          idempotent: true
        },
        UpdateOriginEndpoint: {
          http: {
            method: "PUT",
            requestUri: "/channelGroup/{ChannelGroupName}/channel/{ChannelName}/originEndpoint/{OriginEndpointName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelGroupName",
              "ChannelName",
              "OriginEndpointName",
              "ContainerType"
            ],
            members: {
              ChannelGroupName: {
                location: "uri",
                locationName: "ChannelGroupName"
              },
              ChannelName: {
                location: "uri",
                locationName: "ChannelName"
              },
              OriginEndpointName: {
                location: "uri",
                locationName: "OriginEndpointName"
              },
              ContainerType: {},
              Segment: {
                shape: "Sh"
              },
              Description: {},
              StartoverWindowSeconds: {
                type: "integer"
              },
              HlsManifests: {
                shape: "S14"
              },
              LowLatencyHlsManifests: {
                shape: "S1e"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Arn",
              "ChannelGroupName",
              "ChannelName",
              "OriginEndpointName",
              "ContainerType",
              "Segment",
              "CreatedAt",
              "ModifiedAt"
            ],
            members: {
              Arn: {},
              ChannelGroupName: {},
              ChannelName: {},
              OriginEndpointName: {},
              ContainerType: {},
              Segment: {
                shape: "Sh"
              },
              CreatedAt: {
                type: "timestamp"
              },
              ModifiedAt: {
                type: "timestamp"
              },
              Description: {},
              StartoverWindowSeconds: {
                type: "integer"
              },
              HlsManifests: {
                shape: "S1k"
              },
              LowLatencyHlsManifests: {
                shape: "S1m"
              },
              Tags: {
                shape: "S5",
                locationName: "tags"
              }
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S5: {
          type: "map",
          key: {},
          value: {}
        },
        Sb: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Id: {},
              Url: {}
            }
          }
        },
        Sh: {
          type: "structure",
          members: {
            SegmentDurationSeconds: {
              type: "integer"
            },
            SegmentName: {},
            TsUseAudioRenditionGroup: {
              type: "boolean"
            },
            IncludeIframeOnlyStreams: {
              type: "boolean"
            },
            TsIncludeDvbSubtitles: {
              type: "boolean"
            },
            Scte: {
              type: "structure",
              members: {
                ScteFilter: {
                  type: "list",
                  member: {}
                }
              }
            },
            Encryption: {
              type: "structure",
              required: [
                "EncryptionMethod",
                "SpekeKeyProvider"
              ],
              members: {
                ConstantInitializationVector: {},
                EncryptionMethod: {
                  type: "structure",
                  members: {
                    TsEncryptionMethod: {},
                    CmafEncryptionMethod: {}
                  }
                },
                KeyRotationIntervalSeconds: {
                  type: "integer"
                },
                SpekeKeyProvider: {
                  type: "structure",
                  required: [
                    "EncryptionContractConfiguration",
                    "ResourceId",
                    "DrmSystems",
                    "RoleArn",
                    "Url"
                  ],
                  members: {
                    EncryptionContractConfiguration: {
                      type: "structure",
                      required: [
                        "PresetSpeke20Audio",
                        "PresetSpeke20Video"
                      ],
                      members: {
                        PresetSpeke20Audio: {},
                        PresetSpeke20Video: {}
                      }
                    },
                    ResourceId: {},
                    DrmSystems: {
                      type: "list",
                      member: {}
                    },
                    RoleArn: {},
                    Url: {}
                  }
                }
              }
            }
          }
        },
        S14: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ManifestName"
            ],
            members: {
              ManifestName: {},
              ChildManifestName: {},
              ScteHls: {
                shape: "S17"
              },
              ManifestWindowSeconds: {
                type: "integer"
              },
              ProgramDateTimeIntervalSeconds: {
                type: "integer"
              },
              FilterConfiguration: {
                shape: "S1b"
              }
            }
          }
        },
        S17: {
          type: "structure",
          members: {
            AdMarkerHls: {}
          }
        },
        S1b: {
          type: "structure",
          members: {
            ManifestFilter: {},
            Start: {
              type: "timestamp"
            },
            End: {
              type: "timestamp"
            },
            TimeDelaySeconds: {
              type: "integer"
            }
          }
        },
        S1e: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ManifestName"
            ],
            members: {
              ManifestName: {},
              ChildManifestName: {},
              ScteHls: {
                shape: "S17"
              },
              ManifestWindowSeconds: {
                type: "integer"
              },
              ProgramDateTimeIntervalSeconds: {
                type: "integer"
              },
              FilterConfiguration: {
                shape: "S1b"
              }
            }
          }
        },
        S1k: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ManifestName",
              "Url"
            ],
            members: {
              ManifestName: {},
              Url: {},
              ChildManifestName: {},
              ManifestWindowSeconds: {
                type: "integer"
              },
              ProgramDateTimeIntervalSeconds: {
                type: "integer"
              },
              ScteHls: {
                shape: "S17"
              },
              FilterConfiguration: {
                shape: "S1b"
              }
            }
          }
        },
        S1m: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ManifestName",
              "Url"
            ],
            members: {
              ManifestName: {},
              Url: {},
              ChildManifestName: {},
              ManifestWindowSeconds: {
                type: "integer"
              },
              ProgramDateTimeIntervalSeconds: {
                type: "integer"
              },
              ScteHls: {
                shape: "S17"
              },
              FilterConfiguration: {
                shape: "S1b"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/mediapackagev2-2022-12-25.paginators.json
var require_mediapackagev2_2022_12_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/mediapackagev2-2022-12-25.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListChannelGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Items"
        },
        ListChannels: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Items"
        },
        ListOriginEndpoints: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/mediapackagev2-2022-12-25.waiters2.json
var require_mediapackagev2_2022_12_25_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/mediapackagev2-2022-12-25.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {}
    };
  }
});

// node_modules/aws-sdk/clients/mediapackagev2.js
var require_mediapackagev2 = __commonJS({
  "node_modules/aws-sdk/clients/mediapackagev2.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["mediapackagev2"] = {};
    AWS2.MediaPackageV2 = Service.defineService("mediapackagev2", ["2022-12-25"]);
    Object.defineProperty(apiLoader.services["mediapackagev2"], "2022-12-25", {
      get: function get() {
        var model = require_mediapackagev2_2022_12_25_min();
        model.paginators = require_mediapackagev2_2022_12_25_paginators().pagination;
        model.waiters = require_mediapackagev2_2022_12_25_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.MediaPackageV2;
  }
});

// node_modules/aws-sdk/apis/payment-cryptography-2021-09-14.min.json
var require_payment_cryptography_2021_09_14_min = __commonJS({
  "node_modules/aws-sdk/apis/payment-cryptography-2021-09-14.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-09-14",
        endpointPrefix: "controlplane.payment-cryptography",
        jsonVersion: "1.0",
        protocol: "json",
        serviceFullName: "Payment Cryptography Control Plane",
        serviceId: "Payment Cryptography",
        signatureVersion: "v4",
        signingName: "payment-cryptography",
        targetPrefix: "PaymentCryptographyControlPlane",
        uid: "payment-cryptography-2021-09-14"
      },
      operations: {
        CreateAlias: {
          input: {
            type: "structure",
            required: [
              "AliasName"
            ],
            members: {
              AliasName: {},
              KeyArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Alias"
            ],
            members: {
              Alias: {
                shape: "S5"
              }
            }
          },
          idempotent: true
        },
        CreateKey: {
          input: {
            type: "structure",
            required: [
              "Exportable",
              "KeyAttributes"
            ],
            members: {
              Enabled: {
                type: "boolean"
              },
              Exportable: {
                type: "boolean"
              },
              KeyAttributes: {
                shape: "S8"
              },
              KeyCheckValueAlgorithm: {},
              Tags: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {
                shape: "Sk"
              }
            }
          }
        },
        DeleteAlias: {
          input: {
            type: "structure",
            required: [
              "AliasName"
            ],
            members: {
              AliasName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteKey: {
          input: {
            type: "structure",
            required: [
              "KeyIdentifier"
            ],
            members: {
              DeleteKeyInDays: {
                type: "integer"
              },
              KeyIdentifier: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {
                shape: "Sk"
              }
            }
          },
          idempotent: true
        },
        ExportKey: {
          input: {
            type: "structure",
            required: [
              "ExportKeyIdentifier",
              "KeyMaterial"
            ],
            members: {
              ExportAttributes: {
                type: "structure",
                members: {
                  ExportDukptInitialKey: {
                    type: "structure",
                    required: [
                      "KeySerialNumber"
                    ],
                    members: {
                      KeySerialNumber: {}
                    }
                  },
                  KeyCheckValueAlgorithm: {}
                }
              },
              ExportKeyIdentifier: {},
              KeyMaterial: {
                type: "structure",
                members: {
                  Tr31KeyBlock: {
                    type: "structure",
                    required: [
                      "WrappingKeyIdentifier"
                    ],
                    members: {
                      WrappingKeyIdentifier: {}
                    }
                  },
                  Tr34KeyBlock: {
                    type: "structure",
                    required: [
                      "CertificateAuthorityPublicKeyIdentifier",
                      "ExportToken",
                      "KeyBlockFormat",
                      "WrappingKeyCertificate"
                    ],
                    members: {
                      CertificateAuthorityPublicKeyIdentifier: {},
                      ExportToken: {},
                      KeyBlockFormat: {},
                      RandomNonce: {},
                      WrappingKeyCertificate: {
                        shape: "S15"
                      }
                    }
                  }
                },
                union: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WrappedKey: {
                type: "structure",
                required: [
                  "KeyMaterial",
                  "WrappedKeyMaterialFormat",
                  "WrappingKeyArn"
                ],
                members: {
                  KeyCheckValue: {},
                  KeyCheckValueAlgorithm: {},
                  KeyMaterial: {
                    type: "string",
                    sensitive: true
                  },
                  WrappedKeyMaterialFormat: {},
                  WrappingKeyArn: {}
                }
              }
            }
          }
        },
        GetAlias: {
          input: {
            type: "structure",
            required: [
              "AliasName"
            ],
            members: {
              AliasName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Alias"
            ],
            members: {
              Alias: {
                shape: "S5"
              }
            }
          }
        },
        GetKey: {
          input: {
            type: "structure",
            required: [
              "KeyIdentifier"
            ],
            members: {
              KeyIdentifier: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {
                shape: "Sk"
              }
            }
          }
        },
        GetParametersForExport: {
          input: {
            type: "structure",
            required: [
              "KeyMaterialType",
              "SigningKeyAlgorithm"
            ],
            members: {
              KeyMaterialType: {},
              SigningKeyAlgorithm: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ExportToken",
              "ParametersValidUntilTimestamp",
              "SigningKeyAlgorithm",
              "SigningKeyCertificate",
              "SigningKeyCertificateChain"
            ],
            members: {
              ExportToken: {},
              ParametersValidUntilTimestamp: {
                type: "timestamp"
              },
              SigningKeyAlgorithm: {},
              SigningKeyCertificate: {
                shape: "S15"
              },
              SigningKeyCertificateChain: {
                shape: "S15"
              }
            }
          }
        },
        GetParametersForImport: {
          input: {
            type: "structure",
            required: [
              "KeyMaterialType",
              "WrappingKeyAlgorithm"
            ],
            members: {
              KeyMaterialType: {},
              WrappingKeyAlgorithm: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ImportToken",
              "ParametersValidUntilTimestamp",
              "WrappingKeyAlgorithm",
              "WrappingKeyCertificate",
              "WrappingKeyCertificateChain"
            ],
            members: {
              ImportToken: {},
              ParametersValidUntilTimestamp: {
                type: "timestamp"
              },
              WrappingKeyAlgorithm: {},
              WrappingKeyCertificate: {
                shape: "S15"
              },
              WrappingKeyCertificateChain: {
                shape: "S15"
              }
            }
          }
        },
        GetPublicKeyCertificate: {
          input: {
            type: "structure",
            required: [
              "KeyIdentifier"
            ],
            members: {
              KeyIdentifier: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "KeyCertificate",
              "KeyCertificateChain"
            ],
            members: {
              KeyCertificate: {
                shape: "S15"
              },
              KeyCertificateChain: {
                shape: "S15"
              }
            }
          }
        },
        ImportKey: {
          input: {
            type: "structure",
            required: [
              "KeyMaterial"
            ],
            members: {
              Enabled: {
                type: "boolean"
              },
              KeyCheckValueAlgorithm: {},
              KeyMaterial: {
                type: "structure",
                members: {
                  RootCertificatePublicKey: {
                    type: "structure",
                    required: [
                      "KeyAttributes",
                      "PublicKeyCertificate"
                    ],
                    members: {
                      KeyAttributes: {
                        shape: "S8"
                      },
                      PublicKeyCertificate: {
                        shape: "S15"
                      }
                    }
                  },
                  Tr31KeyBlock: {
                    type: "structure",
                    required: [
                      "WrappedKeyBlock",
                      "WrappingKeyIdentifier"
                    ],
                    members: {
                      WrappedKeyBlock: {},
                      WrappingKeyIdentifier: {}
                    }
                  },
                  Tr34KeyBlock: {
                    type: "structure",
                    required: [
                      "CertificateAuthorityPublicKeyIdentifier",
                      "ImportToken",
                      "KeyBlockFormat",
                      "SigningKeyCertificate",
                      "WrappedKeyBlock"
                    ],
                    members: {
                      CertificateAuthorityPublicKeyIdentifier: {},
                      ImportToken: {},
                      KeyBlockFormat: {},
                      RandomNonce: {},
                      SigningKeyCertificate: {
                        shape: "S15"
                      },
                      WrappedKeyBlock: {}
                    }
                  },
                  TrustedCertificatePublicKey: {
                    type: "structure",
                    required: [
                      "CertificateAuthorityPublicKeyIdentifier",
                      "KeyAttributes",
                      "PublicKeyCertificate"
                    ],
                    members: {
                      CertificateAuthorityPublicKeyIdentifier: {},
                      KeyAttributes: {
                        shape: "S8"
                      },
                      PublicKeyCertificate: {
                        shape: "S15"
                      }
                    }
                  }
                },
                union: true
              },
              Tags: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {
                shape: "Sk"
              }
            }
          }
        },
        ListAliases: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Aliases"
            ],
            members: {
              Aliases: {
                type: "list",
                member: {
                  shape: "S5"
                }
              },
              NextToken: {}
            }
          }
        },
        ListKeys: {
          input: {
            type: "structure",
            members: {
              KeyState: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Keys"
            ],
            members: {
              Keys: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Enabled",
                    "Exportable",
                    "KeyArn",
                    "KeyAttributes",
                    "KeyCheckValue",
                    "KeyState"
                  ],
                  members: {
                    Enabled: {
                      type: "boolean"
                    },
                    Exportable: {
                      type: "boolean"
                    },
                    KeyArn: {},
                    KeyAttributes: {
                      shape: "S8"
                    },
                    KeyCheckValue: {},
                    KeyState: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              NextToken: {},
              Tags: {
                shape: "Sf"
              }
            }
          }
        },
        RestoreKey: {
          input: {
            type: "structure",
            required: [
              "KeyIdentifier"
            ],
            members: {
              KeyIdentifier: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {
                shape: "Sk"
              }
            }
          }
        },
        StartKeyUsage: {
          input: {
            type: "structure",
            required: [
              "KeyIdentifier"
            ],
            members: {
              KeyIdentifier: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {
                shape: "Sk"
              }
            }
          }
        },
        StopKeyUsage: {
          input: {
            type: "structure",
            required: [
              "KeyIdentifier"
            ],
            members: {
              KeyIdentifier: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {
                shape: "Sk"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAlias: {
          input: {
            type: "structure",
            required: [
              "AliasName"
            ],
            members: {
              AliasName: {},
              KeyArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Alias"
            ],
            members: {
              Alias: {
                shape: "S5"
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          required: [
            "AliasName"
          ],
          members: {
            AliasName: {},
            KeyArn: {}
          }
        },
        S8: {
          type: "structure",
          required: [
            "KeyAlgorithm",
            "KeyClass",
            "KeyModesOfUse",
            "KeyUsage"
          ],
          members: {
            KeyAlgorithm: {},
            KeyClass: {},
            KeyModesOfUse: {
              type: "structure",
              members: {
                Decrypt: {
                  type: "boolean"
                },
                DeriveKey: {
                  type: "boolean"
                },
                Encrypt: {
                  type: "boolean"
                },
                Generate: {
                  type: "boolean"
                },
                NoRestrictions: {
                  type: "boolean"
                },
                Sign: {
                  type: "boolean"
                },
                Unwrap: {
                  type: "boolean"
                },
                Verify: {
                  type: "boolean"
                },
                Wrap: {
                  type: "boolean"
                }
              }
            },
            KeyUsage: {}
          }
        },
        Sf: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sk: {
          type: "structure",
          required: [
            "CreateTimestamp",
            "Enabled",
            "Exportable",
            "KeyArn",
            "KeyAttributes",
            "KeyCheckValue",
            "KeyCheckValueAlgorithm",
            "KeyOrigin",
            "KeyState"
          ],
          members: {
            CreateTimestamp: {
              type: "timestamp"
            },
            DeletePendingTimestamp: {
              type: "timestamp"
            },
            DeleteTimestamp: {
              type: "timestamp"
            },
            Enabled: {
              type: "boolean"
            },
            Exportable: {
              type: "boolean"
            },
            KeyArn: {},
            KeyAttributes: {
              shape: "S8"
            },
            KeyCheckValue: {},
            KeyCheckValueAlgorithm: {},
            KeyOrigin: {},
            KeyState: {},
            UsageStartTimestamp: {
              type: "timestamp"
            },
            UsageStopTimestamp: {
              type: "timestamp"
            }
          }
        },
        S15: {
          type: "string",
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/payment-cryptography-2021-09-14.paginators.json
var require_payment_cryptography_2021_09_14_paginators = __commonJS({
  "node_modules/aws-sdk/apis/payment-cryptography-2021-09-14.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAliases: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Aliases"
        },
        ListKeys: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Keys"
        },
        ListTagsForResource: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Tags"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/paymentcryptography.js
var require_paymentcryptography = __commonJS({
  "node_modules/aws-sdk/clients/paymentcryptography.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["paymentcryptography"] = {};
    AWS2.PaymentCryptography = Service.defineService("paymentcryptography", ["2021-09-14"]);
    Object.defineProperty(apiLoader.services["paymentcryptography"], "2021-09-14", {
      get: function get() {
        var model = require_payment_cryptography_2021_09_14_min();
        model.paginators = require_payment_cryptography_2021_09_14_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.PaymentCryptography;
  }
});

// node_modules/aws-sdk/apis/payment-cryptography-data-2022-02-03.min.json
var require_payment_cryptography_data_2022_02_03_min = __commonJS({
  "node_modules/aws-sdk/apis/payment-cryptography-data-2022-02-03.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2022-02-03",
        endpointPrefix: "dataplane.payment-cryptography",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Payment Cryptography Data Plane",
        serviceId: "Payment Cryptography Data",
        signatureVersion: "v4",
        signingName: "payment-cryptography",
        uid: "payment-cryptography-data-2022-02-03"
      },
      operations: {
        DecryptData: {
          http: {
            requestUri: "/keys/{KeyIdentifier}/decrypt",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CipherText",
              "DecryptionAttributes",
              "KeyIdentifier"
            ],
            members: {
              CipherText: {
                shape: "S2"
              },
              DecryptionAttributes: {
                shape: "S3"
              },
              KeyIdentifier: {
                location: "uri",
                locationName: "KeyIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "KeyArn",
              "KeyCheckValue",
              "PlainText"
            ],
            members: {
              KeyArn: {},
              KeyCheckValue: {},
              PlainText: {
                shape: "S2"
              }
            }
          }
        },
        EncryptData: {
          http: {
            requestUri: "/keys/{KeyIdentifier}/encrypt",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "EncryptionAttributes",
              "KeyIdentifier",
              "PlainText"
            ],
            members: {
              EncryptionAttributes: {
                shape: "S3"
              },
              KeyIdentifier: {
                location: "uri",
                locationName: "KeyIdentifier"
              },
              PlainText: {
                type: "string",
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CipherText",
              "KeyArn"
            ],
            members: {
              CipherText: {
                shape: "S2"
              },
              KeyArn: {},
              KeyCheckValue: {}
            }
          }
        },
        GenerateCardValidationData: {
          http: {
            requestUri: "/cardvalidationdata/generate",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "GenerationAttributes",
              "KeyIdentifier",
              "PrimaryAccountNumber"
            ],
            members: {
              GenerationAttributes: {
                type: "structure",
                members: {
                  AmexCardSecurityCodeVersion1: {
                    shape: "Sn"
                  },
                  AmexCardSecurityCodeVersion2: {
                    shape: "Sp"
                  },
                  CardHolderVerificationValue: {
                    shape: "Sr"
                  },
                  CardVerificationValue1: {
                    shape: "Sv"
                  },
                  CardVerificationValue2: {
                    shape: "Sw"
                  },
                  DynamicCardVerificationCode: {
                    shape: "Sx"
                  },
                  DynamicCardVerificationValue: {
                    shape: "Sz"
                  }
                },
                union: true
              },
              KeyIdentifier: {},
              PrimaryAccountNumber: {
                shape: "S10"
              },
              ValidationDataLength: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "KeyArn",
              "KeyCheckValue",
              "ValidationData"
            ],
            members: {
              KeyArn: {},
              KeyCheckValue: {},
              ValidationData: {}
            }
          }
        },
        GenerateMac: {
          http: {
            requestUri: "/mac/generate",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "GenerationAttributes",
              "KeyIdentifier",
              "MessageData"
            ],
            members: {
              GenerationAttributes: {
                shape: "S15"
              },
              KeyIdentifier: {},
              MacLength: {
                type: "integer"
              },
              MessageData: {
                shape: "S1e"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "KeyArn",
              "KeyCheckValue",
              "Mac"
            ],
            members: {
              KeyArn: {},
              KeyCheckValue: {},
              Mac: {}
            }
          }
        },
        GeneratePinData: {
          http: {
            requestUri: "/pindata/generate",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "EncryptionKeyIdentifier",
              "GenerationAttributes",
              "GenerationKeyIdentifier",
              "PinBlockFormat",
              "PrimaryAccountNumber"
            ],
            members: {
              EncryptionKeyIdentifier: {},
              GenerationAttributes: {
                type: "structure",
                members: {
                  Ibm3624NaturalPin: {
                    type: "structure",
                    required: [
                      "DecimalizationTable",
                      "PinValidationData",
                      "PinValidationDataPadCharacter"
                    ],
                    members: {
                      DecimalizationTable: {},
                      PinValidationData: {},
                      PinValidationDataPadCharacter: {}
                    }
                  },
                  Ibm3624PinFromOffset: {
                    type: "structure",
                    required: [
                      "DecimalizationTable",
                      "PinOffset",
                      "PinValidationData",
                      "PinValidationDataPadCharacter"
                    ],
                    members: {
                      DecimalizationTable: {},
                      PinOffset: {},
                      PinValidationData: {},
                      PinValidationDataPadCharacter: {}
                    }
                  },
                  Ibm3624PinOffset: {
                    type: "structure",
                    required: [
                      "DecimalizationTable",
                      "EncryptedPinBlock",
                      "PinValidationData",
                      "PinValidationDataPadCharacter"
                    ],
                    members: {
                      DecimalizationTable: {},
                      EncryptedPinBlock: {},
                      PinValidationData: {},
                      PinValidationDataPadCharacter: {}
                    }
                  },
                  Ibm3624RandomPin: {
                    type: "structure",
                    required: [
                      "DecimalizationTable",
                      "PinValidationData",
                      "PinValidationDataPadCharacter"
                    ],
                    members: {
                      DecimalizationTable: {},
                      PinValidationData: {},
                      PinValidationDataPadCharacter: {}
                    }
                  },
                  VisaPin: {
                    type: "structure",
                    required: [
                      "PinVerificationKeyIndex"
                    ],
                    members: {
                      PinVerificationKeyIndex: {
                        type: "integer"
                      }
                    }
                  },
                  VisaPinVerificationValue: {
                    type: "structure",
                    required: [
                      "EncryptedPinBlock",
                      "PinVerificationKeyIndex"
                    ],
                    members: {
                      EncryptedPinBlock: {},
                      PinVerificationKeyIndex: {
                        type: "integer"
                      }
                    }
                  }
                },
                union: true
              },
              GenerationKeyIdentifier: {},
              PinBlockFormat: {},
              PinDataLength: {
                type: "integer"
              },
              PrimaryAccountNumber: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EncryptedPinBlock",
              "EncryptionKeyArn",
              "EncryptionKeyCheckValue",
              "GenerationKeyArn",
              "GenerationKeyCheckValue",
              "PinData"
            ],
            members: {
              EncryptedPinBlock: {},
              EncryptionKeyArn: {},
              EncryptionKeyCheckValue: {},
              GenerationKeyArn: {},
              GenerationKeyCheckValue: {},
              PinData: {
                type: "structure",
                members: {
                  PinOffset: {},
                  VerificationValue: {}
                },
                union: true
              }
            }
          }
        },
        ReEncryptData: {
          http: {
            requestUri: "/keys/{IncomingKeyIdentifier}/reencrypt",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CipherText",
              "IncomingEncryptionAttributes",
              "IncomingKeyIdentifier",
              "OutgoingEncryptionAttributes",
              "OutgoingKeyIdentifier"
            ],
            members: {
              CipherText: {
                shape: "S2"
              },
              IncomingEncryptionAttributes: {
                shape: "S20"
              },
              IncomingKeyIdentifier: {
                location: "uri",
                locationName: "IncomingKeyIdentifier"
              },
              OutgoingEncryptionAttributes: {
                shape: "S20"
              },
              OutgoingKeyIdentifier: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "CipherText",
              "KeyArn",
              "KeyCheckValue"
            ],
            members: {
              CipherText: {
                shape: "S2"
              },
              KeyArn: {},
              KeyCheckValue: {}
            }
          }
        },
        TranslatePinData: {
          http: {
            requestUri: "/pindata/translate",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "EncryptedPinBlock",
              "IncomingKeyIdentifier",
              "IncomingTranslationAttributes",
              "OutgoingKeyIdentifier",
              "OutgoingTranslationAttributes"
            ],
            members: {
              EncryptedPinBlock: {
                type: "string",
                sensitive: true
              },
              IncomingDukptAttributes: {
                shape: "S24"
              },
              IncomingKeyIdentifier: {},
              IncomingTranslationAttributes: {
                shape: "S25"
              },
              OutgoingDukptAttributes: {
                shape: "S24"
              },
              OutgoingKeyIdentifier: {},
              OutgoingTranslationAttributes: {
                shape: "S25"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "KeyArn",
              "KeyCheckValue",
              "PinBlock"
            ],
            members: {
              KeyArn: {},
              KeyCheckValue: {},
              PinBlock: {}
            }
          }
        },
        VerifyAuthRequestCryptogram: {
          http: {
            requestUri: "/cryptogram/verify",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AuthRequestCryptogram",
              "KeyIdentifier",
              "MajorKeyDerivationMode",
              "SessionKeyDerivationAttributes",
              "TransactionData"
            ],
            members: {
              AuthRequestCryptogram: {},
              AuthResponseAttributes: {
                type: "structure",
                members: {
                  ArpcMethod1: {
                    type: "structure",
                    required: [
                      "AuthResponseCode"
                    ],
                    members: {
                      AuthResponseCode: {}
                    }
                  },
                  ArpcMethod2: {
                    type: "structure",
                    required: [
                      "CardStatusUpdate"
                    ],
                    members: {
                      CardStatusUpdate: {},
                      ProprietaryAuthenticationData: {}
                    }
                  }
                },
                union: true
              },
              KeyIdentifier: {},
              MajorKeyDerivationMode: {},
              SessionKeyDerivationAttributes: {
                type: "structure",
                members: {
                  Amex: {
                    type: "structure",
                    required: [
                      "PanSequenceNumber",
                      "PrimaryAccountNumber"
                    ],
                    members: {
                      PanSequenceNumber: {},
                      PrimaryAccountNumber: {
                        shape: "S10"
                      }
                    }
                  },
                  Emv2000: {
                    type: "structure",
                    required: [
                      "ApplicationTransactionCounter",
                      "PanSequenceNumber",
                      "PrimaryAccountNumber"
                    ],
                    members: {
                      ApplicationTransactionCounter: {},
                      PanSequenceNumber: {},
                      PrimaryAccountNumber: {
                        shape: "S10"
                      }
                    }
                  },
                  EmvCommon: {
                    type: "structure",
                    required: [
                      "ApplicationTransactionCounter",
                      "PanSequenceNumber",
                      "PrimaryAccountNumber"
                    ],
                    members: {
                      ApplicationTransactionCounter: {},
                      PanSequenceNumber: {},
                      PrimaryAccountNumber: {
                        shape: "S10"
                      }
                    }
                  },
                  Mastercard: {
                    type: "structure",
                    required: [
                      "ApplicationTransactionCounter",
                      "PanSequenceNumber",
                      "PrimaryAccountNumber",
                      "UnpredictableNumber"
                    ],
                    members: {
                      ApplicationTransactionCounter: {},
                      PanSequenceNumber: {},
                      PrimaryAccountNumber: {
                        shape: "S10"
                      },
                      UnpredictableNumber: {}
                    }
                  },
                  Visa: {
                    type: "structure",
                    required: [
                      "PanSequenceNumber",
                      "PrimaryAccountNumber"
                    ],
                    members: {
                      PanSequenceNumber: {},
                      PrimaryAccountNumber: {
                        shape: "S10"
                      }
                    }
                  }
                },
                union: true
              },
              TransactionData: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "KeyArn",
              "KeyCheckValue"
            ],
            members: {
              AuthResponseValue: {},
              KeyArn: {},
              KeyCheckValue: {}
            }
          }
        },
        VerifyCardValidationData: {
          http: {
            requestUri: "/cardvalidationdata/verify",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "KeyIdentifier",
              "PrimaryAccountNumber",
              "ValidationData",
              "VerificationAttributes"
            ],
            members: {
              KeyIdentifier: {},
              PrimaryAccountNumber: {
                shape: "S10"
              },
              ValidationData: {},
              VerificationAttributes: {
                type: "structure",
                members: {
                  AmexCardSecurityCodeVersion1: {
                    shape: "Sn"
                  },
                  AmexCardSecurityCodeVersion2: {
                    shape: "Sp"
                  },
                  CardHolderVerificationValue: {
                    shape: "Sr"
                  },
                  CardVerificationValue1: {
                    shape: "Sv"
                  },
                  CardVerificationValue2: {
                    shape: "Sw"
                  },
                  DiscoverDynamicCardVerificationCode: {
                    type: "structure",
                    required: [
                      "ApplicationTransactionCounter",
                      "CardExpiryDate",
                      "UnpredictableNumber"
                    ],
                    members: {
                      ApplicationTransactionCounter: {},
                      CardExpiryDate: {},
                      UnpredictableNumber: {}
                    }
                  },
                  DynamicCardVerificationCode: {
                    shape: "Sx"
                  },
                  DynamicCardVerificationValue: {
                    shape: "Sz"
                  }
                },
                union: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "KeyArn",
              "KeyCheckValue"
            ],
            members: {
              KeyArn: {},
              KeyCheckValue: {}
            }
          }
        },
        VerifyMac: {
          http: {
            requestUri: "/mac/verify",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "KeyIdentifier",
              "Mac",
              "MessageData",
              "VerificationAttributes"
            ],
            members: {
              KeyIdentifier: {},
              Mac: {
                type: "string",
                sensitive: true
              },
              MacLength: {
                type: "integer"
              },
              MessageData: {
                shape: "S1e"
              },
              VerificationAttributes: {
                shape: "S15"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "KeyArn",
              "KeyCheckValue"
            ],
            members: {
              KeyArn: {},
              KeyCheckValue: {}
            }
          }
        },
        VerifyPinData: {
          http: {
            requestUri: "/pindata/verify",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "EncryptedPinBlock",
              "EncryptionKeyIdentifier",
              "PinBlockFormat",
              "PrimaryAccountNumber",
              "VerificationAttributes",
              "VerificationKeyIdentifier"
            ],
            members: {
              DukptAttributes: {
                type: "structure",
                required: [
                  "DukptDerivationType",
                  "KeySerialNumber"
                ],
                members: {
                  DukptDerivationType: {},
                  KeySerialNumber: {}
                }
              },
              EncryptedPinBlock: {},
              EncryptionKeyIdentifier: {},
              PinBlockFormat: {},
              PinDataLength: {
                type: "integer"
              },
              PrimaryAccountNumber: {
                shape: "S10"
              },
              VerificationAttributes: {
                type: "structure",
                members: {
                  Ibm3624Pin: {
                    type: "structure",
                    required: [
                      "DecimalizationTable",
                      "PinOffset",
                      "PinValidationData",
                      "PinValidationDataPadCharacter"
                    ],
                    members: {
                      DecimalizationTable: {},
                      PinOffset: {},
                      PinValidationData: {},
                      PinValidationDataPadCharacter: {}
                    }
                  },
                  VisaPin: {
                    type: "structure",
                    required: [
                      "PinVerificationKeyIndex",
                      "VerificationValue"
                    ],
                    members: {
                      PinVerificationKeyIndex: {
                        type: "integer"
                      },
                      VerificationValue: {}
                    }
                  }
                },
                union: true
              },
              VerificationKeyIdentifier: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "EncryptionKeyArn",
              "EncryptionKeyCheckValue",
              "VerificationKeyArn",
              "VerificationKeyCheckValue"
            ],
            members: {
              EncryptionKeyArn: {},
              EncryptionKeyCheckValue: {},
              VerificationKeyArn: {},
              VerificationKeyCheckValue: {}
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "string",
          sensitive: true
        },
        S3: {
          type: "structure",
          members: {
            Asymmetric: {
              type: "structure",
              members: {
                PaddingType: {}
              }
            },
            Dukpt: {
              shape: "S6"
            },
            Symmetric: {
              shape: "Sc"
            }
          },
          union: true
        },
        S6: {
          type: "structure",
          required: [
            "KeySerialNumber"
          ],
          members: {
            DukptKeyDerivationType: {},
            DukptKeyVariant: {},
            InitializationVector: {
              shape: "S9"
            },
            KeySerialNumber: {},
            Mode: {}
          }
        },
        S9: {
          type: "string",
          sensitive: true
        },
        Sc: {
          type: "structure",
          required: [
            "Mode"
          ],
          members: {
            InitializationVector: {
              shape: "S9"
            },
            Mode: {},
            PaddingType: {}
          }
        },
        Sn: {
          type: "structure",
          required: [
            "CardExpiryDate"
          ],
          members: {
            CardExpiryDate: {}
          }
        },
        Sp: {
          type: "structure",
          required: [
            "CardExpiryDate",
            "ServiceCode"
          ],
          members: {
            CardExpiryDate: {},
            ServiceCode: {}
          }
        },
        Sr: {
          type: "structure",
          required: [
            "ApplicationTransactionCounter",
            "PanSequenceNumber",
            "UnpredictableNumber"
          ],
          members: {
            ApplicationTransactionCounter: {},
            PanSequenceNumber: {},
            UnpredictableNumber: {}
          }
        },
        Sv: {
          type: "structure",
          required: [
            "CardExpiryDate",
            "ServiceCode"
          ],
          members: {
            CardExpiryDate: {},
            ServiceCode: {}
          }
        },
        Sw: {
          type: "structure",
          required: [
            "CardExpiryDate"
          ],
          members: {
            CardExpiryDate: {}
          }
        },
        Sx: {
          type: "structure",
          required: [
            "ApplicationTransactionCounter",
            "PanSequenceNumber",
            "TrackData",
            "UnpredictableNumber"
          ],
          members: {
            ApplicationTransactionCounter: {},
            PanSequenceNumber: {},
            TrackData: {},
            UnpredictableNumber: {}
          }
        },
        Sz: {
          type: "structure",
          required: [
            "ApplicationTransactionCounter",
            "CardExpiryDate",
            "PanSequenceNumber",
            "ServiceCode"
          ],
          members: {
            ApplicationTransactionCounter: {},
            CardExpiryDate: {},
            PanSequenceNumber: {},
            ServiceCode: {}
          }
        },
        S10: {
          type: "string",
          sensitive: true
        },
        S15: {
          type: "structure",
          members: {
            Algorithm: {},
            DukptCmac: {
              shape: "S17"
            },
            DukptIso9797Algorithm1: {
              shape: "S17"
            },
            DukptIso9797Algorithm3: {
              shape: "S17"
            },
            EmvMac: {
              type: "structure",
              required: [
                "MajorKeyDerivationMode",
                "PanSequenceNumber",
                "PrimaryAccountNumber",
                "SessionKeyDerivationMode",
                "SessionKeyDerivationValue"
              ],
              members: {
                MajorKeyDerivationMode: {},
                PanSequenceNumber: {},
                PrimaryAccountNumber: {
                  shape: "S10"
                },
                SessionKeyDerivationMode: {},
                SessionKeyDerivationValue: {
                  type: "structure",
                  members: {
                    ApplicationCryptogram: {},
                    ApplicationTransactionCounter: {}
                  },
                  union: true
                }
              }
            }
          },
          union: true
        },
        S17: {
          type: "structure",
          required: [
            "DukptKeyVariant",
            "KeySerialNumber"
          ],
          members: {
            DukptDerivationType: {},
            DukptKeyVariant: {},
            KeySerialNumber: {}
          }
        },
        S1e: {
          type: "string",
          sensitive: true
        },
        S20: {
          type: "structure",
          members: {
            Dukpt: {
              shape: "S6"
            },
            Symmetric: {
              shape: "Sc"
            }
          },
          union: true
        },
        S24: {
          type: "structure",
          required: [
            "KeySerialNumber"
          ],
          members: {
            DukptKeyDerivationType: {},
            DukptKeyVariant: {},
            KeySerialNumber: {}
          }
        },
        S25: {
          type: "structure",
          members: {
            IsoFormat0: {
              shape: "S26"
            },
            IsoFormat1: {
              type: "structure",
              members: {}
            },
            IsoFormat3: {
              shape: "S26"
            },
            IsoFormat4: {
              shape: "S26"
            }
          },
          union: true
        },
        S26: {
          type: "structure",
          required: [
            "PrimaryAccountNumber"
          ],
          members: {
            PrimaryAccountNumber: {
              shape: "S10"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/payment-cryptography-data-2022-02-03.paginators.json
var require_payment_cryptography_data_2022_02_03_paginators = __commonJS({
  "node_modules/aws-sdk/apis/payment-cryptography-data-2022-02-03.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/paymentcryptographydata.js
var require_paymentcryptographydata = __commonJS({
  "node_modules/aws-sdk/clients/paymentcryptographydata.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["paymentcryptographydata"] = {};
    AWS2.PaymentCryptographyData = Service.defineService("paymentcryptographydata", ["2022-02-03"]);
    Object.defineProperty(apiLoader.services["paymentcryptographydata"], "2022-02-03", {
      get: function get() {
        var model = require_payment_cryptography_data_2022_02_03_min();
        model.paginators = require_payment_cryptography_data_2022_02_03_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.PaymentCryptographyData;
  }
});

// node_modules/aws-sdk/apis/codeguru-security-2018-05-10.min.json
var require_codeguru_security_2018_05_10_min = __commonJS({
  "node_modules/aws-sdk/apis/codeguru-security-2018-05-10.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-05-10",
        endpointPrefix: "codeguru-security",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon CodeGuru Security",
        serviceId: "CodeGuru Security",
        signatureVersion: "v4",
        signingName: "codeguru-security",
        uid: "codeguru-security-2018-05-10"
      },
      operations: {
        BatchGetFindings: {
          http: {
            requestUri: "/batchGetFindings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "findingIdentifiers"
            ],
            members: {
              findingIdentifiers: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "findingId",
                    "scanName"
                  ],
                  members: {
                    findingId: {},
                    scanName: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "failedFindings",
              "findings"
            ],
            members: {
              failedFindings: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "errorCode",
                    "findingId",
                    "message",
                    "scanName"
                  ],
                  members: {
                    errorCode: {},
                    findingId: {},
                    message: {},
                    scanName: {}
                  }
                }
              },
              findings: {
                shape: "Sa"
              }
            }
          }
        },
        CreateScan: {
          http: {
            requestUri: "/scans",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceId",
              "scanName"
            ],
            members: {
              analysisType: {},
              clientToken: {
                idempotencyToken: true
              },
              resourceId: {
                shape: "Sv"
              },
              scanName: {},
              scanType: {},
              tags: {
                shape: "Sy"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "resourceId",
              "runId",
              "scanName",
              "scanState"
            ],
            members: {
              resourceId: {
                shape: "Sv"
              },
              runId: {},
              scanName: {},
              scanNameArn: {},
              scanState: {}
            }
          }
        },
        CreateUploadUrl: {
          http: {
            requestUri: "/uploadUrl",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "scanName"
            ],
            members: {
              scanName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "codeArtifactId",
              "requestHeaders",
              "s3Url"
            ],
            members: {
              codeArtifactId: {},
              requestHeaders: {
                type: "map",
                key: {},
                value: {},
                sensitive: true
              },
              s3Url: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        GetAccountConfiguration: {
          http: {
            method: "GET",
            requestUri: "/accountConfiguration/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "encryptionConfig"
            ],
            members: {
              encryptionConfig: {
                shape: "S1c"
              }
            }
          }
        },
        GetFindings: {
          http: {
            method: "GET",
            requestUri: "/findings/{scanName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "scanName"
            ],
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              scanName: {
                location: "uri",
                locationName: "scanName"
              },
              status: {
                location: "querystring",
                locationName: "status"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              findings: {
                shape: "Sa"
              },
              nextToken: {}
            }
          }
        },
        GetMetricsSummary: {
          http: {
            method: "GET",
            requestUri: "/metrics/summary",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "date"
            ],
            members: {
              date: {
                location: "querystring",
                locationName: "date",
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              metricsSummary: {
                type: "structure",
                members: {
                  categoriesWithMostFindings: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        categoryName: {},
                        findingNumber: {
                          type: "integer"
                        }
                      }
                    }
                  },
                  date: {
                    type: "timestamp"
                  },
                  openFindings: {
                    shape: "S1n"
                  },
                  scansWithMostOpenCriticalFindings: {
                    type: "list",
                    member: {
                      shape: "S1q"
                    }
                  },
                  scansWithMostOpenFindings: {
                    type: "list",
                    member: {
                      shape: "S1q"
                    }
                  }
                }
              }
            }
          }
        },
        GetScan: {
          http: {
            method: "GET",
            requestUri: "/scans/{scanName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "scanName"
            ],
            members: {
              runId: {
                location: "querystring",
                locationName: "runId"
              },
              scanName: {
                location: "uri",
                locationName: "scanName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "analysisType",
              "createdAt",
              "runId",
              "scanName",
              "scanState"
            ],
            members: {
              analysisType: {},
              createdAt: {
                type: "timestamp"
              },
              numberOfRevisions: {
                type: "long"
              },
              runId: {},
              scanName: {},
              scanNameArn: {},
              scanState: {},
              updatedAt: {
                type: "timestamp"
              }
            }
          }
        },
        ListFindingsMetrics: {
          http: {
            method: "GET",
            requestUri: "/metrics/findings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "endDate",
              "startDate"
            ],
            members: {
              endDate: {
                location: "querystring",
                locationName: "endDate",
                type: "timestamp"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              startDate: {
                location: "querystring",
                locationName: "startDate",
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              findingsMetrics: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    closedFindings: {
                      shape: "S1n"
                    },
                    date: {
                      type: "timestamp"
                    },
                    meanTimeToClose: {
                      shape: "S1n"
                    },
                    newFindings: {
                      shape: "S1n"
                    },
                    openFindings: {
                      shape: "S1n"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListScans: {
          http: {
            method: "GET",
            requestUri: "/scans",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              summaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "createdAt",
                    "runId",
                    "scanName",
                    "scanState"
                  ],
                  members: {
                    createdAt: {
                      type: "timestamp"
                    },
                    runId: {},
                    scanName: {},
                    scanNameArn: {},
                    scanState: {},
                    updatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sy"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sy"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateAccountConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/updateAccountConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "encryptionConfig"
            ],
            members: {
              encryptionConfig: {
                shape: "S1c"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "encryptionConfig"
            ],
            members: {
              encryptionConfig: {
                shape: "S1c"
              }
            }
          }
        }
      },
      shapes: {
        Sa: {
          type: "list",
          member: {
            type: "structure",
            members: {
              createdAt: {
                type: "timestamp"
              },
              description: {},
              detectorId: {},
              detectorName: {},
              detectorTags: {
                type: "list",
                member: {}
              },
              generatorId: {},
              id: {},
              remediation: {
                type: "structure",
                members: {
                  recommendation: {
                    type: "structure",
                    members: {
                      text: {},
                      url: {}
                    }
                  },
                  suggestedFixes: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        code: {},
                        description: {}
                      }
                    }
                  }
                }
              },
              resource: {
                type: "structure",
                members: {
                  id: {},
                  subResourceId: {}
                }
              },
              ruleId: {},
              severity: {},
              status: {},
              title: {},
              type: {},
              updatedAt: {
                type: "timestamp"
              },
              vulnerability: {
                type: "structure",
                members: {
                  filePath: {
                    type: "structure",
                    members: {
                      codeSnippet: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            content: {},
                            number: {
                              type: "integer"
                            }
                          }
                        }
                      },
                      endLine: {
                        type: "integer"
                      },
                      name: {},
                      path: {},
                      startLine: {
                        type: "integer"
                      }
                    }
                  },
                  id: {},
                  itemCount: {
                    type: "integer"
                  },
                  referenceUrls: {
                    type: "list",
                    member: {}
                  },
                  relatedVulnerabilities: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          }
        },
        Sv: {
          type: "structure",
          members: {
            codeArtifactId: {}
          },
          union: true
        },
        Sy: {
          type: "map",
          key: {},
          value: {}
        },
        S1c: {
          type: "structure",
          members: {
            kmsKeyArn: {}
          }
        },
        S1n: {
          type: "structure",
          members: {
            critical: {
              type: "double"
            },
            high: {
              type: "double"
            },
            info: {
              type: "double"
            },
            low: {
              type: "double"
            },
            medium: {
              type: "double"
            }
          }
        },
        S1q: {
          type: "structure",
          members: {
            findingNumber: {
              type: "integer"
            },
            scanName: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/codeguru-security-2018-05-10.paginators.json
var require_codeguru_security_2018_05_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/codeguru-security-2018-05-10.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetFindings: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "findings"
        },
        ListFindingsMetrics: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "findingsMetrics"
        },
        ListScans: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "summaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/codegurusecurity.js
var require_codegurusecurity = __commonJS({
  "node_modules/aws-sdk/clients/codegurusecurity.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["codegurusecurity"] = {};
    AWS2.CodeGuruSecurity = Service.defineService("codegurusecurity", ["2018-05-10"]);
    Object.defineProperty(apiLoader.services["codegurusecurity"], "2018-05-10", {
      get: function get() {
        var model = require_codeguru_security_2018_05_10_min();
        model.paginators = require_codeguru_security_2018_05_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CodeGuruSecurity;
  }
});

// node_modules/aws-sdk/apis/verifiedpermissions-2021-12-01.min.json
var require_verifiedpermissions_2021_12_01_min = __commonJS({
  "node_modules/aws-sdk/apis/verifiedpermissions-2021-12-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-12-01",
        endpointPrefix: "verifiedpermissions",
        jsonVersion: "1.0",
        protocol: "json",
        serviceFullName: "Amazon Verified Permissions",
        serviceId: "VerifiedPermissions",
        signatureVersion: "v4",
        signingName: "verifiedpermissions",
        targetPrefix: "VerifiedPermissions",
        uid: "verifiedpermissions-2021-12-01"
      },
      operations: {
        BatchIsAuthorized: {
          input: {
            type: "structure",
            required: [
              "policyStoreId",
              "requests"
            ],
            members: {
              policyStoreId: {},
              entities: {
                shape: "S3"
              },
              requests: {
                type: "list",
                member: {
                  shape: "Sj"
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "results"
            ],
            members: {
              results: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "request",
                    "decision",
                    "determiningPolicies",
                    "errors"
                  ],
                  members: {
                    request: {
                      shape: "Sj"
                    },
                    decision: {},
                    determiningPolicies: {
                      shape: "St"
                    },
                    errors: {
                      shape: "Sw"
                    }
                  }
                }
              }
            }
          }
        },
        CreateIdentitySource: {
          input: {
            type: "structure",
            required: [
              "policyStoreId",
              "configuration"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              policyStoreId: {},
              configuration: {
                type: "structure",
                members: {
                  cognitoUserPoolConfiguration: {
                    type: "structure",
                    required: [
                      "userPoolArn"
                    ],
                    members: {
                      userPoolArn: {},
                      clientIds: {
                        shape: "S13"
                      }
                    }
                  }
                },
                union: true
              },
              principalEntityType: {
                shape: "S15"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "createdDate",
              "identitySourceId",
              "lastUpdatedDate",
              "policyStoreId"
            ],
            members: {
              createdDate: {
                shape: "S17"
              },
              identitySourceId: {},
              lastUpdatedDate: {
                shape: "S17"
              },
              policyStoreId: {}
            }
          },
          idempotent: true
        },
        CreatePolicy: {
          input: {
            type: "structure",
            required: [
              "policyStoreId",
              "definition"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              policyStoreId: {},
              definition: {
                type: "structure",
                members: {
                  static: {
                    type: "structure",
                    required: [
                      "statement"
                    ],
                    members: {
                      description: {
                        shape: "S1c"
                      },
                      statement: {
                        shape: "S1d"
                      }
                    }
                  },
                  templateLinked: {
                    type: "structure",
                    required: [
                      "policyTemplateId"
                    ],
                    members: {
                      policyTemplateId: {},
                      principal: {
                        shape: "S6"
                      },
                      resource: {
                        shape: "S6"
                      }
                    }
                  }
                },
                union: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "policyStoreId",
              "policyId",
              "policyType",
              "createdDate",
              "lastUpdatedDate"
            ],
            members: {
              policyStoreId: {},
              policyId: {},
              policyType: {},
              principal: {
                shape: "S6"
              },
              resource: {
                shape: "S6"
              },
              createdDate: {
                shape: "S17"
              },
              lastUpdatedDate: {
                shape: "S17"
              }
            }
          },
          idempotent: true
        },
        CreatePolicyStore: {
          input: {
            type: "structure",
            required: [
              "validationSettings"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              validationSettings: {
                shape: "S1j"
              },
              description: {
                shape: "S1l"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "policyStoreId",
              "arn",
              "createdDate",
              "lastUpdatedDate"
            ],
            members: {
              policyStoreId: {},
              arn: {},
              createdDate: {
                shape: "S17"
              },
              lastUpdatedDate: {
                shape: "S17"
              }
            }
          },
          idempotent: true
        },
        CreatePolicyTemplate: {
          input: {
            type: "structure",
            required: [
              "policyStoreId",
              "statement"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              policyStoreId: {},
              description: {
                shape: "S1p"
              },
              statement: {
                shape: "S1d"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "policyStoreId",
              "policyTemplateId",
              "createdDate",
              "lastUpdatedDate"
            ],
            members: {
              policyStoreId: {},
              policyTemplateId: {},
              createdDate: {
                shape: "S17"
              },
              lastUpdatedDate: {
                shape: "S17"
              }
            }
          },
          idempotent: true
        },
        DeleteIdentitySource: {
          input: {
            type: "structure",
            required: [
              "policyStoreId",
              "identitySourceId"
            ],
            members: {
              policyStoreId: {},
              identitySourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeletePolicy: {
          input: {
            type: "structure",
            required: [
              "policyStoreId",
              "policyId"
            ],
            members: {
              policyStoreId: {},
              policyId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeletePolicyStore: {
          input: {
            type: "structure",
            required: [
              "policyStoreId"
            ],
            members: {
              policyStoreId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeletePolicyTemplate: {
          input: {
            type: "structure",
            required: [
              "policyStoreId",
              "policyTemplateId"
            ],
            members: {
              policyStoreId: {},
              policyTemplateId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        GetIdentitySource: {
          input: {
            type: "structure",
            required: [
              "policyStoreId",
              "identitySourceId"
            ],
            members: {
              policyStoreId: {},
              identitySourceId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "createdDate",
              "details",
              "identitySourceId",
              "lastUpdatedDate",
              "policyStoreId",
              "principalEntityType"
            ],
            members: {
              createdDate: {
                shape: "S17"
              },
              details: {
                type: "structure",
                members: {
                  clientIds: {
                    shape: "S13"
                  },
                  userPoolArn: {},
                  discoveryUrl: {},
                  openIdIssuer: {}
                }
              },
              identitySourceId: {},
              lastUpdatedDate: {
                shape: "S17"
              },
              policyStoreId: {},
              principalEntityType: {
                shape: "S15"
              }
            }
          }
        },
        GetPolicy: {
          input: {
            type: "structure",
            required: [
              "policyStoreId",
              "policyId"
            ],
            members: {
              policyStoreId: {},
              policyId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "policyStoreId",
              "policyId",
              "policyType",
              "definition",
              "createdDate",
              "lastUpdatedDate"
            ],
            members: {
              policyStoreId: {},
              policyId: {},
              policyType: {},
              principal: {
                shape: "S6"
              },
              resource: {
                shape: "S6"
              },
              definition: {
                type: "structure",
                members: {
                  static: {
                    type: "structure",
                    required: [
                      "statement"
                    ],
                    members: {
                      description: {
                        shape: "S1c"
                      },
                      statement: {
                        shape: "S1d"
                      }
                    }
                  },
                  templateLinked: {
                    type: "structure",
                    required: [
                      "policyTemplateId"
                    ],
                    members: {
                      policyTemplateId: {},
                      principal: {
                        shape: "S6"
                      },
                      resource: {
                        shape: "S6"
                      }
                    }
                  }
                },
                union: true
              },
              createdDate: {
                shape: "S17"
              },
              lastUpdatedDate: {
                shape: "S17"
              }
            }
          }
        },
        GetPolicyStore: {
          input: {
            type: "structure",
            required: [
              "policyStoreId"
            ],
            members: {
              policyStoreId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "policyStoreId",
              "arn",
              "validationSettings",
              "createdDate",
              "lastUpdatedDate"
            ],
            members: {
              policyStoreId: {},
              arn: {},
              validationSettings: {
                shape: "S1j"
              },
              createdDate: {
                shape: "S17"
              },
              lastUpdatedDate: {
                shape: "S17"
              },
              description: {
                shape: "S1l"
              }
            }
          }
        },
        GetPolicyTemplate: {
          input: {
            type: "structure",
            required: [
              "policyStoreId",
              "policyTemplateId"
            ],
            members: {
              policyStoreId: {},
              policyTemplateId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "policyStoreId",
              "policyTemplateId",
              "statement",
              "createdDate",
              "lastUpdatedDate"
            ],
            members: {
              policyStoreId: {},
              policyTemplateId: {},
              description: {
                shape: "S1p"
              },
              statement: {
                shape: "S1d"
              },
              createdDate: {
                shape: "S17"
              },
              lastUpdatedDate: {
                shape: "S17"
              }
            }
          }
        },
        GetSchema: {
          input: {
            type: "structure",
            required: [
              "policyStoreId"
            ],
            members: {
              policyStoreId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "policyStoreId",
              "schema",
              "createdDate",
              "lastUpdatedDate"
            ],
            members: {
              policyStoreId: {},
              schema: {
                shape: "S2f"
              },
              createdDate: {
                shape: "S17"
              },
              lastUpdatedDate: {
                shape: "S17"
              },
              namespaces: {
                shape: "S2g"
              }
            }
          }
        },
        IsAuthorized: {
          input: {
            type: "structure",
            required: [
              "policyStoreId"
            ],
            members: {
              policyStoreId: {},
              principal: {
                shape: "S6"
              },
              action: {
                shape: "Sk"
              },
              resource: {
                shape: "S6"
              },
              context: {
                shape: "Sn"
              },
              entities: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "decision",
              "determiningPolicies",
              "errors"
            ],
            members: {
              decision: {},
              determiningPolicies: {
                shape: "St"
              },
              errors: {
                shape: "Sw"
              }
            }
          }
        },
        IsAuthorizedWithToken: {
          input: {
            type: "structure",
            required: [
              "policyStoreId"
            ],
            members: {
              policyStoreId: {},
              identityToken: {
                shape: "S2l"
              },
              accessToken: {
                shape: "S2l"
              },
              action: {
                shape: "Sk"
              },
              resource: {
                shape: "S6"
              },
              context: {
                shape: "Sn"
              },
              entities: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "decision",
              "determiningPolicies",
              "errors"
            ],
            members: {
              decision: {},
              determiningPolicies: {
                shape: "St"
              },
              errors: {
                shape: "Sw"
              }
            }
          }
        },
        ListIdentitySources: {
          input: {
            type: "structure",
            required: [
              "policyStoreId"
            ],
            members: {
              policyStoreId: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    principalEntityType: {
                      shape: "S15"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "identitySources"
            ],
            members: {
              nextToken: {},
              identitySources: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "createdDate",
                    "details",
                    "identitySourceId",
                    "lastUpdatedDate",
                    "policyStoreId",
                    "principalEntityType"
                  ],
                  members: {
                    createdDate: {
                      shape: "S17"
                    },
                    details: {
                      type: "structure",
                      members: {
                        clientIds: {
                          shape: "S13"
                        },
                        userPoolArn: {},
                        discoveryUrl: {},
                        openIdIssuer: {}
                      }
                    },
                    identitySourceId: {},
                    lastUpdatedDate: {
                      shape: "S17"
                    },
                    policyStoreId: {},
                    principalEntityType: {
                      shape: "S15"
                    }
                  }
                }
              }
            }
          }
        },
        ListPolicies: {
          input: {
            type: "structure",
            required: [
              "policyStoreId"
            ],
            members: {
              policyStoreId: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filter: {
                type: "structure",
                members: {
                  principal: {
                    shape: "S2z"
                  },
                  resource: {
                    shape: "S2z"
                  },
                  policyType: {},
                  policyTemplateId: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "policies"
            ],
            members: {
              nextToken: {},
              policies: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "policyStoreId",
                    "policyId",
                    "policyType",
                    "definition",
                    "createdDate",
                    "lastUpdatedDate"
                  ],
                  members: {
                    policyStoreId: {},
                    policyId: {},
                    policyType: {},
                    principal: {
                      shape: "S6"
                    },
                    resource: {
                      shape: "S6"
                    },
                    definition: {
                      type: "structure",
                      members: {
                        static: {
                          type: "structure",
                          members: {
                            description: {
                              shape: "S1c"
                            }
                          }
                        },
                        templateLinked: {
                          type: "structure",
                          required: [
                            "policyTemplateId"
                          ],
                          members: {
                            policyTemplateId: {},
                            principal: {
                              shape: "S6"
                            },
                            resource: {
                              shape: "S6"
                            }
                          }
                        }
                      },
                      union: true
                    },
                    createdDate: {
                      shape: "S17"
                    },
                    lastUpdatedDate: {
                      shape: "S17"
                    }
                  }
                }
              }
            }
          }
        },
        ListPolicyStores: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "policyStores"
            ],
            members: {
              nextToken: {},
              policyStores: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "policyStoreId",
                    "arn",
                    "createdDate"
                  ],
                  members: {
                    policyStoreId: {},
                    arn: {},
                    createdDate: {
                      shape: "S17"
                    },
                    lastUpdatedDate: {
                      shape: "S17"
                    },
                    description: {
                      shape: "S1l"
                    }
                  }
                }
              }
            }
          }
        },
        ListPolicyTemplates: {
          input: {
            type: "structure",
            required: [
              "policyStoreId"
            ],
            members: {
              policyStoreId: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "policyTemplates"
            ],
            members: {
              nextToken: {},
              policyTemplates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "policyStoreId",
                    "policyTemplateId",
                    "createdDate",
                    "lastUpdatedDate"
                  ],
                  members: {
                    policyStoreId: {},
                    policyTemplateId: {},
                    description: {
                      shape: "S1p"
                    },
                    createdDate: {
                      shape: "S17"
                    },
                    lastUpdatedDate: {
                      shape: "S17"
                    }
                  }
                }
              }
            }
          }
        },
        PutSchema: {
          input: {
            type: "structure",
            required: [
              "policyStoreId",
              "definition"
            ],
            members: {
              policyStoreId: {},
              definition: {
                type: "structure",
                members: {
                  cedarJson: {
                    shape: "S2f"
                  }
                },
                union: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "policyStoreId",
              "namespaces",
              "createdDate",
              "lastUpdatedDate"
            ],
            members: {
              policyStoreId: {},
              namespaces: {
                shape: "S2g"
              },
              createdDate: {
                shape: "S17"
              },
              lastUpdatedDate: {
                shape: "S17"
              }
            }
          },
          idempotent: true
        },
        UpdateIdentitySource: {
          input: {
            type: "structure",
            required: [
              "policyStoreId",
              "identitySourceId",
              "updateConfiguration"
            ],
            members: {
              policyStoreId: {},
              identitySourceId: {},
              updateConfiguration: {
                type: "structure",
                members: {
                  cognitoUserPoolConfiguration: {
                    type: "structure",
                    required: [
                      "userPoolArn"
                    ],
                    members: {
                      userPoolArn: {},
                      clientIds: {
                        shape: "S13"
                      }
                    }
                  }
                },
                union: true
              },
              principalEntityType: {
                shape: "S15"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "createdDate",
              "identitySourceId",
              "lastUpdatedDate",
              "policyStoreId"
            ],
            members: {
              createdDate: {
                shape: "S17"
              },
              identitySourceId: {},
              lastUpdatedDate: {
                shape: "S17"
              },
              policyStoreId: {}
            }
          },
          idempotent: true
        },
        UpdatePolicy: {
          input: {
            type: "structure",
            required: [
              "policyStoreId",
              "policyId",
              "definition"
            ],
            members: {
              policyStoreId: {},
              policyId: {},
              definition: {
                type: "structure",
                members: {
                  static: {
                    type: "structure",
                    required: [
                      "statement"
                    ],
                    members: {
                      description: {
                        shape: "S1c"
                      },
                      statement: {
                        shape: "S1d"
                      }
                    }
                  }
                },
                union: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "policyStoreId",
              "policyId",
              "policyType",
              "createdDate",
              "lastUpdatedDate"
            ],
            members: {
              policyStoreId: {},
              policyId: {},
              policyType: {},
              principal: {
                shape: "S6"
              },
              resource: {
                shape: "S6"
              },
              createdDate: {
                shape: "S17"
              },
              lastUpdatedDate: {
                shape: "S17"
              }
            }
          },
          idempotent: true
        },
        UpdatePolicyStore: {
          input: {
            type: "structure",
            required: [
              "policyStoreId",
              "validationSettings"
            ],
            members: {
              policyStoreId: {},
              validationSettings: {
                shape: "S1j"
              },
              description: {
                shape: "S1l"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "policyStoreId",
              "arn",
              "createdDate",
              "lastUpdatedDate"
            ],
            members: {
              policyStoreId: {},
              arn: {},
              createdDate: {
                shape: "S17"
              },
              lastUpdatedDate: {
                shape: "S17"
              }
            }
          },
          idempotent: true
        },
        UpdatePolicyTemplate: {
          input: {
            type: "structure",
            required: [
              "policyStoreId",
              "policyTemplateId",
              "statement"
            ],
            members: {
              policyStoreId: {},
              policyTemplateId: {},
              description: {
                shape: "S1p"
              },
              statement: {
                shape: "S1d"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "policyStoreId",
              "policyTemplateId",
              "createdDate",
              "lastUpdatedDate"
            ],
            members: {
              policyStoreId: {},
              policyTemplateId: {},
              createdDate: {
                shape: "S17"
              },
              lastUpdatedDate: {
                shape: "S17"
              }
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S3: {
          type: "structure",
          members: {
            entityList: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "identifier"
                ],
                members: {
                  identifier: {
                    shape: "S6"
                  },
                  attributes: {
                    type: "map",
                    key: {},
                    value: {
                      shape: "Sb"
                    }
                  },
                  parents: {
                    type: "list",
                    member: {
                      shape: "S6"
                    }
                  }
                }
              }
            }
          },
          union: true
        },
        S6: {
          type: "structure",
          required: [
            "entityType",
            "entityId"
          ],
          members: {
            entityType: {
              type: "string",
              sensitive: true
            },
            entityId: {
              type: "string",
              sensitive: true
            }
          }
        },
        Sb: {
          type: "structure",
          members: {
            boolean: {
              type: "boolean",
              sensitive: true
            },
            entityIdentifier: {
              shape: "S6"
            },
            long: {
              type: "long",
              sensitive: true
            },
            string: {
              type: "string",
              sensitive: true
            },
            set: {
              type: "list",
              member: {
                shape: "Sb"
              }
            },
            record: {
              type: "map",
              key: {},
              value: {
                shape: "Sb"
              }
            }
          },
          union: true
        },
        Sj: {
          type: "structure",
          members: {
            principal: {
              shape: "S6"
            },
            action: {
              shape: "Sk"
            },
            resource: {
              shape: "S6"
            },
            context: {
              shape: "Sn"
            }
          }
        },
        Sk: {
          type: "structure",
          required: [
            "actionType",
            "actionId"
          ],
          members: {
            actionType: {
              type: "string",
              sensitive: true
            },
            actionId: {
              type: "string",
              sensitive: true
            }
          }
        },
        Sn: {
          type: "structure",
          members: {
            contextMap: {
              type: "map",
              key: {},
              value: {
                shape: "Sb"
              }
            }
          },
          union: true
        },
        St: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "policyId"
            ],
            members: {
              policyId: {}
            }
          }
        },
        Sw: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "errorDescription"
            ],
            members: {
              errorDescription: {}
            },
            sensitive: true
          }
        },
        S13: {
          type: "list",
          member: {
            type: "string",
            sensitive: true
          }
        },
        S15: {
          type: "string",
          sensitive: true
        },
        S17: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S1c: {
          type: "string",
          sensitive: true
        },
        S1d: {
          type: "string",
          sensitive: true
        },
        S1j: {
          type: "structure",
          required: [
            "mode"
          ],
          members: {
            mode: {}
          }
        },
        S1l: {
          type: "string",
          sensitive: true
        },
        S1p: {
          type: "string",
          sensitive: true
        },
        S2f: {
          type: "string",
          sensitive: true
        },
        S2g: {
          type: "list",
          member: {
            type: "string",
            sensitive: true
          }
        },
        S2l: {
          type: "string",
          sensitive: true
        },
        S2z: {
          type: "structure",
          members: {
            unspecified: {
              type: "boolean"
            },
            identifier: {
              shape: "S6"
            }
          },
          union: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/verifiedpermissions-2021-12-01.paginators.json
var require_verifiedpermissions_2021_12_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/verifiedpermissions-2021-12-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListIdentitySources: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "identitySources"
        },
        ListPolicies: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "policies"
        },
        ListPolicyStores: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "policyStores"
        },
        ListPolicyTemplates: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "policyTemplates"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/verifiedpermissions-2021-12-01.waiters2.json
var require_verifiedpermissions_2021_12_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/verifiedpermissions-2021-12-01.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {}
    };
  }
});

// node_modules/aws-sdk/clients/verifiedpermissions.js
var require_verifiedpermissions = __commonJS({
  "node_modules/aws-sdk/clients/verifiedpermissions.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["verifiedpermissions"] = {};
    AWS2.VerifiedPermissions = Service.defineService("verifiedpermissions", ["2021-12-01"]);
    Object.defineProperty(apiLoader.services["verifiedpermissions"], "2021-12-01", {
      get: function get() {
        var model = require_verifiedpermissions_2021_12_01_min();
        model.paginators = require_verifiedpermissions_2021_12_01_paginators().pagination;
        model.waiters = require_verifiedpermissions_2021_12_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.VerifiedPermissions;
  }
});

// node_modules/aws-sdk/apis/appfabric-2023-05-19.min.json
var require_appfabric_2023_05_19_min = __commonJS({
  "node_modules/aws-sdk/apis/appfabric-2023-05-19.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2023-05-19",
        endpointPrefix: "appfabric",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AppFabric",
        serviceId: "AppFabric",
        signatureVersion: "v4",
        signingName: "appfabric",
        uid: "appfabric-2023-05-19"
      },
      operations: {
        BatchGetUserAccessTasks: {
          http: {
            requestUri: "/useraccess/batchget",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appBundleIdentifier",
              "taskIdList"
            ],
            members: {
              appBundleIdentifier: {},
              taskIdList: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              userAccessResultsList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    app: {},
                    tenantId: {},
                    tenantDisplayName: {},
                    taskId: {},
                    resultStatus: {},
                    email: {
                      shape: "Sc"
                    },
                    userId: {
                      shape: "Sd"
                    },
                    userFullName: {
                      shape: "Sd"
                    },
                    userFirstName: {
                      shape: "Sd"
                    },
                    userLastName: {
                      shape: "Sd"
                    },
                    userStatus: {},
                    taskError: {
                      shape: "Sf"
                    }
                  }
                }
              }
            }
          }
        },
        ConnectAppAuthorization: {
          http: {
            requestUri: "/appbundles/{appBundleIdentifier}/appauthorizations/{appAuthorizationIdentifier}/connect",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appBundleIdentifier",
              "appAuthorizationIdentifier"
            ],
            members: {
              appBundleIdentifier: {
                location: "uri",
                locationName: "appBundleIdentifier"
              },
              appAuthorizationIdentifier: {
                location: "uri",
                locationName: "appAuthorizationIdentifier"
              },
              authRequest: {
                type: "structure",
                required: [
                  "redirectUri",
                  "code"
                ],
                members: {
                  redirectUri: {},
                  code: {
                    shape: "Sd"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "appAuthorizationSummary"
            ],
            members: {
              appAuthorizationSummary: {
                shape: "Sk"
              }
            }
          }
        },
        CreateAppAuthorization: {
          http: {
            requestUri: "/appbundles/{appBundleIdentifier}/appauthorizations",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "appBundleIdentifier",
              "app",
              "credential",
              "tenant",
              "authType"
            ],
            members: {
              appBundleIdentifier: {
                location: "uri",
                locationName: "appBundleIdentifier"
              },
              app: {},
              credential: {
                shape: "Sq"
              },
              tenant: {
                shape: "Sm"
              },
              authType: {},
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "appAuthorization"
            ],
            members: {
              appAuthorization: {
                shape: "Sz"
              }
            }
          },
          idempotent: true
        },
        CreateAppBundle: {
          http: {
            requestUri: "/appbundles",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              clientToken: {
                idempotencyToken: true
              },
              customerManagedKeyIdentifier: {},
              tags: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "appBundle"
            ],
            members: {
              appBundle: {
                shape: "S13"
              }
            }
          },
          idempotent: true
        },
        CreateIngestion: {
          http: {
            requestUri: "/appbundles/{appBundleIdentifier}/ingestions",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "appBundleIdentifier",
              "app",
              "tenantId",
              "ingestionType"
            ],
            members: {
              appBundleIdentifier: {
                location: "uri",
                locationName: "appBundleIdentifier"
              },
              app: {},
              tenantId: {},
              ingestionType: {},
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ingestion"
            ],
            members: {
              ingestion: {
                shape: "S17"
              }
            }
          },
          idempotent: true
        },
        CreateIngestionDestination: {
          http: {
            requestUri: "/appbundles/{appBundleIdentifier}/ingestions/{ingestionIdentifier}/ingestiondestinations",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "appBundleIdentifier",
              "ingestionIdentifier",
              "processingConfiguration",
              "destinationConfiguration"
            ],
            members: {
              appBundleIdentifier: {
                location: "uri",
                locationName: "appBundleIdentifier"
              },
              ingestionIdentifier: {
                location: "uri",
                locationName: "ingestionIdentifier"
              },
              processingConfiguration: {
                shape: "S1a"
              },
              destinationConfiguration: {
                shape: "S1e"
              },
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ingestionDestination"
            ],
            members: {
              ingestionDestination: {
                shape: "S1n"
              }
            }
          },
          idempotent: true
        },
        DeleteAppAuthorization: {
          http: {
            method: "DELETE",
            requestUri: "/appbundles/{appBundleIdentifier}/appauthorizations/{appAuthorizationIdentifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "appBundleIdentifier",
              "appAuthorizationIdentifier"
            ],
            members: {
              appBundleIdentifier: {
                location: "uri",
                locationName: "appBundleIdentifier"
              },
              appAuthorizationIdentifier: {
                location: "uri",
                locationName: "appAuthorizationIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteAppBundle: {
          http: {
            method: "DELETE",
            requestUri: "/appbundles/{appBundleIdentifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "appBundleIdentifier"
            ],
            members: {
              appBundleIdentifier: {
                location: "uri",
                locationName: "appBundleIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteIngestion: {
          http: {
            method: "DELETE",
            requestUri: "/appbundles/{appBundleIdentifier}/ingestions/{ingestionIdentifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "appBundleIdentifier",
              "ingestionIdentifier"
            ],
            members: {
              appBundleIdentifier: {
                location: "uri",
                locationName: "appBundleIdentifier"
              },
              ingestionIdentifier: {
                location: "uri",
                locationName: "ingestionIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteIngestionDestination: {
          http: {
            method: "DELETE",
            requestUri: "/appbundles/{appBundleIdentifier}/ingestions/{ingestionIdentifier}/ingestiondestinations/{ingestionDestinationIdentifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "appBundleIdentifier",
              "ingestionIdentifier",
              "ingestionDestinationIdentifier"
            ],
            members: {
              appBundleIdentifier: {
                location: "uri",
                locationName: "appBundleIdentifier"
              },
              ingestionIdentifier: {
                location: "uri",
                locationName: "ingestionIdentifier"
              },
              ingestionDestinationIdentifier: {
                location: "uri",
                locationName: "ingestionDestinationIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        GetAppAuthorization: {
          http: {
            method: "GET",
            requestUri: "/appbundles/{appBundleIdentifier}/appauthorizations/{appAuthorizationIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appBundleIdentifier",
              "appAuthorizationIdentifier"
            ],
            members: {
              appBundleIdentifier: {
                location: "uri",
                locationName: "appBundleIdentifier"
              },
              appAuthorizationIdentifier: {
                location: "uri",
                locationName: "appAuthorizationIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "appAuthorization"
            ],
            members: {
              appAuthorization: {
                shape: "Sz"
              }
            }
          }
        },
        GetAppBundle: {
          http: {
            method: "GET",
            requestUri: "/appbundles/{appBundleIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appBundleIdentifier"
            ],
            members: {
              appBundleIdentifier: {
                location: "uri",
                locationName: "appBundleIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "appBundle"
            ],
            members: {
              appBundle: {
                shape: "S13"
              }
            }
          }
        },
        GetIngestion: {
          http: {
            method: "GET",
            requestUri: "/appbundles/{appBundleIdentifier}/ingestions/{ingestionIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appBundleIdentifier",
              "ingestionIdentifier"
            ],
            members: {
              appBundleIdentifier: {
                location: "uri",
                locationName: "appBundleIdentifier"
              },
              ingestionIdentifier: {
                location: "uri",
                locationName: "ingestionIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ingestion"
            ],
            members: {
              ingestion: {
                shape: "S17"
              }
            }
          }
        },
        GetIngestionDestination: {
          http: {
            method: "GET",
            requestUri: "/appbundles/{appBundleIdentifier}/ingestions/{ingestionIdentifier}/ingestiondestinations/{ingestionDestinationIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appBundleIdentifier",
              "ingestionIdentifier",
              "ingestionDestinationIdentifier"
            ],
            members: {
              appBundleIdentifier: {
                location: "uri",
                locationName: "appBundleIdentifier"
              },
              ingestionIdentifier: {
                location: "uri",
                locationName: "ingestionIdentifier"
              },
              ingestionDestinationIdentifier: {
                location: "uri",
                locationName: "ingestionDestinationIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ingestionDestination"
            ],
            members: {
              ingestionDestination: {
                shape: "S1n"
              }
            }
          }
        },
        ListAppAuthorizations: {
          http: {
            method: "GET",
            requestUri: "/appbundles/{appBundleIdentifier}/appauthorizations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appBundleIdentifier"
            ],
            members: {
              appBundleIdentifier: {
                location: "uri",
                locationName: "appBundleIdentifier"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "appAuthorizationSummaryList"
            ],
            members: {
              appAuthorizationSummaryList: {
                type: "list",
                member: {
                  shape: "Sk"
                }
              },
              nextToken: {}
            }
          }
        },
        ListAppBundles: {
          http: {
            method: "GET",
            requestUri: "/appbundles",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "appBundleSummaryList"
            ],
            members: {
              appBundleSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn"
                  ],
                  members: {
                    arn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListIngestionDestinations: {
          http: {
            method: "GET",
            requestUri: "/appbundles/{appBundleIdentifier}/ingestions/{ingestionIdentifier}/ingestiondestinations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appBundleIdentifier",
              "ingestionIdentifier"
            ],
            members: {
              appBundleIdentifier: {
                location: "uri",
                locationName: "appBundleIdentifier"
              },
              ingestionIdentifier: {
                location: "uri",
                locationName: "ingestionIdentifier"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ingestionDestinations"
            ],
            members: {
              ingestionDestinations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn"
                  ],
                  members: {
                    arn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListIngestions: {
          http: {
            method: "GET",
            requestUri: "/appbundles/{appBundleIdentifier}/ingestions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appBundleIdentifier"
            ],
            members: {
              appBundleIdentifier: {
                location: "uri",
                locationName: "appBundleIdentifier"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ingestions"
            ],
            members: {
              ingestions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "app",
                    "tenantId",
                    "state"
                  ],
                  members: {
                    arn: {},
                    app: {},
                    tenantId: {},
                    state: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Su"
              }
            }
          }
        },
        StartIngestion: {
          http: {
            requestUri: "/appbundles/{appBundleIdentifier}/ingestions/{ingestionIdentifier}/start",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ingestionIdentifier",
              "appBundleIdentifier"
            ],
            members: {
              ingestionIdentifier: {
                location: "uri",
                locationName: "ingestionIdentifier"
              },
              appBundleIdentifier: {
                location: "uri",
                locationName: "appBundleIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartUserAccessTasks: {
          http: {
            requestUri: "/useraccess/start",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "appBundleIdentifier",
              "email"
            ],
            members: {
              appBundleIdentifier: {},
              email: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              userAccessTasksList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "app",
                    "tenantId"
                  ],
                  members: {
                    app: {},
                    tenantId: {},
                    taskId: {},
                    error: {
                      shape: "Sf"
                    }
                  }
                }
              }
            }
          }
        },
        StopIngestion: {
          http: {
            requestUri: "/appbundles/{appBundleIdentifier}/ingestions/{ingestionIdentifier}/stop",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ingestionIdentifier",
              "appBundleIdentifier"
            ],
            members: {
              ingestionIdentifier: {
                location: "uri",
                locationName: "ingestionIdentifier"
              },
              appBundleIdentifier: {
                location: "uri",
                locationName: "appBundleIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateAppAuthorization: {
          http: {
            method: "PATCH",
            requestUri: "/appbundles/{appBundleIdentifier}/appauthorizations/{appAuthorizationIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appBundleIdentifier",
              "appAuthorizationIdentifier"
            ],
            members: {
              appBundleIdentifier: {
                location: "uri",
                locationName: "appBundleIdentifier"
              },
              appAuthorizationIdentifier: {
                location: "uri",
                locationName: "appAuthorizationIdentifier"
              },
              credential: {
                shape: "Sq"
              },
              tenant: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "appAuthorization"
            ],
            members: {
              appAuthorization: {
                shape: "Sz"
              }
            }
          }
        },
        UpdateIngestionDestination: {
          http: {
            method: "PATCH",
            requestUri: "/appbundles/{appBundleIdentifier}/ingestions/{ingestionIdentifier}/ingestiondestinations/{ingestionDestinationIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "appBundleIdentifier",
              "ingestionIdentifier",
              "ingestionDestinationIdentifier",
              "destinationConfiguration"
            ],
            members: {
              appBundleIdentifier: {
                location: "uri",
                locationName: "appBundleIdentifier"
              },
              ingestionIdentifier: {
                location: "uri",
                locationName: "ingestionIdentifier"
              },
              ingestionDestinationIdentifier: {
                location: "uri",
                locationName: "ingestionDestinationIdentifier"
              },
              destinationConfiguration: {
                shape: "S1e"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ingestionDestination"
            ],
            members: {
              ingestionDestination: {
                shape: "S1n"
              }
            }
          }
        }
      },
      shapes: {
        Sc: {
          type: "string",
          sensitive: true
        },
        Sd: {
          type: "string",
          sensitive: true
        },
        Sf: {
          type: "structure",
          members: {
            errorCode: {},
            errorMessage: {}
          }
        },
        Sk: {
          type: "structure",
          required: [
            "appAuthorizationArn",
            "appBundleArn",
            "app",
            "tenant",
            "status",
            "updatedAt"
          ],
          members: {
            appAuthorizationArn: {},
            appBundleArn: {},
            app: {},
            tenant: {
              shape: "Sm"
            },
            status: {},
            updatedAt: {
              shape: "So"
            }
          }
        },
        Sm: {
          type: "structure",
          required: [
            "tenantIdentifier",
            "tenantDisplayName"
          ],
          members: {
            tenantIdentifier: {},
            tenantDisplayName: {}
          }
        },
        So: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        Sq: {
          type: "structure",
          members: {
            oauth2Credential: {
              type: "structure",
              required: [
                "clientId",
                "clientSecret"
              ],
              members: {
                clientId: {},
                clientSecret: {
                  shape: "Sd"
                }
              }
            },
            apiKeyCredential: {
              type: "structure",
              required: [
                "apiKey"
              ],
              members: {
                apiKey: {
                  shape: "Sd"
                }
              }
            }
          },
          union: true
        },
        Su: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        Sz: {
          type: "structure",
          required: [
            "appAuthorizationArn",
            "appBundleArn",
            "app",
            "tenant",
            "authType",
            "status",
            "createdAt",
            "updatedAt"
          ],
          members: {
            appAuthorizationArn: {},
            appBundleArn: {},
            app: {},
            tenant: {
              shape: "Sm"
            },
            authType: {},
            status: {},
            createdAt: {
              shape: "So"
            },
            updatedAt: {
              shape: "So"
            },
            persona: {},
            authUrl: {}
          }
        },
        S13: {
          type: "structure",
          required: [
            "arn"
          ],
          members: {
            arn: {},
            customerManagedKeyArn: {}
          }
        },
        S17: {
          type: "structure",
          required: [
            "arn",
            "appBundleArn",
            "app",
            "tenantId",
            "createdAt",
            "updatedAt",
            "state",
            "ingestionType"
          ],
          members: {
            arn: {},
            appBundleArn: {},
            app: {},
            tenantId: {},
            createdAt: {
              shape: "So"
            },
            updatedAt: {
              shape: "So"
            },
            state: {},
            ingestionType: {}
          }
        },
        S1a: {
          type: "structure",
          members: {
            auditLog: {
              type: "structure",
              required: [
                "schema",
                "format"
              ],
              members: {
                schema: {},
                format: {}
              }
            }
          },
          union: true
        },
        S1e: {
          type: "structure",
          members: {
            auditLog: {
              type: "structure",
              required: [
                "destination"
              ],
              members: {
                destination: {
                  type: "structure",
                  members: {
                    s3Bucket: {
                      type: "structure",
                      required: [
                        "bucketName"
                      ],
                      members: {
                        bucketName: {},
                        prefix: {}
                      }
                    },
                    firehoseStream: {
                      type: "structure",
                      required: [
                        "streamName"
                      ],
                      members: {
                        streamName: {}
                      }
                    }
                  },
                  union: true
                }
              }
            }
          },
          union: true
        },
        S1n: {
          type: "structure",
          required: [
            "arn",
            "ingestionArn",
            "processingConfiguration",
            "destinationConfiguration"
          ],
          members: {
            arn: {},
            ingestionArn: {},
            processingConfiguration: {
              shape: "S1a"
            },
            destinationConfiguration: {
              shape: "S1e"
            },
            status: {},
            statusReason: {},
            createdAt: {
              shape: "So"
            },
            updatedAt: {
              shape: "So"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/appfabric-2023-05-19.paginators.json
var require_appfabric_2023_05_19_paginators = __commonJS({
  "node_modules/aws-sdk/apis/appfabric-2023-05-19.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAppAuthorizations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "appAuthorizationSummaryList"
        },
        ListAppBundles: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "appBundleSummaryList"
        },
        ListIngestionDestinations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "ingestionDestinations"
        },
        ListIngestions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "ingestions"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/appfabric-2023-05-19.waiters2.json
var require_appfabric_2023_05_19_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/appfabric-2023-05-19.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {}
    };
  }
});

// node_modules/aws-sdk/clients/appfabric.js
var require_appfabric = __commonJS({
  "node_modules/aws-sdk/clients/appfabric.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["appfabric"] = {};
    AWS2.AppFabric = Service.defineService("appfabric", ["2023-05-19"]);
    Object.defineProperty(apiLoader.services["appfabric"], "2023-05-19", {
      get: function get() {
        var model = require_appfabric_2023_05_19_min();
        model.paginators = require_appfabric_2023_05_19_paginators().pagination;
        model.waiters = require_appfabric_2023_05_19_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.AppFabric;
  }
});

// node_modules/aws-sdk/apis/medical-imaging-2023-07-19.min.json
var require_medical_imaging_2023_07_19_min = __commonJS({
  "node_modules/aws-sdk/apis/medical-imaging-2023-07-19.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2023-07-19",
        endpointPrefix: "medical-imaging",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Health Imaging",
        serviceId: "Medical Imaging",
        signatureVersion: "v4",
        signingName: "medical-imaging",
        uid: "medical-imaging-2023-07-19"
      },
      operations: {
        CopyImageSet: {
          http: {
            requestUri: "/datastore/{datastoreId}/imageSet/{sourceImageSetId}/copyImageSet",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "datastoreId",
              "sourceImageSetId",
              "copyImageSetInformation"
            ],
            members: {
              datastoreId: {
                location: "uri",
                locationName: "datastoreId"
              },
              sourceImageSetId: {
                location: "uri",
                locationName: "sourceImageSetId"
              },
              copyImageSetInformation: {
                type: "structure",
                required: [
                  "sourceImageSet"
                ],
                members: {
                  sourceImageSet: {
                    type: "structure",
                    required: [
                      "latestVersionId"
                    ],
                    members: {
                      latestVersionId: {}
                    }
                  },
                  destinationImageSet: {
                    type: "structure",
                    required: [
                      "imageSetId",
                      "latestVersionId"
                    ],
                    members: {
                      imageSetId: {},
                      latestVersionId: {}
                    }
                  }
                }
              }
            },
            payload: "copyImageSetInformation"
          },
          output: {
            type: "structure",
            required: [
              "datastoreId",
              "sourceImageSetProperties",
              "destinationImageSetProperties"
            ],
            members: {
              datastoreId: {},
              sourceImageSetProperties: {
                type: "structure",
                required: [
                  "imageSetId",
                  "latestVersionId"
                ],
                members: {
                  imageSetId: {},
                  latestVersionId: {},
                  imageSetState: {},
                  imageSetWorkflowStatus: {},
                  createdAt: {
                    type: "timestamp"
                  },
                  updatedAt: {
                    type: "timestamp"
                  },
                  imageSetArn: {}
                }
              },
              destinationImageSetProperties: {
                type: "structure",
                required: [
                  "imageSetId",
                  "latestVersionId"
                ],
                members: {
                  imageSetId: {},
                  latestVersionId: {},
                  imageSetState: {},
                  imageSetWorkflowStatus: {},
                  createdAt: {
                    type: "timestamp"
                  },
                  updatedAt: {
                    type: "timestamp"
                  },
                  imageSetArn: {}
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "runtime-"
          }
        },
        CreateDatastore: {
          http: {
            requestUri: "/datastore",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "clientToken"
            ],
            members: {
              datastoreName: {},
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "Si"
              },
              kmsKeyArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "datastoreId",
              "datastoreStatus"
            ],
            members: {
              datastoreId: {},
              datastoreStatus: {}
            }
          },
          idempotent: true
        },
        DeleteDatastore: {
          http: {
            method: "DELETE",
            requestUri: "/datastore/{datastoreId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "datastoreId"
            ],
            members: {
              datastoreId: {
                location: "uri",
                locationName: "datastoreId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "datastoreId",
              "datastoreStatus"
            ],
            members: {
              datastoreId: {},
              datastoreStatus: {}
            }
          },
          idempotent: true
        },
        DeleteImageSet: {
          http: {
            requestUri: "/datastore/{datastoreId}/imageSet/{imageSetId}/deleteImageSet",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "datastoreId",
              "imageSetId"
            ],
            members: {
              datastoreId: {
                location: "uri",
                locationName: "datastoreId"
              },
              imageSetId: {
                location: "uri",
                locationName: "imageSetId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "datastoreId",
              "imageSetId",
              "imageSetState",
              "imageSetWorkflowStatus"
            ],
            members: {
              datastoreId: {},
              imageSetId: {},
              imageSetState: {},
              imageSetWorkflowStatus: {}
            }
          },
          endpoint: {
            hostPrefix: "runtime-"
          },
          idempotent: true
        },
        GetDICOMImportJob: {
          http: {
            method: "GET",
            requestUri: "/getDICOMImportJob/datastore/{datastoreId}/job/{jobId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "datastoreId",
              "jobId"
            ],
            members: {
              datastoreId: {
                location: "uri",
                locationName: "datastoreId"
              },
              jobId: {
                location: "uri",
                locationName: "jobId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobProperties"
            ],
            members: {
              jobProperties: {
                type: "structure",
                required: [
                  "jobId",
                  "jobName",
                  "jobStatus",
                  "datastoreId",
                  "dataAccessRoleArn",
                  "inputS3Uri",
                  "outputS3Uri"
                ],
                members: {
                  jobId: {},
                  jobName: {},
                  jobStatus: {},
                  datastoreId: {},
                  dataAccessRoleArn: {},
                  endedAt: {
                    type: "timestamp"
                  },
                  submittedAt: {
                    type: "timestamp"
                  },
                  inputS3Uri: {},
                  outputS3Uri: {},
                  message: {}
                }
              }
            }
          }
        },
        GetDatastore: {
          http: {
            method: "GET",
            requestUri: "/datastore/{datastoreId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "datastoreId"
            ],
            members: {
              datastoreId: {
                location: "uri",
                locationName: "datastoreId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "datastoreProperties"
            ],
            members: {
              datastoreProperties: {
                type: "structure",
                required: [
                  "datastoreId",
                  "datastoreName",
                  "datastoreStatus"
                ],
                members: {
                  datastoreId: {},
                  datastoreName: {},
                  datastoreStatus: {},
                  kmsKeyArn: {},
                  datastoreArn: {},
                  createdAt: {
                    type: "timestamp"
                  },
                  updatedAt: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        GetImageFrame: {
          http: {
            requestUri: "/datastore/{datastoreId}/imageSet/{imageSetId}/getImageFrame",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "datastoreId",
              "imageSetId",
              "imageFrameInformation"
            ],
            members: {
              datastoreId: {
                location: "uri",
                locationName: "datastoreId"
              },
              imageSetId: {
                location: "uri",
                locationName: "imageSetId"
              },
              imageFrameInformation: {
                type: "structure",
                required: [
                  "imageFrameId"
                ],
                members: {
                  imageFrameId: {}
                }
              }
            },
            payload: "imageFrameInformation"
          },
          output: {
            type: "structure",
            required: [
              "imageFrameBlob"
            ],
            members: {
              imageFrameBlob: {
                type: "blob",
                streaming: true
              },
              contentType: {
                location: "header",
                locationName: "Content-Type"
              }
            },
            payload: "imageFrameBlob"
          },
          endpoint: {
            hostPrefix: "runtime-"
          }
        },
        GetImageSet: {
          http: {
            requestUri: "/datastore/{datastoreId}/imageSet/{imageSetId}/getImageSet",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "datastoreId",
              "imageSetId"
            ],
            members: {
              datastoreId: {
                location: "uri",
                locationName: "datastoreId"
              },
              imageSetId: {
                location: "uri",
                locationName: "imageSetId"
              },
              versionId: {
                location: "querystring",
                locationName: "version"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "datastoreId",
              "imageSetId",
              "versionId",
              "imageSetState"
            ],
            members: {
              datastoreId: {},
              imageSetId: {},
              versionId: {},
              imageSetState: {},
              imageSetWorkflowStatus: {},
              createdAt: {
                type: "timestamp"
              },
              updatedAt: {
                type: "timestamp"
              },
              deletedAt: {
                type: "timestamp"
              },
              message: {},
              imageSetArn: {}
            }
          },
          endpoint: {
            hostPrefix: "runtime-"
          }
        },
        GetImageSetMetadata: {
          http: {
            requestUri: "/datastore/{datastoreId}/imageSet/{imageSetId}/getImageSetMetadata",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "datastoreId",
              "imageSetId"
            ],
            members: {
              datastoreId: {
                location: "uri",
                locationName: "datastoreId"
              },
              imageSetId: {
                location: "uri",
                locationName: "imageSetId"
              },
              versionId: {
                location: "querystring",
                locationName: "version"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "imageSetMetadataBlob"
            ],
            members: {
              imageSetMetadataBlob: {
                type: "blob",
                streaming: true
              },
              contentType: {
                location: "header",
                locationName: "Content-Type"
              },
              contentEncoding: {
                location: "header",
                locationName: "Content-Encoding"
              }
            },
            payload: "imageSetMetadataBlob"
          },
          endpoint: {
            hostPrefix: "runtime-"
          }
        },
        ListDICOMImportJobs: {
          http: {
            method: "GET",
            requestUri: "/listDICOMImportJobs/datastore/{datastoreId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "datastoreId"
            ],
            members: {
              datastoreId: {
                location: "uri",
                locationName: "datastoreId"
              },
              jobStatus: {
                location: "querystring",
                locationName: "jobStatus"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobSummaries"
            ],
            members: {
              jobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "jobId",
                    "jobName",
                    "jobStatus",
                    "datastoreId"
                  ],
                  members: {
                    jobId: {},
                    jobName: {},
                    jobStatus: {},
                    datastoreId: {},
                    dataAccessRoleArn: {},
                    endedAt: {
                      type: "timestamp"
                    },
                    submittedAt: {
                      type: "timestamp"
                    },
                    message: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDatastores: {
          http: {
            method: "GET",
            requestUri: "/datastore",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              datastoreStatus: {
                location: "querystring",
                locationName: "datastoreStatus"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datastoreSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "datastoreId",
                    "datastoreName",
                    "datastoreStatus"
                  ],
                  members: {
                    datastoreId: {},
                    datastoreName: {},
                    datastoreStatus: {},
                    datastoreArn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    updatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListImageSetVersions: {
          http: {
            requestUri: "/datastore/{datastoreId}/imageSet/{imageSetId}/listImageSetVersions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "datastoreId",
              "imageSetId"
            ],
            members: {
              datastoreId: {
                location: "uri",
                locationName: "datastoreId"
              },
              imageSetId: {
                location: "uri",
                locationName: "imageSetId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "imageSetPropertiesList"
            ],
            members: {
              imageSetPropertiesList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "imageSetId",
                    "versionId",
                    "imageSetState"
                  ],
                  members: {
                    imageSetId: {},
                    versionId: {},
                    imageSetState: {},
                    ImageSetWorkflowStatus: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    updatedAt: {
                      type: "timestamp"
                    },
                    deletedAt: {
                      type: "timestamp"
                    },
                    message: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "runtime-"
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "tags"
            ],
            members: {
              tags: {
                shape: "Si"
              }
            }
          }
        },
        SearchImageSets: {
          http: {
            requestUri: "/datastore/{datastoreId}/searchImageSets",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "datastoreId"
            ],
            members: {
              datastoreId: {
                location: "uri",
                locationName: "datastoreId"
              },
              searchCriteria: {
                type: "structure",
                members: {
                  filters: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "values",
                        "operator"
                      ],
                      members: {
                        values: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              DICOMPatientId: {
                                shape: "S23"
                              },
                              DICOMAccessionNumber: {
                                shape: "S24"
                              },
                              DICOMStudyId: {
                                shape: "S25"
                              },
                              DICOMStudyInstanceUID: {
                                shape: "S26"
                              },
                              createdAt: {
                                type: "timestamp"
                              },
                              DICOMStudyDateAndTime: {
                                type: "structure",
                                required: [
                                  "DICOMStudyDate"
                                ],
                                members: {
                                  DICOMStudyDate: {
                                    shape: "S28"
                                  },
                                  DICOMStudyTime: {
                                    shape: "S29"
                                  }
                                }
                              }
                            },
                            union: true
                          }
                        },
                        operator: {}
                      }
                    }
                  }
                },
                sensitive: true
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            payload: "searchCriteria"
          },
          output: {
            type: "structure",
            required: [
              "imageSetsMetadataSummaries"
            ],
            members: {
              imageSetsMetadataSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "imageSetId"
                  ],
                  members: {
                    imageSetId: {},
                    version: {
                      type: "integer"
                    },
                    createdAt: {
                      type: "timestamp"
                    },
                    updatedAt: {
                      type: "timestamp"
                    },
                    DICOMTags: {
                      type: "structure",
                      members: {
                        DICOMPatientId: {
                          shape: "S23"
                        },
                        DICOMPatientName: {
                          type: "string",
                          sensitive: true
                        },
                        DICOMPatientBirthDate: {
                          type: "string",
                          sensitive: true
                        },
                        DICOMPatientSex: {
                          type: "string",
                          sensitive: true
                        },
                        DICOMStudyInstanceUID: {
                          shape: "S26"
                        },
                        DICOMStudyId: {
                          shape: "S25"
                        },
                        DICOMStudyDescription: {
                          type: "string",
                          sensitive: true
                        },
                        DICOMNumberOfStudyRelatedSeries: {
                          type: "integer"
                        },
                        DICOMNumberOfStudyRelatedInstances: {
                          type: "integer"
                        },
                        DICOMAccessionNumber: {
                          shape: "S24"
                        },
                        DICOMStudyDate: {
                          shape: "S28"
                        },
                        DICOMStudyTime: {
                          shape: "S29"
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "runtime-"
          }
        },
        StartDICOMImportJob: {
          http: {
            requestUri: "/startDICOMImportJob/datastore/{datastoreId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "dataAccessRoleArn",
              "clientToken",
              "datastoreId",
              "inputS3Uri",
              "outputS3Uri"
            ],
            members: {
              jobName: {},
              dataAccessRoleArn: {},
              clientToken: {
                idempotencyToken: true
              },
              datastoreId: {
                location: "uri",
                locationName: "datastoreId"
              },
              inputS3Uri: {},
              outputS3Uri: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "datastoreId",
              "jobId",
              "jobStatus",
              "submittedAt"
            ],
            members: {
              datastoreId: {},
              jobId: {},
              jobStatus: {},
              submittedAt: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateImageSetMetadata: {
          http: {
            requestUri: "/datastore/{datastoreId}/imageSet/{imageSetId}/updateImageSetMetadata",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "datastoreId",
              "imageSetId",
              "latestVersionId",
              "updateImageSetMetadataUpdates"
            ],
            members: {
              datastoreId: {
                location: "uri",
                locationName: "datastoreId"
              },
              imageSetId: {
                location: "uri",
                locationName: "imageSetId"
              },
              latestVersionId: {
                location: "querystring",
                locationName: "latestVersion"
              },
              updateImageSetMetadataUpdates: {
                type: "structure",
                members: {
                  DICOMUpdates: {
                    type: "structure",
                    members: {
                      removableAttributes: {
                        shape: "S2x"
                      },
                      updatableAttributes: {
                        shape: "S2x"
                      }
                    }
                  }
                },
                union: true
              }
            },
            payload: "updateImageSetMetadataUpdates"
          },
          output: {
            type: "structure",
            required: [
              "datastoreId",
              "imageSetId",
              "latestVersionId",
              "imageSetState"
            ],
            members: {
              datastoreId: {},
              imageSetId: {},
              latestVersionId: {},
              imageSetState: {},
              imageSetWorkflowStatus: {},
              createdAt: {
                type: "timestamp"
              },
              updatedAt: {
                type: "timestamp"
              },
              message: {}
            }
          },
          endpoint: {
            hostPrefix: "runtime-"
          }
        }
      },
      shapes: {
        Si: {
          type: "map",
          key: {},
          value: {}
        },
        S23: {
          type: "string",
          sensitive: true
        },
        S24: {
          type: "string",
          sensitive: true
        },
        S25: {
          type: "string",
          sensitive: true
        },
        S26: {
          type: "string",
          sensitive: true
        },
        S28: {
          type: "string",
          sensitive: true
        },
        S29: {
          type: "string",
          sensitive: true
        },
        S2x: {
          type: "blob",
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/medical-imaging-2023-07-19.paginators.json
var require_medical_imaging_2023_07_19_paginators = __commonJS({
  "node_modules/aws-sdk/apis/medical-imaging-2023-07-19.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListDICOMImportJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "jobSummaries"
        },
        ListDatastores: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "datastoreSummaries"
        },
        ListImageSetVersions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "imageSetPropertiesList"
        },
        SearchImageSets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "imageSetsMetadataSummaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/medical-imaging-2023-07-19.waiters2.json
var require_medical_imaging_2023_07_19_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/medical-imaging-2023-07-19.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {}
    };
  }
});

// node_modules/aws-sdk/clients/medicalimaging.js
var require_medicalimaging = __commonJS({
  "node_modules/aws-sdk/clients/medicalimaging.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["medicalimaging"] = {};
    AWS2.MedicalImaging = Service.defineService("medicalimaging", ["2023-07-19"]);
    Object.defineProperty(apiLoader.services["medicalimaging"], "2023-07-19", {
      get: function get() {
        var model = require_medical_imaging_2023_07_19_min();
        model.paginators = require_medical_imaging_2023_07_19_paginators().pagination;
        model.waiters = require_medical_imaging_2023_07_19_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.MedicalImaging;
  }
});

// node_modules/aws-sdk/apis/entityresolution-2018-05-10.min.json
var require_entityresolution_2018_05_10_min = __commonJS({
  "node_modules/aws-sdk/apis/entityresolution-2018-05-10.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-05-10",
        endpointPrefix: "entityresolution",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "AWSEntityResolution",
        serviceFullName: "AWS EntityResolution",
        serviceId: "EntityResolution",
        signatureVersion: "v4",
        signingName: "entityresolution",
        uid: "entityresolution-2018-05-10"
      },
      operations: {
        CreateIdMappingWorkflow: {
          http: {
            requestUri: "/idmappingworkflows",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "idMappingTechniques",
              "inputSourceConfig",
              "outputSourceConfig",
              "roleArn",
              "workflowName"
            ],
            members: {
              description: {},
              idMappingTechniques: {
                shape: "S3"
              },
              inputSourceConfig: {
                shape: "Sa"
              },
              outputSourceConfig: {
                shape: "Se"
              },
              roleArn: {},
              tags: {
                shape: "Si"
              },
              workflowName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "idMappingTechniques",
              "inputSourceConfig",
              "outputSourceConfig",
              "roleArn",
              "workflowArn",
              "workflowName"
            ],
            members: {
              description: {},
              idMappingTechniques: {
                shape: "S3"
              },
              inputSourceConfig: {
                shape: "Sa"
              },
              outputSourceConfig: {
                shape: "Se"
              },
              roleArn: {},
              workflowArn: {},
              workflowName: {}
            }
          }
        },
        CreateMatchingWorkflow: {
          http: {
            requestUri: "/matchingworkflows",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "inputSourceConfig",
              "outputSourceConfig",
              "resolutionTechniques",
              "roleArn",
              "workflowName"
            ],
            members: {
              description: {},
              incrementalRunConfig: {
                shape: "So"
              },
              inputSourceConfig: {
                shape: "Sq"
              },
              outputSourceConfig: {
                shape: "Su"
              },
              resolutionTechniques: {
                shape: "Sz"
              },
              roleArn: {},
              tags: {
                shape: "Si"
              },
              workflowName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "inputSourceConfig",
              "outputSourceConfig",
              "resolutionTechniques",
              "roleArn",
              "workflowArn",
              "workflowName"
            ],
            members: {
              description: {},
              incrementalRunConfig: {
                shape: "So"
              },
              inputSourceConfig: {
                shape: "Sq"
              },
              outputSourceConfig: {
                shape: "Su"
              },
              resolutionTechniques: {
                shape: "Sz"
              },
              roleArn: {},
              workflowArn: {},
              workflowName: {}
            }
          }
        },
        CreateSchemaMapping: {
          http: {
            requestUri: "/schemas",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "mappedInputFields",
              "schemaName"
            ],
            members: {
              description: {},
              mappedInputFields: {
                shape: "S1b"
              },
              schemaName: {},
              tags: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "description",
              "mappedInputFields",
              "schemaArn",
              "schemaName"
            ],
            members: {
              description: {},
              mappedInputFields: {
                shape: "S1b"
              },
              schemaArn: {},
              schemaName: {}
            }
          }
        },
        DeleteIdMappingWorkflow: {
          http: {
            method: "DELETE",
            requestUri: "/idmappingworkflows/{workflowName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workflowName"
            ],
            members: {
              workflowName: {
                location: "uri",
                locationName: "workflowName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "message"
            ],
            members: {
              message: {}
            }
          },
          idempotent: true
        },
        DeleteMatchingWorkflow: {
          http: {
            method: "DELETE",
            requestUri: "/matchingworkflows/{workflowName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workflowName"
            ],
            members: {
              workflowName: {
                location: "uri",
                locationName: "workflowName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "message"
            ],
            members: {
              message: {}
            }
          },
          idempotent: true
        },
        DeleteSchemaMapping: {
          http: {
            method: "DELETE",
            requestUri: "/schemas/{schemaName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "schemaName"
            ],
            members: {
              schemaName: {
                location: "uri",
                locationName: "schemaName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "message"
            ],
            members: {
              message: {}
            }
          },
          idempotent: true
        },
        GetIdMappingJob: {
          http: {
            method: "GET",
            requestUri: "/idmappingworkflows/{workflowName}/jobs/{jobId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "jobId",
              "workflowName"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              workflowName: {
                location: "uri",
                locationName: "workflowName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobId",
              "startTime",
              "status"
            ],
            members: {
              endTime: {
                type: "timestamp"
              },
              errorDetails: {
                shape: "S1q"
              },
              jobId: {},
              metrics: {
                type: "structure",
                members: {
                  inputRecords: {
                    type: "integer"
                  },
                  recordsNotProcessed: {
                    type: "integer"
                  },
                  totalRecordsProcessed: {
                    type: "integer"
                  }
                }
              },
              startTime: {
                type: "timestamp"
              },
              status: {}
            }
          }
        },
        GetIdMappingWorkflow: {
          http: {
            method: "GET",
            requestUri: "/idmappingworkflows/{workflowName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workflowName"
            ],
            members: {
              workflowName: {
                location: "uri",
                locationName: "workflowName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "createdAt",
              "idMappingTechniques",
              "inputSourceConfig",
              "outputSourceConfig",
              "roleArn",
              "updatedAt",
              "workflowArn",
              "workflowName"
            ],
            members: {
              createdAt: {
                type: "timestamp"
              },
              description: {},
              idMappingTechniques: {
                shape: "S3"
              },
              inputSourceConfig: {
                shape: "Sa"
              },
              outputSourceConfig: {
                shape: "Se"
              },
              roleArn: {},
              tags: {
                shape: "Si"
              },
              updatedAt: {
                type: "timestamp"
              },
              workflowArn: {},
              workflowName: {}
            }
          }
        },
        GetMatchId: {
          http: {
            requestUri: "/matchingworkflows/{workflowName}/matches",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "record",
              "workflowName"
            ],
            members: {
              record: {
                type: "map",
                key: {},
                value: {},
                sensitive: true
              },
              workflowName: {
                location: "uri",
                locationName: "workflowName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              matchId: {}
            }
          }
        },
        GetMatchingJob: {
          http: {
            method: "GET",
            requestUri: "/matchingworkflows/{workflowName}/jobs/{jobId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "jobId",
              "workflowName"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              workflowName: {
                location: "uri",
                locationName: "workflowName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobId",
              "startTime",
              "status"
            ],
            members: {
              endTime: {
                type: "timestamp"
              },
              errorDetails: {
                shape: "S1q"
              },
              jobId: {},
              metrics: {
                type: "structure",
                members: {
                  inputRecords: {
                    type: "integer"
                  },
                  matchIDs: {
                    type: "integer"
                  },
                  recordsNotProcessed: {
                    type: "integer"
                  },
                  totalRecordsProcessed: {
                    type: "integer"
                  }
                }
              },
              startTime: {
                type: "timestamp"
              },
              status: {}
            }
          }
        },
        GetMatchingWorkflow: {
          http: {
            method: "GET",
            requestUri: "/matchingworkflows/{workflowName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workflowName"
            ],
            members: {
              workflowName: {
                location: "uri",
                locationName: "workflowName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "createdAt",
              "inputSourceConfig",
              "outputSourceConfig",
              "resolutionTechniques",
              "roleArn",
              "updatedAt",
              "workflowArn",
              "workflowName"
            ],
            members: {
              createdAt: {
                type: "timestamp"
              },
              description: {},
              incrementalRunConfig: {
                shape: "So"
              },
              inputSourceConfig: {
                shape: "Sq"
              },
              outputSourceConfig: {
                shape: "Su"
              },
              resolutionTechniques: {
                shape: "Sz"
              },
              roleArn: {},
              tags: {
                shape: "Si"
              },
              updatedAt: {
                type: "timestamp"
              },
              workflowArn: {},
              workflowName: {}
            }
          }
        },
        GetProviderService: {
          http: {
            method: "GET",
            requestUri: "/providerservices/{providerName}/{providerServiceName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "providerName",
              "providerServiceName"
            ],
            members: {
              providerName: {
                location: "uri",
                locationName: "providerName"
              },
              providerServiceName: {
                location: "uri",
                locationName: "providerServiceName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "anonymizedOutput",
              "providerEndpointConfiguration",
              "providerEntityOutputDefinition",
              "providerName",
              "providerServiceArn",
              "providerServiceDisplayName",
              "providerServiceName",
              "providerServiceType"
            ],
            members: {
              anonymizedOutput: {
                type: "boolean"
              },
              providerConfigurationDefinition: {
                shape: "S8"
              },
              providerEndpointConfiguration: {
                type: "structure",
                members: {
                  marketplaceConfiguration: {
                    type: "structure",
                    required: [
                      "assetId",
                      "dataSetId",
                      "listingId",
                      "revisionId"
                    ],
                    members: {
                      assetId: {},
                      dataSetId: {},
                      listingId: {},
                      revisionId: {}
                    }
                  }
                },
                union: true
              },
              providerEntityOutputDefinition: {
                shape: "S8"
              },
              providerIntermediateDataAccessConfiguration: {
                type: "structure",
                members: {
                  awsAccountIds: {
                    type: "list",
                    member: {}
                  },
                  requiredBucketActions: {
                    type: "list",
                    member: {}
                  }
                }
              },
              providerName: {},
              providerServiceArn: {},
              providerServiceDisplayName: {},
              providerServiceName: {},
              providerServiceType: {}
            }
          }
        },
        GetSchemaMapping: {
          http: {
            method: "GET",
            requestUri: "/schemas/{schemaName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "schemaName"
            ],
            members: {
              schemaName: {
                location: "uri",
                locationName: "schemaName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "createdAt",
              "hasWorkflows",
              "mappedInputFields",
              "schemaArn",
              "schemaName",
              "updatedAt"
            ],
            members: {
              createdAt: {
                type: "timestamp"
              },
              description: {},
              hasWorkflows: {
                type: "boolean"
              },
              mappedInputFields: {
                shape: "S1b"
              },
              schemaArn: {},
              schemaName: {},
              tags: {
                shape: "Si"
              },
              updatedAt: {
                type: "timestamp"
              }
            }
          }
        },
        ListIdMappingJobs: {
          http: {
            method: "GET",
            requestUri: "/idmappingworkflows/{workflowName}/jobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workflowName"
            ],
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              workflowName: {
                location: "uri",
                locationName: "workflowName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobs: {
                shape: "S2n"
              },
              nextToken: {}
            }
          }
        },
        ListIdMappingWorkflows: {
          http: {
            method: "GET",
            requestUri: "/idmappingworkflows",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              workflowSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "createdAt",
                    "updatedAt",
                    "workflowArn",
                    "workflowName"
                  ],
                  members: {
                    createdAt: {
                      type: "timestamp"
                    },
                    updatedAt: {
                      type: "timestamp"
                    },
                    workflowArn: {},
                    workflowName: {}
                  }
                }
              }
            }
          }
        },
        ListMatchingJobs: {
          http: {
            method: "GET",
            requestUri: "/matchingworkflows/{workflowName}/jobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workflowName"
            ],
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              workflowName: {
                location: "uri",
                locationName: "workflowName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobs: {
                shape: "S2n"
              },
              nextToken: {}
            }
          }
        },
        ListMatchingWorkflows: {
          http: {
            method: "GET",
            requestUri: "/matchingworkflows",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              workflowSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "createdAt",
                    "resolutionType",
                    "updatedAt",
                    "workflowArn",
                    "workflowName"
                  ],
                  members: {
                    createdAt: {
                      type: "timestamp"
                    },
                    resolutionType: {},
                    updatedAt: {
                      type: "timestamp"
                    },
                    workflowArn: {},
                    workflowName: {}
                  }
                }
              }
            }
          }
        },
        ListProviderServices: {
          http: {
            method: "GET",
            requestUri: "/providerservices",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              providerName: {
                location: "querystring",
                locationName: "providerName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              providerServiceSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "providerName",
                    "providerServiceArn",
                    "providerServiceDisplayName",
                    "providerServiceName",
                    "providerServiceType"
                  ],
                  members: {
                    providerName: {},
                    providerServiceArn: {},
                    providerServiceDisplayName: {},
                    providerServiceName: {},
                    providerServiceType: {}
                  }
                }
              }
            }
          }
        },
        ListSchemaMappings: {
          http: {
            method: "GET",
            requestUri: "/schemas",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              schemaList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "createdAt",
                    "hasWorkflows",
                    "schemaArn",
                    "schemaName",
                    "updatedAt"
                  ],
                  members: {
                    createdAt: {
                      type: "timestamp"
                    },
                    hasWorkflows: {
                      type: "boolean"
                    },
                    schemaArn: {},
                    schemaName: {},
                    updatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "tags"
            ],
            members: {
              tags: {
                shape: "Si"
              }
            }
          }
        },
        StartIdMappingJob: {
          http: {
            requestUri: "/idmappingworkflows/{workflowName}/jobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workflowName"
            ],
            members: {
              workflowName: {
                location: "uri",
                locationName: "workflowName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {}
            }
          }
        },
        StartMatchingJob: {
          http: {
            requestUri: "/matchingworkflows/{workflowName}/jobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workflowName"
            ],
            members: {
              workflowName: {
                location: "uri",
                locationName: "workflowName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateIdMappingWorkflow: {
          http: {
            method: "PUT",
            requestUri: "/idmappingworkflows/{workflowName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "idMappingTechniques",
              "inputSourceConfig",
              "outputSourceConfig",
              "roleArn",
              "workflowName"
            ],
            members: {
              description: {},
              idMappingTechniques: {
                shape: "S3"
              },
              inputSourceConfig: {
                shape: "Sa"
              },
              outputSourceConfig: {
                shape: "Se"
              },
              roleArn: {},
              workflowName: {
                location: "uri",
                locationName: "workflowName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "idMappingTechniques",
              "inputSourceConfig",
              "outputSourceConfig",
              "roleArn",
              "workflowArn",
              "workflowName"
            ],
            members: {
              description: {},
              idMappingTechniques: {
                shape: "S3"
              },
              inputSourceConfig: {
                shape: "Sa"
              },
              outputSourceConfig: {
                shape: "Se"
              },
              roleArn: {},
              workflowArn: {},
              workflowName: {}
            }
          },
          idempotent: true
        },
        UpdateMatchingWorkflow: {
          http: {
            method: "PUT",
            requestUri: "/matchingworkflows/{workflowName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "inputSourceConfig",
              "outputSourceConfig",
              "resolutionTechniques",
              "roleArn",
              "workflowName"
            ],
            members: {
              description: {},
              incrementalRunConfig: {
                shape: "So"
              },
              inputSourceConfig: {
                shape: "Sq"
              },
              outputSourceConfig: {
                shape: "Su"
              },
              resolutionTechniques: {
                shape: "Sz"
              },
              roleArn: {},
              workflowName: {
                location: "uri",
                locationName: "workflowName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "inputSourceConfig",
              "outputSourceConfig",
              "resolutionTechniques",
              "roleArn",
              "workflowName"
            ],
            members: {
              description: {},
              incrementalRunConfig: {
                shape: "So"
              },
              inputSourceConfig: {
                shape: "Sq"
              },
              outputSourceConfig: {
                shape: "Su"
              },
              resolutionTechniques: {
                shape: "Sz"
              },
              roleArn: {},
              workflowName: {}
            }
          },
          idempotent: true
        },
        UpdateSchemaMapping: {
          http: {
            method: "PUT",
            requestUri: "/schemas/{schemaName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "mappedInputFields",
              "schemaName"
            ],
            members: {
              description: {},
              mappedInputFields: {
                shape: "S1b"
              },
              schemaName: {
                location: "uri",
                locationName: "schemaName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "mappedInputFields",
              "schemaArn",
              "schemaName"
            ],
            members: {
              description: {},
              mappedInputFields: {
                shape: "S1b"
              },
              schemaArn: {},
              schemaName: {}
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S3: {
          type: "structure",
          required: [
            "idMappingType",
            "providerProperties"
          ],
          members: {
            idMappingType: {},
            providerProperties: {
              shape: "S5"
            }
          }
        },
        S5: {
          type: "structure",
          required: [
            "providerServiceArn"
          ],
          members: {
            intermediateSourceConfiguration: {
              type: "structure",
              required: [
                "intermediateS3Path"
              ],
              members: {
                intermediateS3Path: {}
              }
            },
            providerConfiguration: {
              shape: "S8"
            },
            providerServiceArn: {}
          }
        },
        S8: {
          type: "structure",
          members: {},
          document: true
        },
        Sa: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "inputSourceARN",
              "schemaName"
            ],
            members: {
              inputSourceARN: {},
              schemaName: {}
            }
          }
        },
        Se: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "outputS3Path"
            ],
            members: {
              KMSArn: {},
              outputS3Path: {}
            }
          }
        },
        Si: {
          type: "map",
          key: {},
          value: {}
        },
        So: {
          type: "structure",
          members: {
            incrementalRunType: {}
          }
        },
        Sq: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "inputSourceARN",
              "schemaName"
            ],
            members: {
              applyNormalization: {
                type: "boolean"
              },
              inputSourceARN: {},
              schemaName: {}
            }
          }
        },
        Su: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "output",
              "outputS3Path"
            ],
            members: {
              KMSArn: {},
              applyNormalization: {
                type: "boolean"
              },
              output: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name"
                  ],
                  members: {
                    hashed: {
                      type: "boolean"
                    },
                    name: {}
                  }
                }
              },
              outputS3Path: {}
            }
          }
        },
        Sz: {
          type: "structure",
          required: [
            "resolutionType"
          ],
          members: {
            providerProperties: {
              shape: "S5"
            },
            resolutionType: {},
            ruleBasedProperties: {
              type: "structure",
              required: [
                "attributeMatchingModel",
                "rules"
              ],
              members: {
                attributeMatchingModel: {},
                rules: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "matchingKeys",
                      "ruleName"
                    ],
                    members: {
                      matchingKeys: {
                        type: "list",
                        member: {}
                      },
                      ruleName: {}
                    }
                  }
                }
              }
            }
          }
        },
        S1b: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "fieldName",
              "type"
            ],
            members: {
              fieldName: {},
              groupName: {},
              matchKey: {},
              subType: {},
              type: {}
            }
          }
        },
        S1q: {
          type: "structure",
          members: {
            errorMessage: {}
          }
        },
        S2n: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "jobId",
              "startTime",
              "status"
            ],
            members: {
              endTime: {
                type: "timestamp"
              },
              jobId: {},
              startTime: {
                type: "timestamp"
              },
              status: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/entityresolution-2018-05-10.paginators.json
var require_entityresolution_2018_05_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/entityresolution-2018-05-10.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListIdMappingJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "jobs"
        },
        ListIdMappingWorkflows: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "workflowSummaries"
        },
        ListMatchingJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "jobs"
        },
        ListMatchingWorkflows: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "workflowSummaries"
        },
        ListProviderServices: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "providerServiceSummaries"
        },
        ListSchemaMappings: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "schemaList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/entityresolution.js
var require_entityresolution = __commonJS({
  "node_modules/aws-sdk/clients/entityresolution.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["entityresolution"] = {};
    AWS2.EntityResolution = Service.defineService("entityresolution", ["2018-05-10"]);
    Object.defineProperty(apiLoader.services["entityresolution"], "2018-05-10", {
      get: function get() {
        var model = require_entityresolution_2018_05_10_min();
        model.paginators = require_entityresolution_2018_05_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.EntityResolution;
  }
});

// node_modules/aws-sdk/apis/managedblockchain-query-2023-05-04.min.json
var require_managedblockchain_query_2023_05_04_min = __commonJS({
  "node_modules/aws-sdk/apis/managedblockchain-query-2023-05-04.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2023-05-04",
        endpointPrefix: "managedblockchain-query",
        jsonVersion: "1.1",
        protocol: "rest-json",
        ripServiceName: "chainquery",
        serviceFullName: "Amazon Managed Blockchain Query",
        serviceId: "ManagedBlockchain Query",
        signatureVersion: "v4",
        signingName: "managedblockchain-query",
        uid: "managedblockchain-query-2023-05-04"
      },
      operations: {
        BatchGetTokenBalance: {
          http: {
            requestUri: "/batch-get-token-balance",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              getTokenBalanceInputs: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "tokenIdentifier",
                    "ownerIdentifier"
                  ],
                  members: {
                    tokenIdentifier: {
                      shape: "S4"
                    },
                    ownerIdentifier: {
                      shape: "S8"
                    },
                    atBlockchainInstant: {
                      shape: "S9"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "tokenBalances",
              "errors"
            ],
            members: {
              tokenBalances: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "balance",
                    "atBlockchainInstant"
                  ],
                  members: {
                    ownerIdentifier: {
                      shape: "S8"
                    },
                    tokenIdentifier: {
                      shape: "S4"
                    },
                    balance: {},
                    atBlockchainInstant: {
                      shape: "S9"
                    },
                    lastUpdatedTime: {
                      shape: "S9"
                    }
                  }
                }
              },
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "errorCode",
                    "errorMessage",
                    "errorType"
                  ],
                  members: {
                    tokenIdentifier: {
                      shape: "S4"
                    },
                    ownerIdentifier: {
                      shape: "S8"
                    },
                    atBlockchainInstant: {
                      shape: "S9"
                    },
                    errorCode: {},
                    errorMessage: {},
                    errorType: {}
                  }
                }
              }
            }
          }
        },
        GetAssetContract: {
          http: {
            requestUri: "/get-asset-contract",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "contractIdentifier"
            ],
            members: {
              contractIdentifier: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "contractIdentifier",
              "tokenStandard",
              "deployerAddress"
            ],
            members: {
              contractIdentifier: {
                shape: "Sj"
              },
              tokenStandard: {},
              deployerAddress: {},
              metadata: {
                type: "structure",
                members: {
                  name: {},
                  symbol: {},
                  decimals: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        GetTokenBalance: {
          http: {
            requestUri: "/get-token-balance",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "tokenIdentifier",
              "ownerIdentifier"
            ],
            members: {
              tokenIdentifier: {
                shape: "S4"
              },
              ownerIdentifier: {
                shape: "S8"
              },
              atBlockchainInstant: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "balance",
              "atBlockchainInstant"
            ],
            members: {
              ownerIdentifier: {
                shape: "S8"
              },
              tokenIdentifier: {
                shape: "S4"
              },
              balance: {},
              atBlockchainInstant: {
                shape: "S9"
              },
              lastUpdatedTime: {
                shape: "S9"
              }
            }
          }
        },
        GetTransaction: {
          http: {
            requestUri: "/get-transaction",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "transactionHash",
              "network"
            ],
            members: {
              transactionHash: {},
              network: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "transaction"
            ],
            members: {
              transaction: {
                type: "structure",
                required: [
                  "network",
                  "transactionHash",
                  "transactionTimestamp",
                  "transactionIndex",
                  "numberOfTransactions",
                  "to"
                ],
                members: {
                  network: {},
                  blockHash: {},
                  transactionHash: {},
                  blockNumber: {},
                  transactionTimestamp: {
                    type: "timestamp"
                  },
                  transactionIndex: {
                    type: "long"
                  },
                  numberOfTransactions: {
                    type: "long"
                  },
                  status: {
                    deprecated: true,
                    deprecatedMessage: "The status field in the GetTransaction response is deprecated and is replaced with the confirmationStatus and executionStatus fields."
                  },
                  to: {},
                  from: {},
                  contractAddress: {},
                  gasUsed: {},
                  cumulativeGasUsed: {},
                  effectiveGasPrice: {},
                  signatureV: {
                    type: "integer"
                  },
                  signatureR: {},
                  signatureS: {},
                  transactionFee: {},
                  transactionId: {},
                  confirmationStatus: {},
                  executionStatus: {}
                }
              }
            }
          }
        },
        ListAssetContracts: {
          http: {
            requestUri: "/list-asset-contracts",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "contractFilter"
            ],
            members: {
              contractFilter: {
                type: "structure",
                required: [
                  "network",
                  "tokenStandard",
                  "deployerAddress"
                ],
                members: {
                  network: {},
                  tokenStandard: {},
                  deployerAddress: {}
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "contracts"
            ],
            members: {
              contracts: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "contractIdentifier",
                    "tokenStandard",
                    "deployerAddress"
                  ],
                  members: {
                    contractIdentifier: {
                      shape: "Sj"
                    },
                    tokenStandard: {},
                    deployerAddress: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTokenBalances: {
          http: {
            requestUri: "/list-token-balances",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "tokenFilter"
            ],
            members: {
              ownerFilter: {
                type: "structure",
                required: [
                  "address"
                ],
                members: {
                  address: {}
                }
              },
              tokenFilter: {
                type: "structure",
                required: [
                  "network"
                ],
                members: {
                  network: {},
                  contractAddress: {},
                  tokenId: {}
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "tokenBalances"
            ],
            members: {
              tokenBalances: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "balance",
                    "atBlockchainInstant"
                  ],
                  members: {
                    ownerIdentifier: {
                      shape: "S8"
                    },
                    tokenIdentifier: {
                      shape: "S4"
                    },
                    balance: {},
                    atBlockchainInstant: {
                      shape: "S9"
                    },
                    lastUpdatedTime: {
                      shape: "S9"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTransactionEvents: {
          http: {
            requestUri: "/list-transaction-events",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "transactionHash",
              "network"
            ],
            members: {
              transactionHash: {},
              network: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "events"
            ],
            members: {
              events: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "network",
                    "transactionHash",
                    "eventType"
                  ],
                  members: {
                    network: {},
                    transactionHash: {},
                    eventType: {},
                    from: {},
                    to: {},
                    value: {},
                    contractAddress: {},
                    tokenId: {},
                    transactionId: {},
                    voutIndex: {
                      type: "integer"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTransactions: {
          http: {
            requestUri: "/list-transactions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "address",
              "network"
            ],
            members: {
              address: {},
              network: {},
              fromBlockchainInstant: {
                shape: "S9"
              },
              toBlockchainInstant: {
                shape: "S9"
              },
              sort: {
                type: "structure",
                members: {
                  sortBy: {},
                  sortOrder: {}
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "transactions"
            ],
            members: {
              transactions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "transactionHash",
                    "network",
                    "transactionTimestamp"
                  ],
                  members: {
                    transactionHash: {},
                    network: {},
                    transactionTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          required: [
            "network"
          ],
          members: {
            network: {},
            contractAddress: {},
            tokenId: {}
          }
        },
        S8: {
          type: "structure",
          required: [
            "address"
          ],
          members: {
            address: {}
          }
        },
        S9: {
          type: "structure",
          members: {
            time: {
              type: "timestamp"
            }
          }
        },
        Sj: {
          type: "structure",
          required: [
            "network",
            "contractAddress"
          ],
          members: {
            network: {},
            contractAddress: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/managedblockchain-query-2023-05-04.paginators.json
var require_managedblockchain_query_2023_05_04_paginators = __commonJS({
  "node_modules/aws-sdk/apis/managedblockchain-query-2023-05-04.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAssetContracts: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "contracts"
        },
        ListTokenBalances: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "tokenBalances"
        },
        ListTransactionEvents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "events"
        },
        ListTransactions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "transactions"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/managedblockchain-query-2023-05-04.waiters2.json
var require_managedblockchain_query_2023_05_04_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/managedblockchain-query-2023-05-04.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {}
    };
  }
});

// node_modules/aws-sdk/clients/managedblockchainquery.js
var require_managedblockchainquery = __commonJS({
  "node_modules/aws-sdk/clients/managedblockchainquery.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["managedblockchainquery"] = {};
    AWS2.ManagedBlockchainQuery = Service.defineService("managedblockchainquery", ["2023-05-04"]);
    Object.defineProperty(apiLoader.services["managedblockchainquery"], "2023-05-04", {
      get: function get() {
        var model = require_managedblockchain_query_2023_05_04_min();
        model.paginators = require_managedblockchain_query_2023_05_04_paginators().pagination;
        model.waiters = require_managedblockchain_query_2023_05_04_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.ManagedBlockchainQuery;
  }
});

// node_modules/aws-sdk/apis/neptunedata-2023-08-01.min.json
var require_neptunedata_2023_08_01_min = __commonJS({
  "node_modules/aws-sdk/apis/neptunedata-2023-08-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2023-08-01",
        endpointPrefix: "neptune-db",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon NeptuneData",
        serviceId: "neptunedata",
        signatureVersion: "v4",
        signingName: "neptune-db",
        uid: "neptunedata-2023-08-01"
      },
      operations: {
        CancelGremlinQuery: {
          http: {
            method: "DELETE",
            requestUri: "/gremlin/status/{queryId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "queryId"
            ],
            members: {
              queryId: {
                location: "uri",
                locationName: "queryId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              status: {}
            }
          },
          idempotent: true
        },
        CancelLoaderJob: {
          http: {
            method: "DELETE",
            requestUri: "/loader/{loadId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "loadId"
            ],
            members: {
              loadId: {
                location: "uri",
                locationName: "loadId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              status: {}
            }
          },
          idempotent: true
        },
        CancelMLDataProcessingJob: {
          http: {
            method: "DELETE",
            requestUri: "/ml/dataprocessing/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              neptuneIamRoleArn: {
                location: "querystring",
                locationName: "neptuneIamRoleArn"
              },
              clean: {
                location: "querystring",
                locationName: "clean",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              status: {}
            }
          },
          idempotent: true
        },
        CancelMLModelTrainingJob: {
          http: {
            method: "DELETE",
            requestUri: "/ml/modeltraining/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              neptuneIamRoleArn: {
                location: "querystring",
                locationName: "neptuneIamRoleArn"
              },
              clean: {
                location: "querystring",
                locationName: "clean",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              status: {}
            }
          },
          idempotent: true
        },
        CancelMLModelTransformJob: {
          http: {
            method: "DELETE",
            requestUri: "/ml/modeltransform/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              neptuneIamRoleArn: {
                location: "querystring",
                locationName: "neptuneIamRoleArn"
              },
              clean: {
                location: "querystring",
                locationName: "clean",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              status: {}
            }
          },
          idempotent: true
        },
        CancelOpenCypherQuery: {
          http: {
            method: "DELETE",
            requestUri: "/opencypher/status/{queryId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "queryId"
            ],
            members: {
              queryId: {
                location: "uri",
                locationName: "queryId"
              },
              silent: {
                location: "querystring",
                locationName: "silent",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              status: {},
              payload: {
                type: "boolean"
              }
            }
          },
          idempotent: true
        },
        CreateMLEndpoint: {
          http: {
            requestUri: "/ml/endpoints",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              id: {},
              mlModelTrainingJobId: {},
              mlModelTransformJobId: {},
              update: {
                type: "boolean"
              },
              neptuneIamRoleArn: {},
              modelName: {},
              instanceType: {},
              instanceCount: {
                type: "integer"
              },
              volumeEncryptionKMSKey: {}
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              arn: {},
              creationTimeInMillis: {
                type: "long"
              }
            }
          }
        },
        DeleteMLEndpoint: {
          http: {
            method: "DELETE",
            requestUri: "/ml/endpoints/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              neptuneIamRoleArn: {
                location: "querystring",
                locationName: "neptuneIamRoleArn"
              },
              clean: {
                location: "querystring",
                locationName: "clean",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              status: {}
            }
          },
          idempotent: true
        },
        DeletePropertygraphStatistics: {
          http: {
            method: "DELETE",
            requestUri: "/propertygraph/statistics",
            responseCode: 200
          },
          output: {
            type: "structure",
            members: {
              statusCode: {
                location: "statusCode",
                type: "integer"
              },
              status: {},
              payload: {
                shape: "Sm"
              }
            }
          },
          idempotent: true
        },
        DeleteSparqlStatistics: {
          http: {
            method: "DELETE",
            requestUri: "/sparql/statistics",
            responseCode: 200
          },
          output: {
            type: "structure",
            members: {
              statusCode: {
                location: "statusCode",
                type: "integer"
              },
              status: {},
              payload: {
                shape: "Sm"
              }
            }
          },
          idempotent: true
        },
        ExecuteFastReset: {
          http: {
            requestUri: "/system",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "action"
            ],
            members: {
              action: {},
              token: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "status"
            ],
            members: {
              status: {},
              payload: {
                type: "structure",
                members: {
                  token: {}
                }
              }
            }
          },
          idempotent: true
        },
        ExecuteGremlinExplainQuery: {
          http: {
            requestUri: "/gremlin/explain",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "gremlinQuery"
            ],
            members: {
              gremlinQuery: {
                locationName: "gremlin"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              output: {
                type: "blob"
              }
            },
            payload: "output"
          }
        },
        ExecuteGremlinProfileQuery: {
          http: {
            requestUri: "/gremlin/profile",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "gremlinQuery"
            ],
            members: {
              gremlinQuery: {
                locationName: "gremlin"
              },
              results: {
                locationName: "profile.results",
                type: "boolean"
              },
              chop: {
                locationName: "profile.chop",
                type: "integer"
              },
              serializer: {
                locationName: "profile.serializer"
              },
              indexOps: {
                locationName: "profile.indexOps",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              output: {
                type: "blob"
              }
            },
            payload: "output"
          }
        },
        ExecuteGremlinQuery: {
          http: {
            requestUri: "/gremlin",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "gremlinQuery"
            ],
            members: {
              gremlinQuery: {
                locationName: "gremlin"
              },
              serializer: {
                location: "header",
                locationName: "accept"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              status: {
                type: "structure",
                members: {
                  message: {},
                  code: {
                    type: "integer"
                  },
                  attributes: {
                    shape: "S10"
                  }
                }
              },
              result: {
                shape: "S10"
              },
              meta: {
                shape: "S10"
              }
            }
          }
        },
        ExecuteOpenCypherExplainQuery: {
          http: {
            requestUri: "/opencypher/explain",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "openCypherQuery",
              "explainMode"
            ],
            members: {
              openCypherQuery: {
                locationName: "query"
              },
              parameters: {},
              explainMode: {
                locationName: "explain"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "results"
            ],
            members: {
              results: {
                type: "blob"
              }
            },
            payload: "results"
          }
        },
        ExecuteOpenCypherQuery: {
          http: {
            requestUri: "/opencypher",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "openCypherQuery"
            ],
            members: {
              openCypherQuery: {
                locationName: "query"
              },
              parameters: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "results"
            ],
            members: {
              results: {
                shape: "S10"
              }
            }
          }
        },
        GetEngineStatus: {
          http: {
            method: "GET",
            requestUri: "/status",
            responseCode: 200
          },
          output: {
            type: "structure",
            members: {
              status: {},
              startTime: {},
              dbEngineVersion: {},
              role: {},
              dfeQueryEngine: {},
              gremlin: {
                shape: "S18"
              },
              sparql: {
                shape: "S18"
              },
              opencypher: {
                shape: "S18"
              },
              labMode: {
                shape: "S19"
              },
              rollingBackTrxCount: {
                type: "integer"
              },
              rollingBackTrxEarliestStartTime: {},
              features: {
                type: "map",
                key: {},
                value: {
                  shape: "S10"
                }
              },
              settings: {
                shape: "S19"
              }
            }
          }
        },
        GetGremlinQueryStatus: {
          http: {
            method: "GET",
            requestUri: "/gremlin/status/{queryId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "queryId"
            ],
            members: {
              queryId: {
                location: "uri",
                locationName: "queryId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              queryId: {},
              queryString: {},
              queryEvalStats: {
                shape: "S1d"
              }
            }
          }
        },
        GetLoaderJobStatus: {
          http: {
            method: "GET",
            requestUri: "/loader/{loadId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "loadId"
            ],
            members: {
              loadId: {
                location: "uri",
                locationName: "loadId"
              },
              details: {
                location: "querystring",
                locationName: "details",
                type: "boolean"
              },
              errors: {
                location: "querystring",
                locationName: "errors",
                type: "boolean"
              },
              page: {
                location: "querystring",
                locationName: "page",
                type: "integer"
              },
              errorsPerPage: {
                location: "querystring",
                locationName: "errorsPerPage",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "status",
              "payload"
            ],
            members: {
              status: {},
              payload: {
                shape: "S10"
              }
            }
          }
        },
        GetMLDataProcessingJob: {
          http: {
            method: "GET",
            requestUri: "/ml/dataprocessing/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              neptuneIamRoleArn: {
                location: "querystring",
                locationName: "neptuneIamRoleArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              status: {},
              id: {},
              processingJob: {
                shape: "S1j"
              }
            }
          }
        },
        GetMLEndpoint: {
          http: {
            method: "GET",
            requestUri: "/ml/endpoints/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              neptuneIamRoleArn: {
                location: "querystring",
                locationName: "neptuneIamRoleArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              status: {},
              id: {},
              endpoint: {
                shape: "S1j"
              },
              endpointConfig: {
                shape: "S1m"
              }
            }
          }
        },
        GetMLModelTrainingJob: {
          http: {
            method: "GET",
            requestUri: "/ml/modeltraining/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              neptuneIamRoleArn: {
                location: "querystring",
                locationName: "neptuneIamRoleArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              status: {},
              id: {},
              processingJob: {
                shape: "S1j"
              },
              hpoJob: {
                shape: "S1j"
              },
              modelTransformJob: {
                shape: "S1j"
              },
              mlModels: {
                type: "list",
                member: {
                  shape: "S1m"
                }
              }
            }
          }
        },
        GetMLModelTransformJob: {
          http: {
            method: "GET",
            requestUri: "/ml/modeltransform/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              neptuneIamRoleArn: {
                location: "querystring",
                locationName: "neptuneIamRoleArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              status: {},
              id: {},
              baseProcessingJob: {
                shape: "S1j"
              },
              remoteModelTransformJob: {
                shape: "S1j"
              },
              models: {
                type: "list",
                member: {
                  shape: "S1m"
                }
              }
            }
          }
        },
        GetOpenCypherQueryStatus: {
          http: {
            method: "GET",
            requestUri: "/opencypher/status/{queryId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "queryId"
            ],
            members: {
              queryId: {
                location: "uri",
                locationName: "queryId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              queryId: {},
              queryString: {},
              queryEvalStats: {
                shape: "S1d"
              }
            }
          }
        },
        GetPropertygraphStatistics: {
          http: {
            method: "GET",
            requestUri: "/propertygraph/statistics",
            responseCode: 200
          },
          output: {
            type: "structure",
            required: [
              "status",
              "payload"
            ],
            members: {
              status: {},
              payload: {
                shape: "S1w"
              }
            }
          }
        },
        GetPropertygraphStream: {
          http: {
            method: "GET",
            requestUri: "/propertygraph/stream",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "long"
              },
              iteratorType: {
                location: "querystring",
                locationName: "iteratorType"
              },
              commitNum: {
                location: "querystring",
                locationName: "commitNum",
                type: "long"
              },
              opNum: {
                location: "querystring",
                locationName: "opNum",
                type: "long"
              },
              encoding: {
                location: "header",
                locationName: "Accept-Encoding"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "lastEventId",
              "lastTrxTimestampInMillis",
              "format",
              "records",
              "totalRecords"
            ],
            members: {
              lastEventId: {
                shape: "S19"
              },
              lastTrxTimestampInMillis: {
                locationName: "lastTrxTimestamp",
                type: "long"
              },
              format: {},
              records: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "commitTimestampInMillis",
                    "eventId",
                    "data",
                    "op"
                  ],
                  members: {
                    commitTimestampInMillis: {
                      locationName: "commitTimestamp",
                      type: "long"
                    },
                    eventId: {
                      shape: "S19"
                    },
                    data: {
                      type: "structure",
                      required: [
                        "id",
                        "type",
                        "key",
                        "value"
                      ],
                      members: {
                        id: {},
                        type: {},
                        key: {},
                        value: {
                          shape: "S10"
                        },
                        from: {},
                        to: {}
                      }
                    },
                    op: {},
                    isLastOp: {
                      type: "boolean"
                    }
                  }
                }
              },
              totalRecords: {
                type: "integer"
              }
            }
          }
        },
        GetPropertygraphSummary: {
          http: {
            method: "GET",
            requestUri: "/propertygraph/statistics/summary",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              mode: {
                location: "querystring",
                locationName: "mode"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              statusCode: {
                location: "statusCode",
                type: "integer"
              },
              payload: {
                type: "structure",
                members: {
                  version: {},
                  lastStatisticsComputationTime: {
                    shape: "S1x"
                  },
                  graphSummary: {
                    type: "structure",
                    members: {
                      numNodes: {
                        type: "long"
                      },
                      numEdges: {
                        type: "long"
                      },
                      numNodeLabels: {
                        type: "long"
                      },
                      numEdgeLabels: {
                        type: "long"
                      },
                      nodeLabels: {
                        type: "list",
                        member: {}
                      },
                      edgeLabels: {
                        type: "list",
                        member: {}
                      },
                      numNodeProperties: {
                        type: "long"
                      },
                      numEdgeProperties: {
                        type: "long"
                      },
                      nodeProperties: {
                        shape: "S2e"
                      },
                      edgeProperties: {
                        shape: "S2e"
                      },
                      totalNodePropertyValues: {
                        type: "long"
                      },
                      totalEdgePropertyValues: {
                        type: "long"
                      },
                      nodeStructures: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            count: {
                              type: "long"
                            },
                            nodeProperties: {
                              type: "list",
                              member: {}
                            },
                            distinctOutgoingEdgeLabels: {
                              type: "list",
                              member: {}
                            }
                          }
                        }
                      },
                      edgeStructures: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            count: {
                              type: "long"
                            },
                            edgeProperties: {
                              type: "list",
                              member: {}
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetRDFGraphSummary: {
          http: {
            method: "GET",
            requestUri: "/rdf/statistics/summary",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              mode: {
                location: "querystring",
                locationName: "mode"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              statusCode: {
                location: "statusCode",
                type: "integer"
              },
              payload: {
                type: "structure",
                members: {
                  version: {},
                  lastStatisticsComputationTime: {
                    shape: "S1x"
                  },
                  graphSummary: {
                    type: "structure",
                    members: {
                      numDistinctSubjects: {
                        type: "long"
                      },
                      numDistinctPredicates: {
                        type: "long"
                      },
                      numQuads: {
                        type: "long"
                      },
                      numClasses: {
                        type: "long"
                      },
                      classes: {
                        type: "list",
                        member: {}
                      },
                      predicates: {
                        shape: "S2e"
                      },
                      subjectStructures: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            count: {
                              type: "long"
                            },
                            predicates: {
                              type: "list",
                              member: {}
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetSparqlStatistics: {
          http: {
            method: "GET",
            requestUri: "/sparql/statistics",
            responseCode: 200
          },
          output: {
            type: "structure",
            required: [
              "status",
              "payload"
            ],
            members: {
              status: {},
              payload: {
                shape: "S1w"
              }
            }
          }
        },
        GetSparqlStream: {
          http: {
            method: "GET",
            requestUri: "/sparql/stream",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "long"
              },
              iteratorType: {
                location: "querystring",
                locationName: "iteratorType"
              },
              commitNum: {
                location: "querystring",
                locationName: "commitNum",
                type: "long"
              },
              opNum: {
                location: "querystring",
                locationName: "opNum",
                type: "long"
              },
              encoding: {
                location: "header",
                locationName: "Accept-Encoding"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "lastEventId",
              "lastTrxTimestampInMillis",
              "format",
              "records",
              "totalRecords"
            ],
            members: {
              lastEventId: {
                shape: "S19"
              },
              lastTrxTimestampInMillis: {
                locationName: "lastTrxTimestamp",
                type: "long"
              },
              format: {},
              records: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "commitTimestampInMillis",
                    "eventId",
                    "data",
                    "op"
                  ],
                  members: {
                    commitTimestampInMillis: {
                      locationName: "commitTimestamp",
                      type: "long"
                    },
                    eventId: {
                      shape: "S19"
                    },
                    data: {
                      type: "structure",
                      required: [
                        "stmt"
                      ],
                      members: {
                        stmt: {}
                      }
                    },
                    op: {},
                    isLastOp: {
                      type: "boolean"
                    }
                  }
                }
              },
              totalRecords: {
                type: "integer"
              }
            }
          }
        },
        ListGremlinQueries: {
          http: {
            method: "GET",
            requestUri: "/gremlin/status",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              includeWaiting: {
                location: "querystring",
                locationName: "includeWaiting",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              acceptedQueryCount: {
                type: "integer"
              },
              runningQueryCount: {
                type: "integer"
              },
              queries: {
                type: "list",
                member: {
                  shape: "S35"
                }
              }
            }
          }
        },
        ListLoaderJobs: {
          http: {
            method: "GET",
            requestUri: "/loader",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              includeQueuedLoads: {
                location: "querystring",
                locationName: "includeQueuedLoads",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "status",
              "payload"
            ],
            members: {
              status: {},
              payload: {
                type: "structure",
                members: {
                  loadIds: {
                    shape: "S3a"
                  }
                }
              }
            }
          }
        },
        ListMLDataProcessingJobs: {
          http: {
            method: "GET",
            requestUri: "/ml/dataprocessing",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxItems: {
                location: "querystring",
                locationName: "maxItems",
                type: "integer"
              },
              neptuneIamRoleArn: {
                location: "querystring",
                locationName: "neptuneIamRoleArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ids: {
                shape: "S3a"
              }
            }
          }
        },
        ListMLEndpoints: {
          http: {
            method: "GET",
            requestUri: "/ml/endpoints",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxItems: {
                location: "querystring",
                locationName: "maxItems",
                type: "integer"
              },
              neptuneIamRoleArn: {
                location: "querystring",
                locationName: "neptuneIamRoleArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ids: {
                shape: "S3a"
              }
            }
          }
        },
        ListMLModelTrainingJobs: {
          http: {
            method: "GET",
            requestUri: "/ml/modeltraining",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxItems: {
                location: "querystring",
                locationName: "maxItems",
                type: "integer"
              },
              neptuneIamRoleArn: {
                location: "querystring",
                locationName: "neptuneIamRoleArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ids: {
                shape: "S3a"
              }
            }
          }
        },
        ListMLModelTransformJobs: {
          http: {
            method: "GET",
            requestUri: "/ml/modeltransform",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxItems: {
                location: "querystring",
                locationName: "maxItems",
                type: "integer"
              },
              neptuneIamRoleArn: {
                location: "querystring",
                locationName: "neptuneIamRoleArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ids: {
                shape: "S3a"
              }
            }
          }
        },
        ListOpenCypherQueries: {
          http: {
            method: "GET",
            requestUri: "/opencypher/status",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              includeWaiting: {
                location: "querystring",
                locationName: "includeWaiting",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              acceptedQueryCount: {
                type: "integer"
              },
              runningQueryCount: {
                type: "integer"
              },
              queries: {
                type: "list",
                member: {
                  shape: "S35"
                }
              }
            }
          }
        },
        ManagePropertygraphStatistics: {
          http: {
            requestUri: "/propertygraph/statistics",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              mode: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "status"
            ],
            members: {
              status: {},
              payload: {
                shape: "S3t"
              }
            }
          },
          idempotent: true
        },
        ManageSparqlStatistics: {
          http: {
            requestUri: "/sparql/statistics",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              mode: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "status"
            ],
            members: {
              status: {},
              payload: {
                shape: "S3t"
              }
            }
          },
          idempotent: true
        },
        StartLoaderJob: {
          http: {
            requestUri: "/loader",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "source",
              "format",
              "s3BucketRegion",
              "iamRoleArn"
            ],
            members: {
              source: {},
              format: {},
              s3BucketRegion: {
                locationName: "region"
              },
              iamRoleArn: {},
              mode: {},
              failOnError: {
                type: "boolean"
              },
              parallelism: {},
              parserConfiguration: {
                shape: "S19"
              },
              updateSingleCardinalityProperties: {
                type: "boolean"
              },
              queueRequest: {
                type: "boolean"
              },
              dependencies: {
                shape: "S3a"
              },
              userProvidedEdgeIds: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "status",
              "payload"
            ],
            members: {
              status: {},
              payload: {
                shape: "S19"
              }
            }
          },
          idempotent: true
        },
        StartMLDataProcessingJob: {
          http: {
            requestUri: "/ml/dataprocessing",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "inputDataS3Location",
              "processedDataS3Location"
            ],
            members: {
              id: {},
              previousDataProcessingJobId: {},
              inputDataS3Location: {},
              processedDataS3Location: {},
              sagemakerIamRoleArn: {},
              neptuneIamRoleArn: {},
              processingInstanceType: {},
              processingInstanceVolumeSizeInGB: {
                type: "integer"
              },
              processingTimeOutInSeconds: {
                type: "integer"
              },
              modelType: {},
              configFileName: {},
              subnets: {
                shape: "S3a"
              },
              securityGroupIds: {
                shape: "S3a"
              },
              volumeEncryptionKMSKey: {},
              s3OutputEncryptionKMSKey: {}
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              arn: {},
              creationTimeInMillis: {
                type: "long"
              }
            }
          }
        },
        StartMLModelTrainingJob: {
          http: {
            requestUri: "/ml/modeltraining",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "dataProcessingJobId",
              "trainModelS3Location"
            ],
            members: {
              id: {},
              previousModelTrainingJobId: {},
              dataProcessingJobId: {},
              trainModelS3Location: {},
              sagemakerIamRoleArn: {},
              neptuneIamRoleArn: {},
              baseProcessingInstanceType: {},
              trainingInstanceType: {},
              trainingInstanceVolumeSizeInGB: {
                type: "integer"
              },
              trainingTimeOutInSeconds: {
                type: "integer"
              },
              maxHPONumberOfTrainingJobs: {
                type: "integer"
              },
              maxHPOParallelTrainingJobs: {
                type: "integer"
              },
              subnets: {
                shape: "S3a"
              },
              securityGroupIds: {
                shape: "S3a"
              },
              volumeEncryptionKMSKey: {},
              s3OutputEncryptionKMSKey: {},
              enableManagedSpotTraining: {
                type: "boolean"
              },
              customModelTrainingParameters: {
                type: "structure",
                required: [
                  "sourceS3DirectoryPath"
                ],
                members: {
                  sourceS3DirectoryPath: {},
                  trainingEntryPointScript: {},
                  transformEntryPointScript: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              arn: {},
              creationTimeInMillis: {
                type: "long"
              }
            }
          }
        },
        StartMLModelTransformJob: {
          http: {
            requestUri: "/ml/modeltransform",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "modelTransformOutputS3Location"
            ],
            members: {
              id: {},
              dataProcessingJobId: {},
              mlModelTrainingJobId: {},
              trainingJobName: {},
              modelTransformOutputS3Location: {},
              sagemakerIamRoleArn: {},
              neptuneIamRoleArn: {},
              customModelTransformParameters: {
                type: "structure",
                required: [
                  "sourceS3DirectoryPath"
                ],
                members: {
                  sourceS3DirectoryPath: {},
                  transformEntryPointScript: {}
                }
              },
              baseProcessingInstanceType: {},
              baseProcessingInstanceVolumeSizeInGB: {
                type: "integer"
              },
              subnets: {
                shape: "S3a"
              },
              securityGroupIds: {
                shape: "S3a"
              },
              volumeEncryptionKMSKey: {},
              s3OutputEncryptionKMSKey: {}
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              arn: {},
              creationTimeInMillis: {
                type: "long"
              }
            }
          }
        }
      },
      shapes: {
        Sm: {
          type: "structure",
          members: {
            active: {
              type: "boolean"
            },
            statisticsId: {}
          }
        },
        S10: {
          type: "structure",
          members: {},
          document: true
        },
        S18: {
          type: "structure",
          required: [
            "version"
          ],
          members: {
            version: {}
          }
        },
        S19: {
          type: "map",
          key: {},
          value: {}
        },
        S1d: {
          type: "structure",
          members: {
            waited: {
              type: "integer"
            },
            elapsed: {
              type: "integer"
            },
            cancelled: {
              type: "boolean"
            },
            subqueries: {
              shape: "S10"
            }
          }
        },
        S1j: {
          type: "structure",
          members: {
            name: {},
            arn: {},
            status: {},
            outputLocation: {},
            failureReason: {},
            cloudwatchLogUrl: {}
          }
        },
        S1m: {
          type: "structure",
          members: {
            name: {},
            arn: {}
          }
        },
        S1w: {
          type: "structure",
          members: {
            autoCompute: {
              type: "boolean"
            },
            active: {
              type: "boolean"
            },
            statisticsId: {},
            date: {
              shape: "S1x"
            },
            note: {},
            signatureInfo: {
              type: "structure",
              members: {
                signatureCount: {
                  type: "integer"
                },
                instanceCount: {
                  type: "integer"
                },
                predicateCount: {
                  type: "integer"
                }
              }
            }
          }
        },
        S1x: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S2e: {
          type: "list",
          member: {
            type: "map",
            key: {},
            value: {
              type: "long"
            }
          }
        },
        S35: {
          type: "structure",
          members: {
            queryId: {},
            queryString: {},
            queryEvalStats: {
              shape: "S1d"
            }
          }
        },
        S3a: {
          type: "list",
          member: {}
        },
        S3t: {
          type: "structure",
          members: {
            statisticsId: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/neptunedata-2023-08-01.paginators.json
var require_neptunedata_2023_08_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/neptunedata-2023-08-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/neptunedata.js
var require_neptunedata = __commonJS({
  "node_modules/aws-sdk/clients/neptunedata.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["neptunedata"] = {};
    AWS2.Neptunedata = Service.defineService("neptunedata", ["2023-08-01"]);
    Object.defineProperty(apiLoader.services["neptunedata"], "2023-08-01", {
      get: function get() {
        var model = require_neptunedata_2023_08_01_min();
        model.paginators = require_neptunedata_2023_08_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Neptunedata;
  }
});

// node_modules/aws-sdk/apis/pca-connector-ad-2018-05-10.min.json
var require_pca_connector_ad_2018_05_10_min = __commonJS({
  "node_modules/aws-sdk/apis/pca-connector-ad-2018-05-10.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-05-10",
        endpointPrefix: "pca-connector-ad",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "PcaConnectorAd",
        serviceId: "Pca Connector Ad",
        signatureVersion: "v4",
        signingName: "pca-connector-ad",
        uid: "pca-connector-ad-2018-05-10"
      },
      operations: {
        CreateConnector: {
          http: {
            requestUri: "/connectors",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn",
              "DirectoryId",
              "VpcInformation"
            ],
            members: {
              CertificateAuthorityArn: {},
              ClientToken: {
                idempotencyToken: true
              },
              DirectoryId: {},
              Tags: {
                shape: "S5"
              },
              VpcInformation: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectorArn: {}
            }
          }
        },
        CreateDirectoryRegistration: {
          http: {
            requestUri: "/directoryRegistrations",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              DirectoryId: {},
              Tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DirectoryRegistrationArn: {}
            }
          }
        },
        CreateServicePrincipalName: {
          http: {
            requestUri: "/directoryRegistrations/{DirectoryRegistrationArn}/servicePrincipalNames/{ConnectorArn}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "ConnectorArn",
              "DirectoryRegistrationArn"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              ConnectorArn: {
                location: "uri",
                locationName: "ConnectorArn"
              },
              DirectoryRegistrationArn: {
                location: "uri",
                locationName: "DirectoryRegistrationArn"
              }
            }
          },
          idempotent: true
        },
        CreateTemplate: {
          http: {
            requestUri: "/templates",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ConnectorArn",
              "Definition",
              "Name"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              ConnectorArn: {},
              Definition: {
                shape: "Sh"
              },
              Name: {},
              Tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplateArn: {}
            }
          }
        },
        CreateTemplateGroupAccessControlEntry: {
          http: {
            requestUri: "/templates/{TemplateArn}/accessControlEntries",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccessRights",
              "GroupDisplayName",
              "GroupSecurityIdentifier",
              "TemplateArn"
            ],
            members: {
              AccessRights: {
                shape: "S1y"
              },
              ClientToken: {
                idempotencyToken: true
              },
              GroupDisplayName: {},
              GroupSecurityIdentifier: {},
              TemplateArn: {
                location: "uri",
                locationName: "TemplateArn"
              }
            }
          },
          idempotent: true
        },
        DeleteConnector: {
          http: {
            method: "DELETE",
            requestUri: "/connectors/{ConnectorArn}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "ConnectorArn"
            ],
            members: {
              ConnectorArn: {
                location: "uri",
                locationName: "ConnectorArn"
              }
            }
          },
          idempotent: true
        },
        DeleteDirectoryRegistration: {
          http: {
            method: "DELETE",
            requestUri: "/directoryRegistrations/{DirectoryRegistrationArn}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "DirectoryRegistrationArn"
            ],
            members: {
              DirectoryRegistrationArn: {
                location: "uri",
                locationName: "DirectoryRegistrationArn"
              }
            }
          },
          idempotent: true
        },
        DeleteServicePrincipalName: {
          http: {
            method: "DELETE",
            requestUri: "/directoryRegistrations/{DirectoryRegistrationArn}/servicePrincipalNames/{ConnectorArn}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "ConnectorArn",
              "DirectoryRegistrationArn"
            ],
            members: {
              ConnectorArn: {
                location: "uri",
                locationName: "ConnectorArn"
              },
              DirectoryRegistrationArn: {
                location: "uri",
                locationName: "DirectoryRegistrationArn"
              }
            }
          },
          idempotent: true
        },
        DeleteTemplate: {
          http: {
            method: "DELETE",
            requestUri: "/templates/{TemplateArn}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "TemplateArn"
            ],
            members: {
              TemplateArn: {
                location: "uri",
                locationName: "TemplateArn"
              }
            }
          },
          idempotent: true
        },
        DeleteTemplateGroupAccessControlEntry: {
          http: {
            method: "DELETE",
            requestUri: "/templates/{TemplateArn}/accessControlEntries/{GroupSecurityIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "GroupSecurityIdentifier",
              "TemplateArn"
            ],
            members: {
              GroupSecurityIdentifier: {
                location: "uri",
                locationName: "GroupSecurityIdentifier"
              },
              TemplateArn: {
                location: "uri",
                locationName: "TemplateArn"
              }
            }
          },
          idempotent: true
        },
        GetConnector: {
          http: {
            method: "GET",
            requestUri: "/connectors/{ConnectorArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ConnectorArn"
            ],
            members: {
              ConnectorArn: {
                location: "uri",
                locationName: "ConnectorArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Connector: {
                type: "structure",
                members: {
                  Arn: {},
                  CertificateAuthorityArn: {},
                  CertificateEnrollmentPolicyServerEndpoint: {},
                  CreatedAt: {
                    type: "timestamp"
                  },
                  DirectoryId: {},
                  Status: {},
                  StatusReason: {},
                  UpdatedAt: {
                    type: "timestamp"
                  },
                  VpcInformation: {
                    shape: "S7"
                  }
                }
              }
            }
          }
        },
        GetDirectoryRegistration: {
          http: {
            method: "GET",
            requestUri: "/directoryRegistrations/{DirectoryRegistrationArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryRegistrationArn"
            ],
            members: {
              DirectoryRegistrationArn: {
                location: "uri",
                locationName: "DirectoryRegistrationArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DirectoryRegistration: {
                type: "structure",
                members: {
                  Arn: {},
                  CreatedAt: {
                    type: "timestamp"
                  },
                  DirectoryId: {},
                  Status: {},
                  StatusReason: {},
                  UpdatedAt: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        GetServicePrincipalName: {
          http: {
            method: "GET",
            requestUri: "/directoryRegistrations/{DirectoryRegistrationArn}/servicePrincipalNames/{ConnectorArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ConnectorArn",
              "DirectoryRegistrationArn"
            ],
            members: {
              ConnectorArn: {
                location: "uri",
                locationName: "ConnectorArn"
              },
              DirectoryRegistrationArn: {
                location: "uri",
                locationName: "DirectoryRegistrationArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ServicePrincipalName: {
                type: "structure",
                members: {
                  ConnectorArn: {},
                  CreatedAt: {
                    type: "timestamp"
                  },
                  DirectoryRegistrationArn: {},
                  Status: {},
                  StatusReason: {},
                  UpdatedAt: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        GetTemplate: {
          http: {
            method: "GET",
            requestUri: "/templates/{TemplateArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "TemplateArn"
            ],
            members: {
              TemplateArn: {
                location: "uri",
                locationName: "TemplateArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Template: {
                type: "structure",
                members: {
                  Arn: {},
                  ConnectorArn: {},
                  CreatedAt: {
                    type: "timestamp"
                  },
                  Definition: {
                    shape: "Sh"
                  },
                  Name: {},
                  ObjectIdentifier: {},
                  PolicySchema: {
                    type: "integer"
                  },
                  Revision: {
                    shape: "S2r"
                  },
                  Status: {},
                  UpdatedAt: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        GetTemplateGroupAccessControlEntry: {
          http: {
            method: "GET",
            requestUri: "/templates/{TemplateArn}/accessControlEntries/{GroupSecurityIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "GroupSecurityIdentifier",
              "TemplateArn"
            ],
            members: {
              GroupSecurityIdentifier: {
                location: "uri",
                locationName: "GroupSecurityIdentifier"
              },
              TemplateArn: {
                location: "uri",
                locationName: "TemplateArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccessControlEntry: {
                type: "structure",
                members: {
                  AccessRights: {
                    shape: "S1y"
                  },
                  CreatedAt: {
                    type: "timestamp"
                  },
                  GroupDisplayName: {},
                  GroupSecurityIdentifier: {},
                  TemplateArn: {},
                  UpdatedAt: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        ListConnectors: {
          http: {
            method: "GET",
            requestUri: "/connectors",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Connectors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    CertificateAuthorityArn: {},
                    CertificateEnrollmentPolicyServerEndpoint: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    DirectoryId: {},
                    Status: {},
                    StatusReason: {},
                    UpdatedAt: {
                      type: "timestamp"
                    },
                    VpcInformation: {
                      shape: "S7"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDirectoryRegistrations: {
          http: {
            method: "GET",
            requestUri: "/directoryRegistrations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DirectoryRegistrations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    DirectoryId: {},
                    Status: {},
                    StatusReason: {},
                    UpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListServicePrincipalNames: {
          http: {
            method: "GET",
            requestUri: "/directoryRegistrations/{DirectoryRegistrationArn}/servicePrincipalNames",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryRegistrationArn"
            ],
            members: {
              DirectoryRegistrationArn: {
                location: "uri",
                locationName: "DirectoryRegistrationArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ServicePrincipalNames: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ConnectorArn: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    DirectoryRegistrationArn: {},
                    Status: {},
                    StatusReason: {},
                    UpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S5"
              }
            }
          }
        },
        ListTemplateGroupAccessControlEntries: {
          http: {
            method: "GET",
            requestUri: "/templates/{TemplateArn}/accessControlEntries",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "TemplateArn"
            ],
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              TemplateArn: {
                location: "uri",
                locationName: "TemplateArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccessControlEntries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AccessRights: {
                      shape: "S1y"
                    },
                    CreatedAt: {
                      type: "timestamp"
                    },
                    GroupDisplayName: {},
                    GroupSecurityIdentifier: {},
                    TemplateArn: {},
                    UpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTemplates: {
          http: {
            method: "GET",
            requestUri: "/templates",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ConnectorArn"
            ],
            members: {
              ConnectorArn: {
                location: "querystring",
                locationName: "ConnectorArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Templates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    ConnectorArn: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    Definition: {
                      shape: "Sh"
                    },
                    Name: {},
                    ObjectIdentifier: {},
                    PolicySchema: {
                      type: "integer"
                    },
                    Revision: {
                      shape: "S2r"
                    },
                    Status: {},
                    UpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{ResourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "S5"
              }
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          idempotent: true
        },
        UpdateTemplate: {
          http: {
            method: "PATCH",
            requestUri: "/templates/{TemplateArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "TemplateArn"
            ],
            members: {
              Definition: {
                shape: "Sh"
              },
              ReenrollAllCertificateHolders: {
                type: "boolean"
              },
              TemplateArn: {
                location: "uri",
                locationName: "TemplateArn"
              }
            }
          }
        },
        UpdateTemplateGroupAccessControlEntry: {
          http: {
            method: "PATCH",
            requestUri: "/templates/{TemplateArn}/accessControlEntries/{GroupSecurityIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "GroupSecurityIdentifier",
              "TemplateArn"
            ],
            members: {
              AccessRights: {
                shape: "S1y"
              },
              GroupDisplayName: {},
              GroupSecurityIdentifier: {
                location: "uri",
                locationName: "GroupSecurityIdentifier"
              },
              TemplateArn: {
                location: "uri",
                locationName: "TemplateArn"
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "map",
          key: {},
          value: {}
        },
        S7: {
          type: "structure",
          required: [
            "SecurityGroupIds"
          ],
          members: {
            SecurityGroupIds: {
              type: "list",
              member: {}
            }
          }
        },
        Sh: {
          type: "structure",
          members: {
            TemplateV2: {
              type: "structure",
              required: [
                "CertificateValidity",
                "EnrollmentFlags",
                "Extensions",
                "GeneralFlags",
                "PrivateKeyAttributes",
                "PrivateKeyFlags",
                "SubjectNameFlags"
              ],
              members: {
                CertificateValidity: {
                  shape: "Sj"
                },
                EnrollmentFlags: {
                  type: "structure",
                  members: {
                    EnableKeyReuseOnNtTokenKeysetStorageFull: {
                      type: "boolean"
                    },
                    IncludeSymmetricAlgorithms: {
                      type: "boolean"
                    },
                    NoSecurityExtension: {
                      type: "boolean"
                    },
                    RemoveInvalidCertificateFromPersonalStore: {
                      type: "boolean"
                    },
                    UserInteractionRequired: {
                      type: "boolean"
                    }
                  }
                },
                Extensions: {
                  type: "structure",
                  required: [
                    "KeyUsage"
                  ],
                  members: {
                    ApplicationPolicies: {
                      shape: "Sq"
                    },
                    KeyUsage: {
                      shape: "Sv"
                    }
                  }
                },
                GeneralFlags: {
                  type: "structure",
                  members: {
                    AutoEnrollment: {
                      type: "boolean"
                    },
                    MachineType: {
                      type: "boolean"
                    }
                  }
                },
                PrivateKeyAttributes: {
                  type: "structure",
                  required: [
                    "KeySpec",
                    "MinimalKeyLength"
                  ],
                  members: {
                    CryptoProviders: {
                      shape: "Sz"
                    },
                    KeySpec: {},
                    MinimalKeyLength: {
                      type: "integer"
                    }
                  }
                },
                PrivateKeyFlags: {
                  type: "structure",
                  required: [
                    "ClientVersion"
                  ],
                  members: {
                    ClientVersion: {},
                    ExportableKey: {
                      type: "boolean"
                    },
                    StrongKeyProtectionRequired: {
                      type: "boolean"
                    }
                  }
                },
                SubjectNameFlags: {
                  type: "structure",
                  members: {
                    RequireCommonName: {
                      type: "boolean"
                    },
                    RequireDirectoryPath: {
                      type: "boolean"
                    },
                    RequireDnsAsCn: {
                      type: "boolean"
                    },
                    RequireEmail: {
                      type: "boolean"
                    },
                    SanRequireDirectoryGuid: {
                      type: "boolean"
                    },
                    SanRequireDns: {
                      type: "boolean"
                    },
                    SanRequireDomainDns: {
                      type: "boolean"
                    },
                    SanRequireEmail: {
                      type: "boolean"
                    },
                    SanRequireSpn: {
                      type: "boolean"
                    },
                    SanRequireUpn: {
                      type: "boolean"
                    }
                  }
                },
                SupersededTemplates: {
                  shape: "S16"
                }
              }
            },
            TemplateV3: {
              type: "structure",
              required: [
                "CertificateValidity",
                "EnrollmentFlags",
                "Extensions",
                "GeneralFlags",
                "HashAlgorithm",
                "PrivateKeyAttributes",
                "PrivateKeyFlags",
                "SubjectNameFlags"
              ],
              members: {
                CertificateValidity: {
                  shape: "Sj"
                },
                EnrollmentFlags: {
                  type: "structure",
                  members: {
                    EnableKeyReuseOnNtTokenKeysetStorageFull: {
                      type: "boolean"
                    },
                    IncludeSymmetricAlgorithms: {
                      type: "boolean"
                    },
                    NoSecurityExtension: {
                      type: "boolean"
                    },
                    RemoveInvalidCertificateFromPersonalStore: {
                      type: "boolean"
                    },
                    UserInteractionRequired: {
                      type: "boolean"
                    }
                  }
                },
                Extensions: {
                  type: "structure",
                  required: [
                    "KeyUsage"
                  ],
                  members: {
                    ApplicationPolicies: {
                      shape: "Sq"
                    },
                    KeyUsage: {
                      shape: "Sv"
                    }
                  }
                },
                GeneralFlags: {
                  type: "structure",
                  members: {
                    AutoEnrollment: {
                      type: "boolean"
                    },
                    MachineType: {
                      type: "boolean"
                    }
                  }
                },
                HashAlgorithm: {},
                PrivateKeyAttributes: {
                  type: "structure",
                  required: [
                    "Algorithm",
                    "KeySpec",
                    "KeyUsageProperty",
                    "MinimalKeyLength"
                  ],
                  members: {
                    Algorithm: {},
                    CryptoProviders: {
                      shape: "Sz"
                    },
                    KeySpec: {},
                    KeyUsageProperty: {
                      shape: "S1f"
                    },
                    MinimalKeyLength: {
                      type: "integer"
                    }
                  }
                },
                PrivateKeyFlags: {
                  type: "structure",
                  required: [
                    "ClientVersion"
                  ],
                  members: {
                    ClientVersion: {},
                    ExportableKey: {
                      type: "boolean"
                    },
                    RequireAlternateSignatureAlgorithm: {
                      type: "boolean"
                    },
                    StrongKeyProtectionRequired: {
                      type: "boolean"
                    }
                  }
                },
                SubjectNameFlags: {
                  type: "structure",
                  members: {
                    RequireCommonName: {
                      type: "boolean"
                    },
                    RequireDirectoryPath: {
                      type: "boolean"
                    },
                    RequireDnsAsCn: {
                      type: "boolean"
                    },
                    RequireEmail: {
                      type: "boolean"
                    },
                    SanRequireDirectoryGuid: {
                      type: "boolean"
                    },
                    SanRequireDns: {
                      type: "boolean"
                    },
                    SanRequireDomainDns: {
                      type: "boolean"
                    },
                    SanRequireEmail: {
                      type: "boolean"
                    },
                    SanRequireSpn: {
                      type: "boolean"
                    },
                    SanRequireUpn: {
                      type: "boolean"
                    }
                  }
                },
                SupersededTemplates: {
                  shape: "S16"
                }
              }
            },
            TemplateV4: {
              type: "structure",
              required: [
                "CertificateValidity",
                "EnrollmentFlags",
                "Extensions",
                "GeneralFlags",
                "PrivateKeyAttributes",
                "PrivateKeyFlags",
                "SubjectNameFlags"
              ],
              members: {
                CertificateValidity: {
                  shape: "Sj"
                },
                EnrollmentFlags: {
                  type: "structure",
                  members: {
                    EnableKeyReuseOnNtTokenKeysetStorageFull: {
                      type: "boolean"
                    },
                    IncludeSymmetricAlgorithms: {
                      type: "boolean"
                    },
                    NoSecurityExtension: {
                      type: "boolean"
                    },
                    RemoveInvalidCertificateFromPersonalStore: {
                      type: "boolean"
                    },
                    UserInteractionRequired: {
                      type: "boolean"
                    }
                  }
                },
                Extensions: {
                  type: "structure",
                  required: [
                    "KeyUsage"
                  ],
                  members: {
                    ApplicationPolicies: {
                      shape: "Sq"
                    },
                    KeyUsage: {
                      shape: "Sv"
                    }
                  }
                },
                GeneralFlags: {
                  type: "structure",
                  members: {
                    AutoEnrollment: {
                      type: "boolean"
                    },
                    MachineType: {
                      type: "boolean"
                    }
                  }
                },
                HashAlgorithm: {},
                PrivateKeyAttributes: {
                  type: "structure",
                  required: [
                    "KeySpec",
                    "MinimalKeyLength"
                  ],
                  members: {
                    Algorithm: {},
                    CryptoProviders: {
                      shape: "Sz"
                    },
                    KeySpec: {},
                    KeyUsageProperty: {
                      shape: "S1f"
                    },
                    MinimalKeyLength: {
                      type: "integer"
                    }
                  }
                },
                PrivateKeyFlags: {
                  type: "structure",
                  required: [
                    "ClientVersion"
                  ],
                  members: {
                    ClientVersion: {},
                    ExportableKey: {
                      type: "boolean"
                    },
                    RequireAlternateSignatureAlgorithm: {
                      type: "boolean"
                    },
                    RequireSameKeyRenewal: {
                      type: "boolean"
                    },
                    StrongKeyProtectionRequired: {
                      type: "boolean"
                    },
                    UseLegacyProvider: {
                      type: "boolean"
                    }
                  }
                },
                SubjectNameFlags: {
                  type: "structure",
                  members: {
                    RequireCommonName: {
                      type: "boolean"
                    },
                    RequireDirectoryPath: {
                      type: "boolean"
                    },
                    RequireDnsAsCn: {
                      type: "boolean"
                    },
                    RequireEmail: {
                      type: "boolean"
                    },
                    SanRequireDirectoryGuid: {
                      type: "boolean"
                    },
                    SanRequireDns: {
                      type: "boolean"
                    },
                    SanRequireDomainDns: {
                      type: "boolean"
                    },
                    SanRequireEmail: {
                      type: "boolean"
                    },
                    SanRequireSpn: {
                      type: "boolean"
                    },
                    SanRequireUpn: {
                      type: "boolean"
                    }
                  }
                },
                SupersededTemplates: {
                  shape: "S16"
                }
              }
            }
          },
          union: true
        },
        Sj: {
          type: "structure",
          required: [
            "RenewalPeriod",
            "ValidityPeriod"
          ],
          members: {
            RenewalPeriod: {
              shape: "Sk"
            },
            ValidityPeriod: {
              shape: "Sk"
            }
          }
        },
        Sk: {
          type: "structure",
          required: [
            "Period",
            "PeriodType"
          ],
          members: {
            Period: {
              type: "long"
            },
            PeriodType: {}
          }
        },
        Sq: {
          type: "structure",
          required: [
            "Policies"
          ],
          members: {
            Critical: {
              type: "boolean"
            },
            Policies: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  PolicyObjectIdentifier: {},
                  PolicyType: {}
                },
                union: true
              }
            }
          }
        },
        Sv: {
          type: "structure",
          required: [
            "UsageFlags"
          ],
          members: {
            Critical: {
              type: "boolean"
            },
            UsageFlags: {
              type: "structure",
              members: {
                DataEncipherment: {
                  type: "boolean"
                },
                DigitalSignature: {
                  type: "boolean"
                },
                KeyAgreement: {
                  type: "boolean"
                },
                KeyEncipherment: {
                  type: "boolean"
                },
                NonRepudiation: {
                  type: "boolean"
                }
              }
            }
          }
        },
        Sz: {
          type: "list",
          member: {}
        },
        S16: {
          type: "list",
          member: {}
        },
        S1f: {
          type: "structure",
          members: {
            PropertyFlags: {
              type: "structure",
              members: {
                Decrypt: {
                  type: "boolean"
                },
                KeyAgreement: {
                  type: "boolean"
                },
                Sign: {
                  type: "boolean"
                }
              }
            },
            PropertyType: {}
          },
          union: true
        },
        S1y: {
          type: "structure",
          members: {
            AutoEnroll: {},
            Enroll: {}
          }
        },
        S2r: {
          type: "structure",
          required: [
            "MajorRevision",
            "MinorRevision"
          ],
          members: {
            MajorRevision: {
              type: "integer"
            },
            MinorRevision: {
              type: "integer"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/pca-connector-ad-2018-05-10.paginators.json
var require_pca_connector_ad_2018_05_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/pca-connector-ad-2018-05-10.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListConnectors: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Connectors"
        },
        ListDirectoryRegistrations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "DirectoryRegistrations"
        },
        ListServicePrincipalNames: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ServicePrincipalNames"
        },
        ListTemplateGroupAccessControlEntries: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AccessControlEntries"
        },
        ListTemplates: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Templates"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/pcaconnectorad.js
var require_pcaconnectorad = __commonJS({
  "node_modules/aws-sdk/clients/pcaconnectorad.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["pcaconnectorad"] = {};
    AWS2.PcaConnectorAd = Service.defineService("pcaconnectorad", ["2018-05-10"]);
    Object.defineProperty(apiLoader.services["pcaconnectorad"], "2018-05-10", {
      get: function get() {
        var model = require_pca_connector_ad_2018_05_10_min();
        model.paginators = require_pca_connector_ad_2018_05_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.PcaConnectorAd;
  }
});

// node_modules/aws-sdk/apis/bedrock-2023-04-20.min.json
var require_bedrock_2023_04_20_min = __commonJS({
  "node_modules/aws-sdk/apis/bedrock-2023-04-20.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2023-04-20",
        endpointPrefix: "bedrock",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Bedrock",
        serviceId: "Bedrock",
        signatureVersion: "v4",
        signingName: "bedrock",
        uid: "bedrock-2023-04-20"
      },
      operations: {
        CreateModelCustomizationJob: {
          http: {
            requestUri: "/model-customization-jobs",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "jobName",
              "customModelName",
              "roleArn",
              "baseModelIdentifier",
              "trainingDataConfig",
              "outputDataConfig",
              "hyperParameters"
            ],
            members: {
              jobName: {},
              customModelName: {},
              roleArn: {},
              clientRequestToken: {
                idempotencyToken: true
              },
              baseModelIdentifier: {},
              customizationType: {},
              customModelKmsKeyId: {},
              jobTags: {
                shape: "S9"
              },
              customModelTags: {
                shape: "S9"
              },
              trainingDataConfig: {
                shape: "Sd"
              },
              validationDataConfig: {
                shape: "Sf"
              },
              outputDataConfig: {
                shape: "Si"
              },
              hyperParameters: {
                shape: "Sj"
              },
              vpcConfig: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobArn"
            ],
            members: {
              jobArn: {}
            }
          },
          idempotent: true
        },
        CreateProvisionedModelThroughput: {
          http: {
            requestUri: "/provisioned-model-throughput",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "modelUnits",
              "provisionedModelName",
              "modelId"
            ],
            members: {
              clientRequestToken: {
                idempotencyToken: true
              },
              modelUnits: {
                type: "integer"
              },
              provisionedModelName: {},
              modelId: {},
              commitmentDuration: {},
              tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "provisionedModelArn"
            ],
            members: {
              provisionedModelArn: {}
            }
          },
          idempotent: true
        },
        DeleteCustomModel: {
          http: {
            method: "DELETE",
            requestUri: "/custom-models/{modelIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "modelIdentifier"
            ],
            members: {
              modelIdentifier: {
                location: "uri",
                locationName: "modelIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteModelInvocationLoggingConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/logging/modelinvocations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteProvisionedModelThroughput: {
          http: {
            method: "DELETE",
            requestUri: "/provisioned-model-throughput/{provisionedModelId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "provisionedModelId"
            ],
            members: {
              provisionedModelId: {
                location: "uri",
                locationName: "provisionedModelId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        GetCustomModel: {
          http: {
            method: "GET",
            requestUri: "/custom-models/{modelIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "modelIdentifier"
            ],
            members: {
              modelIdentifier: {
                location: "uri",
                locationName: "modelIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "modelArn",
              "modelName",
              "jobArn",
              "baseModelArn",
              "trainingDataConfig",
              "outputDataConfig",
              "creationTime"
            ],
            members: {
              modelArn: {},
              modelName: {},
              jobName: {},
              jobArn: {},
              baseModelArn: {},
              customizationType: {},
              modelKmsKeyArn: {},
              hyperParameters: {
                shape: "Sj"
              },
              trainingDataConfig: {
                shape: "Sd"
              },
              validationDataConfig: {
                shape: "Sf"
              },
              outputDataConfig: {
                shape: "Si"
              },
              trainingMetrics: {
                shape: "S1a"
              },
              validationMetrics: {
                shape: "S1c"
              },
              creationTime: {
                shape: "S1e"
              }
            }
          }
        },
        GetFoundationModel: {
          http: {
            method: "GET",
            requestUri: "/foundation-models/{modelIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "modelIdentifier"
            ],
            members: {
              modelIdentifier: {
                location: "uri",
                locationName: "modelIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              modelDetails: {
                type: "structure",
                required: [
                  "modelArn",
                  "modelId"
                ],
                members: {
                  modelArn: {},
                  modelId: {},
                  modelName: {},
                  providerName: {},
                  inputModalities: {
                    shape: "S1l"
                  },
                  outputModalities: {
                    shape: "S1l"
                  },
                  responseStreamingSupported: {
                    type: "boolean"
                  },
                  customizationsSupported: {
                    shape: "S1o"
                  },
                  inferenceTypesSupported: {
                    shape: "S1q"
                  },
                  modelLifecycle: {
                    shape: "S1s"
                  }
                }
              }
            }
          }
        },
        GetModelCustomizationJob: {
          http: {
            method: "GET",
            requestUri: "/model-customization-jobs/{jobIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "jobIdentifier"
            ],
            members: {
              jobIdentifier: {
                location: "uri",
                locationName: "jobIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobArn",
              "jobName",
              "outputModelName",
              "roleArn",
              "creationTime",
              "baseModelArn",
              "hyperParameters",
              "trainingDataConfig",
              "validationDataConfig",
              "outputDataConfig"
            ],
            members: {
              jobArn: {},
              jobName: {},
              outputModelName: {},
              outputModelArn: {},
              clientRequestToken: {},
              roleArn: {},
              status: {},
              failureMessage: {},
              creationTime: {
                shape: "S1e"
              },
              lastModifiedTime: {
                shape: "S1e"
              },
              endTime: {
                shape: "S1e"
              },
              baseModelArn: {},
              hyperParameters: {
                shape: "Sj"
              },
              trainingDataConfig: {
                shape: "Sd"
              },
              validationDataConfig: {
                shape: "Sf"
              },
              outputDataConfig: {
                shape: "Si"
              },
              customizationType: {},
              outputModelKmsKeyArn: {},
              trainingMetrics: {
                shape: "S1a"
              },
              validationMetrics: {
                shape: "S1c"
              },
              vpcConfig: {
                shape: "Sl"
              }
            }
          }
        },
        GetModelInvocationLoggingConfiguration: {
          http: {
            method: "GET",
            requestUri: "/logging/modelinvocations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              loggingConfig: {
                shape: "S22"
              }
            }
          }
        },
        GetProvisionedModelThroughput: {
          http: {
            method: "GET",
            requestUri: "/provisioned-model-throughput/{provisionedModelId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "provisionedModelId"
            ],
            members: {
              provisionedModelId: {
                location: "uri",
                locationName: "provisionedModelId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "modelUnits",
              "desiredModelUnits",
              "provisionedModelName",
              "provisionedModelArn",
              "modelArn",
              "desiredModelArn",
              "foundationModelArn",
              "status",
              "creationTime",
              "lastModifiedTime"
            ],
            members: {
              modelUnits: {
                type: "integer"
              },
              desiredModelUnits: {
                type: "integer"
              },
              provisionedModelName: {},
              provisionedModelArn: {},
              modelArn: {},
              desiredModelArn: {},
              foundationModelArn: {},
              status: {},
              creationTime: {
                shape: "S1e"
              },
              lastModifiedTime: {
                shape: "S1e"
              },
              failureMessage: {},
              commitmentDuration: {},
              commitmentExpirationTime: {
                shape: "S1e"
              }
            }
          }
        },
        ListCustomModels: {
          http: {
            method: "GET",
            requestUri: "/custom-models",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              creationTimeBefore: {
                shape: "S1e",
                location: "querystring",
                locationName: "creationTimeBefore"
              },
              creationTimeAfter: {
                shape: "S1e",
                location: "querystring",
                locationName: "creationTimeAfter"
              },
              nameContains: {
                location: "querystring",
                locationName: "nameContains"
              },
              baseModelArnEquals: {
                location: "querystring",
                locationName: "baseModelArnEquals"
              },
              foundationModelArnEquals: {
                location: "querystring",
                locationName: "foundationModelArnEquals"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              sortBy: {
                location: "querystring",
                locationName: "sortBy"
              },
              sortOrder: {
                location: "querystring",
                locationName: "sortOrder"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              modelSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "modelArn",
                    "modelName",
                    "creationTime",
                    "baseModelArn",
                    "baseModelName"
                  ],
                  members: {
                    modelArn: {},
                    modelName: {},
                    creationTime: {
                      shape: "S1e"
                    },
                    baseModelArn: {},
                    baseModelName: {},
                    customizationType: {}
                  }
                }
              }
            }
          }
        },
        ListFoundationModels: {
          http: {
            method: "GET",
            requestUri: "/foundation-models",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              byProvider: {
                location: "querystring",
                locationName: "byProvider"
              },
              byCustomizationType: {
                location: "querystring",
                locationName: "byCustomizationType"
              },
              byOutputModality: {
                location: "querystring",
                locationName: "byOutputModality"
              },
              byInferenceType: {
                location: "querystring",
                locationName: "byInferenceType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              modelSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "modelArn",
                    "modelId"
                  ],
                  members: {
                    modelArn: {},
                    modelId: {},
                    modelName: {},
                    providerName: {},
                    inputModalities: {
                      shape: "S1l"
                    },
                    outputModalities: {
                      shape: "S1l"
                    },
                    responseStreamingSupported: {
                      type: "boolean"
                    },
                    customizationsSupported: {
                      shape: "S1o"
                    },
                    inferenceTypesSupported: {
                      shape: "S1q"
                    },
                    modelLifecycle: {
                      shape: "S1s"
                    }
                  }
                }
              }
            }
          }
        },
        ListModelCustomizationJobs: {
          http: {
            method: "GET",
            requestUri: "/model-customization-jobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              creationTimeAfter: {
                shape: "S1e",
                location: "querystring",
                locationName: "creationTimeAfter"
              },
              creationTimeBefore: {
                shape: "S1e",
                location: "querystring",
                locationName: "creationTimeBefore"
              },
              statusEquals: {
                location: "querystring",
                locationName: "statusEquals"
              },
              nameContains: {
                location: "querystring",
                locationName: "nameContains"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              sortBy: {
                location: "querystring",
                locationName: "sortBy"
              },
              sortOrder: {
                location: "querystring",
                locationName: "sortOrder"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              modelCustomizationJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "jobArn",
                    "baseModelArn",
                    "jobName",
                    "status",
                    "creationTime"
                  ],
                  members: {
                    jobArn: {},
                    baseModelArn: {},
                    jobName: {},
                    status: {},
                    lastModifiedTime: {
                      shape: "S1e"
                    },
                    creationTime: {
                      shape: "S1e"
                    },
                    endTime: {
                      shape: "S1e"
                    },
                    customModelArn: {},
                    customModelName: {},
                    customizationType: {}
                  }
                }
              }
            }
          }
        },
        ListProvisionedModelThroughputs: {
          http: {
            method: "GET",
            requestUri: "/provisioned-model-throughputs",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              creationTimeAfter: {
                shape: "S1e",
                location: "querystring",
                locationName: "creationTimeAfter"
              },
              creationTimeBefore: {
                shape: "S1e",
                location: "querystring",
                locationName: "creationTimeBefore"
              },
              statusEquals: {
                location: "querystring",
                locationName: "statusEquals"
              },
              modelArnEquals: {
                location: "querystring",
                locationName: "modelArnEquals"
              },
              nameContains: {
                location: "querystring",
                locationName: "nameContains"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              sortBy: {
                location: "querystring",
                locationName: "sortBy"
              },
              sortOrder: {
                location: "querystring",
                locationName: "sortOrder"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              provisionedModelSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "provisionedModelName",
                    "provisionedModelArn",
                    "modelArn",
                    "desiredModelArn",
                    "foundationModelArn",
                    "modelUnits",
                    "desiredModelUnits",
                    "status",
                    "creationTime",
                    "lastModifiedTime"
                  ],
                  members: {
                    provisionedModelName: {},
                    provisionedModelArn: {},
                    modelArn: {},
                    desiredModelArn: {},
                    foundationModelArn: {},
                    modelUnits: {
                      type: "integer"
                    },
                    desiredModelUnits: {
                      type: "integer"
                    },
                    status: {},
                    commitmentDuration: {},
                    commitmentExpirationTime: {
                      shape: "S1e"
                    },
                    creationTime: {
                      shape: "S1e"
                    },
                    lastModifiedTime: {
                      shape: "S1e"
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            requestUri: "/listTagsForResource",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceARN"
            ],
            members: {
              resourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S9"
              }
            }
          }
        },
        PutModelInvocationLoggingConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/logging/modelinvocations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "loggingConfig"
            ],
            members: {
              loggingConfig: {
                shape: "S22"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        StopModelCustomizationJob: {
          http: {
            requestUri: "/model-customization-jobs/{jobIdentifier}/stop",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "jobIdentifier"
            ],
            members: {
              jobIdentifier: {
                location: "uri",
                locationName: "jobIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        TagResource: {
          http: {
            requestUri: "/tagResource",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceARN",
              "tags"
            ],
            members: {
              resourceARN: {},
              tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            requestUri: "/untagResource",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceARN",
              "tagKeys"
            ],
            members: {
              resourceARN: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateProvisionedModelThroughput: {
          http: {
            method: "PATCH",
            requestUri: "/provisioned-model-throughput/{provisionedModelId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "provisionedModelId"
            ],
            members: {
              provisionedModelId: {
                location: "uri",
                locationName: "provisionedModelId"
              },
              desiredProvisionedModelName: {},
              desiredModelId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        }
      },
      shapes: {
        S9: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        Sd: {
          type: "structure",
          required: [
            "s3Uri"
          ],
          members: {
            s3Uri: {}
          }
        },
        Sf: {
          type: "structure",
          required: [
            "validators"
          ],
          members: {
            validators: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "s3Uri"
                ],
                members: {
                  s3Uri: {}
                }
              }
            }
          }
        },
        Si: {
          type: "structure",
          required: [
            "s3Uri"
          ],
          members: {
            s3Uri: {}
          }
        },
        Sj: {
          type: "map",
          key: {},
          value: {}
        },
        Sl: {
          type: "structure",
          required: [
            "subnetIds",
            "securityGroupIds"
          ],
          members: {
            subnetIds: {
              type: "list",
              member: {}
            },
            securityGroupIds: {
              type: "list",
              member: {}
            }
          }
        },
        S1a: {
          type: "structure",
          members: {
            trainingLoss: {
              type: "float"
            }
          }
        },
        S1c: {
          type: "list",
          member: {
            type: "structure",
            members: {
              validationLoss: {
                type: "float"
              }
            }
          }
        },
        S1e: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S1l: {
          type: "list",
          member: {}
        },
        S1o: {
          type: "list",
          member: {}
        },
        S1q: {
          type: "list",
          member: {}
        },
        S1s: {
          type: "structure",
          required: [
            "status"
          ],
          members: {
            status: {}
          }
        },
        S22: {
          type: "structure",
          members: {
            cloudWatchConfig: {
              type: "structure",
              required: [
                "logGroupName",
                "roleArn"
              ],
              members: {
                logGroupName: {},
                roleArn: {},
                largeDataDeliveryS3Config: {
                  shape: "S25"
                }
              }
            },
            s3Config: {
              shape: "S25"
            },
            textDataDeliveryEnabled: {
              type: "boolean"
            },
            imageDataDeliveryEnabled: {
              type: "boolean"
            },
            embeddingDataDeliveryEnabled: {
              type: "boolean"
            }
          }
        },
        S25: {
          type: "structure",
          required: [
            "bucketName"
          ],
          members: {
            bucketName: {},
            keyPrefix: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/bedrock-2023-04-20.paginators.json
var require_bedrock_2023_04_20_paginators = __commonJS({
  "node_modules/aws-sdk/apis/bedrock-2023-04-20.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListCustomModels: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "modelSummaries"
        },
        ListModelCustomizationJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "modelCustomizationJobSummaries"
        },
        ListProvisionedModelThroughputs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "provisionedModelSummaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/bedrock-2023-04-20.waiters2.json
var require_bedrock_2023_04_20_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/bedrock-2023-04-20.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {}
    };
  }
});

// node_modules/aws-sdk/clients/bedrock.js
var require_bedrock = __commonJS({
  "node_modules/aws-sdk/clients/bedrock.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["bedrock"] = {};
    AWS2.Bedrock = Service.defineService("bedrock", ["2023-04-20"]);
    Object.defineProperty(apiLoader.services["bedrock"], "2023-04-20", {
      get: function get() {
        var model = require_bedrock_2023_04_20_min();
        model.paginators = require_bedrock_2023_04_20_paginators().pagination;
        model.waiters = require_bedrock_2023_04_20_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Bedrock;
  }
});

// node_modules/aws-sdk/apis/bedrock-runtime-2023-09-30.min.json
var require_bedrock_runtime_2023_09_30_min = __commonJS({
  "node_modules/aws-sdk/apis/bedrock-runtime-2023-09-30.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2023-09-30",
        endpointPrefix: "bedrock-runtime",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Bedrock Runtime",
        serviceId: "Bedrock Runtime",
        signatureVersion: "v4",
        signingName: "bedrock",
        uid: "bedrock-runtime-2023-09-30"
      },
      operations: {
        InvokeModel: {
          http: {
            requestUri: "/model/{modelId}/invoke",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "body",
              "modelId"
            ],
            members: {
              body: {
                shape: "S2"
              },
              contentType: {
                location: "header",
                locationName: "Content-Type"
              },
              accept: {
                location: "header",
                locationName: "Accept"
              },
              modelId: {
                location: "uri",
                locationName: "modelId"
              }
            },
            payload: "body"
          },
          output: {
            type: "structure",
            required: [
              "body",
              "contentType"
            ],
            members: {
              body: {
                shape: "S2"
              },
              contentType: {
                location: "header",
                locationName: "Content-Type"
              }
            },
            payload: "body"
          }
        },
        InvokeModelWithResponseStream: {
          http: {
            requestUri: "/model/{modelId}/invoke-with-response-stream",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "body",
              "modelId"
            ],
            members: {
              body: {
                shape: "S2"
              },
              contentType: {
                location: "header",
                locationName: "Content-Type"
              },
              accept: {
                location: "header",
                locationName: "X-Amzn-Bedrock-Accept"
              },
              modelId: {
                location: "uri",
                locationName: "modelId"
              }
            },
            payload: "body"
          },
          output: {
            type: "structure",
            required: [
              "body",
              "contentType"
            ],
            members: {
              body: {
                type: "structure",
                members: {
                  chunk: {
                    type: "structure",
                    members: {
                      bytes: {
                        type: "blob",
                        sensitive: true
                      }
                    },
                    event: true,
                    sensitive: true
                  },
                  internalServerException: {
                    type: "structure",
                    members: {
                      message: {}
                    },
                    error: {
                      httpStatusCode: 500
                    },
                    exception: true,
                    fault: true
                  },
                  modelStreamErrorException: {
                    type: "structure",
                    members: {
                      message: {},
                      originalStatusCode: {
                        type: "integer"
                      },
                      originalMessage: {}
                    },
                    error: {
                      httpStatusCode: 424,
                      senderFault: true
                    },
                    exception: true
                  },
                  validationException: {
                    type: "structure",
                    members: {
                      message: {}
                    },
                    error: {
                      httpStatusCode: 400,
                      senderFault: true
                    },
                    exception: true
                  },
                  throttlingException: {
                    type: "structure",
                    members: {
                      message: {}
                    },
                    error: {
                      httpStatusCode: 429,
                      senderFault: true
                    },
                    exception: true
                  },
                  modelTimeoutException: {
                    type: "structure",
                    members: {
                      message: {}
                    },
                    error: {
                      httpStatusCode: 408,
                      senderFault: true
                    },
                    exception: true
                  }
                },
                eventstream: true
              },
              contentType: {
                location: "header",
                locationName: "X-Amzn-Bedrock-Content-Type"
              }
            },
            payload: "body"
          }
        }
      },
      shapes: {
        S2: {
          type: "blob",
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/bedrock-runtime-2023-09-30.paginators.json
var require_bedrock_runtime_2023_09_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/bedrock-runtime-2023-09-30.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/apis/bedrock-runtime-2023-09-30.waiters2.json
var require_bedrock_runtime_2023_09_30_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/bedrock-runtime-2023-09-30.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {}
    };
  }
});

// node_modules/aws-sdk/clients/bedrockruntime.js
var require_bedrockruntime = __commonJS({
  "node_modules/aws-sdk/clients/bedrockruntime.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["bedrockruntime"] = {};
    AWS2.BedrockRuntime = Service.defineService("bedrockruntime", ["2023-09-30"]);
    Object.defineProperty(apiLoader.services["bedrockruntime"], "2023-09-30", {
      get: function get() {
        var model = require_bedrock_runtime_2023_09_30_min();
        model.paginators = require_bedrock_runtime_2023_09_30_paginators().pagination;
        model.waiters = require_bedrock_runtime_2023_09_30_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.BedrockRuntime;
  }
});

// node_modules/aws-sdk/apis/datazone-2018-05-10.min.json
var require_datazone_2018_05_10_min = __commonJS({
  "node_modules/aws-sdk/apis/datazone-2018-05-10.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-05-10",
        endpointPrefix: "datazone",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon DataZone",
        serviceId: "DataZone",
        signatureVersion: "v4",
        signingName: "datazone",
        uid: "datazone-2018-05-10"
      },
      operations: {
        AcceptPredictions: {
          http: {
            method: "PUT",
            requestUri: "/v2/domains/{domainIdentifier}/assets/{identifier}/accept-predictions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              acceptChoices: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    predictionChoice: {
                      type: "integer"
                    },
                    predictionTarget: {}
                  }
                }
              },
              acceptRule: {
                type: "structure",
                members: {
                  rule: {},
                  threshold: {
                    type: "float"
                  }
                }
              },
              clientToken: {
                idempotencyToken: true
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              },
              revision: {
                location: "querystring",
                locationName: "revision"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetId",
              "domainId",
              "revision"
            ],
            members: {
              assetId: {},
              domainId: {},
              revision: {}
            }
          },
          idempotent: true
        },
        AcceptSubscriptionRequest: {
          http: {
            method: "PUT",
            requestUri: "/v2/domains/{domainIdentifier}/subscription-requests/{identifier}/accept",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              decisionComment: {
                shape: "Sg"
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "createdAt",
              "createdBy",
              "domainId",
              "id",
              "requestReason",
              "status",
              "subscribedListings",
              "subscribedPrincipals",
              "updatedAt"
            ],
            members: {
              createdAt: {
                type: "timestamp"
              },
              createdBy: {},
              decisionComment: {
                shape: "Sg"
              },
              domainId: {},
              id: {},
              requestReason: {
                shape: "Sl"
              },
              reviewerId: {},
              status: {},
              subscribedListings: {
                type: "list",
                member: {
                  shape: "So"
                }
              },
              subscribedPrincipals: {
                type: "list",
                member: {
                  shape: "S12"
                }
              },
              updatedAt: {
                type: "timestamp"
              },
              updatedBy: {}
            }
          },
          idempotent: true
        },
        CancelSubscription: {
          http: {
            method: "PUT",
            requestUri: "/v2/domains/{domainIdentifier}/subscriptions/{identifier}/cancel",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "createdAt",
              "createdBy",
              "domainId",
              "id",
              "status",
              "subscribedListing",
              "subscribedPrincipal",
              "updatedAt"
            ],
            members: {
              createdAt: {
                type: "timestamp"
              },
              createdBy: {},
              domainId: {},
              id: {},
              retainPermissions: {
                type: "boolean"
              },
              status: {},
              subscribedListing: {
                shape: "So"
              },
              subscribedPrincipal: {
                shape: "S12"
              },
              subscriptionRequestId: {},
              updatedAt: {
                type: "timestamp"
              },
              updatedBy: {}
            }
          },
          idempotent: true
        },
        CreateAsset: {
          http: {
            requestUri: "/v2/domains/{domainIdentifier}/assets",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "name",
              "owningProjectIdentifier",
              "typeIdentifier"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              description: {
                shape: "Sp"
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              externalIdentifier: {
                shape: "S1d"
              },
              formsInput: {
                shape: "S1e"
              },
              glossaryTerms: {
                shape: "S1j"
              },
              name: {
                shape: "S1l"
              },
              owningProjectIdentifier: {},
              predictionConfiguration: {
                shape: "S1m"
              },
              typeIdentifier: {},
              typeRevision: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "domainId",
              "formsOutput",
              "id",
              "name",
              "owningProjectId",
              "revision",
              "typeIdentifier",
              "typeRevision"
            ],
            members: {
              createdAt: {
                type: "timestamp"
              },
              createdBy: {},
              description: {
                shape: "Sp"
              },
              domainId: {},
              externalIdentifier: {
                shape: "S1d"
              },
              firstRevisionCreatedAt: {
                type: "timestamp"
              },
              firstRevisionCreatedBy: {},
              formsOutput: {
                shape: "S1q"
              },
              glossaryTerms: {
                shape: "S1j"
              },
              id: {},
              listing: {
                shape: "S1t"
              },
              name: {
                shape: "S1l"
              },
              owningProjectId: {},
              predictionConfiguration: {
                shape: "S1m"
              },
              readOnlyFormsOutput: {
                shape: "S1q"
              },
              revision: {},
              typeIdentifier: {},
              typeRevision: {}
            }
          },
          idempotent: true
        },
        CreateAssetRevision: {
          http: {
            requestUri: "/v2/domains/{domainIdentifier}/assets/{identifier}/revisions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier",
              "name"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              description: {
                shape: "Sp"
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              formsInput: {
                shape: "S1e"
              },
              glossaryTerms: {
                shape: "S1j"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              },
              name: {
                shape: "S1l"
              },
              predictionConfiguration: {
                shape: "S1m"
              },
              typeRevision: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "domainId",
              "formsOutput",
              "id",
              "name",
              "owningProjectId",
              "revision",
              "typeIdentifier",
              "typeRevision"
            ],
            members: {
              createdAt: {
                type: "timestamp"
              },
              createdBy: {},
              description: {
                shape: "Sp"
              },
              domainId: {},
              externalIdentifier: {
                shape: "S1d"
              },
              firstRevisionCreatedAt: {
                type: "timestamp"
              },
              firstRevisionCreatedBy: {},
              formsOutput: {
                shape: "S1q"
              },
              glossaryTerms: {
                shape: "S1j"
              },
              id: {},
              listing: {
                shape: "S1t"
              },
              name: {
                shape: "S1l"
              },
              owningProjectId: {},
              predictionConfiguration: {
                shape: "S1m"
              },
              readOnlyFormsOutput: {
                shape: "S1q"
              },
              revision: {},
              typeIdentifier: {},
              typeRevision: {}
            }
          },
          idempotent: true
        },
        CreateAssetType: {
          http: {
            requestUri: "/v2/domains/{domainIdentifier}/asset-types",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "formsInput",
              "name",
              "owningProjectIdentifier"
            ],
            members: {
              description: {
                shape: "Sp"
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              formsInput: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  required: [
                    "typeIdentifier",
                    "typeRevision"
                  ],
                  members: {
                    required: {
                      type: "boolean"
                    },
                    typeIdentifier: {},
                    typeRevision: {}
                  }
                }
              },
              name: {},
              owningProjectIdentifier: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "domainId",
              "formsOutput",
              "name",
              "revision"
            ],
            members: {
              createdAt: {
                type: "timestamp"
              },
              createdBy: {},
              description: {
                shape: "Sp"
              },
              domainId: {},
              formsOutput: {
                shape: "S21"
              },
              name: {},
              originDomainId: {},
              originProjectId: {},
              owningProjectId: {},
              revision: {},
              updatedAt: {
                type: "timestamp"
              },
              updatedBy: {}
            }
          }
        },
        CreateDataSource: {
          http: {
            requestUri: "/v2/domains/{domainIdentifier}/data-sources",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "environmentIdentifier",
              "name",
              "projectIdentifier",
              "type"
            ],
            members: {
              assetFormsInput: {
                shape: "S1e"
              },
              clientToken: {
                idempotencyToken: true
              },
              configuration: {
                shape: "S24"
              },
              description: {
                shape: "Sp"
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              enableSetting: {},
              environmentIdentifier: {},
              name: {
                shape: "S2p"
              },
              projectIdentifier: {},
              publishOnImport: {
                type: "boolean"
              },
              recommendation: {
                shape: "S2q"
              },
              schedule: {
                shape: "S2r"
              },
              type: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "domainId",
              "environmentId",
              "id",
              "name",
              "projectId"
            ],
            members: {
              assetFormsOutput: {
                shape: "S1q"
              },
              configuration: {
                shape: "S2w"
              },
              createdAt: {
                shape: "S35"
              },
              description: {
                shape: "Sp"
              },
              domainId: {},
              enableSetting: {},
              environmentId: {},
              errorMessage: {
                shape: "S37"
              },
              id: {},
              lastRunAt: {
                shape: "S35"
              },
              lastRunErrorMessage: {
                shape: "S37"
              },
              lastRunStatus: {},
              name: {
                shape: "S2p"
              },
              projectId: {},
              publishOnImport: {
                type: "boolean"
              },
              recommendation: {
                shape: "S2q"
              },
              schedule: {
                shape: "S2r"
              },
              status: {},
              type: {},
              updatedAt: {
                shape: "S35"
              }
            }
          },
          idempotent: true
        },
        CreateDomain: {
          http: {
            requestUri: "/v2/domains",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "domainExecutionRole",
              "name"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              description: {},
              domainExecutionRole: {},
              kmsKeyIdentifier: {},
              name: {},
              singleSignOn: {
                shape: "S3f"
              },
              tags: {
                shape: "S3i"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              arn: {},
              description: {},
              domainExecutionRole: {},
              id: {},
              kmsKeyIdentifier: {},
              name: {},
              portalUrl: {},
              singleSignOn: {
                shape: "S3f"
              },
              status: {},
              tags: {
                shape: "S3i"
              }
            }
          },
          idempotent: true
        },
        CreateEnvironment: {
          http: {
            requestUri: "/v2/domains/{domainIdentifier}/environments",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "environmentProfileIdentifier",
              "name",
              "projectIdentifier"
            ],
            members: {
              description: {},
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              environmentProfileIdentifier: {},
              glossaryTerms: {
                shape: "S1j"
              },
              name: {},
              projectIdentifier: {},
              userParameters: {
                shape: "S3p"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "createdBy",
              "domainId",
              "environmentProfileId",
              "name",
              "projectId",
              "provider"
            ],
            members: {
              awsAccountId: {},
              awsAccountRegion: {},
              createdAt: {
                shape: "S3u"
              },
              createdBy: {},
              deploymentProperties: {
                shape: "S3v"
              },
              description: {
                shape: "Sp"
              },
              domainId: {},
              environmentActions: {
                shape: "S3y"
              },
              environmentBlueprintId: {},
              environmentProfileId: {},
              glossaryTerms: {
                shape: "S1j"
              },
              id: {},
              lastDeployment: {
                shape: "S44"
              },
              name: {
                shape: "S4a"
              },
              projectId: {},
              provider: {},
              provisionedResources: {
                shape: "S4b"
              },
              provisioningProperties: {
                shape: "S4d"
              },
              status: {},
              updatedAt: {
                shape: "S3u"
              },
              userParameters: {
                shape: "S4g"
              }
            }
          }
        },
        CreateEnvironmentProfile: {
          http: {
            requestUri: "/v2/domains/{domainIdentifier}/environment-profiles",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "environmentBlueprintIdentifier",
              "name",
              "projectIdentifier"
            ],
            members: {
              awsAccountId: {},
              awsAccountRegion: {},
              description: {
                shape: "Sp"
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              environmentBlueprintIdentifier: {},
              name: {
                shape: "S4k"
              },
              projectIdentifier: {},
              userParameters: {
                shape: "S3p"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "createdBy",
              "domainId",
              "environmentBlueprintId",
              "id",
              "name"
            ],
            members: {
              awsAccountId: {},
              awsAccountRegion: {},
              createdAt: {
                shape: "S3u"
              },
              createdBy: {},
              description: {
                shape: "Sp"
              },
              domainId: {},
              environmentBlueprintId: {},
              id: {},
              name: {
                shape: "S4k"
              },
              projectId: {},
              updatedAt: {
                shape: "S3u"
              },
              userParameters: {
                shape: "S4g"
              }
            }
          }
        },
        CreateFormType: {
          http: {
            requestUri: "/v2/domains/{domainIdentifier}/form-types",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "model",
              "name",
              "owningProjectIdentifier"
            ],
            members: {
              description: {
                shape: "Sp"
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              model: {
                shape: "S4n"
              },
              name: {
                shape: "S1s"
              },
              owningProjectIdentifier: {},
              status: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "domainId",
              "name",
              "revision"
            ],
            members: {
              description: {
                shape: "Sp"
              },
              domainId: {},
              name: {
                shape: "S1s"
              },
              originDomainId: {},
              originProjectId: {},
              owningProjectId: {},
              revision: {}
            }
          }
        },
        CreateGlossary: {
          http: {
            requestUri: "/v2/domains/{domainIdentifier}/glossaries",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "name",
              "owningProjectIdentifier"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              description: {
                shape: "S4s"
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              name: {
                shape: "S4t"
              },
              owningProjectIdentifier: {},
              status: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "domainId",
              "id",
              "name",
              "owningProjectId"
            ],
            members: {
              description: {
                shape: "S4s"
              },
              domainId: {},
              id: {},
              name: {
                shape: "S4t"
              },
              owningProjectId: {},
              status: {}
            }
          },
          idempotent: true
        },
        CreateGlossaryTerm: {
          http: {
            requestUri: "/v2/domains/{domainIdentifier}/glossary-terms",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "glossaryIdentifier",
              "name"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              glossaryIdentifier: {},
              longDescription: {
                shape: "S4y"
              },
              name: {
                shape: "Sx"
              },
              shortDescription: {
                shape: "Sy"
              },
              status: {},
              termRelations: {
                shape: "S50"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "domainId",
              "glossaryId",
              "id",
              "name",
              "status"
            ],
            members: {
              domainId: {},
              glossaryId: {},
              id: {},
              longDescription: {
                shape: "S4y"
              },
              name: {
                shape: "Sx"
              },
              shortDescription: {
                shape: "Sy"
              },
              status: {},
              termRelations: {
                shape: "S50"
              }
            }
          },
          idempotent: true
        },
        CreateGroupProfile: {
          http: {
            requestUri: "/v2/domains/{domainIdentifier}/group-profiles",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "groupIdentifier"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              groupIdentifier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              domainId: {},
              groupName: {
                shape: "S57"
              },
              id: {},
              status: {}
            }
          },
          idempotent: true
        },
        CreateListingChangeSet: {
          http: {
            requestUri: "/v2/domains/{domainIdentifier}/listings/change-set",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "action",
              "domainIdentifier",
              "entityIdentifier",
              "entityType"
            ],
            members: {
              action: {},
              clientToken: {
                idempotencyToken: true
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              entityIdentifier: {},
              entityRevision: {},
              entityType: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "listingId",
              "listingRevision",
              "status"
            ],
            members: {
              listingId: {},
              listingRevision: {},
              status: {}
            }
          }
        },
        CreateProject: {
          http: {
            requestUri: "/v2/domains/{domainIdentifier}/projects",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "name"
            ],
            members: {
              description: {
                shape: "Sp"
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              glossaryTerms: {
                shape: "S1j"
              },
              name: {
                shape: "S14"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "createdBy",
              "domainId",
              "id",
              "name"
            ],
            members: {
              createdAt: {
                shape: "S3u"
              },
              createdBy: {},
              description: {
                shape: "Sp"
              },
              domainId: {},
              glossaryTerms: {
                shape: "S1j"
              },
              id: {},
              lastUpdatedAt: {
                shape: "S3u"
              },
              name: {
                shape: "S14"
              }
            }
          }
        },
        CreateProjectMembership: {
          http: {
            requestUri: "/v2/domains/{domainIdentifier}/projects/{projectIdentifier}/createMembership",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "designation",
              "domainIdentifier",
              "member",
              "projectIdentifier"
            ],
            members: {
              designation: {},
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              member: {
                shape: "S5j"
              },
              projectIdentifier: {
                location: "uri",
                locationName: "projectIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateSubscriptionGrant: {
          http: {
            requestUri: "/v2/domains/{domainIdentifier}/subscription-grants",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "environmentIdentifier",
              "grantedEntity",
              "subscriptionTargetIdentifier"
            ],
            members: {
              assetTargetNames: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "assetId",
                    "targetName"
                  ],
                  members: {
                    assetId: {},
                    targetName: {}
                  }
                }
              },
              clientToken: {
                idempotencyToken: true
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              environmentIdentifier: {},
              grantedEntity: {
                type: "structure",
                members: {
                  listing: {
                    type: "structure",
                    required: [
                      "identifier",
                      "revision"
                    ],
                    members: {
                      identifier: {},
                      revision: {}
                    }
                  }
                },
                union: true
              },
              subscriptionTargetIdentifier: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "createdAt",
              "createdBy",
              "domainId",
              "grantedEntity",
              "id",
              "status",
              "subscriptionTargetId",
              "updatedAt"
            ],
            members: {
              assets: {
                shape: "S5s"
              },
              createdAt: {
                type: "timestamp"
              },
              createdBy: {},
              domainId: {},
              grantedEntity: {
                shape: "S5x"
              },
              id: {},
              status: {},
              subscriptionId: {},
              subscriptionTargetId: {},
              updatedAt: {
                type: "timestamp"
              },
              updatedBy: {}
            }
          }
        },
        CreateSubscriptionRequest: {
          http: {
            requestUri: "/v2/domains/{domainIdentifier}/subscription-requests",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "requestReason",
              "subscribedListings",
              "subscribedPrincipals"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              requestReason: {
                shape: "Sl"
              },
              subscribedListings: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "identifier"
                  ],
                  members: {
                    identifier: {}
                  }
                }
              },
              subscribedPrincipals: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    project: {
                      type: "structure",
                      members: {
                        identifier: {}
                      }
                    }
                  },
                  union: true
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "createdAt",
              "createdBy",
              "domainId",
              "id",
              "requestReason",
              "status",
              "subscribedListings",
              "subscribedPrincipals",
              "updatedAt"
            ],
            members: {
              createdAt: {
                type: "timestamp"
              },
              createdBy: {},
              decisionComment: {
                shape: "Sg"
              },
              domainId: {},
              id: {},
              requestReason: {
                shape: "Sl"
              },
              reviewerId: {},
              status: {},
              subscribedListings: {
                type: "list",
                member: {
                  shape: "So"
                }
              },
              subscribedPrincipals: {
                type: "list",
                member: {
                  shape: "S12"
                }
              },
              updatedAt: {
                type: "timestamp"
              },
              updatedBy: {}
            }
          }
        },
        CreateSubscriptionTarget: {
          http: {
            requestUri: "/v2/domains/{domainIdentifier}/environments/{environmentIdentifier}/subscription-targets",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicableAssetTypes",
              "authorizedPrincipals",
              "domainIdentifier",
              "environmentIdentifier",
              "manageAccessRole",
              "name",
              "subscriptionTargetConfig",
              "type"
            ],
            members: {
              applicableAssetTypes: {
                shape: "S6b"
              },
              authorizedPrincipals: {
                shape: "S6c"
              },
              clientToken: {
                idempotencyToken: true
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              environmentIdentifier: {
                location: "uri",
                locationName: "environmentIdentifier"
              },
              manageAccessRole: {},
              name: {
                shape: "S6e"
              },
              provider: {},
              subscriptionTargetConfig: {
                shape: "S6f"
              },
              type: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "applicableAssetTypes",
              "authorizedPrincipals",
              "createdAt",
              "createdBy",
              "domainId",
              "environmentId",
              "id",
              "manageAccessRole",
              "name",
              "projectId",
              "provider",
              "subscriptionTargetConfig",
              "type"
            ],
            members: {
              applicableAssetTypes: {
                shape: "S6b"
              },
              authorizedPrincipals: {
                shape: "S6c"
              },
              createdAt: {
                type: "timestamp"
              },
              createdBy: {},
              domainId: {},
              environmentId: {},
              id: {},
              manageAccessRole: {},
              name: {
                shape: "S6e"
              },
              projectId: {},
              provider: {},
              subscriptionTargetConfig: {
                shape: "S6f"
              },
              type: {},
              updatedAt: {
                type: "timestamp"
              },
              updatedBy: {}
            }
          }
        },
        CreateUserProfile: {
          http: {
            requestUri: "/v2/domains/{domainIdentifier}/user-profiles",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "userIdentifier"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              userIdentifier: {},
              userType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              details: {
                shape: "S6m"
              },
              domainId: {},
              id: {},
              status: {},
              type: {}
            }
          },
          idempotent: true
        },
        DeleteAsset: {
          http: {
            method: "DELETE",
            requestUri: "/v2/domains/{domainIdentifier}/assets/{identifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteAssetType: {
          http: {
            method: "DELETE",
            requestUri: "/v2/domains/{domainIdentifier}/asset-types/{identifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDataSource: {
          http: {
            method: "DELETE",
            requestUri: "/v2/domains/{domainIdentifier}/data-sources/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "domainId",
              "environmentId",
              "id",
              "name",
              "projectId"
            ],
            members: {
              assetFormsOutput: {
                shape: "S1q"
              },
              configuration: {
                shape: "S2w"
              },
              createdAt: {
                shape: "S35"
              },
              description: {
                shape: "Sp"
              },
              domainId: {},
              enableSetting: {},
              environmentId: {},
              errorMessage: {
                shape: "S37"
              },
              id: {},
              lastRunAt: {
                shape: "S35"
              },
              lastRunErrorMessage: {
                shape: "S37"
              },
              lastRunStatus: {},
              name: {
                shape: "S2p"
              },
              projectId: {},
              publishOnImport: {
                type: "boolean"
              },
              schedule: {
                shape: "S2r"
              },
              status: {},
              type: {},
              updatedAt: {
                shape: "S35"
              }
            }
          },
          idempotent: true
        },
        DeleteDomain: {
          http: {
            method: "DELETE",
            requestUri: "/v2/domains/{identifier}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "identifier"
            ],
            members: {
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "status"
            ],
            members: {
              status: {}
            }
          },
          idempotent: true
        },
        DeleteEnvironment: {
          http: {
            method: "DELETE",
            requestUri: "/v2/domains/{domainIdentifier}/environments/{identifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          idempotent: true
        },
        DeleteEnvironmentBlueprintConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/v2/domains/{domainIdentifier}/environment-blueprint-configurations/{environmentBlueprintIdentifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "environmentBlueprintIdentifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              environmentBlueprintIdentifier: {
                location: "uri",
                locationName: "environmentBlueprintIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteEnvironmentProfile: {
          http: {
            method: "DELETE",
            requestUri: "/v2/domains/{domainIdentifier}/environment-profiles/{identifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          idempotent: true
        },
        DeleteFormType: {
          http: {
            method: "DELETE",
            requestUri: "/v2/domains/{domainIdentifier}/form-types/{formTypeIdentifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "formTypeIdentifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              formTypeIdentifier: {
                location: "uri",
                locationName: "formTypeIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteGlossary: {
          http: {
            method: "DELETE",
            requestUri: "/v2/domains/{domainIdentifier}/glossaries/{identifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteGlossaryTerm: {
          http: {
            method: "DELETE",
            requestUri: "/v2/domains/{domainIdentifier}/glossary-terms/{identifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteListing: {
          http: {
            method: "DELETE",
            requestUri: "/v2/domains/{domainIdentifier}/listings/{identifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteProject: {
          http: {
            method: "DELETE",
            requestUri: "/v2/domains/{domainIdentifier}/projects/{identifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteProjectMembership: {
          http: {
            requestUri: "/v2/domains/{domainIdentifier}/projects/{projectIdentifier}/deleteMembership",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "member",
              "projectIdentifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              member: {
                shape: "S5j"
              },
              projectIdentifier: {
                location: "uri",
                locationName: "projectIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteSubscriptionGrant: {
          http: {
            method: "DELETE",
            requestUri: "/v2/domains/{domainIdentifier}/subscription-grants/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "createdAt",
              "createdBy",
              "domainId",
              "grantedEntity",
              "id",
              "status",
              "subscriptionTargetId",
              "updatedAt"
            ],
            members: {
              assets: {
                shape: "S5s"
              },
              createdAt: {
                type: "timestamp"
              },
              createdBy: {},
              domainId: {},
              grantedEntity: {
                shape: "S5x"
              },
              id: {},
              status: {},
              subscriptionId: {},
              subscriptionTargetId: {},
              updatedAt: {
                type: "timestamp"
              },
              updatedBy: {}
            }
          }
        },
        DeleteSubscriptionRequest: {
          http: {
            method: "DELETE",
            requestUri: "/v2/domains/{domainIdentifier}/subscription-requests/{identifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          }
        },
        DeleteSubscriptionTarget: {
          http: {
            method: "DELETE",
            requestUri: "/v2/domains/{domainIdentifier}/environments/{environmentIdentifier}/subscription-targets/{identifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "environmentIdentifier",
              "identifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              environmentIdentifier: {
                location: "uri",
                locationName: "environmentIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          }
        },
        GetAsset: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/assets/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              },
              revision: {
                location: "querystring",
                locationName: "revision"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "domainId",
              "formsOutput",
              "id",
              "name",
              "owningProjectId",
              "revision",
              "typeIdentifier",
              "typeRevision"
            ],
            members: {
              createdAt: {
                type: "timestamp"
              },
              createdBy: {},
              description: {
                shape: "Sp"
              },
              domainId: {},
              externalIdentifier: {
                shape: "S1d"
              },
              firstRevisionCreatedAt: {
                type: "timestamp"
              },
              firstRevisionCreatedBy: {},
              formsOutput: {
                shape: "S1q"
              },
              glossaryTerms: {
                shape: "S1j"
              },
              id: {},
              listing: {
                shape: "S1t"
              },
              name: {
                shape: "S1l"
              },
              owningProjectId: {},
              readOnlyFormsOutput: {
                shape: "S1q"
              },
              revision: {},
              typeIdentifier: {},
              typeRevision: {}
            }
          }
        },
        GetAssetType: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/asset-types/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              },
              revision: {
                location: "querystring",
                locationName: "revision"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "domainId",
              "formsOutput",
              "name",
              "owningProjectId",
              "revision"
            ],
            members: {
              createdAt: {
                type: "timestamp"
              },
              createdBy: {},
              description: {
                shape: "Sp"
              },
              domainId: {},
              formsOutput: {
                shape: "S21"
              },
              name: {},
              originDomainId: {},
              originProjectId: {},
              owningProjectId: {},
              revision: {},
              updatedAt: {
                type: "timestamp"
              },
              updatedBy: {}
            }
          }
        },
        GetDataSource: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/data-sources/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "domainId",
              "environmentId",
              "id",
              "name",
              "projectId"
            ],
            members: {
              assetFormsOutput: {
                shape: "S1q"
              },
              configuration: {
                shape: "S2w"
              },
              createdAt: {
                shape: "S35"
              },
              description: {
                shape: "Sp"
              },
              domainId: {},
              enableSetting: {},
              environmentId: {},
              errorMessage: {
                shape: "S37"
              },
              id: {},
              lastRunAssetCount: {
                type: "integer"
              },
              lastRunAt: {
                shape: "S35"
              },
              lastRunErrorMessage: {
                shape: "S37"
              },
              lastRunStatus: {},
              name: {
                shape: "S2p"
              },
              projectId: {},
              publishOnImport: {
                type: "boolean"
              },
              recommendation: {
                shape: "S2q"
              },
              schedule: {
                shape: "S2r"
              },
              status: {},
              type: {},
              updatedAt: {
                shape: "S35"
              }
            }
          }
        },
        GetDataSourceRun: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/data-source-runs/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "createdAt",
              "dataSourceId",
              "domainId",
              "id",
              "projectId",
              "status",
              "type",
              "updatedAt"
            ],
            members: {
              createdAt: {
                shape: "S35"
              },
              dataSourceConfigurationSnapshot: {},
              dataSourceId: {},
              domainId: {},
              errorMessage: {
                shape: "S37"
              },
              id: {},
              projectId: {},
              runStatisticsForAssets: {
                shape: "S7w"
              },
              startedAt: {
                shape: "S35"
              },
              status: {},
              stoppedAt: {
                shape: "S35"
              },
              type: {},
              updatedAt: {
                shape: "S35"
              }
            }
          }
        },
        GetDomain: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "identifier"
            ],
            members: {
              identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "domainExecutionRole",
              "id",
              "status"
            ],
            members: {
              arn: {},
              createdAt: {
                type: "timestamp"
              },
              description: {},
              domainExecutionRole: {},
              id: {},
              kmsKeyIdentifier: {},
              lastUpdatedAt: {
                type: "timestamp"
              },
              name: {},
              portalUrl: {},
              singleSignOn: {
                shape: "S3f"
              },
              status: {},
              tags: {
                shape: "S3i"
              }
            }
          }
        },
        GetEnvironment: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/environments/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "createdBy",
              "domainId",
              "environmentProfileId",
              "name",
              "projectId",
              "provider"
            ],
            members: {
              awsAccountId: {},
              awsAccountRegion: {},
              createdAt: {
                shape: "S3u"
              },
              createdBy: {},
              deploymentProperties: {
                shape: "S3v"
              },
              description: {
                shape: "Sp"
              },
              domainId: {},
              environmentActions: {
                shape: "S3y"
              },
              environmentBlueprintId: {},
              environmentProfileId: {},
              glossaryTerms: {
                shape: "S1j"
              },
              id: {},
              lastDeployment: {
                shape: "S44"
              },
              name: {
                shape: "S4a"
              },
              projectId: {},
              provider: {},
              provisionedResources: {
                shape: "S4b"
              },
              provisioningProperties: {
                shape: "S4d"
              },
              status: {},
              updatedAt: {
                shape: "S3u"
              },
              userParameters: {
                shape: "S4g"
              }
            }
          }
        },
        GetEnvironmentBlueprint: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/environment-blueprints/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "name",
              "provider",
              "provisioningProperties"
            ],
            members: {
              createdAt: {
                shape: "S3u"
              },
              deploymentProperties: {
                shape: "S3v"
              },
              description: {
                shape: "Sp"
              },
              glossaryTerms: {
                shape: "S1j"
              },
              id: {},
              name: {},
              provider: {},
              provisioningProperties: {
                shape: "S4d"
              },
              updatedAt: {
                shape: "S3u"
              },
              userParameters: {
                shape: "S4g"
              }
            }
          }
        },
        GetEnvironmentBlueprintConfiguration: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/environment-blueprint-configurations/{environmentBlueprintIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "environmentBlueprintIdentifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              environmentBlueprintIdentifier: {
                location: "uri",
                locationName: "environmentBlueprintIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "domainId",
              "environmentBlueprintId"
            ],
            members: {
              createdAt: {
                shape: "S3u"
              },
              domainId: {},
              enabledRegions: {
                shape: "S87"
              },
              environmentBlueprintId: {},
              manageAccessRoleArn: {},
              provisioningRoleArn: {},
              regionalParameters: {
                shape: "S89"
              },
              updatedAt: {
                shape: "S3u"
              }
            }
          }
        },
        GetEnvironmentProfile: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/environment-profiles/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "createdBy",
              "domainId",
              "environmentBlueprintId",
              "id",
              "name"
            ],
            members: {
              awsAccountId: {},
              awsAccountRegion: {},
              createdAt: {
                shape: "S3u"
              },
              createdBy: {},
              description: {
                shape: "Sp"
              },
              domainId: {},
              environmentBlueprintId: {},
              id: {},
              name: {
                shape: "S4k"
              },
              projectId: {},
              updatedAt: {
                shape: "S3u"
              },
              userParameters: {
                shape: "S4g"
              }
            }
          }
        },
        GetFormType: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/form-types/{formTypeIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "formTypeIdentifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              formTypeIdentifier: {
                location: "uri",
                locationName: "formTypeIdentifier"
              },
              revision: {
                location: "querystring",
                locationName: "revision"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "domainId",
              "model",
              "name",
              "revision"
            ],
            members: {
              createdAt: {
                type: "timestamp"
              },
              createdBy: {},
              description: {
                shape: "Sp"
              },
              domainId: {},
              imports: {
                shape: "S8f"
              },
              model: {
                shape: "S4n"
              },
              name: {
                shape: "S1s"
              },
              originDomainId: {},
              originProjectId: {},
              owningProjectId: {},
              revision: {},
              status: {}
            }
          }
        },
        GetGlossary: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/glossaries/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "domainId",
              "id",
              "name",
              "owningProjectId",
              "status"
            ],
            members: {
              createdAt: {
                type: "timestamp"
              },
              createdBy: {},
              description: {
                shape: "S4s"
              },
              domainId: {},
              id: {},
              name: {
                shape: "S4t"
              },
              owningProjectId: {},
              status: {},
              updatedAt: {
                type: "timestamp"
              },
              updatedBy: {}
            }
          }
        },
        GetGlossaryTerm: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/glossary-terms/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "domainId",
              "glossaryId",
              "id",
              "name",
              "status"
            ],
            members: {
              createdAt: {
                type: "timestamp"
              },
              createdBy: {},
              domainId: {},
              glossaryId: {},
              id: {},
              longDescription: {
                shape: "S4y"
              },
              name: {
                shape: "Sx"
              },
              shortDescription: {
                shape: "Sy"
              },
              status: {},
              termRelations: {
                shape: "S50"
              },
              updatedAt: {
                type: "timestamp"
              },
              updatedBy: {}
            }
          }
        },
        GetGroupProfile: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/group-profiles/{groupIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "groupIdentifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              groupIdentifier: {
                location: "uri",
                locationName: "groupIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              domainId: {},
              groupName: {
                shape: "S57"
              },
              id: {},
              status: {}
            }
          }
        },
        GetIamPortalLoginUrl: {
          http: {
            requestUri: "/v2/domains/{domainIdentifier}/get-portal-login-url",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "userProfileId"
            ],
            members: {
              authCodeUrl: {},
              userProfileId: {}
            }
          }
        },
        GetListing: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/listings/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              },
              listingRevision: {
                location: "querystring",
                locationName: "listingRevision"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "domainId",
              "id",
              "listingRevision"
            ],
            members: {
              createdAt: {
                type: "timestamp"
              },
              createdBy: {},
              description: {
                shape: "Sp"
              },
              domainId: {},
              id: {},
              item: {
                type: "structure",
                members: {
                  assetListing: {
                    type: "structure",
                    members: {
                      assetId: {},
                      assetRevision: {},
                      assetType: {},
                      createdAt: {
                        type: "timestamp"
                      },
                      forms: {},
                      glossaryTerms: {
                        shape: "Sv"
                      },
                      owningProjectId: {}
                    }
                  }
                },
                union: true
              },
              listingRevision: {},
              name: {},
              status: {},
              updatedAt: {
                type: "timestamp"
              },
              updatedBy: {}
            }
          }
        },
        GetProject: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/projects/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "createdBy",
              "domainId",
              "id",
              "name"
            ],
            members: {
              createdAt: {
                shape: "S3u"
              },
              createdBy: {},
              description: {
                shape: "Sp"
              },
              domainId: {},
              glossaryTerms: {
                shape: "S1j"
              },
              id: {},
              lastUpdatedAt: {
                shape: "S3u"
              },
              name: {
                shape: "S14"
              }
            }
          }
        },
        GetSubscription: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/subscriptions/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "createdAt",
              "createdBy",
              "domainId",
              "id",
              "status",
              "subscribedListing",
              "subscribedPrincipal",
              "updatedAt"
            ],
            members: {
              createdAt: {
                type: "timestamp"
              },
              createdBy: {},
              domainId: {},
              id: {},
              retainPermissions: {
                type: "boolean"
              },
              status: {},
              subscribedListing: {
                shape: "So"
              },
              subscribedPrincipal: {
                shape: "S12"
              },
              subscriptionRequestId: {},
              updatedAt: {
                type: "timestamp"
              },
              updatedBy: {}
            }
          }
        },
        GetSubscriptionGrant: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/subscription-grants/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "createdAt",
              "createdBy",
              "domainId",
              "grantedEntity",
              "id",
              "status",
              "subscriptionTargetId",
              "updatedAt"
            ],
            members: {
              assets: {
                shape: "S5s"
              },
              createdAt: {
                type: "timestamp"
              },
              createdBy: {},
              domainId: {},
              grantedEntity: {
                shape: "S5x"
              },
              id: {},
              status: {},
              subscriptionId: {},
              subscriptionTargetId: {},
              updatedAt: {
                type: "timestamp"
              },
              updatedBy: {}
            }
          }
        },
        GetSubscriptionRequestDetails: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/subscription-requests/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "createdAt",
              "createdBy",
              "domainId",
              "id",
              "requestReason",
              "status",
              "subscribedListings",
              "subscribedPrincipals",
              "updatedAt"
            ],
            members: {
              createdAt: {
                type: "timestamp"
              },
              createdBy: {},
              decisionComment: {
                shape: "Sg"
              },
              domainId: {},
              id: {},
              requestReason: {
                shape: "Sl"
              },
              reviewerId: {},
              status: {},
              subscribedListings: {
                type: "list",
                member: {
                  shape: "So"
                }
              },
              subscribedPrincipals: {
                type: "list",
                member: {
                  shape: "S12"
                }
              },
              updatedAt: {
                type: "timestamp"
              },
              updatedBy: {}
            }
          }
        },
        GetSubscriptionTarget: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/environments/{environmentIdentifier}/subscription-targets/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "environmentIdentifier",
              "identifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              environmentIdentifier: {
                location: "uri",
                locationName: "environmentIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "applicableAssetTypes",
              "authorizedPrincipals",
              "createdAt",
              "createdBy",
              "domainId",
              "environmentId",
              "id",
              "manageAccessRole",
              "name",
              "projectId",
              "provider",
              "subscriptionTargetConfig",
              "type"
            ],
            members: {
              applicableAssetTypes: {
                shape: "S6b"
              },
              authorizedPrincipals: {
                shape: "S6c"
              },
              createdAt: {
                type: "timestamp"
              },
              createdBy: {},
              domainId: {},
              environmentId: {},
              id: {},
              manageAccessRole: {},
              name: {
                shape: "S6e"
              },
              projectId: {},
              provider: {},
              subscriptionTargetConfig: {
                shape: "S6f"
              },
              type: {},
              updatedAt: {
                type: "timestamp"
              },
              updatedBy: {}
            }
          }
        },
        GetUserProfile: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/user-profiles/{userIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "userIdentifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              type: {
                location: "querystring",
                locationName: "type"
              },
              userIdentifier: {
                location: "uri",
                locationName: "userIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              details: {
                shape: "S6m"
              },
              domainId: {},
              id: {},
              status: {},
              type: {}
            }
          }
        },
        ListAssetRevisions: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/assets/{identifier}/revisions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    createdAt: {
                      type: "timestamp"
                    },
                    createdBy: {},
                    domainId: {},
                    id: {},
                    revision: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDataSourceRunActivities: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/data-source-runs/{identifier}/activities",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              status: {
                location: "querystring",
                locationName: "status"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "items"
            ],
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "createdAt",
                    "dataAssetStatus",
                    "dataSourceRunId",
                    "database",
                    "projectId",
                    "technicalName",
                    "updatedAt"
                  ],
                  members: {
                    createdAt: {
                      shape: "S35"
                    },
                    dataAssetId: {},
                    dataAssetStatus: {},
                    dataSourceRunId: {},
                    database: {
                      shape: "S2p"
                    },
                    errorMessage: {
                      shape: "S37"
                    },
                    projectId: {},
                    technicalDescription: {
                      shape: "Sp"
                    },
                    technicalName: {
                      shape: "S2p"
                    },
                    updatedAt: {
                      shape: "S35"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDataSourceRuns: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/data-sources/{dataSourceIdentifier}/runs",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "dataSourceIdentifier",
              "domainIdentifier"
            ],
            members: {
              dataSourceIdentifier: {
                location: "uri",
                locationName: "dataSourceIdentifier"
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              status: {
                location: "querystring",
                locationName: "status"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "items"
            ],
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "createdAt",
                    "dataSourceId",
                    "id",
                    "projectId",
                    "status",
                    "type",
                    "updatedAt"
                  ],
                  members: {
                    createdAt: {
                      shape: "S35"
                    },
                    dataSourceId: {},
                    errorMessage: {
                      shape: "S37"
                    },
                    id: {},
                    projectId: {},
                    runStatisticsForAssets: {
                      shape: "S7w"
                    },
                    startedAt: {
                      shape: "S35"
                    },
                    status: {},
                    stoppedAt: {
                      shape: "S35"
                    },
                    type: {},
                    updatedAt: {
                      shape: "S35"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDataSources: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/data-sources",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "projectIdentifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              environmentIdentifier: {
                location: "querystring",
                locationName: "environmentIdentifier"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              name: {
                shape: "S2p",
                location: "querystring",
                locationName: "name"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              projectIdentifier: {
                location: "querystring",
                locationName: "projectIdentifier"
              },
              status: {
                location: "querystring",
                locationName: "status"
              },
              type: {
                location: "querystring",
                locationName: "type"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "items"
            ],
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "dataSourceId",
                    "domainId",
                    "environmentId",
                    "name",
                    "status",
                    "type"
                  ],
                  members: {
                    createdAt: {
                      shape: "S35"
                    },
                    dataSourceId: {},
                    domainId: {},
                    enableSetting: {},
                    environmentId: {},
                    lastRunAssetCount: {
                      type: "integer"
                    },
                    lastRunAt: {
                      shape: "S35"
                    },
                    lastRunErrorMessage: {
                      shape: "S37"
                    },
                    lastRunStatus: {},
                    name: {
                      shape: "S2p"
                    },
                    schedule: {
                      shape: "S2r"
                    },
                    status: {},
                    type: {},
                    updatedAt: {
                      shape: "S35"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDomains: {
          http: {
            method: "GET",
            requestUri: "/v2/domains",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              status: {
                location: "querystring",
                locationName: "status"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "items"
            ],
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "id",
                    "managedAccountId",
                    "name",
                    "status"
                  ],
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    description: {
                      type: "string",
                      sensitive: true
                    },
                    id: {},
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    managedAccountId: {},
                    name: {
                      type: "string",
                      sensitive: true
                    },
                    portalUrl: {},
                    status: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListEnvironmentBlueprintConfigurations: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/environment-blueprint-configurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "domainId",
                    "environmentBlueprintId"
                  ],
                  members: {
                    createdAt: {
                      shape: "S3u"
                    },
                    domainId: {},
                    enabledRegions: {
                      shape: "S87"
                    },
                    environmentBlueprintId: {},
                    manageAccessRoleArn: {},
                    provisioningRoleArn: {},
                    regionalParameters: {
                      shape: "S89"
                    },
                    updatedAt: {
                      shape: "S3u"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListEnvironmentBlueprints: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/environment-blueprints",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              managed: {
                location: "querystring",
                locationName: "managed",
                type: "boolean"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              name: {
                location: "querystring",
                locationName: "name"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "items"
            ],
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "name",
                    "provider",
                    "provisioningProperties"
                  ],
                  members: {
                    createdAt: {
                      shape: "S3u"
                    },
                    description: {
                      shape: "Sp"
                    },
                    id: {},
                    name: {},
                    provider: {},
                    provisioningProperties: {
                      shape: "S4d"
                    },
                    updatedAt: {
                      shape: "S3u"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListEnvironmentProfiles: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/environment-profiles",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier"
            ],
            members: {
              awsAccountId: {
                location: "querystring",
                locationName: "awsAccountId"
              },
              awsAccountRegion: {
                location: "querystring",
                locationName: "awsAccountRegion"
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              environmentBlueprintIdentifier: {
                location: "querystring",
                locationName: "environmentBlueprintIdentifier"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              name: {
                shape: "S4k",
                location: "querystring",
                locationName: "name"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              projectIdentifier: {
                location: "querystring",
                locationName: "projectIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "items"
            ],
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "createdBy",
                    "domainId",
                    "environmentBlueprintId",
                    "id",
                    "name"
                  ],
                  members: {
                    awsAccountId: {},
                    awsAccountRegion: {},
                    createdAt: {
                      shape: "S3u"
                    },
                    createdBy: {},
                    description: {
                      shape: "Sp"
                    },
                    domainId: {},
                    environmentBlueprintId: {},
                    id: {},
                    name: {
                      shape: "S4k"
                    },
                    projectId: {},
                    updatedAt: {
                      shape: "S3u"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListEnvironments: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/environments",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "projectIdentifier"
            ],
            members: {
              awsAccountId: {
                location: "querystring",
                locationName: "awsAccountId"
              },
              awsAccountRegion: {
                location: "querystring",
                locationName: "awsAccountRegion"
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              environmentBlueprintIdentifier: {
                location: "querystring",
                locationName: "environmentBlueprintIdentifier"
              },
              environmentProfileIdentifier: {
                location: "querystring",
                locationName: "environmentProfileIdentifier"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              name: {
                location: "querystring",
                locationName: "name"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              projectIdentifier: {
                location: "querystring",
                locationName: "projectIdentifier"
              },
              provider: {
                location: "querystring",
                locationName: "provider"
              },
              status: {
                location: "querystring",
                locationName: "status"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "items"
            ],
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "createdBy",
                    "domainId",
                    "environmentProfileId",
                    "name",
                    "projectId",
                    "provider"
                  ],
                  members: {
                    awsAccountId: {},
                    awsAccountRegion: {},
                    createdAt: {
                      shape: "S3u"
                    },
                    createdBy: {},
                    description: {
                      shape: "Sp"
                    },
                    domainId: {},
                    environmentProfileId: {},
                    id: {},
                    name: {
                      shape: "S4a"
                    },
                    projectId: {},
                    provider: {},
                    status: {},
                    updatedAt: {
                      shape: "S3u"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListNotifications: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/notifications",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "type"
            ],
            members: {
              afterTimestamp: {
                location: "querystring",
                locationName: "afterTimestamp",
                type: "timestamp"
              },
              beforeTimestamp: {
                location: "querystring",
                locationName: "beforeTimestamp",
                type: "timestamp"
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              subjects: {
                location: "querystring",
                locationName: "subjects",
                type: "list",
                member: {}
              },
              taskStatus: {
                location: "querystring",
                locationName: "taskStatus"
              },
              type: {
                location: "querystring",
                locationName: "type"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              notifications: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "actionLink",
                    "creationTimestamp",
                    "domainIdentifier",
                    "identifier",
                    "lastUpdatedTimestamp",
                    "message",
                    "title",
                    "topic",
                    "type"
                  ],
                  members: {
                    actionLink: {
                      type: "string",
                      sensitive: true
                    },
                    creationTimestamp: {
                      type: "timestamp"
                    },
                    domainIdentifier: {},
                    identifier: {},
                    lastUpdatedTimestamp: {
                      type: "timestamp"
                    },
                    message: {
                      type: "string",
                      sensitive: true
                    },
                    metadata: {
                      type: "map",
                      key: {},
                      value: {}
                    },
                    status: {},
                    title: {
                      type: "string",
                      sensitive: true
                    },
                    topic: {
                      type: "structure",
                      required: [
                        "resource",
                        "role",
                        "subject"
                      ],
                      members: {
                        resource: {
                          type: "structure",
                          required: [
                            "id",
                            "type"
                          ],
                          members: {
                            id: {},
                            name: {},
                            type: {}
                          }
                        },
                        role: {},
                        subject: {}
                      }
                    },
                    type: {}
                  }
                }
              }
            }
          }
        },
        ListProjectMemberships: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/projects/{projectIdentifier}/memberships",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "projectIdentifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              projectIdentifier: {
                location: "uri",
                locationName: "projectIdentifier"
              },
              sortBy: {
                location: "querystring",
                locationName: "sortBy"
              },
              sortOrder: {
                location: "querystring",
                locationName: "sortOrder"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "members"
            ],
            members: {
              members: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "designation",
                    "memberDetails"
                  ],
                  members: {
                    designation: {},
                    memberDetails: {
                      type: "structure",
                      members: {
                        group: {
                          type: "structure",
                          required: [
                            "groupId"
                          ],
                          members: {
                            groupId: {}
                          }
                        },
                        user: {
                          type: "structure",
                          required: [
                            "userId"
                          ],
                          members: {
                            userId: {}
                          }
                        }
                      },
                      union: true
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListProjects: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/projects",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              groupIdentifier: {
                location: "querystring",
                locationName: "groupIdentifier"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              name: {
                shape: "S14",
                location: "querystring",
                locationName: "name"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              userIdentifier: {
                location: "querystring",
                locationName: "userIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "createdBy",
                    "domainId",
                    "id",
                    "name"
                  ],
                  members: {
                    createdAt: {
                      shape: "S3u"
                    },
                    createdBy: {},
                    description: {
                      shape: "Sp"
                    },
                    domainId: {},
                    id: {},
                    name: {
                      shape: "S14"
                    },
                    updatedAt: {
                      shape: "S3u"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSubscriptionGrants: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/subscription-grants",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              environmentId: {
                location: "querystring",
                locationName: "environmentId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              sortBy: {
                location: "querystring",
                locationName: "sortBy"
              },
              sortOrder: {
                location: "querystring",
                locationName: "sortOrder"
              },
              subscribedListingId: {
                location: "querystring",
                locationName: "subscribedListingId"
              },
              subscriptionId: {
                location: "querystring",
                locationName: "subscriptionId"
              },
              subscriptionTargetId: {
                location: "querystring",
                locationName: "subscriptionTargetId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "items"
            ],
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "createdAt",
                    "createdBy",
                    "domainId",
                    "grantedEntity",
                    "id",
                    "status",
                    "subscriptionTargetId",
                    "updatedAt"
                  ],
                  members: {
                    assets: {
                      shape: "S5s"
                    },
                    createdAt: {
                      type: "timestamp"
                    },
                    createdBy: {},
                    domainId: {},
                    grantedEntity: {
                      shape: "S5x"
                    },
                    id: {},
                    status: {},
                    subscriptionId: {},
                    subscriptionTargetId: {},
                    updatedAt: {
                      type: "timestamp"
                    },
                    updatedBy: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSubscriptionRequests: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/subscription-requests",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier"
            ],
            members: {
              approverProjectId: {
                location: "querystring",
                locationName: "approverProjectId"
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              owningProjectId: {
                location: "querystring",
                locationName: "owningProjectId"
              },
              sortBy: {
                location: "querystring",
                locationName: "sortBy"
              },
              sortOrder: {
                location: "querystring",
                locationName: "sortOrder"
              },
              status: {
                location: "querystring",
                locationName: "status"
              },
              subscribedListingId: {
                location: "querystring",
                locationName: "subscribedListingId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "items"
            ],
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "createdAt",
                    "createdBy",
                    "domainId",
                    "id",
                    "requestReason",
                    "status",
                    "subscribedListings",
                    "subscribedPrincipals",
                    "updatedAt"
                  ],
                  members: {
                    createdAt: {
                      type: "timestamp"
                    },
                    createdBy: {},
                    decisionComment: {
                      shape: "Sg"
                    },
                    domainId: {},
                    id: {},
                    requestReason: {
                      shape: "Sl"
                    },
                    reviewerId: {},
                    status: {},
                    subscribedListings: {
                      type: "list",
                      member: {
                        shape: "So"
                      }
                    },
                    subscribedPrincipals: {
                      type: "list",
                      member: {
                        shape: "S12"
                      }
                    },
                    updatedAt: {
                      type: "timestamp"
                    },
                    updatedBy: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSubscriptionTargets: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/environments/{environmentIdentifier}/subscription-targets",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "environmentIdentifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              environmentIdentifier: {
                location: "uri",
                locationName: "environmentIdentifier"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              sortBy: {
                location: "querystring",
                locationName: "sortBy"
              },
              sortOrder: {
                location: "querystring",
                locationName: "sortOrder"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "items"
            ],
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "applicableAssetTypes",
                    "authorizedPrincipals",
                    "createdAt",
                    "createdBy",
                    "domainId",
                    "environmentId",
                    "id",
                    "manageAccessRole",
                    "name",
                    "projectId",
                    "provider",
                    "subscriptionTargetConfig",
                    "type"
                  ],
                  members: {
                    applicableAssetTypes: {
                      shape: "S6b"
                    },
                    authorizedPrincipals: {
                      shape: "S6c"
                    },
                    createdAt: {
                      type: "timestamp"
                    },
                    createdBy: {},
                    domainId: {},
                    environmentId: {},
                    id: {},
                    manageAccessRole: {},
                    name: {
                      shape: "S6e"
                    },
                    projectId: {},
                    provider: {},
                    subscriptionTargetConfig: {
                      shape: "S6f"
                    },
                    type: {},
                    updatedAt: {
                      type: "timestamp"
                    },
                    updatedBy: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSubscriptions: {
          http: {
            method: "GET",
            requestUri: "/v2/domains/{domainIdentifier}/subscriptions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier"
            ],
            members: {
              approverProjectId: {
                location: "querystring",
                locationName: "approverProjectId"
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              owningProjectId: {
                location: "querystring",
                locationName: "owningProjectId"
              },
              sortBy: {
                location: "querystring",
                locationName: "sortBy"
              },
              sortOrder: {
                location: "querystring",
                locationName: "sortOrder"
              },
              status: {
                location: "querystring",
                locationName: "status"
              },
              subscribedListingId: {
                location: "querystring",
                locationName: "subscribedListingId"
              },
              subscriptionRequestIdentifier: {
                location: "querystring",
                locationName: "subscriptionRequestIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "items"
            ],
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "createdAt",
                    "createdBy",
                    "domainId",
                    "id",
                    "status",
                    "subscribedListing",
                    "subscribedPrincipal",
                    "updatedAt"
                  ],
                  members: {
                    createdAt: {
                      type: "timestamp"
                    },
                    createdBy: {},
                    domainId: {},
                    id: {},
                    retainPermissions: {
                      type: "boolean"
                    },
                    status: {},
                    subscribedListing: {
                      shape: "So"
                    },
                    subscribedPrincipal: {
                      shape: "S12"
                    },
                    subscriptionRequestId: {},
                    updatedAt: {
                      type: "timestamp"
                    },
                    updatedBy: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S3i"
              }
            }
          }
        },
        PutEnvironmentBlueprintConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/v2/domains/{domainIdentifier}/environment-blueprint-configurations/{environmentBlueprintIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "enabledRegions",
              "environmentBlueprintIdentifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              enabledRegions: {
                shape: "S87"
              },
              environmentBlueprintIdentifier: {
                location: "uri",
                locationName: "environmentBlueprintIdentifier"
              },
              manageAccessRoleArn: {},
              provisioningRoleArn: {},
              regionalParameters: {
                shape: "S89"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "domainId",
              "environmentBlueprintId"
            ],
            members: {
              createdAt: {
                shape: "S3u"
              },
              domainId: {},
              enabledRegions: {
                shape: "S87"
              },
              environmentBlueprintId: {},
              manageAccessRoleArn: {},
              provisioningRoleArn: {},
              regionalParameters: {
                shape: "S89"
              },
              updatedAt: {
                shape: "S3u"
              }
            }
          },
          idempotent: true
        },
        RejectPredictions: {
          http: {
            method: "PUT",
            requestUri: "/v2/domains/{domainIdentifier}/assets/{identifier}/reject-predictions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              },
              rejectChoices: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    predictionChoices: {
                      type: "list",
                      member: {
                        type: "integer"
                      }
                    },
                    predictionTarget: {}
                  }
                }
              },
              rejectRule: {
                type: "structure",
                members: {
                  rule: {},
                  threshold: {
                    type: "float"
                  }
                }
              },
              revision: {
                location: "querystring",
                locationName: "revision"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetId",
              "assetRevision",
              "domainId"
            ],
            members: {
              assetId: {},
              assetRevision: {},
              domainId: {}
            }
          },
          idempotent: true
        },
        RejectSubscriptionRequest: {
          http: {
            method: "PUT",
            requestUri: "/v2/domains/{domainIdentifier}/subscription-requests/{identifier}/reject",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              decisionComment: {
                shape: "Sg"
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "createdAt",
              "createdBy",
              "domainId",
              "id",
              "requestReason",
              "status",
              "subscribedListings",
              "subscribedPrincipals",
              "updatedAt"
            ],
            members: {
              createdAt: {
                type: "timestamp"
              },
              createdBy: {},
              decisionComment: {
                shape: "Sg"
              },
              domainId: {},
              id: {},
              requestReason: {
                shape: "Sl"
              },
              reviewerId: {},
              status: {},
              subscribedListings: {
                type: "list",
                member: {
                  shape: "So"
                }
              },
              subscribedPrincipals: {
                type: "list",
                member: {
                  shape: "S12"
                }
              },
              updatedAt: {
                type: "timestamp"
              },
              updatedBy: {}
            }
          },
          idempotent: true
        },
        RevokeSubscription: {
          http: {
            method: "PUT",
            requestUri: "/v2/domains/{domainIdentifier}/subscriptions/{identifier}/revoke",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              },
              retainPermissions: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "createdAt",
              "createdBy",
              "domainId",
              "id",
              "status",
              "subscribedListing",
              "subscribedPrincipal",
              "updatedAt"
            ],
            members: {
              createdAt: {
                type: "timestamp"
              },
              createdBy: {},
              domainId: {},
              id: {},
              retainPermissions: {
                type: "boolean"
              },
              status: {},
              subscribedListing: {
                shape: "So"
              },
              subscribedPrincipal: {
                shape: "S12"
              },
              subscriptionRequestId: {},
              updatedAt: {
                type: "timestamp"
              },
              updatedBy: {}
            }
          },
          idempotent: true
        },
        Search: {
          http: {
            requestUri: "/v2/domains/{domainIdentifier}/search",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "searchScope"
            ],
            members: {
              additionalAttributes: {
                shape: "Sc7"
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              filters: {
                shape: "Sc9"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              owningProjectIdentifier: {},
              searchIn: {
                shape: "Sce"
              },
              searchScope: {},
              searchText: {},
              sort: {
                shape: "Sci"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    assetItem: {
                      type: "structure",
                      required: [
                        "domainId",
                        "identifier",
                        "name",
                        "owningProjectId",
                        "typeIdentifier",
                        "typeRevision"
                      ],
                      members: {
                        additionalAttributes: {
                          type: "structure",
                          members: {
                            formsOutput: {
                              shape: "S1q"
                            },
                            readOnlyFormsOutput: {
                              shape: "S1q"
                            }
                          }
                        },
                        createdAt: {
                          type: "timestamp"
                        },
                        createdBy: {},
                        description: {
                          shape: "Sp"
                        },
                        domainId: {},
                        externalIdentifier: {
                          shape: "S1d"
                        },
                        firstRevisionCreatedAt: {
                          type: "timestamp"
                        },
                        firstRevisionCreatedBy: {},
                        glossaryTerms: {
                          shape: "S1j"
                        },
                        identifier: {},
                        name: {
                          shape: "S1l"
                        },
                        owningProjectId: {},
                        typeIdentifier: {},
                        typeRevision: {}
                      }
                    },
                    dataProductItem: {
                      type: "structure",
                      required: [
                        "domainId",
                        "id",
                        "name",
                        "owningProjectId"
                      ],
                      members: {
                        createdAt: {
                          type: "timestamp"
                        },
                        createdBy: {},
                        dataProductItems: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              domainId: {},
                              itemId: {}
                            }
                          }
                        },
                        description: {
                          type: "string",
                          sensitive: true
                        },
                        domainId: {},
                        glossaryTerms: {
                          shape: "S1j"
                        },
                        id: {},
                        name: {
                          type: "string",
                          sensitive: true
                        },
                        owningProjectId: {},
                        updatedAt: {
                          type: "timestamp"
                        },
                        updatedBy: {}
                      }
                    },
                    glossaryItem: {
                      type: "structure",
                      required: [
                        "domainId",
                        "id",
                        "name",
                        "owningProjectId",
                        "status"
                      ],
                      members: {
                        createdAt: {
                          type: "timestamp"
                        },
                        createdBy: {},
                        description: {
                          shape: "S4s"
                        },
                        domainId: {},
                        id: {},
                        name: {
                          shape: "S4t"
                        },
                        owningProjectId: {},
                        status: {},
                        updatedAt: {
                          type: "timestamp"
                        },
                        updatedBy: {}
                      }
                    },
                    glossaryTermItem: {
                      type: "structure",
                      required: [
                        "domainId",
                        "glossaryId",
                        "id",
                        "name",
                        "status"
                      ],
                      members: {
                        createdAt: {
                          type: "timestamp"
                        },
                        createdBy: {},
                        domainId: {},
                        glossaryId: {},
                        id: {},
                        longDescription: {
                          shape: "S4y"
                        },
                        name: {
                          shape: "Sx"
                        },
                        shortDescription: {
                          shape: "Sy"
                        },
                        status: {},
                        termRelations: {
                          shape: "S50"
                        },
                        updatedAt: {
                          type: "timestamp"
                        },
                        updatedBy: {}
                      }
                    }
                  },
                  union: true
                }
              },
              nextToken: {},
              totalMatchCount: {
                type: "integer"
              }
            }
          }
        },
        SearchGroupProfiles: {
          http: {
            requestUri: "/v2/domains/{domainIdentifier}/search-group-profiles",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "groupType"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              groupType: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              searchText: {
                type: "string",
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    domainId: {},
                    groupName: {
                      shape: "S57"
                    },
                    id: {},
                    status: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        SearchListings: {
          http: {
            requestUri: "/v2/domains/{domainIdentifier}/listings/search",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier"
            ],
            members: {
              additionalAttributes: {
                shape: "Sc7"
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              filters: {
                shape: "Sc9"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              searchIn: {
                shape: "Sce"
              },
              searchText: {},
              sort: {
                shape: "Sci"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    assetListing: {
                      type: "structure",
                      members: {
                        additionalAttributes: {
                          type: "structure",
                          members: {
                            forms: {}
                          }
                        },
                        createdAt: {
                          type: "timestamp"
                        },
                        description: {
                          shape: "Sp"
                        },
                        entityId: {},
                        entityRevision: {},
                        entityType: {},
                        glossaryTerms: {
                          shape: "Sv"
                        },
                        listingCreatedBy: {},
                        listingId: {},
                        listingRevision: {},
                        listingUpdatedBy: {},
                        name: {
                          shape: "S1l"
                        },
                        owningProjectId: {}
                      }
                    }
                  },
                  union: true
                }
              },
              nextToken: {},
              totalMatchCount: {
                type: "integer"
              }
            }
          }
        },
        SearchTypes: {
          http: {
            requestUri: "/v2/domains/{domainIdentifier}/types-search",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "managed",
              "searchScope"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              filters: {
                shape: "Sc9"
              },
              managed: {
                type: "boolean"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              searchIn: {
                shape: "Sce"
              },
              searchScope: {},
              searchText: {},
              sort: {
                shape: "Sci"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    assetTypeItem: {
                      type: "structure",
                      required: [
                        "domainId",
                        "formsOutput",
                        "name",
                        "owningProjectId",
                        "revision"
                      ],
                      members: {
                        createdAt: {
                          type: "timestamp"
                        },
                        createdBy: {},
                        description: {
                          shape: "Sp"
                        },
                        domainId: {},
                        formsOutput: {
                          shape: "S21"
                        },
                        name: {},
                        originDomainId: {},
                        originProjectId: {},
                        owningProjectId: {},
                        revision: {},
                        updatedAt: {
                          type: "timestamp"
                        },
                        updatedBy: {}
                      }
                    },
                    formTypeItem: {
                      type: "structure",
                      required: [
                        "domainId",
                        "name",
                        "revision"
                      ],
                      members: {
                        createdAt: {
                          type: "timestamp"
                        },
                        createdBy: {},
                        description: {
                          shape: "Sp"
                        },
                        domainId: {},
                        imports: {
                          shape: "S8f"
                        },
                        model: {
                          shape: "S4n"
                        },
                        name: {
                          shape: "S1s"
                        },
                        originDomainId: {},
                        originProjectId: {},
                        owningProjectId: {},
                        revision: {},
                        status: {}
                      }
                    }
                  },
                  union: true
                }
              },
              nextToken: {},
              totalMatchCount: {
                type: "integer"
              }
            }
          }
        },
        SearchUserProfiles: {
          http: {
            requestUri: "/v2/domains/{domainIdentifier}/search-user-profiles",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "userType"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              searchText: {
                type: "string",
                sensitive: true
              },
              userType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    details: {
                      shape: "S6m"
                    },
                    domainId: {},
                    id: {},
                    status: {},
                    type: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        StartDataSourceRun: {
          http: {
            requestUri: "/v2/domains/{domainIdentifier}/data-sources/{dataSourceIdentifier}/runs",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "dataSourceIdentifier",
              "domainIdentifier"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              dataSourceIdentifier: {
                location: "uri",
                locationName: "dataSourceIdentifier"
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "createdAt",
              "dataSourceId",
              "domainId",
              "id",
              "projectId",
              "status",
              "type",
              "updatedAt"
            ],
            members: {
              createdAt: {
                shape: "S35"
              },
              dataSourceConfigurationSnapshot: {},
              dataSourceId: {},
              domainId: {},
              errorMessage: {
                shape: "S37"
              },
              id: {},
              projectId: {},
              runStatisticsForAssets: {
                shape: "S7w"
              },
              startedAt: {
                shape: "S35"
              },
              status: {},
              stoppedAt: {
                shape: "S35"
              },
              type: {},
              updatedAt: {
                shape: "S35"
              }
            }
          },
          idempotent: true
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S3i"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateDataSource: {
          http: {
            method: "PATCH",
            requestUri: "/v2/domains/{domainIdentifier}/data-sources/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              assetFormsInput: {
                shape: "S1e"
              },
              configuration: {
                shape: "S24"
              },
              description: {
                shape: "Sp"
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              enableSetting: {},
              identifier: {
                location: "uri",
                locationName: "identifier"
              },
              name: {
                shape: "S2p"
              },
              publishOnImport: {
                type: "boolean"
              },
              recommendation: {
                shape: "S2q"
              },
              schedule: {
                shape: "S2r"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "domainId",
              "environmentId",
              "id",
              "name",
              "projectId"
            ],
            members: {
              assetFormsOutput: {
                shape: "S1q"
              },
              configuration: {
                shape: "S2w"
              },
              createdAt: {
                shape: "S35"
              },
              description: {
                shape: "Sp"
              },
              domainId: {},
              enableSetting: {},
              environmentId: {},
              errorMessage: {
                shape: "S37"
              },
              id: {},
              lastRunAt: {
                shape: "S35"
              },
              lastRunErrorMessage: {
                shape: "S37"
              },
              lastRunStatus: {},
              name: {
                shape: "S2p"
              },
              projectId: {},
              publishOnImport: {
                type: "boolean"
              },
              recommendation: {
                shape: "S2q"
              },
              schedule: {
                shape: "S2r"
              },
              status: {},
              type: {},
              updatedAt: {
                shape: "S35"
              }
            }
          },
          idempotent: true
        },
        UpdateDomain: {
          http: {
            method: "PUT",
            requestUri: "/v2/domains/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "identifier"
            ],
            members: {
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              },
              description: {},
              domainExecutionRole: {},
              identifier: {
                location: "uri",
                locationName: "identifier"
              },
              name: {},
              singleSignOn: {
                shape: "S3f"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              description: {},
              domainExecutionRole: {},
              id: {},
              lastUpdatedAt: {
                type: "timestamp"
              },
              name: {},
              singleSignOn: {
                shape: "S3f"
              }
            }
          },
          idempotent: true
        },
        UpdateEnvironment: {
          http: {
            method: "PATCH",
            requestUri: "/v2/domains/{domainIdentifier}/environments/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              description: {},
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              glossaryTerms: {
                shape: "S1j"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              },
              name: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "createdBy",
              "domainId",
              "environmentProfileId",
              "name",
              "projectId",
              "provider"
            ],
            members: {
              awsAccountId: {},
              awsAccountRegion: {},
              createdAt: {
                shape: "S3u"
              },
              createdBy: {},
              deploymentProperties: {
                shape: "S3v"
              },
              description: {
                shape: "Sp"
              },
              domainId: {},
              environmentActions: {
                shape: "S3y"
              },
              environmentBlueprintId: {},
              environmentProfileId: {},
              glossaryTerms: {
                shape: "S1j"
              },
              id: {},
              lastDeployment: {
                shape: "S44"
              },
              name: {
                shape: "S4a"
              },
              projectId: {},
              provider: {},
              provisionedResources: {
                shape: "S4b"
              },
              provisioningProperties: {
                shape: "S4d"
              },
              status: {},
              updatedAt: {
                shape: "S3u"
              },
              userParameters: {
                shape: "S4g"
              }
            }
          }
        },
        UpdateEnvironmentProfile: {
          http: {
            method: "PATCH",
            requestUri: "/v2/domains/{domainIdentifier}/environment-profiles/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              awsAccountId: {},
              awsAccountRegion: {},
              description: {},
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              },
              name: {
                shape: "S4k"
              },
              userParameters: {
                shape: "S3p"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "createdBy",
              "domainId",
              "environmentBlueprintId",
              "id",
              "name"
            ],
            members: {
              awsAccountId: {},
              awsAccountRegion: {},
              createdAt: {
                shape: "S3u"
              },
              createdBy: {},
              description: {
                shape: "Sp"
              },
              domainId: {},
              environmentBlueprintId: {},
              id: {},
              name: {
                shape: "S4k"
              },
              projectId: {},
              updatedAt: {
                shape: "S3u"
              },
              userParameters: {
                shape: "S4g"
              }
            }
          }
        },
        UpdateGlossary: {
          http: {
            method: "PATCH",
            requestUri: "/v2/domains/{domainIdentifier}/glossaries/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              description: {
                shape: "S4s"
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              },
              name: {
                shape: "S4t"
              },
              status: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "domainId",
              "id",
              "name",
              "owningProjectId"
            ],
            members: {
              description: {
                shape: "S4s"
              },
              domainId: {},
              id: {},
              name: {
                shape: "S4t"
              },
              owningProjectId: {},
              status: {}
            }
          },
          idempotent: true
        },
        UpdateGlossaryTerm: {
          http: {
            method: "PATCH",
            requestUri: "/v2/domains/{domainIdentifier}/glossary-terms/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              glossaryIdentifier: {},
              identifier: {
                location: "uri",
                locationName: "identifier"
              },
              longDescription: {
                shape: "S4y"
              },
              name: {
                shape: "Sx"
              },
              shortDescription: {
                shape: "Sy"
              },
              status: {},
              termRelations: {
                shape: "S50"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "domainId",
              "glossaryId",
              "id",
              "name",
              "status"
            ],
            members: {
              domainId: {},
              glossaryId: {},
              id: {},
              longDescription: {
                shape: "S4y"
              },
              name: {
                shape: "Sx"
              },
              shortDescription: {
                shape: "Sy"
              },
              status: {},
              termRelations: {
                shape: "S50"
              }
            }
          },
          idempotent: true
        },
        UpdateGroupProfile: {
          http: {
            method: "PUT",
            requestUri: "/v2/domains/{domainIdentifier}/group-profiles/{groupIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "groupIdentifier",
              "status"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              groupIdentifier: {
                location: "uri",
                locationName: "groupIdentifier"
              },
              status: {}
            }
          },
          output: {
            type: "structure",
            members: {
              domainId: {},
              groupName: {
                shape: "S57"
              },
              id: {},
              status: {}
            }
          }
        },
        UpdateProject: {
          http: {
            method: "PATCH",
            requestUri: "/v2/domains/{domainIdentifier}/projects/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier"
            ],
            members: {
              description: {
                shape: "Sp"
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              glossaryTerms: {
                shape: "S1j"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              },
              name: {
                shape: "S14"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "createdBy",
              "domainId",
              "id",
              "name"
            ],
            members: {
              createdAt: {
                shape: "S3u"
              },
              createdBy: {},
              description: {
                shape: "Sp"
              },
              domainId: {},
              glossaryTerms: {
                shape: "S1j"
              },
              id: {},
              lastUpdatedAt: {
                shape: "S3u"
              },
              name: {
                shape: "S14"
              }
            }
          },
          idempotent: true
        },
        UpdateSubscriptionGrantStatus: {
          http: {
            method: "PATCH",
            requestUri: "/v2/domains/{domainIdentifier}/subscription-grants/{identifier}/status/{assetIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assetIdentifier",
              "domainIdentifier",
              "identifier",
              "status"
            ],
            members: {
              assetIdentifier: {
                location: "uri",
                locationName: "assetIdentifier"
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              failureCause: {
                shape: "S5u"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              },
              status: {},
              targetName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "createdAt",
              "createdBy",
              "domainId",
              "grantedEntity",
              "id",
              "status",
              "subscriptionTargetId",
              "updatedAt"
            ],
            members: {
              assets: {
                shape: "S5s"
              },
              createdAt: {
                type: "timestamp"
              },
              createdBy: {},
              domainId: {},
              grantedEntity: {
                shape: "S5x"
              },
              id: {},
              status: {},
              subscriptionId: {},
              subscriptionTargetId: {},
              updatedAt: {
                type: "timestamp"
              },
              updatedBy: {}
            }
          },
          idempotent: true
        },
        UpdateSubscriptionRequest: {
          http: {
            method: "PATCH",
            requestUri: "/v2/domains/{domainIdentifier}/subscription-requests/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "identifier",
              "requestReason"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              },
              requestReason: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "createdAt",
              "createdBy",
              "domainId",
              "id",
              "requestReason",
              "status",
              "subscribedListings",
              "subscribedPrincipals",
              "updatedAt"
            ],
            members: {
              createdAt: {
                type: "timestamp"
              },
              createdBy: {},
              decisionComment: {
                shape: "Sg"
              },
              domainId: {},
              id: {},
              requestReason: {
                shape: "Sl"
              },
              reviewerId: {},
              status: {},
              subscribedListings: {
                type: "list",
                member: {
                  shape: "So"
                }
              },
              subscribedPrincipals: {
                type: "list",
                member: {
                  shape: "S12"
                }
              },
              updatedAt: {
                type: "timestamp"
              },
              updatedBy: {}
            }
          },
          idempotent: true
        },
        UpdateSubscriptionTarget: {
          http: {
            method: "PATCH",
            requestUri: "/v2/domains/{domainIdentifier}/environments/{environmentIdentifier}/subscription-targets/{identifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "environmentIdentifier",
              "identifier"
            ],
            members: {
              applicableAssetTypes: {
                shape: "S6b"
              },
              authorizedPrincipals: {
                shape: "S6c"
              },
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              environmentIdentifier: {
                location: "uri",
                locationName: "environmentIdentifier"
              },
              identifier: {
                location: "uri",
                locationName: "identifier"
              },
              manageAccessRole: {},
              name: {
                shape: "S6e"
              },
              provider: {},
              subscriptionTargetConfig: {
                shape: "S6f"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "applicableAssetTypes",
              "authorizedPrincipals",
              "createdAt",
              "createdBy",
              "domainId",
              "environmentId",
              "id",
              "manageAccessRole",
              "name",
              "projectId",
              "provider",
              "subscriptionTargetConfig",
              "type"
            ],
            members: {
              applicableAssetTypes: {
                shape: "S6b"
              },
              authorizedPrincipals: {
                shape: "S6c"
              },
              createdAt: {
                type: "timestamp"
              },
              createdBy: {},
              domainId: {},
              environmentId: {},
              id: {},
              manageAccessRole: {},
              name: {
                shape: "S6e"
              },
              projectId: {},
              provider: {},
              subscriptionTargetConfig: {
                shape: "S6f"
              },
              type: {},
              updatedAt: {
                type: "timestamp"
              },
              updatedBy: {}
            }
          },
          idempotent: true
        },
        UpdateUserProfile: {
          http: {
            method: "PUT",
            requestUri: "/v2/domains/{domainIdentifier}/user-profiles/{userIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "domainIdentifier",
              "status",
              "userIdentifier"
            ],
            members: {
              domainIdentifier: {
                location: "uri",
                locationName: "domainIdentifier"
              },
              status: {},
              type: {},
              userIdentifier: {
                location: "uri",
                locationName: "userIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              details: {
                shape: "S6m"
              },
              domainId: {},
              id: {},
              status: {},
              type: {}
            }
          }
        }
      },
      shapes: {
        Sg: {
          type: "string",
          sensitive: true
        },
        Sl: {
          type: "string",
          sensitive: true
        },
        So: {
          type: "structure",
          required: [
            "description",
            "id",
            "item",
            "name",
            "ownerProjectId"
          ],
          members: {
            description: {
              shape: "Sp"
            },
            id: {},
            item: {
              type: "structure",
              members: {
                assetListing: {
                  type: "structure",
                  members: {
                    entityId: {},
                    entityRevision: {},
                    entityType: {},
                    forms: {},
                    glossaryTerms: {
                      shape: "Sv"
                    }
                  }
                }
              },
              union: true
            },
            name: {},
            ownerProjectId: {},
            ownerProjectName: {},
            revision: {}
          }
        },
        Sp: {
          type: "string",
          sensitive: true
        },
        Sv: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {
                shape: "Sx"
              },
              shortDescription: {
                shape: "Sy"
              }
            }
          }
        },
        Sx: {
          type: "string",
          sensitive: true
        },
        Sy: {
          type: "string",
          sensitive: true
        },
        S12: {
          type: "structure",
          members: {
            project: {
              type: "structure",
              members: {
                id: {},
                name: {
                  shape: "S14"
                }
              }
            }
          },
          union: true
        },
        S14: {
          type: "string",
          sensitive: true
        },
        S1d: {
          type: "string",
          sensitive: true
        },
        S1e: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "formName"
            ],
            members: {
              content: {},
              formName: {},
              typeIdentifier: {},
              typeRevision: {}
            },
            sensitive: true
          },
          sensitive: true
        },
        S1j: {
          type: "list",
          member: {}
        },
        S1l: {
          type: "string",
          sensitive: true
        },
        S1m: {
          type: "structure",
          members: {
            businessNameGeneration: {
              type: "structure",
              members: {
                enabled: {
                  type: "boolean"
                }
              }
            }
          }
        },
        S1q: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "formName"
            ],
            members: {
              content: {},
              formName: {},
              typeName: {
                shape: "S1s"
              },
              typeRevision: {}
            }
          }
        },
        S1s: {
          type: "string",
          sensitive: true
        },
        S1t: {
          type: "structure",
          required: [
            "listingId",
            "listingStatus"
          ],
          members: {
            listingId: {},
            listingStatus: {}
          }
        },
        S21: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "typeName",
              "typeRevision"
            ],
            members: {
              required: {
                type: "boolean"
              },
              typeName: {
                shape: "S1s"
              },
              typeRevision: {}
            }
          }
        },
        S24: {
          type: "structure",
          members: {
            glueRunConfiguration: {
              type: "structure",
              required: [
                "relationalFilterConfigurations"
              ],
              members: {
                dataAccessRole: {},
                relationalFilterConfigurations: {
                  shape: "S27"
                }
              }
            },
            redshiftRunConfiguration: {
              type: "structure",
              required: [
                "redshiftCredentialConfiguration",
                "redshiftStorage",
                "relationalFilterConfigurations"
              ],
              members: {
                dataAccessRole: {},
                redshiftCredentialConfiguration: {
                  shape: "S2h"
                },
                redshiftStorage: {
                  shape: "S2j"
                },
                relationalFilterConfigurations: {
                  shape: "S27"
                }
              }
            }
          },
          union: true
        },
        S27: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "databaseName"
            ],
            members: {
              databaseName: {},
              filterExpressions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "expression",
                    "type"
                  ],
                  members: {
                    expression: {},
                    type: {}
                  }
                }
              },
              schemaName: {}
            }
          }
        },
        S2h: {
          type: "structure",
          required: [
            "secretManagerArn"
          ],
          members: {
            secretManagerArn: {}
          }
        },
        S2j: {
          type: "structure",
          members: {
            redshiftClusterSource: {
              type: "structure",
              required: [
                "clusterName"
              ],
              members: {
                clusterName: {}
              }
            },
            redshiftServerlessSource: {
              type: "structure",
              required: [
                "workgroupName"
              ],
              members: {
                workgroupName: {}
              }
            }
          },
          union: true
        },
        S2p: {
          type: "string",
          sensitive: true
        },
        S2q: {
          type: "structure",
          members: {
            enableBusinessNameGeneration: {
              type: "boolean"
            }
          }
        },
        S2r: {
          type: "structure",
          members: {
            schedule: {},
            timezone: {}
          },
          sensitive: true
        },
        S2w: {
          type: "structure",
          members: {
            glueRunConfiguration: {
              type: "structure",
              required: [
                "relationalFilterConfigurations"
              ],
              members: {
                accountId: {},
                dataAccessRole: {},
                region: {},
                relationalFilterConfigurations: {
                  shape: "S27"
                }
              }
            },
            redshiftRunConfiguration: {
              type: "structure",
              required: [
                "redshiftCredentialConfiguration",
                "redshiftStorage",
                "relationalFilterConfigurations"
              ],
              members: {
                accountId: {},
                dataAccessRole: {},
                redshiftCredentialConfiguration: {
                  shape: "S2h"
                },
                redshiftStorage: {
                  shape: "S2j"
                },
                region: {},
                relationalFilterConfigurations: {
                  shape: "S27"
                }
              }
            }
          },
          union: true
        },
        S35: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S37: {
          type: "structure",
          required: [
            "errorType"
          ],
          members: {
            errorDetail: {},
            errorType: {}
          }
        },
        S3f: {
          type: "structure",
          members: {
            type: {},
            userAssignment: {}
          }
        },
        S3i: {
          type: "map",
          key: {},
          value: {}
        },
        S3p: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              value: {}
            }
          }
        },
        S3u: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S3v: {
          type: "structure",
          members: {
            endTimeoutMinutes: {
              type: "integer"
            },
            startTimeoutMinutes: {
              type: "integer"
            }
          }
        },
        S3y: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "parameters",
              "type"
            ],
            members: {
              auth: {},
              parameters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    key: {},
                    value: {}
                  }
                }
              },
              type: {}
            }
          }
        },
        S44: {
          type: "structure",
          members: {
            deploymentId: {},
            deploymentStatus: {},
            deploymentType: {},
            failureReason: {
              type: "structure",
              required: [
                "message"
              ],
              members: {
                code: {},
                message: {}
              }
            },
            isDeploymentComplete: {
              type: "boolean"
            },
            messages: {
              type: "list",
              member: {}
            }
          }
        },
        S4a: {
          type: "string",
          sensitive: true
        },
        S4b: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "type",
              "value"
            ],
            members: {
              name: {},
              provider: {},
              type: {},
              value: {}
            }
          }
        },
        S4d: {
          type: "structure",
          members: {
            cloudFormation: {
              type: "structure",
              required: [
                "templateUrl"
              ],
              members: {
                templateUrl: {}
              }
            }
          },
          union: true
        },
        S4g: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "fieldType",
              "keyName"
            ],
            members: {
              defaultValue: {},
              description: {
                shape: "Sp"
              },
              fieldType: {},
              isEditable: {
                type: "boolean"
              },
              isOptional: {
                type: "boolean"
              },
              keyName: {}
            }
          }
        },
        S4k: {
          type: "string",
          sensitive: true
        },
        S4n: {
          type: "structure",
          members: {
            smithy: {}
          },
          sensitive: true,
          union: true
        },
        S4s: {
          type: "string",
          sensitive: true
        },
        S4t: {
          type: "string",
          sensitive: true
        },
        S4y: {
          type: "string",
          sensitive: true
        },
        S50: {
          type: "structure",
          members: {
            classifies: {
              type: "list",
              member: {}
            },
            isA: {
              type: "list",
              member: {}
            }
          }
        },
        S57: {
          type: "string",
          sensitive: true
        },
        S5j: {
          type: "structure",
          members: {
            groupIdentifier: {},
            userIdentifier: {}
          },
          union: true
        },
        S5s: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "assetId",
              "assetRevision",
              "status"
            ],
            members: {
              assetId: {},
              assetRevision: {},
              failureCause: {
                shape: "S5u"
              },
              failureTimestamp: {
                type: "timestamp"
              },
              grantedTimestamp: {
                type: "timestamp"
              },
              status: {},
              targetName: {}
            }
          }
        },
        S5u: {
          type: "structure",
          members: {
            message: {}
          }
        },
        S5x: {
          type: "structure",
          members: {
            listing: {
              type: "structure",
              required: [
                "id",
                "revision"
              ],
              members: {
                id: {},
                revision: {}
              }
            }
          },
          union: true
        },
        S6b: {
          type: "list",
          member: {}
        },
        S6c: {
          type: "list",
          member: {}
        },
        S6e: {
          type: "string",
          sensitive: true
        },
        S6f: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "content",
              "formName"
            ],
            members: {
              content: {},
              formName: {}
            }
          }
        },
        S6m: {
          type: "structure",
          members: {
            iam: {
              type: "structure",
              members: {
                arn: {}
              }
            },
            sso: {
              type: "structure",
              members: {
                firstName: {
                  type: "string",
                  sensitive: true
                },
                lastName: {
                  type: "string",
                  sensitive: true
                },
                username: {
                  type: "string",
                  sensitive: true
                }
              }
            }
          },
          union: true
        },
        S7w: {
          type: "structure",
          members: {
            added: {
              type: "integer"
            },
            failed: {
              type: "integer"
            },
            skipped: {
              type: "integer"
            },
            unchanged: {
              type: "integer"
            },
            updated: {
              type: "integer"
            }
          }
        },
        S87: {
          type: "list",
          member: {}
        },
        S89: {
          type: "map",
          key: {},
          value: {
            type: "map",
            key: {},
            value: {}
          }
        },
        S8f: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "revision"
            ],
            members: {
              name: {
                shape: "S1s"
              },
              revision: {}
            }
          }
        },
        Sc7: {
          type: "list",
          member: {}
        },
        Sc9: {
          type: "structure",
          members: {
            and: {
              shape: "Sca"
            },
            filter: {
              type: "structure",
              required: [
                "attribute",
                "value"
              ],
              members: {
                attribute: {},
                value: {}
              }
            },
            or: {
              shape: "Sca"
            }
          },
          union: true
        },
        Sca: {
          type: "list",
          member: {
            shape: "Sc9"
          }
        },
        Sce: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "attribute"
            ],
            members: {
              attribute: {}
            }
          }
        },
        Sci: {
          type: "structure",
          required: [
            "attribute"
          ],
          members: {
            attribute: {},
            order: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/datazone-2018-05-10.paginators.json
var require_datazone_2018_05_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/datazone-2018-05-10.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAssetRevisions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListDataSourceRunActivities: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListDataSourceRuns: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListDataSources: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListDomains: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListEnvironmentBlueprintConfigurations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListEnvironmentBlueprints: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListEnvironmentProfiles: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListEnvironments: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListNotifications: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "notifications"
        },
        ListProjectMemberships: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "members"
        },
        ListProjects: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListSubscriptionGrants: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListSubscriptionRequests: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListSubscriptionTargets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListSubscriptions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        Search: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        SearchGroupProfiles: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        SearchListings: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        SearchTypes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        SearchUserProfiles: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/datazone.js
var require_datazone = __commonJS({
  "node_modules/aws-sdk/clients/datazone.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["datazone"] = {};
    AWS2.DataZone = Service.defineService("datazone", ["2018-05-10"]);
    Object.defineProperty(apiLoader.services["datazone"], "2018-05-10", {
      get: function get() {
        var model = require_datazone_2018_05_10_min();
        model.paginators = require_datazone_2018_05_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.DataZone;
  }
});

// node_modules/aws-sdk/apis/launch-wizard-2018-05-10.min.json
var require_launch_wizard_2018_05_10_min = __commonJS({
  "node_modules/aws-sdk/apis/launch-wizard-2018-05-10.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-05-10",
        endpointPrefix: "launchwizard",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Launch Wizard",
        serviceId: "Launch Wizard",
        signatureVersion: "v4",
        signingName: "launchwizard",
        uid: "launch-wizard-2018-05-10"
      },
      operations: {
        CreateDeployment: {
          http: {
            requestUri: "/createDeployment",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "deploymentPatternName",
              "name",
              "specifications",
              "workloadName"
            ],
            members: {
              deploymentPatternName: {},
              dryRun: {
                type: "boolean"
              },
              name: {},
              specifications: {
                shape: "S5"
              },
              workloadName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deploymentId: {}
            }
          }
        },
        DeleteDeployment: {
          http: {
            requestUri: "/deleteDeployment",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "deploymentId"
            ],
            members: {
              deploymentId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              status: {},
              statusReason: {}
            }
          },
          idempotent: true
        },
        GetDeployment: {
          http: {
            requestUri: "/getDeployment",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "deploymentId"
            ],
            members: {
              deploymentId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deployment: {
                type: "structure",
                members: {
                  createdAt: {
                    type: "timestamp"
                  },
                  deletedAt: {
                    type: "timestamp"
                  },
                  id: {},
                  name: {},
                  patternName: {},
                  resourceGroup: {},
                  specifications: {
                    shape: "S5"
                  },
                  status: {},
                  workloadName: {}
                }
              }
            }
          }
        },
        GetWorkload: {
          http: {
            requestUri: "/getWorkload",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workloadName"
            ],
            members: {
              workloadName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              workload: {
                type: "structure",
                members: {
                  description: {},
                  displayName: {},
                  documentationUrl: {},
                  iconUrl: {},
                  status: {},
                  statusMessage: {},
                  workloadName: {}
                }
              }
            }
          }
        },
        ListDeploymentEvents: {
          http: {
            requestUri: "/listDeploymentEvents",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "deploymentId"
            ],
            members: {
              deploymentId: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deploymentEvents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    description: {},
                    name: {},
                    status: {},
                    statusReason: {},
                    timestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDeployments: {
          http: {
            requestUri: "/listDeployments",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deployments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    createdAt: {
                      type: "timestamp"
                    },
                    id: {},
                    name: {},
                    patternName: {},
                    status: {},
                    workloadName: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListWorkloadDeploymentPatterns: {
          http: {
            requestUri: "/listWorkloadDeploymentPatterns",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workloadName"
            ],
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              workloadName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              workloadDeploymentPatterns: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    deploymentPatternName: {},
                    description: {},
                    displayName: {},
                    status: {},
                    statusMessage: {},
                    workloadName: {},
                    workloadVersionName: {}
                  }
                }
              }
            }
          }
        },
        ListWorkloads: {
          http: {
            requestUri: "/listWorkloads",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              workloads: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    displayName: {},
                    workloadName: {}
                  }
                }
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "map",
          key: {},
          value: {},
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/launch-wizard-2018-05-10.paginators.json
var require_launch_wizard_2018_05_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/launch-wizard-2018-05-10.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListDeploymentEvents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "deploymentEvents"
        },
        ListDeployments: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "deployments"
        },
        ListWorkloadDeploymentPatterns: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "workloadDeploymentPatterns"
        },
        ListWorkloads: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "workloads"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/launchwizard.js
var require_launchwizard = __commonJS({
  "node_modules/aws-sdk/clients/launchwizard.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["launchwizard"] = {};
    AWS2.LaunchWizard = Service.defineService("launchwizard", ["2018-05-10"]);
    Object.defineProperty(apiLoader.services["launchwizard"], "2018-05-10", {
      get: function get() {
        var model = require_launch_wizard_2018_05_10_min();
        model.paginators = require_launch_wizard_2018_05_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.LaunchWizard;
  }
});

// node_modules/aws-sdk/apis/trustedadvisor-2022-09-15.min.json
var require_trustedadvisor_2022_09_15_min = __commonJS({
  "node_modules/aws-sdk/apis/trustedadvisor-2022-09-15.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2022-09-15",
        endpointPrefix: "trustedadvisor",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "TrustedAdvisor Public API",
        serviceId: "TrustedAdvisor",
        signatureVersion: "v4",
        signingName: "trustedadvisor",
        uid: "trustedadvisor-2022-09-15"
      },
      operations: {
        GetOrganizationRecommendation: {
          http: {
            method: "GET",
            requestUri: "/v1/organization-recommendations/{organizationRecommendationIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "organizationRecommendationIdentifier"
            ],
            members: {
              organizationRecommendationIdentifier: {
                location: "uri",
                locationName: "organizationRecommendationIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              organizationRecommendation: {
                type: "structure",
                required: [
                  "arn",
                  "description",
                  "id",
                  "name",
                  "pillars",
                  "resourcesAggregates",
                  "source",
                  "status",
                  "type"
                ],
                members: {
                  arn: {},
                  awsServices: {
                    shape: "S6"
                  },
                  checkArn: {},
                  createdAt: {
                    shape: "S9"
                  },
                  createdBy: {},
                  description: {},
                  id: {},
                  lastUpdatedAt: {
                    shape: "S9"
                  },
                  lifecycleStage: {},
                  name: {},
                  pillarSpecificAggregates: {
                    shape: "Sb"
                  },
                  pillars: {
                    shape: "Se"
                  },
                  resolvedAt: {
                    shape: "S9"
                  },
                  resourcesAggregates: {
                    shape: "Sg"
                  },
                  source: {},
                  status: {},
                  type: {},
                  updateReason: {
                    shape: "Sl"
                  },
                  updateReasonCode: {},
                  updatedOnBehalfOf: {},
                  updatedOnBehalfOfJobTitle: {}
                }
              }
            }
          }
        },
        GetRecommendation: {
          http: {
            method: "GET",
            requestUri: "/v1/recommendations/{recommendationIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "recommendationIdentifier"
            ],
            members: {
              recommendationIdentifier: {
                location: "uri",
                locationName: "recommendationIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              recommendation: {
                type: "structure",
                required: [
                  "arn",
                  "description",
                  "id",
                  "name",
                  "pillars",
                  "resourcesAggregates",
                  "source",
                  "status",
                  "type"
                ],
                members: {
                  arn: {},
                  awsServices: {
                    shape: "S6"
                  },
                  checkArn: {},
                  createdAt: {
                    shape: "S9"
                  },
                  createdBy: {},
                  description: {},
                  id: {},
                  lastUpdatedAt: {
                    shape: "S9"
                  },
                  lifecycleStage: {},
                  name: {},
                  pillarSpecificAggregates: {
                    shape: "Sb"
                  },
                  pillars: {
                    shape: "Se"
                  },
                  resolvedAt: {
                    shape: "S9"
                  },
                  resourcesAggregates: {
                    shape: "Sg"
                  },
                  source: {},
                  status: {},
                  type: {},
                  updateReason: {
                    shape: "Sl"
                  },
                  updateReasonCode: {},
                  updatedOnBehalfOf: {},
                  updatedOnBehalfOfJobTitle: {}
                }
              }
            }
          }
        },
        ListChecks: {
          http: {
            method: "GET",
            requestUri: "/v1/checks",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              awsService: {
                location: "querystring",
                locationName: "awsService"
              },
              language: {
                location: "querystring",
                locationName: "language"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              pillar: {
                location: "querystring",
                locationName: "pillar"
              },
              source: {
                location: "querystring",
                locationName: "source"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "checkSummaries"
            ],
            members: {
              checkSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "awsServices",
                    "description",
                    "id",
                    "metadata",
                    "name",
                    "pillars",
                    "source"
                  ],
                  members: {
                    arn: {},
                    awsServices: {
                      shape: "S6"
                    },
                    description: {},
                    id: {},
                    metadata: {
                      shape: "S10"
                    },
                    name: {},
                    pillars: {
                      shape: "Se"
                    },
                    source: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListOrganizationRecommendationAccounts: {
          http: {
            method: "GET",
            requestUri: "/v1/organization-recommendations/{organizationRecommendationIdentifier}/accounts",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "organizationRecommendationIdentifier"
            ],
            members: {
              affectedAccountId: {
                location: "querystring",
                locationName: "affectedAccountId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              organizationRecommendationIdentifier: {
                location: "uri",
                locationName: "organizationRecommendationIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "accountRecommendationLifecycleSummaries"
            ],
            members: {
              accountRecommendationLifecycleSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    accountId: {},
                    accountRecommendationArn: {},
                    lastUpdatedAt: {
                      shape: "S9"
                    },
                    lifecycleStage: {},
                    updateReason: {
                      shape: "Sl"
                    },
                    updateReasonCode: {},
                    updatedOnBehalfOf: {},
                    updatedOnBehalfOfJobTitle: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListOrganizationRecommendationResources: {
          http: {
            method: "GET",
            requestUri: "/v1/organization-recommendations/{organizationRecommendationIdentifier}/resources",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "organizationRecommendationIdentifier"
            ],
            members: {
              affectedAccountId: {
                location: "querystring",
                locationName: "affectedAccountId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              organizationRecommendationIdentifier: {
                location: "uri",
                locationName: "organizationRecommendationIdentifier"
              },
              regionCode: {
                location: "querystring",
                locationName: "regionCode"
              },
              status: {
                location: "querystring",
                locationName: "status"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "organizationRecommendationResourceSummaries"
            ],
            members: {
              nextToken: {},
              organizationRecommendationResourceSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "awsResourceId",
                    "id",
                    "lastUpdatedAt",
                    "metadata",
                    "recommendationArn",
                    "regionCode",
                    "status"
                  ],
                  members: {
                    accountId: {},
                    arn: {},
                    awsResourceId: {},
                    id: {},
                    lastUpdatedAt: {
                      shape: "S9"
                    },
                    metadata: {
                      shape: "S10"
                    },
                    recommendationArn: {},
                    regionCode: {},
                    status: {}
                  }
                }
              }
            }
          }
        },
        ListOrganizationRecommendations: {
          http: {
            method: "GET",
            requestUri: "/v1/organization-recommendations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              afterLastUpdatedAt: {
                location: "querystring",
                locationName: "afterLastUpdatedAt",
                type: "timestamp"
              },
              awsService: {
                location: "querystring",
                locationName: "awsService"
              },
              beforeLastUpdatedAt: {
                location: "querystring",
                locationName: "beforeLastUpdatedAt",
                type: "timestamp"
              },
              checkIdentifier: {
                location: "querystring",
                locationName: "checkIdentifier"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              pillar: {
                location: "querystring",
                locationName: "pillar"
              },
              source: {
                location: "querystring",
                locationName: "source"
              },
              status: {
                location: "querystring",
                locationName: "status"
              },
              type: {
                location: "querystring",
                locationName: "type"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "organizationRecommendationSummaries"
            ],
            members: {
              nextToken: {},
              organizationRecommendationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "id",
                    "name",
                    "pillars",
                    "resourcesAggregates",
                    "source",
                    "status",
                    "type"
                  ],
                  members: {
                    arn: {},
                    awsServices: {
                      shape: "S6"
                    },
                    checkArn: {},
                    createdAt: {
                      shape: "S9"
                    },
                    id: {},
                    lastUpdatedAt: {
                      shape: "S9"
                    },
                    lifecycleStage: {},
                    name: {},
                    pillarSpecificAggregates: {
                      shape: "Sb"
                    },
                    pillars: {
                      shape: "Se"
                    },
                    resourcesAggregates: {
                      shape: "Sg"
                    },
                    source: {},
                    status: {},
                    type: {}
                  }
                }
              }
            }
          }
        },
        ListRecommendationResources: {
          http: {
            method: "GET",
            requestUri: "/v1/recommendations/{recommendationIdentifier}/resources",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "recommendationIdentifier"
            ],
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              recommendationIdentifier: {
                location: "uri",
                locationName: "recommendationIdentifier"
              },
              regionCode: {
                location: "querystring",
                locationName: "regionCode"
              },
              status: {
                location: "querystring",
                locationName: "status"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "recommendationResourceSummaries"
            ],
            members: {
              nextToken: {},
              recommendationResourceSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "awsResourceId",
                    "id",
                    "lastUpdatedAt",
                    "metadata",
                    "recommendationArn",
                    "regionCode",
                    "status"
                  ],
                  members: {
                    arn: {},
                    awsResourceId: {},
                    id: {},
                    lastUpdatedAt: {
                      shape: "S9"
                    },
                    metadata: {
                      shape: "S10"
                    },
                    recommendationArn: {},
                    regionCode: {},
                    status: {}
                  }
                }
              }
            }
          }
        },
        ListRecommendations: {
          http: {
            method: "GET",
            requestUri: "/v1/recommendations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              afterLastUpdatedAt: {
                location: "querystring",
                locationName: "afterLastUpdatedAt",
                type: "timestamp"
              },
              awsService: {
                location: "querystring",
                locationName: "awsService"
              },
              beforeLastUpdatedAt: {
                location: "querystring",
                locationName: "beforeLastUpdatedAt",
                type: "timestamp"
              },
              checkIdentifier: {
                location: "querystring",
                locationName: "checkIdentifier"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              pillar: {
                location: "querystring",
                locationName: "pillar"
              },
              source: {
                location: "querystring",
                locationName: "source"
              },
              status: {
                location: "querystring",
                locationName: "status"
              },
              type: {
                location: "querystring",
                locationName: "type"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "recommendationSummaries"
            ],
            members: {
              nextToken: {},
              recommendationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "id",
                    "name",
                    "pillars",
                    "resourcesAggregates",
                    "source",
                    "status",
                    "type"
                  ],
                  members: {
                    arn: {},
                    awsServices: {
                      shape: "S6"
                    },
                    checkArn: {},
                    createdAt: {
                      shape: "S9"
                    },
                    id: {},
                    lastUpdatedAt: {
                      shape: "S9"
                    },
                    lifecycleStage: {},
                    name: {},
                    pillarSpecificAggregates: {
                      shape: "Sb"
                    },
                    pillars: {
                      shape: "Se"
                    },
                    resourcesAggregates: {
                      shape: "Sg"
                    },
                    source: {},
                    status: {},
                    type: {}
                  }
                }
              }
            }
          }
        },
        UpdateOrganizationRecommendationLifecycle: {
          http: {
            method: "PUT",
            requestUri: "/v1/organization-recommendations/{organizationRecommendationIdentifier}/lifecycle",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "lifecycleStage",
              "organizationRecommendationIdentifier"
            ],
            members: {
              lifecycleStage: {},
              organizationRecommendationIdentifier: {
                location: "uri",
                locationName: "organizationRecommendationIdentifier"
              },
              updateReason: {
                shape: "Sl"
              },
              updateReasonCode: {}
            }
          },
          idempotent: true
        },
        UpdateRecommendationLifecycle: {
          http: {
            method: "PUT",
            requestUri: "/v1/recommendations/{recommendationIdentifier}/lifecycle",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "lifecycleStage",
              "recommendationIdentifier"
            ],
            members: {
              lifecycleStage: {},
              recommendationIdentifier: {
                location: "uri",
                locationName: "recommendationIdentifier"
              },
              updateReason: {
                shape: "Sl"
              },
              updateReasonCode: {}
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S6: {
          type: "list",
          member: {}
        },
        S9: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        Sb: {
          type: "structure",
          members: {
            costOptimizing: {
              type: "structure",
              required: [
                "estimatedMonthlySavings",
                "estimatedPercentMonthlySavings"
              ],
              members: {
                estimatedMonthlySavings: {
                  type: "double"
                },
                estimatedPercentMonthlySavings: {
                  type: "double"
                }
              }
            }
          }
        },
        Se: {
          type: "list",
          member: {}
        },
        Sg: {
          type: "structure",
          required: [
            "errorCount",
            "okCount",
            "warningCount"
          ],
          members: {
            errorCount: {
              type: "long"
            },
            okCount: {
              type: "long"
            },
            warningCount: {
              type: "long"
            }
          }
        },
        Sl: {
          type: "string",
          sensitive: true
        },
        S10: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/trustedadvisor-2022-09-15.paginators.json
var require_trustedadvisor_2022_09_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/trustedadvisor-2022-09-15.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListChecks: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "checkSummaries"
        },
        ListOrganizationRecommendationAccounts: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "accountRecommendationLifecycleSummaries"
        },
        ListOrganizationRecommendationResources: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "organizationRecommendationResourceSummaries"
        },
        ListOrganizationRecommendations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "organizationRecommendationSummaries"
        },
        ListRecommendationResources: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "recommendationResourceSummaries"
        },
        ListRecommendations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "recommendationSummaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/trustedadvisor.js
var require_trustedadvisor = __commonJS({
  "node_modules/aws-sdk/clients/trustedadvisor.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["trustedadvisor"] = {};
    AWS2.TrustedAdvisor = Service.defineService("trustedadvisor", ["2022-09-15"]);
    Object.defineProperty(apiLoader.services["trustedadvisor"], "2022-09-15", {
      get: function get() {
        var model = require_trustedadvisor_2022_09_15_min();
        model.paginators = require_trustedadvisor_2022_09_15_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.TrustedAdvisor;
  }
});

// node_modules/aws-sdk/apis/cloudfront-keyvaluestore-2022-07-26.min.json
var require_cloudfront_keyvaluestore_2022_07_26_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-keyvaluestore-2022-07-26.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2022-07-26",
        endpointPrefix: "cloudfront-keyvaluestore",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon CloudFront KeyValueStore",
        serviceId: "CloudFront KeyValueStore",
        signatureVersion: "v4",
        signingName: "cloudfront-keyvaluestore",
        uid: "cloudfront-keyvaluestore-2022-07-26"
      },
      operations: {
        DeleteKey: {
          http: {
            method: "DELETE",
            requestUri: "/key-value-stores/{KvsARN}/keys/{Key}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "KvsARN",
              "Key",
              "IfMatch"
            ],
            members: {
              KvsARN: {
                contextParam: {
                  name: "KvsARN"
                },
                location: "uri",
                locationName: "KvsARN"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ItemCount",
              "TotalSizeInBytes",
              "ETag"
            ],
            members: {
              ItemCount: {
                type: "integer"
              },
              TotalSizeInBytes: {
                type: "long"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            }
          },
          idempotent: true
        },
        DescribeKeyValueStore: {
          http: {
            method: "GET",
            requestUri: "/key-value-stores/{KvsARN}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "KvsARN"
            ],
            members: {
              KvsARN: {
                contextParam: {
                  name: "KvsARN"
                },
                location: "uri",
                locationName: "KvsARN"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ItemCount",
              "TotalSizeInBytes",
              "KvsARN",
              "Created",
              "ETag"
            ],
            members: {
              ItemCount: {
                type: "integer"
              },
              TotalSizeInBytes: {
                type: "long"
              },
              KvsARN: {},
              Created: {
                type: "timestamp"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              },
              LastModified: {
                type: "timestamp"
              }
            }
          }
        },
        GetKey: {
          http: {
            method: "GET",
            requestUri: "/key-value-stores/{KvsARN}/keys/{Key}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "KvsARN",
              "Key"
            ],
            members: {
              KvsARN: {
                contextParam: {
                  name: "KvsARN"
                },
                location: "uri",
                locationName: "KvsARN"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Key",
              "Value",
              "ItemCount",
              "TotalSizeInBytes"
            ],
            members: {
              Key: {},
              Value: {
                shape: "Sd"
              },
              ItemCount: {
                type: "integer"
              },
              TotalSizeInBytes: {
                type: "long"
              }
            }
          }
        },
        ListKeys: {
          http: {
            method: "GET",
            requestUri: "/key-value-stores/{KvsARN}/keys",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "KvsARN"
            ],
            members: {
              KvsARN: {
                contextParam: {
                  name: "KvsARN"
                },
                location: "uri",
                locationName: "KvsARN"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key",
                    "Value"
                  ],
                  members: {
                    Key: {},
                    Value: {
                      shape: "Sd"
                    }
                  }
                }
              }
            }
          }
        },
        PutKey: {
          http: {
            method: "PUT",
            requestUri: "/key-value-stores/{KvsARN}/keys/{Key}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Key",
              "Value",
              "KvsARN",
              "IfMatch"
            ],
            members: {
              Key: {
                location: "uri",
                locationName: "Key"
              },
              Value: {
                shape: "Sd"
              },
              KvsARN: {
                contextParam: {
                  name: "KvsARN"
                },
                location: "uri",
                locationName: "KvsARN"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ItemCount",
              "TotalSizeInBytes",
              "ETag"
            ],
            members: {
              ItemCount: {
                type: "integer"
              },
              TotalSizeInBytes: {
                type: "long"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            }
          },
          idempotent: true
        },
        UpdateKeys: {
          http: {
            requestUri: "/key-value-stores/{KvsARN}/keys",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "KvsARN",
              "IfMatch"
            ],
            members: {
              KvsARN: {
                contextParam: {
                  name: "KvsARN"
                },
                location: "uri",
                locationName: "KvsARN"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              },
              Puts: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key",
                    "Value"
                  ],
                  members: {
                    Key: {},
                    Value: {
                      shape: "Sd"
                    }
                  }
                }
              },
              Deletes: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key"
                  ],
                  members: {
                    Key: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ItemCount",
              "TotalSizeInBytes",
              "ETag"
            ],
            members: {
              ItemCount: {
                type: "integer"
              },
              TotalSizeInBytes: {
                type: "long"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            }
          },
          idempotent: true
        }
      },
      shapes: {
        Sd: {
          type: "string",
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-keyvaluestore-2022-07-26.paginators.json
var require_cloudfront_keyvaluestore_2022_07_26_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-keyvaluestore-2022-07-26.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListKeys: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/cloudfrontkeyvaluestore.js
var require_cloudfrontkeyvaluestore = __commonJS({
  "node_modules/aws-sdk/clients/cloudfrontkeyvaluestore.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["cloudfrontkeyvaluestore"] = {};
    AWS2.CloudFrontKeyValueStore = Service.defineService("cloudfrontkeyvaluestore", ["2022-07-26"]);
    Object.defineProperty(apiLoader.services["cloudfrontkeyvaluestore"], "2022-07-26", {
      get: function get() {
        var model = require_cloudfront_keyvaluestore_2022_07_26_min();
        model.paginators = require_cloudfront_keyvaluestore_2022_07_26_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CloudFrontKeyValueStore;
  }
});

// node_modules/aws-sdk/apis/inspector-scan-2023-08-08.min.json
var require_inspector_scan_2023_08_08_min = __commonJS({
  "node_modules/aws-sdk/apis/inspector-scan-2023-08-08.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2023-08-08",
        endpointPrefix: "inspector-scan",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "inspector-scan",
        serviceFullName: "Inspector Scan",
        serviceId: "Inspector Scan",
        signatureVersion: "v4",
        signingName: "inspector-scan",
        uid: "inspector-scan-2023-08-08"
      },
      operations: {
        ScanSbom: {
          http: {
            requestUri: "/scan/sbom",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sbom"
            ],
            members: {
              sbom: {
                shape: "S2"
              },
              outputFormat: {}
            }
          },
          output: {
            type: "structure",
            members: {
              sbom: {
                shape: "S2"
              }
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S2: {
          type: "structure",
          members: {},
          document: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/inspector-scan-2023-08-08.paginators.json
var require_inspector_scan_2023_08_08_paginators = __commonJS({
  "node_modules/aws-sdk/apis/inspector-scan-2023-08-08.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/inspectorscan.js
var require_inspectorscan = __commonJS({
  "node_modules/aws-sdk/clients/inspectorscan.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["inspectorscan"] = {};
    AWS2.InspectorScan = Service.defineService("inspectorscan", ["2023-08-08"]);
    Object.defineProperty(apiLoader.services["inspectorscan"], "2023-08-08", {
      get: function get() {
        var model = require_inspector_scan_2023_08_08_min();
        model.paginators = require_inspector_scan_2023_08_08_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.InspectorScan;
  }
});

// node_modules/aws-sdk/apis/bcm-data-exports-2023-11-26.min.json
var require_bcm_data_exports_2023_11_26_min = __commonJS({
  "node_modules/aws-sdk/apis/bcm-data-exports-2023-11-26.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2023-11-26",
        endpointPrefix: "bcm-data-exports",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Billing and Cost Management Data Exports",
        serviceId: "BCM Data Exports",
        signatureVersion: "v4",
        signingName: "bcm-data-exports",
        targetPrefix: "AWSBillingAndCostManagementDataExports",
        uid: "bcm-data-exports-2023-11-26"
      },
      operations: {
        CreateExport: {
          input: {
            type: "structure",
            required: [
              "Export"
            ],
            members: {
              Export: {
                shape: "S2"
              },
              ResourceTags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ExportArn: {}
            }
          }
        },
        DeleteExport: {
          input: {
            type: "structure",
            required: [
              "ExportArn"
            ],
            members: {
              ExportArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ExportArn: {}
            }
          },
          idempotent: true
        },
        GetExecution: {
          input: {
            type: "structure",
            required: [
              "ExecutionId",
              "ExportArn"
            ],
            members: {
              ExecutionId: {},
              ExportArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ExecutionId: {},
              ExecutionStatus: {
                shape: "Su"
              },
              Export: {
                shape: "S2"
              }
            }
          }
        },
        GetExport: {
          input: {
            type: "structure",
            required: [
              "ExportArn"
            ],
            members: {
              ExportArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Export: {
                shape: "S2"
              },
              ExportStatus: {
                shape: "S10"
              }
            }
          }
        },
        GetTable: {
          input: {
            type: "structure",
            required: [
              "TableName"
            ],
            members: {
              TableName: {},
              TableProperties: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Description: {},
              Schema: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Description: {},
                    Name: {},
                    Type: {}
                  }
                }
              },
              TableName: {},
              TableProperties: {
                shape: "S7"
              }
            }
          }
        },
        ListExecutions: {
          input: {
            type: "structure",
            required: [
              "ExportArn"
            ],
            members: {
              ExportArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Executions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ExecutionId",
                    "ExecutionStatus"
                  ],
                  members: {
                    ExecutionId: {},
                    ExecutionStatus: {
                      shape: "Su"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListExports: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Exports: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ExportArn",
                    "ExportName",
                    "ExportStatus"
                  ],
                  members: {
                    ExportArn: {},
                    ExportName: {},
                    ExportStatus: {
                      shape: "S10"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTables: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Tables: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Description: {},
                    TableName: {},
                    TableProperties: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          DefaultValue: {},
                          Description: {},
                          Name: {},
                          ValidValues: {
                            type: "list",
                            member: {}
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ResourceTags: {
                shape: "Sl"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "ResourceTags"
            ],
            members: {
              ResourceArn: {},
              ResourceTags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "ResourceTagKeys"
            ],
            members: {
              ResourceArn: {},
              ResourceTagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateExport: {
          input: {
            type: "structure",
            required: [
              "Export",
              "ExportArn"
            ],
            members: {
              Export: {
                shape: "S2"
              },
              ExportArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ExportArn: {}
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          required: [
            "DataQuery",
            "DestinationConfigurations",
            "Name",
            "RefreshCadence"
          ],
          members: {
            DataQuery: {
              type: "structure",
              required: [
                "QueryStatement"
              ],
              members: {
                QueryStatement: {},
                TableConfigurations: {
                  type: "map",
                  key: {},
                  value: {
                    shape: "S7"
                  }
                }
              }
            },
            Description: {},
            DestinationConfigurations: {
              type: "structure",
              required: [
                "S3Destination"
              ],
              members: {
                S3Destination: {
                  type: "structure",
                  required: [
                    "S3Bucket",
                    "S3OutputConfigurations",
                    "S3Prefix",
                    "S3Region"
                  ],
                  members: {
                    S3Bucket: {},
                    S3OutputConfigurations: {
                      type: "structure",
                      required: [
                        "Compression",
                        "Format",
                        "OutputType",
                        "Overwrite"
                      ],
                      members: {
                        Compression: {},
                        Format: {},
                        OutputType: {},
                        Overwrite: {}
                      }
                    },
                    S3Prefix: {},
                    S3Region: {}
                  }
                }
              }
            },
            ExportArn: {},
            Name: {},
            RefreshCadence: {
              type: "structure",
              required: [
                "Frequency"
              ],
              members: {
                Frequency: {}
              }
            }
          }
        },
        S7: {
          type: "map",
          key: {},
          value: {}
        },
        Sl: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Su: {
          type: "structure",
          members: {
            CompletedAt: {
              shape: "Sv"
            },
            CreatedAt: {
              shape: "Sv"
            },
            LastUpdatedAt: {
              shape: "Sv"
            },
            StatusCode: {},
            StatusReason: {}
          }
        },
        Sv: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S10: {
          type: "structure",
          members: {
            CreatedAt: {
              shape: "Sv"
            },
            LastRefreshedAt: {
              shape: "Sv"
            },
            LastUpdatedAt: {
              shape: "Sv"
            },
            StatusCode: {},
            StatusReason: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/bcm-data-exports-2023-11-26.paginators.json
var require_bcm_data_exports_2023_11_26_paginators = __commonJS({
  "node_modules/aws-sdk/apis/bcm-data-exports-2023-11-26.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListExecutions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Executions"
        },
        ListExports: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Exports"
        },
        ListTables: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Tables"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/bcmdataexports.js
var require_bcmdataexports = __commonJS({
  "node_modules/aws-sdk/clients/bcmdataexports.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["bcmdataexports"] = {};
    AWS2.BCMDataExports = Service.defineService("bcmdataexports", ["2023-11-26"]);
    Object.defineProperty(apiLoader.services["bcmdataexports"], "2023-11-26", {
      get: function get() {
        var model = require_bcm_data_exports_2023_11_26_min();
        model.paginators = require_bcm_data_exports_2023_11_26_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.BCMDataExports;
  }
});

// node_modules/aws-sdk/apis/cost-optimization-hub-2022-07-26.min.json
var require_cost_optimization_hub_2022_07_26_min = __commonJS({
  "node_modules/aws-sdk/apis/cost-optimization-hub-2022-07-26.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2022-07-26",
        endpointPrefix: "cost-optimization-hub",
        jsonVersion: "1.0",
        protocol: "json",
        serviceFullName: "Cost Optimization Hub",
        serviceId: "Cost Optimization Hub",
        signatureVersion: "v4",
        signingName: "cost-optimization-hub",
        targetPrefix: "CostOptimizationHubService",
        uid: "cost-optimization-hub-2022-07-26"
      },
      operations: {
        GetPreferences: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              memberAccountDiscountVisibility: {},
              savingsEstimationMode: {}
            }
          }
        },
        GetRecommendation: {
          input: {
            type: "structure",
            required: [
              "recommendationId"
            ],
            members: {
              recommendationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              accountId: {},
              actionType: {},
              costCalculationLookbackPeriodInDays: {
                type: "integer"
              },
              currencyCode: {},
              currentResourceDetails: {
                shape: "Sa"
              },
              currentResourceType: {},
              estimatedMonthlyCost: {
                type: "double"
              },
              estimatedMonthlySavings: {
                type: "double"
              },
              estimatedSavingsOverCostCalculationLookbackPeriod: {
                type: "double"
              },
              estimatedSavingsPercentage: {
                type: "double"
              },
              implementationEffort: {},
              lastRefreshTimestamp: {
                type: "timestamp"
              },
              recommendationId: {},
              recommendationLookbackPeriodInDays: {
                type: "integer"
              },
              recommendedResourceDetails: {
                shape: "Sa"
              },
              recommendedResourceType: {},
              region: {},
              resourceArn: {},
              resourceId: {},
              restartNeeded: {
                type: "boolean"
              },
              rollbackPossible: {
                type: "boolean"
              },
              source: {},
              tags: {
                shape: "S1k"
              }
            }
          }
        },
        ListEnrollmentStatuses: {
          input: {
            type: "structure",
            members: {
              accountId: {},
              includeOrganizationInfo: {
                type: "boolean"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    accountId: {},
                    createdTimestamp: {
                      type: "timestamp"
                    },
                    lastUpdatedTimestamp: {
                      type: "timestamp"
                    },
                    status: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListRecommendationSummaries: {
          input: {
            type: "structure",
            required: [
              "groupBy"
            ],
            members: {
              filter: {
                shape: "S1w"
              },
              groupBy: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              currencyCode: {},
              estimatedTotalDedupedSavings: {
                type: "double"
              },
              groupBy: {},
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    estimatedMonthlySavings: {
                      type: "double"
                    },
                    group: {},
                    recommendationCount: {
                      type: "integer"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListRecommendations: {
          input: {
            type: "structure",
            members: {
              filter: {
                shape: "S1w"
              },
              includeAllRecommendations: {
                type: "boolean"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              orderBy: {
                type: "structure",
                members: {
                  dimension: {},
                  order: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    accountId: {},
                    actionType: {},
                    currencyCode: {},
                    currentResourceSummary: {},
                    currentResourceType: {},
                    estimatedMonthlyCost: {
                      type: "double"
                    },
                    estimatedMonthlySavings: {
                      type: "double"
                    },
                    estimatedSavingsPercentage: {
                      type: "double"
                    },
                    implementationEffort: {},
                    lastRefreshTimestamp: {
                      type: "timestamp"
                    },
                    recommendationId: {},
                    recommendationLookbackPeriodInDays: {
                      type: "integer"
                    },
                    recommendedResourceSummary: {},
                    recommendedResourceType: {},
                    region: {},
                    resourceArn: {},
                    resourceId: {},
                    restartNeeded: {
                      type: "boolean"
                    },
                    rollbackPossible: {
                      type: "boolean"
                    },
                    source: {},
                    tags: {
                      shape: "S1k"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        UpdateEnrollmentStatus: {
          input: {
            type: "structure",
            required: [
              "status"
            ],
            members: {
              includeMemberAccounts: {
                type: "boolean"
              },
              status: {}
            }
          },
          output: {
            type: "structure",
            members: {
              status: {}
            }
          }
        },
        UpdatePreferences: {
          input: {
            type: "structure",
            members: {
              memberAccountDiscountVisibility: {},
              savingsEstimationMode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              memberAccountDiscountVisibility: {},
              savingsEstimationMode: {}
            }
          }
        }
      },
      shapes: {
        Sa: {
          type: "structure",
          members: {
            computeSavingsPlans: {
              type: "structure",
              members: {
                configuration: {
                  type: "structure",
                  members: {
                    accountScope: {},
                    hourlyCommitment: {},
                    paymentOption: {},
                    term: {}
                  }
                },
                costCalculation: {
                  shape: "Sd"
                }
              }
            },
            ebsVolume: {
              type: "structure",
              members: {
                configuration: {
                  type: "structure",
                  members: {
                    attachmentState: {},
                    performance: {
                      type: "structure",
                      members: {
                        iops: {
                          type: "double"
                        },
                        throughput: {
                          type: "double"
                        }
                      }
                    },
                    storage: {
                      type: "structure",
                      members: {
                        sizeInGb: {
                          type: "double"
                        },
                        type: {}
                      }
                    }
                  }
                },
                costCalculation: {
                  shape: "Sk"
                }
              }
            },
            ec2AutoScalingGroup: {
              type: "structure",
              members: {
                configuration: {
                  type: "structure",
                  members: {
                    instance: {
                      shape: "Sr"
                    }
                  }
                },
                costCalculation: {
                  shape: "Sk"
                }
              }
            },
            ec2Instance: {
              type: "structure",
              members: {
                configuration: {
                  type: "structure",
                  members: {
                    instance: {
                      shape: "Sr"
                    }
                  }
                },
                costCalculation: {
                  shape: "Sk"
                }
              }
            },
            ec2InstanceSavingsPlans: {
              type: "structure",
              members: {
                configuration: {
                  type: "structure",
                  members: {
                    accountScope: {},
                    hourlyCommitment: {},
                    instanceFamily: {},
                    paymentOption: {},
                    savingsPlansRegion: {},
                    term: {}
                  }
                },
                costCalculation: {
                  shape: "Sd"
                }
              }
            },
            ec2ReservedInstances: {
              type: "structure",
              members: {
                configuration: {
                  type: "structure",
                  members: {
                    accountScope: {},
                    currentGeneration: {},
                    instanceFamily: {},
                    instanceType: {},
                    monthlyRecurringCost: {},
                    normalizedUnitsToPurchase: {},
                    numberOfInstancesToPurchase: {},
                    offeringClass: {},
                    paymentOption: {},
                    platform: {},
                    reservedInstancesRegion: {},
                    service: {},
                    sizeFlexEligible: {
                      type: "boolean"
                    },
                    tenancy: {},
                    term: {},
                    upfrontCost: {}
                  }
                },
                costCalculation: {
                  shape: "Sz"
                }
              }
            },
            ecsService: {
              type: "structure",
              members: {
                configuration: {
                  type: "structure",
                  members: {
                    compute: {
                      shape: "S13"
                    }
                  }
                },
                costCalculation: {
                  shape: "Sk"
                }
              }
            },
            elastiCacheReservedInstances: {
              type: "structure",
              members: {
                configuration: {
                  type: "structure",
                  members: {
                    accountScope: {},
                    currentGeneration: {},
                    instanceFamily: {},
                    instanceType: {},
                    monthlyRecurringCost: {},
                    normalizedUnitsToPurchase: {},
                    numberOfInstancesToPurchase: {},
                    paymentOption: {},
                    reservedInstancesRegion: {},
                    service: {},
                    sizeFlexEligible: {
                      type: "boolean"
                    },
                    term: {},
                    upfrontCost: {}
                  }
                },
                costCalculation: {
                  shape: "Sz"
                }
              }
            },
            lambdaFunction: {
              type: "structure",
              members: {
                configuration: {
                  type: "structure",
                  members: {
                    compute: {
                      shape: "S13"
                    }
                  }
                },
                costCalculation: {
                  shape: "Sk"
                }
              }
            },
            openSearchReservedInstances: {
              type: "structure",
              members: {
                configuration: {
                  type: "structure",
                  members: {
                    accountScope: {},
                    currentGeneration: {},
                    instanceType: {},
                    monthlyRecurringCost: {},
                    normalizedUnitsToPurchase: {},
                    numberOfInstancesToPurchase: {},
                    paymentOption: {},
                    reservedInstancesRegion: {},
                    service: {},
                    sizeFlexEligible: {
                      type: "boolean"
                    },
                    term: {},
                    upfrontCost: {}
                  }
                },
                costCalculation: {
                  shape: "Sz"
                }
              }
            },
            rdsReservedInstances: {
              type: "structure",
              members: {
                configuration: {
                  type: "structure",
                  members: {
                    accountScope: {},
                    currentGeneration: {},
                    databaseEdition: {},
                    databaseEngine: {},
                    deploymentOption: {},
                    instanceFamily: {},
                    instanceType: {},
                    licenseModel: {},
                    monthlyRecurringCost: {},
                    normalizedUnitsToPurchase: {},
                    numberOfInstancesToPurchase: {},
                    paymentOption: {},
                    reservedInstancesRegion: {},
                    service: {},
                    sizeFlexEligible: {
                      type: "boolean"
                    },
                    term: {},
                    upfrontCost: {}
                  }
                },
                costCalculation: {
                  shape: "Sz"
                }
              }
            },
            redshiftReservedInstances: {
              type: "structure",
              members: {
                configuration: {
                  type: "structure",
                  members: {
                    accountScope: {},
                    currentGeneration: {},
                    instanceFamily: {},
                    instanceType: {},
                    monthlyRecurringCost: {},
                    normalizedUnitsToPurchase: {},
                    numberOfInstancesToPurchase: {},
                    paymentOption: {},
                    reservedInstancesRegion: {},
                    service: {},
                    sizeFlexEligible: {
                      type: "boolean"
                    },
                    term: {},
                    upfrontCost: {}
                  }
                },
                costCalculation: {
                  shape: "Sz"
                }
              }
            },
            sageMakerSavingsPlans: {
              type: "structure",
              members: {
                configuration: {
                  type: "structure",
                  members: {
                    accountScope: {},
                    hourlyCommitment: {},
                    paymentOption: {},
                    term: {}
                  }
                },
                costCalculation: {
                  shape: "Sd"
                }
              }
            }
          },
          union: true
        },
        Sd: {
          type: "structure",
          members: {
            pricing: {
              type: "structure",
              members: {
                estimatedMonthlyCommitment: {
                  type: "double"
                },
                estimatedOnDemandCost: {
                  type: "double"
                },
                monthlySavingsPlansEligibleCost: {
                  type: "double"
                },
                savingsPercentage: {
                  type: "double"
                }
              }
            }
          }
        },
        Sk: {
          type: "structure",
          members: {
            pricing: {
              type: "structure",
              members: {
                estimatedCostAfterDiscounts: {
                  type: "double"
                },
                estimatedCostBeforeDiscounts: {
                  type: "double"
                },
                estimatedDiscounts: {
                  type: "structure",
                  members: {
                    otherDiscount: {
                      type: "double"
                    },
                    reservedInstancesDiscount: {
                      type: "double"
                    },
                    savingsPlansDiscount: {
                      type: "double"
                    }
                  }
                },
                estimatedNetUnusedAmortizedCommitments: {
                  type: "double"
                }
              }
            },
            usages: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  operation: {},
                  productCode: {},
                  unit: {},
                  usageAmount: {
                    type: "double"
                  },
                  usageType: {}
                }
              }
            }
          }
        },
        Sr: {
          type: "structure",
          members: {
            type: {}
          }
        },
        Sz: {
          type: "structure",
          members: {
            pricing: {
              type: "structure",
              members: {
                estimatedMonthlyAmortizedReservationCost: {
                  type: "double"
                },
                estimatedOnDemandCost: {
                  type: "double"
                },
                monthlyReservationEligibleCost: {
                  type: "double"
                },
                savingsPercentage: {
                  type: "double"
                }
              }
            }
          }
        },
        S13: {
          type: "structure",
          members: {
            architecture: {},
            memorySizeInMB: {
              type: "integer"
            },
            platform: {},
            vCpu: {
              type: "double"
            }
          }
        },
        S1k: {
          type: "list",
          member: {
            type: "structure",
            members: {
              key: {},
              value: {}
            }
          }
        },
        S1w: {
          type: "structure",
          members: {
            accountIds: {
              type: "list",
              member: {}
            },
            actionTypes: {
              type: "list",
              member: {}
            },
            implementationEfforts: {
              type: "list",
              member: {}
            },
            recommendationIds: {
              type: "list",
              member: {}
            },
            regions: {
              type: "list",
              member: {}
            },
            resourceArns: {
              type: "list",
              member: {}
            },
            resourceIds: {
              type: "list",
              member: {}
            },
            resourceTypes: {
              type: "list",
              member: {}
            },
            restartNeeded: {
              type: "boolean"
            },
            rollbackPossible: {
              type: "boolean"
            },
            tags: {
              shape: "S1k"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cost-optimization-hub-2022-07-26.paginators.json
var require_cost_optimization_hub_2022_07_26_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cost-optimization-hub-2022-07-26.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListEnrollmentStatuses: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListRecommendationSummaries: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListRecommendations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/costoptimizationhub.js
var require_costoptimizationhub = __commonJS({
  "node_modules/aws-sdk/clients/costoptimizationhub.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["costoptimizationhub"] = {};
    AWS2.CostOptimizationHub = Service.defineService("costoptimizationhub", ["2022-07-26"]);
    Object.defineProperty(apiLoader.services["costoptimizationhub"], "2022-07-26", {
      get: function get() {
        var model = require_cost_optimization_hub_2022_07_26_min();
        model.paginators = require_cost_optimization_hub_2022_07_26_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CostOptimizationHub;
  }
});

// node_modules/aws-sdk/apis/eks-auth-2023-11-26.min.json
var require_eks_auth_2023_11_26_min = __commonJS({
  "node_modules/aws-sdk/apis/eks-auth-2023-11-26.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2023-11-26",
        endpointPrefix: "eks-auth",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon EKS Auth",
        serviceId: "EKS Auth",
        signatureVersion: "v4",
        signingName: "eks-auth",
        uid: "eks-auth-2023-11-26"
      },
      operations: {
        AssumeRoleForPodIdentity: {
          http: {
            requestUri: "/clusters/{clusterName}/assume-role-for-pod-identity",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "token"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "clusterName"
              },
              token: {
                type: "string",
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "subject",
              "audience",
              "podIdentityAssociation",
              "assumedRoleUser",
              "credentials"
            ],
            members: {
              subject: {
                type: "structure",
                required: [
                  "namespace",
                  "serviceAccount"
                ],
                members: {
                  namespace: {},
                  serviceAccount: {}
                }
              },
              audience: {},
              podIdentityAssociation: {
                type: "structure",
                required: [
                  "associationArn",
                  "associationId"
                ],
                members: {
                  associationArn: {},
                  associationId: {}
                }
              },
              assumedRoleUser: {
                type: "structure",
                required: [
                  "arn",
                  "assumeRoleId"
                ],
                members: {
                  arn: {},
                  assumeRoleId: {}
                }
              },
              credentials: {
                type: "structure",
                required: [
                  "sessionToken",
                  "secretAccessKey",
                  "accessKeyId",
                  "expiration"
                ],
                members: {
                  sessionToken: {},
                  secretAccessKey: {},
                  accessKeyId: {},
                  expiration: {
                    type: "timestamp"
                  }
                },
                sensitive: true
              }
            }
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/apis/eks-auth-2023-11-26.paginators.json
var require_eks_auth_2023_11_26_paginators = __commonJS({
  "node_modules/aws-sdk/apis/eks-auth-2023-11-26.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/apis/eks-auth-2023-11-26.waiters2.json
var require_eks_auth_2023_11_26_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/eks-auth-2023-11-26.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {}
    };
  }
});

// node_modules/aws-sdk/clients/eksauth.js
var require_eksauth = __commonJS({
  "node_modules/aws-sdk/clients/eksauth.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["eksauth"] = {};
    AWS2.EKSAuth = Service.defineService("eksauth", ["2023-11-26"]);
    Object.defineProperty(apiLoader.services["eksauth"], "2023-11-26", {
      get: function get() {
        var model = require_eks_auth_2023_11_26_min();
        model.paginators = require_eks_auth_2023_11_26_paginators().pagination;
        model.waiters = require_eks_auth_2023_11_26_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.EKSAuth;
  }
});

// node_modules/aws-sdk/apis/freetier-2023-09-07.min.json
var require_freetier_2023_09_07_min = __commonJS({
  "node_modules/aws-sdk/apis/freetier-2023-09-07.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2023-09-07",
        endpointPrefix: "freetier",
        jsonVersion: "1.0",
        protocol: "json",
        serviceFullName: "AWS Free Tier",
        serviceId: "FreeTier",
        signatureVersion: "v4",
        signingName: "freetier",
        targetPrefix: "AWSFreeTierService",
        uid: "freetier-2023-09-07"
      },
      operations: {
        GetFreeTierUsage: {
          input: {
            type: "structure",
            members: {
              filter: {
                shape: "S2"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "freeTierUsages"
            ],
            members: {
              freeTierUsages: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    actualUsageAmount: {
                      type: "double"
                    },
                    description: {},
                    forecastedUsageAmount: {
                      type: "double"
                    },
                    freeTierType: {},
                    limit: {
                      type: "double"
                    },
                    operation: {},
                    region: {},
                    service: {},
                    unit: {},
                    usageType: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          members: {
            And: {
              shape: "S3"
            },
            Dimensions: {
              type: "structure",
              required: [
                "Key",
                "MatchOptions",
                "Values"
              ],
              members: {
                Key: {},
                MatchOptions: {
                  type: "list",
                  member: {}
                },
                Values: {
                  type: "list",
                  member: {}
                }
              }
            },
            Not: {
              shape: "S2"
            },
            Or: {
              shape: "S3"
            }
          }
        },
        S3: {
          type: "list",
          member: {
            shape: "S2"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/freetier-2023-09-07.paginators.json
var require_freetier_2023_09_07_paginators = __commonJS({
  "node_modules/aws-sdk/apis/freetier-2023-09-07.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetFreeTierUsage: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "freeTierUsages"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/freetier.js
var require_freetier = __commonJS({
  "node_modules/aws-sdk/clients/freetier.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["freetier"] = {};
    AWS2.FreeTier = Service.defineService("freetier", ["2023-09-07"]);
    Object.defineProperty(apiLoader.services["freetier"], "2023-09-07", {
      get: function get() {
        var model = require_freetier_2023_09_07_min();
        model.paginators = require_freetier_2023_09_07_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.FreeTier;
  }
});

// node_modules/aws-sdk/apis/repostspace-2022-05-13.min.json
var require_repostspace_2022_05_13_min = __commonJS({
  "node_modules/aws-sdk/apis/repostspace-2022-05-13.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2022-05-13",
        endpointPrefix: "repostspace",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS re:Post Private",
        serviceId: "repostspace",
        signatureVersion: "v4",
        signingName: "repostspace",
        uid: "repostspace-2022-05-13"
      },
      operations: {
        CreateSpace: {
          http: {
            requestUri: "/spaces",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "subdomain",
              "tier"
            ],
            members: {
              description: {
                shape: "S2"
              },
              name: {
                shape: "S3"
              },
              roleArn: {},
              subdomain: {},
              tags: {
                shape: "S6"
              },
              tier: {},
              userKMSKey: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "spaceId"
            ],
            members: {
              spaceId: {}
            }
          },
          idempotent: true
        },
        DeleteSpace: {
          http: {
            method: "DELETE",
            requestUri: "/spaces/{spaceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "spaceId"
            ],
            members: {
              spaceId: {
                location: "uri",
                locationName: "spaceId"
              }
            }
          },
          idempotent: true
        },
        DeregisterAdmin: {
          http: {
            method: "DELETE",
            requestUri: "/spaces/{spaceId}/admins/{adminId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "adminId",
              "spaceId"
            ],
            members: {
              adminId: {
                location: "uri",
                locationName: "adminId"
              },
              spaceId: {
                location: "uri",
                locationName: "spaceId"
              }
            }
          },
          idempotent: true
        },
        GetSpace: {
          http: {
            method: "GET",
            requestUri: "/spaces/{spaceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "spaceId"
            ],
            members: {
              spaceId: {
                location: "uri",
                locationName: "spaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "clientId",
              "configurationStatus",
              "createDateTime",
              "name",
              "randomDomain",
              "spaceId",
              "status",
              "storageLimit",
              "tier",
              "vanityDomain",
              "vanityDomainStatus"
            ],
            members: {
              arn: {},
              clientId: {},
              configurationStatus: {},
              contentSize: {
                type: "long"
              },
              createDateTime: {
                shape: "Sl"
              },
              customerRoleArn: {},
              deleteDateTime: {
                shape: "Sl"
              },
              description: {
                shape: "S2"
              },
              groupAdmins: {
                type: "list",
                member: {}
              },
              name: {
                shape: "S3"
              },
              randomDomain: {},
              spaceId: {},
              status: {},
              storageLimit: {
                type: "long"
              },
              tier: {},
              userAdmins: {
                type: "list",
                member: {}
              },
              userCount: {
                type: "integer"
              },
              userKMSKey: {},
              vanityDomain: {},
              vanityDomainStatus: {}
            }
          }
        },
        ListSpaces: {
          http: {
            method: "GET",
            requestUri: "/spaces",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "spaces"
            ],
            members: {
              nextToken: {},
              spaces: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "configurationStatus",
                    "createDateTime",
                    "name",
                    "randomDomain",
                    "spaceId",
                    "status",
                    "storageLimit",
                    "tier",
                    "vanityDomain",
                    "vanityDomainStatus"
                  ],
                  members: {
                    arn: {},
                    configurationStatus: {},
                    contentSize: {
                      type: "long"
                    },
                    createDateTime: {
                      shape: "Sl"
                    },
                    deleteDateTime: {
                      shape: "Sl"
                    },
                    description: {
                      shape: "S2"
                    },
                    name: {
                      shape: "S3"
                    },
                    randomDomain: {},
                    spaceId: {},
                    status: {},
                    storageLimit: {
                      type: "long"
                    },
                    tier: {},
                    userCount: {
                      type: "integer"
                    },
                    userKMSKey: {},
                    vanityDomain: {},
                    vanityDomainStatus: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S6"
              }
            }
          }
        },
        RegisterAdmin: {
          http: {
            requestUri: "/spaces/{spaceId}/admins/{adminId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "adminId",
              "spaceId"
            ],
            members: {
              adminId: {
                location: "uri",
                locationName: "adminId"
              },
              spaceId: {
                location: "uri",
                locationName: "spaceId"
              }
            }
          },
          idempotent: true
        },
        SendInvites: {
          http: {
            requestUri: "/spaces/{spaceId}/invite",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "accessorIds",
              "body",
              "spaceId",
              "title"
            ],
            members: {
              accessorIds: {
                type: "list",
                member: {}
              },
              body: {
                type: "string",
                sensitive: true
              },
              spaceId: {
                location: "uri",
                locationName: "spaceId"
              },
              title: {
                type: "string",
                sensitive: true
              }
            }
          },
          idempotent: true
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateSpace: {
          http: {
            method: "PUT",
            requestUri: "/spaces/{spaceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "spaceId"
            ],
            members: {
              description: {
                shape: "S2"
              },
              roleArn: {},
              spaceId: {
                location: "uri",
                locationName: "spaceId"
              },
              tier: {}
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S2: {
          type: "string",
          sensitive: true
        },
        S3: {
          type: "string",
          sensitive: true
        },
        S6: {
          type: "map",
          key: {},
          value: {},
          sensitive: true
        },
        Sl: {
          type: "timestamp",
          timestampFormat: "iso8601"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/repostspace-2022-05-13.paginators.json
var require_repostspace_2022_05_13_paginators = __commonJS({
  "node_modules/aws-sdk/apis/repostspace-2022-05-13.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListSpaces: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "spaces"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/repostspace.js
var require_repostspace = __commonJS({
  "node_modules/aws-sdk/clients/repostspace.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["repostspace"] = {};
    AWS2.Repostspace = Service.defineService("repostspace", ["2022-05-13"]);
    Object.defineProperty(apiLoader.services["repostspace"], "2022-05-13", {
      get: function get() {
        var model = require_repostspace_2022_05_13_min();
        model.paginators = require_repostspace_2022_05_13_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.Repostspace;
  }
});

// node_modules/aws-sdk/apis/workspaces-thin-client-2023-08-22.min.json
var require_workspaces_thin_client_2023_08_22_min = __commonJS({
  "node_modules/aws-sdk/apis/workspaces-thin-client-2023-08-22.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2023-08-22",
        endpointPrefix: "thinclient",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon WorkSpaces Thin Client",
        serviceId: "WorkSpaces Thin Client",
        signatureVersion: "v4",
        signingName: "thinclient",
        uid: "workspaces-thin-client-2023-08-22"
      },
      operations: {
        CreateEnvironment: {
          http: {
            requestUri: "/environments",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "desktopArn"
            ],
            members: {
              name: {
                shape: "S2"
              },
              desktopArn: {},
              desktopEndpoint: {
                shape: "S4"
              },
              softwareSetUpdateSchedule: {},
              maintenanceWindow: {
                shape: "S6"
              },
              softwareSetUpdateMode: {},
              desiredSoftwareSetId: {},
              kmsKeyArn: {},
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "Sh"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              environment: {
                shape: "Sk"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DeleteDevice: {
          http: {
            method: "DELETE",
            requestUri: "/devices/{id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "api."
          },
          idempotent: true
        },
        DeleteEnvironment: {
          http: {
            method: "DELETE",
            requestUri: "/environments/{id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "api."
          },
          idempotent: true
        },
        DeregisterDevice: {
          http: {
            requestUri: "/deregister-device/{id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              targetDeviceStatus: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "api."
          },
          idempotent: true
        },
        GetDevice: {
          http: {
            method: "GET",
            requestUri: "/devices/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              device: {
                type: "structure",
                members: {
                  id: {},
                  serialNumber: {},
                  name: {
                    shape: "S11"
                  },
                  model: {},
                  environmentId: {},
                  status: {},
                  currentSoftwareSetId: {},
                  currentSoftwareSetVersion: {},
                  desiredSoftwareSetId: {},
                  pendingSoftwareSetId: {},
                  pendingSoftwareSetVersion: {},
                  softwareSetUpdateSchedule: {},
                  softwareSetComplianceStatus: {},
                  softwareSetUpdateStatus: {},
                  lastConnectedAt: {
                    type: "timestamp"
                  },
                  lastPostureAt: {
                    type: "timestamp"
                  },
                  createdAt: {
                    type: "timestamp"
                  },
                  updatedAt: {
                    type: "timestamp"
                  },
                  arn: {},
                  kmsKeyArn: {},
                  tags: {
                    shape: "Sp"
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        GetEnvironment: {
          http: {
            method: "GET",
            requestUri: "/environments/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              environment: {
                type: "structure",
                members: {
                  id: {},
                  name: {
                    shape: "S2"
                  },
                  desktopArn: {},
                  desktopEndpoint: {
                    shape: "S4"
                  },
                  desktopType: {},
                  activationCode: {},
                  registeredDevicesCount: {
                    type: "integer"
                  },
                  softwareSetUpdateSchedule: {},
                  maintenanceWindow: {
                    shape: "S6"
                  },
                  softwareSetUpdateMode: {},
                  desiredSoftwareSetId: {},
                  pendingSoftwareSetId: {},
                  pendingSoftwareSetVersion: {},
                  softwareSetComplianceStatus: {},
                  createdAt: {
                    type: "timestamp"
                  },
                  updatedAt: {
                    type: "timestamp"
                  },
                  arn: {},
                  kmsKeyArn: {},
                  tags: {
                    shape: "Sp"
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        GetSoftwareSet: {
          http: {
            method: "GET",
            requestUri: "/softwaresets/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              softwareSet: {
                type: "structure",
                members: {
                  id: {},
                  version: {},
                  releasedAt: {
                    type: "timestamp"
                  },
                  supportedUntil: {
                    type: "timestamp"
                  },
                  validationStatus: {},
                  software: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        name: {},
                        version: {}
                      }
                    }
                  },
                  arn: {}
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListDevices: {
          http: {
            method: "GET",
            requestUri: "/devices",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              devices: {
                type: "list",
                member: {
                  shape: "S1l"
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListEnvironments: {
          http: {
            method: "GET",
            requestUri: "/environments",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              environments: {
                type: "list",
                member: {
                  shape: "Sk"
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListSoftwareSets: {
          http: {
            method: "GET",
            requestUri: "/softwaresets",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              softwareSets: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    version: {},
                    releasedAt: {
                      type: "timestamp"
                    },
                    supportedUntil: {
                      type: "timestamp"
                    },
                    validationStatus: {},
                    arn: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sh"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sh"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {},
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "api."
          },
          idempotent: true
        },
        UpdateDevice: {
          http: {
            method: "PATCH",
            requestUri: "/devices/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              name: {
                shape: "S11"
              },
              desiredSoftwareSetId: {},
              softwareSetUpdateSchedule: {},
              kmsKeyArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              device: {
                shape: "S1l"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          },
          idempotent: true
        },
        UpdateEnvironment: {
          http: {
            method: "PATCH",
            requestUri: "/environments/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              name: {
                shape: "S2"
              },
              desktopArn: {},
              desktopEndpoint: {
                shape: "S4"
              },
              softwareSetUpdateSchedule: {},
              maintenanceWindow: {
                shape: "S6"
              },
              softwareSetUpdateMode: {},
              desiredSoftwareSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              environment: {
                shape: "Sk"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          },
          idempotent: true
        },
        UpdateSoftwareSet: {
          http: {
            method: "PATCH",
            requestUri: "/softwaresets/{id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "id",
              "validationStatus"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              validationStatus: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "api."
          },
          idempotent: true
        }
      },
      shapes: {
        S2: {
          type: "string",
          sensitive: true
        },
        S4: {
          type: "string",
          sensitive: true
        },
        S6: {
          type: "structure",
          members: {
            type: {},
            startTimeHour: {
              type: "integer"
            },
            startTimeMinute: {
              type: "integer"
            },
            endTimeHour: {
              type: "integer"
            },
            endTimeMinute: {
              type: "integer"
            },
            daysOfTheWeek: {
              type: "list",
              member: {}
            },
            applyTimeOf: {}
          }
        },
        Sh: {
          type: "map",
          key: {},
          value: {},
          sensitive: true
        },
        Sk: {
          type: "structure",
          members: {
            id: {},
            name: {
              shape: "S2"
            },
            desktopArn: {},
            desktopEndpoint: {
              shape: "S4"
            },
            desktopType: {},
            activationCode: {},
            softwareSetUpdateSchedule: {},
            maintenanceWindow: {
              shape: "S6"
            },
            softwareSetUpdateMode: {},
            desiredSoftwareSetId: {},
            pendingSoftwareSetId: {},
            createdAt: {
              type: "timestamp"
            },
            updatedAt: {
              type: "timestamp"
            },
            arn: {},
            tags: {
              shape: "Sp"
            }
          }
        },
        Sp: {
          type: "structure",
          members: {
            resourceArn: {},
            internalId: {}
          },
          sensitive: true
        },
        S11: {
          type: "string",
          sensitive: true
        },
        S1l: {
          type: "structure",
          members: {
            id: {},
            serialNumber: {},
            name: {
              shape: "S11"
            },
            model: {},
            environmentId: {},
            status: {},
            currentSoftwareSetId: {},
            desiredSoftwareSetId: {},
            pendingSoftwareSetId: {},
            softwareSetUpdateSchedule: {},
            lastConnectedAt: {
              type: "timestamp"
            },
            lastPostureAt: {
              type: "timestamp"
            },
            createdAt: {
              type: "timestamp"
            },
            updatedAt: {
              type: "timestamp"
            },
            arn: {},
            tags: {
              shape: "Sp"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/workspaces-thin-client-2023-08-22.paginators.json
var require_workspaces_thin_client_2023_08_22_paginators = __commonJS({
  "node_modules/aws-sdk/apis/workspaces-thin-client-2023-08-22.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListDevices: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "devices"
        },
        ListEnvironments: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "environments"
        },
        ListSoftwareSets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "softwareSets"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/workspacesthinclient.js
var require_workspacesthinclient = __commonJS({
  "node_modules/aws-sdk/clients/workspacesthinclient.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["workspacesthinclient"] = {};
    AWS2.WorkSpacesThinClient = Service.defineService("workspacesthinclient", ["2023-08-22"]);
    Object.defineProperty(apiLoader.services["workspacesthinclient"], "2023-08-22", {
      get: function get() {
        var model = require_workspaces_thin_client_2023_08_22_min();
        model.paginators = require_workspaces_thin_client_2023_08_22_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.WorkSpacesThinClient;
  }
});

// node_modules/aws-sdk/apis/b2bi-2022-06-23.min.json
var require_b2bi_2022_06_23_min = __commonJS({
  "node_modules/aws-sdk/apis/b2bi-2022-06-23.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2022-06-23",
        endpointPrefix: "b2bi",
        jsonVersion: "1.0",
        protocol: "json",
        serviceAbbreviation: "AWS B2BI",
        serviceFullName: "AWS B2B Data Interchange",
        serviceId: "b2bi",
        signatureVersion: "v4",
        signingName: "b2bi",
        targetPrefix: "B2BI",
        uid: "b2bi-2022-06-23"
      },
      operations: {
        CreateCapability: {
          input: {
            type: "structure",
            required: [
              "name",
              "type",
              "configuration"
            ],
            members: {
              name: {},
              type: {},
              configuration: {
                shape: "S4"
              },
              instructionsDocuments: {
                shape: "Se"
              },
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "capabilityId",
              "capabilityArn",
              "name",
              "type",
              "configuration",
              "createdAt"
            ],
            members: {
              capabilityId: {},
              capabilityArn: {},
              name: {},
              type: {},
              configuration: {
                shape: "S4"
              },
              instructionsDocuments: {
                shape: "Se"
              },
              createdAt: {
                shape: "Sn"
              }
            }
          },
          idempotent: true
        },
        CreatePartnership: {
          input: {
            type: "structure",
            required: [
              "profileId",
              "name",
              "email"
            ],
            members: {
              profileId: {},
              name: {},
              email: {
                shape: "Sr"
              },
              phone: {
                shape: "Ss"
              },
              capabilities: {
                shape: "St"
              },
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "profileId",
              "partnershipId",
              "partnershipArn",
              "createdAt"
            ],
            members: {
              profileId: {},
              partnershipId: {},
              partnershipArn: {},
              name: {},
              email: {
                shape: "Sr"
              },
              phone: {
                shape: "Ss"
              },
              capabilities: {
                shape: "St"
              },
              tradingPartnerId: {},
              createdAt: {
                shape: "Sn"
              }
            }
          },
          idempotent: true
        },
        CreateProfile: {
          input: {
            type: "structure",
            required: [
              "name",
              "phone",
              "businessName",
              "logging"
            ],
            members: {
              name: {},
              email: {
                shape: "Sr"
              },
              phone: {
                shape: "Ss"
              },
              businessName: {},
              logging: {},
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "profileId",
              "profileArn",
              "name",
              "businessName",
              "phone",
              "createdAt"
            ],
            members: {
              profileId: {},
              profileArn: {},
              name: {},
              businessName: {},
              phone: {
                shape: "Ss"
              },
              email: {
                shape: "Sr"
              },
              logging: {},
              logGroupName: {},
              createdAt: {
                shape: "Sn"
              }
            }
          },
          idempotent: true
        },
        CreateTransformer: {
          input: {
            type: "structure",
            required: [
              "name",
              "fileFormat",
              "mappingTemplate",
              "ediType"
            ],
            members: {
              name: {},
              fileFormat: {},
              mappingTemplate: {},
              ediType: {
                shape: "S6"
              },
              sampleDocument: {},
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "transformerId",
              "transformerArn",
              "name",
              "fileFormat",
              "mappingTemplate",
              "status",
              "ediType",
              "createdAt"
            ],
            members: {
              transformerId: {},
              transformerArn: {},
              name: {},
              fileFormat: {},
              mappingTemplate: {},
              status: {},
              ediType: {
                shape: "S6"
              },
              sampleDocument: {},
              createdAt: {
                shape: "Sn"
              }
            }
          },
          idempotent: true
        },
        DeleteCapability: {
          input: {
            type: "structure",
            required: [
              "capabilityId"
            ],
            members: {
              capabilityId: {}
            }
          },
          idempotent: true
        },
        DeletePartnership: {
          input: {
            type: "structure",
            required: [
              "partnershipId"
            ],
            members: {
              partnershipId: {}
            }
          },
          idempotent: true
        },
        DeleteProfile: {
          input: {
            type: "structure",
            required: [
              "profileId"
            ],
            members: {
              profileId: {}
            }
          },
          idempotent: true
        },
        DeleteTransformer: {
          input: {
            type: "structure",
            required: [
              "transformerId"
            ],
            members: {
              transformerId: {}
            }
          },
          idempotent: true
        },
        GetCapability: {
          input: {
            type: "structure",
            required: [
              "capabilityId"
            ],
            members: {
              capabilityId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "capabilityId",
              "capabilityArn",
              "name",
              "type",
              "configuration",
              "createdAt"
            ],
            members: {
              capabilityId: {},
              capabilityArn: {},
              name: {},
              type: {},
              configuration: {
                shape: "S4"
              },
              instructionsDocuments: {
                shape: "Se"
              },
              createdAt: {
                shape: "Sn"
              },
              modifiedAt: {
                shape: "S1g"
              }
            }
          }
        },
        GetPartnership: {
          input: {
            type: "structure",
            required: [
              "partnershipId"
            ],
            members: {
              partnershipId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "profileId",
              "partnershipId",
              "partnershipArn",
              "createdAt"
            ],
            members: {
              profileId: {},
              partnershipId: {},
              partnershipArn: {},
              name: {},
              email: {
                shape: "Sr"
              },
              phone: {
                shape: "Ss"
              },
              capabilities: {
                shape: "St"
              },
              tradingPartnerId: {},
              createdAt: {
                shape: "Sn"
              },
              modifiedAt: {
                shape: "S1g"
              }
            }
          }
        },
        GetProfile: {
          input: {
            type: "structure",
            required: [
              "profileId"
            ],
            members: {
              profileId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "profileId",
              "profileArn",
              "name",
              "phone",
              "businessName",
              "createdAt"
            ],
            members: {
              profileId: {},
              profileArn: {},
              name: {},
              email: {
                shape: "Sr"
              },
              phone: {
                shape: "Ss"
              },
              businessName: {},
              logging: {},
              logGroupName: {},
              createdAt: {
                shape: "Sn"
              },
              modifiedAt: {
                shape: "S1g"
              }
            }
          }
        },
        GetTransformer: {
          input: {
            type: "structure",
            required: [
              "transformerId"
            ],
            members: {
              transformerId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "transformerId",
              "transformerArn",
              "name",
              "fileFormat",
              "mappingTemplate",
              "status",
              "ediType",
              "createdAt"
            ],
            members: {
              transformerId: {},
              transformerArn: {},
              name: {},
              fileFormat: {},
              mappingTemplate: {},
              status: {},
              ediType: {
                shape: "S6"
              },
              sampleDocument: {},
              createdAt: {
                shape: "Sn"
              },
              modifiedAt: {
                shape: "S1g"
              }
            }
          }
        },
        GetTransformerJob: {
          input: {
            type: "structure",
            required: [
              "transformerJobId",
              "transformerId"
            ],
            members: {
              transformerJobId: {},
              transformerId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "status"
            ],
            members: {
              status: {},
              outputFiles: {
                type: "list",
                member: {
                  shape: "Sa"
                }
              },
              message: {}
            }
          }
        },
        ListCapabilities: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "capabilities"
            ],
            members: {
              capabilities: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "capabilityId",
                    "name",
                    "type",
                    "createdAt"
                  ],
                  members: {
                    capabilityId: {},
                    name: {},
                    type: {},
                    createdAt: {
                      shape: "Sn"
                    },
                    modifiedAt: {
                      shape: "S1g"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListPartnerships: {
          input: {
            type: "structure",
            members: {
              profileId: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "partnerships"
            ],
            members: {
              partnerships: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "profileId",
                    "partnershipId",
                    "createdAt"
                  ],
                  members: {
                    profileId: {},
                    partnershipId: {},
                    name: {},
                    capabilities: {
                      shape: "St"
                    },
                    tradingPartnerId: {},
                    createdAt: {
                      shape: "Sn"
                    },
                    modifiedAt: {
                      shape: "S1g"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListProfiles: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "profiles"
            ],
            members: {
              profiles: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "profileId",
                    "name",
                    "businessName",
                    "createdAt"
                  ],
                  members: {
                    profileId: {},
                    name: {},
                    businessName: {},
                    logging: {},
                    logGroupName: {},
                    createdAt: {
                      shape: "Sn"
                    },
                    modifiedAt: {
                      shape: "S1g"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sg"
              }
            }
          }
        },
        ListTransformers: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "transformers"
            ],
            members: {
              transformers: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "transformerId",
                    "name",
                    "fileFormat",
                    "mappingTemplate",
                    "status",
                    "ediType",
                    "createdAt"
                  ],
                  members: {
                    transformerId: {},
                    name: {},
                    fileFormat: {},
                    mappingTemplate: {},
                    status: {},
                    ediType: {
                      shape: "S6"
                    },
                    sampleDocument: {},
                    createdAt: {
                      shape: "Sn"
                    },
                    modifiedAt: {
                      shape: "S1g"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        StartTransformerJob: {
          input: {
            type: "structure",
            required: [
              "inputFile",
              "outputLocation",
              "transformerId"
            ],
            members: {
              inputFile: {
                shape: "Sa"
              },
              outputLocation: {
                shape: "Sa"
              },
              transformerId: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "transformerJobId"
            ],
            members: {
              transformerJobId: {}
            }
          },
          idempotent: true
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "Sg"
              }
            }
          }
        },
        TestMapping: {
          input: {
            type: "structure",
            required: [
              "inputFileContent",
              "mappingTemplate",
              "fileFormat"
            ],
            members: {
              inputFileContent: {},
              mappingTemplate: {},
              fileFormat: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "mappedFileContent"
            ],
            members: {
              mappedFileContent: {}
            }
          },
          idempotent: true
        },
        TestParsing: {
          input: {
            type: "structure",
            required: [
              "inputFile",
              "fileFormat",
              "ediType"
            ],
            members: {
              inputFile: {
                shape: "Sa"
              },
              fileFormat: {},
              ediType: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "parsedFileContent"
            ],
            members: {
              parsedFileContent: {}
            }
          },
          idempotent: true
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          idempotent: true
        },
        UpdateCapability: {
          input: {
            type: "structure",
            required: [
              "capabilityId"
            ],
            members: {
              capabilityId: {},
              name: {},
              configuration: {
                shape: "S4"
              },
              instructionsDocuments: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "capabilityId",
              "capabilityArn",
              "name",
              "type",
              "configuration",
              "createdAt"
            ],
            members: {
              capabilityId: {},
              capabilityArn: {},
              name: {},
              type: {},
              configuration: {
                shape: "S4"
              },
              instructionsDocuments: {
                shape: "Se"
              },
              createdAt: {
                shape: "Sn"
              },
              modifiedAt: {
                shape: "S1g"
              }
            }
          },
          idempotent: true
        },
        UpdatePartnership: {
          input: {
            type: "structure",
            required: [
              "partnershipId"
            ],
            members: {
              partnershipId: {},
              name: {},
              capabilities: {
                shape: "St"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "profileId",
              "partnershipId",
              "partnershipArn",
              "createdAt"
            ],
            members: {
              profileId: {},
              partnershipId: {},
              partnershipArn: {},
              name: {},
              email: {
                shape: "Sr"
              },
              phone: {
                shape: "Ss"
              },
              capabilities: {
                shape: "St"
              },
              tradingPartnerId: {},
              createdAt: {
                shape: "Sn"
              },
              modifiedAt: {
                shape: "S1g"
              }
            }
          },
          idempotent: true
        },
        UpdateProfile: {
          input: {
            type: "structure",
            required: [
              "profileId"
            ],
            members: {
              profileId: {},
              name: {},
              email: {
                shape: "Sr"
              },
              phone: {
                shape: "Ss"
              },
              businessName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "profileId",
              "profileArn",
              "name",
              "phone",
              "businessName",
              "createdAt"
            ],
            members: {
              profileId: {},
              profileArn: {},
              name: {},
              email: {
                shape: "Sr"
              },
              phone: {
                shape: "Ss"
              },
              businessName: {},
              logging: {},
              logGroupName: {},
              createdAt: {
                shape: "Sn"
              },
              modifiedAt: {
                shape: "S1g"
              }
            }
          },
          idempotent: true
        },
        UpdateTransformer: {
          input: {
            type: "structure",
            required: [
              "transformerId"
            ],
            members: {
              transformerId: {},
              name: {},
              fileFormat: {},
              mappingTemplate: {},
              status: {},
              ediType: {
                shape: "S6"
              },
              sampleDocument: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "transformerId",
              "transformerArn",
              "name",
              "fileFormat",
              "mappingTemplate",
              "status",
              "ediType",
              "createdAt",
              "modifiedAt"
            ],
            members: {
              transformerId: {},
              transformerArn: {},
              name: {},
              fileFormat: {},
              mappingTemplate: {},
              status: {},
              ediType: {
                shape: "S6"
              },
              sampleDocument: {},
              createdAt: {
                shape: "Sn"
              },
              modifiedAt: {
                shape: "S1g"
              }
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            edi: {
              type: "structure",
              required: [
                "type",
                "inputLocation",
                "outputLocation",
                "transformerId"
              ],
              members: {
                type: {
                  shape: "S6"
                },
                inputLocation: {
                  shape: "Sa"
                },
                outputLocation: {
                  shape: "Sa"
                },
                transformerId: {}
              }
            }
          },
          union: true
        },
        S6: {
          type: "structure",
          members: {
            x12Details: {
              type: "structure",
              members: {
                transactionSet: {},
                version: {}
              }
            }
          },
          union: true
        },
        Sa: {
          type: "structure",
          members: {
            bucketName: {},
            key: {}
          }
        },
        Se: {
          type: "list",
          member: {
            shape: "Sa"
          }
        },
        Sg: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sn: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        Sr: {
          type: "string",
          sensitive: true
        },
        Ss: {
          type: "string",
          sensitive: true
        },
        St: {
          type: "list",
          member: {}
        },
        S1g: {
          type: "timestamp",
          timestampFormat: "iso8601"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/b2bi-2022-06-23.paginators.json
var require_b2bi_2022_06_23_paginators = __commonJS({
  "node_modules/aws-sdk/apis/b2bi-2022-06-23.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListCapabilities: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "capabilities"
        },
        ListPartnerships: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "partnerships"
        },
        ListProfiles: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "profiles"
        },
        ListTransformers: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "transformers"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/b2bi.js
var require_b2bi = __commonJS({
  "node_modules/aws-sdk/clients/b2bi.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["b2bi"] = {};
    AWS2.B2bi = Service.defineService("b2bi", ["2022-06-23"]);
    Object.defineProperty(apiLoader.services["b2bi"], "2022-06-23", {
      get: function get() {
        var model = require_b2bi_2022_06_23_min();
        model.paginators = require_b2bi_2022_06_23_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.B2bi;
  }
});

// node_modules/aws-sdk/apis/bedrock-agent-2023-06-05.min.json
var require_bedrock_agent_2023_06_05_min = __commonJS({
  "node_modules/aws-sdk/apis/bedrock-agent-2023-06-05.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2023-06-05",
        endpointPrefix: "bedrock-agent",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Agents for Amazon Bedrock",
        serviceId: "Bedrock Agent",
        signatureVersion: "v4",
        signingName: "bedrock",
        uid: "bedrock-agent-2023-06-05"
      },
      operations: {
        AssociateAgentKnowledgeBase: {
          http: {
            method: "PUT",
            requestUri: "/agents/{agentId}/agentversions/{agentVersion}/knowledgebases/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "agentId",
              "agentVersion",
              "knowledgeBaseId",
              "description"
            ],
            members: {
              agentId: {
                location: "uri",
                locationName: "agentId"
              },
              agentVersion: {
                location: "uri",
                locationName: "agentVersion"
              },
              knowledgeBaseId: {},
              description: {},
              knowledgeBaseState: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "agentKnowledgeBase"
            ],
            members: {
              agentKnowledgeBase: {
                shape: "S7"
              }
            }
          },
          idempotent: true
        },
        CreateAgent: {
          http: {
            method: "PUT",
            requestUri: "/agents/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "agentName",
              "agentResourceRoleArn"
            ],
            members: {
              agentName: {},
              clientToken: {
                idempotencyToken: true
              },
              instruction: {
                shape: "Sd"
              },
              foundationModel: {},
              description: {},
              idleSessionTTLInSeconds: {
                type: "integer"
              },
              agentResourceRoleArn: {},
              customerEncryptionKeyArn: {},
              tags: {
                shape: "Si"
              },
              promptOverrideConfiguration: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "agent"
            ],
            members: {
              agent: {
                shape: "S11"
              }
            }
          },
          idempotent: true
        },
        CreateAgentActionGroup: {
          http: {
            method: "PUT",
            requestUri: "/agents/{agentId}/agentversions/{agentVersion}/actiongroups/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "agentId",
              "agentVersion",
              "actionGroupName"
            ],
            members: {
              agentId: {
                location: "uri",
                locationName: "agentId"
              },
              agentVersion: {
                location: "uri",
                locationName: "agentVersion"
              },
              actionGroupName: {},
              clientToken: {
                idempotencyToken: true
              },
              description: {},
              parentActionGroupSignature: {},
              actionGroupExecutor: {
                shape: "S1a"
              },
              apiSchema: {
                shape: "S1b"
              },
              actionGroupState: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "agentActionGroup"
            ],
            members: {
              agentActionGroup: {
                shape: "S1i"
              }
            }
          },
          idempotent: true
        },
        CreateAgentAlias: {
          http: {
            method: "PUT",
            requestUri: "/agents/{agentId}/agentaliases/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "agentId",
              "agentAliasName"
            ],
            members: {
              agentId: {
                location: "uri",
                locationName: "agentId"
              },
              agentAliasName: {},
              clientToken: {
                idempotencyToken: true
              },
              description: {},
              routingConfiguration: {
                shape: "S1k"
              },
              tags: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "agentAlias"
            ],
            members: {
              agentAlias: {
                shape: "S1n"
              }
            }
          },
          idempotent: true
        },
        CreateDataSource: {
          http: {
            method: "PUT",
            requestUri: "/knowledgebases/{knowledgeBaseId}/datasources/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId",
              "name",
              "dataSourceConfiguration"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              clientToken: {
                idempotencyToken: true
              },
              name: {},
              description: {},
              dataSourceConfiguration: {
                shape: "S1u"
              },
              serverSideEncryptionConfiguration: {
                shape: "S20"
              },
              vectorIngestionConfiguration: {
                shape: "S21"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "dataSource"
            ],
            members: {
              dataSource: {
                shape: "S28"
              }
            }
          },
          idempotent: true
        },
        CreateKnowledgeBase: {
          http: {
            method: "PUT",
            requestUri: "/knowledgebases/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "name",
              "roleArn",
              "knowledgeBaseConfiguration",
              "storageConfiguration"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              name: {},
              description: {},
              roleArn: {},
              knowledgeBaseConfiguration: {
                shape: "S2c"
              },
              storageConfiguration: {
                shape: "S2g"
              },
              tags: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "knowledgeBase"
            ],
            members: {
              knowledgeBase: {
                shape: "S33"
              }
            }
          },
          idempotent: true
        },
        DeleteAgent: {
          http: {
            method: "DELETE",
            requestUri: "/agents/{agentId}/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "agentId"
            ],
            members: {
              agentId: {
                location: "uri",
                locationName: "agentId"
              },
              skipResourceInUseCheck: {
                location: "querystring",
                locationName: "skipResourceInUseCheck",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "agentId",
              "agentStatus"
            ],
            members: {
              agentId: {},
              agentStatus: {}
            }
          },
          idempotent: true
        },
        DeleteAgentActionGroup: {
          http: {
            method: "DELETE",
            requestUri: "/agents/{agentId}/agentversions/{agentVersion}/actiongroups/{actionGroupId}/",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "agentId",
              "agentVersion",
              "actionGroupId"
            ],
            members: {
              agentId: {
                location: "uri",
                locationName: "agentId"
              },
              agentVersion: {
                location: "uri",
                locationName: "agentVersion"
              },
              actionGroupId: {
                location: "uri",
                locationName: "actionGroupId"
              },
              skipResourceInUseCheck: {
                location: "querystring",
                locationName: "skipResourceInUseCheck",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteAgentAlias: {
          http: {
            method: "DELETE",
            requestUri: "/agents/{agentId}/agentaliases/{agentAliasId}/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "agentId",
              "agentAliasId"
            ],
            members: {
              agentId: {
                location: "uri",
                locationName: "agentId"
              },
              agentAliasId: {
                location: "uri",
                locationName: "agentAliasId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "agentId",
              "agentAliasId",
              "agentAliasStatus"
            ],
            members: {
              agentId: {},
              agentAliasId: {},
              agentAliasStatus: {}
            }
          },
          idempotent: true
        },
        DeleteAgentVersion: {
          http: {
            method: "DELETE",
            requestUri: "/agents/{agentId}/agentversions/{agentVersion}/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "agentId",
              "agentVersion"
            ],
            members: {
              agentId: {
                location: "uri",
                locationName: "agentId"
              },
              agentVersion: {
                location: "uri",
                locationName: "agentVersion"
              },
              skipResourceInUseCheck: {
                location: "querystring",
                locationName: "skipResourceInUseCheck",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "agentId",
              "agentVersion",
              "agentStatus"
            ],
            members: {
              agentId: {},
              agentVersion: {},
              agentStatus: {}
            }
          },
          idempotent: true
        },
        DeleteDataSource: {
          http: {
            method: "DELETE",
            requestUri: "/knowledgebases/{knowledgeBaseId}/datasources/{dataSourceId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId",
              "dataSourceId"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              dataSourceId: {
                location: "uri",
                locationName: "dataSourceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "knowledgeBaseId",
              "dataSourceId",
              "status"
            ],
            members: {
              knowledgeBaseId: {},
              dataSourceId: {},
              status: {}
            }
          },
          idempotent: true
        },
        DeleteKnowledgeBase: {
          http: {
            method: "DELETE",
            requestUri: "/knowledgebases/{knowledgeBaseId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "knowledgeBaseId",
              "status"
            ],
            members: {
              knowledgeBaseId: {},
              status: {}
            }
          },
          idempotent: true
        },
        DisassociateAgentKnowledgeBase: {
          http: {
            method: "DELETE",
            requestUri: "/agents/{agentId}/agentversions/{agentVersion}/knowledgebases/{knowledgeBaseId}/",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "agentId",
              "agentVersion",
              "knowledgeBaseId"
            ],
            members: {
              agentId: {
                location: "uri",
                locationName: "agentId"
              },
              agentVersion: {
                location: "uri",
                locationName: "agentVersion"
              },
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        GetAgent: {
          http: {
            method: "GET",
            requestUri: "/agents/{agentId}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "agentId"
            ],
            members: {
              agentId: {
                location: "uri",
                locationName: "agentId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "agent"
            ],
            members: {
              agent: {
                shape: "S11"
              }
            }
          }
        },
        GetAgentActionGroup: {
          http: {
            method: "GET",
            requestUri: "/agents/{agentId}/agentversions/{agentVersion}/actiongroups/{actionGroupId}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "agentId",
              "agentVersion",
              "actionGroupId"
            ],
            members: {
              agentId: {
                location: "uri",
                locationName: "agentId"
              },
              agentVersion: {
                location: "uri",
                locationName: "agentVersion"
              },
              actionGroupId: {
                location: "uri",
                locationName: "actionGroupId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "agentActionGroup"
            ],
            members: {
              agentActionGroup: {
                shape: "S1i"
              }
            }
          }
        },
        GetAgentAlias: {
          http: {
            method: "GET",
            requestUri: "/agents/{agentId}/agentaliases/{agentAliasId}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "agentId",
              "agentAliasId"
            ],
            members: {
              agentId: {
                location: "uri",
                locationName: "agentId"
              },
              agentAliasId: {
                location: "uri",
                locationName: "agentAliasId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "agentAlias"
            ],
            members: {
              agentAlias: {
                shape: "S1n"
              }
            }
          }
        },
        GetAgentKnowledgeBase: {
          http: {
            method: "GET",
            requestUri: "/agents/{agentId}/agentversions/{agentVersion}/knowledgebases/{knowledgeBaseId}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "agentId",
              "agentVersion",
              "knowledgeBaseId"
            ],
            members: {
              agentId: {
                location: "uri",
                locationName: "agentId"
              },
              agentVersion: {
                location: "uri",
                locationName: "agentVersion"
              },
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "agentKnowledgeBase"
            ],
            members: {
              agentKnowledgeBase: {
                shape: "S7"
              }
            }
          }
        },
        GetAgentVersion: {
          http: {
            method: "GET",
            requestUri: "/agents/{agentId}/agentversions/{agentVersion}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "agentId",
              "agentVersion"
            ],
            members: {
              agentId: {
                location: "uri",
                locationName: "agentId"
              },
              agentVersion: {
                location: "uri",
                locationName: "agentVersion"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "agentVersion"
            ],
            members: {
              agentVersion: {
                type: "structure",
                required: [
                  "agentId",
                  "agentName",
                  "agentArn",
                  "version",
                  "agentStatus",
                  "idleSessionTTLInSeconds",
                  "agentResourceRoleArn",
                  "createdAt",
                  "updatedAt"
                ],
                members: {
                  agentId: {},
                  agentName: {},
                  agentArn: {},
                  version: {},
                  instruction: {
                    shape: "Sd"
                  },
                  agentStatus: {},
                  foundationModel: {},
                  description: {},
                  idleSessionTTLInSeconds: {
                    type: "integer"
                  },
                  agentResourceRoleArn: {},
                  customerEncryptionKeyArn: {},
                  createdAt: {
                    shape: "S9"
                  },
                  updatedAt: {
                    shape: "S9"
                  },
                  failureReasons: {
                    shape: "S14"
                  },
                  recommendedActions: {
                    shape: "S16"
                  },
                  promptOverrideConfiguration: {
                    shape: "Sl"
                  }
                }
              }
            }
          }
        },
        GetDataSource: {
          http: {
            method: "GET",
            requestUri: "/knowledgebases/{knowledgeBaseId}/datasources/{dataSourceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId",
              "dataSourceId"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              dataSourceId: {
                location: "uri",
                locationName: "dataSourceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "dataSource"
            ],
            members: {
              dataSource: {
                shape: "S28"
              }
            }
          }
        },
        GetIngestionJob: {
          http: {
            method: "GET",
            requestUri: "/knowledgebases/{knowledgeBaseId}/datasources/{dataSourceId}/ingestionjobs/{ingestionJobId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId",
              "dataSourceId",
              "ingestionJobId"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              dataSourceId: {
                location: "uri",
                locationName: "dataSourceId"
              },
              ingestionJobId: {
                location: "uri",
                locationName: "ingestionJobId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ingestionJob"
            ],
            members: {
              ingestionJob: {
                shape: "S41"
              }
            }
          }
        },
        GetKnowledgeBase: {
          http: {
            method: "GET",
            requestUri: "/knowledgebases/{knowledgeBaseId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "knowledgeBase"
            ],
            members: {
              knowledgeBase: {
                shape: "S33"
              }
            }
          }
        },
        ListAgentActionGroups: {
          http: {
            requestUri: "/agents/{agentId}/agentversions/{agentVersion}/actiongroups/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "agentId",
              "agentVersion"
            ],
            members: {
              agentId: {
                location: "uri",
                locationName: "agentId"
              },
              agentVersion: {
                location: "uri",
                locationName: "agentVersion"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "actionGroupSummaries"
            ],
            members: {
              actionGroupSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "actionGroupId",
                    "actionGroupName",
                    "actionGroupState",
                    "updatedAt"
                  ],
                  members: {
                    actionGroupId: {},
                    actionGroupName: {},
                    actionGroupState: {},
                    description: {},
                    updatedAt: {
                      shape: "S9"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAgentAliases: {
          http: {
            requestUri: "/agents/{agentId}/agentaliases/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "agentId"
            ],
            members: {
              agentId: {
                location: "uri",
                locationName: "agentId"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "agentAliasSummaries"
            ],
            members: {
              agentAliasSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "agentAliasId",
                    "agentAliasName",
                    "agentAliasStatus",
                    "createdAt",
                    "updatedAt"
                  ],
                  members: {
                    agentAliasId: {},
                    agentAliasName: {},
                    description: {},
                    routingConfiguration: {
                      shape: "S1k"
                    },
                    agentAliasStatus: {},
                    createdAt: {
                      shape: "S9"
                    },
                    updatedAt: {
                      shape: "S9"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAgentKnowledgeBases: {
          http: {
            requestUri: "/agents/{agentId}/agentversions/{agentVersion}/knowledgebases/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "agentId",
              "agentVersion"
            ],
            members: {
              agentId: {
                location: "uri",
                locationName: "agentId"
              },
              agentVersion: {
                location: "uri",
                locationName: "agentVersion"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "agentKnowledgeBaseSummaries"
            ],
            members: {
              agentKnowledgeBaseSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "knowledgeBaseId",
                    "knowledgeBaseState",
                    "updatedAt"
                  ],
                  members: {
                    knowledgeBaseId: {},
                    description: {},
                    knowledgeBaseState: {},
                    updatedAt: {
                      shape: "S9"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAgentVersions: {
          http: {
            requestUri: "/agents/{agentId}/agentversions/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "agentId"
            ],
            members: {
              agentId: {
                location: "uri",
                locationName: "agentId"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "agentVersionSummaries"
            ],
            members: {
              agentVersionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "agentName",
                    "agentStatus",
                    "agentVersion",
                    "createdAt",
                    "updatedAt"
                  ],
                  members: {
                    agentName: {},
                    agentStatus: {},
                    agentVersion: {},
                    createdAt: {
                      shape: "S9"
                    },
                    updatedAt: {
                      shape: "S9"
                    },
                    description: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAgents: {
          http: {
            requestUri: "/agents/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "agentSummaries"
            ],
            members: {
              agentSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "agentId",
                    "agentName",
                    "agentStatus",
                    "updatedAt"
                  ],
                  members: {
                    agentId: {},
                    agentName: {},
                    agentStatus: {},
                    description: {},
                    updatedAt: {
                      shape: "S9"
                    },
                    latestAgentVersion: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDataSources: {
          http: {
            requestUri: "/knowledgebases/{knowledgeBaseId}/datasources/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "dataSourceSummaries"
            ],
            members: {
              dataSourceSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "knowledgeBaseId",
                    "dataSourceId",
                    "name",
                    "status",
                    "updatedAt"
                  ],
                  members: {
                    knowledgeBaseId: {},
                    dataSourceId: {},
                    name: {},
                    status: {},
                    description: {},
                    updatedAt: {
                      shape: "S9"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListIngestionJobs: {
          http: {
            requestUri: "/knowledgebases/{knowledgeBaseId}/datasources/{dataSourceId}/ingestionjobs/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId",
              "dataSourceId"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              dataSourceId: {
                location: "uri",
                locationName: "dataSourceId"
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "attribute",
                    "operator",
                    "values"
                  ],
                  members: {
                    attribute: {},
                    operator: {},
                    values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              sortBy: {
                type: "structure",
                required: [
                  "attribute",
                  "order"
                ],
                members: {
                  attribute: {},
                  order: {}
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ingestionJobSummaries"
            ],
            members: {
              ingestionJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "knowledgeBaseId",
                    "dataSourceId",
                    "ingestionJobId",
                    "status",
                    "startedAt",
                    "updatedAt"
                  ],
                  members: {
                    knowledgeBaseId: {},
                    dataSourceId: {},
                    ingestionJobId: {},
                    description: {},
                    status: {},
                    startedAt: {
                      shape: "S9"
                    },
                    updatedAt: {
                      shape: "S9"
                    },
                    statistics: {
                      shape: "S43"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListKnowledgeBases: {
          http: {
            requestUri: "/knowledgebases/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "knowledgeBaseSummaries"
            ],
            members: {
              knowledgeBaseSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "knowledgeBaseId",
                    "name",
                    "status",
                    "updatedAt"
                  ],
                  members: {
                    knowledgeBaseId: {},
                    name: {},
                    description: {},
                    status: {},
                    updatedAt: {
                      shape: "S9"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Si"
              }
            }
          }
        },
        PrepareAgent: {
          http: {
            requestUri: "/agents/{agentId}/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "agentId"
            ],
            members: {
              agentId: {
                location: "uri",
                locationName: "agentId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "agentId",
              "agentStatus",
              "agentVersion",
              "preparedAt"
            ],
            members: {
              agentId: {},
              agentStatus: {},
              agentVersion: {},
              preparedAt: {
                shape: "S9"
              }
            }
          }
        },
        StartIngestionJob: {
          http: {
            method: "PUT",
            requestUri: "/knowledgebases/{knowledgeBaseId}/datasources/{dataSourceId}/ingestionjobs/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId",
              "dataSourceId"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              dataSourceId: {
                location: "uri",
                locationName: "dataSourceId"
              },
              clientToken: {
                idempotencyToken: true
              },
              description: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ingestionJob"
            ],
            members: {
              ingestionJob: {
                shape: "S41"
              }
            }
          },
          idempotent: true
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateAgent: {
          http: {
            method: "PUT",
            requestUri: "/agents/{agentId}/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "agentId",
              "agentName",
              "agentResourceRoleArn"
            ],
            members: {
              agentId: {
                location: "uri",
                locationName: "agentId"
              },
              agentName: {},
              instruction: {
                shape: "Sd"
              },
              foundationModel: {},
              description: {},
              idleSessionTTLInSeconds: {
                type: "integer"
              },
              agentResourceRoleArn: {},
              customerEncryptionKeyArn: {},
              promptOverrideConfiguration: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "agent"
            ],
            members: {
              agent: {
                shape: "S11"
              }
            }
          },
          idempotent: true
        },
        UpdateAgentActionGroup: {
          http: {
            method: "PUT",
            requestUri: "/agents/{agentId}/agentversions/{agentVersion}/actiongroups/{actionGroupId}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "agentId",
              "agentVersion",
              "actionGroupId",
              "actionGroupName"
            ],
            members: {
              agentId: {
                location: "uri",
                locationName: "agentId"
              },
              agentVersion: {
                location: "uri",
                locationName: "agentVersion"
              },
              actionGroupId: {
                location: "uri",
                locationName: "actionGroupId"
              },
              actionGroupName: {},
              description: {},
              parentActionGroupSignature: {},
              actionGroupExecutor: {
                shape: "S1a"
              },
              actionGroupState: {},
              apiSchema: {
                shape: "S1b"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "agentActionGroup"
            ],
            members: {
              agentActionGroup: {
                shape: "S1i"
              }
            }
          },
          idempotent: true
        },
        UpdateAgentAlias: {
          http: {
            method: "PUT",
            requestUri: "/agents/{agentId}/agentaliases/{agentAliasId}/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "agentId",
              "agentAliasId",
              "agentAliasName"
            ],
            members: {
              agentId: {
                location: "uri",
                locationName: "agentId"
              },
              agentAliasId: {
                location: "uri",
                locationName: "agentAliasId"
              },
              agentAliasName: {},
              description: {},
              routingConfiguration: {
                shape: "S1k"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "agentAlias"
            ],
            members: {
              agentAlias: {
                shape: "S1n"
              }
            }
          },
          idempotent: true
        },
        UpdateAgentKnowledgeBase: {
          http: {
            method: "PUT",
            requestUri: "/agents/{agentId}/agentversions/{agentVersion}/knowledgebases/{knowledgeBaseId}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "agentId",
              "agentVersion",
              "knowledgeBaseId"
            ],
            members: {
              agentId: {
                location: "uri",
                locationName: "agentId"
              },
              agentVersion: {
                location: "uri",
                locationName: "agentVersion"
              },
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              description: {},
              knowledgeBaseState: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "agentKnowledgeBase"
            ],
            members: {
              agentKnowledgeBase: {
                shape: "S7"
              }
            }
          },
          idempotent: true
        },
        UpdateDataSource: {
          http: {
            method: "PUT",
            requestUri: "/knowledgebases/{knowledgeBaseId}/datasources/{dataSourceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId",
              "dataSourceId",
              "name",
              "dataSourceConfiguration"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              dataSourceId: {
                location: "uri",
                locationName: "dataSourceId"
              },
              name: {},
              description: {},
              dataSourceConfiguration: {
                shape: "S1u"
              },
              serverSideEncryptionConfiguration: {
                shape: "S20"
              },
              vectorIngestionConfiguration: {
                shape: "S21"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "dataSource"
            ],
            members: {
              dataSource: {
                shape: "S28"
              }
            }
          },
          idempotent: true
        },
        UpdateKnowledgeBase: {
          http: {
            method: "PUT",
            requestUri: "/knowledgebases/{knowledgeBaseId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId",
              "name",
              "roleArn",
              "knowledgeBaseConfiguration",
              "storageConfiguration"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              name: {},
              description: {},
              roleArn: {},
              knowledgeBaseConfiguration: {
                shape: "S2c"
              },
              storageConfiguration: {
                shape: "S2g"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "knowledgeBase"
            ],
            members: {
              knowledgeBase: {
                shape: "S33"
              }
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S7: {
          type: "structure",
          required: [
            "agentId",
            "agentVersion",
            "knowledgeBaseId",
            "description",
            "createdAt",
            "updatedAt",
            "knowledgeBaseState"
          ],
          members: {
            agentId: {},
            agentVersion: {},
            knowledgeBaseId: {},
            description: {},
            createdAt: {
              shape: "S9"
            },
            updatedAt: {
              shape: "S9"
            },
            knowledgeBaseState: {}
          }
        },
        S9: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        Sd: {
          type: "string",
          sensitive: true
        },
        Si: {
          type: "map",
          key: {},
          value: {}
        },
        Sl: {
          type: "structure",
          required: [
            "promptConfigurations"
          ],
          members: {
            promptConfigurations: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  promptType: {},
                  promptCreationMode: {},
                  promptState: {},
                  basePromptTemplate: {},
                  inferenceConfiguration: {
                    type: "structure",
                    members: {
                      temperature: {
                        type: "float"
                      },
                      topP: {
                        type: "float"
                      },
                      topK: {
                        type: "integer"
                      },
                      maximumLength: {
                        type: "integer"
                      },
                      stopSequences: {
                        type: "list",
                        member: {}
                      }
                    }
                  },
                  parserMode: {}
                }
              }
            },
            overrideLambda: {}
          },
          sensitive: true
        },
        S11: {
          type: "structure",
          required: [
            "agentId",
            "agentName",
            "agentArn",
            "agentVersion",
            "agentStatus",
            "idleSessionTTLInSeconds",
            "agentResourceRoleArn",
            "createdAt",
            "updatedAt"
          ],
          members: {
            agentId: {},
            agentName: {},
            agentArn: {},
            agentVersion: {},
            clientToken: {},
            instruction: {
              shape: "Sd"
            },
            agentStatus: {},
            foundationModel: {},
            description: {},
            idleSessionTTLInSeconds: {
              type: "integer"
            },
            agentResourceRoleArn: {},
            customerEncryptionKeyArn: {},
            createdAt: {
              shape: "S9"
            },
            updatedAt: {
              shape: "S9"
            },
            preparedAt: {
              shape: "S9"
            },
            failureReasons: {
              shape: "S14"
            },
            recommendedActions: {
              shape: "S16"
            },
            promptOverrideConfiguration: {
              shape: "Sl"
            }
          }
        },
        S14: {
          type: "list",
          member: {}
        },
        S16: {
          type: "list",
          member: {}
        },
        S1a: {
          type: "structure",
          members: {
            lambda: {}
          },
          union: true
        },
        S1b: {
          type: "structure",
          members: {
            s3: {
              type: "structure",
              members: {
                s3BucketName: {},
                s3ObjectKey: {}
              }
            },
            payload: {
              type: "string",
              sensitive: true
            }
          },
          union: true
        },
        S1i: {
          type: "structure",
          required: [
            "agentId",
            "agentVersion",
            "actionGroupId",
            "actionGroupName",
            "createdAt",
            "updatedAt",
            "actionGroupState"
          ],
          members: {
            agentId: {},
            agentVersion: {},
            actionGroupId: {},
            actionGroupName: {},
            clientToken: {},
            description: {},
            createdAt: {
              shape: "S9"
            },
            updatedAt: {
              shape: "S9"
            },
            parentActionSignature: {},
            actionGroupExecutor: {
              shape: "S1a"
            },
            apiSchema: {
              shape: "S1b"
            },
            actionGroupState: {}
          }
        },
        S1k: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "agentVersion"
            ],
            members: {
              agentVersion: {}
            }
          }
        },
        S1n: {
          type: "structure",
          required: [
            "agentId",
            "agentAliasId",
            "agentAliasName",
            "agentAliasArn",
            "routingConfiguration",
            "createdAt",
            "updatedAt",
            "agentAliasStatus"
          ],
          members: {
            agentId: {},
            agentAliasId: {},
            agentAliasName: {},
            agentAliasArn: {},
            clientToken: {},
            description: {},
            routingConfiguration: {
              shape: "S1k"
            },
            createdAt: {
              shape: "S9"
            },
            updatedAt: {
              shape: "S9"
            },
            agentAliasHistoryEvents: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  routingConfiguration: {
                    shape: "S1k"
                  },
                  endDate: {
                    shape: "S9"
                  },
                  startDate: {
                    shape: "S9"
                  }
                }
              }
            },
            agentAliasStatus: {}
          }
        },
        S1u: {
          type: "structure",
          required: [
            "type"
          ],
          members: {
            type: {},
            s3Configuration: {
              type: "structure",
              required: [
                "bucketArn"
              ],
              members: {
                bucketArn: {},
                inclusionPrefixes: {
                  type: "list",
                  member: {}
                }
              }
            }
          }
        },
        S20: {
          type: "structure",
          members: {
            kmsKeyArn: {}
          }
        },
        S21: {
          type: "structure",
          members: {
            chunkingConfiguration: {
              type: "structure",
              required: [
                "chunkingStrategy"
              ],
              members: {
                chunkingStrategy: {},
                fixedSizeChunkingConfiguration: {
                  type: "structure",
                  required: [
                    "maxTokens",
                    "overlapPercentage"
                  ],
                  members: {
                    maxTokens: {
                      type: "integer"
                    },
                    overlapPercentage: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        S28: {
          type: "structure",
          required: [
            "knowledgeBaseId",
            "dataSourceId",
            "name",
            "status",
            "dataSourceConfiguration",
            "createdAt",
            "updatedAt"
          ],
          members: {
            knowledgeBaseId: {},
            dataSourceId: {},
            name: {},
            status: {},
            description: {},
            dataSourceConfiguration: {
              shape: "S1u"
            },
            serverSideEncryptionConfiguration: {
              shape: "S20"
            },
            vectorIngestionConfiguration: {
              shape: "S21"
            },
            createdAt: {
              shape: "S9"
            },
            updatedAt: {
              shape: "S9"
            }
          }
        },
        S2c: {
          type: "structure",
          required: [
            "type"
          ],
          members: {
            type: {},
            vectorKnowledgeBaseConfiguration: {
              type: "structure",
              required: [
                "embeddingModelArn"
              ],
              members: {
                embeddingModelArn: {}
              }
            }
          }
        },
        S2g: {
          type: "structure",
          required: [
            "type"
          ],
          members: {
            type: {},
            opensearchServerlessConfiguration: {
              type: "structure",
              required: [
                "collectionArn",
                "vectorIndexName",
                "fieldMapping"
              ],
              members: {
                collectionArn: {},
                vectorIndexName: {},
                fieldMapping: {
                  type: "structure",
                  required: [
                    "vectorField",
                    "textField",
                    "metadataField"
                  ],
                  members: {
                    vectorField: {},
                    textField: {},
                    metadataField: {}
                  }
                }
              }
            },
            pineconeConfiguration: {
              type: "structure",
              required: [
                "connectionString",
                "credentialsSecretArn",
                "fieldMapping"
              ],
              members: {
                connectionString: {},
                credentialsSecretArn: {},
                namespace: {},
                fieldMapping: {
                  type: "structure",
                  required: [
                    "textField",
                    "metadataField"
                  ],
                  members: {
                    textField: {},
                    metadataField: {}
                  }
                }
              }
            },
            redisEnterpriseCloudConfiguration: {
              type: "structure",
              required: [
                "endpoint",
                "vectorIndexName",
                "credentialsSecretArn",
                "fieldMapping"
              ],
              members: {
                endpoint: {},
                vectorIndexName: {},
                credentialsSecretArn: {},
                fieldMapping: {
                  type: "structure",
                  required: [
                    "vectorField",
                    "textField",
                    "metadataField"
                  ],
                  members: {
                    vectorField: {},
                    textField: {},
                    metadataField: {}
                  }
                }
              }
            },
            rdsConfiguration: {
              type: "structure",
              required: [
                "resourceArn",
                "credentialsSecretArn",
                "databaseName",
                "tableName",
                "fieldMapping"
              ],
              members: {
                resourceArn: {},
                credentialsSecretArn: {},
                databaseName: {},
                tableName: {},
                fieldMapping: {
                  type: "structure",
                  required: [
                    "primaryKeyField",
                    "vectorField",
                    "textField",
                    "metadataField"
                  ],
                  members: {
                    primaryKeyField: {},
                    vectorField: {},
                    textField: {},
                    metadataField: {}
                  }
                }
              }
            }
          }
        },
        S33: {
          type: "structure",
          required: [
            "knowledgeBaseId",
            "name",
            "knowledgeBaseArn",
            "roleArn",
            "knowledgeBaseConfiguration",
            "storageConfiguration",
            "status",
            "createdAt",
            "updatedAt"
          ],
          members: {
            knowledgeBaseId: {},
            name: {},
            knowledgeBaseArn: {},
            description: {},
            roleArn: {},
            knowledgeBaseConfiguration: {
              shape: "S2c"
            },
            storageConfiguration: {
              shape: "S2g"
            },
            status: {},
            createdAt: {
              shape: "S9"
            },
            updatedAt: {
              shape: "S9"
            },
            failureReasons: {
              shape: "S14"
            }
          }
        },
        S41: {
          type: "structure",
          required: [
            "knowledgeBaseId",
            "dataSourceId",
            "ingestionJobId",
            "status",
            "startedAt",
            "updatedAt"
          ],
          members: {
            knowledgeBaseId: {},
            dataSourceId: {},
            ingestionJobId: {},
            description: {},
            status: {},
            statistics: {
              shape: "S43"
            },
            failureReasons: {
              shape: "S14"
            },
            startedAt: {
              shape: "S9"
            },
            updatedAt: {
              shape: "S9"
            }
          }
        },
        S43: {
          type: "structure",
          members: {
            numberOfDocumentsScanned: {
              type: "long"
            },
            numberOfNewDocumentsIndexed: {
              type: "long"
            },
            numberOfModifiedDocumentsIndexed: {
              type: "long"
            },
            numberOfDocumentsDeleted: {
              type: "long"
            },
            numberOfDocumentsFailed: {
              type: "long"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/bedrock-agent-2023-06-05.paginators.json
var require_bedrock_agent_2023_06_05_paginators = __commonJS({
  "node_modules/aws-sdk/apis/bedrock-agent-2023-06-05.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAgentActionGroups: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "actionGroupSummaries"
        },
        ListAgentAliases: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "agentAliasSummaries"
        },
        ListAgentKnowledgeBases: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "agentKnowledgeBaseSummaries"
        },
        ListAgentVersions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "agentVersionSummaries"
        },
        ListAgents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "agentSummaries"
        },
        ListDataSources: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "dataSourceSummaries"
        },
        ListIngestionJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "ingestionJobSummaries"
        },
        ListKnowledgeBases: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "knowledgeBaseSummaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/bedrockagent.js
var require_bedrockagent = __commonJS({
  "node_modules/aws-sdk/clients/bedrockagent.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["bedrockagent"] = {};
    AWS2.BedrockAgent = Service.defineService("bedrockagent", ["2023-06-05"]);
    Object.defineProperty(apiLoader.services["bedrockagent"], "2023-06-05", {
      get: function get() {
        var model = require_bedrock_agent_2023_06_05_min();
        model.paginators = require_bedrock_agent_2023_06_05_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.BedrockAgent;
  }
});

// node_modules/aws-sdk/apis/bedrock-agent-runtime-2023-07-26.min.json
var require_bedrock_agent_runtime_2023_07_26_min = __commonJS({
  "node_modules/aws-sdk/apis/bedrock-agent-runtime-2023-07-26.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2023-07-26",
        endpointPrefix: "bedrock-agent-runtime",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Agents for Amazon Bedrock Runtime",
        serviceId: "Bedrock Agent Runtime",
        signatureVersion: "v4",
        signingName: "bedrock",
        uid: "bedrock-agent-runtime-2023-07-26"
      },
      operations: {
        InvokeAgent: {
          http: {
            requestUri: "/agents/{agentId}/agentAliases/{agentAliasId}/sessions/{sessionId}/text",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "agentId",
              "agentAliasId",
              "sessionId",
              "inputText"
            ],
            members: {
              sessionState: {
                type: "structure",
                members: {
                  sessionAttributes: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  promptSessionAttributes: {
                    type: "map",
                    key: {},
                    value: {}
                  }
                }
              },
              agentId: {
                location: "uri",
                locationName: "agentId"
              },
              agentAliasId: {
                location: "uri",
                locationName: "agentAliasId"
              },
              sessionId: {
                location: "uri",
                locationName: "sessionId"
              },
              endSession: {
                type: "boolean"
              },
              enableTrace: {
                type: "boolean"
              },
              inputText: {
                type: "string",
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "completion",
              "contentType",
              "sessionId"
            ],
            members: {
              completion: {
                type: "structure",
                members: {
                  chunk: {
                    type: "structure",
                    members: {
                      bytes: {
                        type: "blob",
                        sensitive: true
                      },
                      attribution: {
                        type: "structure",
                        members: {
                          citations: {
                            shape: "Sg"
                          }
                        }
                      }
                    },
                    event: true,
                    sensitive: true
                  },
                  trace: {
                    type: "structure",
                    members: {
                      agentId: {},
                      agentAliasId: {},
                      sessionId: {},
                      trace: {
                        type: "structure",
                        members: {
                          preProcessingTrace: {
                            type: "structure",
                            members: {
                              modelInvocationInput: {
                                shape: "Sw"
                              },
                              modelInvocationOutput: {
                                type: "structure",
                                members: {
                                  traceId: {},
                                  parsedResponse: {
                                    type: "structure",
                                    members: {
                                      rationale: {
                                        shape: "S1a"
                                      },
                                      isValid: {
                                        type: "boolean"
                                      }
                                    },
                                    sensitive: true
                                  }
                                },
                                sensitive: true
                              }
                            },
                            sensitive: true,
                            union: true
                          },
                          orchestrationTrace: {
                            type: "structure",
                            members: {
                              rationale: {
                                type: "structure",
                                members: {
                                  traceId: {},
                                  text: {
                                    shape: "S1a"
                                  }
                                },
                                sensitive: true
                              },
                              invocationInput: {
                                type: "structure",
                                members: {
                                  traceId: {},
                                  invocationType: {},
                                  actionGroupInvocationInput: {
                                    type: "structure",
                                    members: {
                                      actionGroupName: {
                                        type: "string",
                                        sensitive: true
                                      },
                                      verb: {
                                        type: "string",
                                        sensitive: true
                                      },
                                      apiPath: {
                                        type: "string",
                                        sensitive: true
                                      },
                                      parameters: {
                                        shape: "S1j"
                                      },
                                      requestBody: {
                                        type: "structure",
                                        members: {
                                          content: {
                                            type: "map",
                                            key: {},
                                            value: {
                                              shape: "S1j"
                                            }
                                          }
                                        }
                                      }
                                    }
                                  },
                                  knowledgeBaseLookupInput: {
                                    type: "structure",
                                    members: {
                                      text: {
                                        type: "string",
                                        sensitive: true
                                      },
                                      knowledgeBaseId: {
                                        type: "string",
                                        sensitive: true
                                      }
                                    }
                                  }
                                },
                                sensitive: true
                              },
                              observation: {
                                type: "structure",
                                members: {
                                  traceId: {},
                                  type: {},
                                  actionGroupInvocationOutput: {
                                    type: "structure",
                                    members: {
                                      text: {
                                        type: "string",
                                        sensitive: true
                                      }
                                    }
                                  },
                                  knowledgeBaseLookupOutput: {
                                    type: "structure",
                                    members: {
                                      retrievedReferences: {
                                        shape: "Sn"
                                      }
                                    }
                                  },
                                  finalResponse: {
                                    type: "structure",
                                    members: {
                                      text: {
                                        type: "string",
                                        sensitive: true
                                      }
                                    }
                                  },
                                  repromptResponse: {
                                    type: "structure",
                                    members: {
                                      text: {},
                                      source: {
                                        type: "string",
                                        sensitive: true
                                      }
                                    },
                                    sensitive: true
                                  }
                                },
                                sensitive: true
                              },
                              modelInvocationInput: {
                                shape: "Sw"
                              }
                            },
                            sensitive: true,
                            union: true
                          },
                          postProcessingTrace: {
                            type: "structure",
                            members: {
                              modelInvocationInput: {
                                shape: "Sw"
                              },
                              modelInvocationOutput: {
                                type: "structure",
                                members: {
                                  traceId: {},
                                  parsedResponse: {
                                    type: "structure",
                                    members: {
                                      text: {
                                        type: "string",
                                        sensitive: true
                                      }
                                    },
                                    sensitive: true
                                  }
                                },
                                sensitive: true
                              }
                            },
                            sensitive: true,
                            union: true
                          },
                          failureTrace: {
                            type: "structure",
                            members: {
                              traceId: {},
                              failureReason: {
                                type: "string",
                                sensitive: true
                              }
                            },
                            sensitive: true
                          }
                        },
                        sensitive: true,
                        union: true
                      }
                    },
                    event: true,
                    sensitive: true
                  },
                  internalServerException: {
                    type: "structure",
                    members: {
                      message: {}
                    },
                    error: {
                      httpStatusCode: 500
                    },
                    exception: true,
                    fault: true
                  },
                  validationException: {
                    type: "structure",
                    members: {
                      message: {}
                    },
                    error: {
                      httpStatusCode: 400,
                      senderFault: true
                    },
                    exception: true
                  },
                  resourceNotFoundException: {
                    type: "structure",
                    members: {
                      message: {}
                    },
                    error: {
                      httpStatusCode: 404,
                      senderFault: true
                    },
                    exception: true
                  },
                  serviceQuotaExceededException: {
                    type: "structure",
                    members: {
                      message: {}
                    },
                    error: {
                      httpStatusCode: 400,
                      senderFault: true
                    },
                    exception: true
                  },
                  throttlingException: {
                    type: "structure",
                    members: {
                      message: {}
                    },
                    error: {
                      httpStatusCode: 429,
                      senderFault: true
                    },
                    exception: true
                  },
                  accessDeniedException: {
                    type: "structure",
                    members: {
                      message: {}
                    },
                    error: {
                      httpStatusCode: 403,
                      senderFault: true
                    },
                    exception: true
                  },
                  conflictException: {
                    type: "structure",
                    members: {
                      message: {}
                    },
                    error: {
                      httpStatusCode: 409,
                      senderFault: true
                    },
                    exception: true
                  },
                  dependencyFailedException: {
                    type: "structure",
                    members: {
                      message: {},
                      resourceName: {}
                    },
                    error: {
                      httpStatusCode: 424,
                      senderFault: true
                    },
                    exception: true
                  },
                  badGatewayException: {
                    type: "structure",
                    members: {
                      message: {},
                      resourceName: {}
                    },
                    error: {
                      httpStatusCode: 502
                    },
                    exception: true,
                    fault: true
                  }
                },
                eventstream: true
              },
              contentType: {
                location: "header",
                locationName: "x-amzn-bedrock-agent-content-type"
              },
              sessionId: {
                location: "header",
                locationName: "x-amz-bedrock-agent-session-id"
              }
            },
            payload: "completion"
          }
        },
        Retrieve: {
          http: {
            requestUri: "/knowledgebases/{knowledgeBaseId}/retrieve",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId",
              "retrievalQuery"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              retrievalQuery: {
                type: "structure",
                required: [
                  "text"
                ],
                members: {
                  text: {}
                },
                sensitive: true
              },
              retrievalConfiguration: {
                type: "structure",
                required: [
                  "vectorSearchConfiguration"
                ],
                members: {
                  vectorSearchConfiguration: {
                    type: "structure",
                    required: [
                      "numberOfResults"
                    ],
                    members: {
                      numberOfResults: {
                        type: "integer"
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "retrievalResults"
            ],
            members: {
              retrievalResults: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "content"
                  ],
                  members: {
                    content: {
                      shape: "Sp"
                    },
                    location: {
                      shape: "Sq"
                    },
                    score: {
                      type: "double"
                    }
                  }
                },
                sensitive: true
              },
              nextToken: {}
            }
          }
        },
        RetrieveAndGenerate: {
          http: {
            requestUri: "/retrieveAndGenerate",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "input"
            ],
            members: {
              sessionId: {},
              input: {
                type: "structure",
                required: [
                  "text"
                ],
                members: {
                  text: {}
                },
                sensitive: true
              },
              retrieveAndGenerateConfiguration: {
                type: "structure",
                required: [
                  "type"
                ],
                members: {
                  type: {},
                  knowledgeBaseConfiguration: {
                    type: "structure",
                    required: [
                      "knowledgeBaseId",
                      "modelArn"
                    ],
                    members: {
                      knowledgeBaseId: {},
                      modelArn: {}
                    }
                  }
                }
              },
              sessionConfiguration: {
                type: "structure",
                required: [
                  "kmsKeyArn"
                ],
                members: {
                  kmsKeyArn: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "sessionId",
              "output"
            ],
            members: {
              sessionId: {},
              output: {
                type: "structure",
                required: [
                  "text"
                ],
                members: {
                  text: {}
                },
                sensitive: true
              },
              citations: {
                shape: "Sg"
              }
            }
          }
        }
      },
      shapes: {
        Sg: {
          type: "list",
          member: {
            type: "structure",
            members: {
              generatedResponsePart: {
                type: "structure",
                members: {
                  textResponsePart: {
                    type: "structure",
                    members: {
                      text: {},
                      span: {
                        type: "structure",
                        members: {
                          start: {
                            type: "integer"
                          },
                          end: {
                            type: "integer"
                          }
                        }
                      }
                    }
                  }
                }
              },
              retrievedReferences: {
                shape: "Sn"
              }
            }
          }
        },
        Sn: {
          type: "list",
          member: {
            type: "structure",
            members: {
              content: {
                shape: "Sp"
              },
              location: {
                shape: "Sq"
              }
            }
          }
        },
        Sp: {
          type: "structure",
          required: [
            "text"
          ],
          members: {
            text: {}
          }
        },
        Sq: {
          type: "structure",
          required: [
            "type"
          ],
          members: {
            type: {},
            s3Location: {
              type: "structure",
              members: {
                uri: {}
              }
            }
          }
        },
        Sw: {
          type: "structure",
          members: {
            traceId: {},
            text: {
              type: "string",
              sensitive: true
            },
            type: {},
            inferenceConfiguration: {
              type: "structure",
              members: {
                temperature: {
                  type: "float"
                },
                topP: {
                  type: "float"
                },
                topK: {
                  type: "integer"
                },
                maximumLength: {
                  type: "integer"
                },
                stopSequences: {
                  type: "list",
                  member: {}
                }
              }
            },
            overrideLambda: {},
            promptCreationMode: {},
            parserMode: {}
          },
          sensitive: true
        },
        S1a: {
          type: "string",
          sensitive: true
        },
        S1j: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              type: {},
              value: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/bedrock-agent-runtime-2023-07-26.paginators.json
var require_bedrock_agent_runtime_2023_07_26_paginators = __commonJS({
  "node_modules/aws-sdk/apis/bedrock-agent-runtime-2023-07-26.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        Retrieve: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "retrievalResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/bedrockagentruntime.js
var require_bedrockagentruntime = __commonJS({
  "node_modules/aws-sdk/clients/bedrockagentruntime.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["bedrockagentruntime"] = {};
    AWS2.BedrockAgentRuntime = Service.defineService("bedrockagentruntime", ["2023-07-26"]);
    Object.defineProperty(apiLoader.services["bedrockagentruntime"], "2023-07-26", {
      get: function get() {
        var model = require_bedrock_agent_runtime_2023_07_26_min();
        model.paginators = require_bedrock_agent_runtime_2023_07_26_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.BedrockAgentRuntime;
  }
});

// node_modules/aws-sdk/apis/qbusiness-2023-11-27.min.json
var require_qbusiness_2023_11_27_min = __commonJS({
  "node_modules/aws-sdk/apis/qbusiness-2023-11-27.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2023-11-27",
        endpointPrefix: "qbusiness",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "QBusiness",
        serviceId: "QBusiness",
        signatureVersion: "v4",
        signingName: "qbusiness",
        uid: "qbusiness-2023-11-27"
      },
      operations: {
        BatchDeleteDocument: {
          http: {
            requestUri: "/applications/{applicationId}/indices/{indexId}/documents/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "documents",
              "indexId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              dataSourceSyncId: {},
              documents: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "documentId"
                  ],
                  members: {
                    documentId: {}
                  }
                }
              },
              indexId: {
                location: "uri",
                locationName: "indexId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              failedDocuments: {
                shape: "S9"
              }
            }
          }
        },
        BatchPutDocument: {
          http: {
            requestUri: "/applications/{applicationId}/indices/{indexId}/documents",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "documents",
              "indexId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              dataSourceSyncId: {},
              documents: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id"
                  ],
                  members: {
                    accessConfiguration: {
                      type: "structure",
                      required: [
                        "accessControls"
                      ],
                      members: {
                        accessControls: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "principals"
                            ],
                            members: {
                              memberRelation: {},
                              principals: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    group: {
                                      type: "structure",
                                      required: [
                                        "access"
                                      ],
                                      members: {
                                        access: {},
                                        membershipType: {},
                                        name: {}
                                      }
                                    },
                                    user: {
                                      type: "structure",
                                      required: [
                                        "access"
                                      ],
                                      members: {
                                        access: {},
                                        id: {},
                                        membershipType: {}
                                      }
                                    }
                                  },
                                  union: true
                                }
                              }
                            }
                          }
                        },
                        memberRelation: {}
                      }
                    },
                    attributes: {
                      type: "list",
                      member: {
                        shape: "Sv"
                      }
                    },
                    content: {
                      type: "structure",
                      members: {
                        blob: {
                          type: "blob"
                        },
                        s3: {
                          type: "structure",
                          required: [
                            "bucket",
                            "key"
                          ],
                          members: {
                            bucket: {},
                            key: {}
                          }
                        }
                      },
                      union: true
                    },
                    contentType: {},
                    documentEnrichmentConfiguration: {
                      shape: "S19"
                    },
                    id: {},
                    title: {}
                  }
                }
              },
              indexId: {
                location: "uri",
                locationName: "indexId"
              },
              roleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              failedDocuments: {
                shape: "S9"
              }
            }
          }
        },
        ChatSync: {
          http: {
            requestUri: "/applications/{applicationId}/conversations?sync",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "userId"
            ],
            members: {
              actionExecution: {
                shape: "S1n"
              },
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              attachments: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "data",
                    "name"
                  ],
                  members: {
                    data: {
                      type: "blob"
                    },
                    name: {}
                  }
                }
              },
              attributeFilter: {
                shape: "S1x"
              },
              clientToken: {
                idempotencyToken: true
              },
              conversationId: {},
              parentMessageId: {},
              userGroups: {
                shape: "S22",
                location: "querystring",
                locationName: "userGroups"
              },
              userId: {
                location: "querystring",
                locationName: "userId"
              },
              userMessage: {}
            }
          },
          output: {
            type: "structure",
            members: {
              actionReview: {
                shape: "S25"
              },
              conversationId: {},
              failedAttachments: {
                shape: "S2e"
              },
              sourceAttributions: {
                shape: "S2h"
              },
              systemMessage: {},
              systemMessageId: {},
              userMessageId: {}
            }
          }
        },
        CreateApplication: {
          http: {
            requestUri: "/applications",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "displayName",
              "roleArn"
            ],
            members: {
              attachmentsConfiguration: {
                shape: "S2m"
              },
              clientToken: {
                idempotencyToken: true
              },
              description: {},
              displayName: {},
              encryptionConfiguration: {
                shape: "S2q"
              },
              roleArn: {},
              tags: {
                shape: "S2s"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applicationArn: {},
              applicationId: {}
            }
          },
          idempotent: true
        },
        CreateDataSource: {
          http: {
            requestUri: "/applications/{applicationId}/indices/{indexId}/datasources",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "configuration",
              "displayName",
              "indexId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              clientToken: {
                idempotencyToken: true
              },
              configuration: {
                shape: "S2z"
              },
              description: {},
              displayName: {},
              documentEnrichmentConfiguration: {
                shape: "S19"
              },
              indexId: {
                location: "uri",
                locationName: "indexId"
              },
              roleArn: {},
              syncSchedule: {},
              tags: {
                shape: "S2s"
              },
              vpcConfiguration: {
                shape: "S32"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              dataSourceArn: {},
              dataSourceId: {}
            }
          },
          idempotent: true
        },
        CreateIndex: {
          http: {
            requestUri: "/applications/{applicationId}/indices",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "displayName"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              capacityConfiguration: {
                shape: "S3a"
              },
              clientToken: {
                idempotencyToken: true
              },
              description: {},
              displayName: {},
              tags: {
                shape: "S2s"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              indexArn: {},
              indexId: {}
            }
          }
        },
        CreatePlugin: {
          http: {
            requestUri: "/applications/{applicationId}/plugins",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "authConfiguration",
              "displayName",
              "serverUrl",
              "type"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              authConfiguration: {
                shape: "S3g"
              },
              clientToken: {
                idempotencyToken: true
              },
              displayName: {},
              serverUrl: {},
              tags: {
                shape: "S2s"
              },
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              pluginArn: {},
              pluginId: {}
            }
          },
          idempotent: true
        },
        CreateRetriever: {
          http: {
            requestUri: "/applications/{applicationId}/retrievers",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "configuration",
              "displayName",
              "type"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              clientToken: {
                idempotencyToken: true
              },
              configuration: {
                shape: "S3p"
              },
              displayName: {},
              roleArn: {},
              tags: {
                shape: "S2s"
              },
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              retrieverArn: {},
              retrieverId: {}
            }
          }
        },
        CreateUser: {
          http: {
            requestUri: "/applications/{applicationId}/users",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "userId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              clientToken: {
                idempotencyToken: true
              },
              userAliases: {
                type: "list",
                member: {
                  shape: "S40"
                }
              },
              userId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        CreateWebExperience: {
          http: {
            requestUri: "/applications/{applicationId}/experiences",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              clientToken: {
                idempotencyToken: true
              },
              samplePromptsControlMode: {},
              subtitle: {},
              tags: {
                shape: "S2s"
              },
              title: {},
              welcomeMessage: {}
            }
          },
          output: {
            type: "structure",
            members: {
              webExperienceArn: {},
              webExperienceId: {}
            }
          }
        },
        DeleteApplication: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{applicationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteChatControlsConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{applicationId}/chatcontrols",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteConversation: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{applicationId}/conversations/{conversationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "conversationId",
              "userId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              conversationId: {
                location: "uri",
                locationName: "conversationId"
              },
              userId: {
                location: "querystring",
                locationName: "userId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteDataSource: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{applicationId}/indices/{indexId}/datasources/{dataSourceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "dataSourceId",
              "indexId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              dataSourceId: {
                location: "uri",
                locationName: "dataSourceId"
              },
              indexId: {
                location: "uri",
                locationName: "indexId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteGroup: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{applicationId}/indices/{indexId}/groups/{groupName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "groupName",
              "indexId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              dataSourceId: {
                location: "querystring",
                locationName: "dataSourceId"
              },
              groupName: {
                location: "uri",
                locationName: "groupName"
              },
              indexId: {
                location: "uri",
                locationName: "indexId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteIndex: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{applicationId}/indices/{indexId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "indexId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              indexId: {
                location: "uri",
                locationName: "indexId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeletePlugin: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{applicationId}/plugins/{pluginId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "pluginId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              pluginId: {
                location: "uri",
                locationName: "pluginId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteRetriever: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{applicationId}/retrievers/{retrieverId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "retrieverId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              retrieverId: {
                location: "uri",
                locationName: "retrieverId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteUser: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{applicationId}/users/{userId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "userId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              userId: {
                location: "uri",
                locationName: "userId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteWebExperience: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{applicationId}/experiences/{webExperienceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "webExperienceId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              webExperienceId: {
                location: "uri",
                locationName: "webExperienceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        GetApplication: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applicationArn: {},
              applicationId: {},
              attachmentsConfiguration: {
                type: "structure",
                members: {
                  attachmentsControlMode: {}
                }
              },
              createdAt: {
                type: "timestamp"
              },
              description: {},
              displayName: {},
              encryptionConfiguration: {
                shape: "S2q"
              },
              error: {
                shape: "Sc"
              },
              roleArn: {},
              status: {},
              updatedAt: {
                type: "timestamp"
              }
            }
          }
        },
        GetChatControlsConfiguration: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/chatcontrols",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              blockedPhrases: {
                type: "structure",
                members: {
                  blockedPhrases: {
                    shape: "S53"
                  },
                  systemMessageOverride: {}
                }
              },
              nextToken: {},
              responseScope: {},
              topicConfigurations: {
                shape: "S57"
              }
            }
          }
        },
        GetDataSource: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/indices/{indexId}/datasources/{dataSourceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "dataSourceId",
              "indexId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              dataSourceId: {
                location: "uri",
                locationName: "dataSourceId"
              },
              indexId: {
                location: "uri",
                locationName: "indexId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applicationId: {},
              configuration: {
                shape: "S2z"
              },
              createdAt: {
                type: "timestamp"
              },
              dataSourceArn: {},
              dataSourceId: {},
              description: {},
              displayName: {},
              documentEnrichmentConfiguration: {
                shape: "S19"
              },
              error: {
                shape: "Sc"
              },
              indexId: {},
              roleArn: {},
              status: {},
              syncSchedule: {},
              type: {},
              updatedAt: {
                type: "timestamp"
              },
              vpcConfiguration: {
                shape: "S32"
              }
            }
          }
        },
        GetGroup: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/indices/{indexId}/groups/{groupName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "groupName",
              "indexId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              dataSourceId: {
                location: "querystring",
                locationName: "dataSourceId"
              },
              groupName: {
                location: "uri",
                locationName: "groupName"
              },
              indexId: {
                location: "uri",
                locationName: "indexId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              status: {
                shape: "S5s"
              },
              statusHistory: {
                type: "list",
                member: {
                  shape: "S5s"
                }
              }
            }
          }
        },
        GetIndex: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/indices/{indexId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "indexId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              indexId: {
                location: "uri",
                locationName: "indexId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applicationId: {},
              capacityConfiguration: {
                shape: "S3a"
              },
              createdAt: {
                type: "timestamp"
              },
              description: {},
              displayName: {},
              documentAttributeConfigurations: {
                shape: "S5x"
              },
              error: {
                shape: "Sc"
              },
              indexArn: {},
              indexId: {},
              indexStatistics: {
                type: "structure",
                members: {
                  textDocumentStatistics: {
                    type: "structure",
                    members: {
                      indexedTextBytes: {
                        type: "long"
                      },
                      indexedTextDocumentCount: {
                        type: "integer"
                      }
                    }
                  }
                }
              },
              status: {},
              updatedAt: {
                type: "timestamp"
              }
            }
          }
        },
        GetPlugin: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/plugins/{pluginId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "pluginId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              pluginId: {
                location: "uri",
                locationName: "pluginId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applicationId: {},
              authConfiguration: {
                shape: "S3g"
              },
              createdAt: {
                type: "timestamp"
              },
              displayName: {},
              pluginArn: {},
              pluginId: {},
              serverUrl: {},
              state: {},
              type: {},
              updatedAt: {
                type: "timestamp"
              }
            }
          }
        },
        GetRetriever: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/retrievers/{retrieverId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "retrieverId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              retrieverId: {
                location: "uri",
                locationName: "retrieverId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applicationId: {},
              configuration: {
                shape: "S3p"
              },
              createdAt: {
                type: "timestamp"
              },
              displayName: {},
              retrieverArn: {},
              retrieverId: {},
              roleArn: {},
              status: {},
              type: {},
              updatedAt: {
                type: "timestamp"
              }
            }
          }
        },
        GetUser: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/users/{userId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "userId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              userId: {
                location: "uri",
                locationName: "userId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              userAliases: {
                shape: "S6e"
              }
            }
          }
        },
        GetWebExperience: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/experiences/{webExperienceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "webExperienceId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              webExperienceId: {
                location: "uri",
                locationName: "webExperienceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applicationId: {},
              authenticationConfiguration: {
                shape: "S6h"
              },
              createdAt: {
                type: "timestamp"
              },
              defaultEndpoint: {},
              error: {
                shape: "Sc"
              },
              samplePromptsControlMode: {},
              status: {},
              subtitle: {},
              title: {},
              updatedAt: {
                type: "timestamp"
              },
              webExperienceArn: {},
              webExperienceId: {},
              welcomeMessage: {}
            }
          }
        },
        ListApplications: {
          http: {
            method: "GET",
            requestUri: "/applications",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applications: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    applicationId: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    displayName: {},
                    status: {},
                    updatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListConversations: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/conversations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "userId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              userId: {
                location: "querystring",
                locationName: "userId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              conversations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    conversationId: {},
                    startTime: {
                      type: "timestamp"
                    },
                    title: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDataSourceSyncJobs: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/indices/{indexId}/datasources/{dataSourceId}/syncjobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "dataSourceId",
              "indexId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              dataSourceId: {
                location: "uri",
                locationName: "dataSourceId"
              },
              endTime: {
                location: "querystring",
                locationName: "endTime",
                type: "timestamp"
              },
              indexId: {
                location: "uri",
                locationName: "indexId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              startTime: {
                location: "querystring",
                locationName: "startTime",
                type: "timestamp"
              },
              statusFilter: {
                location: "querystring",
                locationName: "syncStatus"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              history: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    dataSourceErrorCode: {},
                    endTime: {
                      type: "timestamp"
                    },
                    error: {
                      shape: "Sc"
                    },
                    executionId: {},
                    metrics: {
                      type: "structure",
                      members: {
                        documentsAdded: {},
                        documentsDeleted: {},
                        documentsFailed: {},
                        documentsModified: {},
                        documentsScanned: {}
                      }
                    },
                    startTime: {
                      type: "timestamp"
                    },
                    status: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDataSources: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/indices/{indexId}/datasources",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "indexId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              indexId: {
                location: "uri",
                locationName: "indexId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              dataSources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    createdAt: {
                      type: "timestamp"
                    },
                    dataSourceId: {},
                    displayName: {},
                    status: {},
                    type: {},
                    updatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDocuments: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/index/{indexId}/documents",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "indexId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              dataSourceIds: {
                location: "querystring",
                locationName: "dataSourceIds",
                type: "list",
                member: {}
              },
              indexId: {
                location: "uri",
                locationName: "indexId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              documentDetailList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    createdAt: {
                      type: "timestamp"
                    },
                    documentId: {},
                    error: {
                      shape: "Sc"
                    },
                    status: {},
                    updatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListGroups: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/indices/{indexId}/groups",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "indexId",
              "updatedEarlierThan"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              dataSourceId: {
                location: "querystring",
                locationName: "dataSourceId"
              },
              indexId: {
                location: "uri",
                locationName: "indexId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              updatedEarlierThan: {
                location: "querystring",
                locationName: "updatedEarlierThan",
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    groupName: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListIndices: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/indices",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              indices: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    createdAt: {
                      type: "timestamp"
                    },
                    displayName: {},
                    indexId: {},
                    status: {},
                    updatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListMessages: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/conversations/{conversationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "conversationId",
              "userId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              conversationId: {
                location: "uri",
                locationName: "conversationId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              userId: {
                location: "querystring",
                locationName: "userId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              messages: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    actionExecution: {
                      shape: "S1n"
                    },
                    actionReview: {
                      shape: "S25"
                    },
                    attachments: {
                      shape: "S2e"
                    },
                    body: {},
                    messageId: {},
                    sourceAttribution: {
                      shape: "S2h"
                    },
                    time: {
                      type: "timestamp"
                    },
                    type: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListPlugins: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/plugins",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              plugins: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    createdAt: {
                      type: "timestamp"
                    },
                    displayName: {},
                    pluginId: {},
                    serverUrl: {},
                    state: {},
                    type: {},
                    updatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListRetrievers: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/retrievers",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              retrievers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    applicationId: {},
                    displayName: {},
                    retrieverId: {},
                    status: {},
                    type: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/v1/tags/{resourceARN}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceARN"
            ],
            members: {
              resourceARN: {
                location: "uri",
                locationName: "resourceARN"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S2s"
              }
            }
          }
        },
        ListWebExperiences: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/experiences",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              webExperiences: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    createdAt: {
                      type: "timestamp"
                    },
                    defaultEndpoint: {},
                    status: {},
                    updatedAt: {
                      type: "timestamp"
                    },
                    webExperienceId: {}
                  }
                }
              }
            }
          }
        },
        PutFeedback: {
          http: {
            requestUri: "/applications/{applicationId}/conversations/{conversationId}/messages/{messageId}/feedback",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "conversationId",
              "messageId",
              "userId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              conversationId: {
                location: "uri",
                locationName: "conversationId"
              },
              messageCopiedAt: {
                type: "timestamp"
              },
              messageId: {
                location: "uri",
                locationName: "messageId"
              },
              messageUsefulness: {
                type: "structure",
                required: [
                  "submittedAt",
                  "usefulness"
                ],
                members: {
                  comment: {},
                  reason: {},
                  submittedAt: {
                    type: "timestamp"
                  },
                  usefulness: {}
                }
              },
              userId: {
                location: "querystring",
                locationName: "userId"
              }
            }
          }
        },
        PutGroup: {
          http: {
            method: "PUT",
            requestUri: "/applications/{applicationId}/indices/{indexId}/groups",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "groupMembers",
              "groupName",
              "indexId",
              "type"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              dataSourceId: {},
              groupMembers: {
                type: "structure",
                members: {
                  memberGroups: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "groupName"
                      ],
                      members: {
                        groupName: {},
                        type: {}
                      }
                    }
                  },
                  memberUsers: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "userId"
                      ],
                      members: {
                        type: {},
                        userId: {}
                      }
                    }
                  }
                }
              },
              groupName: {},
              indexId: {
                location: "uri",
                locationName: "indexId"
              },
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        StartDataSourceSyncJob: {
          http: {
            requestUri: "/applications/{applicationId}/indices/{indexId}/datasources/{dataSourceId}/startsync",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "dataSourceId",
              "indexId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              dataSourceId: {
                location: "uri",
                locationName: "dataSourceId"
              },
              indexId: {
                location: "uri",
                locationName: "indexId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              executionId: {}
            }
          }
        },
        StopDataSourceSyncJob: {
          http: {
            requestUri: "/applications/{applicationId}/indices/{indexId}/datasources/{dataSourceId}/stopsync",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "dataSourceId",
              "indexId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              dataSourceId: {
                location: "uri",
                locationName: "dataSourceId"
              },
              indexId: {
                location: "uri",
                locationName: "indexId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            requestUri: "/v1/tags/{resourceARN}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceARN",
              "tags"
            ],
            members: {
              resourceARN: {
                location: "uri",
                locationName: "resourceARN"
              },
              tags: {
                shape: "S2s"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/v1/tags/{resourceARN}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceARN",
              "tagKeys"
            ],
            members: {
              resourceARN: {
                location: "uri",
                locationName: "resourceARN"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateApplication: {
          http: {
            method: "PUT",
            requestUri: "/applications/{applicationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              attachmentsConfiguration: {
                shape: "S2m"
              },
              description: {},
              displayName: {},
              roleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateChatControlsConfiguration: {
          http: {
            method: "PATCH",
            requestUri: "/applications/{applicationId}/chatcontrols",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              blockedPhrasesConfigurationUpdate: {
                type: "structure",
                members: {
                  blockedPhrasesToCreateOrUpdate: {
                    shape: "S53"
                  },
                  blockedPhrasesToDelete: {
                    shape: "S53"
                  },
                  systemMessageOverride: {}
                }
              },
              clientToken: {
                idempotencyToken: true
              },
              responseScope: {},
              topicConfigurationsToCreateOrUpdate: {
                shape: "S57"
              },
              topicConfigurationsToDelete: {
                shape: "S57"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateDataSource: {
          http: {
            method: "PUT",
            requestUri: "/applications/{applicationId}/indices/{indexId}/datasources/{dataSourceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "dataSourceId",
              "indexId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              configuration: {
                shape: "S2z"
              },
              dataSourceId: {
                location: "uri",
                locationName: "dataSourceId"
              },
              description: {},
              displayName: {},
              documentEnrichmentConfiguration: {
                shape: "S19"
              },
              indexId: {
                location: "uri",
                locationName: "indexId"
              },
              roleArn: {},
              syncSchedule: {},
              vpcConfiguration: {
                shape: "S32"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateIndex: {
          http: {
            method: "PUT",
            requestUri: "/applications/{applicationId}/indices/{indexId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "indexId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              capacityConfiguration: {
                shape: "S3a"
              },
              description: {},
              displayName: {},
              documentAttributeConfigurations: {
                shape: "S5x"
              },
              indexId: {
                location: "uri",
                locationName: "indexId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdatePlugin: {
          http: {
            method: "PUT",
            requestUri: "/applications/{applicationId}/plugins/{pluginId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "pluginId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              authConfiguration: {
                shape: "S3g"
              },
              displayName: {},
              pluginId: {
                location: "uri",
                locationName: "pluginId"
              },
              serverUrl: {},
              state: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateRetriever: {
          http: {
            method: "PUT",
            requestUri: "/applications/{applicationId}/retrievers/{retrieverId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "retrieverId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              configuration: {
                shape: "S3p"
              },
              displayName: {},
              retrieverId: {
                location: "uri",
                locationName: "retrieverId"
              },
              roleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateUser: {
          http: {
            method: "PUT",
            requestUri: "/applications/{applicationId}/users/{userId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "userId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              userAliasesToDelete: {
                shape: "S6e"
              },
              userAliasesToUpdate: {
                shape: "S6e"
              },
              userId: {
                location: "uri",
                locationName: "userId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              userAliasesAdded: {
                shape: "S6e"
              },
              userAliasesDeleted: {
                shape: "S6e"
              },
              userAliasesUpdated: {
                shape: "S6e"
              }
            }
          },
          idempotent: true
        },
        UpdateWebExperience: {
          http: {
            method: "PUT",
            requestUri: "/applications/{applicationId}/experiences/{webExperienceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId",
              "webExperienceId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              authenticationConfiguration: {
                shape: "S6h"
              },
              samplePromptsControlMode: {},
              subtitle: {},
              title: {},
              webExperienceId: {
                location: "uri",
                locationName: "webExperienceId"
              },
              welcomeMessage: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        }
      },
      shapes: {
        S9: {
          type: "list",
          member: {
            type: "structure",
            members: {
              dataSourceId: {},
              error: {
                shape: "Sc"
              },
              id: {}
            }
          }
        },
        Sc: {
          type: "structure",
          members: {
            errorCode: {},
            errorMessage: {}
          }
        },
        Sv: {
          type: "structure",
          required: [
            "name",
            "value"
          ],
          members: {
            name: {},
            value: {
              shape: "Sx"
            }
          }
        },
        Sx: {
          type: "structure",
          members: {
            dateValue: {
              type: "timestamp"
            },
            longValue: {
              type: "long"
            },
            stringListValue: {
              type: "list",
              member: {}
            },
            stringValue: {}
          },
          union: true
        },
        S19: {
          type: "structure",
          members: {
            inlineConfigurations: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  condition: {
                    shape: "S1c"
                  },
                  documentContentOperator: {},
                  target: {
                    type: "structure",
                    required: [
                      "key"
                    ],
                    members: {
                      attributeValueOperator: {},
                      key: {},
                      value: {
                        shape: "Sx"
                      }
                    }
                  }
                }
              }
            },
            postExtractionHookConfiguration: {
              shape: "S1h"
            },
            preExtractionHookConfiguration: {
              shape: "S1h"
            }
          }
        },
        S1c: {
          type: "structure",
          required: [
            "key",
            "operator"
          ],
          members: {
            key: {},
            operator: {},
            value: {
              shape: "Sx"
            }
          }
        },
        S1h: {
          type: "structure",
          members: {
            invocationCondition: {
              shape: "S1c"
            },
            lambdaArn: {},
            roleArn: {},
            s3BucketName: {}
          }
        },
        S1n: {
          type: "structure",
          required: [
            "payload",
            "payloadFieldNameSeparator",
            "pluginId"
          ],
          members: {
            payload: {
              type: "map",
              key: {},
              value: {
                type: "structure",
                required: [
                  "value"
                ],
                members: {
                  value: {
                    shape: "S1r"
                  }
                }
              }
            },
            payloadFieldNameSeparator: {},
            pluginId: {}
          }
        },
        S1r: {
          type: "structure",
          members: {},
          document: true
        },
        S1x: {
          type: "structure",
          members: {
            andAllFilters: {
              shape: "S1y"
            },
            containsAll: {
              shape: "Sv"
            },
            containsAny: {
              shape: "Sv"
            },
            equalsTo: {
              shape: "Sv"
            },
            greaterThan: {
              shape: "Sv"
            },
            greaterThanOrEquals: {
              shape: "Sv"
            },
            lessThan: {
              shape: "Sv"
            },
            lessThanOrEquals: {
              shape: "Sv"
            },
            notFilter: {
              shape: "S1x"
            },
            orAllFilters: {
              shape: "S1y"
            }
          }
        },
        S1y: {
          type: "list",
          member: {
            shape: "S1x"
          }
        },
        S22: {
          type: "list",
          member: {}
        },
        S25: {
          type: "structure",
          members: {
            payload: {
              type: "map",
              key: {},
              value: {
                type: "structure",
                members: {
                  allowedValues: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        displayValue: {
                          shape: "S1r"
                        },
                        value: {
                          shape: "S1r"
                        }
                      }
                    }
                  },
                  displayName: {},
                  displayOrder: {
                    type: "integer"
                  },
                  required: {
                    type: "boolean"
                  },
                  type: {},
                  value: {
                    shape: "S1r"
                  }
                }
              }
            },
            payloadFieldNameSeparator: {},
            pluginId: {},
            pluginType: {}
          }
        },
        S2e: {
          type: "list",
          member: {
            type: "structure",
            members: {
              error: {
                shape: "Sc"
              },
              name: {},
              status: {}
            }
          }
        },
        S2h: {
          type: "list",
          member: {
            type: "structure",
            members: {
              citationNumber: {
                type: "integer"
              },
              snippet: {},
              textMessageSegments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    beginOffset: {
                      type: "integer"
                    },
                    endOffset: {
                      type: "integer"
                    }
                  }
                }
              },
              title: {},
              updatedAt: {
                type: "timestamp"
              },
              url: {}
            }
          }
        },
        S2m: {
          type: "structure",
          required: [
            "attachmentsControlMode"
          ],
          members: {
            attachmentsControlMode: {}
          }
        },
        S2q: {
          type: "structure",
          members: {
            kmsKeyId: {
              type: "string",
              sensitive: true
            }
          }
        },
        S2s: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        S2z: {
          type: "structure",
          members: {},
          document: true
        },
        S32: {
          type: "structure",
          required: [
            "securityGroupIds",
            "subnetIds"
          ],
          members: {
            securityGroupIds: {
              type: "list",
              member: {}
            },
            subnetIds: {
              type: "list",
              member: {}
            }
          }
        },
        S3a: {
          type: "structure",
          members: {
            units: {
              type: "integer"
            }
          }
        },
        S3g: {
          type: "structure",
          members: {
            basicAuthConfiguration: {
              type: "structure",
              required: [
                "roleArn",
                "secretArn"
              ],
              members: {
                roleArn: {},
                secretArn: {}
              }
            },
            oAuth2ClientCredentialConfiguration: {
              type: "structure",
              required: [
                "roleArn",
                "secretArn"
              ],
              members: {
                roleArn: {},
                secretArn: {}
              }
            }
          },
          union: true
        },
        S3p: {
          type: "structure",
          members: {
            kendraIndexConfiguration: {
              type: "structure",
              required: [
                "indexId"
              ],
              members: {
                indexId: {}
              }
            },
            nativeIndexConfiguration: {
              type: "structure",
              required: [
                "indexId"
              ],
              members: {
                indexId: {}
              }
            }
          },
          union: true
        },
        S40: {
          type: "structure",
          required: [
            "userId"
          ],
          members: {
            dataSourceId: {},
            indexId: {},
            userId: {}
          }
        },
        S53: {
          type: "list",
          member: {}
        },
        S57: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "rules"
            ],
            members: {
              description: {},
              exampleChatMessages: {
                type: "list",
                member: {}
              },
              name: {},
              rules: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ruleType"
                  ],
                  members: {
                    excludedUsersAndGroups: {
                      shape: "S5f"
                    },
                    includedUsersAndGroups: {
                      shape: "S5f"
                    },
                    ruleConfiguration: {
                      type: "structure",
                      members: {
                        contentBlockerRule: {
                          type: "structure",
                          members: {
                            systemMessageOverride: {}
                          }
                        },
                        contentRetrievalRule: {
                          type: "structure",
                          members: {
                            eligibleDataSources: {
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  dataSourceId: {},
                                  indexId: {}
                                }
                              }
                            }
                          }
                        }
                      },
                      union: true
                    },
                    ruleType: {}
                  }
                }
              }
            }
          }
        },
        S5f: {
          type: "structure",
          members: {
            userGroups: {
              shape: "S22"
            },
            userIds: {
              type: "list",
              member: {}
            }
          }
        },
        S5s: {
          type: "structure",
          members: {
            errorDetail: {
              shape: "Sc"
            },
            lastUpdatedAt: {
              type: "timestamp"
            },
            status: {}
          }
        },
        S5x: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              search: {},
              type: {}
            }
          }
        },
        S6e: {
          type: "list",
          member: {
            shape: "S40"
          }
        },
        S6h: {
          type: "structure",
          members: {
            samlConfiguration: {
              type: "structure",
              required: [
                "metadataXML",
                "roleArn",
                "userIdAttribute"
              ],
              members: {
                metadataXML: {},
                roleArn: {},
                userGroupAttribute: {},
                userIdAttribute: {}
              }
            }
          },
          union: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/qbusiness-2023-11-27.paginators.json
var require_qbusiness_2023_11_27_paginators = __commonJS({
  "node_modules/aws-sdk/apis/qbusiness-2023-11-27.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetChatControlsConfiguration: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "topicConfigurations"
        },
        ListApplications: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "applications"
        },
        ListConversations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "conversations"
        },
        ListDataSourceSyncJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "history"
        },
        ListDataSources: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "dataSources"
        },
        ListDocuments: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "documentDetailList"
        },
        ListGroups: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListIndices: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "indices"
        },
        ListMessages: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "messages"
        },
        ListPlugins: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "plugins"
        },
        ListRetrievers: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "retrievers"
        },
        ListWebExperiences: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "webExperiences"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/qbusiness.js
var require_qbusiness = __commonJS({
  "node_modules/aws-sdk/clients/qbusiness.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["qbusiness"] = {};
    AWS2.QBusiness = Service.defineService("qbusiness", ["2023-11-27"]);
    Object.defineProperty(apiLoader.services["qbusiness"], "2023-11-27", {
      get: function get() {
        var model = require_qbusiness_2023_11_27_min();
        model.paginators = require_qbusiness_2023_11_27_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.QBusiness;
  }
});

// node_modules/aws-sdk/apis/qconnect-2020-10-19.min.json
var require_qconnect_2020_10_19_min = __commonJS({
  "node_modules/aws-sdk/apis/qconnect-2020-10-19.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-10-19",
        endpointPrefix: "wisdom",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Q Connect",
        serviceId: "QConnect",
        signatureVersion: "v4",
        signingName: "wisdom",
        uid: "qconnect-2020-10-19"
      },
      operations: {
        CreateAssistant: {
          http: {
            requestUri: "/assistants",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "type"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              description: {},
              name: {},
              serverSideEncryptionConfiguration: {
                shape: "S5"
              },
              tags: {
                shape: "S7"
              },
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              assistant: {
                shape: "Sc"
              }
            }
          },
          idempotent: true
        },
        CreateAssistantAssociation: {
          http: {
            requestUri: "/assistants/{assistantId}/associations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assistantId",
              "association",
              "associationType"
            ],
            members: {
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              },
              association: {
                type: "structure",
                members: {
                  knowledgeBaseId: {}
                },
                union: true
              },
              associationType: {},
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              assistantAssociation: {
                shape: "Sp"
              }
            }
          },
          idempotent: true
        },
        CreateContent: {
          http: {
            requestUri: "/knowledgeBases/{knowledgeBaseId}/contents",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId",
              "name",
              "uploadId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              metadata: {
                shape: "St"
              },
              name: {},
              overrideLinkOutUri: {},
              tags: {
                shape: "S7"
              },
              title: {},
              uploadId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              content: {
                shape: "Sy"
              }
            }
          },
          idempotent: true
        },
        CreateKnowledgeBase: {
          http: {
            requestUri: "/knowledgeBases",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseType",
              "name"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              description: {},
              knowledgeBaseType: {},
              name: {},
              renderingConfiguration: {
                shape: "S15"
              },
              serverSideEncryptionConfiguration: {
                shape: "S5"
              },
              sourceConfiguration: {
                shape: "S16"
              },
              tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              knowledgeBase: {
                shape: "S1a"
              }
            }
          },
          idempotent: true
        },
        CreateQuickResponse: {
          http: {
            requestUri: "/knowledgeBases/{knowledgeBaseId}/quickResponses",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "content",
              "knowledgeBaseId",
              "name"
            ],
            members: {
              channels: {
                shape: "S1d"
              },
              clientToken: {
                idempotencyToken: true
              },
              content: {
                shape: "S1f"
              },
              contentType: {},
              description: {},
              groupingConfiguration: {
                shape: "S1j"
              },
              isActive: {
                type: "boolean"
              },
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              language: {},
              name: {},
              shortcutKey: {},
              tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              quickResponse: {
                shape: "S1s"
              }
            }
          },
          idempotent: true
        },
        CreateSession: {
          http: {
            requestUri: "/assistants/{assistantId}/sessions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assistantId",
              "name"
            ],
            members: {
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              },
              clientToken: {
                idempotencyToken: true
              },
              description: {},
              name: {},
              tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              session: {
                shape: "S1y"
              }
            }
          },
          idempotent: true
        },
        DeleteAssistant: {
          http: {
            method: "DELETE",
            requestUri: "/assistants/{assistantId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "assistantId"
            ],
            members: {
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteAssistantAssociation: {
          http: {
            method: "DELETE",
            requestUri: "/assistants/{assistantId}/associations/{assistantAssociationId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "assistantAssociationId",
              "assistantId"
            ],
            members: {
              assistantAssociationId: {
                location: "uri",
                locationName: "assistantAssociationId"
              },
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteContent: {
          http: {
            method: "DELETE",
            requestUri: "/knowledgeBases/{knowledgeBaseId}/contents/{contentId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "contentId",
              "knowledgeBaseId"
            ],
            members: {
              contentId: {
                location: "uri",
                locationName: "contentId"
              },
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteImportJob: {
          http: {
            method: "DELETE",
            requestUri: "/knowledgeBases/{knowledgeBaseId}/importJobs/{importJobId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "importJobId",
              "knowledgeBaseId"
            ],
            members: {
              importJobId: {
                location: "uri",
                locationName: "importJobId"
              },
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteKnowledgeBase: {
          http: {
            method: "DELETE",
            requestUri: "/knowledgeBases/{knowledgeBaseId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteQuickResponse: {
          http: {
            method: "DELETE",
            requestUri: "/knowledgeBases/{knowledgeBaseId}/quickResponses/{quickResponseId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId",
              "quickResponseId"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              quickResponseId: {
                location: "uri",
                locationName: "quickResponseId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        GetAssistant: {
          http: {
            method: "GET",
            requestUri: "/assistants/{assistantId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assistantId"
            ],
            members: {
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              assistant: {
                shape: "Sc"
              }
            }
          }
        },
        GetAssistantAssociation: {
          http: {
            method: "GET",
            requestUri: "/assistants/{assistantId}/associations/{assistantAssociationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assistantAssociationId",
              "assistantId"
            ],
            members: {
              assistantAssociationId: {
                location: "uri",
                locationName: "assistantAssociationId"
              },
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              assistantAssociation: {
                shape: "Sp"
              }
            }
          }
        },
        GetContent: {
          http: {
            method: "GET",
            requestUri: "/knowledgeBases/{knowledgeBaseId}/contents/{contentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "contentId",
              "knowledgeBaseId"
            ],
            members: {
              contentId: {
                location: "uri",
                locationName: "contentId"
              },
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              content: {
                shape: "Sy"
              }
            }
          }
        },
        GetContentSummary: {
          http: {
            method: "GET",
            requestUri: "/knowledgeBases/{knowledgeBaseId}/contents/{contentId}/summary",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "contentId",
              "knowledgeBaseId"
            ],
            members: {
              contentId: {
                location: "uri",
                locationName: "contentId"
              },
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              contentSummary: {
                shape: "S2k"
              }
            }
          }
        },
        GetImportJob: {
          http: {
            method: "GET",
            requestUri: "/knowledgeBases/{knowledgeBaseId}/importJobs/{importJobId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "importJobId",
              "knowledgeBaseId"
            ],
            members: {
              importJobId: {
                location: "uri",
                locationName: "importJobId"
              },
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              importJob: {
                shape: "S2n"
              }
            }
          }
        },
        GetKnowledgeBase: {
          http: {
            method: "GET",
            requestUri: "/knowledgeBases/{knowledgeBaseId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              knowledgeBase: {
                shape: "S1a"
              }
            }
          }
        },
        GetQuickResponse: {
          http: {
            method: "GET",
            requestUri: "/knowledgeBases/{knowledgeBaseId}/quickResponses/{quickResponseId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId",
              "quickResponseId"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              quickResponseId: {
                location: "uri",
                locationName: "quickResponseId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              quickResponse: {
                shape: "S1s"
              }
            }
          }
        },
        GetRecommendations: {
          http: {
            method: "GET",
            requestUri: "/assistants/{assistantId}/sessions/{sessionId}/recommendations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assistantId",
              "sessionId"
            ],
            members: {
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              sessionId: {
                location: "uri",
                locationName: "sessionId"
              },
              waitTimeSeconds: {
                location: "querystring",
                locationName: "waitTimeSeconds",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "recommendations"
            ],
            members: {
              recommendations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "recommendationId"
                  ],
                  members: {
                    data: {
                      shape: "S34"
                    },
                    document: {
                      shape: "S3o"
                    },
                    recommendationId: {},
                    relevanceLevel: {},
                    relevanceScore: {
                      type: "double"
                    },
                    type: {}
                  }
                }
              },
              triggers: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "data",
                    "id",
                    "recommendationIds",
                    "source",
                    "type"
                  ],
                  members: {
                    data: {
                      type: "structure",
                      members: {
                        query: {
                          type: "structure",
                          members: {
                            text: {
                              shape: "S3v"
                            }
                          }
                        }
                      },
                      union: true
                    },
                    id: {},
                    recommendationIds: {
                      shape: "S3w"
                    },
                    source: {},
                    type: {}
                  }
                }
              }
            }
          }
        },
        GetSession: {
          http: {
            method: "GET",
            requestUri: "/assistants/{assistantId}/sessions/{sessionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assistantId",
              "sessionId"
            ],
            members: {
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              },
              sessionId: {
                location: "uri",
                locationName: "sessionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              session: {
                shape: "S1y"
              }
            }
          }
        },
        ListAssistantAssociations: {
          http: {
            method: "GET",
            requestUri: "/assistants/{assistantId}/associations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assistantId"
            ],
            members: {
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assistantAssociationSummaries"
            ],
            members: {
              assistantAssociationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "assistantArn",
                    "assistantAssociationArn",
                    "assistantAssociationId",
                    "assistantId",
                    "associationData",
                    "associationType"
                  ],
                  members: {
                    assistantArn: {},
                    assistantAssociationArn: {},
                    assistantAssociationId: {},
                    assistantId: {},
                    associationData: {
                      shape: "Sq"
                    },
                    associationType: {},
                    tags: {
                      shape: "S7"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAssistants: {
          http: {
            method: "GET",
            requestUri: "/assistants",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assistantSummaries"
            ],
            members: {
              assistantSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "assistantArn",
                    "assistantId",
                    "name",
                    "status",
                    "type"
                  ],
                  members: {
                    assistantArn: {},
                    assistantId: {},
                    capabilityConfiguration: {
                      shape: "Sf"
                    },
                    description: {},
                    integrationConfiguration: {
                      shape: "Sh"
                    },
                    name: {},
                    serverSideEncryptionConfiguration: {
                      shape: "S5"
                    },
                    status: {},
                    tags: {
                      shape: "S7"
                    },
                    type: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListContents: {
          http: {
            method: "GET",
            requestUri: "/knowledgeBases/{knowledgeBaseId}/contents",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "contentSummaries"
            ],
            members: {
              contentSummaries: {
                shape: "S4c"
              },
              nextToken: {}
            }
          }
        },
        ListImportJobs: {
          http: {
            method: "GET",
            requestUri: "/knowledgeBases/{knowledgeBaseId}/importJobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "importJobSummaries"
            ],
            members: {
              importJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "createdTime",
                    "importJobId",
                    "importJobType",
                    "knowledgeBaseArn",
                    "knowledgeBaseId",
                    "lastModifiedTime",
                    "status",
                    "uploadId"
                  ],
                  members: {
                    createdTime: {
                      shape: "S12"
                    },
                    externalSourceConfiguration: {
                      shape: "S2o"
                    },
                    importJobId: {},
                    importJobType: {},
                    knowledgeBaseArn: {},
                    knowledgeBaseId: {},
                    lastModifiedTime: {
                      shape: "S12"
                    },
                    metadata: {
                      shape: "St"
                    },
                    status: {},
                    uploadId: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListKnowledgeBases: {
          http: {
            method: "GET",
            requestUri: "/knowledgeBases",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "knowledgeBaseSummaries"
            ],
            members: {
              knowledgeBaseSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "knowledgeBaseArn",
                    "knowledgeBaseId",
                    "knowledgeBaseType",
                    "name",
                    "status"
                  ],
                  members: {
                    description: {},
                    knowledgeBaseArn: {},
                    knowledgeBaseId: {},
                    knowledgeBaseType: {},
                    name: {},
                    renderingConfiguration: {
                      shape: "S15"
                    },
                    serverSideEncryptionConfiguration: {
                      shape: "S5"
                    },
                    sourceConfiguration: {
                      shape: "S16"
                    },
                    status: {},
                    tags: {
                      shape: "S7"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListQuickResponses: {
          http: {
            method: "GET",
            requestUri: "/knowledgeBases/{knowledgeBaseId}/quickResponses",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "quickResponseSummaries"
            ],
            members: {
              nextToken: {},
              quickResponseSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "contentType",
                    "createdTime",
                    "knowledgeBaseArn",
                    "knowledgeBaseId",
                    "lastModifiedTime",
                    "name",
                    "quickResponseArn",
                    "quickResponseId",
                    "status"
                  ],
                  members: {
                    channels: {
                      shape: "S1d"
                    },
                    contentType: {},
                    createdTime: {
                      shape: "S12"
                    },
                    description: {},
                    isActive: {
                      type: "boolean"
                    },
                    knowledgeBaseArn: {},
                    knowledgeBaseId: {},
                    lastModifiedBy: {},
                    lastModifiedTime: {
                      shape: "S12"
                    },
                    name: {},
                    quickResponseArn: {},
                    quickResponseId: {},
                    status: {},
                    tags: {
                      shape: "S7"
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S7"
              }
            }
          }
        },
        NotifyRecommendationsReceived: {
          http: {
            requestUri: "/assistants/{assistantId}/sessions/{sessionId}/recommendations/notify",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assistantId",
              "recommendationIds",
              "sessionId"
            ],
            members: {
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              },
              recommendationIds: {
                shape: "S3w"
              },
              sessionId: {
                location: "uri",
                locationName: "sessionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    message: {},
                    recommendationId: {}
                  }
                }
              },
              recommendationIds: {
                shape: "S3w"
              }
            }
          },
          idempotent: true
        },
        PutFeedback: {
          http: {
            method: "PUT",
            requestUri: "/assistants/{assistantId}/feedback",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assistantId",
              "contentFeedback",
              "targetId",
              "targetType"
            ],
            members: {
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              },
              contentFeedback: {
                shape: "S4x"
              },
              targetId: {},
              targetType: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "assistantArn",
              "assistantId",
              "contentFeedback",
              "targetId",
              "targetType"
            ],
            members: {
              assistantArn: {},
              assistantId: {},
              contentFeedback: {
                shape: "S4x"
              },
              targetId: {},
              targetType: {}
            }
          },
          idempotent: true
        },
        QueryAssistant: {
          http: {
            requestUri: "/assistants/{assistantId}/query",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assistantId",
              "queryText"
            ],
            members: {
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              queryCondition: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    single: {
                      type: "structure",
                      required: [
                        "comparator",
                        "field",
                        "value"
                      ],
                      members: {
                        comparator: {},
                        field: {},
                        value: {}
                      }
                    }
                  },
                  union: true
                }
              },
              queryText: {
                shape: "S3v"
              },
              sessionId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "results"
            ],
            members: {
              nextToken: {},
              results: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "resultId"
                  ],
                  members: {
                    data: {
                      shape: "S34"
                    },
                    document: {
                      shape: "S3o"
                    },
                    relevanceScore: {
                      type: "double"
                    },
                    resultId: {},
                    type: {}
                  }
                }
              }
            }
          }
        },
        RemoveKnowledgeBaseTemplateUri: {
          http: {
            method: "DELETE",
            requestUri: "/knowledgeBases/{knowledgeBaseId}/templateUri",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SearchContent: {
          http: {
            requestUri: "/knowledgeBases/{knowledgeBaseId}/search",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId",
              "searchExpression"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              searchExpression: {
                shape: "S5f"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "contentSummaries"
            ],
            members: {
              contentSummaries: {
                shape: "S4c"
              },
              nextToken: {}
            }
          }
        },
        SearchQuickResponses: {
          http: {
            requestUri: "/knowledgeBases/{knowledgeBaseId}/search/quickResponses",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId",
              "searchExpression"
            ],
            members: {
              attributes: {
                type: "map",
                key: {},
                value: {},
                sensitive: true
              },
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              searchExpression: {
                type: "structure",
                members: {
                  filters: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "name",
                        "operator"
                      ],
                      members: {
                        includeNoExistence: {
                          type: "boolean"
                        },
                        name: {},
                        operator: {},
                        values: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  },
                  orderOnField: {
                    type: "structure",
                    required: [
                      "name"
                    ],
                    members: {
                      name: {},
                      order: {}
                    }
                  },
                  queries: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "name",
                        "operator",
                        "values"
                      ],
                      members: {
                        allowFuzziness: {
                          type: "boolean"
                        },
                        name: {},
                        operator: {},
                        priority: {},
                        values: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "results"
            ],
            members: {
              nextToken: {},
              results: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "contentType",
                    "contents",
                    "createdTime",
                    "isActive",
                    "knowledgeBaseArn",
                    "knowledgeBaseId",
                    "lastModifiedTime",
                    "name",
                    "quickResponseArn",
                    "quickResponseId",
                    "status"
                  ],
                  members: {
                    attributesInterpolated: {
                      shape: "S66"
                    },
                    attributesNotInterpolated: {
                      shape: "S66"
                    },
                    channels: {
                      shape: "S1d"
                    },
                    contentType: {},
                    contents: {
                      shape: "S1t"
                    },
                    createdTime: {
                      shape: "S12"
                    },
                    description: {},
                    groupingConfiguration: {
                      shape: "S1j"
                    },
                    isActive: {
                      type: "boolean"
                    },
                    knowledgeBaseArn: {},
                    knowledgeBaseId: {},
                    language: {},
                    lastModifiedBy: {},
                    lastModifiedTime: {
                      shape: "S12"
                    },
                    name: {},
                    quickResponseArn: {},
                    quickResponseId: {},
                    shortcutKey: {},
                    status: {},
                    tags: {
                      shape: "S7"
                    }
                  }
                }
              }
            }
          }
        },
        SearchSessions: {
          http: {
            requestUri: "/assistants/{assistantId}/searchSessions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assistantId",
              "searchExpression"
            ],
            members: {
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              searchExpression: {
                shape: "S5f"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "sessionSummaries"
            ],
            members: {
              nextToken: {},
              sessionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "assistantArn",
                    "assistantId",
                    "sessionArn",
                    "sessionId"
                  ],
                  members: {
                    assistantArn: {},
                    assistantId: {},
                    sessionArn: {},
                    sessionId: {}
                  }
                }
              }
            }
          }
        },
        StartContentUpload: {
          http: {
            requestUri: "/knowledgeBases/{knowledgeBaseId}/upload",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "contentType",
              "knowledgeBaseId"
            ],
            members: {
              contentType: {},
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              presignedUrlTimeToLive: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "headersToInclude",
              "uploadId",
              "url",
              "urlExpiry"
            ],
            members: {
              headersToInclude: {
                type: "map",
                key: {},
                value: {}
              },
              uploadId: {},
              url: {
                shape: "S11"
              },
              urlExpiry: {
                shape: "S12"
              }
            }
          }
        },
        StartImportJob: {
          http: {
            requestUri: "/knowledgeBases/{knowledgeBaseId}/importJobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "importJobType",
              "knowledgeBaseId",
              "uploadId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              externalSourceConfiguration: {
                shape: "S2o"
              },
              importJobType: {},
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              metadata: {
                shape: "St"
              },
              uploadId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              importJob: {
                shape: "S2n"
              }
            }
          },
          idempotent: true
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateContent: {
          http: {
            requestUri: "/knowledgeBases/{knowledgeBaseId}/contents/{contentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "contentId",
              "knowledgeBaseId"
            ],
            members: {
              contentId: {
                location: "uri",
                locationName: "contentId"
              },
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              metadata: {
                shape: "St"
              },
              overrideLinkOutUri: {},
              removeOverrideLinkOutUri: {
                type: "boolean"
              },
              revisionId: {},
              title: {},
              uploadId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              content: {
                shape: "Sy"
              }
            }
          }
        },
        UpdateKnowledgeBaseTemplateUri: {
          http: {
            requestUri: "/knowledgeBases/{knowledgeBaseId}/templateUri",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId",
              "templateUri"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              templateUri: {}
            }
          },
          output: {
            type: "structure",
            members: {
              knowledgeBase: {
                shape: "S1a"
              }
            }
          }
        },
        UpdateQuickResponse: {
          http: {
            requestUri: "/knowledgeBases/{knowledgeBaseId}/quickResponses/{quickResponseId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId",
              "quickResponseId"
            ],
            members: {
              channels: {
                shape: "S1d"
              },
              content: {
                shape: "S1f"
              },
              contentType: {},
              description: {},
              groupingConfiguration: {
                shape: "S1j"
              },
              isActive: {
                type: "boolean"
              },
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              language: {},
              name: {},
              quickResponseId: {
                location: "uri",
                locationName: "quickResponseId"
              },
              removeDescription: {
                type: "boolean"
              },
              removeGroupingConfiguration: {
                type: "boolean"
              },
              removeShortcutKey: {
                type: "boolean"
              },
              shortcutKey: {}
            }
          },
          output: {
            type: "structure",
            members: {
              quickResponse: {
                shape: "S1s"
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          members: {
            kmsKeyId: {}
          }
        },
        S7: {
          type: "map",
          key: {},
          value: {}
        },
        Sc: {
          type: "structure",
          required: [
            "assistantArn",
            "assistantId",
            "name",
            "status",
            "type"
          ],
          members: {
            assistantArn: {},
            assistantId: {},
            capabilityConfiguration: {
              shape: "Sf"
            },
            description: {},
            integrationConfiguration: {
              shape: "Sh"
            },
            name: {},
            serverSideEncryptionConfiguration: {
              shape: "S5"
            },
            status: {},
            tags: {
              shape: "S7"
            },
            type: {}
          }
        },
        Sf: {
          type: "structure",
          members: {
            type: {}
          }
        },
        Sh: {
          type: "structure",
          members: {
            topicIntegrationArn: {}
          }
        },
        Sp: {
          type: "structure",
          required: [
            "assistantArn",
            "assistantAssociationArn",
            "assistantAssociationId",
            "assistantId",
            "associationData",
            "associationType"
          ],
          members: {
            assistantArn: {},
            assistantAssociationArn: {},
            assistantAssociationId: {},
            assistantId: {},
            associationData: {
              shape: "Sq"
            },
            associationType: {},
            tags: {
              shape: "S7"
            }
          }
        },
        Sq: {
          type: "structure",
          members: {
            knowledgeBaseAssociation: {
              type: "structure",
              members: {
                knowledgeBaseArn: {},
                knowledgeBaseId: {}
              }
            }
          },
          union: true
        },
        St: {
          type: "map",
          key: {},
          value: {}
        },
        Sy: {
          type: "structure",
          required: [
            "contentArn",
            "contentId",
            "contentType",
            "knowledgeBaseArn",
            "knowledgeBaseId",
            "metadata",
            "name",
            "revisionId",
            "status",
            "title",
            "url",
            "urlExpiry"
          ],
          members: {
            contentArn: {},
            contentId: {},
            contentType: {},
            knowledgeBaseArn: {},
            knowledgeBaseId: {},
            linkOutUri: {},
            metadata: {
              shape: "St"
            },
            name: {},
            revisionId: {},
            status: {},
            tags: {
              shape: "S7"
            },
            title: {},
            url: {
              shape: "S11"
            },
            urlExpiry: {
              shape: "S12"
            }
          }
        },
        S11: {
          type: "string",
          sensitive: true
        },
        S12: {
          type: "timestamp",
          timestampFormat: "unixTimestamp"
        },
        S15: {
          type: "structure",
          members: {
            templateUri: {}
          }
        },
        S16: {
          type: "structure",
          members: {
            appIntegrations: {
              type: "structure",
              required: [
                "appIntegrationArn"
              ],
              members: {
                appIntegrationArn: {},
                objectFields: {
                  type: "list",
                  member: {}
                }
              }
            }
          },
          union: true
        },
        S1a: {
          type: "structure",
          required: [
            "knowledgeBaseArn",
            "knowledgeBaseId",
            "knowledgeBaseType",
            "name",
            "status"
          ],
          members: {
            description: {},
            knowledgeBaseArn: {},
            knowledgeBaseId: {},
            knowledgeBaseType: {},
            lastContentModificationTime: {
              shape: "S12"
            },
            name: {},
            renderingConfiguration: {
              shape: "S15"
            },
            serverSideEncryptionConfiguration: {
              shape: "S5"
            },
            sourceConfiguration: {
              shape: "S16"
            },
            status: {},
            tags: {
              shape: "S7"
            }
          }
        },
        S1d: {
          type: "list",
          member: {
            type: "string",
            sensitive: true
          }
        },
        S1f: {
          type: "structure",
          members: {
            content: {
              shape: "S1g"
            }
          },
          union: true
        },
        S1g: {
          type: "string",
          sensitive: true
        },
        S1j: {
          type: "structure",
          members: {
            criteria: {
              type: "string",
              sensitive: true
            },
            values: {
              type: "list",
              member: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        S1s: {
          type: "structure",
          required: [
            "contentType",
            "createdTime",
            "knowledgeBaseArn",
            "knowledgeBaseId",
            "lastModifiedTime",
            "name",
            "quickResponseArn",
            "quickResponseId",
            "status"
          ],
          members: {
            channels: {
              shape: "S1d"
            },
            contentType: {},
            contents: {
              shape: "S1t"
            },
            createdTime: {
              shape: "S12"
            },
            description: {},
            groupingConfiguration: {
              shape: "S1j"
            },
            isActive: {
              type: "boolean"
            },
            knowledgeBaseArn: {},
            knowledgeBaseId: {},
            language: {},
            lastModifiedBy: {},
            lastModifiedTime: {
              shape: "S12"
            },
            name: {},
            quickResponseArn: {},
            quickResponseId: {},
            shortcutKey: {},
            status: {},
            tags: {
              shape: "S7"
            }
          }
        },
        S1t: {
          type: "structure",
          members: {
            markdown: {
              shape: "S1u"
            },
            plainText: {
              shape: "S1u"
            }
          }
        },
        S1u: {
          type: "structure",
          members: {
            content: {
              shape: "S1g"
            }
          },
          union: true
        },
        S1y: {
          type: "structure",
          required: [
            "name",
            "sessionArn",
            "sessionId"
          ],
          members: {
            description: {},
            integrationConfiguration: {
              type: "structure",
              members: {
                topicIntegrationArn: {}
              }
            },
            name: {},
            sessionArn: {},
            sessionId: {},
            tags: {
              shape: "S7"
            }
          }
        },
        S2k: {
          type: "structure",
          required: [
            "contentArn",
            "contentId",
            "contentType",
            "knowledgeBaseArn",
            "knowledgeBaseId",
            "metadata",
            "name",
            "revisionId",
            "status",
            "title"
          ],
          members: {
            contentArn: {},
            contentId: {},
            contentType: {},
            knowledgeBaseArn: {},
            knowledgeBaseId: {},
            metadata: {
              shape: "St"
            },
            name: {},
            revisionId: {},
            status: {},
            tags: {
              shape: "S7"
            },
            title: {}
          }
        },
        S2n: {
          type: "structure",
          required: [
            "createdTime",
            "importJobId",
            "importJobType",
            "knowledgeBaseArn",
            "knowledgeBaseId",
            "lastModifiedTime",
            "status",
            "uploadId",
            "url",
            "urlExpiry"
          ],
          members: {
            createdTime: {
              shape: "S12"
            },
            externalSourceConfiguration: {
              shape: "S2o"
            },
            failedRecordReport: {
              shape: "S11"
            },
            importJobId: {},
            importJobType: {},
            knowledgeBaseArn: {},
            knowledgeBaseId: {},
            lastModifiedTime: {
              shape: "S12"
            },
            metadata: {
              shape: "St"
            },
            status: {},
            uploadId: {},
            url: {
              shape: "S11"
            },
            urlExpiry: {
              shape: "S12"
            }
          }
        },
        S2o: {
          type: "structure",
          required: [
            "configuration",
            "source"
          ],
          members: {
            configuration: {
              type: "structure",
              members: {
                connectConfiguration: {
                  type: "structure",
                  members: {
                    instanceId: {}
                  }
                }
              },
              union: true
            },
            source: {}
          }
        },
        S34: {
          type: "structure",
          required: [
            "details",
            "reference"
          ],
          members: {
            details: {
              type: "structure",
              members: {
                contentData: {
                  type: "structure",
                  required: [
                    "rankingData",
                    "textData"
                  ],
                  members: {
                    rankingData: {
                      shape: "S37"
                    },
                    textData: {
                      shape: "S3a"
                    }
                  }
                },
                generativeData: {
                  type: "structure",
                  required: [
                    "completion",
                    "rankingData",
                    "references"
                  ],
                  members: {
                    completion: {
                      shape: "S3f"
                    },
                    rankingData: {
                      shape: "S37"
                    },
                    references: {
                      type: "list",
                      member: {
                        shape: "S34"
                      }
                    }
                  }
                },
                sourceContentData: {
                  type: "structure",
                  required: [
                    "id",
                    "rankingData",
                    "textData",
                    "type"
                  ],
                  members: {
                    id: {},
                    rankingData: {
                      shape: "S37"
                    },
                    textData: {
                      shape: "S3a"
                    },
                    type: {}
                  }
                }
              },
              union: true
            },
            reference: {
              type: "structure",
              members: {
                contentReference: {
                  shape: "S3l"
                },
                generativeReference: {
                  type: "structure",
                  members: {
                    generationId: {},
                    modelId: {}
                  }
                }
              },
              union: true
            }
          }
        },
        S37: {
          type: "structure",
          members: {
            relevanceLevel: {},
            relevanceScore: {
              type: "double"
            }
          }
        },
        S3a: {
          type: "structure",
          members: {
            excerpt: {
              shape: "S3b"
            },
            title: {
              shape: "S3b"
            }
          }
        },
        S3b: {
          type: "structure",
          members: {
            highlights: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  beginOffsetInclusive: {
                    type: "integer"
                  },
                  endOffsetExclusive: {
                    type: "integer"
                  }
                }
              }
            },
            text: {
              shape: "S3f"
            }
          }
        },
        S3f: {
          type: "string",
          sensitive: true
        },
        S3l: {
          type: "structure",
          members: {
            contentArn: {},
            contentId: {},
            knowledgeBaseArn: {},
            knowledgeBaseId: {}
          }
        },
        S3o: {
          type: "structure",
          required: [
            "contentReference"
          ],
          members: {
            contentReference: {
              shape: "S3l"
            },
            excerpt: {
              shape: "S3b"
            },
            title: {
              shape: "S3b"
            }
          }
        },
        S3v: {
          type: "string",
          sensitive: true
        },
        S3w: {
          type: "list",
          member: {}
        },
        S4c: {
          type: "list",
          member: {
            shape: "S2k"
          }
        },
        S4x: {
          type: "structure",
          members: {
            generativeContentFeedbackData: {
              type: "structure",
              required: [
                "relevance"
              ],
              members: {
                relevance: {}
              }
            }
          },
          union: true
        },
        S5f: {
          type: "structure",
          required: [
            "filters"
          ],
          members: {
            filters: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "field",
                  "operator",
                  "value"
                ],
                members: {
                  field: {},
                  operator: {},
                  value: {}
                }
              }
            }
          }
        },
        S66: {
          type: "list",
          member: {},
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/qconnect-2020-10-19.paginators.json
var require_qconnect_2020_10_19_paginators = __commonJS({
  "node_modules/aws-sdk/apis/qconnect-2020-10-19.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAssistantAssociations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "assistantAssociationSummaries"
        },
        ListAssistants: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "assistantSummaries"
        },
        ListContents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "contentSummaries"
        },
        ListImportJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "importJobSummaries"
        },
        ListKnowledgeBases: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "knowledgeBaseSummaries"
        },
        ListQuickResponses: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "quickResponseSummaries"
        },
        QueryAssistant: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "results"
        },
        SearchContent: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "contentSummaries"
        },
        SearchQuickResponses: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "results"
        },
        SearchSessions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "sessionSummaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/qconnect.js
var require_qconnect = __commonJS({
  "node_modules/aws-sdk/clients/qconnect.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["qconnect"] = {};
    AWS2.QConnect = Service.defineService("qconnect", ["2020-10-19"]);
    Object.defineProperty(apiLoader.services["qconnect"], "2020-10-19", {
      get: function get() {
        var model = require_qconnect_2020_10_19_min();
        model.paginators = require_qconnect_2020_10_19_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.QConnect;
  }
});

// node_modules/aws-sdk/apis/cleanroomsml-2023-09-06.min.json
var require_cleanroomsml_2023_09_06_min = __commonJS({
  "node_modules/aws-sdk/apis/cleanroomsml-2023-09-06.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2023-09-06",
        endpointPrefix: "cleanrooms-ml",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Clean Rooms ML",
        serviceId: "CleanRoomsML",
        signatureVersion: "v4",
        signingName: "cleanrooms-ml",
        uid: "cleanroomsml-2023-09-06"
      },
      operations: {
        CreateAudienceModel: {
          http: {
            requestUri: "/audience-model",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "trainingDatasetArn"
            ],
            members: {
              description: {},
              kmsKeyArn: {},
              name: {},
              tags: {
                shape: "S5"
              },
              trainingDataEndTime: {
                shape: "S8"
              },
              trainingDataStartTime: {
                shape: "S8"
              },
              trainingDatasetArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "audienceModelArn"
            ],
            members: {
              audienceModelArn: {}
            }
          },
          idempotent: true
        },
        CreateConfiguredAudienceModel: {
          http: {
            requestUri: "/configured-audience-model",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "audienceModelArn",
              "name",
              "outputConfig",
              "sharedAudienceMetrics"
            ],
            members: {
              audienceModelArn: {},
              audienceSizeConfig: {
                shape: "Sd"
              },
              childResourceTagOnCreatePolicy: {},
              description: {},
              minMatchingSeedSize: {
                type: "integer"
              },
              name: {},
              outputConfig: {
                shape: "Sj"
              },
              sharedAudienceMetrics: {
                shape: "So"
              },
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "configuredAudienceModelArn"
            ],
            members: {
              configuredAudienceModelArn: {}
            }
          },
          idempotent: true
        },
        CreateTrainingDataset: {
          http: {
            requestUri: "/training-dataset",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "roleArn",
              "trainingData"
            ],
            members: {
              description: {},
              name: {},
              roleArn: {},
              tags: {
                shape: "S5"
              },
              trainingData: {
                type: "list",
                member: {
                  shape: "Su"
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "trainingDatasetArn"
            ],
            members: {
              trainingDatasetArn: {}
            }
          },
          idempotent: true
        },
        DeleteAudienceGenerationJob: {
          http: {
            method: "DELETE",
            requestUri: "/audience-generation-job/{audienceGenerationJobArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "audienceGenerationJobArn"
            ],
            members: {
              audienceGenerationJobArn: {
                location: "uri",
                locationName: "audienceGenerationJobArn"
              }
            }
          },
          idempotent: true
        },
        DeleteAudienceModel: {
          http: {
            method: "DELETE",
            requestUri: "/audience-model/{audienceModelArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "audienceModelArn"
            ],
            members: {
              audienceModelArn: {
                location: "uri",
                locationName: "audienceModelArn"
              }
            }
          },
          idempotent: true
        },
        DeleteConfiguredAudienceModel: {
          http: {
            method: "DELETE",
            requestUri: "/configured-audience-model/{configuredAudienceModelArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "configuredAudienceModelArn"
            ],
            members: {
              configuredAudienceModelArn: {
                location: "uri",
                locationName: "configuredAudienceModelArn"
              }
            }
          },
          idempotent: true
        },
        DeleteConfiguredAudienceModelPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/configured-audience-model/{configuredAudienceModelArn}/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "configuredAudienceModelArn"
            ],
            members: {
              configuredAudienceModelArn: {
                location: "uri",
                locationName: "configuredAudienceModelArn"
              }
            }
          },
          idempotent: true
        },
        DeleteTrainingDataset: {
          http: {
            method: "DELETE",
            requestUri: "/training-dataset/{trainingDatasetArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "trainingDatasetArn"
            ],
            members: {
              trainingDatasetArn: {
                location: "uri",
                locationName: "trainingDatasetArn"
              }
            }
          },
          idempotent: true
        },
        GetAudienceGenerationJob: {
          http: {
            method: "GET",
            requestUri: "/audience-generation-job/{audienceGenerationJobArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "audienceGenerationJobArn"
            ],
            members: {
              audienceGenerationJobArn: {
                location: "uri",
                locationName: "audienceGenerationJobArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "audienceGenerationJobArn",
              "configuredAudienceModelArn",
              "createTime",
              "name",
              "status",
              "updateTime"
            ],
            members: {
              audienceGenerationJobArn: {},
              collaborationId: {},
              configuredAudienceModelArn: {},
              createTime: {
                shape: "S8"
              },
              description: {},
              includeSeedInOutput: {
                type: "boolean"
              },
              metrics: {
                type: "structure",
                required: [
                  "relevanceMetrics"
                ],
                members: {
                  relevanceMetrics: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "audienceSize"
                      ],
                      members: {
                        audienceSize: {
                          shape: "S1l"
                        },
                        score: {
                          type: "double"
                        }
                      }
                    }
                  }
                }
              },
              name: {},
              seedAudience: {
                shape: "S1n"
              },
              startedBy: {},
              status: {},
              statusDetails: {
                shape: "S1p"
              },
              tags: {
                shape: "S5"
              },
              updateTime: {
                shape: "S8"
              }
            }
          }
        },
        GetAudienceModel: {
          http: {
            method: "GET",
            requestUri: "/audience-model/{audienceModelArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "audienceModelArn"
            ],
            members: {
              audienceModelArn: {
                location: "uri",
                locationName: "audienceModelArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "audienceModelArn",
              "createTime",
              "name",
              "status",
              "trainingDatasetArn",
              "updateTime"
            ],
            members: {
              audienceModelArn: {},
              createTime: {
                shape: "S8"
              },
              description: {},
              kmsKeyArn: {},
              metrics: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "forTopKItemPredictions",
                    "type",
                    "value"
                  ],
                  members: {
                    forTopKItemPredictions: {
                      type: "integer"
                    },
                    type: {},
                    value: {
                      type: "double"
                    }
                  }
                }
              },
              name: {},
              status: {},
              statusDetails: {
                shape: "S1p"
              },
              tags: {
                shape: "S5"
              },
              trainingDataEndTime: {
                shape: "S8"
              },
              trainingDataStartTime: {
                shape: "S8"
              },
              trainingDatasetArn: {},
              updateTime: {
                shape: "S8"
              }
            }
          }
        },
        GetConfiguredAudienceModel: {
          http: {
            method: "GET",
            requestUri: "/configured-audience-model/{configuredAudienceModelArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "configuredAudienceModelArn"
            ],
            members: {
              configuredAudienceModelArn: {
                location: "uri",
                locationName: "configuredAudienceModelArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "audienceModelArn",
              "configuredAudienceModelArn",
              "createTime",
              "name",
              "outputConfig",
              "sharedAudienceMetrics",
              "status",
              "updateTime"
            ],
            members: {
              audienceModelArn: {},
              audienceSizeConfig: {
                shape: "Sd"
              },
              childResourceTagOnCreatePolicy: {},
              configuredAudienceModelArn: {},
              createTime: {
                shape: "S8"
              },
              description: {},
              minMatchingSeedSize: {
                type: "integer"
              },
              name: {},
              outputConfig: {
                shape: "Sj"
              },
              sharedAudienceMetrics: {
                shape: "So"
              },
              status: {},
              tags: {
                shape: "S5"
              },
              updateTime: {
                shape: "S8"
              }
            }
          }
        },
        GetConfiguredAudienceModelPolicy: {
          http: {
            method: "GET",
            requestUri: "/configured-audience-model/{configuredAudienceModelArn}/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "configuredAudienceModelArn"
            ],
            members: {
              configuredAudienceModelArn: {
                location: "uri",
                locationName: "configuredAudienceModelArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "configuredAudienceModelArn",
              "configuredAudienceModelPolicy",
              "policyHash"
            ],
            members: {
              configuredAudienceModelArn: {},
              configuredAudienceModelPolicy: {},
              policyHash: {}
            }
          }
        },
        GetTrainingDataset: {
          http: {
            method: "GET",
            requestUri: "/training-dataset/{trainingDatasetArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "trainingDatasetArn"
            ],
            members: {
              trainingDatasetArn: {
                location: "uri",
                locationName: "trainingDatasetArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "createTime",
              "name",
              "roleArn",
              "status",
              "trainingData",
              "trainingDatasetArn",
              "updateTime"
            ],
            members: {
              createTime: {
                shape: "S8"
              },
              description: {},
              name: {},
              roleArn: {},
              status: {},
              tags: {
                shape: "S5"
              },
              trainingData: {
                type: "list",
                member: {
                  shape: "Su"
                }
              },
              trainingDatasetArn: {},
              updateTime: {
                shape: "S8"
              }
            }
          }
        },
        ListAudienceExportJobs: {
          http: {
            method: "GET",
            requestUri: "/audience-export-job",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              audienceGenerationJobArn: {
                location: "querystring",
                locationName: "audienceGenerationJobArn"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "audienceExportJobs"
            ],
            members: {
              audienceExportJobs: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "audienceGenerationJobArn",
                    "audienceSize",
                    "createTime",
                    "name",
                    "status",
                    "updateTime"
                  ],
                  members: {
                    audienceGenerationJobArn: {},
                    audienceSize: {
                      shape: "S1l"
                    },
                    createTime: {
                      shape: "S8"
                    },
                    description: {},
                    name: {},
                    outputLocation: {},
                    status: {},
                    statusDetails: {
                      shape: "S1p"
                    },
                    updateTime: {
                      shape: "S8"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAudienceGenerationJobs: {
          http: {
            method: "GET",
            requestUri: "/audience-generation-job",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              collaborationId: {
                location: "querystring",
                locationName: "collaborationId"
              },
              configuredAudienceModelArn: {
                location: "querystring",
                locationName: "configuredAudienceModelArn"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "audienceGenerationJobs"
            ],
            members: {
              audienceGenerationJobs: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "audienceGenerationJobArn",
                    "configuredAudienceModelArn",
                    "createTime",
                    "name",
                    "status",
                    "updateTime"
                  ],
                  members: {
                    audienceGenerationJobArn: {},
                    collaborationId: {},
                    configuredAudienceModelArn: {},
                    createTime: {
                      shape: "S8"
                    },
                    description: {},
                    name: {},
                    startedBy: {},
                    status: {},
                    updateTime: {
                      shape: "S8"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAudienceModels: {
          http: {
            method: "GET",
            requestUri: "/audience-model",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "audienceModels"
            ],
            members: {
              audienceModels: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "audienceModelArn",
                    "createTime",
                    "name",
                    "status",
                    "trainingDatasetArn",
                    "updateTime"
                  ],
                  members: {
                    audienceModelArn: {},
                    createTime: {
                      shape: "S8"
                    },
                    description: {},
                    name: {},
                    status: {},
                    trainingDatasetArn: {},
                    updateTime: {
                      shape: "S8"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListConfiguredAudienceModels: {
          http: {
            method: "GET",
            requestUri: "/configured-audience-model",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "configuredAudienceModels"
            ],
            members: {
              configuredAudienceModels: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "audienceModelArn",
                    "configuredAudienceModelArn",
                    "createTime",
                    "name",
                    "outputConfig",
                    "status",
                    "updateTime"
                  ],
                  members: {
                    audienceModelArn: {},
                    configuredAudienceModelArn: {},
                    createTime: {
                      shape: "S8"
                    },
                    description: {},
                    name: {},
                    outputConfig: {
                      shape: "Sj"
                    },
                    status: {},
                    updateTime: {
                      shape: "S8"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "tags"
            ],
            members: {
              tags: {
                shape: "S5"
              }
            }
          }
        },
        ListTrainingDatasets: {
          http: {
            method: "GET",
            requestUri: "/training-dataset",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "trainingDatasets"
            ],
            members: {
              nextToken: {},
              trainingDatasets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "createTime",
                    "name",
                    "status",
                    "trainingDatasetArn",
                    "updateTime"
                  ],
                  members: {
                    createTime: {
                      shape: "S8"
                    },
                    description: {},
                    name: {},
                    status: {},
                    trainingDatasetArn: {},
                    updateTime: {
                      shape: "S8"
                    }
                  }
                }
              }
            }
          }
        },
        PutConfiguredAudienceModelPolicy: {
          http: {
            method: "PUT",
            requestUri: "/configured-audience-model/{configuredAudienceModelArn}/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "configuredAudienceModelArn",
              "configuredAudienceModelPolicy"
            ],
            members: {
              configuredAudienceModelArn: {
                location: "uri",
                locationName: "configuredAudienceModelArn"
              },
              configuredAudienceModelPolicy: {},
              policyExistenceCondition: {},
              previousPolicyHash: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "configuredAudienceModelPolicy",
              "policyHash"
            ],
            members: {
              configuredAudienceModelPolicy: {},
              policyHash: {}
            }
          },
          idempotent: true
        },
        StartAudienceExportJob: {
          http: {
            requestUri: "/audience-export-job",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "audienceGenerationJobArn",
              "audienceSize",
              "name"
            ],
            members: {
              audienceGenerationJobArn: {},
              audienceSize: {
                shape: "S1l"
              },
              description: {},
              name: {}
            }
          },
          idempotent: true
        },
        StartAudienceGenerationJob: {
          http: {
            requestUri: "/audience-generation-job",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "configuredAudienceModelArn",
              "name",
              "seedAudience"
            ],
            members: {
              collaborationId: {},
              configuredAudienceModelArn: {},
              description: {},
              includeSeedInOutput: {
                type: "boolean"
              },
              name: {},
              seedAudience: {
                shape: "S1n"
              },
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "audienceGenerationJobArn"
            ],
            members: {
              audienceGenerationJobArn: {}
            }
          },
          idempotent: true
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateConfiguredAudienceModel: {
          http: {
            method: "PATCH",
            requestUri: "/configured-audience-model/{configuredAudienceModelArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "configuredAudienceModelArn"
            ],
            members: {
              audienceModelArn: {},
              audienceSizeConfig: {
                shape: "Sd"
              },
              configuredAudienceModelArn: {
                location: "uri",
                locationName: "configuredAudienceModelArn"
              },
              description: {},
              minMatchingSeedSize: {
                type: "integer"
              },
              outputConfig: {
                shape: "Sj"
              },
              sharedAudienceMetrics: {
                shape: "So"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "configuredAudienceModelArn"
            ],
            members: {
              configuredAudienceModelArn: {}
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S5: {
          type: "map",
          key: {},
          value: {}
        },
        S8: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        Sd: {
          type: "structure",
          required: [
            "audienceSizeBins",
            "audienceSizeType"
          ],
          members: {
            audienceSizeBins: {
              type: "list",
              member: {
                type: "integer"
              }
            },
            audienceSizeType: {}
          }
        },
        Sj: {
          type: "structure",
          required: [
            "destination",
            "roleArn"
          ],
          members: {
            destination: {
              type: "structure",
              required: [
                "s3Destination"
              ],
              members: {
                s3Destination: {
                  shape: "Sl"
                }
              }
            },
            roleArn: {}
          }
        },
        Sl: {
          type: "structure",
          required: [
            "s3Uri"
          ],
          members: {
            s3Uri: {}
          }
        },
        So: {
          type: "list",
          member: {}
        },
        Su: {
          type: "structure",
          required: [
            "inputConfig",
            "type"
          ],
          members: {
            inputConfig: {
              type: "structure",
              required: [
                "dataSource",
                "schema"
              ],
              members: {
                dataSource: {
                  type: "structure",
                  required: [
                    "glueDataSource"
                  ],
                  members: {
                    glueDataSource: {
                      type: "structure",
                      required: [
                        "databaseName",
                        "tableName"
                      ],
                      members: {
                        catalogId: {},
                        databaseName: {},
                        tableName: {}
                      }
                    }
                  }
                },
                schema: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "columnName",
                      "columnTypes"
                    ],
                    members: {
                      columnName: {},
                      columnTypes: {
                        type: "list",
                        member: {}
                      }
                    }
                  }
                }
              }
            },
            type: {}
          }
        },
        S1l: {
          type: "structure",
          required: [
            "type",
            "value"
          ],
          members: {
            type: {},
            value: {
              type: "integer"
            }
          }
        },
        S1n: {
          type: "structure",
          required: [
            "dataSource",
            "roleArn"
          ],
          members: {
            dataSource: {
              shape: "Sl"
            },
            roleArn: {}
          }
        },
        S1p: {
          type: "structure",
          members: {
            message: {},
            statusCode: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cleanroomsml-2023-09-06.paginators.json
var require_cleanroomsml_2023_09_06_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cleanroomsml-2023-09-06.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListAudienceExportJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "audienceExportJobs"
        },
        ListAudienceGenerationJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "audienceGenerationJobs"
        },
        ListAudienceModels: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "audienceModels"
        },
        ListConfiguredAudienceModels: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "configuredAudienceModels"
        },
        ListTrainingDatasets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "trainingDatasets"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/cleanroomsml.js
var require_cleanroomsml = __commonJS({
  "node_modules/aws-sdk/clients/cleanroomsml.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["cleanroomsml"] = {};
    AWS2.CleanRoomsML = Service.defineService("cleanroomsml", ["2023-09-06"]);
    Object.defineProperty(apiLoader.services["cleanroomsml"], "2023-09-06", {
      get: function get() {
        var model = require_cleanroomsml_2023_09_06_min();
        model.paginators = require_cleanroomsml_2023_09_06_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.CleanRoomsML;
  }
});

// node_modules/aws-sdk/apis/marketplace-agreement-2020-03-01.min.json
var require_marketplace_agreement_2020_03_01_min = __commonJS({
  "node_modules/aws-sdk/apis/marketplace-agreement-2020-03-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-03-01",
        endpointPrefix: "agreement-marketplace",
        jsonVersion: "1.0",
        protocol: "json",
        serviceAbbreviation: "Agreement Service",
        serviceFullName: "AWS Marketplace Agreement Service",
        serviceId: "Marketplace Agreement",
        signatureVersion: "v4",
        signingName: "aws-marketplace",
        targetPrefix: "AWSMPCommerceService_v20200301",
        uid: "marketplace-agreement-2020-03-01"
      },
      operations: {
        DescribeAgreement: {
          input: {
            type: "structure",
            required: [
              "agreementId"
            ],
            members: {
              agreementId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              acceptanceTime: {
                type: "timestamp"
              },
              acceptor: {
                shape: "S5"
              },
              agreementId: {},
              agreementType: {},
              endTime: {
                type: "timestamp"
              },
              estimatedCharges: {
                type: "structure",
                members: {
                  agreementValue: {},
                  currencyCode: {}
                }
              },
              proposalSummary: {
                shape: "Sb"
              },
              proposer: {
                shape: "Sg"
              },
              startTime: {
                type: "timestamp"
              },
              status: {}
            }
          }
        },
        GetAgreementTerms: {
          input: {
            type: "structure",
            required: [
              "agreementId"
            ],
            members: {
              agreementId: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              acceptedTerms: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    byolPricingTerm: {
                      type: "structure",
                      members: {
                        type: {}
                      }
                    },
                    configurableUpfrontPricingTerm: {
                      type: "structure",
                      members: {
                        configuration: {
                          type: "structure",
                          required: [
                            "dimensions",
                            "selectorValue"
                          ],
                          members: {
                            dimensions: {
                              type: "list",
                              member: {
                                type: "structure",
                                required: [
                                  "dimensionKey",
                                  "dimensionValue"
                                ],
                                members: {
                                  dimensionKey: {},
                                  dimensionValue: {
                                    type: "integer"
                                  }
                                }
                              }
                            },
                            selectorValue: {}
                          }
                        },
                        currencyCode: {},
                        rateCards: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              constraints: {
                                type: "structure",
                                members: {
                                  multipleDimensionSelection: {},
                                  quantityConfiguration: {}
                                }
                              },
                              rateCard: {
                                shape: "Sy"
                              },
                              selector: {
                                type: "structure",
                                members: {
                                  type: {},
                                  value: {}
                                }
                              }
                            }
                          }
                        },
                        type: {}
                      }
                    },
                    fixedUpfrontPricingTerm: {
                      type: "structure",
                      members: {
                        currencyCode: {},
                        duration: {},
                        grants: {
                          shape: "S12"
                        },
                        price: {},
                        type: {}
                      }
                    },
                    freeTrialPricingTerm: {
                      type: "structure",
                      members: {
                        duration: {},
                        grants: {
                          shape: "S12"
                        },
                        type: {}
                      }
                    },
                    legalTerm: {
                      type: "structure",
                      members: {
                        documents: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              type: {},
                              url: {},
                              version: {}
                            }
                          }
                        },
                        type: {}
                      }
                    },
                    paymentScheduleTerm: {
                      type: "structure",
                      members: {
                        currencyCode: {},
                        schedule: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              chargeAmount: {},
                              chargeDate: {
                                type: "timestamp"
                              }
                            }
                          }
                        },
                        type: {}
                      }
                    },
                    recurringPaymentTerm: {
                      type: "structure",
                      members: {
                        billingPeriod: {},
                        currencyCode: {},
                        price: {},
                        type: {}
                      }
                    },
                    renewalTerm: {
                      type: "structure",
                      members: {
                        configuration: {
                          type: "structure",
                          required: [
                            "enableAutoRenew"
                          ],
                          members: {
                            enableAutoRenew: {
                              type: "boolean"
                            }
                          }
                        },
                        type: {}
                      }
                    },
                    supportTerm: {
                      type: "structure",
                      members: {
                        refundPolicy: {},
                        type: {}
                      }
                    },
                    usageBasedPricingTerm: {
                      type: "structure",
                      members: {
                        currencyCode: {},
                        rateCards: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              rateCard: {
                                shape: "Sy"
                              }
                            }
                          }
                        },
                        type: {}
                      }
                    },
                    validityTerm: {
                      type: "structure",
                      members: {
                        agreementDuration: {},
                        agreementEndDate: {
                          type: "timestamp"
                        },
                        agreementStartDate: {
                          type: "timestamp"
                        },
                        type: {}
                      }
                    }
                  },
                  union: true
                }
              },
              nextToken: {}
            }
          }
        },
        SearchAgreements: {
          input: {
            type: "structure",
            members: {
              catalog: {},
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              sort: {
                type: "structure",
                members: {
                  sortBy: {},
                  sortOrder: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              agreementViewSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    acceptanceTime: {
                      type: "timestamp"
                    },
                    acceptor: {
                      shape: "S5"
                    },
                    agreementId: {},
                    agreementType: {},
                    endTime: {
                      type: "timestamp"
                    },
                    proposalSummary: {
                      shape: "Sb"
                    },
                    proposer: {
                      shape: "Sg"
                    },
                    startTime: {
                      type: "timestamp"
                    },
                    status: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          members: {
            accountId: {}
          }
        },
        Sb: {
          type: "structure",
          members: {
            offerId: {},
            resources: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  id: {},
                  type: {}
                }
              }
            }
          }
        },
        Sg: {
          type: "structure",
          members: {
            accountId: {}
          }
        },
        Sy: {
          type: "list",
          member: {
            type: "structure",
            members: {
              dimensionKey: {},
              price: {}
            }
          }
        },
        S12: {
          type: "list",
          member: {
            type: "structure",
            members: {
              dimensionKey: {},
              maxQuantity: {
                type: "integer"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/marketplace-agreement-2020-03-01.paginators.json
var require_marketplace_agreement_2020_03_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/marketplace-agreement-2020-03-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        GetAgreementTerms: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        SearchAgreements: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/marketplaceagreement.js
var require_marketplaceagreement = __commonJS({
  "node_modules/aws-sdk/clients/marketplaceagreement.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["marketplaceagreement"] = {};
    AWS2.MarketplaceAgreement = Service.defineService("marketplaceagreement", ["2020-03-01"]);
    Object.defineProperty(apiLoader.services["marketplaceagreement"], "2020-03-01", {
      get: function get() {
        var model = require_marketplace_agreement_2020_03_01_min();
        model.paginators = require_marketplace_agreement_2020_03_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.MarketplaceAgreement;
  }
});

// node_modules/aws-sdk/apis/marketplace-deployment-2023-01-25.min.json
var require_marketplace_deployment_2023_01_25_min = __commonJS({
  "node_modules/aws-sdk/apis/marketplace-deployment-2023-01-25.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2023-01-25",
        endpointPrefix: "deployment-marketplace",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Marketplace Deployment Service",
        serviceId: "Marketplace Deployment",
        signatureVersion: "v4",
        signingName: "aws-marketplace",
        uid: "marketplace-deployment-2023-01-25"
      },
      operations: {
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S4"
              }
            }
          }
        },
        PutDeploymentParameter: {
          http: {
            requestUri: "/catalogs/{catalog}/products/{productId}/deployment-parameters",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "agreementId",
              "catalog",
              "deploymentParameter",
              "productId"
            ],
            members: {
              agreementId: {},
              catalog: {
                location: "uri",
                locationName: "catalog"
              },
              clientToken: {
                idempotencyToken: true
              },
              deploymentParameter: {
                type: "structure",
                required: [
                  "name",
                  "secretString"
                ],
                members: {
                  name: {},
                  secretString: {
                    type: "string",
                    sensitive: true
                  }
                }
              },
              expirationDate: {
                type: "timestamp",
                timestampFormat: "iso8601"
              },
              productId: {
                location: "uri",
                locationName: "productId"
              },
              tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "agreementId",
              "deploymentParameterId",
              "resourceArn"
            ],
            members: {
              agreementId: {},
              deploymentParameterId: {},
              resourceArn: {},
              tags: {
                shape: "Sd"
              }
            }
          },
          idempotent: true
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        }
      },
      shapes: {
        S4: {
          type: "map",
          key: {},
          value: {}
        },
        Sd: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/marketplace-deployment-2023-01-25.paginators.json
var require_marketplace_deployment_2023_01_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/marketplace-deployment-2023-01-25.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/marketplacedeployment.js
var require_marketplacedeployment = __commonJS({
  "node_modules/aws-sdk/clients/marketplacedeployment.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["marketplacedeployment"] = {};
    AWS2.MarketplaceDeployment = Service.defineService("marketplacedeployment", ["2023-01-25"]);
    Object.defineProperty(apiLoader.services["marketplacedeployment"], "2023-01-25", {
      get: function get() {
        var model = require_marketplace_deployment_2023_01_25_min();
        model.paginators = require_marketplace_deployment_2023_01_25_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.MarketplaceDeployment;
  }
});

// node_modules/aws-sdk/lib/services/neptunegraph.js
var require_neptunegraph = __commonJS({
  "node_modules/aws-sdk/lib/services/neptunegraph.js"() {
    "use strict";
    var AWS2 = require_core();
    if (AWS2.NeptuneGraph) {
      AWS2.util.update(AWS2.NeptuneGraph.prototype, {
        /**
         * @api private
         */
        validateService: function validateService() {
          var msg = "AWS Neptune Graph is not available in the AWS SDK for JavaScript v2, consider using the AWS SDK for JavaScript v3: https://www.npmjs.com/package/@aws-sdk/client-neptune-graph";
          throw AWS2.util.error(
            new Error(),
            { name: "ServiceExcludedFromV2", message: msg }
          );
        }
      });
    }
  }
});

// node_modules/aws-sdk/apis/neptune-graph-2023-11-29.min.json
var require_neptune_graph_2023_11_29_min = __commonJS({
  "node_modules/aws-sdk/apis/neptune-graph-2023-11-29.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2023-11-29",
        endpointPrefix: "neptune-graph",
        jsonVersion: "1.1",
        protocol: "rest-json",
        ripServiceName: "neptune-graph",
        serviceAbbreviation: "Neptune Graph",
        serviceFullName: "Amazon Neptune Graph",
        serviceId: "Neptune Graph",
        signatureVersion: "v4",
        signingName: "neptune-graph",
        uid: "neptune-graph-2023-11-29"
      },
      operations: {
        CancelImportTask: {
          http: {
            method: "DELETE",
            requestUri: "/importtasks/{taskIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "taskIdentifier"
            ],
            members: {
              taskIdentifier: {
                location: "uri",
                locationName: "taskIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "taskId",
              "source",
              "roleArn",
              "status"
            ],
            members: {
              graphId: {},
              taskId: {},
              source: {},
              format: {},
              roleArn: {},
              status: {}
            }
          },
          staticContextParams: {
            ApiType: {
              value: "ControlPlane"
            }
          }
        },
        CreateGraph: {
          http: {
            requestUri: "/graphs",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "graphName",
              "provisionedMemory"
            ],
            members: {
              graphName: {},
              tags: {
                shape: "Sb"
              },
              publicConnectivity: {
                type: "boolean"
              },
              kmsKeyIdentifier: {},
              vectorSearchConfiguration: {
                shape: "Sg"
              },
              replicaCount: {
                type: "integer"
              },
              deletionProtection: {
                type: "boolean"
              },
              provisionedMemory: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "name",
              "arn"
            ],
            members: {
              id: {},
              name: {},
              arn: {},
              status: {},
              statusReason: {},
              createTime: {
                type: "timestamp"
              },
              provisionedMemory: {
                type: "integer"
              },
              endpoint: {},
              publicConnectivity: {
                type: "boolean"
              },
              vectorSearchConfiguration: {
                shape: "Sg"
              },
              replicaCount: {
                type: "integer"
              },
              kmsKeyIdentifier: {},
              sourceSnapshotId: {},
              deletionProtection: {
                type: "boolean"
              },
              buildNumber: {}
            }
          },
          staticContextParams: {
            ApiType: {
              value: "ControlPlane"
            }
          }
        },
        CreateGraphSnapshot: {
          http: {
            requestUri: "/snapshots",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "graphIdentifier",
              "snapshotName"
            ],
            members: {
              graphIdentifier: {},
              snapshotName: {},
              tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "name",
              "arn"
            ],
            members: {
              id: {},
              name: {},
              arn: {},
              sourceGraphId: {},
              snapshotCreateTime: {
                type: "timestamp"
              },
              status: {},
              kmsKeyIdentifier: {}
            }
          },
          staticContextParams: {
            ApiType: {
              value: "ControlPlane"
            }
          }
        },
        CreateGraphUsingImportTask: {
          http: {
            requestUri: "/importtasks",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "graphName",
              "source",
              "roleArn"
            ],
            members: {
              graphName: {},
              tags: {
                shape: "Sb"
              },
              publicConnectivity: {
                type: "boolean"
              },
              kmsKeyIdentifier: {},
              vectorSearchConfiguration: {
                shape: "Sg"
              },
              replicaCount: {
                type: "integer"
              },
              deletionProtection: {
                type: "boolean"
              },
              importOptions: {
                shape: "Su"
              },
              maxProvisionedMemory: {
                type: "integer"
              },
              minProvisionedMemory: {
                type: "integer"
              },
              failOnError: {
                type: "boolean"
              },
              source: {},
              format: {},
              roleArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "taskId",
              "source",
              "roleArn",
              "status"
            ],
            members: {
              graphId: {},
              taskId: {},
              source: {},
              format: {},
              roleArn: {},
              status: {},
              importOptions: {
                shape: "Su"
              }
            }
          },
          staticContextParams: {
            ApiType: {
              value: "ControlPlane"
            }
          }
        },
        CreatePrivateGraphEndpoint: {
          http: {
            requestUri: "/graphs/{graphIdentifier}/endpoints/",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "graphIdentifier"
            ],
            members: {
              graphIdentifier: {
                location: "uri",
                locationName: "graphIdentifier"
              },
              vpcId: {},
              subnetIds: {
                shape: "S11"
              },
              vpcSecurityGroupIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "vpcId",
              "subnetIds",
              "status"
            ],
            members: {
              vpcId: {},
              subnetIds: {
                shape: "S11"
              },
              status: {},
              vpcEndpointId: {}
            }
          },
          staticContextParams: {
            ApiType: {
              value: "ControlPlane"
            }
          }
        },
        DeleteGraph: {
          http: {
            method: "DELETE",
            requestUri: "/graphs/{graphIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "graphIdentifier",
              "skipSnapshot"
            ],
            members: {
              graphIdentifier: {
                location: "uri",
                locationName: "graphIdentifier"
              },
              skipSnapshot: {
                location: "querystring",
                locationName: "skipSnapshot",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "name",
              "arn"
            ],
            members: {
              id: {},
              name: {},
              arn: {},
              status: {},
              statusReason: {},
              createTime: {
                type: "timestamp"
              },
              provisionedMemory: {
                type: "integer"
              },
              endpoint: {},
              publicConnectivity: {
                type: "boolean"
              },
              vectorSearchConfiguration: {
                shape: "Sg"
              },
              replicaCount: {
                type: "integer"
              },
              kmsKeyIdentifier: {},
              sourceSnapshotId: {},
              deletionProtection: {
                type: "boolean"
              },
              buildNumber: {}
            }
          },
          staticContextParams: {
            ApiType: {
              value: "ControlPlane"
            }
          }
        },
        DeleteGraphSnapshot: {
          http: {
            method: "DELETE",
            requestUri: "/snapshots/{snapshotIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "snapshotIdentifier"
            ],
            members: {
              snapshotIdentifier: {
                location: "uri",
                locationName: "snapshotIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "name",
              "arn"
            ],
            members: {
              id: {},
              name: {},
              arn: {},
              sourceGraphId: {},
              snapshotCreateTime: {
                type: "timestamp"
              },
              status: {},
              kmsKeyIdentifier: {}
            }
          },
          staticContextParams: {
            ApiType: {
              value: "ControlPlane"
            }
          }
        },
        DeletePrivateGraphEndpoint: {
          http: {
            method: "DELETE",
            requestUri: "/graphs/{graphIdentifier}/endpoints/{vpcId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "graphIdentifier",
              "vpcId"
            ],
            members: {
              graphIdentifier: {
                location: "uri",
                locationName: "graphIdentifier"
              },
              vpcId: {
                location: "uri",
                locationName: "vpcId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "vpcId",
              "subnetIds",
              "status"
            ],
            members: {
              vpcId: {},
              subnetIds: {
                shape: "S11"
              },
              status: {},
              vpcEndpointId: {}
            }
          },
          staticContextParams: {
            ApiType: {
              value: "ControlPlane"
            }
          }
        },
        GetGraph: {
          http: {
            method: "GET",
            requestUri: "/graphs/{graphIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "graphIdentifier"
            ],
            members: {
              graphIdentifier: {
                location: "uri",
                locationName: "graphIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "name",
              "arn"
            ],
            members: {
              id: {},
              name: {},
              arn: {},
              status: {},
              statusReason: {},
              createTime: {
                type: "timestamp"
              },
              provisionedMemory: {
                type: "integer"
              },
              endpoint: {},
              publicConnectivity: {
                type: "boolean"
              },
              vectorSearchConfiguration: {
                shape: "Sg"
              },
              replicaCount: {
                type: "integer"
              },
              kmsKeyIdentifier: {},
              sourceSnapshotId: {},
              deletionProtection: {
                type: "boolean"
              },
              buildNumber: {}
            }
          },
          staticContextParams: {
            ApiType: {
              value: "ControlPlane"
            }
          }
        },
        GetGraphSnapshot: {
          http: {
            method: "GET",
            requestUri: "/snapshots/{snapshotIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "snapshotIdentifier"
            ],
            members: {
              snapshotIdentifier: {
                location: "uri",
                locationName: "snapshotIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "name",
              "arn"
            ],
            members: {
              id: {},
              name: {},
              arn: {},
              sourceGraphId: {},
              snapshotCreateTime: {
                type: "timestamp"
              },
              status: {},
              kmsKeyIdentifier: {}
            }
          },
          staticContextParams: {
            ApiType: {
              value: "ControlPlane"
            }
          }
        },
        GetImportTask: {
          http: {
            method: "GET",
            requestUri: "/importtasks/{taskIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "taskIdentifier"
            ],
            members: {
              taskIdentifier: {
                location: "uri",
                locationName: "taskIdentifier"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "taskId",
              "source",
              "roleArn",
              "status"
            ],
            members: {
              graphId: {},
              taskId: {},
              source: {},
              format: {},
              roleArn: {},
              status: {},
              importOptions: {
                shape: "Su"
              },
              importTaskDetails: {
                type: "structure",
                required: [
                  "status",
                  "startTime",
                  "timeElapsedSeconds",
                  "progressPercentage",
                  "errorCount",
                  "statementCount",
                  "dictionaryEntryCount"
                ],
                members: {
                  status: {},
                  startTime: {
                    type: "timestamp"
                  },
                  timeElapsedSeconds: {
                    type: "long"
                  },
                  progressPercentage: {
                    type: "integer"
                  },
                  errorCount: {
                    type: "integer"
                  },
                  errorDetails: {},
                  statementCount: {
                    type: "long"
                  },
                  dictionaryEntryCount: {
                    type: "long"
                  }
                }
              },
              attemptNumber: {
                type: "integer"
              },
              statusReason: {}
            }
          },
          staticContextParams: {
            ApiType: {
              value: "ControlPlane"
            }
          }
        },
        GetPrivateGraphEndpoint: {
          http: {
            method: "GET",
            requestUri: "/graphs/{graphIdentifier}/endpoints/{vpcId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "graphIdentifier",
              "vpcId"
            ],
            members: {
              graphIdentifier: {
                location: "uri",
                locationName: "graphIdentifier"
              },
              vpcId: {
                location: "uri",
                locationName: "vpcId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "vpcId",
              "subnetIds",
              "status"
            ],
            members: {
              vpcId: {},
              subnetIds: {
                shape: "S11"
              },
              status: {},
              vpcEndpointId: {}
            }
          },
          staticContextParams: {
            ApiType: {
              value: "ControlPlane"
            }
          }
        },
        ListGraphSnapshots: {
          http: {
            method: "GET",
            requestUri: "/snapshots",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              graphIdentifier: {
                location: "querystring",
                locationName: "graphIdentifier"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "graphSnapshots"
            ],
            members: {
              graphSnapshots: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "name",
                    "arn"
                  ],
                  members: {
                    id: {},
                    name: {},
                    arn: {},
                    sourceGraphId: {},
                    snapshotCreateTime: {
                      type: "timestamp"
                    },
                    status: {},
                    kmsKeyIdentifier: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          staticContextParams: {
            ApiType: {
              value: "ControlPlane"
            }
          }
        },
        ListGraphs: {
          http: {
            method: "GET",
            requestUri: "/graphs",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "graphs"
            ],
            members: {
              graphs: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "name",
                    "arn"
                  ],
                  members: {
                    id: {},
                    name: {},
                    arn: {},
                    status: {},
                    provisionedMemory: {
                      type: "integer"
                    },
                    publicConnectivity: {
                      type: "boolean"
                    },
                    endpoint: {},
                    replicaCount: {
                      type: "integer"
                    },
                    kmsKeyIdentifier: {},
                    deletionProtection: {
                      type: "boolean"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          staticContextParams: {
            ApiType: {
              value: "ControlPlane"
            }
          }
        },
        ListImportTasks: {
          http: {
            method: "GET",
            requestUri: "/importtasks",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "tasks"
            ],
            members: {
              tasks: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "taskId",
                    "source",
                    "roleArn",
                    "status"
                  ],
                  members: {
                    graphId: {},
                    taskId: {},
                    source: {},
                    format: {},
                    roleArn: {},
                    status: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          staticContextParams: {
            ApiType: {
              value: "ControlPlane"
            }
          }
        },
        ListPrivateGraphEndpoints: {
          http: {
            method: "GET",
            requestUri: "/graphs/{graphIdentifier}/endpoints/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "graphIdentifier"
            ],
            members: {
              graphIdentifier: {
                location: "uri",
                locationName: "graphIdentifier"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "privateGraphEndpoints"
            ],
            members: {
              privateGraphEndpoints: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "vpcId",
                    "subnetIds",
                    "status"
                  ],
                  members: {
                    vpcId: {},
                    subnetIds: {
                      shape: "S11"
                    },
                    status: {},
                    vpcEndpointId: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          staticContextParams: {
            ApiType: {
              value: "ControlPlane"
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sb"
              }
            }
          },
          staticContextParams: {
            ApiType: {
              value: "ControlPlane"
            }
          }
        },
        ResetGraph: {
          http: {
            method: "PUT",
            requestUri: "/graphs/{graphIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "graphIdentifier",
              "skipSnapshot"
            ],
            members: {
              graphIdentifier: {
                location: "uri",
                locationName: "graphIdentifier"
              },
              skipSnapshot: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "name",
              "arn"
            ],
            members: {
              id: {},
              name: {},
              arn: {},
              status: {},
              statusReason: {},
              createTime: {
                type: "timestamp"
              },
              provisionedMemory: {
                type: "integer"
              },
              endpoint: {},
              publicConnectivity: {
                type: "boolean"
              },
              vectorSearchConfiguration: {
                shape: "Sg"
              },
              replicaCount: {
                type: "integer"
              },
              kmsKeyIdentifier: {},
              sourceSnapshotId: {},
              deletionProtection: {
                type: "boolean"
              },
              buildNumber: {}
            }
          },
          staticContextParams: {
            ApiType: {
              value: "ControlPlane"
            }
          }
        },
        RestoreGraphFromSnapshot: {
          http: {
            requestUri: "/snapshots/{snapshotIdentifier}/restore",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "snapshotIdentifier",
              "graphName"
            ],
            members: {
              snapshotIdentifier: {
                location: "uri",
                locationName: "snapshotIdentifier"
              },
              graphName: {},
              provisionedMemory: {
                type: "integer"
              },
              deletionProtection: {
                type: "boolean"
              },
              tags: {
                shape: "Sb"
              },
              replicaCount: {
                type: "integer"
              },
              publicConnectivity: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "name",
              "arn"
            ],
            members: {
              id: {},
              name: {},
              arn: {},
              status: {},
              statusReason: {},
              createTime: {
                type: "timestamp"
              },
              provisionedMemory: {
                type: "integer"
              },
              endpoint: {},
              publicConnectivity: {
                type: "boolean"
              },
              vectorSearchConfiguration: {
                shape: "Sg"
              },
              replicaCount: {
                type: "integer"
              },
              kmsKeyIdentifier: {},
              sourceSnapshotId: {},
              deletionProtection: {
                type: "boolean"
              },
              buildNumber: {}
            }
          },
          staticContextParams: {
            ApiType: {
              value: "ControlPlane"
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true,
          staticContextParams: {
            ApiType: {
              value: "ControlPlane"
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true,
          staticContextParams: {
            ApiType: {
              value: "ControlPlane"
            }
          }
        },
        UpdateGraph: {
          http: {
            method: "PATCH",
            requestUri: "/graphs/{graphIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "graphIdentifier"
            ],
            members: {
              graphIdentifier: {
                location: "uri",
                locationName: "graphIdentifier"
              },
              publicConnectivity: {
                type: "boolean"
              },
              provisionedMemory: {
                type: "integer"
              },
              deletionProtection: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "name",
              "arn"
            ],
            members: {
              id: {},
              name: {},
              arn: {},
              status: {},
              statusReason: {},
              createTime: {
                type: "timestamp"
              },
              provisionedMemory: {
                type: "integer"
              },
              endpoint: {},
              publicConnectivity: {
                type: "boolean"
              },
              vectorSearchConfiguration: {
                shape: "Sg"
              },
              replicaCount: {
                type: "integer"
              },
              kmsKeyIdentifier: {},
              sourceSnapshotId: {},
              deletionProtection: {
                type: "boolean"
              },
              buildNumber: {}
            }
          },
          staticContextParams: {
            ApiType: {
              value: "ControlPlane"
            }
          }
        }
      },
      shapes: {
        Sb: {
          type: "map",
          key: {},
          value: {}
        },
        Sg: {
          type: "structure",
          required: [
            "dimension"
          ],
          members: {
            dimension: {
              type: "integer"
            }
          }
        },
        Su: {
          type: "structure",
          members: {
            neptune: {
              type: "structure",
              required: [
                "s3ExportPath",
                "s3ExportKmsKeyId"
              ],
              members: {
                s3ExportPath: {},
                s3ExportKmsKeyId: {},
                preserveDefaultVertexLabels: {
                  type: "boolean"
                },
                preserveEdgeIds: {
                  type: "boolean"
                }
              }
            }
          },
          union: true
        },
        S11: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/neptune-graph-2023-11-29.paginators.json
var require_neptune_graph_2023_11_29_paginators = __commonJS({
  "node_modules/aws-sdk/apis/neptune-graph-2023-11-29.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListGraphSnapshots: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "graphSnapshots"
        },
        ListGraphs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "graphs"
        },
        ListImportTasks: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "tasks"
        },
        ListPrivateGraphEndpoints: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "privateGraphEndpoints"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/neptune-graph-2023-11-29.waiters2.json
var require_neptune_graph_2023_11_29_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/neptune-graph-2023-11-29.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        GraphAvailable: {
          description: "Wait until Graph is Available",
          delay: 60,
          maxAttempts: 480,
          operation: "GetGraph",
          acceptors: [{
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "DELETING"
          }, {
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "FAILED"
          }, {
            matcher: "path",
            argument: "status",
            state: "success",
            expected: "AVAILABLE"
          }]
        },
        GraphDeleted: {
          description: "Wait until Graph is Deleted",
          delay: 60,
          maxAttempts: 60,
          operation: "GetGraph",
          acceptors: [{
            matcher: "path",
            argument: "status != 'DELETING'",
            state: "failure",
            expected: true
          }, {
            matcher: "error",
            state: "success",
            expected: "ResourceNotFoundException"
          }]
        },
        GraphSnapshotAvailable: {
          description: "Wait until GraphSnapshot is Available",
          delay: 60,
          maxAttempts: 120,
          operation: "GetGraphSnapshot",
          acceptors: [{
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "DELETING"
          }, {
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "FAILED"
          }, {
            matcher: "path",
            argument: "status",
            state: "success",
            expected: "AVAILABLE"
          }]
        },
        GraphSnapshotDeleted: {
          description: "Wait until GraphSnapshot is Deleted",
          delay: 60,
          maxAttempts: 60,
          operation: "GetGraphSnapshot",
          acceptors: [{
            matcher: "path",
            argument: "status != 'DELETING'",
            state: "failure",
            expected: true
          }, {
            matcher: "error",
            state: "success",
            expected: "ResourceNotFoundException"
          }]
        },
        ImportTaskCancelled: {
          description: "Wait until Import Task is Cancelled",
          delay: 60,
          maxAttempts: 60,
          operation: "GetImportTask",
          acceptors: [{
            matcher: "path",
            argument: "status != 'CANCELLING'",
            state: "failure",
            expected: true
          }, {
            matcher: "path",
            argument: "status",
            state: "success",
            expected: "CANCELLED"
          }]
        },
        ImportTaskSuccessful: {
          description: "Wait until Import Task is Successful",
          delay: 60,
          maxAttempts: 480,
          operation: "GetImportTask",
          acceptors: [{
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "CANCELLING"
          }, {
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "CANCELLED"
          }, {
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "ROLLING_BACK"
          }, {
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "FAILED"
          }, {
            matcher: "path",
            argument: "status",
            state: "success",
            expected: "SUCCEEDED"
          }]
        },
        PrivateGraphEndpointAvailable: {
          description: "Wait until PrivateGraphEndpoint is Available",
          delay: 10,
          maxAttempts: 180,
          operation: "GetPrivateGraphEndpoint",
          acceptors: [{
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "DELETING"
          }, {
            matcher: "path",
            argument: "status",
            state: "failure",
            expected: "FAILED"
          }, {
            matcher: "path",
            argument: "status",
            state: "success",
            expected: "AVAILABLE"
          }]
        },
        PrivateGraphEndpointDeleted: {
          description: "Wait until PrivateGraphEndpoint is Deleted",
          delay: 10,
          maxAttempts: 180,
          operation: "GetPrivateGraphEndpoint",
          acceptors: [{
            matcher: "path",
            argument: "status != 'DELETING'",
            state: "failure",
            expected: true
          }, {
            matcher: "error",
            state: "success",
            expected: "ResourceNotFoundException"
          }]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/neptunegraph.js
var require_neptunegraph2 = __commonJS({
  "node_modules/aws-sdk/clients/neptunegraph.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["neptunegraph"] = {};
    AWS2.NeptuneGraph = Service.defineService("neptunegraph", ["2023-11-29"]);
    require_neptunegraph();
    Object.defineProperty(apiLoader.services["neptunegraph"], "2023-11-29", {
      get: function get() {
        var model = require_neptune_graph_2023_11_29_min();
        model.paginators = require_neptune_graph_2023_11_29_paginators().pagination;
        model.waiters = require_neptune_graph_2023_11_29_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.NeptuneGraph;
  }
});

// node_modules/aws-sdk/apis/networkmonitor-2023-08-01.min.json
var require_networkmonitor_2023_08_01_min = __commonJS({
  "node_modules/aws-sdk/apis/networkmonitor-2023-08-01.min.json"(exports2, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2023-08-01",
        endpointPrefix: "networkmonitor",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon CloudWatch Network Monitor",
        serviceId: "NetworkMonitor",
        signatureVersion: "v4",
        signingName: "networkmonitor",
        uid: "networkmonitor-2023-08-01"
      },
      operations: {
        CreateMonitor: {
          http: {
            requestUri: "/monitors",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "monitorName"
            ],
            members: {
              monitorName: {},
              probes: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "sourceArn",
                    "destination",
                    "protocol"
                  ],
                  members: {
                    sourceArn: {},
                    destination: {},
                    destinationPort: {
                      type: "integer"
                    },
                    protocol: {},
                    packetSize: {
                      type: "integer"
                    },
                    probeTags: {
                      shape: "Sa"
                    }
                  }
                }
              },
              aggregationPeriod: {
                type: "long"
              },
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "monitorArn",
              "monitorName",
              "state"
            ],
            members: {
              monitorArn: {},
              monitorName: {},
              state: {},
              aggregationPeriod: {
                type: "long"
              },
              tags: {
                shape: "Sa"
              }
            }
          },
          idempotent: true
        },
        CreateProbe: {
          http: {
            requestUri: "/monitors/{monitorName}/probes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "monitorName",
              "probe"
            ],
            members: {
              monitorName: {
                location: "uri",
                locationName: "monitorName"
              },
              probe: {
                type: "structure",
                required: [
                  "sourceArn",
                  "destination",
                  "protocol"
                ],
                members: {
                  sourceArn: {},
                  destination: {},
                  destinationPort: {
                    type: "integer"
                  },
                  protocol: {},
                  packetSize: {
                    type: "integer"
                  },
                  tags: {
                    shape: "Sa"
                  }
                }
              },
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "sourceArn",
              "destination",
              "protocol"
            ],
            members: {
              probeId: {},
              probeArn: {},
              sourceArn: {},
              destination: {},
              destinationPort: {
                type: "integer"
              },
              protocol: {},
              packetSize: {
                type: "integer"
              },
              addressFamily: {},
              vpcId: {},
              state: {},
              createdAt: {
                type: "timestamp"
              },
              modifiedAt: {
                type: "timestamp"
              },
              tags: {
                shape: "Sa"
              }
            }
          },
          idempotent: true
        },
        DeleteMonitor: {
          http: {
            method: "DELETE",
            requestUri: "/monitors/{monitorName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "monitorName"
            ],
            members: {
              monitorName: {
                location: "uri",
                locationName: "monitorName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteProbe: {
          http: {
            method: "DELETE",
            requestUri: "/monitors/{monitorName}/probes/{probeId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "monitorName",
              "probeId"
            ],
            members: {
              monitorName: {
                location: "uri",
                locationName: "monitorName"
              },
              probeId: {
                location: "uri",
                locationName: "probeId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        GetMonitor: {
          http: {
            method: "GET",
            requestUri: "/monitors/{monitorName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "monitorName"
            ],
            members: {
              monitorName: {
                location: "uri",
                locationName: "monitorName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "monitorArn",
              "monitorName",
              "state",
              "aggregationPeriod",
              "createdAt",
              "modifiedAt"
            ],
            members: {
              monitorArn: {},
              monitorName: {},
              state: {},
              aggregationPeriod: {
                type: "long"
              },
              tags: {
                shape: "Sa"
              },
              probes: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "sourceArn",
                    "destination",
                    "protocol"
                  ],
                  members: {
                    probeId: {},
                    probeArn: {},
                    sourceArn: {},
                    destination: {},
                    destinationPort: {
                      type: "integer"
                    },
                    protocol: {},
                    packetSize: {
                      type: "integer"
                    },
                    addressFamily: {},
                    vpcId: {},
                    state: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    modifiedAt: {
                      type: "timestamp"
                    },
                    tags: {
                      shape: "Sa"
                    }
                  }
                }
              },
              createdAt: {
                type: "timestamp"
              },
              modifiedAt: {
                type: "timestamp"
              }
            }
          }
        },
        GetProbe: {
          http: {
            method: "GET",
            requestUri: "/monitors/{monitorName}/probes/{probeId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "monitorName",
              "probeId"
            ],
            members: {
              monitorName: {
                location: "uri",
                locationName: "monitorName"
              },
              probeId: {
                location: "uri",
                locationName: "probeId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "sourceArn",
              "destination",
              "protocol"
            ],
            members: {
              probeId: {},
              probeArn: {},
              sourceArn: {},
              destination: {},
              destinationPort: {
                type: "integer"
              },
              protocol: {},
              packetSize: {
                type: "integer"
              },
              addressFamily: {},
              vpcId: {},
              state: {},
              createdAt: {
                type: "timestamp"
              },
              modifiedAt: {
                type: "timestamp"
              },
              tags: {
                shape: "Sa"
              }
            }
          }
        },
        ListMonitors: {
          http: {
            method: "GET",
            requestUri: "/monitors",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              state: {
                location: "querystring",
                locationName: "state"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "monitors"
            ],
            members: {
              monitors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "monitorArn",
                    "monitorName",
                    "state"
                  ],
                  members: {
                    monitorArn: {},
                    monitorName: {},
                    state: {},
                    aggregationPeriod: {
                      type: "long"
                    },
                    tags: {
                      shape: "Sa"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sa"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateMonitor: {
          http: {
            method: "PATCH",
            requestUri: "/monitors/{monitorName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "monitorName",
              "aggregationPeriod"
            ],
            members: {
              monitorName: {
                location: "uri",
                locationName: "monitorName"
              },
              aggregationPeriod: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "monitorArn",
              "monitorName",
              "state"
            ],
            members: {
              monitorArn: {},
              monitorName: {},
              state: {},
              aggregationPeriod: {
                type: "long"
              },
              tags: {
                shape: "Sa"
              }
            }
          },
          idempotent: true
        },
        UpdateProbe: {
          http: {
            method: "PATCH",
            requestUri: "/monitors/{monitorName}/probes/{probeId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "monitorName",
              "probeId"
            ],
            members: {
              monitorName: {
                location: "uri",
                locationName: "monitorName"
              },
              probeId: {
                location: "uri",
                locationName: "probeId"
              },
              state: {},
              destination: {},
              destinationPort: {
                type: "integer"
              },
              protocol: {},
              packetSize: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "sourceArn",
              "destination",
              "protocol"
            ],
            members: {
              probeId: {},
              probeArn: {},
              sourceArn: {},
              destination: {},
              destinationPort: {
                type: "integer"
              },
              protocol: {},
              packetSize: {
                type: "integer"
              },
              addressFamily: {},
              vpcId: {},
              state: {},
              createdAt: {
                type: "timestamp"
              },
              modifiedAt: {
                type: "timestamp"
              },
              tags: {
                shape: "Sa"
              }
            }
          },
          idempotent: true
        }
      },
      shapes: {
        Sa: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/networkmonitor-2023-08-01.paginators.json
var require_networkmonitor_2023_08_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/networkmonitor-2023-08-01.paginators.json"(exports2, module2) {
    module2.exports = {
      pagination: {
        ListMonitors: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "monitors"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/networkmonitor-2023-08-01.waiters2.json
var require_networkmonitor_2023_08_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/networkmonitor-2023-08-01.waiters2.json"(exports2, module2) {
    module2.exports = {
      version: 2,
      waiters: {}
    };
  }
});

// node_modules/aws-sdk/clients/networkmonitor.js
var require_networkmonitor = __commonJS({
  "node_modules/aws-sdk/clients/networkmonitor.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    var Service = AWS2.Service;
    var apiLoader = AWS2.apiLoader;
    apiLoader.services["networkmonitor"] = {};
    AWS2.NetworkMonitor = Service.defineService("networkmonitor", ["2023-08-01"]);
    Object.defineProperty(apiLoader.services["networkmonitor"], "2023-08-01", {
      get: function get() {
        var model = require_networkmonitor_2023_08_01_min();
        model.paginators = require_networkmonitor_2023_08_01_paginators().pagination;
        model.waiters = require_networkmonitor_2023_08_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS2.NetworkMonitor;
  }
});

// node_modules/aws-sdk/clients/all.js
var require_all = __commonJS({
  "node_modules/aws-sdk/clients/all.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    module2.exports = {
      ACM: require_acm(),
      APIGateway: require_apigateway2(),
      ApplicationAutoScaling: require_applicationautoscaling(),
      AppStream: require_appstream(),
      AutoScaling: require_autoscaling(),
      Batch: require_batch(),
      Budgets: require_budgets(),
      CloudDirectory: require_clouddirectory(),
      CloudFormation: require_cloudformation(),
      CloudFront: require_cloudfront2(),
      CloudHSM: require_cloudhsm(),
      CloudSearch: require_cloudsearch(),
      CloudSearchDomain: require_cloudsearchdomain2(),
      CloudTrail: require_cloudtrail(),
      CloudWatch: require_cloudwatch(),
      CloudWatchEvents: require_cloudwatchevents(),
      CloudWatchLogs: require_cloudwatchlogs(),
      CodeBuild: require_codebuild(),
      CodeCommit: require_codecommit(),
      CodeDeploy: require_codedeploy(),
      CodePipeline: require_codepipeline(),
      CognitoIdentity: require_cognitoidentity(),
      CognitoIdentityServiceProvider: require_cognitoidentityserviceprovider(),
      CognitoSync: require_cognitosync(),
      ConfigService: require_configservice(),
      CUR: require_cur(),
      DataPipeline: require_datapipeline(),
      DeviceFarm: require_devicefarm(),
      DirectConnect: require_directconnect(),
      DirectoryService: require_directoryservice(),
      Discovery: require_discovery(),
      DMS: require_dms(),
      DynamoDB: require_dynamodb2(),
      DynamoDBStreams: require_dynamodbstreams(),
      EC2: require_ec22(),
      ECR: require_ecr(),
      ECS: require_ecs(),
      EFS: require_efs(),
      ElastiCache: require_elasticache(),
      ElasticBeanstalk: require_elasticbeanstalk(),
      ELB: require_elb(),
      ELBv2: require_elbv2(),
      EMR: require_emr(),
      ES: require_es(),
      ElasticTranscoder: require_elastictranscoder(),
      Firehose: require_firehose(),
      GameLift: require_gamelift(),
      Glacier: require_glacier2(),
      Health: require_health(),
      IAM: require_iam(),
      ImportExport: require_importexport(),
      Inspector: require_inspector(),
      Iot: require_iot(),
      IotData: require_iotdata2(),
      Kinesis: require_kinesis(),
      KinesisAnalytics: require_kinesisanalytics(),
      KMS: require_kms(),
      Lambda: require_lambda2(),
      LexRuntime: require_lexruntime(),
      Lightsail: require_lightsail(),
      MachineLearning: require_machinelearning2(),
      MarketplaceCommerceAnalytics: require_marketplacecommerceanalytics(),
      MarketplaceMetering: require_marketplacemetering(),
      MTurk: require_mturk(),
      MobileAnalytics: require_mobileanalytics(),
      OpsWorks: require_opsworks(),
      OpsWorksCM: require_opsworkscm(),
      Organizations: require_organizations(),
      Pinpoint: require_pinpoint(),
      Polly: require_polly2(),
      RDS: require_rds2(),
      Redshift: require_redshift(),
      Rekognition: require_rekognition(),
      ResourceGroupsTaggingAPI: require_resourcegroupstaggingapi(),
      Route53: require_route532(),
      Route53Domains: require_route53domains(),
      S3: require_s33(),
      S3Control: require_s3control2(),
      ServiceCatalog: require_servicecatalog(),
      SES: require_ses(),
      Shield: require_shield(),
      SimpleDB: require_simpledb(),
      SMS: require_sms(),
      Snowball: require_snowball(),
      SNS: require_sns(),
      SQS: require_sqs2(),
      SSM: require_ssm(),
      StorageGateway: require_storagegateway(),
      StepFunctions: require_stepfunctions(),
      STS: require_sts2(),
      Support: require_support(),
      SWF: require_swf2(),
      XRay: require_xray(),
      WAF: require_waf(),
      WAFRegional: require_wafregional(),
      WorkDocs: require_workdocs(),
      WorkSpaces: require_workspaces(),
      CodeStar: require_codestar(),
      LexModelBuildingService: require_lexmodelbuildingservice(),
      MarketplaceEntitlementService: require_marketplaceentitlementservice(),
      Athena: require_athena(),
      Greengrass: require_greengrass(),
      DAX: require_dax(),
      MigrationHub: require_migrationhub(),
      CloudHSMV2: require_cloudhsmv2(),
      Glue: require_glue(),
      Mobile: require_mobile(),
      Pricing: require_pricing(),
      CostExplorer: require_costexplorer(),
      MediaConvert: require_mediaconvert(),
      MediaLive: require_medialive(),
      MediaPackage: require_mediapackage(),
      MediaStore: require_mediastore(),
      MediaStoreData: require_mediastoredata(),
      AppSync: require_appsync(),
      GuardDuty: require_guardduty(),
      MQ: require_mq(),
      Comprehend: require_comprehend(),
      IoTJobsDataPlane: require_iotjobsdataplane(),
      KinesisVideoArchivedMedia: require_kinesisvideoarchivedmedia(),
      KinesisVideoMedia: require_kinesisvideomedia(),
      KinesisVideo: require_kinesisvideo(),
      SageMakerRuntime: require_sagemakerruntime(),
      SageMaker: require_sagemaker(),
      Translate: require_translate(),
      ResourceGroups: require_resourcegroups(),
      AlexaForBusiness: require_alexaforbusiness(),
      Cloud9: require_cloud9(),
      ServerlessApplicationRepository: require_serverlessapplicationrepository(),
      ServiceDiscovery: require_servicediscovery(),
      WorkMail: require_workmail(),
      AutoScalingPlans: require_autoscalingplans(),
      TranscribeService: require_transcribeservice(),
      Connect: require_connect(),
      ACMPCA: require_acmpca(),
      FMS: require_fms(),
      SecretsManager: require_secretsmanager(),
      IoTAnalytics: require_iotanalytics(),
      IoT1ClickDevicesService: require_iot1clickdevicesservice(),
      IoT1ClickProjects: require_iot1clickprojects(),
      PI: require_pi(),
      Neptune: require_neptune2(),
      MediaTailor: require_mediatailor(),
      EKS: require_eks(),
      DLM: require_dlm(),
      Signer: require_signer3(),
      Chime: require_chime(),
      PinpointEmail: require_pinpointemail(),
      RAM: require_ram(),
      Route53Resolver: require_route53resolver(),
      PinpointSMSVoice: require_pinpointsmsvoice(),
      QuickSight: require_quicksight(),
      RDSDataService: require_rdsdataservice2(),
      Amplify: require_amplify(),
      DataSync: require_datasync(),
      RoboMaker: require_robomaker(),
      Transfer: require_transfer(),
      GlobalAccelerator: require_globalaccelerator(),
      ComprehendMedical: require_comprehendmedical(),
      KinesisAnalyticsV2: require_kinesisanalyticsv2(),
      MediaConnect: require_mediaconnect(),
      FSx: require_fsx(),
      SecurityHub: require_securityhub(),
      AppMesh: require_appmesh(),
      LicenseManager: require_licensemanager(),
      Kafka: require_kafka(),
      ApiGatewayManagementApi: require_apigatewaymanagementapi(),
      ApiGatewayV2: require_apigatewayv2(),
      DocDB: require_docdb2(),
      Backup: require_backup(),
      WorkLink: require_worklink(),
      Textract: require_textract(),
      ManagedBlockchain: require_managedblockchain(),
      MediaPackageVod: require_mediapackagevod(),
      GroundStation: require_groundstation(),
      IoTThingsGraph: require_iotthingsgraph(),
      IoTEvents: require_iotevents(),
      IoTEventsData: require_ioteventsdata(),
      Personalize: require_personalize(),
      PersonalizeEvents: require_personalizeevents(),
      PersonalizeRuntime: require_personalizeruntime(),
      ApplicationInsights: require_applicationinsights(),
      ServiceQuotas: require_servicequotas(),
      EC2InstanceConnect: require_ec2instanceconnect(),
      EventBridge: require_eventbridge2(),
      LakeFormation: require_lakeformation(),
      ForecastService: require_forecastservice(),
      ForecastQueryService: require_forecastqueryservice(),
      QLDB: require_qldb(),
      QLDBSession: require_qldbsession(),
      WorkMailMessageFlow: require_workmailmessageflow(),
      CodeStarNotifications: require_codestarnotifications(),
      SavingsPlans: require_savingsplans(),
      SSO: require_sso(),
      SSOOIDC: require_ssooidc(),
      MarketplaceCatalog: require_marketplacecatalog(),
      DataExchange: require_dataexchange(),
      SESV2: require_sesv2(),
      MigrationHubConfig: require_migrationhubconfig(),
      ConnectParticipant: require_connectparticipant(),
      AppConfig: require_appconfig(),
      IoTSecureTunneling: require_iotsecuretunneling(),
      WAFV2: require_wafv2(),
      ElasticInference: require_elasticinference(),
      Imagebuilder: require_imagebuilder(),
      Schemas: require_schemas(),
      AccessAnalyzer: require_accessanalyzer(),
      CodeGuruReviewer: require_codegurureviewer(),
      CodeGuruProfiler: require_codeguruprofiler(),
      ComputeOptimizer: require_computeoptimizer(),
      FraudDetector: require_frauddetector(),
      Kendra: require_kendra(),
      NetworkManager: require_networkmanager(),
      Outposts: require_outposts(),
      AugmentedAIRuntime: require_augmentedairuntime(),
      EBS: require_ebs(),
      KinesisVideoSignalingChannels: require_kinesisvideosignalingchannels(),
      Detective: require_detective(),
      CodeStarconnections: require_codestarconnections(),
      Synthetics: require_synthetics(),
      IoTSiteWise: require_iotsitewise(),
      Macie2: require_macie2(),
      CodeArtifact: require_codeartifact(),
      Honeycode: require_honeycode(),
      IVS: require_ivs(),
      Braket: require_braket(),
      IdentityStore: require_identitystore(),
      Appflow: require_appflow(),
      RedshiftData: require_redshiftdata(),
      SSOAdmin: require_ssoadmin(),
      TimestreamQuery: require_timestreamquery(),
      TimestreamWrite: require_timestreamwrite(),
      S3Outposts: require_s3outposts(),
      DataBrew: require_databrew(),
      ServiceCatalogAppRegistry: require_servicecatalogappregistry(),
      NetworkFirewall: require_networkfirewall(),
      MWAA: require_mwaa(),
      AmplifyBackend: require_amplifybackend(),
      AppIntegrations: require_appintegrations(),
      ConnectContactLens: require_connectcontactlens(),
      DevOpsGuru: require_devopsguru(),
      ECRPUBLIC: require_ecrpublic(),
      LookoutVision: require_lookoutvision(),
      SageMakerFeatureStoreRuntime: require_sagemakerfeaturestoreruntime(),
      CustomerProfiles: require_customerprofiles(),
      AuditManager: require_auditmanager(),
      EMRcontainers: require_emrcontainers(),
      HealthLake: require_healthlake(),
      SagemakerEdge: require_sagemakeredge(),
      Amp: require_amp(),
      GreengrassV2: require_greengrassv2(),
      IotDeviceAdvisor: require_iotdeviceadvisor(),
      IoTFleetHub: require_iotfleethub(),
      IoTWireless: require_iotwireless(),
      Location: require_location(),
      WellArchitected: require_wellarchitected(),
      LexModelsV2: require_lexmodelsv2(),
      LexRuntimeV2: require_lexruntimev2(),
      Fis: require_fis(),
      LookoutMetrics: require_lookoutmetrics(),
      Mgn: require_mgn(),
      LookoutEquipment: require_lookoutequipment(),
      Nimble: require_nimble(),
      Finspace: require_finspace(),
      Finspacedata: require_finspacedata(),
      SSMContacts: require_ssmcontacts(),
      SSMIncidents: require_ssmincidents(),
      ApplicationCostProfiler: require_applicationcostprofiler(),
      AppRunner: require_apprunner(),
      Proton: require_proton(),
      Route53RecoveryCluster: require_route53recoverycluster(),
      Route53RecoveryControlConfig: require_route53recoverycontrolconfig(),
      Route53RecoveryReadiness: require_route53recoveryreadiness(),
      ChimeSDKIdentity: require_chimesdkidentity(),
      ChimeSDKMessaging: require_chimesdkmessaging(),
      SnowDeviceManagement: require_snowdevicemanagement(),
      MemoryDB: require_memorydb(),
      OpenSearch: require_opensearch(),
      KafkaConnect: require_kafkaconnect(),
      VoiceID: require_voiceid(),
      Wisdom: require_wisdom(),
      Account: require_account(),
      CloudControl: require_cloudcontrol(),
      Grafana: require_grafana(),
      Panorama: require_panorama(),
      ChimeSDKMeetings: require_chimesdkmeetings(),
      Resiliencehub: require_resiliencehub(),
      MigrationHubStrategy: require_migrationhubstrategy(),
      AppConfigData: require_appconfigdata(),
      Drs: require_drs(),
      MigrationHubRefactorSpaces: require_migrationhubrefactorspaces(),
      Evidently: require_evidently(),
      Inspector2: require_inspector2(),
      Rbin: require_rbin(),
      RUM: require_rum(),
      BackupGateway: require_backupgateway(),
      IoTTwinMaker: require_iottwinmaker(),
      WorkSpacesWeb: require_workspacesweb(),
      AmplifyUIBuilder: require_amplifyuibuilder(),
      Keyspaces: require_keyspaces(),
      Billingconductor: require_billingconductor(),
      PinpointSMSVoiceV2: require_pinpointsmsvoicev2(),
      Ivschat: require_ivschat(),
      ChimeSDKMediaPipelines: require_chimesdkmediapipelines(),
      EMRServerless: require_emrserverless(),
      M2: require_m2(),
      ConnectCampaigns: require_connectcampaigns(),
      RedshiftServerless: require_redshiftserverless(),
      RolesAnywhere: require_rolesanywhere(),
      LicenseManagerUserSubscriptions: require_licensemanagerusersubscriptions(),
      BackupStorage: require_backupstorage(),
      PrivateNetworks: require_privatenetworks(),
      SupportApp: require_supportapp(),
      ControlTower: require_controltower(),
      IoTFleetWise: require_iotfleetwise(),
      MigrationHubOrchestrator: require_migrationhuborchestrator(),
      ConnectCases: require_connectcases(),
      ResourceExplorer2: require_resourceexplorer2(),
      Scheduler: require_scheduler(),
      ChimeSDKVoice: require_chimesdkvoice(),
      IoTRoboRunner: require_iotroborunner(),
      SsmSap: require_ssmsap(),
      OAM: require_oam(),
      ARCZonalShift: require_arczonalshift(),
      Omics: require_omics(),
      OpenSearchServerless: require_opensearchserverless(),
      SecurityLake: require_securitylake(),
      SimSpaceWeaver: require_simspaceweaver(),
      DocDBElastic: require_docdbelastic(),
      SageMakerGeospatial: require_sagemakergeospatial(),
      CodeCatalyst: require_codecatalyst(),
      Pipes: require_pipes(),
      SageMakerMetrics: require_sagemakermetrics(),
      KinesisVideoWebRTCStorage: require_kinesisvideowebrtcstorage(),
      LicenseManagerLinuxSubscriptions: require_licensemanagerlinuxsubscriptions(),
      KendraRanking: require_kendraranking(),
      CleanRooms: require_cleanrooms(),
      CloudTrailData: require_cloudtraildata(),
      Tnb: require_tnb(),
      InternetMonitor: require_internetmonitor(),
      IVSRealTime: require_ivsrealtime(),
      VPCLattice: require_vpclattice(),
      OSIS: require_osis(),
      MediaPackageV2: require_mediapackagev2(),
      PaymentCryptography: require_paymentcryptography(),
      PaymentCryptographyData: require_paymentcryptographydata(),
      CodeGuruSecurity: require_codegurusecurity(),
      VerifiedPermissions: require_verifiedpermissions(),
      AppFabric: require_appfabric(),
      MedicalImaging: require_medicalimaging(),
      EntityResolution: require_entityresolution(),
      ManagedBlockchainQuery: require_managedblockchainquery(),
      Neptunedata: require_neptunedata(),
      PcaConnectorAd: require_pcaconnectorad(),
      Bedrock: require_bedrock(),
      BedrockRuntime: require_bedrockruntime(),
      DataZone: require_datazone(),
      LaunchWizard: require_launchwizard(),
      TrustedAdvisor: require_trustedadvisor(),
      CloudFrontKeyValueStore: require_cloudfrontkeyvaluestore(),
      InspectorScan: require_inspectorscan(),
      BCMDataExports: require_bcmdataexports(),
      CostOptimizationHub: require_costoptimizationhub(),
      EKSAuth: require_eksauth(),
      FreeTier: require_freetier(),
      Repostspace: require_repostspace(),
      WorkSpacesThinClient: require_workspacesthinclient(),
      B2bi: require_b2bi(),
      BedrockAgent: require_bedrockagent(),
      BedrockAgentRuntime: require_bedrockagentruntime(),
      QBusiness: require_qbusiness(),
      QConnect: require_qconnect(),
      CleanRoomsML: require_cleanroomsml(),
      MarketplaceAgreement: require_marketplaceagreement(),
      MarketplaceDeployment: require_marketplacedeployment(),
      NeptuneGraph: require_neptunegraph2(),
      NetworkMonitor: require_networkmonitor()
    };
  }
});

// node_modules/aws-sdk/lib/aws.js
var require_aws = __commonJS({
  "node_modules/aws-sdk/lib/aws.js"(exports2, module2) {
    "use strict";
    require_node_loader();
    var AWS2 = require_core();
    require_all();
    module2.exports = AWS2;
  }
});

// node_modules/constructs/lib/dependency.js
var require_dependency = __commonJS({
  "node_modules/constructs/lib/dependency.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Dependable = exports2.DependencyGroup = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var DependencyGroup = class {
      /**
       * @experimental
       */
      constructor(...deps) {
        this._deps = new Array();
        const self2 = this;
        Dependable.implement(this, {
          get dependencyRoots() {
            const result = new Array();
            for (const d of self2._deps) {
              result.push(...Dependable.of(d).dependencyRoots);
            }
            return result;
          }
        });
        this.add(...deps);
      }
      /**
       * (experimental) Add a construct to the dependency roots.
       *
       * @experimental
       */
      add(...scopes) {
        this._deps.push(...scopes);
      }
    };
    exports2.DependencyGroup = DependencyGroup;
    _a = JSII_RTTI_SYMBOL_1;
    DependencyGroup[_a] = { fqn: "constructs.DependencyGroup", version: "10.0.5" };
    var DEPENDABLE_SYMBOL = Symbol.for("@aws-cdk/core.DependableTrait");
    var Dependable = class {
      /**
       * (experimental) Turn any object into an IDependable.
       *
       * @experimental
       */
      static implement(instance, trait) {
        instance[DEPENDABLE_SYMBOL] = trait;
      }
      /**
       * (experimental) Return the matching Dependable for the given class instance.
       *
       * @experimental
       */
      static of(instance) {
        const ret = instance[DEPENDABLE_SYMBOL];
        if (!ret) {
          throw new Error(`${instance} does not implement IDependable. Use "Dependable.implement()" to implement`);
        }
        return ret;
      }
      /**
       * (deprecated) Return the matching Dependable for the given class instance.
       *
       * @deprecated use `of`
       */
      static get(instance) {
        return this.of(instance);
      }
    };
    exports2.Dependable = Dependable;
    _b = JSII_RTTI_SYMBOL_1;
    Dependable[_b] = { fqn: "constructs.Dependable", version: "10.0.5" };
  }
});

// node_modules/constructs/lib/private/stack-trace.js
var require_stack_trace = __commonJS({
  "node_modules/constructs/lib/private/stack-trace.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.captureStackTrace = void 0;
    function captureStackTrace(below) {
      below = below || captureStackTrace;
      const object = { stack: "" };
      const previousLimit = Error.stackTraceLimit;
      try {
        Error.stackTraceLimit = Number.MAX_SAFE_INTEGER;
        Error.captureStackTrace(object, below);
      } finally {
        Error.stackTraceLimit = previousLimit;
      }
      if (!object.stack) {
        return [];
      }
      return object.stack.split("\n").slice(1).map((s) => s.replace(/^\s*at\s+/, ""));
    }
    exports2.captureStackTrace = captureStackTrace;
  }
});

// node_modules/constructs/lib/private/uniqueid.js
var require_uniqueid = __commonJS({
  "node_modules/constructs/lib/private/uniqueid.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.addressOf = void 0;
    var crypto = require("crypto");
    var HIDDEN_ID = "Default";
    function addressOf(components) {
      const hash = crypto.createHash("sha1");
      for (const c of components) {
        if (c === HIDDEN_ID) {
          continue;
        }
        hash.update(c);
        hash.update("\n");
      }
      return "c8" + hash.digest("hex");
    }
    exports2.addressOf = addressOf;
  }
});

// node_modules/constructs/lib/construct.js
var require_construct = __commonJS({
  "node_modules/constructs/lib/construct.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ConstructOrder = exports2.Construct = exports2.Node = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var dependency_1 = require_dependency();
    var stack_trace_1 = require_stack_trace();
    var uniqueid_1 = require_uniqueid();
    var Node = class _Node {
      /**
       * @stability stable
       */
      constructor(host, scope, id) {
        this.host = host;
        this._locked = false;
        this._children = {};
        this._context = {};
        this._metadata = new Array();
        this._dependencies = /* @__PURE__ */ new Set();
        this._validations = new Array();
        id = id !== null && id !== void 0 ? id : "";
        this.id = sanitizeId(id);
        this.scope = scope;
        if (scope && !this.id) {
          throw new Error("Only root constructs may have an empty ID");
        }
        scope === null || scope === void 0 ? void 0 : scope.node.addChild(host, this.id);
      }
      /**
       * (deprecated) Returns the node associated with a construct.
       *
       * @param construct the construct.
       * @deprecated use `construct.node` instead
       */
      static of(construct) {
        return construct.node;
      }
      /**
       * The full, absolute path of this construct in the tree.
       *
       * Components are separated by '/'.
       *
       * @stability stable
       */
      get path() {
        const components = this.scopes.filter((c) => c.node.id).map((c) => c.node.id);
        return components.join(_Node.PATH_SEP);
      }
      /**
       * Returns an opaque tree-unique address for this construct.
       *
       * Addresses are 42 characters hexadecimal strings. They begin with "c8"
       * followed by 40 lowercase hexadecimal characters (0-9a-f).
       *
       * Addresses are calculated using a SHA-1 of the components of the construct
       * path.
       *
       * To enable refactorings of construct trees, constructs with the ID `Default`
       * will be excluded from the calculation. In those cases constructs in the
       * same tree may have the same addreess.
       *
       * @stability stable
       * @example
       *
       * c83a2846e506bcc5f10682b564084bca2d275709ee
       */
      get addr() {
        if (!this._addr) {
          this._addr = uniqueid_1.addressOf(this.scopes.map((c) => _Node.of(c).id));
        }
        return this._addr;
      }
      /**
       * Return a direct child by id, or undefined.
       *
       * @param id Identifier of direct child.
       * @returns the child if found, or undefined
       * @stability stable
       */
      tryFindChild(id) {
        return this._children[sanitizeId(id)];
      }
      /**
       * Return a direct child by id.
       *
       * Throws an error if the child is not found.
       *
       * @param id Identifier of direct child.
       * @returns Child with the given id.
       * @stability stable
       */
      findChild(id) {
        const ret = this.tryFindChild(id);
        if (!ret) {
          throw new Error(`No child with id: '${id}'`);
        }
        return ret;
      }
      /**
       * Returns the child construct that has the id `Default` or `Resource"`.
       *
       * This is usually the construct that provides the bulk of the underlying functionality.
       * Useful for modifications of the underlying construct that are not available at the higher levels.
       * Override the defaultChild property.
       *
       * This should only be used in the cases where the correct
       * default child is not named 'Resource' or 'Default' as it
       * should be.
       *
       * If you set this to undefined, the default behavior of finding
       * the child named 'Resource' or 'Default' will be used.
       *
       * @returns a construct or undefined if there is no default child
       * @stability stable
       * @throws if there is more than one child
       */
      get defaultChild() {
        if (this._defaultChild !== void 0) {
          return this._defaultChild;
        }
        const resourceChild = this.tryFindChild("Resource");
        const defaultChild = this.tryFindChild("Default");
        if (resourceChild && defaultChild) {
          throw new Error(`Cannot determine default child for ${this.path}. There is both a child with id "Resource" and id "Default"`);
        }
        return defaultChild || resourceChild;
      }
      /**
       * Returns the child construct that has the id `Default` or `Resource"`.
       *
       * This is usually the construct that provides the bulk of the underlying functionality.
       * Useful for modifications of the underlying construct that are not available at the higher levels.
       * Override the defaultChild property.
       *
       * This should only be used in the cases where the correct
       * default child is not named 'Resource' or 'Default' as it
       * should be.
       *
       * If you set this to undefined, the default behavior of finding
       * the child named 'Resource' or 'Default' will be used.
       *
       * @returns a construct or undefined if there is no default child
       * @stability stable
       * @throws if there is more than one child
       */
      set defaultChild(value) {
        this._defaultChild = value;
      }
      /**
       * All direct children of this construct.
       *
       * @stability stable
       */
      get children() {
        return Object.values(this._children);
      }
      /**
       * Return this construct and all of its children in the given order.
       *
       * @stability stable
       */
      findAll(order = ConstructOrder.PREORDER) {
        const ret = new Array();
        visit(this.host);
        return ret;
        function visit(c) {
          if (order === ConstructOrder.PREORDER) {
            ret.push(c);
          }
          for (const child of c.node.children) {
            visit(child);
          }
          if (order === ConstructOrder.POSTORDER) {
            ret.push(c);
          }
        }
      }
      /**
       * This can be used to set contextual values.
       *
       * Context must be set before any children are added, since children may consult context info during construction.
       * If the key already exists, it will be overridden.
       *
       * @param key The context key.
       * @param value The context value.
       * @stability stable
       */
      setContext(key, value) {
        if (this.children.length > 0) {
          const names = this.children.map((c) => c.node.id);
          throw new Error("Cannot set context after children have been added: " + names.join(","));
        }
        this._context[key] = value;
      }
      /**
       * Retrieves a value from tree context.
       *
       * Context is usually initialized at the root, but can be overridden at any point in the tree.
       *
       * @param key The context key.
       * @returns The context value or `undefined` if there is no context value for thie key.
       * @stability stable
       */
      tryGetContext(key) {
        const value = this._context[key];
        if (value !== void 0) {
          return value;
        }
        return this.scope && this.scope.node.tryGetContext(key);
      }
      /**
       * An immutable array of metadata objects associated with this construct.
       *
       * This can be used, for example, to implement support for deprecation notices, source mapping, etc.
       *
       * @stability stable
       */
      get metadata() {
        return [...this._metadata];
      }
      /**
       * Adds a metadata entry to this construct.
       *
       * Entries are arbitrary values and will also include a stack trace to allow tracing back to
       * the code location for when the entry was added. It can be used, for example, to include source
       * mapping in CloudFormation templates to improve diagnostics.
       *
       * @param type a string denoting the type of metadata.
       * @param data the value of the metadata (can be a Token).
       * @param options options.
       * @stability stable
       */
      addMetadata(type, data, options = {}) {
        var _c, _d;
        if (data == null) {
          return;
        }
        const shouldTrace = (_c = options.stackTrace) !== null && _c !== void 0 ? _c : false;
        const trace = shouldTrace ? stack_trace_1.captureStackTrace((_d = options.traceFromFunction) !== null && _d !== void 0 ? _d : this.addMetadata) : void 0;
        this._metadata.push({ type, data, trace });
      }
      /**
       * All parent scopes of this construct.
       *
       * @returns a list of parent scopes. The last element in the list will always
       * be the current construct and the first element will be the root of the
       * tree.
       * @stability stable
       */
      get scopes() {
        const ret = new Array();
        let curr = this.host;
        while (curr) {
          ret.unshift(curr);
          curr = curr.node.scope;
        }
        return ret;
      }
      /**
       * Returns the root of the construct tree.
       *
       * @returns The root of the construct tree.
       * @stability stable
       */
      get root() {
        return this.scopes[0];
      }
      /**
       * Returns true if this construct or the scopes in which it is defined are locked.
       *
       * @stability stable
       */
      get locked() {
        if (this._locked) {
          return true;
        }
        if (this.scope && this.scope.node.locked) {
          return true;
        }
        return false;
      }
      /**
       * Add an ordering dependency on another construct.
       *
       * An `IDependable`
       *
       * @stability stable
       */
      addDependency(...deps) {
        for (const d of deps) {
          this._dependencies.add(d);
        }
      }
      /**
       * Return all dependencies registered on this node (non-recursive).
       *
       * @stability stable
       */
      get dependencies() {
        const result = new Array();
        for (const dep of this._dependencies) {
          for (const root of dependency_1.Dependable.of(dep).dependencyRoots) {
            result.push(root);
          }
        }
        return result;
      }
      /**
       * (experimental) Remove the child with the given name, if present.
       *
       * @returns Whether a child with the given name was deleted.
       * @experimental
       */
      tryRemoveChild(childName) {
        if (!(childName in this._children)) {
          return false;
        }
        delete this._children[childName];
        return true;
      }
      /**
       * Adds a validation to this construct.
       *
       * When `node.validate()` is called, the `validate()` method will be called on
       * all validations and all errors will be returned.
       *
       * @param validation The validation object.
       * @stability stable
       */
      addValidation(validation) {
        this._validations.push(validation);
      }
      /**
       * Validates this construct.
       *
       * Invokes the `validate()` method on all validations added through
       * `addValidation()`.
       *
       * @returns an array of validation error messages associated with this
       * construct.
       * @stability stable
       */
      validate() {
        const deprecated = ["validate", "onValidate", "synthesize", "onSynthesize", "prepare", "onPrepare"];
        for (const method of deprecated) {
          if (typeof this.host[method] === "function") {
            throw new Error(`the construct "${this.path}" has a "${method}()" method which is no longer supported. Use "construct.node.addValidation()" to add validations to a construct`);
          }
        }
        const errors = new Array();
        for (const v of this._validations) {
          errors.push(...v.validate());
        }
        return errors;
      }
      /**
       * Locks this construct from allowing more children to be added.
       *
       * After this
       * call, no more children can be added to this construct or to any children.
       *
       * @stability stable
       */
      lock() {
        this._locked = true;
      }
      /**
       * Adds a child construct to this node.
       *
       * @param child The child construct
       * @param childName The type name of the child construct.
       * @returns The resolved path part name of the child
       */
      addChild(child, childName) {
        var _c;
        if (this.locked) {
          if (!this.path) {
            throw new Error("Cannot add children during synthesis");
          }
          throw new Error(`Cannot add children to "${this.path}" during synthesis`);
        }
        if (childName in this._children) {
          const name = (_c = this.id) !== null && _c !== void 0 ? _c : "";
          const typeName = this.host.constructor.name;
          throw new Error(`There is already a Construct with name '${childName}' in ${typeName}${name.length > 0 ? " [" + name + "]" : ""}`);
        }
        if (!childName && this.id) {
          throw new Error(`cannot add a nameless construct to the named scope: ${this.path}`);
        }
        this._children[childName] = child;
        if (Object.keys(this._children).length > 1 && Object.keys(this._children).filter((x) => !x).length > 0) {
          throw new Error("only a single construct is allowed in a scope if it has an empty name");
        }
      }
    };
    exports2.Node = Node;
    _a = JSII_RTTI_SYMBOL_1;
    Node[_a] = { fqn: "constructs.Node", version: "10.0.5" };
    Node.PATH_SEP = "/";
    var Construct = class _Construct {
      /**
       * Creates a new construct node.
       *
       * @param scope The scope in which to define this construct.
       * @param id The scoped construct ID.
       * @stability stable
       */
      constructor(scope, id) {
        this.node = new Node(this, scope, id);
        dependency_1.Dependable.implement(this, {
          dependencyRoots: [this]
        });
      }
      /**
       * (deprecated) Checks if `x` is a construct.
       *
       * @param x Any object.
       * @returns true if `x` is an object created from a class which extends `Construct`.
       * @deprecated use `x instanceof Construct` instead
       */
      static isConstruct(x) {
        return x instanceof _Construct;
      }
      /**
       * Returns a string representation of this construct.
       *
       * @stability stable
       */
      toString() {
        return this.node.path || "<root>";
      }
    };
    exports2.Construct = Construct;
    _b = JSII_RTTI_SYMBOL_1;
    Construct[_b] = { fqn: "constructs.Construct", version: "10.0.5" };
    var ConstructOrder;
    (function(ConstructOrder2) {
      ConstructOrder2[ConstructOrder2["PREORDER"] = 0] = "PREORDER";
      ConstructOrder2[ConstructOrder2["POSTORDER"] = 1] = "POSTORDER";
    })(ConstructOrder = exports2.ConstructOrder || (exports2.ConstructOrder = {}));
    var PATH_SEP_REGEX = new RegExp(`${Node.PATH_SEP}`, "g");
    function sanitizeId(id) {
      return id.replace(PATH_SEP_REGEX, "--");
    }
  }
});

// node_modules/constructs/lib/metadata.js
var require_metadata2 = __commonJS({
  "node_modules/constructs/lib/metadata.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/constructs/lib/index.js
var require_lib2 = __commonJS({
  "node_modules/constructs/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports3) {
      for (var p in m)
        if (p !== "default" && !exports3.hasOwnProperty(p))
          __createBinding(exports3, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar(require_construct(), exports2);
    __exportStar(require_metadata2(), exports2);
    __exportStar(require_dependency(), exports2);
  }
});

// node_modules/aws-cdk-lib/core/lib/aspect.js
var require_aspect = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/aspect.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Aspects = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var ASPECTS_SYMBOL = Symbol.for("cdk-aspects");
    var Aspects = class _Aspects {
      static of(scope) {
        let aspects = scope[ASPECTS_SYMBOL];
        return aspects || (aspects = new _Aspects(), Object.defineProperty(scope, ASPECTS_SYMBOL, { value: aspects, configurable: false, enumerable: false })), aspects;
      }
      constructor() {
        this._aspects = [];
      }
      add(aspect) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_IAspect(aspect);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.add), error;
        }
        this._aspects.push(aspect);
      }
      get all() {
        return [...this._aspects];
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Aspects[_a] = { fqn: "aws-cdk-lib.Aspects", version: "2.80.0" }, exports2.Aspects = Aspects;
  }
});

// node_modules/aws-cdk-lib/cloud-assembly-schema/lib/cloud-assembly/schema.js
var require_schema = __commonJS({
  "node_modules/aws-cdk-lib/cloud-assembly-schema/lib/cloud-assembly/schema.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ArtifactType = void 0;
    var ArtifactType;
    (function(ArtifactType2) {
      ArtifactType2.NONE = "none", ArtifactType2.AWS_CLOUDFORMATION_STACK = "aws:cloudformation:stack", ArtifactType2.CDK_TREE = "cdk:tree", ArtifactType2.ASSET_MANIFEST = "cdk:asset-manifest", ArtifactType2.NESTED_CLOUD_ASSEMBLY = "cdk:cloud-assembly";
    })(ArtifactType = exports2.ArtifactType || (exports2.ArtifactType = {}));
  }
});

// node_modules/aws-cdk-lib/cloud-assembly-schema/lib/cloud-assembly/metadata-schema.js
var require_metadata_schema = __commonJS({
  "node_modules/aws-cdk-lib/cloud-assembly-schema/lib/cloud-assembly/metadata-schema.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ArtifactMetadataEntryType = void 0;
    var ArtifactMetadataEntryType;
    (function(ArtifactMetadataEntryType2) {
      ArtifactMetadataEntryType2.ASSET = "aws:cdk:asset", ArtifactMetadataEntryType2.INFO = "aws:cdk:info", ArtifactMetadataEntryType2.WARN = "aws:cdk:warning", ArtifactMetadataEntryType2.ERROR = "aws:cdk:error", ArtifactMetadataEntryType2.LOGICAL_ID = "aws:cdk:logicalId", ArtifactMetadataEntryType2.STACK_TAGS = "aws:cdk:stack-tags";
    })(ArtifactMetadataEntryType = exports2.ArtifactMetadataEntryType || (exports2.ArtifactMetadataEntryType = {}));
  }
});

// node_modules/aws-cdk-lib/cloud-assembly-schema/lib/cloud-assembly/artifact-schema.js
var require_artifact_schema = __commonJS({
  "node_modules/aws-cdk-lib/cloud-assembly-schema/lib/cloud-assembly/artifact-schema.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/cloud-assembly-schema/lib/cloud-assembly/context-queries.js
var require_context_queries = __commonJS({
  "node_modules/aws-cdk-lib/cloud-assembly-schema/lib/cloud-assembly/context-queries.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LoadBalancerListenerProtocol = exports2.LoadBalancerType = exports2.ContextProvider = void 0;
    var ContextProvider;
    (function(ContextProvider2) {
      ContextProvider2.AMI_PROVIDER = "ami", ContextProvider2.AVAILABILITY_ZONE_PROVIDER = "availability-zones", ContextProvider2.HOSTED_ZONE_PROVIDER = "hosted-zone", ContextProvider2.SSM_PARAMETER_PROVIDER = "ssm", ContextProvider2.VPC_PROVIDER = "vpc-provider", ContextProvider2.ENDPOINT_SERVICE_AVAILABILITY_ZONE_PROVIDER = "endpoint-service-availability-zones", ContextProvider2.LOAD_BALANCER_PROVIDER = "load-balancer", ContextProvider2.LOAD_BALANCER_LISTENER_PROVIDER = "load-balancer-listener", ContextProvider2.SECURITY_GROUP_PROVIDER = "security-group", ContextProvider2.KEY_PROVIDER = "key-provider", ContextProvider2.PLUGIN = "plugin";
    })(ContextProvider = exports2.ContextProvider || (exports2.ContextProvider = {}));
    var LoadBalancerType;
    (function(LoadBalancerType2) {
      LoadBalancerType2.NETWORK = "network", LoadBalancerType2.APPLICATION = "application";
    })(LoadBalancerType = exports2.LoadBalancerType || (exports2.LoadBalancerType = {}));
    var LoadBalancerListenerProtocol;
    (function(LoadBalancerListenerProtocol2) {
      LoadBalancerListenerProtocol2.HTTP = "HTTP", LoadBalancerListenerProtocol2.HTTPS = "HTTPS", LoadBalancerListenerProtocol2.TCP = "TCP", LoadBalancerListenerProtocol2.TLS = "TLS", LoadBalancerListenerProtocol2.UDP = "UDP", LoadBalancerListenerProtocol2.TCP_UDP = "TCP_UDP";
    })(LoadBalancerListenerProtocol = exports2.LoadBalancerListenerProtocol || (exports2.LoadBalancerListenerProtocol = {}));
  }
});

// node_modules/aws-cdk-lib/cloud-assembly-schema/lib/cloud-assembly/index.js
var require_cloud_assembly = __commonJS({
  "node_modules/aws-cdk-lib/cloud-assembly-schema/lib/cloud-assembly/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_schema(), exports2), __exportStar(require_metadata_schema(), exports2), __exportStar(require_artifact_schema(), exports2), __exportStar(require_context_queries(), exports2);
  }
});

// node_modules/aws-cdk-lib/cloud-assembly-schema/lib/assets/schema.js
var require_schema2 = __commonJS({
  "node_modules/aws-cdk-lib/cloud-assembly-schema/lib/assets/schema.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/cloud-assembly-schema/lib/assets/docker-image-asset.js
var require_docker_image_asset = __commonJS({
  "node_modules/aws-cdk-lib/cloud-assembly-schema/lib/assets/docker-image-asset.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/cloud-assembly-schema/lib/assets/file-asset.js
var require_file_asset = __commonJS({
  "node_modules/aws-cdk-lib/cloud-assembly-schema/lib/assets/file-asset.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FileAssetPackaging = void 0;
    var FileAssetPackaging;
    (function(FileAssetPackaging2) {
      FileAssetPackaging2.FILE = "file", FileAssetPackaging2.ZIP_DIRECTORY = "zip";
    })(FileAssetPackaging = exports2.FileAssetPackaging || (exports2.FileAssetPackaging = {}));
  }
});

// node_modules/aws-cdk-lib/cloud-assembly-schema/lib/assets/aws-destination.js
var require_aws_destination = __commonJS({
  "node_modules/aws-cdk-lib/cloud-assembly-schema/lib/assets/aws-destination.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/cloud-assembly-schema/lib/assets/index.js
var require_assets = __commonJS({
  "node_modules/aws-cdk-lib/cloud-assembly-schema/lib/assets/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_schema2(), exports2), __exportStar(require_docker_image_asset(), exports2), __exportStar(require_file_asset(), exports2), __exportStar(require_aws_destination(), exports2);
  }
});

// node_modules/aws-cdk-lib/node_modules/jsonschema/lib/helpers.js
var require_helpers2 = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/jsonschema/lib/helpers.js"(exports2, module2) {
    "use strict";
    var uri = require("url");
    var ValidationError = exports2.ValidationError = function ValidationError2(message, instance, schema, path, name, argument) {
      if (Array.isArray(path)) {
        this.path = path;
        this.property = path.reduce(function(sum, item) {
          return sum + makeSuffix(item);
        }, "instance");
      } else if (path !== void 0) {
        this.property = path;
      }
      if (message) {
        this.message = message;
      }
      if (schema) {
        var id = schema.$id || schema.id;
        this.schema = id || schema;
      }
      if (instance !== void 0) {
        this.instance = instance;
      }
      this.name = name;
      this.argument = argument;
      this.stack = this.toString();
    };
    ValidationError.prototype.toString = function toString() {
      return this.property + " " + this.message;
    };
    var ValidatorResult = exports2.ValidatorResult = function ValidatorResult2(instance, schema, options, ctx) {
      this.instance = instance;
      this.schema = schema;
      this.options = options;
      this.path = ctx.path;
      this.propertyPath = ctx.propertyPath;
      this.errors = [];
      this.throwError = options && options.throwError;
      this.throwFirst = options && options.throwFirst;
      this.throwAll = options && options.throwAll;
      this.disableFormat = options && options.disableFormat === true;
    };
    ValidatorResult.prototype.addError = function addError(detail) {
      var err;
      if (typeof detail == "string") {
        err = new ValidationError(detail, this.instance, this.schema, this.path);
      } else {
        if (!detail)
          throw new Error("Missing error detail");
        if (!detail.message)
          throw new Error("Missing error message");
        if (!detail.name)
          throw new Error("Missing validator type");
        err = new ValidationError(detail.message, this.instance, this.schema, this.path, detail.name, detail.argument);
      }
      this.errors.push(err);
      if (this.throwFirst) {
        throw new ValidatorResultError(this);
      } else if (this.throwError) {
        throw err;
      }
      return err;
    };
    ValidatorResult.prototype.importErrors = function importErrors(res) {
      if (typeof res == "string" || res && res.validatorType) {
        this.addError(res);
      } else if (res && res.errors) {
        this.errors = this.errors.concat(res.errors);
      }
    };
    function stringizer(v, i) {
      return i + ": " + v.toString() + "\n";
    }
    ValidatorResult.prototype.toString = function toString(res) {
      return this.errors.map(stringizer).join("");
    };
    Object.defineProperty(ValidatorResult.prototype, "valid", { get: function() {
      return !this.errors.length;
    } });
    module2.exports.ValidatorResultError = ValidatorResultError;
    function ValidatorResultError(result) {
      if (Error.captureStackTrace) {
        Error.captureStackTrace(this, ValidatorResultError);
      }
      this.instance = result.instance;
      this.schema = result.schema;
      this.options = result.options;
      this.errors = result.errors;
    }
    ValidatorResultError.prototype = new Error();
    ValidatorResultError.prototype.constructor = ValidatorResultError;
    ValidatorResultError.prototype.name = "Validation Error";
    var SchemaError = exports2.SchemaError = function SchemaError2(msg, schema) {
      this.message = msg;
      this.schema = schema;
      Error.call(this, msg);
      Error.captureStackTrace(this, SchemaError2);
    };
    SchemaError.prototype = Object.create(
      Error.prototype,
      {
        constructor: { value: SchemaError, enumerable: false },
        name: { value: "SchemaError", enumerable: false }
      }
    );
    var SchemaContext = exports2.SchemaContext = function SchemaContext2(schema, options, path, base, schemas) {
      this.schema = schema;
      this.options = options;
      if (Array.isArray(path)) {
        this.path = path;
        this.propertyPath = path.reduce(function(sum, item) {
          return sum + makeSuffix(item);
        }, "instance");
      } else {
        this.propertyPath = path;
      }
      this.base = base;
      this.schemas = schemas;
    };
    SchemaContext.prototype.resolve = function resolve(target) {
      return uri.resolve(this.base, target);
    };
    SchemaContext.prototype.makeChild = function makeChild(schema, propertyName) {
      var path = propertyName === void 0 ? this.path : this.path.concat([propertyName]);
      var id = schema.$id || schema.id;
      var base = uri.resolve(this.base, id || "");
      var ctx = new SchemaContext(schema, this.options, path, base, Object.create(this.schemas));
      if (id && !ctx.schemas[base]) {
        ctx.schemas[base] = schema;
      }
      return ctx;
    };
    var FORMAT_REGEXPS = exports2.FORMAT_REGEXPS = {
      // 7.3.1. Dates, Times, and Duration
      "date-time": /^\d{4}-(?:0[0-9]{1}|1[0-2]{1})-(3[01]|0[1-9]|[12][0-9])[tT ](2[0-4]|[01][0-9]):([0-5][0-9]):(60|[0-5][0-9])(\.\d+)?([zZ]|[+-]([0-5][0-9]):(60|[0-5][0-9]))$/,
      "date": /^\d{4}-(?:0[0-9]{1}|1[0-2]{1})-(3[01]|0[1-9]|[12][0-9])$/,
      "time": /^(2[0-4]|[01][0-9]):([0-5][0-9]):(60|[0-5][0-9])$/,
      "duration": /P(T\d+(H(\d+M(\d+S)?)?|M(\d+S)?|S)|\d+(D|M(\d+D)?|Y(\d+M(\d+D)?)?)(T\d+(H(\d+M(\d+S)?)?|M(\d+S)?|S))?|\d+W)/i,
      // 7.3.2. Email Addresses
      // TODO: fix the email production
      "email": /^(?:[\w\!\#\$\%\&\'\*\+\-\/\=\?\^\`\{\|\}\~]+\.)*[\w\!\#\$\%\&\'\*\+\-\/\=\?\^\`\{\|\}\~]+@(?:(?:(?:[a-zA-Z0-9](?:[a-zA-Z0-9\-](?!\.)){0,61}[a-zA-Z0-9]?\.)+[a-zA-Z0-9](?:[a-zA-Z0-9\-](?!$)){0,61}[a-zA-Z0-9]?)|(?:\[(?:(?:[01]?\d{1,2}|2[0-4]\d|25[0-5])\.){3}(?:[01]?\d{1,2}|2[0-4]\d|25[0-5])\]))$/,
      "idn-email": /^("(?:[!#-\[\]-\u{10FFFF}]|\\[\t -\u{10FFFF}])*"|[!#-'*+\-/-9=?A-Z\^-\u{10FFFF}](?:\.?[!#-'*+\-/-9=?A-Z\^-\u{10FFFF}])*)@([!#-'*+\-/-9=?A-Z\^-\u{10FFFF}](?:\.?[!#-'*+\-/-9=?A-Z\^-\u{10FFFF}])*|\[[!-Z\^-\u{10FFFF}]*\])$/u,
      // 7.3.3. Hostnames
      // 7.3.4. IP Addresses
      "ip-address": /^(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/,
      // FIXME whitespace is invalid
      "ipv6": /^\s*((([0-9A-Fa-f]{1,4}:){7}([0-9A-Fa-f]{1,4}|:))|(([0-9A-Fa-f]{1,4}:){6}(:[0-9A-Fa-f]{1,4}|((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){5}(((:[0-9A-Fa-f]{1,4}){1,2})|:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){4}(((:[0-9A-Fa-f]{1,4}){1,3})|((:[0-9A-Fa-f]{1,4})?:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){3}(((:[0-9A-Fa-f]{1,4}){1,4})|((:[0-9A-Fa-f]{1,4}){0,2}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){2}(((:[0-9A-Fa-f]{1,4}){1,5})|((:[0-9A-Fa-f]{1,4}){0,3}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){1}(((:[0-9A-Fa-f]{1,4}){1,6})|((:[0-9A-Fa-f]{1,4}){0,4}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(:(((:[0-9A-Fa-f]{1,4}){1,7})|((:[0-9A-Fa-f]{1,4}){0,5}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:)))(%.+)?\s*$/,
      // 7.3.5. Resource Identifiers
      // TODO: A more accurate regular expression for "uri" goes:
      // [A-Za-z][+\-.0-9A-Za-z]*:((/(/((%[0-9A-Fa-f]{2}|[!$&-.0-9;=A-Z_a-z~])+|(\[(([Vv][0-9A-Fa-f]+\.[!$&-.0-;=A-Z_a-z~]+)?|[.0-:A-Fa-f]+)\])?)(:\d*)?)?)?#(%[0-9A-Fa-f]{2}|[!$&-;=?-Z_a-z~])*|(/(/((%[0-9A-Fa-f]{2}|[!$&-.0-9;=A-Z_a-z~])+|(\[(([Vv][0-9A-Fa-f]+\.[!$&-.0-;=A-Z_a-z~]+)?|[.0-:A-Fa-f]+)\])?)(:\d*)?[/?]|[!$&-.0-;=?-Z_a-z~])|/?%[0-9A-Fa-f]{2}|[!$&-.0-;=?-Z_a-z~])(%[0-9A-Fa-f]{2}|[!$&-;=?-Z_a-z~])*(#(%[0-9A-Fa-f]{2}|[!$&-;=?-Z_a-z~])*)?|/(/((%[0-9A-Fa-f]{2}|[!$&-.0-9;=A-Z_a-z~])+(:\d*)?|(\[(([Vv][0-9A-Fa-f]+\.[!$&-.0-;=A-Z_a-z~]+)?|[.0-:A-Fa-f]+)\])?:\d*|\[(([Vv][0-9A-Fa-f]+\.[!$&-.0-;=A-Z_a-z~]+)?|[.0-:A-Fa-f]+)\])?)?)?
      "uri": /^[a-zA-Z][a-zA-Z0-9+.-]*:[^\s]*$/,
      "uri-reference": /^(((([A-Za-z][+\-.0-9A-Za-z]*(:%[0-9A-Fa-f]{2}|:[!$&-.0-;=?-Z_a-z~]|[/?])|\?)(%[0-9A-Fa-f]{2}|[!$&-;=?-Z_a-z~])*|([A-Za-z][+\-.0-9A-Za-z]*:?)?)|([A-Za-z][+\-.0-9A-Za-z]*:)?\/((%[0-9A-Fa-f]{2}|\/((%[0-9A-Fa-f]{2}|[!$&-.0-9;=A-Z_a-z~])+|(\[(([Vv][0-9A-Fa-f]+\.[!$&-.0-;=A-Z_a-z~]+)?|[.0-:A-Fa-f]+)\])?)(:\d*)?[/?]|[!$&-.0-;=?-Z_a-z~])(%[0-9A-Fa-f]{2}|[!$&-;=?-Z_a-z~])*|(\/((%[0-9A-Fa-f]{2}|[!$&-.0-9;=A-Z_a-z~])+|(\[(([Vv][0-9A-Fa-f]+\.[!$&-.0-;=A-Z_a-z~]+)?|[.0-:A-Fa-f]+)\])?)(:\d*)?)?))#(%[0-9A-Fa-f]{2}|[!$&-;=?-Z_a-z~])*|(([A-Za-z][+\-.0-9A-Za-z]*)?%[0-9A-Fa-f]{2}|[!$&-.0-9;=@_~]|[A-Za-z][+\-.0-9A-Za-z]*[!$&-*,;=@_~])(%[0-9A-Fa-f]{2}|[!$&-.0-9;=@-Z_a-z~])*((([/?](%[0-9A-Fa-f]{2}|[!$&-;=?-Z_a-z~])*)?#|[/?])(%[0-9A-Fa-f]{2}|[!$&-;=?-Z_a-z~])*)?|([A-Za-z][+\-.0-9A-Za-z]*(:%[0-9A-Fa-f]{2}|:[!$&-.0-;=?-Z_a-z~]|[/?])|\?)(%[0-9A-Fa-f]{2}|[!$&-;=?-Z_a-z~])*|([A-Za-z][+\-.0-9A-Za-z]*:)?\/((%[0-9A-Fa-f]{2}|\/((%[0-9A-Fa-f]{2}|[!$&-.0-9;=A-Z_a-z~])+|(\[(([Vv][0-9A-Fa-f]+\.[!$&-.0-;=A-Z_a-z~]+)?|[.0-:A-Fa-f]+)\])?)(:\d*)?[/?]|[!$&-.0-;=?-Z_a-z~])(%[0-9A-Fa-f]{2}|[!$&-;=?-Z_a-z~])*|\/((%[0-9A-Fa-f]{2}|[!$&-.0-9;=A-Z_a-z~])+(:\d*)?|(\[(([Vv][0-9A-Fa-f]+\.[!$&-.0-;=A-Z_a-z~]+)?|[.0-:A-Fa-f]+)\])?:\d*|\[(([Vv][0-9A-Fa-f]+\.[!$&-.0-;=A-Z_a-z~]+)?|[.0-:A-Fa-f]+)\])?)?|[A-Za-z][+\-.0-9A-Za-z]*:?)?$/,
      "iri": /^[a-zA-Z][a-zA-Z0-9+.-]*:[^\s]*$/,
      "iri-reference": /^(((([A-Za-z][+\-.0-9A-Za-z]*(:%[0-9A-Fa-f]{2}|:[!$&-.0-;=?-Z_a-z~-\u{10FFFF}]|[/?])|\?)(%[0-9A-Fa-f]{2}|[!$&-;=?-Z_a-z~-\u{10FFFF}])*|([A-Za-z][+\-.0-9A-Za-z]*:?)?)|([A-Za-z][+\-.0-9A-Za-z]*:)?\/((%[0-9A-Fa-f]{2}|\/((%[0-9A-Fa-f]{2}|[!$&-.0-9;=A-Z_a-z~-\u{10FFFF}])+|(\[(([Vv][0-9A-Fa-f]+\.[!$&-.0-;=A-Z_a-z~-\u{10FFFF}]+)?|[.0-:A-Fa-f]+)\])?)(:\d*)?[/?]|[!$&-.0-;=?-Z_a-z~-\u{10FFFF}])(%[0-9A-Fa-f]{2}|[!$&-;=?-Z_a-z~-\u{10FFFF}])*|(\/((%[0-9A-Fa-f]{2}|[!$&-.0-9;=A-Z_a-z~-\u{10FFFF}])+|(\[(([Vv][0-9A-Fa-f]+\.[!$&-.0-;=A-Z_a-z~-\u{10FFFF}]+)?|[.0-:A-Fa-f]+)\])?)(:\d*)?)?))#(%[0-9A-Fa-f]{2}|[!$&-;=?-Z_a-z~-\u{10FFFF}])*|(([A-Za-z][+\-.0-9A-Za-z]*)?%[0-9A-Fa-f]{2}|[!$&-.0-9;=@_~-\u{10FFFF}]|[A-Za-z][+\-.0-9A-Za-z]*[!$&-*,;=@_~-\u{10FFFF}])(%[0-9A-Fa-f]{2}|[!$&-.0-9;=@-Z_a-z~-\u{10FFFF}])*((([/?](%[0-9A-Fa-f]{2}|[!$&-;=?-Z_a-z~-\u{10FFFF}])*)?#|[/?])(%[0-9A-Fa-f]{2}|[!$&-;=?-Z_a-z~-\u{10FFFF}])*)?|([A-Za-z][+\-.0-9A-Za-z]*(:%[0-9A-Fa-f]{2}|:[!$&-.0-;=?-Z_a-z~-\u{10FFFF}]|[/?])|\?)(%[0-9A-Fa-f]{2}|[!$&-;=?-Z_a-z~-\u{10FFFF}])*|([A-Za-z][+\-.0-9A-Za-z]*:)?\/((%[0-9A-Fa-f]{2}|\/((%[0-9A-Fa-f]{2}|[!$&-.0-9;=A-Z_a-z~-\u{10FFFF}])+|(\[(([Vv][0-9A-Fa-f]+\.[!$&-.0-;=A-Z_a-z~-\u{10FFFF}]+)?|[.0-:A-Fa-f]+)\])?)(:\d*)?[/?]|[!$&-.0-;=?-Z_a-z~-\u{10FFFF}])(%[0-9A-Fa-f]{2}|[!$&-;=?-Z_a-z~-\u{10FFFF}])*|\/((%[0-9A-Fa-f]{2}|[!$&-.0-9;=A-Z_a-z~-\u{10FFFF}])+(:\d*)?|(\[(([Vv][0-9A-Fa-f]+\.[!$&-.0-;=A-Z_a-z~-\u{10FFFF}]+)?|[.0-:A-Fa-f]+)\])?:\d*|\[(([Vv][0-9A-Fa-f]+\.[!$&-.0-;=A-Z_a-z~-\u{10FFFF}]+)?|[.0-:A-Fa-f]+)\])?)?|[A-Za-z][+\-.0-9A-Za-z]*:?)?$/u,
      "uuid": /^[0-9A-F]{8}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{12}$/i,
      // 7.3.6. uri-template
      "uri-template": /(%[0-9a-f]{2}|[!#$&(-;=?@\[\]_a-z~]|\{[!#&+,./;=?@|]?(%[0-9a-f]{2}|[0-9_a-z])(\.?(%[0-9a-f]{2}|[0-9_a-z]))*(:[1-9]\d{0,3}|\*)?(,(%[0-9a-f]{2}|[0-9_a-z])(\.?(%[0-9a-f]{2}|[0-9_a-z]))*(:[1-9]\d{0,3}|\*)?)*\})*/iu,
      // 7.3.7. JSON Pointers
      "json-pointer": /^(\/([\x00-\x2e0-@\[-}\x7f]|~[01])*)*$/iu,
      "relative-json-pointer": /^\d+(#|(\/([\x00-\x2e0-@\[-}\x7f]|~[01])*)*)$/iu,
      // hostname regex from: http://stackoverflow.com/a/1420225/5628
      "hostname": /^(?=.{1,255}$)[0-9A-Za-z](?:(?:[0-9A-Za-z]|-){0,61}[0-9A-Za-z])?(?:\.[0-9A-Za-z](?:(?:[0-9A-Za-z]|-){0,61}[0-9A-Za-z])?)*\.?$/,
      "host-name": /^(?=.{1,255}$)[0-9A-Za-z](?:(?:[0-9A-Za-z]|-){0,61}[0-9A-Za-z])?(?:\.[0-9A-Za-z](?:(?:[0-9A-Za-z]|-){0,61}[0-9A-Za-z])?)*\.?$/,
      "utc-millisec": function(input) {
        return typeof input === "string" && parseFloat(input) === parseInt(input, 10) && !isNaN(input);
      },
      // 7.3.8. regex
      "regex": function(input) {
        var result = true;
        try {
          new RegExp(input);
        } catch (e) {
          result = false;
        }
        return result;
      },
      // Other definitions
      // "style" was removed from JSON Schema in draft-4 and is deprecated
      "style": /[\r\n\t ]*[^\r\n\t ][^:]*:[\r\n\t ]*[^\r\n\t ;]*[\r\n\t ]*;?/,
      // "color" was removed from JSON Schema in draft-4 and is deprecated
      "color": /^(#?([0-9A-Fa-f]{3}){1,2}\b|aqua|black|blue|fuchsia|gray|green|lime|maroon|navy|olive|orange|purple|red|silver|teal|white|yellow|(rgb\(\s*\b([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\b\s*,\s*\b([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\b\s*,\s*\b([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\b\s*\))|(rgb\(\s*(\d?\d%|100%)+\s*,\s*(\d?\d%|100%)+\s*,\s*(\d?\d%|100%)+\s*\)))$/,
      "phone": /^\+(?:[0-9] ?){6,14}[0-9]$/,
      "alpha": /^[a-zA-Z]+$/,
      "alphanumeric": /^[a-zA-Z0-9]+$/
    };
    FORMAT_REGEXPS.regexp = FORMAT_REGEXPS.regex;
    FORMAT_REGEXPS.pattern = FORMAT_REGEXPS.regex;
    FORMAT_REGEXPS.ipv4 = FORMAT_REGEXPS["ip-address"];
    exports2.isFormat = function isFormat(input, format, validator) {
      if (typeof input === "string" && FORMAT_REGEXPS[format] !== void 0) {
        if (FORMAT_REGEXPS[format] instanceof RegExp) {
          return FORMAT_REGEXPS[format].test(input);
        }
        if (typeof FORMAT_REGEXPS[format] === "function") {
          return FORMAT_REGEXPS[format](input);
        }
      } else if (validator && validator.customFormats && typeof validator.customFormats[format] === "function") {
        return validator.customFormats[format](input);
      }
      return true;
    };
    var makeSuffix = exports2.makeSuffix = function makeSuffix2(key) {
      key = key.toString();
      if (!key.match(/[.\s\[\]]/) && !key.match(/^[\d]/)) {
        return "." + key;
      }
      if (key.match(/^\d+$/)) {
        return "[" + key + "]";
      }
      return "[" + JSON.stringify(key) + "]";
    };
    exports2.deepCompareStrict = function deepCompareStrict(a, b) {
      if (typeof a !== typeof b) {
        return false;
      }
      if (Array.isArray(a)) {
        if (!Array.isArray(b)) {
          return false;
        }
        if (a.length !== b.length) {
          return false;
        }
        return a.every(function(v, i) {
          return deepCompareStrict(a[i], b[i]);
        });
      }
      if (typeof a === "object") {
        if (!a || !b) {
          return a === b;
        }
        var aKeys = Object.keys(a);
        var bKeys = Object.keys(b);
        if (aKeys.length !== bKeys.length) {
          return false;
        }
        return aKeys.every(function(v) {
          return deepCompareStrict(a[v], b[v]);
        });
      }
      return a === b;
    };
    function deepMerger(target, dst, e, i) {
      if (typeof e === "object") {
        dst[i] = deepMerge(target[i], e);
      } else {
        if (target.indexOf(e) === -1) {
          dst.push(e);
        }
      }
    }
    function copyist(src, dst, key) {
      dst[key] = src[key];
    }
    function copyistWithDeepMerge(target, src, dst, key) {
      if (typeof src[key] !== "object" || !src[key]) {
        dst[key] = src[key];
      } else {
        if (!target[key]) {
          dst[key] = src[key];
        } else {
          dst[key] = deepMerge(target[key], src[key]);
        }
      }
    }
    function deepMerge(target, src) {
      var array = Array.isArray(src);
      var dst = array && [] || {};
      if (array) {
        target = target || [];
        dst = dst.concat(target);
        src.forEach(deepMerger.bind(null, target, dst));
      } else {
        if (target && typeof target === "object") {
          Object.keys(target).forEach(copyist.bind(null, target, dst));
        }
        Object.keys(src).forEach(copyistWithDeepMerge.bind(null, target, src, dst));
      }
      return dst;
    }
    module2.exports.deepMerge = deepMerge;
    exports2.objectGetPath = function objectGetPath(o, s) {
      var parts = s.split("/").slice(1);
      var k;
      while (typeof (k = parts.shift()) == "string") {
        var n = decodeURIComponent(k.replace(/~0/, "~").replace(/~1/g, "/"));
        if (!(n in o))
          return;
        o = o[n];
      }
      return o;
    };
    function pathEncoder(v) {
      return "/" + encodeURIComponent(v).replace(/~/g, "%7E");
    }
    exports2.encodePath = function encodePointer(a) {
      return a.map(pathEncoder).join("");
    };
    exports2.getDecimalPlaces = function getDecimalPlaces(number) {
      var decimalPlaces = 0;
      if (isNaN(number))
        return decimalPlaces;
      if (typeof number !== "number") {
        number = Number(number);
      }
      var parts = number.toString().split("e");
      if (parts.length === 2) {
        if (parts[1][0] !== "-") {
          return decimalPlaces;
        } else {
          decimalPlaces = Number(parts[1].slice(1));
        }
      }
      var decimalParts = parts[0].split(".");
      if (decimalParts.length === 2) {
        decimalPlaces += decimalParts[1].length;
      }
      return decimalPlaces;
    };
    exports2.isSchema = function isSchema(val) {
      return typeof val === "object" && val || typeof val === "boolean";
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/jsonschema/lib/attribute.js
var require_attribute = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/jsonschema/lib/attribute.js"(exports2, module2) {
    "use strict";
    var helpers = require_helpers2();
    var ValidatorResult = helpers.ValidatorResult;
    var SchemaError = helpers.SchemaError;
    var attribute = {};
    attribute.ignoreProperties = {
      // informative properties
      "id": true,
      "default": true,
      "description": true,
      "title": true,
      // arguments to other properties
      "additionalItems": true,
      "then": true,
      "else": true,
      // special-handled properties
      "$schema": true,
      "$ref": true,
      "extends": true
    };
    var validators = attribute.validators = {};
    validators.type = function validateType(instance, schema, options, ctx) {
      if (instance === void 0) {
        return null;
      }
      var result = new ValidatorResult(instance, schema, options, ctx);
      var types = Array.isArray(schema.type) ? schema.type : [schema.type];
      if (!types.some(this.testType.bind(this, instance, schema, options, ctx))) {
        var list = types.map(function(v) {
          if (!v)
            return;
          var id = v.$id || v.id;
          return id ? "<" + id + ">" : v + "";
        });
        result.addError({
          name: "type",
          argument: list,
          message: "is not of a type(s) " + list
        });
      }
      return result;
    };
    function testSchemaNoThrow(instance, options, ctx, callback, schema) {
      var throwError = options.throwError;
      var throwAll = options.throwAll;
      options.throwError = false;
      options.throwAll = false;
      var res = this.validateSchema(instance, schema, options, ctx);
      options.throwError = throwError;
      options.throwAll = throwAll;
      if (!res.valid && callback instanceof Function) {
        callback(res);
      }
      return res.valid;
    }
    validators.anyOf = function validateAnyOf(instance, schema, options, ctx) {
      if (instance === void 0) {
        return null;
      }
      var result = new ValidatorResult(instance, schema, options, ctx);
      var inner = new ValidatorResult(instance, schema, options, ctx);
      if (!Array.isArray(schema.anyOf)) {
        throw new SchemaError("anyOf must be an array");
      }
      if (!schema.anyOf.some(
        testSchemaNoThrow.bind(
          this,
          instance,
          options,
          ctx,
          function(res) {
            inner.importErrors(res);
          }
        )
      )) {
        var list = schema.anyOf.map(function(v, i) {
          var id = v.$id || v.id;
          if (id)
            return "<" + id + ">";
          return v.title && JSON.stringify(v.title) || v["$ref"] && "<" + v["$ref"] + ">" || "[subschema " + i + "]";
        });
        if (options.nestedErrors) {
          result.importErrors(inner);
        }
        result.addError({
          name: "anyOf",
          argument: list,
          message: "is not any of " + list.join(",")
        });
      }
      return result;
    };
    validators.allOf = function validateAllOf(instance, schema, options, ctx) {
      if (instance === void 0) {
        return null;
      }
      if (!Array.isArray(schema.allOf)) {
        throw new SchemaError("allOf must be an array");
      }
      var result = new ValidatorResult(instance, schema, options, ctx);
      var self2 = this;
      schema.allOf.forEach(function(v, i) {
        var valid = self2.validateSchema(instance, v, options, ctx);
        if (!valid.valid) {
          var id = v.$id || v.id;
          var msg = id || v.title && JSON.stringify(v.title) || v["$ref"] && "<" + v["$ref"] + ">" || "[subschema " + i + "]";
          result.addError({
            name: "allOf",
            argument: { id: msg, length: valid.errors.length, valid },
            message: "does not match allOf schema " + msg + " with " + valid.errors.length + " error[s]:"
          });
          result.importErrors(valid);
        }
      });
      return result;
    };
    validators.oneOf = function validateOneOf(instance, schema, options, ctx) {
      if (instance === void 0) {
        return null;
      }
      if (!Array.isArray(schema.oneOf)) {
        throw new SchemaError("oneOf must be an array");
      }
      var result = new ValidatorResult(instance, schema, options, ctx);
      var inner = new ValidatorResult(instance, schema, options, ctx);
      var count = schema.oneOf.filter(
        testSchemaNoThrow.bind(
          this,
          instance,
          options,
          ctx,
          function(res) {
            inner.importErrors(res);
          }
        )
      ).length;
      var list = schema.oneOf.map(function(v, i) {
        var id = v.$id || v.id;
        return id || v.title && JSON.stringify(v.title) || v["$ref"] && "<" + v["$ref"] + ">" || "[subschema " + i + "]";
      });
      if (count !== 1) {
        if (options.nestedErrors) {
          result.importErrors(inner);
        }
        result.addError({
          name: "oneOf",
          argument: list,
          message: "is not exactly one from " + list.join(",")
        });
      }
      return result;
    };
    validators.if = function validateIf(instance, schema, options, ctx) {
      if (instance === void 0)
        return null;
      if (!helpers.isSchema(schema.if))
        throw new Error('Expected "if" keyword to be a schema');
      var ifValid = testSchemaNoThrow.call(this, instance, options, ctx, null, schema.if);
      var result = new ValidatorResult(instance, schema, options, ctx);
      var res;
      if (ifValid) {
        if (schema.then === void 0)
          return;
        if (!helpers.isSchema(schema.then))
          throw new Error('Expected "then" keyword to be a schema');
        res = this.validateSchema(instance, schema.then, options, ctx.makeChild(schema.then));
        result.importErrors(res);
      } else {
        if (schema.else === void 0)
          return;
        if (!helpers.isSchema(schema.else))
          throw new Error('Expected "else" keyword to be a schema');
        res = this.validateSchema(instance, schema.else, options, ctx.makeChild(schema.else));
        result.importErrors(res);
      }
      return result;
    };
    function getEnumerableProperty(object, key) {
      if (Object.hasOwnProperty.call(object, key))
        return object[key];
      if (!(key in object))
        return;
      while (object = Object.getPrototypeOf(object)) {
        if (Object.propertyIsEnumerable.call(object, key))
          return object[key];
      }
    }
    validators.propertyNames = function validatePropertyNames(instance, schema, options, ctx) {
      if (!this.types.object(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      var subschema = schema.propertyNames !== void 0 ? schema.propertyNames : {};
      if (!helpers.isSchema(subschema))
        throw new SchemaError('Expected "propertyNames" to be a schema (object or boolean)');
      for (var property in instance) {
        if (getEnumerableProperty(instance, property) !== void 0) {
          var res = this.validateSchema(property, subschema, options, ctx.makeChild(subschema));
          result.importErrors(res);
        }
      }
      return result;
    };
    validators.properties = function validateProperties(instance, schema, options, ctx) {
      if (!this.types.object(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      var properties = schema.properties || {};
      for (var property in properties) {
        var subschema = properties[property];
        if (subschema === void 0) {
          continue;
        } else if (subschema === null) {
          throw new SchemaError('Unexpected null, expected schema in "properties"');
        }
        if (typeof options.preValidateProperty == "function") {
          options.preValidateProperty(instance, property, subschema, options, ctx);
        }
        var prop = getEnumerableProperty(instance, property);
        var res = this.validateSchema(prop, subschema, options, ctx.makeChild(subschema, property));
        if (res.instance !== result.instance[property])
          result.instance[property] = res.instance;
        result.importErrors(res);
      }
      return result;
    };
    function testAdditionalProperty(instance, schema, options, ctx, property, result) {
      if (!this.types.object(instance))
        return;
      if (schema.properties && schema.properties[property] !== void 0) {
        return;
      }
      if (schema.additionalProperties === false) {
        result.addError({
          name: "additionalProperties",
          argument: property,
          message: "is not allowed to have the additional property " + JSON.stringify(property)
        });
      } else {
        var additionalProperties = schema.additionalProperties || {};
        if (typeof options.preValidateProperty == "function") {
          options.preValidateProperty(instance, property, additionalProperties, options, ctx);
        }
        var res = this.validateSchema(instance[property], additionalProperties, options, ctx.makeChild(additionalProperties, property));
        if (res.instance !== result.instance[property])
          result.instance[property] = res.instance;
        result.importErrors(res);
      }
    }
    validators.patternProperties = function validatePatternProperties(instance, schema, options, ctx) {
      if (!this.types.object(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      var patternProperties = schema.patternProperties || {};
      for (var property in instance) {
        var test = true;
        for (var pattern in patternProperties) {
          var subschema = patternProperties[pattern];
          if (subschema === void 0) {
            continue;
          } else if (subschema === null) {
            throw new SchemaError('Unexpected null, expected schema in "patternProperties"');
          }
          try {
            var regexp = new RegExp(pattern, "u");
          } catch (_e) {
            regexp = new RegExp(pattern);
          }
          if (!regexp.test(property)) {
            continue;
          }
          test = false;
          if (typeof options.preValidateProperty == "function") {
            options.preValidateProperty(instance, property, subschema, options, ctx);
          }
          var res = this.validateSchema(instance[property], subschema, options, ctx.makeChild(subschema, property));
          if (res.instance !== result.instance[property])
            result.instance[property] = res.instance;
          result.importErrors(res);
        }
        if (test) {
          testAdditionalProperty.call(this, instance, schema, options, ctx, property, result);
        }
      }
      return result;
    };
    validators.additionalProperties = function validateAdditionalProperties(instance, schema, options, ctx) {
      if (!this.types.object(instance))
        return;
      if (schema.patternProperties) {
        return null;
      }
      var result = new ValidatorResult(instance, schema, options, ctx);
      for (var property in instance) {
        testAdditionalProperty.call(this, instance, schema, options, ctx, property, result);
      }
      return result;
    };
    validators.minProperties = function validateMinProperties(instance, schema, options, ctx) {
      if (!this.types.object(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      var keys = Object.keys(instance);
      if (!(keys.length >= schema.minProperties)) {
        result.addError({
          name: "minProperties",
          argument: schema.minProperties,
          message: "does not meet minimum property length of " + schema.minProperties
        });
      }
      return result;
    };
    validators.maxProperties = function validateMaxProperties(instance, schema, options, ctx) {
      if (!this.types.object(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      var keys = Object.keys(instance);
      if (!(keys.length <= schema.maxProperties)) {
        result.addError({
          name: "maxProperties",
          argument: schema.maxProperties,
          message: "does not meet maximum property length of " + schema.maxProperties
        });
      }
      return result;
    };
    validators.items = function validateItems(instance, schema, options, ctx) {
      var self2 = this;
      if (!this.types.array(instance))
        return;
      if (schema.items === void 0)
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      instance.every(function(value, i) {
        if (Array.isArray(schema.items)) {
          var items = schema.items[i] === void 0 ? schema.additionalItems : schema.items[i];
        } else {
          var items = schema.items;
        }
        if (items === void 0) {
          return true;
        }
        if (items === false) {
          result.addError({
            name: "items",
            message: "additionalItems not permitted"
          });
          return false;
        }
        var res = self2.validateSchema(value, items, options, ctx.makeChild(items, i));
        if (res.instance !== result.instance[i])
          result.instance[i] = res.instance;
        result.importErrors(res);
        return true;
      });
      return result;
    };
    validators.contains = function validateContains(instance, schema, options, ctx) {
      var self2 = this;
      if (!this.types.array(instance))
        return;
      if (schema.contains === void 0)
        return;
      if (!helpers.isSchema(schema.contains))
        throw new Error('Expected "contains" keyword to be a schema');
      var result = new ValidatorResult(instance, schema, options, ctx);
      var count = instance.some(function(value, i) {
        var res = self2.validateSchema(value, schema.contains, options, ctx.makeChild(schema.contains, i));
        return res.errors.length === 0;
      });
      if (count === false) {
        result.addError({
          name: "contains",
          argument: schema.contains,
          message: "must contain an item matching given schema"
        });
      }
      return result;
    };
    validators.minimum = function validateMinimum(instance, schema, options, ctx) {
      if (!this.types.number(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      if (schema.exclusiveMinimum && schema.exclusiveMinimum === true) {
        if (!(instance > schema.minimum)) {
          result.addError({
            name: "minimum",
            argument: schema.minimum,
            message: "must be greater than " + schema.minimum
          });
        }
      } else {
        if (!(instance >= schema.minimum)) {
          result.addError({
            name: "minimum",
            argument: schema.minimum,
            message: "must be greater than or equal to " + schema.minimum
          });
        }
      }
      return result;
    };
    validators.maximum = function validateMaximum(instance, schema, options, ctx) {
      if (!this.types.number(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      if (schema.exclusiveMaximum && schema.exclusiveMaximum === true) {
        if (!(instance < schema.maximum)) {
          result.addError({
            name: "maximum",
            argument: schema.maximum,
            message: "must be less than " + schema.maximum
          });
        }
      } else {
        if (!(instance <= schema.maximum)) {
          result.addError({
            name: "maximum",
            argument: schema.maximum,
            message: "must be less than or equal to " + schema.maximum
          });
        }
      }
      return result;
    };
    validators.exclusiveMinimum = function validateExclusiveMinimum(instance, schema, options, ctx) {
      if (typeof schema.exclusiveMinimum === "boolean")
        return;
      if (!this.types.number(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      var valid = instance > schema.exclusiveMinimum;
      if (!valid) {
        result.addError({
          name: "exclusiveMinimum",
          argument: schema.exclusiveMinimum,
          message: "must be strictly greater than " + schema.exclusiveMinimum
        });
      }
      return result;
    };
    validators.exclusiveMaximum = function validateExclusiveMaximum(instance, schema, options, ctx) {
      if (typeof schema.exclusiveMaximum === "boolean")
        return;
      if (!this.types.number(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      var valid = instance < schema.exclusiveMaximum;
      if (!valid) {
        result.addError({
          name: "exclusiveMaximum",
          argument: schema.exclusiveMaximum,
          message: "must be strictly less than " + schema.exclusiveMaximum
        });
      }
      return result;
    };
    var validateMultipleOfOrDivisbleBy = function validateMultipleOfOrDivisbleBy2(instance, schema, options, ctx, validationType, errorMessage) {
      if (!this.types.number(instance))
        return;
      var validationArgument = schema[validationType];
      if (validationArgument == 0) {
        throw new SchemaError(validationType + " cannot be zero");
      }
      var result = new ValidatorResult(instance, schema, options, ctx);
      var instanceDecimals = helpers.getDecimalPlaces(instance);
      var divisorDecimals = helpers.getDecimalPlaces(validationArgument);
      var maxDecimals = Math.max(instanceDecimals, divisorDecimals);
      var multiplier = Math.pow(10, maxDecimals);
      if (Math.round(instance * multiplier) % Math.round(validationArgument * multiplier) !== 0) {
        result.addError({
          name: validationType,
          argument: validationArgument,
          message: errorMessage + JSON.stringify(validationArgument)
        });
      }
      return result;
    };
    validators.multipleOf = function validateMultipleOf(instance, schema, options, ctx) {
      return validateMultipleOfOrDivisbleBy.call(this, instance, schema, options, ctx, "multipleOf", "is not a multiple of (divisible by) ");
    };
    validators.divisibleBy = function validateDivisibleBy(instance, schema, options, ctx) {
      return validateMultipleOfOrDivisbleBy.call(this, instance, schema, options, ctx, "divisibleBy", "is not divisible by (multiple of) ");
    };
    validators.required = function validateRequired(instance, schema, options, ctx) {
      var result = new ValidatorResult(instance, schema, options, ctx);
      if (instance === void 0 && schema.required === true) {
        result.addError({
          name: "required",
          message: "is required"
        });
      } else if (this.types.object(instance) && Array.isArray(schema.required)) {
        schema.required.forEach(function(n) {
          if (getEnumerableProperty(instance, n) === void 0) {
            result.addError({
              name: "required",
              argument: n,
              message: "requires property " + JSON.stringify(n)
            });
          }
        });
      }
      return result;
    };
    validators.pattern = function validatePattern(instance, schema, options, ctx) {
      if (!this.types.string(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      var pattern = schema.pattern;
      try {
        var regexp = new RegExp(pattern, "u");
      } catch (_e) {
        regexp = new RegExp(pattern);
      }
      if (!instance.match(regexp)) {
        result.addError({
          name: "pattern",
          argument: schema.pattern,
          message: "does not match pattern " + JSON.stringify(schema.pattern.toString())
        });
      }
      return result;
    };
    validators.format = function validateFormat(instance, schema, options, ctx) {
      if (instance === void 0)
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      if (!result.disableFormat && !helpers.isFormat(instance, schema.format, this)) {
        result.addError({
          name: "format",
          argument: schema.format,
          message: "does not conform to the " + JSON.stringify(schema.format) + " format"
        });
      }
      return result;
    };
    validators.minLength = function validateMinLength(instance, schema, options, ctx) {
      if (!this.types.string(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      var hsp = instance.match(/[\uDC00-\uDFFF]/g);
      var length = instance.length - (hsp ? hsp.length : 0);
      if (!(length >= schema.minLength)) {
        result.addError({
          name: "minLength",
          argument: schema.minLength,
          message: "does not meet minimum length of " + schema.minLength
        });
      }
      return result;
    };
    validators.maxLength = function validateMaxLength(instance, schema, options, ctx) {
      if (!this.types.string(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      var hsp = instance.match(/[\uDC00-\uDFFF]/g);
      var length = instance.length - (hsp ? hsp.length : 0);
      if (!(length <= schema.maxLength)) {
        result.addError({
          name: "maxLength",
          argument: schema.maxLength,
          message: "does not meet maximum length of " + schema.maxLength
        });
      }
      return result;
    };
    validators.minItems = function validateMinItems(instance, schema, options, ctx) {
      if (!this.types.array(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      if (!(instance.length >= schema.minItems)) {
        result.addError({
          name: "minItems",
          argument: schema.minItems,
          message: "does not meet minimum length of " + schema.minItems
        });
      }
      return result;
    };
    validators.maxItems = function validateMaxItems(instance, schema, options, ctx) {
      if (!this.types.array(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      if (!(instance.length <= schema.maxItems)) {
        result.addError({
          name: "maxItems",
          argument: schema.maxItems,
          message: "does not meet maximum length of " + schema.maxItems
        });
      }
      return result;
    };
    function testArrays(v, i, a) {
      var j, len = a.length;
      for (j = i + 1, len; j < len; j++) {
        if (helpers.deepCompareStrict(v, a[j])) {
          return false;
        }
      }
      return true;
    }
    validators.uniqueItems = function validateUniqueItems(instance, schema, options, ctx) {
      if (schema.uniqueItems !== true)
        return;
      if (!this.types.array(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      if (!instance.every(testArrays)) {
        result.addError({
          name: "uniqueItems",
          message: "contains duplicate item"
        });
      }
      return result;
    };
    validators.dependencies = function validateDependencies(instance, schema, options, ctx) {
      if (!this.types.object(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      for (var property in schema.dependencies) {
        if (instance[property] === void 0) {
          continue;
        }
        var dep = schema.dependencies[property];
        var childContext = ctx.makeChild(dep, property);
        if (typeof dep == "string") {
          dep = [dep];
        }
        if (Array.isArray(dep)) {
          dep.forEach(function(prop) {
            if (instance[prop] === void 0) {
              result.addError({
                // FIXME there's two different "dependencies" errors here with slightly different outputs
                // Can we make these the same? Or should we create different error types?
                name: "dependencies",
                argument: childContext.propertyPath,
                message: "property " + prop + " not found, required by " + childContext.propertyPath
              });
            }
          });
        } else {
          var res = this.validateSchema(instance, dep, options, childContext);
          if (result.instance !== res.instance)
            result.instance = res.instance;
          if (res && res.errors.length) {
            result.addError({
              name: "dependencies",
              argument: childContext.propertyPath,
              message: "does not meet dependency required by " + childContext.propertyPath
            });
            result.importErrors(res);
          }
        }
      }
      return result;
    };
    validators["enum"] = function validateEnum(instance, schema, options, ctx) {
      if (instance === void 0) {
        return null;
      }
      if (!Array.isArray(schema["enum"])) {
        throw new SchemaError("enum expects an array", schema);
      }
      var result = new ValidatorResult(instance, schema, options, ctx);
      if (!schema["enum"].some(helpers.deepCompareStrict.bind(null, instance))) {
        result.addError({
          name: "enum",
          argument: schema["enum"],
          message: "is not one of enum values: " + schema["enum"].map(String).join(",")
        });
      }
      return result;
    };
    validators["const"] = function validateEnum(instance, schema, options, ctx) {
      if (instance === void 0) {
        return null;
      }
      var result = new ValidatorResult(instance, schema, options, ctx);
      if (!helpers.deepCompareStrict(schema["const"], instance)) {
        result.addError({
          name: "const",
          argument: schema["const"],
          message: "does not exactly match expected constant: " + schema["const"]
        });
      }
      return result;
    };
    validators.not = validators.disallow = function validateNot(instance, schema, options, ctx) {
      var self2 = this;
      if (instance === void 0)
        return null;
      var result = new ValidatorResult(instance, schema, options, ctx);
      var notTypes = schema.not || schema.disallow;
      if (!notTypes)
        return null;
      if (!Array.isArray(notTypes))
        notTypes = [notTypes];
      notTypes.forEach(function(type) {
        if (self2.testType(instance, schema, options, ctx, type)) {
          var id = type && (type.$id || type.id);
          var schemaId = id || type;
          result.addError({
            name: "not",
            argument: schemaId,
            message: "is of prohibited type " + schemaId
          });
        }
      });
      return result;
    };
    module2.exports = attribute;
  }
});

// node_modules/aws-cdk-lib/node_modules/jsonschema/lib/scan.js
var require_scan = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/jsonschema/lib/scan.js"(exports2, module2) {
    "use strict";
    var urilib = require("url");
    var helpers = require_helpers2();
    module2.exports.SchemaScanResult = SchemaScanResult;
    function SchemaScanResult(found, ref) {
      this.id = found;
      this.ref = ref;
    }
    module2.exports.scan = function scan(base, schema) {
      function scanSchema(baseuri, schema2) {
        if (!schema2 || typeof schema2 != "object")
          return;
        if (schema2.$ref) {
          var resolvedUri = urilib.resolve(baseuri, schema2.$ref);
          ref[resolvedUri] = ref[resolvedUri] ? ref[resolvedUri] + 1 : 0;
          return;
        }
        var id = schema2.$id || schema2.id;
        var ourBase = id ? urilib.resolve(baseuri, id) : baseuri;
        if (ourBase) {
          if (ourBase.indexOf("#") < 0)
            ourBase += "#";
          if (found[ourBase]) {
            if (!helpers.deepCompareStrict(found[ourBase], schema2)) {
              throw new Error("Schema <" + ourBase + "> already exists with different definition");
            }
            return found[ourBase];
          }
          found[ourBase] = schema2;
          if (ourBase[ourBase.length - 1] == "#") {
            found[ourBase.substring(0, ourBase.length - 1)] = schema2;
          }
        }
        scanArray(ourBase + "/items", Array.isArray(schema2.items) ? schema2.items : [schema2.items]);
        scanArray(ourBase + "/extends", Array.isArray(schema2.extends) ? schema2.extends : [schema2.extends]);
        scanSchema(ourBase + "/additionalItems", schema2.additionalItems);
        scanObject(ourBase + "/properties", schema2.properties);
        scanSchema(ourBase + "/additionalProperties", schema2.additionalProperties);
        scanObject(ourBase + "/definitions", schema2.definitions);
        scanObject(ourBase + "/patternProperties", schema2.patternProperties);
        scanObject(ourBase + "/dependencies", schema2.dependencies);
        scanArray(ourBase + "/disallow", schema2.disallow);
        scanArray(ourBase + "/allOf", schema2.allOf);
        scanArray(ourBase + "/anyOf", schema2.anyOf);
        scanArray(ourBase + "/oneOf", schema2.oneOf);
        scanSchema(ourBase + "/not", schema2.not);
      }
      function scanArray(baseuri, schemas) {
        if (!Array.isArray(schemas))
          return;
        for (var i = 0; i < schemas.length; i++) {
          scanSchema(baseuri + "/" + i, schemas[i]);
        }
      }
      function scanObject(baseuri, schemas) {
        if (!schemas || typeof schemas != "object")
          return;
        for (var p in schemas) {
          scanSchema(baseuri + "/" + p, schemas[p]);
        }
      }
      var found = {};
      var ref = {};
      scanSchema(base, schema);
      return new SchemaScanResult(found, ref);
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/jsonschema/lib/validator.js
var require_validator = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/jsonschema/lib/validator.js"(exports2, module2) {
    "use strict";
    var urilib = require("url");
    var attribute = require_attribute();
    var helpers = require_helpers2();
    var scanSchema = require_scan().scan;
    var ValidatorResult = helpers.ValidatorResult;
    var ValidatorResultError = helpers.ValidatorResultError;
    var SchemaError = helpers.SchemaError;
    var SchemaContext = helpers.SchemaContext;
    var anonymousBase = "/";
    var Validator = function Validator2() {
      this.customFormats = Object.create(Validator2.prototype.customFormats);
      this.schemas = {};
      this.unresolvedRefs = [];
      this.types = Object.create(types);
      this.attributes = Object.create(attribute.validators);
    };
    Validator.prototype.customFormats = {};
    Validator.prototype.schemas = null;
    Validator.prototype.types = null;
    Validator.prototype.attributes = null;
    Validator.prototype.unresolvedRefs = null;
    Validator.prototype.addSchema = function addSchema(schema, base) {
      var self2 = this;
      if (!schema) {
        return null;
      }
      var scan = scanSchema(base || anonymousBase, schema);
      var ourUri = base || schema.$id || schema.id;
      for (var uri in scan.id) {
        this.schemas[uri] = scan.id[uri];
      }
      for (var uri in scan.ref) {
        this.unresolvedRefs.push(uri);
      }
      this.unresolvedRefs = this.unresolvedRefs.filter(function(uri2) {
        return typeof self2.schemas[uri2] === "undefined";
      });
      return this.schemas[ourUri];
    };
    Validator.prototype.addSubSchemaArray = function addSubSchemaArray(baseuri, schemas) {
      if (!Array.isArray(schemas))
        return;
      for (var i = 0; i < schemas.length; i++) {
        this.addSubSchema(baseuri, schemas[i]);
      }
    };
    Validator.prototype.addSubSchemaObject = function addSubSchemaArray(baseuri, schemas) {
      if (!schemas || typeof schemas != "object")
        return;
      for (var p in schemas) {
        this.addSubSchema(baseuri, schemas[p]);
      }
    };
    Validator.prototype.setSchemas = function setSchemas(schemas) {
      this.schemas = schemas;
    };
    Validator.prototype.getSchema = function getSchema(urn) {
      return this.schemas[urn];
    };
    Validator.prototype.validate = function validate(instance, schema, options, ctx) {
      if (typeof schema !== "boolean" && typeof schema !== "object" || schema === null) {
        throw new SchemaError("Expected `schema` to be an object or boolean");
      }
      if (!options) {
        options = {};
      }
      var id = schema.$id || schema.id;
      var base = urilib.resolve(options.base || anonymousBase, id || "");
      if (!ctx) {
        ctx = new SchemaContext(schema, options, [], base, Object.create(this.schemas));
        if (!ctx.schemas[base]) {
          ctx.schemas[base] = schema;
        }
        var found = scanSchema(base, schema);
        for (var n in found.id) {
          var sch = found.id[n];
          ctx.schemas[n] = sch;
        }
      }
      if (options.required && instance === void 0) {
        var result = new ValidatorResult(instance, schema, options, ctx);
        result.addError("is required, but is undefined");
        return result;
      }
      var result = this.validateSchema(instance, schema, options, ctx);
      if (!result) {
        throw new Error("Result undefined");
      } else if (options.throwAll && result.errors.length) {
        throw new ValidatorResultError(result);
      }
      return result;
    };
    function shouldResolve(schema) {
      var ref = typeof schema === "string" ? schema : schema.$ref;
      if (typeof ref == "string")
        return ref;
      return false;
    }
    Validator.prototype.validateSchema = function validateSchema(instance, schema, options, ctx) {
      var result = new ValidatorResult(instance, schema, options, ctx);
      if (typeof schema === "boolean") {
        if (schema === true) {
          schema = {};
        } else if (schema === false) {
          schema = { type: [] };
        }
      } else if (!schema) {
        throw new Error("schema is undefined");
      }
      if (schema["extends"]) {
        if (Array.isArray(schema["extends"])) {
          var schemaobj = { schema, ctx };
          schema["extends"].forEach(this.schemaTraverser.bind(this, schemaobj));
          schema = schemaobj.schema;
          schemaobj.schema = null;
          schemaobj.ctx = null;
          schemaobj = null;
        } else {
          schema = helpers.deepMerge(schema, this.superResolve(schema["extends"], ctx));
        }
      }
      var switchSchema = shouldResolve(schema);
      if (switchSchema) {
        var resolved = this.resolve(schema, switchSchema, ctx);
        var subctx = new SchemaContext(resolved.subschema, options, ctx.path, resolved.switchSchema, ctx.schemas);
        return this.validateSchema(instance, resolved.subschema, options, subctx);
      }
      var skipAttributes = options && options.skipAttributes || [];
      for (var key in schema) {
        if (!attribute.ignoreProperties[key] && skipAttributes.indexOf(key) < 0) {
          var validatorErr = null;
          var validator = this.attributes[key];
          if (validator) {
            validatorErr = validator.call(this, instance, schema, options, ctx);
          } else if (options.allowUnknownAttributes === false) {
            throw new SchemaError("Unsupported attribute: " + key, schema);
          }
          if (validatorErr) {
            result.importErrors(validatorErr);
          }
        }
      }
      if (typeof options.rewrite == "function") {
        var value = options.rewrite.call(this, instance, schema, options, ctx);
        result.instance = value;
      }
      return result;
    };
    Validator.prototype.schemaTraverser = function schemaTraverser(schemaobj, s) {
      schemaobj.schema = helpers.deepMerge(schemaobj.schema, this.superResolve(s, schemaobj.ctx));
    };
    Validator.prototype.superResolve = function superResolve(schema, ctx) {
      var ref = shouldResolve(schema);
      if (ref) {
        return this.resolve(schema, ref, ctx).subschema;
      }
      return schema;
    };
    Validator.prototype.resolve = function resolve(schema, switchSchema, ctx) {
      switchSchema = ctx.resolve(switchSchema);
      if (ctx.schemas[switchSchema]) {
        return { subschema: ctx.schemas[switchSchema], switchSchema };
      }
      var parsed = urilib.parse(switchSchema);
      var fragment = parsed && parsed.hash;
      var document = fragment && fragment.length && switchSchema.substr(0, switchSchema.length - fragment.length);
      if (!document || !ctx.schemas[document]) {
        throw new SchemaError("no such schema <" + switchSchema + ">", schema);
      }
      var subschema = helpers.objectGetPath(ctx.schemas[document], fragment.substr(1));
      if (subschema === void 0) {
        throw new SchemaError("no such schema " + fragment + " located in <" + document + ">", schema);
      }
      return { subschema, switchSchema };
    };
    Validator.prototype.testType = function validateType(instance, schema, options, ctx, type) {
      if (type === void 0) {
        return;
      } else if (type === null) {
        throw new SchemaError('Unexpected null in "type" keyword');
      }
      if (typeof this.types[type] == "function") {
        return this.types[type].call(this, instance);
      }
      if (type && typeof type == "object") {
        var res = this.validateSchema(instance, type, options, ctx);
        return res === void 0 || !(res && res.errors.length);
      }
      return true;
    };
    var types = Validator.prototype.types = {};
    types.string = function testString(instance) {
      return typeof instance == "string";
    };
    types.number = function testNumber(instance) {
      return typeof instance == "number" && isFinite(instance);
    };
    types.integer = function testInteger(instance) {
      return typeof instance == "number" && instance % 1 === 0;
    };
    types.boolean = function testBoolean(instance) {
      return typeof instance == "boolean";
    };
    types.array = function testArray(instance) {
      return Array.isArray(instance);
    };
    types["null"] = function testNull(instance) {
      return instance === null;
    };
    types.date = function testDate(instance) {
      return instance instanceof Date;
    };
    types.any = function testAny(instance) {
      return true;
    };
    types.object = function testObject(instance) {
      return instance && typeof instance === "object" && !Array.isArray(instance) && !(instance instanceof Date);
    };
    module2.exports = Validator;
  }
});

// node_modules/aws-cdk-lib/node_modules/jsonschema/lib/index.js
var require_lib3 = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/jsonschema/lib/index.js"(exports2, module2) {
    "use strict";
    var Validator = module2.exports.Validator = require_validator();
    module2.exports.ValidatorResult = require_helpers2().ValidatorResult;
    module2.exports.ValidatorResultError = require_helpers2().ValidatorResultError;
    module2.exports.ValidationError = require_helpers2().ValidationError;
    module2.exports.SchemaError = require_helpers2().SchemaError;
    module2.exports.SchemaScanResult = require_scan().SchemaScanResult;
    module2.exports.scan = require_scan().scan;
    module2.exports.validate = function(instance, schema, options) {
      var v = new Validator();
      return v.validate(instance, schema, options);
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/internal/constants.js
var require_constants = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/internal/constants.js"(exports2, module2) {
    "use strict";
    var SEMVER_SPEC_VERSION = "2.0.0";
    var MAX_LENGTH = 256;
    var MAX_SAFE_INTEGER = Number.MAX_SAFE_INTEGER || /* istanbul ignore next */
    9007199254740991;
    var MAX_SAFE_COMPONENT_LENGTH = 16;
    var RELEASE_TYPES = [
      "major",
      "premajor",
      "minor",
      "preminor",
      "patch",
      "prepatch",
      "prerelease"
    ];
    module2.exports = {
      MAX_LENGTH,
      MAX_SAFE_COMPONENT_LENGTH,
      MAX_SAFE_INTEGER,
      RELEASE_TYPES,
      SEMVER_SPEC_VERSION,
      FLAG_INCLUDE_PRERELEASE: 1,
      FLAG_LOOSE: 2
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/internal/debug.js
var require_debug = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/internal/debug.js"(exports2, module2) {
    "use strict";
    var debug = typeof process === "object" && process.env && process.env.NODE_DEBUG && /\bsemver\b/i.test(process.env.NODE_DEBUG) ? (...args) => console.error("SEMVER", ...args) : () => {
    };
    module2.exports = debug;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/internal/re.js
var require_re = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/internal/re.js"(exports2, module2) {
    "use strict";
    var { MAX_SAFE_COMPONENT_LENGTH } = require_constants();
    var debug = require_debug();
    exports2 = module2.exports = {};
    var re = exports2.re = [];
    var src = exports2.src = [];
    var t = exports2.t = {};
    var R = 0;
    var createToken = (name, value, isGlobal) => {
      const index = R++;
      debug(name, index, value);
      t[name] = index;
      src[index] = value;
      re[index] = new RegExp(value, isGlobal ? "g" : void 0);
    };
    createToken("NUMERICIDENTIFIER", "0|[1-9]\\d*");
    createToken("NUMERICIDENTIFIERLOOSE", "[0-9]+");
    createToken("NONNUMERICIDENTIFIER", "\\d*[a-zA-Z-][a-zA-Z0-9-]*");
    createToken("MAINVERSION", `(${src[t.NUMERICIDENTIFIER]})\\.(${src[t.NUMERICIDENTIFIER]})\\.(${src[t.NUMERICIDENTIFIER]})`);
    createToken("MAINVERSIONLOOSE", `(${src[t.NUMERICIDENTIFIERLOOSE]})\\.(${src[t.NUMERICIDENTIFIERLOOSE]})\\.(${src[t.NUMERICIDENTIFIERLOOSE]})`);
    createToken("PRERELEASEIDENTIFIER", `(?:${src[t.NUMERICIDENTIFIER]}|${src[t.NONNUMERICIDENTIFIER]})`);
    createToken("PRERELEASEIDENTIFIERLOOSE", `(?:${src[t.NUMERICIDENTIFIERLOOSE]}|${src[t.NONNUMERICIDENTIFIER]})`);
    createToken("PRERELEASE", `(?:-(${src[t.PRERELEASEIDENTIFIER]}(?:\\.${src[t.PRERELEASEIDENTIFIER]})*))`);
    createToken("PRERELEASELOOSE", `(?:-?(${src[t.PRERELEASEIDENTIFIERLOOSE]}(?:\\.${src[t.PRERELEASEIDENTIFIERLOOSE]})*))`);
    createToken("BUILDIDENTIFIER", "[0-9A-Za-z-]+");
    createToken("BUILD", `(?:\\+(${src[t.BUILDIDENTIFIER]}(?:\\.${src[t.BUILDIDENTIFIER]})*))`);
    createToken("FULLPLAIN", `v?${src[t.MAINVERSION]}${src[t.PRERELEASE]}?${src[t.BUILD]}?`);
    createToken("FULL", `^${src[t.FULLPLAIN]}$`);
    createToken("LOOSEPLAIN", `[v=\\s]*${src[t.MAINVERSIONLOOSE]}${src[t.PRERELEASELOOSE]}?${src[t.BUILD]}?`);
    createToken("LOOSE", `^${src[t.LOOSEPLAIN]}$`);
    createToken("GTLT", "((?:<|>)?=?)");
    createToken("XRANGEIDENTIFIERLOOSE", `${src[t.NUMERICIDENTIFIERLOOSE]}|x|X|\\*`);
    createToken("XRANGEIDENTIFIER", `${src[t.NUMERICIDENTIFIER]}|x|X|\\*`);
    createToken("XRANGEPLAIN", `[v=\\s]*(${src[t.XRANGEIDENTIFIER]})(?:\\.(${src[t.XRANGEIDENTIFIER]})(?:\\.(${src[t.XRANGEIDENTIFIER]})(?:${src[t.PRERELEASE]})?${src[t.BUILD]}?)?)?`);
    createToken("XRANGEPLAINLOOSE", `[v=\\s]*(${src[t.XRANGEIDENTIFIERLOOSE]})(?:\\.(${src[t.XRANGEIDENTIFIERLOOSE]})(?:\\.(${src[t.XRANGEIDENTIFIERLOOSE]})(?:${src[t.PRERELEASELOOSE]})?${src[t.BUILD]}?)?)?`);
    createToken("XRANGE", `^${src[t.GTLT]}\\s*${src[t.XRANGEPLAIN]}$`);
    createToken("XRANGELOOSE", `^${src[t.GTLT]}\\s*${src[t.XRANGEPLAINLOOSE]}$`);
    createToken("COERCE", `${"(^|[^\\d])(\\d{1,"}${MAX_SAFE_COMPONENT_LENGTH}})(?:\\.(\\d{1,${MAX_SAFE_COMPONENT_LENGTH}}))?(?:\\.(\\d{1,${MAX_SAFE_COMPONENT_LENGTH}}))?(?:$|[^\\d])`);
    createToken("COERCERTL", src[t.COERCE], true);
    createToken("LONETILDE", "(?:~>?)");
    createToken("TILDETRIM", `(\\s*)${src[t.LONETILDE]}\\s+`, true);
    exports2.tildeTrimReplace = "$1~";
    createToken("TILDE", `^${src[t.LONETILDE]}${src[t.XRANGEPLAIN]}$`);
    createToken("TILDELOOSE", `^${src[t.LONETILDE]}${src[t.XRANGEPLAINLOOSE]}$`);
    createToken("LONECARET", "(?:\\^)");
    createToken("CARETTRIM", `(\\s*)${src[t.LONECARET]}\\s+`, true);
    exports2.caretTrimReplace = "$1^";
    createToken("CARET", `^${src[t.LONECARET]}${src[t.XRANGEPLAIN]}$`);
    createToken("CARETLOOSE", `^${src[t.LONECARET]}${src[t.XRANGEPLAINLOOSE]}$`);
    createToken("COMPARATORLOOSE", `^${src[t.GTLT]}\\s*(${src[t.LOOSEPLAIN]})$|^$`);
    createToken("COMPARATOR", `^${src[t.GTLT]}\\s*(${src[t.FULLPLAIN]})$|^$`);
    createToken("COMPARATORTRIM", `(\\s*)${src[t.GTLT]}\\s*(${src[t.LOOSEPLAIN]}|${src[t.XRANGEPLAIN]})`, true);
    exports2.comparatorTrimReplace = "$1$2$3";
    createToken("HYPHENRANGE", `^\\s*(${src[t.XRANGEPLAIN]})\\s+-\\s+(${src[t.XRANGEPLAIN]})\\s*$`);
    createToken("HYPHENRANGELOOSE", `^\\s*(${src[t.XRANGEPLAINLOOSE]})\\s+-\\s+(${src[t.XRANGEPLAINLOOSE]})\\s*$`);
    createToken("STAR", "(<|>)?=?\\s*\\*");
    createToken("GTE0", "^\\s*>=\\s*0\\.0\\.0\\s*$");
    createToken("GTE0PRE", "^\\s*>=\\s*0\\.0\\.0-0\\s*$");
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/internal/parse-options.js
var require_parse_options = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/internal/parse-options.js"(exports2, module2) {
    "use strict";
    var looseOption = Object.freeze({ loose: true });
    var emptyOpts = Object.freeze({});
    var parseOptions = (options) => {
      if (!options) {
        return emptyOpts;
      }
      if (typeof options !== "object") {
        return looseOption;
      }
      return options;
    };
    module2.exports = parseOptions;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/internal/identifiers.js
var require_identifiers = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/internal/identifiers.js"(exports2, module2) {
    "use strict";
    var numeric = /^[0-9]+$/;
    var compareIdentifiers = (a, b) => {
      const anum = numeric.test(a);
      const bnum = numeric.test(b);
      if (anum && bnum) {
        a = +a;
        b = +b;
      }
      return a === b ? 0 : anum && !bnum ? -1 : bnum && !anum ? 1 : a < b ? -1 : 1;
    };
    var rcompareIdentifiers = (a, b) => compareIdentifiers(b, a);
    module2.exports = {
      compareIdentifiers,
      rcompareIdentifiers
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/classes/semver.js
var require_semver = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/classes/semver.js"(exports2, module2) {
    "use strict";
    var debug = require_debug();
    var { MAX_LENGTH, MAX_SAFE_INTEGER } = require_constants();
    var { re, t } = require_re();
    var parseOptions = require_parse_options();
    var { compareIdentifiers } = require_identifiers();
    var SemVer = class _SemVer {
      constructor(version, options) {
        options = parseOptions(options);
        if (version instanceof _SemVer) {
          if (version.loose === !!options.loose && version.includePrerelease === !!options.includePrerelease) {
            return version;
          } else {
            version = version.version;
          }
        } else if (typeof version !== "string") {
          throw new TypeError(`Invalid version. Must be a string. Got type "${typeof version}".`);
        }
        if (version.length > MAX_LENGTH) {
          throw new TypeError(
            `version is longer than ${MAX_LENGTH} characters`
          );
        }
        debug("SemVer", version, options);
        this.options = options;
        this.loose = !!options.loose;
        this.includePrerelease = !!options.includePrerelease;
        const m = version.trim().match(options.loose ? re[t.LOOSE] : re[t.FULL]);
        if (!m) {
          throw new TypeError(`Invalid Version: ${version}`);
        }
        this.raw = version;
        this.major = +m[1];
        this.minor = +m[2];
        this.patch = +m[3];
        if (this.major > MAX_SAFE_INTEGER || this.major < 0) {
          throw new TypeError("Invalid major version");
        }
        if (this.minor > MAX_SAFE_INTEGER || this.minor < 0) {
          throw new TypeError("Invalid minor version");
        }
        if (this.patch > MAX_SAFE_INTEGER || this.patch < 0) {
          throw new TypeError("Invalid patch version");
        }
        if (!m[4]) {
          this.prerelease = [];
        } else {
          this.prerelease = m[4].split(".").map((id) => {
            if (/^[0-9]+$/.test(id)) {
              const num = +id;
              if (num >= 0 && num < MAX_SAFE_INTEGER) {
                return num;
              }
            }
            return id;
          });
        }
        this.build = m[5] ? m[5].split(".") : [];
        this.format();
      }
      format() {
        this.version = `${this.major}.${this.minor}.${this.patch}`;
        if (this.prerelease.length) {
          this.version += `-${this.prerelease.join(".")}`;
        }
        return this.version;
      }
      toString() {
        return this.version;
      }
      compare(other) {
        debug("SemVer.compare", this.version, this.options, other);
        if (!(other instanceof _SemVer)) {
          if (typeof other === "string" && other === this.version) {
            return 0;
          }
          other = new _SemVer(other, this.options);
        }
        if (other.version === this.version) {
          return 0;
        }
        return this.compareMain(other) || this.comparePre(other);
      }
      compareMain(other) {
        if (!(other instanceof _SemVer)) {
          other = new _SemVer(other, this.options);
        }
        return compareIdentifiers(this.major, other.major) || compareIdentifiers(this.minor, other.minor) || compareIdentifiers(this.patch, other.patch);
      }
      comparePre(other) {
        if (!(other instanceof _SemVer)) {
          other = new _SemVer(other, this.options);
        }
        if (this.prerelease.length && !other.prerelease.length) {
          return -1;
        } else if (!this.prerelease.length && other.prerelease.length) {
          return 1;
        } else if (!this.prerelease.length && !other.prerelease.length) {
          return 0;
        }
        let i = 0;
        do {
          const a = this.prerelease[i];
          const b = other.prerelease[i];
          debug("prerelease compare", i, a, b);
          if (a === void 0 && b === void 0) {
            return 0;
          } else if (b === void 0) {
            return 1;
          } else if (a === void 0) {
            return -1;
          } else if (a === b) {
            continue;
          } else {
            return compareIdentifiers(a, b);
          }
        } while (++i);
      }
      compareBuild(other) {
        if (!(other instanceof _SemVer)) {
          other = new _SemVer(other, this.options);
        }
        let i = 0;
        do {
          const a = this.build[i];
          const b = other.build[i];
          debug("prerelease compare", i, a, b);
          if (a === void 0 && b === void 0) {
            return 0;
          } else if (b === void 0) {
            return 1;
          } else if (a === void 0) {
            return -1;
          } else if (a === b) {
            continue;
          } else {
            return compareIdentifiers(a, b);
          }
        } while (++i);
      }
      // preminor will bump the version up to the next minor release, and immediately
      // down to pre-release. premajor and prepatch work the same way.
      inc(release, identifier, identifierBase) {
        switch (release) {
          case "premajor":
            this.prerelease.length = 0;
            this.patch = 0;
            this.minor = 0;
            this.major++;
            this.inc("pre", identifier, identifierBase);
            break;
          case "preminor":
            this.prerelease.length = 0;
            this.patch = 0;
            this.minor++;
            this.inc("pre", identifier, identifierBase);
            break;
          case "prepatch":
            this.prerelease.length = 0;
            this.inc("patch", identifier, identifierBase);
            this.inc("pre", identifier, identifierBase);
            break;
          case "prerelease":
            if (this.prerelease.length === 0) {
              this.inc("patch", identifier, identifierBase);
            }
            this.inc("pre", identifier, identifierBase);
            break;
          case "major":
            if (this.minor !== 0 || this.patch !== 0 || this.prerelease.length === 0) {
              this.major++;
            }
            this.minor = 0;
            this.patch = 0;
            this.prerelease = [];
            break;
          case "minor":
            if (this.patch !== 0 || this.prerelease.length === 0) {
              this.minor++;
            }
            this.patch = 0;
            this.prerelease = [];
            break;
          case "patch":
            if (this.prerelease.length === 0) {
              this.patch++;
            }
            this.prerelease = [];
            break;
          case "pre": {
            const base = Number(identifierBase) ? 1 : 0;
            if (!identifier && identifierBase === false) {
              throw new Error("invalid increment argument: identifier is empty");
            }
            if (this.prerelease.length === 0) {
              this.prerelease = [base];
            } else {
              let i = this.prerelease.length;
              while (--i >= 0) {
                if (typeof this.prerelease[i] === "number") {
                  this.prerelease[i]++;
                  i = -2;
                }
              }
              if (i === -1) {
                if (identifier === this.prerelease.join(".") && identifierBase === false) {
                  throw new Error("invalid increment argument: identifier already exists");
                }
                this.prerelease.push(base);
              }
            }
            if (identifier) {
              let prerelease = [identifier, base];
              if (identifierBase === false) {
                prerelease = [identifier];
              }
              if (compareIdentifiers(this.prerelease[0], identifier) === 0) {
                if (isNaN(this.prerelease[1])) {
                  this.prerelease = prerelease;
                }
              } else {
                this.prerelease = prerelease;
              }
            }
            break;
          }
          default:
            throw new Error(`invalid increment argument: ${release}`);
        }
        this.format();
        this.raw = this.version;
        return this;
      }
    };
    module2.exports = SemVer;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/functions/parse.js
var require_parse = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/functions/parse.js"(exports2, module2) {
    "use strict";
    var SemVer = require_semver();
    var parse = (version, options, throwErrors = false) => {
      if (version instanceof SemVer) {
        return version;
      }
      try {
        return new SemVer(version, options);
      } catch (er) {
        if (!throwErrors) {
          return null;
        }
        throw er;
      }
    };
    module2.exports = parse;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/functions/valid.js
var require_valid = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/functions/valid.js"(exports2, module2) {
    "use strict";
    var parse = require_parse();
    var valid = (version, options) => {
      const v = parse(version, options);
      return v ? v.version : null;
    };
    module2.exports = valid;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/functions/clean.js
var require_clean = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/functions/clean.js"(exports2, module2) {
    "use strict";
    var parse = require_parse();
    var clean = (version, options) => {
      const s = parse(version.trim().replace(/^[=v]+/, ""), options);
      return s ? s.version : null;
    };
    module2.exports = clean;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/functions/inc.js
var require_inc = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/functions/inc.js"(exports2, module2) {
    "use strict";
    var SemVer = require_semver();
    var inc = (version, release, options, identifier, identifierBase) => {
      if (typeof options === "string") {
        identifierBase = identifier;
        identifier = options;
        options = void 0;
      }
      try {
        return new SemVer(
          version instanceof SemVer ? version.version : version,
          options
        ).inc(release, identifier, identifierBase).version;
      } catch (er) {
        return null;
      }
    };
    module2.exports = inc;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/functions/diff.js
var require_diff = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/functions/diff.js"(exports2, module2) {
    "use strict";
    var parse = require_parse();
    var diff = (version1, version2) => {
      const v1 = parse(version1, null, true);
      const v2 = parse(version2, null, true);
      const comparison = v1.compare(v2);
      if (comparison === 0) {
        return null;
      }
      const v1Higher = comparison > 0;
      const highVersion = v1Higher ? v1 : v2;
      const lowVersion = v1Higher ? v2 : v1;
      const highHasPre = !!highVersion.prerelease.length;
      const prefix = highHasPre ? "pre" : "";
      if (v1.major !== v2.major) {
        return prefix + "major";
      }
      if (v1.minor !== v2.minor) {
        return prefix + "minor";
      }
      if (v1.patch !== v2.patch) {
        return prefix + "patch";
      }
      if (highHasPre) {
        return "prerelease";
      }
      if (lowVersion.patch) {
        return "patch";
      }
      if (lowVersion.minor) {
        return "minor";
      }
      return "major";
    };
    module2.exports = diff;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/functions/major.js
var require_major = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/functions/major.js"(exports2, module2) {
    "use strict";
    var SemVer = require_semver();
    var major = (a, loose) => new SemVer(a, loose).major;
    module2.exports = major;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/functions/minor.js
var require_minor = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/functions/minor.js"(exports2, module2) {
    "use strict";
    var SemVer = require_semver();
    var minor = (a, loose) => new SemVer(a, loose).minor;
    module2.exports = minor;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/functions/patch.js
var require_patch = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/functions/patch.js"(exports2, module2) {
    "use strict";
    var SemVer = require_semver();
    var patch = (a, loose) => new SemVer(a, loose).patch;
    module2.exports = patch;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/functions/prerelease.js
var require_prerelease = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/functions/prerelease.js"(exports2, module2) {
    "use strict";
    var parse = require_parse();
    var prerelease = (version, options) => {
      const parsed = parse(version, options);
      return parsed && parsed.prerelease.length ? parsed.prerelease : null;
    };
    module2.exports = prerelease;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/functions/compare.js
var require_compare = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/functions/compare.js"(exports2, module2) {
    "use strict";
    var SemVer = require_semver();
    var compare = (a, b, loose) => new SemVer(a, loose).compare(new SemVer(b, loose));
    module2.exports = compare;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/functions/rcompare.js
var require_rcompare = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/functions/rcompare.js"(exports2, module2) {
    "use strict";
    var compare = require_compare();
    var rcompare = (a, b, loose) => compare(b, a, loose);
    module2.exports = rcompare;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/functions/compare-loose.js
var require_compare_loose = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/functions/compare-loose.js"(exports2, module2) {
    "use strict";
    var compare = require_compare();
    var compareLoose = (a, b) => compare(a, b, true);
    module2.exports = compareLoose;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/functions/compare-build.js
var require_compare_build = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/functions/compare-build.js"(exports2, module2) {
    "use strict";
    var SemVer = require_semver();
    var compareBuild = (a, b, loose) => {
      const versionA = new SemVer(a, loose);
      const versionB = new SemVer(b, loose);
      return versionA.compare(versionB) || versionA.compareBuild(versionB);
    };
    module2.exports = compareBuild;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/functions/sort.js
var require_sort = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/functions/sort.js"(exports2, module2) {
    "use strict";
    var compareBuild = require_compare_build();
    var sort = (list, loose) => list.sort((a, b) => compareBuild(a, b, loose));
    module2.exports = sort;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/functions/rsort.js
var require_rsort = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/functions/rsort.js"(exports2, module2) {
    "use strict";
    var compareBuild = require_compare_build();
    var rsort = (list, loose) => list.sort((a, b) => compareBuild(b, a, loose));
    module2.exports = rsort;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/functions/gt.js
var require_gt = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/functions/gt.js"(exports2, module2) {
    "use strict";
    var compare = require_compare();
    var gt = (a, b, loose) => compare(a, b, loose) > 0;
    module2.exports = gt;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/functions/lt.js
var require_lt = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/functions/lt.js"(exports2, module2) {
    "use strict";
    var compare = require_compare();
    var lt = (a, b, loose) => compare(a, b, loose) < 0;
    module2.exports = lt;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/functions/eq.js
var require_eq = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/functions/eq.js"(exports2, module2) {
    "use strict";
    var compare = require_compare();
    var eq = (a, b, loose) => compare(a, b, loose) === 0;
    module2.exports = eq;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/functions/neq.js
var require_neq = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/functions/neq.js"(exports2, module2) {
    "use strict";
    var compare = require_compare();
    var neq = (a, b, loose) => compare(a, b, loose) !== 0;
    module2.exports = neq;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/functions/gte.js
var require_gte = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/functions/gte.js"(exports2, module2) {
    "use strict";
    var compare = require_compare();
    var gte = (a, b, loose) => compare(a, b, loose) >= 0;
    module2.exports = gte;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/functions/lte.js
var require_lte = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/functions/lte.js"(exports2, module2) {
    "use strict";
    var compare = require_compare();
    var lte = (a, b, loose) => compare(a, b, loose) <= 0;
    module2.exports = lte;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/functions/cmp.js
var require_cmp = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/functions/cmp.js"(exports2, module2) {
    "use strict";
    var eq = require_eq();
    var neq = require_neq();
    var gt = require_gt();
    var gte = require_gte();
    var lt = require_lt();
    var lte = require_lte();
    var cmp = (a, op, b, loose) => {
      switch (op) {
        case "===":
          if (typeof a === "object") {
            a = a.version;
          }
          if (typeof b === "object") {
            b = b.version;
          }
          return a === b;
        case "!==":
          if (typeof a === "object") {
            a = a.version;
          }
          if (typeof b === "object") {
            b = b.version;
          }
          return a !== b;
        case "":
        case "=":
        case "==":
          return eq(a, b, loose);
        case "!=":
          return neq(a, b, loose);
        case ">":
          return gt(a, b, loose);
        case ">=":
          return gte(a, b, loose);
        case "<":
          return lt(a, b, loose);
        case "<=":
          return lte(a, b, loose);
        default:
          throw new TypeError(`Invalid operator: ${op}`);
      }
    };
    module2.exports = cmp;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/functions/coerce.js
var require_coerce = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/functions/coerce.js"(exports2, module2) {
    "use strict";
    var SemVer = require_semver();
    var parse = require_parse();
    var { re, t } = require_re();
    var coerce = (version, options) => {
      if (version instanceof SemVer) {
        return version;
      }
      if (typeof version === "number") {
        version = String(version);
      }
      if (typeof version !== "string") {
        return null;
      }
      options = options || {};
      let match = null;
      if (!options.rtl) {
        match = version.match(re[t.COERCE]);
      } else {
        let next;
        while ((next = re[t.COERCERTL].exec(version)) && (!match || match.index + match[0].length !== version.length)) {
          if (!match || next.index + next[0].length !== match.index + match[0].length) {
            match = next;
          }
          re[t.COERCERTL].lastIndex = next.index + next[1].length + next[2].length;
        }
        re[t.COERCERTL].lastIndex = -1;
      }
      if (match === null) {
        return null;
      }
      return parse(`${match[2]}.${match[3] || "0"}.${match[4] || "0"}`, options);
    };
    module2.exports = coerce;
  }
});

// node_modules/aws-cdk-lib/node_modules/yallist/iterator.js
var require_iterator = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/yallist/iterator.js"(exports2, module2) {
    "use strict";
    module2.exports = function(Yallist) {
      Yallist.prototype[Symbol.iterator] = function* () {
        for (let walker = this.head; walker; walker = walker.next) {
          yield walker.value;
        }
      };
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/yallist/yallist.js
var require_yallist = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/yallist/yallist.js"(exports2, module2) {
    "use strict";
    module2.exports = Yallist;
    Yallist.Node = Node;
    Yallist.create = Yallist;
    function Yallist(list) {
      var self2 = this;
      if (!(self2 instanceof Yallist)) {
        self2 = new Yallist();
      }
      self2.tail = null;
      self2.head = null;
      self2.length = 0;
      if (list && typeof list.forEach === "function") {
        list.forEach(function(item) {
          self2.push(item);
        });
      } else if (arguments.length > 0) {
        for (var i = 0, l = arguments.length; i < l; i++) {
          self2.push(arguments[i]);
        }
      }
      return self2;
    }
    Yallist.prototype.removeNode = function(node) {
      if (node.list !== this) {
        throw new Error("removing node which does not belong to this list");
      }
      var next = node.next;
      var prev = node.prev;
      if (next) {
        next.prev = prev;
      }
      if (prev) {
        prev.next = next;
      }
      if (node === this.head) {
        this.head = next;
      }
      if (node === this.tail) {
        this.tail = prev;
      }
      node.list.length--;
      node.next = null;
      node.prev = null;
      node.list = null;
      return next;
    };
    Yallist.prototype.unshiftNode = function(node) {
      if (node === this.head) {
        return;
      }
      if (node.list) {
        node.list.removeNode(node);
      }
      var head = this.head;
      node.list = this;
      node.next = head;
      if (head) {
        head.prev = node;
      }
      this.head = node;
      if (!this.tail) {
        this.tail = node;
      }
      this.length++;
    };
    Yallist.prototype.pushNode = function(node) {
      if (node === this.tail) {
        return;
      }
      if (node.list) {
        node.list.removeNode(node);
      }
      var tail = this.tail;
      node.list = this;
      node.prev = tail;
      if (tail) {
        tail.next = node;
      }
      this.tail = node;
      if (!this.head) {
        this.head = node;
      }
      this.length++;
    };
    Yallist.prototype.push = function() {
      for (var i = 0, l = arguments.length; i < l; i++) {
        push(this, arguments[i]);
      }
      return this.length;
    };
    Yallist.prototype.unshift = function() {
      for (var i = 0, l = arguments.length; i < l; i++) {
        unshift(this, arguments[i]);
      }
      return this.length;
    };
    Yallist.prototype.pop = function() {
      if (!this.tail) {
        return void 0;
      }
      var res = this.tail.value;
      this.tail = this.tail.prev;
      if (this.tail) {
        this.tail.next = null;
      } else {
        this.head = null;
      }
      this.length--;
      return res;
    };
    Yallist.prototype.shift = function() {
      if (!this.head) {
        return void 0;
      }
      var res = this.head.value;
      this.head = this.head.next;
      if (this.head) {
        this.head.prev = null;
      } else {
        this.tail = null;
      }
      this.length--;
      return res;
    };
    Yallist.prototype.forEach = function(fn, thisp) {
      thisp = thisp || this;
      for (var walker = this.head, i = 0; walker !== null; i++) {
        fn.call(thisp, walker.value, i, this);
        walker = walker.next;
      }
    };
    Yallist.prototype.forEachReverse = function(fn, thisp) {
      thisp = thisp || this;
      for (var walker = this.tail, i = this.length - 1; walker !== null; i--) {
        fn.call(thisp, walker.value, i, this);
        walker = walker.prev;
      }
    };
    Yallist.prototype.get = function(n) {
      for (var i = 0, walker = this.head; walker !== null && i < n; i++) {
        walker = walker.next;
      }
      if (i === n && walker !== null) {
        return walker.value;
      }
    };
    Yallist.prototype.getReverse = function(n) {
      for (var i = 0, walker = this.tail; walker !== null && i < n; i++) {
        walker = walker.prev;
      }
      if (i === n && walker !== null) {
        return walker.value;
      }
    };
    Yallist.prototype.map = function(fn, thisp) {
      thisp = thisp || this;
      var res = new Yallist();
      for (var walker = this.head; walker !== null; ) {
        res.push(fn.call(thisp, walker.value, this));
        walker = walker.next;
      }
      return res;
    };
    Yallist.prototype.mapReverse = function(fn, thisp) {
      thisp = thisp || this;
      var res = new Yallist();
      for (var walker = this.tail; walker !== null; ) {
        res.push(fn.call(thisp, walker.value, this));
        walker = walker.prev;
      }
      return res;
    };
    Yallist.prototype.reduce = function(fn, initial) {
      var acc;
      var walker = this.head;
      if (arguments.length > 1) {
        acc = initial;
      } else if (this.head) {
        walker = this.head.next;
        acc = this.head.value;
      } else {
        throw new TypeError("Reduce of empty list with no initial value");
      }
      for (var i = 0; walker !== null; i++) {
        acc = fn(acc, walker.value, i);
        walker = walker.next;
      }
      return acc;
    };
    Yallist.prototype.reduceReverse = function(fn, initial) {
      var acc;
      var walker = this.tail;
      if (arguments.length > 1) {
        acc = initial;
      } else if (this.tail) {
        walker = this.tail.prev;
        acc = this.tail.value;
      } else {
        throw new TypeError("Reduce of empty list with no initial value");
      }
      for (var i = this.length - 1; walker !== null; i--) {
        acc = fn(acc, walker.value, i);
        walker = walker.prev;
      }
      return acc;
    };
    Yallist.prototype.toArray = function() {
      var arr = new Array(this.length);
      for (var i = 0, walker = this.head; walker !== null; i++) {
        arr[i] = walker.value;
        walker = walker.next;
      }
      return arr;
    };
    Yallist.prototype.toArrayReverse = function() {
      var arr = new Array(this.length);
      for (var i = 0, walker = this.tail; walker !== null; i++) {
        arr[i] = walker.value;
        walker = walker.prev;
      }
      return arr;
    };
    Yallist.prototype.slice = function(from, to) {
      to = to || this.length;
      if (to < 0) {
        to += this.length;
      }
      from = from || 0;
      if (from < 0) {
        from += this.length;
      }
      var ret = new Yallist();
      if (to < from || to < 0) {
        return ret;
      }
      if (from < 0) {
        from = 0;
      }
      if (to > this.length) {
        to = this.length;
      }
      for (var i = 0, walker = this.head; walker !== null && i < from; i++) {
        walker = walker.next;
      }
      for (; walker !== null && i < to; i++, walker = walker.next) {
        ret.push(walker.value);
      }
      return ret;
    };
    Yallist.prototype.sliceReverse = function(from, to) {
      to = to || this.length;
      if (to < 0) {
        to += this.length;
      }
      from = from || 0;
      if (from < 0) {
        from += this.length;
      }
      var ret = new Yallist();
      if (to < from || to < 0) {
        return ret;
      }
      if (from < 0) {
        from = 0;
      }
      if (to > this.length) {
        to = this.length;
      }
      for (var i = this.length, walker = this.tail; walker !== null && i > to; i--) {
        walker = walker.prev;
      }
      for (; walker !== null && i > from; i--, walker = walker.prev) {
        ret.push(walker.value);
      }
      return ret;
    };
    Yallist.prototype.splice = function(start, deleteCount, ...nodes) {
      if (start > this.length) {
        start = this.length - 1;
      }
      if (start < 0) {
        start = this.length + start;
      }
      for (var i = 0, walker = this.head; walker !== null && i < start; i++) {
        walker = walker.next;
      }
      var ret = [];
      for (var i = 0; walker && i < deleteCount; i++) {
        ret.push(walker.value);
        walker = this.removeNode(walker);
      }
      if (walker === null) {
        walker = this.tail;
      }
      if (walker !== this.head && walker !== this.tail) {
        walker = walker.prev;
      }
      for (var i = 0; i < nodes.length; i++) {
        walker = insert(this, walker, nodes[i]);
      }
      return ret;
    };
    Yallist.prototype.reverse = function() {
      var head = this.head;
      var tail = this.tail;
      for (var walker = head; walker !== null; walker = walker.prev) {
        var p = walker.prev;
        walker.prev = walker.next;
        walker.next = p;
      }
      this.head = tail;
      this.tail = head;
      return this;
    };
    function insert(self2, node, value) {
      var inserted = node === self2.head ? new Node(value, null, node, self2) : new Node(value, node, node.next, self2);
      if (inserted.next === null) {
        self2.tail = inserted;
      }
      if (inserted.prev === null) {
        self2.head = inserted;
      }
      self2.length++;
      return inserted;
    }
    function push(self2, item) {
      self2.tail = new Node(item, self2.tail, null, self2);
      if (!self2.head) {
        self2.head = self2.tail;
      }
      self2.length++;
    }
    function unshift(self2, item) {
      self2.head = new Node(item, null, self2.head, self2);
      if (!self2.tail) {
        self2.tail = self2.head;
      }
      self2.length++;
    }
    function Node(value, prev, next, list) {
      if (!(this instanceof Node)) {
        return new Node(value, prev, next, list);
      }
      this.list = list;
      this.value = value;
      if (prev) {
        prev.next = this;
        this.prev = prev;
      } else {
        this.prev = null;
      }
      if (next) {
        next.prev = this;
        this.next = next;
      } else {
        this.next = null;
      }
    }
    try {
      require_iterator()(Yallist);
    } catch (er) {
    }
  }
});

// node_modules/aws-cdk-lib/node_modules/lru-cache/index.js
var require_lru_cache = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/lru-cache/index.js"(exports2, module2) {
    "use strict";
    var Yallist = require_yallist();
    var MAX = Symbol("max");
    var LENGTH = Symbol("length");
    var LENGTH_CALCULATOR = Symbol("lengthCalculator");
    var ALLOW_STALE = Symbol("allowStale");
    var MAX_AGE = Symbol("maxAge");
    var DISPOSE = Symbol("dispose");
    var NO_DISPOSE_ON_SET = Symbol("noDisposeOnSet");
    var LRU_LIST = Symbol("lruList");
    var CACHE = Symbol("cache");
    var UPDATE_AGE_ON_GET = Symbol("updateAgeOnGet");
    var naiveLength = () => 1;
    var LRUCache = class {
      constructor(options) {
        if (typeof options === "number")
          options = { max: options };
        if (!options)
          options = {};
        if (options.max && (typeof options.max !== "number" || options.max < 0))
          throw new TypeError("max must be a non-negative number");
        const max = this[MAX] = options.max || Infinity;
        const lc = options.length || naiveLength;
        this[LENGTH_CALCULATOR] = typeof lc !== "function" ? naiveLength : lc;
        this[ALLOW_STALE] = options.stale || false;
        if (options.maxAge && typeof options.maxAge !== "number")
          throw new TypeError("maxAge must be a number");
        this[MAX_AGE] = options.maxAge || 0;
        this[DISPOSE] = options.dispose;
        this[NO_DISPOSE_ON_SET] = options.noDisposeOnSet || false;
        this[UPDATE_AGE_ON_GET] = options.updateAgeOnGet || false;
        this.reset();
      }
      // resize the cache when the max changes.
      set max(mL) {
        if (typeof mL !== "number" || mL < 0)
          throw new TypeError("max must be a non-negative number");
        this[MAX] = mL || Infinity;
        trim(this);
      }
      get max() {
        return this[MAX];
      }
      set allowStale(allowStale) {
        this[ALLOW_STALE] = !!allowStale;
      }
      get allowStale() {
        return this[ALLOW_STALE];
      }
      set maxAge(mA) {
        if (typeof mA !== "number")
          throw new TypeError("maxAge must be a non-negative number");
        this[MAX_AGE] = mA;
        trim(this);
      }
      get maxAge() {
        return this[MAX_AGE];
      }
      // resize the cache when the lengthCalculator changes.
      set lengthCalculator(lC) {
        if (typeof lC !== "function")
          lC = naiveLength;
        if (lC !== this[LENGTH_CALCULATOR]) {
          this[LENGTH_CALCULATOR] = lC;
          this[LENGTH] = 0;
          this[LRU_LIST].forEach((hit) => {
            hit.length = this[LENGTH_CALCULATOR](hit.value, hit.key);
            this[LENGTH] += hit.length;
          });
        }
        trim(this);
      }
      get lengthCalculator() {
        return this[LENGTH_CALCULATOR];
      }
      get length() {
        return this[LENGTH];
      }
      get itemCount() {
        return this[LRU_LIST].length;
      }
      rforEach(fn, thisp) {
        thisp = thisp || this;
        for (let walker = this[LRU_LIST].tail; walker !== null; ) {
          const prev = walker.prev;
          forEachStep(this, fn, walker, thisp);
          walker = prev;
        }
      }
      forEach(fn, thisp) {
        thisp = thisp || this;
        for (let walker = this[LRU_LIST].head; walker !== null; ) {
          const next = walker.next;
          forEachStep(this, fn, walker, thisp);
          walker = next;
        }
      }
      keys() {
        return this[LRU_LIST].toArray().map((k) => k.key);
      }
      values() {
        return this[LRU_LIST].toArray().map((k) => k.value);
      }
      reset() {
        if (this[DISPOSE] && this[LRU_LIST] && this[LRU_LIST].length) {
          this[LRU_LIST].forEach((hit) => this[DISPOSE](hit.key, hit.value));
        }
        this[CACHE] = /* @__PURE__ */ new Map();
        this[LRU_LIST] = new Yallist();
        this[LENGTH] = 0;
      }
      dump() {
        return this[LRU_LIST].map((hit) => isStale(this, hit) ? false : {
          k: hit.key,
          v: hit.value,
          e: hit.now + (hit.maxAge || 0)
        }).toArray().filter((h) => h);
      }
      dumpLru() {
        return this[LRU_LIST];
      }
      set(key, value, maxAge) {
        maxAge = maxAge || this[MAX_AGE];
        if (maxAge && typeof maxAge !== "number")
          throw new TypeError("maxAge must be a number");
        const now = maxAge ? Date.now() : 0;
        const len = this[LENGTH_CALCULATOR](value, key);
        if (this[CACHE].has(key)) {
          if (len > this[MAX]) {
            del(this, this[CACHE].get(key));
            return false;
          }
          const node = this[CACHE].get(key);
          const item = node.value;
          if (this[DISPOSE]) {
            if (!this[NO_DISPOSE_ON_SET])
              this[DISPOSE](key, item.value);
          }
          item.now = now;
          item.maxAge = maxAge;
          item.value = value;
          this[LENGTH] += len - item.length;
          item.length = len;
          this.get(key);
          trim(this);
          return true;
        }
        const hit = new Entry(key, value, len, now, maxAge);
        if (hit.length > this[MAX]) {
          if (this[DISPOSE])
            this[DISPOSE](key, value);
          return false;
        }
        this[LENGTH] += hit.length;
        this[LRU_LIST].unshift(hit);
        this[CACHE].set(key, this[LRU_LIST].head);
        trim(this);
        return true;
      }
      has(key) {
        if (!this[CACHE].has(key))
          return false;
        const hit = this[CACHE].get(key).value;
        return !isStale(this, hit);
      }
      get(key) {
        return get(this, key, true);
      }
      peek(key) {
        return get(this, key, false);
      }
      pop() {
        const node = this[LRU_LIST].tail;
        if (!node)
          return null;
        del(this, node);
        return node.value;
      }
      del(key) {
        del(this, this[CACHE].get(key));
      }
      load(arr) {
        this.reset();
        const now = Date.now();
        for (let l = arr.length - 1; l >= 0; l--) {
          const hit = arr[l];
          const expiresAt = hit.e || 0;
          if (expiresAt === 0)
            this.set(hit.k, hit.v);
          else {
            const maxAge = expiresAt - now;
            if (maxAge > 0) {
              this.set(hit.k, hit.v, maxAge);
            }
          }
        }
      }
      prune() {
        this[CACHE].forEach((value, key) => get(this, key, false));
      }
    };
    var get = (self2, key, doUse) => {
      const node = self2[CACHE].get(key);
      if (node) {
        const hit = node.value;
        if (isStale(self2, hit)) {
          del(self2, node);
          if (!self2[ALLOW_STALE])
            return void 0;
        } else {
          if (doUse) {
            if (self2[UPDATE_AGE_ON_GET])
              node.value.now = Date.now();
            self2[LRU_LIST].unshiftNode(node);
          }
        }
        return hit.value;
      }
    };
    var isStale = (self2, hit) => {
      if (!hit || !hit.maxAge && !self2[MAX_AGE])
        return false;
      const diff = Date.now() - hit.now;
      return hit.maxAge ? diff > hit.maxAge : self2[MAX_AGE] && diff > self2[MAX_AGE];
    };
    var trim = (self2) => {
      if (self2[LENGTH] > self2[MAX]) {
        for (let walker = self2[LRU_LIST].tail; self2[LENGTH] > self2[MAX] && walker !== null; ) {
          const prev = walker.prev;
          del(self2, walker);
          walker = prev;
        }
      }
    };
    var del = (self2, node) => {
      if (node) {
        const hit = node.value;
        if (self2[DISPOSE])
          self2[DISPOSE](hit.key, hit.value);
        self2[LENGTH] -= hit.length;
        self2[CACHE].delete(hit.key);
        self2[LRU_LIST].removeNode(node);
      }
    };
    var Entry = class {
      constructor(key, value, length, now, maxAge) {
        this.key = key;
        this.value = value;
        this.length = length;
        this.now = now;
        this.maxAge = maxAge || 0;
      }
    };
    var forEachStep = (self2, fn, node, thisp) => {
      let hit = node.value;
      if (isStale(self2, hit)) {
        del(self2, node);
        if (!self2[ALLOW_STALE])
          hit = void 0;
      }
      if (hit)
        fn.call(thisp, hit.value, hit.key, self2);
    };
    module2.exports = LRUCache;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/classes/range.js
var require_range = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/classes/range.js"(exports2, module2) {
    "use strict";
    var Range = class _Range {
      constructor(range, options) {
        options = parseOptions(options);
        if (range instanceof _Range) {
          if (range.loose === !!options.loose && range.includePrerelease === !!options.includePrerelease) {
            return range;
          } else {
            return new _Range(range.raw, options);
          }
        }
        if (range instanceof Comparator) {
          this.raw = range.value;
          this.set = [[range]];
          this.format();
          return this;
        }
        this.options = options;
        this.loose = !!options.loose;
        this.includePrerelease = !!options.includePrerelease;
        this.raw = range;
        this.set = range.split("||").map((r) => this.parseRange(r.trim())).filter((c) => c.length);
        if (!this.set.length) {
          throw new TypeError(`Invalid SemVer Range: ${range}`);
        }
        if (this.set.length > 1) {
          const first = this.set[0];
          this.set = this.set.filter((c) => !isNullSet(c[0]));
          if (this.set.length === 0) {
            this.set = [first];
          } else if (this.set.length > 1) {
            for (const c of this.set) {
              if (c.length === 1 && isAny(c[0])) {
                this.set = [c];
                break;
              }
            }
          }
        }
        this.format();
      }
      format() {
        this.range = this.set.map((comps) => {
          return comps.join(" ").trim();
        }).join("||").trim();
        return this.range;
      }
      toString() {
        return this.range;
      }
      parseRange(range) {
        range = range.trim();
        const memoOpts = (this.options.includePrerelease && FLAG_INCLUDE_PRERELEASE) | (this.options.loose && FLAG_LOOSE);
        const memoKey = memoOpts + ":" + range;
        const cached = cache.get(memoKey);
        if (cached) {
          return cached;
        }
        const loose = this.options.loose;
        const hr = loose ? re[t.HYPHENRANGELOOSE] : re[t.HYPHENRANGE];
        range = range.replace(hr, hyphenReplace(this.options.includePrerelease));
        debug("hyphen replace", range);
        range = range.replace(re[t.COMPARATORTRIM], comparatorTrimReplace);
        debug("comparator trim", range);
        range = range.replace(re[t.TILDETRIM], tildeTrimReplace);
        range = range.replace(re[t.CARETTRIM], caretTrimReplace);
        range = range.split(/\s+/).join(" ");
        let rangeList = range.split(" ").map((comp) => parseComparator(comp, this.options)).join(" ").split(/\s+/).map((comp) => replaceGTE0(comp, this.options));
        if (loose) {
          rangeList = rangeList.filter((comp) => {
            debug("loose invalid filter", comp, this.options);
            return !!comp.match(re[t.COMPARATORLOOSE]);
          });
        }
        debug("range list", rangeList);
        const rangeMap = /* @__PURE__ */ new Map();
        const comparators = rangeList.map((comp) => new Comparator(comp, this.options));
        for (const comp of comparators) {
          if (isNullSet(comp)) {
            return [comp];
          }
          rangeMap.set(comp.value, comp);
        }
        if (rangeMap.size > 1 && rangeMap.has("")) {
          rangeMap.delete("");
        }
        const result = [...rangeMap.values()];
        cache.set(memoKey, result);
        return result;
      }
      intersects(range, options) {
        if (!(range instanceof _Range)) {
          throw new TypeError("a Range is required");
        }
        return this.set.some((thisComparators) => {
          return isSatisfiable(thisComparators, options) && range.set.some((rangeComparators) => {
            return isSatisfiable(rangeComparators, options) && thisComparators.every((thisComparator) => {
              return rangeComparators.every((rangeComparator) => {
                return thisComparator.intersects(rangeComparator, options);
              });
            });
          });
        });
      }
      // if ANY of the sets match ALL of its comparators, then pass
      test(version) {
        if (!version) {
          return false;
        }
        if (typeof version === "string") {
          try {
            version = new SemVer(version, this.options);
          } catch (er) {
            return false;
          }
        }
        for (let i = 0; i < this.set.length; i++) {
          if (testSet(this.set[i], version, this.options)) {
            return true;
          }
        }
        return false;
      }
    };
    module2.exports = Range;
    var LRU = require_lru_cache();
    var cache = new LRU({ max: 1e3 });
    var parseOptions = require_parse_options();
    var Comparator = require_comparator();
    var debug = require_debug();
    var SemVer = require_semver();
    var {
      re,
      t,
      comparatorTrimReplace,
      tildeTrimReplace,
      caretTrimReplace
    } = require_re();
    var { FLAG_INCLUDE_PRERELEASE, FLAG_LOOSE } = require_constants();
    var isNullSet = (c) => c.value === "<0.0.0-0";
    var isAny = (c) => c.value === "";
    var isSatisfiable = (comparators, options) => {
      let result = true;
      const remainingComparators = comparators.slice();
      let testComparator = remainingComparators.pop();
      while (result && remainingComparators.length) {
        result = remainingComparators.every((otherComparator) => {
          return testComparator.intersects(otherComparator, options);
        });
        testComparator = remainingComparators.pop();
      }
      return result;
    };
    var parseComparator = (comp, options) => {
      debug("comp", comp, options);
      comp = replaceCarets(comp, options);
      debug("caret", comp);
      comp = replaceTildes(comp, options);
      debug("tildes", comp);
      comp = replaceXRanges(comp, options);
      debug("xrange", comp);
      comp = replaceStars(comp, options);
      debug("stars", comp);
      return comp;
    };
    var isX = (id) => !id || id.toLowerCase() === "x" || id === "*";
    var replaceTildes = (comp, options) => comp.trim().split(/\s+/).map((c) => {
      return replaceTilde(c, options);
    }).join(" ");
    var replaceTilde = (comp, options) => {
      const r = options.loose ? re[t.TILDELOOSE] : re[t.TILDE];
      return comp.replace(r, (_, M, m, p, pr) => {
        debug("tilde", comp, _, M, m, p, pr);
        let ret;
        if (isX(M)) {
          ret = "";
        } else if (isX(m)) {
          ret = `>=${M}.0.0 <${+M + 1}.0.0-0`;
        } else if (isX(p)) {
          ret = `>=${M}.${m}.0 <${M}.${+m + 1}.0-0`;
        } else if (pr) {
          debug("replaceTilde pr", pr);
          ret = `>=${M}.${m}.${p}-${pr} <${M}.${+m + 1}.0-0`;
        } else {
          ret = `>=${M}.${m}.${p} <${M}.${+m + 1}.0-0`;
        }
        debug("tilde return", ret);
        return ret;
      });
    };
    var replaceCarets = (comp, options) => comp.trim().split(/\s+/).map((c) => {
      return replaceCaret(c, options);
    }).join(" ");
    var replaceCaret = (comp, options) => {
      debug("caret", comp, options);
      const r = options.loose ? re[t.CARETLOOSE] : re[t.CARET];
      const z = options.includePrerelease ? "-0" : "";
      return comp.replace(r, (_, M, m, p, pr) => {
        debug("caret", comp, _, M, m, p, pr);
        let ret;
        if (isX(M)) {
          ret = "";
        } else if (isX(m)) {
          ret = `>=${M}.0.0${z} <${+M + 1}.0.0-0`;
        } else if (isX(p)) {
          if (M === "0") {
            ret = `>=${M}.${m}.0${z} <${M}.${+m + 1}.0-0`;
          } else {
            ret = `>=${M}.${m}.0${z} <${+M + 1}.0.0-0`;
          }
        } else if (pr) {
          debug("replaceCaret pr", pr);
          if (M === "0") {
            if (m === "0") {
              ret = `>=${M}.${m}.${p}-${pr} <${M}.${m}.${+p + 1}-0`;
            } else {
              ret = `>=${M}.${m}.${p}-${pr} <${M}.${+m + 1}.0-0`;
            }
          } else {
            ret = `>=${M}.${m}.${p}-${pr} <${+M + 1}.0.0-0`;
          }
        } else {
          debug("no pr");
          if (M === "0") {
            if (m === "0") {
              ret = `>=${M}.${m}.${p}${z} <${M}.${m}.${+p + 1}-0`;
            } else {
              ret = `>=${M}.${m}.${p}${z} <${M}.${+m + 1}.0-0`;
            }
          } else {
            ret = `>=${M}.${m}.${p} <${+M + 1}.0.0-0`;
          }
        }
        debug("caret return", ret);
        return ret;
      });
    };
    var replaceXRanges = (comp, options) => {
      debug("replaceXRanges", comp, options);
      return comp.split(/\s+/).map((c) => {
        return replaceXRange(c, options);
      }).join(" ");
    };
    var replaceXRange = (comp, options) => {
      comp = comp.trim();
      const r = options.loose ? re[t.XRANGELOOSE] : re[t.XRANGE];
      return comp.replace(r, (ret, gtlt, M, m, p, pr) => {
        debug("xRange", comp, ret, gtlt, M, m, p, pr);
        const xM = isX(M);
        const xm = xM || isX(m);
        const xp = xm || isX(p);
        const anyX = xp;
        if (gtlt === "=" && anyX) {
          gtlt = "";
        }
        pr = options.includePrerelease ? "-0" : "";
        if (xM) {
          if (gtlt === ">" || gtlt === "<") {
            ret = "<0.0.0-0";
          } else {
            ret = "*";
          }
        } else if (gtlt && anyX) {
          if (xm) {
            m = 0;
          }
          p = 0;
          if (gtlt === ">") {
            gtlt = ">=";
            if (xm) {
              M = +M + 1;
              m = 0;
              p = 0;
            } else {
              m = +m + 1;
              p = 0;
            }
          } else if (gtlt === "<=") {
            gtlt = "<";
            if (xm) {
              M = +M + 1;
            } else {
              m = +m + 1;
            }
          }
          if (gtlt === "<") {
            pr = "-0";
          }
          ret = `${gtlt + M}.${m}.${p}${pr}`;
        } else if (xm) {
          ret = `>=${M}.0.0${pr} <${+M + 1}.0.0-0`;
        } else if (xp) {
          ret = `>=${M}.${m}.0${pr} <${M}.${+m + 1}.0-0`;
        }
        debug("xRange return", ret);
        return ret;
      });
    };
    var replaceStars = (comp, options) => {
      debug("replaceStars", comp, options);
      return comp.trim().replace(re[t.STAR], "");
    };
    var replaceGTE0 = (comp, options) => {
      debug("replaceGTE0", comp, options);
      return comp.trim().replace(re[options.includePrerelease ? t.GTE0PRE : t.GTE0], "");
    };
    var hyphenReplace = (incPr) => ($0, from, fM, fm, fp, fpr, fb, to, tM, tm, tp, tpr, tb) => {
      if (isX(fM)) {
        from = "";
      } else if (isX(fm)) {
        from = `>=${fM}.0.0${incPr ? "-0" : ""}`;
      } else if (isX(fp)) {
        from = `>=${fM}.${fm}.0${incPr ? "-0" : ""}`;
      } else if (fpr) {
        from = `>=${from}`;
      } else {
        from = `>=${from}${incPr ? "-0" : ""}`;
      }
      if (isX(tM)) {
        to = "";
      } else if (isX(tm)) {
        to = `<${+tM + 1}.0.0-0`;
      } else if (isX(tp)) {
        to = `<${tM}.${+tm + 1}.0-0`;
      } else if (tpr) {
        to = `<=${tM}.${tm}.${tp}-${tpr}`;
      } else if (incPr) {
        to = `<${tM}.${tm}.${+tp + 1}-0`;
      } else {
        to = `<=${to}`;
      }
      return `${from} ${to}`.trim();
    };
    var testSet = (set, version, options) => {
      for (let i = 0; i < set.length; i++) {
        if (!set[i].test(version)) {
          return false;
        }
      }
      if (version.prerelease.length && !options.includePrerelease) {
        for (let i = 0; i < set.length; i++) {
          debug(set[i].semver);
          if (set[i].semver === Comparator.ANY) {
            continue;
          }
          if (set[i].semver.prerelease.length > 0) {
            const allowed = set[i].semver;
            if (allowed.major === version.major && allowed.minor === version.minor && allowed.patch === version.patch) {
              return true;
            }
          }
        }
        return false;
      }
      return true;
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/classes/comparator.js
var require_comparator = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/classes/comparator.js"(exports2, module2) {
    "use strict";
    var ANY = Symbol("SemVer ANY");
    var Comparator = class _Comparator {
      static get ANY() {
        return ANY;
      }
      constructor(comp, options) {
        options = parseOptions(options);
        if (comp instanceof _Comparator) {
          if (comp.loose === !!options.loose) {
            return comp;
          } else {
            comp = comp.value;
          }
        }
        debug("comparator", comp, options);
        this.options = options;
        this.loose = !!options.loose;
        this.parse(comp);
        if (this.semver === ANY) {
          this.value = "";
        } else {
          this.value = this.operator + this.semver.version;
        }
        debug("comp", this);
      }
      parse(comp) {
        const r = this.options.loose ? re[t.COMPARATORLOOSE] : re[t.COMPARATOR];
        const m = comp.match(r);
        if (!m) {
          throw new TypeError(`Invalid comparator: ${comp}`);
        }
        this.operator = m[1] !== void 0 ? m[1] : "";
        if (this.operator === "=") {
          this.operator = "";
        }
        if (!m[2]) {
          this.semver = ANY;
        } else {
          this.semver = new SemVer(m[2], this.options.loose);
        }
      }
      toString() {
        return this.value;
      }
      test(version) {
        debug("Comparator.test", version, this.options.loose);
        if (this.semver === ANY || version === ANY) {
          return true;
        }
        if (typeof version === "string") {
          try {
            version = new SemVer(version, this.options);
          } catch (er) {
            return false;
          }
        }
        return cmp(version, this.operator, this.semver, this.options);
      }
      intersects(comp, options) {
        if (!(comp instanceof _Comparator)) {
          throw new TypeError("a Comparator is required");
        }
        if (this.operator === "") {
          if (this.value === "") {
            return true;
          }
          return new Range(comp.value, options).test(this.value);
        } else if (comp.operator === "") {
          if (comp.value === "") {
            return true;
          }
          return new Range(this.value, options).test(comp.semver);
        }
        options = parseOptions(options);
        if (options.includePrerelease && (this.value === "<0.0.0-0" || comp.value === "<0.0.0-0")) {
          return false;
        }
        if (!options.includePrerelease && (this.value.startsWith("<0.0.0") || comp.value.startsWith("<0.0.0"))) {
          return false;
        }
        if (this.operator.startsWith(">") && comp.operator.startsWith(">")) {
          return true;
        }
        if (this.operator.startsWith("<") && comp.operator.startsWith("<")) {
          return true;
        }
        if (this.semver.version === comp.semver.version && this.operator.includes("=") && comp.operator.includes("=")) {
          return true;
        }
        if (cmp(this.semver, "<", comp.semver, options) && this.operator.startsWith(">") && comp.operator.startsWith("<")) {
          return true;
        }
        if (cmp(this.semver, ">", comp.semver, options) && this.operator.startsWith("<") && comp.operator.startsWith(">")) {
          return true;
        }
        return false;
      }
    };
    module2.exports = Comparator;
    var parseOptions = require_parse_options();
    var { re, t } = require_re();
    var cmp = require_cmp();
    var debug = require_debug();
    var SemVer = require_semver();
    var Range = require_range();
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/functions/satisfies.js
var require_satisfies = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/functions/satisfies.js"(exports2, module2) {
    "use strict";
    var Range = require_range();
    var satisfies = (version, range, options) => {
      try {
        range = new Range(range, options);
      } catch (er) {
        return false;
      }
      return range.test(version);
    };
    module2.exports = satisfies;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/ranges/to-comparators.js
var require_to_comparators = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/ranges/to-comparators.js"(exports2, module2) {
    "use strict";
    var Range = require_range();
    var toComparators = (range, options) => new Range(range, options).set.map((comp) => comp.map((c) => c.value).join(" ").trim().split(" "));
    module2.exports = toComparators;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/ranges/max-satisfying.js
var require_max_satisfying = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/ranges/max-satisfying.js"(exports2, module2) {
    "use strict";
    var SemVer = require_semver();
    var Range = require_range();
    var maxSatisfying = (versions, range, options) => {
      let max = null;
      let maxSV = null;
      let rangeObj = null;
      try {
        rangeObj = new Range(range, options);
      } catch (er) {
        return null;
      }
      versions.forEach((v) => {
        if (rangeObj.test(v)) {
          if (!max || maxSV.compare(v) === -1) {
            max = v;
            maxSV = new SemVer(max, options);
          }
        }
      });
      return max;
    };
    module2.exports = maxSatisfying;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/ranges/min-satisfying.js
var require_min_satisfying = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/ranges/min-satisfying.js"(exports2, module2) {
    "use strict";
    var SemVer = require_semver();
    var Range = require_range();
    var minSatisfying = (versions, range, options) => {
      let min = null;
      let minSV = null;
      let rangeObj = null;
      try {
        rangeObj = new Range(range, options);
      } catch (er) {
        return null;
      }
      versions.forEach((v) => {
        if (rangeObj.test(v)) {
          if (!min || minSV.compare(v) === 1) {
            min = v;
            minSV = new SemVer(min, options);
          }
        }
      });
      return min;
    };
    module2.exports = minSatisfying;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/ranges/min-version.js
var require_min_version = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/ranges/min-version.js"(exports2, module2) {
    "use strict";
    var SemVer = require_semver();
    var Range = require_range();
    var gt = require_gt();
    var minVersion = (range, loose) => {
      range = new Range(range, loose);
      let minver = new SemVer("0.0.0");
      if (range.test(minver)) {
        return minver;
      }
      minver = new SemVer("0.0.0-0");
      if (range.test(minver)) {
        return minver;
      }
      minver = null;
      for (let i = 0; i < range.set.length; ++i) {
        const comparators = range.set[i];
        let setMin = null;
        comparators.forEach((comparator) => {
          const compver = new SemVer(comparator.semver.version);
          switch (comparator.operator) {
            case ">":
              if (compver.prerelease.length === 0) {
                compver.patch++;
              } else {
                compver.prerelease.push(0);
              }
              compver.raw = compver.format();
            case "":
            case ">=":
              if (!setMin || gt(compver, setMin)) {
                setMin = compver;
              }
              break;
            case "<":
            case "<=":
              break;
            default:
              throw new Error(`Unexpected operation: ${comparator.operator}`);
          }
        });
        if (setMin && (!minver || gt(minver, setMin))) {
          minver = setMin;
        }
      }
      if (minver && range.test(minver)) {
        return minver;
      }
      return null;
    };
    module2.exports = minVersion;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/ranges/valid.js
var require_valid2 = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/ranges/valid.js"(exports2, module2) {
    "use strict";
    var Range = require_range();
    var validRange = (range, options) => {
      try {
        return new Range(range, options).range || "*";
      } catch (er) {
        return null;
      }
    };
    module2.exports = validRange;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/ranges/outside.js
var require_outside = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/ranges/outside.js"(exports2, module2) {
    "use strict";
    var SemVer = require_semver();
    var Comparator = require_comparator();
    var { ANY } = Comparator;
    var Range = require_range();
    var satisfies = require_satisfies();
    var gt = require_gt();
    var lt = require_lt();
    var lte = require_lte();
    var gte = require_gte();
    var outside = (version, range, hilo, options) => {
      version = new SemVer(version, options);
      range = new Range(range, options);
      let gtfn, ltefn, ltfn, comp, ecomp;
      switch (hilo) {
        case ">":
          gtfn = gt;
          ltefn = lte;
          ltfn = lt;
          comp = ">";
          ecomp = ">=";
          break;
        case "<":
          gtfn = lt;
          ltefn = gte;
          ltfn = gt;
          comp = "<";
          ecomp = "<=";
          break;
        default:
          throw new TypeError('Must provide a hilo val of "<" or ">"');
      }
      if (satisfies(version, range, options)) {
        return false;
      }
      for (let i = 0; i < range.set.length; ++i) {
        const comparators = range.set[i];
        let high = null;
        let low = null;
        comparators.forEach((comparator) => {
          if (comparator.semver === ANY) {
            comparator = new Comparator(">=0.0.0");
          }
          high = high || comparator;
          low = low || comparator;
          if (gtfn(comparator.semver, high.semver, options)) {
            high = comparator;
          } else if (ltfn(comparator.semver, low.semver, options)) {
            low = comparator;
          }
        });
        if (high.operator === comp || high.operator === ecomp) {
          return false;
        }
        if ((!low.operator || low.operator === comp) && ltefn(version, low.semver)) {
          return false;
        } else if (low.operator === ecomp && ltfn(version, low.semver)) {
          return false;
        }
      }
      return true;
    };
    module2.exports = outside;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/ranges/gtr.js
var require_gtr = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/ranges/gtr.js"(exports2, module2) {
    "use strict";
    var outside = require_outside();
    var gtr = (version, range, options) => outside(version, range, ">", options);
    module2.exports = gtr;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/ranges/ltr.js
var require_ltr = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/ranges/ltr.js"(exports2, module2) {
    "use strict";
    var outside = require_outside();
    var ltr = (version, range, options) => outside(version, range, "<", options);
    module2.exports = ltr;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/ranges/intersects.js
var require_intersects = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/ranges/intersects.js"(exports2, module2) {
    "use strict";
    var Range = require_range();
    var intersects = (r1, r2, options) => {
      r1 = new Range(r1, options);
      r2 = new Range(r2, options);
      return r1.intersects(r2, options);
    };
    module2.exports = intersects;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/ranges/simplify.js
var require_simplify = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/ranges/simplify.js"(exports2, module2) {
    "use strict";
    var satisfies = require_satisfies();
    var compare = require_compare();
    module2.exports = (versions, range, options) => {
      const set = [];
      let first = null;
      let prev = null;
      const v = versions.sort((a, b) => compare(a, b, options));
      for (const version of v) {
        const included = satisfies(version, range, options);
        if (included) {
          prev = version;
          if (!first) {
            first = version;
          }
        } else {
          if (prev) {
            set.push([first, prev]);
          }
          prev = null;
          first = null;
        }
      }
      if (first) {
        set.push([first, null]);
      }
      const ranges = [];
      for (const [min, max] of set) {
        if (min === max) {
          ranges.push(min);
        } else if (!max && min === v[0]) {
          ranges.push("*");
        } else if (!max) {
          ranges.push(`>=${min}`);
        } else if (min === v[0]) {
          ranges.push(`<=${max}`);
        } else {
          ranges.push(`${min} - ${max}`);
        }
      }
      const simplified = ranges.join(" || ");
      const original = typeof range.raw === "string" ? range.raw : String(range);
      return simplified.length < original.length ? simplified : range;
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/ranges/subset.js
var require_subset = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/ranges/subset.js"(exports2, module2) {
    "use strict";
    var Range = require_range();
    var Comparator = require_comparator();
    var { ANY } = Comparator;
    var satisfies = require_satisfies();
    var compare = require_compare();
    var subset = (sub, dom, options = {}) => {
      if (sub === dom) {
        return true;
      }
      sub = new Range(sub, options);
      dom = new Range(dom, options);
      let sawNonNull = false;
      OUTER:
        for (const simpleSub of sub.set) {
          for (const simpleDom of dom.set) {
            const isSub = simpleSubset(simpleSub, simpleDom, options);
            sawNonNull = sawNonNull || isSub !== null;
            if (isSub) {
              continue OUTER;
            }
          }
          if (sawNonNull) {
            return false;
          }
        }
      return true;
    };
    var minimumVersionWithPreRelease = [new Comparator(">=0.0.0-0")];
    var minimumVersion = [new Comparator(">=0.0.0")];
    var simpleSubset = (sub, dom, options) => {
      if (sub === dom) {
        return true;
      }
      if (sub.length === 1 && sub[0].semver === ANY) {
        if (dom.length === 1 && dom[0].semver === ANY) {
          return true;
        } else if (options.includePrerelease) {
          sub = minimumVersionWithPreRelease;
        } else {
          sub = minimumVersion;
        }
      }
      if (dom.length === 1 && dom[0].semver === ANY) {
        if (options.includePrerelease) {
          return true;
        } else {
          dom = minimumVersion;
        }
      }
      const eqSet = /* @__PURE__ */ new Set();
      let gt, lt;
      for (const c of sub) {
        if (c.operator === ">" || c.operator === ">=") {
          gt = higherGT(gt, c, options);
        } else if (c.operator === "<" || c.operator === "<=") {
          lt = lowerLT(lt, c, options);
        } else {
          eqSet.add(c.semver);
        }
      }
      if (eqSet.size > 1) {
        return null;
      }
      let gtltComp;
      if (gt && lt) {
        gtltComp = compare(gt.semver, lt.semver, options);
        if (gtltComp > 0) {
          return null;
        } else if (gtltComp === 0 && (gt.operator !== ">=" || lt.operator !== "<=")) {
          return null;
        }
      }
      for (const eq of eqSet) {
        if (gt && !satisfies(eq, String(gt), options)) {
          return null;
        }
        if (lt && !satisfies(eq, String(lt), options)) {
          return null;
        }
        for (const c of dom) {
          if (!satisfies(eq, String(c), options)) {
            return false;
          }
        }
        return true;
      }
      let higher, lower;
      let hasDomLT, hasDomGT;
      let needDomLTPre = lt && !options.includePrerelease && lt.semver.prerelease.length ? lt.semver : false;
      let needDomGTPre = gt && !options.includePrerelease && gt.semver.prerelease.length ? gt.semver : false;
      if (needDomLTPre && needDomLTPre.prerelease.length === 1 && lt.operator === "<" && needDomLTPre.prerelease[0] === 0) {
        needDomLTPre = false;
      }
      for (const c of dom) {
        hasDomGT = hasDomGT || c.operator === ">" || c.operator === ">=";
        hasDomLT = hasDomLT || c.operator === "<" || c.operator === "<=";
        if (gt) {
          if (needDomGTPre) {
            if (c.semver.prerelease && c.semver.prerelease.length && c.semver.major === needDomGTPre.major && c.semver.minor === needDomGTPre.minor && c.semver.patch === needDomGTPre.patch) {
              needDomGTPre = false;
            }
          }
          if (c.operator === ">" || c.operator === ">=") {
            higher = higherGT(gt, c, options);
            if (higher === c && higher !== gt) {
              return false;
            }
          } else if (gt.operator === ">=" && !satisfies(gt.semver, String(c), options)) {
            return false;
          }
        }
        if (lt) {
          if (needDomLTPre) {
            if (c.semver.prerelease && c.semver.prerelease.length && c.semver.major === needDomLTPre.major && c.semver.minor === needDomLTPre.minor && c.semver.patch === needDomLTPre.patch) {
              needDomLTPre = false;
            }
          }
          if (c.operator === "<" || c.operator === "<=") {
            lower = lowerLT(lt, c, options);
            if (lower === c && lower !== lt) {
              return false;
            }
          } else if (lt.operator === "<=" && !satisfies(lt.semver, String(c), options)) {
            return false;
          }
        }
        if (!c.operator && (lt || gt) && gtltComp !== 0) {
          return false;
        }
      }
      if (gt && hasDomLT && !lt && gtltComp !== 0) {
        return false;
      }
      if (lt && hasDomGT && !gt && gtltComp !== 0) {
        return false;
      }
      if (needDomGTPre || needDomLTPre) {
        return false;
      }
      return true;
    };
    var higherGT = (a, b, options) => {
      if (!a) {
        return b;
      }
      const comp = compare(a.semver, b.semver, options);
      return comp > 0 ? a : comp < 0 ? b : b.operator === ">" && a.operator === ">=" ? b : a;
    };
    var lowerLT = (a, b, options) => {
      if (!a) {
        return b;
      }
      const comp = compare(a.semver, b.semver, options);
      return comp < 0 ? a : comp > 0 ? b : b.operator === "<" && a.operator === "<=" ? b : a;
    };
    module2.exports = subset;
  }
});

// node_modules/aws-cdk-lib/node_modules/semver/index.js
var require_semver2 = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/semver/index.js"(exports2, module2) {
    "use strict";
    var internalRe = require_re();
    var constants = require_constants();
    var SemVer = require_semver();
    var identifiers = require_identifiers();
    var parse = require_parse();
    var valid = require_valid();
    var clean = require_clean();
    var inc = require_inc();
    var diff = require_diff();
    var major = require_major();
    var minor = require_minor();
    var patch = require_patch();
    var prerelease = require_prerelease();
    var compare = require_compare();
    var rcompare = require_rcompare();
    var compareLoose = require_compare_loose();
    var compareBuild = require_compare_build();
    var sort = require_sort();
    var rsort = require_rsort();
    var gt = require_gt();
    var lt = require_lt();
    var eq = require_eq();
    var neq = require_neq();
    var gte = require_gte();
    var lte = require_lte();
    var cmp = require_cmp();
    var coerce = require_coerce();
    var Comparator = require_comparator();
    var Range = require_range();
    var satisfies = require_satisfies();
    var toComparators = require_to_comparators();
    var maxSatisfying = require_max_satisfying();
    var minSatisfying = require_min_satisfying();
    var minVersion = require_min_version();
    var validRange = require_valid2();
    var outside = require_outside();
    var gtr = require_gtr();
    var ltr = require_ltr();
    var intersects = require_intersects();
    var simplifyRange = require_simplify();
    var subset = require_subset();
    module2.exports = {
      parse,
      valid,
      clean,
      inc,
      diff,
      major,
      minor,
      patch,
      prerelease,
      compare,
      rcompare,
      compareLoose,
      compareBuild,
      sort,
      rsort,
      gt,
      lt,
      eq,
      neq,
      gte,
      lte,
      cmp,
      coerce,
      Comparator,
      Range,
      satisfies,
      toComparators,
      maxSatisfying,
      minSatisfying,
      minVersion,
      validRange,
      outside,
      gtr,
      ltr,
      intersects,
      simplifyRange,
      subset,
      SemVer,
      re: internalRe.re,
      src: internalRe.src,
      tokens: internalRe.t,
      SEMVER_SPEC_VERSION: constants.SEMVER_SPEC_VERSION,
      RELEASE_TYPES: constants.RELEASE_TYPES,
      compareIdentifiers: identifiers.compareIdentifiers,
      rcompareIdentifiers: identifiers.rcompareIdentifiers
    };
  }
});

// node_modules/aws-cdk-lib/cloud-assembly-schema/schema/assets.schema.json
var require_assets_schema = __commonJS({
  "node_modules/aws-cdk-lib/cloud-assembly-schema/schema/assets.schema.json"(exports2, module2) {
    module2.exports = {
      $ref: "#/definitions/AssetManifest",
      definitions: {
        AssetManifest: {
          description: "Definitions for the asset manifest",
          type: "object",
          properties: {
            version: {
              description: "Version of the manifest",
              type: "string"
            },
            files: {
              description: "The file assets in this manifest (Default - No files)",
              type: "object",
              additionalProperties: {
                $ref: "#/definitions/FileAsset"
              }
            },
            dockerImages: {
              description: "The Docker image assets in this manifest (Default - No Docker images)",
              type: "object",
              additionalProperties: {
                $ref: "#/definitions/DockerImageAsset"
              }
            }
          },
          required: [
            "version"
          ]
        },
        FileAsset: {
          description: "A file asset",
          type: "object",
          properties: {
            source: {
              $ref: "#/definitions/FileSource",
              description: "Source description for file assets"
            },
            destinations: {
              description: "Destinations for this file asset",
              type: "object",
              additionalProperties: {
                $ref: "#/definitions/FileDestination"
              }
            }
          },
          required: [
            "destinations",
            "source"
          ]
        },
        FileSource: {
          description: "Describe the source of a file asset",
          type: "object",
          properties: {
            executable: {
              description: "External command which will produce the file asset to upload. (Default - Exactly one of `executable` and `path` is required.)",
              type: "array",
              items: {
                type: "string"
              }
            },
            path: {
              description: "The filesystem object to upload\n\nThis path is relative to the asset manifest location. (Default - Exactly one of `executable` and `path` is required.)",
              type: "string"
            },
            packaging: {
              description: "Packaging method\n\nOnly allowed when `path` is specified. (Default FILE)",
              enum: [
                "file",
                "zip"
              ],
              type: "string"
            }
          }
        },
        FileDestination: {
          description: "Where in S3 a file asset needs to be published",
          type: "object",
          properties: {
            bucketName: {
              description: "The name of the bucket",
              type: "string"
            },
            objectKey: {
              description: "The destination object key",
              type: "string"
            },
            region: {
              description: "The region where this asset will need to be published (Default - Current region)",
              type: "string"
            },
            assumeRoleArn: {
              description: "The role that needs to be assumed while publishing this asset (Default - No role will be assumed)",
              type: "string"
            },
            assumeRoleExternalId: {
              description: "The ExternalId that needs to be supplied while assuming this role (Default - No ExternalId will be supplied)",
              type: "string"
            }
          },
          required: [
            "bucketName",
            "objectKey"
          ]
        },
        DockerImageAsset: {
          description: "A file asset",
          type: "object",
          properties: {
            source: {
              $ref: "#/definitions/DockerImageSource",
              description: "Source description for file assets"
            },
            destinations: {
              description: "Destinations for this file asset",
              type: "object",
              additionalProperties: {
                $ref: "#/definitions/DockerImageDestination"
              }
            }
          },
          required: [
            "destinations",
            "source"
          ]
        },
        DockerImageSource: {
          description: "Properties for how to produce a Docker image from a source",
          type: "object",
          properties: {
            directory: {
              description: "The directory containing the Docker image build instructions.\n\nThis path is relative to the asset manifest location. (Default - Exactly one of `directory` and `executable` is required)",
              type: "string"
            },
            executable: {
              description: "A command-line executable that returns the name of a local\nDocker image on stdout after being run. (Default - Exactly one of `directory` and `executable` is required)",
              type: "array",
              items: {
                type: "string"
              }
            },
            dockerFile: {
              description: "The name of the file with build instructions\n\nOnly allowed when `directory` is set. (Default Dockerfile)",
              type: "string"
            },
            dockerBuildTarget: {
              description: "Target build stage in a Dockerfile with multiple build stages\n\nOnly allowed when `directory` is set. (Default - The last stage in the Dockerfile)",
              type: "string"
            },
            dockerBuildArgs: {
              description: "Additional build arguments\n\nOnly allowed when `directory` is set. (Default - No additional build arguments)",
              type: "object",
              additionalProperties: {
                type: "string"
              }
            },
            dockerBuildSecrets: {
              description: "Additional build secrets\n\nOnly allowed when `directory` is set. (Default - No additional build secrets)",
              type: "object",
              additionalProperties: {
                type: "string"
              }
            },
            networkMode: {
              description: "Networking mode for the RUN commands during build. _Requires Docker Engine API v1.25+_.\n\nSpecify this property to build images on a specific networking mode. (Default - no networking mode specified)",
              type: "string"
            },
            platform: {
              description: "Platform to build for. _Requires Docker Buildx_.\n\nSpecify this property to build images on a specific platform/architecture. (Default - current machine platform)",
              type: "string"
            },
            dockerOutputs: {
              description: "Outputs (Default - no outputs are passed to the build command (default outputs are used))",
              type: "array",
              items: {
                type: "string"
              }
            },
            cacheFrom: {
              description: "Cache from options to pass to the `docker build` command. (Default - no cache from options are passed to the build command)",
              type: "array",
              items: {
                $ref: "#/definitions/DockerCacheOption"
              }
            },
            cacheTo: {
              description: "Cache to options to pass to the `docker build` command. (Default - no cache to options are passed to the build command)",
              $ref: "#/definitions/DockerCacheOption"
            }
          }
        },
        DockerCacheOption: {
          description: "Options for configuring the Docker cache backend",
          type: "object",
          properties: {
            type: {
              description: "The type of cache to use.\nRefer to https://docs.docker.com/build/cache/backends/ for full list of backends. (Default - unspecified)",
              type: "string"
            },
            params: {
              description: "Any parameters to pass into the docker cache backend configuration.\nRefer to https://docs.docker.com/build/cache/backends/ for cache backend configuration. (Default {} No options provided)",
              type: "object",
              additionalProperties: {
                type: "string"
              }
            }
          },
          required: [
            "type"
          ]
        },
        DockerImageDestination: {
          description: "Where to publish docker images",
          type: "object",
          properties: {
            repositoryName: {
              description: "Name of the ECR repository to publish to",
              type: "string"
            },
            imageTag: {
              description: "Tag of the image to publish",
              type: "string"
            },
            region: {
              description: "The region where this asset will need to be published (Default - Current region)",
              type: "string"
            },
            assumeRoleArn: {
              description: "The role that needs to be assumed while publishing this asset (Default - No role will be assumed)",
              type: "string"
            },
            assumeRoleExternalId: {
              description: "The ExternalId that needs to be supplied while assuming this role (Default - No ExternalId will be supplied)",
              type: "string"
            }
          },
          required: [
            "imageTag",
            "repositoryName"
          ]
        }
      },
      $schema: "http://json-schema.org/draft-07/schema#"
    };
  }
});

// node_modules/aws-cdk-lib/cloud-assembly-schema/schema/cloud-assembly.schema.json
var require_cloud_assembly_schema = __commonJS({
  "node_modules/aws-cdk-lib/cloud-assembly-schema/schema/cloud-assembly.schema.json"(exports2, module2) {
    module2.exports = {
      $ref: "#/definitions/AssemblyManifest",
      definitions: {
        AssemblyManifest: {
          description: "A manifest which describes the cloud assembly.",
          type: "object",
          properties: {
            version: {
              description: "Protocol version",
              type: "string"
            },
            artifacts: {
              description: "The set of artifacts in this assembly. (Default - no artifacts.)",
              type: "object",
              additionalProperties: {
                $ref: "#/definitions/ArtifactManifest"
              }
            },
            missing: {
              description: "Missing context information. If this field has values, it means that the\ncloud assembly is not complete and should not be deployed. (Default - no missing context.)",
              type: "array",
              items: {
                $ref: "#/definitions/MissingContext"
              }
            },
            runtime: {
              description: "Runtime information. (Default - no info.)",
              $ref: "#/definitions/RuntimeInfo"
            }
          },
          required: [
            "version"
          ]
        },
        ArtifactManifest: {
          description: "A manifest for a single artifact within the cloud assembly.",
          type: "object",
          properties: {
            type: {
              $ref: "#/definitions/ArtifactType",
              description: "The type of artifact."
            },
            environment: {
              description: "The environment into which this artifact is deployed. (Default - no envrionment.)",
              type: "string"
            },
            metadata: {
              description: "Associated metadata. (Default - no metadata.)",
              type: "object",
              additionalProperties: {
                type: "array",
                items: {
                  $ref: "#/definitions/MetadataEntry"
                }
              }
            },
            dependencies: {
              description: "IDs of artifacts that must be deployed before this artifact. (Default - no dependencies.)",
              type: "array",
              items: {
                type: "string"
              }
            },
            properties: {
              description: "The set of properties for this artifact (depends on type) (Default - no properties.)",
              anyOf: [
                {
                  $ref: "#/definitions/AwsCloudFormationStackProperties"
                },
                {
                  $ref: "#/definitions/AssetManifestProperties"
                },
                {
                  $ref: "#/definitions/TreeArtifactProperties"
                },
                {
                  $ref: "#/definitions/NestedCloudAssemblyProperties"
                }
              ]
            },
            displayName: {
              description: "A string that represents this artifact. Should only be used in user interfaces. (Default - no display name)",
              type: "string"
            }
          },
          required: [
            "type"
          ]
        },
        ArtifactType: {
          description: "Type of cloud artifact.",
          enum: [
            "aws:cloudformation:stack",
            "cdk:asset-manifest",
            "cdk:cloud-assembly",
            "cdk:tree",
            "none"
          ],
          type: "string"
        },
        MetadataEntry: {
          description: "A metadata entry in a cloud assembly artifact.",
          type: "object",
          properties: {
            type: {
              description: "The type of the metadata entry.",
              type: "string"
            },
            data: {
              description: "The data. (Default - no data.)",
              anyOf: [
                {
                  $ref: "#/definitions/FileAssetMetadataEntry"
                },
                {
                  $ref: "#/definitions/ContainerImageAssetMetadataEntry"
                },
                {
                  type: "array",
                  items: {
                    $ref: "#/definitions/Tag"
                  }
                },
                {
                  type: "string"
                },
                {
                  description: "Free form data."
                }
              ]
            },
            trace: {
              description: "A stack trace for when the entry was created. (Default - no trace.)",
              type: "array",
              items: {
                type: "string"
              }
            }
          },
          required: [
            "type"
          ]
        },
        FileAssetMetadataEntry: {
          description: "Metadata Entry spec for files.",
          type: "object",
          properties: {
            packaging: {
              description: "Requested packaging style",
              enum: [
                "file",
                "zip"
              ],
              type: "string"
            },
            s3BucketParameter: {
              description: "Name of parameter where S3 bucket should be passed in",
              type: "string"
            },
            s3KeyParameter: {
              description: "Name of parameter where S3 key should be passed in",
              type: "string"
            },
            artifactHashParameter: {
              description: "The name of the parameter where the hash of the bundled asset should be passed in.",
              type: "string"
            },
            id: {
              description: "Logical identifier for the asset",
              type: "string"
            },
            sourceHash: {
              description: "The hash of the asset source.",
              type: "string"
            },
            path: {
              description: "Path on disk to the asset",
              type: "string"
            }
          },
          required: [
            "artifactHashParameter",
            "id",
            "packaging",
            "path",
            "s3BucketParameter",
            "s3KeyParameter",
            "sourceHash"
          ]
        },
        ContainerImageAssetMetadataEntry: {
          description: "Metadata Entry spec for container images.",
          type: "object",
          properties: {
            packaging: {
              description: "Type of asset",
              type: "string",
              enum: [
                "container-image"
              ]
            },
            imageNameParameter: {
              description: 'ECR Repository name and repo digest (separated by "@sha256:") where this\nimage is stored. (Default undefined If not specified, `repositoryName` and `imageTag` are\nrequired because otherwise how will the stack know where to find the asset,\nha?)',
              type: "string"
            },
            repositoryName: {
              description: "ECR repository name, if omitted a default name based on the asset's ID is\nused instead. Specify this property if you need to statically address the\nimage, e.g. from a Kubernetes Pod. Note, this is only the repository name,\nwithout the registry and the tag parts. (Default - this parameter is REQUIRED after 1.21.0)",
              type: "string"
            },
            imageTag: {
              description: "The docker image tag to use for tagging pushed images. This field is\nrequired if `imageParameterName` is ommited (otherwise, the app won't be\nable to find the image). (Default - this parameter is REQUIRED after 1.21.0)",
              type: "string"
            },
            buildArgs: {
              description: "Build args to pass to the `docker build` command (Default no build args are passed)",
              type: "object",
              additionalProperties: {
                type: "string"
              }
            },
            buildSecrets: {
              description: "Build secrets to pass to the `docker build` command (Default no build secrets are passed)",
              type: "object",
              additionalProperties: {
                type: "string"
              }
            },
            target: {
              description: "Docker target to build to (Default no build target)",
              type: "string"
            },
            file: {
              description: "Path to the Dockerfile (relative to the directory). (Default - no file is passed)",
              type: "string"
            },
            networkMode: {
              description: "Networking mode for the RUN commands during build. (Default - no networking mode specified)",
              type: "string"
            },
            platform: {
              description: "Platform to build for. _Requires Docker Buildx_. (Default - current machine platform)",
              type: "string"
            },
            outputs: {
              description: "Outputs to pass to the `docker build` command. (Default - no outputs are passed to the build command (default outputs are used))",
              type: "array",
              items: {
                type: "string"
              }
            },
            cacheFrom: {
              description: "Cache from options to pass to the `docker build` command. (Default - no cache from options are passed to the build command)",
              type: "array",
              items: {
                $ref: "#/definitions/ContainerImageAssetCacheOption"
              }
            },
            cacheTo: {
              description: "Cache to options to pass to the `docker build` command. (Default - no cache to options are passed to the build command)",
              $ref: "#/definitions/ContainerImageAssetCacheOption"
            },
            id: {
              description: "Logical identifier for the asset",
              type: "string"
            },
            sourceHash: {
              description: "The hash of the asset source.",
              type: "string"
            },
            path: {
              description: "Path on disk to the asset",
              type: "string"
            }
          },
          required: [
            "id",
            "packaging",
            "path",
            "sourceHash"
          ]
        },
        ContainerImageAssetCacheOption: {
          description: "Options for configuring the Docker cache backend",
          type: "object",
          properties: {
            type: {
              description: "The type of cache to use.\nRefer to https://docs.docker.com/build/cache/backends/ for full list of backends. (Default - unspecified)",
              type: "string"
            },
            params: {
              description: "Any parameters to pass into the docker cache backend configuration.\nRefer to https://docs.docker.com/build/cache/backends/ for cache backend configuration. (Default {} No options provided)",
              type: "object",
              additionalProperties: {
                type: "string"
              }
            }
          },
          required: [
            "type"
          ]
        },
        Tag: {
          description: "Metadata Entry spec for stack tag.",
          type: "object",
          properties: {
            key: {
              description: 'Tag key.\n\n(In the actual file on disk this will be cased as "Key", and the structure is\npatched to match this structure upon loading:\nhttps://github.com/aws/aws-cdk/blob/4aadaa779b48f35838cccd4e25107b2338f05547/packages/%40aws-cdk/cloud-assembly-schema/lib/manifest.ts#L137)',
              type: "string"
            },
            value: {
              description: 'Tag value.\n\n(In the actual file on disk this will be cased as "Value", and the structure is\npatched to match this structure upon loading:\nhttps://github.com/aws/aws-cdk/blob/4aadaa779b48f35838cccd4e25107b2338f05547/packages/%40aws-cdk/cloud-assembly-schema/lib/manifest.ts#L137)',
              type: "string"
            }
          },
          required: [
            "key",
            "value"
          ]
        },
        AwsCloudFormationStackProperties: {
          description: "Artifact properties for CloudFormation stacks.",
          type: "object",
          properties: {
            templateFile: {
              description: "A file relative to the assembly root which contains the CloudFormation template for this stack.",
              type: "string"
            },
            parameters: {
              description: "Values for CloudFormation stack parameters that should be passed when the stack is deployed. (Default - No parameters)",
              type: "object",
              additionalProperties: {
                type: "string"
              }
            },
            tags: {
              description: "Values for CloudFormation stack tags that should be passed when the stack is deployed. (Default - No tags)",
              type: "object",
              additionalProperties: {
                type: "string"
              }
            },
            stackName: {
              description: "The name to use for the CloudFormation stack. (Default - name derived from artifact ID)",
              type: "string"
            },
            terminationProtection: {
              description: "Whether to enable termination protection for this stack.",
              default: false,
              type: "boolean"
            },
            assumeRoleArn: {
              description: "The role that needs to be assumed to deploy the stack (Default - No role is assumed (current credentials are used))",
              type: "string"
            },
            assumeRoleExternalId: {
              description: "External ID to use when assuming role for cloudformation deployments (Default - No external ID)",
              type: "string"
            },
            cloudFormationExecutionRoleArn: {
              description: "The role that is passed to CloudFormation to execute the change set (Default - No role is passed (currently assumed role/credentials are used))",
              type: "string"
            },
            lookupRole: {
              description: "The role to use to look up values from the target AWS account (Default - No role is assumed (current credentials are used))",
              $ref: "#/definitions/BootstrapRole"
            },
            stackTemplateAssetObjectUrl: {
              description: "If the stack template has already been included in the asset manifest, its asset URL (Default - Not uploaded yet, upload just before deploying)",
              type: "string"
            },
            requiresBootstrapStackVersion: {
              description: "Version of bootstrap stack required to deploy this stack (Default - No bootstrap stack required)",
              type: "number"
            },
            bootstrapStackVersionSsmParameter: {
              description: "SSM parameter where the bootstrap stack version number can be found\n\nOnly used if `requiresBootstrapStackVersion` is set.\n\n- If this value is not set, the bootstrap stack name must be known at\n  deployment time so the stack version can be looked up from the stack\n  outputs.\n- If this value is set, the bootstrap stack can have any name because\n  we won't need to look it up. (Default - Bootstrap stack version number looked up)",
              type: "string"
            },
            validateOnSynth: {
              description: "Whether this stack should be validated by the CLI after synthesis (Default - false)",
              type: "boolean"
            }
          },
          required: [
            "templateFile"
          ]
        },
        BootstrapRole: {
          description: "Information needed to access an IAM role created\nas part of the bootstrap process",
          type: "object",
          properties: {
            arn: {
              description: "The ARN of the IAM role created as part of bootrapping\ne.g. lookupRoleArn",
              type: "string"
            },
            assumeRoleExternalId: {
              description: "External ID to use when assuming the bootstrap role (Default - No external ID)",
              type: "string"
            },
            requiresBootstrapStackVersion: {
              description: "Version of bootstrap stack required to use this role (Default - No bootstrap stack required)",
              type: "number"
            },
            bootstrapStackVersionSsmParameter: {
              description: "Name of SSM parameter with bootstrap stack version (Default - Discover SSM parameter by reading stack)",
              type: "string"
            }
          },
          required: [
            "arn"
          ]
        },
        AssetManifestProperties: {
          description: "Artifact properties for the Asset Manifest",
          type: "object",
          properties: {
            file: {
              description: "Filename of the asset manifest",
              type: "string"
            },
            requiresBootstrapStackVersion: {
              description: "Version of bootstrap stack required to deploy this stack (Default - Version 1 (basic modern bootstrap stack))",
              type: "number"
            },
            bootstrapStackVersionSsmParameter: {
              description: "SSM parameter where the bootstrap stack version number can be found\n\n- If this value is not set, the bootstrap stack name must be known at\n  deployment time so the stack version can be looked up from the stack\n  outputs.\n- If this value is set, the bootstrap stack can have any name because\n  we won't need to look it up. (Default - Bootstrap stack version number looked up)",
              type: "string"
            }
          },
          required: [
            "file"
          ]
        },
        TreeArtifactProperties: {
          description: "Artifact properties for the Construct Tree Artifact",
          type: "object",
          properties: {
            file: {
              description: "Filename of the tree artifact",
              type: "string"
            }
          },
          required: [
            "file"
          ]
        },
        NestedCloudAssemblyProperties: {
          description: "Artifact properties for nested cloud assemblies",
          type: "object",
          properties: {
            directoryName: {
              description: "Relative path to the nested cloud assembly",
              type: "string"
            },
            displayName: {
              description: "Display name for the cloud assembly (Default - The artifact ID)",
              type: "string"
            }
          },
          required: [
            "directoryName"
          ]
        },
        MissingContext: {
          description: "Represents a missing piece of context.",
          type: "object",
          properties: {
            key: {
              description: "The missing context key.",
              type: "string"
            },
            provider: {
              $ref: "#/definitions/ContextProvider",
              description: "The provider from which we expect this context key to be obtained."
            },
            props: {
              $ref: "#/definitions/ContextQueryProperties",
              description: "A set of provider-specific options."
            }
          },
          required: [
            "key",
            "props",
            "provider"
          ]
        },
        ContextProvider: {
          description: "Identifier for the context provider",
          enum: [
            "ami",
            "availability-zones",
            "endpoint-service-availability-zones",
            "hosted-zone",
            "key-provider",
            "load-balancer",
            "load-balancer-listener",
            "plugin",
            "security-group",
            "ssm",
            "vpc-provider"
          ],
          type: "string"
        },
        ContextQueryProperties: {
          anyOf: [
            {
              $ref: "#/definitions/AmiContextQuery"
            },
            {
              $ref: "#/definitions/AvailabilityZonesContextQuery"
            },
            {
              $ref: "#/definitions/HostedZoneContextQuery"
            },
            {
              $ref: "#/definitions/SSMParameterContextQuery"
            },
            {
              $ref: "#/definitions/VpcContextQuery"
            },
            {
              $ref: "#/definitions/EndpointServiceAvailabilityZonesContextQuery"
            },
            {
              $ref: "#/definitions/LoadBalancerContextQuery"
            },
            {
              $ref: "#/definitions/LoadBalancerListenerContextQuery"
            },
            {
              $ref: "#/definitions/SecurityGroupContextQuery"
            },
            {
              $ref: "#/definitions/KeyContextQuery"
            },
            {
              $ref: "#/definitions/PluginContextQuery"
            }
          ]
        },
        AmiContextQuery: {
          description: "Query to AMI context provider",
          type: "object",
          properties: {
            account: {
              description: "Account to query",
              type: "string"
            },
            region: {
              description: "Region to query",
              type: "string"
            },
            lookupRoleArn: {
              description: "The ARN of the role that should be used to look up the missing values (Default - None)",
              type: "string"
            },
            owners: {
              description: "Owners to DescribeImages call (Default - All owners)",
              type: "array",
              items: {
                type: "string"
              }
            },
            filters: {
              description: "Filters to DescribeImages call",
              type: "object",
              additionalProperties: {
                type: "array",
                items: {
                  type: "string"
                }
              }
            }
          },
          required: [
            "account",
            "filters",
            "region"
          ]
        },
        AvailabilityZonesContextQuery: {
          description: "Query to availability zone context provider",
          type: "object",
          properties: {
            account: {
              description: "Query account",
              type: "string"
            },
            region: {
              description: "Query region",
              type: "string"
            },
            lookupRoleArn: {
              description: "The ARN of the role that should be used to look up the missing values (Default - None)",
              type: "string"
            }
          },
          required: [
            "account",
            "region"
          ]
        },
        HostedZoneContextQuery: {
          description: "Query to hosted zone context provider",
          type: "object",
          properties: {
            account: {
              description: "Query account",
              type: "string"
            },
            region: {
              description: "Query region",
              type: "string"
            },
            lookupRoleArn: {
              description: "The ARN of the role that should be used to look up the missing values (Default - None)",
              type: "string"
            },
            domainName: {
              description: "The domain name e.g. example.com to lookup",
              type: "string"
            },
            privateZone: {
              description: "True if the zone you want to find is a private hosted zone",
              default: false,
              type: "boolean"
            },
            vpcId: {
              description: "The VPC ID to that the private zone must be associated with\n\nIf you provide VPC ID and privateZone is false, this will return no results\nand raise an error. (Default - Required if privateZone=true)",
              type: "string"
            }
          },
          required: [
            "account",
            "domainName",
            "region"
          ]
        },
        SSMParameterContextQuery: {
          description: "Query to SSM Parameter Context Provider",
          type: "object",
          properties: {
            account: {
              description: "Query account",
              type: "string"
            },
            region: {
              description: "Query region",
              type: "string"
            },
            lookupRoleArn: {
              description: "The ARN of the role that should be used to look up the missing values (Default - None)",
              type: "string"
            },
            parameterName: {
              description: "Parameter name to query",
              type: "string"
            }
          },
          required: [
            "account",
            "parameterName",
            "region"
          ]
        },
        VpcContextQuery: {
          description: "Query input for looking up a VPC",
          type: "object",
          properties: {
            account: {
              description: "Query account",
              type: "string"
            },
            region: {
              description: "Query region",
              type: "string"
            },
            lookupRoleArn: {
              description: "The ARN of the role that should be used to look up the missing values (Default - None)",
              type: "string"
            },
            filter: {
              description: "Filters to apply to the VPC\n\nFilter parameters are the same as passed to DescribeVpcs.",
              type: "object",
              additionalProperties: {
                type: "string"
              }
            },
            returnAsymmetricSubnets: {
              description: "Whether to populate the subnetGroups field of the `VpcContextResponse`,\nwhich contains potentially asymmetric subnet groups.",
              default: false,
              type: "boolean"
            },
            subnetGroupNameTag: {
              description: "Optional tag for subnet group name.\nIf not provided, we'll look at the aws-cdk:subnet-name tag.\nIf the subnet does not have the specified tag,\nwe'll use its type as the name. (Default 'aws-cdk:subnet-name')",
              type: "string"
            },
            returnVpnGateways: {
              description: "Whether to populate the `vpnGatewayId` field of the `VpcContextResponse`,\nwhich contains the VPN Gateway ID, if one exists. You can explicitly\ndisable this in order to avoid the lookup if you know the VPC does not have\na VPN Gatway attached. (Default true)",
              type: "boolean"
            }
          },
          required: [
            "account",
            "filter",
            "region"
          ]
        },
        EndpointServiceAvailabilityZonesContextQuery: {
          description: "Query to endpoint service context provider",
          type: "object",
          properties: {
            account: {
              description: "Query account",
              type: "string"
            },
            region: {
              description: "Query region",
              type: "string"
            },
            lookupRoleArn: {
              description: "The ARN of the role that should be used to look up the missing values (Default - None)",
              type: "string"
            },
            serviceName: {
              description: "Query service name",
              type: "string"
            }
          },
          required: [
            "account",
            "region",
            "serviceName"
          ]
        },
        LoadBalancerContextQuery: {
          description: "Query input for looking up a load balancer",
          type: "object",
          properties: {
            account: {
              description: "Query account",
              type: "string"
            },
            region: {
              description: "Query region",
              type: "string"
            },
            lookupRoleArn: {
              description: "The ARN of the role that should be used to look up the missing values (Default - None)",
              type: "string"
            },
            loadBalancerType: {
              $ref: "#/definitions/LoadBalancerType",
              description: "Filter load balancers by their type"
            },
            loadBalancerArn: {
              description: "Find by load balancer's ARN (Default - does not search by load balancer arn)",
              type: "string"
            },
            loadBalancerTags: {
              description: "Match load balancer tags (Default - does not match load balancers by tags)",
              type: "array",
              items: {
                $ref: "#/definitions/Tag"
              }
            }
          },
          required: [
            "account",
            "loadBalancerType",
            "region"
          ]
        },
        LoadBalancerType: {
          description: "Type of load balancer",
          enum: [
            "application",
            "network"
          ],
          type: "string"
        },
        LoadBalancerListenerContextQuery: {
          description: "Query input for looking up a load balancer listener",
          type: "object",
          properties: {
            account: {
              description: "Query account",
              type: "string"
            },
            region: {
              description: "Query region",
              type: "string"
            },
            lookupRoleArn: {
              description: "The ARN of the role that should be used to look up the missing values (Default - None)",
              type: "string"
            },
            listenerArn: {
              description: "Find by listener's arn (Default - does not find by listener arn)",
              type: "string"
            },
            listenerProtocol: {
              description: "Filter by listener protocol (Default - does not filter by listener protocol)",
              enum: [
                "HTTP",
                "HTTPS",
                "TCP",
                "TCP_UDP",
                "TLS",
                "UDP"
              ],
              type: "string"
            },
            listenerPort: {
              description: "Filter listeners by listener port (Default - does not filter by a listener port)",
              type: "number"
            },
            loadBalancerType: {
              $ref: "#/definitions/LoadBalancerType",
              description: "Filter load balancers by their type"
            },
            loadBalancerArn: {
              description: "Find by load balancer's ARN (Default - does not search by load balancer arn)",
              type: "string"
            },
            loadBalancerTags: {
              description: "Match load balancer tags (Default - does not match load balancers by tags)",
              type: "array",
              items: {
                $ref: "#/definitions/Tag"
              }
            }
          },
          required: [
            "account",
            "loadBalancerType",
            "region"
          ]
        },
        SecurityGroupContextQuery: {
          description: "Query input for looking up a security group",
          type: "object",
          properties: {
            account: {
              description: "Query account",
              type: "string"
            },
            region: {
              description: "Query region",
              type: "string"
            },
            lookupRoleArn: {
              description: "The ARN of the role that should be used to look up the missing values (Default - None)",
              type: "string"
            },
            securityGroupId: {
              description: "Security group id (Default - None)",
              type: "string"
            },
            securityGroupName: {
              description: "Security group name (Default - None)",
              type: "string"
            },
            vpcId: {
              description: "VPC ID (Default - None)",
              type: "string"
            }
          },
          required: [
            "account",
            "region"
          ]
        },
        KeyContextQuery: {
          description: "Query input for looking up a KMS Key",
          type: "object",
          properties: {
            account: {
              description: "Query account",
              type: "string"
            },
            region: {
              description: "Query region",
              type: "string"
            },
            lookupRoleArn: {
              description: "The ARN of the role that should be used to look up the missing values (Default - None)",
              type: "string"
            },
            aliasName: {
              description: "Alias name used to search the Key",
              type: "string"
            }
          },
          required: [
            "account",
            "aliasName",
            "region"
          ]
        },
        PluginContextQuery: {
          description: "Query input for plugins\n\nThis alternate branch is necessary because it needs to be able to escape all type checking\nwe do on on the cloud assembly -- we cannot know the properties that will be used a priori.",
          type: "object",
          additionalProperties: {},
          properties: {
            pluginName: {
              description: "The name of the plugin",
              type: "string"
            }
          },
          required: [
            "pluginName"
          ]
        },
        RuntimeInfo: {
          description: "Information about the application's runtime components.",
          type: "object",
          properties: {
            libraries: {
              description: "The list of libraries loaded in the application, associated with their versions.",
              type: "object",
              additionalProperties: {
                type: "string"
              }
            }
          },
          required: [
            "libraries"
          ]
        }
      },
      $schema: "http://json-schema.org/draft-07/schema#"
    };
  }
});

// node_modules/aws-cdk-lib/cloud-assembly-schema/schema/cloud-assembly.version.json
var require_cloud_assembly_version = __commonJS({
  "node_modules/aws-cdk-lib/cloud-assembly-schema/schema/cloud-assembly.version.json"(exports2, module2) {
    module2.exports = { version: "31.0.0" };
  }
});

// node_modules/aws-cdk-lib/cloud-assembly-schema/schema/integ.schema.json
var require_integ_schema = __commonJS({
  "node_modules/aws-cdk-lib/cloud-assembly-schema/schema/integ.schema.json"(exports2, module2) {
    module2.exports = {
      $ref: "#/definitions/IntegManifest",
      definitions: {
        IntegManifest: {
          description: "Definitions for the integration testing manifest",
          type: "object",
          properties: {
            version: {
              description: "Version of the manifest",
              type: "string"
            },
            enableLookups: {
              description: "Enable lookups for this test. If lookups are enabled\nthen `stackUpdateWorkflow` must be set to false.\nLookups should only be enabled when you are explicitely testing\nlookups.",
              default: false,
              type: "boolean"
            },
            synthContext: {
              description: "Additional context to use when performing\na synth. Any context provided here will override\nany default context (Default - no additional context)",
              type: "object",
              additionalProperties: {
                type: "string"
              }
            },
            testCases: {
              description: "test cases",
              type: "object",
              additionalProperties: {
                $ref: "#/definitions/TestCase"
              }
            }
          },
          required: [
            "testCases",
            "version"
          ]
        },
        TestCase: {
          description: "Represents an integration test case",
          type: "object",
          properties: {
            stacks: {
              description: "Stacks that should be tested as part of this test case\nThe stackNames will be passed as args to the cdk commands\nso dependent stacks will be automatically deployed unless\n`exclusively` is passed",
              type: "array",
              items: {
                type: "string"
              }
            },
            assertionStack: {
              description: "The node id of the stack that contains assertions.\nThis is the value that can be used to deploy the stack with the CDK CLI (Default - no assertion stack)",
              type: "string"
            },
            assertionStackName: {
              description: "The name of the stack that contains assertions (Default - no assertion stack)",
              type: "string"
            },
            stackUpdateWorkflow: {
              description: "Run update workflow on this test case\nThis should only be set to false to test scenarios\nthat are not possible to test as part of the update workflow (Default true)",
              type: "boolean"
            },
            cdkCommandOptions: {
              description: "Additional options to use for each CDK command (Default - runner default options)",
              $ref: "#/definitions/CdkCommands"
            },
            hooks: {
              description: "Additional commands to run at predefined points in the test workflow\n\ne.g. { postDeploy: ['yarn', 'test'] } (Default - no hooks)",
              $ref: "#/definitions/Hooks"
            },
            diffAssets: {
              description: "Whether or not to include asset hashes in the diff\nAsset hashes can introduces a lot of unneccessary noise into tests,\nbut there are some cases where asset hashes _should_ be included. For example\nany tests involving custom resources or bundling",
              default: false,
              type: "boolean"
            },
            allowDestroy: {
              description: "List of CloudFormation resource types in this stack that can\nbe destroyed as part of an update without failing the test.\n\nThis list should only include resources that for this specific\nintegration test we are sure will not cause errors or an outage if\ndestroyed. For example, maybe we know that a new resource will be created\nfirst before the old resource is destroyed which prevents any outage.\n\ne.g. ['AWS::IAM::Role'] (Default - do not allow destruction of any resources on update)",
              type: "array",
              items: {
                type: "string"
              }
            },
            regions: {
              description: "Limit deployment to these regions (Default - can run in any region)",
              type: "array",
              items: {
                type: "string"
              }
            }
          },
          required: [
            "stacks"
          ]
        },
        CdkCommands: {
          description: "Options for specific cdk commands that are run\nas part of the integration test workflow",
          type: "object",
          properties: {
            deploy: {
              description: "Options to for the cdk deploy command (Default - default deploy options)",
              $ref: "#/definitions/DeployCommand"
            },
            destroy: {
              description: "Options to for the cdk destroy command (Default - default destroy options)",
              $ref: "#/definitions/DestroyCommand"
            }
          }
        },
        DeployCommand: {
          description: "Represents a cdk deploy command",
          type: "object",
          properties: {
            args: {
              description: "Additional arguments to pass to the command\nThis can be used to test specific CLI functionality (Default - only default args are used)",
              $ref: "#/definitions/DeployOptions"
            },
            enabled: {
              description: "Whether or not to run this command as part of the workflow\nThis can be used if you only want to test some of the workflow\nfor example enable `synth` and disable `deploy` & `destroy` in order\nto limit the test to synthesis (Default true)",
              type: "boolean"
            },
            expectError: {
              description: "If the runner should expect this command to fail",
              default: false,
              type: "boolean"
            },
            expectedMessage: {
              description: "This can be used in combination with `expectedError`\nto validate that a specific message is returned. (Default - do not validate message)",
              type: "string"
            }
          }
        },
        DeployOptions: {
          description: "Options to use with cdk deploy",
          type: "object",
          properties: {
            exclusively: {
              description: "Only perform action on the given stack",
              default: false,
              type: "boolean"
            },
            toolkitStackName: {
              description: "Name of the toolkit stack to use/deploy (Default CDKToolkit)",
              type: "string"
            },
            reuseAssets: {
              description: "Reuse the assets with the given asset IDs (Default - do not reuse assets)",
              type: "array",
              items: {
                type: "string"
              }
            },
            changeSetName: {
              description: "Optional name to use for the CloudFormation change set.\nIf not provided, a name will be generated automatically. (Default - auto generate a name)",
              type: "string"
            },
            force: {
              description: "Always deploy, even if templates are identical.",
              default: false,
              type: "boolean"
            },
            rollback: {
              description: "Rollback failed deployments (Default true)",
              type: "boolean"
            },
            notificationArns: {
              description: "ARNs of SNS topics that CloudFormation will notify with stack related events (Default - no notifications)",
              type: "array",
              items: {
                type: "string"
              }
            },
            requireApproval: {
              description: "What kind of security changes require approval (Default RequireApproval.Never)",
              enum: [
                "any-change",
                "broadening",
                "never"
              ],
              type: "string"
            },
            execute: {
              description: "Whether to execute the ChangeSet\nNot providing `execute` parameter will result in execution of ChangeSet (Default true)",
              type: "boolean"
            },
            parameters: {
              description: "Additional parameters for CloudFormation at deploy time (Default [object Object])",
              type: "object",
              additionalProperties: {
                type: "string"
              }
            },
            usePreviousParameters: {
              description: "Use previous values for unspecified parameters\n\nIf not set, all parameters must be specified for every deployment. (Default true)",
              type: "boolean"
            },
            outputsFile: {
              description: "Path to file where stack outputs will be written after a successful deploy as JSON (Default - Outputs are not written to any file)",
              type: "string"
            },
            ci: {
              description: "Whether we are on a CI system",
              default: false,
              type: "boolean"
            },
            stacks: {
              description: "List of stacks to deploy\n\nRequried if `all` is not set (Default - [])",
              type: "array",
              items: {
                type: "string"
              }
            },
            all: {
              description: "Deploy all stacks\n\nRequried if `stacks` is not set (Default - false)",
              type: "boolean"
            },
            app: {
              description: 'command-line for executing your app or a cloud assembly directory\ne.g. "node bin/my-app.js"\nor\n"cdk.out" (Default - read from cdk.json)',
              type: "string"
            },
            roleArn: {
              description: "Role to pass to CloudFormation for deployment (Default - use the bootstrap cfn-exec role)",
              type: "string"
            },
            context: {
              description: "Additional context (Default - no additional context)",
              type: "object",
              additionalProperties: {
                type: "string"
              }
            },
            trace: {
              description: "Print trace for stack warnings",
              default: false,
              type: "boolean"
            },
            strict: {
              description: "Do not construct stacks with warnings",
              default: false,
              type: "boolean"
            },
            lookups: {
              description: "Perform context lookups.\n\nSynthesis fails if this is disabled and context lookups need\nto be performed (Default true)",
              type: "boolean"
            },
            ignoreErrors: {
              description: "Ignores synthesis errors, which will likely produce an invalid output",
              default: false,
              type: "boolean"
            },
            json: {
              description: "Use JSON output instead of YAML when templates are printed\nto STDOUT",
              default: false,
              type: "boolean"
            },
            verbose: {
              description: "show debug logs",
              default: false,
              type: "boolean"
            },
            debug: {
              description: "enable emission of additional debugging information, such as creation stack\ntraces of tokens",
              default: false,
              type: "boolean"
            },
            profile: {
              description: "Use the indicated AWS profile as the default environment (Default - no profile is used)",
              type: "string"
            },
            proxy: {
              description: "Use the indicated proxy. Will read from\nHTTPS_PROXY environment if specified (Default - no proxy)",
              type: "string"
            },
            caBundlePath: {
              description: "Path to CA certificate to use when validating HTTPS\nrequests. (Default - read from AWS_CA_BUNDLE environment variable)",
              type: "string"
            },
            ec2Creds: {
              description: "Force trying to fetch EC2 instance credentials (Default - guess EC2 instance status)",
              type: "boolean"
            },
            versionReporting: {
              description: 'Include "AWS::CDK::Metadata" resource in synthesized templates (Default true)',
              type: "boolean"
            },
            pathMetadata: {
              description: 'Include "aws:cdk:path" CloudFormation metadata for each resource (Default true)',
              type: "boolean"
            },
            assetMetadata: {
              description: 'Include "aws:asset:*" CloudFormation metadata for resources that use assets (Default true)',
              type: "boolean"
            },
            staging: {
              description: "Copy assets to the output directory\n\nNeeded for local debugging the source files with SAM CLI",
              default: false,
              type: "boolean"
            },
            output: {
              description: "Emits the synthesized cloud assembly into a directory (Default cdk.out)",
              type: "string"
            },
            notices: {
              description: "Show relevant notices (Default true)",
              type: "boolean"
            },
            color: {
              description: "Show colors and other style from console output (Default true)",
              type: "boolean"
            }
          }
        },
        DestroyCommand: {
          description: "Represents a cdk destroy command",
          type: "object",
          properties: {
            args: {
              description: "Additional arguments to pass to the command\nThis can be used to test specific CLI functionality (Default - only default args are used)",
              $ref: "#/definitions/DestroyOptions"
            },
            enabled: {
              description: "Whether or not to run this command as part of the workflow\nThis can be used if you only want to test some of the workflow\nfor example enable `synth` and disable `deploy` & `destroy` in order\nto limit the test to synthesis (Default true)",
              type: "boolean"
            },
            expectError: {
              description: "If the runner should expect this command to fail",
              default: false,
              type: "boolean"
            },
            expectedMessage: {
              description: "This can be used in combination with `expectedError`\nto validate that a specific message is returned. (Default - do not validate message)",
              type: "string"
            }
          }
        },
        DestroyOptions: {
          description: "Options to use with cdk destroy",
          type: "object",
          properties: {
            force: {
              description: "Do not ask for permission before destroying stacks",
              default: false,
              type: "boolean"
            },
            exclusively: {
              description: "Only destroy the given stack",
              default: false,
              type: "boolean"
            },
            stacks: {
              description: "List of stacks to deploy\n\nRequried if `all` is not set (Default - [])",
              type: "array",
              items: {
                type: "string"
              }
            },
            all: {
              description: "Deploy all stacks\n\nRequried if `stacks` is not set (Default - false)",
              type: "boolean"
            },
            app: {
              description: 'command-line for executing your app or a cloud assembly directory\ne.g. "node bin/my-app.js"\nor\n"cdk.out" (Default - read from cdk.json)',
              type: "string"
            },
            roleArn: {
              description: "Role to pass to CloudFormation for deployment (Default - use the bootstrap cfn-exec role)",
              type: "string"
            },
            context: {
              description: "Additional context (Default - no additional context)",
              type: "object",
              additionalProperties: {
                type: "string"
              }
            },
            trace: {
              description: "Print trace for stack warnings",
              default: false,
              type: "boolean"
            },
            strict: {
              description: "Do not construct stacks with warnings",
              default: false,
              type: "boolean"
            },
            lookups: {
              description: "Perform context lookups.\n\nSynthesis fails if this is disabled and context lookups need\nto be performed (Default true)",
              type: "boolean"
            },
            ignoreErrors: {
              description: "Ignores synthesis errors, which will likely produce an invalid output",
              default: false,
              type: "boolean"
            },
            json: {
              description: "Use JSON output instead of YAML when templates are printed\nto STDOUT",
              default: false,
              type: "boolean"
            },
            verbose: {
              description: "show debug logs",
              default: false,
              type: "boolean"
            },
            debug: {
              description: "enable emission of additional debugging information, such as creation stack\ntraces of tokens",
              default: false,
              type: "boolean"
            },
            profile: {
              description: "Use the indicated AWS profile as the default environment (Default - no profile is used)",
              type: "string"
            },
            proxy: {
              description: "Use the indicated proxy. Will read from\nHTTPS_PROXY environment if specified (Default - no proxy)",
              type: "string"
            },
            caBundlePath: {
              description: "Path to CA certificate to use when validating HTTPS\nrequests. (Default - read from AWS_CA_BUNDLE environment variable)",
              type: "string"
            },
            ec2Creds: {
              description: "Force trying to fetch EC2 instance credentials (Default - guess EC2 instance status)",
              type: "boolean"
            },
            versionReporting: {
              description: 'Include "AWS::CDK::Metadata" resource in synthesized templates (Default true)',
              type: "boolean"
            },
            pathMetadata: {
              description: 'Include "aws:cdk:path" CloudFormation metadata for each resource (Default true)',
              type: "boolean"
            },
            assetMetadata: {
              description: 'Include "aws:asset:*" CloudFormation metadata for resources that use assets (Default true)',
              type: "boolean"
            },
            staging: {
              description: "Copy assets to the output directory\n\nNeeded for local debugging the source files with SAM CLI",
              default: false,
              type: "boolean"
            },
            output: {
              description: "Emits the synthesized cloud assembly into a directory (Default cdk.out)",
              type: "string"
            },
            notices: {
              description: "Show relevant notices (Default true)",
              type: "boolean"
            },
            color: {
              description: "Show colors and other style from console output (Default true)",
              type: "boolean"
            }
          }
        },
        Hooks: {
          description: "Commands to run at predefined points during the\nintegration test workflow",
          type: "object",
          properties: {
            preDeploy: {
              description: "Commands to run prior to deploying the cdk stacks\nin the integration test (Default - no commands)",
              type: "array",
              items: {
                type: "string"
              }
            },
            postDeploy: {
              description: "Commands to run prior after deploying the cdk stacks\nin the integration test (Default - no commands)",
              type: "array",
              items: {
                type: "string"
              }
            },
            preDestroy: {
              description: "Commands to run prior to destroying the cdk stacks\nin the integration test (Default - no commands)",
              type: "array",
              items: {
                type: "string"
              }
            },
            postDestroy: {
              description: "Commands to run after destroying the cdk stacks\nin the integration test (Default - no commands)",
              type: "array",
              items: {
                type: "string"
              }
            }
          }
        }
      },
      $schema: "http://json-schema.org/draft-07/schema#"
    };
  }
});

// node_modules/aws-cdk-lib/cloud-assembly-schema/lib/manifest.js
var require_manifest = __commonJS({
  "node_modules/aws-cdk-lib/cloud-assembly-schema/lib/manifest.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Manifest = exports2.VERSION_MISMATCH = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var fs = require("fs");
    var jsonschema = require_lib3();
    var semver = require_semver2();
    var assembly = require_cloud_assembly();
    exports2.VERSION_MISMATCH = "Cloud assembly schema version mismatch";
    var ASSETS_SCHEMA = require_assets_schema();
    var ASSEMBLY_SCHEMA = require_cloud_assembly_schema();
    var SCHEMA_VERSION = require_cloud_assembly_version().version;
    var INTEG_SCHEMA = require_integ_schema();
    var Manifest = class _Manifest {
      static saveAssemblyManifest(manifest, filePath) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_cloud_assembly_schema_AssemblyManifest(manifest);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.saveAssemblyManifest), error;
        }
        _Manifest.saveManifest(manifest, filePath, ASSEMBLY_SCHEMA, _Manifest.patchStackTagsOnWrite);
      }
      static loadAssemblyManifest(filePath, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_cloud_assembly_schema_LoadManifestOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.loadAssemblyManifest), error;
        }
        return _Manifest.loadManifest(filePath, ASSEMBLY_SCHEMA, _Manifest.patchStackTagsOnRead, options);
      }
      static saveAssetManifest(manifest, filePath) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_cloud_assembly_schema_AssetManifest(manifest);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.saveAssetManifest), error;
        }
        _Manifest.saveManifest(manifest, filePath, ASSETS_SCHEMA, _Manifest.patchStackTagsOnRead);
      }
      static loadAssetManifest(filePath) {
        return this.loadManifest(filePath, ASSETS_SCHEMA);
      }
      static saveIntegManifest(manifest, filePath) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_cloud_assembly_schema_IntegManifest(manifest);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.saveIntegManifest), error;
        }
        _Manifest.saveManifest(manifest, filePath, INTEG_SCHEMA);
      }
      static loadIntegManifest(filePath) {
        return this.loadManifest(filePath, INTEG_SCHEMA);
      }
      static version() {
        return SCHEMA_VERSION;
      }
      static save(manifest, filePath) {
        return this.saveAssemblyManifest(manifest, filePath);
      }
      static load(filePath) {
        return this.loadAssemblyManifest(filePath);
      }
      static validate(manifest, schema, options) {
        function parseVersion(version) {
          const ver = semver.valid(version);
          if (!ver)
            throw new Error(`Invalid semver string: "${version}"`);
          return ver;
        }
        const maxSupported = parseVersion(_Manifest.version()), actual = parseVersion(manifest.version);
        if (semver.gt(actual, maxSupported) && !options?.skipVersionCheck)
          throw new Error(`${exports2.VERSION_MISMATCH}: Maximum schema version supported is ${maxSupported}, but found ${actual}`);
        let errors = new jsonschema.Validator().validate(manifest, schema, { nestedErrors: true, allowUnknownAttributes: false }).errors;
        if (options?.skipEnumCheck && (errors = stripEnumErrors(errors)), errors.length > 0)
          throw new Error(`Invalid assembly manifest:
${errors.map((e) => e.stack).join(`
`)}`);
      }
      static saveManifest(manifest, filePath, schema, preprocess) {
        let withVersion = { ...manifest, version: _Manifest.version() };
        _Manifest.validate(withVersion, schema), preprocess && (withVersion = preprocess(withVersion)), fs.writeFileSync(filePath, JSON.stringify(withVersion, void 0, 2));
      }
      static loadManifest(filePath, schema, preprocess, options) {
        const contents = fs.readFileSync(filePath, { encoding: "utf-8" });
        let obj;
        try {
          obj = JSON.parse(contents);
        } catch (e) {
          throw new Error(`${e.message}, while parsing ${JSON.stringify(contents)}`);
        }
        return preprocess && (obj = preprocess(obj)), _Manifest.validate(obj, schema, options), obj;
      }
      static patchStackTagsOnRead(manifest) {
        return _Manifest.replaceStackTags(manifest, (tags) => tags.map((diskTag) => ({ key: diskTag.Key, value: diskTag.Value })));
      }
      static patchStackTagsOnWrite(manifest) {
        return _Manifest.replaceStackTags(manifest, (tags) => tags.map((memTag) => "Key" in memTag ? memTag : { Key: memTag.key, Value: memTag.value }));
      }
      static replaceStackTags(manifest, fn) {
        return noUndefined({ ...manifest, artifacts: mapValues(manifest.artifacts, (artifact) => artifact.type !== assembly.ArtifactType.AWS_CLOUDFORMATION_STACK ? artifact : noUndefined({ ...artifact, metadata: mapValues(artifact.metadata, (metadataEntries) => metadataEntries.map((metadataEntry) => metadataEntry.type !== assembly.ArtifactMetadataEntryType.STACK_TAGS || !metadataEntry.data ? metadataEntry : { ...metadataEntry, data: fn(metadataEntry.data) })) })) });
      }
      constructor() {
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Manifest[_a] = { fqn: "aws-cdk-lib.cloud_assembly_schema.Manifest", version: "2.80.0" }, exports2.Manifest = Manifest;
    function mapValues(xs, fn) {
      if (!xs)
        return;
      const ret = {};
      for (const [k, v] of Object.entries(xs))
        ret[k] = fn(v);
      return ret;
    }
    function noUndefined(xs) {
      const ret = {};
      for (const [k, v] of Object.entries(xs))
        v !== void 0 && (ret[k] = v);
      return ret;
    }
    function stripEnumErrors(errors) {
      return errors.filter((e) => typeof e.schema == "string" || !("enum" in e.schema));
    }
  }
});

// node_modules/aws-cdk-lib/cloud-assembly-schema/lib/integ-tests/schema.js
var require_schema3 = __commonJS({
  "node_modules/aws-cdk-lib/cloud-assembly-schema/lib/integ-tests/schema.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/cloud-assembly-schema/lib/integ-tests/commands/common.js
var require_common = __commonJS({
  "node_modules/aws-cdk-lib/cloud-assembly-schema/lib/integ-tests/commands/common.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.RequireApproval = void 0;
    var RequireApproval;
    (function(RequireApproval2) {
      RequireApproval2.NEVER = "never", RequireApproval2.ANYCHANGE = "any-change", RequireApproval2.BROADENING = "broadening";
    })(RequireApproval = exports2.RequireApproval || (exports2.RequireApproval = {}));
  }
});

// node_modules/aws-cdk-lib/cloud-assembly-schema/lib/integ-tests/commands/deploy.js
var require_deploy = __commonJS({
  "node_modules/aws-cdk-lib/cloud-assembly-schema/lib/integ-tests/commands/deploy.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/cloud-assembly-schema/lib/integ-tests/commands/destroy.js
var require_destroy = __commonJS({
  "node_modules/aws-cdk-lib/cloud-assembly-schema/lib/integ-tests/commands/destroy.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/cloud-assembly-schema/lib/integ-tests/commands/index.js
var require_commands = __commonJS({
  "node_modules/aws-cdk-lib/cloud-assembly-schema/lib/integ-tests/commands/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_common(), exports2), __exportStar(require_deploy(), exports2), __exportStar(require_destroy(), exports2);
  }
});

// node_modules/aws-cdk-lib/cloud-assembly-schema/lib/integ-tests/test-case.js
var require_test_case = __commonJS({
  "node_modules/aws-cdk-lib/cloud-assembly-schema/lib/integ-tests/test-case.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/cloud-assembly-schema/lib/integ-tests/index.js
var require_integ_tests = __commonJS({
  "node_modules/aws-cdk-lib/cloud-assembly-schema/lib/integ-tests/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_schema3(), exports2), __exportStar(require_commands(), exports2), __exportStar(require_test_case(), exports2);
  }
});

// node_modules/aws-cdk-lib/cloud-assembly-schema/lib/index.js
var require_lib4 = __commonJS({
  "node_modules/aws-cdk-lib/cloud-assembly-schema/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_cloud_assembly(), exports2), __exportStar(require_assets(), exports2), __exportStar(require_manifest(), exports2), __exportStar(require_integ_tests(), exports2);
  }
});

// node_modules/aws-cdk-lib/cloud-assembly-schema/index.js
var require_cloud_assembly_schema2 = __commonJS({
  "node_modules/aws-cdk-lib/cloud-assembly-schema/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib4(), exports2);
  }
});

// node_modules/aws-cdk-lib/cx-api/lib/cxapi.js
var require_cxapi = __commonJS({
  "node_modules/aws-cdk-lib/cx-api/lib/cxapi.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SSMPARAM_NO_INVALIDATE = exports2.PROVIDER_ERROR_KEY = exports2.CLI_VERSION_ENV = exports2.CLI_ASM_VERSION_ENV = exports2.DEFAULT_REGION_ENV = exports2.DEFAULT_ACCOUNT_ENV = exports2.CONTEXT_OVERFLOW_LOCATION_ENV = exports2.CONTEXT_ENV = exports2.OUTDIR_ENV = void 0, exports2.OUTDIR_ENV = "CDK_OUTDIR", exports2.CONTEXT_ENV = "CDK_CONTEXT_JSON", exports2.CONTEXT_OVERFLOW_LOCATION_ENV = "CONTEXT_OVERFLOW_LOCATION_ENV", exports2.DEFAULT_ACCOUNT_ENV = "CDK_DEFAULT_ACCOUNT", exports2.DEFAULT_REGION_ENV = "CDK_DEFAULT_REGION", exports2.CLI_ASM_VERSION_ENV = "CDK_CLI_ASM_VERSION", exports2.CLI_VERSION_ENV = "CDK_CLI_VERSION", exports2.PROVIDER_ERROR_KEY = "$providerError", exports2.SSMPARAM_NO_INVALIDATE = "[cdk:skip]";
  }
});

// node_modules/aws-cdk-lib/cx-api/lib/context/vpc.js
var require_vpc = __commonJS({
  "node_modules/aws-cdk-lib/cx-api/lib/context/vpc.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.VpcSubnetGroupType = void 0;
    var VpcSubnetGroupType;
    (function(VpcSubnetGroupType2) {
      VpcSubnetGroupType2.PUBLIC = "Public", VpcSubnetGroupType2.PRIVATE = "Private", VpcSubnetGroupType2.ISOLATED = "Isolated";
    })(VpcSubnetGroupType = exports2.VpcSubnetGroupType || (exports2.VpcSubnetGroupType = {}));
  }
});

// node_modules/aws-cdk-lib/cx-api/lib/context/ami.js
var require_ami = __commonJS({
  "node_modules/aws-cdk-lib/cx-api/lib/context/ami.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/cx-api/lib/context/load-balancer.js
var require_load_balancer = __commonJS({
  "node_modules/aws-cdk-lib/cx-api/lib/context/load-balancer.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LoadBalancerIpAddressType = void 0;
    var LoadBalancerIpAddressType;
    (function(LoadBalancerIpAddressType2) {
      LoadBalancerIpAddressType2.IPV4 = "ipv4", LoadBalancerIpAddressType2.DUAL_STACK = "dualstack";
    })(LoadBalancerIpAddressType = exports2.LoadBalancerIpAddressType || (exports2.LoadBalancerIpAddressType = {}));
  }
});

// node_modules/aws-cdk-lib/cx-api/lib/context/availability-zones.js
var require_availability_zones = __commonJS({
  "node_modules/aws-cdk-lib/cx-api/lib/context/availability-zones.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AVAILABILITY_ZONE_FALLBACK_CONTEXT_KEY = void 0, exports2.AVAILABILITY_ZONE_FALLBACK_CONTEXT_KEY = "aws:cdk:availability-zones:fallback";
  }
});

// node_modules/aws-cdk-lib/cx-api/lib/context/endpoint-service-availability-zones.js
var require_endpoint_service_availability_zones = __commonJS({
  "node_modules/aws-cdk-lib/cx-api/lib/context/endpoint-service-availability-zones.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ENDPOINT_SERVICE_AVAILABILITY_ZONE_PROVIDER = void 0, exports2.ENDPOINT_SERVICE_AVAILABILITY_ZONE_PROVIDER = "endpoint-service-availability-zones";
  }
});

// node_modules/aws-cdk-lib/cx-api/lib/context/security-group.js
var require_security_group = __commonJS({
  "node_modules/aws-cdk-lib/cx-api/lib/context/security-group.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/cx-api/lib/context/key.js
var require_key = __commonJS({
  "node_modules/aws-cdk-lib/cx-api/lib/context/key.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/cx-api/lib/metadata.js
var require_metadata3 = __commonJS({
  "node_modules/aws-cdk-lib/cx-api/lib/metadata.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SynthesisMessageLevel = exports2.PATH_METADATA_KEY = void 0, exports2.PATH_METADATA_KEY = "aws:cdk:path";
    var SynthesisMessageLevel;
    (function(SynthesisMessageLevel2) {
      SynthesisMessageLevel2.INFO = "info", SynthesisMessageLevel2.WARNING = "warning", SynthesisMessageLevel2.ERROR = "error";
    })(SynthesisMessageLevel = exports2.SynthesisMessageLevel || (exports2.SynthesisMessageLevel = {}));
  }
});

// node_modules/aws-cdk-lib/cx-api/lib/cloud-artifact.js
var require_cloud_artifact = __commonJS({
  "node_modules/aws-cdk-lib/cx-api/lib/cloud-artifact.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CloudArtifact = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var metadata_1 = require_metadata3();
    var cxschema = require_cloud_assembly_schema2();
    var CloudArtifact = class _CloudArtifact {
      static fromManifest(assembly, id, artifact) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_cx_api_CloudAssembly(assembly), jsiiDeprecationWarnings.aws_cdk_lib_cloud_assembly_schema_ArtifactManifest(artifact);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromManifest), error;
        }
        throw new Error("Implementation not overridden yet");
      }
      constructor(assembly, id, manifest) {
        this.assembly = assembly, this.id = id;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_cx_api_CloudAssembly(assembly), jsiiDeprecationWarnings.aws_cdk_lib_cloud_assembly_schema_ArtifactManifest(manifest);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CloudArtifact), error;
        }
        this.manifest = manifest, this.messages = this.renderMessages(), this._dependencyIDs = manifest.dependencies || [];
      }
      get dependencies() {
        return this._deps ? this._deps : (this._deps = this._dependencyIDs.map((id) => {
          const dep = this.assembly.tryGetArtifact(id);
          if (!dep)
            throw new Error(`Artifact ${this.id} depends on non-existing artifact ${id}`);
          return dep;
        }), this._deps);
      }
      findMetadataByType(type) {
        const result = new Array();
        for (const path of Object.keys(this.manifest.metadata || {}))
          for (const entry of (this.manifest.metadata || {})[path])
            entry.type === type && result.push({ path, ...entry });
        return result;
      }
      renderMessages() {
        const messages = new Array();
        for (const [id, metadata] of Object.entries(this.manifest.metadata || {}))
          for (const entry of metadata) {
            let level;
            switch (entry.type) {
              case cxschema.ArtifactMetadataEntryType.WARN:
                level = metadata_1.SynthesisMessageLevel.WARNING;
                break;
              case cxschema.ArtifactMetadataEntryType.ERROR:
                level = metadata_1.SynthesisMessageLevel.ERROR;
                break;
              case cxschema.ArtifactMetadataEntryType.INFO:
                level = metadata_1.SynthesisMessageLevel.INFO;
                break;
              default:
                continue;
            }
            messages.push({ level, entry, id });
          }
        return messages;
      }
      get hierarchicalId() {
        return this.manifest.displayName ?? this.id;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CloudArtifact[_a] = { fqn: "aws-cdk-lib.cx_api.CloudArtifact", version: "2.80.0" }, exports2.CloudArtifact = CloudArtifact;
  }
});

// node_modules/aws-cdk-lib/cx-api/lib/artifacts/asset-manifest-artifact.js
var require_asset_manifest_artifact = __commonJS({
  "node_modules/aws-cdk-lib/cx-api/lib/artifacts/asset-manifest-artifact.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AssetManifestArtifact = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var fs = require("fs");
    var path = require("path");
    var cloud_artifact_1 = require_cloud_artifact();
    var ASSET_MANIFEST_ARTIFACT_SYM = Symbol.for("@aws-cdk/cx-api.AssetManifestArtifact");
    var AssetManifestArtifact = class _AssetManifestArtifact extends cloud_artifact_1.CloudArtifact {
      static isAssetManifestArtifact(art) {
        return art && typeof art == "object" && art[ASSET_MANIFEST_ARTIFACT_SYM];
      }
      constructor(assembly, name, artifact) {
        super(assembly, name, artifact);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_cx_api_CloudAssembly(assembly), jsiiDeprecationWarnings.aws_cdk_lib_cloud_assembly_schema_ArtifactManifest(artifact);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AssetManifestArtifact), error;
        }
        const properties = this.manifest.properties || {};
        if (!properties.file)
          throw new Error('Invalid AssetManifestArtifact. Missing "file" property');
        this.file = path.resolve(this.assembly.directory, properties.file), this.requiresBootstrapStackVersion = properties.requiresBootstrapStackVersion, this.bootstrapStackVersionSsmParameter = properties.bootstrapStackVersionSsmParameter;
      }
      get contents() {
        return this._contents !== void 0 ? this._contents : this._contents = JSON.parse(fs.readFileSync(this.file, "utf-8"));
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AssetManifestArtifact[_a] = { fqn: "aws-cdk-lib.cx_api.AssetManifestArtifact", version: "2.80.0" }, exports2.AssetManifestArtifact = AssetManifestArtifact, Object.defineProperty(AssetManifestArtifact.prototype, ASSET_MANIFEST_ARTIFACT_SYM, { value: true, enumerable: false, writable: false });
  }
});

// node_modules/aws-cdk-lib/cx-api/lib/environment.js
var require_environment = __commonJS({
  "node_modules/aws-cdk-lib/cx-api/lib/environment.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EnvironmentUtils = exports2.UNKNOWN_REGION = exports2.UNKNOWN_ACCOUNT = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var AWS_ENV_REGEX = /aws\:\/\/([a-z0-9A-Z\-\@\.\_]+)\/([a-z\-0-9]+)/;
    exports2.UNKNOWN_ACCOUNT = "unknown-account", exports2.UNKNOWN_REGION = "unknown-region";
    var EnvironmentUtils = class {
      static parse(environment) {
        const env = AWS_ENV_REGEX.exec(environment);
        if (!env)
          throw new Error(`Unable to parse environment specification "${environment}". Expected format: aws://account/region`);
        const [, account, region] = env;
        if (!account || !region)
          throw new Error(`Invalid environment specification: ${environment}`);
        return { account, region, name: environment };
      }
      static make(account, region) {
        return { account, region, name: this.format(account, region) };
      }
      static format(account, region) {
        return `aws://${account}/${region}`;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EnvironmentUtils[_a] = { fqn: "aws-cdk-lib.cx_api.EnvironmentUtils", version: "2.80.0" }, exports2.EnvironmentUtils = EnvironmentUtils;
  }
});

// node_modules/aws-cdk-lib/cx-api/lib/artifacts/cloudformation-artifact.js
var require_cloudformation_artifact = __commonJS({
  "node_modules/aws-cdk-lib/cx-api/lib/artifacts/cloudformation-artifact.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CloudFormationStackArtifact = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var fs = require("fs");
    var path = require("path");
    var cxschema = require_cloud_assembly_schema2();
    var cloud_artifact_1 = require_cloud_artifact();
    var environment_1 = require_environment();
    var CLOUDFORMATION_STACK_ARTIFACT_SYM = Symbol.for("@aws-cdk/cx-api.CloudFormationStackArtifact");
    var CloudFormationStackArtifact = class _CloudFormationStackArtifact extends cloud_artifact_1.CloudArtifact {
      static isCloudFormationStackArtifact(art) {
        return art && typeof art == "object" && art[CLOUDFORMATION_STACK_ARTIFACT_SYM];
      }
      constructor(assembly, artifactId, artifact) {
        super(assembly, artifactId, artifact);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_cx_api_CloudAssembly(assembly), jsiiDeprecationWarnings.aws_cdk_lib_cloud_assembly_schema_ArtifactManifest(artifact);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CloudFormationStackArtifact), error;
        }
        const properties = this.manifest.properties || {};
        if (!properties.templateFile)
          throw new Error('Invalid CloudFormation stack artifact. Missing "templateFile" property in cloud assembly manifest');
        if (!artifact.environment)
          throw new Error("Invalid CloudFormation stack artifact. Missing environment");
        this.environment = environment_1.EnvironmentUtils.parse(artifact.environment), this.templateFile = properties.templateFile, this.parameters = properties.parameters ?? {}, this.tags = properties.tags ?? this.tagsFromMetadata(), this.assumeRoleArn = properties.assumeRoleArn, this.assumeRoleExternalId = properties.assumeRoleExternalId, this.cloudFormationExecutionRoleArn = properties.cloudFormationExecutionRoleArn, this.stackTemplateAssetObjectUrl = properties.stackTemplateAssetObjectUrl, this.requiresBootstrapStackVersion = properties.requiresBootstrapStackVersion, this.bootstrapStackVersionSsmParameter = properties.bootstrapStackVersionSsmParameter, this.terminationProtection = properties.terminationProtection, this.validateOnSynth = properties.validateOnSynth, this.lookupRole = properties.lookupRole, this.stackName = properties.stackName || artifactId, this.assets = this.findMetadataByType(cxschema.ArtifactMetadataEntryType.ASSET).map((e) => e.data), this.displayName = this.stackName === artifactId ? this.hierarchicalId : `${this.hierarchicalId} (${this.stackName})`, this.name = this.stackName, this.originalName = this.stackName;
      }
      get templateFullPath() {
        return path.join(this.assembly.directory, this.templateFile);
      }
      get template() {
        return this._template === void 0 && (this._template = JSON.parse(fs.readFileSync(this.templateFullPath, "utf-8"))), this._template;
      }
      tagsFromMetadata() {
        const ret = {};
        for (const metadataEntry of this.findMetadataByType(cxschema.ArtifactMetadataEntryType.STACK_TAGS))
          for (const tag of metadataEntry.data ?? [])
            ret[tag.key] = tag.value;
        return ret;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CloudFormationStackArtifact[_a] = { fqn: "aws-cdk-lib.cx_api.CloudFormationStackArtifact", version: "2.80.0" }, exports2.CloudFormationStackArtifact = CloudFormationStackArtifact, Object.defineProperty(CloudFormationStackArtifact.prototype, CLOUDFORMATION_STACK_ARTIFACT_SYM, { value: true, enumerable: false, writable: false });
  }
});

// node_modules/aws-cdk-lib/cx-api/lib/artifacts/nested-cloud-assembly-artifact.js
var require_nested_cloud_assembly_artifact = __commonJS({
  "node_modules/aws-cdk-lib/cx-api/lib/artifacts/nested-cloud-assembly-artifact.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.NestedCloudAssemblyArtifact = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var path = require("path");
    var cloud_artifact_1 = require_cloud_artifact();
    var NESTED_CLOUD_ASSEMBLY_SYM = Symbol.for("@aws-cdk/cx-api.NestedCloudAssemblyArtifact");
    var NestedCloudAssemblyArtifact = class _NestedCloudAssemblyArtifact extends cloud_artifact_1.CloudArtifact {
      static isNestedCloudAssemblyArtifact(art) {
        return art && typeof art == "object" && art[NESTED_CLOUD_ASSEMBLY_SYM];
      }
      constructor(assembly, name, artifact) {
        super(assembly, name, artifact);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_cx_api_CloudAssembly(assembly), jsiiDeprecationWarnings.aws_cdk_lib_cloud_assembly_schema_ArtifactManifest(artifact);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _NestedCloudAssemblyArtifact), error;
        }
        const properties = this.manifest.properties || {};
        this.directoryName = properties.directoryName, this.displayName = properties.displayName ?? name;
      }
      get fullPath() {
        return path.join(this.assembly.directory, this.directoryName);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, NestedCloudAssemblyArtifact[_a] = { fqn: "aws-cdk-lib.cx_api.NestedCloudAssemblyArtifact", version: "2.80.0" }, exports2.NestedCloudAssemblyArtifact = NestedCloudAssemblyArtifact, Object.defineProperty(NestedCloudAssemblyArtifact.prototype, NESTED_CLOUD_ASSEMBLY_SYM, { value: true, enumerable: false, writable: false });
  }
});

// node_modules/aws-cdk-lib/cx-api/lib/artifacts/tree-cloud-artifact.js
var require_tree_cloud_artifact = __commonJS({
  "node_modules/aws-cdk-lib/cx-api/lib/artifacts/tree-cloud-artifact.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.TreeCloudArtifact = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cloud_artifact_1 = require_cloud_artifact();
    var TREE_CLOUD_ARTIFACT_SYM = Symbol.for("@aws-cdk/cx-api.TreeCloudArtifact");
    var TreeCloudArtifact = class _TreeCloudArtifact extends cloud_artifact_1.CloudArtifact {
      static isTreeCloudArtifact(art) {
        return art && typeof art == "object" && art[TREE_CLOUD_ARTIFACT_SYM];
      }
      constructor(assembly, name, artifact) {
        super(assembly, name, artifact);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_cx_api_CloudAssembly(assembly), jsiiDeprecationWarnings.aws_cdk_lib_cloud_assembly_schema_ArtifactManifest(artifact);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _TreeCloudArtifact), error;
        }
        const properties = this.manifest.properties || {};
        if (!properties.file)
          throw new Error('Invalid TreeCloudArtifact. Missing "file" property');
        this.file = properties.file;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, TreeCloudArtifact[_a] = { fqn: "aws-cdk-lib.cx_api.TreeCloudArtifact", version: "2.80.0" }, exports2.TreeCloudArtifact = TreeCloudArtifact, Object.defineProperty(TreeCloudArtifact.prototype, TREE_CLOUD_ARTIFACT_SYM, { value: true, enumerable: false, writable: false });
  }
});

// node_modules/aws-cdk-lib/cx-api/lib/cloud-artifact-aug.js
var require_cloud_artifact_aug = __commonJS({
  "node_modules/aws-cdk-lib/cx-api/lib/cloud-artifact-aug.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var asset_manifest_artifact_1 = require_asset_manifest_artifact();
    var cloudformation_artifact_1 = require_cloudformation_artifact();
    var nested_cloud_assembly_artifact_1 = require_nested_cloud_assembly_artifact();
    var tree_cloud_artifact_1 = require_tree_cloud_artifact();
    var cloud_artifact_1 = require_cloud_artifact();
    var cxschema = require_cloud_assembly_schema2();
    cloud_artifact_1.CloudArtifact.fromManifest = function(assembly, id, artifact) {
      switch (artifact.type) {
        case cxschema.ArtifactType.AWS_CLOUDFORMATION_STACK:
          return new cloudformation_artifact_1.CloudFormationStackArtifact(assembly, id, artifact);
        case cxschema.ArtifactType.CDK_TREE:
          return new tree_cloud_artifact_1.TreeCloudArtifact(assembly, id, artifact);
        case cxschema.ArtifactType.ASSET_MANIFEST:
          return new asset_manifest_artifact_1.AssetManifestArtifact(assembly, id, artifact);
        case cxschema.ArtifactType.NESTED_CLOUD_ASSEMBLY:
          return new nested_cloud_assembly_artifact_1.NestedCloudAssemblyArtifact(assembly, id, artifact);
        default:
          return;
      }
    };
  }
});

// node_modules/aws-cdk-lib/cx-api/lib/toposort.js
var require_toposort = __commonJS({
  "node_modules/aws-cdk-lib/cx-api/lib/toposort.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.topologicalSort = void 0;
    function topologicalSort(xs, keyFn, depFn) {
      const remaining = /* @__PURE__ */ new Map();
      for (const element of xs) {
        const key = keyFn(element);
        remaining.set(key, { key, element, dependencies: depFn(element) });
      }
      const ret = new Array();
      for (; remaining.size > 0; ) {
        const selectable = Array.from(remaining.values()).filter((e) => e.dependencies.every((d) => !remaining.has(d)));
        selectable.sort((a, b) => a.key < b.key ? -1 : b.key < a.key ? 1 : 0);
        for (const selected of selectable)
          ret.push(selected.element), remaining.delete(selected.key);
        if (selectable.length === 0)
          throw new Error(`Could not determine ordering between: ${Array.from(remaining.keys()).join(", ")}`);
      }
      return ret;
    }
    exports2.topologicalSort = topologicalSort;
  }
});

// node_modules/aws-cdk-lib/cx-api/lib/cloud-assembly.js
var require_cloud_assembly2 = __commonJS({
  "node_modules/aws-cdk-lib/cx-api/lib/cloud-assembly.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CloudAssemblyBuilder = exports2.CloudAssembly = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var fs = require("fs");
    var os = require("os");
    var path = require("path");
    var cloudformation_artifact_1 = require_cloudformation_artifact();
    var nested_cloud_assembly_artifact_1 = require_nested_cloud_assembly_artifact();
    var tree_cloud_artifact_1 = require_tree_cloud_artifact();
    var cloud_artifact_1 = require_cloud_artifact();
    var toposort_1 = require_toposort();
    var cxschema = require_cloud_assembly_schema2();
    var MANIFEST_FILE = "manifest.json";
    var CloudAssembly = class _CloudAssembly {
      constructor(directory, loadOptions) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_cloud_assembly_schema_LoadManifestOptions(loadOptions);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CloudAssembly), error;
        }
        this.directory = directory, this.manifest = cxschema.Manifest.loadAssemblyManifest(path.join(directory, MANIFEST_FILE), loadOptions), this.version = this.manifest.version, this.artifacts = this.renderArtifacts(loadOptions?.topoSort ?? true), this.runtime = this.manifest.runtime || { libraries: {} }, this.validateDeps();
      }
      tryGetArtifact(id) {
        return this.artifacts.find((a) => a.id === id);
      }
      getStackByName(stackName) {
        const artifacts = this.artifacts.filter((a) => a instanceof cloudformation_artifact_1.CloudFormationStackArtifact && a.stackName === stackName);
        if (!artifacts || artifacts.length === 0)
          throw new Error(`Unable to find stack with stack name "${stackName}"`);
        if (artifacts.length > 1)
          throw new Error(`There are multiple stacks with the stack name "${stackName}" (${artifacts.map((a) => a.id).join(",")}). Use "getStackArtifact(id)" instead`);
        return artifacts[0];
      }
      getStack(stackName) {
        return this.getStackByName(stackName);
      }
      getStackArtifact(artifactId) {
        const artifact = this.tryGetArtifactRecursively(artifactId);
        if (!artifact)
          throw new Error(`Unable to find artifact with id "${artifactId}"`);
        if (!(artifact instanceof cloudformation_artifact_1.CloudFormationStackArtifact))
          throw new Error(`Artifact ${artifactId} is not a CloudFormation stack`);
        return artifact;
      }
      tryGetArtifactRecursively(artifactId) {
        return this.stacksRecursively.find((a) => a.id === artifactId);
      }
      get stacksRecursively() {
        function search(stackArtifacts, assemblies) {
          if (assemblies.length === 0)
            return stackArtifacts;
          const [head, ...tail] = assemblies, nestedAssemblies = head.nestedAssemblies.map((asm) => asm.nestedAssembly);
          return search(stackArtifacts.concat(head.stacks), tail.concat(nestedAssemblies));
        }
        return search([], [this]);
      }
      getNestedAssemblyArtifact(artifactId) {
        const artifact = this.tryGetArtifact(artifactId);
        if (!artifact)
          throw new Error(`Unable to find artifact with id "${artifactId}"`);
        if (!(artifact instanceof nested_cloud_assembly_artifact_1.NestedCloudAssemblyArtifact))
          throw new Error(`Found artifact '${artifactId}' but it's not a nested cloud assembly`);
        return artifact;
      }
      getNestedAssembly(artifactId) {
        return this.getNestedAssemblyArtifact(artifactId).nestedAssembly;
      }
      tree() {
        const trees = this.artifacts.filter((a) => a.manifest.type === cxschema.ArtifactType.CDK_TREE);
        if (trees.length === 0)
          return;
        if (trees.length > 1)
          throw new Error(`Multiple artifacts of type ${cxschema.ArtifactType.CDK_TREE} found in manifest`);
        const tree = trees[0];
        if (!(tree instanceof tree_cloud_artifact_1.TreeCloudArtifact))
          throw new Error('"Tree" artifact is not of expected type');
        return tree;
      }
      get stacks() {
        return this.artifacts.filter(isCloudFormationStackArtifact);
        function isCloudFormationStackArtifact(x) {
          return x instanceof cloudformation_artifact_1.CloudFormationStackArtifact;
        }
      }
      get nestedAssemblies() {
        return this.artifacts.filter(isNestedCloudAssemblyArtifact);
        function isNestedCloudAssemblyArtifact(x) {
          return x instanceof nested_cloud_assembly_artifact_1.NestedCloudAssemblyArtifact;
        }
      }
      validateDeps() {
        for (const artifact of this.artifacts)
          artifact.dependencies;
      }
      renderArtifacts(topoSort) {
        const result = new Array();
        for (const [name, artifact] of Object.entries(this.manifest.artifacts || {})) {
          const cloudartifact = cloud_artifact_1.CloudArtifact.fromManifest(this, name, artifact);
          cloudartifact && result.push(cloudartifact);
        }
        return topoSort ? (0, toposort_1.topologicalSort)(result, (x) => x.id, (x) => x._dependencyIDs) : result;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CloudAssembly[_a] = { fqn: "aws-cdk-lib.cx_api.CloudAssembly", version: "2.80.0" }, exports2.CloudAssembly = CloudAssembly;
    var CloudAssemblyBuilder = class _CloudAssemblyBuilder {
      constructor(outdir, props = {}) {
        this.artifacts = {}, this.missing = new Array();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_cx_api_CloudAssemblyBuilderProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CloudAssemblyBuilder), error;
        }
        this.outdir = determineOutputDirectory(outdir), this.assetOutdir = props.assetOutdir ?? this.outdir, this.parentBuilder = props.parentBuilder, ensureDirSync(this.outdir);
      }
      addArtifact(id, manifest) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_cloud_assembly_schema_ArtifactManifest(manifest);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addArtifact), error;
        }
        this.artifacts[id] = filterUndefined(manifest);
      }
      addMissing(missing) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_cloud_assembly_schema_MissingContext(missing);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addMissing), error;
        }
        this.missing.every((m) => m.key !== missing.key) && this.missing.push(missing), this.parentBuilder?.addMissing(missing);
      }
      buildAssembly(options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_cx_api_AssemblyBuildOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.buildAssembly), error;
        }
        let manifest = { version: cxschema.Manifest.version(), artifacts: this.artifacts, runtime: options.runtimeInfo, missing: this.missing.length > 0 ? this.missing : void 0 };
        manifest = filterUndefined(manifest);
        const manifestFilePath = path.join(this.outdir, MANIFEST_FILE);
        return cxschema.Manifest.saveAssemblyManifest(manifest, manifestFilePath), fs.writeFileSync(path.join(this.outdir, "cdk.out"), JSON.stringify({ version: manifest.version })), new CloudAssembly(this.outdir);
      }
      createNestedAssembly(artifactId, displayName) {
        const directoryName = artifactId, innerAsmDir = path.join(this.outdir, directoryName);
        return this.addArtifact(artifactId, { type: cxschema.ArtifactType.NESTED_CLOUD_ASSEMBLY, properties: { directoryName, displayName } }), new _CloudAssemblyBuilder(innerAsmDir, { assetOutdir: this.assetOutdir, parentBuilder: this });
      }
      delete() {
        fs.rmSync(this.outdir, { recursive: true, force: true });
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CloudAssemblyBuilder[_b] = { fqn: "aws-cdk-lib.cx_api.CloudAssemblyBuilder", version: "2.80.0" }, exports2.CloudAssemblyBuilder = CloudAssemblyBuilder;
    function filterUndefined(obj) {
      if (Array.isArray(obj))
        return obj.filter((x) => x !== void 0).map((x) => filterUndefined(x));
      if (typeof obj == "object") {
        const ret = {};
        for (const [key, value] of Object.entries(obj))
          value !== void 0 && (ret[key] = filterUndefined(value));
        return ret;
      }
      return obj;
    }
    function determineOutputDirectory(outdir) {
      return outdir ?? fs.mkdtempSync(path.join(fs.realpathSync(os.tmpdir()), "cdk.out"));
    }
    function ensureDirSync(dir) {
      if (fs.existsSync(dir)) {
        if (!fs.statSync(dir).isDirectory())
          throw new Error(`${dir} must be a directory`);
      } else
        fs.mkdirSync(dir, { recursive: true });
    }
  }
});

// node_modules/aws-cdk-lib/cx-api/lib/artifacts/nested-cloud-assembly-artifact-aug.js
var require_nested_cloud_assembly_artifact_aug = __commonJS({
  "node_modules/aws-cdk-lib/cx-api/lib/artifacts/nested-cloud-assembly-artifact-aug.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var nested_cloud_assembly_artifact_1 = require_nested_cloud_assembly_artifact();
    var cloud_assembly_1 = require_cloud_assembly2();
    var cacheSym = Symbol();
    Object.defineProperty(nested_cloud_assembly_artifact_1.NestedCloudAssemblyArtifact.prototype, "nestedAssembly", { get() {
      return this[cacheSym] || (this[cacheSym] = new cloud_assembly_1.CloudAssembly(this.fullPath)), this[cacheSym];
    } });
  }
});

// node_modules/aws-cdk-lib/cx-api/lib/assets.js
var require_assets2 = __commonJS({
  "node_modules/aws-cdk-lib/cx-api/lib/assets.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ASSET_PREFIX_SEPARATOR = exports2.ASSET_RESOURCE_METADATA_DOCKER_CACHE_TO_KEY = exports2.ASSET_RESOURCE_METADATA_DOCKER_CACHE_FROM_KEY = exports2.ASSET_RESOURCE_METADATA_DOCKER_OUTPUTS_KEY = exports2.ASSET_RESOURCE_METADATA_IS_BUNDLED_KEY = exports2.ASSET_RESOURCE_METADATA_PROPERTY_KEY = exports2.ASSET_RESOURCE_METADATA_DOCKER_BUILD_TARGET_KEY = exports2.ASSET_RESOURCE_METADATA_DOCKER_BUILD_SECRETS_KEY = exports2.ASSET_RESOURCE_METADATA_DOCKER_BUILD_ARGS_KEY = exports2.ASSET_RESOURCE_METADATA_DOCKERFILE_PATH_KEY = exports2.ASSET_RESOURCE_METADATA_PATH_KEY = exports2.ASSET_RESOURCE_METADATA_ENABLED_CONTEXT = void 0, exports2.ASSET_RESOURCE_METADATA_ENABLED_CONTEXT = "aws:cdk:enable-asset-metadata", exports2.ASSET_RESOURCE_METADATA_PATH_KEY = "aws:asset:path", exports2.ASSET_RESOURCE_METADATA_DOCKERFILE_PATH_KEY = "aws:asset:dockerfile-path", exports2.ASSET_RESOURCE_METADATA_DOCKER_BUILD_ARGS_KEY = "aws:asset:docker-build-args", exports2.ASSET_RESOURCE_METADATA_DOCKER_BUILD_SECRETS_KEY = "aws:asset:docker-build-secrets", exports2.ASSET_RESOURCE_METADATA_DOCKER_BUILD_TARGET_KEY = "aws:asset:docker-build-target", exports2.ASSET_RESOURCE_METADATA_PROPERTY_KEY = "aws:asset:property", exports2.ASSET_RESOURCE_METADATA_IS_BUNDLED_KEY = "aws:asset:is-bundled", exports2.ASSET_RESOURCE_METADATA_DOCKER_OUTPUTS_KEY = "aws:asset:docker-outputs", exports2.ASSET_RESOURCE_METADATA_DOCKER_CACHE_FROM_KEY = "aws:asset:docker-cache-from", exports2.ASSET_RESOURCE_METADATA_DOCKER_CACHE_TO_KEY = "aws:asset:docker-cache-to", exports2.ASSET_PREFIX_SEPARATOR = "||";
  }
});

// node_modules/aws-cdk-lib/cx-api/lib/private/flag-modeling.js
var require_flag_modeling = __commonJS({
  "node_modules/aws-cdk-lib/cx-api/lib/private/flag-modeling.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.compareVersions = exports2.MAGIC_V2NEXT = exports2.FlagType = void 0;
    var FlagType;
    (function(FlagType2) {
      FlagType2[FlagType2.ApiDefault = 0] = "ApiDefault", FlagType2[FlagType2.BugFix = 1] = "BugFix", FlagType2[FlagType2.VisibleContext = 2] = "VisibleContext";
    })(FlagType = exports2.FlagType || (exports2.FlagType = {})), exports2.MAGIC_V2NEXT = "V2NEXT";
    function compareVersions(a, b) {
      if (a === b)
        return 0;
      if (a === void 0)
        return -1;
      if (b === void 0)
        return 1;
      const as = a.split(".").map((x) => parseInt(x, 10)), bs = b.split(".").map((x) => parseInt(x, 10));
      if (a === exports2.MAGIC_V2NEXT)
        return bs[0] <= 2 ? 1 : -1;
      if (b === exports2.MAGIC_V2NEXT)
        return as[0] <= 2 ? -1 : 1;
      for (let i = 0; i < Math.min(as.length, bs.length); i++) {
        if (as[i] < bs[i])
          return -1;
        if (as[i] > bs[i])
          return 1;
      }
      return as.length - bs.length;
    }
    exports2.compareVersions = compareVersions;
  }
});

// node_modules/aws-cdk-lib/cx-api/lib/features.js
var require_features = __commonJS({
  "node_modules/aws-cdk-lib/cx-api/lib/features.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FUTURE_FLAGS_EXPIRED = exports2.futureFlagDefault = exports2.CURRENT_VERSION_FLAG_DEFAULTS = exports2.NEW_PROJECT_CONTEXT = exports2.CURRENT_VERSION_EXPIRED_FLAGS = exports2.FLAGS = exports2.APIGATEWAY_REQUEST_VALIDATOR_UNIQUE_ID = exports2.EC2_RESTRICT_DEFAULT_SECURITY_GROUP = exports2.ENABLE_EMR_SERVICE_POLICY_V2 = exports2.REDSHIFT_COLUMN_ID = exports2.SECRETS_MANAGER_TARGET_ATTACHMENT_RESOURCE_POLICY = exports2.EC2_LAUNCH_TEMPLATE_DEFAULT_USER_DATA = exports2.APIGATEWAY_AUTHORIZER_CHANGE_DEPLOYMENT_LOGICAL_ID = exports2.CODEDEPLOY_REMOVE_ALARMS_FROM_DEPLOYMENT_GROUP = exports2.DATABASE_PROXY_UNIQUE_RESOURCE_NAME = exports2.AWS_CUSTOM_RESOURCE_LATEST_SDK_DEFAULT = exports2.ROUTE53_PATTERNS_USE_CERTIFICATE = exports2.S3_SERVER_ACCESS_LOGS_USE_BUCKET_POLICY = exports2.ECS_DISABLE_EXPLICIT_DEPLOYMENT_CONTROLLER_FOR_CIRCUIT_BREAKER = exports2.IAM_STANDARDIZED_SERVICE_PRINCIPALS = exports2.EVENTS_TARGET_QUEUE_SAME_ACCOUNT = exports2.ENABLE_PARTITION_LITERALS = exports2.APIGATEWAY_DISABLE_CLOUDWATCH_ROLE = exports2.SNS_SUBSCRIPTIONS_SQS_DECRYPTION_POLICY = exports2.S3_CREATE_DEFAULT_LOGGING_POLICY = exports2.CODEPIPELINE_CROSS_ACCOUNT_KEY_ALIAS_STACK_SAFE_RESOURCE_NAME = exports2.VALIDATE_SNAPSHOT_REMOVAL_POLICY = exports2.IAM_IMPORTED_ROLE_STACK_SAFE_DEFAULT_POLICY_NAME = exports2.IAM_MINIMIZE_POLICIES = exports2.ECS_ARN_FORMAT_INCLUDES_CLUSTER_NAME = exports2.EC2_UNIQUE_IMDSV2_LAUNCH_TEMPLATE_NAME = exports2.ECS_SERVICE_EXTENSIONS_ENABLE_DEFAULT_LOG_DRIVER = exports2.TARGET_PARTITIONS = exports2.CHECK_SECRET_USAGE = exports2.CLOUDFRONT_DEFAULT_SECURITY_POLICY_TLS_V1_2_2021 = exports2.LAMBDA_RECOGNIZE_LAYER_VERSION = exports2.LAMBDA_RECOGNIZE_VERSION_PROPS = exports2.EFS_DEFAULT_ENCRYPTION_AT_REST = exports2.APIGATEWAY_USAGEPLANKEY_ORDERINSENSITIVE_ID = exports2.RDS_LOWERCASE_DB_IDENTIFIER = exports2.ECS_REMOVE_DEFAULT_DESIRED_COUNT = exports2.S3_GRANT_WRITE_WITHOUT_ACL = exports2.KMS_DEFAULT_KEY_POLICIES = exports2.SECRETS_MANAGER_PARSE_OWNED_SECRET_NAME = exports2.DOCKER_IGNORE_SUPPORT = exports2.STACK_RELATIVE_EXPORTS_CONTEXT = exports2.NEW_STYLE_STACK_SYNTHESIS_CONTEXT = exports2.ENABLE_DIFF_NO_FAIL = exports2.ENABLE_DIFF_NO_FAIL_CONTEXT = exports2.ENABLE_STACK_NAME_DUPLICATES_CONTEXT = void 0, exports2.NEW_PROJECT_DEFAULT_CONTEXT = exports2.FUTURE_FLAGS = void 0;
    var flag_modeling_1 = require_flag_modeling();
    exports2.ENABLE_STACK_NAME_DUPLICATES_CONTEXT = "@aws-cdk/core:enableStackNameDuplicates", exports2.ENABLE_DIFF_NO_FAIL_CONTEXT = "aws-cdk:enableDiffNoFail", exports2.ENABLE_DIFF_NO_FAIL = exports2.ENABLE_DIFF_NO_FAIL_CONTEXT, exports2.NEW_STYLE_STACK_SYNTHESIS_CONTEXT = "@aws-cdk/core:newStyleStackSynthesis", exports2.STACK_RELATIVE_EXPORTS_CONTEXT = "@aws-cdk/core:stackRelativeExports", exports2.DOCKER_IGNORE_SUPPORT = "@aws-cdk/aws-ecr-assets:dockerIgnoreSupport", exports2.SECRETS_MANAGER_PARSE_OWNED_SECRET_NAME = "@aws-cdk/aws-secretsmanager:parseOwnedSecretName", exports2.KMS_DEFAULT_KEY_POLICIES = "@aws-cdk/aws-kms:defaultKeyPolicies", exports2.S3_GRANT_WRITE_WITHOUT_ACL = "@aws-cdk/aws-s3:grantWriteWithoutAcl", exports2.ECS_REMOVE_DEFAULT_DESIRED_COUNT = "@aws-cdk/aws-ecs-patterns:removeDefaultDesiredCount", exports2.RDS_LOWERCASE_DB_IDENTIFIER = "@aws-cdk/aws-rds:lowercaseDbIdentifier", exports2.APIGATEWAY_USAGEPLANKEY_ORDERINSENSITIVE_ID = "@aws-cdk/aws-apigateway:usagePlanKeyOrderInsensitiveId", exports2.EFS_DEFAULT_ENCRYPTION_AT_REST = "@aws-cdk/aws-efs:defaultEncryptionAtRest", exports2.LAMBDA_RECOGNIZE_VERSION_PROPS = "@aws-cdk/aws-lambda:recognizeVersionProps", exports2.LAMBDA_RECOGNIZE_LAYER_VERSION = "@aws-cdk/aws-lambda:recognizeLayerVersion", exports2.CLOUDFRONT_DEFAULT_SECURITY_POLICY_TLS_V1_2_2021 = "@aws-cdk/aws-cloudfront:defaultSecurityPolicyTLSv1.2_2021", exports2.CHECK_SECRET_USAGE = "@aws-cdk/core:checkSecretUsage", exports2.TARGET_PARTITIONS = "@aws-cdk/core:target-partitions", exports2.ECS_SERVICE_EXTENSIONS_ENABLE_DEFAULT_LOG_DRIVER = "@aws-cdk-containers/ecs-service-extensions:enableDefaultLogDriver", exports2.EC2_UNIQUE_IMDSV2_LAUNCH_TEMPLATE_NAME = "@aws-cdk/aws-ec2:uniqueImdsv2TemplateName", exports2.ECS_ARN_FORMAT_INCLUDES_CLUSTER_NAME = "@aws-cdk/aws-ecs:arnFormatIncludesClusterName", exports2.IAM_MINIMIZE_POLICIES = "@aws-cdk/aws-iam:minimizePolicies", exports2.IAM_IMPORTED_ROLE_STACK_SAFE_DEFAULT_POLICY_NAME = "@aws-cdk/aws-iam:importedRoleStackSafeDefaultPolicyName", exports2.VALIDATE_SNAPSHOT_REMOVAL_POLICY = "@aws-cdk/core:validateSnapshotRemovalPolicy", exports2.CODEPIPELINE_CROSS_ACCOUNT_KEY_ALIAS_STACK_SAFE_RESOURCE_NAME = "@aws-cdk/aws-codepipeline:crossAccountKeyAliasStackSafeResourceName", exports2.S3_CREATE_DEFAULT_LOGGING_POLICY = "@aws-cdk/aws-s3:createDefaultLoggingPolicy", exports2.SNS_SUBSCRIPTIONS_SQS_DECRYPTION_POLICY = "@aws-cdk/aws-sns-subscriptions:restrictSqsDescryption", exports2.APIGATEWAY_DISABLE_CLOUDWATCH_ROLE = "@aws-cdk/aws-apigateway:disableCloudWatchRole", exports2.ENABLE_PARTITION_LITERALS = "@aws-cdk/core:enablePartitionLiterals", exports2.EVENTS_TARGET_QUEUE_SAME_ACCOUNT = "@aws-cdk/aws-events:eventsTargetQueueSameAccount", exports2.IAM_STANDARDIZED_SERVICE_PRINCIPALS = "@aws-cdk/aws-iam:standardizedServicePrincipals", exports2.ECS_DISABLE_EXPLICIT_DEPLOYMENT_CONTROLLER_FOR_CIRCUIT_BREAKER = "@aws-cdk/aws-ecs:disableExplicitDeploymentControllerForCircuitBreaker", exports2.S3_SERVER_ACCESS_LOGS_USE_BUCKET_POLICY = "@aws-cdk/aws-s3:serverAccessLogsUseBucketPolicy", exports2.ROUTE53_PATTERNS_USE_CERTIFICATE = "@aws-cdk/aws-route53-patters:useCertificate", exports2.AWS_CUSTOM_RESOURCE_LATEST_SDK_DEFAULT = "@aws-cdk/customresources:installLatestAwsSdkDefault", exports2.DATABASE_PROXY_UNIQUE_RESOURCE_NAME = "@aws-cdk/aws-rds:databaseProxyUniqueResourceName", exports2.CODEDEPLOY_REMOVE_ALARMS_FROM_DEPLOYMENT_GROUP = "@aws-cdk/aws-codedeploy:removeAlarmsFromDeploymentGroup", exports2.APIGATEWAY_AUTHORIZER_CHANGE_DEPLOYMENT_LOGICAL_ID = "@aws-cdk/aws-apigateway:authorizerChangeDeploymentLogicalId", exports2.EC2_LAUNCH_TEMPLATE_DEFAULT_USER_DATA = "@aws-cdk/aws-ec2:launchTemplateDefaultUserData", exports2.SECRETS_MANAGER_TARGET_ATTACHMENT_RESOURCE_POLICY = "@aws-cdk/aws-secretsmanager:useAttachedSecretResourcePolicyForSecretTargetAttachments", exports2.REDSHIFT_COLUMN_ID = "@aws-cdk/aws-redshift:columnId", exports2.ENABLE_EMR_SERVICE_POLICY_V2 = "@aws-cdk/aws-stepfunctions-tasks:enableEmrServicePolicyV2", exports2.EC2_RESTRICT_DEFAULT_SECURITY_GROUP = "@aws-cdk/aws-ec2:restrictDefaultSecurityGroup", exports2.APIGATEWAY_REQUEST_VALIDATOR_UNIQUE_ID = "@aws-cdk/aws-apigateway:requestValidatorUniqueId", exports2.FLAGS = { [exports2.ENABLE_STACK_NAME_DUPLICATES_CONTEXT]: { type: flag_modeling_1.FlagType.ApiDefault, summary: "Allow multiple stacks with the same name", detailsMd: `
      If this is set, multiple stacks can use the same stack name (e.g. deployed to
      different environments). This means that the name of the synthesized template
      file will be based on the construct path and not on the defined \`stackName\`
      of the stack.`, recommendedValue: true, introducedIn: { v1: "1.16.0" }, defaults: { v2: true }, compatibilityWithOldBehaviorMd: "Pass stack identifiers to the CLI instead of stack names." }, [exports2.ENABLE_DIFF_NO_FAIL_CONTEXT]: { type: flag_modeling_1.FlagType.ApiDefault, summary: "Make `cdk diff` not fail when there are differences", detailsMd: "\n      Determines what status code `cdk diff` should return when the specified stack\n      differs from the deployed stack or the local CloudFormation template:\n\n      * `aws-cdk:enableDiffNoFail=true` => status code == 0\n      * `aws-cdk:enableDiffNoFail=false` => status code == 1\n\n      You can override this behavior with the --fail flag:\n\n      * `--fail` => status code == 1\n      * `--no-fail` => status code == 0", introducedIn: { v1: "1.19.0" }, defaults: { v2: true }, recommendedValue: true, compatibilityWithOldBehaviorMd: "Specify `--fail` to the CLI." }, [exports2.NEW_STYLE_STACK_SYNTHESIS_CONTEXT]: { type: flag_modeling_1.FlagType.BugFix, summary: "Switch to new stack synthesis method which enables CI/CD", detailsMd: "\n      If this flag is specified, all `Stack`s will use the `DefaultStackSynthesizer` by\n      default. If it is not set, they will use the `LegacyStackSynthesizer`.", introducedIn: { v1: "1.39.0", v2: "2.0.0" }, defaults: { v2: true }, recommendedValue: true }, [exports2.STACK_RELATIVE_EXPORTS_CONTEXT]: { type: flag_modeling_1.FlagType.BugFix, summary: "Name exports based on the construct paths relative to the stack, rather than the global construct path", detailsMd: `
      Combined with the stack name this relative construct path is good enough to
      ensure uniqueness, and makes the export names robust against refactoring
      the location of the stack in the construct tree (specifically, moving the Stack
      into a Stage).`, introducedIn: { v1: "1.58.0", v2: "2.0.0" }, defaults: { v2: true }, recommendedValue: true }, [exports2.DOCKER_IGNORE_SUPPORT]: { type: flag_modeling_1.FlagType.ApiDefault, summary: "DockerImageAsset properly supports `.dockerignore` files by default", detailsMd: `
      If this flag is not set, the default behavior for \`DockerImageAsset\` is to use
      glob semantics for \`.dockerignore\` files. If this flag is set, the default behavior
      is standard Docker ignore semantics.

      This is a feature flag as the old behavior was technically incorrect but
      users may have come to depend on it.`, introducedIn: { v1: "1.73.0" }, defaults: { v2: true }, recommendedValue: true, compatibilityWithOldBehaviorMd: "Update your `.dockerignore` file to match standard Docker ignore rules, if necessary." }, [exports2.SECRETS_MANAGER_PARSE_OWNED_SECRET_NAME]: { type: flag_modeling_1.FlagType.ApiDefault, summary: "Fix the referencing of SecretsManager names from ARNs", detailsMd: `
      Secret.secretName for an "owned" secret will attempt to parse the secretName from the ARN,
      rather than the default full resource name, which includes the SecretsManager suffix.

      If this flag is not set, Secret.secretName will include the SecretsManager suffix, which cannot be directly
      used by SecretsManager.DescribeSecret, and must be parsed by the user first (e.g., Fn:Join, Fn:Select, Fn:Split).`, introducedIn: { v1: "1.77.0" }, defaults: { v2: true }, recommendedValue: true, compatibilityWithOldBehaviorMd: "Use `parseArn(secret.secretName).resourceName` to emulate the incorrect old parsing." }, [exports2.KMS_DEFAULT_KEY_POLICIES]: { type: flag_modeling_1.FlagType.ApiDefault, summary: "Tighten default KMS key policies", detailsMd: `
      KMS Keys start with a default key policy that grants the account access to administer the key,
      mirroring the behavior of the KMS SDK/CLI/Console experience. Users may override the default key
      policy by specifying their own.

      If this flag is not set, the default key policy depends on the setting of the \`trustAccountIdentities\`
      flag. If false (the default, for backwards-compatibility reasons), the default key policy somewhat
      resembles the default admin key policy, but with the addition of 'GenerateDataKey' permissions. If
      true, the policy matches what happens when this feature flag is set.

      Additionally, if this flag is not set and the user supplies a custom key policy, this will be appended
      to the key's default policy (rather than replacing it).`, introducedIn: { v1: "1.78.0" }, defaults: { v2: true }, recommendedValue: true, compatibilityWithOldBehaviorMd: "Pass `trustAccountIdentities: false` to `Key` construct to restore the old behavior." }, [exports2.S3_GRANT_WRITE_WITHOUT_ACL]: { type: flag_modeling_1.FlagType.ApiDefault, summary: "Remove `PutObjectAcl` from Bucket.grantWrite", detailsMd: `
      Change the old 's3:PutObject*' permission to 's3:PutObject' on Bucket,
      as the former includes 's3:PutObjectAcl',
      which could be used to grant read/write object access to IAM principals in other accounts.
      Use a feature flag to make sure existing customers who might be relying
      on the overly-broad permissions are not broken.`, introducedIn: { v1: "1.85.0" }, defaults: { v2: true }, recommendedValue: true, compatibilityWithOldBehaviorMd: "Call `bucket.grantPutAcl()` in addition to `bucket.grantWrite()` to grant ACL permissions." }, [exports2.ECS_REMOVE_DEFAULT_DESIRED_COUNT]: { type: flag_modeling_1.FlagType.ApiDefault, summary: "Do not specify a default DesiredCount for ECS services", detailsMd: `
      ApplicationLoadBalancedServiceBase, ApplicationMultipleTargetGroupServiceBase,
      NetworkLoadBalancedServiceBase, NetworkMultipleTargetGroupServiceBase, and
      QueueProcessingServiceBase currently determine a default value for the desired count of
      a CfnService if a desiredCount is not provided. The result of this is that on every
      deployment, the service count is reset to the fixed value, even if it was autoscaled.

      If this flag is not set, the default behaviour for CfnService.desiredCount is to set a
      desiredCount of 1, if one is not provided. If true, a default will not be defined for
      CfnService.desiredCount and as such desiredCount will be undefined, if one is not provided.`, introducedIn: { v1: "1.92.0" }, defaults: { v2: true }, recommendedValue: true, compatibilityWithOldBehaviorMd: "You can pass `desiredCount: 1` explicitly, but you should never need this." }, [exports2.RDS_LOWERCASE_DB_IDENTIFIER]: { type: flag_modeling_1.FlagType.BugFix, summary: "Force lowercasing of RDS Cluster names in CDK", detailsMd: `
      Cluster names must be lowercase, and the service will lowercase the name when the cluster
      is created. However, CDK did not use to know about this, and would use the user-provided name
      referencing the cluster, which would fail if it happened to be mixed-case.

      With this flag, lowercase the name in CDK so we can reference it properly.

      Must be behind a permanent flag because changing a name from mixed case to lowercase between deployments
      would lead CloudFormation to think the name was changed and would trigger a cluster replacement
      (losing data!).`, introducedIn: { v1: "1.97.0", v2: "2.0.0" }, defaults: { v2: true }, recommendedValue: true }, [exports2.APIGATEWAY_USAGEPLANKEY_ORDERINSENSITIVE_ID]: { type: flag_modeling_1.FlagType.BugFix, summary: "Allow adding/removing multiple UsagePlanKeys independently", detailsMd: `
      The UsagePlanKey resource connects an ApiKey with a UsagePlan. API Gateway does not allow more than one UsagePlanKey
      for any given UsagePlan and ApiKey combination. For this reason, CloudFormation cannot replace this resource without
      either the UsagePlan or ApiKey changing.

      The feature addition to support multiple UsagePlanKey resources - 142bd0e2 - recognized this and attempted to keep
      existing UsagePlanKey logical ids unchanged.
      However, this intentionally caused the logical id of the UsagePlanKey to be sensitive to order. That is, when
      the 'first' UsagePlanKey resource is removed, the logical id of the 'second' assumes what was originally the 'first',
      which again is disallowed.

      In effect, there is no way to get out of this mess in a backwards compatible way, while supporting existing stacks.
      This flag changes the logical id layout of UsagePlanKey to not be sensitive to order.`, introducedIn: { v1: "1.98.0", v2: "2.0.0" }, defaults: { v2: true }, recommendedValue: true }, [exports2.EFS_DEFAULT_ENCRYPTION_AT_REST]: { type: flag_modeling_1.FlagType.ApiDefault, summary: "Enable this feature flag to have elastic file systems encrypted at rest by default.", detailsMd: "\n      Encryption can also be configured explicitly using the `encrypted` property.\n      ", introducedIn: { v1: "1.98.0" }, defaults: { v2: true }, recommendedValue: true, compatibilityWithOldBehaviorMd: "Pass the `encrypted: false` property to the `FileSystem` construct to disable encryption." }, [exports2.LAMBDA_RECOGNIZE_VERSION_PROPS]: { type: flag_modeling_1.FlagType.BugFix, summary: "Enable this feature flag to opt in to the updated logical id calculation for Lambda Version created using the  `fn.currentVersion`.", detailsMd: `
      The previous calculation incorrectly considered properties of the \`AWS::Lambda::Function\` resource that did
      not constitute creating a new Version.

      See 'currentVersion' section in the aws-lambda module's README for more details.`, introducedIn: { v1: "1.106.0", v2: "2.0.0" }, defaults: { v2: true }, recommendedValue: true }, [exports2.LAMBDA_RECOGNIZE_LAYER_VERSION]: { type: flag_modeling_1.FlagType.BugFix, summary: "Enable this feature flag to opt in to the updated logical id calculation for Lambda Version created using the `fn.currentVersion`.", detailsMd: `
      This flag correct incorporates Lambda Layer properties into the Lambda Function Version.

      See 'currentVersion' section in the aws-lambda module's README for more details.`, introducedIn: { v1: "1.159.0", v2: "2.27.0" }, recommendedValue: true }, [exports2.CLOUDFRONT_DEFAULT_SECURITY_POLICY_TLS_V1_2_2021]: { type: flag_modeling_1.FlagType.BugFix, summary: "Enable this feature flag to have cloudfront distributions use the security policy TLSv1.2_2021 by default.", detailsMd: "\n      The security policy can also be configured explicitly using the `minimumProtocolVersion` property.", introducedIn: { v1: "1.117.0", v2: "2.0.0" }, defaults: { v2: true }, recommendedValue: true }, [exports2.CHECK_SECRET_USAGE]: { type: flag_modeling_1.FlagType.VisibleContext, summary: "Enable this flag to make it impossible to accidentally use SecretValues in unsafe locations", detailsMd: "\n      With this flag enabled, `SecretValue` instances can only be passed to\n      constructs that accept `SecretValue`s; otherwise, `unsafeUnwrap()` must be\n      called to use it as a regular string.", introducedIn: { v1: "1.153.0", v2: "2.21.0" }, recommendedValue: true }, [exports2.TARGET_PARTITIONS]: { type: flag_modeling_1.FlagType.VisibleContext, summary: "What regions to include in lookup tables of environment agnostic stacks", detailsMd: `
      Has no effect on stacks that have a defined region, but will limit the amount
      of unnecessary regions included in stacks without a known region.

      The type of this value should be a list of strings.`, introducedIn: { v1: "1.137.0", v2: "2.4.0" }, recommendedValue: ["aws", "aws-cn"] }, [exports2.ECS_SERVICE_EXTENSIONS_ENABLE_DEFAULT_LOG_DRIVER]: { type: flag_modeling_1.FlagType.ApiDefault, summary: "ECS extensions will automatically add an `awslogs` driver if no logging is specified", detailsMd: `
      Enable this feature flag to configure default logging behavior for the ECS Service Extensions. This will enable the
      \`awslogs\` log driver for the application container of the service to send the container logs to CloudWatch Logs.

      This is a feature flag as the new behavior provides a better default experience for the users.`, introducedIn: { v1: "1.140.0", v2: "2.8.0" }, recommendedValue: true, compatibilityWithOldBehaviorMd: "Specify a log driver explicitly." }, [exports2.EC2_UNIQUE_IMDSV2_LAUNCH_TEMPLATE_NAME]: { type: flag_modeling_1.FlagType.BugFix, summary: "Enable this feature flag to have Launch Templates generated by the `InstanceRequireImdsv2Aspect` use unique names.", detailsMd: "\n      Previously, the generated Launch Template names were only unique within a stack because they were based only on the\n      `Instance` construct ID. If another stack that has an `Instance` with the same construct ID is deployed in the same\n      account and region, the deployments would always fail as the generated Launch Template names were the same.\n\n      The new implementation addresses this issue by generating the Launch Template name with the `Names.uniqueId` method.", introducedIn: { v1: "1.140.0", v2: "2.8.0" }, recommendedValue: true }, [exports2.ECS_ARN_FORMAT_INCLUDES_CLUSTER_NAME]: { type: flag_modeling_1.FlagType.BugFix, summary: "ARN format used by ECS. In the new ARN format, the cluster name is part of the resource ID.", detailsMd: `
      If this flag is not set, the old ARN format (without cluster name) for ECS is used.
      If this flag is set, the new ARN format (with cluster name) for ECS is used.

      This is a feature flag as the old format is still valid for existing ECS clusters.

      See https://docs.aws.amazon.com/AmazonECS/latest/developerguide/ecs-account-settings.html#ecs-resource-ids
      `, introducedIn: { v2: "2.35.0" }, recommendedValue: true }, [exports2.IAM_MINIMIZE_POLICIES]: { type: flag_modeling_1.FlagType.VisibleContext, summary: "Minimize IAM policies by combining Statements", detailsMd: `
      Minimize IAM policies by combining Principals, Actions and Resources of two
      Statements in the policies, as long as it doesn't change the meaning of the
      policy.`, introducedIn: { v1: "1.150.0", v2: "2.18.0" }, recommendedValue: true }, [exports2.VALIDATE_SNAPSHOT_REMOVAL_POLICY]: { type: flag_modeling_1.FlagType.ApiDefault, summary: "Error on snapshot removal policies on resources that do not support it.", detailsMd: `
      Makes sure we do not allow snapshot removal policy on resources that do not support it.
      If supplied on an unsupported resource, CloudFormation ignores the policy altogether.
      This flag will reduce confusion and unexpected loss of data when erroneously supplying
      the snapshot removal policy.`, introducedIn: { v2: "2.28.0" }, recommendedValue: true, compatibilityWithOldBehaviorMd: "The old behavior was incorrect. Update your source to not specify SNAPSHOT policies on resources that do not support it." }, [exports2.CODEPIPELINE_CROSS_ACCOUNT_KEY_ALIAS_STACK_SAFE_RESOURCE_NAME]: { type: flag_modeling_1.FlagType.BugFix, summary: "Generate key aliases that include the stack name", detailsMd: `
      Enable this feature flag to have CodePipeline generate a unique cross account key alias name using the stack name.

      Previously, when creating multiple pipelines with similar naming conventions and when crossAccountKeys is true,
      the KMS key alias name created for these pipelines may be the same due to how the uniqueId is generated.

      This new implementation creates a stack safe resource name for the alias using the stack name instead of the stack ID.
      `, introducedIn: { v2: "2.29.0" }, recommendedValue: true }, [exports2.S3_CREATE_DEFAULT_LOGGING_POLICY]: { type: flag_modeling_1.FlagType.BugFix, summary: "Enable this feature flag to create an S3 bucket policy by default in cases where an AWS service would automatically create the Policy if one does not exist.", detailsMd: `
      For example, in order to send VPC flow logs to an S3 bucket, there is a specific Bucket Policy
      that needs to be attached to the bucket. If you create the bucket without a policy and then add the
      bucket as the flow log destination, the service will automatically create the bucket policy with the
      necessary permissions. If you were to then try and add your own bucket policy CloudFormation will throw
      and error indicating that a bucket policy already exists.

      In cases where we know what the required policy is we can go ahead and create the policy so we can
      remain in control of it.

      @see https://docs.aws.amazon.com/AmazonCloudWatch/latest/logs/AWS-logs-and-resource-policy.html#AWS-logs-infrastructure-S3
      `, introducedIn: { v2: "2.31.0" }, recommendedValue: true }, [exports2.SNS_SUBSCRIPTIONS_SQS_DECRYPTION_POLICY]: { type: flag_modeling_1.FlagType.BugFix, summary: "Restrict KMS key policy for encrypted Queues a bit more", detailsMd: `
      Enable this feature flag to restrict the decryption of a SQS queue, which is subscribed to a SNS topic, to
      only the topic which it is subscribed to and not the whole SNS service of an account.

      Previously the decryption was only restricted to the SNS service principal. To make the SQS subscription more
      secure, it is a good practice to restrict the decryption further and only allow the connected SNS topic to decryption
      the subscribed queue.`, introducedIn: { v2: "2.32.0" }, recommendedValue: true }, [exports2.APIGATEWAY_DISABLE_CLOUDWATCH_ROLE]: { type: flag_modeling_1.FlagType.BugFix, summary: "Make default CloudWatch Role behavior safe for multiple API Gateways in one environment", detailsMd: `
      Enable this feature flag to change the default behavior for aws-apigateway.RestApi and aws-apigateway.SpecRestApi
      to _not_ create a CloudWatch role and Account. There is only a single ApiGateway account per AWS
      environment which means that each time you create a RestApi in your account the ApiGateway account
      is overwritten. If at some point the newest RestApi is deleted, the ApiGateway Account and CloudWatch
      role will also be deleted, breaking any existing ApiGateways that were depending on them.

      When this flag is enabled you should either create the ApiGateway account and CloudWatch role
      separately _or_ only enable the cloudWatchRole on a single RestApi.
      `, introducedIn: { v2: "2.38.0" }, recommendedValue: true }, [exports2.ENABLE_PARTITION_LITERALS]: { type: flag_modeling_1.FlagType.BugFix, summary: "Make ARNs concrete if AWS partition is known", detailsMd: `
      Enable this feature flag to get partition names as string literals in Stacks with known regions defined in
      their environment, such as "aws" or "aws-cn".  Previously the CloudFormation intrinsic function
      "Ref: AWS::Partition" was used.  For example:

      \`\`\`yaml
      Principal:
        AWS:
          Fn::Join:
            - ""
            - - "arn:"
              - Ref: AWS::Partition
              - :iam::123456789876:root
      \`\`\`

      becomes:

      \`\`\`yaml
      Principal:
        AWS: "arn:aws:iam::123456789876:root"
      \`\`\`

      The intrinsic function will still be used in Stacks where no region is defined or the region's partition
      is unknown.
      `, introducedIn: { v2: "2.38.0" }, recommendedValue: true }, [exports2.EVENTS_TARGET_QUEUE_SAME_ACCOUNT]: { type: flag_modeling_1.FlagType.BugFix, summary: "Event Rules may only push to encrypted SQS queues in the same account", detailsMd: `
      This flag applies to SQS Queues that are used as the target of event Rules. When enabled, only principals
      from the same account as the Rule can send messages. If a queue is unencrypted, this restriction will
      always apply, regardless of the value of this flag.
      `, introducedIn: { v2: "2.51.0" }, recommendedValue: true }, [exports2.IAM_STANDARDIZED_SERVICE_PRINCIPALS]: { type: flag_modeling_1.FlagType.BugFix, summary: "Use standardized (global) service principals everywhere", detailsMd: `
      We used to maintain a database of exceptions to Service Principal names in various regions. This database
      is no longer necessary: all service principals names have been standardized to their global form (\`SERVICE.amazonaws.com\`).

      This flag disables use of that exceptions database and always uses the global service principal.
      `, introducedIn: { v2: "2.51.0" }, recommendedValue: true }, [exports2.ECS_DISABLE_EXPLICIT_DEPLOYMENT_CONTROLLER_FOR_CIRCUIT_BREAKER]: { type: flag_modeling_1.FlagType.BugFix, summary: 'Avoid setting the "ECS" deployment controller when adding a circuit breaker', detailsMd: `
      Enable this feature flag to avoid setting the "ECS" deployment controller when adding a circuit breaker to an
      ECS Service, as this will trigger a full replacement which fails to deploy when using set service names.
      This does not change any behaviour as the default deployment controller when it is not defined is ECS.

      This is a feature flag as the new behavior provides a better default experience for the users.
      `, introducedIn: { v2: "2.51.0" }, recommendedValue: true }, [exports2.IAM_IMPORTED_ROLE_STACK_SAFE_DEFAULT_POLICY_NAME]: { type: flag_modeling_1.FlagType.BugFix, summary: "Enable this feature to by default create default policy names for imported roles that depend on the stack the role is in.", detailsMd: `
      Without this, importing the same role in multiple places could lead to the permissions given for one version of the imported role
      to overwrite permissions given to the role at a different place where it was imported. This was due to all imported instances
      of a role using the same default policy name.

      This new implementation creates default policy names based on the constructs node path in their stack.
      `, introducedIn: { v2: "2.60.0" }, recommendedValue: true }, [exports2.S3_SERVER_ACCESS_LOGS_USE_BUCKET_POLICY]: { type: flag_modeling_1.FlagType.BugFix, summary: "Use S3 Bucket Policy instead of ACLs for Server Access Logging", detailsMd: `
      Enable this feature flag to use S3 Bucket Policy for granting permission fo Server Access Logging
      rather than using the canned \`LogDeliveryWrite\` ACL. ACLs do not work when Object Ownership is
      enabled on the bucket.

      This flag uses a Bucket Policy statement to allow Server Access Log delivery, following best
      practices for S3.

      @see https://docs.aws.amazon.com/AmazonS3/latest/userguide/enable-server-access-logging.html
    `, introducedIn: { v2: "2.60.0" }, recommendedValue: true }, [exports2.ROUTE53_PATTERNS_USE_CERTIFICATE]: { type: flag_modeling_1.FlagType.ApiDefault, summary: "Use the official `Certificate` resource instead of `DnsValidatedCertificate`", detailsMd: "\n      Enable this feature flag to use the official CloudFormation supported `Certificate` resource instead\n      of the deprecated `DnsValidatedCertificate` construct. If this flag is enabled and you are creating\n      the stack in a region other than us-east-1 then you must also set `crossRegionReferences=true` on the\n      stack.\n      ", introducedIn: { v2: "V2\xB7NEXT" }, recommendedValue: true, compatibilityWithOldBehaviorMd: "Define a `DnsValidatedCertificate` explicitly and pass in the `certificate` property" }, [exports2.AWS_CUSTOM_RESOURCE_LATEST_SDK_DEFAULT]: { type: flag_modeling_1.FlagType.ApiDefault, summary: "Whether to install the latest SDK by default in AwsCustomResource", detailsMd: `
      This was originally introduced and enabled by default to not be limited by the SDK version
      that's installed on AWS Lambda. However, it creates issues for Lambdas bound to VPCs that
      do not have internet access, or in environments where 'npmjs.com' is not available.

      The recommended setting is to disable the default installation behavior, and pass the
      flag on a resource-by-resource basis to enable it if necessary.
    `, compatibilityWithOldBehaviorMd: "Set installLatestAwsSdk: true on all resources that need it.", introducedIn: { v2: "2.60.0" }, recommendedValue: false }, [exports2.DATABASE_PROXY_UNIQUE_RESOURCE_NAME]: { type: flag_modeling_1.FlagType.BugFix, summary: "Use unique resource name for Database Proxy", detailsMd: "\n      If this flag is not set, the default behavior for `DatabaseProxy` is\n      to use `id` of the constructor for `dbProxyName` when it's not specified in the argument.\n      In this case, users can't deploy `DatabaseProxy`s that have the same `id` in the same region.\n\n      If this flag is set, the default behavior is to use unique resource names for each `DatabaseProxy`.\n\n      This is a feature flag as the old behavior was technically incorrect, but users may have come to depend on it.\n    ", introducedIn: { v2: "2.65.0" }, recommendedValue: true }, [exports2.CODEDEPLOY_REMOVE_ALARMS_FROM_DEPLOYMENT_GROUP]: { type: flag_modeling_1.FlagType.BugFix, summary: "Remove CloudWatch alarms from deployment group", detailsMd: `
      Enable this flag to be able to remove all CloudWatch alarms from a deployment group by removing
      the alarms from the construct. If this flag is not set, removing all alarms from the construct
      will still leave the alarms configured for the deployment group.
    `, introducedIn: { v2: "2.65.0" }, recommendedValue: true }, [exports2.APIGATEWAY_AUTHORIZER_CHANGE_DEPLOYMENT_LOGICAL_ID]: { type: flag_modeling_1.FlagType.BugFix, summary: "Include authorizer configuration in the calculation of the API deployment logical ID.", detailsMd: `
      The logical ID of the AWS::ApiGateway::Deployment resource is calculated by hashing
      the API configuration, including methods, and resources, etc. Enable this feature flag
      to also include the configuration of any authorizer attached to the API in the
      calculation, so any changes made to an authorizer will create a new deployment.
      `, introducedIn: { v2: "2.66.0" }, recommendedValue: true }, [exports2.EC2_LAUNCH_TEMPLATE_DEFAULT_USER_DATA]: { type: flag_modeling_1.FlagType.BugFix, summary: "Define user data for a launch template by default when a machine image is provided.", detailsMd: `
      The ec2.LaunchTemplate construct did not define user data when a machine image is
      provided despite the document. If this is set, a user data is automatically defined
      according to the OS of the machine image.
      `, recommendedValue: true, introducedIn: { v2: "2.67.0" } }, [exports2.SECRETS_MANAGER_TARGET_ATTACHMENT_RESOURCE_POLICY]: { type: flag_modeling_1.FlagType.BugFix, summary: "SecretTargetAttachments uses the ResourcePolicy of the attached Secret.", detailsMd: `
      Enable this feature flag to make SecretTargetAttachments use the ResourcePolicy of the attached Secret.
      SecretTargetAttachments are created to connect a Secret to a target resource.
      In CDK code, they behave like regular Secret and can be used as a stand-in in most situations.
      Previously, adding to the ResourcePolicy of a SecretTargetAttachment did attempt to create a separate ResourcePolicy for the same Secret.
      However Secrets can only have a single ResourcePolicy, causing the CloudFormation deployment to fail.

      When enabling this feature flag for an existing Stack, ResourcePolicies created via a SecretTargetAttachment will need replacement.
      This won't be possible without intervention due to limitation outlined above.
      First remove all permissions granted to the Secret and deploy without the ResourcePolicies.
      Then you can re-add the permissions and deploy again.
      `, recommendedValue: true, introducedIn: { v2: "2.67.0" } }, [exports2.REDSHIFT_COLUMN_ID]: { type: flag_modeling_1.FlagType.BugFix, summary: "Whether to use an ID to track Redshift column changes", detailsMd: "\n      Redshift columns are identified by their `name`. If a column is renamed, the old column\n      will be dropped and a new column will be created. This can cause data loss.\n\n      This flag enables the use of an `id` attribute for Redshift columns. If this flag is enabled, the\n      internal CDK architecture will track changes of Redshift columns through their `id`, rather\n      than their `name`. This will prevent data loss when columns are renamed.\n\n      **NOTE** - Enabling this flag comes at a **risk**. When enabled, update the `id`s of all columns,\n      **however** do not change the `names`s of the columns. If the `name`s of the columns are changed during\n      initial deployment, the columns will be dropped and recreated, causing data loss. After the initial deployment\n      of the `id`s, the `name`s of the columns can be changed without data loss.\n      ", introducedIn: { v2: "2.68.0" }, recommendedValue: true }, [exports2.ENABLE_EMR_SERVICE_POLICY_V2]: { type: flag_modeling_1.FlagType.BugFix, summary: "Enable AmazonEMRServicePolicy_v2 managed policies", detailsMd: `
      If this flag is not set, the default behavior for \`EmrCreateCluster\` is
      to use \`AmazonElasticMapReduceRole\` managed policies.

      If this flag is set, the default behavior is to use the new \`AmazonEMRServicePolicy_v2\`
      managed policies.

      This is a feature flag as the old behavior will be deprecated, but some resources may require manual
      intervention since they might not have the appropriate tags propagated automatically.
      `, introducedIn: { v2: "2.72.0" }, recommendedValue: true }, [exports2.EC2_RESTRICT_DEFAULT_SECURITY_GROUP]: { type: flag_modeling_1.FlagType.ApiDefault, summary: "Restrict access to the VPC default security group", detailsMd: `
      Enable this feature flag to remove the default ingress/egress rules from the
      VPC default security group.

      When a VPC is created, a default security group is created as well and this cannot
      be deleted. The default security group is created with ingress/egress rules that allow
      _all_ traffic. [AWS Security best practices recommend](https://docs.aws.amazon.com/securityhub/latest/userguide/ec2-controls.html#ec2-2)
      removing these ingress/egress rules in order to restrict access to the default security group.
    `, introducedIn: { v2: "V2\xB7NEXT" }, recommendedValue: true, compatibilityWithOldBehaviorMd: `
      To allow all ingress/egress traffic to the VPC default security group you
      can set the \`restrictDefaultSecurityGroup: false\`.
    ` }, [exports2.APIGATEWAY_REQUEST_VALIDATOR_UNIQUE_ID]: { type: flag_modeling_1.FlagType.BugFix, summary: "Generate a unique id for each RequestValidator added to a method", detailsMd: "\n      This flag allows multiple RequestValidators to be added to a RestApi when\n      providing the `RequestValidatorOptions` in the `addMethod()` method.\n\n      If the flag is not set then only a single RequestValidator can be added in this way.\n      Any additional RequestValidators have to be created directly with `new RequestValidator`.\n    ", introducedIn: { v2: "V2\xB7NEXT" }, recommendedValue: true } };
    var CURRENT_MV = "v2";
    exports2.CURRENT_VERSION_EXPIRED_FLAGS = Object.entries(exports2.FLAGS).filter(([_, flag]) => flag.introducedIn[CURRENT_MV] === void 0).map(([name, _]) => name).sort(), exports2.NEW_PROJECT_CONTEXT = Object.fromEntries(Object.entries(exports2.FLAGS).filter(([_, flag]) => flag.recommendedValue !== flag.defaults?.[CURRENT_MV] && flag.introducedIn[CURRENT_MV]).map(([name, flag]) => [name, flag.recommendedValue])), exports2.CURRENT_VERSION_FLAG_DEFAULTS = Object.fromEntries(Object.entries(exports2.FLAGS).filter(([_, flag]) => flag.defaults?.[CURRENT_MV] !== void 0).map(([name, flag]) => [name, flag.defaults?.[CURRENT_MV]]));
    function futureFlagDefault(flag) {
      const value = exports2.CURRENT_VERSION_FLAG_DEFAULTS[flag] ?? false;
      if (typeof value != "boolean")
        throw new Error(`futureFlagDefault: default type of flag '${flag}' should be boolean, got '${typeof value}'`);
      return value;
    }
    exports2.futureFlagDefault = futureFlagDefault, exports2.FUTURE_FLAGS_EXPIRED = exports2.CURRENT_VERSION_EXPIRED_FLAGS, exports2.FUTURE_FLAGS = Object.fromEntries(Object.entries(exports2.NEW_PROJECT_CONTEXT).filter(([_, v]) => typeof v == "boolean")), exports2.NEW_PROJECT_DEFAULT_CONTEXT = Object.fromEntries(Object.entries(exports2.NEW_PROJECT_CONTEXT).filter(([_, v]) => typeof v != "boolean"));
  }
});

// node_modules/aws-cdk-lib/cx-api/lib/placeholders.js
var require_placeholders = __commonJS({
  "node_modules/aws-cdk-lib/cx-api/lib/placeholders.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EnvironmentPlaceholders = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var EnvironmentPlaceholders = class _EnvironmentPlaceholders {
      static replace(object, values) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_cx_api_EnvironmentPlaceholderValues(values);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.replace), error;
        }
        return this.recurse(object, (value) => (value = replaceAll(value, _EnvironmentPlaceholders.CURRENT_REGION, values.region), value = replaceAll(value, _EnvironmentPlaceholders.CURRENT_ACCOUNT, values.accountId), value = replaceAll(value, _EnvironmentPlaceholders.CURRENT_PARTITION, values.partition), value));
      }
      static async replaceAsync(object, provider) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_cx_api_IEnvironmentPlaceholderProvider(provider);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.replaceAsync), error;
        }
        let needRegion = false, needAccountId = false, needPartition = false;
        this.recurse(object, (value) => (value.indexOf(_EnvironmentPlaceholders.CURRENT_REGION) > 1 && (needRegion = true), value.indexOf(_EnvironmentPlaceholders.CURRENT_ACCOUNT) > 1 && (needAccountId = true), value.indexOf(_EnvironmentPlaceholders.CURRENT_PARTITION) > 1 && (needPartition = true), value));
        const region = needRegion ? await provider.region() : void 0, accountId = needAccountId ? await provider.accountId() : void 0, partition = needPartition ? await provider.partition() : void 0;
        return this.recurse(object, (value) => (value = replaceAll(value, _EnvironmentPlaceholders.CURRENT_REGION, region ?? "WONTHAPPEN"), value = replaceAll(value, _EnvironmentPlaceholders.CURRENT_ACCOUNT, accountId ?? "WONTHAPPEN"), value = replaceAll(value, _EnvironmentPlaceholders.CURRENT_PARTITION, partition ?? "WONTHAPPEN"), value));
      }
      static recurse(value, cb) {
        if (typeof value == "string")
          return cb(value);
        if (typeof value != "object" || value === null)
          return value;
        if (Array.isArray(value))
          return value.map((x) => this.recurse(x, cb));
        const ret = {};
        for (const [key, inner] of Object.entries(value))
          ret[key] = this.recurse(inner, cb);
        return ret;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EnvironmentPlaceholders[_a] = { fqn: "aws-cdk-lib.cx_api.EnvironmentPlaceholders", version: "2.80.0" }, EnvironmentPlaceholders.CURRENT_REGION = "${AWS::Region}", EnvironmentPlaceholders.CURRENT_ACCOUNT = "${AWS::AccountId}", EnvironmentPlaceholders.CURRENT_PARTITION = "${AWS::Partition}", exports2.EnvironmentPlaceholders = EnvironmentPlaceholders;
    function replaceAll(s, search, replace) {
      return s.split(search).join(replace);
    }
  }
});

// node_modules/aws-cdk-lib/cx-api/lib/app.js
var require_app = __commonJS({
  "node_modules/aws-cdk-lib/cx-api/lib/app.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.BUNDLING_STACKS = exports2.DISABLE_LOGICAL_ID_METADATA = exports2.DISABLE_METADATA_STACK_TRACE = exports2.DISABLE_ASSET_STAGING_CONTEXT = exports2.ANALYTICS_REPORTING_ENABLED_CONTEXT = exports2.PATH_METADATA_ENABLE_CONTEXT = void 0, exports2.PATH_METADATA_ENABLE_CONTEXT = "aws:cdk:enable-path-metadata", exports2.ANALYTICS_REPORTING_ENABLED_CONTEXT = "aws:cdk:version-reporting", exports2.DISABLE_ASSET_STAGING_CONTEXT = "aws:cdk:disable-asset-staging", exports2.DISABLE_METADATA_STACK_TRACE = "aws:cdk:disable-stack-trace", exports2.DISABLE_LOGICAL_ID_METADATA = "aws:cdk:disable-logicalId-metadata", exports2.BUNDLING_STACKS = "aws:cdk:bundling-stacks";
  }
});

// node_modules/aws-cdk-lib/cx-api/lib/index.js
var require_lib5 = __commonJS({
  "node_modules/aws-cdk-lib/cx-api/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_cxapi(), exports2), __exportStar(require_vpc(), exports2), __exportStar(require_ami(), exports2), __exportStar(require_load_balancer(), exports2), __exportStar(require_availability_zones(), exports2), __exportStar(require_endpoint_service_availability_zones(), exports2), __exportStar(require_security_group(), exports2), __exportStar(require_key(), exports2), __exportStar(require_cloud_artifact(), exports2), require_cloud_artifact_aug(), __exportStar(require_asset_manifest_artifact(), exports2), __exportStar(require_cloudformation_artifact(), exports2), __exportStar(require_tree_cloud_artifact(), exports2), __exportStar(require_nested_cloud_assembly_artifact(), exports2), require_nested_cloud_assembly_artifact_aug(), __exportStar(require_cloud_assembly2(), exports2), __exportStar(require_assets2(), exports2), __exportStar(require_environment(), exports2), __exportStar(require_metadata3(), exports2), __exportStar(require_features(), exports2), __exportStar(require_placeholders(), exports2), __exportStar(require_app(), exports2);
  }
});

// node_modules/aws-cdk-lib/cx-api/index.js
var require_cx_api = __commonJS({
  "node_modules/aws-cdk-lib/cx-api/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib5(), exports2);
  }
});

// node_modules/aws-cdk-lib/core/lib/annotations.js
var require_annotations = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/annotations.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Annotations = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cxschema = require_cloud_assembly_schema2();
    var cxapi = require_cx_api();
    var Annotations = class _Annotations {
      static of(scope) {
        return new _Annotations(scope);
      }
      constructor(scope) {
        this.scope = scope;
        const disableTrace = scope.node.tryGetContext(cxapi.DISABLE_METADATA_STACK_TRACE) || process.env.CDK_DISABLE_STACK_TRACE;
        this.stackTraces = !disableTrace;
      }
      addWarning(message) {
        this.addMessage(cxschema.ArtifactMetadataEntryType.WARN, message);
      }
      addInfo(message) {
        this.addMessage(cxschema.ArtifactMetadataEntryType.INFO, message);
      }
      addError(message) {
        this.addMessage(cxschema.ArtifactMetadataEntryType.ERROR, message);
      }
      addDeprecation(api, message) {
        const text = `The API ${api} is deprecated: ${message}. This API will be removed in the next major release`;
        if (process.env.CDK_BLOCK_DEPRECATIONS)
          throw new Error(`${this.scope.node.path}: ${text}`);
        this.addWarning(text);
      }
      addMessage(level, message) {
        !this.scope.node.metadata.find((x) => x.data === message) && this.scope.node.addMetadata(level, message, { stackTrace: this.stackTraces });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Annotations[_a] = { fqn: "aws-cdk-lib.Annotations", version: "2.80.0" }, exports2.Annotations = Annotations;
  }
});

// node_modules/aws-cdk-lib/core/lib/debug.js
var require_debug2 = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/debug.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.debugModeEnabled = exports2.CDK_DEBUG = void 0;
    var process_1 = require("process");
    exports2.CDK_DEBUG = "CDK_DEBUG";
    function debugModeEnabled() {
      return isTruthy(process_1.env[exports2.CDK_DEBUG]);
    }
    exports2.debugModeEnabled = debugModeEnabled;
    var TRUTHY_VALUES = /* @__PURE__ */ new Set(["1", "on", "true"]);
    function isTruthy(value) {
      return value ? TRUTHY_VALUES.has(value.toLowerCase()) : false;
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/stack-trace.js
var require_stack_trace2 = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/stack-trace.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.captureStackTrace = void 0;
    var debug_1 = require_debug2();
    function captureStackTrace(below = captureStackTrace, limit = Number.MAX_SAFE_INTEGER) {
      if (!(0, debug_1.debugModeEnabled)())
        return ["stack traces disabled"];
      const object = {}, previousLimit = Error.stackTraceLimit;
      try {
        Error.stackTraceLimit = limit, Error.captureStackTrace(object, below);
      } finally {
        Error.stackTraceLimit = previousLimit;
      }
      return object.stack ? object.stack.split(`
`).slice(1).map((s) => s.replace(/^\s*at\s+/, "")) : [];
    }
    exports2.captureStackTrace = captureStackTrace;
  }
});

// node_modules/aws-cdk-lib/core/lib/string-fragments.js
var require_string_fragments = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/string-fragments.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.TokenizedStringFragments = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var token_1 = require_token2();
    var TokenizedStringFragments = class _TokenizedStringFragments {
      constructor() {
        this.fragments = new Array();
      }
      get firstToken() {
        const first = this.fragments[0];
        if (first.type === "token")
          return first.token;
      }
      get firstValue() {
        return fragmentValue(this.fragments[0]);
      }
      get length() {
        return this.fragments.length;
      }
      addLiteral(lit) {
        this.fragments.push({ type: "literal", lit });
      }
      addToken(token) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_IResolvable(token);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToken), error;
        }
        this.fragments.push({ type: "token", token });
      }
      addIntrinsic(value) {
        this.fragments.push({ type: "intrinsic", value });
      }
      get tokens() {
        const ret = new Array();
        for (const f of this.fragments)
          f.type === "token" && ret.push(f.token);
        return ret;
      }
      mapTokens(mapper) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ITokenMapper(mapper);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.mapTokens), error;
        }
        const ret = new _TokenizedStringFragments();
        for (const f of this.fragments)
          switch (f.type) {
            case "literal":
              ret.addLiteral(f.lit);
              break;
            case "token":
              const mapped = mapper.mapToken(f.token);
              (0, token_1.isResolvableObject)(mapped) ? ret.addToken(mapped) : token_1.Token.isUnresolved(mapped) ? ret.addIntrinsic(mapped) : ret.addLiteral(mapped);
              break;
            case "intrinsic":
              ret.addIntrinsic(f.value);
              break;
          }
        return ret;
      }
      join(concat) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_IFragmentConcatenator(concat);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.join), error;
        }
        if (this.fragments.length === 0)
          return concat.join(void 0, void 0);
        if (this.fragments.length === 1)
          return this.firstValue;
        const values = this.fragments.map(fragmentValue);
        for (; values.length > 1; ) {
          const prefix = values.splice(0, 2);
          values.splice(0, 0, concat.join(prefix[0], prefix[1]));
        }
        return values[0];
      }
    };
    _a = JSII_RTTI_SYMBOL_1, TokenizedStringFragments[_a] = { fqn: "aws-cdk-lib.TokenizedStringFragments", version: "2.80.0" }, exports2.TokenizedStringFragments = TokenizedStringFragments;
    function fragmentValue(fragment) {
      switch (fragment.type) {
        case "literal":
          return fragment.lit;
        case "token":
          return fragment.token.toString();
        case "intrinsic":
          return fragment.value;
      }
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/private/encoding.js
var require_encoding = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/private/encoding.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.stringContainsNumberTokens = exports2.extractTokenDouble = exports2.createTokenDouble = exports2.unresolved = exports2.containsListTokenElement = exports2.NullConcat = exports2.regexQuote = exports2.TokenString = exports2.STRINGIFIED_NUMBER_PATTERN = exports2.VALID_KEY_CHARS = exports2.END_TOKEN_MARKER = exports2.BEGIN_LIST_TOKEN_MARKER = exports2.BEGIN_STRING_TOKEN_MARKER = void 0;
    var string_fragments_1 = require_string_fragments();
    var token_1 = require_token2();
    exports2.BEGIN_STRING_TOKEN_MARKER = "${Token[", exports2.BEGIN_LIST_TOKEN_MARKER = "#{Token[", exports2.END_TOKEN_MARKER = "]}", exports2.VALID_KEY_CHARS = "a-zA-Z0-9:._-";
    var QUOTED_BEGIN_STRING_TOKEN_MARKER = regexQuote(exports2.BEGIN_STRING_TOKEN_MARKER);
    var QUOTED_BEGIN_LIST_TOKEN_MARKER = regexQuote(exports2.BEGIN_LIST_TOKEN_MARKER);
    var QUOTED_END_TOKEN_MARKER = regexQuote(exports2.END_TOKEN_MARKER);
    exports2.STRINGIFIED_NUMBER_PATTERN = "-1\\.\\d{10,16}e\\+289";
    var STRING_TOKEN_REGEX = new RegExp(`${QUOTED_BEGIN_STRING_TOKEN_MARKER}([${exports2.VALID_KEY_CHARS}]+)${QUOTED_END_TOKEN_MARKER}|(${exports2.STRINGIFIED_NUMBER_PATTERN})`, "g");
    var LIST_TOKEN_REGEX = new RegExp(`${QUOTED_BEGIN_LIST_TOKEN_MARKER}([${exports2.VALID_KEY_CHARS}]+)${QUOTED_END_TOKEN_MARKER}`, "g");
    var TokenString = class _TokenString {
      static forString(s) {
        return new _TokenString(s, STRING_TOKEN_REGEX);
      }
      static forListToken(s) {
        return new _TokenString(s, LIST_TOKEN_REGEX);
      }
      constructor(str, re) {
        this.str = str, this.re = re;
      }
      split(lookup) {
        const ret = new string_fragments_1.TokenizedStringFragments();
        let rest = 0;
        this.re.lastIndex = 0;
        let m = this.re.exec(this.str);
        for (; m; )
          m.index > rest && ret.addLiteral(this.str.substring(rest, m.index)), ret.addToken(lookup(m[1] ?? m[2])), rest = this.re.lastIndex, m = this.re.exec(this.str);
        return rest < this.str.length && ret.addLiteral(this.str.substring(rest)), ret;
      }
      test() {
        return this.re.lastIndex = 0, this.re.test(this.str);
      }
    };
    exports2.TokenString = TokenString;
    function regexQuote(s) {
      return s.replace(/[.?*+^$[\]\\(){}|-]/g, "\\$&");
    }
    exports2.regexQuote = regexQuote;
    var NullConcat = class {
      join(_left, _right) {
      }
    };
    exports2.NullConcat = NullConcat;
    function containsListTokenElement(xs) {
      return xs.some((x) => typeof x == "string" && TokenString.forListToken(x).test());
    }
    exports2.containsListTokenElement = containsListTokenElement;
    function unresolved(obj) {
      return typeof obj == "string" ? TokenString.forString(obj).test() : typeof obj == "number" ? extractTokenDouble(obj) !== void 0 : Array.isArray(obj) && obj.length === 1 ? typeof obj[0] == "string" && TokenString.forListToken(obj[0]).test() : (0, token_1.isResolvableObject)(obj);
    }
    exports2.unresolved = unresolved;
    var DOUBLE_TOKEN_MARKER_BITS = -67174400;
    var MAX_ENCODABLE_INTEGER = Math.pow(2, 48) - 1;
    var BITS32 = Math.pow(2, 32);
    function createTokenDouble(x) {
      if (Math.floor(x) !== x || x < 0)
        throw new Error("Can only encode positive integers");
      if (x > MAX_ENCODABLE_INTEGER)
        throw new Error(`Got an index too large to encode: ${x}`);
      const buf = new ArrayBuffer(8), ints = new Uint32Array(buf);
      return ints[0] = x & 4294967295, ints[1] = shr32(x) & 65535 | DOUBLE_TOKEN_MARKER_BITS, new Float64Array(buf)[0];
    }
    exports2.createTokenDouble = createTokenDouble;
    function shr32(x) {
      return Math.floor(x / BITS32);
    }
    function shl32(x) {
      return x * BITS32;
    }
    function extractTokenDouble(encoded) {
      const buf = new ArrayBuffer(8);
      new Float64Array(buf)[0] = encoded;
      const ints = new Uint32Array(buf);
      if ((ints[1] & 4294901760) === DOUBLE_TOKEN_MARKER_BITS)
        return ints[0] + shl32(ints[1] & 65535);
    }
    exports2.extractTokenDouble = extractTokenDouble;
    var STRINGIFIED_NUMBER_REGEX = new RegExp(exports2.STRINGIFIED_NUMBER_PATTERN);
    function stringContainsNumberTokens(x) {
      return !!x.match(STRINGIFIED_NUMBER_REGEX);
    }
    exports2.stringContainsNumberTokens = stringContainsNumberTokens;
  }
});

// node_modules/aws-cdk-lib/core/lib/type-hints.js
var require_type_hints = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/type-hints.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ResolutionTypeHint = void 0;
    var ResolutionTypeHint;
    (function(ResolutionTypeHint2) {
      ResolutionTypeHint2.STRING = "string", ResolutionTypeHint2.NUMBER = "number", ResolutionTypeHint2.STRING_LIST = "string-list";
    })(ResolutionTypeHint = exports2.ResolutionTypeHint || (exports2.ResolutionTypeHint = {}));
  }
});

// node_modules/aws-cdk-lib/core/lib/private/intrinsic.js
var require_intrinsic = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/private/intrinsic.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Intrinsic = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var stack_trace_1 = require_stack_trace2();
    var token_1 = require_token2();
    var type_hints_1 = require_type_hints();
    var Intrinsic = class _Intrinsic {
      constructor(value, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_IntrinsicProps(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Intrinsic), error;
        }
        if (isFunction(value))
          throw new Error(`Argument to Intrinsic must be a plain value object, got ${value}`);
        this.creationStack = options.stackTrace ?? true ? (0, stack_trace_1.captureStackTrace)() : [], this.value = value, this.typeHint = options.typeHint ?? type_hints_1.ResolutionTypeHint.STRING;
      }
      resolve(_context) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_IResolveContext(_context);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.resolve), error;
        }
        return this.value;
      }
      toString() {
        return token_1.Token.asString(this);
      }
      toStringList() {
        return token_1.Token.asList(this);
      }
      toJSON() {
        return "<unresolved-token>";
      }
      newError(message) {
        return new Error(`${message}
Token created:
    at ${this.creationStack.join(`
    at `)}
Error thrown:`);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Intrinsic[_a] = { fqn: "aws-cdk-lib.Intrinsic", version: "2.80.0" }, exports2.Intrinsic = Intrinsic;
    function isFunction(x) {
      return typeof x == "function";
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/private/token-map.js
var require_token_map = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/private/token-map.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.TokenMap = void 0;
    var encoding_1 = require_encoding();
    var token_1 = require_token2();
    var glob = global;
    var STRING_SYMBOL = Symbol.for("@aws-cdk/core.TokenMap.STRING");
    var LIST_SYMBOL = Symbol.for("@aws-cdk/core.TokenMap.LIST");
    var NUMBER_SYMBOL = Symbol.for("@aws-cdk/core.TokenMap.NUMBER");
    var TokenMap = class _TokenMap {
      constructor() {
        this.stringTokenMap = /* @__PURE__ */ new Map(), this.numberTokenMap = /* @__PURE__ */ new Map(), this.tokenCounter = Math.floor(Math.random() * 10);
      }
      static instance() {
        return glob.__cdkTokenMap || (glob.__cdkTokenMap = new _TokenMap()), glob.__cdkTokenMap;
      }
      registerString(token, displayHint) {
        return cachedValue(token, STRING_SYMBOL, () => {
          const key = this.registerStringKey(token, displayHint);
          return `${encoding_1.BEGIN_STRING_TOKEN_MARKER}${key}${encoding_1.END_TOKEN_MARKER}`;
        });
      }
      registerList(token, displayHint) {
        return cachedValue(token, LIST_SYMBOL, () => {
          const key = this.registerStringKey(token, displayHint);
          return [`${encoding_1.BEGIN_LIST_TOKEN_MARKER}${key}${encoding_1.END_TOKEN_MARKER}`];
        });
      }
      registerNumber(token) {
        return cachedValue(token, NUMBER_SYMBOL, () => this.registerNumberKey(token));
      }
      tokenFromEncoding(x) {
        if ((0, token_1.isResolvableObject)(x))
          return x;
        if (typeof x == "string")
          return this.lookupString(x);
        if (Array.isArray(x))
          return this.lookupList(x);
        if (token_1.Token.isUnresolved(x))
          return x;
      }
      lookupString(s) {
        const fragments = this.splitString(s);
        if (fragments.tokens.length > 0 && fragments.length === 1)
          return fragments.firstToken;
      }
      lookupList(xs) {
        if (xs.length !== 1)
          return;
        const fragments = encoding_1.TokenString.forListToken(xs[0]).split(this.lookupToken.bind(this));
        if (fragments.length === 1)
          return fragments.firstToken;
      }
      splitString(s) {
        return encoding_1.TokenString.forString(s).split(this.lookupToken.bind(this));
      }
      lookupNumberToken(x) {
        const tokenIndex = (0, encoding_1.extractTokenDouble)(x);
        if (tokenIndex === void 0)
          return;
        const t = this.numberTokenMap.get(tokenIndex);
        if (t === void 0)
          throw new Error("Encoded representation of unknown number Token found");
        return t;
      }
      lookupToken(key) {
        const token = this.stringTokenMap.get(key);
        if (!token)
          throw new Error(`Unrecognized token key: ${key}`);
        return token;
      }
      registerStringKey(token, displayHint) {
        const counter = this.tokenCounter++, key = `${(displayHint || "TOKEN").replace(new RegExp(`[^${encoding_1.VALID_KEY_CHARS}]`, "g"), ".")}.${counter}`;
        return this.stringTokenMap.set(key, token), key;
      }
      registerNumberKey(token) {
        const counter = this.tokenCounter++, dbl = (0, encoding_1.createTokenDouble)(counter);
        return this.numberTokenMap.set(counter, token), this.stringTokenMap.set(`${dbl}`, token), dbl;
      }
    };
    exports2.TokenMap = TokenMap;
    function cachedValue(x, sym, prod) {
      let cached = x[sym];
      return cached === void 0 && (cached = prod(), Object.defineProperty(x, sym, { value: cached })), cached;
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/resolvable.js
var require_resolvable = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/resolvable.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DefaultTokenResolver = exports2.StringConcat = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var encoding_1 = require_encoding();
    var token_map_1 = require_token_map();
    var StringConcat = class {
      join(left, right) {
        return left === void 0 ? right !== void 0 ? `${right}` : void 0 : right === void 0 ? `${left}` : `${left}${right}`;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, StringConcat[_a] = { fqn: "aws-cdk-lib.StringConcat", version: "2.80.0" }, exports2.StringConcat = StringConcat;
    var DefaultTokenResolver = class _DefaultTokenResolver {
      constructor(concat) {
        this.concat = concat;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_IFragmentConcatenator(concat);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _DefaultTokenResolver), error;
        }
      }
      resolveToken(t, context, postProcessor) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_IResolvable(t), jsiiDeprecationWarnings.aws_cdk_lib_IResolveContext(context), jsiiDeprecationWarnings.aws_cdk_lib_IPostProcessor(postProcessor);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.resolveToken), error;
        }
        try {
          let resolved = t.resolve(context);
          return resolved = context.resolve(resolved), resolved = postProcessor.postProcess(resolved, context), resolved;
        } catch (e) {
          let message = `Resolution error: ${e.message}.`;
          throw t.creationStack && t.creationStack.length > 0 && (message += `
Object creation stack:
  at ${t.creationStack.join(`
  at `)}`), e.message = message, e;
        }
      }
      resolveString(fragments, context) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TokenizedStringFragments(fragments), jsiiDeprecationWarnings.aws_cdk_lib_IResolveContext(context);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.resolveString), error;
        }
        return fragments.mapTokens({ mapToken: context.resolve }).join(this.concat);
      }
      resolveList(xs, context) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_IResolveContext(context);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.resolveList), error;
        }
        if (xs.length !== 1)
          throw new Error(`Cannot add elements to list token, got: ${xs}`);
        const str = encoding_1.TokenString.forListToken(xs[0]), tokenMap = token_map_1.TokenMap.instance(), fragments = str.split(tokenMap.lookupToken.bind(tokenMap));
        if (fragments.length !== 1)
          throw new Error(`Cannot concatenate strings in a tokenized string array, got: ${xs[0]}`);
        return fragments.mapTokens({ mapToken: context.resolve }).firstValue;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, DefaultTokenResolver[_b] = { fqn: "aws-cdk-lib.DefaultTokenResolver", version: "2.80.0" }, exports2.DefaultTokenResolver = DefaultTokenResolver;
  }
});

// node_modules/aws-cdk-lib/core/lib/private/resolve.js
var require_resolve = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/private/resolve.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.resolvedTypeHint = exports2.RememberingTokenResolver = exports2.findTokens = exports2.resolve = exports2.INTRINSIC_KEY_PREFIX = void 0;
    var encoding_1 = require_encoding();
    var token_map_1 = require_token_map();
    var resolvable_1 = require_resolvable();
    var type_hints_1 = require_type_hints();
    var tokenMap = token_map_1.TokenMap.instance();
    var RESOLUTION_TYPEHINT_SYM = Symbol.for("@aws-cdk/core.resolvedTypeHint");
    exports2.INTRINSIC_KEY_PREFIX = "$IntrinsicKey$";
    function resolve(obj, options) {
      const prefix = options.prefix || [], pathName = "/" + prefix.join("/");
      function makeContext(appendPath) {
        const newPrefix = appendPath !== void 0 ? prefix.concat([appendPath]) : options.prefix;
        let postProcessor;
        const context = { preparing: options.preparing, scope: options.scope, documentPath: newPrefix ?? [], registerPostProcessor(pp) {
          postProcessor = pp;
        }, resolve(x, changeOptions) {
          return resolve(x, { ...options, ...changeOptions, prefix: newPrefix });
        } };
        return [context, { postProcess(x) {
          return postProcessor ? postProcessor.postProcess(x, context) : x;
        } }];
      }
      if (prefix.length > 200)
        throw new Error("Unable to resolve object tree with circular reference. Path: " + pathName);
      const leaveEmpty = options.removeEmpty === false;
      if (typeof obj > "u")
        return;
      if (obj === null)
        return null;
      if (typeof obj == "function")
        throw new Error(`Trying to resolve a non-data object. Only token are supported for lazy evaluation. Path: ${pathName}. Object: ${obj}`);
      if (typeof obj == "string") {
        if (encoding_1.TokenString.forListToken(obj).test())
          throw new Error("Found an encoded list token string in a scalar string context. Use 'Fn.select(0, list)' (not 'list[0]') to extract elements from token lists.");
        const str = encoding_1.TokenString.forString(obj);
        if (str.test()) {
          const fragments = str.split(tokenMap.lookupToken.bind(tokenMap));
          return tagResolvedValue(options.resolver.resolveString(fragments, makeContext()[0]), type_hints_1.ResolutionTypeHint.STRING);
        }
        return obj;
      }
      if (typeof obj == "number")
        return tagResolvedValue(resolveNumberToken(obj, makeContext()[0]), type_hints_1.ResolutionTypeHint.NUMBER);
      if (typeof obj != "object" || obj instanceof Date)
        return obj;
      if (Array.isArray(obj))
        return (0, encoding_1.containsListTokenElement)(obj) ? tagResolvedValue(options.resolver.resolveList(obj, makeContext()[0]), type_hints_1.ResolutionTypeHint.STRING_LIST) : obj.map((x, i) => makeContext(`${i}`)[0].resolve(x)).filter((x) => leaveEmpty || typeof x < "u");
      if (obj === null)
        return obj;
      if ((0, encoding_1.unresolved)(obj)) {
        const [context, postProcessor] = makeContext();
        return tagResolvedValue(options.resolver.resolveToken(obj, context, postProcessor), type_hints_1.ResolutionTypeHint.STRING);
      }
      if (isConstruct(obj))
        throw new Error("Trying to resolve() a Construct at " + pathName);
      const result = {};
      let intrinsicKeyCtr = 0;
      for (const key of Object.keys(obj)) {
        const value = makeContext(String(key))[0].resolve(obj[key]);
        if (typeof value > "u") {
          leaveEmpty && (result[key] = void 0);
          continue;
        }
        if (!(0, encoding_1.unresolved)(key)) {
          result[key] = value;
          continue;
        }
        const resolvedKey = makeContext()[0].resolve(key);
        if (typeof resolvedKey == "string")
          result[resolvedKey] = value;
        else {
          if (!options.allowIntrinsicKeys)
            throw new Error(`"${String(key)}" is used as the key in a map so must resolve to a string, but it resolves to: ${JSON.stringify(resolvedKey)}. Consider using "CfnJson" to delay resolution to deployment-time`);
          result[`${exports2.INTRINSIC_KEY_PREFIX}${intrinsicKeyCtr++}`] = [resolvedKey, value];
        }
      }
      const previousTypeHint = resolvedTypeHint(obj);
      return previousTypeHint ? tagResolvedValue(result, previousTypeHint) : result;
    }
    exports2.resolve = resolve;
    function findTokens(scope, fn) {
      const resolver = new RememberingTokenResolver(new resolvable_1.StringConcat());
      return resolve(fn(), { scope, prefix: [], resolver, preparing: true }), resolver.tokens;
    }
    exports2.findTokens = findTokens;
    var RememberingTokenResolver = class extends resolvable_1.DefaultTokenResolver {
      constructor() {
        super(...arguments), this.tokensSeen = /* @__PURE__ */ new Set();
      }
      resolveToken(t, context, postProcessor) {
        return this.tokensSeen.add(t), super.resolveToken(t, context, postProcessor);
      }
      resolveString(s, context) {
        return super.resolveString(s, context);
      }
      get tokens() {
        return Array.from(this.tokensSeen);
      }
    };
    exports2.RememberingTokenResolver = RememberingTokenResolver;
    function isConstruct(x) {
      return x._children !== void 0 && x._metadata !== void 0;
    }
    function resolveNumberToken(x, context) {
      const token = token_map_1.TokenMap.instance().lookupNumberToken(x);
      return token === void 0 ? x : context.resolve(token);
    }
    function tagResolvedValue(value, typeHint) {
      return typeof value != "object" || value == null || Object.defineProperty(value, RESOLUTION_TYPEHINT_SYM, { value: typeHint, configurable: true }), value;
    }
    function resolvedTypeHint(value) {
      if (!(typeof value != "object" || value == null))
        return value[RESOLUTION_TYPEHINT_SYM];
    }
    exports2.resolvedTypeHint = resolvedTypeHint;
  }
});

// node_modules/aws-cdk-lib/core/lib/token.js
var require_token2 = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/token.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.withResolved = exports2.isResolvableObject = exports2.JsonNull = exports2.Tokenization = exports2.Token = exports2.TokenComparison = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var lazy_1 = require_lazy();
    var encoding_1 = require_encoding();
    var intrinsic_1 = require_intrinsic();
    var resolve_1 = require_resolve();
    var token_map_1 = require_token_map();
    var TokenComparison = class {
      constructor() {
      }
    };
    _a = JSII_RTTI_SYMBOL_1, TokenComparison[_a] = { fqn: "aws-cdk-lib.TokenComparison", version: "2.80.0" }, TokenComparison.SAME = new TokenComparison(), TokenComparison.DIFFERENT = new TokenComparison(), TokenComparison.ONE_UNRESOLVED = new TokenComparison(), TokenComparison.BOTH_UNRESOLVED = new TokenComparison(), exports2.TokenComparison = TokenComparison;
    var Token = class _Token {
      static isUnresolved(obj) {
        return (0, encoding_1.unresolved)(obj);
      }
      static asString(value, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_EncodingOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.asString), error;
        }
        return typeof value == "string" ? value : token_map_1.TokenMap.instance().registerString(_Token.asAny(value), options.displayHint);
      }
      static asNumber(value) {
        return typeof value == "number" ? value : token_map_1.TokenMap.instance().registerNumber(_Token.asAny(value));
      }
      static asList(value, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_EncodingOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.asList), error;
        }
        return Array.isArray(value) && value.every((x) => typeof x == "string") ? value : token_map_1.TokenMap.instance().registerList(_Token.asAny(value), options.displayHint);
      }
      static asAny(value) {
        return value = Tokenization.reverse(value) ?? value, isResolvableObject(value) ? value : new intrinsic_1.Intrinsic(value);
      }
      static compareStrings(possibleToken1, possibleToken2) {
        const firstIsUnresolved = _Token.isUnresolved(possibleToken1), secondIsUnresolved = _Token.isUnresolved(possibleToken2);
        return firstIsUnresolved && secondIsUnresolved ? TokenComparison.BOTH_UNRESOLVED : firstIsUnresolved || secondIsUnresolved ? TokenComparison.ONE_UNRESOLVED : possibleToken1 === possibleToken2 ? TokenComparison.SAME : TokenComparison.DIFFERENT;
      }
      constructor() {
      }
    };
    _b = JSII_RTTI_SYMBOL_1, Token[_b] = { fqn: "aws-cdk-lib.Token", version: "2.80.0" }, exports2.Token = Token;
    var Tokenization = class _Tokenization {
      static reverseString(s) {
        return token_map_1.TokenMap.instance().splitString(s);
      }
      static reverseCompleteString(s) {
        const fragments = _Tokenization.reverseString(s);
        if (fragments.length !== 1)
          throw new Error(`Tokenzation.reverseCompleteString: argument must not be a concatentation, got '${s}'`);
        return fragments.firstToken;
      }
      static reverseNumber(n) {
        return token_map_1.TokenMap.instance().lookupNumberToken(n);
      }
      static reverseList(l) {
        return token_map_1.TokenMap.instance().lookupList(l);
      }
      static reverse(x, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ReverseOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.reverse), error;
        }
        if (_Tokenization.isResolvable(x))
          return x;
        if (typeof x == "string") {
          if (options.failConcat === false) {
            const fragments = _Tokenization.reverseString(x);
            return fragments.length === 1 ? fragments.firstToken : void 0;
          }
          return _Tokenization.reverseCompleteString(x);
        }
        if (Array.isArray(x))
          return _Tokenization.reverseList(x);
        if (typeof x == "number")
          return _Tokenization.reverseNumber(x);
      }
      static resolve(obj, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ResolveOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.resolve), error;
        }
        return (0, resolve_1.resolve)(obj, { scope: options.scope, resolver: options.resolver, preparing: options.preparing ?? false, removeEmpty: options.removeEmpty });
      }
      static isResolvable(obj) {
        return isResolvableObject(obj);
      }
      static stringifyNumber(x) {
        return Token.isUnresolved(x) ? lazy_1.Lazy.uncachedString({ produce: (context) => {
          const resolved = context.resolve(x);
          return typeof resolved != "number" ? resolved : `${resolved}`;
        } }) : typeof x != "number" ? x : `${x}`;
      }
      constructor() {
      }
    };
    _c = JSII_RTTI_SYMBOL_1, Tokenization[_c] = { fqn: "aws-cdk-lib.Tokenization", version: "2.80.0" }, exports2.Tokenization = Tokenization;
    var JsonNull = class {
      constructor() {
        this.creationStack = [];
      }
      resolve(_ctx) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_IResolveContext(_ctx);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.resolve), error;
        }
        return null;
      }
      toJSON() {
        return null;
      }
      toString() {
        return "null";
      }
    };
    _d = JSII_RTTI_SYMBOL_1, JsonNull[_d] = { fqn: "aws-cdk-lib.JsonNull", version: "2.80.0" }, JsonNull.INSTANCE = new JsonNull(), exports2.JsonNull = JsonNull;
    function isResolvableObject(x) {
      return typeof x == "object" && x !== null && typeof x.resolve == "function";
    }
    exports2.isResolvableObject = isResolvableObject;
    function withResolved(...args) {
      if (args.length < 2)
        return;
      const argArray = args.slice(0, args.length - 1);
      argArray.some(Token.isUnresolved) || args[args.length - 1].apply(arguments, argArray);
    }
    exports2.withResolved = withResolved;
  }
});

// node_modules/aws-cdk-lib/core/lib/lazy.js
var require_lazy = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/lazy.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Lazy = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var debug_1 = require_debug2();
    var stack_trace_1 = require_stack_trace2();
    var token_1 = require_token2();
    var Lazy = class {
      static stringValue(producer, options = {}) {
        return token_1.Token.asString(new LazyString(producer, false), options);
      }
      static string(producer, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_IStableStringProducer(producer), jsiiDeprecationWarnings.aws_cdk_lib_LazyStringValueOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.string), error;
        }
        return token_1.Token.asString(new LazyString(producer, true), options);
      }
      static uncachedString(producer, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_IStringProducer(producer), jsiiDeprecationWarnings.aws_cdk_lib_LazyStringValueOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.uncachedString), error;
        }
        return token_1.Token.asString(new LazyString(producer, false), options);
      }
      static numberValue(producer) {
        return token_1.Token.asNumber(new LazyNumber(producer, false));
      }
      static number(producer) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_IStableNumberProducer(producer);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.number), error;
        }
        return token_1.Token.asNumber(new LazyNumber(producer, true));
      }
      static uncachedNumber(producer) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_INumberProducer(producer);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.uncachedNumber), error;
        }
        return token_1.Token.asNumber(new LazyNumber(producer, false));
      }
      static listValue(producer, options = {}) {
        return token_1.Token.asList(new LazyList(producer, false, options), options);
      }
      static uncachedList(producer, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_IListProducer(producer), jsiiDeprecationWarnings.aws_cdk_lib_LazyListValueOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.uncachedList), error;
        }
        return token_1.Token.asList(new LazyList(producer, false, options), options);
      }
      static list(producer, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_IStableListProducer(producer), jsiiDeprecationWarnings.aws_cdk_lib_LazyListValueOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.list), error;
        }
        return token_1.Token.asList(new LazyList(producer, true, options), options);
      }
      static anyValue(producer, options = {}) {
        return new LazyAny(producer, false, options);
      }
      static any(producer, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_IStableAnyProducer(producer), jsiiDeprecationWarnings.aws_cdk_lib_LazyAnyValueOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.any), error;
        }
        return new LazyAny(producer, true, options);
      }
      static uncachedAny(producer, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_IAnyProducer(producer), jsiiDeprecationWarnings.aws_cdk_lib_LazyAnyValueOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.uncachedAny), error;
        }
        return new LazyAny(producer, false, options);
      }
      constructor() {
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Lazy[_a] = { fqn: "aws-cdk-lib.Lazy", version: "2.80.0" }, exports2.Lazy = Lazy;
    var LazyBase = class {
      constructor(producer, cache) {
        this.producer = producer, this.cache = cache, this.creationStack = (0, debug_1.debugModeEnabled)() ? (0, stack_trace_1.captureStackTrace)(this.constructor) : [`Execute again with ${debug_1.CDK_DEBUG}=true to capture stack traces`];
      }
      resolve(context) {
        return this.cache ? this._cached ?? (this._cached = this.producer.produce(context)) : this.producer.produce(context);
      }
      toString() {
        return token_1.Token.asString(this);
      }
      toJSON() {
        return "<unresolved-lazy>";
      }
    };
    var LazyString = class extends LazyBase {
    };
    var LazyNumber = class extends LazyBase {
    };
    var LazyList = class extends LazyBase {
      constructor(producer, cache, options = {}) {
        super(producer, cache), this.options = options;
      }
      resolve(context) {
        const resolved = super.resolve(context);
        if (!(resolved?.length === 0 && this.options.omitEmpty))
          return resolved;
      }
    };
    var LazyAny = class extends LazyBase {
      constructor(producer, cache, options = {}) {
        super(producer, cache), this.options = options;
      }
      resolve(context) {
        const resolved = super.resolve(context);
        if (!(Array.isArray(resolved) && resolved.length === 0 && this.options.omitEmptyArray))
          return resolved;
      }
    };
  }
});

// node_modules/aws-cdk-lib/core/lib/reference.js
var require_reference = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/reference.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Reference = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var intrinsic_1 = require_intrinsic();
    var REFERENCE_SYMBOL = Symbol.for("@aws-cdk/core.Reference");
    var Reference = class _Reference extends intrinsic_1.Intrinsic {
      static isReference(x) {
        return typeof x == "object" && x !== null && REFERENCE_SYMBOL in x;
      }
      constructor(value, target, displayName, typeHint) {
        super(value, { typeHint });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ResolutionTypeHint(typeHint);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Reference), error;
        }
        Object.defineProperty(this, REFERENCE_SYMBOL, { value: true }), this.target = target, this.displayName = displayName || "Reference";
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Reference[_a] = { fqn: "aws-cdk-lib.Reference", version: "2.80.0" }, exports2.Reference = Reference;
  }
});

// node_modules/aws-cdk-lib/node_modules/concat-map/index.js
var require_concat_map = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/concat-map/index.js"(exports2, module2) {
    "use strict";
    module2.exports = function(xs, fn) {
      var res = [];
      for (var i = 0; i < xs.length; i++) {
        var x = fn(xs[i], i);
        if (isArray(x))
          res.push.apply(res, x);
        else
          res.push(x);
      }
      return res;
    };
    var isArray = Array.isArray || function(xs) {
      return Object.prototype.toString.call(xs) === "[object Array]";
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/balanced-match/index.js
var require_balanced_match = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/balanced-match/index.js"(exports2, module2) {
    "use strict";
    module2.exports = balanced;
    function balanced(a, b, str) {
      if (a instanceof RegExp)
        a = maybeMatch(a, str);
      if (b instanceof RegExp)
        b = maybeMatch(b, str);
      var r = range(a, b, str);
      return r && {
        start: r[0],
        end: r[1],
        pre: str.slice(0, r[0]),
        body: str.slice(r[0] + a.length, r[1]),
        post: str.slice(r[1] + b.length)
      };
    }
    function maybeMatch(reg, str) {
      var m = str.match(reg);
      return m ? m[0] : null;
    }
    balanced.range = range;
    function range(a, b, str) {
      var begs, beg, left, right, result;
      var ai = str.indexOf(a);
      var bi = str.indexOf(b, ai + 1);
      var i = ai;
      if (ai >= 0 && bi > 0) {
        if (a === b) {
          return [ai, bi];
        }
        begs = [];
        left = str.length;
        while (i >= 0 && !result) {
          if (i == ai) {
            begs.push(i);
            ai = str.indexOf(a, i + 1);
          } else if (begs.length == 1) {
            result = [begs.pop(), bi];
          } else {
            beg = begs.pop();
            if (beg < left) {
              left = beg;
              right = bi;
            }
            bi = str.indexOf(b, i + 1);
          }
          i = ai < bi && ai >= 0 ? ai : bi;
        }
        if (begs.length) {
          result = [left, right];
        }
      }
      return result;
    }
  }
});

// node_modules/aws-cdk-lib/node_modules/brace-expansion/index.js
var require_brace_expansion = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/brace-expansion/index.js"(exports2, module2) {
    "use strict";
    var concatMap = require_concat_map();
    var balanced = require_balanced_match();
    module2.exports = expandTop;
    var escSlash = "\0SLASH" + Math.random() + "\0";
    var escOpen = "\0OPEN" + Math.random() + "\0";
    var escClose = "\0CLOSE" + Math.random() + "\0";
    var escComma = "\0COMMA" + Math.random() + "\0";
    var escPeriod = "\0PERIOD" + Math.random() + "\0";
    function numeric(str) {
      return parseInt(str, 10) == str ? parseInt(str, 10) : str.charCodeAt(0);
    }
    function escapeBraces(str) {
      return str.split("\\\\").join(escSlash).split("\\{").join(escOpen).split("\\}").join(escClose).split("\\,").join(escComma).split("\\.").join(escPeriod);
    }
    function unescapeBraces(str) {
      return str.split(escSlash).join("\\").split(escOpen).join("{").split(escClose).join("}").split(escComma).join(",").split(escPeriod).join(".");
    }
    function parseCommaParts(str) {
      if (!str)
        return [""];
      var parts = [];
      var m = balanced("{", "}", str);
      if (!m)
        return str.split(",");
      var pre = m.pre;
      var body = m.body;
      var post = m.post;
      var p = pre.split(",");
      p[p.length - 1] += "{" + body + "}";
      var postParts = parseCommaParts(post);
      if (post.length) {
        p[p.length - 1] += postParts.shift();
        p.push.apply(p, postParts);
      }
      parts.push.apply(parts, p);
      return parts;
    }
    function expandTop(str) {
      if (!str)
        return [];
      if (str.substr(0, 2) === "{}") {
        str = "\\{\\}" + str.substr(2);
      }
      return expand(escapeBraces(str), true).map(unescapeBraces);
    }
    function embrace(str) {
      return "{" + str + "}";
    }
    function isPadded(el) {
      return /^-?0\d/.test(el);
    }
    function lte(i, y) {
      return i <= y;
    }
    function gte(i, y) {
      return i >= y;
    }
    function expand(str, isTop) {
      var expansions = [];
      var m = balanced("{", "}", str);
      if (!m || /\$$/.test(m.pre))
        return [str];
      var isNumericSequence = /^-?\d+\.\.-?\d+(?:\.\.-?\d+)?$/.test(m.body);
      var isAlphaSequence = /^[a-zA-Z]\.\.[a-zA-Z](?:\.\.-?\d+)?$/.test(m.body);
      var isSequence = isNumericSequence || isAlphaSequence;
      var isOptions = m.body.indexOf(",") >= 0;
      if (!isSequence && !isOptions) {
        if (m.post.match(/,.*\}/)) {
          str = m.pre + "{" + m.body + escClose + m.post;
          return expand(str);
        }
        return [str];
      }
      var n;
      if (isSequence) {
        n = m.body.split(/\.\./);
      } else {
        n = parseCommaParts(m.body);
        if (n.length === 1) {
          n = expand(n[0], false).map(embrace);
          if (n.length === 1) {
            var post = m.post.length ? expand(m.post, false) : [""];
            return post.map(function(p) {
              return m.pre + n[0] + p;
            });
          }
        }
      }
      var pre = m.pre;
      var post = m.post.length ? expand(m.post, false) : [""];
      var N;
      if (isSequence) {
        var x = numeric(n[0]);
        var y = numeric(n[1]);
        var width = Math.max(n[0].length, n[1].length);
        var incr = n.length == 3 ? Math.abs(numeric(n[2])) : 1;
        var test = lte;
        var reverse = y < x;
        if (reverse) {
          incr *= -1;
          test = gte;
        }
        var pad = n.some(isPadded);
        N = [];
        for (var i = x; test(i, y); i += incr) {
          var c;
          if (isAlphaSequence) {
            c = String.fromCharCode(i);
            if (c === "\\")
              c = "";
          } else {
            c = String(i);
            if (pad) {
              var need = width - c.length;
              if (need > 0) {
                var z = new Array(need + 1).join("0");
                if (i < 0)
                  c = "-" + z + c.slice(1);
                else
                  c = z + c;
              }
            }
          }
          N.push(c);
        }
      } else {
        N = concatMap(n, function(el) {
          return expand(el, false);
        });
      }
      for (var j = 0; j < N.length; j++) {
        for (var k = 0; k < post.length; k++) {
          var expansion = pre + N[j] + post[k];
          if (!isTop || isSequence || expansion)
            expansions.push(expansion);
        }
      }
      return expansions;
    }
  }
});

// node_modules/aws-cdk-lib/node_modules/minimatch/minimatch.js
var require_minimatch = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/minimatch/minimatch.js"(exports2, module2) {
    "use strict";
    module2.exports = minimatch;
    minimatch.Minimatch = Minimatch;
    var path = function() {
      try {
        return require("path");
      } catch (e) {
      }
    }() || {
      sep: "/"
    };
    minimatch.sep = path.sep;
    var GLOBSTAR = minimatch.GLOBSTAR = Minimatch.GLOBSTAR = {};
    var expand = require_brace_expansion();
    var plTypes = {
      "!": { open: "(?:(?!(?:", close: "))[^/]*?)" },
      "?": { open: "(?:", close: ")?" },
      "+": { open: "(?:", close: ")+" },
      "*": { open: "(?:", close: ")*" },
      "@": { open: "(?:", close: ")" }
    };
    var qmark = "[^/]";
    var star = qmark + "*?";
    var twoStarDot = "(?:(?!(?:\\/|^)(?:\\.{1,2})($|\\/)).)*?";
    var twoStarNoDot = "(?:(?!(?:\\/|^)\\.).)*?";
    var reSpecials = charSet("().*{}+?[]^$\\!");
    function charSet(s) {
      return s.split("").reduce(function(set, c) {
        set[c] = true;
        return set;
      }, {});
    }
    var slashSplit = /\/+/;
    minimatch.filter = filter;
    function filter(pattern, options) {
      options = options || {};
      return function(p, i, list) {
        return minimatch(p, pattern, options);
      };
    }
    function ext(a, b) {
      b = b || {};
      var t = {};
      Object.keys(a).forEach(function(k) {
        t[k] = a[k];
      });
      Object.keys(b).forEach(function(k) {
        t[k] = b[k];
      });
      return t;
    }
    minimatch.defaults = function(def) {
      if (!def || typeof def !== "object" || !Object.keys(def).length) {
        return minimatch;
      }
      var orig = minimatch;
      var m = function minimatch2(p, pattern, options) {
        return orig(p, pattern, ext(def, options));
      };
      m.Minimatch = function Minimatch2(pattern, options) {
        return new orig.Minimatch(pattern, ext(def, options));
      };
      m.Minimatch.defaults = function defaults(options) {
        return orig.defaults(ext(def, options)).Minimatch;
      };
      m.filter = function filter2(pattern, options) {
        return orig.filter(pattern, ext(def, options));
      };
      m.defaults = function defaults(options) {
        return orig.defaults(ext(def, options));
      };
      m.makeRe = function makeRe2(pattern, options) {
        return orig.makeRe(pattern, ext(def, options));
      };
      m.braceExpand = function braceExpand2(pattern, options) {
        return orig.braceExpand(pattern, ext(def, options));
      };
      m.match = function(list, pattern, options) {
        return orig.match(list, pattern, ext(def, options));
      };
      return m;
    };
    Minimatch.defaults = function(def) {
      return minimatch.defaults(def).Minimatch;
    };
    function minimatch(p, pattern, options) {
      assertValidPattern(pattern);
      if (!options)
        options = {};
      if (!options.nocomment && pattern.charAt(0) === "#") {
        return false;
      }
      return new Minimatch(pattern, options).match(p);
    }
    function Minimatch(pattern, options) {
      if (!(this instanceof Minimatch)) {
        return new Minimatch(pattern, options);
      }
      assertValidPattern(pattern);
      if (!options)
        options = {};
      pattern = pattern.trim();
      if (!options.allowWindowsEscape && path.sep !== "/") {
        pattern = pattern.split(path.sep).join("/");
      }
      this.options = options;
      this.set = [];
      this.pattern = pattern;
      this.regexp = null;
      this.negate = false;
      this.comment = false;
      this.empty = false;
      this.partial = !!options.partial;
      this.make();
    }
    Minimatch.prototype.debug = function() {
    };
    Minimatch.prototype.make = make;
    function make() {
      var pattern = this.pattern;
      var options = this.options;
      if (!options.nocomment && pattern.charAt(0) === "#") {
        this.comment = true;
        return;
      }
      if (!pattern) {
        this.empty = true;
        return;
      }
      this.parseNegate();
      var set = this.globSet = this.braceExpand();
      if (options.debug)
        this.debug = function debug() {
          console.error.apply(console, arguments);
        };
      this.debug(this.pattern, set);
      set = this.globParts = set.map(function(s) {
        return s.split(slashSplit);
      });
      this.debug(this.pattern, set);
      set = set.map(function(s, si, set2) {
        return s.map(this.parse, this);
      }, this);
      this.debug(this.pattern, set);
      set = set.filter(function(s) {
        return s.indexOf(false) === -1;
      });
      this.debug(this.pattern, set);
      this.set = set;
    }
    Minimatch.prototype.parseNegate = parseNegate;
    function parseNegate() {
      var pattern = this.pattern;
      var negate = false;
      var options = this.options;
      var negateOffset = 0;
      if (options.nonegate)
        return;
      for (var i = 0, l = pattern.length; i < l && pattern.charAt(i) === "!"; i++) {
        negate = !negate;
        negateOffset++;
      }
      if (negateOffset)
        this.pattern = pattern.substr(negateOffset);
      this.negate = negate;
    }
    minimatch.braceExpand = function(pattern, options) {
      return braceExpand(pattern, options);
    };
    Minimatch.prototype.braceExpand = braceExpand;
    function braceExpand(pattern, options) {
      if (!options) {
        if (this instanceof Minimatch) {
          options = this.options;
        } else {
          options = {};
        }
      }
      pattern = typeof pattern === "undefined" ? this.pattern : pattern;
      assertValidPattern(pattern);
      if (options.nobrace || !/\{(?:(?!\{).)*\}/.test(pattern)) {
        return [pattern];
      }
      return expand(pattern);
    }
    var MAX_PATTERN_LENGTH = 1024 * 64;
    var assertValidPattern = function(pattern) {
      if (typeof pattern !== "string") {
        throw new TypeError("invalid pattern");
      }
      if (pattern.length > MAX_PATTERN_LENGTH) {
        throw new TypeError("pattern is too long");
      }
    };
    Minimatch.prototype.parse = parse;
    var SUBPARSE = {};
    function parse(pattern, isSub) {
      assertValidPattern(pattern);
      var options = this.options;
      if (pattern === "**") {
        if (!options.noglobstar)
          return GLOBSTAR;
        else
          pattern = "*";
      }
      if (pattern === "")
        return "";
      var re = "";
      var hasMagic = !!options.nocase;
      var escaping = false;
      var patternListStack = [];
      var negativeLists = [];
      var stateChar;
      var inClass = false;
      var reClassStart = -1;
      var classStart = -1;
      var patternStart = pattern.charAt(0) === "." ? "" : options.dot ? "(?!(?:^|\\/)\\.{1,2}(?:$|\\/))" : "(?!\\.)";
      var self2 = this;
      function clearStateChar() {
        if (stateChar) {
          switch (stateChar) {
            case "*":
              re += star;
              hasMagic = true;
              break;
            case "?":
              re += qmark;
              hasMagic = true;
              break;
            default:
              re += "\\" + stateChar;
              break;
          }
          self2.debug("clearStateChar %j %j", stateChar, re);
          stateChar = false;
        }
      }
      for (var i = 0, len = pattern.length, c; i < len && (c = pattern.charAt(i)); i++) {
        this.debug("%s	%s %s %j", pattern, i, re, c);
        if (escaping && reSpecials[c]) {
          re += "\\" + c;
          escaping = false;
          continue;
        }
        switch (c) {
          case "/": {
            return false;
          }
          case "\\":
            clearStateChar();
            escaping = true;
            continue;
          case "?":
          case "*":
          case "+":
          case "@":
          case "!":
            this.debug("%s	%s %s %j <-- stateChar", pattern, i, re, c);
            if (inClass) {
              this.debug("  in class");
              if (c === "!" && i === classStart + 1)
                c = "^";
              re += c;
              continue;
            }
            self2.debug("call clearStateChar %j", stateChar);
            clearStateChar();
            stateChar = c;
            if (options.noext)
              clearStateChar();
            continue;
          case "(":
            if (inClass) {
              re += "(";
              continue;
            }
            if (!stateChar) {
              re += "\\(";
              continue;
            }
            patternListStack.push({
              type: stateChar,
              start: i - 1,
              reStart: re.length,
              open: plTypes[stateChar].open,
              close: plTypes[stateChar].close
            });
            re += stateChar === "!" ? "(?:(?!(?:" : "(?:";
            this.debug("plType %j %j", stateChar, re);
            stateChar = false;
            continue;
          case ")":
            if (inClass || !patternListStack.length) {
              re += "\\)";
              continue;
            }
            clearStateChar();
            hasMagic = true;
            var pl = patternListStack.pop();
            re += pl.close;
            if (pl.type === "!") {
              negativeLists.push(pl);
            }
            pl.reEnd = re.length;
            continue;
          case "|":
            if (inClass || !patternListStack.length || escaping) {
              re += "\\|";
              escaping = false;
              continue;
            }
            clearStateChar();
            re += "|";
            continue;
          case "[":
            clearStateChar();
            if (inClass) {
              re += "\\" + c;
              continue;
            }
            inClass = true;
            classStart = i;
            reClassStart = re.length;
            re += c;
            continue;
          case "]":
            if (i === classStart + 1 || !inClass) {
              re += "\\" + c;
              escaping = false;
              continue;
            }
            var cs = pattern.substring(classStart + 1, i);
            try {
              RegExp("[" + cs + "]");
            } catch (er) {
              var sp = this.parse(cs, SUBPARSE);
              re = re.substr(0, reClassStart) + "\\[" + sp[0] + "\\]";
              hasMagic = hasMagic || sp[1];
              inClass = false;
              continue;
            }
            hasMagic = true;
            inClass = false;
            re += c;
            continue;
          default:
            clearStateChar();
            if (escaping) {
              escaping = false;
            } else if (reSpecials[c] && !(c === "^" && inClass)) {
              re += "\\";
            }
            re += c;
        }
      }
      if (inClass) {
        cs = pattern.substr(classStart + 1);
        sp = this.parse(cs, SUBPARSE);
        re = re.substr(0, reClassStart) + "\\[" + sp[0];
        hasMagic = hasMagic || sp[1];
      }
      for (pl = patternListStack.pop(); pl; pl = patternListStack.pop()) {
        var tail = re.slice(pl.reStart + pl.open.length);
        this.debug("setting tail", re, pl);
        tail = tail.replace(/((?:\\{2}){0,64})(\\?)\|/g, function(_, $1, $2) {
          if (!$2) {
            $2 = "\\";
          }
          return $1 + $1 + $2 + "|";
        });
        this.debug("tail=%j\n   %s", tail, tail, pl, re);
        var t = pl.type === "*" ? star : pl.type === "?" ? qmark : "\\" + pl.type;
        hasMagic = true;
        re = re.slice(0, pl.reStart) + t + "\\(" + tail;
      }
      clearStateChar();
      if (escaping) {
        re += "\\\\";
      }
      var addPatternStart = false;
      switch (re.charAt(0)) {
        case "[":
        case ".":
        case "(":
          addPatternStart = true;
      }
      for (var n = negativeLists.length - 1; n > -1; n--) {
        var nl = negativeLists[n];
        var nlBefore = re.slice(0, nl.reStart);
        var nlFirst = re.slice(nl.reStart, nl.reEnd - 8);
        var nlLast = re.slice(nl.reEnd - 8, nl.reEnd);
        var nlAfter = re.slice(nl.reEnd);
        nlLast += nlAfter;
        var openParensBefore = nlBefore.split("(").length - 1;
        var cleanAfter = nlAfter;
        for (i = 0; i < openParensBefore; i++) {
          cleanAfter = cleanAfter.replace(/\)[+*?]?/, "");
        }
        nlAfter = cleanAfter;
        var dollar = "";
        if (nlAfter === "" && isSub !== SUBPARSE) {
          dollar = "$";
        }
        var newRe = nlBefore + nlFirst + nlAfter + dollar + nlLast;
        re = newRe;
      }
      if (re !== "" && hasMagic) {
        re = "(?=.)" + re;
      }
      if (addPatternStart) {
        re = patternStart + re;
      }
      if (isSub === SUBPARSE) {
        return [re, hasMagic];
      }
      if (!hasMagic) {
        return globUnescape(pattern);
      }
      var flags = options.nocase ? "i" : "";
      try {
        var regExp = new RegExp("^" + re + "$", flags);
      } catch (er) {
        return new RegExp("$.");
      }
      regExp._glob = pattern;
      regExp._src = re;
      return regExp;
    }
    minimatch.makeRe = function(pattern, options) {
      return new Minimatch(pattern, options || {}).makeRe();
    };
    Minimatch.prototype.makeRe = makeRe;
    function makeRe() {
      if (this.regexp || this.regexp === false)
        return this.regexp;
      var set = this.set;
      if (!set.length) {
        this.regexp = false;
        return this.regexp;
      }
      var options = this.options;
      var twoStar = options.noglobstar ? star : options.dot ? twoStarDot : twoStarNoDot;
      var flags = options.nocase ? "i" : "";
      var re = set.map(function(pattern) {
        return pattern.map(function(p) {
          return p === GLOBSTAR ? twoStar : typeof p === "string" ? regExpEscape(p) : p._src;
        }).join("\\/");
      }).join("|");
      re = "^(?:" + re + ")$";
      if (this.negate)
        re = "^(?!" + re + ").*$";
      try {
        this.regexp = new RegExp(re, flags);
      } catch (ex) {
        this.regexp = false;
      }
      return this.regexp;
    }
    minimatch.match = function(list, pattern, options) {
      options = options || {};
      var mm = new Minimatch(pattern, options);
      list = list.filter(function(f) {
        return mm.match(f);
      });
      if (mm.options.nonull && !list.length) {
        list.push(pattern);
      }
      return list;
    };
    Minimatch.prototype.match = function match(f, partial) {
      if (typeof partial === "undefined")
        partial = this.partial;
      this.debug("match", f, this.pattern);
      if (this.comment)
        return false;
      if (this.empty)
        return f === "";
      if (f === "/" && partial)
        return true;
      var options = this.options;
      if (path.sep !== "/") {
        f = f.split(path.sep).join("/");
      }
      f = f.split(slashSplit);
      this.debug(this.pattern, "split", f);
      var set = this.set;
      this.debug(this.pattern, "set", set);
      var filename;
      var i;
      for (i = f.length - 1; i >= 0; i--) {
        filename = f[i];
        if (filename)
          break;
      }
      for (i = 0; i < set.length; i++) {
        var pattern = set[i];
        var file = f;
        if (options.matchBase && pattern.length === 1) {
          file = [filename];
        }
        var hit = this.matchOne(file, pattern, partial);
        if (hit) {
          if (options.flipNegate)
            return true;
          return !this.negate;
        }
      }
      if (options.flipNegate)
        return false;
      return this.negate;
    };
    Minimatch.prototype.matchOne = function(file, pattern, partial) {
      var options = this.options;
      this.debug(
        "matchOne",
        { "this": this, file, pattern }
      );
      this.debug("matchOne", file.length, pattern.length);
      for (var fi = 0, pi = 0, fl = file.length, pl = pattern.length; fi < fl && pi < pl; fi++, pi++) {
        this.debug("matchOne loop");
        var p = pattern[pi];
        var f = file[fi];
        this.debug(pattern, p, f);
        if (p === false)
          return false;
        if (p === GLOBSTAR) {
          this.debug("GLOBSTAR", [pattern, p, f]);
          var fr = fi;
          var pr = pi + 1;
          if (pr === pl) {
            this.debug("** at the end");
            for (; fi < fl; fi++) {
              if (file[fi] === "." || file[fi] === ".." || !options.dot && file[fi].charAt(0) === ".")
                return false;
            }
            return true;
          }
          while (fr < fl) {
            var swallowee = file[fr];
            this.debug("\nglobstar while", file, fr, pattern, pr, swallowee);
            if (this.matchOne(file.slice(fr), pattern.slice(pr), partial)) {
              this.debug("globstar found match!", fr, fl, swallowee);
              return true;
            } else {
              if (swallowee === "." || swallowee === ".." || !options.dot && swallowee.charAt(0) === ".") {
                this.debug("dot detected!", file, fr, pattern, pr);
                break;
              }
              this.debug("globstar swallow a segment, and continue");
              fr++;
            }
          }
          if (partial) {
            this.debug("\n>>> no match, partial?", file, fr, pattern, pr);
            if (fr === fl)
              return true;
          }
          return false;
        }
        var hit;
        if (typeof p === "string") {
          hit = f === p;
          this.debug("string match", p, f, hit);
        } else {
          hit = f.match(p);
          this.debug("pattern match", p, f, hit);
        }
        if (!hit)
          return false;
      }
      if (fi === fl && pi === pl) {
        return true;
      } else if (fi === fl) {
        return partial;
      } else if (pi === pl) {
        return fi === fl - 1 && file[fi] === "";
      }
      throw new Error("wtf?");
    };
    function globUnescape(s) {
      return s.replace(/\\(.)/g, "$1");
    }
    function regExpEscape(s) {
      return s.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
    }
  }
});

// node_modules/aws-cdk-lib/node_modules/universalify/index.js
var require_universalify = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/universalify/index.js"(exports2) {
    "use strict";
    exports2.fromCallback = function(fn) {
      return Object.defineProperty(function(...args) {
        if (typeof args[args.length - 1] === "function")
          fn.apply(this, args);
        else {
          return new Promise((resolve, reject) => {
            fn.call(
              this,
              ...args,
              (err, res) => err != null ? reject(err) : resolve(res)
            );
          });
        }
      }, "name", { value: fn.name });
    };
    exports2.fromPromise = function(fn) {
      return Object.defineProperty(function(...args) {
        const cb = args[args.length - 1];
        if (typeof cb !== "function")
          return fn.apply(this, args);
        else
          fn.apply(this, args.slice(0, -1)).then((r) => cb(null, r), cb);
      }, "name", { value: fn.name });
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/graceful-fs/polyfills.js
var require_polyfills = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/graceful-fs/polyfills.js"(exports2, module2) {
    "use strict";
    var constants = require("constants");
    var origCwd = process.cwd;
    var cwd = null;
    var platform = process.env.GRACEFUL_FS_PLATFORM || process.platform;
    process.cwd = function() {
      if (!cwd)
        cwd = origCwd.call(process);
      return cwd;
    };
    try {
      process.cwd();
    } catch (er) {
    }
    if (typeof process.chdir === "function") {
      chdir = process.chdir;
      process.chdir = function(d) {
        cwd = null;
        chdir.call(process, d);
      };
      if (Object.setPrototypeOf)
        Object.setPrototypeOf(process.chdir, chdir);
    }
    var chdir;
    module2.exports = patch;
    function patch(fs) {
      if (constants.hasOwnProperty("O_SYMLINK") && process.version.match(/^v0\.6\.[0-2]|^v0\.5\./)) {
        patchLchmod(fs);
      }
      if (!fs.lutimes) {
        patchLutimes(fs);
      }
      fs.chown = chownFix(fs.chown);
      fs.fchown = chownFix(fs.fchown);
      fs.lchown = chownFix(fs.lchown);
      fs.chmod = chmodFix(fs.chmod);
      fs.fchmod = chmodFix(fs.fchmod);
      fs.lchmod = chmodFix(fs.lchmod);
      fs.chownSync = chownFixSync(fs.chownSync);
      fs.fchownSync = chownFixSync(fs.fchownSync);
      fs.lchownSync = chownFixSync(fs.lchownSync);
      fs.chmodSync = chmodFixSync(fs.chmodSync);
      fs.fchmodSync = chmodFixSync(fs.fchmodSync);
      fs.lchmodSync = chmodFixSync(fs.lchmodSync);
      fs.stat = statFix(fs.stat);
      fs.fstat = statFix(fs.fstat);
      fs.lstat = statFix(fs.lstat);
      fs.statSync = statFixSync(fs.statSync);
      fs.fstatSync = statFixSync(fs.fstatSync);
      fs.lstatSync = statFixSync(fs.lstatSync);
      if (fs.chmod && !fs.lchmod) {
        fs.lchmod = function(path, mode, cb) {
          if (cb)
            process.nextTick(cb);
        };
        fs.lchmodSync = function() {
        };
      }
      if (fs.chown && !fs.lchown) {
        fs.lchown = function(path, uid, gid, cb) {
          if (cb)
            process.nextTick(cb);
        };
        fs.lchownSync = function() {
        };
      }
      if (platform === "win32") {
        fs.rename = typeof fs.rename !== "function" ? fs.rename : function(fs$rename) {
          function rename(from, to, cb) {
            var start = Date.now();
            var backoff = 0;
            fs$rename(from, to, function CB(er) {
              if (er && (er.code === "EACCES" || er.code === "EPERM" || er.code === "EBUSY") && Date.now() - start < 6e4) {
                setTimeout(function() {
                  fs.stat(to, function(stater, st) {
                    if (stater && stater.code === "ENOENT")
                      fs$rename(from, to, CB);
                    else
                      cb(er);
                  });
                }, backoff);
                if (backoff < 100)
                  backoff += 10;
                return;
              }
              if (cb)
                cb(er);
            });
          }
          if (Object.setPrototypeOf)
            Object.setPrototypeOf(rename, fs$rename);
          return rename;
        }(fs.rename);
      }
      fs.read = typeof fs.read !== "function" ? fs.read : function(fs$read) {
        function read(fd, buffer, offset, length, position, callback_) {
          var callback;
          if (callback_ && typeof callback_ === "function") {
            var eagCounter = 0;
            callback = function(er, _, __) {
              if (er && er.code === "EAGAIN" && eagCounter < 10) {
                eagCounter++;
                return fs$read.call(fs, fd, buffer, offset, length, position, callback);
              }
              callback_.apply(this, arguments);
            };
          }
          return fs$read.call(fs, fd, buffer, offset, length, position, callback);
        }
        if (Object.setPrototypeOf)
          Object.setPrototypeOf(read, fs$read);
        return read;
      }(fs.read);
      fs.readSync = typeof fs.readSync !== "function" ? fs.readSync : /* @__PURE__ */ function(fs$readSync) {
        return function(fd, buffer, offset, length, position) {
          var eagCounter = 0;
          while (true) {
            try {
              return fs$readSync.call(fs, fd, buffer, offset, length, position);
            } catch (er) {
              if (er.code === "EAGAIN" && eagCounter < 10) {
                eagCounter++;
                continue;
              }
              throw er;
            }
          }
        };
      }(fs.readSync);
      function patchLchmod(fs2) {
        fs2.lchmod = function(path, mode, callback) {
          fs2.open(
            path,
            constants.O_WRONLY | constants.O_SYMLINK,
            mode,
            function(err, fd) {
              if (err) {
                if (callback)
                  callback(err);
                return;
              }
              fs2.fchmod(fd, mode, function(err2) {
                fs2.close(fd, function(err22) {
                  if (callback)
                    callback(err2 || err22);
                });
              });
            }
          );
        };
        fs2.lchmodSync = function(path, mode) {
          var fd = fs2.openSync(path, constants.O_WRONLY | constants.O_SYMLINK, mode);
          var threw = true;
          var ret;
          try {
            ret = fs2.fchmodSync(fd, mode);
            threw = false;
          } finally {
            if (threw) {
              try {
                fs2.closeSync(fd);
              } catch (er) {
              }
            } else {
              fs2.closeSync(fd);
            }
          }
          return ret;
        };
      }
      function patchLutimes(fs2) {
        if (constants.hasOwnProperty("O_SYMLINK") && fs2.futimes) {
          fs2.lutimes = function(path, at, mt, cb) {
            fs2.open(path, constants.O_SYMLINK, function(er, fd) {
              if (er) {
                if (cb)
                  cb(er);
                return;
              }
              fs2.futimes(fd, at, mt, function(er2) {
                fs2.close(fd, function(er22) {
                  if (cb)
                    cb(er2 || er22);
                });
              });
            });
          };
          fs2.lutimesSync = function(path, at, mt) {
            var fd = fs2.openSync(path, constants.O_SYMLINK);
            var ret;
            var threw = true;
            try {
              ret = fs2.futimesSync(fd, at, mt);
              threw = false;
            } finally {
              if (threw) {
                try {
                  fs2.closeSync(fd);
                } catch (er) {
                }
              } else {
                fs2.closeSync(fd);
              }
            }
            return ret;
          };
        } else if (fs2.futimes) {
          fs2.lutimes = function(_a, _b, _c, cb) {
            if (cb)
              process.nextTick(cb);
          };
          fs2.lutimesSync = function() {
          };
        }
      }
      function chmodFix(orig) {
        if (!orig)
          return orig;
        return function(target, mode, cb) {
          return orig.call(fs, target, mode, function(er) {
            if (chownErOk(er))
              er = null;
            if (cb)
              cb.apply(this, arguments);
          });
        };
      }
      function chmodFixSync(orig) {
        if (!orig)
          return orig;
        return function(target, mode) {
          try {
            return orig.call(fs, target, mode);
          } catch (er) {
            if (!chownErOk(er))
              throw er;
          }
        };
      }
      function chownFix(orig) {
        if (!orig)
          return orig;
        return function(target, uid, gid, cb) {
          return orig.call(fs, target, uid, gid, function(er) {
            if (chownErOk(er))
              er = null;
            if (cb)
              cb.apply(this, arguments);
          });
        };
      }
      function chownFixSync(orig) {
        if (!orig)
          return orig;
        return function(target, uid, gid) {
          try {
            return orig.call(fs, target, uid, gid);
          } catch (er) {
            if (!chownErOk(er))
              throw er;
          }
        };
      }
      function statFix(orig) {
        if (!orig)
          return orig;
        return function(target, options, cb) {
          if (typeof options === "function") {
            cb = options;
            options = null;
          }
          function callback(er, stats) {
            if (stats) {
              if (stats.uid < 0)
                stats.uid += 4294967296;
              if (stats.gid < 0)
                stats.gid += 4294967296;
            }
            if (cb)
              cb.apply(this, arguments);
          }
          return options ? orig.call(fs, target, options, callback) : orig.call(fs, target, callback);
        };
      }
      function statFixSync(orig) {
        if (!orig)
          return orig;
        return function(target, options) {
          var stats = options ? orig.call(fs, target, options) : orig.call(fs, target);
          if (stats) {
            if (stats.uid < 0)
              stats.uid += 4294967296;
            if (stats.gid < 0)
              stats.gid += 4294967296;
          }
          return stats;
        };
      }
      function chownErOk(er) {
        if (!er)
          return true;
        if (er.code === "ENOSYS")
          return true;
        var nonroot = !process.getuid || process.getuid() !== 0;
        if (nonroot) {
          if (er.code === "EINVAL" || er.code === "EPERM")
            return true;
        }
        return false;
      }
    }
  }
});

// node_modules/aws-cdk-lib/node_modules/graceful-fs/legacy-streams.js
var require_legacy_streams = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/graceful-fs/legacy-streams.js"(exports2, module2) {
    "use strict";
    var Stream = require("stream").Stream;
    module2.exports = legacy;
    function legacy(fs) {
      return {
        ReadStream,
        WriteStream
      };
      function ReadStream(path, options) {
        if (!(this instanceof ReadStream))
          return new ReadStream(path, options);
        Stream.call(this);
        var self2 = this;
        this.path = path;
        this.fd = null;
        this.readable = true;
        this.paused = false;
        this.flags = "r";
        this.mode = 438;
        this.bufferSize = 64 * 1024;
        options = options || {};
        var keys = Object.keys(options);
        for (var index = 0, length = keys.length; index < length; index++) {
          var key = keys[index];
          this[key] = options[key];
        }
        if (this.encoding)
          this.setEncoding(this.encoding);
        if (this.start !== void 0) {
          if ("number" !== typeof this.start) {
            throw TypeError("start must be a Number");
          }
          if (this.end === void 0) {
            this.end = Infinity;
          } else if ("number" !== typeof this.end) {
            throw TypeError("end must be a Number");
          }
          if (this.start > this.end) {
            throw new Error("start must be <= end");
          }
          this.pos = this.start;
        }
        if (this.fd !== null) {
          process.nextTick(function() {
            self2._read();
          });
          return;
        }
        fs.open(this.path, this.flags, this.mode, function(err, fd) {
          if (err) {
            self2.emit("error", err);
            self2.readable = false;
            return;
          }
          self2.fd = fd;
          self2.emit("open", fd);
          self2._read();
        });
      }
      function WriteStream(path, options) {
        if (!(this instanceof WriteStream))
          return new WriteStream(path, options);
        Stream.call(this);
        this.path = path;
        this.fd = null;
        this.writable = true;
        this.flags = "w";
        this.encoding = "binary";
        this.mode = 438;
        this.bytesWritten = 0;
        options = options || {};
        var keys = Object.keys(options);
        for (var index = 0, length = keys.length; index < length; index++) {
          var key = keys[index];
          this[key] = options[key];
        }
        if (this.start !== void 0) {
          if ("number" !== typeof this.start) {
            throw TypeError("start must be a Number");
          }
          if (this.start < 0) {
            throw new Error("start must be >= zero");
          }
          this.pos = this.start;
        }
        this.busy = false;
        this._queue = [];
        if (this.fd === null) {
          this._open = fs.open;
          this._queue.push([this._open, this.path, this.flags, this.mode, void 0]);
          this.flush();
        }
      }
    }
  }
});

// node_modules/aws-cdk-lib/node_modules/graceful-fs/clone.js
var require_clone = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/graceful-fs/clone.js"(exports2, module2) {
    "use strict";
    module2.exports = clone;
    var getPrototypeOf = Object.getPrototypeOf || function(obj) {
      return obj.__proto__;
    };
    function clone(obj) {
      if (obj === null || typeof obj !== "object")
        return obj;
      if (obj instanceof Object)
        var copy = { __proto__: getPrototypeOf(obj) };
      else
        var copy = /* @__PURE__ */ Object.create(null);
      Object.getOwnPropertyNames(obj).forEach(function(key) {
        Object.defineProperty(copy, key, Object.getOwnPropertyDescriptor(obj, key));
      });
      return copy;
    }
  }
});

// node_modules/aws-cdk-lib/node_modules/graceful-fs/graceful-fs.js
var require_graceful_fs = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/graceful-fs/graceful-fs.js"(exports2, module2) {
    "use strict";
    var fs = require("fs");
    var polyfills = require_polyfills();
    var legacy = require_legacy_streams();
    var clone = require_clone();
    var util = require("util");
    var gracefulQueue;
    var previousSymbol;
    if (typeof Symbol === "function" && typeof Symbol.for === "function") {
      gracefulQueue = Symbol.for("graceful-fs.queue");
      previousSymbol = Symbol.for("graceful-fs.previous");
    } else {
      gracefulQueue = "___graceful-fs.queue";
      previousSymbol = "___graceful-fs.previous";
    }
    function noop() {
    }
    function publishQueue(context, queue2) {
      Object.defineProperty(context, gracefulQueue, {
        get: function() {
          return queue2;
        }
      });
    }
    var debug = noop;
    if (util.debuglog)
      debug = util.debuglog("gfs4");
    else if (/\bgfs4\b/i.test(process.env.NODE_DEBUG || ""))
      debug = function() {
        var m = util.format.apply(util, arguments);
        m = "GFS4: " + m.split(/\n/).join("\nGFS4: ");
        console.error(m);
      };
    if (!fs[gracefulQueue]) {
      queue = global[gracefulQueue] || [];
      publishQueue(fs, queue);
      fs.close = function(fs$close) {
        function close(fd, cb) {
          return fs$close.call(fs, fd, function(err) {
            if (!err) {
              resetQueue();
            }
            if (typeof cb === "function")
              cb.apply(this, arguments);
          });
        }
        Object.defineProperty(close, previousSymbol, {
          value: fs$close
        });
        return close;
      }(fs.close);
      fs.closeSync = function(fs$closeSync) {
        function closeSync(fd) {
          fs$closeSync.apply(fs, arguments);
          resetQueue();
        }
        Object.defineProperty(closeSync, previousSymbol, {
          value: fs$closeSync
        });
        return closeSync;
      }(fs.closeSync);
      if (/\bgfs4\b/i.test(process.env.NODE_DEBUG || "")) {
        process.on("exit", function() {
          debug(fs[gracefulQueue]);
          require("assert").equal(fs[gracefulQueue].length, 0);
        });
      }
    }
    var queue;
    if (!global[gracefulQueue]) {
      publishQueue(global, fs[gracefulQueue]);
    }
    module2.exports = patch(clone(fs));
    if (process.env.TEST_GRACEFUL_FS_GLOBAL_PATCH && !fs.__patched) {
      module2.exports = patch(fs);
      fs.__patched = true;
    }
    function patch(fs2) {
      polyfills(fs2);
      fs2.gracefulify = patch;
      fs2.createReadStream = createReadStream;
      fs2.createWriteStream = createWriteStream;
      var fs$readFile = fs2.readFile;
      fs2.readFile = readFile;
      function readFile(path, options, cb) {
        if (typeof options === "function")
          cb = options, options = null;
        return go$readFile(path, options, cb);
        function go$readFile(path2, options2, cb2, startTime) {
          return fs$readFile(path2, options2, function(err) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([go$readFile, [path2, options2, cb2], err, startTime || Date.now(), Date.now()]);
            else {
              if (typeof cb2 === "function")
                cb2.apply(this, arguments);
            }
          });
        }
      }
      var fs$writeFile = fs2.writeFile;
      fs2.writeFile = writeFile;
      function writeFile(path, data, options, cb) {
        if (typeof options === "function")
          cb = options, options = null;
        return go$writeFile(path, data, options, cb);
        function go$writeFile(path2, data2, options2, cb2, startTime) {
          return fs$writeFile(path2, data2, options2, function(err) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([go$writeFile, [path2, data2, options2, cb2], err, startTime || Date.now(), Date.now()]);
            else {
              if (typeof cb2 === "function")
                cb2.apply(this, arguments);
            }
          });
        }
      }
      var fs$appendFile = fs2.appendFile;
      if (fs$appendFile)
        fs2.appendFile = appendFile;
      function appendFile(path, data, options, cb) {
        if (typeof options === "function")
          cb = options, options = null;
        return go$appendFile(path, data, options, cb);
        function go$appendFile(path2, data2, options2, cb2, startTime) {
          return fs$appendFile(path2, data2, options2, function(err) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([go$appendFile, [path2, data2, options2, cb2], err, startTime || Date.now(), Date.now()]);
            else {
              if (typeof cb2 === "function")
                cb2.apply(this, arguments);
            }
          });
        }
      }
      var fs$copyFile = fs2.copyFile;
      if (fs$copyFile)
        fs2.copyFile = copyFile;
      function copyFile(src, dest, flags, cb) {
        if (typeof flags === "function") {
          cb = flags;
          flags = 0;
        }
        return go$copyFile(src, dest, flags, cb);
        function go$copyFile(src2, dest2, flags2, cb2, startTime) {
          return fs$copyFile(src2, dest2, flags2, function(err) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([go$copyFile, [src2, dest2, flags2, cb2], err, startTime || Date.now(), Date.now()]);
            else {
              if (typeof cb2 === "function")
                cb2.apply(this, arguments);
            }
          });
        }
      }
      var fs$readdir = fs2.readdir;
      fs2.readdir = readdir;
      var noReaddirOptionVersions = /^v[0-5]\./;
      function readdir(path, options, cb) {
        if (typeof options === "function")
          cb = options, options = null;
        var go$readdir = noReaddirOptionVersions.test(process.version) ? function go$readdir2(path2, options2, cb2, startTime) {
          return fs$readdir(path2, fs$readdirCallback(
            path2,
            options2,
            cb2,
            startTime
          ));
        } : function go$readdir2(path2, options2, cb2, startTime) {
          return fs$readdir(path2, options2, fs$readdirCallback(
            path2,
            options2,
            cb2,
            startTime
          ));
        };
        return go$readdir(path, options, cb);
        function fs$readdirCallback(path2, options2, cb2, startTime) {
          return function(err, files) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([
                go$readdir,
                [path2, options2, cb2],
                err,
                startTime || Date.now(),
                Date.now()
              ]);
            else {
              if (files && files.sort)
                files.sort();
              if (typeof cb2 === "function")
                cb2.call(this, err, files);
            }
          };
        }
      }
      if (process.version.substr(0, 4) === "v0.8") {
        var legStreams = legacy(fs2);
        ReadStream = legStreams.ReadStream;
        WriteStream = legStreams.WriteStream;
      }
      var fs$ReadStream = fs2.ReadStream;
      if (fs$ReadStream) {
        ReadStream.prototype = Object.create(fs$ReadStream.prototype);
        ReadStream.prototype.open = ReadStream$open;
      }
      var fs$WriteStream = fs2.WriteStream;
      if (fs$WriteStream) {
        WriteStream.prototype = Object.create(fs$WriteStream.prototype);
        WriteStream.prototype.open = WriteStream$open;
      }
      Object.defineProperty(fs2, "ReadStream", {
        get: function() {
          return ReadStream;
        },
        set: function(val) {
          ReadStream = val;
        },
        enumerable: true,
        configurable: true
      });
      Object.defineProperty(fs2, "WriteStream", {
        get: function() {
          return WriteStream;
        },
        set: function(val) {
          WriteStream = val;
        },
        enumerable: true,
        configurable: true
      });
      var FileReadStream = ReadStream;
      Object.defineProperty(fs2, "FileReadStream", {
        get: function() {
          return FileReadStream;
        },
        set: function(val) {
          FileReadStream = val;
        },
        enumerable: true,
        configurable: true
      });
      var FileWriteStream = WriteStream;
      Object.defineProperty(fs2, "FileWriteStream", {
        get: function() {
          return FileWriteStream;
        },
        set: function(val) {
          FileWriteStream = val;
        },
        enumerable: true,
        configurable: true
      });
      function ReadStream(path, options) {
        if (this instanceof ReadStream)
          return fs$ReadStream.apply(this, arguments), this;
        else
          return ReadStream.apply(Object.create(ReadStream.prototype), arguments);
      }
      function ReadStream$open() {
        var that = this;
        open(that.path, that.flags, that.mode, function(err, fd) {
          if (err) {
            if (that.autoClose)
              that.destroy();
            that.emit("error", err);
          } else {
            that.fd = fd;
            that.emit("open", fd);
            that.read();
          }
        });
      }
      function WriteStream(path, options) {
        if (this instanceof WriteStream)
          return fs$WriteStream.apply(this, arguments), this;
        else
          return WriteStream.apply(Object.create(WriteStream.prototype), arguments);
      }
      function WriteStream$open() {
        var that = this;
        open(that.path, that.flags, that.mode, function(err, fd) {
          if (err) {
            that.destroy();
            that.emit("error", err);
          } else {
            that.fd = fd;
            that.emit("open", fd);
          }
        });
      }
      function createReadStream(path, options) {
        return new fs2.ReadStream(path, options);
      }
      function createWriteStream(path, options) {
        return new fs2.WriteStream(path, options);
      }
      var fs$open = fs2.open;
      fs2.open = open;
      function open(path, flags, mode, cb) {
        if (typeof mode === "function")
          cb = mode, mode = null;
        return go$open(path, flags, mode, cb);
        function go$open(path2, flags2, mode2, cb2, startTime) {
          return fs$open(path2, flags2, mode2, function(err, fd) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([go$open, [path2, flags2, mode2, cb2], err, startTime || Date.now(), Date.now()]);
            else {
              if (typeof cb2 === "function")
                cb2.apply(this, arguments);
            }
          });
        }
      }
      return fs2;
    }
    function enqueue(elem) {
      debug("ENQUEUE", elem[0].name, elem[1]);
      fs[gracefulQueue].push(elem);
      retry();
    }
    var retryTimer;
    function resetQueue() {
      var now = Date.now();
      for (var i = 0; i < fs[gracefulQueue].length; ++i) {
        if (fs[gracefulQueue][i].length > 2) {
          fs[gracefulQueue][i][3] = now;
          fs[gracefulQueue][i][4] = now;
        }
      }
      retry();
    }
    function retry() {
      clearTimeout(retryTimer);
      retryTimer = void 0;
      if (fs[gracefulQueue].length === 0)
        return;
      var elem = fs[gracefulQueue].shift();
      var fn = elem[0];
      var args = elem[1];
      var err = elem[2];
      var startTime = elem[3];
      var lastTime = elem[4];
      if (startTime === void 0) {
        debug("RETRY", fn.name, args);
        fn.apply(null, args);
      } else if (Date.now() - startTime >= 6e4) {
        debug("TIMEOUT", fn.name, args);
        var cb = args.pop();
        if (typeof cb === "function")
          cb.call(null, err);
      } else {
        var sinceAttempt = Date.now() - lastTime;
        var sinceStart = Math.max(lastTime - startTime, 1);
        var desiredDelay = Math.min(sinceStart * 1.2, 100);
        if (sinceAttempt >= desiredDelay) {
          debug("RETRY", fn.name, args);
          fn.apply(null, args.concat([startTime]));
        } else {
          fs[gracefulQueue].push(elem);
        }
      }
      if (retryTimer === void 0) {
        retryTimer = setTimeout(retry, 0);
      }
    }
  }
});

// node_modules/aws-cdk-lib/node_modules/fs-extra/lib/fs/index.js
var require_fs = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/fs-extra/lib/fs/index.js"(exports2) {
    "use strict";
    var u = require_universalify().fromCallback;
    var fs = require_graceful_fs();
    var api = [
      "access",
      "appendFile",
      "chmod",
      "chown",
      "close",
      "copyFile",
      "fchmod",
      "fchown",
      "fdatasync",
      "fstat",
      "fsync",
      "ftruncate",
      "futimes",
      "lchmod",
      "lchown",
      "link",
      "lstat",
      "mkdir",
      "mkdtemp",
      "open",
      "opendir",
      "readdir",
      "readFile",
      "readlink",
      "realpath",
      "rename",
      "rm",
      "rmdir",
      "stat",
      "symlink",
      "truncate",
      "unlink",
      "utimes",
      "writeFile"
    ].filter((key) => {
      return typeof fs[key] === "function";
    });
    Object.assign(exports2, fs);
    api.forEach((method) => {
      exports2[method] = u(fs[method]);
    });
    exports2.exists = function(filename, callback) {
      if (typeof callback === "function") {
        return fs.exists(filename, callback);
      }
      return new Promise((resolve) => {
        return fs.exists(filename, resolve);
      });
    };
    exports2.read = function(fd, buffer, offset, length, position, callback) {
      if (typeof callback === "function") {
        return fs.read(fd, buffer, offset, length, position, callback);
      }
      return new Promise((resolve, reject) => {
        fs.read(fd, buffer, offset, length, position, (err, bytesRead, buffer2) => {
          if (err)
            return reject(err);
          resolve({ bytesRead, buffer: buffer2 });
        });
      });
    };
    exports2.write = function(fd, buffer, ...args) {
      if (typeof args[args.length - 1] === "function") {
        return fs.write(fd, buffer, ...args);
      }
      return new Promise((resolve, reject) => {
        fs.write(fd, buffer, ...args, (err, bytesWritten, buffer2) => {
          if (err)
            return reject(err);
          resolve({ bytesWritten, buffer: buffer2 });
        });
      });
    };
    exports2.readv = function(fd, buffers, ...args) {
      if (typeof args[args.length - 1] === "function") {
        return fs.readv(fd, buffers, ...args);
      }
      return new Promise((resolve, reject) => {
        fs.readv(fd, buffers, ...args, (err, bytesRead, buffers2) => {
          if (err)
            return reject(err);
          resolve({ bytesRead, buffers: buffers2 });
        });
      });
    };
    exports2.writev = function(fd, buffers, ...args) {
      if (typeof args[args.length - 1] === "function") {
        return fs.writev(fd, buffers, ...args);
      }
      return new Promise((resolve, reject) => {
        fs.writev(fd, buffers, ...args, (err, bytesWritten, buffers2) => {
          if (err)
            return reject(err);
          resolve({ bytesWritten, buffers: buffers2 });
        });
      });
    };
    if (typeof fs.realpath.native === "function") {
      exports2.realpath.native = u(fs.realpath.native);
    } else {
      process.emitWarning(
        "fs.realpath.native is not a function. Is fs being monkey-patched?",
        "Warning",
        "fs-extra-WARN0003"
      );
    }
  }
});

// node_modules/aws-cdk-lib/node_modules/fs-extra/lib/mkdirs/utils.js
var require_utils2 = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/fs-extra/lib/mkdirs/utils.js"(exports2, module2) {
    "use strict";
    var path = require("path");
    module2.exports.checkPath = function checkPath(pth) {
      if (process.platform === "win32") {
        const pathHasInvalidWinCharacters = /[<>:"|?*]/.test(pth.replace(path.parse(pth).root, ""));
        if (pathHasInvalidWinCharacters) {
          const error = new Error(`Path contains invalid characters: ${pth}`);
          error.code = "EINVAL";
          throw error;
        }
      }
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/fs-extra/lib/mkdirs/make-dir.js
var require_make_dir = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/fs-extra/lib/mkdirs/make-dir.js"(exports2, module2) {
    "use strict";
    var fs = require_fs();
    var { checkPath } = require_utils2();
    var getMode = (options) => {
      const defaults = { mode: 511 };
      if (typeof options === "number")
        return options;
      return { ...defaults, ...options }.mode;
    };
    module2.exports.makeDir = async (dir, options) => {
      checkPath(dir);
      return fs.mkdir(dir, {
        mode: getMode(options),
        recursive: true
      });
    };
    module2.exports.makeDirSync = (dir, options) => {
      checkPath(dir);
      return fs.mkdirSync(dir, {
        mode: getMode(options),
        recursive: true
      });
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/fs-extra/lib/mkdirs/index.js
var require_mkdirs = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/fs-extra/lib/mkdirs/index.js"(exports2, module2) {
    "use strict";
    var u = require_universalify().fromPromise;
    var { makeDir: _makeDir, makeDirSync } = require_make_dir();
    var makeDir = u(_makeDir);
    module2.exports = {
      mkdirs: makeDir,
      mkdirsSync: makeDirSync,
      // alias
      mkdirp: makeDir,
      mkdirpSync: makeDirSync,
      ensureDir: makeDir,
      ensureDirSync: makeDirSync
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/fs-extra/lib/path-exists/index.js
var require_path_exists = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/fs-extra/lib/path-exists/index.js"(exports2, module2) {
    "use strict";
    var u = require_universalify().fromPromise;
    var fs = require_fs();
    function pathExists(path) {
      return fs.access(path).then(() => true).catch(() => false);
    }
    module2.exports = {
      pathExists: u(pathExists),
      pathExistsSync: fs.existsSync
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/fs-extra/lib/util/utimes.js
var require_utimes = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/fs-extra/lib/util/utimes.js"(exports2, module2) {
    "use strict";
    var fs = require_graceful_fs();
    function utimesMillis(path, atime, mtime, callback) {
      fs.open(path, "r+", (err, fd) => {
        if (err)
          return callback(err);
        fs.futimes(fd, atime, mtime, (futimesErr) => {
          fs.close(fd, (closeErr) => {
            if (callback)
              callback(futimesErr || closeErr);
          });
        });
      });
    }
    function utimesMillisSync(path, atime, mtime) {
      const fd = fs.openSync(path, "r+");
      fs.futimesSync(fd, atime, mtime);
      return fs.closeSync(fd);
    }
    module2.exports = {
      utimesMillis,
      utimesMillisSync
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/fs-extra/lib/util/stat.js
var require_stat = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/fs-extra/lib/util/stat.js"(exports2, module2) {
    "use strict";
    var fs = require_fs();
    var path = require("path");
    var util = require("util");
    function getStats(src, dest, opts) {
      const statFunc = opts.dereference ? (file) => fs.stat(file, { bigint: true }) : (file) => fs.lstat(file, { bigint: true });
      return Promise.all([
        statFunc(src),
        statFunc(dest).catch((err) => {
          if (err.code === "ENOENT")
            return null;
          throw err;
        })
      ]).then(([srcStat, destStat]) => ({ srcStat, destStat }));
    }
    function getStatsSync(src, dest, opts) {
      let destStat;
      const statFunc = opts.dereference ? (file) => fs.statSync(file, { bigint: true }) : (file) => fs.lstatSync(file, { bigint: true });
      const srcStat = statFunc(src);
      try {
        destStat = statFunc(dest);
      } catch (err) {
        if (err.code === "ENOENT")
          return { srcStat, destStat: null };
        throw err;
      }
      return { srcStat, destStat };
    }
    function checkPaths(src, dest, funcName, opts, cb) {
      util.callbackify(getStats)(src, dest, opts, (err, stats) => {
        if (err)
          return cb(err);
        const { srcStat, destStat } = stats;
        if (destStat) {
          if (areIdentical(srcStat, destStat)) {
            const srcBaseName = path.basename(src);
            const destBaseName = path.basename(dest);
            if (funcName === "move" && srcBaseName !== destBaseName && srcBaseName.toLowerCase() === destBaseName.toLowerCase()) {
              return cb(null, { srcStat, destStat, isChangingCase: true });
            }
            return cb(new Error("Source and destination must not be the same."));
          }
          if (srcStat.isDirectory() && !destStat.isDirectory()) {
            return cb(new Error(`Cannot overwrite non-directory '${dest}' with directory '${src}'.`));
          }
          if (!srcStat.isDirectory() && destStat.isDirectory()) {
            return cb(new Error(`Cannot overwrite directory '${dest}' with non-directory '${src}'.`));
          }
        }
        if (srcStat.isDirectory() && isSrcSubdir(src, dest)) {
          return cb(new Error(errMsg(src, dest, funcName)));
        }
        return cb(null, { srcStat, destStat });
      });
    }
    function checkPathsSync(src, dest, funcName, opts) {
      const { srcStat, destStat } = getStatsSync(src, dest, opts);
      if (destStat) {
        if (areIdentical(srcStat, destStat)) {
          const srcBaseName = path.basename(src);
          const destBaseName = path.basename(dest);
          if (funcName === "move" && srcBaseName !== destBaseName && srcBaseName.toLowerCase() === destBaseName.toLowerCase()) {
            return { srcStat, destStat, isChangingCase: true };
          }
          throw new Error("Source and destination must not be the same.");
        }
        if (srcStat.isDirectory() && !destStat.isDirectory()) {
          throw new Error(`Cannot overwrite non-directory '${dest}' with directory '${src}'.`);
        }
        if (!srcStat.isDirectory() && destStat.isDirectory()) {
          throw new Error(`Cannot overwrite directory '${dest}' with non-directory '${src}'.`);
        }
      }
      if (srcStat.isDirectory() && isSrcSubdir(src, dest)) {
        throw new Error(errMsg(src, dest, funcName));
      }
      return { srcStat, destStat };
    }
    function checkParentPaths(src, srcStat, dest, funcName, cb) {
      const srcParent = path.resolve(path.dirname(src));
      const destParent = path.resolve(path.dirname(dest));
      if (destParent === srcParent || destParent === path.parse(destParent).root)
        return cb();
      fs.stat(destParent, { bigint: true }, (err, destStat) => {
        if (err) {
          if (err.code === "ENOENT")
            return cb();
          return cb(err);
        }
        if (areIdentical(srcStat, destStat)) {
          return cb(new Error(errMsg(src, dest, funcName)));
        }
        return checkParentPaths(src, srcStat, destParent, funcName, cb);
      });
    }
    function checkParentPathsSync(src, srcStat, dest, funcName) {
      const srcParent = path.resolve(path.dirname(src));
      const destParent = path.resolve(path.dirname(dest));
      if (destParent === srcParent || destParent === path.parse(destParent).root)
        return;
      let destStat;
      try {
        destStat = fs.statSync(destParent, { bigint: true });
      } catch (err) {
        if (err.code === "ENOENT")
          return;
        throw err;
      }
      if (areIdentical(srcStat, destStat)) {
        throw new Error(errMsg(src, dest, funcName));
      }
      return checkParentPathsSync(src, srcStat, destParent, funcName);
    }
    function areIdentical(srcStat, destStat) {
      return destStat.ino && destStat.dev && destStat.ino === srcStat.ino && destStat.dev === srcStat.dev;
    }
    function isSrcSubdir(src, dest) {
      const srcArr = path.resolve(src).split(path.sep).filter((i) => i);
      const destArr = path.resolve(dest).split(path.sep).filter((i) => i);
      return srcArr.reduce((acc, cur, i) => acc && destArr[i] === cur, true);
    }
    function errMsg(src, dest, funcName) {
      return `Cannot ${funcName} '${src}' to a subdirectory of itself, '${dest}'.`;
    }
    module2.exports = {
      checkPaths,
      checkPathsSync,
      checkParentPaths,
      checkParentPathsSync,
      isSrcSubdir,
      areIdentical
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/fs-extra/lib/copy/copy.js
var require_copy = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/fs-extra/lib/copy/copy.js"(exports2, module2) {
    "use strict";
    var fs = require_graceful_fs();
    var path = require("path");
    var mkdirs = require_mkdirs().mkdirs;
    var pathExists = require_path_exists().pathExists;
    var utimesMillis = require_utimes().utimesMillis;
    var stat = require_stat();
    function copy(src, dest, opts, cb) {
      if (typeof opts === "function" && !cb) {
        cb = opts;
        opts = {};
      } else if (typeof opts === "function") {
        opts = { filter: opts };
      }
      cb = cb || function() {
      };
      opts = opts || {};
      opts.clobber = "clobber" in opts ? !!opts.clobber : true;
      opts.overwrite = "overwrite" in opts ? !!opts.overwrite : opts.clobber;
      if (opts.preserveTimestamps && process.arch === "ia32") {
        process.emitWarning(
          "Using the preserveTimestamps option in 32-bit node is not recommended;\n\n	see https://github.com/jprichardson/node-fs-extra/issues/269",
          "Warning",
          "fs-extra-WARN0001"
        );
      }
      stat.checkPaths(src, dest, "copy", opts, (err, stats) => {
        if (err)
          return cb(err);
        const { srcStat, destStat } = stats;
        stat.checkParentPaths(src, srcStat, dest, "copy", (err2) => {
          if (err2)
            return cb(err2);
          runFilter(src, dest, opts, (err3, include) => {
            if (err3)
              return cb(err3);
            if (!include)
              return cb();
            checkParentDir(destStat, src, dest, opts, cb);
          });
        });
      });
    }
    function checkParentDir(destStat, src, dest, opts, cb) {
      const destParent = path.dirname(dest);
      pathExists(destParent, (err, dirExists) => {
        if (err)
          return cb(err);
        if (dirExists)
          return getStats(destStat, src, dest, opts, cb);
        mkdirs(destParent, (err2) => {
          if (err2)
            return cb(err2);
          return getStats(destStat, src, dest, opts, cb);
        });
      });
    }
    function runFilter(src, dest, opts, cb) {
      if (!opts.filter)
        return cb(null, true);
      Promise.resolve(opts.filter(src, dest)).then((include) => cb(null, include), (error) => cb(error));
    }
    function getStats(destStat, src, dest, opts, cb) {
      const stat2 = opts.dereference ? fs.stat : fs.lstat;
      stat2(src, (err, srcStat) => {
        if (err)
          return cb(err);
        if (srcStat.isDirectory())
          return onDir(srcStat, destStat, src, dest, opts, cb);
        else if (srcStat.isFile() || srcStat.isCharacterDevice() || srcStat.isBlockDevice())
          return onFile(srcStat, destStat, src, dest, opts, cb);
        else if (srcStat.isSymbolicLink())
          return onLink(destStat, src, dest, opts, cb);
        else if (srcStat.isSocket())
          return cb(new Error(`Cannot copy a socket file: ${src}`));
        else if (srcStat.isFIFO())
          return cb(new Error(`Cannot copy a FIFO pipe: ${src}`));
        return cb(new Error(`Unknown file: ${src}`));
      });
    }
    function onFile(srcStat, destStat, src, dest, opts, cb) {
      if (!destStat)
        return copyFile(srcStat, src, dest, opts, cb);
      return mayCopyFile(srcStat, src, dest, opts, cb);
    }
    function mayCopyFile(srcStat, src, dest, opts, cb) {
      if (opts.overwrite) {
        fs.unlink(dest, (err) => {
          if (err)
            return cb(err);
          return copyFile(srcStat, src, dest, opts, cb);
        });
      } else if (opts.errorOnExist) {
        return cb(new Error(`'${dest}' already exists`));
      } else
        return cb();
    }
    function copyFile(srcStat, src, dest, opts, cb) {
      fs.copyFile(src, dest, (err) => {
        if (err)
          return cb(err);
        if (opts.preserveTimestamps)
          return handleTimestampsAndMode(srcStat.mode, src, dest, cb);
        return setDestMode(dest, srcStat.mode, cb);
      });
    }
    function handleTimestampsAndMode(srcMode, src, dest, cb) {
      if (fileIsNotWritable(srcMode)) {
        return makeFileWritable(dest, srcMode, (err) => {
          if (err)
            return cb(err);
          return setDestTimestampsAndMode(srcMode, src, dest, cb);
        });
      }
      return setDestTimestampsAndMode(srcMode, src, dest, cb);
    }
    function fileIsNotWritable(srcMode) {
      return (srcMode & 128) === 0;
    }
    function makeFileWritable(dest, srcMode, cb) {
      return setDestMode(dest, srcMode | 128, cb);
    }
    function setDestTimestampsAndMode(srcMode, src, dest, cb) {
      setDestTimestamps(src, dest, (err) => {
        if (err)
          return cb(err);
        return setDestMode(dest, srcMode, cb);
      });
    }
    function setDestMode(dest, srcMode, cb) {
      return fs.chmod(dest, srcMode, cb);
    }
    function setDestTimestamps(src, dest, cb) {
      fs.stat(src, (err, updatedSrcStat) => {
        if (err)
          return cb(err);
        return utimesMillis(dest, updatedSrcStat.atime, updatedSrcStat.mtime, cb);
      });
    }
    function onDir(srcStat, destStat, src, dest, opts, cb) {
      if (!destStat)
        return mkDirAndCopy(srcStat.mode, src, dest, opts, cb);
      return copyDir(src, dest, opts, cb);
    }
    function mkDirAndCopy(srcMode, src, dest, opts, cb) {
      fs.mkdir(dest, (err) => {
        if (err)
          return cb(err);
        copyDir(src, dest, opts, (err2) => {
          if (err2)
            return cb(err2);
          return setDestMode(dest, srcMode, cb);
        });
      });
    }
    function copyDir(src, dest, opts, cb) {
      fs.readdir(src, (err, items) => {
        if (err)
          return cb(err);
        return copyDirItems(items, src, dest, opts, cb);
      });
    }
    function copyDirItems(items, src, dest, opts, cb) {
      const item = items.pop();
      if (!item)
        return cb();
      return copyDirItem(items, item, src, dest, opts, cb);
    }
    function copyDirItem(items, item, src, dest, opts, cb) {
      const srcItem = path.join(src, item);
      const destItem = path.join(dest, item);
      runFilter(srcItem, destItem, opts, (err, include) => {
        if (err)
          return cb(err);
        if (!include)
          return copyDirItems(items, src, dest, opts, cb);
        stat.checkPaths(srcItem, destItem, "copy", opts, (err2, stats) => {
          if (err2)
            return cb(err2);
          const { destStat } = stats;
          getStats(destStat, srcItem, destItem, opts, (err3) => {
            if (err3)
              return cb(err3);
            return copyDirItems(items, src, dest, opts, cb);
          });
        });
      });
    }
    function onLink(destStat, src, dest, opts, cb) {
      fs.readlink(src, (err, resolvedSrc) => {
        if (err)
          return cb(err);
        if (opts.dereference) {
          resolvedSrc = path.resolve(process.cwd(), resolvedSrc);
        }
        if (!destStat) {
          return fs.symlink(resolvedSrc, dest, cb);
        } else {
          fs.readlink(dest, (err2, resolvedDest) => {
            if (err2) {
              if (err2.code === "EINVAL" || err2.code === "UNKNOWN")
                return fs.symlink(resolvedSrc, dest, cb);
              return cb(err2);
            }
            if (opts.dereference) {
              resolvedDest = path.resolve(process.cwd(), resolvedDest);
            }
            if (stat.isSrcSubdir(resolvedSrc, resolvedDest)) {
              return cb(new Error(`Cannot copy '${resolvedSrc}' to a subdirectory of itself, '${resolvedDest}'.`));
            }
            if (stat.isSrcSubdir(resolvedDest, resolvedSrc)) {
              return cb(new Error(`Cannot overwrite '${resolvedDest}' with '${resolvedSrc}'.`));
            }
            return copyLink(resolvedSrc, dest, cb);
          });
        }
      });
    }
    function copyLink(resolvedSrc, dest, cb) {
      fs.unlink(dest, (err) => {
        if (err)
          return cb(err);
        return fs.symlink(resolvedSrc, dest, cb);
      });
    }
    module2.exports = copy;
  }
});

// node_modules/aws-cdk-lib/node_modules/fs-extra/lib/copy/copy-sync.js
var require_copy_sync = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/fs-extra/lib/copy/copy-sync.js"(exports2, module2) {
    "use strict";
    var fs = require_graceful_fs();
    var path = require("path");
    var mkdirsSync = require_mkdirs().mkdirsSync;
    var utimesMillisSync = require_utimes().utimesMillisSync;
    var stat = require_stat();
    function copySync(src, dest, opts) {
      if (typeof opts === "function") {
        opts = { filter: opts };
      }
      opts = opts || {};
      opts.clobber = "clobber" in opts ? !!opts.clobber : true;
      opts.overwrite = "overwrite" in opts ? !!opts.overwrite : opts.clobber;
      if (opts.preserveTimestamps && process.arch === "ia32") {
        process.emitWarning(
          "Using the preserveTimestamps option in 32-bit node is not recommended;\n\n	see https://github.com/jprichardson/node-fs-extra/issues/269",
          "Warning",
          "fs-extra-WARN0002"
        );
      }
      const { srcStat, destStat } = stat.checkPathsSync(src, dest, "copy", opts);
      stat.checkParentPathsSync(src, srcStat, dest, "copy");
      if (opts.filter && !opts.filter(src, dest))
        return;
      const destParent = path.dirname(dest);
      if (!fs.existsSync(destParent))
        mkdirsSync(destParent);
      return getStats(destStat, src, dest, opts);
    }
    function getStats(destStat, src, dest, opts) {
      const statSync = opts.dereference ? fs.statSync : fs.lstatSync;
      const srcStat = statSync(src);
      if (srcStat.isDirectory())
        return onDir(srcStat, destStat, src, dest, opts);
      else if (srcStat.isFile() || srcStat.isCharacterDevice() || srcStat.isBlockDevice())
        return onFile(srcStat, destStat, src, dest, opts);
      else if (srcStat.isSymbolicLink())
        return onLink(destStat, src, dest, opts);
      else if (srcStat.isSocket())
        throw new Error(`Cannot copy a socket file: ${src}`);
      else if (srcStat.isFIFO())
        throw new Error(`Cannot copy a FIFO pipe: ${src}`);
      throw new Error(`Unknown file: ${src}`);
    }
    function onFile(srcStat, destStat, src, dest, opts) {
      if (!destStat)
        return copyFile(srcStat, src, dest, opts);
      return mayCopyFile(srcStat, src, dest, opts);
    }
    function mayCopyFile(srcStat, src, dest, opts) {
      if (opts.overwrite) {
        fs.unlinkSync(dest);
        return copyFile(srcStat, src, dest, opts);
      } else if (opts.errorOnExist) {
        throw new Error(`'${dest}' already exists`);
      }
    }
    function copyFile(srcStat, src, dest, opts) {
      fs.copyFileSync(src, dest);
      if (opts.preserveTimestamps)
        handleTimestamps(srcStat.mode, src, dest);
      return setDestMode(dest, srcStat.mode);
    }
    function handleTimestamps(srcMode, src, dest) {
      if (fileIsNotWritable(srcMode))
        makeFileWritable(dest, srcMode);
      return setDestTimestamps(src, dest);
    }
    function fileIsNotWritable(srcMode) {
      return (srcMode & 128) === 0;
    }
    function makeFileWritable(dest, srcMode) {
      return setDestMode(dest, srcMode | 128);
    }
    function setDestMode(dest, srcMode) {
      return fs.chmodSync(dest, srcMode);
    }
    function setDestTimestamps(src, dest) {
      const updatedSrcStat = fs.statSync(src);
      return utimesMillisSync(dest, updatedSrcStat.atime, updatedSrcStat.mtime);
    }
    function onDir(srcStat, destStat, src, dest, opts) {
      if (!destStat)
        return mkDirAndCopy(srcStat.mode, src, dest, opts);
      return copyDir(src, dest, opts);
    }
    function mkDirAndCopy(srcMode, src, dest, opts) {
      fs.mkdirSync(dest);
      copyDir(src, dest, opts);
      return setDestMode(dest, srcMode);
    }
    function copyDir(src, dest, opts) {
      fs.readdirSync(src).forEach((item) => copyDirItem(item, src, dest, opts));
    }
    function copyDirItem(item, src, dest, opts) {
      const srcItem = path.join(src, item);
      const destItem = path.join(dest, item);
      if (opts.filter && !opts.filter(srcItem, destItem))
        return;
      const { destStat } = stat.checkPathsSync(srcItem, destItem, "copy", opts);
      return getStats(destStat, srcItem, destItem, opts);
    }
    function onLink(destStat, src, dest, opts) {
      let resolvedSrc = fs.readlinkSync(src);
      if (opts.dereference) {
        resolvedSrc = path.resolve(process.cwd(), resolvedSrc);
      }
      if (!destStat) {
        return fs.symlinkSync(resolvedSrc, dest);
      } else {
        let resolvedDest;
        try {
          resolvedDest = fs.readlinkSync(dest);
        } catch (err) {
          if (err.code === "EINVAL" || err.code === "UNKNOWN")
            return fs.symlinkSync(resolvedSrc, dest);
          throw err;
        }
        if (opts.dereference) {
          resolvedDest = path.resolve(process.cwd(), resolvedDest);
        }
        if (stat.isSrcSubdir(resolvedSrc, resolvedDest)) {
          throw new Error(`Cannot copy '${resolvedSrc}' to a subdirectory of itself, '${resolvedDest}'.`);
        }
        if (stat.isSrcSubdir(resolvedDest, resolvedSrc)) {
          throw new Error(`Cannot overwrite '${resolvedDest}' with '${resolvedSrc}'.`);
        }
        return copyLink(resolvedSrc, dest);
      }
    }
    function copyLink(resolvedSrc, dest) {
      fs.unlinkSync(dest);
      return fs.symlinkSync(resolvedSrc, dest);
    }
    module2.exports = copySync;
  }
});

// node_modules/aws-cdk-lib/node_modules/fs-extra/lib/copy/index.js
var require_copy2 = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/fs-extra/lib/copy/index.js"(exports2, module2) {
    "use strict";
    var u = require_universalify().fromCallback;
    module2.exports = {
      copy: u(require_copy()),
      copySync: require_copy_sync()
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/fs-extra/lib/remove/index.js
var require_remove = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/fs-extra/lib/remove/index.js"(exports2, module2) {
    "use strict";
    var fs = require_graceful_fs();
    var u = require_universalify().fromCallback;
    function remove(path, callback) {
      fs.rm(path, { recursive: true, force: true }, callback);
    }
    function removeSync(path) {
      fs.rmSync(path, { recursive: true, force: true });
    }
    module2.exports = {
      remove: u(remove),
      removeSync
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/fs-extra/lib/empty/index.js
var require_empty = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/fs-extra/lib/empty/index.js"(exports2, module2) {
    "use strict";
    var u = require_universalify().fromPromise;
    var fs = require_fs();
    var path = require("path");
    var mkdir = require_mkdirs();
    var remove = require_remove();
    var emptyDir = u(async function emptyDir2(dir) {
      let items;
      try {
        items = await fs.readdir(dir);
      } catch {
        return mkdir.mkdirs(dir);
      }
      return Promise.all(items.map((item) => remove.remove(path.join(dir, item))));
    });
    function emptyDirSync(dir) {
      let items;
      try {
        items = fs.readdirSync(dir);
      } catch {
        return mkdir.mkdirsSync(dir);
      }
      items.forEach((item) => {
        item = path.join(dir, item);
        remove.removeSync(item);
      });
    }
    module2.exports = {
      emptyDirSync,
      emptydirSync: emptyDirSync,
      emptyDir,
      emptydir: emptyDir
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/fs-extra/lib/ensure/file.js
var require_file = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/fs-extra/lib/ensure/file.js"(exports2, module2) {
    "use strict";
    var u = require_universalify().fromCallback;
    var path = require("path");
    var fs = require_graceful_fs();
    var mkdir = require_mkdirs();
    function createFile(file, callback) {
      function makeFile() {
        fs.writeFile(file, "", (err) => {
          if (err)
            return callback(err);
          callback();
        });
      }
      fs.stat(file, (err, stats) => {
        if (!err && stats.isFile())
          return callback();
        const dir = path.dirname(file);
        fs.stat(dir, (err2, stats2) => {
          if (err2) {
            if (err2.code === "ENOENT") {
              return mkdir.mkdirs(dir, (err3) => {
                if (err3)
                  return callback(err3);
                makeFile();
              });
            }
            return callback(err2);
          }
          if (stats2.isDirectory())
            makeFile();
          else {
            fs.readdir(dir, (err3) => {
              if (err3)
                return callback(err3);
            });
          }
        });
      });
    }
    function createFileSync(file) {
      let stats;
      try {
        stats = fs.statSync(file);
      } catch {
      }
      if (stats && stats.isFile())
        return;
      const dir = path.dirname(file);
      try {
        if (!fs.statSync(dir).isDirectory()) {
          fs.readdirSync(dir);
        }
      } catch (err) {
        if (err && err.code === "ENOENT")
          mkdir.mkdirsSync(dir);
        else
          throw err;
      }
      fs.writeFileSync(file, "");
    }
    module2.exports = {
      createFile: u(createFile),
      createFileSync
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/fs-extra/lib/ensure/link.js
var require_link = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/fs-extra/lib/ensure/link.js"(exports2, module2) {
    "use strict";
    var u = require_universalify().fromCallback;
    var path = require("path");
    var fs = require_graceful_fs();
    var mkdir = require_mkdirs();
    var pathExists = require_path_exists().pathExists;
    var { areIdentical } = require_stat();
    function createLink(srcpath, dstpath, callback) {
      function makeLink(srcpath2, dstpath2) {
        fs.link(srcpath2, dstpath2, (err) => {
          if (err)
            return callback(err);
          callback(null);
        });
      }
      fs.lstat(dstpath, (_, dstStat) => {
        fs.lstat(srcpath, (err, srcStat) => {
          if (err) {
            err.message = err.message.replace("lstat", "ensureLink");
            return callback(err);
          }
          if (dstStat && areIdentical(srcStat, dstStat))
            return callback(null);
          const dir = path.dirname(dstpath);
          pathExists(dir, (err2, dirExists) => {
            if (err2)
              return callback(err2);
            if (dirExists)
              return makeLink(srcpath, dstpath);
            mkdir.mkdirs(dir, (err3) => {
              if (err3)
                return callback(err3);
              makeLink(srcpath, dstpath);
            });
          });
        });
      });
    }
    function createLinkSync(srcpath, dstpath) {
      let dstStat;
      try {
        dstStat = fs.lstatSync(dstpath);
      } catch {
      }
      try {
        const srcStat = fs.lstatSync(srcpath);
        if (dstStat && areIdentical(srcStat, dstStat))
          return;
      } catch (err) {
        err.message = err.message.replace("lstat", "ensureLink");
        throw err;
      }
      const dir = path.dirname(dstpath);
      const dirExists = fs.existsSync(dir);
      if (dirExists)
        return fs.linkSync(srcpath, dstpath);
      mkdir.mkdirsSync(dir);
      return fs.linkSync(srcpath, dstpath);
    }
    module2.exports = {
      createLink: u(createLink),
      createLinkSync
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/fs-extra/lib/ensure/symlink-paths.js
var require_symlink_paths = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/fs-extra/lib/ensure/symlink-paths.js"(exports2, module2) {
    "use strict";
    var path = require("path");
    var fs = require_graceful_fs();
    var pathExists = require_path_exists().pathExists;
    function symlinkPaths(srcpath, dstpath, callback) {
      if (path.isAbsolute(srcpath)) {
        return fs.lstat(srcpath, (err) => {
          if (err) {
            err.message = err.message.replace("lstat", "ensureSymlink");
            return callback(err);
          }
          return callback(null, {
            toCwd: srcpath,
            toDst: srcpath
          });
        });
      } else {
        const dstdir = path.dirname(dstpath);
        const relativeToDst = path.join(dstdir, srcpath);
        return pathExists(relativeToDst, (err, exists) => {
          if (err)
            return callback(err);
          if (exists) {
            return callback(null, {
              toCwd: relativeToDst,
              toDst: srcpath
            });
          } else {
            return fs.lstat(srcpath, (err2) => {
              if (err2) {
                err2.message = err2.message.replace("lstat", "ensureSymlink");
                return callback(err2);
              }
              return callback(null, {
                toCwd: srcpath,
                toDst: path.relative(dstdir, srcpath)
              });
            });
          }
        });
      }
    }
    function symlinkPathsSync(srcpath, dstpath) {
      let exists;
      if (path.isAbsolute(srcpath)) {
        exists = fs.existsSync(srcpath);
        if (!exists)
          throw new Error("absolute srcpath does not exist");
        return {
          toCwd: srcpath,
          toDst: srcpath
        };
      } else {
        const dstdir = path.dirname(dstpath);
        const relativeToDst = path.join(dstdir, srcpath);
        exists = fs.existsSync(relativeToDst);
        if (exists) {
          return {
            toCwd: relativeToDst,
            toDst: srcpath
          };
        } else {
          exists = fs.existsSync(srcpath);
          if (!exists)
            throw new Error("relative srcpath does not exist");
          return {
            toCwd: srcpath,
            toDst: path.relative(dstdir, srcpath)
          };
        }
      }
    }
    module2.exports = {
      symlinkPaths,
      symlinkPathsSync
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/fs-extra/lib/ensure/symlink-type.js
var require_symlink_type = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/fs-extra/lib/ensure/symlink-type.js"(exports2, module2) {
    "use strict";
    var fs = require_graceful_fs();
    function symlinkType(srcpath, type, callback) {
      callback = typeof type === "function" ? type : callback;
      type = typeof type === "function" ? false : type;
      if (type)
        return callback(null, type);
      fs.lstat(srcpath, (err, stats) => {
        if (err)
          return callback(null, "file");
        type = stats && stats.isDirectory() ? "dir" : "file";
        callback(null, type);
      });
    }
    function symlinkTypeSync(srcpath, type) {
      let stats;
      if (type)
        return type;
      try {
        stats = fs.lstatSync(srcpath);
      } catch {
        return "file";
      }
      return stats && stats.isDirectory() ? "dir" : "file";
    }
    module2.exports = {
      symlinkType,
      symlinkTypeSync
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/fs-extra/lib/ensure/symlink.js
var require_symlink = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/fs-extra/lib/ensure/symlink.js"(exports2, module2) {
    "use strict";
    var u = require_universalify().fromCallback;
    var path = require("path");
    var fs = require_fs();
    var _mkdirs = require_mkdirs();
    var mkdirs = _mkdirs.mkdirs;
    var mkdirsSync = _mkdirs.mkdirsSync;
    var _symlinkPaths = require_symlink_paths();
    var symlinkPaths = _symlinkPaths.symlinkPaths;
    var symlinkPathsSync = _symlinkPaths.symlinkPathsSync;
    var _symlinkType = require_symlink_type();
    var symlinkType = _symlinkType.symlinkType;
    var symlinkTypeSync = _symlinkType.symlinkTypeSync;
    var pathExists = require_path_exists().pathExists;
    var { areIdentical } = require_stat();
    function createSymlink(srcpath, dstpath, type, callback) {
      callback = typeof type === "function" ? type : callback;
      type = typeof type === "function" ? false : type;
      fs.lstat(dstpath, (err, stats) => {
        if (!err && stats.isSymbolicLink()) {
          Promise.all([
            fs.stat(srcpath),
            fs.stat(dstpath)
          ]).then(([srcStat, dstStat]) => {
            if (areIdentical(srcStat, dstStat))
              return callback(null);
            _createSymlink(srcpath, dstpath, type, callback);
          });
        } else
          _createSymlink(srcpath, dstpath, type, callback);
      });
    }
    function _createSymlink(srcpath, dstpath, type, callback) {
      symlinkPaths(srcpath, dstpath, (err, relative) => {
        if (err)
          return callback(err);
        srcpath = relative.toDst;
        symlinkType(relative.toCwd, type, (err2, type2) => {
          if (err2)
            return callback(err2);
          const dir = path.dirname(dstpath);
          pathExists(dir, (err3, dirExists) => {
            if (err3)
              return callback(err3);
            if (dirExists)
              return fs.symlink(srcpath, dstpath, type2, callback);
            mkdirs(dir, (err4) => {
              if (err4)
                return callback(err4);
              fs.symlink(srcpath, dstpath, type2, callback);
            });
          });
        });
      });
    }
    function createSymlinkSync(srcpath, dstpath, type) {
      let stats;
      try {
        stats = fs.lstatSync(dstpath);
      } catch {
      }
      if (stats && stats.isSymbolicLink()) {
        const srcStat = fs.statSync(srcpath);
        const dstStat = fs.statSync(dstpath);
        if (areIdentical(srcStat, dstStat))
          return;
      }
      const relative = symlinkPathsSync(srcpath, dstpath);
      srcpath = relative.toDst;
      type = symlinkTypeSync(relative.toCwd, type);
      const dir = path.dirname(dstpath);
      const exists = fs.existsSync(dir);
      if (exists)
        return fs.symlinkSync(srcpath, dstpath, type);
      mkdirsSync(dir);
      return fs.symlinkSync(srcpath, dstpath, type);
    }
    module2.exports = {
      createSymlink: u(createSymlink),
      createSymlinkSync
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/fs-extra/lib/ensure/index.js
var require_ensure = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/fs-extra/lib/ensure/index.js"(exports2, module2) {
    "use strict";
    var { createFile, createFileSync } = require_file();
    var { createLink, createLinkSync } = require_link();
    var { createSymlink, createSymlinkSync } = require_symlink();
    module2.exports = {
      // file
      createFile,
      createFileSync,
      ensureFile: createFile,
      ensureFileSync: createFileSync,
      // link
      createLink,
      createLinkSync,
      ensureLink: createLink,
      ensureLinkSync: createLinkSync,
      // symlink
      createSymlink,
      createSymlinkSync,
      ensureSymlink: createSymlink,
      ensureSymlinkSync: createSymlinkSync
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/jsonfile/utils.js
var require_utils3 = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/jsonfile/utils.js"(exports2, module2) {
    "use strict";
    function stringify(obj, { EOL = "\n", finalEOL = true, replacer = null, spaces } = {}) {
      const EOF = finalEOL ? EOL : "";
      const str = JSON.stringify(obj, replacer, spaces);
      return str.replace(/\n/g, EOL) + EOF;
    }
    function stripBom(content) {
      if (Buffer.isBuffer(content))
        content = content.toString("utf8");
      return content.replace(/^\uFEFF/, "");
    }
    module2.exports = { stringify, stripBom };
  }
});

// node_modules/aws-cdk-lib/node_modules/jsonfile/index.js
var require_jsonfile = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/jsonfile/index.js"(exports2, module2) {
    "use strict";
    var _fs;
    try {
      _fs = require_graceful_fs();
    } catch (_) {
      _fs = require("fs");
    }
    var universalify = require_universalify();
    var { stringify, stripBom } = require_utils3();
    async function _readFile(file, options = {}) {
      if (typeof options === "string") {
        options = { encoding: options };
      }
      const fs = options.fs || _fs;
      const shouldThrow = "throws" in options ? options.throws : true;
      let data = await universalify.fromCallback(fs.readFile)(file, options);
      data = stripBom(data);
      let obj;
      try {
        obj = JSON.parse(data, options ? options.reviver : null);
      } catch (err) {
        if (shouldThrow) {
          err.message = `${file}: ${err.message}`;
          throw err;
        } else {
          return null;
        }
      }
      return obj;
    }
    var readFile = universalify.fromPromise(_readFile);
    function readFileSync(file, options = {}) {
      if (typeof options === "string") {
        options = { encoding: options };
      }
      const fs = options.fs || _fs;
      const shouldThrow = "throws" in options ? options.throws : true;
      try {
        let content = fs.readFileSync(file, options);
        content = stripBom(content);
        return JSON.parse(content, options.reviver);
      } catch (err) {
        if (shouldThrow) {
          err.message = `${file}: ${err.message}`;
          throw err;
        } else {
          return null;
        }
      }
    }
    async function _writeFile(file, obj, options = {}) {
      const fs = options.fs || _fs;
      const str = stringify(obj, options);
      await universalify.fromCallback(fs.writeFile)(file, str, options);
    }
    var writeFile = universalify.fromPromise(_writeFile);
    function writeFileSync(file, obj, options = {}) {
      const fs = options.fs || _fs;
      const str = stringify(obj, options);
      return fs.writeFileSync(file, str, options);
    }
    var jsonfile = {
      readFile,
      readFileSync,
      writeFile,
      writeFileSync
    };
    module2.exports = jsonfile;
  }
});

// node_modules/aws-cdk-lib/node_modules/fs-extra/lib/json/jsonfile.js
var require_jsonfile2 = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/fs-extra/lib/json/jsonfile.js"(exports2, module2) {
    "use strict";
    var jsonFile = require_jsonfile();
    module2.exports = {
      // jsonfile exports
      readJson: jsonFile.readFile,
      readJsonSync: jsonFile.readFileSync,
      writeJson: jsonFile.writeFile,
      writeJsonSync: jsonFile.writeFileSync
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/fs-extra/lib/output-file/index.js
var require_output_file = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/fs-extra/lib/output-file/index.js"(exports2, module2) {
    "use strict";
    var u = require_universalify().fromCallback;
    var fs = require_graceful_fs();
    var path = require("path");
    var mkdir = require_mkdirs();
    var pathExists = require_path_exists().pathExists;
    function outputFile(file, data, encoding, callback) {
      if (typeof encoding === "function") {
        callback = encoding;
        encoding = "utf8";
      }
      const dir = path.dirname(file);
      pathExists(dir, (err, itDoes) => {
        if (err)
          return callback(err);
        if (itDoes)
          return fs.writeFile(file, data, encoding, callback);
        mkdir.mkdirs(dir, (err2) => {
          if (err2)
            return callback(err2);
          fs.writeFile(file, data, encoding, callback);
        });
      });
    }
    function outputFileSync(file, ...args) {
      const dir = path.dirname(file);
      if (fs.existsSync(dir)) {
        return fs.writeFileSync(file, ...args);
      }
      mkdir.mkdirsSync(dir);
      fs.writeFileSync(file, ...args);
    }
    module2.exports = {
      outputFile: u(outputFile),
      outputFileSync
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/fs-extra/lib/json/output-json.js
var require_output_json = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/fs-extra/lib/json/output-json.js"(exports2, module2) {
    "use strict";
    var { stringify } = require_utils3();
    var { outputFile } = require_output_file();
    async function outputJson(file, data, options = {}) {
      const str = stringify(data, options);
      await outputFile(file, str, options);
    }
    module2.exports = outputJson;
  }
});

// node_modules/aws-cdk-lib/node_modules/fs-extra/lib/json/output-json-sync.js
var require_output_json_sync = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/fs-extra/lib/json/output-json-sync.js"(exports2, module2) {
    "use strict";
    var { stringify } = require_utils3();
    var { outputFileSync } = require_output_file();
    function outputJsonSync(file, data, options) {
      const str = stringify(data, options);
      outputFileSync(file, str, options);
    }
    module2.exports = outputJsonSync;
  }
});

// node_modules/aws-cdk-lib/node_modules/fs-extra/lib/json/index.js
var require_json2 = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/fs-extra/lib/json/index.js"(exports2, module2) {
    "use strict";
    var u = require_universalify().fromPromise;
    var jsonFile = require_jsonfile2();
    jsonFile.outputJson = u(require_output_json());
    jsonFile.outputJsonSync = require_output_json_sync();
    jsonFile.outputJSON = jsonFile.outputJson;
    jsonFile.outputJSONSync = jsonFile.outputJsonSync;
    jsonFile.writeJSON = jsonFile.writeJson;
    jsonFile.writeJSONSync = jsonFile.writeJsonSync;
    jsonFile.readJSON = jsonFile.readJson;
    jsonFile.readJSONSync = jsonFile.readJsonSync;
    module2.exports = jsonFile;
  }
});

// node_modules/aws-cdk-lib/node_modules/fs-extra/lib/move/move.js
var require_move = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/fs-extra/lib/move/move.js"(exports2, module2) {
    "use strict";
    var fs = require_graceful_fs();
    var path = require("path");
    var copy = require_copy2().copy;
    var remove = require_remove().remove;
    var mkdirp = require_mkdirs().mkdirp;
    var pathExists = require_path_exists().pathExists;
    var stat = require_stat();
    function move(src, dest, opts, cb) {
      if (typeof opts === "function") {
        cb = opts;
        opts = {};
      }
      opts = opts || {};
      const overwrite = opts.overwrite || opts.clobber || false;
      stat.checkPaths(src, dest, "move", opts, (err, stats) => {
        if (err)
          return cb(err);
        const { srcStat, isChangingCase = false } = stats;
        stat.checkParentPaths(src, srcStat, dest, "move", (err2) => {
          if (err2)
            return cb(err2);
          if (isParentRoot(dest))
            return doRename(src, dest, overwrite, isChangingCase, cb);
          mkdirp(path.dirname(dest), (err3) => {
            if (err3)
              return cb(err3);
            return doRename(src, dest, overwrite, isChangingCase, cb);
          });
        });
      });
    }
    function isParentRoot(dest) {
      const parent = path.dirname(dest);
      const parsedPath = path.parse(parent);
      return parsedPath.root === parent;
    }
    function doRename(src, dest, overwrite, isChangingCase, cb) {
      if (isChangingCase)
        return rename(src, dest, overwrite, cb);
      if (overwrite) {
        return remove(dest, (err) => {
          if (err)
            return cb(err);
          return rename(src, dest, overwrite, cb);
        });
      }
      pathExists(dest, (err, destExists) => {
        if (err)
          return cb(err);
        if (destExists)
          return cb(new Error("dest already exists."));
        return rename(src, dest, overwrite, cb);
      });
    }
    function rename(src, dest, overwrite, cb) {
      fs.rename(src, dest, (err) => {
        if (!err)
          return cb();
        if (err.code !== "EXDEV")
          return cb(err);
        return moveAcrossDevice(src, dest, overwrite, cb);
      });
    }
    function moveAcrossDevice(src, dest, overwrite, cb) {
      const opts = {
        overwrite,
        errorOnExist: true,
        preserveTimestamps: true
      };
      copy(src, dest, opts, (err) => {
        if (err)
          return cb(err);
        return remove(src, cb);
      });
    }
    module2.exports = move;
  }
});

// node_modules/aws-cdk-lib/node_modules/fs-extra/lib/move/move-sync.js
var require_move_sync = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/fs-extra/lib/move/move-sync.js"(exports2, module2) {
    "use strict";
    var fs = require_graceful_fs();
    var path = require("path");
    var copySync = require_copy2().copySync;
    var removeSync = require_remove().removeSync;
    var mkdirpSync = require_mkdirs().mkdirpSync;
    var stat = require_stat();
    function moveSync(src, dest, opts) {
      opts = opts || {};
      const overwrite = opts.overwrite || opts.clobber || false;
      const { srcStat, isChangingCase = false } = stat.checkPathsSync(src, dest, "move", opts);
      stat.checkParentPathsSync(src, srcStat, dest, "move");
      if (!isParentRoot(dest))
        mkdirpSync(path.dirname(dest));
      return doRename(src, dest, overwrite, isChangingCase);
    }
    function isParentRoot(dest) {
      const parent = path.dirname(dest);
      const parsedPath = path.parse(parent);
      return parsedPath.root === parent;
    }
    function doRename(src, dest, overwrite, isChangingCase) {
      if (isChangingCase)
        return rename(src, dest, overwrite);
      if (overwrite) {
        removeSync(dest);
        return rename(src, dest, overwrite);
      }
      if (fs.existsSync(dest))
        throw new Error("dest already exists.");
      return rename(src, dest, overwrite);
    }
    function rename(src, dest, overwrite) {
      try {
        fs.renameSync(src, dest);
      } catch (err) {
        if (err.code !== "EXDEV")
          throw err;
        return moveAcrossDevice(src, dest, overwrite);
      }
    }
    function moveAcrossDevice(src, dest, overwrite) {
      const opts = {
        overwrite,
        errorOnExist: true,
        preserveTimestamps: true
      };
      copySync(src, dest, opts);
      return removeSync(src);
    }
    module2.exports = moveSync;
  }
});

// node_modules/aws-cdk-lib/node_modules/fs-extra/lib/move/index.js
var require_move2 = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/fs-extra/lib/move/index.js"(exports2, module2) {
    "use strict";
    var u = require_universalify().fromCallback;
    module2.exports = {
      move: u(require_move()),
      moveSync: require_move_sync()
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/fs-extra/lib/index.js
var require_lib6 = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/fs-extra/lib/index.js"(exports2, module2) {
    "use strict";
    module2.exports = {
      // Export promiseified graceful-fs:
      ...require_fs(),
      // Export extra methods:
      ...require_copy2(),
      ...require_empty(),
      ...require_ensure(),
      ...require_json2(),
      ...require_mkdirs(),
      ...require_move2(),
      ...require_output_file(),
      ...require_path_exists(),
      ...require_remove()
    };
  }
});

// node_modules/aws-cdk-lib/core/lib/private/private-context.js
var require_private_context = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/private/private-context.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PRIVATE_CONTEXT_DEFAULT_STACK_SYNTHESIZER = void 0;
    var PREFIX = `aws-cdk-private:${Math.random()}:`;
    exports2.PRIVATE_CONTEXT_DEFAULT_STACK_SYNTHESIZER = `${PREFIX}core/defaultStackSynthesizer`;
  }
});

// node_modules/aws-cdk-lib/core/lib/stage.js
var require_stage = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/stage.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Stage = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var synthesis_1 = require_synthesis();
    var cxapi = require_cx_api();
    var STAGE_SYMBOL = Symbol.for("@aws-cdk/core.Stage");
    var Stage = class _Stage extends constructs_1.Construct {
      static of(construct) {
        return constructs_1.Node.of(construct).scopes.reverse().slice(1).find(_Stage.isStage);
      }
      static isStage(x) {
        return x !== null && typeof x == "object" && STAGE_SYMBOL in x;
      }
      constructor(scope, id, props = {}) {
        super(scope, id), this.policyValidationBeta1 = [];
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_StageProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Stage), error;
        }
        if (id !== "" && !/^[a-z][a-z0-9\-\_\.]+$/i.test(id))
          throw new Error(`invalid stage name "${id}". Stage name must start with a letter and contain only alphanumeric characters, hypens ('-'), underscores ('_') and periods ('.')`);
        Object.defineProperty(this, STAGE_SYMBOL, { value: true }), this.parentStage = _Stage.of(this), this.region = props.env?.region ?? this.parentStage?.region, this.account = props.env?.account ?? this.parentStage?.account, props.permissionsBoundary?._bind(this), this._assemblyBuilder = this.createBuilder(props.outdir), this.stageName = [this.parentStage?.stageName, props.stageName ?? id].filter((x) => x).join("-"), props.policyValidationBeta1 && (this.policyValidationBeta1 = props.policyValidationBeta1);
      }
      get outdir() {
        return this._assemblyBuilder.outdir;
      }
      get assetOutdir() {
        return this._assemblyBuilder.assetOutdir;
      }
      get artifactId() {
        return this.node.path ? `assembly-${this.node.path.replace(/\//g, "-").replace(/^-+|-+$/g, "")}` : "";
      }
      synth(options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_StageSynthesisOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.synth), error;
        }
        return (!this.assembly || options.force) && (this.assembly = (0, synthesis_1.synthesize)(this, { skipValidation: options.skipValidation, validateOnSynthesis: options.validateOnSynthesis })), this.assembly;
      }
      createBuilder(outdir) {
        if (this.parentStage && outdir)
          throw new Error('"outdir" cannot be specified for nested stages');
        return this.parentStage ? this.parentStage._assemblyBuilder.createNestedAssembly(this.artifactId, this.node.path) : new cxapi.CloudAssemblyBuilder(outdir);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Stage[_a] = { fqn: "aws-cdk-lib.Stage", version: "2.80.0" }, exports2.Stage = Stage;
  }
});

// node_modules/aws-cdk-lib/core/lib/private/runtime-info.js
var require_runtime_info = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/private/runtime-info.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.constructInfoFromStack = exports2.constructInfoFromConstruct = void 0;
    var app_1 = require_app2();
    var stack_1 = require_stack();
    var stage_1 = require_stage();
    var ALLOWED_FQN_PREFIXES = ["@aws-cdk/", "@aws-cdk-containers/", "@aws-solutions-konstruk/", "@aws-solutions-constructs/", "@amzn/", "@cdklabs/", "aws-rfdk.", "aws-cdk-lib.", "cdk8s."];
    var JSII_RUNTIME_SYMBOL = Symbol.for("jsii.rtti");
    function constructInfoFromConstruct(construct) {
      const jsiiRuntimeInfo = Object.getPrototypeOf(construct).constructor[JSII_RUNTIME_SYMBOL];
      if (typeof jsiiRuntimeInfo == "object" && jsiiRuntimeInfo !== null && typeof jsiiRuntimeInfo.fqn == "string" && typeof jsiiRuntimeInfo.version == "string")
        return { fqn: jsiiRuntimeInfo.fqn, version: jsiiRuntimeInfo.version };
      if (jsiiRuntimeInfo)
        throw new Error(`malformed jsii runtime info for construct: '${construct.node.path}'`);
    }
    exports2.constructInfoFromConstruct = constructInfoFromConstruct;
    function addValidationPluginInfo(stack, allConstructInfos) {
      let stage = stage_1.Stage.of(stack), done = false;
      do
        app_1.App.isApp(stage) && (done = true), stage && (allConstructInfos.push(...stage.policyValidationBeta1.map((plugin) => ({ fqn: pluginFqn(plugin), version: plugin.version ?? "0.0.0" }))), stage = stage_1.Stage.of(stage));
      while (!done && stage);
    }
    function pluginFqn(plugin) {
      return ["policyValidation", plugin.name, plugin.ruleIds?.join("|")].filter((x) => x != null).join(".");
    }
    function constructInfoFromStack(stack) {
      const isDefined = (value) => value !== void 0, allConstructInfos = constructsInStack(stack).map((construct) => constructInfoFromConstruct(construct)).filter(isDefined).filter((info) => ALLOWED_FQN_PREFIXES.find((prefix) => info.fqn.startsWith(prefix)));
      allConstructInfos.push({ fqn: "jsii-runtime.Runtime", version: getJsiiAgentVersion() }), addValidationPluginInfo(stack, allConstructInfos);
      const uniqKeys = /* @__PURE__ */ new Set();
      return allConstructInfos.filter((construct) => {
        const constructKey = `${construct.fqn}@${construct.version}`, isDuplicate = uniqKeys.has(constructKey);
        return uniqKeys.add(constructKey), !isDuplicate;
      });
    }
    exports2.constructInfoFromStack = constructInfoFromStack;
    function constructsInStack(construct) {
      const constructs = [construct];
      return construct.node.children.filter((child) => !stage_1.Stage.isStage(child) && !stack_1.Stack.isStack(child)).forEach((child) => constructs.push(...constructsInStack(child))), constructs;
    }
    function getJsiiAgentVersion() {
      let jsiiAgent = process.env.JSII_AGENT;
      return jsiiAgent || (jsiiAgent = `node.js/${process.version}`), jsiiAgent = jsiiAgent.replace(/[^a-z0-9.-/=_]/gi, "-"), jsiiAgent;
    }
  }
});

// node_modules/aws-cdk-lib/region-info/lib/default.js
var require_default = __commonJS({
  "node_modules/aws-cdk-lib/region-info/lib/default.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Default = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var Default = class {
      static servicePrincipal(serviceFqn, region, urlSuffix) {
        const serviceName = extractSimpleName(serviceFqn);
        if (!serviceName)
          return serviceFqn;
        function determineConfiguration(service) {
          function universal(s) {
            return `${s}.amazonaws.com`;
          }
          function partitional(s, _, u) {
            return `${s}.${u}`;
          }
          function regional(s, r) {
            return `${s}.${r}.amazonaws.com`;
          }
          function regionalPartitional(s, r, u) {
            return `${s}.${r}.${u}`;
          }
          const US_ISO_EXCEPTIONS = /* @__PURE__ */ new Set(["cloudhsm", "config", "states", "workspaces"]);
          if (region.startsWith("us-iso-") && US_ISO_EXCEPTIONS.has(service))
            switch (service) {
              case "states":
                return universal;
              default:
                return partitional;
            }
          const US_ISOB_EXCEPTIONS = /* @__PURE__ */ new Set(["dms", "states"]);
          if (region.startsWith("us-isob-") && US_ISOB_EXCEPTIONS.has(service))
            switch (service) {
              case "states":
                return universal;
              default:
                return partitional;
            }
          switch (service) {
            case "codedeploy":
              return region.startsWith("cn-") ? regionalPartitional : region.startsWith("us-iso") ? universal : regional;
            case "logs":
              return regionalPartitional;
            case "states":
              return regional;
            case "elasticmapreduce":
              return region.startsWith("cn-") ? partitional : universal;
            default:
              return universal;
          }
        }
        return determineConfiguration(serviceName)(serviceName, region, urlSuffix);
      }
      constructor() {
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Default[_a] = { fqn: "aws-cdk-lib.region_info.Default", version: "2.80.0" }, Default.VPC_ENDPOINT_SERVICE_NAME_PREFIX = "com.amazonaws.vpce", exports2.Default = Default;
    function extractSimpleName(serviceFqn) {
      const matches = serviceFqn.match(/^([^.]+)(?:(?:\.amazonaws\.com(?:\.cn)?)|(?:\.c2s\.ic\.gov)|(?:\.sc2s\.sgov\.gov))?$/);
      return matches ? matches[1] : void 0;
    }
  }
});

// node_modules/aws-cdk-lib/region-info/lib/aws-entities.js
var require_aws_entities = __commonJS({
  "node_modules/aws-cdk-lib/region-info/lib/aws-entities.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.partitionInformation = exports2.regionsBefore = exports2.before = exports2.AWS_SERVICES = exports2.AWS_REGIONS = exports2.AWS_REGIONS_AND_RULES = exports2.RULE_CLASSIC_PARTITION_BECOMES_OPT_IN = exports2.RULE_S3_WEBSITE_REGIONAL_SUBDOMAIN = void 0, exports2.RULE_S3_WEBSITE_REGIONAL_SUBDOMAIN = Symbol("S3_WEBSITE_REGIONAL_SUBDOMAIN"), exports2.RULE_CLASSIC_PARTITION_BECOMES_OPT_IN = Symbol("CLASSIC_PARTITION_BECOMES_OPT_IN"), exports2.AWS_REGIONS_AND_RULES = ["us-east-1", "eu-west-1", "us-west-1", "ap-southeast-1", "ap-northeast-1", "us-gov-west-1", "us-west-2", "sa-east-1", "ap-southeast-2", exports2.RULE_S3_WEBSITE_REGIONAL_SUBDOMAIN, "cn-north-1", "us-iso-east-1", "eu-central-1", "ap-northeast-2", "ap-south-1", "us-east-2", "ca-central-1", "eu-west-2", "us-isob-east-1", "cn-northwest-1", "eu-west-3", "ap-northeast-3", "us-gov-east-1", "eu-north-1", exports2.RULE_CLASSIC_PARTITION_BECOMES_OPT_IN, "ap-east-1", "me-south-1", "eu-south-1", "af-south-1", "us-iso-west-1", "eu-south-2", "ap-southeast-3", "me-central-1", "ap-south-2", "eu-central-2"], exports2.AWS_REGIONS = exports2.AWS_REGIONS_AND_RULES.filter((x) => typeof x == "string").sort(), exports2.AWS_SERVICES = ["application-autoscaling", "autoscaling", "codedeploy", "ec2", "events", "lambda", "logs", "s3", "ssm", "sns", "sqs", "states"].sort();
    function before(region, ruleOrRegion) {
      const ruleIx = exports2.AWS_REGIONS_AND_RULES.indexOf(ruleOrRegion);
      if (ruleIx === -1)
        throw new Error(`Unknown rule: ${String(ruleOrRegion)}`);
      const regionIx = exports2.AWS_REGIONS_AND_RULES.indexOf(region);
      return regionIx === -1 ? false : regionIx < ruleIx;
    }
    exports2.before = before;
    function regionsBefore(ruleOrRegion) {
      const ruleIx = exports2.AWS_REGIONS_AND_RULES.indexOf(ruleOrRegion);
      if (ruleIx === -1)
        throw new Error(`Unknown rule: ${String(ruleOrRegion)}`);
      return exports2.AWS_REGIONS_AND_RULES.slice(0, ruleIx).filter((entry) => typeof entry == "string").sort();
    }
    exports2.regionsBefore = regionsBefore;
    var PARTITION_MAP = { default: { partition: "aws", domainSuffix: "amazonaws.com" }, "cn-": { partition: "aws-cn", domainSuffix: "amazonaws.com.cn" }, "us-gov-": { partition: "aws-us-gov", domainSuffix: "amazonaws.com" }, "us-iso-": { partition: "aws-iso", domainSuffix: "c2s.ic.gov" }, "us-isob-": { partition: "aws-iso-b", domainSuffix: "sc2s.sgov.gov" } };
    function partitionInformation(region) {
      for (const [prefix, info] of Object.entries(PARTITION_MAP))
        if (region.startsWith(prefix))
          return info;
      return PARTITION_MAP.default;
    }
    exports2.partitionInformation = partitionInformation;
  }
});

// node_modules/aws-cdk-lib/region-info/lib/fact.js
var require_fact = __commonJS({
  "node_modules/aws-cdk-lib/region-info/lib/fact.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FactName = exports2.Fact = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var aws_entities_1 = require_aws_entities();
    var Fact = class {
      static get regions() {
        return Array.from(aws_entities_1.AWS_REGIONS);
      }
      static find(region, name) {
        const regionFacts = this.database[region];
        return regionFacts && regionFacts[name];
      }
      static requireFact(region, name) {
        const foundFact = this.find(region, name);
        if (!foundFact)
          throw new Error(`No fact ${name} could be found for region: ${region} and name: ${name}`);
        return foundFact;
      }
      static register(fact, allowReplacing = false) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_region_info_IFact(fact);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.register), error;
        }
        const regionFacts = this.database[fact.region] || (this.database[fact.region] = {});
        if (fact.name in regionFacts && regionFacts[fact.name] !== fact.value && !allowReplacing)
          throw new Error(`Region ${fact.region} already has a fact ${fact.name}, with value ${regionFacts[fact.name]}`);
        fact.value !== void 0 && (regionFacts[fact.name] = fact.value);
      }
      static unregister(region, name, value) {
        const regionFacts = this.database[region] || {};
        if (name in regionFacts && value && regionFacts[name] !== value)
          throw new Error(`Attempted to remove ${name} from ${region} with value ${value}, but the fact's value is ${regionFacts[name]}`);
        delete regionFacts[name];
      }
      constructor() {
        throw new Error("Use the static methods of Fact instead!");
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Fact[_a] = { fqn: "aws-cdk-lib.region_info.Fact", version: "2.80.0" }, Fact.database = {}, exports2.Fact = Fact;
    var FactName = class {
      static cloudwatchLambdaInsightsVersion(version, arch) {
        return `cloudwatch-lambda-insights-version:${version.split(".").join("_") + `_${arch ?? "x86_64"}`}`;
      }
      static servicePrincipal(service) {
        return `service-principal:${service.replace(/\.amazonaws\.com(\.cn)?$/, "")}`;
      }
      static adotLambdaLayer(type, version, architecture) {
        return `adot-lambda-layer:${type + "_" + version.split(".").join("_") + "_" + architecture}`;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, FactName[_b] = { fqn: "aws-cdk-lib.region_info.FactName", version: "2.80.0" }, FactName.PARTITION = "partition", FactName.DOMAIN_SUFFIX = "domainSuffix", FactName.CDK_METADATA_RESOURCE_AVAILABLE = "cdk:metadata-resource:available", FactName.IS_OPT_IN_REGION = "aws:is-opt-in-region", FactName.S3_STATIC_WEBSITE_ENDPOINT = "s3-static-website:endpoint", FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID = "s3-static-website:route-53-hosted-zone-id", FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID = "ebs-environment:route-53-hosted-zone-id", FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX = "vpcEndpointServiceNamePrefix", FactName.ELBV2_ACCOUNT = "elbv2Account", FactName.DLC_REPOSITORY_ACCOUNT = "dlcRepositoryAccount", FactName.APPMESH_ECR_ACCOUNT = "appMeshRepositoryAccount", FactName.FIREHOSE_CIDR_BLOCK = "firehoseCidrBlock", FactName.DEFAULT_CR_NODE_VERSION = "defaultCrNodeVersion", exports2.FactName = FactName;
  }
});

// node_modules/aws-cdk-lib/region-info/lib/region-info.js
var require_region_info = __commonJS({
  "node_modules/aws-cdk-lib/region-info/lib/region-info.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.RegionInfo = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var aws_entities_1 = require_aws_entities();
    var fact_1 = require_fact();
    var RegionInfo = class _RegionInfo {
      static get regions() {
        return fact_1.Fact.regions.map(_RegionInfo.get);
      }
      static regionMap(factName) {
        const ret = {};
        for (const regionInfo of _RegionInfo.regions) {
          const fact = fact_1.Fact.find(regionInfo.name, factName);
          fact && (ret[regionInfo.name] = fact);
        }
        return ret;
      }
      static limitedRegionMap(factName, partitions) {
        const ret = {};
        for (const [region, value] of Object.entries(_RegionInfo.regionMap(factName)))
          partitions.includes((0, aws_entities_1.partitionInformation)(region).partition) && (ret[region] = value);
        return ret;
      }
      static get(name) {
        return new _RegionInfo(name);
      }
      constructor(name) {
        this.name = name;
      }
      get cdkMetadataResourceAvailable() {
        return fact_1.Fact.find(this.name, fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE) === "YES";
      }
      get isOptInRegion() {
        return fact_1.Fact.find(this.name, fact_1.FactName.IS_OPT_IN_REGION) === "YES";
      }
      get domainSuffix() {
        return fact_1.Fact.find(this.name, fact_1.FactName.DOMAIN_SUFFIX);
      }
      get partition() {
        return fact_1.Fact.find(this.name, fact_1.FactName.PARTITION);
      }
      get s3StaticWebsiteEndpoint() {
        return fact_1.Fact.find(this.name, fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT);
      }
      get s3StaticWebsiteHostedZoneId() {
        return fact_1.Fact.find(this.name, fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID);
      }
      get ebsEnvEndpointHostedZoneId() {
        return fact_1.Fact.find(this.name, fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID);
      }
      get vpcEndpointServiceNamePrefix() {
        return fact_1.Fact.find(this.name, fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX);
      }
      servicePrincipal(service) {
        return fact_1.Fact.find(this.name, fact_1.FactName.servicePrincipal(service));
      }
      get elbv2Account() {
        return fact_1.Fact.find(this.name, fact_1.FactName.ELBV2_ACCOUNT);
      }
      get dlcRepositoryAccount() {
        return fact_1.Fact.find(this.name, fact_1.FactName.DLC_REPOSITORY_ACCOUNT);
      }
      cloudwatchLambdaInsightsArn(insightsVersion, architecture) {
        return fact_1.Fact.find(this.name, fact_1.FactName.cloudwatchLambdaInsightsVersion(insightsVersion, architecture));
      }
      get appMeshRepositoryAccount() {
        return fact_1.Fact.find(this.name, fact_1.FactName.APPMESH_ECR_ACCOUNT);
      }
      get firehoseCidrBlock() {
        return fact_1.Fact.find(this.name, fact_1.FactName.FIREHOSE_CIDR_BLOCK);
      }
      adotLambdaLayerArn(type, version, architecture) {
        return fact_1.Fact.find(this.name, fact_1.FactName.adotLambdaLayer(type, version, architecture));
      }
    };
    _a = JSII_RTTI_SYMBOL_1, RegionInfo[_a] = { fqn: "aws-cdk-lib.region_info.RegionInfo", version: "2.80.0" }, exports2.RegionInfo = RegionInfo;
  }
});

// node_modules/aws-cdk-lib/region-info/lib/built-ins.generated.js
var require_built_ins_generated = __commonJS({
  "node_modules/aws-cdk-lib/region-info/lib/built-ins.generated.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.BuiltIns = void 0;
    var fact_1 = require_fact();
    var BuiltIns = class {
      static register() {
        fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.PARTITION, value: "aws" }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.DOMAIN_SUFFIX, value: "amazonaws.com" }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "YES" }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.IS_OPT_IN_REGION, value: "YES" }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website.af-south-1.amazonaws.com" }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "Z11KHD8FBVPUYU" }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "Z1EI3BVKMKK4AM" }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.ELBV2_ACCOUNT, value: "098369216593" }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: "924023996002" }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs16.x" }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.FIREHOSE_CIDR_BLOCK, value: "13.244.121.224/27" }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "com.amazonaws.vpce" }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.af-south-1.amazonaws.com" }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.af-south-1.amazonaws.com" }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.servicePrincipal("states"), value: "states.af-south-1.amazonaws.com" }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: "arn:aws:lambda:af-south-1:012438385374:layer:LambdaInsightsExtension:13" }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: "arn:aws:lambda:af-south-1:012438385374:layer:LambdaInsightsExtension:11" }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: "arn:aws:lambda:af-south-1:012438385374:layer:LambdaInsightsExtension:9" }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: "arn:aws:lambda:af-south-1:012438385374:layer:LambdaInsightsExtension:8" }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "af-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.PARTITION, value: "aws" }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.DOMAIN_SUFFIX, value: "amazonaws.com" }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "YES" }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.IS_OPT_IN_REGION, value: "YES" }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website.ap-east-1.amazonaws.com" }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "ZNB98KWMFR0R6" }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "ZPWYUBWRU171A" }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.ELBV2_ACCOUNT, value: "754344448648" }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: "871362719292" }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: "856666278305" }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs16.x" }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.FIREHOSE_CIDR_BLOCK, value: "18.162.221.32/27" }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "com.amazonaws.vpce" }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.ap-east-1.amazonaws.com" }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.ap-east-1.amazonaws.com" }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.servicePrincipal("states"), value: "states.ap-east-1.amazonaws.com" }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: "arn:aws:lambda:ap-east-1:519774774795:layer:LambdaInsightsExtension:13" }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: "arn:aws:lambda:ap-east-1:519774774795:layer:LambdaInsightsExtension:11" }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: "arn:aws:lambda:ap-east-1:519774774795:layer:LambdaInsightsExtension:9" }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: "arn:aws:lambda:ap-east-1:519774774795:layer:LambdaInsightsExtension:8" }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.PARTITION, value: "aws" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.DOMAIN_SUFFIX, value: "amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "YES" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.IS_OPT_IN_REGION, value: "NO" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website-ap-northeast-1.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "Z2M4EHUR26P7ZW" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "Z1R25G3KIG2GBW" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.ELBV2_ACCOUNT, value: "582318560864" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: "763104351884" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: "840364872350" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs16.x" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.FIREHOSE_CIDR_BLOCK, value: "13.113.196.224/27" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "com.amazonaws.vpce" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.ap-northeast-1.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.ap-northeast-1.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.servicePrincipal("states"), value: "states.ap-northeast-1.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-1:580247275435:layer:LambdaInsightsExtension:31" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: "arn:aws:lambda:ap-northeast-1:580247275435:layer:LambdaInsightsExtension-Arm64:2" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-1:580247275435:layer:LambdaInsightsExtension:25" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: "arn:aws:lambda:ap-northeast-1:580247275435:layer:LambdaInsightsExtension-Arm64:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-1:580247275435:layer:LambdaInsightsExtension:23" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-1:580247275435:layer:LambdaInsightsExtension:14" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-1:580247275435:layer:LambdaInsightsExtension:12" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-1:580247275435:layer:LambdaInsightsExtension:11" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-1:580247275435:layer:LambdaInsightsExtension:2" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-19-0:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-19-0:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-7-0:2" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-7-0:2" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-python-amd64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-python-arm64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-python-amd64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-python-arm64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-python-amd64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-python-arm64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-python-amd64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-python-arm64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-collector-amd64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-collector-arm64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-collector-amd64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-collector-arm64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-collector-amd64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-collector-arm64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-collector-amd64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-collector-arm64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-collector-amd64-ver-0-62-1:1" }), fact_1.Fact.register({ region: "ap-northeast-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: "arn:aws:lambda:ap-northeast-1:901920570463:layer:aws-otel-collector-arm64-ver-0-62-1:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.PARTITION, value: "aws" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.DOMAIN_SUFFIX, value: "amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "YES" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.IS_OPT_IN_REGION, value: "NO" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website.ap-northeast-2.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "Z3W03O7B5YMIYP" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "Z3JE5OI70TWKCP" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.ELBV2_ACCOUNT, value: "600734575887" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: "763104351884" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: "840364872350" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs16.x" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.FIREHOSE_CIDR_BLOCK, value: "13.209.1.64/27" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "com.amazonaws.vpce" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.ap-northeast-2.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.ap-northeast-2.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.servicePrincipal("states"), value: "states.ap-northeast-2.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-2:580247275435:layer:LambdaInsightsExtension:20" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-2:580247275435:layer:LambdaInsightsExtension:18" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-2:580247275435:layer:LambdaInsightsExtension:16" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-2:580247275435:layer:LambdaInsightsExtension:14" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-2:580247275435:layer:LambdaInsightsExtension:12" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-2:580247275435:layer:LambdaInsightsExtension:11" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-2:580247275435:layer:LambdaInsightsExtension:2" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-19-0:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-19-0:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-java-agent-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-java-agent-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-java-agent-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-java-agent-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-java-agent-amd64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-java-agent-arm64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-nodejs-amd64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-nodejs-arm64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-nodejs-amd64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-nodejs-arm64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-nodejs-amd64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-nodejs-arm64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-nodejs-amd64-ver-1-7-0:2" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-nodejs-arm64-ver-1-7-0:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-python-amd64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-python-arm64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-python-amd64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-python-arm64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-python-amd64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-python-arm64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-python-amd64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-python-arm64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-collector-amd64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-collector-arm64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-collector-amd64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-collector-arm64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-collector-amd64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-collector-arm64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-collector-amd64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-collector-arm64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-collector-amd64-ver-0-62-1:1" }), fact_1.Fact.register({ region: "ap-northeast-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: "arn:aws:lambda:ap-northeast-2:901920570463:layer:aws-otel-collector-arm64-ver-0-62-1:1" }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.PARTITION, value: "aws" }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.DOMAIN_SUFFIX, value: "amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "NO" }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.IS_OPT_IN_REGION, value: "NO" }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website.ap-northeast-3.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "Z2YQB5RD63NC85" }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "ZNE5GEY1TIAGY" }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.ELBV2_ACCOUNT, value: "383597477331" }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: "840364872350" }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs16.x" }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.FIREHOSE_CIDR_BLOCK, value: "13.208.177.192/27" }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "com.amazonaws.vpce" }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.ap-northeast-3.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.ap-northeast-3.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.servicePrincipal("states"), value: "states.ap-northeast-3.amazonaws.com" }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-3:194566237122:layer:LambdaInsightsExtension:2" }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: "arn:aws:lambda:ap-northeast-3:194566237122:layer:LambdaInsightsExtension:1" }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-northeast-3", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.PARTITION, value: "aws" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.DOMAIN_SUFFIX, value: "amazonaws.com" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "YES" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.IS_OPT_IN_REGION, value: "NO" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website.ap-south-1.amazonaws.com" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "Z11RGJOFQNVJUP" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "Z18NTBI3Y7N9TZ" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.ELBV2_ACCOUNT, value: "718504428378" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: "763104351884" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: "840364872350" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs16.x" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.FIREHOSE_CIDR_BLOCK, value: "13.232.67.32/27" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "com.amazonaws.vpce" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.ap-south-1.amazonaws.com" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.ap-south-1.amazonaws.com" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.servicePrincipal("states"), value: "states.ap-south-1.amazonaws.com" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: "arn:aws:lambda:ap-south-1:580247275435:layer:LambdaInsightsExtension:21" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: "arn:aws:lambda:ap-south-1:580247275435:layer:LambdaInsightsExtension-Arm64:2" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: "arn:aws:lambda:ap-south-1:580247275435:layer:LambdaInsightsExtension:18" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: "arn:aws:lambda:ap-south-1:580247275435:layer:LambdaInsightsExtension-Arm64:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: "arn:aws:lambda:ap-south-1:580247275435:layer:LambdaInsightsExtension:16" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: "arn:aws:lambda:ap-south-1:580247275435:layer:LambdaInsightsExtension:14" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: "arn:aws:lambda:ap-south-1:580247275435:layer:LambdaInsightsExtension:12" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: "arn:aws:lambda:ap-south-1:580247275435:layer:LambdaInsightsExtension:11" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: "arn:aws:lambda:ap-south-1:580247275435:layer:LambdaInsightsExtension:2" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-19-0:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-19-0:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-7-0:2" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-7-0:2" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-python-amd64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-python-arm64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-python-amd64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-python-arm64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-python-amd64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-python-arm64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-python-amd64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-python-arm64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-collector-amd64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-collector-arm64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-collector-amd64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-collector-arm64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-collector-amd64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-collector-arm64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-collector-amd64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-collector-arm64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-collector-amd64-ver-0-62-1:1" }), fact_1.Fact.register({ region: "ap-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: "arn:aws:lambda:ap-south-1:901920570463:layer:aws-otel-collector-arm64-ver-0-62-1:1" }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.PARTITION, value: "aws" }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.DOMAIN_SUFFIX, value: "amazonaws.com" }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "NO" }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.IS_OPT_IN_REGION, value: "YES" }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website.ap-south-2.amazonaws.com" }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "Z02976202B4EZMXIPMXF7" }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "" }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.ELBV2_ACCOUNT, value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs16.x" }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "com.amazonaws.vpce" }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.ap-south-2.amazonaws.com" }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.ap-south-2.amazonaws.com" }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.servicePrincipal("states"), value: "states.ap-south-2.amazonaws.com" }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: "arn:aws:lambda:ap-south-2:891564319516:layer:LambdaInsightsExtension:6" }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-south-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.PARTITION, value: "aws" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.DOMAIN_SUFFIX, value: "amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "YES" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.IS_OPT_IN_REGION, value: "NO" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website-ap-southeast-1.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "Z3O0J2DXBE1FTB" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "Z16FZ9L249IFLT" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.ELBV2_ACCOUNT, value: "114774131450" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: "763104351884" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: "840364872350" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs16.x" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.FIREHOSE_CIDR_BLOCK, value: "13.228.64.192/27" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "com.amazonaws.vpce" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.ap-southeast-1.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.ap-southeast-1.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.servicePrincipal("states"), value: "states.ap-southeast-1.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-1:580247275435:layer:LambdaInsightsExtension:21" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: "arn:aws:lambda:ap-southeast-1:580247275435:layer:LambdaInsightsExtension-Arm64:2" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-1:580247275435:layer:LambdaInsightsExtension:18" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: "arn:aws:lambda:ap-southeast-1:580247275435:layer:LambdaInsightsExtension-Arm64:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-1:580247275435:layer:LambdaInsightsExtension:16" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-1:580247275435:layer:LambdaInsightsExtension:14" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-1:580247275435:layer:LambdaInsightsExtension:12" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-1:580247275435:layer:LambdaInsightsExtension:11" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-1:580247275435:layer:LambdaInsightsExtension:2" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-19-0:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-19-0:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-7-0:2" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-7-0:2" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-python-amd64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-python-arm64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-python-amd64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-python-arm64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-python-amd64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-python-arm64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-python-amd64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-python-arm64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-collector-amd64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-collector-arm64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-collector-amd64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-collector-arm64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-collector-amd64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-collector-arm64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-collector-amd64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-collector-arm64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-collector-amd64-ver-0-62-1:1" }), fact_1.Fact.register({ region: "ap-southeast-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: "arn:aws:lambda:ap-southeast-1:901920570463:layer:aws-otel-collector-arm64-ver-0-62-1:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.PARTITION, value: "aws" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.DOMAIN_SUFFIX, value: "amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "YES" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.IS_OPT_IN_REGION, value: "NO" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website-ap-southeast-2.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "Z1WCIGYICN2BYD" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "Z2PCDNR3VC2G1N" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.ELBV2_ACCOUNT, value: "783225319266" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: "763104351884" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: "840364872350" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs16.x" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.FIREHOSE_CIDR_BLOCK, value: "13.210.67.224/27" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "com.amazonaws.vpce" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.ap-southeast-2.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.ap-southeast-2.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.servicePrincipal("states"), value: "states.ap-southeast-2.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-2:580247275435:layer:LambdaInsightsExtension:21" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: "arn:aws:lambda:ap-southeast-2:580247275435:layer:LambdaInsightsExtension-Arm64:2" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-2:580247275435:layer:LambdaInsightsExtension:18" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: "arn:aws:lambda:ap-southeast-2:580247275435:layer:LambdaInsightsExtension-Arm64:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-2:580247275435:layer:LambdaInsightsExtension:16" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-2:580247275435:layer:LambdaInsightsExtension:14" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-2:580247275435:layer:LambdaInsightsExtension:12" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-2:580247275435:layer:LambdaInsightsExtension:11" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-2:580247275435:layer:LambdaInsightsExtension:2" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-19-0:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-19-0:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-java-agent-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-java-agent-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-java-agent-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-java-agent-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-java-agent-amd64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-java-agent-arm64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-nodejs-amd64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-nodejs-arm64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-nodejs-amd64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-nodejs-arm64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-nodejs-amd64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-nodejs-arm64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-nodejs-amd64-ver-1-7-0:2" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-nodejs-arm64-ver-1-7-0:2" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-python-amd64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-python-arm64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-python-amd64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-python-arm64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-python-amd64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-python-arm64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-python-amd64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-python-arm64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-collector-amd64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-collector-arm64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-collector-amd64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-collector-arm64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-collector-amd64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-collector-arm64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-collector-amd64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-collector-arm64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-collector-amd64-ver-0-62-1:1" }), fact_1.Fact.register({ region: "ap-southeast-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: "arn:aws:lambda:ap-southeast-2:901920570463:layer:aws-otel-collector-arm64-ver-0-62-1:1" }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.PARTITION, value: "aws" }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.DOMAIN_SUFFIX, value: "amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "NO" }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.IS_OPT_IN_REGION, value: "YES" }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website.ap-southeast-3.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "Z01846753K324LI26A3VV" }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "" }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.ELBV2_ACCOUNT, value: "589379963580" }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: "909464085924" }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs16.x" }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.FIREHOSE_CIDR_BLOCK, value: "108.136.221.64/27" }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "com.amazonaws.vpce" }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.ap-southeast-3.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.ap-southeast-3.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.servicePrincipal("states"), value: "states.ap-southeast-3.amazonaws.com" }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: "arn:aws:lambda:ap-southeast-3:439286490199:layer:LambdaInsightsExtension:8" }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ap-southeast-3", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.PARTITION, value: "aws" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.DOMAIN_SUFFIX, value: "amazonaws.com" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "YES" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.IS_OPT_IN_REGION, value: "NO" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website.ca-central-1.amazonaws.com" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "Z1QDHH18159H29" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "ZJFCZL7SSZB5I" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.ELBV2_ACCOUNT, value: "985666609251" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: "763104351884" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: "840364872350" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs16.x" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.FIREHOSE_CIDR_BLOCK, value: "35.183.92.128/27" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "com.amazonaws.vpce" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.ca-central-1.amazonaws.com" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.ca-central-1.amazonaws.com" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.servicePrincipal("states"), value: "states.ca-central-1.amazonaws.com" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: "arn:aws:lambda:ca-central-1:580247275435:layer:LambdaInsightsExtension:20" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: "arn:aws:lambda:ca-central-1:580247275435:layer:LambdaInsightsExtension:18" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: "arn:aws:lambda:ca-central-1:580247275435:layer:LambdaInsightsExtension:16" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: "arn:aws:lambda:ca-central-1:580247275435:layer:LambdaInsightsExtension:14" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: "arn:aws:lambda:ca-central-1:580247275435:layer:LambdaInsightsExtension:12" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: "arn:aws:lambda:ca-central-1:580247275435:layer:LambdaInsightsExtension:11" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: "arn:aws:lambda:ca-central-1:580247275435:layer:LambdaInsightsExtension:2" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-19-0:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-19-0:2" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-7-0:2" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-7-0:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-python-amd64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-python-arm64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-python-amd64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-python-arm64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-python-amd64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-python-arm64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-python-amd64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-python-arm64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-collector-amd64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-collector-arm64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-collector-amd64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-collector-arm64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-collector-amd64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-collector-arm64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-collector-amd64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-collector-arm64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-collector-amd64-ver-0-62-1:1" }), fact_1.Fact.register({ region: "ca-central-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: "arn:aws:lambda:ca-central-1:901920570463:layer:aws-otel-collector-arm64-ver-0-62-1:1" }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.PARTITION, value: "aws-cn" }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.DOMAIN_SUFFIX, value: "amazonaws.com.cn" }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "YES" }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.IS_OPT_IN_REGION, value: "NO" }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website.cn-north-1.amazonaws.com.cn" }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "" }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "" }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.ELBV2_ACCOUNT, value: "638102146993" }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: "727897471807" }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: "919366029133" }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs16.x" }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.FIREHOSE_CIDR_BLOCK, value: "52.81.151.32/27" }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "cn.com.amazonaws.vpce" }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.cn-north-1.amazonaws.com.cn" }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.cn-north-1.amazonaws.com.cn" }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.servicePrincipal("states"), value: "states.cn-north-1.amazonaws.com" }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: "arn:aws-cn:lambda:cn-north-1:488211338238:layer:LambdaInsightsExtension:14" }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: "arn:aws-cn:lambda:cn-north-1:488211338238:layer:LambdaInsightsExtension:11" }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: "arn:aws-cn:lambda:cn-north-1:488211338238:layer:LambdaInsightsExtension:9" }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: "arn:aws-cn:lambda:cn-north-1:488211338238:layer:LambdaInsightsExtension:8" }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-north-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.PARTITION, value: "aws-cn" }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.DOMAIN_SUFFIX, value: "amazonaws.com.cn" }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "YES" }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.IS_OPT_IN_REGION, value: "NO" }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website.cn-northwest-1.amazonaws.com.cn" }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "Z282HJ1KT0DH03" }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "" }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.ELBV2_ACCOUNT, value: "037604701340" }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: "727897471807" }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: "919830735681" }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs16.x" }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.FIREHOSE_CIDR_BLOCK, value: "161.189.23.64/27" }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "cn.com.amazonaws.vpce" }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.cn-northwest-1.amazonaws.com.cn" }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.cn-northwest-1.amazonaws.com.cn" }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.servicePrincipal("states"), value: "states.cn-northwest-1.amazonaws.com" }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: "arn:aws-cn:lambda:cn-northwest-1:488211338238:layer:LambdaInsightsExtension:14" }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: "arn:aws-cn:lambda:cn-northwest-1:488211338238:layer:LambdaInsightsExtension:11" }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: "arn:aws-cn:lambda:cn-northwest-1:488211338238:layer:LambdaInsightsExtension:9" }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: "arn:aws-cn:lambda:cn-northwest-1:488211338238:layer:LambdaInsightsExtension:8" }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "cn-northwest-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.PARTITION, value: "aws" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.DOMAIN_SUFFIX, value: "amazonaws.com" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "YES" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.IS_OPT_IN_REGION, value: "NO" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website.eu-central-1.amazonaws.com" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "Z21DNDUVLTQW6Q" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "Z1FRNW7UH4DEZJ" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.ELBV2_ACCOUNT, value: "054676820928" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: "763104351884" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: "840364872350" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs16.x" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.FIREHOSE_CIDR_BLOCK, value: "35.158.127.160/27" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "com.amazonaws.vpce" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.eu-central-1.amazonaws.com" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.eu-central-1.amazonaws.com" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.servicePrincipal("states"), value: "states.eu-central-1.amazonaws.com" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: "arn:aws:lambda:eu-central-1:580247275435:layer:LambdaInsightsExtension:21" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: "arn:aws:lambda:eu-central-1:580247275435:layer:LambdaInsightsExtension-Arm64:2" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: "arn:aws:lambda:eu-central-1:580247275435:layer:LambdaInsightsExtension:18" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: "arn:aws:lambda:eu-central-1:580247275435:layer:LambdaInsightsExtension-Arm64:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: "arn:aws:lambda:eu-central-1:580247275435:layer:LambdaInsightsExtension:16" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: "arn:aws:lambda:eu-central-1:580247275435:layer:LambdaInsightsExtension:14" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: "arn:aws:lambda:eu-central-1:580247275435:layer:LambdaInsightsExtension:12" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: "arn:aws:lambda:eu-central-1:580247275435:layer:LambdaInsightsExtension:11" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: "arn:aws:lambda:eu-central-1:580247275435:layer:LambdaInsightsExtension:2" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-19-0:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-19-0:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-7-0:2" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-7-0:2" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-python-amd64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-python-arm64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-python-amd64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-python-arm64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-python-amd64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-python-arm64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-python-amd64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-python-arm64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-collector-amd64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-collector-arm64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-collector-amd64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-collector-arm64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-collector-amd64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-collector-arm64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-collector-amd64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-collector-arm64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-collector-amd64-ver-0-62-1:1" }), fact_1.Fact.register({ region: "eu-central-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: "arn:aws:lambda:eu-central-1:901920570463:layer:aws-otel-collector-arm64-ver-0-62-1:1" }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.PARTITION, value: "aws" }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.DOMAIN_SUFFIX, value: "amazonaws.com" }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "NO" }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.IS_OPT_IN_REGION, value: "YES" }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website.eu-central-2.amazonaws.com" }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "Z030506016YDQGETNASS" }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "" }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.ELBV2_ACCOUNT, value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs16.x" }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.FIREHOSE_CIDR_BLOCK, value: "16.62.183.32/27" }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "com.amazonaws.vpce" }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.eu-central-2.amazonaws.com" }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.eu-central-2.amazonaws.com" }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.servicePrincipal("states"), value: "states.eu-central-2.amazonaws.com" }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: "arn:aws:lambda:eu-central-2:033019950311:layer:LambdaInsightsExtension:7" }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-central-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.PARTITION, value: "aws" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.DOMAIN_SUFFIX, value: "amazonaws.com" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "YES" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.IS_OPT_IN_REGION, value: "NO" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website.eu-north-1.amazonaws.com" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "Z3BAZG2TWCNX0D" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "Z23GO28BZ5AETM" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.ELBV2_ACCOUNT, value: "897822967062" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: "763104351884" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: "840364872350" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs16.x" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.FIREHOSE_CIDR_BLOCK, value: "13.53.63.224/27" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "com.amazonaws.vpce" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.eu-north-1.amazonaws.com" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.eu-north-1.amazonaws.com" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.servicePrincipal("states"), value: "states.eu-north-1.amazonaws.com" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: "arn:aws:lambda:eu-north-1:580247275435:layer:LambdaInsightsExtension:20" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: "arn:aws:lambda:eu-north-1:580247275435:layer:LambdaInsightsExtension:18" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: "arn:aws:lambda:eu-north-1:580247275435:layer:LambdaInsightsExtension:16" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: "arn:aws:lambda:eu-north-1:580247275435:layer:LambdaInsightsExtension:14" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: "arn:aws:lambda:eu-north-1:580247275435:layer:LambdaInsightsExtension:12" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: "arn:aws:lambda:eu-north-1:580247275435:layer:LambdaInsightsExtension:11" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: "arn:aws:lambda:eu-north-1:580247275435:layer:LambdaInsightsExtension:2" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-19-0:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-19-0:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-7-0:2" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-7-0:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-python-amd64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-python-arm64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-python-amd64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-python-arm64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-python-amd64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-python-arm64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-python-amd64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-python-arm64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-collector-amd64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-collector-arm64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-collector-amd64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-collector-arm64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-collector-amd64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-collector-arm64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-collector-amd64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-collector-arm64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-collector-amd64-ver-0-62-1:1" }), fact_1.Fact.register({ region: "eu-north-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: "arn:aws:lambda:eu-north-1:901920570463:layer:aws-otel-collector-arm64-ver-0-62-1:1" }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.PARTITION, value: "aws" }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.DOMAIN_SUFFIX, value: "amazonaws.com" }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "YES" }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.IS_OPT_IN_REGION, value: "YES" }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website.eu-south-1.amazonaws.com" }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "Z3IXVV8C73GIO3" }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "Z10VDYYOA2JFKM" }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.ELBV2_ACCOUNT, value: "635631232127" }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: "422531588944" }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs16.x" }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.FIREHOSE_CIDR_BLOCK, value: "15.161.135.128/27" }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "com.amazonaws.vpce" }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.eu-south-1.amazonaws.com" }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.eu-south-1.amazonaws.com" }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.servicePrincipal("states"), value: "states.eu-south-1.amazonaws.com" }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: "arn:aws:lambda:eu-south-1:339249233099:layer:LambdaInsightsExtension:13" }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: "arn:aws:lambda:eu-south-1:339249233099:layer:LambdaInsightsExtension:11" }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: "arn:aws:lambda:eu-south-1:339249233099:layer:LambdaInsightsExtension:9" }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: "arn:aws:lambda:eu-south-1:339249233099:layer:LambdaInsightsExtension:8" }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.PARTITION, value: "aws" }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.DOMAIN_SUFFIX, value: "amazonaws.com" }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "NO" }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.IS_OPT_IN_REGION, value: "YES" }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website.eu-south-2.amazonaws.com" }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "Z0081959F7139GRJC19J" }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "" }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.ELBV2_ACCOUNT, value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs16.x" }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.FIREHOSE_CIDR_BLOCK, value: "18.100.71.96/27" }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "com.amazonaws.vpce" }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.eu-south-2.amazonaws.com" }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.eu-south-2.amazonaws.com" }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.servicePrincipal("states"), value: "states.eu-south-2.amazonaws.com" }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: "arn:aws:lambda:eu-south-2:352183217350:layer:LambdaInsightsExtension:2" }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-south-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.PARTITION, value: "aws" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.DOMAIN_SUFFIX, value: "amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "YES" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.IS_OPT_IN_REGION, value: "NO" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website-eu-west-1.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "Z1BKCTXD74EZPE" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "Z2NYPWQ7DFZAZH" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.ELBV2_ACCOUNT, value: "156460612806" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: "763104351884" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: "840364872350" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs16.x" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.FIREHOSE_CIDR_BLOCK, value: "52.19.239.192/27" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "com.amazonaws.vpce" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.eu-west-1.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.eu-west-1.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.servicePrincipal("states"), value: "states.eu-west-1.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: "arn:aws:lambda:eu-west-1:580247275435:layer:LambdaInsightsExtension:21" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: "arn:aws:lambda:eu-west-1:580247275435:layer:LambdaInsightsExtension-Arm64:2" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: "arn:aws:lambda:eu-west-1:580247275435:layer:LambdaInsightsExtension:18" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: "arn:aws:lambda:eu-west-1:580247275435:layer:LambdaInsightsExtension-Arm64:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: "arn:aws:lambda:eu-west-1:580247275435:layer:LambdaInsightsExtension:16" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: "arn:aws:lambda:eu-west-1:580247275435:layer:LambdaInsightsExtension:14" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: "arn:aws:lambda:eu-west-1:580247275435:layer:LambdaInsightsExtension:12" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: "arn:aws:lambda:eu-west-1:580247275435:layer:LambdaInsightsExtension:11" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: "arn:aws:lambda:eu-west-1:580247275435:layer:LambdaInsightsExtension:2" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-19-0:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-19-0:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-7-0:2" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-7-0:2" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-python-amd64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-python-arm64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-python-amd64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-python-arm64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-python-amd64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-python-arm64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-python-amd64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-python-arm64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-collector-amd64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-collector-arm64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-collector-amd64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-collector-arm64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-collector-amd64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-collector-arm64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-collector-amd64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-collector-arm64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-collector-amd64-ver-0-62-1:1" }), fact_1.Fact.register({ region: "eu-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: "arn:aws:lambda:eu-west-1:901920570463:layer:aws-otel-collector-arm64-ver-0-62-1:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.PARTITION, value: "aws" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.DOMAIN_SUFFIX, value: "amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "YES" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.IS_OPT_IN_REGION, value: "NO" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website.eu-west-2.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "Z3GKZC51ZF0DB4" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "Z1GKAAAUGATPF1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.ELBV2_ACCOUNT, value: "652711504416" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: "763104351884" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: "840364872350" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs16.x" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.FIREHOSE_CIDR_BLOCK, value: "18.130.1.96/27" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "com.amazonaws.vpce" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.eu-west-2.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.eu-west-2.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.servicePrincipal("states"), value: "states.eu-west-2.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: "arn:aws:lambda:eu-west-2:580247275435:layer:LambdaInsightsExtension:21" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: "arn:aws:lambda:eu-west-2:580247275435:layer:LambdaInsightsExtension-Arm64:2" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: "arn:aws:lambda:eu-west-2:580247275435:layer:LambdaInsightsExtension:18" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: "arn:aws:lambda:eu-west-2:580247275435:layer:LambdaInsightsExtension-Arm64:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: "arn:aws:lambda:eu-west-2:580247275435:layer:LambdaInsightsExtension:16" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: "arn:aws:lambda:eu-west-2:580247275435:layer:LambdaInsightsExtension:14" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: "arn:aws:lambda:eu-west-2:580247275435:layer:LambdaInsightsExtension:12" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: "arn:aws:lambda:eu-west-2:580247275435:layer:LambdaInsightsExtension:11" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: "arn:aws:lambda:eu-west-2:580247275435:layer:LambdaInsightsExtension:2" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-19-0:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-19-0:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-java-agent-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-java-agent-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-java-agent-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-java-agent-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-java-agent-amd64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-java-agent-arm64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-nodejs-amd64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-nodejs-arm64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-nodejs-amd64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-nodejs-arm64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-nodejs-amd64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-nodejs-arm64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-nodejs-amd64-ver-1-7-0:2" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-nodejs-arm64-ver-1-7-0:2" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-python-amd64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-python-arm64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-python-amd64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-python-arm64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-python-amd64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-python-arm64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-python-amd64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-python-arm64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-collector-amd64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-collector-arm64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-collector-amd64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-collector-arm64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-collector-amd64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-collector-arm64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-collector-amd64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-collector-arm64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-collector-amd64-ver-0-62-1:1" }), fact_1.Fact.register({ region: "eu-west-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: "arn:aws:lambda:eu-west-2:901920570463:layer:aws-otel-collector-arm64-ver-0-62-1:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.PARTITION, value: "aws" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.DOMAIN_SUFFIX, value: "amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "YES" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.IS_OPT_IN_REGION, value: "NO" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website.eu-west-3.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "Z3R1K369G5AVDG" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "Z5WN6GAYWG5OB" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.ELBV2_ACCOUNT, value: "009996457667" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: "763104351884" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: "840364872350" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs16.x" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.FIREHOSE_CIDR_BLOCK, value: "35.180.1.96/27" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "com.amazonaws.vpce" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.eu-west-3.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.eu-west-3.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.servicePrincipal("states"), value: "states.eu-west-3.amazonaws.com" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: "arn:aws:lambda:eu-west-3:580247275435:layer:LambdaInsightsExtension:20" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: "arn:aws:lambda:eu-west-3:580247275435:layer:LambdaInsightsExtension:18" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: "arn:aws:lambda:eu-west-3:580247275435:layer:LambdaInsightsExtension:16" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: "arn:aws:lambda:eu-west-3:580247275435:layer:LambdaInsightsExtension:14" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: "arn:aws:lambda:eu-west-3:580247275435:layer:LambdaInsightsExtension:12" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: "arn:aws:lambda:eu-west-3:580247275435:layer:LambdaInsightsExtension:11" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: "arn:aws:lambda:eu-west-3:580247275435:layer:LambdaInsightsExtension:2" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-19-0:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-19-0:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-java-agent-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-java-agent-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-java-agent-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-java-agent-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-java-agent-amd64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-java-agent-arm64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-nodejs-amd64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-nodejs-arm64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-nodejs-amd64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-nodejs-arm64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-nodejs-amd64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-nodejs-arm64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-nodejs-amd64-ver-1-7-0:2" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-nodejs-arm64-ver-1-7-0:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-python-amd64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-python-arm64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-python-amd64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-python-arm64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-python-amd64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-python-arm64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-python-amd64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-python-arm64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-collector-amd64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-collector-arm64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-collector-amd64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-collector-arm64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-collector-amd64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-collector-arm64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-collector-amd64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-collector-arm64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-collector-amd64-ver-0-62-1:1" }), fact_1.Fact.register({ region: "eu-west-3", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: "arn:aws:lambda:eu-west-3:901920570463:layer:aws-otel-collector-arm64-ver-0-62-1:1" }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.PARTITION, value: "aws" }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.DOMAIN_SUFFIX, value: "amazonaws.com" }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "NO" }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.IS_OPT_IN_REGION, value: "YES" }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website.me-central-1.amazonaws.com" }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "Z06143092I8HRXZRUZROF" }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "" }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.ELBV2_ACCOUNT, value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs16.x" }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "com.amazonaws.vpce" }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.me-central-1.amazonaws.com" }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.me-central-1.amazonaws.com" }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.servicePrincipal("states"), value: "states.me-central-1.amazonaws.com" }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: "arn:aws:lambda:me-central-1:732604637566:layer:LambdaInsightsExtension:6" }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-central-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.PARTITION, value: "aws" }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.DOMAIN_SUFFIX, value: "amazonaws.com" }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "YES" }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.IS_OPT_IN_REGION, value: "YES" }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website.me-south-1.amazonaws.com" }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "Z1MPMWCPA7YB62" }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "Z2BBTEKR2I36N2" }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.ELBV2_ACCOUNT, value: "076674570225" }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: "217643126080" }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: "772975370895" }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs16.x" }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.FIREHOSE_CIDR_BLOCK, value: "15.185.91.0/27" }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "com.amazonaws.vpce" }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.me-south-1.amazonaws.com" }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.me-south-1.amazonaws.com" }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.servicePrincipal("states"), value: "states.me-south-1.amazonaws.com" }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: "arn:aws:lambda:me-south-1:285320876703:layer:LambdaInsightsExtension:13" }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: "arn:aws:lambda:me-south-1:285320876703:layer:LambdaInsightsExtension:11" }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: "arn:aws:lambda:me-south-1:285320876703:layer:LambdaInsightsExtension:9" }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: "arn:aws:lambda:me-south-1:285320876703:layer:LambdaInsightsExtension:8" }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "me-south-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.PARTITION, value: "aws" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.DOMAIN_SUFFIX, value: "amazonaws.com" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "YES" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.IS_OPT_IN_REGION, value: "NO" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website-sa-east-1.amazonaws.com" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "Z7KQH4QJS55SO" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "Z10X7K2B4QSOFV" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.ELBV2_ACCOUNT, value: "507241528517" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: "763104351884" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: "840364872350" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs16.x" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.FIREHOSE_CIDR_BLOCK, value: "18.228.1.128/27" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "com.amazonaws.vpce" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.sa-east-1.amazonaws.com" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.sa-east-1.amazonaws.com" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.servicePrincipal("states"), value: "states.sa-east-1.amazonaws.com" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: "arn:aws:lambda:sa-east-1:580247275435:layer:LambdaInsightsExtension:20" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: "arn:aws:lambda:sa-east-1:580247275435:layer:LambdaInsightsExtension:18" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: "arn:aws:lambda:sa-east-1:580247275435:layer:LambdaInsightsExtension:16" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: "arn:aws:lambda:sa-east-1:580247275435:layer:LambdaInsightsExtension:14" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: "arn:aws:lambda:sa-east-1:580247275435:layer:LambdaInsightsExtension:12" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: "arn:aws:lambda:sa-east-1:580247275435:layer:LambdaInsightsExtension:11" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: "arn:aws:lambda:sa-east-1:580247275435:layer:LambdaInsightsExtension:2" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-19-0:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-19-0:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-7-0:2" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-7-0:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-python-amd64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-python-arm64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-python-amd64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-python-arm64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-python-amd64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-python-arm64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-python-amd64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-python-arm64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-collector-amd64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-collector-arm64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-collector-amd64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-collector-arm64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-collector-amd64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-collector-arm64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-collector-amd64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-collector-arm64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-collector-amd64-ver-0-62-1:1" }), fact_1.Fact.register({ region: "sa-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: "arn:aws:lambda:sa-east-1:901920570463:layer:aws-otel-collector-arm64-ver-0-62-1:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.PARTITION, value: "aws" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.DOMAIN_SUFFIX, value: "amazonaws.com" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "YES" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.IS_OPT_IN_REGION, value: "NO" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website-us-east-1.amazonaws.com" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "Z3AQBSTGFYJSTF" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "Z117KPS5GTRQ2G" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.ELBV2_ACCOUNT, value: "127311923021" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: "763104351884" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: "840364872350" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs16.x" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.FIREHOSE_CIDR_BLOCK, value: "52.70.63.192/27" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "com.amazonaws.vpce" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.us-east-1.amazonaws.com" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.us-east-1.amazonaws.com" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.servicePrincipal("states"), value: "states.us-east-1.amazonaws.com" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: "arn:aws:lambda:us-east-1:580247275435:layer:LambdaInsightsExtension:21" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: "arn:aws:lambda:us-east-1:580247275435:layer:LambdaInsightsExtension-Arm64:2" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: "arn:aws:lambda:us-east-1:580247275435:layer:LambdaInsightsExtension:18" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: "arn:aws:lambda:us-east-1:580247275435:layer:LambdaInsightsExtension-Arm64:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: "arn:aws:lambda:us-east-1:580247275435:layer:LambdaInsightsExtension:16" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: "arn:aws:lambda:us-east-1:580247275435:layer:LambdaInsightsExtension:14" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: "arn:aws:lambda:us-east-1:580247275435:layer:LambdaInsightsExtension:12" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: "arn:aws:lambda:us-east-1:580247275435:layer:LambdaInsightsExtension:11" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: "arn:aws:lambda:us-east-1:580247275435:layer:LambdaInsightsExtension:2" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-19-0:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-19-0:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-7-0:2" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-7-0:2" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-python-amd64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-python-arm64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-python-amd64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-python-arm64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-python-amd64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-python-arm64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-python-amd64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-python-arm64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-collector-amd64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-collector-arm64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-collector-amd64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-collector-arm64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-collector-amd64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-collector-arm64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-collector-amd64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-collector-arm64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-collector-amd64-ver-0-62-1:1" }), fact_1.Fact.register({ region: "us-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: "arn:aws:lambda:us-east-1:901920570463:layer:aws-otel-collector-arm64-ver-0-62-1:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.PARTITION, value: "aws" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.DOMAIN_SUFFIX, value: "amazonaws.com" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "YES" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.IS_OPT_IN_REGION, value: "NO" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website.us-east-2.amazonaws.com" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "Z2O1EMRO9K5GLX" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "Z14LCN19Q5QHIC" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.ELBV2_ACCOUNT, value: "033677994240" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: "763104351884" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: "840364872350" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs16.x" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.FIREHOSE_CIDR_BLOCK, value: "13.58.135.96/27" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "com.amazonaws.vpce" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.us-east-2.amazonaws.com" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.us-east-2.amazonaws.com" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.servicePrincipal("states"), value: "states.us-east-2.amazonaws.com" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: "arn:aws:lambda:us-east-2:580247275435:layer:LambdaInsightsExtension:21" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: "arn:aws:lambda:us-east-2:580247275435:layer:LambdaInsightsExtension-Arm64:2" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: "arn:aws:lambda:us-east-2:580247275435:layer:LambdaInsightsExtension:18" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: "arn:aws:lambda:us-east-2:580247275435:layer:LambdaInsightsExtension-Arm64:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: "arn:aws:lambda:us-east-2:580247275435:layer:LambdaInsightsExtension:16" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: "arn:aws:lambda:us-east-2:580247275435:layer:LambdaInsightsExtension:14" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: "arn:aws:lambda:us-east-2:580247275435:layer:LambdaInsightsExtension:12" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: "arn:aws:lambda:us-east-2:580247275435:layer:LambdaInsightsExtension:11" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: "arn:aws:lambda:us-east-2:580247275435:layer:LambdaInsightsExtension:2" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-19-0:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-19-0:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-java-agent-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-java-agent-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-java-agent-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-java-agent-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-java-agent-amd64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-java-agent-arm64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-nodejs-amd64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-nodejs-arm64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-nodejs-amd64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-nodejs-arm64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-nodejs-amd64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-nodejs-arm64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-nodejs-amd64-ver-1-7-0:2" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-nodejs-arm64-ver-1-7-0:2" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-python-amd64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-python-arm64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-python-amd64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-python-arm64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-python-amd64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-python-arm64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-python-amd64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-python-arm64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-collector-amd64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-collector-arm64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-collector-amd64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-collector-arm64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-collector-amd64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-collector-arm64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-collector-amd64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-collector-arm64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-collector-amd64-ver-0-62-1:1" }), fact_1.Fact.register({ region: "us-east-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: "arn:aws:lambda:us-east-2:901920570463:layer:aws-otel-collector-arm64-ver-0-62-1:1" }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.PARTITION, value: "aws-us-gov" }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.DOMAIN_SUFFIX, value: "amazonaws.com" }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "NO" }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.IS_OPT_IN_REGION, value: "NO" }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website.us-gov-east-1.amazonaws.com" }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "Z2NIFVYYW2VKV1" }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "Z35TSARG0EJ4VU" }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.ELBV2_ACCOUNT, value: "190560391635" }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs16.x" }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.FIREHOSE_CIDR_BLOCK, value: "18.253.138.96/27" }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "com.amazonaws.vpce" }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.us-gov-east-1.amazonaws.com" }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.us-gov-east-1.amazonaws.com" }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.servicePrincipal("states"), value: "states.us-gov-east-1.amazonaws.com" }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.PARTITION, value: "aws-us-gov" }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.DOMAIN_SUFFIX, value: "amazonaws.com" }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "NO" }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.IS_OPT_IN_REGION, value: "NO" }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website-us-gov-west-1.amazonaws.com" }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "Z31GFT0UA1I2HV" }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "Z4KAURWC4UUUG" }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.ELBV2_ACCOUNT, value: "048591011584" }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs16.x" }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.FIREHOSE_CIDR_BLOCK, value: "52.61.204.160/27" }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "com.amazonaws.vpce" }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.us-gov-west-1.amazonaws.com" }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.us-gov-west-1.amazonaws.com" }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.servicePrincipal("states"), value: "states.us-gov-west-1.amazonaws.com" }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-gov-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.PARTITION, value: "aws-iso" }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.DOMAIN_SUFFIX, value: "c2s.ic.gov" }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "NO" }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.IS_OPT_IN_REGION, value: "NO" }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website.us-iso-east-1.c2s.ic.gov" }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "" }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "" }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.ELBV2_ACCOUNT, value: "770363063475" }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs14.x" }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "gov.ic.c2s.vpce" }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.amazonaws.com" }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.us-iso-east-1.c2s.ic.gov" }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.servicePrincipal("states"), value: "states.amazonaws.com" }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.PARTITION, value: "aws-iso" }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.DOMAIN_SUFFIX, value: "c2s.ic.gov" }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "NO" }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.IS_OPT_IN_REGION, value: "NO" }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website.us-iso-west-1.c2s.ic.gov" }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "" }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "" }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.ELBV2_ACCOUNT, value: "121062877647" }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs14.x" }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "gov.ic.c2s.vpce" }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.amazonaws.com" }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.us-iso-west-1.c2s.ic.gov" }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.servicePrincipal("states"), value: "states.amazonaws.com" }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-iso-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.PARTITION, value: "aws-iso-b" }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.DOMAIN_SUFFIX, value: "sc2s.sgov.gov" }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "NO" }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.IS_OPT_IN_REGION, value: "NO" }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website.us-isob-east-1.sc2s.sgov.gov" }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "" }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "" }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.ELBV2_ACCOUNT, value: "740734521339" }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs14.x" }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "gov.sgov.sc2s.vpce" }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.amazonaws.com" }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.us-isob-east-1.sc2s.sgov.gov" }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.servicePrincipal("states"), value: "states.amazonaws.com" }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-isob-east-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.PARTITION, value: "aws" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.DOMAIN_SUFFIX, value: "amazonaws.com" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "YES" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.IS_OPT_IN_REGION, value: "NO" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website-us-west-1.amazonaws.com" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "Z2F56UZL2M1ACD" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "Z1LQECGX5PH1X" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.ELBV2_ACCOUNT, value: "027434742980" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: "763104351884" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: "840364872350" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs16.x" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.FIREHOSE_CIDR_BLOCK, value: "13.57.135.192/27" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "com.amazonaws.vpce" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.us-west-1.amazonaws.com" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.us-west-1.amazonaws.com" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.servicePrincipal("states"), value: "states.us-west-1.amazonaws.com" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: "arn:aws:lambda:us-west-1:580247275435:layer:LambdaInsightsExtension:20" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: "arn:aws:lambda:us-west-1:580247275435:layer:LambdaInsightsExtension:18" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: void 0 }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: "arn:aws:lambda:us-west-1:580247275435:layer:LambdaInsightsExtension:16" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: "arn:aws:lambda:us-west-1:580247275435:layer:LambdaInsightsExtension:14" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: "arn:aws:lambda:us-west-1:580247275435:layer:LambdaInsightsExtension:12" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: "arn:aws:lambda:us-west-1:580247275435:layer:LambdaInsightsExtension:11" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: "arn:aws:lambda:us-west-1:580247275435:layer:LambdaInsightsExtension:2" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-19-0:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-19-0:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-java-agent-amd64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-java-agent-arm64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-nodejs-amd64-ver-1-7-0:2" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-nodejs-arm64-ver-1-7-0:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-python-amd64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-python-arm64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-python-amd64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-python-arm64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-python-amd64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-python-arm64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-python-amd64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-python-arm64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-collector-amd64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-collector-arm64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-collector-amd64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-collector-arm64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-collector-amd64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-collector-arm64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-collector-amd64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-collector-arm64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-collector-amd64-ver-0-62-1:1" }), fact_1.Fact.register({ region: "us-west-1", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: "arn:aws:lambda:us-west-1:901920570463:layer:aws-otel-collector-arm64-ver-0-62-1:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.PARTITION, value: "aws" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.DOMAIN_SUFFIX, value: "amazonaws.com" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.CDK_METADATA_RESOURCE_AVAILABLE, value: "YES" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.IS_OPT_IN_REGION, value: "NO" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.S3_STATIC_WEBSITE_ENDPOINT, value: "s3-website-us-west-2.amazonaws.com" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.S3_STATIC_WEBSITE_ZONE_53_HOSTED_ZONE_ID, value: "Z3BJ6K6RIION7M" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.EBS_ENV_ENDPOINT_HOSTED_ZONE_ID, value: "Z38NKT9BP95V3O" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.ELBV2_ACCOUNT, value: "797873946194" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.DLC_REPOSITORY_ACCOUNT, value: "763104351884" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.APPMESH_ECR_ACCOUNT, value: "840364872350" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.DEFAULT_CR_NODE_VERSION, value: "nodejs16.x" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.FIREHOSE_CIDR_BLOCK, value: "52.89.255.224/27" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.VPC_ENDPOINT_SERVICE_NAME_PREFIX, value: "com.amazonaws.vpce" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.servicePrincipal("application-autoscaling"), value: "application-autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.servicePrincipal("autoscaling"), value: "autoscaling.amazonaws.com" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.servicePrincipal("codedeploy"), value: "codedeploy.us-west-2.amazonaws.com" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.servicePrincipal("ec2"), value: "ec2.amazonaws.com" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.servicePrincipal("events"), value: "events.amazonaws.com" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.servicePrincipal("lambda"), value: "lambda.amazonaws.com" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.servicePrincipal("logs"), value: "logs.us-west-2.amazonaws.com" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.servicePrincipal("s3"), value: "s3.amazonaws.com" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.servicePrincipal("sns"), value: "sns.amazonaws.com" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.servicePrincipal("sqs"), value: "sqs.amazonaws.com" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.servicePrincipal("ssm"), value: "ssm.amazonaws.com" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.servicePrincipal("states"), value: "states.us-west-2.amazonaws.com" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.178.0", "x86_64"), value: void 0 }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.143.0", "x86_64"), value: "arn:aws:lambda:us-west-2:580247275435:layer:LambdaInsightsExtension:21" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "arm64"), value: "arn:aws:lambda:us-west-2:580247275435:layer:LambdaInsightsExtension-Arm64:2" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.135.0", "x86_64"), value: "arn:aws:lambda:us-west-2:580247275435:layer:LambdaInsightsExtension:18" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "arm64"), value: "arn:aws:lambda:us-west-2:580247275435:layer:LambdaInsightsExtension-Arm64:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.119.0", "x86_64"), value: "arn:aws:lambda:us-west-2:580247275435:layer:LambdaInsightsExtension:16" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.98.0", "x86_64"), value: "arn:aws:lambda:us-west-2:580247275435:layer:LambdaInsightsExtension:14" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.89.0", "x86_64"), value: "arn:aws:lambda:us-west-2:580247275435:layer:LambdaInsightsExtension:12" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.86.0", "x86_64"), value: "arn:aws:lambda:us-west-2:580247275435:layer:LambdaInsightsExtension:11" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.cloudwatchLambdaInsightsVersion("1.0.54.0", "x86_64"), value: "arn:aws:lambda:us-west-2:580247275435:layer:LambdaInsightsExtension:2" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "x86_64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.24.0", "arm64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "x86_64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.23.0", "arm64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "x86_64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.1", "arm64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "x86_64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.21.0", "arm64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "x86_64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-java-wrapper-amd64-ver-1-19-0:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_SDK", "1.19.0", "arm64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-java-wrapper-arm64-ver-1-19-0:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "x86_64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-java-agent-amd64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.24.0", "arm64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-java-agent-arm64-ver-1-24-0:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "x86_64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-java-agent-amd64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.23.0", "arm64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-java-agent-arm64-ver-1-23-0:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "x86_64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.1", "arm64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-1:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "x86_64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-java-agent-amd64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.21.0", "arm64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-java-agent-arm64-ver-1-21-0:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "x86_64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-java-agent-amd64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("JAVA_AUTO_INSTRUMENTATION", "1.19.2", "arm64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-java-agent-arm64-ver-1-19-2:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "x86_64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-nodejs-amd64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.12.0", "arm64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-nodejs-arm64-ver-1-12-0:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "x86_64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-nodejs-amd64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.9.1", "arm64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-nodejs-arm64-ver-1-9-1:2" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "x86_64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-nodejs-amd64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.8.0", "arm64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-nodejs-arm64-ver-1-8-0:2" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "x86_64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-nodejs-amd64-ver-1-7-0:2" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("JAVASCRIPT_SDK", "1.7.0", "arm64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-nodejs-arm64-ver-1-7-0:2" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "x86_64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-python-amd64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.17.0", "arm64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-python-arm64-ver-1-17-0:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "x86_64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-python-amd64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.16.0", "arm64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-python-arm64-ver-1-16-0:2" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "x86_64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-python-amd64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.15.0", "arm64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-python-arm64-ver-1-15-0:2" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "x86_64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-python-amd64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("PYTHON_SDK", "1.13.0", "arm64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-python-arm64-ver-1-13-0:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "x86_64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-collector-amd64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.74.0", "arm64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-collector-arm64-ver-0-74-0:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "x86_64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-collector-amd64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.72.0", "arm64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-collector-arm64-ver-0-72-0:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "x86_64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-collector-amd64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.70.0", "arm64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-collector-arm64-ver-0-70-0:4" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "x86_64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-collector-amd64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.68.0", "arm64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-collector-arm64-ver-0-68-0:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "x86_64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-collector-amd64-ver-0-62-1:1" }), fact_1.Fact.register({ region: "us-west-2", name: fact_1.FactName.adotLambdaLayer("GENERIC", "0.62.1", "arm64"), value: "arn:aws:lambda:us-west-2:901920570463:layer:aws-otel-collector-arm64-ver-0-62-1:1" });
      }
      constructor() {
      }
    };
    exports2.BuiltIns = BuiltIns;
  }
});

// node_modules/aws-cdk-lib/region-info/lib/index.js
var require_lib7 = __commonJS({
  "node_modules/aws-cdk-lib/region-info/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_default(), exports2), __exportStar(require_fact(), exports2), __exportStar(require_region_info(), exports2);
    var built_ins_generated_1 = require_built_ins_generated();
    built_ins_generated_1.BuiltIns.register();
  }
});

// node_modules/aws-cdk-lib/region-info/index.js
var require_region_info2 = __commonJS({
  "node_modules/aws-cdk-lib/region-info/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib7(), exports2);
  }
});

// node_modules/aws-cdk-lib/core/lib/cfn-condition.js
var require_cfn_condition = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/cfn-condition.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnCondition = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cfn_element_1 = require_cfn_element();
    var CfnCondition = class _CfnCondition extends cfn_element_1.CfnElement {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnConditionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCondition), error;
        }
        this.expression = props && props.expression;
      }
      _toCloudFormation() {
        return this.expression ? { Conditions: { [this.logicalId]: this.expression } } : {};
      }
      resolve(_context) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_IResolveContext(_context);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.resolve), error;
        }
        return { Condition: this.logicalId };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnCondition[_a] = { fqn: "aws-cdk-lib.CfnCondition", version: "2.80.0" }, exports2.CfnCondition = CfnCondition;
  }
});

// node_modules/aws-cdk-lib/core/lib/removal-policy.js
var require_removal_policy = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/removal-policy.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.RemovalPolicy = void 0;
    var RemovalPolicy;
    (function(RemovalPolicy2) {
      RemovalPolicy2.DESTROY = "destroy", RemovalPolicy2.RETAIN = "retain", RemovalPolicy2.SNAPSHOT = "snapshot";
    })(RemovalPolicy = exports2.RemovalPolicy || (exports2.RemovalPolicy = {}));
  }
});

// node_modules/aws-cdk-lib/core/lib/util.js
var require_util2 = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/util.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.undefinedIfAllValuesAreEmpty = exports2.findLastCommonElement = exports2.pathToTopLevelStack = exports2.PostResolveToken = exports2.filterUndefined = exports2.ignoreEmpty = exports2.capitalizePropertyNames = void 0;
    var intrinsic_1 = require_intrinsic();
    var stack_1 = require_stack();
    function capitalizePropertyNames(construct, obj) {
      if (obj = stack_1.Stack.of(construct).resolve(obj), typeof obj != "object")
        return obj;
      if (Array.isArray(obj))
        return obj.map((x) => capitalizePropertyNames(construct, x));
      const newObj = {};
      for (const key of Object.keys(obj)) {
        const value = obj[key], newKey = key.charAt(0).toUpperCase() + key.slice(1);
        newObj[newKey] = capitalizePropertyNames(construct, value);
      }
      return newObj;
    }
    exports2.capitalizePropertyNames = capitalizePropertyNames;
    function ignoreEmpty(obj) {
      return new PostResolveToken(obj, (o) => {
        if (o == null)
          return o;
        if (!(Array.isArray(o) && o.length === 0) && !(typeof o == "object" && Object.keys(o).length === 0))
          return o;
      });
    }
    exports2.ignoreEmpty = ignoreEmpty;
    function filterUndefined(obj) {
      if (Array.isArray(obj))
        return obj.filter((x) => x != null).map((x) => filterUndefined(x));
      if (typeof obj == "object") {
        const ret = {};
        for (const [key, value] of Object.entries(obj))
          value != null && (ret[key] = filterUndefined(value));
        return ret;
      }
      return obj;
    }
    exports2.filterUndefined = filterUndefined;
    var PostResolveToken = class extends intrinsic_1.Intrinsic {
      constructor(value, processor) {
        super(value, { stackTrace: false }), this.processor = processor;
      }
      resolve(context) {
        return context.registerPostProcessor(this), super.resolve(context);
      }
      postProcess(o, _context) {
        return this.processor(o);
      }
    };
    exports2.PostResolveToken = PostResolveToken;
    function pathToTopLevelStack(s) {
      return s.nestedStackParent ? [...pathToTopLevelStack(s.nestedStackParent), s] : [s];
    }
    exports2.pathToTopLevelStack = pathToTopLevelStack;
    function findLastCommonElement(path1, path2) {
      let i = 0;
      for (; i < path1.length && i < path2.length && path1[i] === path2[i]; )
        i++;
      return path1[i - 1];
    }
    exports2.findLastCommonElement = findLastCommonElement;
    function undefinedIfAllValuesAreEmpty(object) {
      return Object.values(object).some((v) => v !== void 0) ? object : void 0;
    }
    exports2.undefinedIfAllValuesAreEmpty = undefinedIfAllValuesAreEmpty;
  }
});

// node_modules/aws-cdk-lib/core/lib/arn.js
var require_arn = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/arn.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Arn = exports2.ArnFormat = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cfn_fn_1 = require_cfn_fn();
    var token_1 = require_token2();
    var util_1 = require_util2();
    var ArnFormat;
    (function(ArnFormat2) {
      ArnFormat2.NO_RESOURCE_NAME = "arn:aws:service:region:account:resource", ArnFormat2.COLON_RESOURCE_NAME = "arn:aws:service:region:account:resource:resourceName", ArnFormat2.SLASH_RESOURCE_NAME = "arn:aws:service:region:account:resource/resourceName", ArnFormat2.SLASH_RESOURCE_SLASH_RESOURCE_NAME = "arn:aws:service:region:account:/resource/resourceName";
    })(ArnFormat = exports2.ArnFormat || (exports2.ArnFormat = {}));
    var Arn2 = class _Arn {
      static format(components, stack) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ArnComponents(components), jsiiDeprecationWarnings.aws_cdk_lib_Stack(stack);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.format), error;
        }
        const partition = components.partition ?? stack?.partition, region = components.region ?? stack?.region, account = components.account ?? stack?.account;
        if (partition == null || region == null || account == null)
          throw new Error(`Arn.format: partition (${partition}), region (${region}), and account (${account}) must all be passed if stack is not passed.`);
        const sep = components.sep ?? (components.arnFormat === ArnFormat.COLON_RESOURCE_NAME ? ":" : "/"), values = ["arn", ":", partition, ":", components.service, ":", region, ":", account, ":", ...components.arnFormat === ArnFormat.SLASH_RESOURCE_SLASH_RESOURCE_NAME ? ["/"] : [], components.resource];
        if (sep !== "/" && sep !== ":" && sep !== "")
          throw new Error('resourcePathSep may only be ":", "/" or an empty string');
        return components.resourceName != null && (values.push(sep), values.push(components.resourceName)), values.join("");
      }
      static parse(arn, sepIfToken = "/", hasName = true) {
        let arnFormat;
        return hasName ? arnFormat = sepIfToken === "/" ? ArnFormat.SLASH_RESOURCE_NAME : ArnFormat.COLON_RESOURCE_NAME : arnFormat = ArnFormat.NO_RESOURCE_NAME, this.split(arn, arnFormat);
      }
      static split(arn, arnFormat) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ArnFormat(arnFormat);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.split), error;
        }
        const components = parseArnShape(arn);
        if (components === "token")
          return parseTokenArn(arn, arnFormat);
        const [, partition, service, region, account, resourceTypeOrName, ...rest] = components;
        let resource, resourceName, sep, resourcePartStartIndex = 0, detectedArnFormat, slashIndex = resourceTypeOrName.indexOf("/");
        return slashIndex === 0 && (slashIndex = resourceTypeOrName.indexOf("/", 1), resourcePartStartIndex = 1, detectedArnFormat = ArnFormat.SLASH_RESOURCE_SLASH_RESOURCE_NAME), slashIndex !== -1 ? arnFormat === ArnFormat.NO_RESOURCE_NAME ? (sep = void 0, slashIndex = -1, detectedArnFormat = ArnFormat.NO_RESOURCE_NAME) : (sep = "/", detectedArnFormat = resourcePartStartIndex === 0 ? ArnFormat.SLASH_RESOURCE_NAME : ArnFormat.SLASH_RESOURCE_SLASH_RESOURCE_NAME) : rest.length > 0 ? (sep = ":", slashIndex = -1, detectedArnFormat = ArnFormat.COLON_RESOURCE_NAME) : (sep = void 0, detectedArnFormat = ArnFormat.NO_RESOURCE_NAME), slashIndex !== -1 ? (resource = resourceTypeOrName.substring(resourcePartStartIndex, slashIndex), resourceName = resourceTypeOrName.substring(slashIndex + 1)) : resource = resourceTypeOrName, rest.length > 0 && (resourceName ? resourceName += ":" : resourceName = "", resourceName += rest.join(":")), (0, util_1.filterUndefined)({ service: service || void 0, resource: resource || void 0, partition: partition || void 0, region, account, resourceName, sep, arnFormat: detectedArnFormat });
      }
      static extractResourceName(arn, resourceType) {
        if (parseArnShape(arn) === "token")
          return cfn_fn_1.Fn.select(1, cfn_fn_1.Fn.split(`:${resourceType}/`, arn));
        const parsed = _Arn.split(arn, ArnFormat.SLASH_RESOURCE_NAME);
        if (!token_1.Token.isUnresolved(parsed.resource) && parsed.resource !== resourceType)
          throw new Error(`Expected resource type '${resourceType}' in ARN, got '${parsed.resource}' in '${arn}'`);
        if (!parsed.resourceName)
          throw new Error(`Expected resource name in ARN, didn't find one: '${arn}'`);
        return parsed.resourceName;
      }
      constructor() {
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Arn2[_a] = { fqn: "aws-cdk-lib.Arn", version: "2.80.0" }, exports2.Arn = Arn2;
    function parseTokenArn(arnToken, arnFormat) {
      const components = cfn_fn_1.Fn.split(":", arnToken), partition = cfn_fn_1.Fn.select(1, components).toString(), service = cfn_fn_1.Fn.select(2, components).toString(), region = cfn_fn_1.Fn.select(3, components).toString(), account = cfn_fn_1.Fn.select(4, components).toString();
      let resource, resourceName, sep;
      if (arnFormat === ArnFormat.NO_RESOURCE_NAME || arnFormat === ArnFormat.COLON_RESOURCE_NAME)
        resource = cfn_fn_1.Fn.select(5, components), arnFormat === ArnFormat.COLON_RESOURCE_NAME ? (resourceName = cfn_fn_1.Fn.select(6, components), sep = ":") : (resourceName = void 0, sep = void 0);
      else {
        const lastComponents = cfn_fn_1.Fn.split("/", cfn_fn_1.Fn.select(5, components));
        arnFormat === ArnFormat.SLASH_RESOURCE_NAME ? (resource = cfn_fn_1.Fn.select(0, lastComponents), resourceName = cfn_fn_1.Fn.select(1, lastComponents)) : (resource = cfn_fn_1.Fn.select(1, lastComponents), resourceName = cfn_fn_1.Fn.select(2, lastComponents)), sep = "/";
      }
      return { partition, service, region, account, resource, resourceName, sep, arnFormat };
    }
    function parseArnShape(arn) {
      if (!arn.startsWith("arn:")) {
        if (token_1.Token.isUnresolved(arn))
          return "token";
        throw new Error(`ARNs must start with "arn:" and have at least 6 components: ${arn}`);
      }
      const components = arn.split(":");
      if (!(components.length > 1 ? components[1] : void 0))
        throw new Error("The `partition` component (2nd component) of an ARN is required: " + arn);
      if (!(components.length > 2 ? components[2] : void 0))
        throw new Error("The `service` component (3rd component) of an ARN is required: " + arn);
      if (!(components.length > 5 ? components[5] : void 0))
        throw new Error("The `resource` component (6th component) of an ARN is required: " + arn);
      return components;
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/private/md5.js
var require_md52 = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/private/md5.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.jsMd5 = exports2.cryptoMd5 = exports2.md5hash = void 0;
    var crypto = require("crypto");
    var _impl;
    function md5hash(x) {
      if (!_impl)
        try {
          crypto.createHash("md5"), _impl = cryptoMd5;
        } catch {
          _impl = jsMd5;
        }
      return _impl(x);
    }
    exports2.md5hash = md5hash;
    function cryptoMd5(x) {
      const hash = crypto.createHash("md5");
      return hash.update(x), hash.digest("hex");
    }
    exports2.cryptoMd5 = cryptoMd5;
    function jsMd5(s) {
      return hex(md5Buffer(Buffer.from(s, "utf-8")));
    }
    exports2.jsMd5 = jsMd5;
    function md5Round(x, k) {
      let a = x[0], b = x[1], c = x[2], d = x[3];
      a = F(a, b, c, d, k[0], 7, -680876936), d = F(d, a, b, c, k[1], 12, -389564586), c = F(c, d, a, b, k[2], 17, 606105819), b = F(b, c, d, a, k[3], 22, -1044525330), a = F(a, b, c, d, k[4], 7, -176418897), d = F(d, a, b, c, k[5], 12, 1200080426), c = F(c, d, a, b, k[6], 17, -1473231341), b = F(b, c, d, a, k[7], 22, -45705983), a = F(a, b, c, d, k[8], 7, 1770035416), d = F(d, a, b, c, k[9], 12, -1958414417), c = F(c, d, a, b, k[10], 17, -42063), b = F(b, c, d, a, k[11], 22, -1990404162), a = F(a, b, c, d, k[12], 7, 1804603682), d = F(d, a, b, c, k[13], 12, -40341101), c = F(c, d, a, b, k[14], 17, -1502002290), b = F(b, c, d, a, k[15], 22, 1236535329), a = G(a, b, c, d, k[1], 5, -165796510), d = G(d, a, b, c, k[6], 9, -1069501632), c = G(c, d, a, b, k[11], 14, 643717713), b = G(b, c, d, a, k[0], 20, -373897302), a = G(a, b, c, d, k[5], 5, -701558691), d = G(d, a, b, c, k[10], 9, 38016083), c = G(c, d, a, b, k[15], 14, -660478335), b = G(b, c, d, a, k[4], 20, -405537848), a = G(a, b, c, d, k[9], 5, 568446438), d = G(d, a, b, c, k[14], 9, -1019803690), c = G(c, d, a, b, k[3], 14, -187363961), b = G(b, c, d, a, k[8], 20, 1163531501), a = G(a, b, c, d, k[13], 5, -1444681467), d = G(d, a, b, c, k[2], 9, -51403784), c = G(c, d, a, b, k[7], 14, 1735328473), b = G(b, c, d, a, k[12], 20, -1926607734), a = H(a, b, c, d, k[5], 4, -378558), d = H(d, a, b, c, k[8], 11, -2022574463), c = H(c, d, a, b, k[11], 16, 1839030562), b = H(b, c, d, a, k[14], 23, -35309556), a = H(a, b, c, d, k[1], 4, -1530992060), d = H(d, a, b, c, k[4], 11, 1272893353), c = H(c, d, a, b, k[7], 16, -155497632), b = H(b, c, d, a, k[10], 23, -1094730640), a = H(a, b, c, d, k[13], 4, 681279174), d = H(d, a, b, c, k[0], 11, -358537222), c = H(c, d, a, b, k[3], 16, -722521979), b = H(b, c, d, a, k[6], 23, 76029189), a = H(a, b, c, d, k[9], 4, -640364487), d = H(d, a, b, c, k[12], 11, -421815835), c = H(c, d, a, b, k[15], 16, 530742520), b = H(b, c, d, a, k[2], 23, -995338651), a = I(a, b, c, d, k[0], 6, -198630844), d = I(d, a, b, c, k[7], 10, 1126891415), c = I(c, d, a, b, k[14], 15, -1416354905), b = I(b, c, d, a, k[5], 21, -57434055), a = I(a, b, c, d, k[12], 6, 1700485571), d = I(d, a, b, c, k[3], 10, -1894986606), c = I(c, d, a, b, k[10], 15, -1051523), b = I(b, c, d, a, k[1], 21, -2054922799), a = I(a, b, c, d, k[8], 6, 1873313359), d = I(d, a, b, c, k[15], 10, -30611744), c = I(c, d, a, b, k[6], 15, -1560198380), b = I(b, c, d, a, k[13], 21, 1309151649), a = I(a, b, c, d, k[4], 6, -145523070), d = I(d, a, b, c, k[11], 10, -1120210379), c = I(c, d, a, b, k[2], 15, 718787259), b = I(b, c, d, a, k[9], 21, -343485551), x[0] = add32(a, x[0]), x[1] = add32(b, x[1]), x[2] = add32(c, x[2]), x[3] = add32(d, x[3]);
    }
    function cmn(q, a, b, x, s, t) {
      return a = add32(add32(a, q), add32(x, t)), add32(a << s | a >>> 32 - s, b);
    }
    function F(a, b, c, d, x, s, t) {
      return cmn(b & c | ~b & d, a, b, x, s, t);
    }
    function G(a, b, c, d, x, s, t) {
      return cmn(b & d | c & ~d, a, b, x, s, t);
    }
    function H(a, b, c, d, x, s, t) {
      return cmn(b ^ c ^ d, a, b, x, s, t);
    }
    function I(a, b, c, d, x, s, t) {
      return cmn(c ^ (b | ~d), a, b, x, s, t);
    }
    function md5Buffer(buf) {
      let n = buf.length, state = [1732584193, -271733879, -1732584194, 271733878], i = 0;
      for (; i + 64 <= n; i += 64)
        md5Round(state, bytesToWordsBuf(buf, i));
      const remainingBytes = n - i, padding = Buffer.alloc(64 - remainingBytes < 9 ? 128 : 64);
      buf.copy(padding, 0, i), padding.writeUint8(128, remainingBytes);
      const bitLength = n * 8;
      return padding.writeUint32LE(n << 3, padding.length - 8), bitLength >= 4294967295 && padding.writeUint32LE(Math.floor(bitLength / 4294967295), padding.length - 4), md5Round(state, bytesToWordsBuf(padding, 0)), padding.length > 64 && md5Round(state, bytesToWordsBuf(padding, 64)), state;
    }
    function bytesToWordsBuf(buf, byteOffset) {
      const ret = new Array(16);
      let i = 0, j = byteOffset;
      for (; i < 16; i++, j += 4)
        ret[i] = buf.readUint32LE(j);
      return ret;
    }
    var hex_chr = "0123456789abcdef".split("");
    function hexify(n) {
      const s = new Array();
      for (let j = 0; j < 4; j++)
        s.push(hex_chr[n >>> j * 8 + 4 & 15] + hex_chr[n >>> j * 8 & 15]);
      return s.join("");
    }
    function hex(x) {
      const ret = new Array(x.length);
      for (let i = 0; i < x.length; i++)
        ret[i] = hexify(x[i]);
      return ret.join("");
    }
    function add32(a, b) {
      return a + b & 4294967295;
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/private/unique-resource-name.js
var require_unique_resource_name = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/private/unique-resource-name.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.makeUniqueResourceName = void 0;
    var md5_1 = require_md52();
    var HIDDEN_FROM_HUMAN_ID = "Resource";
    var HIDDEN_ID = "Default";
    var PATH_SEP = "/";
    var MAX_LEN = 256;
    var HASH_LEN = 8;
    function makeUniqueResourceName(components, options) {
      const maxLength = options.maxLength ?? 256, separator = options.separator ?? "";
      if (components = components.filter((x) => x !== HIDDEN_ID), components.length === 0)
        throw new Error("Unable to calculate a unique resource name for an empty set of components");
      if (components.length === 1) {
        const topLevelResource = removeNonAllowedSpecialCharacters(components[0], separator, options.allowedSpecialCharacters);
        if (topLevelResource.length <= maxLength)
          return topLevelResource;
      }
      const hash = pathHash(components), human = removeDupes(components).filter((pathElement) => pathElement !== HIDDEN_FROM_HUMAN_ID).map((pathElement) => removeNonAllowedSpecialCharacters(pathElement, separator, options.allowedSpecialCharacters)).filter((pathElement) => pathElement).join(separator).concat(separator), maxhumanLength = maxLength - HASH_LEN;
      return human.length > maxhumanLength ? `${splitInMiddle(human, maxhumanLength)}${hash}` : `${human}${hash}`;
    }
    exports2.makeUniqueResourceName = makeUniqueResourceName;
    function pathHash(path) {
      return (0, md5_1.md5hash)(path.join(PATH_SEP)).slice(0, HASH_LEN).toUpperCase();
    }
    function removeNonAllowedSpecialCharacters(s, _separator, allowedSpecialCharacters) {
      const pattern = allowedSpecialCharacters ? `[^A-Za-z0-9${allowedSpecialCharacters}]` : "[^A-Za-z0-9]", regex = new RegExp(pattern, "g");
      return s.replace(regex, "");
    }
    function removeDupes(path) {
      const ret = new Array();
      for (const component of path)
        (ret.length === 0 || !ret[ret.length - 1].endsWith(component)) && ret.push(component);
      return ret;
    }
    function splitInMiddle(s, maxLength = MAX_LEN - HASH_LEN) {
      const half = maxLength / 2;
      return s.slice(0, half) + s.slice(-half);
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/private/uniqueid.js
var require_uniqueid2 = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/private/uniqueid.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.makeUniqueId = void 0;
    var encoding_1 = require_encoding();
    var md5_1 = require_md52();
    var HIDDEN_FROM_HUMAN_ID = "Resource";
    var HIDDEN_ID = "Default";
    var PATH_SEP = "/";
    var HASH_LEN = 8;
    var MAX_HUMAN_LEN = 240;
    var MAX_ID_LEN = 255;
    function makeUniqueId(components) {
      if (components = components.filter((x) => x !== HIDDEN_ID), components.length === 0)
        throw new Error("Unable to calculate a unique id for an empty set of components");
      const unresolvedTokens = components.filter((c) => (0, encoding_1.unresolved)(c));
      if (unresolvedTokens.length > 0)
        throw new Error(`ID components may not include unresolved tokens: ${unresolvedTokens.join(",")}`);
      if (components.length === 1) {
        const candidate = removeNonAlphanumeric(components[0]);
        if (candidate.length <= MAX_ID_LEN)
          return candidate;
      }
      const hash = pathHash(components);
      return removeDupes(components).filter((x) => x !== HIDDEN_FROM_HUMAN_ID).map(removeNonAlphanumeric).join("").slice(0, MAX_HUMAN_LEN) + hash;
    }
    exports2.makeUniqueId = makeUniqueId;
    function pathHash(path) {
      return (0, md5_1.md5hash)(path.join(PATH_SEP)).slice(0, HASH_LEN).toUpperCase();
    }
    function removeNonAlphanumeric(s) {
      return s.replace(/[^A-Za-z0-9]/g, "");
    }
    function removeDupes(path) {
      const ret = new Array();
      for (const component of path)
        (ret.length === 0 || !ret[ret.length - 1].endsWith(component)) && ret.push(component);
      return ret;
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/names.js
var require_names = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/names.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Names = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var encoding_1 = require_encoding();
    var unique_resource_name_1 = require_unique_resource_name();
    var uniqueid_1 = require_uniqueid2();
    var stack_1 = require_stack();
    var Names = class {
      static uniqueId(construct) {
        const components = constructs_1.Node.of(construct).scopes.slice(1).map((c) => constructs_1.Node.of(c).id);
        return components.length > 0 ? (0, uniqueid_1.makeUniqueId)(components) : "";
      }
      static nodeUniqueId(node) {
        const components = node.scopes.slice(1).map((c) => constructs_1.Node.of(c).id);
        return components.length > 0 ? (0, uniqueid_1.makeUniqueId)(components) : "";
      }
      static uniqueResourceName(construct, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_UniqueResourceNameOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.uniqueResourceName), error;
        }
        const node = constructs_1.Node.of(construct), componentsPath = node.scopes.slice(node.scopes.indexOf(node.scopes.reverse().find((component) => stack_1.Stack.isStack(component) && !(0, encoding_1.unresolved)(component.stackName)))).map((component) => stack_1.Stack.isStack(component) && !(0, encoding_1.unresolved)(component.stackName) ? component.stackName : constructs_1.Node.of(component).id);
        return (0, unique_resource_name_1.makeUniqueResourceName)(componentsPath, options);
      }
      constructor() {
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Names[_a] = { fqn: "aws-cdk-lib.Names", version: "2.80.0" }, exports2.Names = Names;
  }
});

// node_modules/aws-cdk-lib/core/lib/private/physical-name-generator.js
var require_physical_name_generator = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/private/physical-name-generator.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.isGeneratedWhenNeededMarker = exports2.GeneratedWhenNeededMarker = exports2.generatePhysicalName = void 0;
    var crypto = require("crypto");
    var constructs_1 = require_lib2();
    var token_map_1 = require_token_map();
    var names_1 = require_names();
    var stack_1 = require_stack();
    var token_1 = require_token2();
    function generatePhysicalName(resource) {
      const stack = stack_1.Stack.of(resource), stackPart = new PrefixNamePart(stack.stackName, 25), idPart = new SuffixNamePart(names_1.Names.nodeUniqueId(resource.node), 24), region = stack.region;
      if (token_1.Token.isUnresolved(region) || !region)
        throw new Error(`Cannot generate a physical name for ${constructs_1.Node.of(resource).path}, because the region is un-resolved or missing`);
      const account = stack.account;
      if (token_1.Token.isUnresolved(account) || !account)
        throw new Error(`Cannot generate a physical name for ${constructs_1.Node.of(resource).path}, because the account is un-resolved or missing`);
      const parts = [stackPart, idPart].map((part) => part.generate()), hashLength = 12, hash = crypto.createHash("sha256").update(stackPart.bareStr).update(idPart.bareStr).update(region).update(account).digest("hex").slice(0, hashLength);
      return [...parts, hash].join("").toLowerCase();
    }
    exports2.generatePhysicalName = generatePhysicalName;
    var NamePart = class {
      constructor(bareStr) {
        this.bareStr = bareStr;
      }
    };
    var PrefixNamePart = class extends NamePart {
      constructor(bareStr, prefixLength) {
        super(bareStr), this.prefixLength = prefixLength;
      }
      generate() {
        return this.bareStr.slice(0, this.prefixLength);
      }
    };
    var SuffixNamePart = class extends NamePart {
      constructor(str, suffixLength) {
        super(str), this.suffixLength = suffixLength;
      }
      generate() {
        const strLen = this.bareStr.length, startIndex = Math.max(strLen - this.suffixLength, 0);
        return this.bareStr.slice(startIndex, strLen);
      }
    };
    var GENERATE_IF_NEEDED_SYMBOL = Symbol.for("@aws-cdk/core.<private>.GenerateIfNeeded");
    var GeneratedWhenNeededMarker = class {
      constructor() {
        this.creationStack = [], Object.defineProperty(this, GENERATE_IF_NEEDED_SYMBOL, { value: true });
      }
      resolve(_ctx) {
        throw new Error('Invalid physical name passed to CloudFormation. Use "this.physicalName" instead');
      }
      toString() {
        return "PhysicalName.GENERATE_IF_NEEDED";
      }
    };
    exports2.GeneratedWhenNeededMarker = GeneratedWhenNeededMarker;
    function isGeneratedWhenNeededMarker(val) {
      const token = token_map_1.TokenMap.instance().lookupString(val);
      return !!token && GENERATE_IF_NEEDED_SYMBOL in token;
    }
    exports2.isGeneratedWhenNeededMarker = isGeneratedWhenNeededMarker;
  }
});

// node_modules/aws-cdk-lib/core/lib/resource.js
var require_resource = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/resource.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Resource = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var arn_1 = require_arn();
    var cfn_resource_1 = require_cfn_resource();
    var lazy_1 = require_lazy();
    var physical_name_generator_1 = require_physical_name_generator();
    var reference_1 = require_reference();
    var stack_1 = require_stack();
    var token_1 = require_token2();
    var constructs_1 = require_lib2();
    var RESOURCE_SYMBOL = Symbol.for("@aws-cdk/core.Resource");
    var Resource = class _Resource extends constructs_1.Construct {
      static isResource(construct) {
        return construct !== null && typeof construct == "object" && RESOURCE_SYMBOL in construct;
      }
      static isOwnedResource(construct) {
        return construct.node.defaultChild ? cfn_resource_1.CfnResource.isCfnResource(construct.node.defaultChild) : false;
      }
      constructor(scope, id, props = {}) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ResourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Resource), error;
        }
        if ((props.account !== void 0 || props.region !== void 0) && props.environmentFromArn !== void 0)
          throw new Error(`Supply at most one of 'account'/'region' (${props.account}/${props.region}) and 'environmentFromArn' (${props.environmentFromArn})`);
        Object.defineProperty(this, RESOURCE_SYMBOL, { value: true }), this.stack = stack_1.Stack.of(this);
        const parsedArn = props.environmentFromArn ? this.stack.splitArn(props.environmentFromArn, arn_1.ArnFormat.NO_RESOURCE_NAME) : void 0;
        this.env = { account: props.account ?? parsedArn?.account ?? this.stack.account, region: props.region ?? parsedArn?.region ?? this.stack.region };
        let physicalName = props.physicalName;
        props.physicalName && (0, physical_name_generator_1.isGeneratedWhenNeededMarker)(props.physicalName) ? (this._physicalName = void 0, this._allowCrossEnvironment = true, physicalName = lazy_1.Lazy.string({ produce: () => this._physicalName })) : props.physicalName && !token_1.Token.isUnresolved(props.physicalName) ? (this._physicalName = props.physicalName, this._allowCrossEnvironment = true) : (this._physicalName = props.physicalName, this._allowCrossEnvironment = false), physicalName === void 0 && (physicalName = token_1.Token.asString(void 0)), this.physicalName = physicalName;
      }
      _enableCrossEnvironment() {
        if (!this._allowCrossEnvironment)
          throw new Error(`Cannot use resource '${this.node.path}' in a cross-environment fashion, the resource's physical name must be explicit set or use \`PhysicalName.GENERATE_IF_NEEDED\``);
        this._physicalName || (this._physicalName = this.generatePhysicalName());
      }
      applyRemovalPolicy(policy) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_RemovalPolicy(policy);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.applyRemovalPolicy), error;
        }
        const child = this.node.defaultChild;
        if (!child || !cfn_resource_1.CfnResource.isCfnResource(child))
          throw new Error("Cannot apply RemovalPolicy: no child or not a CfnResource. Apply the removal policy on the CfnResource directly.");
        child.applyRemovalPolicy(policy);
      }
      generatePhysicalName() {
        return (0, physical_name_generator_1.generatePhysicalName)(this);
      }
      getResourceNameAttribute(nameAttr) {
        return mimicReference(nameAttr, { produce: (context) => {
          const consumingStack = stack_1.Stack.of(context.scope);
          return this.stack.account !== consumingStack.account || this.stack.region !== consumingStack.region && !consumingStack._crossRegionReferences ? (this._enableCrossEnvironment(), this.physicalName) : nameAttr;
        } });
      }
      getResourceArnAttribute(arnAttr, arnComponents) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ArnComponents(arnComponents);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.getResourceArnAttribute), error;
        }
        return mimicReference(arnAttr, { produce: (context) => {
          const consumingStack = stack_1.Stack.of(context.scope);
          return this.stack.account !== consumingStack.account || this.stack.region !== consumingStack.region && !consumingStack._crossRegionReferences ? (this._enableCrossEnvironment(), this.stack.formatArn(arnComponents)) : arnAttr;
        } });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Resource[_a] = { fqn: "aws-cdk-lib.Resource", version: "2.80.0" }, exports2.Resource = Resource;
    function mimicReference(refSource, producer) {
      const reference = token_1.Tokenization.reverse(refSource, { failConcat: false });
      return reference_1.Reference.isReference(reference) ? token_1.Token.asString(new class extends reference_1.Reference {
        resolve(context) {
          return producer.produce(context);
        }
      }(reference, reference.target, reference.displayName)) : lazy_1.Lazy.uncachedString(producer);
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/custom-resource.js
var require_custom_resource = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/custom-resource.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CustomResource = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cfn_resource_1 = require_cfn_resource();
    var removal_policy_1 = require_removal_policy();
    var resource_1 = require_resource();
    var token_1 = require_token2();
    var CustomResource2 = class _CustomResource extends resource_1.Resource {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CustomResourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CustomResource), error;
        }
        const type = renderResourceType(props.resourceType), properties = props.pascalCaseProperties ?? false ? uppercaseProperties(props.properties || {}) : props.properties || {};
        this.resource = new cfn_resource_1.CfnResource(this, "Default", { type, properties: { ServiceToken: props.serviceToken, ...properties } }), this.resource.applyRemovalPolicy(props.removalPolicy, { default: removal_policy_1.RemovalPolicy.DESTROY });
      }
      get ref() {
        return this.resource.ref;
      }
      getAtt(attributeName) {
        return this.resource.getAtt(attributeName);
      }
      getAttString(attributeName) {
        return token_1.Token.asString(this.getAtt(attributeName));
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CustomResource2[_a] = { fqn: "aws-cdk-lib.CustomResource", version: "2.80.0" }, exports2.CustomResource = CustomResource2;
    function uppercaseProperties(props) {
      const ret = {};
      return Object.keys(props).forEach((key) => {
        const upper = key.slice(0, 1).toUpperCase() + key.slice(1);
        ret[upper] = props[key];
      }), ret;
    }
    function renderResourceType(resourceType) {
      if (!resourceType)
        return "AWS::CloudFormation::CustomResource";
      if (!resourceType.startsWith("Custom::"))
        throw new Error(`Custom resource type must begin with "Custom::" (${resourceType})`);
      if (resourceType.length > 60)
        throw new Error(`Custom resource type length > 60 (${resourceType})`);
      const typeName = resourceType.slice(resourceType.indexOf("::") + 2);
      if (!/^[a-z0-9_@-]+$/i.test(typeName))
        throw new Error(`Custom resource type name can only include alphanumeric characters and _@- (${typeName})`);
      return resourceType;
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/assets.js
var require_assets3 = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/assets.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FileAssetPackaging = exports2.AssetHashType = void 0;
    var AssetHashType;
    (function(AssetHashType2) {
      AssetHashType2.SOURCE = "source", AssetHashType2.BUNDLE = "bundle", AssetHashType2.OUTPUT = "output", AssetHashType2.CUSTOM = "custom";
    })(AssetHashType = exports2.AssetHashType || (exports2.AssetHashType = {}));
    var FileAssetPackaging;
    (function(FileAssetPackaging2) {
      FileAssetPackaging2.ZIP_DIRECTORY = "zip", FileAssetPackaging2.FILE = "file";
    })(FileAssetPackaging = exports2.FileAssetPackaging || (exports2.FileAssetPackaging = {}));
  }
});

// node_modules/aws-cdk-lib/node_modules/@balena/dockerignore/ignore.js
var require_ignore = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/@balena/dockerignore/ignore.js"(exports2, module2) {
    "use strict";
    var path = require("path");
    var factory = (options) => new IgnoreBase(options);
    factory.default = factory;
    module2.exports = factory;
    function make_array(subject) {
      return Array.isArray(subject) ? subject : [subject];
    }
    var REGEX_TRAILING_SLASH = /(?<=.)\/$/;
    var REGEX_TRAILING_BACKSLASH = /(?<=.)\\$/;
    var REGEX_TRAILING_PATH_SEP = path.sep === "\\" ? REGEX_TRAILING_BACKSLASH : REGEX_TRAILING_SLASH;
    var KEY_IGNORE = typeof Symbol !== "undefined" ? Symbol.for("dockerignore") : "dockerignore";
    function cleanPath(file) {
      return path.normalize(file).replace(REGEX_TRAILING_PATH_SEP, "");
    }
    function toSlash(file) {
      if (path.sep === "/") {
        return file;
      }
      return file.replace(/\\/g, "/");
    }
    function fromSlash(file) {
      if (path.sep === "/") {
        return file;
      }
      return file.replace(/\//g, path.sep);
    }
    var IgnoreBase = class {
      constructor({
        // https://github.com/kaelzhang/node-ignore/blob/5.1.4/index.js#L372
        ignorecase = true
      } = {}) {
        this._rules = [];
        this._ignorecase = ignorecase;
        this[KEY_IGNORE] = true;
        this._initCache();
      }
      _initCache() {
        this._cache = {};
      }
      // @param {Array.<string>|string|Ignore} pattern
      add(pattern) {
        this._added = false;
        if (typeof pattern === "string") {
          pattern = pattern.split(/\r?\n/g);
        }
        make_array(pattern).forEach(this._addPattern, this);
        if (this._added) {
          this._initCache();
        }
        return this;
      }
      // legacy
      addPattern(pattern) {
        return this.add(pattern);
      }
      _addPattern(pattern) {
        if (pattern && pattern[KEY_IGNORE]) {
          this._rules = this._rules.concat(pattern._rules);
          this._added = true;
          return;
        }
        if (this._checkPattern(pattern)) {
          const rule = this._createRule(pattern.trim());
          if (rule !== null) {
            this._added = true;
            this._rules.push(rule);
          }
        }
      }
      _checkPattern(pattern) {
        return pattern && typeof pattern === "string" && pattern.indexOf("#") !== 0 && pattern.trim() !== "";
      }
      filter(paths) {
        return make_array(paths).filter((path2) => this._filter(path2));
      }
      createFilter() {
        return (path2) => this._filter(path2);
      }
      ignores(path2) {
        return !this._filter(path2);
      }
      // https://github.com/moby/moby/blob/v19.03.8/builder/dockerignore/dockerignore.go#L41-L53
      // https://github.com/moby/moby/blob/v19.03.8/pkg/fileutils/fileutils.go#L29-L55
      _createRule(pattern) {
        const origin = pattern;
        let negative = false;
        if (pattern[0] === "!") {
          negative = true;
          pattern = pattern.substring(1).trim();
        }
        if (pattern.length > 0) {
          pattern = cleanPath(pattern);
          pattern = toSlash(pattern);
          if (pattern.length > 1 && pattern[0] === "/") {
            pattern = pattern.slice(1);
          }
        }
        if (negative) {
          pattern = "!" + pattern;
        }
        pattern = pattern.trim();
        if (pattern === "") {
          return null;
        }
        pattern = cleanPath(pattern);
        if (pattern[0] === "!") {
          if (pattern.length === 1) {
            return null;
          }
          negative = true;
          pattern = pattern.substring(1);
        } else {
          negative = false;
        }
        return {
          origin,
          pattern,
          // https://github.com/moby/moby/blob/v19.03.8/pkg/fileutils/fileutils.go#L54
          dirs: pattern.split(path.sep),
          negative
        };
      }
      // @returns `Boolean` true if the `path` is NOT ignored
      _filter(path2) {
        if (!path2) {
          return false;
        }
        if (path2 in this._cache) {
          return this._cache[path2];
        }
        return this._cache[path2] = this._test(path2);
      }
      // @returns {Boolean} true if a file is NOT ignored
      // https://github.com/moby/moby/blob/v19.03.8/pkg/fileutils/fileutils.go#L62
      _test(file) {
        file = fromSlash(file);
        const parentPath = cleanPath(path.dirname(file));
        const parentPathDirs = parentPath.split(path.sep);
        let matched = false;
        this._rules.forEach((rule) => {
          let match = this._match(file, rule);
          if (!match && parentPath !== ".") {
            if (rule.dirs.includes("**")) {
              for (let i = rule.dirs.filter((x) => x !== "**").length; i <= parentPathDirs.length; i++) {
                match = match || this._match(parentPathDirs.slice(0, i).join(path.sep), rule);
              }
            } else if (rule.dirs.length <= parentPathDirs.length) {
              match = this._match(parentPathDirs.slice(0, rule.dirs.length).join(path.sep), rule);
            }
          }
          if (match) {
            matched = !rule.negative;
          }
        });
        return !matched;
      }
      // @returns {Boolean} true if a file is matched by a rule
      _match(file, rule) {
        return this._compile(rule).regexp.test(file);
      }
      // https://github.com/moby/moby/blob/v19.03.8/pkg/fileutils/fileutils.go#L139
      _compile(rule) {
        if (rule.regexp) {
          return rule;
        }
        let regStr = "^";
        let escapedSlash = path.sep === "\\" ? "\\\\" : path.sep;
        for (let i = 0; i < rule.pattern.length; i++) {
          const ch = rule.pattern[i];
          if (ch === "*") {
            if (rule.pattern[i + 1] === "*") {
              i++;
              if (rule.pattern[i + 1] === path.sep) {
                i++;
              }
              if (rule.pattern[i + 1] === void 0) {
                regStr += ".*";
              } else {
                regStr += `(.*${escapedSlash})?`;
              }
            } else {
              regStr += `[^${escapedSlash}]*`;
            }
          } else if (ch === "?") {
            regStr += `[^${escapedSlash}]`;
          } else if (ch === "." || ch === "$") {
            regStr += `\\${ch}`;
          } else if (ch === "\\") {
            if (path.sep === "\\") {
              regStr += escapedSlash;
              continue;
            }
            if (rule.pattern[i + 1] !== void 0) {
              regStr += "\\" + rule.pattern[i + 1];
              i++;
            } else {
              regStr += "\\";
            }
          } else {
            regStr += ch;
          }
        }
        regStr += "$";
        rule.regexp = new RegExp(regStr, this._ignorecase ? "i" : "");
        return rule;
      }
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/ignore/index.js
var require_ignore2 = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/ignore/index.js"(exports2, module2) {
    "use strict";
    function makeArray(subject) {
      return Array.isArray(subject) ? subject : [subject];
    }
    var EMPTY = "";
    var SPACE = " ";
    var ESCAPE = "\\";
    var REGEX_TEST_BLANK_LINE = /^\s+$/;
    var REGEX_INVALID_TRAILING_BACKSLASH = /(?:[^\\]|^)\\$/;
    var REGEX_REPLACE_LEADING_EXCAPED_EXCLAMATION = /^\\!/;
    var REGEX_REPLACE_LEADING_EXCAPED_HASH = /^\\#/;
    var REGEX_SPLITALL_CRLF = /\r?\n/g;
    var REGEX_TEST_INVALID_PATH = /^\.*\/|^\.+$/;
    var SLASH = "/";
    var TMP_KEY_IGNORE = "node-ignore";
    if (typeof Symbol !== "undefined") {
      TMP_KEY_IGNORE = Symbol.for("node-ignore");
    }
    var KEY_IGNORE = TMP_KEY_IGNORE;
    var define = (object, key, value) => Object.defineProperty(object, key, { value });
    var REGEX_REGEXP_RANGE = /([0-z])-([0-z])/g;
    var RETURN_FALSE = () => false;
    var sanitizeRange = (range) => range.replace(
      REGEX_REGEXP_RANGE,
      (match, from, to) => from.charCodeAt(0) <= to.charCodeAt(0) ? match : EMPTY
    );
    var cleanRangeBackSlash = (slashes) => {
      const { length } = slashes;
      return slashes.slice(0, length - length % 2);
    };
    var REPLACERS = [
      // > Trailing spaces are ignored unless they are quoted with backslash ("\")
      [
        // (a\ ) -> (a )
        // (a  ) -> (a)
        // (a \ ) -> (a  )
        /\\?\s+$/,
        (match) => match.indexOf("\\") === 0 ? SPACE : EMPTY
      ],
      // replace (\ ) with ' '
      [
        /\\\s/g,
        () => SPACE
      ],
      // Escape metacharacters
      // which is written down by users but means special for regular expressions.
      // > There are 12 characters with special meanings:
      // > - the backslash \,
      // > - the caret ^,
      // > - the dollar sign $,
      // > - the period or dot .,
      // > - the vertical bar or pipe symbol |,
      // > - the question mark ?,
      // > - the asterisk or star *,
      // > - the plus sign +,
      // > - the opening parenthesis (,
      // > - the closing parenthesis ),
      // > - and the opening square bracket [,
      // > - the opening curly brace {,
      // > These special characters are often called "metacharacters".
      [
        /[\\$.|*+(){^]/g,
        (match) => `\\${match}`
      ],
      [
        // > a question mark (?) matches a single character
        /(?!\\)\?/g,
        () => "[^/]"
      ],
      // leading slash
      [
        // > A leading slash matches the beginning of the pathname.
        // > For example, "/*.c" matches "cat-file.c" but not "mozilla-sha1/sha1.c".
        // A leading slash matches the beginning of the pathname
        /^\//,
        () => "^"
      ],
      // replace special metacharacter slash after the leading slash
      [
        /\//g,
        () => "\\/"
      ],
      [
        // > A leading "**" followed by a slash means match in all directories.
        // > For example, "**/foo" matches file or directory "foo" anywhere,
        // > the same as pattern "foo".
        // > "**/foo/bar" matches file or directory "bar" anywhere that is directly
        // >   under directory "foo".
        // Notice that the '*'s have been replaced as '\\*'
        /^\^*\\\*\\\*\\\//,
        // '**/foo' <-> 'foo'
        () => "^(?:.*\\/)?"
      ],
      // starting
      [
        // there will be no leading '/'
        //   (which has been replaced by section "leading slash")
        // If starts with '**', adding a '^' to the regular expression also works
        /^(?=[^^])/,
        function startingReplacer() {
          return !/\/(?!$)/.test(this) ? "(?:^|\\/)" : "^";
        }
      ],
      // two globstars
      [
        // Use lookahead assertions so that we could match more than one `'/**'`
        /\\\/\\\*\\\*(?=\\\/|$)/g,
        // Zero, one or several directories
        // should not use '*', or it will be replaced by the next replacer
        // Check if it is not the last `'/**'`
        (_, index, str) => index + 6 < str.length ? "(?:\\/[^\\/]+)*" : "\\/.+"
      ],
      // normal intermediate wildcards
      [
        // Never replace escaped '*'
        // ignore rule '\*' will match the path '*'
        // 'abc.*/' -> go
        // 'abc.*'  -> skip this rule,
        //    coz trailing single wildcard will be handed by [trailing wildcard]
        /(^|[^\\]+)(\\\*)+(?=.+)/g,
        // '*.js' matches '.js'
        // '*.js' doesn't match 'abc'
        (_, p1, p2) => {
          const unescaped = p2.replace(/\\\*/g, "[^\\/]*");
          return p1 + unescaped;
        }
      ],
      [
        // unescape, revert step 3 except for back slash
        // For example, if a user escape a '\\*',
        // after step 3, the result will be '\\\\\\*'
        /\\\\\\(?=[$.|*+(){^])/g,
        () => ESCAPE
      ],
      [
        // '\\\\' -> '\\'
        /\\\\/g,
        () => ESCAPE
      ],
      [
        // > The range notation, e.g. [a-zA-Z],
        // > can be used to match one of the characters in a range.
        // `\` is escaped by step 3
        /(\\)?\[([^\]/]*?)(\\*)($|\])/g,
        (match, leadEscape, range, endEscape, close) => leadEscape === ESCAPE ? `\\[${range}${cleanRangeBackSlash(endEscape)}${close}` : close === "]" ? endEscape.length % 2 === 0 ? `[${sanitizeRange(range)}${endEscape}]` : "[]" : "[]"
      ],
      // ending
      [
        // 'js' will not match 'js.'
        // 'ab' will not match 'abc'
        /(?:[^*])$/,
        // WTF!
        // https://git-scm.com/docs/gitignore
        // changes in [2.22.1](https://git-scm.com/docs/gitignore/2.22.1)
        // which re-fixes #24, #38
        // > If there is a separator at the end of the pattern then the pattern
        // > will only match directories, otherwise the pattern can match both
        // > files and directories.
        // 'js*' will not match 'a.js'
        // 'js/' will not match 'a.js'
        // 'js' will match 'a.js' and 'a.js/'
        (match) => /\/$/.test(match) ? `${match}$` : `${match}(?=$|\\/$)`
      ],
      // trailing wildcard
      [
        /(\^|\\\/)?\\\*$/,
        (_, p1) => {
          const prefix = p1 ? `${p1}[^/]+` : "[^/]*";
          return `${prefix}(?=$|\\/$)`;
        }
      ]
    ];
    var regexCache = /* @__PURE__ */ Object.create(null);
    var makeRegex = (pattern, ignoreCase) => {
      let source = regexCache[pattern];
      if (!source) {
        source = REPLACERS.reduce(
          (prev, current) => prev.replace(current[0], current[1].bind(pattern)),
          pattern
        );
        regexCache[pattern] = source;
      }
      return ignoreCase ? new RegExp(source, "i") : new RegExp(source);
    };
    var isString = (subject) => typeof subject === "string";
    var checkPattern = (pattern) => pattern && isString(pattern) && !REGEX_TEST_BLANK_LINE.test(pattern) && !REGEX_INVALID_TRAILING_BACKSLASH.test(pattern) && pattern.indexOf("#") !== 0;
    var splitPattern = (pattern) => pattern.split(REGEX_SPLITALL_CRLF);
    var IgnoreRule = class {
      constructor(origin, pattern, negative, regex) {
        this.origin = origin;
        this.pattern = pattern;
        this.negative = negative;
        this.regex = regex;
      }
    };
    var createRule = (pattern, ignoreCase) => {
      const origin = pattern;
      let negative = false;
      if (pattern.indexOf("!") === 0) {
        negative = true;
        pattern = pattern.substr(1);
      }
      pattern = pattern.replace(REGEX_REPLACE_LEADING_EXCAPED_EXCLAMATION, "!").replace(REGEX_REPLACE_LEADING_EXCAPED_HASH, "#");
      const regex = makeRegex(pattern, ignoreCase);
      return new IgnoreRule(
        origin,
        pattern,
        negative,
        regex
      );
    };
    var throwError = (message, Ctor) => {
      throw new Ctor(message);
    };
    var checkPath = (path, originalPath, doThrow) => {
      if (!isString(path)) {
        return doThrow(
          `path must be a string, but got \`${originalPath}\``,
          TypeError
        );
      }
      if (!path) {
        return doThrow(`path must not be empty`, TypeError);
      }
      if (checkPath.isNotRelative(path)) {
        const r = "`path.relative()`d";
        return doThrow(
          `path should be a ${r} string, but got "${originalPath}"`,
          RangeError
        );
      }
      return true;
    };
    var isNotRelative = (path) => REGEX_TEST_INVALID_PATH.test(path);
    checkPath.isNotRelative = isNotRelative;
    checkPath.convert = (p) => p;
    var Ignore = class {
      constructor({
        ignorecase = true,
        ignoreCase = ignorecase,
        allowRelativePaths = false
      } = {}) {
        define(this, KEY_IGNORE, true);
        this._rules = [];
        this._ignoreCase = ignoreCase;
        this._allowRelativePaths = allowRelativePaths;
        this._initCache();
      }
      _initCache() {
        this._ignoreCache = /* @__PURE__ */ Object.create(null);
        this._testCache = /* @__PURE__ */ Object.create(null);
      }
      _addPattern(pattern) {
        if (pattern && pattern[KEY_IGNORE]) {
          this._rules = this._rules.concat(pattern._rules);
          this._added = true;
          return;
        }
        if (checkPattern(pattern)) {
          const rule = createRule(pattern, this._ignoreCase);
          this._added = true;
          this._rules.push(rule);
        }
      }
      // @param {Array<string> | string | Ignore} pattern
      add(pattern) {
        this._added = false;
        makeArray(
          isString(pattern) ? splitPattern(pattern) : pattern
        ).forEach(this._addPattern, this);
        if (this._added) {
          this._initCache();
        }
        return this;
      }
      // legacy
      addPattern(pattern) {
        return this.add(pattern);
      }
      //          |           ignored : unignored
      // negative |   0:0   |   0:1   |   1:0   |   1:1
      // -------- | ------- | ------- | ------- | --------
      //     0    |  TEST   |  TEST   |  SKIP   |    X
      //     1    |  TESTIF |  SKIP   |  TEST   |    X
      // - SKIP: always skip
      // - TEST: always test
      // - TESTIF: only test if checkUnignored
      // - X: that never happen
      // @param {boolean} whether should check if the path is unignored,
      //   setting `checkUnignored` to `false` could reduce additional
      //   path matching.
      // @returns {TestResult} true if a file is ignored
      _testOne(path, checkUnignored) {
        let ignored = false;
        let unignored = false;
        this._rules.forEach((rule) => {
          const { negative } = rule;
          if (unignored === negative && ignored !== unignored || negative && !ignored && !unignored && !checkUnignored) {
            return;
          }
          const matched = rule.regex.test(path);
          if (matched) {
            ignored = !negative;
            unignored = negative;
          }
        });
        return {
          ignored,
          unignored
        };
      }
      // @returns {TestResult}
      _test(originalPath, cache, checkUnignored, slices) {
        const path = originalPath && checkPath.convert(originalPath);
        checkPath(
          path,
          originalPath,
          this._allowRelativePaths ? RETURN_FALSE : throwError
        );
        return this._t(path, cache, checkUnignored, slices);
      }
      _t(path, cache, checkUnignored, slices) {
        if (path in cache) {
          return cache[path];
        }
        if (!slices) {
          slices = path.split(SLASH);
        }
        slices.pop();
        if (!slices.length) {
          return cache[path] = this._testOne(path, checkUnignored);
        }
        const parent = this._t(
          slices.join(SLASH) + SLASH,
          cache,
          checkUnignored,
          slices
        );
        return cache[path] = parent.ignored ? parent : this._testOne(path, checkUnignored);
      }
      ignores(path) {
        return this._test(path, this._ignoreCache, false).ignored;
      }
      createFilter() {
        return (path) => !this.ignores(path);
      }
      filter(paths) {
        return makeArray(paths).filter(this.createFilter());
      }
      // @returns {TestResult}
      test(path) {
        return this._test(path, this._testCache, true);
      }
    };
    var factory = (options) => new Ignore(options);
    var isPathValid = (path) => checkPath(path && checkPath.convert(path), path, RETURN_FALSE);
    factory.isPathValid = isPathValid;
    factory.default = factory;
    module2.exports = factory;
    if (
      // Detect `process` so that it can run in browsers.
      typeof process !== "undefined" && (process.env && process.env.IGNORE_TEST_WIN32 || process.platform === "win32")
    ) {
      const makePosix = (str) => /^\\\\\?\\/.test(str) || /["<>|\u0000-\u001F]+/u.test(str) ? str : str.replace(/\\/g, "/");
      checkPath.convert = makePosix;
      const REGIX_IS_WINDOWS_PATH_ABSOLUTE = /^[a-z]:\//i;
      checkPath.isNotRelative = (path) => REGIX_IS_WINDOWS_PATH_ABSOLUTE.test(path) || isNotRelative(path);
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/fs/options.js
var require_options = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/fs/options.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.IgnoreMode = exports2.SymlinkFollowMode = void 0;
    var SymlinkFollowMode;
    (function(SymlinkFollowMode2) {
      SymlinkFollowMode2.NEVER = "never", SymlinkFollowMode2.ALWAYS = "always", SymlinkFollowMode2.EXTERNAL = "external", SymlinkFollowMode2.BLOCK_EXTERNAL = "internal-only";
    })(SymlinkFollowMode = exports2.SymlinkFollowMode || (exports2.SymlinkFollowMode = {}));
    var IgnoreMode;
    (function(IgnoreMode2) {
      IgnoreMode2.GLOB = "glob", IgnoreMode2.GIT = "git", IgnoreMode2.DOCKER = "docker";
    })(IgnoreMode = exports2.IgnoreMode || (exports2.IgnoreMode = {}));
  }
});

// node_modules/aws-cdk-lib/core/lib/fs/ignore.js
var require_ignore3 = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/fs/ignore.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DockerIgnoreStrategy = exports2.GitIgnoreStrategy = exports2.GlobIgnoreStrategy = exports2.IgnoreStrategy = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var path = require("path");
    var dockerignore_1 = require_ignore();
    var ignore_1 = require_ignore2();
    var minimatch = require_minimatch();
    var options_1 = require_options();
    var IgnoreStrategy = class {
      static glob(absoluteRootPath, patterns) {
        return new GlobIgnoreStrategy(absoluteRootPath, patterns);
      }
      static git(absoluteRootPath, patterns) {
        return new GitIgnoreStrategy(absoluteRootPath, patterns);
      }
      static docker(absoluteRootPath, patterns) {
        return new DockerIgnoreStrategy(absoluteRootPath, patterns);
      }
      static fromCopyOptions(options, absoluteRootPath) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CopyOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromCopyOptions), error;
        }
        const ignoreMode = options.ignoreMode || options_1.IgnoreMode.GLOB, exclude = options.exclude || [];
        switch (ignoreMode) {
          case options_1.IgnoreMode.GLOB:
            return this.glob(absoluteRootPath, exclude);
          case options_1.IgnoreMode.GIT:
            return this.git(absoluteRootPath, exclude);
          case options_1.IgnoreMode.DOCKER:
            return this.docker(absoluteRootPath, exclude);
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, IgnoreStrategy[_a] = { fqn: "aws-cdk-lib.IgnoreStrategy", version: "2.80.0" }, exports2.IgnoreStrategy = IgnoreStrategy;
    var GlobIgnoreStrategy = class extends IgnoreStrategy {
      constructor(absoluteRootPath, patterns) {
        if (super(), !path.isAbsolute(absoluteRootPath))
          throw new Error("GlobIgnoreStrategy expects an absolute file path");
        this.absoluteRootPath = absoluteRootPath, this.patterns = patterns;
      }
      add(pattern) {
        this.patterns.push(pattern);
      }
      ignores(absoluteFilePath) {
        if (!path.isAbsolute(absoluteFilePath))
          throw new Error("GlobIgnoreStrategy.ignores() expects an absolute path");
        let relativePath = path.relative(this.absoluteRootPath, absoluteFilePath), excludeOutput = false;
        for (const pattern of this.patterns) {
          const negate = pattern.startsWith("!"), match = minimatch(relativePath, pattern, { matchBase: true, flipNegate: true });
          !negate && match && (excludeOutput = true), negate && match && (excludeOutput = false);
        }
        return excludeOutput;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, GlobIgnoreStrategy[_b] = { fqn: "aws-cdk-lib.GlobIgnoreStrategy", version: "2.80.0" }, exports2.GlobIgnoreStrategy = GlobIgnoreStrategy;
    var GitIgnoreStrategy = class extends IgnoreStrategy {
      constructor(absoluteRootPath, patterns) {
        if (super(), !path.isAbsolute(absoluteRootPath))
          throw new Error("GitIgnoreStrategy expects an absolute file path");
        this.absoluteRootPath = absoluteRootPath, this.ignore = (0, ignore_1.default)().add(patterns);
      }
      add(pattern) {
        this.ignore.add(pattern);
      }
      ignores(absoluteFilePath) {
        if (!path.isAbsolute(absoluteFilePath))
          throw new Error("GitIgnoreStrategy.ignores() expects an absolute path");
        let relativePath = path.relative(this.absoluteRootPath, absoluteFilePath);
        return this.ignore.ignores(relativePath);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, GitIgnoreStrategy[_c] = { fqn: "aws-cdk-lib.GitIgnoreStrategy", version: "2.80.0" }, exports2.GitIgnoreStrategy = GitIgnoreStrategy;
    var DockerIgnoreStrategy = class extends IgnoreStrategy {
      constructor(absoluteRootPath, patterns) {
        if (super(), !path.isAbsolute(absoluteRootPath))
          throw new Error("DockerIgnoreStrategy expects an absolute file path");
        this.absoluteRootPath = absoluteRootPath, this.ignore = (0, dockerignore_1.default)().add(patterns);
      }
      add(pattern) {
        this.ignore.add(pattern);
      }
      ignores(absoluteFilePath) {
        if (!path.isAbsolute(absoluteFilePath))
          throw new Error("DockerIgnoreStrategy.ignores() expects an absolute path");
        let relativePath = path.relative(this.absoluteRootPath, absoluteFilePath);
        return this.ignore.ignores(relativePath);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, DockerIgnoreStrategy[_d] = { fqn: "aws-cdk-lib.DockerIgnoreStrategy", version: "2.80.0" }, exports2.DockerIgnoreStrategy = DockerIgnoreStrategy;
  }
});

// node_modules/aws-cdk-lib/core/lib/fs/utils.js
var require_utils4 = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/fs/utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.shouldFollow = void 0;
    var fs = require("fs");
    var path = require("path");
    var options_1 = require_options();
    function shouldFollow(mode, sourceRoot, realPath) {
      switch (mode) {
        case options_1.SymlinkFollowMode.ALWAYS:
          return fs.existsSync(realPath);
        case options_1.SymlinkFollowMode.EXTERNAL:
          return !_isInternal() && fs.existsSync(realPath);
        case options_1.SymlinkFollowMode.BLOCK_EXTERNAL:
          return _isInternal() && fs.existsSync(realPath);
        case options_1.SymlinkFollowMode.NEVER:
          return false;
        default:
          throw new Error(`Unsupported FollowMode: ${mode}`);
      }
      function _isInternal() {
        return path.resolve(realPath).startsWith(path.resolve(sourceRoot));
      }
    }
    exports2.shouldFollow = shouldFollow;
  }
});

// node_modules/aws-cdk-lib/core/lib/fs/copy.js
var require_copy3 = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/fs/copy.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.copyDirectory = void 0;
    var fs = require("fs");
    var path = require("path");
    var ignore_1 = require_ignore3();
    var options_1 = require_options();
    var utils_1 = require_utils4();
    function copyDirectory(srcDir, destDir, options = {}, rootDir) {
      const follow = options.follow ?? options_1.SymlinkFollowMode.EXTERNAL;
      rootDir = rootDir || srcDir;
      const ignoreStrategy = ignore_1.IgnoreStrategy.fromCopyOptions(options, rootDir);
      if (!fs.statSync(srcDir).isDirectory())
        throw new Error(`${srcDir} is not a directory`);
      const files = fs.readdirSync(srcDir);
      for (const file of files) {
        const sourceFilePath = path.join(srcDir, file);
        if (ignoreStrategy.ignores(sourceFilePath))
          continue;
        const destFilePath = path.join(destDir, file);
        let stat = follow === options_1.SymlinkFollowMode.ALWAYS ? fs.statSync(sourceFilePath) : fs.lstatSync(sourceFilePath);
        if (stat && stat.isSymbolicLink()) {
          const target = fs.readlinkSync(sourceFilePath), targetPath = path.normalize(path.resolve(srcDir, target));
          (0, utils_1.shouldFollow)(follow, rootDir, targetPath) ? stat = fs.statSync(sourceFilePath) : (fs.symlinkSync(target, destFilePath), stat = void 0);
        }
        stat && stat.isDirectory() && (fs.mkdirSync(destFilePath), copyDirectory(sourceFilePath, destFilePath, options, rootDir), stat = void 0), stat && stat.isFile() && (fs.copyFileSync(sourceFilePath, destFilePath), stat = void 0);
      }
    }
    exports2.copyDirectory = copyDirectory;
  }
});

// node_modules/aws-cdk-lib/core/lib/private/cache.js
var require_cache = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/private/cache.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Cache = void 0;
    var Cache = class {
      constructor() {
        this.cache = /* @__PURE__ */ new Map();
      }
      clear() {
        this.cache.clear();
      }
      obtain(cacheKey, calcFn) {
        let value = this.cache.get(cacheKey);
        return value || (value = calcFn(), this.cache.set(cacheKey, value), value);
      }
    };
    exports2.Cache = Cache;
  }
});

// node_modules/aws-cdk-lib/core/lib/fs/fingerprint.js
var require_fingerprint = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/fs/fingerprint.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.contentFingerprint = exports2.fingerprint = exports2.clearLargeFileFingerprintCache = void 0;
    var crypto = require("crypto");
    var fs = require("fs");
    var path = require("path");
    var ignore_1 = require_ignore3();
    var options_1 = require_options();
    var utils_1 = require_utils4();
    var cache_1 = require_cache();
    var BUFFER_SIZE = 8 * 1024;
    var CTRL_SOH = "";
    var CTRL_SOT = "";
    var CTRL_ETX = "";
    var CR = "\r";
    var LF = `
`;
    var CRLF = `${CR}${LF}`;
    var fingerprintCache = new cache_1.Cache();
    function clearLargeFileFingerprintCache() {
      fingerprintCache.clear();
    }
    exports2.clearLargeFileFingerprintCache = clearLargeFileFingerprintCache;
    function fingerprint(fileOrDirectory, options = {}) {
      const hash = crypto.createHash("sha256");
      _hashField(hash, "options.extra", options.extraHash || "");
      const follow = options.follow || options_1.SymlinkFollowMode.EXTERNAL;
      _hashField(hash, "options.follow", follow), fileOrDirectory = fs.realpathSync(fileOrDirectory);
      const isDir = fs.statSync(fileOrDirectory).isDirectory(), rootDirectory = isDir ? fileOrDirectory : path.dirname(fileOrDirectory), ignoreMode = options.ignoreMode || options_1.IgnoreMode.GLOB;
      ignoreMode != options_1.IgnoreMode.GLOB && _hashField(hash, "options.ignoreMode", ignoreMode);
      const ignoreStrategy = ignore_1.IgnoreStrategy.fromCopyOptions(options, fileOrDirectory);
      return _processFileOrDirectory(fileOrDirectory, isDir), hash.digest("hex");
      function _processFileOrDirectory(symbolicPath, isRootDir = false, realPath = symbolicPath) {
        if (!isRootDir && ignoreStrategy.ignores(symbolicPath))
          return;
        const stat = fs.lstatSync(realPath), hashComponent = path.relative(fileOrDirectory, symbolicPath).replace(/\\/g, "/");
        if (stat.isSymbolicLink()) {
          const linkTarget = fs.readlinkSync(realPath), resolvedLinkTarget = path.resolve(path.dirname(realPath), linkTarget);
          (0, utils_1.shouldFollow)(follow, rootDirectory, resolvedLinkTarget) ? _processFileOrDirectory(symbolicPath, false, resolvedLinkTarget) : _hashField(hash, `link:${hashComponent}`, linkTarget);
        } else if (stat.isFile())
          _hashField(hash, `file:${hashComponent}`, contentFingerprint(realPath));
        else if (stat.isDirectory())
          for (const item of fs.readdirSync(realPath).sort())
            _processFileOrDirectory(path.join(symbolicPath, item), false, path.join(realPath, item));
        else
          throw new Error(`Unable to hash ${symbolicPath}: it is neither a file nor a directory`);
      }
    }
    exports2.fingerprint = fingerprint;
    function contentFingerprint(file) {
      const stats = fs.statSync(file, { bigint: true }), cacheKey = JSON.stringify({ mtime_unix: stats.mtime.toUTCString(), mtime_ms: stats.mtimeMs.toString(), inode: stats.ino.toString(), size: stats.size.toString() });
      return fingerprintCache.obtain(cacheKey, () => contentFingerprintMiss(file));
    }
    exports2.contentFingerprint = contentFingerprint;
    function contentFingerprintMiss(file) {
      const hash = crypto.createHash("sha256"), buffer = Buffer.alloc(BUFFER_SIZE), fd = fs.openSync(file, fs.constants.O_DSYNC | fs.constants.O_RDONLY | fs.constants.O_SYNC);
      let size = 0, isBinary = false, lastStr = "", read = 0;
      try {
        for (; (read = fs.readSync(fd, buffer, 0, BUFFER_SIZE, null)) !== 0; ) {
          const slicedBuffer = buffer.slice(0, read);
          size === 0 && (isBinary = slicedBuffer.indexOf(0) !== -1);
          let dataBuffer = slicedBuffer;
          if (!isBinary) {
            const str = buffer.slice(0, read).toString();
            if (new RegExp(`${CR}$`).test(str)) {
              lastStr += str;
              continue;
            }
            const normalizedData = (lastStr + str).replace(new RegExp(CRLF, "g"), LF);
            dataBuffer = Buffer.from(normalizedData), lastStr = "";
          }
          size += dataBuffer.length, hash.update(dataBuffer);
        }
        lastStr && hash.update(Buffer.from(lastStr));
      } finally {
        fs.closeSync(fd);
      }
      return `${size}:${hash.digest("hex")}`;
    }
    function _hashField(hash, header, value) {
      hash.update(CTRL_SOH).update(header).update(CTRL_SOT).update(value).update(CTRL_ETX);
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/fs/index.js
var require_fs2 = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/fs/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FileSystem = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var fs = require("fs");
    var os = require("os");
    var path = require("path");
    var copy_1 = require_copy3();
    var fingerprint_1 = require_fingerprint();
    __exportStar(require_ignore3(), exports2), __exportStar(require_options(), exports2);
    var FileSystem = class _FileSystem {
      static copyDirectory(srcDir, destDir, options = {}, rootDir) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CopyOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.copyDirectory), error;
        }
        return (0, copy_1.copyDirectory)(srcDir, destDir, options, rootDir);
      }
      static fingerprint(fileOrDirectory, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_FingerprintOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fingerprint), error;
        }
        return (0, fingerprint_1.fingerprint)(fileOrDirectory, options);
      }
      static isEmpty(dir) {
        return fs.readdirSync(dir).length === 0;
      }
      static get tmpdir() {
        return _FileSystem._tmpdir || (_FileSystem._tmpdir = fs.realpathSync(os.tmpdir())), _FileSystem._tmpdir;
      }
      static mkdtemp(prefix) {
        return fs.mkdtempSync(path.join(_FileSystem.tmpdir, prefix));
      }
    };
    _a = JSII_RTTI_SYMBOL_1, FileSystem[_a] = { fqn: "aws-cdk-lib.FileSystem", version: "2.80.0" }, exports2.FileSystem = FileSystem;
  }
});

// node_modules/aws-cdk-lib/core/lib/private/asset-staging.js
var require_asset_staging = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/private/asset-staging.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.dockerExec = exports2.AssetBundlingVolumeCopy = exports2.AssetBundlingBindMount = void 0;
    var child_process_1 = require("child_process");
    var crypto = require("crypto");
    var os = require("os");
    var asset_staging_1 = require_asset_staging2();
    var AssetBundlingBase = class {
      constructor(options) {
        this.options = options;
      }
      determineUser() {
        let user;
        if (this.options.user)
          user = this.options.user;
        else {
          const userInfo = os.userInfo();
          user = userInfo.uid !== -1 ? `${userInfo.uid}:${userInfo.gid}` : "1000:1000";
        }
        return user;
      }
    };
    var AssetBundlingBindMount = class extends AssetBundlingBase {
      run() {
        this.options.image.run({ command: this.options.command, user: this.determineUser(), environment: this.options.environment, entrypoint: this.options.entrypoint, workingDirectory: this.options.workingDirectory ?? asset_staging_1.AssetStaging.BUNDLING_INPUT_DIR, securityOpt: this.options.securityOpt ?? "", volumesFrom: this.options.volumesFrom, volumes: [{ hostPath: this.options.sourcePath, containerPath: asset_staging_1.AssetStaging.BUNDLING_INPUT_DIR }, { hostPath: this.options.bundleDir, containerPath: asset_staging_1.AssetStaging.BUNDLING_OUTPUT_DIR }, ...this.options.volumes ?? []] });
      }
    };
    exports2.AssetBundlingBindMount = AssetBundlingBindMount;
    var AssetBundlingVolumeCopy = class extends AssetBundlingBase {
      constructor(options) {
        super(options);
        const copySuffix = crypto.randomBytes(12).toString("hex");
        this.inputVolumeName = `assetInput${copySuffix}`, this.outputVolumeName = `assetOutput${copySuffix}`, this.copyContainerName = `copyContainer${copySuffix}`;
      }
      prepareVolumes() {
        dockerExec(["volume", "create", this.inputVolumeName]), dockerExec(["volume", "create", this.outputVolumeName]);
      }
      cleanVolumes() {
        dockerExec(["volume", "rm", this.inputVolumeName]), dockerExec(["volume", "rm", this.outputVolumeName]);
      }
      startHelperContainer(user) {
        dockerExec(["run", "--name", this.copyContainerName, "-v", `${this.inputVolumeName}:${asset_staging_1.AssetStaging.BUNDLING_INPUT_DIR}`, "-v", `${this.outputVolumeName}:${asset_staging_1.AssetStaging.BUNDLING_OUTPUT_DIR}`, "public.ecr.aws/docker/library/alpine", "sh", "-c", `mkdir -p ${asset_staging_1.AssetStaging.BUNDLING_INPUT_DIR} && chown -R ${user} ${asset_staging_1.AssetStaging.BUNDLING_OUTPUT_DIR} && chown -R ${user} ${asset_staging_1.AssetStaging.BUNDLING_INPUT_DIR}`]);
      }
      cleanHelperContainer() {
        dockerExec(["rm", this.copyContainerName]);
      }
      copyInputFrom(sourcePath) {
        dockerExec(["cp", `${sourcePath}/.`, `${this.copyContainerName}:${asset_staging_1.AssetStaging.BUNDLING_INPUT_DIR}`]);
      }
      copyOutputTo(outputPath) {
        dockerExec(["cp", `${this.copyContainerName}:${asset_staging_1.AssetStaging.BUNDLING_OUTPUT_DIR}/.`, outputPath]);
      }
      run() {
        const user = this.determineUser();
        this.prepareVolumes(), this.startHelperContainer(user), this.copyInputFrom(this.options.sourcePath), this.options.image.run({ command: this.options.command, user, environment: this.options.environment, entrypoint: this.options.entrypoint, workingDirectory: this.options.workingDirectory ?? asset_staging_1.AssetStaging.BUNDLING_INPUT_DIR, securityOpt: this.options.securityOpt ?? "", volumes: this.options.volumes, volumesFrom: [this.copyContainerName, ...this.options.volumesFrom ?? []] }), this.copyOutputTo(this.options.bundleDir), this.cleanHelperContainer(), this.cleanVolumes();
      }
    };
    exports2.AssetBundlingVolumeCopy = AssetBundlingVolumeCopy;
    function dockerExec(args, options) {
      const prog = process.env.CDK_DOCKER ?? "docker", proc = (0, child_process_1.spawnSync)(prog, args, options ?? { encoding: "utf-8", stdio: ["ignore", process.stderr, "inherit"] });
      if (proc.error)
        throw proc.error;
      if (proc.status !== 0) {
        let prependLines = function(firstLine, text) {
          if (!text || text.length === 0)
            return [];
          const padding = " ".repeat(firstLine.length);
          return text.toString("utf-8").split(`
`).map((line, idx) => `${idx === 0 ? firstLine : padding}${line}`);
        };
        const reason = proc.signal != null ? `signal ${proc.signal}` : `status ${proc.status}`, command = [prog, ...args.map((arg) => /[^a-z0-9_-]/i.test(arg) ? JSON.stringify(arg) : arg)].join(" ");
        throw new Error([`${prog} exited with ${reason}`, ...prependLines("--> STDOUT:  ", proc.stdout) ?? [], ...prependLines("--> STDERR:  ", proc.stderr) ?? [], `--> Command: ${command}`].join(`
`));
      }
      return proc;
    }
    exports2.dockerExec = dockerExec;
  }
});

// node_modules/aws-cdk-lib/core/lib/private/jsii-deprecated.js
var require_jsii_deprecated = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/private/jsii-deprecated.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.reset = exports2.quiet = void 0;
    function quiet() {
      const deprecated = process.env.JSII_DEPRECATED;
      return process.env.JSII_DEPRECATED = "quiet", deprecated;
    }
    exports2.quiet = quiet;
    function reset(deprecated) {
      deprecated === void 0 ? delete process.env.JSII_DEPRECATED : process.env.JSII_DEPRECATED = deprecated;
    }
    exports2.reset = reset;
  }
});

// node_modules/aws-cdk-lib/core/lib/bundling.js
var require_bundling = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/bundling.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DockerVolumeConsistency = exports2.DockerImage = exports2.BundlingDockerImage = exports2.BundlingFileAccess = exports2.BundlingOutput = exports2.DockerBuildSecret = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var child_process_1 = require("child_process");
    var crypto = require("crypto");
    var path_1 = require("path");
    var fs_1 = require_fs2();
    var asset_staging_1 = require_asset_staging();
    var jsii_deprecated_1 = require_jsii_deprecated();
    var DockerBuildSecret = class {
      static fromSrc(src) {
        return `src=${src}`;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, DockerBuildSecret[_a] = { fqn: "aws-cdk-lib.DockerBuildSecret", version: "2.80.0" }, exports2.DockerBuildSecret = DockerBuildSecret;
    var BundlingOutput;
    (function(BundlingOutput2) {
      BundlingOutput2.ARCHIVED = "archived", BundlingOutput2.NOT_ARCHIVED = "not-archived", BundlingOutput2.AUTO_DISCOVER = "auto-discover";
    })(BundlingOutput = exports2.BundlingOutput || (exports2.BundlingOutput = {}));
    var BundlingFileAccess;
    (function(BundlingFileAccess2) {
      BundlingFileAccess2.VOLUME_COPY = "VOLUME_COPY", BundlingFileAccess2.BIND_MOUNT = "BIND_MOUNT";
    })(BundlingFileAccess = exports2.BundlingFileAccess || (exports2.BundlingFileAccess = {}));
    var BundlingDockerImage = class {
      static fromRegistry(image) {
        return new DockerImage(image);
      }
      static fromAsset(path, options = {}) {
        return DockerImage.fromBuild(path, options);
      }
      constructor(image, _imageHash) {
        this.image = image, this._imageHash = _imageHash;
      }
      toJSON() {
        return this._imageHash ?? this.image;
      }
      run(options = {}) {
        const volumes = options.volumes || [], environment = options.environment || {}, entrypoint = options.entrypoint?.[0] || null, command = [...options.entrypoint?.[1] ? [...options.entrypoint.slice(1)] : [], ...options.command ? [...options.command] : []], dockerArgs = ["run", "--rm", ...options.securityOpt ? ["--security-opt", options.securityOpt] : [], ...options.network ? ["--network", options.network] : [], ...options.user ? ["-u", options.user] : [], ...options.volumesFrom ? flatten(options.volumesFrom.map((v) => ["--volumes-from", v])) : [], ...flatten(volumes.map((v) => ["-v", `${v.hostPath}:${v.containerPath}:${isSeLinux() ? "z," : ""}${v.consistency ?? DockerVolumeConsistency.DELEGATED}`])), ...flatten(Object.entries(environment).map(([k, v]) => ["--env", `${k}=${v}`])), ...options.workingDirectory ? ["-w", options.workingDirectory] : [], ...entrypoint ? ["--entrypoint", entrypoint] : [], this.image, ...command];
        (0, asset_staging_1.dockerExec)(dockerArgs);
      }
      cp(imagePath, outputPath) {
        const { stdout } = (0, asset_staging_1.dockerExec)(["create", this.image], {}), match = stdout.toString().match(/([0-9a-f]{16,})/);
        if (!match)
          throw new Error("Failed to extract container ID from Docker create output");
        const containerId = match[1], containerPath = `${containerId}:${imagePath}`, destPath = outputPath ?? fs_1.FileSystem.mkdtemp("cdk-docker-cp-");
        try {
          return (0, asset_staging_1.dockerExec)(["cp", containerPath, destPath]), destPath;
        } catch (err) {
          throw new Error(`Failed to copy files from ${containerPath} to ${destPath}: ${err}`);
        } finally {
          (0, asset_staging_1.dockerExec)(["rm", "-v", containerId]);
        }
      }
    };
    _b = JSII_RTTI_SYMBOL_1, BundlingDockerImage[_b] = { fqn: "aws-cdk-lib.BundlingDockerImage", version: "2.80.0" }, exports2.BundlingDockerImage = BundlingDockerImage;
    var DockerImage = class _DockerImage extends BundlingDockerImage {
      static fromBuild(path, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_DockerBuildOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromBuild), error;
        }
        const buildArgs = options.buildArgs || {};
        if (options.file && (0, path_1.isAbsolute)(options.file))
          throw new Error(`"file" must be relative to the docker build directory. Got ${options.file}`);
        const input = JSON.stringify({ path, ...options }), tag = `cdk-${crypto.createHash("sha256").update(input).digest("hex")}`, dockerArgs = ["build", "-t", tag, ...options.file ? ["-f", (0, path_1.join)(path, options.file)] : [], ...options.platform ? ["--platform", options.platform] : [], ...options.targetStage ? ["--target", options.targetStage] : [], ...flatten(Object.entries(buildArgs).map(([k, v]) => ["--build-arg", `${k}=${v}`])), path];
        (0, asset_staging_1.dockerExec)(dockerArgs);
        const hash = fs_1.FileSystem.fingerprint(path, { extraHash: JSON.stringify(options) });
        return new _DockerImage(tag, hash);
      }
      static fromRegistry(image) {
        return new _DockerImage(image);
      }
      constructor(image, _imageHash) {
        const deprecated = (0, jsii_deprecated_1.quiet)();
        super(image, _imageHash), (0, jsii_deprecated_1.reset)(deprecated), this.image = image;
      }
      toJSON() {
        const deprecated = (0, jsii_deprecated_1.quiet)(), json = super.toJSON();
        return (0, jsii_deprecated_1.reset)(deprecated), json;
      }
      run(options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_DockerRunOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.run), error;
        }
        const deprecated = (0, jsii_deprecated_1.quiet)(), result = super.run(options);
        return (0, jsii_deprecated_1.reset)(deprecated), result;
      }
      cp(imagePath, outputPath) {
        const deprecated = (0, jsii_deprecated_1.quiet)(), result = super.cp(imagePath, outputPath);
        return (0, jsii_deprecated_1.reset)(deprecated), result;
      }
    };
    _c = JSII_RTTI_SYMBOL_1, DockerImage[_c] = { fqn: "aws-cdk-lib.DockerImage", version: "2.80.0" }, exports2.DockerImage = DockerImage;
    var DockerVolumeConsistency;
    (function(DockerVolumeConsistency2) {
      DockerVolumeConsistency2.CONSISTENT = "consistent", DockerVolumeConsistency2.DELEGATED = "delegated", DockerVolumeConsistency2.CACHED = "cached";
    })(DockerVolumeConsistency = exports2.DockerVolumeConsistency || (exports2.DockerVolumeConsistency = {}));
    function flatten(x) {
      return Array.prototype.concat([], ...x);
    }
    function isSeLinux() {
      if (process.platform != "linux")
        return false;
      const prog = "selinuxenabled", proc = (0, child_process_1.spawnSync)(prog, [], { stdio: ["pipe", process.stderr, "inherit"] });
      return proc.error ? false : proc.status == 0;
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/asset-staging.js
var require_asset_staging2 = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/asset-staging.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AssetStaging = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var crypto = require("crypto");
    var path = require("path");
    var constructs_1 = require_lib2();
    var fs = require_lib6();
    var assets_1 = require_assets3();
    var bundling_1 = require_bundling();
    var fs_1 = require_fs2();
    var fingerprint_1 = require_fingerprint();
    var names_1 = require_names();
    var asset_staging_1 = require_asset_staging();
    var cache_1 = require_cache();
    var stack_1 = require_stack();
    var stage_1 = require_stage();
    var cxapi = require_cx_api();
    var ARCHIVE_EXTENSIONS = [".tar.gz", ".zip", ".jar", ".tar", ".tgz"];
    var ASSET_SALT_CONTEXT_KEY = "@aws-cdk/core:assetHashSalt";
    var AssetStaging = class _AssetStaging extends constructs_1.Construct {
      static clearAssetHashCache() {
        this.assetCache.clear(), (0, fingerprint_1.clearLargeFileFingerprintCache)();
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_AssetStagingProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AssetStaging), error;
        }
        const salt = this.node.tryGetContext(ASSET_SALT_CONTEXT_KEY);
        if (this.sourcePath = path.resolve(props.sourcePath), this.fingerprintOptions = { ...props, extraHash: props.extraHash || salt ? `${props.extraHash ?? ""}${salt ?? ""}` : void 0 }, !fs.existsSync(this.sourcePath))
          throw new Error(`Cannot find asset at ${this.sourcePath}`);
        this.sourceStats = fs.statSync(this.sourcePath);
        const outdir = stage_1.Stage.of(this)?.assetOutdir;
        if (!outdir)
          throw new Error('unable to determine cloud assembly asset output directory. Assets must be defined indirectly within a "Stage" or an "App" scope');
        this.assetOutdir = outdir, this.customSourceFingerprint = props.assetHash, this.hashType = determineHashType(props.assetHashType, this.customSourceFingerprint);
        let stageThisAsset, skip = false;
        if (props.bundling) {
          skip = !stack_1.Stack.of(this).bundlingRequired;
          const bundling = props.bundling;
          stageThisAsset = () => this.stageByBundling(bundling, skip);
        } else
          stageThisAsset = () => this.stageByCopying();
        this.cacheKey = calculateCacheKey({ outdir: this.assetOutdir, sourcePath: path.resolve(props.sourcePath), bundling: props.bundling, assetHashType: this.hashType, customFingerprint: this.customSourceFingerprint, extraHash: props.extraHash, exclude: props.exclude, ignoreMode: props.ignoreMode, skip });
        const staged = _AssetStaging.assetCache.obtain(this.cacheKey, stageThisAsset);
        this.stagedPath = staged.stagedPath, this.absoluteStagedPath = staged.stagedPath, this.assetHash = staged.assetHash, this.packaging = staged.packaging, this.isArchive = staged.isArchive;
      }
      get sourceHash() {
        return this.assetHash;
      }
      relativeStagedPath(stack) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Stack(stack);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.relativeStagedPath), error;
        }
        const asmManifestDir = stage_1.Stage.of(stack)?.outdir;
        return asmManifestDir ? path.relative(this.assetOutdir, this.stagedPath).startsWith("..") || this.stagingDisabled ? this.stagedPath : path.relative(asmManifestDir, this.stagedPath) : this.stagedPath;
      }
      stageByCopying() {
        const assetHash = this.calculateHash(this.hashType), stagedPath = this.stagingDisabled ? this.sourcePath : path.resolve(this.assetOutdir, renderAssetFilename(assetHash, getExtension(this.sourcePath)));
        if (!this.sourceStats.isDirectory() && !this.sourceStats.isFile())
          throw new Error(`Asset ${this.sourcePath} is expected to be either a directory or a regular file`);
        return this.stageAsset(this.sourcePath, stagedPath, "copy"), { assetHash, stagedPath, packaging: this.sourceStats.isDirectory() ? assets_1.FileAssetPackaging.ZIP_DIRECTORY : assets_1.FileAssetPackaging.FILE, isArchive: this.sourceStats.isDirectory() || ARCHIVE_EXTENSIONS.includes(getExtension(this.sourcePath).toLowerCase()) };
      }
      stageByBundling(bundling, skip) {
        if (!this.sourceStats.isDirectory())
          throw new Error(`Asset ${this.sourcePath} is expected to be a directory when bundling`);
        if (skip) {
          let hashType = this.hashType;
          return (hashType === assets_1.AssetHashType.OUTPUT || hashType === assets_1.AssetHashType.BUNDLE) && (this.customSourceFingerprint = names_1.Names.uniqueId(this), hashType = assets_1.AssetHashType.CUSTOM), { assetHash: this.calculateHash(hashType, bundling), stagedPath: this.sourcePath, packaging: assets_1.FileAssetPackaging.ZIP_DIRECTORY, isArchive: true };
        }
        let assetHash = this.hashType === assets_1.AssetHashType.SOURCE || this.hashType === assets_1.AssetHashType.CUSTOM ? this.calculateHash(this.hashType, bundling) : void 0;
        const bundleDir = this.determineBundleDir(this.assetOutdir, assetHash);
        this.bundle(bundling, bundleDir);
        const bundlingOutputType = bundling.outputType ?? bundling_1.BundlingOutput.AUTO_DISCOVER, bundledAsset = determineBundledAsset(bundleDir, bundlingOutputType);
        assetHash = assetHash ?? this.calculateHash(this.hashType, bundling, bundledAsset.path);
        const stagedPath = path.resolve(this.assetOutdir, renderAssetFilename(assetHash, bundledAsset.extension));
        return this.stageAsset(bundledAsset.path, stagedPath, "move"), bundledAsset.packaging === assets_1.FileAssetPackaging.FILE && fs.closeSync(fs.openSync(bundledAsset.path, "w")), { assetHash, stagedPath, packaging: bundledAsset.packaging, isArchive: true };
      }
      get stagingDisabled() {
        return !!this.node.tryGetContext(cxapi.DISABLE_ASSET_STAGING_CONTEXT);
      }
      stageAsset(sourcePath, targetPath, style) {
        if (fs.existsSync(targetPath)) {
          style === "move" && sourcePath !== targetPath && fs.removeSync(sourcePath);
          return;
        }
        if (style == "move") {
          fs.renameSync(sourcePath, targetPath);
          return;
        }
        if (this.sourceStats.isFile())
          fs.copyFileSync(sourcePath, targetPath);
        else if (this.sourceStats.isDirectory())
          fs.mkdirSync(targetPath), fs_1.FileSystem.copyDirectory(sourcePath, targetPath, this.fingerprintOptions);
        else
          throw new Error(`Unknown file type: ${sourcePath}`);
      }
      determineBundleDir(outdir, sourceHash) {
        return sourceHash ? path.resolve(outdir, renderAssetFilename(sourceHash)) : path.resolve(outdir, `bundling-temp-${this.cacheKey}`);
      }
      bundle(options, bundleDir) {
        if (fs.existsSync(bundleDir))
          return;
        fs.ensureDirSync(bundleDir), fs.chmodSync(bundleDir, 511);
        let localBundling;
        try {
          if (process.stderr.write(`Bundling asset ${this.node.path}...
`), localBundling = options.local?.tryBundle(bundleDir, options), !localBundling) {
            const assetStagingOptions = { sourcePath: this.sourcePath, bundleDir, ...options };
            switch (options.bundlingFileAccess) {
              case bundling_1.BundlingFileAccess.VOLUME_COPY:
                new asset_staging_1.AssetBundlingVolumeCopy(assetStagingOptions).run();
                break;
              case bundling_1.BundlingFileAccess.BIND_MOUNT:
              default:
                new asset_staging_1.AssetBundlingBindMount(assetStagingOptions).run();
                break;
            }
          }
        } catch (err) {
          const bundleErrorDir = bundleDir + "-error";
          throw fs.existsSync(bundleErrorDir) && fs.removeSync(bundleErrorDir), fs.renameSync(bundleDir, bundleErrorDir), new Error(`Failed to bundle asset ${this.node.path}, bundle output is located at ${bundleErrorDir}: ${err}`);
        }
        if (fs_1.FileSystem.isEmpty(bundleDir)) {
          const outputDir = localBundling ? bundleDir : _AssetStaging.BUNDLING_OUTPUT_DIR;
          throw new Error(`Bundling did not produce any output. Check that content is written to ${outputDir}.`);
        }
      }
      calculateHash(hashType, bundling, outputDir) {
        if (hashType == assets_1.AssetHashType.CUSTOM || hashType == assets_1.AssetHashType.SOURCE && bundling) {
          const hash = crypto.createHash("sha256");
          return hash.update(this.customSourceFingerprint ?? fs_1.FileSystem.fingerprint(this.sourcePath, this.fingerprintOptions)), bundling && hash.update(JSON.stringify(bundling)), hash.digest("hex");
        }
        switch (hashType) {
          case assets_1.AssetHashType.SOURCE:
            return fs_1.FileSystem.fingerprint(this.sourcePath, this.fingerprintOptions);
          case assets_1.AssetHashType.BUNDLE:
          case assets_1.AssetHashType.OUTPUT:
            if (!outputDir)
              throw new Error(`Cannot use \`${hashType}\` hash type when \`bundling\` is not specified.`);
            return fs_1.FileSystem.fingerprint(outputDir, this.fingerprintOptions);
          default:
            throw new Error("Unknown asset hash type.");
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AssetStaging[_a] = { fqn: "aws-cdk-lib.AssetStaging", version: "2.80.0" }, AssetStaging.BUNDLING_INPUT_DIR = "/asset-input", AssetStaging.BUNDLING_OUTPUT_DIR = "/asset-output", AssetStaging.assetCache = new cache_1.Cache(), exports2.AssetStaging = AssetStaging;
    function renderAssetFilename(assetHash, extension = "") {
      return `asset.${assetHash}${extension}`;
    }
    function determineHashType(assetHashType, customSourceFingerprint) {
      const hashType = customSourceFingerprint ? assetHashType ?? assets_1.AssetHashType.CUSTOM : assetHashType ?? assets_1.AssetHashType.SOURCE;
      if (customSourceFingerprint && hashType !== assets_1.AssetHashType.CUSTOM)
        throw new Error(`Cannot specify \`${assetHashType}\` for \`assetHashType\` when \`assetHash\` is specified. Use \`CUSTOM\` or leave \`undefined\`.`);
      if (hashType === assets_1.AssetHashType.CUSTOM && !customSourceFingerprint)
        throw new Error("`assetHash` must be specified when `assetHashType` is set to `AssetHashType.CUSTOM`.");
      return hashType;
    }
    function calculateCacheKey(props) {
      return crypto.createHash("sha256").update(JSON.stringify(sortObject(props))).digest("hex");
    }
    function sortObject(object) {
      if (typeof object != "object" || object instanceof Array)
        return object;
      const ret = {};
      for (const key of Object.keys(object).sort())
        ret[key] = sortObject(object[key]);
      return ret;
    }
    function singleArchiveFile(directory) {
      if (!fs.existsSync(directory))
        throw new Error(`Directory ${directory} does not exist.`);
      if (!fs.statSync(directory).isDirectory())
        throw new Error(`${directory} is not a directory.`);
      const content = fs.readdirSync(directory);
      if (content.length === 1) {
        const file = path.join(directory, content[0]), extension = getExtension(content[0]).toLowerCase();
        if (fs.statSync(file).isFile() && ARCHIVE_EXTENSIONS.includes(extension))
          return file;
      }
    }
    function determineBundledAsset(bundleDir, outputType) {
      const archiveFile = singleArchiveFile(bundleDir);
      switch (outputType === bundling_1.BundlingOutput.AUTO_DISCOVER && (outputType = archiveFile ? bundling_1.BundlingOutput.ARCHIVED : bundling_1.BundlingOutput.NOT_ARCHIVED), outputType) {
        case bundling_1.BundlingOutput.NOT_ARCHIVED:
          return { path: bundleDir, packaging: assets_1.FileAssetPackaging.ZIP_DIRECTORY };
        case bundling_1.BundlingOutput.ARCHIVED:
          if (!archiveFile)
            throw new Error("Bundling output directory is expected to include only a single archive file when `output` is set to `ARCHIVED`");
          return { path: archiveFile, packaging: assets_1.FileAssetPackaging.FILE, extension: getExtension(archiveFile) };
      }
    }
    function getExtension(source) {
      for (const ext of ARCHIVE_EXTENSIONS)
        if (source.toLowerCase().endsWith(ext))
          return ext;
      return path.extname(source);
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/duration.js
var require_duration = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/duration.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Duration = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var token_1 = require_token2();
    var Duration = class _Duration {
      static millis(amount) {
        return new _Duration(amount, TimeUnit.Milliseconds);
      }
      static seconds(amount) {
        return new _Duration(amount, TimeUnit.Seconds);
      }
      static minutes(amount) {
        return new _Duration(amount, TimeUnit.Minutes);
      }
      static hours(amount) {
        return new _Duration(amount, TimeUnit.Hours);
      }
      static days(amount) {
        return new _Duration(amount, TimeUnit.Days);
      }
      static parse(duration) {
        const matches = duration.match(/^P(?:(\d+)D)?(?:T(?:(\d+)H)?(?:(\d+)M)?(?:(\d+)\.?(\d{1,3})?S)?)?$/);
        if (!matches)
          throw new Error(`Not a valid ISO duration: ${duration}`);
        const [, days, hours, minutes, seconds, milliseconds] = matches;
        if (!days && !hours && !minutes && !seconds && !milliseconds)
          throw new Error(`Not a valid ISO duration: ${duration}`);
        const millis = milliseconds ? milliseconds.padEnd(3, "0") : "";
        return _Duration.millis(_toInt(millis) + _toInt(seconds) * TimeUnit.Seconds.inMillis + _toInt(minutes) * TimeUnit.Minutes.inMillis + _toInt(hours) * TimeUnit.Hours.inMillis + _toInt(days) * TimeUnit.Days.inMillis);
        function _toInt(str) {
          return str ? Number(str) : 0;
        }
      }
      constructor(amount, unit) {
        if (!token_1.Token.isUnresolved(amount) && amount < 0)
          throw new Error(`Duration amounts cannot be negative. Received: ${amount}`);
        this.amount = amount, this.unit = unit;
      }
      plus(rhs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Duration(rhs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.plus), error;
        }
        const targetUnit = finestUnit(this.unit, rhs.unit), res = convert(this.amount, this.unit, targetUnit, {}) + convert(rhs.amount, rhs.unit, targetUnit, {});
        return new _Duration(res, targetUnit);
      }
      minus(rhs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Duration(rhs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.minus), error;
        }
        const targetUnit = finestUnit(this.unit, rhs.unit), res = convert(this.amount, this.unit, targetUnit, {}) - convert(rhs.amount, rhs.unit, targetUnit, {});
        return new _Duration(res, targetUnit);
      }
      toMilliseconds(opts = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TimeConversionOptions(opts);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.toMilliseconds), error;
        }
        return convert(this.amount, this.unit, TimeUnit.Milliseconds, opts);
      }
      toSeconds(opts = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TimeConversionOptions(opts);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.toSeconds), error;
        }
        return convert(this.amount, this.unit, TimeUnit.Seconds, opts);
      }
      toMinutes(opts = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TimeConversionOptions(opts);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.toMinutes), error;
        }
        return convert(this.amount, this.unit, TimeUnit.Minutes, opts);
      }
      toHours(opts = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TimeConversionOptions(opts);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.toHours), error;
        }
        return convert(this.amount, this.unit, TimeUnit.Hours, opts);
      }
      toDays(opts = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TimeConversionOptions(opts);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.toDays), error;
        }
        return convert(this.amount, this.unit, TimeUnit.Days, opts);
      }
      toIsoString() {
        if (this.amount === 0)
          return "PT0S";
        const ret = ["P"];
        let tee = false;
        for (const [amount, unit] of this.components(true))
          [TimeUnit.Seconds, TimeUnit.Minutes, TimeUnit.Hours].includes(unit) && !tee && (ret.push("T"), tee = true), ret.push(`${amount}${unit.isoLabel}`);
        return ret.join("");
      }
      toISOString() {
        return this.toIsoString();
      }
      toHumanString() {
        if (this.amount === 0)
          return fmtUnit(0, this.unit);
        if (token_1.Token.isUnresolved(this.amount))
          return `<token> ${this.unit.label}`;
        return this.components(false).slice(0, 2).map(([amount, unit]) => fmtUnit(amount, unit)).join(" ");
        function fmtUnit(amount, unit) {
          return amount === 1 ? `${amount} ${unit.label.substring(0, unit.label.length - 1)}` : `${amount} ${unit.label}`;
        }
      }
      toString() {
        return `Duration.${this.unit.label}(${this.amount})`;
      }
      components(combineMillisWithSeconds) {
        const ret = new Array();
        let millis = convert(this.amount, this.unit, TimeUnit.Milliseconds, { integral: false });
        for (const unit of [TimeUnit.Days, TimeUnit.Hours, TimeUnit.Minutes, TimeUnit.Seconds]) {
          const count = convert(millis, TimeUnit.Milliseconds, unit, { integral: false }), wholeCount = unit === TimeUnit.Seconds && combineMillisWithSeconds ? count : Math.floor(count);
          wholeCount > 0 && (ret.push([wholeCount, unit]), millis -= wholeCount * unit.inMillis);
        }
        return millis > 1e-4 && ret.push([millis, TimeUnit.Milliseconds]), ret;
      }
      isUnresolved() {
        return token_1.Token.isUnresolved(this.amount);
      }
      unitLabel() {
        return this.unit.label;
      }
      formatTokenToNumber() {
        return `${token_1.Tokenization.stringifyNumber(this.amount)} ${this.unit.label}`;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Duration[_a] = { fqn: "aws-cdk-lib.Duration", version: "2.80.0" }, exports2.Duration = Duration;
    var TimeUnit = class {
      constructor(label, isoLabel, inMillis) {
        this.label = label, this.isoLabel = isoLabel, this.inMillis = inMillis;
      }
      toString() {
        return this.label;
      }
    };
    TimeUnit.Milliseconds = new TimeUnit("millis", "", 1), TimeUnit.Seconds = new TimeUnit("seconds", "S", 1e3), TimeUnit.Minutes = new TimeUnit("minutes", "M", 6e4), TimeUnit.Hours = new TimeUnit("hours", "H", 36e5), TimeUnit.Days = new TimeUnit("days", "D", 864e5);
    function convert(amount, fromUnit, toUnit, { integral = true }) {
      if (fromUnit.inMillis === toUnit.inMillis) {
        if (integral && !token_1.Token.isUnresolved(amount) && !Number.isInteger(amount))
          throw new Error(`${amount} must be a whole number of ${toUnit}.`);
        return amount;
      }
      if (token_1.Token.isUnresolved(amount))
        throw new Error(`Duration must be specified as 'Duration.${toUnit}()' here since its value comes from a token and cannot be converted (got Duration.${fromUnit})`);
      const value = amount * fromUnit.inMillis / toUnit.inMillis;
      if (!Number.isInteger(value) && integral)
        throw new Error(`'${amount} ${fromUnit}' cannot be converted into a whole number of ${toUnit}.`);
      return value;
    }
    function finestUnit(a, b) {
      return a.inMillis < b.inMillis ? a : b;
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/cfn-pseudo.js
var require_cfn_pseudo = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/cfn-pseudo.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ScopedAws = exports2.Aws = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cfn_reference_1 = require_cfn_reference();
    var token_1 = require_token2();
    var AWS_ACCOUNTID = "AWS::AccountId";
    var AWS_URLSUFFIX = "AWS::URLSuffix";
    var AWS_NOTIFICATIONARNS = "AWS::NotificationARNs";
    var AWS_PARTITION = "AWS::Partition";
    var AWS_REGION = "AWS::Region";
    var AWS_STACKID = "AWS::StackId";
    var AWS_STACKNAME = "AWS::StackName";
    var AWS_NOVALUE = "AWS::NoValue";
    var Aws = class {
      constructor() {
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Aws[_a] = { fqn: "aws-cdk-lib.Aws", version: "2.80.0" }, Aws.ACCOUNT_ID = pseudoString(AWS_ACCOUNTID), Aws.URL_SUFFIX = pseudoString(AWS_URLSUFFIX), Aws.NOTIFICATION_ARNS = token_1.Token.asList({ Ref: AWS_NOTIFICATIONARNS }, { displayHint: AWS_NOTIFICATIONARNS }), Aws.PARTITION = pseudoString(AWS_PARTITION), Aws.REGION = pseudoString(AWS_REGION), Aws.STACK_ID = pseudoString(AWS_STACKID), Aws.STACK_NAME = pseudoString(AWS_STACKNAME), Aws.NO_VALUE = pseudoString(AWS_NOVALUE), exports2.Aws = Aws;
    var ScopedAws = class {
      constructor(scope) {
        this.scope = scope;
      }
      get accountId() {
        return this.asString(AWS_ACCOUNTID);
      }
      get urlSuffix() {
        return this.asString(AWS_URLSUFFIX);
      }
      get notificationArns() {
        return token_1.Token.asList(cfn_reference_1.CfnReference.forPseudo(AWS_NOTIFICATIONARNS, this.scope), { displayHint: AWS_NOTIFICATIONARNS });
      }
      get partition() {
        return this.asString(AWS_PARTITION);
      }
      get region() {
        return this.asString(AWS_REGION);
      }
      get stackId() {
        return this.asString(AWS_STACKID);
      }
      get stackName() {
        return this.asString(AWS_STACKNAME);
      }
      asString(name) {
        return token_1.Token.asString(cfn_reference_1.CfnReference.forPseudo(name, this.scope), { displayHint: name });
      }
    };
    _b = JSII_RTTI_SYMBOL_1, ScopedAws[_b] = { fqn: "aws-cdk-lib.ScopedAws", version: "2.80.0" }, exports2.ScopedAws = ScopedAws;
    function pseudoString(name) {
      return token_1.Token.asString({ Ref: name }, { displayHint: name.replace("::", ".") });
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/cfn-resource-policy.js
var require_cfn_resource_policy = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/cfn-resource-policy.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnDeletionPolicy = void 0;
    var CfnDeletionPolicy;
    (function(CfnDeletionPolicy2) {
      CfnDeletionPolicy2.DELETE = "Delete", CfnDeletionPolicy2.RETAIN = "Retain", CfnDeletionPolicy2.SNAPSHOT = "Snapshot";
    })(CfnDeletionPolicy = exports2.CfnDeletionPolicy || (exports2.CfnDeletionPolicy = {}));
  }
});

// node_modules/aws-cdk-lib/core/lib/helpers-internal/cfn-parse.js
var require_cfn_parse = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/helpers-internal/cfn-parse.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnParser = exports2.CfnParsingContext = exports2.FromCloudFormation = exports2.FromCloudFormationPropertyObject = exports2.FromCloudFormationResult = void 0;
    var cfn_fn_1 = require_cfn_fn();
    var cfn_pseudo_1 = require_cfn_pseudo();
    var cfn_resource_policy_1 = require_cfn_resource_policy();
    var lazy_1 = require_lazy();
    var cfn_reference_1 = require_cfn_reference();
    var token_1 = require_token2();
    var util_1 = require_util2();
    var FromCloudFormationResult = class {
      constructor(value) {
        this.value = value, this.extraProperties = {};
      }
      appendExtraProperties(prefix, properties) {
        for (const [key, val] of Object.entries(properties ?? {}))
          this.extraProperties[`${prefix}.${key}`] = val;
      }
    };
    exports2.FromCloudFormationResult = FromCloudFormationResult;
    var FromCloudFormationPropertyObject = class extends FromCloudFormationResult {
      constructor() {
        super({}), this.recognizedProperties = /* @__PURE__ */ new Set();
      }
      addPropertyResult(cdkPropName, cfnPropName, result) {
        this.recognizedProperties.add(cfnPropName), result && (this.value[cdkPropName] = result.value, this.appendExtraProperties(cfnPropName, result.extraProperties));
      }
      addUnrecognizedPropertiesAsExtra(properties) {
        for (const [key, val] of Object.entries(properties))
          this.recognizedProperties.has(key) || (this.extraProperties[key] = val);
      }
    };
    exports2.FromCloudFormationPropertyObject = FromCloudFormationPropertyObject;
    var FromCloudFormation = class {
      static getAny(value) {
        return new FromCloudFormationResult(value);
      }
      static getBoolean(value) {
        if (typeof value == "string")
          switch (value) {
            case "true":
              return new FromCloudFormationResult(true);
            case "false":
              return new FromCloudFormationResult(false);
            default:
              throw new Error(`Expected 'true' or 'false' for boolean value, got: '${value}'`);
          }
        return new FromCloudFormationResult(value);
      }
      static getDate(value) {
        return (0, token_1.isResolvableObject)(value) ? new FromCloudFormationResult(value) : typeof value == "string" ? new FromCloudFormationResult(new Date(value)) : new FromCloudFormationResult(value);
      }
      static getString(value) {
        return (0, token_1.isResolvableObject)(value) ? new FromCloudFormationResult(value.toString()) : typeof value == "number" ? new FromCloudFormationResult(value.toString()) : typeof value == "boolean" ? new FromCloudFormationResult(value.toString()) : new FromCloudFormationResult(value);
      }
      static getNumber(value) {
        if ((0, token_1.isResolvableObject)(value))
          return new FromCloudFormationResult(token_1.Token.asNumber(value));
        if (typeof value == "string") {
          const parsedValue = parseFloat(value);
          if (!isNaN(parsedValue))
            return new FromCloudFormationResult(parsedValue);
        }
        return new FromCloudFormationResult(value);
      }
      static getStringArray(value) {
        return (0, token_1.isResolvableObject)(value) ? new FromCloudFormationResult(token_1.Token.asList(value)) : this.getArray(this.getString)(value);
      }
      static getArray(mapper) {
        return (value) => {
          if (!Array.isArray(value))
            return new FromCloudFormationResult(value);
          const values = new Array(), ret = new FromCloudFormationResult(values);
          for (let i = 0; i < value.length; i++) {
            const result = mapper(value[i]);
            values.push(result.value), ret.appendExtraProperties(`${i}`, result.extraProperties);
          }
          return ret;
        };
      }
      static getMap(mapper) {
        return (value) => {
          if (typeof value != "object")
            return new FromCloudFormationResult(value);
          const values = {}, ret = new FromCloudFormationResult(values);
          for (const [key, val] of Object.entries(value)) {
            const result = mapper(val);
            values[key] = result.value, ret.appendExtraProperties(key, result.extraProperties);
          }
          return ret;
        };
      }
      static getCfnTag(tag) {
        return tag == null ? new FromCloudFormationResult({}) : new FromCloudFormationResult({ key: tag.Key, value: tag.Value });
      }
      static getTypeUnion(validators, mappers) {
        return (value) => {
          for (let i = 0; i < validators.length; i++) {
            const candidate = mappers[i](value);
            if (validators[i](candidate.value).isSuccess)
              return candidate;
          }
          return new FromCloudFormationResult(value);
        };
      }
    };
    exports2.FromCloudFormation = FromCloudFormation;
    var CfnParsingContext;
    (function(CfnParsingContext2) {
      CfnParsingContext2[CfnParsingContext2.CONDITIONS = 0] = "CONDITIONS", CfnParsingContext2[CfnParsingContext2.RULES = 1] = "RULES";
    })(CfnParsingContext = exports2.CfnParsingContext || (exports2.CfnParsingContext = {}));
    var CfnParser = class {
      constructor(options) {
        this.options = options;
      }
      handleAttributes(resource, resourceAttributes, logicalId) {
        const cfnOptions = resource.cfnOptions;
        if (cfnOptions.creationPolicy = this.parseCreationPolicy(resourceAttributes.CreationPolicy), cfnOptions.updatePolicy = this.parseUpdatePolicy(resourceAttributes.UpdatePolicy), cfnOptions.deletionPolicy = this.parseDeletionPolicy(resourceAttributes.DeletionPolicy), cfnOptions.updateReplacePolicy = this.parseDeletionPolicy(resourceAttributes.UpdateReplacePolicy), cfnOptions.version = this.parseValue(resourceAttributes.Version), cfnOptions.description = this.parseValue(resourceAttributes.Description), cfnOptions.metadata = this.parseValue(resourceAttributes.Metadata), resourceAttributes.Condition) {
          const condition = this.finder.findCondition(resourceAttributes.Condition);
          if (!condition)
            throw new Error(`Resource '${logicalId}' uses Condition '${resourceAttributes.Condition}' that doesn't exist`);
          cfnOptions.condition = condition;
        }
        resourceAttributes.DependsOn = resourceAttributes.DependsOn ?? [];
        const dependencies = Array.isArray(resourceAttributes.DependsOn) ? resourceAttributes.DependsOn : [resourceAttributes.DependsOn];
        for (const dep of dependencies) {
          const depResource = this.finder.findResource(dep);
          if (!depResource)
            throw new Error(`Resource '${logicalId}' depends on '${dep}' that doesn't exist`);
          resource.node.addDependency(depResource);
        }
      }
      parseCreationPolicy(policy) {
        if (typeof policy != "object")
          return;
        return policy = this.parseValue(policy), (0, util_1.undefinedIfAllValuesAreEmpty)({ autoScalingCreationPolicy: parseAutoScalingCreationPolicy(policy.AutoScalingCreationPolicy), resourceSignal: parseResourceSignal(policy.ResourceSignal) });
        function parseAutoScalingCreationPolicy(p) {
          if (typeof p == "object")
            return (0, util_1.undefinedIfAllValuesAreEmpty)({ minSuccessfulInstancesPercent: FromCloudFormation.getNumber(p.MinSuccessfulInstancesPercent).value });
        }
        function parseResourceSignal(p) {
          if (typeof p == "object")
            return (0, util_1.undefinedIfAllValuesAreEmpty)({ count: FromCloudFormation.getNumber(p.Count).value, timeout: FromCloudFormation.getString(p.Timeout).value });
        }
      }
      parseUpdatePolicy(policy) {
        if (typeof policy != "object")
          return;
        return policy = this.parseValue(policy), (0, util_1.undefinedIfAllValuesAreEmpty)({ autoScalingReplacingUpdate: parseAutoScalingReplacingUpdate(policy.AutoScalingReplacingUpdate), autoScalingRollingUpdate: parseAutoScalingRollingUpdate(policy.AutoScalingRollingUpdate), autoScalingScheduledAction: parseAutoScalingScheduledAction(policy.AutoScalingScheduledAction), codeDeployLambdaAliasUpdate: parseCodeDeployLambdaAliasUpdate(policy.CodeDeployLambdaAliasUpdate), enableVersionUpgrade: FromCloudFormation.getBoolean(policy.EnableVersionUpgrade).value, useOnlineResharding: FromCloudFormation.getBoolean(policy.UseOnlineResharding).value });
        function parseAutoScalingReplacingUpdate(p) {
          if (typeof p == "object")
            return (0, util_1.undefinedIfAllValuesAreEmpty)({ willReplace: p.WillReplace });
        }
        function parseAutoScalingRollingUpdate(p) {
          if (typeof p == "object")
            return (0, util_1.undefinedIfAllValuesAreEmpty)({ maxBatchSize: FromCloudFormation.getNumber(p.MaxBatchSize).value, minInstancesInService: FromCloudFormation.getNumber(p.MinInstancesInService).value, minSuccessfulInstancesPercent: FromCloudFormation.getNumber(p.MinSuccessfulInstancesPercent).value, pauseTime: FromCloudFormation.getString(p.PauseTime).value, suspendProcesses: FromCloudFormation.getStringArray(p.SuspendProcesses).value, waitOnResourceSignals: FromCloudFormation.getBoolean(p.WaitOnResourceSignals).value });
        }
        function parseCodeDeployLambdaAliasUpdate(p) {
          if (typeof p == "object")
            return { beforeAllowTrafficHook: FromCloudFormation.getString(p.BeforeAllowTrafficHook).value, afterAllowTrafficHook: FromCloudFormation.getString(p.AfterAllowTrafficHook).value, applicationName: FromCloudFormation.getString(p.ApplicationName).value, deploymentGroupName: FromCloudFormation.getString(p.DeploymentGroupName).value };
        }
        function parseAutoScalingScheduledAction(p) {
          if (typeof p == "object")
            return (0, util_1.undefinedIfAllValuesAreEmpty)({ ignoreUnmodifiedGroupSizeProperties: FromCloudFormation.getBoolean(p.IgnoreUnmodifiedGroupSizeProperties).value });
        }
      }
      parseDeletionPolicy(policy) {
        switch (policy) {
          case null:
            return;
          case void 0:
            return;
          case "Delete":
            return cfn_resource_policy_1.CfnDeletionPolicy.DELETE;
          case "Retain":
            return cfn_resource_policy_1.CfnDeletionPolicy.RETAIN;
          case "Snapshot":
            return cfn_resource_policy_1.CfnDeletionPolicy.SNAPSHOT;
          default:
            throw new Error(`Unrecognized DeletionPolicy '${policy}'`);
        }
      }
      parseValue(cfnValue) {
        if (cfnValue != null) {
          if ((0, token_1.isResolvableObject)(cfnValue))
            return cfnValue;
          if (Array.isArray(cfnValue))
            return cfnValue.map((el) => this.parseValue(el));
          if (typeof cfnValue == "object") {
            const cfnIntrinsic = this.parseIfCfnIntrinsic(cfnValue);
            if (cfnIntrinsic !== void 0)
              return cfnIntrinsic;
            const ret = {};
            for (const [key, val] of Object.entries(cfnValue))
              ret[key] = this.parseValue(val);
            return ret;
          }
          return cfnValue;
        }
      }
      get finder() {
        return this.options.finder;
      }
      parseIfCfnIntrinsic(object) {
        const key = this.looksLikeCfnIntrinsic(object);
        switch (key) {
          case void 0:
            return;
          case "Ref": {
            const refTarget = object[key], specialRef = this.specialCaseRefs(refTarget);
            if (specialRef !== void 0)
              return specialRef;
            {
              const refElement = this.finder.findRefTarget(refTarget);
              if (!refElement)
                throw new Error(`Element used in Ref expression with logical ID: '${refTarget}' not found`);
              return cfn_reference_1.CfnReference.for(refElement, "Ref");
            }
          }
          case "Fn::GetAtt": {
            const value = object[key];
            let logicalId, attributeName, stringForm;
            if (typeof value == "string") {
              const dotIndex = value.indexOf(".");
              if (dotIndex === -1)
                throw new Error(`Short-form Fn::GetAtt must contain a '.' in its string argument, got: '${value}'`);
              logicalId = value.slice(0, dotIndex), attributeName = value.slice(dotIndex + 1), stringForm = true;
            } else
              logicalId = value[0], attributeName = value[1], stringForm = false;
            const target = this.finder.findResource(logicalId);
            if (!target)
              throw new Error(`Resource used in GetAtt expression with logical ID: '${logicalId}' not found`);
            return cfn_reference_1.CfnReference.for(target, attributeName, stringForm ? cfn_reference_1.ReferenceRendering.GET_ATT_STRING : void 0);
          }
          case "Fn::Join": {
            const value = this.parseValue(object[key]);
            return cfn_fn_1.Fn.join(value[0], lazy_1.Lazy.list({ produce: () => value[1] }));
          }
          case "Fn::Cidr": {
            const value = this.parseValue(object[key]);
            return cfn_fn_1.Fn.cidr(value[0], value[1], value[2]);
          }
          case "Fn::FindInMap": {
            const value = this.parseValue(object[key]);
            let mappingName;
            if (token_1.Token.isUnresolved(value[0]))
              mappingName = value[0];
            else {
              const mapping = this.finder.findMapping(value[0]);
              if (!mapping)
                throw new Error(`Mapping used in FindInMap expression with name '${value[0]}' was not found in the template`);
              mappingName = mapping.logicalId;
            }
            return cfn_fn_1.Fn._findInMap(mappingName, value[1], value[2]);
          }
          case "Fn::Select": {
            const value = this.parseValue(object[key]);
            return cfn_fn_1.Fn.select(value[0], value[1]);
          }
          case "Fn::GetAZs": {
            const value = this.parseValue(object[key]);
            return cfn_fn_1.Fn.getAzs(value);
          }
          case "Fn::ImportValue": {
            const value = this.parseValue(object[key]);
            return cfn_fn_1.Fn.importValue(value);
          }
          case "Fn::Split": {
            const value = this.parseValue(object[key]);
            return cfn_fn_1.Fn.split(value[0], value[1]);
          }
          case "Fn::Transform": {
            const value = this.parseValue(object[key]);
            return cfn_fn_1.Fn.transform(value.Name, value.Parameters);
          }
          case "Fn::Base64": {
            const value = this.parseValue(object[key]);
            return cfn_fn_1.Fn.base64(value);
          }
          case "Fn::If": {
            const value = this.parseValue(object[key]), condition = this.finder.findCondition(value[0]);
            if (!condition)
              throw new Error(`Condition '${value[0]}' used in an Fn::If expression does not exist in the template`);
            return cfn_fn_1.Fn.conditionIf(condition.logicalId, value[1], value[2]);
          }
          case "Fn::Equals": {
            const value = this.parseValue(object[key]);
            return cfn_fn_1.Fn.conditionEquals(value[0], value[1]);
          }
          case "Fn::And": {
            const value = this.parseValue(object[key]);
            return cfn_fn_1.Fn.conditionAnd(...value);
          }
          case "Fn::Not": {
            const value = this.parseValue(object[key]);
            return cfn_fn_1.Fn.conditionNot(value[0]);
          }
          case "Fn::Or": {
            const value = this.parseValue(object[key]);
            return cfn_fn_1.Fn.conditionOr(...value);
          }
          case "Fn::Sub": {
            const value = this.parseValue(object[key]);
            let fnSubString, map;
            return typeof value == "string" ? (fnSubString = value, map = void 0) : (fnSubString = value[0], map = value[1]), this.parseFnSubString(fnSubString, map);
          }
          case "Condition": {
            const condition = this.finder.findCondition(object[key]);
            if (!condition)
              throw new Error(`Referenced Condition with name '${object[key]}' was not found in the template`);
            return { Condition: condition.logicalId };
          }
          default:
            if (this.options.context === CfnParsingContext.RULES)
              return this.handleRulesIntrinsic(key, object);
            throw new Error(`Unsupported CloudFormation function '${key}'`);
        }
      }
      looksLikeCfnIntrinsic(object) {
        const objectKeys = Object.keys(object);
        if (objectKeys.length !== 1)
          return;
        const key = objectKeys[0];
        return key === "Ref" || key.startsWith("Fn::") || this.options.context === CfnParsingContext.CONDITIONS && key === "Condition" ? key : void 0;
      }
      parseFnSubString(templateString, expressionMap) {
        const map = expressionMap ?? {}, self2 = this;
        return cfn_fn_1.Fn.sub(go(templateString), Object.keys(map).length === 0 ? expressionMap : map);
        function go(value) {
          const leftBrace = value.indexOf("${");
          if (leftBrace === -1)
            return value;
          const rightBrace = value.indexOf("}", leftBrace);
          if (rightBrace === -1)
            return value;
          const leftHalf = value.substring(0, leftBrace), rightHalf = value.substring(rightBrace + 1), refTarget = value.substring(leftBrace + 2, rightBrace).trim();
          if (refTarget[0] === "!")
            return value.substring(0, rightBrace + 1) + go(rightHalf);
          if (refTarget in map)
            return leftHalf + "${" + refTarget + "}" + go(rightHalf);
          const specialRef = self2.specialCaseSubRefs(refTarget);
          if (specialRef !== void 0)
            return token_1.Token.isUnresolved(specialRef) ? (map[refTarget] = specialRef, leftHalf + "${" + refTarget + "}" + go(rightHalf)) : leftHalf + specialRef + go(rightHalf);
          const dotIndex = refTarget.indexOf(".");
          if (dotIndex === -1) {
            const refElement = self2.finder.findRefTarget(refTarget);
            if (!refElement)
              throw new Error(`Element referenced in Fn::Sub expression with logical ID: '${refTarget}' was not found in the template`);
            return leftHalf + cfn_reference_1.CfnReference.for(refElement, "Ref", cfn_reference_1.ReferenceRendering.FN_SUB).toString() + go(rightHalf);
          } else {
            const targetId = refTarget.substring(0, dotIndex), refResource = self2.finder.findResource(targetId);
            if (!refResource)
              throw new Error(`Resource referenced in Fn::Sub expression with logical ID: '${targetId}' was not found in the template`);
            const attribute = refTarget.substring(dotIndex + 1);
            return leftHalf + cfn_reference_1.CfnReference.for(refResource, attribute, cfn_reference_1.ReferenceRendering.FN_SUB).toString() + go(rightHalf);
          }
        }
      }
      handleRulesIntrinsic(key, object) {
        switch (key) {
          case "Fn::ValueOf": {
            const value = this.parseValue(object[key]), parameterName = value[0];
            if (parameterName in this.parameters)
              throw new Error(`Cannot substitute parameter '${parameterName}' used in Fn::ValueOf expression with attribute '${value[1]}'`);
            const param = this.finder.findRefTarget(parameterName);
            if (!param)
              throw new Error(`Rule references parameter '${parameterName}' which was not found in the template`);
            return lazy_1.Lazy.any({ produce: () => ({ "Fn::ValueOf": [param.logicalId, value[1]] }) });
          }
          default:
            return;
        }
      }
      specialCaseRefs(value) {
        if (value in this.parameters)
          return this.parameters[value];
        switch (value) {
          case "AWS::AccountId":
            return cfn_pseudo_1.Aws.ACCOUNT_ID;
          case "AWS::Region":
            return cfn_pseudo_1.Aws.REGION;
          case "AWS::Partition":
            return cfn_pseudo_1.Aws.PARTITION;
          case "AWS::URLSuffix":
            return cfn_pseudo_1.Aws.URL_SUFFIX;
          case "AWS::NotificationARNs":
            return cfn_pseudo_1.Aws.NOTIFICATION_ARNS;
          case "AWS::StackId":
            return cfn_pseudo_1.Aws.STACK_ID;
          case "AWS::StackName":
            return cfn_pseudo_1.Aws.STACK_NAME;
          case "AWS::NoValue":
            return cfn_pseudo_1.Aws.NO_VALUE;
          default:
            return;
        }
      }
      specialCaseSubRefs(value) {
        return value in this.parameters ? this.parameters[value] : value.indexOf("::") === -1 ? void 0 : "${" + value + "}";
      }
      get parameters() {
        return this.options.parameters || {};
      }
    };
    exports2.CfnParser = CfnParser;
  }
});

// node_modules/aws-cdk-lib/core/lib/helpers-internal/customize-roles.js
var require_customize_roles = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/helpers-internal/customize-roles.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.getCustomizeRolesConfig = exports2.CUSTOMIZE_ROLES_CONTEXT_KEY = exports2.getPrecreatedRoleConfig = exports2.PolicySynthesizer = exports2.POLICY_SYNTHESIZER_ID = void 0;
    var fs = require("fs");
    var path = require("path");
    var constructs_1 = require_lib2();
    var annotations_1 = require_annotations();
    var app_1 = require_app2();
    var reference_1 = require_reference();
    var resolvable_1 = require_resolvable();
    var token_1 = require_token2();
    exports2.POLICY_SYNTHESIZER_ID = "PolicySynthesizer";
    var PolicySynthesizer = class _PolicySynthesizer extends constructs_1.Construct {
      static getOrCreate(scope) {
        const synthesizer = scope.node.root.node.tryFindChild(exports2.POLICY_SYNTHESIZER_ID);
        return synthesizer || new _PolicySynthesizer(scope.node.root);
      }
      constructor(scope) {
        super(scope, exports2.POLICY_SYNTHESIZER_ID), this.roleReport = {}, this.managedPolicyReport = {}, (0, app_1.attachCustomSynthesis)(this, { onSynthesize: (session) => {
          const report = this.createJsonReport();
          if (report.roles?.length > 0) {
            const filePath = path.join(session.outdir, "iam-policy-report");
            fs.writeFileSync(filePath + ".txt", this.createHumanReport(report)), fs.writeFileSync(filePath + ".json", JSON.stringify(report, void 0, 2));
          }
        } });
      }
      createJsonReport() {
        return Object.entries(this.roleReport).reduce((acc, [key, value]) => {
          const { policyArns, policyStatements } = this.renderManagedPoliciesForRole(key, value.managedPolicies);
          return acc = { roles: [...acc.roles ?? [], { roleConstructPath: key, roleName: value.missing ? "missing role" : value.roleName, missing: value.missing, assumeRolePolicy: this.resolveReferences(value.assumeRolePolicy), managedPolicyArns: this.resolveReferences(policyArns), managedPolicyStatements: this.resolveReferences(policyStatements), identityPolicyStatements: this.resolveReferences(value.policyStatements) }] }, acc;
        }, {});
      }
      createHumanReport(report) {
        return report.roles.map((role) => [`<${role.missing ? "missing role" : role.roleName}> (${role.roleConstructPath})`, "", "AssumeRole Policy:", ...this.toJsonString(role.assumeRolePolicy), "", "Managed Policy ARNs:", ...this.toJsonString(role.managedPolicyArns), "", "Managed Policies Statements:", this.toJsonString(role.managedPolicyStatements), "", "Identity Policy Statements:", this.toJsonString(role.identityPolicyStatements)].join(`
`)).join("");
      }
      toJsonString(value) {
        return Array.isArray(value) && value.length === 0 || !value ? ["NONE"] : [JSON.stringify(value, void 0, 2)];
      }
      renderManagedPoliciesForRole(rolePath, managedPolicies) {
        const policyStatements = [];
        Object.values(this.managedPolicyReport).forEach((value) => {
          value.roles?.includes(rolePath) && policyStatements.push(...value.policyStatements);
        });
        const policyArns = [];
        return managedPolicies.forEach((policy) => {
          constructs_1.Construct.isConstruct(policy) && this.managedPolicyReport.hasOwnProperty(policy.node.path) ? policyStatements.push(...this.managedPolicyReport[policy.node.path].policyStatements) : policyArns.push(policy.managedPolicyArn);
        }), { policyArns, policyStatements };
      }
      resolveReferences(ref) {
        if (Array.isArray(ref) && ref.length === 0 || !ref)
          return [];
        if (Array.isArray(ref))
          return ref.map((r) => this.resolveReferences(r));
        if (typeof ref == "object")
          return this.resolveJsonObject(ref);
        const resolvable = token_1.Tokenization.reverseString(ref);
        return resolvable.length === 1 && reference_1.Reference.isReference(resolvable.firstToken) ? `(${resolvable.firstToken.target.node.path}.${resolvable.firstToken.displayName})` : resolvable.mapTokens({ mapToken: (r) => {
          if (reference_1.Reference.isReference(r))
            return `(${r.target.node.path}.${r.displayName})`;
          const resolved = token_1.Tokenization.resolve(r, { scope: this, resolver: new resolvable_1.DefaultTokenResolver(new resolvable_1.StringConcat()) });
          if (typeof resolved == "object" && resolved.hasOwnProperty("Ref"))
            switch (resolved.Ref) {
              case "AWS::AccountId":
                return "(ACCOUNT)";
              case "AWS::Partition":
                return "(PARTITION)";
              case "AWS::Region":
                return "(REGION)";
              default:
                return r;
            }
          return r;
        } }).join(new resolvable_1.StringConcat());
      }
      resolveJsonObject(statement) {
        const newStatement = statement;
        for (const [key, value] of Object.entries(statement))
          newStatement[key] = this.resolveReferences(value);
        return newStatement;
      }
      addRole(rolePath, options) {
        if (this.roleReport.hasOwnProperty(rolePath))
          throw new Error(`IAM Policy Report already has an entry for role: ${rolePath}`);
        this.roleReport[rolePath] = options;
      }
      addManagedPolicy(policyPath, options) {
        if (this.managedPolicyReport.hasOwnProperty(policyPath))
          throw new Error(`IAM Policy Report already has an entry for managed policy: ${policyPath}`);
        this.managedPolicyReport[policyPath] = options;
      }
    };
    exports2.PolicySynthesizer = PolicySynthesizer;
    function getPrecreatedRoleConfig(scope, rolePath) {
      const precreatedRolePath = rolePath ?? scope.node.path, customizeRolesContext = scope.node.tryGetContext(exports2.CUSTOMIZE_ROLES_CONTEXT_KEY);
      if (customizeRolesContext !== void 0) {
        const customizeRoles = customizeRolesContext;
        if (customizeRoles.preventSynthesis === false)
          return { preventSynthesis: false, enabled: true };
        if (customizeRoles.usePrecreatedRoles?.hasOwnProperty(precreatedRolePath))
          if (token_1.Token.isUnresolved(customizeRoles.usePrecreatedRoles[precreatedRolePath]))
            annotations_1.Annotations.of(scope).addError(`Cannot resolve precreated role name at path "${precreatedRolePath}". The value may be a token.`);
          else
            return { enabled: true, preventSynthesis: true, precreatedRoleName: customizeRoles.usePrecreatedRoles[precreatedRolePath] };
        else
          annotations_1.Annotations.of(scope).addError(`IAM Role is being created at path "${precreatedRolePath}" and customizeRoles.preventSynthesis is enabled. You must provide a precreated role name in customizeRoles.precreatedRoles`);
        return { enabled: true, preventSynthesis: true };
      }
      return { enabled: false };
    }
    exports2.getPrecreatedRoleConfig = getPrecreatedRoleConfig, exports2.CUSTOMIZE_ROLES_CONTEXT_KEY = "@aws-cdk/iam:customizeRoles";
    function getCustomizeRolesConfig(scope) {
      const customizeRolesContext = scope.node.tryGetContext(exports2.CUSTOMIZE_ROLES_CONTEXT_KEY);
      return { preventSynthesis: customizeRolesContext !== void 0 && customizeRolesContext.preventSynthesis !== false, enabled: customizeRolesContext !== void 0 };
    }
    exports2.getCustomizeRolesConfig = getCustomizeRolesConfig;
  }
});

// node_modules/aws-cdk-lib/core/lib/helpers-internal/index.js
var require_helpers_internal = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/helpers-internal/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.md5hash = void 0, __exportStar(require_cfn_parse(), exports2);
    var md5_1 = require_md52();
    Object.defineProperty(exports2, "md5hash", { enumerable: true, get: function() {
      return md5_1.md5hash;
    } }), __exportStar(require_customize_roles(), exports2);
  }
});

// node_modules/aws-cdk-lib/core/lib/size.js
var require_size = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/size.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SizeRoundingBehavior = exports2.Size = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var token_1 = require_token2();
    var Size = class _Size {
      static bytes(amount) {
        return new _Size(amount, StorageUnit.Bytes);
      }
      static kibibytes(amount) {
        return new _Size(amount, StorageUnit.Kibibytes);
      }
      static mebibytes(amount) {
        return new _Size(amount, StorageUnit.Mebibytes);
      }
      static gibibytes(amount) {
        return new _Size(amount, StorageUnit.Gibibytes);
      }
      static tebibytes(amount) {
        return new _Size(amount, StorageUnit.Tebibytes);
      }
      static pebibyte(amount) {
        return _Size.pebibytes(amount);
      }
      static pebibytes(amount) {
        return new _Size(amount, StorageUnit.Pebibytes);
      }
      constructor(amount, unit) {
        if (!token_1.Token.isUnresolved(amount) && amount < 0)
          throw new Error(`Storage amounts cannot be negative. Received: ${amount}`);
        this.amount = amount, this.unit = unit;
      }
      toBytes(opts = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_SizeConversionOptions(opts);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.toBytes), error;
        }
        return convert(this.amount, this.unit, StorageUnit.Bytes, opts);
      }
      toKibibytes(opts = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_SizeConversionOptions(opts);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.toKibibytes), error;
        }
        return convert(this.amount, this.unit, StorageUnit.Kibibytes, opts);
      }
      toMebibytes(opts = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_SizeConversionOptions(opts);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.toMebibytes), error;
        }
        return convert(this.amount, this.unit, StorageUnit.Mebibytes, opts);
      }
      toGibibytes(opts = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_SizeConversionOptions(opts);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.toGibibytes), error;
        }
        return convert(this.amount, this.unit, StorageUnit.Gibibytes, opts);
      }
      toTebibytes(opts = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_SizeConversionOptions(opts);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.toTebibytes), error;
        }
        return convert(this.amount, this.unit, StorageUnit.Tebibytes, opts);
      }
      toPebibytes(opts = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_SizeConversionOptions(opts);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.toPebibytes), error;
        }
        return convert(this.amount, this.unit, StorageUnit.Pebibytes, opts);
      }
      isUnresolved() {
        return token_1.Token.isUnresolved(this.amount);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Size[_a] = { fqn: "aws-cdk-lib.Size", version: "2.80.0" }, exports2.Size = Size;
    var SizeRoundingBehavior;
    (function(SizeRoundingBehavior2) {
      SizeRoundingBehavior2[SizeRoundingBehavior2.FAIL = 0] = "FAIL", SizeRoundingBehavior2[SizeRoundingBehavior2.FLOOR = 1] = "FLOOR", SizeRoundingBehavior2[SizeRoundingBehavior2.NONE = 2] = "NONE";
    })(SizeRoundingBehavior = exports2.SizeRoundingBehavior || (exports2.SizeRoundingBehavior = {}));
    var StorageUnit = class {
      constructor(label, inBytes) {
        this.label = label, this.inBytes = inBytes;
      }
      toString() {
        return this.label;
      }
    };
    StorageUnit.Bytes = new StorageUnit("bytes", 1), StorageUnit.Kibibytes = new StorageUnit("kibibytes", 1024), StorageUnit.Mebibytes = new StorageUnit("mebibytes", 1024 * 1024), StorageUnit.Gibibytes = new StorageUnit("gibibytes", 1024 * 1024 * 1024), StorageUnit.Tebibytes = new StorageUnit("tebibytes", 1024 * 1024 * 1024 * 1024), StorageUnit.Pebibytes = new StorageUnit("pebibytes", 1024 * 1024 * 1024 * 1024 * 1024);
    function convert(amount, fromUnit, toUnit, options = {}) {
      const rounding = options.rounding ?? SizeRoundingBehavior.FAIL;
      if (fromUnit.inBytes === toUnit.inBytes)
        return amount;
      if (token_1.Token.isUnresolved(amount))
        throw new Error(`Size must be specified as 'Size.${toUnit}()' here since its value comes from a token and cannot be converted (got Size.${fromUnit})`);
      const multiplier = fromUnit.inBytes / toUnit.inBytes, value = amount * multiplier;
      switch (rounding) {
        case SizeRoundingBehavior.NONE:
          return value;
        case SizeRoundingBehavior.FLOOR:
          return Math.floor(value);
        default:
        case SizeRoundingBehavior.FAIL:
          if (!Number.isInteger(value))
            throw new Error(`'${amount} ${fromUnit}' cannot be converted into a whole number of ${toUnit}.`);
          return value;
      }
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/custom-resource-provider/custom-resource-provider.js
var require_custom_resource_provider = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/custom-resource-provider/custom-resource-provider.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CustomResourceProvider = exports2.CustomResourceProviderRuntime = exports2.builtInCustomResourceProviderNodeRuntime = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var fs = require("fs");
    var path = require("path");
    var constructs_1 = require_lib2();
    var fse = require_lib6();
    var cxapi = require_cx_api();
    var region_info_1 = require_region_info2();
    var asset_staging_1 = require_asset_staging2();
    var assets_1 = require_assets3();
    var cfn_resource_1 = require_cfn_resource();
    var duration_1 = require_duration();
    var fs_1 = require_fs2();
    var helpers_internal_1 = require_helpers_internal();
    var lazy_1 = require_lazy();
    var size_1 = require_size();
    var stack_1 = require_stack();
    var token_1 = require_token2();
    var ENTRYPOINT_FILENAME = "__entrypoint__";
    var ENTRYPOINT_NODEJS_SOURCE = path.join(__dirname, "nodejs-entrypoint.js");
    function builtInCustomResourceProviderNodeRuntime(scope) {
      const runtimeName = stack_1.Stack.of(scope).regionalFact(region_info_1.FactName.DEFAULT_CR_NODE_VERSION, "nodejs16.x");
      return Object.values(CustomResourceProviderRuntime).find((value) => value === runtimeName) ?? CustomResourceProviderRuntime.NODEJS_16_X;
    }
    exports2.builtInCustomResourceProviderNodeRuntime = builtInCustomResourceProviderNodeRuntime;
    var CustomResourceProviderRuntime;
    (function(CustomResourceProviderRuntime2) {
      CustomResourceProviderRuntime2.NODEJS_12_X = "nodejs12.x", CustomResourceProviderRuntime2.NODEJS_12 = "deprecated_nodejs12.x", CustomResourceProviderRuntime2.NODEJS_14_X = "nodejs14.x", CustomResourceProviderRuntime2.NODEJS_16_X = "nodejs16.x";
    })(CustomResourceProviderRuntime = exports2.CustomResourceProviderRuntime || (exports2.CustomResourceProviderRuntime = {}));
    var CustomResourceProvider = class _CustomResourceProvider extends constructs_1.Construct {
      static getOrCreate(scope, uniqueid, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CustomResourceProviderProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.getOrCreate), error;
        }
        return this.getOrCreateProvider(scope, uniqueid, props).serviceToken;
      }
      static getOrCreateProvider(scope, uniqueid, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CustomResourceProviderProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.getOrCreateProvider), error;
        }
        const id = `${uniqueid}CustomResourceProvider`, stack = stack_1.Stack.of(scope);
        return stack.node.tryFindChild(id) ?? new _CustomResourceProvider(stack, id, props);
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CustomResourceProviderProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CustomResourceProvider), error;
        }
        const stack = stack_1.Stack.of(scope);
        if (!fs.existsSync(path.join(props.codeDirectory, "index.js")))
          throw new Error(`cannot find ${props.codeDirectory}/index.js`);
        const stagingDirectory = fs_1.FileSystem.mkdtemp("cdk-custom-resource");
        fse.copySync(props.codeDirectory, stagingDirectory, { filter: (src, _dest) => !src.endsWith(".ts") }), fs.copyFileSync(ENTRYPOINT_NODEJS_SOURCE, path.join(stagingDirectory, `${ENTRYPOINT_FILENAME}.js`));
        const staging = new asset_staging_1.AssetStaging(this, "Staging", { sourcePath: stagingDirectory }), assetFileName = staging.relativeStagedPath(stack), asset = stack.synthesizer.addFileAsset({ fileName: assetFileName, sourceHash: staging.assetHash, packaging: assets_1.FileAssetPackaging.ZIP_DIRECTORY });
        if (props.policyStatements)
          for (const statement of props.policyStatements)
            this.addToRolePolicy(statement);
        const config = (0, helpers_internal_1.getPrecreatedRoleConfig)(this, `${this.node.path}/Role`), assumeRolePolicyDoc = [{ Action: "sts:AssumeRole", Effect: "Allow", Principal: { Service: "lambda.amazonaws.com" } }], managedPolicyArn = "arn:${AWS::Partition}:iam::aws:policy/service-role/AWSLambdaBasicExecutionRole";
        this.roleArn = "", config.enabled && (this.node.addValidation({ validate: () => (helpers_internal_1.PolicySynthesizer.getOrCreate(this).addRole(`${this.node.path}/Role`, { missing: !config.precreatedRoleName, roleName: config.precreatedRoleName ?? id + "Role", managedPolicies: [{ managedPolicyArn }], policyStatements: this.policyStatements ?? [], assumeRolePolicy: assumeRolePolicyDoc }), []) }), this.roleArn = stack_1.Stack.of(this).formatArn({ region: "", service: "iam", resource: "role", resourceName: config.precreatedRoleName })), config.preventSynthesis || (this._role = new cfn_resource_1.CfnResource(this, "Role", { type: "AWS::IAM::Role", properties: { AssumeRolePolicyDocument: { Version: "2012-10-17", Statement: assumeRolePolicyDoc }, ManagedPolicyArns: [{ "Fn::Sub": managedPolicyArn }], Policies: lazy_1.Lazy.any({ produce: () => this.renderPolicies() }) } }), this.roleArn = token_1.Token.asString(this._role.getAtt("Arn")));
        const timeout = props.timeout ?? duration_1.Duration.minutes(15), memory = props.memorySize ?? size_1.Size.mebibytes(128), handler2 = new cfn_resource_1.CfnResource(this, "Handler", { type: "AWS::Lambda::Function", properties: { Code: { S3Bucket: asset.bucketName, S3Key: asset.objectKey }, Timeout: timeout.toSeconds(), MemorySize: memory.toMebibytes(), Handler: `${ENTRYPOINT_FILENAME}.handler`, Role: this.roleArn, Runtime: customResourceProviderRuntimeToString(props.runtime), Environment: this.renderEnvironmentVariables(props.environment), Description: props.description ?? void 0 } });
        this._role && handler2.addDependency(this._role), this.node.tryGetContext(cxapi.ASSET_RESOURCE_METADATA_ENABLED_CONTEXT) && (handler2.addMetadata(cxapi.ASSET_RESOURCE_METADATA_PATH_KEY, assetFileName), handler2.addMetadata(cxapi.ASSET_RESOURCE_METADATA_PROPERTY_KEY, "Code")), this.serviceToken = token_1.Token.asString(handler2.getAtt("Arn")), this.codeHash = staging.assetHash;
      }
      addToRolePolicy(statement) {
        this.policyStatements || (this.policyStatements = []), this.policyStatements.push(statement);
      }
      renderPolicies() {
        return this.policyStatements ? [{ PolicyName: "Inline", PolicyDocument: { Version: "2012-10-17", Statement: this.policyStatements } }] : void 0;
      }
      renderEnvironmentVariables(env) {
        if (!env || Object.keys(env).length === 0)
          return;
        env = { ...env }, env.AWS_STS_REGIONAL_ENDPOINTS = "regional";
        const variables = {}, keys = Object.keys(env).sort();
        for (const key of keys)
          variables[key] = env[key];
        return { Variables: variables };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CustomResourceProvider[_a] = { fqn: "aws-cdk-lib.CustomResourceProvider", version: "2.80.0" }, exports2.CustomResourceProvider = CustomResourceProvider;
    function customResourceProviderRuntimeToString(x) {
      switch (x) {
        case CustomResourceProviderRuntime.NODEJS_12:
        case CustomResourceProviderRuntime.NODEJS_12_X:
          return "nodejs12.x";
        case CustomResourceProviderRuntime.NODEJS_14_X:
          return "nodejs14.x";
        case CustomResourceProviderRuntime.NODEJS_16_X:
          return "nodejs16.x";
      }
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/custom-resource-provider/index.js
var require_custom_resource_provider2 = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/custom-resource-provider/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_custom_resource_provider(), exports2);
  }
});

// node_modules/aws-cdk-lib/core/lib/private/cfn-utils-provider.js
var require_cfn_utils_provider = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/private/cfn-utils-provider.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnUtils = exports2.CfnUtilsProvider = void 0;
    var constructs_1 = require_lib2();
    var custom_resource_1 = require_custom_resource();
    var custom_resource_provider_1 = require_custom_resource_provider2();
    var CfnUtilsProvider = class extends constructs_1.Construct {
      static getOrCreate(scope) {
        return custom_resource_provider_1.CustomResourceProvider.getOrCreate(scope, "AWSCDKCfnUtilsProvider", { runtime: (0, custom_resource_provider_1.builtInCustomResourceProviderNodeRuntime)(scope), codeDirectory: `${__dirname}/cfn-utils-provider` });
      }
    };
    exports2.CfnUtilsProvider = CfnUtilsProvider;
    var CfnUtils = class {
      static stringify(scope, id, value) {
        return new custom_resource_1.CustomResource(scope, id, { serviceToken: CfnUtilsProvider.getOrCreate(scope), resourceType: "Custom::AWSCDKCfnJsonStringify", properties: { Value: value } }).getAttString("Value");
      }
    };
    exports2.CfnUtils = CfnUtils;
  }
});

// node_modules/aws-cdk-lib/node_modules/yaml/dist/PlainValue-ec8e588e.js
var require_PlainValue_ec8e588e = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/yaml/dist/PlainValue-ec8e588e.js"(exports2) {
    "use strict";
    var Char = {
      ANCHOR: "&",
      COMMENT: "#",
      TAG: "!",
      DIRECTIVES_END: "-",
      DOCUMENT_END: "."
    };
    var Type = {
      ALIAS: "ALIAS",
      BLANK_LINE: "BLANK_LINE",
      BLOCK_FOLDED: "BLOCK_FOLDED",
      BLOCK_LITERAL: "BLOCK_LITERAL",
      COMMENT: "COMMENT",
      DIRECTIVE: "DIRECTIVE",
      DOCUMENT: "DOCUMENT",
      FLOW_MAP: "FLOW_MAP",
      FLOW_SEQ: "FLOW_SEQ",
      MAP: "MAP",
      MAP_KEY: "MAP_KEY",
      MAP_VALUE: "MAP_VALUE",
      PLAIN: "PLAIN",
      QUOTE_DOUBLE: "QUOTE_DOUBLE",
      QUOTE_SINGLE: "QUOTE_SINGLE",
      SEQ: "SEQ",
      SEQ_ITEM: "SEQ_ITEM"
    };
    var defaultTagPrefix = "tag:yaml.org,2002:";
    var defaultTags = {
      MAP: "tag:yaml.org,2002:map",
      SEQ: "tag:yaml.org,2002:seq",
      STR: "tag:yaml.org,2002:str"
    };
    function findLineStarts(src) {
      const ls = [0];
      let offset = src.indexOf("\n");
      while (offset !== -1) {
        offset += 1;
        ls.push(offset);
        offset = src.indexOf("\n", offset);
      }
      return ls;
    }
    function getSrcInfo(cst) {
      let lineStarts, src;
      if (typeof cst === "string") {
        lineStarts = findLineStarts(cst);
        src = cst;
      } else {
        if (Array.isArray(cst))
          cst = cst[0];
        if (cst && cst.context) {
          if (!cst.lineStarts)
            cst.lineStarts = findLineStarts(cst.context.src);
          lineStarts = cst.lineStarts;
          src = cst.context.src;
        }
      }
      return {
        lineStarts,
        src
      };
    }
    function getLinePos(offset, cst) {
      if (typeof offset !== "number" || offset < 0)
        return null;
      const {
        lineStarts,
        src
      } = getSrcInfo(cst);
      if (!lineStarts || !src || offset > src.length)
        return null;
      for (let i = 0; i < lineStarts.length; ++i) {
        const start = lineStarts[i];
        if (offset < start) {
          return {
            line: i,
            col: offset - lineStarts[i - 1] + 1
          };
        }
        if (offset === start)
          return {
            line: i + 1,
            col: 1
          };
      }
      const line = lineStarts.length;
      return {
        line,
        col: offset - lineStarts[line - 1] + 1
      };
    }
    function getLine(line, cst) {
      const {
        lineStarts,
        src
      } = getSrcInfo(cst);
      if (!lineStarts || !(line >= 1) || line > lineStarts.length)
        return null;
      const start = lineStarts[line - 1];
      let end = lineStarts[line];
      while (end && end > start && src[end - 1] === "\n")
        --end;
      return src.slice(start, end);
    }
    function getPrettyContext({
      start,
      end
    }, cst, maxWidth = 80) {
      let src = getLine(start.line, cst);
      if (!src)
        return null;
      let {
        col
      } = start;
      if (src.length > maxWidth) {
        if (col <= maxWidth - 10) {
          src = src.substr(0, maxWidth - 1) + "\u2026";
        } else {
          const halfWidth = Math.round(maxWidth / 2);
          if (src.length > col + halfWidth)
            src = src.substr(0, col + halfWidth - 1) + "\u2026";
          col -= src.length - maxWidth;
          src = "\u2026" + src.substr(1 - maxWidth);
        }
      }
      let errLen = 1;
      let errEnd = "";
      if (end) {
        if (end.line === start.line && col + (end.col - start.col) <= maxWidth + 1) {
          errLen = end.col - start.col;
        } else {
          errLen = Math.min(src.length + 1, maxWidth) - col;
          errEnd = "\u2026";
        }
      }
      const offset = col > 1 ? " ".repeat(col - 1) : "";
      const err = "^".repeat(errLen);
      return `${src}
${offset}${err}${errEnd}`;
    }
    var Range = class _Range {
      static copy(orig) {
        return new _Range(orig.start, orig.end);
      }
      constructor(start, end) {
        this.start = start;
        this.end = end || start;
      }
      isEmpty() {
        return typeof this.start !== "number" || !this.end || this.end <= this.start;
      }
      /**
       * Set `origStart` and `origEnd` to point to the original source range for
       * this node, which may differ due to dropped CR characters.
       *
       * @param {number[]} cr - Positions of dropped CR characters
       * @param {number} offset - Starting index of `cr` from the last call
       * @returns {number} - The next offset, matching the one found for `origStart`
       */
      setOrigRange(cr, offset) {
        const {
          start,
          end
        } = this;
        if (cr.length === 0 || end <= cr[0]) {
          this.origStart = start;
          this.origEnd = end;
          return offset;
        }
        let i = offset;
        while (i < cr.length) {
          if (cr[i] > start)
            break;
          else
            ++i;
        }
        this.origStart = start + i;
        const nextOffset = i;
        while (i < cr.length) {
          if (cr[i] >= end)
            break;
          else
            ++i;
        }
        this.origEnd = end + i;
        return nextOffset;
      }
    };
    var Node = class _Node {
      static addStringTerminator(src, offset, str) {
        if (str[str.length - 1] === "\n")
          return str;
        const next = _Node.endOfWhiteSpace(src, offset);
        return next >= src.length || src[next] === "\n" ? str + "\n" : str;
      }
      // ^(---|...)
      static atDocumentBoundary(src, offset, sep) {
        const ch0 = src[offset];
        if (!ch0)
          return true;
        const prev = src[offset - 1];
        if (prev && prev !== "\n")
          return false;
        if (sep) {
          if (ch0 !== sep)
            return false;
        } else {
          if (ch0 !== Char.DIRECTIVES_END && ch0 !== Char.DOCUMENT_END)
            return false;
        }
        const ch1 = src[offset + 1];
        const ch2 = src[offset + 2];
        if (ch1 !== ch0 || ch2 !== ch0)
          return false;
        const ch3 = src[offset + 3];
        return !ch3 || ch3 === "\n" || ch3 === "	" || ch3 === " ";
      }
      static endOfIdentifier(src, offset) {
        let ch = src[offset];
        const isVerbatim = ch === "<";
        const notOk = isVerbatim ? ["\n", "	", " ", ">"] : ["\n", "	", " ", "[", "]", "{", "}", ","];
        while (ch && notOk.indexOf(ch) === -1)
          ch = src[offset += 1];
        if (isVerbatim && ch === ">")
          offset += 1;
        return offset;
      }
      static endOfIndent(src, offset) {
        let ch = src[offset];
        while (ch === " ")
          ch = src[offset += 1];
        return offset;
      }
      static endOfLine(src, offset) {
        let ch = src[offset];
        while (ch && ch !== "\n")
          ch = src[offset += 1];
        return offset;
      }
      static endOfWhiteSpace(src, offset) {
        let ch = src[offset];
        while (ch === "	" || ch === " ")
          ch = src[offset += 1];
        return offset;
      }
      static startOfLine(src, offset) {
        let ch = src[offset - 1];
        if (ch === "\n")
          return offset;
        while (ch && ch !== "\n")
          ch = src[offset -= 1];
        return offset + 1;
      }
      /**
       * End of indentation, or null if the line's indent level is not more
       * than `indent`
       *
       * @param {string} src
       * @param {number} indent
       * @param {number} lineStart
       * @returns {?number}
       */
      static endOfBlockIndent(src, indent, lineStart) {
        const inEnd = _Node.endOfIndent(src, lineStart);
        if (inEnd > lineStart + indent) {
          return inEnd;
        } else {
          const wsEnd = _Node.endOfWhiteSpace(src, inEnd);
          const ch = src[wsEnd];
          if (!ch || ch === "\n")
            return wsEnd;
        }
        return null;
      }
      static atBlank(src, offset, endAsBlank) {
        const ch = src[offset];
        return ch === "\n" || ch === "	" || ch === " " || endAsBlank && !ch;
      }
      static nextNodeIsIndented(ch, indentDiff, indicatorAsIndent) {
        if (!ch || indentDiff < 0)
          return false;
        if (indentDiff > 0)
          return true;
        return indicatorAsIndent && ch === "-";
      }
      // should be at line or string end, or at next non-whitespace char
      static normalizeOffset(src, offset) {
        const ch = src[offset];
        return !ch ? offset : ch !== "\n" && src[offset - 1] === "\n" ? offset - 1 : _Node.endOfWhiteSpace(src, offset);
      }
      // fold single newline into space, multiple newlines to N - 1 newlines
      // presumes src[offset] === '\n'
      static foldNewline(src, offset, indent) {
        let inCount = 0;
        let error = false;
        let fold = "";
        let ch = src[offset + 1];
        while (ch === " " || ch === "	" || ch === "\n") {
          switch (ch) {
            case "\n":
              inCount = 0;
              offset += 1;
              fold += "\n";
              break;
            case "	":
              if (inCount <= indent)
                error = true;
              offset = _Node.endOfWhiteSpace(src, offset + 2) - 1;
              break;
            case " ":
              inCount += 1;
              offset += 1;
              break;
          }
          ch = src[offset + 1];
        }
        if (!fold)
          fold = " ";
        if (ch && inCount <= indent)
          error = true;
        return {
          fold,
          offset,
          error
        };
      }
      constructor(type, props, context) {
        Object.defineProperty(this, "context", {
          value: context || null,
          writable: true
        });
        this.error = null;
        this.range = null;
        this.valueRange = null;
        this.props = props || [];
        this.type = type;
        this.value = null;
      }
      getPropValue(idx, key, skipKey) {
        if (!this.context)
          return null;
        const {
          src
        } = this.context;
        const prop = this.props[idx];
        return prop && src[prop.start] === key ? src.slice(prop.start + (skipKey ? 1 : 0), prop.end) : null;
      }
      get anchor() {
        for (let i = 0; i < this.props.length; ++i) {
          const anchor = this.getPropValue(i, Char.ANCHOR, true);
          if (anchor != null)
            return anchor;
        }
        return null;
      }
      get comment() {
        const comments = [];
        for (let i = 0; i < this.props.length; ++i) {
          const comment = this.getPropValue(i, Char.COMMENT, true);
          if (comment != null)
            comments.push(comment);
        }
        return comments.length > 0 ? comments.join("\n") : null;
      }
      commentHasRequiredWhitespace(start) {
        const {
          src
        } = this.context;
        if (this.header && start === this.header.end)
          return false;
        if (!this.valueRange)
          return false;
        const {
          end
        } = this.valueRange;
        return start !== end || _Node.atBlank(src, end - 1);
      }
      get hasComment() {
        if (this.context) {
          const {
            src
          } = this.context;
          for (let i = 0; i < this.props.length; ++i) {
            if (src[this.props[i].start] === Char.COMMENT)
              return true;
          }
        }
        return false;
      }
      get hasProps() {
        if (this.context) {
          const {
            src
          } = this.context;
          for (let i = 0; i < this.props.length; ++i) {
            if (src[this.props[i].start] !== Char.COMMENT)
              return true;
          }
        }
        return false;
      }
      get includesTrailingLines() {
        return false;
      }
      get jsonLike() {
        const jsonLikeTypes = [Type.FLOW_MAP, Type.FLOW_SEQ, Type.QUOTE_DOUBLE, Type.QUOTE_SINGLE];
        return jsonLikeTypes.indexOf(this.type) !== -1;
      }
      get rangeAsLinePos() {
        if (!this.range || !this.context)
          return void 0;
        const start = getLinePos(this.range.start, this.context.root);
        if (!start)
          return void 0;
        const end = getLinePos(this.range.end, this.context.root);
        return {
          start,
          end
        };
      }
      get rawValue() {
        if (!this.valueRange || !this.context)
          return null;
        const {
          start,
          end
        } = this.valueRange;
        return this.context.src.slice(start, end);
      }
      get tag() {
        for (let i = 0; i < this.props.length; ++i) {
          const tag = this.getPropValue(i, Char.TAG, false);
          if (tag != null) {
            if (tag[1] === "<") {
              return {
                verbatim: tag.slice(2, -1)
              };
            } else {
              const [_, handle, suffix] = tag.match(/^(.*!)([^!]*)$/);
              return {
                handle,
                suffix
              };
            }
          }
        }
        return null;
      }
      get valueRangeContainsNewline() {
        if (!this.valueRange || !this.context)
          return false;
        const {
          start,
          end
        } = this.valueRange;
        const {
          src
        } = this.context;
        for (let i = start; i < end; ++i) {
          if (src[i] === "\n")
            return true;
        }
        return false;
      }
      parseComment(start) {
        const {
          src
        } = this.context;
        if (src[start] === Char.COMMENT) {
          const end = _Node.endOfLine(src, start + 1);
          const commentRange = new Range(start, end);
          this.props.push(commentRange);
          return end;
        }
        return start;
      }
      /**
       * Populates the `origStart` and `origEnd` values of all ranges for this
       * node. Extended by child classes to handle descendant nodes.
       *
       * @param {number[]} cr - Positions of dropped CR characters
       * @param {number} offset - Starting index of `cr` from the last call
       * @returns {number} - The next offset, matching the one found for `origStart`
       */
      setOrigRanges(cr, offset) {
        if (this.range)
          offset = this.range.setOrigRange(cr, offset);
        if (this.valueRange)
          this.valueRange.setOrigRange(cr, offset);
        this.props.forEach((prop) => prop.setOrigRange(cr, offset));
        return offset;
      }
      toString() {
        const {
          context: {
            src
          },
          range,
          value
        } = this;
        if (value != null)
          return value;
        const str = src.slice(range.start, range.end);
        return _Node.addStringTerminator(src, range.end, str);
      }
    };
    var YAMLError = class extends Error {
      constructor(name, source, message) {
        if (!message || !(source instanceof Node))
          throw new Error(`Invalid arguments for new ${name}`);
        super();
        this.name = name;
        this.message = message;
        this.source = source;
      }
      makePretty() {
        if (!this.source)
          return;
        this.nodeType = this.source.type;
        const cst = this.source.context && this.source.context.root;
        if (typeof this.offset === "number") {
          this.range = new Range(this.offset, this.offset + 1);
          const start = cst && getLinePos(this.offset, cst);
          if (start) {
            const end = {
              line: start.line,
              col: start.col + 1
            };
            this.linePos = {
              start,
              end
            };
          }
          delete this.offset;
        } else {
          this.range = this.source.range;
          this.linePos = this.source.rangeAsLinePos;
        }
        if (this.linePos) {
          const {
            line,
            col
          } = this.linePos.start;
          this.message += ` at line ${line}, column ${col}`;
          const ctx = cst && getPrettyContext(this.linePos, cst);
          if (ctx)
            this.message += `:

${ctx}
`;
        }
        delete this.source;
      }
    };
    var YAMLReferenceError = class extends YAMLError {
      constructor(source, message) {
        super("YAMLReferenceError", source, message);
      }
    };
    var YAMLSemanticError = class extends YAMLError {
      constructor(source, message) {
        super("YAMLSemanticError", source, message);
      }
    };
    var YAMLSyntaxError = class extends YAMLError {
      constructor(source, message) {
        super("YAMLSyntaxError", source, message);
      }
    };
    var YAMLWarning = class extends YAMLError {
      constructor(source, message) {
        super("YAMLWarning", source, message);
      }
    };
    function _defineProperty(obj, key, value) {
      if (key in obj) {
        Object.defineProperty(obj, key, {
          value,
          enumerable: true,
          configurable: true,
          writable: true
        });
      } else {
        obj[key] = value;
      }
      return obj;
    }
    var PlainValue = class _PlainValue extends Node {
      static endOfLine(src, start, inFlow) {
        let ch = src[start];
        let offset = start;
        while (ch && ch !== "\n") {
          if (inFlow && (ch === "[" || ch === "]" || ch === "{" || ch === "}" || ch === ","))
            break;
          const next = src[offset + 1];
          if (ch === ":" && (!next || next === "\n" || next === "	" || next === " " || inFlow && next === ","))
            break;
          if ((ch === " " || ch === "	") && next === "#")
            break;
          offset += 1;
          ch = next;
        }
        return offset;
      }
      get strValue() {
        if (!this.valueRange || !this.context)
          return null;
        let {
          start,
          end
        } = this.valueRange;
        const {
          src
        } = this.context;
        let ch = src[end - 1];
        while (start < end && (ch === "\n" || ch === "	" || ch === " "))
          ch = src[--end - 1];
        let str = "";
        for (let i = start; i < end; ++i) {
          const ch2 = src[i];
          if (ch2 === "\n") {
            const {
              fold,
              offset
            } = Node.foldNewline(src, i, -1);
            str += fold;
            i = offset;
          } else if (ch2 === " " || ch2 === "	") {
            const wsStart = i;
            let next = src[i + 1];
            while (i < end && (next === " " || next === "	")) {
              i += 1;
              next = src[i + 1];
            }
            if (next !== "\n")
              str += i > wsStart ? src.slice(wsStart, i + 1) : ch2;
          } else {
            str += ch2;
          }
        }
        const ch0 = src[start];
        switch (ch0) {
          case "	": {
            const msg = "Plain value cannot start with a tab character";
            const errors = [new YAMLSemanticError(this, msg)];
            return {
              errors,
              str
            };
          }
          case "@":
          case "`": {
            const msg = `Plain value cannot start with reserved character ${ch0}`;
            const errors = [new YAMLSemanticError(this, msg)];
            return {
              errors,
              str
            };
          }
          default:
            return str;
        }
      }
      parseBlockValue(start) {
        const {
          indent,
          inFlow,
          src
        } = this.context;
        let offset = start;
        let valueEnd = start;
        for (let ch = src[offset]; ch === "\n"; ch = src[offset]) {
          if (Node.atDocumentBoundary(src, offset + 1))
            break;
          const end = Node.endOfBlockIndent(src, indent, offset + 1);
          if (end === null || src[end] === "#")
            break;
          if (src[end] === "\n") {
            offset = end;
          } else {
            valueEnd = _PlainValue.endOfLine(src, end, inFlow);
            offset = valueEnd;
          }
        }
        if (this.valueRange.isEmpty())
          this.valueRange.start = start;
        this.valueRange.end = valueEnd;
        return valueEnd;
      }
      /**
       * Parses a plain value from the source
       *
       * Accepted forms are:
       * ```
       * #comment
       *
       * first line
       *
       * first line #comment
       *
       * first line
       * block
       * lines
       *
       * #comment
       * block
       * lines
       * ```
       * where block lines are empty or have an indent level greater than `indent`.
       *
       * @param {ParseContext} context
       * @param {number} start - Index of first character
       * @returns {number} - Index of the character after this scalar, may be `\n`
       */
      parse(context, start) {
        this.context = context;
        const {
          inFlow,
          src
        } = context;
        let offset = start;
        const ch = src[offset];
        if (ch && ch !== "#" && ch !== "\n") {
          offset = _PlainValue.endOfLine(src, start, inFlow);
        }
        this.valueRange = new Range(start, offset);
        offset = Node.endOfWhiteSpace(src, offset);
        offset = this.parseComment(offset);
        if (!this.hasComment || this.valueRange.isEmpty()) {
          offset = this.parseBlockValue(offset);
        }
        return offset;
      }
    };
    exports2.Char = Char;
    exports2.Node = Node;
    exports2.PlainValue = PlainValue;
    exports2.Range = Range;
    exports2.Type = Type;
    exports2.YAMLError = YAMLError;
    exports2.YAMLReferenceError = YAMLReferenceError;
    exports2.YAMLSemanticError = YAMLSemanticError;
    exports2.YAMLSyntaxError = YAMLSyntaxError;
    exports2.YAMLWarning = YAMLWarning;
    exports2._defineProperty = _defineProperty;
    exports2.defaultTagPrefix = defaultTagPrefix;
    exports2.defaultTags = defaultTags;
  }
});

// node_modules/aws-cdk-lib/node_modules/yaml/dist/parse-cst.js
var require_parse_cst = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/yaml/dist/parse-cst.js"(exports2) {
    "use strict";
    var PlainValue = require_PlainValue_ec8e588e();
    var BlankLine = class extends PlainValue.Node {
      constructor() {
        super(PlainValue.Type.BLANK_LINE);
      }
      /* istanbul ignore next */
      get includesTrailingLines() {
        return true;
      }
      /**
       * Parses a blank line from the source
       *
       * @param {ParseContext} context
       * @param {number} start - Index of first \n character
       * @returns {number} - Index of the character after this
       */
      parse(context, start) {
        this.context = context;
        this.range = new PlainValue.Range(start, start + 1);
        return start + 1;
      }
    };
    var CollectionItem = class extends PlainValue.Node {
      constructor(type, props) {
        super(type, props);
        this.node = null;
      }
      get includesTrailingLines() {
        return !!this.node && this.node.includesTrailingLines;
      }
      /**
       * @param {ParseContext} context
       * @param {number} start - Index of first character
       * @returns {number} - Index of the character after this
       */
      parse(context, start) {
        this.context = context;
        const {
          parseNode,
          src
        } = context;
        let {
          atLineStart,
          lineStart
        } = context;
        if (!atLineStart && this.type === PlainValue.Type.SEQ_ITEM)
          this.error = new PlainValue.YAMLSemanticError(this, "Sequence items must not have preceding content on the same line");
        const indent = atLineStart ? start - lineStart : context.indent;
        let offset = PlainValue.Node.endOfWhiteSpace(src, start + 1);
        let ch = src[offset];
        const inlineComment = ch === "#";
        const comments = [];
        let blankLine = null;
        while (ch === "\n" || ch === "#") {
          if (ch === "#") {
            const end2 = PlainValue.Node.endOfLine(src, offset + 1);
            comments.push(new PlainValue.Range(offset, end2));
            offset = end2;
          } else {
            atLineStart = true;
            lineStart = offset + 1;
            const wsEnd = PlainValue.Node.endOfWhiteSpace(src, lineStart);
            if (src[wsEnd] === "\n" && comments.length === 0) {
              blankLine = new BlankLine();
              lineStart = blankLine.parse({
                src
              }, lineStart);
            }
            offset = PlainValue.Node.endOfIndent(src, lineStart);
          }
          ch = src[offset];
        }
        if (PlainValue.Node.nextNodeIsIndented(ch, offset - (lineStart + indent), this.type !== PlainValue.Type.SEQ_ITEM)) {
          this.node = parseNode({
            atLineStart,
            inCollection: false,
            indent,
            lineStart,
            parent: this
          }, offset);
        } else if (ch && lineStart > start + 1) {
          offset = lineStart - 1;
        }
        if (this.node) {
          if (blankLine) {
            const items = context.parent.items || context.parent.contents;
            if (items)
              items.push(blankLine);
          }
          if (comments.length)
            Array.prototype.push.apply(this.props, comments);
          offset = this.node.range.end;
        } else {
          if (inlineComment) {
            const c = comments[0];
            this.props.push(c);
            offset = c.end;
          } else {
            offset = PlainValue.Node.endOfLine(src, start + 1);
          }
        }
        const end = this.node ? this.node.valueRange.end : offset;
        this.valueRange = new PlainValue.Range(start, end);
        return offset;
      }
      setOrigRanges(cr, offset) {
        offset = super.setOrigRanges(cr, offset);
        return this.node ? this.node.setOrigRanges(cr, offset) : offset;
      }
      toString() {
        const {
          context: {
            src
          },
          node,
          range,
          value
        } = this;
        if (value != null)
          return value;
        const str = node ? src.slice(range.start, node.range.start) + String(node) : src.slice(range.start, range.end);
        return PlainValue.Node.addStringTerminator(src, range.end, str);
      }
    };
    var Comment = class extends PlainValue.Node {
      constructor() {
        super(PlainValue.Type.COMMENT);
      }
      /**
       * Parses a comment line from the source
       *
       * @param {ParseContext} context
       * @param {number} start - Index of first character
       * @returns {number} - Index of the character after this scalar
       */
      parse(context, start) {
        this.context = context;
        const offset = this.parseComment(start);
        this.range = new PlainValue.Range(start, offset);
        return offset;
      }
    };
    function grabCollectionEndComments(node) {
      let cnode = node;
      while (cnode instanceof CollectionItem)
        cnode = cnode.node;
      if (!(cnode instanceof Collection))
        return null;
      const len = cnode.items.length;
      let ci = -1;
      for (let i = len - 1; i >= 0; --i) {
        const n = cnode.items[i];
        if (n.type === PlainValue.Type.COMMENT) {
          const {
            indent,
            lineStart
          } = n.context;
          if (indent > 0 && n.range.start >= lineStart + indent)
            break;
          ci = i;
        } else if (n.type === PlainValue.Type.BLANK_LINE)
          ci = i;
        else
          break;
      }
      if (ci === -1)
        return null;
      const ca = cnode.items.splice(ci, len - ci);
      const prevEnd = ca[0].range.start;
      while (true) {
        cnode.range.end = prevEnd;
        if (cnode.valueRange && cnode.valueRange.end > prevEnd)
          cnode.valueRange.end = prevEnd;
        if (cnode === node)
          break;
        cnode = cnode.context.parent;
      }
      return ca;
    }
    var Collection = class _Collection extends PlainValue.Node {
      static nextContentHasIndent(src, offset, indent) {
        const lineStart = PlainValue.Node.endOfLine(src, offset) + 1;
        offset = PlainValue.Node.endOfWhiteSpace(src, lineStart);
        const ch = src[offset];
        if (!ch)
          return false;
        if (offset >= lineStart + indent)
          return true;
        if (ch !== "#" && ch !== "\n")
          return false;
        return _Collection.nextContentHasIndent(src, offset, indent);
      }
      constructor(firstItem) {
        super(firstItem.type === PlainValue.Type.SEQ_ITEM ? PlainValue.Type.SEQ : PlainValue.Type.MAP);
        for (let i = firstItem.props.length - 1; i >= 0; --i) {
          if (firstItem.props[i].start < firstItem.context.lineStart) {
            this.props = firstItem.props.slice(0, i + 1);
            firstItem.props = firstItem.props.slice(i + 1);
            const itemRange = firstItem.props[0] || firstItem.valueRange;
            firstItem.range.start = itemRange.start;
            break;
          }
        }
        this.items = [firstItem];
        const ec = grabCollectionEndComments(firstItem);
        if (ec)
          Array.prototype.push.apply(this.items, ec);
      }
      get includesTrailingLines() {
        return this.items.length > 0;
      }
      /**
       * @param {ParseContext} context
       * @param {number} start - Index of first character
       * @returns {number} - Index of the character after this
       */
      parse(context, start) {
        this.context = context;
        const {
          parseNode,
          src
        } = context;
        let lineStart = PlainValue.Node.startOfLine(src, start);
        const firstItem = this.items[0];
        firstItem.context.parent = this;
        this.valueRange = PlainValue.Range.copy(firstItem.valueRange);
        const indent = firstItem.range.start - firstItem.context.lineStart;
        let offset = start;
        offset = PlainValue.Node.normalizeOffset(src, offset);
        let ch = src[offset];
        let atLineStart = PlainValue.Node.endOfWhiteSpace(src, lineStart) === offset;
        let prevIncludesTrailingLines = false;
        while (ch) {
          while (ch === "\n" || ch === "#") {
            if (atLineStart && ch === "\n" && !prevIncludesTrailingLines) {
              const blankLine = new BlankLine();
              offset = blankLine.parse({
                src
              }, offset);
              this.valueRange.end = offset;
              if (offset >= src.length) {
                ch = null;
                break;
              }
              this.items.push(blankLine);
              offset -= 1;
            } else if (ch === "#") {
              if (offset < lineStart + indent && !_Collection.nextContentHasIndent(src, offset, indent)) {
                return offset;
              }
              const comment = new Comment();
              offset = comment.parse({
                indent,
                lineStart,
                src
              }, offset);
              this.items.push(comment);
              this.valueRange.end = offset;
              if (offset >= src.length) {
                ch = null;
                break;
              }
            }
            lineStart = offset + 1;
            offset = PlainValue.Node.endOfIndent(src, lineStart);
            if (PlainValue.Node.atBlank(src, offset)) {
              const wsEnd = PlainValue.Node.endOfWhiteSpace(src, offset);
              const next = src[wsEnd];
              if (!next || next === "\n" || next === "#") {
                offset = wsEnd;
              }
            }
            ch = src[offset];
            atLineStart = true;
          }
          if (!ch) {
            break;
          }
          if (offset !== lineStart + indent && (atLineStart || ch !== ":")) {
            if (offset < lineStart + indent) {
              if (lineStart > start)
                offset = lineStart;
              break;
            } else if (!this.error) {
              const msg = "All collection items must start at the same column";
              this.error = new PlainValue.YAMLSyntaxError(this, msg);
            }
          }
          if (firstItem.type === PlainValue.Type.SEQ_ITEM) {
            if (ch !== "-") {
              if (lineStart > start)
                offset = lineStart;
              break;
            }
          } else if (ch === "-" && !this.error) {
            const next = src[offset + 1];
            if (!next || next === "\n" || next === "	" || next === " ") {
              const msg = "A collection cannot be both a mapping and a sequence";
              this.error = new PlainValue.YAMLSyntaxError(this, msg);
            }
          }
          const node = parseNode({
            atLineStart,
            inCollection: true,
            indent,
            lineStart,
            parent: this
          }, offset);
          if (!node)
            return offset;
          this.items.push(node);
          this.valueRange.end = node.valueRange.end;
          offset = PlainValue.Node.normalizeOffset(src, node.range.end);
          ch = src[offset];
          atLineStart = false;
          prevIncludesTrailingLines = node.includesTrailingLines;
          if (ch) {
            let ls = offset - 1;
            let prev = src[ls];
            while (prev === " " || prev === "	")
              prev = src[--ls];
            if (prev === "\n") {
              lineStart = ls + 1;
              atLineStart = true;
            }
          }
          const ec = grabCollectionEndComments(node);
          if (ec)
            Array.prototype.push.apply(this.items, ec);
        }
        return offset;
      }
      setOrigRanges(cr, offset) {
        offset = super.setOrigRanges(cr, offset);
        this.items.forEach((node) => {
          offset = node.setOrigRanges(cr, offset);
        });
        return offset;
      }
      toString() {
        const {
          context: {
            src
          },
          items,
          range,
          value
        } = this;
        if (value != null)
          return value;
        let str = src.slice(range.start, items[0].range.start) + String(items[0]);
        for (let i = 1; i < items.length; ++i) {
          const item = items[i];
          const {
            atLineStart,
            indent
          } = item.context;
          if (atLineStart)
            for (let i2 = 0; i2 < indent; ++i2)
              str += " ";
          str += String(item);
        }
        return PlainValue.Node.addStringTerminator(src, range.end, str);
      }
    };
    var Directive = class extends PlainValue.Node {
      constructor() {
        super(PlainValue.Type.DIRECTIVE);
        this.name = null;
      }
      get parameters() {
        const raw = this.rawValue;
        return raw ? raw.trim().split(/[ \t]+/) : [];
      }
      parseName(start) {
        const {
          src
        } = this.context;
        let offset = start;
        let ch = src[offset];
        while (ch && ch !== "\n" && ch !== "	" && ch !== " ")
          ch = src[offset += 1];
        this.name = src.slice(start, offset);
        return offset;
      }
      parseParameters(start) {
        const {
          src
        } = this.context;
        let offset = start;
        let ch = src[offset];
        while (ch && ch !== "\n" && ch !== "#")
          ch = src[offset += 1];
        this.valueRange = new PlainValue.Range(start, offset);
        return offset;
      }
      parse(context, start) {
        this.context = context;
        let offset = this.parseName(start + 1);
        offset = this.parseParameters(offset);
        offset = this.parseComment(offset);
        this.range = new PlainValue.Range(start, offset);
        return offset;
      }
    };
    var Document = class _Document extends PlainValue.Node {
      static startCommentOrEndBlankLine(src, start) {
        const offset = PlainValue.Node.endOfWhiteSpace(src, start);
        const ch = src[offset];
        return ch === "#" || ch === "\n" ? offset : start;
      }
      constructor() {
        super(PlainValue.Type.DOCUMENT);
        this.directives = null;
        this.contents = null;
        this.directivesEndMarker = null;
        this.documentEndMarker = null;
      }
      parseDirectives(start) {
        const {
          src
        } = this.context;
        this.directives = [];
        let atLineStart = true;
        let hasDirectives = false;
        let offset = start;
        while (!PlainValue.Node.atDocumentBoundary(src, offset, PlainValue.Char.DIRECTIVES_END)) {
          offset = _Document.startCommentOrEndBlankLine(src, offset);
          switch (src[offset]) {
            case "\n":
              if (atLineStart) {
                const blankLine = new BlankLine();
                offset = blankLine.parse({
                  src
                }, offset);
                if (offset < src.length) {
                  this.directives.push(blankLine);
                }
              } else {
                offset += 1;
                atLineStart = true;
              }
              break;
            case "#":
              {
                const comment = new Comment();
                offset = comment.parse({
                  src
                }, offset);
                this.directives.push(comment);
                atLineStart = false;
              }
              break;
            case "%":
              {
                const directive = new Directive();
                offset = directive.parse({
                  parent: this,
                  src
                }, offset);
                this.directives.push(directive);
                hasDirectives = true;
                atLineStart = false;
              }
              break;
            default:
              if (hasDirectives) {
                this.error = new PlainValue.YAMLSemanticError(this, "Missing directives-end indicator line");
              } else if (this.directives.length > 0) {
                this.contents = this.directives;
                this.directives = [];
              }
              return offset;
          }
        }
        if (src[offset]) {
          this.directivesEndMarker = new PlainValue.Range(offset, offset + 3);
          return offset + 3;
        }
        if (hasDirectives) {
          this.error = new PlainValue.YAMLSemanticError(this, "Missing directives-end indicator line");
        } else if (this.directives.length > 0) {
          this.contents = this.directives;
          this.directives = [];
        }
        return offset;
      }
      parseContents(start) {
        const {
          parseNode,
          src
        } = this.context;
        if (!this.contents)
          this.contents = [];
        let lineStart = start;
        while (src[lineStart - 1] === "-")
          lineStart -= 1;
        let offset = PlainValue.Node.endOfWhiteSpace(src, start);
        let atLineStart = lineStart === start;
        this.valueRange = new PlainValue.Range(offset);
        while (!PlainValue.Node.atDocumentBoundary(src, offset, PlainValue.Char.DOCUMENT_END)) {
          switch (src[offset]) {
            case "\n":
              if (atLineStart) {
                const blankLine = new BlankLine();
                offset = blankLine.parse({
                  src
                }, offset);
                if (offset < src.length) {
                  this.contents.push(blankLine);
                }
              } else {
                offset += 1;
                atLineStart = true;
              }
              lineStart = offset;
              break;
            case "#":
              {
                const comment = new Comment();
                offset = comment.parse({
                  src
                }, offset);
                this.contents.push(comment);
                atLineStart = false;
              }
              break;
            default: {
              const iEnd = PlainValue.Node.endOfIndent(src, offset);
              const context = {
                atLineStart,
                indent: -1,
                inFlow: false,
                inCollection: false,
                lineStart,
                parent: this
              };
              const node = parseNode(context, iEnd);
              if (!node)
                return this.valueRange.end = iEnd;
              this.contents.push(node);
              offset = node.range.end;
              atLineStart = false;
              const ec = grabCollectionEndComments(node);
              if (ec)
                Array.prototype.push.apply(this.contents, ec);
            }
          }
          offset = _Document.startCommentOrEndBlankLine(src, offset);
        }
        this.valueRange.end = offset;
        if (src[offset]) {
          this.documentEndMarker = new PlainValue.Range(offset, offset + 3);
          offset += 3;
          if (src[offset]) {
            offset = PlainValue.Node.endOfWhiteSpace(src, offset);
            if (src[offset] === "#") {
              const comment = new Comment();
              offset = comment.parse({
                src
              }, offset);
              this.contents.push(comment);
            }
            switch (src[offset]) {
              case "\n":
                offset += 1;
                break;
              case void 0:
                break;
              default:
                this.error = new PlainValue.YAMLSyntaxError(this, "Document end marker line cannot have a non-comment suffix");
            }
          }
        }
        return offset;
      }
      /**
       * @param {ParseContext} context
       * @param {number} start - Index of first character
       * @returns {number} - Index of the character after this
       */
      parse(context, start) {
        context.root = this;
        this.context = context;
        const {
          src
        } = context;
        let offset = src.charCodeAt(start) === 65279 ? start + 1 : start;
        offset = this.parseDirectives(offset);
        offset = this.parseContents(offset);
        return offset;
      }
      setOrigRanges(cr, offset) {
        offset = super.setOrigRanges(cr, offset);
        this.directives.forEach((node) => {
          offset = node.setOrigRanges(cr, offset);
        });
        if (this.directivesEndMarker)
          offset = this.directivesEndMarker.setOrigRange(cr, offset);
        this.contents.forEach((node) => {
          offset = node.setOrigRanges(cr, offset);
        });
        if (this.documentEndMarker)
          offset = this.documentEndMarker.setOrigRange(cr, offset);
        return offset;
      }
      toString() {
        const {
          contents,
          directives,
          value
        } = this;
        if (value != null)
          return value;
        let str = directives.join("");
        if (contents.length > 0) {
          if (directives.length > 0 || contents[0].type === PlainValue.Type.COMMENT)
            str += "---\n";
          str += contents.join("");
        }
        if (str[str.length - 1] !== "\n")
          str += "\n";
        return str;
      }
    };
    var Alias = class extends PlainValue.Node {
      /**
       * Parses an *alias from the source
       *
       * @param {ParseContext} context
       * @param {number} start - Index of first character
       * @returns {number} - Index of the character after this scalar
       */
      parse(context, start) {
        this.context = context;
        const {
          src
        } = context;
        let offset = PlainValue.Node.endOfIdentifier(src, start + 1);
        this.valueRange = new PlainValue.Range(start + 1, offset);
        offset = PlainValue.Node.endOfWhiteSpace(src, offset);
        offset = this.parseComment(offset);
        return offset;
      }
    };
    var Chomp = {
      CLIP: "CLIP",
      KEEP: "KEEP",
      STRIP: "STRIP"
    };
    var BlockValue = class extends PlainValue.Node {
      constructor(type, props) {
        super(type, props);
        this.blockIndent = null;
        this.chomping = Chomp.CLIP;
        this.header = null;
      }
      get includesTrailingLines() {
        return this.chomping === Chomp.KEEP;
      }
      get strValue() {
        if (!this.valueRange || !this.context)
          return null;
        let {
          start,
          end
        } = this.valueRange;
        const {
          indent,
          src
        } = this.context;
        if (this.valueRange.isEmpty())
          return "";
        let lastNewLine = null;
        let ch = src[end - 1];
        while (ch === "\n" || ch === "	" || ch === " ") {
          end -= 1;
          if (end <= start) {
            if (this.chomping === Chomp.KEEP)
              break;
            else
              return "";
          }
          if (ch === "\n")
            lastNewLine = end;
          ch = src[end - 1];
        }
        let keepStart = end + 1;
        if (lastNewLine) {
          if (this.chomping === Chomp.KEEP) {
            keepStart = lastNewLine;
            end = this.valueRange.end;
          } else {
            end = lastNewLine;
          }
        }
        const bi = indent + this.blockIndent;
        const folded = this.type === PlainValue.Type.BLOCK_FOLDED;
        let atStart = true;
        let str = "";
        let sep = "";
        let prevMoreIndented = false;
        for (let i = start; i < end; ++i) {
          for (let j = 0; j < bi; ++j) {
            if (src[i] !== " ")
              break;
            i += 1;
          }
          const ch2 = src[i];
          if (ch2 === "\n") {
            if (sep === "\n")
              str += "\n";
            else
              sep = "\n";
          } else {
            const lineEnd = PlainValue.Node.endOfLine(src, i);
            const line = src.slice(i, lineEnd);
            i = lineEnd;
            if (folded && (ch2 === " " || ch2 === "	") && i < keepStart) {
              if (sep === " ")
                sep = "\n";
              else if (!prevMoreIndented && !atStart && sep === "\n")
                sep = "\n\n";
              str += sep + line;
              sep = lineEnd < end && src[lineEnd] || "";
              prevMoreIndented = true;
            } else {
              str += sep + line;
              sep = folded && i < keepStart ? " " : "\n";
              prevMoreIndented = false;
            }
            if (atStart && line !== "")
              atStart = false;
          }
        }
        return this.chomping === Chomp.STRIP ? str : str + "\n";
      }
      parseBlockHeader(start) {
        const {
          src
        } = this.context;
        let offset = start + 1;
        let bi = "";
        while (true) {
          const ch = src[offset];
          switch (ch) {
            case "-":
              this.chomping = Chomp.STRIP;
              break;
            case "+":
              this.chomping = Chomp.KEEP;
              break;
            case "0":
            case "1":
            case "2":
            case "3":
            case "4":
            case "5":
            case "6":
            case "7":
            case "8":
            case "9":
              bi += ch;
              break;
            default:
              this.blockIndent = Number(bi) || null;
              this.header = new PlainValue.Range(start, offset);
              return offset;
          }
          offset += 1;
        }
      }
      parseBlockValue(start) {
        const {
          indent,
          src
        } = this.context;
        const explicit = !!this.blockIndent;
        let offset = start;
        let valueEnd = start;
        let minBlockIndent = 1;
        for (let ch = src[offset]; ch === "\n"; ch = src[offset]) {
          offset += 1;
          if (PlainValue.Node.atDocumentBoundary(src, offset))
            break;
          const end = PlainValue.Node.endOfBlockIndent(src, indent, offset);
          if (end === null)
            break;
          const ch2 = src[end];
          const lineIndent = end - (offset + indent);
          if (!this.blockIndent) {
            if (src[end] !== "\n") {
              if (lineIndent < minBlockIndent) {
                const msg = "Block scalars with more-indented leading empty lines must use an explicit indentation indicator";
                this.error = new PlainValue.YAMLSemanticError(this, msg);
              }
              this.blockIndent = lineIndent;
            } else if (lineIndent > minBlockIndent) {
              minBlockIndent = lineIndent;
            }
          } else if (ch2 && ch2 !== "\n" && lineIndent < this.blockIndent) {
            if (src[end] === "#")
              break;
            if (!this.error) {
              const src2 = explicit ? "explicit indentation indicator" : "first line";
              const msg = `Block scalars must not be less indented than their ${src2}`;
              this.error = new PlainValue.YAMLSemanticError(this, msg);
            }
          }
          if (src[end] === "\n") {
            offset = end;
          } else {
            offset = valueEnd = PlainValue.Node.endOfLine(src, end);
          }
        }
        if (this.chomping !== Chomp.KEEP) {
          offset = src[valueEnd] ? valueEnd + 1 : valueEnd;
        }
        this.valueRange = new PlainValue.Range(start + 1, offset);
        return offset;
      }
      /**
       * Parses a block value from the source
       *
       * Accepted forms are:
       * ```
       * BS
       * block
       * lines
       *
       * BS #comment
       * block
       * lines
       * ```
       * where the block style BS matches the regexp `[|>][-+1-9]*` and block lines
       * are empty or have an indent level greater than `indent`.
       *
       * @param {ParseContext} context
       * @param {number} start - Index of first character
       * @returns {number} - Index of the character after this block
       */
      parse(context, start) {
        this.context = context;
        const {
          src
        } = context;
        let offset = this.parseBlockHeader(start);
        offset = PlainValue.Node.endOfWhiteSpace(src, offset);
        offset = this.parseComment(offset);
        offset = this.parseBlockValue(offset);
        return offset;
      }
      setOrigRanges(cr, offset) {
        offset = super.setOrigRanges(cr, offset);
        return this.header ? this.header.setOrigRange(cr, offset) : offset;
      }
    };
    var FlowCollection = class extends PlainValue.Node {
      constructor(type, props) {
        super(type, props);
        this.items = null;
      }
      prevNodeIsJsonLike(idx = this.items.length) {
        const node = this.items[idx - 1];
        return !!node && (node.jsonLike || node.type === PlainValue.Type.COMMENT && this.prevNodeIsJsonLike(idx - 1));
      }
      /**
       * @param {ParseContext} context
       * @param {number} start - Index of first character
       * @returns {number} - Index of the character after this
       */
      parse(context, start) {
        this.context = context;
        const {
          parseNode,
          src
        } = context;
        let {
          indent,
          lineStart
        } = context;
        let char = src[start];
        this.items = [{
          char,
          offset: start
        }];
        let offset = PlainValue.Node.endOfWhiteSpace(src, start + 1);
        char = src[offset];
        while (char && char !== "]" && char !== "}") {
          switch (char) {
            case "\n":
              {
                lineStart = offset + 1;
                const wsEnd = PlainValue.Node.endOfWhiteSpace(src, lineStart);
                if (src[wsEnd] === "\n") {
                  const blankLine = new BlankLine();
                  lineStart = blankLine.parse({
                    src
                  }, lineStart);
                  this.items.push(blankLine);
                }
                offset = PlainValue.Node.endOfIndent(src, lineStart);
                if (offset <= lineStart + indent) {
                  char = src[offset];
                  if (offset < lineStart + indent || char !== "]" && char !== "}") {
                    const msg = "Insufficient indentation in flow collection";
                    this.error = new PlainValue.YAMLSemanticError(this, msg);
                  }
                }
              }
              break;
            case ",":
              {
                this.items.push({
                  char,
                  offset
                });
                offset += 1;
              }
              break;
            case "#":
              {
                const comment = new Comment();
                offset = comment.parse({
                  src
                }, offset);
                this.items.push(comment);
              }
              break;
            case "?":
            case ":": {
              const next = src[offset + 1];
              if (next === "\n" || next === "	" || next === " " || next === "," || // in-flow : after JSON-like key does not need to be followed by whitespace
              char === ":" && this.prevNodeIsJsonLike()) {
                this.items.push({
                  char,
                  offset
                });
                offset += 1;
                break;
              }
            }
            default: {
              const node = parseNode({
                atLineStart: false,
                inCollection: false,
                inFlow: true,
                indent: -1,
                lineStart,
                parent: this
              }, offset);
              if (!node) {
                this.valueRange = new PlainValue.Range(start, offset);
                return offset;
              }
              this.items.push(node);
              offset = PlainValue.Node.normalizeOffset(src, node.range.end);
            }
          }
          offset = PlainValue.Node.endOfWhiteSpace(src, offset);
          char = src[offset];
        }
        this.valueRange = new PlainValue.Range(start, offset + 1);
        if (char) {
          this.items.push({
            char,
            offset
          });
          offset = PlainValue.Node.endOfWhiteSpace(src, offset + 1);
          offset = this.parseComment(offset);
        }
        return offset;
      }
      setOrigRanges(cr, offset) {
        offset = super.setOrigRanges(cr, offset);
        this.items.forEach((node) => {
          if (node instanceof PlainValue.Node) {
            offset = node.setOrigRanges(cr, offset);
          } else if (cr.length === 0) {
            node.origOffset = node.offset;
          } else {
            let i = offset;
            while (i < cr.length) {
              if (cr[i] > node.offset)
                break;
              else
                ++i;
            }
            node.origOffset = node.offset + i;
            offset = i;
          }
        });
        return offset;
      }
      toString() {
        const {
          context: {
            src
          },
          items,
          range,
          value
        } = this;
        if (value != null)
          return value;
        const nodes = items.filter((item) => item instanceof PlainValue.Node);
        let str = "";
        let prevEnd = range.start;
        nodes.forEach((node) => {
          const prefix = src.slice(prevEnd, node.range.start);
          prevEnd = node.range.end;
          str += prefix + String(node);
          if (str[str.length - 1] === "\n" && src[prevEnd - 1] !== "\n" && src[prevEnd] === "\n") {
            prevEnd += 1;
          }
        });
        str += src.slice(prevEnd, range.end);
        return PlainValue.Node.addStringTerminator(src, range.end, str);
      }
    };
    var QuoteDouble = class _QuoteDouble extends PlainValue.Node {
      static endOfQuote(src, offset) {
        let ch = src[offset];
        while (ch && ch !== '"') {
          offset += ch === "\\" ? 2 : 1;
          ch = src[offset];
        }
        return offset + 1;
      }
      /**
       * @returns {string | { str: string, errors: YAMLSyntaxError[] }}
       */
      get strValue() {
        if (!this.valueRange || !this.context)
          return null;
        const errors = [];
        const {
          start,
          end
        } = this.valueRange;
        const {
          indent,
          src
        } = this.context;
        if (src[end - 1] !== '"')
          errors.push(new PlainValue.YAMLSyntaxError(this, 'Missing closing "quote'));
        let str = "";
        for (let i = start + 1; i < end - 1; ++i) {
          const ch = src[i];
          if (ch === "\n") {
            if (PlainValue.Node.atDocumentBoundary(src, i + 1))
              errors.push(new PlainValue.YAMLSemanticError(this, "Document boundary indicators are not allowed within string values"));
            const {
              fold,
              offset,
              error
            } = PlainValue.Node.foldNewline(src, i, indent);
            str += fold;
            i = offset;
            if (error)
              errors.push(new PlainValue.YAMLSemanticError(this, "Multi-line double-quoted string needs to be sufficiently indented"));
          } else if (ch === "\\") {
            i += 1;
            switch (src[i]) {
              case "0":
                str += "\0";
                break;
              case "a":
                str += "\x07";
                break;
              case "b":
                str += "\b";
                break;
              case "e":
                str += "\x1B";
                break;
              case "f":
                str += "\f";
                break;
              case "n":
                str += "\n";
                break;
              case "r":
                str += "\r";
                break;
              case "t":
                str += "	";
                break;
              case "v":
                str += "\v";
                break;
              case "N":
                str += "\x85";
                break;
              case "_":
                str += "\xA0";
                break;
              case "L":
                str += "\u2028";
                break;
              case "P":
                str += "\u2029";
                break;
              case " ":
                str += " ";
                break;
              case '"':
                str += '"';
                break;
              case "/":
                str += "/";
                break;
              case "\\":
                str += "\\";
                break;
              case "	":
                str += "	";
                break;
              case "x":
                str += this.parseCharCode(i + 1, 2, errors);
                i += 2;
                break;
              case "u":
                str += this.parseCharCode(i + 1, 4, errors);
                i += 4;
                break;
              case "U":
                str += this.parseCharCode(i + 1, 8, errors);
                i += 8;
                break;
              case "\n":
                while (src[i + 1] === " " || src[i + 1] === "	")
                  i += 1;
                break;
              default:
                errors.push(new PlainValue.YAMLSyntaxError(this, `Invalid escape sequence ${src.substr(i - 1, 2)}`));
                str += "\\" + src[i];
            }
          } else if (ch === " " || ch === "	") {
            const wsStart = i;
            let next = src[i + 1];
            while (next === " " || next === "	") {
              i += 1;
              next = src[i + 1];
            }
            if (next !== "\n")
              str += i > wsStart ? src.slice(wsStart, i + 1) : ch;
          } else {
            str += ch;
          }
        }
        return errors.length > 0 ? {
          errors,
          str
        } : str;
      }
      parseCharCode(offset, length, errors) {
        const {
          src
        } = this.context;
        const cc = src.substr(offset, length);
        const ok = cc.length === length && /^[0-9a-fA-F]+$/.test(cc);
        const code = ok ? parseInt(cc, 16) : NaN;
        if (isNaN(code)) {
          errors.push(new PlainValue.YAMLSyntaxError(this, `Invalid escape sequence ${src.substr(offset - 2, length + 2)}`));
          return src.substr(offset - 2, length + 2);
        }
        return String.fromCodePoint(code);
      }
      /**
       * Parses a "double quoted" value from the source
       *
       * @param {ParseContext} context
       * @param {number} start - Index of first character
       * @returns {number} - Index of the character after this scalar
       */
      parse(context, start) {
        this.context = context;
        const {
          src
        } = context;
        let offset = _QuoteDouble.endOfQuote(src, start + 1);
        this.valueRange = new PlainValue.Range(start, offset);
        offset = PlainValue.Node.endOfWhiteSpace(src, offset);
        offset = this.parseComment(offset);
        return offset;
      }
    };
    var QuoteSingle = class _QuoteSingle extends PlainValue.Node {
      static endOfQuote(src, offset) {
        let ch = src[offset];
        while (ch) {
          if (ch === "'") {
            if (src[offset + 1] !== "'")
              break;
            ch = src[offset += 2];
          } else {
            ch = src[offset += 1];
          }
        }
        return offset + 1;
      }
      /**
       * @returns {string | { str: string, errors: YAMLSyntaxError[] }}
       */
      get strValue() {
        if (!this.valueRange || !this.context)
          return null;
        const errors = [];
        const {
          start,
          end
        } = this.valueRange;
        const {
          indent,
          src
        } = this.context;
        if (src[end - 1] !== "'")
          errors.push(new PlainValue.YAMLSyntaxError(this, "Missing closing 'quote"));
        let str = "";
        for (let i = start + 1; i < end - 1; ++i) {
          const ch = src[i];
          if (ch === "\n") {
            if (PlainValue.Node.atDocumentBoundary(src, i + 1))
              errors.push(new PlainValue.YAMLSemanticError(this, "Document boundary indicators are not allowed within string values"));
            const {
              fold,
              offset,
              error
            } = PlainValue.Node.foldNewline(src, i, indent);
            str += fold;
            i = offset;
            if (error)
              errors.push(new PlainValue.YAMLSemanticError(this, "Multi-line single-quoted string needs to be sufficiently indented"));
          } else if (ch === "'") {
            str += ch;
            i += 1;
            if (src[i] !== "'")
              errors.push(new PlainValue.YAMLSyntaxError(this, "Unescaped single quote? This should not happen."));
          } else if (ch === " " || ch === "	") {
            const wsStart = i;
            let next = src[i + 1];
            while (next === " " || next === "	") {
              i += 1;
              next = src[i + 1];
            }
            if (next !== "\n")
              str += i > wsStart ? src.slice(wsStart, i + 1) : ch;
          } else {
            str += ch;
          }
        }
        return errors.length > 0 ? {
          errors,
          str
        } : str;
      }
      /**
       * Parses a 'single quoted' value from the source
       *
       * @param {ParseContext} context
       * @param {number} start - Index of first character
       * @returns {number} - Index of the character after this scalar
       */
      parse(context, start) {
        this.context = context;
        const {
          src
        } = context;
        let offset = _QuoteSingle.endOfQuote(src, start + 1);
        this.valueRange = new PlainValue.Range(start, offset);
        offset = PlainValue.Node.endOfWhiteSpace(src, offset);
        offset = this.parseComment(offset);
        return offset;
      }
    };
    function createNewNode(type, props) {
      switch (type) {
        case PlainValue.Type.ALIAS:
          return new Alias(type, props);
        case PlainValue.Type.BLOCK_FOLDED:
        case PlainValue.Type.BLOCK_LITERAL:
          return new BlockValue(type, props);
        case PlainValue.Type.FLOW_MAP:
        case PlainValue.Type.FLOW_SEQ:
          return new FlowCollection(type, props);
        case PlainValue.Type.MAP_KEY:
        case PlainValue.Type.MAP_VALUE:
        case PlainValue.Type.SEQ_ITEM:
          return new CollectionItem(type, props);
        case PlainValue.Type.COMMENT:
        case PlainValue.Type.PLAIN:
          return new PlainValue.PlainValue(type, props);
        case PlainValue.Type.QUOTE_DOUBLE:
          return new QuoteDouble(type, props);
        case PlainValue.Type.QUOTE_SINGLE:
          return new QuoteSingle(type, props);
        default:
          return null;
      }
    }
    var ParseContext = class _ParseContext {
      static parseType(src, offset, inFlow) {
        switch (src[offset]) {
          case "*":
            return PlainValue.Type.ALIAS;
          case ">":
            return PlainValue.Type.BLOCK_FOLDED;
          case "|":
            return PlainValue.Type.BLOCK_LITERAL;
          case "{":
            return PlainValue.Type.FLOW_MAP;
          case "[":
            return PlainValue.Type.FLOW_SEQ;
          case "?":
            return !inFlow && PlainValue.Node.atBlank(src, offset + 1, true) ? PlainValue.Type.MAP_KEY : PlainValue.Type.PLAIN;
          case ":":
            return !inFlow && PlainValue.Node.atBlank(src, offset + 1, true) ? PlainValue.Type.MAP_VALUE : PlainValue.Type.PLAIN;
          case "-":
            return !inFlow && PlainValue.Node.atBlank(src, offset + 1, true) ? PlainValue.Type.SEQ_ITEM : PlainValue.Type.PLAIN;
          case '"':
            return PlainValue.Type.QUOTE_DOUBLE;
          case "'":
            return PlainValue.Type.QUOTE_SINGLE;
          default:
            return PlainValue.Type.PLAIN;
        }
      }
      constructor(orig = {}, {
        atLineStart,
        inCollection,
        inFlow,
        indent,
        lineStart,
        parent
      } = {}) {
        PlainValue._defineProperty(this, "parseNode", (overlay, start) => {
          if (PlainValue.Node.atDocumentBoundary(this.src, start))
            return null;
          const context = new _ParseContext(this, overlay);
          const {
            props,
            type,
            valueStart
          } = context.parseProps(start);
          const node = createNewNode(type, props);
          let offset = node.parse(context, valueStart);
          node.range = new PlainValue.Range(start, offset);
          if (offset <= start) {
            node.error = new Error(`Node#parse consumed no characters`);
            node.error.parseEnd = offset;
            node.error.source = node;
            node.range.end = start + 1;
          }
          if (context.nodeStartsCollection(node)) {
            if (!node.error && !context.atLineStart && context.parent.type === PlainValue.Type.DOCUMENT) {
              node.error = new PlainValue.YAMLSyntaxError(node, "Block collection must not have preceding content here (e.g. directives-end indicator)");
            }
            const collection = new Collection(node);
            offset = collection.parse(new _ParseContext(context), offset);
            collection.range = new PlainValue.Range(start, offset);
            return collection;
          }
          return node;
        });
        this.atLineStart = atLineStart != null ? atLineStart : orig.atLineStart || false;
        this.inCollection = inCollection != null ? inCollection : orig.inCollection || false;
        this.inFlow = inFlow != null ? inFlow : orig.inFlow || false;
        this.indent = indent != null ? indent : orig.indent;
        this.lineStart = lineStart != null ? lineStart : orig.lineStart;
        this.parent = parent != null ? parent : orig.parent || {};
        this.root = orig.root;
        this.src = orig.src;
      }
      nodeStartsCollection(node) {
        const {
          inCollection,
          inFlow,
          src
        } = this;
        if (inCollection || inFlow)
          return false;
        if (node instanceof CollectionItem)
          return true;
        let offset = node.range.end;
        if (src[offset] === "\n" || src[offset - 1] === "\n")
          return false;
        offset = PlainValue.Node.endOfWhiteSpace(src, offset);
        return src[offset] === ":";
      }
      // Anchor and tag are before type, which determines the node implementation
      // class; hence this intermediate step.
      parseProps(offset) {
        const {
          inFlow,
          parent,
          src
        } = this;
        const props = [];
        let lineHasProps = false;
        offset = this.atLineStart ? PlainValue.Node.endOfIndent(src, offset) : PlainValue.Node.endOfWhiteSpace(src, offset);
        let ch = src[offset];
        while (ch === PlainValue.Char.ANCHOR || ch === PlainValue.Char.COMMENT || ch === PlainValue.Char.TAG || ch === "\n") {
          if (ch === "\n") {
            let inEnd = offset;
            let lineStart;
            do {
              lineStart = inEnd + 1;
              inEnd = PlainValue.Node.endOfIndent(src, lineStart);
            } while (src[inEnd] === "\n");
            const indentDiff = inEnd - (lineStart + this.indent);
            const noIndicatorAsIndent = parent.type === PlainValue.Type.SEQ_ITEM && parent.context.atLineStart;
            if (src[inEnd] !== "#" && !PlainValue.Node.nextNodeIsIndented(src[inEnd], indentDiff, !noIndicatorAsIndent))
              break;
            this.atLineStart = true;
            this.lineStart = lineStart;
            lineHasProps = false;
            offset = inEnd;
          } else if (ch === PlainValue.Char.COMMENT) {
            const end = PlainValue.Node.endOfLine(src, offset + 1);
            props.push(new PlainValue.Range(offset, end));
            offset = end;
          } else {
            let end = PlainValue.Node.endOfIdentifier(src, offset + 1);
            if (ch === PlainValue.Char.TAG && src[end] === "," && /^[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+,\d\d\d\d(-\d\d){0,2}\/\S/.test(src.slice(offset + 1, end + 13))) {
              end = PlainValue.Node.endOfIdentifier(src, end + 5);
            }
            props.push(new PlainValue.Range(offset, end));
            lineHasProps = true;
            offset = PlainValue.Node.endOfWhiteSpace(src, end);
          }
          ch = src[offset];
        }
        if (lineHasProps && ch === ":" && PlainValue.Node.atBlank(src, offset + 1, true))
          offset -= 1;
        const type = _ParseContext.parseType(src, offset, inFlow);
        return {
          props,
          type,
          valueStart: offset
        };
      }
      /**
       * Parses a node from the source
       * @param {ParseContext} overlay
       * @param {number} start - Index of first non-whitespace character for the node
       * @returns {?Node} - null if at a document boundary
       */
    };
    function parse(src) {
      const cr = [];
      if (src.indexOf("\r") !== -1) {
        src = src.replace(/\r\n?/g, (match, offset2) => {
          if (match.length > 1)
            cr.push(offset2);
          return "\n";
        });
      }
      const documents = [];
      let offset = 0;
      do {
        const doc = new Document();
        const context = new ParseContext({
          src
        });
        offset = doc.parse(context, offset);
        documents.push(doc);
      } while (offset < src.length);
      documents.setOrigRanges = () => {
        if (cr.length === 0)
          return false;
        for (let i = 1; i < cr.length; ++i)
          cr[i] -= i;
        let crOffset = 0;
        for (let i = 0; i < documents.length; ++i) {
          crOffset = documents[i].setOrigRanges(cr, crOffset);
        }
        cr.splice(0, cr.length);
        return true;
      };
      documents.toString = () => documents.join("...\n");
      return documents;
    }
    exports2.parse = parse;
  }
});

// node_modules/aws-cdk-lib/node_modules/yaml/dist/resolveSeq-d03cb037.js
var require_resolveSeq_d03cb037 = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/yaml/dist/resolveSeq-d03cb037.js"(exports2) {
    "use strict";
    var PlainValue = require_PlainValue_ec8e588e();
    function addCommentBefore(str, indent, comment) {
      if (!comment)
        return str;
      const cc = comment.replace(/[\s\S]^/gm, `$&${indent}#`);
      return `#${cc}
${indent}${str}`;
    }
    function addComment(str, indent, comment) {
      return !comment ? str : comment.indexOf("\n") === -1 ? `${str} #${comment}` : `${str}
` + comment.replace(/^/gm, `${indent || ""}#`);
    }
    var Node = class {
    };
    function toJSON(value, arg, ctx) {
      if (Array.isArray(value))
        return value.map((v, i) => toJSON(v, String(i), ctx));
      if (value && typeof value.toJSON === "function") {
        const anchor = ctx && ctx.anchors && ctx.anchors.get(value);
        if (anchor)
          ctx.onCreate = (res2) => {
            anchor.res = res2;
            delete ctx.onCreate;
          };
        const res = value.toJSON(arg, ctx);
        if (anchor && ctx.onCreate)
          ctx.onCreate(res);
        return res;
      }
      if ((!ctx || !ctx.keep) && typeof value === "bigint")
        return Number(value);
      return value;
    }
    var Scalar = class extends Node {
      constructor(value) {
        super();
        this.value = value;
      }
      toJSON(arg, ctx) {
        return ctx && ctx.keep ? this.value : toJSON(this.value, arg, ctx);
      }
      toString() {
        return String(this.value);
      }
    };
    function collectionFromPath(schema, path, value) {
      let v = value;
      for (let i = path.length - 1; i >= 0; --i) {
        const k = path[i];
        if (Number.isInteger(k) && k >= 0) {
          const a = [];
          a[k] = v;
          v = a;
        } else {
          const o = {};
          Object.defineProperty(o, k, {
            value: v,
            writable: true,
            enumerable: true,
            configurable: true
          });
          v = o;
        }
      }
      return schema.createNode(v, false);
    }
    var isEmptyPath = (path) => path == null || typeof path === "object" && path[Symbol.iterator]().next().done;
    var Collection = class _Collection extends Node {
      constructor(schema) {
        super();
        PlainValue._defineProperty(this, "items", []);
        this.schema = schema;
      }
      addIn(path, value) {
        if (isEmptyPath(path))
          this.add(value);
        else {
          const [key, ...rest] = path;
          const node = this.get(key, true);
          if (node instanceof _Collection)
            node.addIn(rest, value);
          else if (node === void 0 && this.schema)
            this.set(key, collectionFromPath(this.schema, rest, value));
          else
            throw new Error(`Expected YAML collection at ${key}. Remaining path: ${rest}`);
        }
      }
      deleteIn([key, ...rest]) {
        if (rest.length === 0)
          return this.delete(key);
        const node = this.get(key, true);
        if (node instanceof _Collection)
          return node.deleteIn(rest);
        else
          throw new Error(`Expected YAML collection at ${key}. Remaining path: ${rest}`);
      }
      getIn([key, ...rest], keepScalar) {
        const node = this.get(key, true);
        if (rest.length === 0)
          return !keepScalar && node instanceof Scalar ? node.value : node;
        else
          return node instanceof _Collection ? node.getIn(rest, keepScalar) : void 0;
      }
      hasAllNullValues() {
        return this.items.every((node) => {
          if (!node || node.type !== "PAIR")
            return false;
          const n = node.value;
          return n == null || n instanceof Scalar && n.value == null && !n.commentBefore && !n.comment && !n.tag;
        });
      }
      hasIn([key, ...rest]) {
        if (rest.length === 0)
          return this.has(key);
        const node = this.get(key, true);
        return node instanceof _Collection ? node.hasIn(rest) : false;
      }
      setIn([key, ...rest], value) {
        if (rest.length === 0) {
          this.set(key, value);
        } else {
          const node = this.get(key, true);
          if (node instanceof _Collection)
            node.setIn(rest, value);
          else if (node === void 0 && this.schema)
            this.set(key, collectionFromPath(this.schema, rest, value));
          else
            throw new Error(`Expected YAML collection at ${key}. Remaining path: ${rest}`);
        }
      }
      // overridden in implementations
      /* istanbul ignore next */
      toJSON() {
        return null;
      }
      toString(ctx, {
        blockItem,
        flowChars,
        isMap,
        itemIndent
      }, onComment, onChompKeep) {
        const {
          indent,
          indentStep,
          stringify
        } = ctx;
        const inFlow = this.type === PlainValue.Type.FLOW_MAP || this.type === PlainValue.Type.FLOW_SEQ || ctx.inFlow;
        if (inFlow)
          itemIndent += indentStep;
        const allNullValues = isMap && this.hasAllNullValues();
        ctx = Object.assign({}, ctx, {
          allNullValues,
          indent: itemIndent,
          inFlow,
          type: null
        });
        let chompKeep = false;
        let hasItemWithNewLine = false;
        const nodes = this.items.reduce((nodes2, item, i) => {
          let comment;
          if (item) {
            if (!chompKeep && item.spaceBefore)
              nodes2.push({
                type: "comment",
                str: ""
              });
            if (item.commentBefore)
              item.commentBefore.match(/^.*$/gm).forEach((line) => {
                nodes2.push({
                  type: "comment",
                  str: `#${line}`
                });
              });
            if (item.comment)
              comment = item.comment;
            if (inFlow && (!chompKeep && item.spaceBefore || item.commentBefore || item.comment || item.key && (item.key.commentBefore || item.key.comment) || item.value && (item.value.commentBefore || item.value.comment)))
              hasItemWithNewLine = true;
          }
          chompKeep = false;
          let str2 = stringify(item, ctx, () => comment = null, () => chompKeep = true);
          if (inFlow && !hasItemWithNewLine && str2.includes("\n"))
            hasItemWithNewLine = true;
          if (inFlow && i < this.items.length - 1)
            str2 += ",";
          str2 = addComment(str2, itemIndent, comment);
          if (chompKeep && (comment || inFlow))
            chompKeep = false;
          nodes2.push({
            type: "item",
            str: str2
          });
          return nodes2;
        }, []);
        let str;
        if (nodes.length === 0) {
          str = flowChars.start + flowChars.end;
        } else if (inFlow) {
          const {
            start,
            end
          } = flowChars;
          const strings = nodes.map((n) => n.str);
          if (hasItemWithNewLine || strings.reduce((sum, str2) => sum + str2.length + 2, 2) > _Collection.maxFlowStringSingleLineLength) {
            str = start;
            for (const s of strings) {
              str += s ? `
${indentStep}${indent}${s}` : "\n";
            }
            str += `
${indent}${end}`;
          } else {
            str = `${start} ${strings.join(" ")} ${end}`;
          }
        } else {
          const strings = nodes.map(blockItem);
          str = strings.shift();
          for (const s of strings)
            str += s ? `
${indent}${s}` : "\n";
        }
        if (this.comment) {
          str += "\n" + this.comment.replace(/^/gm, `${indent}#`);
          if (onComment)
            onComment();
        } else if (chompKeep && onChompKeep)
          onChompKeep();
        return str;
      }
    };
    PlainValue._defineProperty(Collection, "maxFlowStringSingleLineLength", 60);
    function asItemIndex(key) {
      let idx = key instanceof Scalar ? key.value : key;
      if (idx && typeof idx === "string")
        idx = Number(idx);
      return Number.isInteger(idx) && idx >= 0 ? idx : null;
    }
    var YAMLSeq = class extends Collection {
      add(value) {
        this.items.push(value);
      }
      delete(key) {
        const idx = asItemIndex(key);
        if (typeof idx !== "number")
          return false;
        const del = this.items.splice(idx, 1);
        return del.length > 0;
      }
      get(key, keepScalar) {
        const idx = asItemIndex(key);
        if (typeof idx !== "number")
          return void 0;
        const it = this.items[idx];
        return !keepScalar && it instanceof Scalar ? it.value : it;
      }
      has(key) {
        const idx = asItemIndex(key);
        return typeof idx === "number" && idx < this.items.length;
      }
      set(key, value) {
        const idx = asItemIndex(key);
        if (typeof idx !== "number")
          throw new Error(`Expected a valid index, not ${key}.`);
        this.items[idx] = value;
      }
      toJSON(_, ctx) {
        const seq = [];
        if (ctx && ctx.onCreate)
          ctx.onCreate(seq);
        let i = 0;
        for (const item of this.items)
          seq.push(toJSON(item, String(i++), ctx));
        return seq;
      }
      toString(ctx, onComment, onChompKeep) {
        if (!ctx)
          return JSON.stringify(this);
        return super.toString(ctx, {
          blockItem: (n) => n.type === "comment" ? n.str : `- ${n.str}`,
          flowChars: {
            start: "[",
            end: "]"
          },
          isMap: false,
          itemIndent: (ctx.indent || "") + "  "
        }, onComment, onChompKeep);
      }
    };
    var stringifyKey = (key, jsKey, ctx) => {
      if (jsKey === null)
        return "";
      if (typeof jsKey !== "object")
        return String(jsKey);
      if (key instanceof Node && ctx && ctx.doc)
        return key.toString({
          anchors: /* @__PURE__ */ Object.create(null),
          doc: ctx.doc,
          indent: "",
          indentStep: ctx.indentStep,
          inFlow: true,
          inStringifyKey: true,
          stringify: ctx.stringify
        });
      return JSON.stringify(jsKey);
    };
    var Pair = class _Pair extends Node {
      constructor(key, value = null) {
        super();
        this.key = key;
        this.value = value;
        this.type = _Pair.Type.PAIR;
      }
      get commentBefore() {
        return this.key instanceof Node ? this.key.commentBefore : void 0;
      }
      set commentBefore(cb) {
        if (this.key == null)
          this.key = new Scalar(null);
        if (this.key instanceof Node)
          this.key.commentBefore = cb;
        else {
          const msg = "Pair.commentBefore is an alias for Pair.key.commentBefore. To set it, the key must be a Node.";
          throw new Error(msg);
        }
      }
      addToJSMap(ctx, map) {
        const key = toJSON(this.key, "", ctx);
        if (map instanceof Map) {
          const value = toJSON(this.value, key, ctx);
          map.set(key, value);
        } else if (map instanceof Set) {
          map.add(key);
        } else {
          const stringKey = stringifyKey(this.key, key, ctx);
          const value = toJSON(this.value, stringKey, ctx);
          if (stringKey in map)
            Object.defineProperty(map, stringKey, {
              value,
              writable: true,
              enumerable: true,
              configurable: true
            });
          else
            map[stringKey] = value;
        }
        return map;
      }
      toJSON(_, ctx) {
        const pair = ctx && ctx.mapAsMap ? /* @__PURE__ */ new Map() : {};
        return this.addToJSMap(ctx, pair);
      }
      toString(ctx, onComment, onChompKeep) {
        if (!ctx || !ctx.doc)
          return JSON.stringify(this);
        const {
          indent: indentSize,
          indentSeq,
          simpleKeys
        } = ctx.doc.options;
        let {
          key,
          value
        } = this;
        let keyComment = key instanceof Node && key.comment;
        if (simpleKeys) {
          if (keyComment) {
            throw new Error("With simple keys, key nodes cannot have comments");
          }
          if (key instanceof Collection) {
            const msg = "With simple keys, collection cannot be used as a key value";
            throw new Error(msg);
          }
        }
        let explicitKey = !simpleKeys && (!key || keyComment || (key instanceof Node ? key instanceof Collection || key.type === PlainValue.Type.BLOCK_FOLDED || key.type === PlainValue.Type.BLOCK_LITERAL : typeof key === "object"));
        const {
          doc,
          indent,
          indentStep,
          stringify
        } = ctx;
        ctx = Object.assign({}, ctx, {
          implicitKey: !explicitKey,
          indent: indent + indentStep
        });
        let chompKeep = false;
        let str = stringify(key, ctx, () => keyComment = null, () => chompKeep = true);
        str = addComment(str, ctx.indent, keyComment);
        if (!explicitKey && str.length > 1024) {
          if (simpleKeys)
            throw new Error("With simple keys, single line scalar must not span more than 1024 characters");
          explicitKey = true;
        }
        if (ctx.allNullValues && !simpleKeys) {
          if (this.comment) {
            str = addComment(str, ctx.indent, this.comment);
            if (onComment)
              onComment();
          } else if (chompKeep && !keyComment && onChompKeep)
            onChompKeep();
          return ctx.inFlow && !explicitKey ? str : `? ${str}`;
        }
        str = explicitKey ? `? ${str}
${indent}:` : `${str}:`;
        if (this.comment) {
          str = addComment(str, ctx.indent, this.comment);
          if (onComment)
            onComment();
        }
        let vcb = "";
        let valueComment = null;
        if (value instanceof Node) {
          if (value.spaceBefore)
            vcb = "\n";
          if (value.commentBefore) {
            const cs = value.commentBefore.replace(/^/gm, `${ctx.indent}#`);
            vcb += `
${cs}`;
          }
          valueComment = value.comment;
        } else if (value && typeof value === "object") {
          value = doc.schema.createNode(value, true);
        }
        ctx.implicitKey = false;
        if (!explicitKey && !this.comment && value instanceof Scalar)
          ctx.indentAtStart = str.length + 1;
        chompKeep = false;
        if (!indentSeq && indentSize >= 2 && !ctx.inFlow && !explicitKey && value instanceof YAMLSeq && value.type !== PlainValue.Type.FLOW_SEQ && !value.tag && !doc.anchors.getName(value)) {
          ctx.indent = ctx.indent.substr(2);
        }
        const valueStr = stringify(value, ctx, () => valueComment = null, () => chompKeep = true);
        let ws = " ";
        if (vcb || this.comment) {
          ws = `${vcb}
${ctx.indent}`;
        } else if (!explicitKey && value instanceof Collection) {
          const flow = valueStr[0] === "[" || valueStr[0] === "{";
          if (!flow || valueStr.includes("\n"))
            ws = `
${ctx.indent}`;
        } else if (valueStr[0] === "\n")
          ws = "";
        if (chompKeep && !valueComment && onChompKeep)
          onChompKeep();
        return addComment(str + ws + valueStr, ctx.indent, valueComment);
      }
    };
    PlainValue._defineProperty(Pair, "Type", {
      PAIR: "PAIR",
      MERGE_PAIR: "MERGE_PAIR"
    });
    var getAliasCount = (node, anchors) => {
      if (node instanceof Alias) {
        const anchor = anchors.get(node.source);
        return anchor.count * anchor.aliasCount;
      } else if (node instanceof Collection) {
        let count = 0;
        for (const item of node.items) {
          const c = getAliasCount(item, anchors);
          if (c > count)
            count = c;
        }
        return count;
      } else if (node instanceof Pair) {
        const kc = getAliasCount(node.key, anchors);
        const vc = getAliasCount(node.value, anchors);
        return Math.max(kc, vc);
      }
      return 1;
    };
    var Alias = class _Alias extends Node {
      static stringify({
        range,
        source
      }, {
        anchors,
        doc,
        implicitKey,
        inStringifyKey
      }) {
        let anchor = Object.keys(anchors).find((a) => anchors[a] === source);
        if (!anchor && inStringifyKey)
          anchor = doc.anchors.getName(source) || doc.anchors.newName();
        if (anchor)
          return `*${anchor}${implicitKey ? " " : ""}`;
        const msg = doc.anchors.getName(source) ? "Alias node must be after source node" : "Source node not found for alias node";
        throw new Error(`${msg} [${range}]`);
      }
      constructor(source) {
        super();
        this.source = source;
        this.type = PlainValue.Type.ALIAS;
      }
      set tag(t) {
        throw new Error("Alias nodes cannot have tags");
      }
      toJSON(arg, ctx) {
        if (!ctx)
          return toJSON(this.source, arg, ctx);
        const {
          anchors,
          maxAliasCount
        } = ctx;
        const anchor = anchors.get(this.source);
        if (!anchor || anchor.res === void 0) {
          const msg = "This should not happen: Alias anchor was not resolved?";
          if (this.cstNode)
            throw new PlainValue.YAMLReferenceError(this.cstNode, msg);
          else
            throw new ReferenceError(msg);
        }
        if (maxAliasCount >= 0) {
          anchor.count += 1;
          if (anchor.aliasCount === 0)
            anchor.aliasCount = getAliasCount(this.source, anchors);
          if (anchor.count * anchor.aliasCount > maxAliasCount) {
            const msg = "Excessive alias count indicates a resource exhaustion attack";
            if (this.cstNode)
              throw new PlainValue.YAMLReferenceError(this.cstNode, msg);
            else
              throw new ReferenceError(msg);
          }
        }
        return anchor.res;
      }
      // Only called when stringifying an alias mapping key while constructing
      // Object output.
      toString(ctx) {
        return _Alias.stringify(this, ctx);
      }
    };
    PlainValue._defineProperty(Alias, "default", true);
    function findPair(items, key) {
      const k = key instanceof Scalar ? key.value : key;
      for (const it of items) {
        if (it instanceof Pair) {
          if (it.key === key || it.key === k)
            return it;
          if (it.key && it.key.value === k)
            return it;
        }
      }
      return void 0;
    }
    var YAMLMap = class extends Collection {
      add(pair, overwrite) {
        if (!pair)
          pair = new Pair(pair);
        else if (!(pair instanceof Pair))
          pair = new Pair(pair.key || pair, pair.value);
        const prev = findPair(this.items, pair.key);
        const sortEntries = this.schema && this.schema.sortMapEntries;
        if (prev) {
          if (overwrite)
            prev.value = pair.value;
          else
            throw new Error(`Key ${pair.key} already set`);
        } else if (sortEntries) {
          const i = this.items.findIndex((item) => sortEntries(pair, item) < 0);
          if (i === -1)
            this.items.push(pair);
          else
            this.items.splice(i, 0, pair);
        } else {
          this.items.push(pair);
        }
      }
      delete(key) {
        const it = findPair(this.items, key);
        if (!it)
          return false;
        const del = this.items.splice(this.items.indexOf(it), 1);
        return del.length > 0;
      }
      get(key, keepScalar) {
        const it = findPair(this.items, key);
        const node = it && it.value;
        return !keepScalar && node instanceof Scalar ? node.value : node;
      }
      has(key) {
        return !!findPair(this.items, key);
      }
      set(key, value) {
        this.add(new Pair(key, value), true);
      }
      /**
       * @param {*} arg ignored
       * @param {*} ctx Conversion context, originally set in Document#toJSON()
       * @param {Class} Type If set, forces the returned collection type
       * @returns {*} Instance of Type, Map, or Object
       */
      toJSON(_, ctx, Type) {
        const map = Type ? new Type() : ctx && ctx.mapAsMap ? /* @__PURE__ */ new Map() : {};
        if (ctx && ctx.onCreate)
          ctx.onCreate(map);
        for (const item of this.items)
          item.addToJSMap(ctx, map);
        return map;
      }
      toString(ctx, onComment, onChompKeep) {
        if (!ctx)
          return JSON.stringify(this);
        for (const item of this.items) {
          if (!(item instanceof Pair))
            throw new Error(`Map items must all be pairs; found ${JSON.stringify(item)} instead`);
        }
        return super.toString(ctx, {
          blockItem: (n) => n.str,
          flowChars: {
            start: "{",
            end: "}"
          },
          isMap: true,
          itemIndent: ctx.indent || ""
        }, onComment, onChompKeep);
      }
    };
    var MERGE_KEY = "<<";
    var Merge = class extends Pair {
      constructor(pair) {
        if (pair instanceof Pair) {
          let seq = pair.value;
          if (!(seq instanceof YAMLSeq)) {
            seq = new YAMLSeq();
            seq.items.push(pair.value);
            seq.range = pair.value.range;
          }
          super(pair.key, seq);
          this.range = pair.range;
        } else {
          super(new Scalar(MERGE_KEY), new YAMLSeq());
        }
        this.type = Pair.Type.MERGE_PAIR;
      }
      // If the value associated with a merge key is a single mapping node, each of
      // its key/value pairs is inserted into the current mapping, unless the key
      // already exists in it. If the value associated with the merge key is a
      // sequence, then this sequence is expected to contain mapping nodes and each
      // of these nodes is merged in turn according to its order in the sequence.
      // Keys in mapping nodes earlier in the sequence override keys specified in
      // later mapping nodes. -- http://yaml.org/type/merge.html
      addToJSMap(ctx, map) {
        for (const {
          source
        } of this.value.items) {
          if (!(source instanceof YAMLMap))
            throw new Error("Merge sources must be maps");
          const srcMap = source.toJSON(null, ctx, Map);
          for (const [key, value] of srcMap) {
            if (map instanceof Map) {
              if (!map.has(key))
                map.set(key, value);
            } else if (map instanceof Set) {
              map.add(key);
            } else if (!Object.prototype.hasOwnProperty.call(map, key)) {
              Object.defineProperty(map, key, {
                value,
                writable: true,
                enumerable: true,
                configurable: true
              });
            }
          }
        }
        return map;
      }
      toString(ctx, onComment) {
        const seq = this.value;
        if (seq.items.length > 1)
          return super.toString(ctx, onComment);
        this.value = seq.items[0];
        const str = super.toString(ctx, onComment);
        this.value = seq;
        return str;
      }
    };
    var binaryOptions = {
      defaultType: PlainValue.Type.BLOCK_LITERAL,
      lineWidth: 76
    };
    var boolOptions = {
      trueStr: "true",
      falseStr: "false"
    };
    var intOptions = {
      asBigInt: false
    };
    var nullOptions = {
      nullStr: "null"
    };
    var strOptions = {
      defaultType: PlainValue.Type.PLAIN,
      doubleQuoted: {
        jsonEncoding: false,
        minMultiLineLength: 40
      },
      fold: {
        lineWidth: 80,
        minContentWidth: 20
      }
    };
    function resolveScalar(str, tags, scalarFallback) {
      for (const {
        format,
        test,
        resolve
      } of tags) {
        if (test) {
          const match = str.match(test);
          if (match) {
            let res = resolve.apply(null, match);
            if (!(res instanceof Scalar))
              res = new Scalar(res);
            if (format)
              res.format = format;
            return res;
          }
        }
      }
      if (scalarFallback)
        str = scalarFallback(str);
      return new Scalar(str);
    }
    var FOLD_FLOW = "flow";
    var FOLD_BLOCK = "block";
    var FOLD_QUOTED = "quoted";
    var consumeMoreIndentedLines = (text, i) => {
      let ch = text[i + 1];
      while (ch === " " || ch === "	") {
        do {
          ch = text[i += 1];
        } while (ch && ch !== "\n");
        ch = text[i + 1];
      }
      return i;
    };
    function foldFlowLines(text, indent, mode, {
      indentAtStart,
      lineWidth = 80,
      minContentWidth = 20,
      onFold,
      onOverflow
    }) {
      if (!lineWidth || lineWidth < 0)
        return text;
      const endStep = Math.max(1 + minContentWidth, 1 + lineWidth - indent.length);
      if (text.length <= endStep)
        return text;
      const folds = [];
      const escapedFolds = {};
      let end = lineWidth - indent.length;
      if (typeof indentAtStart === "number") {
        if (indentAtStart > lineWidth - Math.max(2, minContentWidth))
          folds.push(0);
        else
          end = lineWidth - indentAtStart;
      }
      let split = void 0;
      let prev = void 0;
      let overflow = false;
      let i = -1;
      let escStart = -1;
      let escEnd = -1;
      if (mode === FOLD_BLOCK) {
        i = consumeMoreIndentedLines(text, i);
        if (i !== -1)
          end = i + endStep;
      }
      for (let ch; ch = text[i += 1]; ) {
        if (mode === FOLD_QUOTED && ch === "\\") {
          escStart = i;
          switch (text[i + 1]) {
            case "x":
              i += 3;
              break;
            case "u":
              i += 5;
              break;
            case "U":
              i += 9;
              break;
            default:
              i += 1;
          }
          escEnd = i;
        }
        if (ch === "\n") {
          if (mode === FOLD_BLOCK)
            i = consumeMoreIndentedLines(text, i);
          end = i + endStep;
          split = void 0;
        } else {
          if (ch === " " && prev && prev !== " " && prev !== "\n" && prev !== "	") {
            const next = text[i + 1];
            if (next && next !== " " && next !== "\n" && next !== "	")
              split = i;
          }
          if (i >= end) {
            if (split) {
              folds.push(split);
              end = split + endStep;
              split = void 0;
            } else if (mode === FOLD_QUOTED) {
              while (prev === " " || prev === "	") {
                prev = ch;
                ch = text[i += 1];
                overflow = true;
              }
              const j = i > escEnd + 1 ? i - 2 : escStart - 1;
              if (escapedFolds[j])
                return text;
              folds.push(j);
              escapedFolds[j] = true;
              end = j + endStep;
              split = void 0;
            } else {
              overflow = true;
            }
          }
        }
        prev = ch;
      }
      if (overflow && onOverflow)
        onOverflow();
      if (folds.length === 0)
        return text;
      if (onFold)
        onFold();
      let res = text.slice(0, folds[0]);
      for (let i2 = 0; i2 < folds.length; ++i2) {
        const fold = folds[i2];
        const end2 = folds[i2 + 1] || text.length;
        if (fold === 0)
          res = `
${indent}${text.slice(0, end2)}`;
        else {
          if (mode === FOLD_QUOTED && escapedFolds[fold])
            res += `${text[fold]}\\`;
          res += `
${indent}${text.slice(fold + 1, end2)}`;
        }
      }
      return res;
    }
    var getFoldOptions = ({
      indentAtStart
    }) => indentAtStart ? Object.assign({
      indentAtStart
    }, strOptions.fold) : strOptions.fold;
    var containsDocumentMarker = (str) => /^(%|---|\.\.\.)/m.test(str);
    function lineLengthOverLimit(str, lineWidth, indentLength) {
      if (!lineWidth || lineWidth < 0)
        return false;
      const limit = lineWidth - indentLength;
      const strLen = str.length;
      if (strLen <= limit)
        return false;
      for (let i = 0, start = 0; i < strLen; ++i) {
        if (str[i] === "\n") {
          if (i - start > limit)
            return true;
          start = i + 1;
          if (strLen - start <= limit)
            return false;
        }
      }
      return true;
    }
    function doubleQuotedString(value, ctx) {
      const {
        implicitKey
      } = ctx;
      const {
        jsonEncoding,
        minMultiLineLength
      } = strOptions.doubleQuoted;
      const json = JSON.stringify(value);
      if (jsonEncoding)
        return json;
      const indent = ctx.indent || (containsDocumentMarker(value) ? "  " : "");
      let str = "";
      let start = 0;
      for (let i = 0, ch = json[i]; ch; ch = json[++i]) {
        if (ch === " " && json[i + 1] === "\\" && json[i + 2] === "n") {
          str += json.slice(start, i) + "\\ ";
          i += 1;
          start = i;
          ch = "\\";
        }
        if (ch === "\\")
          switch (json[i + 1]) {
            case "u":
              {
                str += json.slice(start, i);
                const code = json.substr(i + 2, 4);
                switch (code) {
                  case "0000":
                    str += "\\0";
                    break;
                  case "0007":
                    str += "\\a";
                    break;
                  case "000b":
                    str += "\\v";
                    break;
                  case "001b":
                    str += "\\e";
                    break;
                  case "0085":
                    str += "\\N";
                    break;
                  case "00a0":
                    str += "\\_";
                    break;
                  case "2028":
                    str += "\\L";
                    break;
                  case "2029":
                    str += "\\P";
                    break;
                  default:
                    if (code.substr(0, 2) === "00")
                      str += "\\x" + code.substr(2);
                    else
                      str += json.substr(i, 6);
                }
                i += 5;
                start = i + 1;
              }
              break;
            case "n":
              if (implicitKey || json[i + 2] === '"' || json.length < minMultiLineLength) {
                i += 1;
              } else {
                str += json.slice(start, i) + "\n\n";
                while (json[i + 2] === "\\" && json[i + 3] === "n" && json[i + 4] !== '"') {
                  str += "\n";
                  i += 2;
                }
                str += indent;
                if (json[i + 2] === " ")
                  str += "\\";
                i += 1;
                start = i + 1;
              }
              break;
            default:
              i += 1;
          }
      }
      str = start ? str + json.slice(start) : json;
      return implicitKey ? str : foldFlowLines(str, indent, FOLD_QUOTED, getFoldOptions(ctx));
    }
    function singleQuotedString(value, ctx) {
      if (ctx.implicitKey) {
        if (/\n/.test(value))
          return doubleQuotedString(value, ctx);
      } else {
        if (/[ \t]\n|\n[ \t]/.test(value))
          return doubleQuotedString(value, ctx);
      }
      const indent = ctx.indent || (containsDocumentMarker(value) ? "  " : "");
      const res = "'" + value.replace(/'/g, "''").replace(/\n+/g, `$&
${indent}`) + "'";
      return ctx.implicitKey ? res : foldFlowLines(res, indent, FOLD_FLOW, getFoldOptions(ctx));
    }
    function blockString({
      comment,
      type,
      value
    }, ctx, onComment, onChompKeep) {
      if (/\n[\t ]+$/.test(value) || /^\s*$/.test(value)) {
        return doubleQuotedString(value, ctx);
      }
      const indent = ctx.indent || (ctx.forceBlockIndent || containsDocumentMarker(value) ? "  " : "");
      const indentSize = indent ? "2" : "1";
      const literal = type === PlainValue.Type.BLOCK_FOLDED ? false : type === PlainValue.Type.BLOCK_LITERAL ? true : !lineLengthOverLimit(value, strOptions.fold.lineWidth, indent.length);
      let header = literal ? "|" : ">";
      if (!value)
        return header + "\n";
      let wsStart = "";
      let wsEnd = "";
      value = value.replace(/[\n\t ]*$/, (ws) => {
        const n = ws.indexOf("\n");
        if (n === -1) {
          header += "-";
        } else if (value === ws || n !== ws.length - 1) {
          header += "+";
          if (onChompKeep)
            onChompKeep();
        }
        wsEnd = ws.replace(/\n$/, "");
        return "";
      }).replace(/^[\n ]*/, (ws) => {
        if (ws.indexOf(" ") !== -1)
          header += indentSize;
        const m = ws.match(/ +$/);
        if (m) {
          wsStart = ws.slice(0, -m[0].length);
          return m[0];
        } else {
          wsStart = ws;
          return "";
        }
      });
      if (wsEnd)
        wsEnd = wsEnd.replace(/\n+(?!\n|$)/g, `$&${indent}`);
      if (wsStart)
        wsStart = wsStart.replace(/\n+/g, `$&${indent}`);
      if (comment) {
        header += " #" + comment.replace(/ ?[\r\n]+/g, " ");
        if (onComment)
          onComment();
      }
      if (!value)
        return `${header}${indentSize}
${indent}${wsEnd}`;
      if (literal) {
        value = value.replace(/\n+/g, `$&${indent}`);
        return `${header}
${indent}${wsStart}${value}${wsEnd}`;
      }
      value = value.replace(/\n+/g, "\n$&").replace(/(?:^|\n)([\t ].*)(?:([\n\t ]*)\n(?![\n\t ]))?/g, "$1$2").replace(/\n+/g, `$&${indent}`);
      const body = foldFlowLines(`${wsStart}${value}${wsEnd}`, indent, FOLD_BLOCK, strOptions.fold);
      return `${header}
${indent}${body}`;
    }
    function plainString(item, ctx, onComment, onChompKeep) {
      const {
        comment,
        type,
        value
      } = item;
      const {
        actualString,
        implicitKey,
        indent,
        inFlow
      } = ctx;
      if (implicitKey && /[\n[\]{},]/.test(value) || inFlow && /[[\]{},]/.test(value)) {
        return doubleQuotedString(value, ctx);
      }
      if (!value || /^[\n\t ,[\]{}#&*!|>'"%@`]|^[?-]$|^[?-][ \t]|[\n:][ \t]|[ \t]\n|[\n\t ]#|[\n\t :]$/.test(value)) {
        return implicitKey || inFlow || value.indexOf("\n") === -1 ? value.indexOf('"') !== -1 && value.indexOf("'") === -1 ? singleQuotedString(value, ctx) : doubleQuotedString(value, ctx) : blockString(item, ctx, onComment, onChompKeep);
      }
      if (!implicitKey && !inFlow && type !== PlainValue.Type.PLAIN && value.indexOf("\n") !== -1) {
        return blockString(item, ctx, onComment, onChompKeep);
      }
      if (indent === "" && containsDocumentMarker(value)) {
        ctx.forceBlockIndent = true;
        return blockString(item, ctx, onComment, onChompKeep);
      }
      const str = value.replace(/\n+/g, `$&
${indent}`);
      if (actualString) {
        const {
          tags
        } = ctx.doc.schema;
        const resolved = resolveScalar(str, tags, tags.scalarFallback).value;
        if (typeof resolved !== "string")
          return doubleQuotedString(value, ctx);
      }
      const body = implicitKey ? str : foldFlowLines(str, indent, FOLD_FLOW, getFoldOptions(ctx));
      if (comment && !inFlow && (body.indexOf("\n") !== -1 || comment.indexOf("\n") !== -1)) {
        if (onComment)
          onComment();
        return addCommentBefore(body, indent, comment);
      }
      return body;
    }
    function stringifyString(item, ctx, onComment, onChompKeep) {
      const {
        defaultType
      } = strOptions;
      const {
        implicitKey,
        inFlow
      } = ctx;
      let {
        type,
        value
      } = item;
      if (typeof value !== "string") {
        value = String(value);
        item = Object.assign({}, item, {
          value
        });
      }
      const _stringify = (_type) => {
        switch (_type) {
          case PlainValue.Type.BLOCK_FOLDED:
          case PlainValue.Type.BLOCK_LITERAL:
            return blockString(item, ctx, onComment, onChompKeep);
          case PlainValue.Type.QUOTE_DOUBLE:
            return doubleQuotedString(value, ctx);
          case PlainValue.Type.QUOTE_SINGLE:
            return singleQuotedString(value, ctx);
          case PlainValue.Type.PLAIN:
            return plainString(item, ctx, onComment, onChompKeep);
          default:
            return null;
        }
      };
      if (type !== PlainValue.Type.QUOTE_DOUBLE && /[\x00-\x08\x0b-\x1f\x7f-\x9f]/.test(value)) {
        type = PlainValue.Type.QUOTE_DOUBLE;
      } else if ((implicitKey || inFlow) && (type === PlainValue.Type.BLOCK_FOLDED || type === PlainValue.Type.BLOCK_LITERAL)) {
        type = PlainValue.Type.QUOTE_DOUBLE;
      }
      let res = _stringify(type);
      if (res === null) {
        res = _stringify(defaultType);
        if (res === null)
          throw new Error(`Unsupported default string type ${defaultType}`);
      }
      return res;
    }
    function stringifyNumber({
      format,
      minFractionDigits,
      tag,
      value
    }) {
      if (typeof value === "bigint")
        return String(value);
      if (!isFinite(value))
        return isNaN(value) ? ".nan" : value < 0 ? "-.inf" : ".inf";
      let n = JSON.stringify(value);
      if (!format && minFractionDigits && (!tag || tag === "tag:yaml.org,2002:float") && /^\d/.test(n)) {
        let i = n.indexOf(".");
        if (i < 0) {
          i = n.length;
          n += ".";
        }
        let d = minFractionDigits - (n.length - i - 1);
        while (d-- > 0)
          n += "0";
      }
      return n;
    }
    function checkFlowCollectionEnd(errors, cst) {
      let char, name;
      switch (cst.type) {
        case PlainValue.Type.FLOW_MAP:
          char = "}";
          name = "flow map";
          break;
        case PlainValue.Type.FLOW_SEQ:
          char = "]";
          name = "flow sequence";
          break;
        default:
          errors.push(new PlainValue.YAMLSemanticError(cst, "Not a flow collection!?"));
          return;
      }
      let lastItem;
      for (let i = cst.items.length - 1; i >= 0; --i) {
        const item = cst.items[i];
        if (!item || item.type !== PlainValue.Type.COMMENT) {
          lastItem = item;
          break;
        }
      }
      if (lastItem && lastItem.char !== char) {
        const msg = `Expected ${name} to end with ${char}`;
        let err;
        if (typeof lastItem.offset === "number") {
          err = new PlainValue.YAMLSemanticError(cst, msg);
          err.offset = lastItem.offset + 1;
        } else {
          err = new PlainValue.YAMLSemanticError(lastItem, msg);
          if (lastItem.range && lastItem.range.end)
            err.offset = lastItem.range.end - lastItem.range.start;
        }
        errors.push(err);
      }
    }
    function checkFlowCommentSpace(errors, comment) {
      const prev = comment.context.src[comment.range.start - 1];
      if (prev !== "\n" && prev !== "	" && prev !== " ") {
        const msg = "Comments must be separated from other tokens by white space characters";
        errors.push(new PlainValue.YAMLSemanticError(comment, msg));
      }
    }
    function getLongKeyError(source, key) {
      const sk = String(key);
      const k = sk.substr(0, 8) + "..." + sk.substr(-8);
      return new PlainValue.YAMLSemanticError(source, `The "${k}" key is too long`);
    }
    function resolveComments(collection, comments) {
      for (const {
        afterKey,
        before,
        comment
      } of comments) {
        let item = collection.items[before];
        if (!item) {
          if (comment !== void 0) {
            if (collection.comment)
              collection.comment += "\n" + comment;
            else
              collection.comment = comment;
          }
        } else {
          if (afterKey && item.value)
            item = item.value;
          if (comment === void 0) {
            if (afterKey || !item.commentBefore)
              item.spaceBefore = true;
          } else {
            if (item.commentBefore)
              item.commentBefore += "\n" + comment;
            else
              item.commentBefore = comment;
          }
        }
      }
    }
    function resolveString(doc, node) {
      const res = node.strValue;
      if (!res)
        return "";
      if (typeof res === "string")
        return res;
      res.errors.forEach((error) => {
        if (!error.source)
          error.source = node;
        doc.errors.push(error);
      });
      return res.str;
    }
    function resolveTagHandle(doc, node) {
      const {
        handle,
        suffix
      } = node.tag;
      let prefix = doc.tagPrefixes.find((p) => p.handle === handle);
      if (!prefix) {
        const dtp = doc.getDefaults().tagPrefixes;
        if (dtp)
          prefix = dtp.find((p) => p.handle === handle);
        if (!prefix)
          throw new PlainValue.YAMLSemanticError(node, `The ${handle} tag handle is non-default and was not declared.`);
      }
      if (!suffix)
        throw new PlainValue.YAMLSemanticError(node, `The ${handle} tag has no suffix.`);
      if (handle === "!" && (doc.version || doc.options.version) === "1.0") {
        if (suffix[0] === "^") {
          doc.warnings.push(new PlainValue.YAMLWarning(node, "YAML 1.0 ^ tag expansion is not supported"));
          return suffix;
        }
        if (/[:/]/.test(suffix)) {
          const vocab = suffix.match(/^([a-z0-9-]+)\/(.*)/i);
          return vocab ? `tag:${vocab[1]}.yaml.org,2002:${vocab[2]}` : `tag:${suffix}`;
        }
      }
      return prefix.prefix + decodeURIComponent(suffix);
    }
    function resolveTagName(doc, node) {
      const {
        tag,
        type
      } = node;
      let nonSpecific = false;
      if (tag) {
        const {
          handle,
          suffix,
          verbatim
        } = tag;
        if (verbatim) {
          if (verbatim !== "!" && verbatim !== "!!")
            return verbatim;
          const msg = `Verbatim tags aren't resolved, so ${verbatim} is invalid.`;
          doc.errors.push(new PlainValue.YAMLSemanticError(node, msg));
        } else if (handle === "!" && !suffix) {
          nonSpecific = true;
        } else {
          try {
            return resolveTagHandle(doc, node);
          } catch (error) {
            doc.errors.push(error);
          }
        }
      }
      switch (type) {
        case PlainValue.Type.BLOCK_FOLDED:
        case PlainValue.Type.BLOCK_LITERAL:
        case PlainValue.Type.QUOTE_DOUBLE:
        case PlainValue.Type.QUOTE_SINGLE:
          return PlainValue.defaultTags.STR;
        case PlainValue.Type.FLOW_MAP:
        case PlainValue.Type.MAP:
          return PlainValue.defaultTags.MAP;
        case PlainValue.Type.FLOW_SEQ:
        case PlainValue.Type.SEQ:
          return PlainValue.defaultTags.SEQ;
        case PlainValue.Type.PLAIN:
          return nonSpecific ? PlainValue.defaultTags.STR : null;
        default:
          return null;
      }
    }
    function resolveByTagName(doc, node, tagName) {
      const {
        tags
      } = doc.schema;
      const matchWithTest = [];
      for (const tag of tags) {
        if (tag.tag === tagName) {
          if (tag.test)
            matchWithTest.push(tag);
          else {
            const res = tag.resolve(doc, node);
            return res instanceof Collection ? res : new Scalar(res);
          }
        }
      }
      const str = resolveString(doc, node);
      if (typeof str === "string" && matchWithTest.length > 0)
        return resolveScalar(str, matchWithTest, tags.scalarFallback);
      return null;
    }
    function getFallbackTagName({
      type
    }) {
      switch (type) {
        case PlainValue.Type.FLOW_MAP:
        case PlainValue.Type.MAP:
          return PlainValue.defaultTags.MAP;
        case PlainValue.Type.FLOW_SEQ:
        case PlainValue.Type.SEQ:
          return PlainValue.defaultTags.SEQ;
        default:
          return PlainValue.defaultTags.STR;
      }
    }
    function resolveTag(doc, node, tagName) {
      try {
        const res = resolveByTagName(doc, node, tagName);
        if (res) {
          if (tagName && node.tag)
            res.tag = tagName;
          return res;
        }
      } catch (error) {
        if (!error.source)
          error.source = node;
        doc.errors.push(error);
        return null;
      }
      try {
        const fallback = getFallbackTagName(node);
        if (!fallback)
          throw new Error(`The tag ${tagName} is unavailable`);
        const msg = `The tag ${tagName} is unavailable, falling back to ${fallback}`;
        doc.warnings.push(new PlainValue.YAMLWarning(node, msg));
        const res = resolveByTagName(doc, node, fallback);
        res.tag = tagName;
        return res;
      } catch (error) {
        const refError = new PlainValue.YAMLReferenceError(node, error.message);
        refError.stack = error.stack;
        doc.errors.push(refError);
        return null;
      }
    }
    var isCollectionItem = (node) => {
      if (!node)
        return false;
      const {
        type
      } = node;
      return type === PlainValue.Type.MAP_KEY || type === PlainValue.Type.MAP_VALUE || type === PlainValue.Type.SEQ_ITEM;
    };
    function resolveNodeProps(errors, node) {
      const comments = {
        before: [],
        after: []
      };
      let hasAnchor = false;
      let hasTag = false;
      const props = isCollectionItem(node.context.parent) ? node.context.parent.props.concat(node.props) : node.props;
      for (const {
        start,
        end
      } of props) {
        switch (node.context.src[start]) {
          case PlainValue.Char.COMMENT: {
            if (!node.commentHasRequiredWhitespace(start)) {
              const msg = "Comments must be separated from other tokens by white space characters";
              errors.push(new PlainValue.YAMLSemanticError(node, msg));
            }
            const {
              header,
              valueRange
            } = node;
            const cc = valueRange && (start > valueRange.start || header && start > header.start) ? comments.after : comments.before;
            cc.push(node.context.src.slice(start + 1, end));
            break;
          }
          case PlainValue.Char.ANCHOR:
            if (hasAnchor) {
              const msg = "A node can have at most one anchor";
              errors.push(new PlainValue.YAMLSemanticError(node, msg));
            }
            hasAnchor = true;
            break;
          case PlainValue.Char.TAG:
            if (hasTag) {
              const msg = "A node can have at most one tag";
              errors.push(new PlainValue.YAMLSemanticError(node, msg));
            }
            hasTag = true;
            break;
        }
      }
      return {
        comments,
        hasAnchor,
        hasTag
      };
    }
    function resolveNodeValue(doc, node) {
      const {
        anchors,
        errors,
        schema
      } = doc;
      if (node.type === PlainValue.Type.ALIAS) {
        const name = node.rawValue;
        const src = anchors.getNode(name);
        if (!src) {
          const msg = `Aliased anchor not found: ${name}`;
          errors.push(new PlainValue.YAMLReferenceError(node, msg));
          return null;
        }
        const res = new Alias(src);
        anchors._cstAliases.push(res);
        return res;
      }
      const tagName = resolveTagName(doc, node);
      if (tagName)
        return resolveTag(doc, node, tagName);
      if (node.type !== PlainValue.Type.PLAIN) {
        const msg = `Failed to resolve ${node.type} node here`;
        errors.push(new PlainValue.YAMLSyntaxError(node, msg));
        return null;
      }
      try {
        const str = resolveString(doc, node);
        return resolveScalar(str, schema.tags, schema.tags.scalarFallback);
      } catch (error) {
        if (!error.source)
          error.source = node;
        errors.push(error);
        return null;
      }
    }
    function resolveNode(doc, node) {
      if (!node)
        return null;
      if (node.error)
        doc.errors.push(node.error);
      const {
        comments,
        hasAnchor,
        hasTag
      } = resolveNodeProps(doc.errors, node);
      if (hasAnchor) {
        const {
          anchors
        } = doc;
        const name = node.anchor;
        const prev = anchors.getNode(name);
        if (prev)
          anchors.map[anchors.newName(name)] = prev;
        anchors.map[name] = node;
      }
      if (node.type === PlainValue.Type.ALIAS && (hasAnchor || hasTag)) {
        const msg = "An alias node must not specify any properties";
        doc.errors.push(new PlainValue.YAMLSemanticError(node, msg));
      }
      const res = resolveNodeValue(doc, node);
      if (res) {
        res.range = [node.range.start, node.range.end];
        if (doc.options.keepCstNodes)
          res.cstNode = node;
        if (doc.options.keepNodeTypes)
          res.type = node.type;
        const cb = comments.before.join("\n");
        if (cb) {
          res.commentBefore = res.commentBefore ? `${res.commentBefore}
${cb}` : cb;
        }
        const ca = comments.after.join("\n");
        if (ca)
          res.comment = res.comment ? `${res.comment}
${ca}` : ca;
      }
      return node.resolved = res;
    }
    function resolveMap(doc, cst) {
      if (cst.type !== PlainValue.Type.MAP && cst.type !== PlainValue.Type.FLOW_MAP) {
        const msg = `A ${cst.type} node cannot be resolved as a mapping`;
        doc.errors.push(new PlainValue.YAMLSyntaxError(cst, msg));
        return null;
      }
      const {
        comments,
        items
      } = cst.type === PlainValue.Type.FLOW_MAP ? resolveFlowMapItems(doc, cst) : resolveBlockMapItems(doc, cst);
      const map = new YAMLMap();
      map.items = items;
      resolveComments(map, comments);
      let hasCollectionKey = false;
      for (let i = 0; i < items.length; ++i) {
        const {
          key: iKey
        } = items[i];
        if (iKey instanceof Collection)
          hasCollectionKey = true;
        if (doc.schema.merge && iKey && iKey.value === MERGE_KEY) {
          items[i] = new Merge(items[i]);
          const sources = items[i].value.items;
          let error = null;
          sources.some((node) => {
            if (node instanceof Alias) {
              const {
                type
              } = node.source;
              if (type === PlainValue.Type.MAP || type === PlainValue.Type.FLOW_MAP)
                return false;
              return error = "Merge nodes aliases can only point to maps";
            }
            return error = "Merge nodes can only have Alias nodes as values";
          });
          if (error)
            doc.errors.push(new PlainValue.YAMLSemanticError(cst, error));
        } else {
          for (let j = i + 1; j < items.length; ++j) {
            const {
              key: jKey
            } = items[j];
            if (iKey === jKey || iKey && jKey && Object.prototype.hasOwnProperty.call(iKey, "value") && iKey.value === jKey.value) {
              const msg = `Map keys must be unique; "${iKey}" is repeated`;
              doc.errors.push(new PlainValue.YAMLSemanticError(cst, msg));
              break;
            }
          }
        }
      }
      if (hasCollectionKey && !doc.options.mapAsMap) {
        const warn = "Keys with collection values will be stringified as YAML due to JS Object restrictions. Use mapAsMap: true to avoid this.";
        doc.warnings.push(new PlainValue.YAMLWarning(cst, warn));
      }
      cst.resolved = map;
      return map;
    }
    var valueHasPairComment = ({
      context: {
        lineStart,
        node,
        src
      },
      props
    }) => {
      if (props.length === 0)
        return false;
      const {
        start
      } = props[0];
      if (node && start > node.valueRange.start)
        return false;
      if (src[start] !== PlainValue.Char.COMMENT)
        return false;
      for (let i = lineStart; i < start; ++i)
        if (src[i] === "\n")
          return false;
      return true;
    };
    function resolvePairComment(item, pair) {
      if (!valueHasPairComment(item))
        return;
      const comment = item.getPropValue(0, PlainValue.Char.COMMENT, true);
      let found = false;
      const cb = pair.value.commentBefore;
      if (cb && cb.startsWith(comment)) {
        pair.value.commentBefore = cb.substr(comment.length + 1);
        found = true;
      } else {
        const cc = pair.value.comment;
        if (!item.node && cc && cc.startsWith(comment)) {
          pair.value.comment = cc.substr(comment.length + 1);
          found = true;
        }
      }
      if (found)
        pair.comment = comment;
    }
    function resolveBlockMapItems(doc, cst) {
      const comments = [];
      const items = [];
      let key = void 0;
      let keyStart = null;
      for (let i = 0; i < cst.items.length; ++i) {
        const item = cst.items[i];
        switch (item.type) {
          case PlainValue.Type.BLANK_LINE:
            comments.push({
              afterKey: !!key,
              before: items.length
            });
            break;
          case PlainValue.Type.COMMENT:
            comments.push({
              afterKey: !!key,
              before: items.length,
              comment: item.comment
            });
            break;
          case PlainValue.Type.MAP_KEY:
            if (key !== void 0)
              items.push(new Pair(key));
            if (item.error)
              doc.errors.push(item.error);
            key = resolveNode(doc, item.node);
            keyStart = null;
            break;
          case PlainValue.Type.MAP_VALUE:
            {
              if (key === void 0)
                key = null;
              if (item.error)
                doc.errors.push(item.error);
              if (!item.context.atLineStart && item.node && item.node.type === PlainValue.Type.MAP && !item.node.context.atLineStart) {
                const msg = "Nested mappings are not allowed in compact mappings";
                doc.errors.push(new PlainValue.YAMLSemanticError(item.node, msg));
              }
              let valueNode = item.node;
              if (!valueNode && item.props.length > 0) {
                valueNode = new PlainValue.PlainValue(PlainValue.Type.PLAIN, []);
                valueNode.context = {
                  parent: item,
                  src: item.context.src
                };
                const pos = item.range.start + 1;
                valueNode.range = {
                  start: pos,
                  end: pos
                };
                valueNode.valueRange = {
                  start: pos,
                  end: pos
                };
                if (typeof item.range.origStart === "number") {
                  const origPos = item.range.origStart + 1;
                  valueNode.range.origStart = valueNode.range.origEnd = origPos;
                  valueNode.valueRange.origStart = valueNode.valueRange.origEnd = origPos;
                }
              }
              const pair = new Pair(key, resolveNode(doc, valueNode));
              resolvePairComment(item, pair);
              items.push(pair);
              if (key && typeof keyStart === "number") {
                if (item.range.start > keyStart + 1024)
                  doc.errors.push(getLongKeyError(cst, key));
              }
              key = void 0;
              keyStart = null;
            }
            break;
          default:
            if (key !== void 0)
              items.push(new Pair(key));
            key = resolveNode(doc, item);
            keyStart = item.range.start;
            if (item.error)
              doc.errors.push(item.error);
            next:
              for (let j = i + 1; ; ++j) {
                const nextItem = cst.items[j];
                switch (nextItem && nextItem.type) {
                  case PlainValue.Type.BLANK_LINE:
                  case PlainValue.Type.COMMENT:
                    continue next;
                  case PlainValue.Type.MAP_VALUE:
                    break next;
                  default: {
                    const msg = "Implicit map keys need to be followed by map values";
                    doc.errors.push(new PlainValue.YAMLSemanticError(item, msg));
                    break next;
                  }
                }
              }
            if (item.valueRangeContainsNewline) {
              const msg = "Implicit map keys need to be on a single line";
              doc.errors.push(new PlainValue.YAMLSemanticError(item, msg));
            }
        }
      }
      if (key !== void 0)
        items.push(new Pair(key));
      return {
        comments,
        items
      };
    }
    function resolveFlowMapItems(doc, cst) {
      const comments = [];
      const items = [];
      let key = void 0;
      let explicitKey = false;
      let next = "{";
      for (let i = 0; i < cst.items.length; ++i) {
        const item = cst.items[i];
        if (typeof item.char === "string") {
          const {
            char,
            offset
          } = item;
          if (char === "?" && key === void 0 && !explicitKey) {
            explicitKey = true;
            next = ":";
            continue;
          }
          if (char === ":") {
            if (key === void 0)
              key = null;
            if (next === ":") {
              next = ",";
              continue;
            }
          } else {
            if (explicitKey) {
              if (key === void 0 && char !== ",")
                key = null;
              explicitKey = false;
            }
            if (key !== void 0) {
              items.push(new Pair(key));
              key = void 0;
              if (char === ",") {
                next = ":";
                continue;
              }
            }
          }
          if (char === "}") {
            if (i === cst.items.length - 1)
              continue;
          } else if (char === next) {
            next = ":";
            continue;
          }
          const msg = `Flow map contains an unexpected ${char}`;
          const err = new PlainValue.YAMLSyntaxError(cst, msg);
          err.offset = offset;
          doc.errors.push(err);
        } else if (item.type === PlainValue.Type.BLANK_LINE) {
          comments.push({
            afterKey: !!key,
            before: items.length
          });
        } else if (item.type === PlainValue.Type.COMMENT) {
          checkFlowCommentSpace(doc.errors, item);
          comments.push({
            afterKey: !!key,
            before: items.length,
            comment: item.comment
          });
        } else if (key === void 0) {
          if (next === ",")
            doc.errors.push(new PlainValue.YAMLSemanticError(item, "Separator , missing in flow map"));
          key = resolveNode(doc, item);
        } else {
          if (next !== ",")
            doc.errors.push(new PlainValue.YAMLSemanticError(item, "Indicator : missing in flow map entry"));
          items.push(new Pair(key, resolveNode(doc, item)));
          key = void 0;
          explicitKey = false;
        }
      }
      checkFlowCollectionEnd(doc.errors, cst);
      if (key !== void 0)
        items.push(new Pair(key));
      return {
        comments,
        items
      };
    }
    function resolveSeq(doc, cst) {
      if (cst.type !== PlainValue.Type.SEQ && cst.type !== PlainValue.Type.FLOW_SEQ) {
        const msg = `A ${cst.type} node cannot be resolved as a sequence`;
        doc.errors.push(new PlainValue.YAMLSyntaxError(cst, msg));
        return null;
      }
      const {
        comments,
        items
      } = cst.type === PlainValue.Type.FLOW_SEQ ? resolveFlowSeqItems(doc, cst) : resolveBlockSeqItems(doc, cst);
      const seq = new YAMLSeq();
      seq.items = items;
      resolveComments(seq, comments);
      if (!doc.options.mapAsMap && items.some((it) => it instanceof Pair && it.key instanceof Collection)) {
        const warn = "Keys with collection values will be stringified as YAML due to JS Object restrictions. Use mapAsMap: true to avoid this.";
        doc.warnings.push(new PlainValue.YAMLWarning(cst, warn));
      }
      cst.resolved = seq;
      return seq;
    }
    function resolveBlockSeqItems(doc, cst) {
      const comments = [];
      const items = [];
      for (let i = 0; i < cst.items.length; ++i) {
        const item = cst.items[i];
        switch (item.type) {
          case PlainValue.Type.BLANK_LINE:
            comments.push({
              before: items.length
            });
            break;
          case PlainValue.Type.COMMENT:
            comments.push({
              comment: item.comment,
              before: items.length
            });
            break;
          case PlainValue.Type.SEQ_ITEM:
            if (item.error)
              doc.errors.push(item.error);
            items.push(resolveNode(doc, item.node));
            if (item.hasProps) {
              const msg = "Sequence items cannot have tags or anchors before the - indicator";
              doc.errors.push(new PlainValue.YAMLSemanticError(item, msg));
            }
            break;
          default:
            if (item.error)
              doc.errors.push(item.error);
            doc.errors.push(new PlainValue.YAMLSyntaxError(item, `Unexpected ${item.type} node in sequence`));
        }
      }
      return {
        comments,
        items
      };
    }
    function resolveFlowSeqItems(doc, cst) {
      const comments = [];
      const items = [];
      let explicitKey = false;
      let key = void 0;
      let keyStart = null;
      let next = "[";
      let prevItem = null;
      for (let i = 0; i < cst.items.length; ++i) {
        const item = cst.items[i];
        if (typeof item.char === "string") {
          const {
            char,
            offset
          } = item;
          if (char !== ":" && (explicitKey || key !== void 0)) {
            if (explicitKey && key === void 0)
              key = next ? items.pop() : null;
            items.push(new Pair(key));
            explicitKey = false;
            key = void 0;
            keyStart = null;
          }
          if (char === next) {
            next = null;
          } else if (!next && char === "?") {
            explicitKey = true;
          } else if (next !== "[" && char === ":" && key === void 0) {
            if (next === ",") {
              key = items.pop();
              if (key instanceof Pair) {
                const msg = "Chaining flow sequence pairs is invalid";
                const err = new PlainValue.YAMLSemanticError(cst, msg);
                err.offset = offset;
                doc.errors.push(err);
              }
              if (!explicitKey && typeof keyStart === "number") {
                const keyEnd = item.range ? item.range.start : item.offset;
                if (keyEnd > keyStart + 1024)
                  doc.errors.push(getLongKeyError(cst, key));
                const {
                  src
                } = prevItem.context;
                for (let i2 = keyStart; i2 < keyEnd; ++i2)
                  if (src[i2] === "\n") {
                    const msg = "Implicit keys of flow sequence pairs need to be on a single line";
                    doc.errors.push(new PlainValue.YAMLSemanticError(prevItem, msg));
                    break;
                  }
              }
            } else {
              key = null;
            }
            keyStart = null;
            explicitKey = false;
            next = null;
          } else if (next === "[" || char !== "]" || i < cst.items.length - 1) {
            const msg = `Flow sequence contains an unexpected ${char}`;
            const err = new PlainValue.YAMLSyntaxError(cst, msg);
            err.offset = offset;
            doc.errors.push(err);
          }
        } else if (item.type === PlainValue.Type.BLANK_LINE) {
          comments.push({
            before: items.length
          });
        } else if (item.type === PlainValue.Type.COMMENT) {
          checkFlowCommentSpace(doc.errors, item);
          comments.push({
            comment: item.comment,
            before: items.length
          });
        } else {
          if (next) {
            const msg = `Expected a ${next} in flow sequence`;
            doc.errors.push(new PlainValue.YAMLSemanticError(item, msg));
          }
          const value = resolveNode(doc, item);
          if (key === void 0) {
            items.push(value);
            prevItem = item;
          } else {
            items.push(new Pair(key, value));
            key = void 0;
          }
          keyStart = item.range.start;
          next = ",";
        }
      }
      checkFlowCollectionEnd(doc.errors, cst);
      if (key !== void 0)
        items.push(new Pair(key));
      return {
        comments,
        items
      };
    }
    exports2.Alias = Alias;
    exports2.Collection = Collection;
    exports2.Merge = Merge;
    exports2.Node = Node;
    exports2.Pair = Pair;
    exports2.Scalar = Scalar;
    exports2.YAMLMap = YAMLMap;
    exports2.YAMLSeq = YAMLSeq;
    exports2.addComment = addComment;
    exports2.binaryOptions = binaryOptions;
    exports2.boolOptions = boolOptions;
    exports2.findPair = findPair;
    exports2.intOptions = intOptions;
    exports2.isEmptyPath = isEmptyPath;
    exports2.nullOptions = nullOptions;
    exports2.resolveMap = resolveMap;
    exports2.resolveNode = resolveNode;
    exports2.resolveSeq = resolveSeq;
    exports2.resolveString = resolveString;
    exports2.strOptions = strOptions;
    exports2.stringifyNumber = stringifyNumber;
    exports2.stringifyString = stringifyString;
    exports2.toJSON = toJSON;
  }
});

// node_modules/aws-cdk-lib/node_modules/yaml/dist/warnings-1000a372.js
var require_warnings_1000a372 = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/yaml/dist/warnings-1000a372.js"(exports2) {
    "use strict";
    var PlainValue = require_PlainValue_ec8e588e();
    var resolveSeq = require_resolveSeq_d03cb037();
    var binary = {
      identify: (value) => value instanceof Uint8Array,
      // Buffer inherits from Uint8Array
      default: false,
      tag: "tag:yaml.org,2002:binary",
      /**
       * Returns a Buffer in node and an Uint8Array in browsers
       *
       * To use the resulting buffer as an image, you'll want to do something like:
       *
       *   const blob = new Blob([buffer], { type: 'image/jpeg' })
       *   document.querySelector('#photo').src = URL.createObjectURL(blob)
       */
      resolve: (doc, node) => {
        const src = resolveSeq.resolveString(doc, node);
        if (typeof Buffer === "function") {
          return Buffer.from(src, "base64");
        } else if (typeof atob === "function") {
          const str = atob(src.replace(/[\n\r]/g, ""));
          const buffer = new Uint8Array(str.length);
          for (let i = 0; i < str.length; ++i)
            buffer[i] = str.charCodeAt(i);
          return buffer;
        } else {
          const msg = "This environment does not support reading binary tags; either Buffer or atob is required";
          doc.errors.push(new PlainValue.YAMLReferenceError(node, msg));
          return null;
        }
      },
      options: resolveSeq.binaryOptions,
      stringify: ({
        comment,
        type,
        value
      }, ctx, onComment, onChompKeep) => {
        let src;
        if (typeof Buffer === "function") {
          src = value instanceof Buffer ? value.toString("base64") : Buffer.from(value.buffer).toString("base64");
        } else if (typeof btoa === "function") {
          let s = "";
          for (let i = 0; i < value.length; ++i)
            s += String.fromCharCode(value[i]);
          src = btoa(s);
        } else {
          throw new Error("This environment does not support writing binary tags; either Buffer or btoa is required");
        }
        if (!type)
          type = resolveSeq.binaryOptions.defaultType;
        if (type === PlainValue.Type.QUOTE_DOUBLE) {
          value = src;
        } else {
          const {
            lineWidth
          } = resolveSeq.binaryOptions;
          const n = Math.ceil(src.length / lineWidth);
          const lines = new Array(n);
          for (let i = 0, o = 0; i < n; ++i, o += lineWidth) {
            lines[i] = src.substr(o, lineWidth);
          }
          value = lines.join(type === PlainValue.Type.BLOCK_LITERAL ? "\n" : " ");
        }
        return resolveSeq.stringifyString({
          comment,
          type,
          value
        }, ctx, onComment, onChompKeep);
      }
    };
    function parsePairs(doc, cst) {
      const seq = resolveSeq.resolveSeq(doc, cst);
      for (let i = 0; i < seq.items.length; ++i) {
        let item = seq.items[i];
        if (item instanceof resolveSeq.Pair)
          continue;
        else if (item instanceof resolveSeq.YAMLMap) {
          if (item.items.length > 1) {
            const msg = "Each pair must have its own sequence indicator";
            throw new PlainValue.YAMLSemanticError(cst, msg);
          }
          const pair = item.items[0] || new resolveSeq.Pair();
          if (item.commentBefore)
            pair.commentBefore = pair.commentBefore ? `${item.commentBefore}
${pair.commentBefore}` : item.commentBefore;
          if (item.comment)
            pair.comment = pair.comment ? `${item.comment}
${pair.comment}` : item.comment;
          item = pair;
        }
        seq.items[i] = item instanceof resolveSeq.Pair ? item : new resolveSeq.Pair(item);
      }
      return seq;
    }
    function createPairs(schema, iterable, ctx) {
      const pairs2 = new resolveSeq.YAMLSeq(schema);
      pairs2.tag = "tag:yaml.org,2002:pairs";
      for (const it of iterable) {
        let key, value;
        if (Array.isArray(it)) {
          if (it.length === 2) {
            key = it[0];
            value = it[1];
          } else
            throw new TypeError(`Expected [key, value] tuple: ${it}`);
        } else if (it && it instanceof Object) {
          const keys = Object.keys(it);
          if (keys.length === 1) {
            key = keys[0];
            value = it[key];
          } else
            throw new TypeError(`Expected { key: value } tuple: ${it}`);
        } else {
          key = it;
        }
        const pair = schema.createPair(key, value, ctx);
        pairs2.items.push(pair);
      }
      return pairs2;
    }
    var pairs = {
      default: false,
      tag: "tag:yaml.org,2002:pairs",
      resolve: parsePairs,
      createNode: createPairs
    };
    var YAMLOMap = class _YAMLOMap extends resolveSeq.YAMLSeq {
      constructor() {
        super();
        PlainValue._defineProperty(this, "add", resolveSeq.YAMLMap.prototype.add.bind(this));
        PlainValue._defineProperty(this, "delete", resolveSeq.YAMLMap.prototype.delete.bind(this));
        PlainValue._defineProperty(this, "get", resolveSeq.YAMLMap.prototype.get.bind(this));
        PlainValue._defineProperty(this, "has", resolveSeq.YAMLMap.prototype.has.bind(this));
        PlainValue._defineProperty(this, "set", resolveSeq.YAMLMap.prototype.set.bind(this));
        this.tag = _YAMLOMap.tag;
      }
      toJSON(_, ctx) {
        const map = /* @__PURE__ */ new Map();
        if (ctx && ctx.onCreate)
          ctx.onCreate(map);
        for (const pair of this.items) {
          let key, value;
          if (pair instanceof resolveSeq.Pair) {
            key = resolveSeq.toJSON(pair.key, "", ctx);
            value = resolveSeq.toJSON(pair.value, key, ctx);
          } else {
            key = resolveSeq.toJSON(pair, "", ctx);
          }
          if (map.has(key))
            throw new Error("Ordered maps must not include duplicate keys");
          map.set(key, value);
        }
        return map;
      }
    };
    PlainValue._defineProperty(YAMLOMap, "tag", "tag:yaml.org,2002:omap");
    function parseOMap(doc, cst) {
      const pairs2 = parsePairs(doc, cst);
      const seenKeys = [];
      for (const {
        key
      } of pairs2.items) {
        if (key instanceof resolveSeq.Scalar) {
          if (seenKeys.includes(key.value)) {
            const msg = "Ordered maps must not include duplicate keys";
            throw new PlainValue.YAMLSemanticError(cst, msg);
          } else {
            seenKeys.push(key.value);
          }
        }
      }
      return Object.assign(new YAMLOMap(), pairs2);
    }
    function createOMap(schema, iterable, ctx) {
      const pairs2 = createPairs(schema, iterable, ctx);
      const omap2 = new YAMLOMap();
      omap2.items = pairs2.items;
      return omap2;
    }
    var omap = {
      identify: (value) => value instanceof Map,
      nodeClass: YAMLOMap,
      default: false,
      tag: "tag:yaml.org,2002:omap",
      resolve: parseOMap,
      createNode: createOMap
    };
    var YAMLSet = class _YAMLSet extends resolveSeq.YAMLMap {
      constructor() {
        super();
        this.tag = _YAMLSet.tag;
      }
      add(key) {
        const pair = key instanceof resolveSeq.Pair ? key : new resolveSeq.Pair(key);
        const prev = resolveSeq.findPair(this.items, pair.key);
        if (!prev)
          this.items.push(pair);
      }
      get(key, keepPair) {
        const pair = resolveSeq.findPair(this.items, key);
        return !keepPair && pair instanceof resolveSeq.Pair ? pair.key instanceof resolveSeq.Scalar ? pair.key.value : pair.key : pair;
      }
      set(key, value) {
        if (typeof value !== "boolean")
          throw new Error(`Expected boolean value for set(key, value) in a YAML set, not ${typeof value}`);
        const prev = resolveSeq.findPair(this.items, key);
        if (prev && !value) {
          this.items.splice(this.items.indexOf(prev), 1);
        } else if (!prev && value) {
          this.items.push(new resolveSeq.Pair(key));
        }
      }
      toJSON(_, ctx) {
        return super.toJSON(_, ctx, Set);
      }
      toString(ctx, onComment, onChompKeep) {
        if (!ctx)
          return JSON.stringify(this);
        if (this.hasAllNullValues())
          return super.toString(ctx, onComment, onChompKeep);
        else
          throw new Error("Set items must all have null values");
      }
    };
    PlainValue._defineProperty(YAMLSet, "tag", "tag:yaml.org,2002:set");
    function parseSet(doc, cst) {
      const map = resolveSeq.resolveMap(doc, cst);
      if (!map.hasAllNullValues())
        throw new PlainValue.YAMLSemanticError(cst, "Set items must all have null values");
      return Object.assign(new YAMLSet(), map);
    }
    function createSet(schema, iterable, ctx) {
      const set2 = new YAMLSet();
      for (const value of iterable)
        set2.items.push(schema.createPair(value, null, ctx));
      return set2;
    }
    var set = {
      identify: (value) => value instanceof Set,
      nodeClass: YAMLSet,
      default: false,
      tag: "tag:yaml.org,2002:set",
      resolve: parseSet,
      createNode: createSet
    };
    var parseSexagesimal = (sign, parts) => {
      const n = parts.split(":").reduce((n2, p) => n2 * 60 + Number(p), 0);
      return sign === "-" ? -n : n;
    };
    var stringifySexagesimal = ({
      value
    }) => {
      if (isNaN(value) || !isFinite(value))
        return resolveSeq.stringifyNumber(value);
      let sign = "";
      if (value < 0) {
        sign = "-";
        value = Math.abs(value);
      }
      const parts = [value % 60];
      if (value < 60) {
        parts.unshift(0);
      } else {
        value = Math.round((value - parts[0]) / 60);
        parts.unshift(value % 60);
        if (value >= 60) {
          value = Math.round((value - parts[0]) / 60);
          parts.unshift(value);
        }
      }
      return sign + parts.map((n) => n < 10 ? "0" + String(n) : String(n)).join(":").replace(/000000\d*$/, "");
    };
    var intTime = {
      identify: (value) => typeof value === "number",
      default: true,
      tag: "tag:yaml.org,2002:int",
      format: "TIME",
      test: /^([-+]?)([0-9][0-9_]*(?::[0-5]?[0-9])+)$/,
      resolve: (str, sign, parts) => parseSexagesimal(sign, parts.replace(/_/g, "")),
      stringify: stringifySexagesimal
    };
    var floatTime = {
      identify: (value) => typeof value === "number",
      default: true,
      tag: "tag:yaml.org,2002:float",
      format: "TIME",
      test: /^([-+]?)([0-9][0-9_]*(?::[0-5]?[0-9])+\.[0-9_]*)$/,
      resolve: (str, sign, parts) => parseSexagesimal(sign, parts.replace(/_/g, "")),
      stringify: stringifySexagesimal
    };
    var timestamp = {
      identify: (value) => value instanceof Date,
      default: true,
      tag: "tag:yaml.org,2002:timestamp",
      // If the time zone is omitted, the timestamp is assumed to be specified in UTC. The time part
      // may be omitted altogether, resulting in a date format. In such a case, the time part is
      // assumed to be 00:00:00Z (start of day, UTC).
      test: RegExp("^(?:([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})(?:(?:t|T|[ \\t]+)([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2}(\\.[0-9]+)?)(?:[ \\t]*(Z|[-+][012]?[0-9](?::[0-9]{2})?))?)?)$"),
      resolve: (str, year, month, day, hour, minute, second, millisec, tz) => {
        if (millisec)
          millisec = (millisec + "00").substr(1, 3);
        let date = Date.UTC(year, month - 1, day, hour || 0, minute || 0, second || 0, millisec || 0);
        if (tz && tz !== "Z") {
          let d = parseSexagesimal(tz[0], tz.slice(1));
          if (Math.abs(d) < 30)
            d *= 60;
          date -= 6e4 * d;
        }
        return new Date(date);
      },
      stringify: ({
        value
      }) => value.toISOString().replace(/((T00:00)?:00)?\.000Z$/, "")
    };
    function shouldWarn(deprecation) {
      const env = typeof process !== "undefined" && process.env || {};
      if (deprecation) {
        if (typeof YAML_SILENCE_DEPRECATION_WARNINGS !== "undefined")
          return !YAML_SILENCE_DEPRECATION_WARNINGS;
        return !env.YAML_SILENCE_DEPRECATION_WARNINGS;
      }
      if (typeof YAML_SILENCE_WARNINGS !== "undefined")
        return !YAML_SILENCE_WARNINGS;
      return !env.YAML_SILENCE_WARNINGS;
    }
    function warn(warning, type) {
      if (shouldWarn(false)) {
        const emit = typeof process !== "undefined" && process.emitWarning;
        if (emit)
          emit(warning, type);
        else {
          console.warn(type ? `${type}: ${warning}` : warning);
        }
      }
    }
    function warnFileDeprecation(filename) {
      if (shouldWarn(true)) {
        const path = filename.replace(/.*yaml[/\\]/i, "").replace(/\.js$/, "").replace(/\\/g, "/");
        warn(`The endpoint 'yaml/${path}' will be removed in a future release.`, "DeprecationWarning");
      }
    }
    var warned = {};
    function warnOptionDeprecation(name, alternative) {
      if (!warned[name] && shouldWarn(true)) {
        warned[name] = true;
        let msg = `The option '${name}' will be removed in a future release`;
        msg += alternative ? `, use '${alternative}' instead.` : ".";
        warn(msg, "DeprecationWarning");
      }
    }
    exports2.binary = binary;
    exports2.floatTime = floatTime;
    exports2.intTime = intTime;
    exports2.omap = omap;
    exports2.pairs = pairs;
    exports2.set = set;
    exports2.timestamp = timestamp;
    exports2.warn = warn;
    exports2.warnFileDeprecation = warnFileDeprecation;
    exports2.warnOptionDeprecation = warnOptionDeprecation;
  }
});

// node_modules/aws-cdk-lib/node_modules/yaml/dist/Schema-88e323a7.js
var require_Schema_88e323a7 = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/yaml/dist/Schema-88e323a7.js"(exports2) {
    "use strict";
    var PlainValue = require_PlainValue_ec8e588e();
    var resolveSeq = require_resolveSeq_d03cb037();
    var warnings = require_warnings_1000a372();
    function createMap(schema, obj, ctx) {
      const map2 = new resolveSeq.YAMLMap(schema);
      if (obj instanceof Map) {
        for (const [key, value] of obj)
          map2.items.push(schema.createPair(key, value, ctx));
      } else if (obj && typeof obj === "object") {
        for (const key of Object.keys(obj))
          map2.items.push(schema.createPair(key, obj[key], ctx));
      }
      if (typeof schema.sortMapEntries === "function") {
        map2.items.sort(schema.sortMapEntries);
      }
      return map2;
    }
    var map = {
      createNode: createMap,
      default: true,
      nodeClass: resolveSeq.YAMLMap,
      tag: "tag:yaml.org,2002:map",
      resolve: resolveSeq.resolveMap
    };
    function createSeq(schema, obj, ctx) {
      const seq2 = new resolveSeq.YAMLSeq(schema);
      if (obj && obj[Symbol.iterator]) {
        for (const it of obj) {
          const v = schema.createNode(it, ctx.wrapScalars, null, ctx);
          seq2.items.push(v);
        }
      }
      return seq2;
    }
    var seq = {
      createNode: createSeq,
      default: true,
      nodeClass: resolveSeq.YAMLSeq,
      tag: "tag:yaml.org,2002:seq",
      resolve: resolveSeq.resolveSeq
    };
    var string = {
      identify: (value) => typeof value === "string",
      default: true,
      tag: "tag:yaml.org,2002:str",
      resolve: resolveSeq.resolveString,
      stringify(item, ctx, onComment, onChompKeep) {
        ctx = Object.assign({
          actualString: true
        }, ctx);
        return resolveSeq.stringifyString(item, ctx, onComment, onChompKeep);
      },
      options: resolveSeq.strOptions
    };
    var failsafe = [map, seq, string];
    var intIdentify$2 = (value) => typeof value === "bigint" || Number.isInteger(value);
    var intResolve$1 = (src, part, radix) => resolveSeq.intOptions.asBigInt ? BigInt(src) : parseInt(part, radix);
    function intStringify$1(node, radix, prefix) {
      const {
        value
      } = node;
      if (intIdentify$2(value) && value >= 0)
        return prefix + value.toString(radix);
      return resolveSeq.stringifyNumber(node);
    }
    var nullObj = {
      identify: (value) => value == null,
      createNode: (schema, value, ctx) => ctx.wrapScalars ? new resolveSeq.Scalar(null) : null,
      default: true,
      tag: "tag:yaml.org,2002:null",
      test: /^(?:~|[Nn]ull|NULL)?$/,
      resolve: () => null,
      options: resolveSeq.nullOptions,
      stringify: () => resolveSeq.nullOptions.nullStr
    };
    var boolObj = {
      identify: (value) => typeof value === "boolean",
      default: true,
      tag: "tag:yaml.org,2002:bool",
      test: /^(?:[Tt]rue|TRUE|[Ff]alse|FALSE)$/,
      resolve: (str) => str[0] === "t" || str[0] === "T",
      options: resolveSeq.boolOptions,
      stringify: ({
        value
      }) => value ? resolveSeq.boolOptions.trueStr : resolveSeq.boolOptions.falseStr
    };
    var octObj = {
      identify: (value) => intIdentify$2(value) && value >= 0,
      default: true,
      tag: "tag:yaml.org,2002:int",
      format: "OCT",
      test: /^0o([0-7]+)$/,
      resolve: (str, oct) => intResolve$1(str, oct, 8),
      options: resolveSeq.intOptions,
      stringify: (node) => intStringify$1(node, 8, "0o")
    };
    var intObj = {
      identify: intIdentify$2,
      default: true,
      tag: "tag:yaml.org,2002:int",
      test: /^[-+]?[0-9]+$/,
      resolve: (str) => intResolve$1(str, str, 10),
      options: resolveSeq.intOptions,
      stringify: resolveSeq.stringifyNumber
    };
    var hexObj = {
      identify: (value) => intIdentify$2(value) && value >= 0,
      default: true,
      tag: "tag:yaml.org,2002:int",
      format: "HEX",
      test: /^0x([0-9a-fA-F]+)$/,
      resolve: (str, hex) => intResolve$1(str, hex, 16),
      options: resolveSeq.intOptions,
      stringify: (node) => intStringify$1(node, 16, "0x")
    };
    var nanObj = {
      identify: (value) => typeof value === "number",
      default: true,
      tag: "tag:yaml.org,2002:float",
      test: /^(?:[-+]?\.inf|(\.nan))$/i,
      resolve: (str, nan) => nan ? NaN : str[0] === "-" ? Number.NEGATIVE_INFINITY : Number.POSITIVE_INFINITY,
      stringify: resolveSeq.stringifyNumber
    };
    var expObj = {
      identify: (value) => typeof value === "number",
      default: true,
      tag: "tag:yaml.org,2002:float",
      format: "EXP",
      test: /^[-+]?(?:\.[0-9]+|[0-9]+(?:\.[0-9]*)?)[eE][-+]?[0-9]+$/,
      resolve: (str) => parseFloat(str),
      stringify: ({
        value
      }) => Number(value).toExponential()
    };
    var floatObj = {
      identify: (value) => typeof value === "number",
      default: true,
      tag: "tag:yaml.org,2002:float",
      test: /^[-+]?(?:\.([0-9]+)|[0-9]+\.([0-9]*))$/,
      resolve(str, frac1, frac2) {
        const frac = frac1 || frac2;
        const node = new resolveSeq.Scalar(parseFloat(str));
        if (frac && frac[frac.length - 1] === "0")
          node.minFractionDigits = frac.length;
        return node;
      },
      stringify: resolveSeq.stringifyNumber
    };
    var core = failsafe.concat([nullObj, boolObj, octObj, intObj, hexObj, nanObj, expObj, floatObj]);
    var intIdentify$1 = (value) => typeof value === "bigint" || Number.isInteger(value);
    var stringifyJSON = ({
      value
    }) => JSON.stringify(value);
    var json = [map, seq, {
      identify: (value) => typeof value === "string",
      default: true,
      tag: "tag:yaml.org,2002:str",
      resolve: resolveSeq.resolveString,
      stringify: stringifyJSON
    }, {
      identify: (value) => value == null,
      createNode: (schema, value, ctx) => ctx.wrapScalars ? new resolveSeq.Scalar(null) : null,
      default: true,
      tag: "tag:yaml.org,2002:null",
      test: /^null$/,
      resolve: () => null,
      stringify: stringifyJSON
    }, {
      identify: (value) => typeof value === "boolean",
      default: true,
      tag: "tag:yaml.org,2002:bool",
      test: /^true|false$/,
      resolve: (str) => str === "true",
      stringify: stringifyJSON
    }, {
      identify: intIdentify$1,
      default: true,
      tag: "tag:yaml.org,2002:int",
      test: /^-?(?:0|[1-9][0-9]*)$/,
      resolve: (str) => resolveSeq.intOptions.asBigInt ? BigInt(str) : parseInt(str, 10),
      stringify: ({
        value
      }) => intIdentify$1(value) ? value.toString() : JSON.stringify(value)
    }, {
      identify: (value) => typeof value === "number",
      default: true,
      tag: "tag:yaml.org,2002:float",
      test: /^-?(?:0|[1-9][0-9]*)(?:\.[0-9]*)?(?:[eE][-+]?[0-9]+)?$/,
      resolve: (str) => parseFloat(str),
      stringify: stringifyJSON
    }];
    json.scalarFallback = (str) => {
      throw new SyntaxError(`Unresolved plain scalar ${JSON.stringify(str)}`);
    };
    var boolStringify = ({
      value
    }) => value ? resolveSeq.boolOptions.trueStr : resolveSeq.boolOptions.falseStr;
    var intIdentify = (value) => typeof value === "bigint" || Number.isInteger(value);
    function intResolve(sign, src, radix) {
      let str = src.replace(/_/g, "");
      if (resolveSeq.intOptions.asBigInt) {
        switch (radix) {
          case 2:
            str = `0b${str}`;
            break;
          case 8:
            str = `0o${str}`;
            break;
          case 16:
            str = `0x${str}`;
            break;
        }
        const n2 = BigInt(str);
        return sign === "-" ? BigInt(-1) * n2 : n2;
      }
      const n = parseInt(str, radix);
      return sign === "-" ? -1 * n : n;
    }
    function intStringify(node, radix, prefix) {
      const {
        value
      } = node;
      if (intIdentify(value)) {
        const str = value.toString(radix);
        return value < 0 ? "-" + prefix + str.substr(1) : prefix + str;
      }
      return resolveSeq.stringifyNumber(node);
    }
    var yaml11 = failsafe.concat([{
      identify: (value) => value == null,
      createNode: (schema, value, ctx) => ctx.wrapScalars ? new resolveSeq.Scalar(null) : null,
      default: true,
      tag: "tag:yaml.org,2002:null",
      test: /^(?:~|[Nn]ull|NULL)?$/,
      resolve: () => null,
      options: resolveSeq.nullOptions,
      stringify: () => resolveSeq.nullOptions.nullStr
    }, {
      identify: (value) => typeof value === "boolean",
      default: true,
      tag: "tag:yaml.org,2002:bool",
      test: /^(?:Y|y|[Yy]es|YES|[Tt]rue|TRUE|[Oo]n|ON)$/,
      resolve: () => true,
      options: resolveSeq.boolOptions,
      stringify: boolStringify
    }, {
      identify: (value) => typeof value === "boolean",
      default: true,
      tag: "tag:yaml.org,2002:bool",
      test: /^(?:N|n|[Nn]o|NO|[Ff]alse|FALSE|[Oo]ff|OFF)$/i,
      resolve: () => false,
      options: resolveSeq.boolOptions,
      stringify: boolStringify
    }, {
      identify: intIdentify,
      default: true,
      tag: "tag:yaml.org,2002:int",
      format: "BIN",
      test: /^([-+]?)0b([0-1_]+)$/,
      resolve: (str, sign, bin) => intResolve(sign, bin, 2),
      stringify: (node) => intStringify(node, 2, "0b")
    }, {
      identify: intIdentify,
      default: true,
      tag: "tag:yaml.org,2002:int",
      format: "OCT",
      test: /^([-+]?)0([0-7_]+)$/,
      resolve: (str, sign, oct) => intResolve(sign, oct, 8),
      stringify: (node) => intStringify(node, 8, "0")
    }, {
      identify: intIdentify,
      default: true,
      tag: "tag:yaml.org,2002:int",
      test: /^([-+]?)([0-9][0-9_]*)$/,
      resolve: (str, sign, abs) => intResolve(sign, abs, 10),
      stringify: resolveSeq.stringifyNumber
    }, {
      identify: intIdentify,
      default: true,
      tag: "tag:yaml.org,2002:int",
      format: "HEX",
      test: /^([-+]?)0x([0-9a-fA-F_]+)$/,
      resolve: (str, sign, hex) => intResolve(sign, hex, 16),
      stringify: (node) => intStringify(node, 16, "0x")
    }, {
      identify: (value) => typeof value === "number",
      default: true,
      tag: "tag:yaml.org,2002:float",
      test: /^(?:[-+]?\.inf|(\.nan))$/i,
      resolve: (str, nan) => nan ? NaN : str[0] === "-" ? Number.NEGATIVE_INFINITY : Number.POSITIVE_INFINITY,
      stringify: resolveSeq.stringifyNumber
    }, {
      identify: (value) => typeof value === "number",
      default: true,
      tag: "tag:yaml.org,2002:float",
      format: "EXP",
      test: /^[-+]?([0-9][0-9_]*)?(\.[0-9_]*)?[eE][-+]?[0-9]+$/,
      resolve: (str) => parseFloat(str.replace(/_/g, "")),
      stringify: ({
        value
      }) => Number(value).toExponential()
    }, {
      identify: (value) => typeof value === "number",
      default: true,
      tag: "tag:yaml.org,2002:float",
      test: /^[-+]?(?:[0-9][0-9_]*)?\.([0-9_]*)$/,
      resolve(str, frac) {
        const node = new resolveSeq.Scalar(parseFloat(str.replace(/_/g, "")));
        if (frac) {
          const f = frac.replace(/_/g, "");
          if (f[f.length - 1] === "0")
            node.minFractionDigits = f.length;
        }
        return node;
      },
      stringify: resolveSeq.stringifyNumber
    }], warnings.binary, warnings.omap, warnings.pairs, warnings.set, warnings.intTime, warnings.floatTime, warnings.timestamp);
    var schemas = {
      core,
      failsafe,
      json,
      yaml11
    };
    var tags = {
      binary: warnings.binary,
      bool: boolObj,
      float: floatObj,
      floatExp: expObj,
      floatNaN: nanObj,
      floatTime: warnings.floatTime,
      int: intObj,
      intHex: hexObj,
      intOct: octObj,
      intTime: warnings.intTime,
      map,
      null: nullObj,
      omap: warnings.omap,
      pairs: warnings.pairs,
      seq,
      set: warnings.set,
      timestamp: warnings.timestamp
    };
    function findTagObject(value, tagName, tags2) {
      if (tagName) {
        const match = tags2.filter((t) => t.tag === tagName);
        const tagObj = match.find((t) => !t.format) || match[0];
        if (!tagObj)
          throw new Error(`Tag ${tagName} not found`);
        return tagObj;
      }
      return tags2.find((t) => (t.identify && t.identify(value) || t.class && value instanceof t.class) && !t.format);
    }
    function createNode(value, tagName, ctx) {
      if (value instanceof resolveSeq.Node)
        return value;
      const {
        defaultPrefix,
        onTagObj,
        prevObjects,
        schema,
        wrapScalars
      } = ctx;
      if (tagName && tagName.startsWith("!!"))
        tagName = defaultPrefix + tagName.slice(2);
      let tagObj = findTagObject(value, tagName, schema.tags);
      if (!tagObj) {
        if (typeof value.toJSON === "function")
          value = value.toJSON();
        if (!value || typeof value !== "object")
          return wrapScalars ? new resolveSeq.Scalar(value) : value;
        tagObj = value instanceof Map ? map : value[Symbol.iterator] ? seq : map;
      }
      if (onTagObj) {
        onTagObj(tagObj);
        delete ctx.onTagObj;
      }
      const obj = {
        value: void 0,
        node: void 0
      };
      if (value && typeof value === "object" && prevObjects) {
        const prev = prevObjects.get(value);
        if (prev) {
          const alias = new resolveSeq.Alias(prev);
          ctx.aliasNodes.push(alias);
          return alias;
        }
        obj.value = value;
        prevObjects.set(value, obj);
      }
      obj.node = tagObj.createNode ? tagObj.createNode(ctx.schema, value, ctx) : wrapScalars ? new resolveSeq.Scalar(value) : value;
      if (tagName && obj.node instanceof resolveSeq.Node)
        obj.node.tag = tagName;
      return obj.node;
    }
    function getSchemaTags(schemas2, knownTags, customTags, schemaId) {
      let tags2 = schemas2[schemaId.replace(/\W/g, "")];
      if (!tags2) {
        const keys = Object.keys(schemas2).map((key) => JSON.stringify(key)).join(", ");
        throw new Error(`Unknown schema "${schemaId}"; use one of ${keys}`);
      }
      if (Array.isArray(customTags)) {
        for (const tag of customTags)
          tags2 = tags2.concat(tag);
      } else if (typeof customTags === "function") {
        tags2 = customTags(tags2.slice());
      }
      for (let i = 0; i < tags2.length; ++i) {
        const tag = tags2[i];
        if (typeof tag === "string") {
          const tagObj = knownTags[tag];
          if (!tagObj) {
            const keys = Object.keys(knownTags).map((key) => JSON.stringify(key)).join(", ");
            throw new Error(`Unknown custom tag "${tag}"; use one of ${keys}`);
          }
          tags2[i] = tagObj;
        }
      }
      return tags2;
    }
    var sortMapEntriesByKey = (a, b) => a.key < b.key ? -1 : a.key > b.key ? 1 : 0;
    var Schema = class _Schema {
      // TODO: remove in v2
      // TODO: remove in v2
      constructor({
        customTags,
        merge,
        schema,
        sortMapEntries,
        tags: deprecatedCustomTags
      }) {
        this.merge = !!merge;
        this.name = schema;
        this.sortMapEntries = sortMapEntries === true ? sortMapEntriesByKey : sortMapEntries || null;
        if (!customTags && deprecatedCustomTags)
          warnings.warnOptionDeprecation("tags", "customTags");
        this.tags = getSchemaTags(schemas, tags, customTags || deprecatedCustomTags, schema);
      }
      createNode(value, wrapScalars, tagName, ctx) {
        const baseCtx = {
          defaultPrefix: _Schema.defaultPrefix,
          schema: this,
          wrapScalars
        };
        const createCtx = ctx ? Object.assign(ctx, baseCtx) : baseCtx;
        return createNode(value, tagName, createCtx);
      }
      createPair(key, value, ctx) {
        if (!ctx)
          ctx = {
            wrapScalars: true
          };
        const k = this.createNode(key, ctx.wrapScalars, null, ctx);
        const v = this.createNode(value, ctx.wrapScalars, null, ctx);
        return new resolveSeq.Pair(k, v);
      }
    };
    PlainValue._defineProperty(Schema, "defaultPrefix", PlainValue.defaultTagPrefix);
    PlainValue._defineProperty(Schema, "defaultTags", PlainValue.defaultTags);
    exports2.Schema = Schema;
  }
});

// node_modules/aws-cdk-lib/node_modules/yaml/dist/Document-9b4560a1.js
var require_Document_9b4560a1 = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/yaml/dist/Document-9b4560a1.js"(exports2) {
    "use strict";
    var PlainValue = require_PlainValue_ec8e588e();
    var resolveSeq = require_resolveSeq_d03cb037();
    var Schema = require_Schema_88e323a7();
    var defaultOptions = {
      anchorPrefix: "a",
      customTags: null,
      indent: 2,
      indentSeq: true,
      keepCstNodes: false,
      keepNodeTypes: true,
      keepBlobsInJSON: true,
      mapAsMap: false,
      maxAliasCount: 100,
      prettyErrors: false,
      // TODO Set true in v2
      simpleKeys: false,
      version: "1.2"
    };
    var scalarOptions = {
      get binary() {
        return resolveSeq.binaryOptions;
      },
      set binary(opt) {
        Object.assign(resolveSeq.binaryOptions, opt);
      },
      get bool() {
        return resolveSeq.boolOptions;
      },
      set bool(opt) {
        Object.assign(resolveSeq.boolOptions, opt);
      },
      get int() {
        return resolveSeq.intOptions;
      },
      set int(opt) {
        Object.assign(resolveSeq.intOptions, opt);
      },
      get null() {
        return resolveSeq.nullOptions;
      },
      set null(opt) {
        Object.assign(resolveSeq.nullOptions, opt);
      },
      get str() {
        return resolveSeq.strOptions;
      },
      set str(opt) {
        Object.assign(resolveSeq.strOptions, opt);
      }
    };
    var documentOptions = {
      "1.0": {
        schema: "yaml-1.1",
        merge: true,
        tagPrefixes: [{
          handle: "!",
          prefix: PlainValue.defaultTagPrefix
        }, {
          handle: "!!",
          prefix: "tag:private.yaml.org,2002:"
        }]
      },
      1.1: {
        schema: "yaml-1.1",
        merge: true,
        tagPrefixes: [{
          handle: "!",
          prefix: "!"
        }, {
          handle: "!!",
          prefix: PlainValue.defaultTagPrefix
        }]
      },
      1.2: {
        schema: "core",
        merge: false,
        tagPrefixes: [{
          handle: "!",
          prefix: "!"
        }, {
          handle: "!!",
          prefix: PlainValue.defaultTagPrefix
        }]
      }
    };
    function stringifyTag(doc, tag) {
      if ((doc.version || doc.options.version) === "1.0") {
        const priv = tag.match(/^tag:private\.yaml\.org,2002:([^:/]+)$/);
        if (priv)
          return "!" + priv[1];
        const vocab = tag.match(/^tag:([a-zA-Z0-9-]+)\.yaml\.org,2002:(.*)/);
        return vocab ? `!${vocab[1]}/${vocab[2]}` : `!${tag.replace(/^tag:/, "")}`;
      }
      let p = doc.tagPrefixes.find((p2) => tag.indexOf(p2.prefix) === 0);
      if (!p) {
        const dtp = doc.getDefaults().tagPrefixes;
        p = dtp && dtp.find((p2) => tag.indexOf(p2.prefix) === 0);
      }
      if (!p)
        return tag[0] === "!" ? tag : `!<${tag}>`;
      const suffix = tag.substr(p.prefix.length).replace(/[!,[\]{}]/g, (ch) => ({
        "!": "%21",
        ",": "%2C",
        "[": "%5B",
        "]": "%5D",
        "{": "%7B",
        "}": "%7D"
      })[ch]);
      return p.handle + suffix;
    }
    function getTagObject(tags, item) {
      if (item instanceof resolveSeq.Alias)
        return resolveSeq.Alias;
      if (item.tag) {
        const match = tags.filter((t) => t.tag === item.tag);
        if (match.length > 0)
          return match.find((t) => t.format === item.format) || match[0];
      }
      let tagObj, obj;
      if (item instanceof resolveSeq.Scalar) {
        obj = item.value;
        const match = tags.filter((t) => t.identify && t.identify(obj) || t.class && obj instanceof t.class);
        tagObj = match.find((t) => t.format === item.format) || match.find((t) => !t.format);
      } else {
        obj = item;
        tagObj = tags.find((t) => t.nodeClass && obj instanceof t.nodeClass);
      }
      if (!tagObj) {
        const name = obj && obj.constructor ? obj.constructor.name : typeof obj;
        throw new Error(`Tag not resolved for ${name} value`);
      }
      return tagObj;
    }
    function stringifyProps(node, tagObj, {
      anchors,
      doc
    }) {
      const props = [];
      const anchor = doc.anchors.getName(node);
      if (anchor) {
        anchors[anchor] = node;
        props.push(`&${anchor}`);
      }
      if (node.tag) {
        props.push(stringifyTag(doc, node.tag));
      } else if (!tagObj.default) {
        props.push(stringifyTag(doc, tagObj.tag));
      }
      return props.join(" ");
    }
    function stringify(item, ctx, onComment, onChompKeep) {
      const {
        anchors,
        schema
      } = ctx.doc;
      let tagObj;
      if (!(item instanceof resolveSeq.Node)) {
        const createCtx = {
          aliasNodes: [],
          onTagObj: (o) => tagObj = o,
          prevObjects: /* @__PURE__ */ new Map()
        };
        item = schema.createNode(item, true, null, createCtx);
        for (const alias of createCtx.aliasNodes) {
          alias.source = alias.source.node;
          let name = anchors.getName(alias.source);
          if (!name) {
            name = anchors.newName();
            anchors.map[name] = alias.source;
          }
        }
      }
      if (item instanceof resolveSeq.Pair)
        return item.toString(ctx, onComment, onChompKeep);
      if (!tagObj)
        tagObj = getTagObject(schema.tags, item);
      const props = stringifyProps(item, tagObj, ctx);
      if (props.length > 0)
        ctx.indentAtStart = (ctx.indentAtStart || 0) + props.length + 1;
      const str = typeof tagObj.stringify === "function" ? tagObj.stringify(item, ctx, onComment, onChompKeep) : item instanceof resolveSeq.Scalar ? resolveSeq.stringifyString(item, ctx, onComment, onChompKeep) : item.toString(ctx, onComment, onChompKeep);
      if (!props)
        return str;
      return item instanceof resolveSeq.Scalar || str[0] === "{" || str[0] === "[" ? `${props} ${str}` : `${props}
${ctx.indent}${str}`;
    }
    var Anchors = class _Anchors {
      static validAnchorNode(node) {
        return node instanceof resolveSeq.Scalar || node instanceof resolveSeq.YAMLSeq || node instanceof resolveSeq.YAMLMap;
      }
      constructor(prefix) {
        PlainValue._defineProperty(this, "map", /* @__PURE__ */ Object.create(null));
        this.prefix = prefix;
      }
      createAlias(node, name) {
        this.setAnchor(node, name);
        return new resolveSeq.Alias(node);
      }
      createMergePair(...sources) {
        const merge = new resolveSeq.Merge();
        merge.value.items = sources.map((s) => {
          if (s instanceof resolveSeq.Alias) {
            if (s.source instanceof resolveSeq.YAMLMap)
              return s;
          } else if (s instanceof resolveSeq.YAMLMap) {
            return this.createAlias(s);
          }
          throw new Error("Merge sources must be Map nodes or their Aliases");
        });
        return merge;
      }
      getName(node) {
        const {
          map
        } = this;
        return Object.keys(map).find((a) => map[a] === node);
      }
      getNames() {
        return Object.keys(this.map);
      }
      getNode(name) {
        return this.map[name];
      }
      newName(prefix) {
        if (!prefix)
          prefix = this.prefix;
        const names = Object.keys(this.map);
        for (let i = 1; true; ++i) {
          const name = `${prefix}${i}`;
          if (!names.includes(name))
            return name;
        }
      }
      // During parsing, map & aliases contain CST nodes
      resolveNodes() {
        const {
          map,
          _cstAliases
        } = this;
        Object.keys(map).forEach((a) => {
          map[a] = map[a].resolved;
        });
        _cstAliases.forEach((a) => {
          a.source = a.source.resolved;
        });
        delete this._cstAliases;
      }
      setAnchor(node, name) {
        if (node != null && !_Anchors.validAnchorNode(node)) {
          throw new Error("Anchors may only be set for Scalar, Seq and Map nodes");
        }
        if (name && /[\x00-\x19\s,[\]{}]/.test(name)) {
          throw new Error("Anchor names must not contain whitespace or control characters");
        }
        const {
          map
        } = this;
        const prev = node && Object.keys(map).find((a) => map[a] === node);
        if (prev) {
          if (!name) {
            return prev;
          } else if (prev !== name) {
            delete map[prev];
            map[name] = node;
          }
        } else {
          if (!name) {
            if (!node)
              return null;
            name = this.newName();
          }
          map[name] = node;
        }
        return name;
      }
    };
    var visit = (node, tags) => {
      if (node && typeof node === "object") {
        const {
          tag
        } = node;
        if (node instanceof resolveSeq.Collection) {
          if (tag)
            tags[tag] = true;
          node.items.forEach((n) => visit(n, tags));
        } else if (node instanceof resolveSeq.Pair) {
          visit(node.key, tags);
          visit(node.value, tags);
        } else if (node instanceof resolveSeq.Scalar) {
          if (tag)
            tags[tag] = true;
        }
      }
      return tags;
    };
    var listTagNames = (node) => Object.keys(visit(node, {}));
    function parseContents(doc, contents) {
      const comments = {
        before: [],
        after: []
      };
      let body = void 0;
      let spaceBefore = false;
      for (const node of contents) {
        if (node.valueRange) {
          if (body !== void 0) {
            const msg = "Document contains trailing content not separated by a ... or --- line";
            doc.errors.push(new PlainValue.YAMLSyntaxError(node, msg));
            break;
          }
          const res = resolveSeq.resolveNode(doc, node);
          if (spaceBefore) {
            res.spaceBefore = true;
            spaceBefore = false;
          }
          body = res;
        } else if (node.comment !== null) {
          const cc = body === void 0 ? comments.before : comments.after;
          cc.push(node.comment);
        } else if (node.type === PlainValue.Type.BLANK_LINE) {
          spaceBefore = true;
          if (body === void 0 && comments.before.length > 0 && !doc.commentBefore) {
            doc.commentBefore = comments.before.join("\n");
            comments.before = [];
          }
        }
      }
      doc.contents = body || null;
      if (!body) {
        doc.comment = comments.before.concat(comments.after).join("\n") || null;
      } else {
        const cb = comments.before.join("\n");
        if (cb) {
          const cbNode = body instanceof resolveSeq.Collection && body.items[0] ? body.items[0] : body;
          cbNode.commentBefore = cbNode.commentBefore ? `${cb}
${cbNode.commentBefore}` : cb;
        }
        doc.comment = comments.after.join("\n") || null;
      }
    }
    function resolveTagDirective({
      tagPrefixes
    }, directive) {
      const [handle, prefix] = directive.parameters;
      if (!handle || !prefix) {
        const msg = "Insufficient parameters given for %TAG directive";
        throw new PlainValue.YAMLSemanticError(directive, msg);
      }
      if (tagPrefixes.some((p) => p.handle === handle)) {
        const msg = "The %TAG directive must only be given at most once per handle in the same document.";
        throw new PlainValue.YAMLSemanticError(directive, msg);
      }
      return {
        handle,
        prefix
      };
    }
    function resolveYamlDirective(doc, directive) {
      let [version] = directive.parameters;
      if (directive.name === "YAML:1.0")
        version = "1.0";
      if (!version) {
        const msg = "Insufficient parameters given for %YAML directive";
        throw new PlainValue.YAMLSemanticError(directive, msg);
      }
      if (!documentOptions[version]) {
        const v0 = doc.version || doc.options.version;
        const msg = `Document will be parsed as YAML ${v0} rather than YAML ${version}`;
        doc.warnings.push(new PlainValue.YAMLWarning(directive, msg));
      }
      return version;
    }
    function parseDirectives(doc, directives, prevDoc) {
      const directiveComments = [];
      let hasDirectives = false;
      for (const directive of directives) {
        const {
          comment,
          name
        } = directive;
        switch (name) {
          case "TAG":
            try {
              doc.tagPrefixes.push(resolveTagDirective(doc, directive));
            } catch (error) {
              doc.errors.push(error);
            }
            hasDirectives = true;
            break;
          case "YAML":
          case "YAML:1.0":
            if (doc.version) {
              const msg = "The %YAML directive must only be given at most once per document.";
              doc.errors.push(new PlainValue.YAMLSemanticError(directive, msg));
            }
            try {
              doc.version = resolveYamlDirective(doc, directive);
            } catch (error) {
              doc.errors.push(error);
            }
            hasDirectives = true;
            break;
          default:
            if (name) {
              const msg = `YAML only supports %TAG and %YAML directives, and not %${name}`;
              doc.warnings.push(new PlainValue.YAMLWarning(directive, msg));
            }
        }
        if (comment)
          directiveComments.push(comment);
      }
      if (prevDoc && !hasDirectives && "1.1" === (doc.version || prevDoc.version || doc.options.version)) {
        const copyTagPrefix = ({
          handle,
          prefix
        }) => ({
          handle,
          prefix
        });
        doc.tagPrefixes = prevDoc.tagPrefixes.map(copyTagPrefix);
        doc.version = prevDoc.version;
      }
      doc.commentBefore = directiveComments.join("\n") || null;
    }
    function assertCollection(contents) {
      if (contents instanceof resolveSeq.Collection)
        return true;
      throw new Error("Expected a YAML collection as document contents");
    }
    var Document = class _Document {
      constructor(options) {
        this.anchors = new Anchors(options.anchorPrefix);
        this.commentBefore = null;
        this.comment = null;
        this.contents = null;
        this.directivesEndMarker = null;
        this.errors = [];
        this.options = options;
        this.schema = null;
        this.tagPrefixes = [];
        this.version = null;
        this.warnings = [];
      }
      add(value) {
        assertCollection(this.contents);
        return this.contents.add(value);
      }
      addIn(path, value) {
        assertCollection(this.contents);
        this.contents.addIn(path, value);
      }
      delete(key) {
        assertCollection(this.contents);
        return this.contents.delete(key);
      }
      deleteIn(path) {
        if (resolveSeq.isEmptyPath(path)) {
          if (this.contents == null)
            return false;
          this.contents = null;
          return true;
        }
        assertCollection(this.contents);
        return this.contents.deleteIn(path);
      }
      getDefaults() {
        return _Document.defaults[this.version] || _Document.defaults[this.options.version] || {};
      }
      get(key, keepScalar) {
        return this.contents instanceof resolveSeq.Collection ? this.contents.get(key, keepScalar) : void 0;
      }
      getIn(path, keepScalar) {
        if (resolveSeq.isEmptyPath(path))
          return !keepScalar && this.contents instanceof resolveSeq.Scalar ? this.contents.value : this.contents;
        return this.contents instanceof resolveSeq.Collection ? this.contents.getIn(path, keepScalar) : void 0;
      }
      has(key) {
        return this.contents instanceof resolveSeq.Collection ? this.contents.has(key) : false;
      }
      hasIn(path) {
        if (resolveSeq.isEmptyPath(path))
          return this.contents !== void 0;
        return this.contents instanceof resolveSeq.Collection ? this.contents.hasIn(path) : false;
      }
      set(key, value) {
        assertCollection(this.contents);
        this.contents.set(key, value);
      }
      setIn(path, value) {
        if (resolveSeq.isEmptyPath(path))
          this.contents = value;
        else {
          assertCollection(this.contents);
          this.contents.setIn(path, value);
        }
      }
      setSchema(id, customTags) {
        if (!id && !customTags && this.schema)
          return;
        if (typeof id === "number")
          id = id.toFixed(1);
        if (id === "1.0" || id === "1.1" || id === "1.2") {
          if (this.version)
            this.version = id;
          else
            this.options.version = id;
          delete this.options.schema;
        } else if (id && typeof id === "string") {
          this.options.schema = id;
        }
        if (Array.isArray(customTags))
          this.options.customTags = customTags;
        const opt = Object.assign({}, this.getDefaults(), this.options);
        this.schema = new Schema.Schema(opt);
      }
      parse(node, prevDoc) {
        if (this.options.keepCstNodes)
          this.cstNode = node;
        if (this.options.keepNodeTypes)
          this.type = "DOCUMENT";
        const {
          directives = [],
          contents = [],
          directivesEndMarker,
          error,
          valueRange
        } = node;
        if (error) {
          if (!error.source)
            error.source = this;
          this.errors.push(error);
        }
        parseDirectives(this, directives, prevDoc);
        if (directivesEndMarker)
          this.directivesEndMarker = true;
        this.range = valueRange ? [valueRange.start, valueRange.end] : null;
        this.setSchema();
        this.anchors._cstAliases = [];
        parseContents(this, contents);
        this.anchors.resolveNodes();
        if (this.options.prettyErrors) {
          for (const error2 of this.errors)
            if (error2 instanceof PlainValue.YAMLError)
              error2.makePretty();
          for (const warn of this.warnings)
            if (warn instanceof PlainValue.YAMLError)
              warn.makePretty();
        }
        return this;
      }
      listNonDefaultTags() {
        return listTagNames(this.contents).filter((t) => t.indexOf(Schema.Schema.defaultPrefix) !== 0);
      }
      setTagPrefix(handle, prefix) {
        if (handle[0] !== "!" || handle[handle.length - 1] !== "!")
          throw new Error("Handle must start and end with !");
        if (prefix) {
          const prev = this.tagPrefixes.find((p) => p.handle === handle);
          if (prev)
            prev.prefix = prefix;
          else
            this.tagPrefixes.push({
              handle,
              prefix
            });
        } else {
          this.tagPrefixes = this.tagPrefixes.filter((p) => p.handle !== handle);
        }
      }
      toJSON(arg, onAnchor) {
        const {
          keepBlobsInJSON,
          mapAsMap,
          maxAliasCount
        } = this.options;
        const keep = keepBlobsInJSON && (typeof arg !== "string" || !(this.contents instanceof resolveSeq.Scalar));
        const ctx = {
          doc: this,
          indentStep: "  ",
          keep,
          mapAsMap: keep && !!mapAsMap,
          maxAliasCount,
          stringify
          // Requiring directly in Pair would create circular dependencies
        };
        const anchorNames = Object.keys(this.anchors.map);
        if (anchorNames.length > 0)
          ctx.anchors = new Map(anchorNames.map((name) => [this.anchors.map[name], {
            alias: [],
            aliasCount: 0,
            count: 1
          }]));
        const res = resolveSeq.toJSON(this.contents, arg, ctx);
        if (typeof onAnchor === "function" && ctx.anchors)
          for (const {
            count,
            res: res2
          } of ctx.anchors.values())
            onAnchor(res2, count);
        return res;
      }
      toString() {
        if (this.errors.length > 0)
          throw new Error("Document with errors cannot be stringified");
        const indentSize = this.options.indent;
        if (!Number.isInteger(indentSize) || indentSize <= 0) {
          const s = JSON.stringify(indentSize);
          throw new Error(`"indent" option must be a positive integer, not ${s}`);
        }
        this.setSchema();
        const lines = [];
        let hasDirectives = false;
        if (this.version) {
          let vd = "%YAML 1.2";
          if (this.schema.name === "yaml-1.1") {
            if (this.version === "1.0")
              vd = "%YAML:1.0";
            else if (this.version === "1.1")
              vd = "%YAML 1.1";
          }
          lines.push(vd);
          hasDirectives = true;
        }
        const tagNames = this.listNonDefaultTags();
        this.tagPrefixes.forEach(({
          handle,
          prefix
        }) => {
          if (tagNames.some((t) => t.indexOf(prefix) === 0)) {
            lines.push(`%TAG ${handle} ${prefix}`);
            hasDirectives = true;
          }
        });
        if (hasDirectives || this.directivesEndMarker)
          lines.push("---");
        if (this.commentBefore) {
          if (hasDirectives || !this.directivesEndMarker)
            lines.unshift("");
          lines.unshift(this.commentBefore.replace(/^/gm, "#"));
        }
        const ctx = {
          anchors: /* @__PURE__ */ Object.create(null),
          doc: this,
          indent: "",
          indentStep: " ".repeat(indentSize),
          stringify
          // Requiring directly in nodes would create circular dependencies
        };
        let chompKeep = false;
        let contentComment = null;
        if (this.contents) {
          if (this.contents instanceof resolveSeq.Node) {
            if (this.contents.spaceBefore && (hasDirectives || this.directivesEndMarker))
              lines.push("");
            if (this.contents.commentBefore)
              lines.push(this.contents.commentBefore.replace(/^/gm, "#"));
            ctx.forceBlockIndent = !!this.comment;
            contentComment = this.contents.comment;
          }
          const onChompKeep = contentComment ? null : () => chompKeep = true;
          const body = stringify(this.contents, ctx, () => contentComment = null, onChompKeep);
          lines.push(resolveSeq.addComment(body, "", contentComment));
        } else if (this.contents !== void 0) {
          lines.push(stringify(this.contents, ctx));
        }
        if (this.comment) {
          if ((!chompKeep || contentComment) && lines[lines.length - 1] !== "")
            lines.push("");
          lines.push(this.comment.replace(/^/gm, "#"));
        }
        return lines.join("\n") + "\n";
      }
    };
    PlainValue._defineProperty(Document, "defaults", documentOptions);
    exports2.Document = Document;
    exports2.defaultOptions = defaultOptions;
    exports2.scalarOptions = scalarOptions;
  }
});

// node_modules/aws-cdk-lib/node_modules/yaml/dist/index.js
var require_dist2 = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/yaml/dist/index.js"(exports2) {
    "use strict";
    var parseCst = require_parse_cst();
    var Document$1 = require_Document_9b4560a1();
    var Schema = require_Schema_88e323a7();
    var PlainValue = require_PlainValue_ec8e588e();
    var warnings = require_warnings_1000a372();
    require_resolveSeq_d03cb037();
    function createNode(value, wrapScalars = true, tag) {
      if (tag === void 0 && typeof wrapScalars === "string") {
        tag = wrapScalars;
        wrapScalars = true;
      }
      const options = Object.assign({}, Document$1.Document.defaults[Document$1.defaultOptions.version], Document$1.defaultOptions);
      const schema = new Schema.Schema(options);
      return schema.createNode(value, wrapScalars, tag);
    }
    var Document = class extends Document$1.Document {
      constructor(options) {
        super(Object.assign({}, Document$1.defaultOptions, options));
      }
    };
    function parseAllDocuments(src, options) {
      const stream = [];
      let prev;
      for (const cstDoc of parseCst.parse(src)) {
        const doc = new Document(options);
        doc.parse(cstDoc, prev);
        stream.push(doc);
        prev = doc;
      }
      return stream;
    }
    function parseDocument(src, options) {
      const cst = parseCst.parse(src);
      const doc = new Document(options).parse(cst[0]);
      if (cst.length > 1) {
        const errMsg = "Source contains multiple documents; please use YAML.parseAllDocuments()";
        doc.errors.unshift(new PlainValue.YAMLSemanticError(cst[1], errMsg));
      }
      return doc;
    }
    function parse(src, options) {
      const doc = parseDocument(src, options);
      doc.warnings.forEach((warning) => warnings.warn(warning));
      if (doc.errors.length > 0)
        throw doc.errors[0];
      return doc.toJSON();
    }
    function stringify(value, options) {
      const doc = new Document(options);
      doc.contents = value;
      return String(doc);
    }
    var YAML = {
      createNode,
      defaultOptions: Document$1.defaultOptions,
      Document,
      parse,
      parseAllDocuments,
      parseCST: parseCst.parse,
      parseDocument,
      scalarOptions: Document$1.scalarOptions,
      stringify
    };
    exports2.YAML = YAML;
  }
});

// node_modules/aws-cdk-lib/node_modules/yaml/index.js
var require_yaml = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/yaml/index.js"(exports2, module2) {
    "use strict";
    module2.exports = require_dist2().YAML;
  }
});

// node_modules/aws-cdk-lib/node_modules/yaml/dist/types.js
var require_types2 = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/yaml/dist/types.js"(exports2) {
    "use strict";
    var resolveSeq = require_resolveSeq_d03cb037();
    var Schema = require_Schema_88e323a7();
    require_PlainValue_ec8e588e();
    require_warnings_1000a372();
    exports2.Alias = resolveSeq.Alias;
    exports2.Collection = resolveSeq.Collection;
    exports2.Merge = resolveSeq.Merge;
    exports2.Node = resolveSeq.Node;
    exports2.Pair = resolveSeq.Pair;
    exports2.Scalar = resolveSeq.Scalar;
    exports2.YAMLMap = resolveSeq.YAMLMap;
    exports2.YAMLSeq = resolveSeq.YAMLSeq;
    exports2.binaryOptions = resolveSeq.binaryOptions;
    exports2.boolOptions = resolveSeq.boolOptions;
    exports2.intOptions = resolveSeq.intOptions;
    exports2.nullOptions = resolveSeq.nullOptions;
    exports2.strOptions = resolveSeq.strOptions;
    exports2.Schema = Schema.Schema;
  }
});

// node_modules/aws-cdk-lib/node_modules/yaml/types.js
var require_types3 = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/yaml/types.js"(exports2) {
    "use strict";
    var types = require_types2();
    exports2.binaryOptions = types.binaryOptions;
    exports2.boolOptions = types.boolOptions;
    exports2.intOptions = types.intOptions;
    exports2.nullOptions = types.nullOptions;
    exports2.strOptions = types.strOptions;
    exports2.Schema = types.Schema;
    exports2.Alias = types.Alias;
    exports2.Collection = types.Collection;
    exports2.Merge = types.Merge;
    exports2.Node = types.Node;
    exports2.Pair = types.Pair;
    exports2.Scalar = types.Scalar;
    exports2.YAMLMap = types.YAMLMap;
    exports2.YAMLSeq = types.YAMLSeq;
  }
});

// node_modules/aws-cdk-lib/core/lib/private/yaml-cfn.js
var require_yaml_cfn = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/private/yaml-cfn.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.serialize = void 0;
    var yaml = require_yaml();
    var yaml_types = require_types3();
    function serialize(obj) {
      const oldFold = yaml_types.strOptions.fold.lineWidth;
      try {
        return yaml_types.strOptions.fold.lineWidth = 0, yaml.stringify(obj, { schema: "yaml-1.1" });
      } finally {
        yaml_types.strOptions.fold.lineWidth = oldFold;
      }
    }
    exports2.serialize = serialize;
  }
});

// node_modules/aws-cdk-lib/core/lib/private/cloudformation-lang.js
var require_cloudformation_lang = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/private/cloudformation-lang.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.isNameOfCloudFormationIntrinsic = exports2.minimalCloudFormationJoin = exports2.CLOUDFORMATION_TOKEN_RESOLVER = exports2.CloudFormationLang = void 0;
    var cfn_utils_provider_1 = require_cfn_utils_provider();
    var resolve_1 = require_resolve();
    var yaml_cfn = require_yaml_cfn();
    var lazy_1 = require_lazy();
    var resolvable_1 = require_resolvable();
    var stack_1 = require_stack();
    var token_1 = require_token2();
    var type_hints_1 = require_type_hints();
    var CloudFormationLang = class {
      static toJSON(obj, space) {
        return lazy_1.Lazy.uncachedString({ produce: (ctx) => tokenAwareStringify(obj, space ?? 0, ctx) });
      }
      static toYAML(obj) {
        return lazy_1.Lazy.uncachedString({ produce: () => yaml_cfn.serialize(obj) });
      }
      static concat(left, right) {
        if (left === void 0 && right === void 0)
          return "";
        const parts = new Array();
        return left !== void 0 && parts.push(left), right !== void 0 && parts.push(right), parts.length === 1 ? parts[0] : parts.length === 2 && isConcatable(parts[0]) && isConcatable(parts[1]) ? `${parts[0]}${parts[1]}` : fnJoinConcat(parts);
      }
    };
    exports2.CloudFormationLang = CloudFormationLang;
    function fnJoinConcat(parts) {
      return { "Fn::Join": ["", minimalCloudFormationJoin("", parts)] };
    }
    function tokenAwareStringify(root, space, ctx) {
      let indent = 0;
      const ret = new Array();
      switch (recurse(ctx.resolve(root, { allowIntrinsicKeys: true })), ret.length) {
        case 0:
          return;
        case 1:
          return renderSegment(ret[0]);
        default:
          return fnJoinConcat(ret.map(renderSegment));
      }
      function recurse(obj) {
        if (obj !== void 0) {
          if (token_1.Token.isUnresolved(obj))
            throw new Error("This shouldn't happen anymore");
          if (Array.isArray(obj))
            return renderCollection("[", "]", obj, recurse);
          if (typeof obj == "object" && obj != null && !(obj instanceof Date)) {
            if (isIntrinsic(obj) && (0, resolve_1.resolvedTypeHint)(obj)) {
              renderIntrinsic(obj);
              return;
            }
            return renderCollection("{", "}", definedEntries(obj), ([key, value]) => {
              key.startsWith(resolve_1.INTRINSIC_KEY_PREFIX) && ([key, value] = value), recurse(key), pushLiteral(prettyPunctuation(":")), recurse(value);
            });
          }
          pushLiteral(JSON.stringify(obj));
        }
      }
      function renderCollection(pre, post, xs, each) {
        pushLiteral(pre), indent += space;
        let atLeastOne = false;
        for (const [comma, item] of sepIter(xs))
          comma && pushLiteral(","), pushLineBreak(), each(item), atLeastOne = true;
        indent -= space, atLeastOne && pushLineBreak(), pushLiteral(post);
      }
      function renderIntrinsic(intrinsic) {
        switch ((0, resolve_1.resolvedTypeHint)(intrinsic)) {
          case type_hints_1.ResolutionTypeHint.STRING:
            pushLiteral('"'), pushIntrinsic(deepQuoteStringLiterals(intrinsic)), pushLiteral('"');
            return;
          case type_hints_1.ResolutionTypeHint.STRING_LIST:
            const stack = stack_1.Stack.of(ctx.scope), stringifyResponse = stringifyCache.obtain(stack, JSON.stringify(intrinsic), () => cfn_utils_provider_1.CfnUtils.stringify(stack, `CdkJsonStringify${stringifyCounter++}`, intrinsic));
            pushIntrinsic(stringifyResponse);
            return;
          case type_hints_1.ResolutionTypeHint.NUMBER:
            pushIntrinsic(intrinsic);
            return;
        }
        throw new Error(`Unexpected type hint: ${(0, resolve_1.resolvedTypeHint)(intrinsic)}`);
      }
      function pushLiteral(lit) {
        let last = ret[ret.length - 1];
        last?.type !== "literal" && (last = { type: "literal", parts: [] }, ret.push(last)), last.parts.push(lit);
      }
      function pushIntrinsic(intrinsic) {
        ret.push({ type: "intrinsic", intrinsic });
      }
      function pushLineBreak() {
        space > 0 && pushLiteral(`
${" ".repeat(indent)}`);
      }
      function prettyPunctuation(punc) {
        return space > 0 ? `${punc} ` : punc;
      }
    }
    function renderSegment(s) {
      switch (s.type) {
        case "literal":
          return s.parts.join("");
        case "intrinsic":
          return s.intrinsic;
      }
    }
    var CLOUDFORMATION_CONCAT = { join(left, right) {
      return CloudFormationLang.concat(left, right);
    } };
    exports2.CLOUDFORMATION_TOKEN_RESOLVER = new resolvable_1.DefaultTokenResolver(CLOUDFORMATION_CONCAT);
    function minimalCloudFormationJoin(delimiter, values) {
      let i = 0;
      for (; i < values.length; ) {
        const el = values[i];
        isSplicableFnJoinIntrinsic(el) ? values.splice(i, 1, ...el["Fn::Join"][1]) : i > 0 && isConcatable(values[i - 1]) && isConcatable(values[i]) ? (values[i - 1] = `${values[i - 1]}${delimiter}${values[i]}`, values.splice(i, 1)) : i += 1;
      }
      return values;
      function isSplicableFnJoinIntrinsic(obj) {
        if (!isIntrinsic(obj) || Object.keys(obj)[0] !== "Fn::Join")
          return false;
        const [delim, list] = obj["Fn::Join"];
        return !(delim !== delimiter || token_1.Token.isUnresolved(list) || !Array.isArray(list));
      }
    }
    exports2.minimalCloudFormationJoin = minimalCloudFormationJoin;
    function isConcatable(obj) {
      return ["string", "number"].includes(typeof obj) && !token_1.Token.isUnresolved(obj);
    }
    function isIntrinsic(x) {
      if (Array.isArray(x) || x === null || typeof x != "object")
        return false;
      const keys = Object.keys(x);
      return keys.length !== 1 ? false : keys[0] === "Ref" || isNameOfCloudFormationIntrinsic(keys[0]);
    }
    function isNameOfCloudFormationIntrinsic(name) {
      return name.startsWith("Fn::") ? name !== "Fn::GetArtifactAtt" && name !== "Fn::GetParam" : false;
    }
    exports2.isNameOfCloudFormationIntrinsic = isNameOfCloudFormationIntrinsic;
    function* sepIter(xs) {
      let comma = false;
      for (const item of xs)
        yield [comma, item], comma = true;
    }
    function* definedEntries(xs) {
      for (const [key, value] of Object.entries(xs))
        value !== void 0 && (yield [key, value]);
    }
    function deepQuoteStringLiterals(x) {
      if (Array.isArray(x))
        return x.map(deepQuoteStringLiterals);
      if (typeof x == "object" && x != null) {
        const ret = {};
        for (const [key, value] of Object.entries(x))
          ret[deepQuoteStringLiterals(key)] = deepQuoteStringLiterals(value);
        return ret;
      }
      return typeof x == "string" ? quoteString(x) : x;
    }
    function quoteString(s) {
      return s = JSON.stringify(s), s.substring(1, s.length - 1);
    }
    var stringifyCounter = 1;
    var ScopedCache = class {
      constructor() {
        this.cache = /* @__PURE__ */ new WeakMap();
      }
      obtain(object, key, init) {
        let kvMap = this.cache.get(object);
        kvMap || (kvMap = /* @__PURE__ */ new Map(), this.cache.set(object, kvMap));
        let ret = kvMap.get(key);
        return ret === void 0 && (ret = init(), kvMap.set(key, ret)), ret;
      }
    };
    var stringifyCache = new ScopedCache();
  }
});

// node_modules/aws-cdk-lib/core/lib/cfn-fn.js
var require_cfn_fn = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/cfn-fn.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Fn = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cloudformation_lang_1 = require_cloudformation_lang();
    var intrinsic_1 = require_intrinsic();
    var reference_1 = require_reference();
    var stack_1 = require_stack();
    var stack_trace_1 = require_stack_trace2();
    var token_1 = require_token2();
    var Fn = class _Fn {
      static ref(logicalName) {
        return new FnRef(logicalName).toString();
      }
      static getAtt(logicalNameOfResource, attributeName) {
        return new FnGetAtt(logicalNameOfResource, attributeName);
      }
      static join(delimiter, listOfValues) {
        if (listOfValues.length === 0)
          throw new Error("FnJoin requires at least one value to be provided");
        return new FnJoin(delimiter, listOfValues).toString();
      }
      static split(delimiter, source, assumedLength) {
        if (!token_1.Token.isUnresolved(source))
          return source.split(delimiter);
        if (token_1.Token.isUnresolved(delimiter))
          throw new Error("Fn.split: 'delimiter' may not be a token value");
        const split = token_1.Token.asList(new FnSplit(delimiter, source));
        if (assumedLength === void 0)
          return split;
        if (token_1.Token.isUnresolved(assumedLength))
          throw new Error("Fn.split: 'assumedLength' may not be a token value");
        return range(assumedLength).map((i) => _Fn.select(i, split));
      }
      static select(index, array) {
        return !token_1.Token.isUnresolved(index) && !token_1.Token.isUnresolved(array) && !array.some(token_1.Token.isUnresolved) ? array[index] : new FnSelect(index, array).toString();
      }
      static sub(body, variables) {
        return new FnSub(body, variables).toString();
      }
      static base64(data) {
        return new FnBase64(data).toString();
      }
      static cidr(ipBlock, count, sizeMask) {
        return token_1.Token.asList(new FnCidr(ipBlock, count, sizeMask));
      }
      static parseDomainName(url) {
        const noHttps = _Fn.select(1, _Fn.split("//", url));
        return _Fn.select(0, _Fn.split("/", noHttps));
      }
      static getAzs(region) {
        return token_1.Token.asList(new FnGetAZs(region));
      }
      static importValue(sharedValueToImport) {
        return new FnImportValue(sharedValueToImport).toString();
      }
      static importListValue(sharedValueToImport, assumedLength, delimiter = ",") {
        return _Fn.split(delimiter, _Fn.importValue(sharedValueToImport), assumedLength);
      }
      static findInMap(mapName, topLevelKey, secondLevelKey) {
        return _Fn._findInMap(mapName, topLevelKey, secondLevelKey).toString();
      }
      static _findInMap(mapName, topLevelKey, secondLevelKey) {
        return new FnFindInMap(mapName, topLevelKey, secondLevelKey);
      }
      static transform(macroName, parameters) {
        return new FnTransform(macroName, parameters);
      }
      static conditionAnd(...conditions) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ICfnConditionExpression(conditions);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.conditionAnd), error;
        }
        if (conditions.length === 0)
          throw new Error("Fn.conditionAnd() needs at least one argument");
        return conditions.length === 1 ? conditions[0] : _Fn.conditionAnd(..._inGroupsOf(conditions, 10).map((group) => new FnAnd(...group)));
      }
      static conditionEquals(lhs, rhs) {
        return new FnEquals(lhs, rhs);
      }
      static conditionIf(conditionId, valueIfTrue, valueIfFalse) {
        return new FnIf(conditionId, valueIfTrue, valueIfFalse);
      }
      static conditionNot(condition) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ICfnConditionExpression(condition);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.conditionNot), error;
        }
        return new FnNot(condition);
      }
      static conditionOr(...conditions) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ICfnConditionExpression(conditions);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.conditionOr), error;
        }
        if (conditions.length === 0)
          throw new Error("Fn.conditionOr() needs at least one argument");
        return conditions.length === 1 ? conditions[0] : _Fn.conditionOr(..._inGroupsOf(conditions, 10).map((group) => new FnOr(...group)));
      }
      static conditionContains(listOfStrings, value) {
        return new FnContains(listOfStrings, value);
      }
      static conditionEachMemberEquals(listOfStrings, value) {
        return new FnEachMemberEquals(listOfStrings, value);
      }
      static conditionEachMemberIn(stringsToCheck, stringsToMatch) {
        return new FnEachMemberIn(stringsToCheck, stringsToMatch);
      }
      static refAll(parameterType) {
        return token_1.Token.asList(new FnRefAll(parameterType));
      }
      static valueOf(parameterOrLogicalId, attribute) {
        return new FnValueOf(parameterOrLogicalId, attribute).toString();
      }
      static valueOfAll(parameterType, attribute) {
        return token_1.Token.asList(new FnValueOfAll(parameterType, attribute));
      }
      static toJsonString(object) {
        return token_1.Token.isUnresolved(object) ? new FnToJsonString(object).toString() : JSON.stringify(object);
      }
      static len(array) {
        if (!token_1.Token.isUnresolved(array)) {
          if (!Array.isArray(array))
            throw new Error("Fn.length() needs an array");
          return array.length;
        }
        return token_1.Token.asNumber(new FnLength(array));
      }
      constructor() {
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Fn[_a] = { fqn: "aws-cdk-lib.Fn", version: "2.80.0" }, exports2.Fn = Fn;
    var FnBase = class extends intrinsic_1.Intrinsic {
      constructor(name, value) {
        super({ [name]: value });
      }
    };
    var FnRef = class extends FnBase {
      constructor(logicalName) {
        super("Ref", logicalName);
      }
    };
    var FnFindInMap = class extends FnBase {
      constructor(mapName, topLevelKey, secondLevelKey) {
        super("Fn::FindInMap", [mapName, topLevelKey, secondLevelKey]);
      }
    };
    var FnTransform = class extends FnBase {
      constructor(macroName, parameters) {
        super("Fn::Transform", { Name: macroName, Parameters: parameters });
      }
    };
    var FnGetAtt = class extends FnBase {
      constructor(logicalNameOfResource, attributeName) {
        super("Fn::GetAtt", [logicalNameOfResource, attributeName]);
      }
    };
    var FnGetAZs = class extends FnBase {
      constructor(region) {
        super("Fn::GetAZs", region || "");
      }
    };
    var FnImportValue = class extends FnBase {
      constructor(sharedValueToImport) {
        super("Fn::ImportValue", sharedValueToImport);
      }
    };
    var FnSelect = class extends FnBase {
      constructor(index, array) {
        super("Fn::Select", [index, array]);
      }
    };
    var FnSplit = class extends FnBase {
      constructor(delimiter, source) {
        super("Fn::Split", [delimiter, source]);
      }
    };
    var FnSub = class extends FnBase {
      constructor(body, variables) {
        super("Fn::Sub", variables ? [body, variables] : body);
      }
    };
    var FnBase64 = class extends FnBase {
      constructor(data) {
        super("Fn::Base64", data);
      }
    };
    var FnCidr = class extends FnBase {
      constructor(ipBlock, count, sizeMask) {
        if (count < 1 || count > 256)
          throw new Error(`Fn::Cidr's count attribute must be between 1 and 256, ${count} was provided.`);
        super("Fn::Cidr", [ipBlock, count, sizeMask]);
      }
    };
    var FnConditionBase = class extends intrinsic_1.Intrinsic {
      constructor(type, value) {
        super({ [type]: value }), this.disambiguator = true;
      }
    };
    var FnAnd = class extends FnConditionBase {
      constructor(...condition) {
        super("Fn::And", condition);
      }
    };
    var FnEquals = class extends FnConditionBase {
      constructor(lhs, rhs) {
        super("Fn::Equals", [lhs, rhs]);
      }
    };
    var FnIf = class extends FnConditionBase {
      constructor(condition, valueIfTrue, valueIfFalse) {
        super("Fn::If", [condition, valueIfTrue, valueIfFalse]);
      }
    };
    var FnNot = class extends FnConditionBase {
      constructor(condition) {
        super("Fn::Not", [condition]);
      }
    };
    var FnOr = class extends FnConditionBase {
      constructor(...condition) {
        super("Fn::Or", condition);
      }
    };
    var FnContains = class extends FnConditionBase {
      constructor(listOfStrings, value) {
        super("Fn::Contains", [listOfStrings, value]);
      }
    };
    var FnEachMemberEquals = class extends FnConditionBase {
      constructor(listOfStrings, value) {
        super("Fn::EachMemberEquals", [listOfStrings, value]);
      }
    };
    var FnEachMemberIn = class extends FnConditionBase {
      constructor(stringsToCheck, stringsToMatch) {
        super("Fn::EachMemberIn", [stringsToCheck, stringsToMatch]);
      }
    };
    var FnRefAll = class extends FnBase {
      constructor(parameterType) {
        super("Fn::RefAll", parameterType);
      }
    };
    var FnValueOf = class extends FnBase {
      constructor(parameterOrLogicalId, attribute) {
        super("Fn::ValueOf", [parameterOrLogicalId, attribute]);
      }
    };
    var FnValueOfAll = class extends FnBase {
      constructor(parameterType, attribute) {
        super("Fn::ValueOfAll", [parameterType, attribute]);
      }
    };
    var FnJoin = class {
      constructor(delimiter, listOfValues) {
        if (listOfValues.length === 0)
          throw new Error("FnJoin requires at least one value to be provided");
        this.delimiter = delimiter, this.listOfValues = listOfValues, this.creationStack = (0, stack_trace_1.captureStackTrace)();
      }
      resolve(context) {
        if (token_1.Token.isUnresolved(this.listOfValues))
          return { "Fn::Join": [this.delimiter, this.listOfValues] };
        const resolved = this.resolveValues(context);
        return resolved.length === 1 ? resolved[0] : { "Fn::Join": [this.delimiter, resolved] };
      }
      toString() {
        return token_1.Token.asString(this, { displayHint: "Fn::Join" });
      }
      toJSON() {
        return "<Fn::Join>";
      }
      resolveValues(context) {
        const resolvedValues = this.listOfValues.map((x) => reference_1.Reference.isReference(x) ? x : context.resolve(x));
        return (0, cloudformation_lang_1.minimalCloudFormationJoin)(this.delimiter, resolvedValues);
      }
    };
    var FnToJsonString = class {
      constructor(object) {
        this.object = object, this.creationStack = (0, stack_trace_1.captureStackTrace)();
      }
      resolve(context) {
        return stack_1.Stack.of(context.scope).addTransform("AWS::LanguageExtensions"), { "Fn::ToJsonString": this.object };
      }
      toString() {
        return token_1.Token.asString(this, { displayHint: "Fn::ToJsonString" });
      }
      toJSON() {
        return "<Fn::ToJsonString>";
      }
    };
    var FnLength = class {
      constructor(array) {
        this.array = array, this.creationStack = (0, stack_trace_1.captureStackTrace)();
      }
      resolve(context) {
        return stack_1.Stack.of(context.scope).addTransform("AWS::LanguageExtensions"), { "Fn::Length": this.array };
      }
      toString() {
        return token_1.Token.asString(this, { displayHint: "Fn::Length" });
      }
      toJSON() {
        return "<Fn::Length>";
      }
    };
    function _inGroupsOf(array, maxGroup) {
      const result = new Array();
      for (let i = 0; i < array.length; i += maxGroup)
        result.push(array.slice(i, i + maxGroup));
      return result;
    }
    function range(n) {
      const ret = [];
      for (let i = 0; i < n; i++)
        ret.push(i);
      return ret;
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/private/metadata-resource.js
var require_metadata_resource = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/private/metadata-resource.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.formatAnalytics = exports2.MetadataResource = void 0;
    var zlib = require("zlib");
    var constructs_1 = require_lib2();
    var runtime_info_1 = require_runtime_info();
    var region_info_1 = require_region_info2();
    var cfn_condition_1 = require_cfn_condition();
    var cfn_fn_1 = require_cfn_fn();
    var cfn_pseudo_1 = require_cfn_pseudo();
    var cfn_resource_1 = require_cfn_resource();
    var lazy_1 = require_lazy();
    var token_1 = require_token2();
    var MetadataResource = class extends constructs_1.Construct {
      constructor(scope, id) {
        if (super(scope, id), token_1.Token.isUnresolved(scope.region) || region_info_1.RegionInfo.get(scope.region).cdkMetadataResourceAvailable) {
          const resource = new cfn_resource_1.CfnResource(this, "Default", { type: "AWS::CDK::Metadata", properties: { Analytics: lazy_1.Lazy.string({ produce: () => formatAnalytics((0, runtime_info_1.constructInfoFromStack)(scope)) }) } });
          if (token_1.Token.isUnresolved(scope.region)) {
            const condition = new cfn_condition_1.CfnCondition(this, "Condition", { expression: makeCdkMetadataAvailableCondition() });
            condition.overrideLogicalId("CDKMetadataAvailable"), resource.cfnOptions.condition = condition;
          }
        }
      }
    };
    exports2.MetadataResource = MetadataResource;
    function makeCdkMetadataAvailableCondition() {
      return cfn_fn_1.Fn.conditionOr(...region_info_1.RegionInfo.regions.filter((ri) => ri.cdkMetadataResourceAvailable).map((ri) => cfn_fn_1.Fn.conditionEquals(cfn_pseudo_1.Aws.REGION, ri.name)));
    }
    var Trie = class extends Map {
    };
    function formatAnalytics(infos) {
      const trie = new Trie();
      infos.forEach((info) => insertFqnInTrie(`${info.version}!${info.fqn}`, trie));
      const plaintextEncodedConstructs = prefixEncodeTrie(trie), compressedConstructsBuffer = zlib.gzipSync(Buffer.from(plaintextEncodedConstructs));
      return setGzipOperatingSystemToUnknown(compressedConstructsBuffer), `v2:deflate64:${compressedConstructsBuffer.toString("base64")}`;
    }
    exports2.formatAnalytics = formatAnalytics;
    function insertFqnInTrie(fqn, trie) {
      for (const fqnPart of fqn.replace(/[^a-z0-9]/gi, "$& ").split(" ")) {
        const nextLevelTreeRef = trie.get(fqnPart) ?? new Trie();
        trie.set(fqnPart, nextLevelTreeRef), trie = nextLevelTreeRef;
      }
      return trie;
    }
    function prefixEncodeTrie(trie) {
      let prefixEncoded = "", isFirstEntryAtLevel = true;
      return [...trie.entries()].forEach(([key, value]) => {
        isFirstEntryAtLevel || (prefixEncoded += ","), isFirstEntryAtLevel = false, prefixEncoded += key, value.size > 1 ? (prefixEncoded += "{", prefixEncoded += prefixEncodeTrie(value), prefixEncoded += "}") : prefixEncoded += prefixEncodeTrie(value);
      }), prefixEncoded;
    }
    function setGzipOperatingSystemToUnknown(gzipBuffer) {
      if (gzipBuffer[0] !== 31 || gzipBuffer[1] !== 139)
        throw new Error("Expecting a gzip buffer (must start with 0x1f8b)");
      gzipBuffer[9] = 255;
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/cfn-output.js
var require_cfn_output = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/cfn-output.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnOutput = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cfn_element_1 = require_cfn_element();
    var CfnOutput = class _CfnOutput extends cfn_element_1.CfnElement {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnOutputProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnOutput), error;
        }
        if (props.value === void 0)
          throw new Error(`Missing value for CloudFormation output at path "${this.node.path}"`);
        if (Array.isArray(props.value))
          throw new Error(`CloudFormation output was given a string list instead of a string at path "${this.node.path}"`);
        this._description = props.description, this._value = props.value, this._condition = props.condition, this._exportName = props.exportName, this.node.addValidation({ validate: () => this.validateOutput() });
      }
      get description() {
        return this._description;
      }
      set description(description) {
        this._description = description;
      }
      get value() {
        return this._value;
      }
      set value(value) {
        this._value = value;
      }
      get condition() {
        return this._condition;
      }
      set condition(condition) {
        this._condition = condition;
      }
      get exportName() {
        return this._exportName;
      }
      set exportName(exportName) {
        this._exportName = exportName;
      }
      get importValue() {
        return cfn_fn_1.Fn.importValue(lazy_1.Lazy.uncachedString({ produce: (ctx) => {
          if (stack_1.Stack.of(ctx.scope) === this.stack)
            throw new Error(`'importValue' property of '${this.node.path}' should only be used in a different Stack`);
          if (!this._exportName)
            throw new Error(`Add an exportName to the CfnOutput at '${this.node.path}' in order to use 'output.importValue'`);
          return this._exportName;
        } }));
      }
      _toCloudFormation() {
        return { Outputs: { [this.logicalId]: { Description: this._description, Value: this._value, Export: this._exportName != null ? { Name: this._exportName } : void 0, Condition: this._condition ? this._condition.logicalId : void 0 } } };
      }
      validateOutput() {
        return this._exportName && !token_1.Token.isUnresolved(this._exportName) && this._exportName.length > 255 ? [`Export name cannot exceed 255 characters (got ${this._exportName.length} characters)`] : [];
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnOutput[_a] = { fqn: "aws-cdk-lib.CfnOutput", version: "2.80.0" }, exports2.CfnOutput = CfnOutput;
    var cfn_fn_1 = require_cfn_fn();
    var lazy_1 = require_lazy();
    var stack_1 = require_stack();
    var token_1 = require_token2();
  }
});

// node_modules/aws-cdk-lib/core/lib/cfn-parameter.js
var require_cfn_parameter = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/cfn-parameter.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnParameter = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cfn_element_1 = require_cfn_element();
    var cfn_reference_1 = require_cfn_reference();
    var token_1 = require_token2();
    var type_hints_1 = require_type_hints();
    var CfnParameter = class _CfnParameter extends cfn_element_1.CfnElement {
      constructor(scope, id, props = {}) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnParameterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnParameter), error;
        }
        this._type = props.type || "String", this._default = props.default, this._allowedPattern = props.allowedPattern, this._allowedValues = props.allowedValues, this._constraintDescription = props.constraintDescription, this._description = props.description, this._maxLength = props.maxLength, this._maxValue = props.maxValue, this._minLength = props.minLength, this._minValue = props.minValue, this._noEcho = props.noEcho, this.typeHint = typeToTypeHint(this._type);
      }
      get type() {
        return this._type;
      }
      set type(type) {
        this._type = type, this.typeHint = typeToTypeHint(this._type);
      }
      get default() {
        return this._default;
      }
      set default(value) {
        this._default = value;
      }
      get allowedPattern() {
        return this._allowedPattern;
      }
      set allowedPattern(pattern) {
        this._allowedPattern = pattern;
      }
      get allowedValues() {
        return this._allowedValues;
      }
      set allowedValues(values) {
        this._allowedValues = values;
      }
      get constraintDescription() {
        return this._constraintDescription;
      }
      set constraintDescription(desc) {
        this._constraintDescription = desc;
      }
      get description() {
        return this._description;
      }
      set description(desc) {
        this._description = desc;
      }
      get maxLength() {
        return this._maxLength;
      }
      set maxLength(len) {
        this._maxLength = len;
      }
      get minLength() {
        return this._minLength;
      }
      set minLength(len) {
        this._minLength = len;
      }
      get maxValue() {
        return this._maxValue;
      }
      set maxValue(len) {
        this._maxValue = len;
      }
      get minValue() {
        return this._minValue;
      }
      set minValue(len) {
        this._minValue = len;
      }
      get noEcho() {
        return !!this._noEcho;
      }
      set noEcho(echo) {
        this._noEcho = echo;
      }
      get value() {
        return cfn_reference_1.CfnReference.for(this, "Ref", void 0, this.typeHint);
      }
      get valueAsString() {
        if (!isStringType(this.type) && !isNumberType(this.type))
          throw new Error(`Parameter type (${this.type}) is not a string or number type`);
        return token_1.Token.asString(this.value);
      }
      get valueAsList() {
        if (!isListType(this.type))
          throw new Error(`Parameter type (${this.type}) is not a string list type`);
        return token_1.Token.asList(this.value);
      }
      get valueAsNumber() {
        if (!isNumberType(this.type))
          throw new Error(`Parameter type (${this.type}) is not a number type`);
        return token_1.Token.asNumber(this.value);
      }
      _toCloudFormation() {
        return { Parameters: { [this.logicalId]: { Type: this.type, Default: this.default, AllowedPattern: this.allowedPattern, AllowedValues: this.allowedValues, ConstraintDescription: this.constraintDescription, Description: this.description, MaxLength: this.maxLength, MaxValue: this.maxValue, MinLength: this.minLength, MinValue: this.minValue, NoEcho: this._noEcho } } };
      }
      resolve(_context) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_IResolveContext(_context);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.resolve), error;
        }
        return this.value;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnParameter[_a] = { fqn: "aws-cdk-lib.CfnParameter", version: "2.80.0" }, exports2.CfnParameter = CfnParameter;
    function isListType(type) {
      return type.indexOf("List<") >= 0 || type.indexOf("CommaDelimitedList") >= 0;
    }
    function isNumberType(type) {
      return type === "Number";
    }
    function isStringType(type) {
      return !isListType(type) && !isNumberType(type);
    }
    function typeToTypeHint(type) {
      return isListType(type) ? type_hints_1.ResolutionTypeHint.STRING_LIST : isNumberType(type) ? type_hints_1.ResolutionTypeHint.NUMBER : type_hints_1.ResolutionTypeHint.STRING;
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/custom-resource-provider/cross-region-export-providers/types.js
var require_types4 = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/custom-resource-provider/cross-region-export-providers/types.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SSM_EXPORT_PATH_PREFIX = void 0, exports2.SSM_EXPORT_PATH_PREFIX = "cdk/exports/";
  }
});

// node_modules/aws-cdk-lib/core/lib/custom-resource-provider/cross-region-export-providers/export-reader-provider.js
var require_export_reader_provider = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/custom-resource-provider/cross-region-export-providers/export-reader-provider.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ExportReader = void 0;
    var path = require("path");
    var constructs_1 = require_lib2();
    var types_1 = require_types4();
    var cfn_resource_1 = require_cfn_resource();
    var custom_resource_1 = require_custom_resource();
    var lazy_1 = require_lazy();
    var stack_1 = require_stack();
    var custom_resource_provider_1 = require_custom_resource_provider();
    var ExportReader = class _ExportReader extends constructs_1.Construct {
      static getOrCreate(scope, uniqueId, _props = {}) {
        const stack = stack_1.Stack.of(scope), existing = stack.node.tryFindChild(uniqueId);
        return existing || new _ExportReader(stack, uniqueId);
      }
      constructor(scope, id, _props = {}) {
        super(scope, id), this.importParameters = {};
        const stack = stack_1.Stack.of(this), resourceType = "Custom::CrossRegionExportReader", serviceToken = custom_resource_provider_1.CustomResourceProvider.getOrCreate(this, resourceType, { codeDirectory: path.join(__dirname, "cross-region-ssm-reader-handler"), runtime: (0, custom_resource_provider_1.builtInCustomResourceProviderNodeRuntime)(this), policyStatements: [{ Effect: "Allow", Resource: stack.formatArn({ service: "ssm", resource: "parameter", resourceName: `${types_1.SSM_EXPORT_PATH_PREFIX}${stack.stackName}/*` }), Action: ["ssm:AddTagsToResource", "ssm:RemoveTagsFromResource", "ssm:GetParameters"] }] }), properties = { region: stack.region, prefix: stack.stackName, imports: lazy_1.Lazy.any({ produce: () => this.importParameters }) };
        this.customResource = new custom_resource_1.CustomResource(this, "Resource", { resourceType, serviceToken, properties: { ReaderProps: properties } });
      }
      addDependency(resource) {
        const customResource = this.customResource.node.tryFindChild("Default");
        customResource && cfn_resource_1.CfnResource.isCfnResource(customResource) && customResource.addDependsOn(resource);
      }
      importValue(name, value) {
        return this.importParameters[name] = value.toString(), this.customResource.getAtt(name);
      }
    };
    exports2.ExportReader = ExportReader;
  }
});

// node_modules/aws-cdk-lib/core/lib/cfn-dynamic-reference.js
var require_cfn_dynamic_reference = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/cfn-dynamic-reference.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnDynamicReferenceService = exports2.CfnDynamicReference = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var intrinsic_1 = require_intrinsic();
    var CfnDynamicReference = class _CfnDynamicReference extends intrinsic_1.Intrinsic {
      constructor(service, key) {
        super("{{resolve:" + service + ":" + key + "}}");
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnDynamicReferenceService(service);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDynamicReference), error;
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnDynamicReference[_a] = { fqn: "aws-cdk-lib.CfnDynamicReference", version: "2.80.0" }, exports2.CfnDynamicReference = CfnDynamicReference;
    var CfnDynamicReferenceService;
    (function(CfnDynamicReferenceService2) {
      CfnDynamicReferenceService2.SSM = "ssm", CfnDynamicReferenceService2.SSM_SECURE = "ssm-secure", CfnDynamicReferenceService2.SECRETS_MANAGER = "secretsmanager";
    })(CfnDynamicReferenceService = exports2.CfnDynamicReferenceService || (exports2.CfnDynamicReferenceService = {}));
  }
});

// node_modules/aws-cdk-lib/core/lib/custom-resource-provider/cross-region-export-providers/export-writer-provider.js
var require_export_writer_provider = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/custom-resource-provider/cross-region-export-providers/export-writer-provider.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ExportWriter = void 0;
    var path = require("path");
    var constructs_1 = require_lib2();
    var export_reader_provider_1 = require_export_reader_provider();
    var types_1 = require_types4();
    var cfn_dynamic_reference_1 = require_cfn_dynamic_reference();
    var custom_resource_1 = require_custom_resource();
    var lazy_1 = require_lazy();
    var uniqueid_1 = require_uniqueid2();
    var stack_1 = require_stack();
    var token_1 = require_token2();
    var custom_resource_provider_1 = require_custom_resource_provider();
    var CRProvider = class _CRProvider extends custom_resource_provider_1.CustomResourceProvider {
      static getOrCreateProvider(scope, uniqueid, props) {
        const id = `${uniqueid}CustomResourceProvider`, stack = stack_1.Stack.of(scope);
        return stack.node.tryFindChild(id) ?? new _CRProvider(stack, id, props);
      }
      constructor(scope, id, props) {
        super(scope, id, props), this.resourceArns = /* @__PURE__ */ new Set(), this.addToRolePolicy({ Effect: "Allow", Resource: lazy_1.Lazy.list({ produce: () => Array.from(this.resourceArns) }), Action: ["ssm:DeleteParameters", "ssm:ListTagsForResource", "ssm:GetParameters", "ssm:PutParameter"] });
      }
      addResourceArn(arn) {
        this.resourceArns.add(arn);
      }
    };
    var ExportWriter = class _ExportWriter extends constructs_1.Construct {
      static getOrCreate(scope, uniqueId, props) {
        const stack = stack_1.Stack.of(scope), existing = stack.node.tryFindChild(uniqueId);
        return existing || new _ExportWriter(stack, uniqueId, { region: props.region });
      }
      constructor(scope, id, props) {
        super(scope, id), this._references = {};
        const stack = stack_1.Stack.of(this), region = props.region ?? stack.region, resourceType = "Custom::CrossRegionExportWriter";
        this.provider = CRProvider.getOrCreateProvider(this, resourceType, { codeDirectory: path.join(__dirname, "cross-region-ssm-writer-handler"), runtime: (0, custom_resource_provider_1.builtInCustomResourceProviderNodeRuntime)(this) }), this.addRegionToPolicy(region);
        const properties = { region, exports: lazy_1.Lazy.any({ produce: () => this._references }) };
        new custom_resource_1.CustomResource(this, "Resource", { resourceType, serviceToken: this.provider.serviceToken, properties: { WriterProps: properties } });
      }
      exportValue(exportName, reference, importStack) {
        const stack = stack_1.Stack.of(this), parameterName = `/${types_1.SSM_EXPORT_PATH_PREFIX}${exportName}`, ref = new cfn_dynamic_reference_1.CfnDynamicReference(cfn_dynamic_reference_1.CfnDynamicReferenceService.SSM, parameterName);
        return this._references[parameterName] = stack.resolve(reference.toString()), this.addToExportReader(parameterName, ref, importStack);
      }
      addRegionToPolicy(region) {
        token_1.Token.isUnresolved(region) || this.provider.addResourceArn(stack_1.Stack.of(this).formatArn({ service: "ssm", resource: "parameter", region, resourceName: `${types_1.SSM_EXPORT_PATH_PREFIX}*` }));
      }
      addToExportReader(exportName, exportValueRef, importStack) {
        const readerConstructName = (0, uniqueid_1.makeUniqueId)(["ExportsReader"]), exportReader = export_reader_provider_1.ExportReader.getOrCreate(importStack.nestedStackParent ?? importStack, readerConstructName);
        return this.addRegionToPolicy(importStack.region), exportReader.importValue(exportName, exportValueRef);
      }
    };
    exports2.ExportWriter = ExportWriter;
  }
});

// node_modules/aws-cdk-lib/core/lib/private/refs.js
var require_refs = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/private/refs.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.referenceNestedStackValueInParent = exports2.getExportable = exports2.resolveReferences = void 0;
    var cfn_reference_1 = require_cfn_reference();
    var resolve_1 = require_resolve();
    var uniqueid_1 = require_uniqueid2();
    var cxapi = require_cx_api();
    var cfn_element_1 = require_cfn_element();
    var cfn_output_1 = require_cfn_output();
    var cfn_parameter_1 = require_cfn_parameter();
    var export_writer_provider_1 = require_export_writer_provider();
    var names_1 = require_names();
    var stack_1 = require_stack();
    var token_1 = require_token2();
    var type_hints_1 = require_type_hints();
    function resolveReferences(scope) {
      const edges = findAllReferences(scope);
      for (const { source, value } of edges) {
        const consumer = stack_1.Stack.of(source);
        if (!value.hasValueForStack(consumer)) {
          const resolved = resolveValue(consumer, value);
          value.assignValueForStack(consumer, resolved);
        }
      }
    }
    exports2.resolveReferences = resolveReferences;
    function resolveValue(consumer, reference) {
      const producer = stack_1.Stack.of(reference.target), producerAccount = token_1.Token.isUnresolved(producer.account) ? cxapi.UNKNOWN_ACCOUNT : producer.account, producerRegion = token_1.Token.isUnresolved(producer.region) ? cxapi.UNKNOWN_REGION : producer.region, consumerAccount = token_1.Token.isUnresolved(consumer.account) ? cxapi.UNKNOWN_ACCOUNT : consumer.account, consumerRegion = token_1.Token.isUnresolved(consumer.region) ? cxapi.UNKNOWN_REGION : consumer.region;
      if (producer === consumer)
        return reference;
      if (producer.node.root !== consumer.node.root)
        throw new Error("Cannot reference across apps. Consuming and producing stacks must be defined within the same CDK app.");
      if (producerAccount !== consumerAccount)
        throw new Error(`Stack "${consumer.node.path}" cannot reference ${renderReference(reference)} in stack "${producer.node.path}". Cross stack references are only supported for stacks deployed to the same account or between nested stacks and their parent stack`);
      if (producerRegion !== consumerRegion && !consumer._crossRegionReferences)
        throw new Error(`Stack "${consumer.node.path}" cannot reference ${renderReference(reference)} in stack "${producer.node.path}". Cross stack references are only supported for stacks deployed to the same environment or between nested stacks and their parent stack. Set crossRegionReferences=true to enable cross region references`);
      if (consumer.nestedStackParent && isNested(consumer, producer)) {
        const parameterValue = resolveValue(consumer.nestedStackParent, reference);
        return createNestedStackParameter(consumer, reference, parameterValue);
      }
      if (producer.nested) {
        const outputValue = createNestedStackOutput(producer, reference);
        return resolveValue(consumer, outputValue);
      }
      if (producerRegion !== consumerRegion && consumer._crossRegionReferences) {
        if (producerRegion === cxapi.UNKNOWN_REGION || consumerRegion === cxapi.UNKNOWN_REGION)
          throw new Error(`Stack "${consumer.node.path}" cannot reference ${renderReference(reference)} in stack "${producer.node.path}". Cross stack/region references are only supported for stacks with an explicit region defined. `);
        return consumer.addDependency(producer, `${consumer.node.path} -> ${reference.target.node.path}.${reference.displayName}`), createCrossRegionImportValue(reference, consumer);
      }
      return consumer.addDependency(producer, `${consumer.node.path} -> ${reference.target.node.path}.${reference.displayName}`), createImportValue(reference);
    }
    function renderReference(ref) {
      return `{${ref.target.node.path}[${ref.displayName}]}`;
    }
    function findAllReferences(root) {
      const result = new Array();
      for (const consumer of root.node.findAll())
        if (cfn_element_1.CfnElement.isCfnElement(consumer))
          try {
            const tokens = (0, resolve_1.findTokens)(consumer, () => consumer._toCloudFormation());
            for (const token of tokens)
              cfn_reference_1.CfnReference.isCfnReference(token) && result.push({ source: consumer, value: token });
          } catch (e) {
            if (e.type === "CfnSynthesisError")
              continue;
            throw e;
          }
      return result;
    }
    function createImportValue(reference) {
      const exportingStack = stack_1.Stack.of(reference.target);
      let importExpr;
      return reference.typeHint === type_hints_1.ResolutionTypeHint.STRING_LIST ? (importExpr = exportingStack.exportStringListValue(reference), token_1.Tokenization.reverseList(importExpr)) : (importExpr = exportingStack.exportValue(reference), token_1.Tokenization.reverseCompleteString(importExpr));
    }
    function createCrossRegionImportValue(reference, importStack) {
      const referenceStack = stack_1.Stack.of(reference.target), exportingStack = referenceStack.nestedStackParent ?? referenceStack, exportable = getExportable(exportingStack, reference), id = JSON.stringify(exportingStack.resolve(exportable)), exportName = generateExportName(importStack, reference, id);
      if (token_1.Token.isUnresolved(exportName))
        throw new Error(`unresolved token in generated export name: ${JSON.stringify(exportingStack.resolve(exportName))}`);
      const writerConstructName = (0, uniqueid_1.makeUniqueId)(["ExportsWriter", importStack.region]), exported = export_writer_provider_1.ExportWriter.getOrCreate(exportingStack, writerConstructName, { region: importStack.region }).exportValue(exportName, reference, importStack);
      return importStack.nestedStackParent ? createNestedStackParameter(importStack, exported, exported) : exported;
    }
    function generateExportName(importStack, reference, id) {
      const referenceStack = stack_1.Stack.of(reference.target), components = [referenceStack.stackName ?? "", referenceStack.region, id], prefix = `${importStack.nestedStackParent?.stackName ?? importStack.stackName}/`, localPart = (0, uniqueid_1.makeUniqueId)(components), maxLength = 900;
      return prefix + localPart.slice(Math.max(0, localPart.length - maxLength + prefix.length));
    }
    function getExportable(stack, reference) {
      return cfn_element_1.CfnElement.isCfnElement(reference.target) && reference.target._lockLogicalId(), referenceNestedStackValueInParent(reference, stack);
    }
    exports2.getExportable = getExportable;
    function createNestedStackParameter(nested, reference, value) {
      const paramId = generateUniqueId(nested, reference, "reference-to-");
      let param = nested.node.tryFindChild(paramId);
      if (!param) {
        if (param = new cfn_parameter_1.CfnParameter(nested, paramId, { type: "String" }), !("setParameter" in nested))
          throw new Error('assertion failed: nested stack should have a "setParameter" method');
        nested.setParameter(param.logicalId, token_1.Token.asString(value));
      }
      return param.value;
    }
    function createNestedStackOutput(producer, reference) {
      const outputId = generateUniqueId(producer, reference);
      let output = producer.node.tryFindChild(outputId);
      if (output || (output = new cfn_output_1.CfnOutput(producer, outputId, { value: token_1.Token.asString(reference) })), !producer.nestedStackResource)
        throw new Error("assertion failed");
      return producer.nestedStackResource.getAtt(`Outputs.${output.logicalId}`);
    }
    function referenceNestedStackValueInParent(reference, targetStack) {
      let currentStack = stack_1.Stack.of(reference.target);
      if (currentStack !== targetStack && !isNested(currentStack, targetStack))
        throw new Error(`Referenced resource must be in stack '${targetStack.node.path}', got '${reference.target.node.path}'`);
      for (; currentStack !== targetStack; )
        reference = createNestedStackOutput(stack_1.Stack.of(reference.target), reference), currentStack = stack_1.Stack.of(reference.target);
      return reference;
    }
    exports2.referenceNestedStackValueInParent = referenceNestedStackValueInParent;
    function isNested(nested, parent) {
      return nested.nestedStackParent === parent ? true : nested.nestedStackParent ? isNested(nested.nestedStackParent, parent) : false;
    }
    function generateUniqueId(stack, ref, prefix = "") {
      return stack.resolve(`${prefix}${names_1.Names.nodeUniqueId(ref.target.node)}${ref.displayName}`);
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/private/prepare-app.js
var require_prepare_app = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/private/prepare-app.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.prepareApp = void 0;
    var constructs_1 = require_lib2();
    var refs_1 = require_refs();
    var cfn_resource_1 = require_cfn_resource();
    var stack_1 = require_stack();
    var stage_1 = require_stage();
    function prepareApp(root) {
      for (const dependency of findTransitiveDeps(root)) {
        const targetCfnResources = findCfnResources(dependency.target), sourceCfnResources = findCfnResources(dependency.source);
        for (const target of targetCfnResources)
          for (const source of sourceCfnResources)
            source.addDependency(target);
      }
      (0, refs_1.resolveReferences)(root);
      const queue = findAllNestedStacks(root);
      if (queue.length > 0) {
        for (; queue.length > 0; ) {
          const nested = queue.shift();
          defineNestedStackAsset(nested);
        }
        (0, refs_1.resolveReferences)(root);
      }
    }
    exports2.prepareApp = prepareApp;
    function defineNestedStackAsset(nestedStack) {
      nestedStack._prepareTemplateAsset();
    }
    function findAllNestedStacks(root) {
      const result = new Array(), includeStack = (stack) => !stack_1.Stack.isStack(stack) || !stack.nested ? false : stage_1.Stage.of(stack) ? stage_1.Stage.of(stack) === root : true;
      for (const stack of root.node.findAll(constructs_1.ConstructOrder.POSTORDER))
        includeStack(stack) && result.push(stack);
      return result;
    }
    function findCfnResources(root) {
      return root.node.findAll().filter(cfn_resource_1.CfnResource.isCfnResource);
    }
    function findTransitiveDeps(root) {
      const found = /* @__PURE__ */ new Map(), ret = new Array();
      for (const source of root.node.findAll())
        for (const dependable of source.node.dependencies)
          for (const target of constructs_1.Dependable.of(dependable).dependencyRoots) {
            let foundTargets = found.get(source);
            foundTargets || found.set(source, foundTargets = /* @__PURE__ */ new Set()), foundTargets.has(target) || (ret.push({ source, target }), foundTargets.add(target));
          }
      return ret;
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/tree.js
var require_tree = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/tree.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.TreeInspector = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var TreeInspector = class {
      constructor() {
        this.attributes = {};
      }
      addAttribute(key, value) {
        this.attributes[key] = value;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, TreeInspector[_a] = { fqn: "aws-cdk-lib.TreeInspector", version: "2.80.0" }, exports2.TreeInspector = TreeInspector;
  }
});

// node_modules/aws-cdk-lib/core/lib/private/tree-metadata.js
var require_tree_metadata = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/private/tree-metadata.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.TreeMetadata = void 0;
    var fs = require("fs");
    var path = require("path");
    var constructs_1 = require_lib2();
    var runtime_info_1 = require_runtime_info();
    var cloud_assembly_schema_1 = require_cloud_assembly_schema2();
    var annotations_1 = require_annotations();
    var stack_1 = require_stack();
    var tree_1 = require_tree();
    var FILE_PATH = "tree.json";
    var TreeMetadata = class extends constructs_1.Construct {
      constructor(scope) {
        super(scope, "Tree");
      }
      _synthesizeTree(session) {
        const lookup = {}, visit = (construct) => {
          const childrenMap = construct.node.children.map((c) => {
            try {
              return visit(c);
            } catch (e) {
              annotations_1.Annotations.of(this).addWarning(`Failed to render tree metadata for node [${c.node.id}]. Reason: ${e}`);
              return;
            }
          }).filter((child) => child !== void 0).reduce((map, child) => Object.assign(map, { [child.id]: child }), {}), parent = construct.node.scope, node = { id: construct.node.id || "App", path: construct.node.path, parent: parent && parent.node.path ? { id: parent.node.id, path: parent.node.path, constructInfo: (0, runtime_info_1.constructInfoFromConstruct)(parent) } : void 0, children: Object.keys(childrenMap).length === 0 ? void 0 : childrenMap, attributes: this.synthAttributes(construct), constructInfo: (0, runtime_info_1.constructInfoFromConstruct)(construct) };
          return lookup[node.path] = node, node;
        }, tree = { version: "tree-0.1", tree: visit(this.node.root) };
        this._tree = lookup;
        const builder = session.assembly;
        fs.writeFileSync(path.join(builder.outdir, FILE_PATH), JSON.stringify(tree, (key, value) => {
          if (key !== "parent")
            return value;
        }, 2), { encoding: "utf-8" }), builder.addArtifact("Tree", { type: cloud_assembly_schema_1.ArtifactType.CDK_TREE, properties: { file: FILE_PATH } });
      }
      getNodeWithParents(node) {
        if (!this._tree)
          throw new Error(`attempting to get node branch for ${node.path}, but the tree has not been created yet!`);
        let tree = node;
        return node.parent && (tree = { ...node, parent: this.getNodeWithParents(this._tree[node.parent.path]) }), tree;
      }
      renderTreeWithChildren(node, child) {
        return node.parent ? this.renderTreeWithChildren(node.parent, node) : child ? { ...node, children: { [child.id]: child } } : node;
      }
      _getNodeBranch(constructPath) {
        if (!this._tree)
          throw new Error(`attempting to get node branch for ${constructPath}, but the tree has not been created yet!`);
        const tree = this._tree[constructPath], treeWithParents = this.getNodeWithParents(tree);
        return this.renderTreeWithChildren(treeWithParents);
      }
      synthAttributes(construct) {
        function canInspect(inspectable) {
          return inspectable.inspect !== void 0;
        }
        const inspector = new tree_1.TreeInspector();
        if (canInspect(construct))
          return construct.inspect(inspector), stack_1.Stack.of(construct).resolve(inspector.attributes);
      }
    };
    exports2.TreeMetadata = TreeMetadata;
  }
});

// node_modules/aws-cdk-lib/core/lib/validation/private/construct-tree.js
var require_construct_tree = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/validation/private/construct-tree.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ConstructTree = void 0;
    var app_1 = require_app2();
    var cfn_resource_1 = require_cfn_resource();
    var stack_1 = require_stack();
    var ConstructTree = class {
      constructor(root) {
        this.root = root, this._traceCache = /* @__PURE__ */ new Map(), this._constructByPath = /* @__PURE__ */ new Map(), this._constructByTemplatePathAndLogicalId = /* @__PURE__ */ new Map(), app_1.App.isApp(this.root) ? this.treeMetadata = this.root.node.tryFindChild("Tree") : this.treeMetadata = app_1.App.of(this.root)?.node.tryFindChild("Tree"), this._constructByPath.set(this.root.node.path, root), this.root.node.findAll().forEach((child) => {
          this._constructByPath.set(child.node.path, child);
          const defaultChild = child.node.defaultChild;
          if (defaultChild && cfn_resource_1.CfnResource.isCfnResource(defaultChild)) {
            const stack = stack_1.Stack.of(defaultChild), logicalId = stack.resolve(defaultChild.logicalId);
            this.setLogicalId(stack, logicalId, child);
          }
        }), this.root.node.findAll().forEach((child) => {
          if (cfn_resource_1.CfnResource.isCfnResource(child)) {
            const stack = stack_1.Stack.of(child), logicalId = stack_1.Stack.of(child).resolve(child.logicalId);
            this.setLogicalId(stack, logicalId, child);
          }
        });
      }
      setLogicalId(stack, logicalId, child) {
        this._constructByTemplatePathAndLogicalId.has(stack.templateFile) ? this._constructByTemplatePathAndLogicalId.get(stack.templateFile)?.set(logicalId, child) : this._constructByTemplatePathAndLogicalId.set(stack.templateFile, /* @__PURE__ */ new Map([[logicalId, child]]));
      }
      getTraceMetadata(size, node) {
        if (node) {
          const construct = this.getConstructByPath(node.path);
          if (construct) {
            let trace;
            return cfn_resource_1.CfnResource.isCfnResource(construct) ? trace = construct.node.metadata.find((meta) => !!meta.trace)?.trace ?? [] : trace = construct.node.defaultChild?.node.metadata.find((meta) => !!meta.trace)?.trace ?? [], Object.create(trace.slice(0, size));
          }
        }
        return [];
      }
      getNodeWithTrace(node) {
        return node.children ? this.getNodeWithTrace(this.getChild(node.children)) : node;
      }
      getTrace(node, locations) {
        const trace = this._traceCache.get(node.path);
        if (trace)
          return trace;
        const size = this.nodeSize(node), nodeWithTrace = this.getNodeWithTrace(node), metadata = locations ?? this.getTraceMetadata(size, nodeWithTrace), thisLocation = metadata.pop(), constructTrace = { id: node.id, path: node.path, child: node.children ? this.getTrace(this.getChild(node.children), metadata) : void 0, construct: node.constructInfo?.fqn, libraryVersion: node.constructInfo?.version, location: thisLocation ?? "Run with '--debug' to include location info" };
        return this._traceCache.set(constructTrace.path, constructTrace), constructTrace;
      }
      getChild(children2) {
        return Object.values(children2)[0];
      }
      nodeSize(node) {
        let size = 1;
        if (!node.children)
          return size;
        let children2 = this.getChild(node.children);
        do
          size++, children2 = children2.children ? this.getChild(children2.children) : void 0;
        while (children2);
        return size;
      }
      getTreeNode(path) {
        return this.treeMetadata._getNodeBranch(path);
      }
      getConstructByPath(path) {
        return this._constructByPath.get(path);
      }
      getConstructByLogicalId(templateFile, logicalId) {
        return this._constructByTemplatePathAndLogicalId.get(templateFile)?.get(logicalId);
      }
    };
    exports2.ConstructTree = ConstructTree;
  }
});

// node_modules/aws-cdk-lib/node_modules/ansi-regex/index.js
var require_ansi_regex = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/ansi-regex/index.js"(exports2, module2) {
    "use strict";
    module2.exports = ({ onlyFirst = false } = {}) => {
      const pattern = [
        "[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)",
        "(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-ntqry=><~]))"
      ].join("|");
      return new RegExp(pattern, onlyFirst ? void 0 : "g");
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/strip-ansi/index.js
var require_strip_ansi = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/strip-ansi/index.js"(exports2, module2) {
    "use strict";
    var ansiRegex = require_ansi_regex();
    module2.exports = (string) => typeof string === "string" ? string.replace(ansiRegex(), "") : string;
  }
});

// node_modules/aws-cdk-lib/node_modules/is-fullwidth-code-point/index.js
var require_is_fullwidth_code_point = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/is-fullwidth-code-point/index.js"(exports2, module2) {
    "use strict";
    var isFullwidthCodePoint = (codePoint) => {
      if (Number.isNaN(codePoint)) {
        return false;
      }
      if (codePoint >= 4352 && (codePoint <= 4447 || // Hangul Jamo
      codePoint === 9001 || // LEFT-POINTING ANGLE BRACKET
      codePoint === 9002 || // RIGHT-POINTING ANGLE BRACKET
      // CJK Radicals Supplement .. Enclosed CJK Letters and Months
      11904 <= codePoint && codePoint <= 12871 && codePoint !== 12351 || // Enclosed CJK Letters and Months .. CJK Unified Ideographs Extension A
      12880 <= codePoint && codePoint <= 19903 || // CJK Unified Ideographs .. Yi Radicals
      19968 <= codePoint && codePoint <= 42182 || // Hangul Jamo Extended-A
      43360 <= codePoint && codePoint <= 43388 || // Hangul Syllables
      44032 <= codePoint && codePoint <= 55203 || // CJK Compatibility Ideographs
      63744 <= codePoint && codePoint <= 64255 || // Vertical Forms
      65040 <= codePoint && codePoint <= 65049 || // CJK Compatibility Forms .. Small Form Variants
      65072 <= codePoint && codePoint <= 65131 || // Halfwidth and Fullwidth Forms
      65281 <= codePoint && codePoint <= 65376 || 65504 <= codePoint && codePoint <= 65510 || // Kana Supplement
      110592 <= codePoint && codePoint <= 110593 || // Enclosed Ideographic Supplement
      127488 <= codePoint && codePoint <= 127569 || // CJK Unified Ideographs Extension B .. Tertiary Ideographic Plane
      131072 <= codePoint && codePoint <= 262141)) {
        return true;
      }
      return false;
    };
    module2.exports = isFullwidthCodePoint;
    module2.exports.default = isFullwidthCodePoint;
  }
});

// node_modules/aws-cdk-lib/node_modules/emoji-regex/index.js
var require_emoji_regex = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/emoji-regex/index.js"(exports2, module2) {
    "use strict";
    module2.exports = function() {
      return /\uD83C\uDFF4\uDB40\uDC67\uDB40\uDC62(?:\uDB40\uDC65\uDB40\uDC6E\uDB40\uDC67|\uDB40\uDC73\uDB40\uDC63\uDB40\uDC74|\uDB40\uDC77\uDB40\uDC6C\uDB40\uDC73)\uDB40\uDC7F|\uD83D\uDC68(?:\uD83C\uDFFC\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFB|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFE])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFD])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFC])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83D\uDC68|(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D[\uDC66\uDC67])|[\u2695\u2696\u2708]\uFE0F|\uD83D[\uDC66\uDC67]|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|(?:\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708])\uFE0F|\uD83C\uDFFB\u200D(?:\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C[\uDFFB-\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83D\uDC69)\uD83C\uDFFB|\uD83E\uDDD1(?:\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1(?:\uD83C[\uDFFB-\uDFFF])|\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1)|(?:\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB-\uDFFE])|(?:\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83D\uDC69)(?:\uD83C[\uDFFB\uDFFC])|\uD83D\uDC69(?:\uD83C\uDFFE\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFD\uDFFF])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFD-\uDFFF])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFB\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFC-\uDFFF])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|(?:\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83D\uDC69)(?:\uD83C[\uDFFB-\uDFFD])|\uD83D\uDC69\u200D\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D[\uDC66\uDC67])|(?:\uD83D\uDC41\uFE0F\u200D\uD83D\uDDE8|\uD83D\uDC69(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])|(?:(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)\uFE0F|\uD83D\uDC6F|\uD83E[\uDD3C\uDDDE\uDDDF])\u200D[\u2640\u2642]|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uD83C[\uDFFB-\uDFFF])\u200D[\u2640\u2642]|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD6-\uDDDD])(?:(?:\uD83C[\uDFFB-\uDFFF])\u200D[\u2640\u2642]|\u200D[\u2640\u2642])|\uD83C\uDFF4\u200D\u2620)\uFE0F|\uD83D\uDC69\u200D\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|\uD83C\uDFF3\uFE0F\u200D\uD83C\uDF08|\uD83D\uDC15\u200D\uD83E\uDDBA|\uD83D\uDC69\u200D\uD83D\uDC66|\uD83D\uDC69\u200D\uD83D\uDC67|\uD83C\uDDFD\uD83C\uDDF0|\uD83C\uDDF4\uD83C\uDDF2|\uD83C\uDDF6\uD83C\uDDE6|[#\*0-9]\uFE0F\u20E3|\uD83C\uDDE7(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEF\uDDF1-\uDDF4\uDDF6-\uDDF9\uDDFB\uDDFC\uDDFE\uDDFF])|\uD83C\uDDF9(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDED\uDDEF-\uDDF4\uDDF7\uDDF9\uDDFB\uDDFC\uDDFF])|\uD83C\uDDEA(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDED\uDDF7-\uDDFA])|\uD83E\uDDD1(?:\uD83C[\uDFFB-\uDFFF])|\uD83C\uDDF7(?:\uD83C[\uDDEA\uDDF4\uDDF8\uDDFA\uDDFC])|\uD83D\uDC69(?:\uD83C[\uDFFB-\uDFFF])|\uD83C\uDDF2(?:\uD83C[\uDDE6\uDDE8-\uDDED\uDDF0-\uDDFF])|\uD83C\uDDE6(?:\uD83C[\uDDE8-\uDDEC\uDDEE\uDDF1\uDDF2\uDDF4\uDDF6-\uDDFA\uDDFC\uDDFD\uDDFF])|\uD83C\uDDF0(?:\uD83C[\uDDEA\uDDEC-\uDDEE\uDDF2\uDDF3\uDDF5\uDDF7\uDDFC\uDDFE\uDDFF])|\uD83C\uDDED(?:\uD83C[\uDDF0\uDDF2\uDDF3\uDDF7\uDDF9\uDDFA])|\uD83C\uDDE9(?:\uD83C[\uDDEA\uDDEC\uDDEF\uDDF0\uDDF2\uDDF4\uDDFF])|\uD83C\uDDFE(?:\uD83C[\uDDEA\uDDF9])|\uD83C\uDDEC(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEE\uDDF1-\uDDF3\uDDF5-\uDDFA\uDDFC\uDDFE])|\uD83C\uDDF8(?:\uD83C[\uDDE6-\uDDEA\uDDEC-\uDDF4\uDDF7-\uDDF9\uDDFB\uDDFD-\uDDFF])|\uD83C\uDDEB(?:\uD83C[\uDDEE-\uDDF0\uDDF2\uDDF4\uDDF7])|\uD83C\uDDF5(?:\uD83C[\uDDE6\uDDEA-\uDDED\uDDF0-\uDDF3\uDDF7-\uDDF9\uDDFC\uDDFE])|\uD83C\uDDFB(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDEE\uDDF3\uDDFA])|\uD83C\uDDF3(?:\uD83C[\uDDE6\uDDE8\uDDEA-\uDDEC\uDDEE\uDDF1\uDDF4\uDDF5\uDDF7\uDDFA\uDDFF])|\uD83C\uDDE8(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDEE\uDDF0-\uDDF5\uDDF7\uDDFA-\uDDFF])|\uD83C\uDDF1(?:\uD83C[\uDDE6-\uDDE8\uDDEE\uDDF0\uDDF7-\uDDFB\uDDFE])|\uD83C\uDDFF(?:\uD83C[\uDDE6\uDDF2\uDDFC])|\uD83C\uDDFC(?:\uD83C[\uDDEB\uDDF8])|\uD83C\uDDFA(?:\uD83C[\uDDE6\uDDEC\uDDF2\uDDF3\uDDF8\uDDFE\uDDFF])|\uD83C\uDDEE(?:\uD83C[\uDDE8-\uDDEA\uDDF1-\uDDF4\uDDF6-\uDDF9])|\uD83C\uDDEF(?:\uD83C[\uDDEA\uDDF2\uDDF4\uDDF5])|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uD83C[\uDFFB-\uDFFF])|(?:[\u261D\u270A-\u270D]|\uD83C[\uDF85\uDFC2\uDFC7]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC70\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDCAA\uDD74\uDD7A\uDD90\uDD95\uDD96\uDE4C\uDE4F\uDEC0\uDECC]|\uD83E[\uDD0F\uDD18-\uDD1C\uDD1E\uDD1F\uDD30-\uDD36\uDDB5\uDDB6\uDDBB\uDDD2-\uDDD5])(?:\uD83C[\uDFFB-\uDFFF])|(?:[\u231A\u231B\u23E9-\u23EC\u23F0\u23F3\u25FD\u25FE\u2614\u2615\u2648-\u2653\u267F\u2693\u26A1\u26AA\u26AB\u26BD\u26BE\u26C4\u26C5\u26CE\u26D4\u26EA\u26F2\u26F3\u26F5\u26FA\u26FD\u2705\u270A\u270B\u2728\u274C\u274E\u2753-\u2755\u2757\u2795-\u2797\u27B0\u27BF\u2B1B\u2B1C\u2B50\u2B55]|\uD83C[\uDC04\uDCCF\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF93\uDFA0-\uDFCA\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF4\uDFF8-\uDFFF]|\uD83D[\uDC00-\uDC3E\uDC40\uDC42-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDD7A\uDD95\uDD96\uDDA4\uDDFB-\uDE4F\uDE80-\uDEC5\uDECC\uDED0-\uDED2\uDED5\uDEEB\uDEEC\uDEF4-\uDEFA\uDFE0-\uDFEB]|\uD83E[\uDD0D-\uDD3A\uDD3C-\uDD45\uDD47-\uDD71\uDD73-\uDD76\uDD7A-\uDDA2\uDDA5-\uDDAA\uDDAE-\uDDCA\uDDCD-\uDDFF\uDE70-\uDE73\uDE78-\uDE7A\uDE80-\uDE82\uDE90-\uDE95])|(?:[#\*0-9\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u231A\u231B\u2328\u23CF\u23E9-\u23F3\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB-\u25FE\u2600-\u2604\u260E\u2611\u2614\u2615\u2618\u261D\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u2648-\u2653\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u267F\u2692-\u2697\u2699\u269B\u269C\u26A0\u26A1\u26AA\u26AB\u26B0\u26B1\u26BD\u26BE\u26C4\u26C5\u26C8\u26CE\u26CF\u26D1\u26D3\u26D4\u26E9\u26EA\u26F0-\u26F5\u26F7-\u26FA\u26FD\u2702\u2705\u2708-\u270D\u270F\u2712\u2714\u2716\u271D\u2721\u2728\u2733\u2734\u2744\u2747\u274C\u274E\u2753-\u2755\u2757\u2763\u2764\u2795-\u2797\u27A1\u27B0\u27BF\u2934\u2935\u2B05-\u2B07\u2B1B\u2B1C\u2B50\u2B55\u3030\u303D\u3297\u3299]|\uD83C[\uDC04\uDCCF\uDD70\uDD71\uDD7E\uDD7F\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE02\uDE1A\uDE2F\uDE32-\uDE3A\uDE50\uDE51\uDF00-\uDF21\uDF24-\uDF93\uDF96\uDF97\uDF99-\uDF9B\uDF9E-\uDFF0\uDFF3-\uDFF5\uDFF7-\uDFFF]|\uD83D[\uDC00-\uDCFD\uDCFF-\uDD3D\uDD49-\uDD4E\uDD50-\uDD67\uDD6F\uDD70\uDD73-\uDD7A\uDD87\uDD8A-\uDD8D\uDD90\uDD95\uDD96\uDDA4\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA-\uDE4F\uDE80-\uDEC5\uDECB-\uDED2\uDED5\uDEE0-\uDEE5\uDEE9\uDEEB\uDEEC\uDEF0\uDEF3-\uDEFA\uDFE0-\uDFEB]|\uD83E[\uDD0D-\uDD3A\uDD3C-\uDD45\uDD47-\uDD71\uDD73-\uDD76\uDD7A-\uDDA2\uDDA5-\uDDAA\uDDAE-\uDDCA\uDDCD-\uDDFF\uDE70-\uDE73\uDE78-\uDE7A\uDE80-\uDE82\uDE90-\uDE95])\uFE0F|(?:[\u261D\u26F9\u270A-\u270D]|\uD83C[\uDF85\uDFC2-\uDFC4\uDFC7\uDFCA-\uDFCC]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66-\uDC78\uDC7C\uDC81-\uDC83\uDC85-\uDC87\uDC8F\uDC91\uDCAA\uDD74\uDD75\uDD7A\uDD90\uDD95\uDD96\uDE45-\uDE47\uDE4B-\uDE4F\uDEA3\uDEB4-\uDEB6\uDEC0\uDECC]|\uD83E[\uDD0F\uDD18-\uDD1F\uDD26\uDD30-\uDD39\uDD3C-\uDD3E\uDDB5\uDDB6\uDDB8\uDDB9\uDDBB\uDDCD-\uDDCF\uDDD1-\uDDDD])/g;
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/string-width/index.js
var require_string_width = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/string-width/index.js"(exports2, module2) {
    "use strict";
    var stripAnsi = require_strip_ansi();
    var isFullwidthCodePoint = require_is_fullwidth_code_point();
    var emojiRegex = require_emoji_regex();
    var stringWidth = (string) => {
      if (typeof string !== "string" || string.length === 0) {
        return 0;
      }
      string = stripAnsi(string);
      if (string.length === 0) {
        return 0;
      }
      string = string.replace(emojiRegex(), "  ");
      let width = 0;
      for (let i = 0; i < string.length; i++) {
        const code = string.codePointAt(i);
        if (code <= 31 || code >= 127 && code <= 159) {
          continue;
        }
        if (code >= 768 && code <= 879) {
          continue;
        }
        if (code > 65535) {
          i++;
        }
        width += isFullwidthCodePoint(code) ? 2 : 1;
      }
      return width;
    };
    module2.exports = stringWidth;
    module2.exports.default = stringWidth;
  }
});

// node_modules/aws-cdk-lib/node_modules/astral-regex/index.js
var require_astral_regex = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/astral-regex/index.js"(exports2, module2) {
    "use strict";
    var regex = "[\uD800-\uDBFF][\uDC00-\uDFFF]";
    var astralRegex = (options) => options && options.exact ? new RegExp(`^${regex}$`) : new RegExp(regex, "g");
    module2.exports = astralRegex;
  }
});

// node_modules/aws-cdk-lib/node_modules/color-name/index.js
var require_color_name = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/color-name/index.js"(exports2, module2) {
    "use strict";
    module2.exports = {
      "aliceblue": [240, 248, 255],
      "antiquewhite": [250, 235, 215],
      "aqua": [0, 255, 255],
      "aquamarine": [127, 255, 212],
      "azure": [240, 255, 255],
      "beige": [245, 245, 220],
      "bisque": [255, 228, 196],
      "black": [0, 0, 0],
      "blanchedalmond": [255, 235, 205],
      "blue": [0, 0, 255],
      "blueviolet": [138, 43, 226],
      "brown": [165, 42, 42],
      "burlywood": [222, 184, 135],
      "cadetblue": [95, 158, 160],
      "chartreuse": [127, 255, 0],
      "chocolate": [210, 105, 30],
      "coral": [255, 127, 80],
      "cornflowerblue": [100, 149, 237],
      "cornsilk": [255, 248, 220],
      "crimson": [220, 20, 60],
      "cyan": [0, 255, 255],
      "darkblue": [0, 0, 139],
      "darkcyan": [0, 139, 139],
      "darkgoldenrod": [184, 134, 11],
      "darkgray": [169, 169, 169],
      "darkgreen": [0, 100, 0],
      "darkgrey": [169, 169, 169],
      "darkkhaki": [189, 183, 107],
      "darkmagenta": [139, 0, 139],
      "darkolivegreen": [85, 107, 47],
      "darkorange": [255, 140, 0],
      "darkorchid": [153, 50, 204],
      "darkred": [139, 0, 0],
      "darksalmon": [233, 150, 122],
      "darkseagreen": [143, 188, 143],
      "darkslateblue": [72, 61, 139],
      "darkslategray": [47, 79, 79],
      "darkslategrey": [47, 79, 79],
      "darkturquoise": [0, 206, 209],
      "darkviolet": [148, 0, 211],
      "deeppink": [255, 20, 147],
      "deepskyblue": [0, 191, 255],
      "dimgray": [105, 105, 105],
      "dimgrey": [105, 105, 105],
      "dodgerblue": [30, 144, 255],
      "firebrick": [178, 34, 34],
      "floralwhite": [255, 250, 240],
      "forestgreen": [34, 139, 34],
      "fuchsia": [255, 0, 255],
      "gainsboro": [220, 220, 220],
      "ghostwhite": [248, 248, 255],
      "gold": [255, 215, 0],
      "goldenrod": [218, 165, 32],
      "gray": [128, 128, 128],
      "green": [0, 128, 0],
      "greenyellow": [173, 255, 47],
      "grey": [128, 128, 128],
      "honeydew": [240, 255, 240],
      "hotpink": [255, 105, 180],
      "indianred": [205, 92, 92],
      "indigo": [75, 0, 130],
      "ivory": [255, 255, 240],
      "khaki": [240, 230, 140],
      "lavender": [230, 230, 250],
      "lavenderblush": [255, 240, 245],
      "lawngreen": [124, 252, 0],
      "lemonchiffon": [255, 250, 205],
      "lightblue": [173, 216, 230],
      "lightcoral": [240, 128, 128],
      "lightcyan": [224, 255, 255],
      "lightgoldenrodyellow": [250, 250, 210],
      "lightgray": [211, 211, 211],
      "lightgreen": [144, 238, 144],
      "lightgrey": [211, 211, 211],
      "lightpink": [255, 182, 193],
      "lightsalmon": [255, 160, 122],
      "lightseagreen": [32, 178, 170],
      "lightskyblue": [135, 206, 250],
      "lightslategray": [119, 136, 153],
      "lightslategrey": [119, 136, 153],
      "lightsteelblue": [176, 196, 222],
      "lightyellow": [255, 255, 224],
      "lime": [0, 255, 0],
      "limegreen": [50, 205, 50],
      "linen": [250, 240, 230],
      "magenta": [255, 0, 255],
      "maroon": [128, 0, 0],
      "mediumaquamarine": [102, 205, 170],
      "mediumblue": [0, 0, 205],
      "mediumorchid": [186, 85, 211],
      "mediumpurple": [147, 112, 219],
      "mediumseagreen": [60, 179, 113],
      "mediumslateblue": [123, 104, 238],
      "mediumspringgreen": [0, 250, 154],
      "mediumturquoise": [72, 209, 204],
      "mediumvioletred": [199, 21, 133],
      "midnightblue": [25, 25, 112],
      "mintcream": [245, 255, 250],
      "mistyrose": [255, 228, 225],
      "moccasin": [255, 228, 181],
      "navajowhite": [255, 222, 173],
      "navy": [0, 0, 128],
      "oldlace": [253, 245, 230],
      "olive": [128, 128, 0],
      "olivedrab": [107, 142, 35],
      "orange": [255, 165, 0],
      "orangered": [255, 69, 0],
      "orchid": [218, 112, 214],
      "palegoldenrod": [238, 232, 170],
      "palegreen": [152, 251, 152],
      "paleturquoise": [175, 238, 238],
      "palevioletred": [219, 112, 147],
      "papayawhip": [255, 239, 213],
      "peachpuff": [255, 218, 185],
      "peru": [205, 133, 63],
      "pink": [255, 192, 203],
      "plum": [221, 160, 221],
      "powderblue": [176, 224, 230],
      "purple": [128, 0, 128],
      "rebeccapurple": [102, 51, 153],
      "red": [255, 0, 0],
      "rosybrown": [188, 143, 143],
      "royalblue": [65, 105, 225],
      "saddlebrown": [139, 69, 19],
      "salmon": [250, 128, 114],
      "sandybrown": [244, 164, 96],
      "seagreen": [46, 139, 87],
      "seashell": [255, 245, 238],
      "sienna": [160, 82, 45],
      "silver": [192, 192, 192],
      "skyblue": [135, 206, 235],
      "slateblue": [106, 90, 205],
      "slategray": [112, 128, 144],
      "slategrey": [112, 128, 144],
      "snow": [255, 250, 250],
      "springgreen": [0, 255, 127],
      "steelblue": [70, 130, 180],
      "tan": [210, 180, 140],
      "teal": [0, 128, 128],
      "thistle": [216, 191, 216],
      "tomato": [255, 99, 71],
      "turquoise": [64, 224, 208],
      "violet": [238, 130, 238],
      "wheat": [245, 222, 179],
      "white": [255, 255, 255],
      "whitesmoke": [245, 245, 245],
      "yellow": [255, 255, 0],
      "yellowgreen": [154, 205, 50]
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/color-convert/conversions.js
var require_conversions = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/color-convert/conversions.js"(exports2, module2) {
    "use strict";
    var cssKeywords = require_color_name();
    var reverseKeywords = {};
    for (const key of Object.keys(cssKeywords)) {
      reverseKeywords[cssKeywords[key]] = key;
    }
    var convert = {
      rgb: { channels: 3, labels: "rgb" },
      hsl: { channels: 3, labels: "hsl" },
      hsv: { channels: 3, labels: "hsv" },
      hwb: { channels: 3, labels: "hwb" },
      cmyk: { channels: 4, labels: "cmyk" },
      xyz: { channels: 3, labels: "xyz" },
      lab: { channels: 3, labels: "lab" },
      lch: { channels: 3, labels: "lch" },
      hex: { channels: 1, labels: ["hex"] },
      keyword: { channels: 1, labels: ["keyword"] },
      ansi16: { channels: 1, labels: ["ansi16"] },
      ansi256: { channels: 1, labels: ["ansi256"] },
      hcg: { channels: 3, labels: ["h", "c", "g"] },
      apple: { channels: 3, labels: ["r16", "g16", "b16"] },
      gray: { channels: 1, labels: ["gray"] }
    };
    module2.exports = convert;
    for (const model of Object.keys(convert)) {
      if (!("channels" in convert[model])) {
        throw new Error("missing channels property: " + model);
      }
      if (!("labels" in convert[model])) {
        throw new Error("missing channel labels property: " + model);
      }
      if (convert[model].labels.length !== convert[model].channels) {
        throw new Error("channel and label counts mismatch: " + model);
      }
      const { channels, labels } = convert[model];
      delete convert[model].channels;
      delete convert[model].labels;
      Object.defineProperty(convert[model], "channels", { value: channels });
      Object.defineProperty(convert[model], "labels", { value: labels });
    }
    convert.rgb.hsl = function(rgb) {
      const r = rgb[0] / 255;
      const g = rgb[1] / 255;
      const b = rgb[2] / 255;
      const min = Math.min(r, g, b);
      const max = Math.max(r, g, b);
      const delta = max - min;
      let h;
      let s;
      if (max === min) {
        h = 0;
      } else if (r === max) {
        h = (g - b) / delta;
      } else if (g === max) {
        h = 2 + (b - r) / delta;
      } else if (b === max) {
        h = 4 + (r - g) / delta;
      }
      h = Math.min(h * 60, 360);
      if (h < 0) {
        h += 360;
      }
      const l = (min + max) / 2;
      if (max === min) {
        s = 0;
      } else if (l <= 0.5) {
        s = delta / (max + min);
      } else {
        s = delta / (2 - max - min);
      }
      return [h, s * 100, l * 100];
    };
    convert.rgb.hsv = function(rgb) {
      let rdif;
      let gdif;
      let bdif;
      let h;
      let s;
      const r = rgb[0] / 255;
      const g = rgb[1] / 255;
      const b = rgb[2] / 255;
      const v = Math.max(r, g, b);
      const diff = v - Math.min(r, g, b);
      const diffc = function(c) {
        return (v - c) / 6 / diff + 1 / 2;
      };
      if (diff === 0) {
        h = 0;
        s = 0;
      } else {
        s = diff / v;
        rdif = diffc(r);
        gdif = diffc(g);
        bdif = diffc(b);
        if (r === v) {
          h = bdif - gdif;
        } else if (g === v) {
          h = 1 / 3 + rdif - bdif;
        } else if (b === v) {
          h = 2 / 3 + gdif - rdif;
        }
        if (h < 0) {
          h += 1;
        } else if (h > 1) {
          h -= 1;
        }
      }
      return [
        h * 360,
        s * 100,
        v * 100
      ];
    };
    convert.rgb.hwb = function(rgb) {
      const r = rgb[0];
      const g = rgb[1];
      let b = rgb[2];
      const h = convert.rgb.hsl(rgb)[0];
      const w = 1 / 255 * Math.min(r, Math.min(g, b));
      b = 1 - 1 / 255 * Math.max(r, Math.max(g, b));
      return [h, w * 100, b * 100];
    };
    convert.rgb.cmyk = function(rgb) {
      const r = rgb[0] / 255;
      const g = rgb[1] / 255;
      const b = rgb[2] / 255;
      const k = Math.min(1 - r, 1 - g, 1 - b);
      const c = (1 - r - k) / (1 - k) || 0;
      const m = (1 - g - k) / (1 - k) || 0;
      const y = (1 - b - k) / (1 - k) || 0;
      return [c * 100, m * 100, y * 100, k * 100];
    };
    function comparativeDistance(x, y) {
      return (x[0] - y[0]) ** 2 + (x[1] - y[1]) ** 2 + (x[2] - y[2]) ** 2;
    }
    convert.rgb.keyword = function(rgb) {
      const reversed = reverseKeywords[rgb];
      if (reversed) {
        return reversed;
      }
      let currentClosestDistance = Infinity;
      let currentClosestKeyword;
      for (const keyword of Object.keys(cssKeywords)) {
        const value = cssKeywords[keyword];
        const distance = comparativeDistance(rgb, value);
        if (distance < currentClosestDistance) {
          currentClosestDistance = distance;
          currentClosestKeyword = keyword;
        }
      }
      return currentClosestKeyword;
    };
    convert.keyword.rgb = function(keyword) {
      return cssKeywords[keyword];
    };
    convert.rgb.xyz = function(rgb) {
      let r = rgb[0] / 255;
      let g = rgb[1] / 255;
      let b = rgb[2] / 255;
      r = r > 0.04045 ? ((r + 0.055) / 1.055) ** 2.4 : r / 12.92;
      g = g > 0.04045 ? ((g + 0.055) / 1.055) ** 2.4 : g / 12.92;
      b = b > 0.04045 ? ((b + 0.055) / 1.055) ** 2.4 : b / 12.92;
      const x = r * 0.4124 + g * 0.3576 + b * 0.1805;
      const y = r * 0.2126 + g * 0.7152 + b * 0.0722;
      const z = r * 0.0193 + g * 0.1192 + b * 0.9505;
      return [x * 100, y * 100, z * 100];
    };
    convert.rgb.lab = function(rgb) {
      const xyz = convert.rgb.xyz(rgb);
      let x = xyz[0];
      let y = xyz[1];
      let z = xyz[2];
      x /= 95.047;
      y /= 100;
      z /= 108.883;
      x = x > 8856e-6 ? x ** (1 / 3) : 7.787 * x + 16 / 116;
      y = y > 8856e-6 ? y ** (1 / 3) : 7.787 * y + 16 / 116;
      z = z > 8856e-6 ? z ** (1 / 3) : 7.787 * z + 16 / 116;
      const l = 116 * y - 16;
      const a = 500 * (x - y);
      const b = 200 * (y - z);
      return [l, a, b];
    };
    convert.hsl.rgb = function(hsl) {
      const h = hsl[0] / 360;
      const s = hsl[1] / 100;
      const l = hsl[2] / 100;
      let t2;
      let t3;
      let val;
      if (s === 0) {
        val = l * 255;
        return [val, val, val];
      }
      if (l < 0.5) {
        t2 = l * (1 + s);
      } else {
        t2 = l + s - l * s;
      }
      const t1 = 2 * l - t2;
      const rgb = [0, 0, 0];
      for (let i = 0; i < 3; i++) {
        t3 = h + 1 / 3 * -(i - 1);
        if (t3 < 0) {
          t3++;
        }
        if (t3 > 1) {
          t3--;
        }
        if (6 * t3 < 1) {
          val = t1 + (t2 - t1) * 6 * t3;
        } else if (2 * t3 < 1) {
          val = t2;
        } else if (3 * t3 < 2) {
          val = t1 + (t2 - t1) * (2 / 3 - t3) * 6;
        } else {
          val = t1;
        }
        rgb[i] = val * 255;
      }
      return rgb;
    };
    convert.hsl.hsv = function(hsl) {
      const h = hsl[0];
      let s = hsl[1] / 100;
      let l = hsl[2] / 100;
      let smin = s;
      const lmin = Math.max(l, 0.01);
      l *= 2;
      s *= l <= 1 ? l : 2 - l;
      smin *= lmin <= 1 ? lmin : 2 - lmin;
      const v = (l + s) / 2;
      const sv = l === 0 ? 2 * smin / (lmin + smin) : 2 * s / (l + s);
      return [h, sv * 100, v * 100];
    };
    convert.hsv.rgb = function(hsv) {
      const h = hsv[0] / 60;
      const s = hsv[1] / 100;
      let v = hsv[2] / 100;
      const hi = Math.floor(h) % 6;
      const f = h - Math.floor(h);
      const p = 255 * v * (1 - s);
      const q = 255 * v * (1 - s * f);
      const t = 255 * v * (1 - s * (1 - f));
      v *= 255;
      switch (hi) {
        case 0:
          return [v, t, p];
        case 1:
          return [q, v, p];
        case 2:
          return [p, v, t];
        case 3:
          return [p, q, v];
        case 4:
          return [t, p, v];
        case 5:
          return [v, p, q];
      }
    };
    convert.hsv.hsl = function(hsv) {
      const h = hsv[0];
      const s = hsv[1] / 100;
      const v = hsv[2] / 100;
      const vmin = Math.max(v, 0.01);
      let sl;
      let l;
      l = (2 - s) * v;
      const lmin = (2 - s) * vmin;
      sl = s * vmin;
      sl /= lmin <= 1 ? lmin : 2 - lmin;
      sl = sl || 0;
      l /= 2;
      return [h, sl * 100, l * 100];
    };
    convert.hwb.rgb = function(hwb) {
      const h = hwb[0] / 360;
      let wh = hwb[1] / 100;
      let bl = hwb[2] / 100;
      const ratio = wh + bl;
      let f;
      if (ratio > 1) {
        wh /= ratio;
        bl /= ratio;
      }
      const i = Math.floor(6 * h);
      const v = 1 - bl;
      f = 6 * h - i;
      if ((i & 1) !== 0) {
        f = 1 - f;
      }
      const n = wh + f * (v - wh);
      let r;
      let g;
      let b;
      switch (i) {
        default:
        case 6:
        case 0:
          r = v;
          g = n;
          b = wh;
          break;
        case 1:
          r = n;
          g = v;
          b = wh;
          break;
        case 2:
          r = wh;
          g = v;
          b = n;
          break;
        case 3:
          r = wh;
          g = n;
          b = v;
          break;
        case 4:
          r = n;
          g = wh;
          b = v;
          break;
        case 5:
          r = v;
          g = wh;
          b = n;
          break;
      }
      return [r * 255, g * 255, b * 255];
    };
    convert.cmyk.rgb = function(cmyk) {
      const c = cmyk[0] / 100;
      const m = cmyk[1] / 100;
      const y = cmyk[2] / 100;
      const k = cmyk[3] / 100;
      const r = 1 - Math.min(1, c * (1 - k) + k);
      const g = 1 - Math.min(1, m * (1 - k) + k);
      const b = 1 - Math.min(1, y * (1 - k) + k);
      return [r * 255, g * 255, b * 255];
    };
    convert.xyz.rgb = function(xyz) {
      const x = xyz[0] / 100;
      const y = xyz[1] / 100;
      const z = xyz[2] / 100;
      let r;
      let g;
      let b;
      r = x * 3.2406 + y * -1.5372 + z * -0.4986;
      g = x * -0.9689 + y * 1.8758 + z * 0.0415;
      b = x * 0.0557 + y * -0.204 + z * 1.057;
      r = r > 31308e-7 ? 1.055 * r ** (1 / 2.4) - 0.055 : r * 12.92;
      g = g > 31308e-7 ? 1.055 * g ** (1 / 2.4) - 0.055 : g * 12.92;
      b = b > 31308e-7 ? 1.055 * b ** (1 / 2.4) - 0.055 : b * 12.92;
      r = Math.min(Math.max(0, r), 1);
      g = Math.min(Math.max(0, g), 1);
      b = Math.min(Math.max(0, b), 1);
      return [r * 255, g * 255, b * 255];
    };
    convert.xyz.lab = function(xyz) {
      let x = xyz[0];
      let y = xyz[1];
      let z = xyz[2];
      x /= 95.047;
      y /= 100;
      z /= 108.883;
      x = x > 8856e-6 ? x ** (1 / 3) : 7.787 * x + 16 / 116;
      y = y > 8856e-6 ? y ** (1 / 3) : 7.787 * y + 16 / 116;
      z = z > 8856e-6 ? z ** (1 / 3) : 7.787 * z + 16 / 116;
      const l = 116 * y - 16;
      const a = 500 * (x - y);
      const b = 200 * (y - z);
      return [l, a, b];
    };
    convert.lab.xyz = function(lab) {
      const l = lab[0];
      const a = lab[1];
      const b = lab[2];
      let x;
      let y;
      let z;
      y = (l + 16) / 116;
      x = a / 500 + y;
      z = y - b / 200;
      const y2 = y ** 3;
      const x2 = x ** 3;
      const z2 = z ** 3;
      y = y2 > 8856e-6 ? y2 : (y - 16 / 116) / 7.787;
      x = x2 > 8856e-6 ? x2 : (x - 16 / 116) / 7.787;
      z = z2 > 8856e-6 ? z2 : (z - 16 / 116) / 7.787;
      x *= 95.047;
      y *= 100;
      z *= 108.883;
      return [x, y, z];
    };
    convert.lab.lch = function(lab) {
      const l = lab[0];
      const a = lab[1];
      const b = lab[2];
      let h;
      const hr = Math.atan2(b, a);
      h = hr * 360 / 2 / Math.PI;
      if (h < 0) {
        h += 360;
      }
      const c = Math.sqrt(a * a + b * b);
      return [l, c, h];
    };
    convert.lch.lab = function(lch) {
      const l = lch[0];
      const c = lch[1];
      const h = lch[2];
      const hr = h / 360 * 2 * Math.PI;
      const a = c * Math.cos(hr);
      const b = c * Math.sin(hr);
      return [l, a, b];
    };
    convert.rgb.ansi16 = function(args, saturation = null) {
      const [r, g, b] = args;
      let value = saturation === null ? convert.rgb.hsv(args)[2] : saturation;
      value = Math.round(value / 50);
      if (value === 0) {
        return 30;
      }
      let ansi = 30 + (Math.round(b / 255) << 2 | Math.round(g / 255) << 1 | Math.round(r / 255));
      if (value === 2) {
        ansi += 60;
      }
      return ansi;
    };
    convert.hsv.ansi16 = function(args) {
      return convert.rgb.ansi16(convert.hsv.rgb(args), args[2]);
    };
    convert.rgb.ansi256 = function(args) {
      const r = args[0];
      const g = args[1];
      const b = args[2];
      if (r === g && g === b) {
        if (r < 8) {
          return 16;
        }
        if (r > 248) {
          return 231;
        }
        return Math.round((r - 8) / 247 * 24) + 232;
      }
      const ansi = 16 + 36 * Math.round(r / 255 * 5) + 6 * Math.round(g / 255 * 5) + Math.round(b / 255 * 5);
      return ansi;
    };
    convert.ansi16.rgb = function(args) {
      let color = args % 10;
      if (color === 0 || color === 7) {
        if (args > 50) {
          color += 3.5;
        }
        color = color / 10.5 * 255;
        return [color, color, color];
      }
      const mult = (~~(args > 50) + 1) * 0.5;
      const r = (color & 1) * mult * 255;
      const g = (color >> 1 & 1) * mult * 255;
      const b = (color >> 2 & 1) * mult * 255;
      return [r, g, b];
    };
    convert.ansi256.rgb = function(args) {
      if (args >= 232) {
        const c = (args - 232) * 10 + 8;
        return [c, c, c];
      }
      args -= 16;
      let rem;
      const r = Math.floor(args / 36) / 5 * 255;
      const g = Math.floor((rem = args % 36) / 6) / 5 * 255;
      const b = rem % 6 / 5 * 255;
      return [r, g, b];
    };
    convert.rgb.hex = function(args) {
      const integer = ((Math.round(args[0]) & 255) << 16) + ((Math.round(args[1]) & 255) << 8) + (Math.round(args[2]) & 255);
      const string = integer.toString(16).toUpperCase();
      return "000000".substring(string.length) + string;
    };
    convert.hex.rgb = function(args) {
      const match = args.toString(16).match(/[a-f0-9]{6}|[a-f0-9]{3}/i);
      if (!match) {
        return [0, 0, 0];
      }
      let colorString = match[0];
      if (match[0].length === 3) {
        colorString = colorString.split("").map((char) => {
          return char + char;
        }).join("");
      }
      const integer = parseInt(colorString, 16);
      const r = integer >> 16 & 255;
      const g = integer >> 8 & 255;
      const b = integer & 255;
      return [r, g, b];
    };
    convert.rgb.hcg = function(rgb) {
      const r = rgb[0] / 255;
      const g = rgb[1] / 255;
      const b = rgb[2] / 255;
      const max = Math.max(Math.max(r, g), b);
      const min = Math.min(Math.min(r, g), b);
      const chroma = max - min;
      let grayscale;
      let hue;
      if (chroma < 1) {
        grayscale = min / (1 - chroma);
      } else {
        grayscale = 0;
      }
      if (chroma <= 0) {
        hue = 0;
      } else if (max === r) {
        hue = (g - b) / chroma % 6;
      } else if (max === g) {
        hue = 2 + (b - r) / chroma;
      } else {
        hue = 4 + (r - g) / chroma;
      }
      hue /= 6;
      hue %= 1;
      return [hue * 360, chroma * 100, grayscale * 100];
    };
    convert.hsl.hcg = function(hsl) {
      const s = hsl[1] / 100;
      const l = hsl[2] / 100;
      const c = l < 0.5 ? 2 * s * l : 2 * s * (1 - l);
      let f = 0;
      if (c < 1) {
        f = (l - 0.5 * c) / (1 - c);
      }
      return [hsl[0], c * 100, f * 100];
    };
    convert.hsv.hcg = function(hsv) {
      const s = hsv[1] / 100;
      const v = hsv[2] / 100;
      const c = s * v;
      let f = 0;
      if (c < 1) {
        f = (v - c) / (1 - c);
      }
      return [hsv[0], c * 100, f * 100];
    };
    convert.hcg.rgb = function(hcg) {
      const h = hcg[0] / 360;
      const c = hcg[1] / 100;
      const g = hcg[2] / 100;
      if (c === 0) {
        return [g * 255, g * 255, g * 255];
      }
      const pure = [0, 0, 0];
      const hi = h % 1 * 6;
      const v = hi % 1;
      const w = 1 - v;
      let mg = 0;
      switch (Math.floor(hi)) {
        case 0:
          pure[0] = 1;
          pure[1] = v;
          pure[2] = 0;
          break;
        case 1:
          pure[0] = w;
          pure[1] = 1;
          pure[2] = 0;
          break;
        case 2:
          pure[0] = 0;
          pure[1] = 1;
          pure[2] = v;
          break;
        case 3:
          pure[0] = 0;
          pure[1] = w;
          pure[2] = 1;
          break;
        case 4:
          pure[0] = v;
          pure[1] = 0;
          pure[2] = 1;
          break;
        default:
          pure[0] = 1;
          pure[1] = 0;
          pure[2] = w;
      }
      mg = (1 - c) * g;
      return [
        (c * pure[0] + mg) * 255,
        (c * pure[1] + mg) * 255,
        (c * pure[2] + mg) * 255
      ];
    };
    convert.hcg.hsv = function(hcg) {
      const c = hcg[1] / 100;
      const g = hcg[2] / 100;
      const v = c + g * (1 - c);
      let f = 0;
      if (v > 0) {
        f = c / v;
      }
      return [hcg[0], f * 100, v * 100];
    };
    convert.hcg.hsl = function(hcg) {
      const c = hcg[1] / 100;
      const g = hcg[2] / 100;
      const l = g * (1 - c) + 0.5 * c;
      let s = 0;
      if (l > 0 && l < 0.5) {
        s = c / (2 * l);
      } else if (l >= 0.5 && l < 1) {
        s = c / (2 * (1 - l));
      }
      return [hcg[0], s * 100, l * 100];
    };
    convert.hcg.hwb = function(hcg) {
      const c = hcg[1] / 100;
      const g = hcg[2] / 100;
      const v = c + g * (1 - c);
      return [hcg[0], (v - c) * 100, (1 - v) * 100];
    };
    convert.hwb.hcg = function(hwb) {
      const w = hwb[1] / 100;
      const b = hwb[2] / 100;
      const v = 1 - b;
      const c = v - w;
      let g = 0;
      if (c < 1) {
        g = (v - c) / (1 - c);
      }
      return [hwb[0], c * 100, g * 100];
    };
    convert.apple.rgb = function(apple) {
      return [apple[0] / 65535 * 255, apple[1] / 65535 * 255, apple[2] / 65535 * 255];
    };
    convert.rgb.apple = function(rgb) {
      return [rgb[0] / 255 * 65535, rgb[1] / 255 * 65535, rgb[2] / 255 * 65535];
    };
    convert.gray.rgb = function(args) {
      return [args[0] / 100 * 255, args[0] / 100 * 255, args[0] / 100 * 255];
    };
    convert.gray.hsl = function(args) {
      return [0, 0, args[0]];
    };
    convert.gray.hsv = convert.gray.hsl;
    convert.gray.hwb = function(gray) {
      return [0, 100, gray[0]];
    };
    convert.gray.cmyk = function(gray) {
      return [0, 0, 0, gray[0]];
    };
    convert.gray.lab = function(gray) {
      return [gray[0], 0, 0];
    };
    convert.gray.hex = function(gray) {
      const val = Math.round(gray[0] / 100 * 255) & 255;
      const integer = (val << 16) + (val << 8) + val;
      const string = integer.toString(16).toUpperCase();
      return "000000".substring(string.length) + string;
    };
    convert.rgb.gray = function(rgb) {
      const val = (rgb[0] + rgb[1] + rgb[2]) / 3;
      return [val / 255 * 100];
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/color-convert/route.js
var require_route = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/color-convert/route.js"(exports2, module2) {
    "use strict";
    var conversions = require_conversions();
    function buildGraph() {
      const graph = {};
      const models = Object.keys(conversions);
      for (let len = models.length, i = 0; i < len; i++) {
        graph[models[i]] = {
          // http://jsperf.com/1-vs-infinity
          // micro-opt, but this is simple.
          distance: -1,
          parent: null
        };
      }
      return graph;
    }
    function deriveBFS(fromModel) {
      const graph = buildGraph();
      const queue = [fromModel];
      graph[fromModel].distance = 0;
      while (queue.length) {
        const current = queue.pop();
        const adjacents = Object.keys(conversions[current]);
        for (let len = adjacents.length, i = 0; i < len; i++) {
          const adjacent = adjacents[i];
          const node = graph[adjacent];
          if (node.distance === -1) {
            node.distance = graph[current].distance + 1;
            node.parent = current;
            queue.unshift(adjacent);
          }
        }
      }
      return graph;
    }
    function link(from, to) {
      return function(args) {
        return to(from(args));
      };
    }
    function wrapConversion(toModel, graph) {
      const path = [graph[toModel].parent, toModel];
      let fn = conversions[graph[toModel].parent][toModel];
      let cur = graph[toModel].parent;
      while (graph[cur].parent) {
        path.unshift(graph[cur].parent);
        fn = link(conversions[graph[cur].parent][cur], fn);
        cur = graph[cur].parent;
      }
      fn.conversion = path;
      return fn;
    }
    module2.exports = function(fromModel) {
      const graph = deriveBFS(fromModel);
      const conversion = {};
      const models = Object.keys(graph);
      for (let len = models.length, i = 0; i < len; i++) {
        const toModel = models[i];
        const node = graph[toModel];
        if (node.parent === null) {
          continue;
        }
        conversion[toModel] = wrapConversion(toModel, graph);
      }
      return conversion;
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/color-convert/index.js
var require_color_convert = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/color-convert/index.js"(exports2, module2) {
    "use strict";
    var conversions = require_conversions();
    var route = require_route();
    var convert = {};
    var models = Object.keys(conversions);
    function wrapRaw(fn) {
      const wrappedFn = function(...args) {
        const arg0 = args[0];
        if (arg0 === void 0 || arg0 === null) {
          return arg0;
        }
        if (arg0.length > 1) {
          args = arg0;
        }
        return fn(args);
      };
      if ("conversion" in fn) {
        wrappedFn.conversion = fn.conversion;
      }
      return wrappedFn;
    }
    function wrapRounded(fn) {
      const wrappedFn = function(...args) {
        const arg0 = args[0];
        if (arg0 === void 0 || arg0 === null) {
          return arg0;
        }
        if (arg0.length > 1) {
          args = arg0;
        }
        const result = fn(args);
        if (typeof result === "object") {
          for (let len = result.length, i = 0; i < len; i++) {
            result[i] = Math.round(result[i]);
          }
        }
        return result;
      };
      if ("conversion" in fn) {
        wrappedFn.conversion = fn.conversion;
      }
      return wrappedFn;
    }
    models.forEach((fromModel) => {
      convert[fromModel] = {};
      Object.defineProperty(convert[fromModel], "channels", { value: conversions[fromModel].channels });
      Object.defineProperty(convert[fromModel], "labels", { value: conversions[fromModel].labels });
      const routes = route(fromModel);
      const routeModels = Object.keys(routes);
      routeModels.forEach((toModel) => {
        const fn = routes[toModel];
        convert[fromModel][toModel] = wrapRounded(fn);
        convert[fromModel][toModel].raw = wrapRaw(fn);
      });
    });
    module2.exports = convert;
  }
});

// node_modules/aws-cdk-lib/node_modules/ansi-styles/index.js
var require_ansi_styles = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/ansi-styles/index.js"(exports2, module2) {
    "use strict";
    var wrapAnsi16 = (fn, offset) => (...args) => {
      const code = fn(...args);
      return `\x1B[${code + offset}m`;
    };
    var wrapAnsi256 = (fn, offset) => (...args) => {
      const code = fn(...args);
      return `\x1B[${38 + offset};5;${code}m`;
    };
    var wrapAnsi16m = (fn, offset) => (...args) => {
      const rgb = fn(...args);
      return `\x1B[${38 + offset};2;${rgb[0]};${rgb[1]};${rgb[2]}m`;
    };
    var ansi2ansi = (n) => n;
    var rgb2rgb = (r, g, b) => [r, g, b];
    var setLazyProperty = (object, property, get) => {
      Object.defineProperty(object, property, {
        get: () => {
          const value = get();
          Object.defineProperty(object, property, {
            value,
            enumerable: true,
            configurable: true
          });
          return value;
        },
        enumerable: true,
        configurable: true
      });
    };
    var colorConvert;
    var makeDynamicStyles = (wrap, targetSpace, identity, isBackground) => {
      if (colorConvert === void 0) {
        colorConvert = require_color_convert();
      }
      const offset = isBackground ? 10 : 0;
      const styles = {};
      for (const [sourceSpace, suite] of Object.entries(colorConvert)) {
        const name = sourceSpace === "ansi16" ? "ansi" : sourceSpace;
        if (sourceSpace === targetSpace) {
          styles[name] = wrap(identity, offset);
        } else if (typeof suite === "object") {
          styles[name] = wrap(suite[targetSpace], offset);
        }
      }
      return styles;
    };
    function assembleStyles() {
      const codes = /* @__PURE__ */ new Map();
      const styles = {
        modifier: {
          reset: [0, 0],
          // 21 isn't widely supported and 22 does the same thing
          bold: [1, 22],
          dim: [2, 22],
          italic: [3, 23],
          underline: [4, 24],
          inverse: [7, 27],
          hidden: [8, 28],
          strikethrough: [9, 29]
        },
        color: {
          black: [30, 39],
          red: [31, 39],
          green: [32, 39],
          yellow: [33, 39],
          blue: [34, 39],
          magenta: [35, 39],
          cyan: [36, 39],
          white: [37, 39],
          // Bright color
          blackBright: [90, 39],
          redBright: [91, 39],
          greenBright: [92, 39],
          yellowBright: [93, 39],
          blueBright: [94, 39],
          magentaBright: [95, 39],
          cyanBright: [96, 39],
          whiteBright: [97, 39]
        },
        bgColor: {
          bgBlack: [40, 49],
          bgRed: [41, 49],
          bgGreen: [42, 49],
          bgYellow: [43, 49],
          bgBlue: [44, 49],
          bgMagenta: [45, 49],
          bgCyan: [46, 49],
          bgWhite: [47, 49],
          // Bright color
          bgBlackBright: [100, 49],
          bgRedBright: [101, 49],
          bgGreenBright: [102, 49],
          bgYellowBright: [103, 49],
          bgBlueBright: [104, 49],
          bgMagentaBright: [105, 49],
          bgCyanBright: [106, 49],
          bgWhiteBright: [107, 49]
        }
      };
      styles.color.gray = styles.color.blackBright;
      styles.bgColor.bgGray = styles.bgColor.bgBlackBright;
      styles.color.grey = styles.color.blackBright;
      styles.bgColor.bgGrey = styles.bgColor.bgBlackBright;
      for (const [groupName, group] of Object.entries(styles)) {
        for (const [styleName, style] of Object.entries(group)) {
          styles[styleName] = {
            open: `\x1B[${style[0]}m`,
            close: `\x1B[${style[1]}m`
          };
          group[styleName] = styles[styleName];
          codes.set(style[0], style[1]);
        }
        Object.defineProperty(styles, groupName, {
          value: group,
          enumerable: false
        });
      }
      Object.defineProperty(styles, "codes", {
        value: codes,
        enumerable: false
      });
      styles.color.close = "\x1B[39m";
      styles.bgColor.close = "\x1B[49m";
      setLazyProperty(styles.color, "ansi", () => makeDynamicStyles(wrapAnsi16, "ansi16", ansi2ansi, false));
      setLazyProperty(styles.color, "ansi256", () => makeDynamicStyles(wrapAnsi256, "ansi256", ansi2ansi, false));
      setLazyProperty(styles.color, "ansi16m", () => makeDynamicStyles(wrapAnsi16m, "rgb", rgb2rgb, false));
      setLazyProperty(styles.bgColor, "ansi", () => makeDynamicStyles(wrapAnsi16, "ansi16", ansi2ansi, true));
      setLazyProperty(styles.bgColor, "ansi256", () => makeDynamicStyles(wrapAnsi256, "ansi256", ansi2ansi, true));
      setLazyProperty(styles.bgColor, "ansi16m", () => makeDynamicStyles(wrapAnsi16m, "rgb", rgb2rgb, true));
      return styles;
    }
    Object.defineProperty(module2, "exports", {
      enumerable: true,
      get: assembleStyles
    });
  }
});

// node_modules/aws-cdk-lib/node_modules/slice-ansi/index.js
var require_slice_ansi = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/slice-ansi/index.js"(exports2, module2) {
    "use strict";
    var isFullwidthCodePoint = require_is_fullwidth_code_point();
    var astralRegex = require_astral_regex();
    var ansiStyles = require_ansi_styles();
    var ESCAPES = [
      "\x1B",
      "\x9B"
    ];
    var wrapAnsi = (code) => `${ESCAPES[0]}[${code}m`;
    var checkAnsi = (ansiCodes, isEscapes, endAnsiCode) => {
      let output = [];
      ansiCodes = [...ansiCodes];
      for (let ansiCode of ansiCodes) {
        const ansiCodeOrigin = ansiCode;
        if (ansiCode.includes(";")) {
          ansiCode = ansiCode.split(";")[0][0] + "0";
        }
        const item = ansiStyles.codes.get(Number.parseInt(ansiCode, 10));
        if (item) {
          const indexEscape = ansiCodes.indexOf(item.toString());
          if (indexEscape === -1) {
            output.push(wrapAnsi(isEscapes ? item : ansiCodeOrigin));
          } else {
            ansiCodes.splice(indexEscape, 1);
          }
        } else if (isEscapes) {
          output.push(wrapAnsi(0));
          break;
        } else {
          output.push(wrapAnsi(ansiCodeOrigin));
        }
      }
      if (isEscapes) {
        output = output.filter((element, index) => output.indexOf(element) === index);
        if (endAnsiCode !== void 0) {
          const fistEscapeCode = wrapAnsi(ansiStyles.codes.get(Number.parseInt(endAnsiCode, 10)));
          output = output.reduce((current, next) => next === fistEscapeCode ? [next, ...current] : [...current, next], []);
        }
      }
      return output.join("");
    };
    module2.exports = (string, begin, end) => {
      const characters = [...string];
      const ansiCodes = [];
      let stringEnd = typeof end === "number" ? end : characters.length;
      let isInsideEscape = false;
      let ansiCode;
      let visible = 0;
      let output = "";
      for (const [index, character] of characters.entries()) {
        let leftEscape = false;
        if (ESCAPES.includes(character)) {
          const code = /\d[^m]*/.exec(string.slice(index, index + 18));
          ansiCode = code && code.length > 0 ? code[0] : void 0;
          if (visible < stringEnd) {
            isInsideEscape = true;
            if (ansiCode !== void 0) {
              ansiCodes.push(ansiCode);
            }
          }
        } else if (isInsideEscape && character === "m") {
          isInsideEscape = false;
          leftEscape = true;
        }
        if (!isInsideEscape && !leftEscape) {
          visible++;
        }
        if (!astralRegex({ exact: true }).test(character) && isFullwidthCodePoint(character.codePointAt())) {
          visible++;
          if (typeof end !== "number") {
            stringEnd++;
          }
        }
        if (visible > begin && visible <= stringEnd) {
          output += character;
        } else if (visible === begin && !isInsideEscape && ansiCode !== void 0) {
          output = checkAnsi(ansiCodes);
        } else if (visible >= stringEnd) {
          output += checkAnsi(ansiCodes, true, ansiCode);
          break;
        }
      }
      return output;
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/getBorderCharacters.js
var require_getBorderCharacters = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/getBorderCharacters.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getBorderCharacters = void 0;
    var getBorderCharacters = (name) => {
      if (name === "honeywell") {
        return {
          topBody: "\u2550",
          topJoin: "\u2564",
          topLeft: "\u2554",
          topRight: "\u2557",
          bottomBody: "\u2550",
          bottomJoin: "\u2567",
          bottomLeft: "\u255A",
          bottomRight: "\u255D",
          bodyLeft: "\u2551",
          bodyRight: "\u2551",
          bodyJoin: "\u2502",
          headerJoin: "\u252C",
          joinBody: "\u2500",
          joinLeft: "\u255F",
          joinRight: "\u2562",
          joinJoin: "\u253C",
          joinMiddleDown: "\u252C",
          joinMiddleUp: "\u2534",
          joinMiddleLeft: "\u2524",
          joinMiddleRight: "\u251C"
        };
      }
      if (name === "norc") {
        return {
          topBody: "\u2500",
          topJoin: "\u252C",
          topLeft: "\u250C",
          topRight: "\u2510",
          bottomBody: "\u2500",
          bottomJoin: "\u2534",
          bottomLeft: "\u2514",
          bottomRight: "\u2518",
          bodyLeft: "\u2502",
          bodyRight: "\u2502",
          bodyJoin: "\u2502",
          headerJoin: "\u252C",
          joinBody: "\u2500",
          joinLeft: "\u251C",
          joinRight: "\u2524",
          joinJoin: "\u253C",
          joinMiddleDown: "\u252C",
          joinMiddleUp: "\u2534",
          joinMiddleLeft: "\u2524",
          joinMiddleRight: "\u251C"
        };
      }
      if (name === "ramac") {
        return {
          topBody: "-",
          topJoin: "+",
          topLeft: "+",
          topRight: "+",
          bottomBody: "-",
          bottomJoin: "+",
          bottomLeft: "+",
          bottomRight: "+",
          bodyLeft: "|",
          bodyRight: "|",
          bodyJoin: "|",
          headerJoin: "+",
          joinBody: "-",
          joinLeft: "|",
          joinRight: "|",
          joinJoin: "|",
          joinMiddleDown: "+",
          joinMiddleUp: "+",
          joinMiddleLeft: "+",
          joinMiddleRight: "+"
        };
      }
      if (name === "void") {
        return {
          topBody: "",
          topJoin: "",
          topLeft: "",
          topRight: "",
          bottomBody: "",
          bottomJoin: "",
          bottomLeft: "",
          bottomRight: "",
          bodyLeft: "",
          bodyRight: "",
          bodyJoin: "",
          headerJoin: "",
          joinBody: "",
          joinLeft: "",
          joinRight: "",
          joinJoin: "",
          joinMiddleDown: "",
          joinMiddleUp: "",
          joinMiddleLeft: "",
          joinMiddleRight: ""
        };
      }
      throw new Error('Unknown border template "' + name + '".');
    };
    exports2.getBorderCharacters = getBorderCharacters;
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/utils.js
var require_utils5 = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/utils.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.isCellInRange = exports2.areCellEqual = exports2.calculateRangeCoordinate = exports2.findOriginalRowIndex = exports2.flatten = exports2.extractTruncates = exports2.sumArray = exports2.sequence = exports2.distributeUnevenly = exports2.countSpaceSequence = exports2.groupBySizes = exports2.makeBorderConfig = exports2.splitAnsi = exports2.normalizeString = void 0;
    var slice_ansi_1 = __importDefault(require_slice_ansi());
    var string_width_1 = __importDefault(require_string_width());
    var strip_ansi_1 = __importDefault(require_strip_ansi());
    var getBorderCharacters_1 = require_getBorderCharacters();
    var normalizeString = (input) => {
      return input.replace(/\r\n/g, "\n");
    };
    exports2.normalizeString = normalizeString;
    var splitAnsi = (input) => {
      const lengths = (0, strip_ansi_1.default)(input).split("\n").map(string_width_1.default);
      const result = [];
      let startIndex = 0;
      lengths.forEach((length) => {
        result.push(length === 0 ? "" : (0, slice_ansi_1.default)(input, startIndex, startIndex + length));
        startIndex += length + 1;
      });
      return result;
    };
    exports2.splitAnsi = splitAnsi;
    var makeBorderConfig = (border) => {
      return {
        ...(0, getBorderCharacters_1.getBorderCharacters)("honeywell"),
        ...border
      };
    };
    exports2.makeBorderConfig = makeBorderConfig;
    var groupBySizes = (array, sizes) => {
      let startIndex = 0;
      return sizes.map((size) => {
        const group = array.slice(startIndex, startIndex + size);
        startIndex += size;
        return group;
      });
    };
    exports2.groupBySizes = groupBySizes;
    var countSpaceSequence = (input) => {
      var _a, _b;
      return (_b = (_a = input.match(/\s+/g)) === null || _a === void 0 ? void 0 : _a.length) !== null && _b !== void 0 ? _b : 0;
    };
    exports2.countSpaceSequence = countSpaceSequence;
    var distributeUnevenly = (sum, length) => {
      const result = Array.from({ length }).fill(Math.floor(sum / length));
      return result.map((element, index) => {
        return element + (index < sum % length ? 1 : 0);
      });
    };
    exports2.distributeUnevenly = distributeUnevenly;
    var sequence = (start, end) => {
      return Array.from({ length: end - start + 1 }, (_, index) => {
        return index + start;
      });
    };
    exports2.sequence = sequence;
    var sumArray = (array) => {
      return array.reduce((accumulator, element) => {
        return accumulator + element;
      }, 0);
    };
    exports2.sumArray = sumArray;
    var extractTruncates = (config) => {
      return config.columns.map(({ truncate }) => {
        return truncate;
      });
    };
    exports2.extractTruncates = extractTruncates;
    var flatten = (array) => {
      return [].concat(...array);
    };
    exports2.flatten = flatten;
    var findOriginalRowIndex = (mappedRowHeights, mappedRowIndex) => {
      const rowIndexMapping = (0, exports2.flatten)(mappedRowHeights.map((height, index) => {
        return Array.from({ length: height }, () => {
          return index;
        });
      }));
      return rowIndexMapping[mappedRowIndex];
    };
    exports2.findOriginalRowIndex = findOriginalRowIndex;
    var calculateRangeCoordinate = (spanningCellConfig) => {
      const { row, col, colSpan = 1, rowSpan = 1 } = spanningCellConfig;
      return {
        bottomRight: {
          col: col + colSpan - 1,
          row: row + rowSpan - 1
        },
        topLeft: {
          col,
          row
        }
      };
    };
    exports2.calculateRangeCoordinate = calculateRangeCoordinate;
    var areCellEqual = (cell1, cell2) => {
      return cell1.row === cell2.row && cell1.col === cell2.col;
    };
    exports2.areCellEqual = areCellEqual;
    var isCellInRange = (cell, { topLeft, bottomRight }) => {
      return topLeft.row <= cell.row && cell.row <= bottomRight.row && topLeft.col <= cell.col && cell.col <= bottomRight.col;
    };
    exports2.isCellInRange = isCellInRange;
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/alignString.js
var require_alignString = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/alignString.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.alignString = void 0;
    var string_width_1 = __importDefault(require_string_width());
    var utils_1 = require_utils5();
    var alignLeft = (subject, width) => {
      return subject + " ".repeat(width);
    };
    var alignRight = (subject, width) => {
      return " ".repeat(width) + subject;
    };
    var alignCenter = (subject, width) => {
      return " ".repeat(Math.floor(width / 2)) + subject + " ".repeat(Math.ceil(width / 2));
    };
    var alignJustify = (subject, width) => {
      const spaceSequenceCount = (0, utils_1.countSpaceSequence)(subject);
      if (spaceSequenceCount === 0) {
        return alignLeft(subject, width);
      }
      const addingSpaces = (0, utils_1.distributeUnevenly)(width, spaceSequenceCount);
      if (Math.max(...addingSpaces) > 3) {
        return alignLeft(subject, width);
      }
      let spaceSequenceIndex = 0;
      return subject.replace(/\s+/g, (groupSpace) => {
        return groupSpace + " ".repeat(addingSpaces[spaceSequenceIndex++]);
      });
    };
    var alignString = (subject, containerWidth, alignment) => {
      const subjectWidth = (0, string_width_1.default)(subject);
      if (subjectWidth === containerWidth) {
        return subject;
      }
      if (subjectWidth > containerWidth) {
        throw new Error("Subject parameter value width cannot be greater than the container width.");
      }
      if (subjectWidth === 0) {
        return " ".repeat(containerWidth);
      }
      const availableWidth = containerWidth - subjectWidth;
      if (alignment === "left") {
        return alignLeft(subject, availableWidth);
      }
      if (alignment === "right") {
        return alignRight(subject, availableWidth);
      }
      if (alignment === "justify") {
        return alignJustify(subject, availableWidth);
      }
      return alignCenter(subject, availableWidth);
    };
    exports2.alignString = alignString;
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/alignTableData.js
var require_alignTableData = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/alignTableData.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.alignTableData = void 0;
    var alignString_1 = require_alignString();
    var alignTableData = (rows, config) => {
      return rows.map((row, rowIndex) => {
        return row.map((cell, cellIndex) => {
          var _a;
          const { width, alignment } = config.columns[cellIndex];
          const containingRange = (_a = config.spanningCellManager) === null || _a === void 0 ? void 0 : _a.getContainingRange({
            col: cellIndex,
            row: rowIndex
          }, { mapped: true });
          if (containingRange) {
            return cell;
          }
          return (0, alignString_1.alignString)(cell, width, alignment);
        });
      });
    };
    exports2.alignTableData = alignTableData;
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/wrapString.js
var require_wrapString = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/wrapString.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.wrapString = void 0;
    var slice_ansi_1 = __importDefault(require_slice_ansi());
    var string_width_1 = __importDefault(require_string_width());
    var wrapString = (subject, size) => {
      let subjectSlice = subject;
      const chunks = [];
      do {
        chunks.push((0, slice_ansi_1.default)(subjectSlice, 0, size));
        subjectSlice = (0, slice_ansi_1.default)(subjectSlice, size).trim();
      } while ((0, string_width_1.default)(subjectSlice));
      return chunks;
    };
    exports2.wrapString = wrapString;
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/wrapWord.js
var require_wrapWord = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/wrapWord.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.wrapWord = void 0;
    var slice_ansi_1 = __importDefault(require_slice_ansi());
    var strip_ansi_1 = __importDefault(require_strip_ansi());
    var calculateStringLengths = (input, size) => {
      let subject = (0, strip_ansi_1.default)(input);
      const chunks = [];
      const re = new RegExp("(^.{1," + String(Math.max(size, 1)) + "}(\\s+|$))|(^.{1," + String(Math.max(size - 1, 1)) + "}(\\\\|/|_|\\.|,|;|-))");
      do {
        let chunk;
        const match = re.exec(subject);
        if (match) {
          chunk = match[0];
          subject = subject.slice(chunk.length);
          const trimmedLength = chunk.trim().length;
          const offset = chunk.length - trimmedLength;
          chunks.push([trimmedLength, offset]);
        } else {
          chunk = subject.slice(0, size);
          subject = subject.slice(size);
          chunks.push([chunk.length, 0]);
        }
      } while (subject.length);
      return chunks;
    };
    var wrapWord = (input, size) => {
      const result = [];
      let startIndex = 0;
      calculateStringLengths(input, size).forEach(([length, offset]) => {
        result.push((0, slice_ansi_1.default)(input, startIndex, startIndex + length));
        startIndex += length + offset;
      });
      return result;
    };
    exports2.wrapWord = wrapWord;
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/wrapCell.js
var require_wrapCell = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/wrapCell.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.wrapCell = void 0;
    var utils_1 = require_utils5();
    var wrapString_1 = require_wrapString();
    var wrapWord_1 = require_wrapWord();
    var wrapCell = (cellValue, cellWidth, useWrapWord) => {
      const cellLines = (0, utils_1.splitAnsi)(cellValue);
      for (let lineNr = 0; lineNr < cellLines.length; ) {
        let lineChunks;
        if (useWrapWord) {
          lineChunks = (0, wrapWord_1.wrapWord)(cellLines[lineNr], cellWidth);
        } else {
          lineChunks = (0, wrapString_1.wrapString)(cellLines[lineNr], cellWidth);
        }
        cellLines.splice(lineNr, 1, ...lineChunks);
        lineNr += lineChunks.length;
      }
      return cellLines;
    };
    exports2.wrapCell = wrapCell;
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/calculateCellHeight.js
var require_calculateCellHeight = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/calculateCellHeight.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.calculateCellHeight = void 0;
    var wrapCell_1 = require_wrapCell();
    var calculateCellHeight = (value, columnWidth, useWrapWord = false) => {
      return (0, wrapCell_1.wrapCell)(value, columnWidth, useWrapWord).length;
    };
    exports2.calculateCellHeight = calculateCellHeight;
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/calculateRowHeights.js
var require_calculateRowHeights = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/calculateRowHeights.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.calculateRowHeights = void 0;
    var calculateCellHeight_1 = require_calculateCellHeight();
    var utils_1 = require_utils5();
    var calculateRowHeights = (rows, config) => {
      const rowHeights = [];
      for (const [rowIndex, row] of rows.entries()) {
        let rowHeight = 1;
        row.forEach((cell, cellIndex) => {
          var _a;
          const containingRange = (_a = config.spanningCellManager) === null || _a === void 0 ? void 0 : _a.getContainingRange({
            col: cellIndex,
            row: rowIndex
          });
          if (!containingRange) {
            const cellHeight = (0, calculateCellHeight_1.calculateCellHeight)(cell, config.columns[cellIndex].width, config.columns[cellIndex].wrapWord);
            rowHeight = Math.max(rowHeight, cellHeight);
            return;
          }
          const { topLeft, bottomRight, height } = containingRange;
          if (rowIndex === bottomRight.row) {
            const totalOccupiedSpanningCellHeight = (0, utils_1.sumArray)(rowHeights.slice(topLeft.row));
            const totalHorizontalBorderHeight = bottomRight.row - topLeft.row;
            const totalHiddenHorizontalBorderHeight = (0, utils_1.sequence)(topLeft.row + 1, bottomRight.row).filter((horizontalBorderIndex) => {
              var _a2;
              return !((_a2 = config.drawHorizontalLine) === null || _a2 === void 0 ? void 0 : _a2.call(config, horizontalBorderIndex, rows.length));
            }).length;
            const cellHeight = height - totalOccupiedSpanningCellHeight - totalHorizontalBorderHeight + totalHiddenHorizontalBorderHeight;
            rowHeight = Math.max(rowHeight, cellHeight);
          }
        });
        rowHeights.push(rowHeight);
      }
      return rowHeights;
    };
    exports2.calculateRowHeights = calculateRowHeights;
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/drawContent.js
var require_drawContent = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/drawContent.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.drawContent = void 0;
    var drawContent = (parameters) => {
      const { contents, separatorGetter, drawSeparator, spanningCellManager, rowIndex, elementType } = parameters;
      const contentSize = contents.length;
      const result = [];
      if (drawSeparator(0, contentSize)) {
        result.push(separatorGetter(0, contentSize));
      }
      contents.forEach((content, contentIndex) => {
        if (!elementType || elementType === "border" || elementType === "row") {
          result.push(content);
        }
        if (elementType === "cell" && rowIndex === void 0) {
          result.push(content);
        }
        if (elementType === "cell" && rowIndex !== void 0) {
          const containingRange = spanningCellManager === null || spanningCellManager === void 0 ? void 0 : spanningCellManager.getContainingRange({
            col: contentIndex,
            row: rowIndex
          });
          if (!containingRange || contentIndex === containingRange.topLeft.col) {
            result.push(content);
          }
        }
        if (contentIndex + 1 < contentSize && drawSeparator(contentIndex + 1, contentSize)) {
          const separator = separatorGetter(contentIndex + 1, contentSize);
          if (elementType === "cell" && rowIndex !== void 0) {
            const currentCell = {
              col: contentIndex + 1,
              row: rowIndex
            };
            const containingRange = spanningCellManager === null || spanningCellManager === void 0 ? void 0 : spanningCellManager.getContainingRange(currentCell);
            if (!containingRange || containingRange.topLeft.col === currentCell.col) {
              result.push(separator);
            }
          } else {
            result.push(separator);
          }
        }
      });
      if (drawSeparator(contentSize, contentSize)) {
        result.push(separatorGetter(contentSize, contentSize));
      }
      return result.join("");
    };
    exports2.drawContent = drawContent;
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/drawBorder.js
var require_drawBorder = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/drawBorder.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.createTableBorderGetter = exports2.drawBorderBottom = exports2.drawBorderJoin = exports2.drawBorderTop = exports2.drawBorder = exports2.createSeparatorGetter = exports2.drawBorderSegments = void 0;
    var drawContent_1 = require_drawContent();
    var drawBorderSegments = (columnWidths, parameters) => {
      const { separator, horizontalBorderIndex, spanningCellManager } = parameters;
      return columnWidths.map((columnWidth, columnIndex) => {
        const normalSegment = separator.body.repeat(columnWidth);
        if (horizontalBorderIndex === void 0) {
          return normalSegment;
        }
        const range = spanningCellManager === null || spanningCellManager === void 0 ? void 0 : spanningCellManager.getContainingRange({
          col: columnIndex,
          row: horizontalBorderIndex
        });
        if (!range) {
          return normalSegment;
        }
        const { topLeft } = range;
        if (horizontalBorderIndex === topLeft.row) {
          return normalSegment;
        }
        if (columnIndex !== topLeft.col) {
          return "";
        }
        return range.extractBorderContent(horizontalBorderIndex);
      });
    };
    exports2.drawBorderSegments = drawBorderSegments;
    var createSeparatorGetter = (dependencies) => {
      const { separator, spanningCellManager, horizontalBorderIndex, rowCount } = dependencies;
      return (verticalBorderIndex, columnCount) => {
        const inSameRange = spanningCellManager === null || spanningCellManager === void 0 ? void 0 : spanningCellManager.inSameRange;
        if (horizontalBorderIndex !== void 0 && inSameRange) {
          const topCell = {
            col: verticalBorderIndex,
            row: horizontalBorderIndex - 1
          };
          const leftCell = {
            col: verticalBorderIndex - 1,
            row: horizontalBorderIndex
          };
          const oppositeCell = {
            col: verticalBorderIndex - 1,
            row: horizontalBorderIndex - 1
          };
          const currentCell = {
            col: verticalBorderIndex,
            row: horizontalBorderIndex
          };
          const pairs = [
            [oppositeCell, topCell],
            [topCell, currentCell],
            [currentCell, leftCell],
            [leftCell, oppositeCell]
          ];
          if (verticalBorderIndex === 0) {
            if (inSameRange(currentCell, topCell) && separator.bodyJoinOuter) {
              return separator.bodyJoinOuter;
            }
            return separator.left;
          }
          if (verticalBorderIndex === columnCount) {
            if (inSameRange(oppositeCell, leftCell) && separator.bodyJoinOuter) {
              return separator.bodyJoinOuter;
            }
            return separator.right;
          }
          if (horizontalBorderIndex === 0) {
            if (inSameRange(currentCell, leftCell)) {
              return separator.body;
            }
            return separator.join;
          }
          if (horizontalBorderIndex === rowCount) {
            if (inSameRange(topCell, oppositeCell)) {
              return separator.body;
            }
            return separator.join;
          }
          const sameRangeCount = pairs.map((pair) => {
            return inSameRange(...pair);
          }).filter(Boolean).length;
          if (sameRangeCount === 0) {
            return separator.join;
          }
          if (sameRangeCount === 4) {
            return "";
          }
          if (sameRangeCount === 2) {
            if (inSameRange(...pairs[1]) && inSameRange(...pairs[3]) && separator.bodyJoinInner) {
              return separator.bodyJoinInner;
            }
            return separator.body;
          }
          if (sameRangeCount === 1) {
            if (!separator.joinRight || !separator.joinLeft || !separator.joinUp || !separator.joinDown) {
              throw new Error(`Can not get border separator for position [${horizontalBorderIndex}, ${verticalBorderIndex}]`);
            }
            if (inSameRange(...pairs[0])) {
              return separator.joinDown;
            }
            if (inSameRange(...pairs[1])) {
              return separator.joinLeft;
            }
            if (inSameRange(...pairs[2])) {
              return separator.joinUp;
            }
            return separator.joinRight;
          }
          throw new Error("Invalid case");
        }
        if (verticalBorderIndex === 0) {
          return separator.left;
        }
        if (verticalBorderIndex === columnCount) {
          return separator.right;
        }
        return separator.join;
      };
    };
    exports2.createSeparatorGetter = createSeparatorGetter;
    var drawBorder = (columnWidths, parameters) => {
      const borderSegments = (0, exports2.drawBorderSegments)(columnWidths, parameters);
      const { drawVerticalLine, horizontalBorderIndex, spanningCellManager } = parameters;
      return (0, drawContent_1.drawContent)({
        contents: borderSegments,
        drawSeparator: drawVerticalLine,
        elementType: "border",
        rowIndex: horizontalBorderIndex,
        separatorGetter: (0, exports2.createSeparatorGetter)(parameters),
        spanningCellManager
      }) + "\n";
    };
    exports2.drawBorder = drawBorder;
    var drawBorderTop = (columnWidths, parameters) => {
      const { border } = parameters;
      const result = (0, exports2.drawBorder)(columnWidths, {
        ...parameters,
        separator: {
          body: border.topBody,
          join: border.topJoin,
          left: border.topLeft,
          right: border.topRight
        }
      });
      if (result === "\n") {
        return "";
      }
      return result;
    };
    exports2.drawBorderTop = drawBorderTop;
    var drawBorderJoin = (columnWidths, parameters) => {
      const { border } = parameters;
      return (0, exports2.drawBorder)(columnWidths, {
        ...parameters,
        separator: {
          body: border.joinBody,
          bodyJoinInner: border.bodyJoin,
          bodyJoinOuter: border.bodyLeft,
          join: border.joinJoin,
          joinDown: border.joinMiddleDown,
          joinLeft: border.joinMiddleLeft,
          joinRight: border.joinMiddleRight,
          joinUp: border.joinMiddleUp,
          left: border.joinLeft,
          right: border.joinRight
        }
      });
    };
    exports2.drawBorderJoin = drawBorderJoin;
    var drawBorderBottom = (columnWidths, parameters) => {
      const { border } = parameters;
      return (0, exports2.drawBorder)(columnWidths, {
        ...parameters,
        separator: {
          body: border.bottomBody,
          join: border.bottomJoin,
          left: border.bottomLeft,
          right: border.bottomRight
        }
      });
    };
    exports2.drawBorderBottom = drawBorderBottom;
    var createTableBorderGetter = (columnWidths, parameters) => {
      return (index, size) => {
        const drawBorderParameters = {
          ...parameters,
          horizontalBorderIndex: index
        };
        if (index === 0) {
          return (0, exports2.drawBorderTop)(columnWidths, drawBorderParameters);
        } else if (index === size) {
          return (0, exports2.drawBorderBottom)(columnWidths, drawBorderParameters);
        }
        return (0, exports2.drawBorderJoin)(columnWidths, drawBorderParameters);
      };
    };
    exports2.createTableBorderGetter = createTableBorderGetter;
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/drawRow.js
var require_drawRow = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/drawRow.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.drawRow = void 0;
    var drawContent_1 = require_drawContent();
    var drawRow = (row, config) => {
      const { border, drawVerticalLine, rowIndex, spanningCellManager } = config;
      return (0, drawContent_1.drawContent)({
        contents: row,
        drawSeparator: drawVerticalLine,
        elementType: "cell",
        rowIndex,
        separatorGetter: (index, columnCount) => {
          if (index === 0) {
            return border.bodyLeft;
          }
          if (index === columnCount) {
            return border.bodyRight;
          }
          return border.bodyJoin;
        },
        spanningCellManager
      }) + "\n";
    };
    exports2.drawRow = drawRow;
  }
});

// node_modules/aws-cdk-lib/node_modules/fast-deep-equal/index.js
var require_fast_deep_equal = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/fast-deep-equal/index.js"(exports2, module2) {
    "use strict";
    module2.exports = function equal(a, b) {
      if (a === b)
        return true;
      if (a && b && typeof a == "object" && typeof b == "object") {
        if (a.constructor !== b.constructor)
          return false;
        var length, i, keys;
        if (Array.isArray(a)) {
          length = a.length;
          if (length != b.length)
            return false;
          for (i = length; i-- !== 0; )
            if (!equal(a[i], b[i]))
              return false;
          return true;
        }
        if (a.constructor === RegExp)
          return a.source === b.source && a.flags === b.flags;
        if (a.valueOf !== Object.prototype.valueOf)
          return a.valueOf() === b.valueOf();
        if (a.toString !== Object.prototype.toString)
          return a.toString() === b.toString();
        keys = Object.keys(a);
        length = keys.length;
        if (length !== Object.keys(b).length)
          return false;
        for (i = length; i-- !== 0; )
          if (!Object.prototype.hasOwnProperty.call(b, keys[i]))
            return false;
        for (i = length; i-- !== 0; ) {
          var key = keys[i];
          if (!equal(a[key], b[key]))
            return false;
        }
        return true;
      }
      return a !== a && b !== b;
    };
  }
});

// node_modules/aws-cdk-lib/node_modules/ajv/dist/runtime/equal.js
var require_equal = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/ajv/dist/runtime/equal.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var equal = require_fast_deep_equal();
    equal.code = 'require("ajv/dist/runtime/equal").default';
    exports2.default = equal;
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/generated/validators.js
var require_validators = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/generated/validators.js"(exports2) {
    "use strict";
    exports2["config.json"] = validate43;
    var schema13 = {
      "$id": "config.json",
      "$schema": "http://json-schema.org/draft-07/schema#",
      "type": "object",
      "properties": {
        "border": {
          "$ref": "shared.json#/definitions/borders"
        },
        "header": {
          "type": "object",
          "properties": {
            "content": {
              "type": "string"
            },
            "alignment": {
              "$ref": "shared.json#/definitions/alignment"
            },
            "wrapWord": {
              "type": "boolean"
            },
            "truncate": {
              "type": "integer"
            },
            "paddingLeft": {
              "type": "integer"
            },
            "paddingRight": {
              "type": "integer"
            }
          },
          "required": ["content"],
          "additionalProperties": false
        },
        "columns": {
          "$ref": "shared.json#/definitions/columns"
        },
        "columnDefault": {
          "$ref": "shared.json#/definitions/column"
        },
        "drawVerticalLine": {
          "typeof": "function"
        },
        "drawHorizontalLine": {
          "typeof": "function"
        },
        "singleLine": {
          "typeof": "boolean"
        },
        "spanningCells": {
          "type": "array",
          "items": {
            "type": "object",
            "properties": {
              "col": {
                "type": "integer",
                "minimum": 0
              },
              "row": {
                "type": "integer",
                "minimum": 0
              },
              "colSpan": {
                "type": "integer",
                "minimum": 1
              },
              "rowSpan": {
                "type": "integer",
                "minimum": 1
              },
              "alignment": {
                "$ref": "shared.json#/definitions/alignment"
              },
              "verticalAlignment": {
                "$ref": "shared.json#/definitions/verticalAlignment"
              },
              "wrapWord": {
                "type": "boolean"
              },
              "truncate": {
                "type": "integer"
              },
              "paddingLeft": {
                "type": "integer"
              },
              "paddingRight": {
                "type": "integer"
              }
            },
            "required": ["row", "col"],
            "additionalProperties": false
          }
        }
      },
      "additionalProperties": false
    };
    var schema15 = {
      "type": "object",
      "properties": {
        "topBody": {
          "$ref": "#/definitions/border"
        },
        "topJoin": {
          "$ref": "#/definitions/border"
        },
        "topLeft": {
          "$ref": "#/definitions/border"
        },
        "topRight": {
          "$ref": "#/definitions/border"
        },
        "bottomBody": {
          "$ref": "#/definitions/border"
        },
        "bottomJoin": {
          "$ref": "#/definitions/border"
        },
        "bottomLeft": {
          "$ref": "#/definitions/border"
        },
        "bottomRight": {
          "$ref": "#/definitions/border"
        },
        "bodyLeft": {
          "$ref": "#/definitions/border"
        },
        "bodyRight": {
          "$ref": "#/definitions/border"
        },
        "bodyJoin": {
          "$ref": "#/definitions/border"
        },
        "headerJoin": {
          "$ref": "#/definitions/border"
        },
        "joinBody": {
          "$ref": "#/definitions/border"
        },
        "joinLeft": {
          "$ref": "#/definitions/border"
        },
        "joinRight": {
          "$ref": "#/definitions/border"
        },
        "joinJoin": {
          "$ref": "#/definitions/border"
        },
        "joinMiddleUp": {
          "$ref": "#/definitions/border"
        },
        "joinMiddleDown": {
          "$ref": "#/definitions/border"
        },
        "joinMiddleLeft": {
          "$ref": "#/definitions/border"
        },
        "joinMiddleRight": {
          "$ref": "#/definitions/border"
        }
      },
      "additionalProperties": false
    };
    var func8 = Object.prototype.hasOwnProperty;
    function validate46(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) {
      let vErrors = null;
      let errors = 0;
      if (typeof data !== "string") {
        const err0 = {
          instancePath,
          schemaPath: "#/type",
          keyword: "type",
          params: {
            type: "string"
          },
          message: "must be string"
        };
        if (vErrors === null) {
          vErrors = [err0];
        } else {
          vErrors.push(err0);
        }
        errors++;
      }
      validate46.errors = vErrors;
      return errors === 0;
    }
    function validate45(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) {
      let vErrors = null;
      let errors = 0;
      if (data && typeof data == "object" && !Array.isArray(data)) {
        for (const key0 in data) {
          if (!func8.call(schema15.properties, key0)) {
            const err0 = {
              instancePath,
              schemaPath: "#/additionalProperties",
              keyword: "additionalProperties",
              params: {
                additionalProperty: key0
              },
              message: "must NOT have additional properties"
            };
            if (vErrors === null) {
              vErrors = [err0];
            } else {
              vErrors.push(err0);
            }
            errors++;
          }
        }
        if (data.topBody !== void 0) {
          if (!validate46(data.topBody, {
            instancePath: instancePath + "/topBody",
            parentData: data,
            parentDataProperty: "topBody",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.topJoin !== void 0) {
          if (!validate46(data.topJoin, {
            instancePath: instancePath + "/topJoin",
            parentData: data,
            parentDataProperty: "topJoin",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.topLeft !== void 0) {
          if (!validate46(data.topLeft, {
            instancePath: instancePath + "/topLeft",
            parentData: data,
            parentDataProperty: "topLeft",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.topRight !== void 0) {
          if (!validate46(data.topRight, {
            instancePath: instancePath + "/topRight",
            parentData: data,
            parentDataProperty: "topRight",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.bottomBody !== void 0) {
          if (!validate46(data.bottomBody, {
            instancePath: instancePath + "/bottomBody",
            parentData: data,
            parentDataProperty: "bottomBody",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.bottomJoin !== void 0) {
          if (!validate46(data.bottomJoin, {
            instancePath: instancePath + "/bottomJoin",
            parentData: data,
            parentDataProperty: "bottomJoin",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.bottomLeft !== void 0) {
          if (!validate46(data.bottomLeft, {
            instancePath: instancePath + "/bottomLeft",
            parentData: data,
            parentDataProperty: "bottomLeft",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.bottomRight !== void 0) {
          if (!validate46(data.bottomRight, {
            instancePath: instancePath + "/bottomRight",
            parentData: data,
            parentDataProperty: "bottomRight",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.bodyLeft !== void 0) {
          if (!validate46(data.bodyLeft, {
            instancePath: instancePath + "/bodyLeft",
            parentData: data,
            parentDataProperty: "bodyLeft",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.bodyRight !== void 0) {
          if (!validate46(data.bodyRight, {
            instancePath: instancePath + "/bodyRight",
            parentData: data,
            parentDataProperty: "bodyRight",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.bodyJoin !== void 0) {
          if (!validate46(data.bodyJoin, {
            instancePath: instancePath + "/bodyJoin",
            parentData: data,
            parentDataProperty: "bodyJoin",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.headerJoin !== void 0) {
          if (!validate46(data.headerJoin, {
            instancePath: instancePath + "/headerJoin",
            parentData: data,
            parentDataProperty: "headerJoin",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.joinBody !== void 0) {
          if (!validate46(data.joinBody, {
            instancePath: instancePath + "/joinBody",
            parentData: data,
            parentDataProperty: "joinBody",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.joinLeft !== void 0) {
          if (!validate46(data.joinLeft, {
            instancePath: instancePath + "/joinLeft",
            parentData: data,
            parentDataProperty: "joinLeft",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.joinRight !== void 0) {
          if (!validate46(data.joinRight, {
            instancePath: instancePath + "/joinRight",
            parentData: data,
            parentDataProperty: "joinRight",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.joinJoin !== void 0) {
          if (!validate46(data.joinJoin, {
            instancePath: instancePath + "/joinJoin",
            parentData: data,
            parentDataProperty: "joinJoin",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.joinMiddleUp !== void 0) {
          if (!validate46(data.joinMiddleUp, {
            instancePath: instancePath + "/joinMiddleUp",
            parentData: data,
            parentDataProperty: "joinMiddleUp",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.joinMiddleDown !== void 0) {
          if (!validate46(data.joinMiddleDown, {
            instancePath: instancePath + "/joinMiddleDown",
            parentData: data,
            parentDataProperty: "joinMiddleDown",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.joinMiddleLeft !== void 0) {
          if (!validate46(data.joinMiddleLeft, {
            instancePath: instancePath + "/joinMiddleLeft",
            parentData: data,
            parentDataProperty: "joinMiddleLeft",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.joinMiddleRight !== void 0) {
          if (!validate46(data.joinMiddleRight, {
            instancePath: instancePath + "/joinMiddleRight",
            parentData: data,
            parentDataProperty: "joinMiddleRight",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
      } else {
        const err1 = {
          instancePath,
          schemaPath: "#/type",
          keyword: "type",
          params: {
            type: "object"
          },
          message: "must be object"
        };
        if (vErrors === null) {
          vErrors = [err1];
        } else {
          vErrors.push(err1);
        }
        errors++;
      }
      validate45.errors = vErrors;
      return errors === 0;
    }
    var schema17 = {
      "type": "string",
      "enum": ["left", "right", "center", "justify"]
    };
    var func0 = require_equal().default;
    function validate68(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) {
      let vErrors = null;
      let errors = 0;
      if (typeof data !== "string") {
        const err0 = {
          instancePath,
          schemaPath: "#/type",
          keyword: "type",
          params: {
            type: "string"
          },
          message: "must be string"
        };
        if (vErrors === null) {
          vErrors = [err0];
        } else {
          vErrors.push(err0);
        }
        errors++;
      }
      if (!(data === "left" || data === "right" || data === "center" || data === "justify")) {
        const err1 = {
          instancePath,
          schemaPath: "#/enum",
          keyword: "enum",
          params: {
            allowedValues: schema17.enum
          },
          message: "must be equal to one of the allowed values"
        };
        if (vErrors === null) {
          vErrors = [err1];
        } else {
          vErrors.push(err1);
        }
        errors++;
      }
      validate68.errors = vErrors;
      return errors === 0;
    }
    var pattern0 = new RegExp("^[0-9]+$", "u");
    function validate72(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) {
      let vErrors = null;
      let errors = 0;
      if (typeof data !== "string") {
        const err0 = {
          instancePath,
          schemaPath: "#/type",
          keyword: "type",
          params: {
            type: "string"
          },
          message: "must be string"
        };
        if (vErrors === null) {
          vErrors = [err0];
        } else {
          vErrors.push(err0);
        }
        errors++;
      }
      if (!(data === "left" || data === "right" || data === "center" || data === "justify")) {
        const err1 = {
          instancePath,
          schemaPath: "#/enum",
          keyword: "enum",
          params: {
            allowedValues: schema17.enum
          },
          message: "must be equal to one of the allowed values"
        };
        if (vErrors === null) {
          vErrors = [err1];
        } else {
          vErrors.push(err1);
        }
        errors++;
      }
      validate72.errors = vErrors;
      return errors === 0;
    }
    var schema21 = {
      "type": "string",
      "enum": ["top", "middle", "bottom"]
    };
    function validate74(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) {
      let vErrors = null;
      let errors = 0;
      if (typeof data !== "string") {
        const err0 = {
          instancePath,
          schemaPath: "#/type",
          keyword: "type",
          params: {
            type: "string"
          },
          message: "must be string"
        };
        if (vErrors === null) {
          vErrors = [err0];
        } else {
          vErrors.push(err0);
        }
        errors++;
      }
      if (!(data === "top" || data === "middle" || data === "bottom")) {
        const err1 = {
          instancePath,
          schemaPath: "#/enum",
          keyword: "enum",
          params: {
            allowedValues: schema21.enum
          },
          message: "must be equal to one of the allowed values"
        };
        if (vErrors === null) {
          vErrors = [err1];
        } else {
          vErrors.push(err1);
        }
        errors++;
      }
      validate74.errors = vErrors;
      return errors === 0;
    }
    function validate71(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) {
      let vErrors = null;
      let errors = 0;
      if (data && typeof data == "object" && !Array.isArray(data)) {
        for (const key0 in data) {
          if (!(key0 === "alignment" || key0 === "verticalAlignment" || key0 === "width" || key0 === "wrapWord" || key0 === "truncate" || key0 === "paddingLeft" || key0 === "paddingRight")) {
            const err0 = {
              instancePath,
              schemaPath: "#/additionalProperties",
              keyword: "additionalProperties",
              params: {
                additionalProperty: key0
              },
              message: "must NOT have additional properties"
            };
            if (vErrors === null) {
              vErrors = [err0];
            } else {
              vErrors.push(err0);
            }
            errors++;
          }
        }
        if (data.alignment !== void 0) {
          if (!validate72(data.alignment, {
            instancePath: instancePath + "/alignment",
            parentData: data,
            parentDataProperty: "alignment",
            rootData
          })) {
            vErrors = vErrors === null ? validate72.errors : vErrors.concat(validate72.errors);
            errors = vErrors.length;
          }
        }
        if (data.verticalAlignment !== void 0) {
          if (!validate74(data.verticalAlignment, {
            instancePath: instancePath + "/verticalAlignment",
            parentData: data,
            parentDataProperty: "verticalAlignment",
            rootData
          })) {
            vErrors = vErrors === null ? validate74.errors : vErrors.concat(validate74.errors);
            errors = vErrors.length;
          }
        }
        if (data.width !== void 0) {
          let data2 = data.width;
          if (!(typeof data2 == "number" && (!(data2 % 1) && !isNaN(data2)) && isFinite(data2))) {
            const err1 = {
              instancePath: instancePath + "/width",
              schemaPath: "#/properties/width/type",
              keyword: "type",
              params: {
                type: "integer"
              },
              message: "must be integer"
            };
            if (vErrors === null) {
              vErrors = [err1];
            } else {
              vErrors.push(err1);
            }
            errors++;
          }
          if (typeof data2 == "number" && isFinite(data2)) {
            if (data2 < 1 || isNaN(data2)) {
              const err2 = {
                instancePath: instancePath + "/width",
                schemaPath: "#/properties/width/minimum",
                keyword: "minimum",
                params: {
                  comparison: ">=",
                  limit: 1
                },
                message: "must be >= 1"
              };
              if (vErrors === null) {
                vErrors = [err2];
              } else {
                vErrors.push(err2);
              }
              errors++;
            }
          }
        }
        if (data.wrapWord !== void 0) {
          if (typeof data.wrapWord !== "boolean") {
            const err3 = {
              instancePath: instancePath + "/wrapWord",
              schemaPath: "#/properties/wrapWord/type",
              keyword: "type",
              params: {
                type: "boolean"
              },
              message: "must be boolean"
            };
            if (vErrors === null) {
              vErrors = [err3];
            } else {
              vErrors.push(err3);
            }
            errors++;
          }
        }
        if (data.truncate !== void 0) {
          let data4 = data.truncate;
          if (!(typeof data4 == "number" && (!(data4 % 1) && !isNaN(data4)) && isFinite(data4))) {
            const err4 = {
              instancePath: instancePath + "/truncate",
              schemaPath: "#/properties/truncate/type",
              keyword: "type",
              params: {
                type: "integer"
              },
              message: "must be integer"
            };
            if (vErrors === null) {
              vErrors = [err4];
            } else {
              vErrors.push(err4);
            }
            errors++;
          }
        }
        if (data.paddingLeft !== void 0) {
          let data5 = data.paddingLeft;
          if (!(typeof data5 == "number" && (!(data5 % 1) && !isNaN(data5)) && isFinite(data5))) {
            const err5 = {
              instancePath: instancePath + "/paddingLeft",
              schemaPath: "#/properties/paddingLeft/type",
              keyword: "type",
              params: {
                type: "integer"
              },
              message: "must be integer"
            };
            if (vErrors === null) {
              vErrors = [err5];
            } else {
              vErrors.push(err5);
            }
            errors++;
          }
        }
        if (data.paddingRight !== void 0) {
          let data6 = data.paddingRight;
          if (!(typeof data6 == "number" && (!(data6 % 1) && !isNaN(data6)) && isFinite(data6))) {
            const err6 = {
              instancePath: instancePath + "/paddingRight",
              schemaPath: "#/properties/paddingRight/type",
              keyword: "type",
              params: {
                type: "integer"
              },
              message: "must be integer"
            };
            if (vErrors === null) {
              vErrors = [err6];
            } else {
              vErrors.push(err6);
            }
            errors++;
          }
        }
      } else {
        const err7 = {
          instancePath,
          schemaPath: "#/type",
          keyword: "type",
          params: {
            type: "object"
          },
          message: "must be object"
        };
        if (vErrors === null) {
          vErrors = [err7];
        } else {
          vErrors.push(err7);
        }
        errors++;
      }
      validate71.errors = vErrors;
      return errors === 0;
    }
    function validate70(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) {
      let vErrors = null;
      let errors = 0;
      const _errs0 = errors;
      let valid0 = false;
      let passing0 = null;
      const _errs1 = errors;
      if (data && typeof data == "object" && !Array.isArray(data)) {
        for (const key0 in data) {
          if (!pattern0.test(key0)) {
            const err0 = {
              instancePath,
              schemaPath: "#/oneOf/0/additionalProperties",
              keyword: "additionalProperties",
              params: {
                additionalProperty: key0
              },
              message: "must NOT have additional properties"
            };
            if (vErrors === null) {
              vErrors = [err0];
            } else {
              vErrors.push(err0);
            }
            errors++;
          }
        }
        for (const key1 in data) {
          if (pattern0.test(key1)) {
            if (!validate71(data[key1], {
              instancePath: instancePath + "/" + key1.replace(/~/g, "~0").replace(/\//g, "~1"),
              parentData: data,
              parentDataProperty: key1,
              rootData
            })) {
              vErrors = vErrors === null ? validate71.errors : vErrors.concat(validate71.errors);
              errors = vErrors.length;
            }
          }
        }
      } else {
        const err1 = {
          instancePath,
          schemaPath: "#/oneOf/0/type",
          keyword: "type",
          params: {
            type: "object"
          },
          message: "must be object"
        };
        if (vErrors === null) {
          vErrors = [err1];
        } else {
          vErrors.push(err1);
        }
        errors++;
      }
      var _valid0 = _errs1 === errors;
      if (_valid0) {
        valid0 = true;
        passing0 = 0;
      }
      const _errs5 = errors;
      if (Array.isArray(data)) {
        const len0 = data.length;
        for (let i0 = 0; i0 < len0; i0++) {
          if (!validate71(data[i0], {
            instancePath: instancePath + "/" + i0,
            parentData: data,
            parentDataProperty: i0,
            rootData
          })) {
            vErrors = vErrors === null ? validate71.errors : vErrors.concat(validate71.errors);
            errors = vErrors.length;
          }
        }
      } else {
        const err2 = {
          instancePath,
          schemaPath: "#/oneOf/1/type",
          keyword: "type",
          params: {
            type: "array"
          },
          message: "must be array"
        };
        if (vErrors === null) {
          vErrors = [err2];
        } else {
          vErrors.push(err2);
        }
        errors++;
      }
      var _valid0 = _errs5 === errors;
      if (_valid0 && valid0) {
        valid0 = false;
        passing0 = [passing0, 1];
      } else {
        if (_valid0) {
          valid0 = true;
          passing0 = 1;
        }
      }
      if (!valid0) {
        const err3 = {
          instancePath,
          schemaPath: "#/oneOf",
          keyword: "oneOf",
          params: {
            passingSchemas: passing0
          },
          message: "must match exactly one schema in oneOf"
        };
        if (vErrors === null) {
          vErrors = [err3];
        } else {
          vErrors.push(err3);
        }
        errors++;
      } else {
        errors = _errs0;
        if (vErrors !== null) {
          if (_errs0) {
            vErrors.length = _errs0;
          } else {
            vErrors = null;
          }
        }
      }
      validate70.errors = vErrors;
      return errors === 0;
    }
    function validate79(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) {
      let vErrors = null;
      let errors = 0;
      if (data && typeof data == "object" && !Array.isArray(data)) {
        for (const key0 in data) {
          if (!(key0 === "alignment" || key0 === "verticalAlignment" || key0 === "width" || key0 === "wrapWord" || key0 === "truncate" || key0 === "paddingLeft" || key0 === "paddingRight")) {
            const err0 = {
              instancePath,
              schemaPath: "#/additionalProperties",
              keyword: "additionalProperties",
              params: {
                additionalProperty: key0
              },
              message: "must NOT have additional properties"
            };
            if (vErrors === null) {
              vErrors = [err0];
            } else {
              vErrors.push(err0);
            }
            errors++;
          }
        }
        if (data.alignment !== void 0) {
          if (!validate72(data.alignment, {
            instancePath: instancePath + "/alignment",
            parentData: data,
            parentDataProperty: "alignment",
            rootData
          })) {
            vErrors = vErrors === null ? validate72.errors : vErrors.concat(validate72.errors);
            errors = vErrors.length;
          }
        }
        if (data.verticalAlignment !== void 0) {
          if (!validate74(data.verticalAlignment, {
            instancePath: instancePath + "/verticalAlignment",
            parentData: data,
            parentDataProperty: "verticalAlignment",
            rootData
          })) {
            vErrors = vErrors === null ? validate74.errors : vErrors.concat(validate74.errors);
            errors = vErrors.length;
          }
        }
        if (data.width !== void 0) {
          let data2 = data.width;
          if (!(typeof data2 == "number" && (!(data2 % 1) && !isNaN(data2)) && isFinite(data2))) {
            const err1 = {
              instancePath: instancePath + "/width",
              schemaPath: "#/properties/width/type",
              keyword: "type",
              params: {
                type: "integer"
              },
              message: "must be integer"
            };
            if (vErrors === null) {
              vErrors = [err1];
            } else {
              vErrors.push(err1);
            }
            errors++;
          }
          if (typeof data2 == "number" && isFinite(data2)) {
            if (data2 < 1 || isNaN(data2)) {
              const err2 = {
                instancePath: instancePath + "/width",
                schemaPath: "#/properties/width/minimum",
                keyword: "minimum",
                params: {
                  comparison: ">=",
                  limit: 1
                },
                message: "must be >= 1"
              };
              if (vErrors === null) {
                vErrors = [err2];
              } else {
                vErrors.push(err2);
              }
              errors++;
            }
          }
        }
        if (data.wrapWord !== void 0) {
          if (typeof data.wrapWord !== "boolean") {
            const err3 = {
              instancePath: instancePath + "/wrapWord",
              schemaPath: "#/properties/wrapWord/type",
              keyword: "type",
              params: {
                type: "boolean"
              },
              message: "must be boolean"
            };
            if (vErrors === null) {
              vErrors = [err3];
            } else {
              vErrors.push(err3);
            }
            errors++;
          }
        }
        if (data.truncate !== void 0) {
          let data4 = data.truncate;
          if (!(typeof data4 == "number" && (!(data4 % 1) && !isNaN(data4)) && isFinite(data4))) {
            const err4 = {
              instancePath: instancePath + "/truncate",
              schemaPath: "#/properties/truncate/type",
              keyword: "type",
              params: {
                type: "integer"
              },
              message: "must be integer"
            };
            if (vErrors === null) {
              vErrors = [err4];
            } else {
              vErrors.push(err4);
            }
            errors++;
          }
        }
        if (data.paddingLeft !== void 0) {
          let data5 = data.paddingLeft;
          if (!(typeof data5 == "number" && (!(data5 % 1) && !isNaN(data5)) && isFinite(data5))) {
            const err5 = {
              instancePath: instancePath + "/paddingLeft",
              schemaPath: "#/properties/paddingLeft/type",
              keyword: "type",
              params: {
                type: "integer"
              },
              message: "must be integer"
            };
            if (vErrors === null) {
              vErrors = [err5];
            } else {
              vErrors.push(err5);
            }
            errors++;
          }
        }
        if (data.paddingRight !== void 0) {
          let data6 = data.paddingRight;
          if (!(typeof data6 == "number" && (!(data6 % 1) && !isNaN(data6)) && isFinite(data6))) {
            const err6 = {
              instancePath: instancePath + "/paddingRight",
              schemaPath: "#/properties/paddingRight/type",
              keyword: "type",
              params: {
                type: "integer"
              },
              message: "must be integer"
            };
            if (vErrors === null) {
              vErrors = [err6];
            } else {
              vErrors.push(err6);
            }
            errors++;
          }
        }
      } else {
        const err7 = {
          instancePath,
          schemaPath: "#/type",
          keyword: "type",
          params: {
            type: "object"
          },
          message: "must be object"
        };
        if (vErrors === null) {
          vErrors = [err7];
        } else {
          vErrors.push(err7);
        }
        errors++;
      }
      validate79.errors = vErrors;
      return errors === 0;
    }
    function validate84(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) {
      let vErrors = null;
      let errors = 0;
      if (typeof data !== "string") {
        const err0 = {
          instancePath,
          schemaPath: "#/type",
          keyword: "type",
          params: {
            type: "string"
          },
          message: "must be string"
        };
        if (vErrors === null) {
          vErrors = [err0];
        } else {
          vErrors.push(err0);
        }
        errors++;
      }
      if (!(data === "top" || data === "middle" || data === "bottom")) {
        const err1 = {
          instancePath,
          schemaPath: "#/enum",
          keyword: "enum",
          params: {
            allowedValues: schema21.enum
          },
          message: "must be equal to one of the allowed values"
        };
        if (vErrors === null) {
          vErrors = [err1];
        } else {
          vErrors.push(err1);
        }
        errors++;
      }
      validate84.errors = vErrors;
      return errors === 0;
    }
    function validate43(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) {
      ;
      let vErrors = null;
      let errors = 0;
      if (data && typeof data == "object" && !Array.isArray(data)) {
        for (const key0 in data) {
          if (!(key0 === "border" || key0 === "header" || key0 === "columns" || key0 === "columnDefault" || key0 === "drawVerticalLine" || key0 === "drawHorizontalLine" || key0 === "singleLine" || key0 === "spanningCells")) {
            const err0 = {
              instancePath,
              schemaPath: "#/additionalProperties",
              keyword: "additionalProperties",
              params: {
                additionalProperty: key0
              },
              message: "must NOT have additional properties"
            };
            if (vErrors === null) {
              vErrors = [err0];
            } else {
              vErrors.push(err0);
            }
            errors++;
          }
        }
        if (data.border !== void 0) {
          if (!validate45(data.border, {
            instancePath: instancePath + "/border",
            parentData: data,
            parentDataProperty: "border",
            rootData
          })) {
            vErrors = vErrors === null ? validate45.errors : vErrors.concat(validate45.errors);
            errors = vErrors.length;
          }
        }
        if (data.header !== void 0) {
          let data1 = data.header;
          if (data1 && typeof data1 == "object" && !Array.isArray(data1)) {
            if (data1.content === void 0) {
              const err1 = {
                instancePath: instancePath + "/header",
                schemaPath: "#/properties/header/required",
                keyword: "required",
                params: {
                  missingProperty: "content"
                },
                message: "must have required property 'content'"
              };
              if (vErrors === null) {
                vErrors = [err1];
              } else {
                vErrors.push(err1);
              }
              errors++;
            }
            for (const key1 in data1) {
              if (!(key1 === "content" || key1 === "alignment" || key1 === "wrapWord" || key1 === "truncate" || key1 === "paddingLeft" || key1 === "paddingRight")) {
                const err2 = {
                  instancePath: instancePath + "/header",
                  schemaPath: "#/properties/header/additionalProperties",
                  keyword: "additionalProperties",
                  params: {
                    additionalProperty: key1
                  },
                  message: "must NOT have additional properties"
                };
                if (vErrors === null) {
                  vErrors = [err2];
                } else {
                  vErrors.push(err2);
                }
                errors++;
              }
            }
            if (data1.content !== void 0) {
              if (typeof data1.content !== "string") {
                const err3 = {
                  instancePath: instancePath + "/header/content",
                  schemaPath: "#/properties/header/properties/content/type",
                  keyword: "type",
                  params: {
                    type: "string"
                  },
                  message: "must be string"
                };
                if (vErrors === null) {
                  vErrors = [err3];
                } else {
                  vErrors.push(err3);
                }
                errors++;
              }
            }
            if (data1.alignment !== void 0) {
              if (!validate68(data1.alignment, {
                instancePath: instancePath + "/header/alignment",
                parentData: data1,
                parentDataProperty: "alignment",
                rootData
              })) {
                vErrors = vErrors === null ? validate68.errors : vErrors.concat(validate68.errors);
                errors = vErrors.length;
              }
            }
            if (data1.wrapWord !== void 0) {
              if (typeof data1.wrapWord !== "boolean") {
                const err4 = {
                  instancePath: instancePath + "/header/wrapWord",
                  schemaPath: "#/properties/header/properties/wrapWord/type",
                  keyword: "type",
                  params: {
                    type: "boolean"
                  },
                  message: "must be boolean"
                };
                if (vErrors === null) {
                  vErrors = [err4];
                } else {
                  vErrors.push(err4);
                }
                errors++;
              }
            }
            if (data1.truncate !== void 0) {
              let data5 = data1.truncate;
              if (!(typeof data5 == "number" && (!(data5 % 1) && !isNaN(data5)) && isFinite(data5))) {
                const err5 = {
                  instancePath: instancePath + "/header/truncate",
                  schemaPath: "#/properties/header/properties/truncate/type",
                  keyword: "type",
                  params: {
                    type: "integer"
                  },
                  message: "must be integer"
                };
                if (vErrors === null) {
                  vErrors = [err5];
                } else {
                  vErrors.push(err5);
                }
                errors++;
              }
            }
            if (data1.paddingLeft !== void 0) {
              let data6 = data1.paddingLeft;
              if (!(typeof data6 == "number" && (!(data6 % 1) && !isNaN(data6)) && isFinite(data6))) {
                const err6 = {
                  instancePath: instancePath + "/header/paddingLeft",
                  schemaPath: "#/properties/header/properties/paddingLeft/type",
                  keyword: "type",
                  params: {
                    type: "integer"
                  },
                  message: "must be integer"
                };
                if (vErrors === null) {
                  vErrors = [err6];
                } else {
                  vErrors.push(err6);
                }
                errors++;
              }
            }
            if (data1.paddingRight !== void 0) {
              let data7 = data1.paddingRight;
              if (!(typeof data7 == "number" && (!(data7 % 1) && !isNaN(data7)) && isFinite(data7))) {
                const err7 = {
                  instancePath: instancePath + "/header/paddingRight",
                  schemaPath: "#/properties/header/properties/paddingRight/type",
                  keyword: "type",
                  params: {
                    type: "integer"
                  },
                  message: "must be integer"
                };
                if (vErrors === null) {
                  vErrors = [err7];
                } else {
                  vErrors.push(err7);
                }
                errors++;
              }
            }
          } else {
            const err8 = {
              instancePath: instancePath + "/header",
              schemaPath: "#/properties/header/type",
              keyword: "type",
              params: {
                type: "object"
              },
              message: "must be object"
            };
            if (vErrors === null) {
              vErrors = [err8];
            } else {
              vErrors.push(err8);
            }
            errors++;
          }
        }
        if (data.columns !== void 0) {
          if (!validate70(data.columns, {
            instancePath: instancePath + "/columns",
            parentData: data,
            parentDataProperty: "columns",
            rootData
          })) {
            vErrors = vErrors === null ? validate70.errors : vErrors.concat(validate70.errors);
            errors = vErrors.length;
          }
        }
        if (data.columnDefault !== void 0) {
          if (!validate79(data.columnDefault, {
            instancePath: instancePath + "/columnDefault",
            parentData: data,
            parentDataProperty: "columnDefault",
            rootData
          })) {
            vErrors = vErrors === null ? validate79.errors : vErrors.concat(validate79.errors);
            errors = vErrors.length;
          }
        }
        if (data.drawVerticalLine !== void 0) {
          if (typeof data.drawVerticalLine != "function") {
            const err9 = {
              instancePath: instancePath + "/drawVerticalLine",
              schemaPath: "#/properties/drawVerticalLine/typeof",
              keyword: "typeof",
              params: {},
              message: 'must pass "typeof" keyword validation'
            };
            if (vErrors === null) {
              vErrors = [err9];
            } else {
              vErrors.push(err9);
            }
            errors++;
          }
        }
        if (data.drawHorizontalLine !== void 0) {
          if (typeof data.drawHorizontalLine != "function") {
            const err10 = {
              instancePath: instancePath + "/drawHorizontalLine",
              schemaPath: "#/properties/drawHorizontalLine/typeof",
              keyword: "typeof",
              params: {},
              message: 'must pass "typeof" keyword validation'
            };
            if (vErrors === null) {
              vErrors = [err10];
            } else {
              vErrors.push(err10);
            }
            errors++;
          }
        }
        if (data.singleLine !== void 0) {
          if (typeof data.singleLine != "boolean") {
            const err11 = {
              instancePath: instancePath + "/singleLine",
              schemaPath: "#/properties/singleLine/typeof",
              keyword: "typeof",
              params: {},
              message: 'must pass "typeof" keyword validation'
            };
            if (vErrors === null) {
              vErrors = [err11];
            } else {
              vErrors.push(err11);
            }
            errors++;
          }
        }
        if (data.spanningCells !== void 0) {
          let data13 = data.spanningCells;
          if (Array.isArray(data13)) {
            const len0 = data13.length;
            for (let i0 = 0; i0 < len0; i0++) {
              let data14 = data13[i0];
              if (data14 && typeof data14 == "object" && !Array.isArray(data14)) {
                if (data14.row === void 0) {
                  const err12 = {
                    instancePath: instancePath + "/spanningCells/" + i0,
                    schemaPath: "#/properties/spanningCells/items/required",
                    keyword: "required",
                    params: {
                      missingProperty: "row"
                    },
                    message: "must have required property 'row'"
                  };
                  if (vErrors === null) {
                    vErrors = [err12];
                  } else {
                    vErrors.push(err12);
                  }
                  errors++;
                }
                if (data14.col === void 0) {
                  const err13 = {
                    instancePath: instancePath + "/spanningCells/" + i0,
                    schemaPath: "#/properties/spanningCells/items/required",
                    keyword: "required",
                    params: {
                      missingProperty: "col"
                    },
                    message: "must have required property 'col'"
                  };
                  if (vErrors === null) {
                    vErrors = [err13];
                  } else {
                    vErrors.push(err13);
                  }
                  errors++;
                }
                for (const key2 in data14) {
                  if (!func8.call(schema13.properties.spanningCells.items.properties, key2)) {
                    const err14 = {
                      instancePath: instancePath + "/spanningCells/" + i0,
                      schemaPath: "#/properties/spanningCells/items/additionalProperties",
                      keyword: "additionalProperties",
                      params: {
                        additionalProperty: key2
                      },
                      message: "must NOT have additional properties"
                    };
                    if (vErrors === null) {
                      vErrors = [err14];
                    } else {
                      vErrors.push(err14);
                    }
                    errors++;
                  }
                }
                if (data14.col !== void 0) {
                  let data15 = data14.col;
                  if (!(typeof data15 == "number" && (!(data15 % 1) && !isNaN(data15)) && isFinite(data15))) {
                    const err15 = {
                      instancePath: instancePath + "/spanningCells/" + i0 + "/col",
                      schemaPath: "#/properties/spanningCells/items/properties/col/type",
                      keyword: "type",
                      params: {
                        type: "integer"
                      },
                      message: "must be integer"
                    };
                    if (vErrors === null) {
                      vErrors = [err15];
                    } else {
                      vErrors.push(err15);
                    }
                    errors++;
                  }
                  if (typeof data15 == "number" && isFinite(data15)) {
                    if (data15 < 0 || isNaN(data15)) {
                      const err16 = {
                        instancePath: instancePath + "/spanningCells/" + i0 + "/col",
                        schemaPath: "#/properties/spanningCells/items/properties/col/minimum",
                        keyword: "minimum",
                        params: {
                          comparison: ">=",
                          limit: 0
                        },
                        message: "must be >= 0"
                      };
                      if (vErrors === null) {
                        vErrors = [err16];
                      } else {
                        vErrors.push(err16);
                      }
                      errors++;
                    }
                  }
                }
                if (data14.row !== void 0) {
                  let data16 = data14.row;
                  if (!(typeof data16 == "number" && (!(data16 % 1) && !isNaN(data16)) && isFinite(data16))) {
                    const err17 = {
                      instancePath: instancePath + "/spanningCells/" + i0 + "/row",
                      schemaPath: "#/properties/spanningCells/items/properties/row/type",
                      keyword: "type",
                      params: {
                        type: "integer"
                      },
                      message: "must be integer"
                    };
                    if (vErrors === null) {
                      vErrors = [err17];
                    } else {
                      vErrors.push(err17);
                    }
                    errors++;
                  }
                  if (typeof data16 == "number" && isFinite(data16)) {
                    if (data16 < 0 || isNaN(data16)) {
                      const err18 = {
                        instancePath: instancePath + "/spanningCells/" + i0 + "/row",
                        schemaPath: "#/properties/spanningCells/items/properties/row/minimum",
                        keyword: "minimum",
                        params: {
                          comparison: ">=",
                          limit: 0
                        },
                        message: "must be >= 0"
                      };
                      if (vErrors === null) {
                        vErrors = [err18];
                      } else {
                        vErrors.push(err18);
                      }
                      errors++;
                    }
                  }
                }
                if (data14.colSpan !== void 0) {
                  let data17 = data14.colSpan;
                  if (!(typeof data17 == "number" && (!(data17 % 1) && !isNaN(data17)) && isFinite(data17))) {
                    const err19 = {
                      instancePath: instancePath + "/spanningCells/" + i0 + "/colSpan",
                      schemaPath: "#/properties/spanningCells/items/properties/colSpan/type",
                      keyword: "type",
                      params: {
                        type: "integer"
                      },
                      message: "must be integer"
                    };
                    if (vErrors === null) {
                      vErrors = [err19];
                    } else {
                      vErrors.push(err19);
                    }
                    errors++;
                  }
                  if (typeof data17 == "number" && isFinite(data17)) {
                    if (data17 < 1 || isNaN(data17)) {
                      const err20 = {
                        instancePath: instancePath + "/spanningCells/" + i0 + "/colSpan",
                        schemaPath: "#/properties/spanningCells/items/properties/colSpan/minimum",
                        keyword: "minimum",
                        params: {
                          comparison: ">=",
                          limit: 1
                        },
                        message: "must be >= 1"
                      };
                      if (vErrors === null) {
                        vErrors = [err20];
                      } else {
                        vErrors.push(err20);
                      }
                      errors++;
                    }
                  }
                }
                if (data14.rowSpan !== void 0) {
                  let data18 = data14.rowSpan;
                  if (!(typeof data18 == "number" && (!(data18 % 1) && !isNaN(data18)) && isFinite(data18))) {
                    const err21 = {
                      instancePath: instancePath + "/spanningCells/" + i0 + "/rowSpan",
                      schemaPath: "#/properties/spanningCells/items/properties/rowSpan/type",
                      keyword: "type",
                      params: {
                        type: "integer"
                      },
                      message: "must be integer"
                    };
                    if (vErrors === null) {
                      vErrors = [err21];
                    } else {
                      vErrors.push(err21);
                    }
                    errors++;
                  }
                  if (typeof data18 == "number" && isFinite(data18)) {
                    if (data18 < 1 || isNaN(data18)) {
                      const err22 = {
                        instancePath: instancePath + "/spanningCells/" + i0 + "/rowSpan",
                        schemaPath: "#/properties/spanningCells/items/properties/rowSpan/minimum",
                        keyword: "minimum",
                        params: {
                          comparison: ">=",
                          limit: 1
                        },
                        message: "must be >= 1"
                      };
                      if (vErrors === null) {
                        vErrors = [err22];
                      } else {
                        vErrors.push(err22);
                      }
                      errors++;
                    }
                  }
                }
                if (data14.alignment !== void 0) {
                  if (!validate68(data14.alignment, {
                    instancePath: instancePath + "/spanningCells/" + i0 + "/alignment",
                    parentData: data14,
                    parentDataProperty: "alignment",
                    rootData
                  })) {
                    vErrors = vErrors === null ? validate68.errors : vErrors.concat(validate68.errors);
                    errors = vErrors.length;
                  }
                }
                if (data14.verticalAlignment !== void 0) {
                  if (!validate84(data14.verticalAlignment, {
                    instancePath: instancePath + "/spanningCells/" + i0 + "/verticalAlignment",
                    parentData: data14,
                    parentDataProperty: "verticalAlignment",
                    rootData
                  })) {
                    vErrors = vErrors === null ? validate84.errors : vErrors.concat(validate84.errors);
                    errors = vErrors.length;
                  }
                }
                if (data14.wrapWord !== void 0) {
                  if (typeof data14.wrapWord !== "boolean") {
                    const err23 = {
                      instancePath: instancePath + "/spanningCells/" + i0 + "/wrapWord",
                      schemaPath: "#/properties/spanningCells/items/properties/wrapWord/type",
                      keyword: "type",
                      params: {
                        type: "boolean"
                      },
                      message: "must be boolean"
                    };
                    if (vErrors === null) {
                      vErrors = [err23];
                    } else {
                      vErrors.push(err23);
                    }
                    errors++;
                  }
                }
                if (data14.truncate !== void 0) {
                  let data22 = data14.truncate;
                  if (!(typeof data22 == "number" && (!(data22 % 1) && !isNaN(data22)) && isFinite(data22))) {
                    const err24 = {
                      instancePath: instancePath + "/spanningCells/" + i0 + "/truncate",
                      schemaPath: "#/properties/spanningCells/items/properties/truncate/type",
                      keyword: "type",
                      params: {
                        type: "integer"
                      },
                      message: "must be integer"
                    };
                    if (vErrors === null) {
                      vErrors = [err24];
                    } else {
                      vErrors.push(err24);
                    }
                    errors++;
                  }
                }
                if (data14.paddingLeft !== void 0) {
                  let data23 = data14.paddingLeft;
                  if (!(typeof data23 == "number" && (!(data23 % 1) && !isNaN(data23)) && isFinite(data23))) {
                    const err25 = {
                      instancePath: instancePath + "/spanningCells/" + i0 + "/paddingLeft",
                      schemaPath: "#/properties/spanningCells/items/properties/paddingLeft/type",
                      keyword: "type",
                      params: {
                        type: "integer"
                      },
                      message: "must be integer"
                    };
                    if (vErrors === null) {
                      vErrors = [err25];
                    } else {
                      vErrors.push(err25);
                    }
                    errors++;
                  }
                }
                if (data14.paddingRight !== void 0) {
                  let data24 = data14.paddingRight;
                  if (!(typeof data24 == "number" && (!(data24 % 1) && !isNaN(data24)) && isFinite(data24))) {
                    const err26 = {
                      instancePath: instancePath + "/spanningCells/" + i0 + "/paddingRight",
                      schemaPath: "#/properties/spanningCells/items/properties/paddingRight/type",
                      keyword: "type",
                      params: {
                        type: "integer"
                      },
                      message: "must be integer"
                    };
                    if (vErrors === null) {
                      vErrors = [err26];
                    } else {
                      vErrors.push(err26);
                    }
                    errors++;
                  }
                }
              } else {
                const err27 = {
                  instancePath: instancePath + "/spanningCells/" + i0,
                  schemaPath: "#/properties/spanningCells/items/type",
                  keyword: "type",
                  params: {
                    type: "object"
                  },
                  message: "must be object"
                };
                if (vErrors === null) {
                  vErrors = [err27];
                } else {
                  vErrors.push(err27);
                }
                errors++;
              }
            }
          } else {
            const err28 = {
              instancePath: instancePath + "/spanningCells",
              schemaPath: "#/properties/spanningCells/type",
              keyword: "type",
              params: {
                type: "array"
              },
              message: "must be array"
            };
            if (vErrors === null) {
              vErrors = [err28];
            } else {
              vErrors.push(err28);
            }
            errors++;
          }
        }
      } else {
        const err29 = {
          instancePath,
          schemaPath: "#/type",
          keyword: "type",
          params: {
            type: "object"
          },
          message: "must be object"
        };
        if (vErrors === null) {
          vErrors = [err29];
        } else {
          vErrors.push(err29);
        }
        errors++;
      }
      validate43.errors = vErrors;
      return errors === 0;
    }
    exports2["streamConfig.json"] = validate86;
    function validate87(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) {
      let vErrors = null;
      let errors = 0;
      if (data && typeof data == "object" && !Array.isArray(data)) {
        for (const key0 in data) {
          if (!func8.call(schema15.properties, key0)) {
            const err0 = {
              instancePath,
              schemaPath: "#/additionalProperties",
              keyword: "additionalProperties",
              params: {
                additionalProperty: key0
              },
              message: "must NOT have additional properties"
            };
            if (vErrors === null) {
              vErrors = [err0];
            } else {
              vErrors.push(err0);
            }
            errors++;
          }
        }
        if (data.topBody !== void 0) {
          if (!validate46(data.topBody, {
            instancePath: instancePath + "/topBody",
            parentData: data,
            parentDataProperty: "topBody",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.topJoin !== void 0) {
          if (!validate46(data.topJoin, {
            instancePath: instancePath + "/topJoin",
            parentData: data,
            parentDataProperty: "topJoin",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.topLeft !== void 0) {
          if (!validate46(data.topLeft, {
            instancePath: instancePath + "/topLeft",
            parentData: data,
            parentDataProperty: "topLeft",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.topRight !== void 0) {
          if (!validate46(data.topRight, {
            instancePath: instancePath + "/topRight",
            parentData: data,
            parentDataProperty: "topRight",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.bottomBody !== void 0) {
          if (!validate46(data.bottomBody, {
            instancePath: instancePath + "/bottomBody",
            parentData: data,
            parentDataProperty: "bottomBody",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.bottomJoin !== void 0) {
          if (!validate46(data.bottomJoin, {
            instancePath: instancePath + "/bottomJoin",
            parentData: data,
            parentDataProperty: "bottomJoin",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.bottomLeft !== void 0) {
          if (!validate46(data.bottomLeft, {
            instancePath: instancePath + "/bottomLeft",
            parentData: data,
            parentDataProperty: "bottomLeft",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.bottomRight !== void 0) {
          if (!validate46(data.bottomRight, {
            instancePath: instancePath + "/bottomRight",
            parentData: data,
            parentDataProperty: "bottomRight",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.bodyLeft !== void 0) {
          if (!validate46(data.bodyLeft, {
            instancePath: instancePath + "/bodyLeft",
            parentData: data,
            parentDataProperty: "bodyLeft",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.bodyRight !== void 0) {
          if (!validate46(data.bodyRight, {
            instancePath: instancePath + "/bodyRight",
            parentData: data,
            parentDataProperty: "bodyRight",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.bodyJoin !== void 0) {
          if (!validate46(data.bodyJoin, {
            instancePath: instancePath + "/bodyJoin",
            parentData: data,
            parentDataProperty: "bodyJoin",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.headerJoin !== void 0) {
          if (!validate46(data.headerJoin, {
            instancePath: instancePath + "/headerJoin",
            parentData: data,
            parentDataProperty: "headerJoin",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.joinBody !== void 0) {
          if (!validate46(data.joinBody, {
            instancePath: instancePath + "/joinBody",
            parentData: data,
            parentDataProperty: "joinBody",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.joinLeft !== void 0) {
          if (!validate46(data.joinLeft, {
            instancePath: instancePath + "/joinLeft",
            parentData: data,
            parentDataProperty: "joinLeft",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.joinRight !== void 0) {
          if (!validate46(data.joinRight, {
            instancePath: instancePath + "/joinRight",
            parentData: data,
            parentDataProperty: "joinRight",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.joinJoin !== void 0) {
          if (!validate46(data.joinJoin, {
            instancePath: instancePath + "/joinJoin",
            parentData: data,
            parentDataProperty: "joinJoin",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.joinMiddleUp !== void 0) {
          if (!validate46(data.joinMiddleUp, {
            instancePath: instancePath + "/joinMiddleUp",
            parentData: data,
            parentDataProperty: "joinMiddleUp",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.joinMiddleDown !== void 0) {
          if (!validate46(data.joinMiddleDown, {
            instancePath: instancePath + "/joinMiddleDown",
            parentData: data,
            parentDataProperty: "joinMiddleDown",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.joinMiddleLeft !== void 0) {
          if (!validate46(data.joinMiddleLeft, {
            instancePath: instancePath + "/joinMiddleLeft",
            parentData: data,
            parentDataProperty: "joinMiddleLeft",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
        if (data.joinMiddleRight !== void 0) {
          if (!validate46(data.joinMiddleRight, {
            instancePath: instancePath + "/joinMiddleRight",
            parentData: data,
            parentDataProperty: "joinMiddleRight",
            rootData
          })) {
            vErrors = vErrors === null ? validate46.errors : vErrors.concat(validate46.errors);
            errors = vErrors.length;
          }
        }
      } else {
        const err1 = {
          instancePath,
          schemaPath: "#/type",
          keyword: "type",
          params: {
            type: "object"
          },
          message: "must be object"
        };
        if (vErrors === null) {
          vErrors = [err1];
        } else {
          vErrors.push(err1);
        }
        errors++;
      }
      validate87.errors = vErrors;
      return errors === 0;
    }
    function validate109(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) {
      let vErrors = null;
      let errors = 0;
      const _errs0 = errors;
      let valid0 = false;
      let passing0 = null;
      const _errs1 = errors;
      if (data && typeof data == "object" && !Array.isArray(data)) {
        for (const key0 in data) {
          if (!pattern0.test(key0)) {
            const err0 = {
              instancePath,
              schemaPath: "#/oneOf/0/additionalProperties",
              keyword: "additionalProperties",
              params: {
                additionalProperty: key0
              },
              message: "must NOT have additional properties"
            };
            if (vErrors === null) {
              vErrors = [err0];
            } else {
              vErrors.push(err0);
            }
            errors++;
          }
        }
        for (const key1 in data) {
          if (pattern0.test(key1)) {
            if (!validate71(data[key1], {
              instancePath: instancePath + "/" + key1.replace(/~/g, "~0").replace(/\//g, "~1"),
              parentData: data,
              parentDataProperty: key1,
              rootData
            })) {
              vErrors = vErrors === null ? validate71.errors : vErrors.concat(validate71.errors);
              errors = vErrors.length;
            }
          }
        }
      } else {
        const err1 = {
          instancePath,
          schemaPath: "#/oneOf/0/type",
          keyword: "type",
          params: {
            type: "object"
          },
          message: "must be object"
        };
        if (vErrors === null) {
          vErrors = [err1];
        } else {
          vErrors.push(err1);
        }
        errors++;
      }
      var _valid0 = _errs1 === errors;
      if (_valid0) {
        valid0 = true;
        passing0 = 0;
      }
      const _errs5 = errors;
      if (Array.isArray(data)) {
        const len0 = data.length;
        for (let i0 = 0; i0 < len0; i0++) {
          if (!validate71(data[i0], {
            instancePath: instancePath + "/" + i0,
            parentData: data,
            parentDataProperty: i0,
            rootData
          })) {
            vErrors = vErrors === null ? validate71.errors : vErrors.concat(validate71.errors);
            errors = vErrors.length;
          }
        }
      } else {
        const err2 = {
          instancePath,
          schemaPath: "#/oneOf/1/type",
          keyword: "type",
          params: {
            type: "array"
          },
          message: "must be array"
        };
        if (vErrors === null) {
          vErrors = [err2];
        } else {
          vErrors.push(err2);
        }
        errors++;
      }
      var _valid0 = _errs5 === errors;
      if (_valid0 && valid0) {
        valid0 = false;
        passing0 = [passing0, 1];
      } else {
        if (_valid0) {
          valid0 = true;
          passing0 = 1;
        }
      }
      if (!valid0) {
        const err3 = {
          instancePath,
          schemaPath: "#/oneOf",
          keyword: "oneOf",
          params: {
            passingSchemas: passing0
          },
          message: "must match exactly one schema in oneOf"
        };
        if (vErrors === null) {
          vErrors = [err3];
        } else {
          vErrors.push(err3);
        }
        errors++;
      } else {
        errors = _errs0;
        if (vErrors !== null) {
          if (_errs0) {
            vErrors.length = _errs0;
          } else {
            vErrors = null;
          }
        }
      }
      validate109.errors = vErrors;
      return errors === 0;
    }
    function validate113(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) {
      let vErrors = null;
      let errors = 0;
      if (data && typeof data == "object" && !Array.isArray(data)) {
        for (const key0 in data) {
          if (!(key0 === "alignment" || key0 === "verticalAlignment" || key0 === "width" || key0 === "wrapWord" || key0 === "truncate" || key0 === "paddingLeft" || key0 === "paddingRight")) {
            const err0 = {
              instancePath,
              schemaPath: "#/additionalProperties",
              keyword: "additionalProperties",
              params: {
                additionalProperty: key0
              },
              message: "must NOT have additional properties"
            };
            if (vErrors === null) {
              vErrors = [err0];
            } else {
              vErrors.push(err0);
            }
            errors++;
          }
        }
        if (data.alignment !== void 0) {
          if (!validate72(data.alignment, {
            instancePath: instancePath + "/alignment",
            parentData: data,
            parentDataProperty: "alignment",
            rootData
          })) {
            vErrors = vErrors === null ? validate72.errors : vErrors.concat(validate72.errors);
            errors = vErrors.length;
          }
        }
        if (data.verticalAlignment !== void 0) {
          if (!validate74(data.verticalAlignment, {
            instancePath: instancePath + "/verticalAlignment",
            parentData: data,
            parentDataProperty: "verticalAlignment",
            rootData
          })) {
            vErrors = vErrors === null ? validate74.errors : vErrors.concat(validate74.errors);
            errors = vErrors.length;
          }
        }
        if (data.width !== void 0) {
          let data2 = data.width;
          if (!(typeof data2 == "number" && (!(data2 % 1) && !isNaN(data2)) && isFinite(data2))) {
            const err1 = {
              instancePath: instancePath + "/width",
              schemaPath: "#/properties/width/type",
              keyword: "type",
              params: {
                type: "integer"
              },
              message: "must be integer"
            };
            if (vErrors === null) {
              vErrors = [err1];
            } else {
              vErrors.push(err1);
            }
            errors++;
          }
          if (typeof data2 == "number" && isFinite(data2)) {
            if (data2 < 1 || isNaN(data2)) {
              const err2 = {
                instancePath: instancePath + "/width",
                schemaPath: "#/properties/width/minimum",
                keyword: "minimum",
                params: {
                  comparison: ">=",
                  limit: 1
                },
                message: "must be >= 1"
              };
              if (vErrors === null) {
                vErrors = [err2];
              } else {
                vErrors.push(err2);
              }
              errors++;
            }
          }
        }
        if (data.wrapWord !== void 0) {
          if (typeof data.wrapWord !== "boolean") {
            const err3 = {
              instancePath: instancePath + "/wrapWord",
              schemaPath: "#/properties/wrapWord/type",
              keyword: "type",
              params: {
                type: "boolean"
              },
              message: "must be boolean"
            };
            if (vErrors === null) {
              vErrors = [err3];
            } else {
              vErrors.push(err3);
            }
            errors++;
          }
        }
        if (data.truncate !== void 0) {
          let data4 = data.truncate;
          if (!(typeof data4 == "number" && (!(data4 % 1) && !isNaN(data4)) && isFinite(data4))) {
            const err4 = {
              instancePath: instancePath + "/truncate",
              schemaPath: "#/properties/truncate/type",
              keyword: "type",
              params: {
                type: "integer"
              },
              message: "must be integer"
            };
            if (vErrors === null) {
              vErrors = [err4];
            } else {
              vErrors.push(err4);
            }
            errors++;
          }
        }
        if (data.paddingLeft !== void 0) {
          let data5 = data.paddingLeft;
          if (!(typeof data5 == "number" && (!(data5 % 1) && !isNaN(data5)) && isFinite(data5))) {
            const err5 = {
              instancePath: instancePath + "/paddingLeft",
              schemaPath: "#/properties/paddingLeft/type",
              keyword: "type",
              params: {
                type: "integer"
              },
              message: "must be integer"
            };
            if (vErrors === null) {
              vErrors = [err5];
            } else {
              vErrors.push(err5);
            }
            errors++;
          }
        }
        if (data.paddingRight !== void 0) {
          let data6 = data.paddingRight;
          if (!(typeof data6 == "number" && (!(data6 % 1) && !isNaN(data6)) && isFinite(data6))) {
            const err6 = {
              instancePath: instancePath + "/paddingRight",
              schemaPath: "#/properties/paddingRight/type",
              keyword: "type",
              params: {
                type: "integer"
              },
              message: "must be integer"
            };
            if (vErrors === null) {
              vErrors = [err6];
            } else {
              vErrors.push(err6);
            }
            errors++;
          }
        }
      } else {
        const err7 = {
          instancePath,
          schemaPath: "#/type",
          keyword: "type",
          params: {
            type: "object"
          },
          message: "must be object"
        };
        if (vErrors === null) {
          vErrors = [err7];
        } else {
          vErrors.push(err7);
        }
        errors++;
      }
      validate113.errors = vErrors;
      return errors === 0;
    }
    function validate86(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) {
      ;
      let vErrors = null;
      let errors = 0;
      if (data && typeof data == "object" && !Array.isArray(data)) {
        if (data.columnDefault === void 0) {
          const err0 = {
            instancePath,
            schemaPath: "#/required",
            keyword: "required",
            params: {
              missingProperty: "columnDefault"
            },
            message: "must have required property 'columnDefault'"
          };
          if (vErrors === null) {
            vErrors = [err0];
          } else {
            vErrors.push(err0);
          }
          errors++;
        }
        if (data.columnCount === void 0) {
          const err1 = {
            instancePath,
            schemaPath: "#/required",
            keyword: "required",
            params: {
              missingProperty: "columnCount"
            },
            message: "must have required property 'columnCount'"
          };
          if (vErrors === null) {
            vErrors = [err1];
          } else {
            vErrors.push(err1);
          }
          errors++;
        }
        for (const key0 in data) {
          if (!(key0 === "border" || key0 === "columns" || key0 === "columnDefault" || key0 === "columnCount" || key0 === "drawVerticalLine")) {
            const err2 = {
              instancePath,
              schemaPath: "#/additionalProperties",
              keyword: "additionalProperties",
              params: {
                additionalProperty: key0
              },
              message: "must NOT have additional properties"
            };
            if (vErrors === null) {
              vErrors = [err2];
            } else {
              vErrors.push(err2);
            }
            errors++;
          }
        }
        if (data.border !== void 0) {
          if (!validate87(data.border, {
            instancePath: instancePath + "/border",
            parentData: data,
            parentDataProperty: "border",
            rootData
          })) {
            vErrors = vErrors === null ? validate87.errors : vErrors.concat(validate87.errors);
            errors = vErrors.length;
          }
        }
        if (data.columns !== void 0) {
          if (!validate109(data.columns, {
            instancePath: instancePath + "/columns",
            parentData: data,
            parentDataProperty: "columns",
            rootData
          })) {
            vErrors = vErrors === null ? validate109.errors : vErrors.concat(validate109.errors);
            errors = vErrors.length;
          }
        }
        if (data.columnDefault !== void 0) {
          if (!validate113(data.columnDefault, {
            instancePath: instancePath + "/columnDefault",
            parentData: data,
            parentDataProperty: "columnDefault",
            rootData
          })) {
            vErrors = vErrors === null ? validate113.errors : vErrors.concat(validate113.errors);
            errors = vErrors.length;
          }
        }
        if (data.columnCount !== void 0) {
          let data3 = data.columnCount;
          if (!(typeof data3 == "number" && (!(data3 % 1) && !isNaN(data3)) && isFinite(data3))) {
            const err3 = {
              instancePath: instancePath + "/columnCount",
              schemaPath: "#/properties/columnCount/type",
              keyword: "type",
              params: {
                type: "integer"
              },
              message: "must be integer"
            };
            if (vErrors === null) {
              vErrors = [err3];
            } else {
              vErrors.push(err3);
            }
            errors++;
          }
          if (typeof data3 == "number" && isFinite(data3)) {
            if (data3 < 1 || isNaN(data3)) {
              const err4 = {
                instancePath: instancePath + "/columnCount",
                schemaPath: "#/properties/columnCount/minimum",
                keyword: "minimum",
                params: {
                  comparison: ">=",
                  limit: 1
                },
                message: "must be >= 1"
              };
              if (vErrors === null) {
                vErrors = [err4];
              } else {
                vErrors.push(err4);
              }
              errors++;
            }
          }
        }
        if (data.drawVerticalLine !== void 0) {
          if (typeof data.drawVerticalLine != "function") {
            const err5 = {
              instancePath: instancePath + "/drawVerticalLine",
              schemaPath: "#/properties/drawVerticalLine/typeof",
              keyword: "typeof",
              params: {},
              message: 'must pass "typeof" keyword validation'
            };
            if (vErrors === null) {
              vErrors = [err5];
            } else {
              vErrors.push(err5);
            }
            errors++;
          }
        }
      } else {
        const err6 = {
          instancePath,
          schemaPath: "#/type",
          keyword: "type",
          params: {
            type: "object"
          },
          message: "must be object"
        };
        if (vErrors === null) {
          vErrors = [err6];
        } else {
          vErrors.push(err6);
        }
        errors++;
      }
      validate86.errors = vErrors;
      return errors === 0;
    }
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/validateConfig.js
var require_validateConfig = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/validateConfig.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.validateConfig = void 0;
    var validators_1 = __importDefault(require_validators());
    var validateConfig = (schemaId, config) => {
      const validate = validators_1.default[schemaId];
      if (!validate(config) && validate.errors) {
        const errors = validate.errors.map((error) => {
          return {
            message: error.message,
            params: error.params,
            schemaPath: error.schemaPath
          };
        });
        console.log("config", config);
        console.log("errors", errors);
        throw new Error("Invalid config.");
      }
    };
    exports2.validateConfig = validateConfig;
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/makeStreamConfig.js
var require_makeStreamConfig = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/makeStreamConfig.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.makeStreamConfig = void 0;
    var utils_1 = require_utils5();
    var validateConfig_1 = require_validateConfig();
    var makeColumnsConfig = (columnCount, columns = {}, columnDefault) => {
      return Array.from({ length: columnCount }).map((_, index) => {
        return {
          alignment: "left",
          paddingLeft: 1,
          paddingRight: 1,
          truncate: Number.POSITIVE_INFINITY,
          verticalAlignment: "top",
          wrapWord: false,
          ...columnDefault,
          ...columns[index]
        };
      });
    };
    var makeStreamConfig = (config) => {
      (0, validateConfig_1.validateConfig)("streamConfig.json", config);
      if (config.columnDefault.width === void 0) {
        throw new Error("Must provide config.columnDefault.width when creating a stream.");
      }
      return {
        drawVerticalLine: () => {
          return true;
        },
        ...config,
        border: (0, utils_1.makeBorderConfig)(config.border),
        columns: makeColumnsConfig(config.columnCount, config.columns, config.columnDefault)
      };
    };
    exports2.makeStreamConfig = makeStreamConfig;
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/mapDataUsingRowHeights.js
var require_mapDataUsingRowHeights = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/mapDataUsingRowHeights.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.mapDataUsingRowHeights = exports2.padCellVertically = void 0;
    var utils_1 = require_utils5();
    var wrapCell_1 = require_wrapCell();
    var createEmptyStrings = (length) => {
      return new Array(length).fill("");
    };
    var padCellVertically = (lines, rowHeight, verticalAlignment) => {
      const availableLines = rowHeight - lines.length;
      if (verticalAlignment === "top") {
        return [...lines, ...createEmptyStrings(availableLines)];
      }
      if (verticalAlignment === "bottom") {
        return [...createEmptyStrings(availableLines), ...lines];
      }
      return [
        ...createEmptyStrings(Math.floor(availableLines / 2)),
        ...lines,
        ...createEmptyStrings(Math.ceil(availableLines / 2))
      ];
    };
    exports2.padCellVertically = padCellVertically;
    var mapDataUsingRowHeights = (unmappedRows, rowHeights, config) => {
      const nColumns = unmappedRows[0].length;
      const mappedRows = unmappedRows.map((unmappedRow, unmappedRowIndex) => {
        const outputRowHeight = rowHeights[unmappedRowIndex];
        const outputRow = Array.from({ length: outputRowHeight }, () => {
          return new Array(nColumns).fill("");
        });
        unmappedRow.forEach((cell, cellIndex) => {
          var _a;
          const containingRange = (_a = config.spanningCellManager) === null || _a === void 0 ? void 0 : _a.getContainingRange({
            col: cellIndex,
            row: unmappedRowIndex
          });
          if (containingRange) {
            containingRange.extractCellContent(unmappedRowIndex).forEach((cellLine, cellLineIndex) => {
              outputRow[cellLineIndex][cellIndex] = cellLine;
            });
            return;
          }
          const cellLines = (0, wrapCell_1.wrapCell)(cell, config.columns[cellIndex].width, config.columns[cellIndex].wrapWord);
          const paddedCellLines = (0, exports2.padCellVertically)(cellLines, outputRowHeight, config.columns[cellIndex].verticalAlignment);
          paddedCellLines.forEach((cellLine, cellLineIndex) => {
            outputRow[cellLineIndex][cellIndex] = cellLine;
          });
        });
        return outputRow;
      });
      return (0, utils_1.flatten)(mappedRows);
    };
    exports2.mapDataUsingRowHeights = mapDataUsingRowHeights;
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/padTableData.js
var require_padTableData = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/padTableData.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.padTableData = exports2.padString = void 0;
    var padString = (input, paddingLeft, paddingRight) => {
      return " ".repeat(paddingLeft) + input + " ".repeat(paddingRight);
    };
    exports2.padString = padString;
    var padTableData = (rows, config) => {
      return rows.map((cells, rowIndex) => {
        return cells.map((cell, cellIndex) => {
          var _a;
          const containingRange = (_a = config.spanningCellManager) === null || _a === void 0 ? void 0 : _a.getContainingRange({
            col: cellIndex,
            row: rowIndex
          }, { mapped: true });
          if (containingRange) {
            return cell;
          }
          const { paddingLeft, paddingRight } = config.columns[cellIndex];
          return (0, exports2.padString)(cell, paddingLeft, paddingRight);
        });
      });
    };
    exports2.padTableData = padTableData;
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/stringifyTableData.js
var require_stringifyTableData = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/stringifyTableData.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.stringifyTableData = void 0;
    var utils_1 = require_utils5();
    var stringifyTableData = (rows) => {
      return rows.map((cells) => {
        return cells.map((cell) => {
          return (0, utils_1.normalizeString)(String(cell));
        });
      });
    };
    exports2.stringifyTableData = stringifyTableData;
  }
});

// node_modules/aws-cdk-lib/node_modules/lodash.truncate/index.js
var require_lodash = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/lodash.truncate/index.js"(exports2, module2) {
    "use strict";
    var DEFAULT_TRUNC_LENGTH = 30;
    var DEFAULT_TRUNC_OMISSION = "...";
    var INFINITY = 1 / 0;
    var MAX_INTEGER = 17976931348623157e292;
    var NAN = 0 / 0;
    var regexpTag = "[object RegExp]";
    var symbolTag = "[object Symbol]";
    var reTrim = /^\s+|\s+$/g;
    var reFlags = /\w*$/;
    var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;
    var reIsBinary = /^0b[01]+$/i;
    var reIsOctal = /^0o[0-7]+$/i;
    var rsAstralRange = "\\ud800-\\udfff";
    var rsComboMarksRange = "\\u0300-\\u036f\\ufe20-\\ufe23";
    var rsComboSymbolsRange = "\\u20d0-\\u20f0";
    var rsVarRange = "\\ufe0e\\ufe0f";
    var rsAstral = "[" + rsAstralRange + "]";
    var rsCombo = "[" + rsComboMarksRange + rsComboSymbolsRange + "]";
    var rsFitz = "\\ud83c[\\udffb-\\udfff]";
    var rsModifier = "(?:" + rsCombo + "|" + rsFitz + ")";
    var rsNonAstral = "[^" + rsAstralRange + "]";
    var rsRegional = "(?:\\ud83c[\\udde6-\\uddff]){2}";
    var rsSurrPair = "[\\ud800-\\udbff][\\udc00-\\udfff]";
    var rsZWJ = "\\u200d";
    var reOptMod = rsModifier + "?";
    var rsOptVar = "[" + rsVarRange + "]?";
    var rsOptJoin = "(?:" + rsZWJ + "(?:" + [rsNonAstral, rsRegional, rsSurrPair].join("|") + ")" + rsOptVar + reOptMod + ")*";
    var rsSeq = rsOptVar + reOptMod + rsOptJoin;
    var rsSymbol = "(?:" + [rsNonAstral + rsCombo + "?", rsCombo, rsRegional, rsSurrPair, rsAstral].join("|") + ")";
    var reUnicode = RegExp(rsFitz + "(?=" + rsFitz + ")|" + rsSymbol + rsSeq, "g");
    var reHasUnicode = RegExp("[" + rsZWJ + rsAstralRange + rsComboMarksRange + rsComboSymbolsRange + rsVarRange + "]");
    var freeParseInt = parseInt;
    var freeGlobal = typeof global == "object" && global && global.Object === Object && global;
    var freeSelf = typeof self == "object" && self && self.Object === Object && self;
    var root = freeGlobal || freeSelf || Function("return this")();
    var freeExports = typeof exports2 == "object" && exports2 && !exports2.nodeType && exports2;
    var freeModule = freeExports && typeof module2 == "object" && module2 && !module2.nodeType && module2;
    var moduleExports = freeModule && freeModule.exports === freeExports;
    var freeProcess = moduleExports && freeGlobal.process;
    var nodeUtil = function() {
      try {
        return freeProcess && freeProcess.binding("util");
      } catch (e) {
      }
    }();
    var nodeIsRegExp = nodeUtil && nodeUtil.isRegExp;
    var asciiSize = baseProperty("length");
    function asciiToArray(string) {
      return string.split("");
    }
    function baseProperty(key) {
      return function(object) {
        return object == null ? void 0 : object[key];
      };
    }
    function baseUnary(func) {
      return function(value) {
        return func(value);
      };
    }
    function hasUnicode(string) {
      return reHasUnicode.test(string);
    }
    function stringSize(string) {
      return hasUnicode(string) ? unicodeSize(string) : asciiSize(string);
    }
    function stringToArray(string) {
      return hasUnicode(string) ? unicodeToArray(string) : asciiToArray(string);
    }
    function unicodeSize(string) {
      var result = reUnicode.lastIndex = 0;
      while (reUnicode.test(string)) {
        result++;
      }
      return result;
    }
    function unicodeToArray(string) {
      return string.match(reUnicode) || [];
    }
    var objectProto = Object.prototype;
    var objectToString = objectProto.toString;
    var Symbol2 = root.Symbol;
    var symbolProto = Symbol2 ? Symbol2.prototype : void 0;
    var symbolToString = symbolProto ? symbolProto.toString : void 0;
    function baseIsRegExp(value) {
      return isObject(value) && objectToString.call(value) == regexpTag;
    }
    function baseSlice(array, start, end) {
      var index = -1, length = array.length;
      if (start < 0) {
        start = -start > length ? 0 : length + start;
      }
      end = end > length ? length : end;
      if (end < 0) {
        end += length;
      }
      length = start > end ? 0 : end - start >>> 0;
      start >>>= 0;
      var result = Array(length);
      while (++index < length) {
        result[index] = array[index + start];
      }
      return result;
    }
    function baseToString(value) {
      if (typeof value == "string") {
        return value;
      }
      if (isSymbol(value)) {
        return symbolToString ? symbolToString.call(value) : "";
      }
      var result = value + "";
      return result == "0" && 1 / value == -INFINITY ? "-0" : result;
    }
    function castSlice(array, start, end) {
      var length = array.length;
      end = end === void 0 ? length : end;
      return !start && end >= length ? array : baseSlice(array, start, end);
    }
    function isObject(value) {
      var type = typeof value;
      return !!value && (type == "object" || type == "function");
    }
    function isObjectLike(value) {
      return !!value && typeof value == "object";
    }
    var isRegExp = nodeIsRegExp ? baseUnary(nodeIsRegExp) : baseIsRegExp;
    function isSymbol(value) {
      return typeof value == "symbol" || isObjectLike(value) && objectToString.call(value) == symbolTag;
    }
    function toFinite(value) {
      if (!value) {
        return value === 0 ? value : 0;
      }
      value = toNumber(value);
      if (value === INFINITY || value === -INFINITY) {
        var sign = value < 0 ? -1 : 1;
        return sign * MAX_INTEGER;
      }
      return value === value ? value : 0;
    }
    function toInteger(value) {
      var result = toFinite(value), remainder = result % 1;
      return result === result ? remainder ? result - remainder : result : 0;
    }
    function toNumber(value) {
      if (typeof value == "number") {
        return value;
      }
      if (isSymbol(value)) {
        return NAN;
      }
      if (isObject(value)) {
        var other = typeof value.valueOf == "function" ? value.valueOf() : value;
        value = isObject(other) ? other + "" : other;
      }
      if (typeof value != "string") {
        return value === 0 ? value : +value;
      }
      value = value.replace(reTrim, "");
      var isBinary = reIsBinary.test(value);
      return isBinary || reIsOctal.test(value) ? freeParseInt(value.slice(2), isBinary ? 2 : 8) : reIsBadHex.test(value) ? NAN : +value;
    }
    function toString(value) {
      return value == null ? "" : baseToString(value);
    }
    function truncate(string, options) {
      var length = DEFAULT_TRUNC_LENGTH, omission = DEFAULT_TRUNC_OMISSION;
      if (isObject(options)) {
        var separator = "separator" in options ? options.separator : separator;
        length = "length" in options ? toInteger(options.length) : length;
        omission = "omission" in options ? baseToString(options.omission) : omission;
      }
      string = toString(string);
      var strLength = string.length;
      if (hasUnicode(string)) {
        var strSymbols = stringToArray(string);
        strLength = strSymbols.length;
      }
      if (length >= strLength) {
        return string;
      }
      var end = length - stringSize(omission);
      if (end < 1) {
        return omission;
      }
      var result = strSymbols ? castSlice(strSymbols, 0, end).join("") : string.slice(0, end);
      if (separator === void 0) {
        return result + omission;
      }
      if (strSymbols) {
        end += result.length - end;
      }
      if (isRegExp(separator)) {
        if (string.slice(end).search(separator)) {
          var match, substring = result;
          if (!separator.global) {
            separator = RegExp(separator.source, toString(reFlags.exec(separator)) + "g");
          }
          separator.lastIndex = 0;
          while (match = separator.exec(substring)) {
            var newEnd = match.index;
          }
          result = result.slice(0, newEnd === void 0 ? end : newEnd);
        }
      } else if (string.indexOf(baseToString(separator), end) != end) {
        var index = result.lastIndexOf(separator);
        if (index > -1) {
          result = result.slice(0, index);
        }
      }
      return result + omission;
    }
    module2.exports = truncate;
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/truncateTableData.js
var require_truncateTableData = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/truncateTableData.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.truncateTableData = exports2.truncateString = void 0;
    var lodash_truncate_1 = __importDefault(require_lodash());
    var truncateString = (input, length) => {
      return (0, lodash_truncate_1.default)(input, {
        length,
        omission: "\u2026"
      });
    };
    exports2.truncateString = truncateString;
    var truncateTableData = (rows, truncates) => {
      return rows.map((cells) => {
        return cells.map((cell, cellIndex) => {
          return (0, exports2.truncateString)(cell, truncates[cellIndex]);
        });
      });
    };
    exports2.truncateTableData = truncateTableData;
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/createStream.js
var require_createStream = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/createStream.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.createStream = void 0;
    var alignTableData_1 = require_alignTableData();
    var calculateRowHeights_1 = require_calculateRowHeights();
    var drawBorder_1 = require_drawBorder();
    var drawRow_1 = require_drawRow();
    var makeStreamConfig_1 = require_makeStreamConfig();
    var mapDataUsingRowHeights_1 = require_mapDataUsingRowHeights();
    var padTableData_1 = require_padTableData();
    var stringifyTableData_1 = require_stringifyTableData();
    var truncateTableData_1 = require_truncateTableData();
    var utils_1 = require_utils5();
    var prepareData = (data, config) => {
      let rows = (0, stringifyTableData_1.stringifyTableData)(data);
      rows = (0, truncateTableData_1.truncateTableData)(rows, (0, utils_1.extractTruncates)(config));
      const rowHeights = (0, calculateRowHeights_1.calculateRowHeights)(rows, config);
      rows = (0, mapDataUsingRowHeights_1.mapDataUsingRowHeights)(rows, rowHeights, config);
      rows = (0, alignTableData_1.alignTableData)(rows, config);
      rows = (0, padTableData_1.padTableData)(rows, config);
      return rows;
    };
    var create = (row, columnWidths, config) => {
      const rows = prepareData([row], config);
      const body = rows.map((literalRow) => {
        return (0, drawRow_1.drawRow)(literalRow, config);
      }).join("");
      let output;
      output = "";
      output += (0, drawBorder_1.drawBorderTop)(columnWidths, config);
      output += body;
      output += (0, drawBorder_1.drawBorderBottom)(columnWidths, config);
      output = output.trimEnd();
      process.stdout.write(output);
    };
    var append = (row, columnWidths, config) => {
      const rows = prepareData([row], config);
      const body = rows.map((literalRow) => {
        return (0, drawRow_1.drawRow)(literalRow, config);
      }).join("");
      let output = "";
      const bottom = (0, drawBorder_1.drawBorderBottom)(columnWidths, config);
      if (bottom !== "\n") {
        output = "\r\x1B[K";
      }
      output += (0, drawBorder_1.drawBorderJoin)(columnWidths, config);
      output += body;
      output += bottom;
      output = output.trimEnd();
      process.stdout.write(output);
    };
    var createStream = (userConfig) => {
      const config = (0, makeStreamConfig_1.makeStreamConfig)(userConfig);
      const columnWidths = Object.values(config.columns).map((column) => {
        return column.width + column.paddingLeft + column.paddingRight;
      });
      let empty = true;
      return {
        write: (row) => {
          if (row.length !== config.columnCount) {
            throw new Error("Row cell count does not match the config.columnCount.");
          }
          if (empty) {
            empty = false;
            create(row, columnWidths, config);
          } else {
            append(row, columnWidths, config);
          }
        }
      };
    };
    exports2.createStream = createStream;
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/calculateOutputColumnWidths.js
var require_calculateOutputColumnWidths = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/calculateOutputColumnWidths.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.calculateOutputColumnWidths = void 0;
    var calculateOutputColumnWidths = (config) => {
      return config.columns.map((col) => {
        return col.paddingLeft + col.width + col.paddingRight;
      });
    };
    exports2.calculateOutputColumnWidths = calculateOutputColumnWidths;
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/drawTable.js
var require_drawTable = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/drawTable.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.drawTable = void 0;
    var drawBorder_1 = require_drawBorder();
    var drawContent_1 = require_drawContent();
    var drawRow_1 = require_drawRow();
    var utils_1 = require_utils5();
    var drawTable = (rows, outputColumnWidths, rowHeights, config) => {
      const { drawHorizontalLine, singleLine } = config;
      const contents = (0, utils_1.groupBySizes)(rows, rowHeights).map((group, groupIndex) => {
        return group.map((row) => {
          return (0, drawRow_1.drawRow)(row, {
            ...config,
            rowIndex: groupIndex
          });
        }).join("");
      });
      return (0, drawContent_1.drawContent)({
        contents,
        drawSeparator: (index, size) => {
          if (index === 0 || index === size) {
            return drawHorizontalLine(index, size);
          }
          return !singleLine && drawHorizontalLine(index, size);
        },
        elementType: "row",
        rowIndex: -1,
        separatorGetter: (0, drawBorder_1.createTableBorderGetter)(outputColumnWidths, {
          ...config,
          rowCount: contents.length
        }),
        spanningCellManager: config.spanningCellManager
      });
    };
    exports2.drawTable = drawTable;
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/injectHeaderConfig.js
var require_injectHeaderConfig = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/injectHeaderConfig.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.injectHeaderConfig = void 0;
    var injectHeaderConfig = (rows, config) => {
      var _a;
      let spanningCellConfig = (_a = config.spanningCells) !== null && _a !== void 0 ? _a : [];
      const headerConfig = config.header;
      const adjustedRows = [...rows];
      if (headerConfig) {
        spanningCellConfig = spanningCellConfig.map(({ row, ...rest }) => {
          return {
            ...rest,
            row: row + 1
          };
        });
        const { content, ...headerStyles } = headerConfig;
        spanningCellConfig.unshift({
          alignment: "center",
          col: 0,
          colSpan: rows[0].length,
          paddingLeft: 1,
          paddingRight: 1,
          row: 0,
          wrapWord: false,
          ...headerStyles
        });
        adjustedRows.unshift([content, ...Array.from({ length: rows[0].length - 1 }).fill("")]);
      }
      return [
        adjustedRows,
        spanningCellConfig
      ];
    };
    exports2.injectHeaderConfig = injectHeaderConfig;
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/calculateMaximumColumnWidths.js
var require_calculateMaximumColumnWidths = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/calculateMaximumColumnWidths.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.calculateMaximumColumnWidths = exports2.calculateMaximumCellWidth = void 0;
    var string_width_1 = __importDefault(require_string_width());
    var utils_1 = require_utils5();
    var calculateMaximumCellWidth = (cell) => {
      return Math.max(...cell.split("\n").map(string_width_1.default));
    };
    exports2.calculateMaximumCellWidth = calculateMaximumCellWidth;
    var calculateMaximumColumnWidths = (rows, spanningCellConfigs = []) => {
      const columnWidths = new Array(rows[0].length).fill(0);
      const rangeCoordinates = spanningCellConfigs.map(utils_1.calculateRangeCoordinate);
      const isSpanningCell = (rowIndex, columnIndex) => {
        return rangeCoordinates.some((rangeCoordinate) => {
          return (0, utils_1.isCellInRange)({
            col: columnIndex,
            row: rowIndex
          }, rangeCoordinate);
        });
      };
      rows.forEach((row, rowIndex) => {
        row.forEach((cell, cellIndex) => {
          if (isSpanningCell(rowIndex, cellIndex)) {
            return;
          }
          columnWidths[cellIndex] = Math.max(columnWidths[cellIndex], (0, exports2.calculateMaximumCellWidth)(cell));
        });
      });
      return columnWidths;
    };
    exports2.calculateMaximumColumnWidths = calculateMaximumColumnWidths;
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/alignSpanningCell.js
var require_alignSpanningCell = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/alignSpanningCell.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.alignVerticalRangeContent = exports2.wrapRangeContent = void 0;
    var string_width_1 = __importDefault(require_string_width());
    var alignString_1 = require_alignString();
    var mapDataUsingRowHeights_1 = require_mapDataUsingRowHeights();
    var padTableData_1 = require_padTableData();
    var truncateTableData_1 = require_truncateTableData();
    var utils_1 = require_utils5();
    var wrapCell_1 = require_wrapCell();
    var wrapRangeContent = (rangeConfig, rangeWidth, context) => {
      const { topLeft, paddingRight, paddingLeft, truncate, wrapWord, alignment } = rangeConfig;
      const originalContent = context.rows[topLeft.row][topLeft.col];
      const contentWidth = rangeWidth - paddingLeft - paddingRight;
      return (0, wrapCell_1.wrapCell)((0, truncateTableData_1.truncateString)(originalContent, truncate), contentWidth, wrapWord).map((line) => {
        const alignedLine = (0, alignString_1.alignString)(line, contentWidth, alignment);
        return (0, padTableData_1.padString)(alignedLine, paddingLeft, paddingRight);
      });
    };
    exports2.wrapRangeContent = wrapRangeContent;
    var alignVerticalRangeContent = (range, content, context) => {
      const { rows, drawHorizontalLine, rowHeights } = context;
      const { topLeft, bottomRight, verticalAlignment } = range;
      if (rowHeights.length === 0) {
        return [];
      }
      const totalCellHeight = (0, utils_1.sumArray)(rowHeights.slice(topLeft.row, bottomRight.row + 1));
      const totalBorderHeight = bottomRight.row - topLeft.row;
      const hiddenHorizontalBorderCount = (0, utils_1.sequence)(topLeft.row + 1, bottomRight.row).filter((horizontalBorderIndex) => {
        return !drawHorizontalLine(horizontalBorderIndex, rows.length);
      }).length;
      const availableRangeHeight = totalCellHeight + totalBorderHeight - hiddenHorizontalBorderCount;
      return (0, mapDataUsingRowHeights_1.padCellVertically)(content, availableRangeHeight, verticalAlignment).map((line) => {
        if (line.length === 0) {
          return " ".repeat((0, string_width_1.default)(content[0]));
        }
        return line;
      });
    };
    exports2.alignVerticalRangeContent = alignVerticalRangeContent;
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/calculateSpanningCellWidth.js
var require_calculateSpanningCellWidth = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/calculateSpanningCellWidth.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.calculateSpanningCellWidth = void 0;
    var utils_1 = require_utils5();
    var calculateSpanningCellWidth = (rangeConfig, dependencies) => {
      const { columnsConfig, drawVerticalLine } = dependencies;
      const { topLeft, bottomRight } = rangeConfig;
      const totalWidth = (0, utils_1.sumArray)(columnsConfig.slice(topLeft.col, bottomRight.col + 1).map(({ width }) => {
        return width;
      }));
      const totalPadding = topLeft.col === bottomRight.col ? columnsConfig[topLeft.col].paddingRight + columnsConfig[bottomRight.col].paddingLeft : (0, utils_1.sumArray)(columnsConfig.slice(topLeft.col, bottomRight.col + 1).map(({ paddingLeft, paddingRight }) => {
        return paddingLeft + paddingRight;
      }));
      const totalBorderWidths = bottomRight.col - topLeft.col;
      const totalHiddenVerticalBorders = (0, utils_1.sequence)(topLeft.col + 1, bottomRight.col).filter((verticalBorderIndex) => {
        return !drawVerticalLine(verticalBorderIndex, columnsConfig.length);
      }).length;
      return totalWidth + totalPadding + totalBorderWidths - totalHiddenVerticalBorders;
    };
    exports2.calculateSpanningCellWidth = calculateSpanningCellWidth;
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/makeRangeConfig.js
var require_makeRangeConfig = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/makeRangeConfig.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.makeRangeConfig = void 0;
    var utils_1 = require_utils5();
    var makeRangeConfig = (spanningCellConfig, columnsConfig) => {
      var _a;
      const { topLeft, bottomRight } = (0, utils_1.calculateRangeCoordinate)(spanningCellConfig);
      const cellConfig = {
        ...columnsConfig[topLeft.col],
        ...spanningCellConfig,
        paddingRight: (_a = spanningCellConfig.paddingRight) !== null && _a !== void 0 ? _a : columnsConfig[bottomRight.col].paddingRight
      };
      return {
        ...cellConfig,
        bottomRight,
        topLeft
      };
    };
    exports2.makeRangeConfig = makeRangeConfig;
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/spanningCellManager.js
var require_spanningCellManager = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/spanningCellManager.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.createSpanningCellManager = void 0;
    var alignSpanningCell_1 = require_alignSpanningCell();
    var calculateSpanningCellWidth_1 = require_calculateSpanningCellWidth();
    var makeRangeConfig_1 = require_makeRangeConfig();
    var utils_1 = require_utils5();
    var findRangeConfig = (cell, rangeConfigs) => {
      return rangeConfigs.find((rangeCoordinate) => {
        return (0, utils_1.isCellInRange)(cell, rangeCoordinate);
      });
    };
    var getContainingRange = (rangeConfig, context) => {
      const width = (0, calculateSpanningCellWidth_1.calculateSpanningCellWidth)(rangeConfig, context);
      const wrappedContent = (0, alignSpanningCell_1.wrapRangeContent)(rangeConfig, width, context);
      const alignedContent = (0, alignSpanningCell_1.alignVerticalRangeContent)(rangeConfig, wrappedContent, context);
      const getCellContent = (rowIndex) => {
        const { topLeft } = rangeConfig;
        const { drawHorizontalLine, rowHeights } = context;
        const totalWithinHorizontalBorderHeight = rowIndex - topLeft.row;
        const totalHiddenHorizontalBorderHeight = (0, utils_1.sequence)(topLeft.row + 1, rowIndex).filter((index) => {
          return !(drawHorizontalLine === null || drawHorizontalLine === void 0 ? void 0 : drawHorizontalLine(index, rowHeights.length));
        }).length;
        const offset = (0, utils_1.sumArray)(rowHeights.slice(topLeft.row, rowIndex)) + totalWithinHorizontalBorderHeight - totalHiddenHorizontalBorderHeight;
        return alignedContent.slice(offset, offset + rowHeights[rowIndex]);
      };
      const getBorderContent = (borderIndex) => {
        const { topLeft } = rangeConfig;
        const offset = (0, utils_1.sumArray)(context.rowHeights.slice(topLeft.row, borderIndex)) + (borderIndex - topLeft.row - 1);
        return alignedContent[offset];
      };
      return {
        ...rangeConfig,
        extractBorderContent: getBorderContent,
        extractCellContent: getCellContent,
        height: wrappedContent.length,
        width
      };
    };
    var inSameRange = (cell1, cell2, ranges) => {
      const range1 = findRangeConfig(cell1, ranges);
      const range2 = findRangeConfig(cell2, ranges);
      if (range1 && range2) {
        return (0, utils_1.areCellEqual)(range1.topLeft, range2.topLeft);
      }
      return false;
    };
    var hashRange = (range) => {
      const { row, col } = range.topLeft;
      return `${row}/${col}`;
    };
    var createSpanningCellManager = (parameters) => {
      const { spanningCellConfigs, columnsConfig } = parameters;
      const ranges = spanningCellConfigs.map((config) => {
        return (0, makeRangeConfig_1.makeRangeConfig)(config, columnsConfig);
      });
      const rangeCache = {};
      let rowHeights = [];
      return {
        getContainingRange: (cell, options) => {
          var _a;
          const originalRow = (options === null || options === void 0 ? void 0 : options.mapped) ? (0, utils_1.findOriginalRowIndex)(rowHeights, cell.row) : cell.row;
          const range = findRangeConfig({
            ...cell,
            row: originalRow
          }, ranges);
          if (!range) {
            return void 0;
          }
          if (rowHeights.length === 0) {
            return getContainingRange(range, {
              ...parameters,
              rowHeights
            });
          }
          const hash = hashRange(range);
          (_a = rangeCache[hash]) !== null && _a !== void 0 ? _a : rangeCache[hash] = getContainingRange(range, {
            ...parameters,
            rowHeights
          });
          return rangeCache[hash];
        },
        inSameRange: (cell1, cell2) => {
          return inSameRange(cell1, cell2, ranges);
        },
        rowHeights,
        setRowHeights: (_rowHeights) => {
          rowHeights = _rowHeights;
        }
      };
    };
    exports2.createSpanningCellManager = createSpanningCellManager;
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/validateSpanningCellConfig.js
var require_validateSpanningCellConfig = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/validateSpanningCellConfig.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.validateSpanningCellConfig = void 0;
    var utils_1 = require_utils5();
    var inRange = (start, end, value) => {
      return start <= value && value <= end;
    };
    var validateSpanningCellConfig = (rows, configs) => {
      const [nRow, nCol] = [rows.length, rows[0].length];
      configs.forEach((config, configIndex) => {
        const { colSpan, rowSpan } = config;
        if (colSpan === void 0 && rowSpan === void 0) {
          throw new Error(`Expect at least colSpan or rowSpan is provided in config.spanningCells[${configIndex}]`);
        }
        if (colSpan !== void 0 && colSpan < 1) {
          throw new Error(`Expect colSpan is not equal zero, instead got: ${colSpan} in config.spanningCells[${configIndex}]`);
        }
        if (rowSpan !== void 0 && rowSpan < 1) {
          throw new Error(`Expect rowSpan is not equal zero, instead got: ${rowSpan} in config.spanningCells[${configIndex}]`);
        }
      });
      const rangeCoordinates = configs.map(utils_1.calculateRangeCoordinate);
      rangeCoordinates.forEach(({ topLeft, bottomRight }, rangeIndex) => {
        if (!inRange(0, nCol - 1, topLeft.col) || !inRange(0, nRow - 1, topLeft.row) || !inRange(0, nCol - 1, bottomRight.col) || !inRange(0, nRow - 1, bottomRight.row)) {
          throw new Error(`Some cells in config.spanningCells[${rangeIndex}] are out of the table`);
        }
      });
      const configOccupy = Array.from({ length: nRow }, () => {
        return Array.from({ length: nCol });
      });
      rangeCoordinates.forEach(({ topLeft, bottomRight }, rangeIndex) => {
        (0, utils_1.sequence)(topLeft.row, bottomRight.row).forEach((row) => {
          (0, utils_1.sequence)(topLeft.col, bottomRight.col).forEach((col) => {
            if (configOccupy[row][col] !== void 0) {
              throw new Error(`Spanning cells in config.spanningCells[${configOccupy[row][col]}] and config.spanningCells[${rangeIndex}] are overlap each other`);
            }
            configOccupy[row][col] = rangeIndex;
          });
        });
      });
    };
    exports2.validateSpanningCellConfig = validateSpanningCellConfig;
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/makeTableConfig.js
var require_makeTableConfig = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/makeTableConfig.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.makeTableConfig = void 0;
    var calculateMaximumColumnWidths_1 = require_calculateMaximumColumnWidths();
    var spanningCellManager_1 = require_spanningCellManager();
    var utils_1 = require_utils5();
    var validateConfig_1 = require_validateConfig();
    var validateSpanningCellConfig_1 = require_validateSpanningCellConfig();
    var makeColumnsConfig = (rows, columns, columnDefault, spanningCellConfigs) => {
      const columnWidths = (0, calculateMaximumColumnWidths_1.calculateMaximumColumnWidths)(rows, spanningCellConfigs);
      return rows[0].map((_, columnIndex) => {
        return {
          alignment: "left",
          paddingLeft: 1,
          paddingRight: 1,
          truncate: Number.POSITIVE_INFINITY,
          verticalAlignment: "top",
          width: columnWidths[columnIndex],
          wrapWord: false,
          ...columnDefault,
          ...columns === null || columns === void 0 ? void 0 : columns[columnIndex]
        };
      });
    };
    var makeTableConfig = (rows, config = {}, injectedSpanningCellConfig) => {
      var _a, _b, _c, _d, _e;
      (0, validateConfig_1.validateConfig)("config.json", config);
      (0, validateSpanningCellConfig_1.validateSpanningCellConfig)(rows, (_a = config.spanningCells) !== null && _a !== void 0 ? _a : []);
      const spanningCellConfigs = (_b = injectedSpanningCellConfig !== null && injectedSpanningCellConfig !== void 0 ? injectedSpanningCellConfig : config.spanningCells) !== null && _b !== void 0 ? _b : [];
      const columnsConfig = makeColumnsConfig(rows, config.columns, config.columnDefault, spanningCellConfigs);
      const drawVerticalLine = (_c = config.drawVerticalLine) !== null && _c !== void 0 ? _c : () => {
        return true;
      };
      const drawHorizontalLine = (_d = config.drawHorizontalLine) !== null && _d !== void 0 ? _d : () => {
        return true;
      };
      return {
        ...config,
        border: (0, utils_1.makeBorderConfig)(config.border),
        columns: columnsConfig,
        drawHorizontalLine,
        drawVerticalLine,
        singleLine: (_e = config.singleLine) !== null && _e !== void 0 ? _e : false,
        spanningCellManager: (0, spanningCellManager_1.createSpanningCellManager)({
          columnsConfig,
          drawHorizontalLine,
          drawVerticalLine,
          rows,
          spanningCellConfigs
        })
      };
    };
    exports2.makeTableConfig = makeTableConfig;
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/validateTableData.js
var require_validateTableData = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/validateTableData.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.validateTableData = void 0;
    var utils_1 = require_utils5();
    var validateTableData = (rows) => {
      if (!Array.isArray(rows)) {
        throw new TypeError("Table data must be an array.");
      }
      if (rows.length === 0) {
        throw new Error("Table must define at least one row.");
      }
      if (rows[0].length === 0) {
        throw new Error("Table must define at least one column.");
      }
      const columnNumber = rows[0].length;
      for (const row of rows) {
        if (!Array.isArray(row)) {
          throw new TypeError("Table row data must be an array.");
        }
        if (row.length !== columnNumber) {
          throw new Error("Table must have a consistent number of cells.");
        }
        for (const cell of row) {
          if (/[\u0001-\u0006\u0008\u0009\u000B-\u001A]/.test((0, utils_1.normalizeString)(String(cell)))) {
            throw new Error("Table data must not contain control characters.");
          }
        }
      }
    };
    exports2.validateTableData = validateTableData;
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/table.js
var require_table = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/table.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.table = void 0;
    var alignTableData_1 = require_alignTableData();
    var calculateOutputColumnWidths_1 = require_calculateOutputColumnWidths();
    var calculateRowHeights_1 = require_calculateRowHeights();
    var drawTable_1 = require_drawTable();
    var injectHeaderConfig_1 = require_injectHeaderConfig();
    var makeTableConfig_1 = require_makeTableConfig();
    var mapDataUsingRowHeights_1 = require_mapDataUsingRowHeights();
    var padTableData_1 = require_padTableData();
    var stringifyTableData_1 = require_stringifyTableData();
    var truncateTableData_1 = require_truncateTableData();
    var utils_1 = require_utils5();
    var validateTableData_1 = require_validateTableData();
    var table = (data, userConfig = {}) => {
      (0, validateTableData_1.validateTableData)(data);
      let rows = (0, stringifyTableData_1.stringifyTableData)(data);
      const [injectedRows, injectedSpanningCellConfig] = (0, injectHeaderConfig_1.injectHeaderConfig)(rows, userConfig);
      const config = (0, makeTableConfig_1.makeTableConfig)(injectedRows, userConfig, injectedSpanningCellConfig);
      rows = (0, truncateTableData_1.truncateTableData)(injectedRows, (0, utils_1.extractTruncates)(config));
      const rowHeights = (0, calculateRowHeights_1.calculateRowHeights)(rows, config);
      config.spanningCellManager.setRowHeights(rowHeights);
      rows = (0, mapDataUsingRowHeights_1.mapDataUsingRowHeights)(rows, rowHeights, config);
      rows = (0, alignTableData_1.alignTableData)(rows, config);
      rows = (0, padTableData_1.padTableData)(rows, config);
      const outputColumnWidths = (0, calculateOutputColumnWidths_1.calculateOutputColumnWidths)(config);
      return (0, drawTable_1.drawTable)(rows, outputColumnWidths, rowHeights, config);
    };
    exports2.table = table;
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/types/api.js
var require_api2 = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/types/api.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/node_modules/table/dist/src/index.js
var require_src = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/table/dist/src/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports3) {
      for (var p in m)
        if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p))
          __createBinding(exports3, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getBorderCharacters = exports2.createStream = exports2.table = void 0;
    var createStream_1 = require_createStream();
    Object.defineProperty(exports2, "createStream", { enumerable: true, get: function() {
      return createStream_1.createStream;
    } });
    var getBorderCharacters_1 = require_getBorderCharacters();
    Object.defineProperty(exports2, "getBorderCharacters", { enumerable: true, get: function() {
      return getBorderCharacters_1.getBorderCharacters;
    } });
    var table_1 = require_table();
    Object.defineProperty(exports2, "table", { enumerable: true, get: function() {
      return table_1.table;
    } });
    __exportStar(require_api2(), exports2);
  }
});

// node_modules/aws-cdk-lib/core/lib/validation/private/trace.js
var require_trace = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/validation/private/trace.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ReportTrace = void 0;
    var STARTER_LINE = "\u2514\u2500\u2500 ";
    var VERTICAL_LINE = "\u2502";
    var ReportTrace = class {
      constructor(tree) {
        this.tree = tree;
      }
      formatJson(constructPath) {
        return this.trace(constructPath);
      }
      formatPrettyPrinted(constructPath) {
        const trace = this.formatJson(constructPath);
        return this.renderPrettyPrintedTraceInfo(trace);
      }
      renderPrettyPrintedTraceInfo(info, indent, start = STARTER_LINE) {
        const notAvailableMessage = "	Construct trace not available. Rerun with `--debug` to see trace information";
        if (info) {
          const indentation = indent ?? " ".repeat(STARTER_LINE.length + 1);
          return [`${start} ${info?.id} (${info?.path})`, `${indentation}${VERTICAL_LINE} Construct: ${info?.construct}`, `${indentation}${VERTICAL_LINE} Library Version: ${info?.libraryVersion}`, `${indentation}${VERTICAL_LINE} Location: ${info?.location}`, ...info?.child ? [this.renderPrettyPrintedTraceInfo(info?.child, " ".repeat(indentation.length + STARTER_LINE.length + 1), indentation + STARTER_LINE)] : []].join(`
	`);
        }
        return notAvailableMessage;
      }
      trace(constructPath) {
        if (constructPath) {
          const treeNode = this.tree.getTreeNode(constructPath);
          if (treeNode)
            return this.tree.getTrace(treeNode);
        }
      }
    };
    exports2.ReportTrace = ReportTrace;
  }
});

// node_modules/aws-cdk-lib/core/lib/validation/report.js
var require_report = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/validation/report.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PolicyValidationReportStatusBeta1 = void 0;
    var PolicyValidationReportStatusBeta1;
    (function(PolicyValidationReportStatusBeta12) {
      PolicyValidationReportStatusBeta12.SUCCESS = "success", PolicyValidationReportStatusBeta12.FAILURE = "failure";
    })(PolicyValidationReportStatusBeta1 = exports2.PolicyValidationReportStatusBeta1 || (exports2.PolicyValidationReportStatusBeta1 = {}));
  }
});

// node_modules/aws-cdk-lib/core/lib/validation/private/report.js
var require_report2 = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/validation/private/report.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PolicyValidationReportFormatter = void 0;
    var os = require("os");
    var path = require("path");
    var table_1 = require_src();
    var trace_1 = require_trace();
    var report = require_report();
    var PolicyValidationReportFormatter = class {
      constructor(tree) {
        this.tree = tree, this.reportTrace = new trace_1.ReportTrace(tree);
      }
      formatPrettyPrinted(reps) {
        const json = this.formatJson(reps), output = [json.title];
        return output.push("-".repeat(json.title.length)), json.pluginReports.forEach((plugin) => {
          output.push(""), output.push((0, table_1.table)([[`Plugin: ${plugin.summary.pluginName}`], [`Version: ${plugin.version ?? "N/A"}`], [`Status: ${plugin.summary.status}`]], { header: { content: "Plugin Report" }, singleLine: true, columns: [{ paddingLeft: 3, paddingRight: 3 }] })), plugin.summary.metadata && (output.push(""), output.push(`Metadata: 
	${Object.entries(plugin.summary.metadata).flatMap(([key, value]) => `${key}: ${value}`).join(`
	`)}`)), plugin.violations.length > 0 && (output.push(""), output.push("(Violations)")), plugin.violations.forEach((violation) => {
            const constructs = violation.violatingConstructs, occurrences = constructs.length, title = reset(red(bright(`${violation.ruleName} (${occurrences} occurrences)`)));
            output.push(""), output.push(title), violation.severity && output.push(`Severity: ${violation.severity}`), output.push(""), output.push("  Occurrences:");
            for (const construct of constructs)
              if (output.push(""), output.push(`    - Construct Path: ${construct.constructPath ?? "N/A"}`), output.push(`    - Template Path: ${construct.templatePath}`), output.push(`    - Creation Stack:
	${this.reportTrace.formatPrettyPrinted(construct.constructPath)}`), output.push(`    - Resource ID: ${construct.resourceLogicalId}`), construct.locations) {
                output.push("    - Template Locations:");
                for (const location of construct.locations)
                  output.push(`      > ${location}`);
              }
            output.push(""), output.push(`  Description: ${violation.description}`), violation.fix && output.push(`  How to fix: ${violation.fix}`), violation.ruleMetadata && output.push(`  Rule Metadata: 
	${Object.entries(violation.ruleMetadata).flatMap(([key, value]) => `${key}: ${value}`).join(`
	`)}`);
          });
        }), output.push(""), output.push("Policy Validation Report Summary"), output.push(""), output.push((0, table_1.table)([["Plugin", "Status"], ...reps.map((rep) => [rep.pluginName, rep.success ? "success" : "failure"])], {})), output.join(os.EOL);
      }
      formatJson(reps) {
        return { title: "Validation Report", pluginReports: reps.filter((rep) => !rep.success).map((rep) => ({ version: rep.pluginVersion, summary: { pluginName: rep.pluginName, status: rep.success ? report.PolicyValidationReportStatusBeta1.SUCCESS : report.PolicyValidationReportStatusBeta1.FAILURE, metadata: rep.metadata }, violations: rep.violations.map((violation) => ({ ruleName: violation.ruleName, description: violation.description, fix: violation.fix, ruleMetadata: violation.ruleMetadata, severity: violation.severity, violatingResources: violation.violatingResources, violatingConstructs: violation.violatingResources.map((resource) => {
          const constructPath = this.tree.getConstructByLogicalId(path.basename(resource.templatePath), resource.resourceLogicalId)?.node.path;
          return { constructStack: this.reportTrace.formatJson(constructPath), constructPath, locations: resource.locations, resourceLogicalId: resource.resourceLogicalId, templatePath: resource.templatePath };
        }) })) })) };
      }
    };
    exports2.PolicyValidationReportFormatter = PolicyValidationReportFormatter;
    function reset(s) {
      return `${s}\x1B[0m`;
    }
    function red(s) {
      return `\x1B[31m${s}`;
    }
    function bright(s) {
      return `\x1B[1m${s}`;
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/private/synthesis.js
var require_synthesis = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/private/synthesis.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.addCustomSynthesis = exports2.synthesize = void 0;
    var fs = require("fs");
    var path = require("path");
    var metadata_resource_1 = require_metadata_resource();
    var prepare_app_1 = require_prepare_app();
    var tree_metadata_1 = require_tree_metadata();
    var cxapi = require_cx_api();
    var annotations_1 = require_annotations();
    var app_1 = require_app2();
    var aspect_1 = require_aspect();
    var fs_1 = require_fs2();
    var stack_1 = require_stack();
    var stage_1 = require_stage();
    var construct_tree_1 = require_construct_tree();
    var report_1 = require_report2();
    var POLICY_VALIDATION_FILE_PATH = "policy-validation-report.json";
    var VALIDATION_REPORT_JSON_CONTEXT = "@aws-cdk/core:validationReportJson";
    function synthesize(root, options = {}) {
      injectTreeMetadata(root), synthNestedAssemblies(root, options), invokeAspects(root), injectMetadataResources(root), (0, prepare_app_1.prepareApp)(root), options.skipValidation || validateTree(root);
      const builder = stage_1.Stage.isStage(root) ? root._assemblyBuilder : new cxapi.CloudAssemblyBuilder(options.outdir);
      synthesizeTree(root, builder, options.validateOnSynthesis);
      const assembly = builder.buildAssembly();
      return invokeValidationPlugins(root, builder.outdir, assembly), assembly;
    }
    exports2.synthesize = synthesize;
    function getAssemblies(root, rootAssembly) {
      const assemblies = /* @__PURE__ */ new Map();
      return assemblies.set(root.artifactId, rootAssembly), visitAssemblies(root, "pre", (construct) => {
        const stage = construct;
        stage.parentStage && assemblies.has(stage.parentStage.artifactId) && assemblies.set(stage.artifactId, assemblies.get(stage.parentStage.artifactId).getNestedAssembly(stage.artifactId));
      }), assemblies;
    }
    function invokeValidationPlugins(root, outdir, assembly) {
      if (!app_1.App.isApp(root))
        return;
      let hash;
      const assemblies = getAssemblies(root, assembly), templatePathsByPlugin = /* @__PURE__ */ new Map();
      visitAssemblies(root, "post", (construct) => {
        if (stage_1.Stage.isStage(construct))
          for (const plugin of construct.policyValidationBeta1) {
            templatePathsByPlugin.has(plugin) || templatePathsByPlugin.set(plugin, []);
            let assemblyToUse = assemblies.get(construct.artifactId);
            if (!assemblyToUse)
              throw new Error(`Validation failed, cannot find cloud assembly for stage ${construct.stageName}`);
            templatePathsByPlugin.get(plugin).push(...assemblyToUse.stacksRecursively.map((stack) => stack.templateFullPath));
          }
      });
      const reports = [];
      templatePathsByPlugin.size > 0 && console.log(`Performing Policy Validations
`), templatePathsByPlugin.size > 0 && (hash = fs_1.FileSystem.fingerprint(outdir));
      for (const [plugin, paths] of templatePathsByPlugin.entries()) {
        try {
          const report = plugin.validate({ templatePaths: paths });
          reports.push({ ...report, pluginName: plugin.name });
        } catch (e) {
          reports.push({ success: false, pluginName: plugin.name, pluginVersion: plugin.version, violations: [], metadata: { error: `Validation plugin '${plugin.name}' failed: ${e.message}` } });
        }
        if (fs_1.FileSystem.fingerprint(outdir) !== hash)
          throw new Error(`Illegal operation: validation plugin '${plugin.name}' modified the cloud assembly`);
      }
      if (reports.length > 0) {
        const tree = new construct_tree_1.ConstructTree(root), formatter = new report_1.PolicyValidationReportFormatter(tree), formatJson = root.node.tryGetContext(VALIDATION_REPORT_JSON_CONTEXT) ?? false, output = formatJson ? formatter.formatJson(reports) : formatter.formatPrettyPrinted(reports), reportFile = path.join(assembly.directory, POLICY_VALIDATION_FILE_PATH);
        if (formatJson ? fs.writeFileSync(reportFile, JSON.stringify(output, void 0, 2)) : console.error(output), reports.some((r) => !r.success)) {
          const message = formatJson ? `Validation failed. See the validation report in '${reportFile}' for details` : "Validation failed. See the validation report above for details";
          console.log(message), process.exitCode = 1;
        } else
          console.log("Policy Validation Successful!");
      }
    }
    var CUSTOM_SYNTHESIS_SYM = Symbol.for("@aws-cdk/core:customSynthesis");
    function addCustomSynthesis(construct, synthesis) {
      Object.defineProperty(construct, CUSTOM_SYNTHESIS_SYM, { value: synthesis, enumerable: false });
    }
    exports2.addCustomSynthesis = addCustomSynthesis;
    function getCustomSynthesis(construct) {
      return construct[CUSTOM_SYNTHESIS_SYM];
    }
    function synthNestedAssemblies(root, options) {
      for (const child of root.node.children)
        stage_1.Stage.isStage(child) ? child.synth(options) : synthNestedAssemblies(child, options);
    }
    function invokeAspects(root) {
      const invokedByPath = {};
      let nestedAspectWarning = false;
      recurse(root, []);
      function recurse(construct, inheritedAspects) {
        const node = construct.node, aspects = aspect_1.Aspects.of(construct), allAspectsHere = [...inheritedAspects ?? [], ...aspects.all], nodeAspectsCount = aspects.all.length;
        for (const aspect of allAspectsHere) {
          let invoked = invokedByPath[node.path];
          invoked || (invoked = invokedByPath[node.path] = []), !invoked.includes(aspect) && (aspect.visit(construct), !nestedAspectWarning && nodeAspectsCount !== aspects.all.length && (annotations_1.Annotations.of(construct).addWarning("We detected an Aspect was added via another Aspect, and will not be applied"), nestedAspectWarning = true), invoked.push(aspect));
        }
        for (const child of construct.node.children)
          stage_1.Stage.isStage(child) || recurse(child, allAspectsHere);
      }
    }
    function injectMetadataResources(root) {
      visit(root, "post", (construct) => {
        if (!stack_1.Stack.isStack(construct) || !construct._versionReportingEnabled)
          return;
        const CDKMetadata = "CDKMetadata";
        construct.node.tryFindChild(CDKMetadata) || new metadata_resource_1.MetadataResource(construct, CDKMetadata);
      });
    }
    function injectTreeMetadata(root) {
      visit(root, "post", (construct) => {
        if (!app_1.App.isApp(construct) || !construct._treeMetadata)
          return;
        const CDKTreeMetadata = "Tree";
        construct.node.tryFindChild(CDKTreeMetadata) || new tree_metadata_1.TreeMetadata(construct);
      });
    }
    function synthesizeTree(root, builder, validateOnSynth = false) {
      visit(root, "post", (construct) => {
        const session = { outdir: builder.outdir, assembly: builder, validateOnSynth };
        stack_1.Stack.isStack(construct) ? construct.synthesizer.synthesize(session) : construct instanceof tree_metadata_1.TreeMetadata ? construct._synthesizeTree(session) : getCustomSynthesis(construct)?.onSynthesize(session);
      });
    }
    function validateTree(root) {
      const errors = new Array();
      if (visit(root, "pre", (construct) => {
        for (const message of construct.node.validate())
          errors.push({ message, source: construct });
      }), errors.length > 0) {
        const errorList = errors.map((e) => `[${e.source.node.path}] ${e.message}`).join(`
  `);
        throw new Error(`Validation failed with the following errors:
  ${errorList}`);
      }
    }
    function visitAssemblies(root, order, cb) {
      order === "pre" && cb(root);
      for (const child of root.node.children)
        stage_1.Stage.isStage(child) && visitAssemblies(child, order, cb);
      order === "post" && cb(root);
    }
    function visit(root, order, cb) {
      order === "pre" && cb(root);
      for (const child of root.node.children)
        stage_1.Stage.isStage(child) || visit(child, order, cb);
      order === "post" && cb(root);
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/app.js
var require_app2 = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/app.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.attachCustomSynthesis = exports2.App = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var fs = require_lib6();
    var private_context_1 = require_private_context();
    var synthesis_1 = require_synthesis();
    var stage_1 = require_stage();
    var cxapi = require_cx_api();
    var APP_SYMBOL = Symbol.for("@aws-cdk/core.App");
    var App = class _App extends stage_1.Stage {
      static isApp(obj) {
        return APP_SYMBOL in obj;
      }
      constructor(props = {}) {
        super(void 0, "", { outdir: props.outdir ?? process.env[cxapi.OUTDIR_ENV], policyValidationBeta1: props.policyValidationBeta1 });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_AppProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _App), error;
        }
        Object.defineProperty(this, APP_SYMBOL, { value: true }), this.loadContext(props.context, props.postCliContext), props.stackTraces === false && this.node.setContext(cxapi.DISABLE_METADATA_STACK_TRACE, true), props.defaultStackSynthesizer && this.node.setContext(private_context_1.PRIVATE_CONTEXT_DEFAULT_STACK_SYNTHESIZER, props.defaultStackSynthesizer);
        const analyticsReporting = props.analyticsReporting ?? props.runtimeInfo;
        analyticsReporting !== void 0 && this.node.setContext(cxapi.ANALYTICS_REPORTING_ENABLED_CONTEXT, analyticsReporting), (props.autoSynth ?? cxapi.OUTDIR_ENV in process.env) && process.once("beforeExit", () => this.synth()), this._treeMetadata = props.treeMetadata ?? true;
      }
      loadContext(defaults = {}, final = {}) {
        for (const [k, v] of Object.entries(defaults))
          this.node.setContext(k, v);
        const context = { ...this.readContextFromEnvironment(), ...this.readContextFromTempFile() };
        for (const [k, v] of Object.entries(context))
          this.node.setContext(k, v);
        for (const [k, v] of Object.entries(final))
          this.node.setContext(k, v);
      }
      readContextFromTempFile() {
        const location = process.env[cxapi.CONTEXT_OVERFLOW_LOCATION_ENV];
        return location ? fs.readJSONSync(location) : {};
      }
      readContextFromEnvironment() {
        const contextJson = process.env[cxapi.CONTEXT_ENV];
        return contextJson ? JSON.parse(contextJson) : {};
      }
    };
    _a = JSII_RTTI_SYMBOL_1, App[_a] = { fqn: "aws-cdk-lib.App", version: "2.80.0" }, exports2.App = App;
    function attachCustomSynthesis(construct, synthesis) {
      (0, synthesis_1.addCustomSynthesis)(construct, synthesis);
    }
    exports2.attachCustomSynthesis = attachCustomSynthesis;
  }
});

// node_modules/aws-cdk-lib/core/lib/context-provider.js
var require_context_provider = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/context-provider.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ContextProvider = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var annotations_1 = require_annotations();
    var stack_1 = require_stack();
    var token_1 = require_token2();
    var cxapi = require_cx_api();
    var ContextProvider = class {
      static getKey(scope, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_GetContextKeyOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.getKey), error;
        }
        const stack = stack_1.Stack.of(scope), props = options.includeEnvironment ?? true ? { account: stack.account, region: stack.region, ...options.props } : options.props ?? {};
        if (Object.values(props).find((x) => token_1.Token.isUnresolved(x)))
          throw new Error(`Cannot determine scope for context provider ${options.provider}.
This usually happens when one or more of the provider props have unresolved tokens`);
        const propStrings = propsToArray(props);
        return { key: `${options.provider}:${propStrings.join(":")}`, props };
      }
      static getValue(scope, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_GetContextValueOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.getValue), error;
        }
        const stack = stack_1.Stack.of(scope);
        if (token_1.Token.isUnresolved(stack.account) || token_1.Token.isUnresolved(stack.region))
          throw new Error(`Cannot retrieve value from context provider ${options.provider} since account/region are not specified at the stack level. Configure "env" with an account and region when you define your stack.See https://docs.aws.amazon.com/cdk/latest/guide/environments.html for more details.`);
        const { key, props } = this.getKey(scope, options), value = constructs_1.Node.of(scope).tryGetContext(key), providerError = extractProviderError(value);
        return value === void 0 || providerError !== void 0 ? (stack.reportMissingContextKey({ key, provider: options.provider, props }), providerError !== void 0 && annotations_1.Annotations.of(scope).addError(providerError), { value: options.dummyValue }) : { value };
      }
      constructor() {
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ContextProvider[_a] = { fqn: "aws-cdk-lib.ContextProvider", version: "2.80.0" }, exports2.ContextProvider = ContextProvider;
    function extractProviderError(value) {
      if (typeof value == "object" && value !== null)
        return value[cxapi.PROVIDER_ERROR_KEY];
    }
    function colonQuote(xs) {
      return xs.replace("$", "$$").replace(":", "$:");
    }
    function propsToArray(props, keyPrefix = "") {
      const ret = [];
      for (const key of Object.keys(props))
        if (props[key] !== void 0)
          switch (typeof props[key]) {
            case "object": {
              ret.push(...propsToArray(props[key], `${keyPrefix}${key}.`));
              break;
            }
            case "string": {
              ret.push(`${keyPrefix}${key}=${colonQuote(props[key])}`);
              break;
            }
            default: {
              ret.push(`${keyPrefix}${key}=${JSON.stringify(props[key])}`);
              break;
            }
          }
      return ret.sort(), ret;
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/feature-flags.js
var require_feature_flags = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/feature-flags.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FeatureFlags = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var cxapi = require_cx_api();
    var FeatureFlags = class _FeatureFlags {
      static of(scope) {
        return new _FeatureFlags(scope);
      }
      constructor(construct) {
        this.construct = construct;
      }
      isEnabled(featureFlag) {
        const context = constructs_1.Node.of(this.construct).tryGetContext(featureFlag);
        if (cxapi.CURRENT_VERSION_EXPIRED_FLAGS.includes(featureFlag)) {
          if (context !== void 0)
            throw new Error(`Unsupported feature flag '${featureFlag}'. This flag existed on CDKv1 but has been removed in CDKv2. CDK will now behave as the same as when the flag is enabled.`);
          return true;
        }
        return context !== void 0 ? !!context : cxapi.futureFlagDefault(featureFlag);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, FeatureFlags[_a] = { fqn: "aws-cdk-lib.FeatureFlags", version: "2.80.0" }, exports2.FeatureFlags = FeatureFlags;
  }
});

// node_modules/aws-cdk-lib/core/lib/permissions-boundary.js
var require_permissions_boundary = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/permissions-boundary.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PermissionsBoundary = exports2.PERMISSIONS_BOUNDARY_CONTEXT_KEY = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    exports2.PERMISSIONS_BOUNDARY_CONTEXT_KEY = "@aws-cdk/core:permissionsBoundary";
    var PermissionsBoundary = class _PermissionsBoundary {
      static fromName(name) {
        return new _PermissionsBoundary(name);
      }
      static fromArn(arn) {
        return new _PermissionsBoundary(void 0, arn);
      }
      constructor(policyName, policyArn) {
        this.policyName = policyName, this.policyArn = policyArn;
      }
      _bind(scope, _options = {}) {
        scope.node.setContext(exports2.PERMISSIONS_BOUNDARY_CONTEXT_KEY, { name: this.policyName, arn: this.policyArn });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, PermissionsBoundary[_a] = { fqn: "aws-cdk-lib.PermissionsBoundary", version: "2.80.0" }, exports2.PermissionsBoundary = PermissionsBoundary;
  }
});

// node_modules/aws-cdk-lib/core/lib/private/logical-id.js
var require_logical_id = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/private/logical-id.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LogicalIDs = void 0;
    var LogicalIDs = class {
      constructor() {
        this.renames = {}, this.reverse = {};
      }
      addRename(oldId, newId) {
        if (oldId in this.renames)
          throw new Error(`A rename has already been registered for '${oldId}'`);
        this.renames[oldId] = newId;
      }
      applyRename(oldId) {
        let newId = oldId;
        if (oldId in this.renames && (newId = this.renames[oldId]), newId in this.reverse && this.reverse[newId] !== oldId)
          throw new Error(`Two objects have been assigned the same Logical ID: '${this.reverse[newId]}' and '${oldId}' are now both named '${newId}'.`);
        return this.reverse[newId] = oldId, validateLogicalId(newId), newId;
      }
      assertAllRenamesApplied() {
        const keys = /* @__PURE__ */ new Set();
        if (Object.keys(this.renames).forEach(keys.add.bind(keys)), Object.keys(this.reverse).map((newId) => {
          keys.delete(this.reverse[newId]);
        }), keys.size !== 0) {
          const unusedRenames = Array.from(keys.values());
          throw new Error(`The following Logical IDs were attempted to be renamed, but not found: ${unusedRenames.join(", ")}`);
        }
      }
    };
    exports2.LogicalIDs = LogicalIDs;
    var VALID_LOGICALID_REGEX = /^[A-Za-z][A-Za-z0-9]{1,254}$/;
    function validateLogicalId(logicalId) {
      if (!VALID_LOGICALID_REGEX.test(logicalId))
        throw new Error(`Logical ID must adhere to the regular expression: ${VALID_LOGICALID_REGEX.toString()}, got '${logicalId}'`);
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/deps.js
var require_deps = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/deps.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.obtainDependencies = exports2.removeDependency = exports2.addDependency = void 0;
    var cfn_resource_1 = require_cfn_resource();
    var stack_1 = require_stack();
    var stage_1 = require_stage();
    var util_1 = require_util2();
    function addDependency(source, target, reason) {
      operateOnDependency(DependencyOperation.ADD, source, target, reason);
    }
    exports2.addDependency = addDependency;
    function removeDependency(source, target) {
      operateOnDependency(DependencyOperation.REMOVE, source, target);
    }
    exports2.removeDependency = removeDependency;
    var DependencyOperation;
    (function(DependencyOperation2) {
      DependencyOperation2[DependencyOperation2.ADD = 0] = "ADD", DependencyOperation2[DependencyOperation2.REMOVE = 1] = "REMOVE";
    })(DependencyOperation || (DependencyOperation = {}));
    function operateOnDependency(operation, source, target, description) {
      if (source === target)
        return;
      const sourceStack = stack_1.Stack.of(source), targetStack = stack_1.Stack.of(target), sourceStage = stage_1.Stage.of(sourceStack), targetStage = stage_1.Stage.of(targetStack);
      if (sourceStage !== targetStage)
        throw new Error(`You cannot have a dependency from '${source.node.path}' (in ${describeStage(sourceStage)}) to '${target.node.path}' (in ${describeStage(targetStage)}): dependency cannot cross stage boundaries`);
      const sourcePath = (0, util_1.pathToTopLevelStack)(sourceStack), targetPath = (0, util_1.pathToTopLevelStack)(targetStack), commonStack = (0, util_1.findLastCommonElement)(sourcePath, targetPath);
      if (!commonStack) {
        const topLevelSource = sourcePath[0], topLevelTarget = targetPath[0], reason = { source, target, description };
        switch (operation) {
          case DependencyOperation.ADD: {
            topLevelSource._addAssemblyDependency(topLevelTarget, reason);
            break;
          }
          case DependencyOperation.REMOVE: {
            topLevelSource._removeAssemblyDependency(topLevelTarget, reason);
            break;
          }
          default:
            throw new Error(`Unsupported dependency operation: ${operation}`);
        }
        return;
      }
      if (commonStack === source)
        return;
      if (commonStack === target)
        throw new Error(`Nested stack '${sourceStack.node.path}' cannot depend on a parent stack '${targetStack.node.path}'`);
      const sourceResource = resourceInCommonStackFor(source, commonStack), targetResource = resourceInCommonStackFor(target, commonStack);
      switch (operation) {
        case DependencyOperation.ADD: {
          sourceResource._addResourceDependency(targetResource);
          break;
        }
        case DependencyOperation.REMOVE: {
          sourceResource._removeResourceDependency(targetResource);
          break;
        }
        default:
          throw new Error(`Unsupported dependency operation: ${operation}`);
      }
    }
    function obtainDependencies(source) {
      let dependencies = [];
      return source instanceof cfn_resource_1.CfnResource && (dependencies = source.obtainResourceDependencies()), (0, util_1.pathToTopLevelStack)(stack_1.Stack.of(source)).forEach((stack) => {
        dependencies = [...dependencies, ...stack._obtainAssemblyDependencies({ source })];
      }), dependencies;
    }
    exports2.obtainDependencies = obtainDependencies;
    function resourceInCommonStackFor(element, commonStack) {
      const resource = stack_1.Stack.isStack(element) ? element.nestedStackResource : element;
      if (!resource)
        throw new Error(`Unexpected value for resource when looking at ${element}!`);
      const resourceStack = stack_1.Stack.of(resource);
      return commonStack === resourceStack ? resource : resourceInCommonStackFor(resourceStack, commonStack);
    }
    function describeStage(assembly) {
      return assembly ? assembly.parentStage ? `Stage '${assembly.node.path}'` : "the App" : "an unrooted construct tree";
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/stack-synthesizers/types.js
var require_types5 = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/stack-synthesizers/types.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.isReusableStackSynthesizer = void 0;
    function isReusableStackSynthesizer(x) {
      return !!x.reusableBind;
    }
    exports2.isReusableStackSynthesizer = isReusableStackSynthesizer;
  }
});

// node_modules/aws-cdk-lib/core/lib/stack-synthesizers/_shared.js
var require_shared = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/stack-synthesizers/_shared.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.resolvedOr = exports2.StringSpecializer = exports2.assertBound = exports2.contentHash = exports2.addStackArtifactToAssembly = void 0;
    var crypto = require("crypto");
    var constructs_1 = require_lib2();
    var cxschema = require_cloud_assembly_schema2();
    var cxapi = require_cx_api();
    var stack_1 = require_stack();
    var token_1 = require_token2();
    function addStackArtifactToAssembly(session, stack, stackProps, additionalStackDependencies) {
      stack.tags.hasTags() && stack.node.addMetadata(cxschema.ArtifactMetadataEntryType.STACK_TAGS, stack.tags.renderTags());
      const deps = [...stack.dependencies.map((s) => s.artifactId), ...additionalStackDependencies], meta = collectStackMetadata(stack), stackNameProperty = stack.stackName === stack.artifactId ? {} : { stackName: stack.stackName }, properties = { templateFile: stack.templateFile, terminationProtection: stack.terminationProtection, tags: nonEmptyDict(stack.tags.tagValues()), validateOnSynth: session.validateOnSynth, ...stackProps, ...stackNameProperty };
      session.assembly.addArtifact(stack.artifactId, { type: cxschema.ArtifactType.AWS_CLOUDFORMATION_STACK, environment: stack.environment, properties, dependencies: deps.length > 0 ? deps : void 0, metadata: Object.keys(meta).length > 0 ? meta : void 0, displayName: stack.node.path });
    }
    exports2.addStackArtifactToAssembly = addStackArtifactToAssembly;
    function collectStackMetadata(stack) {
      const output = {};
      return visit(stack), output;
      function visit(node) {
        if (findParentStack(node) === stack) {
          node.node.metadata.length > 0 && (output[constructs_1.Node.PATH_SEP + node.node.path] = node.node.metadata.map((md) => stack.resolve(md)));
          for (const child of node.node.children)
            visit(child);
        }
      }
      function findParentStack(node) {
        if (stack_1.Stack.isStack(node) && node.nestedStackParent === void 0)
          return node;
        if (node.node.scope)
          return findParentStack(node.node.scope);
      }
    }
    function contentHash(content) {
      return crypto.createHash("sha256").update(content).digest("hex");
    }
    exports2.contentHash = contentHash;
    function assertBound(x) {
      if (x === null && x === void 0)
        throw new Error("You must call bindStack() first");
    }
    exports2.assertBound = assertBound;
    function nonEmptyDict(xs) {
      return Object.keys(xs).length > 0 ? xs : void 0;
    }
    function replaceAll(s, search, replace) {
      return s.split(search).join(replace);
    }
    var StringSpecializer = class {
      constructor(stack, qualifier) {
        this.stack = stack, this.qualifier = qualifier;
      }
      specialize(s) {
        return s = replaceAll(s, "${Qualifier}", this.qualifier), cxapi.EnvironmentPlaceholders.replace(s, { region: resolvedOr(this.stack.region, cxapi.EnvironmentPlaceholders.CURRENT_REGION), accountId: resolvedOr(this.stack.account, cxapi.EnvironmentPlaceholders.CURRENT_ACCOUNT), partition: cxapi.EnvironmentPlaceholders.CURRENT_PARTITION });
      }
      qualifierOnly(s) {
        return replaceAll(s, "${Qualifier}", this.qualifier);
      }
    };
    exports2.StringSpecializer = StringSpecializer;
    function resolvedOr(x, def) {
      return token_1.Token.isUnresolved(x) ? def : x;
    }
    exports2.resolvedOr = resolvedOr;
  }
});

// node_modules/aws-cdk-lib/core/lib/stack-synthesizers/asset-manifest-builder.js
var require_asset_manifest_builder = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/stack-synthesizers/asset-manifest-builder.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AssetManifestBuilder = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var fs = require("fs");
    var path = require("path");
    var _shared_1 = require_shared();
    var cxschema = require_cloud_assembly_schema2();
    var assets_1 = require_assets3();
    var AssetManifestBuilder = class {
      constructor() {
        this.files = {}, this.dockerImages = {};
      }
      defaultAddFileAsset(stack, asset, target) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Stack(stack), jsiiDeprecationWarnings.aws_cdk_lib_FileAssetSource(asset), jsiiDeprecationWarnings.aws_cdk_lib_AssetManifestFileDestination(target);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.defaultAddFileAsset), error;
        }
        validateFileAssetSource(asset);
        const extension = asset.fileName != null ? path.extname(asset.fileName) : "", objectKey = (target.bucketPrefix ?? "") + asset.sourceHash + (asset.packaging === assets_1.FileAssetPackaging.ZIP_DIRECTORY ? ".zip" : extension);
        return this.addFileAsset(stack, asset.sourceHash, { path: asset.fileName, executable: asset.executable, packaging: asset.packaging }, { bucketName: target.bucketName, objectKey, region: (0, _shared_1.resolvedOr)(stack.region, void 0), assumeRoleArn: target.role?.assumeRoleArn, assumeRoleExternalId: target.role?.assumeRoleExternalId });
      }
      defaultAddDockerImageAsset(stack, asset, target) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Stack(stack), jsiiDeprecationWarnings.aws_cdk_lib_DockerImageAssetSource(asset), jsiiDeprecationWarnings.aws_cdk_lib_AssetManifestDockerImageDestination(target);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.defaultAddDockerImageAsset), error;
        }
        validateDockerImageAssetSource(asset);
        const imageTag = `${target.dockerTagPrefix ?? ""}${asset.sourceHash}`;
        return this.addDockerImageAsset(stack, asset.sourceHash, { executable: asset.executable, directory: asset.directoryName, dockerBuildArgs: asset.dockerBuildArgs, dockerBuildSecrets: asset.dockerBuildSecrets, dockerBuildTarget: asset.dockerBuildTarget, dockerFile: asset.dockerFile, networkMode: asset.networkMode, platform: asset.platform, dockerOutputs: asset.dockerOutputs, cacheFrom: asset.dockerCacheFrom, cacheTo: asset.dockerCacheTo }, { repositoryName: target.repositoryName, imageTag, region: (0, _shared_1.resolvedOr)(stack.region, void 0), assumeRoleArn: target.role?.assumeRoleArn, assumeRoleExternalId: target.role?.assumeRoleExternalId });
      }
      addFileAsset(stack, sourceHash, source, dest) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Stack(stack), jsiiDeprecationWarnings.aws_cdk_lib_cloud_assembly_schema_FileSource(source), jsiiDeprecationWarnings.aws_cdk_lib_cloud_assembly_schema_FileDestination(dest);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addFileAsset), error;
        }
        return this.files[sourceHash] || (this.files[sourceHash] = { source, destinations: {} }), this.files[sourceHash].destinations[this.manifestEnvName(stack)] = dest, dest;
      }
      addDockerImageAsset(stack, sourceHash, source, dest) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Stack(stack), jsiiDeprecationWarnings.aws_cdk_lib_cloud_assembly_schema_DockerImageSource(source), jsiiDeprecationWarnings.aws_cdk_lib_cloud_assembly_schema_DockerImageDestination(dest);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addDockerImageAsset), error;
        }
        return this.dockerImages[sourceHash] || (this.dockerImages[sourceHash] = { source, destinations: {} }), this.dockerImages[sourceHash].destinations[this.manifestEnvName(stack)] = dest, dest;
      }
      get hasAssets() {
        return Object.keys(this.files).length + Object.keys(this.dockerImages).length > 0;
      }
      emitManifest(stack, session, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Stack(stack), jsiiDeprecationWarnings.aws_cdk_lib_ISynthesisSession(session), jsiiDeprecationWarnings.aws_cdk_lib_cloud_assembly_schema_AssetManifestOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.emitManifest), error;
        }
        const artifactId = `${stack.artifactId}.assets`, manifestFile = `${artifactId}.json`, outPath = path.join(session.assembly.outdir, manifestFile), manifest = { version: cxschema.Manifest.version(), files: this.files, dockerImages: this.dockerImages };
        return fs.writeFileSync(outPath, JSON.stringify(manifest, void 0, 2)), session.assembly.addArtifact(artifactId, { type: cxschema.ArtifactType.ASSET_MANIFEST, properties: { file: manifestFile, ...options } }), artifactId;
      }
      manifestEnvName(stack) {
        return [(0, _shared_1.resolvedOr)(stack.account, "current_account"), (0, _shared_1.resolvedOr)(stack.region, "current_region")].join("-");
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AssetManifestBuilder[_a] = { fqn: "aws-cdk-lib.AssetManifestBuilder", version: "2.80.0" }, exports2.AssetManifestBuilder = AssetManifestBuilder;
    function validateFileAssetSource(asset) {
      if (!!asset.executable == !!asset.fileName)
        throw new Error(`Exactly one of 'fileName' or 'executable' is required, got: ${JSON.stringify(asset)}`);
      if (!!asset.packaging != !!asset.fileName)
        throw new Error(`'packaging' is expected in combination with 'fileName', got: ${JSON.stringify(asset)}`);
    }
    function validateDockerImageAssetSource(asset) {
      if (!!asset.executable == !!asset.directoryName)
        throw new Error(`Exactly one of 'directoryName' or 'executable' is required, got: ${JSON.stringify(asset)}`);
      check("dockerBuildArgs"), check("dockerBuildTarget"), check("dockerOutputs"), check("dockerFile");
      function check(key) {
        if (asset[key] && !asset.directoryName)
          throw new Error(`'${key}' is only allowed in combination with 'directoryName', got: ${JSON.stringify(asset)}`);
      }
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/cfn-rule.js
var require_cfn_rule = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/cfn-rule.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnRule = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cfn_element_1 = require_cfn_element();
    var util_1 = require_util2();
    var CfnRule = class _CfnRule extends cfn_element_1.CfnRefElement {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnRuleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRule), error;
        }
        this.ruleCondition = props && props.ruleCondition, this.assertions = props && props.assertions;
      }
      addAssertion(condition, description) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ICfnConditionExpression(condition);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addAssertion), error;
        }
        this.assertions || (this.assertions = []), this.assertions.push({ assert: condition, assertDescription: description });
      }
      _toCloudFormation() {
        return { Rules: { [this.logicalId]: { RuleCondition: this.ruleCondition, Assertions: (0, util_1.capitalizePropertyNames)(this, this.assertions) } } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnRule[_a] = { fqn: "aws-cdk-lib.CfnRule", version: "2.80.0" }, exports2.CfnRule = CfnRule;
  }
});

// node_modules/aws-cdk-lib/core/lib/stack-synthesizers/stack-synthesizer.js
var require_stack_synthesizer = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/stack-synthesizers/stack-synthesizer.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.StackSynthesizer = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var fs = require("fs");
    var path = require("path");
    var _shared_1 = require_shared();
    var cxapi = require_cx_api();
    var assets_1 = require_assets3();
    var cfn_fn_1 = require_cfn_fn();
    var cfn_parameter_1 = require_cfn_parameter();
    var cfn_rule_1 = require_cfn_rule();
    var StackSynthesizer = class {
      get bootstrapQualifier() {
      }
      bind(stack) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Stack(stack);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        if (this._boundStack !== void 0)
          throw new Error("A StackSynthesizer can only be used for one Stack: create a new instance to use with a different Stack");
        this._boundStack = stack;
      }
      synthesizeStackTemplate(stack, session) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.StackSynthesizer#synthesizeStackTemplate", "Use `synthesizeTemplate` instead"), jsiiDeprecationWarnings.aws_cdk_lib_Stack(stack), jsiiDeprecationWarnings.aws_cdk_lib_ISynthesisSession(session);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.synthesizeStackTemplate), error;
        }
        stack._synthesizeTemplate(session);
      }
      synthesizeTemplate(session, lookupRoleArn) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ISynthesisSession(session);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.synthesizeTemplate), error;
        }
        return this.boundStack._synthesizeTemplate(session, lookupRoleArn), stackTemplateFileAsset(this.boundStack, session);
      }
      emitStackArtifact(stack, session, options = {}) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.StackSynthesizer#emitStackArtifact", "Use `emitArtifact` instead"), jsiiDeprecationWarnings.aws_cdk_lib_Stack(stack), jsiiDeprecationWarnings.aws_cdk_lib_ISynthesisSession(session), jsiiDeprecationWarnings.aws_cdk_lib_SynthesizeStackArtifactOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.emitStackArtifact), error;
        }
        (0, _shared_1.addStackArtifactToAssembly)(session, stack, options ?? {}, options.additionalDependencies ?? []);
      }
      emitArtifact(session, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ISynthesisSession(session), jsiiDeprecationWarnings.aws_cdk_lib_SynthesizeStackArtifactOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.emitArtifact), error;
        }
        (0, _shared_1.addStackArtifactToAssembly)(session, this.boundStack, options ?? {}, options.additionalDependencies ?? []);
      }
      addBootstrapVersionRule(requiredVersion, bootstrapStackVersionSsmParameter) {
        addBootstrapVersionRule(this.boundStack, requiredVersion, bootstrapStackVersionSsmParameter);
      }
      get boundStack() {
        if (!this._boundStack)
          throw new Error("The StackSynthesizer must be bound to a Stack first before boundStack() can be called");
        return this._boundStack;
      }
      cloudFormationLocationFromFileAsset(location) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_cloud_assembly_schema_FileDestination(location);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.cloudFormationLocationFromFileAsset), error;
        }
        const { region, urlSuffix } = stackLocationOrInstrinsics(this.boundStack), httpUrl = cfnify(`https://s3.${region}.${urlSuffix}/${location.bucketName}/${location.objectKey}`), s3ObjectUrlWithPlaceholders = `s3://${location.bucketName}/${location.objectKey}`;
        return { bucketName: cfnify(location.bucketName), objectKey: cfnify(location.objectKey), httpUrl, s3ObjectUrl: cfnify(s3ObjectUrlWithPlaceholders), s3ObjectUrlWithPlaceholders, s3Url: httpUrl };
      }
      cloudFormationLocationFromDockerImageAsset(dest) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_cloud_assembly_schema_DockerImageDestination(dest);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.cloudFormationLocationFromDockerImageAsset), error;
        }
        const { account, region, urlSuffix } = stackLocationOrInstrinsics(this.boundStack);
        return { repositoryName: cfnify(dest.repositoryName), imageUri: cfnify(`${account}.dkr.ecr.${region}.${urlSuffix}/${dest.repositoryName}:${dest.imageTag}`), imageTag: cfnify(dest.imageTag) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, StackSynthesizer[_a] = { fqn: "aws-cdk-lib.StackSynthesizer", version: "2.80.0" }, exports2.StackSynthesizer = StackSynthesizer;
    function stackTemplateFileAsset(stack, session) {
      const templatePath = path.join(session.assembly.outdir, stack.templateFile);
      if (!fs.existsSync(templatePath))
        throw new Error(`Stack template ${stack.stackName} not written yet: ${templatePath}`);
      const template = fs.readFileSync(templatePath, { encoding: "utf-8" }), sourceHash = (0, _shared_1.contentHash)(template);
      return { fileName: stack.templateFile, packaging: assets_1.FileAssetPackaging.FILE, sourceHash };
    }
    function addBootstrapVersionRule(stack, requiredVersion, bootstrapStackVersionSsmParameter) {
      if (stack.node.tryFindChild("BootstrapVersion"))
        return;
      const param = new cfn_parameter_1.CfnParameter(stack, "BootstrapVersion", { type: "AWS::SSM::Parameter::Value<String>", description: `Version of the CDK Bootstrap resources in this environment, automatically retrieved from SSM Parameter Store. ${cxapi.SSMPARAM_NO_INVALIDATE}`, default: bootstrapStackVersionSsmParameter }), oldVersions = range(1, requiredVersion).map((n) => `${n}`);
      new cfn_rule_1.CfnRule(stack, "CheckBootstrapVersion", { assertions: [{ assert: cfn_fn_1.Fn.conditionNot(cfn_fn_1.Fn.conditionContains(oldVersions, param.valueAsString)), assertDescription: `CDK bootstrap stack version ${requiredVersion} required. Please run 'cdk bootstrap' with a recent version of the CDK CLI.` }] });
    }
    function range(startIncl, endExcl) {
      const ret = new Array();
      for (let i = startIncl; i < endExcl; i++)
        ret.push(i);
      return ret;
    }
    function stackLocationOrInstrinsics(stack) {
      return { account: (0, _shared_1.resolvedOr)(stack.account, "${AWS::AccountId}"), region: (0, _shared_1.resolvedOr)(stack.region, "${AWS::Region}"), urlSuffix: (0, _shared_1.resolvedOr)(stack.urlSuffix, "${AWS::URLSuffix}") };
    }
    function cfnify(s) {
      return s.indexOf("${") > -1 ? cfn_fn_1.Fn.sub(s) : s;
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/stack-synthesizers/default-synthesizer.js
var require_default_synthesizer = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/stack-synthesizers/default-synthesizer.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DefaultStackSynthesizer = exports2.BOOTSTRAP_QUALIFIER_CONTEXT = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var _shared_1 = require_shared();
    var asset_manifest_builder_1 = require_asset_manifest_builder();
    var stack_synthesizer_1 = require_stack_synthesizer();
    var cxapi = require_cx_api();
    var token_1 = require_token2();
    exports2.BOOTSTRAP_QUALIFIER_CONTEXT = "@aws-cdk/core:bootstrapQualifier";
    var MIN_BOOTSTRAP_STACK_VERSION = 6;
    var MIN_LOOKUP_ROLE_BOOTSTRAP_STACK_VERSION = 8;
    var DefaultStackSynthesizer = class _DefaultStackSynthesizer extends stack_synthesizer_1.StackSynthesizer {
      constructor(props = {}) {
        super(), this.props = props, this.assetManifest = new asset_manifest_builder_1.AssetManifestBuilder();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_DefaultStackSynthesizerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _DefaultStackSynthesizer), error;
        }
        this.useLookupRoleForStackOperations = props.useLookupRoleForStackOperations ?? true;
        for (const key in props)
          props.hasOwnProperty(key) && validateNoToken(key);
        function validateNoToken(key) {
          const prop = props[key];
          if (typeof prop == "string" && token_1.Token.isUnresolved(prop))
            throw new Error(`DefaultStackSynthesizer property '${key}' cannot contain tokens; only the following placeholder strings are allowed: ` + ["${Qualifier}", cxapi.EnvironmentPlaceholders.CURRENT_REGION, cxapi.EnvironmentPlaceholders.CURRENT_ACCOUNT, cxapi.EnvironmentPlaceholders.CURRENT_PARTITION].join(", "));
        }
      }
      reusableBind(stack) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Stack(stack);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.reusableBind), error;
        }
        const copy = Object.create(this);
        return copy.bind(stack), copy;
      }
      get bootstrapQualifier() {
        return this.qualifier;
      }
      bind(stack) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Stack(stack);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        super.bind(stack);
        const qualifier = this.props.qualifier ?? stack.node.tryGetContext(exports2.BOOTSTRAP_QUALIFIER_CONTEXT) ?? _DefaultStackSynthesizer.DEFAULT_QUALIFIER;
        this.qualifier = qualifier;
        const spec = new _shared_1.StringSpecializer(stack, qualifier);
        this.bucketName = spec.specialize(this.props.fileAssetsBucketName ?? _DefaultStackSynthesizer.DEFAULT_FILE_ASSETS_BUCKET_NAME), this.repositoryName = spec.specialize(this.props.imageAssetsRepositoryName ?? _DefaultStackSynthesizer.DEFAULT_IMAGE_ASSETS_REPOSITORY_NAME), this._deployRoleArn = spec.specialize(this.props.deployRoleArn ?? _DefaultStackSynthesizer.DEFAULT_DEPLOY_ROLE_ARN), this._cloudFormationExecutionRoleArn = spec.specialize(this.props.cloudFormationExecutionRole ?? _DefaultStackSynthesizer.DEFAULT_CLOUDFORMATION_ROLE_ARN), this.fileAssetPublishingRoleArn = spec.specialize(this.props.fileAssetPublishingRoleArn ?? _DefaultStackSynthesizer.DEFAULT_FILE_ASSET_PUBLISHING_ROLE_ARN), this.imageAssetPublishingRoleArn = spec.specialize(this.props.imageAssetPublishingRoleArn ?? _DefaultStackSynthesizer.DEFAULT_IMAGE_ASSET_PUBLISHING_ROLE_ARN), this.lookupRoleArn = spec.specialize(this.props.lookupRoleArn ?? _DefaultStackSynthesizer.DEFAULT_LOOKUP_ROLE_ARN), this.bucketPrefix = spec.specialize(this.props.bucketPrefix ?? _DefaultStackSynthesizer.DEFAULT_FILE_ASSET_PREFIX), this.dockerTagPrefix = spec.specialize(this.props.dockerTagPrefix ?? _DefaultStackSynthesizer.DEFAULT_DOCKER_ASSET_PREFIX), this.bootstrapStackVersionSsmParameter = spec.qualifierOnly(this.props.bootstrapStackVersionSsmParameter ?? _DefaultStackSynthesizer.DEFAULT_BOOTSTRAP_STACK_VERSION_SSM_PARAMETER);
      }
      addFileAsset(asset) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_FileAssetSource(asset);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addFileAsset), error;
        }
        (0, _shared_1.assertBound)(this.bucketName);
        const location = this.assetManifest.defaultAddFileAsset(this.boundStack, asset, { bucketName: this.bucketName, bucketPrefix: this.bucketPrefix, role: this.fileAssetPublishingRoleArn ? { assumeRoleArn: this.fileAssetPublishingRoleArn, assumeRoleExternalId: this.props.fileAssetPublishingExternalId } : void 0 });
        return this.cloudFormationLocationFromFileAsset(location);
      }
      addDockerImageAsset(asset) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_DockerImageAssetSource(asset);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addDockerImageAsset), error;
        }
        (0, _shared_1.assertBound)(this.repositoryName);
        const location = this.assetManifest.defaultAddDockerImageAsset(this.boundStack, asset, { repositoryName: this.repositoryName, dockerTagPrefix: this.dockerTagPrefix, role: this.imageAssetPublishingRoleArn ? { assumeRoleArn: this.imageAssetPublishingRoleArn, assumeRoleExternalId: this.props.imageAssetPublishingExternalId } : void 0 });
        return this.cloudFormationLocationFromDockerImageAsset(location);
      }
      synthesizeStackTemplate(stack, session) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Stack(stack), jsiiDeprecationWarnings.aws_cdk_lib_ISynthesisSession(session);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.synthesizeStackTemplate), error;
        }
        stack._synthesizeTemplate(session, this.lookupRoleArn);
      }
      get stack() {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.DefaultStackSynthesizer#stack", "Use `boundStack` instead.");
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, jsiiDeprecationWarnings.getPropertyDescriptor(this, "stack").get), error;
        }
        return this.boundStack;
      }
      synthesize(session) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ISynthesisSession(session);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.synthesize), error;
        }
        (0, _shared_1.assertBound)(this.qualifier), (this.props.generateBootstrapVersionRule ?? true) && this.addBootstrapVersionRule(MIN_BOOTSTRAP_STACK_VERSION, this.bootstrapStackVersionSsmParameter);
        const templateAssetSource = this.synthesizeTemplate(session, this.lookupRoleArn), templateAsset = this.addFileAsset(templateAssetSource), assetManifestId = this.assetManifest.emitManifest(this.boundStack, session, { requiresBootstrapStackVersion: MIN_BOOTSTRAP_STACK_VERSION, bootstrapStackVersionSsmParameter: this.bootstrapStackVersionSsmParameter });
        this.emitArtifact(session, { assumeRoleExternalId: this.props.deployRoleExternalId, assumeRoleArn: this._deployRoleArn, cloudFormationExecutionRoleArn: this._cloudFormationExecutionRoleArn, stackTemplateAssetObjectUrl: templateAsset.s3ObjectUrlWithPlaceholders, requiresBootstrapStackVersion: MIN_BOOTSTRAP_STACK_VERSION, bootstrapStackVersionSsmParameter: this.bootstrapStackVersionSsmParameter, additionalDependencies: [assetManifestId], lookupRole: this.useLookupRoleForStackOperations && this.lookupRoleArn ? { arn: this.lookupRoleArn, assumeRoleExternalId: this.props.lookupRoleExternalId, requiresBootstrapStackVersion: MIN_LOOKUP_ROLE_BOOTSTRAP_STACK_VERSION, bootstrapStackVersionSsmParameter: this.bootstrapStackVersionSsmParameter } : void 0 });
      }
      get deployRoleArn() {
        if (!this._deployRoleArn)
          throw new Error("deployRoleArn getter can only be called after the synthesizer has been bound to a Stack");
        return this._deployRoleArn;
      }
      get cloudFormationExecutionRoleArn() {
        if (!this._cloudFormationExecutionRoleArn)
          throw new Error("cloudFormationExecutionRoleArn getter can only be called after the synthesizer has been bound to a Stack");
        return this._cloudFormationExecutionRoleArn;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, DefaultStackSynthesizer[_a] = { fqn: "aws-cdk-lib.DefaultStackSynthesizer", version: "2.80.0" }, DefaultStackSynthesizer.DEFAULT_QUALIFIER = "hnb659fds", DefaultStackSynthesizer.DEFAULT_CLOUDFORMATION_ROLE_ARN = "arn:${AWS::Partition}:iam::${AWS::AccountId}:role/cdk-${Qualifier}-cfn-exec-role-${AWS::AccountId}-${AWS::Region}", DefaultStackSynthesizer.DEFAULT_DEPLOY_ROLE_ARN = "arn:${AWS::Partition}:iam::${AWS::AccountId}:role/cdk-${Qualifier}-deploy-role-${AWS::AccountId}-${AWS::Region}", DefaultStackSynthesizer.DEFAULT_FILE_ASSET_PUBLISHING_ROLE_ARN = "arn:${AWS::Partition}:iam::${AWS::AccountId}:role/cdk-${Qualifier}-file-publishing-role-${AWS::AccountId}-${AWS::Region}", DefaultStackSynthesizer.DEFAULT_IMAGE_ASSET_PUBLISHING_ROLE_ARN = "arn:${AWS::Partition}:iam::${AWS::AccountId}:role/cdk-${Qualifier}-image-publishing-role-${AWS::AccountId}-${AWS::Region}", DefaultStackSynthesizer.DEFAULT_LOOKUP_ROLE_ARN = "arn:${AWS::Partition}:iam::${AWS::AccountId}:role/cdk-${Qualifier}-lookup-role-${AWS::AccountId}-${AWS::Region}", DefaultStackSynthesizer.DEFAULT_IMAGE_ASSETS_REPOSITORY_NAME = "cdk-${Qualifier}-container-assets-${AWS::AccountId}-${AWS::Region}", DefaultStackSynthesizer.DEFAULT_FILE_ASSETS_BUCKET_NAME = "cdk-${Qualifier}-assets-${AWS::AccountId}-${AWS::Region}", DefaultStackSynthesizer.DEFAULT_FILE_ASSET_KEY_ARN_EXPORT_NAME = "CdkBootstrap-${Qualifier}-FileAssetKeyArn", DefaultStackSynthesizer.DEFAULT_FILE_ASSET_PREFIX = "", DefaultStackSynthesizer.DEFAULT_DOCKER_ASSET_PREFIX = "", DefaultStackSynthesizer.DEFAULT_BOOTSTRAP_STACK_VERSION_SSM_PARAMETER = "/cdk-bootstrap/${Qualifier}/version", exports2.DefaultStackSynthesizer = DefaultStackSynthesizer;
  }
});

// node_modules/aws-cdk-lib/core/lib/private/asset-parameters.js
var require_asset_parameters = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/private/asset-parameters.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FileAssetParameters = void 0;
    var constructs_1 = require_lib2();
    var cfn_parameter_1 = require_cfn_parameter();
    var FileAssetParameters = class extends constructs_1.Construct {
      constructor(scope, id) {
        super(scope, id), this.bucketNameParameter = new cfn_parameter_1.CfnParameter(this, "S3Bucket", { type: "String", description: `S3 bucket for asset "${id}"` }), this.objectKeyParameter = new cfn_parameter_1.CfnParameter(this, "S3VersionKey", { type: "String", description: `S3 key for asset version "${id}"` }), this.artifactHashParameter = new cfn_parameter_1.CfnParameter(this, "ArtifactHash", { description: `Artifact hash for asset "${id}"`, type: "String" });
      }
    };
    exports2.FileAssetParameters = FileAssetParameters;
  }
});

// node_modules/aws-cdk-lib/core/lib/stack-synthesizers/legacy.js
var require_legacy = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/stack-synthesizers/legacy.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LegacyStackSynthesizer = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var _shared_1 = require_shared();
    var stack_synthesizer_1 = require_stack_synthesizer();
    var cxschema = require_cloud_assembly_schema2();
    var cxapi = require_cx_api();
    var cfn_fn_1 = require_cfn_fn();
    var asset_parameters_1 = require_asset_parameters();
    var ASSETS_ECR_REPOSITORY_NAME = "aws-cdk/assets";
    var ASSETS_ECR_REPOSITORY_NAME_OVERRIDE_CONTEXT_KEY = "assets-ecr-repository-name";
    var LegacyStackSynthesizer = class extends stack_synthesizer_1.StackSynthesizer {
      constructor() {
        super(...arguments), this.cycle = false, this.addedImageAssets = /* @__PURE__ */ new Set();
      }
      addFileAsset(asset) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_FileAssetSource(asset);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addFileAsset), error;
        }
        if (this.cycle)
          return this.doAddFileAsset(asset);
        this.cycle = true;
        try {
          const stack = this.boundStack;
          return withoutDeprecationWarnings(() => stack.addFileAsset(asset));
        } finally {
          this.cycle = false;
        }
      }
      addDockerImageAsset(asset) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_DockerImageAssetSource(asset);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addDockerImageAsset), error;
        }
        if (this.cycle)
          return this.doAddDockerImageAsset(asset);
        this.cycle = true;
        try {
          const stack = this.boundStack;
          return withoutDeprecationWarnings(() => stack.addDockerImageAsset(asset));
        } finally {
          this.cycle = false;
        }
      }
      synthesize(session) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ISynthesisSession(session);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.synthesize), error;
        }
        this.synthesizeTemplate(session), this.emitArtifact(session);
      }
      reusableBind(stack) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Stack(stack);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.reusableBind), error;
        }
        const copy = Object.create(this);
        return copy.bind(stack), copy;
      }
      doAddDockerImageAsset(asset) {
        const repositoryNameOverride = this.boundStack.node.tryGetContext(ASSETS_ECR_REPOSITORY_NAME_OVERRIDE_CONTEXT_KEY), repositoryName = asset.repositoryName ?? repositoryNameOverride ?? ASSETS_ECR_REPOSITORY_NAME, imageTag = asset.sourceHash, assetId = asset.sourceHash;
        if (!this.addedImageAssets.has(assetId)) {
          if (!asset.directoryName)
            throw new Error(`LegacyStackSynthesizer does not support this type of file asset: ${JSON.stringify(asset)}`);
          const metadata = { repositoryName, imageTag, id: assetId, packaging: "container-image", path: asset.directoryName, sourceHash: asset.sourceHash, buildArgs: asset.dockerBuildArgs, target: asset.dockerBuildTarget, file: asset.dockerFile, networkMode: asset.networkMode, platform: asset.platform, outputs: asset.dockerOutputs, cacheFrom: asset.dockerCacheFrom, cacheTo: asset.dockerCacheTo };
          this.boundStack.node.addMetadata(cxschema.ArtifactMetadataEntryType.ASSET, metadata), this.addedImageAssets.add(assetId);
        }
        return { imageUri: `${this.boundStack.account}.dkr.ecr.${this.boundStack.region}.${this.boundStack.urlSuffix}/${repositoryName}:${imageTag}`, repositoryName };
      }
      doAddFileAsset(asset) {
        let params = this.assetParameters.node.tryFindChild(asset.sourceHash);
        if (!params) {
          if (params = new asset_parameters_1.FileAssetParameters(this.assetParameters, asset.sourceHash), !asset.fileName || !asset.packaging)
            throw new Error(`LegacyStackSynthesizer does not support this type of file asset: ${JSON.stringify(asset)}`);
          const metadata = { path: asset.fileName, id: asset.sourceHash, packaging: asset.packaging, sourceHash: asset.sourceHash, s3BucketParameter: params.bucketNameParameter.logicalId, s3KeyParameter: params.objectKeyParameter.logicalId, artifactHashParameter: params.artifactHashParameter.logicalId };
          this.boundStack.node.addMetadata(cxschema.ArtifactMetadataEntryType.ASSET, metadata);
        }
        const bucketName = params.bucketNameParameter.valueAsString, encodedKey = params.objectKeyParameter.valueAsString, s3Prefix = cfn_fn_1.Fn.select(0, cfn_fn_1.Fn.split(cxapi.ASSET_PREFIX_SEPARATOR, encodedKey)), s3Filename = cfn_fn_1.Fn.select(1, cfn_fn_1.Fn.split(cxapi.ASSET_PREFIX_SEPARATOR, encodedKey)), objectKey = `${s3Prefix}${s3Filename}`, httpUrl = `https://s3.${this.boundStack.region}.${this.boundStack.urlSuffix}/${bucketName}/${objectKey}`, s3ObjectUrl = `s3://${bucketName}/${objectKey}`;
        return { bucketName, objectKey, httpUrl, s3ObjectUrl, s3Url: httpUrl };
      }
      get assetParameters() {
        return (0, _shared_1.assertBound)(this.boundStack), this._assetParameters || (this._assetParameters = new constructs_1.Construct(this.boundStack, "AssetParameters")), this._assetParameters;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LegacyStackSynthesizer[_a] = { fqn: "aws-cdk-lib.LegacyStackSynthesizer", version: "2.80.0" }, exports2.LegacyStackSynthesizer = LegacyStackSynthesizer;
    function withoutDeprecationWarnings(block) {
      const orig = process.env.JSII_DEPRECATED;
      process.env.JSII_DEPRECATED = "quiet";
      try {
        return block();
      } finally {
        process.env.JSII_DEPRECATED = orig;
      }
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/stack-synthesizers/bootstrapless-synthesizer.js
var require_bootstrapless_synthesizer = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/stack-synthesizers/bootstrapless-synthesizer.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.BootstraplessSynthesizer = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var default_synthesizer_1 = require_default_synthesizer();
    var BootstraplessSynthesizer = class _BootstraplessSynthesizer extends default_synthesizer_1.DefaultStackSynthesizer {
      constructor(props) {
        super({ deployRoleArn: props.deployRoleArn, cloudFormationExecutionRole: props.cloudFormationExecutionRoleArn, generateBootstrapVersionRule: false });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_BootstraplessSynthesizerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _BootstraplessSynthesizer), error;
        }
      }
      addFileAsset(_asset) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_FileAssetSource(_asset);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addFileAsset), error;
        }
        throw new Error("Cannot add assets to a Stack that uses the BootstraplessSynthesizer");
      }
      addDockerImageAsset(_asset) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_DockerImageAssetSource(_asset);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addDockerImageAsset), error;
        }
        throw new Error("Cannot add assets to a Stack that uses the BootstraplessSynthesizer");
      }
      synthesize(session) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ISynthesisSession(session);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.synthesize), error;
        }
        this.synthesizeStackTemplate(this.boundStack, session), this.emitArtifact(session, { assumeRoleArn: this.deployRoleArn, cloudFormationExecutionRoleArn: this.cloudFormationExecutionRoleArn });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, BootstraplessSynthesizer[_a] = { fqn: "aws-cdk-lib.BootstraplessSynthesizer", version: "2.80.0" }, exports2.BootstraplessSynthesizer = BootstraplessSynthesizer;
  }
});

// node_modules/aws-cdk-lib/core/lib/stack-synthesizers/nested.js
var require_nested = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/stack-synthesizers/nested.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.NestedStackSynthesizer = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var stack_synthesizer_1 = require_stack_synthesizer();
    var NestedStackSynthesizer = class _NestedStackSynthesizer extends stack_synthesizer_1.StackSynthesizer {
      constructor(parentDeployment) {
        super(), this.parentDeployment = parentDeployment;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_IStackSynthesizer(parentDeployment);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _NestedStackSynthesizer), error;
        }
      }
      get bootstrapQualifier() {
        return this.parentDeployment.bootstrapQualifier;
      }
      addFileAsset(asset) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_FileAssetSource(asset);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addFileAsset), error;
        }
        return this.parentDeployment.addFileAsset(asset);
      }
      addDockerImageAsset(asset) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_DockerImageAssetSource(asset);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addDockerImageAsset), error;
        }
        return this.parentDeployment.addDockerImageAsset(asset);
      }
      synthesize(session) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ISynthesisSession(session);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.synthesize), error;
        }
        this.synthesizeTemplate(session);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, NestedStackSynthesizer[_a] = { fqn: "aws-cdk-lib.NestedStackSynthesizer", version: "2.80.0" }, exports2.NestedStackSynthesizer = NestedStackSynthesizer;
  }
});

// node_modules/aws-cdk-lib/core/lib/stack-synthesizers/cli-credentials-synthesizer.js
var require_cli_credentials_synthesizer = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/stack-synthesizers/cli-credentials-synthesizer.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CliCredentialsStackSynthesizer = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var _shared_1 = require_shared();
    var asset_manifest_builder_1 = require_asset_manifest_builder();
    var default_synthesizer_1 = require_default_synthesizer();
    var stack_synthesizer_1 = require_stack_synthesizer();
    var cxapi = require_cx_api();
    var token_1 = require_token2();
    var CliCredentialsStackSynthesizer = class _CliCredentialsStackSynthesizer extends stack_synthesizer_1.StackSynthesizer {
      constructor(props = {}) {
        super(), this.props = props, this.assetManifest = new asset_manifest_builder_1.AssetManifestBuilder();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CliCredentialsStackSynthesizerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CliCredentialsStackSynthesizer), error;
        }
        for (const key in props)
          props.hasOwnProperty(key) && validateNoToken(key);
        function validateNoToken(key) {
          const prop = props[key];
          if (typeof prop == "string" && token_1.Token.isUnresolved(prop))
            throw new Error(`CliCredentialsStackSynthesizer property '${key}' cannot contain tokens; only the following placeholder strings are allowed: ` + ["${Qualifier}", cxapi.EnvironmentPlaceholders.CURRENT_REGION, cxapi.EnvironmentPlaceholders.CURRENT_ACCOUNT, cxapi.EnvironmentPlaceholders.CURRENT_PARTITION].join(", "));
        }
      }
      get bootstrapQualifier() {
        return this.qualifier;
      }
      bind(stack) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Stack(stack);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        super.bind(stack);
        const qualifier = this.props.qualifier ?? stack.node.tryGetContext(default_synthesizer_1.BOOTSTRAP_QUALIFIER_CONTEXT) ?? default_synthesizer_1.DefaultStackSynthesizer.DEFAULT_QUALIFIER;
        this.qualifier = qualifier;
        const spec = new _shared_1.StringSpecializer(stack, qualifier);
        this.bucketName = spec.specialize(this.props.fileAssetsBucketName ?? default_synthesizer_1.DefaultStackSynthesizer.DEFAULT_FILE_ASSETS_BUCKET_NAME), this.repositoryName = spec.specialize(this.props.imageAssetsRepositoryName ?? default_synthesizer_1.DefaultStackSynthesizer.DEFAULT_IMAGE_ASSETS_REPOSITORY_NAME), this.bucketPrefix = spec.specialize(this.props.bucketPrefix ?? default_synthesizer_1.DefaultStackSynthesizer.DEFAULT_FILE_ASSET_PREFIX), this.dockerTagPrefix = spec.specialize(this.props.dockerTagPrefix ?? default_synthesizer_1.DefaultStackSynthesizer.DEFAULT_DOCKER_ASSET_PREFIX);
      }
      reusableBind(stack) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Stack(stack);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.reusableBind), error;
        }
        const copy = Object.create(this);
        return copy.bind(stack), copy;
      }
      addFileAsset(asset) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_FileAssetSource(asset);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addFileAsset), error;
        }
        (0, _shared_1.assertBound)(this.bucketName);
        const location = this.assetManifest.defaultAddFileAsset(this.boundStack, asset, { bucketName: this.bucketName, bucketPrefix: this.bucketPrefix });
        return this.cloudFormationLocationFromFileAsset(location);
      }
      addDockerImageAsset(asset) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_DockerImageAssetSource(asset);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addDockerImageAsset), error;
        }
        (0, _shared_1.assertBound)(this.repositoryName);
        const location = this.assetManifest.defaultAddDockerImageAsset(this.boundStack, asset, { repositoryName: this.repositoryName, dockerTagPrefix: this.dockerTagPrefix });
        return this.cloudFormationLocationFromDockerImageAsset(location);
      }
      synthesize(session) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ISynthesisSession(session);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.synthesize), error;
        }
        (0, _shared_1.assertBound)(this.qualifier);
        const templateAssetSource = this.synthesizeTemplate(session), templateAsset = this.addFileAsset(templateAssetSource), assetManifestId = this.assetManifest.emitManifest(this.boundStack, session);
        this.emitArtifact(session, { stackTemplateAssetObjectUrl: templateAsset.s3ObjectUrlWithPlaceholders, additionalDependencies: [assetManifestId] });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CliCredentialsStackSynthesizer[_a] = { fqn: "aws-cdk-lib.CliCredentialsStackSynthesizer", version: "2.80.0" }, exports2.CliCredentialsStackSynthesizer = CliCredentialsStackSynthesizer;
  }
});

// node_modules/aws-cdk-lib/core/lib/stack-synthesizers/index.js
var require_stack_synthesizers = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/stack-synthesizers/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_types5(), exports2), __exportStar(require_default_synthesizer(), exports2), __exportStar(require_legacy(), exports2), __exportStar(require_bootstrapless_synthesizer(), exports2), __exportStar(require_nested(), exports2), __exportStar(require_stack_synthesizer(), exports2), __exportStar(require_cli_credentials_synthesizer(), exports2), __exportStar(require_asset_manifest_builder(), exports2);
  }
});

// node_modules/aws-cdk-lib/core/lib/cfn-mapping.js
var require_cfn_mapping = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/cfn-mapping.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnMapping = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var annotations_1 = require_annotations();
    var cfn_element_1 = require_cfn_element();
    var cfn_fn_1 = require_cfn_fn();
    var stack_1 = require_stack();
    var token_1 = require_token2();
    var CfnMapping = class _CfnMapping extends cfn_element_1.CfnRefElement {
      constructor(scope, id, props = {}) {
        super(scope, id), this.lazyRender = false, this.lazyInformed = false;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnMappingProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnMapping), error;
        }
        this.mapping = props.mapping ? this.validateMapping(props.mapping) : {}, this.lazy = props.lazy;
      }
      setValue(key1, key2, value) {
        this.validateAlphanumeric(key2), key1 in this.mapping || (this.mapping[key1] = {}), this.mapping[key1][key2] = value;
      }
      findInMap(key1, key2) {
        let fullyResolved = false;
        if (!token_1.Token.isUnresolved(key1)) {
          if (!(key1 in this.mapping))
            throw new Error(`Mapping doesn't contain top-level key '${key1}'`);
          if (!token_1.Token.isUnresolved(key2)) {
            if (!(key2 in this.mapping[key1]))
              throw new Error(`Mapping doesn't contain second-level key '${key2}'`);
            fullyResolved = true;
          }
        }
        if (fullyResolved) {
          if (this.lazy)
            return this.mapping[key1][key2];
        } else
          this.lazyRender = true;
        return new CfnMappingEmbedder(this, this.mapping, key1, key2).toString();
      }
      _toCloudFormation() {
        return this.lazy === void 0 && !this.lazyRender && this.informLazyUse(), !this.lazy || this.lazy && this.lazyRender ? { Mappings: { [this.logicalId]: this.mapping } } : {};
      }
      informLazyUse() {
        this.lazyInformed || annotations_1.Annotations.of(this).addInfo("Consider making this CfnMapping a lazy mapping by providing `lazy: true`: either no findInMap was called or every findInMap could be immediately resolved without using Fn::FindInMap"), this.lazyInformed = true;
      }
      validateMapping(mapping) {
        return Object.keys(mapping).forEach((m) => Object.keys(mapping[m]).forEach(this.validateAlphanumeric)), mapping;
      }
      validateAlphanumeric(value) {
        if (value.match(/[^a-zA-Z0-9]/g))
          throw new Error(`Attribute name '${value}' must contain only alphanumeric characters.`);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnMapping[_a] = { fqn: "aws-cdk-lib.CfnMapping", version: "2.80.0" }, exports2.CfnMapping = CfnMapping;
    var CfnMappingEmbedder = class {
      constructor(cfnMapping, mapping, key1, key2) {
        this.cfnMapping = cfnMapping, this.mapping = mapping, this.key1 = key1, this.key2 = key2, this.creationStack = [];
      }
      resolve(context) {
        const consumingStack = stack_1.Stack.of(context.scope);
        if (consumingStack === stack_1.Stack.of(this.cfnMapping))
          return cfn_fn_1.Fn.findInMap(this.cfnMapping.logicalId, this.key1, this.key2);
        const constructScope = consumingStack, constructId = `MappingCopy-${this.cfnMapping.node.id}-${this.cfnMapping.node.addr}`;
        let mappingCopy = constructScope.node.tryFindChild(constructId);
        return mappingCopy || (mappingCopy = new CfnMapping(constructScope, constructId, { mapping: this.mapping })), cfn_fn_1.Fn.findInMap(mappingCopy.logicalId, this.key1, this.key2);
      }
      toString() {
        return token_1.Token.asString(this);
      }
    };
  }
});

// node_modules/aws-cdk-lib/core/lib/private/region-lookup.js
var require_region_lookup = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/private/region-lookup.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.deployTimeLookup = void 0;
    var cxapi = require_cx_api();
    var region_info_1 = require_region_info2();
    var cfn_mapping_1 = require_cfn_mapping();
    var cfn_pseudo_1 = require_cfn_pseudo();
    function deployTimeLookup(stack, factName, lookupMap, defaultValue) {
      if (Object.values(lookupMap).length === 0) {
        if (defaultValue === void 0)
          throw new Error(`region-info: don't have any information for ${factName}. Use 'Fact.register' to provide values, or add partitions to the '${cxapi.TARGET_PARTITIONS}' context value.`);
        return defaultValue;
      }
      const pattern = findValuePattern(lookupMap);
      if (pattern !== void 0)
        return pattern;
      const [factClass, factParam] = factName.includes(":") ? factName.split(":") : [factName, "value"], mapId = `${ucfirst(factClass)}Map`, factKey = factParam.replace(/[^a-zA-Z0-9]/g, "x");
      let mapping = stack.node.tryFindChild(mapId);
      mapping || (mapping = new cfn_mapping_1.CfnMapping(stack, mapId));
      for (const [region, value] of Object.entries(lookupMap))
        mapping.setValue(region, factKey, value);
      return mapping.findInMap(cfn_pseudo_1.Aws.REGION, factKey);
    }
    exports2.deployTimeLookup = deployTimeLookup;
    function ucfirst(x) {
      return `${x.slice(0, 1).toUpperCase()}${x.slice(1)}`;
    }
    function findValuePattern(regionMap) {
      const simplified = { ...regionMap }, urlSuffixes = Object.keys(simplified).map(urlSuffix);
      if (!allSame(urlSuffixes) && Object.entries(simplified).every(([region, value]) => value.includes(urlSuffix(region))))
        for (const region in simplified)
          simplified[region] = replaceAll(simplified[region], urlSuffix(region), cfn_pseudo_1.Aws.URL_SUFFIX);
      if (Object.entries(simplified).every(([region, value]) => value.includes(region)))
        for (const region in simplified)
          simplified[region] = replaceAll(simplified[region], region, cfn_pseudo_1.Aws.REGION);
      const values = Object.values(simplified);
      if (allSame(values))
        return values[0];
    }
    function allSame(xs) {
      return xs.every((x) => x === xs[0]);
    }
    function urlSuffix(region) {
      return region_info_1.RegionInfo.get(region)?.domainSuffix ?? "amazonaws.com";
    }
    function replaceAll(x, pat, replacement) {
      return x.split(pat).join(replacement);
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/stack.js
var require_stack = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/stack.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.rootPathTo = exports2.Stack = exports2.STACK_RESOURCE_LIMIT_CONTEXT = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var fs = require("fs");
    var path = require("path");
    var constructs_1 = require_lib2();
    var minimatch = require_minimatch();
    var annotations_1 = require_annotations();
    var app_1 = require_app2();
    var arn_1 = require_arn();
    var aspect_1 = require_aspect();
    var cfn_element_1 = require_cfn_element();
    var cfn_fn_1 = require_cfn_fn();
    var cfn_pseudo_1 = require_cfn_pseudo();
    var cfn_resource_1 = require_cfn_resource();
    var context_provider_1 = require_context_provider();
    var feature_flags_1 = require_feature_flags();
    var permissions_boundary_1 = require_permissions_boundary();
    var cloudformation_lang_1 = require_cloudformation_lang();
    var logical_id_1 = require_logical_id();
    var resolve_1 = require_resolve();
    var uniqueid_1 = require_uniqueid2();
    var cxschema = require_cloud_assembly_schema2();
    var cxapi = require_cx_api();
    var STACK_SYMBOL = Symbol.for("@aws-cdk/core.Stack");
    var MY_STACK_CACHE = Symbol.for("@aws-cdk/core.Stack.myStack");
    exports2.STACK_RESOURCE_LIMIT_CONTEXT = "@aws-cdk/core:stackResourceLimit";
    var VALID_STACK_NAME_REGEX = /^[A-Za-z][A-Za-z0-9-]*$/;
    var MAX_RESOURCES = 500;
    var STRING_LIST_REFERENCE_DELIMITER = "||";
    var Stack2 = class _Stack extends constructs_1.Construct {
      static isStack(x) {
        return x !== null && typeof x == "object" && STACK_SYMBOL in x;
      }
      static of(construct) {
        const cache = construct[MY_STACK_CACHE];
        if (cache)
          return cache;
        {
          const value = _lookup(construct);
          return Object.defineProperty(construct, MY_STACK_CACHE, { enumerable: false, writable: false, configurable: false, value }), value;
        }
        function _lookup(c) {
          if (_Stack.isStack(c))
            return c;
          const _scope = constructs_1.Node.of(c).scope;
          if (stage_1.Stage.isStage(c) || !_scope)
            throw new Error(`${construct.constructor?.name ?? "Construct"} at '${constructs_1.Node.of(construct).path}' should be created in the scope of a Stack, but no Stack found`);
          return _lookup(_scope);
        }
      }
      constructor(scope, id, props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_StackProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Stack), error;
        }
        scope = scope ?? new app_1.App({ autoSynth: false, outdir: fs_1.FileSystem.mkdtemp("cdk-test-app-") }), id = id ?? "Default", super(scope, id), this._missingContext = new Array(), this._stackDependencies = {}, this.templateOptions = {}, this._crossRegionReferences = !!props.crossRegionReferences, Object.defineProperty(this, STACK_SYMBOL, { value: true }), this._logicalIds = new logical_id_1.LogicalIDs();
        const { account, region, environment } = this.parseEnvironment(props.env);
        if (this.account = account, this.region = region, this.environment = environment, this.terminationProtection = props.terminationProtection, props.description !== void 0) {
          if (props.description.length > 512)
            throw new Error(`Stack description must be <= 1024 bytes. Received description: '${props.description}'`);
          this.templateOptions.description = props.description;
        }
        if (this._stackName = props.stackName ?? this.generateStackName(), this._stackName.length > 128)
          throw new Error(`Stack name must be <= 128 characters. Stack name: '${this._stackName}'`);
        if (this.tags = new tag_manager_1.TagManager(cfn_resource_1.TagType.KEY_VALUE, "aws:cdk:stack", props.tags), !VALID_STACK_NAME_REGEX.test(this.stackName))
          throw new Error(`Stack name must match the regular expression: ${VALID_STACK_NAME_REGEX.toString()}, got '${this.stackName}'`);
        const featureFlags = feature_flags_1.FeatureFlags.of(this), stackNameDupeContext = featureFlags.isEnabled(cxapi.ENABLE_STACK_NAME_DUPLICATES_CONTEXT), newStyleSynthesisContext = featureFlags.isEnabled(cxapi.NEW_STYLE_STACK_SYNTHESIS_CONTEXT);
        this.artifactId = stackNameDupeContext || newStyleSynthesisContext ? this.generateStackArtifactId() : this.stackName, this.templateFile = `${this.artifactId}.template.json`, this._versionReportingEnabled = (props.analyticsReporting ?? this.node.tryGetContext(cxapi.ANALYTICS_REPORTING_ENABLED_CONTEXT)) && !this.nestedStackParent;
        const synthesizer = props.synthesizer ?? this.node.tryGetContext(private_context_1.PRIVATE_CONTEXT_DEFAULT_STACK_SYNTHESIZER) ?? (newStyleSynthesisContext ? new stack_synthesizers_1.DefaultStackSynthesizer() : new stack_synthesizers_1.LegacyStackSynthesizer());
        (0, stack_synthesizers_1.isReusableStackSynthesizer)(synthesizer) ? this.synthesizer = synthesizer.reusableBind(this) : (this.synthesizer = synthesizer, this.synthesizer.bind(this)), props.permissionsBoundary?._bind(this), this.addPermissionsBoundaryAspect();
      }
      get permissionsBoundaryArn() {
        const qualifier = this.synthesizer.bootstrapQualifier ?? this.node.tryGetContext(stack_synthesizers_1.BOOTSTRAP_QUALIFIER_CONTEXT) ?? stack_synthesizers_1.DefaultStackSynthesizer.DEFAULT_QUALIFIER, spec = new _shared_1.StringSpecializer(this, qualifier), context = this.node.tryGetContext(permissions_boundary_1.PERMISSIONS_BOUNDARY_CONTEXT_KEY);
        let arn;
        if (context && context.arn ? arn = spec.specialize(context.arn) : context && context.name && (arn = spec.specialize(this.formatArn({ service: "iam", resource: "policy", region: "", resourceName: context.name }))), arn && (arn.includes("${Qualifier}") || arn.includes("${AWS::AccountId}") || arn.includes("${AWS::Region}") || arn.includes("${AWS::Partition}")))
          throw new Error(`The permissions boundary ${arn} includes a pseudo parameter, which is not supported for environment agnostic stacks`);
        return arn;
      }
      addPermissionsBoundaryAspect() {
        const permissionsBoundaryArn = this.permissionsBoundaryArn;
        permissionsBoundaryArn && aspect_1.Aspects.of(this).add({ visit(node) {
          cfn_resource_1.CfnResource.isCfnResource(node) && (node.cfnResourceType == "AWS::IAM::Role" || node.cfnResourceType == "AWS::IAM::User") && node.addPropertyOverride("PermissionsBoundary", permissionsBoundaryArn);
        } });
      }
      resolve(obj) {
        return (0, resolve_1.resolve)(obj, { scope: this, prefix: [], resolver: cloudformation_lang_1.CLOUDFORMATION_TOKEN_RESOLVER, preparing: false });
      }
      toJsonString(obj, space) {
        return cloudformation_lang_1.CloudFormationLang.toJSON(obj, space).toString();
      }
      toYamlString(obj) {
        return cloudformation_lang_1.CloudFormationLang.toYAML(obj).toString();
      }
      reportMissingContext(report) {
        if (!Object.values(cxschema.ContextProvider).includes(report.provider))
          throw new Error(`Unknown context provider requested in: ${JSON.stringify(report)}`);
        this.reportMissingContextKey(report);
      }
      reportMissingContextKey(report) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_cloud_assembly_schema_MissingContext(report);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.reportMissingContextKey), error;
        }
        this._missingContext.push(report);
      }
      renameLogicalId(oldId, newId) {
        this._logicalIds.addRename(oldId, newId);
      }
      getLogicalId(element) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnElement(element);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.getLogicalId), error;
        }
        const logicalId = this.allocateLogicalId(element);
        return this._logicalIds.applyRename(logicalId);
      }
      addDependency(target, reason) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Stack(target);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addDependency), error;
        }
        (0, deps_1.addDependency)(this, target, reason ?? `{${this.node.path}}.addDependency({${target.node.path}})`);
      }
      get dependencies() {
        return Object.values(this._stackDependencies).map((x) => x.stack);
      }
      get stackName() {
        return this._stackName;
      }
      get partition() {
        return !feature_flags_1.FeatureFlags.of(this).isEnabled(cxapi.ENABLE_PARTITION_LITERALS) || token_1.Token.isUnresolved(this.region) ? cfn_pseudo_1.Aws.PARTITION : region_info_1.RegionInfo.get(this.region).partition ?? cfn_pseudo_1.Aws.PARTITION;
      }
      get urlSuffix() {
        return cfn_pseudo_1.Aws.URL_SUFFIX;
      }
      get stackId() {
        return new cfn_pseudo_1.ScopedAws(this).stackId;
      }
      get notificationArns() {
        return new cfn_pseudo_1.ScopedAws(this).notificationArns;
      }
      get nested() {
        return this.nestedStackResource !== void 0;
      }
      formatArn(components) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ArnComponents(components);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.formatArn), error;
        }
        return arn_1.Arn.format(components, this);
      }
      parseArn(arn, sepIfToken = "/", hasName = true) {
        return arn_1.Arn.parse(arn, sepIfToken, hasName);
      }
      splitArn(arn, arnFormat) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ArnFormat(arnFormat);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.splitArn), error;
        }
        return arn_1.Arn.split(arn, arnFormat);
      }
      get availabilityZones() {
        if (token_1.Token.isUnresolved(this.account) || token_1.Token.isUnresolved(this.region))
          return this.node.tryGetContext(cxapi.AVAILABILITY_ZONE_FALLBACK_CONTEXT_KEY) || [cfn_fn_1.Fn.select(0, cfn_fn_1.Fn.getAzs()), cfn_fn_1.Fn.select(1, cfn_fn_1.Fn.getAzs())];
        const value = context_provider_1.ContextProvider.getValue(this, { provider: cxschema.ContextProvider.AVAILABILITY_ZONE_PROVIDER, dummyValue: ["dummy1a", "dummy1b", "dummy1c"] }).value;
        if (!Array.isArray(value))
          throw new Error(`Provider ${cxschema.ContextProvider.AVAILABILITY_ZONE_PROVIDER} expects a list`);
        return value;
      }
      addFileAsset(asset) {
        return this.synthesizer.addFileAsset(asset);
      }
      addDockerImageAsset(asset) {
        return this.synthesizer.addDockerImageAsset(asset);
      }
      get nestedStackParent() {
        return this.nestedStackResource && _Stack.of(this.nestedStackResource);
      }
      get parentStack() {
        return this.nestedStackParent;
      }
      addTransform(transform) {
        this.templateOptions.transforms || (this.templateOptions.transforms = []), this.templateOptions.transforms.push(transform);
      }
      addMetadata(key, value) {
        this.templateOptions.metadata || (this.templateOptions.metadata = {}), this.templateOptions.metadata[key] = value;
      }
      _addAssemblyDependency(target, reason = {}) {
        if (this.nested || target.nested)
          throw new Error("Cannot add assembly-level dependencies for nested stacks");
        reason.source || (reason.source = this), reason.target || (reason.target = target), reason.description || (reason.description = "no description provided");
        const cycle = target.stackDependencyReasons(this);
        if (cycle !== void 0) {
          const cycleDescription = cycle.map((cycleReason) => cycleReason.description).join(", ");
          throw new Error(`'${target.node.path}' depends on '${this.node.path}' (${cycleDescription}). Adding this dependency (${reason.description}) would create a cyclic reference.`);
        }
        let dep = this._stackDependencies[names_1.Names.uniqueId(target)];
        dep || (dep = this._stackDependencies[names_1.Names.uniqueId(target)] = { stack: target, reasons: [] });
        let existingReasons = /* @__PURE__ */ new Set();
        dep.reasons.forEach((existingReason) => {
          existingReason.source == reason.source && existingReason.target == reason.target && existingReasons.add(existingReason);
        }), !(existingReasons.size > 0) && (dep.reasons.push(reason), process.env.CDK_DEBUG_DEPS && console.error(`[CDK_DEBUG_DEPS] stack "${reason.source.node.path}" depends on "${reason.target.node.path}"`));
      }
      _obtainAssemblyDependencies(reasonFilter) {
        if (!reasonFilter.source)
          throw new Error("reasonFilter.source must be defined!");
        let dependencies = /* @__PURE__ */ new Set();
        return Object.values(this._stackDependencies).forEach((dep) => {
          dep.reasons.forEach((reason) => {
            if (reasonFilter.source == reason.source) {
              if (!reason.target)
                throw new Error(`Encountered an invalid dependency target from source '${reasonFilter.source.node.path}'`);
              dependencies.add(reason.target);
            }
          });
        }), Array.from(dependencies);
      }
      _removeAssemblyDependency(target, reasonFilter = {}) {
        if (this.nested || target.nested)
          throw new Error("There cannot be assembly-level dependencies for nested stacks");
        reasonFilter.source || (reasonFilter.source = this), reasonFilter.target || (reasonFilter.target = target);
        let dep = this._stackDependencies[names_1.Names.uniqueId(target)];
        if (!dep)
          return;
        let matchedReasons = /* @__PURE__ */ new Set();
        if (dep.reasons.forEach((reason) => {
          reasonFilter.source == reason.source && reasonFilter.target == reason.target && matchedReasons.add(reason);
        }), matchedReasons.size > 1)
          throw new Error(`There cannot be more than one reason for dependency removal, found: ${matchedReasons}`);
        if (matchedReasons.size == 0)
          return;
        let matchedReason = Array.from(matchedReasons)[0], index = dep.reasons.indexOf(matchedReason, 0);
        dep.reasons.splice(index, 1), dep.reasons.length == 0 && delete this._stackDependencies[names_1.Names.uniqueId(target)], process.env.CDK_DEBUG_DEPS && console.log(`[CDK_DEBUG_DEPS] stack "${this.node.path}" no longer depends on "${target.node.path}" because: ${reasonFilter}`);
      }
      _synthesizeTemplate(session, lookupRoleArn) {
        const builder = session.assembly, template = this._toCloudFormation(), outPath = path.join(builder.outdir, this.templateFile);
        if (this.maxResources > 0) {
          const resources = template.Resources || {}, numberOfResources = Object.keys(resources).length;
          if (numberOfResources > this.maxResources) {
            const counts = Object.entries(count(Object.values(resources).map((r) => `${r?.Type}`))).map(([type, c]) => `${type} (${c})`).join(", ");
            throw new Error(`Number of resources in stack '${this.node.path}': ${numberOfResources} is greater than allowed maximum of ${this.maxResources}: ${counts}`);
          } else
            numberOfResources >= this.maxResources * 0.8 && annotations_1.Annotations.of(this).addInfo(`Number of resources: ${numberOfResources} is approaching allowed maximum of ${this.maxResources}`);
        }
        fs.writeFileSync(outPath, JSON.stringify(template, void 0, 1));
        for (const ctx of this._missingContext)
          lookupRoleArn != null ? builder.addMissing({ ...ctx, props: { ...ctx.props, lookupRoleArn } }) : builder.addMissing(ctx);
      }
      regionalFact(factName, defaultValue) {
        if (!token_1.Token.isUnresolved(this.region)) {
          const ret = region_info_1.Fact.find(this.region, factName) ?? defaultValue;
          if (ret === void 0)
            throw new Error(`region-info: don't know ${factName} for region ${this.region}. Use 'Fact.register' to provide this value.`);
          return ret;
        }
        const partitions = constructs_1.Node.of(this).tryGetContext(cxapi.TARGET_PARTITIONS);
        if (partitions !== void 0 && partitions !== "undefined" && !Array.isArray(partitions))
          throw new Error(`Context value '${cxapi.TARGET_PARTITIONS}' should be a list of strings, got: ${JSON.stringify(partitions)}`);
        const lookupMap = partitions !== void 0 && partitions !== "undefined" ? region_info_1.RegionInfo.limitedRegionMap(factName, partitions) : region_info_1.RegionInfo.regionMap(factName);
        return (0, region_lookup_1.deployTimeLookup)(this, factName, lookupMap, defaultValue);
      }
      exportValue(exportedValue, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ExportValueOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.exportValue), error;
        }
        if (options.name)
          return new cfn_output_1.CfnOutput(this, `Export${options.name}`, { value: exportedValue, exportName: options.name }), cfn_fn_1.Fn.importValue(options.name);
        const { exportName, exportsScope, id, exportable } = this.resolveExportedValue(exportedValue);
        exportsScope.node.tryFindChild(id) || new cfn_output_1.CfnOutput(exportsScope, id, { value: token_1.Token.asString(exportable), exportName });
        const importValue = cfn_fn_1.Fn.importValue(exportName);
        if (Array.isArray(importValue))
          throw new Error("Attempted to export a list value from `exportValue()`: use `exportStringListValue()` instead");
        return importValue;
      }
      exportStringListValue(exportedValue, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ExportValueOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.exportStringListValue), error;
        }
        if (options.name)
          return new cfn_output_1.CfnOutput(this, `Export${options.name}`, { value: cfn_fn_1.Fn.join(STRING_LIST_REFERENCE_DELIMITER, exportedValue), exportName: options.name }), cfn_fn_1.Fn.split(STRING_LIST_REFERENCE_DELIMITER, cfn_fn_1.Fn.importValue(options.name));
        const { exportName, exportsScope, id, exportable } = this.resolveExportedValue(exportedValue);
        exportsScope.node.tryFindChild(id) || new cfn_output_1.CfnOutput(exportsScope, id, { value: cfn_fn_1.Fn.join(STRING_LIST_REFERENCE_DELIMITER, token_1.Token.asList(exportable)), exportName });
        const importValue = cfn_fn_1.Fn.split(STRING_LIST_REFERENCE_DELIMITER, cfn_fn_1.Fn.importValue(exportName));
        if (!Array.isArray(importValue))
          throw new Error("Attempted to export a string value from `exportStringListValue()`: use `exportValue()` instead");
        return importValue;
      }
      allocateLogicalId(cfnElement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnElement(cfnElement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.allocateLogicalId), error;
        }
        const scopes = cfnElement.node.scopes, stackIndex = scopes.indexOf(cfnElement.stack), pathComponents = scopes.slice(stackIndex + 1).map((x) => x.node.id);
        return (0, uniqueid_1.makeUniqueId)(pathComponents);
      }
      _validateId(name) {
        if (name && !VALID_STACK_NAME_REGEX.test(name))
          throw new Error(`Stack name must match the regular expression: ${VALID_STACK_NAME_REGEX.toString()}, got '${name}'`);
      }
      _toCloudFormation() {
        let transform;
        this.templateOptions.transform && (annotations_1.Annotations.of(this).addWarning("This stack is using the deprecated `templateOptions.transform` property. Consider switching to `addTransform()`."), this.addTransform(this.templateOptions.transform)), this.templateOptions.transforms && (this.templateOptions.transforms.length === 1 ? transform = this.templateOptions.transforms[0] : transform = Array.from(new Set(this.templateOptions.transforms)));
        const template = { Description: this.templateOptions.description, Transform: transform, AWSTemplateFormatVersion: this.templateOptions.templateFormatVersion, Metadata: this.templateOptions.metadata }, fragments = cfnElements(this).map((e) => this.resolve(e._toCloudFormation()));
        for (const fragment of fragments)
          merge(template, fragment);
        const ret = this.resolve(template) || {};
        return this._logicalIds.assertAllRenamesApplied(), ret;
      }
      prepareCrossReference(_sourceStack, reference) {
        return reference;
      }
      parseEnvironment(env = {}) {
        const containingAssembly = stage_1.Stage.of(this);
        if (env.account && typeof env.account != "string")
          throw new Error(`Account id of stack environment must be a 'string' but received '${typeof env.account}'`);
        if (env.region && typeof env.region != "string")
          throw new Error(`Region of stack environment must be a 'string' but received '${typeof env.region}'`);
        const account = env.account ?? containingAssembly?.account ?? cfn_pseudo_1.Aws.ACCOUNT_ID, region = env.region ?? containingAssembly?.region ?? cfn_pseudo_1.Aws.REGION, envAccount = token_1.Token.isUnresolved(account) ? cxapi.UNKNOWN_ACCOUNT : account, envRegion = token_1.Token.isUnresolved(region) ? cxapi.UNKNOWN_REGION : region;
        return { account, region, environment: cxapi.EnvironmentUtils.format(envAccount, envRegion) };
      }
      get maxResources() {
        const contextLimit = this.node.tryGetContext(exports2.STACK_RESOURCE_LIMIT_CONTEXT);
        return contextLimit !== void 0 ? parseInt(contextLimit, 10) : MAX_RESOURCES;
      }
      stackDependencyReasons(other) {
        if (this === other)
          return [];
        for (const dep of Object.values(this._stackDependencies)) {
          const ret = dep.stack.stackDependencyReasons(other);
          if (ret !== void 0)
            return [...dep.reasons, ...ret];
        }
      }
      generateStackName() {
        const assembly = stage_1.Stage.of(this);
        return `${assembly && assembly.stageName ? `${assembly.stageName}-` : ""}${this.generateStackId(assembly)}`;
      }
      generateStackArtifactId() {
        return this.generateStackId(this.node.root);
      }
      generateStackId(container) {
        const ids = rootPathTo(this, container).map((c) => constructs_1.Node.of(c).id);
        if (ids.length === 1 && !ids[0])
          throw new Error("unexpected: stack id must always be defined");
        return makeStackName(ids);
      }
      resolveExportedValue(exportedValue) {
        const resolvable = token_1.Tokenization.reverse(exportedValue);
        if (!resolvable || !reference_1.Reference.isReference(resolvable))
          throw new Error("exportValue: either supply 'name' or make sure to export a resource attribute (like 'bucket.bucketName')");
        const exportable = (0, refs_1.getExportable)(this, resolvable), exportsScope = getCreateExportsScope(this), resolved = this.resolve(exportable), id = "Output" + JSON.stringify(resolved), exportName = generateExportName(exportsScope, id);
        if (token_1.Token.isUnresolved(exportName))
          throw new Error(`unresolved token in generated export name: ${JSON.stringify(this.resolve(exportName))}`);
        return { exportable, exportsScope, id, exportName };
      }
      get bundlingRequired() {
        return (this.node.tryGetContext(cxapi.BUNDLING_STACKS) ?? ["**"]).some((pattern) => minimatch(this.node.path, pattern));
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Stack2[_a] = { fqn: "aws-cdk-lib.Stack", version: "2.80.0" }, exports2.Stack = Stack2;
    function merge(template, fragment) {
      for (const section of Object.keys(fragment)) {
        const src = fragment[section], dest = template[section];
        dest ? template[section] = mergeSection(section, dest, src) : template[section] = src;
      }
    }
    function mergeSection(section, val1, val2) {
      switch (section) {
        case "Description":
          return `${val1}
${val2}`;
        case "AWSTemplateFormatVersion":
          if (val1 != null && val2 != null && val1 !== val2)
            throw new Error(`Conflicting CloudFormation template versions provided: '${val1}' and '${val2}`);
          return val1 ?? val2;
        case "Transform":
          return mergeSets(val1, val2);
        default:
          return mergeObjectsWithoutDuplicates(section, val1, val2);
      }
    }
    function mergeSets(val1, val2) {
      const array1 = val1 == null ? [] : Array.isArray(val1) ? val1 : [val1], array2 = val2 == null ? [] : Array.isArray(val2) ? val2 : [val2];
      for (const value of array2)
        array1.includes(value) || array1.push(value);
      return array1.length === 1 ? array1[0] : array1;
    }
    function mergeObjectsWithoutDuplicates(section, dest, src) {
      if (typeof dest != "object")
        throw new Error(`Expecting ${JSON.stringify(dest)} to be an object`);
      if (typeof src != "object")
        throw new Error(`Expecting ${JSON.stringify(src)} to be an object`);
      for (const id of Object.keys(src)) {
        if (id in dest)
          throw new Error(`section '${section}' already contains '${id}'`);
        dest[id] = src[id];
      }
      return dest;
    }
    function cfnElements(node, into = []) {
      cfn_element_1.CfnElement.isCfnElement(node) && into.push(node);
      for (const child of constructs_1.Node.of(node).children)
        Stack2.isStack(child) || cfnElements(child, into);
      return into;
    }
    function rootPathTo(construct, ancestor) {
      const scopes = constructs_1.Node.of(construct).scopes;
      for (let i = scopes.length - 2; i >= 0; i--)
        if (scopes[i] === ancestor)
          return scopes.slice(i + 1);
      return scopes;
    }
    exports2.rootPathTo = rootPathTo;
    function makeStackName(components) {
      return components.length === 1 ? components[0] : (0, unique_resource_name_1.makeUniqueResourceName)(components, { maxLength: 128 });
    }
    function getCreateExportsScope(stack) {
      const exportsName = "Exports";
      let stackExports = stack.node.tryFindChild(exportsName);
      return stackExports === void 0 && (stackExports = new constructs_1.Construct(stack, exportsName)), stackExports;
    }
    function generateExportName(stackExports, id) {
      const stackRelativeExports = feature_flags_1.FeatureFlags.of(stackExports).isEnabled(cxapi.STACK_RELATIVE_EXPORTS_CONTEXT), stack = Stack2.of(stackExports), components = [...stackExports.node.scopes.slice(stackRelativeExports ? stack.node.scopes.length : 2).map((c) => c.node.id), id], prefix = stack.stackName ? stack.stackName + ":" : "", localPart = (0, uniqueid_1.makeUniqueId)(components), maxLength = 255;
      return prefix + localPart.slice(Math.max(0, localPart.length - maxLength + prefix.length));
    }
    function count(xs) {
      const ret = {};
      for (const x of xs)
        x in ret ? ret[x] += 1 : ret[x] = 1;
      return ret;
    }
    var cfn_output_1 = require_cfn_output();
    var deps_1 = require_deps();
    var fs_1 = require_fs2();
    var names_1 = require_names();
    var reference_1 = require_reference();
    var stack_synthesizers_1 = require_stack_synthesizers();
    var _shared_1 = require_shared();
    var stage_1 = require_stage();
    var tag_manager_1 = require_tag_manager();
    var token_1 = require_token2();
    var refs_1 = require_refs();
    var region_info_1 = require_region_info2();
    var region_lookup_1 = require_region_lookup();
    var unique_resource_name_1 = require_unique_resource_name();
    var private_context_1 = require_private_context();
  }
});

// node_modules/aws-cdk-lib/core/lib/private/cfn-reference.js
var require_cfn_reference = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/private/cfn-reference.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnReference = exports2.ReferenceRendering = void 0;
    var reference_1 = require_reference();
    var CFN_REFERENCE_SYMBOL = Symbol.for("@aws-cdk/core.CfnReference");
    var ReferenceRendering;
    (function(ReferenceRendering2) {
      ReferenceRendering2[ReferenceRendering2.FN_SUB = 0] = "FN_SUB", ReferenceRendering2[ReferenceRendering2.GET_ATT_STRING = 1] = "GET_ATT_STRING";
    })(ReferenceRendering = exports2.ReferenceRendering || (exports2.ReferenceRendering = {}));
    var CfnReference = class _CfnReference extends reference_1.Reference {
      static isCfnReference(x) {
        return CFN_REFERENCE_SYMBOL in x;
      }
      static for(target, attribute, refRender, typeHint) {
        return _CfnReference.singletonReference(target, attribute, refRender, () => {
          const cfnIntrinsic = refRender === ReferenceRendering.FN_SUB ? "${" + target.logicalId + (attribute === "Ref" ? "" : `.${attribute}`) + "}" : attribute === "Ref" ? { Ref: target.logicalId } : { "Fn::GetAtt": refRender === ReferenceRendering.GET_ATT_STRING ? `${target.logicalId}.${attribute}` : [target.logicalId, attribute] };
          return new _CfnReference(cfnIntrinsic, attribute, target, typeHint);
        });
      }
      static forPseudo(pseudoName, scope) {
        return _CfnReference.singletonReference(scope, `Pseudo:${pseudoName}`, void 0, () => {
          const cfnIntrinsic = { Ref: pseudoName };
          return new _CfnReference(cfnIntrinsic, pseudoName, scope);
        });
      }
      static singletonReference(target, attribKey, refRender, fresh) {
        let attribs = _CfnReference.referenceTable.get(target);
        attribs || (attribs = /* @__PURE__ */ new Map(), _CfnReference.referenceTable.set(target, attribs));
        let cacheKey = attribKey;
        switch (refRender) {
          case ReferenceRendering.FN_SUB:
            cacheKey += "Fn::Sub";
            break;
          case ReferenceRendering.GET_ATT_STRING:
            cacheKey += "Fn::GetAtt::String";
            break;
        }
        let ref = attribs.get(cacheKey);
        return ref || (ref = fresh(), attribs.set(cacheKey, ref)), ref;
      }
      constructor(value, displayName, target, typeHint) {
        super(value, target, displayName, typeHint), this.target = target, this.replacementTokens = /* @__PURE__ */ new Map(), this.targetStack = stack_1.Stack.of(target), Object.defineProperty(this, CFN_REFERENCE_SYMBOL, { value: true });
      }
      resolve(context) {
        const consumingStack = stack_1.Stack.of(context.scope), token = this.replacementTokens.get(consumingStack);
        return token ? token.resolve(context) : super.resolve(context);
      }
      hasValueForStack(stack) {
        return stack === this.targetStack ? true : this.replacementTokens.has(stack);
      }
      assignValueForStack(stack, value) {
        if (stack === this.targetStack)
          throw new Error("cannot assign a value for the same stack");
        if (this.hasValueForStack(stack))
          throw new Error("Cannot assign a reference value twice to the same stack. Use hasValueForStack to check first");
        this.replacementTokens.set(stack, value);
      }
      toString() {
        return token_1.Token.asString(this, { displayHint: `${this.target.node.id}.${this.displayName}` });
      }
    };
    CfnReference.referenceTable = /* @__PURE__ */ new Map(), exports2.CfnReference = CfnReference;
    var stack_1 = require_stack();
    var token_1 = require_token2();
  }
});

// node_modules/aws-cdk-lib/core/lib/cfn-element.js
var require_cfn_element = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/cfn-element.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnRefElement = exports2.CfnElement = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var debug_1 = require_debug2();
    var lazy_1 = require_lazy();
    var cxschema = require_cloud_assembly_schema2();
    var cxapi = require_cx_api();
    var CFN_ELEMENT_SYMBOL = Symbol.for("@aws-cdk/core.CfnElement");
    var CfnElement = class extends constructs_1.Construct {
      static isCfnElement(x) {
        return CFN_ELEMENT_SYMBOL in x;
      }
      constructor(scope, id) {
        super(scope, id), Object.defineProperty(this, CFN_ELEMENT_SYMBOL, { value: true }), this.stack = stack_1.Stack.of(this), this.logicalId = lazy_1.Lazy.uncachedString({ produce: () => this.synthesizeLogicalId() }, { displayHint: `${notTooLong(constructs_1.Node.of(this).path)}.LogicalID` }), this.node.tryGetContext(cxapi.DISABLE_LOGICAL_ID_METADATA) || constructs_1.Node.of(this).addMetadata(cxschema.ArtifactMetadataEntryType.LOGICAL_ID, this.logicalId, { stackTrace: (0, debug_1.debugModeEnabled)(), traceFromFunction: this.constructor });
      }
      overrideLogicalId(newLogicalId) {
        if (this._logicalIdLocked)
          throw new Error(`The logicalId for resource at path ${constructs_1.Node.of(this).path} has been locked and cannot be overridden
Make sure you are calling "overrideLogicalId" before Stack.exportValue`);
        this._logicalIdOverride = newLogicalId;
      }
      _lockLogicalId() {
        this._logicalIdLocked = true;
      }
      get creationStack() {
        const trace = constructs_1.Node.of(this).metadata.find((md) => md.type === cxschema.ArtifactMetadataEntryType.LOGICAL_ID).trace;
        if (!trace)
          return [];
        return filterStackTrace(trace);
        function filterStackTrace(stack) {
          const result = Array.of(...stack);
          for (; result.length > 0 && shouldFilter(result[result.length - 1]); )
            result.pop();
          return result.length === 0 ? stack : result;
        }
        function shouldFilter(str) {
          return str.match(/[^(]+\(internal\/.*/) !== null;
        }
      }
      synthesizeLogicalId() {
        return this._logicalIdOverride ? this._logicalIdOverride : this.stack.getLogicalId(this);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnElement[_a] = { fqn: "aws-cdk-lib.CfnElement", version: "2.80.0" }, exports2.CfnElement = CfnElement;
    var CfnRefElement = class extends CfnElement {
      get ref() {
        return token_1.Token.asString(cfn_reference_1.CfnReference.for(this, "Ref"));
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnRefElement[_b] = { fqn: "aws-cdk-lib.CfnRefElement", version: "2.80.0" }, exports2.CfnRefElement = CfnRefElement;
    function notTooLong(x) {
      return x.length < 100 ? x : x.slice(0, 47) + "..." + x.slice(-47);
    }
    var cfn_reference_1 = require_cfn_reference();
    var stack_1 = require_stack();
    var token_1 = require_token2();
  }
});

// node_modules/aws-cdk-lib/core/lib/cfn-resource.js
var require_cfn_resource = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/cfn-resource.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.TagType = exports2.CfnResource = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var annotations_1 = require_annotations();
    var cfn_element_1 = require_cfn_element();
    var cfn_resource_policy_1 = require_cfn_resource_policy();
    var constructs_1 = require_lib2();
    var deps_1 = require_deps();
    var cfn_reference_1 = require_cfn_reference();
    var cloudformation_lang_1 = require_cloudformation_lang();
    var removal_policy_1 = require_removal_policy();
    var tag_manager_1 = require_tag_manager();
    var token_1 = require_token2();
    var util_1 = require_util2();
    var feature_flags_1 = require_feature_flags();
    var cxapi = require_cx_api();
    var CfnResource = class _CfnResource extends cfn_element_1.CfnRefElement {
      static isCfnResource(construct) {
        return construct.cfnResourceType !== void 0;
      }
      constructor(scope, id, props) {
        super(scope, id), this.cfnOptions = {}, this.rawOverrides = {}, this.dependsOn = /* @__PURE__ */ new Set();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnResourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResource), error;
        }
        if (!props.type)
          throw new Error("The `type` property is required");
        this.cfnResourceType = props.type, this._cfnProperties = props.properties || {}, constructs_1.Node.of(this).tryGetContext(cxapi.PATH_METADATA_ENABLE_CONTEXT) && this.addMetadata(cxapi.PATH_METADATA_KEY, constructs_1.Node.of(this).path);
      }
      applyRemovalPolicy(policy, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_RemovalPolicy(policy), jsiiDeprecationWarnings.aws_cdk_lib_RemovalPolicyOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.applyRemovalPolicy), error;
        }
        policy = policy || options.default || removal_policy_1.RemovalPolicy.RETAIN;
        let deletionPolicy;
        switch (policy) {
          case removal_policy_1.RemovalPolicy.DESTROY:
            deletionPolicy = cfn_resource_policy_1.CfnDeletionPolicy.DELETE;
            break;
          case removal_policy_1.RemovalPolicy.RETAIN:
            deletionPolicy = cfn_resource_policy_1.CfnDeletionPolicy.RETAIN;
            break;
          case removal_policy_1.RemovalPolicy.SNAPSHOT:
            if (!["AWS::EC2::Volume", "AWS::ElastiCache::CacheCluster", "AWS::ElastiCache::ReplicationGroup", "AWS::Neptune::DBCluster", "AWS::RDS::DBCluster", "AWS::RDS::DBInstance", "AWS::Redshift::Cluster"].includes(this.cfnResourceType)) {
              if (feature_flags_1.FeatureFlags.of(this).isEnabled(cxapi.VALIDATE_SNAPSHOT_REMOVAL_POLICY))
                throw new Error(`${this.cfnResourceType} does not support snapshot removal policy`);
              annotations_1.Annotations.of(this).addWarning(`${this.cfnResourceType} does not support snapshot removal policy. This policy will be ignored.`);
            }
            deletionPolicy = cfn_resource_policy_1.CfnDeletionPolicy.SNAPSHOT;
            break;
          default:
            throw new Error(`Invalid removal policy: ${policy}`);
        }
        this.cfnOptions.deletionPolicy = deletionPolicy, options.applyToUpdateReplacePolicy !== false && (this.cfnOptions.updateReplacePolicy = deletionPolicy);
      }
      getAtt(attributeName, typeHint) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ResolutionTypeHint(typeHint);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.getAtt), error;
        }
        return cfn_reference_1.CfnReference.for(this, attributeName, void 0, typeHint);
      }
      addOverride(path, value) {
        const parts = splitOnPeriods(path);
        let curr = this.rawOverrides;
        for (; parts.length > 1; ) {
          const key = parts.shift();
          curr[key] != null && typeof curr[key] == "object" && !Array.isArray(curr[key]) || (curr[key] = {}), curr = curr[key];
        }
        const lastKey = parts.shift();
        curr[lastKey] = value;
      }
      addDeletionOverride(path) {
        this.addOverride(path, void 0);
      }
      addPropertyOverride(propertyPath, value) {
        this.addOverride(`Properties.${propertyPath}`, value);
      }
      addPropertyDeletionOverride(propertyPath) {
        this.addPropertyOverride(propertyPath, void 0);
      }
      addDependsOn(target) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.CfnResource#addDependsOn", "use addDependency"), jsiiDeprecationWarnings.aws_cdk_lib_CfnResource(target);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addDependsOn), error;
        }
        return this.addDependency(target);
      }
      addDependency(target) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnResource(target);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addDependency), error;
        }
        target.shouldSynthesize() && (0, deps_1.addDependency)(this, target, `{${this.node.path}}.addDependency({${target.node.path}})`);
      }
      removeDependency(target) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnResource(target);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.removeDependency), error;
        }
        target.shouldSynthesize() && (0, deps_1.removeDependency)(this, target);
      }
      obtainDependencies() {
        return (0, deps_1.obtainDependencies)(this);
      }
      replaceDependency(target, newTarget) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnResource(target), jsiiDeprecationWarnings.aws_cdk_lib_CfnResource(newTarget);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.replaceDependency), error;
        }
        if (this.obtainDependencies().includes(target))
          this.removeDependency(target), this.addDependency(newTarget);
        else
          throw new Error(`"${constructs_1.Node.of(this).path}" does not depend on "${constructs_1.Node.of(target).path}"`);
      }
      addMetadata(key, value) {
        this.cfnOptions.metadata || (this.cfnOptions.metadata = {}), this.cfnOptions.metadata[key] = value;
      }
      getMetadata(key) {
        return this.cfnOptions.metadata?.[key];
      }
      toString() {
        return `${super.toString()} [${this.cfnResourceType}]`;
      }
      _addResourceDependency(target) {
        this.dependsOn.add(target);
      }
      obtainResourceDependencies() {
        return Array.from(this.dependsOn.values());
      }
      _removeResourceDependency(target) {
        this.dependsOn.delete(target);
      }
      _toCloudFormation() {
        if (!this.shouldSynthesize())
          return {};
        try {
          return { Resources: { [this.logicalId]: new util_1.PostResolveToken({ Type: this.cfnResourceType, Properties: (0, util_1.ignoreEmpty)(this.cfnProperties), DependsOn: (0, util_1.ignoreEmpty)(renderDependsOn(this.dependsOn)), CreationPolicy: (0, util_1.capitalizePropertyNames)(this, renderCreationPolicy(this.cfnOptions.creationPolicy)), UpdatePolicy: (0, util_1.capitalizePropertyNames)(this, this.cfnOptions.updatePolicy), UpdateReplacePolicy: (0, util_1.capitalizePropertyNames)(this, this.cfnOptions.updateReplacePolicy), DeletionPolicy: (0, util_1.capitalizePropertyNames)(this, this.cfnOptions.deletionPolicy), Version: this.cfnOptions.version, Description: this.cfnOptions.description, Metadata: (0, util_1.ignoreEmpty)(this.cfnOptions.metadata), Condition: this.cfnOptions.condition && this.cfnOptions.condition.logicalId }, (resourceDef) => {
            const renderedProps = this.renderProperties(resourceDef.Properties || {});
            if (renderedProps) {
              const hasDefined = Object.values(renderedProps).find((v) => v !== void 0);
              resourceDef.Properties = hasDefined !== void 0 ? renderedProps : void 0;
            }
            const resolvedRawOverrides = token_1.Tokenization.resolve(this.rawOverrides, { scope: this, resolver: cloudformation_lang_1.CLOUDFORMATION_TOKEN_RESOLVER, removeEmpty: false });
            return deepMerge(resourceDef, resolvedRawOverrides);
          }) } };
        } catch (e) {
          e.message = `While synthesizing ${this.node.path}: ${e.message}`;
          const trace = this.creationStack;
          if (trace) {
            const creationStack = ["--- resource created at ---", ...trace].join(`
  at `), problemTrace = e.stack.slice(e.stack.indexOf(e.message) + e.message.length);
            e.stack = `${e.message}
  ${creationStack}
  --- problem discovered at ---${problemTrace}`;
          }
          throw e;
        }
        function renderDependsOn(dependsOn) {
          return Array.from(dependsOn).sort((x, y) => x.node.path.localeCompare(y.node.path)).map((r) => r.logicalId);
        }
        function renderCreationPolicy(policy) {
          if (!policy)
            return;
          const result = { ...policy };
          return policy.resourceSignal && policy.resourceSignal.timeout && (result.resourceSignal = policy.resourceSignal), result;
        }
      }
      get cfnProperties() {
        const props = this._cfnProperties || {};
        if (tag_manager_1.TagManager.isTaggable(this)) {
          const tagsProp = {};
          return tagsProp[this.tags.tagPropertyName] = this.tags.renderTags(), deepMerge(props, tagsProp);
        }
        return props;
      }
      renderProperties(props) {
        return props;
      }
      get updatedProperites() {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.CfnResource#updatedProperites", `use \`updatedProperties\`

Return properties modified after initiation

Resources that expose mutable properties should override this function to
collect and return the properties object for this resource.`);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, jsiiDeprecationWarnings.getPropertyDescriptor(this, "updatedProperites").get), error;
        }
        return this.updatedProperties;
      }
      get updatedProperties() {
        return this._cfnProperties;
      }
      validateProperties(_properties) {
      }
      shouldSynthesize() {
        return true;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnResource[_a] = { fqn: "aws-cdk-lib.CfnResource", version: "2.80.0" }, exports2.CfnResource = CfnResource;
    var TagType;
    (function(TagType2) {
      TagType2.STANDARD = "StandardTag", TagType2.AUTOSCALING_GROUP = "AutoScalingGroupTag", TagType2.MAP = "StringToStringMap", TagType2.KEY_VALUE = "KeyValue", TagType2.NOT_TAGGABLE = "NotTaggable";
    })(TagType = exports2.TagType || (exports2.TagType = {}));
    var MERGE_EXCLUDE_KEYS = ["Ref", "Fn::Base64", "Fn::Cidr", "Fn::FindInMap", "Fn::GetAtt", "Fn::GetAZs", "Fn::ImportValue", "Fn::Join", "Fn::Select", "Fn::Split", "Fn::Sub", "Fn::Transform", "Fn::And", "Fn::Equals", "Fn::If", "Fn::Not", "Fn::Or"];
    function deepMerge(target, ...sources) {
      for (const source of sources) {
        if (typeof source != "object" || typeof target != "object")
          throw new Error(`Invalid usage. Both source (${JSON.stringify(source)}) and target (${JSON.stringify(target)}) must be objects`);
        for (const key of Object.keys(source)) {
          const value = source[key];
          if (typeof value == "object" && value != null && !Array.isArray(value)) {
            typeof target[key] != "object" ? target[key] = {} : Object.keys(target[key]).length === 1 && MERGE_EXCLUDE_KEYS.includes(Object.keys(target[key])[0]) && (target[key] = {}), Object.keys(value).length === 1 && MERGE_EXCLUDE_KEYS.includes(Object.keys(value)[0]) && (target[key] = {}), deepMerge(target[key], value);
            const output = target[key];
            typeof output == "object" && Object.keys(output).length === 0 && delete target[key];
          } else
            value === void 0 ? delete target[key] : target[key] = value;
        }
      }
      return target;
    }
    function splitOnPeriods(x) {
      const ret = [""];
      for (let i = 0; i < x.length; i++)
        x[i] === "\\" && i + 1 < x.length ? (ret[0] += x[i + 1], i++) : x[i] === "." ? ret.unshift("") : ret[0] += x[i];
      return ret.reverse(), ret;
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/tag-manager.js
var require_tag_manager = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/tag-manager.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.TagManager = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cfn_resource_1 = require_cfn_resource();
    var lazy_1 = require_lazy();
    var StandardFormatter = class {
      parseTags(cfnPropertyTags, priority) {
        if (!Array.isArray(cfnPropertyTags))
          throw new Error(`Invalid tag input expected array of {key, value} have ${JSON.stringify(cfnPropertyTags)}`);
        const tags = [], dynamicTags = [];
        for (const tag of cfnPropertyTags)
          tag.key === void 0 || tag.value === void 0 ? dynamicTags.push(tag) : tags.push({ key: `${tag.key}`, value: `${tag.value}`, priority });
        return { tags, dynamicTags };
      }
      formatTags(tags) {
        const cfnTags = [];
        for (const tag of tags)
          cfnTags.push({ key: tag.key, value: tag.value });
        return cfnTags;
      }
    };
    var AsgFormatter = class {
      parseTags(cfnPropertyTags, priority) {
        if (!Array.isArray(cfnPropertyTags))
          throw new Error(`Invalid tag input expected array of {key, value, propagateAtLaunch} have ${JSON.stringify(cfnPropertyTags)}`);
        const tags = [], dynamicTags = [];
        for (const tag of cfnPropertyTags)
          tag.key === void 0 || tag.value === void 0 || tag.propagateAtLaunch === void 0 ? dynamicTags.push(tag) : tags.push({ key: `${tag.key}`, value: `${tag.value}`, priority, applyToLaunchedInstances: !!tag.propagateAtLaunch });
        return { tags, dynamicTags };
      }
      formatTags(tags) {
        const cfnTags = [];
        for (const tag of tags)
          cfnTags.push({ key: tag.key, value: tag.value, propagateAtLaunch: tag.applyToLaunchedInstances !== false });
        return cfnTags;
      }
    };
    var MapFormatter = class {
      parseTags(cfnPropertyTags, priority) {
        if (Array.isArray(cfnPropertyTags) || typeof cfnPropertyTags != "object")
          throw new Error(`Invalid tag input expected map of {key: value} have ${JSON.stringify(cfnPropertyTags)}`);
        const tags = [];
        for (const [key, value] of Object.entries(cfnPropertyTags))
          tags.push({ key, value: `${value}`, priority });
        return { tags, dynamicTags: void 0 };
      }
      formatTags(tags) {
        const cfnTags = {};
        for (const tag of tags)
          cfnTags[`${tag.key}`] = `${tag.value}`;
        return cfnTags;
      }
    };
    var KeyValueFormatter = class {
      parseTags(keyValueTags, priority) {
        const tags = [];
        for (const key in keyValueTags)
          if (keyValueTags.hasOwnProperty(key)) {
            const value = keyValueTags[key];
            tags.push({ key, value, priority });
          }
        return { tags, dynamicTags: void 0 };
      }
      formatTags(unformattedTags) {
        const tags = [];
        return unformattedTags.forEach((tag) => {
          tags.push({ Key: tag.key, Value: tag.value });
        }), tags;
      }
    };
    var NoFormat = class {
      parseTags(_cfnPropertyTags) {
        return { tags: [], dynamicTags: void 0 };
      }
      formatTags(_tags) {
      }
    };
    var _tagFormattersCache;
    function TAG_FORMATTERS() {
      return _tagFormattersCache ?? (_tagFormattersCache = { [cfn_resource_1.TagType.AUTOSCALING_GROUP]: new AsgFormatter(), [cfn_resource_1.TagType.STANDARD]: new StandardFormatter(), [cfn_resource_1.TagType.MAP]: new MapFormatter(), [cfn_resource_1.TagType.KEY_VALUE]: new KeyValueFormatter(), [cfn_resource_1.TagType.NOT_TAGGABLE]: new NoFormat() });
    }
    var TagManager = class _TagManager {
      static isTaggable(construct) {
        return construct.tags !== void 0;
      }
      constructor(tagType, resourceTypeName, tagStructure, options = {}) {
        this.tags = /* @__PURE__ */ new Map(), this.priorities = /* @__PURE__ */ new Map(), this.initialTagPriority = 50;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TagType(tagType), jsiiDeprecationWarnings.aws_cdk_lib_TagManagerOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _TagManager), error;
        }
        if (this.resourceTypeName = resourceTypeName, this.tagFormatter = TAG_FORMATTERS()[tagType], tagStructure !== void 0) {
          const parseTagsResult = this.tagFormatter.parseTags(tagStructure, this.initialTagPriority);
          this.dynamicTags = parseTagsResult.dynamicTags, this._setTag(...parseTagsResult.tags);
        }
        this.tagPropertyName = options.tagPropertyName || "tags", this.renderedTags = lazy_1.Lazy.any({ produce: () => this.renderTags() });
      }
      setTag(key, value, priority = 0, applyToLaunchedInstances = true) {
        this._setTag({ key, value, priority, applyToLaunchedInstances });
      }
      removeTag(key, priority) {
        priority >= (this.priorities.get(key) || 0) && (this.tags.delete(key), this.priorities.set(key, priority));
      }
      renderTags() {
        const formattedTags = this.tagFormatter.formatTags(this.sortedTags);
        if (Array.isArray(formattedTags) || Array.isArray(this.dynamicTags)) {
          const ret = [...formattedTags ?? [], ...this.dynamicTags ?? []];
          return ret.length > 0 ? ret : void 0;
        } else {
          const ret = { ...formattedTags ?? {}, ...this.dynamicTags ?? {} };
          return Object.keys(ret).length > 0 ? ret : void 0;
        }
      }
      tagValues() {
        const ret = {};
        for (const tag of this.sortedTags)
          ret[tag.key] = tag.value;
        return ret;
      }
      applyTagAspectHere(include, exclude) {
        return !(exclude && exclude.length > 0 && exclude.indexOf(this.resourceTypeName) !== -1 || include && include.length > 0 && include.indexOf(this.resourceTypeName) === -1);
      }
      hasTags() {
        return this.tags.size > 0;
      }
      _setTag(...tags) {
        for (const tag of tags)
          tag.priority >= (this.priorities.get(tag.key) || 0) && (this.tags.set(tag.key, tag), this.priorities.set(tag.key, tag.priority));
      }
      get sortedTags() {
        return Array.from(this.tags.values()).sort((a, b) => a.key.localeCompare(b.key));
      }
    };
    _a = JSII_RTTI_SYMBOL_1, TagManager[_a] = { fqn: "aws-cdk-lib.TagManager", version: "2.80.0" }, exports2.TagManager = TagManager;
  }
});

// node_modules/aws-cdk-lib/core/lib/tag-aspect.js
var require_tag_aspect = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/tag-aspect.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.RemoveTag = exports2.Tags = exports2.Tag = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var annotations_1 = require_annotations();
    var aspect_1 = require_aspect();
    var tag_manager_1 = require_tag_manager();
    var TagBase = class {
      constructor(key, props = {}) {
        this.key = key, this.props = props;
      }
      visit(construct) {
        tag_manager_1.TagManager.isTaggable(construct) && this.applyTag(construct);
      }
    };
    var Tag = class _Tag extends TagBase {
      static add(scope, key, value, props = {}) {
        annotations_1.Annotations.of(scope).addDeprecation("@aws-cdk/core.Tag.add(scope,k,v)", 'Use "Tags.of(scope).add(k,v)" instead'), Tags.of(scope).add(key, value, props);
      }
      static remove(scope, key, props = {}) {
        annotations_1.Annotations.of(scope).addDeprecation("@aws-cdk/core.Tag.remove(scope,k,v)", 'Use "Tags.of(scope).remove(k,v)" instead'), Tags.of(scope).remove(key, props);
      }
      constructor(key, value, props = {}) {
        super(key, props), this.defaultPriority = 100;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TagProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Tag), error;
        }
        if (value === void 0)
          throw new Error("Tag must have a value");
        this.value = value;
      }
      applyTag(resource) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ITaggable(resource);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.applyTag), error;
        }
        resource.tags.applyTagAspectHere(this.props.includeResourceTypes, this.props.excludeResourceTypes) && resource.tags.setTag(this.key, this.value, this.props.priority ?? this.defaultPriority, this.props.applyToLaunchedInstances !== false);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Tag[_a] = { fqn: "aws-cdk-lib.Tag", version: "2.80.0" }, exports2.Tag = Tag;
    var Tags = class _Tags {
      static of(scope) {
        return new _Tags(scope);
      }
      constructor(scope) {
        this.scope = scope;
      }
      add(key, value, props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TagProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.add), error;
        }
        aspect_1.Aspects.of(this.scope).add(new Tag(key, value, props));
      }
      remove(key, props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TagProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.remove), error;
        }
        aspect_1.Aspects.of(this.scope).add(new RemoveTag(key, props));
      }
    };
    _b = JSII_RTTI_SYMBOL_1, Tags[_b] = { fqn: "aws-cdk-lib.Tags", version: "2.80.0" }, exports2.Tags = Tags;
    var RemoveTag = class _RemoveTag extends TagBase {
      constructor(key, props = {}) {
        super(key, props), this.defaultPriority = 200;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TagProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _RemoveTag), error;
        }
      }
      applyTag(resource) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ITaggable(resource);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.applyTag), error;
        }
        resource.tags.applyTagAspectHere(this.props.includeResourceTypes, this.props.excludeResourceTypes) && resource.tags.removeTag(this.key, this.props.priority ?? this.defaultPriority);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, RemoveTag[_c] = { fqn: "aws-cdk-lib.RemoveTag", version: "2.80.0" }, exports2.RemoveTag = RemoveTag;
  }
});

// node_modules/aws-cdk-lib/core/lib/cfn-hook.js
var require_cfn_hook = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/cfn-hook.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnHook = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cfn_element_1 = require_cfn_element();
    var util_1 = require_util2();
    var CfnHook = class _CfnHook extends cfn_element_1.CfnElement {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnHookProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnHook), error;
        }
        this.type = props.type, this._cfnHookProperties = props.properties;
      }
      _toCloudFormation() {
        return { Hooks: { [this.logicalId]: { Type: this.type, Properties: (0, util_1.ignoreEmpty)(this.renderProperties(this._cfnHookProperties)) } } };
      }
      renderProperties(props) {
        return props;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnHook[_a] = { fqn: "aws-cdk-lib.CfnHook", version: "2.80.0" }, exports2.CfnHook = CfnHook;
  }
});

// node_modules/aws-cdk-lib/core/lib/cfn-codedeploy-blue-green-hook.js
var require_cfn_codedeploy_blue_green_hook = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/cfn-codedeploy-blue-green-hook.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnCodeDeployBlueGreenHook = exports2.CfnTrafficRoutingType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cfn_hook_1 = require_cfn_hook();
    var util_1 = require_util2();
    var CfnTrafficRoutingType;
    (function(CfnTrafficRoutingType2) {
      CfnTrafficRoutingType2.ALL_AT_ONCE = "AllAtOnce", CfnTrafficRoutingType2.TIME_BASED_CANARY = "TimeBasedCanary", CfnTrafficRoutingType2.TIME_BASED_LINEAR = "TimeBasedLinear";
    })(CfnTrafficRoutingType = exports2.CfnTrafficRoutingType || (exports2.CfnTrafficRoutingType = {}));
    var CfnCodeDeployBlueGreenHook = class _CfnCodeDeployBlueGreenHook extends cfn_hook_1.CfnHook {
      static _fromCloudFormation(scope, id, hookAttributes, options) {
        hookAttributes = hookAttributes || {};
        const hookProperties = options.parser.parseValue(hookAttributes.Properties);
        return new _CfnCodeDeployBlueGreenHook(scope, id, { serviceRole: hookProperties?.ServiceRole, applications: hookProperties?.Applications?.map(applicationFromCloudFormation), trafficRoutingConfig: { type: hookProperties?.TrafficRoutingConfig?.Type, timeBasedCanary: { stepPercentage: hookProperties?.TrafficRoutingConfig?.TimeBasedCanary?.StepPercentage, bakeTimeMins: hookProperties?.TrafficRoutingConfig?.TimeBasedCanary?.BakeTimeMins }, timeBasedLinear: { stepPercentage: hookProperties?.TrafficRoutingConfig?.TimeBasedLinear?.StepPercentage, bakeTimeMins: hookProperties?.TrafficRoutingConfig?.TimeBasedLinear?.BakeTimeMins } }, additionalOptions: { terminationWaitTimeInMinutes: hookProperties?.AdditionalOptions?.TerminationWaitTimeInMinutes }, lifecycleEventHooks: { beforeInstall: hookProperties?.LifecycleEventHooks?.BeforeInstall, afterInstall: hookProperties?.LifecycleEventHooks?.AfterInstall, afterAllowTestTraffic: hookProperties?.LifecycleEventHooks?.AfterAllowTestTraffic, beforeAllowTraffic: hookProperties?.LifecycleEventHooks?.BeforeAllowTraffic, afterAllowTraffic: hookProperties?.LifecycleEventHooks?.AfterAllowTraffic } });
        function applicationFromCloudFormation(app) {
          const target = findResource(app?.Target?.LogicalID), taskDefinitions = app?.ECSAttributes?.TaskDefinitions?.map((td) => findResource(td)), taskSets = app?.ECSAttributes?.TaskSets?.map((ts) => findResource(ts)), prodTrafficRoute = findResource(app?.ECSAttributes?.TrafficRouting?.ProdTrafficRoute?.LogicalID), testTrafficRoute = findResource(app?.ECSAttributes?.TrafficRouting?.TestTrafficRoute?.LogicalID), targetGroups = app?.ECSAttributes?.TrafficRouting?.TargetGroups?.map((tg) => findResource(tg));
          return { target: { type: app?.Target?.Type, logicalId: target?.logicalId }, ecsAttributes: { taskDefinitions: taskDefinitions?.map((td) => td?.logicalId), taskSets: taskSets?.map((ts) => ts?.logicalId), trafficRouting: { prodTrafficRoute: { type: app?.ECSAttributes?.TrafficRouting?.ProdTrafficRoute?.Type, logicalId: prodTrafficRoute?.logicalId }, testTrafficRoute: { type: app?.ECSAttributes?.TrafficRouting?.TestTrafficRoute?.Type, logicalId: testTrafficRoute?.logicalId }, targetGroups: targetGroups?.map((tg) => tg?.logicalId) } } };
        }
        function findResource(logicalId) {
          if (logicalId == null)
            return;
          const ret = options.parser.finder.findResource(logicalId);
          if (!ret)
            throw new Error(`Hook '${id}' references resource '${logicalId}' that was not found in the template`);
          return ret;
        }
      }
      constructor(scope, id, props) {
        super(scope, id, { type: "AWS::CodeDeploy::BlueGreen" });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnCodeDeployBlueGreenHookProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCodeDeployBlueGreenHook), error;
        }
        this._serviceRole = props.serviceRole, this._applications = props.applications, this._trafficRoutingConfig = props.trafficRoutingConfig, this._additionalOptions = props.additionalOptions, this._lifecycleEventHooks = props.lifecycleEventHooks;
      }
      get serviceRole() {
        return this._serviceRole;
      }
      set serviceRole(serviceRole) {
        this._serviceRole = serviceRole;
      }
      get applications() {
        return this._applications;
      }
      set applications(value) {
        this._applications = value;
      }
      get trafficRoutingConfig() {
        return this._trafficRoutingConfig;
      }
      set trafficRoutingConfig(value) {
        this._trafficRoutingConfig = value;
      }
      get additionalOptions() {
        return this._additionalOptions;
      }
      set additionalOptions(value) {
        this._additionalOptions = value;
      }
      get lifecycleEventHooks() {
        return this._lifecycleEventHooks;
      }
      set lifecycleEventHooks(value) {
        this._lifecycleEventHooks = value;
      }
      renderProperties(_props) {
        return { ServiceRole: this.serviceRole, Applications: this.applications.map((app) => ({ Target: { Type: app.target.type, LogicalID: app.target.logicalId }, ECSAttributes: { TaskDefinitions: app.ecsAttributes.taskDefinitions, TaskSets: app.ecsAttributes.taskSets, TrafficRouting: { ProdTrafficRoute: { Type: app.ecsAttributes.trafficRouting.prodTrafficRoute.type, LogicalID: app.ecsAttributes.trafficRouting.prodTrafficRoute.logicalId }, TestTrafficRoute: { Type: app.ecsAttributes.trafficRouting.testTrafficRoute.type, LogicalID: app.ecsAttributes.trafficRouting.testTrafficRoute.logicalId }, TargetGroups: app.ecsAttributes.trafficRouting.targetGroups } } })), TrafficRoutingConfig: (0, util_1.undefinedIfAllValuesAreEmpty)({ Type: this.trafficRoutingConfig?.type, TimeBasedCanary: (0, util_1.undefinedIfAllValuesAreEmpty)({ StepPercentage: this.trafficRoutingConfig?.timeBasedCanary?.stepPercentage, BakeTimeMins: this.trafficRoutingConfig?.timeBasedCanary?.bakeTimeMins }), TimeBasedLinear: (0, util_1.undefinedIfAllValuesAreEmpty)({ StepPercentage: this.trafficRoutingConfig?.timeBasedLinear?.stepPercentage, BakeTimeMins: this.trafficRoutingConfig?.timeBasedLinear?.bakeTimeMins }) }), AdditionalOptions: (0, util_1.undefinedIfAllValuesAreEmpty)({ TerminationWaitTimeInMinutes: this.additionalOptions?.terminationWaitTimeInMinutes }), LifecycleEventHooks: (0, util_1.undefinedIfAllValuesAreEmpty)({ BeforeInstall: this.lifecycleEventHooks?.beforeInstall, AfterInstall: this.lifecycleEventHooks?.afterInstall, AfterAllowTestTraffic: this.lifecycleEventHooks?.afterAllowTestTraffic, BeforeAllowTraffic: this.lifecycleEventHooks?.beforeAllowTraffic, AfterAllowTraffic: this.lifecycleEventHooks?.afterAllowTraffic }) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnCodeDeployBlueGreenHook[_a] = { fqn: "aws-cdk-lib.CfnCodeDeployBlueGreenHook", version: "2.80.0" }, exports2.CfnCodeDeployBlueGreenHook = CfnCodeDeployBlueGreenHook;
  }
});

// node_modules/aws-cdk-lib/core/lib/cfn-include.js
var require_cfn_include = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/cfn-include.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnInclude = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cfn_element_1 = require_cfn_element();
    var CfnInclude = class extends cfn_element_1.CfnElement {
      constructor(scope, id, props) {
        super(scope, id), this.template = props.template;
      }
      _toCloudFormation() {
        return this.template;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnInclude[_a] = { fqn: "aws-cdk-lib.CfnInclude", version: "2.80.0" }, exports2.CfnInclude = CfnInclude;
  }
});

// node_modules/aws-cdk-lib/core/lib/cfn-tag.js
var require_cfn_tag = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/cfn-tag.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/core/lib/cfn-json.js
var require_cfn_json = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/cfn-json.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnJson = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var custom_resource_1 = require_custom_resource();
    var cfn_utils_provider_1 = require_cfn_utils_provider();
    var stack_1 = require_stack();
    var stack_trace_1 = require_stack_trace2();
    var CfnJson = class _CfnJson extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id), this.creationStack = [];
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnJsonProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnJson), error;
        }
        this.creationStack = (0, stack_trace_1.captureStackTrace)(), this.jsonString = stack_1.Stack.of(this).toJsonString(props.value);
        const resource = new custom_resource_1.CustomResource(this, "Resource", { serviceToken: cfn_utils_provider_1.CfnUtilsProvider.getOrCreate(this), resourceType: "Custom::AWSCDKCfnJson", properties: { Value: this.jsonString } });
        this.value = resource.getAtt("Value");
      }
      toJSON() {
        return this.jsonString;
      }
      resolve(_context) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_IResolveContext(_context);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.resolve), error;
        }
        return this.value;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnJson[_a] = { fqn: "aws-cdk-lib.CfnJson", version: "2.80.0" }, exports2.CfnJson = CfnJson;
  }
});

// node_modules/aws-cdk-lib/core/lib/expiration.js
var require_expiration = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/expiration.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Expiration = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var Expiration = class _Expiration {
      static atDate(d) {
        return new _Expiration(d);
      }
      static atTimestamp(t) {
        return _Expiration.atDate(new Date(t));
      }
      static after(t) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Duration(t);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.after), error;
        }
        return _Expiration.atDate(new Date(Date.now() + t.toMilliseconds()));
      }
      static fromString(s) {
        return new _Expiration(new Date(s));
      }
      constructor(date) {
        this.date = date;
      }
      toEpoch() {
        return Math.round(this.date.getTime() / 1e3);
      }
      isBefore(t) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Duration(t);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.isBefore), error;
        }
        return this.date < new Date(Date.now() + t.toMilliseconds());
      }
      isAfter(t) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Duration(t);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.isAfter), error;
        }
        return this.date > new Date(Date.now() + t.toMilliseconds());
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Expiration[_a] = { fqn: "aws-cdk-lib.Expiration", version: "2.80.0" }, exports2.Expiration = Expiration;
  }
});

// node_modules/aws-cdk-lib/core/lib/environment.js
var require_environment2 = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/environment.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/core/lib/runtime.js
var require_runtime = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/runtime.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.unionValidator = exports2.requireProperty = exports2.requiredValidator = exports2.propertyValidator = exports2.hashValidator = exports2.listValidator = exports2.validateCfnTag = exports2.validateObject = exports2.validateDate = exports2.validateBoolean = exports2.validateNumber = exports2.validateString = exports2.canInspect = exports2.VALIDATION_SUCCESS = exports2.ValidationResults = exports2.ValidationResult = exports2.unionMapper = exports2.hashMapper = exports2.listMapper = exports2.cfnTagToCloudFormation = exports2.dateToCloudFormation = exports2.numberToCloudFormation = exports2.objectToCloudFormation = exports2.booleanToCloudFormation = exports2.stringToCloudFormation = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    function identity(x) {
      return x;
    }
    exports2.stringToCloudFormation = identity, exports2.booleanToCloudFormation = identity, exports2.objectToCloudFormation = identity, exports2.numberToCloudFormation = identity;
    function dateToCloudFormation(x) {
      if (x)
        return `${x.getUTCFullYear()}-${pad(x.getUTCMonth() + 1)}-${pad(x.getUTCDate())}T${pad(x.getUTCHours())}:${pad(x.getUTCMinutes())}:${pad(x.getUTCSeconds())}`;
    }
    exports2.dateToCloudFormation = dateToCloudFormation;
    function pad(x) {
      return x < 10 ? "0" + x.toString() : x.toString();
    }
    function cfnTagToCloudFormation(x) {
      return { Key: x.key, Value: x.value };
    }
    exports2.cfnTagToCloudFormation = cfnTagToCloudFormation;
    function listMapper(elementMapper) {
      return (x) => canInspect(x) ? x.map(elementMapper) : x;
    }
    exports2.listMapper = listMapper;
    function hashMapper(elementMapper) {
      return (x) => {
        if (!canInspect(x))
          return x;
        const ret = {};
        return Object.keys(x).forEach((key) => {
          ret[key] = elementMapper(x[key]);
        }), ret;
      };
    }
    exports2.hashMapper = hashMapper;
    function unionMapper(validators, mappers) {
      if (validators.length !== mappers.length)
        throw Error("Not the same amount of validators and mappers passed to unionMapper()");
      return (x) => {
        if (!canInspect(x))
          return x;
        for (let i = 0; i < validators.length; i++)
          if (validators[i](x).isSuccess)
            return mappers[i](x);
        throw new TypeError("No validators matched in the union()");
      };
    }
    exports2.unionMapper = unionMapper;
    var ValidationResult = class _ValidationResult {
      constructor(errorMessage = "", results = new ValidationResults()) {
        this.errorMessage = errorMessage, this.results = results;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ValidationResults(results);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ValidationResult), error;
        }
      }
      get isSuccess() {
        return !this.errorMessage && this.results.isSuccess;
      }
      assertSuccess() {
        if (!this.isSuccess) {
          let message = this.errorTree();
          throw message = message.slice(0, 1).toUpperCase() + message.slice(1), new CfnSynthesisError(message);
        }
      }
      errorTree() {
        const childMessages = this.results.errorTreeList();
        return this.errorMessage + (childMessages.length ? `
  ${childMessages.replace(/\n/g, `
  `)}` : "");
      }
      prefix(message) {
        return this.isSuccess ? this : new _ValidationResult(`${message}: ${this.errorMessage}`, this.results);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ValidationResult[_a] = { fqn: "aws-cdk-lib.ValidationResult", version: "2.80.0" }, exports2.ValidationResult = ValidationResult;
    var ValidationResults = class {
      constructor(results = []) {
        this.results = results;
      }
      collect(result) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ValidationResult(result);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.collect), error;
        }
        result.isSuccess || this.results.push(result);
      }
      get isSuccess() {
        return this.results.every((x) => x.isSuccess);
      }
      errorTreeList() {
        return this.results.map((child) => child.errorTree()).join(`
`);
      }
      wrap(message) {
        return this.isSuccess ? exports2.VALIDATION_SUCCESS : new ValidationResult(message, this);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, ValidationResults[_b] = { fqn: "aws-cdk-lib.ValidationResults", version: "2.80.0" }, exports2.ValidationResults = ValidationResults, exports2.VALIDATION_SUCCESS = new ValidationResult();
    function canInspect(x) {
      return x != null && !isCloudFormationIntrinsic(x) && !isCloudFormationDynamicReference(x);
    }
    exports2.canInspect = canInspect;
    function validateString(x) {
      return canInspect(x) && typeof x != "string" ? new ValidationResult(`${JSON.stringify(x)} should be a string`) : exports2.VALIDATION_SUCCESS;
    }
    exports2.validateString = validateString;
    function validateNumber(x) {
      return canInspect(x) && typeof x != "number" ? new ValidationResult(`${JSON.stringify(x)} should be a number`) : exports2.VALIDATION_SUCCESS;
    }
    exports2.validateNumber = validateNumber;
    function validateBoolean(x) {
      return canInspect(x) && typeof x != "boolean" ? new ValidationResult(`${JSON.stringify(x)} should be a boolean`) : exports2.VALIDATION_SUCCESS;
    }
    exports2.validateBoolean = validateBoolean;
    function validateDate(x) {
      return canInspect(x) && !(x instanceof Date) ? new ValidationResult(`${JSON.stringify(x)} should be a Date`) : x !== void 0 && isNaN(x.getTime()) ? new ValidationResult("got an unparseable Date") : exports2.VALIDATION_SUCCESS;
    }
    exports2.validateDate = validateDate;
    function validateObject(x) {
      return canInspect(x) && typeof x != "object" ? new ValidationResult(`${JSON.stringify(x)} should be an 'object'`) : exports2.VALIDATION_SUCCESS;
    }
    exports2.validateObject = validateObject;
    function validateCfnTag(x) {
      return canInspect(x) && (x.key == null || x.value == null) ? new ValidationResult(`${JSON.stringify(x)} should have a 'key' and a 'value' property`) : exports2.VALIDATION_SUCCESS;
    }
    exports2.validateCfnTag = validateCfnTag;
    function listValidator(elementValidator) {
      return (x) => {
        if (!canInspect(x))
          return exports2.VALIDATION_SUCCESS;
        if (!x.forEach)
          return new ValidationResult(`${JSON.stringify(x)} should be a list`);
        for (let i = 0; i < x.length; i++) {
          const element = x[i], result = elementValidator(element);
          if (!result.isSuccess)
            return result.prefix(`element ${i}`);
        }
        return exports2.VALIDATION_SUCCESS;
      };
    }
    exports2.listValidator = listValidator;
    function hashValidator(elementValidator) {
      return (x) => {
        if (!canInspect(x))
          return exports2.VALIDATION_SUCCESS;
        for (const key of Object.keys(x)) {
          const result = elementValidator(x[key]);
          if (!result.isSuccess)
            return result.prefix(`element '${key}'`);
        }
        return exports2.VALIDATION_SUCCESS;
      };
    }
    exports2.hashValidator = hashValidator;
    function propertyValidator(propName, validator) {
      return (x) => validator(x).prefix(propName);
    }
    exports2.propertyValidator = propertyValidator;
    function requiredValidator(x) {
      return x == null ? new ValidationResult("required but missing") : exports2.VALIDATION_SUCCESS;
    }
    exports2.requiredValidator = requiredValidator;
    function requireProperty(props, name, context) {
      const value = props[name];
      if (value == null)
        throw new Error(`${context.toString()} is missing required property: ${name}`);
      return value;
    }
    exports2.requireProperty = requireProperty;
    function unionValidator(...validators) {
      return (x) => {
        const results = new ValidationResults();
        let eitherOr = "either";
        for (const validator of validators) {
          const result = validator(x);
          if (result.isSuccess)
            return result;
          results.collect(result.prefix(eitherOr)), eitherOr = "or";
        }
        return results.wrap("not one of the possible types");
      };
    }
    exports2.unionValidator = unionValidator;
    function isCloudFormationIntrinsic(x) {
      if (typeof x != "object")
        return false;
      const keys = Object.keys(x);
      return keys.length !== 1 ? false : keys[0] === "Ref" || keys[0].slice(0, 4) === "Fn::";
    }
    function isCloudFormationDynamicReference(x) {
      return typeof x == "string" && x.startsWith("{{resolve:") && x.endsWith("}}");
    }
    var CfnSynthesisError = class extends Error {
      constructor() {
        super(...arguments), this.type = "CfnSynthesisError";
      }
    };
  }
});

// node_modules/aws-cdk-lib/core/lib/secret-value.js
var require_secret_value = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/secret-value.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SecretValue = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cfn_dynamic_reference_1 = require_cfn_dynamic_reference();
    var cfn_resource_1 = require_cfn_resource();
    var feature_flags_1 = require_feature_flags();
    var cfn_reference_1 = require_cfn_reference();
    var intrinsic_1 = require_intrinsic();
    var token_1 = require_token2();
    var cx_api_1 = require_cx_api();
    var SecretValue = class _SecretValue extends intrinsic_1.Intrinsic {
      static isSecretValue(x) {
        return typeof x == "object" && x && x[SECRET_VALUE_SYM];
      }
      static plainText(secret) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.SecretValue#plainText", "Use `unsafePlainText()` instead.");
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.plainText), error;
        }
        return new _SecretValue(secret);
      }
      static unsafePlainText(secret) {
        return new _SecretValue(secret);
      }
      static secretsManager(secretId, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_SecretsManagerSecretOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.secretsManager), error;
        }
        if (!secretId)
          throw new Error("secretId cannot be empty");
        if (!token_1.Token.isUnresolved(secretId) && !secretId.startsWith("arn:") && secretId.includes(":"))
          throw new Error(`secret id "${secretId}" is not an ARN but contains ":"`);
        if (options.versionStage && options.versionId)
          throw new Error(`versionStage: '${options.versionStage}' and versionId: '${options.versionId}' were both provided but only one is allowed`);
        const parts = [secretId, "SecretString", options.jsonField || "", options.versionStage || "", options.versionId || ""], dyref = new cfn_dynamic_reference_1.CfnDynamicReference(cfn_dynamic_reference_1.CfnDynamicReferenceService.SECRETS_MANAGER, parts.join(":"));
        return this.cfnDynamicReference(dyref);
      }
      static ssmSecure(parameterName, version) {
        return this.cfnDynamicReference(new cfn_dynamic_reference_1.CfnDynamicReference(cfn_dynamic_reference_1.CfnDynamicReferenceService.SSM_SECURE, version ? `${parameterName}:${version}` : parameterName));
      }
      static cfnDynamicReference(ref) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnDynamicReference(ref);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.cfnDynamicReference), error;
        }
        return new _SecretValue(ref);
      }
      static cfnParameter(param) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnParameter(param);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.cfnParameter), error;
        }
        if (!param.noEcho)
          throw new Error('CloudFormation parameter must be configured with "NoEcho"');
        return new _SecretValue(param.value);
      }
      static resourceAttribute(attr) {
        const resolved = token_1.Tokenization.reverseCompleteString(attr);
        if (!resolved || !cfn_reference_1.CfnReference.isCfnReference(resolved) || !cfn_resource_1.CfnResource.isCfnResource(resolved.target))
          throw new Error("SecretValue.resourceAttribute() must be used with a resource attribute");
        return new _SecretValue(attr);
      }
      constructor(protectedValue, options) {
        super(protectedValue, options);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_IntrinsicProps(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SecretValue), error;
        }
        this.rawValue = protectedValue;
      }
      unsafeUnwrap() {
        return token_1.Token.asString(this.rawValue);
      }
      resolve(context) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_IResolveContext(context);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.resolve), error;
        }
        if (feature_flags_1.FeatureFlags.of(context.scope).isEnabled(cx_api_1.CHECK_SECRET_USAGE))
          throw new Error(`Synthing a secret value to ${context.documentPath.join("/")}. Using a SecretValue here risks exposing your secret. Only pass SecretValues to constructs that accept a SecretValue property, or call AWS Secrets Manager directly in your runtime code. Call 'secretValue.unsafeUnwrap()' if you understand and accept the risks.`);
        return super.resolve(context);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SecretValue[_a] = { fqn: "aws-cdk-lib.SecretValue", version: "2.80.0" }, exports2.SecretValue = SecretValue;
    var SECRET_VALUE_SYM = Symbol.for("@aws-cdk/core.SecretValue");
    Object.defineProperty(SecretValue.prototype, SECRET_VALUE_SYM, { value: true, configurable: false, enumerable: false, writable: false });
  }
});

// node_modules/aws-cdk-lib/core/lib/physical-name.js
var require_physical_name = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/physical-name.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PhysicalName = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var physical_name_generator_1 = require_physical_name_generator();
    var token_1 = require_token2();
    var PhysicalName = class {
      constructor() {
      }
    };
    _a = JSII_RTTI_SYMBOL_1, PhysicalName[_a] = { fqn: "aws-cdk-lib.PhysicalName", version: "2.80.0" }, PhysicalName.GENERATE_IF_NEEDED = token_1.Token.asString(new physical_name_generator_1.GeneratedWhenNeededMarker()), exports2.PhysicalName = PhysicalName;
  }
});

// node_modules/aws-cdk-lib/core/lib/cloudformation.generated.js
var require_cloudformation_generated = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/cloudformation.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    var _l;
    var _m;
    var _o;
    var _p;
    var _q;
    var _r;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnWaitConditionHandle = exports2.CfnWaitCondition = exports2.CfnTypeActivation = exports2.CfnStackSet = exports2.CfnStack = exports2.CfnResourceVersion = exports2.CfnResourceDefaultVersion = exports2.CfnPublisher = exports2.CfnPublicTypeVersion = exports2.CfnModuleVersion = exports2.CfnModuleDefaultVersion = exports2.CfnMacro = exports2.CfnHookVersion = exports2.CfnHookTypeConfig = exports2.CfnHookDefaultVersion = exports2.CfnCustomResource = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_lib8();
    var cfn_parse = require_helpers_internal();
    function CfnCustomResourcePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("serviceToken", cdk.requiredValidator)(properties.serviceToken)), errors.collect(cdk.propertyValidator("serviceToken", cdk.validateString)(properties.serviceToken)), errors.wrap('supplied properties not correct for "CfnCustomResourceProps"');
    }
    function cfnCustomResourcePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCustomResourcePropsValidator(properties).assertSuccess(), { ServiceToken: cdk.stringToCloudFormation(properties.serviceToken) }) : properties;
    }
    function CfnCustomResourcePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("serviceToken", "ServiceToken", cfn_parse.FromCloudFormation.getString(properties.ServiceToken)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCustomResource = class _CfnCustomResource extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCustomResourcePropsFromCloudFormation(resourceProperties), ret = new _CfnCustomResource(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCustomResource.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnCustomResourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCustomResource), error;
        }
        cdk.requireProperty(props, "serviceToken", this), this.serviceToken = props.serviceToken;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCustomResource.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { serviceToken: this.serviceToken };
      }
      renderProperties(props) {
        return cfnCustomResourcePropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnCustomResource[_a] = { fqn: "aws-cdk-lib.CfnCustomResource", version: "2.80.0" }, CfnCustomResource.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::CustomResource", exports2.CfnCustomResource = CfnCustomResource;
    function CfnHookDefaultVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("typeName", cdk.validateString)(properties.typeName)), errors.collect(cdk.propertyValidator("typeVersionArn", cdk.validateString)(properties.typeVersionArn)), errors.collect(cdk.propertyValidator("versionId", cdk.validateString)(properties.versionId)), errors.wrap('supplied properties not correct for "CfnHookDefaultVersionProps"');
    }
    function cfnHookDefaultVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHookDefaultVersionPropsValidator(properties).assertSuccess(), { TypeName: cdk.stringToCloudFormation(properties.typeName), TypeVersionArn: cdk.stringToCloudFormation(properties.typeVersionArn), VersionId: cdk.stringToCloudFormation(properties.versionId) }) : properties;
    }
    function CfnHookDefaultVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("typeName", "TypeName", properties.TypeName != null ? cfn_parse.FromCloudFormation.getString(properties.TypeName) : void 0), ret.addPropertyResult("typeVersionArn", "TypeVersionArn", properties.TypeVersionArn != null ? cfn_parse.FromCloudFormation.getString(properties.TypeVersionArn) : void 0), ret.addPropertyResult("versionId", "VersionId", properties.VersionId != null ? cfn_parse.FromCloudFormation.getString(properties.VersionId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnHookDefaultVersion = class _CfnHookDefaultVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnHookDefaultVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnHookDefaultVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnHookDefaultVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnHookDefaultVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnHookDefaultVersion), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.typeName = props.typeName, this.typeVersionArn = props.typeVersionArn, this.versionId = props.versionId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnHookDefaultVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { typeName: this.typeName, typeVersionArn: this.typeVersionArn, versionId: this.versionId };
      }
      renderProperties(props) {
        return cfnHookDefaultVersionPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnHookDefaultVersion[_b] = { fqn: "aws-cdk-lib.CfnHookDefaultVersion", version: "2.80.0" }, CfnHookDefaultVersion.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::HookDefaultVersion", exports2.CfnHookDefaultVersion = CfnHookDefaultVersion;
    function CfnHookTypeConfigPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configuration", cdk.requiredValidator)(properties.configuration)), errors.collect(cdk.propertyValidator("configuration", cdk.validateString)(properties.configuration)), errors.collect(cdk.propertyValidator("configurationAlias", cdk.validateString)(properties.configurationAlias)), errors.collect(cdk.propertyValidator("typeArn", cdk.validateString)(properties.typeArn)), errors.collect(cdk.propertyValidator("typeName", cdk.validateString)(properties.typeName)), errors.wrap('supplied properties not correct for "CfnHookTypeConfigProps"');
    }
    function cfnHookTypeConfigPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHookTypeConfigPropsValidator(properties).assertSuccess(), { Configuration: cdk.stringToCloudFormation(properties.configuration), ConfigurationAlias: cdk.stringToCloudFormation(properties.configurationAlias), TypeArn: cdk.stringToCloudFormation(properties.typeArn), TypeName: cdk.stringToCloudFormation(properties.typeName) }) : properties;
    }
    function CfnHookTypeConfigPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configuration", "Configuration", cfn_parse.FromCloudFormation.getString(properties.Configuration)), ret.addPropertyResult("configurationAlias", "ConfigurationAlias", properties.ConfigurationAlias != null ? cfn_parse.FromCloudFormation.getString(properties.ConfigurationAlias) : void 0), ret.addPropertyResult("typeArn", "TypeArn", properties.TypeArn != null ? cfn_parse.FromCloudFormation.getString(properties.TypeArn) : void 0), ret.addPropertyResult("typeName", "TypeName", properties.TypeName != null ? cfn_parse.FromCloudFormation.getString(properties.TypeName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnHookTypeConfig = class _CfnHookTypeConfig extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnHookTypeConfigPropsFromCloudFormation(resourceProperties), ret = new _CfnHookTypeConfig(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnHookTypeConfig.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnHookTypeConfigProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnHookTypeConfig), error;
        }
        cdk.requireProperty(props, "configuration", this), this.attrConfigurationArn = cdk.Token.asString(this.getAtt("ConfigurationArn", cdk.ResolutionTypeHint.STRING)), this.configuration = props.configuration, this.configurationAlias = props.configurationAlias, this.typeArn = props.typeArn, this.typeName = props.typeName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnHookTypeConfig.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { configuration: this.configuration, configurationAlias: this.configurationAlias, typeArn: this.typeArn, typeName: this.typeName };
      }
      renderProperties(props) {
        return cfnHookTypeConfigPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnHookTypeConfig[_c] = { fqn: "aws-cdk-lib.CfnHookTypeConfig", version: "2.80.0" }, CfnHookTypeConfig.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::HookTypeConfig", exports2.CfnHookTypeConfig = CfnHookTypeConfig;
    function CfnHookVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("executionRoleArn", cdk.validateString)(properties.executionRoleArn)), errors.collect(cdk.propertyValidator("loggingConfig", CfnHookVersion_LoggingConfigPropertyValidator)(properties.loggingConfig)), errors.collect(cdk.propertyValidator("schemaHandlerPackage", cdk.requiredValidator)(properties.schemaHandlerPackage)), errors.collect(cdk.propertyValidator("schemaHandlerPackage", cdk.validateString)(properties.schemaHandlerPackage)), errors.collect(cdk.propertyValidator("typeName", cdk.requiredValidator)(properties.typeName)), errors.collect(cdk.propertyValidator("typeName", cdk.validateString)(properties.typeName)), errors.wrap('supplied properties not correct for "CfnHookVersionProps"');
    }
    function cfnHookVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHookVersionPropsValidator(properties).assertSuccess(), { SchemaHandlerPackage: cdk.stringToCloudFormation(properties.schemaHandlerPackage), TypeName: cdk.stringToCloudFormation(properties.typeName), ExecutionRoleArn: cdk.stringToCloudFormation(properties.executionRoleArn), LoggingConfig: cfnHookVersionLoggingConfigPropertyToCloudFormation(properties.loggingConfig) }) : properties;
    }
    function CfnHookVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("schemaHandlerPackage", "SchemaHandlerPackage", cfn_parse.FromCloudFormation.getString(properties.SchemaHandlerPackage)), ret.addPropertyResult("typeName", "TypeName", cfn_parse.FromCloudFormation.getString(properties.TypeName)), ret.addPropertyResult("executionRoleArn", "ExecutionRoleArn", properties.ExecutionRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.ExecutionRoleArn) : void 0), ret.addPropertyResult("loggingConfig", "LoggingConfig", properties.LoggingConfig != null ? CfnHookVersionLoggingConfigPropertyFromCloudFormation(properties.LoggingConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnHookVersion = class _CfnHookVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnHookVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnHookVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnHookVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnHookVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnHookVersion), error;
        }
        cdk.requireProperty(props, "schemaHandlerPackage", this), cdk.requireProperty(props, "typeName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrIsDefaultVersion = this.getAtt("IsDefaultVersion", cdk.ResolutionTypeHint.STRING), this.attrTypeArn = cdk.Token.asString(this.getAtt("TypeArn", cdk.ResolutionTypeHint.STRING)), this.attrVersionId = cdk.Token.asString(this.getAtt("VersionId", cdk.ResolutionTypeHint.STRING)), this.attrVisibility = cdk.Token.asString(this.getAtt("Visibility", cdk.ResolutionTypeHint.STRING)), this.schemaHandlerPackage = props.schemaHandlerPackage, this.typeName = props.typeName, this.executionRoleArn = props.executionRoleArn, this.loggingConfig = props.loggingConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnHookVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { schemaHandlerPackage: this.schemaHandlerPackage, typeName: this.typeName, executionRoleArn: this.executionRoleArn, loggingConfig: this.loggingConfig };
      }
      renderProperties(props) {
        return cfnHookVersionPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnHookVersion[_d] = { fqn: "aws-cdk-lib.CfnHookVersion", version: "2.80.0" }, CfnHookVersion.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::HookVersion", exports2.CfnHookVersion = CfnHookVersion;
    function CfnHookVersion_LoggingConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logGroupName", cdk.validateString)(properties.logGroupName)), errors.collect(cdk.propertyValidator("logRoleArn", cdk.validateString)(properties.logRoleArn)), errors.wrap('supplied properties not correct for "LoggingConfigProperty"');
    }
    function cfnHookVersionLoggingConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHookVersion_LoggingConfigPropertyValidator(properties).assertSuccess(), { LogGroupName: cdk.stringToCloudFormation(properties.logGroupName), LogRoleArn: cdk.stringToCloudFormation(properties.logRoleArn) }) : properties;
    }
    function CfnHookVersionLoggingConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logGroupName", "LogGroupName", properties.LogGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.LogGroupName) : void 0), ret.addPropertyResult("logRoleArn", "LogRoleArn", properties.LogRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.LogRoleArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMacroPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("functionName", cdk.requiredValidator)(properties.functionName)), errors.collect(cdk.propertyValidator("functionName", cdk.validateString)(properties.functionName)), errors.collect(cdk.propertyValidator("logGroupName", cdk.validateString)(properties.logGroupName)), errors.collect(cdk.propertyValidator("logRoleArn", cdk.validateString)(properties.logRoleArn)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "CfnMacroProps"');
    }
    function cfnMacroPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMacroPropsValidator(properties).assertSuccess(), { FunctionName: cdk.stringToCloudFormation(properties.functionName), Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), LogGroupName: cdk.stringToCloudFormation(properties.logGroupName), LogRoleARN: cdk.stringToCloudFormation(properties.logRoleArn) }) : properties;
    }
    function CfnMacroPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("functionName", "FunctionName", cfn_parse.FromCloudFormation.getString(properties.FunctionName)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("logGroupName", "LogGroupName", properties.LogGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.LogGroupName) : void 0), ret.addPropertyResult("logRoleArn", "LogRoleARN", properties.LogRoleARN != null ? cfn_parse.FromCloudFormation.getString(properties.LogRoleARN) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnMacro = class _CfnMacro extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnMacroPropsFromCloudFormation(resourceProperties), ret = new _CfnMacro(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnMacro.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnMacroProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnMacro), error;
        }
        cdk.requireProperty(props, "functionName", this), cdk.requireProperty(props, "name", this), this.functionName = props.functionName, this.name = props.name, this.description = props.description, this.logGroupName = props.logGroupName, this.logRoleArn = props.logRoleArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnMacro.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { functionName: this.functionName, name: this.name, description: this.description, logGroupName: this.logGroupName, logRoleArn: this.logRoleArn };
      }
      renderProperties(props) {
        return cfnMacroPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnMacro[_e] = { fqn: "aws-cdk-lib.CfnMacro", version: "2.80.0" }, CfnMacro.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::Macro", exports2.CfnMacro = CfnMacro;
    function CfnModuleDefaultVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("moduleName", cdk.validateString)(properties.moduleName)), errors.collect(cdk.propertyValidator("versionId", cdk.validateString)(properties.versionId)), errors.wrap('supplied properties not correct for "CfnModuleDefaultVersionProps"');
    }
    function cfnModuleDefaultVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModuleDefaultVersionPropsValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn), ModuleName: cdk.stringToCloudFormation(properties.moduleName), VersionId: cdk.stringToCloudFormation(properties.versionId) }) : properties;
    }
    function CfnModuleDefaultVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", properties.Arn != null ? cfn_parse.FromCloudFormation.getString(properties.Arn) : void 0), ret.addPropertyResult("moduleName", "ModuleName", properties.ModuleName != null ? cfn_parse.FromCloudFormation.getString(properties.ModuleName) : void 0), ret.addPropertyResult("versionId", "VersionId", properties.VersionId != null ? cfn_parse.FromCloudFormation.getString(properties.VersionId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnModuleDefaultVersion = class _CfnModuleDefaultVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnModuleDefaultVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnModuleDefaultVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnModuleDefaultVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnModuleDefaultVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnModuleDefaultVersion), error;
        }
        this.arn = props.arn, this.moduleName = props.moduleName, this.versionId = props.versionId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnModuleDefaultVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { arn: this.arn, moduleName: this.moduleName, versionId: this.versionId };
      }
      renderProperties(props) {
        return cfnModuleDefaultVersionPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnModuleDefaultVersion[_f] = { fqn: "aws-cdk-lib.CfnModuleDefaultVersion", version: "2.80.0" }, CfnModuleDefaultVersion.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::ModuleDefaultVersion", exports2.CfnModuleDefaultVersion = CfnModuleDefaultVersion;
    function CfnModuleVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("moduleName", cdk.requiredValidator)(properties.moduleName)), errors.collect(cdk.propertyValidator("moduleName", cdk.validateString)(properties.moduleName)), errors.collect(cdk.propertyValidator("modulePackage", cdk.requiredValidator)(properties.modulePackage)), errors.collect(cdk.propertyValidator("modulePackage", cdk.validateString)(properties.modulePackage)), errors.wrap('supplied properties not correct for "CfnModuleVersionProps"');
    }
    function cfnModuleVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModuleVersionPropsValidator(properties).assertSuccess(), { ModuleName: cdk.stringToCloudFormation(properties.moduleName), ModulePackage: cdk.stringToCloudFormation(properties.modulePackage) }) : properties;
    }
    function CfnModuleVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("moduleName", "ModuleName", cfn_parse.FromCloudFormation.getString(properties.ModuleName)), ret.addPropertyResult("modulePackage", "ModulePackage", cfn_parse.FromCloudFormation.getString(properties.ModulePackage)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnModuleVersion = class _CfnModuleVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnModuleVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnModuleVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnModuleVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnModuleVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnModuleVersion), error;
        }
        cdk.requireProperty(props, "moduleName", this), cdk.requireProperty(props, "modulePackage", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrDescription = cdk.Token.asString(this.getAtt("Description", cdk.ResolutionTypeHint.STRING)), this.attrDocumentationUrl = cdk.Token.asString(this.getAtt("DocumentationUrl", cdk.ResolutionTypeHint.STRING)), this.attrIsDefaultVersion = this.getAtt("IsDefaultVersion", cdk.ResolutionTypeHint.STRING), this.attrSchema = cdk.Token.asString(this.getAtt("Schema", cdk.ResolutionTypeHint.STRING)), this.attrTimeCreated = cdk.Token.asString(this.getAtt("TimeCreated", cdk.ResolutionTypeHint.STRING)), this.attrVersionId = cdk.Token.asString(this.getAtt("VersionId", cdk.ResolutionTypeHint.STRING)), this.attrVisibility = cdk.Token.asString(this.getAtt("Visibility", cdk.ResolutionTypeHint.STRING)), this.moduleName = props.moduleName, this.modulePackage = props.modulePackage;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnModuleVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { moduleName: this.moduleName, modulePackage: this.modulePackage };
      }
      renderProperties(props) {
        return cfnModuleVersionPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnModuleVersion[_g] = { fqn: "aws-cdk-lib.CfnModuleVersion", version: "2.80.0" }, CfnModuleVersion.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::ModuleVersion", exports2.CfnModuleVersion = CfnModuleVersion;
    function CfnPublicTypeVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("logDeliveryBucket", cdk.validateString)(properties.logDeliveryBucket)), errors.collect(cdk.propertyValidator("publicVersionNumber", cdk.validateString)(properties.publicVersionNumber)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("typeName", cdk.validateString)(properties.typeName)), errors.wrap('supplied properties not correct for "CfnPublicTypeVersionProps"');
    }
    function cfnPublicTypeVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPublicTypeVersionPropsValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn), LogDeliveryBucket: cdk.stringToCloudFormation(properties.logDeliveryBucket), PublicVersionNumber: cdk.stringToCloudFormation(properties.publicVersionNumber), Type: cdk.stringToCloudFormation(properties.type), TypeName: cdk.stringToCloudFormation(properties.typeName) }) : properties;
    }
    function CfnPublicTypeVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", properties.Arn != null ? cfn_parse.FromCloudFormation.getString(properties.Arn) : void 0), ret.addPropertyResult("logDeliveryBucket", "LogDeliveryBucket", properties.LogDeliveryBucket != null ? cfn_parse.FromCloudFormation.getString(properties.LogDeliveryBucket) : void 0), ret.addPropertyResult("publicVersionNumber", "PublicVersionNumber", properties.PublicVersionNumber != null ? cfn_parse.FromCloudFormation.getString(properties.PublicVersionNumber) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addPropertyResult("typeName", "TypeName", properties.TypeName != null ? cfn_parse.FromCloudFormation.getString(properties.TypeName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPublicTypeVersion = class _CfnPublicTypeVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPublicTypeVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnPublicTypeVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnPublicTypeVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnPublicTypeVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPublicTypeVersion), error;
        }
        this.attrPublicTypeArn = cdk.Token.asString(this.getAtt("PublicTypeArn", cdk.ResolutionTypeHint.STRING)), this.attrPublisherId = cdk.Token.asString(this.getAtt("PublisherId", cdk.ResolutionTypeHint.STRING)), this.attrTypeVersionArn = cdk.Token.asString(this.getAtt("TypeVersionArn", cdk.ResolutionTypeHint.STRING)), this.arn = props.arn, this.logDeliveryBucket = props.logDeliveryBucket, this.publicVersionNumber = props.publicVersionNumber, this.type = props.type, this.typeName = props.typeName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPublicTypeVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { arn: this.arn, logDeliveryBucket: this.logDeliveryBucket, publicVersionNumber: this.publicVersionNumber, type: this.type, typeName: this.typeName };
      }
      renderProperties(props) {
        return cfnPublicTypeVersionPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnPublicTypeVersion[_h] = { fqn: "aws-cdk-lib.CfnPublicTypeVersion", version: "2.80.0" }, CfnPublicTypeVersion.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::PublicTypeVersion", exports2.CfnPublicTypeVersion = CfnPublicTypeVersion;
    function CfnPublisherPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acceptTermsAndConditions", cdk.requiredValidator)(properties.acceptTermsAndConditions)), errors.collect(cdk.propertyValidator("acceptTermsAndConditions", cdk.validateBoolean)(properties.acceptTermsAndConditions)), errors.collect(cdk.propertyValidator("connectionArn", cdk.validateString)(properties.connectionArn)), errors.wrap('supplied properties not correct for "CfnPublisherProps"');
    }
    function cfnPublisherPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPublisherPropsValidator(properties).assertSuccess(), { AcceptTermsAndConditions: cdk.booleanToCloudFormation(properties.acceptTermsAndConditions), ConnectionArn: cdk.stringToCloudFormation(properties.connectionArn) }) : properties;
    }
    function CfnPublisherPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("acceptTermsAndConditions", "AcceptTermsAndConditions", cfn_parse.FromCloudFormation.getBoolean(properties.AcceptTermsAndConditions)), ret.addPropertyResult("connectionArn", "ConnectionArn", properties.ConnectionArn != null ? cfn_parse.FromCloudFormation.getString(properties.ConnectionArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPublisher = class _CfnPublisher extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPublisherPropsFromCloudFormation(resourceProperties), ret = new _CfnPublisher(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPublisher.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnPublisherProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPublisher), error;
        }
        cdk.requireProperty(props, "acceptTermsAndConditions", this), this.attrIdentityProvider = cdk.Token.asString(this.getAtt("IdentityProvider", cdk.ResolutionTypeHint.STRING)), this.attrPublisherId = cdk.Token.asString(this.getAtt("PublisherId", cdk.ResolutionTypeHint.STRING)), this.attrPublisherProfile = cdk.Token.asString(this.getAtt("PublisherProfile", cdk.ResolutionTypeHint.STRING)), this.attrPublisherStatus = cdk.Token.asString(this.getAtt("PublisherStatus", cdk.ResolutionTypeHint.STRING)), this.acceptTermsAndConditions = props.acceptTermsAndConditions, this.connectionArn = props.connectionArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPublisher.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { acceptTermsAndConditions: this.acceptTermsAndConditions, connectionArn: this.connectionArn };
      }
      renderProperties(props) {
        return cfnPublisherPropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnPublisher[_j] = { fqn: "aws-cdk-lib.CfnPublisher", version: "2.80.0" }, CfnPublisher.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::Publisher", exports2.CfnPublisher = CfnPublisher;
    function CfnResourceDefaultVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("typeName", cdk.validateString)(properties.typeName)), errors.collect(cdk.propertyValidator("typeVersionArn", cdk.validateString)(properties.typeVersionArn)), errors.collect(cdk.propertyValidator("versionId", cdk.validateString)(properties.versionId)), errors.wrap('supplied properties not correct for "CfnResourceDefaultVersionProps"');
    }
    function cfnResourceDefaultVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceDefaultVersionPropsValidator(properties).assertSuccess(), { TypeName: cdk.stringToCloudFormation(properties.typeName), TypeVersionArn: cdk.stringToCloudFormation(properties.typeVersionArn), VersionId: cdk.stringToCloudFormation(properties.versionId) }) : properties;
    }
    function CfnResourceDefaultVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("typeName", "TypeName", properties.TypeName != null ? cfn_parse.FromCloudFormation.getString(properties.TypeName) : void 0), ret.addPropertyResult("typeVersionArn", "TypeVersionArn", properties.TypeVersionArn != null ? cfn_parse.FromCloudFormation.getString(properties.TypeVersionArn) : void 0), ret.addPropertyResult("versionId", "VersionId", properties.VersionId != null ? cfn_parse.FromCloudFormation.getString(properties.VersionId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResourceDefaultVersion = class _CfnResourceDefaultVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResourceDefaultVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnResourceDefaultVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnResourceDefaultVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnResourceDefaultVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResourceDefaultVersion), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.typeName = props.typeName, this.typeVersionArn = props.typeVersionArn, this.versionId = props.versionId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResourceDefaultVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { typeName: this.typeName, typeVersionArn: this.typeVersionArn, versionId: this.versionId };
      }
      renderProperties(props) {
        return cfnResourceDefaultVersionPropsToCloudFormation(props);
      }
    };
    _k = JSII_RTTI_SYMBOL_1, CfnResourceDefaultVersion[_k] = { fqn: "aws-cdk-lib.CfnResourceDefaultVersion", version: "2.80.0" }, CfnResourceDefaultVersion.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::ResourceDefaultVersion", exports2.CfnResourceDefaultVersion = CfnResourceDefaultVersion;
    function CfnResourceVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("executionRoleArn", cdk.validateString)(properties.executionRoleArn)), errors.collect(cdk.propertyValidator("loggingConfig", CfnResourceVersion_LoggingConfigPropertyValidator)(properties.loggingConfig)), errors.collect(cdk.propertyValidator("schemaHandlerPackage", cdk.requiredValidator)(properties.schemaHandlerPackage)), errors.collect(cdk.propertyValidator("schemaHandlerPackage", cdk.validateString)(properties.schemaHandlerPackage)), errors.collect(cdk.propertyValidator("typeName", cdk.requiredValidator)(properties.typeName)), errors.collect(cdk.propertyValidator("typeName", cdk.validateString)(properties.typeName)), errors.wrap('supplied properties not correct for "CfnResourceVersionProps"');
    }
    function cfnResourceVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceVersionPropsValidator(properties).assertSuccess(), { SchemaHandlerPackage: cdk.stringToCloudFormation(properties.schemaHandlerPackage), TypeName: cdk.stringToCloudFormation(properties.typeName), ExecutionRoleArn: cdk.stringToCloudFormation(properties.executionRoleArn), LoggingConfig: cfnResourceVersionLoggingConfigPropertyToCloudFormation(properties.loggingConfig) }) : properties;
    }
    function CfnResourceVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("schemaHandlerPackage", "SchemaHandlerPackage", cfn_parse.FromCloudFormation.getString(properties.SchemaHandlerPackage)), ret.addPropertyResult("typeName", "TypeName", cfn_parse.FromCloudFormation.getString(properties.TypeName)), ret.addPropertyResult("executionRoleArn", "ExecutionRoleArn", properties.ExecutionRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.ExecutionRoleArn) : void 0), ret.addPropertyResult("loggingConfig", "LoggingConfig", properties.LoggingConfig != null ? CfnResourceVersionLoggingConfigPropertyFromCloudFormation(properties.LoggingConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResourceVersion = class _CfnResourceVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResourceVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnResourceVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnResourceVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnResourceVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResourceVersion), error;
        }
        cdk.requireProperty(props, "schemaHandlerPackage", this), cdk.requireProperty(props, "typeName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrIsDefaultVersion = this.getAtt("IsDefaultVersion", cdk.ResolutionTypeHint.STRING), this.attrProvisioningType = cdk.Token.asString(this.getAtt("ProvisioningType", cdk.ResolutionTypeHint.STRING)), this.attrTypeArn = cdk.Token.asString(this.getAtt("TypeArn", cdk.ResolutionTypeHint.STRING)), this.attrVersionId = cdk.Token.asString(this.getAtt("VersionId", cdk.ResolutionTypeHint.STRING)), this.attrVisibility = cdk.Token.asString(this.getAtt("Visibility", cdk.ResolutionTypeHint.STRING)), this.schemaHandlerPackage = props.schemaHandlerPackage, this.typeName = props.typeName, this.executionRoleArn = props.executionRoleArn, this.loggingConfig = props.loggingConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResourceVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { schemaHandlerPackage: this.schemaHandlerPackage, typeName: this.typeName, executionRoleArn: this.executionRoleArn, loggingConfig: this.loggingConfig };
      }
      renderProperties(props) {
        return cfnResourceVersionPropsToCloudFormation(props);
      }
    };
    _l = JSII_RTTI_SYMBOL_1, CfnResourceVersion[_l] = { fqn: "aws-cdk-lib.CfnResourceVersion", version: "2.80.0" }, CfnResourceVersion.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::ResourceVersion", exports2.CfnResourceVersion = CfnResourceVersion;
    function CfnResourceVersion_LoggingConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logGroupName", cdk.validateString)(properties.logGroupName)), errors.collect(cdk.propertyValidator("logRoleArn", cdk.validateString)(properties.logRoleArn)), errors.wrap('supplied properties not correct for "LoggingConfigProperty"');
    }
    function cfnResourceVersionLoggingConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceVersion_LoggingConfigPropertyValidator(properties).assertSuccess(), { LogGroupName: cdk.stringToCloudFormation(properties.logGroupName), LogRoleArn: cdk.stringToCloudFormation(properties.logRoleArn) }) : properties;
    }
    function CfnResourceVersionLoggingConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logGroupName", "LogGroupName", properties.LogGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.LogGroupName) : void 0), ret.addPropertyResult("logRoleArn", "LogRoleArn", properties.LogRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.LogRoleArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStackPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("notificationArns", cdk.listValidator(cdk.validateString))(properties.notificationArns)), errors.collect(cdk.propertyValidator("parameters", cdk.hashValidator(cdk.validateString))(properties.parameters)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("templateUrl", cdk.requiredValidator)(properties.templateUrl)), errors.collect(cdk.propertyValidator("templateUrl", cdk.validateString)(properties.templateUrl)), errors.collect(cdk.propertyValidator("timeoutInMinutes", cdk.validateNumber)(properties.timeoutInMinutes)), errors.wrap('supplied properties not correct for "CfnStackProps"');
    }
    function cfnStackPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStackPropsValidator(properties).assertSuccess(), { TemplateURL: cdk.stringToCloudFormation(properties.templateUrl), NotificationARNs: cdk.listMapper(cdk.stringToCloudFormation)(properties.notificationArns), Parameters: cdk.hashMapper(cdk.stringToCloudFormation)(properties.parameters), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TimeoutInMinutes: cdk.numberToCloudFormation(properties.timeoutInMinutes) }) : properties;
    }
    function CfnStackPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("templateUrl", "TemplateURL", cfn_parse.FromCloudFormation.getString(properties.TemplateURL)), ret.addPropertyResult("notificationArns", "NotificationARNs", properties.NotificationARNs != null ? cfn_parse.FromCloudFormation.getStringArray(properties.NotificationARNs) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Parameters) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("timeoutInMinutes", "TimeoutInMinutes", properties.TimeoutInMinutes != null ? cfn_parse.FromCloudFormation.getNumber(properties.TimeoutInMinutes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnStack = class _CfnStack extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnStackPropsFromCloudFormation(resourceProperties), ret = new _CfnStack(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnStack.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnStackProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnStack), error;
        }
        cdk.requireProperty(props, "templateUrl", this), this.templateUrl = props.templateUrl, this.notificationArns = props.notificationArns, this.parameters = props.parameters, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::CloudFormation::Stack", props.tags, { tagPropertyName: "tags" }), this.timeoutInMinutes = props.timeoutInMinutes, this.node.scope && cdk.Resource.isResource(this.node.scope) && this.node.addValidation({ validate: () => this.cfnOptions.deletionPolicy === void 0 ? ["'AWS::CloudFormation::Stack' is a stateful resource type, and you must specify a Removal Policy for it. Call 'resource.applyRemovalPolicy()'."] : [] });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStack.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { templateUrl: this.templateUrl, notificationArns: this.notificationArns, parameters: this.parameters, tags: this.tags.renderTags(), timeoutInMinutes: this.timeoutInMinutes };
      }
      renderProperties(props) {
        return cfnStackPropsToCloudFormation(props);
      }
    };
    _m = JSII_RTTI_SYMBOL_1, CfnStack[_m] = { fqn: "aws-cdk-lib.CfnStack", version: "2.80.0" }, CfnStack.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::Stack", exports2.CfnStack = CfnStack;
    function CfnStackSetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("administrationRoleArn", cdk.validateString)(properties.administrationRoleArn)), errors.collect(cdk.propertyValidator("autoDeployment", CfnStackSet_AutoDeploymentPropertyValidator)(properties.autoDeployment)), errors.collect(cdk.propertyValidator("callAs", cdk.validateString)(properties.callAs)), errors.collect(cdk.propertyValidator("capabilities", cdk.listValidator(cdk.validateString))(properties.capabilities)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("executionRoleName", cdk.validateString)(properties.executionRoleName)), errors.collect(cdk.propertyValidator("managedExecution", cdk.validateObject)(properties.managedExecution)), errors.collect(cdk.propertyValidator("operationPreferences", CfnStackSet_OperationPreferencesPropertyValidator)(properties.operationPreferences)), errors.collect(cdk.propertyValidator("parameters", cdk.listValidator(CfnStackSet_ParameterPropertyValidator))(properties.parameters)), errors.collect(cdk.propertyValidator("permissionModel", cdk.requiredValidator)(properties.permissionModel)), errors.collect(cdk.propertyValidator("permissionModel", cdk.validateString)(properties.permissionModel)), errors.collect(cdk.propertyValidator("stackInstancesGroup", cdk.listValidator(CfnStackSet_StackInstancesPropertyValidator))(properties.stackInstancesGroup)), errors.collect(cdk.propertyValidator("stackSetName", cdk.requiredValidator)(properties.stackSetName)), errors.collect(cdk.propertyValidator("stackSetName", cdk.validateString)(properties.stackSetName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("templateBody", cdk.validateString)(properties.templateBody)), errors.collect(cdk.propertyValidator("templateUrl", cdk.validateString)(properties.templateUrl)), errors.wrap('supplied properties not correct for "CfnStackSetProps"');
    }
    function cfnStackSetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStackSetPropsValidator(properties).assertSuccess(), { PermissionModel: cdk.stringToCloudFormation(properties.permissionModel), StackSetName: cdk.stringToCloudFormation(properties.stackSetName), AdministrationRoleARN: cdk.stringToCloudFormation(properties.administrationRoleArn), AutoDeployment: cfnStackSetAutoDeploymentPropertyToCloudFormation(properties.autoDeployment), CallAs: cdk.stringToCloudFormation(properties.callAs), Capabilities: cdk.listMapper(cdk.stringToCloudFormation)(properties.capabilities), Description: cdk.stringToCloudFormation(properties.description), ExecutionRoleName: cdk.stringToCloudFormation(properties.executionRoleName), ManagedExecution: cdk.objectToCloudFormation(properties.managedExecution), OperationPreferences: cfnStackSetOperationPreferencesPropertyToCloudFormation(properties.operationPreferences), Parameters: cdk.listMapper(cfnStackSetParameterPropertyToCloudFormation)(properties.parameters), StackInstancesGroup: cdk.listMapper(cfnStackSetStackInstancesPropertyToCloudFormation)(properties.stackInstancesGroup), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TemplateBody: cdk.stringToCloudFormation(properties.templateBody), TemplateURL: cdk.stringToCloudFormation(properties.templateUrl) }) : properties;
    }
    function CfnStackSetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("permissionModel", "PermissionModel", cfn_parse.FromCloudFormation.getString(properties.PermissionModel)), ret.addPropertyResult("stackSetName", "StackSetName", cfn_parse.FromCloudFormation.getString(properties.StackSetName)), ret.addPropertyResult("administrationRoleArn", "AdministrationRoleARN", properties.AdministrationRoleARN != null ? cfn_parse.FromCloudFormation.getString(properties.AdministrationRoleARN) : void 0), ret.addPropertyResult("autoDeployment", "AutoDeployment", properties.AutoDeployment != null ? CfnStackSetAutoDeploymentPropertyFromCloudFormation(properties.AutoDeployment) : void 0), ret.addPropertyResult("callAs", "CallAs", properties.CallAs != null ? cfn_parse.FromCloudFormation.getString(properties.CallAs) : void 0), ret.addPropertyResult("capabilities", "Capabilities", properties.Capabilities != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Capabilities) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("executionRoleName", "ExecutionRoleName", properties.ExecutionRoleName != null ? cfn_parse.FromCloudFormation.getString(properties.ExecutionRoleName) : void 0), ret.addPropertyResult("managedExecution", "ManagedExecution", properties.ManagedExecution != null ? cfn_parse.FromCloudFormation.getAny(properties.ManagedExecution) : void 0), ret.addPropertyResult("operationPreferences", "OperationPreferences", properties.OperationPreferences != null ? CfnStackSetOperationPreferencesPropertyFromCloudFormation(properties.OperationPreferences) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getArray(CfnStackSetParameterPropertyFromCloudFormation)(properties.Parameters) : void 0), ret.addPropertyResult("stackInstancesGroup", "StackInstancesGroup", properties.StackInstancesGroup != null ? cfn_parse.FromCloudFormation.getArray(CfnStackSetStackInstancesPropertyFromCloudFormation)(properties.StackInstancesGroup) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("templateBody", "TemplateBody", properties.TemplateBody != null ? cfn_parse.FromCloudFormation.getString(properties.TemplateBody) : void 0), ret.addPropertyResult("templateUrl", "TemplateURL", properties.TemplateURL != null ? cfn_parse.FromCloudFormation.getString(properties.TemplateURL) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnStackSet = class _CfnStackSet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnStackSetPropsFromCloudFormation(resourceProperties), ret = new _CfnStackSet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnStackSet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnStackSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnStackSet), error;
        }
        cdk.requireProperty(props, "permissionModel", this), cdk.requireProperty(props, "stackSetName", this), this.attrStackSetId = cdk.Token.asString(this.getAtt("StackSetId", cdk.ResolutionTypeHint.STRING)), this.permissionModel = props.permissionModel, this.stackSetName = props.stackSetName, this.administrationRoleArn = props.administrationRoleArn, this.autoDeployment = props.autoDeployment, this.callAs = props.callAs, this.capabilities = props.capabilities, this.description = props.description, this.executionRoleName = props.executionRoleName, this.managedExecution = props.managedExecution, this.operationPreferences = props.operationPreferences, this.parameters = props.parameters, this.stackInstancesGroup = props.stackInstancesGroup, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::CloudFormation::StackSet", props.tags, { tagPropertyName: "tags" }), this.templateBody = props.templateBody, this.templateUrl = props.templateUrl;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStackSet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { permissionModel: this.permissionModel, stackSetName: this.stackSetName, administrationRoleArn: this.administrationRoleArn, autoDeployment: this.autoDeployment, callAs: this.callAs, capabilities: this.capabilities, description: this.description, executionRoleName: this.executionRoleName, managedExecution: this.managedExecution, operationPreferences: this.operationPreferences, parameters: this.parameters, stackInstancesGroup: this.stackInstancesGroup, tags: this.tags.renderTags(), templateBody: this.templateBody, templateUrl: this.templateUrl };
      }
      renderProperties(props) {
        return cfnStackSetPropsToCloudFormation(props);
      }
    };
    _o = JSII_RTTI_SYMBOL_1, CfnStackSet[_o] = { fqn: "aws-cdk-lib.CfnStackSet", version: "2.80.0" }, CfnStackSet.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::StackSet", exports2.CfnStackSet = CfnStackSet;
    function CfnStackSet_AutoDeploymentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("retainStacksOnAccountRemoval", cdk.validateBoolean)(properties.retainStacksOnAccountRemoval)), errors.wrap('supplied properties not correct for "AutoDeploymentProperty"');
    }
    function cfnStackSetAutoDeploymentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStackSet_AutoDeploymentPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled), RetainStacksOnAccountRemoval: cdk.booleanToCloudFormation(properties.retainStacksOnAccountRemoval) }) : properties;
    }
    function CfnStackSetAutoDeploymentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("retainStacksOnAccountRemoval", "RetainStacksOnAccountRemoval", properties.RetainStacksOnAccountRemoval != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RetainStacksOnAccountRemoval) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStackSet_DeploymentTargetsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accountFilterType", cdk.validateString)(properties.accountFilterType)), errors.collect(cdk.propertyValidator("accounts", cdk.listValidator(cdk.validateString))(properties.accounts)), errors.collect(cdk.propertyValidator("organizationalUnitIds", cdk.listValidator(cdk.validateString))(properties.organizationalUnitIds)), errors.wrap('supplied properties not correct for "DeploymentTargetsProperty"');
    }
    function cfnStackSetDeploymentTargetsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStackSet_DeploymentTargetsPropertyValidator(properties).assertSuccess(), { AccountFilterType: cdk.stringToCloudFormation(properties.accountFilterType), Accounts: cdk.listMapper(cdk.stringToCloudFormation)(properties.accounts), OrganizationalUnitIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.organizationalUnitIds) }) : properties;
    }
    function CfnStackSetDeploymentTargetsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accountFilterType", "AccountFilterType", properties.AccountFilterType != null ? cfn_parse.FromCloudFormation.getString(properties.AccountFilterType) : void 0), ret.addPropertyResult("accounts", "Accounts", properties.Accounts != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Accounts) : void 0), ret.addPropertyResult("organizationalUnitIds", "OrganizationalUnitIds", properties.OrganizationalUnitIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.OrganizationalUnitIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStackSet_OperationPreferencesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("failureToleranceCount", cdk.validateNumber)(properties.failureToleranceCount)), errors.collect(cdk.propertyValidator("failureTolerancePercentage", cdk.validateNumber)(properties.failureTolerancePercentage)), errors.collect(cdk.propertyValidator("maxConcurrentCount", cdk.validateNumber)(properties.maxConcurrentCount)), errors.collect(cdk.propertyValidator("maxConcurrentPercentage", cdk.validateNumber)(properties.maxConcurrentPercentage)), errors.collect(cdk.propertyValidator("regionConcurrencyType", cdk.validateString)(properties.regionConcurrencyType)), errors.collect(cdk.propertyValidator("regionOrder", cdk.listValidator(cdk.validateString))(properties.regionOrder)), errors.wrap('supplied properties not correct for "OperationPreferencesProperty"');
    }
    function cfnStackSetOperationPreferencesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStackSet_OperationPreferencesPropertyValidator(properties).assertSuccess(), { FailureToleranceCount: cdk.numberToCloudFormation(properties.failureToleranceCount), FailureTolerancePercentage: cdk.numberToCloudFormation(properties.failureTolerancePercentage), MaxConcurrentCount: cdk.numberToCloudFormation(properties.maxConcurrentCount), MaxConcurrentPercentage: cdk.numberToCloudFormation(properties.maxConcurrentPercentage), RegionConcurrencyType: cdk.stringToCloudFormation(properties.regionConcurrencyType), RegionOrder: cdk.listMapper(cdk.stringToCloudFormation)(properties.regionOrder) }) : properties;
    }
    function CfnStackSetOperationPreferencesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("failureToleranceCount", "FailureToleranceCount", properties.FailureToleranceCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.FailureToleranceCount) : void 0), ret.addPropertyResult("failureTolerancePercentage", "FailureTolerancePercentage", properties.FailureTolerancePercentage != null ? cfn_parse.FromCloudFormation.getNumber(properties.FailureTolerancePercentage) : void 0), ret.addPropertyResult("maxConcurrentCount", "MaxConcurrentCount", properties.MaxConcurrentCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxConcurrentCount) : void 0), ret.addPropertyResult("maxConcurrentPercentage", "MaxConcurrentPercentage", properties.MaxConcurrentPercentage != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxConcurrentPercentage) : void 0), ret.addPropertyResult("regionConcurrencyType", "RegionConcurrencyType", properties.RegionConcurrencyType != null ? cfn_parse.FromCloudFormation.getString(properties.RegionConcurrencyType) : void 0), ret.addPropertyResult("regionOrder", "RegionOrder", properties.RegionOrder != null ? cfn_parse.FromCloudFormation.getStringArray(properties.RegionOrder) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStackSet_ParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("parameterKey", cdk.requiredValidator)(properties.parameterKey)), errors.collect(cdk.propertyValidator("parameterKey", cdk.validateString)(properties.parameterKey)), errors.collect(cdk.propertyValidator("parameterValue", cdk.requiredValidator)(properties.parameterValue)), errors.collect(cdk.propertyValidator("parameterValue", cdk.validateString)(properties.parameterValue)), errors.wrap('supplied properties not correct for "ParameterProperty"');
    }
    function cfnStackSetParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStackSet_ParameterPropertyValidator(properties).assertSuccess(), { ParameterKey: cdk.stringToCloudFormation(properties.parameterKey), ParameterValue: cdk.stringToCloudFormation(properties.parameterValue) }) : properties;
    }
    function CfnStackSetParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("parameterKey", "ParameterKey", cfn_parse.FromCloudFormation.getString(properties.ParameterKey)), ret.addPropertyResult("parameterValue", "ParameterValue", cfn_parse.FromCloudFormation.getString(properties.ParameterValue)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStackSet_StackInstancesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deploymentTargets", cdk.requiredValidator)(properties.deploymentTargets)), errors.collect(cdk.propertyValidator("deploymentTargets", CfnStackSet_DeploymentTargetsPropertyValidator)(properties.deploymentTargets)), errors.collect(cdk.propertyValidator("parameterOverrides", cdk.listValidator(CfnStackSet_ParameterPropertyValidator))(properties.parameterOverrides)), errors.collect(cdk.propertyValidator("regions", cdk.requiredValidator)(properties.regions)), errors.collect(cdk.propertyValidator("regions", cdk.listValidator(cdk.validateString))(properties.regions)), errors.wrap('supplied properties not correct for "StackInstancesProperty"');
    }
    function cfnStackSetStackInstancesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStackSet_StackInstancesPropertyValidator(properties).assertSuccess(), { DeploymentTargets: cfnStackSetDeploymentTargetsPropertyToCloudFormation(properties.deploymentTargets), ParameterOverrides: cdk.listMapper(cfnStackSetParameterPropertyToCloudFormation)(properties.parameterOverrides), Regions: cdk.listMapper(cdk.stringToCloudFormation)(properties.regions) }) : properties;
    }
    function CfnStackSetStackInstancesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deploymentTargets", "DeploymentTargets", CfnStackSetDeploymentTargetsPropertyFromCloudFormation(properties.DeploymentTargets)), ret.addPropertyResult("parameterOverrides", "ParameterOverrides", properties.ParameterOverrides != null ? cfn_parse.FromCloudFormation.getArray(CfnStackSetParameterPropertyFromCloudFormation)(properties.ParameterOverrides) : void 0), ret.addPropertyResult("regions", "Regions", cfn_parse.FromCloudFormation.getStringArray(properties.Regions)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTypeActivationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoUpdate", cdk.validateBoolean)(properties.autoUpdate)), errors.collect(cdk.propertyValidator("executionRoleArn", cdk.validateString)(properties.executionRoleArn)), errors.collect(cdk.propertyValidator("loggingConfig", CfnTypeActivation_LoggingConfigPropertyValidator)(properties.loggingConfig)), errors.collect(cdk.propertyValidator("majorVersion", cdk.validateString)(properties.majorVersion)), errors.collect(cdk.propertyValidator("publicTypeArn", cdk.validateString)(properties.publicTypeArn)), errors.collect(cdk.propertyValidator("publisherId", cdk.validateString)(properties.publisherId)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("typeName", cdk.validateString)(properties.typeName)), errors.collect(cdk.propertyValidator("typeNameAlias", cdk.validateString)(properties.typeNameAlias)), errors.collect(cdk.propertyValidator("versionBump", cdk.validateString)(properties.versionBump)), errors.wrap('supplied properties not correct for "CfnTypeActivationProps"');
    }
    function cfnTypeActivationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTypeActivationPropsValidator(properties).assertSuccess(), { AutoUpdate: cdk.booleanToCloudFormation(properties.autoUpdate), ExecutionRoleArn: cdk.stringToCloudFormation(properties.executionRoleArn), LoggingConfig: cfnTypeActivationLoggingConfigPropertyToCloudFormation(properties.loggingConfig), MajorVersion: cdk.stringToCloudFormation(properties.majorVersion), PublicTypeArn: cdk.stringToCloudFormation(properties.publicTypeArn), PublisherId: cdk.stringToCloudFormation(properties.publisherId), Type: cdk.stringToCloudFormation(properties.type), TypeName: cdk.stringToCloudFormation(properties.typeName), TypeNameAlias: cdk.stringToCloudFormation(properties.typeNameAlias), VersionBump: cdk.stringToCloudFormation(properties.versionBump) }) : properties;
    }
    function CfnTypeActivationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("autoUpdate", "AutoUpdate", properties.AutoUpdate != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AutoUpdate) : void 0), ret.addPropertyResult("executionRoleArn", "ExecutionRoleArn", properties.ExecutionRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.ExecutionRoleArn) : void 0), ret.addPropertyResult("loggingConfig", "LoggingConfig", properties.LoggingConfig != null ? CfnTypeActivationLoggingConfigPropertyFromCloudFormation(properties.LoggingConfig) : void 0), ret.addPropertyResult("majorVersion", "MajorVersion", properties.MajorVersion != null ? cfn_parse.FromCloudFormation.getString(properties.MajorVersion) : void 0), ret.addPropertyResult("publicTypeArn", "PublicTypeArn", properties.PublicTypeArn != null ? cfn_parse.FromCloudFormation.getString(properties.PublicTypeArn) : void 0), ret.addPropertyResult("publisherId", "PublisherId", properties.PublisherId != null ? cfn_parse.FromCloudFormation.getString(properties.PublisherId) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addPropertyResult("typeName", "TypeName", properties.TypeName != null ? cfn_parse.FromCloudFormation.getString(properties.TypeName) : void 0), ret.addPropertyResult("typeNameAlias", "TypeNameAlias", properties.TypeNameAlias != null ? cfn_parse.FromCloudFormation.getString(properties.TypeNameAlias) : void 0), ret.addPropertyResult("versionBump", "VersionBump", properties.VersionBump != null ? cfn_parse.FromCloudFormation.getString(properties.VersionBump) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTypeActivation = class _CfnTypeActivation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTypeActivationPropsFromCloudFormation(resourceProperties), ret = new _CfnTypeActivation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnTypeActivation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnTypeActivationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTypeActivation), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.autoUpdate = props.autoUpdate, this.executionRoleArn = props.executionRoleArn, this.loggingConfig = props.loggingConfig, this.majorVersion = props.majorVersion, this.publicTypeArn = props.publicTypeArn, this.publisherId = props.publisherId, this.type = props.type, this.typeName = props.typeName, this.typeNameAlias = props.typeNameAlias, this.versionBump = props.versionBump;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTypeActivation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { autoUpdate: this.autoUpdate, executionRoleArn: this.executionRoleArn, loggingConfig: this.loggingConfig, majorVersion: this.majorVersion, publicTypeArn: this.publicTypeArn, publisherId: this.publisherId, type: this.type, typeName: this.typeName, typeNameAlias: this.typeNameAlias, versionBump: this.versionBump };
      }
      renderProperties(props) {
        return cfnTypeActivationPropsToCloudFormation(props);
      }
    };
    _p = JSII_RTTI_SYMBOL_1, CfnTypeActivation[_p] = { fqn: "aws-cdk-lib.CfnTypeActivation", version: "2.80.0" }, CfnTypeActivation.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::TypeActivation", exports2.CfnTypeActivation = CfnTypeActivation;
    function CfnTypeActivation_LoggingConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logGroupName", cdk.validateString)(properties.logGroupName)), errors.collect(cdk.propertyValidator("logRoleArn", cdk.validateString)(properties.logRoleArn)), errors.wrap('supplied properties not correct for "LoggingConfigProperty"');
    }
    function cfnTypeActivationLoggingConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTypeActivation_LoggingConfigPropertyValidator(properties).assertSuccess(), { LogGroupName: cdk.stringToCloudFormation(properties.logGroupName), LogRoleArn: cdk.stringToCloudFormation(properties.logRoleArn) }) : properties;
    }
    function CfnTypeActivationLoggingConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logGroupName", "LogGroupName", properties.LogGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.LogGroupName) : void 0), ret.addPropertyResult("logRoleArn", "LogRoleArn", properties.LogRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.LogRoleArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWaitConditionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("count", cdk.validateNumber)(properties.count)), errors.collect(cdk.propertyValidator("handle", cdk.validateString)(properties.handle)), errors.collect(cdk.propertyValidator("timeout", cdk.validateString)(properties.timeout)), errors.wrap('supplied properties not correct for "CfnWaitConditionProps"');
    }
    function cfnWaitConditionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWaitConditionPropsValidator(properties).assertSuccess(), { Count: cdk.numberToCloudFormation(properties.count), Handle: cdk.stringToCloudFormation(properties.handle), Timeout: cdk.stringToCloudFormation(properties.timeout) }) : properties;
    }
    function CfnWaitConditionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("count", "Count", properties.Count != null ? cfn_parse.FromCloudFormation.getNumber(properties.Count) : void 0), ret.addPropertyResult("handle", "Handle", properties.Handle != null ? cfn_parse.FromCloudFormation.getString(properties.Handle) : void 0), ret.addPropertyResult("timeout", "Timeout", properties.Timeout != null ? cfn_parse.FromCloudFormation.getString(properties.Timeout) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnWaitCondition = class _CfnWaitCondition extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnWaitConditionPropsFromCloudFormation(resourceProperties), ret = new _CfnWaitCondition(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnWaitCondition.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnWaitConditionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnWaitCondition), error;
        }
        this.attrData = this.getAtt("Data", cdk.ResolutionTypeHint.STRING), this.count = props.count, this.handle = props.handle, this.timeout = props.timeout;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnWaitCondition.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { count: this.count, handle: this.handle, timeout: this.timeout };
      }
      renderProperties(props) {
        return cfnWaitConditionPropsToCloudFormation(props);
      }
    };
    _q = JSII_RTTI_SYMBOL_1, CfnWaitCondition[_q] = { fqn: "aws-cdk-lib.CfnWaitCondition", version: "2.80.0" }, CfnWaitCondition.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::WaitCondition", exports2.CfnWaitCondition = CfnWaitCondition;
    var CfnWaitConditionHandle = class _CfnWaitConditionHandle extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const ret = new _CfnWaitConditionHandle(scope, id);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id) {
        super(scope, id, { type: _CfnWaitConditionHandle.CFN_RESOURCE_TYPE_NAME });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnWaitConditionHandle.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
    };
    _r = JSII_RTTI_SYMBOL_1, CfnWaitConditionHandle[_r] = { fqn: "aws-cdk-lib.CfnWaitConditionHandle", version: "2.80.0" }, CfnWaitConditionHandle.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::WaitConditionHandle", exports2.CfnWaitConditionHandle = CfnWaitConditionHandle;
  }
});

// node_modules/aws-cdk-lib/core/lib/nested-stack.js
var require_nested_stack = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/nested-stack.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.NestedStack = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var crypto = require("crypto");
    var constructs_1 = require_lib2();
    var assets_1 = require_assets3();
    var cfn_fn_1 = require_cfn_fn();
    var cfn_pseudo_1 = require_cfn_pseudo();
    var cloudformation_generated_1 = require_cloudformation_generated();
    var lazy_1 = require_lazy();
    var names_1 = require_names();
    var removal_policy_1 = require_removal_policy();
    var stack_1 = require_stack();
    var stack_synthesizers_1 = require_stack_synthesizers();
    var token_1 = require_token2();
    var cxapi = require_cx_api();
    var NESTED_STACK_SYMBOL = Symbol.for("@aws-cdk/core.NestedStack");
    var NestedStack = class _NestedStack extends stack_1.Stack {
      static isNestedStack(x) {
        return x != null && typeof x == "object" && NESTED_STACK_SYMBOL in x;
      }
      constructor(scope, id, props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_NestedStackProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _NestedStack), error;
        }
        const parentStack = findParentStack(scope);
        super(scope, id, { env: { account: parentStack.account, region: parentStack.region }, synthesizer: new stack_synthesizers_1.NestedStackSynthesizer(parentStack.synthesizer), description: props.description, crossRegionReferences: parentStack._crossRegionReferences }), this._parentStack = parentStack;
        const parentScope = new constructs_1.Construct(scope, id + ".NestedStack");
        Object.defineProperty(this, NESTED_STACK_SYMBOL, { value: true }), this.templateFile = `${names_1.Names.uniqueId(this)}.nested.template.json`, this.parameters = props.parameters || {}, this.resource = new cloudformation_generated_1.CfnStack(parentScope, `${id}.NestedStackResource`, { templateUrl: lazy_1.Lazy.uncachedString({ produce: () => this._templateUrl || "<unresolved>" }), parameters: lazy_1.Lazy.any({ produce: () => Object.keys(this.parameters).length > 0 ? this.parameters : void 0 }), notificationArns: props.notificationArns, timeoutInMinutes: props.timeout ? props.timeout.toMinutes() : void 0 }), this.resource.applyRemovalPolicy(props.removalPolicy ?? removal_policy_1.RemovalPolicy.DESTROY), this.nestedStackResource = this.resource, this.node.defaultChild = this.resource, this._contextualStackName = this.contextualAttribute(cfn_pseudo_1.Aws.STACK_NAME, cfn_fn_1.Fn.select(1, cfn_fn_1.Fn.split("/", this.resource.ref))), this._contextualStackId = this.contextualAttribute(cfn_pseudo_1.Aws.STACK_ID, this.resource.ref);
      }
      get stackName() {
        return this._contextualStackName;
      }
      get stackId() {
        return this._contextualStackId;
      }
      setParameter(name, value) {
        this.parameters[name] = value;
      }
      _prepareTemplateAsset() {
        if (this._templateUrl)
          return false;
        Object.entries(this.tags.tagValues()).forEach(([key, value]) => {
          this.resource.tags.setTag(key, value);
        });
        const cfn = JSON.stringify(this._toCloudFormation()), templateHash = crypto.createHash("sha256").update(cfn).digest("hex"), templateLocation = this._parentStack.synthesizer.addFileAsset({ packaging: assets_1.FileAssetPackaging.FILE, sourceHash: templateHash, fileName: this.templateFile });
        return this.addResourceMetadata(this.resource, "TemplateURL"), this._templateUrl = `https://s3.${this._parentStack.region}.${this._parentStack.urlSuffix}/${templateLocation.bucketName}/${templateLocation.objectKey}`, true;
      }
      contextualAttribute(innerValue, outerValue) {
        return token_1.Token.asString({ resolve: (context) => stack_1.Stack.of(context.scope) === this ? innerValue : outerValue });
      }
      addResourceMetadata(resource, resourceProperty) {
        this.node.tryGetContext(cxapi.ASSET_RESOURCE_METADATA_ENABLED_CONTEXT) && (resource.cfnOptions.metadata = resource.cfnOptions.metadata || {}, resource.cfnOptions.metadata[cxapi.ASSET_RESOURCE_METADATA_PATH_KEY] = this.templateFile, resource.cfnOptions.metadata[cxapi.ASSET_RESOURCE_METADATA_PROPERTY_KEY] = resourceProperty);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, NestedStack[_a] = { fqn: "aws-cdk-lib.NestedStack", version: "2.80.0" }, exports2.NestedStack = NestedStack;
    function findParentStack(scope) {
      if (!scope)
        throw new Error("Nested stacks cannot be defined as a root construct");
      const parentStack = constructs_1.Node.of(scope).scopes.reverse().find((p) => stack_1.Stack.isStack(p));
      if (!parentStack)
        throw new Error("Nested stacks must be defined within scope of another non-nested stack");
      return parentStack;
    }
  }
});

// node_modules/aws-cdk-lib/core/lib/cfn-capabilities.js
var require_cfn_capabilities = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/cfn-capabilities.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnCapabilities = void 0;
    var CfnCapabilities;
    (function(CfnCapabilities2) {
      CfnCapabilities2.NONE = "", CfnCapabilities2.ANONYMOUS_IAM = "CAPABILITY_IAM", CfnCapabilities2.NAMED_IAM = "CAPABILITY_NAMED_IAM", CfnCapabilities2.AUTO_EXPAND = "CAPABILITY_AUTO_EXPAND";
    })(CfnCapabilities = exports2.CfnCapabilities || (exports2.CfnCapabilities = {}));
  }
});

// node_modules/aws-cdk-lib/core/lib/validation/validation.js
var require_validation = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/validation/validation.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/core/lib/validation/index.js
var require_validation2 = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/validation/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_validation(), exports2), __exportStar(require_report(), exports2);
  }
});

// node_modules/aws-cdk-lib/core/lib/time-zone.js
var require_time_zone = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/time-zone.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.TimeZone = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var TimeZone = class _TimeZone {
      static of(timezoneName) {
        return new _TimeZone(timezoneName);
      }
      constructor(timezoneName) {
        this.timezoneName = timezoneName;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, TimeZone[_a] = { fqn: "aws-cdk-lib.TimeZone", version: "2.80.0" }, TimeZone.AFRICA_ABIDJAN = new TimeZone("Africa/Abidjan"), TimeZone.AFRICA_ALGIERS = new TimeZone("Africa/Algiers"), TimeZone.AFRICA_BISSAU = new TimeZone("Africa/Bissau"), TimeZone.AFRICA_CAIRO = new TimeZone("Africa/Cairo"), TimeZone.AFRICA_CASABLANCA = new TimeZone("Africa/Casablanca"), TimeZone.AFRICA_CEUTA = new TimeZone("Africa/Ceuta"), TimeZone.AFRICA_EL_AAIUN = new TimeZone("Africa/El_Aaiun"), TimeZone.AFRICA_JOHANNESBURG = new TimeZone("Africa/Johannesburg"), TimeZone.AFRICA_JUBA = new TimeZone("Africa/Juba"), TimeZone.AFRICA_KHARTOUM = new TimeZone("Africa/Khartoum"), TimeZone.AFRICA_LAGOS = new TimeZone("Africa/Lagos"), TimeZone.AFRICA_MAPUTO = new TimeZone("Africa/Maputo"), TimeZone.AFRICA_MONROVIA = new TimeZone("Africa/Monrovia"), TimeZone.AFRICA_NAIROBI = new TimeZone("Africa/Nairobi"), TimeZone.AFRICA_NDJAMENA = new TimeZone("Africa/Ndjamena"), TimeZone.AFRICA_SAO_TOME = new TimeZone("Africa/Sao_Tome"), TimeZone.AFRICA_TRIPOLI = new TimeZone("Africa/Tripoli"), TimeZone.AFRICA_TUNIS = new TimeZone("Africa/Tunis"), TimeZone.AFRICA_WINDHOEK = new TimeZone("Africa/Windhoek"), TimeZone.AMERICA_ADAK = new TimeZone("America/Adak"), TimeZone.AMERICA_ANCHORAGE = new TimeZone("America/Anchorage"), TimeZone.AMERICA_ARAGUAINA = new TimeZone("America/Araguaina"), TimeZone.AMERICA_ARGENTINA_BUENOS_AIRES = new TimeZone("America/Argentina/Buenos_Aires"), TimeZone.AMERICA_ARGENTINA_CATAMARCA = new TimeZone("America/Argentina/Catamarca"), TimeZone.AMERICA_ARGENTINA_CORDOBA = new TimeZone("America/Argentina/Cordoba"), TimeZone.AMERICA_ARGENTINA_JUJUY = new TimeZone("America/Argentina/Jujuy"), TimeZone.AMERICA_ARGENTINA_LA_RIOJA = new TimeZone("America/Argentina/La_Rioja"), TimeZone.AMERICA_ARGENTINA_MENDOZA = new TimeZone("America/Argentina/Mendoza"), TimeZone.AMERICA_ARGENTINA_RIO_GALLEGOS = new TimeZone("America/Argentina/Rio_Gallegos"), TimeZone.AMERICA_ARGENTINA_SALTA = new TimeZone("America/Argentina/Salta"), TimeZone.AMERICA_ARGENTINA_SAN_JUAN = new TimeZone("America/Argentina/San_Juan"), TimeZone.AMERICA_ARGENTINA_SAN_LUIS = new TimeZone("America/Argentina/San_Luis"), TimeZone.AMERICA_ARGENTINA_TUCUMAN = new TimeZone("America/Argentina/Tucuman"), TimeZone.AMERICA_ARGENTINA_USHUAIA = new TimeZone("America/Argentina/Ushuaia"), TimeZone.AMERICA_ASUNCION = new TimeZone("America/Asuncion"), TimeZone.AMERICA_BAHIA = new TimeZone("America/Bahia"), TimeZone.AMERICA_BAHIA_BANDERAS = new TimeZone("America/Bahia_Banderas"), TimeZone.AMERICA_BARBADOS = new TimeZone("America/Barbados"), TimeZone.AMERICA_BELEM = new TimeZone("America/Belem"), TimeZone.AMERICA_BELIZE = new TimeZone("America/Belize"), TimeZone.AMERICA_BOA_VISTA = new TimeZone("America/Boa_Vista"), TimeZone.AMERICA_BOGOTA = new TimeZone("America/Bogota"), TimeZone.AMERICA_BOISE = new TimeZone("America/Boise"), TimeZone.AMERICA_CAMBRIDGE_BAY = new TimeZone("America/Cambridge_Bay"), TimeZone.AMERICA_CAMPO_GRANDE = new TimeZone("America/Campo_Grande"), TimeZone.AMERICA_CANCUN = new TimeZone("America/Cancun"), TimeZone.AMERICA_CARACAS = new TimeZone("America/Caracas"), TimeZone.AMERICA_CAYENNE = new TimeZone("America/Cayenne"), TimeZone.AMERICA_CHICAGO = new TimeZone("America/Chicago"), TimeZone.AMERICA_CHIHUAHUA = new TimeZone("America/Chihuahua"), TimeZone.AMERICA_CIUDAD_JUAREZ = new TimeZone("America/Ciudad_Juarez"), TimeZone.AMERICA_COSTA_RICA = new TimeZone("America/Costa_Rica"), TimeZone.AMERICA_CUIABA = new TimeZone("America/Cuiaba"), TimeZone.AMERICA_DANMARKSHAVN = new TimeZone("America/Danmarkshavn"), TimeZone.AMERICA_DAWSON = new TimeZone("America/Dawson"), TimeZone.AMERICA_DAWSON_CREEK = new TimeZone("America/Dawson_Creek"), TimeZone.AMERICA_DENVER = new TimeZone("America/Denver"), TimeZone.AMERICA_DETROIT = new TimeZone("America/Detroit"), TimeZone.AMERICA_EDMONTON = new TimeZone("America/Edmonton"), TimeZone.AMERICA_EIRUNEPE = new TimeZone("America/Eirunepe"), TimeZone.AMERICA_EL_SALVADOR = new TimeZone("America/El_Salvador"), TimeZone.AMERICA_FORT_NELSON = new TimeZone("America/Fort_Nelson"), TimeZone.AMERICA_FORTALEZA = new TimeZone("America/Fortaleza"), TimeZone.AMERICA_GLACE_BAY = new TimeZone("America/Glace_Bay"), TimeZone.AMERICA_GOOSE_BAY = new TimeZone("America/Goose_Bay"), TimeZone.AMERICA_GRAND_TURK = new TimeZone("America/Grand_Turk"), TimeZone.AMERICA_GUATEMALA = new TimeZone("America/Guatemala"), TimeZone.AMERICA_GUAYAQUIL = new TimeZone("America/Guayaquil"), TimeZone.AMERICA_GUYANA = new TimeZone("America/Guyana"), TimeZone.AMERICA_HALIFAX = new TimeZone("America/Halifax"), TimeZone.AMERICA_HAVANA = new TimeZone("America/Havana"), TimeZone.AMERICA_HERMOSILLO = new TimeZone("America/Hermosillo"), TimeZone.AMERICA_INDIANA_INDIANAPOLIS = new TimeZone("America/Indiana/Indianapolis"), TimeZone.AMERICA_INDIANA_KNOX = new TimeZone("America/Indiana/Knox"), TimeZone.AMERICA_INDIANA_MARENGO = new TimeZone("America/Indiana/Marengo"), TimeZone.AMERICA_INDIANA_PETERSBURG = new TimeZone("America/Indiana/Petersburg"), TimeZone.AMERICA_INDIANA_TELL_CITY = new TimeZone("America/Indiana/Tell_City"), TimeZone.AMERICA_INDIANA_VEVAY = new TimeZone("America/Indiana/Vevay"), TimeZone.AMERICA_INDIANA_VINCENNES = new TimeZone("America/Indiana/Vincennes"), TimeZone.AMERICA_INDIANA_WINAMAC = new TimeZone("America/Indiana/Winamac"), TimeZone.AMERICA_INUVIK = new TimeZone("America/Inuvik"), TimeZone.AMERICA_IQALUIT = new TimeZone("America/Iqaluit"), TimeZone.AMERICA_JAMAICA = new TimeZone("America/Jamaica"), TimeZone.AMERICA_JUNEAU = new TimeZone("America/Juneau"), TimeZone.AMERICA_KENTUCKY_LOUISVILLE = new TimeZone("America/Kentucky/Louisville"), TimeZone.AMERICA_KENTUCKY_MONTICELLO = new TimeZone("America/Kentucky/Monticello"), TimeZone.AMERICA_LA_PAZ = new TimeZone("America/La_Paz"), TimeZone.AMERICA_LIMA = new TimeZone("America/Lima"), TimeZone.AMERICA_LOS_ANGELES = new TimeZone("America/Los_Angeles"), TimeZone.AMERICA_MACEIO = new TimeZone("America/Maceio"), TimeZone.AMERICA_MANAGUA = new TimeZone("America/Managua"), TimeZone.AMERICA_MANAUS = new TimeZone("America/Manaus"), TimeZone.AMERICA_MARTINIQUE = new TimeZone("America/Martinique"), TimeZone.AMERICA_MATAMOROS = new TimeZone("America/Matamoros"), TimeZone.AMERICA_MAZATLAN = new TimeZone("America/Mazatlan"), TimeZone.AMERICA_MENOMINEE = new TimeZone("America/Menominee"), TimeZone.AMERICA_MERIDA = new TimeZone("America/Merida"), TimeZone.AMERICA_METLAKATLA = new TimeZone("America/Metlakatla"), TimeZone.AMERICA_MEXICO_CITY = new TimeZone("America/Mexico_City"), TimeZone.AMERICA_MIQUELON = new TimeZone("America/Miquelon"), TimeZone.AMERICA_MONCTON = new TimeZone("America/Moncton"), TimeZone.AMERICA_MONTERREY = new TimeZone("America/Monterrey"), TimeZone.AMERICA_MONTEVIDEO = new TimeZone("America/Montevideo"), TimeZone.AMERICA_NEW_YORK = new TimeZone("America/New_York"), TimeZone.AMERICA_NOME = new TimeZone("America/Nome"), TimeZone.AMERICA_NORONHA = new TimeZone("America/Noronha"), TimeZone.AMERICA_NORTH_DAKOTA_BEULAH = new TimeZone("America/North_Dakota/Beulah"), TimeZone.AMERICA_NORTH_DAKOTA_CENTER = new TimeZone("America/North_Dakota/Center"), TimeZone.AMERICA_NORTH_DAKOTA_NEW_SALEM = new TimeZone("America/North_Dakota/New_Salem"), TimeZone.AMERICA_NUUK = new TimeZone("America/Nuuk"), TimeZone.AMERICA_OJINAGA = new TimeZone("America/Ojinaga"), TimeZone.AMERICA_PANAMA = new TimeZone("America/Panama"), TimeZone.AMERICA_PARAMARIBO = new TimeZone("America/Paramaribo"), TimeZone.AMERICA_PHOENIX = new TimeZone("America/Phoenix"), TimeZone.AMERICA_PORT_MINUS_AU_MINUS_PRINCE = new TimeZone("America/Port-au-Prince"), TimeZone.AMERICA_PORTO_VELHO = new TimeZone("America/Porto_Velho"), TimeZone.AMERICA_PUERTO_RICO = new TimeZone("America/Puerto_Rico"), TimeZone.AMERICA_PUNTA_ARENAS = new TimeZone("America/Punta_Arenas"), TimeZone.AMERICA_RANKIN_INLET = new TimeZone("America/Rankin_Inlet"), TimeZone.AMERICA_RECIFE = new TimeZone("America/Recife"), TimeZone.AMERICA_REGINA = new TimeZone("America/Regina"), TimeZone.AMERICA_RESOLUTE = new TimeZone("America/Resolute"), TimeZone.AMERICA_RIO_BRANCO = new TimeZone("America/Rio_Branco"), TimeZone.AMERICA_SANTAREM = new TimeZone("America/Santarem"), TimeZone.AMERICA_SANTIAGO = new TimeZone("America/Santiago"), TimeZone.AMERICA_SANTO_DOMINGO = new TimeZone("America/Santo_Domingo"), TimeZone.AMERICA_SAO_PAULO = new TimeZone("America/Sao_Paulo"), TimeZone.AMERICA_SCORESBYSUND = new TimeZone("America/Scoresbysund"), TimeZone.AMERICA_SITKA = new TimeZone("America/Sitka"), TimeZone.AMERICA_ST_JOHNS = new TimeZone("America/St_Johns"), TimeZone.AMERICA_SWIFT_CURRENT = new TimeZone("America/Swift_Current"), TimeZone.AMERICA_TEGUCIGALPA = new TimeZone("America/Tegucigalpa"), TimeZone.AMERICA_THULE = new TimeZone("America/Thule"), TimeZone.AMERICA_TIJUANA = new TimeZone("America/Tijuana"), TimeZone.AMERICA_TORONTO = new TimeZone("America/Toronto"), TimeZone.AMERICA_VANCOUVER = new TimeZone("America/Vancouver"), TimeZone.AMERICA_WHITEHORSE = new TimeZone("America/Whitehorse"), TimeZone.AMERICA_WINNIPEG = new TimeZone("America/Winnipeg"), TimeZone.AMERICA_YAKUTAT = new TimeZone("America/Yakutat"), TimeZone.AMERICA_YELLOWKNIFE = new TimeZone("America/Yellowknife"), TimeZone.ANTARCTICA_CASEY = new TimeZone("Antarctica/Casey"), TimeZone.ANTARCTICA_DAVIS = new TimeZone("Antarctica/Davis"), TimeZone.ANTARCTICA_MACQUARIE = new TimeZone("Antarctica/Macquarie"), TimeZone.ANTARCTICA_MAWSON = new TimeZone("Antarctica/Mawson"), TimeZone.ANTARCTICA_PALMER = new TimeZone("Antarctica/Palmer"), TimeZone.ANTARCTICA_ROTHERA = new TimeZone("Antarctica/Rothera"), TimeZone.ANTARCTICA_TROLL = new TimeZone("Antarctica/Troll"), TimeZone.ASIA_ALMATY = new TimeZone("Asia/Almaty"), TimeZone.ASIA_AMMAN = new TimeZone("Asia/Amman"), TimeZone.ASIA_ANADYR = new TimeZone("Asia/Anadyr"), TimeZone.ASIA_AQTAU = new TimeZone("Asia/Aqtau"), TimeZone.ASIA_AQTOBE = new TimeZone("Asia/Aqtobe"), TimeZone.ASIA_ASHGABAT = new TimeZone("Asia/Ashgabat"), TimeZone.ASIA_ATYRAU = new TimeZone("Asia/Atyrau"), TimeZone.ASIA_BAGHDAD = new TimeZone("Asia/Baghdad"), TimeZone.ASIA_BAKU = new TimeZone("Asia/Baku"), TimeZone.ASIA_BANGKOK = new TimeZone("Asia/Bangkok"), TimeZone.ASIA_BARNAUL = new TimeZone("Asia/Barnaul"), TimeZone.ASIA_BEIRUT = new TimeZone("Asia/Beirut"), TimeZone.ASIA_BISHKEK = new TimeZone("Asia/Bishkek"), TimeZone.ASIA_CHITA = new TimeZone("Asia/Chita"), TimeZone.ASIA_CHOIBALSAN = new TimeZone("Asia/Choibalsan"), TimeZone.ASIA_COLOMBO = new TimeZone("Asia/Colombo"), TimeZone.ASIA_DAMASCUS = new TimeZone("Asia/Damascus"), TimeZone.ASIA_DHAKA = new TimeZone("Asia/Dhaka"), TimeZone.ASIA_DILI = new TimeZone("Asia/Dili"), TimeZone.ASIA_DUBAI = new TimeZone("Asia/Dubai"), TimeZone.ASIA_DUSHANBE = new TimeZone("Asia/Dushanbe"), TimeZone.ASIA_FAMAGUSTA = new TimeZone("Asia/Famagusta"), TimeZone.ASIA_GAZA = new TimeZone("Asia/Gaza"), TimeZone.ASIA_HEBRON = new TimeZone("Asia/Hebron"), TimeZone.ASIA_HO_CHI_MINH = new TimeZone("Asia/Ho_Chi_Minh"), TimeZone.ASIA_HONG_KONG = new TimeZone("Asia/Hong_Kong"), TimeZone.ASIA_HOVD = new TimeZone("Asia/Hovd"), TimeZone.ASIA_IRKUTSK = new TimeZone("Asia/Irkutsk"), TimeZone.ASIA_JAKARTA = new TimeZone("Asia/Jakarta"), TimeZone.ASIA_JAYAPURA = new TimeZone("Asia/Jayapura"), TimeZone.ASIA_JERUSALEM = new TimeZone("Asia/Jerusalem"), TimeZone.ASIA_KABUL = new TimeZone("Asia/Kabul"), TimeZone.ASIA_KAMCHATKA = new TimeZone("Asia/Kamchatka"), TimeZone.ASIA_KARACHI = new TimeZone("Asia/Karachi"), TimeZone.ASIA_KATHMANDU = new TimeZone("Asia/Kathmandu"), TimeZone.ASIA_KHANDYGA = new TimeZone("Asia/Khandyga"), TimeZone.ASIA_KOLKATA = new TimeZone("Asia/Kolkata"), TimeZone.ASIA_KRASNOYARSK = new TimeZone("Asia/Krasnoyarsk"), TimeZone.ASIA_KUCHING = new TimeZone("Asia/Kuching"), TimeZone.ASIA_MACAU = new TimeZone("Asia/Macau"), TimeZone.ASIA_MAGADAN = new TimeZone("Asia/Magadan"), TimeZone.ASIA_MAKASSAR = new TimeZone("Asia/Makassar"), TimeZone.ASIA_MANILA = new TimeZone("Asia/Manila"), TimeZone.ASIA_NICOSIA = new TimeZone("Asia/Nicosia"), TimeZone.ASIA_NOVOKUZNETSK = new TimeZone("Asia/Novokuznetsk"), TimeZone.ASIA_NOVOSIBIRSK = new TimeZone("Asia/Novosibirsk"), TimeZone.ASIA_OMSK = new TimeZone("Asia/Omsk"), TimeZone.ASIA_ORAL = new TimeZone("Asia/Oral"), TimeZone.ASIA_PONTIANAK = new TimeZone("Asia/Pontianak"), TimeZone.ASIA_PYONGYANG = new TimeZone("Asia/Pyongyang"), TimeZone.ASIA_QATAR = new TimeZone("Asia/Qatar"), TimeZone.ASIA_QOSTANAY = new TimeZone("Asia/Qostanay"), TimeZone.ASIA_QYZYLORDA = new TimeZone("Asia/Qyzylorda"), TimeZone.ASIA_RIYADH = new TimeZone("Asia/Riyadh"), TimeZone.ASIA_SAKHALIN = new TimeZone("Asia/Sakhalin"), TimeZone.ASIA_SAMARKAND = new TimeZone("Asia/Samarkand"), TimeZone.ASIA_SEOUL = new TimeZone("Asia/Seoul"), TimeZone.ASIA_SHANGHAI = new TimeZone("Asia/Shanghai"), TimeZone.ASIA_SINGAPORE = new TimeZone("Asia/Singapore"), TimeZone.ASIA_SREDNEKOLYMSK = new TimeZone("Asia/Srednekolymsk"), TimeZone.ASIA_TAIPEI = new TimeZone("Asia/Taipei"), TimeZone.ASIA_TASHKENT = new TimeZone("Asia/Tashkent"), TimeZone.ASIA_TBILISI = new TimeZone("Asia/Tbilisi"), TimeZone.ASIA_TEHRAN = new TimeZone("Asia/Tehran"), TimeZone.ASIA_THIMPHU = new TimeZone("Asia/Thimphu"), TimeZone.ASIA_TOKYO = new TimeZone("Asia/Tokyo"), TimeZone.ASIA_TOMSK = new TimeZone("Asia/Tomsk"), TimeZone.ASIA_ULAANBAATAR = new TimeZone("Asia/Ulaanbaatar"), TimeZone.ASIA_URUMQI = new TimeZone("Asia/Urumqi"), TimeZone.ASIA_UST_MINUS_NERA = new TimeZone("Asia/Ust-Nera"), TimeZone.ASIA_VLADIVOSTOK = new TimeZone("Asia/Vladivostok"), TimeZone.ASIA_YAKUTSK = new TimeZone("Asia/Yakutsk"), TimeZone.ASIA_YANGON = new TimeZone("Asia/Yangon"), TimeZone.ASIA_YEKATERINBURG = new TimeZone("Asia/Yekaterinburg"), TimeZone.ASIA_YEREVAN = new TimeZone("Asia/Yerevan"), TimeZone.ATLANTIC_AZORES = new TimeZone("Atlantic/Azores"), TimeZone.ATLANTIC_BERMUDA = new TimeZone("Atlantic/Bermuda"), TimeZone.ATLANTIC_CANARY = new TimeZone("Atlantic/Canary"), TimeZone.ATLANTIC_CAPE_VERDE = new TimeZone("Atlantic/Cape_Verde"), TimeZone.ATLANTIC_FAROE = new TimeZone("Atlantic/Faroe"), TimeZone.ATLANTIC_MADEIRA = new TimeZone("Atlantic/Madeira"), TimeZone.ATLANTIC_SOUTH_GEORGIA = new TimeZone("Atlantic/South_Georgia"), TimeZone.ATLANTIC_STANLEY = new TimeZone("Atlantic/Stanley"), TimeZone.AUSTRALIA_ADELAIDE = new TimeZone("Australia/Adelaide"), TimeZone.AUSTRALIA_BRISBANE = new TimeZone("Australia/Brisbane"), TimeZone.AUSTRALIA_BROKEN_HILL = new TimeZone("Australia/Broken_Hill"), TimeZone.AUSTRALIA_DARWIN = new TimeZone("Australia/Darwin"), TimeZone.AUSTRALIA_EUCLA = new TimeZone("Australia/Eucla"), TimeZone.AUSTRALIA_HOBART = new TimeZone("Australia/Hobart"), TimeZone.AUSTRALIA_LINDEMAN = new TimeZone("Australia/Lindeman"), TimeZone.AUSTRALIA_LORD_HOWE = new TimeZone("Australia/Lord_Howe"), TimeZone.AUSTRALIA_MELBOURNE = new TimeZone("Australia/Melbourne"), TimeZone.AUSTRALIA_PERTH = new TimeZone("Australia/Perth"), TimeZone.AUSTRALIA_SYDNEY = new TimeZone("Australia/Sydney"), TimeZone.CET = new TimeZone("CET"), TimeZone.CST6CDT = new TimeZone("CST6CDT"), TimeZone.EET = new TimeZone("EET"), TimeZone.EST = new TimeZone("EST"), TimeZone.EST5EDT = new TimeZone("EST5EDT"), TimeZone.ETC_GMT = new TimeZone("Etc/GMT"), TimeZone.ETC_GMT_PLUS_1 = new TimeZone("Etc/GMT+1"), TimeZone.ETC_GMT_PLUS_10 = new TimeZone("Etc/GMT+10"), TimeZone.ETC_GMT_PLUS_11 = new TimeZone("Etc/GMT+11"), TimeZone.ETC_GMT_PLUS_12 = new TimeZone("Etc/GMT+12"), TimeZone.ETC_GMT_PLUS_2 = new TimeZone("Etc/GMT+2"), TimeZone.ETC_GMT_PLUS_3 = new TimeZone("Etc/GMT+3"), TimeZone.ETC_GMT_PLUS_4 = new TimeZone("Etc/GMT+4"), TimeZone.ETC_GMT_PLUS_5 = new TimeZone("Etc/GMT+5"), TimeZone.ETC_GMT_PLUS_6 = new TimeZone("Etc/GMT+6"), TimeZone.ETC_GMT_PLUS_7 = new TimeZone("Etc/GMT+7"), TimeZone.ETC_GMT_PLUS_8 = new TimeZone("Etc/GMT+8"), TimeZone.ETC_GMT_PLUS_9 = new TimeZone("Etc/GMT+9"), TimeZone.ETC_GMT_MINUS_1 = new TimeZone("Etc/GMT-1"), TimeZone.ETC_GMT_MINUS_10 = new TimeZone("Etc/GMT-10"), TimeZone.ETC_GMT_MINUS_11 = new TimeZone("Etc/GMT-11"), TimeZone.ETC_GMT_MINUS_12 = new TimeZone("Etc/GMT-12"), TimeZone.ETC_GMT_MINUS_13 = new TimeZone("Etc/GMT-13"), TimeZone.ETC_GMT_MINUS_14 = new TimeZone("Etc/GMT-14"), TimeZone.ETC_GMT_MINUS_2 = new TimeZone("Etc/GMT-2"), TimeZone.ETC_GMT_MINUS_3 = new TimeZone("Etc/GMT-3"), TimeZone.ETC_GMT_MINUS_4 = new TimeZone("Etc/GMT-4"), TimeZone.ETC_GMT_MINUS_5 = new TimeZone("Etc/GMT-5"), TimeZone.ETC_GMT_MINUS_6 = new TimeZone("Etc/GMT-6"), TimeZone.ETC_GMT_MINUS_7 = new TimeZone("Etc/GMT-7"), TimeZone.ETC_GMT_MINUS_8 = new TimeZone("Etc/GMT-8"), TimeZone.ETC_GMT_MINUS_9 = new TimeZone("Etc/GMT-9"), TimeZone.ETC_UTC = new TimeZone("Etc/UTC"), TimeZone.EUROPE_ANDORRA = new TimeZone("Europe/Andorra"), TimeZone.EUROPE_ASTRAKHAN = new TimeZone("Europe/Astrakhan"), TimeZone.EUROPE_ATHENS = new TimeZone("Europe/Athens"), TimeZone.EUROPE_BELGRADE = new TimeZone("Europe/Belgrade"), TimeZone.EUROPE_BERLIN = new TimeZone("Europe/Berlin"), TimeZone.EUROPE_BRUSSELS = new TimeZone("Europe/Brussels"), TimeZone.EUROPE_BUCHAREST = new TimeZone("Europe/Bucharest"), TimeZone.EUROPE_BUDAPEST = new TimeZone("Europe/Budapest"), TimeZone.EUROPE_CHISINAU = new TimeZone("Europe/Chisinau"), TimeZone.EUROPE_DUBLIN = new TimeZone("Europe/Dublin"), TimeZone.EUROPE_GIBRALTAR = new TimeZone("Europe/Gibraltar"), TimeZone.EUROPE_HELSINKI = new TimeZone("Europe/Helsinki"), TimeZone.EUROPE_ISTANBUL = new TimeZone("Europe/Istanbul"), TimeZone.EUROPE_KALININGRAD = new TimeZone("Europe/Kaliningrad"), TimeZone.EUROPE_KIROV = new TimeZone("Europe/Kirov"), TimeZone.EUROPE_KYIV = new TimeZone("Europe/Kyiv"), TimeZone.EUROPE_LISBON = new TimeZone("Europe/Lisbon"), TimeZone.EUROPE_LONDON = new TimeZone("Europe/London"), TimeZone.EUROPE_MADRID = new TimeZone("Europe/Madrid"), TimeZone.EUROPE_MALTA = new TimeZone("Europe/Malta"), TimeZone.EUROPE_MINSK = new TimeZone("Europe/Minsk"), TimeZone.EUROPE_MOSCOW = new TimeZone("Europe/Moscow"), TimeZone.EUROPE_PARIS = new TimeZone("Europe/Paris"), TimeZone.EUROPE_PRAGUE = new TimeZone("Europe/Prague"), TimeZone.EUROPE_RIGA = new TimeZone("Europe/Riga"), TimeZone.EUROPE_ROME = new TimeZone("Europe/Rome"), TimeZone.EUROPE_SAMARA = new TimeZone("Europe/Samara"), TimeZone.EUROPE_SARATOV = new TimeZone("Europe/Saratov"), TimeZone.EUROPE_SIMFEROPOL = new TimeZone("Europe/Simferopol"), TimeZone.EUROPE_SOFIA = new TimeZone("Europe/Sofia"), TimeZone.EUROPE_TALLINN = new TimeZone("Europe/Tallinn"), TimeZone.EUROPE_TIRANE = new TimeZone("Europe/Tirane"), TimeZone.EUROPE_ULYANOVSK = new TimeZone("Europe/Ulyanovsk"), TimeZone.EUROPE_VIENNA = new TimeZone("Europe/Vienna"), TimeZone.EUROPE_VILNIUS = new TimeZone("Europe/Vilnius"), TimeZone.EUROPE_VOLGOGRAD = new TimeZone("Europe/Volgograd"), TimeZone.EUROPE_WARSAW = new TimeZone("Europe/Warsaw"), TimeZone.EUROPE_ZURICH = new TimeZone("Europe/Zurich"), TimeZone.FACTORY = new TimeZone("Factory"), TimeZone.HST = new TimeZone("HST"), TimeZone.INDIAN_CHAGOS = new TimeZone("Indian/Chagos"), TimeZone.INDIAN_MALDIVES = new TimeZone("Indian/Maldives"), TimeZone.INDIAN_MAURITIUS = new TimeZone("Indian/Mauritius"), TimeZone.MET = new TimeZone("MET"), TimeZone.MST = new TimeZone("MST"), TimeZone.MST7MDT = new TimeZone("MST7MDT"), TimeZone.PACIFIC_APIA = new TimeZone("Pacific/Apia"), TimeZone.PACIFIC_AUCKLAND = new TimeZone("Pacific/Auckland"), TimeZone.PACIFIC_BOUGAINVILLE = new TimeZone("Pacific/Bougainville"), TimeZone.PACIFIC_CHATHAM = new TimeZone("Pacific/Chatham"), TimeZone.PACIFIC_EASTER = new TimeZone("Pacific/Easter"), TimeZone.PACIFIC_EFATE = new TimeZone("Pacific/Efate"), TimeZone.PACIFIC_FAKAOFO = new TimeZone("Pacific/Fakaofo"), TimeZone.PACIFIC_FIJI = new TimeZone("Pacific/Fiji"), TimeZone.PACIFIC_GALAPAGOS = new TimeZone("Pacific/Galapagos"), TimeZone.PACIFIC_GAMBIER = new TimeZone("Pacific/Gambier"), TimeZone.PACIFIC_GUADALCANAL = new TimeZone("Pacific/Guadalcanal"), TimeZone.PACIFIC_GUAM = new TimeZone("Pacific/Guam"), TimeZone.PACIFIC_HONOLULU = new TimeZone("Pacific/Honolulu"), TimeZone.PACIFIC_KANTON = new TimeZone("Pacific/Kanton"), TimeZone.PACIFIC_KIRITIMATI = new TimeZone("Pacific/Kiritimati"), TimeZone.PACIFIC_KOSRAE = new TimeZone("Pacific/Kosrae"), TimeZone.PACIFIC_KWAJALEIN = new TimeZone("Pacific/Kwajalein"), TimeZone.PACIFIC_MARQUESAS = new TimeZone("Pacific/Marquesas"), TimeZone.PACIFIC_NAURU = new TimeZone("Pacific/Nauru"), TimeZone.PACIFIC_NIUE = new TimeZone("Pacific/Niue"), TimeZone.PACIFIC_NORFOLK = new TimeZone("Pacific/Norfolk"), TimeZone.PACIFIC_NOUMEA = new TimeZone("Pacific/Noumea"), TimeZone.PACIFIC_PAGO_PAGO = new TimeZone("Pacific/Pago_Pago"), TimeZone.PACIFIC_PALAU = new TimeZone("Pacific/Palau"), TimeZone.PACIFIC_PITCAIRN = new TimeZone("Pacific/Pitcairn"), TimeZone.PACIFIC_PORT_MORESBY = new TimeZone("Pacific/Port_Moresby"), TimeZone.PACIFIC_RAROTONGA = new TimeZone("Pacific/Rarotonga"), TimeZone.PACIFIC_TAHITI = new TimeZone("Pacific/Tahiti"), TimeZone.PACIFIC_TARAWA = new TimeZone("Pacific/Tarawa"), TimeZone.PACIFIC_TONGATAPU = new TimeZone("Pacific/Tongatapu"), TimeZone.PST8PDT = new TimeZone("PST8PDT"), TimeZone.WET = new TimeZone("WET"), exports2.TimeZone = TimeZone;
  }
});

// node_modules/aws-cdk-lib/core/lib/index.js
var require_lib8 = __commonJS({
  "node_modules/aws-cdk-lib/core/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_aspect(), exports2), __exportStar(require_tag_aspect(), exports2), __exportStar(require_token2(), exports2), __exportStar(require_resolvable(), exports2), __exportStar(require_type_hints(), exports2), __exportStar(require_lazy(), exports2), __exportStar(require_tag_manager(), exports2), __exportStar(require_string_fragments(), exports2), __exportStar(require_stack_synthesizers(), exports2), __exportStar(require_reference(), exports2), __exportStar(require_cfn_condition(), exports2), __exportStar(require_cfn_fn(), exports2), __exportStar(require_cfn_hook(), exports2), __exportStar(require_cfn_codedeploy_blue_green_hook(), exports2), __exportStar(require_cfn_include(), exports2), __exportStar(require_cfn_mapping(), exports2), __exportStar(require_cfn_output(), exports2), __exportStar(require_cfn_parameter(), exports2), __exportStar(require_cfn_pseudo(), exports2), __exportStar(require_cfn_resource(), exports2), __exportStar(require_cfn_resource_policy(), exports2), __exportStar(require_cfn_rule(), exports2), __exportStar(require_stack(), exports2), __exportStar(require_stage(), exports2), __exportStar(require_cfn_element(), exports2), __exportStar(require_cfn_dynamic_reference(), exports2), __exportStar(require_cfn_tag(), exports2), __exportStar(require_cfn_json(), exports2), __exportStar(require_removal_policy(), exports2), __exportStar(require_arn(), exports2), __exportStar(require_duration(), exports2), __exportStar(require_expiration(), exports2), __exportStar(require_size(), exports2), __exportStar(require_stack_trace2(), exports2), __exportStar(require_app2(), exports2), __exportStar(require_context_provider(), exports2), __exportStar(require_environment2(), exports2), __exportStar(require_annotations(), exports2), __exportStar(require_runtime(), exports2), __exportStar(require_secret_value(), exports2), __exportStar(require_resource(), exports2), __exportStar(require_physical_name(), exports2), __exportStar(require_assets3(), exports2), __exportStar(require_tree(), exports2), __exportStar(require_asset_staging2(), exports2), __exportStar(require_bundling(), exports2), __exportStar(require_fs2(), exports2), __exportStar(require_custom_resource(), exports2), __exportStar(require_nested_stack(), exports2), __exportStar(require_custom_resource_provider2(), exports2), __exportStar(require_cfn_capabilities(), exports2), __exportStar(require_cloudformation_generated(), exports2), __exportStar(require_feature_flags(), exports2), __exportStar(require_permissions_boundary(), exports2), __exportStar(require_validation2(), exports2), __exportStar(require_intrinsic(), exports2), __exportStar(require_names(), exports2), __exportStar(require_time_zone(), exports2);
  }
});

// node_modules/aws-cdk-lib/core/index.js
var require_core2 = __commonJS({
  "node_modules/aws-cdk-lib/core/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib8(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-applicationautoscaling/lib/applicationautoscaling.generated.js
var require_applicationautoscaling_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-applicationautoscaling/lib/applicationautoscaling.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnScalingPolicy = exports2.CfnScalableTarget = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnScalableTargetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxCapacity", cdk.requiredValidator)(properties.maxCapacity)), errors.collect(cdk.propertyValidator("maxCapacity", cdk.validateNumber)(properties.maxCapacity)), errors.collect(cdk.propertyValidator("minCapacity", cdk.requiredValidator)(properties.minCapacity)), errors.collect(cdk.propertyValidator("minCapacity", cdk.validateNumber)(properties.minCapacity)), errors.collect(cdk.propertyValidator("resourceId", cdk.requiredValidator)(properties.resourceId)), errors.collect(cdk.propertyValidator("resourceId", cdk.validateString)(properties.resourceId)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("scalableDimension", cdk.requiredValidator)(properties.scalableDimension)), errors.collect(cdk.propertyValidator("scalableDimension", cdk.validateString)(properties.scalableDimension)), errors.collect(cdk.propertyValidator("scheduledActions", cdk.listValidator(CfnScalableTarget_ScheduledActionPropertyValidator))(properties.scheduledActions)), errors.collect(cdk.propertyValidator("serviceNamespace", cdk.requiredValidator)(properties.serviceNamespace)), errors.collect(cdk.propertyValidator("serviceNamespace", cdk.validateString)(properties.serviceNamespace)), errors.collect(cdk.propertyValidator("suspendedState", CfnScalableTarget_SuspendedStatePropertyValidator)(properties.suspendedState)), errors.wrap('supplied properties not correct for "CfnScalableTargetProps"');
    }
    function cfnScalableTargetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalableTargetPropsValidator(properties).assertSuccess(), { MaxCapacity: cdk.numberToCloudFormation(properties.maxCapacity), MinCapacity: cdk.numberToCloudFormation(properties.minCapacity), ResourceId: cdk.stringToCloudFormation(properties.resourceId), RoleARN: cdk.stringToCloudFormation(properties.roleArn), ScalableDimension: cdk.stringToCloudFormation(properties.scalableDimension), ServiceNamespace: cdk.stringToCloudFormation(properties.serviceNamespace), ScheduledActions: cdk.listMapper(cfnScalableTargetScheduledActionPropertyToCloudFormation)(properties.scheduledActions), SuspendedState: cfnScalableTargetSuspendedStatePropertyToCloudFormation(properties.suspendedState) }) : properties;
    }
    function CfnScalableTargetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxCapacity", "MaxCapacity", cfn_parse.FromCloudFormation.getNumber(properties.MaxCapacity)), ret.addPropertyResult("minCapacity", "MinCapacity", cfn_parse.FromCloudFormation.getNumber(properties.MinCapacity)), ret.addPropertyResult("resourceId", "ResourceId", cfn_parse.FromCloudFormation.getString(properties.ResourceId)), ret.addPropertyResult("roleArn", "RoleARN", cfn_parse.FromCloudFormation.getString(properties.RoleARN)), ret.addPropertyResult("scalableDimension", "ScalableDimension", cfn_parse.FromCloudFormation.getString(properties.ScalableDimension)), ret.addPropertyResult("serviceNamespace", "ServiceNamespace", cfn_parse.FromCloudFormation.getString(properties.ServiceNamespace)), ret.addPropertyResult("scheduledActions", "ScheduledActions", properties.ScheduledActions != null ? cfn_parse.FromCloudFormation.getArray(CfnScalableTargetScheduledActionPropertyFromCloudFormation)(properties.ScheduledActions) : void 0), ret.addPropertyResult("suspendedState", "SuspendedState", properties.SuspendedState != null ? CfnScalableTargetSuspendedStatePropertyFromCloudFormation(properties.SuspendedState) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnScalableTarget = class _CfnScalableTarget extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnScalableTargetPropsFromCloudFormation(resourceProperties), ret = new _CfnScalableTarget(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnScalableTarget.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_applicationautoscaling_CfnScalableTargetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnScalableTarget), error;
        }
        cdk.requireProperty(props, "maxCapacity", this), cdk.requireProperty(props, "minCapacity", this), cdk.requireProperty(props, "resourceId", this), cdk.requireProperty(props, "roleArn", this), cdk.requireProperty(props, "scalableDimension", this), cdk.requireProperty(props, "serviceNamespace", this), this.maxCapacity = props.maxCapacity, this.minCapacity = props.minCapacity, this.resourceId = props.resourceId, this.roleArn = props.roleArn, this.scalableDimension = props.scalableDimension, this.serviceNamespace = props.serviceNamespace, this.scheduledActions = props.scheduledActions, this.suspendedState = props.suspendedState;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnScalableTarget.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { maxCapacity: this.maxCapacity, minCapacity: this.minCapacity, resourceId: this.resourceId, roleArn: this.roleArn, scalableDimension: this.scalableDimension, serviceNamespace: this.serviceNamespace, scheduledActions: this.scheduledActions, suspendedState: this.suspendedState };
      }
      renderProperties(props) {
        return cfnScalableTargetPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnScalableTarget[_a] = { fqn: "aws-cdk-lib.aws_applicationautoscaling.CfnScalableTarget", version: "2.80.0" }, CfnScalableTarget.CFN_RESOURCE_TYPE_NAME = "AWS::ApplicationAutoScaling::ScalableTarget", exports2.CfnScalableTarget = CfnScalableTarget;
    function CfnScalableTarget_ScalableTargetActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxCapacity", cdk.validateNumber)(properties.maxCapacity)), errors.collect(cdk.propertyValidator("minCapacity", cdk.validateNumber)(properties.minCapacity)), errors.wrap('supplied properties not correct for "ScalableTargetActionProperty"');
    }
    function cfnScalableTargetScalableTargetActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalableTarget_ScalableTargetActionPropertyValidator(properties).assertSuccess(), { MaxCapacity: cdk.numberToCloudFormation(properties.maxCapacity), MinCapacity: cdk.numberToCloudFormation(properties.minCapacity) }) : properties;
    }
    function CfnScalableTargetScalableTargetActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxCapacity", "MaxCapacity", properties.MaxCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxCapacity) : void 0), ret.addPropertyResult("minCapacity", "MinCapacity", properties.MinCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinCapacity) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScalableTarget_ScheduledActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endTime", cdk.validateDate)(properties.endTime)), errors.collect(cdk.propertyValidator("scalableTargetAction", CfnScalableTarget_ScalableTargetActionPropertyValidator)(properties.scalableTargetAction)), errors.collect(cdk.propertyValidator("schedule", cdk.requiredValidator)(properties.schedule)), errors.collect(cdk.propertyValidator("schedule", cdk.validateString)(properties.schedule)), errors.collect(cdk.propertyValidator("scheduledActionName", cdk.requiredValidator)(properties.scheduledActionName)), errors.collect(cdk.propertyValidator("scheduledActionName", cdk.validateString)(properties.scheduledActionName)), errors.collect(cdk.propertyValidator("startTime", cdk.validateDate)(properties.startTime)), errors.collect(cdk.propertyValidator("timezone", cdk.validateString)(properties.timezone)), errors.wrap('supplied properties not correct for "ScheduledActionProperty"');
    }
    function cfnScalableTargetScheduledActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalableTarget_ScheduledActionPropertyValidator(properties).assertSuccess(), { EndTime: cdk.dateToCloudFormation(properties.endTime), ScalableTargetAction: cfnScalableTargetScalableTargetActionPropertyToCloudFormation(properties.scalableTargetAction), Schedule: cdk.stringToCloudFormation(properties.schedule), ScheduledActionName: cdk.stringToCloudFormation(properties.scheduledActionName), StartTime: cdk.dateToCloudFormation(properties.startTime), Timezone: cdk.stringToCloudFormation(properties.timezone) }) : properties;
    }
    function CfnScalableTargetScheduledActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endTime", "EndTime", properties.EndTime != null ? cfn_parse.FromCloudFormation.getDate(properties.EndTime) : void 0), ret.addPropertyResult("scalableTargetAction", "ScalableTargetAction", properties.ScalableTargetAction != null ? CfnScalableTargetScalableTargetActionPropertyFromCloudFormation(properties.ScalableTargetAction) : void 0), ret.addPropertyResult("schedule", "Schedule", cfn_parse.FromCloudFormation.getString(properties.Schedule)), ret.addPropertyResult("scheduledActionName", "ScheduledActionName", cfn_parse.FromCloudFormation.getString(properties.ScheduledActionName)), ret.addPropertyResult("startTime", "StartTime", properties.StartTime != null ? cfn_parse.FromCloudFormation.getDate(properties.StartTime) : void 0), ret.addPropertyResult("timezone", "Timezone", properties.Timezone != null ? cfn_parse.FromCloudFormation.getString(properties.Timezone) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScalableTarget_SuspendedStatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dynamicScalingInSuspended", cdk.validateBoolean)(properties.dynamicScalingInSuspended)), errors.collect(cdk.propertyValidator("dynamicScalingOutSuspended", cdk.validateBoolean)(properties.dynamicScalingOutSuspended)), errors.collect(cdk.propertyValidator("scheduledScalingSuspended", cdk.validateBoolean)(properties.scheduledScalingSuspended)), errors.wrap('supplied properties not correct for "SuspendedStateProperty"');
    }
    function cfnScalableTargetSuspendedStatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalableTarget_SuspendedStatePropertyValidator(properties).assertSuccess(), { DynamicScalingInSuspended: cdk.booleanToCloudFormation(properties.dynamicScalingInSuspended), DynamicScalingOutSuspended: cdk.booleanToCloudFormation(properties.dynamicScalingOutSuspended), ScheduledScalingSuspended: cdk.booleanToCloudFormation(properties.scheduledScalingSuspended) }) : properties;
    }
    function CfnScalableTargetSuspendedStatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dynamicScalingInSuspended", "DynamicScalingInSuspended", properties.DynamicScalingInSuspended != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DynamicScalingInSuspended) : void 0), ret.addPropertyResult("dynamicScalingOutSuspended", "DynamicScalingOutSuspended", properties.DynamicScalingOutSuspended != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DynamicScalingOutSuspended) : void 0), ret.addPropertyResult("scheduledScalingSuspended", "ScheduledScalingSuspended", properties.ScheduledScalingSuspended != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ScheduledScalingSuspended) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScalingPolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("policyName", cdk.requiredValidator)(properties.policyName)), errors.collect(cdk.propertyValidator("policyName", cdk.validateString)(properties.policyName)), errors.collect(cdk.propertyValidator("policyType", cdk.requiredValidator)(properties.policyType)), errors.collect(cdk.propertyValidator("policyType", cdk.validateString)(properties.policyType)), errors.collect(cdk.propertyValidator("resourceId", cdk.validateString)(properties.resourceId)), errors.collect(cdk.propertyValidator("scalableDimension", cdk.validateString)(properties.scalableDimension)), errors.collect(cdk.propertyValidator("scalingTargetId", cdk.validateString)(properties.scalingTargetId)), errors.collect(cdk.propertyValidator("serviceNamespace", cdk.validateString)(properties.serviceNamespace)), errors.collect(cdk.propertyValidator("stepScalingPolicyConfiguration", CfnScalingPolicy_StepScalingPolicyConfigurationPropertyValidator)(properties.stepScalingPolicyConfiguration)), errors.collect(cdk.propertyValidator("targetTrackingScalingPolicyConfiguration", CfnScalingPolicy_TargetTrackingScalingPolicyConfigurationPropertyValidator)(properties.targetTrackingScalingPolicyConfiguration)), errors.wrap('supplied properties not correct for "CfnScalingPolicyProps"');
    }
    function cfnScalingPolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPolicyPropsValidator(properties).assertSuccess(), { PolicyName: cdk.stringToCloudFormation(properties.policyName), PolicyType: cdk.stringToCloudFormation(properties.policyType), ResourceId: cdk.stringToCloudFormation(properties.resourceId), ScalableDimension: cdk.stringToCloudFormation(properties.scalableDimension), ScalingTargetId: cdk.stringToCloudFormation(properties.scalingTargetId), ServiceNamespace: cdk.stringToCloudFormation(properties.serviceNamespace), StepScalingPolicyConfiguration: cfnScalingPolicyStepScalingPolicyConfigurationPropertyToCloudFormation(properties.stepScalingPolicyConfiguration), TargetTrackingScalingPolicyConfiguration: cfnScalingPolicyTargetTrackingScalingPolicyConfigurationPropertyToCloudFormation(properties.targetTrackingScalingPolicyConfiguration) }) : properties;
    }
    function CfnScalingPolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("policyName", "PolicyName", cfn_parse.FromCloudFormation.getString(properties.PolicyName)), ret.addPropertyResult("policyType", "PolicyType", cfn_parse.FromCloudFormation.getString(properties.PolicyType)), ret.addPropertyResult("resourceId", "ResourceId", properties.ResourceId != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceId) : void 0), ret.addPropertyResult("scalableDimension", "ScalableDimension", properties.ScalableDimension != null ? cfn_parse.FromCloudFormation.getString(properties.ScalableDimension) : void 0), ret.addPropertyResult("scalingTargetId", "ScalingTargetId", properties.ScalingTargetId != null ? cfn_parse.FromCloudFormation.getString(properties.ScalingTargetId) : void 0), ret.addPropertyResult("serviceNamespace", "ServiceNamespace", properties.ServiceNamespace != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceNamespace) : void 0), ret.addPropertyResult("stepScalingPolicyConfiguration", "StepScalingPolicyConfiguration", properties.StepScalingPolicyConfiguration != null ? CfnScalingPolicyStepScalingPolicyConfigurationPropertyFromCloudFormation(properties.StepScalingPolicyConfiguration) : void 0), ret.addPropertyResult("targetTrackingScalingPolicyConfiguration", "TargetTrackingScalingPolicyConfiguration", properties.TargetTrackingScalingPolicyConfiguration != null ? CfnScalingPolicyTargetTrackingScalingPolicyConfigurationPropertyFromCloudFormation(properties.TargetTrackingScalingPolicyConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnScalingPolicy = class _CfnScalingPolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnScalingPolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnScalingPolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnScalingPolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_applicationautoscaling_CfnScalingPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnScalingPolicy), error;
        }
        cdk.requireProperty(props, "policyName", this), cdk.requireProperty(props, "policyType", this), this.policyName = props.policyName, this.policyType = props.policyType, this.resourceId = props.resourceId, this.scalableDimension = props.scalableDimension, this.scalingTargetId = props.scalingTargetId, this.serviceNamespace = props.serviceNamespace, this.stepScalingPolicyConfiguration = props.stepScalingPolicyConfiguration, this.targetTrackingScalingPolicyConfiguration = props.targetTrackingScalingPolicyConfiguration;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnScalingPolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { policyName: this.policyName, policyType: this.policyType, resourceId: this.resourceId, scalableDimension: this.scalableDimension, scalingTargetId: this.scalingTargetId, serviceNamespace: this.serviceNamespace, stepScalingPolicyConfiguration: this.stepScalingPolicyConfiguration, targetTrackingScalingPolicyConfiguration: this.targetTrackingScalingPolicyConfiguration };
      }
      renderProperties(props) {
        return cfnScalingPolicyPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnScalingPolicy[_b] = { fqn: "aws-cdk-lib.aws_applicationautoscaling.CfnScalingPolicy", version: "2.80.0" }, CfnScalingPolicy.CFN_RESOURCE_TYPE_NAME = "AWS::ApplicationAutoScaling::ScalingPolicy", exports2.CfnScalingPolicy = CfnScalingPolicy;
    function CfnScalingPolicy_CustomizedMetricSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dimensions", cdk.listValidator(CfnScalingPolicy_MetricDimensionPropertyValidator))(properties.dimensions)), errors.collect(cdk.propertyValidator("metricName", cdk.requiredValidator)(properties.metricName)), errors.collect(cdk.propertyValidator("metricName", cdk.validateString)(properties.metricName)), errors.collect(cdk.propertyValidator("namespace", cdk.requiredValidator)(properties.namespace)), errors.collect(cdk.propertyValidator("namespace", cdk.validateString)(properties.namespace)), errors.collect(cdk.propertyValidator("statistic", cdk.requiredValidator)(properties.statistic)), errors.collect(cdk.propertyValidator("statistic", cdk.validateString)(properties.statistic)), errors.collect(cdk.propertyValidator("unit", cdk.validateString)(properties.unit)), errors.wrap('supplied properties not correct for "CustomizedMetricSpecificationProperty"');
    }
    function cfnScalingPolicyCustomizedMetricSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPolicy_CustomizedMetricSpecificationPropertyValidator(properties).assertSuccess(), { Dimensions: cdk.listMapper(cfnScalingPolicyMetricDimensionPropertyToCloudFormation)(properties.dimensions), MetricName: cdk.stringToCloudFormation(properties.metricName), Namespace: cdk.stringToCloudFormation(properties.namespace), Statistic: cdk.stringToCloudFormation(properties.statistic), Unit: cdk.stringToCloudFormation(properties.unit) }) : properties;
    }
    function CfnScalingPolicyCustomizedMetricSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dimensions", "Dimensions", properties.Dimensions != null ? cfn_parse.FromCloudFormation.getArray(CfnScalingPolicyMetricDimensionPropertyFromCloudFormation)(properties.Dimensions) : void 0), ret.addPropertyResult("metricName", "MetricName", cfn_parse.FromCloudFormation.getString(properties.MetricName)), ret.addPropertyResult("namespace", "Namespace", cfn_parse.FromCloudFormation.getString(properties.Namespace)), ret.addPropertyResult("statistic", "Statistic", cfn_parse.FromCloudFormation.getString(properties.Statistic)), ret.addPropertyResult("unit", "Unit", properties.Unit != null ? cfn_parse.FromCloudFormation.getString(properties.Unit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScalingPolicy_MetricDimensionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "MetricDimensionProperty"');
    }
    function cfnScalingPolicyMetricDimensionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPolicy_MetricDimensionPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnScalingPolicyMetricDimensionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScalingPolicy_PredefinedMetricSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("predefinedMetricType", cdk.requiredValidator)(properties.predefinedMetricType)), errors.collect(cdk.propertyValidator("predefinedMetricType", cdk.validateString)(properties.predefinedMetricType)), errors.collect(cdk.propertyValidator("resourceLabel", cdk.validateString)(properties.resourceLabel)), errors.wrap('supplied properties not correct for "PredefinedMetricSpecificationProperty"');
    }
    function cfnScalingPolicyPredefinedMetricSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPolicy_PredefinedMetricSpecificationPropertyValidator(properties).assertSuccess(), { PredefinedMetricType: cdk.stringToCloudFormation(properties.predefinedMetricType), ResourceLabel: cdk.stringToCloudFormation(properties.resourceLabel) }) : properties;
    }
    function CfnScalingPolicyPredefinedMetricSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("predefinedMetricType", "PredefinedMetricType", cfn_parse.FromCloudFormation.getString(properties.PredefinedMetricType)), ret.addPropertyResult("resourceLabel", "ResourceLabel", properties.ResourceLabel != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceLabel) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScalingPolicy_StepAdjustmentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("metricIntervalLowerBound", cdk.validateNumber)(properties.metricIntervalLowerBound)), errors.collect(cdk.propertyValidator("metricIntervalUpperBound", cdk.validateNumber)(properties.metricIntervalUpperBound)), errors.collect(cdk.propertyValidator("scalingAdjustment", cdk.requiredValidator)(properties.scalingAdjustment)), errors.collect(cdk.propertyValidator("scalingAdjustment", cdk.validateNumber)(properties.scalingAdjustment)), errors.wrap('supplied properties not correct for "StepAdjustmentProperty"');
    }
    function cfnScalingPolicyStepAdjustmentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPolicy_StepAdjustmentPropertyValidator(properties).assertSuccess(), { MetricIntervalLowerBound: cdk.numberToCloudFormation(properties.metricIntervalLowerBound), MetricIntervalUpperBound: cdk.numberToCloudFormation(properties.metricIntervalUpperBound), ScalingAdjustment: cdk.numberToCloudFormation(properties.scalingAdjustment) }) : properties;
    }
    function CfnScalingPolicyStepAdjustmentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("metricIntervalLowerBound", "MetricIntervalLowerBound", properties.MetricIntervalLowerBound != null ? cfn_parse.FromCloudFormation.getNumber(properties.MetricIntervalLowerBound) : void 0), ret.addPropertyResult("metricIntervalUpperBound", "MetricIntervalUpperBound", properties.MetricIntervalUpperBound != null ? cfn_parse.FromCloudFormation.getNumber(properties.MetricIntervalUpperBound) : void 0), ret.addPropertyResult("scalingAdjustment", "ScalingAdjustment", cfn_parse.FromCloudFormation.getNumber(properties.ScalingAdjustment)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScalingPolicy_StepScalingPolicyConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("adjustmentType", cdk.validateString)(properties.adjustmentType)), errors.collect(cdk.propertyValidator("cooldown", cdk.validateNumber)(properties.cooldown)), errors.collect(cdk.propertyValidator("metricAggregationType", cdk.validateString)(properties.metricAggregationType)), errors.collect(cdk.propertyValidator("minAdjustmentMagnitude", cdk.validateNumber)(properties.minAdjustmentMagnitude)), errors.collect(cdk.propertyValidator("stepAdjustments", cdk.listValidator(CfnScalingPolicy_StepAdjustmentPropertyValidator))(properties.stepAdjustments)), errors.wrap('supplied properties not correct for "StepScalingPolicyConfigurationProperty"');
    }
    function cfnScalingPolicyStepScalingPolicyConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPolicy_StepScalingPolicyConfigurationPropertyValidator(properties).assertSuccess(), { AdjustmentType: cdk.stringToCloudFormation(properties.adjustmentType), Cooldown: cdk.numberToCloudFormation(properties.cooldown), MetricAggregationType: cdk.stringToCloudFormation(properties.metricAggregationType), MinAdjustmentMagnitude: cdk.numberToCloudFormation(properties.minAdjustmentMagnitude), StepAdjustments: cdk.listMapper(cfnScalingPolicyStepAdjustmentPropertyToCloudFormation)(properties.stepAdjustments) }) : properties;
    }
    function CfnScalingPolicyStepScalingPolicyConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("adjustmentType", "AdjustmentType", properties.AdjustmentType != null ? cfn_parse.FromCloudFormation.getString(properties.AdjustmentType) : void 0), ret.addPropertyResult("cooldown", "Cooldown", properties.Cooldown != null ? cfn_parse.FromCloudFormation.getNumber(properties.Cooldown) : void 0), ret.addPropertyResult("metricAggregationType", "MetricAggregationType", properties.MetricAggregationType != null ? cfn_parse.FromCloudFormation.getString(properties.MetricAggregationType) : void 0), ret.addPropertyResult("minAdjustmentMagnitude", "MinAdjustmentMagnitude", properties.MinAdjustmentMagnitude != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinAdjustmentMagnitude) : void 0), ret.addPropertyResult("stepAdjustments", "StepAdjustments", properties.StepAdjustments != null ? cfn_parse.FromCloudFormation.getArray(CfnScalingPolicyStepAdjustmentPropertyFromCloudFormation)(properties.StepAdjustments) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScalingPolicy_TargetTrackingScalingPolicyConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customizedMetricSpecification", CfnScalingPolicy_CustomizedMetricSpecificationPropertyValidator)(properties.customizedMetricSpecification)), errors.collect(cdk.propertyValidator("disableScaleIn", cdk.validateBoolean)(properties.disableScaleIn)), errors.collect(cdk.propertyValidator("predefinedMetricSpecification", CfnScalingPolicy_PredefinedMetricSpecificationPropertyValidator)(properties.predefinedMetricSpecification)), errors.collect(cdk.propertyValidator("scaleInCooldown", cdk.validateNumber)(properties.scaleInCooldown)), errors.collect(cdk.propertyValidator("scaleOutCooldown", cdk.validateNumber)(properties.scaleOutCooldown)), errors.collect(cdk.propertyValidator("targetValue", cdk.requiredValidator)(properties.targetValue)), errors.collect(cdk.propertyValidator("targetValue", cdk.validateNumber)(properties.targetValue)), errors.wrap('supplied properties not correct for "TargetTrackingScalingPolicyConfigurationProperty"');
    }
    function cfnScalingPolicyTargetTrackingScalingPolicyConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPolicy_TargetTrackingScalingPolicyConfigurationPropertyValidator(properties).assertSuccess(), { CustomizedMetricSpecification: cfnScalingPolicyCustomizedMetricSpecificationPropertyToCloudFormation(properties.customizedMetricSpecification), DisableScaleIn: cdk.booleanToCloudFormation(properties.disableScaleIn), PredefinedMetricSpecification: cfnScalingPolicyPredefinedMetricSpecificationPropertyToCloudFormation(properties.predefinedMetricSpecification), ScaleInCooldown: cdk.numberToCloudFormation(properties.scaleInCooldown), ScaleOutCooldown: cdk.numberToCloudFormation(properties.scaleOutCooldown), TargetValue: cdk.numberToCloudFormation(properties.targetValue) }) : properties;
    }
    function CfnScalingPolicyTargetTrackingScalingPolicyConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customizedMetricSpecification", "CustomizedMetricSpecification", properties.CustomizedMetricSpecification != null ? CfnScalingPolicyCustomizedMetricSpecificationPropertyFromCloudFormation(properties.CustomizedMetricSpecification) : void 0), ret.addPropertyResult("disableScaleIn", "DisableScaleIn", properties.DisableScaleIn != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DisableScaleIn) : void 0), ret.addPropertyResult("predefinedMetricSpecification", "PredefinedMetricSpecification", properties.PredefinedMetricSpecification != null ? CfnScalingPolicyPredefinedMetricSpecificationPropertyFromCloudFormation(properties.PredefinedMetricSpecification) : void 0), ret.addPropertyResult("scaleInCooldown", "ScaleInCooldown", properties.ScaleInCooldown != null ? cfn_parse.FromCloudFormation.getNumber(properties.ScaleInCooldown) : void 0), ret.addPropertyResult("scaleOutCooldown", "ScaleOutCooldown", properties.ScaleOutCooldown != null ? cfn_parse.FromCloudFormation.getNumber(properties.ScaleOutCooldown) : void 0), ret.addPropertyResult("targetValue", "TargetValue", cfn_parse.FromCloudFormation.getNumber(properties.TargetValue)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-applicationautoscaling/lib/target-tracking-scaling-policy.js
var require_target_tracking_scaling_policy = __commonJS({
  "node_modules/aws-cdk-lib/aws-applicationautoscaling/lib/target-tracking-scaling-policy.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PredefinedMetric = exports2.TargetTrackingScalingPolicy = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var applicationautoscaling_generated_1 = require_applicationautoscaling_generated();
    var cdk = require_core2();
    var TargetTrackingScalingPolicy = class _TargetTrackingScalingPolicy extends constructs_1.Construct {
      constructor(scope, id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_applicationautoscaling_TargetTrackingScalingPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _TargetTrackingScalingPolicy), error;
        }
        if (props.customMetric === void 0 == (props.predefinedMetric === void 0))
          throw new Error("Exactly one of 'customMetric' or 'predefinedMetric' must be specified.");
        if (props.customMetric && !props.customMetric.toMetricConfig().metricStat)
          throw new Error("Only direct metrics are supported for Target Tracking. Use Step Scaling or supply a Metric object.");
        super(scope, id);
        const predefinedMetric = props.predefinedMetric === PredefinedMetric.DYNAMODB_WRITE_CAPACITY_UTILIZATION ? PredefinedMetric.DYANMODB_WRITE_CAPACITY_UTILIZATION : props.predefinedMetric, resource = new applicationautoscaling_generated_1.CfnScalingPolicy(this, "Resource", { policyName: props.policyName || cdk.Names.uniqueId(this), policyType: "TargetTrackingScaling", scalingTargetId: props.scalingTarget.scalableTargetId, targetTrackingScalingPolicyConfiguration: { customizedMetricSpecification: renderCustomMetric(props.customMetric), disableScaleIn: props.disableScaleIn, predefinedMetricSpecification: predefinedMetric !== void 0 ? { predefinedMetricType: predefinedMetric, resourceLabel: props.resourceLabel } : void 0, scaleInCooldown: props.scaleInCooldown && props.scaleInCooldown.toSeconds(), scaleOutCooldown: props.scaleOutCooldown && props.scaleOutCooldown.toSeconds(), targetValue: props.targetValue } });
        this.scalingPolicyArn = resource.ref;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, TargetTrackingScalingPolicy[_a] = { fqn: "aws-cdk-lib.aws_applicationautoscaling.TargetTrackingScalingPolicy", version: "2.80.0" }, exports2.TargetTrackingScalingPolicy = TargetTrackingScalingPolicy;
    function renderCustomMetric(metric) {
      if (!metric)
        return;
      const c = metric.toMetricConfig().metricStat;
      if (c.statistic.startsWith("p"))
        throw new Error(`Cannot use statistic '${c.statistic}' for Target Tracking: only 'Average', 'Minimum', 'Maximum', 'SampleCount', and 'Sum' are supported.`);
      return { dimensions: c.dimensions, metricName: c.metricName, namespace: c.namespace, statistic: c.statistic, unit: c.unitFilter };
    }
    var PredefinedMetric;
    (function(PredefinedMetric2) {
      PredefinedMetric2.APPSTREAM_AVERAGE_CAPACITY_UTILIZATION = "AppStreamAverageCapacityUtilization", PredefinedMetric2.CASSANDRA_READ_CAPACITY_UTILIZATION = "CassandraReadCapacityUtilization", PredefinedMetric2.CASSANDRA_WRITE_CAPACITY_UTILIZATION = "CassandraWriteCapacityUtilization", PredefinedMetric2.COMPREHEND_INFERENCE_UTILIZATION = "ComprehendInferenceUtilization", PredefinedMetric2.NEPTURE_READER_AVERAGE_CPU_UTILIZATION = "NeptuneReaderAverageCPUUtilization", PredefinedMetric2.DYNAMODB_READ_CAPACITY_UTILIZATION = "DynamoDBReadCapacityUtilization", PredefinedMetric2.DYNAMODB_WRITE_CAPACITY_UTILIZATION = "DynamoDBWriteCapacityUtilization-dummy", PredefinedMetric2.DYANMODB_WRITE_CAPACITY_UTILIZATION = "DynamoDBWriteCapacityUtilization", PredefinedMetric2.ALB_REQUEST_COUNT_PER_TARGET = "ALBRequestCountPerTarget", PredefinedMetric2.RDS_READER_AVERAGE_CPU_UTILIZATION = "RDSReaderAverageCPUUtilization", PredefinedMetric2.RDS_READER_AVERAGE_DATABASE_CONNECTIONS = "RDSReaderAverageDatabaseConnections", PredefinedMetric2.EC2_SPOT_FLEET_REQUEST_AVERAGE_CPU_UTILIZATION = "EC2SpotFleetRequestAverageCPUUtilization", PredefinedMetric2.EC2_SPOT_FLEET_REQUEST_AVERAGE_NETWORK_IN = "EC2SpotFleetRequestAverageNetworkIn", PredefinedMetric2.EC2_SPOT_FLEET_REQUEST_AVERAGE_NETWORK_OUT = "EC2SpotFleetRequestAverageNetworkOut", PredefinedMetric2.SAGEMAKER_VARIANT_INVOCATIONS_PER_INSTANCE = "SageMakerVariantInvocationsPerInstance", PredefinedMetric2.ECS_SERVICE_AVERAGE_CPU_UTILIZATION = "ECSServiceAverageCPUUtilization", PredefinedMetric2.ECS_SERVICE_AVERAGE_MEMORY_UTILIZATION = "ECSServiceAverageMemoryUtilization", PredefinedMetric2.LAMBDA_PROVISIONED_CONCURRENCY_UTILIZATION = "LambdaProvisionedConcurrencyUtilization", PredefinedMetric2.KAFKA_BROKER_STORAGE_UTILIZATION = "KafkaBrokerStorageUtilization", PredefinedMetric2.ELASTICACHE_PRIMARY_ENGINE_CPU_UTILIZATION = "ElastiCachePrimaryEngineCPUUtilization", PredefinedMetric2.ELASTICACHE_REPLICA_ENGINE_CPU_UTILIZATION = "ElastiCacheReplicaEngineCPUUtilization", PredefinedMetric2.ELASTICACHE_DATABASE_MEMORY_USAGE_COUNTED_FOR_EVICT_PERCENTAGE = "ElastiCacheDatabaseMemoryUsageCountedForEvictPercentage";
    })(PredefinedMetric = exports2.PredefinedMetric || (exports2.PredefinedMetric = {}));
  }
});

// node_modules/aws-cdk-lib/aws-cloudwatch/lib/metric-types.js
var require_metric_types = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudwatch/lib/metric-types.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Unit = exports2.Statistic = void 0;
    var Statistic;
    (function(Statistic2) {
      Statistic2.SAMPLE_COUNT = "SampleCount", Statistic2.AVERAGE = "Average", Statistic2.SUM = "Sum", Statistic2.MINIMUM = "Minimum", Statistic2.MAXIMUM = "Maximum";
    })(Statistic = exports2.Statistic || (exports2.Statistic = {}));
    var Unit;
    (function(Unit2) {
      Unit2.SECONDS = "Seconds", Unit2.MICROSECONDS = "Microseconds", Unit2.MILLISECONDS = "Milliseconds", Unit2.BYTES = "Bytes", Unit2.KILOBYTES = "Kilobytes", Unit2.MEGABYTES = "Megabytes", Unit2.GIGABYTES = "Gigabytes", Unit2.TERABYTES = "Terabytes", Unit2.BITS = "Bits", Unit2.KILOBITS = "Kilobits", Unit2.MEGABITS = "Megabits", Unit2.GIGABITS = "Gigabits", Unit2.TERABITS = "Terabits", Unit2.PERCENT = "Percent", Unit2.COUNT = "Count", Unit2.BYTES_PER_SECOND = "Bytes/Second", Unit2.KILOBYTES_PER_SECOND = "Kilobytes/Second", Unit2.MEGABYTES_PER_SECOND = "Megabytes/Second", Unit2.GIGABYTES_PER_SECOND = "Gigabytes/Second", Unit2.TERABYTES_PER_SECOND = "Terabytes/Second", Unit2.BITS_PER_SECOND = "Bits/Second", Unit2.KILOBITS_PER_SECOND = "Kilobits/Second", Unit2.MEGABITS_PER_SECOND = "Megabits/Second", Unit2.GIGABITS_PER_SECOND = "Gigabits/Second", Unit2.TERABITS_PER_SECOND = "Terabits/Second", Unit2.COUNT_PER_SECOND = "Count/Second", Unit2.NONE = "None";
    })(Unit = exports2.Unit || (exports2.Unit = {}));
  }
});

// node_modules/aws-cdk-lib/custom-resources/lib/aws-custom-resource/runtime/index.js
var require_runtime2 = __commonJS({
  "node_modules/aws-cdk-lib/custom-resources/lib/aws-custom-resource/runtime/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.handler = exports2.forceSdkInstallation = exports2.flatten = exports2.PHYSICAL_RESOURCE_ID_REFERENCE = void 0;
    var child_process_1 = require("child_process");
    var fs = require("fs");
    var path_1 = require("path");
    exports2.PHYSICAL_RESOURCE_ID_REFERENCE = "PHYSICAL:RESOURCEID:";
    function flatten(object) {
      return Object.assign({}, ...function _flatten(child, path = []) {
        return [].concat(...Object.keys(child).map((key) => {
          const childKey = Buffer.isBuffer(child[key]) ? child[key].toString("utf8") : child[key];
          return typeof childKey == "object" && childKey !== null ? _flatten(childKey, path.concat([key])) : { [path.concat([key]).join(".")]: childKey };
        }));
      }(object));
    }
    exports2.flatten = flatten;
    function decodeSpecialValues(object, physicalResourceId) {
      return JSON.parse(JSON.stringify(object), (_k, v) => {
        switch (v) {
          case exports2.PHYSICAL_RESOURCE_ID_REFERENCE:
            return physicalResourceId;
          default:
            return v;
        }
      });
    }
    function filterKeys(object, pred) {
      return Object.entries(object).reduce((acc, [k, v]) => pred(k) ? { ...acc, [k]: v } : acc, {});
    }
    var latestSdkInstalled = false;
    function forceSdkInstallation() {
      latestSdkInstalled = false;
    }
    exports2.forceSdkInstallation = forceSdkInstallation;
    function installLatestSdk() {
      console.log("Installing latest AWS SDK v2"), (0, child_process_1.execSync)("HOME=/tmp npm install aws-sdk@2 --production --no-package-lock --no-save --prefix /tmp"), latestSdkInstalled = true;
    }
    var patchedServices = [];
    function patchSdk(awsSdk) {
      const apiLoader = awsSdk.apiLoader;
      return patchedServices.forEach(({ serviceName, apiVersions }) => {
        const lowerServiceName = serviceName.toLowerCase();
        awsSdk.Service.hasService(lowerServiceName) ? awsSdk.Service.addVersions(awsSdk[serviceName], apiVersions) : (apiLoader.services[lowerServiceName] = {}, awsSdk[serviceName] = awsSdk.Service.defineService(lowerServiceName, apiVersions)), apiVersions.forEach((apiVersion) => {
          Object.defineProperty(apiLoader.services[lowerServiceName], apiVersion, { get: function() {
            const modelFilePrefix = `aws-sdk-patch/${lowerServiceName}-${apiVersion}`, model = JSON.parse(fs.readFileSync((0, path_1.join)(__dirname, `${modelFilePrefix}.service.json`), "utf-8"));
            return model.paginators = JSON.parse(fs.readFileSync((0, path_1.join)(__dirname, `${modelFilePrefix}.paginators.json`), "utf-8")).pagination, model;
          }, enumerable: true, configurable: true });
        });
      }), awsSdk;
    }
    async function handler2(event, context) {
      try {
        let AWS2;
        if (!latestSdkInstalled && event.ResourceProperties.InstallLatestAwsSdk === "true")
          try {
            installLatestSdk(), AWS2 = require("/tmp/node_modules/aws-sdk");
          } catch (e) {
            console.log(`Failed to install latest AWS SDK v2: ${e}`), AWS2 = require_aws();
          }
        else
          latestSdkInstalled ? AWS2 = require("/tmp/node_modules/aws-sdk") : AWS2 = require_aws();
        try {
          AWS2 = patchSdk(AWS2);
        } catch (e) {
          console.log(`Failed to patch AWS SDK: ${e}. Proceeding with the installed copy.`);
        }
        console.log(JSON.stringify({ ...event, ResponseURL: "..." })), console.log("AWS SDK VERSION: " + AWS2.VERSION), event.ResourceProperties.Create = decodeCall(event.ResourceProperties.Create), event.ResourceProperties.Update = decodeCall(event.ResourceProperties.Update), event.ResourceProperties.Delete = decodeCall(event.ResourceProperties.Delete);
        let physicalResourceId;
        switch (event.RequestType) {
          case "Create":
            physicalResourceId = event.ResourceProperties.Create?.physicalResourceId?.id ?? event.ResourceProperties.Update?.physicalResourceId?.id ?? event.ResourceProperties.Delete?.physicalResourceId?.id ?? event.LogicalResourceId;
            break;
          case "Update":
          case "Delete":
            physicalResourceId = event.ResourceProperties[event.RequestType]?.physicalResourceId?.id ?? event.PhysicalResourceId;
            break;
        }
        let flatData = {}, data = {};
        const call = event.ResourceProperties[event.RequestType];
        if (call) {
          let credentials;
          if (call.assumedRoleArn) {
            const timestamp = (/* @__PURE__ */ new Date()).getTime(), params = { RoleArn: call.assumedRoleArn, RoleSessionName: `${timestamp}-${physicalResourceId}`.substring(0, 64) };
            credentials = new AWS2.ChainableTemporaryCredentials({ params, stsConfig: { stsRegionalEndpoints: "regional" } });
          }
          if (!Object.prototype.hasOwnProperty.call(AWS2, call.service))
            throw Error(`Service ${call.service} does not exist in AWS SDK version ${AWS2.VERSION}.`);
          const awsService = new AWS2[call.service]({ apiVersion: call.apiVersion, credentials, region: call.region });
          try {
            const response = await awsService[call.action](call.parameters && decodeSpecialValues(call.parameters, physicalResourceId)).promise();
            flatData = { apiVersion: awsService.config.apiVersion, region: awsService.config.region, ...flatten(response) };
            let outputPaths;
            call.outputPath ? outputPaths = [call.outputPath] : call.outputPaths && (outputPaths = call.outputPaths), outputPaths ? data = filterKeys(flatData, startsWithOneOf(outputPaths)) : data = flatData;
          } catch (e) {
            if (!call.ignoreErrorCodesMatching || !new RegExp(call.ignoreErrorCodesMatching).test(e.code))
              throw e;
          }
          call.physicalResourceId?.responsePath && (physicalResourceId = flatData[call.physicalResourceId.responsePath]);
        }
        await respond("SUCCESS", "OK", physicalResourceId, data);
      } catch (e) {
        console.log(e), await respond("FAILED", e.message || "Internal Error", context.logStreamName, {});
      }
      function respond(responseStatus, reason, physicalResourceId, data) {
        const responseBody = JSON.stringify({ Status: responseStatus, Reason: reason, PhysicalResourceId: physicalResourceId, StackId: event.StackId, RequestId: event.RequestId, LogicalResourceId: event.LogicalResourceId, NoEcho: false, Data: data });
        console.log("Responding", responseBody);
        const parsedUrl = require("url").parse(event.ResponseURL), requestOptions = { hostname: parsedUrl.hostname, path: parsedUrl.path, method: "PUT", headers: { "content-type": "", "content-length": Buffer.byteLength(responseBody, "utf8") } };
        return new Promise((resolve, reject) => {
          try {
            const request = require("https").request(requestOptions, resolve);
            request.on("error", reject), request.write(responseBody), request.end();
          } catch (e) {
            reject(e);
          }
        });
      }
    }
    exports2.handler = handler2;
    function decodeCall(call) {
      if (call)
        return JSON.parse(call);
    }
    function startsWithOneOf(searchStrings) {
      return function(string) {
        for (const searchString of searchStrings)
          if (string.startsWith(searchString))
            return true;
        return false;
      };
    }
  }
});

// node_modules/aws-cdk-lib/aws-iam/lib/iam.generated.js
var require_iam_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-iam/lib/iam.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    var _l;
    var _m;
    var _o;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnVirtualMFADevice = exports2.CfnUserToGroupAddition = exports2.CfnUser = exports2.CfnServiceLinkedRole = exports2.CfnServerCertificate = exports2.CfnSAMLProvider = exports2.CfnRole = exports2.CfnPolicy = exports2.CfnOIDCProvider = exports2.CfnManagedPolicy = exports2.CfnInstanceProfile = exports2.CfnGroup = exports2.CfnAccessKey = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAccessKeyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("serial", cdk.validateNumber)(properties.serial)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.collect(cdk.propertyValidator("userName", cdk.requiredValidator)(properties.userName)), errors.collect(cdk.propertyValidator("userName", cdk.validateString)(properties.userName)), errors.wrap('supplied properties not correct for "CfnAccessKeyProps"');
    }
    function cfnAccessKeyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccessKeyPropsValidator(properties).assertSuccess(), { UserName: cdk.stringToCloudFormation(properties.userName), Serial: cdk.numberToCloudFormation(properties.serial), Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnAccessKeyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("userName", "UserName", cfn_parse.FromCloudFormation.getString(properties.UserName)), ret.addPropertyResult("serial", "Serial", properties.Serial != null ? cfn_parse.FromCloudFormation.getNumber(properties.Serial) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAccessKey = class _CfnAccessKey extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAccessKeyPropsFromCloudFormation(resourceProperties), ret = new _CfnAccessKey(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAccessKey.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_CfnAccessKeyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAccessKey), error;
        }
        cdk.requireProperty(props, "userName", this), this.attrSecretAccessKey = cdk.Token.asString(this.getAtt("SecretAccessKey", cdk.ResolutionTypeHint.STRING)), this.userName = props.userName, this.serial = props.serial, this.status = props.status;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAccessKey.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { userName: this.userName, serial: this.serial, status: this.status };
      }
      renderProperties(props) {
        return cfnAccessKeyPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAccessKey[_a] = { fqn: "aws-cdk-lib.aws_iam.CfnAccessKey", version: "2.80.0" }, CfnAccessKey.CFN_RESOURCE_TYPE_NAME = "AWS::IAM::AccessKey", exports2.CfnAccessKey = CfnAccessKey;
    function CfnGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groupName", cdk.validateString)(properties.groupName)), errors.collect(cdk.propertyValidator("managedPolicyArns", cdk.listValidator(cdk.validateString))(properties.managedPolicyArns)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.collect(cdk.propertyValidator("policies", cdk.listValidator(CfnGroup_PolicyPropertyValidator))(properties.policies)), errors.wrap('supplied properties not correct for "CfnGroupProps"');
    }
    function cfnGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGroupPropsValidator(properties).assertSuccess(), { GroupName: cdk.stringToCloudFormation(properties.groupName), ManagedPolicyArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.managedPolicyArns), Path: cdk.stringToCloudFormation(properties.path), Policies: cdk.listMapper(cfnGroupPolicyPropertyToCloudFormation)(properties.policies) }) : properties;
    }
    function CfnGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupName", "GroupName", properties.GroupName != null ? cfn_parse.FromCloudFormation.getString(properties.GroupName) : void 0), ret.addPropertyResult("managedPolicyArns", "ManagedPolicyArns", properties.ManagedPolicyArns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ManagedPolicyArns) : void 0), ret.addPropertyResult("path", "Path", properties.Path != null ? cfn_parse.FromCloudFormation.getString(properties.Path) : void 0), ret.addPropertyResult("policies", "Policies", properties.Policies != null ? cfn_parse.FromCloudFormation.getArray(CfnGroupPolicyPropertyFromCloudFormation)(properties.Policies) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnGroup = class _CfnGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_CfnGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnGroup), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.groupName = props.groupName, this.managedPolicyArns = props.managedPolicyArns, this.path = props.path, this.policies = props.policies;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { groupName: this.groupName, managedPolicyArns: this.managedPolicyArns, path: this.path, policies: this.policies };
      }
      renderProperties(props) {
        return cfnGroupPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnGroup[_b] = { fqn: "aws-cdk-lib.aws_iam.CfnGroup", version: "2.80.0" }, CfnGroup.CFN_RESOURCE_TYPE_NAME = "AWS::IAM::Group", exports2.CfnGroup = CfnGroup;
    function CfnGroup_PolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("policyDocument", cdk.requiredValidator)(properties.policyDocument)), errors.collect(cdk.propertyValidator("policyDocument", cdk.validateObject)(properties.policyDocument)), errors.collect(cdk.propertyValidator("policyName", cdk.requiredValidator)(properties.policyName)), errors.collect(cdk.propertyValidator("policyName", cdk.validateString)(properties.policyName)), errors.wrap('supplied properties not correct for "PolicyProperty"');
    }
    function cfnGroupPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGroup_PolicyPropertyValidator(properties).assertSuccess(), { PolicyDocument: cdk.objectToCloudFormation(properties.policyDocument), PolicyName: cdk.stringToCloudFormation(properties.policyName) }) : properties;
    }
    function CfnGroupPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("policyDocument", "PolicyDocument", cfn_parse.FromCloudFormation.getAny(properties.PolicyDocument)), ret.addPropertyResult("policyName", "PolicyName", cfn_parse.FromCloudFormation.getString(properties.PolicyName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstanceProfilePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceProfileName", cdk.validateString)(properties.instanceProfileName)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.collect(cdk.propertyValidator("roles", cdk.requiredValidator)(properties.roles)), errors.collect(cdk.propertyValidator("roles", cdk.listValidator(cdk.validateString))(properties.roles)), errors.wrap('supplied properties not correct for "CfnInstanceProfileProps"');
    }
    function cfnInstanceProfilePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceProfilePropsValidator(properties).assertSuccess(), { Roles: cdk.listMapper(cdk.stringToCloudFormation)(properties.roles), InstanceProfileName: cdk.stringToCloudFormation(properties.instanceProfileName), Path: cdk.stringToCloudFormation(properties.path) }) : properties;
    }
    function CfnInstanceProfilePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("roles", "Roles", cfn_parse.FromCloudFormation.getStringArray(properties.Roles)), ret.addPropertyResult("instanceProfileName", "InstanceProfileName", properties.InstanceProfileName != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceProfileName) : void 0), ret.addPropertyResult("path", "Path", properties.Path != null ? cfn_parse.FromCloudFormation.getString(properties.Path) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnInstanceProfile = class _CfnInstanceProfile extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnInstanceProfilePropsFromCloudFormation(resourceProperties), ret = new _CfnInstanceProfile(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnInstanceProfile.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_CfnInstanceProfileProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnInstanceProfile), error;
        }
        cdk.requireProperty(props, "roles", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.roles = props.roles, this.instanceProfileName = props.instanceProfileName, this.path = props.path;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnInstanceProfile.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { roles: this.roles, instanceProfileName: this.instanceProfileName, path: this.path };
      }
      renderProperties(props) {
        return cfnInstanceProfilePropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnInstanceProfile[_c] = { fqn: "aws-cdk-lib.aws_iam.CfnInstanceProfile", version: "2.80.0" }, CfnInstanceProfile.CFN_RESOURCE_TYPE_NAME = "AWS::IAM::InstanceProfile", exports2.CfnInstanceProfile = CfnInstanceProfile;
    function CfnManagedPolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("groups", cdk.listValidator(cdk.validateString))(properties.groups)), errors.collect(cdk.propertyValidator("managedPolicyName", cdk.validateString)(properties.managedPolicyName)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.collect(cdk.propertyValidator("policyDocument", cdk.requiredValidator)(properties.policyDocument)), errors.collect(cdk.propertyValidator("policyDocument", cdk.validateObject)(properties.policyDocument)), errors.collect(cdk.propertyValidator("roles", cdk.listValidator(cdk.validateString))(properties.roles)), errors.collect(cdk.propertyValidator("users", cdk.listValidator(cdk.validateString))(properties.users)), errors.wrap('supplied properties not correct for "CfnManagedPolicyProps"');
    }
    function cfnManagedPolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnManagedPolicyPropsValidator(properties).assertSuccess(), { PolicyDocument: cdk.objectToCloudFormation(properties.policyDocument), Description: cdk.stringToCloudFormation(properties.description), Groups: cdk.listMapper(cdk.stringToCloudFormation)(properties.groups), ManagedPolicyName: cdk.stringToCloudFormation(properties.managedPolicyName), Path: cdk.stringToCloudFormation(properties.path), Roles: cdk.listMapper(cdk.stringToCloudFormation)(properties.roles), Users: cdk.listMapper(cdk.stringToCloudFormation)(properties.users) }) : properties;
    }
    function CfnManagedPolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("policyDocument", "PolicyDocument", cfn_parse.FromCloudFormation.getAny(properties.PolicyDocument)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("groups", "Groups", properties.Groups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Groups) : void 0), ret.addPropertyResult("managedPolicyName", "ManagedPolicyName", properties.ManagedPolicyName != null ? cfn_parse.FromCloudFormation.getString(properties.ManagedPolicyName) : void 0), ret.addPropertyResult("path", "Path", properties.Path != null ? cfn_parse.FromCloudFormation.getString(properties.Path) : void 0), ret.addPropertyResult("roles", "Roles", properties.Roles != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Roles) : void 0), ret.addPropertyResult("users", "Users", properties.Users != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Users) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnManagedPolicy = class _CfnManagedPolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnManagedPolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnManagedPolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnManagedPolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_CfnManagedPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnManagedPolicy), error;
        }
        cdk.requireProperty(props, "policyDocument", this), this.policyDocument = props.policyDocument, this.description = props.description, this.groups = props.groups, this.managedPolicyName = props.managedPolicyName, this.path = props.path, this.roles = props.roles, this.users = props.users;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnManagedPolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { policyDocument: this.policyDocument, description: this.description, groups: this.groups, managedPolicyName: this.managedPolicyName, path: this.path, roles: this.roles, users: this.users };
      }
      renderProperties(props) {
        return cfnManagedPolicyPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnManagedPolicy[_d] = { fqn: "aws-cdk-lib.aws_iam.CfnManagedPolicy", version: "2.80.0" }, CfnManagedPolicy.CFN_RESOURCE_TYPE_NAME = "AWS::IAM::ManagedPolicy", exports2.CfnManagedPolicy = CfnManagedPolicy;
    function CfnOIDCProviderPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clientIdList", cdk.listValidator(cdk.validateString))(properties.clientIdList)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("thumbprintList", cdk.requiredValidator)(properties.thumbprintList)), errors.collect(cdk.propertyValidator("thumbprintList", cdk.listValidator(cdk.validateString))(properties.thumbprintList)), errors.collect(cdk.propertyValidator("url", cdk.validateString)(properties.url)), errors.wrap('supplied properties not correct for "CfnOIDCProviderProps"');
    }
    function cfnOIDCProviderPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOIDCProviderPropsValidator(properties).assertSuccess(), { ThumbprintList: cdk.listMapper(cdk.stringToCloudFormation)(properties.thumbprintList), ClientIdList: cdk.listMapper(cdk.stringToCloudFormation)(properties.clientIdList), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), Url: cdk.stringToCloudFormation(properties.url) }) : properties;
    }
    function CfnOIDCProviderPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("thumbprintList", "ThumbprintList", cfn_parse.FromCloudFormation.getStringArray(properties.ThumbprintList)), ret.addPropertyResult("clientIdList", "ClientIdList", properties.ClientIdList != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ClientIdList) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("url", "Url", properties.Url != null ? cfn_parse.FromCloudFormation.getString(properties.Url) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnOIDCProvider = class _CfnOIDCProvider extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnOIDCProviderPropsFromCloudFormation(resourceProperties), ret = new _CfnOIDCProvider(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnOIDCProvider.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_CfnOIDCProviderProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnOIDCProvider), error;
        }
        cdk.requireProperty(props, "thumbprintList", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.thumbprintList = props.thumbprintList, this.clientIdList = props.clientIdList, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IAM::OIDCProvider", props.tags, { tagPropertyName: "tags" }), this.url = props.url;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnOIDCProvider.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { thumbprintList: this.thumbprintList, clientIdList: this.clientIdList, tags: this.tags.renderTags(), url: this.url };
      }
      renderProperties(props) {
        return cfnOIDCProviderPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnOIDCProvider[_e] = { fqn: "aws-cdk-lib.aws_iam.CfnOIDCProvider", version: "2.80.0" }, CfnOIDCProvider.CFN_RESOURCE_TYPE_NAME = "AWS::IAM::OIDCProvider", exports2.CfnOIDCProvider = CfnOIDCProvider;
    function CfnPolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groups", cdk.listValidator(cdk.validateString))(properties.groups)), errors.collect(cdk.propertyValidator("policyDocument", cdk.requiredValidator)(properties.policyDocument)), errors.collect(cdk.propertyValidator("policyDocument", cdk.validateObject)(properties.policyDocument)), errors.collect(cdk.propertyValidator("policyName", cdk.requiredValidator)(properties.policyName)), errors.collect(cdk.propertyValidator("policyName", cdk.validateString)(properties.policyName)), errors.collect(cdk.propertyValidator("roles", cdk.listValidator(cdk.validateString))(properties.roles)), errors.collect(cdk.propertyValidator("users", cdk.listValidator(cdk.validateString))(properties.users)), errors.wrap('supplied properties not correct for "CfnPolicyProps"');
    }
    function cfnPolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPolicyPropsValidator(properties).assertSuccess(), { PolicyDocument: cdk.objectToCloudFormation(properties.policyDocument), PolicyName: cdk.stringToCloudFormation(properties.policyName), Groups: cdk.listMapper(cdk.stringToCloudFormation)(properties.groups), Roles: cdk.listMapper(cdk.stringToCloudFormation)(properties.roles), Users: cdk.listMapper(cdk.stringToCloudFormation)(properties.users) }) : properties;
    }
    function CfnPolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("policyDocument", "PolicyDocument", cfn_parse.FromCloudFormation.getAny(properties.PolicyDocument)), ret.addPropertyResult("policyName", "PolicyName", cfn_parse.FromCloudFormation.getString(properties.PolicyName)), ret.addPropertyResult("groups", "Groups", properties.Groups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Groups) : void 0), ret.addPropertyResult("roles", "Roles", properties.Roles != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Roles) : void 0), ret.addPropertyResult("users", "Users", properties.Users != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Users) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPolicy = class _CfnPolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnPolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_CfnPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPolicy), error;
        }
        cdk.requireProperty(props, "policyDocument", this), cdk.requireProperty(props, "policyName", this), this.policyDocument = props.policyDocument, this.policyName = props.policyName, this.groups = props.groups, this.roles = props.roles, this.users = props.users;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { policyDocument: this.policyDocument, policyName: this.policyName, groups: this.groups, roles: this.roles, users: this.users };
      }
      renderProperties(props) {
        return cfnPolicyPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnPolicy[_f] = { fqn: "aws-cdk-lib.aws_iam.CfnPolicy", version: "2.80.0" }, CfnPolicy.CFN_RESOURCE_TYPE_NAME = "AWS::IAM::Policy", exports2.CfnPolicy = CfnPolicy;
    function CfnRolePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("assumeRolePolicyDocument", cdk.requiredValidator)(properties.assumeRolePolicyDocument)), errors.collect(cdk.propertyValidator("assumeRolePolicyDocument", cdk.validateObject)(properties.assumeRolePolicyDocument)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("managedPolicyArns", cdk.listValidator(cdk.validateString))(properties.managedPolicyArns)), errors.collect(cdk.propertyValidator("maxSessionDuration", cdk.validateNumber)(properties.maxSessionDuration)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.collect(cdk.propertyValidator("permissionsBoundary", cdk.validateString)(properties.permissionsBoundary)), errors.collect(cdk.propertyValidator("policies", cdk.listValidator(CfnRole_PolicyPropertyValidator))(properties.policies)), errors.collect(cdk.propertyValidator("roleName", cdk.validateString)(properties.roleName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnRoleProps"');
    }
    function cfnRolePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRolePropsValidator(properties).assertSuccess(), { AssumeRolePolicyDocument: cdk.objectToCloudFormation(properties.assumeRolePolicyDocument), Description: cdk.stringToCloudFormation(properties.description), ManagedPolicyArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.managedPolicyArns), MaxSessionDuration: cdk.numberToCloudFormation(properties.maxSessionDuration), Path: cdk.stringToCloudFormation(properties.path), PermissionsBoundary: cdk.stringToCloudFormation(properties.permissionsBoundary), Policies: cdk.listMapper(cfnRolePolicyPropertyToCloudFormation)(properties.policies), RoleName: cdk.stringToCloudFormation(properties.roleName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnRolePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("assumeRolePolicyDocument", "AssumeRolePolicyDocument", cfn_parse.FromCloudFormation.getAny(properties.AssumeRolePolicyDocument)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("managedPolicyArns", "ManagedPolicyArns", properties.ManagedPolicyArns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ManagedPolicyArns) : void 0), ret.addPropertyResult("maxSessionDuration", "MaxSessionDuration", properties.MaxSessionDuration != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxSessionDuration) : void 0), ret.addPropertyResult("path", "Path", properties.Path != null ? cfn_parse.FromCloudFormation.getString(properties.Path) : void 0), ret.addPropertyResult("permissionsBoundary", "PermissionsBoundary", properties.PermissionsBoundary != null ? cfn_parse.FromCloudFormation.getString(properties.PermissionsBoundary) : void 0), ret.addPropertyResult("policies", "Policies", properties.Policies != null ? cfn_parse.FromCloudFormation.getArray(CfnRolePolicyPropertyFromCloudFormation)(properties.Policies) : void 0), ret.addPropertyResult("roleName", "RoleName", properties.RoleName != null ? cfn_parse.FromCloudFormation.getString(properties.RoleName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRole = class _CfnRole extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRolePropsFromCloudFormation(resourceProperties), ret = new _CfnRole(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRole.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_CfnRoleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRole), error;
        }
        cdk.requireProperty(props, "assumeRolePolicyDocument", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrRoleId = cdk.Token.asString(this.getAtt("RoleId", cdk.ResolutionTypeHint.STRING)), this.assumeRolePolicyDocument = props.assumeRolePolicyDocument, this.description = props.description, this.managedPolicyArns = props.managedPolicyArns, this.maxSessionDuration = props.maxSessionDuration, this.path = props.path, this.permissionsBoundary = props.permissionsBoundary, this.policies = props.policies, this.roleName = props.roleName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IAM::Role", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRole.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { assumeRolePolicyDocument: this.assumeRolePolicyDocument, description: this.description, managedPolicyArns: this.managedPolicyArns, maxSessionDuration: this.maxSessionDuration, path: this.path, permissionsBoundary: this.permissionsBoundary, policies: this.policies, roleName: this.roleName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnRolePropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnRole[_g] = { fqn: "aws-cdk-lib.aws_iam.CfnRole", version: "2.80.0" }, CfnRole.CFN_RESOURCE_TYPE_NAME = "AWS::IAM::Role", exports2.CfnRole = CfnRole;
    function CfnRole_PolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("policyDocument", cdk.requiredValidator)(properties.policyDocument)), errors.collect(cdk.propertyValidator("policyDocument", cdk.validateObject)(properties.policyDocument)), errors.collect(cdk.propertyValidator("policyName", cdk.requiredValidator)(properties.policyName)), errors.collect(cdk.propertyValidator("policyName", cdk.validateString)(properties.policyName)), errors.wrap('supplied properties not correct for "PolicyProperty"');
    }
    function cfnRolePolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRole_PolicyPropertyValidator(properties).assertSuccess(), { PolicyDocument: cdk.objectToCloudFormation(properties.policyDocument), PolicyName: cdk.stringToCloudFormation(properties.policyName) }) : properties;
    }
    function CfnRolePolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("policyDocument", "PolicyDocument", cfn_parse.FromCloudFormation.getAny(properties.PolicyDocument)), ret.addPropertyResult("policyName", "PolicyName", cfn_parse.FromCloudFormation.getString(properties.PolicyName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSAMLProviderPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("samlMetadataDocument", cdk.requiredValidator)(properties.samlMetadataDocument)), errors.collect(cdk.propertyValidator("samlMetadataDocument", cdk.validateString)(properties.samlMetadataDocument)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnSAMLProviderProps"');
    }
    function cfnSAMLProviderPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSAMLProviderPropsValidator(properties).assertSuccess(), { SamlMetadataDocument: cdk.stringToCloudFormation(properties.samlMetadataDocument), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnSAMLProviderPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("samlMetadataDocument", "SamlMetadataDocument", cfn_parse.FromCloudFormation.getString(properties.SamlMetadataDocument)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSAMLProvider = class _CfnSAMLProvider extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSAMLProviderPropsFromCloudFormation(resourceProperties), ret = new _CfnSAMLProvider(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSAMLProvider.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_CfnSAMLProviderProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSAMLProvider), error;
        }
        cdk.requireProperty(props, "samlMetadataDocument", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.samlMetadataDocument = props.samlMetadataDocument, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IAM::SAMLProvider", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSAMLProvider.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { samlMetadataDocument: this.samlMetadataDocument, name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnSAMLProviderPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnSAMLProvider[_h] = { fqn: "aws-cdk-lib.aws_iam.CfnSAMLProvider", version: "2.80.0" }, CfnSAMLProvider.CFN_RESOURCE_TYPE_NAME = "AWS::IAM::SAMLProvider", exports2.CfnSAMLProvider = CfnSAMLProvider;
    function CfnServerCertificatePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateBody", cdk.validateString)(properties.certificateBody)), errors.collect(cdk.propertyValidator("certificateChain", cdk.validateString)(properties.certificateChain)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.collect(cdk.propertyValidator("privateKey", cdk.validateString)(properties.privateKey)), errors.collect(cdk.propertyValidator("serverCertificateName", cdk.validateString)(properties.serverCertificateName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnServerCertificateProps"');
    }
    function cfnServerCertificatePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnServerCertificatePropsValidator(properties).assertSuccess(), { CertificateBody: cdk.stringToCloudFormation(properties.certificateBody), CertificateChain: cdk.stringToCloudFormation(properties.certificateChain), Path: cdk.stringToCloudFormation(properties.path), PrivateKey: cdk.stringToCloudFormation(properties.privateKey), ServerCertificateName: cdk.stringToCloudFormation(properties.serverCertificateName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnServerCertificatePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificateBody", "CertificateBody", properties.CertificateBody != null ? cfn_parse.FromCloudFormation.getString(properties.CertificateBody) : void 0), ret.addPropertyResult("certificateChain", "CertificateChain", properties.CertificateChain != null ? cfn_parse.FromCloudFormation.getString(properties.CertificateChain) : void 0), ret.addPropertyResult("path", "Path", properties.Path != null ? cfn_parse.FromCloudFormation.getString(properties.Path) : void 0), ret.addPropertyResult("privateKey", "PrivateKey", properties.PrivateKey != null ? cfn_parse.FromCloudFormation.getString(properties.PrivateKey) : void 0), ret.addPropertyResult("serverCertificateName", "ServerCertificateName", properties.ServerCertificateName != null ? cfn_parse.FromCloudFormation.getString(properties.ServerCertificateName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnServerCertificate = class _CfnServerCertificate extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnServerCertificatePropsFromCloudFormation(resourceProperties), ret = new _CfnServerCertificate(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnServerCertificate.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_CfnServerCertificateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnServerCertificate), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.certificateBody = props.certificateBody, this.certificateChain = props.certificateChain, this.path = props.path, this.privateKey = props.privateKey, this.serverCertificateName = props.serverCertificateName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IAM::ServerCertificate", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnServerCertificate.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { certificateBody: this.certificateBody, certificateChain: this.certificateChain, path: this.path, privateKey: this.privateKey, serverCertificateName: this.serverCertificateName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnServerCertificatePropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnServerCertificate[_j] = { fqn: "aws-cdk-lib.aws_iam.CfnServerCertificate", version: "2.80.0" }, CfnServerCertificate.CFN_RESOURCE_TYPE_NAME = "AWS::IAM::ServerCertificate", exports2.CfnServerCertificate = CfnServerCertificate;
    function CfnServiceLinkedRolePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("awsServiceName", cdk.requiredValidator)(properties.awsServiceName)), errors.collect(cdk.propertyValidator("awsServiceName", cdk.validateString)(properties.awsServiceName)), errors.collect(cdk.propertyValidator("customSuffix", cdk.validateString)(properties.customSuffix)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.wrap('supplied properties not correct for "CfnServiceLinkedRoleProps"');
    }
    function cfnServiceLinkedRolePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnServiceLinkedRolePropsValidator(properties).assertSuccess(), { AWSServiceName: cdk.stringToCloudFormation(properties.awsServiceName), CustomSuffix: cdk.stringToCloudFormation(properties.customSuffix), Description: cdk.stringToCloudFormation(properties.description) }) : properties;
    }
    function CfnServiceLinkedRolePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("awsServiceName", "AWSServiceName", cfn_parse.FromCloudFormation.getString(properties.AWSServiceName)), ret.addPropertyResult("customSuffix", "CustomSuffix", properties.CustomSuffix != null ? cfn_parse.FromCloudFormation.getString(properties.CustomSuffix) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnServiceLinkedRole = class _CfnServiceLinkedRole extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnServiceLinkedRolePropsFromCloudFormation(resourceProperties), ret = new _CfnServiceLinkedRole(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnServiceLinkedRole.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_CfnServiceLinkedRoleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnServiceLinkedRole), error;
        }
        cdk.requireProperty(props, "awsServiceName", this), this.awsServiceName = props.awsServiceName, this.customSuffix = props.customSuffix, this.description = props.description;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnServiceLinkedRole.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { awsServiceName: this.awsServiceName, customSuffix: this.customSuffix, description: this.description };
      }
      renderProperties(props) {
        return cfnServiceLinkedRolePropsToCloudFormation(props);
      }
    };
    _k = JSII_RTTI_SYMBOL_1, CfnServiceLinkedRole[_k] = { fqn: "aws-cdk-lib.aws_iam.CfnServiceLinkedRole", version: "2.80.0" }, CfnServiceLinkedRole.CFN_RESOURCE_TYPE_NAME = "AWS::IAM::ServiceLinkedRole", exports2.CfnServiceLinkedRole = CfnServiceLinkedRole;
    function CfnUserPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groups", cdk.listValidator(cdk.validateString))(properties.groups)), errors.collect(cdk.propertyValidator("loginProfile", CfnUser_LoginProfilePropertyValidator)(properties.loginProfile)), errors.collect(cdk.propertyValidator("managedPolicyArns", cdk.listValidator(cdk.validateString))(properties.managedPolicyArns)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.collect(cdk.propertyValidator("permissionsBoundary", cdk.validateString)(properties.permissionsBoundary)), errors.collect(cdk.propertyValidator("policies", cdk.listValidator(CfnUser_PolicyPropertyValidator))(properties.policies)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("userName", cdk.validateString)(properties.userName)), errors.wrap('supplied properties not correct for "CfnUserProps"');
    }
    function cfnUserPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPropsValidator(properties).assertSuccess(), { Groups: cdk.listMapper(cdk.stringToCloudFormation)(properties.groups), LoginProfile: cfnUserLoginProfilePropertyToCloudFormation(properties.loginProfile), ManagedPolicyArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.managedPolicyArns), Path: cdk.stringToCloudFormation(properties.path), PermissionsBoundary: cdk.stringToCloudFormation(properties.permissionsBoundary), Policies: cdk.listMapper(cfnUserPolicyPropertyToCloudFormation)(properties.policies), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), UserName: cdk.stringToCloudFormation(properties.userName) }) : properties;
    }
    function CfnUserPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groups", "Groups", properties.Groups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Groups) : void 0), ret.addPropertyResult("loginProfile", "LoginProfile", properties.LoginProfile != null ? CfnUserLoginProfilePropertyFromCloudFormation(properties.LoginProfile) : void 0), ret.addPropertyResult("managedPolicyArns", "ManagedPolicyArns", properties.ManagedPolicyArns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ManagedPolicyArns) : void 0), ret.addPropertyResult("path", "Path", properties.Path != null ? cfn_parse.FromCloudFormation.getString(properties.Path) : void 0), ret.addPropertyResult("permissionsBoundary", "PermissionsBoundary", properties.PermissionsBoundary != null ? cfn_parse.FromCloudFormation.getString(properties.PermissionsBoundary) : void 0), ret.addPropertyResult("policies", "Policies", properties.Policies != null ? cfn_parse.FromCloudFormation.getArray(CfnUserPolicyPropertyFromCloudFormation)(properties.Policies) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("userName", "UserName", properties.UserName != null ? cfn_parse.FromCloudFormation.getString(properties.UserName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnUser = class _CfnUser extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnUserPropsFromCloudFormation(resourceProperties), ret = new _CfnUser(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnUser.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_CfnUserProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnUser), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.groups = props.groups, this.loginProfile = props.loginProfile, this.managedPolicyArns = props.managedPolicyArns, this.path = props.path, this.permissionsBoundary = props.permissionsBoundary, this.policies = props.policies, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IAM::User", props.tags, { tagPropertyName: "tags" }), this.userName = props.userName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnUser.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { groups: this.groups, loginProfile: this.loginProfile, managedPolicyArns: this.managedPolicyArns, path: this.path, permissionsBoundary: this.permissionsBoundary, policies: this.policies, tags: this.tags.renderTags(), userName: this.userName };
      }
      renderProperties(props) {
        return cfnUserPropsToCloudFormation(props);
      }
    };
    _l = JSII_RTTI_SYMBOL_1, CfnUser[_l] = { fqn: "aws-cdk-lib.aws_iam.CfnUser", version: "2.80.0" }, CfnUser.CFN_RESOURCE_TYPE_NAME = "AWS::IAM::User", exports2.CfnUser = CfnUser;
    function CfnUser_LoginProfilePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("password", cdk.requiredValidator)(properties.password)), errors.collect(cdk.propertyValidator("password", cdk.validateString)(properties.password)), errors.collect(cdk.propertyValidator("passwordResetRequired", cdk.validateBoolean)(properties.passwordResetRequired)), errors.wrap('supplied properties not correct for "LoginProfileProperty"');
    }
    function cfnUserLoginProfilePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUser_LoginProfilePropertyValidator(properties).assertSuccess(), { Password: cdk.stringToCloudFormation(properties.password), PasswordResetRequired: cdk.booleanToCloudFormation(properties.passwordResetRequired) }) : properties;
    }
    function CfnUserLoginProfilePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("password", "Password", cfn_parse.FromCloudFormation.getString(properties.Password)), ret.addPropertyResult("passwordResetRequired", "PasswordResetRequired", properties.PasswordResetRequired != null ? cfn_parse.FromCloudFormation.getBoolean(properties.PasswordResetRequired) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUser_PolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("policyDocument", cdk.requiredValidator)(properties.policyDocument)), errors.collect(cdk.propertyValidator("policyDocument", cdk.validateObject)(properties.policyDocument)), errors.collect(cdk.propertyValidator("policyName", cdk.requiredValidator)(properties.policyName)), errors.collect(cdk.propertyValidator("policyName", cdk.validateString)(properties.policyName)), errors.wrap('supplied properties not correct for "PolicyProperty"');
    }
    function cfnUserPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUser_PolicyPropertyValidator(properties).assertSuccess(), { PolicyDocument: cdk.objectToCloudFormation(properties.policyDocument), PolicyName: cdk.stringToCloudFormation(properties.policyName) }) : properties;
    }
    function CfnUserPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("policyDocument", "PolicyDocument", cfn_parse.FromCloudFormation.getAny(properties.PolicyDocument)), ret.addPropertyResult("policyName", "PolicyName", cfn_parse.FromCloudFormation.getString(properties.PolicyName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserToGroupAdditionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groupName", cdk.requiredValidator)(properties.groupName)), errors.collect(cdk.propertyValidator("groupName", cdk.validateString)(properties.groupName)), errors.collect(cdk.propertyValidator("users", cdk.requiredValidator)(properties.users)), errors.collect(cdk.propertyValidator("users", cdk.listValidator(cdk.validateString))(properties.users)), errors.wrap('supplied properties not correct for "CfnUserToGroupAdditionProps"');
    }
    function cfnUserToGroupAdditionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserToGroupAdditionPropsValidator(properties).assertSuccess(), { GroupName: cdk.stringToCloudFormation(properties.groupName), Users: cdk.listMapper(cdk.stringToCloudFormation)(properties.users) }) : properties;
    }
    function CfnUserToGroupAdditionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupName", "GroupName", cfn_parse.FromCloudFormation.getString(properties.GroupName)), ret.addPropertyResult("users", "Users", cfn_parse.FromCloudFormation.getStringArray(properties.Users)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnUserToGroupAddition = class _CfnUserToGroupAddition extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnUserToGroupAdditionPropsFromCloudFormation(resourceProperties), ret = new _CfnUserToGroupAddition(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnUserToGroupAddition.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_CfnUserToGroupAdditionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnUserToGroupAddition), error;
        }
        cdk.requireProperty(props, "groupName", this), cdk.requireProperty(props, "users", this), this.groupName = props.groupName, this.users = props.users;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnUserToGroupAddition.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { groupName: this.groupName, users: this.users };
      }
      renderProperties(props) {
        return cfnUserToGroupAdditionPropsToCloudFormation(props);
      }
    };
    _m = JSII_RTTI_SYMBOL_1, CfnUserToGroupAddition[_m] = { fqn: "aws-cdk-lib.aws_iam.CfnUserToGroupAddition", version: "2.80.0" }, CfnUserToGroupAddition.CFN_RESOURCE_TYPE_NAME = "AWS::IAM::UserToGroupAddition", exports2.CfnUserToGroupAddition = CfnUserToGroupAddition;
    function CfnVirtualMFADevicePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("users", cdk.requiredValidator)(properties.users)), errors.collect(cdk.propertyValidator("users", cdk.listValidator(cdk.validateString))(properties.users)), errors.collect(cdk.propertyValidator("virtualMfaDeviceName", cdk.validateString)(properties.virtualMfaDeviceName)), errors.wrap('supplied properties not correct for "CfnVirtualMFADeviceProps"');
    }
    function cfnVirtualMFADevicePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualMFADevicePropsValidator(properties).assertSuccess(), { Users: cdk.listMapper(cdk.stringToCloudFormation)(properties.users), Path: cdk.stringToCloudFormation(properties.path), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VirtualMfaDeviceName: cdk.stringToCloudFormation(properties.virtualMfaDeviceName) }) : properties;
    }
    function CfnVirtualMFADevicePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("users", "Users", cfn_parse.FromCloudFormation.getStringArray(properties.Users)), ret.addPropertyResult("path", "Path", properties.Path != null ? cfn_parse.FromCloudFormation.getString(properties.Path) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("virtualMfaDeviceName", "VirtualMfaDeviceName", properties.VirtualMfaDeviceName != null ? cfn_parse.FromCloudFormation.getString(properties.VirtualMfaDeviceName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVirtualMFADevice = class _CfnVirtualMFADevice extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVirtualMFADevicePropsFromCloudFormation(resourceProperties), ret = new _CfnVirtualMFADevice(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVirtualMFADevice.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_CfnVirtualMFADeviceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVirtualMFADevice), error;
        }
        cdk.requireProperty(props, "users", this), this.attrSerialNumber = cdk.Token.asString(this.getAtt("SerialNumber", cdk.ResolutionTypeHint.STRING)), this.users = props.users, this.path = props.path, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IAM::VirtualMFADevice", props.tags, { tagPropertyName: "tags" }), this.virtualMfaDeviceName = props.virtualMfaDeviceName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVirtualMFADevice.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { users: this.users, path: this.path, tags: this.tags.renderTags(), virtualMfaDeviceName: this.virtualMfaDeviceName };
      }
      renderProperties(props) {
        return cfnVirtualMFADevicePropsToCloudFormation(props);
      }
    };
    _o = JSII_RTTI_SYMBOL_1, CfnVirtualMFADevice[_o] = { fqn: "aws-cdk-lib.aws_iam.CfnVirtualMFADevice", version: "2.80.0" }, CfnVirtualMFADevice.CFN_RESOURCE_TYPE_NAME = "AWS::IAM::VirtualMFADevice", exports2.CfnVirtualMFADevice = CfnVirtualMFADevice;
  }
});

// node_modules/aws-cdk-lib/aws-iam/lib/private/util.js
var require_util3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-iam/lib/private/util.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.sum = exports2.UniqueStringSet = exports2.mergePrincipal = exports2.AttachedPolicies = exports2.generatePolicyName = exports2.undefinedIfEmpty = exports2.LITERAL_STRING_KEY = void 0;
    var core_1 = require_core2();
    var MAX_POLICY_NAME_LEN = 128;
    exports2.LITERAL_STRING_KEY = "LiteralString";
    function undefinedIfEmpty(f) {
      return core_1.Lazy.list({ produce: () => {
        const array = f();
        return array && array.length > 0 ? array : void 0;
      } });
    }
    exports2.undefinedIfEmpty = undefinedIfEmpty;
    function generatePolicyName(scope, logicalId) {
      const resolvedLogicalId = core_1.Tokenization.resolve(logicalId, { scope, resolver: new core_1.DefaultTokenResolver(new core_1.StringConcat()) });
      return lastNCharacters(resolvedLogicalId, MAX_POLICY_NAME_LEN);
    }
    exports2.generatePolicyName = generatePolicyName;
    function lastNCharacters(str, n) {
      const startIndex = Math.max(str.length - n, 0);
      return str.substring(startIndex, str.length);
    }
    var AttachedPolicies = class {
      constructor() {
        this.policies = new Array();
      }
      attach(policy) {
        if (!this.policies.find((p) => p === policy)) {
          if (this.policies.find((p) => p.policyName === policy.policyName))
            throw new Error(`A policy named "${policy.policyName}" is already attached`);
          this.policies.push(policy);
        }
      }
    };
    exports2.AttachedPolicies = AttachedPolicies;
    function mergePrincipal(target, source) {
      const sourceKeys = Object.keys(source), targetKeys = Object.keys(target);
      if (exports2.LITERAL_STRING_KEY in source && targetKeys.some((k) => k !== exports2.LITERAL_STRING_KEY) || exports2.LITERAL_STRING_KEY in target && sourceKeys.some((k) => k !== exports2.LITERAL_STRING_KEY))
        throw new Error(`Cannot merge principals ${JSON.stringify(target)} and ${JSON.stringify(source)}; if one uses a literal principal string the other one must be empty`);
      for (const key of sourceKeys) {
        target[key] = target[key] ?? [];
        let value = source[key];
        Array.isArray(value) || (value = [value]), target[key].push(...value);
      }
      return target;
    }
    exports2.mergePrincipal = mergePrincipal;
    var UniqueStringSet = class _UniqueStringSet {
      static from(fn) {
        return core_1.Token.asList(new _UniqueStringSet(fn));
      }
      constructor(fn) {
        this.fn = fn, this.creationStack = (0, core_1.captureStackTrace)();
      }
      resolve(context) {
        return context.registerPostProcessor(this), this.fn();
      }
      postProcess(input, _context) {
        if (!Array.isArray(input))
          return input;
        if (input.length === 0)
          return;
        const uniq = {};
        for (const el of input)
          uniq[JSON.stringify(el)] = el;
        return Object.values(uniq);
      }
      toString() {
        return core_1.Token.asString(this);
      }
    };
    exports2.UniqueStringSet = UniqueStringSet;
    function sum(xs) {
      return xs.reduce((a, b) => a + b, 0);
    }
    exports2.sum = sum;
  }
});

// node_modules/aws-cdk-lib/aws-iam/lib/policy.js
var require_policy = __commonJS({
  "node_modules/aws-cdk-lib/aws-iam/lib/policy.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Policy = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam_generated_1 = require_iam_generated();
    var policy_document_1 = require_policy_document();
    var util_1 = require_util3();
    var core_1 = require_core2();
    var Policy = class _Policy extends core_1.Resource {
      static fromPolicyName(scope, id, policyName) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.policyName = policyName;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.policyName || core_1.Lazy.string({ produce: () => (0, util_1.generatePolicyName)(scope, resource.logicalId) }) }), this.document = new policy_document_1.PolicyDocument(), this.roles = new Array(), this.users = new Array(), this.groups = new Array(), this.referenceTaken = false;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Policy), error;
        }
        const self2 = this;
        class CfnPolicyConditional extends iam_generated_1.CfnPolicy {
          shouldSynthesize() {
            return self2.force || self2.referenceTaken || !self2.document.isEmpty && self2.isAttached;
          }
        }
        props.document && (this.document = props.document);
        const resource = new CfnPolicyConditional(this, "Resource", { policyDocument: this.document, policyName: this.physicalName, roles: (0, util_1.undefinedIfEmpty)(() => this.roles.map((r) => r.roleName)), users: (0, util_1.undefinedIfEmpty)(() => this.users.map((u) => u.userName)), groups: (0, util_1.undefinedIfEmpty)(() => this.groups.map((g) => g.groupName)) });
        this._policyName = this.physicalName, this.force = props.force ?? false, props.users && props.users.forEach((u) => this.attachToUser(u)), props.groups && props.groups.forEach((g) => this.attachToGroup(g)), props.roles && props.roles.forEach((r) => this.attachToRole(r)), props.statements && props.statements.forEach((p) => this.addStatements(p)), this.grantPrincipal = new PolicyGrantPrincipal(this), this.node.addValidation({ validate: () => this.validatePolicy() });
      }
      addStatements(...statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addStatements), error;
        }
        this.document.addStatements(...statement);
      }
      attachToUser(user) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IUser(user);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.attachToUser), error;
        }
        this.users.find((u) => u === user) || (this.users.push(user), user.attachInlinePolicy(this));
      }
      attachToRole(role) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IRole(role);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.attachToRole), error;
        }
        this.roles.find((r) => r === role) || (this.roles.push(role), role.attachInlinePolicy(this));
      }
      attachToGroup(group) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGroup(group);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.attachToGroup), error;
        }
        this.groups.find((g) => g === group) || (this.groups.push(group), group.attachInlinePolicy(this));
      }
      get policyName() {
        return this.referenceTaken = true, this._policyName;
      }
      validatePolicy() {
        const result = new Array();
        return this.document.isEmpty && (this.force && result.push("Policy created with force=true is empty. You must add statements to the policy"), !this.force && this.referenceTaken && result.push("This Policy has been referenced by a resource, so it must contain at least one statement.")), this.isAttached || (this.force && result.push("Policy created with force=true must be attached to at least one principal: user, group or role"), !this.force && this.referenceTaken && result.push("This Policy has been referenced by a resource, so it must be attached to at least one user, group or role.")), result.push(...this.document.validateForIdentityPolicy()), result;
      }
      get isAttached() {
        return this.groups.length + this.users.length + this.roles.length > 0;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Policy[_a] = { fqn: "aws-cdk-lib.aws_iam.Policy", version: "2.80.0" }, exports2.Policy = Policy;
    var PolicyGrantPrincipal = class {
      constructor(_policy) {
        this._policy = _policy, this.assumeRoleAction = "sts:AssumeRole", this.grantPrincipal = this, this.principalAccount = _policy.env.account;
      }
      get policyFragment() {
        throw new Error(`Cannot use a Policy '${this._policy.node.path}' as the 'Principal' or 'NotPrincipal' in an IAM Policy`);
      }
      addToPolicy(statement) {
        return this.addToPrincipalPolicy(statement).statementAdded;
      }
      addToPrincipalPolicy(statement) {
        return this._policy.addStatements(statement), { statementAdded: true, policyDependable: this._policy };
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-iam/lib/private/assume-role-policy.js
var require_assume_role_policy = __commonJS({
  "node_modules/aws-cdk-lib/aws-iam/lib/private/assume-role-policy.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.defaultAddPrincipalToAssumeRole = void 0;
    var policy_statement_1 = require_policy_statement();
    function defaultAddPrincipalToAssumeRole(principal, doc) {
      isAssumeRolePrincipal(principal) ? principal.addToAssumeRolePolicy(doc) : doc.addStatements(new policy_statement_1.PolicyStatement({ actions: [principal.assumeRoleAction], principals: [principal] }));
    }
    exports2.defaultAddPrincipalToAssumeRole = defaultAddPrincipalToAssumeRole;
    function isAssumeRolePrincipal(principal) {
      return !!principal.addToAssumeRolePolicy;
    }
  }
});

// node_modules/aws-cdk-lib/aws-iam/lib/private/policydoc-adapter.js
var require_policydoc_adapter = __commonJS({
  "node_modules/aws-cdk-lib/aws-iam/lib/private/policydoc-adapter.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.MutatingPolicyDocumentAdapter = void 0;
    var policy_document_1 = require_policy_document();
    var MutatingPolicyDocumentAdapter = class extends policy_document_1.PolicyDocument {
      constructor(wrapped, mutator) {
        super(), this.wrapped = wrapped, this.mutator = mutator;
      }
      addStatements(...statements) {
        for (const st of statements)
          this.wrapped.addStatements(this.mutator(st));
      }
    };
    exports2.MutatingPolicyDocumentAdapter = MutatingPolicyDocumentAdapter;
  }
});

// node_modules/aws-cdk-lib/aws-iam/lib/principals.js
var require_principals = __commonJS({
  "node_modules/aws-cdk-lib/aws-iam/lib/principals.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    var _l;
    var _m;
    var _o;
    var _p;
    var _q;
    var _r;
    var _s;
    var _t;
    var _u;
    var _v;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.validateConditionObject = exports2.CompositePrincipal = exports2.StarPrincipal = exports2.Anyone = exports2.AnyPrincipal = exports2.AccountRootPrincipal = exports2.SamlConsolePrincipal = exports2.SamlPrincipal = exports2.OpenIdConnectPrincipal = exports2.WebIdentityPrincipal = exports2.FederatedPrincipal = exports2.CanonicalUserPrincipal = exports2.OrganizationPrincipal = exports2.ServicePrincipal = exports2.AccountPrincipal = exports2.ArnPrincipal = exports2.PrincipalPolicyFragment = exports2.SessionTagsPrincipal = exports2.PrincipalWithConditions = exports2.PrincipalBase = exports2.ComparablePrincipal = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var policy_statement_1 = require_policy_statement();
    var assume_role_policy_1 = require_assume_role_policy();
    var util_1 = require_util3();
    var cdk = require_core2();
    var cxapi = require_cx_api();
    var region_info_1 = require_region_info2();
    var ComparablePrincipal = class _ComparablePrincipal {
      static isComparablePrincipal(x) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IPrincipal(x);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.isComparablePrincipal), error;
        }
        return "dedupeString" in x;
      }
      static dedupeStringFor(x) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IPrincipal(x);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.dedupeStringFor), error;
        }
        return _ComparablePrincipal.isComparablePrincipal(x) ? x.dedupeString() : void 0;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ComparablePrincipal[_a] = { fqn: "aws-cdk-lib.aws_iam.ComparablePrincipal", version: "2.80.0" }, exports2.ComparablePrincipal = ComparablePrincipal;
    var PrincipalBase = class {
      constructor() {
        this.grantPrincipal = this, this.principalAccount = void 0, this.assumeRoleAction = "sts:AssumeRole";
      }
      addToPolicy(statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToPolicy), error;
        }
        return this.addToPrincipalPolicy(statement).statementAdded;
      }
      addToPrincipalPolicy(_statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(_statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToPrincipalPolicy), error;
        }
        return { statementAdded: false };
      }
      addToAssumeRolePolicy(document) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyDocument(document);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToAssumeRolePolicy), error;
        }
        document.addStatements(new policy_statement_1.PolicyStatement({ actions: [this.assumeRoleAction], principals: [this] }));
      }
      toString() {
        return JSON.stringify(this.policyFragment.principalJson);
      }
      toJSON() {
        return this.policyFragment.principalJson;
      }
      withConditions(conditions) {
        return new PrincipalWithConditions(this, conditions);
      }
      withSessionTags() {
        return new SessionTagsPrincipal(this);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, PrincipalBase[_b] = { fqn: "aws-cdk-lib.aws_iam.PrincipalBase", version: "2.80.0" }, exports2.PrincipalBase = PrincipalBase;
    var PrincipalAdapter = class extends PrincipalBase {
      constructor(wrapped) {
        super(), this.wrapped = wrapped, this.assumeRoleAction = this.wrapped.assumeRoleAction, this.principalAccount = this.wrapped.principalAccount;
      }
      get policyFragment() {
        return this.wrapped.policyFragment;
      }
      addToPolicy(statement) {
        return this.wrapped.addToPolicy(statement);
      }
      addToPrincipalPolicy(statement) {
        return this.wrapped.addToPrincipalPolicy(statement);
      }
      appendDedupe(append) {
        const inner = ComparablePrincipal.dedupeStringFor(this.wrapped);
        return inner !== void 0 ? `${this.constructor.name}:${inner}:${append}` : void 0;
      }
    };
    var PrincipalWithConditions = class _PrincipalWithConditions extends PrincipalAdapter {
      constructor(principal, conditions) {
        super(principal);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IPrincipal(principal);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _PrincipalWithConditions), error;
        }
        this.additionalConditions = conditions;
      }
      addCondition(key, value) {
        validateConditionObject(value);
        const existingValue = this.additionalConditions[key];
        if (!existingValue) {
          this.additionalConditions[key] = value;
          return;
        }
        validateConditionObject(existingValue), this.additionalConditions[key] = { ...existingValue, ...value };
      }
      addConditions(conditions) {
        Object.entries(conditions).forEach(([key, value]) => {
          this.addCondition(key, value);
        });
      }
      get conditions() {
        return this.mergeConditions(this.wrapped.policyFragment.conditions, this.additionalConditions);
      }
      get policyFragment() {
        return new PrincipalPolicyFragment(this.wrapped.policyFragment.principalJson, this.conditions);
      }
      toString() {
        return this.wrapped.toString();
      }
      toJSON() {
        return this.policyFragment.principalJson;
      }
      dedupeString() {
        return this.appendDedupe(JSON.stringify(this.conditions));
      }
      mergeConditions(principalConditions, additionalConditions) {
        const mergedConditions = {};
        return Object.entries(principalConditions).forEach(([operator, condition]) => {
          mergedConditions[operator] = condition;
        }), Object.entries(additionalConditions).forEach(([operator, condition]) => {
          const existing = mergedConditions[operator];
          if (!existing) {
            mergedConditions[operator] = condition;
            return;
          }
          if (cdk.Token.isUnresolved(condition) || cdk.Token.isUnresolved(existing))
            throw new Error(`multiple "${operator}" conditions cannot be merged if one of them contains an unresolved token`);
          validateConditionObject(existing), validateConditionObject(condition), mergedConditions[operator] = { ...existing, ...condition };
        }), mergedConditions;
      }
    };
    _c = JSII_RTTI_SYMBOL_1, PrincipalWithConditions[_c] = { fqn: "aws-cdk-lib.aws_iam.PrincipalWithConditions", version: "2.80.0" }, exports2.PrincipalWithConditions = PrincipalWithConditions;
    var SessionTagsPrincipal = class _SessionTagsPrincipal extends PrincipalAdapter {
      constructor(principal) {
        super(principal);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IPrincipal(principal);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SessionTagsPrincipal), error;
        }
      }
      addToAssumeRolePolicy(doc) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyDocument(doc);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToAssumeRolePolicy), error;
        }
        const adapter = require_policydoc_adapter();
        (0, assume_role_policy_1.defaultAddPrincipalToAssumeRole)(this.wrapped, new adapter.MutatingPolicyDocumentAdapter(doc, (statement) => (statement.addActions("sts:TagSession"), statement)));
      }
      dedupeString() {
        return this.appendDedupe("");
      }
    };
    _d = JSII_RTTI_SYMBOL_1, SessionTagsPrincipal[_d] = { fqn: "aws-cdk-lib.aws_iam.SessionTagsPrincipal", version: "2.80.0" }, exports2.SessionTagsPrincipal = SessionTagsPrincipal;
    var PrincipalPolicyFragment = class {
      constructor(principalJson, conditions = {}) {
        this.principalJson = principalJson, this.conditions = conditions;
      }
    };
    _e = JSII_RTTI_SYMBOL_1, PrincipalPolicyFragment[_e] = { fqn: "aws-cdk-lib.aws_iam.PrincipalPolicyFragment", version: "2.80.0" }, exports2.PrincipalPolicyFragment = PrincipalPolicyFragment;
    var ArnPrincipal = class extends PrincipalBase {
      constructor(arn) {
        super(), this.arn = arn;
      }
      get policyFragment() {
        return new PrincipalPolicyFragment({ AWS: [this.arn] });
      }
      toString() {
        return `ArnPrincipal(${this.arn})`;
      }
      inOrganization(organizationId) {
        return this.withConditions({ StringEquals: { "aws:PrincipalOrgID": organizationId } });
      }
      dedupeString() {
        return `ArnPrincipal:${this.arn}`;
      }
    };
    _f = JSII_RTTI_SYMBOL_1, ArnPrincipal[_f] = { fqn: "aws-cdk-lib.aws_iam.ArnPrincipal", version: "2.80.0" }, exports2.ArnPrincipal = ArnPrincipal;
    var AccountPrincipal = class extends ArnPrincipal {
      constructor(accountId) {
        if (super(new StackDependentToken((stack) => `arn:${stack.partition}:iam::${accountId}:root`).toString()), this.accountId = accountId, !cdk.Token.isUnresolved(accountId) && typeof accountId != "string")
          throw new Error("accountId should be of type string");
        this.principalAccount = accountId;
      }
      toString() {
        return `AccountPrincipal(${this.accountId})`;
      }
    };
    _g = JSII_RTTI_SYMBOL_1, AccountPrincipal[_g] = { fqn: "aws-cdk-lib.aws_iam.AccountPrincipal", version: "2.80.0" }, exports2.AccountPrincipal = AccountPrincipal;
    var ServicePrincipal = class _ServicePrincipal extends PrincipalBase {
      static servicePrincipalName(service) {
        return new ServicePrincipalToken(service, {}).toString();
      }
      constructor(service, opts = {}) {
        super(), this.service = service, this.opts = opts;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_ServicePrincipalOpts(opts);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ServicePrincipal), error;
        }
      }
      get policyFragment() {
        return new PrincipalPolicyFragment({ Service: [new ServicePrincipalToken(this.service, this.opts).toString()] }, this.opts.conditions);
      }
      toString() {
        return `ServicePrincipal(${this.service})`;
      }
      dedupeString() {
        return `ServicePrincipal:${this.service}:${JSON.stringify(this.opts)}`;
      }
    };
    _h = JSII_RTTI_SYMBOL_1, ServicePrincipal[_h] = { fqn: "aws-cdk-lib.aws_iam.ServicePrincipal", version: "2.80.0" }, exports2.ServicePrincipal = ServicePrincipal;
    var OrganizationPrincipal = class extends PrincipalBase {
      constructor(organizationId) {
        super(), this.organizationId = organizationId;
      }
      get policyFragment() {
        return new PrincipalPolicyFragment({ AWS: ["*"] }, { StringEquals: { "aws:PrincipalOrgID": this.organizationId } });
      }
      toString() {
        return `OrganizationPrincipal(${this.organizationId})`;
      }
      dedupeString() {
        return `OrganizationPrincipal:${this.organizationId}`;
      }
    };
    _j = JSII_RTTI_SYMBOL_1, OrganizationPrincipal[_j] = { fqn: "aws-cdk-lib.aws_iam.OrganizationPrincipal", version: "2.80.0" }, exports2.OrganizationPrincipal = OrganizationPrincipal;
    var CanonicalUserPrincipal = class extends PrincipalBase {
      constructor(canonicalUserId) {
        super(), this.canonicalUserId = canonicalUserId;
      }
      get policyFragment() {
        return new PrincipalPolicyFragment({ CanonicalUser: [this.canonicalUserId] });
      }
      toString() {
        return `CanonicalUserPrincipal(${this.canonicalUserId})`;
      }
      dedupeString() {
        return `CanonicalUserPrincipal:${this.canonicalUserId}`;
      }
    };
    _k = JSII_RTTI_SYMBOL_1, CanonicalUserPrincipal[_k] = { fqn: "aws-cdk-lib.aws_iam.CanonicalUserPrincipal", version: "2.80.0" }, exports2.CanonicalUserPrincipal = CanonicalUserPrincipal;
    var FederatedPrincipal = class extends PrincipalBase {
      constructor(federated, conditions = {}, assumeRoleAction = "sts:AssumeRole") {
        super(), this.federated = federated, this.conditions = conditions, this.assumeRoleAction = assumeRoleAction;
      }
      get policyFragment() {
        return new PrincipalPolicyFragment({ Federated: [this.federated] }, this.conditions);
      }
      toString() {
        return `FederatedPrincipal(${this.federated})`;
      }
      dedupeString() {
        return `FederatedPrincipal:${this.federated}:${this.assumeRoleAction}:${JSON.stringify(this.conditions)}`;
      }
    };
    _l = JSII_RTTI_SYMBOL_1, FederatedPrincipal[_l] = { fqn: "aws-cdk-lib.aws_iam.FederatedPrincipal", version: "2.80.0" }, exports2.FederatedPrincipal = FederatedPrincipal;
    var WebIdentityPrincipal = class extends FederatedPrincipal {
      constructor(identityProvider, conditions = {}) {
        super(identityProvider, conditions ?? {}, "sts:AssumeRoleWithWebIdentity");
      }
      get policyFragment() {
        return new PrincipalPolicyFragment({ Federated: [this.federated] }, this.conditions);
      }
      toString() {
        return `WebIdentityPrincipal(${this.federated})`;
      }
    };
    _m = JSII_RTTI_SYMBOL_1, WebIdentityPrincipal[_m] = { fqn: "aws-cdk-lib.aws_iam.WebIdentityPrincipal", version: "2.80.0" }, exports2.WebIdentityPrincipal = WebIdentityPrincipal;
    var OpenIdConnectPrincipal = class _OpenIdConnectPrincipal extends WebIdentityPrincipal {
      constructor(openIdConnectProvider, conditions = {}) {
        super(openIdConnectProvider.openIdConnectProviderArn, conditions ?? {});
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IOpenIdConnectProvider(openIdConnectProvider);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _OpenIdConnectPrincipal), error;
        }
      }
      get policyFragment() {
        return new PrincipalPolicyFragment({ Federated: [this.federated] }, this.conditions);
      }
      toString() {
        return `OpenIdConnectPrincipal(${this.federated})`;
      }
    };
    _o = JSII_RTTI_SYMBOL_1, OpenIdConnectPrincipal[_o] = { fqn: "aws-cdk-lib.aws_iam.OpenIdConnectPrincipal", version: "2.80.0" }, exports2.OpenIdConnectPrincipal = OpenIdConnectPrincipal;
    var SamlPrincipal = class _SamlPrincipal extends FederatedPrincipal {
      constructor(samlProvider, conditions) {
        super(samlProvider.samlProviderArn, conditions, "sts:AssumeRoleWithSAML");
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_ISamlProvider(samlProvider);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SamlPrincipal), error;
        }
      }
      toString() {
        return `SamlPrincipal(${this.federated})`;
      }
    };
    _p = JSII_RTTI_SYMBOL_1, SamlPrincipal[_p] = { fqn: "aws-cdk-lib.aws_iam.SamlPrincipal", version: "2.80.0" }, exports2.SamlPrincipal = SamlPrincipal;
    var SamlConsolePrincipal = class _SamlConsolePrincipal extends SamlPrincipal {
      constructor(samlProvider, conditions = {}) {
        super(samlProvider, { ...conditions, StringEquals: { "SAML:aud": cdk.Aws.PARTITION === "aws-cn" ? "https://signin.amazonaws.cn/saml" : "https://signin.aws.amazon.com/saml" } });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_ISamlProvider(samlProvider);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SamlConsolePrincipal), error;
        }
      }
      toString() {
        return `SamlConsolePrincipal(${this.federated})`;
      }
    };
    _q = JSII_RTTI_SYMBOL_1, SamlConsolePrincipal[_q] = { fqn: "aws-cdk-lib.aws_iam.SamlConsolePrincipal", version: "2.80.0" }, exports2.SamlConsolePrincipal = SamlConsolePrincipal;
    var AccountRootPrincipal = class extends AccountPrincipal {
      constructor() {
        super(new StackDependentToken((stack) => stack.account).toString());
      }
      toString() {
        return "AccountRootPrincipal()";
      }
    };
    _r = JSII_RTTI_SYMBOL_1, AccountRootPrincipal[_r] = { fqn: "aws-cdk-lib.aws_iam.AccountRootPrincipal", version: "2.80.0" }, exports2.AccountRootPrincipal = AccountRootPrincipal;
    var AnyPrincipal = class extends ArnPrincipal {
      constructor() {
        super("*");
      }
      toString() {
        return "AnyPrincipal()";
      }
    };
    _s = JSII_RTTI_SYMBOL_1, AnyPrincipal[_s] = { fqn: "aws-cdk-lib.aws_iam.AnyPrincipal", version: "2.80.0" }, exports2.AnyPrincipal = AnyPrincipal;
    var Anyone = class extends AnyPrincipal {
    };
    _t = JSII_RTTI_SYMBOL_1, Anyone[_t] = { fqn: "aws-cdk-lib.aws_iam.Anyone", version: "2.80.0" }, exports2.Anyone = Anyone;
    var StarPrincipal = class extends PrincipalBase {
      constructor() {
        super(...arguments), this.policyFragment = { principalJson: { [util_1.LITERAL_STRING_KEY]: ["*"] }, conditions: {} };
      }
      toString() {
        return "StarPrincipal()";
      }
      dedupeString() {
        return "StarPrincipal";
      }
    };
    _u = JSII_RTTI_SYMBOL_1, StarPrincipal[_u] = { fqn: "aws-cdk-lib.aws_iam.StarPrincipal", version: "2.80.0" }, exports2.StarPrincipal = StarPrincipal;
    var CompositePrincipal = class _CompositePrincipal extends PrincipalBase {
      constructor(...principals) {
        super(), this.principals = new Array();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IPrincipal(principals);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CompositePrincipal), error;
        }
        if (principals.length === 0)
          throw new Error("CompositePrincipals must be constructed with at least 1 Principal but none were passed.");
        this.assumeRoleAction = principals[0].assumeRoleAction, this.addPrincipals(...principals);
      }
      addPrincipals(...principals) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IPrincipal(principals);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addPrincipals), error;
        }
        return this.principals.push(...principals), this;
      }
      addToAssumeRolePolicy(doc) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyDocument(doc);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToAssumeRolePolicy), error;
        }
        for (const p of this.principals)
          (0, assume_role_policy_1.defaultAddPrincipalToAssumeRole)(p, doc);
      }
      get policyFragment() {
        for (const p of this.principals) {
          const fragment = p.policyFragment;
          if (fragment.conditions && Object.keys(fragment.conditions).length > 0)
            throw new Error(`Components of a CompositePrincipal must not have conditions. Tried to add the following fragment: ${JSON.stringify(fragment)}`);
        }
        const principalJson = {};
        for (const p of this.principals)
          (0, util_1.mergePrincipal)(principalJson, p.policyFragment.principalJson);
        return new PrincipalPolicyFragment(principalJson);
      }
      toString() {
        return `CompositePrincipal(${this.principals})`;
      }
      dedupeString() {
        const inner = this.principals.map(ComparablePrincipal.dedupeStringFor);
        if (!inner.some((x) => x === void 0))
          return `CompositePrincipal[${inner.join(",")}]`;
      }
    };
    _v = JSII_RTTI_SYMBOL_1, CompositePrincipal[_v] = { fqn: "aws-cdk-lib.aws_iam.CompositePrincipal", version: "2.80.0" }, exports2.CompositePrincipal = CompositePrincipal;
    var StackDependentToken = class {
      constructor(fn) {
        this.fn = fn, this.creationStack = cdk.captureStackTrace();
      }
      resolve(context) {
        return this.fn(cdk.Stack.of(context.scope));
      }
      toString() {
        return cdk.Token.asString(this);
      }
      toJSON() {
        return "<unresolved-token>";
      }
    };
    var ServicePrincipalToken = class {
      constructor(service, opts) {
        this.service = service, this.opts = opts, this.creationStack = cdk.captureStackTrace();
      }
      resolve(ctx) {
        return cdk.FeatureFlags.of(ctx.scope).isEnabled(cxapi.IAM_STANDARDIZED_SERVICE_PRINCIPALS) ? this.newStandardizedBehavior(ctx) : this.legacyBehavior(ctx);
      }
      newStandardizedBehavior(ctx) {
        const stack = cdk.Stack.of(ctx.scope);
        return this.opts.region && !cdk.Token.isUnresolved(this.opts.region) && stack.region !== this.opts.region && region_info_1.RegionInfo.get(this.opts.region).isOptInRegion ? this.service.replace(/\.amazonaws\.com$/, `.${this.opts.region}.amazonaws.com`) : this.service;
      }
      legacyBehavior(ctx) {
        if (this.opts.region)
          return region_info_1.RegionInfo.get(this.opts.region).servicePrincipal(this.service) ?? region_info_1.Default.servicePrincipal(this.service, this.opts.region, cdk.Aws.URL_SUFFIX);
        const stack = cdk.Stack.of(ctx.scope);
        return stack.regionalFact(region_info_1.FactName.servicePrincipal(this.service), region_info_1.Default.servicePrincipal(this.service, stack.region, cdk.Aws.URL_SUFFIX));
      }
      toString() {
        return cdk.Token.asString(this, { displayHint: this.service });
      }
      toJSON() {
        return `<${this.service}>`;
      }
    };
    function validateConditionObject(x) {
      if (!x || typeof x != "object" || Array.isArray(x))
        throw new Error("A Condition should be represented as a map of operator to value");
    }
    exports2.validateConditionObject = validateConditionObject;
  }
});

// node_modules/aws-cdk-lib/aws-iam/lib/group.js
var require_group = __commonJS({
  "node_modules/aws-cdk-lib/aws-iam/lib/group.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Group = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam_generated_1 = require_iam_generated();
    var policy_1 = require_policy();
    var principals_1 = require_principals();
    var util_1 = require_util3();
    var core_1 = require_core2();
    var GroupBase = class extends core_1.Resource {
      constructor() {
        super(...arguments), this.grantPrincipal = this, this.principalAccount = this.env.account, this.assumeRoleAction = "sts:AssumeRole", this.attachedPolicies = new util_1.AttachedPolicies();
      }
      get policyFragment() {
        return new principals_1.ArnPrincipal(this.groupArn).policyFragment;
      }
      attachInlinePolicy(policy) {
        this.attachedPolicies.attach(policy), policy.attachToGroup(this);
      }
      addManagedPolicy(_policy) {
      }
      addUser(user) {
        user.addToGroup(this);
      }
      addToPrincipalPolicy(statement) {
        return this.defaultPolicy || (this.defaultPolicy = new policy_1.Policy(this, "DefaultPolicy"), this.defaultPolicy.attachToGroup(this)), this.defaultPolicy.addStatements(statement), { statementAdded: true, policyDependable: this.defaultPolicy };
      }
      addToPolicy(statement) {
        return this.addToPrincipalPolicy(statement).statementAdded;
      }
    };
    var Group = class _Group extends GroupBase {
      static fromGroupArn(scope, id, groupArn) {
        const arnComponents = core_1.Stack.of(scope).splitArn(groupArn, core_1.ArnFormat.SLASH_RESOURCE_NAME), groupName = arnComponents.resourceName;
        class Import extends GroupBase {
          constructor() {
            super(...arguments), this.groupName = groupName, this.groupArn = groupArn, this.principalAccount = arnComponents.account;
          }
        }
        return new Import(scope, id);
      }
      static fromGroupName(scope, id, groupName) {
        const groupArn = core_1.Stack.of(scope).formatArn({ service: "iam", region: "", resource: "group", resourceName: groupName });
        return _Group.fromGroupArn(scope, id, groupArn);
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.groupName }), this.managedPolicies = [];
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_GroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Group), error;
        }
        this.managedPolicies.push(...props.managedPolicies || []);
        const group = new iam_generated_1.CfnGroup(this, "Resource", { groupName: this.physicalName, managedPolicyArns: core_1.Lazy.list({ produce: () => this.managedPolicies.map((p) => p.managedPolicyArn) }, { omitEmpty: true }), path: props.path });
        this.groupName = this.getResourceNameAttribute(group.ref), this.groupArn = this.getResourceArnAttribute(group.attrArn, { region: "", service: "iam", resource: "group", resourceName: `${props.path ? props.path.substr(props.path.charAt(0) === "/" ? 1 : 0) : ""}${this.physicalName}` }), this.managedPoliciesExceededWarning();
      }
      addManagedPolicy(policy) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IManagedPolicy(policy);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addManagedPolicy), error;
        }
        this.managedPolicies.find((mp) => mp === policy) || (this.managedPolicies.push(policy), this.managedPoliciesExceededWarning());
      }
      managedPoliciesExceededWarning() {
        this.managedPolicies.length > 10 && core_1.Annotations.of(this).addWarning(`You added ${this.managedPolicies.length} to IAM Group ${this.physicalName}. The maximum number of managed policies attached to an IAM group is 10.`);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Group[_a] = { fqn: "aws-cdk-lib.aws_iam.Group", version: "2.80.0" }, exports2.Group = Group;
  }
});

// node_modules/aws-cdk-lib/aws-iam/lib/util.js
var require_util4 = __commonJS({
  "node_modules/aws-cdk-lib/aws-iam/lib/util.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.sum = exports2.UniqueStringSet = exports2.mergePrincipal = exports2.AttachedPolicies = exports2.generatePolicyName = exports2.undefinedIfEmpty = exports2.LITERAL_STRING_KEY = void 0;
    var core_1 = require_core2();
    var MAX_POLICY_NAME_LEN = 128;
    exports2.LITERAL_STRING_KEY = "LiteralString";
    function undefinedIfEmpty(f) {
      return core_1.Lazy.list({ produce: () => {
        const array = f();
        return array && array.length > 0 ? array : void 0;
      } });
    }
    exports2.undefinedIfEmpty = undefinedIfEmpty;
    function generatePolicyName(scope, logicalId) {
      const resolvedLogicalId = core_1.Tokenization.resolve(logicalId, { scope, resolver: new core_1.DefaultTokenResolver(new core_1.StringConcat()) });
      return lastNCharacters(resolvedLogicalId, MAX_POLICY_NAME_LEN);
    }
    exports2.generatePolicyName = generatePolicyName;
    function lastNCharacters(str, n) {
      const startIndex = Math.max(str.length - n, 0);
      return str.substring(startIndex, str.length);
    }
    var AttachedPolicies = class {
      constructor() {
        this.policies = new Array();
      }
      attach(policy) {
        if (!this.policies.find((p) => p === policy)) {
          if (this.policies.find((p) => p.policyName === policy.policyName))
            throw new Error(`A policy named "${policy.policyName}" is already attached`);
          this.policies.push(policy);
        }
      }
    };
    exports2.AttachedPolicies = AttachedPolicies;
    function mergePrincipal(target, source) {
      const sourceKeys = Object.keys(source), targetKeys = Object.keys(target);
      if (exports2.LITERAL_STRING_KEY in source && targetKeys.some((k) => k !== exports2.LITERAL_STRING_KEY) || exports2.LITERAL_STRING_KEY in target && sourceKeys.some((k) => k !== exports2.LITERAL_STRING_KEY))
        throw new Error(`Cannot merge principals ${JSON.stringify(target)} and ${JSON.stringify(source)}; if one uses a literal principal string the other one must be empty`);
      for (const key of sourceKeys) {
        target[key] = target[key] ?? [];
        let value = source[key];
        Array.isArray(value) || (value = [value]), target[key].push(...value);
      }
      return target;
    }
    exports2.mergePrincipal = mergePrincipal;
    var UniqueStringSet = class _UniqueStringSet {
      static from(fn) {
        return core_1.Token.asList(new _UniqueStringSet(fn));
      }
      constructor(fn) {
        this.fn = fn, this.creationStack = (0, core_1.captureStackTrace)();
      }
      resolve(context) {
        return context.registerPostProcessor(this), this.fn();
      }
      postProcess(input, _context) {
        if (!Array.isArray(input))
          return input;
        if (input.length === 0)
          return;
        const uniq = {};
        for (const el of input)
          uniq[JSON.stringify(el)] = el;
        return Object.values(uniq);
      }
      toString() {
        return core_1.Token.asString(this);
      }
    };
    exports2.UniqueStringSet = UniqueStringSet;
    function sum(xs) {
      return xs.reduce((a, b) => a + b, 0);
    }
    exports2.sum = sum;
  }
});

// node_modules/aws-cdk-lib/aws-iam/lib/private/postprocess-policy-document.js
var require_postprocess_policy_document = __commonJS({
  "node_modules/aws-cdk-lib/aws-iam/lib/private/postprocess-policy-document.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.normalizeStatement = exports2.PostProcessPolicyDocument = void 0;
    var cdk = require_core2();
    var util_1 = require_util4();
    var PostProcessPolicyDocument = class {
      constructor(autoAssignSids, sort) {
        this.autoAssignSids = autoAssignSids, this.sort = sort;
      }
      postProcess(input, _context) {
        if (!input || !input.Statement)
          return input;
        const jsonStatements = /* @__PURE__ */ new Set(), uniqueStatements = [];
        for (const statement of input.Statement) {
          const jsonStatement = JSON.stringify(statement);
          jsonStatements.has(jsonStatement) || (uniqueStatements.push(statement), jsonStatements.add(jsonStatement));
        }
        const statements = uniqueStatements.map((s, i) => (this.autoAssignSids && !s.Sid && (s.Sid = i.toString()), this.sort && (s.Action && (s.Action = sortByJson(s.Action)), s.Resource && (s.Resource = sortByJson(s.Resource)), s.Principal && (s.Principal = sortPrincipals(s.Principal))), s));
        return { ...input, Statement: statements };
      }
    };
    exports2.PostProcessPolicyDocument = PostProcessPolicyDocument;
    function normalizeStatement(s) {
      return noUndef({ Action: _norm(s.Action, { unique: true }), NotAction: _norm(s.NotAction, { unique: true }), Condition: _norm(s.Condition), Effect: _norm(s.Effect), Principal: _normPrincipal(s.Principal), NotPrincipal: _normPrincipal(s.NotPrincipal), Resource: _norm(s.Resource, { unique: true }), NotResource: _norm(s.NotResource, { unique: true }), Sid: _norm(s.Sid) });
      function _norm(values, { unique = false } = { unique: false }) {
        if (values != null) {
          if (cdk.Token.isUnresolved(values))
            return values;
          if (Array.isArray(values))
            return !values || values.length === 0 ? void 0 : values.length === 1 ? values[0] : unique ? Array.from(new Set(values)) : values;
          if (!(values && typeof values == "object" && Object.keys(values).length === 0))
            return values;
        }
      }
      function _normPrincipal(principal) {
        if (!principal || Array.isArray(principal) || typeof principal != "object")
          return;
        const keys = Object.keys(principal);
        if (keys.length === 0)
          return;
        if (util_1.LITERAL_STRING_KEY in principal)
          return principal[util_1.LITERAL_STRING_KEY][0];
        const result = {};
        for (const key of keys) {
          const normVal = _norm(principal[key]);
          normVal && (result[key] = normVal);
        }
        return result;
      }
    }
    exports2.normalizeStatement = normalizeStatement;
    function noUndef(x) {
      const ret = {};
      for (const [key, value] of Object.entries(x))
        value !== void 0 && (ret[key] = value);
      return ret;
    }
    function sortPrincipals(xs) {
      if (!xs || Array.isArray(xs) || typeof xs != "object")
        return xs;
      const ret = {};
      for (const k of Object.keys(xs).sort())
        ret[k] = sortByJson(xs[k]);
      return ret;
    }
    function sortByJson(xs) {
      if (!Array.isArray(xs))
        return xs;
      const intermediate = /* @__PURE__ */ new Map();
      for (const x of xs)
        intermediate.set(JSON.stringify(x), x);
      const sorted = Array.from(intermediate.keys()).sort().map((k) => intermediate.get(k));
      return xs.splice(0, xs.length, ...sorted), xs.length !== 1 ? xs : xs[0];
    }
  }
});

// node_modules/aws-cdk-lib/aws-iam/lib/policy-statement.js
var require_policy_statement = __commonJS({
  "node_modules/aws-cdk-lib/aws-iam/lib/policy-statement.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.deriveEstimateSizeOptions = exports2.Effect = exports2.PolicyStatement = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var group_1 = require_group();
    var principals_1 = require_principals();
    var postprocess_policy_document_1 = require_postprocess_policy_document();
    var util_1 = require_util3();
    var cdk = require_core2();
    var ensureArrayOrUndefined = (field) => {
      if (field !== void 0) {
        if (typeof field != "string" && !Array.isArray(field))
          throw new Error("Fields must be either a string or an array of strings");
        if (Array.isArray(field) && field.find((f) => typeof f != "string"))
          throw new Error("Fields must be either a string or an array of strings");
        return Array.isArray(field) ? field : [field];
      }
    };
    var DEFAULT_ARN_SIZE_ESTIMATE = 150;
    var ARN_SIZE_ESTIMATE_CONTEXT_KEY = "@aws-cdk/aws-iam.arnSizeEstimate";
    var PolicyStatement2 = class _PolicyStatement {
      static fromJson(obj) {
        const ret = new _PolicyStatement({ sid: obj.Sid, actions: ensureArrayOrUndefined(obj.Action), resources: ensureArrayOrUndefined(obj.Resource), conditions: obj.Condition, effect: obj.Effect, notActions: ensureArrayOrUndefined(obj.NotAction), notResources: ensureArrayOrUndefined(obj.NotResource), principals: obj.Principal ? [new JsonPrincipal(obj.Principal)] : void 0, notPrincipals: obj.NotPrincipal ? [new JsonPrincipal(obj.NotPrincipal)] : void 0 }), errors = ret.validateForAnyPolicy();
        if (errors.length > 0)
          throw new Error("Incorrect Policy Statement: " + errors.join(`
`));
        return ret;
      }
      constructor(props = {}) {
        this._action = new OrderedSet(), this._notAction = new OrderedSet(), this._principal = {}, this._notPrincipal = {}, this._resource = new OrderedSet(), this._notResource = new OrderedSet(), this._condition = {}, this._principals = new OrderedSet(), this._notPrincipals = new OrderedSet(), this._frozen = false;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatementProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _PolicyStatement), error;
        }
        this._sid = props.sid, this._effect = props.effect || Effect.ALLOW, this.addActions(...props.actions || []), this.addNotActions(...props.notActions || []), this.addPrincipals(...props.principals || []), this.addNotPrincipals(...props.notPrincipals || []), this.addResources(...props.resources || []), this.addNotResources(...props.notResources || []), props.conditions !== void 0 && this.addConditions(props.conditions);
      }
      get sid() {
        return this._sid;
      }
      set sid(sid) {
        this.assertNotFrozen("sid"), this._sid = sid;
      }
      get effect() {
        return this._effect;
      }
      set effect(effect) {
        this.assertNotFrozen("effect"), this._effect = effect;
      }
      addActions(...actions) {
        if (this.assertNotFrozen("addActions"), actions.length > 0 && this._notAction.length > 0)
          throw new Error("Cannot add 'Actions' to policy statement if 'NotActions' have been added");
        this.validatePolicyActions(actions), this._action.push(...actions);
      }
      addNotActions(...notActions) {
        if (this.assertNotFrozen("addNotActions"), notActions.length > 0 && this._action.length > 0)
          throw new Error("Cannot add 'NotActions' to policy statement if 'Actions' have been added");
        this.validatePolicyActions(notActions), this._notAction.push(...notActions);
      }
      get hasPrincipal() {
        return this._principals.length + this._notPrincipals.length > 0;
      }
      addPrincipals(...principals) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IPrincipal(principals);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addPrincipals), error;
        }
        if (this.assertNotFrozen("addPrincipals"), principals.length > 0 && this._notPrincipals.length > 0)
          throw new Error("Cannot add 'Principals' to policy statement if 'NotPrincipals' have been added");
        for (const principal of principals)
          this.validatePolicyPrincipal(principal);
        const added = this._principals.push(...principals);
        for (const principal of added) {
          const fragment = principal.policyFragment;
          (0, util_1.mergePrincipal)(this._principal, fragment.principalJson), this.addPrincipalConditions(fragment.conditions);
        }
      }
      addNotPrincipals(...notPrincipals) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IPrincipal(notPrincipals);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addNotPrincipals), error;
        }
        if (this.assertNotFrozen("addNotPrincipals"), notPrincipals.length > 0 && this._principals.length > 0)
          throw new Error("Cannot add 'NotPrincipals' to policy statement if 'Principals' have been added");
        for (const notPrincipal of notPrincipals)
          this.validatePolicyPrincipal(notPrincipal);
        const added = this._notPrincipals.push(...notPrincipals);
        for (const notPrincipal of added) {
          const fragment = notPrincipal.policyFragment;
          (0, util_1.mergePrincipal)(this._notPrincipal, fragment.principalJson), this.addPrincipalConditions(fragment.conditions);
        }
      }
      validatePolicyActions(actions) {
        if (!cdk.Token.isUnresolved(actions)) {
          for (const action of actions || [])
            if (!cdk.Token.isUnresolved(action) && !/^(\*|[a-zA-Z0-9-]+:[a-zA-Z0-9*]+)$/.test(action))
              throw new Error(`Action '${action}' is invalid. An action string consists of a service namespace, a colon, and the name of an action. Action names can include wildcards.`);
        }
      }
      validatePolicyPrincipal(principal) {
        if (principal instanceof group_1.Group)
          throw new Error("Cannot use an IAM Group as the 'Principal' or 'NotPrincipal' in an IAM Policy");
      }
      addAwsAccountPrincipal(accountId) {
        this.addPrincipals(new principals_1.AccountPrincipal(accountId));
      }
      addArnPrincipal(arn) {
        this.addPrincipals(new principals_1.ArnPrincipal(arn));
      }
      addServicePrincipal(service, opts) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_ServicePrincipalOpts(opts);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addServicePrincipal), error;
        }
        this.addPrincipals(new principals_1.ServicePrincipal(service, opts));
      }
      addFederatedPrincipal(federated, conditions) {
        this.addPrincipals(new principals_1.FederatedPrincipal(federated, conditions));
      }
      addAccountRootPrincipal() {
        this.addPrincipals(new principals_1.AccountRootPrincipal());
      }
      addCanonicalUserPrincipal(canonicalUserId) {
        this.addPrincipals(new principals_1.CanonicalUserPrincipal(canonicalUserId));
      }
      addAnyPrincipal() {
        this.addPrincipals(new principals_1.AnyPrincipal());
      }
      addResources(...arns) {
        if (this.assertNotFrozen("addResources"), arns.length > 0 && this._notResource.length > 0)
          throw new Error("Cannot add 'Resources' to policy statement if 'NotResources' have been added");
        this._resource.push(...arns);
      }
      addNotResources(...arns) {
        if (this.assertNotFrozen("addNotResources"), arns.length > 0 && this._resource.length > 0)
          throw new Error("Cannot add 'NotResources' to policy statement if 'Resources' have been added");
        this._notResource.push(...arns);
      }
      addAllResources() {
        this.addResources("*");
      }
      get hasResource() {
        return this._resource && this._resource.length > 0;
      }
      addCondition(key, value) {
        this.assertNotFrozen("addCondition"), (0, principals_1.validateConditionObject)(value);
        const existingValue = this._condition[key];
        this._condition[key] = existingValue ? { ...existingValue, ...value } : value;
      }
      addConditions(conditions) {
        Object.keys(conditions).map((key) => {
          this.addCondition(key, conditions[key]);
        });
      }
      addAccountCondition(accountId) {
        this.addCondition("StringEquals", { "sts:ExternalId": accountId });
      }
      copy(overrides = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatementProps(overrides);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.copy), error;
        }
        return new _PolicyStatement({ sid: overrides.sid ?? this.sid, effect: overrides.effect ?? this.effect, actions: overrides.actions ?? this.actions, notActions: overrides.notActions ?? this.notActions, principals: overrides.principals ?? this.principals, notPrincipals: overrides.notPrincipals ?? this.notPrincipals, resources: overrides.resources ?? this.resources, notResources: overrides.notResources ?? this.notResources, conditions: overrides.conditions ?? this.conditions });
      }
      toStatementJson() {
        return (0, postprocess_policy_document_1.normalizeStatement)({ Action: this._action.direct(), NotAction: this._notAction.direct(), Condition: this._condition, Effect: this.effect, Principal: this._principal, NotPrincipal: this._notPrincipal, Resource: this._resource.direct(), NotResource: this._notResource.direct(), Sid: this.sid });
      }
      toString() {
        return cdk.Token.asString(this, { displayHint: "PolicyStatement" });
      }
      toJSON() {
        return this.toStatementJson();
      }
      addPrincipalConditions(conditions) {
        const theseConditions = JSON.stringify(conditions);
        if (this.principalConditionsJson === void 0)
          this.principalConditionsJson = theseConditions;
        else if (this.principalConditionsJson !== theseConditions)
          throw new Error(`All principals in a PolicyStatement must have the same Conditions (got '${this.principalConditionsJson}' and '${theseConditions}'). Use multiple statements instead.`);
        this.addConditions(conditions);
      }
      validateForAnyPolicy() {
        const errors = new Array();
        return this._action.length === 0 && this._notAction.length === 0 && errors.push("A PolicyStatement must specify at least one 'action' or 'notAction'."), errors;
      }
      validateForResourcePolicy() {
        const errors = this.validateForAnyPolicy();
        return this._principals.length === 0 && this._notPrincipals.length === 0 && errors.push("A PolicyStatement used in a resource-based policy must specify at least one IAM principal."), errors;
      }
      validateForIdentityPolicy() {
        const errors = this.validateForAnyPolicy();
        return (this._principals.length > 0 || this._notPrincipals.length > 0) && errors.push("A PolicyStatement used in an identity-based policy cannot specify any IAM principals."), this._resource.length === 0 && this._notResource.length === 0 && errors.push("A PolicyStatement used in an identity-based policy must specify at least one resource."), errors;
      }
      get actions() {
        return this._action.copy();
      }
      get notActions() {
        return this._notAction.copy();
      }
      get principals() {
        return this._principals.copy();
      }
      get notPrincipals() {
        return this._notPrincipals.copy();
      }
      get resources() {
        return this._resource.copy();
      }
      get notResources() {
        return this._notResource.copy();
      }
      get conditions() {
        return { ...this._condition };
      }
      freeze() {
        return this._frozen = true, this;
      }
      get frozen() {
        return this._frozen;
      }
      _estimateSize(options) {
        let ret = 0;
        const { actionEstimate, arnEstimate } = options;
        return ret += `"Effect": "${this.effect}",`.length, count("Action", this.actions, actionEstimate), count("NotAction", this.notActions, actionEstimate), count("Resource", this.resources, arnEstimate), count("NotResource", this.notResources, arnEstimate), ret += this.principals.length * arnEstimate, ret += this.notPrincipals.length * arnEstimate, ret += JSON.stringify(this.conditions).length, ret;
        function count(key, values, tokenSize) {
          values.length > 0 && (ret += key.length + 5 + (0, util_1.sum)(values.map((v) => (cdk.Token.isUnresolved(v) ? tokenSize : v.length) + 3)));
        }
      }
      assertNotFrozen(method) {
        if (this._frozen)
          throw new Error(`${method}: freeze() has been called on this PolicyStatement previously, so it can no longer be modified`);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, PolicyStatement2[_a] = { fqn: "aws-cdk-lib.aws_iam.PolicyStatement", version: "2.80.0" }, exports2.PolicyStatement = PolicyStatement2;
    var Effect;
    (function(Effect2) {
      Effect2.ALLOW = "Allow", Effect2.DENY = "Deny";
    })(Effect = exports2.Effect || (exports2.Effect = {}));
    var JsonPrincipal = class extends principals_1.PrincipalBase {
      constructor(json = {}) {
        if (super(), typeof json == "string" && (json = { [util_1.LITERAL_STRING_KEY]: [json] }), typeof json != "object")
          throw new Error(`JSON IAM principal should be an object, got ${JSON.stringify(json)}`);
        this.policyFragment = { principalJson: json, conditions: {} };
      }
      dedupeString() {
        return JSON.stringify(this.policyFragment);
      }
    };
    function deriveEstimateSizeOptions(scope) {
      const arnEstimate = scope.node.tryGetContext(ARN_SIZE_ESTIMATE_CONTEXT_KEY) ?? DEFAULT_ARN_SIZE_ESTIMATE;
      if (typeof arnEstimate != "number")
        throw new Error(`Context value ${ARN_SIZE_ESTIMATE_CONTEXT_KEY} should be a number, got ${JSON.stringify(arnEstimate)}`);
      return { actionEstimate: 20, arnEstimate };
    }
    exports2.deriveEstimateSizeOptions = deriveEstimateSizeOptions;
    var OrderedSet = class {
      constructor() {
        this.set = /* @__PURE__ */ new Set(), this.array = new Array();
      }
      push(...xs) {
        const ret = new Array();
        for (const x of xs)
          this.set.has(x) || (this.set.add(x), this.array.push(x), ret.push(x));
        return ret;
      }
      get length() {
        return this.array.length;
      }
      copy() {
        return [...this.array];
      }
      direct() {
        return this.array;
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-iam/lib/private/comparable-principal.js
var require_comparable_principal = __commonJS({
  "node_modules/aws-cdk-lib/aws-iam/lib/private/comparable-principal.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.partitionPrincipals = void 0;
    var principals_1 = require_principals();
    function partitionPrincipals(xs) {
      const nonComparable = [], comparable = {};
      for (const x of xs) {
        const dedupe = principals_1.ComparablePrincipal.dedupeStringFor(x);
        dedupe ? comparable[dedupe] = x : nonComparable.push(x);
      }
      return { comparable, nonComparable };
    }
    exports2.partitionPrincipals = partitionPrincipals;
  }
});

// node_modules/aws-cdk-lib/aws-iam/lib/private/merge-statements.js
var require_merge_statements = __commonJS({
  "node_modules/aws-cdk-lib/aws-iam/lib/private/merge-statements.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.mergeStatements = void 0;
    var comparable_principal_1 = require_comparable_principal();
    var policy_statement_1 = require_policy_statement();
    var util_1 = require_util4();
    var MAX_MERGE_SIZE = 2e3;
    function mergeStatements(statements, options) {
      const sizeOptions = (0, policy_statement_1.deriveEstimateSizeOptions)(options.scope), compStatements = statements.map(makeComparable), mergeFn = options?.mergeIfCombinable ?? true ? mergeIfCombinable : mergeIfEqual;
      for (; onePass(); )
        ;
      const mergedStatements = new Array(), originsMap = /* @__PURE__ */ new Map();
      for (const comp of compStatements) {
        const statement = renderComparable(comp);
        mergedStatements.push(statement), originsMap.set(statement, comp.originals);
      }
      return { mergedStatements, originsMap };
      function onePass() {
        let ret = false;
        for (let i = 0; i < compStatements.length; i++) {
          let j = i + 1;
          for (; j < compStatements.length; ) {
            const merged = mergeFn(compStatements[i], compStatements[j], !!options.limitSize, sizeOptions);
            merged ? (compStatements[i] = merged, compStatements.splice(j, 1), ret = true) : j++;
          }
        }
        return ret;
      }
    }
    exports2.mergeStatements = mergeStatements;
    function mergeIfCombinable(a, b, limitSize, options) {
      if (a.statement.effect !== b.statement.effect || a.statement.sid || b.statement.sid || a.conditionString !== b.conditionString || !setEqual(a.statement.notActions, b.statement.notActions) || !setEqual(a.statement.notResources, b.statement.notResources) || !setEqualPrincipals(a.statement.notPrincipals, b.statement.notPrincipals) || (setEqual(a.statement.actions, b.statement.actions) ? 1 : 0) + (setEqual(a.statement.resources, b.statement.resources) ? 1 : 0) + (setEqualPrincipals(a.statement.principals, b.statement.principals) ? 1 : 0) < 2 || unmergeablePrincipals(a, b))
        return;
      const combined = a.statement.copy({ actions: setMerge(a.statement.actions, b.statement.actions), resources: setMerge(a.statement.resources, b.statement.resources), principals: setMergePrincipals(a.statement.principals, b.statement.principals) });
      if (!(limitSize && combined._estimateSize(options) > MAX_MERGE_SIZE))
        return { originals: [...a.originals, ...b.originals], statement: combined, conditionString: a.conditionString };
    }
    function mergeIfEqual(a, b) {
      if (a.statement.effect === b.statement.effect && a.statement.sid === b.statement.sid && a.conditionString === b.conditionString && !(!setEqual(a.statement.notActions, b.statement.notActions) || !setEqual(a.statement.notResources, b.statement.notResources) || !setEqualPrincipals(a.statement.notPrincipals, b.statement.notPrincipals)) && !(!setEqual(a.statement.actions, b.statement.actions) || !setEqual(a.statement.resources, b.statement.resources) || !setEqualPrincipals(a.statement.principals, b.statement.principals)))
        return { originals: [...a.originals, ...b.originals], statement: a.statement, conditionString: a.conditionString };
    }
    function makeComparable(s) {
      return { originals: [s], statement: s, conditionString: JSON.stringify(s.conditions) };
    }
    function unmergeablePrincipals(a, b) {
      const aHasLiteral = a.statement.principals.some((v) => util_1.LITERAL_STRING_KEY in v.policyFragment.principalJson), bHasLiteral = b.statement.principals.some((v) => util_1.LITERAL_STRING_KEY in v.policyFragment.principalJson);
      return aHasLiteral !== bHasLiteral;
    }
    function renderComparable(s) {
      return s.statement;
    }
    function setEqual(a, b) {
      const bSet = new Set(b);
      return a.length === b.length && a.every((k) => bSet.has(k));
    }
    function setMerge(x, y) {
      return Array.from(/* @__PURE__ */ new Set([...x, ...y])).sort();
    }
    function setEqualPrincipals(xs, ys) {
      const xPrincipals = (0, comparable_principal_1.partitionPrincipals)(xs), yPrincipals = (0, comparable_principal_1.partitionPrincipals)(ys), nonComp = setEqual(xPrincipals.nonComparable, yPrincipals.nonComparable), comp = setEqual(Object.keys(xPrincipals.comparable), Object.keys(yPrincipals.comparable));
      return nonComp && comp;
    }
    function setMergePrincipals(xs, ys) {
      const xPrincipals = (0, comparable_principal_1.partitionPrincipals)(xs), yPrincipals = (0, comparable_principal_1.partitionPrincipals)(ys), comparable = { ...xPrincipals.comparable, ...yPrincipals.comparable };
      return [...Object.values(comparable), ...xPrincipals.nonComparable, ...yPrincipals.nonComparable];
    }
  }
});

// node_modules/aws-cdk-lib/aws-iam/lib/policy-document.js
var require_policy_document = __commonJS({
  "node_modules/aws-cdk-lib/aws-iam/lib/policy-document.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PolicyDocument = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var policy_statement_1 = require_policy_statement();
    var merge_statements_1 = require_merge_statements();
    var postprocess_policy_document_1 = require_postprocess_policy_document();
    var cdk = require_core2();
    var cxapi = require_cx_api();
    var PolicyDocument = class _PolicyDocument {
      static fromJson(obj) {
        const newPolicyDocument = new _PolicyDocument(), statement = obj.Statement ?? [];
        if (statement && !Array.isArray(statement))
          throw new Error("Statement must be an array");
        return newPolicyDocument.addStatements(...obj.Statement.map((s) => policy_statement_1.PolicyStatement.fromJson(s))), newPolicyDocument;
      }
      constructor(props = {}) {
        this.statements = new Array();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyDocumentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _PolicyDocument), error;
        }
        this.creationStack = cdk.captureStackTrace(), this.autoAssignSids = !!props.assignSids, this.minimize = props.minimize, this.addStatements(...props.statements || []);
      }
      resolve(context) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_IResolveContext(context);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.resolve), error;
        }
        this.freezeStatements(), this._maybeMergeStatements(context.scope);
        const sort = this.shouldMerge(context.scope);
        return context.registerPostProcessor(new postprocess_policy_document_1.PostProcessPolicyDocument(this.autoAssignSids, sort)), this.render();
      }
      get isEmpty() {
        return this.statements.length === 0;
      }
      get statementCount() {
        return this.statements.length;
      }
      addStatements(...statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addStatements), error;
        }
        this.statements.push(...statement);
      }
      toString() {
        return cdk.Token.asString(this, { displayHint: "PolicyDocument" });
      }
      toJSON() {
        return this.render();
      }
      validateForAnyPolicy() {
        const errors = new Array();
        for (const statement of this.statements)
          errors.push(...statement.validateForAnyPolicy());
        return errors;
      }
      validateForResourcePolicy() {
        const errors = new Array();
        for (const statement of this.statements)
          errors.push(...statement.validateForResourcePolicy());
        return errors;
      }
      validateForIdentityPolicy() {
        const errors = new Array();
        for (const statement of this.statements)
          errors.push(...statement.validateForIdentityPolicy());
        return errors;
      }
      _maybeMergeStatements(scope) {
        if (this.shouldMerge(scope)) {
          const result = (0, merge_statements_1.mergeStatements)(this.statements, { scope });
          this.statements.splice(0, this.statements.length, ...result.mergedStatements);
        }
      }
      _splitDocument(scope, selfMaximumSize, splitMaximumSize) {
        const self2 = this, newDocs = [];
        this.freezeStatements();
        let statementsToOriginals = new Map(this.statements.map((s) => [s, [s]]));
        const doActualMerging = this.shouldMerge(scope), result = (0, merge_statements_1.mergeStatements)(this.statements, { scope, limitSize: true, mergeIfCombinable: doActualMerging });
        this.statements.splice(0, this.statements.length, ...result.mergedStatements), statementsToOriginals = result.originsMap;
        const sizeOptions = (0, policy_statement_1.deriveEstimateSizeOptions)(scope), statementSizes = new Map(this.statements.map((s) => [s, s._estimateSize(sizeOptions)]));
        let selfSize = 0;
        const polSizes = /* @__PURE__ */ new Map(), polSize = (x) => polSizes.get(x) ?? 0;
        let i = 0;
        for (; i < this.statements.length; ) {
          const statement = this.statements[i], statementSize = statementSizes.get(statement) ?? 0;
          if (selfSize + statementSize < selfMaximumSize) {
            selfSize += statementSize, i++;
            continue;
          }
          const addToDoc = findDocWithSpace(statementSize);
          addToDoc.addStatements(statement), polSizes.set(addToDoc, polSize(addToDoc) + statementSize), this.statements.splice(i, 1);
        }
        const ret = /* @__PURE__ */ new Map();
        ret.set(this, this.statements.flatMap((s) => statementsToOriginals.get(s) ?? [s]));
        for (const newDoc of newDocs)
          ret.set(newDoc, newDoc.statements.flatMap((s) => statementsToOriginals.get(s) ?? [s]));
        return ret;
        function findDocWithSpace(size) {
          let j = 0;
          for (; j < newDocs.length && polSize(newDocs[j]) + size > splitMaximumSize; )
            j++;
          if (j < newDocs.length)
            return newDocs[j];
          const newDoc = new _PolicyDocument({ assignSids: self2.autoAssignSids, minimize: self2.minimize });
          return newDocs.push(newDoc), newDoc;
        }
      }
      render() {
        return this.isEmpty ? void 0 : { Statement: this.statements.map((s) => s.toStatementJson()), Version: "2012-10-17" };
      }
      shouldMerge(scope) {
        return this.minimize ?? cdk.FeatureFlags.of(scope).isEnabled(cxapi.IAM_MINIMIZE_POLICIES) ?? false;
      }
      freezeStatements() {
        for (const statement of this.statements)
          statement.freeze();
      }
    };
    _a = JSII_RTTI_SYMBOL_1, PolicyDocument[_a] = { fqn: "aws-cdk-lib.aws_iam.PolicyDocument", version: "2.80.0" }, exports2.PolicyDocument = PolicyDocument;
  }
});

// node_modules/aws-cdk-lib/aws-iam/lib/managed-policy.js
var require_managed_policy = __commonJS({
  "node_modules/aws-cdk-lib/aws-iam/lib/managed-policy.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ManagedPolicy = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam_generated_1 = require_iam_generated();
    var policy_document_1 = require_policy_document();
    var util_1 = require_util3();
    var core_1 = require_core2();
    var helpers_internal_1 = require_helpers_internal();
    var ManagedPolicy = class _ManagedPolicy extends core_1.Resource {
      static fromManagedPolicyName(scope, id, managedPolicyName) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.managedPolicyArn = core_1.Stack.of(scope).formatArn({ service: "iam", region: "", account: core_1.Stack.of(scope).account, resource: "policy", resourceName: managedPolicyName });
          }
        }
        return new Import(scope, id);
      }
      static fromManagedPolicyArn(scope, id, managedPolicyArn) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.managedPolicyArn = managedPolicyArn;
          }
        }
        return new Import(scope, id);
      }
      static fromAwsManagedPolicyName(managedPolicyName) {
        class AwsManagedPolicy {
          constructor() {
            this.managedPolicyArn = core_1.Arn.format({ partition: core_1.Aws.PARTITION, service: "iam", region: "", account: "aws", resource: "policy", resourceName: managedPolicyName });
          }
        }
        return new AwsManagedPolicy();
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.managedPolicyName }), this.document = new policy_document_1.PolicyDocument(), this.roles = new Array(), this.users = new Array(), this.groups = new Array();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_ManagedPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ManagedPolicy), error;
        }
        this.description = props.description || "", this.path = props.path || "/", props.document && (this.document = props.document);
        const config = (0, helpers_internal_1.getCustomizeRolesConfig)(this), _precreatedPolicy = _ManagedPolicy.fromManagedPolicyName(this, "Imported" + id, id);
        if (this.managedPolicyName = id, this.managedPolicyArn = _precreatedPolicy.managedPolicyArn, config.enabled && (this._precreatedPolicy = _precreatedPolicy), !config.preventSynthesis) {
          const resource = new iam_generated_1.CfnManagedPolicy(this, "Resource", { policyDocument: this.document, managedPolicyName: this.physicalName, description: this.description, path: this.path, roles: (0, util_1.undefinedIfEmpty)(() => this.roles.map((r) => r.roleName)), users: (0, util_1.undefinedIfEmpty)(() => this.users.map((u) => u.userName)), groups: (0, util_1.undefinedIfEmpty)(() => this.groups.map((g) => g.groupName)) });
          this.managedPolicyName = this.getResourceNameAttribute(core_1.Stack.of(this).splitArn(resource.ref, core_1.ArnFormat.SLASH_RESOURCE_NAME).resourceName), this.managedPolicyArn = this.getResourceArnAttribute(resource.ref, { region: "", service: "iam", resource: "policy", resourceName: this.physicalName });
        }
        props.users && props.users.forEach((u) => this.attachToUser(u)), props.groups && props.groups.forEach((g) => this.attachToGroup(g)), props.roles && props.roles.forEach((r) => this.attachToRole(r)), props.statements && props.statements.forEach((p) => this.addStatements(p)), this.grantPrincipal = new ManagedPolicyGrantPrincipal(this), this.node.addValidation({ validate: () => this.validateManagedPolicy() });
      }
      addStatements(...statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addStatements), error;
        }
        this.document.addStatements(...statement);
      }
      attachToUser(user) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IUser(user);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.attachToUser), error;
        }
        this.users.find((u) => u === user) || this.users.push(user);
      }
      attachToRole(role) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IRole(role);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.attachToRole), error;
        }
        this.roles.find((r) => r === role) || this.roles.push(role);
      }
      attachToGroup(group) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGroup(group);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.attachToGroup), error;
        }
        this.groups.find((g) => g === group) || this.groups.push(group);
      }
      validateManagedPolicy() {
        const result = new Array();
        return this.document.isEmpty && result.push("Managed Policy is empty. You must add statements to the policy"), result.push(...this.document.validateForIdentityPolicy()), result.length === 0 && this._precreatedPolicy && helpers_internal_1.PolicySynthesizer.getOrCreate(this).addManagedPolicy(this.node.path, { policyStatements: this.document.toJSON()?.Statement, roles: this.roles.map((role) => role.node.path) }), result;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ManagedPolicy[_a] = { fqn: "aws-cdk-lib.aws_iam.ManagedPolicy", version: "2.80.0" }, exports2.ManagedPolicy = ManagedPolicy;
    var ManagedPolicyGrantPrincipal = class {
      constructor(_managedPolicy) {
        this._managedPolicy = _managedPolicy, this.assumeRoleAction = "sts:AssumeRole", this.grantPrincipal = this, this.principalAccount = _managedPolicy.env.account;
      }
      get policyFragment() {
        throw new Error(`Cannot use a ManagedPolicy '${this._managedPolicy.node.path}' as the 'Principal' or 'NotPrincipal' in an IAM Policy`);
      }
      addToPolicy(statement) {
        return this.addToPrincipalPolicy(statement).statementAdded;
      }
      addToPrincipalPolicy(statement) {
        return this._managedPolicy.addStatements(statement), { statementAdded: true, policyDependable: this._managedPolicy };
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-iam/lib/grant.js
var require_grant = __commonJS({
  "node_modules/aws-cdk-lib/aws-iam/lib/grant.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CompositeDependable = exports2.Grant = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var policy_statement_1 = require_policy_statement();
    var cdk = require_core2();
    var Grant = class _Grant {
      static addToPrincipalOrResource(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_GrantWithResourceOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToPrincipalOrResource), error;
        }
        const result = _Grant.addToPrincipal({ ...options, scope: options.resource }), resourceAndPrincipalAccountComparison = options.grantee.grantPrincipal.principalAccount ? cdk.Token.compareStrings(options.resource.env.account, options.grantee.grantPrincipal.principalAccount) : void 0, equalOrBothUnresolved = resourceAndPrincipalAccountComparison === cdk.TokenComparison.SAME || resourceAndPrincipalAccountComparison == cdk.TokenComparison.BOTH_UNRESOLVED, sameAccount = resourceAndPrincipalAccountComparison ? equalOrBothUnresolved : false;
        if (result.success && sameAccount)
          return result;
        const statement = new policy_statement_1.PolicyStatement({ actions: options.actions, resources: options.resourceSelfArns || options.resourceArns, principals: [options.grantee.grantPrincipal] }), resourceResult = options.resource.addToResourcePolicy(statement);
        return new _Grant({ resourceStatement: statement, options, policyDependable: resourceResult.statementAdded ? resourceResult.policyDependable ?? options.resource : void 0 });
      }
      static addToPrincipal(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_GrantOnPrincipalOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToPrincipal), error;
        }
        const statement = new policy_statement_1.PolicyStatement({ actions: options.actions, resources: options.resourceArns, conditions: options.conditions }), addedToPrincipal = options.grantee.grantPrincipal.addToPrincipalPolicy(statement);
        if (!addedToPrincipal.statementAdded)
          return new _Grant({ principalStatement: void 0, options });
        if (!addedToPrincipal.policyDependable)
          throw new Error("Contract violation: when Principal returns statementAdded=true, it should return a dependable");
        return new _Grant({ principalStatement: statement, options, policyDependable: addedToPrincipal.policyDependable });
      }
      static addToPrincipalAndResource(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_GrantOnPrincipalAndResourceOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToPrincipalAndResource), error;
        }
        const result = _Grant.addToPrincipal({ ...options, scope: options.resource }), statement = new policy_statement_1.PolicyStatement({ actions: options.actions, resources: options.resourceSelfArns || options.resourceArns, principals: [options.resourcePolicyPrincipal || options.grantee.grantPrincipal] }), resourceResult = options.resource.addToResourcePolicy(statement), resourceDependable = resourceResult.statementAdded ? resourceResult.policyDependable ?? options.resource : void 0;
        return new _Grant({ principalStatement: statement, resourceStatement: result.resourceStatement, options, policyDependable: resourceDependable ? new CompositeDependable(result, resourceDependable) : result });
      }
      static drop(grantee, _intent) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(grantee);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.drop), error;
        }
        return new _Grant({ options: { grantee, actions: [], resourceArns: [] } });
      }
      constructor(props) {
        this.principalStatements = new Array(), this.resourceStatements = new Array(), this.dependables = new Array(), this.options = props.options, this.principalStatement = props.principalStatement, this.resourceStatement = props.resourceStatement, this.principalStatement && this.principalStatements.push(this.principalStatement), this.resourceStatement && this.resourceStatements.push(this.resourceStatement), props.policyDependable && this.dependables.push(props.policyDependable);
        const self2 = this;
        constructs_1.Dependable.implement(this, { get dependencyRoots() {
          return Array.from(new Set(self2.dependables.flatMap((d) => constructs_1.Dependable.of(d).dependencyRoots)));
        } });
      }
      get success() {
        return this.principalStatement !== void 0 || this.resourceStatement !== void 0;
      }
      assertSuccess() {
        if (!this.success)
          throw new Error(`${describeGrant(this.options)} could not be added on either identity or resource policy.`);
      }
      applyBefore(...constructs) {
        for (const construct of constructs)
          construct.node.addDependency(this);
      }
      combine(rhs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_Grant(rhs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.combine), error;
        }
        const combinedPrinc = [...this.principalStatements, ...rhs.principalStatements], combinedRes = [...this.resourceStatements, ...rhs.resourceStatements], ret = new _Grant({ options: this.options, principalStatement: combinedPrinc[0], resourceStatement: combinedRes[0] });
        return ret.principalStatements.splice(0, ret.principalStatements.length, ...combinedPrinc), ret.resourceStatements.splice(0, ret.resourceStatements.length, ...combinedRes), ret.dependables.push(...this.dependables, ...rhs.dependables), ret;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Grant[_a] = { fqn: "aws-cdk-lib.aws_iam.Grant", version: "2.80.0" }, exports2.Grant = Grant;
    function describeGrant(options) {
      return `Permissions for '${options.grantee}' to call '${options.actions}' on '${options.resourceArns}'`;
    }
    var CompositeDependable = class {
      constructor(...dependables) {
        constructs_1.Dependable.implement(this, { get dependencyRoots() {
          return Array.prototype.concat.apply([], dependables.map((d) => constructs_1.Dependable.of(d).dependencyRoots));
        } });
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CompositeDependable[_b] = { fqn: "aws-cdk-lib.aws_iam.CompositeDependable", version: "2.80.0" }, exports2.CompositeDependable = CompositeDependable;
  }
});

// node_modules/aws-cdk-lib/aws-iam/lib/private/immutable-role.js
var require_immutable_role = __commonJS({
  "node_modules/aws-cdk-lib/aws-iam/lib/private/immutable-role.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ImmutableRole = void 0;
    var constructs_1 = require_lib2();
    var core_1 = require_core2();
    var ImmutableRole = class extends core_1.Resource {
      constructor(scope, id, role, addGrantsToResources) {
        super(scope, id, { account: role.env.account, region: role.env.region }), this.role = role, this.addGrantsToResources = addGrantsToResources, this.assumeRoleAction = this.role.assumeRoleAction, this.policyFragment = this.role.policyFragment, this.grantPrincipal = this, this.principalAccount = this.role.principalAccount, this.roleArn = this.role.roleArn, this.roleName = this.role.roleName, this.stack = this.role.stack, constructs_1.Dependable.implement(this, { dependencyRoots: [role] }), this.node.defaultChild = role.node.defaultChild;
      }
      attachInlinePolicy(_policy) {
      }
      addManagedPolicy(_policy) {
      }
      addToPolicy(statement) {
        return this.addToPrincipalPolicy(statement).statementAdded;
      }
      addToPrincipalPolicy(_statement) {
        return { statementAdded: !this.addGrantsToResources, policyDependable: new constructs_1.DependencyGroup() };
      }
      grant(grantee, ...actions) {
        return this.role.grant(grantee, ...actions);
      }
      grantPassRole(grantee) {
        return this.role.grantPassRole(grantee);
      }
      grantAssumeRole(identity) {
        return this.role.grantAssumeRole(identity);
      }
    };
    exports2.ImmutableRole = ImmutableRole;
  }
});

// node_modules/aws-cdk-lib/aws-iam/lib/private/imported-role.js
var require_imported_role = __commonJS({
  "node_modules/aws-cdk-lib/aws-iam/lib/private/imported-role.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ImportedRole = void 0;
    var core_1 = require_core2();
    var cx_api_1 = require_cx_api();
    var grant_1 = require_grant();
    var policy_1 = require_policy();
    var principals_1 = require_principals();
    var util_1 = require_util4();
    var ImportedRole = class extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id, { account: props.account }), this.grantPrincipal = this, this.assumeRoleAction = "sts:AssumeRole", this.attachedPolicies = new util_1.AttachedPolicies(), this.roleArn = props.roleArn, this.roleName = props.roleName, this.policyFragment = new principals_1.ArnPrincipal(this.roleArn).policyFragment, this.defaultPolicyName = props.defaultPolicyName, this.principalAccount = props.account;
      }
      addToPolicy(statement) {
        return this.addToPrincipalPolicy(statement).statementAdded;
      }
      addToPrincipalPolicy(statement) {
        if (!this.defaultPolicy) {
          const useUniqueName = core_1.FeatureFlags.of(this).isEnabled(cx_api_1.IAM_IMPORTED_ROLE_STACK_SAFE_DEFAULT_POLICY_NAME), defaultDefaultPolicyName = useUniqueName ? `Policy${core_1.Names.uniqueId(this)}` : "Policy", policyName = this.defaultPolicyName ?? defaultDefaultPolicyName;
          this.defaultPolicy = new policy_1.Policy(this, policyName, useUniqueName ? { policyName } : void 0), this.attachInlinePolicy(this.defaultPolicy);
        }
        return this.defaultPolicy.addStatements(statement), { statementAdded: true, policyDependable: this.defaultPolicy };
      }
      attachInlinePolicy(policy) {
        const thisAndPolicyAccountComparison = core_1.Token.compareStrings(this.env.account, policy.env.account);
        (thisAndPolicyAccountComparison === core_1.TokenComparison.SAME || thisAndPolicyAccountComparison === core_1.TokenComparison.BOTH_UNRESOLVED || thisAndPolicyAccountComparison === core_1.TokenComparison.ONE_UNRESOLVED) && (this.attachedPolicies.attach(policy), policy.attachToRole(this));
      }
      addManagedPolicy(policy) {
        core_1.Annotations.of(this).addWarning(`Not adding managed policy: ${policy.managedPolicyArn} to imported role: ${this.roleName}`);
      }
      grantPassRole(identity) {
        return this.grant(identity, "iam:PassRole");
      }
      grantAssumeRole(identity) {
        return this.grant(identity, "sts:AssumeRole");
      }
      grant(grantee, ...actions) {
        return grant_1.Grant.addToPrincipal({ grantee, actions, resourceArns: [this.roleArn], scope: this });
      }
      dedupeString() {
        return `ImportedRole:${this.roleArn}`;
      }
    };
    exports2.ImportedRole = ImportedRole;
  }
});

// node_modules/aws-cdk-lib/aws-iam/lib/private/precreated-role.js
var require_precreated_role = __commonJS({
  "node_modules/aws-cdk-lib/aws-iam/lib/private/precreated-role.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PrecreatedRole = void 0;
    var constructs_1 = require_lib2();
    var core_1 = require_core2();
    var helpers_internal_1 = require_helpers_internal();
    var PrecreatedRole = class extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id, { account: props.role.env.account, region: props.role.env.region }), this.grantPrincipal = this, this.policyStatements = [], this.managedPolicies = [], this.role = props.role, this.assumeRoleAction = this.role.assumeRoleAction, this.policyFragment = this.role.policyFragment, this.principalAccount = this.role.principalAccount, this.roleArn = this.role.roleArn, this.roleName = this.role.roleName, this.stack = this.role.stack;
        const rolePath = props.rolePath ?? this.node.path;
        constructs_1.Dependable.implement(this, { dependencyRoots: [this.role] }), this.policySynthesizer = helpers_internal_1.PolicySynthesizer.getOrCreate(this), this.policySynthesizer.addRole(rolePath, { roleName: this.roleName, managedPolicies: this.managedPolicies, policyStatements: this.policyStatements, assumeRolePolicy: core_1.Stack.of(this).resolve(props.assumeRolePolicy?.toJSON()?.Statement), missing: props.missing });
      }
      attachInlinePolicy(policy) {
        const statements = policy.document.toJSON()?.Statement;
        statements && Array.isArray(statements) && statements.forEach((statement) => {
          this.policyStatements.push(statement);
        });
      }
      addManagedPolicy(policy) {
        this.managedPolicies.push(policy);
      }
      addToPolicy(statement) {
        return this.policyStatements.push(statement.toStatementJson()), false;
      }
      addToPrincipalPolicy(statement) {
        return this.addToPolicy(statement), { statementAdded: true, policyDependable: new constructs_1.DependencyGroup() };
      }
      grant(grantee, ...actions) {
        return this.role.grant(grantee, ...actions);
      }
      grantPassRole(grantee) {
        return this.role.grantPassRole(grantee);
      }
      grantAssumeRole(identity) {
        return this.role.grantAssumeRole(identity);
      }
    };
    exports2.PrecreatedRole = PrecreatedRole;
  }
});

// node_modules/aws-cdk-lib/aws-iam/lib/role.js
var require_role = __commonJS({
  "node_modules/aws-cdk-lib/aws-iam/lib/role.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Role = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var grant_1 = require_grant();
    var iam_generated_1 = require_iam_generated();
    var managed_policy_1 = require_managed_policy();
    var policy_1 = require_policy();
    var policy_document_1 = require_policy_document();
    var principals_1 = require_principals();
    var assume_role_policy_1 = require_assume_role_policy();
    var immutable_role_1 = require_immutable_role();
    var imported_role_1 = require_imported_role();
    var policydoc_adapter_1 = require_policydoc_adapter();
    var precreated_role_1 = require_precreated_role();
    var util_1 = require_util3();
    var core_1 = require_core2();
    var helpers_internal_1 = require_helpers_internal();
    var MAX_INLINE_SIZE = 1e4;
    var MAX_MANAGEDPOL_SIZE = 6e3;
    var IAM_ROLE_SYMBOL = Symbol.for("@aws-cdk/packages/aws-iam/lib/role.Role");
    var Role = class _Role extends core_1.Resource {
      static fromRoleArn(scope, id, roleArn, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_FromRoleArnOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromRoleArn), error;
        }
        const scopeStack = core_1.Stack.of(scope), parsedArn = scopeStack.splitArn(roleArn, core_1.ArnFormat.SLASH_RESOURCE_NAME), resourceName = parsedArn.resourceName, roleAccount = parsedArn.account, roleName = resourceName.split("/").pop();
        if ((0, helpers_internal_1.getCustomizeRolesConfig)(scope).enabled)
          return new precreated_role_1.PrecreatedRole(scope, id, { rolePath: `${scope.node.path}/${id}`, role: new imported_role_1.ImportedRole(scope, `Import${id}`, { account: roleAccount, roleArn, roleName, ...options }) });
        if (options.addGrantsToResources !== void 0 && options.mutable !== false)
          throw new Error("'addGrantsToResources' can only be passed if 'mutable: false'");
        const roleArnAndScopeStackAccountComparison = core_1.Token.compareStrings(roleAccount ?? "", scopeStack.account), equalOrAnyUnresolved = roleArnAndScopeStackAccountComparison === core_1.TokenComparison.SAME || roleArnAndScopeStackAccountComparison === core_1.TokenComparison.BOTH_UNRESOLVED || roleArnAndScopeStackAccountComparison === core_1.TokenComparison.ONE_UNRESOLVED, mutableRoleId = options.mutable !== false && equalOrAnyUnresolved ? id : `MutableRole${id}`, importedRole = new imported_role_1.ImportedRole(scope, mutableRoleId, { roleArn, roleName, account: roleAccount, ...options });
        return options.mutable !== false && equalOrAnyUnresolved ? importedRole : new immutable_role_1.ImmutableRole(scope, id, importedRole, options.addGrantsToResources ?? false);
      }
      static isRole(x) {
        return x !== null && typeof x == "object" && IAM_ROLE_SYMBOL in x;
      }
      static fromRoleName(scope, id, roleName, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_FromRoleNameOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromRoleName), error;
        }
        return _Role.fromRoleArn(scope, id, core_1.Stack.of(scope).formatArn({ region: "", service: "iam", resource: "role", resourceName: roleName }), options);
      }
      static customizeRoles(scope, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_CustomizeRolesOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.customizeRoles), error;
        }
        const preventSynthesis = options?.preventSynthesis ?? true, useRoles = {};
        for (const [constructPath, roleName] of Object.entries(options?.usePrecreatedRoles ?? {})) {
          const absPath = constructPath.startsWith(scope.node.path) ? constructPath : `${scope.node.path}/${constructPath}`;
          useRoles[absPath] = roleName;
        }
        scope.node.setContext(helpers_internal_1.CUSTOMIZE_ROLES_CONTEXT_KEY, { preventSynthesis, usePrecreatedRoles: useRoles });
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.roleName }), this.grantPrincipal = this, this.principalAccount = this.env.account, this.assumeRoleAction = "sts:AssumeRole", this.managedPolicies = [], this.attachedPolicies = new util_1.AttachedPolicies(), this.dependables = /* @__PURE__ */ new Map(), this._didSplit = false;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_RoleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Role), error;
        }
        const externalIds = props.externalIds || [];
        props.externalId && externalIds.push(props.externalId), this.assumeRolePolicy = createAssumeRolePolicy(props.assumedBy, externalIds), this.managedPolicies.push(...props.managedPolicies || []), this.inlinePolicies = props.inlinePolicies || {}, this.permissionsBoundary = props.permissionsBoundary;
        const maxSessionDuration = props.maxSessionDuration && props.maxSessionDuration.toSeconds();
        validateMaxSessionDuration(maxSessionDuration);
        const description = props.description && props.description?.length > 0 ? props.description : void 0;
        if (description && description.length > 1e3)
          throw new Error("Role description must be no longer than 1000 characters.");
        validateRolePath(props.path);
        const config = this.getPrecreatedRoleConfig(), roleArn = core_1.Stack.of(scope).formatArn({ region: "", service: "iam", resource: "role", resourceName: config.precreatedRoleName }), importedRole = new imported_role_1.ImportedRole(this, "Import" + id, { roleArn, roleName: config.precreatedRoleName ?? id, account: core_1.Stack.of(this).account });
        if (this.roleName = importedRole.roleName, this.roleArn = importedRole.roleArn, config.enabled) {
          const role = new precreated_role_1.PrecreatedRole(this, "PrecreatedRole" + id, { rolePath: this.node.path, role: importedRole, missing: !config.precreatedRoleName, assumeRolePolicy: this.assumeRolePolicy });
          this.managedPolicies.forEach((policy) => role.addManagedPolicy(policy)), Object.entries(this.inlinePolicies).forEach(([name, policy]) => {
            role.attachInlinePolicy(new policy_1.Policy(this, name, { document: policy }));
          }), this._precreatedRole = role;
        }
        if (!config.preventSynthesis) {
          const role = new iam_generated_1.CfnRole(this, "Resource", { assumeRolePolicyDocument: this.assumeRolePolicy, managedPolicyArns: util_1.UniqueStringSet.from(() => this.managedPolicies.map((p) => p.managedPolicyArn)), policies: _flatten(this.inlinePolicies), path: props.path, permissionsBoundary: this.permissionsBoundary ? this.permissionsBoundary.managedPolicyArn : void 0, roleName: this.physicalName, maxSessionDuration, description });
          this._roleId = role.attrRoleId, this.roleArn = this.getResourceArnAttribute(role.attrArn, { region: "", service: "iam", resource: "role", resourceName: `${props.path ? props.path.substr(props.path.charAt(0) === "/" ? 1 : 0) : ""}${this.physicalName}` }), this.roleName = this.getResourceNameAttribute(role.ref), core_1.Aspects.of(this).add({ visit: (c) => {
            c === this && this.splitLargePolicy();
          } });
        }
        this.policyFragment = new principals_1.ArnPrincipal(this.roleArn).policyFragment;
        function _flatten(policies) {
          if (policies == null || Object.keys(policies).length === 0)
            return;
          const result = new Array();
          for (const policyName of Object.keys(policies)) {
            const policyDocument = policies[policyName];
            result.push({ policyName, policyDocument });
          }
          return result;
        }
        this.node.addValidation({ validate: () => this.validateRole() });
      }
      addToPrincipalPolicy(statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToPrincipalPolicy), error;
        }
        if (this._precreatedRole)
          return this._precreatedRole.addToPrincipalPolicy(statement);
        {
          this.defaultPolicy || (this.defaultPolicy = new policy_1.Policy(this, "DefaultPolicy"), this.attachInlinePolicy(this.defaultPolicy)), this.defaultPolicy.addStatements(statement);
          const policyDependable = new constructs_1.DependencyGroup();
          return this.dependables.set(statement, policyDependable), { statementAdded: true, policyDependable };
        }
      }
      addToPolicy(statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToPolicy), error;
        }
        return this._precreatedRole ? this._precreatedRole.addToPolicy(statement) : this.addToPrincipalPolicy(statement).statementAdded;
      }
      addManagedPolicy(policy) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IManagedPolicy(policy);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addManagedPolicy), error;
        }
        if (this._precreatedRole)
          return this._precreatedRole.addManagedPolicy(policy);
        if (this.managedPolicies.find((mp) => mp === policy))
          return;
        this.managedPolicies.push(policy);
      }
      attachInlinePolicy(policy) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_Policy(policy);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.attachInlinePolicy), error;
        }
        this._precreatedRole ? this._precreatedRole.attachInlinePolicy(policy) : (this.attachedPolicies.attach(policy), policy.attachToRole(this));
      }
      grant(grantee, ...actions) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IPrincipal(grantee);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grant), error;
        }
        return grant_1.Grant.addToPrincipal({ grantee, actions, resourceArns: [this.roleArn], scope: this });
      }
      grantPassRole(identity) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IPrincipal(identity);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantPassRole), error;
        }
        return this.grant(identity, "iam:PassRole");
      }
      grantAssumeRole(identity) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IPrincipal(identity);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantAssumeRole), error;
        }
        return this.grant(identity, "sts:AssumeRole");
      }
      get roleId() {
        if (!this._roleId)
          throw new Error('"roleId" is not available on precreated roles');
        return this._roleId;
      }
      withoutPolicyUpdates(options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_WithoutPolicyUpdatesOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.withoutPolicyUpdates), error;
        }
        return this.immutableRole || (this.immutableRole = new immutable_role_1.ImmutableRole(constructs_1.Node.of(this).scope, `ImmutableRole${this.node.id}`, this, options.addGrantsToResources ?? false)), this.immutableRole;
      }
      validateRole() {
        const errors = new Array();
        errors.push(...this.assumeRolePolicy?.validateForResourcePolicy() ?? []);
        for (const policy of Object.values(this.inlinePolicies))
          errors.push(...policy.validateForIdentityPolicy());
        return errors;
      }
      splitLargePolicy() {
        if (!this.defaultPolicy || this._didSplit)
          return;
        this._didSplit = true;
        const self2 = this, originalDoc = this.defaultPolicy.document, splitOffDocs = originalDoc._splitDocument(this, MAX_INLINE_SIZE, MAX_MANAGEDPOL_SIZE), mpCount = this.managedPolicies.length + (splitOffDocs.size - 1);
        mpCount > 20 ? core_1.Annotations.of(this).addWarning(`Policy too large: ${mpCount} exceeds the maximum of 20 managed policies attached to a Role`) : mpCount > 10 && core_1.Annotations.of(this).addWarning(`Policy large: ${mpCount} exceeds 10 managed policies attached to a Role, this requires a quota increase`), markDeclaringConstruct(originalDoc, this.defaultPolicy);
        let i = 1;
        for (const newDoc of splitOffDocs.keys()) {
          if (newDoc === originalDoc)
            continue;
          const mp = new managed_policy_1.ManagedPolicy(this, `OverflowPolicy${i++}`, { description: `Part of the policies for ${this.node.path}`, document: newDoc, roles: [this] });
          markDeclaringConstruct(newDoc, mp);
        }
        function markDeclaringConstruct(doc, declaringConstruct) {
          for (const original of splitOffDocs.get(doc) ?? [])
            self2.dependables.get(original)?.add(declaringConstruct);
        }
      }
      getPrecreatedRoleConfig() {
        return (0, helpers_internal_1.getPrecreatedRoleConfig)(this);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Role[_a] = { fqn: "aws-cdk-lib.aws_iam.Role", version: "2.80.0" }, exports2.Role = Role;
    function createAssumeRolePolicy(principal, externalIds) {
      const actualDoc = new policy_document_1.PolicyDocument(), addDoc = externalIds.length === 0 ? actualDoc : new policydoc_adapter_1.MutatingPolicyDocumentAdapter(actualDoc, (statement) => (statement.addCondition("StringEquals", { "sts:ExternalId": externalIds.length === 1 ? externalIds[0] : externalIds }), statement));
      return (0, assume_role_policy_1.defaultAddPrincipalToAssumeRole)(principal, addDoc), actualDoc;
    }
    function validateRolePath(path) {
      if (path === void 0 || core_1.Token.isUnresolved(path))
        return;
      const validRolePath = /^(\/|\/[\u0021-\u007F]+\/)$/;
      if (path.length == 0 || path.length > 512)
        throw new Error(`Role path must be between 1 and 512 characters. The provided role path is ${path.length} characters.`);
      if (!validRolePath.test(path))
        throw new Error(`Role path must be either a slash or valid characters (alphanumerics and symbols) surrounded by slashes. Valid characters are unicode characters in [\\u0021-\\u007F]. However, ${path} is provided.`);
    }
    function validateMaxSessionDuration(duration) {
      if (duration !== void 0 && (duration < 3600 || duration > 43200))
        throw new Error(`maxSessionDuration is set to ${duration}, but must be >= 3600sec (1hr) and <= 43200sec (12hrs)`);
    }
    Object.defineProperty(Role.prototype, IAM_ROLE_SYMBOL, { value: true, enumerable: false, writable: false });
  }
});

// node_modules/aws-cdk-lib/aws-iam/lib/user.js
var require_user = __commonJS({
  "node_modules/aws-cdk-lib/aws-iam/lib/user.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.User = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam_generated_1 = require_iam_generated();
    var policy_1 = require_policy();
    var principals_1 = require_principals();
    var util_1 = require_util3();
    var core_1 = require_core2();
    var User = class _User extends core_1.Resource {
      static fromUserName(scope, id, userName) {
        const userArn = core_1.Stack.of(scope).formatArn({ service: "iam", region: "", resource: "user", resourceName: userName });
        return _User.fromUserAttributes(scope, id, { userArn });
      }
      static fromUserArn(scope, id, userArn) {
        return _User.fromUserAttributes(scope, id, { userArn });
      }
      static fromUserAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_UserAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromUserAttributes), error;
        }
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.grantPrincipal = this, this.principalAccount = core_1.Aws.ACCOUNT_ID, this.userName = core_1.Arn.extractResourceName(attrs.userArn, "user").split("/").pop(), this.userArn = attrs.userArn, this.assumeRoleAction = "sts:AssumeRole", this.policyFragment = new principals_1.ArnPrincipal(attrs.userArn).policyFragment, this.attachedPolicies = new util_1.AttachedPolicies(), this.groupId = 0;
          }
          addToPolicy(statement) {
            return this.addToPrincipalPolicy(statement).statementAdded;
          }
          addToPrincipalPolicy(statement) {
            return this.defaultPolicy || (this.defaultPolicy = new policy_1.Policy(this, "Policy"), this.defaultPolicy.attachToUser(this)), this.defaultPolicy.addStatements(statement), { statementAdded: true, policyDependable: this.defaultPolicy };
          }
          addToGroup(group) {
            new iam_generated_1.CfnUserToGroupAddition(core_1.Stack.of(group), `${this.userName}Group${this.groupId}`, { groupName: group.groupName, users: [this.userName] }), this.groupId += 1;
          }
          attachInlinePolicy(policy) {
            this.attachedPolicies.attach(policy), policy.attachToUser(this);
          }
          addManagedPolicy(_policy) {
            throw new Error("Cannot add managed policy to imported User");
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.userName }), this.grantPrincipal = this, this.principalAccount = this.env.account, this.assumeRoleAction = "sts:AssumeRole", this.groups = new Array(), this.managedPolicies = new Array(), this.attachedPolicies = new util_1.AttachedPolicies();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_UserProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _User), error;
        }
        this.managedPolicies.push(...props.managedPolicies || []), this.permissionsBoundary = props.permissionsBoundary;
        const user = new iam_generated_1.CfnUser(this, "Resource", { userName: this.physicalName, groups: (0, util_1.undefinedIfEmpty)(() => this.groups), managedPolicyArns: core_1.Lazy.list({ produce: () => this.managedPolicies.map((p) => p.managedPolicyArn) }, { omitEmpty: true }), path: props.path, permissionsBoundary: this.permissionsBoundary ? this.permissionsBoundary.managedPolicyArn : void 0, loginProfile: this.parseLoginProfile(props) });
        this.userName = this.getResourceNameAttribute(user.ref), this.userArn = this.getResourceArnAttribute(user.attrArn, { region: "", service: "iam", resource: "user", resourceName: `${props.path ? props.path.substr(props.path.charAt(0) === "/" ? 1 : 0) : ""}${this.physicalName}` }), this.policyFragment = new principals_1.ArnPrincipal(this.userArn).policyFragment, props.groups && props.groups.forEach((g) => this.addToGroup(g));
      }
      addToGroup(group) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGroup(group);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToGroup), error;
        }
        this.groups.push(group.groupName);
      }
      addManagedPolicy(policy) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IManagedPolicy(policy);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addManagedPolicy), error;
        }
        this.managedPolicies.find((mp) => mp === policy) || this.managedPolicies.push(policy);
      }
      attachInlinePolicy(policy) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_Policy(policy);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.attachInlinePolicy), error;
        }
        this.attachedPolicies.attach(policy), policy.attachToUser(this);
      }
      addToPrincipalPolicy(statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToPrincipalPolicy), error;
        }
        return this.defaultPolicy || (this.defaultPolicy = new policy_1.Policy(this, "DefaultPolicy"), this.defaultPolicy.attachToUser(this)), this.defaultPolicy.addStatements(statement), { statementAdded: true, policyDependable: this.defaultPolicy };
      }
      addToPolicy(statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToPolicy), error;
        }
        return this.addToPrincipalPolicy(statement).statementAdded;
      }
      parseLoginProfile(props) {
        if (props.password)
          return { password: props.password.unsafeUnwrap(), passwordResetRequired: props.passwordResetRequired };
        if (props.passwordResetRequired)
          throw new Error('Cannot set "passwordResetRequired" without specifying "initialPassword"');
      }
    };
    _a = JSII_RTTI_SYMBOL_1, User[_a] = { fqn: "aws-cdk-lib.aws_iam.User", version: "2.80.0" }, exports2.User = User;
  }
});

// node_modules/aws-cdk-lib/aws-iam/lib/lazy-role.js
var require_lazy_role = __commonJS({
  "node_modules/aws-cdk-lib/aws-iam/lib/lazy-role.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LazyRole = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var role_1 = require_role();
    var cdk = require_core2();
    var LazyRole = class _LazyRole extends cdk.Resource {
      constructor(scope, id, props) {
        super(scope, id), this.props = props, this.grantPrincipal = this, this.principalAccount = this.env.account, this.assumeRoleAction = "sts:AssumeRole", this.statements = new Array(), this.policies = new Array(), this.managedPolicies = new Array();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_LazyRoleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _LazyRole), error;
        }
      }
      addToPrincipalPolicy(statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToPrincipalPolicy), error;
        }
        return this.role ? this.role.addToPrincipalPolicy(statement) : (this.statements.push(statement), { statementAdded: true, policyDependable: this });
      }
      addToPolicy(statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToPolicy), error;
        }
        return this.addToPrincipalPolicy(statement).statementAdded;
      }
      attachInlinePolicy(policy) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_Policy(policy);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.attachInlinePolicy), error;
        }
        this.role ? this.role.attachInlinePolicy(policy) : this.policies.push(policy);
      }
      addManagedPolicy(policy) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IManagedPolicy(policy);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addManagedPolicy), error;
        }
        this.role ? this.role.addManagedPolicy(policy) : this.managedPolicies.push(policy);
      }
      get roleArn() {
        return this.instantiate().roleArn;
      }
      get roleId() {
        return this.instantiate().roleId;
      }
      get roleName() {
        return this.instantiate().roleName;
      }
      get policyFragment() {
        return this.instantiate().policyFragment;
      }
      grant(identity, ...actions) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IPrincipal(identity);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grant), error;
        }
        return this.instantiate().grant(identity, ...actions);
      }
      grantPassRole(identity) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IPrincipal(identity);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantPassRole), error;
        }
        return this.instantiate().grantPassRole(identity);
      }
      grantAssumeRole(identity) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IPrincipal(identity);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantAssumeRole), error;
        }
        return this.instantiate().grantAssumeRole(identity);
      }
      instantiate() {
        if (!this.role) {
          const role = new role_1.Role(this, "Default", this.props);
          this.statements.forEach(role.addToPolicy.bind(role)), this.policies.forEach(role.attachInlinePolicy.bind(role)), this.managedPolicies.forEach(role.addManagedPolicy.bind(role)), this.role = role;
        }
        return this.role;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LazyRole[_a] = { fqn: "aws-cdk-lib.aws_iam.LazyRole", version: "2.80.0" }, exports2.LazyRole = LazyRole;
  }
});

// node_modules/aws-cdk-lib/aws-iam/lib/identity-base.js
var require_identity_base = __commonJS({
  "node_modules/aws-cdk-lib/aws-iam/lib/identity-base.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-iam/lib/unknown-principal.js
var require_unknown_principal = __commonJS({
  "node_modules/aws-cdk-lib/aws-iam/lib/unknown-principal.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.UnknownPrincipal = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var core_1 = require_core2();
    var UnknownPrincipal = class _UnknownPrincipal {
      constructor(props) {
        this.assumeRoleAction = "sts:AssumeRole";
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_UnknownPrincipalProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _UnknownPrincipal), error;
        }
        this.resource = props.resource, this.grantPrincipal = this;
      }
      get policyFragment() {
        throw new Error(`Cannot get policy fragment of ${constructs_1.Node.of(this.resource).path}, resource imported without a role`);
      }
      addToPrincipalPolicy(statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToPrincipalPolicy), error;
        }
        const stack = core_1.Stack.of(this.resource), repr = JSON.stringify(stack.resolve(statement));
        return core_1.Annotations.of(this.resource).addWarning(`Add statement to this resource's role: ${repr}`), { statementAdded: true, policyDependable: new constructs_1.DependencyGroup() };
      }
      addToPolicy(statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToPolicy), error;
        }
        return this.addToPrincipalPolicy(statement).statementAdded;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, UnknownPrincipal[_a] = { fqn: "aws-cdk-lib.aws_iam.UnknownPrincipal", version: "2.80.0" }, exports2.UnknownPrincipal = UnknownPrincipal;
  }
});

// node_modules/aws-cdk-lib/aws-iam/lib/oidc-provider.js
var require_oidc_provider = __commonJS({
  "node_modules/aws-cdk-lib/aws-iam/lib/oidc-provider.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.OpenIdConnectProvider = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var path = require("path");
    var core_1 = require_core2();
    var RESOURCE_TYPE = "Custom::AWSCDKOpenIdConnectProvider";
    var OpenIdConnectProvider = class _OpenIdConnectProvider extends core_1.Resource {
      static fromOpenIdConnectProviderArn(scope, id, openIdConnectProviderArn) {
        const resourceName = core_1.Arn.extractResourceName(openIdConnectProviderArn, "oidc-provider");
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.openIdConnectProviderArn = openIdConnectProviderArn, this.openIdConnectProviderIssuer = resourceName;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_OpenIdConnectProviderProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _OpenIdConnectProvider), error;
        }
        const provider = this.getOrCreateProvider(), resource = new core_1.CustomResource(this, "Resource", { resourceType: RESOURCE_TYPE, serviceToken: provider.serviceToken, properties: { ClientIDList: props.clientIds, ThumbprintList: props.thumbprints, Url: props.url, CodeHash: provider.codeHash } });
        this.openIdConnectProviderArn = core_1.Token.asString(resource.ref), this.openIdConnectProviderIssuer = core_1.Arn.extractResourceName(this.openIdConnectProviderArn, "oidc-provider"), this.openIdConnectProviderthumbprints = core_1.Token.asString(resource.getAtt("Thumbprints"));
      }
      getOrCreateProvider() {
        return core_1.CustomResourceProvider.getOrCreateProvider(this, RESOURCE_TYPE, { codeDirectory: path.join(__dirname, "oidc-provider"), runtime: core_1.CustomResourceProviderRuntime.NODEJS_16_X, policyStatements: [{ Effect: "Allow", Resource: "*", Action: ["iam:CreateOpenIDConnectProvider", "iam:DeleteOpenIDConnectProvider", "iam:UpdateOpenIDConnectProviderThumbprint", "iam:AddClientIDToOpenIDConnectProvider", "iam:RemoveClientIDFromOpenIDConnectProvider"] }] });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, OpenIdConnectProvider[_a] = { fqn: "aws-cdk-lib.aws_iam.OpenIdConnectProvider", version: "2.80.0" }, exports2.OpenIdConnectProvider = OpenIdConnectProvider;
  }
});

// node_modules/aws-cdk-lib/aws-iam/lib/permissions-boundary.js
var require_permissions_boundary2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-iam/lib/permissions-boundary.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PermissionsBoundary = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam_generated_1 = require_iam_generated();
    var core_1 = require_core2();
    var PermissionsBoundary = class _PermissionsBoundary {
      static of(scope) {
        return new _PermissionsBoundary(scope);
      }
      constructor(scope) {
        this.scope = scope;
      }
      apply(boundaryPolicy) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IManagedPolicy(boundaryPolicy);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.apply), error;
        }
        core_1.Aspects.of(this.scope).add({ visit(node) {
          core_1.CfnResource.isCfnResource(node) && (node.cfnResourceType == iam_generated_1.CfnRole.CFN_RESOURCE_TYPE_NAME || node.cfnResourceType == iam_generated_1.CfnUser.CFN_RESOURCE_TYPE_NAME) && node.addPropertyOverride("PermissionsBoundary", boundaryPolicy.managedPolicyArn);
        } });
      }
      clear() {
        core_1.Aspects.of(this.scope).add({ visit(node) {
          core_1.CfnResource.isCfnResource(node) && (node.cfnResourceType == iam_generated_1.CfnRole.CFN_RESOURCE_TYPE_NAME || node.cfnResourceType == iam_generated_1.CfnUser.CFN_RESOURCE_TYPE_NAME) && node.addPropertyDeletionOverride("PermissionsBoundary");
        } });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, PermissionsBoundary[_a] = { fqn: "aws-cdk-lib.aws_iam.PermissionsBoundary", version: "2.80.0" }, exports2.PermissionsBoundary = PermissionsBoundary;
  }
});

// node_modules/aws-cdk-lib/aws-iam/lib/saml-provider.js
var require_saml_provider = __commonJS({
  "node_modules/aws-cdk-lib/aws-iam/lib/saml-provider.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SamlProvider = exports2.SamlMetadataDocument = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var fs = require("fs");
    var iam_generated_1 = require_iam_generated();
    var core_1 = require_core2();
    var SamlMetadataDocument = class {
      static fromXml(xml) {
        return { xml };
      }
      static fromFile(path) {
        return { xml: fs.readFileSync(path, "utf-8") };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SamlMetadataDocument[_a] = { fqn: "aws-cdk-lib.aws_iam.SamlMetadataDocument", version: "2.80.0" }, exports2.SamlMetadataDocument = SamlMetadataDocument;
    var SamlProvider = class _SamlProvider extends core_1.Resource {
      static fromSamlProviderArn(scope, id, samlProviderArn) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.samlProviderArn = samlProviderArn;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_SamlProviderProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SamlProvider), error;
        }
        if (props.name && !core_1.Token.isUnresolved(props.name) && !/^[\w+=,.@-]{1,128}$/.test(props.name))
          throw new Error("Invalid SAML provider name. The name must be a string of characters consisting of upper and lowercase alphanumeric characters with no spaces. You can also include any of the following characters: _+=,.@-. Length must be between 1 and 128 characters.");
        const samlProvider = new iam_generated_1.CfnSAMLProvider(this, "Resource", { name: props.name, samlMetadataDocument: props.metadataDocument.xml });
        this.samlProviderArn = samlProvider.ref;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, SamlProvider[_b] = { fqn: "aws-cdk-lib.aws_iam.SamlProvider", version: "2.80.0" }, exports2.SamlProvider = SamlProvider;
  }
});

// node_modules/aws-cdk-lib/aws-iam/lib/access-key.js
var require_access_key = __commonJS({
  "node_modules/aws-cdk-lib/aws-iam/lib/access-key.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AccessKey = exports2.AccessKeyStatus = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam_generated_1 = require_iam_generated();
    var core_1 = require_core2();
    var AccessKeyStatus;
    (function(AccessKeyStatus2) {
      AccessKeyStatus2.ACTIVE = "Active", AccessKeyStatus2.INACTIVE = "Inactive";
    })(AccessKeyStatus = exports2.AccessKeyStatus || (exports2.AccessKeyStatus = {}));
    var AccessKey = class _AccessKey extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_AccessKeyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AccessKey), error;
        }
        const accessKey = new iam_generated_1.CfnAccessKey(this, "Resource", { userName: props.user.userName, serial: props.serial, status: props.status });
        this.accessKeyId = accessKey.ref, this.secretAccessKey = core_1.SecretValue.resourceAttribute(accessKey.attrSecretAccessKey);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AccessKey[_a] = { fqn: "aws-cdk-lib.aws_iam.AccessKey", version: "2.80.0" }, exports2.AccessKey = AccessKey;
  }
});

// node_modules/aws-cdk-lib/aws-iam/lib/utils.js
var require_utils6 = __commonJS({
  "node_modules/aws-cdk-lib/aws-iam/lib/utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.principalIsOwnedResource = void 0;
    var constructs_1 = require_lib2();
    var core_1 = require_core2();
    function principalIsOwnedResource(principal) {
      return isConstruct(principal) ? core_1.Resource.isOwnedResource(principal) : false;
    }
    exports2.principalIsOwnedResource = principalIsOwnedResource;
    function isConstruct(x) {
      const sym = Symbol.for("constructs.Construct.node");
      return typeof x == "object" && x && (x instanceof constructs_1.Construct || !!x.node || !!x[sym]);
    }
  }
});

// node_modules/aws-cdk-lib/aws-iam/lib/index.js
var require_lib9 = __commonJS({
  "node_modules/aws-cdk-lib/aws-iam/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_policy_document(), exports2), __exportStar(require_policy_statement(), exports2), __exportStar(require_managed_policy(), exports2), __exportStar(require_role(), exports2), __exportStar(require_policy(), exports2), __exportStar(require_user(), exports2), __exportStar(require_group(), exports2), __exportStar(require_lazy_role(), exports2), __exportStar(require_principals(), exports2), __exportStar(require_identity_base(), exports2), __exportStar(require_grant(), exports2), __exportStar(require_unknown_principal(), exports2), __exportStar(require_oidc_provider(), exports2), __exportStar(require_permissions_boundary2(), exports2), __exportStar(require_saml_provider(), exports2), __exportStar(require_access_key(), exports2), __exportStar(require_utils6(), exports2), __exportStar(require_iam_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-iam/index.js
var require_aws_iam = __commonJS({
  "node_modules/aws-cdk-lib/aws-iam/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib9(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/adot-layers.js
var require_adot_layers = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/adot-layers.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AdotLambdaLayerGenericVersion = exports2.AdotLambdaLayerJavaScriptSdkVersion = exports2.AdotLambdaLayerPythonSdkVersion = exports2.AdotLambdaLayerJavaAutoInstrumentationVersion = exports2.AdotLambdaLayerJavaSdkVersion = exports2.AdotLambdaExecWrapper = exports2.AdotLayerVersion = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var stack_1 = require_stack();
    var token_1 = require_token2();
    var region_info_1 = require_region_info2();
    var fact_1 = require_fact();
    var AdotLambdaLayerType;
    (function(AdotLambdaLayerType2) {
      AdotLambdaLayerType2.JAVA_SDK = "JAVA_SDK", AdotLambdaLayerType2.JAVA_AUTO_INSTRUMENTATION = "JAVA_AUTO_INSTRUMENTATION", AdotLambdaLayerType2.JAVASCRIPT_SDK = "JAVASCRIPT_SDK", AdotLambdaLayerType2.PYTHON_SDK = "PYTHON_SDK", AdotLambdaLayerType2.GENERIC = "GENERIC";
    })(AdotLambdaLayerType || (AdotLambdaLayerType = {}));
    function getLayerArn(scope, type, version, architecture) {
      const scopeStack = stack_1.Stack.of(scope), region = scopeStack.region;
      if (region !== void 0 && !token_1.Token.isUnresolved(region)) {
        const arn = region_info_1.RegionInfo.get(region).adotLambdaLayerArn(type, version, architecture);
        if (arn === void 0)
          throw new Error(`Could not find the ARN information for the ADOT Lambda Layer of type ${type} and version ${version} in ${region}`);
        return arn;
      }
      return scopeStack.regionalFact(fact_1.FactName.adotLambdaLayer(type, version, architecture));
    }
    var AdotLayerVersion = class _AdotLayerVersion {
      static fromJavaSdkLayerVersion(version) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_AdotLambdaLayerJavaSdkVersion(version);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromJavaSdkLayerVersion), error;
        }
        return _AdotLayerVersion.fromAdotVersion(version);
      }
      static fromJavaAutoInstrumentationLayerVersion(version) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_AdotLambdaLayerJavaAutoInstrumentationVersion(version);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromJavaAutoInstrumentationLayerVersion), error;
        }
        return _AdotLayerVersion.fromAdotVersion(version);
      }
      static fromJavaScriptSdkLayerVersion(version) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_AdotLambdaLayerJavaScriptSdkVersion(version);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromJavaScriptSdkLayerVersion), error;
        }
        return _AdotLayerVersion.fromAdotVersion(version);
      }
      static fromPythonSdkLayerVersion(version) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_AdotLambdaLayerPythonSdkVersion(version);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromPythonSdkLayerVersion), error;
        }
        return _AdotLayerVersion.fromAdotVersion(version);
      }
      static fromGenericLayerVersion(version) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_AdotLambdaLayerGenericVersion(version);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromGenericLayerVersion), error;
        }
        return _AdotLayerVersion.fromAdotVersion(version);
      }
      static fromAdotVersion(adotVersion) {
        return new class extends _AdotLayerVersion {
          _bind(_function) {
            return { arn: adotVersion.layerArn(_function.stack, _function.architecture) };
          }
        }();
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AdotLayerVersion[_a] = { fqn: "aws-cdk-lib.aws_lambda.AdotLayerVersion", version: "2.80.0" }, exports2.AdotLayerVersion = AdotLayerVersion;
    var AdotLambdaExecWrapper;
    (function(AdotLambdaExecWrapper2) {
      AdotLambdaExecWrapper2.REGULAR_HANDLER = "/opt/otel-handler", AdotLambdaExecWrapper2.PROXY_HANDLER = "/opt/otel-proxy-handler", AdotLambdaExecWrapper2.STREAM_HANDLER = "/opt/otel-stream-handler";
    })(AdotLambdaExecWrapper = exports2.AdotLambdaExecWrapper || (exports2.AdotLambdaExecWrapper = {}));
    var AdotLambdaLayerVersion = class {
      constructor(type, version) {
        this.type = type, this.version = version;
      }
      layerArn(scope, architecture) {
        return getLayerArn(scope, this.type, this.version, architecture.name);
      }
    };
    var AdotLambdaLayerJavaSdkVersion = class extends AdotLambdaLayerVersion {
      constructor(layerVersion) {
        super(AdotLambdaLayerType.JAVA_SDK, layerVersion), this.layerVersion = layerVersion;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, AdotLambdaLayerJavaSdkVersion[_b] = { fqn: "aws-cdk-lib.aws_lambda.AdotLambdaLayerJavaSdkVersion", version: "2.80.0" }, AdotLambdaLayerJavaSdkVersion.LATEST = new AdotLambdaLayerJavaSdkVersion("1.19.0"), AdotLambdaLayerJavaSdkVersion.V1_19_0 = new AdotLambdaLayerJavaSdkVersion("1.19.0"), exports2.AdotLambdaLayerJavaSdkVersion = AdotLambdaLayerJavaSdkVersion;
    var AdotLambdaLayerJavaAutoInstrumentationVersion = class extends AdotLambdaLayerVersion {
      constructor(layerVersion) {
        super(AdotLambdaLayerType.JAVA_AUTO_INSTRUMENTATION, layerVersion), this.layerVersion = layerVersion;
      }
    };
    _c = JSII_RTTI_SYMBOL_1, AdotLambdaLayerJavaAutoInstrumentationVersion[_c] = { fqn: "aws-cdk-lib.aws_lambda.AdotLambdaLayerJavaAutoInstrumentationVersion", version: "2.80.0" }, AdotLambdaLayerJavaAutoInstrumentationVersion.LATEST = new AdotLambdaLayerJavaAutoInstrumentationVersion("1.19.2"), AdotLambdaLayerJavaAutoInstrumentationVersion.V1_19_2 = new AdotLambdaLayerJavaAutoInstrumentationVersion("1.19.2"), exports2.AdotLambdaLayerJavaAutoInstrumentationVersion = AdotLambdaLayerJavaAutoInstrumentationVersion;
    var AdotLambdaLayerPythonSdkVersion = class extends AdotLambdaLayerVersion {
      constructor(layerVersion) {
        super(AdotLambdaLayerType.PYTHON_SDK, layerVersion), this.layerVersion = layerVersion;
      }
    };
    _d = JSII_RTTI_SYMBOL_1, AdotLambdaLayerPythonSdkVersion[_d] = { fqn: "aws-cdk-lib.aws_lambda.AdotLambdaLayerPythonSdkVersion", version: "2.80.0" }, AdotLambdaLayerPythonSdkVersion.LATEST = new AdotLambdaLayerPythonSdkVersion("1.13.0"), AdotLambdaLayerPythonSdkVersion.V1_13_0 = new AdotLambdaLayerPythonSdkVersion("1.13.0"), exports2.AdotLambdaLayerPythonSdkVersion = AdotLambdaLayerPythonSdkVersion;
    var AdotLambdaLayerJavaScriptSdkVersion = class extends AdotLambdaLayerVersion {
      constructor(layerVersion) {
        super(AdotLambdaLayerType.JAVASCRIPT_SDK, layerVersion), this.layerVersion = layerVersion;
      }
    };
    _e = JSII_RTTI_SYMBOL_1, AdotLambdaLayerJavaScriptSdkVersion[_e] = { fqn: "aws-cdk-lib.aws_lambda.AdotLambdaLayerJavaScriptSdkVersion", version: "2.80.0" }, AdotLambdaLayerJavaScriptSdkVersion.LATEST = new AdotLambdaLayerJavaScriptSdkVersion("1.7.0"), AdotLambdaLayerJavaScriptSdkVersion.V1_7_0 = new AdotLambdaLayerJavaScriptSdkVersion("1.7.0"), exports2.AdotLambdaLayerJavaScriptSdkVersion = AdotLambdaLayerJavaScriptSdkVersion;
    var AdotLambdaLayerGenericVersion = class extends AdotLambdaLayerVersion {
      constructor(layerVersion) {
        super(AdotLambdaLayerType.GENERIC, layerVersion), this.layerVersion = layerVersion;
      }
    };
    _f = JSII_RTTI_SYMBOL_1, AdotLambdaLayerGenericVersion[_f] = { fqn: "aws-cdk-lib.aws_lambda.AdotLambdaLayerGenericVersion", version: "2.80.0" }, AdotLambdaLayerGenericVersion.LATEST = new AdotLambdaLayerGenericVersion("0.62.1"), AdotLambdaLayerGenericVersion.V0_62_1 = new AdotLambdaLayerGenericVersion("0.62.1"), exports2.AdotLambdaLayerGenericVersion = AdotLambdaLayerGenericVersion;
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/destination.js
var require_destination = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/destination.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DestinationType = void 0;
    var DestinationType;
    (function(DestinationType2) {
      DestinationType2.FAILURE = "Failure", DestinationType2.SUCCESS = "Success";
    })(DestinationType = exports2.DestinationType || (exports2.DestinationType = {}));
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/lambda.generated.js
var require_lambda_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/lambda.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnVersion = exports2.CfnUrl = exports2.CfnPermission = exports2.CfnLayerVersionPermission = exports2.CfnLayerVersion = exports2.CfnFunction = exports2.CfnEventSourceMapping = exports2.CfnEventInvokeConfig = exports2.CfnCodeSigningConfig = exports2.CfnAlias = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAliasPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("functionName", cdk.requiredValidator)(properties.functionName)), errors.collect(cdk.propertyValidator("functionName", cdk.validateString)(properties.functionName)), errors.collect(cdk.propertyValidator("functionVersion", cdk.requiredValidator)(properties.functionVersion)), errors.collect(cdk.propertyValidator("functionVersion", cdk.validateString)(properties.functionVersion)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("provisionedConcurrencyConfig", CfnAlias_ProvisionedConcurrencyConfigurationPropertyValidator)(properties.provisionedConcurrencyConfig)), errors.collect(cdk.propertyValidator("routingConfig", CfnAlias_AliasRoutingConfigurationPropertyValidator)(properties.routingConfig)), errors.wrap('supplied properties not correct for "CfnAliasProps"');
    }
    function cfnAliasPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAliasPropsValidator(properties).assertSuccess(), { FunctionName: cdk.stringToCloudFormation(properties.functionName), FunctionVersion: cdk.stringToCloudFormation(properties.functionVersion), Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), ProvisionedConcurrencyConfig: cfnAliasProvisionedConcurrencyConfigurationPropertyToCloudFormation(properties.provisionedConcurrencyConfig), RoutingConfig: cfnAliasAliasRoutingConfigurationPropertyToCloudFormation(properties.routingConfig) }) : properties;
    }
    function CfnAliasPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("functionName", "FunctionName", cfn_parse.FromCloudFormation.getString(properties.FunctionName)), ret.addPropertyResult("functionVersion", "FunctionVersion", cfn_parse.FromCloudFormation.getString(properties.FunctionVersion)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("provisionedConcurrencyConfig", "ProvisionedConcurrencyConfig", properties.ProvisionedConcurrencyConfig != null ? CfnAliasProvisionedConcurrencyConfigurationPropertyFromCloudFormation(properties.ProvisionedConcurrencyConfig) : void 0), ret.addPropertyResult("routingConfig", "RoutingConfig", properties.RoutingConfig != null ? CfnAliasAliasRoutingConfigurationPropertyFromCloudFormation(properties.RoutingConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAlias = class _CfnAlias extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAliasPropsFromCloudFormation(resourceProperties), ret = new _CfnAlias(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAlias.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_CfnAliasProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAlias), error;
        }
        cdk.requireProperty(props, "functionName", this), cdk.requireProperty(props, "functionVersion", this), cdk.requireProperty(props, "name", this), this.functionName = props.functionName, this.functionVersion = props.functionVersion, this.name = props.name, this.description = props.description, this.provisionedConcurrencyConfig = props.provisionedConcurrencyConfig, this.routingConfig = props.routingConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAlias.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { functionName: this.functionName, functionVersion: this.functionVersion, name: this.name, description: this.description, provisionedConcurrencyConfig: this.provisionedConcurrencyConfig, routingConfig: this.routingConfig };
      }
      renderProperties(props) {
        return cfnAliasPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAlias[_a] = { fqn: "aws-cdk-lib.aws_lambda.CfnAlias", version: "2.80.0" }, CfnAlias.CFN_RESOURCE_TYPE_NAME = "AWS::Lambda::Alias", exports2.CfnAlias = CfnAlias;
    function CfnAlias_AliasRoutingConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("additionalVersionWeights", cdk.requiredValidator)(properties.additionalVersionWeights)), errors.collect(cdk.propertyValidator("additionalVersionWeights", cdk.listValidator(CfnAlias_VersionWeightPropertyValidator))(properties.additionalVersionWeights)), errors.wrap('supplied properties not correct for "AliasRoutingConfigurationProperty"');
    }
    function cfnAliasAliasRoutingConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlias_AliasRoutingConfigurationPropertyValidator(properties).assertSuccess(), { AdditionalVersionWeights: cdk.listMapper(cfnAliasVersionWeightPropertyToCloudFormation)(properties.additionalVersionWeights) }) : properties;
    }
    function CfnAliasAliasRoutingConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("additionalVersionWeights", "AdditionalVersionWeights", cfn_parse.FromCloudFormation.getArray(CfnAliasVersionWeightPropertyFromCloudFormation)(properties.AdditionalVersionWeights)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAlias_ProvisionedConcurrencyConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("provisionedConcurrentExecutions", cdk.requiredValidator)(properties.provisionedConcurrentExecutions)), errors.collect(cdk.propertyValidator("provisionedConcurrentExecutions", cdk.validateNumber)(properties.provisionedConcurrentExecutions)), errors.wrap('supplied properties not correct for "ProvisionedConcurrencyConfigurationProperty"');
    }
    function cfnAliasProvisionedConcurrencyConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlias_ProvisionedConcurrencyConfigurationPropertyValidator(properties).assertSuccess(), { ProvisionedConcurrentExecutions: cdk.numberToCloudFormation(properties.provisionedConcurrentExecutions) }) : properties;
    }
    function CfnAliasProvisionedConcurrencyConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("provisionedConcurrentExecutions", "ProvisionedConcurrentExecutions", cfn_parse.FromCloudFormation.getNumber(properties.ProvisionedConcurrentExecutions)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAlias_VersionWeightPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("functionVersion", cdk.requiredValidator)(properties.functionVersion)), errors.collect(cdk.propertyValidator("functionVersion", cdk.validateString)(properties.functionVersion)), errors.collect(cdk.propertyValidator("functionWeight", cdk.requiredValidator)(properties.functionWeight)), errors.collect(cdk.propertyValidator("functionWeight", cdk.validateNumber)(properties.functionWeight)), errors.wrap('supplied properties not correct for "VersionWeightProperty"');
    }
    function cfnAliasVersionWeightPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlias_VersionWeightPropertyValidator(properties).assertSuccess(), { FunctionVersion: cdk.stringToCloudFormation(properties.functionVersion), FunctionWeight: cdk.numberToCloudFormation(properties.functionWeight) }) : properties;
    }
    function CfnAliasVersionWeightPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("functionVersion", "FunctionVersion", cfn_parse.FromCloudFormation.getString(properties.FunctionVersion)), ret.addPropertyResult("functionWeight", "FunctionWeight", cfn_parse.FromCloudFormation.getNumber(properties.FunctionWeight)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCodeSigningConfigPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowedPublishers", cdk.requiredValidator)(properties.allowedPublishers)), errors.collect(cdk.propertyValidator("allowedPublishers", CfnCodeSigningConfig_AllowedPublishersPropertyValidator)(properties.allowedPublishers)), errors.collect(cdk.propertyValidator("codeSigningPolicies", CfnCodeSigningConfig_CodeSigningPoliciesPropertyValidator)(properties.codeSigningPolicies)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.wrap('supplied properties not correct for "CfnCodeSigningConfigProps"');
    }
    function cfnCodeSigningConfigPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCodeSigningConfigPropsValidator(properties).assertSuccess(), { AllowedPublishers: cfnCodeSigningConfigAllowedPublishersPropertyToCloudFormation(properties.allowedPublishers), CodeSigningPolicies: cfnCodeSigningConfigCodeSigningPoliciesPropertyToCloudFormation(properties.codeSigningPolicies), Description: cdk.stringToCloudFormation(properties.description) }) : properties;
    }
    function CfnCodeSigningConfigPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowedPublishers", "AllowedPublishers", CfnCodeSigningConfigAllowedPublishersPropertyFromCloudFormation(properties.AllowedPublishers)), ret.addPropertyResult("codeSigningPolicies", "CodeSigningPolicies", properties.CodeSigningPolicies != null ? CfnCodeSigningConfigCodeSigningPoliciesPropertyFromCloudFormation(properties.CodeSigningPolicies) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCodeSigningConfig = class _CfnCodeSigningConfig extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCodeSigningConfigPropsFromCloudFormation(resourceProperties), ret = new _CfnCodeSigningConfig(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCodeSigningConfig.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_CfnCodeSigningConfigProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCodeSigningConfig), error;
        }
        cdk.requireProperty(props, "allowedPublishers", this), this.attrCodeSigningConfigArn = cdk.Token.asString(this.getAtt("CodeSigningConfigArn", cdk.ResolutionTypeHint.STRING)), this.attrCodeSigningConfigId = cdk.Token.asString(this.getAtt("CodeSigningConfigId", cdk.ResolutionTypeHint.STRING)), this.allowedPublishers = props.allowedPublishers, this.codeSigningPolicies = props.codeSigningPolicies, this.description = props.description;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCodeSigningConfig.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { allowedPublishers: this.allowedPublishers, codeSigningPolicies: this.codeSigningPolicies, description: this.description };
      }
      renderProperties(props) {
        return cfnCodeSigningConfigPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnCodeSigningConfig[_b] = { fqn: "aws-cdk-lib.aws_lambda.CfnCodeSigningConfig", version: "2.80.0" }, CfnCodeSigningConfig.CFN_RESOURCE_TYPE_NAME = "AWS::Lambda::CodeSigningConfig", exports2.CfnCodeSigningConfig = CfnCodeSigningConfig;
    function CfnCodeSigningConfig_AllowedPublishersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("signingProfileVersionArns", cdk.requiredValidator)(properties.signingProfileVersionArns)), errors.collect(cdk.propertyValidator("signingProfileVersionArns", cdk.listValidator(cdk.validateString))(properties.signingProfileVersionArns)), errors.wrap('supplied properties not correct for "AllowedPublishersProperty"');
    }
    function cfnCodeSigningConfigAllowedPublishersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCodeSigningConfig_AllowedPublishersPropertyValidator(properties).assertSuccess(), { SigningProfileVersionArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.signingProfileVersionArns) }) : properties;
    }
    function CfnCodeSigningConfigAllowedPublishersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("signingProfileVersionArns", "SigningProfileVersionArns", cfn_parse.FromCloudFormation.getStringArray(properties.SigningProfileVersionArns)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCodeSigningConfig_CodeSigningPoliciesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("untrustedArtifactOnDeployment", cdk.requiredValidator)(properties.untrustedArtifactOnDeployment)), errors.collect(cdk.propertyValidator("untrustedArtifactOnDeployment", cdk.validateString)(properties.untrustedArtifactOnDeployment)), errors.wrap('supplied properties not correct for "CodeSigningPoliciesProperty"');
    }
    function cfnCodeSigningConfigCodeSigningPoliciesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCodeSigningConfig_CodeSigningPoliciesPropertyValidator(properties).assertSuccess(), { UntrustedArtifactOnDeployment: cdk.stringToCloudFormation(properties.untrustedArtifactOnDeployment) }) : properties;
    }
    function CfnCodeSigningConfigCodeSigningPoliciesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("untrustedArtifactOnDeployment", "UntrustedArtifactOnDeployment", cfn_parse.FromCloudFormation.getString(properties.UntrustedArtifactOnDeployment)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEventInvokeConfigPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationConfig", CfnEventInvokeConfig_DestinationConfigPropertyValidator)(properties.destinationConfig)), errors.collect(cdk.propertyValidator("functionName", cdk.requiredValidator)(properties.functionName)), errors.collect(cdk.propertyValidator("functionName", cdk.validateString)(properties.functionName)), errors.collect(cdk.propertyValidator("maximumEventAgeInSeconds", cdk.validateNumber)(properties.maximumEventAgeInSeconds)), errors.collect(cdk.propertyValidator("maximumRetryAttempts", cdk.validateNumber)(properties.maximumRetryAttempts)), errors.collect(cdk.propertyValidator("qualifier", cdk.requiredValidator)(properties.qualifier)), errors.collect(cdk.propertyValidator("qualifier", cdk.validateString)(properties.qualifier)), errors.wrap('supplied properties not correct for "CfnEventInvokeConfigProps"');
    }
    function cfnEventInvokeConfigPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventInvokeConfigPropsValidator(properties).assertSuccess(), { FunctionName: cdk.stringToCloudFormation(properties.functionName), Qualifier: cdk.stringToCloudFormation(properties.qualifier), DestinationConfig: cfnEventInvokeConfigDestinationConfigPropertyToCloudFormation(properties.destinationConfig), MaximumEventAgeInSeconds: cdk.numberToCloudFormation(properties.maximumEventAgeInSeconds), MaximumRetryAttempts: cdk.numberToCloudFormation(properties.maximumRetryAttempts) }) : properties;
    }
    function CfnEventInvokeConfigPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("functionName", "FunctionName", cfn_parse.FromCloudFormation.getString(properties.FunctionName)), ret.addPropertyResult("qualifier", "Qualifier", cfn_parse.FromCloudFormation.getString(properties.Qualifier)), ret.addPropertyResult("destinationConfig", "DestinationConfig", properties.DestinationConfig != null ? CfnEventInvokeConfigDestinationConfigPropertyFromCloudFormation(properties.DestinationConfig) : void 0), ret.addPropertyResult("maximumEventAgeInSeconds", "MaximumEventAgeInSeconds", properties.MaximumEventAgeInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumEventAgeInSeconds) : void 0), ret.addPropertyResult("maximumRetryAttempts", "MaximumRetryAttempts", properties.MaximumRetryAttempts != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumRetryAttempts) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEventInvokeConfig = class _CfnEventInvokeConfig extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEventInvokeConfigPropsFromCloudFormation(resourceProperties), ret = new _CfnEventInvokeConfig(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEventInvokeConfig.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_CfnEventInvokeConfigProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEventInvokeConfig), error;
        }
        cdk.requireProperty(props, "functionName", this), cdk.requireProperty(props, "qualifier", this), this.functionName = props.functionName, this.qualifier = props.qualifier, this.destinationConfig = props.destinationConfig, this.maximumEventAgeInSeconds = props.maximumEventAgeInSeconds, this.maximumRetryAttempts = props.maximumRetryAttempts;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEventInvokeConfig.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { functionName: this.functionName, qualifier: this.qualifier, destinationConfig: this.destinationConfig, maximumEventAgeInSeconds: this.maximumEventAgeInSeconds, maximumRetryAttempts: this.maximumRetryAttempts };
      }
      renderProperties(props) {
        return cfnEventInvokeConfigPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnEventInvokeConfig[_c] = { fqn: "aws-cdk-lib.aws_lambda.CfnEventInvokeConfig", version: "2.80.0" }, CfnEventInvokeConfig.CFN_RESOURCE_TYPE_NAME = "AWS::Lambda::EventInvokeConfig", exports2.CfnEventInvokeConfig = CfnEventInvokeConfig;
    function CfnEventInvokeConfig_DestinationConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("onFailure", CfnEventInvokeConfig_OnFailurePropertyValidator)(properties.onFailure)), errors.collect(cdk.propertyValidator("onSuccess", CfnEventInvokeConfig_OnSuccessPropertyValidator)(properties.onSuccess)), errors.wrap('supplied properties not correct for "DestinationConfigProperty"');
    }
    function cfnEventInvokeConfigDestinationConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventInvokeConfig_DestinationConfigPropertyValidator(properties).assertSuccess(), { OnFailure: cfnEventInvokeConfigOnFailurePropertyToCloudFormation(properties.onFailure), OnSuccess: cfnEventInvokeConfigOnSuccessPropertyToCloudFormation(properties.onSuccess) }) : properties;
    }
    function CfnEventInvokeConfigDestinationConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("onFailure", "OnFailure", properties.OnFailure != null ? CfnEventInvokeConfigOnFailurePropertyFromCloudFormation(properties.OnFailure) : void 0), ret.addPropertyResult("onSuccess", "OnSuccess", properties.OnSuccess != null ? CfnEventInvokeConfigOnSuccessPropertyFromCloudFormation(properties.OnSuccess) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEventInvokeConfig_OnFailurePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destination", cdk.requiredValidator)(properties.destination)), errors.collect(cdk.propertyValidator("destination", cdk.validateString)(properties.destination)), errors.wrap('supplied properties not correct for "OnFailureProperty"');
    }
    function cfnEventInvokeConfigOnFailurePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventInvokeConfig_OnFailurePropertyValidator(properties).assertSuccess(), { Destination: cdk.stringToCloudFormation(properties.destination) }) : properties;
    }
    function CfnEventInvokeConfigOnFailurePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destination", "Destination", cfn_parse.FromCloudFormation.getString(properties.Destination)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEventInvokeConfig_OnSuccessPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destination", cdk.requiredValidator)(properties.destination)), errors.collect(cdk.propertyValidator("destination", cdk.validateString)(properties.destination)), errors.wrap('supplied properties not correct for "OnSuccessProperty"');
    }
    function cfnEventInvokeConfigOnSuccessPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventInvokeConfig_OnSuccessPropertyValidator(properties).assertSuccess(), { Destination: cdk.stringToCloudFormation(properties.destination) }) : properties;
    }
    function CfnEventInvokeConfigOnSuccessPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destination", "Destination", cfn_parse.FromCloudFormation.getString(properties.Destination)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEventSourceMappingPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("amazonManagedKafkaEventSourceConfig", CfnEventSourceMapping_AmazonManagedKafkaEventSourceConfigPropertyValidator)(properties.amazonManagedKafkaEventSourceConfig)), errors.collect(cdk.propertyValidator("batchSize", cdk.validateNumber)(properties.batchSize)), errors.collect(cdk.propertyValidator("bisectBatchOnFunctionError", cdk.validateBoolean)(properties.bisectBatchOnFunctionError)), errors.collect(cdk.propertyValidator("destinationConfig", CfnEventSourceMapping_DestinationConfigPropertyValidator)(properties.destinationConfig)), errors.collect(cdk.propertyValidator("documentDbEventSourceConfig", CfnEventSourceMapping_DocumentDBEventSourceConfigPropertyValidator)(properties.documentDbEventSourceConfig)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("eventSourceArn", cdk.validateString)(properties.eventSourceArn)), errors.collect(cdk.propertyValidator("filterCriteria", CfnEventSourceMapping_FilterCriteriaPropertyValidator)(properties.filterCriteria)), errors.collect(cdk.propertyValidator("functionName", cdk.requiredValidator)(properties.functionName)), errors.collect(cdk.propertyValidator("functionName", cdk.validateString)(properties.functionName)), errors.collect(cdk.propertyValidator("functionResponseTypes", cdk.listValidator(cdk.validateString))(properties.functionResponseTypes)), errors.collect(cdk.propertyValidator("maximumBatchingWindowInSeconds", cdk.validateNumber)(properties.maximumBatchingWindowInSeconds)), errors.collect(cdk.propertyValidator("maximumRecordAgeInSeconds", cdk.validateNumber)(properties.maximumRecordAgeInSeconds)), errors.collect(cdk.propertyValidator("maximumRetryAttempts", cdk.validateNumber)(properties.maximumRetryAttempts)), errors.collect(cdk.propertyValidator("parallelizationFactor", cdk.validateNumber)(properties.parallelizationFactor)), errors.collect(cdk.propertyValidator("queues", cdk.listValidator(cdk.validateString))(properties.queues)), errors.collect(cdk.propertyValidator("scalingConfig", CfnEventSourceMapping_ScalingConfigPropertyValidator)(properties.scalingConfig)), errors.collect(cdk.propertyValidator("selfManagedEventSource", CfnEventSourceMapping_SelfManagedEventSourcePropertyValidator)(properties.selfManagedEventSource)), errors.collect(cdk.propertyValidator("selfManagedKafkaEventSourceConfig", CfnEventSourceMapping_SelfManagedKafkaEventSourceConfigPropertyValidator)(properties.selfManagedKafkaEventSourceConfig)), errors.collect(cdk.propertyValidator("sourceAccessConfigurations", cdk.listValidator(CfnEventSourceMapping_SourceAccessConfigurationPropertyValidator))(properties.sourceAccessConfigurations)), errors.collect(cdk.propertyValidator("startingPosition", cdk.validateString)(properties.startingPosition)), errors.collect(cdk.propertyValidator("startingPositionTimestamp", cdk.validateNumber)(properties.startingPositionTimestamp)), errors.collect(cdk.propertyValidator("topics", cdk.listValidator(cdk.validateString))(properties.topics)), errors.collect(cdk.propertyValidator("tumblingWindowInSeconds", cdk.validateNumber)(properties.tumblingWindowInSeconds)), errors.wrap('supplied properties not correct for "CfnEventSourceMappingProps"');
    }
    function cfnEventSourceMappingPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventSourceMappingPropsValidator(properties).assertSuccess(), { FunctionName: cdk.stringToCloudFormation(properties.functionName), AmazonManagedKafkaEventSourceConfig: cfnEventSourceMappingAmazonManagedKafkaEventSourceConfigPropertyToCloudFormation(properties.amazonManagedKafkaEventSourceConfig), BatchSize: cdk.numberToCloudFormation(properties.batchSize), BisectBatchOnFunctionError: cdk.booleanToCloudFormation(properties.bisectBatchOnFunctionError), DestinationConfig: cfnEventSourceMappingDestinationConfigPropertyToCloudFormation(properties.destinationConfig), DocumentDBEventSourceConfig: cfnEventSourceMappingDocumentDBEventSourceConfigPropertyToCloudFormation(properties.documentDbEventSourceConfig), Enabled: cdk.booleanToCloudFormation(properties.enabled), EventSourceArn: cdk.stringToCloudFormation(properties.eventSourceArn), FilterCriteria: cfnEventSourceMappingFilterCriteriaPropertyToCloudFormation(properties.filterCriteria), FunctionResponseTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.functionResponseTypes), MaximumBatchingWindowInSeconds: cdk.numberToCloudFormation(properties.maximumBatchingWindowInSeconds), MaximumRecordAgeInSeconds: cdk.numberToCloudFormation(properties.maximumRecordAgeInSeconds), MaximumRetryAttempts: cdk.numberToCloudFormation(properties.maximumRetryAttempts), ParallelizationFactor: cdk.numberToCloudFormation(properties.parallelizationFactor), Queues: cdk.listMapper(cdk.stringToCloudFormation)(properties.queues), ScalingConfig: cfnEventSourceMappingScalingConfigPropertyToCloudFormation(properties.scalingConfig), SelfManagedEventSource: cfnEventSourceMappingSelfManagedEventSourcePropertyToCloudFormation(properties.selfManagedEventSource), SelfManagedKafkaEventSourceConfig: cfnEventSourceMappingSelfManagedKafkaEventSourceConfigPropertyToCloudFormation(properties.selfManagedKafkaEventSourceConfig), SourceAccessConfigurations: cdk.listMapper(cfnEventSourceMappingSourceAccessConfigurationPropertyToCloudFormation)(properties.sourceAccessConfigurations), StartingPosition: cdk.stringToCloudFormation(properties.startingPosition), StartingPositionTimestamp: cdk.numberToCloudFormation(properties.startingPositionTimestamp), Topics: cdk.listMapper(cdk.stringToCloudFormation)(properties.topics), TumblingWindowInSeconds: cdk.numberToCloudFormation(properties.tumblingWindowInSeconds) }) : properties;
    }
    function CfnEventSourceMappingPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("functionName", "FunctionName", cfn_parse.FromCloudFormation.getString(properties.FunctionName)), ret.addPropertyResult("amazonManagedKafkaEventSourceConfig", "AmazonManagedKafkaEventSourceConfig", properties.AmazonManagedKafkaEventSourceConfig != null ? CfnEventSourceMappingAmazonManagedKafkaEventSourceConfigPropertyFromCloudFormation(properties.AmazonManagedKafkaEventSourceConfig) : void 0), ret.addPropertyResult("batchSize", "BatchSize", properties.BatchSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.BatchSize) : void 0), ret.addPropertyResult("bisectBatchOnFunctionError", "BisectBatchOnFunctionError", properties.BisectBatchOnFunctionError != null ? cfn_parse.FromCloudFormation.getBoolean(properties.BisectBatchOnFunctionError) : void 0), ret.addPropertyResult("destinationConfig", "DestinationConfig", properties.DestinationConfig != null ? CfnEventSourceMappingDestinationConfigPropertyFromCloudFormation(properties.DestinationConfig) : void 0), ret.addPropertyResult("documentDbEventSourceConfig", "DocumentDBEventSourceConfig", properties.DocumentDBEventSourceConfig != null ? CfnEventSourceMappingDocumentDBEventSourceConfigPropertyFromCloudFormation(properties.DocumentDBEventSourceConfig) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("eventSourceArn", "EventSourceArn", properties.EventSourceArn != null ? cfn_parse.FromCloudFormation.getString(properties.EventSourceArn) : void 0), ret.addPropertyResult("filterCriteria", "FilterCriteria", properties.FilterCriteria != null ? CfnEventSourceMappingFilterCriteriaPropertyFromCloudFormation(properties.FilterCriteria) : void 0), ret.addPropertyResult("functionResponseTypes", "FunctionResponseTypes", properties.FunctionResponseTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.FunctionResponseTypes) : void 0), ret.addPropertyResult("maximumBatchingWindowInSeconds", "MaximumBatchingWindowInSeconds", properties.MaximumBatchingWindowInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumBatchingWindowInSeconds) : void 0), ret.addPropertyResult("maximumRecordAgeInSeconds", "MaximumRecordAgeInSeconds", properties.MaximumRecordAgeInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumRecordAgeInSeconds) : void 0), ret.addPropertyResult("maximumRetryAttempts", "MaximumRetryAttempts", properties.MaximumRetryAttempts != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumRetryAttempts) : void 0), ret.addPropertyResult("parallelizationFactor", "ParallelizationFactor", properties.ParallelizationFactor != null ? cfn_parse.FromCloudFormation.getNumber(properties.ParallelizationFactor) : void 0), ret.addPropertyResult("queues", "Queues", properties.Queues != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Queues) : void 0), ret.addPropertyResult("scalingConfig", "ScalingConfig", properties.ScalingConfig != null ? CfnEventSourceMappingScalingConfigPropertyFromCloudFormation(properties.ScalingConfig) : void 0), ret.addPropertyResult("selfManagedEventSource", "SelfManagedEventSource", properties.SelfManagedEventSource != null ? CfnEventSourceMappingSelfManagedEventSourcePropertyFromCloudFormation(properties.SelfManagedEventSource) : void 0), ret.addPropertyResult("selfManagedKafkaEventSourceConfig", "SelfManagedKafkaEventSourceConfig", properties.SelfManagedKafkaEventSourceConfig != null ? CfnEventSourceMappingSelfManagedKafkaEventSourceConfigPropertyFromCloudFormation(properties.SelfManagedKafkaEventSourceConfig) : void 0), ret.addPropertyResult("sourceAccessConfigurations", "SourceAccessConfigurations", properties.SourceAccessConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnEventSourceMappingSourceAccessConfigurationPropertyFromCloudFormation)(properties.SourceAccessConfigurations) : void 0), ret.addPropertyResult("startingPosition", "StartingPosition", properties.StartingPosition != null ? cfn_parse.FromCloudFormation.getString(properties.StartingPosition) : void 0), ret.addPropertyResult("startingPositionTimestamp", "StartingPositionTimestamp", properties.StartingPositionTimestamp != null ? cfn_parse.FromCloudFormation.getNumber(properties.StartingPositionTimestamp) : void 0), ret.addPropertyResult("topics", "Topics", properties.Topics != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Topics) : void 0), ret.addPropertyResult("tumblingWindowInSeconds", "TumblingWindowInSeconds", properties.TumblingWindowInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.TumblingWindowInSeconds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEventSourceMapping = class _CfnEventSourceMapping extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEventSourceMappingPropsFromCloudFormation(resourceProperties), ret = new _CfnEventSourceMapping(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEventSourceMapping.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_CfnEventSourceMappingProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEventSourceMapping), error;
        }
        cdk.requireProperty(props, "functionName", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.functionName = props.functionName, this.amazonManagedKafkaEventSourceConfig = props.amazonManagedKafkaEventSourceConfig, this.batchSize = props.batchSize, this.bisectBatchOnFunctionError = props.bisectBatchOnFunctionError, this.destinationConfig = props.destinationConfig, this.documentDbEventSourceConfig = props.documentDbEventSourceConfig, this.enabled = props.enabled, this.eventSourceArn = props.eventSourceArn, this.filterCriteria = props.filterCriteria, this.functionResponseTypes = props.functionResponseTypes, this.maximumBatchingWindowInSeconds = props.maximumBatchingWindowInSeconds, this.maximumRecordAgeInSeconds = props.maximumRecordAgeInSeconds, this.maximumRetryAttempts = props.maximumRetryAttempts, this.parallelizationFactor = props.parallelizationFactor, this.queues = props.queues, this.scalingConfig = props.scalingConfig, this.selfManagedEventSource = props.selfManagedEventSource, this.selfManagedKafkaEventSourceConfig = props.selfManagedKafkaEventSourceConfig, this.sourceAccessConfigurations = props.sourceAccessConfigurations, this.startingPosition = props.startingPosition, this.startingPositionTimestamp = props.startingPositionTimestamp, this.topics = props.topics, this.tumblingWindowInSeconds = props.tumblingWindowInSeconds;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEventSourceMapping.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { functionName: this.functionName, amazonManagedKafkaEventSourceConfig: this.amazonManagedKafkaEventSourceConfig, batchSize: this.batchSize, bisectBatchOnFunctionError: this.bisectBatchOnFunctionError, destinationConfig: this.destinationConfig, documentDbEventSourceConfig: this.documentDbEventSourceConfig, enabled: this.enabled, eventSourceArn: this.eventSourceArn, filterCriteria: this.filterCriteria, functionResponseTypes: this.functionResponseTypes, maximumBatchingWindowInSeconds: this.maximumBatchingWindowInSeconds, maximumRecordAgeInSeconds: this.maximumRecordAgeInSeconds, maximumRetryAttempts: this.maximumRetryAttempts, parallelizationFactor: this.parallelizationFactor, queues: this.queues, scalingConfig: this.scalingConfig, selfManagedEventSource: this.selfManagedEventSource, selfManagedKafkaEventSourceConfig: this.selfManagedKafkaEventSourceConfig, sourceAccessConfigurations: this.sourceAccessConfigurations, startingPosition: this.startingPosition, startingPositionTimestamp: this.startingPositionTimestamp, topics: this.topics, tumblingWindowInSeconds: this.tumblingWindowInSeconds };
      }
      renderProperties(props) {
        return cfnEventSourceMappingPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnEventSourceMapping[_d] = { fqn: "aws-cdk-lib.aws_lambda.CfnEventSourceMapping", version: "2.80.0" }, CfnEventSourceMapping.CFN_RESOURCE_TYPE_NAME = "AWS::Lambda::EventSourceMapping", exports2.CfnEventSourceMapping = CfnEventSourceMapping;
    function CfnEventSourceMapping_AmazonManagedKafkaEventSourceConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("consumerGroupId", cdk.validateString)(properties.consumerGroupId)), errors.wrap('supplied properties not correct for "AmazonManagedKafkaEventSourceConfigProperty"');
    }
    function cfnEventSourceMappingAmazonManagedKafkaEventSourceConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventSourceMapping_AmazonManagedKafkaEventSourceConfigPropertyValidator(properties).assertSuccess(), { ConsumerGroupId: cdk.stringToCloudFormation(properties.consumerGroupId) }) : properties;
    }
    function CfnEventSourceMappingAmazonManagedKafkaEventSourceConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("consumerGroupId", "ConsumerGroupId", properties.ConsumerGroupId != null ? cfn_parse.FromCloudFormation.getString(properties.ConsumerGroupId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEventSourceMapping_DestinationConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("onFailure", CfnEventSourceMapping_OnFailurePropertyValidator)(properties.onFailure)), errors.wrap('supplied properties not correct for "DestinationConfigProperty"');
    }
    function cfnEventSourceMappingDestinationConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventSourceMapping_DestinationConfigPropertyValidator(properties).assertSuccess(), { OnFailure: cfnEventSourceMappingOnFailurePropertyToCloudFormation(properties.onFailure) }) : properties;
    }
    function CfnEventSourceMappingDestinationConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("onFailure", "OnFailure", properties.OnFailure != null ? CfnEventSourceMappingOnFailurePropertyFromCloudFormation(properties.OnFailure) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEventSourceMapping_DocumentDBEventSourceConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("collectionName", cdk.validateString)(properties.collectionName)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("fullDocument", cdk.validateString)(properties.fullDocument)), errors.wrap('supplied properties not correct for "DocumentDBEventSourceConfigProperty"');
    }
    function cfnEventSourceMappingDocumentDBEventSourceConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventSourceMapping_DocumentDBEventSourceConfigPropertyValidator(properties).assertSuccess(), { CollectionName: cdk.stringToCloudFormation(properties.collectionName), DatabaseName: cdk.stringToCloudFormation(properties.databaseName), FullDocument: cdk.stringToCloudFormation(properties.fullDocument) }) : properties;
    }
    function CfnEventSourceMappingDocumentDBEventSourceConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("collectionName", "CollectionName", properties.CollectionName != null ? cfn_parse.FromCloudFormation.getString(properties.CollectionName) : void 0), ret.addPropertyResult("databaseName", "DatabaseName", properties.DatabaseName != null ? cfn_parse.FromCloudFormation.getString(properties.DatabaseName) : void 0), ret.addPropertyResult("fullDocument", "FullDocument", properties.FullDocument != null ? cfn_parse.FromCloudFormation.getString(properties.FullDocument) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEventSourceMapping_EndpointsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kafkaBootstrapServers", cdk.listValidator(cdk.validateString))(properties.kafkaBootstrapServers)), errors.wrap('supplied properties not correct for "EndpointsProperty"');
    }
    function cfnEventSourceMappingEndpointsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventSourceMapping_EndpointsPropertyValidator(properties).assertSuccess(), { KafkaBootstrapServers: cdk.listMapper(cdk.stringToCloudFormation)(properties.kafkaBootstrapServers) }) : properties;
    }
    function CfnEventSourceMappingEndpointsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kafkaBootstrapServers", "KafkaBootstrapServers", properties.KafkaBootstrapServers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.KafkaBootstrapServers) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEventSourceMapping_FilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("pattern", cdk.validateString)(properties.pattern)), errors.wrap('supplied properties not correct for "FilterProperty"');
    }
    function cfnEventSourceMappingFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventSourceMapping_FilterPropertyValidator(properties).assertSuccess(), { Pattern: cdk.stringToCloudFormation(properties.pattern) }) : properties;
    }
    function CfnEventSourceMappingFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("pattern", "Pattern", properties.Pattern != null ? cfn_parse.FromCloudFormation.getString(properties.Pattern) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEventSourceMapping_FilterCriteriaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("filters", cdk.listValidator(CfnEventSourceMapping_FilterPropertyValidator))(properties.filters)), errors.wrap('supplied properties not correct for "FilterCriteriaProperty"');
    }
    function cfnEventSourceMappingFilterCriteriaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventSourceMapping_FilterCriteriaPropertyValidator(properties).assertSuccess(), { Filters: cdk.listMapper(cfnEventSourceMappingFilterPropertyToCloudFormation)(properties.filters) }) : properties;
    }
    function CfnEventSourceMappingFilterCriteriaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("filters", "Filters", properties.Filters != null ? cfn_parse.FromCloudFormation.getArray(CfnEventSourceMappingFilterPropertyFromCloudFormation)(properties.Filters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEventSourceMapping_OnFailurePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destination", cdk.validateString)(properties.destination)), errors.wrap('supplied properties not correct for "OnFailureProperty"');
    }
    function cfnEventSourceMappingOnFailurePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventSourceMapping_OnFailurePropertyValidator(properties).assertSuccess(), { Destination: cdk.stringToCloudFormation(properties.destination) }) : properties;
    }
    function CfnEventSourceMappingOnFailurePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destination", "Destination", properties.Destination != null ? cfn_parse.FromCloudFormation.getString(properties.Destination) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEventSourceMapping_ScalingConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maximumConcurrency", cdk.validateNumber)(properties.maximumConcurrency)), errors.wrap('supplied properties not correct for "ScalingConfigProperty"');
    }
    function cfnEventSourceMappingScalingConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventSourceMapping_ScalingConfigPropertyValidator(properties).assertSuccess(), { MaximumConcurrency: cdk.numberToCloudFormation(properties.maximumConcurrency) }) : properties;
    }
    function CfnEventSourceMappingScalingConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maximumConcurrency", "MaximumConcurrency", properties.MaximumConcurrency != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumConcurrency) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEventSourceMapping_SelfManagedEventSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endpoints", CfnEventSourceMapping_EndpointsPropertyValidator)(properties.endpoints)), errors.wrap('supplied properties not correct for "SelfManagedEventSourceProperty"');
    }
    function cfnEventSourceMappingSelfManagedEventSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventSourceMapping_SelfManagedEventSourcePropertyValidator(properties).assertSuccess(), { Endpoints: cfnEventSourceMappingEndpointsPropertyToCloudFormation(properties.endpoints) }) : properties;
    }
    function CfnEventSourceMappingSelfManagedEventSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endpoints", "Endpoints", properties.Endpoints != null ? CfnEventSourceMappingEndpointsPropertyFromCloudFormation(properties.Endpoints) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEventSourceMapping_SelfManagedKafkaEventSourceConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("consumerGroupId", cdk.validateString)(properties.consumerGroupId)), errors.wrap('supplied properties not correct for "SelfManagedKafkaEventSourceConfigProperty"');
    }
    function cfnEventSourceMappingSelfManagedKafkaEventSourceConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventSourceMapping_SelfManagedKafkaEventSourceConfigPropertyValidator(properties).assertSuccess(), { ConsumerGroupId: cdk.stringToCloudFormation(properties.consumerGroupId) }) : properties;
    }
    function CfnEventSourceMappingSelfManagedKafkaEventSourceConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("consumerGroupId", "ConsumerGroupId", properties.ConsumerGroupId != null ? cfn_parse.FromCloudFormation.getString(properties.ConsumerGroupId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEventSourceMapping_SourceAccessConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("uri", cdk.validateString)(properties.uri)), errors.wrap('supplied properties not correct for "SourceAccessConfigurationProperty"');
    }
    function cfnEventSourceMappingSourceAccessConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventSourceMapping_SourceAccessConfigurationPropertyValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type), URI: cdk.stringToCloudFormation(properties.uri) }) : properties;
    }
    function CfnEventSourceMappingSourceAccessConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addPropertyResult("uri", "URI", properties.URI != null ? cfn_parse.FromCloudFormation.getString(properties.URI) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunctionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("architectures", cdk.listValidator(cdk.validateString))(properties.architectures)), errors.collect(cdk.propertyValidator("code", cdk.requiredValidator)(properties.code)), errors.collect(cdk.propertyValidator("code", CfnFunction_CodePropertyValidator)(properties.code)), errors.collect(cdk.propertyValidator("codeSigningConfigArn", cdk.validateString)(properties.codeSigningConfigArn)), errors.collect(cdk.propertyValidator("deadLetterConfig", CfnFunction_DeadLetterConfigPropertyValidator)(properties.deadLetterConfig)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("environment", CfnFunction_EnvironmentPropertyValidator)(properties.environment)), errors.collect(cdk.propertyValidator("ephemeralStorage", CfnFunction_EphemeralStoragePropertyValidator)(properties.ephemeralStorage)), errors.collect(cdk.propertyValidator("fileSystemConfigs", cdk.listValidator(CfnFunction_FileSystemConfigPropertyValidator))(properties.fileSystemConfigs)), errors.collect(cdk.propertyValidator("functionName", cdk.validateString)(properties.functionName)), errors.collect(cdk.propertyValidator("handler", cdk.validateString)(properties.handler)), errors.collect(cdk.propertyValidator("imageConfig", CfnFunction_ImageConfigPropertyValidator)(properties.imageConfig)), errors.collect(cdk.propertyValidator("kmsKeyArn", cdk.validateString)(properties.kmsKeyArn)), errors.collect(cdk.propertyValidator("layers", cdk.listValidator(cdk.validateString))(properties.layers)), errors.collect(cdk.propertyValidator("memorySize", cdk.validateNumber)(properties.memorySize)), errors.collect(cdk.propertyValidator("packageType", cdk.validateString)(properties.packageType)), errors.collect(cdk.propertyValidator("reservedConcurrentExecutions", cdk.validateNumber)(properties.reservedConcurrentExecutions)), errors.collect(cdk.propertyValidator("role", cdk.requiredValidator)(properties.role)), errors.collect(cdk.propertyValidator("role", cdk.validateString)(properties.role)), errors.collect(cdk.propertyValidator("runtime", cdk.validateString)(properties.runtime)), errors.collect(cdk.propertyValidator("runtimeManagementConfig", CfnFunction_RuntimeManagementConfigPropertyValidator)(properties.runtimeManagementConfig)), errors.collect(cdk.propertyValidator("snapStart", CfnFunction_SnapStartPropertyValidator)(properties.snapStart)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("timeout", cdk.validateNumber)(properties.timeout)), errors.collect(cdk.propertyValidator("tracingConfig", CfnFunction_TracingConfigPropertyValidator)(properties.tracingConfig)), errors.collect(cdk.propertyValidator("vpcConfig", CfnFunction_VpcConfigPropertyValidator)(properties.vpcConfig)), errors.wrap('supplied properties not correct for "CfnFunctionProps"');
    }
    function cfnFunctionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunctionPropsValidator(properties).assertSuccess(), { Code: cfnFunctionCodePropertyToCloudFormation(properties.code), Role: cdk.stringToCloudFormation(properties.role), Architectures: cdk.listMapper(cdk.stringToCloudFormation)(properties.architectures), CodeSigningConfigArn: cdk.stringToCloudFormation(properties.codeSigningConfigArn), DeadLetterConfig: cfnFunctionDeadLetterConfigPropertyToCloudFormation(properties.deadLetterConfig), Description: cdk.stringToCloudFormation(properties.description), Environment: cfnFunctionEnvironmentPropertyToCloudFormation(properties.environment), EphemeralStorage: cfnFunctionEphemeralStoragePropertyToCloudFormation(properties.ephemeralStorage), FileSystemConfigs: cdk.listMapper(cfnFunctionFileSystemConfigPropertyToCloudFormation)(properties.fileSystemConfigs), FunctionName: cdk.stringToCloudFormation(properties.functionName), Handler: cdk.stringToCloudFormation(properties.handler), ImageConfig: cfnFunctionImageConfigPropertyToCloudFormation(properties.imageConfig), KmsKeyArn: cdk.stringToCloudFormation(properties.kmsKeyArn), Layers: cdk.listMapper(cdk.stringToCloudFormation)(properties.layers), MemorySize: cdk.numberToCloudFormation(properties.memorySize), PackageType: cdk.stringToCloudFormation(properties.packageType), ReservedConcurrentExecutions: cdk.numberToCloudFormation(properties.reservedConcurrentExecutions), Runtime: cdk.stringToCloudFormation(properties.runtime), RuntimeManagementConfig: cfnFunctionRuntimeManagementConfigPropertyToCloudFormation(properties.runtimeManagementConfig), SnapStart: cfnFunctionSnapStartPropertyToCloudFormation(properties.snapStart), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), Timeout: cdk.numberToCloudFormation(properties.timeout), TracingConfig: cfnFunctionTracingConfigPropertyToCloudFormation(properties.tracingConfig), VpcConfig: cfnFunctionVpcConfigPropertyToCloudFormation(properties.vpcConfig) }) : properties;
    }
    function CfnFunctionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("code", "Code", CfnFunctionCodePropertyFromCloudFormation(properties.Code)), ret.addPropertyResult("role", "Role", cfn_parse.FromCloudFormation.getString(properties.Role)), ret.addPropertyResult("architectures", "Architectures", properties.Architectures != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Architectures) : void 0), ret.addPropertyResult("codeSigningConfigArn", "CodeSigningConfigArn", properties.CodeSigningConfigArn != null ? cfn_parse.FromCloudFormation.getString(properties.CodeSigningConfigArn) : void 0), ret.addPropertyResult("deadLetterConfig", "DeadLetterConfig", properties.DeadLetterConfig != null ? CfnFunctionDeadLetterConfigPropertyFromCloudFormation(properties.DeadLetterConfig) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("environment", "Environment", properties.Environment != null ? CfnFunctionEnvironmentPropertyFromCloudFormation(properties.Environment) : void 0), ret.addPropertyResult("ephemeralStorage", "EphemeralStorage", properties.EphemeralStorage != null ? CfnFunctionEphemeralStoragePropertyFromCloudFormation(properties.EphemeralStorage) : void 0), ret.addPropertyResult("fileSystemConfigs", "FileSystemConfigs", properties.FileSystemConfigs != null ? cfn_parse.FromCloudFormation.getArray(CfnFunctionFileSystemConfigPropertyFromCloudFormation)(properties.FileSystemConfigs) : void 0), ret.addPropertyResult("functionName", "FunctionName", properties.FunctionName != null ? cfn_parse.FromCloudFormation.getString(properties.FunctionName) : void 0), ret.addPropertyResult("handler", "Handler", properties.Handler != null ? cfn_parse.FromCloudFormation.getString(properties.Handler) : void 0), ret.addPropertyResult("imageConfig", "ImageConfig", properties.ImageConfig != null ? CfnFunctionImageConfigPropertyFromCloudFormation(properties.ImageConfig) : void 0), ret.addPropertyResult("kmsKeyArn", "KmsKeyArn", properties.KmsKeyArn != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyArn) : void 0), ret.addPropertyResult("layers", "Layers", properties.Layers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Layers) : void 0), ret.addPropertyResult("memorySize", "MemorySize", properties.MemorySize != null ? cfn_parse.FromCloudFormation.getNumber(properties.MemorySize) : void 0), ret.addPropertyResult("packageType", "PackageType", properties.PackageType != null ? cfn_parse.FromCloudFormation.getString(properties.PackageType) : void 0), ret.addPropertyResult("reservedConcurrentExecutions", "ReservedConcurrentExecutions", properties.ReservedConcurrentExecutions != null ? cfn_parse.FromCloudFormation.getNumber(properties.ReservedConcurrentExecutions) : void 0), ret.addPropertyResult("runtime", "Runtime", properties.Runtime != null ? cfn_parse.FromCloudFormation.getString(properties.Runtime) : void 0), ret.addPropertyResult("runtimeManagementConfig", "RuntimeManagementConfig", properties.RuntimeManagementConfig != null ? CfnFunctionRuntimeManagementConfigPropertyFromCloudFormation(properties.RuntimeManagementConfig) : void 0), ret.addPropertyResult("snapStart", "SnapStart", properties.SnapStart != null ? CfnFunctionSnapStartPropertyFromCloudFormation(properties.SnapStart) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("timeout", "Timeout", properties.Timeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.Timeout) : void 0), ret.addPropertyResult("tracingConfig", "TracingConfig", properties.TracingConfig != null ? CfnFunctionTracingConfigPropertyFromCloudFormation(properties.TracingConfig) : void 0), ret.addPropertyResult("vpcConfig", "VpcConfig", properties.VpcConfig != null ? CfnFunctionVpcConfigPropertyFromCloudFormation(properties.VpcConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFunction = class _CfnFunction extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFunctionPropsFromCloudFormation(resourceProperties), ret = new _CfnFunction(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFunction.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_CfnFunctionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFunction), error;
        }
        cdk.requireProperty(props, "code", this), cdk.requireProperty(props, "role", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrSnapStartResponseApplyOn = cdk.Token.asString(this.getAtt("SnapStartResponse.ApplyOn", cdk.ResolutionTypeHint.STRING)), this.attrSnapStartResponseOptimizationStatus = cdk.Token.asString(this.getAtt("SnapStartResponse.OptimizationStatus", cdk.ResolutionTypeHint.STRING)), this.code = props.code, this.role = props.role, this.architectures = props.architectures, this.codeSigningConfigArn = props.codeSigningConfigArn, this.deadLetterConfig = props.deadLetterConfig, this.description = props.description, this.environment = props.environment, this.ephemeralStorage = props.ephemeralStorage, this.fileSystemConfigs = props.fileSystemConfigs, this.functionName = props.functionName, this.handler = props.handler, this.imageConfig = props.imageConfig, this.kmsKeyArn = props.kmsKeyArn, this.layers = props.layers, this.memorySize = props.memorySize, this.packageType = props.packageType, this.reservedConcurrentExecutions = props.reservedConcurrentExecutions, this.runtime = props.runtime, this.runtimeManagementConfig = props.runtimeManagementConfig, this.snapStart = props.snapStart, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Lambda::Function", props.tags, { tagPropertyName: "tags" }), this.timeout = props.timeout, this.tracingConfig = props.tracingConfig, this.vpcConfig = props.vpcConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFunction.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { code: this.code, role: this.role, architectures: this.architectures, codeSigningConfigArn: this.codeSigningConfigArn, deadLetterConfig: this.deadLetterConfig, description: this.description, environment: this.environment, ephemeralStorage: this.ephemeralStorage, fileSystemConfigs: this.fileSystemConfigs, functionName: this.functionName, handler: this.handler, imageConfig: this.imageConfig, kmsKeyArn: this.kmsKeyArn, layers: this.layers, memorySize: this.memorySize, packageType: this.packageType, reservedConcurrentExecutions: this.reservedConcurrentExecutions, runtime: this.runtime, runtimeManagementConfig: this.runtimeManagementConfig, snapStart: this.snapStart, tags: this.tags.renderTags(), timeout: this.timeout, tracingConfig: this.tracingConfig, vpcConfig: this.vpcConfig };
      }
      renderProperties(props) {
        return cfnFunctionPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnFunction[_e] = { fqn: "aws-cdk-lib.aws_lambda.CfnFunction", version: "2.80.0" }, CfnFunction.CFN_RESOURCE_TYPE_NAME = "AWS::Lambda::Function", exports2.CfnFunction = CfnFunction;
    function CfnFunction_CodePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("imageUri", cdk.validateString)(properties.imageUri)), errors.collect(cdk.propertyValidator("s3Bucket", cdk.validateString)(properties.s3Bucket)), errors.collect(cdk.propertyValidator("s3Key", cdk.validateString)(properties.s3Key)), errors.collect(cdk.propertyValidator("s3ObjectVersion", cdk.validateString)(properties.s3ObjectVersion)), errors.collect(cdk.propertyValidator("zipFile", cdk.validateString)(properties.zipFile)), errors.wrap('supplied properties not correct for "CodeProperty"');
    }
    function cfnFunctionCodePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_CodePropertyValidator(properties).assertSuccess(), { ImageUri: cdk.stringToCloudFormation(properties.imageUri), S3Bucket: cdk.stringToCloudFormation(properties.s3Bucket), S3Key: cdk.stringToCloudFormation(properties.s3Key), S3ObjectVersion: cdk.stringToCloudFormation(properties.s3ObjectVersion), ZipFile: cdk.stringToCloudFormation(properties.zipFile) }) : properties;
    }
    function CfnFunctionCodePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("imageUri", "ImageUri", properties.ImageUri != null ? cfn_parse.FromCloudFormation.getString(properties.ImageUri) : void 0), ret.addPropertyResult("s3Bucket", "S3Bucket", properties.S3Bucket != null ? cfn_parse.FromCloudFormation.getString(properties.S3Bucket) : void 0), ret.addPropertyResult("s3Key", "S3Key", properties.S3Key != null ? cfn_parse.FromCloudFormation.getString(properties.S3Key) : void 0), ret.addPropertyResult("s3ObjectVersion", "S3ObjectVersion", properties.S3ObjectVersion != null ? cfn_parse.FromCloudFormation.getString(properties.S3ObjectVersion) : void 0), ret.addPropertyResult("zipFile", "ZipFile", properties.ZipFile != null ? cfn_parse.FromCloudFormation.getString(properties.ZipFile) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_DeadLetterConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("targetArn", cdk.validateString)(properties.targetArn)), errors.wrap('supplied properties not correct for "DeadLetterConfigProperty"');
    }
    function cfnFunctionDeadLetterConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_DeadLetterConfigPropertyValidator(properties).assertSuccess(), { TargetArn: cdk.stringToCloudFormation(properties.targetArn) }) : properties;
    }
    function CfnFunctionDeadLetterConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("targetArn", "TargetArn", properties.TargetArn != null ? cfn_parse.FromCloudFormation.getString(properties.TargetArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_EnvironmentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("variables", cdk.hashValidator(cdk.validateString))(properties.variables)), errors.wrap('supplied properties not correct for "EnvironmentProperty"');
    }
    function cfnFunctionEnvironmentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_EnvironmentPropertyValidator(properties).assertSuccess(), { Variables: cdk.hashMapper(cdk.stringToCloudFormation)(properties.variables) }) : properties;
    }
    function CfnFunctionEnvironmentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("variables", "Variables", properties.Variables != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Variables) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_EphemeralStoragePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("size", cdk.requiredValidator)(properties.size)), errors.collect(cdk.propertyValidator("size", cdk.validateNumber)(properties.size)), errors.wrap('supplied properties not correct for "EphemeralStorageProperty"');
    }
    function cfnFunctionEphemeralStoragePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_EphemeralStoragePropertyValidator(properties).assertSuccess(), { Size: cdk.numberToCloudFormation(properties.size) }) : properties;
    }
    function CfnFunctionEphemeralStoragePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("size", "Size", cfn_parse.FromCloudFormation.getNumber(properties.Size)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_FileSystemConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.requiredValidator)(properties.arn)), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("localMountPath", cdk.requiredValidator)(properties.localMountPath)), errors.collect(cdk.propertyValidator("localMountPath", cdk.validateString)(properties.localMountPath)), errors.wrap('supplied properties not correct for "FileSystemConfigProperty"');
    }
    function cfnFunctionFileSystemConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_FileSystemConfigPropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn), LocalMountPath: cdk.stringToCloudFormation(properties.localMountPath) }) : properties;
    }
    function CfnFunctionFileSystemConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", cfn_parse.FromCloudFormation.getString(properties.Arn)), ret.addPropertyResult("localMountPath", "LocalMountPath", cfn_parse.FromCloudFormation.getString(properties.LocalMountPath)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_ImageConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("command", cdk.listValidator(cdk.validateString))(properties.command)), errors.collect(cdk.propertyValidator("entryPoint", cdk.listValidator(cdk.validateString))(properties.entryPoint)), errors.collect(cdk.propertyValidator("workingDirectory", cdk.validateString)(properties.workingDirectory)), errors.wrap('supplied properties not correct for "ImageConfigProperty"');
    }
    function cfnFunctionImageConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_ImageConfigPropertyValidator(properties).assertSuccess(), { Command: cdk.listMapper(cdk.stringToCloudFormation)(properties.command), EntryPoint: cdk.listMapper(cdk.stringToCloudFormation)(properties.entryPoint), WorkingDirectory: cdk.stringToCloudFormation(properties.workingDirectory) }) : properties;
    }
    function CfnFunctionImageConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("command", "Command", properties.Command != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Command) : void 0), ret.addPropertyResult("entryPoint", "EntryPoint", properties.EntryPoint != null ? cfn_parse.FromCloudFormation.getStringArray(properties.EntryPoint) : void 0), ret.addPropertyResult("workingDirectory", "WorkingDirectory", properties.WorkingDirectory != null ? cfn_parse.FromCloudFormation.getString(properties.WorkingDirectory) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_RuntimeManagementConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("runtimeVersionArn", cdk.validateString)(properties.runtimeVersionArn)), errors.collect(cdk.propertyValidator("updateRuntimeOn", cdk.requiredValidator)(properties.updateRuntimeOn)), errors.collect(cdk.propertyValidator("updateRuntimeOn", cdk.validateString)(properties.updateRuntimeOn)), errors.wrap('supplied properties not correct for "RuntimeManagementConfigProperty"');
    }
    function cfnFunctionRuntimeManagementConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_RuntimeManagementConfigPropertyValidator(properties).assertSuccess(), { RuntimeVersionArn: cdk.stringToCloudFormation(properties.runtimeVersionArn), UpdateRuntimeOn: cdk.stringToCloudFormation(properties.updateRuntimeOn) }) : properties;
    }
    function CfnFunctionRuntimeManagementConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("runtimeVersionArn", "RuntimeVersionArn", properties.RuntimeVersionArn != null ? cfn_parse.FromCloudFormation.getString(properties.RuntimeVersionArn) : void 0), ret.addPropertyResult("updateRuntimeOn", "UpdateRuntimeOn", cfn_parse.FromCloudFormation.getString(properties.UpdateRuntimeOn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_SnapStartPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applyOn", cdk.requiredValidator)(properties.applyOn)), errors.collect(cdk.propertyValidator("applyOn", cdk.validateString)(properties.applyOn)), errors.wrap('supplied properties not correct for "SnapStartProperty"');
    }
    function cfnFunctionSnapStartPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_SnapStartPropertyValidator(properties).assertSuccess(), { ApplyOn: cdk.stringToCloudFormation(properties.applyOn) }) : properties;
    }
    function CfnFunctionSnapStartPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applyOn", "ApplyOn", cfn_parse.FromCloudFormation.getString(properties.ApplyOn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_TracingConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mode", cdk.validateString)(properties.mode)), errors.wrap('supplied properties not correct for "TracingConfigProperty"');
    }
    function cfnFunctionTracingConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_TracingConfigPropertyValidator(properties).assertSuccess(), { Mode: cdk.stringToCloudFormation(properties.mode) }) : properties;
    }
    function CfnFunctionTracingConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mode", "Mode", properties.Mode != null ? cfn_parse.FromCloudFormation.getString(properties.Mode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_VpcConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.wrap('supplied properties not correct for "VpcConfigProperty"');
    }
    function cfnFunctionVpcConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_VpcConfigPropertyValidator(properties).assertSuccess(), { SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds) }) : properties;
    }
    function CfnFunctionVpcConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("subnetIds", "SubnetIds", properties.SubnetIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLayerVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("compatibleArchitectures", cdk.listValidator(cdk.validateString))(properties.compatibleArchitectures)), errors.collect(cdk.propertyValidator("compatibleRuntimes", cdk.listValidator(cdk.validateString))(properties.compatibleRuntimes)), errors.collect(cdk.propertyValidator("content", cdk.requiredValidator)(properties.content)), errors.collect(cdk.propertyValidator("content", CfnLayerVersion_ContentPropertyValidator)(properties.content)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("layerName", cdk.validateString)(properties.layerName)), errors.collect(cdk.propertyValidator("licenseInfo", cdk.validateString)(properties.licenseInfo)), errors.wrap('supplied properties not correct for "CfnLayerVersionProps"');
    }
    function cfnLayerVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLayerVersionPropsValidator(properties).assertSuccess(), { Content: cfnLayerVersionContentPropertyToCloudFormation(properties.content), CompatibleArchitectures: cdk.listMapper(cdk.stringToCloudFormation)(properties.compatibleArchitectures), CompatibleRuntimes: cdk.listMapper(cdk.stringToCloudFormation)(properties.compatibleRuntimes), Description: cdk.stringToCloudFormation(properties.description), LayerName: cdk.stringToCloudFormation(properties.layerName), LicenseInfo: cdk.stringToCloudFormation(properties.licenseInfo) }) : properties;
    }
    function CfnLayerVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("content", "Content", CfnLayerVersionContentPropertyFromCloudFormation(properties.Content)), ret.addPropertyResult("compatibleArchitectures", "CompatibleArchitectures", properties.CompatibleArchitectures != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CompatibleArchitectures) : void 0), ret.addPropertyResult("compatibleRuntimes", "CompatibleRuntimes", properties.CompatibleRuntimes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CompatibleRuntimes) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("layerName", "LayerName", properties.LayerName != null ? cfn_parse.FromCloudFormation.getString(properties.LayerName) : void 0), ret.addPropertyResult("licenseInfo", "LicenseInfo", properties.LicenseInfo != null ? cfn_parse.FromCloudFormation.getString(properties.LicenseInfo) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLayerVersion = class _CfnLayerVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLayerVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnLayerVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLayerVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_CfnLayerVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLayerVersion), error;
        }
        cdk.requireProperty(props, "content", this), this.content = props.content, this.compatibleArchitectures = props.compatibleArchitectures, this.compatibleRuntimes = props.compatibleRuntimes, this.description = props.description, this.layerName = props.layerName, this.licenseInfo = props.licenseInfo;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLayerVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { content: this.content, compatibleArchitectures: this.compatibleArchitectures, compatibleRuntimes: this.compatibleRuntimes, description: this.description, layerName: this.layerName, licenseInfo: this.licenseInfo };
      }
      renderProperties(props) {
        return cfnLayerVersionPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnLayerVersion[_f] = { fqn: "aws-cdk-lib.aws_lambda.CfnLayerVersion", version: "2.80.0" }, CfnLayerVersion.CFN_RESOURCE_TYPE_NAME = "AWS::Lambda::LayerVersion", exports2.CfnLayerVersion = CfnLayerVersion;
    function CfnLayerVersion_ContentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3Bucket", cdk.requiredValidator)(properties.s3Bucket)), errors.collect(cdk.propertyValidator("s3Bucket", cdk.validateString)(properties.s3Bucket)), errors.collect(cdk.propertyValidator("s3Key", cdk.requiredValidator)(properties.s3Key)), errors.collect(cdk.propertyValidator("s3Key", cdk.validateString)(properties.s3Key)), errors.collect(cdk.propertyValidator("s3ObjectVersion", cdk.validateString)(properties.s3ObjectVersion)), errors.wrap('supplied properties not correct for "ContentProperty"');
    }
    function cfnLayerVersionContentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLayerVersion_ContentPropertyValidator(properties).assertSuccess(), { S3Bucket: cdk.stringToCloudFormation(properties.s3Bucket), S3Key: cdk.stringToCloudFormation(properties.s3Key), S3ObjectVersion: cdk.stringToCloudFormation(properties.s3ObjectVersion) }) : properties;
    }
    function CfnLayerVersionContentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Bucket", "S3Bucket", cfn_parse.FromCloudFormation.getString(properties.S3Bucket)), ret.addPropertyResult("s3Key", "S3Key", cfn_parse.FromCloudFormation.getString(properties.S3Key)), ret.addPropertyResult("s3ObjectVersion", "S3ObjectVersion", properties.S3ObjectVersion != null ? cfn_parse.FromCloudFormation.getString(properties.S3ObjectVersion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLayerVersionPermissionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.requiredValidator)(properties.action)), errors.collect(cdk.propertyValidator("action", cdk.validateString)(properties.action)), errors.collect(cdk.propertyValidator("layerVersionArn", cdk.requiredValidator)(properties.layerVersionArn)), errors.collect(cdk.propertyValidator("layerVersionArn", cdk.validateString)(properties.layerVersionArn)), errors.collect(cdk.propertyValidator("organizationId", cdk.validateString)(properties.organizationId)), errors.collect(cdk.propertyValidator("principal", cdk.requiredValidator)(properties.principal)), errors.collect(cdk.propertyValidator("principal", cdk.validateString)(properties.principal)), errors.wrap('supplied properties not correct for "CfnLayerVersionPermissionProps"');
    }
    function cfnLayerVersionPermissionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLayerVersionPermissionPropsValidator(properties).assertSuccess(), { Action: cdk.stringToCloudFormation(properties.action), LayerVersionArn: cdk.stringToCloudFormation(properties.layerVersionArn), Principal: cdk.stringToCloudFormation(properties.principal), OrganizationId: cdk.stringToCloudFormation(properties.organizationId) }) : properties;
    }
    function CfnLayerVersionPermissionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", cfn_parse.FromCloudFormation.getString(properties.Action)), ret.addPropertyResult("layerVersionArn", "LayerVersionArn", cfn_parse.FromCloudFormation.getString(properties.LayerVersionArn)), ret.addPropertyResult("principal", "Principal", cfn_parse.FromCloudFormation.getString(properties.Principal)), ret.addPropertyResult("organizationId", "OrganizationId", properties.OrganizationId != null ? cfn_parse.FromCloudFormation.getString(properties.OrganizationId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLayerVersionPermission = class _CfnLayerVersionPermission extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLayerVersionPermissionPropsFromCloudFormation(resourceProperties), ret = new _CfnLayerVersionPermission(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLayerVersionPermission.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_CfnLayerVersionPermissionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLayerVersionPermission), error;
        }
        cdk.requireProperty(props, "action", this), cdk.requireProperty(props, "layerVersionArn", this), cdk.requireProperty(props, "principal", this), this.action = props.action, this.layerVersionArn = props.layerVersionArn, this.principal = props.principal, this.organizationId = props.organizationId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLayerVersionPermission.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { action: this.action, layerVersionArn: this.layerVersionArn, principal: this.principal, organizationId: this.organizationId };
      }
      renderProperties(props) {
        return cfnLayerVersionPermissionPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnLayerVersionPermission[_g] = { fqn: "aws-cdk-lib.aws_lambda.CfnLayerVersionPermission", version: "2.80.0" }, CfnLayerVersionPermission.CFN_RESOURCE_TYPE_NAME = "AWS::Lambda::LayerVersionPermission", exports2.CfnLayerVersionPermission = CfnLayerVersionPermission;
    function CfnPermissionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.requiredValidator)(properties.action)), errors.collect(cdk.propertyValidator("action", cdk.validateString)(properties.action)), errors.collect(cdk.propertyValidator("eventSourceToken", cdk.validateString)(properties.eventSourceToken)), errors.collect(cdk.propertyValidator("functionName", cdk.requiredValidator)(properties.functionName)), errors.collect(cdk.propertyValidator("functionName", cdk.validateString)(properties.functionName)), errors.collect(cdk.propertyValidator("functionUrlAuthType", cdk.validateString)(properties.functionUrlAuthType)), errors.collect(cdk.propertyValidator("principal", cdk.requiredValidator)(properties.principal)), errors.collect(cdk.propertyValidator("principal", cdk.validateString)(properties.principal)), errors.collect(cdk.propertyValidator("principalOrgId", cdk.validateString)(properties.principalOrgId)), errors.collect(cdk.propertyValidator("sourceAccount", cdk.validateString)(properties.sourceAccount)), errors.collect(cdk.propertyValidator("sourceArn", cdk.validateString)(properties.sourceArn)), errors.wrap('supplied properties not correct for "CfnPermissionProps"');
    }
    function cfnPermissionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPermissionPropsValidator(properties).assertSuccess(), { Action: cdk.stringToCloudFormation(properties.action), FunctionName: cdk.stringToCloudFormation(properties.functionName), Principal: cdk.stringToCloudFormation(properties.principal), EventSourceToken: cdk.stringToCloudFormation(properties.eventSourceToken), FunctionUrlAuthType: cdk.stringToCloudFormation(properties.functionUrlAuthType), PrincipalOrgID: cdk.stringToCloudFormation(properties.principalOrgId), SourceAccount: cdk.stringToCloudFormation(properties.sourceAccount), SourceArn: cdk.stringToCloudFormation(properties.sourceArn) }) : properties;
    }
    function CfnPermissionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", cfn_parse.FromCloudFormation.getString(properties.Action)), ret.addPropertyResult("functionName", "FunctionName", cfn_parse.FromCloudFormation.getString(properties.FunctionName)), ret.addPropertyResult("principal", "Principal", cfn_parse.FromCloudFormation.getString(properties.Principal)), ret.addPropertyResult("eventSourceToken", "EventSourceToken", properties.EventSourceToken != null ? cfn_parse.FromCloudFormation.getString(properties.EventSourceToken) : void 0), ret.addPropertyResult("functionUrlAuthType", "FunctionUrlAuthType", properties.FunctionUrlAuthType != null ? cfn_parse.FromCloudFormation.getString(properties.FunctionUrlAuthType) : void 0), ret.addPropertyResult("principalOrgId", "PrincipalOrgID", properties.PrincipalOrgID != null ? cfn_parse.FromCloudFormation.getString(properties.PrincipalOrgID) : void 0), ret.addPropertyResult("sourceAccount", "SourceAccount", properties.SourceAccount != null ? cfn_parse.FromCloudFormation.getString(properties.SourceAccount) : void 0), ret.addPropertyResult("sourceArn", "SourceArn", properties.SourceArn != null ? cfn_parse.FromCloudFormation.getString(properties.SourceArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPermission = class _CfnPermission extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPermissionPropsFromCloudFormation(resourceProperties), ret = new _CfnPermission(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPermission.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_CfnPermissionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPermission), error;
        }
        cdk.requireProperty(props, "action", this), cdk.requireProperty(props, "functionName", this), cdk.requireProperty(props, "principal", this), this.action = props.action, this.functionName = props.functionName, this.principal = props.principal, this.eventSourceToken = props.eventSourceToken, this.functionUrlAuthType = props.functionUrlAuthType, this.principalOrgId = props.principalOrgId, this.sourceAccount = props.sourceAccount, this.sourceArn = props.sourceArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPermission.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { action: this.action, functionName: this.functionName, principal: this.principal, eventSourceToken: this.eventSourceToken, functionUrlAuthType: this.functionUrlAuthType, principalOrgId: this.principalOrgId, sourceAccount: this.sourceAccount, sourceArn: this.sourceArn };
      }
      renderProperties(props) {
        return cfnPermissionPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnPermission[_h] = { fqn: "aws-cdk-lib.aws_lambda.CfnPermission", version: "2.80.0" }, CfnPermission.CFN_RESOURCE_TYPE_NAME = "AWS::Lambda::Permission", exports2.CfnPermission = CfnPermission;
    function CfnUrlPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authType", cdk.requiredValidator)(properties.authType)), errors.collect(cdk.propertyValidator("authType", cdk.validateString)(properties.authType)), errors.collect(cdk.propertyValidator("cors", CfnUrl_CorsPropertyValidator)(properties.cors)), errors.collect(cdk.propertyValidator("invokeMode", cdk.validateString)(properties.invokeMode)), errors.collect(cdk.propertyValidator("qualifier", cdk.validateString)(properties.qualifier)), errors.collect(cdk.propertyValidator("targetFunctionArn", cdk.requiredValidator)(properties.targetFunctionArn)), errors.collect(cdk.propertyValidator("targetFunctionArn", cdk.validateString)(properties.targetFunctionArn)), errors.wrap('supplied properties not correct for "CfnUrlProps"');
    }
    function cfnUrlPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUrlPropsValidator(properties).assertSuccess(), { AuthType: cdk.stringToCloudFormation(properties.authType), TargetFunctionArn: cdk.stringToCloudFormation(properties.targetFunctionArn), Cors: cfnUrlCorsPropertyToCloudFormation(properties.cors), InvokeMode: cdk.stringToCloudFormation(properties.invokeMode), Qualifier: cdk.stringToCloudFormation(properties.qualifier) }) : properties;
    }
    function CfnUrlPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authType", "AuthType", cfn_parse.FromCloudFormation.getString(properties.AuthType)), ret.addPropertyResult("targetFunctionArn", "TargetFunctionArn", cfn_parse.FromCloudFormation.getString(properties.TargetFunctionArn)), ret.addPropertyResult("cors", "Cors", properties.Cors != null ? CfnUrlCorsPropertyFromCloudFormation(properties.Cors) : void 0), ret.addPropertyResult("invokeMode", "InvokeMode", properties.InvokeMode != null ? cfn_parse.FromCloudFormation.getString(properties.InvokeMode) : void 0), ret.addPropertyResult("qualifier", "Qualifier", properties.Qualifier != null ? cfn_parse.FromCloudFormation.getString(properties.Qualifier) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnUrl = class _CfnUrl extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnUrlPropsFromCloudFormation(resourceProperties), ret = new _CfnUrl(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnUrl.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_CfnUrlProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnUrl), error;
        }
        cdk.requireProperty(props, "authType", this), cdk.requireProperty(props, "targetFunctionArn", this), this.attrFunctionArn = cdk.Token.asString(this.getAtt("FunctionArn", cdk.ResolutionTypeHint.STRING)), this.attrFunctionUrl = cdk.Token.asString(this.getAtt("FunctionUrl", cdk.ResolutionTypeHint.STRING)), this.authType = props.authType, this.targetFunctionArn = props.targetFunctionArn, this.cors = props.cors, this.invokeMode = props.invokeMode, this.qualifier = props.qualifier;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnUrl.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { authType: this.authType, targetFunctionArn: this.targetFunctionArn, cors: this.cors, invokeMode: this.invokeMode, qualifier: this.qualifier };
      }
      renderProperties(props) {
        return cfnUrlPropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnUrl[_j] = { fqn: "aws-cdk-lib.aws_lambda.CfnUrl", version: "2.80.0" }, CfnUrl.CFN_RESOURCE_TYPE_NAME = "AWS::Lambda::Url", exports2.CfnUrl = CfnUrl;
    function CfnUrl_CorsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowCredentials", cdk.validateBoolean)(properties.allowCredentials)), errors.collect(cdk.propertyValidator("allowHeaders", cdk.listValidator(cdk.validateString))(properties.allowHeaders)), errors.collect(cdk.propertyValidator("allowMethods", cdk.listValidator(cdk.validateString))(properties.allowMethods)), errors.collect(cdk.propertyValidator("allowOrigins", cdk.listValidator(cdk.validateString))(properties.allowOrigins)), errors.collect(cdk.propertyValidator("exposeHeaders", cdk.listValidator(cdk.validateString))(properties.exposeHeaders)), errors.collect(cdk.propertyValidator("maxAge", cdk.validateNumber)(properties.maxAge)), errors.wrap('supplied properties not correct for "CorsProperty"');
    }
    function cfnUrlCorsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUrl_CorsPropertyValidator(properties).assertSuccess(), { AllowCredentials: cdk.booleanToCloudFormation(properties.allowCredentials), AllowHeaders: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowHeaders), AllowMethods: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowMethods), AllowOrigins: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowOrigins), ExposeHeaders: cdk.listMapper(cdk.stringToCloudFormation)(properties.exposeHeaders), MaxAge: cdk.numberToCloudFormation(properties.maxAge) }) : properties;
    }
    function CfnUrlCorsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowCredentials", "AllowCredentials", properties.AllowCredentials != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllowCredentials) : void 0), ret.addPropertyResult("allowHeaders", "AllowHeaders", properties.AllowHeaders != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AllowHeaders) : void 0), ret.addPropertyResult("allowMethods", "AllowMethods", properties.AllowMethods != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AllowMethods) : void 0), ret.addPropertyResult("allowOrigins", "AllowOrigins", properties.AllowOrigins != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AllowOrigins) : void 0), ret.addPropertyResult("exposeHeaders", "ExposeHeaders", properties.ExposeHeaders != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExposeHeaders) : void 0), ret.addPropertyResult("maxAge", "MaxAge", properties.MaxAge != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxAge) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("codeSha256", cdk.validateString)(properties.codeSha256)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("functionName", cdk.requiredValidator)(properties.functionName)), errors.collect(cdk.propertyValidator("functionName", cdk.validateString)(properties.functionName)), errors.collect(cdk.propertyValidator("provisionedConcurrencyConfig", CfnVersion_ProvisionedConcurrencyConfigurationPropertyValidator)(properties.provisionedConcurrencyConfig)), errors.wrap('supplied properties not correct for "CfnVersionProps"');
    }
    function cfnVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVersionPropsValidator(properties).assertSuccess(), { FunctionName: cdk.stringToCloudFormation(properties.functionName), CodeSha256: cdk.stringToCloudFormation(properties.codeSha256), Description: cdk.stringToCloudFormation(properties.description), ProvisionedConcurrencyConfig: cfnVersionProvisionedConcurrencyConfigurationPropertyToCloudFormation(properties.provisionedConcurrencyConfig) }) : properties;
    }
    function CfnVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("functionName", "FunctionName", cfn_parse.FromCloudFormation.getString(properties.FunctionName)), ret.addPropertyResult("codeSha256", "CodeSha256", properties.CodeSha256 != null ? cfn_parse.FromCloudFormation.getString(properties.CodeSha256) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("provisionedConcurrencyConfig", "ProvisionedConcurrencyConfig", properties.ProvisionedConcurrencyConfig != null ? CfnVersionProvisionedConcurrencyConfigurationPropertyFromCloudFormation(properties.ProvisionedConcurrencyConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVersion = class _CfnVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_CfnVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVersion), error;
        }
        cdk.requireProperty(props, "functionName", this), this.attrVersion = cdk.Token.asString(this.getAtt("Version", cdk.ResolutionTypeHint.STRING)), this.functionName = props.functionName, this.codeSha256 = props.codeSha256, this.description = props.description, this.provisionedConcurrencyConfig = props.provisionedConcurrencyConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { functionName: this.functionName, codeSha256: this.codeSha256, description: this.description, provisionedConcurrencyConfig: this.provisionedConcurrencyConfig };
      }
      renderProperties(props) {
        return cfnVersionPropsToCloudFormation(props);
      }
    };
    _k = JSII_RTTI_SYMBOL_1, CfnVersion[_k] = { fqn: "aws-cdk-lib.aws_lambda.CfnVersion", version: "2.80.0" }, CfnVersion.CFN_RESOURCE_TYPE_NAME = "AWS::Lambda::Version", exports2.CfnVersion = CfnVersion;
    function CfnVersion_ProvisionedConcurrencyConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("provisionedConcurrentExecutions", cdk.requiredValidator)(properties.provisionedConcurrentExecutions)), errors.collect(cdk.propertyValidator("provisionedConcurrentExecutions", cdk.validateNumber)(properties.provisionedConcurrentExecutions)), errors.wrap('supplied properties not correct for "ProvisionedConcurrencyConfigurationProperty"');
    }
    function cfnVersionProvisionedConcurrencyConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVersion_ProvisionedConcurrencyConfigurationPropertyValidator(properties).assertSuccess(), { ProvisionedConcurrentExecutions: cdk.numberToCloudFormation(properties.provisionedConcurrentExecutions) }) : properties;
    }
    function CfnVersionProvisionedConcurrencyConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("provisionedConcurrentExecutions", "ProvisionedConcurrentExecutions", cfn_parse.FromCloudFormation.getNumber(properties.ProvisionedConcurrentExecutions)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/event-invoke-config.js
var require_event_invoke_config = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/event-invoke-config.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EventInvokeConfig = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var destination_1 = require_destination();
    var lambda_generated_1 = require_lambda_generated();
    var core_1 = require_core2();
    var EventInvokeConfig = class _EventInvokeConfig extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_EventInvokeConfigProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EventInvokeConfig), error;
        }
        if (props.maxEventAge && (props.maxEventAge.toSeconds() < 60 || props.maxEventAge.toSeconds() > 21600))
          throw new Error("`maximumEventAge` must represent a `Duration` that is between 60 and 21600 seconds.");
        if (props.retryAttempts && (props.retryAttempts < 0 || props.retryAttempts > 2))
          throw new Error("`retryAttempts` must be between 0 and 2.");
        new lambda_generated_1.CfnEventInvokeConfig(this, "Resource", { destinationConfig: props.onFailure || props.onSuccess ? { ...props.onFailure ? { onFailure: props.onFailure.bind(this, props.function, { type: destination_1.DestinationType.FAILURE }) } : {}, ...props.onSuccess ? { onSuccess: props.onSuccess.bind(this, props.function, { type: destination_1.DestinationType.SUCCESS }) } : {} } : void 0, functionName: props.function.functionName, maximumEventAgeInSeconds: props.maxEventAge && props.maxEventAge.toSeconds(), maximumRetryAttempts: props.retryAttempts ?? void 0, qualifier: props.qualifier || "$LATEST" });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EventInvokeConfig[_a] = { fqn: "aws-cdk-lib.aws_lambda.EventInvokeConfig", version: "2.80.0" }, exports2.EventInvokeConfig = EventInvokeConfig;
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/event-source-mapping.js
var require_event_source_mapping = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/event-source-mapping.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.StartingPosition = exports2.EventSourceMapping = exports2.SourceAccessConfigurationType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var lambda_generated_1 = require_lambda_generated();
    var cdk = require_core2();
    var SourceAccessConfigurationType = class _SourceAccessConfigurationType {
      static of(name) {
        return new _SourceAccessConfigurationType(name);
      }
      constructor(type) {
        this.type = type;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SourceAccessConfigurationType[_a] = { fqn: "aws-cdk-lib.aws_lambda.SourceAccessConfigurationType", version: "2.80.0" }, SourceAccessConfigurationType.BASIC_AUTH = new SourceAccessConfigurationType("BASIC_AUTH"), SourceAccessConfigurationType.VPC_SUBNET = new SourceAccessConfigurationType("VPC_SUBNET"), SourceAccessConfigurationType.VPC_SECURITY_GROUP = new SourceAccessConfigurationType("VPC_SECURITY_GROUP"), SourceAccessConfigurationType.SASL_SCRAM_256_AUTH = new SourceAccessConfigurationType("SASL_SCRAM_256_AUTH"), SourceAccessConfigurationType.SASL_SCRAM_512_AUTH = new SourceAccessConfigurationType("SASL_SCRAM_512_AUTH"), SourceAccessConfigurationType.CLIENT_CERTIFICATE_TLS_AUTH = new SourceAccessConfigurationType("CLIENT_CERTIFICATE_TLS_AUTH"), SourceAccessConfigurationType.SERVER_ROOT_CA_CERTIFICATE = new SourceAccessConfigurationType("SERVER_ROOT_CA_CERTIFICATE"), exports2.SourceAccessConfigurationType = SourceAccessConfigurationType;
    var EventSourceMapping = class _EventSourceMapping extends cdk.Resource {
      static fromEventSourceMappingId(scope, id, eventSourceMappingId) {
        const eventSourceMappingArn = _EventSourceMapping.formatArn(scope, eventSourceMappingId);
        class Import extends cdk.Resource {
          constructor() {
            super(...arguments), this.eventSourceMappingId = eventSourceMappingId, this.eventSourceMappingArn = eventSourceMappingArn;
          }
        }
        return new Import(scope, id);
      }
      static formatArn(scope, eventSourceMappingId) {
        return cdk.Stack.of(scope).formatArn({ service: "lambda", resource: "event-source-mapping", resourceName: eventSourceMappingId, arnFormat: cdk.ArnFormat.COLON_RESOURCE_NAME });
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_EventSourceMappingProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EventSourceMapping), error;
        }
        if (props.eventSourceArn == null && props.kafkaBootstrapServers == null)
          throw new Error("Either eventSourceArn or kafkaBootstrapServers must be set");
        if (props.eventSourceArn !== void 0 && props.kafkaBootstrapServers !== void 0)
          throw new Error("eventSourceArn and kafkaBootstrapServers are mutually exclusive");
        if (props.kafkaBootstrapServers && props.kafkaBootstrapServers?.length < 1)
          throw new Error("kafkaBootStrapServers must not be empty if set");
        if (props.maxBatchingWindow && props.maxBatchingWindow.toSeconds() > 300)
          throw new Error(`maxBatchingWindow cannot be over 300 seconds, got ${props.maxBatchingWindow.toSeconds()}`);
        if (props.maxConcurrency && (props.maxConcurrency < 2 || props.maxConcurrency > 1e3))
          throw new Error("maxConcurrency must be between 2 and 1000 concurrent instances");
        if (props.maxRecordAge && (props.maxRecordAge.toSeconds() < 60 || props.maxRecordAge.toDays({ integral: false }) > 7))
          throw new Error("maxRecordAge must be between 60 seconds and 7 days inclusive");
        if (props.retryAttempts !== void 0 && cdk.withResolved(props.retryAttempts, (attempts) => {
          if (attempts < 0 || attempts > 1e4)
            throw new Error(`retryAttempts must be between 0 and 10000 inclusive, got ${attempts}`);
        }), props.parallelizationFactor !== void 0 && cdk.withResolved(props.parallelizationFactor, (factor) => {
          if (factor < 1 || factor > 10)
            throw new Error(`parallelizationFactor must be between 1 and 10 inclusive, got ${factor}`);
        }), props.tumblingWindow && !cdk.Token.isUnresolved(props.tumblingWindow) && props.tumblingWindow.toSeconds() > 900)
          throw new Error(`tumblingWindow cannot be over 900 seconds, got ${props.tumblingWindow.toSeconds()}`);
        if (props.startingPosition === StartingPosition.AT_TIMESTAMP && !props.startingPositionTimestamp)
          throw new Error("startingPositionTimestamp must be provided when startingPosition is AT_TIMESTAMP");
        if (props.startingPosition !== StartingPosition.AT_TIMESTAMP && props.startingPositionTimestamp)
          throw new Error("startingPositionTimestamp can only be used when startingPosition is AT_TIMESTAMP");
        props.kafkaConsumerGroupId && this.validateKafkaConsumerGroupIdOrThrow(props.kafkaConsumerGroupId);
        let destinationConfig;
        props.onFailure && (destinationConfig = { onFailure: props.onFailure.bind(this, props.target) });
        let selfManagedEventSource;
        props.kafkaBootstrapServers && (selfManagedEventSource = { endpoints: { kafkaBootstrapServers: props.kafkaBootstrapServers } });
        let consumerGroupConfig = props.kafkaConsumerGroupId ? { consumerGroupId: props.kafkaConsumerGroupId } : void 0;
        const cfnEventSourceMapping = new lambda_generated_1.CfnEventSourceMapping(this, "Resource", { batchSize: props.batchSize, bisectBatchOnFunctionError: props.bisectBatchOnError, destinationConfig, enabled: props.enabled, eventSourceArn: props.eventSourceArn, functionName: props.target.functionName, startingPosition: props.startingPosition, startingPositionTimestamp: props.startingPositionTimestamp, functionResponseTypes: props.reportBatchItemFailures ? ["ReportBatchItemFailures"] : void 0, maximumBatchingWindowInSeconds: props.maxBatchingWindow?.toSeconds(), maximumRecordAgeInSeconds: props.maxRecordAge?.toSeconds(), maximumRetryAttempts: props.retryAttempts, parallelizationFactor: props.parallelizationFactor, topics: props.kafkaTopic !== void 0 ? [props.kafkaTopic] : void 0, tumblingWindowInSeconds: props.tumblingWindow?.toSeconds(), scalingConfig: props.maxConcurrency ? { maximumConcurrency: props.maxConcurrency } : void 0, sourceAccessConfigurations: props.sourceAccessConfigurations?.map((o) => ({ type: o.type.type, uri: o.uri })), selfManagedEventSource, filterCriteria: props.filters ? { filters: props.filters } : void 0, selfManagedKafkaEventSourceConfig: props.kafkaBootstrapServers ? consumerGroupConfig : void 0, amazonManagedKafkaEventSourceConfig: props.eventSourceArn ? consumerGroupConfig : void 0 });
        this.eventSourceMappingId = cfnEventSourceMapping.ref, this.eventSourceMappingArn = _EventSourceMapping.formatArn(this, this.eventSourceMappingId);
      }
      validateKafkaConsumerGroupIdOrThrow(kafkaConsumerGroupId) {
        if (cdk.Token.isUnresolved(kafkaConsumerGroupId))
          return;
        if (kafkaConsumerGroupId.length > 200 || kafkaConsumerGroupId.length < 1)
          throw new Error("kafkaConsumerGroupId must be a valid string between 1 and 200 characters");
        const patternMatch = new RegExp(/[a-zA-Z0-9-\/*:_+=.@-]*/).exec(kafkaConsumerGroupId);
        if (patternMatch === null || patternMatch[0] !== kafkaConsumerGroupId)
          throw new Error('kafkaConsumerGroupId contains invalid characters. Allowed values are "[a-zA-Z0-9-/*:_+=.@-]"');
      }
    };
    _b = JSII_RTTI_SYMBOL_1, EventSourceMapping[_b] = { fqn: "aws-cdk-lib.aws_lambda.EventSourceMapping", version: "2.80.0" }, exports2.EventSourceMapping = EventSourceMapping;
    var StartingPosition;
    (function(StartingPosition2) {
      StartingPosition2.TRIM_HORIZON = "TRIM_HORIZON", StartingPosition2.LATEST = "LATEST", StartingPosition2.AT_TIMESTAMP = "AT_TIMESTAMP";
    })(StartingPosition = exports2.StartingPosition || (exports2.StartingPosition = {}));
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/function-url.js
var require_function_url = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/function-url.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FunctionUrl = exports2.HttpMethod = exports2.FunctionUrlAuthType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var lambda_generated_1 = require_lambda_generated();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var FunctionUrlAuthType;
    (function(FunctionUrlAuthType2) {
      FunctionUrlAuthType2.AWS_IAM = "AWS_IAM", FunctionUrlAuthType2.NONE = "NONE";
    })(FunctionUrlAuthType = exports2.FunctionUrlAuthType || (exports2.FunctionUrlAuthType = {}));
    var HttpMethod;
    (function(HttpMethod2) {
      HttpMethod2.GET = "GET", HttpMethod2.PUT = "PUT", HttpMethod2.HEAD = "HEAD", HttpMethod2.POST = "POST", HttpMethod2.DELETE = "DELETE", HttpMethod2.PATCH = "PATCH", HttpMethod2.OPTIONS = "OPTIONS", HttpMethod2.ALL = "*";
    })(HttpMethod = exports2.HttpMethod || (exports2.HttpMethod = {}));
    var FunctionUrl = class _FunctionUrl extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_FunctionUrlProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _FunctionUrl), error;
        }
        if (this.instanceOfVersion(props.function))
          throw new Error("FunctionUrl cannot be used with a Version");
        const { targetFunction, alias } = this.instanceOfAlias(props.function) ? { targetFunction: props.function.version.lambda, alias: props.function } : { targetFunction: props.function, alias: void 0 }, resource = new lambda_generated_1.CfnUrl(this, "Resource", { authType: props.authType ?? FunctionUrlAuthType.AWS_IAM, cors: props.cors ? this.renderCors(props.cors) : void 0, targetFunctionArn: targetFunction.functionArn, qualifier: alias?.aliasName });
        alias?.node.defaultChild != null && resource.node.addDependency(alias.node.defaultChild), this.url = resource.attrFunctionUrl, this.functionArn = resource.attrFunctionArn, this.function = props.function, props.authType === FunctionUrlAuthType.NONE && props.function.addPermission("invoke-function-url", { principal: new iam.AnyPrincipal(), action: "lambda:InvokeFunctionUrl", functionUrlAuthType: props.authType });
      }
      grantInvokeUrl(grantee) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(grantee);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantInvokeUrl), error;
        }
        return this.function.grantInvokeUrl(grantee);
      }
      instanceOfVersion(fn) {
        return "version" in fn && !this.instanceOfAlias(fn);
      }
      instanceOfAlias(fn) {
        return "aliasName" in fn;
      }
      renderCors(cors) {
        return { allowCredentials: cors.allowCredentials, allowHeaders: cors.allowedHeaders, allowMethods: cors.allowedMethods ?? [HttpMethod.ALL], allowOrigins: cors.allowedOrigins, exposeHeaders: cors.exposedHeaders, maxAge: cors.maxAge?.toSeconds() };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, FunctionUrl[_a] = { fqn: "aws-cdk-lib.aws_lambda.FunctionUrl", version: "2.80.0" }, exports2.FunctionUrl = FunctionUrl;
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/util.js
var require_util5 = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/util.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.flatten = exports2.flatMap = exports2.addAlias = void 0;
    var alias_1 = require_alias2();
    function addAlias(scope, version, aliasName, options = {}) {
      return new alias_1.Alias(scope, `Alias${aliasName}`, { aliasName, version, ...options });
    }
    exports2.addAlias = addAlias;
    function flatMap(xs, fn) {
      return flatten(xs.map(fn));
    }
    exports2.flatMap = flatMap;
    function flatten(xs) {
      return Array.prototype.concat.apply([], xs);
    }
    exports2.flatten = flatten;
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/function-base.js
var require_function_base = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/function-base.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.QualifiedFunctionBase = exports2.FunctionBase = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var crypto_1 = require("crypto");
    var event_invoke_config_1 = require_event_invoke_config();
    var event_source_mapping_1 = require_event_source_mapping();
    var function_url_1 = require_function_url();
    var lambda_generated_1 = require_lambda_generated();
    var util_1 = require_util5();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var FunctionBase = class extends core_1.Resource {
      constructor() {
        super(...arguments), this._warnIfCurrentVersionCalled = false, this._invocationGrants = {}, this._functionUrlInvocationGrants = {};
      }
      considerWarningOnInvokeFunctionPermissions(scope, action) {
        ["lambda:InvokeFunction", "lambda:*", "lambda:Invoke*"].includes(action) && (scope.node.tryFindChild("CurrentVersion") ? this.warnInvokeFunctionPermissions(scope) : this._warnIfCurrentVersionCalled = true);
      }
      warnInvokeFunctionPermissions(scope) {
        core_1.Annotations.of(scope).addWarning(["AWS Lambda has changed their authorization strategy, which may cause client invocations using the 'Qualifier' parameter of the lambda function to fail with Access Denied errors.", "If you are using a lambda Version or Alias, make sure to call 'grantInvoke' or 'addPermission' on the Version or Alias, not the underlying Function", "See: https://github.com/aws/aws-cdk/issues/19273"].join(`
`));
      }
      addPermission(id, permission) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_Permission(permission);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addPermission), error;
        }
        if (!this.canCreatePermissions)
          return;
        let principal = this.parsePermissionPrincipal(permission.principal), { sourceArn, sourceAccount, principalOrgID } = this.validateConditionCombinations(permission.principal) ?? {};
        const action = permission.action ?? "lambda:InvokeFunction", scope = permission.scope ?? this;
        this.considerWarningOnInvokeFunctionPermissions(scope, action), new lambda_generated_1.CfnPermission(scope, id, { action, principal, functionName: this.functionArn, eventSourceToken: permission.eventSourceToken, sourceAccount: permission.sourceAccount ?? sourceAccount, sourceArn: permission.sourceArn ?? sourceArn, principalOrgId: permission.organizationId ?? principalOrgID, functionUrlAuthType: permission.functionUrlAuthType });
      }
      addToRolePolicy(statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToRolePolicy), error;
        }
        this.role && this.role.addToPrincipalPolicy(statement);
      }
      get connections() {
        if (!this._connections)
          throw new Error('Only VPC-associated Lambda Functions have security groups to manage. Supply the "vpc" parameter when creating the Lambda, or "securityGroupId" when importing it.');
        return this._connections;
      }
      get latestVersion() {
        return this._latestVersion || (this._latestVersion = new LatestVersion(this)), this._latestVersion;
      }
      get isBoundToVpc() {
        return !!this._connections;
      }
      addEventSourceMapping(id, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_EventSourceMappingOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addEventSourceMapping), error;
        }
        return new event_source_mapping_1.EventSourceMapping(this, id, { target: this, ...options });
      }
      grantInvoke(grantee) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(grantee);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantInvoke), error;
        }
        const identifier = `Invoke${(0, crypto_1.createHash)("sha256").update(JSON.stringify({ principal: grantee.grantPrincipal.toString(), conditions: grantee.grantPrincipal.policyFragment.conditions }), "utf8").digest("base64")}`;
        let grant = this._invocationGrants[identifier];
        return grant || (grant = this.grant(grantee, identifier, "lambda:InvokeFunction", this.resourceArnsForGrantInvoke), this._invocationGrants[identifier] = grant), grant;
      }
      grantInvokeUrl(grantee) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(grantee);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantInvokeUrl), error;
        }
        const identifier = `InvokeFunctionUrl${grantee.grantPrincipal}`;
        let grant = this._functionUrlInvocationGrants[identifier];
        return grant || (grant = this.grant(grantee, identifier, "lambda:InvokeFunctionUrl", [this.functionArn], { functionUrlAuthType: function_url_1.FunctionUrlAuthType.AWS_IAM }), this._functionUrlInvocationGrants[identifier] = grant), grant;
      }
      addEventSource(source) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_IEventSource(source);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addEventSource), error;
        }
        source.bind(this);
      }
      configureAsyncInvoke(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_EventInvokeConfigOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.configureAsyncInvoke), error;
        }
        if (this.node.tryFindChild("EventInvokeConfig") !== void 0)
          throw new Error(`An EventInvokeConfig has already been configured for the function at ${this.node.path}`);
        new event_invoke_config_1.EventInvokeConfig(this, "EventInvokeConfig", { function: this, ...options });
      }
      addFunctionUrl(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_FunctionUrlOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addFunctionUrl), error;
        }
        return new function_url_1.FunctionUrl(this, "FunctionUrl", { function: this, ...options });
      }
      _functionNode() {
        return this.node;
      }
      _isStackAccount() {
        return core_1.Token.isUnresolved(this.stack.account) || core_1.Token.isUnresolved(this.functionArn) ? false : this.stack.splitArn(this.functionArn, core_1.ArnFormat.SLASH_RESOURCE_NAME).account === this.stack.account;
      }
      grant(grantee, identifier, action, resourceArns, permissionOverrides) {
        return iam.Grant.addToPrincipalOrResource({ grantee, actions: [action], resourceArns, resource: { addToResourcePolicy: (_statement) => {
          this.addPermission(identifier, { principal: grantee.grantPrincipal, action, ...permissionOverrides });
          const permissionNode = this._functionNode().tryFindChild(identifier);
          if (!permissionNode && !this._skipPermissions)
            throw new Error("Cannot modify permission to lambda function. Function is either imported or $LATEST version.\nIf the function is imported from the same account use `fromFunctionAttributes()` API with the `sameEnvironment` flag.\nIf the function is imported from a different account and already has the correct permissions use `fromFunctionAttributes()` API with the `skipPermissions` flag.");
          return { statementAdded: true, policyDependable: permissionNode };
        }, node: this.node, stack: this.stack, env: this.env, applyRemovalPolicy: this.applyRemovalPolicy } });
      }
      parsePermissionPrincipal(principal) {
        if ("wrapped" in principal && (principal = principal.wrapped), "accountId" in principal)
          return principal.accountId;
        if ("service" in principal)
          return principal.service;
        if ("arn" in principal)
          return principal.arn;
        const stringEquals = matchSingleKey("StringEquals", principal.policyFragment.conditions);
        if (stringEquals && matchSingleKey("aws:PrincipalOrgID", stringEquals))
          return "*";
        const json = principal.policyFragment.principalJson;
        if (Object.keys(principal.policyFragment.conditions).length === 0 && json.AWS) {
          if (typeof json.AWS == "string")
            return json.AWS;
          if (Array.isArray(json.AWS) && json.AWS.length === 1 && typeof json.AWS[0] == "string")
            return json.AWS[0];
        }
        throw new Error(`Invalid principal type for Lambda permission statement: ${principal.constructor.name}. Supported: AccountPrincipal, ArnPrincipal, ServicePrincipal, OrganizationPrincipal`);
        function matchSingleKey(key, obj) {
          if (Object.keys(obj).length === 1)
            return obj[key];
        }
      }
      validateConditionCombinations(principal) {
        const conditions = this.validateConditions(principal);
        if (!conditions)
          return;
        const sourceArn = requireString(requireObject(conditions.ArnLike)?.["aws:SourceArn"]), sourceAccount = requireString(requireObject(conditions.StringEquals)?.["aws:SourceAccount"]), principalOrgID = requireString(requireObject(conditions.StringEquals)?.["aws:PrincipalOrgID"]);
        if (principalOrgID && (sourceArn || sourceAccount))
          throw new Error("PrincipalWithConditions had unsupported condition combinations for Lambda permission statement: principalOrgID cannot be set with other conditions.");
        return { sourceArn, sourceAccount, principalOrgID };
      }
      validateConditions(principal) {
        if (this.isPrincipalWithConditions(principal)) {
          const conditions = principal.policyFragment.conditions, conditionPairs = (0, util_1.flatMap)(Object.entries(conditions), ([operator, conditionObjs]) => Object.keys(conditionObjs).map((key) => ({ operator, key }))), supportedPrincipalConditions = [{ operator: "ArnLike", key: "aws:SourceArn" }, { operator: "StringEquals", key: "aws:SourceAccount" }, { operator: "StringEquals", key: "aws:PrincipalOrgID" }], unsupportedConditions = conditionPairs.filter((condition) => !supportedPrincipalConditions.some((supportedCondition) => supportedCondition.operator === condition.operator && supportedCondition.key === condition.key));
          if (unsupportedConditions.length == 0)
            return conditions;
          throw new Error(`PrincipalWithConditions had unsupported conditions for Lambda permission statement: ${JSON.stringify(unsupportedConditions)}. Supported operator/condition pairs: ${JSON.stringify(supportedPrincipalConditions)}`);
        }
      }
      isPrincipalWithConditions(principal) {
        return Object.keys(principal.policyFragment.conditions).length > 0;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, FunctionBase[_a] = { fqn: "aws-cdk-lib.aws_lambda.FunctionBase", version: "2.80.0" }, exports2.FunctionBase = FunctionBase;
    var QualifiedFunctionBase = class extends FunctionBase {
      constructor() {
        super(...arguments), this.permissionsNode = this.node;
      }
      get latestVersion() {
        return this.lambda.latestVersion;
      }
      get resourceArnsForGrantInvoke() {
        return [this.functionArn];
      }
      configureAsyncInvoke(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_EventInvokeConfigOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.configureAsyncInvoke), error;
        }
        if (this.node.tryFindChild("EventInvokeConfig") !== void 0)
          throw new Error(`An EventInvokeConfig has already been configured for the qualified function at ${this.node.path}`);
        new event_invoke_config_1.EventInvokeConfig(this, "EventInvokeConfig", { function: this.lambda, qualifier: this.qualifier, ...options });
      }
      considerWarningOnInvokeFunctionPermissions(_scope, _action) {
      }
    };
    _b = JSII_RTTI_SYMBOL_1, QualifiedFunctionBase[_b] = { fqn: "aws-cdk-lib.aws_lambda.QualifiedFunctionBase", version: "2.80.0" }, exports2.QualifiedFunctionBase = QualifiedFunctionBase;
    var LatestVersion = class extends FunctionBase {
      constructor(lambda2) {
        super(lambda2, "$LATEST"), this.version = "$LATEST", this.permissionsNode = this.node, this.canCreatePermissions = false, this.lambda = lambda2;
      }
      get functionArn() {
        return `${this.lambda.functionArn}:${this.version}`;
      }
      get functionName() {
        return `${this.lambda.functionName}:${this.version}`;
      }
      get architecture() {
        return this.lambda.architecture;
      }
      get grantPrincipal() {
        return this.lambda.grantPrincipal;
      }
      get latestVersion() {
        return this;
      }
      get role() {
        return this.lambda.role;
      }
      get edgeArn() {
        throw new Error("$LATEST function version cannot be used for Lambda@Edge");
      }
      get resourceArnsForGrantInvoke() {
        return [this.functionArn];
      }
      addAlias(aliasName, options = {}) {
        return (0, util_1.addAlias)(this, this, aliasName, options);
      }
    };
    function requireObject(x) {
      return x && typeof x == "object" && !Array.isArray(x) ? x : void 0;
    }
    function requireString(x) {
      return x && typeof x == "string" ? x : void 0;
    }
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/architecture.js
var require_architecture = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/architecture.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Architecture = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var Architecture = class _Architecture {
      static custom(name, dockerPlatform) {
        return new _Architecture(name, dockerPlatform ?? "linux/amd64");
      }
      constructor(archName, dockerPlatform) {
        this.name = archName, this.dockerPlatform = dockerPlatform;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Architecture[_a] = { fqn: "aws-cdk-lib.aws_lambda.Architecture", version: "2.80.0" }, Architecture.X86_64 = new Architecture("x86_64", "linux/amd64"), Architecture.ARM_64 = new Architecture("arm64", "linux/arm64"), exports2.Architecture = Architecture;
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/function-hash.js
var require_function_hash = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/function-hash.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.VERSION_LOCKED = exports2.trimFromStart = exports2.calculateFunctionHash = void 0;
    var function_1 = require_function();
    var core_1 = require_core2();
    var helpers_internal_1 = require_helpers_internal();
    var cx_api_1 = require_cx_api();
    function calculateFunctionHash(fn, additional = "") {
      const stack = core_1.Stack.of(fn), functionResource = fn.node.defaultChild, config = stack.resolve(functionResource._toCloudFormation()), resources = config.Resources, resourceKeys = Object.keys(resources);
      if (resourceKeys.length !== 1)
        throw new Error(`Expected one rendered CloudFormation resource but found ${resourceKeys.length}`);
      const logicalId = resourceKeys[0], properties = resources[logicalId].Properties;
      let stringifiedConfig;
      if (core_1.FeatureFlags.of(fn).isEnabled(cx_api_1.LAMBDA_RECOGNIZE_VERSION_PROPS)) {
        const updatedProps = sortProperties(filterUsefulKeys(properties));
        stringifiedConfig = JSON.stringify(updatedProps);
      } else {
        const sorted = sortProperties(properties);
        config.Resources[logicalId].Properties = sorted, stringifiedConfig = JSON.stringify(config);
      }
      return core_1.FeatureFlags.of(fn).isEnabled(cx_api_1.LAMBDA_RECOGNIZE_LAYER_VERSION) && (stringifiedConfig = stringifiedConfig + calculateLayersHash(fn._layers)), (0, helpers_internal_1.md5hash)(stringifiedConfig + additional);
    }
    exports2.calculateFunctionHash = calculateFunctionHash;
    function trimFromStart(s, maxLength) {
      const desiredLength = Math.min(maxLength, s.length), newStart = s.length - desiredLength;
      return s.substring(newStart);
    }
    exports2.trimFromStart = trimFromStart, exports2.VERSION_LOCKED = { Architectures: true, Code: true, DeadLetterConfig: true, Description: true, Environment: true, EphemeralStorage: true, FileSystemConfigs: true, FunctionName: true, Handler: true, ImageConfig: true, KmsKeyArn: true, Layers: true, MemorySize: true, PackageType: true, Role: true, Runtime: true, RuntimeManagementConfig: true, SnapStart: true, Timeout: true, TracingConfig: true, VpcConfig: true, CodeSigningConfigArn: false, ReservedConcurrentExecutions: false, Tags: false };
    function filterUsefulKeys(properties) {
      const versionProps = { ...exports2.VERSION_LOCKED, ...function_1.Function._VER_PROPS }, unclassified = Object.entries(properties).filter(([k, v]) => v != null && !Object.keys(versionProps).includes(k)).map(([k, _]) => k);
      if (unclassified.length > 0)
        throw new Error(`The following properties are not recognized as version properties: [${unclassified}]. See the README of the aws-lambda module to learn more about this and to fix it.`);
      Object.entries(versionProps).filter(([_, v]) => !v).map(([k, _]) => k).forEach((p) => delete properties[p]);
      const ret = {};
      return Object.entries(properties).filter(([k, _]) => versionProps[k]).forEach(([k, v]) => ret[k] = v), ret;
    }
    function sortProperties(properties) {
      const ret = {}, requiredProperties = ["Code", "Handler", "Role", "Runtime"];
      for (const requiredProperty of requiredProperties)
        ret[requiredProperty] = properties[requiredProperty];
      for (const property of Object.keys(properties))
        requiredProperties.indexOf(property) === -1 && (ret[property] = properties[property]);
      return ret;
    }
    function calculateLayersHash(layers) {
      const layerConfig = {};
      for (const layer of layers) {
        const stack = core_1.Stack.of(layer), layerResource = layer.node.defaultChild;
        if (layerResource === void 0) {
          core_1.Token.isUnresolved(layer.layerVersionArn) ? layerConfig[layer.node.id] = { arn: stack.resolve(layer.layerVersionArn), runtimes: layer.compatibleRuntimes?.map((r) => r.name) } : layerConfig[layer.layerVersionArn] = layer.compatibleRuntimes;
          continue;
        }
        const resources = stack.resolve(layerResource._toCloudFormation()).Resources, resourceKeys = Object.keys(resources);
        if (resourceKeys.length !== 1)
          throw new Error(`Expected one rendered CloudFormation resource but found ${resourceKeys.length}`);
        const logicalId = resourceKeys[0], properties = resources[logicalId].Properties;
        layerConfig[layer.node.id] = properties;
      }
      return (0, helpers_internal_1.md5hash)(JSON.stringify(layerConfig));
    }
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/handler.js
var require_handler = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/handler.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Handler = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var Handler = class {
      constructor() {
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Handler[_a] = { fqn: "aws-cdk-lib.aws_lambda.Handler", version: "2.80.0" }, Handler.FROM_IMAGE = "FROM_IMAGE", exports2.Handler = Handler;
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/runtime.js
var require_runtime3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/runtime.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Runtime = exports2.RuntimeFamily = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core_1 = require_core2();
    var RuntimeFamily2;
    (function(RuntimeFamily22) {
      RuntimeFamily22[RuntimeFamily22.NODEJS = 0] = "NODEJS", RuntimeFamily22[RuntimeFamily22.JAVA = 1] = "JAVA", RuntimeFamily22[RuntimeFamily22.PYTHON = 2] = "PYTHON", RuntimeFamily22[RuntimeFamily22.DOTNET_CORE = 3] = "DOTNET_CORE", RuntimeFamily22[RuntimeFamily22.GO = 4] = "GO", RuntimeFamily22[RuntimeFamily22.RUBY = 5] = "RUBY", RuntimeFamily22[RuntimeFamily22.OTHER = 6] = "OTHER";
    })(RuntimeFamily2 = exports2.RuntimeFamily || (exports2.RuntimeFamily = {}));
    var Runtime2 = class _Runtime {
      constructor(name, family, props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_RuntimeFamily(family), jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_LambdaRuntimeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Runtime), error;
        }
        this.name = name, this.supportsInlineCode = !!props.supportsInlineCode, this.family = family;
        const imageName = props.bundlingDockerImage ?? `public.ecr.aws/sam/build-${name}`;
        this.bundlingDockerImage = core_1.DockerImage.fromRegistry(imageName), this.bundlingImage = this.bundlingDockerImage, this.supportsCodeGuruProfiling = props.supportsCodeGuruProfiling ?? false, _Runtime.ALL.push(this);
      }
      toString() {
        return this.name;
      }
      runtimeEquals(other) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_Runtime(other);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.runtimeEquals), error;
        }
        return other.name === this.name && other.family === this.family && other.supportsInlineCode === this.supportsInlineCode;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Runtime2[_a] = { fqn: "aws-cdk-lib.aws_lambda.Runtime", version: "2.80.0" }, Runtime2.ALL = new Array(), Runtime2.NODEJS = new Runtime2("nodejs", RuntimeFamily2.NODEJS, { supportsInlineCode: true }), Runtime2.NODEJS_4_3 = new Runtime2("nodejs4.3", RuntimeFamily2.NODEJS, { supportsInlineCode: true }), Runtime2.NODEJS_6_10 = new Runtime2("nodejs6.10", RuntimeFamily2.NODEJS, { supportsInlineCode: true }), Runtime2.NODEJS_8_10 = new Runtime2("nodejs8.10", RuntimeFamily2.NODEJS, { supportsInlineCode: true }), Runtime2.NODEJS_10_X = new Runtime2("nodejs10.x", RuntimeFamily2.NODEJS, { supportsInlineCode: true }), Runtime2.NODEJS_12_X = new Runtime2("nodejs12.x", RuntimeFamily2.NODEJS, { supportsInlineCode: true }), Runtime2.NODEJS_14_X = new Runtime2("nodejs14.x", RuntimeFamily2.NODEJS, { supportsInlineCode: true }), Runtime2.NODEJS_16_X = new Runtime2("nodejs16.x", RuntimeFamily2.NODEJS, { supportsInlineCode: true }), Runtime2.NODEJS_18_X = new Runtime2("nodejs18.x", RuntimeFamily2.NODEJS, { supportsInlineCode: true }), Runtime2.PYTHON_2_7 = new Runtime2("python2.7", RuntimeFamily2.PYTHON, { supportsInlineCode: true }), Runtime2.PYTHON_3_6 = new Runtime2("python3.6", RuntimeFamily2.PYTHON, { supportsInlineCode: true, supportsCodeGuruProfiling: true }), Runtime2.PYTHON_3_7 = new Runtime2("python3.7", RuntimeFamily2.PYTHON, { supportsInlineCode: true, supportsCodeGuruProfiling: true }), Runtime2.PYTHON_3_8 = new Runtime2("python3.8", RuntimeFamily2.PYTHON, { supportsInlineCode: true, supportsCodeGuruProfiling: true }), Runtime2.PYTHON_3_9 = new Runtime2("python3.9", RuntimeFamily2.PYTHON, { supportsInlineCode: true, supportsCodeGuruProfiling: true }), Runtime2.PYTHON_3_10 = new Runtime2("python3.10", RuntimeFamily2.PYTHON, { supportsInlineCode: true, supportsCodeGuruProfiling: true }), Runtime2.JAVA_8 = new Runtime2("java8", RuntimeFamily2.JAVA, { supportsCodeGuruProfiling: true }), Runtime2.JAVA_8_CORRETTO = new Runtime2("java8.al2", RuntimeFamily2.JAVA, { supportsCodeGuruProfiling: true }), Runtime2.JAVA_11 = new Runtime2("java11", RuntimeFamily2.JAVA, { supportsCodeGuruProfiling: true }), Runtime2.JAVA_17 = new Runtime2("java17", RuntimeFamily2.JAVA, { supportsCodeGuruProfiling: true }), Runtime2.DOTNET_6 = new Runtime2("dotnet6", RuntimeFamily2.DOTNET_CORE), Runtime2.DOTNET_CORE_1 = new Runtime2("dotnetcore1.0", RuntimeFamily2.DOTNET_CORE), Runtime2.DOTNET_CORE_2 = new Runtime2("dotnetcore2.0", RuntimeFamily2.DOTNET_CORE), Runtime2.DOTNET_CORE_2_1 = new Runtime2("dotnetcore2.1", RuntimeFamily2.DOTNET_CORE), Runtime2.DOTNET_CORE_3_1 = new Runtime2("dotnetcore3.1", RuntimeFamily2.DOTNET_CORE), Runtime2.GO_1_X = new Runtime2("go1.x", RuntimeFamily2.GO), Runtime2.RUBY_2_5 = new Runtime2("ruby2.5", RuntimeFamily2.RUBY), Runtime2.RUBY_2_7 = new Runtime2("ruby2.7", RuntimeFamily2.RUBY), Runtime2.PROVIDED = new Runtime2("provided", RuntimeFamily2.OTHER), Runtime2.PROVIDED_AL2 = new Runtime2("provided.al2", RuntimeFamily2.OTHER), Runtime2.FROM_IMAGE = new Runtime2("FROM_IMAGE"), exports2.Runtime = Runtime2;
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/layers.js
var require_layers = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/layers.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LayerVersion = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var lambda_generated_1 = require_lambda_generated();
    var runtime_1 = require_runtime3();
    var core_1 = require_core2();
    var LayerVersionBase = class extends core_1.Resource {
      addPermission(id, permission) {
        if (permission.organizationId != null && permission.accountId !== "*")
          throw new Error(`OrganizationId can only be specified if AwsAccountId is '*', but it is ${permission.accountId}`);
        new lambda_generated_1.CfnLayerVersionPermission(this, id, { action: "lambda:GetLayerVersion", layerVersionArn: this.layerVersionArn, principal: permission.accountId, organizationId: permission.organizationId });
      }
    };
    var LayerVersion = class _LayerVersion extends LayerVersionBase {
      static fromLayerVersionArn(scope, id, layerVersionArn) {
        return _LayerVersion.fromLayerVersionAttributes(scope, id, { layerVersionArn, compatibleRuntimes: runtime_1.Runtime.ALL });
      }
      static fromLayerVersionAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_LayerVersionAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromLayerVersionAttributes), error;
        }
        if (attrs.compatibleRuntimes && attrs.compatibleRuntimes.length === 0)
          throw new Error("Attempted to import a Lambda layer that supports no runtime!");
        class Import extends LayerVersionBase {
          constructor() {
            super(...arguments), this.layerVersionArn = attrs.layerVersionArn, this.compatibleRuntimes = attrs.compatibleRuntimes;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.layerVersionName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_LayerVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _LayerVersion), error;
        }
        if (props.compatibleRuntimes && props.compatibleRuntimes.length === 0)
          throw new Error("Attempted to define a Lambda layer that supports no runtime!");
        const code = props.code.bind(this);
        if (code.inlineCode)
          throw new Error("Inline code is not supported for AWS Lambda layers");
        if (!code.s3Location)
          throw new Error("Code must define an S3 location");
        const resource = new lambda_generated_1.CfnLayerVersion(this, "Resource", { compatibleRuntimes: props.compatibleRuntimes && props.compatibleRuntimes.map((r) => r.name), compatibleArchitectures: props.compatibleArchitectures?.map((a) => a.name), content: { s3Bucket: code.s3Location.bucketName, s3Key: code.s3Location.objectKey, s3ObjectVersion: code.s3Location.objectVersion }, description: props.description, layerName: this.physicalName, licenseInfo: props.license });
        props.removalPolicy && resource.applyRemovalPolicy(props.removalPolicy), props.code.bindToResource(resource, { resourceProperty: "Content" }), this.layerVersionArn = resource.ref, this.compatibleRuntimes = props.compatibleRuntimes;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LayerVersion[_a] = { fqn: "aws-cdk-lib.aws_lambda.LayerVersion", version: "2.80.0" }, exports2.LayerVersion = LayerVersion;
  }
});

// node_modules/aws-cdk-lib/aws-cloudwatch/lib/alarm-base.js
var require_alarm_base = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudwatch/lib/alarm-base.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AlarmBase = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core_1 = require_core2();
    var AlarmBase = class extends core_1.Resource {
      renderAlarmRule() {
        return `ALARM("${this.alarmArn}")`;
      }
      addAlarmAction(...actions) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_IAlarmAction(actions);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addAlarmAction), error;
        }
        this.alarmActionArns === void 0 && (this.alarmActionArns = []), this.alarmActionArns.push(...actions.map((a) => a.bind(this, this).alarmActionArn));
      }
      addInsufficientDataAction(...actions) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_IAlarmAction(actions);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addInsufficientDataAction), error;
        }
        this.insufficientDataActionArns === void 0 && (this.insufficientDataActionArns = []), this.insufficientDataActionArns.push(...actions.map((a) => a.bind(this, this).alarmActionArn));
      }
      addOkAction(...actions) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_IAlarmAction(actions);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addOkAction), error;
        }
        this.okActionArns === void 0 && (this.okActionArns = []), this.okActionArns.push(...actions.map((a) => a.bind(this, this).alarmActionArn));
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AlarmBase[_a] = { fqn: "aws-cdk-lib.aws_cloudwatch.AlarmBase", version: "2.80.0" }, exports2.AlarmBase = AlarmBase;
  }
});

// node_modules/aws-cdk-lib/aws-cloudwatch/lib/cloudwatch.generated.js
var require_cloudwatch_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudwatch/lib/cloudwatch.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnMetricStream = exports2.CfnInsightRule = exports2.CfnDashboard = exports2.CfnCompositeAlarm = exports2.CfnAnomalyDetector = exports2.CfnAlarm = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAlarmPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actionsEnabled", cdk.validateBoolean)(properties.actionsEnabled)), errors.collect(cdk.propertyValidator("alarmActions", cdk.listValidator(cdk.validateString))(properties.alarmActions)), errors.collect(cdk.propertyValidator("alarmDescription", cdk.validateString)(properties.alarmDescription)), errors.collect(cdk.propertyValidator("alarmName", cdk.validateString)(properties.alarmName)), errors.collect(cdk.propertyValidator("comparisonOperator", cdk.requiredValidator)(properties.comparisonOperator)), errors.collect(cdk.propertyValidator("comparisonOperator", cdk.validateString)(properties.comparisonOperator)), errors.collect(cdk.propertyValidator("datapointsToAlarm", cdk.validateNumber)(properties.datapointsToAlarm)), errors.collect(cdk.propertyValidator("dimensions", cdk.listValidator(CfnAlarm_DimensionPropertyValidator))(properties.dimensions)), errors.collect(cdk.propertyValidator("evaluateLowSampleCountPercentile", cdk.validateString)(properties.evaluateLowSampleCountPercentile)), errors.collect(cdk.propertyValidator("evaluationPeriods", cdk.requiredValidator)(properties.evaluationPeriods)), errors.collect(cdk.propertyValidator("evaluationPeriods", cdk.validateNumber)(properties.evaluationPeriods)), errors.collect(cdk.propertyValidator("extendedStatistic", cdk.validateString)(properties.extendedStatistic)), errors.collect(cdk.propertyValidator("insufficientDataActions", cdk.listValidator(cdk.validateString))(properties.insufficientDataActions)), errors.collect(cdk.propertyValidator("metricName", cdk.validateString)(properties.metricName)), errors.collect(cdk.propertyValidator("metrics", cdk.listValidator(CfnAlarm_MetricDataQueryPropertyValidator))(properties.metrics)), errors.collect(cdk.propertyValidator("namespace", cdk.validateString)(properties.namespace)), errors.collect(cdk.propertyValidator("okActions", cdk.listValidator(cdk.validateString))(properties.okActions)), errors.collect(cdk.propertyValidator("period", cdk.validateNumber)(properties.period)), errors.collect(cdk.propertyValidator("statistic", cdk.validateString)(properties.statistic)), errors.collect(cdk.propertyValidator("threshold", cdk.validateNumber)(properties.threshold)), errors.collect(cdk.propertyValidator("thresholdMetricId", cdk.validateString)(properties.thresholdMetricId)), errors.collect(cdk.propertyValidator("treatMissingData", cdk.validateString)(properties.treatMissingData)), errors.collect(cdk.propertyValidator("unit", cdk.validateString)(properties.unit)), errors.wrap('supplied properties not correct for "CfnAlarmProps"');
    }
    function cfnAlarmPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlarmPropsValidator(properties).assertSuccess(), { ComparisonOperator: cdk.stringToCloudFormation(properties.comparisonOperator), EvaluationPeriods: cdk.numberToCloudFormation(properties.evaluationPeriods), ActionsEnabled: cdk.booleanToCloudFormation(properties.actionsEnabled), AlarmActions: cdk.listMapper(cdk.stringToCloudFormation)(properties.alarmActions), AlarmDescription: cdk.stringToCloudFormation(properties.alarmDescription), AlarmName: cdk.stringToCloudFormation(properties.alarmName), DatapointsToAlarm: cdk.numberToCloudFormation(properties.datapointsToAlarm), Dimensions: cdk.listMapper(cfnAlarmDimensionPropertyToCloudFormation)(properties.dimensions), EvaluateLowSampleCountPercentile: cdk.stringToCloudFormation(properties.evaluateLowSampleCountPercentile), ExtendedStatistic: cdk.stringToCloudFormation(properties.extendedStatistic), InsufficientDataActions: cdk.listMapper(cdk.stringToCloudFormation)(properties.insufficientDataActions), MetricName: cdk.stringToCloudFormation(properties.metricName), Metrics: cdk.listMapper(cfnAlarmMetricDataQueryPropertyToCloudFormation)(properties.metrics), Namespace: cdk.stringToCloudFormation(properties.namespace), OKActions: cdk.listMapper(cdk.stringToCloudFormation)(properties.okActions), Period: cdk.numberToCloudFormation(properties.period), Statistic: cdk.stringToCloudFormation(properties.statistic), Threshold: cdk.numberToCloudFormation(properties.threshold), ThresholdMetricId: cdk.stringToCloudFormation(properties.thresholdMetricId), TreatMissingData: cdk.stringToCloudFormation(properties.treatMissingData), Unit: cdk.stringToCloudFormation(properties.unit) }) : properties;
    }
    function CfnAlarmPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("comparisonOperator", "ComparisonOperator", cfn_parse.FromCloudFormation.getString(properties.ComparisonOperator)), ret.addPropertyResult("evaluationPeriods", "EvaluationPeriods", cfn_parse.FromCloudFormation.getNumber(properties.EvaluationPeriods)), ret.addPropertyResult("actionsEnabled", "ActionsEnabled", properties.ActionsEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ActionsEnabled) : void 0), ret.addPropertyResult("alarmActions", "AlarmActions", properties.AlarmActions != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AlarmActions) : void 0), ret.addPropertyResult("alarmDescription", "AlarmDescription", properties.AlarmDescription != null ? cfn_parse.FromCloudFormation.getString(properties.AlarmDescription) : void 0), ret.addPropertyResult("alarmName", "AlarmName", properties.AlarmName != null ? cfn_parse.FromCloudFormation.getString(properties.AlarmName) : void 0), ret.addPropertyResult("datapointsToAlarm", "DatapointsToAlarm", properties.DatapointsToAlarm != null ? cfn_parse.FromCloudFormation.getNumber(properties.DatapointsToAlarm) : void 0), ret.addPropertyResult("dimensions", "Dimensions", properties.Dimensions != null ? cfn_parse.FromCloudFormation.getArray(CfnAlarmDimensionPropertyFromCloudFormation)(properties.Dimensions) : void 0), ret.addPropertyResult("evaluateLowSampleCountPercentile", "EvaluateLowSampleCountPercentile", properties.EvaluateLowSampleCountPercentile != null ? cfn_parse.FromCloudFormation.getString(properties.EvaluateLowSampleCountPercentile) : void 0), ret.addPropertyResult("extendedStatistic", "ExtendedStatistic", properties.ExtendedStatistic != null ? cfn_parse.FromCloudFormation.getString(properties.ExtendedStatistic) : void 0), ret.addPropertyResult("insufficientDataActions", "InsufficientDataActions", properties.InsufficientDataActions != null ? cfn_parse.FromCloudFormation.getStringArray(properties.InsufficientDataActions) : void 0), ret.addPropertyResult("metricName", "MetricName", properties.MetricName != null ? cfn_parse.FromCloudFormation.getString(properties.MetricName) : void 0), ret.addPropertyResult("metrics", "Metrics", properties.Metrics != null ? cfn_parse.FromCloudFormation.getArray(CfnAlarmMetricDataQueryPropertyFromCloudFormation)(properties.Metrics) : void 0), ret.addPropertyResult("namespace", "Namespace", properties.Namespace != null ? cfn_parse.FromCloudFormation.getString(properties.Namespace) : void 0), ret.addPropertyResult("okActions", "OKActions", properties.OKActions != null ? cfn_parse.FromCloudFormation.getStringArray(properties.OKActions) : void 0), ret.addPropertyResult("period", "Period", properties.Period != null ? cfn_parse.FromCloudFormation.getNumber(properties.Period) : void 0), ret.addPropertyResult("statistic", "Statistic", properties.Statistic != null ? cfn_parse.FromCloudFormation.getString(properties.Statistic) : void 0), ret.addPropertyResult("threshold", "Threshold", properties.Threshold != null ? cfn_parse.FromCloudFormation.getNumber(properties.Threshold) : void 0), ret.addPropertyResult("thresholdMetricId", "ThresholdMetricId", properties.ThresholdMetricId != null ? cfn_parse.FromCloudFormation.getString(properties.ThresholdMetricId) : void 0), ret.addPropertyResult("treatMissingData", "TreatMissingData", properties.TreatMissingData != null ? cfn_parse.FromCloudFormation.getString(properties.TreatMissingData) : void 0), ret.addPropertyResult("unit", "Unit", properties.Unit != null ? cfn_parse.FromCloudFormation.getString(properties.Unit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAlarm = class _CfnAlarm extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAlarmPropsFromCloudFormation(resourceProperties), ret = new _CfnAlarm(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAlarm.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_CfnAlarmProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAlarm), error;
        }
        cdk.requireProperty(props, "comparisonOperator", this), cdk.requireProperty(props, "evaluationPeriods", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.comparisonOperator = props.comparisonOperator, this.evaluationPeriods = props.evaluationPeriods, this.actionsEnabled = props.actionsEnabled, this.alarmActions = props.alarmActions, this.alarmDescription = props.alarmDescription, this.alarmName = props.alarmName, this.datapointsToAlarm = props.datapointsToAlarm, this.dimensions = props.dimensions, this.evaluateLowSampleCountPercentile = props.evaluateLowSampleCountPercentile, this.extendedStatistic = props.extendedStatistic, this.insufficientDataActions = props.insufficientDataActions, this.metricName = props.metricName, this.metrics = props.metrics, this.namespace = props.namespace, this.okActions = props.okActions, this.period = props.period, this.statistic = props.statistic, this.threshold = props.threshold, this.thresholdMetricId = props.thresholdMetricId, this.treatMissingData = props.treatMissingData, this.unit = props.unit;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAlarm.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { comparisonOperator: this.comparisonOperator, evaluationPeriods: this.evaluationPeriods, actionsEnabled: this.actionsEnabled, alarmActions: this.alarmActions, alarmDescription: this.alarmDescription, alarmName: this.alarmName, datapointsToAlarm: this.datapointsToAlarm, dimensions: this.dimensions, evaluateLowSampleCountPercentile: this.evaluateLowSampleCountPercentile, extendedStatistic: this.extendedStatistic, insufficientDataActions: this.insufficientDataActions, metricName: this.metricName, metrics: this.metrics, namespace: this.namespace, okActions: this.okActions, period: this.period, statistic: this.statistic, threshold: this.threshold, thresholdMetricId: this.thresholdMetricId, treatMissingData: this.treatMissingData, unit: this.unit };
      }
      renderProperties(props) {
        return cfnAlarmPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAlarm[_a] = { fqn: "aws-cdk-lib.aws_cloudwatch.CfnAlarm", version: "2.80.0" }, CfnAlarm.CFN_RESOURCE_TYPE_NAME = "AWS::CloudWatch::Alarm", exports2.CfnAlarm = CfnAlarm;
    function CfnAlarm_DimensionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "DimensionProperty"');
    }
    function cfnAlarmDimensionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlarm_DimensionPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnAlarmDimensionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAlarm_MetricPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dimensions", cdk.listValidator(CfnAlarm_DimensionPropertyValidator))(properties.dimensions)), errors.collect(cdk.propertyValidator("metricName", cdk.validateString)(properties.metricName)), errors.collect(cdk.propertyValidator("namespace", cdk.validateString)(properties.namespace)), errors.wrap('supplied properties not correct for "MetricProperty"');
    }
    function cfnAlarmMetricPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlarm_MetricPropertyValidator(properties).assertSuccess(), { Dimensions: cdk.listMapper(cfnAlarmDimensionPropertyToCloudFormation)(properties.dimensions), MetricName: cdk.stringToCloudFormation(properties.metricName), Namespace: cdk.stringToCloudFormation(properties.namespace) }) : properties;
    }
    function CfnAlarmMetricPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dimensions", "Dimensions", properties.Dimensions != null ? cfn_parse.FromCloudFormation.getArray(CfnAlarmDimensionPropertyFromCloudFormation)(properties.Dimensions) : void 0), ret.addPropertyResult("metricName", "MetricName", properties.MetricName != null ? cfn_parse.FromCloudFormation.getString(properties.MetricName) : void 0), ret.addPropertyResult("namespace", "Namespace", properties.Namespace != null ? cfn_parse.FromCloudFormation.getString(properties.Namespace) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAlarm_MetricDataQueryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accountId", cdk.validateString)(properties.accountId)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("label", cdk.validateString)(properties.label)), errors.collect(cdk.propertyValidator("metricStat", CfnAlarm_MetricStatPropertyValidator)(properties.metricStat)), errors.collect(cdk.propertyValidator("period", cdk.validateNumber)(properties.period)), errors.collect(cdk.propertyValidator("returnData", cdk.validateBoolean)(properties.returnData)), errors.wrap('supplied properties not correct for "MetricDataQueryProperty"');
    }
    function cfnAlarmMetricDataQueryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlarm_MetricDataQueryPropertyValidator(properties).assertSuccess(), { AccountId: cdk.stringToCloudFormation(properties.accountId), Expression: cdk.stringToCloudFormation(properties.expression), Id: cdk.stringToCloudFormation(properties.id), Label: cdk.stringToCloudFormation(properties.label), MetricStat: cfnAlarmMetricStatPropertyToCloudFormation(properties.metricStat), Period: cdk.numberToCloudFormation(properties.period), ReturnData: cdk.booleanToCloudFormation(properties.returnData) }) : properties;
    }
    function CfnAlarmMetricDataQueryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accountId", "AccountId", properties.AccountId != null ? cfn_parse.FromCloudFormation.getString(properties.AccountId) : void 0), ret.addPropertyResult("expression", "Expression", properties.Expression != null ? cfn_parse.FromCloudFormation.getString(properties.Expression) : void 0), ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("label", "Label", properties.Label != null ? cfn_parse.FromCloudFormation.getString(properties.Label) : void 0), ret.addPropertyResult("metricStat", "MetricStat", properties.MetricStat != null ? CfnAlarmMetricStatPropertyFromCloudFormation(properties.MetricStat) : void 0), ret.addPropertyResult("period", "Period", properties.Period != null ? cfn_parse.FromCloudFormation.getNumber(properties.Period) : void 0), ret.addPropertyResult("returnData", "ReturnData", properties.ReturnData != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ReturnData) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAlarm_MetricStatPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("metric", cdk.requiredValidator)(properties.metric)), errors.collect(cdk.propertyValidator("metric", CfnAlarm_MetricPropertyValidator)(properties.metric)), errors.collect(cdk.propertyValidator("period", cdk.requiredValidator)(properties.period)), errors.collect(cdk.propertyValidator("period", cdk.validateNumber)(properties.period)), errors.collect(cdk.propertyValidator("stat", cdk.requiredValidator)(properties.stat)), errors.collect(cdk.propertyValidator("stat", cdk.validateString)(properties.stat)), errors.collect(cdk.propertyValidator("unit", cdk.validateString)(properties.unit)), errors.wrap('supplied properties not correct for "MetricStatProperty"');
    }
    function cfnAlarmMetricStatPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlarm_MetricStatPropertyValidator(properties).assertSuccess(), { Metric: cfnAlarmMetricPropertyToCloudFormation(properties.metric), Period: cdk.numberToCloudFormation(properties.period), Stat: cdk.stringToCloudFormation(properties.stat), Unit: cdk.stringToCloudFormation(properties.unit) }) : properties;
    }
    function CfnAlarmMetricStatPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("metric", "Metric", CfnAlarmMetricPropertyFromCloudFormation(properties.Metric)), ret.addPropertyResult("period", "Period", cfn_parse.FromCloudFormation.getNumber(properties.Period)), ret.addPropertyResult("stat", "Stat", cfn_parse.FromCloudFormation.getString(properties.Stat)), ret.addPropertyResult("unit", "Unit", properties.Unit != null ? cfn_parse.FromCloudFormation.getString(properties.Unit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnomalyDetectorPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configuration", CfnAnomalyDetector_ConfigurationPropertyValidator)(properties.configuration)), errors.collect(cdk.propertyValidator("dimensions", cdk.listValidator(CfnAnomalyDetector_DimensionPropertyValidator))(properties.dimensions)), errors.collect(cdk.propertyValidator("metricMathAnomalyDetector", CfnAnomalyDetector_MetricMathAnomalyDetectorPropertyValidator)(properties.metricMathAnomalyDetector)), errors.collect(cdk.propertyValidator("metricName", cdk.validateString)(properties.metricName)), errors.collect(cdk.propertyValidator("namespace", cdk.validateString)(properties.namespace)), errors.collect(cdk.propertyValidator("singleMetricAnomalyDetector", CfnAnomalyDetector_SingleMetricAnomalyDetectorPropertyValidator)(properties.singleMetricAnomalyDetector)), errors.collect(cdk.propertyValidator("stat", cdk.validateString)(properties.stat)), errors.wrap('supplied properties not correct for "CfnAnomalyDetectorProps"');
    }
    function cfnAnomalyDetectorPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnomalyDetectorPropsValidator(properties).assertSuccess(), { Configuration: cfnAnomalyDetectorConfigurationPropertyToCloudFormation(properties.configuration), Dimensions: cdk.listMapper(cfnAnomalyDetectorDimensionPropertyToCloudFormation)(properties.dimensions), MetricMathAnomalyDetector: cfnAnomalyDetectorMetricMathAnomalyDetectorPropertyToCloudFormation(properties.metricMathAnomalyDetector), MetricName: cdk.stringToCloudFormation(properties.metricName), Namespace: cdk.stringToCloudFormation(properties.namespace), SingleMetricAnomalyDetector: cfnAnomalyDetectorSingleMetricAnomalyDetectorPropertyToCloudFormation(properties.singleMetricAnomalyDetector), Stat: cdk.stringToCloudFormation(properties.stat) }) : properties;
    }
    function CfnAnomalyDetectorPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configuration", "Configuration", properties.Configuration != null ? CfnAnomalyDetectorConfigurationPropertyFromCloudFormation(properties.Configuration) : void 0), ret.addPropertyResult("dimensions", "Dimensions", properties.Dimensions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnomalyDetectorDimensionPropertyFromCloudFormation)(properties.Dimensions) : void 0), ret.addPropertyResult("metricMathAnomalyDetector", "MetricMathAnomalyDetector", properties.MetricMathAnomalyDetector != null ? CfnAnomalyDetectorMetricMathAnomalyDetectorPropertyFromCloudFormation(properties.MetricMathAnomalyDetector) : void 0), ret.addPropertyResult("metricName", "MetricName", properties.MetricName != null ? cfn_parse.FromCloudFormation.getString(properties.MetricName) : void 0), ret.addPropertyResult("namespace", "Namespace", properties.Namespace != null ? cfn_parse.FromCloudFormation.getString(properties.Namespace) : void 0), ret.addPropertyResult("singleMetricAnomalyDetector", "SingleMetricAnomalyDetector", properties.SingleMetricAnomalyDetector != null ? CfnAnomalyDetectorSingleMetricAnomalyDetectorPropertyFromCloudFormation(properties.SingleMetricAnomalyDetector) : void 0), ret.addPropertyResult("stat", "Stat", properties.Stat != null ? cfn_parse.FromCloudFormation.getString(properties.Stat) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAnomalyDetector = class _CfnAnomalyDetector extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAnomalyDetectorPropsFromCloudFormation(resourceProperties), ret = new _CfnAnomalyDetector(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnAnomalyDetector.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_CfnAnomalyDetectorProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAnomalyDetector), error;
        }
        this.configuration = props.configuration, this.dimensions = props.dimensions, this.metricMathAnomalyDetector = props.metricMathAnomalyDetector, this.metricName = props.metricName, this.namespace = props.namespace, this.singleMetricAnomalyDetector = props.singleMetricAnomalyDetector, this.stat = props.stat;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAnomalyDetector.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { configuration: this.configuration, dimensions: this.dimensions, metricMathAnomalyDetector: this.metricMathAnomalyDetector, metricName: this.metricName, namespace: this.namespace, singleMetricAnomalyDetector: this.singleMetricAnomalyDetector, stat: this.stat };
      }
      renderProperties(props) {
        return cfnAnomalyDetectorPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnAnomalyDetector[_b] = { fqn: "aws-cdk-lib.aws_cloudwatch.CfnAnomalyDetector", version: "2.80.0" }, CfnAnomalyDetector.CFN_RESOURCE_TYPE_NAME = "AWS::CloudWatch::AnomalyDetector", exports2.CfnAnomalyDetector = CfnAnomalyDetector;
    function CfnAnomalyDetector_ConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("excludedTimeRanges", cdk.listValidator(CfnAnomalyDetector_RangePropertyValidator))(properties.excludedTimeRanges)), errors.collect(cdk.propertyValidator("metricTimeZone", cdk.validateString)(properties.metricTimeZone)), errors.wrap('supplied properties not correct for "ConfigurationProperty"');
    }
    function cfnAnomalyDetectorConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnomalyDetector_ConfigurationPropertyValidator(properties).assertSuccess(), { ExcludedTimeRanges: cdk.listMapper(cfnAnomalyDetectorRangePropertyToCloudFormation)(properties.excludedTimeRanges), MetricTimeZone: cdk.stringToCloudFormation(properties.metricTimeZone) }) : properties;
    }
    function CfnAnomalyDetectorConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("excludedTimeRanges", "ExcludedTimeRanges", properties.ExcludedTimeRanges != null ? cfn_parse.FromCloudFormation.getArray(CfnAnomalyDetectorRangePropertyFromCloudFormation)(properties.ExcludedTimeRanges) : void 0), ret.addPropertyResult("metricTimeZone", "MetricTimeZone", properties.MetricTimeZone != null ? cfn_parse.FromCloudFormation.getString(properties.MetricTimeZone) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnomalyDetector_DimensionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "DimensionProperty"');
    }
    function cfnAnomalyDetectorDimensionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnomalyDetector_DimensionPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnAnomalyDetectorDimensionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnomalyDetector_MetricPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dimensions", cdk.listValidator(CfnAnomalyDetector_DimensionPropertyValidator))(properties.dimensions)), errors.collect(cdk.propertyValidator("metricName", cdk.requiredValidator)(properties.metricName)), errors.collect(cdk.propertyValidator("metricName", cdk.validateString)(properties.metricName)), errors.collect(cdk.propertyValidator("namespace", cdk.requiredValidator)(properties.namespace)), errors.collect(cdk.propertyValidator("namespace", cdk.validateString)(properties.namespace)), errors.wrap('supplied properties not correct for "MetricProperty"');
    }
    function cfnAnomalyDetectorMetricPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnomalyDetector_MetricPropertyValidator(properties).assertSuccess(), { Dimensions: cdk.listMapper(cfnAnomalyDetectorDimensionPropertyToCloudFormation)(properties.dimensions), MetricName: cdk.stringToCloudFormation(properties.metricName), Namespace: cdk.stringToCloudFormation(properties.namespace) }) : properties;
    }
    function CfnAnomalyDetectorMetricPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dimensions", "Dimensions", properties.Dimensions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnomalyDetectorDimensionPropertyFromCloudFormation)(properties.Dimensions) : void 0), ret.addPropertyResult("metricName", "MetricName", cfn_parse.FromCloudFormation.getString(properties.MetricName)), ret.addPropertyResult("namespace", "Namespace", cfn_parse.FromCloudFormation.getString(properties.Namespace)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnomalyDetector_MetricDataQueryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accountId", cdk.validateString)(properties.accountId)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("label", cdk.validateString)(properties.label)), errors.collect(cdk.propertyValidator("metricStat", CfnAnomalyDetector_MetricStatPropertyValidator)(properties.metricStat)), errors.collect(cdk.propertyValidator("period", cdk.validateNumber)(properties.period)), errors.collect(cdk.propertyValidator("returnData", cdk.validateBoolean)(properties.returnData)), errors.wrap('supplied properties not correct for "MetricDataQueryProperty"');
    }
    function cfnAnomalyDetectorMetricDataQueryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnomalyDetector_MetricDataQueryPropertyValidator(properties).assertSuccess(), { AccountId: cdk.stringToCloudFormation(properties.accountId), Expression: cdk.stringToCloudFormation(properties.expression), Id: cdk.stringToCloudFormation(properties.id), Label: cdk.stringToCloudFormation(properties.label), MetricStat: cfnAnomalyDetectorMetricStatPropertyToCloudFormation(properties.metricStat), Period: cdk.numberToCloudFormation(properties.period), ReturnData: cdk.booleanToCloudFormation(properties.returnData) }) : properties;
    }
    function CfnAnomalyDetectorMetricDataQueryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accountId", "AccountId", properties.AccountId != null ? cfn_parse.FromCloudFormation.getString(properties.AccountId) : void 0), ret.addPropertyResult("expression", "Expression", properties.Expression != null ? cfn_parse.FromCloudFormation.getString(properties.Expression) : void 0), ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("label", "Label", properties.Label != null ? cfn_parse.FromCloudFormation.getString(properties.Label) : void 0), ret.addPropertyResult("metricStat", "MetricStat", properties.MetricStat != null ? CfnAnomalyDetectorMetricStatPropertyFromCloudFormation(properties.MetricStat) : void 0), ret.addPropertyResult("period", "Period", properties.Period != null ? cfn_parse.FromCloudFormation.getNumber(properties.Period) : void 0), ret.addPropertyResult("returnData", "ReturnData", properties.ReturnData != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ReturnData) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnomalyDetector_MetricMathAnomalyDetectorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("metricDataQueries", cdk.listValidator(CfnAnomalyDetector_MetricDataQueryPropertyValidator))(properties.metricDataQueries)), errors.wrap('supplied properties not correct for "MetricMathAnomalyDetectorProperty"');
    }
    function cfnAnomalyDetectorMetricMathAnomalyDetectorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnomalyDetector_MetricMathAnomalyDetectorPropertyValidator(properties).assertSuccess(), { MetricDataQueries: cdk.listMapper(cfnAnomalyDetectorMetricDataQueryPropertyToCloudFormation)(properties.metricDataQueries) }) : properties;
    }
    function CfnAnomalyDetectorMetricMathAnomalyDetectorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("metricDataQueries", "MetricDataQueries", properties.MetricDataQueries != null ? cfn_parse.FromCloudFormation.getArray(CfnAnomalyDetectorMetricDataQueryPropertyFromCloudFormation)(properties.MetricDataQueries) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnomalyDetector_MetricStatPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("metric", cdk.requiredValidator)(properties.metric)), errors.collect(cdk.propertyValidator("metric", CfnAnomalyDetector_MetricPropertyValidator)(properties.metric)), errors.collect(cdk.propertyValidator("period", cdk.requiredValidator)(properties.period)), errors.collect(cdk.propertyValidator("period", cdk.validateNumber)(properties.period)), errors.collect(cdk.propertyValidator("stat", cdk.requiredValidator)(properties.stat)), errors.collect(cdk.propertyValidator("stat", cdk.validateString)(properties.stat)), errors.collect(cdk.propertyValidator("unit", cdk.validateString)(properties.unit)), errors.wrap('supplied properties not correct for "MetricStatProperty"');
    }
    function cfnAnomalyDetectorMetricStatPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnomalyDetector_MetricStatPropertyValidator(properties).assertSuccess(), { Metric: cfnAnomalyDetectorMetricPropertyToCloudFormation(properties.metric), Period: cdk.numberToCloudFormation(properties.period), Stat: cdk.stringToCloudFormation(properties.stat), Unit: cdk.stringToCloudFormation(properties.unit) }) : properties;
    }
    function CfnAnomalyDetectorMetricStatPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("metric", "Metric", CfnAnomalyDetectorMetricPropertyFromCloudFormation(properties.Metric)), ret.addPropertyResult("period", "Period", cfn_parse.FromCloudFormation.getNumber(properties.Period)), ret.addPropertyResult("stat", "Stat", cfn_parse.FromCloudFormation.getString(properties.Stat)), ret.addPropertyResult("unit", "Unit", properties.Unit != null ? cfn_parse.FromCloudFormation.getString(properties.Unit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnomalyDetector_RangePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endTime", cdk.requiredValidator)(properties.endTime)), errors.collect(cdk.propertyValidator("endTime", cdk.validateString)(properties.endTime)), errors.collect(cdk.propertyValidator("startTime", cdk.requiredValidator)(properties.startTime)), errors.collect(cdk.propertyValidator("startTime", cdk.validateString)(properties.startTime)), errors.wrap('supplied properties not correct for "RangeProperty"');
    }
    function cfnAnomalyDetectorRangePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnomalyDetector_RangePropertyValidator(properties).assertSuccess(), { EndTime: cdk.stringToCloudFormation(properties.endTime), StartTime: cdk.stringToCloudFormation(properties.startTime) }) : properties;
    }
    function CfnAnomalyDetectorRangePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endTime", "EndTime", cfn_parse.FromCloudFormation.getString(properties.EndTime)), ret.addPropertyResult("startTime", "StartTime", cfn_parse.FromCloudFormation.getString(properties.StartTime)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnomalyDetector_SingleMetricAnomalyDetectorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dimensions", cdk.listValidator(CfnAnomalyDetector_DimensionPropertyValidator))(properties.dimensions)), errors.collect(cdk.propertyValidator("metricName", cdk.validateString)(properties.metricName)), errors.collect(cdk.propertyValidator("namespace", cdk.validateString)(properties.namespace)), errors.collect(cdk.propertyValidator("stat", cdk.validateString)(properties.stat)), errors.wrap('supplied properties not correct for "SingleMetricAnomalyDetectorProperty"');
    }
    function cfnAnomalyDetectorSingleMetricAnomalyDetectorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnomalyDetector_SingleMetricAnomalyDetectorPropertyValidator(properties).assertSuccess(), { Dimensions: cdk.listMapper(cfnAnomalyDetectorDimensionPropertyToCloudFormation)(properties.dimensions), MetricName: cdk.stringToCloudFormation(properties.metricName), Namespace: cdk.stringToCloudFormation(properties.namespace), Stat: cdk.stringToCloudFormation(properties.stat) }) : properties;
    }
    function CfnAnomalyDetectorSingleMetricAnomalyDetectorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dimensions", "Dimensions", properties.Dimensions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnomalyDetectorDimensionPropertyFromCloudFormation)(properties.Dimensions) : void 0), ret.addPropertyResult("metricName", "MetricName", properties.MetricName != null ? cfn_parse.FromCloudFormation.getString(properties.MetricName) : void 0), ret.addPropertyResult("namespace", "Namespace", properties.Namespace != null ? cfn_parse.FromCloudFormation.getString(properties.Namespace) : void 0), ret.addPropertyResult("stat", "Stat", properties.Stat != null ? cfn_parse.FromCloudFormation.getString(properties.Stat) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCompositeAlarmPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actionsEnabled", cdk.validateBoolean)(properties.actionsEnabled)), errors.collect(cdk.propertyValidator("actionsSuppressor", cdk.validateString)(properties.actionsSuppressor)), errors.collect(cdk.propertyValidator("actionsSuppressorExtensionPeriod", cdk.validateNumber)(properties.actionsSuppressorExtensionPeriod)), errors.collect(cdk.propertyValidator("actionsSuppressorWaitPeriod", cdk.validateNumber)(properties.actionsSuppressorWaitPeriod)), errors.collect(cdk.propertyValidator("alarmActions", cdk.listValidator(cdk.validateString))(properties.alarmActions)), errors.collect(cdk.propertyValidator("alarmDescription", cdk.validateString)(properties.alarmDescription)), errors.collect(cdk.propertyValidator("alarmName", cdk.validateString)(properties.alarmName)), errors.collect(cdk.propertyValidator("alarmRule", cdk.requiredValidator)(properties.alarmRule)), errors.collect(cdk.propertyValidator("alarmRule", cdk.validateString)(properties.alarmRule)), errors.collect(cdk.propertyValidator("insufficientDataActions", cdk.listValidator(cdk.validateString))(properties.insufficientDataActions)), errors.collect(cdk.propertyValidator("okActions", cdk.listValidator(cdk.validateString))(properties.okActions)), errors.wrap('supplied properties not correct for "CfnCompositeAlarmProps"');
    }
    function cfnCompositeAlarmPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCompositeAlarmPropsValidator(properties).assertSuccess(), { AlarmRule: cdk.stringToCloudFormation(properties.alarmRule), ActionsEnabled: cdk.booleanToCloudFormation(properties.actionsEnabled), ActionsSuppressor: cdk.stringToCloudFormation(properties.actionsSuppressor), ActionsSuppressorExtensionPeriod: cdk.numberToCloudFormation(properties.actionsSuppressorExtensionPeriod), ActionsSuppressorWaitPeriod: cdk.numberToCloudFormation(properties.actionsSuppressorWaitPeriod), AlarmActions: cdk.listMapper(cdk.stringToCloudFormation)(properties.alarmActions), AlarmDescription: cdk.stringToCloudFormation(properties.alarmDescription), AlarmName: cdk.stringToCloudFormation(properties.alarmName), InsufficientDataActions: cdk.listMapper(cdk.stringToCloudFormation)(properties.insufficientDataActions), OKActions: cdk.listMapper(cdk.stringToCloudFormation)(properties.okActions) }) : properties;
    }
    function CfnCompositeAlarmPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alarmRule", "AlarmRule", cfn_parse.FromCloudFormation.getString(properties.AlarmRule)), ret.addPropertyResult("actionsEnabled", "ActionsEnabled", properties.ActionsEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ActionsEnabled) : void 0), ret.addPropertyResult("actionsSuppressor", "ActionsSuppressor", properties.ActionsSuppressor != null ? cfn_parse.FromCloudFormation.getString(properties.ActionsSuppressor) : void 0), ret.addPropertyResult("actionsSuppressorExtensionPeriod", "ActionsSuppressorExtensionPeriod", properties.ActionsSuppressorExtensionPeriod != null ? cfn_parse.FromCloudFormation.getNumber(properties.ActionsSuppressorExtensionPeriod) : void 0), ret.addPropertyResult("actionsSuppressorWaitPeriod", "ActionsSuppressorWaitPeriod", properties.ActionsSuppressorWaitPeriod != null ? cfn_parse.FromCloudFormation.getNumber(properties.ActionsSuppressorWaitPeriod) : void 0), ret.addPropertyResult("alarmActions", "AlarmActions", properties.AlarmActions != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AlarmActions) : void 0), ret.addPropertyResult("alarmDescription", "AlarmDescription", properties.AlarmDescription != null ? cfn_parse.FromCloudFormation.getString(properties.AlarmDescription) : void 0), ret.addPropertyResult("alarmName", "AlarmName", properties.AlarmName != null ? cfn_parse.FromCloudFormation.getString(properties.AlarmName) : void 0), ret.addPropertyResult("insufficientDataActions", "InsufficientDataActions", properties.InsufficientDataActions != null ? cfn_parse.FromCloudFormation.getStringArray(properties.InsufficientDataActions) : void 0), ret.addPropertyResult("okActions", "OKActions", properties.OKActions != null ? cfn_parse.FromCloudFormation.getStringArray(properties.OKActions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCompositeAlarm = class _CfnCompositeAlarm extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCompositeAlarmPropsFromCloudFormation(resourceProperties), ret = new _CfnCompositeAlarm(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCompositeAlarm.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_CfnCompositeAlarmProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCompositeAlarm), error;
        }
        cdk.requireProperty(props, "alarmRule", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.alarmRule = props.alarmRule, this.actionsEnabled = props.actionsEnabled, this.actionsSuppressor = props.actionsSuppressor, this.actionsSuppressorExtensionPeriod = props.actionsSuppressorExtensionPeriod, this.actionsSuppressorWaitPeriod = props.actionsSuppressorWaitPeriod, this.alarmActions = props.alarmActions, this.alarmDescription = props.alarmDescription, this.alarmName = props.alarmName, this.insufficientDataActions = props.insufficientDataActions, this.okActions = props.okActions;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCompositeAlarm.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { alarmRule: this.alarmRule, actionsEnabled: this.actionsEnabled, actionsSuppressor: this.actionsSuppressor, actionsSuppressorExtensionPeriod: this.actionsSuppressorExtensionPeriod, actionsSuppressorWaitPeriod: this.actionsSuppressorWaitPeriod, alarmActions: this.alarmActions, alarmDescription: this.alarmDescription, alarmName: this.alarmName, insufficientDataActions: this.insufficientDataActions, okActions: this.okActions };
      }
      renderProperties(props) {
        return cfnCompositeAlarmPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnCompositeAlarm[_c] = { fqn: "aws-cdk-lib.aws_cloudwatch.CfnCompositeAlarm", version: "2.80.0" }, CfnCompositeAlarm.CFN_RESOURCE_TYPE_NAME = "AWS::CloudWatch::CompositeAlarm", exports2.CfnCompositeAlarm = CfnCompositeAlarm;
    function CfnDashboardPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dashboardBody", cdk.requiredValidator)(properties.dashboardBody)), errors.collect(cdk.propertyValidator("dashboardBody", cdk.validateString)(properties.dashboardBody)), errors.collect(cdk.propertyValidator("dashboardName", cdk.validateString)(properties.dashboardName)), errors.wrap('supplied properties not correct for "CfnDashboardProps"');
    }
    function cfnDashboardPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboardPropsValidator(properties).assertSuccess(), { DashboardBody: cdk.stringToCloudFormation(properties.dashboardBody), DashboardName: cdk.stringToCloudFormation(properties.dashboardName) }) : properties;
    }
    function CfnDashboardPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dashboardBody", "DashboardBody", cfn_parse.FromCloudFormation.getString(properties.DashboardBody)), ret.addPropertyResult("dashboardName", "DashboardName", properties.DashboardName != null ? cfn_parse.FromCloudFormation.getString(properties.DashboardName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDashboard = class _CfnDashboard extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDashboardPropsFromCloudFormation(resourceProperties), ret = new _CfnDashboard(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDashboard.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_CfnDashboardProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDashboard), error;
        }
        cdk.requireProperty(props, "dashboardBody", this), this.dashboardBody = props.dashboardBody, this.dashboardName = props.dashboardName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDashboard.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { dashboardBody: this.dashboardBody, dashboardName: this.dashboardName };
      }
      renderProperties(props) {
        return cfnDashboardPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnDashboard[_d] = { fqn: "aws-cdk-lib.aws_cloudwatch.CfnDashboard", version: "2.80.0" }, CfnDashboard.CFN_RESOURCE_TYPE_NAME = "AWS::CloudWatch::Dashboard", exports2.CfnDashboard = CfnDashboard;
    function CfnInsightRulePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ruleBody", cdk.requiredValidator)(properties.ruleBody)), errors.collect(cdk.propertyValidator("ruleBody", cdk.validateString)(properties.ruleBody)), errors.collect(cdk.propertyValidator("ruleName", cdk.requiredValidator)(properties.ruleName)), errors.collect(cdk.propertyValidator("ruleName", cdk.validateString)(properties.ruleName)), errors.collect(cdk.propertyValidator("ruleState", cdk.requiredValidator)(properties.ruleState)), errors.collect(cdk.propertyValidator("ruleState", cdk.validateString)(properties.ruleState)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnInsightRuleProps"');
    }
    function cfnInsightRulePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInsightRulePropsValidator(properties).assertSuccess(), { RuleBody: cdk.stringToCloudFormation(properties.ruleBody), RuleName: cdk.stringToCloudFormation(properties.ruleName), RuleState: cdk.stringToCloudFormation(properties.ruleState), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnInsightRulePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ruleBody", "RuleBody", cfn_parse.FromCloudFormation.getString(properties.RuleBody)), ret.addPropertyResult("ruleName", "RuleName", cfn_parse.FromCloudFormation.getString(properties.RuleName)), ret.addPropertyResult("ruleState", "RuleState", cfn_parse.FromCloudFormation.getString(properties.RuleState)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnInsightRule = class _CfnInsightRule extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnInsightRulePropsFromCloudFormation(resourceProperties), ret = new _CfnInsightRule(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnInsightRule.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_CfnInsightRuleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnInsightRule), error;
        }
        cdk.requireProperty(props, "ruleBody", this), cdk.requireProperty(props, "ruleName", this), cdk.requireProperty(props, "ruleState", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrRuleName = cdk.Token.asString(this.getAtt("RuleName", cdk.ResolutionTypeHint.STRING)), this.ruleBody = props.ruleBody, this.ruleName = props.ruleName, this.ruleState = props.ruleState, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::CloudWatch::InsightRule", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnInsightRule.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { ruleBody: this.ruleBody, ruleName: this.ruleName, ruleState: this.ruleState, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnInsightRulePropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnInsightRule[_e] = { fqn: "aws-cdk-lib.aws_cloudwatch.CfnInsightRule", version: "2.80.0" }, CfnInsightRule.CFN_RESOURCE_TYPE_NAME = "AWS::CloudWatch::InsightRule", exports2.CfnInsightRule = CfnInsightRule;
    function CfnMetricStreamPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("excludeFilters", cdk.listValidator(CfnMetricStream_MetricStreamFilterPropertyValidator))(properties.excludeFilters)), errors.collect(cdk.propertyValidator("firehoseArn", cdk.requiredValidator)(properties.firehoseArn)), errors.collect(cdk.propertyValidator("firehoseArn", cdk.validateString)(properties.firehoseArn)), errors.collect(cdk.propertyValidator("includeFilters", cdk.listValidator(CfnMetricStream_MetricStreamFilterPropertyValidator))(properties.includeFilters)), errors.collect(cdk.propertyValidator("includeLinkedAccountsMetrics", cdk.validateBoolean)(properties.includeLinkedAccountsMetrics)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("outputFormat", cdk.requiredValidator)(properties.outputFormat)), errors.collect(cdk.propertyValidator("outputFormat", cdk.validateString)(properties.outputFormat)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("statisticsConfigurations", cdk.listValidator(CfnMetricStream_MetricStreamStatisticsConfigurationPropertyValidator))(properties.statisticsConfigurations)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnMetricStreamProps"');
    }
    function cfnMetricStreamPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMetricStreamPropsValidator(properties).assertSuccess(), { FirehoseArn: cdk.stringToCloudFormation(properties.firehoseArn), OutputFormat: cdk.stringToCloudFormation(properties.outputFormat), RoleArn: cdk.stringToCloudFormation(properties.roleArn), ExcludeFilters: cdk.listMapper(cfnMetricStreamMetricStreamFilterPropertyToCloudFormation)(properties.excludeFilters), IncludeFilters: cdk.listMapper(cfnMetricStreamMetricStreamFilterPropertyToCloudFormation)(properties.includeFilters), IncludeLinkedAccountsMetrics: cdk.booleanToCloudFormation(properties.includeLinkedAccountsMetrics), Name: cdk.stringToCloudFormation(properties.name), StatisticsConfigurations: cdk.listMapper(cfnMetricStreamMetricStreamStatisticsConfigurationPropertyToCloudFormation)(properties.statisticsConfigurations), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnMetricStreamPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("firehoseArn", "FirehoseArn", cfn_parse.FromCloudFormation.getString(properties.FirehoseArn)), ret.addPropertyResult("outputFormat", "OutputFormat", cfn_parse.FromCloudFormation.getString(properties.OutputFormat)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("excludeFilters", "ExcludeFilters", properties.ExcludeFilters != null ? cfn_parse.FromCloudFormation.getArray(CfnMetricStreamMetricStreamFilterPropertyFromCloudFormation)(properties.ExcludeFilters) : void 0), ret.addPropertyResult("includeFilters", "IncludeFilters", properties.IncludeFilters != null ? cfn_parse.FromCloudFormation.getArray(CfnMetricStreamMetricStreamFilterPropertyFromCloudFormation)(properties.IncludeFilters) : void 0), ret.addPropertyResult("includeLinkedAccountsMetrics", "IncludeLinkedAccountsMetrics", properties.IncludeLinkedAccountsMetrics != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeLinkedAccountsMetrics) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("statisticsConfigurations", "StatisticsConfigurations", properties.StatisticsConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnMetricStreamMetricStreamStatisticsConfigurationPropertyFromCloudFormation)(properties.StatisticsConfigurations) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnMetricStream = class _CfnMetricStream extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnMetricStreamPropsFromCloudFormation(resourceProperties), ret = new _CfnMetricStream(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnMetricStream.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_CfnMetricStreamProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnMetricStream), error;
        }
        cdk.requireProperty(props, "firehoseArn", this), cdk.requireProperty(props, "outputFormat", this), cdk.requireProperty(props, "roleArn", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreationDate = cdk.Token.asString(this.getAtt("CreationDate", cdk.ResolutionTypeHint.STRING)), this.attrLastUpdateDate = cdk.Token.asString(this.getAtt("LastUpdateDate", cdk.ResolutionTypeHint.STRING)), this.attrState = cdk.Token.asString(this.getAtt("State", cdk.ResolutionTypeHint.STRING)), this.firehoseArn = props.firehoseArn, this.outputFormat = props.outputFormat, this.roleArn = props.roleArn, this.excludeFilters = props.excludeFilters, this.includeFilters = props.includeFilters, this.includeLinkedAccountsMetrics = props.includeLinkedAccountsMetrics, this.name = props.name, this.statisticsConfigurations = props.statisticsConfigurations, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::CloudWatch::MetricStream", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnMetricStream.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { firehoseArn: this.firehoseArn, outputFormat: this.outputFormat, roleArn: this.roleArn, excludeFilters: this.excludeFilters, includeFilters: this.includeFilters, includeLinkedAccountsMetrics: this.includeLinkedAccountsMetrics, name: this.name, statisticsConfigurations: this.statisticsConfigurations, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnMetricStreamPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnMetricStream[_f] = { fqn: "aws-cdk-lib.aws_cloudwatch.CfnMetricStream", version: "2.80.0" }, CfnMetricStream.CFN_RESOURCE_TYPE_NAME = "AWS::CloudWatch::MetricStream", exports2.CfnMetricStream = CfnMetricStream;
    function CfnMetricStream_MetricStreamFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("metricNames", cdk.listValidator(cdk.validateString))(properties.metricNames)), errors.collect(cdk.propertyValidator("namespace", cdk.requiredValidator)(properties.namespace)), errors.collect(cdk.propertyValidator("namespace", cdk.validateString)(properties.namespace)), errors.wrap('supplied properties not correct for "MetricStreamFilterProperty"');
    }
    function cfnMetricStreamMetricStreamFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMetricStream_MetricStreamFilterPropertyValidator(properties).assertSuccess(), { MetricNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.metricNames), Namespace: cdk.stringToCloudFormation(properties.namespace) }) : properties;
    }
    function CfnMetricStreamMetricStreamFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("metricNames", "MetricNames", properties.MetricNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.MetricNames) : void 0), ret.addPropertyResult("namespace", "Namespace", cfn_parse.FromCloudFormation.getString(properties.Namespace)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMetricStream_MetricStreamStatisticsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("additionalStatistics", cdk.requiredValidator)(properties.additionalStatistics)), errors.collect(cdk.propertyValidator("additionalStatistics", cdk.listValidator(cdk.validateString))(properties.additionalStatistics)), errors.collect(cdk.propertyValidator("includeMetrics", cdk.requiredValidator)(properties.includeMetrics)), errors.collect(cdk.propertyValidator("includeMetrics", cdk.listValidator(CfnMetricStream_MetricStreamStatisticsMetricPropertyValidator))(properties.includeMetrics)), errors.wrap('supplied properties not correct for "MetricStreamStatisticsConfigurationProperty"');
    }
    function cfnMetricStreamMetricStreamStatisticsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMetricStream_MetricStreamStatisticsConfigurationPropertyValidator(properties).assertSuccess(), { AdditionalStatistics: cdk.listMapper(cdk.stringToCloudFormation)(properties.additionalStatistics), IncludeMetrics: cdk.listMapper(cfnMetricStreamMetricStreamStatisticsMetricPropertyToCloudFormation)(properties.includeMetrics) }) : properties;
    }
    function CfnMetricStreamMetricStreamStatisticsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("additionalStatistics", "AdditionalStatistics", cfn_parse.FromCloudFormation.getStringArray(properties.AdditionalStatistics)), ret.addPropertyResult("includeMetrics", "IncludeMetrics", cfn_parse.FromCloudFormation.getArray(CfnMetricStreamMetricStreamStatisticsMetricPropertyFromCloudFormation)(properties.IncludeMetrics)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMetricStream_MetricStreamStatisticsMetricPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("metricName", cdk.requiredValidator)(properties.metricName)), errors.collect(cdk.propertyValidator("metricName", cdk.validateString)(properties.metricName)), errors.collect(cdk.propertyValidator("namespace", cdk.requiredValidator)(properties.namespace)), errors.collect(cdk.propertyValidator("namespace", cdk.validateString)(properties.namespace)), errors.wrap('supplied properties not correct for "MetricStreamStatisticsMetricProperty"');
    }
    function cfnMetricStreamMetricStreamStatisticsMetricPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMetricStream_MetricStreamStatisticsMetricPropertyValidator(properties).assertSuccess(), { MetricName: cdk.stringToCloudFormation(properties.metricName), Namespace: cdk.stringToCloudFormation(properties.namespace) }) : properties;
    }
    function CfnMetricStreamMetricStreamStatisticsMetricPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("metricName", "MetricName", cfn_parse.FromCloudFormation.getString(properties.MetricName)), ret.addPropertyResult("namespace", "Namespace", cfn_parse.FromCloudFormation.getString(properties.Namespace)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-cloudwatch/lib/private/metric-util.js
var require_metric_util = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudwatch/lib/private/metric-util.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.dispatchMetric = exports2.metricPeriod = exports2.metricKey = void 0;
    var core_1 = require_core2();
    var METRICKEY_SYMBOL = Symbol("@aws-cdk/aws-cloudwatch.MetricKey");
    function metricKey(metric) {
      if (metric.hasOwnProperty(METRICKEY_SYMBOL))
        return metric[METRICKEY_SYMBOL];
      const parts = new Array(), conf = metric.toMetricConfig();
      if (conf.mathExpression) {
        parts.push(conf.mathExpression.expression);
        for (const id of Object.keys(conf.mathExpression.usingMetrics).sort())
          parts.push(id), parts.push(metricKey(conf.mathExpression.usingMetrics[id]));
        conf.mathExpression.searchRegion && parts.push(conf.mathExpression.searchRegion), conf.mathExpression.searchAccount && parts.push(conf.mathExpression.searchAccount);
      }
      if (conf.metricStat) {
        parts.push(conf.metricStat.namespace), parts.push(conf.metricStat.metricName);
        for (const dim of conf.metricStat.dimensions || [])
          parts.push(dim.name), parts.push(dim.value);
        conf.metricStat.statistic && parts.push(conf.metricStat.statistic), conf.metricStat.period && parts.push(`${conf.metricStat.period.toSeconds()}`), conf.metricStat.region && parts.push(conf.metricStat.region), conf.metricStat.account && parts.push(conf.metricStat.account);
      }
      const ret = parts.join("|");
      return Object.defineProperty(metric, METRICKEY_SYMBOL, { value: ret }), ret;
    }
    exports2.metricKey = metricKey;
    function metricPeriod(metric) {
      return dispatchMetric(metric, { withStat(stat) {
        return stat.period;
      }, withExpression() {
        return metric.period || core_1.Duration.minutes(5);
      } });
    }
    exports2.metricPeriod = metricPeriod;
    function dispatchMetric(metric, fns) {
      const conf = metric.toMetricConfig();
      if (conf.metricStat && conf.mathExpression)
        throw new Error("Metric object must not produce both 'metricStat' and 'mathExpression'");
      if (conf.metricStat)
        return fns.withStat(conf.metricStat, conf);
      if (conf.mathExpression)
        return fns.withExpression(conf.mathExpression, conf);
      throw new Error("Metric object must have either 'metricStat' or 'mathExpression'");
    }
    exports2.dispatchMetric = dispatchMetric;
  }
});

// node_modules/aws-cdk-lib/aws-cloudwatch/lib/private/object.js
var require_object = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudwatch/lib/private/object.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.dropUndefined = void 0;
    function dropUndefined(x) {
      if (x === null)
        return x;
      const ret = {};
      for (const [key, value] of Object.entries(x))
        value !== void 0 && (ret[key] = value);
      return ret;
    }
    exports2.dropUndefined = dropUndefined;
  }
});

// node_modules/aws-cdk-lib/aws-cloudwatch/lib/private/drop-empty-object-at-the-end-of-an-array-token.js
var require_drop_empty_object_at_the_end_of_an_array_token = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudwatch/lib/private/drop-empty-object-at-the-end-of-an-array-token.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DropEmptyObjectAtTheEndOfAnArray = void 0;
    var object_1 = require_object();
    var cdk = require_core2();
    var DropEmptyObjectAtTheEndOfAnArray = class {
      constructor(value) {
        this.value = value, this.creationStack = cdk.captureStackTrace();
      }
      resolve(context) {
        return context.registerPostProcessor(this), context.resolve(this.value);
      }
      postProcess(o, _context) {
        if (!Array.isArray(o))
          return o;
        const lastEl = o[o.length - 1];
        return typeof lastEl == "object" && lastEl !== null && Object.keys((0, object_1.dropUndefined)(lastEl)).length === 0 ? o.slice(0, o.length - 1) : o;
      }
    };
    exports2.DropEmptyObjectAtTheEndOfAnArray = DropEmptyObjectAtTheEndOfAnArray;
  }
});

// node_modules/aws-cdk-lib/aws-cloudwatch/lib/private/env-tokens.js
var require_env_tokens = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudwatch/lib/private/env-tokens.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.accountIfDifferentFromStack = exports2.regionIfDifferentFromStack = void 0;
    var cdk = require_core2();
    function regionIfDifferentFromStack(region) {
      return cdk.Token.asString(new StackDependentToken(region, (stack) => stack.region));
    }
    exports2.regionIfDifferentFromStack = regionIfDifferentFromStack;
    function accountIfDifferentFromStack(account) {
      return cdk.Token.asString(new StackDependentToken(account, (stack) => stack.account));
    }
    exports2.accountIfDifferentFromStack = accountIfDifferentFromStack;
    var StackDependentToken = class {
      constructor(originalValue, fn) {
        this.originalValue = originalValue, this.fn = fn, this.creationStack = cdk.captureStackTrace();
      }
      resolve(context) {
        const stackValue = this.fn(cdk.Stack.of(context.scope));
        if (!(!cdk.Token.isUnresolved(stackValue) && stackValue === this.originalValue))
          return this.originalValue;
      }
      toString() {
        return cdk.Token.asString(this);
      }
      toJSON() {
        return this.originalValue;
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-cloudwatch/lib/private/rendering.js
var require_rendering = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudwatch/lib/private/rendering.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.MetricSet = exports2.allMetricsGraphJson = void 0;
    var drop_empty_object_at_the_end_of_an_array_token_1 = require_drop_empty_object_at_the_end_of_an_array_token();
    var env_tokens_1 = require_env_tokens();
    var metric_util_1 = require_metric_util();
    var object_1 = require_object();
    function allMetricsGraphJson(left, right) {
      const mset = new MetricSet();
      return mset.addTopLevel("left", ...left), mset.addTopLevel("right", ...right), mset.entries.map((entry) => new drop_empty_object_at_the_end_of_an_array_token_1.DropEmptyObjectAtTheEndOfAnArray(metricGraphJson(entry.metric, entry.tag, entry.id)));
    }
    exports2.allMetricsGraphJson = allMetricsGraphJson;
    function metricGraphJson(metric, yAxis, id) {
      const config = metric.toMetricConfig(), ret = [], options = { ...config.renderingProperties };
      (0, metric_util_1.dispatchMetric)(metric, { withStat(stat) {
        ret.push(stat.namespace, stat.metricName);
        for (const dim of stat.dimensions || [])
          ret.push(dim.name, dim.value);
        stat.account && (options.accountId = (0, env_tokens_1.accountIfDifferentFromStack)(stat.account)), stat.region && (options.region = (0, env_tokens_1.regionIfDifferentFromStack)(stat.region)), stat.period && stat.period.toSeconds() !== 300 && (options.period = stat.period.toSeconds()), stat.statistic && stat.statistic !== "Average" && (options.stat = stat.statistic);
      }, withExpression(expr) {
        options.expression = expr.expression, expr.searchAccount && (options.accountId = (0, env_tokens_1.accountIfDifferentFromStack)(expr.searchAccount)), expr.searchRegion && (options.region = (0, env_tokens_1.regionIfDifferentFromStack)(expr.searchRegion)), expr.period && expr.period !== 300 && (options.period = expr.period);
      } }), yAxis || (options.visible = false), yAxis !== "left" && (options.yAxis = yAxis), id && (options.id = id), options.visible !== false && options.expression && !options.label && (options.label = options.label === "" ? void 0 : metric.toString());
      const renderedOpts = (0, object_1.dropUndefined)(options);
      return Object.keys(renderedOpts).length !== 0 && ret.push(renderedOpts), ret;
    }
    var MetricSet = class {
      constructor() {
        this.metrics = new Array(), this.metricById = /* @__PURE__ */ new Map(), this.metricByKey = /* @__PURE__ */ new Map();
      }
      addTopLevel(tag, ...metrics) {
        for (const metric of metrics)
          this.addOne(metric, tag);
      }
      get entries() {
        return this.metrics;
      }
      addOne(metric, tag, id) {
        const key = (0, metric_util_1.metricKey)(metric);
        let existingEntry;
        if (id && (existingEntry = this.metricById.get(id), existingEntry && (0, metric_util_1.metricKey)(existingEntry.metric) !== key))
          throw new Error(`Cannot have two different metrics share the same id ('${id}') in one Alarm or Graph. Rename one of them.`);
        existingEntry || (existingEntry = this.metricByKey.get(key), existingEntry?.id && id && (existingEntry = void 0));
        let entry;
        existingEntry ? entry = existingEntry : (entry = { metric }, this.metrics.push(entry), this.metricByKey.set(key, entry)), !entry.id && id && (entry.id = id, this.metricById.set(id, entry)), !entry.tag && tag && (entry.tag = tag);
        const conf = metric.toMetricConfig();
        if (conf.mathExpression)
          for (const [subId, subMetric] of Object.entries(conf.mathExpression.usingMetrics))
            this.addOne(subMetric, void 0, subId);
      }
    };
    exports2.MetricSet = MetricSet;
  }
});

// node_modules/aws-cdk-lib/aws-cloudwatch/lib/stats.js
var require_stats = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudwatch/lib/stats.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Stats = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var Stats = class _Stats {
      static percentile(percentile) {
        return assertPercentage(percentile), `p${percentile}`;
      }
      static p(percentile) {
        return _Stats.percentile(percentile);
      }
      static trimmedMean(p1, p2) {
        return boundaryPercentileStat("tm", "TM", p1, p2);
      }
      static tm(p1, p2) {
        return _Stats.trimmedMean(p1, p2);
      }
      static winsorizedMean(p1, p2) {
        return boundaryPercentileStat("wm", "WM", p1, p2);
      }
      static wm(p1, p2) {
        return _Stats.winsorizedMean(p1, p2);
      }
      static trimmedCount(p1, p2) {
        return boundaryPercentileStat("tc", "TC", p1, p2);
      }
      static tc(p1, p2) {
        return _Stats.trimmedCount(p1, p2);
      }
      static trimmedSum(p1, p2) {
        return boundaryPercentileStat("ts", "TS", p1, p2);
      }
      static ts(p1, p2) {
        return _Stats.trimmedSum(p1, p2);
      }
      static percentileRank(v1, v2) {
        return v2 !== void 0 ? `PR(${v1}:${v2})` : `PR(:${v1})`;
      }
      static pr(v1, v2) {
        return this.percentileRank(v1, v2);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Stats[_a] = { fqn: "aws-cdk-lib.aws_cloudwatch.Stats", version: "2.80.0" }, Stats.SAMPLE_COUNT = "SampleCount", Stats.AVERAGE = "Average", Stats.SUM = "Sum", Stats.MINIMUM = "Minimum", Stats.MAXIMUM = "Maximum", Stats.IQM = "IQM", exports2.Stats = Stats;
    function assertPercentage(x) {
      if (x !== void 0 && (x < 0 || x > 100))
        throw new Error(`Expecting a percentage, got: ${x}`);
    }
    function boundaryPercentileStat(oneBoundaryStat, twoBoundaryStat, p1, p2) {
      return assertPercentage(p1), assertPercentage(p2), p2 !== void 0 ? `${twoBoundaryStat}(${p1}%:${p2}%)` : `${oneBoundaryStat}${p1}`;
    }
  }
});

// node_modules/aws-cdk-lib/aws-cloudwatch/lib/private/statistic.js
var require_statistic = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudwatch/lib/private/statistic.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.normalizeRawStringStatistic = exports2.normalizeStatistic = exports2.parseStatistic = exports2.pairStatisticToString = exports2.singleStatisticToString = void 0;
    var stats_1 = require_stats();
    function parseSingleStatistic(statistic, prefix) {
      const prefixLower = prefix.toLowerCase();
      if (statistic = statistic.toLowerCase(), !statistic.startsWith(prefixLower))
        return;
      const reDecimal = "\\d+(?:\\.\\d+)?", r = new RegExp(`^${prefixLower}(${reDecimal})$`).exec(statistic);
      if (!r)
        return;
      const value = parseFloat(r[1]);
      if (!(value < 0 || value > 100))
        return { type: "single", rawStatistic: statistic, statPrefix: prefixLower, value };
    }
    function parsePairStatistic(statistic, prefix) {
      const r = new RegExp(`^${prefix}\\(([^)]+)\\)$`, "i").exec(statistic);
      if (!r)
        return;
      const common = { type: "pair", canBeSingleStat: false, rawStatistic: statistic, statPrefix: prefix.toUpperCase() }, [lhs, rhs] = r[1].split(":");
      if (rhs === void 0)
        return;
      const parseNumberAndPercent = (x) => {
        if (x = x.trim(), !x)
          return [void 0, false];
        const value = parseFloat(x.replace(/%$/, "")), percent = x.endsWith("%");
        return isNaN(value) || value < 0 || percent && value > 100 ? ["fail", false] : [value, percent];
      }, [lower, lhsPercent] = parseNumberAndPercent(lhs), [upper, rhsPercent] = parseNumberAndPercent(rhs);
      if (lower === "fail" || upper === "fail" || lower === void 0 && upper === void 0 || lower !== void 0 && upper !== void 0 && lhsPercent !== rhsPercent)
        return;
      const isPercent = lhsPercent || rhsPercent, canBeSingleStat = lower === void 0 && isPercent, asSingleStatStr = canBeSingleStat ? `${prefix.toLowerCase()}${upper}` : void 0;
      return { ...common, lower, upper, isPercent, canBeSingleStat, asSingleStatStr };
    }
    function singleStatisticToString(parsed) {
      return `${parsed.statPrefix}${parsed.value}`;
    }
    exports2.singleStatisticToString = singleStatisticToString;
    function pairStatisticToString(parsed) {
      const percent = parsed.isPercent ? "%" : "", lower = parsed.lower ? `${parsed.lower}${percent}` : "", upper = parsed.upper ? `${parsed.upper}${percent}` : "";
      return `${parsed.statPrefix}(${lower}:${upper})`;
    }
    exports2.pairStatisticToString = pairStatisticToString;
    function parseStatistic(stat) {
      const lowerStat = stat.toLowerCase(), statMap = { average: stats_1.Stats.AVERAGE, avg: stats_1.Stats.AVERAGE, minimum: stats_1.Stats.MINIMUM, min: stats_1.Stats.MINIMUM, maximum: stats_1.Stats.MAXIMUM, max: stats_1.Stats.MAXIMUM, samplecount: stats_1.Stats.SAMPLE_COUNT, n: stats_1.Stats.SAMPLE_COUNT, sum: stats_1.Stats.SUM, iqm: stats_1.Stats.IQM };
      if (lowerStat in statMap)
        return { type: "simple", statistic: statMap[lowerStat] };
      let m;
      return m = parseSingleStatistic(stat, "p"), m ? { ...m, statName: "percentile" } : (m = parseSingleStatistic(stat, "tm") || parsePairStatistic(stat, "tm"), m ? { ...m, statName: "trimmedMean" } : (m = parseSingleStatistic(stat, "wm") || parsePairStatistic(stat, "wm"), m ? { ...m, statName: "winsorizedMean" } : (m = parseSingleStatistic(stat, "tc") || parsePairStatistic(stat, "tc"), m ? { ...m, statName: "trimmedCount" } : (m = parseSingleStatistic(stat, "ts") || parsePairStatistic(stat, "ts"), m ? { ...m, statName: "trimmedSum" } : { type: "generic", statistic: stat }))));
    }
    exports2.parseStatistic = parseStatistic;
    function normalizeStatistic(parsed) {
      return parsed.type === "simple" || parsed.type === "generic" ? parsed.statistic : parsed.type === "single" ? parsed.rawStatistic.toLowerCase() : parsed.type === "pair" ? parsed.rawStatistic.toUpperCase() : "";
    }
    exports2.normalizeStatistic = normalizeStatistic;
    function normalizeRawStringStatistic(stat) {
      const parsed = parseStatistic(stat);
      return normalizeStatistic(parsed);
    }
    exports2.normalizeRawStringStatistic = normalizeRawStringStatistic;
  }
});

// node_modules/aws-cdk-lib/aws-cloudwatch/lib/alarm.js
var require_alarm = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudwatch/lib/alarm.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Alarm = exports2.TreatMissingData = exports2.ComparisonOperator = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var alarm_base_1 = require_alarm_base();
    var cloudwatch_generated_1 = require_cloudwatch_generated();
    var metric_util_1 = require_metric_util();
    var object_1 = require_object();
    var rendering_1 = require_rendering();
    var statistic_1 = require_statistic();
    var core_1 = require_core2();
    var ComparisonOperator;
    (function(ComparisonOperator2) {
      ComparisonOperator2.GREATER_THAN_OR_EQUAL_TO_THRESHOLD = "GreaterThanOrEqualToThreshold", ComparisonOperator2.GREATER_THAN_THRESHOLD = "GreaterThanThreshold", ComparisonOperator2.LESS_THAN_THRESHOLD = "LessThanThreshold", ComparisonOperator2.LESS_THAN_OR_EQUAL_TO_THRESHOLD = "LessThanOrEqualToThreshold", ComparisonOperator2.LESS_THAN_LOWER_OR_GREATER_THAN_UPPER_THRESHOLD = "LessThanLowerOrGreaterThanUpperThreshold", ComparisonOperator2.GREATER_THAN_UPPER_THRESHOLD = "GreaterThanUpperThreshold", ComparisonOperator2.LESS_THAN_LOWER_THRESHOLD = "LessThanLowerThreshold";
    })(ComparisonOperator = exports2.ComparisonOperator || (exports2.ComparisonOperator = {}));
    var OPERATOR_SYMBOLS = { GreaterThanOrEqualToThreshold: ">=", GreaterThanThreshold: ">", LessThanThreshold: "<", LessThanOrEqualToThreshold: "<=" };
    var TreatMissingData;
    (function(TreatMissingData2) {
      TreatMissingData2.BREACHING = "breaching", TreatMissingData2.NOT_BREACHING = "notBreaching", TreatMissingData2.IGNORE = "ignore", TreatMissingData2.MISSING = "missing";
    })(TreatMissingData = exports2.TreatMissingData || (exports2.TreatMissingData = {}));
    var Alarm = class _Alarm extends alarm_base_1.AlarmBase {
      static fromAlarmName(scope, id, alarmName) {
        const stack = core_1.Stack.of(scope);
        return this.fromAlarmArn(scope, id, stack.formatArn({ service: "cloudwatch", resource: "alarm", resourceName: alarmName, arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME }));
      }
      static fromAlarmArn(scope, id, alarmArn) {
        class Import extends alarm_base_1.AlarmBase {
          constructor() {
            super(...arguments), this.alarmArn = alarmArn, this.alarmName = core_1.Stack.of(scope).splitArn(alarmArn, core_1.ArnFormat.COLON_RESOURCE_NAME).resourceName;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.alarmName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_AlarmProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Alarm), error;
        }
        const comparisonOperator = props.comparisonOperator || ComparisonOperator.GREATER_THAN_OR_EQUAL_TO_THRESHOLD, metricProps = this.renderMetric(props.metric);
        props.period && (metricProps.period = props.period.toSeconds()), props.statistic && Object.assign(metricProps, { statistic: renderIfSimpleStatistic(props.statistic), extendedStatistic: renderIfExtendedStatistic(props.statistic) });
        const alarm = new cloudwatch_generated_1.CfnAlarm(this, "Resource", { alarmDescription: props.alarmDescription, alarmName: this.physicalName, comparisonOperator, threshold: props.threshold, datapointsToAlarm: props.datapointsToAlarm, evaluateLowSampleCountPercentile: props.evaluateLowSampleCountPercentile, evaluationPeriods: props.evaluationPeriods, treatMissingData: props.treatMissingData, actionsEnabled: props.actionsEnabled, alarmActions: core_1.Lazy.list({ produce: () => this.alarmActionArns }), insufficientDataActions: core_1.Lazy.list({ produce: () => this.insufficientDataActionArns }), okActions: core_1.Lazy.list({ produce: () => this.okActionArns }), ...metricProps });
        this.alarmArn = this.getResourceArnAttribute(alarm.attrArn, { service: "cloudwatch", resource: "alarm", resourceName: this.physicalName, arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME }), this.alarmName = this.getResourceNameAttribute(alarm.ref), this.metric = props.metric;
        const datapoints = props.datapointsToAlarm || props.evaluationPeriods;
        this.annotation = { label: `${this.metric} ${OPERATOR_SYMBOLS[comparisonOperator]} ${props.threshold} for ${datapoints} datapoints within ${describePeriod(props.evaluationPeriods * (0, metric_util_1.metricPeriod)(props.metric).toSeconds())}`, value: props.threshold };
        for (const w of this.metric.warnings ?? [])
          core_1.Annotations.of(this).addWarning(w);
      }
      toAnnotation() {
        return this.annotation;
      }
      addAlarmAction(...actions) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_IAlarmAction(actions);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addAlarmAction), error;
        }
        this.alarmActionArns === void 0 && (this.alarmActionArns = []), this.alarmActionArns.push(...actions.map((a) => this.validateActionArn(a.bind(this, this).alarmActionArn)));
      }
      validateActionArn(actionArn) {
        if (/arn:aws[a-z0-9-]*:automate:[a-z|\d|-]+:ec2:[a-z]+/.test(actionArn)) {
          const metricConfig = this.metric.toMetricConfig();
          if (metricConfig.metricStat?.dimensions?.length != 1 || metricConfig.metricStat?.dimensions[0].name != "InstanceId")
            throw new Error(`EC2 alarm actions requires an EC2 Per-Instance Metric. (${JSON.stringify(metricConfig)} does not have an 'InstanceId' dimension)`);
        }
        return actionArn;
      }
      renderMetric(metric) {
        const self2 = this;
        return (0, metric_util_1.dispatchMetric)(metric, { withStat(stat, conf) {
          return self2.validateMetricStat(stat, metric), conf.renderingProperties?.label == null && !self2.requiresAccountId(stat) ? (0, object_1.dropUndefined)({ dimensions: stat.dimensions, namespace: stat.namespace, metricName: stat.metricName, period: stat.period?.toSeconds(), statistic: renderIfSimpleStatistic(stat.statistic), extendedStatistic: renderIfExtendedStatistic(stat.statistic), unit: stat.unitFilter }) : { metrics: [{ metricStat: { metric: { metricName: stat.metricName, namespace: stat.namespace, dimensions: stat.dimensions }, period: stat.period.toSeconds(), stat: stat.statistic, unit: stat.unitFilter }, id: "m1", accountId: self2.requiresAccountId(stat) ? stat.account : void 0, label: conf.renderingProperties?.label, returnData: true }] };
        }, withExpression() {
          const mset = new rendering_1.MetricSet();
          mset.addTopLevel(true, metric);
          let eid = 0;
          function uniqueMetricId() {
            return `expr_${++eid}`;
          }
          return { metrics: mset.entries.map((entry) => (0, metric_util_1.dispatchMetric)(entry.metric, { withStat(stat, conf) {
            return self2.validateMetricStat(stat, entry.metric), { metricStat: { metric: { metricName: stat.metricName, namespace: stat.namespace, dimensions: stat.dimensions }, period: stat.period.toSeconds(), stat: stat.statistic, unit: stat.unitFilter }, id: entry.id || uniqueMetricId(), accountId: self2.requiresAccountId(stat) ? stat.account : void 0, label: conf.renderingProperties?.label, returnData: entry.tag ? void 0 : false };
          }, withExpression(expr, conf) {
            const hasSubmetrics = mathExprHasSubmetrics(expr);
            return hasSubmetrics && assertSubmetricsCount(expr), self2.validateMetricExpression(expr), { expression: expr.expression, id: entry.id || uniqueMetricId(), label: conf.renderingProperties?.label, period: hasSubmetrics ? void 0 : expr.period, returnData: entry.tag ? void 0 : false };
          } })) };
        } });
      }
      validateMetricStat(stat, metric) {
        const stack = core_1.Stack.of(this);
        if (definitelyDifferent(stat.region, stack.region))
          throw new Error(`Cannot create an Alarm in region '${stack.region}' based on metric '${metric}' in '${stat.region}'`);
      }
      validateMetricExpression(expr) {
        if (expr.searchAccount !== void 0 || expr.searchRegion !== void 0)
          throw new Error("Cannot create an Alarm based on a MathExpression which specifies a searchAccount or searchRegion");
      }
      requiresAccountId(stat) {
        const stackAccount = core_1.Stack.of(this).account;
        return stat.account === void 0 ? false : stackAccount !== stat.account;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Alarm[_a] = { fqn: "aws-cdk-lib.aws_cloudwatch.Alarm", version: "2.80.0" }, exports2.Alarm = Alarm;
    function definitelyDifferent(x, y) {
      return x && !core_1.Token.isUnresolved(y) && x !== y;
    }
    function describePeriod(seconds) {
      return seconds === 60 ? "1 minute" : seconds === 1 ? "1 second" : seconds > 60 ? seconds / 60 + " minutes" : seconds + " seconds";
    }
    function renderIfSimpleStatistic(statistic) {
      if (statistic === void 0)
        return;
      const parsed = (0, statistic_1.parseStatistic)(statistic);
      if (parsed.type === "simple")
        return (0, statistic_1.normalizeStatistic)(parsed);
    }
    function renderIfExtendedStatistic(statistic) {
      if (statistic === void 0)
        return;
      const parsed = (0, statistic_1.parseStatistic)(statistic);
      if (parsed.type !== "simple")
        return parsed.type === "single" || parsed.type === "pair" ? (0, statistic_1.normalizeStatistic)(parsed) : parsed.statistic;
    }
    function mathExprHasSubmetrics(expr) {
      return Object.keys(expr.usingMetrics).length > 0;
    }
    function assertSubmetricsCount(expr) {
      if (Object.keys(expr.usingMetrics).length > 10)
        throw new Error("Alarms on math expressions cannot contain more than 10 individual metrics");
    }
  }
});

// node_modules/aws-cdk-lib/aws-cloudwatch/lib/alarm-action.js
var require_alarm_action = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudwatch/lib/alarm-action.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-cloudwatch/lib/alarm-rule.js
var require_alarm_rule = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudwatch/lib/alarm-rule.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AlarmRule = exports2.AlarmState = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var AlarmState;
    (function(AlarmState2) {
      AlarmState2.ALARM = "ALARM", AlarmState2.OK = "OK", AlarmState2.INSUFFICIENT_DATA = "INSUFFICIENT_DATA";
    })(AlarmState = exports2.AlarmState || (exports2.AlarmState = {}));
    var Operator;
    (function(Operator2) {
      Operator2.AND = "AND", Operator2.OR = "OR", Operator2.NOT = "NOT";
    })(Operator || (Operator = {}));
    var AlarmRule = class {
      static allOf(...operands) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_IAlarmRule(operands);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.allOf), error;
        }
        return this.concat(Operator.AND, ...operands);
      }
      static anyOf(...operands) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_IAlarmRule(operands);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.anyOf), error;
        }
        return this.concat(Operator.OR, ...operands);
      }
      static not(operand) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_IAlarmRule(operand);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.not), error;
        }
        return new class {
          renderAlarmRule() {
            return `(NOT (${operand.renderAlarmRule()}))`;
          }
        }();
      }
      static fromBoolean(value) {
        return new class {
          renderAlarmRule() {
            return `${String(value).toUpperCase()}`;
          }
        }();
      }
      static fromAlarm(alarm, alarmState) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_IAlarm(alarm), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_AlarmState(alarmState);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromAlarm), error;
        }
        return new class {
          renderAlarmRule() {
            return `${alarmState}("${alarm.alarmArn}")`;
          }
        }();
      }
      static fromString(alarmRule) {
        return new class {
          renderAlarmRule() {
            return alarmRule;
          }
        }();
      }
      static concat(operator, ...operands) {
        return new class {
          renderAlarmRule() {
            return `(${operands.map((operand) => `${operand.renderAlarmRule()}`).join(` ${operator} `)})`;
          }
        }();
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AlarmRule[_a] = { fqn: "aws-cdk-lib.aws_cloudwatch.AlarmRule", version: "2.80.0" }, exports2.AlarmRule = AlarmRule;
  }
});

// node_modules/aws-cdk-lib/aws-cloudwatch/lib/composite-alarm.js
var require_composite_alarm = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudwatch/lib/composite-alarm.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CompositeAlarm = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var alarm_base_1 = require_alarm_base();
    var cloudwatch_generated_1 = require_cloudwatch_generated();
    var core_1 = require_core2();
    var CompositeAlarm = class _CompositeAlarm extends alarm_base_1.AlarmBase {
      static fromCompositeAlarmName(scope, id, compositeAlarmName) {
        const stack = core_1.Stack.of(scope);
        return this.fromCompositeAlarmArn(scope, id, stack.formatArn({ service: "cloudwatch", resource: "alarm", resourceName: compositeAlarmName, arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME }));
      }
      static fromCompositeAlarmArn(scope, id, compositeAlarmArn) {
        class Import extends alarm_base_1.AlarmBase {
          constructor() {
            super(...arguments), this.alarmArn = compositeAlarmArn, this.alarmName = core_1.Stack.of(scope).splitArn(compositeAlarmArn, core_1.ArnFormat.COLON_RESOURCE_NAME).resourceName;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.compositeAlarmName ?? core_1.Lazy.string({ produce: () => this.generateUniqueId() }) });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_CompositeAlarmProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CompositeAlarm), error;
        }
        if (props.alarmRule.renderAlarmRule().length > 10240)
          throw new Error("Alarm Rule expression cannot be greater than 10240 characters, please reduce the conditions in the Alarm Rule");
        let extensionPeriod = props.actionsSuppressorExtensionPeriod, waitPeriod = props.actionsSuppressorWaitPeriod;
        if (props.actionsSuppressor === void 0) {
          if (extensionPeriod !== void 0 || waitPeriod !== void 0)
            throw new Error("ActionsSuppressor Extension/Wait Periods require an ActionsSuppressor to be set.");
        } else
          extensionPeriod = extensionPeriod ?? core_1.Duration.minutes(1), waitPeriod = waitPeriod ?? core_1.Duration.minutes(1);
        this.alarmRule = props.alarmRule.renderAlarmRule();
        const alarm = new cloudwatch_generated_1.CfnCompositeAlarm(this, "Resource", { alarmName: this.physicalName, alarmRule: this.alarmRule, alarmDescription: props.alarmDescription, actionsEnabled: props.actionsEnabled, alarmActions: core_1.Lazy.list({ produce: () => this.alarmActionArns }), insufficientDataActions: core_1.Lazy.list({ produce: () => this.insufficientDataActionArns }), okActions: core_1.Lazy.list({ produce: () => this.okActionArns }), actionsSuppressor: props.actionsSuppressor?.alarmArn, actionsSuppressorExtensionPeriod: extensionPeriod?.toSeconds(), actionsSuppressorWaitPeriod: waitPeriod?.toSeconds() });
        this.alarmName = this.getResourceNameAttribute(alarm.ref), this.alarmArn = this.getResourceArnAttribute(alarm.attrArn, { service: "cloudwatch", resource: "alarm", resourceName: this.physicalName, arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME });
      }
      generateUniqueId() {
        const name = core_1.Names.uniqueId(this);
        return name.length > 240 ? name.substring(0, 120) + name.substring(name.length - 120) : name;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CompositeAlarm[_a] = { fqn: "aws-cdk-lib.aws_cloudwatch.CompositeAlarm", version: "2.80.0" }, exports2.CompositeAlarm = CompositeAlarm;
  }
});

// node_modules/aws-cdk-lib/aws-cloudwatch/lib/widget.js
var require_widget = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudwatch/lib/widget.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ConcreteWidget = exports2.GRID_WIDTH = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    exports2.GRID_WIDTH = 24;
    var ConcreteWidget = class {
      constructor(width, height) {
        if (this.warnings = [], this.width = width, this.height = height, this.width > exports2.GRID_WIDTH)
          throw new Error(`Widget is too wide, max ${exports2.GRID_WIDTH} units allowed`);
      }
      position(x, y) {
        this.x = x, this.y = y;
      }
      copyMetricWarnings(...ms) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_IMetric(ms);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.copyMetricWarnings), error;
        }
        this.warnings?.push(...ms.flatMap((m) => m.warnings ?? []));
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ConcreteWidget[_a] = { fqn: "aws-cdk-lib.aws_cloudwatch.ConcreteWidget", version: "2.80.0" }, exports2.ConcreteWidget = ConcreteWidget;
  }
});

// node_modules/aws-cdk-lib/aws-cloudwatch/lib/layout.js
var require_layout = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudwatch/lib/layout.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Spacer = exports2.Column = exports2.Row = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var widget_1 = require_widget();
    var Row = class _Row {
      constructor(...widgets) {
        this.offsets = [];
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_IWidget(widgets);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Row), error;
        }
        this.widgets = widgets, this._width = 0, this._height = 0;
        let x = 0, y = 0;
        for (const widget of widgets)
          x + widget.width > widget_1.GRID_WIDTH && (y = this._height, x = 0), this.updateDimensions(x, y, widget), x += widget.width;
      }
      get width() {
        return this._width;
      }
      get height() {
        return this._height;
      }
      updateDimensions(x, y, widget) {
        this.offsets.push({ x, y }), this._width = Math.max(this.width, x + widget.width), this._height = Math.max(this.height, y + widget.height);
      }
      addWidget(w) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_IWidget(w);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addWidget), error;
        }
        this.widgets.push(w);
        let x = this.width, y = this.height;
        x + w.width > widget_1.GRID_WIDTH && (y = this.height, x = 0), this.updateDimensions(x, y, w);
      }
      position(x, y) {
        for (let i = 0; i < this.widgets.length; i++)
          this.widgets[i].position(x + this.offsets[i].x, y + this.offsets[i].y);
      }
      toJson() {
        const ret = [];
        for (const widget of this.widgets)
          ret.push(...widget.toJson());
        return ret;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Row[_a] = { fqn: "aws-cdk-lib.aws_cloudwatch.Row", version: "2.80.0" }, exports2.Row = Row;
    var Column = class _Column {
      constructor(...widgets) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_IWidget(widgets);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Column), error;
        }
        this.widgets = widgets, this._width = Math.max(...this.widgets.map((w) => w.width)), this._height = sum(...this.widgets.map((w) => w.height));
      }
      get width() {
        return this._width;
      }
      get height() {
        return this._height;
      }
      addWidget(w) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_IWidget(w);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addWidget), error;
        }
        this.widgets.push(w), this._width = Math.max(this.width, w.width), this._height += w.height;
      }
      position(x, y) {
        let widgetY = y;
        for (const widget of this.widgets)
          widget.position(x, widgetY), widgetY += widget.height;
      }
      toJson() {
        const ret = [];
        for (const widget of this.widgets)
          ret.push(...widget.toJson());
        return ret;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, Column[_b] = { fqn: "aws-cdk-lib.aws_cloudwatch.Column", version: "2.80.0" }, exports2.Column = Column;
    var Spacer = class _Spacer {
      constructor(props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_SpacerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Spacer), error;
        }
        this.width = props.width || 1, this.height = props.height || 1;
      }
      position(_x, _y) {
      }
      toJson() {
        return [];
      }
    };
    _c = JSII_RTTI_SYMBOL_1, Spacer[_c] = { fqn: "aws-cdk-lib.aws_cloudwatch.Spacer", version: "2.80.0" }, exports2.Spacer = Spacer;
    function sum(...xs) {
      let ret = 0;
      for (const x of xs)
        ret += x;
      return ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-cloudwatch/lib/dashboard.js
var require_dashboard = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudwatch/lib/dashboard.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Dashboard = exports2.PeriodOverride = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cloudwatch_generated_1 = require_cloudwatch_generated();
    var layout_1 = require_layout();
    var core_1 = require_core2();
    var PeriodOverride;
    (function(PeriodOverride2) {
      PeriodOverride2.AUTO = "auto", PeriodOverride2.INHERIT = "inherit";
    })(PeriodOverride = exports2.PeriodOverride || (exports2.PeriodOverride = {}));
    var Dashboard = class _Dashboard extends core_1.Resource {
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.dashboardName }), this.rows = [];
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_DashboardProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Dashboard), error;
        }
        {
          const { dashboardName } = props;
          if (dashboardName && !core_1.Token.isUnresolved(dashboardName) && !dashboardName.match(/^[\w-]+$/))
            throw new Error([`The value ${dashboardName} for field dashboardName contains invalid characters.`, "It can only contain alphanumerics, dash (-) and underscore (_)."].join(" "));
        }
        if (props.start !== void 0 && props.defaultInterval !== void 0)
          throw "both properties defaultInterval and start cannot be set at once";
        const dashboard = new cloudwatch_generated_1.CfnDashboard(this, "Resource", { dashboardName: this.physicalName, dashboardBody: core_1.Lazy.string({ produce: () => {
          const column = new layout_1.Column(...this.rows);
          return column.position(0, 0), core_1.Stack.of(this).toJsonString({ start: props.defaultInterval !== void 0 ? `-${props.defaultInterval?.toIsoString()}` : props.start, end: props.defaultInterval !== void 0 ? void 0 : props.end, periodOverride: props.periodOverride, widgets: column.toJson() });
        } }) });
        this.dashboardName = this.getResourceNameAttribute(dashboard.ref), (props.widgets || []).forEach((row) => {
          this.addWidgets(...row);
        }), this.dashboardArn = core_1.Stack.of(this).formatArn({ service: "cloudwatch", resource: "dashboard", region: "", resourceName: this.physicalName });
      }
      addWidgets(...widgets) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_IWidget(widgets);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addWidgets), error;
        }
        if (widgets.length === 0)
          return;
        const warnings = allWidgetsDeep(widgets).flatMap((w2) => w2.warnings ?? []);
        for (const w2 of warnings)
          core_1.Annotations.of(this).addWarning(w2);
        const w = widgets.length > 1 ? new layout_1.Row(...widgets) : widgets[0];
        this.rows.push(w);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Dashboard[_a] = { fqn: "aws-cdk-lib.aws_cloudwatch.Dashboard", version: "2.80.0" }, exports2.Dashboard = Dashboard;
    function allWidgetsDeep(ws) {
      const ret = new Array();
      return ws.forEach(recurse), ret;
      function recurse(w) {
        ret.push(w), hasSubWidgets(w) && w.widgets.forEach(recurse);
      }
    }
    function hasSubWidgets(w) {
      return "widgets" in w;
    }
  }
});

// node_modules/aws-cdk-lib/aws-cloudwatch/lib/graph.js
var require_graph = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudwatch/lib/graph.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LegendPosition = exports2.Color = exports2.Shading = exports2.CustomWidget = exports2.SingleValueWidget = exports2.GraphWidget = exports2.GaugeWidget = exports2.GraphWidgetView = exports2.AlarmWidget = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var rendering_1 = require_rendering();
    var widget_1 = require_widget();
    var cdk = require_core2();
    var AlarmWidget = class _AlarmWidget extends widget_1.ConcreteWidget {
      constructor(props) {
        super(props.width || 6, props.height || 6);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_AlarmWidgetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AlarmWidget), error;
        }
        this.props = props;
      }
      toJson() {
        return [{ type: "metric", width: this.width, height: this.height, x: this.x, y: this.y, properties: { view: "timeSeries", title: this.props.title, region: this.props.region || cdk.Aws.REGION, annotations: { alarms: [this.props.alarm.alarmArn] }, yAxis: { left: this.props.leftYAxis ?? void 0 } } }];
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AlarmWidget[_a] = { fqn: "aws-cdk-lib.aws_cloudwatch.AlarmWidget", version: "2.80.0" }, exports2.AlarmWidget = AlarmWidget;
    var GraphWidgetView;
    (function(GraphWidgetView2) {
      GraphWidgetView2.TIME_SERIES = "timeSeries", GraphWidgetView2.BAR = "bar", GraphWidgetView2.PIE = "pie";
    })(GraphWidgetView = exports2.GraphWidgetView || (exports2.GraphWidgetView = {}));
    var GaugeWidget = class _GaugeWidget extends widget_1.ConcreteWidget {
      constructor(props) {
        super(props.width || 6, props.height || 6);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_GaugeWidgetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _GaugeWidget), error;
        }
        this.props = props, this.metrics = props.metrics ?? [], this.copyMetricWarnings(...this.metrics);
      }
      addMetric(metric) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_IMetric(metric);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addMetric), error;
        }
        this.metrics.push(metric), this.copyMetricWarnings(metric);
      }
      toJson() {
        const horizontalAnnotations = [...(this.props.annotations || []).map(mapAnnotation("annotations"))], metrics = (0, rendering_1.allMetricsGraphJson)(this.metrics, []), leftYAxis = { ...this.props.leftYAxis, min: this.props.leftYAxis?.min ?? 0, max: this.props.leftYAxis?.max ?? 100 };
        return [{ type: "metric", width: this.width, height: this.height, x: this.x, y: this.y, properties: { view: "gauge", title: this.props.title, region: this.props.region || cdk.Aws.REGION, metrics: metrics.length > 0 ? metrics : void 0, annotations: horizontalAnnotations.length > 0 ? { horizontal: horizontalAnnotations } : void 0, yAxis: { left: leftYAxis ?? void 0 }, legend: this.props.legendPosition !== void 0 ? { position: this.props.legendPosition } : void 0, liveData: this.props.liveData, setPeriodToTimeRange: this.props.setPeriodToTimeRange, period: this.props.period?.toSeconds(), stat: this.props.statistic } }];
      }
    };
    _b = JSII_RTTI_SYMBOL_1, GaugeWidget[_b] = { fqn: "aws-cdk-lib.aws_cloudwatch.GaugeWidget", version: "2.80.0" }, exports2.GaugeWidget = GaugeWidget;
    var GraphWidget = class _GraphWidget extends widget_1.ConcreteWidget {
      constructor(props) {
        super(props.width || 6, props.height || 6);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_GraphWidgetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _GraphWidget), error;
        }
        this.props = props, this.leftMetrics = props.left ?? [], this.rightMetrics = props.right ?? [], this.copyMetricWarnings(...this.leftMetrics, ...this.rightMetrics);
      }
      addLeftMetric(metric) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_IMetric(metric);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addLeftMetric), error;
        }
        this.leftMetrics.push(metric), this.copyMetricWarnings(metric);
      }
      addRightMetric(metric) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_IMetric(metric);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addRightMetric), error;
        }
        this.rightMetrics.push(metric), this.copyMetricWarnings(metric);
      }
      toJson() {
        const horizontalAnnotations = [...(this.props.leftAnnotations || []).map(mapAnnotation("left")), ...(this.props.rightAnnotations || []).map(mapAnnotation("right"))], metrics = (0, rendering_1.allMetricsGraphJson)(this.leftMetrics, this.rightMetrics);
        return [{ type: "metric", width: this.width, height: this.height, x: this.x, y: this.y, properties: { view: this.props.view ?? GraphWidgetView.TIME_SERIES, title: this.props.title, region: this.props.region || cdk.Aws.REGION, stacked: this.props.stacked, metrics: metrics.length > 0 ? metrics : void 0, annotations: horizontalAnnotations.length > 0 ? { horizontal: horizontalAnnotations } : void 0, yAxis: { left: this.props.leftYAxis ?? void 0, right: this.props.rightYAxis ?? void 0 }, legend: this.props.legendPosition !== void 0 ? { position: this.props.legendPosition } : void 0, liveData: this.props.liveData, setPeriodToTimeRange: this.props.setPeriodToTimeRange, period: this.props.period?.toSeconds(), stat: this.props.statistic } }];
      }
    };
    _c = JSII_RTTI_SYMBOL_1, GraphWidget[_c] = { fqn: "aws-cdk-lib.aws_cloudwatch.GraphWidget", version: "2.80.0" }, exports2.GraphWidget = GraphWidget;
    var SingleValueWidget = class _SingleValueWidget extends widget_1.ConcreteWidget {
      constructor(props) {
        super(props.width || 6, props.height || 3);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_SingleValueWidgetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SingleValueWidget), error;
        }
        if (this.props = props, this.copyMetricWarnings(...props.metrics), props.setPeriodToTimeRange && props.sparkline)
          throw new Error("You cannot use setPeriodToTimeRange with sparkline");
      }
      toJson() {
        return [{ type: "metric", width: this.width, height: this.height, x: this.x, y: this.y, properties: { view: "singleValue", title: this.props.title, region: this.props.region || cdk.Aws.REGION, sparkline: this.props.sparkline, metrics: (0, rendering_1.allMetricsGraphJson)(this.props.metrics, []), setPeriodToTimeRange: this.props.setPeriodToTimeRange, singleValueFullPrecision: this.props.fullPrecision } }];
      }
    };
    _d = JSII_RTTI_SYMBOL_1, SingleValueWidget[_d] = { fqn: "aws-cdk-lib.aws_cloudwatch.SingleValueWidget", version: "2.80.0" }, exports2.SingleValueWidget = SingleValueWidget;
    var CustomWidget = class _CustomWidget extends widget_1.ConcreteWidget {
      constructor(props) {
        super(props.width ?? 6, props.height ?? 6);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_CustomWidgetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CustomWidget), error;
        }
        this.props = props;
      }
      toJson() {
        return [{ type: "custom", width: this.width, height: this.height, x: this.x, y: this.y, properties: { endpoint: this.props.functionArn, params: this.props.params, title: this.props.title, updateOn: { refresh: this.props.updateOnRefresh ?? true, resize: this.props.updateOnResize ?? true, timeRange: this.props.updateOnTimeRangeChange ?? true } } }];
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CustomWidget[_e] = { fqn: "aws-cdk-lib.aws_cloudwatch.CustomWidget", version: "2.80.0" }, exports2.CustomWidget = CustomWidget;
    var Shading;
    (function(Shading2) {
      Shading2.NONE = "none", Shading2.ABOVE = "above", Shading2.BELOW = "below";
    })(Shading = exports2.Shading || (exports2.Shading = {}));
    var Color = class {
      constructor() {
      }
    };
    _f = JSII_RTTI_SYMBOL_1, Color[_f] = { fqn: "aws-cdk-lib.aws_cloudwatch.Color", version: "2.80.0" }, Color.BLUE = "#1f77b4", Color.BROWN = "#8c564b", Color.GREEN = "#2ca02c", Color.GREY = "#7f7f7f", Color.ORANGE = "#ff7f0e", Color.PINK = "#e377c2", Color.PURPLE = "#9467bd", Color.RED = "#d62728", exports2.Color = Color;
    var LegendPosition;
    (function(LegendPosition2) {
      LegendPosition2.BOTTOM = "bottom", LegendPosition2.RIGHT = "right", LegendPosition2.HIDDEN = "hidden";
    })(LegendPosition = exports2.LegendPosition || (exports2.LegendPosition = {}));
    function mapAnnotation(yAxis) {
      return (a) => ({ ...a, yAxis });
    }
  }
});

// node_modules/aws-cdk-lib/aws-cloudwatch/lib/metric.js
var require_metric = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudwatch/lib/metric.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.MathExpression = exports2.Metric = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var alarm_1 = require_alarm();
    var metric_util_1 = require_metric_util();
    var statistic_1 = require_statistic();
    var stats_1 = require_stats();
    var iam = require_aws_iam();
    var cdk = require_core2();
    var Metric = class _Metric {
      static grantPutMetricData(grantee) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(grantee);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantPutMetricData), error;
        }
        return iam.Grant.addToPrincipal({ grantee, actions: ["cloudwatch:PutMetricData"], resourceArns: ["*"] });
      }
      constructor(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Metric), error;
        }
        this.period = props.period || cdk.Duration.minutes(5);
        const periodSec = this.period.toSeconds();
        if (periodSec !== 1 && periodSec !== 5 && periodSec !== 10 && periodSec !== 30 && periodSec % 60 !== 0)
          throw new Error(`'period' must be 1, 5, 10, 30, or a multiple of 60 seconds, received ${periodSec}`);
        this.warnings = void 0, this.dimensions = this.validateDimensions(props.dimensionsMap ?? props.dimensions), this.namespace = props.namespace, this.metricName = props.metricName;
        const parsedStat = (0, statistic_1.parseStatistic)(props.statistic || stats_1.Stats.AVERAGE);
        if (parsedStat.type === "generic") {
          const label = props.label ? `, label "${props.label}"` : "";
          this.warnings = [`Unrecognized statistic "${props.statistic}" for metric with namespace "${props.namespace}"${label} and metric name "${props.metricName}". Preferably use the \`aws_cloudwatch.Stats\` helper class to specify a statistic. You can ignore this warning if your statistic is valid but not yet supported by the \`aws_cloudwatch.Stats\` helper class.`];
        }
        this.statistic = (0, statistic_1.normalizeStatistic)(parsedStat), this.label = props.label, this.color = props.color, this.unit = props.unit, this.account = props.account, this.region = props.region;
      }
      with(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.with), error;
        }
        return (props.label === void 0 || props.label === this.label) && (props.color === void 0 || props.color === this.color) && (props.statistic === void 0 || props.statistic === this.statistic) && (props.unit === void 0 || props.unit === this.unit) && (props.account === void 0 || props.account === this.account) && (props.region === void 0 || props.region === this.region) && props.dimensions === void 0 && props.dimensionsMap === void 0 && (props.period === void 0 || props.period.toSeconds() === this.period.toSeconds()) ? this : new _Metric({ dimensionsMap: props.dimensionsMap ?? props.dimensions ?? this.dimensions, namespace: this.namespace, metricName: this.metricName, period: ifUndefined(props.period, this.period), statistic: ifUndefined(props.statistic, this.statistic), unit: ifUndefined(props.unit, this.unit), label: ifUndefined(props.label, this.label), color: ifUndefined(props.color, this.color), account: ifUndefined(props.account, this.account), region: ifUndefined(props.region, this.region) });
      }
      attachTo(scope) {
        const stack = cdk.Stack.of(scope);
        return this.with({ region: cdk.Token.isUnresolved(stack.region) ? void 0 : stack.region, account: cdk.Token.isUnresolved(stack.account) ? void 0 : stack.account });
      }
      toMetricConfig() {
        const dims = this.dimensionsAsList();
        return { metricStat: { dimensions: dims.length > 0 ? dims : void 0, namespace: this.namespace, metricName: this.metricName, period: this.period, statistic: this.statistic, unitFilter: this.unit, account: this.account, region: this.region }, renderingProperties: { color: this.color, label: this.label } };
      }
      toAlarmConfig() {
        const metricConfig = this.toMetricConfig();
        if (metricConfig.metricStat === void 0)
          throw new Error("Using a math expression is not supported here. Pass a 'Metric' object instead");
        const parsed = (0, statistic_1.parseStatistic)(metricConfig.metricStat.statistic);
        let extendedStatistic;
        return parsed.type === "single" ? extendedStatistic = (0, statistic_1.singleStatisticToString)(parsed) : parsed.type === "pair" && (extendedStatistic = (0, statistic_1.pairStatisticToString)(parsed)), { dimensions: metricConfig.metricStat.dimensions, namespace: metricConfig.metricStat.namespace, metricName: metricConfig.metricStat.metricName, period: metricConfig.metricStat.period.toSeconds(), statistic: parsed.type === "simple" ? parsed.statistic : void 0, extendedStatistic, unit: this.unit };
      }
      toGraphConfig() {
        const metricConfig = this.toMetricConfig();
        if (metricConfig.metricStat === void 0)
          throw new Error("Using a math expression is not supported here. Pass a 'Metric' object instead");
        return { dimensions: metricConfig.metricStat.dimensions, namespace: metricConfig.metricStat.namespace, metricName: metricConfig.metricStat.metricName, renderingProperties: { period: metricConfig.metricStat.period.toSeconds(), stat: metricConfig.metricStat.statistic, color: asString(metricConfig.renderingProperties?.color), label: asString(metricConfig.renderingProperties?.label) }, period: metricConfig.metricStat.period.toSeconds(), statistic: metricConfig.metricStat.statistic, color: asString(metricConfig.renderingProperties?.color), label: asString(metricConfig.renderingProperties?.label), unit: this.unit };
      }
      createAlarm(scope, id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_CreateAlarmOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.createAlarm), error;
        }
        return new alarm_1.Alarm(scope, id, { metric: this.with({ statistic: props.statistic, period: props.period }), alarmName: props.alarmName, alarmDescription: props.alarmDescription, comparisonOperator: props.comparisonOperator, datapointsToAlarm: props.datapointsToAlarm, threshold: props.threshold, evaluationPeriods: props.evaluationPeriods, evaluateLowSampleCountPercentile: props.evaluateLowSampleCountPercentile, treatMissingData: props.treatMissingData, actionsEnabled: props.actionsEnabled });
      }
      toString() {
        return this.label || this.metricName;
      }
      dimensionsAsList() {
        const dims = this.dimensions;
        return dims === void 0 ? [] : Object.keys(dims).sort().map((key) => ({ name: key, value: dims[key] }));
      }
      validateDimensions(dims) {
        if (!dims)
          return dims;
        var dimsArray = Object.keys(dims);
        if (dimsArray?.length > 10)
          throw new Error(`The maximum number of dimensions is 10, received ${dimsArray.length}`);
        return dimsArray.map((key) => {
          if (dims[key] === void 0 || dims[key] === null)
            throw new Error(`Dimension value of '${dims[key]}' is invalid`);
          if (key.length < 1 || key.length > 255)
            throw new Error(`Dimension name must be at least 1 and no more than 255 characters; received ${key}`);
          if (dims[key].length < 1 || dims[key].length > 255)
            throw new Error(`Dimension value must be at least 1 and no more than 255 characters; received ${dims[key]}`);
        }), dims;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Metric[_a] = { fqn: "aws-cdk-lib.aws_cloudwatch.Metric", version: "2.80.0" }, exports2.Metric = Metric;
    function asString(x) {
      if (x !== void 0) {
        if (typeof x != "string")
          throw new Error(`Expected string, got ${x}`);
        return x;
      }
    }
    var MathExpression = class _MathExpression {
      constructor(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MathExpressionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _MathExpression), error;
        }
        this.period = props.period || cdk.Duration.minutes(5), this.expression = props.expression, this.usingMetrics = changeAllPeriods(props.usingMetrics ?? {}, this.period), this.label = props.label, this.color = props.color, this.searchAccount = props.searchAccount, this.searchRegion = props.searchRegion;
        const invalidVariableNames = Object.keys(this.usingMetrics).filter((x) => !validVariableName(x));
        if (invalidVariableNames.length > 0)
          throw new Error(`Invalid variable names in expression: ${invalidVariableNames}. Must start with lowercase letter and only contain alphanumerics.`);
        this.validateNoIdConflicts();
        const missingIdentifiers = allIdentifiersInExpression(this.expression).filter((i) => !this.usingMetrics[i]), warnings = [];
        !this.expression.toUpperCase().match("\\s*SELECT|SEARCH|METRICS\\s.*") && missingIdentifiers.length > 0 && warnings.push(`Math expression '${this.expression}' references unknown identifiers: ${missingIdentifiers.join(", ")}. Please add them to the 'usingMetrics' map.`);
        for (const m of Object.values(this.usingMetrics))
          warnings.push(...m.warnings ?? []);
        warnings.length > 0 && (this.warnings = warnings);
      }
      with(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MathExpressionOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.with), error;
        }
        return (props.label === void 0 || props.label === this.label) && (props.color === void 0 || props.color === this.color) && (props.period === void 0 || props.period.toSeconds() === this.period.toSeconds()) && (props.searchAccount === void 0 || props.searchAccount === this.searchAccount) && (props.searchRegion === void 0 || props.searchRegion === this.searchRegion) ? this : new _MathExpression({ expression: this.expression, usingMetrics: this.usingMetrics, label: ifUndefined(props.label, this.label), color: ifUndefined(props.color, this.color), period: ifUndefined(props.period, this.period), searchAccount: ifUndefined(props.searchAccount, this.searchAccount), searchRegion: ifUndefined(props.searchRegion, this.searchRegion) });
      }
      toAlarmConfig() {
        throw new Error("Using a math expression is not supported here. Pass a 'Metric' object instead");
      }
      toGraphConfig() {
        throw new Error("Using a math expression is not supported here. Pass a 'Metric' object instead");
      }
      toMetricConfig() {
        return { mathExpression: { period: this.period.toSeconds(), expression: this.expression, usingMetrics: this.usingMetrics, searchAccount: this.searchAccount, searchRegion: this.searchRegion }, renderingProperties: { label: this.label, color: this.color } };
      }
      createAlarm(scope, id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_CreateAlarmOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.createAlarm), error;
        }
        return new alarm_1.Alarm(scope, id, { metric: this.with({ period: props.period }), alarmName: props.alarmName, alarmDescription: props.alarmDescription, comparisonOperator: props.comparisonOperator, datapointsToAlarm: props.datapointsToAlarm, threshold: props.threshold, evaluationPeriods: props.evaluationPeriods, evaluateLowSampleCountPercentile: props.evaluateLowSampleCountPercentile, treatMissingData: props.treatMissingData, actionsEnabled: props.actionsEnabled });
      }
      toString() {
        return this.label || this.expression;
      }
      validateNoIdConflicts() {
        const seen = /* @__PURE__ */ new Map();
        visit(this);
        function visit(metric) {
          (0, metric_util_1.dispatchMetric)(metric, { withStat() {
          }, withExpression(expr) {
            for (const [id, subMetric] of Object.entries(expr.usingMetrics)) {
              const existing = seen.get(id);
              if (existing && (0, metric_util_1.metricKey)(existing) !== (0, metric_util_1.metricKey)(subMetric))
                throw new Error(`The ID '${id}' used for two metrics in the expression: '${subMetric}' and '${existing}'. Rename one.`);
              seen.set(id, subMetric), visit(subMetric);
            }
          } });
        }
      }
    };
    _b = JSII_RTTI_SYMBOL_1, MathExpression[_b] = { fqn: "aws-cdk-lib.aws_cloudwatch.MathExpression", version: "2.80.0" }, exports2.MathExpression = MathExpression;
    var VARIABLE_PAT = "[a-z][a-zA-Z0-9_]*";
    var VALID_VARIABLE = new RegExp(`^${VARIABLE_PAT}$`);
    var FIND_VARIABLE = new RegExp(VARIABLE_PAT, "g");
    function validVariableName(x) {
      return VALID_VARIABLE.test(x);
    }
    function allIdentifiersInExpression(x) {
      return Array.from(matchAll(x, FIND_VARIABLE)).map((m) => m[0]);
    }
    function ifUndefined(x, def) {
      return x !== void 0 ? x : def;
    }
    function changeAllPeriods(metrics, period) {
      const ret = {};
      for (const [id, metric] of Object.entries(metrics))
        ret[id] = changePeriod(metric, period);
      return ret;
    }
    function changePeriod(metric, period) {
      if (isModifiableMetric(metric))
        return metric.with({ period });
      throw new Error(`Metric object should also implement 'with': ${metric}`);
    }
    function isModifiableMetric(m) {
      return typeof m == "object" && m !== null && !!m.with;
    }
    function matchAll(x, re) {
      const ret = new Array();
      let m;
      for (; m = re.exec(x); )
        ret.push(m);
      return ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-cloudwatch/lib/log-query.js
var require_log_query = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudwatch/lib/log-query.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LogQueryWidget = exports2.LogQueryVisualizationType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var widget_1 = require_widget();
    var cdk = require_core2();
    var LogQueryVisualizationType;
    (function(LogQueryVisualizationType2) {
      LogQueryVisualizationType2.TABLE = "table", LogQueryVisualizationType2.LINE = "line", LogQueryVisualizationType2.STACKEDAREA = "stackedarea", LogQueryVisualizationType2.BAR = "bar", LogQueryVisualizationType2.PIE = "pie";
    })(LogQueryVisualizationType = exports2.LogQueryVisualizationType || (exports2.LogQueryVisualizationType = {}));
    var LogQueryWidget = class _LogQueryWidget extends widget_1.ConcreteWidget {
      constructor(props) {
        super(props.width || 6, props.height || 6);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_LogQueryWidgetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _LogQueryWidget), error;
        }
        if (this.props = props, props.logGroupNames.length === 0)
          throw new Error("Specify at least one log group name.");
        if (!!props.queryString == !!props.queryLines)
          throw new Error("Specify exactly one of 'queryString' and 'queryLines'");
      }
      toJson() {
        const sources = this.props.logGroupNames.map((l) => `SOURCE '${l}'`).join(" | "), query = this.props.queryLines ? this.props.queryLines.join(`
| `) : this.props.queryString, properties = { view: this.props.view ? this.props.view : LogQueryVisualizationType.TABLE, title: this.props.title, region: this.props.region || cdk.Aws.REGION, query: `${sources} | ${query}` };
        return (this.props.view === LogQueryVisualizationType.LINE || this.props.view === LogQueryVisualizationType.STACKEDAREA) && (properties.view = "timeSeries", properties.stacked = this.props.view === LogQueryVisualizationType.STACKEDAREA), [{ type: "log", width: this.width, height: this.height, x: this.x, y: this.y, properties }];
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LogQueryWidget[_a] = { fqn: "aws-cdk-lib.aws_cloudwatch.LogQueryWidget", version: "2.80.0" }, exports2.LogQueryWidget = LogQueryWidget;
  }
});

// node_modules/aws-cdk-lib/aws-cloudwatch/lib/text.js
var require_text = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudwatch/lib/text.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.TextWidget = exports2.TextWidgetBackground = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var widget_1 = require_widget();
    var TextWidgetBackground;
    (function(TextWidgetBackground2) {
      TextWidgetBackground2.SOLID = "solid", TextWidgetBackground2.TRANSPARENT = "transparent";
    })(TextWidgetBackground = exports2.TextWidgetBackground || (exports2.TextWidgetBackground = {}));
    var TextWidget = class _TextWidget extends widget_1.ConcreteWidget {
      constructor(props) {
        super(props.width || 6, props.height || 2);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_TextWidgetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _TextWidget), error;
        }
        this.markdown = props.markdown, this.background = props.background;
      }
      position(x, y) {
        this.x = x, this.y = y;
      }
      toJson() {
        return [{ type: "text", width: this.width, height: this.height, x: this.x, y: this.y, properties: { markdown: this.markdown, background: this.background } }];
      }
    };
    _a = JSII_RTTI_SYMBOL_1, TextWidget[_a] = { fqn: "aws-cdk-lib.aws_cloudwatch.TextWidget", version: "2.80.0" }, exports2.TextWidget = TextWidget;
  }
});

// node_modules/aws-cdk-lib/aws-cloudwatch/lib/alarm-status-widget.js
var require_alarm_status_widget = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudwatch/lib/alarm-status-widget.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AlarmStatusWidget = exports2.AlarmStatusWidgetSortBy = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var widget_1 = require_widget();
    var AlarmStatusWidgetSortBy;
    (function(AlarmStatusWidgetSortBy2) {
      AlarmStatusWidgetSortBy2.DEFAULT = "default", AlarmStatusWidgetSortBy2.STATE_UPDATED_TIMESTAMP = "stateUpdatedTimestamp", AlarmStatusWidgetSortBy2.TIMESTAMP = "timestamp";
    })(AlarmStatusWidgetSortBy = exports2.AlarmStatusWidgetSortBy || (exports2.AlarmStatusWidgetSortBy = {}));
    var AlarmStatusWidget = class _AlarmStatusWidget extends widget_1.ConcreteWidget {
      constructor(props) {
        super(props.width || 6, props.height || 3);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_AlarmStatusWidgetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AlarmStatusWidget), error;
        }
        this.props = props;
      }
      position(x, y) {
        this.x = x, this.y = y;
      }
      toJson() {
        return [{ type: "alarm", width: this.width, height: this.height, x: this.x, y: this.y, properties: { title: this.props.title ? this.props.title : "Alarm Status", alarms: this.props.alarms.map((alarm) => alarm.alarmArn), states: this.props.states, sortBy: this.props.sortBy } }];
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AlarmStatusWidget[_a] = { fqn: "aws-cdk-lib.aws_cloudwatch.AlarmStatusWidget", version: "2.80.0" }, exports2.AlarmStatusWidget = AlarmStatusWidget;
  }
});

// node_modules/aws-cdk-lib/aws-cloudwatch/lib/index.js
var require_lib10 = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudwatch/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_alarm(), exports2), __exportStar(require_alarm_action(), exports2), __exportStar(require_alarm_base(), exports2), __exportStar(require_alarm_rule(), exports2), __exportStar(require_composite_alarm(), exports2), __exportStar(require_dashboard(), exports2), __exportStar(require_graph(), exports2), __exportStar(require_layout(), exports2), __exportStar(require_metric(), exports2), __exportStar(require_metric_types(), exports2), __exportStar(require_log_query(), exports2), __exportStar(require_text(), exports2), __exportStar(require_widget(), exports2), __exportStar(require_alarm_status_widget(), exports2), __exportStar(require_stats(), exports2), __exportStar(require_cloudwatch_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-cloudwatch/index.js
var require_aws_cloudwatch = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudwatch/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib10(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-codeguruprofiler/lib/codeguruprofiler.generated.js
var require_codeguruprofiler_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-codeguruprofiler/lib/codeguruprofiler.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnProfilingGroup = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnProfilingGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("agentPermissions", cdk.validateObject)(properties.agentPermissions)), errors.collect(cdk.propertyValidator("anomalyDetectionNotificationConfiguration", cdk.listValidator(CfnProfilingGroup_ChannelPropertyValidator))(properties.anomalyDetectionNotificationConfiguration)), errors.collect(cdk.propertyValidator("computePlatform", cdk.validateString)(properties.computePlatform)), errors.collect(cdk.propertyValidator("profilingGroupName", cdk.requiredValidator)(properties.profilingGroupName)), errors.collect(cdk.propertyValidator("profilingGroupName", cdk.validateString)(properties.profilingGroupName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnProfilingGroupProps"');
    }
    function cfnProfilingGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProfilingGroupPropsValidator(properties).assertSuccess(), { ProfilingGroupName: cdk.stringToCloudFormation(properties.profilingGroupName), AgentPermissions: cdk.objectToCloudFormation(properties.agentPermissions), AnomalyDetectionNotificationConfiguration: cdk.listMapper(cfnProfilingGroupChannelPropertyToCloudFormation)(properties.anomalyDetectionNotificationConfiguration), ComputePlatform: cdk.stringToCloudFormation(properties.computePlatform), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnProfilingGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("profilingGroupName", "ProfilingGroupName", cfn_parse.FromCloudFormation.getString(properties.ProfilingGroupName)), ret.addPropertyResult("agentPermissions", "AgentPermissions", properties.AgentPermissions != null ? cfn_parse.FromCloudFormation.getAny(properties.AgentPermissions) : void 0), ret.addPropertyResult("anomalyDetectionNotificationConfiguration", "AnomalyDetectionNotificationConfiguration", properties.AnomalyDetectionNotificationConfiguration != null ? cfn_parse.FromCloudFormation.getArray(CfnProfilingGroupChannelPropertyFromCloudFormation)(properties.AnomalyDetectionNotificationConfiguration) : void 0), ret.addPropertyResult("computePlatform", "ComputePlatform", properties.ComputePlatform != null ? cfn_parse.FromCloudFormation.getString(properties.ComputePlatform) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnProfilingGroup = class _CfnProfilingGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnProfilingGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnProfilingGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnProfilingGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codeguruprofiler_CfnProfilingGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnProfilingGroup), error;
        }
        cdk.requireProperty(props, "profilingGroupName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.profilingGroupName = props.profilingGroupName, this.agentPermissions = props.agentPermissions, this.anomalyDetectionNotificationConfiguration = props.anomalyDetectionNotificationConfiguration, this.computePlatform = props.computePlatform, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::CodeGuruProfiler::ProfilingGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnProfilingGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { profilingGroupName: this.profilingGroupName, agentPermissions: this.agentPermissions, anomalyDetectionNotificationConfiguration: this.anomalyDetectionNotificationConfiguration, computePlatform: this.computePlatform, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnProfilingGroupPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnProfilingGroup[_a] = { fqn: "aws-cdk-lib.aws_codeguruprofiler.CfnProfilingGroup", version: "2.80.0" }, CfnProfilingGroup.CFN_RESOURCE_TYPE_NAME = "AWS::CodeGuruProfiler::ProfilingGroup", exports2.CfnProfilingGroup = CfnProfilingGroup;
    function CfnProfilingGroup_ChannelPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("channelId", cdk.validateString)(properties.channelId)), errors.collect(cdk.propertyValidator("channelUri", cdk.requiredValidator)(properties.channelUri)), errors.collect(cdk.propertyValidator("channelUri", cdk.validateString)(properties.channelUri)), errors.wrap('supplied properties not correct for "ChannelProperty"');
    }
    function cfnProfilingGroupChannelPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProfilingGroup_ChannelPropertyValidator(properties).assertSuccess(), { channelId: cdk.stringToCloudFormation(properties.channelId), channelUri: cdk.stringToCloudFormation(properties.channelUri) }) : properties;
    }
    function CfnProfilingGroupChannelPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("channelId", "channelId", properties.channelId != null ? cfn_parse.FromCloudFormation.getString(properties.channelId) : void 0), ret.addPropertyResult("channelUri", "channelUri", cfn_parse.FromCloudFormation.getString(properties.channelUri)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-codeguruprofiler/lib/profiling-group.js
var require_profiling_group = __commonJS({
  "node_modules/aws-cdk-lib/aws-codeguruprofiler/lib/profiling-group.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ProfilingGroup = exports2.ComputePlatform = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var codeguruprofiler_generated_1 = require_codeguruprofiler_generated();
    var aws_iam_1 = require_aws_iam();
    var core_1 = require_core2();
    var ComputePlatform;
    (function(ComputePlatform2) {
      ComputePlatform2.AWS_LAMBDA = "AWSLambda", ComputePlatform2.DEFAULT = "Default";
    })(ComputePlatform = exports2.ComputePlatform || (exports2.ComputePlatform = {}));
    var ProfilingGroupBase = class extends core_1.Resource {
      grantPublish(grantee) {
        return aws_iam_1.Grant.addToPrincipal({ grantee, actions: ["codeguru-profiler:ConfigureAgent", "codeguru-profiler:PostAgentProfile"], resourceArns: [this.profilingGroupArn] });
      }
      grantRead(grantee) {
        return aws_iam_1.Grant.addToPrincipal({ grantee, actions: ["codeguru-profiler:GetProfile", "codeguru-profiler:DescribeProfilingGroup"], resourceArns: [this.profilingGroupArn] });
      }
    };
    var ProfilingGroup = class _ProfilingGroup extends ProfilingGroupBase {
      static fromProfilingGroupName(scope, id, profilingGroupName) {
        const stack = core_1.Stack.of(scope);
        return this.fromProfilingGroupArn(scope, id, stack.formatArn({ service: "codeguru-profiler", resource: "profilingGroup", resourceName: profilingGroupName }));
      }
      static fromProfilingGroupArn(scope, id, profilingGroupArn) {
        class Import extends ProfilingGroupBase {
          constructor() {
            super(...arguments), this.profilingGroupName = core_1.Stack.of(scope).splitArn(profilingGroupArn, core_1.ArnFormat.SLASH_RESOURCE_NAME).resourceName, this.profilingGroupArn = profilingGroupArn;
          }
        }
        return new Import(scope, id, { environmentFromArn: profilingGroupArn });
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.profilingGroupName ?? core_1.Lazy.string({ produce: () => this.generateUniqueId() }) });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codeguruprofiler_ProfilingGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ProfilingGroup), error;
        }
        const profilingGroup = new codeguruprofiler_generated_1.CfnProfilingGroup(this, "ProfilingGroup", { profilingGroupName: this.physicalName, computePlatform: props.computePlatform });
        this.profilingGroupName = this.getResourceNameAttribute(profilingGroup.ref), this.profilingGroupArn = this.getResourceArnAttribute(profilingGroup.attrArn, { service: "codeguru-profiler", resource: "profilingGroup", resourceName: this.physicalName });
      }
      generateUniqueId() {
        const name = core_1.Names.uniqueId(this);
        return name.length > 240 ? name.substring(0, 120) + name.substring(name.length - 120) : name;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ProfilingGroup[_a] = { fqn: "aws-cdk-lib.aws_codeguruprofiler.ProfilingGroup", version: "2.80.0" }, exports2.ProfilingGroup = ProfilingGroup;
  }
});

// node_modules/aws-cdk-lib/aws-codeguruprofiler/lib/index.js
var require_lib11 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codeguruprofiler/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_codeguruprofiler_generated(), exports2), __exportStar(require_profiling_group(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-codeguruprofiler/index.js
var require_aws_codeguruprofiler = __commonJS({
  "node_modules/aws-cdk-lib/aws-codeguruprofiler/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib11(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/ec2.generated.js
var require_ec2_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/ec2.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    var _l;
    var _m;
    var _o;
    var _p;
    var _q;
    var _r;
    var _s;
    var _t;
    var _u;
    var _v;
    var _w;
    var _x;
    var _y;
    var _z;
    var _0;
    var _1;
    var _2;
    var _3;
    var _4;
    var _5;
    var _6;
    var _7;
    var _8;
    var _9;
    var _10;
    var _11;
    var _12;
    var _13;
    var _14;
    var _15;
    var _16;
    var _17;
    var _18;
    var _19;
    var _20;
    var _21;
    var _22;
    var _23;
    var _24;
    var _25;
    var _26;
    var _27;
    var _28;
    var _29;
    var _30;
    var _31;
    var _32;
    var _33;
    var _34;
    var _35;
    var _36;
    var _37;
    var _38;
    var _39;
    var _40;
    var _41;
    var _42;
    var _43;
    var _44;
    var _45;
    var _46;
    var _47;
    var _48;
    var _49;
    var _50;
    var _51;
    var _52;
    var _53;
    var _54;
    var _55;
    var _56;
    var _57;
    var _58;
    var _59;
    var _60;
    var _61;
    var _62;
    var _63;
    var _64;
    var _65;
    var _66;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnSecurityGroupIngress = exports2.CfnSecurityGroupEgress = exports2.CfnSecurityGroup = exports2.CfnRouteTable = exports2.CfnRoute = exports2.CfnPrefixList = exports2.CfnPlacementGroup = exports2.CfnNetworkPerformanceMetricSubscription = exports2.CfnNetworkInterfacePermission = exports2.CfnNetworkInterfaceAttachment = exports2.CfnNetworkInterface = exports2.CfnNetworkInsightsPath = exports2.CfnNetworkInsightsAnalysis = exports2.CfnNetworkInsightsAccessScopeAnalysis = exports2.CfnNetworkInsightsAccessScope = exports2.CfnNetworkAclEntry = exports2.CfnNetworkAcl = exports2.CfnNatGateway = exports2.CfnLocalGatewayRouteTableVirtualInterfaceGroupAssociation = exports2.CfnLocalGatewayRouteTableVPCAssociation = exports2.CfnLocalGatewayRouteTable = exports2.CfnLocalGatewayRoute = exports2.CfnLaunchTemplate = exports2.CfnKeyPair = exports2.CfnInternetGateway = exports2.CfnInstance = exports2.CfnIPAMScope = exports2.CfnIPAMResourceDiscoveryAssociation = exports2.CfnIPAMResourceDiscovery = exports2.CfnIPAMPoolCidr = exports2.CfnIPAMPool = exports2.CfnIPAMAllocation = exports2.CfnIPAM = exports2.CfnHost = exports2.CfnGatewayRouteTableAssociation = exports2.CfnFlowLog = exports2.CfnEnclaveCertificateIamRoleAssociation = exports2.CfnEgressOnlyInternetGateway = exports2.CfnEIPAssociation = exports2.CfnEIP = exports2.CfnEC2Fleet = exports2.CfnDHCPOptions = exports2.CfnCustomerGateway = exports2.CfnClientVpnTargetNetworkAssociation = exports2.CfnClientVpnRoute = exports2.CfnClientVpnEndpoint = exports2.CfnClientVpnAuthorizationRule = exports2.CfnCarrierGateway = exports2.CfnCapacityReservationFleet = exports2.CfnCapacityReservation = void 0, exports2.CfnVolumeAttachment = exports2.CfnVolume = exports2.CfnVerifiedAccessTrustProvider = exports2.CfnVerifiedAccessInstance = exports2.CfnVerifiedAccessGroup = exports2.CfnVerifiedAccessEndpoint = exports2.CfnVPNGatewayRoutePropagation = exports2.CfnVPNGateway = exports2.CfnVPNConnectionRoute = exports2.CfnVPNConnection = exports2.CfnVPCPeeringConnection = exports2.CfnVPCGatewayAttachment = exports2.CfnVPCEndpointServicePermissions = exports2.CfnVPCEndpointService = exports2.CfnVPCEndpointConnectionNotification = exports2.CfnVPCEndpoint = exports2.CfnVPCDHCPOptionsAssociation = exports2.CfnVPCCidrBlock = exports2.CfnVPC = exports2.CfnTransitGatewayVpcAttachment = exports2.CfnTransitGatewayRouteTablePropagation = exports2.CfnTransitGatewayRouteTableAssociation = exports2.CfnTransitGatewayRouteTable = exports2.CfnTransitGatewayRoute = exports2.CfnTransitGatewayPeeringAttachment = exports2.CfnTransitGatewayMulticastGroupSource = exports2.CfnTransitGatewayMulticastGroupMember = exports2.CfnTransitGatewayMulticastDomainAssociation = exports2.CfnTransitGatewayMulticastDomain = exports2.CfnTransitGatewayConnect = exports2.CfnTransitGatewayAttachment = exports2.CfnTransitGateway = exports2.CfnTrafficMirrorTarget = exports2.CfnTrafficMirrorSession = exports2.CfnTrafficMirrorFilterRule = exports2.CfnTrafficMirrorFilter = exports2.CfnSubnetRouteTableAssociation = exports2.CfnSubnetNetworkAclAssociation = exports2.CfnSubnetCidrBlock = exports2.CfnSubnet = exports2.CfnSpotFleet = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnCapacityReservationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availabilityZone", cdk.requiredValidator)(properties.availabilityZone)), errors.collect(cdk.propertyValidator("availabilityZone", cdk.validateString)(properties.availabilityZone)), errors.collect(cdk.propertyValidator("ebsOptimized", cdk.validateBoolean)(properties.ebsOptimized)), errors.collect(cdk.propertyValidator("endDate", cdk.validateString)(properties.endDate)), errors.collect(cdk.propertyValidator("endDateType", cdk.validateString)(properties.endDateType)), errors.collect(cdk.propertyValidator("ephemeralStorage", cdk.validateBoolean)(properties.ephemeralStorage)), errors.collect(cdk.propertyValidator("instanceCount", cdk.requiredValidator)(properties.instanceCount)), errors.collect(cdk.propertyValidator("instanceCount", cdk.validateNumber)(properties.instanceCount)), errors.collect(cdk.propertyValidator("instanceMatchCriteria", cdk.validateString)(properties.instanceMatchCriteria)), errors.collect(cdk.propertyValidator("instancePlatform", cdk.requiredValidator)(properties.instancePlatform)), errors.collect(cdk.propertyValidator("instancePlatform", cdk.validateString)(properties.instancePlatform)), errors.collect(cdk.propertyValidator("instanceType", cdk.requiredValidator)(properties.instanceType)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("outPostArn", cdk.validateString)(properties.outPostArn)), errors.collect(cdk.propertyValidator("placementGroupArn", cdk.validateString)(properties.placementGroupArn)), errors.collect(cdk.propertyValidator("tagSpecifications", cdk.listValidator(CfnCapacityReservation_TagSpecificationPropertyValidator))(properties.tagSpecifications)), errors.collect(cdk.propertyValidator("tenancy", cdk.validateString)(properties.tenancy)), errors.wrap('supplied properties not correct for "CfnCapacityReservationProps"');
    }
    function cfnCapacityReservationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCapacityReservationPropsValidator(properties).assertSuccess(), { AvailabilityZone: cdk.stringToCloudFormation(properties.availabilityZone), InstanceCount: cdk.numberToCloudFormation(properties.instanceCount), InstancePlatform: cdk.stringToCloudFormation(properties.instancePlatform), InstanceType: cdk.stringToCloudFormation(properties.instanceType), EbsOptimized: cdk.booleanToCloudFormation(properties.ebsOptimized), EndDate: cdk.stringToCloudFormation(properties.endDate), EndDateType: cdk.stringToCloudFormation(properties.endDateType), EphemeralStorage: cdk.booleanToCloudFormation(properties.ephemeralStorage), InstanceMatchCriteria: cdk.stringToCloudFormation(properties.instanceMatchCriteria), OutPostArn: cdk.stringToCloudFormation(properties.outPostArn), PlacementGroupArn: cdk.stringToCloudFormation(properties.placementGroupArn), TagSpecifications: cdk.listMapper(cfnCapacityReservationTagSpecificationPropertyToCloudFormation)(properties.tagSpecifications), Tenancy: cdk.stringToCloudFormation(properties.tenancy) }) : properties;
    }
    function CfnCapacityReservationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("availabilityZone", "AvailabilityZone", cfn_parse.FromCloudFormation.getString(properties.AvailabilityZone)), ret.addPropertyResult("instanceCount", "InstanceCount", cfn_parse.FromCloudFormation.getNumber(properties.InstanceCount)), ret.addPropertyResult("instancePlatform", "InstancePlatform", cfn_parse.FromCloudFormation.getString(properties.InstancePlatform)), ret.addPropertyResult("instanceType", "InstanceType", cfn_parse.FromCloudFormation.getString(properties.InstanceType)), ret.addPropertyResult("ebsOptimized", "EbsOptimized", properties.EbsOptimized != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EbsOptimized) : void 0), ret.addPropertyResult("endDate", "EndDate", properties.EndDate != null ? cfn_parse.FromCloudFormation.getString(properties.EndDate) : void 0), ret.addPropertyResult("endDateType", "EndDateType", properties.EndDateType != null ? cfn_parse.FromCloudFormation.getString(properties.EndDateType) : void 0), ret.addPropertyResult("ephemeralStorage", "EphemeralStorage", properties.EphemeralStorage != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EphemeralStorage) : void 0), ret.addPropertyResult("instanceMatchCriteria", "InstanceMatchCriteria", properties.InstanceMatchCriteria != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceMatchCriteria) : void 0), ret.addPropertyResult("outPostArn", "OutPostArn", properties.OutPostArn != null ? cfn_parse.FromCloudFormation.getString(properties.OutPostArn) : void 0), ret.addPropertyResult("placementGroupArn", "PlacementGroupArn", properties.PlacementGroupArn != null ? cfn_parse.FromCloudFormation.getString(properties.PlacementGroupArn) : void 0), ret.addPropertyResult("tagSpecifications", "TagSpecifications", properties.TagSpecifications != null ? cfn_parse.FromCloudFormation.getArray(CfnCapacityReservationTagSpecificationPropertyFromCloudFormation)(properties.TagSpecifications) : void 0), ret.addPropertyResult("tenancy", "Tenancy", properties.Tenancy != null ? cfn_parse.FromCloudFormation.getString(properties.Tenancy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCapacityReservation = class _CfnCapacityReservation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCapacityReservationPropsFromCloudFormation(resourceProperties), ret = new _CfnCapacityReservation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCapacityReservation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnCapacityReservationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCapacityReservation), error;
        }
        cdk.requireProperty(props, "availabilityZone", this), cdk.requireProperty(props, "instanceCount", this), cdk.requireProperty(props, "instancePlatform", this), cdk.requireProperty(props, "instanceType", this), this.attrAvailabilityZone = cdk.Token.asString(this.getAtt("AvailabilityZone", cdk.ResolutionTypeHint.STRING)), this.attrAvailableInstanceCount = cdk.Token.asNumber(this.getAtt("AvailableInstanceCount", cdk.ResolutionTypeHint.NUMBER)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrInstanceType = cdk.Token.asString(this.getAtt("InstanceType", cdk.ResolutionTypeHint.STRING)), this.attrTenancy = cdk.Token.asString(this.getAtt("Tenancy", cdk.ResolutionTypeHint.STRING)), this.attrTotalInstanceCount = cdk.Token.asNumber(this.getAtt("TotalInstanceCount", cdk.ResolutionTypeHint.NUMBER)), this.availabilityZone = props.availabilityZone, this.instanceCount = props.instanceCount, this.instancePlatform = props.instancePlatform, this.instanceType = props.instanceType, this.ebsOptimized = props.ebsOptimized, this.endDate = props.endDate, this.endDateType = props.endDateType, this.ephemeralStorage = props.ephemeralStorage, this.instanceMatchCriteria = props.instanceMatchCriteria, this.outPostArn = props.outPostArn, this.placementGroupArn = props.placementGroupArn, this.tagSpecifications = props.tagSpecifications, this.tenancy = props.tenancy;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCapacityReservation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { availabilityZone: this.availabilityZone, instanceCount: this.instanceCount, instancePlatform: this.instancePlatform, instanceType: this.instanceType, ebsOptimized: this.ebsOptimized, endDate: this.endDate, endDateType: this.endDateType, ephemeralStorage: this.ephemeralStorage, instanceMatchCriteria: this.instanceMatchCriteria, outPostArn: this.outPostArn, placementGroupArn: this.placementGroupArn, tagSpecifications: this.tagSpecifications, tenancy: this.tenancy };
      }
      renderProperties(props) {
        return cfnCapacityReservationPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnCapacityReservation[_a] = { fqn: "aws-cdk-lib.aws_ec2.CfnCapacityReservation", version: "2.80.0" }, CfnCapacityReservation.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::CapacityReservation", exports2.CfnCapacityReservation = CfnCapacityReservation;
    function CfnCapacityReservation_TagSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceType", cdk.validateString)(properties.resourceType)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "TagSpecificationProperty"');
    }
    function cfnCapacityReservationTagSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCapacityReservation_TagSpecificationPropertyValidator(properties).assertSuccess(), { ResourceType: cdk.stringToCloudFormation(properties.resourceType), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnCapacityReservationTagSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceType", "ResourceType", properties.ResourceType != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceType) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCapacityReservationFleetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allocationStrategy", cdk.validateString)(properties.allocationStrategy)), errors.collect(cdk.propertyValidator("endDate", cdk.validateString)(properties.endDate)), errors.collect(cdk.propertyValidator("instanceMatchCriteria", cdk.validateString)(properties.instanceMatchCriteria)), errors.collect(cdk.propertyValidator("instanceTypeSpecifications", cdk.listValidator(CfnCapacityReservationFleet_InstanceTypeSpecificationPropertyValidator))(properties.instanceTypeSpecifications)), errors.collect(cdk.propertyValidator("noRemoveEndDate", cdk.validateBoolean)(properties.noRemoveEndDate)), errors.collect(cdk.propertyValidator("removeEndDate", cdk.validateBoolean)(properties.removeEndDate)), errors.collect(cdk.propertyValidator("tagSpecifications", cdk.listValidator(CfnCapacityReservationFleet_TagSpecificationPropertyValidator))(properties.tagSpecifications)), errors.collect(cdk.propertyValidator("tenancy", cdk.validateString)(properties.tenancy)), errors.collect(cdk.propertyValidator("totalTargetCapacity", cdk.validateNumber)(properties.totalTargetCapacity)), errors.wrap('supplied properties not correct for "CfnCapacityReservationFleetProps"');
    }
    function cfnCapacityReservationFleetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCapacityReservationFleetPropsValidator(properties).assertSuccess(), { AllocationStrategy: cdk.stringToCloudFormation(properties.allocationStrategy), EndDate: cdk.stringToCloudFormation(properties.endDate), InstanceMatchCriteria: cdk.stringToCloudFormation(properties.instanceMatchCriteria), InstanceTypeSpecifications: cdk.listMapper(cfnCapacityReservationFleetInstanceTypeSpecificationPropertyToCloudFormation)(properties.instanceTypeSpecifications), NoRemoveEndDate: cdk.booleanToCloudFormation(properties.noRemoveEndDate), RemoveEndDate: cdk.booleanToCloudFormation(properties.removeEndDate), TagSpecifications: cdk.listMapper(cfnCapacityReservationFleetTagSpecificationPropertyToCloudFormation)(properties.tagSpecifications), Tenancy: cdk.stringToCloudFormation(properties.tenancy), TotalTargetCapacity: cdk.numberToCloudFormation(properties.totalTargetCapacity) }) : properties;
    }
    function CfnCapacityReservationFleetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allocationStrategy", "AllocationStrategy", properties.AllocationStrategy != null ? cfn_parse.FromCloudFormation.getString(properties.AllocationStrategy) : void 0), ret.addPropertyResult("endDate", "EndDate", properties.EndDate != null ? cfn_parse.FromCloudFormation.getString(properties.EndDate) : void 0), ret.addPropertyResult("instanceMatchCriteria", "InstanceMatchCriteria", properties.InstanceMatchCriteria != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceMatchCriteria) : void 0), ret.addPropertyResult("instanceTypeSpecifications", "InstanceTypeSpecifications", properties.InstanceTypeSpecifications != null ? cfn_parse.FromCloudFormation.getArray(CfnCapacityReservationFleetInstanceTypeSpecificationPropertyFromCloudFormation)(properties.InstanceTypeSpecifications) : void 0), ret.addPropertyResult("noRemoveEndDate", "NoRemoveEndDate", properties.NoRemoveEndDate != null ? cfn_parse.FromCloudFormation.getBoolean(properties.NoRemoveEndDate) : void 0), ret.addPropertyResult("removeEndDate", "RemoveEndDate", properties.RemoveEndDate != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RemoveEndDate) : void 0), ret.addPropertyResult("tagSpecifications", "TagSpecifications", properties.TagSpecifications != null ? cfn_parse.FromCloudFormation.getArray(CfnCapacityReservationFleetTagSpecificationPropertyFromCloudFormation)(properties.TagSpecifications) : void 0), ret.addPropertyResult("tenancy", "Tenancy", properties.Tenancy != null ? cfn_parse.FromCloudFormation.getString(properties.Tenancy) : void 0), ret.addPropertyResult("totalTargetCapacity", "TotalTargetCapacity", properties.TotalTargetCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.TotalTargetCapacity) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCapacityReservationFleet = class _CfnCapacityReservationFleet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCapacityReservationFleetPropsFromCloudFormation(resourceProperties), ret = new _CfnCapacityReservationFleet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnCapacityReservationFleet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnCapacityReservationFleetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCapacityReservationFleet), error;
        }
        this.attrCapacityReservationFleetId = cdk.Token.asString(this.getAtt("CapacityReservationFleetId", cdk.ResolutionTypeHint.STRING)), this.allocationStrategy = props.allocationStrategy, this.endDate = props.endDate, this.instanceMatchCriteria = props.instanceMatchCriteria, this.instanceTypeSpecifications = props.instanceTypeSpecifications, this.noRemoveEndDate = props.noRemoveEndDate, this.removeEndDate = props.removeEndDate, this.tagSpecifications = props.tagSpecifications, this.tenancy = props.tenancy, this.totalTargetCapacity = props.totalTargetCapacity;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCapacityReservationFleet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { allocationStrategy: this.allocationStrategy, endDate: this.endDate, instanceMatchCriteria: this.instanceMatchCriteria, instanceTypeSpecifications: this.instanceTypeSpecifications, noRemoveEndDate: this.noRemoveEndDate, removeEndDate: this.removeEndDate, tagSpecifications: this.tagSpecifications, tenancy: this.tenancy, totalTargetCapacity: this.totalTargetCapacity };
      }
      renderProperties(props) {
        return cfnCapacityReservationFleetPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnCapacityReservationFleet[_b] = { fqn: "aws-cdk-lib.aws_ec2.CfnCapacityReservationFleet", version: "2.80.0" }, CfnCapacityReservationFleet.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::CapacityReservationFleet", exports2.CfnCapacityReservationFleet = CfnCapacityReservationFleet;
    function CfnCapacityReservationFleet_InstanceTypeSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availabilityZone", cdk.validateString)(properties.availabilityZone)), errors.collect(cdk.propertyValidator("availabilityZoneId", cdk.validateString)(properties.availabilityZoneId)), errors.collect(cdk.propertyValidator("ebsOptimized", cdk.validateBoolean)(properties.ebsOptimized)), errors.collect(cdk.propertyValidator("instancePlatform", cdk.validateString)(properties.instancePlatform)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("priority", cdk.validateNumber)(properties.priority)), errors.collect(cdk.propertyValidator("weight", cdk.validateNumber)(properties.weight)), errors.wrap('supplied properties not correct for "InstanceTypeSpecificationProperty"');
    }
    function cfnCapacityReservationFleetInstanceTypeSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCapacityReservationFleet_InstanceTypeSpecificationPropertyValidator(properties).assertSuccess(), { AvailabilityZone: cdk.stringToCloudFormation(properties.availabilityZone), AvailabilityZoneId: cdk.stringToCloudFormation(properties.availabilityZoneId), EbsOptimized: cdk.booleanToCloudFormation(properties.ebsOptimized), InstancePlatform: cdk.stringToCloudFormation(properties.instancePlatform), InstanceType: cdk.stringToCloudFormation(properties.instanceType), Priority: cdk.numberToCloudFormation(properties.priority), Weight: cdk.numberToCloudFormation(properties.weight) }) : properties;
    }
    function CfnCapacityReservationFleetInstanceTypeSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("availabilityZone", "AvailabilityZone", properties.AvailabilityZone != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityZone) : void 0), ret.addPropertyResult("availabilityZoneId", "AvailabilityZoneId", properties.AvailabilityZoneId != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityZoneId) : void 0), ret.addPropertyResult("ebsOptimized", "EbsOptimized", properties.EbsOptimized != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EbsOptimized) : void 0), ret.addPropertyResult("instancePlatform", "InstancePlatform", properties.InstancePlatform != null ? cfn_parse.FromCloudFormation.getString(properties.InstancePlatform) : void 0), ret.addPropertyResult("instanceType", "InstanceType", properties.InstanceType != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceType) : void 0), ret.addPropertyResult("priority", "Priority", properties.Priority != null ? cfn_parse.FromCloudFormation.getNumber(properties.Priority) : void 0), ret.addPropertyResult("weight", "Weight", properties.Weight != null ? cfn_parse.FromCloudFormation.getNumber(properties.Weight) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCapacityReservationFleet_TagSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceType", cdk.validateString)(properties.resourceType)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "TagSpecificationProperty"');
    }
    function cfnCapacityReservationFleetTagSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCapacityReservationFleet_TagSpecificationPropertyValidator(properties).assertSuccess(), { ResourceType: cdk.stringToCloudFormation(properties.resourceType), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnCapacityReservationFleetTagSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceType", "ResourceType", properties.ResourceType != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceType) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCarrierGatewayPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpcId", cdk.requiredValidator)(properties.vpcId)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "CfnCarrierGatewayProps"');
    }
    function cfnCarrierGatewayPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCarrierGatewayPropsValidator(properties).assertSuccess(), { VpcId: cdk.stringToCloudFormation(properties.vpcId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnCarrierGatewayPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("vpcId", "VpcId", cfn_parse.FromCloudFormation.getString(properties.VpcId)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCarrierGateway = class _CfnCarrierGateway extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCarrierGatewayPropsFromCloudFormation(resourceProperties), ret = new _CfnCarrierGateway(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCarrierGateway.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnCarrierGatewayProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCarrierGateway), error;
        }
        cdk.requireProperty(props, "vpcId", this), this.attrCarrierGatewayId = cdk.Token.asString(this.getAtt("CarrierGatewayId", cdk.ResolutionTypeHint.STRING)), this.attrOwnerId = cdk.Token.asString(this.getAtt("OwnerId", cdk.ResolutionTypeHint.STRING)), this.attrState = cdk.Token.asString(this.getAtt("State", cdk.ResolutionTypeHint.STRING)), this.vpcId = props.vpcId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::CarrierGateway", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCarrierGateway.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { vpcId: this.vpcId, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnCarrierGatewayPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnCarrierGateway[_c] = { fqn: "aws-cdk-lib.aws_ec2.CfnCarrierGateway", version: "2.80.0" }, CfnCarrierGateway.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::CarrierGateway", exports2.CfnCarrierGateway = CfnCarrierGateway;
    function CfnClientVpnAuthorizationRulePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessGroupId", cdk.validateString)(properties.accessGroupId)), errors.collect(cdk.propertyValidator("authorizeAllGroups", cdk.validateBoolean)(properties.authorizeAllGroups)), errors.collect(cdk.propertyValidator("clientVpnEndpointId", cdk.requiredValidator)(properties.clientVpnEndpointId)), errors.collect(cdk.propertyValidator("clientVpnEndpointId", cdk.validateString)(properties.clientVpnEndpointId)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("targetNetworkCidr", cdk.requiredValidator)(properties.targetNetworkCidr)), errors.collect(cdk.propertyValidator("targetNetworkCidr", cdk.validateString)(properties.targetNetworkCidr)), errors.wrap('supplied properties not correct for "CfnClientVpnAuthorizationRuleProps"');
    }
    function cfnClientVpnAuthorizationRulePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClientVpnAuthorizationRulePropsValidator(properties).assertSuccess(), { ClientVpnEndpointId: cdk.stringToCloudFormation(properties.clientVpnEndpointId), TargetNetworkCidr: cdk.stringToCloudFormation(properties.targetNetworkCidr), AccessGroupId: cdk.stringToCloudFormation(properties.accessGroupId), AuthorizeAllGroups: cdk.booleanToCloudFormation(properties.authorizeAllGroups), Description: cdk.stringToCloudFormation(properties.description) }) : properties;
    }
    function CfnClientVpnAuthorizationRulePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clientVpnEndpointId", "ClientVpnEndpointId", cfn_parse.FromCloudFormation.getString(properties.ClientVpnEndpointId)), ret.addPropertyResult("targetNetworkCidr", "TargetNetworkCidr", cfn_parse.FromCloudFormation.getString(properties.TargetNetworkCidr)), ret.addPropertyResult("accessGroupId", "AccessGroupId", properties.AccessGroupId != null ? cfn_parse.FromCloudFormation.getString(properties.AccessGroupId) : void 0), ret.addPropertyResult("authorizeAllGroups", "AuthorizeAllGroups", properties.AuthorizeAllGroups != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AuthorizeAllGroups) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnClientVpnAuthorizationRule = class _CfnClientVpnAuthorizationRule extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnClientVpnAuthorizationRulePropsFromCloudFormation(resourceProperties), ret = new _CfnClientVpnAuthorizationRule(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnClientVpnAuthorizationRule.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnClientVpnAuthorizationRuleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnClientVpnAuthorizationRule), error;
        }
        cdk.requireProperty(props, "clientVpnEndpointId", this), cdk.requireProperty(props, "targetNetworkCidr", this), this.clientVpnEndpointId = props.clientVpnEndpointId, this.targetNetworkCidr = props.targetNetworkCidr, this.accessGroupId = props.accessGroupId, this.authorizeAllGroups = props.authorizeAllGroups, this.description = props.description;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnClientVpnAuthorizationRule.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { clientVpnEndpointId: this.clientVpnEndpointId, targetNetworkCidr: this.targetNetworkCidr, accessGroupId: this.accessGroupId, authorizeAllGroups: this.authorizeAllGroups, description: this.description };
      }
      renderProperties(props) {
        return cfnClientVpnAuthorizationRulePropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnClientVpnAuthorizationRule[_d] = { fqn: "aws-cdk-lib.aws_ec2.CfnClientVpnAuthorizationRule", version: "2.80.0" }, CfnClientVpnAuthorizationRule.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::ClientVpnAuthorizationRule", exports2.CfnClientVpnAuthorizationRule = CfnClientVpnAuthorizationRule;
    function CfnClientVpnEndpointPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authenticationOptions", cdk.requiredValidator)(properties.authenticationOptions)), errors.collect(cdk.propertyValidator("authenticationOptions", cdk.listValidator(CfnClientVpnEndpoint_ClientAuthenticationRequestPropertyValidator))(properties.authenticationOptions)), errors.collect(cdk.propertyValidator("clientCidrBlock", cdk.requiredValidator)(properties.clientCidrBlock)), errors.collect(cdk.propertyValidator("clientCidrBlock", cdk.validateString)(properties.clientCidrBlock)), errors.collect(cdk.propertyValidator("clientConnectOptions", CfnClientVpnEndpoint_ClientConnectOptionsPropertyValidator)(properties.clientConnectOptions)), errors.collect(cdk.propertyValidator("clientLoginBannerOptions", CfnClientVpnEndpoint_ClientLoginBannerOptionsPropertyValidator)(properties.clientLoginBannerOptions)), errors.collect(cdk.propertyValidator("connectionLogOptions", cdk.requiredValidator)(properties.connectionLogOptions)), errors.collect(cdk.propertyValidator("connectionLogOptions", CfnClientVpnEndpoint_ConnectionLogOptionsPropertyValidator)(properties.connectionLogOptions)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("dnsServers", cdk.listValidator(cdk.validateString))(properties.dnsServers)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("selfServicePortal", cdk.validateString)(properties.selfServicePortal)), errors.collect(cdk.propertyValidator("serverCertificateArn", cdk.requiredValidator)(properties.serverCertificateArn)), errors.collect(cdk.propertyValidator("serverCertificateArn", cdk.validateString)(properties.serverCertificateArn)), errors.collect(cdk.propertyValidator("sessionTimeoutHours", cdk.validateNumber)(properties.sessionTimeoutHours)), errors.collect(cdk.propertyValidator("splitTunnel", cdk.validateBoolean)(properties.splitTunnel)), errors.collect(cdk.propertyValidator("tagSpecifications", cdk.listValidator(CfnClientVpnEndpoint_TagSpecificationPropertyValidator))(properties.tagSpecifications)), errors.collect(cdk.propertyValidator("transportProtocol", cdk.validateString)(properties.transportProtocol)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.collect(cdk.propertyValidator("vpnPort", cdk.validateNumber)(properties.vpnPort)), errors.wrap('supplied properties not correct for "CfnClientVpnEndpointProps"');
    }
    function cfnClientVpnEndpointPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClientVpnEndpointPropsValidator(properties).assertSuccess(), { AuthenticationOptions: cdk.listMapper(cfnClientVpnEndpointClientAuthenticationRequestPropertyToCloudFormation)(properties.authenticationOptions), ClientCidrBlock: cdk.stringToCloudFormation(properties.clientCidrBlock), ConnectionLogOptions: cfnClientVpnEndpointConnectionLogOptionsPropertyToCloudFormation(properties.connectionLogOptions), ServerCertificateArn: cdk.stringToCloudFormation(properties.serverCertificateArn), ClientConnectOptions: cfnClientVpnEndpointClientConnectOptionsPropertyToCloudFormation(properties.clientConnectOptions), ClientLoginBannerOptions: cfnClientVpnEndpointClientLoginBannerOptionsPropertyToCloudFormation(properties.clientLoginBannerOptions), Description: cdk.stringToCloudFormation(properties.description), DnsServers: cdk.listMapper(cdk.stringToCloudFormation)(properties.dnsServers), SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SelfServicePortal: cdk.stringToCloudFormation(properties.selfServicePortal), SessionTimeoutHours: cdk.numberToCloudFormation(properties.sessionTimeoutHours), SplitTunnel: cdk.booleanToCloudFormation(properties.splitTunnel), TagSpecifications: cdk.listMapper(cfnClientVpnEndpointTagSpecificationPropertyToCloudFormation)(properties.tagSpecifications), TransportProtocol: cdk.stringToCloudFormation(properties.transportProtocol), VpcId: cdk.stringToCloudFormation(properties.vpcId), VpnPort: cdk.numberToCloudFormation(properties.vpnPort) }) : properties;
    }
    function CfnClientVpnEndpointPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authenticationOptions", "AuthenticationOptions", cfn_parse.FromCloudFormation.getArray(CfnClientVpnEndpointClientAuthenticationRequestPropertyFromCloudFormation)(properties.AuthenticationOptions)), ret.addPropertyResult("clientCidrBlock", "ClientCidrBlock", cfn_parse.FromCloudFormation.getString(properties.ClientCidrBlock)), ret.addPropertyResult("connectionLogOptions", "ConnectionLogOptions", CfnClientVpnEndpointConnectionLogOptionsPropertyFromCloudFormation(properties.ConnectionLogOptions)), ret.addPropertyResult("serverCertificateArn", "ServerCertificateArn", cfn_parse.FromCloudFormation.getString(properties.ServerCertificateArn)), ret.addPropertyResult("clientConnectOptions", "ClientConnectOptions", properties.ClientConnectOptions != null ? CfnClientVpnEndpointClientConnectOptionsPropertyFromCloudFormation(properties.ClientConnectOptions) : void 0), ret.addPropertyResult("clientLoginBannerOptions", "ClientLoginBannerOptions", properties.ClientLoginBannerOptions != null ? CfnClientVpnEndpointClientLoginBannerOptionsPropertyFromCloudFormation(properties.ClientLoginBannerOptions) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("dnsServers", "DnsServers", properties.DnsServers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.DnsServers) : void 0), ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("selfServicePortal", "SelfServicePortal", properties.SelfServicePortal != null ? cfn_parse.FromCloudFormation.getString(properties.SelfServicePortal) : void 0), ret.addPropertyResult("sessionTimeoutHours", "SessionTimeoutHours", properties.SessionTimeoutHours != null ? cfn_parse.FromCloudFormation.getNumber(properties.SessionTimeoutHours) : void 0), ret.addPropertyResult("splitTunnel", "SplitTunnel", properties.SplitTunnel != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SplitTunnel) : void 0), ret.addPropertyResult("tagSpecifications", "TagSpecifications", properties.TagSpecifications != null ? cfn_parse.FromCloudFormation.getArray(CfnClientVpnEndpointTagSpecificationPropertyFromCloudFormation)(properties.TagSpecifications) : void 0), ret.addPropertyResult("transportProtocol", "TransportProtocol", properties.TransportProtocol != null ? cfn_parse.FromCloudFormation.getString(properties.TransportProtocol) : void 0), ret.addPropertyResult("vpcId", "VpcId", properties.VpcId != null ? cfn_parse.FromCloudFormation.getString(properties.VpcId) : void 0), ret.addPropertyResult("vpnPort", "VpnPort", properties.VpnPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.VpnPort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnClientVpnEndpoint = class _CfnClientVpnEndpoint extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnClientVpnEndpointPropsFromCloudFormation(resourceProperties), ret = new _CfnClientVpnEndpoint(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnClientVpnEndpoint.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnClientVpnEndpointProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnClientVpnEndpoint), error;
        }
        cdk.requireProperty(props, "authenticationOptions", this), cdk.requireProperty(props, "clientCidrBlock", this), cdk.requireProperty(props, "connectionLogOptions", this), cdk.requireProperty(props, "serverCertificateArn", this), this.authenticationOptions = props.authenticationOptions, this.clientCidrBlock = props.clientCidrBlock, this.connectionLogOptions = props.connectionLogOptions, this.serverCertificateArn = props.serverCertificateArn, this.clientConnectOptions = props.clientConnectOptions, this.clientLoginBannerOptions = props.clientLoginBannerOptions, this.description = props.description, this.dnsServers = props.dnsServers, this.securityGroupIds = props.securityGroupIds, this.selfServicePortal = props.selfServicePortal, this.sessionTimeoutHours = props.sessionTimeoutHours, this.splitTunnel = props.splitTunnel, this.tagSpecifications = props.tagSpecifications, this.transportProtocol = props.transportProtocol, this.vpcId = props.vpcId, this.vpnPort = props.vpnPort;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnClientVpnEndpoint.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { authenticationOptions: this.authenticationOptions, clientCidrBlock: this.clientCidrBlock, connectionLogOptions: this.connectionLogOptions, serverCertificateArn: this.serverCertificateArn, clientConnectOptions: this.clientConnectOptions, clientLoginBannerOptions: this.clientLoginBannerOptions, description: this.description, dnsServers: this.dnsServers, securityGroupIds: this.securityGroupIds, selfServicePortal: this.selfServicePortal, sessionTimeoutHours: this.sessionTimeoutHours, splitTunnel: this.splitTunnel, tagSpecifications: this.tagSpecifications, transportProtocol: this.transportProtocol, vpcId: this.vpcId, vpnPort: this.vpnPort };
      }
      renderProperties(props) {
        return cfnClientVpnEndpointPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnClientVpnEndpoint[_e] = { fqn: "aws-cdk-lib.aws_ec2.CfnClientVpnEndpoint", version: "2.80.0" }, CfnClientVpnEndpoint.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::ClientVpnEndpoint", exports2.CfnClientVpnEndpoint = CfnClientVpnEndpoint;
    function CfnClientVpnEndpoint_CertificateAuthenticationRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clientRootCertificateChainArn", cdk.requiredValidator)(properties.clientRootCertificateChainArn)), errors.collect(cdk.propertyValidator("clientRootCertificateChainArn", cdk.validateString)(properties.clientRootCertificateChainArn)), errors.wrap('supplied properties not correct for "CertificateAuthenticationRequestProperty"');
    }
    function cfnClientVpnEndpointCertificateAuthenticationRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClientVpnEndpoint_CertificateAuthenticationRequestPropertyValidator(properties).assertSuccess(), { ClientRootCertificateChainArn: cdk.stringToCloudFormation(properties.clientRootCertificateChainArn) }) : properties;
    }
    function CfnClientVpnEndpointCertificateAuthenticationRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clientRootCertificateChainArn", "ClientRootCertificateChainArn", cfn_parse.FromCloudFormation.getString(properties.ClientRootCertificateChainArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnClientVpnEndpoint_ClientAuthenticationRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("activeDirectory", CfnClientVpnEndpoint_DirectoryServiceAuthenticationRequestPropertyValidator)(properties.activeDirectory)), errors.collect(cdk.propertyValidator("federatedAuthentication", CfnClientVpnEndpoint_FederatedAuthenticationRequestPropertyValidator)(properties.federatedAuthentication)), errors.collect(cdk.propertyValidator("mutualAuthentication", CfnClientVpnEndpoint_CertificateAuthenticationRequestPropertyValidator)(properties.mutualAuthentication)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "ClientAuthenticationRequestProperty"');
    }
    function cfnClientVpnEndpointClientAuthenticationRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClientVpnEndpoint_ClientAuthenticationRequestPropertyValidator(properties).assertSuccess(), { ActiveDirectory: cfnClientVpnEndpointDirectoryServiceAuthenticationRequestPropertyToCloudFormation(properties.activeDirectory), FederatedAuthentication: cfnClientVpnEndpointFederatedAuthenticationRequestPropertyToCloudFormation(properties.federatedAuthentication), MutualAuthentication: cfnClientVpnEndpointCertificateAuthenticationRequestPropertyToCloudFormation(properties.mutualAuthentication), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnClientVpnEndpointClientAuthenticationRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("activeDirectory", "ActiveDirectory", properties.ActiveDirectory != null ? CfnClientVpnEndpointDirectoryServiceAuthenticationRequestPropertyFromCloudFormation(properties.ActiveDirectory) : void 0), ret.addPropertyResult("federatedAuthentication", "FederatedAuthentication", properties.FederatedAuthentication != null ? CfnClientVpnEndpointFederatedAuthenticationRequestPropertyFromCloudFormation(properties.FederatedAuthentication) : void 0), ret.addPropertyResult("mutualAuthentication", "MutualAuthentication", properties.MutualAuthentication != null ? CfnClientVpnEndpointCertificateAuthenticationRequestPropertyFromCloudFormation(properties.MutualAuthentication) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnClientVpnEndpoint_ClientConnectOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("lambdaFunctionArn", cdk.validateString)(properties.lambdaFunctionArn)), errors.wrap('supplied properties not correct for "ClientConnectOptionsProperty"');
    }
    function cfnClientVpnEndpointClientConnectOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClientVpnEndpoint_ClientConnectOptionsPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled), LambdaFunctionArn: cdk.stringToCloudFormation(properties.lambdaFunctionArn) }) : properties;
    }
    function CfnClientVpnEndpointClientConnectOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addPropertyResult("lambdaFunctionArn", "LambdaFunctionArn", properties.LambdaFunctionArn != null ? cfn_parse.FromCloudFormation.getString(properties.LambdaFunctionArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnClientVpnEndpoint_ClientLoginBannerOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bannerText", cdk.validateString)(properties.bannerText)), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "ClientLoginBannerOptionsProperty"');
    }
    function cfnClientVpnEndpointClientLoginBannerOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClientVpnEndpoint_ClientLoginBannerOptionsPropertyValidator(properties).assertSuccess(), { BannerText: cdk.stringToCloudFormation(properties.bannerText), Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnClientVpnEndpointClientLoginBannerOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bannerText", "BannerText", properties.BannerText != null ? cfn_parse.FromCloudFormation.getString(properties.BannerText) : void 0), ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnClientVpnEndpoint_ConnectionLogOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudwatchLogGroup", cdk.validateString)(properties.cloudwatchLogGroup)), errors.collect(cdk.propertyValidator("cloudwatchLogStream", cdk.validateString)(properties.cloudwatchLogStream)), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "ConnectionLogOptionsProperty"');
    }
    function cfnClientVpnEndpointConnectionLogOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClientVpnEndpoint_ConnectionLogOptionsPropertyValidator(properties).assertSuccess(), { CloudwatchLogGroup: cdk.stringToCloudFormation(properties.cloudwatchLogGroup), CloudwatchLogStream: cdk.stringToCloudFormation(properties.cloudwatchLogStream), Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnClientVpnEndpointConnectionLogOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudwatchLogGroup", "CloudwatchLogGroup", properties.CloudwatchLogGroup != null ? cfn_parse.FromCloudFormation.getString(properties.CloudwatchLogGroup) : void 0), ret.addPropertyResult("cloudwatchLogStream", "CloudwatchLogStream", properties.CloudwatchLogStream != null ? cfn_parse.FromCloudFormation.getString(properties.CloudwatchLogStream) : void 0), ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnClientVpnEndpoint_DirectoryServiceAuthenticationRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("directoryId", cdk.requiredValidator)(properties.directoryId)), errors.collect(cdk.propertyValidator("directoryId", cdk.validateString)(properties.directoryId)), errors.wrap('supplied properties not correct for "DirectoryServiceAuthenticationRequestProperty"');
    }
    function cfnClientVpnEndpointDirectoryServiceAuthenticationRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClientVpnEndpoint_DirectoryServiceAuthenticationRequestPropertyValidator(properties).assertSuccess(), { DirectoryId: cdk.stringToCloudFormation(properties.directoryId) }) : properties;
    }
    function CfnClientVpnEndpointDirectoryServiceAuthenticationRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("directoryId", "DirectoryId", cfn_parse.FromCloudFormation.getString(properties.DirectoryId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnClientVpnEndpoint_FederatedAuthenticationRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("samlProviderArn", cdk.requiredValidator)(properties.samlProviderArn)), errors.collect(cdk.propertyValidator("samlProviderArn", cdk.validateString)(properties.samlProviderArn)), errors.collect(cdk.propertyValidator("selfServiceSamlProviderArn", cdk.validateString)(properties.selfServiceSamlProviderArn)), errors.wrap('supplied properties not correct for "FederatedAuthenticationRequestProperty"');
    }
    function cfnClientVpnEndpointFederatedAuthenticationRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClientVpnEndpoint_FederatedAuthenticationRequestPropertyValidator(properties).assertSuccess(), { SAMLProviderArn: cdk.stringToCloudFormation(properties.samlProviderArn), SelfServiceSAMLProviderArn: cdk.stringToCloudFormation(properties.selfServiceSamlProviderArn) }) : properties;
    }
    function CfnClientVpnEndpointFederatedAuthenticationRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("samlProviderArn", "SAMLProviderArn", cfn_parse.FromCloudFormation.getString(properties.SAMLProviderArn)), ret.addPropertyResult("selfServiceSamlProviderArn", "SelfServiceSAMLProviderArn", properties.SelfServiceSAMLProviderArn != null ? cfn_parse.FromCloudFormation.getString(properties.SelfServiceSAMLProviderArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnClientVpnEndpoint_TagSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceType", cdk.requiredValidator)(properties.resourceType)), errors.collect(cdk.propertyValidator("resourceType", cdk.validateString)(properties.resourceType)), errors.collect(cdk.propertyValidator("tags", cdk.requiredValidator)(properties.tags)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "TagSpecificationProperty"');
    }
    function cfnClientVpnEndpointTagSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClientVpnEndpoint_TagSpecificationPropertyValidator(properties).assertSuccess(), { ResourceType: cdk.stringToCloudFormation(properties.resourceType), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnClientVpnEndpointTagSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceType", "ResourceType", cfn_parse.FromCloudFormation.getString(properties.ResourceType)), ret.addPropertyResult("tags", "Tags", cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnClientVpnRoutePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clientVpnEndpointId", cdk.requiredValidator)(properties.clientVpnEndpointId)), errors.collect(cdk.propertyValidator("clientVpnEndpointId", cdk.validateString)(properties.clientVpnEndpointId)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("destinationCidrBlock", cdk.requiredValidator)(properties.destinationCidrBlock)), errors.collect(cdk.propertyValidator("destinationCidrBlock", cdk.validateString)(properties.destinationCidrBlock)), errors.collect(cdk.propertyValidator("targetVpcSubnetId", cdk.requiredValidator)(properties.targetVpcSubnetId)), errors.collect(cdk.propertyValidator("targetVpcSubnetId", cdk.validateString)(properties.targetVpcSubnetId)), errors.wrap('supplied properties not correct for "CfnClientVpnRouteProps"');
    }
    function cfnClientVpnRoutePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClientVpnRoutePropsValidator(properties).assertSuccess(), { ClientVpnEndpointId: cdk.stringToCloudFormation(properties.clientVpnEndpointId), DestinationCidrBlock: cdk.stringToCloudFormation(properties.destinationCidrBlock), TargetVpcSubnetId: cdk.stringToCloudFormation(properties.targetVpcSubnetId), Description: cdk.stringToCloudFormation(properties.description) }) : properties;
    }
    function CfnClientVpnRoutePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clientVpnEndpointId", "ClientVpnEndpointId", cfn_parse.FromCloudFormation.getString(properties.ClientVpnEndpointId)), ret.addPropertyResult("destinationCidrBlock", "DestinationCidrBlock", cfn_parse.FromCloudFormation.getString(properties.DestinationCidrBlock)), ret.addPropertyResult("targetVpcSubnetId", "TargetVpcSubnetId", cfn_parse.FromCloudFormation.getString(properties.TargetVpcSubnetId)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnClientVpnRoute = class _CfnClientVpnRoute extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnClientVpnRoutePropsFromCloudFormation(resourceProperties), ret = new _CfnClientVpnRoute(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnClientVpnRoute.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnClientVpnRouteProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnClientVpnRoute), error;
        }
        cdk.requireProperty(props, "clientVpnEndpointId", this), cdk.requireProperty(props, "destinationCidrBlock", this), cdk.requireProperty(props, "targetVpcSubnetId", this), this.clientVpnEndpointId = props.clientVpnEndpointId, this.destinationCidrBlock = props.destinationCidrBlock, this.targetVpcSubnetId = props.targetVpcSubnetId, this.description = props.description;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnClientVpnRoute.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { clientVpnEndpointId: this.clientVpnEndpointId, destinationCidrBlock: this.destinationCidrBlock, targetVpcSubnetId: this.targetVpcSubnetId, description: this.description };
      }
      renderProperties(props) {
        return cfnClientVpnRoutePropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnClientVpnRoute[_f] = { fqn: "aws-cdk-lib.aws_ec2.CfnClientVpnRoute", version: "2.80.0" }, CfnClientVpnRoute.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::ClientVpnRoute", exports2.CfnClientVpnRoute = CfnClientVpnRoute;
    function CfnClientVpnTargetNetworkAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clientVpnEndpointId", cdk.requiredValidator)(properties.clientVpnEndpointId)), errors.collect(cdk.propertyValidator("clientVpnEndpointId", cdk.validateString)(properties.clientVpnEndpointId)), errors.collect(cdk.propertyValidator("subnetId", cdk.requiredValidator)(properties.subnetId)), errors.collect(cdk.propertyValidator("subnetId", cdk.validateString)(properties.subnetId)), errors.wrap('supplied properties not correct for "CfnClientVpnTargetNetworkAssociationProps"');
    }
    function cfnClientVpnTargetNetworkAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClientVpnTargetNetworkAssociationPropsValidator(properties).assertSuccess(), { ClientVpnEndpointId: cdk.stringToCloudFormation(properties.clientVpnEndpointId), SubnetId: cdk.stringToCloudFormation(properties.subnetId) }) : properties;
    }
    function CfnClientVpnTargetNetworkAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clientVpnEndpointId", "ClientVpnEndpointId", cfn_parse.FromCloudFormation.getString(properties.ClientVpnEndpointId)), ret.addPropertyResult("subnetId", "SubnetId", cfn_parse.FromCloudFormation.getString(properties.SubnetId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnClientVpnTargetNetworkAssociation = class _CfnClientVpnTargetNetworkAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnClientVpnTargetNetworkAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnClientVpnTargetNetworkAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnClientVpnTargetNetworkAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnClientVpnTargetNetworkAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnClientVpnTargetNetworkAssociation), error;
        }
        cdk.requireProperty(props, "clientVpnEndpointId", this), cdk.requireProperty(props, "subnetId", this), this.clientVpnEndpointId = props.clientVpnEndpointId, this.subnetId = props.subnetId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnClientVpnTargetNetworkAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { clientVpnEndpointId: this.clientVpnEndpointId, subnetId: this.subnetId };
      }
      renderProperties(props) {
        return cfnClientVpnTargetNetworkAssociationPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnClientVpnTargetNetworkAssociation[_g] = { fqn: "aws-cdk-lib.aws_ec2.CfnClientVpnTargetNetworkAssociation", version: "2.80.0" }, CfnClientVpnTargetNetworkAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::ClientVpnTargetNetworkAssociation", exports2.CfnClientVpnTargetNetworkAssociation = CfnClientVpnTargetNetworkAssociation;
    function CfnCustomerGatewayPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bgpAsn", cdk.requiredValidator)(properties.bgpAsn)), errors.collect(cdk.propertyValidator("bgpAsn", cdk.validateNumber)(properties.bgpAsn)), errors.collect(cdk.propertyValidator("deviceName", cdk.validateString)(properties.deviceName)), errors.collect(cdk.propertyValidator("ipAddress", cdk.requiredValidator)(properties.ipAddress)), errors.collect(cdk.propertyValidator("ipAddress", cdk.validateString)(properties.ipAddress)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnCustomerGatewayProps"');
    }
    function cfnCustomerGatewayPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCustomerGatewayPropsValidator(properties).assertSuccess(), { BgpAsn: cdk.numberToCloudFormation(properties.bgpAsn), IpAddress: cdk.stringToCloudFormation(properties.ipAddress), Type: cdk.stringToCloudFormation(properties.type), DeviceName: cdk.stringToCloudFormation(properties.deviceName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnCustomerGatewayPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bgpAsn", "BgpAsn", cfn_parse.FromCloudFormation.getNumber(properties.BgpAsn)), ret.addPropertyResult("ipAddress", "IpAddress", cfn_parse.FromCloudFormation.getString(properties.IpAddress)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("deviceName", "DeviceName", properties.DeviceName != null ? cfn_parse.FromCloudFormation.getString(properties.DeviceName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCustomerGateway = class _CfnCustomerGateway extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCustomerGatewayPropsFromCloudFormation(resourceProperties), ret = new _CfnCustomerGateway(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCustomerGateway.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnCustomerGatewayProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCustomerGateway), error;
        }
        cdk.requireProperty(props, "bgpAsn", this), cdk.requireProperty(props, "ipAddress", this), cdk.requireProperty(props, "type", this), this.attrCustomerGatewayId = cdk.Token.asString(this.getAtt("CustomerGatewayId", cdk.ResolutionTypeHint.STRING)), this.bgpAsn = props.bgpAsn, this.ipAddress = props.ipAddress, this.type = props.type, this.deviceName = props.deviceName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::CustomerGateway", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCustomerGateway.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { bgpAsn: this.bgpAsn, ipAddress: this.ipAddress, type: this.type, deviceName: this.deviceName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnCustomerGatewayPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnCustomerGateway[_h] = { fqn: "aws-cdk-lib.aws_ec2.CfnCustomerGateway", version: "2.80.0" }, CfnCustomerGateway.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::CustomerGateway", exports2.CfnCustomerGateway = CfnCustomerGateway;
    function CfnDHCPOptionsPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.collect(cdk.propertyValidator("domainNameServers", cdk.listValidator(cdk.validateString))(properties.domainNameServers)), errors.collect(cdk.propertyValidator("netbiosNameServers", cdk.listValidator(cdk.validateString))(properties.netbiosNameServers)), errors.collect(cdk.propertyValidator("netbiosNodeType", cdk.validateNumber)(properties.netbiosNodeType)), errors.collect(cdk.propertyValidator("ntpServers", cdk.listValidator(cdk.validateString))(properties.ntpServers)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDHCPOptionsProps"');
    }
    function cfnDHCPOptionsPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDHCPOptionsPropsValidator(properties).assertSuccess(), { DomainName: cdk.stringToCloudFormation(properties.domainName), DomainNameServers: cdk.listMapper(cdk.stringToCloudFormation)(properties.domainNameServers), NetbiosNameServers: cdk.listMapper(cdk.stringToCloudFormation)(properties.netbiosNameServers), NetbiosNodeType: cdk.numberToCloudFormation(properties.netbiosNodeType), NtpServers: cdk.listMapper(cdk.stringToCloudFormation)(properties.ntpServers), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDHCPOptionsPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("domainName", "DomainName", properties.DomainName != null ? cfn_parse.FromCloudFormation.getString(properties.DomainName) : void 0), ret.addPropertyResult("domainNameServers", "DomainNameServers", properties.DomainNameServers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.DomainNameServers) : void 0), ret.addPropertyResult("netbiosNameServers", "NetbiosNameServers", properties.NetbiosNameServers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.NetbiosNameServers) : void 0), ret.addPropertyResult("netbiosNodeType", "NetbiosNodeType", properties.NetbiosNodeType != null ? cfn_parse.FromCloudFormation.getNumber(properties.NetbiosNodeType) : void 0), ret.addPropertyResult("ntpServers", "NtpServers", properties.NtpServers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.NtpServers) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDHCPOptions = class _CfnDHCPOptions extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDHCPOptionsPropsFromCloudFormation(resourceProperties), ret = new _CfnDHCPOptions(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnDHCPOptions.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnDHCPOptionsProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDHCPOptions), error;
        }
        this.attrDhcpOptionsId = cdk.Token.asString(this.getAtt("DhcpOptionsId", cdk.ResolutionTypeHint.STRING)), this.domainName = props.domainName, this.domainNameServers = props.domainNameServers, this.netbiosNameServers = props.netbiosNameServers, this.netbiosNodeType = props.netbiosNodeType, this.ntpServers = props.ntpServers, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::DHCPOptions", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDHCPOptions.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { domainName: this.domainName, domainNameServers: this.domainNameServers, netbiosNameServers: this.netbiosNameServers, netbiosNodeType: this.netbiosNodeType, ntpServers: this.ntpServers, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDHCPOptionsPropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnDHCPOptions[_j] = { fqn: "aws-cdk-lib.aws_ec2.CfnDHCPOptions", version: "2.80.0" }, CfnDHCPOptions.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::DHCPOptions", exports2.CfnDHCPOptions = CfnDHCPOptions;
    function CfnEC2FleetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("context", cdk.validateString)(properties.context)), errors.collect(cdk.propertyValidator("excessCapacityTerminationPolicy", cdk.validateString)(properties.excessCapacityTerminationPolicy)), errors.collect(cdk.propertyValidator("launchTemplateConfigs", cdk.requiredValidator)(properties.launchTemplateConfigs)), errors.collect(cdk.propertyValidator("launchTemplateConfigs", cdk.listValidator(CfnEC2Fleet_FleetLaunchTemplateConfigRequestPropertyValidator))(properties.launchTemplateConfigs)), errors.collect(cdk.propertyValidator("onDemandOptions", CfnEC2Fleet_OnDemandOptionsRequestPropertyValidator)(properties.onDemandOptions)), errors.collect(cdk.propertyValidator("replaceUnhealthyInstances", cdk.validateBoolean)(properties.replaceUnhealthyInstances)), errors.collect(cdk.propertyValidator("spotOptions", CfnEC2Fleet_SpotOptionsRequestPropertyValidator)(properties.spotOptions)), errors.collect(cdk.propertyValidator("tagSpecifications", cdk.listValidator(CfnEC2Fleet_TagSpecificationPropertyValidator))(properties.tagSpecifications)), errors.collect(cdk.propertyValidator("targetCapacitySpecification", cdk.requiredValidator)(properties.targetCapacitySpecification)), errors.collect(cdk.propertyValidator("targetCapacitySpecification", CfnEC2Fleet_TargetCapacitySpecificationRequestPropertyValidator)(properties.targetCapacitySpecification)), errors.collect(cdk.propertyValidator("terminateInstancesWithExpiration", cdk.validateBoolean)(properties.terminateInstancesWithExpiration)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("validFrom", cdk.validateString)(properties.validFrom)), errors.collect(cdk.propertyValidator("validUntil", cdk.validateString)(properties.validUntil)), errors.wrap('supplied properties not correct for "CfnEC2FleetProps"');
    }
    function cfnEC2FleetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEC2FleetPropsValidator(properties).assertSuccess(), { LaunchTemplateConfigs: cdk.listMapper(cfnEC2FleetFleetLaunchTemplateConfigRequestPropertyToCloudFormation)(properties.launchTemplateConfigs), TargetCapacitySpecification: cfnEC2FleetTargetCapacitySpecificationRequestPropertyToCloudFormation(properties.targetCapacitySpecification), Context: cdk.stringToCloudFormation(properties.context), ExcessCapacityTerminationPolicy: cdk.stringToCloudFormation(properties.excessCapacityTerminationPolicy), OnDemandOptions: cfnEC2FleetOnDemandOptionsRequestPropertyToCloudFormation(properties.onDemandOptions), ReplaceUnhealthyInstances: cdk.booleanToCloudFormation(properties.replaceUnhealthyInstances), SpotOptions: cfnEC2FleetSpotOptionsRequestPropertyToCloudFormation(properties.spotOptions), TagSpecifications: cdk.listMapper(cfnEC2FleetTagSpecificationPropertyToCloudFormation)(properties.tagSpecifications), TerminateInstancesWithExpiration: cdk.booleanToCloudFormation(properties.terminateInstancesWithExpiration), Type: cdk.stringToCloudFormation(properties.type), ValidFrom: cdk.stringToCloudFormation(properties.validFrom), ValidUntil: cdk.stringToCloudFormation(properties.validUntil) }) : properties;
    }
    function CfnEC2FleetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("launchTemplateConfigs", "LaunchTemplateConfigs", cfn_parse.FromCloudFormation.getArray(CfnEC2FleetFleetLaunchTemplateConfigRequestPropertyFromCloudFormation)(properties.LaunchTemplateConfigs)), ret.addPropertyResult("targetCapacitySpecification", "TargetCapacitySpecification", CfnEC2FleetTargetCapacitySpecificationRequestPropertyFromCloudFormation(properties.TargetCapacitySpecification)), ret.addPropertyResult("context", "Context", properties.Context != null ? cfn_parse.FromCloudFormation.getString(properties.Context) : void 0), ret.addPropertyResult("excessCapacityTerminationPolicy", "ExcessCapacityTerminationPolicy", properties.ExcessCapacityTerminationPolicy != null ? cfn_parse.FromCloudFormation.getString(properties.ExcessCapacityTerminationPolicy) : void 0), ret.addPropertyResult("onDemandOptions", "OnDemandOptions", properties.OnDemandOptions != null ? CfnEC2FleetOnDemandOptionsRequestPropertyFromCloudFormation(properties.OnDemandOptions) : void 0), ret.addPropertyResult("replaceUnhealthyInstances", "ReplaceUnhealthyInstances", properties.ReplaceUnhealthyInstances != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ReplaceUnhealthyInstances) : void 0), ret.addPropertyResult("spotOptions", "SpotOptions", properties.SpotOptions != null ? CfnEC2FleetSpotOptionsRequestPropertyFromCloudFormation(properties.SpotOptions) : void 0), ret.addPropertyResult("tagSpecifications", "TagSpecifications", properties.TagSpecifications != null ? cfn_parse.FromCloudFormation.getArray(CfnEC2FleetTagSpecificationPropertyFromCloudFormation)(properties.TagSpecifications) : void 0), ret.addPropertyResult("terminateInstancesWithExpiration", "TerminateInstancesWithExpiration", properties.TerminateInstancesWithExpiration != null ? cfn_parse.FromCloudFormation.getBoolean(properties.TerminateInstancesWithExpiration) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addPropertyResult("validFrom", "ValidFrom", properties.ValidFrom != null ? cfn_parse.FromCloudFormation.getString(properties.ValidFrom) : void 0), ret.addPropertyResult("validUntil", "ValidUntil", properties.ValidUntil != null ? cfn_parse.FromCloudFormation.getString(properties.ValidUntil) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEC2Fleet = class _CfnEC2Fleet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEC2FleetPropsFromCloudFormation(resourceProperties), ret = new _CfnEC2Fleet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEC2Fleet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnEC2FleetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEC2Fleet), error;
        }
        cdk.requireProperty(props, "launchTemplateConfigs", this), cdk.requireProperty(props, "targetCapacitySpecification", this), this.attrFleetId = cdk.Token.asString(this.getAtt("FleetId", cdk.ResolutionTypeHint.STRING)), this.launchTemplateConfigs = props.launchTemplateConfigs, this.targetCapacitySpecification = props.targetCapacitySpecification, this.context = props.context, this.excessCapacityTerminationPolicy = props.excessCapacityTerminationPolicy, this.onDemandOptions = props.onDemandOptions, this.replaceUnhealthyInstances = props.replaceUnhealthyInstances, this.spotOptions = props.spotOptions, this.tagSpecifications = props.tagSpecifications, this.terminateInstancesWithExpiration = props.terminateInstancesWithExpiration, this.type = props.type, this.validFrom = props.validFrom, this.validUntil = props.validUntil;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEC2Fleet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { launchTemplateConfigs: this.launchTemplateConfigs, targetCapacitySpecification: this.targetCapacitySpecification, context: this.context, excessCapacityTerminationPolicy: this.excessCapacityTerminationPolicy, onDemandOptions: this.onDemandOptions, replaceUnhealthyInstances: this.replaceUnhealthyInstances, spotOptions: this.spotOptions, tagSpecifications: this.tagSpecifications, terminateInstancesWithExpiration: this.terminateInstancesWithExpiration, type: this.type, validFrom: this.validFrom, validUntil: this.validUntil };
      }
      renderProperties(props) {
        return cfnEC2FleetPropsToCloudFormation(props);
      }
    };
    _k = JSII_RTTI_SYMBOL_1, CfnEC2Fleet[_k] = { fqn: "aws-cdk-lib.aws_ec2.CfnEC2Fleet", version: "2.80.0" }, CfnEC2Fleet.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::EC2Fleet", exports2.CfnEC2Fleet = CfnEC2Fleet;
    function CfnEC2Fleet_AcceleratorCountRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "AcceleratorCountRequestProperty"');
    }
    function cfnEC2FleetAcceleratorCountRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEC2Fleet_AcceleratorCountRequestPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnEC2FleetAcceleratorCountRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEC2Fleet_AcceleratorTotalMemoryMiBRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "AcceleratorTotalMemoryMiBRequestProperty"');
    }
    function cfnEC2FleetAcceleratorTotalMemoryMiBRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEC2Fleet_AcceleratorTotalMemoryMiBRequestPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnEC2FleetAcceleratorTotalMemoryMiBRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEC2Fleet_BaselineEbsBandwidthMbpsRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "BaselineEbsBandwidthMbpsRequestProperty"');
    }
    function cfnEC2FleetBaselineEbsBandwidthMbpsRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEC2Fleet_BaselineEbsBandwidthMbpsRequestPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnEC2FleetBaselineEbsBandwidthMbpsRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEC2Fleet_CapacityRebalancePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("replacementStrategy", cdk.validateString)(properties.replacementStrategy)), errors.collect(cdk.propertyValidator("terminationDelay", cdk.validateNumber)(properties.terminationDelay)), errors.wrap('supplied properties not correct for "CapacityRebalanceProperty"');
    }
    function cfnEC2FleetCapacityRebalancePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEC2Fleet_CapacityRebalancePropertyValidator(properties).assertSuccess(), { ReplacementStrategy: cdk.stringToCloudFormation(properties.replacementStrategy), TerminationDelay: cdk.numberToCloudFormation(properties.terminationDelay) }) : properties;
    }
    function CfnEC2FleetCapacityRebalancePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("replacementStrategy", "ReplacementStrategy", properties.ReplacementStrategy != null ? cfn_parse.FromCloudFormation.getString(properties.ReplacementStrategy) : void 0), ret.addPropertyResult("terminationDelay", "TerminationDelay", properties.TerminationDelay != null ? cfn_parse.FromCloudFormation.getNumber(properties.TerminationDelay) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEC2Fleet_CapacityReservationOptionsRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("usageStrategy", cdk.validateString)(properties.usageStrategy)), errors.wrap('supplied properties not correct for "CapacityReservationOptionsRequestProperty"');
    }
    function cfnEC2FleetCapacityReservationOptionsRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEC2Fleet_CapacityReservationOptionsRequestPropertyValidator(properties).assertSuccess(), { UsageStrategy: cdk.stringToCloudFormation(properties.usageStrategy) }) : properties;
    }
    function CfnEC2FleetCapacityReservationOptionsRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("usageStrategy", "UsageStrategy", properties.UsageStrategy != null ? cfn_parse.FromCloudFormation.getString(properties.UsageStrategy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEC2Fleet_FleetLaunchTemplateConfigRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("launchTemplateSpecification", CfnEC2Fleet_FleetLaunchTemplateSpecificationRequestPropertyValidator)(properties.launchTemplateSpecification)), errors.collect(cdk.propertyValidator("overrides", cdk.listValidator(CfnEC2Fleet_FleetLaunchTemplateOverridesRequestPropertyValidator))(properties.overrides)), errors.wrap('supplied properties not correct for "FleetLaunchTemplateConfigRequestProperty"');
    }
    function cfnEC2FleetFleetLaunchTemplateConfigRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEC2Fleet_FleetLaunchTemplateConfigRequestPropertyValidator(properties).assertSuccess(), { LaunchTemplateSpecification: cfnEC2FleetFleetLaunchTemplateSpecificationRequestPropertyToCloudFormation(properties.launchTemplateSpecification), Overrides: cdk.listMapper(cfnEC2FleetFleetLaunchTemplateOverridesRequestPropertyToCloudFormation)(properties.overrides) }) : properties;
    }
    function CfnEC2FleetFleetLaunchTemplateConfigRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("launchTemplateSpecification", "LaunchTemplateSpecification", properties.LaunchTemplateSpecification != null ? CfnEC2FleetFleetLaunchTemplateSpecificationRequestPropertyFromCloudFormation(properties.LaunchTemplateSpecification) : void 0), ret.addPropertyResult("overrides", "Overrides", properties.Overrides != null ? cfn_parse.FromCloudFormation.getArray(CfnEC2FleetFleetLaunchTemplateOverridesRequestPropertyFromCloudFormation)(properties.Overrides) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEC2Fleet_FleetLaunchTemplateOverridesRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availabilityZone", cdk.validateString)(properties.availabilityZone)), errors.collect(cdk.propertyValidator("instanceRequirements", CfnEC2Fleet_InstanceRequirementsRequestPropertyValidator)(properties.instanceRequirements)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("maxPrice", cdk.validateString)(properties.maxPrice)), errors.collect(cdk.propertyValidator("placement", CfnEC2Fleet_PlacementPropertyValidator)(properties.placement)), errors.collect(cdk.propertyValidator("priority", cdk.validateNumber)(properties.priority)), errors.collect(cdk.propertyValidator("subnetId", cdk.validateString)(properties.subnetId)), errors.collect(cdk.propertyValidator("weightedCapacity", cdk.validateNumber)(properties.weightedCapacity)), errors.wrap('supplied properties not correct for "FleetLaunchTemplateOverridesRequestProperty"');
    }
    function cfnEC2FleetFleetLaunchTemplateOverridesRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEC2Fleet_FleetLaunchTemplateOverridesRequestPropertyValidator(properties).assertSuccess(), { AvailabilityZone: cdk.stringToCloudFormation(properties.availabilityZone), InstanceRequirements: cfnEC2FleetInstanceRequirementsRequestPropertyToCloudFormation(properties.instanceRequirements), InstanceType: cdk.stringToCloudFormation(properties.instanceType), MaxPrice: cdk.stringToCloudFormation(properties.maxPrice), Placement: cfnEC2FleetPlacementPropertyToCloudFormation(properties.placement), Priority: cdk.numberToCloudFormation(properties.priority), SubnetId: cdk.stringToCloudFormation(properties.subnetId), WeightedCapacity: cdk.numberToCloudFormation(properties.weightedCapacity) }) : properties;
    }
    function CfnEC2FleetFleetLaunchTemplateOverridesRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("availabilityZone", "AvailabilityZone", properties.AvailabilityZone != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityZone) : void 0), ret.addPropertyResult("instanceRequirements", "InstanceRequirements", properties.InstanceRequirements != null ? CfnEC2FleetInstanceRequirementsRequestPropertyFromCloudFormation(properties.InstanceRequirements) : void 0), ret.addPropertyResult("instanceType", "InstanceType", properties.InstanceType != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceType) : void 0), ret.addPropertyResult("maxPrice", "MaxPrice", properties.MaxPrice != null ? cfn_parse.FromCloudFormation.getString(properties.MaxPrice) : void 0), ret.addPropertyResult("placement", "Placement", properties.Placement != null ? CfnEC2FleetPlacementPropertyFromCloudFormation(properties.Placement) : void 0), ret.addPropertyResult("priority", "Priority", properties.Priority != null ? cfn_parse.FromCloudFormation.getNumber(properties.Priority) : void 0), ret.addPropertyResult("subnetId", "SubnetId", properties.SubnetId != null ? cfn_parse.FromCloudFormation.getString(properties.SubnetId) : void 0), ret.addPropertyResult("weightedCapacity", "WeightedCapacity", properties.WeightedCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.WeightedCapacity) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEC2Fleet_FleetLaunchTemplateSpecificationRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("launchTemplateId", cdk.validateString)(properties.launchTemplateId)), errors.collect(cdk.propertyValidator("launchTemplateName", cdk.validateString)(properties.launchTemplateName)), errors.collect(cdk.propertyValidator("version", cdk.requiredValidator)(properties.version)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "FleetLaunchTemplateSpecificationRequestProperty"');
    }
    function cfnEC2FleetFleetLaunchTemplateSpecificationRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEC2Fleet_FleetLaunchTemplateSpecificationRequestPropertyValidator(properties).assertSuccess(), { LaunchTemplateId: cdk.stringToCloudFormation(properties.launchTemplateId), LaunchTemplateName: cdk.stringToCloudFormation(properties.launchTemplateName), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnEC2FleetFleetLaunchTemplateSpecificationRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("launchTemplateId", "LaunchTemplateId", properties.LaunchTemplateId != null ? cfn_parse.FromCloudFormation.getString(properties.LaunchTemplateId) : void 0), ret.addPropertyResult("launchTemplateName", "LaunchTemplateName", properties.LaunchTemplateName != null ? cfn_parse.FromCloudFormation.getString(properties.LaunchTemplateName) : void 0), ret.addPropertyResult("version", "Version", cfn_parse.FromCloudFormation.getString(properties.Version)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEC2Fleet_InstanceRequirementsRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acceleratorCount", CfnEC2Fleet_AcceleratorCountRequestPropertyValidator)(properties.acceleratorCount)), errors.collect(cdk.propertyValidator("acceleratorManufacturers", cdk.listValidator(cdk.validateString))(properties.acceleratorManufacturers)), errors.collect(cdk.propertyValidator("acceleratorNames", cdk.listValidator(cdk.validateString))(properties.acceleratorNames)), errors.collect(cdk.propertyValidator("acceleratorTotalMemoryMiB", CfnEC2Fleet_AcceleratorTotalMemoryMiBRequestPropertyValidator)(properties.acceleratorTotalMemoryMiB)), errors.collect(cdk.propertyValidator("acceleratorTypes", cdk.listValidator(cdk.validateString))(properties.acceleratorTypes)), errors.collect(cdk.propertyValidator("allowedInstanceTypes", cdk.listValidator(cdk.validateString))(properties.allowedInstanceTypes)), errors.collect(cdk.propertyValidator("bareMetal", cdk.validateString)(properties.bareMetal)), errors.collect(cdk.propertyValidator("baselineEbsBandwidthMbps", CfnEC2Fleet_BaselineEbsBandwidthMbpsRequestPropertyValidator)(properties.baselineEbsBandwidthMbps)), errors.collect(cdk.propertyValidator("burstablePerformance", cdk.validateString)(properties.burstablePerformance)), errors.collect(cdk.propertyValidator("cpuManufacturers", cdk.listValidator(cdk.validateString))(properties.cpuManufacturers)), errors.collect(cdk.propertyValidator("excludedInstanceTypes", cdk.listValidator(cdk.validateString))(properties.excludedInstanceTypes)), errors.collect(cdk.propertyValidator("instanceGenerations", cdk.listValidator(cdk.validateString))(properties.instanceGenerations)), errors.collect(cdk.propertyValidator("localStorage", cdk.validateString)(properties.localStorage)), errors.collect(cdk.propertyValidator("localStorageTypes", cdk.listValidator(cdk.validateString))(properties.localStorageTypes)), errors.collect(cdk.propertyValidator("memoryGiBPerVCpu", CfnEC2Fleet_MemoryGiBPerVCpuRequestPropertyValidator)(properties.memoryGiBPerVCpu)), errors.collect(cdk.propertyValidator("memoryMiB", CfnEC2Fleet_MemoryMiBRequestPropertyValidator)(properties.memoryMiB)), errors.collect(cdk.propertyValidator("networkBandwidthGbps", CfnEC2Fleet_NetworkBandwidthGbpsRequestPropertyValidator)(properties.networkBandwidthGbps)), errors.collect(cdk.propertyValidator("networkInterfaceCount", CfnEC2Fleet_NetworkInterfaceCountRequestPropertyValidator)(properties.networkInterfaceCount)), errors.collect(cdk.propertyValidator("onDemandMaxPricePercentageOverLowestPrice", cdk.validateNumber)(properties.onDemandMaxPricePercentageOverLowestPrice)), errors.collect(cdk.propertyValidator("requireHibernateSupport", cdk.validateBoolean)(properties.requireHibernateSupport)), errors.collect(cdk.propertyValidator("spotMaxPricePercentageOverLowestPrice", cdk.validateNumber)(properties.spotMaxPricePercentageOverLowestPrice)), errors.collect(cdk.propertyValidator("totalLocalStorageGb", CfnEC2Fleet_TotalLocalStorageGBRequestPropertyValidator)(properties.totalLocalStorageGb)), errors.collect(cdk.propertyValidator("vCpuCount", CfnEC2Fleet_VCpuCountRangeRequestPropertyValidator)(properties.vCpuCount)), errors.wrap('supplied properties not correct for "InstanceRequirementsRequestProperty"');
    }
    function cfnEC2FleetInstanceRequirementsRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEC2Fleet_InstanceRequirementsRequestPropertyValidator(properties).assertSuccess(), { AcceleratorCount: cfnEC2FleetAcceleratorCountRequestPropertyToCloudFormation(properties.acceleratorCount), AcceleratorManufacturers: cdk.listMapper(cdk.stringToCloudFormation)(properties.acceleratorManufacturers), AcceleratorNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.acceleratorNames), AcceleratorTotalMemoryMiB: cfnEC2FleetAcceleratorTotalMemoryMiBRequestPropertyToCloudFormation(properties.acceleratorTotalMemoryMiB), AcceleratorTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.acceleratorTypes), AllowedInstanceTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowedInstanceTypes), BareMetal: cdk.stringToCloudFormation(properties.bareMetal), BaselineEbsBandwidthMbps: cfnEC2FleetBaselineEbsBandwidthMbpsRequestPropertyToCloudFormation(properties.baselineEbsBandwidthMbps), BurstablePerformance: cdk.stringToCloudFormation(properties.burstablePerformance), CpuManufacturers: cdk.listMapper(cdk.stringToCloudFormation)(properties.cpuManufacturers), ExcludedInstanceTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.excludedInstanceTypes), InstanceGenerations: cdk.listMapper(cdk.stringToCloudFormation)(properties.instanceGenerations), LocalStorage: cdk.stringToCloudFormation(properties.localStorage), LocalStorageTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.localStorageTypes), MemoryGiBPerVCpu: cfnEC2FleetMemoryGiBPerVCpuRequestPropertyToCloudFormation(properties.memoryGiBPerVCpu), MemoryMiB: cfnEC2FleetMemoryMiBRequestPropertyToCloudFormation(properties.memoryMiB), NetworkBandwidthGbps: cfnEC2FleetNetworkBandwidthGbpsRequestPropertyToCloudFormation(properties.networkBandwidthGbps), NetworkInterfaceCount: cfnEC2FleetNetworkInterfaceCountRequestPropertyToCloudFormation(properties.networkInterfaceCount), OnDemandMaxPricePercentageOverLowestPrice: cdk.numberToCloudFormation(properties.onDemandMaxPricePercentageOverLowestPrice), RequireHibernateSupport: cdk.booleanToCloudFormation(properties.requireHibernateSupport), SpotMaxPricePercentageOverLowestPrice: cdk.numberToCloudFormation(properties.spotMaxPricePercentageOverLowestPrice), TotalLocalStorageGB: cfnEC2FleetTotalLocalStorageGBRequestPropertyToCloudFormation(properties.totalLocalStorageGb), VCpuCount: cfnEC2FleetVCpuCountRangeRequestPropertyToCloudFormation(properties.vCpuCount) }) : properties;
    }
    function CfnEC2FleetInstanceRequirementsRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("acceleratorCount", "AcceleratorCount", properties.AcceleratorCount != null ? CfnEC2FleetAcceleratorCountRequestPropertyFromCloudFormation(properties.AcceleratorCount) : void 0), ret.addPropertyResult("acceleratorManufacturers", "AcceleratorManufacturers", properties.AcceleratorManufacturers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AcceleratorManufacturers) : void 0), ret.addPropertyResult("acceleratorNames", "AcceleratorNames", properties.AcceleratorNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AcceleratorNames) : void 0), ret.addPropertyResult("acceleratorTotalMemoryMiB", "AcceleratorTotalMemoryMiB", properties.AcceleratorTotalMemoryMiB != null ? CfnEC2FleetAcceleratorTotalMemoryMiBRequestPropertyFromCloudFormation(properties.AcceleratorTotalMemoryMiB) : void 0), ret.addPropertyResult("acceleratorTypes", "AcceleratorTypes", properties.AcceleratorTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AcceleratorTypes) : void 0), ret.addPropertyResult("allowedInstanceTypes", "AllowedInstanceTypes", properties.AllowedInstanceTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AllowedInstanceTypes) : void 0), ret.addPropertyResult("bareMetal", "BareMetal", properties.BareMetal != null ? cfn_parse.FromCloudFormation.getString(properties.BareMetal) : void 0), ret.addPropertyResult("baselineEbsBandwidthMbps", "BaselineEbsBandwidthMbps", properties.BaselineEbsBandwidthMbps != null ? CfnEC2FleetBaselineEbsBandwidthMbpsRequestPropertyFromCloudFormation(properties.BaselineEbsBandwidthMbps) : void 0), ret.addPropertyResult("burstablePerformance", "BurstablePerformance", properties.BurstablePerformance != null ? cfn_parse.FromCloudFormation.getString(properties.BurstablePerformance) : void 0), ret.addPropertyResult("cpuManufacturers", "CpuManufacturers", properties.CpuManufacturers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CpuManufacturers) : void 0), ret.addPropertyResult("excludedInstanceTypes", "ExcludedInstanceTypes", properties.ExcludedInstanceTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExcludedInstanceTypes) : void 0), ret.addPropertyResult("instanceGenerations", "InstanceGenerations", properties.InstanceGenerations != null ? cfn_parse.FromCloudFormation.getStringArray(properties.InstanceGenerations) : void 0), ret.addPropertyResult("localStorage", "LocalStorage", properties.LocalStorage != null ? cfn_parse.FromCloudFormation.getString(properties.LocalStorage) : void 0), ret.addPropertyResult("localStorageTypes", "LocalStorageTypes", properties.LocalStorageTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.LocalStorageTypes) : void 0), ret.addPropertyResult("memoryGiBPerVCpu", "MemoryGiBPerVCpu", properties.MemoryGiBPerVCpu != null ? CfnEC2FleetMemoryGiBPerVCpuRequestPropertyFromCloudFormation(properties.MemoryGiBPerVCpu) : void 0), ret.addPropertyResult("memoryMiB", "MemoryMiB", properties.MemoryMiB != null ? CfnEC2FleetMemoryMiBRequestPropertyFromCloudFormation(properties.MemoryMiB) : void 0), ret.addPropertyResult("networkBandwidthGbps", "NetworkBandwidthGbps", properties.NetworkBandwidthGbps != null ? CfnEC2FleetNetworkBandwidthGbpsRequestPropertyFromCloudFormation(properties.NetworkBandwidthGbps) : void 0), ret.addPropertyResult("networkInterfaceCount", "NetworkInterfaceCount", properties.NetworkInterfaceCount != null ? CfnEC2FleetNetworkInterfaceCountRequestPropertyFromCloudFormation(properties.NetworkInterfaceCount) : void 0), ret.addPropertyResult("onDemandMaxPricePercentageOverLowestPrice", "OnDemandMaxPricePercentageOverLowestPrice", properties.OnDemandMaxPricePercentageOverLowestPrice != null ? cfn_parse.FromCloudFormation.getNumber(properties.OnDemandMaxPricePercentageOverLowestPrice) : void 0), ret.addPropertyResult("requireHibernateSupport", "RequireHibernateSupport", properties.RequireHibernateSupport != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RequireHibernateSupport) : void 0), ret.addPropertyResult("spotMaxPricePercentageOverLowestPrice", "SpotMaxPricePercentageOverLowestPrice", properties.SpotMaxPricePercentageOverLowestPrice != null ? cfn_parse.FromCloudFormation.getNumber(properties.SpotMaxPricePercentageOverLowestPrice) : void 0), ret.addPropertyResult("totalLocalStorageGb", "TotalLocalStorageGB", properties.TotalLocalStorageGB != null ? CfnEC2FleetTotalLocalStorageGBRequestPropertyFromCloudFormation(properties.TotalLocalStorageGB) : void 0), ret.addPropertyResult("vCpuCount", "VCpuCount", properties.VCpuCount != null ? CfnEC2FleetVCpuCountRangeRequestPropertyFromCloudFormation(properties.VCpuCount) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEC2Fleet_MaintenanceStrategiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("capacityRebalance", CfnEC2Fleet_CapacityRebalancePropertyValidator)(properties.capacityRebalance)), errors.wrap('supplied properties not correct for "MaintenanceStrategiesProperty"');
    }
    function cfnEC2FleetMaintenanceStrategiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEC2Fleet_MaintenanceStrategiesPropertyValidator(properties).assertSuccess(), { CapacityRebalance: cfnEC2FleetCapacityRebalancePropertyToCloudFormation(properties.capacityRebalance) }) : properties;
    }
    function CfnEC2FleetMaintenanceStrategiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("capacityRebalance", "CapacityRebalance", properties.CapacityRebalance != null ? CfnEC2FleetCapacityRebalancePropertyFromCloudFormation(properties.CapacityRebalance) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEC2Fleet_MemoryGiBPerVCpuRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "MemoryGiBPerVCpuRequestProperty"');
    }
    function cfnEC2FleetMemoryGiBPerVCpuRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEC2Fleet_MemoryGiBPerVCpuRequestPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnEC2FleetMemoryGiBPerVCpuRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEC2Fleet_MemoryMiBRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "MemoryMiBRequestProperty"');
    }
    function cfnEC2FleetMemoryMiBRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEC2Fleet_MemoryMiBRequestPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnEC2FleetMemoryMiBRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEC2Fleet_NetworkBandwidthGbpsRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "NetworkBandwidthGbpsRequestProperty"');
    }
    function cfnEC2FleetNetworkBandwidthGbpsRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEC2Fleet_NetworkBandwidthGbpsRequestPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnEC2FleetNetworkBandwidthGbpsRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEC2Fleet_NetworkInterfaceCountRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "NetworkInterfaceCountRequestProperty"');
    }
    function cfnEC2FleetNetworkInterfaceCountRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEC2Fleet_NetworkInterfaceCountRequestPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnEC2FleetNetworkInterfaceCountRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEC2Fleet_OnDemandOptionsRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allocationStrategy", cdk.validateString)(properties.allocationStrategy)), errors.collect(cdk.propertyValidator("capacityReservationOptions", CfnEC2Fleet_CapacityReservationOptionsRequestPropertyValidator)(properties.capacityReservationOptions)), errors.collect(cdk.propertyValidator("maxTotalPrice", cdk.validateString)(properties.maxTotalPrice)), errors.collect(cdk.propertyValidator("minTargetCapacity", cdk.validateNumber)(properties.minTargetCapacity)), errors.collect(cdk.propertyValidator("singleAvailabilityZone", cdk.validateBoolean)(properties.singleAvailabilityZone)), errors.collect(cdk.propertyValidator("singleInstanceType", cdk.validateBoolean)(properties.singleInstanceType)), errors.wrap('supplied properties not correct for "OnDemandOptionsRequestProperty"');
    }
    function cfnEC2FleetOnDemandOptionsRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEC2Fleet_OnDemandOptionsRequestPropertyValidator(properties).assertSuccess(), { AllocationStrategy: cdk.stringToCloudFormation(properties.allocationStrategy), CapacityReservationOptions: cfnEC2FleetCapacityReservationOptionsRequestPropertyToCloudFormation(properties.capacityReservationOptions), MaxTotalPrice: cdk.stringToCloudFormation(properties.maxTotalPrice), MinTargetCapacity: cdk.numberToCloudFormation(properties.minTargetCapacity), SingleAvailabilityZone: cdk.booleanToCloudFormation(properties.singleAvailabilityZone), SingleInstanceType: cdk.booleanToCloudFormation(properties.singleInstanceType) }) : properties;
    }
    function CfnEC2FleetOnDemandOptionsRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allocationStrategy", "AllocationStrategy", properties.AllocationStrategy != null ? cfn_parse.FromCloudFormation.getString(properties.AllocationStrategy) : void 0), ret.addPropertyResult("capacityReservationOptions", "CapacityReservationOptions", properties.CapacityReservationOptions != null ? CfnEC2FleetCapacityReservationOptionsRequestPropertyFromCloudFormation(properties.CapacityReservationOptions) : void 0), ret.addPropertyResult("maxTotalPrice", "MaxTotalPrice", properties.MaxTotalPrice != null ? cfn_parse.FromCloudFormation.getString(properties.MaxTotalPrice) : void 0), ret.addPropertyResult("minTargetCapacity", "MinTargetCapacity", properties.MinTargetCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinTargetCapacity) : void 0), ret.addPropertyResult("singleAvailabilityZone", "SingleAvailabilityZone", properties.SingleAvailabilityZone != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SingleAvailabilityZone) : void 0), ret.addPropertyResult("singleInstanceType", "SingleInstanceType", properties.SingleInstanceType != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SingleInstanceType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEC2Fleet_PlacementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("affinity", cdk.validateString)(properties.affinity)), errors.collect(cdk.propertyValidator("availabilityZone", cdk.validateString)(properties.availabilityZone)), errors.collect(cdk.propertyValidator("groupName", cdk.validateString)(properties.groupName)), errors.collect(cdk.propertyValidator("hostId", cdk.validateString)(properties.hostId)), errors.collect(cdk.propertyValidator("hostResourceGroupArn", cdk.validateString)(properties.hostResourceGroupArn)), errors.collect(cdk.propertyValidator("partitionNumber", cdk.validateNumber)(properties.partitionNumber)), errors.collect(cdk.propertyValidator("spreadDomain", cdk.validateString)(properties.spreadDomain)), errors.collect(cdk.propertyValidator("tenancy", cdk.validateString)(properties.tenancy)), errors.wrap('supplied properties not correct for "PlacementProperty"');
    }
    function cfnEC2FleetPlacementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEC2Fleet_PlacementPropertyValidator(properties).assertSuccess(), { Affinity: cdk.stringToCloudFormation(properties.affinity), AvailabilityZone: cdk.stringToCloudFormation(properties.availabilityZone), GroupName: cdk.stringToCloudFormation(properties.groupName), HostId: cdk.stringToCloudFormation(properties.hostId), HostResourceGroupArn: cdk.stringToCloudFormation(properties.hostResourceGroupArn), PartitionNumber: cdk.numberToCloudFormation(properties.partitionNumber), SpreadDomain: cdk.stringToCloudFormation(properties.spreadDomain), Tenancy: cdk.stringToCloudFormation(properties.tenancy) }) : properties;
    }
    function CfnEC2FleetPlacementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("affinity", "Affinity", properties.Affinity != null ? cfn_parse.FromCloudFormation.getString(properties.Affinity) : void 0), ret.addPropertyResult("availabilityZone", "AvailabilityZone", properties.AvailabilityZone != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityZone) : void 0), ret.addPropertyResult("groupName", "GroupName", properties.GroupName != null ? cfn_parse.FromCloudFormation.getString(properties.GroupName) : void 0), ret.addPropertyResult("hostId", "HostId", properties.HostId != null ? cfn_parse.FromCloudFormation.getString(properties.HostId) : void 0), ret.addPropertyResult("hostResourceGroupArn", "HostResourceGroupArn", properties.HostResourceGroupArn != null ? cfn_parse.FromCloudFormation.getString(properties.HostResourceGroupArn) : void 0), ret.addPropertyResult("partitionNumber", "PartitionNumber", properties.PartitionNumber != null ? cfn_parse.FromCloudFormation.getNumber(properties.PartitionNumber) : void 0), ret.addPropertyResult("spreadDomain", "SpreadDomain", properties.SpreadDomain != null ? cfn_parse.FromCloudFormation.getString(properties.SpreadDomain) : void 0), ret.addPropertyResult("tenancy", "Tenancy", properties.Tenancy != null ? cfn_parse.FromCloudFormation.getString(properties.Tenancy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEC2Fleet_SpotOptionsRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allocationStrategy", cdk.validateString)(properties.allocationStrategy)), errors.collect(cdk.propertyValidator("instanceInterruptionBehavior", cdk.validateString)(properties.instanceInterruptionBehavior)), errors.collect(cdk.propertyValidator("instancePoolsToUseCount", cdk.validateNumber)(properties.instancePoolsToUseCount)), errors.collect(cdk.propertyValidator("maintenanceStrategies", CfnEC2Fleet_MaintenanceStrategiesPropertyValidator)(properties.maintenanceStrategies)), errors.collect(cdk.propertyValidator("maxTotalPrice", cdk.validateString)(properties.maxTotalPrice)), errors.collect(cdk.propertyValidator("minTargetCapacity", cdk.validateNumber)(properties.minTargetCapacity)), errors.collect(cdk.propertyValidator("singleAvailabilityZone", cdk.validateBoolean)(properties.singleAvailabilityZone)), errors.collect(cdk.propertyValidator("singleInstanceType", cdk.validateBoolean)(properties.singleInstanceType)), errors.wrap('supplied properties not correct for "SpotOptionsRequestProperty"');
    }
    function cfnEC2FleetSpotOptionsRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEC2Fleet_SpotOptionsRequestPropertyValidator(properties).assertSuccess(), { AllocationStrategy: cdk.stringToCloudFormation(properties.allocationStrategy), InstanceInterruptionBehavior: cdk.stringToCloudFormation(properties.instanceInterruptionBehavior), InstancePoolsToUseCount: cdk.numberToCloudFormation(properties.instancePoolsToUseCount), MaintenanceStrategies: cfnEC2FleetMaintenanceStrategiesPropertyToCloudFormation(properties.maintenanceStrategies), MaxTotalPrice: cdk.stringToCloudFormation(properties.maxTotalPrice), MinTargetCapacity: cdk.numberToCloudFormation(properties.minTargetCapacity), SingleAvailabilityZone: cdk.booleanToCloudFormation(properties.singleAvailabilityZone), SingleInstanceType: cdk.booleanToCloudFormation(properties.singleInstanceType) }) : properties;
    }
    function CfnEC2FleetSpotOptionsRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allocationStrategy", "AllocationStrategy", properties.AllocationStrategy != null ? cfn_parse.FromCloudFormation.getString(properties.AllocationStrategy) : void 0), ret.addPropertyResult("instanceInterruptionBehavior", "InstanceInterruptionBehavior", properties.InstanceInterruptionBehavior != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceInterruptionBehavior) : void 0), ret.addPropertyResult("instancePoolsToUseCount", "InstancePoolsToUseCount", properties.InstancePoolsToUseCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.InstancePoolsToUseCount) : void 0), ret.addPropertyResult("maintenanceStrategies", "MaintenanceStrategies", properties.MaintenanceStrategies != null ? CfnEC2FleetMaintenanceStrategiesPropertyFromCloudFormation(properties.MaintenanceStrategies) : void 0), ret.addPropertyResult("maxTotalPrice", "MaxTotalPrice", properties.MaxTotalPrice != null ? cfn_parse.FromCloudFormation.getString(properties.MaxTotalPrice) : void 0), ret.addPropertyResult("minTargetCapacity", "MinTargetCapacity", properties.MinTargetCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinTargetCapacity) : void 0), ret.addPropertyResult("singleAvailabilityZone", "SingleAvailabilityZone", properties.SingleAvailabilityZone != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SingleAvailabilityZone) : void 0), ret.addPropertyResult("singleInstanceType", "SingleInstanceType", properties.SingleInstanceType != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SingleInstanceType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEC2Fleet_TagSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceType", cdk.validateString)(properties.resourceType)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "TagSpecificationProperty"');
    }
    function cfnEC2FleetTagSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEC2Fleet_TagSpecificationPropertyValidator(properties).assertSuccess(), { ResourceType: cdk.stringToCloudFormation(properties.resourceType), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnEC2FleetTagSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceType", "ResourceType", properties.ResourceType != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceType) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEC2Fleet_TargetCapacitySpecificationRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultTargetCapacityType", cdk.validateString)(properties.defaultTargetCapacityType)), errors.collect(cdk.propertyValidator("onDemandTargetCapacity", cdk.validateNumber)(properties.onDemandTargetCapacity)), errors.collect(cdk.propertyValidator("spotTargetCapacity", cdk.validateNumber)(properties.spotTargetCapacity)), errors.collect(cdk.propertyValidator("targetCapacityUnitType", cdk.validateString)(properties.targetCapacityUnitType)), errors.collect(cdk.propertyValidator("totalTargetCapacity", cdk.requiredValidator)(properties.totalTargetCapacity)), errors.collect(cdk.propertyValidator("totalTargetCapacity", cdk.validateNumber)(properties.totalTargetCapacity)), errors.wrap('supplied properties not correct for "TargetCapacitySpecificationRequestProperty"');
    }
    function cfnEC2FleetTargetCapacitySpecificationRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEC2Fleet_TargetCapacitySpecificationRequestPropertyValidator(properties).assertSuccess(), { DefaultTargetCapacityType: cdk.stringToCloudFormation(properties.defaultTargetCapacityType), OnDemandTargetCapacity: cdk.numberToCloudFormation(properties.onDemandTargetCapacity), SpotTargetCapacity: cdk.numberToCloudFormation(properties.spotTargetCapacity), TargetCapacityUnitType: cdk.stringToCloudFormation(properties.targetCapacityUnitType), TotalTargetCapacity: cdk.numberToCloudFormation(properties.totalTargetCapacity) }) : properties;
    }
    function CfnEC2FleetTargetCapacitySpecificationRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultTargetCapacityType", "DefaultTargetCapacityType", properties.DefaultTargetCapacityType != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultTargetCapacityType) : void 0), ret.addPropertyResult("onDemandTargetCapacity", "OnDemandTargetCapacity", properties.OnDemandTargetCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.OnDemandTargetCapacity) : void 0), ret.addPropertyResult("spotTargetCapacity", "SpotTargetCapacity", properties.SpotTargetCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.SpotTargetCapacity) : void 0), ret.addPropertyResult("targetCapacityUnitType", "TargetCapacityUnitType", properties.TargetCapacityUnitType != null ? cfn_parse.FromCloudFormation.getString(properties.TargetCapacityUnitType) : void 0), ret.addPropertyResult("totalTargetCapacity", "TotalTargetCapacity", cfn_parse.FromCloudFormation.getNumber(properties.TotalTargetCapacity)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEC2Fleet_TotalLocalStorageGBRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "TotalLocalStorageGBRequestProperty"');
    }
    function cfnEC2FleetTotalLocalStorageGBRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEC2Fleet_TotalLocalStorageGBRequestPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnEC2FleetTotalLocalStorageGBRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEC2Fleet_VCpuCountRangeRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "VCpuCountRangeRequestProperty"');
    }
    function cfnEC2FleetVCpuCountRangeRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEC2Fleet_VCpuCountRangeRequestPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnEC2FleetVCpuCountRangeRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEIPPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("domain", cdk.validateString)(properties.domain)), errors.collect(cdk.propertyValidator("instanceId", cdk.validateString)(properties.instanceId)), errors.collect(cdk.propertyValidator("networkBorderGroup", cdk.validateString)(properties.networkBorderGroup)), errors.collect(cdk.propertyValidator("publicIpv4Pool", cdk.validateString)(properties.publicIpv4Pool)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("transferAddress", cdk.validateString)(properties.transferAddress)), errors.wrap('supplied properties not correct for "CfnEIPProps"');
    }
    function cfnEIPPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEIPPropsValidator(properties).assertSuccess(), { Domain: cdk.stringToCloudFormation(properties.domain), InstanceId: cdk.stringToCloudFormation(properties.instanceId), NetworkBorderGroup: cdk.stringToCloudFormation(properties.networkBorderGroup), PublicIpv4Pool: cdk.stringToCloudFormation(properties.publicIpv4Pool), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TransferAddress: cdk.stringToCloudFormation(properties.transferAddress) }) : properties;
    }
    function CfnEIPPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("domain", "Domain", properties.Domain != null ? cfn_parse.FromCloudFormation.getString(properties.Domain) : void 0), ret.addPropertyResult("instanceId", "InstanceId", properties.InstanceId != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceId) : void 0), ret.addPropertyResult("networkBorderGroup", "NetworkBorderGroup", properties.NetworkBorderGroup != null ? cfn_parse.FromCloudFormation.getString(properties.NetworkBorderGroup) : void 0), ret.addPropertyResult("publicIpv4Pool", "PublicIpv4Pool", properties.PublicIpv4Pool != null ? cfn_parse.FromCloudFormation.getString(properties.PublicIpv4Pool) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("transferAddress", "TransferAddress", properties.TransferAddress != null ? cfn_parse.FromCloudFormation.getString(properties.TransferAddress) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEIP = class _CfnEIP extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEIPPropsFromCloudFormation(resourceProperties), ret = new _CfnEIP(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnEIP.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnEIPProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEIP), error;
        }
        this.attrAllocationId = cdk.Token.asString(this.getAtt("AllocationId", cdk.ResolutionTypeHint.STRING)), this.attrPublicIp = cdk.Token.asString(this.getAtt("PublicIp", cdk.ResolutionTypeHint.STRING)), this.domain = props.domain, this.instanceId = props.instanceId, this.networkBorderGroup = props.networkBorderGroup, this.publicIpv4Pool = props.publicIpv4Pool, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::EIP", props.tags, { tagPropertyName: "tags" }), this.transferAddress = props.transferAddress;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEIP.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { domain: this.domain, instanceId: this.instanceId, networkBorderGroup: this.networkBorderGroup, publicIpv4Pool: this.publicIpv4Pool, tags: this.tags.renderTags(), transferAddress: this.transferAddress };
      }
      renderProperties(props) {
        return cfnEIPPropsToCloudFormation(props);
      }
    };
    _l = JSII_RTTI_SYMBOL_1, CfnEIP[_l] = { fqn: "aws-cdk-lib.aws_ec2.CfnEIP", version: "2.80.0" }, CfnEIP.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::EIP", exports2.CfnEIP = CfnEIP;
    function CfnEIPAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allocationId", cdk.validateString)(properties.allocationId)), errors.collect(cdk.propertyValidator("eip", cdk.validateString)(properties.eip)), errors.collect(cdk.propertyValidator("instanceId", cdk.validateString)(properties.instanceId)), errors.collect(cdk.propertyValidator("networkInterfaceId", cdk.validateString)(properties.networkInterfaceId)), errors.collect(cdk.propertyValidator("privateIpAddress", cdk.validateString)(properties.privateIpAddress)), errors.wrap('supplied properties not correct for "CfnEIPAssociationProps"');
    }
    function cfnEIPAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEIPAssociationPropsValidator(properties).assertSuccess(), { AllocationId: cdk.stringToCloudFormation(properties.allocationId), EIP: cdk.stringToCloudFormation(properties.eip), InstanceId: cdk.stringToCloudFormation(properties.instanceId), NetworkInterfaceId: cdk.stringToCloudFormation(properties.networkInterfaceId), PrivateIpAddress: cdk.stringToCloudFormation(properties.privateIpAddress) }) : properties;
    }
    function CfnEIPAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allocationId", "AllocationId", properties.AllocationId != null ? cfn_parse.FromCloudFormation.getString(properties.AllocationId) : void 0), ret.addPropertyResult("eip", "EIP", properties.EIP != null ? cfn_parse.FromCloudFormation.getString(properties.EIP) : void 0), ret.addPropertyResult("instanceId", "InstanceId", properties.InstanceId != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceId) : void 0), ret.addPropertyResult("networkInterfaceId", "NetworkInterfaceId", properties.NetworkInterfaceId != null ? cfn_parse.FromCloudFormation.getString(properties.NetworkInterfaceId) : void 0), ret.addPropertyResult("privateIpAddress", "PrivateIpAddress", properties.PrivateIpAddress != null ? cfn_parse.FromCloudFormation.getString(properties.PrivateIpAddress) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEIPAssociation = class _CfnEIPAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEIPAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnEIPAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnEIPAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnEIPAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEIPAssociation), error;
        }
        this.allocationId = props.allocationId, this.eip = props.eip, this.instanceId = props.instanceId, this.networkInterfaceId = props.networkInterfaceId, this.privateIpAddress = props.privateIpAddress;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEIPAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { allocationId: this.allocationId, eip: this.eip, instanceId: this.instanceId, networkInterfaceId: this.networkInterfaceId, privateIpAddress: this.privateIpAddress };
      }
      renderProperties(props) {
        return cfnEIPAssociationPropsToCloudFormation(props);
      }
    };
    _m = JSII_RTTI_SYMBOL_1, CfnEIPAssociation[_m] = { fqn: "aws-cdk-lib.aws_ec2.CfnEIPAssociation", version: "2.80.0" }, CfnEIPAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::EIPAssociation", exports2.CfnEIPAssociation = CfnEIPAssociation;
    function CfnEgressOnlyInternetGatewayPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("vpcId", cdk.requiredValidator)(properties.vpcId)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "CfnEgressOnlyInternetGatewayProps"');
    }
    function cfnEgressOnlyInternetGatewayPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEgressOnlyInternetGatewayPropsValidator(properties).assertSuccess(), { VpcId: cdk.stringToCloudFormation(properties.vpcId) }) : properties;
    }
    function CfnEgressOnlyInternetGatewayPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("vpcId", "VpcId", cfn_parse.FromCloudFormation.getString(properties.VpcId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEgressOnlyInternetGateway = class _CfnEgressOnlyInternetGateway extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEgressOnlyInternetGatewayPropsFromCloudFormation(resourceProperties), ret = new _CfnEgressOnlyInternetGateway(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEgressOnlyInternetGateway.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnEgressOnlyInternetGatewayProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEgressOnlyInternetGateway), error;
        }
        cdk.requireProperty(props, "vpcId", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.vpcId = props.vpcId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEgressOnlyInternetGateway.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { vpcId: this.vpcId };
      }
      renderProperties(props) {
        return cfnEgressOnlyInternetGatewayPropsToCloudFormation(props);
      }
    };
    _o = JSII_RTTI_SYMBOL_1, CfnEgressOnlyInternetGateway[_o] = { fqn: "aws-cdk-lib.aws_ec2.CfnEgressOnlyInternetGateway", version: "2.80.0" }, CfnEgressOnlyInternetGateway.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::EgressOnlyInternetGateway", exports2.CfnEgressOnlyInternetGateway = CfnEgressOnlyInternetGateway;
    function CfnEnclaveCertificateIamRoleAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateArn", cdk.requiredValidator)(properties.certificateArn)), errors.collect(cdk.propertyValidator("certificateArn", cdk.validateString)(properties.certificateArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "CfnEnclaveCertificateIamRoleAssociationProps"');
    }
    function cfnEnclaveCertificateIamRoleAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEnclaveCertificateIamRoleAssociationPropsValidator(properties).assertSuccess(), { CertificateArn: cdk.stringToCloudFormation(properties.certificateArn), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnEnclaveCertificateIamRoleAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificateArn", "CertificateArn", cfn_parse.FromCloudFormation.getString(properties.CertificateArn)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEnclaveCertificateIamRoleAssociation = class _CfnEnclaveCertificateIamRoleAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEnclaveCertificateIamRoleAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnEnclaveCertificateIamRoleAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEnclaveCertificateIamRoleAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnEnclaveCertificateIamRoleAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEnclaveCertificateIamRoleAssociation), error;
        }
        cdk.requireProperty(props, "certificateArn", this), cdk.requireProperty(props, "roleArn", this), this.attrCertificateS3BucketName = cdk.Token.asString(this.getAtt("CertificateS3BucketName", cdk.ResolutionTypeHint.STRING)), this.attrCertificateS3ObjectKey = cdk.Token.asString(this.getAtt("CertificateS3ObjectKey", cdk.ResolutionTypeHint.STRING)), this.attrEncryptionKmsKeyId = cdk.Token.asString(this.getAtt("EncryptionKmsKeyId", cdk.ResolutionTypeHint.STRING)), this.certificateArn = props.certificateArn, this.roleArn = props.roleArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEnclaveCertificateIamRoleAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { certificateArn: this.certificateArn, roleArn: this.roleArn };
      }
      renderProperties(props) {
        return cfnEnclaveCertificateIamRoleAssociationPropsToCloudFormation(props);
      }
    };
    _p = JSII_RTTI_SYMBOL_1, CfnEnclaveCertificateIamRoleAssociation[_p] = { fqn: "aws-cdk-lib.aws_ec2.CfnEnclaveCertificateIamRoleAssociation", version: "2.80.0" }, CfnEnclaveCertificateIamRoleAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::EnclaveCertificateIamRoleAssociation", exports2.CfnEnclaveCertificateIamRoleAssociation = CfnEnclaveCertificateIamRoleAssociation;
    function CfnFlowLogPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deliverLogsPermissionArn", cdk.validateString)(properties.deliverLogsPermissionArn)), errors.collect(cdk.propertyValidator("destinationOptions", cdk.validateObject)(properties.destinationOptions)), errors.collect(cdk.propertyValidator("logDestination", cdk.validateString)(properties.logDestination)), errors.collect(cdk.propertyValidator("logDestinationType", cdk.validateString)(properties.logDestinationType)), errors.collect(cdk.propertyValidator("logFormat", cdk.validateString)(properties.logFormat)), errors.collect(cdk.propertyValidator("logGroupName", cdk.validateString)(properties.logGroupName)), errors.collect(cdk.propertyValidator("maxAggregationInterval", cdk.validateNumber)(properties.maxAggregationInterval)), errors.collect(cdk.propertyValidator("resourceId", cdk.requiredValidator)(properties.resourceId)), errors.collect(cdk.propertyValidator("resourceId", cdk.validateString)(properties.resourceId)), errors.collect(cdk.propertyValidator("resourceType", cdk.requiredValidator)(properties.resourceType)), errors.collect(cdk.propertyValidator("resourceType", cdk.validateString)(properties.resourceType)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("trafficType", cdk.validateString)(properties.trafficType)), errors.wrap('supplied properties not correct for "CfnFlowLogProps"');
    }
    function cfnFlowLogPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlowLogPropsValidator(properties).assertSuccess(), { ResourceId: cdk.stringToCloudFormation(properties.resourceId), ResourceType: cdk.stringToCloudFormation(properties.resourceType), DeliverLogsPermissionArn: cdk.stringToCloudFormation(properties.deliverLogsPermissionArn), DestinationOptions: cdk.objectToCloudFormation(properties.destinationOptions), LogDestination: cdk.stringToCloudFormation(properties.logDestination), LogDestinationType: cdk.stringToCloudFormation(properties.logDestinationType), LogFormat: cdk.stringToCloudFormation(properties.logFormat), LogGroupName: cdk.stringToCloudFormation(properties.logGroupName), MaxAggregationInterval: cdk.numberToCloudFormation(properties.maxAggregationInterval), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TrafficType: cdk.stringToCloudFormation(properties.trafficType) }) : properties;
    }
    function CfnFlowLogPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceId", "ResourceId", cfn_parse.FromCloudFormation.getString(properties.ResourceId)), ret.addPropertyResult("resourceType", "ResourceType", cfn_parse.FromCloudFormation.getString(properties.ResourceType)), ret.addPropertyResult("deliverLogsPermissionArn", "DeliverLogsPermissionArn", properties.DeliverLogsPermissionArn != null ? cfn_parse.FromCloudFormation.getString(properties.DeliverLogsPermissionArn) : void 0), ret.addPropertyResult("destinationOptions", "DestinationOptions", properties.DestinationOptions != null ? cfn_parse.FromCloudFormation.getAny(properties.DestinationOptions) : void 0), ret.addPropertyResult("logDestination", "LogDestination", properties.LogDestination != null ? cfn_parse.FromCloudFormation.getString(properties.LogDestination) : void 0), ret.addPropertyResult("logDestinationType", "LogDestinationType", properties.LogDestinationType != null ? cfn_parse.FromCloudFormation.getString(properties.LogDestinationType) : void 0), ret.addPropertyResult("logFormat", "LogFormat", properties.LogFormat != null ? cfn_parse.FromCloudFormation.getString(properties.LogFormat) : void 0), ret.addPropertyResult("logGroupName", "LogGroupName", properties.LogGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.LogGroupName) : void 0), ret.addPropertyResult("maxAggregationInterval", "MaxAggregationInterval", properties.MaxAggregationInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxAggregationInterval) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("trafficType", "TrafficType", properties.TrafficType != null ? cfn_parse.FromCloudFormation.getString(properties.TrafficType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFlowLog = class _CfnFlowLog extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFlowLogPropsFromCloudFormation(resourceProperties), ret = new _CfnFlowLog(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFlowLog.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnFlowLogProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFlowLog), error;
        }
        cdk.requireProperty(props, "resourceId", this), cdk.requireProperty(props, "resourceType", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.resourceId = props.resourceId, this.resourceType = props.resourceType, this.deliverLogsPermissionArn = props.deliverLogsPermissionArn, this.destinationOptions = props.destinationOptions, this.logDestination = props.logDestination, this.logDestinationType = props.logDestinationType, this.logFormat = props.logFormat, this.logGroupName = props.logGroupName, this.maxAggregationInterval = props.maxAggregationInterval, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::FlowLog", props.tags, { tagPropertyName: "tags" }), this.trafficType = props.trafficType;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFlowLog.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { resourceId: this.resourceId, resourceType: this.resourceType, deliverLogsPermissionArn: this.deliverLogsPermissionArn, destinationOptions: this.destinationOptions, logDestination: this.logDestination, logDestinationType: this.logDestinationType, logFormat: this.logFormat, logGroupName: this.logGroupName, maxAggregationInterval: this.maxAggregationInterval, tags: this.tags.renderTags(), trafficType: this.trafficType };
      }
      renderProperties(props) {
        return cfnFlowLogPropsToCloudFormation(props);
      }
    };
    _q = JSII_RTTI_SYMBOL_1, CfnFlowLog[_q] = { fqn: "aws-cdk-lib.aws_ec2.CfnFlowLog", version: "2.80.0" }, CfnFlowLog.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::FlowLog", exports2.CfnFlowLog = CfnFlowLog;
    function CfnGatewayRouteTableAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("gatewayId", cdk.requiredValidator)(properties.gatewayId)), errors.collect(cdk.propertyValidator("gatewayId", cdk.validateString)(properties.gatewayId)), errors.collect(cdk.propertyValidator("routeTableId", cdk.requiredValidator)(properties.routeTableId)), errors.collect(cdk.propertyValidator("routeTableId", cdk.validateString)(properties.routeTableId)), errors.wrap('supplied properties not correct for "CfnGatewayRouteTableAssociationProps"');
    }
    function cfnGatewayRouteTableAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGatewayRouteTableAssociationPropsValidator(properties).assertSuccess(), { GatewayId: cdk.stringToCloudFormation(properties.gatewayId), RouteTableId: cdk.stringToCloudFormation(properties.routeTableId) }) : properties;
    }
    function CfnGatewayRouteTableAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("gatewayId", "GatewayId", cfn_parse.FromCloudFormation.getString(properties.GatewayId)), ret.addPropertyResult("routeTableId", "RouteTableId", cfn_parse.FromCloudFormation.getString(properties.RouteTableId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnGatewayRouteTableAssociation = class _CfnGatewayRouteTableAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnGatewayRouteTableAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnGatewayRouteTableAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnGatewayRouteTableAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnGatewayRouteTableAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnGatewayRouteTableAssociation), error;
        }
        cdk.requireProperty(props, "gatewayId", this), cdk.requireProperty(props, "routeTableId", this), this.attrAssociationId = cdk.Token.asString(this.getAtt("AssociationId", cdk.ResolutionTypeHint.STRING)), this.gatewayId = props.gatewayId, this.routeTableId = props.routeTableId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnGatewayRouteTableAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { gatewayId: this.gatewayId, routeTableId: this.routeTableId };
      }
      renderProperties(props) {
        return cfnGatewayRouteTableAssociationPropsToCloudFormation(props);
      }
    };
    _r = JSII_RTTI_SYMBOL_1, CfnGatewayRouteTableAssociation[_r] = { fqn: "aws-cdk-lib.aws_ec2.CfnGatewayRouteTableAssociation", version: "2.80.0" }, CfnGatewayRouteTableAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::GatewayRouteTableAssociation", exports2.CfnGatewayRouteTableAssociation = CfnGatewayRouteTableAssociation;
    function CfnHostPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoPlacement", cdk.validateString)(properties.autoPlacement)), errors.collect(cdk.propertyValidator("availabilityZone", cdk.requiredValidator)(properties.availabilityZone)), errors.collect(cdk.propertyValidator("availabilityZone", cdk.validateString)(properties.availabilityZone)), errors.collect(cdk.propertyValidator("hostMaintenance", cdk.validateString)(properties.hostMaintenance)), errors.collect(cdk.propertyValidator("hostRecovery", cdk.validateString)(properties.hostRecovery)), errors.collect(cdk.propertyValidator("instanceFamily", cdk.validateString)(properties.instanceFamily)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("outpostArn", cdk.validateString)(properties.outpostArn)), errors.wrap('supplied properties not correct for "CfnHostProps"');
    }
    function cfnHostPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHostPropsValidator(properties).assertSuccess(), { AvailabilityZone: cdk.stringToCloudFormation(properties.availabilityZone), AutoPlacement: cdk.stringToCloudFormation(properties.autoPlacement), HostMaintenance: cdk.stringToCloudFormation(properties.hostMaintenance), HostRecovery: cdk.stringToCloudFormation(properties.hostRecovery), InstanceFamily: cdk.stringToCloudFormation(properties.instanceFamily), InstanceType: cdk.stringToCloudFormation(properties.instanceType), OutpostArn: cdk.stringToCloudFormation(properties.outpostArn) }) : properties;
    }
    function CfnHostPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("availabilityZone", "AvailabilityZone", cfn_parse.FromCloudFormation.getString(properties.AvailabilityZone)), ret.addPropertyResult("autoPlacement", "AutoPlacement", properties.AutoPlacement != null ? cfn_parse.FromCloudFormation.getString(properties.AutoPlacement) : void 0), ret.addPropertyResult("hostMaintenance", "HostMaintenance", properties.HostMaintenance != null ? cfn_parse.FromCloudFormation.getString(properties.HostMaintenance) : void 0), ret.addPropertyResult("hostRecovery", "HostRecovery", properties.HostRecovery != null ? cfn_parse.FromCloudFormation.getString(properties.HostRecovery) : void 0), ret.addPropertyResult("instanceFamily", "InstanceFamily", properties.InstanceFamily != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceFamily) : void 0), ret.addPropertyResult("instanceType", "InstanceType", properties.InstanceType != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceType) : void 0), ret.addPropertyResult("outpostArn", "OutpostArn", properties.OutpostArn != null ? cfn_parse.FromCloudFormation.getString(properties.OutpostArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnHost = class _CfnHost extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnHostPropsFromCloudFormation(resourceProperties), ret = new _CfnHost(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnHost.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnHostProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnHost), error;
        }
        cdk.requireProperty(props, "availabilityZone", this), this.attrHostId = cdk.Token.asString(this.getAtt("HostId", cdk.ResolutionTypeHint.STRING)), this.availabilityZone = props.availabilityZone, this.autoPlacement = props.autoPlacement, this.hostMaintenance = props.hostMaintenance, this.hostRecovery = props.hostRecovery, this.instanceFamily = props.instanceFamily, this.instanceType = props.instanceType, this.outpostArn = props.outpostArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnHost.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { availabilityZone: this.availabilityZone, autoPlacement: this.autoPlacement, hostMaintenance: this.hostMaintenance, hostRecovery: this.hostRecovery, instanceFamily: this.instanceFamily, instanceType: this.instanceType, outpostArn: this.outpostArn };
      }
      renderProperties(props) {
        return cfnHostPropsToCloudFormation(props);
      }
    };
    _s = JSII_RTTI_SYMBOL_1, CfnHost[_s] = { fqn: "aws-cdk-lib.aws_ec2.CfnHost", version: "2.80.0" }, CfnHost.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::Host", exports2.CfnHost = CfnHost;
    function CfnIPAMPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultResourceDiscoveryAssociationId", cdk.validateString)(properties.defaultResourceDiscoveryAssociationId)), errors.collect(cdk.propertyValidator("defaultResourceDiscoveryId", cdk.validateString)(properties.defaultResourceDiscoveryId)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("operatingRegions", cdk.listValidator(CfnIPAM_IpamOperatingRegionPropertyValidator))(properties.operatingRegions)), errors.collect(cdk.propertyValidator("resourceDiscoveryAssociationCount", cdk.validateNumber)(properties.resourceDiscoveryAssociationCount)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnIPAMProps"');
    }
    function cfnIPAMPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIPAMPropsValidator(properties).assertSuccess(), { DefaultResourceDiscoveryAssociationId: cdk.stringToCloudFormation(properties.defaultResourceDiscoveryAssociationId), DefaultResourceDiscoveryId: cdk.stringToCloudFormation(properties.defaultResourceDiscoveryId), Description: cdk.stringToCloudFormation(properties.description), OperatingRegions: cdk.listMapper(cfnIPAMIpamOperatingRegionPropertyToCloudFormation)(properties.operatingRegions), ResourceDiscoveryAssociationCount: cdk.numberToCloudFormation(properties.resourceDiscoveryAssociationCount), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnIPAMPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultResourceDiscoveryAssociationId", "DefaultResourceDiscoveryAssociationId", properties.DefaultResourceDiscoveryAssociationId != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultResourceDiscoveryAssociationId) : void 0), ret.addPropertyResult("defaultResourceDiscoveryId", "DefaultResourceDiscoveryId", properties.DefaultResourceDiscoveryId != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultResourceDiscoveryId) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("operatingRegions", "OperatingRegions", properties.OperatingRegions != null ? cfn_parse.FromCloudFormation.getArray(CfnIPAMIpamOperatingRegionPropertyFromCloudFormation)(properties.OperatingRegions) : void 0), ret.addPropertyResult("resourceDiscoveryAssociationCount", "ResourceDiscoveryAssociationCount", properties.ResourceDiscoveryAssociationCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.ResourceDiscoveryAssociationCount) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnIPAM = class _CfnIPAM extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnIPAMPropsFromCloudFormation(resourceProperties), ret = new _CfnIPAM(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnIPAM.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnIPAMProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnIPAM), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrIpamId = cdk.Token.asString(this.getAtt("IpamId", cdk.ResolutionTypeHint.STRING)), this.attrPrivateDefaultScopeId = cdk.Token.asString(this.getAtt("PrivateDefaultScopeId", cdk.ResolutionTypeHint.STRING)), this.attrPublicDefaultScopeId = cdk.Token.asString(this.getAtt("PublicDefaultScopeId", cdk.ResolutionTypeHint.STRING)), this.attrScopeCount = cdk.Token.asNumber(this.getAtt("ScopeCount", cdk.ResolutionTypeHint.NUMBER)), this.defaultResourceDiscoveryAssociationId = props.defaultResourceDiscoveryAssociationId, this.defaultResourceDiscoveryId = props.defaultResourceDiscoveryId, this.description = props.description, this.operatingRegions = props.operatingRegions, this.resourceDiscoveryAssociationCount = props.resourceDiscoveryAssociationCount, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::IPAM", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnIPAM.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { defaultResourceDiscoveryAssociationId: this.defaultResourceDiscoveryAssociationId, defaultResourceDiscoveryId: this.defaultResourceDiscoveryId, description: this.description, operatingRegions: this.operatingRegions, resourceDiscoveryAssociationCount: this.resourceDiscoveryAssociationCount, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnIPAMPropsToCloudFormation(props);
      }
    };
    _t = JSII_RTTI_SYMBOL_1, CfnIPAM[_t] = { fqn: "aws-cdk-lib.aws_ec2.CfnIPAM", version: "2.80.0" }, CfnIPAM.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::IPAM", exports2.CfnIPAM = CfnIPAM;
    function CfnIPAM_IpamOperatingRegionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("regionName", cdk.requiredValidator)(properties.regionName)), errors.collect(cdk.propertyValidator("regionName", cdk.validateString)(properties.regionName)), errors.wrap('supplied properties not correct for "IpamOperatingRegionProperty"');
    }
    function cfnIPAMIpamOperatingRegionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIPAM_IpamOperatingRegionPropertyValidator(properties).assertSuccess(), { RegionName: cdk.stringToCloudFormation(properties.regionName) }) : properties;
    }
    function CfnIPAMIpamOperatingRegionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("regionName", "RegionName", cfn_parse.FromCloudFormation.getString(properties.RegionName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIPAMAllocationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cidr", cdk.validateString)(properties.cidr)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("ipamPoolId", cdk.requiredValidator)(properties.ipamPoolId)), errors.collect(cdk.propertyValidator("ipamPoolId", cdk.validateString)(properties.ipamPoolId)), errors.collect(cdk.propertyValidator("netmaskLength", cdk.validateNumber)(properties.netmaskLength)), errors.wrap('supplied properties not correct for "CfnIPAMAllocationProps"');
    }
    function cfnIPAMAllocationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIPAMAllocationPropsValidator(properties).assertSuccess(), { IpamPoolId: cdk.stringToCloudFormation(properties.ipamPoolId), Cidr: cdk.stringToCloudFormation(properties.cidr), Description: cdk.stringToCloudFormation(properties.description), NetmaskLength: cdk.numberToCloudFormation(properties.netmaskLength) }) : properties;
    }
    function CfnIPAMAllocationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ipamPoolId", "IpamPoolId", cfn_parse.FromCloudFormation.getString(properties.IpamPoolId)), ret.addPropertyResult("cidr", "Cidr", properties.Cidr != null ? cfn_parse.FromCloudFormation.getString(properties.Cidr) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("netmaskLength", "NetmaskLength", properties.NetmaskLength != null ? cfn_parse.FromCloudFormation.getNumber(properties.NetmaskLength) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnIPAMAllocation = class _CfnIPAMAllocation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnIPAMAllocationPropsFromCloudFormation(resourceProperties), ret = new _CfnIPAMAllocation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnIPAMAllocation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnIPAMAllocationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnIPAMAllocation), error;
        }
        cdk.requireProperty(props, "ipamPoolId", this), this.attrIpamPoolAllocationId = cdk.Token.asString(this.getAtt("IpamPoolAllocationId", cdk.ResolutionTypeHint.STRING)), this.ipamPoolId = props.ipamPoolId, this.cidr = props.cidr, this.description = props.description, this.netmaskLength = props.netmaskLength;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnIPAMAllocation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { ipamPoolId: this.ipamPoolId, cidr: this.cidr, description: this.description, netmaskLength: this.netmaskLength };
      }
      renderProperties(props) {
        return cfnIPAMAllocationPropsToCloudFormation(props);
      }
    };
    _u = JSII_RTTI_SYMBOL_1, CfnIPAMAllocation[_u] = { fqn: "aws-cdk-lib.aws_ec2.CfnIPAMAllocation", version: "2.80.0" }, CfnIPAMAllocation.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::IPAMAllocation", exports2.CfnIPAMAllocation = CfnIPAMAllocation;
    function CfnIPAMPoolPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("addressFamily", cdk.requiredValidator)(properties.addressFamily)), errors.collect(cdk.propertyValidator("addressFamily", cdk.validateString)(properties.addressFamily)), errors.collect(cdk.propertyValidator("allocationDefaultNetmaskLength", cdk.validateNumber)(properties.allocationDefaultNetmaskLength)), errors.collect(cdk.propertyValidator("allocationMaxNetmaskLength", cdk.validateNumber)(properties.allocationMaxNetmaskLength)), errors.collect(cdk.propertyValidator("allocationMinNetmaskLength", cdk.validateNumber)(properties.allocationMinNetmaskLength)), errors.collect(cdk.propertyValidator("allocationResourceTags", cdk.listValidator(cdk.validateCfnTag))(properties.allocationResourceTags)), errors.collect(cdk.propertyValidator("autoImport", cdk.validateBoolean)(properties.autoImport)), errors.collect(cdk.propertyValidator("awsService", cdk.validateString)(properties.awsService)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("ipamScopeId", cdk.requiredValidator)(properties.ipamScopeId)), errors.collect(cdk.propertyValidator("ipamScopeId", cdk.validateString)(properties.ipamScopeId)), errors.collect(cdk.propertyValidator("locale", cdk.validateString)(properties.locale)), errors.collect(cdk.propertyValidator("provisionedCidrs", cdk.listValidator(CfnIPAMPool_ProvisionedCidrPropertyValidator))(properties.provisionedCidrs)), errors.collect(cdk.propertyValidator("publicIpSource", cdk.validateString)(properties.publicIpSource)), errors.collect(cdk.propertyValidator("publiclyAdvertisable", cdk.validateBoolean)(properties.publiclyAdvertisable)), errors.collect(cdk.propertyValidator("sourceIpamPoolId", cdk.validateString)(properties.sourceIpamPoolId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnIPAMPoolProps"');
    }
    function cfnIPAMPoolPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIPAMPoolPropsValidator(properties).assertSuccess(), { AddressFamily: cdk.stringToCloudFormation(properties.addressFamily), IpamScopeId: cdk.stringToCloudFormation(properties.ipamScopeId), AllocationDefaultNetmaskLength: cdk.numberToCloudFormation(properties.allocationDefaultNetmaskLength), AllocationMaxNetmaskLength: cdk.numberToCloudFormation(properties.allocationMaxNetmaskLength), AllocationMinNetmaskLength: cdk.numberToCloudFormation(properties.allocationMinNetmaskLength), AllocationResourceTags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.allocationResourceTags), AutoImport: cdk.booleanToCloudFormation(properties.autoImport), AwsService: cdk.stringToCloudFormation(properties.awsService), Description: cdk.stringToCloudFormation(properties.description), Locale: cdk.stringToCloudFormation(properties.locale), ProvisionedCidrs: cdk.listMapper(cfnIPAMPoolProvisionedCidrPropertyToCloudFormation)(properties.provisionedCidrs), PublicIpSource: cdk.stringToCloudFormation(properties.publicIpSource), PubliclyAdvertisable: cdk.booleanToCloudFormation(properties.publiclyAdvertisable), SourceIpamPoolId: cdk.stringToCloudFormation(properties.sourceIpamPoolId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnIPAMPoolPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("addressFamily", "AddressFamily", cfn_parse.FromCloudFormation.getString(properties.AddressFamily)), ret.addPropertyResult("ipamScopeId", "IpamScopeId", cfn_parse.FromCloudFormation.getString(properties.IpamScopeId)), ret.addPropertyResult("allocationDefaultNetmaskLength", "AllocationDefaultNetmaskLength", properties.AllocationDefaultNetmaskLength != null ? cfn_parse.FromCloudFormation.getNumber(properties.AllocationDefaultNetmaskLength) : void 0), ret.addPropertyResult("allocationMaxNetmaskLength", "AllocationMaxNetmaskLength", properties.AllocationMaxNetmaskLength != null ? cfn_parse.FromCloudFormation.getNumber(properties.AllocationMaxNetmaskLength) : void 0), ret.addPropertyResult("allocationMinNetmaskLength", "AllocationMinNetmaskLength", properties.AllocationMinNetmaskLength != null ? cfn_parse.FromCloudFormation.getNumber(properties.AllocationMinNetmaskLength) : void 0), ret.addPropertyResult("allocationResourceTags", "AllocationResourceTags", properties.AllocationResourceTags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.AllocationResourceTags) : void 0), ret.addPropertyResult("autoImport", "AutoImport", properties.AutoImport != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AutoImport) : void 0), ret.addPropertyResult("awsService", "AwsService", properties.AwsService != null ? cfn_parse.FromCloudFormation.getString(properties.AwsService) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("locale", "Locale", properties.Locale != null ? cfn_parse.FromCloudFormation.getString(properties.Locale) : void 0), ret.addPropertyResult("provisionedCidrs", "ProvisionedCidrs", properties.ProvisionedCidrs != null ? cfn_parse.FromCloudFormation.getArray(CfnIPAMPoolProvisionedCidrPropertyFromCloudFormation)(properties.ProvisionedCidrs) : void 0), ret.addPropertyResult("publicIpSource", "PublicIpSource", properties.PublicIpSource != null ? cfn_parse.FromCloudFormation.getString(properties.PublicIpSource) : void 0), ret.addPropertyResult("publiclyAdvertisable", "PubliclyAdvertisable", properties.PubliclyAdvertisable != null ? cfn_parse.FromCloudFormation.getBoolean(properties.PubliclyAdvertisable) : void 0), ret.addPropertyResult("sourceIpamPoolId", "SourceIpamPoolId", properties.SourceIpamPoolId != null ? cfn_parse.FromCloudFormation.getString(properties.SourceIpamPoolId) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnIPAMPool = class _CfnIPAMPool extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnIPAMPoolPropsFromCloudFormation(resourceProperties), ret = new _CfnIPAMPool(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnIPAMPool.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnIPAMPoolProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnIPAMPool), error;
        }
        cdk.requireProperty(props, "addressFamily", this), cdk.requireProperty(props, "ipamScopeId", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrIpamArn = cdk.Token.asString(this.getAtt("IpamArn", cdk.ResolutionTypeHint.STRING)), this.attrIpamPoolId = cdk.Token.asString(this.getAtt("IpamPoolId", cdk.ResolutionTypeHint.STRING)), this.attrIpamScopeArn = cdk.Token.asString(this.getAtt("IpamScopeArn", cdk.ResolutionTypeHint.STRING)), this.attrIpamScopeType = cdk.Token.asString(this.getAtt("IpamScopeType", cdk.ResolutionTypeHint.STRING)), this.attrPoolDepth = cdk.Token.asNumber(this.getAtt("PoolDepth", cdk.ResolutionTypeHint.NUMBER)), this.attrState = cdk.Token.asString(this.getAtt("State", cdk.ResolutionTypeHint.STRING)), this.attrStateMessage = cdk.Token.asString(this.getAtt("StateMessage", cdk.ResolutionTypeHint.STRING)), this.addressFamily = props.addressFamily, this.ipamScopeId = props.ipamScopeId, this.allocationDefaultNetmaskLength = props.allocationDefaultNetmaskLength, this.allocationMaxNetmaskLength = props.allocationMaxNetmaskLength, this.allocationMinNetmaskLength = props.allocationMinNetmaskLength, this.allocationResourceTags = props.allocationResourceTags, this.autoImport = props.autoImport, this.awsService = props.awsService, this.description = props.description, this.locale = props.locale, this.provisionedCidrs = props.provisionedCidrs, this.publicIpSource = props.publicIpSource, this.publiclyAdvertisable = props.publiclyAdvertisable, this.sourceIpamPoolId = props.sourceIpamPoolId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::IPAMPool", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnIPAMPool.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { addressFamily: this.addressFamily, ipamScopeId: this.ipamScopeId, allocationDefaultNetmaskLength: this.allocationDefaultNetmaskLength, allocationMaxNetmaskLength: this.allocationMaxNetmaskLength, allocationMinNetmaskLength: this.allocationMinNetmaskLength, allocationResourceTags: this.allocationResourceTags, autoImport: this.autoImport, awsService: this.awsService, description: this.description, locale: this.locale, provisionedCidrs: this.provisionedCidrs, publicIpSource: this.publicIpSource, publiclyAdvertisable: this.publiclyAdvertisable, sourceIpamPoolId: this.sourceIpamPoolId, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnIPAMPoolPropsToCloudFormation(props);
      }
    };
    _v = JSII_RTTI_SYMBOL_1, CfnIPAMPool[_v] = { fqn: "aws-cdk-lib.aws_ec2.CfnIPAMPool", version: "2.80.0" }, CfnIPAMPool.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::IPAMPool", exports2.CfnIPAMPool = CfnIPAMPool;
    function CfnIPAMPool_ProvisionedCidrPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cidr", cdk.requiredValidator)(properties.cidr)), errors.collect(cdk.propertyValidator("cidr", cdk.validateString)(properties.cidr)), errors.wrap('supplied properties not correct for "ProvisionedCidrProperty"');
    }
    function cfnIPAMPoolProvisionedCidrPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIPAMPool_ProvisionedCidrPropertyValidator(properties).assertSuccess(), { Cidr: cdk.stringToCloudFormation(properties.cidr) }) : properties;
    }
    function CfnIPAMPoolProvisionedCidrPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cidr", "Cidr", cfn_parse.FromCloudFormation.getString(properties.Cidr)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIPAMPoolCidrPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cidr", cdk.validateString)(properties.cidr)), errors.collect(cdk.propertyValidator("ipamPoolId", cdk.requiredValidator)(properties.ipamPoolId)), errors.collect(cdk.propertyValidator("ipamPoolId", cdk.validateString)(properties.ipamPoolId)), errors.collect(cdk.propertyValidator("netmaskLength", cdk.validateNumber)(properties.netmaskLength)), errors.wrap('supplied properties not correct for "CfnIPAMPoolCidrProps"');
    }
    function cfnIPAMPoolCidrPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIPAMPoolCidrPropsValidator(properties).assertSuccess(), { IpamPoolId: cdk.stringToCloudFormation(properties.ipamPoolId), Cidr: cdk.stringToCloudFormation(properties.cidr), NetmaskLength: cdk.numberToCloudFormation(properties.netmaskLength) }) : properties;
    }
    function CfnIPAMPoolCidrPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ipamPoolId", "IpamPoolId", cfn_parse.FromCloudFormation.getString(properties.IpamPoolId)), ret.addPropertyResult("cidr", "Cidr", properties.Cidr != null ? cfn_parse.FromCloudFormation.getString(properties.Cidr) : void 0), ret.addPropertyResult("netmaskLength", "NetmaskLength", properties.NetmaskLength != null ? cfn_parse.FromCloudFormation.getNumber(properties.NetmaskLength) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnIPAMPoolCidr = class _CfnIPAMPoolCidr extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnIPAMPoolCidrPropsFromCloudFormation(resourceProperties), ret = new _CfnIPAMPoolCidr(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnIPAMPoolCidr.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnIPAMPoolCidrProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnIPAMPoolCidr), error;
        }
        cdk.requireProperty(props, "ipamPoolId", this), this.attrIpamPoolCidrId = cdk.Token.asString(this.getAtt("IpamPoolCidrId", cdk.ResolutionTypeHint.STRING)), this.attrState = cdk.Token.asString(this.getAtt("State", cdk.ResolutionTypeHint.STRING)), this.ipamPoolId = props.ipamPoolId, this.cidr = props.cidr, this.netmaskLength = props.netmaskLength;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnIPAMPoolCidr.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { ipamPoolId: this.ipamPoolId, cidr: this.cidr, netmaskLength: this.netmaskLength };
      }
      renderProperties(props) {
        return cfnIPAMPoolCidrPropsToCloudFormation(props);
      }
    };
    _w = JSII_RTTI_SYMBOL_1, CfnIPAMPoolCidr[_w] = { fqn: "aws-cdk-lib.aws_ec2.CfnIPAMPoolCidr", version: "2.80.0" }, CfnIPAMPoolCidr.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::IPAMPoolCidr", exports2.CfnIPAMPoolCidr = CfnIPAMPoolCidr;
    function CfnIPAMResourceDiscoveryPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("operatingRegions", cdk.listValidator(CfnIPAMResourceDiscovery_IpamOperatingRegionPropertyValidator))(properties.operatingRegions)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnIPAMResourceDiscoveryProps"');
    }
    function cfnIPAMResourceDiscoveryPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIPAMResourceDiscoveryPropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), OperatingRegions: cdk.listMapper(cfnIPAMResourceDiscoveryIpamOperatingRegionPropertyToCloudFormation)(properties.operatingRegions), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnIPAMResourceDiscoveryPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("operatingRegions", "OperatingRegions", properties.OperatingRegions != null ? cfn_parse.FromCloudFormation.getArray(CfnIPAMResourceDiscoveryIpamOperatingRegionPropertyFromCloudFormation)(properties.OperatingRegions) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnIPAMResourceDiscovery = class _CfnIPAMResourceDiscovery extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnIPAMResourceDiscoveryPropsFromCloudFormation(resourceProperties), ret = new _CfnIPAMResourceDiscovery(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnIPAMResourceDiscovery.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnIPAMResourceDiscoveryProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnIPAMResourceDiscovery), error;
        }
        this.attrIpamResourceDiscoveryArn = cdk.Token.asString(this.getAtt("IpamResourceDiscoveryArn", cdk.ResolutionTypeHint.STRING)), this.attrIpamResourceDiscoveryId = cdk.Token.asString(this.getAtt("IpamResourceDiscoveryId", cdk.ResolutionTypeHint.STRING)), this.attrIpamResourceDiscoveryRegion = cdk.Token.asString(this.getAtt("IpamResourceDiscoveryRegion", cdk.ResolutionTypeHint.STRING)), this.attrIsDefault = this.getAtt("IsDefault", cdk.ResolutionTypeHint.STRING), this.attrOwnerId = cdk.Token.asString(this.getAtt("OwnerId", cdk.ResolutionTypeHint.STRING)), this.attrState = cdk.Token.asString(this.getAtt("State", cdk.ResolutionTypeHint.STRING)), this.description = props.description, this.operatingRegions = props.operatingRegions, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::IPAMResourceDiscovery", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnIPAMResourceDiscovery.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, operatingRegions: this.operatingRegions, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnIPAMResourceDiscoveryPropsToCloudFormation(props);
      }
    };
    _x = JSII_RTTI_SYMBOL_1, CfnIPAMResourceDiscovery[_x] = { fqn: "aws-cdk-lib.aws_ec2.CfnIPAMResourceDiscovery", version: "2.80.0" }, CfnIPAMResourceDiscovery.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::IPAMResourceDiscovery", exports2.CfnIPAMResourceDiscovery = CfnIPAMResourceDiscovery;
    function CfnIPAMResourceDiscovery_IpamOperatingRegionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("regionName", cdk.requiredValidator)(properties.regionName)), errors.collect(cdk.propertyValidator("regionName", cdk.validateString)(properties.regionName)), errors.wrap('supplied properties not correct for "IpamOperatingRegionProperty"');
    }
    function cfnIPAMResourceDiscoveryIpamOperatingRegionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIPAMResourceDiscovery_IpamOperatingRegionPropertyValidator(properties).assertSuccess(), { RegionName: cdk.stringToCloudFormation(properties.regionName) }) : properties;
    }
    function CfnIPAMResourceDiscoveryIpamOperatingRegionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("regionName", "RegionName", cfn_parse.FromCloudFormation.getString(properties.RegionName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIPAMResourceDiscoveryAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ipamId", cdk.requiredValidator)(properties.ipamId)), errors.collect(cdk.propertyValidator("ipamId", cdk.validateString)(properties.ipamId)), errors.collect(cdk.propertyValidator("ipamResourceDiscoveryId", cdk.requiredValidator)(properties.ipamResourceDiscoveryId)), errors.collect(cdk.propertyValidator("ipamResourceDiscoveryId", cdk.validateString)(properties.ipamResourceDiscoveryId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnIPAMResourceDiscoveryAssociationProps"');
    }
    function cfnIPAMResourceDiscoveryAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIPAMResourceDiscoveryAssociationPropsValidator(properties).assertSuccess(), { IpamId: cdk.stringToCloudFormation(properties.ipamId), IpamResourceDiscoveryId: cdk.stringToCloudFormation(properties.ipamResourceDiscoveryId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnIPAMResourceDiscoveryAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ipamId", "IpamId", cfn_parse.FromCloudFormation.getString(properties.IpamId)), ret.addPropertyResult("ipamResourceDiscoveryId", "IpamResourceDiscoveryId", cfn_parse.FromCloudFormation.getString(properties.IpamResourceDiscoveryId)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnIPAMResourceDiscoveryAssociation = class _CfnIPAMResourceDiscoveryAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnIPAMResourceDiscoveryAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnIPAMResourceDiscoveryAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnIPAMResourceDiscoveryAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnIPAMResourceDiscoveryAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnIPAMResourceDiscoveryAssociation), error;
        }
        cdk.requireProperty(props, "ipamId", this), cdk.requireProperty(props, "ipamResourceDiscoveryId", this), this.attrIpamArn = cdk.Token.asString(this.getAtt("IpamArn", cdk.ResolutionTypeHint.STRING)), this.attrIpamRegion = cdk.Token.asString(this.getAtt("IpamRegion", cdk.ResolutionTypeHint.STRING)), this.attrIpamResourceDiscoveryAssociationArn = cdk.Token.asString(this.getAtt("IpamResourceDiscoveryAssociationArn", cdk.ResolutionTypeHint.STRING)), this.attrIpamResourceDiscoveryAssociationId = cdk.Token.asString(this.getAtt("IpamResourceDiscoveryAssociationId", cdk.ResolutionTypeHint.STRING)), this.attrIsDefault = this.getAtt("IsDefault", cdk.ResolutionTypeHint.STRING), this.attrOwnerId = cdk.Token.asString(this.getAtt("OwnerId", cdk.ResolutionTypeHint.STRING)), this.attrResourceDiscoveryStatus = cdk.Token.asString(this.getAtt("ResourceDiscoveryStatus", cdk.ResolutionTypeHint.STRING)), this.attrState = cdk.Token.asString(this.getAtt("State", cdk.ResolutionTypeHint.STRING)), this.ipamId = props.ipamId, this.ipamResourceDiscoveryId = props.ipamResourceDiscoveryId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::IPAMResourceDiscoveryAssociation", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnIPAMResourceDiscoveryAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { ipamId: this.ipamId, ipamResourceDiscoveryId: this.ipamResourceDiscoveryId, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnIPAMResourceDiscoveryAssociationPropsToCloudFormation(props);
      }
    };
    _y = JSII_RTTI_SYMBOL_1, CfnIPAMResourceDiscoveryAssociation[_y] = { fqn: "aws-cdk-lib.aws_ec2.CfnIPAMResourceDiscoveryAssociation", version: "2.80.0" }, CfnIPAMResourceDiscoveryAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::IPAMResourceDiscoveryAssociation", exports2.CfnIPAMResourceDiscoveryAssociation = CfnIPAMResourceDiscoveryAssociation;
    function CfnIPAMScopePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("ipamId", cdk.requiredValidator)(properties.ipamId)), errors.collect(cdk.propertyValidator("ipamId", cdk.validateString)(properties.ipamId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnIPAMScopeProps"');
    }
    function cfnIPAMScopePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIPAMScopePropsValidator(properties).assertSuccess(), { IpamId: cdk.stringToCloudFormation(properties.ipamId), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnIPAMScopePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ipamId", "IpamId", cfn_parse.FromCloudFormation.getString(properties.IpamId)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnIPAMScope = class _CfnIPAMScope extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnIPAMScopePropsFromCloudFormation(resourceProperties), ret = new _CfnIPAMScope(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnIPAMScope.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnIPAMScopeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnIPAMScope), error;
        }
        cdk.requireProperty(props, "ipamId", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrIpamArn = cdk.Token.asString(this.getAtt("IpamArn", cdk.ResolutionTypeHint.STRING)), this.attrIpamScopeId = cdk.Token.asString(this.getAtt("IpamScopeId", cdk.ResolutionTypeHint.STRING)), this.attrIpamScopeType = cdk.Token.asString(this.getAtt("IpamScopeType", cdk.ResolutionTypeHint.STRING)), this.attrIsDefault = this.getAtt("IsDefault", cdk.ResolutionTypeHint.STRING), this.attrPoolCount = cdk.Token.asNumber(this.getAtt("PoolCount", cdk.ResolutionTypeHint.NUMBER)), this.ipamId = props.ipamId, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::IPAMScope", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnIPAMScope.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { ipamId: this.ipamId, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnIPAMScopePropsToCloudFormation(props);
      }
    };
    _z = JSII_RTTI_SYMBOL_1, CfnIPAMScope[_z] = { fqn: "aws-cdk-lib.aws_ec2.CfnIPAMScope", version: "2.80.0" }, CfnIPAMScope.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::IPAMScope", exports2.CfnIPAMScope = CfnIPAMScope;
    function CfnInstancePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("additionalInfo", cdk.validateString)(properties.additionalInfo)), errors.collect(cdk.propertyValidator("affinity", cdk.validateString)(properties.affinity)), errors.collect(cdk.propertyValidator("availabilityZone", cdk.validateString)(properties.availabilityZone)), errors.collect(cdk.propertyValidator("blockDeviceMappings", cdk.listValidator(CfnInstance_BlockDeviceMappingPropertyValidator))(properties.blockDeviceMappings)), errors.collect(cdk.propertyValidator("cpuOptions", CfnInstance_CpuOptionsPropertyValidator)(properties.cpuOptions)), errors.collect(cdk.propertyValidator("creditSpecification", CfnInstance_CreditSpecificationPropertyValidator)(properties.creditSpecification)), errors.collect(cdk.propertyValidator("disableApiTermination", cdk.validateBoolean)(properties.disableApiTermination)), errors.collect(cdk.propertyValidator("ebsOptimized", cdk.validateBoolean)(properties.ebsOptimized)), errors.collect(cdk.propertyValidator("elasticGpuSpecifications", cdk.listValidator(CfnInstance_ElasticGpuSpecificationPropertyValidator))(properties.elasticGpuSpecifications)), errors.collect(cdk.propertyValidator("elasticInferenceAccelerators", cdk.listValidator(CfnInstance_ElasticInferenceAcceleratorPropertyValidator))(properties.elasticInferenceAccelerators)), errors.collect(cdk.propertyValidator("enclaveOptions", CfnInstance_EnclaveOptionsPropertyValidator)(properties.enclaveOptions)), errors.collect(cdk.propertyValidator("hibernationOptions", CfnInstance_HibernationOptionsPropertyValidator)(properties.hibernationOptions)), errors.collect(cdk.propertyValidator("hostId", cdk.validateString)(properties.hostId)), errors.collect(cdk.propertyValidator("hostResourceGroupArn", cdk.validateString)(properties.hostResourceGroupArn)), errors.collect(cdk.propertyValidator("iamInstanceProfile", cdk.validateString)(properties.iamInstanceProfile)), errors.collect(cdk.propertyValidator("imageId", cdk.validateString)(properties.imageId)), errors.collect(cdk.propertyValidator("instanceInitiatedShutdownBehavior", cdk.validateString)(properties.instanceInitiatedShutdownBehavior)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("ipv6AddressCount", cdk.validateNumber)(properties.ipv6AddressCount)), errors.collect(cdk.propertyValidator("ipv6Addresses", cdk.listValidator(CfnInstance_InstanceIpv6AddressPropertyValidator))(properties.ipv6Addresses)), errors.collect(cdk.propertyValidator("kernelId", cdk.validateString)(properties.kernelId)), errors.collect(cdk.propertyValidator("keyName", cdk.validateString)(properties.keyName)), errors.collect(cdk.propertyValidator("launchTemplate", CfnInstance_LaunchTemplateSpecificationPropertyValidator)(properties.launchTemplate)), errors.collect(cdk.propertyValidator("licenseSpecifications", cdk.listValidator(CfnInstance_LicenseSpecificationPropertyValidator))(properties.licenseSpecifications)), errors.collect(cdk.propertyValidator("monitoring", cdk.validateBoolean)(properties.monitoring)), errors.collect(cdk.propertyValidator("networkInterfaces", cdk.listValidator(CfnInstance_NetworkInterfacePropertyValidator))(properties.networkInterfaces)), errors.collect(cdk.propertyValidator("placementGroupName", cdk.validateString)(properties.placementGroupName)), errors.collect(cdk.propertyValidator("privateDnsNameOptions", CfnInstance_PrivateDnsNameOptionsPropertyValidator)(properties.privateDnsNameOptions)), errors.collect(cdk.propertyValidator("privateIpAddress", cdk.validateString)(properties.privateIpAddress)), errors.collect(cdk.propertyValidator("propagateTagsToVolumeOnCreation", cdk.validateBoolean)(properties.propagateTagsToVolumeOnCreation)), errors.collect(cdk.propertyValidator("ramdiskId", cdk.validateString)(properties.ramdiskId)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("securityGroups", cdk.listValidator(cdk.validateString))(properties.securityGroups)), errors.collect(cdk.propertyValidator("sourceDestCheck", cdk.validateBoolean)(properties.sourceDestCheck)), errors.collect(cdk.propertyValidator("ssmAssociations", cdk.listValidator(CfnInstance_SsmAssociationPropertyValidator))(properties.ssmAssociations)), errors.collect(cdk.propertyValidator("subnetId", cdk.validateString)(properties.subnetId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("tenancy", cdk.validateString)(properties.tenancy)), errors.collect(cdk.propertyValidator("userData", cdk.validateString)(properties.userData)), errors.collect(cdk.propertyValidator("volumes", cdk.listValidator(CfnInstance_VolumePropertyValidator))(properties.volumes)), errors.wrap('supplied properties not correct for "CfnInstanceProps"');
    }
    function cfnInstancePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstancePropsValidator(properties).assertSuccess(), { AdditionalInfo: cdk.stringToCloudFormation(properties.additionalInfo), Affinity: cdk.stringToCloudFormation(properties.affinity), AvailabilityZone: cdk.stringToCloudFormation(properties.availabilityZone), BlockDeviceMappings: cdk.listMapper(cfnInstanceBlockDeviceMappingPropertyToCloudFormation)(properties.blockDeviceMappings), CpuOptions: cfnInstanceCpuOptionsPropertyToCloudFormation(properties.cpuOptions), CreditSpecification: cfnInstanceCreditSpecificationPropertyToCloudFormation(properties.creditSpecification), DisableApiTermination: cdk.booleanToCloudFormation(properties.disableApiTermination), EbsOptimized: cdk.booleanToCloudFormation(properties.ebsOptimized), ElasticGpuSpecifications: cdk.listMapper(cfnInstanceElasticGpuSpecificationPropertyToCloudFormation)(properties.elasticGpuSpecifications), ElasticInferenceAccelerators: cdk.listMapper(cfnInstanceElasticInferenceAcceleratorPropertyToCloudFormation)(properties.elasticInferenceAccelerators), EnclaveOptions: cfnInstanceEnclaveOptionsPropertyToCloudFormation(properties.enclaveOptions), HibernationOptions: cfnInstanceHibernationOptionsPropertyToCloudFormation(properties.hibernationOptions), HostId: cdk.stringToCloudFormation(properties.hostId), HostResourceGroupArn: cdk.stringToCloudFormation(properties.hostResourceGroupArn), IamInstanceProfile: cdk.stringToCloudFormation(properties.iamInstanceProfile), ImageId: cdk.stringToCloudFormation(properties.imageId), InstanceInitiatedShutdownBehavior: cdk.stringToCloudFormation(properties.instanceInitiatedShutdownBehavior), InstanceType: cdk.stringToCloudFormation(properties.instanceType), Ipv6AddressCount: cdk.numberToCloudFormation(properties.ipv6AddressCount), Ipv6Addresses: cdk.listMapper(cfnInstanceInstanceIpv6AddressPropertyToCloudFormation)(properties.ipv6Addresses), KernelId: cdk.stringToCloudFormation(properties.kernelId), KeyName: cdk.stringToCloudFormation(properties.keyName), LaunchTemplate: cfnInstanceLaunchTemplateSpecificationPropertyToCloudFormation(properties.launchTemplate), LicenseSpecifications: cdk.listMapper(cfnInstanceLicenseSpecificationPropertyToCloudFormation)(properties.licenseSpecifications), Monitoring: cdk.booleanToCloudFormation(properties.monitoring), NetworkInterfaces: cdk.listMapper(cfnInstanceNetworkInterfacePropertyToCloudFormation)(properties.networkInterfaces), PlacementGroupName: cdk.stringToCloudFormation(properties.placementGroupName), PrivateDnsNameOptions: cfnInstancePrivateDnsNameOptionsPropertyToCloudFormation(properties.privateDnsNameOptions), PrivateIpAddress: cdk.stringToCloudFormation(properties.privateIpAddress), PropagateTagsToVolumeOnCreation: cdk.booleanToCloudFormation(properties.propagateTagsToVolumeOnCreation), RamdiskId: cdk.stringToCloudFormation(properties.ramdiskId), SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SecurityGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroups), SourceDestCheck: cdk.booleanToCloudFormation(properties.sourceDestCheck), SsmAssociations: cdk.listMapper(cfnInstanceSsmAssociationPropertyToCloudFormation)(properties.ssmAssociations), SubnetId: cdk.stringToCloudFormation(properties.subnetId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), Tenancy: cdk.stringToCloudFormation(properties.tenancy), UserData: cdk.stringToCloudFormation(properties.userData), Volumes: cdk.listMapper(cfnInstanceVolumePropertyToCloudFormation)(properties.volumes) }) : properties;
    }
    function CfnInstancePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("additionalInfo", "AdditionalInfo", properties.AdditionalInfo != null ? cfn_parse.FromCloudFormation.getString(properties.AdditionalInfo) : void 0), ret.addPropertyResult("affinity", "Affinity", properties.Affinity != null ? cfn_parse.FromCloudFormation.getString(properties.Affinity) : void 0), ret.addPropertyResult("availabilityZone", "AvailabilityZone", properties.AvailabilityZone != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityZone) : void 0), ret.addPropertyResult("blockDeviceMappings", "BlockDeviceMappings", properties.BlockDeviceMappings != null ? cfn_parse.FromCloudFormation.getArray(CfnInstanceBlockDeviceMappingPropertyFromCloudFormation)(properties.BlockDeviceMappings) : void 0), ret.addPropertyResult("cpuOptions", "CpuOptions", properties.CpuOptions != null ? CfnInstanceCpuOptionsPropertyFromCloudFormation(properties.CpuOptions) : void 0), ret.addPropertyResult("creditSpecification", "CreditSpecification", properties.CreditSpecification != null ? CfnInstanceCreditSpecificationPropertyFromCloudFormation(properties.CreditSpecification) : void 0), ret.addPropertyResult("disableApiTermination", "DisableApiTermination", properties.DisableApiTermination != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DisableApiTermination) : void 0), ret.addPropertyResult("ebsOptimized", "EbsOptimized", properties.EbsOptimized != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EbsOptimized) : void 0), ret.addPropertyResult("elasticGpuSpecifications", "ElasticGpuSpecifications", properties.ElasticGpuSpecifications != null ? cfn_parse.FromCloudFormation.getArray(CfnInstanceElasticGpuSpecificationPropertyFromCloudFormation)(properties.ElasticGpuSpecifications) : void 0), ret.addPropertyResult("elasticInferenceAccelerators", "ElasticInferenceAccelerators", properties.ElasticInferenceAccelerators != null ? cfn_parse.FromCloudFormation.getArray(CfnInstanceElasticInferenceAcceleratorPropertyFromCloudFormation)(properties.ElasticInferenceAccelerators) : void 0), ret.addPropertyResult("enclaveOptions", "EnclaveOptions", properties.EnclaveOptions != null ? CfnInstanceEnclaveOptionsPropertyFromCloudFormation(properties.EnclaveOptions) : void 0), ret.addPropertyResult("hibernationOptions", "HibernationOptions", properties.HibernationOptions != null ? CfnInstanceHibernationOptionsPropertyFromCloudFormation(properties.HibernationOptions) : void 0), ret.addPropertyResult("hostId", "HostId", properties.HostId != null ? cfn_parse.FromCloudFormation.getString(properties.HostId) : void 0), ret.addPropertyResult("hostResourceGroupArn", "HostResourceGroupArn", properties.HostResourceGroupArn != null ? cfn_parse.FromCloudFormation.getString(properties.HostResourceGroupArn) : void 0), ret.addPropertyResult("iamInstanceProfile", "IamInstanceProfile", properties.IamInstanceProfile != null ? cfn_parse.FromCloudFormation.getString(properties.IamInstanceProfile) : void 0), ret.addPropertyResult("imageId", "ImageId", properties.ImageId != null ? cfn_parse.FromCloudFormation.getString(properties.ImageId) : void 0), ret.addPropertyResult("instanceInitiatedShutdownBehavior", "InstanceInitiatedShutdownBehavior", properties.InstanceInitiatedShutdownBehavior != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceInitiatedShutdownBehavior) : void 0), ret.addPropertyResult("instanceType", "InstanceType", properties.InstanceType != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceType) : void 0), ret.addPropertyResult("ipv6AddressCount", "Ipv6AddressCount", properties.Ipv6AddressCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.Ipv6AddressCount) : void 0), ret.addPropertyResult("ipv6Addresses", "Ipv6Addresses", properties.Ipv6Addresses != null ? cfn_parse.FromCloudFormation.getArray(CfnInstanceInstanceIpv6AddressPropertyFromCloudFormation)(properties.Ipv6Addresses) : void 0), ret.addPropertyResult("kernelId", "KernelId", properties.KernelId != null ? cfn_parse.FromCloudFormation.getString(properties.KernelId) : void 0), ret.addPropertyResult("keyName", "KeyName", properties.KeyName != null ? cfn_parse.FromCloudFormation.getString(properties.KeyName) : void 0), ret.addPropertyResult("launchTemplate", "LaunchTemplate", properties.LaunchTemplate != null ? CfnInstanceLaunchTemplateSpecificationPropertyFromCloudFormation(properties.LaunchTemplate) : void 0), ret.addPropertyResult("licenseSpecifications", "LicenseSpecifications", properties.LicenseSpecifications != null ? cfn_parse.FromCloudFormation.getArray(CfnInstanceLicenseSpecificationPropertyFromCloudFormation)(properties.LicenseSpecifications) : void 0), ret.addPropertyResult("monitoring", "Monitoring", properties.Monitoring != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Monitoring) : void 0), ret.addPropertyResult("networkInterfaces", "NetworkInterfaces", properties.NetworkInterfaces != null ? cfn_parse.FromCloudFormation.getArray(CfnInstanceNetworkInterfacePropertyFromCloudFormation)(properties.NetworkInterfaces) : void 0), ret.addPropertyResult("placementGroupName", "PlacementGroupName", properties.PlacementGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.PlacementGroupName) : void 0), ret.addPropertyResult("privateDnsNameOptions", "PrivateDnsNameOptions", properties.PrivateDnsNameOptions != null ? CfnInstancePrivateDnsNameOptionsPropertyFromCloudFormation(properties.PrivateDnsNameOptions) : void 0), ret.addPropertyResult("privateIpAddress", "PrivateIpAddress", properties.PrivateIpAddress != null ? cfn_parse.FromCloudFormation.getString(properties.PrivateIpAddress) : void 0), ret.addPropertyResult("propagateTagsToVolumeOnCreation", "PropagateTagsToVolumeOnCreation", properties.PropagateTagsToVolumeOnCreation != null ? cfn_parse.FromCloudFormation.getBoolean(properties.PropagateTagsToVolumeOnCreation) : void 0), ret.addPropertyResult("ramdiskId", "RamdiskId", properties.RamdiskId != null ? cfn_parse.FromCloudFormation.getString(properties.RamdiskId) : void 0), ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("securityGroups", "SecurityGroups", properties.SecurityGroups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroups) : void 0), ret.addPropertyResult("sourceDestCheck", "SourceDestCheck", properties.SourceDestCheck != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SourceDestCheck) : void 0), ret.addPropertyResult("ssmAssociations", "SsmAssociations", properties.SsmAssociations != null ? cfn_parse.FromCloudFormation.getArray(CfnInstanceSsmAssociationPropertyFromCloudFormation)(properties.SsmAssociations) : void 0), ret.addPropertyResult("subnetId", "SubnetId", properties.SubnetId != null ? cfn_parse.FromCloudFormation.getString(properties.SubnetId) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("tenancy", "Tenancy", properties.Tenancy != null ? cfn_parse.FromCloudFormation.getString(properties.Tenancy) : void 0), ret.addPropertyResult("userData", "UserData", properties.UserData != null ? cfn_parse.FromCloudFormation.getString(properties.UserData) : void 0), ret.addPropertyResult("volumes", "Volumes", properties.Volumes != null ? cfn_parse.FromCloudFormation.getArray(CfnInstanceVolumePropertyFromCloudFormation)(properties.Volumes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnInstance = class _CfnInstance extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnInstancePropsFromCloudFormation(resourceProperties), ret = new _CfnInstance(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnInstance.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnInstanceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnInstance), error;
        }
        this.attrAvailabilityZone = cdk.Token.asString(this.getAtt("AvailabilityZone", cdk.ResolutionTypeHint.STRING)), this.attrPrivateDnsName = cdk.Token.asString(this.getAtt("PrivateDnsName", cdk.ResolutionTypeHint.STRING)), this.attrPrivateIp = cdk.Token.asString(this.getAtt("PrivateIp", cdk.ResolutionTypeHint.STRING)), this.attrPublicDnsName = cdk.Token.asString(this.getAtt("PublicDnsName", cdk.ResolutionTypeHint.STRING)), this.attrPublicIp = cdk.Token.asString(this.getAtt("PublicIp", cdk.ResolutionTypeHint.STRING)), this.additionalInfo = props.additionalInfo, this.affinity = props.affinity, this.availabilityZone = props.availabilityZone, this.blockDeviceMappings = props.blockDeviceMappings, this.cpuOptions = props.cpuOptions, this.creditSpecification = props.creditSpecification, this.disableApiTermination = props.disableApiTermination, this.ebsOptimized = props.ebsOptimized, this.elasticGpuSpecifications = props.elasticGpuSpecifications, this.elasticInferenceAccelerators = props.elasticInferenceAccelerators, this.enclaveOptions = props.enclaveOptions, this.hibernationOptions = props.hibernationOptions, this.hostId = props.hostId, this.hostResourceGroupArn = props.hostResourceGroupArn, this.iamInstanceProfile = props.iamInstanceProfile, this.imageId = props.imageId, this.instanceInitiatedShutdownBehavior = props.instanceInitiatedShutdownBehavior, this.instanceType = props.instanceType, this.ipv6AddressCount = props.ipv6AddressCount, this.ipv6Addresses = props.ipv6Addresses, this.kernelId = props.kernelId, this.keyName = props.keyName, this.launchTemplate = props.launchTemplate, this.licenseSpecifications = props.licenseSpecifications, this.monitoring = props.monitoring, this.networkInterfaces = props.networkInterfaces, this.placementGroupName = props.placementGroupName, this.privateDnsNameOptions = props.privateDnsNameOptions, this.privateIpAddress = props.privateIpAddress, this.propagateTagsToVolumeOnCreation = props.propagateTagsToVolumeOnCreation, this.ramdiskId = props.ramdiskId, this.securityGroupIds = props.securityGroupIds, this.securityGroups = props.securityGroups, this.sourceDestCheck = props.sourceDestCheck, this.ssmAssociations = props.ssmAssociations, this.subnetId = props.subnetId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::Instance", props.tags, { tagPropertyName: "tags" }), this.tenancy = props.tenancy, this.userData = props.userData, this.volumes = props.volumes;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnInstance.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { additionalInfo: this.additionalInfo, affinity: this.affinity, availabilityZone: this.availabilityZone, blockDeviceMappings: this.blockDeviceMappings, cpuOptions: this.cpuOptions, creditSpecification: this.creditSpecification, disableApiTermination: this.disableApiTermination, ebsOptimized: this.ebsOptimized, elasticGpuSpecifications: this.elasticGpuSpecifications, elasticInferenceAccelerators: this.elasticInferenceAccelerators, enclaveOptions: this.enclaveOptions, hibernationOptions: this.hibernationOptions, hostId: this.hostId, hostResourceGroupArn: this.hostResourceGroupArn, iamInstanceProfile: this.iamInstanceProfile, imageId: this.imageId, instanceInitiatedShutdownBehavior: this.instanceInitiatedShutdownBehavior, instanceType: this.instanceType, ipv6AddressCount: this.ipv6AddressCount, ipv6Addresses: this.ipv6Addresses, kernelId: this.kernelId, keyName: this.keyName, launchTemplate: this.launchTemplate, licenseSpecifications: this.licenseSpecifications, monitoring: this.monitoring, networkInterfaces: this.networkInterfaces, placementGroupName: this.placementGroupName, privateDnsNameOptions: this.privateDnsNameOptions, privateIpAddress: this.privateIpAddress, propagateTagsToVolumeOnCreation: this.propagateTagsToVolumeOnCreation, ramdiskId: this.ramdiskId, securityGroupIds: this.securityGroupIds, securityGroups: this.securityGroups, sourceDestCheck: this.sourceDestCheck, ssmAssociations: this.ssmAssociations, subnetId: this.subnetId, tags: this.tags.renderTags(), tenancy: this.tenancy, userData: this.userData, volumes: this.volumes };
      }
      renderProperties(props) {
        return cfnInstancePropsToCloudFormation(props);
      }
    };
    _0 = JSII_RTTI_SYMBOL_1, CfnInstance[_0] = { fqn: "aws-cdk-lib.aws_ec2.CfnInstance", version: "2.80.0" }, CfnInstance.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::Instance", exports2.CfnInstance = CfnInstance;
    function CfnInstance_AssociationParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.listValidator(cdk.validateString))(properties.value)), errors.wrap('supplied properties not correct for "AssociationParameterProperty"');
    }
    function cfnInstanceAssociationParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstance_AssociationParameterPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.listMapper(cdk.stringToCloudFormation)(properties.value) }) : properties;
    }
    function CfnInstanceAssociationParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getStringArray(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstance_BlockDeviceMappingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deviceName", cdk.requiredValidator)(properties.deviceName)), errors.collect(cdk.propertyValidator("deviceName", cdk.validateString)(properties.deviceName)), errors.collect(cdk.propertyValidator("ebs", CfnInstance_EbsPropertyValidator)(properties.ebs)), errors.collect(cdk.propertyValidator("noDevice", CfnInstance_NoDevicePropertyValidator)(properties.noDevice)), errors.collect(cdk.propertyValidator("virtualName", cdk.validateString)(properties.virtualName)), errors.wrap('supplied properties not correct for "BlockDeviceMappingProperty"');
    }
    function cfnInstanceBlockDeviceMappingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstance_BlockDeviceMappingPropertyValidator(properties).assertSuccess(), { DeviceName: cdk.stringToCloudFormation(properties.deviceName), Ebs: cfnInstanceEbsPropertyToCloudFormation(properties.ebs), NoDevice: cfnInstanceNoDevicePropertyToCloudFormation(properties.noDevice), VirtualName: cdk.stringToCloudFormation(properties.virtualName) }) : properties;
    }
    function CfnInstanceBlockDeviceMappingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deviceName", "DeviceName", cfn_parse.FromCloudFormation.getString(properties.DeviceName)), ret.addPropertyResult("ebs", "Ebs", properties.Ebs != null ? CfnInstanceEbsPropertyFromCloudFormation(properties.Ebs) : void 0), ret.addPropertyResult("noDevice", "NoDevice", properties.NoDevice != null ? CfnInstanceNoDevicePropertyFromCloudFormation(properties.NoDevice) : void 0), ret.addPropertyResult("virtualName", "VirtualName", properties.VirtualName != null ? cfn_parse.FromCloudFormation.getString(properties.VirtualName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstance_CpuOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("coreCount", cdk.validateNumber)(properties.coreCount)), errors.collect(cdk.propertyValidator("threadsPerCore", cdk.validateNumber)(properties.threadsPerCore)), errors.wrap('supplied properties not correct for "CpuOptionsProperty"');
    }
    function cfnInstanceCpuOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstance_CpuOptionsPropertyValidator(properties).assertSuccess(), { CoreCount: cdk.numberToCloudFormation(properties.coreCount), ThreadsPerCore: cdk.numberToCloudFormation(properties.threadsPerCore) }) : properties;
    }
    function CfnInstanceCpuOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("coreCount", "CoreCount", properties.CoreCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.CoreCount) : void 0), ret.addPropertyResult("threadsPerCore", "ThreadsPerCore", properties.ThreadsPerCore != null ? cfn_parse.FromCloudFormation.getNumber(properties.ThreadsPerCore) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstance_CreditSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cpuCredits", cdk.validateString)(properties.cpuCredits)), errors.wrap('supplied properties not correct for "CreditSpecificationProperty"');
    }
    function cfnInstanceCreditSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstance_CreditSpecificationPropertyValidator(properties).assertSuccess(), { CPUCredits: cdk.stringToCloudFormation(properties.cpuCredits) }) : properties;
    }
    function CfnInstanceCreditSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cpuCredits", "CPUCredits", properties.CPUCredits != null ? cfn_parse.FromCloudFormation.getString(properties.CPUCredits) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstance_EbsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deleteOnTermination", cdk.validateBoolean)(properties.deleteOnTermination)), errors.collect(cdk.propertyValidator("encrypted", cdk.validateBoolean)(properties.encrypted)), errors.collect(cdk.propertyValidator("iops", cdk.validateNumber)(properties.iops)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("snapshotId", cdk.validateString)(properties.snapshotId)), errors.collect(cdk.propertyValidator("volumeSize", cdk.validateNumber)(properties.volumeSize)), errors.collect(cdk.propertyValidator("volumeType", cdk.validateString)(properties.volumeType)), errors.wrap('supplied properties not correct for "EbsProperty"');
    }
    function cfnInstanceEbsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstance_EbsPropertyValidator(properties).assertSuccess(), { DeleteOnTermination: cdk.booleanToCloudFormation(properties.deleteOnTermination), Encrypted: cdk.booleanToCloudFormation(properties.encrypted), Iops: cdk.numberToCloudFormation(properties.iops), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), SnapshotId: cdk.stringToCloudFormation(properties.snapshotId), VolumeSize: cdk.numberToCloudFormation(properties.volumeSize), VolumeType: cdk.stringToCloudFormation(properties.volumeType) }) : properties;
    }
    function CfnInstanceEbsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deleteOnTermination", "DeleteOnTermination", properties.DeleteOnTermination != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeleteOnTermination) : void 0), ret.addPropertyResult("encrypted", "Encrypted", properties.Encrypted != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Encrypted) : void 0), ret.addPropertyResult("iops", "Iops", properties.Iops != null ? cfn_parse.FromCloudFormation.getNumber(properties.Iops) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("snapshotId", "SnapshotId", properties.SnapshotId != null ? cfn_parse.FromCloudFormation.getString(properties.SnapshotId) : void 0), ret.addPropertyResult("volumeSize", "VolumeSize", properties.VolumeSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.VolumeSize) : void 0), ret.addPropertyResult("volumeType", "VolumeType", properties.VolumeType != null ? cfn_parse.FromCloudFormation.getString(properties.VolumeType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstance_ElasticGpuSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "ElasticGpuSpecificationProperty"');
    }
    function cfnInstanceElasticGpuSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstance_ElasticGpuSpecificationPropertyValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnInstanceElasticGpuSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstance_ElasticInferenceAcceleratorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("count", cdk.validateNumber)(properties.count)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "ElasticInferenceAcceleratorProperty"');
    }
    function cfnInstanceElasticInferenceAcceleratorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstance_ElasticInferenceAcceleratorPropertyValidator(properties).assertSuccess(), { Count: cdk.numberToCloudFormation(properties.count), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnInstanceElasticInferenceAcceleratorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("count", "Count", properties.Count != null ? cfn_parse.FromCloudFormation.getNumber(properties.Count) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstance_EnclaveOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "EnclaveOptionsProperty"');
    }
    function cfnInstanceEnclaveOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstance_EnclaveOptionsPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnInstanceEnclaveOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstance_HibernationOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configured", cdk.validateBoolean)(properties.configured)), errors.wrap('supplied properties not correct for "HibernationOptionsProperty"');
    }
    function cfnInstanceHibernationOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstance_HibernationOptionsPropertyValidator(properties).assertSuccess(), { Configured: cdk.booleanToCloudFormation(properties.configured) }) : properties;
    }
    function CfnInstanceHibernationOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configured", "Configured", properties.Configured != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Configured) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstance_InstanceIpv6AddressPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ipv6Address", cdk.requiredValidator)(properties.ipv6Address)), errors.collect(cdk.propertyValidator("ipv6Address", cdk.validateString)(properties.ipv6Address)), errors.wrap('supplied properties not correct for "InstanceIpv6AddressProperty"');
    }
    function cfnInstanceInstanceIpv6AddressPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstance_InstanceIpv6AddressPropertyValidator(properties).assertSuccess(), { Ipv6Address: cdk.stringToCloudFormation(properties.ipv6Address) }) : properties;
    }
    function CfnInstanceInstanceIpv6AddressPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ipv6Address", "Ipv6Address", cfn_parse.FromCloudFormation.getString(properties.Ipv6Address)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstance_LaunchTemplateSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("launchTemplateId", cdk.validateString)(properties.launchTemplateId)), errors.collect(cdk.propertyValidator("launchTemplateName", cdk.validateString)(properties.launchTemplateName)), errors.collect(cdk.propertyValidator("version", cdk.requiredValidator)(properties.version)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "LaunchTemplateSpecificationProperty"');
    }
    function cfnInstanceLaunchTemplateSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstance_LaunchTemplateSpecificationPropertyValidator(properties).assertSuccess(), { LaunchTemplateId: cdk.stringToCloudFormation(properties.launchTemplateId), LaunchTemplateName: cdk.stringToCloudFormation(properties.launchTemplateName), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnInstanceLaunchTemplateSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("launchTemplateId", "LaunchTemplateId", properties.LaunchTemplateId != null ? cfn_parse.FromCloudFormation.getString(properties.LaunchTemplateId) : void 0), ret.addPropertyResult("launchTemplateName", "LaunchTemplateName", properties.LaunchTemplateName != null ? cfn_parse.FromCloudFormation.getString(properties.LaunchTemplateName) : void 0), ret.addPropertyResult("version", "Version", cfn_parse.FromCloudFormation.getString(properties.Version)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstance_LicenseSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("licenseConfigurationArn", cdk.requiredValidator)(properties.licenseConfigurationArn)), errors.collect(cdk.propertyValidator("licenseConfigurationArn", cdk.validateString)(properties.licenseConfigurationArn)), errors.wrap('supplied properties not correct for "LicenseSpecificationProperty"');
    }
    function cfnInstanceLicenseSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstance_LicenseSpecificationPropertyValidator(properties).assertSuccess(), { LicenseConfigurationArn: cdk.stringToCloudFormation(properties.licenseConfigurationArn) }) : properties;
    }
    function CfnInstanceLicenseSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("licenseConfigurationArn", "LicenseConfigurationArn", cfn_parse.FromCloudFormation.getString(properties.LicenseConfigurationArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstance_NetworkInterfacePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("associateCarrierIpAddress", cdk.validateBoolean)(properties.associateCarrierIpAddress)), errors.collect(cdk.propertyValidator("associatePublicIpAddress", cdk.validateBoolean)(properties.associatePublicIpAddress)), errors.collect(cdk.propertyValidator("deleteOnTermination", cdk.validateBoolean)(properties.deleteOnTermination)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("deviceIndex", cdk.requiredValidator)(properties.deviceIndex)), errors.collect(cdk.propertyValidator("deviceIndex", cdk.validateString)(properties.deviceIndex)), errors.collect(cdk.propertyValidator("groupSet", cdk.listValidator(cdk.validateString))(properties.groupSet)), errors.collect(cdk.propertyValidator("ipv6AddressCount", cdk.validateNumber)(properties.ipv6AddressCount)), errors.collect(cdk.propertyValidator("ipv6Addresses", cdk.listValidator(CfnInstance_InstanceIpv6AddressPropertyValidator))(properties.ipv6Addresses)), errors.collect(cdk.propertyValidator("networkInterfaceId", cdk.validateString)(properties.networkInterfaceId)), errors.collect(cdk.propertyValidator("privateIpAddress", cdk.validateString)(properties.privateIpAddress)), errors.collect(cdk.propertyValidator("privateIpAddresses", cdk.listValidator(CfnInstance_PrivateIpAddressSpecificationPropertyValidator))(properties.privateIpAddresses)), errors.collect(cdk.propertyValidator("secondaryPrivateIpAddressCount", cdk.validateNumber)(properties.secondaryPrivateIpAddressCount)), errors.collect(cdk.propertyValidator("subnetId", cdk.validateString)(properties.subnetId)), errors.wrap('supplied properties not correct for "NetworkInterfaceProperty"');
    }
    function cfnInstanceNetworkInterfacePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstance_NetworkInterfacePropertyValidator(properties).assertSuccess(), { AssociateCarrierIpAddress: cdk.booleanToCloudFormation(properties.associateCarrierIpAddress), AssociatePublicIpAddress: cdk.booleanToCloudFormation(properties.associatePublicIpAddress), DeleteOnTermination: cdk.booleanToCloudFormation(properties.deleteOnTermination), Description: cdk.stringToCloudFormation(properties.description), DeviceIndex: cdk.stringToCloudFormation(properties.deviceIndex), GroupSet: cdk.listMapper(cdk.stringToCloudFormation)(properties.groupSet), Ipv6AddressCount: cdk.numberToCloudFormation(properties.ipv6AddressCount), Ipv6Addresses: cdk.listMapper(cfnInstanceInstanceIpv6AddressPropertyToCloudFormation)(properties.ipv6Addresses), NetworkInterfaceId: cdk.stringToCloudFormation(properties.networkInterfaceId), PrivateIpAddress: cdk.stringToCloudFormation(properties.privateIpAddress), PrivateIpAddresses: cdk.listMapper(cfnInstancePrivateIpAddressSpecificationPropertyToCloudFormation)(properties.privateIpAddresses), SecondaryPrivateIpAddressCount: cdk.numberToCloudFormation(properties.secondaryPrivateIpAddressCount), SubnetId: cdk.stringToCloudFormation(properties.subnetId) }) : properties;
    }
    function CfnInstanceNetworkInterfacePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("associateCarrierIpAddress", "AssociateCarrierIpAddress", properties.AssociateCarrierIpAddress != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AssociateCarrierIpAddress) : void 0), ret.addPropertyResult("associatePublicIpAddress", "AssociatePublicIpAddress", properties.AssociatePublicIpAddress != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AssociatePublicIpAddress) : void 0), ret.addPropertyResult("deleteOnTermination", "DeleteOnTermination", properties.DeleteOnTermination != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeleteOnTermination) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("deviceIndex", "DeviceIndex", cfn_parse.FromCloudFormation.getString(properties.DeviceIndex)), ret.addPropertyResult("groupSet", "GroupSet", properties.GroupSet != null ? cfn_parse.FromCloudFormation.getStringArray(properties.GroupSet) : void 0), ret.addPropertyResult("ipv6AddressCount", "Ipv6AddressCount", properties.Ipv6AddressCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.Ipv6AddressCount) : void 0), ret.addPropertyResult("ipv6Addresses", "Ipv6Addresses", properties.Ipv6Addresses != null ? cfn_parse.FromCloudFormation.getArray(CfnInstanceInstanceIpv6AddressPropertyFromCloudFormation)(properties.Ipv6Addresses) : void 0), ret.addPropertyResult("networkInterfaceId", "NetworkInterfaceId", properties.NetworkInterfaceId != null ? cfn_parse.FromCloudFormation.getString(properties.NetworkInterfaceId) : void 0), ret.addPropertyResult("privateIpAddress", "PrivateIpAddress", properties.PrivateIpAddress != null ? cfn_parse.FromCloudFormation.getString(properties.PrivateIpAddress) : void 0), ret.addPropertyResult("privateIpAddresses", "PrivateIpAddresses", properties.PrivateIpAddresses != null ? cfn_parse.FromCloudFormation.getArray(CfnInstancePrivateIpAddressSpecificationPropertyFromCloudFormation)(properties.PrivateIpAddresses) : void 0), ret.addPropertyResult("secondaryPrivateIpAddressCount", "SecondaryPrivateIpAddressCount", properties.SecondaryPrivateIpAddressCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.SecondaryPrivateIpAddressCount) : void 0), ret.addPropertyResult("subnetId", "SubnetId", properties.SubnetId != null ? cfn_parse.FromCloudFormation.getString(properties.SubnetId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstance_NoDevicePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.wrap('supplied properties not correct for "NoDeviceProperty"');
    }
    function cfnInstanceNoDevicePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstance_NoDevicePropertyValidator(properties).assertSuccess(), {}) : properties;
    }
    function CfnInstanceNoDevicePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstance_PrivateDnsNameOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enableResourceNameDnsAaaaRecord", cdk.validateBoolean)(properties.enableResourceNameDnsAaaaRecord)), errors.collect(cdk.propertyValidator("enableResourceNameDnsARecord", cdk.validateBoolean)(properties.enableResourceNameDnsARecord)), errors.collect(cdk.propertyValidator("hostnameType", cdk.validateString)(properties.hostnameType)), errors.wrap('supplied properties not correct for "PrivateDnsNameOptionsProperty"');
    }
    function cfnInstancePrivateDnsNameOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstance_PrivateDnsNameOptionsPropertyValidator(properties).assertSuccess(), { EnableResourceNameDnsAAAARecord: cdk.booleanToCloudFormation(properties.enableResourceNameDnsAaaaRecord), EnableResourceNameDnsARecord: cdk.booleanToCloudFormation(properties.enableResourceNameDnsARecord), HostnameType: cdk.stringToCloudFormation(properties.hostnameType) }) : properties;
    }
    function CfnInstancePrivateDnsNameOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enableResourceNameDnsAaaaRecord", "EnableResourceNameDnsAAAARecord", properties.EnableResourceNameDnsAAAARecord != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableResourceNameDnsAAAARecord) : void 0), ret.addPropertyResult("enableResourceNameDnsARecord", "EnableResourceNameDnsARecord", properties.EnableResourceNameDnsARecord != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableResourceNameDnsARecord) : void 0), ret.addPropertyResult("hostnameType", "HostnameType", properties.HostnameType != null ? cfn_parse.FromCloudFormation.getString(properties.HostnameType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstance_PrivateIpAddressSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("primary", cdk.requiredValidator)(properties.primary)), errors.collect(cdk.propertyValidator("primary", cdk.validateBoolean)(properties.primary)), errors.collect(cdk.propertyValidator("privateIpAddress", cdk.requiredValidator)(properties.privateIpAddress)), errors.collect(cdk.propertyValidator("privateIpAddress", cdk.validateString)(properties.privateIpAddress)), errors.wrap('supplied properties not correct for "PrivateIpAddressSpecificationProperty"');
    }
    function cfnInstancePrivateIpAddressSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstance_PrivateIpAddressSpecificationPropertyValidator(properties).assertSuccess(), { Primary: cdk.booleanToCloudFormation(properties.primary), PrivateIpAddress: cdk.stringToCloudFormation(properties.privateIpAddress) }) : properties;
    }
    function CfnInstancePrivateIpAddressSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("primary", "Primary", cfn_parse.FromCloudFormation.getBoolean(properties.Primary)), ret.addPropertyResult("privateIpAddress", "PrivateIpAddress", cfn_parse.FromCloudFormation.getString(properties.PrivateIpAddress)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstance_SsmAssociationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("associationParameters", cdk.listValidator(CfnInstance_AssociationParameterPropertyValidator))(properties.associationParameters)), errors.collect(cdk.propertyValidator("documentName", cdk.requiredValidator)(properties.documentName)), errors.collect(cdk.propertyValidator("documentName", cdk.validateString)(properties.documentName)), errors.wrap('supplied properties not correct for "SsmAssociationProperty"');
    }
    function cfnInstanceSsmAssociationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstance_SsmAssociationPropertyValidator(properties).assertSuccess(), { AssociationParameters: cdk.listMapper(cfnInstanceAssociationParameterPropertyToCloudFormation)(properties.associationParameters), DocumentName: cdk.stringToCloudFormation(properties.documentName) }) : properties;
    }
    function CfnInstanceSsmAssociationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("associationParameters", "AssociationParameters", properties.AssociationParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnInstanceAssociationParameterPropertyFromCloudFormation)(properties.AssociationParameters) : void 0), ret.addPropertyResult("documentName", "DocumentName", cfn_parse.FromCloudFormation.getString(properties.DocumentName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstance_VolumePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("device", cdk.requiredValidator)(properties.device)), errors.collect(cdk.propertyValidator("device", cdk.validateString)(properties.device)), errors.collect(cdk.propertyValidator("volumeId", cdk.requiredValidator)(properties.volumeId)), errors.collect(cdk.propertyValidator("volumeId", cdk.validateString)(properties.volumeId)), errors.wrap('supplied properties not correct for "VolumeProperty"');
    }
    function cfnInstanceVolumePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstance_VolumePropertyValidator(properties).assertSuccess(), { Device: cdk.stringToCloudFormation(properties.device), VolumeId: cdk.stringToCloudFormation(properties.volumeId) }) : properties;
    }
    function CfnInstanceVolumePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("device", "Device", cfn_parse.FromCloudFormation.getString(properties.Device)), ret.addPropertyResult("volumeId", "VolumeId", cfn_parse.FromCloudFormation.getString(properties.VolumeId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInternetGatewayPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnInternetGatewayProps"');
    }
    function cfnInternetGatewayPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInternetGatewayPropsValidator(properties).assertSuccess(), { Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnInternetGatewayPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnInternetGateway = class _CfnInternetGateway extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnInternetGatewayPropsFromCloudFormation(resourceProperties), ret = new _CfnInternetGateway(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnInternetGateway.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnInternetGatewayProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnInternetGateway), error;
        }
        this.attrInternetGatewayId = cdk.Token.asString(this.getAtt("InternetGatewayId", cdk.ResolutionTypeHint.STRING)), this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::InternetGateway", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnInternetGateway.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnInternetGatewayPropsToCloudFormation(props);
      }
    };
    _1 = JSII_RTTI_SYMBOL_1, CfnInternetGateway[_1] = { fqn: "aws-cdk-lib.aws_ec2.CfnInternetGateway", version: "2.80.0" }, CfnInternetGateway.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::InternetGateway", exports2.CfnInternetGateway = CfnInternetGateway;
    function CfnKeyPairPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("keyName", cdk.requiredValidator)(properties.keyName)), errors.collect(cdk.propertyValidator("keyName", cdk.validateString)(properties.keyName)), errors.collect(cdk.propertyValidator("keyType", cdk.validateString)(properties.keyType)), errors.collect(cdk.propertyValidator("publicKeyMaterial", cdk.validateString)(properties.publicKeyMaterial)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnKeyPairProps"');
    }
    function cfnKeyPairPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnKeyPairPropsValidator(properties).assertSuccess(), { KeyName: cdk.stringToCloudFormation(properties.keyName), KeyType: cdk.stringToCloudFormation(properties.keyType), PublicKeyMaterial: cdk.stringToCloudFormation(properties.publicKeyMaterial), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnKeyPairPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("keyName", "KeyName", cfn_parse.FromCloudFormation.getString(properties.KeyName)), ret.addPropertyResult("keyType", "KeyType", properties.KeyType != null ? cfn_parse.FromCloudFormation.getString(properties.KeyType) : void 0), ret.addPropertyResult("publicKeyMaterial", "PublicKeyMaterial", properties.PublicKeyMaterial != null ? cfn_parse.FromCloudFormation.getString(properties.PublicKeyMaterial) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnKeyPair = class _CfnKeyPair extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnKeyPairPropsFromCloudFormation(resourceProperties), ret = new _CfnKeyPair(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnKeyPair.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnKeyPairProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnKeyPair), error;
        }
        cdk.requireProperty(props, "keyName", this), this.attrKeyFingerprint = cdk.Token.asString(this.getAtt("KeyFingerprint", cdk.ResolutionTypeHint.STRING)), this.attrKeyPairId = cdk.Token.asString(this.getAtt("KeyPairId", cdk.ResolutionTypeHint.STRING)), this.keyName = props.keyName, this.keyType = props.keyType, this.publicKeyMaterial = props.publicKeyMaterial, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::KeyPair", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnKeyPair.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { keyName: this.keyName, keyType: this.keyType, publicKeyMaterial: this.publicKeyMaterial, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnKeyPairPropsToCloudFormation(props);
      }
    };
    _2 = JSII_RTTI_SYMBOL_1, CfnKeyPair[_2] = { fqn: "aws-cdk-lib.aws_ec2.CfnKeyPair", version: "2.80.0" }, CfnKeyPair.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::KeyPair", exports2.CfnKeyPair = CfnKeyPair;
    function CfnLaunchTemplatePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("launchTemplateData", cdk.requiredValidator)(properties.launchTemplateData)), errors.collect(cdk.propertyValidator("launchTemplateData", CfnLaunchTemplate_LaunchTemplateDataPropertyValidator)(properties.launchTemplateData)), errors.collect(cdk.propertyValidator("launchTemplateName", cdk.validateString)(properties.launchTemplateName)), errors.collect(cdk.propertyValidator("tagSpecifications", cdk.listValidator(CfnLaunchTemplate_LaunchTemplateTagSpecificationPropertyValidator))(properties.tagSpecifications)), errors.collect(cdk.propertyValidator("versionDescription", cdk.validateString)(properties.versionDescription)), errors.wrap('supplied properties not correct for "CfnLaunchTemplateProps"');
    }
    function cfnLaunchTemplatePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplatePropsValidator(properties).assertSuccess(), { LaunchTemplateData: cfnLaunchTemplateLaunchTemplateDataPropertyToCloudFormation(properties.launchTemplateData), LaunchTemplateName: cdk.stringToCloudFormation(properties.launchTemplateName), TagSpecifications: cdk.listMapper(cfnLaunchTemplateLaunchTemplateTagSpecificationPropertyToCloudFormation)(properties.tagSpecifications), VersionDescription: cdk.stringToCloudFormation(properties.versionDescription) }) : properties;
    }
    function CfnLaunchTemplatePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("launchTemplateData", "LaunchTemplateData", CfnLaunchTemplateLaunchTemplateDataPropertyFromCloudFormation(properties.LaunchTemplateData)), ret.addPropertyResult("launchTemplateName", "LaunchTemplateName", properties.LaunchTemplateName != null ? cfn_parse.FromCloudFormation.getString(properties.LaunchTemplateName) : void 0), ret.addPropertyResult("tagSpecifications", "TagSpecifications", properties.TagSpecifications != null ? cfn_parse.FromCloudFormation.getArray(CfnLaunchTemplateLaunchTemplateTagSpecificationPropertyFromCloudFormation)(properties.TagSpecifications) : void 0), ret.addPropertyResult("versionDescription", "VersionDescription", properties.VersionDescription != null ? cfn_parse.FromCloudFormation.getString(properties.VersionDescription) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLaunchTemplate = class _CfnLaunchTemplate extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLaunchTemplatePropsFromCloudFormation(resourceProperties), ret = new _CfnLaunchTemplate(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLaunchTemplate.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnLaunchTemplateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLaunchTemplate), error;
        }
        cdk.requireProperty(props, "launchTemplateData", this), this.attrDefaultVersionNumber = cdk.Token.asString(this.getAtt("DefaultVersionNumber", cdk.ResolutionTypeHint.STRING)), this.attrLatestVersionNumber = cdk.Token.asString(this.getAtt("LatestVersionNumber", cdk.ResolutionTypeHint.STRING)), this.launchTemplateData = props.launchTemplateData, this.launchTemplateName = props.launchTemplateName, this.tagSpecifications = props.tagSpecifications, this.versionDescription = props.versionDescription;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLaunchTemplate.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { launchTemplateData: this.launchTemplateData, launchTemplateName: this.launchTemplateName, tagSpecifications: this.tagSpecifications, versionDescription: this.versionDescription };
      }
      renderProperties(props) {
        return cfnLaunchTemplatePropsToCloudFormation(props);
      }
    };
    _3 = JSII_RTTI_SYMBOL_1, CfnLaunchTemplate[_3] = { fqn: "aws-cdk-lib.aws_ec2.CfnLaunchTemplate", version: "2.80.0" }, CfnLaunchTemplate.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::LaunchTemplate", exports2.CfnLaunchTemplate = CfnLaunchTemplate;
    function CfnLaunchTemplate_AcceleratorCountPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "AcceleratorCountProperty"');
    }
    function cfnLaunchTemplateAcceleratorCountPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_AcceleratorCountPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnLaunchTemplateAcceleratorCountPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_AcceleratorTotalMemoryMiBPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "AcceleratorTotalMemoryMiBProperty"');
    }
    function cfnLaunchTemplateAcceleratorTotalMemoryMiBPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_AcceleratorTotalMemoryMiBPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnLaunchTemplateAcceleratorTotalMemoryMiBPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_BaselineEbsBandwidthMbpsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "BaselineEbsBandwidthMbpsProperty"');
    }
    function cfnLaunchTemplateBaselineEbsBandwidthMbpsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_BaselineEbsBandwidthMbpsPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnLaunchTemplateBaselineEbsBandwidthMbpsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_BlockDeviceMappingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deviceName", cdk.validateString)(properties.deviceName)), errors.collect(cdk.propertyValidator("ebs", CfnLaunchTemplate_EbsPropertyValidator)(properties.ebs)), errors.collect(cdk.propertyValidator("noDevice", cdk.validateString)(properties.noDevice)), errors.collect(cdk.propertyValidator("virtualName", cdk.validateString)(properties.virtualName)), errors.wrap('supplied properties not correct for "BlockDeviceMappingProperty"');
    }
    function cfnLaunchTemplateBlockDeviceMappingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_BlockDeviceMappingPropertyValidator(properties).assertSuccess(), { DeviceName: cdk.stringToCloudFormation(properties.deviceName), Ebs: cfnLaunchTemplateEbsPropertyToCloudFormation(properties.ebs), NoDevice: cdk.stringToCloudFormation(properties.noDevice), VirtualName: cdk.stringToCloudFormation(properties.virtualName) }) : properties;
    }
    function CfnLaunchTemplateBlockDeviceMappingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deviceName", "DeviceName", properties.DeviceName != null ? cfn_parse.FromCloudFormation.getString(properties.DeviceName) : void 0), ret.addPropertyResult("ebs", "Ebs", properties.Ebs != null ? CfnLaunchTemplateEbsPropertyFromCloudFormation(properties.Ebs) : void 0), ret.addPropertyResult("noDevice", "NoDevice", properties.NoDevice != null ? cfn_parse.FromCloudFormation.getString(properties.NoDevice) : void 0), ret.addPropertyResult("virtualName", "VirtualName", properties.VirtualName != null ? cfn_parse.FromCloudFormation.getString(properties.VirtualName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_CapacityReservationSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("capacityReservationPreference", cdk.validateString)(properties.capacityReservationPreference)), errors.collect(cdk.propertyValidator("capacityReservationTarget", CfnLaunchTemplate_CapacityReservationTargetPropertyValidator)(properties.capacityReservationTarget)), errors.wrap('supplied properties not correct for "CapacityReservationSpecificationProperty"');
    }
    function cfnLaunchTemplateCapacityReservationSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_CapacityReservationSpecificationPropertyValidator(properties).assertSuccess(), { CapacityReservationPreference: cdk.stringToCloudFormation(properties.capacityReservationPreference), CapacityReservationTarget: cfnLaunchTemplateCapacityReservationTargetPropertyToCloudFormation(properties.capacityReservationTarget) }) : properties;
    }
    function CfnLaunchTemplateCapacityReservationSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("capacityReservationPreference", "CapacityReservationPreference", properties.CapacityReservationPreference != null ? cfn_parse.FromCloudFormation.getString(properties.CapacityReservationPreference) : void 0), ret.addPropertyResult("capacityReservationTarget", "CapacityReservationTarget", properties.CapacityReservationTarget != null ? CfnLaunchTemplateCapacityReservationTargetPropertyFromCloudFormation(properties.CapacityReservationTarget) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_CapacityReservationTargetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("capacityReservationId", cdk.validateString)(properties.capacityReservationId)), errors.collect(cdk.propertyValidator("capacityReservationResourceGroupArn", cdk.validateString)(properties.capacityReservationResourceGroupArn)), errors.wrap('supplied properties not correct for "CapacityReservationTargetProperty"');
    }
    function cfnLaunchTemplateCapacityReservationTargetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_CapacityReservationTargetPropertyValidator(properties).assertSuccess(), { CapacityReservationId: cdk.stringToCloudFormation(properties.capacityReservationId), CapacityReservationResourceGroupArn: cdk.stringToCloudFormation(properties.capacityReservationResourceGroupArn) }) : properties;
    }
    function CfnLaunchTemplateCapacityReservationTargetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("capacityReservationId", "CapacityReservationId", properties.CapacityReservationId != null ? cfn_parse.FromCloudFormation.getString(properties.CapacityReservationId) : void 0), ret.addPropertyResult("capacityReservationResourceGroupArn", "CapacityReservationResourceGroupArn", properties.CapacityReservationResourceGroupArn != null ? cfn_parse.FromCloudFormation.getString(properties.CapacityReservationResourceGroupArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_CpuOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("amdSevSnp", cdk.validateString)(properties.amdSevSnp)), errors.collect(cdk.propertyValidator("coreCount", cdk.validateNumber)(properties.coreCount)), errors.collect(cdk.propertyValidator("threadsPerCore", cdk.validateNumber)(properties.threadsPerCore)), errors.wrap('supplied properties not correct for "CpuOptionsProperty"');
    }
    function cfnLaunchTemplateCpuOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_CpuOptionsPropertyValidator(properties).assertSuccess(), { AmdSevSnp: cdk.stringToCloudFormation(properties.amdSevSnp), CoreCount: cdk.numberToCloudFormation(properties.coreCount), ThreadsPerCore: cdk.numberToCloudFormation(properties.threadsPerCore) }) : properties;
    }
    function CfnLaunchTemplateCpuOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("amdSevSnp", "AmdSevSnp", properties.AmdSevSnp != null ? cfn_parse.FromCloudFormation.getString(properties.AmdSevSnp) : void 0), ret.addPropertyResult("coreCount", "CoreCount", properties.CoreCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.CoreCount) : void 0), ret.addPropertyResult("threadsPerCore", "ThreadsPerCore", properties.ThreadsPerCore != null ? cfn_parse.FromCloudFormation.getNumber(properties.ThreadsPerCore) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_CreditSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cpuCredits", cdk.validateString)(properties.cpuCredits)), errors.wrap('supplied properties not correct for "CreditSpecificationProperty"');
    }
    function cfnLaunchTemplateCreditSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_CreditSpecificationPropertyValidator(properties).assertSuccess(), { CpuCredits: cdk.stringToCloudFormation(properties.cpuCredits) }) : properties;
    }
    function CfnLaunchTemplateCreditSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cpuCredits", "CpuCredits", properties.CpuCredits != null ? cfn_parse.FromCloudFormation.getString(properties.CpuCredits) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_EbsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deleteOnTermination", cdk.validateBoolean)(properties.deleteOnTermination)), errors.collect(cdk.propertyValidator("encrypted", cdk.validateBoolean)(properties.encrypted)), errors.collect(cdk.propertyValidator("iops", cdk.validateNumber)(properties.iops)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("snapshotId", cdk.validateString)(properties.snapshotId)), errors.collect(cdk.propertyValidator("throughput", cdk.validateNumber)(properties.throughput)), errors.collect(cdk.propertyValidator("volumeSize", cdk.validateNumber)(properties.volumeSize)), errors.collect(cdk.propertyValidator("volumeType", cdk.validateString)(properties.volumeType)), errors.wrap('supplied properties not correct for "EbsProperty"');
    }
    function cfnLaunchTemplateEbsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_EbsPropertyValidator(properties).assertSuccess(), { DeleteOnTermination: cdk.booleanToCloudFormation(properties.deleteOnTermination), Encrypted: cdk.booleanToCloudFormation(properties.encrypted), Iops: cdk.numberToCloudFormation(properties.iops), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), SnapshotId: cdk.stringToCloudFormation(properties.snapshotId), Throughput: cdk.numberToCloudFormation(properties.throughput), VolumeSize: cdk.numberToCloudFormation(properties.volumeSize), VolumeType: cdk.stringToCloudFormation(properties.volumeType) }) : properties;
    }
    function CfnLaunchTemplateEbsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deleteOnTermination", "DeleteOnTermination", properties.DeleteOnTermination != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeleteOnTermination) : void 0), ret.addPropertyResult("encrypted", "Encrypted", properties.Encrypted != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Encrypted) : void 0), ret.addPropertyResult("iops", "Iops", properties.Iops != null ? cfn_parse.FromCloudFormation.getNumber(properties.Iops) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("snapshotId", "SnapshotId", properties.SnapshotId != null ? cfn_parse.FromCloudFormation.getString(properties.SnapshotId) : void 0), ret.addPropertyResult("throughput", "Throughput", properties.Throughput != null ? cfn_parse.FromCloudFormation.getNumber(properties.Throughput) : void 0), ret.addPropertyResult("volumeSize", "VolumeSize", properties.VolumeSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.VolumeSize) : void 0), ret.addPropertyResult("volumeType", "VolumeType", properties.VolumeType != null ? cfn_parse.FromCloudFormation.getString(properties.VolumeType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_ElasticGpuSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "ElasticGpuSpecificationProperty"');
    }
    function cfnLaunchTemplateElasticGpuSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_ElasticGpuSpecificationPropertyValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnLaunchTemplateElasticGpuSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_EnclaveOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "EnclaveOptionsProperty"');
    }
    function cfnLaunchTemplateEnclaveOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_EnclaveOptionsPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnLaunchTemplateEnclaveOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_HibernationOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configured", cdk.validateBoolean)(properties.configured)), errors.wrap('supplied properties not correct for "HibernationOptionsProperty"');
    }
    function cfnLaunchTemplateHibernationOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_HibernationOptionsPropertyValidator(properties).assertSuccess(), { Configured: cdk.booleanToCloudFormation(properties.configured) }) : properties;
    }
    function CfnLaunchTemplateHibernationOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configured", "Configured", properties.Configured != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Configured) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_IamInstanceProfilePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "IamInstanceProfileProperty"');
    }
    function cfnLaunchTemplateIamInstanceProfilePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_IamInstanceProfilePropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnLaunchTemplateIamInstanceProfilePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", properties.Arn != null ? cfn_parse.FromCloudFormation.getString(properties.Arn) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_InstanceMarketOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("marketType", cdk.validateString)(properties.marketType)), errors.collect(cdk.propertyValidator("spotOptions", CfnLaunchTemplate_SpotOptionsPropertyValidator)(properties.spotOptions)), errors.wrap('supplied properties not correct for "InstanceMarketOptionsProperty"');
    }
    function cfnLaunchTemplateInstanceMarketOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_InstanceMarketOptionsPropertyValidator(properties).assertSuccess(), { MarketType: cdk.stringToCloudFormation(properties.marketType), SpotOptions: cfnLaunchTemplateSpotOptionsPropertyToCloudFormation(properties.spotOptions) }) : properties;
    }
    function CfnLaunchTemplateInstanceMarketOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("marketType", "MarketType", properties.MarketType != null ? cfn_parse.FromCloudFormation.getString(properties.MarketType) : void 0), ret.addPropertyResult("spotOptions", "SpotOptions", properties.SpotOptions != null ? CfnLaunchTemplateSpotOptionsPropertyFromCloudFormation(properties.SpotOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_InstanceRequirementsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acceleratorCount", CfnLaunchTemplate_AcceleratorCountPropertyValidator)(properties.acceleratorCount)), errors.collect(cdk.propertyValidator("acceleratorManufacturers", cdk.listValidator(cdk.validateString))(properties.acceleratorManufacturers)), errors.collect(cdk.propertyValidator("acceleratorNames", cdk.listValidator(cdk.validateString))(properties.acceleratorNames)), errors.collect(cdk.propertyValidator("acceleratorTotalMemoryMiB", CfnLaunchTemplate_AcceleratorTotalMemoryMiBPropertyValidator)(properties.acceleratorTotalMemoryMiB)), errors.collect(cdk.propertyValidator("acceleratorTypes", cdk.listValidator(cdk.validateString))(properties.acceleratorTypes)), errors.collect(cdk.propertyValidator("allowedInstanceTypes", cdk.listValidator(cdk.validateString))(properties.allowedInstanceTypes)), errors.collect(cdk.propertyValidator("bareMetal", cdk.validateString)(properties.bareMetal)), errors.collect(cdk.propertyValidator("baselineEbsBandwidthMbps", CfnLaunchTemplate_BaselineEbsBandwidthMbpsPropertyValidator)(properties.baselineEbsBandwidthMbps)), errors.collect(cdk.propertyValidator("burstablePerformance", cdk.validateString)(properties.burstablePerformance)), errors.collect(cdk.propertyValidator("cpuManufacturers", cdk.listValidator(cdk.validateString))(properties.cpuManufacturers)), errors.collect(cdk.propertyValidator("excludedInstanceTypes", cdk.listValidator(cdk.validateString))(properties.excludedInstanceTypes)), errors.collect(cdk.propertyValidator("instanceGenerations", cdk.listValidator(cdk.validateString))(properties.instanceGenerations)), errors.collect(cdk.propertyValidator("localStorage", cdk.validateString)(properties.localStorage)), errors.collect(cdk.propertyValidator("localStorageTypes", cdk.listValidator(cdk.validateString))(properties.localStorageTypes)), errors.collect(cdk.propertyValidator("memoryGiBPerVCpu", CfnLaunchTemplate_MemoryGiBPerVCpuPropertyValidator)(properties.memoryGiBPerVCpu)), errors.collect(cdk.propertyValidator("memoryMiB", CfnLaunchTemplate_MemoryMiBPropertyValidator)(properties.memoryMiB)), errors.collect(cdk.propertyValidator("networkBandwidthGbps", CfnLaunchTemplate_NetworkBandwidthGbpsPropertyValidator)(properties.networkBandwidthGbps)), errors.collect(cdk.propertyValidator("networkInterfaceCount", CfnLaunchTemplate_NetworkInterfaceCountPropertyValidator)(properties.networkInterfaceCount)), errors.collect(cdk.propertyValidator("onDemandMaxPricePercentageOverLowestPrice", cdk.validateNumber)(properties.onDemandMaxPricePercentageOverLowestPrice)), errors.collect(cdk.propertyValidator("requireHibernateSupport", cdk.validateBoolean)(properties.requireHibernateSupport)), errors.collect(cdk.propertyValidator("spotMaxPricePercentageOverLowestPrice", cdk.validateNumber)(properties.spotMaxPricePercentageOverLowestPrice)), errors.collect(cdk.propertyValidator("totalLocalStorageGb", CfnLaunchTemplate_TotalLocalStorageGBPropertyValidator)(properties.totalLocalStorageGb)), errors.collect(cdk.propertyValidator("vCpuCount", CfnLaunchTemplate_VCpuCountPropertyValidator)(properties.vCpuCount)), errors.wrap('supplied properties not correct for "InstanceRequirementsProperty"');
    }
    function cfnLaunchTemplateInstanceRequirementsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_InstanceRequirementsPropertyValidator(properties).assertSuccess(), { AcceleratorCount: cfnLaunchTemplateAcceleratorCountPropertyToCloudFormation(properties.acceleratorCount), AcceleratorManufacturers: cdk.listMapper(cdk.stringToCloudFormation)(properties.acceleratorManufacturers), AcceleratorNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.acceleratorNames), AcceleratorTotalMemoryMiB: cfnLaunchTemplateAcceleratorTotalMemoryMiBPropertyToCloudFormation(properties.acceleratorTotalMemoryMiB), AcceleratorTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.acceleratorTypes), AllowedInstanceTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowedInstanceTypes), BareMetal: cdk.stringToCloudFormation(properties.bareMetal), BaselineEbsBandwidthMbps: cfnLaunchTemplateBaselineEbsBandwidthMbpsPropertyToCloudFormation(properties.baselineEbsBandwidthMbps), BurstablePerformance: cdk.stringToCloudFormation(properties.burstablePerformance), CpuManufacturers: cdk.listMapper(cdk.stringToCloudFormation)(properties.cpuManufacturers), ExcludedInstanceTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.excludedInstanceTypes), InstanceGenerations: cdk.listMapper(cdk.stringToCloudFormation)(properties.instanceGenerations), LocalStorage: cdk.stringToCloudFormation(properties.localStorage), LocalStorageTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.localStorageTypes), MemoryGiBPerVCpu: cfnLaunchTemplateMemoryGiBPerVCpuPropertyToCloudFormation(properties.memoryGiBPerVCpu), MemoryMiB: cfnLaunchTemplateMemoryMiBPropertyToCloudFormation(properties.memoryMiB), NetworkBandwidthGbps: cfnLaunchTemplateNetworkBandwidthGbpsPropertyToCloudFormation(properties.networkBandwidthGbps), NetworkInterfaceCount: cfnLaunchTemplateNetworkInterfaceCountPropertyToCloudFormation(properties.networkInterfaceCount), OnDemandMaxPricePercentageOverLowestPrice: cdk.numberToCloudFormation(properties.onDemandMaxPricePercentageOverLowestPrice), RequireHibernateSupport: cdk.booleanToCloudFormation(properties.requireHibernateSupport), SpotMaxPricePercentageOverLowestPrice: cdk.numberToCloudFormation(properties.spotMaxPricePercentageOverLowestPrice), TotalLocalStorageGB: cfnLaunchTemplateTotalLocalStorageGBPropertyToCloudFormation(properties.totalLocalStorageGb), VCpuCount: cfnLaunchTemplateVCpuCountPropertyToCloudFormation(properties.vCpuCount) }) : properties;
    }
    function CfnLaunchTemplateInstanceRequirementsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("acceleratorCount", "AcceleratorCount", properties.AcceleratorCount != null ? CfnLaunchTemplateAcceleratorCountPropertyFromCloudFormation(properties.AcceleratorCount) : void 0), ret.addPropertyResult("acceleratorManufacturers", "AcceleratorManufacturers", properties.AcceleratorManufacturers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AcceleratorManufacturers) : void 0), ret.addPropertyResult("acceleratorNames", "AcceleratorNames", properties.AcceleratorNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AcceleratorNames) : void 0), ret.addPropertyResult("acceleratorTotalMemoryMiB", "AcceleratorTotalMemoryMiB", properties.AcceleratorTotalMemoryMiB != null ? CfnLaunchTemplateAcceleratorTotalMemoryMiBPropertyFromCloudFormation(properties.AcceleratorTotalMemoryMiB) : void 0), ret.addPropertyResult("acceleratorTypes", "AcceleratorTypes", properties.AcceleratorTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AcceleratorTypes) : void 0), ret.addPropertyResult("allowedInstanceTypes", "AllowedInstanceTypes", properties.AllowedInstanceTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AllowedInstanceTypes) : void 0), ret.addPropertyResult("bareMetal", "BareMetal", properties.BareMetal != null ? cfn_parse.FromCloudFormation.getString(properties.BareMetal) : void 0), ret.addPropertyResult("baselineEbsBandwidthMbps", "BaselineEbsBandwidthMbps", properties.BaselineEbsBandwidthMbps != null ? CfnLaunchTemplateBaselineEbsBandwidthMbpsPropertyFromCloudFormation(properties.BaselineEbsBandwidthMbps) : void 0), ret.addPropertyResult("burstablePerformance", "BurstablePerformance", properties.BurstablePerformance != null ? cfn_parse.FromCloudFormation.getString(properties.BurstablePerformance) : void 0), ret.addPropertyResult("cpuManufacturers", "CpuManufacturers", properties.CpuManufacturers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CpuManufacturers) : void 0), ret.addPropertyResult("excludedInstanceTypes", "ExcludedInstanceTypes", properties.ExcludedInstanceTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExcludedInstanceTypes) : void 0), ret.addPropertyResult("instanceGenerations", "InstanceGenerations", properties.InstanceGenerations != null ? cfn_parse.FromCloudFormation.getStringArray(properties.InstanceGenerations) : void 0), ret.addPropertyResult("localStorage", "LocalStorage", properties.LocalStorage != null ? cfn_parse.FromCloudFormation.getString(properties.LocalStorage) : void 0), ret.addPropertyResult("localStorageTypes", "LocalStorageTypes", properties.LocalStorageTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.LocalStorageTypes) : void 0), ret.addPropertyResult("memoryGiBPerVCpu", "MemoryGiBPerVCpu", properties.MemoryGiBPerVCpu != null ? CfnLaunchTemplateMemoryGiBPerVCpuPropertyFromCloudFormation(properties.MemoryGiBPerVCpu) : void 0), ret.addPropertyResult("memoryMiB", "MemoryMiB", properties.MemoryMiB != null ? CfnLaunchTemplateMemoryMiBPropertyFromCloudFormation(properties.MemoryMiB) : void 0), ret.addPropertyResult("networkBandwidthGbps", "NetworkBandwidthGbps", properties.NetworkBandwidthGbps != null ? CfnLaunchTemplateNetworkBandwidthGbpsPropertyFromCloudFormation(properties.NetworkBandwidthGbps) : void 0), ret.addPropertyResult("networkInterfaceCount", "NetworkInterfaceCount", properties.NetworkInterfaceCount != null ? CfnLaunchTemplateNetworkInterfaceCountPropertyFromCloudFormation(properties.NetworkInterfaceCount) : void 0), ret.addPropertyResult("onDemandMaxPricePercentageOverLowestPrice", "OnDemandMaxPricePercentageOverLowestPrice", properties.OnDemandMaxPricePercentageOverLowestPrice != null ? cfn_parse.FromCloudFormation.getNumber(properties.OnDemandMaxPricePercentageOverLowestPrice) : void 0), ret.addPropertyResult("requireHibernateSupport", "RequireHibernateSupport", properties.RequireHibernateSupport != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RequireHibernateSupport) : void 0), ret.addPropertyResult("spotMaxPricePercentageOverLowestPrice", "SpotMaxPricePercentageOverLowestPrice", properties.SpotMaxPricePercentageOverLowestPrice != null ? cfn_parse.FromCloudFormation.getNumber(properties.SpotMaxPricePercentageOverLowestPrice) : void 0), ret.addPropertyResult("totalLocalStorageGb", "TotalLocalStorageGB", properties.TotalLocalStorageGB != null ? CfnLaunchTemplateTotalLocalStorageGBPropertyFromCloudFormation(properties.TotalLocalStorageGB) : void 0), ret.addPropertyResult("vCpuCount", "VCpuCount", properties.VCpuCount != null ? CfnLaunchTemplateVCpuCountPropertyFromCloudFormation(properties.VCpuCount) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_Ipv4PrefixSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ipv4Prefix", cdk.validateString)(properties.ipv4Prefix)), errors.wrap('supplied properties not correct for "Ipv4PrefixSpecificationProperty"');
    }
    function cfnLaunchTemplateIpv4PrefixSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_Ipv4PrefixSpecificationPropertyValidator(properties).assertSuccess(), { Ipv4Prefix: cdk.stringToCloudFormation(properties.ipv4Prefix) }) : properties;
    }
    function CfnLaunchTemplateIpv4PrefixSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ipv4Prefix", "Ipv4Prefix", properties.Ipv4Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Ipv4Prefix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_Ipv6AddPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ipv6Address", cdk.validateString)(properties.ipv6Address)), errors.wrap('supplied properties not correct for "Ipv6AddProperty"');
    }
    function cfnLaunchTemplateIpv6AddPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_Ipv6AddPropertyValidator(properties).assertSuccess(), { Ipv6Address: cdk.stringToCloudFormation(properties.ipv6Address) }) : properties;
    }
    function CfnLaunchTemplateIpv6AddPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ipv6Address", "Ipv6Address", properties.Ipv6Address != null ? cfn_parse.FromCloudFormation.getString(properties.Ipv6Address) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_Ipv6PrefixSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ipv6Prefix", cdk.validateString)(properties.ipv6Prefix)), errors.wrap('supplied properties not correct for "Ipv6PrefixSpecificationProperty"');
    }
    function cfnLaunchTemplateIpv6PrefixSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_Ipv6PrefixSpecificationPropertyValidator(properties).assertSuccess(), { Ipv6Prefix: cdk.stringToCloudFormation(properties.ipv6Prefix) }) : properties;
    }
    function CfnLaunchTemplateIpv6PrefixSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ipv6Prefix", "Ipv6Prefix", properties.Ipv6Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Ipv6Prefix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_LaunchTemplateDataPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("blockDeviceMappings", cdk.listValidator(CfnLaunchTemplate_BlockDeviceMappingPropertyValidator))(properties.blockDeviceMappings)), errors.collect(cdk.propertyValidator("capacityReservationSpecification", CfnLaunchTemplate_CapacityReservationSpecificationPropertyValidator)(properties.capacityReservationSpecification)), errors.collect(cdk.propertyValidator("cpuOptions", CfnLaunchTemplate_CpuOptionsPropertyValidator)(properties.cpuOptions)), errors.collect(cdk.propertyValidator("creditSpecification", CfnLaunchTemplate_CreditSpecificationPropertyValidator)(properties.creditSpecification)), errors.collect(cdk.propertyValidator("disableApiStop", cdk.validateBoolean)(properties.disableApiStop)), errors.collect(cdk.propertyValidator("disableApiTermination", cdk.validateBoolean)(properties.disableApiTermination)), errors.collect(cdk.propertyValidator("ebsOptimized", cdk.validateBoolean)(properties.ebsOptimized)), errors.collect(cdk.propertyValidator("elasticGpuSpecifications", cdk.listValidator(CfnLaunchTemplate_ElasticGpuSpecificationPropertyValidator))(properties.elasticGpuSpecifications)), errors.collect(cdk.propertyValidator("elasticInferenceAccelerators", cdk.listValidator(CfnLaunchTemplate_LaunchTemplateElasticInferenceAcceleratorPropertyValidator))(properties.elasticInferenceAccelerators)), errors.collect(cdk.propertyValidator("enclaveOptions", CfnLaunchTemplate_EnclaveOptionsPropertyValidator)(properties.enclaveOptions)), errors.collect(cdk.propertyValidator("hibernationOptions", CfnLaunchTemplate_HibernationOptionsPropertyValidator)(properties.hibernationOptions)), errors.collect(cdk.propertyValidator("iamInstanceProfile", CfnLaunchTemplate_IamInstanceProfilePropertyValidator)(properties.iamInstanceProfile)), errors.collect(cdk.propertyValidator("imageId", cdk.validateString)(properties.imageId)), errors.collect(cdk.propertyValidator("instanceInitiatedShutdownBehavior", cdk.validateString)(properties.instanceInitiatedShutdownBehavior)), errors.collect(cdk.propertyValidator("instanceMarketOptions", CfnLaunchTemplate_InstanceMarketOptionsPropertyValidator)(properties.instanceMarketOptions)), errors.collect(cdk.propertyValidator("instanceRequirements", CfnLaunchTemplate_InstanceRequirementsPropertyValidator)(properties.instanceRequirements)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("kernelId", cdk.validateString)(properties.kernelId)), errors.collect(cdk.propertyValidator("keyName", cdk.validateString)(properties.keyName)), errors.collect(cdk.propertyValidator("licenseSpecifications", cdk.listValidator(CfnLaunchTemplate_LicenseSpecificationPropertyValidator))(properties.licenseSpecifications)), errors.collect(cdk.propertyValidator("maintenanceOptions", CfnLaunchTemplate_MaintenanceOptionsPropertyValidator)(properties.maintenanceOptions)), errors.collect(cdk.propertyValidator("metadataOptions", CfnLaunchTemplate_MetadataOptionsPropertyValidator)(properties.metadataOptions)), errors.collect(cdk.propertyValidator("monitoring", CfnLaunchTemplate_MonitoringPropertyValidator)(properties.monitoring)), errors.collect(cdk.propertyValidator("networkInterfaces", cdk.listValidator(CfnLaunchTemplate_NetworkInterfacePropertyValidator))(properties.networkInterfaces)), errors.collect(cdk.propertyValidator("placement", CfnLaunchTemplate_PlacementPropertyValidator)(properties.placement)), errors.collect(cdk.propertyValidator("privateDnsNameOptions", CfnLaunchTemplate_PrivateDnsNameOptionsPropertyValidator)(properties.privateDnsNameOptions)), errors.collect(cdk.propertyValidator("ramDiskId", cdk.validateString)(properties.ramDiskId)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("securityGroups", cdk.listValidator(cdk.validateString))(properties.securityGroups)), errors.collect(cdk.propertyValidator("tagSpecifications", cdk.listValidator(CfnLaunchTemplate_TagSpecificationPropertyValidator))(properties.tagSpecifications)), errors.collect(cdk.propertyValidator("userData", cdk.validateString)(properties.userData)), errors.wrap('supplied properties not correct for "LaunchTemplateDataProperty"');
    }
    function cfnLaunchTemplateLaunchTemplateDataPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_LaunchTemplateDataPropertyValidator(properties).assertSuccess(), { BlockDeviceMappings: cdk.listMapper(cfnLaunchTemplateBlockDeviceMappingPropertyToCloudFormation)(properties.blockDeviceMappings), CapacityReservationSpecification: cfnLaunchTemplateCapacityReservationSpecificationPropertyToCloudFormation(properties.capacityReservationSpecification), CpuOptions: cfnLaunchTemplateCpuOptionsPropertyToCloudFormation(properties.cpuOptions), CreditSpecification: cfnLaunchTemplateCreditSpecificationPropertyToCloudFormation(properties.creditSpecification), DisableApiStop: cdk.booleanToCloudFormation(properties.disableApiStop), DisableApiTermination: cdk.booleanToCloudFormation(properties.disableApiTermination), EbsOptimized: cdk.booleanToCloudFormation(properties.ebsOptimized), ElasticGpuSpecifications: cdk.listMapper(cfnLaunchTemplateElasticGpuSpecificationPropertyToCloudFormation)(properties.elasticGpuSpecifications), ElasticInferenceAccelerators: cdk.listMapper(cfnLaunchTemplateLaunchTemplateElasticInferenceAcceleratorPropertyToCloudFormation)(properties.elasticInferenceAccelerators), EnclaveOptions: cfnLaunchTemplateEnclaveOptionsPropertyToCloudFormation(properties.enclaveOptions), HibernationOptions: cfnLaunchTemplateHibernationOptionsPropertyToCloudFormation(properties.hibernationOptions), IamInstanceProfile: cfnLaunchTemplateIamInstanceProfilePropertyToCloudFormation(properties.iamInstanceProfile), ImageId: cdk.stringToCloudFormation(properties.imageId), InstanceInitiatedShutdownBehavior: cdk.stringToCloudFormation(properties.instanceInitiatedShutdownBehavior), InstanceMarketOptions: cfnLaunchTemplateInstanceMarketOptionsPropertyToCloudFormation(properties.instanceMarketOptions), InstanceRequirements: cfnLaunchTemplateInstanceRequirementsPropertyToCloudFormation(properties.instanceRequirements), InstanceType: cdk.stringToCloudFormation(properties.instanceType), KernelId: cdk.stringToCloudFormation(properties.kernelId), KeyName: cdk.stringToCloudFormation(properties.keyName), LicenseSpecifications: cdk.listMapper(cfnLaunchTemplateLicenseSpecificationPropertyToCloudFormation)(properties.licenseSpecifications), MaintenanceOptions: cfnLaunchTemplateMaintenanceOptionsPropertyToCloudFormation(properties.maintenanceOptions), MetadataOptions: cfnLaunchTemplateMetadataOptionsPropertyToCloudFormation(properties.metadataOptions), Monitoring: cfnLaunchTemplateMonitoringPropertyToCloudFormation(properties.monitoring), NetworkInterfaces: cdk.listMapper(cfnLaunchTemplateNetworkInterfacePropertyToCloudFormation)(properties.networkInterfaces), Placement: cfnLaunchTemplatePlacementPropertyToCloudFormation(properties.placement), PrivateDnsNameOptions: cfnLaunchTemplatePrivateDnsNameOptionsPropertyToCloudFormation(properties.privateDnsNameOptions), RamDiskId: cdk.stringToCloudFormation(properties.ramDiskId), SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SecurityGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroups), TagSpecifications: cdk.listMapper(cfnLaunchTemplateTagSpecificationPropertyToCloudFormation)(properties.tagSpecifications), UserData: cdk.stringToCloudFormation(properties.userData) }) : properties;
    }
    function CfnLaunchTemplateLaunchTemplateDataPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("blockDeviceMappings", "BlockDeviceMappings", properties.BlockDeviceMappings != null ? cfn_parse.FromCloudFormation.getArray(CfnLaunchTemplateBlockDeviceMappingPropertyFromCloudFormation)(properties.BlockDeviceMappings) : void 0), ret.addPropertyResult("capacityReservationSpecification", "CapacityReservationSpecification", properties.CapacityReservationSpecification != null ? CfnLaunchTemplateCapacityReservationSpecificationPropertyFromCloudFormation(properties.CapacityReservationSpecification) : void 0), ret.addPropertyResult("cpuOptions", "CpuOptions", properties.CpuOptions != null ? CfnLaunchTemplateCpuOptionsPropertyFromCloudFormation(properties.CpuOptions) : void 0), ret.addPropertyResult("creditSpecification", "CreditSpecification", properties.CreditSpecification != null ? CfnLaunchTemplateCreditSpecificationPropertyFromCloudFormation(properties.CreditSpecification) : void 0), ret.addPropertyResult("disableApiStop", "DisableApiStop", properties.DisableApiStop != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DisableApiStop) : void 0), ret.addPropertyResult("disableApiTermination", "DisableApiTermination", properties.DisableApiTermination != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DisableApiTermination) : void 0), ret.addPropertyResult("ebsOptimized", "EbsOptimized", properties.EbsOptimized != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EbsOptimized) : void 0), ret.addPropertyResult("elasticGpuSpecifications", "ElasticGpuSpecifications", properties.ElasticGpuSpecifications != null ? cfn_parse.FromCloudFormation.getArray(CfnLaunchTemplateElasticGpuSpecificationPropertyFromCloudFormation)(properties.ElasticGpuSpecifications) : void 0), ret.addPropertyResult("elasticInferenceAccelerators", "ElasticInferenceAccelerators", properties.ElasticInferenceAccelerators != null ? cfn_parse.FromCloudFormation.getArray(CfnLaunchTemplateLaunchTemplateElasticInferenceAcceleratorPropertyFromCloudFormation)(properties.ElasticInferenceAccelerators) : void 0), ret.addPropertyResult("enclaveOptions", "EnclaveOptions", properties.EnclaveOptions != null ? CfnLaunchTemplateEnclaveOptionsPropertyFromCloudFormation(properties.EnclaveOptions) : void 0), ret.addPropertyResult("hibernationOptions", "HibernationOptions", properties.HibernationOptions != null ? CfnLaunchTemplateHibernationOptionsPropertyFromCloudFormation(properties.HibernationOptions) : void 0), ret.addPropertyResult("iamInstanceProfile", "IamInstanceProfile", properties.IamInstanceProfile != null ? CfnLaunchTemplateIamInstanceProfilePropertyFromCloudFormation(properties.IamInstanceProfile) : void 0), ret.addPropertyResult("imageId", "ImageId", properties.ImageId != null ? cfn_parse.FromCloudFormation.getString(properties.ImageId) : void 0), ret.addPropertyResult("instanceInitiatedShutdownBehavior", "InstanceInitiatedShutdownBehavior", properties.InstanceInitiatedShutdownBehavior != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceInitiatedShutdownBehavior) : void 0), ret.addPropertyResult("instanceMarketOptions", "InstanceMarketOptions", properties.InstanceMarketOptions != null ? CfnLaunchTemplateInstanceMarketOptionsPropertyFromCloudFormation(properties.InstanceMarketOptions) : void 0), ret.addPropertyResult("instanceRequirements", "InstanceRequirements", properties.InstanceRequirements != null ? CfnLaunchTemplateInstanceRequirementsPropertyFromCloudFormation(properties.InstanceRequirements) : void 0), ret.addPropertyResult("instanceType", "InstanceType", properties.InstanceType != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceType) : void 0), ret.addPropertyResult("kernelId", "KernelId", properties.KernelId != null ? cfn_parse.FromCloudFormation.getString(properties.KernelId) : void 0), ret.addPropertyResult("keyName", "KeyName", properties.KeyName != null ? cfn_parse.FromCloudFormation.getString(properties.KeyName) : void 0), ret.addPropertyResult("licenseSpecifications", "LicenseSpecifications", properties.LicenseSpecifications != null ? cfn_parse.FromCloudFormation.getArray(CfnLaunchTemplateLicenseSpecificationPropertyFromCloudFormation)(properties.LicenseSpecifications) : void 0), ret.addPropertyResult("maintenanceOptions", "MaintenanceOptions", properties.MaintenanceOptions != null ? CfnLaunchTemplateMaintenanceOptionsPropertyFromCloudFormation(properties.MaintenanceOptions) : void 0), ret.addPropertyResult("metadataOptions", "MetadataOptions", properties.MetadataOptions != null ? CfnLaunchTemplateMetadataOptionsPropertyFromCloudFormation(properties.MetadataOptions) : void 0), ret.addPropertyResult("monitoring", "Monitoring", properties.Monitoring != null ? CfnLaunchTemplateMonitoringPropertyFromCloudFormation(properties.Monitoring) : void 0), ret.addPropertyResult("networkInterfaces", "NetworkInterfaces", properties.NetworkInterfaces != null ? cfn_parse.FromCloudFormation.getArray(CfnLaunchTemplateNetworkInterfacePropertyFromCloudFormation)(properties.NetworkInterfaces) : void 0), ret.addPropertyResult("placement", "Placement", properties.Placement != null ? CfnLaunchTemplatePlacementPropertyFromCloudFormation(properties.Placement) : void 0), ret.addPropertyResult("privateDnsNameOptions", "PrivateDnsNameOptions", properties.PrivateDnsNameOptions != null ? CfnLaunchTemplatePrivateDnsNameOptionsPropertyFromCloudFormation(properties.PrivateDnsNameOptions) : void 0), ret.addPropertyResult("ramDiskId", "RamDiskId", properties.RamDiskId != null ? cfn_parse.FromCloudFormation.getString(properties.RamDiskId) : void 0), ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("securityGroups", "SecurityGroups", properties.SecurityGroups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroups) : void 0), ret.addPropertyResult("tagSpecifications", "TagSpecifications", properties.TagSpecifications != null ? cfn_parse.FromCloudFormation.getArray(CfnLaunchTemplateTagSpecificationPropertyFromCloudFormation)(properties.TagSpecifications) : void 0), ret.addPropertyResult("userData", "UserData", properties.UserData != null ? cfn_parse.FromCloudFormation.getString(properties.UserData) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_LaunchTemplateElasticInferenceAcceleratorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("count", cdk.validateNumber)(properties.count)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "LaunchTemplateElasticInferenceAcceleratorProperty"');
    }
    function cfnLaunchTemplateLaunchTemplateElasticInferenceAcceleratorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_LaunchTemplateElasticInferenceAcceleratorPropertyValidator(properties).assertSuccess(), { Count: cdk.numberToCloudFormation(properties.count), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnLaunchTemplateLaunchTemplateElasticInferenceAcceleratorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("count", "Count", properties.Count != null ? cfn_parse.FromCloudFormation.getNumber(properties.Count) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_LaunchTemplateTagSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceType", cdk.validateString)(properties.resourceType)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "LaunchTemplateTagSpecificationProperty"');
    }
    function cfnLaunchTemplateLaunchTemplateTagSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_LaunchTemplateTagSpecificationPropertyValidator(properties).assertSuccess(), { ResourceType: cdk.stringToCloudFormation(properties.resourceType), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnLaunchTemplateLaunchTemplateTagSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceType", "ResourceType", properties.ResourceType != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceType) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_LicenseSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("licenseConfigurationArn", cdk.validateString)(properties.licenseConfigurationArn)), errors.wrap('supplied properties not correct for "LicenseSpecificationProperty"');
    }
    function cfnLaunchTemplateLicenseSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_LicenseSpecificationPropertyValidator(properties).assertSuccess(), { LicenseConfigurationArn: cdk.stringToCloudFormation(properties.licenseConfigurationArn) }) : properties;
    }
    function CfnLaunchTemplateLicenseSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("licenseConfigurationArn", "LicenseConfigurationArn", properties.LicenseConfigurationArn != null ? cfn_parse.FromCloudFormation.getString(properties.LicenseConfigurationArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_MaintenanceOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoRecovery", cdk.validateString)(properties.autoRecovery)), errors.wrap('supplied properties not correct for "MaintenanceOptionsProperty"');
    }
    function cfnLaunchTemplateMaintenanceOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_MaintenanceOptionsPropertyValidator(properties).assertSuccess(), { AutoRecovery: cdk.stringToCloudFormation(properties.autoRecovery) }) : properties;
    }
    function CfnLaunchTemplateMaintenanceOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("autoRecovery", "AutoRecovery", properties.AutoRecovery != null ? cfn_parse.FromCloudFormation.getString(properties.AutoRecovery) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_MemoryGiBPerVCpuPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "MemoryGiBPerVCpuProperty"');
    }
    function cfnLaunchTemplateMemoryGiBPerVCpuPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_MemoryGiBPerVCpuPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnLaunchTemplateMemoryGiBPerVCpuPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_MemoryMiBPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "MemoryMiBProperty"');
    }
    function cfnLaunchTemplateMemoryMiBPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_MemoryMiBPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnLaunchTemplateMemoryMiBPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_MetadataOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("httpEndpoint", cdk.validateString)(properties.httpEndpoint)), errors.collect(cdk.propertyValidator("httpProtocolIpv6", cdk.validateString)(properties.httpProtocolIpv6)), errors.collect(cdk.propertyValidator("httpPutResponseHopLimit", cdk.validateNumber)(properties.httpPutResponseHopLimit)), errors.collect(cdk.propertyValidator("httpTokens", cdk.validateString)(properties.httpTokens)), errors.collect(cdk.propertyValidator("instanceMetadataTags", cdk.validateString)(properties.instanceMetadataTags)), errors.wrap('supplied properties not correct for "MetadataOptionsProperty"');
    }
    function cfnLaunchTemplateMetadataOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_MetadataOptionsPropertyValidator(properties).assertSuccess(), { HttpEndpoint: cdk.stringToCloudFormation(properties.httpEndpoint), HttpProtocolIpv6: cdk.stringToCloudFormation(properties.httpProtocolIpv6), HttpPutResponseHopLimit: cdk.numberToCloudFormation(properties.httpPutResponseHopLimit), HttpTokens: cdk.stringToCloudFormation(properties.httpTokens), InstanceMetadataTags: cdk.stringToCloudFormation(properties.instanceMetadataTags) }) : properties;
    }
    function CfnLaunchTemplateMetadataOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("httpEndpoint", "HttpEndpoint", properties.HttpEndpoint != null ? cfn_parse.FromCloudFormation.getString(properties.HttpEndpoint) : void 0), ret.addPropertyResult("httpProtocolIpv6", "HttpProtocolIpv6", properties.HttpProtocolIpv6 != null ? cfn_parse.FromCloudFormation.getString(properties.HttpProtocolIpv6) : void 0), ret.addPropertyResult("httpPutResponseHopLimit", "HttpPutResponseHopLimit", properties.HttpPutResponseHopLimit != null ? cfn_parse.FromCloudFormation.getNumber(properties.HttpPutResponseHopLimit) : void 0), ret.addPropertyResult("httpTokens", "HttpTokens", properties.HttpTokens != null ? cfn_parse.FromCloudFormation.getString(properties.HttpTokens) : void 0), ret.addPropertyResult("instanceMetadataTags", "InstanceMetadataTags", properties.InstanceMetadataTags != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceMetadataTags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_MonitoringPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "MonitoringProperty"');
    }
    function cfnLaunchTemplateMonitoringPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_MonitoringPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnLaunchTemplateMonitoringPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_NetworkBandwidthGbpsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "NetworkBandwidthGbpsProperty"');
    }
    function cfnLaunchTemplateNetworkBandwidthGbpsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_NetworkBandwidthGbpsPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnLaunchTemplateNetworkBandwidthGbpsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_NetworkInterfacePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("associateCarrierIpAddress", cdk.validateBoolean)(properties.associateCarrierIpAddress)), errors.collect(cdk.propertyValidator("associatePublicIpAddress", cdk.validateBoolean)(properties.associatePublicIpAddress)), errors.collect(cdk.propertyValidator("deleteOnTermination", cdk.validateBoolean)(properties.deleteOnTermination)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("deviceIndex", cdk.validateNumber)(properties.deviceIndex)), errors.collect(cdk.propertyValidator("groups", cdk.listValidator(cdk.validateString))(properties.groups)), errors.collect(cdk.propertyValidator("interfaceType", cdk.validateString)(properties.interfaceType)), errors.collect(cdk.propertyValidator("ipv4PrefixCount", cdk.validateNumber)(properties.ipv4PrefixCount)), errors.collect(cdk.propertyValidator("ipv4Prefixes", cdk.listValidator(CfnLaunchTemplate_Ipv4PrefixSpecificationPropertyValidator))(properties.ipv4Prefixes)), errors.collect(cdk.propertyValidator("ipv6AddressCount", cdk.validateNumber)(properties.ipv6AddressCount)), errors.collect(cdk.propertyValidator("ipv6Addresses", cdk.listValidator(CfnLaunchTemplate_Ipv6AddPropertyValidator))(properties.ipv6Addresses)), errors.collect(cdk.propertyValidator("ipv6PrefixCount", cdk.validateNumber)(properties.ipv6PrefixCount)), errors.collect(cdk.propertyValidator("ipv6Prefixes", cdk.listValidator(CfnLaunchTemplate_Ipv6PrefixSpecificationPropertyValidator))(properties.ipv6Prefixes)), errors.collect(cdk.propertyValidator("networkCardIndex", cdk.validateNumber)(properties.networkCardIndex)), errors.collect(cdk.propertyValidator("networkInterfaceId", cdk.validateString)(properties.networkInterfaceId)), errors.collect(cdk.propertyValidator("privateIpAddress", cdk.validateString)(properties.privateIpAddress)), errors.collect(cdk.propertyValidator("privateIpAddresses", cdk.listValidator(CfnLaunchTemplate_PrivateIpAddPropertyValidator))(properties.privateIpAddresses)), errors.collect(cdk.propertyValidator("secondaryPrivateIpAddressCount", cdk.validateNumber)(properties.secondaryPrivateIpAddressCount)), errors.collect(cdk.propertyValidator("subnetId", cdk.validateString)(properties.subnetId)), errors.wrap('supplied properties not correct for "NetworkInterfaceProperty"');
    }
    function cfnLaunchTemplateNetworkInterfacePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_NetworkInterfacePropertyValidator(properties).assertSuccess(), { AssociateCarrierIpAddress: cdk.booleanToCloudFormation(properties.associateCarrierIpAddress), AssociatePublicIpAddress: cdk.booleanToCloudFormation(properties.associatePublicIpAddress), DeleteOnTermination: cdk.booleanToCloudFormation(properties.deleteOnTermination), Description: cdk.stringToCloudFormation(properties.description), DeviceIndex: cdk.numberToCloudFormation(properties.deviceIndex), Groups: cdk.listMapper(cdk.stringToCloudFormation)(properties.groups), InterfaceType: cdk.stringToCloudFormation(properties.interfaceType), Ipv4PrefixCount: cdk.numberToCloudFormation(properties.ipv4PrefixCount), Ipv4Prefixes: cdk.listMapper(cfnLaunchTemplateIpv4PrefixSpecificationPropertyToCloudFormation)(properties.ipv4Prefixes), Ipv6AddressCount: cdk.numberToCloudFormation(properties.ipv6AddressCount), Ipv6Addresses: cdk.listMapper(cfnLaunchTemplateIpv6AddPropertyToCloudFormation)(properties.ipv6Addresses), Ipv6PrefixCount: cdk.numberToCloudFormation(properties.ipv6PrefixCount), Ipv6Prefixes: cdk.listMapper(cfnLaunchTemplateIpv6PrefixSpecificationPropertyToCloudFormation)(properties.ipv6Prefixes), NetworkCardIndex: cdk.numberToCloudFormation(properties.networkCardIndex), NetworkInterfaceId: cdk.stringToCloudFormation(properties.networkInterfaceId), PrivateIpAddress: cdk.stringToCloudFormation(properties.privateIpAddress), PrivateIpAddresses: cdk.listMapper(cfnLaunchTemplatePrivateIpAddPropertyToCloudFormation)(properties.privateIpAddresses), SecondaryPrivateIpAddressCount: cdk.numberToCloudFormation(properties.secondaryPrivateIpAddressCount), SubnetId: cdk.stringToCloudFormation(properties.subnetId) }) : properties;
    }
    function CfnLaunchTemplateNetworkInterfacePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("associateCarrierIpAddress", "AssociateCarrierIpAddress", properties.AssociateCarrierIpAddress != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AssociateCarrierIpAddress) : void 0), ret.addPropertyResult("associatePublicIpAddress", "AssociatePublicIpAddress", properties.AssociatePublicIpAddress != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AssociatePublicIpAddress) : void 0), ret.addPropertyResult("deleteOnTermination", "DeleteOnTermination", properties.DeleteOnTermination != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeleteOnTermination) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("deviceIndex", "DeviceIndex", properties.DeviceIndex != null ? cfn_parse.FromCloudFormation.getNumber(properties.DeviceIndex) : void 0), ret.addPropertyResult("groups", "Groups", properties.Groups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Groups) : void 0), ret.addPropertyResult("interfaceType", "InterfaceType", properties.InterfaceType != null ? cfn_parse.FromCloudFormation.getString(properties.InterfaceType) : void 0), ret.addPropertyResult("ipv4PrefixCount", "Ipv4PrefixCount", properties.Ipv4PrefixCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.Ipv4PrefixCount) : void 0), ret.addPropertyResult("ipv4Prefixes", "Ipv4Prefixes", properties.Ipv4Prefixes != null ? cfn_parse.FromCloudFormation.getArray(CfnLaunchTemplateIpv4PrefixSpecificationPropertyFromCloudFormation)(properties.Ipv4Prefixes) : void 0), ret.addPropertyResult("ipv6AddressCount", "Ipv6AddressCount", properties.Ipv6AddressCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.Ipv6AddressCount) : void 0), ret.addPropertyResult("ipv6Addresses", "Ipv6Addresses", properties.Ipv6Addresses != null ? cfn_parse.FromCloudFormation.getArray(CfnLaunchTemplateIpv6AddPropertyFromCloudFormation)(properties.Ipv6Addresses) : void 0), ret.addPropertyResult("ipv6PrefixCount", "Ipv6PrefixCount", properties.Ipv6PrefixCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.Ipv6PrefixCount) : void 0), ret.addPropertyResult("ipv6Prefixes", "Ipv6Prefixes", properties.Ipv6Prefixes != null ? cfn_parse.FromCloudFormation.getArray(CfnLaunchTemplateIpv6PrefixSpecificationPropertyFromCloudFormation)(properties.Ipv6Prefixes) : void 0), ret.addPropertyResult("networkCardIndex", "NetworkCardIndex", properties.NetworkCardIndex != null ? cfn_parse.FromCloudFormation.getNumber(properties.NetworkCardIndex) : void 0), ret.addPropertyResult("networkInterfaceId", "NetworkInterfaceId", properties.NetworkInterfaceId != null ? cfn_parse.FromCloudFormation.getString(properties.NetworkInterfaceId) : void 0), ret.addPropertyResult("privateIpAddress", "PrivateIpAddress", properties.PrivateIpAddress != null ? cfn_parse.FromCloudFormation.getString(properties.PrivateIpAddress) : void 0), ret.addPropertyResult("privateIpAddresses", "PrivateIpAddresses", properties.PrivateIpAddresses != null ? cfn_parse.FromCloudFormation.getArray(CfnLaunchTemplatePrivateIpAddPropertyFromCloudFormation)(properties.PrivateIpAddresses) : void 0), ret.addPropertyResult("secondaryPrivateIpAddressCount", "SecondaryPrivateIpAddressCount", properties.SecondaryPrivateIpAddressCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.SecondaryPrivateIpAddressCount) : void 0), ret.addPropertyResult("subnetId", "SubnetId", properties.SubnetId != null ? cfn_parse.FromCloudFormation.getString(properties.SubnetId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_NetworkInterfaceCountPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "NetworkInterfaceCountProperty"');
    }
    function cfnLaunchTemplateNetworkInterfaceCountPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_NetworkInterfaceCountPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnLaunchTemplateNetworkInterfaceCountPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_PlacementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("affinity", cdk.validateString)(properties.affinity)), errors.collect(cdk.propertyValidator("availabilityZone", cdk.validateString)(properties.availabilityZone)), errors.collect(cdk.propertyValidator("groupId", cdk.validateString)(properties.groupId)), errors.collect(cdk.propertyValidator("groupName", cdk.validateString)(properties.groupName)), errors.collect(cdk.propertyValidator("hostId", cdk.validateString)(properties.hostId)), errors.collect(cdk.propertyValidator("hostResourceGroupArn", cdk.validateString)(properties.hostResourceGroupArn)), errors.collect(cdk.propertyValidator("partitionNumber", cdk.validateNumber)(properties.partitionNumber)), errors.collect(cdk.propertyValidator("spreadDomain", cdk.validateString)(properties.spreadDomain)), errors.collect(cdk.propertyValidator("tenancy", cdk.validateString)(properties.tenancy)), errors.wrap('supplied properties not correct for "PlacementProperty"');
    }
    function cfnLaunchTemplatePlacementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_PlacementPropertyValidator(properties).assertSuccess(), { Affinity: cdk.stringToCloudFormation(properties.affinity), AvailabilityZone: cdk.stringToCloudFormation(properties.availabilityZone), GroupId: cdk.stringToCloudFormation(properties.groupId), GroupName: cdk.stringToCloudFormation(properties.groupName), HostId: cdk.stringToCloudFormation(properties.hostId), HostResourceGroupArn: cdk.stringToCloudFormation(properties.hostResourceGroupArn), PartitionNumber: cdk.numberToCloudFormation(properties.partitionNumber), SpreadDomain: cdk.stringToCloudFormation(properties.spreadDomain), Tenancy: cdk.stringToCloudFormation(properties.tenancy) }) : properties;
    }
    function CfnLaunchTemplatePlacementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("affinity", "Affinity", properties.Affinity != null ? cfn_parse.FromCloudFormation.getString(properties.Affinity) : void 0), ret.addPropertyResult("availabilityZone", "AvailabilityZone", properties.AvailabilityZone != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityZone) : void 0), ret.addPropertyResult("groupId", "GroupId", properties.GroupId != null ? cfn_parse.FromCloudFormation.getString(properties.GroupId) : void 0), ret.addPropertyResult("groupName", "GroupName", properties.GroupName != null ? cfn_parse.FromCloudFormation.getString(properties.GroupName) : void 0), ret.addPropertyResult("hostId", "HostId", properties.HostId != null ? cfn_parse.FromCloudFormation.getString(properties.HostId) : void 0), ret.addPropertyResult("hostResourceGroupArn", "HostResourceGroupArn", properties.HostResourceGroupArn != null ? cfn_parse.FromCloudFormation.getString(properties.HostResourceGroupArn) : void 0), ret.addPropertyResult("partitionNumber", "PartitionNumber", properties.PartitionNumber != null ? cfn_parse.FromCloudFormation.getNumber(properties.PartitionNumber) : void 0), ret.addPropertyResult("spreadDomain", "SpreadDomain", properties.SpreadDomain != null ? cfn_parse.FromCloudFormation.getString(properties.SpreadDomain) : void 0), ret.addPropertyResult("tenancy", "Tenancy", properties.Tenancy != null ? cfn_parse.FromCloudFormation.getString(properties.Tenancy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_PrivateDnsNameOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enableResourceNameDnsAaaaRecord", cdk.validateBoolean)(properties.enableResourceNameDnsAaaaRecord)), errors.collect(cdk.propertyValidator("enableResourceNameDnsARecord", cdk.validateBoolean)(properties.enableResourceNameDnsARecord)), errors.collect(cdk.propertyValidator("hostnameType", cdk.validateString)(properties.hostnameType)), errors.wrap('supplied properties not correct for "PrivateDnsNameOptionsProperty"');
    }
    function cfnLaunchTemplatePrivateDnsNameOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_PrivateDnsNameOptionsPropertyValidator(properties).assertSuccess(), { EnableResourceNameDnsAAAARecord: cdk.booleanToCloudFormation(properties.enableResourceNameDnsAaaaRecord), EnableResourceNameDnsARecord: cdk.booleanToCloudFormation(properties.enableResourceNameDnsARecord), HostnameType: cdk.stringToCloudFormation(properties.hostnameType) }) : properties;
    }
    function CfnLaunchTemplatePrivateDnsNameOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enableResourceNameDnsAaaaRecord", "EnableResourceNameDnsAAAARecord", properties.EnableResourceNameDnsAAAARecord != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableResourceNameDnsAAAARecord) : void 0), ret.addPropertyResult("enableResourceNameDnsARecord", "EnableResourceNameDnsARecord", properties.EnableResourceNameDnsARecord != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableResourceNameDnsARecord) : void 0), ret.addPropertyResult("hostnameType", "HostnameType", properties.HostnameType != null ? cfn_parse.FromCloudFormation.getString(properties.HostnameType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_PrivateIpAddPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("primary", cdk.validateBoolean)(properties.primary)), errors.collect(cdk.propertyValidator("privateIpAddress", cdk.validateString)(properties.privateIpAddress)), errors.wrap('supplied properties not correct for "PrivateIpAddProperty"');
    }
    function cfnLaunchTemplatePrivateIpAddPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_PrivateIpAddPropertyValidator(properties).assertSuccess(), { Primary: cdk.booleanToCloudFormation(properties.primary), PrivateIpAddress: cdk.stringToCloudFormation(properties.privateIpAddress) }) : properties;
    }
    function CfnLaunchTemplatePrivateIpAddPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("primary", "Primary", properties.Primary != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Primary) : void 0), ret.addPropertyResult("privateIpAddress", "PrivateIpAddress", properties.PrivateIpAddress != null ? cfn_parse.FromCloudFormation.getString(properties.PrivateIpAddress) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_SpotOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("blockDurationMinutes", cdk.validateNumber)(properties.blockDurationMinutes)), errors.collect(cdk.propertyValidator("instanceInterruptionBehavior", cdk.validateString)(properties.instanceInterruptionBehavior)), errors.collect(cdk.propertyValidator("maxPrice", cdk.validateString)(properties.maxPrice)), errors.collect(cdk.propertyValidator("spotInstanceType", cdk.validateString)(properties.spotInstanceType)), errors.collect(cdk.propertyValidator("validUntil", cdk.validateString)(properties.validUntil)), errors.wrap('supplied properties not correct for "SpotOptionsProperty"');
    }
    function cfnLaunchTemplateSpotOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_SpotOptionsPropertyValidator(properties).assertSuccess(), { BlockDurationMinutes: cdk.numberToCloudFormation(properties.blockDurationMinutes), InstanceInterruptionBehavior: cdk.stringToCloudFormation(properties.instanceInterruptionBehavior), MaxPrice: cdk.stringToCloudFormation(properties.maxPrice), SpotInstanceType: cdk.stringToCloudFormation(properties.spotInstanceType), ValidUntil: cdk.stringToCloudFormation(properties.validUntil) }) : properties;
    }
    function CfnLaunchTemplateSpotOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("blockDurationMinutes", "BlockDurationMinutes", properties.BlockDurationMinutes != null ? cfn_parse.FromCloudFormation.getNumber(properties.BlockDurationMinutes) : void 0), ret.addPropertyResult("instanceInterruptionBehavior", "InstanceInterruptionBehavior", properties.InstanceInterruptionBehavior != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceInterruptionBehavior) : void 0), ret.addPropertyResult("maxPrice", "MaxPrice", properties.MaxPrice != null ? cfn_parse.FromCloudFormation.getString(properties.MaxPrice) : void 0), ret.addPropertyResult("spotInstanceType", "SpotInstanceType", properties.SpotInstanceType != null ? cfn_parse.FromCloudFormation.getString(properties.SpotInstanceType) : void 0), ret.addPropertyResult("validUntil", "ValidUntil", properties.ValidUntil != null ? cfn_parse.FromCloudFormation.getString(properties.ValidUntil) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_TagSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceType", cdk.validateString)(properties.resourceType)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "TagSpecificationProperty"');
    }
    function cfnLaunchTemplateTagSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_TagSpecificationPropertyValidator(properties).assertSuccess(), { ResourceType: cdk.stringToCloudFormation(properties.resourceType), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnLaunchTemplateTagSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceType", "ResourceType", properties.ResourceType != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceType) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_TotalLocalStorageGBPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "TotalLocalStorageGBProperty"');
    }
    function cfnLaunchTemplateTotalLocalStorageGBPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_TotalLocalStorageGBPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnLaunchTemplateTotalLocalStorageGBPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchTemplate_VCpuCountPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "VCpuCountProperty"');
    }
    function cfnLaunchTemplateVCpuCountPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplate_VCpuCountPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnLaunchTemplateVCpuCountPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLocalGatewayRoutePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationCidrBlock", cdk.requiredValidator)(properties.destinationCidrBlock)), errors.collect(cdk.propertyValidator("destinationCidrBlock", cdk.validateString)(properties.destinationCidrBlock)), errors.collect(cdk.propertyValidator("localGatewayRouteTableId", cdk.requiredValidator)(properties.localGatewayRouteTableId)), errors.collect(cdk.propertyValidator("localGatewayRouteTableId", cdk.validateString)(properties.localGatewayRouteTableId)), errors.collect(cdk.propertyValidator("localGatewayVirtualInterfaceGroupId", cdk.validateString)(properties.localGatewayVirtualInterfaceGroupId)), errors.collect(cdk.propertyValidator("networkInterfaceId", cdk.validateString)(properties.networkInterfaceId)), errors.wrap('supplied properties not correct for "CfnLocalGatewayRouteProps"');
    }
    function cfnLocalGatewayRoutePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLocalGatewayRoutePropsValidator(properties).assertSuccess(), { DestinationCidrBlock: cdk.stringToCloudFormation(properties.destinationCidrBlock), LocalGatewayRouteTableId: cdk.stringToCloudFormation(properties.localGatewayRouteTableId), LocalGatewayVirtualInterfaceGroupId: cdk.stringToCloudFormation(properties.localGatewayVirtualInterfaceGroupId), NetworkInterfaceId: cdk.stringToCloudFormation(properties.networkInterfaceId) }) : properties;
    }
    function CfnLocalGatewayRoutePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationCidrBlock", "DestinationCidrBlock", cfn_parse.FromCloudFormation.getString(properties.DestinationCidrBlock)), ret.addPropertyResult("localGatewayRouteTableId", "LocalGatewayRouteTableId", cfn_parse.FromCloudFormation.getString(properties.LocalGatewayRouteTableId)), ret.addPropertyResult("localGatewayVirtualInterfaceGroupId", "LocalGatewayVirtualInterfaceGroupId", properties.LocalGatewayVirtualInterfaceGroupId != null ? cfn_parse.FromCloudFormation.getString(properties.LocalGatewayVirtualInterfaceGroupId) : void 0), ret.addPropertyResult("networkInterfaceId", "NetworkInterfaceId", properties.NetworkInterfaceId != null ? cfn_parse.FromCloudFormation.getString(properties.NetworkInterfaceId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLocalGatewayRoute = class _CfnLocalGatewayRoute extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLocalGatewayRoutePropsFromCloudFormation(resourceProperties), ret = new _CfnLocalGatewayRoute(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLocalGatewayRoute.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnLocalGatewayRouteProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLocalGatewayRoute), error;
        }
        cdk.requireProperty(props, "destinationCidrBlock", this), cdk.requireProperty(props, "localGatewayRouteTableId", this), this.attrState = cdk.Token.asString(this.getAtt("State", cdk.ResolutionTypeHint.STRING)), this.attrType = cdk.Token.asString(this.getAtt("Type", cdk.ResolutionTypeHint.STRING)), this.destinationCidrBlock = props.destinationCidrBlock, this.localGatewayRouteTableId = props.localGatewayRouteTableId, this.localGatewayVirtualInterfaceGroupId = props.localGatewayVirtualInterfaceGroupId, this.networkInterfaceId = props.networkInterfaceId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLocalGatewayRoute.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { destinationCidrBlock: this.destinationCidrBlock, localGatewayRouteTableId: this.localGatewayRouteTableId, localGatewayVirtualInterfaceGroupId: this.localGatewayVirtualInterfaceGroupId, networkInterfaceId: this.networkInterfaceId };
      }
      renderProperties(props) {
        return cfnLocalGatewayRoutePropsToCloudFormation(props);
      }
    };
    _4 = JSII_RTTI_SYMBOL_1, CfnLocalGatewayRoute[_4] = { fqn: "aws-cdk-lib.aws_ec2.CfnLocalGatewayRoute", version: "2.80.0" }, CfnLocalGatewayRoute.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::LocalGatewayRoute", exports2.CfnLocalGatewayRoute = CfnLocalGatewayRoute;
    function CfnLocalGatewayRouteTablePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("localGatewayId", cdk.requiredValidator)(properties.localGatewayId)), errors.collect(cdk.propertyValidator("localGatewayId", cdk.validateString)(properties.localGatewayId)), errors.collect(cdk.propertyValidator("mode", cdk.validateString)(properties.mode)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnLocalGatewayRouteTableProps"');
    }
    function cfnLocalGatewayRouteTablePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLocalGatewayRouteTablePropsValidator(properties).assertSuccess(), { LocalGatewayId: cdk.stringToCloudFormation(properties.localGatewayId), Mode: cdk.stringToCloudFormation(properties.mode), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnLocalGatewayRouteTablePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("localGatewayId", "LocalGatewayId", cfn_parse.FromCloudFormation.getString(properties.LocalGatewayId)), ret.addPropertyResult("mode", "Mode", properties.Mode != null ? cfn_parse.FromCloudFormation.getString(properties.Mode) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLocalGatewayRouteTable = class _CfnLocalGatewayRouteTable extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLocalGatewayRouteTablePropsFromCloudFormation(resourceProperties), ret = new _CfnLocalGatewayRouteTable(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLocalGatewayRouteTable.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnLocalGatewayRouteTableProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLocalGatewayRouteTable), error;
        }
        cdk.requireProperty(props, "localGatewayId", this), this.attrLocalGatewayRouteTableArn = cdk.Token.asString(this.getAtt("LocalGatewayRouteTableArn", cdk.ResolutionTypeHint.STRING)), this.attrLocalGatewayRouteTableId = cdk.Token.asString(this.getAtt("LocalGatewayRouteTableId", cdk.ResolutionTypeHint.STRING)), this.attrOutpostArn = cdk.Token.asString(this.getAtt("OutpostArn", cdk.ResolutionTypeHint.STRING)), this.attrOwnerId = cdk.Token.asString(this.getAtt("OwnerId", cdk.ResolutionTypeHint.STRING)), this.attrState = cdk.Token.asString(this.getAtt("State", cdk.ResolutionTypeHint.STRING)), this.localGatewayId = props.localGatewayId, this.mode = props.mode, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::LocalGatewayRouteTable", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLocalGatewayRouteTable.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { localGatewayId: this.localGatewayId, mode: this.mode, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnLocalGatewayRouteTablePropsToCloudFormation(props);
      }
    };
    _5 = JSII_RTTI_SYMBOL_1, CfnLocalGatewayRouteTable[_5] = { fqn: "aws-cdk-lib.aws_ec2.CfnLocalGatewayRouteTable", version: "2.80.0" }, CfnLocalGatewayRouteTable.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::LocalGatewayRouteTable", exports2.CfnLocalGatewayRouteTable = CfnLocalGatewayRouteTable;
    function CfnLocalGatewayRouteTableVPCAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("localGatewayRouteTableId", cdk.requiredValidator)(properties.localGatewayRouteTableId)), errors.collect(cdk.propertyValidator("localGatewayRouteTableId", cdk.validateString)(properties.localGatewayRouteTableId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpcId", cdk.requiredValidator)(properties.vpcId)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "CfnLocalGatewayRouteTableVPCAssociationProps"');
    }
    function cfnLocalGatewayRouteTableVPCAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLocalGatewayRouteTableVPCAssociationPropsValidator(properties).assertSuccess(), { LocalGatewayRouteTableId: cdk.stringToCloudFormation(properties.localGatewayRouteTableId), VpcId: cdk.stringToCloudFormation(properties.vpcId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnLocalGatewayRouteTableVPCAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("localGatewayRouteTableId", "LocalGatewayRouteTableId", cfn_parse.FromCloudFormation.getString(properties.LocalGatewayRouteTableId)), ret.addPropertyResult("vpcId", "VpcId", cfn_parse.FromCloudFormation.getString(properties.VpcId)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLocalGatewayRouteTableVPCAssociation = class _CfnLocalGatewayRouteTableVPCAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLocalGatewayRouteTableVPCAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnLocalGatewayRouteTableVPCAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLocalGatewayRouteTableVPCAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnLocalGatewayRouteTableVPCAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLocalGatewayRouteTableVPCAssociation), error;
        }
        cdk.requireProperty(props, "localGatewayRouteTableId", this), cdk.requireProperty(props, "vpcId", this), this.attrLocalGatewayId = cdk.Token.asString(this.getAtt("LocalGatewayId", cdk.ResolutionTypeHint.STRING)), this.attrLocalGatewayRouteTableVpcAssociationId = cdk.Token.asString(this.getAtt("LocalGatewayRouteTableVpcAssociationId", cdk.ResolutionTypeHint.STRING)), this.attrState = cdk.Token.asString(this.getAtt("State", cdk.ResolutionTypeHint.STRING)), this.localGatewayRouteTableId = props.localGatewayRouteTableId, this.vpcId = props.vpcId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::LocalGatewayRouteTableVPCAssociation", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLocalGatewayRouteTableVPCAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { localGatewayRouteTableId: this.localGatewayRouteTableId, vpcId: this.vpcId, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnLocalGatewayRouteTableVPCAssociationPropsToCloudFormation(props);
      }
    };
    _6 = JSII_RTTI_SYMBOL_1, CfnLocalGatewayRouteTableVPCAssociation[_6] = { fqn: "aws-cdk-lib.aws_ec2.CfnLocalGatewayRouteTableVPCAssociation", version: "2.80.0" }, CfnLocalGatewayRouteTableVPCAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::LocalGatewayRouteTableVPCAssociation", exports2.CfnLocalGatewayRouteTableVPCAssociation = CfnLocalGatewayRouteTableVPCAssociation;
    function CfnLocalGatewayRouteTableVirtualInterfaceGroupAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("localGatewayRouteTableId", cdk.requiredValidator)(properties.localGatewayRouteTableId)), errors.collect(cdk.propertyValidator("localGatewayRouteTableId", cdk.validateString)(properties.localGatewayRouteTableId)), errors.collect(cdk.propertyValidator("localGatewayVirtualInterfaceGroupId", cdk.requiredValidator)(properties.localGatewayVirtualInterfaceGroupId)), errors.collect(cdk.propertyValidator("localGatewayVirtualInterfaceGroupId", cdk.validateString)(properties.localGatewayVirtualInterfaceGroupId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnLocalGatewayRouteTableVirtualInterfaceGroupAssociationProps"');
    }
    function cfnLocalGatewayRouteTableVirtualInterfaceGroupAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLocalGatewayRouteTableVirtualInterfaceGroupAssociationPropsValidator(properties).assertSuccess(), { LocalGatewayRouteTableId: cdk.stringToCloudFormation(properties.localGatewayRouteTableId), LocalGatewayVirtualInterfaceGroupId: cdk.stringToCloudFormation(properties.localGatewayVirtualInterfaceGroupId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnLocalGatewayRouteTableVirtualInterfaceGroupAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("localGatewayRouteTableId", "LocalGatewayRouteTableId", cfn_parse.FromCloudFormation.getString(properties.LocalGatewayRouteTableId)), ret.addPropertyResult("localGatewayVirtualInterfaceGroupId", "LocalGatewayVirtualInterfaceGroupId", cfn_parse.FromCloudFormation.getString(properties.LocalGatewayVirtualInterfaceGroupId)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLocalGatewayRouteTableVirtualInterfaceGroupAssociation = class _CfnLocalGatewayRouteTableVirtualInterfaceGroupAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLocalGatewayRouteTableVirtualInterfaceGroupAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnLocalGatewayRouteTableVirtualInterfaceGroupAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLocalGatewayRouteTableVirtualInterfaceGroupAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnLocalGatewayRouteTableVirtualInterfaceGroupAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLocalGatewayRouteTableVirtualInterfaceGroupAssociation), error;
        }
        cdk.requireProperty(props, "localGatewayRouteTableId", this), cdk.requireProperty(props, "localGatewayVirtualInterfaceGroupId", this), this.attrLocalGatewayId = cdk.Token.asString(this.getAtt("LocalGatewayId", cdk.ResolutionTypeHint.STRING)), this.attrLocalGatewayRouteTableArn = cdk.Token.asString(this.getAtt("LocalGatewayRouteTableArn", cdk.ResolutionTypeHint.STRING)), this.attrLocalGatewayRouteTableVirtualInterfaceGroupAssociationId = cdk.Token.asString(this.getAtt("LocalGatewayRouteTableVirtualInterfaceGroupAssociationId", cdk.ResolutionTypeHint.STRING)), this.attrOwnerId = cdk.Token.asString(this.getAtt("OwnerId", cdk.ResolutionTypeHint.STRING)), this.attrState = cdk.Token.asString(this.getAtt("State", cdk.ResolutionTypeHint.STRING)), this.localGatewayRouteTableId = props.localGatewayRouteTableId, this.localGatewayVirtualInterfaceGroupId = props.localGatewayVirtualInterfaceGroupId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::LocalGatewayRouteTableVirtualInterfaceGroupAssociation", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLocalGatewayRouteTableVirtualInterfaceGroupAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { localGatewayRouteTableId: this.localGatewayRouteTableId, localGatewayVirtualInterfaceGroupId: this.localGatewayVirtualInterfaceGroupId, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnLocalGatewayRouteTableVirtualInterfaceGroupAssociationPropsToCloudFormation(props);
      }
    };
    _7 = JSII_RTTI_SYMBOL_1, CfnLocalGatewayRouteTableVirtualInterfaceGroupAssociation[_7] = { fqn: "aws-cdk-lib.aws_ec2.CfnLocalGatewayRouteTableVirtualInterfaceGroupAssociation", version: "2.80.0" }, CfnLocalGatewayRouteTableVirtualInterfaceGroupAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::LocalGatewayRouteTableVirtualInterfaceGroupAssociation", exports2.CfnLocalGatewayRouteTableVirtualInterfaceGroupAssociation = CfnLocalGatewayRouteTableVirtualInterfaceGroupAssociation;
    function CfnNatGatewayPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allocationId", cdk.validateString)(properties.allocationId)), errors.collect(cdk.propertyValidator("connectivityType", cdk.validateString)(properties.connectivityType)), errors.collect(cdk.propertyValidator("maxDrainDurationSeconds", cdk.validateNumber)(properties.maxDrainDurationSeconds)), errors.collect(cdk.propertyValidator("privateIpAddress", cdk.validateString)(properties.privateIpAddress)), errors.collect(cdk.propertyValidator("secondaryAllocationIds", cdk.listValidator(cdk.validateString))(properties.secondaryAllocationIds)), errors.collect(cdk.propertyValidator("secondaryPrivateIpAddressCount", cdk.validateNumber)(properties.secondaryPrivateIpAddressCount)), errors.collect(cdk.propertyValidator("secondaryPrivateIpAddresses", cdk.listValidator(cdk.validateString))(properties.secondaryPrivateIpAddresses)), errors.collect(cdk.propertyValidator("subnetId", cdk.requiredValidator)(properties.subnetId)), errors.collect(cdk.propertyValidator("subnetId", cdk.validateString)(properties.subnetId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnNatGatewayProps"');
    }
    function cfnNatGatewayPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNatGatewayPropsValidator(properties).assertSuccess(), { SubnetId: cdk.stringToCloudFormation(properties.subnetId), AllocationId: cdk.stringToCloudFormation(properties.allocationId), ConnectivityType: cdk.stringToCloudFormation(properties.connectivityType), MaxDrainDurationSeconds: cdk.numberToCloudFormation(properties.maxDrainDurationSeconds), PrivateIpAddress: cdk.stringToCloudFormation(properties.privateIpAddress), SecondaryAllocationIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.secondaryAllocationIds), SecondaryPrivateIpAddressCount: cdk.numberToCloudFormation(properties.secondaryPrivateIpAddressCount), SecondaryPrivateIpAddresses: cdk.listMapper(cdk.stringToCloudFormation)(properties.secondaryPrivateIpAddresses), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnNatGatewayPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("subnetId", "SubnetId", cfn_parse.FromCloudFormation.getString(properties.SubnetId)), ret.addPropertyResult("allocationId", "AllocationId", properties.AllocationId != null ? cfn_parse.FromCloudFormation.getString(properties.AllocationId) : void 0), ret.addPropertyResult("connectivityType", "ConnectivityType", properties.ConnectivityType != null ? cfn_parse.FromCloudFormation.getString(properties.ConnectivityType) : void 0), ret.addPropertyResult("maxDrainDurationSeconds", "MaxDrainDurationSeconds", properties.MaxDrainDurationSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxDrainDurationSeconds) : void 0), ret.addPropertyResult("privateIpAddress", "PrivateIpAddress", properties.PrivateIpAddress != null ? cfn_parse.FromCloudFormation.getString(properties.PrivateIpAddress) : void 0), ret.addPropertyResult("secondaryAllocationIds", "SecondaryAllocationIds", properties.SecondaryAllocationIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecondaryAllocationIds) : void 0), ret.addPropertyResult("secondaryPrivateIpAddressCount", "SecondaryPrivateIpAddressCount", properties.SecondaryPrivateIpAddressCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.SecondaryPrivateIpAddressCount) : void 0), ret.addPropertyResult("secondaryPrivateIpAddresses", "SecondaryPrivateIpAddresses", properties.SecondaryPrivateIpAddresses != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecondaryPrivateIpAddresses) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnNatGateway = class _CfnNatGateway extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnNatGatewayPropsFromCloudFormation(resourceProperties), ret = new _CfnNatGateway(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnNatGateway.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnNatGatewayProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnNatGateway), error;
        }
        cdk.requireProperty(props, "subnetId", this), this.attrNatGatewayId = cdk.Token.asString(this.getAtt("NatGatewayId", cdk.ResolutionTypeHint.STRING)), this.subnetId = props.subnetId, this.allocationId = props.allocationId, this.connectivityType = props.connectivityType, this.maxDrainDurationSeconds = props.maxDrainDurationSeconds, this.privateIpAddress = props.privateIpAddress, this.secondaryAllocationIds = props.secondaryAllocationIds, this.secondaryPrivateIpAddressCount = props.secondaryPrivateIpAddressCount, this.secondaryPrivateIpAddresses = props.secondaryPrivateIpAddresses, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::NatGateway", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnNatGateway.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { subnetId: this.subnetId, allocationId: this.allocationId, connectivityType: this.connectivityType, maxDrainDurationSeconds: this.maxDrainDurationSeconds, privateIpAddress: this.privateIpAddress, secondaryAllocationIds: this.secondaryAllocationIds, secondaryPrivateIpAddressCount: this.secondaryPrivateIpAddressCount, secondaryPrivateIpAddresses: this.secondaryPrivateIpAddresses, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnNatGatewayPropsToCloudFormation(props);
      }
    };
    _8 = JSII_RTTI_SYMBOL_1, CfnNatGateway[_8] = { fqn: "aws-cdk-lib.aws_ec2.CfnNatGateway", version: "2.80.0" }, CfnNatGateway.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::NatGateway", exports2.CfnNatGateway = CfnNatGateway;
    function CfnNetworkAclPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpcId", cdk.requiredValidator)(properties.vpcId)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "CfnNetworkAclProps"');
    }
    function cfnNetworkAclPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNetworkAclPropsValidator(properties).assertSuccess(), { VpcId: cdk.stringToCloudFormation(properties.vpcId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnNetworkAclPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("vpcId", "VpcId", cfn_parse.FromCloudFormation.getString(properties.VpcId)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnNetworkAcl = class _CfnNetworkAcl extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnNetworkAclPropsFromCloudFormation(resourceProperties), ret = new _CfnNetworkAcl(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnNetworkAcl.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnNetworkAclProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnNetworkAcl), error;
        }
        cdk.requireProperty(props, "vpcId", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.vpcId = props.vpcId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::NetworkAcl", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnNetworkAcl.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { vpcId: this.vpcId, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnNetworkAclPropsToCloudFormation(props);
      }
    };
    _9 = JSII_RTTI_SYMBOL_1, CfnNetworkAcl[_9] = { fqn: "aws-cdk-lib.aws_ec2.CfnNetworkAcl", version: "2.80.0" }, CfnNetworkAcl.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::NetworkAcl", exports2.CfnNetworkAcl = CfnNetworkAcl;
    function CfnNetworkAclEntryPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cidrBlock", cdk.validateString)(properties.cidrBlock)), errors.collect(cdk.propertyValidator("egress", cdk.validateBoolean)(properties.egress)), errors.collect(cdk.propertyValidator("icmp", CfnNetworkAclEntry_IcmpPropertyValidator)(properties.icmp)), errors.collect(cdk.propertyValidator("ipv6CidrBlock", cdk.validateString)(properties.ipv6CidrBlock)), errors.collect(cdk.propertyValidator("networkAclId", cdk.requiredValidator)(properties.networkAclId)), errors.collect(cdk.propertyValidator("networkAclId", cdk.validateString)(properties.networkAclId)), errors.collect(cdk.propertyValidator("portRange", CfnNetworkAclEntry_PortRangePropertyValidator)(properties.portRange)), errors.collect(cdk.propertyValidator("protocol", cdk.requiredValidator)(properties.protocol)), errors.collect(cdk.propertyValidator("protocol", cdk.validateNumber)(properties.protocol)), errors.collect(cdk.propertyValidator("ruleAction", cdk.requiredValidator)(properties.ruleAction)), errors.collect(cdk.propertyValidator("ruleAction", cdk.validateString)(properties.ruleAction)), errors.collect(cdk.propertyValidator("ruleNumber", cdk.requiredValidator)(properties.ruleNumber)), errors.collect(cdk.propertyValidator("ruleNumber", cdk.validateNumber)(properties.ruleNumber)), errors.wrap('supplied properties not correct for "CfnNetworkAclEntryProps"');
    }
    function cfnNetworkAclEntryPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNetworkAclEntryPropsValidator(properties).assertSuccess(), { NetworkAclId: cdk.stringToCloudFormation(properties.networkAclId), Protocol: cdk.numberToCloudFormation(properties.protocol), RuleAction: cdk.stringToCloudFormation(properties.ruleAction), RuleNumber: cdk.numberToCloudFormation(properties.ruleNumber), CidrBlock: cdk.stringToCloudFormation(properties.cidrBlock), Egress: cdk.booleanToCloudFormation(properties.egress), Icmp: cfnNetworkAclEntryIcmpPropertyToCloudFormation(properties.icmp), Ipv6CidrBlock: cdk.stringToCloudFormation(properties.ipv6CidrBlock), PortRange: cfnNetworkAclEntryPortRangePropertyToCloudFormation(properties.portRange) }) : properties;
    }
    function CfnNetworkAclEntryPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("networkAclId", "NetworkAclId", cfn_parse.FromCloudFormation.getString(properties.NetworkAclId)), ret.addPropertyResult("protocol", "Protocol", cfn_parse.FromCloudFormation.getNumber(properties.Protocol)), ret.addPropertyResult("ruleAction", "RuleAction", cfn_parse.FromCloudFormation.getString(properties.RuleAction)), ret.addPropertyResult("ruleNumber", "RuleNumber", cfn_parse.FromCloudFormation.getNumber(properties.RuleNumber)), ret.addPropertyResult("cidrBlock", "CidrBlock", properties.CidrBlock != null ? cfn_parse.FromCloudFormation.getString(properties.CidrBlock) : void 0), ret.addPropertyResult("egress", "Egress", properties.Egress != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Egress) : void 0), ret.addPropertyResult("icmp", "Icmp", properties.Icmp != null ? CfnNetworkAclEntryIcmpPropertyFromCloudFormation(properties.Icmp) : void 0), ret.addPropertyResult("ipv6CidrBlock", "Ipv6CidrBlock", properties.Ipv6CidrBlock != null ? cfn_parse.FromCloudFormation.getString(properties.Ipv6CidrBlock) : void 0), ret.addPropertyResult("portRange", "PortRange", properties.PortRange != null ? CfnNetworkAclEntryPortRangePropertyFromCloudFormation(properties.PortRange) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnNetworkAclEntry = class _CfnNetworkAclEntry extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnNetworkAclEntryPropsFromCloudFormation(resourceProperties), ret = new _CfnNetworkAclEntry(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnNetworkAclEntry.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnNetworkAclEntryProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnNetworkAclEntry), error;
        }
        cdk.requireProperty(props, "networkAclId", this), cdk.requireProperty(props, "protocol", this), cdk.requireProperty(props, "ruleAction", this), cdk.requireProperty(props, "ruleNumber", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.networkAclId = props.networkAclId, this.protocol = props.protocol, this.ruleAction = props.ruleAction, this.ruleNumber = props.ruleNumber, this.cidrBlock = props.cidrBlock, this.egress = props.egress, this.icmp = props.icmp, this.ipv6CidrBlock = props.ipv6CidrBlock, this.portRange = props.portRange;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnNetworkAclEntry.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { networkAclId: this.networkAclId, protocol: this.protocol, ruleAction: this.ruleAction, ruleNumber: this.ruleNumber, cidrBlock: this.cidrBlock, egress: this.egress, icmp: this.icmp, ipv6CidrBlock: this.ipv6CidrBlock, portRange: this.portRange };
      }
      renderProperties(props) {
        return cfnNetworkAclEntryPropsToCloudFormation(props);
      }
    };
    _10 = JSII_RTTI_SYMBOL_1, CfnNetworkAclEntry[_10] = { fqn: "aws-cdk-lib.aws_ec2.CfnNetworkAclEntry", version: "2.80.0" }, CfnNetworkAclEntry.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::NetworkAclEntry", exports2.CfnNetworkAclEntry = CfnNetworkAclEntry;
    function CfnNetworkAclEntry_IcmpPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("code", cdk.validateNumber)(properties.code)), errors.collect(cdk.propertyValidator("type", cdk.validateNumber)(properties.type)), errors.wrap('supplied properties not correct for "IcmpProperty"');
    }
    function cfnNetworkAclEntryIcmpPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNetworkAclEntry_IcmpPropertyValidator(properties).assertSuccess(), { Code: cdk.numberToCloudFormation(properties.code), Type: cdk.numberToCloudFormation(properties.type) }) : properties;
    }
    function CfnNetworkAclEntryIcmpPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("code", "Code", properties.Code != null ? cfn_parse.FromCloudFormation.getNumber(properties.Code) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getNumber(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnNetworkAclEntry_PortRangePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("from", cdk.validateNumber)(properties.from)), errors.collect(cdk.propertyValidator("to", cdk.validateNumber)(properties.to)), errors.wrap('supplied properties not correct for "PortRangeProperty"');
    }
    function cfnNetworkAclEntryPortRangePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNetworkAclEntry_PortRangePropertyValidator(properties).assertSuccess(), { From: cdk.numberToCloudFormation(properties.from), To: cdk.numberToCloudFormation(properties.to) }) : properties;
    }
    function CfnNetworkAclEntryPortRangePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("from", "From", properties.From != null ? cfn_parse.FromCloudFormation.getNumber(properties.From) : void 0), ret.addPropertyResult("to", "To", properties.To != null ? cfn_parse.FromCloudFormation.getNumber(properties.To) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnNetworkInsightsAccessScopePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("excludePaths", cdk.listValidator(CfnNetworkInsightsAccessScope_AccessScopePathRequestPropertyValidator))(properties.excludePaths)), errors.collect(cdk.propertyValidator("matchPaths", cdk.listValidator(CfnNetworkInsightsAccessScope_AccessScopePathRequestPropertyValidator))(properties.matchPaths)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnNetworkInsightsAccessScopeProps"');
    }
    function cfnNetworkInsightsAccessScopePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNetworkInsightsAccessScopePropsValidator(properties).assertSuccess(), { ExcludePaths: cdk.listMapper(cfnNetworkInsightsAccessScopeAccessScopePathRequestPropertyToCloudFormation)(properties.excludePaths), MatchPaths: cdk.listMapper(cfnNetworkInsightsAccessScopeAccessScopePathRequestPropertyToCloudFormation)(properties.matchPaths), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnNetworkInsightsAccessScopePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("excludePaths", "ExcludePaths", properties.ExcludePaths != null ? cfn_parse.FromCloudFormation.getArray(CfnNetworkInsightsAccessScopeAccessScopePathRequestPropertyFromCloudFormation)(properties.ExcludePaths) : void 0), ret.addPropertyResult("matchPaths", "MatchPaths", properties.MatchPaths != null ? cfn_parse.FromCloudFormation.getArray(CfnNetworkInsightsAccessScopeAccessScopePathRequestPropertyFromCloudFormation)(properties.MatchPaths) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnNetworkInsightsAccessScope = class _CfnNetworkInsightsAccessScope extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnNetworkInsightsAccessScopePropsFromCloudFormation(resourceProperties), ret = new _CfnNetworkInsightsAccessScope(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnNetworkInsightsAccessScope.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnNetworkInsightsAccessScopeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnNetworkInsightsAccessScope), error;
        }
        this.attrCreatedDate = cdk.Token.asString(this.getAtt("CreatedDate", cdk.ResolutionTypeHint.STRING)), this.attrNetworkInsightsAccessScopeArn = cdk.Token.asString(this.getAtt("NetworkInsightsAccessScopeArn", cdk.ResolutionTypeHint.STRING)), this.attrNetworkInsightsAccessScopeId = cdk.Token.asString(this.getAtt("NetworkInsightsAccessScopeId", cdk.ResolutionTypeHint.STRING)), this.attrUpdatedDate = cdk.Token.asString(this.getAtt("UpdatedDate", cdk.ResolutionTypeHint.STRING)), this.excludePaths = props.excludePaths, this.matchPaths = props.matchPaths, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::NetworkInsightsAccessScope", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnNetworkInsightsAccessScope.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { excludePaths: this.excludePaths, matchPaths: this.matchPaths, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnNetworkInsightsAccessScopePropsToCloudFormation(props);
      }
    };
    _11 = JSII_RTTI_SYMBOL_1, CfnNetworkInsightsAccessScope[_11] = { fqn: "aws-cdk-lib.aws_ec2.CfnNetworkInsightsAccessScope", version: "2.80.0" }, CfnNetworkInsightsAccessScope.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::NetworkInsightsAccessScope", exports2.CfnNetworkInsightsAccessScope = CfnNetworkInsightsAccessScope;
    function CfnNetworkInsightsAccessScope_AccessScopePathRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destination", CfnNetworkInsightsAccessScope_PathStatementRequestPropertyValidator)(properties.destination)), errors.collect(cdk.propertyValidator("source", CfnNetworkInsightsAccessScope_PathStatementRequestPropertyValidator)(properties.source)), errors.collect(cdk.propertyValidator("throughResources", cdk.listValidator(CfnNetworkInsightsAccessScope_ThroughResourcesStatementRequestPropertyValidator))(properties.throughResources)), errors.wrap('supplied properties not correct for "AccessScopePathRequestProperty"');
    }
    function cfnNetworkInsightsAccessScopeAccessScopePathRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNetworkInsightsAccessScope_AccessScopePathRequestPropertyValidator(properties).assertSuccess(), { Destination: cfnNetworkInsightsAccessScopePathStatementRequestPropertyToCloudFormation(properties.destination), Source: cfnNetworkInsightsAccessScopePathStatementRequestPropertyToCloudFormation(properties.source), ThroughResources: cdk.listMapper(cfnNetworkInsightsAccessScopeThroughResourcesStatementRequestPropertyToCloudFormation)(properties.throughResources) }) : properties;
    }
    function CfnNetworkInsightsAccessScopeAccessScopePathRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destination", "Destination", properties.Destination != null ? CfnNetworkInsightsAccessScopePathStatementRequestPropertyFromCloudFormation(properties.Destination) : void 0), ret.addPropertyResult("source", "Source", properties.Source != null ? CfnNetworkInsightsAccessScopePathStatementRequestPropertyFromCloudFormation(properties.Source) : void 0), ret.addPropertyResult("throughResources", "ThroughResources", properties.ThroughResources != null ? cfn_parse.FromCloudFormation.getArray(CfnNetworkInsightsAccessScopeThroughResourcesStatementRequestPropertyFromCloudFormation)(properties.ThroughResources) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnNetworkInsightsAccessScope_PacketHeaderStatementRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationAddresses", cdk.listValidator(cdk.validateString))(properties.destinationAddresses)), errors.collect(cdk.propertyValidator("destinationPorts", cdk.listValidator(cdk.validateString))(properties.destinationPorts)), errors.collect(cdk.propertyValidator("destinationPrefixLists", cdk.listValidator(cdk.validateString))(properties.destinationPrefixLists)), errors.collect(cdk.propertyValidator("protocols", cdk.listValidator(cdk.validateString))(properties.protocols)), errors.collect(cdk.propertyValidator("sourceAddresses", cdk.listValidator(cdk.validateString))(properties.sourceAddresses)), errors.collect(cdk.propertyValidator("sourcePorts", cdk.listValidator(cdk.validateString))(properties.sourcePorts)), errors.collect(cdk.propertyValidator("sourcePrefixLists", cdk.listValidator(cdk.validateString))(properties.sourcePrefixLists)), errors.wrap('supplied properties not correct for "PacketHeaderStatementRequestProperty"');
    }
    function cfnNetworkInsightsAccessScopePacketHeaderStatementRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNetworkInsightsAccessScope_PacketHeaderStatementRequestPropertyValidator(properties).assertSuccess(), { DestinationAddresses: cdk.listMapper(cdk.stringToCloudFormation)(properties.destinationAddresses), DestinationPorts: cdk.listMapper(cdk.stringToCloudFormation)(properties.destinationPorts), DestinationPrefixLists: cdk.listMapper(cdk.stringToCloudFormation)(properties.destinationPrefixLists), Protocols: cdk.listMapper(cdk.stringToCloudFormation)(properties.protocols), SourceAddresses: cdk.listMapper(cdk.stringToCloudFormation)(properties.sourceAddresses), SourcePorts: cdk.listMapper(cdk.stringToCloudFormation)(properties.sourcePorts), SourcePrefixLists: cdk.listMapper(cdk.stringToCloudFormation)(properties.sourcePrefixLists) }) : properties;
    }
    function CfnNetworkInsightsAccessScopePacketHeaderStatementRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationAddresses", "DestinationAddresses", properties.DestinationAddresses != null ? cfn_parse.FromCloudFormation.getStringArray(properties.DestinationAddresses) : void 0), ret.addPropertyResult("destinationPorts", "DestinationPorts", properties.DestinationPorts != null ? cfn_parse.FromCloudFormation.getStringArray(properties.DestinationPorts) : void 0), ret.addPropertyResult("destinationPrefixLists", "DestinationPrefixLists", properties.DestinationPrefixLists != null ? cfn_parse.FromCloudFormation.getStringArray(properties.DestinationPrefixLists) : void 0), ret.addPropertyResult("protocols", "Protocols", properties.Protocols != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Protocols) : void 0), ret.addPropertyResult("sourceAddresses", "SourceAddresses", properties.SourceAddresses != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SourceAddresses) : void 0), ret.addPropertyResult("sourcePorts", "SourcePorts", properties.SourcePorts != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SourcePorts) : void 0), ret.addPropertyResult("sourcePrefixLists", "SourcePrefixLists", properties.SourcePrefixLists != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SourcePrefixLists) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnNetworkInsightsAccessScope_PathStatementRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("packetHeaderStatement", CfnNetworkInsightsAccessScope_PacketHeaderStatementRequestPropertyValidator)(properties.packetHeaderStatement)), errors.collect(cdk.propertyValidator("resourceStatement", CfnNetworkInsightsAccessScope_ResourceStatementRequestPropertyValidator)(properties.resourceStatement)), errors.wrap('supplied properties not correct for "PathStatementRequestProperty"');
    }
    function cfnNetworkInsightsAccessScopePathStatementRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNetworkInsightsAccessScope_PathStatementRequestPropertyValidator(properties).assertSuccess(), { PacketHeaderStatement: cfnNetworkInsightsAccessScopePacketHeaderStatementRequestPropertyToCloudFormation(properties.packetHeaderStatement), ResourceStatement: cfnNetworkInsightsAccessScopeResourceStatementRequestPropertyToCloudFormation(properties.resourceStatement) }) : properties;
    }
    function CfnNetworkInsightsAccessScopePathStatementRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("packetHeaderStatement", "PacketHeaderStatement", properties.PacketHeaderStatement != null ? CfnNetworkInsightsAccessScopePacketHeaderStatementRequestPropertyFromCloudFormation(properties.PacketHeaderStatement) : void 0), ret.addPropertyResult("resourceStatement", "ResourceStatement", properties.ResourceStatement != null ? CfnNetworkInsightsAccessScopeResourceStatementRequestPropertyFromCloudFormation(properties.ResourceStatement) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnNetworkInsightsAccessScope_ResourceStatementRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceTypes", cdk.listValidator(cdk.validateString))(properties.resourceTypes)), errors.collect(cdk.propertyValidator("resources", cdk.listValidator(cdk.validateString))(properties.resources)), errors.wrap('supplied properties not correct for "ResourceStatementRequestProperty"');
    }
    function cfnNetworkInsightsAccessScopeResourceStatementRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNetworkInsightsAccessScope_ResourceStatementRequestPropertyValidator(properties).assertSuccess(), { ResourceTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.resourceTypes), Resources: cdk.listMapper(cdk.stringToCloudFormation)(properties.resources) }) : properties;
    }
    function CfnNetworkInsightsAccessScopeResourceStatementRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceTypes", "ResourceTypes", properties.ResourceTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ResourceTypes) : void 0), ret.addPropertyResult("resources", "Resources", properties.Resources != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Resources) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnNetworkInsightsAccessScope_ThroughResourcesStatementRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceStatement", CfnNetworkInsightsAccessScope_ResourceStatementRequestPropertyValidator)(properties.resourceStatement)), errors.wrap('supplied properties not correct for "ThroughResourcesStatementRequestProperty"');
    }
    function cfnNetworkInsightsAccessScopeThroughResourcesStatementRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNetworkInsightsAccessScope_ThroughResourcesStatementRequestPropertyValidator(properties).assertSuccess(), { ResourceStatement: cfnNetworkInsightsAccessScopeResourceStatementRequestPropertyToCloudFormation(properties.resourceStatement) }) : properties;
    }
    function CfnNetworkInsightsAccessScopeThroughResourcesStatementRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceStatement", "ResourceStatement", properties.ResourceStatement != null ? CfnNetworkInsightsAccessScopeResourceStatementRequestPropertyFromCloudFormation(properties.ResourceStatement) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnNetworkInsightsAccessScopeAnalysisPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("networkInsightsAccessScopeId", cdk.requiredValidator)(properties.networkInsightsAccessScopeId)), errors.collect(cdk.propertyValidator("networkInsightsAccessScopeId", cdk.validateString)(properties.networkInsightsAccessScopeId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnNetworkInsightsAccessScopeAnalysisProps"');
    }
    function cfnNetworkInsightsAccessScopeAnalysisPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNetworkInsightsAccessScopeAnalysisPropsValidator(properties).assertSuccess(), { NetworkInsightsAccessScopeId: cdk.stringToCloudFormation(properties.networkInsightsAccessScopeId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnNetworkInsightsAccessScopeAnalysisPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("networkInsightsAccessScopeId", "NetworkInsightsAccessScopeId", cfn_parse.FromCloudFormation.getString(properties.NetworkInsightsAccessScopeId)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnNetworkInsightsAccessScopeAnalysis = class _CfnNetworkInsightsAccessScopeAnalysis extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnNetworkInsightsAccessScopeAnalysisPropsFromCloudFormation(resourceProperties), ret = new _CfnNetworkInsightsAccessScopeAnalysis(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnNetworkInsightsAccessScopeAnalysis.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnNetworkInsightsAccessScopeAnalysisProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnNetworkInsightsAccessScopeAnalysis), error;
        }
        cdk.requireProperty(props, "networkInsightsAccessScopeId", this), this.attrAnalyzedEniCount = cdk.Token.asNumber(this.getAtt("AnalyzedEniCount", cdk.ResolutionTypeHint.NUMBER)), this.attrEndDate = cdk.Token.asString(this.getAtt("EndDate", cdk.ResolutionTypeHint.STRING)), this.attrFindingsFound = cdk.Token.asString(this.getAtt("FindingsFound", cdk.ResolutionTypeHint.STRING)), this.attrNetworkInsightsAccessScopeAnalysisArn = cdk.Token.asString(this.getAtt("NetworkInsightsAccessScopeAnalysisArn", cdk.ResolutionTypeHint.STRING)), this.attrNetworkInsightsAccessScopeAnalysisId = cdk.Token.asString(this.getAtt("NetworkInsightsAccessScopeAnalysisId", cdk.ResolutionTypeHint.STRING)), this.attrStartDate = cdk.Token.asString(this.getAtt("StartDate", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.attrStatusMessage = cdk.Token.asString(this.getAtt("StatusMessage", cdk.ResolutionTypeHint.STRING)), this.networkInsightsAccessScopeId = props.networkInsightsAccessScopeId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::NetworkInsightsAccessScopeAnalysis", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnNetworkInsightsAccessScopeAnalysis.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { networkInsightsAccessScopeId: this.networkInsightsAccessScopeId, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnNetworkInsightsAccessScopeAnalysisPropsToCloudFormation(props);
      }
    };
    _12 = JSII_RTTI_SYMBOL_1, CfnNetworkInsightsAccessScopeAnalysis[_12] = { fqn: "aws-cdk-lib.aws_ec2.CfnNetworkInsightsAccessScopeAnalysis", version: "2.80.0" }, CfnNetworkInsightsAccessScopeAnalysis.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::NetworkInsightsAccessScopeAnalysis", exports2.CfnNetworkInsightsAccessScopeAnalysis = CfnNetworkInsightsAccessScopeAnalysis;
    function CfnNetworkInsightsAnalysisPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("additionalAccounts", cdk.listValidator(cdk.validateString))(properties.additionalAccounts)), errors.collect(cdk.propertyValidator("filterInArns", cdk.listValidator(cdk.validateString))(properties.filterInArns)), errors.collect(cdk.propertyValidator("networkInsightsPathId", cdk.requiredValidator)(properties.networkInsightsPathId)), errors.collect(cdk.propertyValidator("networkInsightsPathId", cdk.validateString)(properties.networkInsightsPathId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnNetworkInsightsAnalysisProps"');
    }
    function cfnNetworkInsightsAnalysisPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNetworkInsightsAnalysisPropsValidator(properties).assertSuccess(), { NetworkInsightsPathId: cdk.stringToCloudFormation(properties.networkInsightsPathId), AdditionalAccounts: cdk.listMapper(cdk.stringToCloudFormation)(properties.additionalAccounts), FilterInArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.filterInArns), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnNetworkInsightsAnalysisPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("networkInsightsPathId", "NetworkInsightsPathId", cfn_parse.FromCloudFormation.getString(properties.NetworkInsightsPathId)), ret.addPropertyResult("additionalAccounts", "AdditionalAccounts", properties.AdditionalAccounts != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AdditionalAccounts) : void 0), ret.addPropertyResult("filterInArns", "FilterInArns", properties.FilterInArns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.FilterInArns) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnNetworkInsightsAnalysis = class _CfnNetworkInsightsAnalysis extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnNetworkInsightsAnalysisPropsFromCloudFormation(resourceProperties), ret = new _CfnNetworkInsightsAnalysis(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnNetworkInsightsAnalysis.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnNetworkInsightsAnalysisProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnNetworkInsightsAnalysis), error;
        }
        cdk.requireProperty(props, "networkInsightsPathId", this), this.attrAlternatePathHints = this.getAtt("AlternatePathHints", cdk.ResolutionTypeHint.STRING), this.attrExplanations = this.getAtt("Explanations", cdk.ResolutionTypeHint.STRING), this.attrForwardPathComponents = this.getAtt("ForwardPathComponents", cdk.ResolutionTypeHint.STRING), this.attrNetworkInsightsAnalysisArn = cdk.Token.asString(this.getAtt("NetworkInsightsAnalysisArn", cdk.ResolutionTypeHint.STRING)), this.attrNetworkInsightsAnalysisId = cdk.Token.asString(this.getAtt("NetworkInsightsAnalysisId", cdk.ResolutionTypeHint.STRING)), this.attrNetworkPathFound = this.getAtt("NetworkPathFound", cdk.ResolutionTypeHint.STRING), this.attrReturnPathComponents = this.getAtt("ReturnPathComponents", cdk.ResolutionTypeHint.STRING), this.attrStartDate = cdk.Token.asString(this.getAtt("StartDate", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.attrStatusMessage = cdk.Token.asString(this.getAtt("StatusMessage", cdk.ResolutionTypeHint.STRING)), this.attrSuggestedAccounts = cdk.Token.asList(this.getAtt("SuggestedAccounts", cdk.ResolutionTypeHint.STRING_LIST)), this.networkInsightsPathId = props.networkInsightsPathId, this.additionalAccounts = props.additionalAccounts, this.filterInArns = props.filterInArns, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::NetworkInsightsAnalysis", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnNetworkInsightsAnalysis.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { networkInsightsPathId: this.networkInsightsPathId, additionalAccounts: this.additionalAccounts, filterInArns: this.filterInArns, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnNetworkInsightsAnalysisPropsToCloudFormation(props);
      }
    };
    _13 = JSII_RTTI_SYMBOL_1, CfnNetworkInsightsAnalysis[_13] = { fqn: "aws-cdk-lib.aws_ec2.CfnNetworkInsightsAnalysis", version: "2.80.0" }, CfnNetworkInsightsAnalysis.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::NetworkInsightsAnalysis", exports2.CfnNetworkInsightsAnalysis = CfnNetworkInsightsAnalysis;
    function CfnNetworkInsightsPathPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destination", cdk.validateString)(properties.destination)), errors.collect(cdk.propertyValidator("destinationIp", cdk.validateString)(properties.destinationIp)), errors.collect(cdk.propertyValidator("destinationPort", cdk.validateNumber)(properties.destinationPort)), errors.collect(cdk.propertyValidator("filterAtDestination", CfnNetworkInsightsPath_PathFilterPropertyValidator)(properties.filterAtDestination)), errors.collect(cdk.propertyValidator("filterAtSource", CfnNetworkInsightsPath_PathFilterPropertyValidator)(properties.filterAtSource)), errors.collect(cdk.propertyValidator("protocol", cdk.requiredValidator)(properties.protocol)), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.collect(cdk.propertyValidator("source", cdk.requiredValidator)(properties.source)), errors.collect(cdk.propertyValidator("source", cdk.validateString)(properties.source)), errors.collect(cdk.propertyValidator("sourceIp", cdk.validateString)(properties.sourceIp)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnNetworkInsightsPathProps"');
    }
    function cfnNetworkInsightsPathPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNetworkInsightsPathPropsValidator(properties).assertSuccess(), { Protocol: cdk.stringToCloudFormation(properties.protocol), Source: cdk.stringToCloudFormation(properties.source), Destination: cdk.stringToCloudFormation(properties.destination), DestinationIp: cdk.stringToCloudFormation(properties.destinationIp), DestinationPort: cdk.numberToCloudFormation(properties.destinationPort), FilterAtDestination: cfnNetworkInsightsPathPathFilterPropertyToCloudFormation(properties.filterAtDestination), FilterAtSource: cfnNetworkInsightsPathPathFilterPropertyToCloudFormation(properties.filterAtSource), SourceIp: cdk.stringToCloudFormation(properties.sourceIp), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnNetworkInsightsPathPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("protocol", "Protocol", cfn_parse.FromCloudFormation.getString(properties.Protocol)), ret.addPropertyResult("source", "Source", cfn_parse.FromCloudFormation.getString(properties.Source)), ret.addPropertyResult("destination", "Destination", properties.Destination != null ? cfn_parse.FromCloudFormation.getString(properties.Destination) : void 0), ret.addPropertyResult("destinationIp", "DestinationIp", properties.DestinationIp != null ? cfn_parse.FromCloudFormation.getString(properties.DestinationIp) : void 0), ret.addPropertyResult("destinationPort", "DestinationPort", properties.DestinationPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.DestinationPort) : void 0), ret.addPropertyResult("filterAtDestination", "FilterAtDestination", properties.FilterAtDestination != null ? CfnNetworkInsightsPathPathFilterPropertyFromCloudFormation(properties.FilterAtDestination) : void 0), ret.addPropertyResult("filterAtSource", "FilterAtSource", properties.FilterAtSource != null ? CfnNetworkInsightsPathPathFilterPropertyFromCloudFormation(properties.FilterAtSource) : void 0), ret.addPropertyResult("sourceIp", "SourceIp", properties.SourceIp != null ? cfn_parse.FromCloudFormation.getString(properties.SourceIp) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnNetworkInsightsPath = class _CfnNetworkInsightsPath extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnNetworkInsightsPathPropsFromCloudFormation(resourceProperties), ret = new _CfnNetworkInsightsPath(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnNetworkInsightsPath.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnNetworkInsightsPathProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnNetworkInsightsPath), error;
        }
        cdk.requireProperty(props, "protocol", this), cdk.requireProperty(props, "source", this), this.attrCreatedDate = cdk.Token.asString(this.getAtt("CreatedDate", cdk.ResolutionTypeHint.STRING)), this.attrDestinationArn = cdk.Token.asString(this.getAtt("DestinationArn", cdk.ResolutionTypeHint.STRING)), this.attrNetworkInsightsPathArn = cdk.Token.asString(this.getAtt("NetworkInsightsPathArn", cdk.ResolutionTypeHint.STRING)), this.attrNetworkInsightsPathId = cdk.Token.asString(this.getAtt("NetworkInsightsPathId", cdk.ResolutionTypeHint.STRING)), this.attrSourceArn = cdk.Token.asString(this.getAtt("SourceArn", cdk.ResolutionTypeHint.STRING)), this.protocol = props.protocol, this.source = props.source, this.destination = props.destination, this.destinationIp = props.destinationIp, this.destinationPort = props.destinationPort, this.filterAtDestination = props.filterAtDestination, this.filterAtSource = props.filterAtSource, this.sourceIp = props.sourceIp, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::NetworkInsightsPath", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnNetworkInsightsPath.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { protocol: this.protocol, source: this.source, destination: this.destination, destinationIp: this.destinationIp, destinationPort: this.destinationPort, filterAtDestination: this.filterAtDestination, filterAtSource: this.filterAtSource, sourceIp: this.sourceIp, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnNetworkInsightsPathPropsToCloudFormation(props);
      }
    };
    _14 = JSII_RTTI_SYMBOL_1, CfnNetworkInsightsPath[_14] = { fqn: "aws-cdk-lib.aws_ec2.CfnNetworkInsightsPath", version: "2.80.0" }, CfnNetworkInsightsPath.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::NetworkInsightsPath", exports2.CfnNetworkInsightsPath = CfnNetworkInsightsPath;
    function CfnNetworkInsightsPath_FilterPortRangePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fromPort", cdk.validateNumber)(properties.fromPort)), errors.collect(cdk.propertyValidator("toPort", cdk.validateNumber)(properties.toPort)), errors.wrap('supplied properties not correct for "FilterPortRangeProperty"');
    }
    function cfnNetworkInsightsPathFilterPortRangePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNetworkInsightsPath_FilterPortRangePropertyValidator(properties).assertSuccess(), { FromPort: cdk.numberToCloudFormation(properties.fromPort), ToPort: cdk.numberToCloudFormation(properties.toPort) }) : properties;
    }
    function CfnNetworkInsightsPathFilterPortRangePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fromPort", "FromPort", properties.FromPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.FromPort) : void 0), ret.addPropertyResult("toPort", "ToPort", properties.ToPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.ToPort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnNetworkInsightsPath_PathFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationAddress", cdk.validateString)(properties.destinationAddress)), errors.collect(cdk.propertyValidator("destinationPortRange", CfnNetworkInsightsPath_FilterPortRangePropertyValidator)(properties.destinationPortRange)), errors.collect(cdk.propertyValidator("sourceAddress", cdk.validateString)(properties.sourceAddress)), errors.collect(cdk.propertyValidator("sourcePortRange", CfnNetworkInsightsPath_FilterPortRangePropertyValidator)(properties.sourcePortRange)), errors.wrap('supplied properties not correct for "PathFilterProperty"');
    }
    function cfnNetworkInsightsPathPathFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNetworkInsightsPath_PathFilterPropertyValidator(properties).assertSuccess(), { DestinationAddress: cdk.stringToCloudFormation(properties.destinationAddress), DestinationPortRange: cfnNetworkInsightsPathFilterPortRangePropertyToCloudFormation(properties.destinationPortRange), SourceAddress: cdk.stringToCloudFormation(properties.sourceAddress), SourcePortRange: cfnNetworkInsightsPathFilterPortRangePropertyToCloudFormation(properties.sourcePortRange) }) : properties;
    }
    function CfnNetworkInsightsPathPathFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationAddress", "DestinationAddress", properties.DestinationAddress != null ? cfn_parse.FromCloudFormation.getString(properties.DestinationAddress) : void 0), ret.addPropertyResult("destinationPortRange", "DestinationPortRange", properties.DestinationPortRange != null ? CfnNetworkInsightsPathFilterPortRangePropertyFromCloudFormation(properties.DestinationPortRange) : void 0), ret.addPropertyResult("sourceAddress", "SourceAddress", properties.SourceAddress != null ? cfn_parse.FromCloudFormation.getString(properties.SourceAddress) : void 0), ret.addPropertyResult("sourcePortRange", "SourcePortRange", properties.SourcePortRange != null ? CfnNetworkInsightsPathFilterPortRangePropertyFromCloudFormation(properties.SourcePortRange) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnNetworkInterfacePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("groupSet", cdk.listValidator(cdk.validateString))(properties.groupSet)), errors.collect(cdk.propertyValidator("interfaceType", cdk.validateString)(properties.interfaceType)), errors.collect(cdk.propertyValidator("ipv6AddressCount", cdk.validateNumber)(properties.ipv6AddressCount)), errors.collect(cdk.propertyValidator("ipv6Addresses", cdk.listValidator(CfnNetworkInterface_InstanceIpv6AddressPropertyValidator))(properties.ipv6Addresses)), errors.collect(cdk.propertyValidator("privateIpAddress", cdk.validateString)(properties.privateIpAddress)), errors.collect(cdk.propertyValidator("privateIpAddresses", cdk.listValidator(CfnNetworkInterface_PrivateIpAddressSpecificationPropertyValidator))(properties.privateIpAddresses)), errors.collect(cdk.propertyValidator("secondaryPrivateIpAddressCount", cdk.validateNumber)(properties.secondaryPrivateIpAddressCount)), errors.collect(cdk.propertyValidator("sourceDestCheck", cdk.validateBoolean)(properties.sourceDestCheck)), errors.collect(cdk.propertyValidator("subnetId", cdk.requiredValidator)(properties.subnetId)), errors.collect(cdk.propertyValidator("subnetId", cdk.validateString)(properties.subnetId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnNetworkInterfaceProps"');
    }
    function cfnNetworkInterfacePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNetworkInterfacePropsValidator(properties).assertSuccess(), { SubnetId: cdk.stringToCloudFormation(properties.subnetId), Description: cdk.stringToCloudFormation(properties.description), GroupSet: cdk.listMapper(cdk.stringToCloudFormation)(properties.groupSet), InterfaceType: cdk.stringToCloudFormation(properties.interfaceType), Ipv6AddressCount: cdk.numberToCloudFormation(properties.ipv6AddressCount), Ipv6Addresses: cdk.listMapper(cfnNetworkInterfaceInstanceIpv6AddressPropertyToCloudFormation)(properties.ipv6Addresses), PrivateIpAddress: cdk.stringToCloudFormation(properties.privateIpAddress), PrivateIpAddresses: cdk.listMapper(cfnNetworkInterfacePrivateIpAddressSpecificationPropertyToCloudFormation)(properties.privateIpAddresses), SecondaryPrivateIpAddressCount: cdk.numberToCloudFormation(properties.secondaryPrivateIpAddressCount), SourceDestCheck: cdk.booleanToCloudFormation(properties.sourceDestCheck), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnNetworkInterfacePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("subnetId", "SubnetId", cfn_parse.FromCloudFormation.getString(properties.SubnetId)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("groupSet", "GroupSet", properties.GroupSet != null ? cfn_parse.FromCloudFormation.getStringArray(properties.GroupSet) : void 0), ret.addPropertyResult("interfaceType", "InterfaceType", properties.InterfaceType != null ? cfn_parse.FromCloudFormation.getString(properties.InterfaceType) : void 0), ret.addPropertyResult("ipv6AddressCount", "Ipv6AddressCount", properties.Ipv6AddressCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.Ipv6AddressCount) : void 0), ret.addPropertyResult("ipv6Addresses", "Ipv6Addresses", properties.Ipv6Addresses != null ? cfn_parse.FromCloudFormation.getArray(CfnNetworkInterfaceInstanceIpv6AddressPropertyFromCloudFormation)(properties.Ipv6Addresses) : void 0), ret.addPropertyResult("privateIpAddress", "PrivateIpAddress", properties.PrivateIpAddress != null ? cfn_parse.FromCloudFormation.getString(properties.PrivateIpAddress) : void 0), ret.addPropertyResult("privateIpAddresses", "PrivateIpAddresses", properties.PrivateIpAddresses != null ? cfn_parse.FromCloudFormation.getArray(CfnNetworkInterfacePrivateIpAddressSpecificationPropertyFromCloudFormation)(properties.PrivateIpAddresses) : void 0), ret.addPropertyResult("secondaryPrivateIpAddressCount", "SecondaryPrivateIpAddressCount", properties.SecondaryPrivateIpAddressCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.SecondaryPrivateIpAddressCount) : void 0), ret.addPropertyResult("sourceDestCheck", "SourceDestCheck", properties.SourceDestCheck != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SourceDestCheck) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnNetworkInterface = class _CfnNetworkInterface extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnNetworkInterfacePropsFromCloudFormation(resourceProperties), ret = new _CfnNetworkInterface(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnNetworkInterface.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnNetworkInterfaceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnNetworkInterface), error;
        }
        cdk.requireProperty(props, "subnetId", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrPrimaryPrivateIpAddress = cdk.Token.asString(this.getAtt("PrimaryPrivateIpAddress", cdk.ResolutionTypeHint.STRING)), this.attrSecondaryPrivateIpAddresses = cdk.Token.asList(this.getAtt("SecondaryPrivateIpAddresses", cdk.ResolutionTypeHint.STRING_LIST)), this.subnetId = props.subnetId, this.description = props.description, this.groupSet = props.groupSet, this.interfaceType = props.interfaceType, this.ipv6AddressCount = props.ipv6AddressCount, this.ipv6Addresses = props.ipv6Addresses, this.privateIpAddress = props.privateIpAddress, this.privateIpAddresses = props.privateIpAddresses, this.secondaryPrivateIpAddressCount = props.secondaryPrivateIpAddressCount, this.sourceDestCheck = props.sourceDestCheck, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::NetworkInterface", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnNetworkInterface.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { subnetId: this.subnetId, description: this.description, groupSet: this.groupSet, interfaceType: this.interfaceType, ipv6AddressCount: this.ipv6AddressCount, ipv6Addresses: this.ipv6Addresses, privateIpAddress: this.privateIpAddress, privateIpAddresses: this.privateIpAddresses, secondaryPrivateIpAddressCount: this.secondaryPrivateIpAddressCount, sourceDestCheck: this.sourceDestCheck, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnNetworkInterfacePropsToCloudFormation(props);
      }
    };
    _15 = JSII_RTTI_SYMBOL_1, CfnNetworkInterface[_15] = { fqn: "aws-cdk-lib.aws_ec2.CfnNetworkInterface", version: "2.80.0" }, CfnNetworkInterface.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::NetworkInterface", exports2.CfnNetworkInterface = CfnNetworkInterface;
    function CfnNetworkInterface_InstanceIpv6AddressPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ipv6Address", cdk.requiredValidator)(properties.ipv6Address)), errors.collect(cdk.propertyValidator("ipv6Address", cdk.validateString)(properties.ipv6Address)), errors.wrap('supplied properties not correct for "InstanceIpv6AddressProperty"');
    }
    function cfnNetworkInterfaceInstanceIpv6AddressPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNetworkInterface_InstanceIpv6AddressPropertyValidator(properties).assertSuccess(), { Ipv6Address: cdk.stringToCloudFormation(properties.ipv6Address) }) : properties;
    }
    function CfnNetworkInterfaceInstanceIpv6AddressPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ipv6Address", "Ipv6Address", cfn_parse.FromCloudFormation.getString(properties.Ipv6Address)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnNetworkInterface_PrivateIpAddressSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("primary", cdk.requiredValidator)(properties.primary)), errors.collect(cdk.propertyValidator("primary", cdk.validateBoolean)(properties.primary)), errors.collect(cdk.propertyValidator("privateIpAddress", cdk.requiredValidator)(properties.privateIpAddress)), errors.collect(cdk.propertyValidator("privateIpAddress", cdk.validateString)(properties.privateIpAddress)), errors.wrap('supplied properties not correct for "PrivateIpAddressSpecificationProperty"');
    }
    function cfnNetworkInterfacePrivateIpAddressSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNetworkInterface_PrivateIpAddressSpecificationPropertyValidator(properties).assertSuccess(), { Primary: cdk.booleanToCloudFormation(properties.primary), PrivateIpAddress: cdk.stringToCloudFormation(properties.privateIpAddress) }) : properties;
    }
    function CfnNetworkInterfacePrivateIpAddressSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("primary", "Primary", cfn_parse.FromCloudFormation.getBoolean(properties.Primary)), ret.addPropertyResult("privateIpAddress", "PrivateIpAddress", cfn_parse.FromCloudFormation.getString(properties.PrivateIpAddress)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnNetworkInterfaceAttachmentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deleteOnTermination", cdk.validateBoolean)(properties.deleteOnTermination)), errors.collect(cdk.propertyValidator("deviceIndex", cdk.requiredValidator)(properties.deviceIndex)), errors.collect(cdk.propertyValidator("deviceIndex", cdk.validateString)(properties.deviceIndex)), errors.collect(cdk.propertyValidator("instanceId", cdk.requiredValidator)(properties.instanceId)), errors.collect(cdk.propertyValidator("instanceId", cdk.validateString)(properties.instanceId)), errors.collect(cdk.propertyValidator("networkInterfaceId", cdk.requiredValidator)(properties.networkInterfaceId)), errors.collect(cdk.propertyValidator("networkInterfaceId", cdk.validateString)(properties.networkInterfaceId)), errors.wrap('supplied properties not correct for "CfnNetworkInterfaceAttachmentProps"');
    }
    function cfnNetworkInterfaceAttachmentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNetworkInterfaceAttachmentPropsValidator(properties).assertSuccess(), { DeviceIndex: cdk.stringToCloudFormation(properties.deviceIndex), InstanceId: cdk.stringToCloudFormation(properties.instanceId), NetworkInterfaceId: cdk.stringToCloudFormation(properties.networkInterfaceId), DeleteOnTermination: cdk.booleanToCloudFormation(properties.deleteOnTermination) }) : properties;
    }
    function CfnNetworkInterfaceAttachmentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deviceIndex", "DeviceIndex", cfn_parse.FromCloudFormation.getString(properties.DeviceIndex)), ret.addPropertyResult("instanceId", "InstanceId", cfn_parse.FromCloudFormation.getString(properties.InstanceId)), ret.addPropertyResult("networkInterfaceId", "NetworkInterfaceId", cfn_parse.FromCloudFormation.getString(properties.NetworkInterfaceId)), ret.addPropertyResult("deleteOnTermination", "DeleteOnTermination", properties.DeleteOnTermination != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeleteOnTermination) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnNetworkInterfaceAttachment = class _CfnNetworkInterfaceAttachment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnNetworkInterfaceAttachmentPropsFromCloudFormation(resourceProperties), ret = new _CfnNetworkInterfaceAttachment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnNetworkInterfaceAttachment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnNetworkInterfaceAttachmentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnNetworkInterfaceAttachment), error;
        }
        cdk.requireProperty(props, "deviceIndex", this), cdk.requireProperty(props, "instanceId", this), cdk.requireProperty(props, "networkInterfaceId", this), this.deviceIndex = props.deviceIndex, this.instanceId = props.instanceId, this.networkInterfaceId = props.networkInterfaceId, this.deleteOnTermination = props.deleteOnTermination;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnNetworkInterfaceAttachment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { deviceIndex: this.deviceIndex, instanceId: this.instanceId, networkInterfaceId: this.networkInterfaceId, deleteOnTermination: this.deleteOnTermination };
      }
      renderProperties(props) {
        return cfnNetworkInterfaceAttachmentPropsToCloudFormation(props);
      }
    };
    _16 = JSII_RTTI_SYMBOL_1, CfnNetworkInterfaceAttachment[_16] = { fqn: "aws-cdk-lib.aws_ec2.CfnNetworkInterfaceAttachment", version: "2.80.0" }, CfnNetworkInterfaceAttachment.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::NetworkInterfaceAttachment", exports2.CfnNetworkInterfaceAttachment = CfnNetworkInterfaceAttachment;
    function CfnNetworkInterfacePermissionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("awsAccountId", cdk.requiredValidator)(properties.awsAccountId)), errors.collect(cdk.propertyValidator("awsAccountId", cdk.validateString)(properties.awsAccountId)), errors.collect(cdk.propertyValidator("networkInterfaceId", cdk.requiredValidator)(properties.networkInterfaceId)), errors.collect(cdk.propertyValidator("networkInterfaceId", cdk.validateString)(properties.networkInterfaceId)), errors.collect(cdk.propertyValidator("permission", cdk.requiredValidator)(properties.permission)), errors.collect(cdk.propertyValidator("permission", cdk.validateString)(properties.permission)), errors.wrap('supplied properties not correct for "CfnNetworkInterfacePermissionProps"');
    }
    function cfnNetworkInterfacePermissionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNetworkInterfacePermissionPropsValidator(properties).assertSuccess(), { AwsAccountId: cdk.stringToCloudFormation(properties.awsAccountId), NetworkInterfaceId: cdk.stringToCloudFormation(properties.networkInterfaceId), Permission: cdk.stringToCloudFormation(properties.permission) }) : properties;
    }
    function CfnNetworkInterfacePermissionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("awsAccountId", "AwsAccountId", cfn_parse.FromCloudFormation.getString(properties.AwsAccountId)), ret.addPropertyResult("networkInterfaceId", "NetworkInterfaceId", cfn_parse.FromCloudFormation.getString(properties.NetworkInterfaceId)), ret.addPropertyResult("permission", "Permission", cfn_parse.FromCloudFormation.getString(properties.Permission)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnNetworkInterfacePermission = class _CfnNetworkInterfacePermission extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnNetworkInterfacePermissionPropsFromCloudFormation(resourceProperties), ret = new _CfnNetworkInterfacePermission(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnNetworkInterfacePermission.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnNetworkInterfacePermissionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnNetworkInterfacePermission), error;
        }
        cdk.requireProperty(props, "awsAccountId", this), cdk.requireProperty(props, "networkInterfaceId", this), cdk.requireProperty(props, "permission", this), this.awsAccountId = props.awsAccountId, this.networkInterfaceId = props.networkInterfaceId, this.permission = props.permission;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnNetworkInterfacePermission.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { awsAccountId: this.awsAccountId, networkInterfaceId: this.networkInterfaceId, permission: this.permission };
      }
      renderProperties(props) {
        return cfnNetworkInterfacePermissionPropsToCloudFormation(props);
      }
    };
    _17 = JSII_RTTI_SYMBOL_1, CfnNetworkInterfacePermission[_17] = { fqn: "aws-cdk-lib.aws_ec2.CfnNetworkInterfacePermission", version: "2.80.0" }, CfnNetworkInterfacePermission.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::NetworkInterfacePermission", exports2.CfnNetworkInterfacePermission = CfnNetworkInterfacePermission;
    function CfnNetworkPerformanceMetricSubscriptionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destination", cdk.requiredValidator)(properties.destination)), errors.collect(cdk.propertyValidator("destination", cdk.validateString)(properties.destination)), errors.collect(cdk.propertyValidator("metric", cdk.requiredValidator)(properties.metric)), errors.collect(cdk.propertyValidator("metric", cdk.validateString)(properties.metric)), errors.collect(cdk.propertyValidator("source", cdk.requiredValidator)(properties.source)), errors.collect(cdk.propertyValidator("source", cdk.validateString)(properties.source)), errors.collect(cdk.propertyValidator("statistic", cdk.requiredValidator)(properties.statistic)), errors.collect(cdk.propertyValidator("statistic", cdk.validateString)(properties.statistic)), errors.wrap('supplied properties not correct for "CfnNetworkPerformanceMetricSubscriptionProps"');
    }
    function cfnNetworkPerformanceMetricSubscriptionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNetworkPerformanceMetricSubscriptionPropsValidator(properties).assertSuccess(), { Destination: cdk.stringToCloudFormation(properties.destination), Metric: cdk.stringToCloudFormation(properties.metric), Source: cdk.stringToCloudFormation(properties.source), Statistic: cdk.stringToCloudFormation(properties.statistic) }) : properties;
    }
    function CfnNetworkPerformanceMetricSubscriptionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destination", "Destination", cfn_parse.FromCloudFormation.getString(properties.Destination)), ret.addPropertyResult("metric", "Metric", cfn_parse.FromCloudFormation.getString(properties.Metric)), ret.addPropertyResult("source", "Source", cfn_parse.FromCloudFormation.getString(properties.Source)), ret.addPropertyResult("statistic", "Statistic", cfn_parse.FromCloudFormation.getString(properties.Statistic)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnNetworkPerformanceMetricSubscription = class _CfnNetworkPerformanceMetricSubscription extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnNetworkPerformanceMetricSubscriptionPropsFromCloudFormation(resourceProperties), ret = new _CfnNetworkPerformanceMetricSubscription(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnNetworkPerformanceMetricSubscription.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnNetworkPerformanceMetricSubscriptionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnNetworkPerformanceMetricSubscription), error;
        }
        cdk.requireProperty(props, "destination", this), cdk.requireProperty(props, "metric", this), cdk.requireProperty(props, "source", this), cdk.requireProperty(props, "statistic", this), this.destination = props.destination, this.metric = props.metric, this.source = props.source, this.statistic = props.statistic;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnNetworkPerformanceMetricSubscription.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { destination: this.destination, metric: this.metric, source: this.source, statistic: this.statistic };
      }
      renderProperties(props) {
        return cfnNetworkPerformanceMetricSubscriptionPropsToCloudFormation(props);
      }
    };
    _18 = JSII_RTTI_SYMBOL_1, CfnNetworkPerformanceMetricSubscription[_18] = { fqn: "aws-cdk-lib.aws_ec2.CfnNetworkPerformanceMetricSubscription", version: "2.80.0" }, CfnNetworkPerformanceMetricSubscription.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::NetworkPerformanceMetricSubscription", exports2.CfnNetworkPerformanceMetricSubscription = CfnNetworkPerformanceMetricSubscription;
    function CfnPlacementGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("partitionCount", cdk.validateNumber)(properties.partitionCount)), errors.collect(cdk.propertyValidator("spreadLevel", cdk.validateString)(properties.spreadLevel)), errors.collect(cdk.propertyValidator("strategy", cdk.validateString)(properties.strategy)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnPlacementGroupProps"');
    }
    function cfnPlacementGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPlacementGroupPropsValidator(properties).assertSuccess(), { PartitionCount: cdk.numberToCloudFormation(properties.partitionCount), SpreadLevel: cdk.stringToCloudFormation(properties.spreadLevel), Strategy: cdk.stringToCloudFormation(properties.strategy), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnPlacementGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("partitionCount", "PartitionCount", properties.PartitionCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.PartitionCount) : void 0), ret.addPropertyResult("spreadLevel", "SpreadLevel", properties.SpreadLevel != null ? cfn_parse.FromCloudFormation.getString(properties.SpreadLevel) : void 0), ret.addPropertyResult("strategy", "Strategy", properties.Strategy != null ? cfn_parse.FromCloudFormation.getString(properties.Strategy) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPlacementGroup = class _CfnPlacementGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPlacementGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnPlacementGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnPlacementGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnPlacementGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPlacementGroup), error;
        }
        this.attrGroupName = cdk.Token.asString(this.getAtt("GroupName", cdk.ResolutionTypeHint.STRING)), this.partitionCount = props.partitionCount, this.spreadLevel = props.spreadLevel, this.strategy = props.strategy, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::PlacementGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPlacementGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { partitionCount: this.partitionCount, spreadLevel: this.spreadLevel, strategy: this.strategy, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnPlacementGroupPropsToCloudFormation(props);
      }
    };
    _19 = JSII_RTTI_SYMBOL_1, CfnPlacementGroup[_19] = { fqn: "aws-cdk-lib.aws_ec2.CfnPlacementGroup", version: "2.80.0" }, CfnPlacementGroup.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::PlacementGroup", exports2.CfnPlacementGroup = CfnPlacementGroup;
    function CfnPrefixListPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("addressFamily", cdk.requiredValidator)(properties.addressFamily)), errors.collect(cdk.propertyValidator("addressFamily", cdk.validateString)(properties.addressFamily)), errors.collect(cdk.propertyValidator("entries", cdk.listValidator(CfnPrefixList_EntryPropertyValidator))(properties.entries)), errors.collect(cdk.propertyValidator("maxEntries", cdk.requiredValidator)(properties.maxEntries)), errors.collect(cdk.propertyValidator("maxEntries", cdk.validateNumber)(properties.maxEntries)), errors.collect(cdk.propertyValidator("prefixListName", cdk.requiredValidator)(properties.prefixListName)), errors.collect(cdk.propertyValidator("prefixListName", cdk.validateString)(properties.prefixListName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnPrefixListProps"');
    }
    function cfnPrefixListPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPrefixListPropsValidator(properties).assertSuccess(), { AddressFamily: cdk.stringToCloudFormation(properties.addressFamily), MaxEntries: cdk.numberToCloudFormation(properties.maxEntries), PrefixListName: cdk.stringToCloudFormation(properties.prefixListName), Entries: cdk.listMapper(cfnPrefixListEntryPropertyToCloudFormation)(properties.entries), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnPrefixListPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("addressFamily", "AddressFamily", cfn_parse.FromCloudFormation.getString(properties.AddressFamily)), ret.addPropertyResult("maxEntries", "MaxEntries", cfn_parse.FromCloudFormation.getNumber(properties.MaxEntries)), ret.addPropertyResult("prefixListName", "PrefixListName", cfn_parse.FromCloudFormation.getString(properties.PrefixListName)), ret.addPropertyResult("entries", "Entries", properties.Entries != null ? cfn_parse.FromCloudFormation.getArray(CfnPrefixListEntryPropertyFromCloudFormation)(properties.Entries) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPrefixList = class _CfnPrefixList extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPrefixListPropsFromCloudFormation(resourceProperties), ret = new _CfnPrefixList(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPrefixList.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnPrefixListProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPrefixList), error;
        }
        cdk.requireProperty(props, "addressFamily", this), cdk.requireProperty(props, "maxEntries", this), cdk.requireProperty(props, "prefixListName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrOwnerId = cdk.Token.asString(this.getAtt("OwnerId", cdk.ResolutionTypeHint.STRING)), this.attrPrefixListId = cdk.Token.asString(this.getAtt("PrefixListId", cdk.ResolutionTypeHint.STRING)), this.attrVersion = cdk.Token.asNumber(this.getAtt("Version", cdk.ResolutionTypeHint.NUMBER)), this.addressFamily = props.addressFamily, this.maxEntries = props.maxEntries, this.prefixListName = props.prefixListName, this.entries = props.entries, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::PrefixList", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPrefixList.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { addressFamily: this.addressFamily, maxEntries: this.maxEntries, prefixListName: this.prefixListName, entries: this.entries, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnPrefixListPropsToCloudFormation(props);
      }
    };
    _20 = JSII_RTTI_SYMBOL_1, CfnPrefixList[_20] = { fqn: "aws-cdk-lib.aws_ec2.CfnPrefixList", version: "2.80.0" }, CfnPrefixList.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::PrefixList", exports2.CfnPrefixList = CfnPrefixList;
    function CfnPrefixList_EntryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cidr", cdk.requiredValidator)(properties.cidr)), errors.collect(cdk.propertyValidator("cidr", cdk.validateString)(properties.cidr)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.wrap('supplied properties not correct for "EntryProperty"');
    }
    function cfnPrefixListEntryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPrefixList_EntryPropertyValidator(properties).assertSuccess(), { Cidr: cdk.stringToCloudFormation(properties.cidr), Description: cdk.stringToCloudFormation(properties.description) }) : properties;
    }
    function CfnPrefixListEntryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cidr", "Cidr", cfn_parse.FromCloudFormation.getString(properties.Cidr)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRoutePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("carrierGatewayId", cdk.validateString)(properties.carrierGatewayId)), errors.collect(cdk.propertyValidator("destinationCidrBlock", cdk.validateString)(properties.destinationCidrBlock)), errors.collect(cdk.propertyValidator("destinationIpv6CidrBlock", cdk.validateString)(properties.destinationIpv6CidrBlock)), errors.collect(cdk.propertyValidator("egressOnlyInternetGatewayId", cdk.validateString)(properties.egressOnlyInternetGatewayId)), errors.collect(cdk.propertyValidator("gatewayId", cdk.validateString)(properties.gatewayId)), errors.collect(cdk.propertyValidator("instanceId", cdk.validateString)(properties.instanceId)), errors.collect(cdk.propertyValidator("localGatewayId", cdk.validateString)(properties.localGatewayId)), errors.collect(cdk.propertyValidator("natGatewayId", cdk.validateString)(properties.natGatewayId)), errors.collect(cdk.propertyValidator("networkInterfaceId", cdk.validateString)(properties.networkInterfaceId)), errors.collect(cdk.propertyValidator("routeTableId", cdk.requiredValidator)(properties.routeTableId)), errors.collect(cdk.propertyValidator("routeTableId", cdk.validateString)(properties.routeTableId)), errors.collect(cdk.propertyValidator("transitGatewayId", cdk.validateString)(properties.transitGatewayId)), errors.collect(cdk.propertyValidator("vpcEndpointId", cdk.validateString)(properties.vpcEndpointId)), errors.collect(cdk.propertyValidator("vpcPeeringConnectionId", cdk.validateString)(properties.vpcPeeringConnectionId)), errors.wrap('supplied properties not correct for "CfnRouteProps"');
    }
    function cfnRoutePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoutePropsValidator(properties).assertSuccess(), { RouteTableId: cdk.stringToCloudFormation(properties.routeTableId), CarrierGatewayId: cdk.stringToCloudFormation(properties.carrierGatewayId), DestinationCidrBlock: cdk.stringToCloudFormation(properties.destinationCidrBlock), DestinationIpv6CidrBlock: cdk.stringToCloudFormation(properties.destinationIpv6CidrBlock), EgressOnlyInternetGatewayId: cdk.stringToCloudFormation(properties.egressOnlyInternetGatewayId), GatewayId: cdk.stringToCloudFormation(properties.gatewayId), InstanceId: cdk.stringToCloudFormation(properties.instanceId), LocalGatewayId: cdk.stringToCloudFormation(properties.localGatewayId), NatGatewayId: cdk.stringToCloudFormation(properties.natGatewayId), NetworkInterfaceId: cdk.stringToCloudFormation(properties.networkInterfaceId), TransitGatewayId: cdk.stringToCloudFormation(properties.transitGatewayId), VpcEndpointId: cdk.stringToCloudFormation(properties.vpcEndpointId), VpcPeeringConnectionId: cdk.stringToCloudFormation(properties.vpcPeeringConnectionId) }) : properties;
    }
    function CfnRoutePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("routeTableId", "RouteTableId", cfn_parse.FromCloudFormation.getString(properties.RouteTableId)), ret.addPropertyResult("carrierGatewayId", "CarrierGatewayId", properties.CarrierGatewayId != null ? cfn_parse.FromCloudFormation.getString(properties.CarrierGatewayId) : void 0), ret.addPropertyResult("destinationCidrBlock", "DestinationCidrBlock", properties.DestinationCidrBlock != null ? cfn_parse.FromCloudFormation.getString(properties.DestinationCidrBlock) : void 0), ret.addPropertyResult("destinationIpv6CidrBlock", "DestinationIpv6CidrBlock", properties.DestinationIpv6CidrBlock != null ? cfn_parse.FromCloudFormation.getString(properties.DestinationIpv6CidrBlock) : void 0), ret.addPropertyResult("egressOnlyInternetGatewayId", "EgressOnlyInternetGatewayId", properties.EgressOnlyInternetGatewayId != null ? cfn_parse.FromCloudFormation.getString(properties.EgressOnlyInternetGatewayId) : void 0), ret.addPropertyResult("gatewayId", "GatewayId", properties.GatewayId != null ? cfn_parse.FromCloudFormation.getString(properties.GatewayId) : void 0), ret.addPropertyResult("instanceId", "InstanceId", properties.InstanceId != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceId) : void 0), ret.addPropertyResult("localGatewayId", "LocalGatewayId", properties.LocalGatewayId != null ? cfn_parse.FromCloudFormation.getString(properties.LocalGatewayId) : void 0), ret.addPropertyResult("natGatewayId", "NatGatewayId", properties.NatGatewayId != null ? cfn_parse.FromCloudFormation.getString(properties.NatGatewayId) : void 0), ret.addPropertyResult("networkInterfaceId", "NetworkInterfaceId", properties.NetworkInterfaceId != null ? cfn_parse.FromCloudFormation.getString(properties.NetworkInterfaceId) : void 0), ret.addPropertyResult("transitGatewayId", "TransitGatewayId", properties.TransitGatewayId != null ? cfn_parse.FromCloudFormation.getString(properties.TransitGatewayId) : void 0), ret.addPropertyResult("vpcEndpointId", "VpcEndpointId", properties.VpcEndpointId != null ? cfn_parse.FromCloudFormation.getString(properties.VpcEndpointId) : void 0), ret.addPropertyResult("vpcPeeringConnectionId", "VpcPeeringConnectionId", properties.VpcPeeringConnectionId != null ? cfn_parse.FromCloudFormation.getString(properties.VpcPeeringConnectionId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRoute = class _CfnRoute extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRoutePropsFromCloudFormation(resourceProperties), ret = new _CfnRoute(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRoute.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnRouteProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRoute), error;
        }
        cdk.requireProperty(props, "routeTableId", this), this.routeTableId = props.routeTableId, this.carrierGatewayId = props.carrierGatewayId, this.destinationCidrBlock = props.destinationCidrBlock, this.destinationIpv6CidrBlock = props.destinationIpv6CidrBlock, this.egressOnlyInternetGatewayId = props.egressOnlyInternetGatewayId, this.gatewayId = props.gatewayId, this.instanceId = props.instanceId, this.localGatewayId = props.localGatewayId, this.natGatewayId = props.natGatewayId, this.networkInterfaceId = props.networkInterfaceId, this.transitGatewayId = props.transitGatewayId, this.vpcEndpointId = props.vpcEndpointId, this.vpcPeeringConnectionId = props.vpcPeeringConnectionId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRoute.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { routeTableId: this.routeTableId, carrierGatewayId: this.carrierGatewayId, destinationCidrBlock: this.destinationCidrBlock, destinationIpv6CidrBlock: this.destinationIpv6CidrBlock, egressOnlyInternetGatewayId: this.egressOnlyInternetGatewayId, gatewayId: this.gatewayId, instanceId: this.instanceId, localGatewayId: this.localGatewayId, natGatewayId: this.natGatewayId, networkInterfaceId: this.networkInterfaceId, transitGatewayId: this.transitGatewayId, vpcEndpointId: this.vpcEndpointId, vpcPeeringConnectionId: this.vpcPeeringConnectionId };
      }
      renderProperties(props) {
        return cfnRoutePropsToCloudFormation(props);
      }
    };
    _21 = JSII_RTTI_SYMBOL_1, CfnRoute[_21] = { fqn: "aws-cdk-lib.aws_ec2.CfnRoute", version: "2.80.0" }, CfnRoute.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::Route", exports2.CfnRoute = CfnRoute;
    function CfnRouteTablePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpcId", cdk.requiredValidator)(properties.vpcId)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "CfnRouteTableProps"');
    }
    function cfnRouteTablePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRouteTablePropsValidator(properties).assertSuccess(), { VpcId: cdk.stringToCloudFormation(properties.vpcId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnRouteTablePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("vpcId", "VpcId", cfn_parse.FromCloudFormation.getString(properties.VpcId)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRouteTable = class _CfnRouteTable extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRouteTablePropsFromCloudFormation(resourceProperties), ret = new _CfnRouteTable(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRouteTable.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnRouteTableProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRouteTable), error;
        }
        cdk.requireProperty(props, "vpcId", this), this.attrRouteTableId = cdk.Token.asString(this.getAtt("RouteTableId", cdk.ResolutionTypeHint.STRING)), this.vpcId = props.vpcId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::RouteTable", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRouteTable.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { vpcId: this.vpcId, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnRouteTablePropsToCloudFormation(props);
      }
    };
    _22 = JSII_RTTI_SYMBOL_1, CfnRouteTable[_22] = { fqn: "aws-cdk-lib.aws_ec2.CfnRouteTable", version: "2.80.0" }, CfnRouteTable.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::RouteTable", exports2.CfnRouteTable = CfnRouteTable;
    function CfnSecurityGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groupDescription", cdk.requiredValidator)(properties.groupDescription)), errors.collect(cdk.propertyValidator("groupDescription", cdk.validateString)(properties.groupDescription)), errors.collect(cdk.propertyValidator("groupName", cdk.validateString)(properties.groupName)), errors.collect(cdk.propertyValidator("securityGroupEgress", cdk.listValidator(CfnSecurityGroup_EgressPropertyValidator))(properties.securityGroupEgress)), errors.collect(cdk.propertyValidator("securityGroupIngress", cdk.listValidator(CfnSecurityGroup_IngressPropertyValidator))(properties.securityGroupIngress)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "CfnSecurityGroupProps"');
    }
    function cfnSecurityGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSecurityGroupPropsValidator(properties).assertSuccess(), { GroupDescription: cdk.stringToCloudFormation(properties.groupDescription), GroupName: cdk.stringToCloudFormation(properties.groupName), SecurityGroupEgress: cdk.listMapper(cfnSecurityGroupEgressPropertyToCloudFormation)(properties.securityGroupEgress), SecurityGroupIngress: cdk.listMapper(cfnSecurityGroupIngressPropertyToCloudFormation)(properties.securityGroupIngress), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VpcId: cdk.stringToCloudFormation(properties.vpcId) }) : properties;
    }
    function CfnSecurityGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupDescription", "GroupDescription", cfn_parse.FromCloudFormation.getString(properties.GroupDescription)), ret.addPropertyResult("groupName", "GroupName", properties.GroupName != null ? cfn_parse.FromCloudFormation.getString(properties.GroupName) : void 0), ret.addPropertyResult("securityGroupEgress", "SecurityGroupEgress", properties.SecurityGroupEgress != null ? cfn_parse.FromCloudFormation.getArray(CfnSecurityGroupEgressPropertyFromCloudFormation)(properties.SecurityGroupEgress) : void 0), ret.addPropertyResult("securityGroupIngress", "SecurityGroupIngress", properties.SecurityGroupIngress != null ? cfn_parse.FromCloudFormation.getArray(CfnSecurityGroupIngressPropertyFromCloudFormation)(properties.SecurityGroupIngress) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("vpcId", "VpcId", properties.VpcId != null ? cfn_parse.FromCloudFormation.getString(properties.VpcId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSecurityGroup = class _CfnSecurityGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSecurityGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnSecurityGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSecurityGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnSecurityGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSecurityGroup), error;
        }
        cdk.requireProperty(props, "groupDescription", this), this.attrGroupId = cdk.Token.asString(this.getAtt("GroupId", cdk.ResolutionTypeHint.STRING)), this.attrVpcId = cdk.Token.asString(this.getAtt("VpcId", cdk.ResolutionTypeHint.STRING)), this.groupDescription = props.groupDescription, this.groupName = props.groupName, this.securityGroupEgress = props.securityGroupEgress, this.securityGroupIngress = props.securityGroupIngress, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::SecurityGroup", props.tags, { tagPropertyName: "tags" }), this.vpcId = props.vpcId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSecurityGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { groupDescription: this.groupDescription, groupName: this.groupName, securityGroupEgress: this.securityGroupEgress, securityGroupIngress: this.securityGroupIngress, tags: this.tags.renderTags(), vpcId: this.vpcId };
      }
      renderProperties(props) {
        return cfnSecurityGroupPropsToCloudFormation(props);
      }
    };
    _23 = JSII_RTTI_SYMBOL_1, CfnSecurityGroup[_23] = { fqn: "aws-cdk-lib.aws_ec2.CfnSecurityGroup", version: "2.80.0" }, CfnSecurityGroup.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::SecurityGroup", exports2.CfnSecurityGroup = CfnSecurityGroup;
    function CfnSecurityGroup_EgressPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cidrIp", cdk.validateString)(properties.cidrIp)), errors.collect(cdk.propertyValidator("cidrIpv6", cdk.validateString)(properties.cidrIpv6)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("destinationPrefixListId", cdk.validateString)(properties.destinationPrefixListId)), errors.collect(cdk.propertyValidator("destinationSecurityGroupId", cdk.validateString)(properties.destinationSecurityGroupId)), errors.collect(cdk.propertyValidator("fromPort", cdk.validateNumber)(properties.fromPort)), errors.collect(cdk.propertyValidator("ipProtocol", cdk.requiredValidator)(properties.ipProtocol)), errors.collect(cdk.propertyValidator("ipProtocol", cdk.validateString)(properties.ipProtocol)), errors.collect(cdk.propertyValidator("toPort", cdk.validateNumber)(properties.toPort)), errors.wrap('supplied properties not correct for "EgressProperty"');
    }
    function cfnSecurityGroupEgressPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSecurityGroup_EgressPropertyValidator(properties).assertSuccess(), { CidrIp: cdk.stringToCloudFormation(properties.cidrIp), CidrIpv6: cdk.stringToCloudFormation(properties.cidrIpv6), Description: cdk.stringToCloudFormation(properties.description), DestinationPrefixListId: cdk.stringToCloudFormation(properties.destinationPrefixListId), DestinationSecurityGroupId: cdk.stringToCloudFormation(properties.destinationSecurityGroupId), FromPort: cdk.numberToCloudFormation(properties.fromPort), IpProtocol: cdk.stringToCloudFormation(properties.ipProtocol), ToPort: cdk.numberToCloudFormation(properties.toPort) }) : properties;
    }
    function CfnSecurityGroupEgressPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cidrIp", "CidrIp", properties.CidrIp != null ? cfn_parse.FromCloudFormation.getString(properties.CidrIp) : void 0), ret.addPropertyResult("cidrIpv6", "CidrIpv6", properties.CidrIpv6 != null ? cfn_parse.FromCloudFormation.getString(properties.CidrIpv6) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("destinationPrefixListId", "DestinationPrefixListId", properties.DestinationPrefixListId != null ? cfn_parse.FromCloudFormation.getString(properties.DestinationPrefixListId) : void 0), ret.addPropertyResult("destinationSecurityGroupId", "DestinationSecurityGroupId", properties.DestinationSecurityGroupId != null ? cfn_parse.FromCloudFormation.getString(properties.DestinationSecurityGroupId) : void 0), ret.addPropertyResult("fromPort", "FromPort", properties.FromPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.FromPort) : void 0), ret.addPropertyResult("ipProtocol", "IpProtocol", cfn_parse.FromCloudFormation.getString(properties.IpProtocol)), ret.addPropertyResult("toPort", "ToPort", properties.ToPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.ToPort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSecurityGroup_IngressPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cidrIp", cdk.validateString)(properties.cidrIp)), errors.collect(cdk.propertyValidator("cidrIpv6", cdk.validateString)(properties.cidrIpv6)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("fromPort", cdk.validateNumber)(properties.fromPort)), errors.collect(cdk.propertyValidator("ipProtocol", cdk.requiredValidator)(properties.ipProtocol)), errors.collect(cdk.propertyValidator("ipProtocol", cdk.validateString)(properties.ipProtocol)), errors.collect(cdk.propertyValidator("sourcePrefixListId", cdk.validateString)(properties.sourcePrefixListId)), errors.collect(cdk.propertyValidator("sourceSecurityGroupId", cdk.validateString)(properties.sourceSecurityGroupId)), errors.collect(cdk.propertyValidator("sourceSecurityGroupName", cdk.validateString)(properties.sourceSecurityGroupName)), errors.collect(cdk.propertyValidator("sourceSecurityGroupOwnerId", cdk.validateString)(properties.sourceSecurityGroupOwnerId)), errors.collect(cdk.propertyValidator("toPort", cdk.validateNumber)(properties.toPort)), errors.wrap('supplied properties not correct for "IngressProperty"');
    }
    function cfnSecurityGroupIngressPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSecurityGroup_IngressPropertyValidator(properties).assertSuccess(), { CidrIp: cdk.stringToCloudFormation(properties.cidrIp), CidrIpv6: cdk.stringToCloudFormation(properties.cidrIpv6), Description: cdk.stringToCloudFormation(properties.description), FromPort: cdk.numberToCloudFormation(properties.fromPort), IpProtocol: cdk.stringToCloudFormation(properties.ipProtocol), SourcePrefixListId: cdk.stringToCloudFormation(properties.sourcePrefixListId), SourceSecurityGroupId: cdk.stringToCloudFormation(properties.sourceSecurityGroupId), SourceSecurityGroupName: cdk.stringToCloudFormation(properties.sourceSecurityGroupName), SourceSecurityGroupOwnerId: cdk.stringToCloudFormation(properties.sourceSecurityGroupOwnerId), ToPort: cdk.numberToCloudFormation(properties.toPort) }) : properties;
    }
    function CfnSecurityGroupIngressPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cidrIp", "CidrIp", properties.CidrIp != null ? cfn_parse.FromCloudFormation.getString(properties.CidrIp) : void 0), ret.addPropertyResult("cidrIpv6", "CidrIpv6", properties.CidrIpv6 != null ? cfn_parse.FromCloudFormation.getString(properties.CidrIpv6) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("fromPort", "FromPort", properties.FromPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.FromPort) : void 0), ret.addPropertyResult("ipProtocol", "IpProtocol", cfn_parse.FromCloudFormation.getString(properties.IpProtocol)), ret.addPropertyResult("sourcePrefixListId", "SourcePrefixListId", properties.SourcePrefixListId != null ? cfn_parse.FromCloudFormation.getString(properties.SourcePrefixListId) : void 0), ret.addPropertyResult("sourceSecurityGroupId", "SourceSecurityGroupId", properties.SourceSecurityGroupId != null ? cfn_parse.FromCloudFormation.getString(properties.SourceSecurityGroupId) : void 0), ret.addPropertyResult("sourceSecurityGroupName", "SourceSecurityGroupName", properties.SourceSecurityGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.SourceSecurityGroupName) : void 0), ret.addPropertyResult("sourceSecurityGroupOwnerId", "SourceSecurityGroupOwnerId", properties.SourceSecurityGroupOwnerId != null ? cfn_parse.FromCloudFormation.getString(properties.SourceSecurityGroupOwnerId) : void 0), ret.addPropertyResult("toPort", "ToPort", properties.ToPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.ToPort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSecurityGroupEgressPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cidrIp", cdk.validateString)(properties.cidrIp)), errors.collect(cdk.propertyValidator("cidrIpv6", cdk.validateString)(properties.cidrIpv6)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("destinationPrefixListId", cdk.validateString)(properties.destinationPrefixListId)), errors.collect(cdk.propertyValidator("destinationSecurityGroupId", cdk.validateString)(properties.destinationSecurityGroupId)), errors.collect(cdk.propertyValidator("fromPort", cdk.validateNumber)(properties.fromPort)), errors.collect(cdk.propertyValidator("groupId", cdk.requiredValidator)(properties.groupId)), errors.collect(cdk.propertyValidator("groupId", cdk.validateString)(properties.groupId)), errors.collect(cdk.propertyValidator("ipProtocol", cdk.requiredValidator)(properties.ipProtocol)), errors.collect(cdk.propertyValidator("ipProtocol", cdk.validateString)(properties.ipProtocol)), errors.collect(cdk.propertyValidator("toPort", cdk.validateNumber)(properties.toPort)), errors.wrap('supplied properties not correct for "CfnSecurityGroupEgressProps"');
    }
    function cfnSecurityGroupEgressPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSecurityGroupEgressPropsValidator(properties).assertSuccess(), { GroupId: cdk.stringToCloudFormation(properties.groupId), IpProtocol: cdk.stringToCloudFormation(properties.ipProtocol), CidrIp: cdk.stringToCloudFormation(properties.cidrIp), CidrIpv6: cdk.stringToCloudFormation(properties.cidrIpv6), Description: cdk.stringToCloudFormation(properties.description), DestinationPrefixListId: cdk.stringToCloudFormation(properties.destinationPrefixListId), DestinationSecurityGroupId: cdk.stringToCloudFormation(properties.destinationSecurityGroupId), FromPort: cdk.numberToCloudFormation(properties.fromPort), ToPort: cdk.numberToCloudFormation(properties.toPort) }) : properties;
    }
    function CfnSecurityGroupEgressPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupId", "GroupId", cfn_parse.FromCloudFormation.getString(properties.GroupId)), ret.addPropertyResult("ipProtocol", "IpProtocol", cfn_parse.FromCloudFormation.getString(properties.IpProtocol)), ret.addPropertyResult("cidrIp", "CidrIp", properties.CidrIp != null ? cfn_parse.FromCloudFormation.getString(properties.CidrIp) : void 0), ret.addPropertyResult("cidrIpv6", "CidrIpv6", properties.CidrIpv6 != null ? cfn_parse.FromCloudFormation.getString(properties.CidrIpv6) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("destinationPrefixListId", "DestinationPrefixListId", properties.DestinationPrefixListId != null ? cfn_parse.FromCloudFormation.getString(properties.DestinationPrefixListId) : void 0), ret.addPropertyResult("destinationSecurityGroupId", "DestinationSecurityGroupId", properties.DestinationSecurityGroupId != null ? cfn_parse.FromCloudFormation.getString(properties.DestinationSecurityGroupId) : void 0), ret.addPropertyResult("fromPort", "FromPort", properties.FromPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.FromPort) : void 0), ret.addPropertyResult("toPort", "ToPort", properties.ToPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.ToPort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSecurityGroupEgress = class _CfnSecurityGroupEgress extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSecurityGroupEgressPropsFromCloudFormation(resourceProperties), ret = new _CfnSecurityGroupEgress(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSecurityGroupEgress.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnSecurityGroupEgressProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSecurityGroupEgress), error;
        }
        cdk.requireProperty(props, "groupId", this), cdk.requireProperty(props, "ipProtocol", this), this.groupId = props.groupId, this.ipProtocol = props.ipProtocol, this.cidrIp = props.cidrIp, this.cidrIpv6 = props.cidrIpv6, this.description = props.description, this.destinationPrefixListId = props.destinationPrefixListId, this.destinationSecurityGroupId = props.destinationSecurityGroupId, this.fromPort = props.fromPort, this.toPort = props.toPort;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSecurityGroupEgress.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { groupId: this.groupId, ipProtocol: this.ipProtocol, cidrIp: this.cidrIp, cidrIpv6: this.cidrIpv6, description: this.description, destinationPrefixListId: this.destinationPrefixListId, destinationSecurityGroupId: this.destinationSecurityGroupId, fromPort: this.fromPort, toPort: this.toPort };
      }
      renderProperties(props) {
        return cfnSecurityGroupEgressPropsToCloudFormation(props);
      }
    };
    _24 = JSII_RTTI_SYMBOL_1, CfnSecurityGroupEgress[_24] = { fqn: "aws-cdk-lib.aws_ec2.CfnSecurityGroupEgress", version: "2.80.0" }, CfnSecurityGroupEgress.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::SecurityGroupEgress", exports2.CfnSecurityGroupEgress = CfnSecurityGroupEgress;
    function CfnSecurityGroupIngressPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cidrIp", cdk.validateString)(properties.cidrIp)), errors.collect(cdk.propertyValidator("cidrIpv6", cdk.validateString)(properties.cidrIpv6)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("fromPort", cdk.validateNumber)(properties.fromPort)), errors.collect(cdk.propertyValidator("groupId", cdk.validateString)(properties.groupId)), errors.collect(cdk.propertyValidator("groupName", cdk.validateString)(properties.groupName)), errors.collect(cdk.propertyValidator("ipProtocol", cdk.requiredValidator)(properties.ipProtocol)), errors.collect(cdk.propertyValidator("ipProtocol", cdk.validateString)(properties.ipProtocol)), errors.collect(cdk.propertyValidator("sourcePrefixListId", cdk.validateString)(properties.sourcePrefixListId)), errors.collect(cdk.propertyValidator("sourceSecurityGroupId", cdk.validateString)(properties.sourceSecurityGroupId)), errors.collect(cdk.propertyValidator("sourceSecurityGroupName", cdk.validateString)(properties.sourceSecurityGroupName)), errors.collect(cdk.propertyValidator("sourceSecurityGroupOwnerId", cdk.validateString)(properties.sourceSecurityGroupOwnerId)), errors.collect(cdk.propertyValidator("toPort", cdk.validateNumber)(properties.toPort)), errors.wrap('supplied properties not correct for "CfnSecurityGroupIngressProps"');
    }
    function cfnSecurityGroupIngressPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSecurityGroupIngressPropsValidator(properties).assertSuccess(), { IpProtocol: cdk.stringToCloudFormation(properties.ipProtocol), CidrIp: cdk.stringToCloudFormation(properties.cidrIp), CidrIpv6: cdk.stringToCloudFormation(properties.cidrIpv6), Description: cdk.stringToCloudFormation(properties.description), FromPort: cdk.numberToCloudFormation(properties.fromPort), GroupId: cdk.stringToCloudFormation(properties.groupId), GroupName: cdk.stringToCloudFormation(properties.groupName), SourcePrefixListId: cdk.stringToCloudFormation(properties.sourcePrefixListId), SourceSecurityGroupId: cdk.stringToCloudFormation(properties.sourceSecurityGroupId), SourceSecurityGroupName: cdk.stringToCloudFormation(properties.sourceSecurityGroupName), SourceSecurityGroupOwnerId: cdk.stringToCloudFormation(properties.sourceSecurityGroupOwnerId), ToPort: cdk.numberToCloudFormation(properties.toPort) }) : properties;
    }
    function CfnSecurityGroupIngressPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ipProtocol", "IpProtocol", cfn_parse.FromCloudFormation.getString(properties.IpProtocol)), ret.addPropertyResult("cidrIp", "CidrIp", properties.CidrIp != null ? cfn_parse.FromCloudFormation.getString(properties.CidrIp) : void 0), ret.addPropertyResult("cidrIpv6", "CidrIpv6", properties.CidrIpv6 != null ? cfn_parse.FromCloudFormation.getString(properties.CidrIpv6) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("fromPort", "FromPort", properties.FromPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.FromPort) : void 0), ret.addPropertyResult("groupId", "GroupId", properties.GroupId != null ? cfn_parse.FromCloudFormation.getString(properties.GroupId) : void 0), ret.addPropertyResult("groupName", "GroupName", properties.GroupName != null ? cfn_parse.FromCloudFormation.getString(properties.GroupName) : void 0), ret.addPropertyResult("sourcePrefixListId", "SourcePrefixListId", properties.SourcePrefixListId != null ? cfn_parse.FromCloudFormation.getString(properties.SourcePrefixListId) : void 0), ret.addPropertyResult("sourceSecurityGroupId", "SourceSecurityGroupId", properties.SourceSecurityGroupId != null ? cfn_parse.FromCloudFormation.getString(properties.SourceSecurityGroupId) : void 0), ret.addPropertyResult("sourceSecurityGroupName", "SourceSecurityGroupName", properties.SourceSecurityGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.SourceSecurityGroupName) : void 0), ret.addPropertyResult("sourceSecurityGroupOwnerId", "SourceSecurityGroupOwnerId", properties.SourceSecurityGroupOwnerId != null ? cfn_parse.FromCloudFormation.getString(properties.SourceSecurityGroupOwnerId) : void 0), ret.addPropertyResult("toPort", "ToPort", properties.ToPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.ToPort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSecurityGroupIngress = class _CfnSecurityGroupIngress extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSecurityGroupIngressPropsFromCloudFormation(resourceProperties), ret = new _CfnSecurityGroupIngress(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSecurityGroupIngress.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnSecurityGroupIngressProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSecurityGroupIngress), error;
        }
        cdk.requireProperty(props, "ipProtocol", this), this.ipProtocol = props.ipProtocol, this.cidrIp = props.cidrIp, this.cidrIpv6 = props.cidrIpv6, this.description = props.description, this.fromPort = props.fromPort, this.groupId = props.groupId, this.groupName = props.groupName, this.sourcePrefixListId = props.sourcePrefixListId, this.sourceSecurityGroupId = props.sourceSecurityGroupId, this.sourceSecurityGroupName = props.sourceSecurityGroupName, this.sourceSecurityGroupOwnerId = props.sourceSecurityGroupOwnerId, this.toPort = props.toPort;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSecurityGroupIngress.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { ipProtocol: this.ipProtocol, cidrIp: this.cidrIp, cidrIpv6: this.cidrIpv6, description: this.description, fromPort: this.fromPort, groupId: this.groupId, groupName: this.groupName, sourcePrefixListId: this.sourcePrefixListId, sourceSecurityGroupId: this.sourceSecurityGroupId, sourceSecurityGroupName: this.sourceSecurityGroupName, sourceSecurityGroupOwnerId: this.sourceSecurityGroupOwnerId, toPort: this.toPort };
      }
      renderProperties(props) {
        return cfnSecurityGroupIngressPropsToCloudFormation(props);
      }
    };
    _25 = JSII_RTTI_SYMBOL_1, CfnSecurityGroupIngress[_25] = { fqn: "aws-cdk-lib.aws_ec2.CfnSecurityGroupIngress", version: "2.80.0" }, CfnSecurityGroupIngress.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::SecurityGroupIngress", exports2.CfnSecurityGroupIngress = CfnSecurityGroupIngress;
    function CfnSpotFleetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("spotFleetRequestConfigData", cdk.requiredValidator)(properties.spotFleetRequestConfigData)), errors.collect(cdk.propertyValidator("spotFleetRequestConfigData", CfnSpotFleet_SpotFleetRequestConfigDataPropertyValidator)(properties.spotFleetRequestConfigData)), errors.wrap('supplied properties not correct for "CfnSpotFleetProps"');
    }
    function cfnSpotFleetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleetPropsValidator(properties).assertSuccess(), { SpotFleetRequestConfigData: cfnSpotFleetSpotFleetRequestConfigDataPropertyToCloudFormation(properties.spotFleetRequestConfigData) }) : properties;
    }
    function CfnSpotFleetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("spotFleetRequestConfigData", "SpotFleetRequestConfigData", CfnSpotFleetSpotFleetRequestConfigDataPropertyFromCloudFormation(properties.SpotFleetRequestConfigData)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSpotFleet = class _CfnSpotFleet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSpotFleetPropsFromCloudFormation(resourceProperties), ret = new _CfnSpotFleet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSpotFleet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnSpotFleetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSpotFleet), error;
        }
        cdk.requireProperty(props, "spotFleetRequestConfigData", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.spotFleetRequestConfigData = props.spotFleetRequestConfigData;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSpotFleet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { spotFleetRequestConfigData: this.spotFleetRequestConfigData };
      }
      renderProperties(props) {
        return cfnSpotFleetPropsToCloudFormation(props);
      }
    };
    _26 = JSII_RTTI_SYMBOL_1, CfnSpotFleet[_26] = { fqn: "aws-cdk-lib.aws_ec2.CfnSpotFleet", version: "2.80.0" }, CfnSpotFleet.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::SpotFleet", exports2.CfnSpotFleet = CfnSpotFleet;
    function CfnSpotFleet_AcceleratorCountRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "AcceleratorCountRequestProperty"');
    }
    function cfnSpotFleetAcceleratorCountRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_AcceleratorCountRequestPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnSpotFleetAcceleratorCountRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpotFleet_AcceleratorTotalMemoryMiBRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "AcceleratorTotalMemoryMiBRequestProperty"');
    }
    function cfnSpotFleetAcceleratorTotalMemoryMiBRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_AcceleratorTotalMemoryMiBRequestPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnSpotFleetAcceleratorTotalMemoryMiBRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpotFleet_BaselineEbsBandwidthMbpsRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "BaselineEbsBandwidthMbpsRequestProperty"');
    }
    function cfnSpotFleetBaselineEbsBandwidthMbpsRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_BaselineEbsBandwidthMbpsRequestPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnSpotFleetBaselineEbsBandwidthMbpsRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpotFleet_BlockDeviceMappingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deviceName", cdk.requiredValidator)(properties.deviceName)), errors.collect(cdk.propertyValidator("deviceName", cdk.validateString)(properties.deviceName)), errors.collect(cdk.propertyValidator("ebs", CfnSpotFleet_EbsBlockDevicePropertyValidator)(properties.ebs)), errors.collect(cdk.propertyValidator("noDevice", cdk.validateString)(properties.noDevice)), errors.collect(cdk.propertyValidator("virtualName", cdk.validateString)(properties.virtualName)), errors.wrap('supplied properties not correct for "BlockDeviceMappingProperty"');
    }
    function cfnSpotFleetBlockDeviceMappingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_BlockDeviceMappingPropertyValidator(properties).assertSuccess(), { DeviceName: cdk.stringToCloudFormation(properties.deviceName), Ebs: cfnSpotFleetEbsBlockDevicePropertyToCloudFormation(properties.ebs), NoDevice: cdk.stringToCloudFormation(properties.noDevice), VirtualName: cdk.stringToCloudFormation(properties.virtualName) }) : properties;
    }
    function CfnSpotFleetBlockDeviceMappingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deviceName", "DeviceName", cfn_parse.FromCloudFormation.getString(properties.DeviceName)), ret.addPropertyResult("ebs", "Ebs", properties.Ebs != null ? CfnSpotFleetEbsBlockDevicePropertyFromCloudFormation(properties.Ebs) : void 0), ret.addPropertyResult("noDevice", "NoDevice", properties.NoDevice != null ? cfn_parse.FromCloudFormation.getString(properties.NoDevice) : void 0), ret.addPropertyResult("virtualName", "VirtualName", properties.VirtualName != null ? cfn_parse.FromCloudFormation.getString(properties.VirtualName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpotFleet_ClassicLoadBalancerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "ClassicLoadBalancerProperty"');
    }
    function cfnSpotFleetClassicLoadBalancerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_ClassicLoadBalancerPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnSpotFleetClassicLoadBalancerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpotFleet_ClassicLoadBalancersConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("classicLoadBalancers", cdk.requiredValidator)(properties.classicLoadBalancers)), errors.collect(cdk.propertyValidator("classicLoadBalancers", cdk.listValidator(CfnSpotFleet_ClassicLoadBalancerPropertyValidator))(properties.classicLoadBalancers)), errors.wrap('supplied properties not correct for "ClassicLoadBalancersConfigProperty"');
    }
    function cfnSpotFleetClassicLoadBalancersConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_ClassicLoadBalancersConfigPropertyValidator(properties).assertSuccess(), { ClassicLoadBalancers: cdk.listMapper(cfnSpotFleetClassicLoadBalancerPropertyToCloudFormation)(properties.classicLoadBalancers) }) : properties;
    }
    function CfnSpotFleetClassicLoadBalancersConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("classicLoadBalancers", "ClassicLoadBalancers", cfn_parse.FromCloudFormation.getArray(CfnSpotFleetClassicLoadBalancerPropertyFromCloudFormation)(properties.ClassicLoadBalancers)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpotFleet_EbsBlockDevicePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deleteOnTermination", cdk.validateBoolean)(properties.deleteOnTermination)), errors.collect(cdk.propertyValidator("encrypted", cdk.validateBoolean)(properties.encrypted)), errors.collect(cdk.propertyValidator("iops", cdk.validateNumber)(properties.iops)), errors.collect(cdk.propertyValidator("snapshotId", cdk.validateString)(properties.snapshotId)), errors.collect(cdk.propertyValidator("volumeSize", cdk.validateNumber)(properties.volumeSize)), errors.collect(cdk.propertyValidator("volumeType", cdk.validateString)(properties.volumeType)), errors.wrap('supplied properties not correct for "EbsBlockDeviceProperty"');
    }
    function cfnSpotFleetEbsBlockDevicePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_EbsBlockDevicePropertyValidator(properties).assertSuccess(), { DeleteOnTermination: cdk.booleanToCloudFormation(properties.deleteOnTermination), Encrypted: cdk.booleanToCloudFormation(properties.encrypted), Iops: cdk.numberToCloudFormation(properties.iops), SnapshotId: cdk.stringToCloudFormation(properties.snapshotId), VolumeSize: cdk.numberToCloudFormation(properties.volumeSize), VolumeType: cdk.stringToCloudFormation(properties.volumeType) }) : properties;
    }
    function CfnSpotFleetEbsBlockDevicePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deleteOnTermination", "DeleteOnTermination", properties.DeleteOnTermination != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeleteOnTermination) : void 0), ret.addPropertyResult("encrypted", "Encrypted", properties.Encrypted != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Encrypted) : void 0), ret.addPropertyResult("iops", "Iops", properties.Iops != null ? cfn_parse.FromCloudFormation.getNumber(properties.Iops) : void 0), ret.addPropertyResult("snapshotId", "SnapshotId", properties.SnapshotId != null ? cfn_parse.FromCloudFormation.getString(properties.SnapshotId) : void 0), ret.addPropertyResult("volumeSize", "VolumeSize", properties.VolumeSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.VolumeSize) : void 0), ret.addPropertyResult("volumeType", "VolumeType", properties.VolumeType != null ? cfn_parse.FromCloudFormation.getString(properties.VolumeType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpotFleet_FleetLaunchTemplateSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("launchTemplateId", cdk.validateString)(properties.launchTemplateId)), errors.collect(cdk.propertyValidator("launchTemplateName", cdk.validateString)(properties.launchTemplateName)), errors.collect(cdk.propertyValidator("version", cdk.requiredValidator)(properties.version)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "FleetLaunchTemplateSpecificationProperty"');
    }
    function cfnSpotFleetFleetLaunchTemplateSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_FleetLaunchTemplateSpecificationPropertyValidator(properties).assertSuccess(), { LaunchTemplateId: cdk.stringToCloudFormation(properties.launchTemplateId), LaunchTemplateName: cdk.stringToCloudFormation(properties.launchTemplateName), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnSpotFleetFleetLaunchTemplateSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("launchTemplateId", "LaunchTemplateId", properties.LaunchTemplateId != null ? cfn_parse.FromCloudFormation.getString(properties.LaunchTemplateId) : void 0), ret.addPropertyResult("launchTemplateName", "LaunchTemplateName", properties.LaunchTemplateName != null ? cfn_parse.FromCloudFormation.getString(properties.LaunchTemplateName) : void 0), ret.addPropertyResult("version", "Version", cfn_parse.FromCloudFormation.getString(properties.Version)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpotFleet_GroupIdentifierPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groupId", cdk.requiredValidator)(properties.groupId)), errors.collect(cdk.propertyValidator("groupId", cdk.validateString)(properties.groupId)), errors.wrap('supplied properties not correct for "GroupIdentifierProperty"');
    }
    function cfnSpotFleetGroupIdentifierPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_GroupIdentifierPropertyValidator(properties).assertSuccess(), { GroupId: cdk.stringToCloudFormation(properties.groupId) }) : properties;
    }
    function CfnSpotFleetGroupIdentifierPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupId", "GroupId", cfn_parse.FromCloudFormation.getString(properties.GroupId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpotFleet_IamInstanceProfileSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.wrap('supplied properties not correct for "IamInstanceProfileSpecificationProperty"');
    }
    function cfnSpotFleetIamInstanceProfileSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_IamInstanceProfileSpecificationPropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn) }) : properties;
    }
    function CfnSpotFleetIamInstanceProfileSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", properties.Arn != null ? cfn_parse.FromCloudFormation.getString(properties.Arn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpotFleet_InstanceIpv6AddressPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ipv6Address", cdk.requiredValidator)(properties.ipv6Address)), errors.collect(cdk.propertyValidator("ipv6Address", cdk.validateString)(properties.ipv6Address)), errors.wrap('supplied properties not correct for "InstanceIpv6AddressProperty"');
    }
    function cfnSpotFleetInstanceIpv6AddressPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_InstanceIpv6AddressPropertyValidator(properties).assertSuccess(), { Ipv6Address: cdk.stringToCloudFormation(properties.ipv6Address) }) : properties;
    }
    function CfnSpotFleetInstanceIpv6AddressPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ipv6Address", "Ipv6Address", cfn_parse.FromCloudFormation.getString(properties.Ipv6Address)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpotFleet_InstanceNetworkInterfaceSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("associatePublicIpAddress", cdk.validateBoolean)(properties.associatePublicIpAddress)), errors.collect(cdk.propertyValidator("deleteOnTermination", cdk.validateBoolean)(properties.deleteOnTermination)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("deviceIndex", cdk.validateNumber)(properties.deviceIndex)), errors.collect(cdk.propertyValidator("groups", cdk.listValidator(cdk.validateString))(properties.groups)), errors.collect(cdk.propertyValidator("ipv6AddressCount", cdk.validateNumber)(properties.ipv6AddressCount)), errors.collect(cdk.propertyValidator("ipv6Addresses", cdk.listValidator(CfnSpotFleet_InstanceIpv6AddressPropertyValidator))(properties.ipv6Addresses)), errors.collect(cdk.propertyValidator("networkInterfaceId", cdk.validateString)(properties.networkInterfaceId)), errors.collect(cdk.propertyValidator("privateIpAddresses", cdk.listValidator(CfnSpotFleet_PrivateIpAddressSpecificationPropertyValidator))(properties.privateIpAddresses)), errors.collect(cdk.propertyValidator("secondaryPrivateIpAddressCount", cdk.validateNumber)(properties.secondaryPrivateIpAddressCount)), errors.collect(cdk.propertyValidator("subnetId", cdk.validateString)(properties.subnetId)), errors.wrap('supplied properties not correct for "InstanceNetworkInterfaceSpecificationProperty"');
    }
    function cfnSpotFleetInstanceNetworkInterfaceSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_InstanceNetworkInterfaceSpecificationPropertyValidator(properties).assertSuccess(), { AssociatePublicIpAddress: cdk.booleanToCloudFormation(properties.associatePublicIpAddress), DeleteOnTermination: cdk.booleanToCloudFormation(properties.deleteOnTermination), Description: cdk.stringToCloudFormation(properties.description), DeviceIndex: cdk.numberToCloudFormation(properties.deviceIndex), Groups: cdk.listMapper(cdk.stringToCloudFormation)(properties.groups), Ipv6AddressCount: cdk.numberToCloudFormation(properties.ipv6AddressCount), Ipv6Addresses: cdk.listMapper(cfnSpotFleetInstanceIpv6AddressPropertyToCloudFormation)(properties.ipv6Addresses), NetworkInterfaceId: cdk.stringToCloudFormation(properties.networkInterfaceId), PrivateIpAddresses: cdk.listMapper(cfnSpotFleetPrivateIpAddressSpecificationPropertyToCloudFormation)(properties.privateIpAddresses), SecondaryPrivateIpAddressCount: cdk.numberToCloudFormation(properties.secondaryPrivateIpAddressCount), SubnetId: cdk.stringToCloudFormation(properties.subnetId) }) : properties;
    }
    function CfnSpotFleetInstanceNetworkInterfaceSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("associatePublicIpAddress", "AssociatePublicIpAddress", properties.AssociatePublicIpAddress != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AssociatePublicIpAddress) : void 0), ret.addPropertyResult("deleteOnTermination", "DeleteOnTermination", properties.DeleteOnTermination != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeleteOnTermination) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("deviceIndex", "DeviceIndex", properties.DeviceIndex != null ? cfn_parse.FromCloudFormation.getNumber(properties.DeviceIndex) : void 0), ret.addPropertyResult("groups", "Groups", properties.Groups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Groups) : void 0), ret.addPropertyResult("ipv6AddressCount", "Ipv6AddressCount", properties.Ipv6AddressCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.Ipv6AddressCount) : void 0), ret.addPropertyResult("ipv6Addresses", "Ipv6Addresses", properties.Ipv6Addresses != null ? cfn_parse.FromCloudFormation.getArray(CfnSpotFleetInstanceIpv6AddressPropertyFromCloudFormation)(properties.Ipv6Addresses) : void 0), ret.addPropertyResult("networkInterfaceId", "NetworkInterfaceId", properties.NetworkInterfaceId != null ? cfn_parse.FromCloudFormation.getString(properties.NetworkInterfaceId) : void 0), ret.addPropertyResult("privateIpAddresses", "PrivateIpAddresses", properties.PrivateIpAddresses != null ? cfn_parse.FromCloudFormation.getArray(CfnSpotFleetPrivateIpAddressSpecificationPropertyFromCloudFormation)(properties.PrivateIpAddresses) : void 0), ret.addPropertyResult("secondaryPrivateIpAddressCount", "SecondaryPrivateIpAddressCount", properties.SecondaryPrivateIpAddressCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.SecondaryPrivateIpAddressCount) : void 0), ret.addPropertyResult("subnetId", "SubnetId", properties.SubnetId != null ? cfn_parse.FromCloudFormation.getString(properties.SubnetId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpotFleet_InstanceRequirementsRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acceleratorCount", CfnSpotFleet_AcceleratorCountRequestPropertyValidator)(properties.acceleratorCount)), errors.collect(cdk.propertyValidator("acceleratorManufacturers", cdk.listValidator(cdk.validateString))(properties.acceleratorManufacturers)), errors.collect(cdk.propertyValidator("acceleratorNames", cdk.listValidator(cdk.validateString))(properties.acceleratorNames)), errors.collect(cdk.propertyValidator("acceleratorTotalMemoryMiB", CfnSpotFleet_AcceleratorTotalMemoryMiBRequestPropertyValidator)(properties.acceleratorTotalMemoryMiB)), errors.collect(cdk.propertyValidator("acceleratorTypes", cdk.listValidator(cdk.validateString))(properties.acceleratorTypes)), errors.collect(cdk.propertyValidator("allowedInstanceTypes", cdk.listValidator(cdk.validateString))(properties.allowedInstanceTypes)), errors.collect(cdk.propertyValidator("bareMetal", cdk.validateString)(properties.bareMetal)), errors.collect(cdk.propertyValidator("baselineEbsBandwidthMbps", CfnSpotFleet_BaselineEbsBandwidthMbpsRequestPropertyValidator)(properties.baselineEbsBandwidthMbps)), errors.collect(cdk.propertyValidator("burstablePerformance", cdk.validateString)(properties.burstablePerformance)), errors.collect(cdk.propertyValidator("cpuManufacturers", cdk.listValidator(cdk.validateString))(properties.cpuManufacturers)), errors.collect(cdk.propertyValidator("excludedInstanceTypes", cdk.listValidator(cdk.validateString))(properties.excludedInstanceTypes)), errors.collect(cdk.propertyValidator("instanceGenerations", cdk.listValidator(cdk.validateString))(properties.instanceGenerations)), errors.collect(cdk.propertyValidator("localStorage", cdk.validateString)(properties.localStorage)), errors.collect(cdk.propertyValidator("localStorageTypes", cdk.listValidator(cdk.validateString))(properties.localStorageTypes)), errors.collect(cdk.propertyValidator("memoryGiBPerVCpu", CfnSpotFleet_MemoryGiBPerVCpuRequestPropertyValidator)(properties.memoryGiBPerVCpu)), errors.collect(cdk.propertyValidator("memoryMiB", CfnSpotFleet_MemoryMiBRequestPropertyValidator)(properties.memoryMiB)), errors.collect(cdk.propertyValidator("networkBandwidthGbps", CfnSpotFleet_NetworkBandwidthGbpsRequestPropertyValidator)(properties.networkBandwidthGbps)), errors.collect(cdk.propertyValidator("networkInterfaceCount", CfnSpotFleet_NetworkInterfaceCountRequestPropertyValidator)(properties.networkInterfaceCount)), errors.collect(cdk.propertyValidator("onDemandMaxPricePercentageOverLowestPrice", cdk.validateNumber)(properties.onDemandMaxPricePercentageOverLowestPrice)), errors.collect(cdk.propertyValidator("requireHibernateSupport", cdk.validateBoolean)(properties.requireHibernateSupport)), errors.collect(cdk.propertyValidator("spotMaxPricePercentageOverLowestPrice", cdk.validateNumber)(properties.spotMaxPricePercentageOverLowestPrice)), errors.collect(cdk.propertyValidator("totalLocalStorageGb", CfnSpotFleet_TotalLocalStorageGBRequestPropertyValidator)(properties.totalLocalStorageGb)), errors.collect(cdk.propertyValidator("vCpuCount", CfnSpotFleet_VCpuCountRangeRequestPropertyValidator)(properties.vCpuCount)), errors.wrap('supplied properties not correct for "InstanceRequirementsRequestProperty"');
    }
    function cfnSpotFleetInstanceRequirementsRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_InstanceRequirementsRequestPropertyValidator(properties).assertSuccess(), { AcceleratorCount: cfnSpotFleetAcceleratorCountRequestPropertyToCloudFormation(properties.acceleratorCount), AcceleratorManufacturers: cdk.listMapper(cdk.stringToCloudFormation)(properties.acceleratorManufacturers), AcceleratorNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.acceleratorNames), AcceleratorTotalMemoryMiB: cfnSpotFleetAcceleratorTotalMemoryMiBRequestPropertyToCloudFormation(properties.acceleratorTotalMemoryMiB), AcceleratorTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.acceleratorTypes), AllowedInstanceTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowedInstanceTypes), BareMetal: cdk.stringToCloudFormation(properties.bareMetal), BaselineEbsBandwidthMbps: cfnSpotFleetBaselineEbsBandwidthMbpsRequestPropertyToCloudFormation(properties.baselineEbsBandwidthMbps), BurstablePerformance: cdk.stringToCloudFormation(properties.burstablePerformance), CpuManufacturers: cdk.listMapper(cdk.stringToCloudFormation)(properties.cpuManufacturers), ExcludedInstanceTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.excludedInstanceTypes), InstanceGenerations: cdk.listMapper(cdk.stringToCloudFormation)(properties.instanceGenerations), LocalStorage: cdk.stringToCloudFormation(properties.localStorage), LocalStorageTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.localStorageTypes), MemoryGiBPerVCpu: cfnSpotFleetMemoryGiBPerVCpuRequestPropertyToCloudFormation(properties.memoryGiBPerVCpu), MemoryMiB: cfnSpotFleetMemoryMiBRequestPropertyToCloudFormation(properties.memoryMiB), NetworkBandwidthGbps: cfnSpotFleetNetworkBandwidthGbpsRequestPropertyToCloudFormation(properties.networkBandwidthGbps), NetworkInterfaceCount: cfnSpotFleetNetworkInterfaceCountRequestPropertyToCloudFormation(properties.networkInterfaceCount), OnDemandMaxPricePercentageOverLowestPrice: cdk.numberToCloudFormation(properties.onDemandMaxPricePercentageOverLowestPrice), RequireHibernateSupport: cdk.booleanToCloudFormation(properties.requireHibernateSupport), SpotMaxPricePercentageOverLowestPrice: cdk.numberToCloudFormation(properties.spotMaxPricePercentageOverLowestPrice), TotalLocalStorageGB: cfnSpotFleetTotalLocalStorageGBRequestPropertyToCloudFormation(properties.totalLocalStorageGb), VCpuCount: cfnSpotFleetVCpuCountRangeRequestPropertyToCloudFormation(properties.vCpuCount) }) : properties;
    }
    function CfnSpotFleetInstanceRequirementsRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("acceleratorCount", "AcceleratorCount", properties.AcceleratorCount != null ? CfnSpotFleetAcceleratorCountRequestPropertyFromCloudFormation(properties.AcceleratorCount) : void 0), ret.addPropertyResult("acceleratorManufacturers", "AcceleratorManufacturers", properties.AcceleratorManufacturers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AcceleratorManufacturers) : void 0), ret.addPropertyResult("acceleratorNames", "AcceleratorNames", properties.AcceleratorNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AcceleratorNames) : void 0), ret.addPropertyResult("acceleratorTotalMemoryMiB", "AcceleratorTotalMemoryMiB", properties.AcceleratorTotalMemoryMiB != null ? CfnSpotFleetAcceleratorTotalMemoryMiBRequestPropertyFromCloudFormation(properties.AcceleratorTotalMemoryMiB) : void 0), ret.addPropertyResult("acceleratorTypes", "AcceleratorTypes", properties.AcceleratorTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AcceleratorTypes) : void 0), ret.addPropertyResult("allowedInstanceTypes", "AllowedInstanceTypes", properties.AllowedInstanceTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AllowedInstanceTypes) : void 0), ret.addPropertyResult("bareMetal", "BareMetal", properties.BareMetal != null ? cfn_parse.FromCloudFormation.getString(properties.BareMetal) : void 0), ret.addPropertyResult("baselineEbsBandwidthMbps", "BaselineEbsBandwidthMbps", properties.BaselineEbsBandwidthMbps != null ? CfnSpotFleetBaselineEbsBandwidthMbpsRequestPropertyFromCloudFormation(properties.BaselineEbsBandwidthMbps) : void 0), ret.addPropertyResult("burstablePerformance", "BurstablePerformance", properties.BurstablePerformance != null ? cfn_parse.FromCloudFormation.getString(properties.BurstablePerformance) : void 0), ret.addPropertyResult("cpuManufacturers", "CpuManufacturers", properties.CpuManufacturers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CpuManufacturers) : void 0), ret.addPropertyResult("excludedInstanceTypes", "ExcludedInstanceTypes", properties.ExcludedInstanceTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExcludedInstanceTypes) : void 0), ret.addPropertyResult("instanceGenerations", "InstanceGenerations", properties.InstanceGenerations != null ? cfn_parse.FromCloudFormation.getStringArray(properties.InstanceGenerations) : void 0), ret.addPropertyResult("localStorage", "LocalStorage", properties.LocalStorage != null ? cfn_parse.FromCloudFormation.getString(properties.LocalStorage) : void 0), ret.addPropertyResult("localStorageTypes", "LocalStorageTypes", properties.LocalStorageTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.LocalStorageTypes) : void 0), ret.addPropertyResult("memoryGiBPerVCpu", "MemoryGiBPerVCpu", properties.MemoryGiBPerVCpu != null ? CfnSpotFleetMemoryGiBPerVCpuRequestPropertyFromCloudFormation(properties.MemoryGiBPerVCpu) : void 0), ret.addPropertyResult("memoryMiB", "MemoryMiB", properties.MemoryMiB != null ? CfnSpotFleetMemoryMiBRequestPropertyFromCloudFormation(properties.MemoryMiB) : void 0), ret.addPropertyResult("networkBandwidthGbps", "NetworkBandwidthGbps", properties.NetworkBandwidthGbps != null ? CfnSpotFleetNetworkBandwidthGbpsRequestPropertyFromCloudFormation(properties.NetworkBandwidthGbps) : void 0), ret.addPropertyResult("networkInterfaceCount", "NetworkInterfaceCount", properties.NetworkInterfaceCount != null ? CfnSpotFleetNetworkInterfaceCountRequestPropertyFromCloudFormation(properties.NetworkInterfaceCount) : void 0), ret.addPropertyResult("onDemandMaxPricePercentageOverLowestPrice", "OnDemandMaxPricePercentageOverLowestPrice", properties.OnDemandMaxPricePercentageOverLowestPrice != null ? cfn_parse.FromCloudFormation.getNumber(properties.OnDemandMaxPricePercentageOverLowestPrice) : void 0), ret.addPropertyResult("requireHibernateSupport", "RequireHibernateSupport", properties.RequireHibernateSupport != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RequireHibernateSupport) : void 0), ret.addPropertyResult("spotMaxPricePercentageOverLowestPrice", "SpotMaxPricePercentageOverLowestPrice", properties.SpotMaxPricePercentageOverLowestPrice != null ? cfn_parse.FromCloudFormation.getNumber(properties.SpotMaxPricePercentageOverLowestPrice) : void 0), ret.addPropertyResult("totalLocalStorageGb", "TotalLocalStorageGB", properties.TotalLocalStorageGB != null ? CfnSpotFleetTotalLocalStorageGBRequestPropertyFromCloudFormation(properties.TotalLocalStorageGB) : void 0), ret.addPropertyResult("vCpuCount", "VCpuCount", properties.VCpuCount != null ? CfnSpotFleetVCpuCountRangeRequestPropertyFromCloudFormation(properties.VCpuCount) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpotFleet_LaunchTemplateConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("launchTemplateSpecification", CfnSpotFleet_FleetLaunchTemplateSpecificationPropertyValidator)(properties.launchTemplateSpecification)), errors.collect(cdk.propertyValidator("overrides", cdk.listValidator(CfnSpotFleet_LaunchTemplateOverridesPropertyValidator))(properties.overrides)), errors.wrap('supplied properties not correct for "LaunchTemplateConfigProperty"');
    }
    function cfnSpotFleetLaunchTemplateConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_LaunchTemplateConfigPropertyValidator(properties).assertSuccess(), { LaunchTemplateSpecification: cfnSpotFleetFleetLaunchTemplateSpecificationPropertyToCloudFormation(properties.launchTemplateSpecification), Overrides: cdk.listMapper(cfnSpotFleetLaunchTemplateOverridesPropertyToCloudFormation)(properties.overrides) }) : properties;
    }
    function CfnSpotFleetLaunchTemplateConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("launchTemplateSpecification", "LaunchTemplateSpecification", properties.LaunchTemplateSpecification != null ? CfnSpotFleetFleetLaunchTemplateSpecificationPropertyFromCloudFormation(properties.LaunchTemplateSpecification) : void 0), ret.addPropertyResult("overrides", "Overrides", properties.Overrides != null ? cfn_parse.FromCloudFormation.getArray(CfnSpotFleetLaunchTemplateOverridesPropertyFromCloudFormation)(properties.Overrides) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpotFleet_LaunchTemplateOverridesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availabilityZone", cdk.validateString)(properties.availabilityZone)), errors.collect(cdk.propertyValidator("instanceRequirements", CfnSpotFleet_InstanceRequirementsRequestPropertyValidator)(properties.instanceRequirements)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("priority", cdk.validateNumber)(properties.priority)), errors.collect(cdk.propertyValidator("spotPrice", cdk.validateString)(properties.spotPrice)), errors.collect(cdk.propertyValidator("subnetId", cdk.validateString)(properties.subnetId)), errors.collect(cdk.propertyValidator("weightedCapacity", cdk.validateNumber)(properties.weightedCapacity)), errors.wrap('supplied properties not correct for "LaunchTemplateOverridesProperty"');
    }
    function cfnSpotFleetLaunchTemplateOverridesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_LaunchTemplateOverridesPropertyValidator(properties).assertSuccess(), { AvailabilityZone: cdk.stringToCloudFormation(properties.availabilityZone), InstanceRequirements: cfnSpotFleetInstanceRequirementsRequestPropertyToCloudFormation(properties.instanceRequirements), InstanceType: cdk.stringToCloudFormation(properties.instanceType), Priority: cdk.numberToCloudFormation(properties.priority), SpotPrice: cdk.stringToCloudFormation(properties.spotPrice), SubnetId: cdk.stringToCloudFormation(properties.subnetId), WeightedCapacity: cdk.numberToCloudFormation(properties.weightedCapacity) }) : properties;
    }
    function CfnSpotFleetLaunchTemplateOverridesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("availabilityZone", "AvailabilityZone", properties.AvailabilityZone != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityZone) : void 0), ret.addPropertyResult("instanceRequirements", "InstanceRequirements", properties.InstanceRequirements != null ? CfnSpotFleetInstanceRequirementsRequestPropertyFromCloudFormation(properties.InstanceRequirements) : void 0), ret.addPropertyResult("instanceType", "InstanceType", properties.InstanceType != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceType) : void 0), ret.addPropertyResult("priority", "Priority", properties.Priority != null ? cfn_parse.FromCloudFormation.getNumber(properties.Priority) : void 0), ret.addPropertyResult("spotPrice", "SpotPrice", properties.SpotPrice != null ? cfn_parse.FromCloudFormation.getString(properties.SpotPrice) : void 0), ret.addPropertyResult("subnetId", "SubnetId", properties.SubnetId != null ? cfn_parse.FromCloudFormation.getString(properties.SubnetId) : void 0), ret.addPropertyResult("weightedCapacity", "WeightedCapacity", properties.WeightedCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.WeightedCapacity) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpotFleet_LoadBalancersConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("classicLoadBalancersConfig", CfnSpotFleet_ClassicLoadBalancersConfigPropertyValidator)(properties.classicLoadBalancersConfig)), errors.collect(cdk.propertyValidator("targetGroupsConfig", CfnSpotFleet_TargetGroupsConfigPropertyValidator)(properties.targetGroupsConfig)), errors.wrap('supplied properties not correct for "LoadBalancersConfigProperty"');
    }
    function cfnSpotFleetLoadBalancersConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_LoadBalancersConfigPropertyValidator(properties).assertSuccess(), { ClassicLoadBalancersConfig: cfnSpotFleetClassicLoadBalancersConfigPropertyToCloudFormation(properties.classicLoadBalancersConfig), TargetGroupsConfig: cfnSpotFleetTargetGroupsConfigPropertyToCloudFormation(properties.targetGroupsConfig) }) : properties;
    }
    function CfnSpotFleetLoadBalancersConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("classicLoadBalancersConfig", "ClassicLoadBalancersConfig", properties.ClassicLoadBalancersConfig != null ? CfnSpotFleetClassicLoadBalancersConfigPropertyFromCloudFormation(properties.ClassicLoadBalancersConfig) : void 0), ret.addPropertyResult("targetGroupsConfig", "TargetGroupsConfig", properties.TargetGroupsConfig != null ? CfnSpotFleetTargetGroupsConfigPropertyFromCloudFormation(properties.TargetGroupsConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpotFleet_MemoryGiBPerVCpuRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "MemoryGiBPerVCpuRequestProperty"');
    }
    function cfnSpotFleetMemoryGiBPerVCpuRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_MemoryGiBPerVCpuRequestPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnSpotFleetMemoryGiBPerVCpuRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpotFleet_MemoryMiBRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "MemoryMiBRequestProperty"');
    }
    function cfnSpotFleetMemoryMiBRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_MemoryMiBRequestPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnSpotFleetMemoryMiBRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpotFleet_NetworkBandwidthGbpsRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "NetworkBandwidthGbpsRequestProperty"');
    }
    function cfnSpotFleetNetworkBandwidthGbpsRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_NetworkBandwidthGbpsRequestPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnSpotFleetNetworkBandwidthGbpsRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpotFleet_NetworkInterfaceCountRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "NetworkInterfaceCountRequestProperty"');
    }
    function cfnSpotFleetNetworkInterfaceCountRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_NetworkInterfaceCountRequestPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnSpotFleetNetworkInterfaceCountRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpotFleet_PrivateIpAddressSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("primary", cdk.validateBoolean)(properties.primary)), errors.collect(cdk.propertyValidator("privateIpAddress", cdk.requiredValidator)(properties.privateIpAddress)), errors.collect(cdk.propertyValidator("privateIpAddress", cdk.validateString)(properties.privateIpAddress)), errors.wrap('supplied properties not correct for "PrivateIpAddressSpecificationProperty"');
    }
    function cfnSpotFleetPrivateIpAddressSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_PrivateIpAddressSpecificationPropertyValidator(properties).assertSuccess(), { Primary: cdk.booleanToCloudFormation(properties.primary), PrivateIpAddress: cdk.stringToCloudFormation(properties.privateIpAddress) }) : properties;
    }
    function CfnSpotFleetPrivateIpAddressSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("primary", "Primary", properties.Primary != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Primary) : void 0), ret.addPropertyResult("privateIpAddress", "PrivateIpAddress", cfn_parse.FromCloudFormation.getString(properties.PrivateIpAddress)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpotFleet_SpotCapacityRebalancePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("replacementStrategy", cdk.validateString)(properties.replacementStrategy)), errors.collect(cdk.propertyValidator("terminationDelay", cdk.validateNumber)(properties.terminationDelay)), errors.wrap('supplied properties not correct for "SpotCapacityRebalanceProperty"');
    }
    function cfnSpotFleetSpotCapacityRebalancePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_SpotCapacityRebalancePropertyValidator(properties).assertSuccess(), { ReplacementStrategy: cdk.stringToCloudFormation(properties.replacementStrategy), TerminationDelay: cdk.numberToCloudFormation(properties.terminationDelay) }) : properties;
    }
    function CfnSpotFleetSpotCapacityRebalancePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("replacementStrategy", "ReplacementStrategy", properties.ReplacementStrategy != null ? cfn_parse.FromCloudFormation.getString(properties.ReplacementStrategy) : void 0), ret.addPropertyResult("terminationDelay", "TerminationDelay", properties.TerminationDelay != null ? cfn_parse.FromCloudFormation.getNumber(properties.TerminationDelay) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpotFleet_SpotFleetLaunchSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("blockDeviceMappings", cdk.listValidator(CfnSpotFleet_BlockDeviceMappingPropertyValidator))(properties.blockDeviceMappings)), errors.collect(cdk.propertyValidator("ebsOptimized", cdk.validateBoolean)(properties.ebsOptimized)), errors.collect(cdk.propertyValidator("iamInstanceProfile", CfnSpotFleet_IamInstanceProfileSpecificationPropertyValidator)(properties.iamInstanceProfile)), errors.collect(cdk.propertyValidator("imageId", cdk.requiredValidator)(properties.imageId)), errors.collect(cdk.propertyValidator("imageId", cdk.validateString)(properties.imageId)), errors.collect(cdk.propertyValidator("instanceRequirements", CfnSpotFleet_InstanceRequirementsRequestPropertyValidator)(properties.instanceRequirements)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("kernelId", cdk.validateString)(properties.kernelId)), errors.collect(cdk.propertyValidator("keyName", cdk.validateString)(properties.keyName)), errors.collect(cdk.propertyValidator("monitoring", CfnSpotFleet_SpotFleetMonitoringPropertyValidator)(properties.monitoring)), errors.collect(cdk.propertyValidator("networkInterfaces", cdk.listValidator(CfnSpotFleet_InstanceNetworkInterfaceSpecificationPropertyValidator))(properties.networkInterfaces)), errors.collect(cdk.propertyValidator("placement", CfnSpotFleet_SpotPlacementPropertyValidator)(properties.placement)), errors.collect(cdk.propertyValidator("ramdiskId", cdk.validateString)(properties.ramdiskId)), errors.collect(cdk.propertyValidator("securityGroups", cdk.listValidator(CfnSpotFleet_GroupIdentifierPropertyValidator))(properties.securityGroups)), errors.collect(cdk.propertyValidator("spotPrice", cdk.validateString)(properties.spotPrice)), errors.collect(cdk.propertyValidator("subnetId", cdk.validateString)(properties.subnetId)), errors.collect(cdk.propertyValidator("tagSpecifications", cdk.listValidator(CfnSpotFleet_SpotFleetTagSpecificationPropertyValidator))(properties.tagSpecifications)), errors.collect(cdk.propertyValidator("userData", cdk.validateString)(properties.userData)), errors.collect(cdk.propertyValidator("weightedCapacity", cdk.validateNumber)(properties.weightedCapacity)), errors.wrap('supplied properties not correct for "SpotFleetLaunchSpecificationProperty"');
    }
    function cfnSpotFleetSpotFleetLaunchSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_SpotFleetLaunchSpecificationPropertyValidator(properties).assertSuccess(), { BlockDeviceMappings: cdk.listMapper(cfnSpotFleetBlockDeviceMappingPropertyToCloudFormation)(properties.blockDeviceMappings), EbsOptimized: cdk.booleanToCloudFormation(properties.ebsOptimized), IamInstanceProfile: cfnSpotFleetIamInstanceProfileSpecificationPropertyToCloudFormation(properties.iamInstanceProfile), ImageId: cdk.stringToCloudFormation(properties.imageId), InstanceRequirements: cfnSpotFleetInstanceRequirementsRequestPropertyToCloudFormation(properties.instanceRequirements), InstanceType: cdk.stringToCloudFormation(properties.instanceType), KernelId: cdk.stringToCloudFormation(properties.kernelId), KeyName: cdk.stringToCloudFormation(properties.keyName), Monitoring: cfnSpotFleetSpotFleetMonitoringPropertyToCloudFormation(properties.monitoring), NetworkInterfaces: cdk.listMapper(cfnSpotFleetInstanceNetworkInterfaceSpecificationPropertyToCloudFormation)(properties.networkInterfaces), Placement: cfnSpotFleetSpotPlacementPropertyToCloudFormation(properties.placement), RamdiskId: cdk.stringToCloudFormation(properties.ramdiskId), SecurityGroups: cdk.listMapper(cfnSpotFleetGroupIdentifierPropertyToCloudFormation)(properties.securityGroups), SpotPrice: cdk.stringToCloudFormation(properties.spotPrice), SubnetId: cdk.stringToCloudFormation(properties.subnetId), TagSpecifications: cdk.listMapper(cfnSpotFleetSpotFleetTagSpecificationPropertyToCloudFormation)(properties.tagSpecifications), UserData: cdk.stringToCloudFormation(properties.userData), WeightedCapacity: cdk.numberToCloudFormation(properties.weightedCapacity) }) : properties;
    }
    function CfnSpotFleetSpotFleetLaunchSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("blockDeviceMappings", "BlockDeviceMappings", properties.BlockDeviceMappings != null ? cfn_parse.FromCloudFormation.getArray(CfnSpotFleetBlockDeviceMappingPropertyFromCloudFormation)(properties.BlockDeviceMappings) : void 0), ret.addPropertyResult("ebsOptimized", "EbsOptimized", properties.EbsOptimized != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EbsOptimized) : void 0), ret.addPropertyResult("iamInstanceProfile", "IamInstanceProfile", properties.IamInstanceProfile != null ? CfnSpotFleetIamInstanceProfileSpecificationPropertyFromCloudFormation(properties.IamInstanceProfile) : void 0), ret.addPropertyResult("imageId", "ImageId", cfn_parse.FromCloudFormation.getString(properties.ImageId)), ret.addPropertyResult("instanceRequirements", "InstanceRequirements", properties.InstanceRequirements != null ? CfnSpotFleetInstanceRequirementsRequestPropertyFromCloudFormation(properties.InstanceRequirements) : void 0), ret.addPropertyResult("instanceType", "InstanceType", properties.InstanceType != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceType) : void 0), ret.addPropertyResult("kernelId", "KernelId", properties.KernelId != null ? cfn_parse.FromCloudFormation.getString(properties.KernelId) : void 0), ret.addPropertyResult("keyName", "KeyName", properties.KeyName != null ? cfn_parse.FromCloudFormation.getString(properties.KeyName) : void 0), ret.addPropertyResult("monitoring", "Monitoring", properties.Monitoring != null ? CfnSpotFleetSpotFleetMonitoringPropertyFromCloudFormation(properties.Monitoring) : void 0), ret.addPropertyResult("networkInterfaces", "NetworkInterfaces", properties.NetworkInterfaces != null ? cfn_parse.FromCloudFormation.getArray(CfnSpotFleetInstanceNetworkInterfaceSpecificationPropertyFromCloudFormation)(properties.NetworkInterfaces) : void 0), ret.addPropertyResult("placement", "Placement", properties.Placement != null ? CfnSpotFleetSpotPlacementPropertyFromCloudFormation(properties.Placement) : void 0), ret.addPropertyResult("ramdiskId", "RamdiskId", properties.RamdiskId != null ? cfn_parse.FromCloudFormation.getString(properties.RamdiskId) : void 0), ret.addPropertyResult("securityGroups", "SecurityGroups", properties.SecurityGroups != null ? cfn_parse.FromCloudFormation.getArray(CfnSpotFleetGroupIdentifierPropertyFromCloudFormation)(properties.SecurityGroups) : void 0), ret.addPropertyResult("spotPrice", "SpotPrice", properties.SpotPrice != null ? cfn_parse.FromCloudFormation.getString(properties.SpotPrice) : void 0), ret.addPropertyResult("subnetId", "SubnetId", properties.SubnetId != null ? cfn_parse.FromCloudFormation.getString(properties.SubnetId) : void 0), ret.addPropertyResult("tagSpecifications", "TagSpecifications", properties.TagSpecifications != null ? cfn_parse.FromCloudFormation.getArray(CfnSpotFleetSpotFleetTagSpecificationPropertyFromCloudFormation)(properties.TagSpecifications) : void 0), ret.addPropertyResult("userData", "UserData", properties.UserData != null ? cfn_parse.FromCloudFormation.getString(properties.UserData) : void 0), ret.addPropertyResult("weightedCapacity", "WeightedCapacity", properties.WeightedCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.WeightedCapacity) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpotFleet_SpotFleetMonitoringPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "SpotFleetMonitoringProperty"');
    }
    function cfnSpotFleetSpotFleetMonitoringPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_SpotFleetMonitoringPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnSpotFleetSpotFleetMonitoringPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpotFleet_SpotFleetRequestConfigDataPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allocationStrategy", cdk.validateString)(properties.allocationStrategy)), errors.collect(cdk.propertyValidator("context", cdk.validateString)(properties.context)), errors.collect(cdk.propertyValidator("excessCapacityTerminationPolicy", cdk.validateString)(properties.excessCapacityTerminationPolicy)), errors.collect(cdk.propertyValidator("iamFleetRole", cdk.requiredValidator)(properties.iamFleetRole)), errors.collect(cdk.propertyValidator("iamFleetRole", cdk.validateString)(properties.iamFleetRole)), errors.collect(cdk.propertyValidator("instanceInterruptionBehavior", cdk.validateString)(properties.instanceInterruptionBehavior)), errors.collect(cdk.propertyValidator("instancePoolsToUseCount", cdk.validateNumber)(properties.instancePoolsToUseCount)), errors.collect(cdk.propertyValidator("launchSpecifications", cdk.listValidator(CfnSpotFleet_SpotFleetLaunchSpecificationPropertyValidator))(properties.launchSpecifications)), errors.collect(cdk.propertyValidator("launchTemplateConfigs", cdk.listValidator(CfnSpotFleet_LaunchTemplateConfigPropertyValidator))(properties.launchTemplateConfigs)), errors.collect(cdk.propertyValidator("loadBalancersConfig", CfnSpotFleet_LoadBalancersConfigPropertyValidator)(properties.loadBalancersConfig)), errors.collect(cdk.propertyValidator("onDemandAllocationStrategy", cdk.validateString)(properties.onDemandAllocationStrategy)), errors.collect(cdk.propertyValidator("onDemandMaxTotalPrice", cdk.validateString)(properties.onDemandMaxTotalPrice)), errors.collect(cdk.propertyValidator("onDemandTargetCapacity", cdk.validateNumber)(properties.onDemandTargetCapacity)), errors.collect(cdk.propertyValidator("replaceUnhealthyInstances", cdk.validateBoolean)(properties.replaceUnhealthyInstances)), errors.collect(cdk.propertyValidator("spotMaintenanceStrategies", CfnSpotFleet_SpotMaintenanceStrategiesPropertyValidator)(properties.spotMaintenanceStrategies)), errors.collect(cdk.propertyValidator("spotMaxTotalPrice", cdk.validateString)(properties.spotMaxTotalPrice)), errors.collect(cdk.propertyValidator("spotPrice", cdk.validateString)(properties.spotPrice)), errors.collect(cdk.propertyValidator("tagSpecifications", cdk.listValidator(CfnSpotFleet_SpotFleetTagSpecificationPropertyValidator))(properties.tagSpecifications)), errors.collect(cdk.propertyValidator("targetCapacity", cdk.requiredValidator)(properties.targetCapacity)), errors.collect(cdk.propertyValidator("targetCapacity", cdk.validateNumber)(properties.targetCapacity)), errors.collect(cdk.propertyValidator("targetCapacityUnitType", cdk.validateString)(properties.targetCapacityUnitType)), errors.collect(cdk.propertyValidator("terminateInstancesWithExpiration", cdk.validateBoolean)(properties.terminateInstancesWithExpiration)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("validFrom", cdk.validateString)(properties.validFrom)), errors.collect(cdk.propertyValidator("validUntil", cdk.validateString)(properties.validUntil)), errors.wrap('supplied properties not correct for "SpotFleetRequestConfigDataProperty"');
    }
    function cfnSpotFleetSpotFleetRequestConfigDataPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_SpotFleetRequestConfigDataPropertyValidator(properties).assertSuccess(), { AllocationStrategy: cdk.stringToCloudFormation(properties.allocationStrategy), Context: cdk.stringToCloudFormation(properties.context), ExcessCapacityTerminationPolicy: cdk.stringToCloudFormation(properties.excessCapacityTerminationPolicy), IamFleetRole: cdk.stringToCloudFormation(properties.iamFleetRole), InstanceInterruptionBehavior: cdk.stringToCloudFormation(properties.instanceInterruptionBehavior), InstancePoolsToUseCount: cdk.numberToCloudFormation(properties.instancePoolsToUseCount), LaunchSpecifications: cdk.listMapper(cfnSpotFleetSpotFleetLaunchSpecificationPropertyToCloudFormation)(properties.launchSpecifications), LaunchTemplateConfigs: cdk.listMapper(cfnSpotFleetLaunchTemplateConfigPropertyToCloudFormation)(properties.launchTemplateConfigs), LoadBalancersConfig: cfnSpotFleetLoadBalancersConfigPropertyToCloudFormation(properties.loadBalancersConfig), OnDemandAllocationStrategy: cdk.stringToCloudFormation(properties.onDemandAllocationStrategy), OnDemandMaxTotalPrice: cdk.stringToCloudFormation(properties.onDemandMaxTotalPrice), OnDemandTargetCapacity: cdk.numberToCloudFormation(properties.onDemandTargetCapacity), ReplaceUnhealthyInstances: cdk.booleanToCloudFormation(properties.replaceUnhealthyInstances), SpotMaintenanceStrategies: cfnSpotFleetSpotMaintenanceStrategiesPropertyToCloudFormation(properties.spotMaintenanceStrategies), SpotMaxTotalPrice: cdk.stringToCloudFormation(properties.spotMaxTotalPrice), SpotPrice: cdk.stringToCloudFormation(properties.spotPrice), TagSpecifications: cdk.listMapper(cfnSpotFleetSpotFleetTagSpecificationPropertyToCloudFormation)(properties.tagSpecifications), TargetCapacity: cdk.numberToCloudFormation(properties.targetCapacity), TargetCapacityUnitType: cdk.stringToCloudFormation(properties.targetCapacityUnitType), TerminateInstancesWithExpiration: cdk.booleanToCloudFormation(properties.terminateInstancesWithExpiration), Type: cdk.stringToCloudFormation(properties.type), ValidFrom: cdk.stringToCloudFormation(properties.validFrom), ValidUntil: cdk.stringToCloudFormation(properties.validUntil) }) : properties;
    }
    function CfnSpotFleetSpotFleetRequestConfigDataPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allocationStrategy", "AllocationStrategy", properties.AllocationStrategy != null ? cfn_parse.FromCloudFormation.getString(properties.AllocationStrategy) : void 0), ret.addPropertyResult("context", "Context", properties.Context != null ? cfn_parse.FromCloudFormation.getString(properties.Context) : void 0), ret.addPropertyResult("excessCapacityTerminationPolicy", "ExcessCapacityTerminationPolicy", properties.ExcessCapacityTerminationPolicy != null ? cfn_parse.FromCloudFormation.getString(properties.ExcessCapacityTerminationPolicy) : void 0), ret.addPropertyResult("iamFleetRole", "IamFleetRole", cfn_parse.FromCloudFormation.getString(properties.IamFleetRole)), ret.addPropertyResult("instanceInterruptionBehavior", "InstanceInterruptionBehavior", properties.InstanceInterruptionBehavior != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceInterruptionBehavior) : void 0), ret.addPropertyResult("instancePoolsToUseCount", "InstancePoolsToUseCount", properties.InstancePoolsToUseCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.InstancePoolsToUseCount) : void 0), ret.addPropertyResult("launchSpecifications", "LaunchSpecifications", properties.LaunchSpecifications != null ? cfn_parse.FromCloudFormation.getArray(CfnSpotFleetSpotFleetLaunchSpecificationPropertyFromCloudFormation)(properties.LaunchSpecifications) : void 0), ret.addPropertyResult("launchTemplateConfigs", "LaunchTemplateConfigs", properties.LaunchTemplateConfigs != null ? cfn_parse.FromCloudFormation.getArray(CfnSpotFleetLaunchTemplateConfigPropertyFromCloudFormation)(properties.LaunchTemplateConfigs) : void 0), ret.addPropertyResult("loadBalancersConfig", "LoadBalancersConfig", properties.LoadBalancersConfig != null ? CfnSpotFleetLoadBalancersConfigPropertyFromCloudFormation(properties.LoadBalancersConfig) : void 0), ret.addPropertyResult("onDemandAllocationStrategy", "OnDemandAllocationStrategy", properties.OnDemandAllocationStrategy != null ? cfn_parse.FromCloudFormation.getString(properties.OnDemandAllocationStrategy) : void 0), ret.addPropertyResult("onDemandMaxTotalPrice", "OnDemandMaxTotalPrice", properties.OnDemandMaxTotalPrice != null ? cfn_parse.FromCloudFormation.getString(properties.OnDemandMaxTotalPrice) : void 0), ret.addPropertyResult("onDemandTargetCapacity", "OnDemandTargetCapacity", properties.OnDemandTargetCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.OnDemandTargetCapacity) : void 0), ret.addPropertyResult("replaceUnhealthyInstances", "ReplaceUnhealthyInstances", properties.ReplaceUnhealthyInstances != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ReplaceUnhealthyInstances) : void 0), ret.addPropertyResult("spotMaintenanceStrategies", "SpotMaintenanceStrategies", properties.SpotMaintenanceStrategies != null ? CfnSpotFleetSpotMaintenanceStrategiesPropertyFromCloudFormation(properties.SpotMaintenanceStrategies) : void 0), ret.addPropertyResult("spotMaxTotalPrice", "SpotMaxTotalPrice", properties.SpotMaxTotalPrice != null ? cfn_parse.FromCloudFormation.getString(properties.SpotMaxTotalPrice) : void 0), ret.addPropertyResult("spotPrice", "SpotPrice", properties.SpotPrice != null ? cfn_parse.FromCloudFormation.getString(properties.SpotPrice) : void 0), ret.addPropertyResult("tagSpecifications", "TagSpecifications", properties.TagSpecifications != null ? cfn_parse.FromCloudFormation.getArray(CfnSpotFleetSpotFleetTagSpecificationPropertyFromCloudFormation)(properties.TagSpecifications) : void 0), ret.addPropertyResult("targetCapacity", "TargetCapacity", cfn_parse.FromCloudFormation.getNumber(properties.TargetCapacity)), ret.addPropertyResult("targetCapacityUnitType", "TargetCapacityUnitType", properties.TargetCapacityUnitType != null ? cfn_parse.FromCloudFormation.getString(properties.TargetCapacityUnitType) : void 0), ret.addPropertyResult("terminateInstancesWithExpiration", "TerminateInstancesWithExpiration", properties.TerminateInstancesWithExpiration != null ? cfn_parse.FromCloudFormation.getBoolean(properties.TerminateInstancesWithExpiration) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addPropertyResult("validFrom", "ValidFrom", properties.ValidFrom != null ? cfn_parse.FromCloudFormation.getString(properties.ValidFrom) : void 0), ret.addPropertyResult("validUntil", "ValidUntil", properties.ValidUntil != null ? cfn_parse.FromCloudFormation.getString(properties.ValidUntil) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpotFleet_SpotFleetTagSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceType", cdk.validateString)(properties.resourceType)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "SpotFleetTagSpecificationProperty"');
    }
    function cfnSpotFleetSpotFleetTagSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_SpotFleetTagSpecificationPropertyValidator(properties).assertSuccess(), { ResourceType: cdk.stringToCloudFormation(properties.resourceType), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnSpotFleetSpotFleetTagSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceType", "ResourceType", properties.ResourceType != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceType) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpotFleet_SpotMaintenanceStrategiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("capacityRebalance", CfnSpotFleet_SpotCapacityRebalancePropertyValidator)(properties.capacityRebalance)), errors.wrap('supplied properties not correct for "SpotMaintenanceStrategiesProperty"');
    }
    function cfnSpotFleetSpotMaintenanceStrategiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_SpotMaintenanceStrategiesPropertyValidator(properties).assertSuccess(), { CapacityRebalance: cfnSpotFleetSpotCapacityRebalancePropertyToCloudFormation(properties.capacityRebalance) }) : properties;
    }
    function CfnSpotFleetSpotMaintenanceStrategiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("capacityRebalance", "CapacityRebalance", properties.CapacityRebalance != null ? CfnSpotFleetSpotCapacityRebalancePropertyFromCloudFormation(properties.CapacityRebalance) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpotFleet_SpotPlacementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availabilityZone", cdk.validateString)(properties.availabilityZone)), errors.collect(cdk.propertyValidator("groupName", cdk.validateString)(properties.groupName)), errors.collect(cdk.propertyValidator("tenancy", cdk.validateString)(properties.tenancy)), errors.wrap('supplied properties not correct for "SpotPlacementProperty"');
    }
    function cfnSpotFleetSpotPlacementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_SpotPlacementPropertyValidator(properties).assertSuccess(), { AvailabilityZone: cdk.stringToCloudFormation(properties.availabilityZone), GroupName: cdk.stringToCloudFormation(properties.groupName), Tenancy: cdk.stringToCloudFormation(properties.tenancy) }) : properties;
    }
    function CfnSpotFleetSpotPlacementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("availabilityZone", "AvailabilityZone", properties.AvailabilityZone != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityZone) : void 0), ret.addPropertyResult("groupName", "GroupName", properties.GroupName != null ? cfn_parse.FromCloudFormation.getString(properties.GroupName) : void 0), ret.addPropertyResult("tenancy", "Tenancy", properties.Tenancy != null ? cfn_parse.FromCloudFormation.getString(properties.Tenancy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpotFleet_TargetGroupPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.requiredValidator)(properties.arn)), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.wrap('supplied properties not correct for "TargetGroupProperty"');
    }
    function cfnSpotFleetTargetGroupPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_TargetGroupPropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn) }) : properties;
    }
    function CfnSpotFleetTargetGroupPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", cfn_parse.FromCloudFormation.getString(properties.Arn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpotFleet_TargetGroupsConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("targetGroups", cdk.requiredValidator)(properties.targetGroups)), errors.collect(cdk.propertyValidator("targetGroups", cdk.listValidator(CfnSpotFleet_TargetGroupPropertyValidator))(properties.targetGroups)), errors.wrap('supplied properties not correct for "TargetGroupsConfigProperty"');
    }
    function cfnSpotFleetTargetGroupsConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_TargetGroupsConfigPropertyValidator(properties).assertSuccess(), { TargetGroups: cdk.listMapper(cfnSpotFleetTargetGroupPropertyToCloudFormation)(properties.targetGroups) }) : properties;
    }
    function CfnSpotFleetTargetGroupsConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("targetGroups", "TargetGroups", cfn_parse.FromCloudFormation.getArray(CfnSpotFleetTargetGroupPropertyFromCloudFormation)(properties.TargetGroups)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpotFleet_TotalLocalStorageGBRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "TotalLocalStorageGBRequestProperty"');
    }
    function cfnSpotFleetTotalLocalStorageGBRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_TotalLocalStorageGBRequestPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnSpotFleetTotalLocalStorageGBRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpotFleet_VCpuCountRangeRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "VCpuCountRangeRequestProperty"');
    }
    function cfnSpotFleetVCpuCountRangeRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpotFleet_VCpuCountRangeRequestPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnSpotFleetVCpuCountRangeRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSubnetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("assignIpv6AddressOnCreation", cdk.validateBoolean)(properties.assignIpv6AddressOnCreation)), errors.collect(cdk.propertyValidator("availabilityZone", cdk.validateString)(properties.availabilityZone)), errors.collect(cdk.propertyValidator("availabilityZoneId", cdk.validateString)(properties.availabilityZoneId)), errors.collect(cdk.propertyValidator("cidrBlock", cdk.validateString)(properties.cidrBlock)), errors.collect(cdk.propertyValidator("enableDns64", cdk.validateBoolean)(properties.enableDns64)), errors.collect(cdk.propertyValidator("ipv6CidrBlock", cdk.validateString)(properties.ipv6CidrBlock)), errors.collect(cdk.propertyValidator("ipv6Native", cdk.validateBoolean)(properties.ipv6Native)), errors.collect(cdk.propertyValidator("mapPublicIpOnLaunch", cdk.validateBoolean)(properties.mapPublicIpOnLaunch)), errors.collect(cdk.propertyValidator("outpostArn", cdk.validateString)(properties.outpostArn)), errors.collect(cdk.propertyValidator("privateDnsNameOptionsOnLaunch", cdk.validateObject)(properties.privateDnsNameOptionsOnLaunch)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpcId", cdk.requiredValidator)(properties.vpcId)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "CfnSubnetProps"');
    }
    function cfnSubnetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSubnetPropsValidator(properties).assertSuccess(), { VpcId: cdk.stringToCloudFormation(properties.vpcId), AssignIpv6AddressOnCreation: cdk.booleanToCloudFormation(properties.assignIpv6AddressOnCreation), AvailabilityZone: cdk.stringToCloudFormation(properties.availabilityZone), AvailabilityZoneId: cdk.stringToCloudFormation(properties.availabilityZoneId), CidrBlock: cdk.stringToCloudFormation(properties.cidrBlock), EnableDns64: cdk.booleanToCloudFormation(properties.enableDns64), Ipv6CidrBlock: cdk.stringToCloudFormation(properties.ipv6CidrBlock), Ipv6Native: cdk.booleanToCloudFormation(properties.ipv6Native), MapPublicIpOnLaunch: cdk.booleanToCloudFormation(properties.mapPublicIpOnLaunch), OutpostArn: cdk.stringToCloudFormation(properties.outpostArn), PrivateDnsNameOptionsOnLaunch: cdk.objectToCloudFormation(properties.privateDnsNameOptionsOnLaunch), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnSubnetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("vpcId", "VpcId", cfn_parse.FromCloudFormation.getString(properties.VpcId)), ret.addPropertyResult("assignIpv6AddressOnCreation", "AssignIpv6AddressOnCreation", properties.AssignIpv6AddressOnCreation != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AssignIpv6AddressOnCreation) : void 0), ret.addPropertyResult("availabilityZone", "AvailabilityZone", properties.AvailabilityZone != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityZone) : void 0), ret.addPropertyResult("availabilityZoneId", "AvailabilityZoneId", properties.AvailabilityZoneId != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityZoneId) : void 0), ret.addPropertyResult("cidrBlock", "CidrBlock", properties.CidrBlock != null ? cfn_parse.FromCloudFormation.getString(properties.CidrBlock) : void 0), ret.addPropertyResult("enableDns64", "EnableDns64", properties.EnableDns64 != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableDns64) : void 0), ret.addPropertyResult("ipv6CidrBlock", "Ipv6CidrBlock", properties.Ipv6CidrBlock != null ? cfn_parse.FromCloudFormation.getString(properties.Ipv6CidrBlock) : void 0), ret.addPropertyResult("ipv6Native", "Ipv6Native", properties.Ipv6Native != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Ipv6Native) : void 0), ret.addPropertyResult("mapPublicIpOnLaunch", "MapPublicIpOnLaunch", properties.MapPublicIpOnLaunch != null ? cfn_parse.FromCloudFormation.getBoolean(properties.MapPublicIpOnLaunch) : void 0), ret.addPropertyResult("outpostArn", "OutpostArn", properties.OutpostArn != null ? cfn_parse.FromCloudFormation.getString(properties.OutpostArn) : void 0), ret.addPropertyResult("privateDnsNameOptionsOnLaunch", "PrivateDnsNameOptionsOnLaunch", properties.PrivateDnsNameOptionsOnLaunch != null ? cfn_parse.FromCloudFormation.getAny(properties.PrivateDnsNameOptionsOnLaunch) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSubnet = class _CfnSubnet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSubnetPropsFromCloudFormation(resourceProperties), ret = new _CfnSubnet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSubnet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnSubnetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSubnet), error;
        }
        cdk.requireProperty(props, "vpcId", this), this.attrAvailabilityZone = cdk.Token.asString(this.getAtt("AvailabilityZone", cdk.ResolutionTypeHint.STRING)), this.attrIpv6CidrBlocks = cdk.Token.asList(this.getAtt("Ipv6CidrBlocks", cdk.ResolutionTypeHint.STRING_LIST)), this.attrNetworkAclAssociationId = cdk.Token.asString(this.getAtt("NetworkAclAssociationId", cdk.ResolutionTypeHint.STRING)), this.attrOutpostArn = cdk.Token.asString(this.getAtt("OutpostArn", cdk.ResolutionTypeHint.STRING)), this.attrSubnetId = cdk.Token.asString(this.getAtt("SubnetId", cdk.ResolutionTypeHint.STRING)), this.attrVpcId = cdk.Token.asString(this.getAtt("VpcId", cdk.ResolutionTypeHint.STRING)), this.vpcId = props.vpcId, this.assignIpv6AddressOnCreation = props.assignIpv6AddressOnCreation, this.availabilityZone = props.availabilityZone, this.availabilityZoneId = props.availabilityZoneId, this.cidrBlock = props.cidrBlock, this.enableDns64 = props.enableDns64, this.ipv6CidrBlock = props.ipv6CidrBlock, this.ipv6Native = props.ipv6Native, this.mapPublicIpOnLaunch = props.mapPublicIpOnLaunch, this.outpostArn = props.outpostArn, this.privateDnsNameOptionsOnLaunch = props.privateDnsNameOptionsOnLaunch, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::Subnet", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSubnet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { vpcId: this.vpcId, assignIpv6AddressOnCreation: this.assignIpv6AddressOnCreation, availabilityZone: this.availabilityZone, availabilityZoneId: this.availabilityZoneId, cidrBlock: this.cidrBlock, enableDns64: this.enableDns64, ipv6CidrBlock: this.ipv6CidrBlock, ipv6Native: this.ipv6Native, mapPublicIpOnLaunch: this.mapPublicIpOnLaunch, outpostArn: this.outpostArn, privateDnsNameOptionsOnLaunch: this.privateDnsNameOptionsOnLaunch, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnSubnetPropsToCloudFormation(props);
      }
    };
    _27 = JSII_RTTI_SYMBOL_1, CfnSubnet[_27] = { fqn: "aws-cdk-lib.aws_ec2.CfnSubnet", version: "2.80.0" }, CfnSubnet.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::Subnet", exports2.CfnSubnet = CfnSubnet;
    function CfnSubnetCidrBlockPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ipv6CidrBlock", cdk.requiredValidator)(properties.ipv6CidrBlock)), errors.collect(cdk.propertyValidator("ipv6CidrBlock", cdk.validateString)(properties.ipv6CidrBlock)), errors.collect(cdk.propertyValidator("subnetId", cdk.requiredValidator)(properties.subnetId)), errors.collect(cdk.propertyValidator("subnetId", cdk.validateString)(properties.subnetId)), errors.wrap('supplied properties not correct for "CfnSubnetCidrBlockProps"');
    }
    function cfnSubnetCidrBlockPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSubnetCidrBlockPropsValidator(properties).assertSuccess(), { Ipv6CidrBlock: cdk.stringToCloudFormation(properties.ipv6CidrBlock), SubnetId: cdk.stringToCloudFormation(properties.subnetId) }) : properties;
    }
    function CfnSubnetCidrBlockPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ipv6CidrBlock", "Ipv6CidrBlock", cfn_parse.FromCloudFormation.getString(properties.Ipv6CidrBlock)), ret.addPropertyResult("subnetId", "SubnetId", cfn_parse.FromCloudFormation.getString(properties.SubnetId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSubnetCidrBlock = class _CfnSubnetCidrBlock extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSubnetCidrBlockPropsFromCloudFormation(resourceProperties), ret = new _CfnSubnetCidrBlock(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSubnetCidrBlock.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnSubnetCidrBlockProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSubnetCidrBlock), error;
        }
        cdk.requireProperty(props, "ipv6CidrBlock", this), cdk.requireProperty(props, "subnetId", this), this.ipv6CidrBlock = props.ipv6CidrBlock, this.subnetId = props.subnetId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSubnetCidrBlock.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { ipv6CidrBlock: this.ipv6CidrBlock, subnetId: this.subnetId };
      }
      renderProperties(props) {
        return cfnSubnetCidrBlockPropsToCloudFormation(props);
      }
    };
    _28 = JSII_RTTI_SYMBOL_1, CfnSubnetCidrBlock[_28] = { fqn: "aws-cdk-lib.aws_ec2.CfnSubnetCidrBlock", version: "2.80.0" }, CfnSubnetCidrBlock.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::SubnetCidrBlock", exports2.CfnSubnetCidrBlock = CfnSubnetCidrBlock;
    function CfnSubnetNetworkAclAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("networkAclId", cdk.requiredValidator)(properties.networkAclId)), errors.collect(cdk.propertyValidator("networkAclId", cdk.validateString)(properties.networkAclId)), errors.collect(cdk.propertyValidator("subnetId", cdk.requiredValidator)(properties.subnetId)), errors.collect(cdk.propertyValidator("subnetId", cdk.validateString)(properties.subnetId)), errors.wrap('supplied properties not correct for "CfnSubnetNetworkAclAssociationProps"');
    }
    function cfnSubnetNetworkAclAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSubnetNetworkAclAssociationPropsValidator(properties).assertSuccess(), { NetworkAclId: cdk.stringToCloudFormation(properties.networkAclId), SubnetId: cdk.stringToCloudFormation(properties.subnetId) }) : properties;
    }
    function CfnSubnetNetworkAclAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("networkAclId", "NetworkAclId", cfn_parse.FromCloudFormation.getString(properties.NetworkAclId)), ret.addPropertyResult("subnetId", "SubnetId", cfn_parse.FromCloudFormation.getString(properties.SubnetId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSubnetNetworkAclAssociation = class _CfnSubnetNetworkAclAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSubnetNetworkAclAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnSubnetNetworkAclAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSubnetNetworkAclAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnSubnetNetworkAclAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSubnetNetworkAclAssociation), error;
        }
        cdk.requireProperty(props, "networkAclId", this), cdk.requireProperty(props, "subnetId", this), this.attrAssociationId = cdk.Token.asString(this.getAtt("AssociationId", cdk.ResolutionTypeHint.STRING)), this.networkAclId = props.networkAclId, this.subnetId = props.subnetId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSubnetNetworkAclAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { networkAclId: this.networkAclId, subnetId: this.subnetId };
      }
      renderProperties(props) {
        return cfnSubnetNetworkAclAssociationPropsToCloudFormation(props);
      }
    };
    _29 = JSII_RTTI_SYMBOL_1, CfnSubnetNetworkAclAssociation[_29] = { fqn: "aws-cdk-lib.aws_ec2.CfnSubnetNetworkAclAssociation", version: "2.80.0" }, CfnSubnetNetworkAclAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::SubnetNetworkAclAssociation", exports2.CfnSubnetNetworkAclAssociation = CfnSubnetNetworkAclAssociation;
    function CfnSubnetRouteTableAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("routeTableId", cdk.requiredValidator)(properties.routeTableId)), errors.collect(cdk.propertyValidator("routeTableId", cdk.validateString)(properties.routeTableId)), errors.collect(cdk.propertyValidator("subnetId", cdk.requiredValidator)(properties.subnetId)), errors.collect(cdk.propertyValidator("subnetId", cdk.validateString)(properties.subnetId)), errors.wrap('supplied properties not correct for "CfnSubnetRouteTableAssociationProps"');
    }
    function cfnSubnetRouteTableAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSubnetRouteTableAssociationPropsValidator(properties).assertSuccess(), { RouteTableId: cdk.stringToCloudFormation(properties.routeTableId), SubnetId: cdk.stringToCloudFormation(properties.subnetId) }) : properties;
    }
    function CfnSubnetRouteTableAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("routeTableId", "RouteTableId", cfn_parse.FromCloudFormation.getString(properties.RouteTableId)), ret.addPropertyResult("subnetId", "SubnetId", cfn_parse.FromCloudFormation.getString(properties.SubnetId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSubnetRouteTableAssociation = class _CfnSubnetRouteTableAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSubnetRouteTableAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnSubnetRouteTableAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSubnetRouteTableAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnSubnetRouteTableAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSubnetRouteTableAssociation), error;
        }
        cdk.requireProperty(props, "routeTableId", this), cdk.requireProperty(props, "subnetId", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.routeTableId = props.routeTableId, this.subnetId = props.subnetId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSubnetRouteTableAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { routeTableId: this.routeTableId, subnetId: this.subnetId };
      }
      renderProperties(props) {
        return cfnSubnetRouteTableAssociationPropsToCloudFormation(props);
      }
    };
    _30 = JSII_RTTI_SYMBOL_1, CfnSubnetRouteTableAssociation[_30] = { fqn: "aws-cdk-lib.aws_ec2.CfnSubnetRouteTableAssociation", version: "2.80.0" }, CfnSubnetRouteTableAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::SubnetRouteTableAssociation", exports2.CfnSubnetRouteTableAssociation = CfnSubnetRouteTableAssociation;
    function CfnTrafficMirrorFilterPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("networkServices", cdk.listValidator(cdk.validateString))(properties.networkServices)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnTrafficMirrorFilterProps"');
    }
    function cfnTrafficMirrorFilterPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTrafficMirrorFilterPropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), NetworkServices: cdk.listMapper(cdk.stringToCloudFormation)(properties.networkServices), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnTrafficMirrorFilterPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("networkServices", "NetworkServices", properties.NetworkServices != null ? cfn_parse.FromCloudFormation.getStringArray(properties.NetworkServices) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTrafficMirrorFilter = class _CfnTrafficMirrorFilter extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTrafficMirrorFilterPropsFromCloudFormation(resourceProperties), ret = new _CfnTrafficMirrorFilter(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnTrafficMirrorFilter.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnTrafficMirrorFilterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTrafficMirrorFilter), error;
        }
        this.description = props.description, this.networkServices = props.networkServices, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::TrafficMirrorFilter", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTrafficMirrorFilter.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, networkServices: this.networkServices, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnTrafficMirrorFilterPropsToCloudFormation(props);
      }
    };
    _31 = JSII_RTTI_SYMBOL_1, CfnTrafficMirrorFilter[_31] = { fqn: "aws-cdk-lib.aws_ec2.CfnTrafficMirrorFilter", version: "2.80.0" }, CfnTrafficMirrorFilter.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::TrafficMirrorFilter", exports2.CfnTrafficMirrorFilter = CfnTrafficMirrorFilter;
    function CfnTrafficMirrorFilterRulePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("destinationCidrBlock", cdk.requiredValidator)(properties.destinationCidrBlock)), errors.collect(cdk.propertyValidator("destinationCidrBlock", cdk.validateString)(properties.destinationCidrBlock)), errors.collect(cdk.propertyValidator("destinationPortRange", CfnTrafficMirrorFilterRule_TrafficMirrorPortRangePropertyValidator)(properties.destinationPortRange)), errors.collect(cdk.propertyValidator("protocol", cdk.validateNumber)(properties.protocol)), errors.collect(cdk.propertyValidator("ruleAction", cdk.requiredValidator)(properties.ruleAction)), errors.collect(cdk.propertyValidator("ruleAction", cdk.validateString)(properties.ruleAction)), errors.collect(cdk.propertyValidator("ruleNumber", cdk.requiredValidator)(properties.ruleNumber)), errors.collect(cdk.propertyValidator("ruleNumber", cdk.validateNumber)(properties.ruleNumber)), errors.collect(cdk.propertyValidator("sourceCidrBlock", cdk.requiredValidator)(properties.sourceCidrBlock)), errors.collect(cdk.propertyValidator("sourceCidrBlock", cdk.validateString)(properties.sourceCidrBlock)), errors.collect(cdk.propertyValidator("sourcePortRange", CfnTrafficMirrorFilterRule_TrafficMirrorPortRangePropertyValidator)(properties.sourcePortRange)), errors.collect(cdk.propertyValidator("trafficDirection", cdk.requiredValidator)(properties.trafficDirection)), errors.collect(cdk.propertyValidator("trafficDirection", cdk.validateString)(properties.trafficDirection)), errors.collect(cdk.propertyValidator("trafficMirrorFilterId", cdk.requiredValidator)(properties.trafficMirrorFilterId)), errors.collect(cdk.propertyValidator("trafficMirrorFilterId", cdk.validateString)(properties.trafficMirrorFilterId)), errors.wrap('supplied properties not correct for "CfnTrafficMirrorFilterRuleProps"');
    }
    function cfnTrafficMirrorFilterRulePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTrafficMirrorFilterRulePropsValidator(properties).assertSuccess(), { DestinationCidrBlock: cdk.stringToCloudFormation(properties.destinationCidrBlock), RuleAction: cdk.stringToCloudFormation(properties.ruleAction), RuleNumber: cdk.numberToCloudFormation(properties.ruleNumber), SourceCidrBlock: cdk.stringToCloudFormation(properties.sourceCidrBlock), TrafficDirection: cdk.stringToCloudFormation(properties.trafficDirection), TrafficMirrorFilterId: cdk.stringToCloudFormation(properties.trafficMirrorFilterId), Description: cdk.stringToCloudFormation(properties.description), DestinationPortRange: cfnTrafficMirrorFilterRuleTrafficMirrorPortRangePropertyToCloudFormation(properties.destinationPortRange), Protocol: cdk.numberToCloudFormation(properties.protocol), SourcePortRange: cfnTrafficMirrorFilterRuleTrafficMirrorPortRangePropertyToCloudFormation(properties.sourcePortRange) }) : properties;
    }
    function CfnTrafficMirrorFilterRulePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationCidrBlock", "DestinationCidrBlock", cfn_parse.FromCloudFormation.getString(properties.DestinationCidrBlock)), ret.addPropertyResult("ruleAction", "RuleAction", cfn_parse.FromCloudFormation.getString(properties.RuleAction)), ret.addPropertyResult("ruleNumber", "RuleNumber", cfn_parse.FromCloudFormation.getNumber(properties.RuleNumber)), ret.addPropertyResult("sourceCidrBlock", "SourceCidrBlock", cfn_parse.FromCloudFormation.getString(properties.SourceCidrBlock)), ret.addPropertyResult("trafficDirection", "TrafficDirection", cfn_parse.FromCloudFormation.getString(properties.TrafficDirection)), ret.addPropertyResult("trafficMirrorFilterId", "TrafficMirrorFilterId", cfn_parse.FromCloudFormation.getString(properties.TrafficMirrorFilterId)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("destinationPortRange", "DestinationPortRange", properties.DestinationPortRange != null ? CfnTrafficMirrorFilterRuleTrafficMirrorPortRangePropertyFromCloudFormation(properties.DestinationPortRange) : void 0), ret.addPropertyResult("protocol", "Protocol", properties.Protocol != null ? cfn_parse.FromCloudFormation.getNumber(properties.Protocol) : void 0), ret.addPropertyResult("sourcePortRange", "SourcePortRange", properties.SourcePortRange != null ? CfnTrafficMirrorFilterRuleTrafficMirrorPortRangePropertyFromCloudFormation(properties.SourcePortRange) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTrafficMirrorFilterRule = class _CfnTrafficMirrorFilterRule extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTrafficMirrorFilterRulePropsFromCloudFormation(resourceProperties), ret = new _CfnTrafficMirrorFilterRule(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTrafficMirrorFilterRule.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnTrafficMirrorFilterRuleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTrafficMirrorFilterRule), error;
        }
        cdk.requireProperty(props, "destinationCidrBlock", this), cdk.requireProperty(props, "ruleAction", this), cdk.requireProperty(props, "ruleNumber", this), cdk.requireProperty(props, "sourceCidrBlock", this), cdk.requireProperty(props, "trafficDirection", this), cdk.requireProperty(props, "trafficMirrorFilterId", this), this.destinationCidrBlock = props.destinationCidrBlock, this.ruleAction = props.ruleAction, this.ruleNumber = props.ruleNumber, this.sourceCidrBlock = props.sourceCidrBlock, this.trafficDirection = props.trafficDirection, this.trafficMirrorFilterId = props.trafficMirrorFilterId, this.description = props.description, this.destinationPortRange = props.destinationPortRange, this.protocol = props.protocol, this.sourcePortRange = props.sourcePortRange;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTrafficMirrorFilterRule.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { destinationCidrBlock: this.destinationCidrBlock, ruleAction: this.ruleAction, ruleNumber: this.ruleNumber, sourceCidrBlock: this.sourceCidrBlock, trafficDirection: this.trafficDirection, trafficMirrorFilterId: this.trafficMirrorFilterId, description: this.description, destinationPortRange: this.destinationPortRange, protocol: this.protocol, sourcePortRange: this.sourcePortRange };
      }
      renderProperties(props) {
        return cfnTrafficMirrorFilterRulePropsToCloudFormation(props);
      }
    };
    _32 = JSII_RTTI_SYMBOL_1, CfnTrafficMirrorFilterRule[_32] = { fqn: "aws-cdk-lib.aws_ec2.CfnTrafficMirrorFilterRule", version: "2.80.0" }, CfnTrafficMirrorFilterRule.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::TrafficMirrorFilterRule", exports2.CfnTrafficMirrorFilterRule = CfnTrafficMirrorFilterRule;
    function CfnTrafficMirrorFilterRule_TrafficMirrorPortRangePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fromPort", cdk.requiredValidator)(properties.fromPort)), errors.collect(cdk.propertyValidator("fromPort", cdk.validateNumber)(properties.fromPort)), errors.collect(cdk.propertyValidator("toPort", cdk.requiredValidator)(properties.toPort)), errors.collect(cdk.propertyValidator("toPort", cdk.validateNumber)(properties.toPort)), errors.wrap('supplied properties not correct for "TrafficMirrorPortRangeProperty"');
    }
    function cfnTrafficMirrorFilterRuleTrafficMirrorPortRangePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTrafficMirrorFilterRule_TrafficMirrorPortRangePropertyValidator(properties).assertSuccess(), { FromPort: cdk.numberToCloudFormation(properties.fromPort), ToPort: cdk.numberToCloudFormation(properties.toPort) }) : properties;
    }
    function CfnTrafficMirrorFilterRuleTrafficMirrorPortRangePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fromPort", "FromPort", cfn_parse.FromCloudFormation.getNumber(properties.FromPort)), ret.addPropertyResult("toPort", "ToPort", cfn_parse.FromCloudFormation.getNumber(properties.ToPort)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTrafficMirrorSessionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("networkInterfaceId", cdk.requiredValidator)(properties.networkInterfaceId)), errors.collect(cdk.propertyValidator("networkInterfaceId", cdk.validateString)(properties.networkInterfaceId)), errors.collect(cdk.propertyValidator("packetLength", cdk.validateNumber)(properties.packetLength)), errors.collect(cdk.propertyValidator("sessionNumber", cdk.requiredValidator)(properties.sessionNumber)), errors.collect(cdk.propertyValidator("sessionNumber", cdk.validateNumber)(properties.sessionNumber)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("trafficMirrorFilterId", cdk.requiredValidator)(properties.trafficMirrorFilterId)), errors.collect(cdk.propertyValidator("trafficMirrorFilterId", cdk.validateString)(properties.trafficMirrorFilterId)), errors.collect(cdk.propertyValidator("trafficMirrorTargetId", cdk.requiredValidator)(properties.trafficMirrorTargetId)), errors.collect(cdk.propertyValidator("trafficMirrorTargetId", cdk.validateString)(properties.trafficMirrorTargetId)), errors.collect(cdk.propertyValidator("virtualNetworkId", cdk.validateNumber)(properties.virtualNetworkId)), errors.wrap('supplied properties not correct for "CfnTrafficMirrorSessionProps"');
    }
    function cfnTrafficMirrorSessionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTrafficMirrorSessionPropsValidator(properties).assertSuccess(), { NetworkInterfaceId: cdk.stringToCloudFormation(properties.networkInterfaceId), SessionNumber: cdk.numberToCloudFormation(properties.sessionNumber), TrafficMirrorFilterId: cdk.stringToCloudFormation(properties.trafficMirrorFilterId), TrafficMirrorTargetId: cdk.stringToCloudFormation(properties.trafficMirrorTargetId), Description: cdk.stringToCloudFormation(properties.description), PacketLength: cdk.numberToCloudFormation(properties.packetLength), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VirtualNetworkId: cdk.numberToCloudFormation(properties.virtualNetworkId) }) : properties;
    }
    function CfnTrafficMirrorSessionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("networkInterfaceId", "NetworkInterfaceId", cfn_parse.FromCloudFormation.getString(properties.NetworkInterfaceId)), ret.addPropertyResult("sessionNumber", "SessionNumber", cfn_parse.FromCloudFormation.getNumber(properties.SessionNumber)), ret.addPropertyResult("trafficMirrorFilterId", "TrafficMirrorFilterId", cfn_parse.FromCloudFormation.getString(properties.TrafficMirrorFilterId)), ret.addPropertyResult("trafficMirrorTargetId", "TrafficMirrorTargetId", cfn_parse.FromCloudFormation.getString(properties.TrafficMirrorTargetId)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("packetLength", "PacketLength", properties.PacketLength != null ? cfn_parse.FromCloudFormation.getNumber(properties.PacketLength) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("virtualNetworkId", "VirtualNetworkId", properties.VirtualNetworkId != null ? cfn_parse.FromCloudFormation.getNumber(properties.VirtualNetworkId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTrafficMirrorSession = class _CfnTrafficMirrorSession extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTrafficMirrorSessionPropsFromCloudFormation(resourceProperties), ret = new _CfnTrafficMirrorSession(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTrafficMirrorSession.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnTrafficMirrorSessionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTrafficMirrorSession), error;
        }
        cdk.requireProperty(props, "networkInterfaceId", this), cdk.requireProperty(props, "sessionNumber", this), cdk.requireProperty(props, "trafficMirrorFilterId", this), cdk.requireProperty(props, "trafficMirrorTargetId", this), this.networkInterfaceId = props.networkInterfaceId, this.sessionNumber = props.sessionNumber, this.trafficMirrorFilterId = props.trafficMirrorFilterId, this.trafficMirrorTargetId = props.trafficMirrorTargetId, this.description = props.description, this.packetLength = props.packetLength, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::TrafficMirrorSession", props.tags, { tagPropertyName: "tags" }), this.virtualNetworkId = props.virtualNetworkId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTrafficMirrorSession.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { networkInterfaceId: this.networkInterfaceId, sessionNumber: this.sessionNumber, trafficMirrorFilterId: this.trafficMirrorFilterId, trafficMirrorTargetId: this.trafficMirrorTargetId, description: this.description, packetLength: this.packetLength, tags: this.tags.renderTags(), virtualNetworkId: this.virtualNetworkId };
      }
      renderProperties(props) {
        return cfnTrafficMirrorSessionPropsToCloudFormation(props);
      }
    };
    _33 = JSII_RTTI_SYMBOL_1, CfnTrafficMirrorSession[_33] = { fqn: "aws-cdk-lib.aws_ec2.CfnTrafficMirrorSession", version: "2.80.0" }, CfnTrafficMirrorSession.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::TrafficMirrorSession", exports2.CfnTrafficMirrorSession = CfnTrafficMirrorSession;
    function CfnTrafficMirrorTargetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("gatewayLoadBalancerEndpointId", cdk.validateString)(properties.gatewayLoadBalancerEndpointId)), errors.collect(cdk.propertyValidator("networkInterfaceId", cdk.validateString)(properties.networkInterfaceId)), errors.collect(cdk.propertyValidator("networkLoadBalancerArn", cdk.validateString)(properties.networkLoadBalancerArn)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnTrafficMirrorTargetProps"');
    }
    function cfnTrafficMirrorTargetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTrafficMirrorTargetPropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), GatewayLoadBalancerEndpointId: cdk.stringToCloudFormation(properties.gatewayLoadBalancerEndpointId), NetworkInterfaceId: cdk.stringToCloudFormation(properties.networkInterfaceId), NetworkLoadBalancerArn: cdk.stringToCloudFormation(properties.networkLoadBalancerArn), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnTrafficMirrorTargetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("gatewayLoadBalancerEndpointId", "GatewayLoadBalancerEndpointId", properties.GatewayLoadBalancerEndpointId != null ? cfn_parse.FromCloudFormation.getString(properties.GatewayLoadBalancerEndpointId) : void 0), ret.addPropertyResult("networkInterfaceId", "NetworkInterfaceId", properties.NetworkInterfaceId != null ? cfn_parse.FromCloudFormation.getString(properties.NetworkInterfaceId) : void 0), ret.addPropertyResult("networkLoadBalancerArn", "NetworkLoadBalancerArn", properties.NetworkLoadBalancerArn != null ? cfn_parse.FromCloudFormation.getString(properties.NetworkLoadBalancerArn) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTrafficMirrorTarget = class _CfnTrafficMirrorTarget extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTrafficMirrorTargetPropsFromCloudFormation(resourceProperties), ret = new _CfnTrafficMirrorTarget(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnTrafficMirrorTarget.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnTrafficMirrorTargetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTrafficMirrorTarget), error;
        }
        this.description = props.description, this.gatewayLoadBalancerEndpointId = props.gatewayLoadBalancerEndpointId, this.networkInterfaceId = props.networkInterfaceId, this.networkLoadBalancerArn = props.networkLoadBalancerArn, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::TrafficMirrorTarget", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTrafficMirrorTarget.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, gatewayLoadBalancerEndpointId: this.gatewayLoadBalancerEndpointId, networkInterfaceId: this.networkInterfaceId, networkLoadBalancerArn: this.networkLoadBalancerArn, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnTrafficMirrorTargetPropsToCloudFormation(props);
      }
    };
    _34 = JSII_RTTI_SYMBOL_1, CfnTrafficMirrorTarget[_34] = { fqn: "aws-cdk-lib.aws_ec2.CfnTrafficMirrorTarget", version: "2.80.0" }, CfnTrafficMirrorTarget.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::TrafficMirrorTarget", exports2.CfnTrafficMirrorTarget = CfnTrafficMirrorTarget;
    function CfnTransitGatewayPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("amazonSideAsn", cdk.validateNumber)(properties.amazonSideAsn)), errors.collect(cdk.propertyValidator("associationDefaultRouteTableId", cdk.validateString)(properties.associationDefaultRouteTableId)), errors.collect(cdk.propertyValidator("autoAcceptSharedAttachments", cdk.validateString)(properties.autoAcceptSharedAttachments)), errors.collect(cdk.propertyValidator("defaultRouteTableAssociation", cdk.validateString)(properties.defaultRouteTableAssociation)), errors.collect(cdk.propertyValidator("defaultRouteTablePropagation", cdk.validateString)(properties.defaultRouteTablePropagation)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("dnsSupport", cdk.validateString)(properties.dnsSupport)), errors.collect(cdk.propertyValidator("multicastSupport", cdk.validateString)(properties.multicastSupport)), errors.collect(cdk.propertyValidator("propagationDefaultRouteTableId", cdk.validateString)(properties.propagationDefaultRouteTableId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("transitGatewayCidrBlocks", cdk.listValidator(cdk.validateString))(properties.transitGatewayCidrBlocks)), errors.collect(cdk.propertyValidator("vpnEcmpSupport", cdk.validateString)(properties.vpnEcmpSupport)), errors.wrap('supplied properties not correct for "CfnTransitGatewayProps"');
    }
    function cfnTransitGatewayPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTransitGatewayPropsValidator(properties).assertSuccess(), { AmazonSideAsn: cdk.numberToCloudFormation(properties.amazonSideAsn), AssociationDefaultRouteTableId: cdk.stringToCloudFormation(properties.associationDefaultRouteTableId), AutoAcceptSharedAttachments: cdk.stringToCloudFormation(properties.autoAcceptSharedAttachments), DefaultRouteTableAssociation: cdk.stringToCloudFormation(properties.defaultRouteTableAssociation), DefaultRouteTablePropagation: cdk.stringToCloudFormation(properties.defaultRouteTablePropagation), Description: cdk.stringToCloudFormation(properties.description), DnsSupport: cdk.stringToCloudFormation(properties.dnsSupport), MulticastSupport: cdk.stringToCloudFormation(properties.multicastSupport), PropagationDefaultRouteTableId: cdk.stringToCloudFormation(properties.propagationDefaultRouteTableId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TransitGatewayCidrBlocks: cdk.listMapper(cdk.stringToCloudFormation)(properties.transitGatewayCidrBlocks), VpnEcmpSupport: cdk.stringToCloudFormation(properties.vpnEcmpSupport) }) : properties;
    }
    function CfnTransitGatewayPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("amazonSideAsn", "AmazonSideAsn", properties.AmazonSideAsn != null ? cfn_parse.FromCloudFormation.getNumber(properties.AmazonSideAsn) : void 0), ret.addPropertyResult("associationDefaultRouteTableId", "AssociationDefaultRouteTableId", properties.AssociationDefaultRouteTableId != null ? cfn_parse.FromCloudFormation.getString(properties.AssociationDefaultRouteTableId) : void 0), ret.addPropertyResult("autoAcceptSharedAttachments", "AutoAcceptSharedAttachments", properties.AutoAcceptSharedAttachments != null ? cfn_parse.FromCloudFormation.getString(properties.AutoAcceptSharedAttachments) : void 0), ret.addPropertyResult("defaultRouteTableAssociation", "DefaultRouteTableAssociation", properties.DefaultRouteTableAssociation != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultRouteTableAssociation) : void 0), ret.addPropertyResult("defaultRouteTablePropagation", "DefaultRouteTablePropagation", properties.DefaultRouteTablePropagation != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultRouteTablePropagation) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("dnsSupport", "DnsSupport", properties.DnsSupport != null ? cfn_parse.FromCloudFormation.getString(properties.DnsSupport) : void 0), ret.addPropertyResult("multicastSupport", "MulticastSupport", properties.MulticastSupport != null ? cfn_parse.FromCloudFormation.getString(properties.MulticastSupport) : void 0), ret.addPropertyResult("propagationDefaultRouteTableId", "PropagationDefaultRouteTableId", properties.PropagationDefaultRouteTableId != null ? cfn_parse.FromCloudFormation.getString(properties.PropagationDefaultRouteTableId) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("transitGatewayCidrBlocks", "TransitGatewayCidrBlocks", properties.TransitGatewayCidrBlocks != null ? cfn_parse.FromCloudFormation.getStringArray(properties.TransitGatewayCidrBlocks) : void 0), ret.addPropertyResult("vpnEcmpSupport", "VpnEcmpSupport", properties.VpnEcmpSupport != null ? cfn_parse.FromCloudFormation.getString(properties.VpnEcmpSupport) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTransitGateway = class _CfnTransitGateway extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTransitGatewayPropsFromCloudFormation(resourceProperties), ret = new _CfnTransitGateway(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnTransitGateway.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnTransitGatewayProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTransitGateway), error;
        }
        this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.amazonSideAsn = props.amazonSideAsn, this.associationDefaultRouteTableId = props.associationDefaultRouteTableId, this.autoAcceptSharedAttachments = props.autoAcceptSharedAttachments, this.defaultRouteTableAssociation = props.defaultRouteTableAssociation, this.defaultRouteTablePropagation = props.defaultRouteTablePropagation, this.description = props.description, this.dnsSupport = props.dnsSupport, this.multicastSupport = props.multicastSupport, this.propagationDefaultRouteTableId = props.propagationDefaultRouteTableId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::TransitGateway", props.tags, { tagPropertyName: "tags" }), this.transitGatewayCidrBlocks = props.transitGatewayCidrBlocks, this.vpnEcmpSupport = props.vpnEcmpSupport;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTransitGateway.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { amazonSideAsn: this.amazonSideAsn, associationDefaultRouteTableId: this.associationDefaultRouteTableId, autoAcceptSharedAttachments: this.autoAcceptSharedAttachments, defaultRouteTableAssociation: this.defaultRouteTableAssociation, defaultRouteTablePropagation: this.defaultRouteTablePropagation, description: this.description, dnsSupport: this.dnsSupport, multicastSupport: this.multicastSupport, propagationDefaultRouteTableId: this.propagationDefaultRouteTableId, tags: this.tags.renderTags(), transitGatewayCidrBlocks: this.transitGatewayCidrBlocks, vpnEcmpSupport: this.vpnEcmpSupport };
      }
      renderProperties(props) {
        return cfnTransitGatewayPropsToCloudFormation(props);
      }
    };
    _35 = JSII_RTTI_SYMBOL_1, CfnTransitGateway[_35] = { fqn: "aws-cdk-lib.aws_ec2.CfnTransitGateway", version: "2.80.0" }, CfnTransitGateway.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::TransitGateway", exports2.CfnTransitGateway = CfnTransitGateway;
    function CfnTransitGatewayAttachmentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("options", cdk.validateObject)(properties.options)), errors.collect(cdk.propertyValidator("subnetIds", cdk.requiredValidator)(properties.subnetIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("transitGatewayId", cdk.requiredValidator)(properties.transitGatewayId)), errors.collect(cdk.propertyValidator("transitGatewayId", cdk.validateString)(properties.transitGatewayId)), errors.collect(cdk.propertyValidator("vpcId", cdk.requiredValidator)(properties.vpcId)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "CfnTransitGatewayAttachmentProps"');
    }
    function cfnTransitGatewayAttachmentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTransitGatewayAttachmentPropsValidator(properties).assertSuccess(), { SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds), TransitGatewayId: cdk.stringToCloudFormation(properties.transitGatewayId), VpcId: cdk.stringToCloudFormation(properties.vpcId), Options: cdk.objectToCloudFormation(properties.options), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnTransitGatewayAttachmentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("subnetIds", "SubnetIds", cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds)), ret.addPropertyResult("transitGatewayId", "TransitGatewayId", cfn_parse.FromCloudFormation.getString(properties.TransitGatewayId)), ret.addPropertyResult("vpcId", "VpcId", cfn_parse.FromCloudFormation.getString(properties.VpcId)), ret.addPropertyResult("options", "Options", properties.Options != null ? cfn_parse.FromCloudFormation.getAny(properties.Options) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTransitGatewayAttachment = class _CfnTransitGatewayAttachment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTransitGatewayAttachmentPropsFromCloudFormation(resourceProperties), ret = new _CfnTransitGatewayAttachment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTransitGatewayAttachment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnTransitGatewayAttachmentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTransitGatewayAttachment), error;
        }
        cdk.requireProperty(props, "subnetIds", this), cdk.requireProperty(props, "transitGatewayId", this), cdk.requireProperty(props, "vpcId", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.subnetIds = props.subnetIds, this.transitGatewayId = props.transitGatewayId, this.vpcId = props.vpcId, this.options = props.options, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::TransitGatewayAttachment", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTransitGatewayAttachment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { subnetIds: this.subnetIds, transitGatewayId: this.transitGatewayId, vpcId: this.vpcId, options: this.options, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnTransitGatewayAttachmentPropsToCloudFormation(props);
      }
    };
    _36 = JSII_RTTI_SYMBOL_1, CfnTransitGatewayAttachment[_36] = { fqn: "aws-cdk-lib.aws_ec2.CfnTransitGatewayAttachment", version: "2.80.0" }, CfnTransitGatewayAttachment.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::TransitGatewayAttachment", exports2.CfnTransitGatewayAttachment = CfnTransitGatewayAttachment;
    function CfnTransitGatewayConnectPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("options", cdk.requiredValidator)(properties.options)), errors.collect(cdk.propertyValidator("options", CfnTransitGatewayConnect_TransitGatewayConnectOptionsPropertyValidator)(properties.options)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("transportTransitGatewayAttachmentId", cdk.requiredValidator)(properties.transportTransitGatewayAttachmentId)), errors.collect(cdk.propertyValidator("transportTransitGatewayAttachmentId", cdk.validateString)(properties.transportTransitGatewayAttachmentId)), errors.wrap('supplied properties not correct for "CfnTransitGatewayConnectProps"');
    }
    function cfnTransitGatewayConnectPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTransitGatewayConnectPropsValidator(properties).assertSuccess(), { Options: cfnTransitGatewayConnectTransitGatewayConnectOptionsPropertyToCloudFormation(properties.options), TransportTransitGatewayAttachmentId: cdk.stringToCloudFormation(properties.transportTransitGatewayAttachmentId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnTransitGatewayConnectPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("options", "Options", CfnTransitGatewayConnectTransitGatewayConnectOptionsPropertyFromCloudFormation(properties.Options)), ret.addPropertyResult("transportTransitGatewayAttachmentId", "TransportTransitGatewayAttachmentId", cfn_parse.FromCloudFormation.getString(properties.TransportTransitGatewayAttachmentId)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTransitGatewayConnect = class _CfnTransitGatewayConnect extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTransitGatewayConnectPropsFromCloudFormation(resourceProperties), ret = new _CfnTransitGatewayConnect(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTransitGatewayConnect.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnTransitGatewayConnectProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTransitGatewayConnect), error;
        }
        cdk.requireProperty(props, "options", this), cdk.requireProperty(props, "transportTransitGatewayAttachmentId", this), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrState = cdk.Token.asString(this.getAtt("State", cdk.ResolutionTypeHint.STRING)), this.attrTransitGatewayAttachmentId = cdk.Token.asString(this.getAtt("TransitGatewayAttachmentId", cdk.ResolutionTypeHint.STRING)), this.attrTransitGatewayId = cdk.Token.asString(this.getAtt("TransitGatewayId", cdk.ResolutionTypeHint.STRING)), this.options = props.options, this.transportTransitGatewayAttachmentId = props.transportTransitGatewayAttachmentId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::TransitGatewayConnect", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTransitGatewayConnect.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { options: this.options, transportTransitGatewayAttachmentId: this.transportTransitGatewayAttachmentId, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnTransitGatewayConnectPropsToCloudFormation(props);
      }
    };
    _37 = JSII_RTTI_SYMBOL_1, CfnTransitGatewayConnect[_37] = { fqn: "aws-cdk-lib.aws_ec2.CfnTransitGatewayConnect", version: "2.80.0" }, CfnTransitGatewayConnect.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::TransitGatewayConnect", exports2.CfnTransitGatewayConnect = CfnTransitGatewayConnect;
    function CfnTransitGatewayConnect_TransitGatewayConnectOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.wrap('supplied properties not correct for "TransitGatewayConnectOptionsProperty"');
    }
    function cfnTransitGatewayConnectTransitGatewayConnectOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTransitGatewayConnect_TransitGatewayConnectOptionsPropertyValidator(properties).assertSuccess(), { Protocol: cdk.stringToCloudFormation(properties.protocol) }) : properties;
    }
    function CfnTransitGatewayConnectTransitGatewayConnectOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("protocol", "Protocol", properties.Protocol != null ? cfn_parse.FromCloudFormation.getString(properties.Protocol) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTransitGatewayMulticastDomainPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("options", cdk.validateObject)(properties.options)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("transitGatewayId", cdk.requiredValidator)(properties.transitGatewayId)), errors.collect(cdk.propertyValidator("transitGatewayId", cdk.validateString)(properties.transitGatewayId)), errors.wrap('supplied properties not correct for "CfnTransitGatewayMulticastDomainProps"');
    }
    function cfnTransitGatewayMulticastDomainPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTransitGatewayMulticastDomainPropsValidator(properties).assertSuccess(), { TransitGatewayId: cdk.stringToCloudFormation(properties.transitGatewayId), Options: cdk.objectToCloudFormation(properties.options), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnTransitGatewayMulticastDomainPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("transitGatewayId", "TransitGatewayId", cfn_parse.FromCloudFormation.getString(properties.TransitGatewayId)), ret.addPropertyResult("options", "Options", properties.Options != null ? cfn_parse.FromCloudFormation.getAny(properties.Options) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTransitGatewayMulticastDomain = class _CfnTransitGatewayMulticastDomain extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTransitGatewayMulticastDomainPropsFromCloudFormation(resourceProperties), ret = new _CfnTransitGatewayMulticastDomain(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTransitGatewayMulticastDomain.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnTransitGatewayMulticastDomainProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTransitGatewayMulticastDomain), error;
        }
        cdk.requireProperty(props, "transitGatewayId", this), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrState = cdk.Token.asString(this.getAtt("State", cdk.ResolutionTypeHint.STRING)), this.attrTransitGatewayMulticastDomainArn = cdk.Token.asString(this.getAtt("TransitGatewayMulticastDomainArn", cdk.ResolutionTypeHint.STRING)), this.attrTransitGatewayMulticastDomainId = cdk.Token.asString(this.getAtt("TransitGatewayMulticastDomainId", cdk.ResolutionTypeHint.STRING)), this.transitGatewayId = props.transitGatewayId, this.options = props.options, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::TransitGatewayMulticastDomain", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTransitGatewayMulticastDomain.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { transitGatewayId: this.transitGatewayId, options: this.options, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnTransitGatewayMulticastDomainPropsToCloudFormation(props);
      }
    };
    _38 = JSII_RTTI_SYMBOL_1, CfnTransitGatewayMulticastDomain[_38] = { fqn: "aws-cdk-lib.aws_ec2.CfnTransitGatewayMulticastDomain", version: "2.80.0" }, CfnTransitGatewayMulticastDomain.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::TransitGatewayMulticastDomain", exports2.CfnTransitGatewayMulticastDomain = CfnTransitGatewayMulticastDomain;
    function CfnTransitGatewayMulticastDomainAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("subnetId", cdk.requiredValidator)(properties.subnetId)), errors.collect(cdk.propertyValidator("subnetId", cdk.validateString)(properties.subnetId)), errors.collect(cdk.propertyValidator("transitGatewayAttachmentId", cdk.requiredValidator)(properties.transitGatewayAttachmentId)), errors.collect(cdk.propertyValidator("transitGatewayAttachmentId", cdk.validateString)(properties.transitGatewayAttachmentId)), errors.collect(cdk.propertyValidator("transitGatewayMulticastDomainId", cdk.requiredValidator)(properties.transitGatewayMulticastDomainId)), errors.collect(cdk.propertyValidator("transitGatewayMulticastDomainId", cdk.validateString)(properties.transitGatewayMulticastDomainId)), errors.wrap('supplied properties not correct for "CfnTransitGatewayMulticastDomainAssociationProps"');
    }
    function cfnTransitGatewayMulticastDomainAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTransitGatewayMulticastDomainAssociationPropsValidator(properties).assertSuccess(), { SubnetId: cdk.stringToCloudFormation(properties.subnetId), TransitGatewayAttachmentId: cdk.stringToCloudFormation(properties.transitGatewayAttachmentId), TransitGatewayMulticastDomainId: cdk.stringToCloudFormation(properties.transitGatewayMulticastDomainId) }) : properties;
    }
    function CfnTransitGatewayMulticastDomainAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("subnetId", "SubnetId", cfn_parse.FromCloudFormation.getString(properties.SubnetId)), ret.addPropertyResult("transitGatewayAttachmentId", "TransitGatewayAttachmentId", cfn_parse.FromCloudFormation.getString(properties.TransitGatewayAttachmentId)), ret.addPropertyResult("transitGatewayMulticastDomainId", "TransitGatewayMulticastDomainId", cfn_parse.FromCloudFormation.getString(properties.TransitGatewayMulticastDomainId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTransitGatewayMulticastDomainAssociation = class _CfnTransitGatewayMulticastDomainAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTransitGatewayMulticastDomainAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnTransitGatewayMulticastDomainAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTransitGatewayMulticastDomainAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnTransitGatewayMulticastDomainAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTransitGatewayMulticastDomainAssociation), error;
        }
        cdk.requireProperty(props, "subnetId", this), cdk.requireProperty(props, "transitGatewayAttachmentId", this), cdk.requireProperty(props, "transitGatewayMulticastDomainId", this), this.attrResourceId = cdk.Token.asString(this.getAtt("ResourceId", cdk.ResolutionTypeHint.STRING)), this.attrResourceType = cdk.Token.asString(this.getAtt("ResourceType", cdk.ResolutionTypeHint.STRING)), this.attrState = cdk.Token.asString(this.getAtt("State", cdk.ResolutionTypeHint.STRING)), this.subnetId = props.subnetId, this.transitGatewayAttachmentId = props.transitGatewayAttachmentId, this.transitGatewayMulticastDomainId = props.transitGatewayMulticastDomainId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTransitGatewayMulticastDomainAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { subnetId: this.subnetId, transitGatewayAttachmentId: this.transitGatewayAttachmentId, transitGatewayMulticastDomainId: this.transitGatewayMulticastDomainId };
      }
      renderProperties(props) {
        return cfnTransitGatewayMulticastDomainAssociationPropsToCloudFormation(props);
      }
    };
    _39 = JSII_RTTI_SYMBOL_1, CfnTransitGatewayMulticastDomainAssociation[_39] = { fqn: "aws-cdk-lib.aws_ec2.CfnTransitGatewayMulticastDomainAssociation", version: "2.80.0" }, CfnTransitGatewayMulticastDomainAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::TransitGatewayMulticastDomainAssociation", exports2.CfnTransitGatewayMulticastDomainAssociation = CfnTransitGatewayMulticastDomainAssociation;
    function CfnTransitGatewayMulticastGroupMemberPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groupIpAddress", cdk.requiredValidator)(properties.groupIpAddress)), errors.collect(cdk.propertyValidator("groupIpAddress", cdk.validateString)(properties.groupIpAddress)), errors.collect(cdk.propertyValidator("networkInterfaceId", cdk.requiredValidator)(properties.networkInterfaceId)), errors.collect(cdk.propertyValidator("networkInterfaceId", cdk.validateString)(properties.networkInterfaceId)), errors.collect(cdk.propertyValidator("transitGatewayMulticastDomainId", cdk.requiredValidator)(properties.transitGatewayMulticastDomainId)), errors.collect(cdk.propertyValidator("transitGatewayMulticastDomainId", cdk.validateString)(properties.transitGatewayMulticastDomainId)), errors.wrap('supplied properties not correct for "CfnTransitGatewayMulticastGroupMemberProps"');
    }
    function cfnTransitGatewayMulticastGroupMemberPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTransitGatewayMulticastGroupMemberPropsValidator(properties).assertSuccess(), { GroupIpAddress: cdk.stringToCloudFormation(properties.groupIpAddress), NetworkInterfaceId: cdk.stringToCloudFormation(properties.networkInterfaceId), TransitGatewayMulticastDomainId: cdk.stringToCloudFormation(properties.transitGatewayMulticastDomainId) }) : properties;
    }
    function CfnTransitGatewayMulticastGroupMemberPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupIpAddress", "GroupIpAddress", cfn_parse.FromCloudFormation.getString(properties.GroupIpAddress)), ret.addPropertyResult("networkInterfaceId", "NetworkInterfaceId", cfn_parse.FromCloudFormation.getString(properties.NetworkInterfaceId)), ret.addPropertyResult("transitGatewayMulticastDomainId", "TransitGatewayMulticastDomainId", cfn_parse.FromCloudFormation.getString(properties.TransitGatewayMulticastDomainId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTransitGatewayMulticastGroupMember = class _CfnTransitGatewayMulticastGroupMember extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTransitGatewayMulticastGroupMemberPropsFromCloudFormation(resourceProperties), ret = new _CfnTransitGatewayMulticastGroupMember(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTransitGatewayMulticastGroupMember.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnTransitGatewayMulticastGroupMemberProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTransitGatewayMulticastGroupMember), error;
        }
        cdk.requireProperty(props, "groupIpAddress", this), cdk.requireProperty(props, "networkInterfaceId", this), cdk.requireProperty(props, "transitGatewayMulticastDomainId", this), this.attrGroupMember = this.getAtt("GroupMember", cdk.ResolutionTypeHint.STRING), this.attrGroupSource = this.getAtt("GroupSource", cdk.ResolutionTypeHint.STRING), this.attrMemberType = cdk.Token.asString(this.getAtt("MemberType", cdk.ResolutionTypeHint.STRING)), this.attrResourceId = cdk.Token.asString(this.getAtt("ResourceId", cdk.ResolutionTypeHint.STRING)), this.attrResourceType = cdk.Token.asString(this.getAtt("ResourceType", cdk.ResolutionTypeHint.STRING)), this.attrSourceType = cdk.Token.asString(this.getAtt("SourceType", cdk.ResolutionTypeHint.STRING)), this.attrSubnetId = cdk.Token.asString(this.getAtt("SubnetId", cdk.ResolutionTypeHint.STRING)), this.attrTransitGatewayAttachmentId = cdk.Token.asString(this.getAtt("TransitGatewayAttachmentId", cdk.ResolutionTypeHint.STRING)), this.groupIpAddress = props.groupIpAddress, this.networkInterfaceId = props.networkInterfaceId, this.transitGatewayMulticastDomainId = props.transitGatewayMulticastDomainId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTransitGatewayMulticastGroupMember.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { groupIpAddress: this.groupIpAddress, networkInterfaceId: this.networkInterfaceId, transitGatewayMulticastDomainId: this.transitGatewayMulticastDomainId };
      }
      renderProperties(props) {
        return cfnTransitGatewayMulticastGroupMemberPropsToCloudFormation(props);
      }
    };
    _40 = JSII_RTTI_SYMBOL_1, CfnTransitGatewayMulticastGroupMember[_40] = { fqn: "aws-cdk-lib.aws_ec2.CfnTransitGatewayMulticastGroupMember", version: "2.80.0" }, CfnTransitGatewayMulticastGroupMember.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::TransitGatewayMulticastGroupMember", exports2.CfnTransitGatewayMulticastGroupMember = CfnTransitGatewayMulticastGroupMember;
    function CfnTransitGatewayMulticastGroupSourcePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groupIpAddress", cdk.requiredValidator)(properties.groupIpAddress)), errors.collect(cdk.propertyValidator("groupIpAddress", cdk.validateString)(properties.groupIpAddress)), errors.collect(cdk.propertyValidator("networkInterfaceId", cdk.requiredValidator)(properties.networkInterfaceId)), errors.collect(cdk.propertyValidator("networkInterfaceId", cdk.validateString)(properties.networkInterfaceId)), errors.collect(cdk.propertyValidator("transitGatewayMulticastDomainId", cdk.requiredValidator)(properties.transitGatewayMulticastDomainId)), errors.collect(cdk.propertyValidator("transitGatewayMulticastDomainId", cdk.validateString)(properties.transitGatewayMulticastDomainId)), errors.wrap('supplied properties not correct for "CfnTransitGatewayMulticastGroupSourceProps"');
    }
    function cfnTransitGatewayMulticastGroupSourcePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTransitGatewayMulticastGroupSourcePropsValidator(properties).assertSuccess(), { GroupIpAddress: cdk.stringToCloudFormation(properties.groupIpAddress), NetworkInterfaceId: cdk.stringToCloudFormation(properties.networkInterfaceId), TransitGatewayMulticastDomainId: cdk.stringToCloudFormation(properties.transitGatewayMulticastDomainId) }) : properties;
    }
    function CfnTransitGatewayMulticastGroupSourcePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupIpAddress", "GroupIpAddress", cfn_parse.FromCloudFormation.getString(properties.GroupIpAddress)), ret.addPropertyResult("networkInterfaceId", "NetworkInterfaceId", cfn_parse.FromCloudFormation.getString(properties.NetworkInterfaceId)), ret.addPropertyResult("transitGatewayMulticastDomainId", "TransitGatewayMulticastDomainId", cfn_parse.FromCloudFormation.getString(properties.TransitGatewayMulticastDomainId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTransitGatewayMulticastGroupSource = class _CfnTransitGatewayMulticastGroupSource extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTransitGatewayMulticastGroupSourcePropsFromCloudFormation(resourceProperties), ret = new _CfnTransitGatewayMulticastGroupSource(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTransitGatewayMulticastGroupSource.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnTransitGatewayMulticastGroupSourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTransitGatewayMulticastGroupSource), error;
        }
        cdk.requireProperty(props, "groupIpAddress", this), cdk.requireProperty(props, "networkInterfaceId", this), cdk.requireProperty(props, "transitGatewayMulticastDomainId", this), this.attrGroupMember = this.getAtt("GroupMember", cdk.ResolutionTypeHint.STRING), this.attrGroupSource = this.getAtt("GroupSource", cdk.ResolutionTypeHint.STRING), this.attrMemberType = cdk.Token.asString(this.getAtt("MemberType", cdk.ResolutionTypeHint.STRING)), this.attrResourceId = cdk.Token.asString(this.getAtt("ResourceId", cdk.ResolutionTypeHint.STRING)), this.attrResourceType = cdk.Token.asString(this.getAtt("ResourceType", cdk.ResolutionTypeHint.STRING)), this.attrSourceType = cdk.Token.asString(this.getAtt("SourceType", cdk.ResolutionTypeHint.STRING)), this.attrSubnetId = cdk.Token.asString(this.getAtt("SubnetId", cdk.ResolutionTypeHint.STRING)), this.attrTransitGatewayAttachmentId = cdk.Token.asString(this.getAtt("TransitGatewayAttachmentId", cdk.ResolutionTypeHint.STRING)), this.groupIpAddress = props.groupIpAddress, this.networkInterfaceId = props.networkInterfaceId, this.transitGatewayMulticastDomainId = props.transitGatewayMulticastDomainId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTransitGatewayMulticastGroupSource.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { groupIpAddress: this.groupIpAddress, networkInterfaceId: this.networkInterfaceId, transitGatewayMulticastDomainId: this.transitGatewayMulticastDomainId };
      }
      renderProperties(props) {
        return cfnTransitGatewayMulticastGroupSourcePropsToCloudFormation(props);
      }
    };
    _41 = JSII_RTTI_SYMBOL_1, CfnTransitGatewayMulticastGroupSource[_41] = { fqn: "aws-cdk-lib.aws_ec2.CfnTransitGatewayMulticastGroupSource", version: "2.80.0" }, CfnTransitGatewayMulticastGroupSource.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::TransitGatewayMulticastGroupSource", exports2.CfnTransitGatewayMulticastGroupSource = CfnTransitGatewayMulticastGroupSource;
    function CfnTransitGatewayPeeringAttachmentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("peerAccountId", cdk.requiredValidator)(properties.peerAccountId)), errors.collect(cdk.propertyValidator("peerAccountId", cdk.validateString)(properties.peerAccountId)), errors.collect(cdk.propertyValidator("peerRegion", cdk.requiredValidator)(properties.peerRegion)), errors.collect(cdk.propertyValidator("peerRegion", cdk.validateString)(properties.peerRegion)), errors.collect(cdk.propertyValidator("peerTransitGatewayId", cdk.requiredValidator)(properties.peerTransitGatewayId)), errors.collect(cdk.propertyValidator("peerTransitGatewayId", cdk.validateString)(properties.peerTransitGatewayId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("transitGatewayId", cdk.requiredValidator)(properties.transitGatewayId)), errors.collect(cdk.propertyValidator("transitGatewayId", cdk.validateString)(properties.transitGatewayId)), errors.wrap('supplied properties not correct for "CfnTransitGatewayPeeringAttachmentProps"');
    }
    function cfnTransitGatewayPeeringAttachmentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTransitGatewayPeeringAttachmentPropsValidator(properties).assertSuccess(), { PeerAccountId: cdk.stringToCloudFormation(properties.peerAccountId), PeerRegion: cdk.stringToCloudFormation(properties.peerRegion), PeerTransitGatewayId: cdk.stringToCloudFormation(properties.peerTransitGatewayId), TransitGatewayId: cdk.stringToCloudFormation(properties.transitGatewayId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnTransitGatewayPeeringAttachmentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("peerAccountId", "PeerAccountId", cfn_parse.FromCloudFormation.getString(properties.PeerAccountId)), ret.addPropertyResult("peerRegion", "PeerRegion", cfn_parse.FromCloudFormation.getString(properties.PeerRegion)), ret.addPropertyResult("peerTransitGatewayId", "PeerTransitGatewayId", cfn_parse.FromCloudFormation.getString(properties.PeerTransitGatewayId)), ret.addPropertyResult("transitGatewayId", "TransitGatewayId", cfn_parse.FromCloudFormation.getString(properties.TransitGatewayId)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTransitGatewayPeeringAttachment = class _CfnTransitGatewayPeeringAttachment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTransitGatewayPeeringAttachmentPropsFromCloudFormation(resourceProperties), ret = new _CfnTransitGatewayPeeringAttachment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTransitGatewayPeeringAttachment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnTransitGatewayPeeringAttachmentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTransitGatewayPeeringAttachment), error;
        }
        cdk.requireProperty(props, "peerAccountId", this), cdk.requireProperty(props, "peerRegion", this), cdk.requireProperty(props, "peerTransitGatewayId", this), cdk.requireProperty(props, "transitGatewayId", this), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrState = cdk.Token.asString(this.getAtt("State", cdk.ResolutionTypeHint.STRING)), this.attrStatusCode = cdk.Token.asString(this.getAtt("Status.Code", cdk.ResolutionTypeHint.STRING)), this.attrStatusMessage = cdk.Token.asString(this.getAtt("Status.Message", cdk.ResolutionTypeHint.STRING)), this.attrTransitGatewayAttachmentId = cdk.Token.asString(this.getAtt("TransitGatewayAttachmentId", cdk.ResolutionTypeHint.STRING)), this.peerAccountId = props.peerAccountId, this.peerRegion = props.peerRegion, this.peerTransitGatewayId = props.peerTransitGatewayId, this.transitGatewayId = props.transitGatewayId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::TransitGatewayPeeringAttachment", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTransitGatewayPeeringAttachment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { peerAccountId: this.peerAccountId, peerRegion: this.peerRegion, peerTransitGatewayId: this.peerTransitGatewayId, transitGatewayId: this.transitGatewayId, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnTransitGatewayPeeringAttachmentPropsToCloudFormation(props);
      }
    };
    _42 = JSII_RTTI_SYMBOL_1, CfnTransitGatewayPeeringAttachment[_42] = { fqn: "aws-cdk-lib.aws_ec2.CfnTransitGatewayPeeringAttachment", version: "2.80.0" }, CfnTransitGatewayPeeringAttachment.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::TransitGatewayPeeringAttachment", exports2.CfnTransitGatewayPeeringAttachment = CfnTransitGatewayPeeringAttachment;
    function CfnTransitGatewayRoutePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("blackhole", cdk.validateBoolean)(properties.blackhole)), errors.collect(cdk.propertyValidator("destinationCidrBlock", cdk.validateString)(properties.destinationCidrBlock)), errors.collect(cdk.propertyValidator("transitGatewayAttachmentId", cdk.validateString)(properties.transitGatewayAttachmentId)), errors.collect(cdk.propertyValidator("transitGatewayRouteTableId", cdk.requiredValidator)(properties.transitGatewayRouteTableId)), errors.collect(cdk.propertyValidator("transitGatewayRouteTableId", cdk.validateString)(properties.transitGatewayRouteTableId)), errors.wrap('supplied properties not correct for "CfnTransitGatewayRouteProps"');
    }
    function cfnTransitGatewayRoutePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTransitGatewayRoutePropsValidator(properties).assertSuccess(), { TransitGatewayRouteTableId: cdk.stringToCloudFormation(properties.transitGatewayRouteTableId), Blackhole: cdk.booleanToCloudFormation(properties.blackhole), DestinationCidrBlock: cdk.stringToCloudFormation(properties.destinationCidrBlock), TransitGatewayAttachmentId: cdk.stringToCloudFormation(properties.transitGatewayAttachmentId) }) : properties;
    }
    function CfnTransitGatewayRoutePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("transitGatewayRouteTableId", "TransitGatewayRouteTableId", cfn_parse.FromCloudFormation.getString(properties.TransitGatewayRouteTableId)), ret.addPropertyResult("blackhole", "Blackhole", properties.Blackhole != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Blackhole) : void 0), ret.addPropertyResult("destinationCidrBlock", "DestinationCidrBlock", properties.DestinationCidrBlock != null ? cfn_parse.FromCloudFormation.getString(properties.DestinationCidrBlock) : void 0), ret.addPropertyResult("transitGatewayAttachmentId", "TransitGatewayAttachmentId", properties.TransitGatewayAttachmentId != null ? cfn_parse.FromCloudFormation.getString(properties.TransitGatewayAttachmentId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTransitGatewayRoute = class _CfnTransitGatewayRoute extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTransitGatewayRoutePropsFromCloudFormation(resourceProperties), ret = new _CfnTransitGatewayRoute(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTransitGatewayRoute.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnTransitGatewayRouteProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTransitGatewayRoute), error;
        }
        cdk.requireProperty(props, "transitGatewayRouteTableId", this), this.transitGatewayRouteTableId = props.transitGatewayRouteTableId, this.blackhole = props.blackhole, this.destinationCidrBlock = props.destinationCidrBlock, this.transitGatewayAttachmentId = props.transitGatewayAttachmentId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTransitGatewayRoute.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { transitGatewayRouteTableId: this.transitGatewayRouteTableId, blackhole: this.blackhole, destinationCidrBlock: this.destinationCidrBlock, transitGatewayAttachmentId: this.transitGatewayAttachmentId };
      }
      renderProperties(props) {
        return cfnTransitGatewayRoutePropsToCloudFormation(props);
      }
    };
    _43 = JSII_RTTI_SYMBOL_1, CfnTransitGatewayRoute[_43] = { fqn: "aws-cdk-lib.aws_ec2.CfnTransitGatewayRoute", version: "2.80.0" }, CfnTransitGatewayRoute.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::TransitGatewayRoute", exports2.CfnTransitGatewayRoute = CfnTransitGatewayRoute;
    function CfnTransitGatewayRouteTablePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("transitGatewayId", cdk.requiredValidator)(properties.transitGatewayId)), errors.collect(cdk.propertyValidator("transitGatewayId", cdk.validateString)(properties.transitGatewayId)), errors.wrap('supplied properties not correct for "CfnTransitGatewayRouteTableProps"');
    }
    function cfnTransitGatewayRouteTablePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTransitGatewayRouteTablePropsValidator(properties).assertSuccess(), { TransitGatewayId: cdk.stringToCloudFormation(properties.transitGatewayId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnTransitGatewayRouteTablePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("transitGatewayId", "TransitGatewayId", cfn_parse.FromCloudFormation.getString(properties.TransitGatewayId)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTransitGatewayRouteTable = class _CfnTransitGatewayRouteTable extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTransitGatewayRouteTablePropsFromCloudFormation(resourceProperties), ret = new _CfnTransitGatewayRouteTable(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTransitGatewayRouteTable.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnTransitGatewayRouteTableProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTransitGatewayRouteTable), error;
        }
        cdk.requireProperty(props, "transitGatewayId", this), this.transitGatewayId = props.transitGatewayId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::TransitGatewayRouteTable", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTransitGatewayRouteTable.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { transitGatewayId: this.transitGatewayId, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnTransitGatewayRouteTablePropsToCloudFormation(props);
      }
    };
    _44 = JSII_RTTI_SYMBOL_1, CfnTransitGatewayRouteTable[_44] = { fqn: "aws-cdk-lib.aws_ec2.CfnTransitGatewayRouteTable", version: "2.80.0" }, CfnTransitGatewayRouteTable.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::TransitGatewayRouteTable", exports2.CfnTransitGatewayRouteTable = CfnTransitGatewayRouteTable;
    function CfnTransitGatewayRouteTableAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("transitGatewayAttachmentId", cdk.requiredValidator)(properties.transitGatewayAttachmentId)), errors.collect(cdk.propertyValidator("transitGatewayAttachmentId", cdk.validateString)(properties.transitGatewayAttachmentId)), errors.collect(cdk.propertyValidator("transitGatewayRouteTableId", cdk.requiredValidator)(properties.transitGatewayRouteTableId)), errors.collect(cdk.propertyValidator("transitGatewayRouteTableId", cdk.validateString)(properties.transitGatewayRouteTableId)), errors.wrap('supplied properties not correct for "CfnTransitGatewayRouteTableAssociationProps"');
    }
    function cfnTransitGatewayRouteTableAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTransitGatewayRouteTableAssociationPropsValidator(properties).assertSuccess(), { TransitGatewayAttachmentId: cdk.stringToCloudFormation(properties.transitGatewayAttachmentId), TransitGatewayRouteTableId: cdk.stringToCloudFormation(properties.transitGatewayRouteTableId) }) : properties;
    }
    function CfnTransitGatewayRouteTableAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("transitGatewayAttachmentId", "TransitGatewayAttachmentId", cfn_parse.FromCloudFormation.getString(properties.TransitGatewayAttachmentId)), ret.addPropertyResult("transitGatewayRouteTableId", "TransitGatewayRouteTableId", cfn_parse.FromCloudFormation.getString(properties.TransitGatewayRouteTableId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTransitGatewayRouteTableAssociation = class _CfnTransitGatewayRouteTableAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTransitGatewayRouteTableAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnTransitGatewayRouteTableAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTransitGatewayRouteTableAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnTransitGatewayRouteTableAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTransitGatewayRouteTableAssociation), error;
        }
        cdk.requireProperty(props, "transitGatewayAttachmentId", this), cdk.requireProperty(props, "transitGatewayRouteTableId", this), this.transitGatewayAttachmentId = props.transitGatewayAttachmentId, this.transitGatewayRouteTableId = props.transitGatewayRouteTableId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTransitGatewayRouteTableAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { transitGatewayAttachmentId: this.transitGatewayAttachmentId, transitGatewayRouteTableId: this.transitGatewayRouteTableId };
      }
      renderProperties(props) {
        return cfnTransitGatewayRouteTableAssociationPropsToCloudFormation(props);
      }
    };
    _45 = JSII_RTTI_SYMBOL_1, CfnTransitGatewayRouteTableAssociation[_45] = { fqn: "aws-cdk-lib.aws_ec2.CfnTransitGatewayRouteTableAssociation", version: "2.80.0" }, CfnTransitGatewayRouteTableAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::TransitGatewayRouteTableAssociation", exports2.CfnTransitGatewayRouteTableAssociation = CfnTransitGatewayRouteTableAssociation;
    function CfnTransitGatewayRouteTablePropagationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("transitGatewayAttachmentId", cdk.requiredValidator)(properties.transitGatewayAttachmentId)), errors.collect(cdk.propertyValidator("transitGatewayAttachmentId", cdk.validateString)(properties.transitGatewayAttachmentId)), errors.collect(cdk.propertyValidator("transitGatewayRouteTableId", cdk.requiredValidator)(properties.transitGatewayRouteTableId)), errors.collect(cdk.propertyValidator("transitGatewayRouteTableId", cdk.validateString)(properties.transitGatewayRouteTableId)), errors.wrap('supplied properties not correct for "CfnTransitGatewayRouteTablePropagationProps"');
    }
    function cfnTransitGatewayRouteTablePropagationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTransitGatewayRouteTablePropagationPropsValidator(properties).assertSuccess(), { TransitGatewayAttachmentId: cdk.stringToCloudFormation(properties.transitGatewayAttachmentId), TransitGatewayRouteTableId: cdk.stringToCloudFormation(properties.transitGatewayRouteTableId) }) : properties;
    }
    function CfnTransitGatewayRouteTablePropagationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("transitGatewayAttachmentId", "TransitGatewayAttachmentId", cfn_parse.FromCloudFormation.getString(properties.TransitGatewayAttachmentId)), ret.addPropertyResult("transitGatewayRouteTableId", "TransitGatewayRouteTableId", cfn_parse.FromCloudFormation.getString(properties.TransitGatewayRouteTableId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTransitGatewayRouteTablePropagation = class _CfnTransitGatewayRouteTablePropagation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTransitGatewayRouteTablePropagationPropsFromCloudFormation(resourceProperties), ret = new _CfnTransitGatewayRouteTablePropagation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTransitGatewayRouteTablePropagation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnTransitGatewayRouteTablePropagationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTransitGatewayRouteTablePropagation), error;
        }
        cdk.requireProperty(props, "transitGatewayAttachmentId", this), cdk.requireProperty(props, "transitGatewayRouteTableId", this), this.transitGatewayAttachmentId = props.transitGatewayAttachmentId, this.transitGatewayRouteTableId = props.transitGatewayRouteTableId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTransitGatewayRouteTablePropagation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { transitGatewayAttachmentId: this.transitGatewayAttachmentId, transitGatewayRouteTableId: this.transitGatewayRouteTableId };
      }
      renderProperties(props) {
        return cfnTransitGatewayRouteTablePropagationPropsToCloudFormation(props);
      }
    };
    _46 = JSII_RTTI_SYMBOL_1, CfnTransitGatewayRouteTablePropagation[_46] = { fqn: "aws-cdk-lib.aws_ec2.CfnTransitGatewayRouteTablePropagation", version: "2.80.0" }, CfnTransitGatewayRouteTablePropagation.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::TransitGatewayRouteTablePropagation", exports2.CfnTransitGatewayRouteTablePropagation = CfnTransitGatewayRouteTablePropagation;
    function CfnTransitGatewayVpcAttachmentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("addSubnetIds", cdk.listValidator(cdk.validateString))(properties.addSubnetIds)), errors.collect(cdk.propertyValidator("options", cdk.validateObject)(properties.options)), errors.collect(cdk.propertyValidator("removeSubnetIds", cdk.listValidator(cdk.validateString))(properties.removeSubnetIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.requiredValidator)(properties.subnetIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("transitGatewayId", cdk.requiredValidator)(properties.transitGatewayId)), errors.collect(cdk.propertyValidator("transitGatewayId", cdk.validateString)(properties.transitGatewayId)), errors.collect(cdk.propertyValidator("vpcId", cdk.requiredValidator)(properties.vpcId)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "CfnTransitGatewayVpcAttachmentProps"');
    }
    function cfnTransitGatewayVpcAttachmentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTransitGatewayVpcAttachmentPropsValidator(properties).assertSuccess(), { SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds), TransitGatewayId: cdk.stringToCloudFormation(properties.transitGatewayId), VpcId: cdk.stringToCloudFormation(properties.vpcId), AddSubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.addSubnetIds), Options: cdk.objectToCloudFormation(properties.options), RemoveSubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.removeSubnetIds), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnTransitGatewayVpcAttachmentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("subnetIds", "SubnetIds", cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds)), ret.addPropertyResult("transitGatewayId", "TransitGatewayId", cfn_parse.FromCloudFormation.getString(properties.TransitGatewayId)), ret.addPropertyResult("vpcId", "VpcId", cfn_parse.FromCloudFormation.getString(properties.VpcId)), ret.addPropertyResult("addSubnetIds", "AddSubnetIds", properties.AddSubnetIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AddSubnetIds) : void 0), ret.addPropertyResult("options", "Options", properties.Options != null ? cfn_parse.FromCloudFormation.getAny(properties.Options) : void 0), ret.addPropertyResult("removeSubnetIds", "RemoveSubnetIds", properties.RemoveSubnetIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.RemoveSubnetIds) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTransitGatewayVpcAttachment = class _CfnTransitGatewayVpcAttachment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTransitGatewayVpcAttachmentPropsFromCloudFormation(resourceProperties), ret = new _CfnTransitGatewayVpcAttachment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTransitGatewayVpcAttachment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnTransitGatewayVpcAttachmentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTransitGatewayVpcAttachment), error;
        }
        cdk.requireProperty(props, "subnetIds", this), cdk.requireProperty(props, "transitGatewayId", this), cdk.requireProperty(props, "vpcId", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.subnetIds = props.subnetIds, this.transitGatewayId = props.transitGatewayId, this.vpcId = props.vpcId, this.addSubnetIds = props.addSubnetIds, this.options = props.options, this.removeSubnetIds = props.removeSubnetIds, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::TransitGatewayVpcAttachment", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTransitGatewayVpcAttachment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { subnetIds: this.subnetIds, transitGatewayId: this.transitGatewayId, vpcId: this.vpcId, addSubnetIds: this.addSubnetIds, options: this.options, removeSubnetIds: this.removeSubnetIds, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnTransitGatewayVpcAttachmentPropsToCloudFormation(props);
      }
    };
    _47 = JSII_RTTI_SYMBOL_1, CfnTransitGatewayVpcAttachment[_47] = { fqn: "aws-cdk-lib.aws_ec2.CfnTransitGatewayVpcAttachment", version: "2.80.0" }, CfnTransitGatewayVpcAttachment.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::TransitGatewayVpcAttachment", exports2.CfnTransitGatewayVpcAttachment = CfnTransitGatewayVpcAttachment;
    function CfnVPCPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cidrBlock", cdk.validateString)(properties.cidrBlock)), errors.collect(cdk.propertyValidator("enableDnsHostnames", cdk.validateBoolean)(properties.enableDnsHostnames)), errors.collect(cdk.propertyValidator("enableDnsSupport", cdk.validateBoolean)(properties.enableDnsSupport)), errors.collect(cdk.propertyValidator("instanceTenancy", cdk.validateString)(properties.instanceTenancy)), errors.collect(cdk.propertyValidator("ipv4IpamPoolId", cdk.validateString)(properties.ipv4IpamPoolId)), errors.collect(cdk.propertyValidator("ipv4NetmaskLength", cdk.validateNumber)(properties.ipv4NetmaskLength)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnVPCProps"');
    }
    function cfnVPCPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVPCPropsValidator(properties).assertSuccess(), { CidrBlock: cdk.stringToCloudFormation(properties.cidrBlock), EnableDnsHostnames: cdk.booleanToCloudFormation(properties.enableDnsHostnames), EnableDnsSupport: cdk.booleanToCloudFormation(properties.enableDnsSupport), InstanceTenancy: cdk.stringToCloudFormation(properties.instanceTenancy), Ipv4IpamPoolId: cdk.stringToCloudFormation(properties.ipv4IpamPoolId), Ipv4NetmaskLength: cdk.numberToCloudFormation(properties.ipv4NetmaskLength), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnVPCPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cidrBlock", "CidrBlock", properties.CidrBlock != null ? cfn_parse.FromCloudFormation.getString(properties.CidrBlock) : void 0), ret.addPropertyResult("enableDnsHostnames", "EnableDnsHostnames", properties.EnableDnsHostnames != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableDnsHostnames) : void 0), ret.addPropertyResult("enableDnsSupport", "EnableDnsSupport", properties.EnableDnsSupport != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableDnsSupport) : void 0), ret.addPropertyResult("instanceTenancy", "InstanceTenancy", properties.InstanceTenancy != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceTenancy) : void 0), ret.addPropertyResult("ipv4IpamPoolId", "Ipv4IpamPoolId", properties.Ipv4IpamPoolId != null ? cfn_parse.FromCloudFormation.getString(properties.Ipv4IpamPoolId) : void 0), ret.addPropertyResult("ipv4NetmaskLength", "Ipv4NetmaskLength", properties.Ipv4NetmaskLength != null ? cfn_parse.FromCloudFormation.getNumber(properties.Ipv4NetmaskLength) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVPC = class _CfnVPC extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVPCPropsFromCloudFormation(resourceProperties), ret = new _CfnVPC(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnVPC.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnVPCProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVPC), error;
        }
        this.attrCidrBlock = cdk.Token.asString(this.getAtt("CidrBlock", cdk.ResolutionTypeHint.STRING)), this.attrCidrBlockAssociations = cdk.Token.asList(this.getAtt("CidrBlockAssociations", cdk.ResolutionTypeHint.STRING_LIST)), this.attrDefaultNetworkAcl = cdk.Token.asString(this.getAtt("DefaultNetworkAcl", cdk.ResolutionTypeHint.STRING)), this.attrDefaultSecurityGroup = cdk.Token.asString(this.getAtt("DefaultSecurityGroup", cdk.ResolutionTypeHint.STRING)), this.attrIpv6CidrBlocks = cdk.Token.asList(this.getAtt("Ipv6CidrBlocks", cdk.ResolutionTypeHint.STRING_LIST)), this.attrVpcId = cdk.Token.asString(this.getAtt("VpcId", cdk.ResolutionTypeHint.STRING)), this.cidrBlock = props.cidrBlock, this.enableDnsHostnames = props.enableDnsHostnames, this.enableDnsSupport = props.enableDnsSupport, this.instanceTenancy = props.instanceTenancy, this.ipv4IpamPoolId = props.ipv4IpamPoolId, this.ipv4NetmaskLength = props.ipv4NetmaskLength, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::VPC", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVPC.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { cidrBlock: this.cidrBlock, enableDnsHostnames: this.enableDnsHostnames, enableDnsSupport: this.enableDnsSupport, instanceTenancy: this.instanceTenancy, ipv4IpamPoolId: this.ipv4IpamPoolId, ipv4NetmaskLength: this.ipv4NetmaskLength, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnVPCPropsToCloudFormation(props);
      }
    };
    _48 = JSII_RTTI_SYMBOL_1, CfnVPC[_48] = { fqn: "aws-cdk-lib.aws_ec2.CfnVPC", version: "2.80.0" }, CfnVPC.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::VPC", exports2.CfnVPC = CfnVPC;
    function CfnVPCCidrBlockPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("amazonProvidedIpv6CidrBlock", cdk.validateBoolean)(properties.amazonProvidedIpv6CidrBlock)), errors.collect(cdk.propertyValidator("cidrBlock", cdk.validateString)(properties.cidrBlock)), errors.collect(cdk.propertyValidator("ipv4IpamPoolId", cdk.validateString)(properties.ipv4IpamPoolId)), errors.collect(cdk.propertyValidator("ipv4NetmaskLength", cdk.validateNumber)(properties.ipv4NetmaskLength)), errors.collect(cdk.propertyValidator("ipv6CidrBlock", cdk.validateString)(properties.ipv6CidrBlock)), errors.collect(cdk.propertyValidator("ipv6IpamPoolId", cdk.validateString)(properties.ipv6IpamPoolId)), errors.collect(cdk.propertyValidator("ipv6NetmaskLength", cdk.validateNumber)(properties.ipv6NetmaskLength)), errors.collect(cdk.propertyValidator("ipv6Pool", cdk.validateString)(properties.ipv6Pool)), errors.collect(cdk.propertyValidator("vpcId", cdk.requiredValidator)(properties.vpcId)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "CfnVPCCidrBlockProps"');
    }
    function cfnVPCCidrBlockPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVPCCidrBlockPropsValidator(properties).assertSuccess(), { VpcId: cdk.stringToCloudFormation(properties.vpcId), AmazonProvidedIpv6CidrBlock: cdk.booleanToCloudFormation(properties.amazonProvidedIpv6CidrBlock), CidrBlock: cdk.stringToCloudFormation(properties.cidrBlock), Ipv4IpamPoolId: cdk.stringToCloudFormation(properties.ipv4IpamPoolId), Ipv4NetmaskLength: cdk.numberToCloudFormation(properties.ipv4NetmaskLength), Ipv6CidrBlock: cdk.stringToCloudFormation(properties.ipv6CidrBlock), Ipv6IpamPoolId: cdk.stringToCloudFormation(properties.ipv6IpamPoolId), Ipv6NetmaskLength: cdk.numberToCloudFormation(properties.ipv6NetmaskLength), Ipv6Pool: cdk.stringToCloudFormation(properties.ipv6Pool) }) : properties;
    }
    function CfnVPCCidrBlockPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("vpcId", "VpcId", cfn_parse.FromCloudFormation.getString(properties.VpcId)), ret.addPropertyResult("amazonProvidedIpv6CidrBlock", "AmazonProvidedIpv6CidrBlock", properties.AmazonProvidedIpv6CidrBlock != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AmazonProvidedIpv6CidrBlock) : void 0), ret.addPropertyResult("cidrBlock", "CidrBlock", properties.CidrBlock != null ? cfn_parse.FromCloudFormation.getString(properties.CidrBlock) : void 0), ret.addPropertyResult("ipv4IpamPoolId", "Ipv4IpamPoolId", properties.Ipv4IpamPoolId != null ? cfn_parse.FromCloudFormation.getString(properties.Ipv4IpamPoolId) : void 0), ret.addPropertyResult("ipv4NetmaskLength", "Ipv4NetmaskLength", properties.Ipv4NetmaskLength != null ? cfn_parse.FromCloudFormation.getNumber(properties.Ipv4NetmaskLength) : void 0), ret.addPropertyResult("ipv6CidrBlock", "Ipv6CidrBlock", properties.Ipv6CidrBlock != null ? cfn_parse.FromCloudFormation.getString(properties.Ipv6CidrBlock) : void 0), ret.addPropertyResult("ipv6IpamPoolId", "Ipv6IpamPoolId", properties.Ipv6IpamPoolId != null ? cfn_parse.FromCloudFormation.getString(properties.Ipv6IpamPoolId) : void 0), ret.addPropertyResult("ipv6NetmaskLength", "Ipv6NetmaskLength", properties.Ipv6NetmaskLength != null ? cfn_parse.FromCloudFormation.getNumber(properties.Ipv6NetmaskLength) : void 0), ret.addPropertyResult("ipv6Pool", "Ipv6Pool", properties.Ipv6Pool != null ? cfn_parse.FromCloudFormation.getString(properties.Ipv6Pool) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVPCCidrBlock = class _CfnVPCCidrBlock extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVPCCidrBlockPropsFromCloudFormation(resourceProperties), ret = new _CfnVPCCidrBlock(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVPCCidrBlock.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnVPCCidrBlockProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVPCCidrBlock), error;
        }
        cdk.requireProperty(props, "vpcId", this), this.vpcId = props.vpcId, this.amazonProvidedIpv6CidrBlock = props.amazonProvidedIpv6CidrBlock, this.cidrBlock = props.cidrBlock, this.ipv4IpamPoolId = props.ipv4IpamPoolId, this.ipv4NetmaskLength = props.ipv4NetmaskLength, this.ipv6CidrBlock = props.ipv6CidrBlock, this.ipv6IpamPoolId = props.ipv6IpamPoolId, this.ipv6NetmaskLength = props.ipv6NetmaskLength, this.ipv6Pool = props.ipv6Pool;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVPCCidrBlock.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { vpcId: this.vpcId, amazonProvidedIpv6CidrBlock: this.amazonProvidedIpv6CidrBlock, cidrBlock: this.cidrBlock, ipv4IpamPoolId: this.ipv4IpamPoolId, ipv4NetmaskLength: this.ipv4NetmaskLength, ipv6CidrBlock: this.ipv6CidrBlock, ipv6IpamPoolId: this.ipv6IpamPoolId, ipv6NetmaskLength: this.ipv6NetmaskLength, ipv6Pool: this.ipv6Pool };
      }
      renderProperties(props) {
        return cfnVPCCidrBlockPropsToCloudFormation(props);
      }
    };
    _49 = JSII_RTTI_SYMBOL_1, CfnVPCCidrBlock[_49] = { fqn: "aws-cdk-lib.aws_ec2.CfnVPCCidrBlock", version: "2.80.0" }, CfnVPCCidrBlock.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::VPCCidrBlock", exports2.CfnVPCCidrBlock = CfnVPCCidrBlock;
    function CfnVPCDHCPOptionsAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dhcpOptionsId", cdk.requiredValidator)(properties.dhcpOptionsId)), errors.collect(cdk.propertyValidator("dhcpOptionsId", cdk.validateString)(properties.dhcpOptionsId)), errors.collect(cdk.propertyValidator("vpcId", cdk.requiredValidator)(properties.vpcId)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "CfnVPCDHCPOptionsAssociationProps"');
    }
    function cfnVPCDHCPOptionsAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVPCDHCPOptionsAssociationPropsValidator(properties).assertSuccess(), { DhcpOptionsId: cdk.stringToCloudFormation(properties.dhcpOptionsId), VpcId: cdk.stringToCloudFormation(properties.vpcId) }) : properties;
    }
    function CfnVPCDHCPOptionsAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dhcpOptionsId", "DhcpOptionsId", cfn_parse.FromCloudFormation.getString(properties.DhcpOptionsId)), ret.addPropertyResult("vpcId", "VpcId", cfn_parse.FromCloudFormation.getString(properties.VpcId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVPCDHCPOptionsAssociation = class _CfnVPCDHCPOptionsAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVPCDHCPOptionsAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnVPCDHCPOptionsAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVPCDHCPOptionsAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnVPCDHCPOptionsAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVPCDHCPOptionsAssociation), error;
        }
        cdk.requireProperty(props, "dhcpOptionsId", this), cdk.requireProperty(props, "vpcId", this), this.dhcpOptionsId = props.dhcpOptionsId, this.vpcId = props.vpcId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVPCDHCPOptionsAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { dhcpOptionsId: this.dhcpOptionsId, vpcId: this.vpcId };
      }
      renderProperties(props) {
        return cfnVPCDHCPOptionsAssociationPropsToCloudFormation(props);
      }
    };
    _50 = JSII_RTTI_SYMBOL_1, CfnVPCDHCPOptionsAssociation[_50] = { fqn: "aws-cdk-lib.aws_ec2.CfnVPCDHCPOptionsAssociation", version: "2.80.0" }, CfnVPCDHCPOptionsAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::VPCDHCPOptionsAssociation", exports2.CfnVPCDHCPOptionsAssociation = CfnVPCDHCPOptionsAssociation;
    function CfnVPCEndpointPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("policyDocument", cdk.validateObject)(properties.policyDocument)), errors.collect(cdk.propertyValidator("privateDnsEnabled", cdk.validateBoolean)(properties.privateDnsEnabled)), errors.collect(cdk.propertyValidator("routeTableIds", cdk.listValidator(cdk.validateString))(properties.routeTableIds)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("serviceName", cdk.requiredValidator)(properties.serviceName)), errors.collect(cdk.propertyValidator("serviceName", cdk.validateString)(properties.serviceName)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.collect(cdk.propertyValidator("vpcEndpointType", cdk.validateString)(properties.vpcEndpointType)), errors.collect(cdk.propertyValidator("vpcId", cdk.requiredValidator)(properties.vpcId)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "CfnVPCEndpointProps"');
    }
    function cfnVPCEndpointPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVPCEndpointPropsValidator(properties).assertSuccess(), { ServiceName: cdk.stringToCloudFormation(properties.serviceName), VpcId: cdk.stringToCloudFormation(properties.vpcId), PolicyDocument: cdk.objectToCloudFormation(properties.policyDocument), PrivateDnsEnabled: cdk.booleanToCloudFormation(properties.privateDnsEnabled), RouteTableIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.routeTableIds), SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds), VpcEndpointType: cdk.stringToCloudFormation(properties.vpcEndpointType) }) : properties;
    }
    function CfnVPCEndpointPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("serviceName", "ServiceName", cfn_parse.FromCloudFormation.getString(properties.ServiceName)), ret.addPropertyResult("vpcId", "VpcId", cfn_parse.FromCloudFormation.getString(properties.VpcId)), ret.addPropertyResult("policyDocument", "PolicyDocument", properties.PolicyDocument != null ? cfn_parse.FromCloudFormation.getAny(properties.PolicyDocument) : void 0), ret.addPropertyResult("privateDnsEnabled", "PrivateDnsEnabled", properties.PrivateDnsEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.PrivateDnsEnabled) : void 0), ret.addPropertyResult("routeTableIds", "RouteTableIds", properties.RouteTableIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.RouteTableIds) : void 0), ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("subnetIds", "SubnetIds", properties.SubnetIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds) : void 0), ret.addPropertyResult("vpcEndpointType", "VpcEndpointType", properties.VpcEndpointType != null ? cfn_parse.FromCloudFormation.getString(properties.VpcEndpointType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVPCEndpoint = class _CfnVPCEndpoint extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVPCEndpointPropsFromCloudFormation(resourceProperties), ret = new _CfnVPCEndpoint(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVPCEndpoint.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnVPCEndpointProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVPCEndpoint), error;
        }
        cdk.requireProperty(props, "serviceName", this), cdk.requireProperty(props, "vpcId", this), this.attrCreationTimestamp = cdk.Token.asString(this.getAtt("CreationTimestamp", cdk.ResolutionTypeHint.STRING)), this.attrDnsEntries = cdk.Token.asList(this.getAtt("DnsEntries", cdk.ResolutionTypeHint.STRING_LIST)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrNetworkInterfaceIds = cdk.Token.asList(this.getAtt("NetworkInterfaceIds", cdk.ResolutionTypeHint.STRING_LIST)), this.serviceName = props.serviceName, this.vpcId = props.vpcId, this.policyDocument = props.policyDocument, this.privateDnsEnabled = props.privateDnsEnabled, this.routeTableIds = props.routeTableIds, this.securityGroupIds = props.securityGroupIds, this.subnetIds = props.subnetIds, this.vpcEndpointType = props.vpcEndpointType;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVPCEndpoint.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { serviceName: this.serviceName, vpcId: this.vpcId, policyDocument: this.policyDocument, privateDnsEnabled: this.privateDnsEnabled, routeTableIds: this.routeTableIds, securityGroupIds: this.securityGroupIds, subnetIds: this.subnetIds, vpcEndpointType: this.vpcEndpointType };
      }
      renderProperties(props) {
        return cfnVPCEndpointPropsToCloudFormation(props);
      }
    };
    _51 = JSII_RTTI_SYMBOL_1, CfnVPCEndpoint[_51] = { fqn: "aws-cdk-lib.aws_ec2.CfnVPCEndpoint", version: "2.80.0" }, CfnVPCEndpoint.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::VPCEndpoint", exports2.CfnVPCEndpoint = CfnVPCEndpoint;
    function CfnVPCEndpointConnectionNotificationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectionEvents", cdk.requiredValidator)(properties.connectionEvents)), errors.collect(cdk.propertyValidator("connectionEvents", cdk.listValidator(cdk.validateString))(properties.connectionEvents)), errors.collect(cdk.propertyValidator("connectionNotificationArn", cdk.requiredValidator)(properties.connectionNotificationArn)), errors.collect(cdk.propertyValidator("connectionNotificationArn", cdk.validateString)(properties.connectionNotificationArn)), errors.collect(cdk.propertyValidator("serviceId", cdk.validateString)(properties.serviceId)), errors.collect(cdk.propertyValidator("vpcEndpointId", cdk.validateString)(properties.vpcEndpointId)), errors.wrap('supplied properties not correct for "CfnVPCEndpointConnectionNotificationProps"');
    }
    function cfnVPCEndpointConnectionNotificationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVPCEndpointConnectionNotificationPropsValidator(properties).assertSuccess(), { ConnectionEvents: cdk.listMapper(cdk.stringToCloudFormation)(properties.connectionEvents), ConnectionNotificationArn: cdk.stringToCloudFormation(properties.connectionNotificationArn), ServiceId: cdk.stringToCloudFormation(properties.serviceId), VPCEndpointId: cdk.stringToCloudFormation(properties.vpcEndpointId) }) : properties;
    }
    function CfnVPCEndpointConnectionNotificationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectionEvents", "ConnectionEvents", cfn_parse.FromCloudFormation.getStringArray(properties.ConnectionEvents)), ret.addPropertyResult("connectionNotificationArn", "ConnectionNotificationArn", cfn_parse.FromCloudFormation.getString(properties.ConnectionNotificationArn)), ret.addPropertyResult("serviceId", "ServiceId", properties.ServiceId != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceId) : void 0), ret.addPropertyResult("vpcEndpointId", "VPCEndpointId", properties.VPCEndpointId != null ? cfn_parse.FromCloudFormation.getString(properties.VPCEndpointId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVPCEndpointConnectionNotification = class _CfnVPCEndpointConnectionNotification extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVPCEndpointConnectionNotificationPropsFromCloudFormation(resourceProperties), ret = new _CfnVPCEndpointConnectionNotification(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVPCEndpointConnectionNotification.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnVPCEndpointConnectionNotificationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVPCEndpointConnectionNotification), error;
        }
        cdk.requireProperty(props, "connectionEvents", this), cdk.requireProperty(props, "connectionNotificationArn", this), this.connectionEvents = props.connectionEvents, this.connectionNotificationArn = props.connectionNotificationArn, this.serviceId = props.serviceId, this.vpcEndpointId = props.vpcEndpointId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVPCEndpointConnectionNotification.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { connectionEvents: this.connectionEvents, connectionNotificationArn: this.connectionNotificationArn, serviceId: this.serviceId, vpcEndpointId: this.vpcEndpointId };
      }
      renderProperties(props) {
        return cfnVPCEndpointConnectionNotificationPropsToCloudFormation(props);
      }
    };
    _52 = JSII_RTTI_SYMBOL_1, CfnVPCEndpointConnectionNotification[_52] = { fqn: "aws-cdk-lib.aws_ec2.CfnVPCEndpointConnectionNotification", version: "2.80.0" }, CfnVPCEndpointConnectionNotification.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::VPCEndpointConnectionNotification", exports2.CfnVPCEndpointConnectionNotification = CfnVPCEndpointConnectionNotification;
    function CfnVPCEndpointServicePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acceptanceRequired", cdk.validateBoolean)(properties.acceptanceRequired)), errors.collect(cdk.propertyValidator("contributorInsightsEnabled", cdk.validateBoolean)(properties.contributorInsightsEnabled)), errors.collect(cdk.propertyValidator("gatewayLoadBalancerArns", cdk.listValidator(cdk.validateString))(properties.gatewayLoadBalancerArns)), errors.collect(cdk.propertyValidator("networkLoadBalancerArns", cdk.listValidator(cdk.validateString))(properties.networkLoadBalancerArns)), errors.collect(cdk.propertyValidator("payerResponsibility", cdk.validateString)(properties.payerResponsibility)), errors.wrap('supplied properties not correct for "CfnVPCEndpointServiceProps"');
    }
    function cfnVPCEndpointServicePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVPCEndpointServicePropsValidator(properties).assertSuccess(), { AcceptanceRequired: cdk.booleanToCloudFormation(properties.acceptanceRequired), ContributorInsightsEnabled: cdk.booleanToCloudFormation(properties.contributorInsightsEnabled), GatewayLoadBalancerArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.gatewayLoadBalancerArns), NetworkLoadBalancerArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.networkLoadBalancerArns), PayerResponsibility: cdk.stringToCloudFormation(properties.payerResponsibility) }) : properties;
    }
    function CfnVPCEndpointServicePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("acceptanceRequired", "AcceptanceRequired", properties.AcceptanceRequired != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AcceptanceRequired) : void 0), ret.addPropertyResult("contributorInsightsEnabled", "ContributorInsightsEnabled", properties.ContributorInsightsEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ContributorInsightsEnabled) : void 0), ret.addPropertyResult("gatewayLoadBalancerArns", "GatewayLoadBalancerArns", properties.GatewayLoadBalancerArns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.GatewayLoadBalancerArns) : void 0), ret.addPropertyResult("networkLoadBalancerArns", "NetworkLoadBalancerArns", properties.NetworkLoadBalancerArns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.NetworkLoadBalancerArns) : void 0), ret.addPropertyResult("payerResponsibility", "PayerResponsibility", properties.PayerResponsibility != null ? cfn_parse.FromCloudFormation.getString(properties.PayerResponsibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVPCEndpointService = class _CfnVPCEndpointService extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVPCEndpointServicePropsFromCloudFormation(resourceProperties), ret = new _CfnVPCEndpointService(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnVPCEndpointService.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnVPCEndpointServiceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVPCEndpointService), error;
        }
        this.attrServiceId = cdk.Token.asString(this.getAtt("ServiceId", cdk.ResolutionTypeHint.STRING)), this.acceptanceRequired = props.acceptanceRequired, this.contributorInsightsEnabled = props.contributorInsightsEnabled, this.gatewayLoadBalancerArns = props.gatewayLoadBalancerArns, this.networkLoadBalancerArns = props.networkLoadBalancerArns, this.payerResponsibility = props.payerResponsibility;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVPCEndpointService.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { acceptanceRequired: this.acceptanceRequired, contributorInsightsEnabled: this.contributorInsightsEnabled, gatewayLoadBalancerArns: this.gatewayLoadBalancerArns, networkLoadBalancerArns: this.networkLoadBalancerArns, payerResponsibility: this.payerResponsibility };
      }
      renderProperties(props) {
        return cfnVPCEndpointServicePropsToCloudFormation(props);
      }
    };
    _53 = JSII_RTTI_SYMBOL_1, CfnVPCEndpointService[_53] = { fqn: "aws-cdk-lib.aws_ec2.CfnVPCEndpointService", version: "2.80.0" }, CfnVPCEndpointService.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::VPCEndpointService", exports2.CfnVPCEndpointService = CfnVPCEndpointService;
    function CfnVPCEndpointServicePermissionsPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowedPrincipals", cdk.listValidator(cdk.validateString))(properties.allowedPrincipals)), errors.collect(cdk.propertyValidator("serviceId", cdk.requiredValidator)(properties.serviceId)), errors.collect(cdk.propertyValidator("serviceId", cdk.validateString)(properties.serviceId)), errors.wrap('supplied properties not correct for "CfnVPCEndpointServicePermissionsProps"');
    }
    function cfnVPCEndpointServicePermissionsPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVPCEndpointServicePermissionsPropsValidator(properties).assertSuccess(), { ServiceId: cdk.stringToCloudFormation(properties.serviceId), AllowedPrincipals: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowedPrincipals) }) : properties;
    }
    function CfnVPCEndpointServicePermissionsPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("serviceId", "ServiceId", cfn_parse.FromCloudFormation.getString(properties.ServiceId)), ret.addPropertyResult("allowedPrincipals", "AllowedPrincipals", properties.AllowedPrincipals != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AllowedPrincipals) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVPCEndpointServicePermissions = class _CfnVPCEndpointServicePermissions extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVPCEndpointServicePermissionsPropsFromCloudFormation(resourceProperties), ret = new _CfnVPCEndpointServicePermissions(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVPCEndpointServicePermissions.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnVPCEndpointServicePermissionsProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVPCEndpointServicePermissions), error;
        }
        cdk.requireProperty(props, "serviceId", this), this.serviceId = props.serviceId, this.allowedPrincipals = props.allowedPrincipals;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVPCEndpointServicePermissions.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { serviceId: this.serviceId, allowedPrincipals: this.allowedPrincipals };
      }
      renderProperties(props) {
        return cfnVPCEndpointServicePermissionsPropsToCloudFormation(props);
      }
    };
    _54 = JSII_RTTI_SYMBOL_1, CfnVPCEndpointServicePermissions[_54] = { fqn: "aws-cdk-lib.aws_ec2.CfnVPCEndpointServicePermissions", version: "2.80.0" }, CfnVPCEndpointServicePermissions.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::VPCEndpointServicePermissions", exports2.CfnVPCEndpointServicePermissions = CfnVPCEndpointServicePermissions;
    function CfnVPCGatewayAttachmentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("internetGatewayId", cdk.validateString)(properties.internetGatewayId)), errors.collect(cdk.propertyValidator("vpcId", cdk.requiredValidator)(properties.vpcId)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.collect(cdk.propertyValidator("vpnGatewayId", cdk.validateString)(properties.vpnGatewayId)), errors.wrap('supplied properties not correct for "CfnVPCGatewayAttachmentProps"');
    }
    function cfnVPCGatewayAttachmentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVPCGatewayAttachmentPropsValidator(properties).assertSuccess(), { VpcId: cdk.stringToCloudFormation(properties.vpcId), InternetGatewayId: cdk.stringToCloudFormation(properties.internetGatewayId), VpnGatewayId: cdk.stringToCloudFormation(properties.vpnGatewayId) }) : properties;
    }
    function CfnVPCGatewayAttachmentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("vpcId", "VpcId", cfn_parse.FromCloudFormation.getString(properties.VpcId)), ret.addPropertyResult("internetGatewayId", "InternetGatewayId", properties.InternetGatewayId != null ? cfn_parse.FromCloudFormation.getString(properties.InternetGatewayId) : void 0), ret.addPropertyResult("vpnGatewayId", "VpnGatewayId", properties.VpnGatewayId != null ? cfn_parse.FromCloudFormation.getString(properties.VpnGatewayId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVPCGatewayAttachment = class _CfnVPCGatewayAttachment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVPCGatewayAttachmentPropsFromCloudFormation(resourceProperties), ret = new _CfnVPCGatewayAttachment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVPCGatewayAttachment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnVPCGatewayAttachmentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVPCGatewayAttachment), error;
        }
        cdk.requireProperty(props, "vpcId", this), this.vpcId = props.vpcId, this.internetGatewayId = props.internetGatewayId, this.vpnGatewayId = props.vpnGatewayId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVPCGatewayAttachment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { vpcId: this.vpcId, internetGatewayId: this.internetGatewayId, vpnGatewayId: this.vpnGatewayId };
      }
      renderProperties(props) {
        return cfnVPCGatewayAttachmentPropsToCloudFormation(props);
      }
    };
    _55 = JSII_RTTI_SYMBOL_1, CfnVPCGatewayAttachment[_55] = { fqn: "aws-cdk-lib.aws_ec2.CfnVPCGatewayAttachment", version: "2.80.0" }, CfnVPCGatewayAttachment.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::VPCGatewayAttachment", exports2.CfnVPCGatewayAttachment = CfnVPCGatewayAttachment;
    function CfnVPCPeeringConnectionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("peerOwnerId", cdk.validateString)(properties.peerOwnerId)), errors.collect(cdk.propertyValidator("peerRegion", cdk.validateString)(properties.peerRegion)), errors.collect(cdk.propertyValidator("peerRoleArn", cdk.validateString)(properties.peerRoleArn)), errors.collect(cdk.propertyValidator("peerVpcId", cdk.requiredValidator)(properties.peerVpcId)), errors.collect(cdk.propertyValidator("peerVpcId", cdk.validateString)(properties.peerVpcId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpcId", cdk.requiredValidator)(properties.vpcId)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "CfnVPCPeeringConnectionProps"');
    }
    function cfnVPCPeeringConnectionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVPCPeeringConnectionPropsValidator(properties).assertSuccess(), { PeerVpcId: cdk.stringToCloudFormation(properties.peerVpcId), VpcId: cdk.stringToCloudFormation(properties.vpcId), PeerOwnerId: cdk.stringToCloudFormation(properties.peerOwnerId), PeerRegion: cdk.stringToCloudFormation(properties.peerRegion), PeerRoleArn: cdk.stringToCloudFormation(properties.peerRoleArn), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnVPCPeeringConnectionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("peerVpcId", "PeerVpcId", cfn_parse.FromCloudFormation.getString(properties.PeerVpcId)), ret.addPropertyResult("vpcId", "VpcId", cfn_parse.FromCloudFormation.getString(properties.VpcId)), ret.addPropertyResult("peerOwnerId", "PeerOwnerId", properties.PeerOwnerId != null ? cfn_parse.FromCloudFormation.getString(properties.PeerOwnerId) : void 0), ret.addPropertyResult("peerRegion", "PeerRegion", properties.PeerRegion != null ? cfn_parse.FromCloudFormation.getString(properties.PeerRegion) : void 0), ret.addPropertyResult("peerRoleArn", "PeerRoleArn", properties.PeerRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.PeerRoleArn) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVPCPeeringConnection = class _CfnVPCPeeringConnection extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVPCPeeringConnectionPropsFromCloudFormation(resourceProperties), ret = new _CfnVPCPeeringConnection(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVPCPeeringConnection.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnVPCPeeringConnectionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVPCPeeringConnection), error;
        }
        cdk.requireProperty(props, "peerVpcId", this), cdk.requireProperty(props, "vpcId", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.peerVpcId = props.peerVpcId, this.vpcId = props.vpcId, this.peerOwnerId = props.peerOwnerId, this.peerRegion = props.peerRegion, this.peerRoleArn = props.peerRoleArn, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::VPCPeeringConnection", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVPCPeeringConnection.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { peerVpcId: this.peerVpcId, vpcId: this.vpcId, peerOwnerId: this.peerOwnerId, peerRegion: this.peerRegion, peerRoleArn: this.peerRoleArn, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnVPCPeeringConnectionPropsToCloudFormation(props);
      }
    };
    _56 = JSII_RTTI_SYMBOL_1, CfnVPCPeeringConnection[_56] = { fqn: "aws-cdk-lib.aws_ec2.CfnVPCPeeringConnection", version: "2.80.0" }, CfnVPCPeeringConnection.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::VPCPeeringConnection", exports2.CfnVPCPeeringConnection = CfnVPCPeeringConnection;
    function CfnVPNConnectionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customerGatewayId", cdk.requiredValidator)(properties.customerGatewayId)), errors.collect(cdk.propertyValidator("customerGatewayId", cdk.validateString)(properties.customerGatewayId)), errors.collect(cdk.propertyValidator("staticRoutesOnly", cdk.validateBoolean)(properties.staticRoutesOnly)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("transitGatewayId", cdk.validateString)(properties.transitGatewayId)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("vpnGatewayId", cdk.validateString)(properties.vpnGatewayId)), errors.collect(cdk.propertyValidator("vpnTunnelOptionsSpecifications", cdk.listValidator(CfnVPNConnection_VpnTunnelOptionsSpecificationPropertyValidator))(properties.vpnTunnelOptionsSpecifications)), errors.wrap('supplied properties not correct for "CfnVPNConnectionProps"');
    }
    function cfnVPNConnectionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVPNConnectionPropsValidator(properties).assertSuccess(), { CustomerGatewayId: cdk.stringToCloudFormation(properties.customerGatewayId), Type: cdk.stringToCloudFormation(properties.type), StaticRoutesOnly: cdk.booleanToCloudFormation(properties.staticRoutesOnly), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TransitGatewayId: cdk.stringToCloudFormation(properties.transitGatewayId), VpnGatewayId: cdk.stringToCloudFormation(properties.vpnGatewayId), VpnTunnelOptionsSpecifications: cdk.listMapper(cfnVPNConnectionVpnTunnelOptionsSpecificationPropertyToCloudFormation)(properties.vpnTunnelOptionsSpecifications) }) : properties;
    }
    function CfnVPNConnectionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customerGatewayId", "CustomerGatewayId", cfn_parse.FromCloudFormation.getString(properties.CustomerGatewayId)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("staticRoutesOnly", "StaticRoutesOnly", properties.StaticRoutesOnly != null ? cfn_parse.FromCloudFormation.getBoolean(properties.StaticRoutesOnly) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("transitGatewayId", "TransitGatewayId", properties.TransitGatewayId != null ? cfn_parse.FromCloudFormation.getString(properties.TransitGatewayId) : void 0), ret.addPropertyResult("vpnGatewayId", "VpnGatewayId", properties.VpnGatewayId != null ? cfn_parse.FromCloudFormation.getString(properties.VpnGatewayId) : void 0), ret.addPropertyResult("vpnTunnelOptionsSpecifications", "VpnTunnelOptionsSpecifications", properties.VpnTunnelOptionsSpecifications != null ? cfn_parse.FromCloudFormation.getArray(CfnVPNConnectionVpnTunnelOptionsSpecificationPropertyFromCloudFormation)(properties.VpnTunnelOptionsSpecifications) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVPNConnection = class _CfnVPNConnection extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVPNConnectionPropsFromCloudFormation(resourceProperties), ret = new _CfnVPNConnection(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVPNConnection.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnVPNConnectionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVPNConnection), error;
        }
        cdk.requireProperty(props, "customerGatewayId", this), cdk.requireProperty(props, "type", this), this.attrVpnConnectionId = cdk.Token.asString(this.getAtt("VpnConnectionId", cdk.ResolutionTypeHint.STRING)), this.customerGatewayId = props.customerGatewayId, this.type = props.type, this.staticRoutesOnly = props.staticRoutesOnly, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::VPNConnection", props.tags, { tagPropertyName: "tags" }), this.transitGatewayId = props.transitGatewayId, this.vpnGatewayId = props.vpnGatewayId, this.vpnTunnelOptionsSpecifications = props.vpnTunnelOptionsSpecifications;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVPNConnection.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { customerGatewayId: this.customerGatewayId, type: this.type, staticRoutesOnly: this.staticRoutesOnly, tags: this.tags.renderTags(), transitGatewayId: this.transitGatewayId, vpnGatewayId: this.vpnGatewayId, vpnTunnelOptionsSpecifications: this.vpnTunnelOptionsSpecifications };
      }
      renderProperties(props) {
        return cfnVPNConnectionPropsToCloudFormation(props);
      }
    };
    _57 = JSII_RTTI_SYMBOL_1, CfnVPNConnection[_57] = { fqn: "aws-cdk-lib.aws_ec2.CfnVPNConnection", version: "2.80.0" }, CfnVPNConnection.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::VPNConnection", exports2.CfnVPNConnection = CfnVPNConnection;
    function CfnVPNConnection_VpnTunnelOptionsSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("preSharedKey", cdk.validateString)(properties.preSharedKey)), errors.collect(cdk.propertyValidator("tunnelInsideCidr", cdk.validateString)(properties.tunnelInsideCidr)), errors.wrap('supplied properties not correct for "VpnTunnelOptionsSpecificationProperty"');
    }
    function cfnVPNConnectionVpnTunnelOptionsSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVPNConnection_VpnTunnelOptionsSpecificationPropertyValidator(properties).assertSuccess(), { PreSharedKey: cdk.stringToCloudFormation(properties.preSharedKey), TunnelInsideCidr: cdk.stringToCloudFormation(properties.tunnelInsideCidr) }) : properties;
    }
    function CfnVPNConnectionVpnTunnelOptionsSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("preSharedKey", "PreSharedKey", properties.PreSharedKey != null ? cfn_parse.FromCloudFormation.getString(properties.PreSharedKey) : void 0), ret.addPropertyResult("tunnelInsideCidr", "TunnelInsideCidr", properties.TunnelInsideCidr != null ? cfn_parse.FromCloudFormation.getString(properties.TunnelInsideCidr) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVPNConnectionRoutePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationCidrBlock", cdk.requiredValidator)(properties.destinationCidrBlock)), errors.collect(cdk.propertyValidator("destinationCidrBlock", cdk.validateString)(properties.destinationCidrBlock)), errors.collect(cdk.propertyValidator("vpnConnectionId", cdk.requiredValidator)(properties.vpnConnectionId)), errors.collect(cdk.propertyValidator("vpnConnectionId", cdk.validateString)(properties.vpnConnectionId)), errors.wrap('supplied properties not correct for "CfnVPNConnectionRouteProps"');
    }
    function cfnVPNConnectionRoutePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVPNConnectionRoutePropsValidator(properties).assertSuccess(), { DestinationCidrBlock: cdk.stringToCloudFormation(properties.destinationCidrBlock), VpnConnectionId: cdk.stringToCloudFormation(properties.vpnConnectionId) }) : properties;
    }
    function CfnVPNConnectionRoutePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationCidrBlock", "DestinationCidrBlock", cfn_parse.FromCloudFormation.getString(properties.DestinationCidrBlock)), ret.addPropertyResult("vpnConnectionId", "VpnConnectionId", cfn_parse.FromCloudFormation.getString(properties.VpnConnectionId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVPNConnectionRoute = class _CfnVPNConnectionRoute extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVPNConnectionRoutePropsFromCloudFormation(resourceProperties), ret = new _CfnVPNConnectionRoute(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVPNConnectionRoute.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnVPNConnectionRouteProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVPNConnectionRoute), error;
        }
        cdk.requireProperty(props, "destinationCidrBlock", this), cdk.requireProperty(props, "vpnConnectionId", this), this.destinationCidrBlock = props.destinationCidrBlock, this.vpnConnectionId = props.vpnConnectionId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVPNConnectionRoute.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { destinationCidrBlock: this.destinationCidrBlock, vpnConnectionId: this.vpnConnectionId };
      }
      renderProperties(props) {
        return cfnVPNConnectionRoutePropsToCloudFormation(props);
      }
    };
    _58 = JSII_RTTI_SYMBOL_1, CfnVPNConnectionRoute[_58] = { fqn: "aws-cdk-lib.aws_ec2.CfnVPNConnectionRoute", version: "2.80.0" }, CfnVPNConnectionRoute.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::VPNConnectionRoute", exports2.CfnVPNConnectionRoute = CfnVPNConnectionRoute;
    function CfnVPNGatewayPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("amazonSideAsn", cdk.validateNumber)(properties.amazonSideAsn)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnVPNGatewayProps"');
    }
    function cfnVPNGatewayPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVPNGatewayPropsValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type), AmazonSideAsn: cdk.numberToCloudFormation(properties.amazonSideAsn), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnVPNGatewayPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("amazonSideAsn", "AmazonSideAsn", properties.AmazonSideAsn != null ? cfn_parse.FromCloudFormation.getNumber(properties.AmazonSideAsn) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVPNGateway = class _CfnVPNGateway extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVPNGatewayPropsFromCloudFormation(resourceProperties), ret = new _CfnVPNGateway(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVPNGateway.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnVPNGatewayProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVPNGateway), error;
        }
        cdk.requireProperty(props, "type", this), this.attrVpnGatewayId = cdk.Token.asString(this.getAtt("VPNGatewayId", cdk.ResolutionTypeHint.STRING)), this.type = props.type, this.amazonSideAsn = props.amazonSideAsn, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::VPNGateway", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVPNGateway.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { type: this.type, amazonSideAsn: this.amazonSideAsn, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnVPNGatewayPropsToCloudFormation(props);
      }
    };
    _59 = JSII_RTTI_SYMBOL_1, CfnVPNGateway[_59] = { fqn: "aws-cdk-lib.aws_ec2.CfnVPNGateway", version: "2.80.0" }, CfnVPNGateway.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::VPNGateway", exports2.CfnVPNGateway = CfnVPNGateway;
    function CfnVPNGatewayRoutePropagationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("routeTableIds", cdk.requiredValidator)(properties.routeTableIds)), errors.collect(cdk.propertyValidator("routeTableIds", cdk.listValidator(cdk.validateString))(properties.routeTableIds)), errors.collect(cdk.propertyValidator("vpnGatewayId", cdk.requiredValidator)(properties.vpnGatewayId)), errors.collect(cdk.propertyValidator("vpnGatewayId", cdk.validateString)(properties.vpnGatewayId)), errors.wrap('supplied properties not correct for "CfnVPNGatewayRoutePropagationProps"');
    }
    function cfnVPNGatewayRoutePropagationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVPNGatewayRoutePropagationPropsValidator(properties).assertSuccess(), { RouteTableIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.routeTableIds), VpnGatewayId: cdk.stringToCloudFormation(properties.vpnGatewayId) }) : properties;
    }
    function CfnVPNGatewayRoutePropagationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("routeTableIds", "RouteTableIds", cfn_parse.FromCloudFormation.getStringArray(properties.RouteTableIds)), ret.addPropertyResult("vpnGatewayId", "VpnGatewayId", cfn_parse.FromCloudFormation.getString(properties.VpnGatewayId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVPNGatewayRoutePropagation = class _CfnVPNGatewayRoutePropagation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVPNGatewayRoutePropagationPropsFromCloudFormation(resourceProperties), ret = new _CfnVPNGatewayRoutePropagation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVPNGatewayRoutePropagation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnVPNGatewayRoutePropagationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVPNGatewayRoutePropagation), error;
        }
        cdk.requireProperty(props, "routeTableIds", this), cdk.requireProperty(props, "vpnGatewayId", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.routeTableIds = props.routeTableIds, this.vpnGatewayId = props.vpnGatewayId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVPNGatewayRoutePropagation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { routeTableIds: this.routeTableIds, vpnGatewayId: this.vpnGatewayId };
      }
      renderProperties(props) {
        return cfnVPNGatewayRoutePropagationPropsToCloudFormation(props);
      }
    };
    _60 = JSII_RTTI_SYMBOL_1, CfnVPNGatewayRoutePropagation[_60] = { fqn: "aws-cdk-lib.aws_ec2.CfnVPNGatewayRoutePropagation", version: "2.80.0" }, CfnVPNGatewayRoutePropagation.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::VPNGatewayRoutePropagation", exports2.CfnVPNGatewayRoutePropagation = CfnVPNGatewayRoutePropagation;
    function CfnVerifiedAccessEndpointPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationDomain", cdk.requiredValidator)(properties.applicationDomain)), errors.collect(cdk.propertyValidator("applicationDomain", cdk.validateString)(properties.applicationDomain)), errors.collect(cdk.propertyValidator("attachmentType", cdk.requiredValidator)(properties.attachmentType)), errors.collect(cdk.propertyValidator("attachmentType", cdk.validateString)(properties.attachmentType)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("domainCertificateArn", cdk.requiredValidator)(properties.domainCertificateArn)), errors.collect(cdk.propertyValidator("domainCertificateArn", cdk.validateString)(properties.domainCertificateArn)), errors.collect(cdk.propertyValidator("endpointDomainPrefix", cdk.requiredValidator)(properties.endpointDomainPrefix)), errors.collect(cdk.propertyValidator("endpointDomainPrefix", cdk.validateString)(properties.endpointDomainPrefix)), errors.collect(cdk.propertyValidator("endpointType", cdk.requiredValidator)(properties.endpointType)), errors.collect(cdk.propertyValidator("endpointType", cdk.validateString)(properties.endpointType)), errors.collect(cdk.propertyValidator("loadBalancerOptions", CfnVerifiedAccessEndpoint_LoadBalancerOptionsPropertyValidator)(properties.loadBalancerOptions)), errors.collect(cdk.propertyValidator("networkInterfaceOptions", CfnVerifiedAccessEndpoint_NetworkInterfaceOptionsPropertyValidator)(properties.networkInterfaceOptions)), errors.collect(cdk.propertyValidator("policyDocument", cdk.validateString)(properties.policyDocument)), errors.collect(cdk.propertyValidator("policyEnabled", cdk.validateBoolean)(properties.policyEnabled)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("verifiedAccessGroupId", cdk.requiredValidator)(properties.verifiedAccessGroupId)), errors.collect(cdk.propertyValidator("verifiedAccessGroupId", cdk.validateString)(properties.verifiedAccessGroupId)), errors.wrap('supplied properties not correct for "CfnVerifiedAccessEndpointProps"');
    }
    function cfnVerifiedAccessEndpointPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVerifiedAccessEndpointPropsValidator(properties).assertSuccess(), { ApplicationDomain: cdk.stringToCloudFormation(properties.applicationDomain), AttachmentType: cdk.stringToCloudFormation(properties.attachmentType), DomainCertificateArn: cdk.stringToCloudFormation(properties.domainCertificateArn), EndpointDomainPrefix: cdk.stringToCloudFormation(properties.endpointDomainPrefix), EndpointType: cdk.stringToCloudFormation(properties.endpointType), VerifiedAccessGroupId: cdk.stringToCloudFormation(properties.verifiedAccessGroupId), Description: cdk.stringToCloudFormation(properties.description), LoadBalancerOptions: cfnVerifiedAccessEndpointLoadBalancerOptionsPropertyToCloudFormation(properties.loadBalancerOptions), NetworkInterfaceOptions: cfnVerifiedAccessEndpointNetworkInterfaceOptionsPropertyToCloudFormation(properties.networkInterfaceOptions), PolicyDocument: cdk.stringToCloudFormation(properties.policyDocument), PolicyEnabled: cdk.booleanToCloudFormation(properties.policyEnabled), SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnVerifiedAccessEndpointPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationDomain", "ApplicationDomain", cfn_parse.FromCloudFormation.getString(properties.ApplicationDomain)), ret.addPropertyResult("attachmentType", "AttachmentType", cfn_parse.FromCloudFormation.getString(properties.AttachmentType)), ret.addPropertyResult("domainCertificateArn", "DomainCertificateArn", cfn_parse.FromCloudFormation.getString(properties.DomainCertificateArn)), ret.addPropertyResult("endpointDomainPrefix", "EndpointDomainPrefix", cfn_parse.FromCloudFormation.getString(properties.EndpointDomainPrefix)), ret.addPropertyResult("endpointType", "EndpointType", cfn_parse.FromCloudFormation.getString(properties.EndpointType)), ret.addPropertyResult("verifiedAccessGroupId", "VerifiedAccessGroupId", cfn_parse.FromCloudFormation.getString(properties.VerifiedAccessGroupId)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("loadBalancerOptions", "LoadBalancerOptions", properties.LoadBalancerOptions != null ? CfnVerifiedAccessEndpointLoadBalancerOptionsPropertyFromCloudFormation(properties.LoadBalancerOptions) : void 0), ret.addPropertyResult("networkInterfaceOptions", "NetworkInterfaceOptions", properties.NetworkInterfaceOptions != null ? CfnVerifiedAccessEndpointNetworkInterfaceOptionsPropertyFromCloudFormation(properties.NetworkInterfaceOptions) : void 0), ret.addPropertyResult("policyDocument", "PolicyDocument", properties.PolicyDocument != null ? cfn_parse.FromCloudFormation.getString(properties.PolicyDocument) : void 0), ret.addPropertyResult("policyEnabled", "PolicyEnabled", properties.PolicyEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.PolicyEnabled) : void 0), ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVerifiedAccessEndpoint = class _CfnVerifiedAccessEndpoint extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVerifiedAccessEndpointPropsFromCloudFormation(resourceProperties), ret = new _CfnVerifiedAccessEndpoint(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVerifiedAccessEndpoint.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnVerifiedAccessEndpointProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVerifiedAccessEndpoint), error;
        }
        cdk.requireProperty(props, "applicationDomain", this), cdk.requireProperty(props, "attachmentType", this), cdk.requireProperty(props, "domainCertificateArn", this), cdk.requireProperty(props, "endpointDomainPrefix", this), cdk.requireProperty(props, "endpointType", this), cdk.requireProperty(props, "verifiedAccessGroupId", this), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrDeviceValidationDomain = cdk.Token.asString(this.getAtt("DeviceValidationDomain", cdk.ResolutionTypeHint.STRING)), this.attrEndpointDomain = cdk.Token.asString(this.getAtt("EndpointDomain", cdk.ResolutionTypeHint.STRING)), this.attrLastUpdatedTime = cdk.Token.asString(this.getAtt("LastUpdatedTime", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.attrVerifiedAccessEndpointId = cdk.Token.asString(this.getAtt("VerifiedAccessEndpointId", cdk.ResolutionTypeHint.STRING)), this.attrVerifiedAccessInstanceId = cdk.Token.asString(this.getAtt("VerifiedAccessInstanceId", cdk.ResolutionTypeHint.STRING)), this.applicationDomain = props.applicationDomain, this.attachmentType = props.attachmentType, this.domainCertificateArn = props.domainCertificateArn, this.endpointDomainPrefix = props.endpointDomainPrefix, this.endpointType = props.endpointType, this.verifiedAccessGroupId = props.verifiedAccessGroupId, this.description = props.description, this.loadBalancerOptions = props.loadBalancerOptions, this.networkInterfaceOptions = props.networkInterfaceOptions, this.policyDocument = props.policyDocument, this.policyEnabled = props.policyEnabled, this.securityGroupIds = props.securityGroupIds, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::VerifiedAccessEndpoint", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVerifiedAccessEndpoint.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationDomain: this.applicationDomain, attachmentType: this.attachmentType, domainCertificateArn: this.domainCertificateArn, endpointDomainPrefix: this.endpointDomainPrefix, endpointType: this.endpointType, verifiedAccessGroupId: this.verifiedAccessGroupId, description: this.description, loadBalancerOptions: this.loadBalancerOptions, networkInterfaceOptions: this.networkInterfaceOptions, policyDocument: this.policyDocument, policyEnabled: this.policyEnabled, securityGroupIds: this.securityGroupIds, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnVerifiedAccessEndpointPropsToCloudFormation(props);
      }
    };
    _61 = JSII_RTTI_SYMBOL_1, CfnVerifiedAccessEndpoint[_61] = { fqn: "aws-cdk-lib.aws_ec2.CfnVerifiedAccessEndpoint", version: "2.80.0" }, CfnVerifiedAccessEndpoint.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::VerifiedAccessEndpoint", exports2.CfnVerifiedAccessEndpoint = CfnVerifiedAccessEndpoint;
    function CfnVerifiedAccessEndpoint_LoadBalancerOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("loadBalancerArn", cdk.validateString)(properties.loadBalancerArn)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.wrap('supplied properties not correct for "LoadBalancerOptionsProperty"');
    }
    function cfnVerifiedAccessEndpointLoadBalancerOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVerifiedAccessEndpoint_LoadBalancerOptionsPropertyValidator(properties).assertSuccess(), { LoadBalancerArn: cdk.stringToCloudFormation(properties.loadBalancerArn), Port: cdk.numberToCloudFormation(properties.port), Protocol: cdk.stringToCloudFormation(properties.protocol), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds) }) : properties;
    }
    function CfnVerifiedAccessEndpointLoadBalancerOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("loadBalancerArn", "LoadBalancerArn", properties.LoadBalancerArn != null ? cfn_parse.FromCloudFormation.getString(properties.LoadBalancerArn) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addPropertyResult("protocol", "Protocol", properties.Protocol != null ? cfn_parse.FromCloudFormation.getString(properties.Protocol) : void 0), ret.addPropertyResult("subnetIds", "SubnetIds", properties.SubnetIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVerifiedAccessEndpoint_NetworkInterfaceOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("networkInterfaceId", cdk.validateString)(properties.networkInterfaceId)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.wrap('supplied properties not correct for "NetworkInterfaceOptionsProperty"');
    }
    function cfnVerifiedAccessEndpointNetworkInterfaceOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVerifiedAccessEndpoint_NetworkInterfaceOptionsPropertyValidator(properties).assertSuccess(), { NetworkInterfaceId: cdk.stringToCloudFormation(properties.networkInterfaceId), Port: cdk.numberToCloudFormation(properties.port), Protocol: cdk.stringToCloudFormation(properties.protocol) }) : properties;
    }
    function CfnVerifiedAccessEndpointNetworkInterfaceOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("networkInterfaceId", "NetworkInterfaceId", properties.NetworkInterfaceId != null ? cfn_parse.FromCloudFormation.getString(properties.NetworkInterfaceId) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addPropertyResult("protocol", "Protocol", properties.Protocol != null ? cfn_parse.FromCloudFormation.getString(properties.Protocol) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVerifiedAccessGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("policyDocument", cdk.validateString)(properties.policyDocument)), errors.collect(cdk.propertyValidator("policyEnabled", cdk.validateBoolean)(properties.policyEnabled)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("verifiedAccessInstanceId", cdk.requiredValidator)(properties.verifiedAccessInstanceId)), errors.collect(cdk.propertyValidator("verifiedAccessInstanceId", cdk.validateString)(properties.verifiedAccessInstanceId)), errors.wrap('supplied properties not correct for "CfnVerifiedAccessGroupProps"');
    }
    function cfnVerifiedAccessGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVerifiedAccessGroupPropsValidator(properties).assertSuccess(), { VerifiedAccessInstanceId: cdk.stringToCloudFormation(properties.verifiedAccessInstanceId), Description: cdk.stringToCloudFormation(properties.description), PolicyDocument: cdk.stringToCloudFormation(properties.policyDocument), PolicyEnabled: cdk.booleanToCloudFormation(properties.policyEnabled), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnVerifiedAccessGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("verifiedAccessInstanceId", "VerifiedAccessInstanceId", cfn_parse.FromCloudFormation.getString(properties.VerifiedAccessInstanceId)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("policyDocument", "PolicyDocument", properties.PolicyDocument != null ? cfn_parse.FromCloudFormation.getString(properties.PolicyDocument) : void 0), ret.addPropertyResult("policyEnabled", "PolicyEnabled", properties.PolicyEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.PolicyEnabled) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVerifiedAccessGroup = class _CfnVerifiedAccessGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVerifiedAccessGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnVerifiedAccessGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVerifiedAccessGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnVerifiedAccessGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVerifiedAccessGroup), error;
        }
        cdk.requireProperty(props, "verifiedAccessInstanceId", this), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrLastUpdatedTime = cdk.Token.asString(this.getAtt("LastUpdatedTime", cdk.ResolutionTypeHint.STRING)), this.attrOwner = cdk.Token.asString(this.getAtt("Owner", cdk.ResolutionTypeHint.STRING)), this.attrVerifiedAccessGroupArn = cdk.Token.asString(this.getAtt("VerifiedAccessGroupArn", cdk.ResolutionTypeHint.STRING)), this.attrVerifiedAccessGroupId = cdk.Token.asString(this.getAtt("VerifiedAccessGroupId", cdk.ResolutionTypeHint.STRING)), this.verifiedAccessInstanceId = props.verifiedAccessInstanceId, this.description = props.description, this.policyDocument = props.policyDocument, this.policyEnabled = props.policyEnabled, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::VerifiedAccessGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVerifiedAccessGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { verifiedAccessInstanceId: this.verifiedAccessInstanceId, description: this.description, policyDocument: this.policyDocument, policyEnabled: this.policyEnabled, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnVerifiedAccessGroupPropsToCloudFormation(props);
      }
    };
    _62 = JSII_RTTI_SYMBOL_1, CfnVerifiedAccessGroup[_62] = { fqn: "aws-cdk-lib.aws_ec2.CfnVerifiedAccessGroup", version: "2.80.0" }, CfnVerifiedAccessGroup.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::VerifiedAccessGroup", exports2.CfnVerifiedAccessGroup = CfnVerifiedAccessGroup;
    function CfnVerifiedAccessInstancePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("loggingConfigurations", CfnVerifiedAccessInstance_VerifiedAccessLogsPropertyValidator)(properties.loggingConfigurations)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("verifiedAccessTrustProviderIds", cdk.listValidator(cdk.validateString))(properties.verifiedAccessTrustProviderIds)), errors.collect(cdk.propertyValidator("verifiedAccessTrustProviders", cdk.listValidator(CfnVerifiedAccessInstance_VerifiedAccessTrustProviderPropertyValidator))(properties.verifiedAccessTrustProviders)), errors.wrap('supplied properties not correct for "CfnVerifiedAccessInstanceProps"');
    }
    function cfnVerifiedAccessInstancePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVerifiedAccessInstancePropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), LoggingConfigurations: cfnVerifiedAccessInstanceVerifiedAccessLogsPropertyToCloudFormation(properties.loggingConfigurations), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VerifiedAccessTrustProviderIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.verifiedAccessTrustProviderIds), VerifiedAccessTrustProviders: cdk.listMapper(cfnVerifiedAccessInstanceVerifiedAccessTrustProviderPropertyToCloudFormation)(properties.verifiedAccessTrustProviders) }) : properties;
    }
    function CfnVerifiedAccessInstancePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("loggingConfigurations", "LoggingConfigurations", properties.LoggingConfigurations != null ? CfnVerifiedAccessInstanceVerifiedAccessLogsPropertyFromCloudFormation(properties.LoggingConfigurations) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("verifiedAccessTrustProviderIds", "VerifiedAccessTrustProviderIds", properties.VerifiedAccessTrustProviderIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.VerifiedAccessTrustProviderIds) : void 0), ret.addPropertyResult("verifiedAccessTrustProviders", "VerifiedAccessTrustProviders", properties.VerifiedAccessTrustProviders != null ? cfn_parse.FromCloudFormation.getArray(CfnVerifiedAccessInstanceVerifiedAccessTrustProviderPropertyFromCloudFormation)(properties.VerifiedAccessTrustProviders) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVerifiedAccessInstance = class _CfnVerifiedAccessInstance extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVerifiedAccessInstancePropsFromCloudFormation(resourceProperties), ret = new _CfnVerifiedAccessInstance(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnVerifiedAccessInstance.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnVerifiedAccessInstanceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVerifiedAccessInstance), error;
        }
        this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrLastUpdatedTime = cdk.Token.asString(this.getAtt("LastUpdatedTime", cdk.ResolutionTypeHint.STRING)), this.attrVerifiedAccessInstanceId = cdk.Token.asString(this.getAtt("VerifiedAccessInstanceId", cdk.ResolutionTypeHint.STRING)), this.description = props.description, this.loggingConfigurations = props.loggingConfigurations, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::VerifiedAccessInstance", props.tags, { tagPropertyName: "tags" }), this.verifiedAccessTrustProviderIds = props.verifiedAccessTrustProviderIds, this.verifiedAccessTrustProviders = props.verifiedAccessTrustProviders;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVerifiedAccessInstance.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, loggingConfigurations: this.loggingConfigurations, tags: this.tags.renderTags(), verifiedAccessTrustProviderIds: this.verifiedAccessTrustProviderIds, verifiedAccessTrustProviders: this.verifiedAccessTrustProviders };
      }
      renderProperties(props) {
        return cfnVerifiedAccessInstancePropsToCloudFormation(props);
      }
    };
    _63 = JSII_RTTI_SYMBOL_1, CfnVerifiedAccessInstance[_63] = { fqn: "aws-cdk-lib.aws_ec2.CfnVerifiedAccessInstance", version: "2.80.0" }, CfnVerifiedAccessInstance.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::VerifiedAccessInstance", exports2.CfnVerifiedAccessInstance = CfnVerifiedAccessInstance;
    function CfnVerifiedAccessInstance_CloudWatchLogsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("logGroup", cdk.validateString)(properties.logGroup)), errors.wrap('supplied properties not correct for "CloudWatchLogsProperty"');
    }
    function cfnVerifiedAccessInstanceCloudWatchLogsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVerifiedAccessInstance_CloudWatchLogsPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled), LogGroup: cdk.stringToCloudFormation(properties.logGroup) }) : properties;
    }
    function CfnVerifiedAccessInstanceCloudWatchLogsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("logGroup", "LogGroup", properties.LogGroup != null ? cfn_parse.FromCloudFormation.getString(properties.LogGroup) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVerifiedAccessInstance_KinesisDataFirehosePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deliveryStream", cdk.validateString)(properties.deliveryStream)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "KinesisDataFirehoseProperty"');
    }
    function cfnVerifiedAccessInstanceKinesisDataFirehosePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVerifiedAccessInstance_KinesisDataFirehosePropertyValidator(properties).assertSuccess(), { DeliveryStream: cdk.stringToCloudFormation(properties.deliveryStream), Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnVerifiedAccessInstanceKinesisDataFirehosePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deliveryStream", "DeliveryStream", properties.DeliveryStream != null ? cfn_parse.FromCloudFormation.getString(properties.DeliveryStream) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVerifiedAccessInstance_S3PropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketOwner", cdk.validateString)(properties.bucketOwner)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.wrap('supplied properties not correct for "S3Property"');
    }
    function cfnVerifiedAccessInstanceS3PropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVerifiedAccessInstance_S3PropertyValidator(properties).assertSuccess(), { BucketName: cdk.stringToCloudFormation(properties.bucketName), BucketOwner: cdk.stringToCloudFormation(properties.bucketOwner), Enabled: cdk.booleanToCloudFormation(properties.enabled), Prefix: cdk.stringToCloudFormation(properties.prefix) }) : properties;
    }
    function CfnVerifiedAccessInstanceS3PropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketName", "BucketName", properties.BucketName != null ? cfn_parse.FromCloudFormation.getString(properties.BucketName) : void 0), ret.addPropertyResult("bucketOwner", "BucketOwner", properties.BucketOwner != null ? cfn_parse.FromCloudFormation.getString(properties.BucketOwner) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVerifiedAccessInstance_VerifiedAccessLogsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchLogs", CfnVerifiedAccessInstance_CloudWatchLogsPropertyValidator)(properties.cloudWatchLogs)), errors.collect(cdk.propertyValidator("kinesisDataFirehose", CfnVerifiedAccessInstance_KinesisDataFirehosePropertyValidator)(properties.kinesisDataFirehose)), errors.collect(cdk.propertyValidator("s3", CfnVerifiedAccessInstance_S3PropertyValidator)(properties.s3)), errors.wrap('supplied properties not correct for "VerifiedAccessLogsProperty"');
    }
    function cfnVerifiedAccessInstanceVerifiedAccessLogsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVerifiedAccessInstance_VerifiedAccessLogsPropertyValidator(properties).assertSuccess(), { CloudWatchLogs: cfnVerifiedAccessInstanceCloudWatchLogsPropertyToCloudFormation(properties.cloudWatchLogs), KinesisDataFirehose: cfnVerifiedAccessInstanceKinesisDataFirehosePropertyToCloudFormation(properties.kinesisDataFirehose), S3: cfnVerifiedAccessInstanceS3PropertyToCloudFormation(properties.s3) }) : properties;
    }
    function CfnVerifiedAccessInstanceVerifiedAccessLogsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchLogs", "CloudWatchLogs", properties.CloudWatchLogs != null ? CfnVerifiedAccessInstanceCloudWatchLogsPropertyFromCloudFormation(properties.CloudWatchLogs) : void 0), ret.addPropertyResult("kinesisDataFirehose", "KinesisDataFirehose", properties.KinesisDataFirehose != null ? CfnVerifiedAccessInstanceKinesisDataFirehosePropertyFromCloudFormation(properties.KinesisDataFirehose) : void 0), ret.addPropertyResult("s3", "S3", properties.S3 != null ? CfnVerifiedAccessInstanceS3PropertyFromCloudFormation(properties.S3) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVerifiedAccessInstance_VerifiedAccessTrustProviderPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("deviceTrustProviderType", cdk.validateString)(properties.deviceTrustProviderType)), errors.collect(cdk.propertyValidator("trustProviderType", cdk.validateString)(properties.trustProviderType)), errors.collect(cdk.propertyValidator("userTrustProviderType", cdk.validateString)(properties.userTrustProviderType)), errors.collect(cdk.propertyValidator("verifiedAccessTrustProviderId", cdk.validateString)(properties.verifiedAccessTrustProviderId)), errors.wrap('supplied properties not correct for "VerifiedAccessTrustProviderProperty"');
    }
    function cfnVerifiedAccessInstanceVerifiedAccessTrustProviderPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVerifiedAccessInstance_VerifiedAccessTrustProviderPropertyValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), DeviceTrustProviderType: cdk.stringToCloudFormation(properties.deviceTrustProviderType), TrustProviderType: cdk.stringToCloudFormation(properties.trustProviderType), UserTrustProviderType: cdk.stringToCloudFormation(properties.userTrustProviderType), VerifiedAccessTrustProviderId: cdk.stringToCloudFormation(properties.verifiedAccessTrustProviderId) }) : properties;
    }
    function CfnVerifiedAccessInstanceVerifiedAccessTrustProviderPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("deviceTrustProviderType", "DeviceTrustProviderType", properties.DeviceTrustProviderType != null ? cfn_parse.FromCloudFormation.getString(properties.DeviceTrustProviderType) : void 0), ret.addPropertyResult("trustProviderType", "TrustProviderType", properties.TrustProviderType != null ? cfn_parse.FromCloudFormation.getString(properties.TrustProviderType) : void 0), ret.addPropertyResult("userTrustProviderType", "UserTrustProviderType", properties.UserTrustProviderType != null ? cfn_parse.FromCloudFormation.getString(properties.UserTrustProviderType) : void 0), ret.addPropertyResult("verifiedAccessTrustProviderId", "VerifiedAccessTrustProviderId", properties.VerifiedAccessTrustProviderId != null ? cfn_parse.FromCloudFormation.getString(properties.VerifiedAccessTrustProviderId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVerifiedAccessTrustProviderPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("deviceOptions", CfnVerifiedAccessTrustProvider_DeviceOptionsPropertyValidator)(properties.deviceOptions)), errors.collect(cdk.propertyValidator("deviceTrustProviderType", cdk.validateString)(properties.deviceTrustProviderType)), errors.collect(cdk.propertyValidator("oidcOptions", CfnVerifiedAccessTrustProvider_OidcOptionsPropertyValidator)(properties.oidcOptions)), errors.collect(cdk.propertyValidator("policyReferenceName", cdk.requiredValidator)(properties.policyReferenceName)), errors.collect(cdk.propertyValidator("policyReferenceName", cdk.validateString)(properties.policyReferenceName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("trustProviderType", cdk.requiredValidator)(properties.trustProviderType)), errors.collect(cdk.propertyValidator("trustProviderType", cdk.validateString)(properties.trustProviderType)), errors.collect(cdk.propertyValidator("userTrustProviderType", cdk.validateString)(properties.userTrustProviderType)), errors.wrap('supplied properties not correct for "CfnVerifiedAccessTrustProviderProps"');
    }
    function cfnVerifiedAccessTrustProviderPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVerifiedAccessTrustProviderPropsValidator(properties).assertSuccess(), { PolicyReferenceName: cdk.stringToCloudFormation(properties.policyReferenceName), TrustProviderType: cdk.stringToCloudFormation(properties.trustProviderType), Description: cdk.stringToCloudFormation(properties.description), DeviceOptions: cfnVerifiedAccessTrustProviderDeviceOptionsPropertyToCloudFormation(properties.deviceOptions), DeviceTrustProviderType: cdk.stringToCloudFormation(properties.deviceTrustProviderType), OidcOptions: cfnVerifiedAccessTrustProviderOidcOptionsPropertyToCloudFormation(properties.oidcOptions), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), UserTrustProviderType: cdk.stringToCloudFormation(properties.userTrustProviderType) }) : properties;
    }
    function CfnVerifiedAccessTrustProviderPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("policyReferenceName", "PolicyReferenceName", cfn_parse.FromCloudFormation.getString(properties.PolicyReferenceName)), ret.addPropertyResult("trustProviderType", "TrustProviderType", cfn_parse.FromCloudFormation.getString(properties.TrustProviderType)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("deviceOptions", "DeviceOptions", properties.DeviceOptions != null ? CfnVerifiedAccessTrustProviderDeviceOptionsPropertyFromCloudFormation(properties.DeviceOptions) : void 0), ret.addPropertyResult("deviceTrustProviderType", "DeviceTrustProviderType", properties.DeviceTrustProviderType != null ? cfn_parse.FromCloudFormation.getString(properties.DeviceTrustProviderType) : void 0), ret.addPropertyResult("oidcOptions", "OidcOptions", properties.OidcOptions != null ? CfnVerifiedAccessTrustProviderOidcOptionsPropertyFromCloudFormation(properties.OidcOptions) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("userTrustProviderType", "UserTrustProviderType", properties.UserTrustProviderType != null ? cfn_parse.FromCloudFormation.getString(properties.UserTrustProviderType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVerifiedAccessTrustProvider = class _CfnVerifiedAccessTrustProvider extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVerifiedAccessTrustProviderPropsFromCloudFormation(resourceProperties), ret = new _CfnVerifiedAccessTrustProvider(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVerifiedAccessTrustProvider.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnVerifiedAccessTrustProviderProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVerifiedAccessTrustProvider), error;
        }
        cdk.requireProperty(props, "policyReferenceName", this), cdk.requireProperty(props, "trustProviderType", this), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrLastUpdatedTime = cdk.Token.asString(this.getAtt("LastUpdatedTime", cdk.ResolutionTypeHint.STRING)), this.attrVerifiedAccessTrustProviderId = cdk.Token.asString(this.getAtt("VerifiedAccessTrustProviderId", cdk.ResolutionTypeHint.STRING)), this.policyReferenceName = props.policyReferenceName, this.trustProviderType = props.trustProviderType, this.description = props.description, this.deviceOptions = props.deviceOptions, this.deviceTrustProviderType = props.deviceTrustProviderType, this.oidcOptions = props.oidcOptions, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::VerifiedAccessTrustProvider", props.tags, { tagPropertyName: "tags" }), this.userTrustProviderType = props.userTrustProviderType;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVerifiedAccessTrustProvider.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { policyReferenceName: this.policyReferenceName, trustProviderType: this.trustProviderType, description: this.description, deviceOptions: this.deviceOptions, deviceTrustProviderType: this.deviceTrustProviderType, oidcOptions: this.oidcOptions, tags: this.tags.renderTags(), userTrustProviderType: this.userTrustProviderType };
      }
      renderProperties(props) {
        return cfnVerifiedAccessTrustProviderPropsToCloudFormation(props);
      }
    };
    _64 = JSII_RTTI_SYMBOL_1, CfnVerifiedAccessTrustProvider[_64] = { fqn: "aws-cdk-lib.aws_ec2.CfnVerifiedAccessTrustProvider", version: "2.80.0" }, CfnVerifiedAccessTrustProvider.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::VerifiedAccessTrustProvider", exports2.CfnVerifiedAccessTrustProvider = CfnVerifiedAccessTrustProvider;
    function CfnVerifiedAccessTrustProvider_DeviceOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("tenantId", cdk.validateString)(properties.tenantId)), errors.wrap('supplied properties not correct for "DeviceOptionsProperty"');
    }
    function cfnVerifiedAccessTrustProviderDeviceOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVerifiedAccessTrustProvider_DeviceOptionsPropertyValidator(properties).assertSuccess(), { TenantId: cdk.stringToCloudFormation(properties.tenantId) }) : properties;
    }
    function CfnVerifiedAccessTrustProviderDeviceOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("tenantId", "TenantId", properties.TenantId != null ? cfn_parse.FromCloudFormation.getString(properties.TenantId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVerifiedAccessTrustProvider_OidcOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authorizationEndpoint", cdk.validateString)(properties.authorizationEndpoint)), errors.collect(cdk.propertyValidator("clientId", cdk.validateString)(properties.clientId)), errors.collect(cdk.propertyValidator("clientSecret", cdk.validateString)(properties.clientSecret)), errors.collect(cdk.propertyValidator("issuer", cdk.validateString)(properties.issuer)), errors.collect(cdk.propertyValidator("scope", cdk.validateString)(properties.scope)), errors.collect(cdk.propertyValidator("tokenEndpoint", cdk.validateString)(properties.tokenEndpoint)), errors.collect(cdk.propertyValidator("userInfoEndpoint", cdk.validateString)(properties.userInfoEndpoint)), errors.wrap('supplied properties not correct for "OidcOptionsProperty"');
    }
    function cfnVerifiedAccessTrustProviderOidcOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVerifiedAccessTrustProvider_OidcOptionsPropertyValidator(properties).assertSuccess(), { AuthorizationEndpoint: cdk.stringToCloudFormation(properties.authorizationEndpoint), ClientId: cdk.stringToCloudFormation(properties.clientId), ClientSecret: cdk.stringToCloudFormation(properties.clientSecret), Issuer: cdk.stringToCloudFormation(properties.issuer), Scope: cdk.stringToCloudFormation(properties.scope), TokenEndpoint: cdk.stringToCloudFormation(properties.tokenEndpoint), UserInfoEndpoint: cdk.stringToCloudFormation(properties.userInfoEndpoint) }) : properties;
    }
    function CfnVerifiedAccessTrustProviderOidcOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authorizationEndpoint", "AuthorizationEndpoint", properties.AuthorizationEndpoint != null ? cfn_parse.FromCloudFormation.getString(properties.AuthorizationEndpoint) : void 0), ret.addPropertyResult("clientId", "ClientId", properties.ClientId != null ? cfn_parse.FromCloudFormation.getString(properties.ClientId) : void 0), ret.addPropertyResult("clientSecret", "ClientSecret", properties.ClientSecret != null ? cfn_parse.FromCloudFormation.getString(properties.ClientSecret) : void 0), ret.addPropertyResult("issuer", "Issuer", properties.Issuer != null ? cfn_parse.FromCloudFormation.getString(properties.Issuer) : void 0), ret.addPropertyResult("scope", "Scope", properties.Scope != null ? cfn_parse.FromCloudFormation.getString(properties.Scope) : void 0), ret.addPropertyResult("tokenEndpoint", "TokenEndpoint", properties.TokenEndpoint != null ? cfn_parse.FromCloudFormation.getString(properties.TokenEndpoint) : void 0), ret.addPropertyResult("userInfoEndpoint", "UserInfoEndpoint", properties.UserInfoEndpoint != null ? cfn_parse.FromCloudFormation.getString(properties.UserInfoEndpoint) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVolumePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoEnableIo", cdk.validateBoolean)(properties.autoEnableIo)), errors.collect(cdk.propertyValidator("availabilityZone", cdk.requiredValidator)(properties.availabilityZone)), errors.collect(cdk.propertyValidator("availabilityZone", cdk.validateString)(properties.availabilityZone)), errors.collect(cdk.propertyValidator("encrypted", cdk.validateBoolean)(properties.encrypted)), errors.collect(cdk.propertyValidator("iops", cdk.validateNumber)(properties.iops)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("multiAttachEnabled", cdk.validateBoolean)(properties.multiAttachEnabled)), errors.collect(cdk.propertyValidator("outpostArn", cdk.validateString)(properties.outpostArn)), errors.collect(cdk.propertyValidator("size", cdk.validateNumber)(properties.size)), errors.collect(cdk.propertyValidator("snapshotId", cdk.validateString)(properties.snapshotId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("throughput", cdk.validateNumber)(properties.throughput)), errors.collect(cdk.propertyValidator("volumeType", cdk.validateString)(properties.volumeType)), errors.wrap('supplied properties not correct for "CfnVolumeProps"');
    }
    function cfnVolumePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVolumePropsValidator(properties).assertSuccess(), { AvailabilityZone: cdk.stringToCloudFormation(properties.availabilityZone), AutoEnableIO: cdk.booleanToCloudFormation(properties.autoEnableIo), Encrypted: cdk.booleanToCloudFormation(properties.encrypted), Iops: cdk.numberToCloudFormation(properties.iops), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), MultiAttachEnabled: cdk.booleanToCloudFormation(properties.multiAttachEnabled), OutpostArn: cdk.stringToCloudFormation(properties.outpostArn), Size: cdk.numberToCloudFormation(properties.size), SnapshotId: cdk.stringToCloudFormation(properties.snapshotId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), Throughput: cdk.numberToCloudFormation(properties.throughput), VolumeType: cdk.stringToCloudFormation(properties.volumeType) }) : properties;
    }
    function CfnVolumePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("availabilityZone", "AvailabilityZone", cfn_parse.FromCloudFormation.getString(properties.AvailabilityZone)), ret.addPropertyResult("autoEnableIo", "AutoEnableIO", properties.AutoEnableIO != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AutoEnableIO) : void 0), ret.addPropertyResult("encrypted", "Encrypted", properties.Encrypted != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Encrypted) : void 0), ret.addPropertyResult("iops", "Iops", properties.Iops != null ? cfn_parse.FromCloudFormation.getNumber(properties.Iops) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("multiAttachEnabled", "MultiAttachEnabled", properties.MultiAttachEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.MultiAttachEnabled) : void 0), ret.addPropertyResult("outpostArn", "OutpostArn", properties.OutpostArn != null ? cfn_parse.FromCloudFormation.getString(properties.OutpostArn) : void 0), ret.addPropertyResult("size", "Size", properties.Size != null ? cfn_parse.FromCloudFormation.getNumber(properties.Size) : void 0), ret.addPropertyResult("snapshotId", "SnapshotId", properties.SnapshotId != null ? cfn_parse.FromCloudFormation.getString(properties.SnapshotId) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("throughput", "Throughput", properties.Throughput != null ? cfn_parse.FromCloudFormation.getNumber(properties.Throughput) : void 0), ret.addPropertyResult("volumeType", "VolumeType", properties.VolumeType != null ? cfn_parse.FromCloudFormation.getString(properties.VolumeType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVolume = class _CfnVolume extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVolumePropsFromCloudFormation(resourceProperties), ret = new _CfnVolume(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVolume.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnVolumeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVolume), error;
        }
        cdk.requireProperty(props, "availabilityZone", this), this.attrVolumeId = cdk.Token.asString(this.getAtt("VolumeId", cdk.ResolutionTypeHint.STRING)), this.availabilityZone = props.availabilityZone, this.autoEnableIo = props.autoEnableIo, this.encrypted = props.encrypted, this.iops = props.iops, this.kmsKeyId = props.kmsKeyId, this.multiAttachEnabled = props.multiAttachEnabled, this.outpostArn = props.outpostArn, this.size = props.size, this.snapshotId = props.snapshotId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EC2::Volume", props.tags, { tagPropertyName: "tags" }), this.throughput = props.throughput, this.volumeType = props.volumeType, this.node.scope && cdk.Resource.isResource(this.node.scope) && this.node.addValidation({ validate: () => this.cfnOptions.deletionPolicy === void 0 ? ["'AWS::EC2::Volume' is a stateful resource type, and you must specify a Removal Policy for it. Call 'resource.applyRemovalPolicy()'."] : [] });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVolume.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { availabilityZone: this.availabilityZone, autoEnableIo: this.autoEnableIo, encrypted: this.encrypted, iops: this.iops, kmsKeyId: this.kmsKeyId, multiAttachEnabled: this.multiAttachEnabled, outpostArn: this.outpostArn, size: this.size, snapshotId: this.snapshotId, tags: this.tags.renderTags(), throughput: this.throughput, volumeType: this.volumeType };
      }
      renderProperties(props) {
        return cfnVolumePropsToCloudFormation(props);
      }
    };
    _65 = JSII_RTTI_SYMBOL_1, CfnVolume[_65] = { fqn: "aws-cdk-lib.aws_ec2.CfnVolume", version: "2.80.0" }, CfnVolume.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::Volume", exports2.CfnVolume = CfnVolume;
    function CfnVolumeAttachmentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("device", cdk.requiredValidator)(properties.device)), errors.collect(cdk.propertyValidator("device", cdk.validateString)(properties.device)), errors.collect(cdk.propertyValidator("instanceId", cdk.requiredValidator)(properties.instanceId)), errors.collect(cdk.propertyValidator("instanceId", cdk.validateString)(properties.instanceId)), errors.collect(cdk.propertyValidator("volumeId", cdk.requiredValidator)(properties.volumeId)), errors.collect(cdk.propertyValidator("volumeId", cdk.validateString)(properties.volumeId)), errors.wrap('supplied properties not correct for "CfnVolumeAttachmentProps"');
    }
    function cfnVolumeAttachmentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVolumeAttachmentPropsValidator(properties).assertSuccess(), { Device: cdk.stringToCloudFormation(properties.device), InstanceId: cdk.stringToCloudFormation(properties.instanceId), VolumeId: cdk.stringToCloudFormation(properties.volumeId) }) : properties;
    }
    function CfnVolumeAttachmentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("device", "Device", cfn_parse.FromCloudFormation.getString(properties.Device)), ret.addPropertyResult("instanceId", "InstanceId", cfn_parse.FromCloudFormation.getString(properties.InstanceId)), ret.addPropertyResult("volumeId", "VolumeId", cfn_parse.FromCloudFormation.getString(properties.VolumeId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVolumeAttachment = class _CfnVolumeAttachment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVolumeAttachmentPropsFromCloudFormation(resourceProperties), ret = new _CfnVolumeAttachment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVolumeAttachment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnVolumeAttachmentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVolumeAttachment), error;
        }
        cdk.requireProperty(props, "device", this), cdk.requireProperty(props, "instanceId", this), cdk.requireProperty(props, "volumeId", this), this.device = props.device, this.instanceId = props.instanceId, this.volumeId = props.volumeId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVolumeAttachment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { device: this.device, instanceId: this.instanceId, volumeId: this.volumeId };
      }
      renderProperties(props) {
        return cfnVolumeAttachmentPropsToCloudFormation(props);
      }
    };
    _66 = JSII_RTTI_SYMBOL_1, CfnVolumeAttachment[_66] = { fqn: "aws-cdk-lib.aws_ec2.CfnVolumeAttachment", version: "2.80.0" }, CfnVolumeAttachment.CFN_RESOURCE_TYPE_NAME = "AWS::EC2::VolumeAttachment", exports2.CfnVolumeAttachment = CfnVolumeAttachment;
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/peer.js
var require_peer = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/peer.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Peer = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var connections_1 = require_connections();
    var core_1 = require_core2();
    var Peer = class {
      static ipv4(cidrIp) {
        return new CidrIPv4(cidrIp);
      }
      static anyIpv4() {
        return new AnyIPv4();
      }
      static ipv6(cidrIp) {
        return new CidrIPv6(cidrIp);
      }
      static anyIpv6() {
        return new AnyIPv6();
      }
      static prefixList(prefixListId) {
        return new PrefixList(prefixListId);
      }
      static securityGroupId(securityGroupId, sourceSecurityGroupOwnerId) {
        return new SecurityGroupId(securityGroupId, sourceSecurityGroupOwnerId);
      }
      constructor() {
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Peer[_a] = { fqn: "aws-cdk-lib.aws_ec2.Peer", version: "2.80.0" }, exports2.Peer = Peer;
    var CidrIPv4 = class {
      constructor(cidrIp) {
        if (this.cidrIp = cidrIp, this.canInlineRule = true, this.connections = new connections_1.Connections({ peer: this }), !core_1.Token.isUnresolved(cidrIp)) {
          const cidrMatch = cidrIp.match(/^(\d{1,3}\.){3}\d{1,3}(\/\d+)?$/);
          if (!cidrMatch)
            throw new Error(`Invalid IPv4 CIDR: "${cidrIp}"`);
          if (!cidrMatch[2])
            throw new Error(`CIDR mask is missing in IPv4: "${cidrIp}". Did you mean "${cidrIp}/32"?`);
        }
        this.uniqueId = cidrIp;
      }
      toIngressRuleConfig() {
        return { cidrIp: this.cidrIp };
      }
      toEgressRuleConfig() {
        return { cidrIp: this.cidrIp };
      }
    };
    var AnyIPv4 = class extends CidrIPv4 {
      constructor() {
        super("0.0.0.0/0");
      }
    };
    var CidrIPv6 = class {
      constructor(cidrIpv6) {
        if (this.cidrIpv6 = cidrIpv6, this.canInlineRule = true, this.connections = new connections_1.Connections({ peer: this }), !core_1.Token.isUnresolved(cidrIpv6)) {
          const cidrMatch = cidrIpv6.match(/^([\da-f]{0,4}:){2,7}([\da-f]{0,4})?(\/\d+)?$/);
          if (!cidrMatch)
            throw new Error(`Invalid IPv6 CIDR: "${cidrIpv6}"`);
          if (!cidrMatch[3])
            throw new Error(`CIDR mask is missing in IPv6: "${cidrIpv6}". Did you mean "${cidrIpv6}/128"?`);
        }
        this.uniqueId = cidrIpv6;
      }
      toIngressRuleConfig() {
        return { cidrIpv6: this.cidrIpv6 };
      }
      toEgressRuleConfig() {
        return { cidrIpv6: this.cidrIpv6 };
      }
    };
    var AnyIPv6 = class extends CidrIPv6 {
      constructor() {
        super("::/0");
      }
    };
    var PrefixList = class {
      constructor(prefixListId) {
        this.prefixListId = prefixListId, this.canInlineRule = false, this.connections = new connections_1.Connections({ peer: this }), this.uniqueId = prefixListId;
      }
      toIngressRuleConfig() {
        return { sourcePrefixListId: this.prefixListId };
      }
      toEgressRuleConfig() {
        return { destinationPrefixListId: this.prefixListId };
      }
    };
    var SecurityGroupId = class {
      constructor(securityGroupId, sourceSecurityGroupOwnerId) {
        if (this.securityGroupId = securityGroupId, this.sourceSecurityGroupOwnerId = sourceSecurityGroupOwnerId, this.canInlineRule = true, this.connections = new connections_1.Connections({ peer: this }), !core_1.Token.isUnresolved(securityGroupId) && !securityGroupId.match(/^sg-[a-z0-9]{8,17}$/))
          throw new Error(`Invalid security group ID: "${securityGroupId}"`);
        if (sourceSecurityGroupOwnerId && !core_1.Token.isUnresolved(sourceSecurityGroupOwnerId) && !sourceSecurityGroupOwnerId.match(/^[0-9]{12}$/))
          throw new Error(`Invalid security group owner ID: "${sourceSecurityGroupOwnerId}"`);
        this.uniqueId = securityGroupId;
      }
      toIngressRuleConfig() {
        return { sourceSecurityGroupId: this.securityGroupId, ...this.sourceSecurityGroupOwnerId && { sourceSecurityGroupOwnerId: this.sourceSecurityGroupOwnerId } };
      }
      toEgressRuleConfig() {
        return { destinationSecurityGroupId: this.securityGroupId };
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/connections.js
var require_connections = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/connections.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Connections = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var peer_1 = require_peer();
    var Connections = class _Connections {
      constructor(props = {}) {
        this._securityGroups = new ReactiveList(), this._securityGroupRules = new ReactiveList(), this.skip = false, this.remoteRule = false;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_ConnectionsProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Connections), error;
        }
        this.connections = this, this._securityGroups.push(...props.securityGroups || []), this._securityGroupRules.push(...this._securityGroups.asArray()), props.peer && this._securityGroupRules.push(props.peer), this.defaultPort = props.defaultPort;
      }
      get securityGroups() {
        return this._securityGroups.asArray();
      }
      addSecurityGroup(...securityGroups) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_ISecurityGroup(securityGroups);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addSecurityGroup), error;
        }
        for (const securityGroup of securityGroups)
          this._securityGroups.push(securityGroup), this._securityGroupRules.push(securityGroup);
      }
      allowTo(other, portRange, description) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_IConnectable(other), jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_Port(portRange);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.allowTo), error;
        }
        if (this.skip)
          return;
        const remoteRule = this.remoteRule;
        this._securityGroups.forEachAndForever((securityGroup) => {
          other.connections._securityGroupRules.forEachAndForever((rule) => {
            securityGroup.addEgressRule(rule, portRange, description, remoteRule);
          });
        }), this.skip = true, other.connections.remoteRule = true;
        try {
          other.connections.allowFrom(this, portRange, description);
        } finally {
          this.skip = false, other.connections.remoteRule = false;
        }
      }
      allowFrom(other, portRange, description) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_IConnectable(other), jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_Port(portRange);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.allowFrom), error;
        }
        if (this.skip)
          return;
        const remoteRule = this.remoteRule;
        this._securityGroups.forEachAndForever((securityGroup) => {
          other.connections._securityGroupRules.forEachAndForever((rule) => {
            securityGroup.addIngressRule(rule, portRange, description, remoteRule);
          });
        }), this.skip = true, other.connections.remoteRule = true;
        try {
          other.connections.allowTo(this, portRange, description);
        } finally {
          this.skip = false, other.connections.remoteRule = false;
        }
      }
      allowInternally(portRange, description) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_Port(portRange);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.allowInternally), error;
        }
        this._securityGroups.forEachAndForever((securityGroup) => {
          this._securityGroupRules.forEachAndForever((rule) => {
            securityGroup.addIngressRule(rule, portRange, description), securityGroup.addEgressRule(rule, portRange, description);
          });
        });
      }
      allowToAnyIpv4(portRange, description) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_Port(portRange);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.allowToAnyIpv4), error;
        }
        this.allowTo(peer_1.Peer.anyIpv4(), portRange, description);
      }
      allowFromAnyIpv4(portRange, description) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_Port(portRange);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.allowFromAnyIpv4), error;
        }
        this.allowFrom(peer_1.Peer.anyIpv4(), portRange, description);
      }
      allowDefaultPortFrom(other, description) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_IConnectable(other);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.allowDefaultPortFrom), error;
        }
        if (!this.defaultPort)
          throw new Error("Cannot call allowDefaultPortFrom(): this resource has no default port");
        this.allowFrom(other, this.defaultPort, description);
      }
      allowDefaultPortInternally(description) {
        if (!this.defaultPort)
          throw new Error("Cannot call allowDefaultPortInternally(): this resource has no default port");
        this.allowInternally(this.defaultPort, description);
      }
      allowDefaultPortFromAnyIpv4(description) {
        if (!this.defaultPort)
          throw new Error("Cannot call allowDefaultPortFromAnyIpv4(): this resource has no default port");
        this.allowFromAnyIpv4(this.defaultPort, description);
      }
      allowToDefaultPort(other, description) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_IConnectable(other);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.allowToDefaultPort), error;
        }
        if (other.connections.defaultPort === void 0)
          throw new Error("Cannot call allowToDefaultPort(): other resource has no default port");
        this.allowTo(other, other.connections.defaultPort, description);
      }
      allowDefaultPortTo(other, description) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_IConnectable(other);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.allowDefaultPortTo), error;
        }
        if (!this.defaultPort)
          throw new Error("Cannot call allowDefaultPortTo(): this resource has no default port");
        this.allowTo(other, this.defaultPort, description);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Connections[_a] = { fqn: "aws-cdk-lib.aws_ec2.Connections", version: "2.80.0" }, exports2.Connections = Connections;
    var ReactiveList = class {
      constructor() {
        this.elements = new Array(), this.listeners = new Array();
      }
      push(...xs) {
        this.elements.push(...xs);
        for (const listener of this.listeners)
          for (const x of xs)
            listener(x);
      }
      forEachAndForever(listener) {
        for (const element of this.elements)
          listener(element);
        this.listeners.push(listener);
      }
      asArray() {
        return this.elements.slice();
      }
      get length() {
        return this.elements.length;
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-kms/lib/kms.generated.js
var require_kms_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-kms/lib/kms.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnReplicaKey = exports2.CfnKey = exports2.CfnAlias = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAliasPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aliasName", cdk.requiredValidator)(properties.aliasName)), errors.collect(cdk.propertyValidator("aliasName", cdk.validateString)(properties.aliasName)), errors.collect(cdk.propertyValidator("targetKeyId", cdk.requiredValidator)(properties.targetKeyId)), errors.collect(cdk.propertyValidator("targetKeyId", cdk.validateString)(properties.targetKeyId)), errors.wrap('supplied properties not correct for "CfnAliasProps"');
    }
    function cfnAliasPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAliasPropsValidator(properties).assertSuccess(), { AliasName: cdk.stringToCloudFormation(properties.aliasName), TargetKeyId: cdk.stringToCloudFormation(properties.targetKeyId) }) : properties;
    }
    function CfnAliasPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aliasName", "AliasName", cfn_parse.FromCloudFormation.getString(properties.AliasName)), ret.addPropertyResult("targetKeyId", "TargetKeyId", cfn_parse.FromCloudFormation.getString(properties.TargetKeyId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAlias = class _CfnAlias extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAliasPropsFromCloudFormation(resourceProperties), ret = new _CfnAlias(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAlias.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kms_CfnAliasProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAlias), error;
        }
        cdk.requireProperty(props, "aliasName", this), cdk.requireProperty(props, "targetKeyId", this), this.aliasName = props.aliasName, this.targetKeyId = props.targetKeyId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAlias.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { aliasName: this.aliasName, targetKeyId: this.targetKeyId };
      }
      renderProperties(props) {
        return cfnAliasPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAlias[_a] = { fqn: "aws-cdk-lib.aws_kms.CfnAlias", version: "2.80.0" }, CfnAlias.CFN_RESOURCE_TYPE_NAME = "AWS::KMS::Alias", exports2.CfnAlias = CfnAlias;
    function CfnKeyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("enableKeyRotation", cdk.validateBoolean)(properties.enableKeyRotation)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("keyPolicy", cdk.requiredValidator)(properties.keyPolicy)), errors.collect(cdk.propertyValidator("keyPolicy", cdk.validateObject)(properties.keyPolicy)), errors.collect(cdk.propertyValidator("keySpec", cdk.validateString)(properties.keySpec)), errors.collect(cdk.propertyValidator("keyUsage", cdk.validateString)(properties.keyUsage)), errors.collect(cdk.propertyValidator("multiRegion", cdk.validateBoolean)(properties.multiRegion)), errors.collect(cdk.propertyValidator("pendingWindowInDays", cdk.validateNumber)(properties.pendingWindowInDays)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnKeyProps"');
    }
    function cfnKeyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnKeyPropsValidator(properties).assertSuccess(), { KeyPolicy: cdk.objectToCloudFormation(properties.keyPolicy), Description: cdk.stringToCloudFormation(properties.description), Enabled: cdk.booleanToCloudFormation(properties.enabled), EnableKeyRotation: cdk.booleanToCloudFormation(properties.enableKeyRotation), KeySpec: cdk.stringToCloudFormation(properties.keySpec), KeyUsage: cdk.stringToCloudFormation(properties.keyUsage), MultiRegion: cdk.booleanToCloudFormation(properties.multiRegion), PendingWindowInDays: cdk.numberToCloudFormation(properties.pendingWindowInDays), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnKeyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("keyPolicy", "KeyPolicy", cfn_parse.FromCloudFormation.getAny(properties.KeyPolicy)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("enableKeyRotation", "EnableKeyRotation", properties.EnableKeyRotation != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableKeyRotation) : void 0), ret.addPropertyResult("keySpec", "KeySpec", properties.KeySpec != null ? cfn_parse.FromCloudFormation.getString(properties.KeySpec) : void 0), ret.addPropertyResult("keyUsage", "KeyUsage", properties.KeyUsage != null ? cfn_parse.FromCloudFormation.getString(properties.KeyUsage) : void 0), ret.addPropertyResult("multiRegion", "MultiRegion", properties.MultiRegion != null ? cfn_parse.FromCloudFormation.getBoolean(properties.MultiRegion) : void 0), ret.addPropertyResult("pendingWindowInDays", "PendingWindowInDays", properties.PendingWindowInDays != null ? cfn_parse.FromCloudFormation.getNumber(properties.PendingWindowInDays) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnKey = class _CfnKey extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnKeyPropsFromCloudFormation(resourceProperties), ret = new _CfnKey(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnKey.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kms_CfnKeyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnKey), error;
        }
        cdk.requireProperty(props, "keyPolicy", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrKeyId = cdk.Token.asString(this.getAtt("KeyId", cdk.ResolutionTypeHint.STRING)), this.keyPolicy = props.keyPolicy, this.description = props.description, this.enabled = props.enabled, this.enableKeyRotation = props.enableKeyRotation, this.keySpec = props.keySpec, this.keyUsage = props.keyUsage, this.multiRegion = props.multiRegion, this.pendingWindowInDays = props.pendingWindowInDays, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::KMS::Key", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnKey.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { keyPolicy: this.keyPolicy, description: this.description, enabled: this.enabled, enableKeyRotation: this.enableKeyRotation, keySpec: this.keySpec, keyUsage: this.keyUsage, multiRegion: this.multiRegion, pendingWindowInDays: this.pendingWindowInDays, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnKeyPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnKey[_b] = { fqn: "aws-cdk-lib.aws_kms.CfnKey", version: "2.80.0" }, CfnKey.CFN_RESOURCE_TYPE_NAME = "AWS::KMS::Key", exports2.CfnKey = CfnKey;
    function CfnReplicaKeyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("keyPolicy", cdk.requiredValidator)(properties.keyPolicy)), errors.collect(cdk.propertyValidator("keyPolicy", cdk.validateObject)(properties.keyPolicy)), errors.collect(cdk.propertyValidator("pendingWindowInDays", cdk.validateNumber)(properties.pendingWindowInDays)), errors.collect(cdk.propertyValidator("primaryKeyArn", cdk.requiredValidator)(properties.primaryKeyArn)), errors.collect(cdk.propertyValidator("primaryKeyArn", cdk.validateString)(properties.primaryKeyArn)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnReplicaKeyProps"');
    }
    function cfnReplicaKeyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReplicaKeyPropsValidator(properties).assertSuccess(), { KeyPolicy: cdk.objectToCloudFormation(properties.keyPolicy), PrimaryKeyArn: cdk.stringToCloudFormation(properties.primaryKeyArn), Description: cdk.stringToCloudFormation(properties.description), Enabled: cdk.booleanToCloudFormation(properties.enabled), PendingWindowInDays: cdk.numberToCloudFormation(properties.pendingWindowInDays), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnReplicaKeyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("keyPolicy", "KeyPolicy", cfn_parse.FromCloudFormation.getAny(properties.KeyPolicy)), ret.addPropertyResult("primaryKeyArn", "PrimaryKeyArn", cfn_parse.FromCloudFormation.getString(properties.PrimaryKeyArn)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("pendingWindowInDays", "PendingWindowInDays", properties.PendingWindowInDays != null ? cfn_parse.FromCloudFormation.getNumber(properties.PendingWindowInDays) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnReplicaKey = class _CfnReplicaKey extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnReplicaKeyPropsFromCloudFormation(resourceProperties), ret = new _CfnReplicaKey(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnReplicaKey.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kms_CfnReplicaKeyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnReplicaKey), error;
        }
        cdk.requireProperty(props, "keyPolicy", this), cdk.requireProperty(props, "primaryKeyArn", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrKeyId = cdk.Token.asString(this.getAtt("KeyId", cdk.ResolutionTypeHint.STRING)), this.keyPolicy = props.keyPolicy, this.primaryKeyArn = props.primaryKeyArn, this.description = props.description, this.enabled = props.enabled, this.pendingWindowInDays = props.pendingWindowInDays, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::KMS::ReplicaKey", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnReplicaKey.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { keyPolicy: this.keyPolicy, primaryKeyArn: this.primaryKeyArn, description: this.description, enabled: this.enabled, pendingWindowInDays: this.pendingWindowInDays, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnReplicaKeyPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnReplicaKey[_c] = { fqn: "aws-cdk-lib.aws_kms.CfnReplicaKey", version: "2.80.0" }, CfnReplicaKey.CFN_RESOURCE_TYPE_NAME = "AWS::KMS::ReplicaKey", exports2.CfnReplicaKey = CfnReplicaKey;
  }
});

// node_modules/aws-cdk-lib/aws-kms/lib/alias.js
var require_alias = __commonJS({
  "node_modules/aws-cdk-lib/aws-kms/lib/alias.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Alias = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var kms_generated_1 = require_kms_generated();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var REQUIRED_ALIAS_PREFIX = "alias/";
    var DISALLOWED_PREFIX = REQUIRED_ALIAS_PREFIX + "aws/";
    var AliasBase = class extends core_1.Resource {
      get keyArn() {
        return core_1.Stack.of(this).formatArn({ service: "kms", resource: this.aliasName });
      }
      get keyId() {
        return this.aliasName;
      }
      addAlias(alias) {
        return this.aliasTargetKey.addAlias(alias);
      }
      addToResourcePolicy(statement, allowNoOp) {
        return this.aliasTargetKey.addToResourcePolicy(statement, allowNoOp);
      }
      grant(grantee, ...actions) {
        return this.aliasTargetKey.grant(grantee, ...actions);
      }
      grantDecrypt(grantee) {
        return this.aliasTargetKey.grantDecrypt(grantee);
      }
      grantEncrypt(grantee) {
        return this.aliasTargetKey.grantEncrypt(grantee);
      }
      grantEncryptDecrypt(grantee) {
        return this.aliasTargetKey.grantEncryptDecrypt(grantee);
      }
      grantGenerateMac(grantee) {
        return this.aliasTargetKey.grantGenerateMac(grantee);
      }
      grantVerifyMac(grantee) {
        return this.aliasTargetKey.grantVerifyMac(grantee);
      }
    };
    var Alias = class _Alias extends AliasBase {
      static fromAliasAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kms_AliasAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromAliasAttributes), error;
        }
        class _Alias2 extends AliasBase {
          get aliasName() {
            return attrs.aliasName;
          }
          get aliasTargetKey() {
            return attrs.aliasTargetKey;
          }
        }
        return new _Alias2(scope, id);
      }
      static fromAliasName(scope, id, aliasName) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.keyArn = core_1.Stack.of(this).formatArn({ service: "kms", resource: aliasName }), this.keyId = aliasName, this.aliasName = aliasName;
          }
          get aliasTargetKey() {
            throw new Error("Cannot access aliasTargetKey on an Alias imported by Alias.fromAliasName().");
          }
          addAlias(_alias) {
            throw new Error("Cannot call addAlias on an Alias imported by Alias.fromAliasName().");
          }
          addToResourcePolicy(_statement, _allowNoOp) {
            return { statementAdded: false };
          }
          grant(grantee, ..._actions) {
            return iam.Grant.drop(grantee, "");
          }
          grantDecrypt(grantee) {
            return iam.Grant.drop(grantee, "");
          }
          grantEncrypt(grantee) {
            return iam.Grant.drop(grantee, "");
          }
          grantEncryptDecrypt(grantee) {
            return iam.Grant.drop(grantee, "");
          }
          grantGenerateMac(grantee) {
            return iam.Grant.drop(grantee, "");
          }
          grantVerifyMac(grantee) {
            return iam.Grant.drop(grantee, "");
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kms_AliasProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Alias), error;
        }
        let aliasName = props.aliasName;
        if (core_1.Token.isUnresolved(aliasName)) {
          if (core_1.Tokenization.reverseString(aliasName).firstValue && core_1.Tokenization.reverseString(aliasName).firstToken === void 0) {
            const valueInToken = core_1.Tokenization.reverseString(aliasName).firstValue;
            if (valueInToken.startsWith(REQUIRED_ALIAS_PREFIX) || (aliasName = REQUIRED_ALIAS_PREFIX + aliasName), valueInToken.toLocaleLowerCase().startsWith(DISALLOWED_PREFIX))
              throw new Error(`Alias cannot start with ${DISALLOWED_PREFIX}: ${aliasName}`);
            if (!valueInToken.match(/^[a-zA-Z0-9:/_-]{1,256}$/))
              throw new Error("Alias name must be between 1 and 256 characters in a-zA-Z0-9:/_-");
          }
        } else {
          if (aliasName.startsWith(REQUIRED_ALIAS_PREFIX) || (aliasName = REQUIRED_ALIAS_PREFIX + aliasName), aliasName === REQUIRED_ALIAS_PREFIX)
            throw new Error(`Alias must include a value after "${REQUIRED_ALIAS_PREFIX}": ${aliasName}`);
          if (aliasName.toLocaleLowerCase().startsWith(DISALLOWED_PREFIX))
            throw new Error(`Alias cannot start with ${DISALLOWED_PREFIX}: ${aliasName}`);
          if (!aliasName.match(/^[a-zA-Z0-9:/_-]{1,256}$/))
            throw new Error("Alias name must be between 1 and 256 characters in a-zA-Z0-9:/_-");
        }
        super(scope, id, { physicalName: aliasName }), this.aliasTargetKey = props.targetKey;
        const resource = new kms_generated_1.CfnAlias(this, "Resource", { aliasName: this.physicalName, targetKeyId: this.aliasTargetKey.keyArn });
        this.aliasName = this.getResourceNameAttribute(resource.aliasName), props.removalPolicy && resource.applyRemovalPolicy(props.removalPolicy);
      }
      generatePhysicalName() {
        return REQUIRED_ALIAS_PREFIX + super.generatePhysicalName();
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Alias[_a] = { fqn: "aws-cdk-lib.aws_kms.Alias", version: "2.80.0" }, exports2.Alias = Alias;
  }
});

// node_modules/aws-cdk-lib/aws-kms/lib/private/perms.js
var require_perms = __commonJS({
  "node_modules/aws-cdk-lib/aws-kms/lib/private/perms.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.VERIFY_HMAC_ACTIONS = exports2.GENERATE_HMAC_ACTIONS = exports2.DECRYPT_ACTIONS = exports2.ENCRYPT_ACTIONS = exports2.ADMIN_ACTIONS = void 0, exports2.ADMIN_ACTIONS = ["kms:Create*", "kms:Describe*", "kms:Enable*", "kms:List*", "kms:Put*", "kms:Update*", "kms:Revoke*", "kms:Disable*", "kms:Get*", "kms:Delete*", "kms:TagResource", "kms:UntagResource", "kms:ScheduleKeyDeletion", "kms:CancelKeyDeletion"], exports2.ENCRYPT_ACTIONS = ["kms:Encrypt", "kms:ReEncrypt*", "kms:GenerateDataKey*"], exports2.DECRYPT_ACTIONS = ["kms:Decrypt"], exports2.GENERATE_HMAC_ACTIONS = ["kms:GenerateMac"], exports2.VERIFY_HMAC_ACTIONS = ["kms:VerifyMac"];
  }
});

// node_modules/aws-cdk-lib/aws-kms/lib/key.js
var require_key2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-kms/lib/key.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Key = exports2.KeyUsage = exports2.KeySpec = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var alias_1 = require_alias();
    var kms_generated_1 = require_kms_generated();
    var perms = require_perms();
    var iam = require_aws_iam();
    var cxschema = require_cloud_assembly_schema2();
    var core_1 = require_core2();
    var cxapi = require_cx_api();
    var KeyBase = class extends core_1.Resource {
      constructor(scope, id, props = {}) {
        super(scope, id, props), this.aliases = [], this.node.addValidation({ validate: () => this.policy?.validateForResourcePolicy() ?? [] });
      }
      addAlias(aliasName) {
        const aliasId = this.aliases.length > 0 ? `Alias${aliasName}` : "Alias", alias = new alias_1.Alias(this, aliasId, { aliasName, targetKey: this });
        return this.aliases.push(alias), alias;
      }
      addToResourcePolicy(statement, allowNoOp = true) {
        const stack = core_1.Stack.of(this);
        if (!this.policy) {
          if (allowNoOp)
            return { statementAdded: false };
          throw new Error(`Unable to add statement to IAM resource policy for KMS key: ${JSON.stringify(stack.resolve(this.keyArn))}`);
        }
        return this.policy.addStatements(statement), { statementAdded: true, policyDependable: this.policy };
      }
      grant(grantee, ...actions) {
        const granteeStackDependsOnKeyStack = this.granteeStackDependsOnKeyStack(grantee), principal = granteeStackDependsOnKeyStack ? new iam.AccountPrincipal(granteeStackDependsOnKeyStack) : grantee.grantPrincipal, crossAccountAccess = this.isGranteeFromAnotherAccount(grantee), crossRegionAccess = this.isGranteeFromAnotherRegion(grantee), crossEnvironment = crossAccountAccess || crossRegionAccess, grantOptions = { grantee, actions, resource: this, resourceArns: [this.keyArn], resourceSelfArns: crossEnvironment ? void 0 : ["*"] };
        return this.trustAccountIdentities && !crossEnvironment ? iam.Grant.addToPrincipalOrResource(grantOptions) : iam.Grant.addToPrincipalAndResource({ ...grantOptions, resourceArns: crossEnvironment ? ["*"] : [this.keyArn], resourcePolicyPrincipal: principal });
      }
      grantDecrypt(grantee) {
        return this.grant(grantee, ...perms.DECRYPT_ACTIONS);
      }
      grantEncrypt(grantee) {
        return this.grant(grantee, ...perms.ENCRYPT_ACTIONS);
      }
      grantEncryptDecrypt(grantee) {
        return this.grant(grantee, ...perms.DECRYPT_ACTIONS, ...perms.ENCRYPT_ACTIONS);
      }
      grantGenerateMac(grantee) {
        return this.grant(grantee, ...perms.GENERATE_HMAC_ACTIONS);
      }
      grantVerifyMac(grantee) {
        return this.grant(grantee, ...perms.VERIFY_HMAC_ACTIONS);
      }
      granteeStackDependsOnKeyStack(grantee) {
        const grantPrincipal = grantee.grantPrincipal;
        if (!iam.principalIsOwnedResource(grantPrincipal))
          return;
        const keyStack = core_1.Stack.of(this), granteeStack = core_1.Stack.of(grantPrincipal);
        if (keyStack !== granteeStack)
          return granteeStack.dependencies.includes(keyStack) ? granteeStack.account : void 0;
      }
      isGranteeFromAnotherRegion(grantee) {
        if (!iam.principalIsOwnedResource(grantee.grantPrincipal))
          return false;
        const bucketStack = core_1.Stack.of(this), identityStack = core_1.Stack.of(grantee.grantPrincipal);
        return bucketStack.region !== identityStack.region;
      }
      isGranteeFromAnotherAccount(grantee) {
        if (!iam.principalIsOwnedResource(grantee.grantPrincipal))
          return false;
        const bucketStack = core_1.Stack.of(this), identityStack = core_1.Stack.of(grantee.grantPrincipal);
        return bucketStack.account !== identityStack.account;
      }
    };
    var KeySpec;
    (function(KeySpec2) {
      KeySpec2.SYMMETRIC_DEFAULT = "SYMMETRIC_DEFAULT", KeySpec2.RSA_2048 = "RSA_2048", KeySpec2.RSA_3072 = "RSA_3072", KeySpec2.RSA_4096 = "RSA_4096", KeySpec2.ECC_NIST_P256 = "ECC_NIST_P256", KeySpec2.ECC_NIST_P384 = "ECC_NIST_P384", KeySpec2.ECC_NIST_P521 = "ECC_NIST_P521", KeySpec2.ECC_SECG_P256K1 = "ECC_SECG_P256K1", KeySpec2.HMAC_224 = "HMAC_224", KeySpec2.HMAC_256 = "HMAC_256", KeySpec2.HMAC_384 = "HMAC_384", KeySpec2.HMAC_512 = "HMAC_512", KeySpec2.SM2 = "SM2";
    })(KeySpec = exports2.KeySpec || (exports2.KeySpec = {}));
    var KeyUsage;
    (function(KeyUsage2) {
      KeyUsage2.ENCRYPT_DECRYPT = "ENCRYPT_DECRYPT", KeyUsage2.SIGN_VERIFY = "SIGN_VERIFY", KeyUsage2.GENERATE_VERIFY_MAC = "GENERATE_VERIFY_MAC";
    })(KeyUsage = exports2.KeyUsage || (exports2.KeyUsage = {}));
    var Key = class _Key extends KeyBase {
      static fromKeyArn(scope, id, keyArn) {
        class Import extends KeyBase {
          constructor(keyId, props = {}) {
            super(scope, id, props), this.keyArn = keyArn, this.policy = void 0, this.trustAccountIdentities = true, this.keyId = keyId;
          }
        }
        const keyResourceName = core_1.Stack.of(scope).splitArn(keyArn, core_1.ArnFormat.SLASH_RESOURCE_NAME).resourceName;
        if (!keyResourceName)
          throw new Error(`KMS key ARN must be in the format 'arn:<partition>:kms:<region>:<account>:key/<keyId>', got: '${keyArn}'`);
        return new Import(keyResourceName, { environmentFromArn: keyArn });
      }
      static fromCfnKey(cfnKey) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kms_CfnKey(cfnKey);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromCfnKey), error;
        }
        const id = "@FromCfnKey", existing = cfnKey.node.tryFindChild(id);
        if (existing)
          return existing;
        let keyPolicy;
        try {
          keyPolicy = iam.PolicyDocument.fromJson(cfnKey.keyPolicy);
        } catch {
          throw new Error("Could not parse the PolicyDocument of the passed AWS::KMS::Key resource because it contains CloudFormation functions. This makes it impossible to create a mutable IKey from that Policy. You have to use fromKeyArn instead, passing it the ARN attribute property of the low-level CfnKey");
        }
        return cfnKey.keyPolicy = core_1.Lazy.any({ produce: () => keyPolicy.toJSON() }), new class extends KeyBase {
          constructor() {
            super(...arguments), this.keyArn = cfnKey.attrArn, this.keyId = cfnKey.ref, this.policy = keyPolicy, this.trustAccountIdentities = false;
          }
        }(cfnKey, id);
      }
      static fromLookup(scope, id, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kms_KeyLookupOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromLookup), error;
        }
        class Import extends KeyBase {
          constructor(keyId, keyArn) {
            super(scope, id), this.policy = void 0, this.trustAccountIdentities = true, this.keyId = keyId, this.keyArn = keyArn;
          }
        }
        if (core_1.Token.isUnresolved(options.aliasName))
          throw new Error("All arguments to Key.fromLookup() must be concrete (no Tokens)");
        const attributes = core_1.ContextProvider.getValue(scope, { provider: cxschema.ContextProvider.KEY_PROVIDER, props: { aliasName: options.aliasName }, dummyValue: { keyId: "1234abcd-12ab-34cd-56ef-1234567890ab" } }).value;
        return new Import(attributes.keyId, core_1.Arn.format({ resource: "key", service: "kms", resourceName: attributes.keyId }, core_1.Stack.of(scope)));
      }
      constructor(scope, id, props = {}) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kms_KeyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Key), error;
        }
        const denyLists = { [KeyUsage.ENCRYPT_DECRYPT]: [KeySpec.ECC_NIST_P256, KeySpec.ECC_NIST_P384, KeySpec.ECC_NIST_P521, KeySpec.ECC_SECG_P256K1, KeySpec.HMAC_224, KeySpec.HMAC_256, KeySpec.HMAC_384, KeySpec.HMAC_512], [KeyUsage.SIGN_VERIFY]: [KeySpec.SYMMETRIC_DEFAULT, KeySpec.HMAC_224, KeySpec.HMAC_256, KeySpec.HMAC_384, KeySpec.HMAC_512], [KeyUsage.GENERATE_VERIFY_MAC]: [KeySpec.RSA_2048, KeySpec.RSA_3072, KeySpec.RSA_4096, KeySpec.ECC_NIST_P256, KeySpec.ECC_NIST_P384, KeySpec.ECC_NIST_P521, KeySpec.ECC_SECG_P256K1, KeySpec.SYMMETRIC_DEFAULT, KeySpec.SM2] }, keySpec = props.keySpec ?? KeySpec.SYMMETRIC_DEFAULT, keyUsage = props.keyUsage ?? KeyUsage.ENCRYPT_DECRYPT;
        if (denyLists[keyUsage].includes(keySpec))
          throw new Error(`key spec '${keySpec}' is not valid with usage '${keyUsage}'`);
        if (keySpec.startsWith("HMAC") && props.enableKeyRotation)
          throw new Error("key rotation cannot be enabled on HMAC keys");
        if (keySpec !== KeySpec.SYMMETRIC_DEFAULT && props.enableKeyRotation)
          throw new Error("key rotation cannot be enabled on asymmetric keys");
        const defaultKeyPoliciesFeatureEnabled = core_1.FeatureFlags.of(this).isEnabled(cxapi.KMS_DEFAULT_KEY_POLICIES);
        if (this.policy = props.policy ?? new iam.PolicyDocument(), defaultKeyPoliciesFeatureEnabled) {
          if (props.trustAccountIdentities === false)
            throw new Error("`trustAccountIdentities` cannot be false if the @aws-cdk/aws-kms:defaultKeyPolicies feature flag is set");
          this.trustAccountIdentities = true, props.policy || this.addDefaultAdminPolicy();
        } else
          this.trustAccountIdentities = props.trustAccountIdentities ?? false, this.trustAccountIdentities ? this.addDefaultAdminPolicy() : this.addLegacyAdminPolicy();
        let pendingWindowInDays;
        if (props.pendingWindow && (pendingWindowInDays = props.pendingWindow.toDays(), pendingWindowInDays < 7 || pendingWindowInDays > 30))
          throw new Error(`'pendingWindow' value must between 7 and 30 days. Received: ${pendingWindowInDays}`);
        const resource = new kms_generated_1.CfnKey(this, "Resource", { description: props.description, enableKeyRotation: props.enableKeyRotation, enabled: props.enabled, keySpec: props.keySpec, keyUsage: props.keyUsage, keyPolicy: this.policy, pendingWindowInDays });
        this.keyArn = resource.attrArn, this.keyId = resource.ref, resource.applyRemovalPolicy(props.removalPolicy), (props.admins ?? []).forEach((p) => this.grantAdmin(p)), props.alias !== void 0 && this.addAlias(props.alias);
      }
      grantAdmin(grantee) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(grantee);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantAdmin), error;
        }
        return this.grant(grantee, ...perms.ADMIN_ACTIONS);
      }
      addDefaultAdminPolicy() {
        this.addToResourcePolicy(new iam.PolicyStatement({ resources: ["*"], actions: ["kms:*"], principals: [new iam.AccountRootPrincipal()] }));
      }
      addLegacyAdminPolicy() {
        const actions = ["kms:Create*", "kms:Describe*", "kms:Enable*", "kms:List*", "kms:Put*", "kms:Update*", "kms:Revoke*", "kms:Disable*", "kms:Get*", "kms:Delete*", "kms:ScheduleKeyDeletion", "kms:CancelKeyDeletion", "kms:GenerateDataKey", "kms:TagResource", "kms:UntagResource"];
        this.addToResourcePolicy(new iam.PolicyStatement({ resources: ["*"], actions, principals: [new iam.AccountRootPrincipal()] }));
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Key[_a] = { fqn: "aws-cdk-lib.aws_kms.Key", version: "2.80.0" }, exports2.Key = Key;
  }
});

// node_modules/aws-cdk-lib/aws-kms/lib/key-lookup.js
var require_key_lookup = __commonJS({
  "node_modules/aws-cdk-lib/aws-kms/lib/key-lookup.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-kms/lib/via-service-principal.js
var require_via_service_principal = __commonJS({
  "node_modules/aws-cdk-lib/aws-kms/lib/via-service-principal.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ViaServicePrincipal = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var ViaServicePrincipal = class _ViaServicePrincipal extends iam.PrincipalBase {
      constructor(serviceName, basePrincipal) {
        super(), this.serviceName = serviceName;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IPrincipal(basePrincipal);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ViaServicePrincipal), error;
        }
        this.basePrincipal = basePrincipal || new iam.AnyPrincipal();
      }
      get policyFragment() {
        const base = this.basePrincipal.policyFragment, conditions = Object.assign({}, base.conditions);
        return conditions.StringEquals ? conditions.StringEquals = Object.assign({ "kms:ViaService": this.serviceName }, conditions.StringEquals) : conditions.StringEquals = { "kms:ViaService": this.serviceName }, { principalJson: base.principalJson, conditions };
      }
      dedupeString() {
        const base = iam.ComparablePrincipal.dedupeStringFor(this.basePrincipal);
        return base !== void 0 ? `ViaServicePrincipal:${this.serviceName}:${base}` : void 0;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ViaServicePrincipal[_a] = { fqn: "aws-cdk-lib.aws_kms.ViaServicePrincipal", version: "2.80.0" }, exports2.ViaServicePrincipal = ViaServicePrincipal;
  }
});

// node_modules/aws-cdk-lib/aws-kms/lib/index.js
var require_lib12 = __commonJS({
  "node_modules/aws-cdk-lib/aws-kms/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_key2(), exports2), __exportStar(require_key_lookup(), exports2), __exportStar(require_alias(), exports2), __exportStar(require_via_service_principal(), exports2), __exportStar(require_kms_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-kms/index.js
var require_aws_kms = __commonJS({
  "node_modules/aws-cdk-lib/aws-kms/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib12(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/volume.js
var require_volume = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/volume.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Volume = exports2.EbsDeviceVolumeType = exports2.BlockDeviceVolume = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var ec2_generated_1 = require_ec2_generated();
    var aws_iam_1 = require_aws_iam();
    var aws_kms_1 = require_aws_kms();
    var core_1 = require_core2();
    var helpers_internal_1 = require_helpers_internal();
    var BlockDeviceVolume = class _BlockDeviceVolume {
      static ebs(volumeSize, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_EbsDeviceOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.ebs), error;
        }
        return new this({ ...options, volumeSize });
      }
      static ebsFromSnapshot(snapshotId, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_EbsDeviceSnapshotOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.ebsFromSnapshot), error;
        }
        return new this({ ...options, snapshotId });
      }
      static ephemeral(volumeIndex) {
        if (volumeIndex < 0)
          throw new Error(`volumeIndex must be a number starting from 0, got "${volumeIndex}"`);
        return new this(void 0, `ephemeral${volumeIndex}`);
      }
      constructor(ebsDevice, virtualName) {
        this.ebsDevice = ebsDevice, this.virtualName = virtualName;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_EbsDeviceProps(ebsDevice);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _BlockDeviceVolume), error;
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, BlockDeviceVolume[_a] = { fqn: "aws-cdk-lib.aws_ec2.BlockDeviceVolume", version: "2.80.0" }, exports2.BlockDeviceVolume = BlockDeviceVolume;
    var EbsDeviceVolumeType;
    (function(EbsDeviceVolumeType2) {
      EbsDeviceVolumeType2.STANDARD = "standard", EbsDeviceVolumeType2.IO1 = "io1", EbsDeviceVolumeType2.IO2 = "io2", EbsDeviceVolumeType2.GP2 = "gp2", EbsDeviceVolumeType2.GP3 = "gp3", EbsDeviceVolumeType2.ST1 = "st1", EbsDeviceVolumeType2.SC1 = "sc1", EbsDeviceVolumeType2.GENERAL_PURPOSE_SSD = "gp2", EbsDeviceVolumeType2.GENERAL_PURPOSE_SSD_GP3 = "gp3", EbsDeviceVolumeType2.PROVISIONED_IOPS_SSD = "io1", EbsDeviceVolumeType2.PROVISIONED_IOPS_SSD_IO2 = "io2", EbsDeviceVolumeType2.THROUGHPUT_OPTIMIZED_HDD = "st1", EbsDeviceVolumeType2.COLD_HDD = "sc1", EbsDeviceVolumeType2.MAGNETIC = "standard";
    })(EbsDeviceVolumeType = exports2.EbsDeviceVolumeType || (exports2.EbsDeviceVolumeType = {}));
    var VolumeBase = class extends core_1.Resource {
      grantAttachVolume(grantee, instances) {
        const result = aws_iam_1.Grant.addToPrincipal({ grantee, actions: ["ec2:AttachVolume"], resourceArns: this.collectGrantResourceArns(instances) });
        return this.encryptionKey && this.encryptionKey.grant(grantee, "kms:CreateGrant").principalStatement.addConditions({ Bool: { "kms:GrantIsForAWSResource": true }, StringEquals: { "kms:ViaService": `ec2.${core_1.Stack.of(this).region}.amazonaws.com`, "kms:GrantConstraintType": "EncryptionContextSubset" } }), result;
      }
      grantAttachVolumeByResourceTag(grantee, constructs, tagKeySuffix) {
        const tagValue = this.calculateResourceTagValue([this, ...constructs]), tagKey = `VolumeGrantAttach-${tagKeySuffix ?? tagValue.slice(0, 10).toUpperCase()}`, grantCondition = {};
        grantCondition[`ec2:ResourceTag/${tagKey}`] = tagValue;
        const result = this.grantAttachVolume(grantee);
        return result.principalStatement.addCondition("ForAnyValue:StringEquals", grantCondition), core_1.Tags.of(this).add(tagKey, tagValue), constructs.forEach((construct) => core_1.Tags.of(construct).add(tagKey, tagValue)), result;
      }
      grantDetachVolume(grantee, instances) {
        return aws_iam_1.Grant.addToPrincipal({ grantee, actions: ["ec2:DetachVolume"], resourceArns: this.collectGrantResourceArns(instances) });
      }
      grantDetachVolumeByResourceTag(grantee, constructs, tagKeySuffix) {
        const tagValue = this.calculateResourceTagValue([this, ...constructs]), tagKey = `VolumeGrantDetach-${tagKeySuffix ?? tagValue.slice(0, 10).toUpperCase()}`, grantCondition = {};
        grantCondition[`ec2:ResourceTag/${tagKey}`] = tagValue;
        const result = this.grantDetachVolume(grantee);
        return result.principalStatement.addCondition("ForAnyValue:StringEquals", grantCondition), core_1.Tags.of(this).add(tagKey, tagValue), constructs.forEach((construct) => core_1.Tags.of(construct).add(tagKey, tagValue)), result;
      }
      collectGrantResourceArns(instances) {
        const stack = core_1.Stack.of(this), resourceArns = [`arn:${stack.partition}:ec2:${stack.region}:${stack.account}:volume/${this.volumeId}`], instanceArnPrefix = `arn:${stack.partition}:ec2:${stack.region}:${stack.account}:instance`;
        return instances ? instances.forEach((instance) => resourceArns.push(`${instanceArnPrefix}/${instance?.instanceId}`)) : resourceArns.push(`${instanceArnPrefix}/*`), resourceArns;
      }
      calculateResourceTagValue(constructs) {
        return (0, helpers_internal_1.md5hash)(constructs.map((c) => core_1.Names.uniqueId(c)).join(""));
      }
    };
    var Volume = class _Volume extends VolumeBase {
      static fromVolumeAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_VolumeAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromVolumeAttributes), error;
        }
        class Import extends VolumeBase {
          constructor() {
            super(...arguments), this.volumeId = attrs.volumeId, this.availabilityZone = attrs.availabilityZone, this.encryptionKey = attrs.encryptionKey;
          }
        }
        if (!core_1.Token.isUnresolved(attrs.volumeId) && !/^vol-[0-9a-fA-F]+$/.test(attrs.volumeId))
          throw new Error("`volumeId` does not match expected pattern. Expected `vol-<hexadecmial value>` (ex: `vol-05abe246af`) or a Token");
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.volumeName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_VolumeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Volume), error;
        }
        this.validateProps(props);
        const resource = new ec2_generated_1.CfnVolume(this, "Resource", { availabilityZone: props.availabilityZone, autoEnableIo: props.autoEnableIo, encrypted: props.encrypted, kmsKeyId: props.encryptionKey?.keyArn, iops: props.iops, multiAttachEnabled: props.enableMultiAttach ?? false, size: props.size?.toGibibytes({ rounding: core_1.SizeRoundingBehavior.FAIL }), snapshotId: props.snapshotId, throughput: props.throughput, volumeType: props.volumeType ?? EbsDeviceVolumeType.GENERAL_PURPOSE_SSD });
        if (resource.applyRemovalPolicy(props.removalPolicy), props.volumeName && core_1.Tags.of(resource).add("Name", props.volumeName), this.volumeId = resource.ref, this.availabilityZone = props.availabilityZone, this.encryptionKey = props.encryptionKey, this.encryptionKey) {
          const principal = new aws_kms_1.ViaServicePrincipal(`ec2.${core_1.Stack.of(this).region}.amazonaws.com`, new aws_iam_1.AccountRootPrincipal()).withConditions({ StringEquals: { "kms:CallerAccount": core_1.Stack.of(this).account } }), grant = this.encryptionKey.grant(principal, "kms:DescribeKey", "kms:GenerateDataKeyWithoutPlainText");
          props.snapshotId && grant.principalStatement?.addActions("kms:ReEncrypt*");
        }
      }
      validateProps(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_VolumeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.validateProps), error;
        }
        if (!(props.size || props.snapshotId))
          throw new Error("Must provide at least one of `size` or `snapshotId`");
        if (props.snapshotId && !core_1.Token.isUnresolved(props.snapshotId) && !/^snap-[0-9a-fA-F]+$/.test(props.snapshotId))
          throw new Error("`snapshotId` does match expected pattern. Expected `snap-<hexadecmial value>` (ex: `snap-05abe246af`) or Token");
        if (props.encryptionKey && !props.encrypted)
          throw new Error("`encrypted` must be true when providing an `encryptionKey`.");
        if (props.volumeType && [EbsDeviceVolumeType.PROVISIONED_IOPS_SSD, EbsDeviceVolumeType.PROVISIONED_IOPS_SSD_IO2].includes(props.volumeType) && !props.iops)
          throw new Error("`iops` must be specified if the `volumeType` is `PROVISIONED_IOPS_SSD` or `PROVISIONED_IOPS_SSD_IO2`.");
        if (props.iops) {
          const volumeType = props.volumeType ?? EbsDeviceVolumeType.GENERAL_PURPOSE_SSD;
          if (![EbsDeviceVolumeType.PROVISIONED_IOPS_SSD, EbsDeviceVolumeType.PROVISIONED_IOPS_SSD_IO2, EbsDeviceVolumeType.GENERAL_PURPOSE_SSD_GP3].includes(volumeType))
            throw new Error("`iops` may only be specified if the `volumeType` is `PROVISIONED_IOPS_SSD`, `PROVISIONED_IOPS_SSD_IO2` or `GENERAL_PURPOSE_SSD_GP3`.");
          const iopsRanges = {};
          iopsRanges[EbsDeviceVolumeType.GENERAL_PURPOSE_SSD_GP3] = { Min: 3e3, Max: 16e3 }, iopsRanges[EbsDeviceVolumeType.PROVISIONED_IOPS_SSD] = { Min: 100, Max: 64e3 }, iopsRanges[EbsDeviceVolumeType.PROVISIONED_IOPS_SSD_IO2] = { Min: 100, Max: 64e3 };
          const { Min, Max } = iopsRanges[volumeType];
          if (props.iops < Min || props.iops > Max)
            throw new Error(`\`${volumeType}\` volumes iops must be between ${Min} and ${Max}.`);
          const maximumRatios = {};
          maximumRatios[EbsDeviceVolumeType.GENERAL_PURPOSE_SSD_GP3] = 500, maximumRatios[EbsDeviceVolumeType.PROVISIONED_IOPS_SSD] = 50, maximumRatios[EbsDeviceVolumeType.PROVISIONED_IOPS_SSD_IO2] = 500;
          const maximumRatio = maximumRatios[volumeType];
          if (props.size && props.iops > maximumRatio * props.size.toGibibytes({ rounding: core_1.SizeRoundingBehavior.FAIL }))
            throw new Error(`\`${volumeType}\` volumes iops has a maximum ratio of ${maximumRatio} IOPS/GiB.`);
          const maximumThroughputRatios = {};
          maximumThroughputRatios[EbsDeviceVolumeType.GP3] = 0.25;
          const maximumThroughputRatio = maximumThroughputRatios[volumeType];
          if (props.throughput && props.iops) {
            const iopsRatio = props.throughput / props.iops;
            if (iopsRatio > maximumThroughputRatio)
              throw new Error(`Throughput (MiBps) to iops ratio of ${iopsRatio} is too high; maximum is ${maximumThroughputRatio} MiBps per iops`);
          }
        }
        if (props.enableMultiAttach) {
          const volumeType = props.volumeType ?? EbsDeviceVolumeType.GENERAL_PURPOSE_SSD;
          if (![EbsDeviceVolumeType.PROVISIONED_IOPS_SSD, EbsDeviceVolumeType.PROVISIONED_IOPS_SSD_IO2].includes(volumeType))
            throw new Error("multi-attach is supported exclusively on `PROVISIONED_IOPS_SSD` and `PROVISIONED_IOPS_SSD_IO2` volumes.");
        }
        if (props.size) {
          const size = props.size.toGibibytes({ rounding: core_1.SizeRoundingBehavior.FAIL }), sizeRanges = {};
          sizeRanges[EbsDeviceVolumeType.GENERAL_PURPOSE_SSD] = { Min: 1, Max: 16384 }, sizeRanges[EbsDeviceVolumeType.GENERAL_PURPOSE_SSD_GP3] = { Min: 1, Max: 16384 }, sizeRanges[EbsDeviceVolumeType.PROVISIONED_IOPS_SSD] = { Min: 4, Max: 16384 }, sizeRanges[EbsDeviceVolumeType.PROVISIONED_IOPS_SSD_IO2] = { Min: 4, Max: 16384 }, sizeRanges[EbsDeviceVolumeType.THROUGHPUT_OPTIMIZED_HDD] = { Min: 125, Max: 16384 }, sizeRanges[EbsDeviceVolumeType.COLD_HDD] = { Min: 125, Max: 16384 }, sizeRanges[EbsDeviceVolumeType.MAGNETIC] = { Min: 1, Max: 1024 };
          const volumeType = props.volumeType ?? EbsDeviceVolumeType.GENERAL_PURPOSE_SSD, { Min, Max } = sizeRanges[volumeType];
          if (size < Min || size > Max)
            throw new Error(`\`${volumeType}\` volumes must be between ${Min} GiB and ${Max} GiB in size.`);
        }
        if (props.throughput) {
          const throughputRange = { Min: 125, Max: 1e3 }, { Min, Max } = throughputRange;
          if (props.volumeType != EbsDeviceVolumeType.GP3)
            throw new Error("throughput property requires volumeType: EbsDeviceVolumeType.GP3");
          if (props.throughput < Min || props.throughput > Max)
            throw new Error(`throughput property takes a minimum of ${Min} and a maximum of ${Max}`);
        }
      }
    };
    _b = JSII_RTTI_SYMBOL_1, Volume[_b] = { fqn: "aws-cdk-lib.aws_ec2.Volume", version: "2.80.0" }, exports2.Volume = Volume;
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/private/ebs-util.js
var require_ebs_util = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/private/ebs-util.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.launchTemplateBlockDeviceMappings = exports2.instanceBlockDeviceMappings = void 0;
    var core_1 = require_core2();
    var volume_1 = require_volume();
    function instanceBlockDeviceMappings(construct, blockDevices) {
      return synthesizeBlockDeviceMappings(construct, blockDevices, {});
    }
    exports2.instanceBlockDeviceMappings = instanceBlockDeviceMappings;
    function launchTemplateBlockDeviceMappings(construct, blockDevices) {
      return synthesizeBlockDeviceMappings(construct, blockDevices, "");
    }
    exports2.launchTemplateBlockDeviceMappings = launchTemplateBlockDeviceMappings;
    function synthesizeBlockDeviceMappings(construct, blockDevices, noDeviceValue) {
      return blockDevices.map(({ deviceName, volume, mappingEnabled }) => {
        const { virtualName, ebsDevice: ebs } = volume;
        let finalEbs;
        if (ebs) {
          const { iops, volumeType, kmsKey, ...rest } = ebs;
          if (iops)
            volumeType !== volume_1.EbsDeviceVolumeType.IO1 && volumeType !== volume_1.EbsDeviceVolumeType.IO2 && volumeType !== volume_1.EbsDeviceVolumeType.GP3 && core_1.Annotations.of(construct).addWarning("iops will be ignored without volumeType: IO1, IO2, or GP3");
          else if (volumeType === volume_1.EbsDeviceVolumeType.IO1 || volumeType === volume_1.EbsDeviceVolumeType.IO2)
            throw new Error("iops property is required with volumeType: EbsDeviceVolumeType.IO1 and EbsDeviceVolumeType.IO2");
          finalEbs = { ...rest, iops, volumeType, kmsKeyId: kmsKey?.keyArn };
        } else
          finalEbs = void 0;
        return { deviceName, ebs: finalEbs, virtualName, noDevice: mappingEnabled === false ? noDeviceValue : void 0 };
      });
    }
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/port.js
var require_port = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/port.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Port = exports2.Protocol = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core_1 = require_core2();
    var Protocol;
    (function(Protocol2) {
      Protocol2.ALL = "-1", Protocol2.HOPOPT = "0", Protocol2.ICMP = "icmp", Protocol2.IGMP = "2", Protocol2.GGP = "3", Protocol2.IPV4 = "4", Protocol2.ST = "5", Protocol2.TCP = "tcp", Protocol2.CBT = "7", Protocol2.EGP = "8", Protocol2.IGP = "9", Protocol2.BBN_RCC_MON = "10", Protocol2.NVP_II = "11", Protocol2.PUP = "12", Protocol2.EMCON = "14", Protocol2.XNET = "15", Protocol2.CHAOS = "16", Protocol2.UDP = "udp", Protocol2.MUX = "18", Protocol2.DCN_MEAS = "19", Protocol2.HMP = "20", Protocol2.PRM = "21", Protocol2.XNS_IDP = "22", Protocol2.TRUNK_1 = "23", Protocol2.TRUNK_2 = "24", Protocol2.LEAF_1 = "25", Protocol2.LEAF_2 = "26", Protocol2.RDP = "27", Protocol2.IRTP = "28", Protocol2.ISO_TP4 = "29", Protocol2.NETBLT = "30", Protocol2.MFE_NSP = "31", Protocol2.MERIT_INP = "32", Protocol2.DCCP = "33", Protocol2.THREEPC = "34", Protocol2.IDPR = "35", Protocol2.XTP = "36", Protocol2.DDP = "37", Protocol2.IDPR_CMTP = "38", Protocol2.TPPLUSPLUS = "39", Protocol2.IL = "40", Protocol2.IPV6 = "41", Protocol2.SDRP = "42", Protocol2.IPV6_ROUTE = "43", Protocol2.IPV6_FRAG = "44", Protocol2.IDRP = "45", Protocol2.RSVP = "46", Protocol2.GRE = "47", Protocol2.DSR = "48", Protocol2.BNA = "49", Protocol2.ESP = "50", Protocol2.AH = "51", Protocol2.I_NLSP = "52", Protocol2.SWIPE = "53", Protocol2.NARP = "54", Protocol2.MOBILE = "55", Protocol2.TLSP = "56", Protocol2.SKIP = "57", Protocol2.ICMPV6 = "icmpv6", Protocol2.IPV6_NONXT = "59", Protocol2.IPV6_OPTS = "60", Protocol2.CFTP = "62", Protocol2.ANY_LOCAL = "63", Protocol2.SAT_EXPAK = "64", Protocol2.KRYPTOLAN = "65", Protocol2.RVD = "66", Protocol2.IPPC = "67", Protocol2.ANY_DFS = "68", Protocol2.SAT_MON = "69", Protocol2.VISA = "70", Protocol2.IPCV = "71", Protocol2.CPNX = "72", Protocol2.CPHB = "73", Protocol2.WSN = "74", Protocol2.PVP = "75", Protocol2.BR_SAT_MON = "76", Protocol2.SUN_ND = "77", Protocol2.WB_MON = "78", Protocol2.WB_EXPAK = "79", Protocol2.ISO_IP = "80", Protocol2.VMTP = "81", Protocol2.SECURE_VMTP = "82", Protocol2.VINES = "83", Protocol2.TTP = "84", Protocol2.IPTM = "84_", Protocol2.NSFNET_IGP = "85", Protocol2.DGP = "86", Protocol2.TCF = "87", Protocol2.EIGRP = "88", Protocol2.OSPFIGP = "89", Protocol2.SPRITE_RPC = "90", Protocol2.LARP = "91", Protocol2.MTP = "92", Protocol2.AX_25 = "93", Protocol2.IPIP = "94", Protocol2.MICP = "95", Protocol2.SCC_SP = "96", Protocol2.ETHERIP = "97", Protocol2.ENCAP = "98", Protocol2.ANY_ENC = "99", Protocol2.GMTP = "100", Protocol2.IFMP = "101", Protocol2.PNNI = "102", Protocol2.PIM = "103", Protocol2.ARIS = "104", Protocol2.SCPS = "105", Protocol2.QNX = "106", Protocol2.A_N = "107", Protocol2.IPCOMP = "108", Protocol2.SNP = "109", Protocol2.COMPAQ_PEER = "110", Protocol2.IPX_IN_IP = "111", Protocol2.VRRP = "112", Protocol2.PGM = "113", Protocol2.ANY_0_HOP = "114", Protocol2.L2_T_P = "115", Protocol2.DDX = "116", Protocol2.IATP = "117", Protocol2.STP = "118", Protocol2.SRP = "119", Protocol2.UTI = "120", Protocol2.SMP = "121", Protocol2.SM = "122", Protocol2.PTP = "123", Protocol2.ISIS_IPV4 = "124", Protocol2.FIRE = "125", Protocol2.CRTP = "126", Protocol2.CRUDP = "127", Protocol2.SSCOPMCE = "128", Protocol2.IPLT = "129", Protocol2.SPS = "130", Protocol2.PIPE = "131", Protocol2.SCTP = "132", Protocol2.FC = "133", Protocol2.RSVP_E2E_IGNORE = "134", Protocol2.MOBILITY_HEADER = "135", Protocol2.UDPLITE = "136", Protocol2.MPLS_IN_IP = "137", Protocol2.MANET = "138", Protocol2.HIP = "139", Protocol2.SHIM6 = "140", Protocol2.WESP = "141", Protocol2.ROHC = "142", Protocol2.ETHERNET = "143", Protocol2.EXPERIMENT_1 = "253", Protocol2.EXPERIMENT_2 = "254", Protocol2.RESERVED = "255";
    })(Protocol = exports2.Protocol || (exports2.Protocol = {}));
    var Port = class _Port {
      static tcp(port) {
        return new _Port({ protocol: Protocol.TCP, fromPort: port, toPort: port, stringRepresentation: renderPort(port) });
      }
      static tcpRange(startPort, endPort) {
        return new _Port({ protocol: Protocol.TCP, fromPort: startPort, toPort: endPort, stringRepresentation: `${renderPort(startPort)}-${renderPort(endPort)}` });
      }
      static allTcp() {
        return new _Port({ protocol: Protocol.TCP, fromPort: 0, toPort: 65535, stringRepresentation: "ALL PORTS" });
      }
      static udp(port) {
        return new _Port({ protocol: Protocol.UDP, fromPort: port, toPort: port, stringRepresentation: `UDP ${renderPort(port)}` });
      }
      static udpRange(startPort, endPort) {
        return new _Port({ protocol: Protocol.UDP, fromPort: startPort, toPort: endPort, stringRepresentation: `UDP ${renderPort(startPort)}-${renderPort(endPort)}` });
      }
      static allUdp() {
        return new _Port({ protocol: Protocol.UDP, fromPort: 0, toPort: 65535, stringRepresentation: "UDP ALL PORTS" });
      }
      static icmpTypeAndCode(type, code) {
        return new _Port({ protocol: Protocol.ICMP, fromPort: type, toPort: code, stringRepresentation: `ICMP Type ${type} Code ${code}` });
      }
      static icmpType(type) {
        return new _Port({ protocol: Protocol.ICMP, fromPort: type, toPort: -1, stringRepresentation: `ICMP Type ${type}` });
      }
      static icmpPing() {
        return _Port.icmpType(8);
      }
      static allIcmp() {
        return new _Port({ protocol: Protocol.ICMP, fromPort: -1, toPort: -1, stringRepresentation: "ALL ICMP" });
      }
      static allIcmpV6() {
        return new _Port({ protocol: Protocol.ICMPV6, fromPort: -1, toPort: -1, stringRepresentation: "ALL ICMPv6" });
      }
      static allTraffic() {
        return new _Port({ protocol: Protocol.ALL, stringRepresentation: "ALL TRAFFIC" });
      }
      static esp() {
        return new _Port({ protocol: Protocol.ESP, fromPort: 50, toPort: 50, stringRepresentation: "ESP 50" });
      }
      static ah() {
        return new _Port({ protocol: Protocol.AH, fromPort: 51, toPort: 51, stringRepresentation: "AH 51" });
      }
      constructor(props) {
        this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_PortProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Port), error;
        }
        this.canInlineRule = !core_1.Token.isUnresolved(props.fromPort) && !core_1.Token.isUnresolved(props.toPort);
      }
      toRuleJson() {
        return { ipProtocol: { [Protocol.IPTM]: "84" }[this.props.protocol] ?? this.props.protocol, fromPort: this.props.fromPort, toPort: this.props.toPort };
      }
      toString() {
        return this.props.stringRepresentation;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Port[_a] = { fqn: "aws-cdk-lib.aws_ec2.Port", version: "2.80.0" }, exports2.Port = Port;
    function renderPort(port) {
      return core_1.Token.isUnresolved(port) ? "{IndirectPort}" : port.toString();
    }
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/security-group.js
var require_security_group2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/security-group.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SecurityGroup = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var connections_1 = require_connections();
    var ec2_generated_1 = require_ec2_generated();
    var peer_1 = require_peer();
    var port_1 = require_port();
    var cxschema = require_cloud_assembly_schema2();
    var core_1 = require_core2();
    var SECURITY_GROUP_SYMBOL = Symbol.for("@aws-cdk/iam.SecurityGroup");
    var SECURITY_GROUP_DISABLE_INLINE_RULES_CONTEXT_KEY = "@aws-cdk/aws-ec2.securityGroupDisableInlineRules";
    var SecurityGroupBase = class _SecurityGroupBase extends core_1.Resource {
      static isSecurityGroup(x) {
        return SECURITY_GROUP_SYMBOL in x;
      }
      constructor(scope, id, props) {
        super(scope, id, props), this.canInlineRule = false, this.connections = new connections_1.Connections({ securityGroups: [this] }), this.peerAsTokenCount = 0, Object.defineProperty(this, SECURITY_GROUP_SYMBOL, { value: true });
      }
      get uniqueId() {
        return core_1.Names.nodeUniqueId(this.node);
      }
      addIngressRule(peer, connection, description, remoteRule) {
        description === void 0 && (description = `from ${peer.uniqueId}:${connection}`);
        const { scope, id } = this.determineRuleScope(peer, connection, "from", remoteRule);
        scope.node.tryFindChild(id) === void 0 && new ec2_generated_1.CfnSecurityGroupIngress(scope, id, { groupId: this.securityGroupId, ...peer.toIngressRuleConfig(), ...connection.toRuleJson(), description });
      }
      addEgressRule(peer, connection, description, remoteRule) {
        description === void 0 && (description = `to ${peer.uniqueId}:${connection}`);
        const { scope, id } = this.determineRuleScope(peer, connection, "to", remoteRule);
        scope.node.tryFindChild(id) === void 0 && new ec2_generated_1.CfnSecurityGroupEgress(scope, id, { groupId: this.securityGroupId, ...peer.toEgressRuleConfig(), ...connection.toRuleJson(), description });
      }
      toIngressRuleConfig() {
        return { sourceSecurityGroupId: this.securityGroupId };
      }
      toEgressRuleConfig() {
        return { destinationSecurityGroupId: this.securityGroupId };
      }
      determineRuleScope(peer, connection, fromTo, remoteRule) {
        if (remoteRule && _SecurityGroupBase.isSecurityGroup(peer) && differentStacks(this, peer)) {
          const reversedFromTo = fromTo === "from" ? "to" : "from";
          return { scope: peer, id: `${this.uniqueId}:${connection} ${reversedFromTo}` };
        } else
          return { scope: this, id: `${fromTo} ${this.renderPeer(peer)}:${connection}`.replace("/", "_") };
      }
      renderPeer(peer) {
        return core_1.Token.isUnresolved(peer.uniqueId) ? this.peerAsTokenCount++ ? `'{IndirectPeer${this.peerAsTokenCount}}'` : "{IndirectPeer}" : peer.uniqueId;
      }
    };
    function differentStacks(group1, group2) {
      return core_1.Stack.of(group1) !== core_1.Stack.of(group2);
    }
    var SecurityGroup = class _SecurityGroup extends SecurityGroupBase {
      static fromLookup(scope, id, securityGroupId) {
        return this.fromLookupAttributes(scope, id, { securityGroupId });
      }
      static fromLookupById(scope, id, securityGroupId) {
        return this.fromLookupAttributes(scope, id, { securityGroupId });
      }
      static fromLookupByName(scope, id, securityGroupName, vpc) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_IVpc(vpc);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromLookupByName), error;
        }
        return this.fromLookupAttributes(scope, id, { securityGroupName, vpc });
      }
      static fromSecurityGroupId(scope, id, securityGroupId, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_SecurityGroupImportOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromSecurityGroupId), error;
        }
        class MutableImport extends SecurityGroupBase {
          constructor() {
            super(...arguments), this.securityGroupId = securityGroupId, this.allowAllOutbound = options.allowAllOutbound ?? true, this.allowAllIpv6Outbound = options.allowAllIpv6Outbound ?? false;
          }
          addEgressRule(peer, connection, description, remoteRule) {
            options.allowAllOutbound === false && super.addEgressRule(peer, connection, description, remoteRule);
          }
        }
        class ImmutableImport extends SecurityGroupBase {
          constructor() {
            super(...arguments), this.securityGroupId = securityGroupId, this.allowAllOutbound = options.allowAllOutbound ?? true, this.allowAllIpv6Outbound = options.allowAllIpv6Outbound ?? false;
          }
          addEgressRule(_peer, _connection, _description, _remoteRule) {
          }
          addIngressRule(_peer, _connection, _description, _remoteRule) {
          }
        }
        return options.mutable !== false ? new MutableImport(scope, id) : new ImmutableImport(scope, id);
      }
      static fromLookupAttributes(scope, id, options) {
        if (core_1.Token.isUnresolved(options.securityGroupId) || core_1.Token.isUnresolved(options.securityGroupName) || core_1.Token.isUnresolved(options.vpc?.vpcId))
          throw new Error("All arguments to look up a security group must be concrete (no Tokens)");
        const attributes = core_1.ContextProvider.getValue(scope, { provider: cxschema.ContextProvider.SECURITY_GROUP_PROVIDER, props: { securityGroupId: options.securityGroupId, securityGroupName: options.securityGroupName, vpcId: options.vpc?.vpcId }, dummyValue: { securityGroupId: "sg-12345678", allowAllOutbound: true } }).value;
        return _SecurityGroup.fromSecurityGroupId(scope, id, attributes.securityGroupId, { allowAllOutbound: attributes.allowAllOutbound, mutable: true });
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.securityGroupName }), this.directIngressRules = [], this.directEgressRules = [];
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_SecurityGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SecurityGroup), error;
        }
        const groupDescription = props.description || this.node.path;
        this.allowAllOutbound = props.allowAllOutbound !== false, this.allowAllIpv6Outbound = props.allowAllIpv6Outbound ?? false, this.disableInlineRules = props.disableInlineRules !== void 0 ? !!props.disableInlineRules : !!this.node.tryGetContext(SECURITY_GROUP_DISABLE_INLINE_RULES_CONTEXT_KEY), this.securityGroup = new ec2_generated_1.CfnSecurityGroup(this, "Resource", { groupName: this.physicalName, groupDescription, securityGroupIngress: core_1.Lazy.any({ produce: () => this.directIngressRules }, { omitEmptyArray: true }), securityGroupEgress: core_1.Lazy.any({ produce: () => this.directEgressRules }, { omitEmptyArray: true }), vpcId: props.vpc.vpcId }), this.securityGroupId = this.securityGroup.attrGroupId, this.securityGroupVpcId = this.securityGroup.attrVpcId, this.securityGroupName = this.securityGroup.ref, this.addDefaultEgressRule(), this.addDefaultIpv6EgressRule();
      }
      addIngressRule(peer, connection, description, remoteRule) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_IPeer(peer), jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_Port(connection);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addIngressRule), error;
        }
        if (!peer.canInlineRule || !connection.canInlineRule || this.disableInlineRules) {
          super.addIngressRule(peer, connection, description, remoteRule);
          return;
        }
        description === void 0 && (description = `from ${peer.uniqueId}:${connection}`), this.addDirectIngressRule({ ...peer.toIngressRuleConfig(), ...connection.toRuleJson(), description });
      }
      addEgressRule(peer, connection, description, remoteRule) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_IPeer(peer), jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_Port(connection);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addEgressRule), error;
        }
        const isIpv6 = peer.toEgressRuleConfig().hasOwnProperty("cidrIpv6");
        if (!isIpv6 && this.allowAllOutbound) {
          remoteRule || core_1.Annotations.of(this).addWarning("Ignoring Egress rule since 'allowAllOutbound' is set to true; To add customized rules, set allowAllOutbound=false on the SecurityGroup");
          return;
        } else
          !isIpv6 && !this.allowAllOutbound && this.removeNoTrafficRule();
        if (isIpv6 && this.allowAllIpv6Outbound) {
          remoteRule || core_1.Annotations.of(this).addWarning("Ignoring Egress rule since 'allowAllIpv6Outbound' is set to true; To add customized rules, set allowAllIpv6Outbound=false on the SecurityGroup");
          return;
        }
        if (!peer.canInlineRule || !connection.canInlineRule || this.disableInlineRules) {
          super.addEgressRule(peer, connection, description, remoteRule);
          return;
        }
        description === void 0 && (description = `from ${peer.uniqueId}:${connection}`);
        const rule = { ...peer.toEgressRuleConfig(), ...connection.toRuleJson(), description };
        if (isAllTrafficRule(rule))
          throw new Error('Cannot add an "all traffic" egress rule in this way; set allowAllOutbound=true (for ipv6) or allowAllIpv6Outbound=true (for ipv6) on the SecurityGroup instead.');
        this.addDirectEgressRule(rule);
      }
      addDirectIngressRule(rule) {
        this.hasIngressRule(rule) || this.directIngressRules.push(rule);
      }
      hasIngressRule(rule) {
        return this.directIngressRules.findIndex((r) => ingressRulesEqual(r, rule)) > -1;
      }
      addDirectEgressRule(rule) {
        this.hasEgressRule(rule) || this.directEgressRules.push(rule);
      }
      hasEgressRule(rule) {
        return this.directEgressRules.findIndex((r) => egressRulesEqual(r, rule)) > -1;
      }
      addDefaultEgressRule() {
        if (this.disableInlineRules) {
          const peer = this.allowAllOutbound ? ALL_TRAFFIC_PEER : NO_TRAFFIC_PEER, port = this.allowAllOutbound ? ALL_TRAFFIC_PORT : NO_TRAFFIC_PORT, description = this.allowAllOutbound ? ALLOW_ALL_RULE.description : MATCH_NO_TRAFFIC.description;
          super.addEgressRule(peer, port, description, false);
        } else {
          const rule = this.allowAllOutbound ? ALLOW_ALL_RULE : MATCH_NO_TRAFFIC;
          this.directEgressRules.push(rule);
        }
      }
      addDefaultIpv6EgressRule() {
        const description = "Allow all outbound ipv6 traffic by default", peer = peer_1.Peer.anyIpv6();
        this.allowAllIpv6Outbound && (this.disableInlineRules ? super.addEgressRule(peer, port_1.Port.allTraffic(), description, false) : this.directEgressRules.push({ ipProtocol: "-1", cidrIpv6: peer.uniqueId, description }));
      }
      removeNoTrafficRule() {
        if (this.disableInlineRules) {
          const { scope, id } = this.determineRuleScope(NO_TRAFFIC_PEER, NO_TRAFFIC_PORT, "to", false);
          scope.node.tryRemoveChild(id);
        } else {
          const i = this.directEgressRules.findIndex((r) => egressRulesEqual(r, MATCH_NO_TRAFFIC));
          i > -1 && this.directEgressRules.splice(i, 1);
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SecurityGroup[_a] = { fqn: "aws-cdk-lib.aws_ec2.SecurityGroup", version: "2.80.0" }, exports2.SecurityGroup = SecurityGroup;
    var MATCH_NO_TRAFFIC = { cidrIp: "255.255.255.255/32", description: "Disallow all traffic", ipProtocol: "icmp", fromPort: 252, toPort: 86 };
    var NO_TRAFFIC_PEER = peer_1.Peer.ipv4(MATCH_NO_TRAFFIC.cidrIp);
    var NO_TRAFFIC_PORT = port_1.Port.icmpTypeAndCode(MATCH_NO_TRAFFIC.fromPort, MATCH_NO_TRAFFIC.toPort);
    var ALLOW_ALL_RULE = { cidrIp: "0.0.0.0/0", description: "Allow all outbound traffic by default", ipProtocol: "-1" };
    var ALL_TRAFFIC_PEER = peer_1.Peer.anyIpv4();
    var ALL_TRAFFIC_PORT = port_1.Port.allTraffic();
    function ingressRulesEqual(a, b) {
      return a.cidrIp === b.cidrIp && a.cidrIpv6 === b.cidrIpv6 && a.fromPort === b.fromPort && a.toPort === b.toPort && a.ipProtocol === b.ipProtocol && a.sourceSecurityGroupId === b.sourceSecurityGroupId && a.sourceSecurityGroupName === b.sourceSecurityGroupName && a.sourceSecurityGroupOwnerId === b.sourceSecurityGroupOwnerId;
    }
    function egressRulesEqual(a, b) {
      return a.cidrIp === b.cidrIp && a.cidrIpv6 === b.cidrIpv6 && a.fromPort === b.fromPort && a.toPort === b.toPort && a.ipProtocol === b.ipProtocol && a.destinationPrefixListId === b.destinationPrefixListId && a.destinationSecurityGroupId === b.destinationSecurityGroupId;
    }
    function isAllTrafficRule(rule) {
      return (rule.cidrIp === "0.0.0.0/0" || rule.cidrIpv6 === "::/0") && rule.ipProtocol === "-1";
    }
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/client-vpn-authorization-rule.js
var require_client_vpn_authorization_rule = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/client-vpn-authorization-rule.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ClientVpnAuthorizationRule = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var ec2_generated_1 = require_ec2_generated();
    var core_1 = require_core2();
    var ClientVpnAuthorizationRule = class _ClientVpnAuthorizationRule extends core_1.Resource {
      constructor(scope, id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_ClientVpnAuthorizationRuleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ClientVpnAuthorizationRule), error;
        }
        if (!props.clientVpnEndoint && !props.clientVpnEndpoint)
          throw new Error("ClientVpnAuthorizationRule: either clientVpnEndpoint or clientVpnEndoint (deprecated) must be specified");
        if (props.clientVpnEndoint && props.clientVpnEndpoint)
          throw new Error("ClientVpnAuthorizationRule: either clientVpnEndpoint or clientVpnEndoint (deprecated) must be specified, but not both");
        const clientVpnEndpoint = props.clientVpnEndoint || props.clientVpnEndpoint;
        super(scope, id), new ec2_generated_1.CfnClientVpnAuthorizationRule(this, "Resource", { clientVpnEndpointId: clientVpnEndpoint.endpointId, targetNetworkCidr: props.cidr, accessGroupId: props.groupId, authorizeAllGroups: !props.groupId, description: props.description });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ClientVpnAuthorizationRule[_a] = { fqn: "aws-cdk-lib.aws_ec2.ClientVpnAuthorizationRule", version: "2.80.0" }, exports2.ClientVpnAuthorizationRule = ClientVpnAuthorizationRule;
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/client-vpn-route.js
var require_client_vpn_route = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/client-vpn-route.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ClientVpnRoute = exports2.ClientVpnRouteTarget = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var ec2_generated_1 = require_ec2_generated();
    var core_1 = require_core2();
    var ClientVpnRouteTarget = class {
      static subnet(subnet) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_ISubnet(subnet);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.subnet), error;
        }
        return { subnetId: subnet.subnetId };
      }
      static local() {
        return { subnetId: "local" };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ClientVpnRouteTarget[_a] = { fqn: "aws-cdk-lib.aws_ec2.ClientVpnRouteTarget", version: "2.80.0" }, exports2.ClientVpnRouteTarget = ClientVpnRouteTarget;
    var ClientVpnRoute = class _ClientVpnRoute extends core_1.Resource {
      constructor(scope, id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_ClientVpnRouteProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ClientVpnRoute), error;
        }
        if (!props.clientVpnEndoint && !props.clientVpnEndpoint)
          throw new Error("ClientVpnRoute: either clientVpnEndpoint or clientVpnEndoint (deprecated) must be specified");
        if (props.clientVpnEndoint && props.clientVpnEndpoint)
          throw new Error("ClientVpnRoute: either clientVpnEndpoint or clientVpnEndoint (deprecated) must be specified, but not both");
        const clientVpnEndpoint = props.clientVpnEndoint || props.clientVpnEndpoint;
        super(scope, id), new ec2_generated_1.CfnClientVpnRoute(this, "Resource", { clientVpnEndpointId: clientVpnEndpoint.endpointId, description: props.description, destinationCidrBlock: props.cidr, targetVpcSubnetId: props.target.subnetId }).node.addDependency(clientVpnEndpoint.targetNetworksAssociated);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, ClientVpnRoute[_b] = { fqn: "aws-cdk-lib.aws_ec2.ClientVpnRoute", version: "2.80.0" }, exports2.ClientVpnRoute = ClientVpnRoute;
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/network-util.js
var require_network_util = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/network-util.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CidrBlock = exports2.NetworkBuilder = exports2.NetworkUtils = exports2.InvalidCidrRangeError = void 0;
    var InvalidCidrRangeError = class _InvalidCidrRangeError extends Error {
      constructor(cidr) {
        super(cidr + " is not a valid VPC CIDR range (must be between /16 and /28)"), Object.setPrototypeOf(this, _InvalidCidrRangeError.prototype);
      }
    };
    exports2.InvalidCidrRangeError = InvalidCidrRangeError;
    var NetworkUtils = class {
      static validIp(ipAddress) {
        const octets = ipAddress.split(".");
        return octets.length !== 4 ? false : octets.map((octet) => parseInt(octet, 10)).filter((octet) => octet >= 0 && octet <= 255).length === 4;
      }
      static ipToNum(ipAddress) {
        if (!this.validIp(ipAddress))
          throw new Error(`${ipAddress} is not valid`);
        return ipAddress.split(".").reduce((p, c, i) => p + parseInt(c, 10) * 256 ** (3 - i), 0);
      }
      static numToIp(ipNum) {
        let remaining = ipNum;
        const address = new Array();
        for (let i = 0; i < 4; i++)
          remaining !== 0 ? (address.push(Math.floor(remaining / 256 ** (3 - i))), remaining = remaining % 256 ** (3 - i)) : address.push(0);
        const ipAddress = address.join(".");
        if (!this.validIp(ipAddress))
          throw new Error(`${ipAddress} is not a valid IP Address`);
        return ipAddress;
      }
    };
    exports2.NetworkUtils = NetworkUtils;
    var NetworkBuilder = class {
      constructor(cidr) {
        this.subnetCidrs = [], this.networkCidr = new CidrBlock(cidr), this.subnetCidrs = [], this.nextAvailableIp = this.networkCidr.minAddress();
      }
      addSubnet(mask) {
        return this.addSubnets(mask, 1)[0];
      }
      addSubnets(mask, count = 1) {
        if (mask < 16 || mask > 28)
          throw new InvalidCidrRangeError(`x.x.x.x/${mask}`);
        const maxIp = this.nextAvailableIp + CidrBlock.calculateNetsize(mask) * count;
        if (this.networkCidr.maxAddress() < maxIp - 1)
          throw new Error(`${count} of /${mask} exceeds remaining space of ${this.networkCidr.cidr}`);
        const subnets = [];
        for (let i = 0; i < count; i++) {
          const subnet = new CidrBlock(this.nextAvailableIp, mask);
          this.nextAvailableIp = subnet.nextBlock().minAddress(), this.subnetCidrs.push(subnet), subnets.push(subnet);
        }
        return subnets.map((subnet) => subnet.cidr);
      }
      get cidrStrings() {
        return this.subnetCidrs.map((subnet) => subnet.cidr);
      }
      maskForRemainingSubnets(subnetCount) {
        const remaining = this.networkCidr.maxAddress() - this.nextAvailableIp + 1, ipsPerSubnet = Math.floor(remaining / subnetCount);
        return 32 - Math.floor(Math.log2(ipsPerSubnet));
      }
    };
    exports2.NetworkBuilder = NetworkBuilder;
    var CidrBlock = class _CidrBlock {
      static calculateNetmask(mask) {
        return NetworkUtils.numToIp(2 ** 32 - 2 ** (32 - mask));
      }
      static calculateNetsize(mask) {
        return 2 ** (32 - mask);
      }
      constructor(ipAddressOrCidr, mask) {
        typeof ipAddressOrCidr == "string" ? (this.mask = parseInt(ipAddressOrCidr.split("/")[1], 10), this.networkAddress = NetworkUtils.ipToNum(ipAddressOrCidr.split("/")[0]) + _CidrBlock.calculateNetsize(this.mask) - 1) : (typeof mask == "number" ? this.mask = mask : this.mask = 16, this.networkAddress = ipAddressOrCidr + _CidrBlock.calculateNetsize(this.mask) - 1, this.networkSize = 2 ** (32 - this.mask)), this.networkSize = 2 ** (32 - this.mask), this.cidr = `${this.minIp()}/${this.mask}`;
      }
      maxIp() {
        return NetworkUtils.numToIp(this.maxAddress());
      }
      minIp() {
        return NetworkUtils.numToIp(this.minAddress());
      }
      minAddress() {
        const div = this.networkAddress % this.networkSize;
        return this.networkAddress - div;
      }
      maxAddress() {
        return this.minAddress() + this.networkSize - 1;
      }
      nextBlock() {
        return new _CidrBlock(this.maxAddress() + 1, this.mask);
      }
      containsCidr(other) {
        return this.maxAddress() >= other.maxAddress() && this.minAddress() <= other.minAddress();
      }
    };
    exports2.CidrBlock = CidrBlock;
  }
});

// node_modules/aws-cdk-lib/aws-logs/lib/logs.generated.js
var require_logs_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-logs/lib/logs.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnSubscriptionFilter = exports2.CfnResourcePolicy = exports2.CfnQueryDefinition = exports2.CfnMetricFilter = exports2.CfnLogStream = exports2.CfnLogGroup = exports2.CfnDestination = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnDestinationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationName", cdk.requiredValidator)(properties.destinationName)), errors.collect(cdk.propertyValidator("destinationName", cdk.validateString)(properties.destinationName)), errors.collect(cdk.propertyValidator("destinationPolicy", cdk.validateString)(properties.destinationPolicy)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("targetArn", cdk.requiredValidator)(properties.targetArn)), errors.collect(cdk.propertyValidator("targetArn", cdk.validateString)(properties.targetArn)), errors.wrap('supplied properties not correct for "CfnDestinationProps"');
    }
    function cfnDestinationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDestinationPropsValidator(properties).assertSuccess(), { DestinationName: cdk.stringToCloudFormation(properties.destinationName), RoleArn: cdk.stringToCloudFormation(properties.roleArn), TargetArn: cdk.stringToCloudFormation(properties.targetArn), DestinationPolicy: cdk.stringToCloudFormation(properties.destinationPolicy) }) : properties;
    }
    function CfnDestinationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationName", "DestinationName", cfn_parse.FromCloudFormation.getString(properties.DestinationName)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("targetArn", "TargetArn", cfn_parse.FromCloudFormation.getString(properties.TargetArn)), ret.addPropertyResult("destinationPolicy", "DestinationPolicy", properties.DestinationPolicy != null ? cfn_parse.FromCloudFormation.getString(properties.DestinationPolicy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDestination = class _CfnDestination extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDestinationPropsFromCloudFormation(resourceProperties), ret = new _CfnDestination(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDestination.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_logs_CfnDestinationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDestination), error;
        }
        cdk.requireProperty(props, "destinationName", this), cdk.requireProperty(props, "roleArn", this), cdk.requireProperty(props, "targetArn", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.destinationName = props.destinationName, this.roleArn = props.roleArn, this.targetArn = props.targetArn, this.destinationPolicy = props.destinationPolicy;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDestination.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { destinationName: this.destinationName, roleArn: this.roleArn, targetArn: this.targetArn, destinationPolicy: this.destinationPolicy };
      }
      renderProperties(props) {
        return cfnDestinationPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnDestination[_a] = { fqn: "aws-cdk-lib.aws_logs.CfnDestination", version: "2.80.0" }, CfnDestination.CFN_RESOURCE_TYPE_NAME = "AWS::Logs::Destination", exports2.CfnDestination = CfnDestination;
    function CfnLogGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataProtectionPolicy", cdk.validateObject)(properties.dataProtectionPolicy)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("logGroupName", cdk.validateString)(properties.logGroupName)), errors.collect(cdk.propertyValidator("retentionInDays", cdk.validateNumber)(properties.retentionInDays)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnLogGroupProps"');
    }
    function cfnLogGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLogGroupPropsValidator(properties).assertSuccess(), { DataProtectionPolicy: cdk.objectToCloudFormation(properties.dataProtectionPolicy), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), LogGroupName: cdk.stringToCloudFormation(properties.logGroupName), RetentionInDays: cdk.numberToCloudFormation(properties.retentionInDays), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnLogGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataProtectionPolicy", "DataProtectionPolicy", properties.DataProtectionPolicy != null ? cfn_parse.FromCloudFormation.getAny(properties.DataProtectionPolicy) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("logGroupName", "LogGroupName", properties.LogGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.LogGroupName) : void 0), ret.addPropertyResult("retentionInDays", "RetentionInDays", properties.RetentionInDays != null ? cfn_parse.FromCloudFormation.getNumber(properties.RetentionInDays) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLogGroup = class _CfnLogGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLogGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnLogGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnLogGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_logs_CfnLogGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLogGroup), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.dataProtectionPolicy = props.dataProtectionPolicy, this.kmsKeyId = props.kmsKeyId, this.logGroupName = props.logGroupName, this.retentionInDays = props.retentionInDays, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Logs::LogGroup", props.tags, { tagPropertyName: "tags" }), this.node.scope && cdk.Resource.isResource(this.node.scope) && this.node.addValidation({ validate: () => this.cfnOptions.deletionPolicy === void 0 ? ["'AWS::Logs::LogGroup' is a stateful resource type, and you must specify a Removal Policy for it. Call 'resource.applyRemovalPolicy()'."] : [] });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLogGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { dataProtectionPolicy: this.dataProtectionPolicy, kmsKeyId: this.kmsKeyId, logGroupName: this.logGroupName, retentionInDays: this.retentionInDays, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnLogGroupPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnLogGroup[_b] = { fqn: "aws-cdk-lib.aws_logs.CfnLogGroup", version: "2.80.0" }, CfnLogGroup.CFN_RESOURCE_TYPE_NAME = "AWS::Logs::LogGroup", exports2.CfnLogGroup = CfnLogGroup;
    function CfnLogStreamPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logGroupName", cdk.requiredValidator)(properties.logGroupName)), errors.collect(cdk.propertyValidator("logGroupName", cdk.validateString)(properties.logGroupName)), errors.collect(cdk.propertyValidator("logStreamName", cdk.validateString)(properties.logStreamName)), errors.wrap('supplied properties not correct for "CfnLogStreamProps"');
    }
    function cfnLogStreamPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLogStreamPropsValidator(properties).assertSuccess(), { LogGroupName: cdk.stringToCloudFormation(properties.logGroupName), LogStreamName: cdk.stringToCloudFormation(properties.logStreamName) }) : properties;
    }
    function CfnLogStreamPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logGroupName", "LogGroupName", cfn_parse.FromCloudFormation.getString(properties.LogGroupName)), ret.addPropertyResult("logStreamName", "LogStreamName", properties.LogStreamName != null ? cfn_parse.FromCloudFormation.getString(properties.LogStreamName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLogStream = class _CfnLogStream extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLogStreamPropsFromCloudFormation(resourceProperties), ret = new _CfnLogStream(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLogStream.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_logs_CfnLogStreamProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLogStream), error;
        }
        cdk.requireProperty(props, "logGroupName", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.logGroupName = props.logGroupName, this.logStreamName = props.logStreamName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLogStream.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { logGroupName: this.logGroupName, logStreamName: this.logStreamName };
      }
      renderProperties(props) {
        return cfnLogStreamPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnLogStream[_c] = { fqn: "aws-cdk-lib.aws_logs.CfnLogStream", version: "2.80.0" }, CfnLogStream.CFN_RESOURCE_TYPE_NAME = "AWS::Logs::LogStream", exports2.CfnLogStream = CfnLogStream;
    function CfnMetricFilterPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("filterName", cdk.validateString)(properties.filterName)), errors.collect(cdk.propertyValidator("filterPattern", cdk.requiredValidator)(properties.filterPattern)), errors.collect(cdk.propertyValidator("filterPattern", cdk.validateString)(properties.filterPattern)), errors.collect(cdk.propertyValidator("logGroupName", cdk.requiredValidator)(properties.logGroupName)), errors.collect(cdk.propertyValidator("logGroupName", cdk.validateString)(properties.logGroupName)), errors.collect(cdk.propertyValidator("metricTransformations", cdk.requiredValidator)(properties.metricTransformations)), errors.collect(cdk.propertyValidator("metricTransformations", cdk.listValidator(CfnMetricFilter_MetricTransformationPropertyValidator))(properties.metricTransformations)), errors.wrap('supplied properties not correct for "CfnMetricFilterProps"');
    }
    function cfnMetricFilterPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMetricFilterPropsValidator(properties).assertSuccess(), { FilterPattern: cdk.stringToCloudFormation(properties.filterPattern), LogGroupName: cdk.stringToCloudFormation(properties.logGroupName), MetricTransformations: cdk.listMapper(cfnMetricFilterMetricTransformationPropertyToCloudFormation)(properties.metricTransformations), FilterName: cdk.stringToCloudFormation(properties.filterName) }) : properties;
    }
    function CfnMetricFilterPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("filterPattern", "FilterPattern", cfn_parse.FromCloudFormation.getString(properties.FilterPattern)), ret.addPropertyResult("logGroupName", "LogGroupName", cfn_parse.FromCloudFormation.getString(properties.LogGroupName)), ret.addPropertyResult("metricTransformations", "MetricTransformations", cfn_parse.FromCloudFormation.getArray(CfnMetricFilterMetricTransformationPropertyFromCloudFormation)(properties.MetricTransformations)), ret.addPropertyResult("filterName", "FilterName", properties.FilterName != null ? cfn_parse.FromCloudFormation.getString(properties.FilterName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnMetricFilter = class _CfnMetricFilter extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnMetricFilterPropsFromCloudFormation(resourceProperties), ret = new _CfnMetricFilter(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnMetricFilter.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_logs_CfnMetricFilterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnMetricFilter), error;
        }
        cdk.requireProperty(props, "filterPattern", this), cdk.requireProperty(props, "logGroupName", this), cdk.requireProperty(props, "metricTransformations", this), this.filterPattern = props.filterPattern, this.logGroupName = props.logGroupName, this.metricTransformations = props.metricTransformations, this.filterName = props.filterName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnMetricFilter.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { filterPattern: this.filterPattern, logGroupName: this.logGroupName, metricTransformations: this.metricTransformations, filterName: this.filterName };
      }
      renderProperties(props) {
        return cfnMetricFilterPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnMetricFilter[_d] = { fqn: "aws-cdk-lib.aws_logs.CfnMetricFilter", version: "2.80.0" }, CfnMetricFilter.CFN_RESOURCE_TYPE_NAME = "AWS::Logs::MetricFilter", exports2.CfnMetricFilter = CfnMetricFilter;
    function CfnMetricFilter_DimensionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "DimensionProperty"');
    }
    function cfnMetricFilterDimensionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMetricFilter_DimensionPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnMetricFilterDimensionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMetricFilter_MetricTransformationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultValue", cdk.validateNumber)(properties.defaultValue)), errors.collect(cdk.propertyValidator("dimensions", cdk.listValidator(CfnMetricFilter_DimensionPropertyValidator))(properties.dimensions)), errors.collect(cdk.propertyValidator("metricName", cdk.requiredValidator)(properties.metricName)), errors.collect(cdk.propertyValidator("metricName", cdk.validateString)(properties.metricName)), errors.collect(cdk.propertyValidator("metricNamespace", cdk.requiredValidator)(properties.metricNamespace)), errors.collect(cdk.propertyValidator("metricNamespace", cdk.validateString)(properties.metricNamespace)), errors.collect(cdk.propertyValidator("metricValue", cdk.requiredValidator)(properties.metricValue)), errors.collect(cdk.propertyValidator("metricValue", cdk.validateString)(properties.metricValue)), errors.collect(cdk.propertyValidator("unit", cdk.validateString)(properties.unit)), errors.wrap('supplied properties not correct for "MetricTransformationProperty"');
    }
    function cfnMetricFilterMetricTransformationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMetricFilter_MetricTransformationPropertyValidator(properties).assertSuccess(), { DefaultValue: cdk.numberToCloudFormation(properties.defaultValue), Dimensions: cdk.listMapper(cfnMetricFilterDimensionPropertyToCloudFormation)(properties.dimensions), MetricName: cdk.stringToCloudFormation(properties.metricName), MetricNamespace: cdk.stringToCloudFormation(properties.metricNamespace), MetricValue: cdk.stringToCloudFormation(properties.metricValue), Unit: cdk.stringToCloudFormation(properties.unit) }) : properties;
    }
    function CfnMetricFilterMetricTransformationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultValue", "DefaultValue", properties.DefaultValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.DefaultValue) : void 0), ret.addPropertyResult("dimensions", "Dimensions", properties.Dimensions != null ? cfn_parse.FromCloudFormation.getArray(CfnMetricFilterDimensionPropertyFromCloudFormation)(properties.Dimensions) : void 0), ret.addPropertyResult("metricName", "MetricName", cfn_parse.FromCloudFormation.getString(properties.MetricName)), ret.addPropertyResult("metricNamespace", "MetricNamespace", cfn_parse.FromCloudFormation.getString(properties.MetricNamespace)), ret.addPropertyResult("metricValue", "MetricValue", cfn_parse.FromCloudFormation.getString(properties.MetricValue)), ret.addPropertyResult("unit", "Unit", properties.Unit != null ? cfn_parse.FromCloudFormation.getString(properties.Unit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnQueryDefinitionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logGroupNames", cdk.listValidator(cdk.validateString))(properties.logGroupNames)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("queryString", cdk.requiredValidator)(properties.queryString)), errors.collect(cdk.propertyValidator("queryString", cdk.validateString)(properties.queryString)), errors.wrap('supplied properties not correct for "CfnQueryDefinitionProps"');
    }
    function cfnQueryDefinitionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnQueryDefinitionPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), QueryString: cdk.stringToCloudFormation(properties.queryString), LogGroupNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.logGroupNames) }) : properties;
    }
    function CfnQueryDefinitionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("queryString", "QueryString", cfn_parse.FromCloudFormation.getString(properties.QueryString)), ret.addPropertyResult("logGroupNames", "LogGroupNames", properties.LogGroupNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.LogGroupNames) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnQueryDefinition = class _CfnQueryDefinition extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnQueryDefinitionPropsFromCloudFormation(resourceProperties), ret = new _CfnQueryDefinition(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnQueryDefinition.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_logs_CfnQueryDefinitionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnQueryDefinition), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "queryString", this), this.attrQueryDefinitionId = cdk.Token.asString(this.getAtt("QueryDefinitionId", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.queryString = props.queryString, this.logGroupNames = props.logGroupNames;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnQueryDefinition.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, queryString: this.queryString, logGroupNames: this.logGroupNames };
      }
      renderProperties(props) {
        return cfnQueryDefinitionPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnQueryDefinition[_e] = { fqn: "aws-cdk-lib.aws_logs.CfnQueryDefinition", version: "2.80.0" }, CfnQueryDefinition.CFN_RESOURCE_TYPE_NAME = "AWS::Logs::QueryDefinition", exports2.CfnQueryDefinition = CfnQueryDefinition;
    function CfnResourcePolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("policyDocument", cdk.requiredValidator)(properties.policyDocument)), errors.collect(cdk.propertyValidator("policyDocument", cdk.validateString)(properties.policyDocument)), errors.collect(cdk.propertyValidator("policyName", cdk.requiredValidator)(properties.policyName)), errors.collect(cdk.propertyValidator("policyName", cdk.validateString)(properties.policyName)), errors.wrap('supplied properties not correct for "CfnResourcePolicyProps"');
    }
    function cfnResourcePolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourcePolicyPropsValidator(properties).assertSuccess(), { PolicyDocument: cdk.stringToCloudFormation(properties.policyDocument), PolicyName: cdk.stringToCloudFormation(properties.policyName) }) : properties;
    }
    function CfnResourcePolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("policyDocument", "PolicyDocument", cfn_parse.FromCloudFormation.getString(properties.PolicyDocument)), ret.addPropertyResult("policyName", "PolicyName", cfn_parse.FromCloudFormation.getString(properties.PolicyName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResourcePolicy = class _CfnResourcePolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResourcePolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnResourcePolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnResourcePolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_logs_CfnResourcePolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResourcePolicy), error;
        }
        cdk.requireProperty(props, "policyDocument", this), cdk.requireProperty(props, "policyName", this), this.policyDocument = props.policyDocument, this.policyName = props.policyName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResourcePolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { policyDocument: this.policyDocument, policyName: this.policyName };
      }
      renderProperties(props) {
        return cfnResourcePolicyPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnResourcePolicy[_f] = { fqn: "aws-cdk-lib.aws_logs.CfnResourcePolicy", version: "2.80.0" }, CfnResourcePolicy.CFN_RESOURCE_TYPE_NAME = "AWS::Logs::ResourcePolicy", exports2.CfnResourcePolicy = CfnResourcePolicy;
    function CfnSubscriptionFilterPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationArn", cdk.requiredValidator)(properties.destinationArn)), errors.collect(cdk.propertyValidator("destinationArn", cdk.validateString)(properties.destinationArn)), errors.collect(cdk.propertyValidator("distribution", cdk.validateString)(properties.distribution)), errors.collect(cdk.propertyValidator("filterName", cdk.validateString)(properties.filterName)), errors.collect(cdk.propertyValidator("filterPattern", cdk.requiredValidator)(properties.filterPattern)), errors.collect(cdk.propertyValidator("filterPattern", cdk.validateString)(properties.filterPattern)), errors.collect(cdk.propertyValidator("logGroupName", cdk.requiredValidator)(properties.logGroupName)), errors.collect(cdk.propertyValidator("logGroupName", cdk.validateString)(properties.logGroupName)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "CfnSubscriptionFilterProps"');
    }
    function cfnSubscriptionFilterPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSubscriptionFilterPropsValidator(properties).assertSuccess(), { DestinationArn: cdk.stringToCloudFormation(properties.destinationArn), FilterPattern: cdk.stringToCloudFormation(properties.filterPattern), LogGroupName: cdk.stringToCloudFormation(properties.logGroupName), Distribution: cdk.stringToCloudFormation(properties.distribution), FilterName: cdk.stringToCloudFormation(properties.filterName), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnSubscriptionFilterPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationArn", "DestinationArn", cfn_parse.FromCloudFormation.getString(properties.DestinationArn)), ret.addPropertyResult("filterPattern", "FilterPattern", cfn_parse.FromCloudFormation.getString(properties.FilterPattern)), ret.addPropertyResult("logGroupName", "LogGroupName", cfn_parse.FromCloudFormation.getString(properties.LogGroupName)), ret.addPropertyResult("distribution", "Distribution", properties.Distribution != null ? cfn_parse.FromCloudFormation.getString(properties.Distribution) : void 0), ret.addPropertyResult("filterName", "FilterName", properties.FilterName != null ? cfn_parse.FromCloudFormation.getString(properties.FilterName) : void 0), ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSubscriptionFilter = class _CfnSubscriptionFilter extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSubscriptionFilterPropsFromCloudFormation(resourceProperties), ret = new _CfnSubscriptionFilter(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSubscriptionFilter.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_logs_CfnSubscriptionFilterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSubscriptionFilter), error;
        }
        cdk.requireProperty(props, "destinationArn", this), cdk.requireProperty(props, "filterPattern", this), cdk.requireProperty(props, "logGroupName", this), this.destinationArn = props.destinationArn, this.filterPattern = props.filterPattern, this.logGroupName = props.logGroupName, this.distribution = props.distribution, this.filterName = props.filterName, this.roleArn = props.roleArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSubscriptionFilter.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { destinationArn: this.destinationArn, filterPattern: this.filterPattern, logGroupName: this.logGroupName, distribution: this.distribution, filterName: this.filterName, roleArn: this.roleArn };
      }
      renderProperties(props) {
        return cfnSubscriptionFilterPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnSubscriptionFilter[_g] = { fqn: "aws-cdk-lib.aws_logs.CfnSubscriptionFilter", version: "2.80.0" }, CfnSubscriptionFilter.CFN_RESOURCE_TYPE_NAME = "AWS::Logs::SubscriptionFilter", exports2.CfnSubscriptionFilter = CfnSubscriptionFilter;
  }
});

// node_modules/aws-cdk-lib/aws-logs/lib/cross-account-destination.js
var require_cross_account_destination = __commonJS({
  "node_modules/aws-cdk-lib/aws-logs/lib/cross-account-destination.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CrossAccountDestination = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var logs_generated_1 = require_logs_generated();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var cdk = require_core2();
    var CrossAccountDestination = class _CrossAccountDestination extends cdk.Resource {
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.destinationName || cdk.Lazy.string({ produce: () => this.generateUniqueName() }) }), this.policyDocument = new iam.PolicyDocument();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_logs_CrossAccountDestinationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CrossAccountDestination), error;
        }
        this.resource = new logs_generated_1.CfnDestination(this, "Resource", { destinationName: this.physicalName, destinationPolicy: this.lazyStringifiedPolicyDocument(), roleArn: props.role.roleArn, targetArn: props.targetArn }), this.destinationArn = this.getResourceArnAttribute(this.resource.attrArn, { service: "logs", resource: "destination", resourceName: this.physicalName, arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME }), this.destinationName = this.getResourceNameAttribute(this.resource.ref);
      }
      addToPolicy(statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToPolicy), error;
        }
        this.policyDocument.addStatements(statement);
      }
      bind(_scope, _sourceLogGroup) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_logs_ILogGroup(_sourceLogGroup);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { arn: this.destinationArn };
      }
      generateUniqueName() {
        return cdk.Stack.of(this).stackName + "-" + this.resource.logicalId;
      }
      lazyStringifiedPolicyDocument() {
        return cdk.Lazy.string({ produce: () => this.policyDocument.isEmpty ? "" : cdk.Stack.of(this).toJsonString(this.policyDocument) });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CrossAccountDestination[_a] = { fqn: "aws-cdk-lib.aws_logs.CrossAccountDestination", version: "2.80.0" }, exports2.CrossAccountDestination = CrossAccountDestination;
  }
});

// node_modules/aws-cdk-lib/aws-logs/lib/log-stream.js
var require_log_stream = __commonJS({
  "node_modules/aws-cdk-lib/aws-logs/lib/log-stream.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LogStream = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var logs_generated_1 = require_logs_generated();
    var core_1 = require_core2();
    var LogStream = class _LogStream extends core_1.Resource {
      static fromLogStreamName(scope, id, logStreamName) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.logStreamName = logStreamName;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.logStreamName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_logs_LogStreamProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _LogStream), error;
        }
        const resource = new logs_generated_1.CfnLogStream(this, "Resource", { logGroupName: props.logGroup.logGroupName, logStreamName: this.physicalName });
        resource.applyRemovalPolicy(props.removalPolicy), this.logStreamName = this.getResourceNameAttribute(resource.ref);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LogStream[_a] = { fqn: "aws-cdk-lib.aws_logs.LogStream", version: "2.80.0" }, exports2.LogStream = LogStream;
  }
});

// node_modules/aws-cdk-lib/aws-logs/lib/metric-filter.js
var require_metric_filter = __commonJS({
  "node_modules/aws-cdk-lib/aws-logs/lib/metric-filter.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.MetricFilter = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var logs_generated_1 = require_logs_generated();
    var aws_cloudwatch_1 = require_aws_cloudwatch();
    var core_1 = require_core2();
    var MetricFilter = class _MetricFilter extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_logs_MetricFilterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _MetricFilter), error;
        }
        if (this.metricName = props.metricName, this.metricNamespace = props.metricNamespace, Object.keys(props.dimensions ?? {}).length > 3)
          throw new Error("MetricFilter only supports a maximum of 3 Dimensions");
        new logs_generated_1.CfnMetricFilter(this, "Resource", { logGroupName: props.logGroup.logGroupName, filterPattern: props.filterPattern.logPatternString, metricTransformations: [{ metricNamespace: props.metricNamespace, metricName: props.metricName, metricValue: props.metricValue ?? "1", defaultValue: props.defaultValue, dimensions: props.dimensions ? Object.entries(props.dimensions).map(([key, value]) => ({ key, value })) : void 0, unit: props.unit }] });
      }
      metric(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metric), error;
        }
        return new aws_cloudwatch_1.Metric({ metricName: this.metricName, namespace: this.metricNamespace, statistic: "avg", ...props }).attachTo(this);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, MetricFilter[_a] = { fqn: "aws-cdk-lib.aws_logs.MetricFilter", version: "2.80.0" }, exports2.MetricFilter = MetricFilter;
  }
});

// node_modules/aws-cdk-lib/aws-logs/lib/pattern.js
var require_pattern = __commonJS({
  "node_modules/aws-cdk-lib/aws-logs/lib/pattern.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SpaceDelimitedTextPattern = exports2.FilterPattern = exports2.JsonPattern = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var JsonPattern = class {
      constructor(jsonPatternString) {
        this.jsonPatternString = jsonPatternString;
      }
      get logPatternString() {
        return "{ " + this.jsonPatternString + " }";
      }
    };
    _a = JSII_RTTI_SYMBOL_1, JsonPattern[_a] = { fqn: "aws-cdk-lib.aws_logs.JsonPattern", version: "2.80.0" }, exports2.JsonPattern = JsonPattern;
    var FilterPattern = class {
      static literal(logPatternString) {
        return new LiteralLogPattern(logPatternString);
      }
      static allEvents() {
        return new LiteralLogPattern("");
      }
      static allTerms(...terms) {
        return new TextLogPattern([terms]);
      }
      static anyTerm(...terms) {
        return new TextLogPattern(terms.map((t) => [t]));
      }
      static anyTermGroup(...termGroups) {
        return new TextLogPattern(termGroups);
      }
      static stringValue(jsonField, comparison, value) {
        return new JSONStringPattern(jsonField, comparison, value);
      }
      static numberValue(jsonField, comparison, value) {
        return new JSONNumberPattern(jsonField, comparison, value);
      }
      static isNull(jsonField) {
        return new JSONPostfixPattern(jsonField, "IS NULL");
      }
      static notExists(jsonField) {
        return new JSONPostfixPattern(jsonField, "NOT EXISTS");
      }
      static exists(jsonField) {
        return new JSONStringPattern(jsonField, "=", "*");
      }
      static booleanValue(jsonField, value) {
        return new JSONPostfixPattern(jsonField, value ? "IS TRUE" : "IS FALSE");
      }
      static all(...patterns) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_logs_JsonPattern(patterns);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.all), error;
        }
        if (patterns.length === 0)
          throw new Error("Must supply at least one pattern, or use allEvents() to match all events.");
        return patterns.length === 1 ? patterns[0] : new JSONAggregatePattern("&&", patterns);
      }
      static any(...patterns) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_logs_JsonPattern(patterns);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.any), error;
        }
        if (patterns.length === 0)
          throw new Error("Must supply at least one pattern");
        return patterns.length === 1 ? patterns[0] : new JSONAggregatePattern("||", patterns);
      }
      static spaceDelimited(...columns) {
        return SpaceDelimitedTextPattern.construct(columns);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, FilterPattern[_b] = { fqn: "aws-cdk-lib.aws_logs.FilterPattern", version: "2.80.0" }, exports2.FilterPattern = FilterPattern;
    var LiteralLogPattern = class {
      constructor(logPatternString) {
        this.logPatternString = logPatternString;
      }
    };
    var TextLogPattern = class {
      constructor(clauses) {
        const quotedClauses = clauses.map((terms) => terms.map(quoteTerm).join(" "));
        quotedClauses.length === 1 ? this.logPatternString = quotedClauses[0] : this.logPatternString = quotedClauses.map((alt) => "?" + alt).join(" ");
      }
    };
    var JSONStringPattern = class extends JsonPattern {
      constructor(jsonField, comparison, value) {
        comparison = validateStringOperator(comparison), super(`${jsonField} ${comparison} ${quoteTerm(value)}`);
      }
    };
    var JSONNumberPattern = class extends JsonPattern {
      constructor(jsonField, comparison, value) {
        comparison = validateNumericalOperator(comparison), super(`${jsonField} ${comparison} ${value}`);
      }
    };
    var JSONPostfixPattern = class extends JsonPattern {
      constructor(jsonField, postfix) {
        super(`${jsonField} ${postfix}`);
      }
    };
    var JSONAggregatePattern = class extends JsonPattern {
      constructor(operator, patterns) {
        if (operator !== "&&" && operator !== "||")
          throw new Error("Operator must be one of && or ||");
        const clauses = patterns.map((p) => "(" + p.jsonPatternString + ")");
        super(clauses.join(` ${operator} `));
      }
    };
    var COL_ELLIPSIS = "...";
    var SpaceDelimitedTextPattern = class _SpaceDelimitedTextPattern {
      static construct(columns) {
        for (const column of columns)
          if (!validColumnName(column))
            throw new Error(`Invalid column name: ${column}`);
        if (sum(columns.map((c) => c === COL_ELLIPSIS ? 1 : 0)) > 1)
          throw new Error("Can use at most one '...' column");
        return new _SpaceDelimitedTextPattern(columns, {});
      }
      constructor(columns, restrictions) {
        this.columns = columns, this.restrictions = restrictions;
      }
      whereString(columnName, comparison, value) {
        if (columnName === COL_ELLIPSIS)
          throw new Error("Can't use '...' in a restriction");
        if (this.columns.indexOf(columnName) === -1)
          throw new Error(`Column in restrictions that is not in columns: ${columnName}`);
        return comparison = validateStringOperator(comparison), new _SpaceDelimitedTextPattern(this.columns, this.addRestriction(columnName, { comparison, stringValue: value }));
      }
      whereNumber(columnName, comparison, value) {
        if (columnName === COL_ELLIPSIS)
          throw new Error("Can't use '...' in a restriction");
        if (this.columns.indexOf(columnName) === -1)
          throw new Error(`Column in restrictions that is not in columns: ${columnName}`);
        return comparison = validateNumericalOperator(comparison), new _SpaceDelimitedTextPattern(this.columns, this.addRestriction(columnName, { comparison, numberValue: value }));
      }
      get logPatternString() {
        return "[" + this.columns.map(this.columnExpression.bind(this)).join(", ") + "]";
      }
      columnExpression(column) {
        const restrictions = this.restrictions[column];
        return restrictions ? restrictions.map((r) => renderRestriction(column, r)).join(" && ") : column;
      }
      addRestriction(columnName, restriction) {
        const ret = {};
        for (const key of Object.keys(this.restrictions))
          ret[key] = this.restrictions[key].slice();
        return columnName in ret || (ret[columnName] = []), ret[columnName].push(restriction), ret;
      }
    };
    _c = JSII_RTTI_SYMBOL_1, SpaceDelimitedTextPattern[_c] = { fqn: "aws-cdk-lib.aws_logs.SpaceDelimitedTextPattern", version: "2.80.0" }, exports2.SpaceDelimitedTextPattern = SpaceDelimitedTextPattern;
    function quoteTerm(term) {
      return '"' + term.replace(/\\/g, "\\\\").replace(/"/g, '\\"') + '"';
    }
    function validColumnName(column) {
      return column === COL_ELLIPSIS || /^[a-zA-Z0-9_-]+$/.exec(column);
    }
    function validateStringOperator(operator) {
      if (operator === "==" && (operator = "="), operator !== "=" && operator !== "!=")
        throw new Error(`Invalid comparison operator ('${operator}'), must be either '=' or '!='`);
      return operator;
    }
    var VALID_OPERATORS = ["=", "!=", "<", "<=", ">", ">="];
    function validateNumericalOperator(operator) {
      if (operator === "==" && (operator = "="), VALID_OPERATORS.indexOf(operator) === -1)
        throw new Error(`Invalid comparison operator ('${operator}'), must be one of ${VALID_OPERATORS.join(", ")}`);
      return operator;
    }
    function renderRestriction(column, restriction) {
      if (restriction.numberValue !== void 0)
        return `${column} ${restriction.comparison} ${restriction.numberValue}`;
      if (restriction.stringValue)
        return `${column} ${restriction.comparison} ${quoteTerm(restriction.stringValue)}`;
      throw new Error("Invalid restriction");
    }
    function sum(xs) {
      return xs.reduce((a, c) => a + c, 0);
    }
  }
});

// node_modules/aws-cdk-lib/aws-logs/lib/policy.js
var require_policy2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-logs/lib/policy.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ResourcePolicy = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var logs_generated_1 = require_logs_generated();
    var aws_iam_1 = require_aws_iam();
    var core_1 = require_core2();
    var ResourcePolicy = class _ResourcePolicy extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props?.resourcePolicyName }), this.document = new aws_iam_1.PolicyDocument();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_logs_ResourcePolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ResourcePolicy), error;
        }
        const l1 = new logs_generated_1.CfnResourcePolicy(this, "ResourcePolicy", { policyName: core_1.Lazy.string({ produce: () => props?.resourcePolicyName ?? core_1.Names.uniqueId(this) }), policyDocument: core_1.Lazy.string({ produce: () => JSON.stringify(this.document) }) });
        this.node.defaultChild = l1, props?.policyStatements && this.document.addStatements(...props.policyStatements);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ResourcePolicy[_a] = { fqn: "aws-cdk-lib.aws_logs.ResourcePolicy", version: "2.80.0" }, exports2.ResourcePolicy = ResourcePolicy;
  }
});

// node_modules/aws-cdk-lib/aws-logs/lib/subscription-filter.js
var require_subscription_filter = __commonJS({
  "node_modules/aws-cdk-lib/aws-logs/lib/subscription-filter.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SubscriptionFilter = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var logs_generated_1 = require_logs_generated();
    var core_1 = require_core2();
    var SubscriptionFilter = class _SubscriptionFilter extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_logs_SubscriptionFilterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SubscriptionFilter), error;
        }
        const destProps = props.destination.bind(this, props.logGroup);
        new logs_generated_1.CfnSubscriptionFilter(this, "Resource", { logGroupName: props.logGroup.logGroupName, destinationArn: destProps.arn, roleArn: destProps.role && destProps.role.roleArn, filterPattern: props.filterPattern.logPatternString });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SubscriptionFilter[_a] = { fqn: "aws-cdk-lib.aws_logs.SubscriptionFilter", version: "2.80.0" }, exports2.SubscriptionFilter = SubscriptionFilter;
  }
});

// node_modules/aws-cdk-lib/aws-logs/lib/log-group.js
var require_log_group = __commonJS({
  "node_modules/aws-cdk-lib/aws-logs/lib/log-group.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LogGroup = exports2.RetentionDays = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var log_stream_1 = require_log_stream();
    var logs_generated_1 = require_logs_generated();
    var metric_filter_1 = require_metric_filter();
    var pattern_1 = require_pattern();
    var policy_1 = require_policy2();
    var subscription_filter_1 = require_subscription_filter();
    var cloudwatch = require_aws_cloudwatch();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var LogGroupBase = class extends core_1.Resource {
      addStream(id, props = {}) {
        return new log_stream_1.LogStream(this, id, { logGroup: this, ...props });
      }
      addSubscriptionFilter(id, props) {
        return new subscription_filter_1.SubscriptionFilter(this, id, { logGroup: this, ...props });
      }
      addMetricFilter(id, props) {
        return new metric_filter_1.MetricFilter(this, id, { logGroup: this, ...props });
      }
      extractMetric(jsonField, metricNamespace, metricName) {
        return new metric_filter_1.MetricFilter(this, `${metricNamespace}_${metricName}`, { logGroup: this, metricNamespace, metricName, filterPattern: pattern_1.FilterPattern.exists(jsonField), metricValue: jsonField }), new cloudwatch.Metric({ metricName, namespace: metricNamespace }).attachTo(this);
      }
      grantWrite(grantee) {
        return this.grant(grantee, "logs:CreateLogStream", "logs:PutLogEvents");
      }
      grantRead(grantee) {
        return this.grant(grantee, "logs:FilterLogEvents", "logs:GetLogEvents", "logs:GetLogGroupFields", "logs:DescribeLogGroups", "logs:DescribeLogStreams");
      }
      grant(grantee, ...actions) {
        return iam.Grant.addToPrincipalOrResource({ grantee, actions, resourceArns: [this.logGroupArn], resource: this });
      }
      logGroupPhysicalName() {
        return this.physicalName;
      }
      addToResourcePolicy(statement) {
        return this.policy || (this.policy = new policy_1.ResourcePolicy(this, "Policy")), this.policy.document.addStatements(statement.copy({ principals: statement.principals.map((p) => this.convertArnPrincpalToAccountId(p)) })), { statementAdded: true, policyDependable: this.policy };
      }
      convertArnPrincpalToAccountId(principal) {
        if (principal.principalAccount)
          return new iam.ArnPrincipal(principal.principalAccount);
        if (principal instanceof iam.ArnPrincipal) {
          const parsedArn = core_1.Arn.split(principal.arn, core_1.ArnFormat.SLASH_RESOURCE_NAME);
          if (parsedArn.account)
            return new iam.ArnPrincipal(parsedArn.account);
        }
        return principal;
      }
    };
    var RetentionDays;
    (function(RetentionDays2) {
      RetentionDays2[RetentionDays2.ONE_DAY = 1] = "ONE_DAY", RetentionDays2[RetentionDays2.THREE_DAYS = 3] = "THREE_DAYS", RetentionDays2[RetentionDays2.FIVE_DAYS = 5] = "FIVE_DAYS", RetentionDays2[RetentionDays2.ONE_WEEK = 7] = "ONE_WEEK", RetentionDays2[RetentionDays2.TWO_WEEKS = 14] = "TWO_WEEKS", RetentionDays2[RetentionDays2.ONE_MONTH = 30] = "ONE_MONTH", RetentionDays2[RetentionDays2.TWO_MONTHS = 60] = "TWO_MONTHS", RetentionDays2[RetentionDays2.THREE_MONTHS = 90] = "THREE_MONTHS", RetentionDays2[RetentionDays2.FOUR_MONTHS = 120] = "FOUR_MONTHS", RetentionDays2[RetentionDays2.FIVE_MONTHS = 150] = "FIVE_MONTHS", RetentionDays2[RetentionDays2.SIX_MONTHS = 180] = "SIX_MONTHS", RetentionDays2[RetentionDays2.ONE_YEAR = 365] = "ONE_YEAR", RetentionDays2[RetentionDays2.THIRTEEN_MONTHS = 400] = "THIRTEEN_MONTHS", RetentionDays2[RetentionDays2.EIGHTEEN_MONTHS = 545] = "EIGHTEEN_MONTHS", RetentionDays2[RetentionDays2.TWO_YEARS = 731] = "TWO_YEARS", RetentionDays2[RetentionDays2.THREE_YEARS = 1096] = "THREE_YEARS", RetentionDays2[RetentionDays2.FIVE_YEARS = 1827] = "FIVE_YEARS", RetentionDays2[RetentionDays2.SIX_YEARS = 2192] = "SIX_YEARS", RetentionDays2[RetentionDays2.SEVEN_YEARS = 2557] = "SEVEN_YEARS", RetentionDays2[RetentionDays2.EIGHT_YEARS = 2922] = "EIGHT_YEARS", RetentionDays2[RetentionDays2.NINE_YEARS = 3288] = "NINE_YEARS", RetentionDays2[RetentionDays2.TEN_YEARS = 3653] = "TEN_YEARS", RetentionDays2[RetentionDays2.INFINITE = 9999] = "INFINITE";
    })(RetentionDays = exports2.RetentionDays || (exports2.RetentionDays = {}));
    var LogGroup = class _LogGroup extends LogGroupBase {
      static fromLogGroupArn(scope, id, logGroupArn) {
        const baseLogGroupArn = logGroupArn.replace(/:\*$/, "");
        class Import extends LogGroupBase {
          constructor() {
            super(...arguments), this.logGroupArn = `${baseLogGroupArn}:*`, this.logGroupName = core_1.Stack.of(scope).splitArn(baseLogGroupArn, core_1.ArnFormat.COLON_RESOURCE_NAME).resourceName;
          }
        }
        return new Import(scope, id, { environmentFromArn: baseLogGroupArn });
      }
      static fromLogGroupName(scope, id, logGroupName) {
        const baseLogGroupName = logGroupName.replace(/:\*$/, "");
        class Import extends LogGroupBase {
          constructor() {
            super(...arguments), this.logGroupName = baseLogGroupName, this.logGroupArn = core_1.Stack.of(scope).formatArn({ service: "logs", resource: "log-group", arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME, resourceName: baseLogGroupName + ":*" });
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.logGroupName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_logs_LogGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _LogGroup), error;
        }
        let retentionInDays = props.retention;
        if (retentionInDays === void 0 && (retentionInDays = RetentionDays.TWO_YEARS), (retentionInDays === 1 / 0 || retentionInDays === RetentionDays.INFINITE) && (retentionInDays = void 0), retentionInDays !== void 0 && !core_1.Token.isUnresolved(retentionInDays) && retentionInDays <= 0)
          throw new Error(`retentionInDays must be positive, got ${retentionInDays}`);
        const resource = new logs_generated_1.CfnLogGroup(this, "Resource", { kmsKeyId: props.encryptionKey?.keyArn, logGroupName: this.physicalName, retentionInDays, dataProtectionPolicy: props.dataProtectionPolicy?._bind(this) });
        resource.applyRemovalPolicy(props.removalPolicy), this.logGroupArn = this.getResourceArnAttribute(resource.attrArn, { service: "logs", resource: "log-group", resourceName: this.physicalName, arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME }), this.logGroupName = this.getResourceNameAttribute(resource.ref);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LogGroup[_a] = { fqn: "aws-cdk-lib.aws_logs.LogGroup", version: "2.80.0" }, exports2.LogGroup = LogGroup;
  }
});

// node_modules/aws-cdk-lib/assets/lib/api.js
var require_api3 = __commonJS({
  "node_modules/aws-cdk-lib/assets/lib/api.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/assets/lib/fs/follow-mode.js
var require_follow_mode = __commonJS({
  "node_modules/aws-cdk-lib/assets/lib/fs/follow-mode.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FollowMode = void 0;
    var FollowMode;
    (function(FollowMode2) {
      FollowMode2.NEVER = "never", FollowMode2.ALWAYS = "always", FollowMode2.EXTERNAL = "external", FollowMode2.BLOCK_EXTERNAL = "internal-only";
    })(FollowMode = exports2.FollowMode || (exports2.FollowMode = {}));
  }
});

// node_modules/aws-cdk-lib/assets/lib/fs/options.js
var require_options2 = __commonJS({
  "node_modules/aws-cdk-lib/assets/lib/fs/options.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/assets/lib/compat.js
var require_compat = __commonJS({
  "node_modules/aws-cdk-lib/assets/lib/compat.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.toSymlinkFollow = void 0;
    var follow_mode_1 = require_follow_mode();
    var core_1 = require_core2();
    function toSymlinkFollow(follow) {
      if (follow)
        switch (follow) {
          case follow_mode_1.FollowMode.NEVER:
            return core_1.SymlinkFollowMode.NEVER;
          case follow_mode_1.FollowMode.ALWAYS:
            return core_1.SymlinkFollowMode.ALWAYS;
          case follow_mode_1.FollowMode.BLOCK_EXTERNAL:
            return core_1.SymlinkFollowMode.BLOCK_EXTERNAL;
          case follow_mode_1.FollowMode.EXTERNAL:
            return core_1.SymlinkFollowMode.EXTERNAL;
          default:
            throw new Error(`unknown follow mode: ${follow}`);
        }
    }
    exports2.toSymlinkFollow = toSymlinkFollow;
  }
});

// node_modules/aws-cdk-lib/assets/lib/staging.js
var require_staging = __commonJS({
  "node_modules/aws-cdk-lib/assets/lib/staging.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Staging = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var compat_1 = require_compat();
    var core_1 = require_core2();
    var Staging = class extends core_1.AssetStaging {
      constructor(scope, id, props) {
        super(scope, id, { sourcePath: props.sourcePath, exclude: props.exclude, ignoreMode: props.ignoreMode, extraHash: props.extraHash, follow: (0, compat_1.toSymlinkFollow)(props.follow) });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Staging[_a] = { fqn: "aws-cdk-lib.assets.Staging", version: "2.80.0" }, exports2.Staging = Staging;
  }
});

// node_modules/aws-cdk-lib/assets/lib/index.js
var require_lib13 = __commonJS({
  "node_modules/aws-cdk-lib/assets/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_api3(), exports2), __exportStar(require_follow_mode(), exports2), __exportStar(require_options2(), exports2), __exportStar(require_staging(), exports2);
  }
});

// node_modules/aws-cdk-lib/assets/index.js
var require_assets4 = __commonJS({
  "node_modules/aws-cdk-lib/assets/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib13(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-s3-assets/lib/compat.js
var require_compat2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3-assets/lib/compat.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.toSymlinkFollow = void 0;
    var assets_1 = require_assets4();
    var core_1 = require_core2();
    function toSymlinkFollow(follow) {
      if (follow)
        switch (follow) {
          case assets_1.FollowMode.NEVER:
            return core_1.SymlinkFollowMode.NEVER;
          case assets_1.FollowMode.ALWAYS:
            return core_1.SymlinkFollowMode.ALWAYS;
          case assets_1.FollowMode.BLOCK_EXTERNAL:
            return core_1.SymlinkFollowMode.BLOCK_EXTERNAL;
          case assets_1.FollowMode.EXTERNAL:
            return core_1.SymlinkFollowMode.EXTERNAL;
          default:
            throw new Error(`unknown follow mode: ${follow}`);
        }
    }
    exports2.toSymlinkFollow = toSymlinkFollow;
  }
});

// node_modules/aws-cdk-lib/aws-s3/lib/s3.generated.js
var require_s3_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3/lib/s3.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnStorageLens = exports2.CfnMultiRegionAccessPointPolicy = exports2.CfnMultiRegionAccessPoint = exports2.CfnBucketPolicy = exports2.CfnBucket = exports2.CfnAccessPoint = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAccessPointPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.requiredValidator)(properties.bucket)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("bucketAccountId", cdk.validateString)(properties.bucketAccountId)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("policy", cdk.validateObject)(properties.policy)), errors.collect(cdk.propertyValidator("policyStatus", cdk.validateObject)(properties.policyStatus)), errors.collect(cdk.propertyValidator("publicAccessBlockConfiguration", CfnAccessPoint_PublicAccessBlockConfigurationPropertyValidator)(properties.publicAccessBlockConfiguration)), errors.collect(cdk.propertyValidator("vpcConfiguration", CfnAccessPoint_VpcConfigurationPropertyValidator)(properties.vpcConfiguration)), errors.wrap('supplied properties not correct for "CfnAccessPointProps"');
    }
    function cfnAccessPointPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccessPointPropsValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), BucketAccountId: cdk.stringToCloudFormation(properties.bucketAccountId), Name: cdk.stringToCloudFormation(properties.name), Policy: cdk.objectToCloudFormation(properties.policy), PolicyStatus: cdk.objectToCloudFormation(properties.policyStatus), PublicAccessBlockConfiguration: cfnAccessPointPublicAccessBlockConfigurationPropertyToCloudFormation(properties.publicAccessBlockConfiguration), VpcConfiguration: cfnAccessPointVpcConfigurationPropertyToCloudFormation(properties.vpcConfiguration) }) : properties;
    }
    function CfnAccessPointPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", cfn_parse.FromCloudFormation.getString(properties.Bucket)), ret.addPropertyResult("bucketAccountId", "BucketAccountId", properties.BucketAccountId != null ? cfn_parse.FromCloudFormation.getString(properties.BucketAccountId) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("policy", "Policy", properties.Policy != null ? cfn_parse.FromCloudFormation.getAny(properties.Policy) : void 0), ret.addPropertyResult("policyStatus", "PolicyStatus", properties.PolicyStatus != null ? cfn_parse.FromCloudFormation.getAny(properties.PolicyStatus) : void 0), ret.addPropertyResult("publicAccessBlockConfiguration", "PublicAccessBlockConfiguration", properties.PublicAccessBlockConfiguration != null ? CfnAccessPointPublicAccessBlockConfigurationPropertyFromCloudFormation(properties.PublicAccessBlockConfiguration) : void 0), ret.addPropertyResult("vpcConfiguration", "VpcConfiguration", properties.VpcConfiguration != null ? CfnAccessPointVpcConfigurationPropertyFromCloudFormation(properties.VpcConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAccessPoint = class _CfnAccessPoint extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAccessPointPropsFromCloudFormation(resourceProperties), ret = new _CfnAccessPoint(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAccessPoint.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_CfnAccessPointProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAccessPoint), error;
        }
        cdk.requireProperty(props, "bucket", this), this.attrAlias = cdk.Token.asString(this.getAtt("Alias", cdk.ResolutionTypeHint.STRING)), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.attrNetworkOrigin = cdk.Token.asString(this.getAtt("NetworkOrigin", cdk.ResolutionTypeHint.STRING)), this.bucket = props.bucket, this.bucketAccountId = props.bucketAccountId, this.name = props.name, this.policy = props.policy, this.policyStatus = props.policyStatus, this.publicAccessBlockConfiguration = props.publicAccessBlockConfiguration, this.vpcConfiguration = props.vpcConfiguration;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAccessPoint.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { bucket: this.bucket, bucketAccountId: this.bucketAccountId, name: this.name, policy: this.policy, policyStatus: this.policyStatus, publicAccessBlockConfiguration: this.publicAccessBlockConfiguration, vpcConfiguration: this.vpcConfiguration };
      }
      renderProperties(props) {
        return cfnAccessPointPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAccessPoint[_a] = { fqn: "aws-cdk-lib.aws_s3.CfnAccessPoint", version: "2.80.0" }, CfnAccessPoint.CFN_RESOURCE_TYPE_NAME = "AWS::S3::AccessPoint", exports2.CfnAccessPoint = CfnAccessPoint;
    function CfnAccessPoint_PublicAccessBlockConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("blockPublicAcls", cdk.validateBoolean)(properties.blockPublicAcls)), errors.collect(cdk.propertyValidator("blockPublicPolicy", cdk.validateBoolean)(properties.blockPublicPolicy)), errors.collect(cdk.propertyValidator("ignorePublicAcls", cdk.validateBoolean)(properties.ignorePublicAcls)), errors.collect(cdk.propertyValidator("restrictPublicBuckets", cdk.validateBoolean)(properties.restrictPublicBuckets)), errors.wrap('supplied properties not correct for "PublicAccessBlockConfigurationProperty"');
    }
    function cfnAccessPointPublicAccessBlockConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccessPoint_PublicAccessBlockConfigurationPropertyValidator(properties).assertSuccess(), { BlockPublicAcls: cdk.booleanToCloudFormation(properties.blockPublicAcls), BlockPublicPolicy: cdk.booleanToCloudFormation(properties.blockPublicPolicy), IgnorePublicAcls: cdk.booleanToCloudFormation(properties.ignorePublicAcls), RestrictPublicBuckets: cdk.booleanToCloudFormation(properties.restrictPublicBuckets) }) : properties;
    }
    function CfnAccessPointPublicAccessBlockConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("blockPublicAcls", "BlockPublicAcls", properties.BlockPublicAcls != null ? cfn_parse.FromCloudFormation.getBoolean(properties.BlockPublicAcls) : void 0), ret.addPropertyResult("blockPublicPolicy", "BlockPublicPolicy", properties.BlockPublicPolicy != null ? cfn_parse.FromCloudFormation.getBoolean(properties.BlockPublicPolicy) : void 0), ret.addPropertyResult("ignorePublicAcls", "IgnorePublicAcls", properties.IgnorePublicAcls != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IgnorePublicAcls) : void 0), ret.addPropertyResult("restrictPublicBuckets", "RestrictPublicBuckets", properties.RestrictPublicBuckets != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RestrictPublicBuckets) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAccessPoint_VpcConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "VpcConfigurationProperty"');
    }
    function cfnAccessPointVpcConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccessPoint_VpcConfigurationPropertyValidator(properties).assertSuccess(), { VpcId: cdk.stringToCloudFormation(properties.vpcId) }) : properties;
    }
    function CfnAccessPointVpcConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("vpcId", "VpcId", properties.VpcId != null ? cfn_parse.FromCloudFormation.getString(properties.VpcId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucketPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accelerateConfiguration", CfnBucket_AccelerateConfigurationPropertyValidator)(properties.accelerateConfiguration)), errors.collect(cdk.propertyValidator("accessControl", cdk.validateString)(properties.accessControl)), errors.collect(cdk.propertyValidator("analyticsConfigurations", cdk.listValidator(CfnBucket_AnalyticsConfigurationPropertyValidator))(properties.analyticsConfigurations)), errors.collect(cdk.propertyValidator("bucketEncryption", CfnBucket_BucketEncryptionPropertyValidator)(properties.bucketEncryption)), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.collect(cdk.propertyValidator("corsConfiguration", CfnBucket_CorsConfigurationPropertyValidator)(properties.corsConfiguration)), errors.collect(cdk.propertyValidator("intelligentTieringConfigurations", cdk.listValidator(CfnBucket_IntelligentTieringConfigurationPropertyValidator))(properties.intelligentTieringConfigurations)), errors.collect(cdk.propertyValidator("inventoryConfigurations", cdk.listValidator(CfnBucket_InventoryConfigurationPropertyValidator))(properties.inventoryConfigurations)), errors.collect(cdk.propertyValidator("lifecycleConfiguration", CfnBucket_LifecycleConfigurationPropertyValidator)(properties.lifecycleConfiguration)), errors.collect(cdk.propertyValidator("loggingConfiguration", CfnBucket_LoggingConfigurationPropertyValidator)(properties.loggingConfiguration)), errors.collect(cdk.propertyValidator("metricsConfigurations", cdk.listValidator(CfnBucket_MetricsConfigurationPropertyValidator))(properties.metricsConfigurations)), errors.collect(cdk.propertyValidator("notificationConfiguration", CfnBucket_NotificationConfigurationPropertyValidator)(properties.notificationConfiguration)), errors.collect(cdk.propertyValidator("objectLockConfiguration", CfnBucket_ObjectLockConfigurationPropertyValidator)(properties.objectLockConfiguration)), errors.collect(cdk.propertyValidator("objectLockEnabled", cdk.validateBoolean)(properties.objectLockEnabled)), errors.collect(cdk.propertyValidator("ownershipControls", CfnBucket_OwnershipControlsPropertyValidator)(properties.ownershipControls)), errors.collect(cdk.propertyValidator("publicAccessBlockConfiguration", CfnBucket_PublicAccessBlockConfigurationPropertyValidator)(properties.publicAccessBlockConfiguration)), errors.collect(cdk.propertyValidator("replicationConfiguration", CfnBucket_ReplicationConfigurationPropertyValidator)(properties.replicationConfiguration)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("versioningConfiguration", CfnBucket_VersioningConfigurationPropertyValidator)(properties.versioningConfiguration)), errors.collect(cdk.propertyValidator("websiteConfiguration", CfnBucket_WebsiteConfigurationPropertyValidator)(properties.websiteConfiguration)), errors.wrap('supplied properties not correct for "CfnBucketProps"');
    }
    function cfnBucketPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucketPropsValidator(properties).assertSuccess(), { AccelerateConfiguration: cfnBucketAccelerateConfigurationPropertyToCloudFormation(properties.accelerateConfiguration), AccessControl: cdk.stringToCloudFormation(properties.accessControl), AnalyticsConfigurations: cdk.listMapper(cfnBucketAnalyticsConfigurationPropertyToCloudFormation)(properties.analyticsConfigurations), BucketEncryption: cfnBucketBucketEncryptionPropertyToCloudFormation(properties.bucketEncryption), BucketName: cdk.stringToCloudFormation(properties.bucketName), CorsConfiguration: cfnBucketCorsConfigurationPropertyToCloudFormation(properties.corsConfiguration), IntelligentTieringConfigurations: cdk.listMapper(cfnBucketIntelligentTieringConfigurationPropertyToCloudFormation)(properties.intelligentTieringConfigurations), InventoryConfigurations: cdk.listMapper(cfnBucketInventoryConfigurationPropertyToCloudFormation)(properties.inventoryConfigurations), LifecycleConfiguration: cfnBucketLifecycleConfigurationPropertyToCloudFormation(properties.lifecycleConfiguration), LoggingConfiguration: cfnBucketLoggingConfigurationPropertyToCloudFormation(properties.loggingConfiguration), MetricsConfigurations: cdk.listMapper(cfnBucketMetricsConfigurationPropertyToCloudFormation)(properties.metricsConfigurations), NotificationConfiguration: cfnBucketNotificationConfigurationPropertyToCloudFormation(properties.notificationConfiguration), ObjectLockConfiguration: cfnBucketObjectLockConfigurationPropertyToCloudFormation(properties.objectLockConfiguration), ObjectLockEnabled: cdk.booleanToCloudFormation(properties.objectLockEnabled), OwnershipControls: cfnBucketOwnershipControlsPropertyToCloudFormation(properties.ownershipControls), PublicAccessBlockConfiguration: cfnBucketPublicAccessBlockConfigurationPropertyToCloudFormation(properties.publicAccessBlockConfiguration), ReplicationConfiguration: cfnBucketReplicationConfigurationPropertyToCloudFormation(properties.replicationConfiguration), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VersioningConfiguration: cfnBucketVersioningConfigurationPropertyToCloudFormation(properties.versioningConfiguration), WebsiteConfiguration: cfnBucketWebsiteConfigurationPropertyToCloudFormation(properties.websiteConfiguration) }) : properties;
    }
    function CfnBucketPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accelerateConfiguration", "AccelerateConfiguration", properties.AccelerateConfiguration != null ? CfnBucketAccelerateConfigurationPropertyFromCloudFormation(properties.AccelerateConfiguration) : void 0), ret.addPropertyResult("accessControl", "AccessControl", properties.AccessControl != null ? cfn_parse.FromCloudFormation.getString(properties.AccessControl) : void 0), ret.addPropertyResult("analyticsConfigurations", "AnalyticsConfigurations", properties.AnalyticsConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnBucketAnalyticsConfigurationPropertyFromCloudFormation)(properties.AnalyticsConfigurations) : void 0), ret.addPropertyResult("bucketEncryption", "BucketEncryption", properties.BucketEncryption != null ? CfnBucketBucketEncryptionPropertyFromCloudFormation(properties.BucketEncryption) : void 0), ret.addPropertyResult("bucketName", "BucketName", properties.BucketName != null ? cfn_parse.FromCloudFormation.getString(properties.BucketName) : void 0), ret.addPropertyResult("corsConfiguration", "CorsConfiguration", properties.CorsConfiguration != null ? CfnBucketCorsConfigurationPropertyFromCloudFormation(properties.CorsConfiguration) : void 0), ret.addPropertyResult("intelligentTieringConfigurations", "IntelligentTieringConfigurations", properties.IntelligentTieringConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnBucketIntelligentTieringConfigurationPropertyFromCloudFormation)(properties.IntelligentTieringConfigurations) : void 0), ret.addPropertyResult("inventoryConfigurations", "InventoryConfigurations", properties.InventoryConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnBucketInventoryConfigurationPropertyFromCloudFormation)(properties.InventoryConfigurations) : void 0), ret.addPropertyResult("lifecycleConfiguration", "LifecycleConfiguration", properties.LifecycleConfiguration != null ? CfnBucketLifecycleConfigurationPropertyFromCloudFormation(properties.LifecycleConfiguration) : void 0), ret.addPropertyResult("loggingConfiguration", "LoggingConfiguration", properties.LoggingConfiguration != null ? CfnBucketLoggingConfigurationPropertyFromCloudFormation(properties.LoggingConfiguration) : void 0), ret.addPropertyResult("metricsConfigurations", "MetricsConfigurations", properties.MetricsConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnBucketMetricsConfigurationPropertyFromCloudFormation)(properties.MetricsConfigurations) : void 0), ret.addPropertyResult("notificationConfiguration", "NotificationConfiguration", properties.NotificationConfiguration != null ? CfnBucketNotificationConfigurationPropertyFromCloudFormation(properties.NotificationConfiguration) : void 0), ret.addPropertyResult("objectLockConfiguration", "ObjectLockConfiguration", properties.ObjectLockConfiguration != null ? CfnBucketObjectLockConfigurationPropertyFromCloudFormation(properties.ObjectLockConfiguration) : void 0), ret.addPropertyResult("objectLockEnabled", "ObjectLockEnabled", properties.ObjectLockEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ObjectLockEnabled) : void 0), ret.addPropertyResult("ownershipControls", "OwnershipControls", properties.OwnershipControls != null ? CfnBucketOwnershipControlsPropertyFromCloudFormation(properties.OwnershipControls) : void 0), ret.addPropertyResult("publicAccessBlockConfiguration", "PublicAccessBlockConfiguration", properties.PublicAccessBlockConfiguration != null ? CfnBucketPublicAccessBlockConfigurationPropertyFromCloudFormation(properties.PublicAccessBlockConfiguration) : void 0), ret.addPropertyResult("replicationConfiguration", "ReplicationConfiguration", properties.ReplicationConfiguration != null ? CfnBucketReplicationConfigurationPropertyFromCloudFormation(properties.ReplicationConfiguration) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("versioningConfiguration", "VersioningConfiguration", properties.VersioningConfiguration != null ? CfnBucketVersioningConfigurationPropertyFromCloudFormation(properties.VersioningConfiguration) : void 0), ret.addPropertyResult("websiteConfiguration", "WebsiteConfiguration", properties.WebsiteConfiguration != null ? CfnBucketWebsiteConfigurationPropertyFromCloudFormation(properties.WebsiteConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnBucket = class _CfnBucket extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnBucketPropsFromCloudFormation(resourceProperties), ret = new _CfnBucket(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnBucket.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_CfnBucketProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnBucket), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrDomainName = cdk.Token.asString(this.getAtt("DomainName", cdk.ResolutionTypeHint.STRING)), this.attrDualStackDomainName = cdk.Token.asString(this.getAtt("DualStackDomainName", cdk.ResolutionTypeHint.STRING)), this.attrRegionalDomainName = cdk.Token.asString(this.getAtt("RegionalDomainName", cdk.ResolutionTypeHint.STRING)), this.attrWebsiteUrl = cdk.Token.asString(this.getAtt("WebsiteURL", cdk.ResolutionTypeHint.STRING)), this.accelerateConfiguration = props.accelerateConfiguration, this.accessControl = props.accessControl, this.analyticsConfigurations = props.analyticsConfigurations, this.bucketEncryption = props.bucketEncryption, this.bucketName = props.bucketName, this.corsConfiguration = props.corsConfiguration, this.intelligentTieringConfigurations = props.intelligentTieringConfigurations, this.inventoryConfigurations = props.inventoryConfigurations, this.lifecycleConfiguration = props.lifecycleConfiguration, this.loggingConfiguration = props.loggingConfiguration, this.metricsConfigurations = props.metricsConfigurations, this.notificationConfiguration = props.notificationConfiguration, this.objectLockConfiguration = props.objectLockConfiguration, this.objectLockEnabled = props.objectLockEnabled, this.ownershipControls = props.ownershipControls, this.publicAccessBlockConfiguration = props.publicAccessBlockConfiguration, this.replicationConfiguration = props.replicationConfiguration, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::S3::Bucket", props.tags, { tagPropertyName: "tags" }), this.versioningConfiguration = props.versioningConfiguration, this.websiteConfiguration = props.websiteConfiguration, this.node.scope && cdk.Resource.isResource(this.node.scope) && this.node.addValidation({ validate: () => this.cfnOptions.deletionPolicy === void 0 ? ["'AWS::S3::Bucket' is a stateful resource type, and you must specify a Removal Policy for it. Call 'resource.applyRemovalPolicy()'."] : [] });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnBucket.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { accelerateConfiguration: this.accelerateConfiguration, accessControl: this.accessControl, analyticsConfigurations: this.analyticsConfigurations, bucketEncryption: this.bucketEncryption, bucketName: this.bucketName, corsConfiguration: this.corsConfiguration, intelligentTieringConfigurations: this.intelligentTieringConfigurations, inventoryConfigurations: this.inventoryConfigurations, lifecycleConfiguration: this.lifecycleConfiguration, loggingConfiguration: this.loggingConfiguration, metricsConfigurations: this.metricsConfigurations, notificationConfiguration: this.notificationConfiguration, objectLockConfiguration: this.objectLockConfiguration, objectLockEnabled: this.objectLockEnabled, ownershipControls: this.ownershipControls, publicAccessBlockConfiguration: this.publicAccessBlockConfiguration, replicationConfiguration: this.replicationConfiguration, tags: this.tags.renderTags(), versioningConfiguration: this.versioningConfiguration, websiteConfiguration: this.websiteConfiguration };
      }
      renderProperties(props) {
        return cfnBucketPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnBucket[_b] = { fqn: "aws-cdk-lib.aws_s3.CfnBucket", version: "2.80.0" }, CfnBucket.CFN_RESOURCE_TYPE_NAME = "AWS::S3::Bucket", exports2.CfnBucket = CfnBucket;
    function CfnBucket_AbortIncompleteMultipartUploadPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("daysAfterInitiation", cdk.requiredValidator)(properties.daysAfterInitiation)), errors.collect(cdk.propertyValidator("daysAfterInitiation", cdk.validateNumber)(properties.daysAfterInitiation)), errors.wrap('supplied properties not correct for "AbortIncompleteMultipartUploadProperty"');
    }
    function cfnBucketAbortIncompleteMultipartUploadPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_AbortIncompleteMultipartUploadPropertyValidator(properties).assertSuccess(), { DaysAfterInitiation: cdk.numberToCloudFormation(properties.daysAfterInitiation) }) : properties;
    }
    function CfnBucketAbortIncompleteMultipartUploadPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("daysAfterInitiation", "DaysAfterInitiation", cfn_parse.FromCloudFormation.getNumber(properties.DaysAfterInitiation)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_AccelerateConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accelerationStatus", cdk.requiredValidator)(properties.accelerationStatus)), errors.collect(cdk.propertyValidator("accelerationStatus", cdk.validateString)(properties.accelerationStatus)), errors.wrap('supplied properties not correct for "AccelerateConfigurationProperty"');
    }
    function cfnBucketAccelerateConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_AccelerateConfigurationPropertyValidator(properties).assertSuccess(), { AccelerationStatus: cdk.stringToCloudFormation(properties.accelerationStatus) }) : properties;
    }
    function CfnBucketAccelerateConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accelerationStatus", "AccelerationStatus", cfn_parse.FromCloudFormation.getString(properties.AccelerationStatus)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_AccessControlTranslationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("owner", cdk.requiredValidator)(properties.owner)), errors.collect(cdk.propertyValidator("owner", cdk.validateString)(properties.owner)), errors.wrap('supplied properties not correct for "AccessControlTranslationProperty"');
    }
    function cfnBucketAccessControlTranslationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_AccessControlTranslationPropertyValidator(properties).assertSuccess(), { Owner: cdk.stringToCloudFormation(properties.owner) }) : properties;
    }
    function CfnBucketAccessControlTranslationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("owner", "Owner", cfn_parse.FromCloudFormation.getString(properties.Owner)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_AnalyticsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.collect(cdk.propertyValidator("storageClassAnalysis", cdk.requiredValidator)(properties.storageClassAnalysis)), errors.collect(cdk.propertyValidator("storageClassAnalysis", CfnBucket_StorageClassAnalysisPropertyValidator)(properties.storageClassAnalysis)), errors.collect(cdk.propertyValidator("tagFilters", cdk.listValidator(CfnBucket_TagFilterPropertyValidator))(properties.tagFilters)), errors.wrap('supplied properties not correct for "AnalyticsConfigurationProperty"');
    }
    function cfnBucketAnalyticsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_AnalyticsConfigurationPropertyValidator(properties).assertSuccess(), { Id: cdk.stringToCloudFormation(properties.id), Prefix: cdk.stringToCloudFormation(properties.prefix), StorageClassAnalysis: cfnBucketStorageClassAnalysisPropertyToCloudFormation(properties.storageClassAnalysis), TagFilters: cdk.listMapper(cfnBucketTagFilterPropertyToCloudFormation)(properties.tagFilters) }) : properties;
    }
    function CfnBucketAnalyticsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addPropertyResult("storageClassAnalysis", "StorageClassAnalysis", CfnBucketStorageClassAnalysisPropertyFromCloudFormation(properties.StorageClassAnalysis)), ret.addPropertyResult("tagFilters", "TagFilters", properties.TagFilters != null ? cfn_parse.FromCloudFormation.getArray(CfnBucketTagFilterPropertyFromCloudFormation)(properties.TagFilters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_BucketEncryptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("serverSideEncryptionConfiguration", cdk.requiredValidator)(properties.serverSideEncryptionConfiguration)), errors.collect(cdk.propertyValidator("serverSideEncryptionConfiguration", cdk.listValidator(CfnBucket_ServerSideEncryptionRulePropertyValidator))(properties.serverSideEncryptionConfiguration)), errors.wrap('supplied properties not correct for "BucketEncryptionProperty"');
    }
    function cfnBucketBucketEncryptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_BucketEncryptionPropertyValidator(properties).assertSuccess(), { ServerSideEncryptionConfiguration: cdk.listMapper(cfnBucketServerSideEncryptionRulePropertyToCloudFormation)(properties.serverSideEncryptionConfiguration) }) : properties;
    }
    function CfnBucketBucketEncryptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("serverSideEncryptionConfiguration", "ServerSideEncryptionConfiguration", cfn_parse.FromCloudFormation.getArray(CfnBucketServerSideEncryptionRulePropertyFromCloudFormation)(properties.ServerSideEncryptionConfiguration)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_CorsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("corsRules", cdk.requiredValidator)(properties.corsRules)), errors.collect(cdk.propertyValidator("corsRules", cdk.listValidator(CfnBucket_CorsRulePropertyValidator))(properties.corsRules)), errors.wrap('supplied properties not correct for "CorsConfigurationProperty"');
    }
    function cfnBucketCorsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_CorsConfigurationPropertyValidator(properties).assertSuccess(), { CorsRules: cdk.listMapper(cfnBucketCorsRulePropertyToCloudFormation)(properties.corsRules) }) : properties;
    }
    function CfnBucketCorsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("corsRules", "CorsRules", cfn_parse.FromCloudFormation.getArray(CfnBucketCorsRulePropertyFromCloudFormation)(properties.CorsRules)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_CorsRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowedHeaders", cdk.listValidator(cdk.validateString))(properties.allowedHeaders)), errors.collect(cdk.propertyValidator("allowedMethods", cdk.requiredValidator)(properties.allowedMethods)), errors.collect(cdk.propertyValidator("allowedMethods", cdk.listValidator(cdk.validateString))(properties.allowedMethods)), errors.collect(cdk.propertyValidator("allowedOrigins", cdk.requiredValidator)(properties.allowedOrigins)), errors.collect(cdk.propertyValidator("allowedOrigins", cdk.listValidator(cdk.validateString))(properties.allowedOrigins)), errors.collect(cdk.propertyValidator("exposedHeaders", cdk.listValidator(cdk.validateString))(properties.exposedHeaders)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("maxAge", cdk.validateNumber)(properties.maxAge)), errors.wrap('supplied properties not correct for "CorsRuleProperty"');
    }
    function cfnBucketCorsRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_CorsRulePropertyValidator(properties).assertSuccess(), { AllowedHeaders: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowedHeaders), AllowedMethods: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowedMethods), AllowedOrigins: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowedOrigins), ExposedHeaders: cdk.listMapper(cdk.stringToCloudFormation)(properties.exposedHeaders), Id: cdk.stringToCloudFormation(properties.id), MaxAge: cdk.numberToCloudFormation(properties.maxAge) }) : properties;
    }
    function CfnBucketCorsRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowedHeaders", "AllowedHeaders", properties.AllowedHeaders != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AllowedHeaders) : void 0), ret.addPropertyResult("allowedMethods", "AllowedMethods", cfn_parse.FromCloudFormation.getStringArray(properties.AllowedMethods)), ret.addPropertyResult("allowedOrigins", "AllowedOrigins", cfn_parse.FromCloudFormation.getStringArray(properties.AllowedOrigins)), ret.addPropertyResult("exposedHeaders", "ExposedHeaders", properties.ExposedHeaders != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExposedHeaders) : void 0), ret.addPropertyResult("id", "Id", properties.Id != null ? cfn_parse.FromCloudFormation.getString(properties.Id) : void 0), ret.addPropertyResult("maxAge", "MaxAge", properties.MaxAge != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxAge) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_DataExportPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destination", cdk.requiredValidator)(properties.destination)), errors.collect(cdk.propertyValidator("destination", CfnBucket_DestinationPropertyValidator)(properties.destination)), errors.collect(cdk.propertyValidator("outputSchemaVersion", cdk.requiredValidator)(properties.outputSchemaVersion)), errors.collect(cdk.propertyValidator("outputSchemaVersion", cdk.validateString)(properties.outputSchemaVersion)), errors.wrap('supplied properties not correct for "DataExportProperty"');
    }
    function cfnBucketDataExportPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_DataExportPropertyValidator(properties).assertSuccess(), { Destination: cfnBucketDestinationPropertyToCloudFormation(properties.destination), OutputSchemaVersion: cdk.stringToCloudFormation(properties.outputSchemaVersion) }) : properties;
    }
    function CfnBucketDataExportPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destination", "Destination", CfnBucketDestinationPropertyFromCloudFormation(properties.Destination)), ret.addPropertyResult("outputSchemaVersion", "OutputSchemaVersion", cfn_parse.FromCloudFormation.getString(properties.OutputSchemaVersion)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_DefaultRetentionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("days", cdk.validateNumber)(properties.days)), errors.collect(cdk.propertyValidator("mode", cdk.validateString)(properties.mode)), errors.collect(cdk.propertyValidator("years", cdk.validateNumber)(properties.years)), errors.wrap('supplied properties not correct for "DefaultRetentionProperty"');
    }
    function cfnBucketDefaultRetentionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_DefaultRetentionPropertyValidator(properties).assertSuccess(), { Days: cdk.numberToCloudFormation(properties.days), Mode: cdk.stringToCloudFormation(properties.mode), Years: cdk.numberToCloudFormation(properties.years) }) : properties;
    }
    function CfnBucketDefaultRetentionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("days", "Days", properties.Days != null ? cfn_parse.FromCloudFormation.getNumber(properties.Days) : void 0), ret.addPropertyResult("mode", "Mode", properties.Mode != null ? cfn_parse.FromCloudFormation.getString(properties.Mode) : void 0), ret.addPropertyResult("years", "Years", properties.Years != null ? cfn_parse.FromCloudFormation.getNumber(properties.Years) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_DeleteMarkerReplicationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "DeleteMarkerReplicationProperty"');
    }
    function cfnBucketDeleteMarkerReplicationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_DeleteMarkerReplicationPropertyValidator(properties).assertSuccess(), { Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnBucketDeleteMarkerReplicationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_DestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketAccountId", cdk.validateString)(properties.bucketAccountId)), errors.collect(cdk.propertyValidator("bucketArn", cdk.requiredValidator)(properties.bucketArn)), errors.collect(cdk.propertyValidator("bucketArn", cdk.validateString)(properties.bucketArn)), errors.collect(cdk.propertyValidator("format", cdk.requiredValidator)(properties.format)), errors.collect(cdk.propertyValidator("format", cdk.validateString)(properties.format)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.wrap('supplied properties not correct for "DestinationProperty"');
    }
    function cfnBucketDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_DestinationPropertyValidator(properties).assertSuccess(), { BucketAccountId: cdk.stringToCloudFormation(properties.bucketAccountId), BucketArn: cdk.stringToCloudFormation(properties.bucketArn), Format: cdk.stringToCloudFormation(properties.format), Prefix: cdk.stringToCloudFormation(properties.prefix) }) : properties;
    }
    function CfnBucketDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketAccountId", "BucketAccountId", properties.BucketAccountId != null ? cfn_parse.FromCloudFormation.getString(properties.BucketAccountId) : void 0), ret.addPropertyResult("bucketArn", "BucketArn", cfn_parse.FromCloudFormation.getString(properties.BucketArn)), ret.addPropertyResult("format", "Format", cfn_parse.FromCloudFormation.getString(properties.Format)), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_EncryptionConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("replicaKmsKeyId", cdk.requiredValidator)(properties.replicaKmsKeyId)), errors.collect(cdk.propertyValidator("replicaKmsKeyId", cdk.validateString)(properties.replicaKmsKeyId)), errors.wrap('supplied properties not correct for "EncryptionConfigurationProperty"');
    }
    function cfnBucketEncryptionConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_EncryptionConfigurationPropertyValidator(properties).assertSuccess(), { ReplicaKmsKeyID: cdk.stringToCloudFormation(properties.replicaKmsKeyId) }) : properties;
    }
    function CfnBucketEncryptionConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("replicaKmsKeyId", "ReplicaKmsKeyID", cfn_parse.FromCloudFormation.getString(properties.ReplicaKmsKeyID)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_EventBridgeConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("eventBridgeEnabled", cdk.validateBoolean)(properties.eventBridgeEnabled)), errors.wrap('supplied properties not correct for "EventBridgeConfigurationProperty"');
    }
    function cfnBucketEventBridgeConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_EventBridgeConfigurationPropertyValidator(properties).assertSuccess(), { EventBridgeEnabled: cdk.booleanToCloudFormation(properties.eventBridgeEnabled) }) : properties;
    }
    function CfnBucketEventBridgeConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("eventBridgeEnabled", "EventBridgeEnabled", properties.EventBridgeEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EventBridgeEnabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_FilterRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "FilterRuleProperty"');
    }
    function cfnBucketFilterRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_FilterRulePropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnBucketFilterRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_IntelligentTieringConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.collect(cdk.propertyValidator("status", cdk.requiredValidator)(properties.status)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.collect(cdk.propertyValidator("tagFilters", cdk.listValidator(CfnBucket_TagFilterPropertyValidator))(properties.tagFilters)), errors.collect(cdk.propertyValidator("tierings", cdk.requiredValidator)(properties.tierings)), errors.collect(cdk.propertyValidator("tierings", cdk.listValidator(CfnBucket_TieringPropertyValidator))(properties.tierings)), errors.wrap('supplied properties not correct for "IntelligentTieringConfigurationProperty"');
    }
    function cfnBucketIntelligentTieringConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_IntelligentTieringConfigurationPropertyValidator(properties).assertSuccess(), { Id: cdk.stringToCloudFormation(properties.id), Prefix: cdk.stringToCloudFormation(properties.prefix), Status: cdk.stringToCloudFormation(properties.status), TagFilters: cdk.listMapper(cfnBucketTagFilterPropertyToCloudFormation)(properties.tagFilters), Tierings: cdk.listMapper(cfnBucketTieringPropertyToCloudFormation)(properties.tierings) }) : properties;
    }
    function CfnBucketIntelligentTieringConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addPropertyResult("status", "Status", cfn_parse.FromCloudFormation.getString(properties.Status)), ret.addPropertyResult("tagFilters", "TagFilters", properties.TagFilters != null ? cfn_parse.FromCloudFormation.getArray(CfnBucketTagFilterPropertyFromCloudFormation)(properties.TagFilters) : void 0), ret.addPropertyResult("tierings", "Tierings", cfn_parse.FromCloudFormation.getArray(CfnBucketTieringPropertyFromCloudFormation)(properties.Tierings)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_InventoryConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destination", cdk.requiredValidator)(properties.destination)), errors.collect(cdk.propertyValidator("destination", CfnBucket_DestinationPropertyValidator)(properties.destination)), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("includedObjectVersions", cdk.requiredValidator)(properties.includedObjectVersions)), errors.collect(cdk.propertyValidator("includedObjectVersions", cdk.validateString)(properties.includedObjectVersions)), errors.collect(cdk.propertyValidator("optionalFields", cdk.listValidator(cdk.validateString))(properties.optionalFields)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.collect(cdk.propertyValidator("scheduleFrequency", cdk.requiredValidator)(properties.scheduleFrequency)), errors.collect(cdk.propertyValidator("scheduleFrequency", cdk.validateString)(properties.scheduleFrequency)), errors.wrap('supplied properties not correct for "InventoryConfigurationProperty"');
    }
    function cfnBucketInventoryConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_InventoryConfigurationPropertyValidator(properties).assertSuccess(), { Destination: cfnBucketDestinationPropertyToCloudFormation(properties.destination), Enabled: cdk.booleanToCloudFormation(properties.enabled), Id: cdk.stringToCloudFormation(properties.id), IncludedObjectVersions: cdk.stringToCloudFormation(properties.includedObjectVersions), OptionalFields: cdk.listMapper(cdk.stringToCloudFormation)(properties.optionalFields), Prefix: cdk.stringToCloudFormation(properties.prefix), ScheduleFrequency: cdk.stringToCloudFormation(properties.scheduleFrequency) }) : properties;
    }
    function CfnBucketInventoryConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destination", "Destination", CfnBucketDestinationPropertyFromCloudFormation(properties.Destination)), ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("includedObjectVersions", "IncludedObjectVersions", cfn_parse.FromCloudFormation.getString(properties.IncludedObjectVersions)), ret.addPropertyResult("optionalFields", "OptionalFields", properties.OptionalFields != null ? cfn_parse.FromCloudFormation.getStringArray(properties.OptionalFields) : void 0), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addPropertyResult("scheduleFrequency", "ScheduleFrequency", cfn_parse.FromCloudFormation.getString(properties.ScheduleFrequency)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_LambdaConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("event", cdk.requiredValidator)(properties.event)), errors.collect(cdk.propertyValidator("event", cdk.validateString)(properties.event)), errors.collect(cdk.propertyValidator("filter", CfnBucket_NotificationFilterPropertyValidator)(properties.filter)), errors.collect(cdk.propertyValidator("function", cdk.requiredValidator)(properties.function)), errors.collect(cdk.propertyValidator("function", cdk.validateString)(properties.function)), errors.wrap('supplied properties not correct for "LambdaConfigurationProperty"');
    }
    function cfnBucketLambdaConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_LambdaConfigurationPropertyValidator(properties).assertSuccess(), { Event: cdk.stringToCloudFormation(properties.event), Filter: cfnBucketNotificationFilterPropertyToCloudFormation(properties.filter), Function: cdk.stringToCloudFormation(properties.function) }) : properties;
    }
    function CfnBucketLambdaConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("event", "Event", cfn_parse.FromCloudFormation.getString(properties.Event)), ret.addPropertyResult("filter", "Filter", properties.Filter != null ? CfnBucketNotificationFilterPropertyFromCloudFormation(properties.Filter) : void 0), ret.addPropertyResult("function", "Function", cfn_parse.FromCloudFormation.getString(properties.Function)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_LifecycleConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("rules", cdk.requiredValidator)(properties.rules)), errors.collect(cdk.propertyValidator("rules", cdk.listValidator(CfnBucket_RulePropertyValidator))(properties.rules)), errors.wrap('supplied properties not correct for "LifecycleConfigurationProperty"');
    }
    function cfnBucketLifecycleConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_LifecycleConfigurationPropertyValidator(properties).assertSuccess(), { Rules: cdk.listMapper(cfnBucketRulePropertyToCloudFormation)(properties.rules) }) : properties;
    }
    function CfnBucketLifecycleConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("rules", "Rules", cfn_parse.FromCloudFormation.getArray(CfnBucketRulePropertyFromCloudFormation)(properties.Rules)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_LoggingConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationBucketName", cdk.validateString)(properties.destinationBucketName)), errors.collect(cdk.propertyValidator("logFilePrefix", cdk.validateString)(properties.logFilePrefix)), errors.wrap('supplied properties not correct for "LoggingConfigurationProperty"');
    }
    function cfnBucketLoggingConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_LoggingConfigurationPropertyValidator(properties).assertSuccess(), { DestinationBucketName: cdk.stringToCloudFormation(properties.destinationBucketName), LogFilePrefix: cdk.stringToCloudFormation(properties.logFilePrefix) }) : properties;
    }
    function CfnBucketLoggingConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationBucketName", "DestinationBucketName", properties.DestinationBucketName != null ? cfn_parse.FromCloudFormation.getString(properties.DestinationBucketName) : void 0), ret.addPropertyResult("logFilePrefix", "LogFilePrefix", properties.LogFilePrefix != null ? cfn_parse.FromCloudFormation.getString(properties.LogFilePrefix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_MetricsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("eventThreshold", CfnBucket_ReplicationTimeValuePropertyValidator)(properties.eventThreshold)), errors.collect(cdk.propertyValidator("status", cdk.requiredValidator)(properties.status)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "MetricsProperty"');
    }
    function cfnBucketMetricsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_MetricsPropertyValidator(properties).assertSuccess(), { EventThreshold: cfnBucketReplicationTimeValuePropertyToCloudFormation(properties.eventThreshold), Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnBucketMetricsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("eventThreshold", "EventThreshold", properties.EventThreshold != null ? CfnBucketReplicationTimeValuePropertyFromCloudFormation(properties.EventThreshold) : void 0), ret.addPropertyResult("status", "Status", cfn_parse.FromCloudFormation.getString(properties.Status)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_MetricsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessPointArn", cdk.validateString)(properties.accessPointArn)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.collect(cdk.propertyValidator("tagFilters", cdk.listValidator(CfnBucket_TagFilterPropertyValidator))(properties.tagFilters)), errors.wrap('supplied properties not correct for "MetricsConfigurationProperty"');
    }
    function cfnBucketMetricsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_MetricsConfigurationPropertyValidator(properties).assertSuccess(), { AccessPointArn: cdk.stringToCloudFormation(properties.accessPointArn), Id: cdk.stringToCloudFormation(properties.id), Prefix: cdk.stringToCloudFormation(properties.prefix), TagFilters: cdk.listMapper(cfnBucketTagFilterPropertyToCloudFormation)(properties.tagFilters) }) : properties;
    }
    function CfnBucketMetricsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessPointArn", "AccessPointArn", properties.AccessPointArn != null ? cfn_parse.FromCloudFormation.getString(properties.AccessPointArn) : void 0), ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addPropertyResult("tagFilters", "TagFilters", properties.TagFilters != null ? cfn_parse.FromCloudFormation.getArray(CfnBucketTagFilterPropertyFromCloudFormation)(properties.TagFilters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_NoncurrentVersionExpirationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("newerNoncurrentVersions", cdk.validateNumber)(properties.newerNoncurrentVersions)), errors.collect(cdk.propertyValidator("noncurrentDays", cdk.requiredValidator)(properties.noncurrentDays)), errors.collect(cdk.propertyValidator("noncurrentDays", cdk.validateNumber)(properties.noncurrentDays)), errors.wrap('supplied properties not correct for "NoncurrentVersionExpirationProperty"');
    }
    function cfnBucketNoncurrentVersionExpirationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_NoncurrentVersionExpirationPropertyValidator(properties).assertSuccess(), { NewerNoncurrentVersions: cdk.numberToCloudFormation(properties.newerNoncurrentVersions), NoncurrentDays: cdk.numberToCloudFormation(properties.noncurrentDays) }) : properties;
    }
    function CfnBucketNoncurrentVersionExpirationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("newerNoncurrentVersions", "NewerNoncurrentVersions", properties.NewerNoncurrentVersions != null ? cfn_parse.FromCloudFormation.getNumber(properties.NewerNoncurrentVersions) : void 0), ret.addPropertyResult("noncurrentDays", "NoncurrentDays", cfn_parse.FromCloudFormation.getNumber(properties.NoncurrentDays)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_NoncurrentVersionTransitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("newerNoncurrentVersions", cdk.validateNumber)(properties.newerNoncurrentVersions)), errors.collect(cdk.propertyValidator("storageClass", cdk.requiredValidator)(properties.storageClass)), errors.collect(cdk.propertyValidator("storageClass", cdk.validateString)(properties.storageClass)), errors.collect(cdk.propertyValidator("transitionInDays", cdk.requiredValidator)(properties.transitionInDays)), errors.collect(cdk.propertyValidator("transitionInDays", cdk.validateNumber)(properties.transitionInDays)), errors.wrap('supplied properties not correct for "NoncurrentVersionTransitionProperty"');
    }
    function cfnBucketNoncurrentVersionTransitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_NoncurrentVersionTransitionPropertyValidator(properties).assertSuccess(), { NewerNoncurrentVersions: cdk.numberToCloudFormation(properties.newerNoncurrentVersions), StorageClass: cdk.stringToCloudFormation(properties.storageClass), TransitionInDays: cdk.numberToCloudFormation(properties.transitionInDays) }) : properties;
    }
    function CfnBucketNoncurrentVersionTransitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("newerNoncurrentVersions", "NewerNoncurrentVersions", properties.NewerNoncurrentVersions != null ? cfn_parse.FromCloudFormation.getNumber(properties.NewerNoncurrentVersions) : void 0), ret.addPropertyResult("storageClass", "StorageClass", cfn_parse.FromCloudFormation.getString(properties.StorageClass)), ret.addPropertyResult("transitionInDays", "TransitionInDays", cfn_parse.FromCloudFormation.getNumber(properties.TransitionInDays)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_NotificationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("eventBridgeConfiguration", CfnBucket_EventBridgeConfigurationPropertyValidator)(properties.eventBridgeConfiguration)), errors.collect(cdk.propertyValidator("lambdaConfigurations", cdk.listValidator(CfnBucket_LambdaConfigurationPropertyValidator))(properties.lambdaConfigurations)), errors.collect(cdk.propertyValidator("queueConfigurations", cdk.listValidator(CfnBucket_QueueConfigurationPropertyValidator))(properties.queueConfigurations)), errors.collect(cdk.propertyValidator("topicConfigurations", cdk.listValidator(CfnBucket_TopicConfigurationPropertyValidator))(properties.topicConfigurations)), errors.wrap('supplied properties not correct for "NotificationConfigurationProperty"');
    }
    function cfnBucketNotificationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_NotificationConfigurationPropertyValidator(properties).assertSuccess(), { EventBridgeConfiguration: cfnBucketEventBridgeConfigurationPropertyToCloudFormation(properties.eventBridgeConfiguration), LambdaConfigurations: cdk.listMapper(cfnBucketLambdaConfigurationPropertyToCloudFormation)(properties.lambdaConfigurations), QueueConfigurations: cdk.listMapper(cfnBucketQueueConfigurationPropertyToCloudFormation)(properties.queueConfigurations), TopicConfigurations: cdk.listMapper(cfnBucketTopicConfigurationPropertyToCloudFormation)(properties.topicConfigurations) }) : properties;
    }
    function CfnBucketNotificationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("eventBridgeConfiguration", "EventBridgeConfiguration", properties.EventBridgeConfiguration != null ? CfnBucketEventBridgeConfigurationPropertyFromCloudFormation(properties.EventBridgeConfiguration) : void 0), ret.addPropertyResult("lambdaConfigurations", "LambdaConfigurations", properties.LambdaConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnBucketLambdaConfigurationPropertyFromCloudFormation)(properties.LambdaConfigurations) : void 0), ret.addPropertyResult("queueConfigurations", "QueueConfigurations", properties.QueueConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnBucketQueueConfigurationPropertyFromCloudFormation)(properties.QueueConfigurations) : void 0), ret.addPropertyResult("topicConfigurations", "TopicConfigurations", properties.TopicConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnBucketTopicConfigurationPropertyFromCloudFormation)(properties.TopicConfigurations) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_NotificationFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3Key", cdk.requiredValidator)(properties.s3Key)), errors.collect(cdk.propertyValidator("s3Key", CfnBucket_S3KeyFilterPropertyValidator)(properties.s3Key)), errors.wrap('supplied properties not correct for "NotificationFilterProperty"');
    }
    function cfnBucketNotificationFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_NotificationFilterPropertyValidator(properties).assertSuccess(), { S3Key: cfnBucketS3KeyFilterPropertyToCloudFormation(properties.s3Key) }) : properties;
    }
    function CfnBucketNotificationFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Key", "S3Key", CfnBucketS3KeyFilterPropertyFromCloudFormation(properties.S3Key)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_ObjectLockConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("objectLockEnabled", cdk.validateString)(properties.objectLockEnabled)), errors.collect(cdk.propertyValidator("rule", CfnBucket_ObjectLockRulePropertyValidator)(properties.rule)), errors.wrap('supplied properties not correct for "ObjectLockConfigurationProperty"');
    }
    function cfnBucketObjectLockConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_ObjectLockConfigurationPropertyValidator(properties).assertSuccess(), { ObjectLockEnabled: cdk.stringToCloudFormation(properties.objectLockEnabled), Rule: cfnBucketObjectLockRulePropertyToCloudFormation(properties.rule) }) : properties;
    }
    function CfnBucketObjectLockConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("objectLockEnabled", "ObjectLockEnabled", properties.ObjectLockEnabled != null ? cfn_parse.FromCloudFormation.getString(properties.ObjectLockEnabled) : void 0), ret.addPropertyResult("rule", "Rule", properties.Rule != null ? CfnBucketObjectLockRulePropertyFromCloudFormation(properties.Rule) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_ObjectLockRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultRetention", CfnBucket_DefaultRetentionPropertyValidator)(properties.defaultRetention)), errors.wrap('supplied properties not correct for "ObjectLockRuleProperty"');
    }
    function cfnBucketObjectLockRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_ObjectLockRulePropertyValidator(properties).assertSuccess(), { DefaultRetention: cfnBucketDefaultRetentionPropertyToCloudFormation(properties.defaultRetention) }) : properties;
    }
    function CfnBucketObjectLockRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultRetention", "DefaultRetention", properties.DefaultRetention != null ? CfnBucketDefaultRetentionPropertyFromCloudFormation(properties.DefaultRetention) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_OwnershipControlsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("rules", cdk.requiredValidator)(properties.rules)), errors.collect(cdk.propertyValidator("rules", cdk.listValidator(CfnBucket_OwnershipControlsRulePropertyValidator))(properties.rules)), errors.wrap('supplied properties not correct for "OwnershipControlsProperty"');
    }
    function cfnBucketOwnershipControlsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_OwnershipControlsPropertyValidator(properties).assertSuccess(), { Rules: cdk.listMapper(cfnBucketOwnershipControlsRulePropertyToCloudFormation)(properties.rules) }) : properties;
    }
    function CfnBucketOwnershipControlsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("rules", "Rules", cfn_parse.FromCloudFormation.getArray(CfnBucketOwnershipControlsRulePropertyFromCloudFormation)(properties.Rules)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_OwnershipControlsRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("objectOwnership", cdk.validateString)(properties.objectOwnership)), errors.wrap('supplied properties not correct for "OwnershipControlsRuleProperty"');
    }
    function cfnBucketOwnershipControlsRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_OwnershipControlsRulePropertyValidator(properties).assertSuccess(), { ObjectOwnership: cdk.stringToCloudFormation(properties.objectOwnership) }) : properties;
    }
    function CfnBucketOwnershipControlsRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("objectOwnership", "ObjectOwnership", properties.ObjectOwnership != null ? cfn_parse.FromCloudFormation.getString(properties.ObjectOwnership) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_PublicAccessBlockConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("blockPublicAcls", cdk.validateBoolean)(properties.blockPublicAcls)), errors.collect(cdk.propertyValidator("blockPublicPolicy", cdk.validateBoolean)(properties.blockPublicPolicy)), errors.collect(cdk.propertyValidator("ignorePublicAcls", cdk.validateBoolean)(properties.ignorePublicAcls)), errors.collect(cdk.propertyValidator("restrictPublicBuckets", cdk.validateBoolean)(properties.restrictPublicBuckets)), errors.wrap('supplied properties not correct for "PublicAccessBlockConfigurationProperty"');
    }
    function cfnBucketPublicAccessBlockConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_PublicAccessBlockConfigurationPropertyValidator(properties).assertSuccess(), { BlockPublicAcls: cdk.booleanToCloudFormation(properties.blockPublicAcls), BlockPublicPolicy: cdk.booleanToCloudFormation(properties.blockPublicPolicy), IgnorePublicAcls: cdk.booleanToCloudFormation(properties.ignorePublicAcls), RestrictPublicBuckets: cdk.booleanToCloudFormation(properties.restrictPublicBuckets) }) : properties;
    }
    function CfnBucketPublicAccessBlockConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("blockPublicAcls", "BlockPublicAcls", properties.BlockPublicAcls != null ? cfn_parse.FromCloudFormation.getBoolean(properties.BlockPublicAcls) : void 0), ret.addPropertyResult("blockPublicPolicy", "BlockPublicPolicy", properties.BlockPublicPolicy != null ? cfn_parse.FromCloudFormation.getBoolean(properties.BlockPublicPolicy) : void 0), ret.addPropertyResult("ignorePublicAcls", "IgnorePublicAcls", properties.IgnorePublicAcls != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IgnorePublicAcls) : void 0), ret.addPropertyResult("restrictPublicBuckets", "RestrictPublicBuckets", properties.RestrictPublicBuckets != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RestrictPublicBuckets) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_QueueConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("event", cdk.requiredValidator)(properties.event)), errors.collect(cdk.propertyValidator("event", cdk.validateString)(properties.event)), errors.collect(cdk.propertyValidator("filter", CfnBucket_NotificationFilterPropertyValidator)(properties.filter)), errors.collect(cdk.propertyValidator("queue", cdk.requiredValidator)(properties.queue)), errors.collect(cdk.propertyValidator("queue", cdk.validateString)(properties.queue)), errors.wrap('supplied properties not correct for "QueueConfigurationProperty"');
    }
    function cfnBucketQueueConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_QueueConfigurationPropertyValidator(properties).assertSuccess(), { Event: cdk.stringToCloudFormation(properties.event), Filter: cfnBucketNotificationFilterPropertyToCloudFormation(properties.filter), Queue: cdk.stringToCloudFormation(properties.queue) }) : properties;
    }
    function CfnBucketQueueConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("event", "Event", cfn_parse.FromCloudFormation.getString(properties.Event)), ret.addPropertyResult("filter", "Filter", properties.Filter != null ? CfnBucketNotificationFilterPropertyFromCloudFormation(properties.Filter) : void 0), ret.addPropertyResult("queue", "Queue", cfn_parse.FromCloudFormation.getString(properties.Queue)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_RedirectAllRequestsToPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("hostName", cdk.requiredValidator)(properties.hostName)), errors.collect(cdk.propertyValidator("hostName", cdk.validateString)(properties.hostName)), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.wrap('supplied properties not correct for "RedirectAllRequestsToProperty"');
    }
    function cfnBucketRedirectAllRequestsToPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_RedirectAllRequestsToPropertyValidator(properties).assertSuccess(), { HostName: cdk.stringToCloudFormation(properties.hostName), Protocol: cdk.stringToCloudFormation(properties.protocol) }) : properties;
    }
    function CfnBucketRedirectAllRequestsToPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("hostName", "HostName", cfn_parse.FromCloudFormation.getString(properties.HostName)), ret.addPropertyResult("protocol", "Protocol", properties.Protocol != null ? cfn_parse.FromCloudFormation.getString(properties.Protocol) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_RedirectRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("hostName", cdk.validateString)(properties.hostName)), errors.collect(cdk.propertyValidator("httpRedirectCode", cdk.validateString)(properties.httpRedirectCode)), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.collect(cdk.propertyValidator("replaceKeyPrefixWith", cdk.validateString)(properties.replaceKeyPrefixWith)), errors.collect(cdk.propertyValidator("replaceKeyWith", cdk.validateString)(properties.replaceKeyWith)), errors.wrap('supplied properties not correct for "RedirectRuleProperty"');
    }
    function cfnBucketRedirectRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_RedirectRulePropertyValidator(properties).assertSuccess(), { HostName: cdk.stringToCloudFormation(properties.hostName), HttpRedirectCode: cdk.stringToCloudFormation(properties.httpRedirectCode), Protocol: cdk.stringToCloudFormation(properties.protocol), ReplaceKeyPrefixWith: cdk.stringToCloudFormation(properties.replaceKeyPrefixWith), ReplaceKeyWith: cdk.stringToCloudFormation(properties.replaceKeyWith) }) : properties;
    }
    function CfnBucketRedirectRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("hostName", "HostName", properties.HostName != null ? cfn_parse.FromCloudFormation.getString(properties.HostName) : void 0), ret.addPropertyResult("httpRedirectCode", "HttpRedirectCode", properties.HttpRedirectCode != null ? cfn_parse.FromCloudFormation.getString(properties.HttpRedirectCode) : void 0), ret.addPropertyResult("protocol", "Protocol", properties.Protocol != null ? cfn_parse.FromCloudFormation.getString(properties.Protocol) : void 0), ret.addPropertyResult("replaceKeyPrefixWith", "ReplaceKeyPrefixWith", properties.ReplaceKeyPrefixWith != null ? cfn_parse.FromCloudFormation.getString(properties.ReplaceKeyPrefixWith) : void 0), ret.addPropertyResult("replaceKeyWith", "ReplaceKeyWith", properties.ReplaceKeyWith != null ? cfn_parse.FromCloudFormation.getString(properties.ReplaceKeyWith) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_ReplicaModificationsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("status", cdk.requiredValidator)(properties.status)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "ReplicaModificationsProperty"');
    }
    function cfnBucketReplicaModificationsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_ReplicaModificationsPropertyValidator(properties).assertSuccess(), { Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnBucketReplicaModificationsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("status", "Status", cfn_parse.FromCloudFormation.getString(properties.Status)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_ReplicationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("role", cdk.requiredValidator)(properties.role)), errors.collect(cdk.propertyValidator("role", cdk.validateString)(properties.role)), errors.collect(cdk.propertyValidator("rules", cdk.requiredValidator)(properties.rules)), errors.collect(cdk.propertyValidator("rules", cdk.listValidator(CfnBucket_ReplicationRulePropertyValidator))(properties.rules)), errors.wrap('supplied properties not correct for "ReplicationConfigurationProperty"');
    }
    function cfnBucketReplicationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_ReplicationConfigurationPropertyValidator(properties).assertSuccess(), { Role: cdk.stringToCloudFormation(properties.role), Rules: cdk.listMapper(cfnBucketReplicationRulePropertyToCloudFormation)(properties.rules) }) : properties;
    }
    function CfnBucketReplicationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("role", "Role", cfn_parse.FromCloudFormation.getString(properties.Role)), ret.addPropertyResult("rules", "Rules", cfn_parse.FromCloudFormation.getArray(CfnBucketReplicationRulePropertyFromCloudFormation)(properties.Rules)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_ReplicationDestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessControlTranslation", CfnBucket_AccessControlTranslationPropertyValidator)(properties.accessControlTranslation)), errors.collect(cdk.propertyValidator("account", cdk.validateString)(properties.account)), errors.collect(cdk.propertyValidator("bucket", cdk.requiredValidator)(properties.bucket)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("encryptionConfiguration", CfnBucket_EncryptionConfigurationPropertyValidator)(properties.encryptionConfiguration)), errors.collect(cdk.propertyValidator("metrics", CfnBucket_MetricsPropertyValidator)(properties.metrics)), errors.collect(cdk.propertyValidator("replicationTime", CfnBucket_ReplicationTimePropertyValidator)(properties.replicationTime)), errors.collect(cdk.propertyValidator("storageClass", cdk.validateString)(properties.storageClass)), errors.wrap('supplied properties not correct for "ReplicationDestinationProperty"');
    }
    function cfnBucketReplicationDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_ReplicationDestinationPropertyValidator(properties).assertSuccess(), { AccessControlTranslation: cfnBucketAccessControlTranslationPropertyToCloudFormation(properties.accessControlTranslation), Account: cdk.stringToCloudFormation(properties.account), Bucket: cdk.stringToCloudFormation(properties.bucket), EncryptionConfiguration: cfnBucketEncryptionConfigurationPropertyToCloudFormation(properties.encryptionConfiguration), Metrics: cfnBucketMetricsPropertyToCloudFormation(properties.metrics), ReplicationTime: cfnBucketReplicationTimePropertyToCloudFormation(properties.replicationTime), StorageClass: cdk.stringToCloudFormation(properties.storageClass) }) : properties;
    }
    function CfnBucketReplicationDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessControlTranslation", "AccessControlTranslation", properties.AccessControlTranslation != null ? CfnBucketAccessControlTranslationPropertyFromCloudFormation(properties.AccessControlTranslation) : void 0), ret.addPropertyResult("account", "Account", properties.Account != null ? cfn_parse.FromCloudFormation.getString(properties.Account) : void 0), ret.addPropertyResult("bucket", "Bucket", cfn_parse.FromCloudFormation.getString(properties.Bucket)), ret.addPropertyResult("encryptionConfiguration", "EncryptionConfiguration", properties.EncryptionConfiguration != null ? CfnBucketEncryptionConfigurationPropertyFromCloudFormation(properties.EncryptionConfiguration) : void 0), ret.addPropertyResult("metrics", "Metrics", properties.Metrics != null ? CfnBucketMetricsPropertyFromCloudFormation(properties.Metrics) : void 0), ret.addPropertyResult("replicationTime", "ReplicationTime", properties.ReplicationTime != null ? CfnBucketReplicationTimePropertyFromCloudFormation(properties.ReplicationTime) : void 0), ret.addPropertyResult("storageClass", "StorageClass", properties.StorageClass != null ? cfn_parse.FromCloudFormation.getString(properties.StorageClass) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_ReplicationRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deleteMarkerReplication", CfnBucket_DeleteMarkerReplicationPropertyValidator)(properties.deleteMarkerReplication)), errors.collect(cdk.propertyValidator("destination", cdk.requiredValidator)(properties.destination)), errors.collect(cdk.propertyValidator("destination", CfnBucket_ReplicationDestinationPropertyValidator)(properties.destination)), errors.collect(cdk.propertyValidator("filter", CfnBucket_ReplicationRuleFilterPropertyValidator)(properties.filter)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.collect(cdk.propertyValidator("priority", cdk.validateNumber)(properties.priority)), errors.collect(cdk.propertyValidator("sourceSelectionCriteria", CfnBucket_SourceSelectionCriteriaPropertyValidator)(properties.sourceSelectionCriteria)), errors.collect(cdk.propertyValidator("status", cdk.requiredValidator)(properties.status)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "ReplicationRuleProperty"');
    }
    function cfnBucketReplicationRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_ReplicationRulePropertyValidator(properties).assertSuccess(), { DeleteMarkerReplication: cfnBucketDeleteMarkerReplicationPropertyToCloudFormation(properties.deleteMarkerReplication), Destination: cfnBucketReplicationDestinationPropertyToCloudFormation(properties.destination), Filter: cfnBucketReplicationRuleFilterPropertyToCloudFormation(properties.filter), Id: cdk.stringToCloudFormation(properties.id), Prefix: cdk.stringToCloudFormation(properties.prefix), Priority: cdk.numberToCloudFormation(properties.priority), SourceSelectionCriteria: cfnBucketSourceSelectionCriteriaPropertyToCloudFormation(properties.sourceSelectionCriteria), Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnBucketReplicationRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deleteMarkerReplication", "DeleteMarkerReplication", properties.DeleteMarkerReplication != null ? CfnBucketDeleteMarkerReplicationPropertyFromCloudFormation(properties.DeleteMarkerReplication) : void 0), ret.addPropertyResult("destination", "Destination", CfnBucketReplicationDestinationPropertyFromCloudFormation(properties.Destination)), ret.addPropertyResult("filter", "Filter", properties.Filter != null ? CfnBucketReplicationRuleFilterPropertyFromCloudFormation(properties.Filter) : void 0), ret.addPropertyResult("id", "Id", properties.Id != null ? cfn_parse.FromCloudFormation.getString(properties.Id) : void 0), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addPropertyResult("priority", "Priority", properties.Priority != null ? cfn_parse.FromCloudFormation.getNumber(properties.Priority) : void 0), ret.addPropertyResult("sourceSelectionCriteria", "SourceSelectionCriteria", properties.SourceSelectionCriteria != null ? CfnBucketSourceSelectionCriteriaPropertyFromCloudFormation(properties.SourceSelectionCriteria) : void 0), ret.addPropertyResult("status", "Status", cfn_parse.FromCloudFormation.getString(properties.Status)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_ReplicationRuleAndOperatorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.collect(cdk.propertyValidator("tagFilters", cdk.listValidator(CfnBucket_TagFilterPropertyValidator))(properties.tagFilters)), errors.wrap('supplied properties not correct for "ReplicationRuleAndOperatorProperty"');
    }
    function cfnBucketReplicationRuleAndOperatorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_ReplicationRuleAndOperatorPropertyValidator(properties).assertSuccess(), { Prefix: cdk.stringToCloudFormation(properties.prefix), TagFilters: cdk.listMapper(cfnBucketTagFilterPropertyToCloudFormation)(properties.tagFilters) }) : properties;
    }
    function CfnBucketReplicationRuleAndOperatorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addPropertyResult("tagFilters", "TagFilters", properties.TagFilters != null ? cfn_parse.FromCloudFormation.getArray(CfnBucketTagFilterPropertyFromCloudFormation)(properties.TagFilters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_ReplicationRuleFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("and", CfnBucket_ReplicationRuleAndOperatorPropertyValidator)(properties.and)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.collect(cdk.propertyValidator("tagFilter", CfnBucket_TagFilterPropertyValidator)(properties.tagFilter)), errors.wrap('supplied properties not correct for "ReplicationRuleFilterProperty"');
    }
    function cfnBucketReplicationRuleFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_ReplicationRuleFilterPropertyValidator(properties).assertSuccess(), { And: cfnBucketReplicationRuleAndOperatorPropertyToCloudFormation(properties.and), Prefix: cdk.stringToCloudFormation(properties.prefix), TagFilter: cfnBucketTagFilterPropertyToCloudFormation(properties.tagFilter) }) : properties;
    }
    function CfnBucketReplicationRuleFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("and", "And", properties.And != null ? CfnBucketReplicationRuleAndOperatorPropertyFromCloudFormation(properties.And) : void 0), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addPropertyResult("tagFilter", "TagFilter", properties.TagFilter != null ? CfnBucketTagFilterPropertyFromCloudFormation(properties.TagFilter) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_ReplicationTimePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("status", cdk.requiredValidator)(properties.status)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.collect(cdk.propertyValidator("time", cdk.requiredValidator)(properties.time)), errors.collect(cdk.propertyValidator("time", CfnBucket_ReplicationTimeValuePropertyValidator)(properties.time)), errors.wrap('supplied properties not correct for "ReplicationTimeProperty"');
    }
    function cfnBucketReplicationTimePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_ReplicationTimePropertyValidator(properties).assertSuccess(), { Status: cdk.stringToCloudFormation(properties.status), Time: cfnBucketReplicationTimeValuePropertyToCloudFormation(properties.time) }) : properties;
    }
    function CfnBucketReplicationTimePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("status", "Status", cfn_parse.FromCloudFormation.getString(properties.Status)), ret.addPropertyResult("time", "Time", CfnBucketReplicationTimeValuePropertyFromCloudFormation(properties.Time)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_ReplicationTimeValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("minutes", cdk.requiredValidator)(properties.minutes)), errors.collect(cdk.propertyValidator("minutes", cdk.validateNumber)(properties.minutes)), errors.wrap('supplied properties not correct for "ReplicationTimeValueProperty"');
    }
    function cfnBucketReplicationTimeValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_ReplicationTimeValuePropertyValidator(properties).assertSuccess(), { Minutes: cdk.numberToCloudFormation(properties.minutes) }) : properties;
    }
    function CfnBucketReplicationTimeValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("minutes", "Minutes", cfn_parse.FromCloudFormation.getNumber(properties.Minutes)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_RoutingRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("redirectRule", cdk.requiredValidator)(properties.redirectRule)), errors.collect(cdk.propertyValidator("redirectRule", CfnBucket_RedirectRulePropertyValidator)(properties.redirectRule)), errors.collect(cdk.propertyValidator("routingRuleCondition", CfnBucket_RoutingRuleConditionPropertyValidator)(properties.routingRuleCondition)), errors.wrap('supplied properties not correct for "RoutingRuleProperty"');
    }
    function cfnBucketRoutingRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_RoutingRulePropertyValidator(properties).assertSuccess(), { RedirectRule: cfnBucketRedirectRulePropertyToCloudFormation(properties.redirectRule), RoutingRuleCondition: cfnBucketRoutingRuleConditionPropertyToCloudFormation(properties.routingRuleCondition) }) : properties;
    }
    function CfnBucketRoutingRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("redirectRule", "RedirectRule", CfnBucketRedirectRulePropertyFromCloudFormation(properties.RedirectRule)), ret.addPropertyResult("routingRuleCondition", "RoutingRuleCondition", properties.RoutingRuleCondition != null ? CfnBucketRoutingRuleConditionPropertyFromCloudFormation(properties.RoutingRuleCondition) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_RoutingRuleConditionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("httpErrorCodeReturnedEquals", cdk.validateString)(properties.httpErrorCodeReturnedEquals)), errors.collect(cdk.propertyValidator("keyPrefixEquals", cdk.validateString)(properties.keyPrefixEquals)), errors.wrap('supplied properties not correct for "RoutingRuleConditionProperty"');
    }
    function cfnBucketRoutingRuleConditionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_RoutingRuleConditionPropertyValidator(properties).assertSuccess(), { HttpErrorCodeReturnedEquals: cdk.stringToCloudFormation(properties.httpErrorCodeReturnedEquals), KeyPrefixEquals: cdk.stringToCloudFormation(properties.keyPrefixEquals) }) : properties;
    }
    function CfnBucketRoutingRuleConditionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("httpErrorCodeReturnedEquals", "HttpErrorCodeReturnedEquals", properties.HttpErrorCodeReturnedEquals != null ? cfn_parse.FromCloudFormation.getString(properties.HttpErrorCodeReturnedEquals) : void 0), ret.addPropertyResult("keyPrefixEquals", "KeyPrefixEquals", properties.KeyPrefixEquals != null ? cfn_parse.FromCloudFormation.getString(properties.KeyPrefixEquals) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_RulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("abortIncompleteMultipartUpload", CfnBucket_AbortIncompleteMultipartUploadPropertyValidator)(properties.abortIncompleteMultipartUpload)), errors.collect(cdk.propertyValidator("expirationDate", cdk.validateDate)(properties.expirationDate)), errors.collect(cdk.propertyValidator("expirationInDays", cdk.validateNumber)(properties.expirationInDays)), errors.collect(cdk.propertyValidator("expiredObjectDeleteMarker", cdk.validateBoolean)(properties.expiredObjectDeleteMarker)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("noncurrentVersionExpiration", CfnBucket_NoncurrentVersionExpirationPropertyValidator)(properties.noncurrentVersionExpiration)), errors.collect(cdk.propertyValidator("noncurrentVersionExpirationInDays", cdk.validateNumber)(properties.noncurrentVersionExpirationInDays)), errors.collect(cdk.propertyValidator("noncurrentVersionTransition", CfnBucket_NoncurrentVersionTransitionPropertyValidator)(properties.noncurrentVersionTransition)), errors.collect(cdk.propertyValidator("noncurrentVersionTransitions", cdk.listValidator(CfnBucket_NoncurrentVersionTransitionPropertyValidator))(properties.noncurrentVersionTransitions)), errors.collect(cdk.propertyValidator("objectSizeGreaterThan", cdk.validateNumber)(properties.objectSizeGreaterThan)), errors.collect(cdk.propertyValidator("objectSizeLessThan", cdk.validateNumber)(properties.objectSizeLessThan)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.collect(cdk.propertyValidator("status", cdk.requiredValidator)(properties.status)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.collect(cdk.propertyValidator("tagFilters", cdk.listValidator(CfnBucket_TagFilterPropertyValidator))(properties.tagFilters)), errors.collect(cdk.propertyValidator("transition", CfnBucket_TransitionPropertyValidator)(properties.transition)), errors.collect(cdk.propertyValidator("transitions", cdk.listValidator(CfnBucket_TransitionPropertyValidator))(properties.transitions)), errors.wrap('supplied properties not correct for "RuleProperty"');
    }
    function cfnBucketRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_RulePropertyValidator(properties).assertSuccess(), { AbortIncompleteMultipartUpload: cfnBucketAbortIncompleteMultipartUploadPropertyToCloudFormation(properties.abortIncompleteMultipartUpload), ExpirationDate: cdk.dateToCloudFormation(properties.expirationDate), ExpirationInDays: cdk.numberToCloudFormation(properties.expirationInDays), ExpiredObjectDeleteMarker: cdk.booleanToCloudFormation(properties.expiredObjectDeleteMarker), Id: cdk.stringToCloudFormation(properties.id), NoncurrentVersionExpiration: cfnBucketNoncurrentVersionExpirationPropertyToCloudFormation(properties.noncurrentVersionExpiration), NoncurrentVersionExpirationInDays: cdk.numberToCloudFormation(properties.noncurrentVersionExpirationInDays), NoncurrentVersionTransition: cfnBucketNoncurrentVersionTransitionPropertyToCloudFormation(properties.noncurrentVersionTransition), NoncurrentVersionTransitions: cdk.listMapper(cfnBucketNoncurrentVersionTransitionPropertyToCloudFormation)(properties.noncurrentVersionTransitions), ObjectSizeGreaterThan: cdk.numberToCloudFormation(properties.objectSizeGreaterThan), ObjectSizeLessThan: cdk.numberToCloudFormation(properties.objectSizeLessThan), Prefix: cdk.stringToCloudFormation(properties.prefix), Status: cdk.stringToCloudFormation(properties.status), TagFilters: cdk.listMapper(cfnBucketTagFilterPropertyToCloudFormation)(properties.tagFilters), Transition: cfnBucketTransitionPropertyToCloudFormation(properties.transition), Transitions: cdk.listMapper(cfnBucketTransitionPropertyToCloudFormation)(properties.transitions) }) : properties;
    }
    function CfnBucketRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("abortIncompleteMultipartUpload", "AbortIncompleteMultipartUpload", properties.AbortIncompleteMultipartUpload != null ? CfnBucketAbortIncompleteMultipartUploadPropertyFromCloudFormation(properties.AbortIncompleteMultipartUpload) : void 0), ret.addPropertyResult("expirationDate", "ExpirationDate", properties.ExpirationDate != null ? cfn_parse.FromCloudFormation.getDate(properties.ExpirationDate) : void 0), ret.addPropertyResult("expirationInDays", "ExpirationInDays", properties.ExpirationInDays != null ? cfn_parse.FromCloudFormation.getNumber(properties.ExpirationInDays) : void 0), ret.addPropertyResult("expiredObjectDeleteMarker", "ExpiredObjectDeleteMarker", properties.ExpiredObjectDeleteMarker != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ExpiredObjectDeleteMarker) : void 0), ret.addPropertyResult("id", "Id", properties.Id != null ? cfn_parse.FromCloudFormation.getString(properties.Id) : void 0), ret.addPropertyResult("noncurrentVersionExpiration", "NoncurrentVersionExpiration", properties.NoncurrentVersionExpiration != null ? CfnBucketNoncurrentVersionExpirationPropertyFromCloudFormation(properties.NoncurrentVersionExpiration) : void 0), ret.addPropertyResult("noncurrentVersionExpirationInDays", "NoncurrentVersionExpirationInDays", properties.NoncurrentVersionExpirationInDays != null ? cfn_parse.FromCloudFormation.getNumber(properties.NoncurrentVersionExpirationInDays) : void 0), ret.addPropertyResult("noncurrentVersionTransition", "NoncurrentVersionTransition", properties.NoncurrentVersionTransition != null ? CfnBucketNoncurrentVersionTransitionPropertyFromCloudFormation(properties.NoncurrentVersionTransition) : void 0), ret.addPropertyResult("noncurrentVersionTransitions", "NoncurrentVersionTransitions", properties.NoncurrentVersionTransitions != null ? cfn_parse.FromCloudFormation.getArray(CfnBucketNoncurrentVersionTransitionPropertyFromCloudFormation)(properties.NoncurrentVersionTransitions) : void 0), ret.addPropertyResult("objectSizeGreaterThan", "ObjectSizeGreaterThan", properties.ObjectSizeGreaterThan != null ? cfn_parse.FromCloudFormation.getNumber(properties.ObjectSizeGreaterThan) : void 0), ret.addPropertyResult("objectSizeLessThan", "ObjectSizeLessThan", properties.ObjectSizeLessThan != null ? cfn_parse.FromCloudFormation.getNumber(properties.ObjectSizeLessThan) : void 0), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addPropertyResult("status", "Status", cfn_parse.FromCloudFormation.getString(properties.Status)), ret.addPropertyResult("tagFilters", "TagFilters", properties.TagFilters != null ? cfn_parse.FromCloudFormation.getArray(CfnBucketTagFilterPropertyFromCloudFormation)(properties.TagFilters) : void 0), ret.addPropertyResult("transition", "Transition", properties.Transition != null ? CfnBucketTransitionPropertyFromCloudFormation(properties.Transition) : void 0), ret.addPropertyResult("transitions", "Transitions", properties.Transitions != null ? cfn_parse.FromCloudFormation.getArray(CfnBucketTransitionPropertyFromCloudFormation)(properties.Transitions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_S3KeyFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("rules", cdk.requiredValidator)(properties.rules)), errors.collect(cdk.propertyValidator("rules", cdk.listValidator(CfnBucket_FilterRulePropertyValidator))(properties.rules)), errors.wrap('supplied properties not correct for "S3KeyFilterProperty"');
    }
    function cfnBucketS3KeyFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_S3KeyFilterPropertyValidator(properties).assertSuccess(), { Rules: cdk.listMapper(cfnBucketFilterRulePropertyToCloudFormation)(properties.rules) }) : properties;
    }
    function CfnBucketS3KeyFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("rules", "Rules", cfn_parse.FromCloudFormation.getArray(CfnBucketFilterRulePropertyFromCloudFormation)(properties.Rules)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_ServerSideEncryptionByDefaultPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kmsMasterKeyId", cdk.validateString)(properties.kmsMasterKeyId)), errors.collect(cdk.propertyValidator("sseAlgorithm", cdk.requiredValidator)(properties.sseAlgorithm)), errors.collect(cdk.propertyValidator("sseAlgorithm", cdk.validateString)(properties.sseAlgorithm)), errors.wrap('supplied properties not correct for "ServerSideEncryptionByDefaultProperty"');
    }
    function cfnBucketServerSideEncryptionByDefaultPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_ServerSideEncryptionByDefaultPropertyValidator(properties).assertSuccess(), { KMSMasterKeyID: cdk.stringToCloudFormation(properties.kmsMasterKeyId), SSEAlgorithm: cdk.stringToCloudFormation(properties.sseAlgorithm) }) : properties;
    }
    function CfnBucketServerSideEncryptionByDefaultPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsMasterKeyId", "KMSMasterKeyID", properties.KMSMasterKeyID != null ? cfn_parse.FromCloudFormation.getString(properties.KMSMasterKeyID) : void 0), ret.addPropertyResult("sseAlgorithm", "SSEAlgorithm", cfn_parse.FromCloudFormation.getString(properties.SSEAlgorithm)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_ServerSideEncryptionRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketKeyEnabled", cdk.validateBoolean)(properties.bucketKeyEnabled)), errors.collect(cdk.propertyValidator("serverSideEncryptionByDefault", CfnBucket_ServerSideEncryptionByDefaultPropertyValidator)(properties.serverSideEncryptionByDefault)), errors.wrap('supplied properties not correct for "ServerSideEncryptionRuleProperty"');
    }
    function cfnBucketServerSideEncryptionRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_ServerSideEncryptionRulePropertyValidator(properties).assertSuccess(), { BucketKeyEnabled: cdk.booleanToCloudFormation(properties.bucketKeyEnabled), ServerSideEncryptionByDefault: cfnBucketServerSideEncryptionByDefaultPropertyToCloudFormation(properties.serverSideEncryptionByDefault) }) : properties;
    }
    function CfnBucketServerSideEncryptionRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketKeyEnabled", "BucketKeyEnabled", properties.BucketKeyEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.BucketKeyEnabled) : void 0), ret.addPropertyResult("serverSideEncryptionByDefault", "ServerSideEncryptionByDefault", properties.ServerSideEncryptionByDefault != null ? CfnBucketServerSideEncryptionByDefaultPropertyFromCloudFormation(properties.ServerSideEncryptionByDefault) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_SourceSelectionCriteriaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("replicaModifications", CfnBucket_ReplicaModificationsPropertyValidator)(properties.replicaModifications)), errors.collect(cdk.propertyValidator("sseKmsEncryptedObjects", CfnBucket_SseKmsEncryptedObjectsPropertyValidator)(properties.sseKmsEncryptedObjects)), errors.wrap('supplied properties not correct for "SourceSelectionCriteriaProperty"');
    }
    function cfnBucketSourceSelectionCriteriaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_SourceSelectionCriteriaPropertyValidator(properties).assertSuccess(), { ReplicaModifications: cfnBucketReplicaModificationsPropertyToCloudFormation(properties.replicaModifications), SseKmsEncryptedObjects: cfnBucketSseKmsEncryptedObjectsPropertyToCloudFormation(properties.sseKmsEncryptedObjects) }) : properties;
    }
    function CfnBucketSourceSelectionCriteriaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("replicaModifications", "ReplicaModifications", properties.ReplicaModifications != null ? CfnBucketReplicaModificationsPropertyFromCloudFormation(properties.ReplicaModifications) : void 0), ret.addPropertyResult("sseKmsEncryptedObjects", "SseKmsEncryptedObjects", properties.SseKmsEncryptedObjects != null ? CfnBucketSseKmsEncryptedObjectsPropertyFromCloudFormation(properties.SseKmsEncryptedObjects) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_SseKmsEncryptedObjectsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("status", cdk.requiredValidator)(properties.status)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "SseKmsEncryptedObjectsProperty"');
    }
    function cfnBucketSseKmsEncryptedObjectsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_SseKmsEncryptedObjectsPropertyValidator(properties).assertSuccess(), { Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnBucketSseKmsEncryptedObjectsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("status", "Status", cfn_parse.FromCloudFormation.getString(properties.Status)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_StorageClassAnalysisPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataExport", CfnBucket_DataExportPropertyValidator)(properties.dataExport)), errors.wrap('supplied properties not correct for "StorageClassAnalysisProperty"');
    }
    function cfnBucketStorageClassAnalysisPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_StorageClassAnalysisPropertyValidator(properties).assertSuccess(), { DataExport: cfnBucketDataExportPropertyToCloudFormation(properties.dataExport) }) : properties;
    }
    function CfnBucketStorageClassAnalysisPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataExport", "DataExport", properties.DataExport != null ? CfnBucketDataExportPropertyFromCloudFormation(properties.DataExport) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_TagFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TagFilterProperty"');
    }
    function cfnBucketTagFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_TagFilterPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnBucketTagFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_TieringPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessTier", cdk.requiredValidator)(properties.accessTier)), errors.collect(cdk.propertyValidator("accessTier", cdk.validateString)(properties.accessTier)), errors.collect(cdk.propertyValidator("days", cdk.requiredValidator)(properties.days)), errors.collect(cdk.propertyValidator("days", cdk.validateNumber)(properties.days)), errors.wrap('supplied properties not correct for "TieringProperty"');
    }
    function cfnBucketTieringPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_TieringPropertyValidator(properties).assertSuccess(), { AccessTier: cdk.stringToCloudFormation(properties.accessTier), Days: cdk.numberToCloudFormation(properties.days) }) : properties;
    }
    function CfnBucketTieringPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessTier", "AccessTier", cfn_parse.FromCloudFormation.getString(properties.AccessTier)), ret.addPropertyResult("days", "Days", cfn_parse.FromCloudFormation.getNumber(properties.Days)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_TopicConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("event", cdk.requiredValidator)(properties.event)), errors.collect(cdk.propertyValidator("event", cdk.validateString)(properties.event)), errors.collect(cdk.propertyValidator("filter", CfnBucket_NotificationFilterPropertyValidator)(properties.filter)), errors.collect(cdk.propertyValidator("topic", cdk.requiredValidator)(properties.topic)), errors.collect(cdk.propertyValidator("topic", cdk.validateString)(properties.topic)), errors.wrap('supplied properties not correct for "TopicConfigurationProperty"');
    }
    function cfnBucketTopicConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_TopicConfigurationPropertyValidator(properties).assertSuccess(), { Event: cdk.stringToCloudFormation(properties.event), Filter: cfnBucketNotificationFilterPropertyToCloudFormation(properties.filter), Topic: cdk.stringToCloudFormation(properties.topic) }) : properties;
    }
    function CfnBucketTopicConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("event", "Event", cfn_parse.FromCloudFormation.getString(properties.Event)), ret.addPropertyResult("filter", "Filter", properties.Filter != null ? CfnBucketNotificationFilterPropertyFromCloudFormation(properties.Filter) : void 0), ret.addPropertyResult("topic", "Topic", cfn_parse.FromCloudFormation.getString(properties.Topic)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_TransitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("storageClass", cdk.requiredValidator)(properties.storageClass)), errors.collect(cdk.propertyValidator("storageClass", cdk.validateString)(properties.storageClass)), errors.collect(cdk.propertyValidator("transitionDate", cdk.validateDate)(properties.transitionDate)), errors.collect(cdk.propertyValidator("transitionInDays", cdk.validateNumber)(properties.transitionInDays)), errors.wrap('supplied properties not correct for "TransitionProperty"');
    }
    function cfnBucketTransitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_TransitionPropertyValidator(properties).assertSuccess(), { StorageClass: cdk.stringToCloudFormation(properties.storageClass), TransitionDate: cdk.dateToCloudFormation(properties.transitionDate), TransitionInDays: cdk.numberToCloudFormation(properties.transitionInDays) }) : properties;
    }
    function CfnBucketTransitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("storageClass", "StorageClass", cfn_parse.FromCloudFormation.getString(properties.StorageClass)), ret.addPropertyResult("transitionDate", "TransitionDate", properties.TransitionDate != null ? cfn_parse.FromCloudFormation.getDate(properties.TransitionDate) : void 0), ret.addPropertyResult("transitionInDays", "TransitionInDays", properties.TransitionInDays != null ? cfn_parse.FromCloudFormation.getNumber(properties.TransitionInDays) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_VersioningConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("status", cdk.requiredValidator)(properties.status)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "VersioningConfigurationProperty"');
    }
    function cfnBucketVersioningConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_VersioningConfigurationPropertyValidator(properties).assertSuccess(), { Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnBucketVersioningConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("status", "Status", cfn_parse.FromCloudFormation.getString(properties.Status)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_WebsiteConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("errorDocument", cdk.validateString)(properties.errorDocument)), errors.collect(cdk.propertyValidator("indexDocument", cdk.validateString)(properties.indexDocument)), errors.collect(cdk.propertyValidator("redirectAllRequestsTo", CfnBucket_RedirectAllRequestsToPropertyValidator)(properties.redirectAllRequestsTo)), errors.collect(cdk.propertyValidator("routingRules", cdk.listValidator(CfnBucket_RoutingRulePropertyValidator))(properties.routingRules)), errors.wrap('supplied properties not correct for "WebsiteConfigurationProperty"');
    }
    function cfnBucketWebsiteConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_WebsiteConfigurationPropertyValidator(properties).assertSuccess(), { ErrorDocument: cdk.stringToCloudFormation(properties.errorDocument), IndexDocument: cdk.stringToCloudFormation(properties.indexDocument), RedirectAllRequestsTo: cfnBucketRedirectAllRequestsToPropertyToCloudFormation(properties.redirectAllRequestsTo), RoutingRules: cdk.listMapper(cfnBucketRoutingRulePropertyToCloudFormation)(properties.routingRules) }) : properties;
    }
    function CfnBucketWebsiteConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("errorDocument", "ErrorDocument", properties.ErrorDocument != null ? cfn_parse.FromCloudFormation.getString(properties.ErrorDocument) : void 0), ret.addPropertyResult("indexDocument", "IndexDocument", properties.IndexDocument != null ? cfn_parse.FromCloudFormation.getString(properties.IndexDocument) : void 0), ret.addPropertyResult("redirectAllRequestsTo", "RedirectAllRequestsTo", properties.RedirectAllRequestsTo != null ? CfnBucketRedirectAllRequestsToPropertyFromCloudFormation(properties.RedirectAllRequestsTo) : void 0), ret.addPropertyResult("routingRules", "RoutingRules", properties.RoutingRules != null ? cfn_parse.FromCloudFormation.getArray(CfnBucketRoutingRulePropertyFromCloudFormation)(properties.RoutingRules) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucketPolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.requiredValidator)(properties.bucket)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("policyDocument", cdk.requiredValidator)(properties.policyDocument)), errors.collect(cdk.propertyValidator("policyDocument", cdk.validateObject)(properties.policyDocument)), errors.wrap('supplied properties not correct for "CfnBucketPolicyProps"');
    }
    function cfnBucketPolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucketPolicyPropsValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), PolicyDocument: cdk.objectToCloudFormation(properties.policyDocument) }) : properties;
    }
    function CfnBucketPolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", cfn_parse.FromCloudFormation.getString(properties.Bucket)), ret.addPropertyResult("policyDocument", "PolicyDocument", cfn_parse.FromCloudFormation.getAny(properties.PolicyDocument)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnBucketPolicy = class _CfnBucketPolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnBucketPolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnBucketPolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnBucketPolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_CfnBucketPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnBucketPolicy), error;
        }
        cdk.requireProperty(props, "bucket", this), cdk.requireProperty(props, "policyDocument", this), this.bucket = props.bucket, this.policyDocument = props.policyDocument;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnBucketPolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { bucket: this.bucket, policyDocument: this.policyDocument };
      }
      renderProperties(props) {
        return cfnBucketPolicyPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnBucketPolicy[_c] = { fqn: "aws-cdk-lib.aws_s3.CfnBucketPolicy", version: "2.80.0" }, CfnBucketPolicy.CFN_RESOURCE_TYPE_NAME = "AWS::S3::BucketPolicy", exports2.CfnBucketPolicy = CfnBucketPolicy;
    function CfnMultiRegionAccessPointPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("publicAccessBlockConfiguration", CfnMultiRegionAccessPoint_PublicAccessBlockConfigurationPropertyValidator)(properties.publicAccessBlockConfiguration)), errors.collect(cdk.propertyValidator("regions", cdk.requiredValidator)(properties.regions)), errors.collect(cdk.propertyValidator("regions", cdk.listValidator(CfnMultiRegionAccessPoint_RegionPropertyValidator))(properties.regions)), errors.wrap('supplied properties not correct for "CfnMultiRegionAccessPointProps"');
    }
    function cfnMultiRegionAccessPointPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMultiRegionAccessPointPropsValidator(properties).assertSuccess(), { Regions: cdk.listMapper(cfnMultiRegionAccessPointRegionPropertyToCloudFormation)(properties.regions), Name: cdk.stringToCloudFormation(properties.name), PublicAccessBlockConfiguration: cfnMultiRegionAccessPointPublicAccessBlockConfigurationPropertyToCloudFormation(properties.publicAccessBlockConfiguration) }) : properties;
    }
    function CfnMultiRegionAccessPointPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("regions", "Regions", cfn_parse.FromCloudFormation.getArray(CfnMultiRegionAccessPointRegionPropertyFromCloudFormation)(properties.Regions)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("publicAccessBlockConfiguration", "PublicAccessBlockConfiguration", properties.PublicAccessBlockConfiguration != null ? CfnMultiRegionAccessPointPublicAccessBlockConfigurationPropertyFromCloudFormation(properties.PublicAccessBlockConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnMultiRegionAccessPoint = class _CfnMultiRegionAccessPoint extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnMultiRegionAccessPointPropsFromCloudFormation(resourceProperties), ret = new _CfnMultiRegionAccessPoint(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnMultiRegionAccessPoint.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_CfnMultiRegionAccessPointProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnMultiRegionAccessPoint), error;
        }
        cdk.requireProperty(props, "regions", this), this.attrAlias = cdk.Token.asString(this.getAtt("Alias", cdk.ResolutionTypeHint.STRING)), this.attrCreatedAt = cdk.Token.asString(this.getAtt("CreatedAt", cdk.ResolutionTypeHint.STRING)), this.regions = props.regions, this.name = props.name, this.publicAccessBlockConfiguration = props.publicAccessBlockConfiguration;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnMultiRegionAccessPoint.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { regions: this.regions, name: this.name, publicAccessBlockConfiguration: this.publicAccessBlockConfiguration };
      }
      renderProperties(props) {
        return cfnMultiRegionAccessPointPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnMultiRegionAccessPoint[_d] = { fqn: "aws-cdk-lib.aws_s3.CfnMultiRegionAccessPoint", version: "2.80.0" }, CfnMultiRegionAccessPoint.CFN_RESOURCE_TYPE_NAME = "AWS::S3::MultiRegionAccessPoint", exports2.CfnMultiRegionAccessPoint = CfnMultiRegionAccessPoint;
    function CfnMultiRegionAccessPoint_PublicAccessBlockConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("blockPublicAcls", cdk.validateBoolean)(properties.blockPublicAcls)), errors.collect(cdk.propertyValidator("blockPublicPolicy", cdk.validateBoolean)(properties.blockPublicPolicy)), errors.collect(cdk.propertyValidator("ignorePublicAcls", cdk.validateBoolean)(properties.ignorePublicAcls)), errors.collect(cdk.propertyValidator("restrictPublicBuckets", cdk.validateBoolean)(properties.restrictPublicBuckets)), errors.wrap('supplied properties not correct for "PublicAccessBlockConfigurationProperty"');
    }
    function cfnMultiRegionAccessPointPublicAccessBlockConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMultiRegionAccessPoint_PublicAccessBlockConfigurationPropertyValidator(properties).assertSuccess(), { BlockPublicAcls: cdk.booleanToCloudFormation(properties.blockPublicAcls), BlockPublicPolicy: cdk.booleanToCloudFormation(properties.blockPublicPolicy), IgnorePublicAcls: cdk.booleanToCloudFormation(properties.ignorePublicAcls), RestrictPublicBuckets: cdk.booleanToCloudFormation(properties.restrictPublicBuckets) }) : properties;
    }
    function CfnMultiRegionAccessPointPublicAccessBlockConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("blockPublicAcls", "BlockPublicAcls", properties.BlockPublicAcls != null ? cfn_parse.FromCloudFormation.getBoolean(properties.BlockPublicAcls) : void 0), ret.addPropertyResult("blockPublicPolicy", "BlockPublicPolicy", properties.BlockPublicPolicy != null ? cfn_parse.FromCloudFormation.getBoolean(properties.BlockPublicPolicy) : void 0), ret.addPropertyResult("ignorePublicAcls", "IgnorePublicAcls", properties.IgnorePublicAcls != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IgnorePublicAcls) : void 0), ret.addPropertyResult("restrictPublicBuckets", "RestrictPublicBuckets", properties.RestrictPublicBuckets != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RestrictPublicBuckets) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMultiRegionAccessPoint_RegionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.requiredValidator)(properties.bucket)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("bucketAccountId", cdk.validateString)(properties.bucketAccountId)), errors.wrap('supplied properties not correct for "RegionProperty"');
    }
    function cfnMultiRegionAccessPointRegionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMultiRegionAccessPoint_RegionPropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), BucketAccountId: cdk.stringToCloudFormation(properties.bucketAccountId) }) : properties;
    }
    function CfnMultiRegionAccessPointRegionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", cfn_parse.FromCloudFormation.getString(properties.Bucket)), ret.addPropertyResult("bucketAccountId", "BucketAccountId", properties.BucketAccountId != null ? cfn_parse.FromCloudFormation.getString(properties.BucketAccountId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMultiRegionAccessPointPolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mrapName", cdk.requiredValidator)(properties.mrapName)), errors.collect(cdk.propertyValidator("mrapName", cdk.validateString)(properties.mrapName)), errors.collect(cdk.propertyValidator("policy", cdk.requiredValidator)(properties.policy)), errors.collect(cdk.propertyValidator("policy", cdk.validateObject)(properties.policy)), errors.wrap('supplied properties not correct for "CfnMultiRegionAccessPointPolicyProps"');
    }
    function cfnMultiRegionAccessPointPolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMultiRegionAccessPointPolicyPropsValidator(properties).assertSuccess(), { MrapName: cdk.stringToCloudFormation(properties.mrapName), Policy: cdk.objectToCloudFormation(properties.policy) }) : properties;
    }
    function CfnMultiRegionAccessPointPolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mrapName", "MrapName", cfn_parse.FromCloudFormation.getString(properties.MrapName)), ret.addPropertyResult("policy", "Policy", cfn_parse.FromCloudFormation.getAny(properties.Policy)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnMultiRegionAccessPointPolicy = class _CfnMultiRegionAccessPointPolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnMultiRegionAccessPointPolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnMultiRegionAccessPointPolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnMultiRegionAccessPointPolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_CfnMultiRegionAccessPointPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnMultiRegionAccessPointPolicy), error;
        }
        cdk.requireProperty(props, "mrapName", this), cdk.requireProperty(props, "policy", this), this.attrPolicyStatusIsPublic = cdk.Token.asString(this.getAtt("PolicyStatus.IsPublic", cdk.ResolutionTypeHint.STRING)), this.mrapName = props.mrapName, this.policy = props.policy;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnMultiRegionAccessPointPolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { mrapName: this.mrapName, policy: this.policy };
      }
      renderProperties(props) {
        return cfnMultiRegionAccessPointPolicyPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnMultiRegionAccessPointPolicy[_e] = { fqn: "aws-cdk-lib.aws_s3.CfnMultiRegionAccessPointPolicy", version: "2.80.0" }, CfnMultiRegionAccessPointPolicy.CFN_RESOURCE_TYPE_NAME = "AWS::S3::MultiRegionAccessPointPolicy", exports2.CfnMultiRegionAccessPointPolicy = CfnMultiRegionAccessPointPolicy;
    function CfnStorageLensPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("storageLensConfiguration", cdk.requiredValidator)(properties.storageLensConfiguration)), errors.collect(cdk.propertyValidator("storageLensConfiguration", CfnStorageLens_StorageLensConfigurationPropertyValidator)(properties.storageLensConfiguration)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnStorageLensProps"');
    }
    function cfnStorageLensPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStorageLensPropsValidator(properties).assertSuccess(), { StorageLensConfiguration: cfnStorageLensStorageLensConfigurationPropertyToCloudFormation(properties.storageLensConfiguration), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnStorageLensPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("storageLensConfiguration", "StorageLensConfiguration", CfnStorageLensStorageLensConfigurationPropertyFromCloudFormation(properties.StorageLensConfiguration)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnStorageLens = class _CfnStorageLens extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnStorageLensPropsFromCloudFormation(resourceProperties), ret = new _CfnStorageLens(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnStorageLens.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_CfnStorageLensProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnStorageLens), error;
        }
        cdk.requireProperty(props, "storageLensConfiguration", this), this.attrStorageLensConfigurationStorageLensArn = cdk.Token.asString(this.getAtt("StorageLensConfiguration.StorageLensArn", cdk.ResolutionTypeHint.STRING)), this.storageLensConfiguration = props.storageLensConfiguration, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::S3::StorageLens", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStorageLens.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { storageLensConfiguration: this.storageLensConfiguration, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnStorageLensPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnStorageLens[_f] = { fqn: "aws-cdk-lib.aws_s3.CfnStorageLens", version: "2.80.0" }, CfnStorageLens.CFN_RESOURCE_TYPE_NAME = "AWS::S3::StorageLens", exports2.CfnStorageLens = CfnStorageLens;
    function CfnStorageLens_AccountLevelPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("activityMetrics", CfnStorageLens_ActivityMetricsPropertyValidator)(properties.activityMetrics)), errors.collect(cdk.propertyValidator("advancedCostOptimizationMetrics", CfnStorageLens_AdvancedCostOptimizationMetricsPropertyValidator)(properties.advancedCostOptimizationMetrics)), errors.collect(cdk.propertyValidator("advancedDataProtectionMetrics", CfnStorageLens_AdvancedDataProtectionMetricsPropertyValidator)(properties.advancedDataProtectionMetrics)), errors.collect(cdk.propertyValidator("bucketLevel", cdk.requiredValidator)(properties.bucketLevel)), errors.collect(cdk.propertyValidator("bucketLevel", CfnStorageLens_BucketLevelPropertyValidator)(properties.bucketLevel)), errors.collect(cdk.propertyValidator("detailedStatusCodesMetrics", CfnStorageLens_DetailedStatusCodesMetricsPropertyValidator)(properties.detailedStatusCodesMetrics)), errors.wrap('supplied properties not correct for "AccountLevelProperty"');
    }
    function cfnStorageLensAccountLevelPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStorageLens_AccountLevelPropertyValidator(properties).assertSuccess(), { ActivityMetrics: cfnStorageLensActivityMetricsPropertyToCloudFormation(properties.activityMetrics), AdvancedCostOptimizationMetrics: cfnStorageLensAdvancedCostOptimizationMetricsPropertyToCloudFormation(properties.advancedCostOptimizationMetrics), AdvancedDataProtectionMetrics: cfnStorageLensAdvancedDataProtectionMetricsPropertyToCloudFormation(properties.advancedDataProtectionMetrics), BucketLevel: cfnStorageLensBucketLevelPropertyToCloudFormation(properties.bucketLevel), DetailedStatusCodesMetrics: cfnStorageLensDetailedStatusCodesMetricsPropertyToCloudFormation(properties.detailedStatusCodesMetrics) }) : properties;
    }
    function CfnStorageLensAccountLevelPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("activityMetrics", "ActivityMetrics", properties.ActivityMetrics != null ? CfnStorageLensActivityMetricsPropertyFromCloudFormation(properties.ActivityMetrics) : void 0), ret.addPropertyResult("advancedCostOptimizationMetrics", "AdvancedCostOptimizationMetrics", properties.AdvancedCostOptimizationMetrics != null ? CfnStorageLensAdvancedCostOptimizationMetricsPropertyFromCloudFormation(properties.AdvancedCostOptimizationMetrics) : void 0), ret.addPropertyResult("advancedDataProtectionMetrics", "AdvancedDataProtectionMetrics", properties.AdvancedDataProtectionMetrics != null ? CfnStorageLensAdvancedDataProtectionMetricsPropertyFromCloudFormation(properties.AdvancedDataProtectionMetrics) : void 0), ret.addPropertyResult("bucketLevel", "BucketLevel", CfnStorageLensBucketLevelPropertyFromCloudFormation(properties.BucketLevel)), ret.addPropertyResult("detailedStatusCodesMetrics", "DetailedStatusCodesMetrics", properties.DetailedStatusCodesMetrics != null ? CfnStorageLensDetailedStatusCodesMetricsPropertyFromCloudFormation(properties.DetailedStatusCodesMetrics) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStorageLens_ActivityMetricsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("isEnabled", cdk.validateBoolean)(properties.isEnabled)), errors.wrap('supplied properties not correct for "ActivityMetricsProperty"');
    }
    function cfnStorageLensActivityMetricsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStorageLens_ActivityMetricsPropertyValidator(properties).assertSuccess(), { IsEnabled: cdk.booleanToCloudFormation(properties.isEnabled) }) : properties;
    }
    function CfnStorageLensActivityMetricsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("isEnabled", "IsEnabled", properties.IsEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsEnabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStorageLens_AdvancedCostOptimizationMetricsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("isEnabled", cdk.validateBoolean)(properties.isEnabled)), errors.wrap('supplied properties not correct for "AdvancedCostOptimizationMetricsProperty"');
    }
    function cfnStorageLensAdvancedCostOptimizationMetricsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStorageLens_AdvancedCostOptimizationMetricsPropertyValidator(properties).assertSuccess(), { IsEnabled: cdk.booleanToCloudFormation(properties.isEnabled) }) : properties;
    }
    function CfnStorageLensAdvancedCostOptimizationMetricsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("isEnabled", "IsEnabled", properties.IsEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsEnabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStorageLens_AdvancedDataProtectionMetricsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("isEnabled", cdk.validateBoolean)(properties.isEnabled)), errors.wrap('supplied properties not correct for "AdvancedDataProtectionMetricsProperty"');
    }
    function cfnStorageLensAdvancedDataProtectionMetricsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStorageLens_AdvancedDataProtectionMetricsPropertyValidator(properties).assertSuccess(), { IsEnabled: cdk.booleanToCloudFormation(properties.isEnabled) }) : properties;
    }
    function CfnStorageLensAdvancedDataProtectionMetricsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("isEnabled", "IsEnabled", properties.IsEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsEnabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStorageLens_AwsOrgPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.requiredValidator)(properties.arn)), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.wrap('supplied properties not correct for "AwsOrgProperty"');
    }
    function cfnStorageLensAwsOrgPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStorageLens_AwsOrgPropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn) }) : properties;
    }
    function CfnStorageLensAwsOrgPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", cfn_parse.FromCloudFormation.getString(properties.Arn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStorageLens_BucketLevelPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("activityMetrics", CfnStorageLens_ActivityMetricsPropertyValidator)(properties.activityMetrics)), errors.collect(cdk.propertyValidator("advancedCostOptimizationMetrics", CfnStorageLens_AdvancedCostOptimizationMetricsPropertyValidator)(properties.advancedCostOptimizationMetrics)), errors.collect(cdk.propertyValidator("advancedDataProtectionMetrics", CfnStorageLens_AdvancedDataProtectionMetricsPropertyValidator)(properties.advancedDataProtectionMetrics)), errors.collect(cdk.propertyValidator("detailedStatusCodesMetrics", CfnStorageLens_DetailedStatusCodesMetricsPropertyValidator)(properties.detailedStatusCodesMetrics)), errors.collect(cdk.propertyValidator("prefixLevel", CfnStorageLens_PrefixLevelPropertyValidator)(properties.prefixLevel)), errors.wrap('supplied properties not correct for "BucketLevelProperty"');
    }
    function cfnStorageLensBucketLevelPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStorageLens_BucketLevelPropertyValidator(properties).assertSuccess(), { ActivityMetrics: cfnStorageLensActivityMetricsPropertyToCloudFormation(properties.activityMetrics), AdvancedCostOptimizationMetrics: cfnStorageLensAdvancedCostOptimizationMetricsPropertyToCloudFormation(properties.advancedCostOptimizationMetrics), AdvancedDataProtectionMetrics: cfnStorageLensAdvancedDataProtectionMetricsPropertyToCloudFormation(properties.advancedDataProtectionMetrics), DetailedStatusCodesMetrics: cfnStorageLensDetailedStatusCodesMetricsPropertyToCloudFormation(properties.detailedStatusCodesMetrics), PrefixLevel: cfnStorageLensPrefixLevelPropertyToCloudFormation(properties.prefixLevel) }) : properties;
    }
    function CfnStorageLensBucketLevelPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("activityMetrics", "ActivityMetrics", properties.ActivityMetrics != null ? CfnStorageLensActivityMetricsPropertyFromCloudFormation(properties.ActivityMetrics) : void 0), ret.addPropertyResult("advancedCostOptimizationMetrics", "AdvancedCostOptimizationMetrics", properties.AdvancedCostOptimizationMetrics != null ? CfnStorageLensAdvancedCostOptimizationMetricsPropertyFromCloudFormation(properties.AdvancedCostOptimizationMetrics) : void 0), ret.addPropertyResult("advancedDataProtectionMetrics", "AdvancedDataProtectionMetrics", properties.AdvancedDataProtectionMetrics != null ? CfnStorageLensAdvancedDataProtectionMetricsPropertyFromCloudFormation(properties.AdvancedDataProtectionMetrics) : void 0), ret.addPropertyResult("detailedStatusCodesMetrics", "DetailedStatusCodesMetrics", properties.DetailedStatusCodesMetrics != null ? CfnStorageLensDetailedStatusCodesMetricsPropertyFromCloudFormation(properties.DetailedStatusCodesMetrics) : void 0), ret.addPropertyResult("prefixLevel", "PrefixLevel", properties.PrefixLevel != null ? CfnStorageLensPrefixLevelPropertyFromCloudFormation(properties.PrefixLevel) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStorageLens_BucketsAndRegionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("buckets", cdk.listValidator(cdk.validateString))(properties.buckets)), errors.collect(cdk.propertyValidator("regions", cdk.listValidator(cdk.validateString))(properties.regions)), errors.wrap('supplied properties not correct for "BucketsAndRegionsProperty"');
    }
    function cfnStorageLensBucketsAndRegionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStorageLens_BucketsAndRegionsPropertyValidator(properties).assertSuccess(), { Buckets: cdk.listMapper(cdk.stringToCloudFormation)(properties.buckets), Regions: cdk.listMapper(cdk.stringToCloudFormation)(properties.regions) }) : properties;
    }
    function CfnStorageLensBucketsAndRegionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("buckets", "Buckets", properties.Buckets != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Buckets) : void 0), ret.addPropertyResult("regions", "Regions", properties.Regions != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Regions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStorageLens_CloudWatchMetricsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("isEnabled", cdk.requiredValidator)(properties.isEnabled)), errors.collect(cdk.propertyValidator("isEnabled", cdk.validateBoolean)(properties.isEnabled)), errors.wrap('supplied properties not correct for "CloudWatchMetricsProperty"');
    }
    function cfnStorageLensCloudWatchMetricsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStorageLens_CloudWatchMetricsPropertyValidator(properties).assertSuccess(), { IsEnabled: cdk.booleanToCloudFormation(properties.isEnabled) }) : properties;
    }
    function CfnStorageLensCloudWatchMetricsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("isEnabled", "IsEnabled", cfn_parse.FromCloudFormation.getBoolean(properties.IsEnabled)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStorageLens_DataExportPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchMetrics", CfnStorageLens_CloudWatchMetricsPropertyValidator)(properties.cloudWatchMetrics)), errors.collect(cdk.propertyValidator("s3BucketDestination", CfnStorageLens_S3BucketDestinationPropertyValidator)(properties.s3BucketDestination)), errors.wrap('supplied properties not correct for "DataExportProperty"');
    }
    function cfnStorageLensDataExportPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStorageLens_DataExportPropertyValidator(properties).assertSuccess(), { CloudWatchMetrics: cfnStorageLensCloudWatchMetricsPropertyToCloudFormation(properties.cloudWatchMetrics), S3BucketDestination: cfnStorageLensS3BucketDestinationPropertyToCloudFormation(properties.s3BucketDestination) }) : properties;
    }
    function CfnStorageLensDataExportPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchMetrics", "CloudWatchMetrics", properties.CloudWatchMetrics != null ? CfnStorageLensCloudWatchMetricsPropertyFromCloudFormation(properties.CloudWatchMetrics) : void 0), ret.addPropertyResult("s3BucketDestination", "S3BucketDestination", properties.S3BucketDestination != null ? CfnStorageLensS3BucketDestinationPropertyFromCloudFormation(properties.S3BucketDestination) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStorageLens_DetailedStatusCodesMetricsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("isEnabled", cdk.validateBoolean)(properties.isEnabled)), errors.wrap('supplied properties not correct for "DetailedStatusCodesMetricsProperty"');
    }
    function cfnStorageLensDetailedStatusCodesMetricsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStorageLens_DetailedStatusCodesMetricsPropertyValidator(properties).assertSuccess(), { IsEnabled: cdk.booleanToCloudFormation(properties.isEnabled) }) : properties;
    }
    function CfnStorageLensDetailedStatusCodesMetricsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("isEnabled", "IsEnabled", properties.IsEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsEnabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStorageLens_EncryptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ssekms", CfnStorageLens_SSEKMSPropertyValidator)(properties.ssekms)), errors.collect(cdk.propertyValidator("sses3", cdk.validateObject)(properties.sses3)), errors.wrap('supplied properties not correct for "EncryptionProperty"');
    }
    function cfnStorageLensEncryptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStorageLens_EncryptionPropertyValidator(properties).assertSuccess(), { SSEKMS: cfnStorageLensSSEKMSPropertyToCloudFormation(properties.ssekms), SSES3: cdk.objectToCloudFormation(properties.sses3) }) : properties;
    }
    function CfnStorageLensEncryptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ssekms", "SSEKMS", properties.SSEKMS != null ? CfnStorageLensSSEKMSPropertyFromCloudFormation(properties.SSEKMS) : void 0), ret.addPropertyResult("sses3", "SSES3", properties.SSES3 != null ? cfn_parse.FromCloudFormation.getAny(properties.SSES3) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStorageLens_PrefixLevelPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("storageMetrics", cdk.requiredValidator)(properties.storageMetrics)), errors.collect(cdk.propertyValidator("storageMetrics", CfnStorageLens_PrefixLevelStorageMetricsPropertyValidator)(properties.storageMetrics)), errors.wrap('supplied properties not correct for "PrefixLevelProperty"');
    }
    function cfnStorageLensPrefixLevelPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStorageLens_PrefixLevelPropertyValidator(properties).assertSuccess(), { StorageMetrics: cfnStorageLensPrefixLevelStorageMetricsPropertyToCloudFormation(properties.storageMetrics) }) : properties;
    }
    function CfnStorageLensPrefixLevelPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("storageMetrics", "StorageMetrics", CfnStorageLensPrefixLevelStorageMetricsPropertyFromCloudFormation(properties.StorageMetrics)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStorageLens_PrefixLevelStorageMetricsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("isEnabled", cdk.validateBoolean)(properties.isEnabled)), errors.collect(cdk.propertyValidator("selectionCriteria", CfnStorageLens_SelectionCriteriaPropertyValidator)(properties.selectionCriteria)), errors.wrap('supplied properties not correct for "PrefixLevelStorageMetricsProperty"');
    }
    function cfnStorageLensPrefixLevelStorageMetricsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStorageLens_PrefixLevelStorageMetricsPropertyValidator(properties).assertSuccess(), { IsEnabled: cdk.booleanToCloudFormation(properties.isEnabled), SelectionCriteria: cfnStorageLensSelectionCriteriaPropertyToCloudFormation(properties.selectionCriteria) }) : properties;
    }
    function CfnStorageLensPrefixLevelStorageMetricsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("isEnabled", "IsEnabled", properties.IsEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsEnabled) : void 0), ret.addPropertyResult("selectionCriteria", "SelectionCriteria", properties.SelectionCriteria != null ? CfnStorageLensSelectionCriteriaPropertyFromCloudFormation(properties.SelectionCriteria) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStorageLens_S3BucketDestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accountId", cdk.requiredValidator)(properties.accountId)), errors.collect(cdk.propertyValidator("accountId", cdk.validateString)(properties.accountId)), errors.collect(cdk.propertyValidator("arn", cdk.requiredValidator)(properties.arn)), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("encryption", CfnStorageLens_EncryptionPropertyValidator)(properties.encryption)), errors.collect(cdk.propertyValidator("format", cdk.requiredValidator)(properties.format)), errors.collect(cdk.propertyValidator("format", cdk.validateString)(properties.format)), errors.collect(cdk.propertyValidator("outputSchemaVersion", cdk.requiredValidator)(properties.outputSchemaVersion)), errors.collect(cdk.propertyValidator("outputSchemaVersion", cdk.validateString)(properties.outputSchemaVersion)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.wrap('supplied properties not correct for "S3BucketDestinationProperty"');
    }
    function cfnStorageLensS3BucketDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStorageLens_S3BucketDestinationPropertyValidator(properties).assertSuccess(), { AccountId: cdk.stringToCloudFormation(properties.accountId), Arn: cdk.stringToCloudFormation(properties.arn), Encryption: cfnStorageLensEncryptionPropertyToCloudFormation(properties.encryption), Format: cdk.stringToCloudFormation(properties.format), OutputSchemaVersion: cdk.stringToCloudFormation(properties.outputSchemaVersion), Prefix: cdk.stringToCloudFormation(properties.prefix) }) : properties;
    }
    function CfnStorageLensS3BucketDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accountId", "AccountId", cfn_parse.FromCloudFormation.getString(properties.AccountId)), ret.addPropertyResult("arn", "Arn", cfn_parse.FromCloudFormation.getString(properties.Arn)), ret.addPropertyResult("encryption", "Encryption", properties.Encryption != null ? CfnStorageLensEncryptionPropertyFromCloudFormation(properties.Encryption) : void 0), ret.addPropertyResult("format", "Format", cfn_parse.FromCloudFormation.getString(properties.Format)), ret.addPropertyResult("outputSchemaVersion", "OutputSchemaVersion", cfn_parse.FromCloudFormation.getString(properties.OutputSchemaVersion)), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStorageLens_SSEKMSPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("keyId", cdk.requiredValidator)(properties.keyId)), errors.collect(cdk.propertyValidator("keyId", cdk.validateString)(properties.keyId)), errors.wrap('supplied properties not correct for "SSEKMSProperty"');
    }
    function cfnStorageLensSSEKMSPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStorageLens_SSEKMSPropertyValidator(properties).assertSuccess(), { KeyId: cdk.stringToCloudFormation(properties.keyId) }) : properties;
    }
    function CfnStorageLensSSEKMSPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("keyId", "KeyId", cfn_parse.FromCloudFormation.getString(properties.KeyId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStorageLens_SelectionCriteriaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("delimiter", cdk.validateString)(properties.delimiter)), errors.collect(cdk.propertyValidator("maxDepth", cdk.validateNumber)(properties.maxDepth)), errors.collect(cdk.propertyValidator("minStorageBytesPercentage", cdk.validateNumber)(properties.minStorageBytesPercentage)), errors.wrap('supplied properties not correct for "SelectionCriteriaProperty"');
    }
    function cfnStorageLensSelectionCriteriaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStorageLens_SelectionCriteriaPropertyValidator(properties).assertSuccess(), { Delimiter: cdk.stringToCloudFormation(properties.delimiter), MaxDepth: cdk.numberToCloudFormation(properties.maxDepth), MinStorageBytesPercentage: cdk.numberToCloudFormation(properties.minStorageBytesPercentage) }) : properties;
    }
    function CfnStorageLensSelectionCriteriaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("delimiter", "Delimiter", properties.Delimiter != null ? cfn_parse.FromCloudFormation.getString(properties.Delimiter) : void 0), ret.addPropertyResult("maxDepth", "MaxDepth", properties.MaxDepth != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxDepth) : void 0), ret.addPropertyResult("minStorageBytesPercentage", "MinStorageBytesPercentage", properties.MinStorageBytesPercentage != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinStorageBytesPercentage) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStorageLens_StorageLensConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accountLevel", cdk.requiredValidator)(properties.accountLevel)), errors.collect(cdk.propertyValidator("accountLevel", CfnStorageLens_AccountLevelPropertyValidator)(properties.accountLevel)), errors.collect(cdk.propertyValidator("awsOrg", CfnStorageLens_AwsOrgPropertyValidator)(properties.awsOrg)), errors.collect(cdk.propertyValidator("dataExport", CfnStorageLens_DataExportPropertyValidator)(properties.dataExport)), errors.collect(cdk.propertyValidator("exclude", CfnStorageLens_BucketsAndRegionsPropertyValidator)(properties.exclude)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("include", CfnStorageLens_BucketsAndRegionsPropertyValidator)(properties.include)), errors.collect(cdk.propertyValidator("isEnabled", cdk.requiredValidator)(properties.isEnabled)), errors.collect(cdk.propertyValidator("isEnabled", cdk.validateBoolean)(properties.isEnabled)), errors.collect(cdk.propertyValidator("storageLensArn", cdk.validateString)(properties.storageLensArn)), errors.wrap('supplied properties not correct for "StorageLensConfigurationProperty"');
    }
    function cfnStorageLensStorageLensConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStorageLens_StorageLensConfigurationPropertyValidator(properties).assertSuccess(), { AccountLevel: cfnStorageLensAccountLevelPropertyToCloudFormation(properties.accountLevel), AwsOrg: cfnStorageLensAwsOrgPropertyToCloudFormation(properties.awsOrg), DataExport: cfnStorageLensDataExportPropertyToCloudFormation(properties.dataExport), Exclude: cfnStorageLensBucketsAndRegionsPropertyToCloudFormation(properties.exclude), Id: cdk.stringToCloudFormation(properties.id), Include: cfnStorageLensBucketsAndRegionsPropertyToCloudFormation(properties.include), IsEnabled: cdk.booleanToCloudFormation(properties.isEnabled), StorageLensArn: cdk.stringToCloudFormation(properties.storageLensArn) }) : properties;
    }
    function CfnStorageLensStorageLensConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accountLevel", "AccountLevel", CfnStorageLensAccountLevelPropertyFromCloudFormation(properties.AccountLevel)), ret.addPropertyResult("awsOrg", "AwsOrg", properties.AwsOrg != null ? CfnStorageLensAwsOrgPropertyFromCloudFormation(properties.AwsOrg) : void 0), ret.addPropertyResult("dataExport", "DataExport", properties.DataExport != null ? CfnStorageLensDataExportPropertyFromCloudFormation(properties.DataExport) : void 0), ret.addPropertyResult("exclude", "Exclude", properties.Exclude != null ? CfnStorageLensBucketsAndRegionsPropertyFromCloudFormation(properties.Exclude) : void 0), ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("include", "Include", properties.Include != null ? CfnStorageLensBucketsAndRegionsPropertyFromCloudFormation(properties.Include) : void 0), ret.addPropertyResult("isEnabled", "IsEnabled", cfn_parse.FromCloudFormation.getBoolean(properties.IsEnabled)), ret.addPropertyResult("storageLensArn", "StorageLensArn", properties.StorageLensArn != null ? cfn_parse.FromCloudFormation.getString(properties.StorageLensArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-s3/lib/bucket-policy.js
var require_bucket_policy = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3/lib/bucket-policy.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.BucketPolicy = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var bucket_1 = require_bucket();
    var s3_generated_1 = require_s3_generated();
    var aws_iam_1 = require_aws_iam();
    var core_1 = require_core2();
    var cfn_reference_1 = require_cfn_reference();
    var BucketPolicy = class _BucketPolicy extends core_1.Resource {
      static fromCfnBucketPolicy(cfnBucketPolicy) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_CfnBucketPolicy(cfnBucketPolicy);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromCfnBucketPolicy), error;
        }
        const id = "@FromCfnBucketPolicy", existing = cfnBucketPolicy.node.tryFindChild(id);
        if (existing)
          return existing;
        let bucket;
        if (core_1.Token.isUnresolved(cfnBucketPolicy.bucket)) {
          const bucketIResolvable = core_1.Tokenization.reverse(cfnBucketPolicy.bucket);
          if (bucketIResolvable instanceof cfn_reference_1.CfnReference) {
            const cfnElement = bucketIResolvable.target;
            cfnElement instanceof s3_generated_1.CfnBucket && (bucket = bucket_1.Bucket.fromCfnBucket(cfnElement));
          }
        }
        bucket || (bucket = bucket_1.Bucket.fromBucketName(cfnBucketPolicy, "@FromCfnBucket", cfnBucketPolicy.bucket));
        const ret = new class extends _BucketPolicy {
          constructor() {
            super(...arguments), this.document = aws_iam_1.PolicyDocument.fromJson(cfnBucketPolicy.policyDocument);
          }
        }(cfnBucketPolicy, id, { bucket });
        return bucket.policy = ret, ret;
      }
      constructor(scope, id, props) {
        super(scope, id), this.document = new aws_iam_1.PolicyDocument();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_BucketPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _BucketPolicy), error;
        }
        this.bucket = props.bucket, this.resource = new s3_generated_1.CfnBucketPolicy(this, "Resource", { bucket: this.bucket.bucketName, policyDocument: this.document }), props.removalPolicy && this.resource.applyRemovalPolicy(props.removalPolicy);
      }
      applyRemovalPolicy(removalPolicy) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_RemovalPolicy(removalPolicy);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.applyRemovalPolicy), error;
        }
        this.resource.applyRemovalPolicy(removalPolicy);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, BucketPolicy[_a] = { fqn: "aws-cdk-lib.aws_s3.BucketPolicy", version: "2.80.0" }, exports2.BucketPolicy = BucketPolicy;
  }
});

// node_modules/aws-cdk-lib/aws-s3/lib/notifications-resource/notifications-resource-handler.js
var require_notifications_resource_handler = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3/lib/notifications-resource/notifications-resource-handler.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.NotificationsResourceHandler = exports2.NotificationsResourceHandlerProps = void 0;
    var fs = require("fs");
    var path = require("path");
    var constructs_1 = require_lib2();
    var iam = require_aws_iam();
    var cdk = require_core2();
    var NotificationsResourceHandlerProps = class {
    };
    exports2.NotificationsResourceHandlerProps = NotificationsResourceHandlerProps;
    var NotificationsResourceHandler = class _NotificationsResourceHandler extends constructs_1.Construct {
      static singleton(context, props = {}) {
        const root = cdk.Stack.of(context), logicalId = "BucketNotificationsHandler050a0587b7544547bf325f094a3db834";
        let lambda2 = root.node.tryFindChild(logicalId);
        return lambda2 || (lambda2 = new _NotificationsResourceHandler(root, logicalId, props)), lambda2;
      }
      constructor(scope, id, props = {}) {
        super(scope, id), this.role = props.role ?? new iam.Role(this, "Role", { assumedBy: new iam.ServicePrincipal("lambda.amazonaws.com") }), this.role.addManagedPolicy(iam.ManagedPolicy.fromAwsManagedPolicyName("service-role/AWSLambdaBasicExecutionRole")), this.role.addToPrincipalPolicy(new iam.PolicyStatement({ actions: ["s3:PutBucketNotification"], resources: ["*"] }));
        const resourceType = "AWS::Lambda::Function";
        class InLineLambda extends cdk.CfnResource {
          constructor() {
            super(...arguments), this.tags = new cdk.TagManager(cdk.TagType.STANDARD, resourceType);
          }
          renderProperties(properties) {
            return properties.Tags = cdk.listMapper(cdk.cfnTagToCloudFormation)(this.tags.renderTags()), delete properties.tags, properties;
          }
        }
        const handlerSourceWithoutComments = fs.readFileSync(path.join(__dirname, "lambda/index.py"), "utf8").replace(/^ *#.*\n?/gm, "");
        if (handlerSourceWithoutComments.length > 4096)
          throw new Error(`Source of Notifications Resource Handler is too large (${handlerSourceWithoutComments.length} > 4096)`);
        const resource = new InLineLambda(this, "Resource", { type: resourceType, properties: { Description: 'AWS CloudFormation handler for "Custom::S3BucketNotifications" resources (@aws-cdk/aws-s3)', Code: { ZipFile: handlerSourceWithoutComments }, Handler: "index.handler", Role: this.role.roleArn, Runtime: "python3.9", Timeout: 300 } });
        resource.node.addDependency(this.role), this.functionArn = resource.getAtt("Arn").toString();
      }
      addToRolePolicy(statement) {
        this.role.addToPrincipalPolicy(statement);
      }
    };
    exports2.NotificationsResourceHandler = NotificationsResourceHandler;
  }
});

// node_modules/aws-cdk-lib/aws-s3/lib/destination.js
var require_destination2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3/lib/destination.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.BucketNotificationDestinationType = void 0;
    var BucketNotificationDestinationType;
    (function(BucketNotificationDestinationType2) {
      BucketNotificationDestinationType2[BucketNotificationDestinationType2.LAMBDA = 0] = "LAMBDA", BucketNotificationDestinationType2[BucketNotificationDestinationType2.QUEUE = 1] = "QUEUE", BucketNotificationDestinationType2[BucketNotificationDestinationType2.TOPIC = 2] = "TOPIC";
    })(BucketNotificationDestinationType = exports2.BucketNotificationDestinationType || (exports2.BucketNotificationDestinationType = {}));
  }
});

// node_modules/aws-cdk-lib/aws-s3/lib/notifications-resource/notifications-resource.js
var require_notifications_resource = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3/lib/notifications-resource/notifications-resource.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.BucketNotifications = void 0;
    var constructs_1 = require_lib2();
    var notifications_resource_handler_1 = require_notifications_resource_handler();
    var iam = require_aws_iam();
    var cdk = require_core2();
    var bucket_1 = require_bucket();
    var destination_1 = require_destination2();
    var BucketNotifications = class extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id), this.eventBridgeEnabled = false, this.lambdaNotifications = new Array(), this.queueNotifications = new Array(), this.topicNotifications = new Array(), this.bucket = props.bucket, this.handlerRole = props.handlerRole;
      }
      addNotification(event, target, ...filters) {
        const resource = this.createResourceOnce(), targetProps = target.bind(this, this.bucket), commonConfig = { Events: [event], Filter: renderFilters(filters) };
        switch (targetProps.dependencies && resource.node.addDependency(...targetProps.dependencies), targetProps.type) {
          case destination_1.BucketNotificationDestinationType.LAMBDA:
            this.lambdaNotifications.push({ ...commonConfig, LambdaFunctionArn: targetProps.arn });
            break;
          case destination_1.BucketNotificationDestinationType.QUEUE:
            this.queueNotifications.push({ ...commonConfig, QueueArn: targetProps.arn });
            break;
          case destination_1.BucketNotificationDestinationType.TOPIC:
            this.topicNotifications.push({ ...commonConfig, TopicArn: targetProps.arn });
            break;
          default:
            throw new Error("Unsupported notification target type:" + destination_1.BucketNotificationDestinationType[targetProps.type]);
        }
      }
      enableEventBridgeNotification() {
        this.createResourceOnce(), this.eventBridgeEnabled = true;
      }
      renderNotificationConfiguration() {
        return { EventBridgeConfiguration: this.eventBridgeEnabled ? {} : void 0, LambdaFunctionConfigurations: this.lambdaNotifications.length > 0 ? this.lambdaNotifications : void 0, QueueConfigurations: this.queueNotifications.length > 0 ? this.queueNotifications : void 0, TopicConfigurations: this.topicNotifications.length > 0 ? this.topicNotifications : void 0 };
      }
      createResourceOnce() {
        if (!this.resource) {
          const handler2 = notifications_resource_handler_1.NotificationsResourceHandler.singleton(this, { role: this.handlerRole }), managed = this.bucket instanceof bucket_1.Bucket;
          managed || handler2.addToRolePolicy(new iam.PolicyStatement({ actions: ["s3:GetBucketNotification"], resources: ["*"] })), this.resource = new cdk.CfnResource(this, "Resource", { type: "Custom::S3BucketNotifications", properties: { ServiceToken: handler2.functionArn, BucketName: this.bucket.bucketName, NotificationConfiguration: cdk.Lazy.any({ produce: () => this.renderNotificationConfiguration() }), Managed: managed } });
        }
        return this.resource;
      }
    };
    exports2.BucketNotifications = BucketNotifications;
    function renderFilters(filters) {
      if (!filters || filters.length === 0)
        return;
      const renderedRules = new Array();
      let hasPrefix = false, hasSuffix = false;
      for (const rule of filters) {
        if (!rule.suffix && !rule.prefix)
          throw new Error("NotificationKeyFilter must specify `prefix` and/or `suffix`");
        if (rule.suffix) {
          if (hasSuffix)
            throw new Error("Cannot specify more than one suffix rule in a filter.");
          renderedRules.push({ Name: "suffix", Value: rule.suffix }), hasSuffix = true;
        }
        if (rule.prefix) {
          if (hasPrefix)
            throw new Error("Cannot specify more than one prefix rule in a filter.");
          renderedRules.push({ Name: "prefix", Value: rule.prefix }), hasPrefix = true;
        }
      }
      return { Key: { FilterRules: renderedRules } };
    }
  }
});

// node_modules/aws-cdk-lib/aws-s3/lib/notifications-resource/index.js
var require_notifications_resource2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3/lib/notifications-resource/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_notifications_resource(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-s3/lib/perms.js
var require_perms2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3/lib/perms.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.KEY_WRITE_ACTIONS = exports2.KEY_READ_ACTIONS = exports2.BUCKET_DELETE_ACTIONS = exports2.BUCKET_PUT_ACL_ACTIONS = exports2.BUCKET_PUT_ACTIONS = exports2.LEGACY_BUCKET_PUT_ACTIONS = exports2.BUCKET_READ_METADATA_ACTIONS = exports2.BUCKET_READ_ACTIONS = void 0, exports2.BUCKET_READ_ACTIONS = ["s3:GetObject*", "s3:GetBucket*", "s3:List*"], exports2.BUCKET_READ_METADATA_ACTIONS = ["s3:GetBucket*", "s3:List*"], exports2.LEGACY_BUCKET_PUT_ACTIONS = ["s3:PutObject*", "s3:Abort*"], exports2.BUCKET_PUT_ACTIONS = ["s3:PutObject", "s3:PutObjectLegalHold", "s3:PutObjectRetention", "s3:PutObjectTagging", "s3:PutObjectVersionTagging", "s3:Abort*"], exports2.BUCKET_PUT_ACL_ACTIONS = ["s3:PutObjectAcl", "s3:PutObjectVersionAcl"], exports2.BUCKET_DELETE_ACTIONS = ["s3:DeleteObject*"], exports2.KEY_READ_ACTIONS = ["kms:Decrypt", "kms:DescribeKey"], exports2.KEY_WRITE_ACTIONS = ["kms:Encrypt", "kms:ReEncrypt*", "kms:GenerateDataKey*", "kms:Decrypt"];
  }
});

// node_modules/aws-cdk-lib/aws-s3/lib/util.js
var require_util6 = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3/lib/util.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.parseBucketName = exports2.parseBucketArn = void 0;
    var cdk = require_core2();
    function parseBucketArn(construct, props) {
      if (props.bucketArn)
        return props.bucketArn;
      if (props.bucketName)
        return cdk.Stack.of(construct).formatArn({ region: "", account: "", service: "s3", resource: props.bucketName });
      throw new Error("Cannot determine bucket ARN. At least `bucketArn` or `bucketName` is needed");
    }
    exports2.parseBucketArn = parseBucketArn;
    function parseBucketName(construct, props) {
      if (props.bucketName)
        return props.bucketName;
      if (props.bucketArn)
        return cdk.Stack.of(construct).splitArn(props.bucketArn, cdk.ArnFormat.SLASH_RESOURCE_NAME).resource;
    }
    exports2.parseBucketName = parseBucketName;
  }
});

// node_modules/aws-cdk-lib/aws-events/lib/input.js
var require_input = __commonJS({
  "node_modules/aws-cdk-lib/aws-events/lib/input.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EventField = exports2.RuleTargetInput = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core_1 = require_core2();
    var RuleTargetInput = class {
      static fromText(text) {
        return new FieldAwareEventInput(text, InputType.Text);
      }
      static fromMultilineText(text) {
        return new FieldAwareEventInput(text, InputType.Multiline);
      }
      static fromObject(obj) {
        return new FieldAwareEventInput(obj, InputType.Object);
      }
      static fromEventPath(path) {
        return new LiteralEventInput({ inputPath: path });
      }
      constructor() {
      }
    };
    _a = JSII_RTTI_SYMBOL_1, RuleTargetInput[_a] = { fqn: "aws-cdk-lib.aws_events.RuleTargetInput", version: "2.80.0" }, exports2.RuleTargetInput = RuleTargetInput;
    var LiteralEventInput = class extends RuleTargetInput {
      constructor(props) {
        super(), this.props = props;
      }
      bind(_rule) {
        return this.props;
      }
    };
    var FieldAwareEventInput = class extends RuleTargetInput {
      constructor(input, inputType) {
        super(), this.input = input, this.inputType = inputType;
      }
      bind(rule) {
        let fieldCounter = 0;
        const pathToKey = /* @__PURE__ */ new Map(), inputPathsMap = {};
        function keyForField(f) {
          const existing = pathToKey.get(f.path);
          if (existing !== void 0)
            return existing;
          fieldCounter += 1;
          const key = f.displayHint || `f${fieldCounter}`;
          return pathToKey.set(f.path, key), key;
        }
        class EventFieldReplacer extends core_1.DefaultTokenResolver {
          constructor() {
            super(new core_1.StringConcat());
          }
          resolveToken(t, _context) {
            if (!isEventField(t))
              return core_1.Token.asString(t);
            const key = keyForField(t);
            if (inputPathsMap[key] && inputPathsMap[key] !== t.path)
              throw new Error(`Single key '${key}' is used for two different JSON paths: '${t.path}' and '${inputPathsMap[key]}'`);
            return inputPathsMap[key] = t.path, `<${key}>`;
          }
        }
        const stack = core_1.Stack.of(rule);
        let resolved;
        this.inputType === InputType.Multiline ? (resolved = core_1.Tokenization.resolve(this.input, { scope: rule, resolver: new EventFieldReplacer() }), resolved = resolved.split(`
`).map(stack.toJsonString).join(`
`)) : resolved = stack.toJsonString(core_1.Tokenization.resolve(this.input, { scope: rule, resolver: new EventFieldReplacer() }));
        const keys = Object.keys(inputPathsMap);
        return keys.length === 0 ? { input: resolved } : { inputTemplate: this.unquoteKeyPlaceholders(resolved, keys), inputPathsMap };
      }
      unquoteKeyPlaceholders(sub, keys) {
        if (this.inputType !== InputType.Object)
          return sub;
        return core_1.Lazy.uncachedString({ produce: (ctx) => core_1.Token.asString(deepUnquote(ctx.resolve(sub))) });
        function deepUnquote(resolved) {
          if (Array.isArray(resolved))
            return resolved.map(deepUnquote);
          if (typeof resolved == "object" && resolved !== null) {
            for (const [key, value] of Object.entries(resolved))
              resolved[key] = deepUnquote(value);
            return resolved;
          } else if (typeof resolved == "string")
            return keys.reduce((r, key) => r.replace(new RegExp(`(?<!\\\\)"<${key}>"`, "g"), `<${key}>`), resolved);
          return resolved;
        }
      }
    };
    var EventField = class _EventField {
      static get eventId() {
        return this.fromPath("$.id");
      }
      static get detailType() {
        return this.fromPath("$.detail-type");
      }
      static get source() {
        return this.fromPath("$.source");
      }
      static get account() {
        return this.fromPath("$.account");
      }
      static get time() {
        return this.fromPath("$.time");
      }
      static get region() {
        return this.fromPath("$.region");
      }
      static fromPath(path) {
        return new _EventField(path).toString();
      }
      constructor(path) {
        this.path = path, this.displayHint = this.path.replace(/^[^a-zA-Z0-9_-]+/, "").replace(/[^a-zA-Z0-9_-]/g, "-"), Object.defineProperty(this, EVENT_FIELD_SYMBOL, { value: true }), this.creationStack = (0, core_1.captureStackTrace)();
      }
      resolve(_ctx) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_IResolveContext(_ctx);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.resolve), error;
        }
        return this.path;
      }
      toString() {
        return core_1.Token.asString(this, { displayHint: this.displayHint });
      }
      toJSON() {
        return `<path:${this.path}>`;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, EventField[_b] = { fqn: "aws-cdk-lib.aws_events.EventField", version: "2.80.0" }, exports2.EventField = EventField;
    var InputType;
    (function(InputType2) {
      InputType2[InputType2.Object = 0] = "Object", InputType2[InputType2.Text = 1] = "Text", InputType2[InputType2.Multiline = 2] = "Multiline";
    })(InputType || (InputType = {}));
    function isEventField(x) {
      return EVENT_FIELD_SYMBOL in x;
    }
    var EVENT_FIELD_SYMBOL = Symbol.for("@aws-cdk/aws-events.EventField");
  }
});

// node_modules/aws-cdk-lib/aws-events/lib/events.generated.js
var require_events_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-events/lib/events.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnRule = exports2.CfnEventBusPolicy = exports2.CfnEventBus = exports2.CfnEndpoint = exports2.CfnConnection = exports2.CfnArchive = exports2.CfnApiDestination = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnApiDestinationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectionArn", cdk.requiredValidator)(properties.connectionArn)), errors.collect(cdk.propertyValidator("connectionArn", cdk.validateString)(properties.connectionArn)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("httpMethod", cdk.requiredValidator)(properties.httpMethod)), errors.collect(cdk.propertyValidator("httpMethod", cdk.validateString)(properties.httpMethod)), errors.collect(cdk.propertyValidator("invocationEndpoint", cdk.requiredValidator)(properties.invocationEndpoint)), errors.collect(cdk.propertyValidator("invocationEndpoint", cdk.validateString)(properties.invocationEndpoint)), errors.collect(cdk.propertyValidator("invocationRateLimitPerSecond", cdk.validateNumber)(properties.invocationRateLimitPerSecond)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "CfnApiDestinationProps"');
    }
    function cfnApiDestinationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApiDestinationPropsValidator(properties).assertSuccess(), { ConnectionArn: cdk.stringToCloudFormation(properties.connectionArn), HttpMethod: cdk.stringToCloudFormation(properties.httpMethod), InvocationEndpoint: cdk.stringToCloudFormation(properties.invocationEndpoint), Description: cdk.stringToCloudFormation(properties.description), InvocationRateLimitPerSecond: cdk.numberToCloudFormation(properties.invocationRateLimitPerSecond), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnApiDestinationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectionArn", "ConnectionArn", cfn_parse.FromCloudFormation.getString(properties.ConnectionArn)), ret.addPropertyResult("httpMethod", "HttpMethod", cfn_parse.FromCloudFormation.getString(properties.HttpMethod)), ret.addPropertyResult("invocationEndpoint", "InvocationEndpoint", cfn_parse.FromCloudFormation.getString(properties.InvocationEndpoint)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("invocationRateLimitPerSecond", "InvocationRateLimitPerSecond", properties.InvocationRateLimitPerSecond != null ? cfn_parse.FromCloudFormation.getNumber(properties.InvocationRateLimitPerSecond) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApiDestination = class _CfnApiDestination extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApiDestinationPropsFromCloudFormation(resourceProperties), ret = new _CfnApiDestination(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApiDestination.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_CfnApiDestinationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApiDestination), error;
        }
        cdk.requireProperty(props, "connectionArn", this), cdk.requireProperty(props, "httpMethod", this), cdk.requireProperty(props, "invocationEndpoint", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.connectionArn = props.connectionArn, this.httpMethod = props.httpMethod, this.invocationEndpoint = props.invocationEndpoint, this.description = props.description, this.invocationRateLimitPerSecond = props.invocationRateLimitPerSecond, this.name = props.name;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApiDestination.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { connectionArn: this.connectionArn, httpMethod: this.httpMethod, invocationEndpoint: this.invocationEndpoint, description: this.description, invocationRateLimitPerSecond: this.invocationRateLimitPerSecond, name: this.name };
      }
      renderProperties(props) {
        return cfnApiDestinationPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnApiDestination[_a] = { fqn: "aws-cdk-lib.aws_events.CfnApiDestination", version: "2.80.0" }, CfnApiDestination.CFN_RESOURCE_TYPE_NAME = "AWS::Events::ApiDestination", exports2.CfnApiDestination = CfnApiDestination;
    function CfnArchivePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("archiveName", cdk.validateString)(properties.archiveName)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("eventPattern", cdk.validateObject)(properties.eventPattern)), errors.collect(cdk.propertyValidator("retentionDays", cdk.validateNumber)(properties.retentionDays)), errors.collect(cdk.propertyValidator("sourceArn", cdk.requiredValidator)(properties.sourceArn)), errors.collect(cdk.propertyValidator("sourceArn", cdk.validateString)(properties.sourceArn)), errors.wrap('supplied properties not correct for "CfnArchiveProps"');
    }
    function cfnArchivePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnArchivePropsValidator(properties).assertSuccess(), { SourceArn: cdk.stringToCloudFormation(properties.sourceArn), ArchiveName: cdk.stringToCloudFormation(properties.archiveName), Description: cdk.stringToCloudFormation(properties.description), EventPattern: cdk.objectToCloudFormation(properties.eventPattern), RetentionDays: cdk.numberToCloudFormation(properties.retentionDays) }) : properties;
    }
    function CfnArchivePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sourceArn", "SourceArn", cfn_parse.FromCloudFormation.getString(properties.SourceArn)), ret.addPropertyResult("archiveName", "ArchiveName", properties.ArchiveName != null ? cfn_parse.FromCloudFormation.getString(properties.ArchiveName) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("eventPattern", "EventPattern", properties.EventPattern != null ? cfn_parse.FromCloudFormation.getAny(properties.EventPattern) : void 0), ret.addPropertyResult("retentionDays", "RetentionDays", properties.RetentionDays != null ? cfn_parse.FromCloudFormation.getNumber(properties.RetentionDays) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnArchive = class _CfnArchive extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnArchivePropsFromCloudFormation(resourceProperties), ret = new _CfnArchive(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnArchive.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_CfnArchiveProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnArchive), error;
        }
        cdk.requireProperty(props, "sourceArn", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.sourceArn = props.sourceArn, this.archiveName = props.archiveName, this.description = props.description, this.eventPattern = props.eventPattern, this.retentionDays = props.retentionDays;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnArchive.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { sourceArn: this.sourceArn, archiveName: this.archiveName, description: this.description, eventPattern: this.eventPattern, retentionDays: this.retentionDays };
      }
      renderProperties(props) {
        return cfnArchivePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnArchive[_b] = { fqn: "aws-cdk-lib.aws_events.CfnArchive", version: "2.80.0" }, CfnArchive.CFN_RESOURCE_TYPE_NAME = "AWS::Events::Archive", exports2.CfnArchive = CfnArchive;
    function CfnConnectionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authParameters", cdk.requiredValidator)(properties.authParameters)), errors.collect(cdk.propertyValidator("authParameters", CfnConnection_AuthParametersPropertyValidator)(properties.authParameters)), errors.collect(cdk.propertyValidator("authorizationType", cdk.requiredValidator)(properties.authorizationType)), errors.collect(cdk.propertyValidator("authorizationType", cdk.validateString)(properties.authorizationType)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "CfnConnectionProps"');
    }
    function cfnConnectionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectionPropsValidator(properties).assertSuccess(), { AuthorizationType: cdk.stringToCloudFormation(properties.authorizationType), AuthParameters: cfnConnectionAuthParametersPropertyToCloudFormation(properties.authParameters), Description: cdk.stringToCloudFormation(properties.description), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnConnectionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authorizationType", "AuthorizationType", cfn_parse.FromCloudFormation.getString(properties.AuthorizationType)), ret.addPropertyResult("authParameters", "AuthParameters", CfnConnectionAuthParametersPropertyFromCloudFormation(properties.AuthParameters)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnConnection = class _CfnConnection extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnConnectionPropsFromCloudFormation(resourceProperties), ret = new _CfnConnection(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnConnection.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_CfnConnectionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnConnection), error;
        }
        cdk.requireProperty(props, "authParameters", this), cdk.requireProperty(props, "authorizationType", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrSecretArn = cdk.Token.asString(this.getAtt("SecretArn", cdk.ResolutionTypeHint.STRING)), this.authorizationType = props.authorizationType, this.authParameters = props.authParameters, this.description = props.description, this.name = props.name;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnConnection.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { authorizationType: this.authorizationType, authParameters: this.authParameters, description: this.description, name: this.name };
      }
      renderProperties(props) {
        return cfnConnectionPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnConnection[_c] = { fqn: "aws-cdk-lib.aws_events.CfnConnection", version: "2.80.0" }, CfnConnection.CFN_RESOURCE_TYPE_NAME = "AWS::Events::Connection", exports2.CfnConnection = CfnConnection;
    function CfnConnection_ApiKeyAuthParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiKeyName", cdk.requiredValidator)(properties.apiKeyName)), errors.collect(cdk.propertyValidator("apiKeyName", cdk.validateString)(properties.apiKeyName)), errors.collect(cdk.propertyValidator("apiKeyValue", cdk.requiredValidator)(properties.apiKeyValue)), errors.collect(cdk.propertyValidator("apiKeyValue", cdk.validateString)(properties.apiKeyValue)), errors.wrap('supplied properties not correct for "ApiKeyAuthParametersProperty"');
    }
    function cfnConnectionApiKeyAuthParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnection_ApiKeyAuthParametersPropertyValidator(properties).assertSuccess(), { ApiKeyName: cdk.stringToCloudFormation(properties.apiKeyName), ApiKeyValue: cdk.stringToCloudFormation(properties.apiKeyValue) }) : properties;
    }
    function CfnConnectionApiKeyAuthParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiKeyName", "ApiKeyName", cfn_parse.FromCloudFormation.getString(properties.ApiKeyName)), ret.addPropertyResult("apiKeyValue", "ApiKeyValue", cfn_parse.FromCloudFormation.getString(properties.ApiKeyValue)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnection_AuthParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiKeyAuthParameters", CfnConnection_ApiKeyAuthParametersPropertyValidator)(properties.apiKeyAuthParameters)), errors.collect(cdk.propertyValidator("basicAuthParameters", CfnConnection_BasicAuthParametersPropertyValidator)(properties.basicAuthParameters)), errors.collect(cdk.propertyValidator("invocationHttpParameters", CfnConnection_ConnectionHttpParametersPropertyValidator)(properties.invocationHttpParameters)), errors.collect(cdk.propertyValidator("oAuthParameters", CfnConnection_OAuthParametersPropertyValidator)(properties.oAuthParameters)), errors.wrap('supplied properties not correct for "AuthParametersProperty"');
    }
    function cfnConnectionAuthParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnection_AuthParametersPropertyValidator(properties).assertSuccess(), { ApiKeyAuthParameters: cfnConnectionApiKeyAuthParametersPropertyToCloudFormation(properties.apiKeyAuthParameters), BasicAuthParameters: cfnConnectionBasicAuthParametersPropertyToCloudFormation(properties.basicAuthParameters), InvocationHttpParameters: cfnConnectionConnectionHttpParametersPropertyToCloudFormation(properties.invocationHttpParameters), OAuthParameters: cfnConnectionOAuthParametersPropertyToCloudFormation(properties.oAuthParameters) }) : properties;
    }
    function CfnConnectionAuthParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiKeyAuthParameters", "ApiKeyAuthParameters", properties.ApiKeyAuthParameters != null ? CfnConnectionApiKeyAuthParametersPropertyFromCloudFormation(properties.ApiKeyAuthParameters) : void 0), ret.addPropertyResult("basicAuthParameters", "BasicAuthParameters", properties.BasicAuthParameters != null ? CfnConnectionBasicAuthParametersPropertyFromCloudFormation(properties.BasicAuthParameters) : void 0), ret.addPropertyResult("invocationHttpParameters", "InvocationHttpParameters", properties.InvocationHttpParameters != null ? CfnConnectionConnectionHttpParametersPropertyFromCloudFormation(properties.InvocationHttpParameters) : void 0), ret.addPropertyResult("oAuthParameters", "OAuthParameters", properties.OAuthParameters != null ? CfnConnectionOAuthParametersPropertyFromCloudFormation(properties.OAuthParameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnection_BasicAuthParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("password", cdk.requiredValidator)(properties.password)), errors.collect(cdk.propertyValidator("password", cdk.validateString)(properties.password)), errors.collect(cdk.propertyValidator("username", cdk.requiredValidator)(properties.username)), errors.collect(cdk.propertyValidator("username", cdk.validateString)(properties.username)), errors.wrap('supplied properties not correct for "BasicAuthParametersProperty"');
    }
    function cfnConnectionBasicAuthParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnection_BasicAuthParametersPropertyValidator(properties).assertSuccess(), { Password: cdk.stringToCloudFormation(properties.password), Username: cdk.stringToCloudFormation(properties.username) }) : properties;
    }
    function CfnConnectionBasicAuthParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("password", "Password", cfn_parse.FromCloudFormation.getString(properties.Password)), ret.addPropertyResult("username", "Username", cfn_parse.FromCloudFormation.getString(properties.Username)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnection_ClientParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clientId", cdk.requiredValidator)(properties.clientId)), errors.collect(cdk.propertyValidator("clientId", cdk.validateString)(properties.clientId)), errors.collect(cdk.propertyValidator("clientSecret", cdk.requiredValidator)(properties.clientSecret)), errors.collect(cdk.propertyValidator("clientSecret", cdk.validateString)(properties.clientSecret)), errors.wrap('supplied properties not correct for "ClientParametersProperty"');
    }
    function cfnConnectionClientParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnection_ClientParametersPropertyValidator(properties).assertSuccess(), { ClientID: cdk.stringToCloudFormation(properties.clientId), ClientSecret: cdk.stringToCloudFormation(properties.clientSecret) }) : properties;
    }
    function CfnConnectionClientParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clientId", "ClientID", cfn_parse.FromCloudFormation.getString(properties.ClientID)), ret.addPropertyResult("clientSecret", "ClientSecret", cfn_parse.FromCloudFormation.getString(properties.ClientSecret)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnection_ConnectionHttpParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bodyParameters", cdk.listValidator(CfnConnection_ParameterPropertyValidator))(properties.bodyParameters)), errors.collect(cdk.propertyValidator("headerParameters", cdk.listValidator(CfnConnection_ParameterPropertyValidator))(properties.headerParameters)), errors.collect(cdk.propertyValidator("queryStringParameters", cdk.listValidator(CfnConnection_ParameterPropertyValidator))(properties.queryStringParameters)), errors.wrap('supplied properties not correct for "ConnectionHttpParametersProperty"');
    }
    function cfnConnectionConnectionHttpParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnection_ConnectionHttpParametersPropertyValidator(properties).assertSuccess(), { BodyParameters: cdk.listMapper(cfnConnectionParameterPropertyToCloudFormation)(properties.bodyParameters), HeaderParameters: cdk.listMapper(cfnConnectionParameterPropertyToCloudFormation)(properties.headerParameters), QueryStringParameters: cdk.listMapper(cfnConnectionParameterPropertyToCloudFormation)(properties.queryStringParameters) }) : properties;
    }
    function CfnConnectionConnectionHttpParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bodyParameters", "BodyParameters", properties.BodyParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnConnectionParameterPropertyFromCloudFormation)(properties.BodyParameters) : void 0), ret.addPropertyResult("headerParameters", "HeaderParameters", properties.HeaderParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnConnectionParameterPropertyFromCloudFormation)(properties.HeaderParameters) : void 0), ret.addPropertyResult("queryStringParameters", "QueryStringParameters", properties.QueryStringParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnConnectionParameterPropertyFromCloudFormation)(properties.QueryStringParameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnection_OAuthParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authorizationEndpoint", cdk.requiredValidator)(properties.authorizationEndpoint)), errors.collect(cdk.propertyValidator("authorizationEndpoint", cdk.validateString)(properties.authorizationEndpoint)), errors.collect(cdk.propertyValidator("clientParameters", cdk.requiredValidator)(properties.clientParameters)), errors.collect(cdk.propertyValidator("clientParameters", CfnConnection_ClientParametersPropertyValidator)(properties.clientParameters)), errors.collect(cdk.propertyValidator("httpMethod", cdk.requiredValidator)(properties.httpMethod)), errors.collect(cdk.propertyValidator("httpMethod", cdk.validateString)(properties.httpMethod)), errors.collect(cdk.propertyValidator("oAuthHttpParameters", CfnConnection_ConnectionHttpParametersPropertyValidator)(properties.oAuthHttpParameters)), errors.wrap('supplied properties not correct for "OAuthParametersProperty"');
    }
    function cfnConnectionOAuthParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnection_OAuthParametersPropertyValidator(properties).assertSuccess(), { AuthorizationEndpoint: cdk.stringToCloudFormation(properties.authorizationEndpoint), ClientParameters: cfnConnectionClientParametersPropertyToCloudFormation(properties.clientParameters), HttpMethod: cdk.stringToCloudFormation(properties.httpMethod), OAuthHttpParameters: cfnConnectionConnectionHttpParametersPropertyToCloudFormation(properties.oAuthHttpParameters) }) : properties;
    }
    function CfnConnectionOAuthParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authorizationEndpoint", "AuthorizationEndpoint", cfn_parse.FromCloudFormation.getString(properties.AuthorizationEndpoint)), ret.addPropertyResult("clientParameters", "ClientParameters", CfnConnectionClientParametersPropertyFromCloudFormation(properties.ClientParameters)), ret.addPropertyResult("httpMethod", "HttpMethod", cfn_parse.FromCloudFormation.getString(properties.HttpMethod)), ret.addPropertyResult("oAuthHttpParameters", "OAuthHttpParameters", properties.OAuthHttpParameters != null ? CfnConnectionConnectionHttpParametersPropertyFromCloudFormation(properties.OAuthHttpParameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnection_ParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("isValueSecret", cdk.validateBoolean)(properties.isValueSecret)), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "ParameterProperty"');
    }
    function cfnConnectionParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnection_ParameterPropertyValidator(properties).assertSuccess(), { IsValueSecret: cdk.booleanToCloudFormation(properties.isValueSecret), Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnConnectionParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("isValueSecret", "IsValueSecret", properties.IsValueSecret != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsValueSecret) : void 0), ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpointPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("eventBuses", cdk.requiredValidator)(properties.eventBuses)), errors.collect(cdk.propertyValidator("eventBuses", cdk.listValidator(CfnEndpoint_EndpointEventBusPropertyValidator))(properties.eventBuses)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("replicationConfig", CfnEndpoint_ReplicationConfigPropertyValidator)(properties.replicationConfig)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("routingConfig", cdk.requiredValidator)(properties.routingConfig)), errors.collect(cdk.propertyValidator("routingConfig", CfnEndpoint_RoutingConfigPropertyValidator)(properties.routingConfig)), errors.wrap('supplied properties not correct for "CfnEndpointProps"');
    }
    function cfnEndpointPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpointPropsValidator(properties).assertSuccess(), { EventBuses: cdk.listMapper(cfnEndpointEndpointEventBusPropertyToCloudFormation)(properties.eventBuses), RoutingConfig: cfnEndpointRoutingConfigPropertyToCloudFormation(properties.routingConfig), Description: cdk.stringToCloudFormation(properties.description), Name: cdk.stringToCloudFormation(properties.name), ReplicationConfig: cfnEndpointReplicationConfigPropertyToCloudFormation(properties.replicationConfig), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnEndpointPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("eventBuses", "EventBuses", cfn_parse.FromCloudFormation.getArray(CfnEndpointEndpointEventBusPropertyFromCloudFormation)(properties.EventBuses)), ret.addPropertyResult("routingConfig", "RoutingConfig", CfnEndpointRoutingConfigPropertyFromCloudFormation(properties.RoutingConfig)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("replicationConfig", "ReplicationConfig", properties.ReplicationConfig != null ? CfnEndpointReplicationConfigPropertyFromCloudFormation(properties.ReplicationConfig) : void 0), ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEndpoint = class _CfnEndpoint extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEndpointPropsFromCloudFormation(resourceProperties), ret = new _CfnEndpoint(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEndpoint.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_CfnEndpointProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEndpoint), error;
        }
        cdk.requireProperty(props, "eventBuses", this), cdk.requireProperty(props, "routingConfig", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrEndpointId = cdk.Token.asString(this.getAtt("EndpointId", cdk.ResolutionTypeHint.STRING)), this.attrEndpointUrl = cdk.Token.asString(this.getAtt("EndpointUrl", cdk.ResolutionTypeHint.STRING)), this.attrState = cdk.Token.asString(this.getAtt("State", cdk.ResolutionTypeHint.STRING)), this.attrStateReason = cdk.Token.asString(this.getAtt("StateReason", cdk.ResolutionTypeHint.STRING)), this.eventBuses = props.eventBuses, this.routingConfig = props.routingConfig, this.description = props.description, this.name = props.name, this.replicationConfig = props.replicationConfig, this.roleArn = props.roleArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEndpoint.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { eventBuses: this.eventBuses, routingConfig: this.routingConfig, description: this.description, name: this.name, replicationConfig: this.replicationConfig, roleArn: this.roleArn };
      }
      renderProperties(props) {
        return cfnEndpointPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnEndpoint[_d] = { fqn: "aws-cdk-lib.aws_events.CfnEndpoint", version: "2.80.0" }, CfnEndpoint.CFN_RESOURCE_TYPE_NAME = "AWS::Events::Endpoint", exports2.CfnEndpoint = CfnEndpoint;
    function CfnEndpoint_EndpointEventBusPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("eventBusArn", cdk.requiredValidator)(properties.eventBusArn)), errors.collect(cdk.propertyValidator("eventBusArn", cdk.validateString)(properties.eventBusArn)), errors.wrap('supplied properties not correct for "EndpointEventBusProperty"');
    }
    function cfnEndpointEndpointEventBusPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpoint_EndpointEventBusPropertyValidator(properties).assertSuccess(), { EventBusArn: cdk.stringToCloudFormation(properties.eventBusArn) }) : properties;
    }
    function CfnEndpointEndpointEventBusPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("eventBusArn", "EventBusArn", cfn_parse.FromCloudFormation.getString(properties.EventBusArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpoint_FailoverConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("primary", cdk.requiredValidator)(properties.primary)), errors.collect(cdk.propertyValidator("primary", CfnEndpoint_PrimaryPropertyValidator)(properties.primary)), errors.collect(cdk.propertyValidator("secondary", cdk.requiredValidator)(properties.secondary)), errors.collect(cdk.propertyValidator("secondary", CfnEndpoint_SecondaryPropertyValidator)(properties.secondary)), errors.wrap('supplied properties not correct for "FailoverConfigProperty"');
    }
    function cfnEndpointFailoverConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpoint_FailoverConfigPropertyValidator(properties).assertSuccess(), { Primary: cfnEndpointPrimaryPropertyToCloudFormation(properties.primary), Secondary: cfnEndpointSecondaryPropertyToCloudFormation(properties.secondary) }) : properties;
    }
    function CfnEndpointFailoverConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("primary", "Primary", CfnEndpointPrimaryPropertyFromCloudFormation(properties.Primary)), ret.addPropertyResult("secondary", "Secondary", CfnEndpointSecondaryPropertyFromCloudFormation(properties.Secondary)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpoint_PrimaryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("healthCheck", cdk.requiredValidator)(properties.healthCheck)), errors.collect(cdk.propertyValidator("healthCheck", cdk.validateString)(properties.healthCheck)), errors.wrap('supplied properties not correct for "PrimaryProperty"');
    }
    function cfnEndpointPrimaryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpoint_PrimaryPropertyValidator(properties).assertSuccess(), { HealthCheck: cdk.stringToCloudFormation(properties.healthCheck) }) : properties;
    }
    function CfnEndpointPrimaryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("healthCheck", "HealthCheck", cfn_parse.FromCloudFormation.getString(properties.HealthCheck)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpoint_ReplicationConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("state", cdk.requiredValidator)(properties.state)), errors.collect(cdk.propertyValidator("state", cdk.validateString)(properties.state)), errors.wrap('supplied properties not correct for "ReplicationConfigProperty"');
    }
    function cfnEndpointReplicationConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpoint_ReplicationConfigPropertyValidator(properties).assertSuccess(), { State: cdk.stringToCloudFormation(properties.state) }) : properties;
    }
    function CfnEndpointReplicationConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("state", "State", cfn_parse.FromCloudFormation.getString(properties.State)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpoint_RoutingConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("failoverConfig", cdk.requiredValidator)(properties.failoverConfig)), errors.collect(cdk.propertyValidator("failoverConfig", CfnEndpoint_FailoverConfigPropertyValidator)(properties.failoverConfig)), errors.wrap('supplied properties not correct for "RoutingConfigProperty"');
    }
    function cfnEndpointRoutingConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpoint_RoutingConfigPropertyValidator(properties).assertSuccess(), { FailoverConfig: cfnEndpointFailoverConfigPropertyToCloudFormation(properties.failoverConfig) }) : properties;
    }
    function CfnEndpointRoutingConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("failoverConfig", "FailoverConfig", CfnEndpointFailoverConfigPropertyFromCloudFormation(properties.FailoverConfig)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpoint_SecondaryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("route", cdk.requiredValidator)(properties.route)), errors.collect(cdk.propertyValidator("route", cdk.validateString)(properties.route)), errors.wrap('supplied properties not correct for "SecondaryProperty"');
    }
    function cfnEndpointSecondaryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpoint_SecondaryPropertyValidator(properties).assertSuccess(), { Route: cdk.stringToCloudFormation(properties.route) }) : properties;
    }
    function CfnEndpointSecondaryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("route", "Route", cfn_parse.FromCloudFormation.getString(properties.Route)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEventBusPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("eventSourceName", cdk.validateString)(properties.eventSourceName)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(CfnEventBus_TagEntryPropertyValidator))(properties.tags)), errors.wrap('supplied properties not correct for "CfnEventBusProps"');
    }
    function cfnEventBusPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventBusPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), EventSourceName: cdk.stringToCloudFormation(properties.eventSourceName), Tags: cdk.listMapper(cfnEventBusTagEntryPropertyToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnEventBusPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("eventSourceName", "EventSourceName", properties.EventSourceName != null ? cfn_parse.FromCloudFormation.getString(properties.EventSourceName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(CfnEventBusTagEntryPropertyFromCloudFormation)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEventBus = class _CfnEventBus extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEventBusPropsFromCloudFormation(resourceProperties), ret = new _CfnEventBus(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEventBus.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_CfnEventBusProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEventBus), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.attrPolicy = cdk.Token.asString(this.getAtt("Policy", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.eventSourceName = props.eventSourceName, this.tags = props.tags;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEventBus.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, eventSourceName: this.eventSourceName, tags: this.tags };
      }
      renderProperties(props) {
        return cfnEventBusPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnEventBus[_e] = { fqn: "aws-cdk-lib.aws_events.CfnEventBus", version: "2.80.0" }, CfnEventBus.CFN_RESOURCE_TYPE_NAME = "AWS::Events::EventBus", exports2.CfnEventBus = CfnEventBus;
    function CfnEventBus_TagEntryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TagEntryProperty"');
    }
    function cfnEventBusTagEntryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventBus_TagEntryPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnEventBusTagEntryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEventBusPolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.validateString)(properties.action)), errors.collect(cdk.propertyValidator("condition", CfnEventBusPolicy_ConditionPropertyValidator)(properties.condition)), errors.collect(cdk.propertyValidator("eventBusName", cdk.validateString)(properties.eventBusName)), errors.collect(cdk.propertyValidator("principal", cdk.validateString)(properties.principal)), errors.collect(cdk.propertyValidator("statement", cdk.validateObject)(properties.statement)), errors.collect(cdk.propertyValidator("statementId", cdk.requiredValidator)(properties.statementId)), errors.collect(cdk.propertyValidator("statementId", cdk.validateString)(properties.statementId)), errors.wrap('supplied properties not correct for "CfnEventBusPolicyProps"');
    }
    function cfnEventBusPolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventBusPolicyPropsValidator(properties).assertSuccess(), { StatementId: cdk.stringToCloudFormation(properties.statementId), Action: cdk.stringToCloudFormation(properties.action), Condition: cfnEventBusPolicyConditionPropertyToCloudFormation(properties.condition), EventBusName: cdk.stringToCloudFormation(properties.eventBusName), Principal: cdk.stringToCloudFormation(properties.principal), Statement: cdk.objectToCloudFormation(properties.statement) }) : properties;
    }
    function CfnEventBusPolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("statementId", "StatementId", cfn_parse.FromCloudFormation.getString(properties.StatementId)), ret.addPropertyResult("action", "Action", properties.Action != null ? cfn_parse.FromCloudFormation.getString(properties.Action) : void 0), ret.addPropertyResult("condition", "Condition", properties.Condition != null ? CfnEventBusPolicyConditionPropertyFromCloudFormation(properties.Condition) : void 0), ret.addPropertyResult("eventBusName", "EventBusName", properties.EventBusName != null ? cfn_parse.FromCloudFormation.getString(properties.EventBusName) : void 0), ret.addPropertyResult("principal", "Principal", properties.Principal != null ? cfn_parse.FromCloudFormation.getString(properties.Principal) : void 0), ret.addPropertyResult("statement", "Statement", properties.Statement != null ? cfn_parse.FromCloudFormation.getAny(properties.Statement) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEventBusPolicy = class _CfnEventBusPolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEventBusPolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnEventBusPolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEventBusPolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_CfnEventBusPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEventBusPolicy), error;
        }
        cdk.requireProperty(props, "statementId", this), this.statementId = props.statementId, this.action = props.action, this.condition = props.condition, this.eventBusName = props.eventBusName, this.principal = props.principal, this.statement = props.statement;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEventBusPolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { statementId: this.statementId, action: this.action, condition: this.condition, eventBusName: this.eventBusName, principal: this.principal, statement: this.statement };
      }
      renderProperties(props) {
        return cfnEventBusPolicyPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnEventBusPolicy[_f] = { fqn: "aws-cdk-lib.aws_events.CfnEventBusPolicy", version: "2.80.0" }, CfnEventBusPolicy.CFN_RESOURCE_TYPE_NAME = "AWS::Events::EventBusPolicy", exports2.CfnEventBusPolicy = CfnEventBusPolicy;
    function CfnEventBusPolicy_ConditionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "ConditionProperty"');
    }
    function cfnEventBusPolicyConditionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventBusPolicy_ConditionPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Type: cdk.stringToCloudFormation(properties.type), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnEventBusPolicyConditionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRulePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("eventBusName", cdk.validateString)(properties.eventBusName)), errors.collect(cdk.propertyValidator("eventPattern", cdk.validateObject)(properties.eventPattern)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("scheduleExpression", cdk.validateString)(properties.scheduleExpression)), errors.collect(cdk.propertyValidator("state", cdk.validateString)(properties.state)), errors.collect(cdk.propertyValidator("targets", cdk.listValidator(CfnRule_TargetPropertyValidator))(properties.targets)), errors.wrap('supplied properties not correct for "CfnRuleProps"');
    }
    function cfnRulePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRulePropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), EventBusName: cdk.stringToCloudFormation(properties.eventBusName), EventPattern: cdk.objectToCloudFormation(properties.eventPattern), Name: cdk.stringToCloudFormation(properties.name), RoleArn: cdk.stringToCloudFormation(properties.roleArn), ScheduleExpression: cdk.stringToCloudFormation(properties.scheduleExpression), State: cdk.stringToCloudFormation(properties.state), Targets: cdk.listMapper(cfnRuleTargetPropertyToCloudFormation)(properties.targets) }) : properties;
    }
    function CfnRulePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("eventBusName", "EventBusName", properties.EventBusName != null ? cfn_parse.FromCloudFormation.getString(properties.EventBusName) : void 0), ret.addPropertyResult("eventPattern", "EventPattern", properties.EventPattern != null ? cfn_parse.FromCloudFormation.getAny(properties.EventPattern) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addPropertyResult("scheduleExpression", "ScheduleExpression", properties.ScheduleExpression != null ? cfn_parse.FromCloudFormation.getString(properties.ScheduleExpression) : void 0), ret.addPropertyResult("state", "State", properties.State != null ? cfn_parse.FromCloudFormation.getString(properties.State) : void 0), ret.addPropertyResult("targets", "Targets", properties.Targets != null ? cfn_parse.FromCloudFormation.getArray(CfnRuleTargetPropertyFromCloudFormation)(properties.Targets) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRule = class _CfnRule extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRulePropsFromCloudFormation(resourceProperties), ret = new _CfnRule(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnRule.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_CfnRuleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRule), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.description = props.description, this.eventBusName = props.eventBusName, this.eventPattern = props.eventPattern, this.name = props.name, this.roleArn = props.roleArn, this.scheduleExpression = props.scheduleExpression, this.state = props.state, this.targets = props.targets;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRule.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, eventBusName: this.eventBusName, eventPattern: this.eventPattern, name: this.name, roleArn: this.roleArn, scheduleExpression: this.scheduleExpression, state: this.state, targets: this.targets };
      }
      renderProperties(props) {
        return cfnRulePropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnRule[_g] = { fqn: "aws-cdk-lib.aws_events.CfnRule", version: "2.80.0" }, CfnRule.CFN_RESOURCE_TYPE_NAME = "AWS::Events::Rule", exports2.CfnRule = CfnRule;
    function CfnRule_AwsVpcConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("assignPublicIp", cdk.validateString)(properties.assignPublicIp)), errors.collect(cdk.propertyValidator("securityGroups", cdk.listValidator(cdk.validateString))(properties.securityGroups)), errors.collect(cdk.propertyValidator("subnets", cdk.requiredValidator)(properties.subnets)), errors.collect(cdk.propertyValidator("subnets", cdk.listValidator(cdk.validateString))(properties.subnets)), errors.wrap('supplied properties not correct for "AwsVpcConfigurationProperty"');
    }
    function cfnRuleAwsVpcConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_AwsVpcConfigurationPropertyValidator(properties).assertSuccess(), { AssignPublicIp: cdk.stringToCloudFormation(properties.assignPublicIp), SecurityGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroups), Subnets: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnets) }) : properties;
    }
    function CfnRuleAwsVpcConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("assignPublicIp", "AssignPublicIp", properties.AssignPublicIp != null ? cfn_parse.FromCloudFormation.getString(properties.AssignPublicIp) : void 0), ret.addPropertyResult("securityGroups", "SecurityGroups", properties.SecurityGroups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroups) : void 0), ret.addPropertyResult("subnets", "Subnets", cfn_parse.FromCloudFormation.getStringArray(properties.Subnets)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_BatchArrayPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("size", cdk.validateNumber)(properties.size)), errors.wrap('supplied properties not correct for "BatchArrayPropertiesProperty"');
    }
    function cfnRuleBatchArrayPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_BatchArrayPropertiesPropertyValidator(properties).assertSuccess(), { Size: cdk.numberToCloudFormation(properties.size) }) : properties;
    }
    function CfnRuleBatchArrayPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("size", "Size", properties.Size != null ? cfn_parse.FromCloudFormation.getNumber(properties.Size) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_BatchParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arrayProperties", CfnRule_BatchArrayPropertiesPropertyValidator)(properties.arrayProperties)), errors.collect(cdk.propertyValidator("jobDefinition", cdk.requiredValidator)(properties.jobDefinition)), errors.collect(cdk.propertyValidator("jobDefinition", cdk.validateString)(properties.jobDefinition)), errors.collect(cdk.propertyValidator("jobName", cdk.requiredValidator)(properties.jobName)), errors.collect(cdk.propertyValidator("jobName", cdk.validateString)(properties.jobName)), errors.collect(cdk.propertyValidator("retryStrategy", CfnRule_BatchRetryStrategyPropertyValidator)(properties.retryStrategy)), errors.wrap('supplied properties not correct for "BatchParametersProperty"');
    }
    function cfnRuleBatchParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_BatchParametersPropertyValidator(properties).assertSuccess(), { ArrayProperties: cfnRuleBatchArrayPropertiesPropertyToCloudFormation(properties.arrayProperties), JobDefinition: cdk.stringToCloudFormation(properties.jobDefinition), JobName: cdk.stringToCloudFormation(properties.jobName), RetryStrategy: cfnRuleBatchRetryStrategyPropertyToCloudFormation(properties.retryStrategy) }) : properties;
    }
    function CfnRuleBatchParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arrayProperties", "ArrayProperties", properties.ArrayProperties != null ? CfnRuleBatchArrayPropertiesPropertyFromCloudFormation(properties.ArrayProperties) : void 0), ret.addPropertyResult("jobDefinition", "JobDefinition", cfn_parse.FromCloudFormation.getString(properties.JobDefinition)), ret.addPropertyResult("jobName", "JobName", cfn_parse.FromCloudFormation.getString(properties.JobName)), ret.addPropertyResult("retryStrategy", "RetryStrategy", properties.RetryStrategy != null ? CfnRuleBatchRetryStrategyPropertyFromCloudFormation(properties.RetryStrategy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_BatchRetryStrategyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attempts", cdk.validateNumber)(properties.attempts)), errors.wrap('supplied properties not correct for "BatchRetryStrategyProperty"');
    }
    function cfnRuleBatchRetryStrategyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_BatchRetryStrategyPropertyValidator(properties).assertSuccess(), { Attempts: cdk.numberToCloudFormation(properties.attempts) }) : properties;
    }
    function CfnRuleBatchRetryStrategyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attempts", "Attempts", properties.Attempts != null ? cfn_parse.FromCloudFormation.getNumber(properties.Attempts) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_CapacityProviderStrategyItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("base", cdk.validateNumber)(properties.base)), errors.collect(cdk.propertyValidator("capacityProvider", cdk.requiredValidator)(properties.capacityProvider)), errors.collect(cdk.propertyValidator("capacityProvider", cdk.validateString)(properties.capacityProvider)), errors.collect(cdk.propertyValidator("weight", cdk.validateNumber)(properties.weight)), errors.wrap('supplied properties not correct for "CapacityProviderStrategyItemProperty"');
    }
    function cfnRuleCapacityProviderStrategyItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_CapacityProviderStrategyItemPropertyValidator(properties).assertSuccess(), { Base: cdk.numberToCloudFormation(properties.base), CapacityProvider: cdk.stringToCloudFormation(properties.capacityProvider), Weight: cdk.numberToCloudFormation(properties.weight) }) : properties;
    }
    function CfnRuleCapacityProviderStrategyItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("base", "Base", properties.Base != null ? cfn_parse.FromCloudFormation.getNumber(properties.Base) : void 0), ret.addPropertyResult("capacityProvider", "CapacityProvider", cfn_parse.FromCloudFormation.getString(properties.CapacityProvider)), ret.addPropertyResult("weight", "Weight", properties.Weight != null ? cfn_parse.FromCloudFormation.getNumber(properties.Weight) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_DeadLetterConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.wrap('supplied properties not correct for "DeadLetterConfigProperty"');
    }
    function cfnRuleDeadLetterConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_DeadLetterConfigPropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn) }) : properties;
    }
    function CfnRuleDeadLetterConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", properties.Arn != null ? cfn_parse.FromCloudFormation.getString(properties.Arn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_EcsParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("capacityProviderStrategy", cdk.listValidator(CfnRule_CapacityProviderStrategyItemPropertyValidator))(properties.capacityProviderStrategy)), errors.collect(cdk.propertyValidator("enableEcsManagedTags", cdk.validateBoolean)(properties.enableEcsManagedTags)), errors.collect(cdk.propertyValidator("enableExecuteCommand", cdk.validateBoolean)(properties.enableExecuteCommand)), errors.collect(cdk.propertyValidator("group", cdk.validateString)(properties.group)), errors.collect(cdk.propertyValidator("launchType", cdk.validateString)(properties.launchType)), errors.collect(cdk.propertyValidator("networkConfiguration", CfnRule_NetworkConfigurationPropertyValidator)(properties.networkConfiguration)), errors.collect(cdk.propertyValidator("placementConstraints", cdk.listValidator(CfnRule_PlacementConstraintPropertyValidator))(properties.placementConstraints)), errors.collect(cdk.propertyValidator("placementStrategies", cdk.listValidator(CfnRule_PlacementStrategyPropertyValidator))(properties.placementStrategies)), errors.collect(cdk.propertyValidator("platformVersion", cdk.validateString)(properties.platformVersion)), errors.collect(cdk.propertyValidator("propagateTags", cdk.validateString)(properties.propagateTags)), errors.collect(cdk.propertyValidator("referenceId", cdk.validateString)(properties.referenceId)), errors.collect(cdk.propertyValidator("tagList", cdk.listValidator(cdk.validateCfnTag))(properties.tagList)), errors.collect(cdk.propertyValidator("taskCount", cdk.validateNumber)(properties.taskCount)), errors.collect(cdk.propertyValidator("taskDefinitionArn", cdk.requiredValidator)(properties.taskDefinitionArn)), errors.collect(cdk.propertyValidator("taskDefinitionArn", cdk.validateString)(properties.taskDefinitionArn)), errors.wrap('supplied properties not correct for "EcsParametersProperty"');
    }
    function cfnRuleEcsParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_EcsParametersPropertyValidator(properties).assertSuccess(), { CapacityProviderStrategy: cdk.listMapper(cfnRuleCapacityProviderStrategyItemPropertyToCloudFormation)(properties.capacityProviderStrategy), EnableECSManagedTags: cdk.booleanToCloudFormation(properties.enableEcsManagedTags), EnableExecuteCommand: cdk.booleanToCloudFormation(properties.enableExecuteCommand), Group: cdk.stringToCloudFormation(properties.group), LaunchType: cdk.stringToCloudFormation(properties.launchType), NetworkConfiguration: cfnRuleNetworkConfigurationPropertyToCloudFormation(properties.networkConfiguration), PlacementConstraints: cdk.listMapper(cfnRulePlacementConstraintPropertyToCloudFormation)(properties.placementConstraints), PlacementStrategies: cdk.listMapper(cfnRulePlacementStrategyPropertyToCloudFormation)(properties.placementStrategies), PlatformVersion: cdk.stringToCloudFormation(properties.platformVersion), PropagateTags: cdk.stringToCloudFormation(properties.propagateTags), ReferenceId: cdk.stringToCloudFormation(properties.referenceId), TagList: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tagList), TaskCount: cdk.numberToCloudFormation(properties.taskCount), TaskDefinitionArn: cdk.stringToCloudFormation(properties.taskDefinitionArn) }) : properties;
    }
    function CfnRuleEcsParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("capacityProviderStrategy", "CapacityProviderStrategy", properties.CapacityProviderStrategy != null ? cfn_parse.FromCloudFormation.getArray(CfnRuleCapacityProviderStrategyItemPropertyFromCloudFormation)(properties.CapacityProviderStrategy) : void 0), ret.addPropertyResult("enableEcsManagedTags", "EnableECSManagedTags", properties.EnableECSManagedTags != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableECSManagedTags) : void 0), ret.addPropertyResult("enableExecuteCommand", "EnableExecuteCommand", properties.EnableExecuteCommand != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableExecuteCommand) : void 0), ret.addPropertyResult("group", "Group", properties.Group != null ? cfn_parse.FromCloudFormation.getString(properties.Group) : void 0), ret.addPropertyResult("launchType", "LaunchType", properties.LaunchType != null ? cfn_parse.FromCloudFormation.getString(properties.LaunchType) : void 0), ret.addPropertyResult("networkConfiguration", "NetworkConfiguration", properties.NetworkConfiguration != null ? CfnRuleNetworkConfigurationPropertyFromCloudFormation(properties.NetworkConfiguration) : void 0), ret.addPropertyResult("placementConstraints", "PlacementConstraints", properties.PlacementConstraints != null ? cfn_parse.FromCloudFormation.getArray(CfnRulePlacementConstraintPropertyFromCloudFormation)(properties.PlacementConstraints) : void 0), ret.addPropertyResult("placementStrategies", "PlacementStrategies", properties.PlacementStrategies != null ? cfn_parse.FromCloudFormation.getArray(CfnRulePlacementStrategyPropertyFromCloudFormation)(properties.PlacementStrategies) : void 0), ret.addPropertyResult("platformVersion", "PlatformVersion", properties.PlatformVersion != null ? cfn_parse.FromCloudFormation.getString(properties.PlatformVersion) : void 0), ret.addPropertyResult("propagateTags", "PropagateTags", properties.PropagateTags != null ? cfn_parse.FromCloudFormation.getString(properties.PropagateTags) : void 0), ret.addPropertyResult("referenceId", "ReferenceId", properties.ReferenceId != null ? cfn_parse.FromCloudFormation.getString(properties.ReferenceId) : void 0), ret.addPropertyResult("tagList", "TagList", properties.TagList != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.TagList) : void 0), ret.addPropertyResult("taskCount", "TaskCount", properties.TaskCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.TaskCount) : void 0), ret.addPropertyResult("taskDefinitionArn", "TaskDefinitionArn", cfn_parse.FromCloudFormation.getString(properties.TaskDefinitionArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_HttpParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("headerParameters", cdk.hashValidator(cdk.validateString))(properties.headerParameters)), errors.collect(cdk.propertyValidator("pathParameterValues", cdk.listValidator(cdk.validateString))(properties.pathParameterValues)), errors.collect(cdk.propertyValidator("queryStringParameters", cdk.hashValidator(cdk.validateString))(properties.queryStringParameters)), errors.wrap('supplied properties not correct for "HttpParametersProperty"');
    }
    function cfnRuleHttpParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_HttpParametersPropertyValidator(properties).assertSuccess(), { HeaderParameters: cdk.hashMapper(cdk.stringToCloudFormation)(properties.headerParameters), PathParameterValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.pathParameterValues), QueryStringParameters: cdk.hashMapper(cdk.stringToCloudFormation)(properties.queryStringParameters) }) : properties;
    }
    function CfnRuleHttpParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("headerParameters", "HeaderParameters", properties.HeaderParameters != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.HeaderParameters) : void 0), ret.addPropertyResult("pathParameterValues", "PathParameterValues", properties.PathParameterValues != null ? cfn_parse.FromCloudFormation.getStringArray(properties.PathParameterValues) : void 0), ret.addPropertyResult("queryStringParameters", "QueryStringParameters", properties.QueryStringParameters != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.QueryStringParameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_InputTransformerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("inputPathsMap", cdk.hashValidator(cdk.validateString))(properties.inputPathsMap)), errors.collect(cdk.propertyValidator("inputTemplate", cdk.requiredValidator)(properties.inputTemplate)), errors.collect(cdk.propertyValidator("inputTemplate", cdk.validateString)(properties.inputTemplate)), errors.wrap('supplied properties not correct for "InputTransformerProperty"');
    }
    function cfnRuleInputTransformerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_InputTransformerPropertyValidator(properties).assertSuccess(), { InputPathsMap: cdk.hashMapper(cdk.stringToCloudFormation)(properties.inputPathsMap), InputTemplate: cdk.stringToCloudFormation(properties.inputTemplate) }) : properties;
    }
    function CfnRuleInputTransformerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("inputPathsMap", "InputPathsMap", properties.InputPathsMap != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.InputPathsMap) : void 0), ret.addPropertyResult("inputTemplate", "InputTemplate", cfn_parse.FromCloudFormation.getString(properties.InputTemplate)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_KinesisParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("partitionKeyPath", cdk.requiredValidator)(properties.partitionKeyPath)), errors.collect(cdk.propertyValidator("partitionKeyPath", cdk.validateString)(properties.partitionKeyPath)), errors.wrap('supplied properties not correct for "KinesisParametersProperty"');
    }
    function cfnRuleKinesisParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_KinesisParametersPropertyValidator(properties).assertSuccess(), { PartitionKeyPath: cdk.stringToCloudFormation(properties.partitionKeyPath) }) : properties;
    }
    function CfnRuleKinesisParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("partitionKeyPath", "PartitionKeyPath", cfn_parse.FromCloudFormation.getString(properties.PartitionKeyPath)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_NetworkConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("awsVpcConfiguration", CfnRule_AwsVpcConfigurationPropertyValidator)(properties.awsVpcConfiguration)), errors.wrap('supplied properties not correct for "NetworkConfigurationProperty"');
    }
    function cfnRuleNetworkConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_NetworkConfigurationPropertyValidator(properties).assertSuccess(), { AwsVpcConfiguration: cfnRuleAwsVpcConfigurationPropertyToCloudFormation(properties.awsVpcConfiguration) }) : properties;
    }
    function CfnRuleNetworkConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("awsVpcConfiguration", "AwsVpcConfiguration", properties.AwsVpcConfiguration != null ? CfnRuleAwsVpcConfigurationPropertyFromCloudFormation(properties.AwsVpcConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_PlacementConstraintPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "PlacementConstraintProperty"');
    }
    function cfnRulePlacementConstraintPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_PlacementConstraintPropertyValidator(properties).assertSuccess(), { Expression: cdk.stringToCloudFormation(properties.expression), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnRulePlacementConstraintPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("expression", "Expression", properties.Expression != null ? cfn_parse.FromCloudFormation.getString(properties.Expression) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_PlacementStrategyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("field", cdk.validateString)(properties.field)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "PlacementStrategyProperty"');
    }
    function cfnRulePlacementStrategyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_PlacementStrategyPropertyValidator(properties).assertSuccess(), { Field: cdk.stringToCloudFormation(properties.field), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnRulePlacementStrategyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("field", "Field", properties.Field != null ? cfn_parse.FromCloudFormation.getString(properties.Field) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_RedshiftDataParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("database", cdk.requiredValidator)(properties.database)), errors.collect(cdk.propertyValidator("database", cdk.validateString)(properties.database)), errors.collect(cdk.propertyValidator("dbUser", cdk.validateString)(properties.dbUser)), errors.collect(cdk.propertyValidator("secretManagerArn", cdk.validateString)(properties.secretManagerArn)), errors.collect(cdk.propertyValidator("sql", cdk.requiredValidator)(properties.sql)), errors.collect(cdk.propertyValidator("sql", cdk.validateString)(properties.sql)), errors.collect(cdk.propertyValidator("statementName", cdk.validateString)(properties.statementName)), errors.collect(cdk.propertyValidator("withEvent", cdk.validateBoolean)(properties.withEvent)), errors.wrap('supplied properties not correct for "RedshiftDataParametersProperty"');
    }
    function cfnRuleRedshiftDataParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_RedshiftDataParametersPropertyValidator(properties).assertSuccess(), { Database: cdk.stringToCloudFormation(properties.database), DbUser: cdk.stringToCloudFormation(properties.dbUser), SecretManagerArn: cdk.stringToCloudFormation(properties.secretManagerArn), Sql: cdk.stringToCloudFormation(properties.sql), StatementName: cdk.stringToCloudFormation(properties.statementName), WithEvent: cdk.booleanToCloudFormation(properties.withEvent) }) : properties;
    }
    function CfnRuleRedshiftDataParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("database", "Database", cfn_parse.FromCloudFormation.getString(properties.Database)), ret.addPropertyResult("dbUser", "DbUser", properties.DbUser != null ? cfn_parse.FromCloudFormation.getString(properties.DbUser) : void 0), ret.addPropertyResult("secretManagerArn", "SecretManagerArn", properties.SecretManagerArn != null ? cfn_parse.FromCloudFormation.getString(properties.SecretManagerArn) : void 0), ret.addPropertyResult("sql", "Sql", cfn_parse.FromCloudFormation.getString(properties.Sql)), ret.addPropertyResult("statementName", "StatementName", properties.StatementName != null ? cfn_parse.FromCloudFormation.getString(properties.StatementName) : void 0), ret.addPropertyResult("withEvent", "WithEvent", properties.WithEvent != null ? cfn_parse.FromCloudFormation.getBoolean(properties.WithEvent) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_RetryPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maximumEventAgeInSeconds", cdk.validateNumber)(properties.maximumEventAgeInSeconds)), errors.collect(cdk.propertyValidator("maximumRetryAttempts", cdk.validateNumber)(properties.maximumRetryAttempts)), errors.wrap('supplied properties not correct for "RetryPolicyProperty"');
    }
    function cfnRuleRetryPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_RetryPolicyPropertyValidator(properties).assertSuccess(), { MaximumEventAgeInSeconds: cdk.numberToCloudFormation(properties.maximumEventAgeInSeconds), MaximumRetryAttempts: cdk.numberToCloudFormation(properties.maximumRetryAttempts) }) : properties;
    }
    function CfnRuleRetryPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maximumEventAgeInSeconds", "MaximumEventAgeInSeconds", properties.MaximumEventAgeInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumEventAgeInSeconds) : void 0), ret.addPropertyResult("maximumRetryAttempts", "MaximumRetryAttempts", properties.MaximumRetryAttempts != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumRetryAttempts) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_RunCommandParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("runCommandTargets", cdk.requiredValidator)(properties.runCommandTargets)), errors.collect(cdk.propertyValidator("runCommandTargets", cdk.listValidator(CfnRule_RunCommandTargetPropertyValidator))(properties.runCommandTargets)), errors.wrap('supplied properties not correct for "RunCommandParametersProperty"');
    }
    function cfnRuleRunCommandParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_RunCommandParametersPropertyValidator(properties).assertSuccess(), { RunCommandTargets: cdk.listMapper(cfnRuleRunCommandTargetPropertyToCloudFormation)(properties.runCommandTargets) }) : properties;
    }
    function CfnRuleRunCommandParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("runCommandTargets", "RunCommandTargets", cfn_parse.FromCloudFormation.getArray(CfnRuleRunCommandTargetPropertyFromCloudFormation)(properties.RunCommandTargets)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_RunCommandTargetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("values", cdk.requiredValidator)(properties.values)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "RunCommandTargetProperty"');
    }
    function cfnRuleRunCommandTargetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_RunCommandTargetPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnRuleRunCommandTargetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("values", "Values", cfn_parse.FromCloudFormation.getStringArray(properties.Values)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_SageMakerPipelineParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "SageMakerPipelineParameterProperty"');
    }
    function cfnRuleSageMakerPipelineParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_SageMakerPipelineParameterPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnRuleSageMakerPipelineParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_SageMakerPipelineParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("pipelineParameterList", cdk.listValidator(CfnRule_SageMakerPipelineParameterPropertyValidator))(properties.pipelineParameterList)), errors.wrap('supplied properties not correct for "SageMakerPipelineParametersProperty"');
    }
    function cfnRuleSageMakerPipelineParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_SageMakerPipelineParametersPropertyValidator(properties).assertSuccess(), { PipelineParameterList: cdk.listMapper(cfnRuleSageMakerPipelineParameterPropertyToCloudFormation)(properties.pipelineParameterList) }) : properties;
    }
    function CfnRuleSageMakerPipelineParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("pipelineParameterList", "PipelineParameterList", properties.PipelineParameterList != null ? cfn_parse.FromCloudFormation.getArray(CfnRuleSageMakerPipelineParameterPropertyFromCloudFormation)(properties.PipelineParameterList) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_SqsParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("messageGroupId", cdk.requiredValidator)(properties.messageGroupId)), errors.collect(cdk.propertyValidator("messageGroupId", cdk.validateString)(properties.messageGroupId)), errors.wrap('supplied properties not correct for "SqsParametersProperty"');
    }
    function cfnRuleSqsParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_SqsParametersPropertyValidator(properties).assertSuccess(), { MessageGroupId: cdk.stringToCloudFormation(properties.messageGroupId) }) : properties;
    }
    function CfnRuleSqsParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("messageGroupId", "MessageGroupId", cfn_parse.FromCloudFormation.getString(properties.MessageGroupId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_TargetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.requiredValidator)(properties.arn)), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("batchParameters", CfnRule_BatchParametersPropertyValidator)(properties.batchParameters)), errors.collect(cdk.propertyValidator("deadLetterConfig", CfnRule_DeadLetterConfigPropertyValidator)(properties.deadLetterConfig)), errors.collect(cdk.propertyValidator("ecsParameters", CfnRule_EcsParametersPropertyValidator)(properties.ecsParameters)), errors.collect(cdk.propertyValidator("httpParameters", CfnRule_HttpParametersPropertyValidator)(properties.httpParameters)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("input", cdk.validateString)(properties.input)), errors.collect(cdk.propertyValidator("inputPath", cdk.validateString)(properties.inputPath)), errors.collect(cdk.propertyValidator("inputTransformer", CfnRule_InputTransformerPropertyValidator)(properties.inputTransformer)), errors.collect(cdk.propertyValidator("kinesisParameters", CfnRule_KinesisParametersPropertyValidator)(properties.kinesisParameters)), errors.collect(cdk.propertyValidator("redshiftDataParameters", CfnRule_RedshiftDataParametersPropertyValidator)(properties.redshiftDataParameters)), errors.collect(cdk.propertyValidator("retryPolicy", CfnRule_RetryPolicyPropertyValidator)(properties.retryPolicy)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("runCommandParameters", CfnRule_RunCommandParametersPropertyValidator)(properties.runCommandParameters)), errors.collect(cdk.propertyValidator("sageMakerPipelineParameters", CfnRule_SageMakerPipelineParametersPropertyValidator)(properties.sageMakerPipelineParameters)), errors.collect(cdk.propertyValidator("sqsParameters", CfnRule_SqsParametersPropertyValidator)(properties.sqsParameters)), errors.wrap('supplied properties not correct for "TargetProperty"');
    }
    function cfnRuleTargetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_TargetPropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn), BatchParameters: cfnRuleBatchParametersPropertyToCloudFormation(properties.batchParameters), DeadLetterConfig: cfnRuleDeadLetterConfigPropertyToCloudFormation(properties.deadLetterConfig), EcsParameters: cfnRuleEcsParametersPropertyToCloudFormation(properties.ecsParameters), HttpParameters: cfnRuleHttpParametersPropertyToCloudFormation(properties.httpParameters), Id: cdk.stringToCloudFormation(properties.id), Input: cdk.stringToCloudFormation(properties.input), InputPath: cdk.stringToCloudFormation(properties.inputPath), InputTransformer: cfnRuleInputTransformerPropertyToCloudFormation(properties.inputTransformer), KinesisParameters: cfnRuleKinesisParametersPropertyToCloudFormation(properties.kinesisParameters), RedshiftDataParameters: cfnRuleRedshiftDataParametersPropertyToCloudFormation(properties.redshiftDataParameters), RetryPolicy: cfnRuleRetryPolicyPropertyToCloudFormation(properties.retryPolicy), RoleArn: cdk.stringToCloudFormation(properties.roleArn), RunCommandParameters: cfnRuleRunCommandParametersPropertyToCloudFormation(properties.runCommandParameters), SageMakerPipelineParameters: cfnRuleSageMakerPipelineParametersPropertyToCloudFormation(properties.sageMakerPipelineParameters), SqsParameters: cfnRuleSqsParametersPropertyToCloudFormation(properties.sqsParameters) }) : properties;
    }
    function CfnRuleTargetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", cfn_parse.FromCloudFormation.getString(properties.Arn)), ret.addPropertyResult("batchParameters", "BatchParameters", properties.BatchParameters != null ? CfnRuleBatchParametersPropertyFromCloudFormation(properties.BatchParameters) : void 0), ret.addPropertyResult("deadLetterConfig", "DeadLetterConfig", properties.DeadLetterConfig != null ? CfnRuleDeadLetterConfigPropertyFromCloudFormation(properties.DeadLetterConfig) : void 0), ret.addPropertyResult("ecsParameters", "EcsParameters", properties.EcsParameters != null ? CfnRuleEcsParametersPropertyFromCloudFormation(properties.EcsParameters) : void 0), ret.addPropertyResult("httpParameters", "HttpParameters", properties.HttpParameters != null ? CfnRuleHttpParametersPropertyFromCloudFormation(properties.HttpParameters) : void 0), ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("input", "Input", properties.Input != null ? cfn_parse.FromCloudFormation.getString(properties.Input) : void 0), ret.addPropertyResult("inputPath", "InputPath", properties.InputPath != null ? cfn_parse.FromCloudFormation.getString(properties.InputPath) : void 0), ret.addPropertyResult("inputTransformer", "InputTransformer", properties.InputTransformer != null ? CfnRuleInputTransformerPropertyFromCloudFormation(properties.InputTransformer) : void 0), ret.addPropertyResult("kinesisParameters", "KinesisParameters", properties.KinesisParameters != null ? CfnRuleKinesisParametersPropertyFromCloudFormation(properties.KinesisParameters) : void 0), ret.addPropertyResult("redshiftDataParameters", "RedshiftDataParameters", properties.RedshiftDataParameters != null ? CfnRuleRedshiftDataParametersPropertyFromCloudFormation(properties.RedshiftDataParameters) : void 0), ret.addPropertyResult("retryPolicy", "RetryPolicy", properties.RetryPolicy != null ? CfnRuleRetryPolicyPropertyFromCloudFormation(properties.RetryPolicy) : void 0), ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addPropertyResult("runCommandParameters", "RunCommandParameters", properties.RunCommandParameters != null ? CfnRuleRunCommandParametersPropertyFromCloudFormation(properties.RunCommandParameters) : void 0), ret.addPropertyResult("sageMakerPipelineParameters", "SageMakerPipelineParameters", properties.SageMakerPipelineParameters != null ? CfnRuleSageMakerPipelineParametersPropertyFromCloudFormation(properties.SageMakerPipelineParameters) : void 0), ret.addPropertyResult("sqsParameters", "SqsParameters", properties.SqsParameters != null ? CfnRuleSqsParametersPropertyFromCloudFormation(properties.SqsParameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-events/lib/schedule.js
var require_schedule = __commonJS({
  "node_modules/aws-cdk-lib/aws-events/lib/schedule.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Schedule = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core_1 = require_core2();
    var Schedule = class _Schedule {
      static expression(expression) {
        return new LiteralSchedule(expression);
      }
      static rate(duration) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Duration(duration);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.rate), error;
        }
        if (duration.isUnresolved()) {
          if (["minute", "minutes", "hour", "hours", "day", "days"].indexOf(duration.unitLabel()) === -1)
            throw new Error("Allowed units for scheduling are: 'minute', 'minutes', 'hour', 'hours', 'day', 'days'");
          return new LiteralSchedule(`rate(${duration.formatTokenToNumber()})`);
        }
        if (duration.toMinutes() === 0)
          throw new Error("Duration cannot be 0");
        let rate = maybeRate(duration.toDays({ integral: false }), "day");
        return rate === void 0 && (rate = maybeRate(duration.toHours({ integral: false }), "hour")), rate === void 0 && (rate = makeRate(duration.toMinutes({ integral: true }), "minute")), new LiteralSchedule(rate);
      }
      static cron(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_CronOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.cron), error;
        }
        if (options.weekDay !== void 0 && options.day !== void 0)
          throw new Error("Cannot supply both 'day' and 'weekDay', use at most one");
        const minute = fallback(options.minute, "*"), hour = fallback(options.hour, "*"), month = fallback(options.month, "*"), year = fallback(options.year, "*"), day = fallback(options.day, options.weekDay !== void 0 ? "?" : "*"), weekDay = fallback(options.weekDay, "?");
        return new class extends _Schedule {
          constructor() {
            super(...arguments), this.expressionString = `cron(${minute} ${hour} ${day} ${month} ${weekDay} ${year})`;
          }
          _bind(scope) {
            return options.minute || core_1.Annotations.of(scope).addWarning("cron: If you don't pass 'minute', by default the event runs every minute. Pass 'minute: '*'' if that's what you intend, or 'minute: 0' to run once per hour instead."), new LiteralSchedule(this.expressionString);
          }
        }();
      }
      constructor() {
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Schedule[_a] = { fqn: "aws-cdk-lib.aws_events.Schedule", version: "2.80.0" }, exports2.Schedule = Schedule;
    var LiteralSchedule = class extends Schedule {
      constructor(expressionString) {
        super(), this.expressionString = expressionString;
      }
      _bind() {
      }
    };
    function fallback(x, def) {
      return x ?? def;
    }
    function maybeRate(interval, singular) {
      if (!(interval === 0 || !Number.isInteger(interval)))
        return makeRate(interval, singular);
    }
    function makeRate(interval, singular) {
      return interval === 1 ? `rate(1 ${singular})` : `rate(${interval} ${singular}s)`;
    }
  }
});

// node_modules/aws-cdk-lib/aws-events/lib/util.js
var require_util7 = __commonJS({
  "node_modules/aws-cdk-lib/aws-events/lib/util.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.renderEventPattern = exports2.mergeEventPattern = void 0;
    function mergeEventPattern(dest, src) {
      return dest = dest || {}, mergeObject(dest, src), dest;
      function mergeObject(destObj, srcObj) {
        if (typeof srcObj != "object")
          throw new Error(`Invalid event pattern '${JSON.stringify(srcObj)}', expecting an object or an array`);
        for (const field of Object.keys(srcObj)) {
          const srcValue = srcObj[field], destValue = destObj[field];
          if (srcValue !== void 0) {
            if (typeof srcValue != "object")
              throw new Error(`Invalid event pattern field { ${field}: ${JSON.stringify(srcValue)} }. All fields must be arrays`);
            if (destObj[field] === void 0) {
              destObj[field] = srcValue;
              continue;
            }
            if (Array.isArray(srcValue) !== Array.isArray(destValue))
              throw new Error(`Invalid event pattern field ${field}. Type mismatch between existing pattern ${JSON.stringify(destValue)} and added pattern ${JSON.stringify(srcValue)}`);
            if (Array.isArray(srcValue)) {
              const result = [...destValue, ...srcValue], resultJson = result.map((i) => JSON.stringify(i));
              destObj[field] = result.filter((value, index) => resultJson.indexOf(JSON.stringify(value)) === index);
              continue;
            }
            mergeObject(destObj[field], srcValue);
          }
        }
      }
    }
    exports2.mergeEventPattern = mergeEventPattern;
    function renderEventPattern(eventPattern) {
      if (Object.keys(eventPattern).length === 0)
        return;
      const out = {};
      for (let key of Object.keys(eventPattern)) {
        const value = eventPattern[key];
        key === "detailType" && (key = "detail-type"), out[key] = value;
      }
      return out;
    }
    exports2.renderEventPattern = renderEventPattern;
  }
});

// node_modules/aws-cdk-lib/aws-events/lib/rule.js
var require_rule = __commonJS({
  "node_modules/aws-cdk-lib/aws-events/lib/rule.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Rule = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var events_generated_1 = require_events_generated();
    var schedule_1 = require_schedule();
    var util_1 = require_util7();
    var aws_iam_1 = require_aws_iam();
    var core_1 = require_core2();
    var Rule = class _Rule extends core_1.Resource {
      static fromEventRuleArn(scope, id, eventRuleArn) {
        const parts = core_1.Stack.of(scope).splitArn(eventRuleArn, core_1.ArnFormat.SLASH_RESOURCE_NAME);
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.ruleArn = eventRuleArn, this.ruleName = parts.resourceName || "";
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props = {}) {
        super(determineRuleScope(scope, props), id, { physicalName: props.ruleName }), this.targets = new Array(), this.eventPattern = {}, this._xEnvTargetsAdded = /* @__PURE__ */ new Set();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_RuleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Rule), error;
        }
        if (props.eventBus && props.schedule)
          throw new Error("Cannot associate rule with 'eventBus' when using 'schedule'");
        this.description = props.description, this.scheduleExpression = props.schedule?.expressionString, props.schedule?._bind(this);
        const resource = new events_generated_1.CfnRule(this, "Resource", { name: this.physicalName, description: this.description, state: props.enabled == null || props.enabled ? "ENABLED" : "DISABLED", scheduleExpression: this.scheduleExpression, eventPattern: core_1.Lazy.any({ produce: () => this._renderEventPattern() }), targets: core_1.Lazy.any({ produce: () => this.renderTargets() }), eventBusName: props.eventBus && props.eventBus.eventBusName });
        this.ruleArn = this.getResourceArnAttribute(resource.attrArn, { service: "events", resource: "rule", resourceName: this.physicalName }), this.ruleName = this.getResourceNameAttribute(resource.ref), this.addEventPattern(props.eventPattern);
        for (const target of props.targets || [])
          this.addTarget(target);
        this.node.addValidation({ validate: () => this.validateRule() });
      }
      addTarget(target) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_IRuleTarget(target);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addTarget), error;
        }
        if (!target)
          return;
        const autoGeneratedId = `Target${this.targets.length}`, targetProps = target.bind(this, autoGeneratedId), inputProps = targetProps.input && targetProps.input.bind(this), roleArn = targetProps.role?.roleArn, id = targetProps.id || autoGeneratedId;
        if (targetProps.targetResource) {
          const targetStack = core_1.Stack.of(targetProps.targetResource), targetAccount = targetProps.targetResource.env?.account || targetStack.account, targetRegion = targetProps.targetResource.env?.region || targetStack.region, sourceStack = core_1.Stack.of(this), sourceAccount = sourceStack.account, sourceRegion = sourceStack.region;
          if (!this.sameEnvDimension(sourceAccount, targetAccount) || !this.sameEnvDimension(sourceRegion, targetRegion)) {
            if (!targetAccount || core_1.Token.isUnresolved(targetAccount))
              throw new Error("You need to provide a concrete account for the target stack when using cross-account or cross-region events");
            if (!targetRegion || core_1.Token.isUnresolved(targetRegion))
              throw new Error("You need to provide a concrete region for the target stack when using cross-account or cross-region events");
            if (core_1.Token.isUnresolved(sourceAccount))
              throw new Error("You need to provide a concrete account for the source stack when using cross-account or cross-region events");
            const sourceApp = this.node.root;
            if (!sourceApp || !core_1.App.isApp(sourceApp))
              throw new Error("Event stack which uses cross-account or cross-region targets must be part of a CDK app");
            const targetApp = constructs_1.Node.of(targetProps.targetResource).root;
            if (!targetApp || !core_1.App.isApp(targetApp))
              throw new Error("Target stack which uses cross-account or cross-region event targets must be part of a CDK app");
            if (sourceApp !== targetApp)
              throw new Error("Event stack and target stack must belong to the same CDK app");
            this.ensureXEnvTargetEventBus(targetStack, targetAccount, targetRegion, id);
            const mirrorRuleScope = this.obtainMirrorRuleScope(targetStack, targetAccount, targetRegion);
            new MirrorRule(mirrorRuleScope, `${core_1.Names.uniqueId(this)}-${id}`, { targets: [target], eventPattern: this.eventPattern, schedule: this.scheduleExpression ? schedule_1.Schedule.expression(this.scheduleExpression) : void 0, description: this.description }, this);
            return;
          }
        }
        this.targets.push({ id, arn: targetProps.arn, roleArn, ecsParameters: targetProps.ecsParameters, httpParameters: targetProps.httpParameters, kinesisParameters: targetProps.kinesisParameters, runCommandParameters: targetProps.runCommandParameters, batchParameters: targetProps.batchParameters, deadLetterConfig: targetProps.deadLetterConfig, retryPolicy: targetProps.retryPolicy, sqsParameters: targetProps.sqsParameters, input: inputProps && inputProps.input, inputPath: inputProps && inputProps.inputPath, inputTransformer: inputProps?.inputTemplate !== void 0 ? { inputTemplate: inputProps.inputTemplate, inputPathsMap: inputProps.inputPathsMap } : void 0 });
      }
      addEventPattern(eventPattern) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_EventPattern(eventPattern);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addEventPattern), error;
        }
        eventPattern && (0, util_1.mergeEventPattern)(this.eventPattern, eventPattern);
      }
      _renderEventPattern() {
        return (0, util_1.renderEventPattern)(this.eventPattern);
      }
      validateRule() {
        const errors = [], name = this.physicalName;
        return name !== void 0 && !core_1.Token.isUnresolved(name) && ((name.length < 1 || name.length > 64) && errors.push(`Event rule name must be between 1 and 64 characters. Received: ${name}`), /^[\.\-_A-Za-z0-9]+$/.test(name) || errors.push(`Event rule name ${name} can contain only letters, numbers, periods, hyphens, or underscores with no spaces.`)), Object.keys(this.eventPattern).length === 0 && !this.scheduleExpression && errors.push("Either 'eventPattern' or 'schedule' must be defined"), errors;
      }
      renderTargets() {
        if (this.targets.length !== 0)
          return this.targets;
      }
      ensureXEnvTargetEventBus(targetStack, targetAccount, targetRegion, id) {
        const key = `${targetAccount}:${targetRegion}`;
        if (this._xEnvTargetsAdded.has(key))
          return;
        this._xEnvTargetsAdded.add(key);
        const eventBusArn = targetStack.formatArn({ service: "events", resource: "event-bus", resourceName: "default", region: targetRegion, account: targetAccount }), roleArn = this.sameEnvDimension(targetRegion, core_1.Stack.of(this).region) ? void 0 : this.crossRegionPutEventsRole(eventBusArn).roleArn;
        this.targets.push({ id, arn: eventBusArn, roleArn });
        const sourceApp = this.node.root, sourceAccount = core_1.Stack.of(this).account;
        if (!this.sameEnvDimension(sourceAccount, targetAccount)) {
          const stackId = `EventBusPolicy-${sourceAccount}-${targetRegion}-${targetAccount}`;
          let eventBusPolicyStack = sourceApp.node.tryFindChild(stackId);
          if (!eventBusPolicyStack) {
            eventBusPolicyStack = new core_1.Stack(sourceApp, stackId, { env: { account: targetAccount, region: targetRegion }, stackName: `${targetStack.stackName}-EventBusPolicy-support-${targetRegion}-${sourceAccount}` });
            const statementPrefix = `Allow-account-${sourceAccount}-`;
            new events_generated_1.CfnEventBusPolicy(eventBusPolicyStack, "GivePermToOtherAccount", { action: "events:PutEvents", statementId: statementPrefix + core_1.Names.uniqueResourceName(this, { maxLength: 64 - statementPrefix.length }), principal: sourceAccount });
          }
          core_1.Stack.of(this).addDependency(eventBusPolicyStack);
        }
      }
      obtainMirrorRuleScope(targetStack, targetAccount, targetRegion) {
        if (this.sameEnvDimension(targetStack.account, targetAccount) && this.sameEnvDimension(targetStack.region, targetRegion))
          return targetStack;
        throw new Error("Cannot create a cross-account or cross-region rule for an imported resource (create a stack with the right environment for the imported resource)");
      }
      crossRegionPutEventsRole(eventBusArn) {
        const id = "EventsRole";
        let role = this.node.tryFindChild(id);
        return role || (role = new aws_iam_1.Role(this, id, { roleName: core_1.PhysicalName.GENERATE_IF_NEEDED, assumedBy: new aws_iam_1.ServicePrincipal("events.amazonaws.com") })), role.addToPrincipalPolicy(new aws_iam_1.PolicyStatement({ actions: ["events:PutEvents"], resources: [eventBusArn] })), role;
      }
      sameEnvDimension(dim1, dim2) {
        switch (core_1.Token.compareStrings(dim1, dim2)) {
          case core_1.TokenComparison.ONE_UNRESOLVED:
            return core_1.Annotations.of(this).addWarning(`Either the Event Rule or target has an unresolved environment. 
           If they are being used in a cross-environment setup you need to specify the environment for both.`), true;
          case core_1.TokenComparison.BOTH_UNRESOLVED:
          case core_1.TokenComparison.SAME:
            return true;
          default:
            return false;
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Rule[_a] = { fqn: "aws-cdk-lib.aws_events.Rule", version: "2.80.0" }, exports2.Rule = Rule;
    function determineRuleScope(scope, props) {
      if (!props.crossStackScope)
        return scope;
      const scopeStack = core_1.Stack.of(scope), targetStack = core_1.Stack.of(props.crossStackScope);
      if (scopeStack === targetStack)
        return scope;
      const regionComparison = core_1.Token.compareStrings(scopeStack.region, targetStack.region), accountComparison = core_1.Token.compareStrings(scopeStack.account, targetStack.account);
      return (regionComparison === core_1.TokenComparison.SAME || regionComparison === core_1.TokenComparison.BOTH_UNRESOLVED) && (accountComparison === core_1.TokenComparison.SAME || accountComparison === core_1.TokenComparison.BOTH_UNRESOLVED) ? props.crossStackScope : scope;
    }
    var MirrorRule = class extends Rule {
      constructor(scope, id, props, source) {
        super(scope, id, props), this.source = source;
      }
      _renderEventPattern() {
        return this.source._renderEventPattern();
      }
      validateRule() {
        return [];
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-events/lib/rule-ref.js
var require_rule_ref = __commonJS({
  "node_modules/aws-cdk-lib/aws-events/lib/rule-ref.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-events/lib/target.js
var require_target = __commonJS({
  "node_modules/aws-cdk-lib/aws-events/lib/target.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-events/lib/archive.js
var require_archive = __commonJS({
  "node_modules/aws-cdk-lib/aws-events/lib/archive.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Archive = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var events_generated_1 = require_events_generated();
    var util_1 = require_util7();
    var core_1 = require_core2();
    var Archive = class _Archive extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.archiveName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_ArchiveProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Archive), error;
        }
        let archive = new events_generated_1.CfnArchive(this, "Archive", { sourceArn: props.sourceEventBus.eventBusArn, description: props.description, eventPattern: (0, util_1.renderEventPattern)(props.eventPattern), retentionDays: props.retention?.toDays({ integral: true }) || 0, archiveName: this.physicalName });
        this.archiveArn = archive.attrArn, this.archiveName = archive.ref, this.node.defaultChild = archive;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Archive[_a] = { fqn: "aws-cdk-lib.aws_events.Archive", version: "2.80.0" }, exports2.Archive = Archive;
  }
});

// node_modules/aws-cdk-lib/aws-events/lib/event-bus.js
var require_event_bus = __commonJS({
  "node_modules/aws-cdk-lib/aws-events/lib/event-bus.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EventBusPolicy = exports2.EventBus = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var archive_1 = require_archive();
    var events_generated_1 = require_events_generated();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var EventBusBase = class extends core_1.Resource {
      archive(id, props) {
        return new archive_1.Archive(this, id, { sourceEventBus: this, description: props.description || `Event Archive for ${this.eventBusName} Event Bus`, eventPattern: props.eventPattern, retention: props.retention, archiveName: props.archiveName });
      }
      grantPutEventsTo(grantee) {
        return iam.Grant.addToPrincipal({ grantee, actions: ["events:PutEvents"], resourceArns: [this.eventBusArn] });
      }
    };
    var EventBus = class _EventBus extends EventBusBase {
      static fromEventBusArn(scope, id, eventBusArn) {
        const parts = core_1.Stack.of(scope).splitArn(eventBusArn, core_1.ArnFormat.SLASH_RESOURCE_NAME);
        return new ImportedEventBus(scope, id, { eventBusArn, eventBusName: parts.resourceName || "", eventBusPolicy: "" });
      }
      static fromEventBusName(scope, id, eventBusName) {
        const eventBusArn = core_1.Stack.of(scope).formatArn({ resource: "event-bus", service: "events", resourceName: eventBusName });
        return _EventBus.fromEventBusAttributes(scope, id, { eventBusName, eventBusArn, eventBusPolicy: "" });
      }
      static fromEventBusAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_EventBusAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromEventBusAttributes), error;
        }
        return new ImportedEventBus(scope, id, attrs);
      }
      static grantPutEvents(grantee) {
        return iam.Grant.addToPrincipal({ grantee, actions: ["events:PutEvents"], resourceArns: ["*"] });
      }
      static grantAllPutEvents(grantee) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(grantee);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantAllPutEvents), error;
        }
        return iam.Grant.addToPrincipal({ grantee, actions: ["events:PutEvents"], resourceArns: ["*"] });
      }
      static eventBusProps(defaultEventBusName, props = {}) {
        const { eventBusName, eventSourceName } = props, eventBusNameRegex = /^[\/\.\-_A-Za-z0-9]{1,256}$/;
        if (eventBusName !== void 0 && eventSourceName !== void 0)
          throw new Error("'eventBusName' and 'eventSourceName' cannot both be provided");
        if (eventBusName !== void 0) {
          if (!core_1.Token.isUnresolved(eventBusName)) {
            if (eventBusName === "default")
              throw new Error("'eventBusName' must not be 'default'");
            if (eventBusName.indexOf("/") > -1)
              throw new Error("'eventBusName' must not contain '/'");
            if (!eventBusNameRegex.test(eventBusName))
              throw new Error(`'eventBusName' must satisfy: ${eventBusNameRegex}`);
          }
          return { eventBusName };
        }
        if (eventSourceName !== void 0) {
          if (!core_1.Token.isUnresolved(eventSourceName)) {
            const eventSourceNameRegex = /^aws\.partner(\/[\.\-_A-Za-z0-9]+){2,}$/;
            if (eventSourceNameRegex.test(eventSourceName)) {
              if (!eventBusNameRegex.test(eventSourceName))
                throw new Error(`'eventSourceName' must satisfy: ${eventBusNameRegex}`);
            } else
              throw new Error(`'eventSourceName' must satisfy: ${eventSourceNameRegex}`);
          }
          return { eventBusName: eventSourceName, eventSourceName };
        }
        return { eventBusName: defaultEventBusName };
      }
      constructor(scope, id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_EventBusProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EventBus), error;
        }
        const { eventBusName, eventSourceName } = _EventBus.eventBusProps(core_1.Lazy.string({ produce: () => core_1.Names.uniqueId(this) }), props);
        super(scope, id, { physicalName: eventBusName });
        const eventBus = new events_generated_1.CfnEventBus(this, "Resource", { name: this.physicalName, eventSourceName });
        this.eventBusArn = this.getResourceArnAttribute(eventBus.attrArn, { service: "events", resource: "event-bus", resourceName: eventBus.name }), this.eventBusName = this.getResourceNameAttribute(eventBus.ref), this.eventBusPolicy = eventBus.attrPolicy, this.eventSourceName = eventBus.eventSourceName;
      }
      addToResourcePolicy(statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToResourcePolicy), error;
        }
        if (statement.sid == null)
          throw new Error("Event Bus policy statements must have a sid");
        return this.policy ? { statementAdded: false } : (this.policy = new EventBusPolicy(this, "Policy", { eventBus: this, statement: statement.toJSON(), statementId: statement.sid }), { statementAdded: true, policyDependable: this.policy });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EventBus[_a] = { fqn: "aws-cdk-lib.aws_events.EventBus", version: "2.80.0" }, exports2.EventBus = EventBus;
    var ImportedEventBus = class extends EventBusBase {
      constructor(scope, id, attrs) {
        const arnParts = core_1.Stack.of(scope).splitArn(attrs.eventBusArn, core_1.ArnFormat.SLASH_RESOURCE_NAME);
        super(scope, id, { account: arnParts.account, region: arnParts.region }), this.eventBusArn = attrs.eventBusArn, this.eventBusName = attrs.eventBusName, this.eventBusPolicy = attrs.eventBusPolicy, this.eventSourceName = attrs.eventSourceName;
      }
    };
    var EventBusPolicy = class _EventBusPolicy extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_EventBusPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EventBusPolicy), error;
        }
        new events_generated_1.CfnEventBusPolicy(this, "Resource", { statementId: props.statementId, statement: props.statement, eventBusName: props.eventBus.eventBusName });
      }
    };
    _b = JSII_RTTI_SYMBOL_1, EventBusPolicy[_b] = { fqn: "aws-cdk-lib.aws_events.EventBusPolicy", version: "2.80.0" }, exports2.EventBusPolicy = EventBusPolicy;
  }
});

// node_modules/aws-cdk-lib/aws-events/lib/event-pattern.js
var require_event_pattern = __commonJS({
  "node_modules/aws-cdk-lib/aws-events/lib/event-pattern.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Match = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core_1 = require_core2();
    var Match = class _Match {
      static nullValue() {
        return this.fromObjects([null]);
      }
      static exists() {
        return this.fromObjects([{ exists: true }]);
      }
      static doesNotExist() {
        return this.fromObjects([{ exists: false }]);
      }
      static exactString(value) {
        return this.fromObjects([value]);
      }
      static equalsIgnoreCase(value) {
        return this.fromObjects([{ "equals-ignore-case": value }]);
      }
      static prefix(value) {
        return this.fromObjects([{ prefix: value }]);
      }
      static suffix(value) {
        return this.fromObjects([{ suffix: value }]);
      }
      static cidr(range) {
        const ipv4Regex = /^([0-9]{1,3}\.){3}[0-9]{1,3}(\/([0-9]|[1-2][0-9]|3[0-2]))?$/igm, ipv6Regex = /^s*((([0-9A-Fa-f]{1,4}:){7}([0-9A-Fa-f]{1,4}|:))|(([0-9A-Fa-f]{1,4}:){6}(:[0-9A-Fa-f]{1,4}|((25[0-5]|2[0-4]d|1dd|[1-9]?d)(.(25[0-5]|2[0-4]d|1dd|[1-9]?d)){3})|:))|(([0-9A-Fa-f]{1,4}:){5}(((:[0-9A-Fa-f]{1,4}){1,2})|:((25[0-5]|2[0-4]d|1dd|[1-9]?d)(.(25[0-5]|2[0-4]d|1dd|[1-9]?d)){3})|:))|(([0-9A-Fa-f]{1,4}:){4}(((:[0-9A-Fa-f]{1,4}){1,3})|((:[0-9A-Fa-f]{1,4})?:((25[0-5]|2[0-4]d|1dd|[1-9]?d)(.(25[0-5]|2[0-4]d|1dd|[1-9]?d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){3}(((:[0-9A-Fa-f]{1,4}){1,4})|((:[0-9A-Fa-f]{1,4}){0,2}:((25[0-5]|2[0-4]d|1dd|[1-9]?d)(.(25[0-5]|2[0-4]d|1dd|[1-9]?d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){2}(((:[0-9A-Fa-f]{1,4}){1,5})|((:[0-9A-Fa-f]{1,4}){0,3}:((25[0-5]|2[0-4]d|1dd|[1-9]?d)(.(25[0-5]|2[0-4]d|1dd|[1-9]?d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){1}(((:[0-9A-Fa-f]{1,4}){1,6})|((:[0-9A-Fa-f]{1,4}){0,4}:((25[0-5]|2[0-4]d|1dd|[1-9]?d)(.(25[0-5]|2[0-4]d|1dd|[1-9]?d)){3}))|:))|(:(((:[0-9A-Fa-f]{1,4}){1,7})|((:[0-9A-Fa-f]{1,4}){0,5}:((25[0-5]|2[0-4]d|1dd|[1-9]?d)(.(25[0-5]|2[0-4]d|1dd|[1-9]?d)){3}))|:)))(%.+)?s*(\/([0-9]|[1-9][0-9]|1[0-1][0-9]|12[0-8]))?$/igm;
        if (!ipv4Regex.test(range) && !ipv6Regex.test(range))
          throw new Error(`Invalid IP address range: ${range}`);
        return this.fromObjects([{ cidr: range }]);
      }
      static ipAddressRange(range) {
        return _Match.cidr(range);
      }
      static anythingBut(...values) {
        if (values.length === 0)
          throw new Error("anythingBut matchers must be non-empty lists");
        const allNumbers = values.every((v) => typeof v == "number"), allStrings = values.every((v) => typeof v == "string");
        if (!(allNumbers || allStrings))
          throw new Error("anythingBut matchers must be lists that contain only strings or only numbers.");
        return this.fromObjects([{ "anything-but": values }]);
      }
      static anythingButPrefix(prefix) {
        return this.fromObjects([{ "anything-but": { prefix } }]);
      }
      static greaterThan(value) {
        return this.numeric(">", value);
      }
      static greaterThanOrEqual(value) {
        return this.numeric(">=", value);
      }
      static lessThan(value) {
        return this.numeric("<", value);
      }
      static lessThanOrEqual(value) {
        return this.numeric("<=", value);
      }
      static equal(value) {
        return this.numeric("=", value);
      }
      static interval(lower, upper) {
        if (lower > upper)
          throw new Error(`Invalid interval: [${lower}, ${upper}]`);
        return _Match.allOf(_Match.greaterThanOrEqual(lower), _Match.lessThanOrEqual(upper));
      }
      static allOf(...matchers) {
        if (matchers.length === 0)
          throw new Error("A list of matchers must contain at least one element.");
        return this.fromMergedObjects(matchers);
      }
      static anyOf(...matchers) {
        if (matchers.length === 0)
          throw new Error("A list of matchers must contain at least one element.");
        return this.fromObjects(matchers);
      }
      static numeric(operator, value) {
        return this.fromObjects([{ numeric: [operator, value] }]);
      }
      static fromObjects(values) {
        return new _Match(values, { mergeMatchers: false }).asList();
      }
      static fromMergedObjects(values) {
        return new _Match(values, { mergeMatchers: true }).asList();
      }
      constructor(matchers, options) {
        this.matchers = matchers, this.options = options, this.creationStack = (0, core_1.captureStackTrace)();
      }
      resolve(context) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_IResolveContext(context);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.resolve), error;
        }
        const matchers = this.matchers.flatMap((matcher) => context.resolve(matcher));
        return this.options.mergeMatchers ? this.merge(matchers) : matchers;
      }
      merge(matchers) {
        if (!matchers.every((matcher) => matcher?.numeric))
          throw new Error("Only numeric matchers can be merged into a single matcher.");
        return [{ numeric: matchers.flatMap((matcher) => matcher.numeric) }];
      }
      toString() {
        return core_1.Token.asString(this);
      }
      asList() {
        return core_1.Token.asList(this);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Match[_a] = { fqn: "aws-cdk-lib.aws_events.Match", version: "2.80.0" }, exports2.Match = Match;
  }
});

// node_modules/aws-cdk-lib/aws-events/lib/on-event-options.js
var require_on_event_options = __commonJS({
  "node_modules/aws-cdk-lib/aws-events/lib/on-event-options.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-events/lib/connection.js
var require_connection = __commonJS({
  "node_modules/aws-cdk-lib/aws-events/lib/connection.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.HttpMethod = exports2.Connection = exports2.HttpParameter = exports2.Authorization = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var events_generated_1 = require_events_generated();
    var core_1 = require_core2();
    var Authorization = class _Authorization {
      static apiKey(apiKeyName, apiKeyValue) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_SecretValue(apiKeyValue);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.apiKey), error;
        }
        return new class extends _Authorization {
          _bind() {
            return { authorizationType: AuthorizationType.API_KEY, authParameters: { apiKeyAuthParameters: { apiKeyName, apiKeyValue: apiKeyValue.unsafeUnwrap() } } };
          }
        }();
      }
      static basic(username, password) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_SecretValue(password);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.basic), error;
        }
        return new class extends _Authorization {
          _bind() {
            return { authorizationType: AuthorizationType.BASIC, authParameters: { basicAuthParameters: { username, password: password.unsafeUnwrap() } } };
          }
        }();
      }
      static oauth(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_OAuthAuthorizationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.oauth), error;
        }
        if (![HttpMethod.POST, HttpMethod.GET, HttpMethod.PUT].includes(props.httpMethod))
          throw new Error("httpMethod must be one of GET, POST, PUT");
        return new class extends _Authorization {
          _bind() {
            return { authorizationType: AuthorizationType.OAUTH_CLIENT_CREDENTIALS, authParameters: { oAuthParameters: { authorizationEndpoint: props.authorizationEndpoint, clientParameters: { clientId: props.clientId, clientSecret: props.clientSecret.unsafeUnwrap() }, httpMethod: props.httpMethod, oAuthHttpParameters: { bodyParameters: renderHttpParameters(props.bodyParameters), headerParameters: renderHttpParameters(props.headerParameters), queryStringParameters: renderHttpParameters(props.queryStringParameters) } } } };
          }
        }();
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Authorization[_a] = { fqn: "aws-cdk-lib.aws_events.Authorization", version: "2.80.0" }, exports2.Authorization = Authorization;
    var HttpParameter = class _HttpParameter {
      static fromString(value) {
        return new class extends _HttpParameter {
          _render(name) {
            return { key: name, value, isValueSecret: false };
          }
        }();
      }
      static fromSecret(value) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_SecretValue(value);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromSecret), error;
        }
        return new class extends _HttpParameter {
          _render(name) {
            return { key: name, value: value.unsafeUnwrap(), isValueSecret: true };
          }
        }();
      }
    };
    _b = JSII_RTTI_SYMBOL_1, HttpParameter[_b] = { fqn: "aws-cdk-lib.aws_events.HttpParameter", version: "2.80.0" }, exports2.HttpParameter = HttpParameter;
    var Connection = class _Connection extends core_1.Resource {
      static fromEventBusArn(scope, id, connectionArn, connectionSecretArn) {
        const parts = core_1.Stack.of(scope).parseArn(connectionArn);
        return new ImportedConnection(scope, id, { connectionArn, connectionName: parts.resourceName || "", connectionSecretArn });
      }
      static fromConnectionAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_ConnectionAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromConnectionAttributes), error;
        }
        return new ImportedConnection(scope, id, attrs);
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.connectionName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_ConnectionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Connection), error;
        }
        const authBind = props.authorization._bind(), invocationHttpParameters = props.headerParameters || props.queryStringParameters || props.bodyParameters ? { bodyParameters: renderHttpParameters(props.bodyParameters), headerParameters: renderHttpParameters(props.headerParameters), queryStringParameters: renderHttpParameters(props.queryStringParameters) } : void 0;
        let connection = new events_generated_1.CfnConnection(this, "Connection", { authorizationType: authBind.authorizationType, authParameters: { ...authBind.authParameters, invocationHttpParameters }, description: props.description, name: this.physicalName });
        this.connectionName = this.getResourceNameAttribute(connection.ref), this.connectionArn = connection.attrArn, this.connectionSecretArn = connection.attrSecretArn;
      }
    };
    _c = JSII_RTTI_SYMBOL_1, Connection[_c] = { fqn: "aws-cdk-lib.aws_events.Connection", version: "2.80.0" }, exports2.Connection = Connection;
    var ImportedConnection = class extends core_1.Resource {
      constructor(scope, id, attrs) {
        const arnParts = core_1.Stack.of(scope).parseArn(attrs.connectionArn);
        super(scope, id, { account: arnParts.account, region: arnParts.region }), this.connectionArn = attrs.connectionArn, this.connectionName = attrs.connectionName, this.connectionSecretArn = attrs.connectionSecretArn;
      }
    };
    var HttpMethod;
    (function(HttpMethod2) {
      HttpMethod2.POST = "POST", HttpMethod2.GET = "GET", HttpMethod2.HEAD = "HEAD", HttpMethod2.OPTIONS = "OPTIONS", HttpMethod2.PUT = "PUT", HttpMethod2.PATCH = "PATCH", HttpMethod2.DELETE = "DELETE";
    })(HttpMethod = exports2.HttpMethod || (exports2.HttpMethod = {}));
    var AuthorizationType;
    (function(AuthorizationType2) {
      AuthorizationType2.API_KEY = "API_KEY", AuthorizationType2.BASIC = "BASIC", AuthorizationType2.OAUTH_CLIENT_CREDENTIALS = "OAUTH_CLIENT_CREDENTIALS";
    })(AuthorizationType || (AuthorizationType = {}));
    function renderHttpParameters(ps) {
      if (!(!ps || Object.keys(ps).length === 0))
        return Object.entries(ps).map(([name, p]) => p._render(name));
    }
  }
});

// node_modules/aws-cdk-lib/aws-events/lib/api-destination.js
var require_api_destination = __commonJS({
  "node_modules/aws-cdk-lib/aws-events/lib/api-destination.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ApiDestination = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var connection_1 = require_connection();
    var events_generated_1 = require_events_generated();
    var core_1 = require_core2();
    var ApiDestination = class _ApiDestination extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.apiDestinationName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_ApiDestinationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ApiDestination), error;
        }
        this.connection = props.connection;
        let apiDestination = new events_generated_1.CfnApiDestination(this, "ApiDestination", { connectionArn: this.connection.connectionArn, description: props.description, httpMethod: props.httpMethod ?? connection_1.HttpMethod.POST, invocationEndpoint: props.endpoint, invocationRateLimitPerSecond: props.rateLimitPerSecond, name: this.physicalName });
        this.apiDestinationName = this.getResourceNameAttribute(apiDestination.ref), this.apiDestinationArn = apiDestination.attrArn;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ApiDestination[_a] = { fqn: "aws-cdk-lib.aws_events.ApiDestination", version: "2.80.0" }, exports2.ApiDestination = ApiDestination;
  }
});

// node_modules/aws-cdk-lib/aws-events/lib/index.js
var require_lib14 = __commonJS({
  "node_modules/aws-cdk-lib/aws-events/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_input(), exports2), __exportStar(require_rule(), exports2), __exportStar(require_rule_ref(), exports2), __exportStar(require_target(), exports2), __exportStar(require_event_bus(), exports2), __exportStar(require_event_pattern(), exports2), __exportStar(require_schedule(), exports2), __exportStar(require_on_event_options(), exports2), __exportStar(require_archive(), exports2), __exportStar(require_connection(), exports2), __exportStar(require_api_destination(), exports2), __exportStar(require_events_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-events/index.js
var require_aws_events = __commonJS({
  "node_modules/aws-cdk-lib/aws-events/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib14(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-s3/lib/bucket.js
var require_bucket = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3/lib/bucket.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ObjectLockRetention = exports2.ObjectLockMode = exports2.ReplaceKey = exports2.BucketAccessControl = exports2.EventType = exports2.BucketEncryption = exports2.Bucket = exports2.ObjectOwnership = exports2.InventoryObjectVersion = exports2.InventoryFrequency = exports2.InventoryFormat = exports2.RedirectProtocol = exports2.HttpMethods = exports2.BlockPublicAccess = exports2.BucketBase = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var os_1 = require("os");
    var path = require("path");
    var bucket_policy_1 = require_bucket_policy();
    var notifications_resource_1 = require_notifications_resource2();
    var perms = require_perms2();
    var s3_generated_1 = require_s3_generated();
    var util_1 = require_util6();
    var events = require_aws_events();
    var iam = require_aws_iam();
    var kms = require_aws_kms();
    var core_1 = require_core2();
    var cfn_reference_1 = require_cfn_reference();
    var cxapi = require_cx_api();
    var regionInformation = require_region_info2();
    var AUTO_DELETE_OBJECTS_RESOURCE_TYPE = "Custom::S3AutoDeleteObjects";
    var AUTO_DELETE_OBJECTS_TAG = "aws-cdk:auto-delete-objects";
    var BucketBase = class _BucketBase extends core_1.Resource {
      constructor(scope, id, props = {}) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ResourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _BucketBase), error;
        }
        this.node.addValidation({ validate: () => this.policy?.document.validateForResourcePolicy() ?? [] });
      }
      onCloudTrailEvent(id, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_OnCloudTrailBucketEventOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.onCloudTrailEvent), error;
        }
        const rule = new events.Rule(this, id, options);
        return rule.addTarget(options.target), rule.addEventPattern({ source: ["aws.s3"], detailType: ["AWS API Call via CloudTrail"], detail: { resources: { ARN: options.paths?.map((p) => this.arnForObjects(p)) ?? [this.bucketArn] } } }), rule;
      }
      onCloudTrailPutObject(id, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_OnCloudTrailBucketEventOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.onCloudTrailPutObject), error;
        }
        const rule = this.onCloudTrailEvent(id, options);
        return rule.addEventPattern({ detail: { eventName: ["PutObject"] } }), rule;
      }
      onCloudTrailWriteObject(id, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_OnCloudTrailBucketEventOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.onCloudTrailWriteObject), error;
        }
        const rule = this.onCloudTrailEvent(id, options);
        return rule.addEventPattern({ detail: { eventName: ["CompleteMultipartUpload", "CopyObject", "PutObject"], requestParameters: { bucketName: [this.bucketName], key: options.paths } } }), rule;
      }
      addToResourcePolicy(permission) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(permission);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToResourcePolicy), error;
        }
        return !this.policy && this.autoCreatePolicy && (this.policy = new bucket_policy_1.BucketPolicy(this, "Policy", { bucket: this })), this.policy ? (this.policy.document.addStatements(permission), { statementAdded: true, policyDependable: this.policy }) : { statementAdded: false };
      }
      urlForObject(key) {
        const stack = core_1.Stack.of(this), prefix = `https://s3.${this.env.region}.${stack.urlSuffix}/`;
        return typeof key != "string" ? this.urlJoin(prefix, this.bucketName) : this.urlJoin(prefix, this.bucketName, key);
      }
      transferAccelerationUrlForObject(key, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_TransferAccelerationUrlOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.transferAccelerationUrlForObject), error;
        }
        const dualStack = options?.dualStack ? ".dualstack" : "", prefix = `https://${this.bucketName}.s3-accelerate${dualStack}.amazonaws.com/`;
        return typeof key != "string" ? this.urlJoin(prefix) : this.urlJoin(prefix, key);
      }
      virtualHostedUrlForObject(key, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_VirtualHostedStyleUrlOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.virtualHostedUrlForObject), error;
        }
        const prefix = `https://${options?.regional ?? true ? this.bucketRegionalDomainName : this.bucketDomainName}`;
        return typeof key != "string" ? prefix : this.urlJoin(prefix, key);
      }
      s3UrlForObject(key) {
        const prefix = "s3://";
        return typeof key != "string" ? this.urlJoin(prefix, this.bucketName) : this.urlJoin(prefix, this.bucketName, key);
      }
      arnForObjects(keyPattern) {
        return `${this.bucketArn}/${keyPattern}`;
      }
      grantRead(identity, objectsKeyPattern = "*") {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(identity);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantRead), error;
        }
        return this.grant(identity, perms.BUCKET_READ_ACTIONS, perms.KEY_READ_ACTIONS, this.bucketArn, this.arnForObjects(objectsKeyPattern));
      }
      grantWrite(identity, objectsKeyPattern = "*", allowedActionPatterns = []) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(identity);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantWrite), error;
        }
        const grantedWriteActions = allowedActionPatterns.length > 0 ? allowedActionPatterns : this.writeActions;
        return this.grant(identity, grantedWriteActions, perms.KEY_WRITE_ACTIONS, this.bucketArn, this.arnForObjects(objectsKeyPattern));
      }
      grantPut(identity, objectsKeyPattern = "*") {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(identity);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantPut), error;
        }
        return this.grant(identity, this.putActions, perms.KEY_WRITE_ACTIONS, this.arnForObjects(objectsKeyPattern));
      }
      grantPutAcl(identity, objectsKeyPattern = "*") {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(identity);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantPutAcl), error;
        }
        return this.grant(identity, perms.BUCKET_PUT_ACL_ACTIONS, [], this.arnForObjects(objectsKeyPattern));
      }
      grantDelete(identity, objectsKeyPattern = "*") {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(identity);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantDelete), error;
        }
        return this.grant(identity, perms.BUCKET_DELETE_ACTIONS, [], this.arnForObjects(objectsKeyPattern));
      }
      grantReadWrite(identity, objectsKeyPattern = "*") {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(identity);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantReadWrite), error;
        }
        const bucketActions = perms.BUCKET_READ_ACTIONS.concat(this.writeActions), keyActions = [.../* @__PURE__ */ new Set([...perms.KEY_READ_ACTIONS, ...perms.KEY_WRITE_ACTIONS])];
        return this.grant(identity, bucketActions, keyActions, this.bucketArn, this.arnForObjects(objectsKeyPattern));
      }
      grantPublicAccess(keyPrefix = "*", ...allowedActions) {
        if (this.disallowPublicAccess)
          throw new Error("Cannot grant public access when 'blockPublicPolicy' is enabled");
        return allowedActions = allowedActions.length > 0 ? allowedActions : ["s3:GetObject"], iam.Grant.addToPrincipalOrResource({ actions: allowedActions, resourceArns: [this.arnForObjects(keyPrefix)], grantee: new iam.AnyPrincipal(), resource: this });
      }
      addEventNotification(event, dest, ...filters) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_EventType(event), jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_IBucketNotificationDestination(dest), jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_NotificationKeyFilter(filters);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addEventNotification), error;
        }
        this.withNotifications((notifications) => notifications.addNotification(event, dest, ...filters));
      }
      withNotifications(cb) {
        this.notifications || (this.notifications = new notifications_resource_1.BucketNotifications(this, "Notifications", { bucket: this, handlerRole: this.notificationsHandlerRole })), cb(this.notifications);
      }
      addObjectCreatedNotification(dest, ...filters) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_IBucketNotificationDestination(dest), jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_NotificationKeyFilter(filters);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addObjectCreatedNotification), error;
        }
        return this.addEventNotification(EventType.OBJECT_CREATED, dest, ...filters);
      }
      addObjectRemovedNotification(dest, ...filters) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_IBucketNotificationDestination(dest), jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_NotificationKeyFilter(filters);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addObjectRemovedNotification), error;
        }
        return this.addEventNotification(EventType.OBJECT_REMOVED, dest, ...filters);
      }
      enableEventBridgeNotification() {
        this.withNotifications((notifications) => notifications.enableEventBridgeNotification());
      }
      get writeActions() {
        return [...perms.BUCKET_DELETE_ACTIONS, ...this.putActions];
      }
      get putActions() {
        return core_1.FeatureFlags.of(this).isEnabled(cxapi.S3_GRANT_WRITE_WITHOUT_ACL) ? perms.BUCKET_PUT_ACTIONS : perms.LEGACY_BUCKET_PUT_ACTIONS;
      }
      urlJoin(...components) {
        return components.reduce((result, component) => (result.endsWith("/") && (result = result.slice(0, -1)), component.startsWith("/") && (component = component.slice(1)), `${result}/${component}`));
      }
      grant(grantee, bucketActions, keyActions, resourceArn, ...otherResourceArns) {
        const resources = [resourceArn, ...otherResourceArns], ret = iam.Grant.addToPrincipalOrResource({ grantee, actions: bucketActions, resourceArns: resources, resource: this });
        return this.encryptionKey && keyActions && keyActions.length !== 0 && this.encryptionKey.grant(grantee, ...keyActions), ret;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, BucketBase[_a] = { fqn: "aws-cdk-lib.aws_s3.BucketBase", version: "2.80.0" }, exports2.BucketBase = BucketBase;
    var BlockPublicAccess = class _BlockPublicAccess {
      constructor(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_BlockPublicAccessOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _BlockPublicAccess), error;
        }
        this.blockPublicAcls = options.blockPublicAcls, this.blockPublicPolicy = options.blockPublicPolicy, this.ignorePublicAcls = options.ignorePublicAcls, this.restrictPublicBuckets = options.restrictPublicBuckets;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, BlockPublicAccess[_b] = { fqn: "aws-cdk-lib.aws_s3.BlockPublicAccess", version: "2.80.0" }, BlockPublicAccess.BLOCK_ALL = new BlockPublicAccess({ blockPublicAcls: true, blockPublicPolicy: true, ignorePublicAcls: true, restrictPublicBuckets: true }), BlockPublicAccess.BLOCK_ACLS = new BlockPublicAccess({ blockPublicAcls: true, ignorePublicAcls: true }), exports2.BlockPublicAccess = BlockPublicAccess;
    var HttpMethods;
    (function(HttpMethods2) {
      HttpMethods2.GET = "GET", HttpMethods2.PUT = "PUT", HttpMethods2.HEAD = "HEAD", HttpMethods2.POST = "POST", HttpMethods2.DELETE = "DELETE";
    })(HttpMethods = exports2.HttpMethods || (exports2.HttpMethods = {}));
    var RedirectProtocol;
    (function(RedirectProtocol2) {
      RedirectProtocol2.HTTP = "http", RedirectProtocol2.HTTPS = "https";
    })(RedirectProtocol = exports2.RedirectProtocol || (exports2.RedirectProtocol = {}));
    var InventoryFormat;
    (function(InventoryFormat2) {
      InventoryFormat2.CSV = "CSV", InventoryFormat2.PARQUET = "Parquet", InventoryFormat2.ORC = "ORC";
    })(InventoryFormat = exports2.InventoryFormat || (exports2.InventoryFormat = {}));
    var InventoryFrequency;
    (function(InventoryFrequency2) {
      InventoryFrequency2.DAILY = "Daily", InventoryFrequency2.WEEKLY = "Weekly";
    })(InventoryFrequency = exports2.InventoryFrequency || (exports2.InventoryFrequency = {}));
    var InventoryObjectVersion;
    (function(InventoryObjectVersion2) {
      InventoryObjectVersion2.ALL = "All", InventoryObjectVersion2.CURRENT = "Current";
    })(InventoryObjectVersion = exports2.InventoryObjectVersion || (exports2.InventoryObjectVersion = {}));
    var ObjectOwnership;
    (function(ObjectOwnership2) {
      ObjectOwnership2.BUCKET_OWNER_ENFORCED = "BucketOwnerEnforced", ObjectOwnership2.BUCKET_OWNER_PREFERRED = "BucketOwnerPreferred", ObjectOwnership2.OBJECT_WRITER = "ObjectWriter";
    })(ObjectOwnership = exports2.ObjectOwnership || (exports2.ObjectOwnership = {}));
    var Bucket = class _Bucket extends BucketBase {
      static fromBucketArn(scope, id, bucketArn) {
        return _Bucket.fromBucketAttributes(scope, id, { bucketArn });
      }
      static fromBucketName(scope, id, bucketName) {
        return _Bucket.fromBucketAttributes(scope, id, { bucketName });
      }
      static fromBucketAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_BucketAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromBucketAttributes), error;
        }
        const stack = core_1.Stack.of(scope), region = attrs.region ?? stack.region, regionInfo = regionInformation.RegionInfo.get(region), urlSuffix = regionInfo.domainSuffix ?? stack.urlSuffix, bucketName = (0, util_1.parseBucketName)(scope, attrs);
        if (!bucketName)
          throw new Error("Bucket name is required");
        _Bucket.validateBucketName(bucketName);
        const oldEndpoint = `s3-website-${region}.${urlSuffix}`, newEndpoint = `s3-website.${region}.${urlSuffix}`;
        let staticDomainEndpoint = regionInfo.s3StaticWebsiteEndpoint ?? core_1.Lazy.string({ produce: () => stack.regionalFact(regionInformation.FactName.S3_STATIC_WEBSITE_ENDPOINT, newEndpoint) });
        attrs.bucketWebsiteNewUrlFormat !== void 0 && (staticDomainEndpoint = attrs.bucketWebsiteNewUrlFormat ? newEndpoint : oldEndpoint);
        const websiteDomain = `${bucketName}.${staticDomainEndpoint}`;
        class Import extends BucketBase {
          constructor() {
            super(...arguments), this.bucketName = bucketName, this.bucketArn = (0, util_1.parseBucketArn)(scope, attrs), this.bucketDomainName = attrs.bucketDomainName || `${bucketName}.s3.${urlSuffix}`, this.bucketWebsiteUrl = attrs.bucketWebsiteUrl || `http://${websiteDomain}`, this.bucketWebsiteDomainName = attrs.bucketWebsiteUrl ? core_1.Fn.select(2, core_1.Fn.split("/", attrs.bucketWebsiteUrl)) : websiteDomain, this.bucketRegionalDomainName = attrs.bucketRegionalDomainName || `${bucketName}.s3.${region}.${urlSuffix}`, this.bucketDualStackDomainName = attrs.bucketDualStackDomainName || `${bucketName}.s3.dualstack.${region}.${urlSuffix}`, this.bucketWebsiteNewUrlFormat = attrs.bucketWebsiteNewUrlFormat ?? false, this.encryptionKey = attrs.encryptionKey, this.isWebsite = attrs.isWebsite ?? false, this.policy = void 0, this.autoCreatePolicy = false, this.disallowPublicAccess = false, this.notificationsHandlerRole = attrs.notificationsHandlerRole;
          }
          export() {
            return attrs;
          }
        }
        return new Import(scope, id, { account: attrs.account, region: attrs.region });
      }
      static fromCfnBucket(cfnBucket) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_CfnBucket(cfnBucket);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromCfnBucket), error;
        }
        const id = "@FromCfnBucket", existing = cfnBucket.node.tryFindChild(id);
        if (existing)
          return existing;
        let encryptionKey;
        if (cfnBucket.bucketEncryption) {
          const serverSideEncryptionConfiguration = cfnBucket.bucketEncryption.serverSideEncryptionConfiguration;
          if (Array.isArray(serverSideEncryptionConfiguration) && serverSideEncryptionConfiguration.length === 1) {
            const serverSideEncryptionByDefault = serverSideEncryptionConfiguration[0].serverSideEncryptionByDefault;
            if (serverSideEncryptionByDefault && core_1.Token.isUnresolved(serverSideEncryptionByDefault.kmsMasterKeyId)) {
              const kmsIResolvable = core_1.Tokenization.reverse(serverSideEncryptionByDefault.kmsMasterKeyId);
              if (kmsIResolvable instanceof cfn_reference_1.CfnReference) {
                const cfnElement = kmsIResolvable.target;
                cfnElement instanceof kms.CfnKey && (encryptionKey = kms.Key.fromCfnKey(cfnElement));
              }
            }
          }
        }
        return new class extends BucketBase {
          constructor() {
            super(cfnBucket, id), this.bucketArn = cfnBucket.attrArn, this.bucketName = cfnBucket.ref, this.bucketDomainName = cfnBucket.attrDomainName, this.bucketDualStackDomainName = cfnBucket.attrDualStackDomainName, this.bucketRegionalDomainName = cfnBucket.attrRegionalDomainName, this.bucketWebsiteUrl = cfnBucket.attrWebsiteUrl, this.bucketWebsiteDomainName = core_1.Fn.select(2, core_1.Fn.split("/", cfnBucket.attrWebsiteUrl)), this.encryptionKey = encryptionKey, this.isWebsite = cfnBucket.websiteConfiguration !== void 0, this.policy = void 0, this.autoCreatePolicy = true, this.disallowPublicAccess = cfnBucket.publicAccessBlockConfiguration && cfnBucket.publicAccessBlockConfiguration.blockPublicPolicy, this.node.defaultChild = cfnBucket;
          }
        }();
      }
      static validateBucketName(physicalName) {
        const bucketName = physicalName;
        if (!bucketName || core_1.Token.isUnresolved(bucketName))
          return;
        const errors = [];
        (bucketName.length < 3 || bucketName.length > 63) && errors.push("Bucket name must be at least 3 and no more than 63 characters");
        const charsetMatch = bucketName.match(/[^a-z0-9.-]/);
        charsetMatch && errors.push(`Bucket name must only contain lowercase characters and the symbols, period (.) and dash (-) (offset: ${charsetMatch.index})`), /[a-z0-9]/.test(bucketName.charAt(0)) || errors.push("Bucket name must start and end with a lowercase character or number (offset: 0)"), /[a-z0-9]/.test(bucketName.charAt(bucketName.length - 1)) || errors.push(`Bucket name must start and end with a lowercase character or number (offset: ${bucketName.length - 1})`);
        const consecSymbolMatch = bucketName.match(/\.-|-\.|\.\./);
        if (consecSymbolMatch && errors.push(`Bucket name must not have dash next to period, or period next to dash, or consecutive periods (offset: ${consecSymbolMatch.index})`), /^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/.test(bucketName) && errors.push("Bucket name must not resemble an IP address"), errors.length > 0)
          throw new Error(`Invalid S3 bucket name (value: ${bucketName})${os_1.EOL}${errors.join(os_1.EOL)}`);
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.bucketName }), this.autoCreatePolicy = true, this.lifecycleRules = [], this.metrics = [], this.cors = [], this.inventories = [];
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_BucketProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Bucket), error;
        }
        this.notificationsHandlerRole = props.notificationsHandlerRole;
        const { bucketEncryption, encryptionKey } = this.parseEncryption(props);
        _Bucket.validateBucketName(this.physicalName);
        const websiteConfiguration = this.renderWebsiteConfiguration(props);
        this.isWebsite = websiteConfiguration !== void 0;
        const objectLockConfiguration = this.parseObjectLockConfig(props);
        this.objectOwnership = props.objectOwnership;
        const resource = new s3_generated_1.CfnBucket(this, "Resource", { bucketName: this.physicalName, bucketEncryption, versioningConfiguration: props.versioned ? { status: "Enabled" } : void 0, lifecycleConfiguration: core_1.Lazy.any({ produce: () => this.parseLifecycleConfiguration() }), websiteConfiguration, publicAccessBlockConfiguration: props.blockPublicAccess, metricsConfigurations: core_1.Lazy.any({ produce: () => this.parseMetricConfiguration() }), corsConfiguration: core_1.Lazy.any({ produce: () => this.parseCorsConfiguration() }), accessControl: core_1.Lazy.string({ produce: () => this.accessControl }), loggingConfiguration: this.parseServerAccessLogs(props), inventoryConfigurations: core_1.Lazy.any({ produce: () => this.parseInventoryConfiguration() }), ownershipControls: core_1.Lazy.any({ produce: () => this.parseOwnershipControls() }), accelerateConfiguration: props.transferAcceleration ? { accelerationStatus: "Enabled" } : void 0, intelligentTieringConfigurations: this.parseTieringConfig(props), objectLockEnabled: objectLockConfiguration ? true : props.objectLockEnabled, objectLockConfiguration });
        this._resource = resource, resource.applyRemovalPolicy(props.removalPolicy), this.encryptionKey = encryptionKey, this.eventBridgeEnabled = props.eventBridgeEnabled, this.bucketName = this.getResourceNameAttribute(resource.ref), this.bucketArn = this.getResourceArnAttribute(resource.attrArn, { region: "", account: "", service: "s3", resource: this.physicalName }), this.bucketDomainName = resource.attrDomainName, this.bucketWebsiteUrl = resource.attrWebsiteUrl, this.bucketWebsiteDomainName = core_1.Fn.select(2, core_1.Fn.split("/", this.bucketWebsiteUrl)), this.bucketDualStackDomainName = resource.attrDualStackDomainName, this.bucketRegionalDomainName = resource.attrRegionalDomainName, this.disallowPublicAccess = props.blockPublicAccess && props.blockPublicAccess.blockPublicPolicy, this.accessControl = props.accessControl, props.enforceSSL && this.enforceSSLStatement(), props.serverAccessLogsBucket instanceof _Bucket ? props.serverAccessLogsBucket.allowLogDelivery(this, props.serverAccessLogsPrefix) : !props.serverAccessLogsBucket && props.serverAccessLogsPrefix ? this.allowLogDelivery(this, props.serverAccessLogsPrefix) : props.serverAccessLogsBucket && core_1.Annotations.of(this).addWarning(`Unable to add necessary logging permissions to imported target bucket: ${props.serverAccessLogsBucket}`);
        for (const inventory of props.inventories ?? [])
          this.addInventory(inventory);
        if ((props.metrics || []).forEach(this.addMetric.bind(this)), (props.cors || []).forEach(this.addCorsRule.bind(this)), (props.lifecycleRules || []).forEach(this.addLifecycleRule.bind(this)), props.publicReadAccess && this.grantPublicAccess(), props.autoDeleteObjects) {
          if (props.removalPolicy !== core_1.RemovalPolicy.DESTROY)
            throw new Error("Cannot use 'autoDeleteObjects' property on a bucket without setting removal policy to 'DESTROY'.");
          this.enableAutoDeleteObjects();
        }
        this.eventBridgeEnabled && this.enableEventBridgeNotification();
      }
      addLifecycleRule(rule) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_LifecycleRule(rule);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addLifecycleRule), error;
        }
        this.lifecycleRules.push(rule);
      }
      addMetric(metric) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_BucketMetrics(metric);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addMetric), error;
        }
        this.metrics.push(metric);
      }
      addCorsRule(rule) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_CorsRule(rule);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addCorsRule), error;
        }
        this.cors.push(rule);
      }
      addInventory(inventory) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_Inventory(inventory);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addInventory), error;
        }
        this.inventories.push(inventory);
      }
      enforceSSLStatement() {
        const statement = new iam.PolicyStatement({ actions: ["s3:*"], conditions: { Bool: { "aws:SecureTransport": "false" } }, effect: iam.Effect.DENY, resources: [this.bucketArn, this.arnForObjects("*")], principals: [new iam.AnyPrincipal()] });
        this.addToResourcePolicy(statement);
      }
      parseEncryption(props) {
        let encryptionType = props.encryption;
        if (encryptionType === void 0 && (encryptionType = props.encryptionKey ? BucketEncryption.KMS : BucketEncryption.UNENCRYPTED), encryptionType !== BucketEncryption.KMS && props.encryptionKey)
          throw new Error(`encryptionKey is specified, so 'encryption' must be set to KMS (value: ${encryptionType})`);
        if (props.bucketKeyEnabled && ![BucketEncryption.KMS, BucketEncryption.KMS_MANAGED].includes(encryptionType))
          throw new Error(`bucketKeyEnabled is specified, so 'encryption' must be set to KMS (value: ${encryptionType})`);
        if (encryptionType === BucketEncryption.UNENCRYPTED)
          return { bucketEncryption: void 0, encryptionKey: void 0 };
        if (encryptionType === BucketEncryption.KMS) {
          const encryptionKey = props.encryptionKey || new kms.Key(this, "Key", { description: `Created by ${this.node.path}` }), bucketEncryption = { serverSideEncryptionConfiguration: [{ bucketKeyEnabled: props.bucketKeyEnabled, serverSideEncryptionByDefault: { sseAlgorithm: "aws:kms", kmsMasterKeyId: encryptionKey.keyArn } }] };
          return { encryptionKey, bucketEncryption };
        }
        if (encryptionType === BucketEncryption.S3_MANAGED)
          return { bucketEncryption: { serverSideEncryptionConfiguration: [{ serverSideEncryptionByDefault: { sseAlgorithm: "AES256" } }] } };
        if (encryptionType === BucketEncryption.KMS_MANAGED)
          return { bucketEncryption: { serverSideEncryptionConfiguration: [{ bucketKeyEnabled: props.bucketKeyEnabled, serverSideEncryptionByDefault: { sseAlgorithm: "aws:kms" } }] } };
        throw new Error(`Unexpected 'encryptionType': ${encryptionType}`);
      }
      parseLifecycleConfiguration() {
        if (!this.lifecycleRules || this.lifecycleRules.length === 0)
          return;
        const self2 = this;
        return { rules: this.lifecycleRules.map(parseLifecycleRule) };
        function parseLifecycleRule(rule) {
          const enabled = rule.enabled ?? true;
          return { abortIncompleteMultipartUpload: rule.abortIncompleteMultipartUploadAfter !== void 0 ? { daysAfterInitiation: rule.abortIncompleteMultipartUploadAfter.toDays() } : void 0, expirationDate: rule.expirationDate, expirationInDays: rule.expiration?.toDays(), id: rule.id, noncurrentVersionExpiration: rule.noncurrentVersionExpiration && { noncurrentDays: rule.noncurrentVersionExpiration.toDays(), newerNoncurrentVersions: rule.noncurrentVersionsToRetain }, noncurrentVersionTransitions: mapOrUndefined(rule.noncurrentVersionTransitions, (t) => ({ storageClass: t.storageClass.value, transitionInDays: t.transitionAfter.toDays(), newerNoncurrentVersions: t.noncurrentVersionsToRetain })), prefix: rule.prefix, status: enabled ? "Enabled" : "Disabled", transitions: mapOrUndefined(rule.transitions, (t) => ({ storageClass: t.storageClass.value, transitionDate: t.transitionDate, transitionInDays: t.transitionAfter && t.transitionAfter.toDays() })), expiredObjectDeleteMarker: rule.expiredObjectDeleteMarker, tagFilters: self2.parseTagFilters(rule.tagFilters), objectSizeLessThan: rule.objectSizeLessThan, objectSizeGreaterThan: rule.objectSizeGreaterThan };
        }
      }
      parseServerAccessLogs(props) {
        if (!(!props.serverAccessLogsBucket && !props.serverAccessLogsPrefix)) {
          if (!props.serverAccessLogsBucket && (props.encryptionKey || props.encryption === BucketEncryption.KMS_MANAGED || props.encryption === BucketEncryption.KMS) || props.serverAccessLogsBucket?.encryptionKey)
            throw new Error("SSE-S3 is the only supported default bucket encryption for Server Access Logging target buckets");
          return { destinationBucketName: props.serverAccessLogsBucket?.bucketName, logFilePrefix: props.serverAccessLogsPrefix };
        }
      }
      parseMetricConfiguration() {
        if (!this.metrics || this.metrics.length === 0)
          return;
        const self2 = this;
        return this.metrics.map(parseMetric);
        function parseMetric(metric) {
          return { id: metric.id, prefix: metric.prefix, tagFilters: self2.parseTagFilters(metric.tagFilters) };
        }
      }
      parseCorsConfiguration() {
        if (!this.cors || this.cors.length === 0)
          return;
        return { corsRules: this.cors.map(parseCors) };
        function parseCors(rule) {
          return { id: rule.id, maxAge: rule.maxAge, allowedHeaders: rule.allowedHeaders, allowedMethods: rule.allowedMethods, allowedOrigins: rule.allowedOrigins, exposedHeaders: rule.exposedHeaders };
        }
      }
      parseTagFilters(tagFilters) {
        if (!(!tagFilters || tagFilters.length === 0))
          return Object.keys(tagFilters).map((tag) => ({ key: tag, value: tagFilters[tag] }));
      }
      parseOwnershipControls() {
        const aclsThatDoNotRequireObjectOwnership = [BucketAccessControl.PRIVATE, BucketAccessControl.BUCKET_OWNER_READ, BucketAccessControl.BUCKET_OWNER_FULL_CONTROL], accessControlRequiresObjectOwnership = this.accessControl && !aclsThatDoNotRequireObjectOwnership.includes(this.accessControl);
        if (!(!this.objectOwnership && !accessControlRequiresObjectOwnership)) {
          if (accessControlRequiresObjectOwnership && this.objectOwnership === ObjectOwnership.BUCKET_OWNER_ENFORCED)
            throw new Error(`objectOwnership must be set to "${ObjectOwnership.OBJECT_WRITER}" when accessControl is "${this.accessControl}"`);
          return { rules: [{ objectOwnership: this.objectOwnership ?? ObjectOwnership.OBJECT_WRITER }] };
        }
      }
      parseTieringConfig({ intelligentTieringConfigurations }) {
        if (intelligentTieringConfigurations)
          return intelligentTieringConfigurations.map((config) => {
            const tierings = [];
            return config.archiveAccessTierTime && tierings.push({ accessTier: "ARCHIVE_ACCESS", days: config.archiveAccessTierTime.toDays({ integral: true }) }), config.deepArchiveAccessTierTime && tierings.push({ accessTier: "DEEP_ARCHIVE_ACCESS", days: config.deepArchiveAccessTierTime.toDays({ integral: true }) }), { id: config.name, prefix: config.prefix, status: "Enabled", tagFilters: config.tags, tierings };
          });
      }
      parseObjectLockConfig(props) {
        const { objectLockEnabled, objectLockDefaultRetention } = props;
        if (objectLockDefaultRetention) {
          if (objectLockEnabled === false && objectLockDefaultRetention)
            throw new Error("Object Lock must be enabled to configure default retention settings");
          return { objectLockEnabled: "Enabled", rule: { defaultRetention: { days: objectLockDefaultRetention.duration.toDays(), mode: objectLockDefaultRetention.mode } } };
        }
      }
      renderWebsiteConfiguration(props) {
        if (!props.websiteErrorDocument && !props.websiteIndexDocument && !props.websiteRedirect && !props.websiteRoutingRules)
          return;
        if (props.websiteErrorDocument && !props.websiteIndexDocument)
          throw new Error('"websiteIndexDocument" is required if "websiteErrorDocument" is set');
        if (props.websiteRedirect && (props.websiteErrorDocument || props.websiteIndexDocument || props.websiteRoutingRules))
          throw new Error('"websiteIndexDocument", "websiteErrorDocument" and, "websiteRoutingRules" cannot be set if "websiteRedirect" is used');
        const routingRules = props.websiteRoutingRules ? props.websiteRoutingRules.map((rule) => {
          if (rule.condition && !rule.condition.httpErrorCodeReturnedEquals && !rule.condition.keyPrefixEquals)
            throw new Error("The condition property cannot be an empty object");
          return { redirectRule: { hostName: rule.hostName, httpRedirectCode: rule.httpRedirectCode, protocol: rule.protocol, replaceKeyWith: rule.replaceKey && rule.replaceKey.withKey, replaceKeyPrefixWith: rule.replaceKey && rule.replaceKey.prefixWithKey }, routingRuleCondition: rule.condition };
        }) : void 0;
        return { indexDocument: props.websiteIndexDocument, errorDocument: props.websiteErrorDocument, redirectAllRequestsTo: props.websiteRedirect, routingRules };
      }
      allowLogDelivery(from, prefix) {
        if (core_1.FeatureFlags.of(this).isEnabled(cxapi.S3_SERVER_ACCESS_LOGS_USE_BUCKET_POLICY)) {
          let conditions;
          from instanceof _Bucket && core_1.Stack.of(this) === core_1.Stack.of(from) && (conditions = { ArnLike: { "aws:SourceArn": from.bucketArn }, StringEquals: { "aws:SourceAccount": from.env.account } }), this.addToResourcePolicy(new iam.PolicyStatement({ effect: iam.Effect.ALLOW, principals: [new iam.ServicePrincipal("logging.s3.amazonaws.com")], actions: ["s3:PutObject"], resources: [this.arnForObjects(prefix ? `${prefix}*` : "*")], conditions }));
        } else {
          if (this.accessControl && this.accessControl !== BucketAccessControl.LOG_DELIVERY_WRITE)
            throw new Error("Cannot enable log delivery to this bucket because the bucket's ACL has been set and can't be changed");
          this.accessControl = BucketAccessControl.LOG_DELIVERY_WRITE;
        }
      }
      parseInventoryConfiguration() {
        if (!(!this.inventories || this.inventories.length === 0))
          return this.inventories.map((inventory, index) => {
            const format = inventory.format ?? InventoryFormat.CSV, frequency = inventory.frequency ?? InventoryFrequency.WEEKLY, id = inventory.inventoryId ?? `${this.node.id}Inventory${index}`;
            return inventory.destination.bucket instanceof _Bucket && inventory.destination.bucket.addToResourcePolicy(new iam.PolicyStatement({ effect: iam.Effect.ALLOW, actions: ["s3:PutObject"], resources: [inventory.destination.bucket.bucketArn, inventory.destination.bucket.arnForObjects(`${inventory.destination.prefix ?? ""}*`)], principals: [new iam.ServicePrincipal("s3.amazonaws.com")], conditions: { ArnLike: { "aws:SourceArn": this.bucketArn } } })), { id, destination: { bucketArn: inventory.destination.bucket.bucketArn, bucketAccountId: inventory.destination.bucketOwner, prefix: inventory.destination.prefix, format }, enabled: inventory.enabled ?? true, includedObjectVersions: inventory.includeObjectVersions ?? InventoryObjectVersion.ALL, scheduleFrequency: frequency, optionalFields: inventory.optionalFields, prefix: inventory.objectsPrefix };
          });
      }
      enableAutoDeleteObjects() {
        const provider = core_1.CustomResourceProvider.getOrCreateProvider(this, AUTO_DELETE_OBJECTS_RESOURCE_TYPE, { codeDirectory: path.join(__dirname, "auto-delete-objects-handler"), runtime: (0, core_1.builtInCustomResourceProviderNodeRuntime)(this), description: `Lambda function for auto-deleting objects in ${this.bucketName} S3 bucket.` });
        this.addToResourcePolicy(new iam.PolicyStatement({ actions: [...perms.BUCKET_READ_METADATA_ACTIONS, ...perms.BUCKET_DELETE_ACTIONS], resources: [this.bucketArn, this.arnForObjects("*")], principals: [new iam.ArnPrincipal(provider.roleArn)] }));
        const customResource = new core_1.CustomResource(this, "AutoDeleteObjectsCustomResource", { resourceType: AUTO_DELETE_OBJECTS_RESOURCE_TYPE, serviceToken: provider.serviceToken, properties: { BucketName: this.bucketName } });
        this.policy && customResource.node.addDependency(this.policy), core_1.Tags.of(this._resource).add(AUTO_DELETE_OBJECTS_TAG, "true");
      }
    };
    _c = JSII_RTTI_SYMBOL_1, Bucket[_c] = { fqn: "aws-cdk-lib.aws_s3.Bucket", version: "2.80.0" }, exports2.Bucket = Bucket;
    var BucketEncryption;
    (function(BucketEncryption2) {
      BucketEncryption2.UNENCRYPTED = "UNENCRYPTED", BucketEncryption2.KMS_MANAGED = "KMS_MANAGED", BucketEncryption2.S3_MANAGED = "S3_MANAGED", BucketEncryption2.KMS = "KMS";
    })(BucketEncryption = exports2.BucketEncryption || (exports2.BucketEncryption = {}));
    var EventType;
    (function(EventType2) {
      EventType2.OBJECT_CREATED = "s3:ObjectCreated:*", EventType2.OBJECT_CREATED_PUT = "s3:ObjectCreated:Put", EventType2.OBJECT_CREATED_POST = "s3:ObjectCreated:Post", EventType2.OBJECT_CREATED_COPY = "s3:ObjectCreated:Copy", EventType2.OBJECT_CREATED_COMPLETE_MULTIPART_UPLOAD = "s3:ObjectCreated:CompleteMultipartUpload", EventType2.OBJECT_REMOVED = "s3:ObjectRemoved:*", EventType2.OBJECT_REMOVED_DELETE = "s3:ObjectRemoved:Delete", EventType2.OBJECT_REMOVED_DELETE_MARKER_CREATED = "s3:ObjectRemoved:DeleteMarkerCreated", EventType2.OBJECT_RESTORE_POST = "s3:ObjectRestore:Post", EventType2.OBJECT_RESTORE_COMPLETED = "s3:ObjectRestore:Completed", EventType2.OBJECT_RESTORE_DELETE = "s3:ObjectRestore:Delete", EventType2.REDUCED_REDUNDANCY_LOST_OBJECT = "s3:ReducedRedundancyLostObject", EventType2.REPLICATION_OPERATION_FAILED_REPLICATION = "s3:Replication:OperationFailedReplication", EventType2.REPLICATION_OPERATION_MISSED_THRESHOLD = "s3:Replication:OperationMissedThreshold", EventType2.REPLICATION_OPERATION_REPLICATED_AFTER_THRESHOLD = "s3:Replication:OperationReplicatedAfterThreshold", EventType2.REPLICATION_OPERATION_NOT_TRACKED = "s3:Replication:OperationNotTracked", EventType2.LIFECYCLE_EXPIRATION = "s3:LifecycleExpiration:*", EventType2.LIFECYCLE_EXPIRATION_DELETE = "s3:LifecycleExpiration:Delete", EventType2.LIFECYCLE_EXPIRATION_DELETE_MARKER_CREATED = "s3:LifecycleExpiration:DeleteMarkerCreated", EventType2.LIFECYCLE_TRANSITION = "s3:LifecycleTransition", EventType2.INTELLIGENT_TIERING = "s3:IntelligentTiering", EventType2.OBJECT_TAGGING = "s3:ObjectTagging:*", EventType2.OBJECT_TAGGING_PUT = "s3:ObjectTagging:Put", EventType2.OBJECT_TAGGING_DELETE = "s3:ObjectTagging:Delete", EventType2.OBJECT_ACL_PUT = "s3:ObjectAcl:Put";
    })(EventType = exports2.EventType || (exports2.EventType = {}));
    var BucketAccessControl;
    (function(BucketAccessControl2) {
      BucketAccessControl2.PRIVATE = "Private", BucketAccessControl2.PUBLIC_READ = "PublicRead", BucketAccessControl2.PUBLIC_READ_WRITE = "PublicReadWrite", BucketAccessControl2.AUTHENTICATED_READ = "AuthenticatedRead", BucketAccessControl2.LOG_DELIVERY_WRITE = "LogDeliveryWrite", BucketAccessControl2.BUCKET_OWNER_READ = "BucketOwnerRead", BucketAccessControl2.BUCKET_OWNER_FULL_CONTROL = "BucketOwnerFullControl", BucketAccessControl2.AWS_EXEC_READ = "AwsExecRead";
    })(BucketAccessControl = exports2.BucketAccessControl || (exports2.BucketAccessControl = {}));
    var ReplaceKey = class {
      static with(keyReplacement) {
        return new this(keyReplacement);
      }
      static prefixWith(keyReplacement) {
        return new this(void 0, keyReplacement);
      }
      constructor(withKey, prefixWithKey) {
        this.withKey = withKey, this.prefixWithKey = prefixWithKey;
      }
    };
    _d = JSII_RTTI_SYMBOL_1, ReplaceKey[_d] = { fqn: "aws-cdk-lib.aws_s3.ReplaceKey", version: "2.80.0" }, exports2.ReplaceKey = ReplaceKey;
    var ObjectLockMode;
    (function(ObjectLockMode2) {
      ObjectLockMode2.GOVERNANCE = "GOVERNANCE", ObjectLockMode2.COMPLIANCE = "COMPLIANCE";
    })(ObjectLockMode = exports2.ObjectLockMode || (exports2.ObjectLockMode = {}));
    var ObjectLockRetention = class _ObjectLockRetention {
      static governance(duration) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Duration(duration);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.governance), error;
        }
        return new _ObjectLockRetention(ObjectLockMode.GOVERNANCE, duration);
      }
      static compliance(duration) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Duration(duration);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.compliance), error;
        }
        return new _ObjectLockRetention(ObjectLockMode.COMPLIANCE, duration);
      }
      constructor(mode, duration) {
        if (duration.toDays() > 365 * 100)
          throw new Error("Object Lock retention duration must be less than 100 years");
        if (duration.toDays() < 1)
          throw new Error("Object Lock retention duration must be at least 1 day");
        this.mode = mode, this.duration = duration;
      }
    };
    _e = JSII_RTTI_SYMBOL_1, ObjectLockRetention[_e] = { fqn: "aws-cdk-lib.aws_s3.ObjectLockRetention", version: "2.80.0" }, exports2.ObjectLockRetention = ObjectLockRetention;
    function mapOrUndefined(list, callback) {
      if (!(!list || list.length === 0))
        return list.map(callback);
    }
  }
});

// node_modules/aws-cdk-lib/aws-s3/lib/location.js
var require_location2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3/lib/location.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-s3/lib/rule.js
var require_rule2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3/lib/rule.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.StorageClass = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var StorageClass = class {
      constructor(value) {
        this.value = value;
      }
      toString() {
        return this.value;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, StorageClass[_a] = { fqn: "aws-cdk-lib.aws_s3.StorageClass", version: "2.80.0" }, StorageClass.INFREQUENT_ACCESS = new StorageClass("STANDARD_IA"), StorageClass.ONE_ZONE_INFREQUENT_ACCESS = new StorageClass("ONEZONE_IA"), StorageClass.GLACIER = new StorageClass("GLACIER"), StorageClass.GLACIER_INSTANT_RETRIEVAL = new StorageClass("GLACIER_IR"), StorageClass.DEEP_ARCHIVE = new StorageClass("DEEP_ARCHIVE"), StorageClass.INTELLIGENT_TIERING = new StorageClass("INTELLIGENT_TIERING"), exports2.StorageClass = StorageClass;
  }
});

// node_modules/aws-cdk-lib/aws-s3/lib/index.js
var require_lib15 = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_bucket(), exports2), __exportStar(require_bucket_policy(), exports2), __exportStar(require_destination2(), exports2), __exportStar(require_location2(), exports2), __exportStar(require_rule2(), exports2), __exportStar(require_s3_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-s3/index.js
var require_aws_s3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib15(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-s3-assets/lib/asset.js
var require_asset = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3-assets/lib/asset.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Asset = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var path = require("path");
    var constructs_1 = require_lib2();
    var compat_1 = require_compat2();
    var kms = require_aws_kms();
    var s3 = require_aws_s3();
    var cdk = require_core2();
    var cxapi = require_cx_api();
    var Asset = class _Asset extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_assets_AssetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Asset), error;
        }
        this.isBundled = props.bundling != null;
        const staging = new cdk.AssetStaging(this, "Stage", { ...props, sourcePath: path.resolve(props.path), follow: props.followSymlinks ?? (0, compat_1.toSymlinkFollow)(props.follow), assetHash: props.assetHash ?? props.sourceHash });
        this.assetHash = staging.assetHash, this.sourceHash = this.assetHash;
        const stack = cdk.Stack.of(this);
        this.assetPath = staging.relativeStagedPath(stack), this.isFile = staging.packaging === cdk.FileAssetPackaging.FILE, this.isZipArchive = staging.isArchive;
        const location = stack.synthesizer.addFileAsset({ packaging: staging.packaging, sourceHash: this.sourceHash, fileName: this.assetPath });
        this.s3BucketName = location.bucketName, this.s3ObjectKey = location.objectKey, this.s3ObjectUrl = location.s3ObjectUrl, this.httpUrl = location.httpUrl, this.s3Url = location.httpUrl;
        const kmsKey = location.kmsKeyArn ? kms.Key.fromKeyArn(this, "Key", location.kmsKeyArn) : void 0;
        this.bucket = s3.Bucket.fromBucketAttributes(this, "AssetBucket", { bucketName: this.s3BucketName, encryptionKey: kmsKey });
        for (const reader of props.readers ?? [])
          this.grantRead(reader);
      }
      addResourceMetadata(resource, resourceProperty) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnResource(resource);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addResourceMetadata), error;
        }
        this.node.tryGetContext(cxapi.ASSET_RESOURCE_METADATA_ENABLED_CONTEXT) && (resource.cfnOptions.metadata = resource.cfnOptions.metadata || {}, resource.cfnOptions.metadata[cxapi.ASSET_RESOURCE_METADATA_PATH_KEY] = this.assetPath, resource.cfnOptions.metadata[cxapi.ASSET_RESOURCE_METADATA_IS_BUNDLED_KEY] = this.isBundled, resource.cfnOptions.metadata[cxapi.ASSET_RESOURCE_METADATA_PROPERTY_KEY] = resourceProperty);
      }
      grantRead(grantee) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(grantee);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantRead), error;
        }
        this.bucket.grantRead(grantee);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Asset[_a] = { fqn: "aws-cdk-lib.aws_s3_assets.Asset", version: "2.80.0" }, exports2.Asset = Asset;
  }
});

// node_modules/aws-cdk-lib/aws-s3-assets/lib/index.js
var require_lib16 = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3-assets/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_asset(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-s3-assets/index.js
var require_aws_s3_assets = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3-assets/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib16(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-logs/lib/log-retention.js
var require_log_retention = __commonJS({
  "node_modules/aws-cdk-lib/aws-logs/lib/log-retention.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LogRetention = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var path = require("path");
    var constructs_1 = require_lib2();
    var log_group_1 = require_log_group();
    var iam = require_aws_iam();
    var s3_assets = require_aws_s3_assets();
    var cdk = require_core2();
    var core_1 = require_core2();
    var region_info_1 = require_region_info2();
    var LogRetention = class _LogRetention extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_logs_LogRetentionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _LogRetention), error;
        }
        const provider = this.ensureSingletonLogRetentionFunction(props);
        props.removalPolicy === cdk.RemovalPolicy.DESTROY && provider.grantDeleteLogGroup(props.logGroupName);
        const retryOptions = props.logRetentionRetryOptions, logGroupName = new cdk.CfnResource(this, "Resource", { type: "Custom::LogRetention", properties: { ServiceToken: provider.functionArn, LogGroupName: props.logGroupName, LogGroupRegion: props.logGroupRegion, SdkRetry: retryOptions ? { maxRetries: retryOptions.maxRetries, base: retryOptions.base?.toMilliseconds() } : void 0, RetentionInDays: props.retention === log_group_1.RetentionDays.INFINITE ? void 0 : props.retention, RemovalPolicy: props.removalPolicy } }).getAtt("LogGroupName").toString();
        this.logGroupArn = cdk.Stack.of(this).formatArn({ region: props.logGroupRegion, service: "logs", resource: "log-group", resourceName: `${logGroupName}:*`, arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME });
      }
      ensureSingletonLogRetentionFunction(props) {
        const functionLogicalId = "LogRetentionaae0aa3c5b4d4f87b02d85b201efdd8a", existing = cdk.Stack.of(this).node.tryFindChild(functionLogicalId);
        return existing || new LogRetentionFunction(cdk.Stack.of(this), functionLogicalId, props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LogRetention[_a] = { fqn: "aws-cdk-lib.aws_logs.LogRetention", version: "2.80.0" }, exports2.LogRetention = LogRetention;
    var LogRetentionFunction = class extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id), this.tags = new cdk.TagManager(cdk.TagType.KEY_VALUE, "AWS::Lambda::Function");
        const asset = new s3_assets.Asset(this, "Code", { path: path.join(__dirname, "log-retention-provider") }), role = props.role || new iam.Role(this, "ServiceRole", { assumedBy: new iam.ServicePrincipal("lambda.amazonaws.com"), managedPolicies: [iam.ManagedPolicy.fromAwsManagedPolicyName("service-role/AWSLambdaBasicExecutionRole")] });
        role.addToPrincipalPolicy(new iam.PolicyStatement({ actions: ["logs:PutRetentionPolicy", "logs:DeleteRetentionPolicy"], resources: ["*"] })), this.role = role;
        const resource = new cdk.CfnResource(this, "Resource", { type: "AWS::Lambda::Function", properties: { Handler: "index.handler", Runtime: cdk.Stack.of(scope).regionalFact(region_info_1.FactName.DEFAULT_CR_NODE_VERSION, "nodejs16.x"), Code: { S3Bucket: asset.s3BucketName, S3Key: asset.s3ObjectKey }, Role: role.roleArn, Tags: this.tags.renderedTags } });
        this.functionArn = resource.getAtt("Arn"), asset.addResourceMetadata(resource, "Code"), role.node.children.forEach((child) => {
          cdk.CfnResource.isCfnResource(child) && resource.addDependency(child), constructs_1.Construct.isConstruct(child) && child.node.defaultChild && cdk.CfnResource.isCfnResource(child.node.defaultChild) && resource.addDependency(child.node.defaultChild);
        });
      }
      grantDeleteLogGroup(logGroupName) {
        this.role.addToPrincipalPolicy(new iam.PolicyStatement({ actions: ["logs:DeleteLogGroup"], resources: [cdk.Stack.of(this).formatArn({ service: "logs", resource: "log-group", resourceName: `${logGroupName}:*`, arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME })] }));
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-logs/lib/query-definition.js
var require_query_definition = __commonJS({
  "node_modules/aws-cdk-lib/aws-logs/lib/query-definition.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.QueryDefinition = exports2.QueryString = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var _1 = require_lib17();
    var core_1 = require_core2();
    var QueryString = class _QueryString {
      constructor(props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_logs_QueryStringProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _QueryString), error;
        }
        this.fields = props.fields, this.stats = props.stats, this.sort = props.sort, this.limit = props.limit, this.display = props.display, props.parseStatements ? this.parse = props.parseStatements : props.parse ? this.parse = [props.parse] : this.parse = [], props.filterStatements ? this.filter = props.filterStatements : props.filter ? this.filter = [props.filter] : this.filter = [];
      }
      toString() {
        return [this.buildQueryLine("fields", this.fields?.join(", ")), ...this.buildQueryLines("parse", this.parse), ...this.buildQueryLines("filter", this.filter), this.buildQueryLine("stats", this.stats), this.buildQueryLine("sort", this.sort), this.buildQueryLine("limit", this.limit?.toString()), this.buildQueryLine("display", this.display)].filter((queryLine) => queryLine !== void 0 && queryLine.length > 0).join(`
| `);
      }
      buildQueryLines(command, statements) {
        return statements === void 0 ? [] : statements.map((statement) => this.buildQueryLine(command, statement));
      }
      buildQueryLine(command, statement) {
        return statement ? `${command} ${statement}` : "";
      }
    };
    _a = JSII_RTTI_SYMBOL_1, QueryString[_a] = { fqn: "aws-cdk-lib.aws_logs.QueryString", version: "2.80.0" }, exports2.QueryString = QueryString;
    var QueryDefinition = class _QueryDefinition extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.queryDefinitionName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_logs_QueryDefinitionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _QueryDefinition), error;
        }
        const queryDefinition = new _1.CfnQueryDefinition(this, "Resource", { name: props.queryDefinitionName, queryString: props.queryString.toString(), logGroupNames: typeof props.logGroups > "u" ? [] : props.logGroups.flatMap((logGroup) => logGroup.logGroupName) });
        this.queryDefinitionId = queryDefinition.attrQueryDefinitionId;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, QueryDefinition[_b] = { fqn: "aws-cdk-lib.aws_logs.QueryDefinition", version: "2.80.0" }, exports2.QueryDefinition = QueryDefinition;
  }
});

// node_modules/aws-cdk-lib/aws-logs/lib/data-protection-policy.js
var require_data_protection_policy = __commonJS({
  "node_modules/aws-cdk-lib/aws-logs/lib/data-protection-policy.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DataIdentifier = exports2.DataProtectionPolicy = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core_1 = require_core2();
    var DataProtectionPolicy = class _DataProtectionPolicy {
      constructor(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_logs_DataProtectionPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _DataProtectionPolicy), error;
        }
        if (props.identifiers.length == 0)
          throw new Error("DataIdentifier cannot be empty");
        this.dataProtectionPolicyProps = props;
      }
      _bind(_scope) {
        const name = this.dataProtectionPolicyProps.name || "data-protection-policy-cdk", description = this.dataProtectionPolicyProps.description || "cdk generated data protection policy", version = "2021-06-01", findingsDestination = {};
        this.dataProtectionPolicyProps.logGroupAuditDestination && (findingsDestination.cloudWatchLogs = { logGroup: this.dataProtectionPolicyProps.logGroupAuditDestination.logGroupName }), this.dataProtectionPolicyProps.s3BucketAuditDestination && (findingsDestination.s3 = { bucket: this.dataProtectionPolicyProps.s3BucketAuditDestination.bucketName }), this.dataProtectionPolicyProps.deliveryStreamNameAuditDestination && (findingsDestination.firehose = { deliveryStream: this.dataProtectionPolicyProps.deliveryStreamNameAuditDestination });
        const identifierArns = [];
        for (let identifier of this.dataProtectionPolicyProps.identifiers)
          identifierArns.push(core_1.Stack.of(_scope).formatArn({ resource: "data-identifier", region: "", account: "aws", service: "dataprotection", resourceName: identifier.toString() }));
        return { name, description, version, statement: [{ sid: "audit-statement-cdk", dataIdentifier: identifierArns, operation: { audit: { findingsDestination } } }, { sid: "redact-statement-cdk", dataIdentifier: identifierArns, operation: { deidentify: { maskConfig: {} } } }] };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, DataProtectionPolicy[_a] = { fqn: "aws-cdk-lib.aws_logs.DataProtectionPolicy", version: "2.80.0" }, exports2.DataProtectionPolicy = DataProtectionPolicy;
    var DataIdentifier = class {
      constructor(identifier) {
        this.identifier = identifier;
      }
      toString() {
        return this.identifier;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, DataIdentifier[_b] = { fqn: "aws-cdk-lib.aws_logs.DataIdentifier", version: "2.80.0" }, DataIdentifier.ADDRESS = new DataIdentifier("Address"), DataIdentifier.AWSSECRETKEY = new DataIdentifier("AwsSecretKey"), DataIdentifier.BANKACCOUNTNUMBER_DE = new DataIdentifier("BankAccountNumber-DE"), DataIdentifier.BANKACCOUNTNUMBER_ES = new DataIdentifier("BankAccountNumber-ES"), DataIdentifier.BANKACCOUNTNUMBER_FR = new DataIdentifier("BankAccountNumber-FR"), DataIdentifier.BANKACCOUNTNUMBER_GB = new DataIdentifier("BankAccountNumber-GB"), DataIdentifier.BANKACCOUNTNUMBER_IT = new DataIdentifier("BankAccountNumber-IT"), DataIdentifier.BANKACCOUNTNUMBER_US = new DataIdentifier("BankAccountNumber-US"), DataIdentifier.CEPCODE_BR = new DataIdentifier("CepCode-BR"), DataIdentifier.CNPJ_BR = new DataIdentifier("Cnpj-BR"), DataIdentifier.CPFCODE_BR = new DataIdentifier("CpfCode-BR"), DataIdentifier.CREDITCARDEXPIRATION = new DataIdentifier("CreditCardExpiration"), DataIdentifier.CREDITCARDNUMBER = new DataIdentifier("CreditCardNumber"), DataIdentifier.CREDITCARDSECURITYCODE = new DataIdentifier("CreditCardSecurityCode"), DataIdentifier.DRIVERSLICENSE_AT = new DataIdentifier("DriversLicense-AT"), DataIdentifier.DRIVERSLICENSE_AU = new DataIdentifier("DriversLicense-AU"), DataIdentifier.DRIVERSLICENSE_BE = new DataIdentifier("DriversLicense-BE"), DataIdentifier.DRIVERSLICENSE_BG = new DataIdentifier("DriversLicense-BG"), DataIdentifier.DRIVERSLICENSE_CA = new DataIdentifier("DriversLicense-CA"), DataIdentifier.DRIVERSLICENSE_CY = new DataIdentifier("DriversLicense-CY"), DataIdentifier.DRIVERSLICENSE_CZ = new DataIdentifier("DriversLicense-CZ"), DataIdentifier.DRIVERSLICENSE_DE = new DataIdentifier("DriversLicense-DE"), DataIdentifier.DRIVERSLICENSE_DK = new DataIdentifier("DriversLicense-DK"), DataIdentifier.DRIVERSLICENSE_EE = new DataIdentifier("DriversLicense-EE"), DataIdentifier.DRIVERSLICENSE_ES = new DataIdentifier("DriversLicense-ES"), DataIdentifier.DRIVERSLICENSE_FI = new DataIdentifier("DriversLicense-FI"), DataIdentifier.DRIVERSLICENSE_FR = new DataIdentifier("DriversLicense-FR"), DataIdentifier.DRIVERSLICENSE_GB = new DataIdentifier("DriversLicense-GB"), DataIdentifier.DRIVERSLICENSE_GR = new DataIdentifier("DriversLicense-GR"), DataIdentifier.DRIVERSLICENSE_HR = new DataIdentifier("DriversLicense-HR"), DataIdentifier.DRIVERSLICENSE_HU = new DataIdentifier("DriversLicense-HU"), DataIdentifier.DRIVERSLICENSE_IE = new DataIdentifier("DriversLicense-IE"), DataIdentifier.DRIVERSLICENSE_IT = new DataIdentifier("DriversLicense-IT"), DataIdentifier.DRIVERSLICENSE_LT = new DataIdentifier("DriversLicense-LT"), DataIdentifier.DRIVERSLICENSE_LU = new DataIdentifier("DriversLicense-LU"), DataIdentifier.DRIVERSLICENSE_LV = new DataIdentifier("DriversLicense-LV"), DataIdentifier.DRIVERSLICENSE_MT = new DataIdentifier("DriversLicense-MT"), DataIdentifier.DRIVERSLICENSE_NL = new DataIdentifier("DriversLicense-NL"), DataIdentifier.DRIVERSLICENSE_PL = new DataIdentifier("DriversLicense-PL"), DataIdentifier.DRIVERSLICENSE_PT = new DataIdentifier("DriversLicense-PT"), DataIdentifier.DRIVERSLICENSE_RO = new DataIdentifier("DriversLicense-RO"), DataIdentifier.DRIVERSLICENSE_SE = new DataIdentifier("DriversLicense-SE"), DataIdentifier.DRIVERSLICENSE_SI = new DataIdentifier("DriversLicense-SI"), DataIdentifier.DRIVERSLICENSE_SK = new DataIdentifier("DriversLicense-SK"), DataIdentifier.DRIVERSLICENSE_US = new DataIdentifier("DriversLicense-US"), DataIdentifier.DRUGENFORCEMENTAGENCYNUMBER_US = new DataIdentifier("DrugEnforcementAgencyNumber-US"), DataIdentifier.ELECTORALROLLNUMBER_GB = new DataIdentifier("ElectoralRollNumber-GB"), DataIdentifier.EMAILADDRESS = new DataIdentifier("EmailAddress"), DataIdentifier.HEALTHINSURANCECARDNUMBER_EU = new DataIdentifier("HealthInsuranceCardNumber-EU"), DataIdentifier.HEALTHINSURANCECLAIMNUMBER_US = new DataIdentifier("HealthInsuranceClaimNumber-US"), DataIdentifier.HEALTHINSURANCENUMBER_FR = new DataIdentifier("HealthInsuranceNumber-FR"), DataIdentifier.HEALTHCAREPROCEDURECODE_US = new DataIdentifier("HealthcareProcedureCode-US"), DataIdentifier.INDIVIDUALTAXIDENTIFICATIONNUMBER_US = new DataIdentifier("IndividualTaxIdentificationNumber-US"), DataIdentifier.INSEECODE_FR = new DataIdentifier("InseeCode-FR"), DataIdentifier.IPADDRESS = new DataIdentifier("IpAddress"), DataIdentifier.LATLONG = new DataIdentifier("LatLong"), DataIdentifier.MEDICAREBENEFICIARYNUMBER_US = new DataIdentifier("MedicareBeneficiaryNumber-US"), DataIdentifier.NAME = new DataIdentifier("Name"), DataIdentifier.NATIONALDRUGCODE_US = new DataIdentifier("NationalDrugCode-US"), DataIdentifier.NATIONALIDENTIFICATIONNUMBER_DE = new DataIdentifier("NationalIdentificationNumber-DE"), DataIdentifier.NATIONALIDENTIFICATIONNUMBER_ES = new DataIdentifier("NationalIdentificationNumber-ES"), DataIdentifier.NATIONALIDENTIFICATIONNUMBER_IT = new DataIdentifier("NationalIdentificationNumber-IT"), DataIdentifier.NATIONALINSURANCENUMBER_GB = new DataIdentifier("NationalInsuranceNumber-GB"), DataIdentifier.NATIONALPROVIDERID_US = new DataIdentifier("NationalProviderId-US"), DataIdentifier.NHSNUMBER_GB = new DataIdentifier("NhsNumber-GB"), DataIdentifier.NIENUMBER_ES = new DataIdentifier("NieNumber-ES"), DataIdentifier.NIFNUMBER_ES = new DataIdentifier("NifNumber-ES"), DataIdentifier.OPENSSHPRIVATEKEY = new DataIdentifier("OpenSshPrivateKey"), DataIdentifier.PASSPORTNUMBER_CA = new DataIdentifier("PassportNumber-CA"), DataIdentifier.PASSPORTNUMBER_DE = new DataIdentifier("PassportNumber-DE"), DataIdentifier.PASSPORTNUMBER_ES = new DataIdentifier("PassportNumber-ES"), DataIdentifier.PASSPORTNUMBER_FR = new DataIdentifier("PassportNumber-FR"), DataIdentifier.PASSPORTNUMBER_GB = new DataIdentifier("PassportNumber-GB"), DataIdentifier.PASSPORTNUMBER_IT = new DataIdentifier("PassportNumber-IT"), DataIdentifier.PASSPORTNUMBER_US = new DataIdentifier("PassportNumber-US"), DataIdentifier.PERMANENTRESIDENCENUMBER_CA = new DataIdentifier("PermanentResidenceNumber-CA"), DataIdentifier.PERSONALHEALTHNUMBER_CA = new DataIdentifier("PersonalHealthNumber-CA"), DataIdentifier.PGPPRIVATEKEY = new DataIdentifier("PgpPrivateKey"), DataIdentifier.PHONENUMBER = new DataIdentifier("PhoneNumber"), DataIdentifier.PHONENUMBER_BR = new DataIdentifier("PhoneNumber-BR"), DataIdentifier.PHONENUMBER_DE = new DataIdentifier("PhoneNumber-DE"), DataIdentifier.PHONENUMBER_ES = new DataIdentifier("PhoneNumber-ES"), DataIdentifier.PHONENUMBER_FR = new DataIdentifier("PhoneNumber-FR"), DataIdentifier.PHONENUMBER_GB = new DataIdentifier("PhoneNumber-GB"), DataIdentifier.PHONENUMBER_IT = new DataIdentifier("PhoneNumber-IT"), DataIdentifier.PHONENUMBER_US = new DataIdentifier("PhoneNumber-US"), DataIdentifier.PKCSPRIVATEKEY = new DataIdentifier("PkcsPrivateKey"), DataIdentifier.POSTALCODE_CA = new DataIdentifier("PostalCode-CA"), DataIdentifier.PUTTYPRIVATEKEY = new DataIdentifier("PuttyPrivateKey"), DataIdentifier.RGNUMBER_BR = new DataIdentifier("RgNumber-BR"), DataIdentifier.SOCIALINSURANCENUMBER_CA = new DataIdentifier("SocialInsuranceNumber-CA"), DataIdentifier.SSN_ES = new DataIdentifier("Ssn-ES"), DataIdentifier.SSN_US = new DataIdentifier("Ssn-US"), DataIdentifier.TAXID_DE = new DataIdentifier("TaxId-DE"), DataIdentifier.TAXID_ES = new DataIdentifier("TaxId-ES"), DataIdentifier.TAXID_FR = new DataIdentifier("TaxId-FR"), DataIdentifier.TAXID_GB = new DataIdentifier("TaxId-GB"), DataIdentifier.VEHICLEIDENTIFICATIONNUMBER = new DataIdentifier("VehicleIdentificationNumber"), DataIdentifier.ZIPCODE_US = new DataIdentifier("ZipCode-US"), exports2.DataIdentifier = DataIdentifier;
  }
});

// node_modules/aws-cdk-lib/aws-logs/lib/index.js
var require_lib17 = __commonJS({
  "node_modules/aws-cdk-lib/aws-logs/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_cross_account_destination(), exports2), __exportStar(require_log_group(), exports2), __exportStar(require_log_stream(), exports2), __exportStar(require_metric_filter(), exports2), __exportStar(require_pattern(), exports2), __exportStar(require_subscription_filter(), exports2), __exportStar(require_log_retention(), exports2), __exportStar(require_policy2(), exports2), __exportStar(require_query_definition(), exports2), __exportStar(require_data_protection_policy(), exports2), __exportStar(require_logs_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-logs/index.js
var require_aws_logs = __commonJS({
  "node_modules/aws-cdk-lib/aws-logs/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib17(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/client-vpn-endpoint.js
var require_client_vpn_endpoint = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/client-vpn-endpoint.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ClientVpnEndpoint = exports2.ClientVpnUserBasedAuthentication = exports2.ClientVpnSessionTimeout = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var client_vpn_authorization_rule_1 = require_client_vpn_authorization_rule();
    var client_vpn_route_1 = require_client_vpn_route();
    var connections_1 = require_connections();
    var ec2_generated_1 = require_ec2_generated();
    var network_util_1 = require_network_util();
    var security_group_1 = require_security_group2();
    var logs = require_aws_logs();
    var core_1 = require_core2();
    var ClientVpnSessionTimeout;
    (function(ClientVpnSessionTimeout2) {
      ClientVpnSessionTimeout2[ClientVpnSessionTimeout2.EIGHT_HOURS = 8] = "EIGHT_HOURS", ClientVpnSessionTimeout2[ClientVpnSessionTimeout2.TEN_HOURS = 10] = "TEN_HOURS", ClientVpnSessionTimeout2[ClientVpnSessionTimeout2.TWELVE_HOURS = 12] = "TWELVE_HOURS", ClientVpnSessionTimeout2[ClientVpnSessionTimeout2.TWENTY_FOUR_HOURS = 24] = "TWENTY_FOUR_HOURS";
    })(ClientVpnSessionTimeout = exports2.ClientVpnSessionTimeout || (exports2.ClientVpnSessionTimeout = {}));
    var ClientVpnUserBasedAuthentication = class {
      static activeDirectory(directoryId) {
        return new ActiveDirectoryAuthentication(directoryId);
      }
      static federated(samlProvider, selfServiceSamlProvider) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_ISamlProvider(samlProvider), jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_ISamlProvider(selfServiceSamlProvider);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.federated), error;
        }
        return new FederatedAuthentication(samlProvider, selfServiceSamlProvider);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ClientVpnUserBasedAuthentication[_a] = { fqn: "aws-cdk-lib.aws_ec2.ClientVpnUserBasedAuthentication", version: "2.80.0" }, exports2.ClientVpnUserBasedAuthentication = ClientVpnUserBasedAuthentication;
    var ActiveDirectoryAuthentication = class extends ClientVpnUserBasedAuthentication {
      constructor(directoryId) {
        super(), this.directoryId = directoryId;
      }
      render() {
        return { type: "directory-service-authentication", activeDirectory: { directoryId: this.directoryId } };
      }
    };
    var FederatedAuthentication = class extends ClientVpnUserBasedAuthentication {
      constructor(samlProvider, selfServiceSamlProvider) {
        super(), this.samlProvider = samlProvider, this.selfServiceSamlProvider = selfServiceSamlProvider;
      }
      render() {
        return { type: "federated-authentication", federatedAuthentication: { samlProviderArn: this.samlProvider.samlProviderArn, selfServiceSamlProviderArn: this.selfServiceSamlProvider?.samlProviderArn } };
      }
    };
    var ClientVpnEndpoint = class _ClientVpnEndpoint extends core_1.Resource {
      static fromEndpointAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_ClientVpnEndpointAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromEndpointAttributes), error;
        }
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.endpointId = attrs.endpointId, this.connections = new connections_1.Connections({ securityGroups: attrs.securityGroups }), this.targetNetworksAssociated = new constructs_1.DependencyGroup();
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id), this._targetNetworksAssociated = new constructs_1.DependencyGroup();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_ClientVpnEndpointProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ClientVpnEndpoint), error;
        }
        if (!core_1.Token.isUnresolved(props.vpc.vpcCidrBlock)) {
          const clientCidr = new network_util_1.CidrBlock(props.cidr);
          if (new network_util_1.CidrBlock(props.vpc.vpcCidrBlock).containsCidr(clientCidr))
            throw new Error("The client CIDR cannot overlap with the local CIDR of the VPC");
        }
        if (props.dnsServers && props.dnsServers.length > 2)
          throw new Error("A client VPN endpoint can have up to two DNS servers");
        if (props.logging == false && (props.logGroup || props.logStream))
          throw new Error("Cannot specify `logGroup` or `logStream` when logging is disabled");
        if (props.clientConnectionHandler && !core_1.Token.isUnresolved(props.clientConnectionHandler.functionName) && !props.clientConnectionHandler.functionName.startsWith("AWSClientVPN-"))
          throw new Error("The name of the Lambda function must begin with the `AWSClientVPN-` prefix");
        if (props.clientLoginBanner && !core_1.Token.isUnresolved(props.clientLoginBanner) && props.clientLoginBanner.length > 1400)
          throw new Error(`The maximum length for the client login banner is 1400, got ${props.clientLoginBanner.length}`);
        const logging = props.logging ?? true, logGroup = logging ? props.logGroup ?? new logs.LogGroup(this, "LogGroup") : void 0, securityGroups = props.securityGroups ?? [new security_group_1.SecurityGroup(this, "SecurityGroup", { vpc: props.vpc })];
        this.connections = new connections_1.Connections({ securityGroups });
        const endpoint = new ec2_generated_1.CfnClientVpnEndpoint(this, "Resource", { authenticationOptions: renderAuthenticationOptions(props.clientCertificateArn, props.userBasedAuthentication), clientCidrBlock: props.cidr, clientConnectOptions: props.clientConnectionHandler ? { enabled: true, lambdaFunctionArn: props.clientConnectionHandler.functionArn } : void 0, connectionLogOptions: { enabled: logging, cloudwatchLogGroup: logGroup?.logGroupName, cloudwatchLogStream: props.logStream?.logStreamName }, description: props.description, dnsServers: props.dnsServers, securityGroupIds: securityGroups.map((s) => s.securityGroupId), selfServicePortal: booleanToEnabledDisabled(props.selfServicePortal), serverCertificateArn: props.serverCertificateArn, splitTunnel: props.splitTunnel, transportProtocol: props.transportProtocol, vpcId: props.vpc.vpcId, vpnPort: props.port, sessionTimeoutHours: props.sessionTimeout, clientLoginBannerOptions: props.clientLoginBanner ? { enabled: true, bannerText: props.clientLoginBanner } : void 0 });
        this.endpointId = endpoint.ref, props.userBasedAuthentication && (props.selfServicePortal ?? true) && new core_1.CfnOutput(this, "SelfServicePortalUrl", { value: `https://self-service.clientvpn.amazonaws.com/endpoints/${this.endpointId}` });
        const subnetIds = props.vpc.selectSubnets(props.vpcSubnets).subnetIds;
        if (core_1.Token.isUnresolved(subnetIds))
          throw new Error("Cannot associate subnets when VPC are imported from parameters or exports containing lists of subnet IDs.");
        for (const [idx, subnetId] of Object.entries(subnetIds))
          this._targetNetworksAssociated.add(new ec2_generated_1.CfnClientVpnTargetNetworkAssociation(this, `Association${idx}`, { clientVpnEndpointId: this.endpointId, subnetId }));
        this.targetNetworksAssociated = this._targetNetworksAssociated, (props.authorizeAllUsersToVpcCidr ?? true) && this.addAuthorizationRule("AuthorizeAll", { cidr: props.vpc.vpcCidrBlock });
      }
      addAuthorizationRule(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_ClientVpnAuthorizationRuleOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addAuthorizationRule), error;
        }
        return new client_vpn_authorization_rule_1.ClientVpnAuthorizationRule(this, id, { ...props, clientVpnEndpoint: this });
      }
      addRoute(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_ClientVpnRouteOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addRoute), error;
        }
        return new client_vpn_route_1.ClientVpnRoute(this, id, { ...props, clientVpnEndpoint: this });
      }
    };
    _b = JSII_RTTI_SYMBOL_1, ClientVpnEndpoint[_b] = { fqn: "aws-cdk-lib.aws_ec2.ClientVpnEndpoint", version: "2.80.0" }, exports2.ClientVpnEndpoint = ClientVpnEndpoint;
    function renderAuthenticationOptions(clientCertificateArn, userBasedAuthentication) {
      const authenticationOptions = [];
      if (clientCertificateArn && authenticationOptions.push({ type: "certificate-authentication", mutualAuthentication: { clientRootCertificateChainArn: clientCertificateArn } }), userBasedAuthentication && authenticationOptions.push(userBasedAuthentication.render()), authenticationOptions.length === 0)
        throw new Error("A client VPN endpoint must use at least one authentication option");
      return authenticationOptions;
    }
    function booleanToEnabledDisabled(val) {
      switch (val) {
        case void 0:
          return;
        case true:
          return "enabled";
        case false:
          return "disabled";
      }
    }
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/cidr-splits.js
var require_cidr_splits = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/cidr-splits.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.calculateCidrSplits = void 0;
    function calculateCidrSplits(rootNetmask, netmasks) {
      const ret = new Array();
      let offset = 0;
      for (const netmask of netmasks) {
        const size = Math.pow(2, 32 - netmask);
        offset = nextMultiple(offset, size);
        const count = Math.pow(2, netmask - rootNetmask);
        ret.push({ count, netmask, index: offset / size }), offset += size;
      }
      if (offset > Math.pow(2, 32 - rootNetmask))
        throw new Error(`IP space of size /${rootNetmask} not big enough to allocate subnets of sizes ${netmasks.map((x) => `/${x}`)}`);
      return ret;
    }
    exports2.calculateCidrSplits = calculateCidrSplits;
    function nextMultiple(current, multiple) {
      return Math.ceil(current / multiple) * multiple;
    }
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/ip-addresses.js
var require_ip_addresses = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/ip-addresses.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.IpAddresses = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cidr_splits_1 = require_cidr_splits();
    var network_util_1 = require_network_util();
    var core_1 = require_core2();
    var IpAddresses = class {
      static cidr(cidrBlock) {
        return new Cidr(cidrBlock);
      }
      static awsIpamAllocation(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_AwsIpamProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.awsIpamAllocation), error;
        }
        return new AwsIpam(props);
      }
      constructor() {
      }
    };
    _a = JSII_RTTI_SYMBOL_1, IpAddresses[_a] = { fqn: "aws-cdk-lib.aws_ec2.IpAddresses", version: "2.80.0" }, exports2.IpAddresses = IpAddresses;
    var AwsIpam = class {
      constructor(props) {
        this.props = props;
      }
      allocateVpcCidr() {
        return { ipv4NetmaskLength: this.props.ipv4NetmaskLength, ipv4IpamPoolId: this.props.ipv4IpamPoolId };
      }
      allocateSubnetsCidr(input) {
        return { allocatedSubnets: (0, cidr_splits_1.calculateCidrSplits)(this.props.ipv4NetmaskLength, input.requestedSubnets.map((mask) => {
          if (mask.configuration.cidrMask === void 0 && this.props.defaultSubnetIpv4NetmaskLength === void 0)
            throw new Error("If you have not set a cidr for all subnets in this case you must set a defaultCidrMask in AwsIpam Options");
          const cidrMask = mask.configuration.cidrMask ?? this.props.defaultSubnetIpv4NetmaskLength;
          if (cidrMask === void 0)
            throw new Error("Should not have happened, but satisfies the type checker");
          return cidrMask;
        })).map((subnet) => ({ cidr: core_1.Fn.select(subnet.index, core_1.Fn.cidr(input.vpcCidr, subnet.count, `${32 - subnet.netmask}`)) })) };
      }
    };
    var Cidr = class {
      constructor(cidrBlock) {
        if (this.cidrBlock = cidrBlock, core_1.Token.isUnresolved(cidrBlock))
          throw new Error("'cidr' property must be a concrete CIDR string, got a Token (we need to parse it for automatic subdivision)");
        this.networkBuilder = new network_util_1.NetworkBuilder(this.cidrBlock);
      }
      allocateVpcCidr() {
        return { cidrBlock: this.networkBuilder.networkCidr.cidr };
      }
      allocateSubnetsCidr(input) {
        const allocatedSubnets = [], subnetsWithoutDefinedCidr = [];
        input.requestedSubnets.forEach((requestedSubnet, index) => {
          requestedSubnet.configuration.cidrMask === void 0 ? subnetsWithoutDefinedCidr.push({ index, requestedSubnet }) : allocatedSubnets.push({ cidr: this.networkBuilder.addSubnet(requestedSubnet.configuration.cidrMask) });
        });
        const cidrMaskForRemaining = this.networkBuilder.maskForRemainingSubnets(subnetsWithoutDefinedCidr.length);
        return subnetsWithoutDefinedCidr.forEach((subnet) => {
          allocatedSubnets.splice(subnet.index, 0, { cidr: this.networkBuilder.addSubnet(cidrMaskForRemaining) });
        }), { allocatedSubnets };
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-ssm/lib/ssm.generated.js
var require_ssm_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-ssm/lib/ssm.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnResourcePolicy = exports2.CfnResourceDataSync = exports2.CfnPatchBaseline = exports2.CfnParameter = exports2.CfnMaintenanceWindowTask = exports2.CfnMaintenanceWindowTarget = exports2.CfnMaintenanceWindow = exports2.CfnDocument = exports2.CfnAssociation = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applyOnlyAtCronInterval", cdk.validateBoolean)(properties.applyOnlyAtCronInterval)), errors.collect(cdk.propertyValidator("associationName", cdk.validateString)(properties.associationName)), errors.collect(cdk.propertyValidator("automationTargetParameterName", cdk.validateString)(properties.automationTargetParameterName)), errors.collect(cdk.propertyValidator("calendarNames", cdk.listValidator(cdk.validateString))(properties.calendarNames)), errors.collect(cdk.propertyValidator("complianceSeverity", cdk.validateString)(properties.complianceSeverity)), errors.collect(cdk.propertyValidator("documentVersion", cdk.validateString)(properties.documentVersion)), errors.collect(cdk.propertyValidator("instanceId", cdk.validateString)(properties.instanceId)), errors.collect(cdk.propertyValidator("maxConcurrency", cdk.validateString)(properties.maxConcurrency)), errors.collect(cdk.propertyValidator("maxErrors", cdk.validateString)(properties.maxErrors)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("outputLocation", CfnAssociation_InstanceAssociationOutputLocationPropertyValidator)(properties.outputLocation)), errors.collect(cdk.propertyValidator("parameters", cdk.validateObject)(properties.parameters)), errors.collect(cdk.propertyValidator("scheduleExpression", cdk.validateString)(properties.scheduleExpression)), errors.collect(cdk.propertyValidator("scheduleOffset", cdk.validateNumber)(properties.scheduleOffset)), errors.collect(cdk.propertyValidator("syncCompliance", cdk.validateString)(properties.syncCompliance)), errors.collect(cdk.propertyValidator("targets", cdk.listValidator(CfnAssociation_TargetPropertyValidator))(properties.targets)), errors.collect(cdk.propertyValidator("waitForSuccessTimeoutSeconds", cdk.validateNumber)(properties.waitForSuccessTimeoutSeconds)), errors.wrap('supplied properties not correct for "CfnAssociationProps"');
    }
    function cfnAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssociationPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), ApplyOnlyAtCronInterval: cdk.booleanToCloudFormation(properties.applyOnlyAtCronInterval), AssociationName: cdk.stringToCloudFormation(properties.associationName), AutomationTargetParameterName: cdk.stringToCloudFormation(properties.automationTargetParameterName), CalendarNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.calendarNames), ComplianceSeverity: cdk.stringToCloudFormation(properties.complianceSeverity), DocumentVersion: cdk.stringToCloudFormation(properties.documentVersion), InstanceId: cdk.stringToCloudFormation(properties.instanceId), MaxConcurrency: cdk.stringToCloudFormation(properties.maxConcurrency), MaxErrors: cdk.stringToCloudFormation(properties.maxErrors), OutputLocation: cfnAssociationInstanceAssociationOutputLocationPropertyToCloudFormation(properties.outputLocation), Parameters: cdk.objectToCloudFormation(properties.parameters), ScheduleExpression: cdk.stringToCloudFormation(properties.scheduleExpression), ScheduleOffset: cdk.numberToCloudFormation(properties.scheduleOffset), SyncCompliance: cdk.stringToCloudFormation(properties.syncCompliance), Targets: cdk.listMapper(cfnAssociationTargetPropertyToCloudFormation)(properties.targets), WaitForSuccessTimeoutSeconds: cdk.numberToCloudFormation(properties.waitForSuccessTimeoutSeconds) }) : properties;
    }
    function CfnAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("applyOnlyAtCronInterval", "ApplyOnlyAtCronInterval", properties.ApplyOnlyAtCronInterval != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ApplyOnlyAtCronInterval) : void 0), ret.addPropertyResult("associationName", "AssociationName", properties.AssociationName != null ? cfn_parse.FromCloudFormation.getString(properties.AssociationName) : void 0), ret.addPropertyResult("automationTargetParameterName", "AutomationTargetParameterName", properties.AutomationTargetParameterName != null ? cfn_parse.FromCloudFormation.getString(properties.AutomationTargetParameterName) : void 0), ret.addPropertyResult("calendarNames", "CalendarNames", properties.CalendarNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CalendarNames) : void 0), ret.addPropertyResult("complianceSeverity", "ComplianceSeverity", properties.ComplianceSeverity != null ? cfn_parse.FromCloudFormation.getString(properties.ComplianceSeverity) : void 0), ret.addPropertyResult("documentVersion", "DocumentVersion", properties.DocumentVersion != null ? cfn_parse.FromCloudFormation.getString(properties.DocumentVersion) : void 0), ret.addPropertyResult("instanceId", "InstanceId", properties.InstanceId != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceId) : void 0), ret.addPropertyResult("maxConcurrency", "MaxConcurrency", properties.MaxConcurrency != null ? cfn_parse.FromCloudFormation.getString(properties.MaxConcurrency) : void 0), ret.addPropertyResult("maxErrors", "MaxErrors", properties.MaxErrors != null ? cfn_parse.FromCloudFormation.getString(properties.MaxErrors) : void 0), ret.addPropertyResult("outputLocation", "OutputLocation", properties.OutputLocation != null ? CfnAssociationInstanceAssociationOutputLocationPropertyFromCloudFormation(properties.OutputLocation) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getAny(properties.Parameters) : void 0), ret.addPropertyResult("scheduleExpression", "ScheduleExpression", properties.ScheduleExpression != null ? cfn_parse.FromCloudFormation.getString(properties.ScheduleExpression) : void 0), ret.addPropertyResult("scheduleOffset", "ScheduleOffset", properties.ScheduleOffset != null ? cfn_parse.FromCloudFormation.getNumber(properties.ScheduleOffset) : void 0), ret.addPropertyResult("syncCompliance", "SyncCompliance", properties.SyncCompliance != null ? cfn_parse.FromCloudFormation.getString(properties.SyncCompliance) : void 0), ret.addPropertyResult("targets", "Targets", properties.Targets != null ? cfn_parse.FromCloudFormation.getArray(CfnAssociationTargetPropertyFromCloudFormation)(properties.Targets) : void 0), ret.addPropertyResult("waitForSuccessTimeoutSeconds", "WaitForSuccessTimeoutSeconds", properties.WaitForSuccessTimeoutSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.WaitForSuccessTimeoutSeconds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAssociation = class _CfnAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ssm_CfnAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAssociation), error;
        }
        cdk.requireProperty(props, "name", this), this.attrAssociationId = cdk.Token.asString(this.getAtt("AssociationId", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.applyOnlyAtCronInterval = props.applyOnlyAtCronInterval, this.associationName = props.associationName, this.automationTargetParameterName = props.automationTargetParameterName, this.calendarNames = props.calendarNames, this.complianceSeverity = props.complianceSeverity, this.documentVersion = props.documentVersion, this.instanceId = props.instanceId, this.maxConcurrency = props.maxConcurrency, this.maxErrors = props.maxErrors, this.outputLocation = props.outputLocation, this.parameters = props.parameters, this.scheduleExpression = props.scheduleExpression, this.scheduleOffset = props.scheduleOffset, this.syncCompliance = props.syncCompliance, this.targets = props.targets, this.waitForSuccessTimeoutSeconds = props.waitForSuccessTimeoutSeconds;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, applyOnlyAtCronInterval: this.applyOnlyAtCronInterval, associationName: this.associationName, automationTargetParameterName: this.automationTargetParameterName, calendarNames: this.calendarNames, complianceSeverity: this.complianceSeverity, documentVersion: this.documentVersion, instanceId: this.instanceId, maxConcurrency: this.maxConcurrency, maxErrors: this.maxErrors, outputLocation: this.outputLocation, parameters: this.parameters, scheduleExpression: this.scheduleExpression, scheduleOffset: this.scheduleOffset, syncCompliance: this.syncCompliance, targets: this.targets, waitForSuccessTimeoutSeconds: this.waitForSuccessTimeoutSeconds };
      }
      renderProperties(props) {
        return cfnAssociationPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAssociation[_a] = { fqn: "aws-cdk-lib.aws_ssm.CfnAssociation", version: "2.80.0" }, CfnAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::SSM::Association", exports2.CfnAssociation = CfnAssociation;
    function CfnAssociation_InstanceAssociationOutputLocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3Location", CfnAssociation_S3OutputLocationPropertyValidator)(properties.s3Location)), errors.wrap('supplied properties not correct for "InstanceAssociationOutputLocationProperty"');
    }
    function cfnAssociationInstanceAssociationOutputLocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssociation_InstanceAssociationOutputLocationPropertyValidator(properties).assertSuccess(), { S3Location: cfnAssociationS3OutputLocationPropertyToCloudFormation(properties.s3Location) }) : properties;
    }
    function CfnAssociationInstanceAssociationOutputLocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Location", "S3Location", properties.S3Location != null ? CfnAssociationS3OutputLocationPropertyFromCloudFormation(properties.S3Location) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAssociation_S3OutputLocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("outputS3BucketName", cdk.validateString)(properties.outputS3BucketName)), errors.collect(cdk.propertyValidator("outputS3KeyPrefix", cdk.validateString)(properties.outputS3KeyPrefix)), errors.collect(cdk.propertyValidator("outputS3Region", cdk.validateString)(properties.outputS3Region)), errors.wrap('supplied properties not correct for "S3OutputLocationProperty"');
    }
    function cfnAssociationS3OutputLocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssociation_S3OutputLocationPropertyValidator(properties).assertSuccess(), { OutputS3BucketName: cdk.stringToCloudFormation(properties.outputS3BucketName), OutputS3KeyPrefix: cdk.stringToCloudFormation(properties.outputS3KeyPrefix), OutputS3Region: cdk.stringToCloudFormation(properties.outputS3Region) }) : properties;
    }
    function CfnAssociationS3OutputLocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("outputS3BucketName", "OutputS3BucketName", properties.OutputS3BucketName != null ? cfn_parse.FromCloudFormation.getString(properties.OutputS3BucketName) : void 0), ret.addPropertyResult("outputS3KeyPrefix", "OutputS3KeyPrefix", properties.OutputS3KeyPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.OutputS3KeyPrefix) : void 0), ret.addPropertyResult("outputS3Region", "OutputS3Region", properties.OutputS3Region != null ? cfn_parse.FromCloudFormation.getString(properties.OutputS3Region) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAssociation_TargetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("values", cdk.requiredValidator)(properties.values)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "TargetProperty"');
    }
    function cfnAssociationTargetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssociation_TargetPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnAssociationTargetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("values", "Values", cfn_parse.FromCloudFormation.getStringArray(properties.Values)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDocumentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attachments", cdk.listValidator(CfnDocument_AttachmentsSourcePropertyValidator))(properties.attachments)), errors.collect(cdk.propertyValidator("content", cdk.requiredValidator)(properties.content)), errors.collect(cdk.propertyValidator("content", cdk.validateObject)(properties.content)), errors.collect(cdk.propertyValidator("documentFormat", cdk.validateString)(properties.documentFormat)), errors.collect(cdk.propertyValidator("documentType", cdk.validateString)(properties.documentType)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("requires", cdk.listValidator(CfnDocument_DocumentRequiresPropertyValidator))(properties.requires)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("targetType", cdk.validateString)(properties.targetType)), errors.collect(cdk.propertyValidator("updateMethod", cdk.validateString)(properties.updateMethod)), errors.collect(cdk.propertyValidator("versionName", cdk.validateString)(properties.versionName)), errors.wrap('supplied properties not correct for "CfnDocumentProps"');
    }
    function cfnDocumentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDocumentPropsValidator(properties).assertSuccess(), { Content: cdk.objectToCloudFormation(properties.content), Attachments: cdk.listMapper(cfnDocumentAttachmentsSourcePropertyToCloudFormation)(properties.attachments), DocumentFormat: cdk.stringToCloudFormation(properties.documentFormat), DocumentType: cdk.stringToCloudFormation(properties.documentType), Name: cdk.stringToCloudFormation(properties.name), Requires: cdk.listMapper(cfnDocumentDocumentRequiresPropertyToCloudFormation)(properties.requires), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TargetType: cdk.stringToCloudFormation(properties.targetType), UpdateMethod: cdk.stringToCloudFormation(properties.updateMethod), VersionName: cdk.stringToCloudFormation(properties.versionName) }) : properties;
    }
    function CfnDocumentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("content", "Content", cfn_parse.FromCloudFormation.getAny(properties.Content)), ret.addPropertyResult("attachments", "Attachments", properties.Attachments != null ? cfn_parse.FromCloudFormation.getArray(CfnDocumentAttachmentsSourcePropertyFromCloudFormation)(properties.Attachments) : void 0), ret.addPropertyResult("documentFormat", "DocumentFormat", properties.DocumentFormat != null ? cfn_parse.FromCloudFormation.getString(properties.DocumentFormat) : void 0), ret.addPropertyResult("documentType", "DocumentType", properties.DocumentType != null ? cfn_parse.FromCloudFormation.getString(properties.DocumentType) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("requires", "Requires", properties.Requires != null ? cfn_parse.FromCloudFormation.getArray(CfnDocumentDocumentRequiresPropertyFromCloudFormation)(properties.Requires) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("targetType", "TargetType", properties.TargetType != null ? cfn_parse.FromCloudFormation.getString(properties.TargetType) : void 0), ret.addPropertyResult("updateMethod", "UpdateMethod", properties.UpdateMethod != null ? cfn_parse.FromCloudFormation.getString(properties.UpdateMethod) : void 0), ret.addPropertyResult("versionName", "VersionName", properties.VersionName != null ? cfn_parse.FromCloudFormation.getString(properties.VersionName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDocument = class _CfnDocument extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDocumentPropsFromCloudFormation(resourceProperties), ret = new _CfnDocument(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDocument.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ssm_CfnDocumentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDocument), error;
        }
        cdk.requireProperty(props, "content", this), this.content = props.content, this.attachments = props.attachments, this.documentFormat = props.documentFormat, this.documentType = props.documentType, this.name = props.name, this.requires = props.requires, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SSM::Document", props.tags, { tagPropertyName: "tags" }), this.targetType = props.targetType, this.updateMethod = props.updateMethod, this.versionName = props.versionName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDocument.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { content: this.content, attachments: this.attachments, documentFormat: this.documentFormat, documentType: this.documentType, name: this.name, requires: this.requires, tags: this.tags.renderTags(), targetType: this.targetType, updateMethod: this.updateMethod, versionName: this.versionName };
      }
      renderProperties(props) {
        return cfnDocumentPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnDocument[_b] = { fqn: "aws-cdk-lib.aws_ssm.CfnDocument", version: "2.80.0" }, CfnDocument.CFN_RESOURCE_TYPE_NAME = "AWS::SSM::Document", exports2.CfnDocument = CfnDocument;
    function CfnDocument_AttachmentsSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "AttachmentsSourceProperty"');
    }
    function cfnDocumentAttachmentsSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDocument_AttachmentsSourcePropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Name: cdk.stringToCloudFormation(properties.name), Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnDocumentAttachmentsSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDocument_DocumentRequiresPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "DocumentRequiresProperty"');
    }
    function cfnDocumentDocumentRequiresPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDocument_DocumentRequiresPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnDocumentDocumentRequiresPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getString(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMaintenanceWindowPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowUnassociatedTargets", cdk.requiredValidator)(properties.allowUnassociatedTargets)), errors.collect(cdk.propertyValidator("allowUnassociatedTargets", cdk.validateBoolean)(properties.allowUnassociatedTargets)), errors.collect(cdk.propertyValidator("cutoff", cdk.requiredValidator)(properties.cutoff)), errors.collect(cdk.propertyValidator("cutoff", cdk.validateNumber)(properties.cutoff)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("duration", cdk.requiredValidator)(properties.duration)), errors.collect(cdk.propertyValidator("duration", cdk.validateNumber)(properties.duration)), errors.collect(cdk.propertyValidator("endDate", cdk.validateString)(properties.endDate)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("schedule", cdk.requiredValidator)(properties.schedule)), errors.collect(cdk.propertyValidator("schedule", cdk.validateString)(properties.schedule)), errors.collect(cdk.propertyValidator("scheduleOffset", cdk.validateNumber)(properties.scheduleOffset)), errors.collect(cdk.propertyValidator("scheduleTimezone", cdk.validateString)(properties.scheduleTimezone)), errors.collect(cdk.propertyValidator("startDate", cdk.validateString)(properties.startDate)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnMaintenanceWindowProps"');
    }
    function cfnMaintenanceWindowPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMaintenanceWindowPropsValidator(properties).assertSuccess(), { AllowUnassociatedTargets: cdk.booleanToCloudFormation(properties.allowUnassociatedTargets), Cutoff: cdk.numberToCloudFormation(properties.cutoff), Duration: cdk.numberToCloudFormation(properties.duration), Name: cdk.stringToCloudFormation(properties.name), Schedule: cdk.stringToCloudFormation(properties.schedule), Description: cdk.stringToCloudFormation(properties.description), EndDate: cdk.stringToCloudFormation(properties.endDate), ScheduleOffset: cdk.numberToCloudFormation(properties.scheduleOffset), ScheduleTimezone: cdk.stringToCloudFormation(properties.scheduleTimezone), StartDate: cdk.stringToCloudFormation(properties.startDate), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnMaintenanceWindowPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowUnassociatedTargets", "AllowUnassociatedTargets", cfn_parse.FromCloudFormation.getBoolean(properties.AllowUnassociatedTargets)), ret.addPropertyResult("cutoff", "Cutoff", cfn_parse.FromCloudFormation.getNumber(properties.Cutoff)), ret.addPropertyResult("duration", "Duration", cfn_parse.FromCloudFormation.getNumber(properties.Duration)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("schedule", "Schedule", cfn_parse.FromCloudFormation.getString(properties.Schedule)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("endDate", "EndDate", properties.EndDate != null ? cfn_parse.FromCloudFormation.getString(properties.EndDate) : void 0), ret.addPropertyResult("scheduleOffset", "ScheduleOffset", properties.ScheduleOffset != null ? cfn_parse.FromCloudFormation.getNumber(properties.ScheduleOffset) : void 0), ret.addPropertyResult("scheduleTimezone", "ScheduleTimezone", properties.ScheduleTimezone != null ? cfn_parse.FromCloudFormation.getString(properties.ScheduleTimezone) : void 0), ret.addPropertyResult("startDate", "StartDate", properties.StartDate != null ? cfn_parse.FromCloudFormation.getString(properties.StartDate) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnMaintenanceWindow = class _CfnMaintenanceWindow extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnMaintenanceWindowPropsFromCloudFormation(resourceProperties), ret = new _CfnMaintenanceWindow(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnMaintenanceWindow.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ssm_CfnMaintenanceWindowProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnMaintenanceWindow), error;
        }
        cdk.requireProperty(props, "allowUnassociatedTargets", this), cdk.requireProperty(props, "cutoff", this), cdk.requireProperty(props, "duration", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "schedule", this), this.allowUnassociatedTargets = props.allowUnassociatedTargets, this.cutoff = props.cutoff, this.duration = props.duration, this.name = props.name, this.schedule = props.schedule, this.description = props.description, this.endDate = props.endDate, this.scheduleOffset = props.scheduleOffset, this.scheduleTimezone = props.scheduleTimezone, this.startDate = props.startDate, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SSM::MaintenanceWindow", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnMaintenanceWindow.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { allowUnassociatedTargets: this.allowUnassociatedTargets, cutoff: this.cutoff, duration: this.duration, name: this.name, schedule: this.schedule, description: this.description, endDate: this.endDate, scheduleOffset: this.scheduleOffset, scheduleTimezone: this.scheduleTimezone, startDate: this.startDate, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnMaintenanceWindowPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnMaintenanceWindow[_c] = { fqn: "aws-cdk-lib.aws_ssm.CfnMaintenanceWindow", version: "2.80.0" }, CfnMaintenanceWindow.CFN_RESOURCE_TYPE_NAME = "AWS::SSM::MaintenanceWindow", exports2.CfnMaintenanceWindow = CfnMaintenanceWindow;
    function CfnMaintenanceWindowTargetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("ownerInformation", cdk.validateString)(properties.ownerInformation)), errors.collect(cdk.propertyValidator("resourceType", cdk.requiredValidator)(properties.resourceType)), errors.collect(cdk.propertyValidator("resourceType", cdk.validateString)(properties.resourceType)), errors.collect(cdk.propertyValidator("targets", cdk.requiredValidator)(properties.targets)), errors.collect(cdk.propertyValidator("targets", cdk.listValidator(CfnMaintenanceWindowTarget_TargetsPropertyValidator))(properties.targets)), errors.collect(cdk.propertyValidator("windowId", cdk.requiredValidator)(properties.windowId)), errors.collect(cdk.propertyValidator("windowId", cdk.validateString)(properties.windowId)), errors.wrap('supplied properties not correct for "CfnMaintenanceWindowTargetProps"');
    }
    function cfnMaintenanceWindowTargetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMaintenanceWindowTargetPropsValidator(properties).assertSuccess(), { ResourceType: cdk.stringToCloudFormation(properties.resourceType), Targets: cdk.listMapper(cfnMaintenanceWindowTargetTargetsPropertyToCloudFormation)(properties.targets), WindowId: cdk.stringToCloudFormation(properties.windowId), Description: cdk.stringToCloudFormation(properties.description), Name: cdk.stringToCloudFormation(properties.name), OwnerInformation: cdk.stringToCloudFormation(properties.ownerInformation) }) : properties;
    }
    function CfnMaintenanceWindowTargetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceType", "ResourceType", cfn_parse.FromCloudFormation.getString(properties.ResourceType)), ret.addPropertyResult("targets", "Targets", cfn_parse.FromCloudFormation.getArray(CfnMaintenanceWindowTargetTargetsPropertyFromCloudFormation)(properties.Targets)), ret.addPropertyResult("windowId", "WindowId", cfn_parse.FromCloudFormation.getString(properties.WindowId)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("ownerInformation", "OwnerInformation", properties.OwnerInformation != null ? cfn_parse.FromCloudFormation.getString(properties.OwnerInformation) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnMaintenanceWindowTarget = class _CfnMaintenanceWindowTarget extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnMaintenanceWindowTargetPropsFromCloudFormation(resourceProperties), ret = new _CfnMaintenanceWindowTarget(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnMaintenanceWindowTarget.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ssm_CfnMaintenanceWindowTargetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnMaintenanceWindowTarget), error;
        }
        cdk.requireProperty(props, "resourceType", this), cdk.requireProperty(props, "targets", this), cdk.requireProperty(props, "windowId", this), this.resourceType = props.resourceType, this.targets = props.targets, this.windowId = props.windowId, this.description = props.description, this.name = props.name, this.ownerInformation = props.ownerInformation;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnMaintenanceWindowTarget.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { resourceType: this.resourceType, targets: this.targets, windowId: this.windowId, description: this.description, name: this.name, ownerInformation: this.ownerInformation };
      }
      renderProperties(props) {
        return cfnMaintenanceWindowTargetPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnMaintenanceWindowTarget[_d] = { fqn: "aws-cdk-lib.aws_ssm.CfnMaintenanceWindowTarget", version: "2.80.0" }, CfnMaintenanceWindowTarget.CFN_RESOURCE_TYPE_NAME = "AWS::SSM::MaintenanceWindowTarget", exports2.CfnMaintenanceWindowTarget = CfnMaintenanceWindowTarget;
    function CfnMaintenanceWindowTarget_TargetsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("values", cdk.requiredValidator)(properties.values)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "TargetsProperty"');
    }
    function cfnMaintenanceWindowTargetTargetsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMaintenanceWindowTarget_TargetsPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnMaintenanceWindowTargetTargetsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("values", "Values", cfn_parse.FromCloudFormation.getStringArray(properties.Values)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMaintenanceWindowTaskPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cutoffBehavior", cdk.validateString)(properties.cutoffBehavior)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("loggingInfo", CfnMaintenanceWindowTask_LoggingInfoPropertyValidator)(properties.loggingInfo)), errors.collect(cdk.propertyValidator("maxConcurrency", cdk.validateString)(properties.maxConcurrency)), errors.collect(cdk.propertyValidator("maxErrors", cdk.validateString)(properties.maxErrors)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("priority", cdk.requiredValidator)(properties.priority)), errors.collect(cdk.propertyValidator("priority", cdk.validateNumber)(properties.priority)), errors.collect(cdk.propertyValidator("serviceRoleArn", cdk.validateString)(properties.serviceRoleArn)), errors.collect(cdk.propertyValidator("targets", cdk.listValidator(CfnMaintenanceWindowTask_TargetPropertyValidator))(properties.targets)), errors.collect(cdk.propertyValidator("taskArn", cdk.requiredValidator)(properties.taskArn)), errors.collect(cdk.propertyValidator("taskArn", cdk.validateString)(properties.taskArn)), errors.collect(cdk.propertyValidator("taskInvocationParameters", CfnMaintenanceWindowTask_TaskInvocationParametersPropertyValidator)(properties.taskInvocationParameters)), errors.collect(cdk.propertyValidator("taskParameters", cdk.validateObject)(properties.taskParameters)), errors.collect(cdk.propertyValidator("taskType", cdk.requiredValidator)(properties.taskType)), errors.collect(cdk.propertyValidator("taskType", cdk.validateString)(properties.taskType)), errors.collect(cdk.propertyValidator("windowId", cdk.requiredValidator)(properties.windowId)), errors.collect(cdk.propertyValidator("windowId", cdk.validateString)(properties.windowId)), errors.wrap('supplied properties not correct for "CfnMaintenanceWindowTaskProps"');
    }
    function cfnMaintenanceWindowTaskPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMaintenanceWindowTaskPropsValidator(properties).assertSuccess(), { Priority: cdk.numberToCloudFormation(properties.priority), TaskArn: cdk.stringToCloudFormation(properties.taskArn), TaskType: cdk.stringToCloudFormation(properties.taskType), WindowId: cdk.stringToCloudFormation(properties.windowId), CutoffBehavior: cdk.stringToCloudFormation(properties.cutoffBehavior), Description: cdk.stringToCloudFormation(properties.description), LoggingInfo: cfnMaintenanceWindowTaskLoggingInfoPropertyToCloudFormation(properties.loggingInfo), MaxConcurrency: cdk.stringToCloudFormation(properties.maxConcurrency), MaxErrors: cdk.stringToCloudFormation(properties.maxErrors), Name: cdk.stringToCloudFormation(properties.name), ServiceRoleArn: cdk.stringToCloudFormation(properties.serviceRoleArn), Targets: cdk.listMapper(cfnMaintenanceWindowTaskTargetPropertyToCloudFormation)(properties.targets), TaskInvocationParameters: cfnMaintenanceWindowTaskTaskInvocationParametersPropertyToCloudFormation(properties.taskInvocationParameters), TaskParameters: cdk.objectToCloudFormation(properties.taskParameters) }) : properties;
    }
    function CfnMaintenanceWindowTaskPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("priority", "Priority", cfn_parse.FromCloudFormation.getNumber(properties.Priority)), ret.addPropertyResult("taskArn", "TaskArn", cfn_parse.FromCloudFormation.getString(properties.TaskArn)), ret.addPropertyResult("taskType", "TaskType", cfn_parse.FromCloudFormation.getString(properties.TaskType)), ret.addPropertyResult("windowId", "WindowId", cfn_parse.FromCloudFormation.getString(properties.WindowId)), ret.addPropertyResult("cutoffBehavior", "CutoffBehavior", properties.CutoffBehavior != null ? cfn_parse.FromCloudFormation.getString(properties.CutoffBehavior) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("loggingInfo", "LoggingInfo", properties.LoggingInfo != null ? CfnMaintenanceWindowTaskLoggingInfoPropertyFromCloudFormation(properties.LoggingInfo) : void 0), ret.addPropertyResult("maxConcurrency", "MaxConcurrency", properties.MaxConcurrency != null ? cfn_parse.FromCloudFormation.getString(properties.MaxConcurrency) : void 0), ret.addPropertyResult("maxErrors", "MaxErrors", properties.MaxErrors != null ? cfn_parse.FromCloudFormation.getString(properties.MaxErrors) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("serviceRoleArn", "ServiceRoleArn", properties.ServiceRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceRoleArn) : void 0), ret.addPropertyResult("targets", "Targets", properties.Targets != null ? cfn_parse.FromCloudFormation.getArray(CfnMaintenanceWindowTaskTargetPropertyFromCloudFormation)(properties.Targets) : void 0), ret.addPropertyResult("taskInvocationParameters", "TaskInvocationParameters", properties.TaskInvocationParameters != null ? CfnMaintenanceWindowTaskTaskInvocationParametersPropertyFromCloudFormation(properties.TaskInvocationParameters) : void 0), ret.addPropertyResult("taskParameters", "TaskParameters", properties.TaskParameters != null ? cfn_parse.FromCloudFormation.getAny(properties.TaskParameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnMaintenanceWindowTask = class _CfnMaintenanceWindowTask extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnMaintenanceWindowTaskPropsFromCloudFormation(resourceProperties), ret = new _CfnMaintenanceWindowTask(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnMaintenanceWindowTask.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ssm_CfnMaintenanceWindowTaskProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnMaintenanceWindowTask), error;
        }
        cdk.requireProperty(props, "priority", this), cdk.requireProperty(props, "taskArn", this), cdk.requireProperty(props, "taskType", this), cdk.requireProperty(props, "windowId", this), this.priority = props.priority, this.taskArn = props.taskArn, this.taskType = props.taskType, this.windowId = props.windowId, this.cutoffBehavior = props.cutoffBehavior, this.description = props.description, this.loggingInfo = props.loggingInfo, this.maxConcurrency = props.maxConcurrency, this.maxErrors = props.maxErrors, this.name = props.name, this.serviceRoleArn = props.serviceRoleArn, this.targets = props.targets, this.taskInvocationParameters = props.taskInvocationParameters, this.taskParameters = props.taskParameters;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnMaintenanceWindowTask.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { priority: this.priority, taskArn: this.taskArn, taskType: this.taskType, windowId: this.windowId, cutoffBehavior: this.cutoffBehavior, description: this.description, loggingInfo: this.loggingInfo, maxConcurrency: this.maxConcurrency, maxErrors: this.maxErrors, name: this.name, serviceRoleArn: this.serviceRoleArn, targets: this.targets, taskInvocationParameters: this.taskInvocationParameters, taskParameters: this.taskParameters };
      }
      renderProperties(props) {
        return cfnMaintenanceWindowTaskPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnMaintenanceWindowTask[_e] = { fqn: "aws-cdk-lib.aws_ssm.CfnMaintenanceWindowTask", version: "2.80.0" }, CfnMaintenanceWindowTask.CFN_RESOURCE_TYPE_NAME = "AWS::SSM::MaintenanceWindowTask", exports2.CfnMaintenanceWindowTask = CfnMaintenanceWindowTask;
    function CfnMaintenanceWindowTask_CloudWatchOutputConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchLogGroupName", cdk.validateString)(properties.cloudWatchLogGroupName)), errors.collect(cdk.propertyValidator("cloudWatchOutputEnabled", cdk.validateBoolean)(properties.cloudWatchOutputEnabled)), errors.wrap('supplied properties not correct for "CloudWatchOutputConfigProperty"');
    }
    function cfnMaintenanceWindowTaskCloudWatchOutputConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMaintenanceWindowTask_CloudWatchOutputConfigPropertyValidator(properties).assertSuccess(), { CloudWatchLogGroupName: cdk.stringToCloudFormation(properties.cloudWatchLogGroupName), CloudWatchOutputEnabled: cdk.booleanToCloudFormation(properties.cloudWatchOutputEnabled) }) : properties;
    }
    function CfnMaintenanceWindowTaskCloudWatchOutputConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchLogGroupName", "CloudWatchLogGroupName", properties.CloudWatchLogGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.CloudWatchLogGroupName) : void 0), ret.addPropertyResult("cloudWatchOutputEnabled", "CloudWatchOutputEnabled", properties.CloudWatchOutputEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CloudWatchOutputEnabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMaintenanceWindowTask_LoggingInfoPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("region", cdk.requiredValidator)(properties.region)), errors.collect(cdk.propertyValidator("region", cdk.validateString)(properties.region)), errors.collect(cdk.propertyValidator("s3Bucket", cdk.requiredValidator)(properties.s3Bucket)), errors.collect(cdk.propertyValidator("s3Bucket", cdk.validateString)(properties.s3Bucket)), errors.collect(cdk.propertyValidator("s3Prefix", cdk.validateString)(properties.s3Prefix)), errors.wrap('supplied properties not correct for "LoggingInfoProperty"');
    }
    function cfnMaintenanceWindowTaskLoggingInfoPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMaintenanceWindowTask_LoggingInfoPropertyValidator(properties).assertSuccess(), { Region: cdk.stringToCloudFormation(properties.region), S3Bucket: cdk.stringToCloudFormation(properties.s3Bucket), S3Prefix: cdk.stringToCloudFormation(properties.s3Prefix) }) : properties;
    }
    function CfnMaintenanceWindowTaskLoggingInfoPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("region", "Region", cfn_parse.FromCloudFormation.getString(properties.Region)), ret.addPropertyResult("s3Bucket", "S3Bucket", cfn_parse.FromCloudFormation.getString(properties.S3Bucket)), ret.addPropertyResult("s3Prefix", "S3Prefix", properties.S3Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.S3Prefix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMaintenanceWindowTask_MaintenanceWindowAutomationParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("documentVersion", cdk.validateString)(properties.documentVersion)), errors.collect(cdk.propertyValidator("parameters", cdk.validateObject)(properties.parameters)), errors.wrap('supplied properties not correct for "MaintenanceWindowAutomationParametersProperty"');
    }
    function cfnMaintenanceWindowTaskMaintenanceWindowAutomationParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMaintenanceWindowTask_MaintenanceWindowAutomationParametersPropertyValidator(properties).assertSuccess(), { DocumentVersion: cdk.stringToCloudFormation(properties.documentVersion), Parameters: cdk.objectToCloudFormation(properties.parameters) }) : properties;
    }
    function CfnMaintenanceWindowTaskMaintenanceWindowAutomationParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("documentVersion", "DocumentVersion", properties.DocumentVersion != null ? cfn_parse.FromCloudFormation.getString(properties.DocumentVersion) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getAny(properties.Parameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMaintenanceWindowTask_MaintenanceWindowLambdaParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clientContext", cdk.validateString)(properties.clientContext)), errors.collect(cdk.propertyValidator("payload", cdk.validateString)(properties.payload)), errors.collect(cdk.propertyValidator("qualifier", cdk.validateString)(properties.qualifier)), errors.wrap('supplied properties not correct for "MaintenanceWindowLambdaParametersProperty"');
    }
    function cfnMaintenanceWindowTaskMaintenanceWindowLambdaParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMaintenanceWindowTask_MaintenanceWindowLambdaParametersPropertyValidator(properties).assertSuccess(), { ClientContext: cdk.stringToCloudFormation(properties.clientContext), Payload: cdk.stringToCloudFormation(properties.payload), Qualifier: cdk.stringToCloudFormation(properties.qualifier) }) : properties;
    }
    function CfnMaintenanceWindowTaskMaintenanceWindowLambdaParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clientContext", "ClientContext", properties.ClientContext != null ? cfn_parse.FromCloudFormation.getString(properties.ClientContext) : void 0), ret.addPropertyResult("payload", "Payload", properties.Payload != null ? cfn_parse.FromCloudFormation.getString(properties.Payload) : void 0), ret.addPropertyResult("qualifier", "Qualifier", properties.Qualifier != null ? cfn_parse.FromCloudFormation.getString(properties.Qualifier) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMaintenanceWindowTask_MaintenanceWindowRunCommandParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchOutputConfig", CfnMaintenanceWindowTask_CloudWatchOutputConfigPropertyValidator)(properties.cloudWatchOutputConfig)), errors.collect(cdk.propertyValidator("comment", cdk.validateString)(properties.comment)), errors.collect(cdk.propertyValidator("documentHash", cdk.validateString)(properties.documentHash)), errors.collect(cdk.propertyValidator("documentHashType", cdk.validateString)(properties.documentHashType)), errors.collect(cdk.propertyValidator("documentVersion", cdk.validateString)(properties.documentVersion)), errors.collect(cdk.propertyValidator("notificationConfig", CfnMaintenanceWindowTask_NotificationConfigPropertyValidator)(properties.notificationConfig)), errors.collect(cdk.propertyValidator("outputS3BucketName", cdk.validateString)(properties.outputS3BucketName)), errors.collect(cdk.propertyValidator("outputS3KeyPrefix", cdk.validateString)(properties.outputS3KeyPrefix)), errors.collect(cdk.propertyValidator("parameters", cdk.validateObject)(properties.parameters)), errors.collect(cdk.propertyValidator("serviceRoleArn", cdk.validateString)(properties.serviceRoleArn)), errors.collect(cdk.propertyValidator("timeoutSeconds", cdk.validateNumber)(properties.timeoutSeconds)), errors.wrap('supplied properties not correct for "MaintenanceWindowRunCommandParametersProperty"');
    }
    function cfnMaintenanceWindowTaskMaintenanceWindowRunCommandParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMaintenanceWindowTask_MaintenanceWindowRunCommandParametersPropertyValidator(properties).assertSuccess(), { CloudWatchOutputConfig: cfnMaintenanceWindowTaskCloudWatchOutputConfigPropertyToCloudFormation(properties.cloudWatchOutputConfig), Comment: cdk.stringToCloudFormation(properties.comment), DocumentHash: cdk.stringToCloudFormation(properties.documentHash), DocumentHashType: cdk.stringToCloudFormation(properties.documentHashType), DocumentVersion: cdk.stringToCloudFormation(properties.documentVersion), NotificationConfig: cfnMaintenanceWindowTaskNotificationConfigPropertyToCloudFormation(properties.notificationConfig), OutputS3BucketName: cdk.stringToCloudFormation(properties.outputS3BucketName), OutputS3KeyPrefix: cdk.stringToCloudFormation(properties.outputS3KeyPrefix), Parameters: cdk.objectToCloudFormation(properties.parameters), ServiceRoleArn: cdk.stringToCloudFormation(properties.serviceRoleArn), TimeoutSeconds: cdk.numberToCloudFormation(properties.timeoutSeconds) }) : properties;
    }
    function CfnMaintenanceWindowTaskMaintenanceWindowRunCommandParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchOutputConfig", "CloudWatchOutputConfig", properties.CloudWatchOutputConfig != null ? CfnMaintenanceWindowTaskCloudWatchOutputConfigPropertyFromCloudFormation(properties.CloudWatchOutputConfig) : void 0), ret.addPropertyResult("comment", "Comment", properties.Comment != null ? cfn_parse.FromCloudFormation.getString(properties.Comment) : void 0), ret.addPropertyResult("documentHash", "DocumentHash", properties.DocumentHash != null ? cfn_parse.FromCloudFormation.getString(properties.DocumentHash) : void 0), ret.addPropertyResult("documentHashType", "DocumentHashType", properties.DocumentHashType != null ? cfn_parse.FromCloudFormation.getString(properties.DocumentHashType) : void 0), ret.addPropertyResult("documentVersion", "DocumentVersion", properties.DocumentVersion != null ? cfn_parse.FromCloudFormation.getString(properties.DocumentVersion) : void 0), ret.addPropertyResult("notificationConfig", "NotificationConfig", properties.NotificationConfig != null ? CfnMaintenanceWindowTaskNotificationConfigPropertyFromCloudFormation(properties.NotificationConfig) : void 0), ret.addPropertyResult("outputS3BucketName", "OutputS3BucketName", properties.OutputS3BucketName != null ? cfn_parse.FromCloudFormation.getString(properties.OutputS3BucketName) : void 0), ret.addPropertyResult("outputS3KeyPrefix", "OutputS3KeyPrefix", properties.OutputS3KeyPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.OutputS3KeyPrefix) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getAny(properties.Parameters) : void 0), ret.addPropertyResult("serviceRoleArn", "ServiceRoleArn", properties.ServiceRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceRoleArn) : void 0), ret.addPropertyResult("timeoutSeconds", "TimeoutSeconds", properties.TimeoutSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.TimeoutSeconds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMaintenanceWindowTask_MaintenanceWindowStepFunctionsParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("input", cdk.validateString)(properties.input)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "MaintenanceWindowStepFunctionsParametersProperty"');
    }
    function cfnMaintenanceWindowTaskMaintenanceWindowStepFunctionsParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMaintenanceWindowTask_MaintenanceWindowStepFunctionsParametersPropertyValidator(properties).assertSuccess(), { Input: cdk.stringToCloudFormation(properties.input), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnMaintenanceWindowTaskMaintenanceWindowStepFunctionsParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("input", "Input", properties.Input != null ? cfn_parse.FromCloudFormation.getString(properties.Input) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMaintenanceWindowTask_NotificationConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("notificationArn", cdk.requiredValidator)(properties.notificationArn)), errors.collect(cdk.propertyValidator("notificationArn", cdk.validateString)(properties.notificationArn)), errors.collect(cdk.propertyValidator("notificationEvents", cdk.listValidator(cdk.validateString))(properties.notificationEvents)), errors.collect(cdk.propertyValidator("notificationType", cdk.validateString)(properties.notificationType)), errors.wrap('supplied properties not correct for "NotificationConfigProperty"');
    }
    function cfnMaintenanceWindowTaskNotificationConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMaintenanceWindowTask_NotificationConfigPropertyValidator(properties).assertSuccess(), { NotificationArn: cdk.stringToCloudFormation(properties.notificationArn), NotificationEvents: cdk.listMapper(cdk.stringToCloudFormation)(properties.notificationEvents), NotificationType: cdk.stringToCloudFormation(properties.notificationType) }) : properties;
    }
    function CfnMaintenanceWindowTaskNotificationConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("notificationArn", "NotificationArn", cfn_parse.FromCloudFormation.getString(properties.NotificationArn)), ret.addPropertyResult("notificationEvents", "NotificationEvents", properties.NotificationEvents != null ? cfn_parse.FromCloudFormation.getStringArray(properties.NotificationEvents) : void 0), ret.addPropertyResult("notificationType", "NotificationType", properties.NotificationType != null ? cfn_parse.FromCloudFormation.getString(properties.NotificationType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMaintenanceWindowTask_TargetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("values", cdk.requiredValidator)(properties.values)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "TargetProperty"');
    }
    function cfnMaintenanceWindowTaskTargetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMaintenanceWindowTask_TargetPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnMaintenanceWindowTaskTargetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("values", "Values", cfn_parse.FromCloudFormation.getStringArray(properties.Values)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMaintenanceWindowTask_TaskInvocationParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maintenanceWindowAutomationParameters", CfnMaintenanceWindowTask_MaintenanceWindowAutomationParametersPropertyValidator)(properties.maintenanceWindowAutomationParameters)), errors.collect(cdk.propertyValidator("maintenanceWindowLambdaParameters", CfnMaintenanceWindowTask_MaintenanceWindowLambdaParametersPropertyValidator)(properties.maintenanceWindowLambdaParameters)), errors.collect(cdk.propertyValidator("maintenanceWindowRunCommandParameters", CfnMaintenanceWindowTask_MaintenanceWindowRunCommandParametersPropertyValidator)(properties.maintenanceWindowRunCommandParameters)), errors.collect(cdk.propertyValidator("maintenanceWindowStepFunctionsParameters", CfnMaintenanceWindowTask_MaintenanceWindowStepFunctionsParametersPropertyValidator)(properties.maintenanceWindowStepFunctionsParameters)), errors.wrap('supplied properties not correct for "TaskInvocationParametersProperty"');
    }
    function cfnMaintenanceWindowTaskTaskInvocationParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMaintenanceWindowTask_TaskInvocationParametersPropertyValidator(properties).assertSuccess(), { MaintenanceWindowAutomationParameters: cfnMaintenanceWindowTaskMaintenanceWindowAutomationParametersPropertyToCloudFormation(properties.maintenanceWindowAutomationParameters), MaintenanceWindowLambdaParameters: cfnMaintenanceWindowTaskMaintenanceWindowLambdaParametersPropertyToCloudFormation(properties.maintenanceWindowLambdaParameters), MaintenanceWindowRunCommandParameters: cfnMaintenanceWindowTaskMaintenanceWindowRunCommandParametersPropertyToCloudFormation(properties.maintenanceWindowRunCommandParameters), MaintenanceWindowStepFunctionsParameters: cfnMaintenanceWindowTaskMaintenanceWindowStepFunctionsParametersPropertyToCloudFormation(properties.maintenanceWindowStepFunctionsParameters) }) : properties;
    }
    function CfnMaintenanceWindowTaskTaskInvocationParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maintenanceWindowAutomationParameters", "MaintenanceWindowAutomationParameters", properties.MaintenanceWindowAutomationParameters != null ? CfnMaintenanceWindowTaskMaintenanceWindowAutomationParametersPropertyFromCloudFormation(properties.MaintenanceWindowAutomationParameters) : void 0), ret.addPropertyResult("maintenanceWindowLambdaParameters", "MaintenanceWindowLambdaParameters", properties.MaintenanceWindowLambdaParameters != null ? CfnMaintenanceWindowTaskMaintenanceWindowLambdaParametersPropertyFromCloudFormation(properties.MaintenanceWindowLambdaParameters) : void 0), ret.addPropertyResult("maintenanceWindowRunCommandParameters", "MaintenanceWindowRunCommandParameters", properties.MaintenanceWindowRunCommandParameters != null ? CfnMaintenanceWindowTaskMaintenanceWindowRunCommandParametersPropertyFromCloudFormation(properties.MaintenanceWindowRunCommandParameters) : void 0), ret.addPropertyResult("maintenanceWindowStepFunctionsParameters", "MaintenanceWindowStepFunctionsParameters", properties.MaintenanceWindowStepFunctionsParameters != null ? CfnMaintenanceWindowTaskMaintenanceWindowStepFunctionsParametersPropertyFromCloudFormation(properties.MaintenanceWindowStepFunctionsParameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnParameterPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowedPattern", cdk.validateString)(properties.allowedPattern)), errors.collect(cdk.propertyValidator("dataType", cdk.validateString)(properties.dataType)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("policies", cdk.validateString)(properties.policies)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.collect(cdk.propertyValidator("tier", cdk.validateString)(properties.tier)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "CfnParameterProps"');
    }
    function cfnParameterPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnParameterPropsValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type), Value: cdk.stringToCloudFormation(properties.value), AllowedPattern: cdk.stringToCloudFormation(properties.allowedPattern), DataType: cdk.stringToCloudFormation(properties.dataType), Description: cdk.stringToCloudFormation(properties.description), Name: cdk.stringToCloudFormation(properties.name), Policies: cdk.stringToCloudFormation(properties.policies), Tags: cdk.objectToCloudFormation(properties.tags), Tier: cdk.stringToCloudFormation(properties.tier) }) : properties;
    }
    function CfnParameterPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addPropertyResult("allowedPattern", "AllowedPattern", properties.AllowedPattern != null ? cfn_parse.FromCloudFormation.getString(properties.AllowedPattern) : void 0), ret.addPropertyResult("dataType", "DataType", properties.DataType != null ? cfn_parse.FromCloudFormation.getString(properties.DataType) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("policies", "Policies", properties.Policies != null ? cfn_parse.FromCloudFormation.getString(properties.Policies) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addPropertyResult("tier", "Tier", properties.Tier != null ? cfn_parse.FromCloudFormation.getString(properties.Tier) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnParameter = class _CfnParameter extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnParameterPropsFromCloudFormation(resourceProperties), ret = new _CfnParameter(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnParameter.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ssm_CfnParameterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnParameter), error;
        }
        cdk.requireProperty(props, "type", this), cdk.requireProperty(props, "value", this), this.attrType = cdk.Token.asString(this.getAtt("Type", cdk.ResolutionTypeHint.STRING)), this.attrValue = cdk.Token.asString(this.getAtt("Value", cdk.ResolutionTypeHint.STRING)), this.type = props.type, this.value = props.value, this.allowedPattern = props.allowedPattern, this.dataType = props.dataType, this.description = props.description, this.name = props.name, this.policies = props.policies, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::SSM::Parameter", props.tags, { tagPropertyName: "tags" }), this.tier = props.tier;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnParameter.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { type: this.type, value: this.value, allowedPattern: this.allowedPattern, dataType: this.dataType, description: this.description, name: this.name, policies: this.policies, tags: this.tags.renderTags(), tier: this.tier };
      }
      renderProperties(props) {
        return cfnParameterPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnParameter[_f] = { fqn: "aws-cdk-lib.aws_ssm.CfnParameter", version: "2.80.0" }, CfnParameter.CFN_RESOURCE_TYPE_NAME = "AWS::SSM::Parameter", exports2.CfnParameter = CfnParameter;
    function CfnPatchBaselinePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("approvalRules", CfnPatchBaseline_RuleGroupPropertyValidator)(properties.approvalRules)), errors.collect(cdk.propertyValidator("approvedPatches", cdk.listValidator(cdk.validateString))(properties.approvedPatches)), errors.collect(cdk.propertyValidator("approvedPatchesComplianceLevel", cdk.validateString)(properties.approvedPatchesComplianceLevel)), errors.collect(cdk.propertyValidator("approvedPatchesEnableNonSecurity", cdk.validateBoolean)(properties.approvedPatchesEnableNonSecurity)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("globalFilters", CfnPatchBaseline_PatchFilterGroupPropertyValidator)(properties.globalFilters)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("operatingSystem", cdk.validateString)(properties.operatingSystem)), errors.collect(cdk.propertyValidator("patchGroups", cdk.listValidator(cdk.validateString))(properties.patchGroups)), errors.collect(cdk.propertyValidator("rejectedPatches", cdk.listValidator(cdk.validateString))(properties.rejectedPatches)), errors.collect(cdk.propertyValidator("rejectedPatchesAction", cdk.validateString)(properties.rejectedPatchesAction)), errors.collect(cdk.propertyValidator("sources", cdk.listValidator(CfnPatchBaseline_PatchSourcePropertyValidator))(properties.sources)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnPatchBaselineProps"');
    }
    function cfnPatchBaselinePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPatchBaselinePropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), ApprovalRules: cfnPatchBaselineRuleGroupPropertyToCloudFormation(properties.approvalRules), ApprovedPatches: cdk.listMapper(cdk.stringToCloudFormation)(properties.approvedPatches), ApprovedPatchesComplianceLevel: cdk.stringToCloudFormation(properties.approvedPatchesComplianceLevel), ApprovedPatchesEnableNonSecurity: cdk.booleanToCloudFormation(properties.approvedPatchesEnableNonSecurity), Description: cdk.stringToCloudFormation(properties.description), GlobalFilters: cfnPatchBaselinePatchFilterGroupPropertyToCloudFormation(properties.globalFilters), OperatingSystem: cdk.stringToCloudFormation(properties.operatingSystem), PatchGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.patchGroups), RejectedPatches: cdk.listMapper(cdk.stringToCloudFormation)(properties.rejectedPatches), RejectedPatchesAction: cdk.stringToCloudFormation(properties.rejectedPatchesAction), Sources: cdk.listMapper(cfnPatchBaselinePatchSourcePropertyToCloudFormation)(properties.sources), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnPatchBaselinePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("approvalRules", "ApprovalRules", properties.ApprovalRules != null ? CfnPatchBaselineRuleGroupPropertyFromCloudFormation(properties.ApprovalRules) : void 0), ret.addPropertyResult("approvedPatches", "ApprovedPatches", properties.ApprovedPatches != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ApprovedPatches) : void 0), ret.addPropertyResult("approvedPatchesComplianceLevel", "ApprovedPatchesComplianceLevel", properties.ApprovedPatchesComplianceLevel != null ? cfn_parse.FromCloudFormation.getString(properties.ApprovedPatchesComplianceLevel) : void 0), ret.addPropertyResult("approvedPatchesEnableNonSecurity", "ApprovedPatchesEnableNonSecurity", properties.ApprovedPatchesEnableNonSecurity != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ApprovedPatchesEnableNonSecurity) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("globalFilters", "GlobalFilters", properties.GlobalFilters != null ? CfnPatchBaselinePatchFilterGroupPropertyFromCloudFormation(properties.GlobalFilters) : void 0), ret.addPropertyResult("operatingSystem", "OperatingSystem", properties.OperatingSystem != null ? cfn_parse.FromCloudFormation.getString(properties.OperatingSystem) : void 0), ret.addPropertyResult("patchGroups", "PatchGroups", properties.PatchGroups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.PatchGroups) : void 0), ret.addPropertyResult("rejectedPatches", "RejectedPatches", properties.RejectedPatches != null ? cfn_parse.FromCloudFormation.getStringArray(properties.RejectedPatches) : void 0), ret.addPropertyResult("rejectedPatchesAction", "RejectedPatchesAction", properties.RejectedPatchesAction != null ? cfn_parse.FromCloudFormation.getString(properties.RejectedPatchesAction) : void 0), ret.addPropertyResult("sources", "Sources", properties.Sources != null ? cfn_parse.FromCloudFormation.getArray(CfnPatchBaselinePatchSourcePropertyFromCloudFormation)(properties.Sources) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPatchBaseline = class _CfnPatchBaseline extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPatchBaselinePropsFromCloudFormation(resourceProperties), ret = new _CfnPatchBaseline(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPatchBaseline.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ssm_CfnPatchBaselineProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPatchBaseline), error;
        }
        cdk.requireProperty(props, "name", this), this.name = props.name, this.approvalRules = props.approvalRules, this.approvedPatches = props.approvedPatches, this.approvedPatchesComplianceLevel = props.approvedPatchesComplianceLevel, this.approvedPatchesEnableNonSecurity = props.approvedPatchesEnableNonSecurity, this.description = props.description, this.globalFilters = props.globalFilters, this.operatingSystem = props.operatingSystem, this.patchGroups = props.patchGroups, this.rejectedPatches = props.rejectedPatches, this.rejectedPatchesAction = props.rejectedPatchesAction, this.sources = props.sources, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SSM::PatchBaseline", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPatchBaseline.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, approvalRules: this.approvalRules, approvedPatches: this.approvedPatches, approvedPatchesComplianceLevel: this.approvedPatchesComplianceLevel, approvedPatchesEnableNonSecurity: this.approvedPatchesEnableNonSecurity, description: this.description, globalFilters: this.globalFilters, operatingSystem: this.operatingSystem, patchGroups: this.patchGroups, rejectedPatches: this.rejectedPatches, rejectedPatchesAction: this.rejectedPatchesAction, sources: this.sources, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnPatchBaselinePropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnPatchBaseline[_g] = { fqn: "aws-cdk-lib.aws_ssm.CfnPatchBaseline", version: "2.80.0" }, CfnPatchBaseline.CFN_RESOURCE_TYPE_NAME = "AWS::SSM::PatchBaseline", exports2.CfnPatchBaseline = CfnPatchBaseline;
    function CfnPatchBaseline_PatchFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "PatchFilterProperty"');
    }
    function cfnPatchBaselinePatchFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPatchBaseline_PatchFilterPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnPatchBaselinePatchFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPatchBaseline_PatchFilterGroupPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("patchFilters", cdk.listValidator(CfnPatchBaseline_PatchFilterPropertyValidator))(properties.patchFilters)), errors.wrap('supplied properties not correct for "PatchFilterGroupProperty"');
    }
    function cfnPatchBaselinePatchFilterGroupPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPatchBaseline_PatchFilterGroupPropertyValidator(properties).assertSuccess(), { PatchFilters: cdk.listMapper(cfnPatchBaselinePatchFilterPropertyToCloudFormation)(properties.patchFilters) }) : properties;
    }
    function CfnPatchBaselinePatchFilterGroupPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("patchFilters", "PatchFilters", properties.PatchFilters != null ? cfn_parse.FromCloudFormation.getArray(CfnPatchBaselinePatchFilterPropertyFromCloudFormation)(properties.PatchFilters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPatchBaseline_PatchSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configuration", cdk.validateString)(properties.configuration)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("products", cdk.listValidator(cdk.validateString))(properties.products)), errors.wrap('supplied properties not correct for "PatchSourceProperty"');
    }
    function cfnPatchBaselinePatchSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPatchBaseline_PatchSourcePropertyValidator(properties).assertSuccess(), { Configuration: cdk.stringToCloudFormation(properties.configuration), Name: cdk.stringToCloudFormation(properties.name), Products: cdk.listMapper(cdk.stringToCloudFormation)(properties.products) }) : properties;
    }
    function CfnPatchBaselinePatchSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configuration", "Configuration", properties.Configuration != null ? cfn_parse.FromCloudFormation.getString(properties.Configuration) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("products", "Products", properties.Products != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Products) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPatchBaseline_RulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("approveAfterDays", cdk.validateNumber)(properties.approveAfterDays)), errors.collect(cdk.propertyValidator("approveUntilDate", cdk.validateString)(properties.approveUntilDate)), errors.collect(cdk.propertyValidator("complianceLevel", cdk.validateString)(properties.complianceLevel)), errors.collect(cdk.propertyValidator("enableNonSecurity", cdk.validateBoolean)(properties.enableNonSecurity)), errors.collect(cdk.propertyValidator("patchFilterGroup", CfnPatchBaseline_PatchFilterGroupPropertyValidator)(properties.patchFilterGroup)), errors.wrap('supplied properties not correct for "RuleProperty"');
    }
    function cfnPatchBaselineRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPatchBaseline_RulePropertyValidator(properties).assertSuccess(), { ApproveAfterDays: cdk.numberToCloudFormation(properties.approveAfterDays), ApproveUntilDate: cdk.stringToCloudFormation(properties.approveUntilDate), ComplianceLevel: cdk.stringToCloudFormation(properties.complianceLevel), EnableNonSecurity: cdk.booleanToCloudFormation(properties.enableNonSecurity), PatchFilterGroup: cfnPatchBaselinePatchFilterGroupPropertyToCloudFormation(properties.patchFilterGroup) }) : properties;
    }
    function CfnPatchBaselineRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("approveAfterDays", "ApproveAfterDays", properties.ApproveAfterDays != null ? cfn_parse.FromCloudFormation.getNumber(properties.ApproveAfterDays) : void 0), ret.addPropertyResult("approveUntilDate", "ApproveUntilDate", properties.ApproveUntilDate != null ? cfn_parse.FromCloudFormation.getString(properties.ApproveUntilDate) : void 0), ret.addPropertyResult("complianceLevel", "ComplianceLevel", properties.ComplianceLevel != null ? cfn_parse.FromCloudFormation.getString(properties.ComplianceLevel) : void 0), ret.addPropertyResult("enableNonSecurity", "EnableNonSecurity", properties.EnableNonSecurity != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableNonSecurity) : void 0), ret.addPropertyResult("patchFilterGroup", "PatchFilterGroup", properties.PatchFilterGroup != null ? CfnPatchBaselinePatchFilterGroupPropertyFromCloudFormation(properties.PatchFilterGroup) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPatchBaseline_RuleGroupPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("patchRules", cdk.listValidator(CfnPatchBaseline_RulePropertyValidator))(properties.patchRules)), errors.wrap('supplied properties not correct for "RuleGroupProperty"');
    }
    function cfnPatchBaselineRuleGroupPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPatchBaseline_RuleGroupPropertyValidator(properties).assertSuccess(), { PatchRules: cdk.listMapper(cfnPatchBaselineRulePropertyToCloudFormation)(properties.patchRules) }) : properties;
    }
    function CfnPatchBaselineRuleGroupPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("patchRules", "PatchRules", properties.PatchRules != null ? cfn_parse.FromCloudFormation.getArray(CfnPatchBaselineRulePropertyFromCloudFormation)(properties.PatchRules) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourceDataSyncPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketPrefix", cdk.validateString)(properties.bucketPrefix)), errors.collect(cdk.propertyValidator("bucketRegion", cdk.validateString)(properties.bucketRegion)), errors.collect(cdk.propertyValidator("kmsKeyArn", cdk.validateString)(properties.kmsKeyArn)), errors.collect(cdk.propertyValidator("s3Destination", CfnResourceDataSync_S3DestinationPropertyValidator)(properties.s3Destination)), errors.collect(cdk.propertyValidator("syncFormat", cdk.validateString)(properties.syncFormat)), errors.collect(cdk.propertyValidator("syncName", cdk.requiredValidator)(properties.syncName)), errors.collect(cdk.propertyValidator("syncName", cdk.validateString)(properties.syncName)), errors.collect(cdk.propertyValidator("syncSource", CfnResourceDataSync_SyncSourcePropertyValidator)(properties.syncSource)), errors.collect(cdk.propertyValidator("syncType", cdk.validateString)(properties.syncType)), errors.wrap('supplied properties not correct for "CfnResourceDataSyncProps"');
    }
    function cfnResourceDataSyncPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceDataSyncPropsValidator(properties).assertSuccess(), { SyncName: cdk.stringToCloudFormation(properties.syncName), BucketName: cdk.stringToCloudFormation(properties.bucketName), BucketPrefix: cdk.stringToCloudFormation(properties.bucketPrefix), BucketRegion: cdk.stringToCloudFormation(properties.bucketRegion), KMSKeyArn: cdk.stringToCloudFormation(properties.kmsKeyArn), S3Destination: cfnResourceDataSyncS3DestinationPropertyToCloudFormation(properties.s3Destination), SyncFormat: cdk.stringToCloudFormation(properties.syncFormat), SyncSource: cfnResourceDataSyncSyncSourcePropertyToCloudFormation(properties.syncSource), SyncType: cdk.stringToCloudFormation(properties.syncType) }) : properties;
    }
    function CfnResourceDataSyncPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("syncName", "SyncName", cfn_parse.FromCloudFormation.getString(properties.SyncName)), ret.addPropertyResult("bucketName", "BucketName", properties.BucketName != null ? cfn_parse.FromCloudFormation.getString(properties.BucketName) : void 0), ret.addPropertyResult("bucketPrefix", "BucketPrefix", properties.BucketPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.BucketPrefix) : void 0), ret.addPropertyResult("bucketRegion", "BucketRegion", properties.BucketRegion != null ? cfn_parse.FromCloudFormation.getString(properties.BucketRegion) : void 0), ret.addPropertyResult("kmsKeyArn", "KMSKeyArn", properties.KMSKeyArn != null ? cfn_parse.FromCloudFormation.getString(properties.KMSKeyArn) : void 0), ret.addPropertyResult("s3Destination", "S3Destination", properties.S3Destination != null ? CfnResourceDataSyncS3DestinationPropertyFromCloudFormation(properties.S3Destination) : void 0), ret.addPropertyResult("syncFormat", "SyncFormat", properties.SyncFormat != null ? cfn_parse.FromCloudFormation.getString(properties.SyncFormat) : void 0), ret.addPropertyResult("syncSource", "SyncSource", properties.SyncSource != null ? CfnResourceDataSyncSyncSourcePropertyFromCloudFormation(properties.SyncSource) : void 0), ret.addPropertyResult("syncType", "SyncType", properties.SyncType != null ? cfn_parse.FromCloudFormation.getString(properties.SyncType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResourceDataSync = class _CfnResourceDataSync extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResourceDataSyncPropsFromCloudFormation(resourceProperties), ret = new _CfnResourceDataSync(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnResourceDataSync.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ssm_CfnResourceDataSyncProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResourceDataSync), error;
        }
        cdk.requireProperty(props, "syncName", this), this.attrSyncName = cdk.Token.asString(this.getAtt("SyncName", cdk.ResolutionTypeHint.STRING)), this.syncName = props.syncName, this.bucketName = props.bucketName, this.bucketPrefix = props.bucketPrefix, this.bucketRegion = props.bucketRegion, this.kmsKeyArn = props.kmsKeyArn, this.s3Destination = props.s3Destination, this.syncFormat = props.syncFormat, this.syncSource = props.syncSource, this.syncType = props.syncType;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResourceDataSync.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { syncName: this.syncName, bucketName: this.bucketName, bucketPrefix: this.bucketPrefix, bucketRegion: this.bucketRegion, kmsKeyArn: this.kmsKeyArn, s3Destination: this.s3Destination, syncFormat: this.syncFormat, syncSource: this.syncSource, syncType: this.syncType };
      }
      renderProperties(props) {
        return cfnResourceDataSyncPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnResourceDataSync[_h] = { fqn: "aws-cdk-lib.aws_ssm.CfnResourceDataSync", version: "2.80.0" }, CfnResourceDataSync.CFN_RESOURCE_TYPE_NAME = "AWS::SSM::ResourceDataSync", exports2.CfnResourceDataSync = CfnResourceDataSync;
    function CfnResourceDataSync_AwsOrganizationsSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("organizationSourceType", cdk.requiredValidator)(properties.organizationSourceType)), errors.collect(cdk.propertyValidator("organizationSourceType", cdk.validateString)(properties.organizationSourceType)), errors.collect(cdk.propertyValidator("organizationalUnits", cdk.listValidator(cdk.validateString))(properties.organizationalUnits)), errors.wrap('supplied properties not correct for "AwsOrganizationsSourceProperty"');
    }
    function cfnResourceDataSyncAwsOrganizationsSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceDataSync_AwsOrganizationsSourcePropertyValidator(properties).assertSuccess(), { OrganizationSourceType: cdk.stringToCloudFormation(properties.organizationSourceType), OrganizationalUnits: cdk.listMapper(cdk.stringToCloudFormation)(properties.organizationalUnits) }) : properties;
    }
    function CfnResourceDataSyncAwsOrganizationsSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("organizationSourceType", "OrganizationSourceType", cfn_parse.FromCloudFormation.getString(properties.OrganizationSourceType)), ret.addPropertyResult("organizationalUnits", "OrganizationalUnits", properties.OrganizationalUnits != null ? cfn_parse.FromCloudFormation.getStringArray(properties.OrganizationalUnits) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourceDataSync_S3DestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketName", cdk.requiredValidator)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketPrefix", cdk.validateString)(properties.bucketPrefix)), errors.collect(cdk.propertyValidator("bucketRegion", cdk.requiredValidator)(properties.bucketRegion)), errors.collect(cdk.propertyValidator("bucketRegion", cdk.validateString)(properties.bucketRegion)), errors.collect(cdk.propertyValidator("kmsKeyArn", cdk.validateString)(properties.kmsKeyArn)), errors.collect(cdk.propertyValidator("syncFormat", cdk.requiredValidator)(properties.syncFormat)), errors.collect(cdk.propertyValidator("syncFormat", cdk.validateString)(properties.syncFormat)), errors.wrap('supplied properties not correct for "S3DestinationProperty"');
    }
    function cfnResourceDataSyncS3DestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceDataSync_S3DestinationPropertyValidator(properties).assertSuccess(), { BucketName: cdk.stringToCloudFormation(properties.bucketName), BucketPrefix: cdk.stringToCloudFormation(properties.bucketPrefix), BucketRegion: cdk.stringToCloudFormation(properties.bucketRegion), KMSKeyArn: cdk.stringToCloudFormation(properties.kmsKeyArn), SyncFormat: cdk.stringToCloudFormation(properties.syncFormat) }) : properties;
    }
    function CfnResourceDataSyncS3DestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketName", "BucketName", cfn_parse.FromCloudFormation.getString(properties.BucketName)), ret.addPropertyResult("bucketPrefix", "BucketPrefix", properties.BucketPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.BucketPrefix) : void 0), ret.addPropertyResult("bucketRegion", "BucketRegion", cfn_parse.FromCloudFormation.getString(properties.BucketRegion)), ret.addPropertyResult("kmsKeyArn", "KMSKeyArn", properties.KMSKeyArn != null ? cfn_parse.FromCloudFormation.getString(properties.KMSKeyArn) : void 0), ret.addPropertyResult("syncFormat", "SyncFormat", cfn_parse.FromCloudFormation.getString(properties.SyncFormat)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourceDataSync_SyncSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("awsOrganizationsSource", CfnResourceDataSync_AwsOrganizationsSourcePropertyValidator)(properties.awsOrganizationsSource)), errors.collect(cdk.propertyValidator("includeFutureRegions", cdk.validateBoolean)(properties.includeFutureRegions)), errors.collect(cdk.propertyValidator("sourceRegions", cdk.requiredValidator)(properties.sourceRegions)), errors.collect(cdk.propertyValidator("sourceRegions", cdk.listValidator(cdk.validateString))(properties.sourceRegions)), errors.collect(cdk.propertyValidator("sourceType", cdk.requiredValidator)(properties.sourceType)), errors.collect(cdk.propertyValidator("sourceType", cdk.validateString)(properties.sourceType)), errors.wrap('supplied properties not correct for "SyncSourceProperty"');
    }
    function cfnResourceDataSyncSyncSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceDataSync_SyncSourcePropertyValidator(properties).assertSuccess(), { AwsOrganizationsSource: cfnResourceDataSyncAwsOrganizationsSourcePropertyToCloudFormation(properties.awsOrganizationsSource), IncludeFutureRegions: cdk.booleanToCloudFormation(properties.includeFutureRegions), SourceRegions: cdk.listMapper(cdk.stringToCloudFormation)(properties.sourceRegions), SourceType: cdk.stringToCloudFormation(properties.sourceType) }) : properties;
    }
    function CfnResourceDataSyncSyncSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("awsOrganizationsSource", "AwsOrganizationsSource", properties.AwsOrganizationsSource != null ? CfnResourceDataSyncAwsOrganizationsSourcePropertyFromCloudFormation(properties.AwsOrganizationsSource) : void 0), ret.addPropertyResult("includeFutureRegions", "IncludeFutureRegions", properties.IncludeFutureRegions != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeFutureRegions) : void 0), ret.addPropertyResult("sourceRegions", "SourceRegions", cfn_parse.FromCloudFormation.getStringArray(properties.SourceRegions)), ret.addPropertyResult("sourceType", "SourceType", cfn_parse.FromCloudFormation.getString(properties.SourceType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourcePolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("policy", cdk.requiredValidator)(properties.policy)), errors.collect(cdk.propertyValidator("policy", cdk.validateObject)(properties.policy)), errors.collect(cdk.propertyValidator("resourceArn", cdk.requiredValidator)(properties.resourceArn)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.wrap('supplied properties not correct for "CfnResourcePolicyProps"');
    }
    function cfnResourcePolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourcePolicyPropsValidator(properties).assertSuccess(), { Policy: cdk.objectToCloudFormation(properties.policy), ResourceArn: cdk.stringToCloudFormation(properties.resourceArn) }) : properties;
    }
    function CfnResourcePolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("policy", "Policy", cfn_parse.FromCloudFormation.getAny(properties.Policy)), ret.addPropertyResult("resourceArn", "ResourceArn", cfn_parse.FromCloudFormation.getString(properties.ResourceArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResourcePolicy = class _CfnResourcePolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResourcePolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnResourcePolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnResourcePolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ssm_CfnResourcePolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResourcePolicy), error;
        }
        cdk.requireProperty(props, "policy", this), cdk.requireProperty(props, "resourceArn", this), this.attrPolicyHash = cdk.Token.asString(this.getAtt("PolicyHash", cdk.ResolutionTypeHint.STRING)), this.attrPolicyId = cdk.Token.asString(this.getAtt("PolicyId", cdk.ResolutionTypeHint.STRING)), this.policy = props.policy, this.resourceArn = props.resourceArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResourcePolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { policy: this.policy, resourceArn: this.resourceArn };
      }
      renderProperties(props) {
        return cfnResourcePolicyPropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnResourcePolicy[_j] = { fqn: "aws-cdk-lib.aws_ssm.CfnResourcePolicy", version: "2.80.0" }, CfnResourcePolicy.CFN_RESOURCE_TYPE_NAME = "AWS::SSM::ResourcePolicy", exports2.CfnResourcePolicy = CfnResourcePolicy;
  }
});

// node_modules/aws-cdk-lib/aws-ssm/lib/util.js
var require_util8 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ssm/lib/util.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.arnForParameterName = exports2.AUTOGEN_MARKER = void 0;
    var core_1 = require_core2();
    exports2.AUTOGEN_MARKER = "$$autogen$$";
    function arnForParameterName(scope, parameterName, options = {}) {
      const physicalName = options.physicalName, nameToValidate = physicalName || parameterName;
      if (!core_1.Token.isUnresolved(nameToValidate) && nameToValidate.includes("/") && !nameToValidate.startsWith("/"))
        throw new Error(`Parameter names must be fully qualified (if they include "/" they must also begin with a "/"): ${nameToValidate}`);
      if (isSimpleName())
        return core_1.Stack.of(scope).formatArn({ service: "ssm", resource: "parameter", arnFormat: core_1.ArnFormat.SLASH_RESOURCE_NAME, resourceName: parameterName });
      return core_1.Stack.of(scope).formatArn({ service: "ssm", resource: `parameter${parameterName}` });
      function isSimpleName() {
        const concreteName = core_1.Token.isUnresolved(parameterName) ? physicalName : parameterName;
        if (!concreteName || core_1.Token.isUnresolved(concreteName)) {
          if (options.simpleName === void 0)
            throw new Error('Unable to determine ARN separator for SSM parameter since the parameter name is an unresolved token. Use "fromAttributes" and specify "simpleName" explicitly');
          return options.simpleName;
        }
        const result = !concreteName.startsWith("/");
        if (options.simpleName !== void 0 && options.simpleName !== result)
          throw concreteName === exports2.AUTOGEN_MARKER ? new Error('If "parameterName" is not explicitly defined, "simpleName" must be "true" or undefined since auto-generated parameter names always have simple names') : new Error(`Parameter name "${concreteName}" is ${result ? "a simple name" : "not a simple name"}, but "simpleName" was explicitly set to ${options.simpleName}. Either omit it or set it to ${result}`);
        return result;
      }
    }
    exports2.arnForParameterName = arnForParameterName;
  }
});

// node_modules/aws-cdk-lib/aws-ssm/lib/parameter.js
var require_parameter = __commonJS({
  "node_modules/aws-cdk-lib/aws-ssm/lib/parameter.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.StringListParameter = exports2.StringParameter = exports2.ParameterTier = exports2.ParameterDataType = exports2.ParameterType = exports2.ParameterValueType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var ssm = require_ssm_generated();
    var util_1 = require_util8();
    var iam = require_aws_iam();
    var cxschema = require_cloud_assembly_schema2();
    var core_1 = require_core2();
    var ParameterBase = class extends core_1.Resource {
      grantRead(grantee) {
        return this.encryptionKey && this.encryptionKey.grantDecrypt(grantee), iam.Grant.addToPrincipal({ grantee, actions: ["ssm:DescribeParameters", "ssm:GetParameters", "ssm:GetParameter", "ssm:GetParameterHistory"], resourceArns: [this.parameterArn] });
      }
      grantWrite(grantee) {
        return this.encryptionKey && this.encryptionKey.grantEncrypt(grantee), iam.Grant.addToPrincipal({ grantee, actions: ["ssm:PutParameter"], resourceArns: [this.parameterArn] });
      }
    };
    var ParameterValueType;
    (function(ParameterValueType2) {
      ParameterValueType2.STRING = "String", ParameterValueType2.AWS_EC2_AVAILABILITYZONE_NAME = "AWS::EC2::AvailabilityZone::Name", ParameterValueType2.AWS_EC2_IMAGE_ID = "AWS::EC2::Image::Id", ParameterValueType2.AWS_EC2_INSTANCE_ID = "AWS::EC2::Instance::Id", ParameterValueType2.AWS_EC2_KEYPAIR_KEYNAME = "AWS::EC2::KeyPair::KeyName", ParameterValueType2.AWS_EC2_SECURITYGROUP_GROUPNAME = "AWS::EC2::SecurityGroup::GroupName", ParameterValueType2.AWS_EC2_SECURITYGROUP_ID = "AWS::EC2::SecurityGroup::Id", ParameterValueType2.AWS_EC2_SUBNET_ID = "AWS::EC2::Subnet::Id", ParameterValueType2.AWS_EC2_VOLUME_ID = "AWS::EC2::Volume::Id", ParameterValueType2.AWS_EC2_VPC_ID = "AWS::EC2::VPC::Id", ParameterValueType2.AWS_ROUTE53_HOSTEDZONE_ID = "AWS::Route53::HostedZone::Id";
    })(ParameterValueType = exports2.ParameterValueType || (exports2.ParameterValueType = {}));
    var ParameterType;
    (function(ParameterType2) {
      ParameterType2.STRING = "String", ParameterType2.SECURE_STRING = "SecureString", ParameterType2.STRING_LIST = "StringList", ParameterType2.AWS_EC2_IMAGE_ID = "AWS::EC2::Image::Id";
    })(ParameterType = exports2.ParameterType || (exports2.ParameterType = {}));
    var ParameterDataType;
    (function(ParameterDataType2) {
      ParameterDataType2.TEXT = "text", ParameterDataType2.AWS_EC2_IMAGE = "aws:ec2:image";
    })(ParameterDataType = exports2.ParameterDataType || (exports2.ParameterDataType = {}));
    var ParameterTier;
    (function(ParameterTier2) {
      ParameterTier2.ADVANCED = "Advanced", ParameterTier2.INTELLIGENT_TIERING = "Intelligent-Tiering", ParameterTier2.STANDARD = "Standard";
    })(ParameterTier = exports2.ParameterTier || (exports2.ParameterTier = {}));
    var StringParameter = class _StringParameter extends ParameterBase {
      static fromStringParameterName(scope, id, stringParameterName) {
        return this.fromStringParameterAttributes(scope, id, { parameterName: stringParameterName });
      }
      static fromStringParameterAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ssm_StringParameterAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromStringParameterAttributes), error;
        }
        if (!attrs.parameterName)
          throw new Error("parameterName cannot be an empty string");
        if (attrs.type && ![ParameterType.STRING, ParameterType.AWS_EC2_IMAGE_ID].includes(attrs.type))
          throw new Error(`fromStringParameterAttributes does not support ${attrs.type}. Please use ParameterType.STRING or ParameterType.AWS_EC2_IMAGE_ID`);
        const type = attrs.type ?? attrs.valueType ?? ParameterValueType.STRING, stringValue = attrs.version ? new core_1.CfnDynamicReference(core_1.CfnDynamicReferenceService.SSM, `${attrs.parameterName}:${core_1.Tokenization.stringifyNumber(attrs.version)}`).toString() : new core_1.CfnParameter(scope, `${id}.Parameter`, { type: `AWS::SSM::Parameter::Value<${type}>`, default: attrs.parameterName }).valueAsString;
        class Import extends ParameterBase {
          constructor() {
            super(...arguments), this.parameterName = attrs.parameterName, this.parameterArn = (0, util_1.arnForParameterName)(this, attrs.parameterName, { simpleName: attrs.simpleName }), this.parameterType = ParameterType.STRING, this.stringValue = stringValue;
          }
        }
        return new Import(scope, id);
      }
      static fromSecureStringParameterAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ssm_SecureStringParameterAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromSecureStringParameterAttributes), error;
        }
        const version = attrs.version ? core_1.Tokenization.stringifyNumber(attrs.version) : "", stringValue = new core_1.CfnDynamicReference(core_1.CfnDynamicReferenceService.SSM_SECURE, version ? `${attrs.parameterName}:${version}` : attrs.parameterName).toString();
        class Import extends ParameterBase {
          constructor() {
            super(...arguments), this.parameterName = attrs.parameterName, this.parameterArn = (0, util_1.arnForParameterName)(this, attrs.parameterName, { simpleName: attrs.simpleName }), this.parameterType = ParameterType.SECURE_STRING, this.stringValue = stringValue, this.encryptionKey = attrs.encryptionKey;
          }
        }
        return new Import(scope, id);
      }
      static valueFromLookup(scope, parameterName) {
        return core_1.ContextProvider.getValue(scope, { provider: cxschema.ContextProvider.SSM_PARAMETER_PROVIDER, props: { parameterName }, dummyValue: `dummy-value-for-${parameterName}` }).value;
      }
      static valueForStringParameter(scope, parameterName, version) {
        return _StringParameter.valueForTypedStringParameterV2(scope, parameterName, ParameterValueType.STRING, version);
      }
      static valueForTypedStringParameterV2(scope, parameterName, type = ParameterValueType.STRING, version) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ssm_ParameterValueType(type);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.valueForTypedStringParameterV2), error;
        }
        const stack = core_1.Stack.of(scope), id = makeIdentityForImportedValue(parameterName), exists = stack.node.tryFindChild(id);
        return exists ? exists.stringValue : this.fromStringParameterAttributes(stack, id, { parameterName, version, valueType: type }).stringValue;
      }
      static valueForTypedStringParameter(scope, parameterName, type = ParameterType.STRING, version) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_ssm.StringParameter#valueForTypedStringParameter", "- use valueForTypedStringParameterV2 instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_ssm_ParameterType(type);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.valueForTypedStringParameter), error;
        }
        if (type === ParameterType.STRING_LIST)
          throw new Error("valueForTypedStringParameter does not support STRING_LIST, use valueForTypedListParameter instead");
        const stack = core_1.Stack.of(scope), id = makeIdentityForImportedValue(parameterName), exists = stack.node.tryFindChild(id);
        return exists ? exists.stringValue : this.fromStringParameterAttributes(stack, id, { parameterName, version, type }).stringValue;
      }
      static valueForSecureStringParameter(scope, parameterName, version) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_ssm.StringParameter#valueForSecureStringParameter", "Use `SecretValue.ssmSecure()` instead, it will correctly type the imported value as a `SecretValue` and allow importing without version. `SecretValue` lives in the core `aws-cdk-lib` module.");
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.valueForSecureStringParameter), error;
        }
        const stack = core_1.Stack.of(scope), id = makeIdentityForImportedValue(parameterName), exists = stack.node.tryFindChild(id);
        return exists ? exists.stringValue : this.fromSecureStringParameterAttributes(stack, id, { parameterName, version }).stringValue;
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.parameterName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ssm_StringParameterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _StringParameter), error;
        }
        if (props.allowedPattern && _assertValidValue(props.stringValue, props.allowedPattern), validateParameterName(this.physicalName), props.description && props.description?.length > 1024)
          throw new Error("Description cannot be longer than 1024 characters.");
        if (props.type && props.type === ParameterType.AWS_EC2_IMAGE_ID)
          throw new Error("The type must either be ParameterType.STRING or ParameterType.STRING_LIST. Did you mean to set dataType: ParameterDataType.AWS_EC2_IMAGE instead?");
        const resource = new ssm.CfnParameter(this, "Resource", { allowedPattern: props.allowedPattern, description: props.description, name: this.physicalName, tier: props.tier, type: props.type || ParameterType.STRING, dataType: props.dataType, value: props.stringValue });
        this.parameterName = this.getResourceNameAttribute(resource.ref), this.parameterArn = (0, util_1.arnForParameterName)(this, this.parameterName, { physicalName: props.parameterName || util_1.AUTOGEN_MARKER, simpleName: props.simpleName }), this.parameterType = resource.attrType, this.stringValue = resource.attrValue;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, StringParameter[_a] = { fqn: "aws-cdk-lib.aws_ssm.StringParameter", version: "2.80.0" }, exports2.StringParameter = StringParameter;
    var StringListParameter = class _StringListParameter extends ParameterBase {
      static fromStringListParameterName(scope, id, stringListParameterName) {
        class Import extends ParameterBase {
          constructor() {
            super(...arguments), this.parameterName = stringListParameterName, this.parameterArn = (0, util_1.arnForParameterName)(this, this.parameterName), this.parameterType = ParameterType.STRING_LIST, this.stringListValue = core_1.Fn.split(",", new core_1.CfnDynamicReference(core_1.CfnDynamicReferenceService.SSM, stringListParameterName).toString());
          }
        }
        return new Import(scope, id);
      }
      static fromListParameterAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ssm_ListParameterAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromListParameterAttributes), error;
        }
        if (!attrs.parameterName)
          throw new Error("parameterName cannot be an empty string");
        const valueType = `List<${attrs.elementType ?? ParameterValueType.STRING}>`, stringValue = attrs.version ? new core_1.CfnDynamicReference(core_1.CfnDynamicReferenceService.SSM, `${attrs.parameterName}:${core_1.Tokenization.stringifyNumber(attrs.version)}`).toStringList() : new core_1.CfnParameter(scope, `${id}.Parameter`, { type: `AWS::SSM::Parameter::Value<${valueType}>`, default: attrs.parameterName }).valueAsList;
        class Import extends ParameterBase {
          constructor() {
            super(...arguments), this.parameterName = attrs.parameterName, this.parameterArn = (0, util_1.arnForParameterName)(this, attrs.parameterName, { simpleName: attrs.simpleName }), this.parameterType = valueType, this.stringListValue = stringValue;
          }
        }
        return new Import(scope, id);
      }
      static valueForTypedListParameter(scope, parameterName, type = ParameterValueType.STRING, version) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ssm_ParameterValueType(type);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.valueForTypedListParameter), error;
        }
        const stack = core_1.Stack.of(scope), id = makeIdentityForImportedValue(parameterName), exists = stack.node.tryFindChild(id);
        return exists ? exists.stringListValue : this.fromListParameterAttributes(stack, id, { parameterName, elementType: type, version }).stringListValue;
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.parameterName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ssm_StringListParameterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _StringListParameter), error;
        }
        if (props.stringListValue.find((str) => !core_1.Token.isUnresolved(str) && str.indexOf(",") !== -1))
          throw new Error("Values of a StringList SSM Parameter cannot contain the ',' character. Use a string parameter instead.");
        if (props.allowedPattern && !core_1.Token.isUnresolved(props.stringListValue) && props.stringListValue.forEach((str) => _assertValidValue(str, props.allowedPattern)), validateParameterName(this.physicalName), props.description && props.description?.length > 1024)
          throw new Error("Description cannot be longer than 1024 characters.");
        const resource = new ssm.CfnParameter(this, "Resource", { allowedPattern: props.allowedPattern, description: props.description, name: this.physicalName, tier: props.tier, type: ParameterType.STRING_LIST, value: core_1.Fn.join(",", props.stringListValue) });
        this.parameterName = this.getResourceNameAttribute(resource.ref), this.parameterArn = (0, util_1.arnForParameterName)(this, this.parameterName, { physicalName: props.parameterName || util_1.AUTOGEN_MARKER, simpleName: props.simpleName }), this.parameterType = resource.attrType, this.stringListValue = core_1.Fn.split(",", resource.attrValue);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, StringListParameter[_b] = { fqn: "aws-cdk-lib.aws_ssm.StringListParameter", version: "2.80.0" }, exports2.StringListParameter = StringListParameter;
    function _assertValidValue(value, allowedPattern) {
      if (!(core_1.Token.isUnresolved(value) || core_1.Token.isUnresolved(allowedPattern)) && !new RegExp(allowedPattern).test(value))
        throw new Error(`The supplied value (${value}) does not match the specified allowedPattern (${allowedPattern})`);
    }
    function makeIdentityForImportedValue(parameterName) {
      return `SsmParameterValue:${parameterName}:C96584B6-F00A-464E-AD19-53AFF4B05118`;
    }
    function validateParameterName(parameterName) {
      if (!core_1.Token.isUnresolved(parameterName)) {
        if (parameterName.length > 2048)
          throw new Error("name cannot be longer than 2048 characters.");
        if (!parameterName.match(/^[\/\w.-]+$/))
          throw new Error(`name must only contain letters, numbers, and the following 4 symbols .-_/; got ${parameterName}`);
      }
    }
  }
});

// node_modules/aws-cdk-lib/aws-ssm/lib/index.js
var require_lib18 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ssm/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_parameter(), exports2), __exportStar(require_ssm_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-ssm/index.js
var require_aws_ssm = __commonJS({
  "node_modules/aws-cdk-lib/aws-ssm/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib18(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/machine-image/utils.js
var require_utils7 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/machine-image/utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.lookupImage = void 0;
    var ssm = require_aws_ssm();
    function lookupImage(scope, cachedInContext, parameterName) {
      return cachedInContext ? ssm.StringParameter.valueFromLookup(scope, parameterName) : ssm.StringParameter.valueForTypedStringParameterV2(scope, parameterName, ssm.ParameterValueType.AWS_EC2_IMAGE_ID);
    }
    exports2.lookupImage = lookupImage;
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/user-data.js
var require_user_data = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/user-data.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.MultipartUserData = exports2.MultipartBody = exports2.UserData = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var machine_image_1 = require_machine_image2();
    var core_1 = require_core2();
    var UserData = class _UserData {
      static forLinux(options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_LinuxUserDataOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.forLinux), error;
        }
        return new LinuxUserData(options);
      }
      static forWindows(options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_WindowsUserDataOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.forWindows), error;
        }
        return new WindowsUserData(options);
      }
      static custom(content) {
        const userData = new CustomUserData();
        return userData.addCommands(content), userData;
      }
      static forOperatingSystem(os) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_OperatingSystemType(os);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.forOperatingSystem), error;
        }
        switch (os) {
          case machine_image_1.OperatingSystemType.LINUX:
            return _UserData.forLinux();
          case machine_image_1.OperatingSystemType.WINDOWS:
            return _UserData.forWindows();
          case machine_image_1.OperatingSystemType.UNKNOWN:
            throw new Error("Cannot determine UserData for unknown operating system type");
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, UserData[_a] = { fqn: "aws-cdk-lib.aws_ec2.UserData", version: "2.80.0" }, exports2.UserData = UserData;
    var LinuxUserData = class extends UserData {
      constructor(props = {}) {
        super(), this.props = props, this.lines = [], this.onExitLines = [];
      }
      addCommands(...commands) {
        this.lines.push(...commands);
      }
      addOnExitCommands(...commands) {
        this.onExitLines.push(...commands);
      }
      render() {
        return [this.props.shebang ?? "#!/bin/bash", ...this.renderOnExitLines(), ...this.lines].join(`
`);
      }
      addS3DownloadCommand(params) {
        const s3Path = `s3://${params.bucket.bucketName}/${params.bucketKey}`, localPath = params.localFile && params.localFile.length !== 0 ? params.localFile : `/tmp/${params.bucketKey}`;
        return this.addCommands(`mkdir -p $(dirname '${localPath}')`, `aws s3 cp '${s3Path}' '${localPath}'` + (params.region !== void 0 ? ` --region ${params.region}` : "")), localPath;
      }
      addExecuteFileCommand(params) {
        this.addCommands("set -e", `chmod +x '${params.filePath}'`, `'${params.filePath}' ${params.arguments ?? ""}`.trim());
      }
      addSignalOnExitCommand(resource) {
        const stack = core_1.Stack.of(resource), resourceID = resource.node.defaultChild.logicalId;
        this.addOnExitCommands(`/opt/aws/bin/cfn-signal --stack ${stack.stackName} --resource ${resourceID} --region ${stack.region} -e $exitCode || echo 'Failed to send Cloudformation Signal'`);
      }
      renderOnExitLines() {
        return this.onExitLines.length > 0 ? ["function exitTrap(){", "exitCode=$?", ...this.onExitLines, "}", "trap exitTrap EXIT"] : [];
      }
    };
    var WindowsUserData = class extends UserData {
      constructor(props = {}) {
        super(), this.props = props, this.lines = [], this.onExitLines = [];
      }
      addCommands(...commands) {
        this.lines.push(...commands);
      }
      addOnExitCommands(...commands) {
        this.onExitLines.push(...commands);
      }
      render() {
        return `<powershell>${[...this.renderOnExitLines(), ...this.lines, ...this.onExitLines.length > 0 ? ['throw "Success"'] : []].join(`
`)}</powershell>${this.props.persist ?? false ? "<persist>true</persist>" : ""}`;
      }
      addS3DownloadCommand(params) {
        const localPath = params.localFile && params.localFile.length !== 0 ? params.localFile : `C:/temp/${params.bucketKey}`;
        return this.addCommands(`mkdir (Split-Path -Path '${localPath}' ) -ea 0`, `Read-S3Object -BucketName '${params.bucket.bucketName}' -key '${params.bucketKey}' -file '${localPath}' -ErrorAction Stop` + (params.region !== void 0 ? ` -Region ${params.region}` : "")), localPath;
      }
      addExecuteFileCommand(params) {
        this.addCommands(`&'${params.filePath}' ${params.arguments ?? ""}`.trim(), `if (!$?) { Write-Error 'Failed to execute the file "${params.filePath}"' -ErrorAction Stop }`);
      }
      addSignalOnExitCommand(resource) {
        const stack = core_1.Stack.of(resource), resourceID = resource.node.defaultChild.logicalId;
        this.addOnExitCommands(`cfn-signal --stack ${stack.stackName} --resource ${resourceID} --region ${stack.region} --success ($success.ToString().ToLower())`);
      }
      renderOnExitLines() {
        return this.onExitLines.length > 0 ? ["trap {", '$success=($PSItem.Exception.Message -eq "Success")', ...this.onExitLines, "break", "}"] : [];
      }
    };
    var CustomUserData = class extends UserData {
      constructor() {
        super(), this.lines = [];
      }
      addCommands(...commands) {
        this.lines.push(...commands);
      }
      addOnExitCommands() {
        throw new Error("CustomUserData does not support addOnExitCommands, use UserData.forLinux() or UserData.forWindows() instead.");
      }
      render() {
        return this.lines.join(`
`);
      }
      addS3DownloadCommand() {
        throw new Error("CustomUserData does not support addS3DownloadCommand, use UserData.forLinux() or UserData.forWindows() instead.");
      }
      addExecuteFileCommand() {
        throw new Error("CustomUserData does not support addExecuteFileCommand, use UserData.forLinux() or UserData.forWindows() instead.");
      }
      addSignalOnExitCommand() {
        throw new Error("CustomUserData does not support addSignalOnExitCommand, use UserData.forLinux() or UserData.forWindows() instead.");
      }
    };
    var MultipartBody = class {
      static fromUserData(userData, contentType) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_UserData(userData);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromUserData), error;
        }
        return new MultipartBodyUserDataWrapper(userData, contentType);
      }
      static fromRawBody(opts) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_MultipartBodyOptions(opts);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromRawBody), error;
        }
        return new MultipartBodyRaw(opts);
      }
      constructor() {
      }
    };
    _b = JSII_RTTI_SYMBOL_1, MultipartBody[_b] = { fqn: "aws-cdk-lib.aws_ec2.MultipartBody", version: "2.80.0" }, MultipartBody.SHELL_SCRIPT = 'text/x-shellscript; charset="utf-8"', MultipartBody.CLOUD_BOOTHOOK = 'text/cloud-boothook; charset="utf-8"', exports2.MultipartBody = MultipartBody;
    var MultipartBodyRaw = class extends MultipartBody {
      constructor(props) {
        super(), this.props = props;
      }
      renderBodyPart() {
        const result = [];
        return result.push(`Content-Type: ${this.props.contentType}`), this.props.transferEncoding != null && result.push(`Content-Transfer-Encoding: ${this.props.transferEncoding}`), result.push(""), this.props.body != null && result.push(this.props.body), result;
      }
    };
    var MultipartBodyUserDataWrapper = class extends MultipartBody {
      constructor(userData, contentType) {
        super(), this.userData = userData, this.contentType = contentType || MultipartBody.SHELL_SCRIPT;
      }
      renderBodyPart() {
        const result = [];
        return result.push(`Content-Type: ${this.contentType}`), result.push("Content-Transfer-Encoding: base64"), result.push(""), result.push(core_1.Fn.base64(this.userData.render())), result;
      }
    };
    var MultipartUserData = class _MultipartUserData extends UserData {
      constructor(opts) {
        super(), this.parts = [];
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_MultipartUserDataOptions(opts);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _MultipartUserData), error;
        }
        let partsSeparator;
        if (opts?.partsSeparator != null) {
          if (new RegExp(_MultipartUserData.BOUNDRY_PATTERN).test(opts.partsSeparator))
            throw new Error(`Invalid characters in separator. Separator has to match pattern ${_MultipartUserData.BOUNDRY_PATTERN}`);
          partsSeparator = opts.partsSeparator;
        } else
          partsSeparator = "+AWS+CDK+User+Data+Separator==";
        this.opts = { partsSeparator };
      }
      addPart(part) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_MultipartBody(part);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addPart), error;
        }
        this.parts.push(part);
      }
      addUserDataPart(userData, contentType, makeDefault) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_UserData(userData);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addUserDataPart), error;
        }
        this.addPart(MultipartBody.fromUserData(userData, contentType)), makeDefault = makeDefault ?? this.defaultUserData === void 0, makeDefault && (this.defaultUserData = userData);
      }
      render() {
        const boundary = this.opts.partsSeparator;
        var resultArchive = new Array();
        return resultArchive.push(`Content-Type: multipart/mixed; boundary="${boundary}"`), resultArchive.push("MIME-Version: 1.0"), resultArchive.push(""), this.parts.forEach((part) => {
          resultArchive.push(`--${boundary}`), resultArchive.push(...part.renderBodyPart());
        }), resultArchive.push(`--${boundary}--`), resultArchive.push(""), resultArchive.join(`
`);
      }
      addS3DownloadCommand(params) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_S3DownloadOptions(params);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addS3DownloadCommand), error;
        }
        if (this.defaultUserData)
          return this.defaultUserData.addS3DownloadCommand(params);
        throw new Error(_MultipartUserData.USE_PART_ERROR);
      }
      addExecuteFileCommand(params) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_ExecuteFileOptions(params);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addExecuteFileCommand), error;
        }
        if (this.defaultUserData)
          this.defaultUserData.addExecuteFileCommand(params);
        else
          throw new Error(_MultipartUserData.USE_PART_ERROR);
      }
      addSignalOnExitCommand(resource) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Resource(resource);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addSignalOnExitCommand), error;
        }
        if (this.defaultUserData)
          this.defaultUserData.addSignalOnExitCommand(resource);
        else
          throw new Error(_MultipartUserData.USE_PART_ERROR);
      }
      addCommands(...commands) {
        if (this.defaultUserData)
          this.defaultUserData.addCommands(...commands);
        else
          throw new Error(_MultipartUserData.USE_PART_ERROR);
      }
      addOnExitCommands(...commands) {
        if (this.defaultUserData)
          this.defaultUserData.addOnExitCommands(...commands);
        else
          throw new Error(_MultipartUserData.USE_PART_ERROR);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, MultipartUserData[_c] = { fqn: "aws-cdk-lib.aws_ec2.MultipartUserData", version: "2.80.0" }, MultipartUserData.USE_PART_ERROR = "MultipartUserData only supports this operation if it has a default UserData. Call addUserDataPart with makeDefault=true.", MultipartUserData.BOUNDRY_PATTERN = "[^a-zA-Z0-9()+,-./:=?]", exports2.MultipartUserData = MultipartUserData;
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/machine-image/common.js
var require_common2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/machine-image/common.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AmazonLinuxStorage = exports2.AmazonLinuxVirt = exports2.AmazonLinuxEdition = exports2.AmazonLinuxCpuType = exports2.OperatingSystemType = exports2.AmazonLinuxGeneration = exports2.AmazonLinuxImageSsmParameterBase = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var utils_1 = require_utils7();
    var user_data_1 = require_user_data();
    var AmazonLinuxImageSsmParameterBase = class _AmazonLinuxImageSsmParameterBase {
      constructor(props) {
        this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_AmazonLinuxImageSsmParameterBaseProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AmazonLinuxImageSsmParameterBase), error;
        }
        this.cachedInContext = this.props.cachedInContext ?? true;
      }
      getImage(scope) {
        const imageId = (0, utils_1.lookupImage)(scope, this.cachedInContext, this.props.parameterName), osType = OperatingSystemType.LINUX;
        return { imageId, osType, userData: this.props.userData ?? user_data_1.UserData.forLinux() };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AmazonLinuxImageSsmParameterBase[_a] = { fqn: "aws-cdk-lib.aws_ec2.AmazonLinuxImageSsmParameterBase", version: "2.80.0" }, exports2.AmazonLinuxImageSsmParameterBase = AmazonLinuxImageSsmParameterBase;
    var AmazonLinuxGeneration;
    (function(AmazonLinuxGeneration2) {
      AmazonLinuxGeneration2.AMAZON_LINUX = "amzn", AmazonLinuxGeneration2.AMAZON_LINUX_2 = "amzn2", AmazonLinuxGeneration2.AMAZON_LINUX_2022 = "al2022", AmazonLinuxGeneration2.AMAZON_LINUX_2023 = "al2023";
    })(AmazonLinuxGeneration = exports2.AmazonLinuxGeneration || (exports2.AmazonLinuxGeneration = {}));
    var OperatingSystemType;
    (function(OperatingSystemType2) {
      OperatingSystemType2[OperatingSystemType2.LINUX = 0] = "LINUX", OperatingSystemType2[OperatingSystemType2.WINDOWS = 1] = "WINDOWS", OperatingSystemType2[OperatingSystemType2.UNKNOWN = 2] = "UNKNOWN";
    })(OperatingSystemType = exports2.OperatingSystemType || (exports2.OperatingSystemType = {}));
    var AmazonLinuxCpuType;
    (function(AmazonLinuxCpuType2) {
      AmazonLinuxCpuType2.ARM_64 = "arm64", AmazonLinuxCpuType2.X86_64 = "x86_64";
    })(AmazonLinuxCpuType = exports2.AmazonLinuxCpuType || (exports2.AmazonLinuxCpuType = {}));
    var AmazonLinuxEdition;
    (function(AmazonLinuxEdition2) {
      AmazonLinuxEdition2.STANDARD = "standard", AmazonLinuxEdition2.MINIMAL = "minimal";
    })(AmazonLinuxEdition = exports2.AmazonLinuxEdition || (exports2.AmazonLinuxEdition = {}));
    var AmazonLinuxVirt;
    (function(AmazonLinuxVirt2) {
      AmazonLinuxVirt2.HVM = "hvm", AmazonLinuxVirt2.PV = "pv";
    })(AmazonLinuxVirt = exports2.AmazonLinuxVirt || (exports2.AmazonLinuxVirt = {}));
    var AmazonLinuxStorage;
    (function(AmazonLinuxStorage2) {
      AmazonLinuxStorage2.EBS = "ebs", AmazonLinuxStorage2.S3 = "s3", AmazonLinuxStorage2.GENERAL_PURPOSE = "gp2";
    })(AmazonLinuxStorage = exports2.AmazonLinuxStorage || (exports2.AmazonLinuxStorage = {}));
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/machine-image/amazon-linux2.js
var require_amazon_linux2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/machine-image/amazon-linux2.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AmazonLinux2ImageSsmParameter = exports2.AmazonLinux2Kernel = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var common_1 = require_common2();
    var AmazonLinux2Kernel = class {
      constructor(version) {
        this.version = version;
      }
      toString() {
        return this.version === "default" ? void 0 : `kernel-${this.version}`;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AmazonLinux2Kernel[_a] = { fqn: "aws-cdk-lib.aws_ec2.AmazonLinux2Kernel", version: "2.80.0" }, AmazonLinux2Kernel.CDK_LATEST = new AmazonLinux2Kernel("5.10"), AmazonLinux2Kernel.DEFAULT = new AmazonLinux2Kernel("default"), AmazonLinux2Kernel.KERNEL_5_10 = new AmazonLinux2Kernel("5.10"), exports2.AmazonLinux2Kernel = AmazonLinux2Kernel;
    var AmazonLinux2ImageSsmParameter = class _AmazonLinux2ImageSsmParameter extends common_1.AmazonLinuxImageSsmParameterBase {
      static ssmParameterName(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_AmazonLinux2ImageSsmParameterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.ssmParameterName), error;
        }
        const edition = props && props.edition || common_1.AmazonLinuxEdition.STANDARD;
        return "/aws/service/ami-amazon-linux-latest/" + [common_1.AmazonLinuxGeneration.AMAZON_LINUX_2, "ami", edition !== common_1.AmazonLinuxEdition.STANDARD ? edition : void 0, props.kernel?.toString(), props.virtualization ?? common_1.AmazonLinuxVirt.HVM, props.cpuType ?? common_1.AmazonLinuxCpuType.X86_64, props.storage ?? common_1.AmazonLinuxStorage.GENERAL_PURPOSE].filter((x) => !!x).join("-");
      }
      constructor(props) {
        super({ parameterName: _AmazonLinux2ImageSsmParameter.ssmParameterName(props), cachedInContext: props.cachedInContext, userData: props.userData });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_AmazonLinux2ImageSsmParameterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AmazonLinux2ImageSsmParameter), error;
        }
      }
    };
    _b = JSII_RTTI_SYMBOL_1, AmazonLinux2ImageSsmParameter[_b] = { fqn: "aws-cdk-lib.aws_ec2.AmazonLinux2ImageSsmParameter", version: "2.80.0" }, exports2.AmazonLinux2ImageSsmParameter = AmazonLinux2ImageSsmParameter;
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/machine-image/amazon-linux-2022.js
var require_amazon_linux_2022 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/machine-image/amazon-linux-2022.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AmazonLinux2022ImageSsmParameter = exports2.AmazonLinux2022Kernel = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var common_1 = require_common2();
    var AmazonLinux2022Kernel = class {
      constructor(version) {
        this.version = version;
      }
      toString() {
        return `kernel-${this.version}`;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AmazonLinux2022Kernel[_a] = { fqn: "aws-cdk-lib.aws_ec2.AmazonLinux2022Kernel", version: "2.80.0" }, AmazonLinux2022Kernel.CDK_LATEST = new AmazonLinux2022Kernel("5.15"), AmazonLinux2022Kernel.DEFAULT = new AmazonLinux2022Kernel("default"), AmazonLinux2022Kernel.KERNEL_5_15 = new AmazonLinux2022Kernel("5.15"), exports2.AmazonLinux2022Kernel = AmazonLinux2022Kernel;
    var AmazonLinux2022ImageSsmParameter = class _AmazonLinux2022ImageSsmParameter extends common_1.AmazonLinuxImageSsmParameterBase {
      static ssmParameterName(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_AmazonLinux2022ImageSsmParameterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.ssmParameterName), error;
        }
        const edition = props && props.edition || common_1.AmazonLinuxEdition.STANDARD;
        return "/aws/service/ami-amazon-linux-latest/" + [common_1.AmazonLinuxGeneration.AMAZON_LINUX_2022, "ami", edition !== common_1.AmazonLinuxEdition.STANDARD ? edition : void 0, props.kernel?.toString(), props.cpuType ?? common_1.AmazonLinuxCpuType.X86_64].filter((x) => !!x).join("-");
      }
      constructor(props) {
        super({ parameterName: _AmazonLinux2022ImageSsmParameter.ssmParameterName(props), cachedInContext: props.cachedInContext, userData: props.userData });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_AmazonLinux2022ImageSsmParameterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AmazonLinux2022ImageSsmParameter), error;
        }
      }
    };
    _b = JSII_RTTI_SYMBOL_1, AmazonLinux2022ImageSsmParameter[_b] = { fqn: "aws-cdk-lib.aws_ec2.AmazonLinux2022ImageSsmParameter", version: "2.80.0" }, exports2.AmazonLinux2022ImageSsmParameter = AmazonLinux2022ImageSsmParameter;
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/machine-image/amazon-linux-2023.js
var require_amazon_linux_2023 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/machine-image/amazon-linux-2023.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AmazonLinux2023ImageSsmParameter = exports2.AmazonLinux2023Kernel = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var common_1 = require_common2();
    var AmazonLinux2023Kernel = class {
      constructor(version) {
        this.version = version;
      }
      toString() {
        return `kernel-${this.version}`;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AmazonLinux2023Kernel[_a] = { fqn: "aws-cdk-lib.aws_ec2.AmazonLinux2023Kernel", version: "2.80.0" }, AmazonLinux2023Kernel.CDK_LATEST = new AmazonLinux2023Kernel("6.1"), AmazonLinux2023Kernel.DEFAULT = new AmazonLinux2023Kernel("default"), AmazonLinux2023Kernel.KERNEL_6_1 = new AmazonLinux2023Kernel("6.1"), exports2.AmazonLinux2023Kernel = AmazonLinux2023Kernel;
    var AmazonLinux2023ImageSsmParameter = class _AmazonLinux2023ImageSsmParameter extends common_1.AmazonLinuxImageSsmParameterBase {
      static ssmParameterName(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_AmazonLinux2023ImageSsmParameterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.ssmParameterName), error;
        }
        const edition = props && props.edition || common_1.AmazonLinuxEdition.STANDARD;
        return "/aws/service/ami-amazon-linux-latest/" + [common_1.AmazonLinuxGeneration.AMAZON_LINUX_2023, "ami", edition !== common_1.AmazonLinuxEdition.STANDARD ? edition : void 0, (props.kernel ?? AmazonLinux2023Kernel.DEFAULT)?.toString(), props.cpuType ?? common_1.AmazonLinuxCpuType.X86_64].filter((x) => !!x).join("-");
      }
      constructor(props = {}) {
        super({ parameterName: _AmazonLinux2023ImageSsmParameter.ssmParameterName(props), cachedInContext: props.cachedInContext, userData: props.userData });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_AmazonLinux2023ImageSsmParameterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AmazonLinux2023ImageSsmParameter), error;
        }
      }
    };
    _b = JSII_RTTI_SYMBOL_1, AmazonLinux2023ImageSsmParameter[_b] = { fqn: "aws-cdk-lib.aws_ec2.AmazonLinux2023ImageSsmParameter", version: "2.80.0" }, exports2.AmazonLinux2023ImageSsmParameter = AmazonLinux2023ImageSsmParameter;
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/windows-versions.js
var require_windows_versions = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/windows-versions.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.WindowsVersion = void 0;
    var WindowsVersion;
    (function(WindowsVersion2) {
      WindowsVersion2.WINDOWS_SERVER_2008_SP2_ENGLISH_64BIT_SQL_2008_SP4_EXPRESS = "Windows_Server-2008-SP2-English-64Bit-SQL_2008_SP4_Express", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_CHINESE_SIMPLIFIED_64BIT_BASE = "Windows_Server-2012-R2_RTM-Chinese_Simplified-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_CHINESE_TRADITIONAL_64BIT_BASE = "Windows_Server-2012-R2_RTM-Chinese_Traditional-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_DUTCH_64BIT_BASE = "Windows_Server-2012-R2_RTM-Dutch-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_ENGLISH_64BIT_SQL_2014_SP2_ENTERPRISE = "Windows_Server-2012-R2_RTM-English-64Bit-SQL_2014_SP2_Enterprise", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_HUNGARIAN_64BIT_BASE = "Windows_Server-2012-R2_RTM-Hungarian-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_JAPANESE_64BIT_BASE = "Windows_Server-2012-R2_RTM-Japanese-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2016_ENGLISH_CORE_CONTAINERS = "Windows_Server-2016-English-Core-Containers", WindowsVersion2.WINDOWS_SERVER_2016_ENGLISH_CORE_SQL_2016_SP1_WEB = "Windows_Server-2016-English-Core-SQL_2016_SP1_Web", WindowsVersion2.WINDOWS_SERVER_2016_GERMAN_FULL_BASE = "Windows_Server-2016-German-Full-Base", WindowsVersion2.WINDOWS_SERVER_2016_GERMAL_FULL_BASE = "Windows_Server-2016-Germal-Full-Base", WindowsVersion2.WINDOWS_SERVER_2003_R2_SP2_LANGUAGE_PACKS_32BIT_BASE = "Windows_Server-2003-R2_SP2-Language_Packs-32Bit-Base", WindowsVersion2.WINDOWS_SERVER_2008_R2_SP1_ENGLISH_64BIT_SQL_2008_R2_SP3_WEB = "Windows_Server-2008-R2_SP1-English-64Bit-SQL_2008_R2_SP3_Web", WindowsVersion2.WINDOWS_SERVER_2008_R2_SP1_ENGLISH_64BIT_SQL_2012_SP4_EXPRESS = "Windows_Server-2008-R2_SP1-English-64Bit-SQL_2012_SP4_Express", WindowsVersion2.WINDOWS_SERVER_2012_R2_SP1_PORTUGUESE_BRAZIL_64BIT_CORE = "Windows_Server-2008-R2_SP1-Portuguese_Brazil-64Bit-Core", WindowsVersion2.WINDOWS_SERVER_2012_R2_SP1_PORTUGESE_BRAZIL_64BIT_CORE = "Windows_Server-2008-R2_SP1-Portugese_Brazil-64Bit-Core", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_ENGLISH_64BIT_SQL_2016_SP2_STANDARD = "Windows_Server-2012-R2_RTM-English-64Bit-SQL_2016_SP2_Standard", WindowsVersion2.WINDOWS_SERVER_2012_RTM_ENGLISH_64BIT_SQL_2014_SP2_EXPRESS = "Windows_Server-2012-RTM-English-64Bit-SQL_2014_SP2_Express", WindowsVersion2.WINDOWS_SERVER_2012_RTM_ITALIAN_64BIT_BASE = "Windows_Server-2012-RTM-Italian-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2016_ENGLISH_CORE_SQL_2016_SP1_EXPRESS = "Windows_Server-2016-English-Core-SQL_2016_SP1_Express", WindowsVersion2.WINDOWS_SERVER_2016_ENGLISH_DEEP_LEARNING = "Windows_Server-2016-English-Deep-Learning", WindowsVersion2.WINDOWS_SERVER_2019_ITALIAN_FULL_BASE = "Windows_Server-2019-Italian-Full-Base", WindowsVersion2.WINDOWS_SERVER_2008_R2_SP1_KOREAN_64BIT_BASE = "Windows_Server-2008-R2_SP1-Korean-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_ENGLISH_64BIT_SQL_2016_SP1_EXPRESS = "Windows_Server-2012-R2_RTM-English-64Bit-SQL_2016_SP1_Express", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_JAPANESE_64BIT_SQL_2016_SP2_WEB = "Windows_Server-2012-R2_RTM-Japanese-64Bit-SQL_2016_SP2_Web", WindowsVersion2.WINDOWS_SERVER_2016_JAPANESE_FULL_FQL_2016_SP2_WEB = "Windows_Server-2016-Japanese-Full-SQL_2016_SP2_Web", WindowsVersion2.WINDOWS_SERVER_2016_KOREAN_FULL_BASE = "Windows_Server-2016-Korean-Full-Base", WindowsVersion2.WINDOWS_SERVER_2016_KOREAN_FULL_SQL_2016_SP2_STANDARD = "Windows_Server-2016-Korean-Full-SQL_2016_SP2_Standard", WindowsVersion2.WINDOWS_SERVER_2016_PORTUGUESE_PORTUGAL_FULL_BASE = "Windows_Server-2016-Portuguese_Portugal-Full-Base", WindowsVersion2.WINDOWS_SERVER_2016_PORTUGESE_PORTUGAL_FULL_BASE = "Windows_Server-2016-Portugese_Portugal-Full-Base", WindowsVersion2.WINDOWS_SERVER_2019_ENGLISH_FULL_SQL_2017_WEB = "Windows_Server-2019-English-Full-SQL_2017_Web", WindowsVersion2.WINDOWS_SERVER_2019_FRENCH_FULL_BASE = "Windows_Server-2019-French-Full-Base", WindowsVersion2.WINDOWS_SERVER_2019_KOREAN_FULL_BASE = "Windows_Server-2019-Korean-Full-Base", WindowsVersion2.WINDOWS_SERVER_2008_R2_SP1_CHINESE_HONG_KONG_SAR_64BIT_BASE = "Windows_Server-2008-R2_SP1-Chinese_Hong_Kong_SAR-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2008_R2_SP1_CHINESE_PRC_64BIT_BASE = "Windows_Server-2008-R2_SP1-Chinese_PRC-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_RTM_FRENCH_64BIT_BASE = "Windows_Server-2012-RTM-French-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2016_ENGLISH_FULL_CONTAINERS = "Windows_Server-2016-English-Full-Containers", WindowsVersion2.WINDOWS_SERVER_2016_ENGLISH_FULL_SQL_2016_SP1_STANDARD = "Windows_Server-2016-English-Full-SQL_2016_SP1_Standard", WindowsVersion2.WINDOWS_SERVER_2016_RUSSIAN_FULL_BASE = "Windows_Server-2016-Russian-Full-Base", WindowsVersion2.WINDOWS_SERVER_2019_CHINESE_SIMPLIFIED_FULL_BASE = "Windows_Server-2019-Chinese_Simplified-Full-Base", WindowsVersion2.WINDOWS_SERVER_2019_ENGLISH_FULL_SQL_2016_SP2_STANDARD = "Windows_Server-2019-English-Full-SQL_2016_SP2_Standard", WindowsVersion2.WINDOWS_SERVER_2019_HUNGARIAN_FULL_BASE = "Windows_Server-2019-Hungarian-Full-Base", WindowsVersion2.WINDOWS_SERVER_2008_R2_SP1_ENGLISH_64BIT_SQL_2008_R2_SP3_EXPRESS = "Windows_Server-2008-R2_SP1-English-64Bit-SQL_2008_R2_SP3_Express", WindowsVersion2.WINDOWS_SERVER_2007_R2_SP1_LANGUAGE_PACKS_64BIT_BASE = "Windows_Server-2008-R2_SP1-Language_Packs-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2008_SP2_ENGLISH_32BIT_BASE = "Windows_Server-2008-SP2-English-32Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_ENGLISH_64BIT_SQL_2012_SP4_ENTERPRISE = "Windows_Server-2012-R2_RTM-English-64Bit-SQL_2012_SP4_Enterprise", WindowsVersion2.WINDOWS_SERVER_2012_RTM_CHINESE_TRADITIONAL_64BIT_BASE = "Windows_Server-2012-RTM-Chinese_Traditional-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_RTM_ENGLISH_64BIT_SQL_2008_R2_SP3_EXPRESS = "Windows_Server-2012-RTM-English-64Bit-SQL_2008_R2_SP3_Express", WindowsVersion2.WINDOWS_SERVER_2012_RTM_ENGLISH_64BIT_SQL_2014_SP2_STANDARD = "Windows_Server-2012-RTM-English-64Bit-SQL_2014_SP2_Standard", WindowsVersion2.WINDOWS_SERVER_2012_RTM_JAPANESE_64BIT_SQL_2014_SP2_EXPRESS = "Windows_Server-2012-RTM-Japanese-64Bit-SQL_2014_SP2_Express", WindowsVersion2.WINDOWS_SERVER_2016_POLISH_FULL_BASE = "Windows_Server-2016-Polish-Full-Base", WindowsVersion2.WINDOWS_SERVER_2019_ENGLISH_FULL_SQL_2016_SP2_WEB = "Windows_Server-2019-English-Full-SQL_2016_SP2_Web", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_ENGLISH_64BIT_SQL_2014_SP3_STANDARD = "Windows_Server-2012-R2_RTM-English-64Bit-SQL_2014_SP3_Standard", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_ENGLISH_64BIT_SQL_2016_SP2_EXPRESS = "Windows_Server-2012-R2_RTM-English-64Bit-SQL_2016_SP2_Express", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_ENGLISH_DEEP_LEARNING = "Windows_Server-2012-R2_RTM-English-Deep-Learning", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_GERMAN_64BIT_BASE = "Windows_Server-2012-R2_RTM-German-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_JAPANESE_64BIT_SQL_2016_SP1_EXPRESS = "Windows_Server-2012-R2_RTM-Japanese-64Bit-SQL_2016_SP1_Express", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_RUSSIAN_64BIT_BASE = "Windows_Server-2012-R2_RTM-Russian-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_RTM_CHINESE_TRADITIONAL_HONG_KONG_SAR_64BIT_BASE = "Windows_Server-2012-RTM-Chinese_Traditional_Hong_Kong_SAR-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_RTM_HUNGARIAN_64BIT_BASE = "Windows_Server-2012-RTM-Hungarian-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_RTM_JAPANESE_64BIT_SQL_2014_SP3_STANDARD = "Windows_Server-2012-RTM-Japanese-64Bit-SQL_2014_SP3_Standard", WindowsVersion2.WINDOWS_SERVER_2019_ENGLISH_FULL_HYPERV = "Windows_Server-2019-English-Full-HyperV", WindowsVersion2.WINDOWS_SERVER_2003_R2_SP2_ENGLISH_64BIT_SQL_2005_SP4_EXPRESS = "Windows_Server-2003-R2_SP2-English-64Bit-SQL_2005_SP4_Express", WindowsVersion2.WINDOWS_SERVER_2008_R2_SP1_JAPANESE_64BIT_SQL_2012_SP4_EXPRESS = "Windows_Server-2008-R2_SP1-Japanese-64Bit-SQL_2012_SP4_Express", WindowsVersion2.WINDOWS_SERVER_2012_RTM_GERMAN_64BIT_BASE = "Windows_Server-2012-RTM-German-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_RTM_JAPANESE_64BIT_SQL_2008_R2_SP3_STANDARD = "Windows_Server-2012-RTM-Japanese-64Bit-SQL_2008_R2_SP3_Standard", WindowsVersion2.WINDOWS_SERVER_2016_ENGLISH_FULL_SQL_2016_SP2_STANDARD = "Windows_Server-2016-English-Full-SQL_2016_SP2_Standard", WindowsVersion2.WINDOWS_SERVER_2019_ENGLISH_FULL_SQL_2017_EXPRESS = "Windows_Server-2019-English-Full-SQL_2017_Express", WindowsVersion2.WINDOWS_SERVER_2019_JAPANESE_FULL_BASE = "Windows_Server-2019-Japanese-Full-Base", WindowsVersion2.WINDOWS_SERVER_2019_RUSSIAN_FULL_BASE = "Windows_Server-2019-Russian-Full-Base", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_ENGLISH_64BIT_SQL_2014_SP2_STANDARD = "Windows_Server-2012-R2_RTM-English-64Bit-SQL_2014_SP2_Standard", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_ITALIAN_64BIT_BASE = "Windows_Server-2012-R2_RTM-Italian-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_RTM_ENGLISH_64BIT_BASE = "Windows_Server-2012-RTM-English-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_RTM_ENGLISH_64BIT_SQL_2008_R2_SP3_STANDARD = "Windows_Server-2012-RTM-English-64Bit-SQL_2008_R2_SP3_Standard", WindowsVersion2.WINDOWS_SERVER_2016_ENGLISH_FULL_HYPERV = "Windows_Server-2016-English-Full-HyperV", WindowsVersion2.WINDOWS_SERVER_2016_ENGLISH_FULL_SQL_2016_SP2_ENTERPRISE = "Windows_Server-2016-English-Full-SQL_2016_SP2_Enterprise", WindowsVersion2.WINDOWS_SERVER_2019_CHINESE_TRADITIONAL_FULL_BASE = "Windows_Server-2019-Chinese_Traditional-Full-Base", WindowsVersion2.WINDOWS_SERVER_2019_ENGLISH_CORE_BASE = "Windows_Server-2019-English-Core-Base", WindowsVersion2.WINDOWS_SERVER_2019_ENGLISH_CORE_CONTAINERSLATEST = "Windows_Server-2019-English-Core-ContainersLatest", WindowsVersion2.WINDOWS_SERVER_2008_SP2_ENGLISH_64BIT_BASE = "Windows_Server-2008-SP2-English-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_FRENCH_64BIT_BASE = "Windows_Server-2012-R2_RTM-French-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_POLISH_64BIT_BASE = "Windows_Server-2012-R2_RTM-Polish-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_RTM_ENGLISH_64BIT_SQL_2012_SP4_EXPRESS = "Windows_Server-2012-RTM-English-64Bit-SQL_2012_SP4_Express", WindowsVersion2.WINDOWS_SERVER_2012_RTM_ENGLISH_64BIT_SQL_2014_SP3_STANDARD = "Windows_Server-2012-RTM-English-64Bit-SQL_2014_SP3_Standard", WindowsVersion2.WINDOWS_SERVER_2012_RTM_JAPANESE_64BIT_2012_SP4_STANDARD = "Windows_Server-2012-RTM-Japanese-64Bit-SQL_2012_SP4_Standard", WindowsVersion2.WINDOWS_SERVER_2016_ENGLISH_CORE_CONTAINERSLATEST = "Windows_Server-2016-English-Core-ContainersLatest", WindowsVersion2.WINDOWS_SERVER_2019_ENGLISH_FULL_SQL_2016_SP2_EXPRESS = "Windows_Server-2019-English-Full-SQL_2016_SP2_Express", WindowsVersion2.WINDOWS_SERVER_2019_TURKISH_FULL_BASE = "Windows_Server-2019-Turkish-Full-Base", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_ENGLISH_64BIT_SQL_2014_SP2_EXPRESS = "Windows_Server-2012-R2_RTM-English-64Bit-SQL_2014_SP2_Express", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_ENGLISH_64BIT_SQL_2014_SP3_WEB = "Windows_Server-2012-R2_RTM-English-64Bit-SQL_2014_SP3_Web", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_JAPANESE_64BIT_SQL_2016_SP1_WEB = "Windows_Server-2012-R2_RTM-Japanese-64Bit-SQL_2016_SP1_Web", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_PORTUGUESE_BRAZIL_64BIT_BASE = "Windows_Server-2012-R2_RTM-Portuguese_Brazil-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_PORTUGESE_BRAZIL_64BIT_BASE = "Windows_Server-2012-R2_RTM-Portugese_Brazil-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_PORTUGUESE_PORTUGAL_64BIT_BASE = "Windows_Server-2012-R2_RTM-Portuguese_Portugal-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_PORTUGESE_PORTUGAL_64BIT_BASE = "Windows_Server-2012-R2_RTM-Portugese_Portugal-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_SWEDISH_64BIT_BASE = "Windows_Server-2012-R2_RTM-Swedish-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2016_ENGLISH_FULL_SQL_2016_SP1_EXPRESS = "Windows_Server-2016-English-Full-SQL_2016_SP1_Express", WindowsVersion2.WINDOWS_SERVER_2016_ITALIAN_FULL_BASE = "Windows_Server-2016-Italian-Full-Base", WindowsVersion2.WINDOWS_SERVER_2016_SPANISH_FULL_BASE = "Windows_Server-2016-Spanish-Full-Base", WindowsVersion2.WINDOWS_SERVER_2019_ENGLISH_FULL_SQL_2017_STANDARD = "Windows_Server-2019-English-Full-SQL_2017_Standard", WindowsVersion2.WINDOWS_SERVER_2003_R2_SP2_LANGUAGE_PACKS_64BIT_SQL_2005_SP4_STANDARD = "Windows_Server-2003-R2_SP2-Language_Packs-64Bit-SQL_2005_SP4_Standard", WindowsVersion2.WINDOWS_SERVER_2008_R2_SP1_JAPANESE_64BIT_SQL_2008_R2_SP3_STANDARD = "Windows_Server-2008-R2_SP1-Japanese-64Bit-SQL_2008_R2_SP3_Standard", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_JAPANESE_64BIT_SQL_2016_SP1_STANDARD = "Windows_Server-2012-R2_RTM-Japanese-64Bit-SQL_2016_SP1_Standard", WindowsVersion2.WINDOWS_SERVER_2012_RTM_ENGLISH_64BIT_SQL_2007_R2_SP3_WEB = "Windows_Server-2012-RTM-English-64Bit-SQL_2008_R2_SP3_Web", WindowsVersion2.WINDOWS_SERVER_2012_RTM_JAPANESE_64BIT_SQL_2014_SP2_WEB = "Windows_Server-2012-RTM-Japanese-64Bit-SQL_2014_SP2_Web", WindowsVersion2.WINDOWS_SERVER_2016_ENGLISH_CORE_SQL_2016_SP2_ENTERPRISE = "Windows_Server-2016-English-Core-SQL_2016_SP2_Enterprise", WindowsVersion2.WINDOWS_SERVER_2016_PORTUGUESE_BRAZIL_FULL_BASE = "Windows_Server-2016-Portuguese_Brazil-Full-Base", WindowsVersion2.WINDOWS_SERVER_2016_PORTUGESE_BRAZIL_FULL_BASE = "Windows_Server-2016-Portugese_Brazil-Full-Base", WindowsVersion2.WINDOWS_SERVER_2019_ENGLISH_FULL_BASE = "Windows_Server-2019-English-Full-Base", WindowsVersion2.WINDOWS_SERVER_2003_R2_SP2_ENGLISH_32BIT_BASE = "Windows_Server-2003-R2_SP2-English-32Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_CZECH_64BIT_BASE = "Windows_Server-2012-R2_RTM-Czech-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_ENGLISH_64BIT_SQL_2016_SP1_STANDARD = "Windows_Server-2012-R2_RTM-English-64Bit-SQL_2016_SP1_Standard", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_JAPANESE_64BIT_SQL_2014_SP2_EXPRESS = "Windows_Server-2012-R2_RTM-Japanese-64Bit-SQL_2014_SP2_Express", WindowsVersion2.WINDOWS_SERVER_2012_RTM_ENGLISH_64BIT_SQL_2012_SP4_STANDARD = "Windows_Server-2012-RTM-English-64Bit-SQL_2012_SP4_Standard", WindowsVersion2.WINDOWS_SERVER_2016_ENGLISH_CORE_SQL_2016_SP1_ENTERPRISE = "Windows_Server-2016-English-Core-SQL_2016_SP1_Enterprise", WindowsVersion2.WINDOWS_SERVER_2016_JAPANESE_FULL_SQL_2016_SP1_WEB = "Windows_Server-2016-Japanese-Full-SQL_2016_SP1_Web", WindowsVersion2.WINDOWS_SERVER_2016_SWEDISH_FULL_BASE = "Windows_Server-2016-Swedish-Full-Base", WindowsVersion2.WINDOWS_SERVER_2016_TURKISH_FULL_BASE = "Windows_Server-2016-Turkish-Full-Base", WindowsVersion2.WINDOWS_SERVER_2008_R2_SP1_ENGLISH_64BIT_CORE_SQL_2012_SP4_STANDARD = "Windows_Server-2008-R2_SP1-English-64Bit-Core_SQL_2012_SP4_Standard", WindowsVersion2.WINDOWS_SERVER_2008_R2_SP1_LANGUAGE_PACKS_64BIT_SQL_2008_R2_SP3_STANDARD = "Windows_Server-2008-R2_SP1-Language_Packs-64Bit-SQL_2008_R2_SP3_Standard", WindowsVersion2.WINDOWS_SERVER_2012_RTM_CZECH_64BIT_BASE = "Windows_Server-2012-RTM-Czech-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_RTM_TURKISH_64BIT_BASE = "Windows_Server-2012-RTM-Turkish-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2016_DUTCH_FULL_BASE = "Windows_Server-2016-Dutch-Full-Base", WindowsVersion2.WINDOWS_SERVER_2016_ENGLISH_FULL_SQL_2016_SP2_EXPRESS = "Windows_Server-2016-English-Full-SQL_2016_SP2_Express", WindowsVersion2.WINDOWS_SERVER_2016_ENGLISH_FULL_SQL_2017_ENTERPRISE = "Windows_Server-2016-English-Full-SQL_2017_Enterprise", WindowsVersion2.WINDOWS_SERVER_2016_HUNGARIAN_FULL_BASE = "Windows_Server-2016-Hungarian-Full-Base", WindowsVersion2.WINDOWS_SERVER_2016_KOREAN_FULL_SQL_2016_SP1_STANDARD = "Windows_Server-2016-Korean-Full-SQL_2016_SP1_Standard", WindowsVersion2.WINDOWS_SERVER_2019_SPANISH_FULL_BASE = "Windows_Server-2019-Spanish-Full-Base", WindowsVersion2.WINDOWS_SERVER_2003_R2_SP2_ENGLISH_64BIT_BASE = "Windows_Server-2003-R2_SP2-English-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2008_R2_SP1_ENGLISH_64BIT_BASE = "Windows_Server-2008-R2_SP1-English-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2008_R2_SP1_LANGUAGE_PACKS_64BIT_SQL_2008_R2_SP3_EXPRESS = "Windows_Server-2008-R2_SP1-Language_Packs-64Bit-SQL_2008_R2_SP3_Express", WindowsVersion2.WINDOWS_SERVER_2012_SP2_PORTUGUESE_BRAZIL_64BIT_BASE = "Windows_Server-2008-SP2-Portuguese_Brazil-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_SP2_PORTUGESE_BRAZIL_64BIT_BASE = "Windows_Server-2008-SP2-Portugese_Brazil-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_ENGLISH_64BIT_SQL_2016_SP1_WEB = "Windows_Server-2012-R2_RTM-English-64Bit-SQL_2016_SP1_Web", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_JAPANESE_64BIT_SQL_2014_SP3_EXPRESS = "Windows_Server-2012-R2_RTM-Japanese-64Bit-SQL_2014_SP3_Express", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_JAPANESE_64BIT_SQL_2016_SP2_ENTERPRISE = "Windows_Server-2012-R2_RTM-Japanese-64Bit-SQL_2016_SP2_Enterprise", WindowsVersion2.WINDOWS_SERVER_2012_RTM_JAPANESE_64BIT_BASE = "Windows_Server-2012-RTM-Japanese-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2019_ENGLISH_FULL_CONTAINERSLATEST = "Windows_Server-2019-English-Full-ContainersLatest", WindowsVersion2.WINDOWS_SERVER_2019_ENGLISH_FULL_SQL_2017_ENTERPRISE = "Windows_Server-2019-English-Full-SQL_2017_Enterprise", WindowsVersion2.WINDOWS_SERVER_1709_ENGLISH_CORE_CONTAINERSLATEST = "Windows_Server-1709-English-Core-ContainersLatest", WindowsVersion2.WINDOWS_SERVER_1803_ENGLISH_CORE_BASE = "Windows_Server-1803-English-Core-Base", WindowsVersion2.WINDOWS_SERVER_2008_R2_SP1_ENGLISH_64BIT_SQL_2012_SP4_WEB = "Windows_Server-2008-R2_SP1-English-64Bit-SQL_2012_SP4_Web", WindowsVersion2.WINDOWS_SERVER_2008_R2_SP1_JAPANESE_64BIT_BASE = "Windows_Server-2008-R2_SP1-Japanese-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2008_SP2_ENGLISH_64BIT_SQL_2008_SP4_STANDARD = "Windows_Server-2008-SP2-English-64Bit-SQL_2008_SP4_Standard", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_ENGLISH_64BIT_BASE = "Windows_Server-2012-R2_RTM-English-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_RTM_PORTUGUESE_BRAZIL_64BIT_BASE = "Windows_Server-2012-RTM-Portuguese_Brazil-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_RTM_PORTUGESE_BRAZIL_64BIT_BASE = "Windows_Server-2012-RTM-Portugese_Brazil-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2016_ENGLISH_FULL_SQL_2016_SP1_WEB = "Windows_Server-2016-English-Full-SQL_2016_SP1_Web", WindowsVersion2.WINDOWS_SERVER_2016_ENGLISH_P3 = "Windows_Server-2016-English-P3", WindowsVersion2.WINDOWS_SERVER_2016_JAPANESE_FULL_SQL_2016_SP1_ENTERPRISE = "Windows_Server-2016-Japanese-Full-SQL_2016_SP1_Enterprise", WindowsVersion2.WINDOWS_SERVER_2003_R2_SP2_LANGUAGE_PACKS_64BIT_BASE = "Windows_Server-2003-R2_SP2-Language_Packs-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_CHINESE_TRADITIONAL_HONG_KONG_64BIT_BASE = "Windows_Server-2012-R2_RTM-Chinese_Traditional_Hong_Kong-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_ENGLISH_64BIT_SQL_2014_SP3_EXPRESS = "Windows_Server-2012-R2_RTM-English-64Bit-SQL_2014_SP3_Express", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_ENGLISH_64BIT_SQL_2016_SP2_ENTERPRISE = "Windows_Server-2012-R2_RTM-English-64Bit-SQL_2016_SP2_Enterprise", WindowsVersion2.WINDOWS_SERVER_2012_RTM_CHINESE_SIMPLIFIED_64BIT_BASE = "Windows_Server-2012-RTM-Chinese_Simplified-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_RTM_ENGLISH_64BIT_SQL_2012_SP4_WEB = "Windows_Server-2012-RTM-English-64Bit-SQL_2012_SP4_Web", WindowsVersion2.WINDOWS_SERVER_2012_RTM_JAPANESE_64BIT_SQL_2014_SP3_WEB = "Windows_Server-2012-RTM-Japanese-64Bit-SQL_2014_SP3_Web", WindowsVersion2.WINDOWS_SERVER_2016_JAPANESE_FULL_BASE = "Windows_Server-2016-Japanese-Full-Base", WindowsVersion2.WINDOWS_SERVER_2016_JAPANESE_FULL_SQL_2016_SP1_EXPRESS = "Windows_Server-2016-Japanese-Full-SQL_2016_SP1_Express", WindowsVersion2.WINDOWS_SERVER_1803_ENGLISH_CORE_CONTAINERSLATEST = "Windows_Server-1803-English-Core-ContainersLatest", WindowsVersion2.WINDOWS_SERVER_2008_R2_SP1_JAPANESE_64BIT_SQL_2012_SP4_STANDARD = "Windows_Server-2008-R2_SP1-Japanese-64Bit-SQL_2012_SP4_Standard", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_ENGLISH_64BIT_CORE = "Windows_Server-2012-R2_RTM-English-64Bit-Core", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_ENGLISH_64BIT_SQL_2014_SP2_WEB = "Windows_Server-2012-R2_RTM-English-64Bit-SQL_2014_SP2_Web", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_ENGLISH_64BIT_SQL_2014_SP3_ENTERPRISE = "Windows_Server-2012-R2_RTM-English-64Bit-SQL_2014_SP3_Enterprise", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_JAPANESE_64BIT_SQL_2016_SP2_STANDARD = "Windows_Server-2012-R2_RTM-Japanese-64Bit-SQL_2016_SP2_Standard", WindowsVersion2.WINDOWS_SERVER_2012_RTM_ENGLISH_64BIT_2014_SP3_WEB = "Windows_Server-2012-RTM-English-64Bit-SQL_2014_SP3_Web", WindowsVersion2.WINDOWS_SERVER_2012_RTM_SWEDISH_64BIT_BASE = "Windows_Server-2012-RTM-Swedish-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2016_CHINESE_SIMPLIFIED_FULL_BASE = "Windows_Server-2016-Chinese_Simplified-Full-Base", WindowsVersion2.WINDOWS_SERVER_2019_POLISH_FULL_BASE = "Windows_Server-2019-Polish-Full-Base", WindowsVersion2.WINDOWS_SERVER_2008_R2_SP1_JAPANESE_64BIT_SQL_2008_R2_SP3_WEB = "Windows_Server-2008-R2_SP1-Japanese-64Bit-SQL_2008_R2_SP3_Web", WindowsVersion2.WINDOWS_SERVER_2008_R2_SP1_PORTUGUESE_BRAZIL_64BIT_BASE = "Windows_Server-2008-R2_SP1-Portuguese_Brazil-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2008_R2_SP1_PORTUGESE_BRAZIL_64BIT_BASE = "Windows_Server-2008-R2_SP1-Portugese_Brazil-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_JAPANESE_64BIT_SQL_2016_SP1_ENTERPRISE = "Windows_Server-2012-R2_RTM-Japanese-64Bit-SQL_2016_SP1_Enterprise", WindowsVersion2.WINDOWS_SERVER_2012_RTM_JAPANESE_64BIT_SQL_2016_SP2_EXPRESS = "Windows_Server-2012-R2_RTM-Japanese-64Bit-SQL_2016_SP2_Express", WindowsVersion2.WINDOWS_SERVER_2012_RTM_ENGLISH_64BIT_SQL_2014_SP3_EXPRESS = "Windows_Server-2012-RTM-English-64Bit-SQL_2014_SP3_Express", WindowsVersion2.WINDOWS_SERVER_2012_RTM_JAPANESE_64BIT_SQL_2014_SP2_STANDARD = "Windows_Server-2012-RTM-Japanese-64Bit-SQL_2014_SP2_Standard", WindowsVersion2.WINDOWS_SERVER_2016_ENGLISH_CORE_BASE = "Windows_Server-2016-English-Core-Base", WindowsVersion2.WINDOWS_SERVER_2016_ENGLISH_FULL_BASE = "Windows_Server-2016-English-Full-Base", WindowsVersion2.WINDOWS_SERVER_2016_ENGLISH_FULL_SQL_2017_WEB = "Windows_Server-2016-English-Full-SQL_2017_Web", WindowsVersion2.WINDOWS_SERVER_2019_GERMAN_FULL_BASE = "Windows_Server-2019-German-Full-Base", WindowsVersion2.WINDOWS_SERVER_2003_R2_SP2_ENGLISH_64BIT_SQL_2005_SP4_STANDARD = "Windows_Server-2003-R2_SP2-English-64Bit-SQL_2005_SP4_Standard", WindowsVersion2.WINDOWS_SERVER_2008_R2_SP1_ENGLISH_64BIT_SQL_2012_SP4_ENTERPRISE = "Windows_Server-2008-R2_SP1-English-64Bit-SQL_2012_SP4_Enterprise", WindowsVersion2.WINDOWS_SERVER_2008_R2_SP1_JAPANESE_64BIT_SQL_2008_R2_SP3_EXPRESS = "Windows_Server-2008-R2_SP1-Japanese-64Bit-SQL_2008_R2_SP3_Express", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_ENGLISH_64BIT_SQL_2016_SP1_ENTERPRISE = "Windows_Server-2012-R2_RTM-English-64Bit-SQL_2016_SP1_Enterprise", WindowsVersion2.WINDOWS_SERVER_2012_RTM_ENGLISH_64BIT_SQL_2014_SP2_WEB = "Windows_Server-2012-RTM-English-64Bit-SQL_2014_SP2_Web", WindowsVersion2.WINDOWS_SERVER_2012_RTM_JAPANESE_64BIT_SQL_2008_R2_SP3_EXPRESS = "Windows_Server-2012-RTM-Japanese-64Bit-SQL_2008_R2_SP3_Express", WindowsVersion2.WINDOWS_SERVER_2016_FRENCH_FULL_BASE = "Windows_Server-2016-French-Full-Base", WindowsVersion2.WINDOWS_SERVER_2016_JAPANESE_FULL_SQL_2016_SP2_ENTERPRISE = "Windows_Server-2016-Japanese-Full-SQL_2016_SP2_Enterprise", WindowsVersion2.WINDOWS_SERVER_2019_CZECH_FULL_BASE = "Windows_Server-2019-Czech-Full-Base", WindowsVersion2.WINDOWS_SERVER_1809_ENGLISH_CORE_BASE = "Windows_Server-1809-English-Core-Base", WindowsVersion2.WINDOWS_SERVER_1809_ENGLISH_CORE_CONTAINERSLATEST = "Windows_Server-1809-English-Core-ContainersLatest", WindowsVersion2.WINDOWS_SERVER_2003_R2_SP2_LANGUAGE_PACKS_64BIT_SQL_2005_SP4_EXPRESS = "Windows_Server-2003-R2_SP2-Language_Packs-64Bit-SQL_2005_SP4_Express", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_TURKISH_64BIT_BASE = "Windows_Server-2012-R2_RTM-Turkish-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_RTM_JAPANESE_64BIT_SQL_2012_SP4_WEB = "Windows_Server-2012-RTM-Japanese-64Bit-SQL_2012_SP4_Web", WindowsVersion2.WINDOWS_SERVER_2012_RTM_POLISH_64BIT_BASE = "Windows_Server-2012-RTM-Polish-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_RTM_SPANISH_64BIT_BASE = "Windows_Server-2012-RTM-Spanish-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2016_ENGLISH_FULL_SQL_2016_SP1_ENTERPRISE = "Windows_Server-2016-English-Full-SQL_2016_SP1_Enterprise", WindowsVersion2.WINDOWS_SERVER_2016_JAPANESE_FULL_SQL_2016_SP2_EXPRESS = "Windows_Server-2016-Japanese-Full-SQL_2016_SP2_Express", WindowsVersion2.WINDOWS_SERVER_2019_ENGLISH_FULL_SQL_2016_SP2_ENTERPRISE = "Windows_Server-2019-English-Full-SQL_2016_SP2_Enterprise", WindowsVersion2.WINDOWS_SERVER_1709_ENGLISH_CORE_BASE = "Windows_Server-1709-English-Core-Base", WindowsVersion2.WINDOWS_SERVER_2008_R2_SP1_ENGLISH_61BIT_SQL_2012_RTM_SP2_ENTERPRISE = "Windows_Server-2008-R2_SP1-English-64Bit-SQL_2012_RTM_SP2_Enterprise", WindowsVersion2.WINDOWS_SERVER_2008_R2_SP1_ENGLISH_64BIT_SQL_2012_SP4_STANDARD = "Windows_Server-2008-R2_SP1-English-64Bit-SQL_2012_SP4_Standard", WindowsVersion2.WINDOWS_SERVER_2008_SP2_PORTUGUESE_BRAZIL_32BIT_BASE = "Windows_Server-2008-SP2-Portuguese_Brazil-32Bit-Base", WindowsVersion2.WINDOWS_SERVER_2008_SP2_PORTUGESE_BRAZIL_32BIT_BASE = "Windows_Server-2008-SP2-Portugese_Brazil-32Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_JAPANESE_64BIT_SQL_2014_SP2_STANDARD = "Windows_Server-2012-R2_RTM-Japanese-64Bit-SQL_2014_SP2_Standard", WindowsVersion2.WINDOWS_SERVER_2012_RTM_JAPANESE_64BIT_SQL_2012_SP4_EXPRESS = "Windows_Server-2012-RTM-Japanese-64Bit-SQL_2012_SP4_Express", WindowsVersion2.WINDOWS_SERVER_2012_RTM_PORTUGUESE_PORTUGAL_64BIT_BASE = "Windows_Server-2012-RTM-Portuguese_Portugal-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_RTM_PORTUGESE_PORTUGAL_64BIT_BASE = "Windows_Server-2012-RTM-Portugese_Portugal-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2016_CZECH_FULL_BASE = "Windows_Server-2016-Czech-Full-Base", WindowsVersion2.WINDOWS_SERVER_2016_JAPANESE_FULL_SQL_2016_SP1_STANDARD = "Windows_Server-2016-Japanese-Full-SQL_2016_SP1_Standard", WindowsVersion2.WINDOWS_SERVER_2019_DUTCH_FULL_BASE = "Windows_Server-2019-Dutch-Full-Base", WindowsVersion2.WINDOWS_SERVER_2008_R2_SP1_ENGLISH_64BIT_CORE = "Windows_Server-2008-R2_SP1-English-64Bit-Core", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_ENGLISH_64BIT_SQL_2016_SP2_WEB = "Windows_Server-2012-R2_RTM-English-64Bit-SQL_2016_SP2_Web", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_KOREAN_64BIT_BASE = "Windows_Server-2012-R2_RTM-Korean-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_RTM_DUTCH_64BIT_BASE = "Windows_Server-2012-RTM-Dutch-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2016_ENGLISH_64BIT_SQL_2012_SP4_ENTERPRISE = "Windows_Server-2016-English-64Bit-SQL_2012_SP4_Enterprise", WindowsVersion2.WINDOWS_SERVER_2016_ENGLISH_CORE_SQL_2016_SP1_STANDARD = "Windows_Server-2016-English-Core-SQL_2016_SP1_Standard", WindowsVersion2.WINDOWS_SERVER_2016_ENGLISH_CORE_SQL_2016_SP2_EXPRESS = "Windows_Server-2016-English-Core-SQL_2016_SP2_Express", WindowsVersion2.WINDOWS_SERVER_2016_ENGLISH_CORE_SQL_2016_SP2_WEB = "Windows_Server-2016-English-Core-SQL_2016_SP2_Web", WindowsVersion2.WINDOWS_SERVER_2016_ENGLISH_FULL_SQL_2017_STANDARD = "Windows_Server-2016-English-Full-SQL_2017_Standard", WindowsVersion2.WINDOWS_SERVER_2019_PORTUGUESE_BRAZIL_FULL_BASE = "Windows_Server-2019-Portuguese_Brazil-Full-Base", WindowsVersion2.WINDOWS_SERVER_2019_PORTUGESE_BRAZIL_FULL_BASE = "Windows_Server-2019-Portugese_Brazil-Full-Base", WindowsVersion2.WINDOWS_SERVER_2008_R2_SP1_ENGLISH_64BIT_SQL_2008_R2_SP3_STANDARD = "Windows_Server-2008-R2_SP1-English-64Bit-SQL_2008_R2_SP3_Standard", WindowsVersion2.WINDOWS_SERVER_2008_R2_SP1_ENGLISH_64BIT_SHAREPOINT_2010_SP2_FOUNDATION = "Windows_Server-2008-R2_SP1-English-64Bit-SharePoint_2010_SP2_Foundation", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_ENGLISH_P3 = "Windows_Server-2012-R2_RTM-English-P3", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_JAPANESE_64BIT_SQL_2014_SP3_STANDARD = "Windows_Server-2012-R2_RTM-Japanese-64Bit-SQL_2014_SP3_Standard", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_SPANISH_64BIT_BASE = "Windows_Server-2012-R2_RTM-Spanish-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_RTM_JAPANESE_64BIT_SQL_2014_SP3_EXPRESS = "Windows_Server-2012-RTM-Japanese-64Bit-SQL_2014_SP3_Express", WindowsVersion2.WINDOWS_SERVER_2016_ENGLISH_CORE_SQL_2016_SP2_STANDARD = "Windows_Server-2016-English-Core-SQL_2016_SP2_Standard", WindowsVersion2.WINDOWS_SERVER_2016_JAPANESE_FULL_SQL_2016_SP2_STANDARD = "Windows_Server-2016-Japanese-Full-SQL_2016_SP2_Standard", WindowsVersion2.WINDOWS_SERVER_2019_PORTUGUESE_PORTUGAL_FULL_BASE = "Windows_Server-2019-Portuguese_Portugal-Full-Base", WindowsVersion2.WINDOWS_SERVER_2019_PORTUGESE_PORTUGAL_FULL_BASE = "Windows_Server-2019-Portugese_Portugal-Full-Base", WindowsVersion2.WINDOWS_SERVER_2019_SWEDISH_FULL_BASE = "Windows_Server-2019-Swedish-Full-Base", WindowsVersion2.WINDOWS_SERVER_2012_R2_RTM_ENGLISH_64BIT_HYPERV = "Windows_Server-2012-R2_RTM-English-64Bit-HyperV", WindowsVersion2.WINDOWS_SERVER_2012_RTM_KOREAN_64BIT_BASE = "Windows_Server-2012-RTM-Korean-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2012_RTM_RUSSIAN_64BIT_BASE = "Windows_Server-2012-RTM-Russian-64Bit-Base", WindowsVersion2.WINDOWS_SERVER_2016_CHINESE_TRADITIONAL_FULL_BASE = "Windows_Server-2016-Chinese_Traditional-Full-Base", WindowsVersion2.WINDOWS_SERVER_2016_ENGLISH_FULL_SQL_2016_SP2_WEB = "Windows_Server-2016-English-Full-SQL_2016_SP2_Web", WindowsVersion2.WINDOWS_SERVER_2016_ENGLISH_FULL_SQL_2017_EXPRESS = "Windows_Server-2016-English-Full-SQL_2017_Express", WindowsVersion2.WINDOWS_SERVER_2022_JAPANESE_FULL_SQL_2019_ENTERPRISE = "Windows_Server-2022-Japanese-Full-SQL_2019_Enterprise", WindowsVersion2.WINDOWS_SERVER_2022_PORTUGUESE_BRAZIL_FULL_BASE = "Windows_Server-2022-Portuguese_Brazil-Full-Base", WindowsVersion2.WINDOWS_SERVER_2022_ITALIAN_FULL_BASE = "Windows_Server-2022-Italian-Full-Base", WindowsVersion2.WINDOWS_SERVER_2022_ENGLISH_FULL_CONTAINERSLATEST = "Windows_Server-2022-English-Full-ContainersLatest", WindowsVersion2.WINDOWS_SERVER_2022_RUSSIAN_FULL_BASE = "Windows_Server-2022-Russian-Full-Base", WindowsVersion2.WINDOWS_SERVER_2022_ENGLISH_FULL_SQL_2019_EXPRESS = "Windows_Server-2022-English-Full-SQL_2019_Express", WindowsVersion2.WINDOWS_SERVER_2022_POLISH_FULL_BASE = "Windows_Server-2022-Polish-Full-Base", WindowsVersion2.WINDOWS_SERVER_2022_ENGLISH_CORE_BASE = "Windows_Server-2022-English-Core-Base", WindowsVersion2.WINDOWS_SERVER_2022_HUNGARIAN_FULL_BASE = "Windows_Server-2022-Hungarian-Full-Base", WindowsVersion2.WINDOWS_SERVER_2022_ENGLISH_FULL_SQL_2017_EXPRESS = "Windows_Server-2022-English-Full-SQL_2017_Express", WindowsVersion2.WINDOWS_SERVER_2022_GERMAN_FULL_BASE = "Windows_Server-2022-German-Full-Base", WindowsVersion2.WINDOWS_SERVER_2022_ENGLISH_CORE_CONTAINERSLATEST = "Windows_Server-2022-English-Core-ContainersLatest", WindowsVersion2.WINDOWS_SERVER_2022_ENGLISH_FULL_SQL_2019_STANDARD = "Windows_Server-2022-English-Full-SQL_2019_Standard", WindowsVersion2.WINDOWS_SERVER_2022_JAPANESE_FULL_SQL_2017_WEB = "Windows_Server-2022-Japanese-Full-SQL_2017_Web", WindowsVersion2.WINDOWS_SERVER_2022_ENGLISH_FULL_SQL_2017_WEB = "Windows_Server-2022-English-Full-SQL_2017_Web", WindowsVersion2.WINDOWS_SERVER_2022_JAPANESE_FULL_BASE = "Windows_Server-2022-Japanese-Full-Base", WindowsVersion2.WINDOWS_SERVER_2022_KOREAN_FULL_BASE = "Windows_Server-2022-Korean-Full-Base", WindowsVersion2.WINDOWS_SERVER_2022_JAPANESE_FULL_SQL_2017_ENTERPRISE = "Windows_Server-2022-Japanese-Full-SQL_2017_Enterprise", WindowsVersion2.WINDOWS_SERVER_2022_JAPANESE_FULL_SQL_2019_STANDARD = "Windows_Server-2022-Japanese-Full-SQL_2019_Standard", WindowsVersion2.WINDOWS_SERVER_2022_CHINESE_SIMPLIFIED_FULL_BASE = "Windows_Server-2022-Chinese_Simplified-Full-Base", WindowsVersion2.WINDOWS_SERVER_2022_ENGLISH_FULL_SQL_2019_WEB = "Windows_Server-2022-English-Full-SQL_2019_Web", WindowsVersion2.WINDOWS_SERVER_2022_SPANISH_FULL_BASE = "Windows_Server-2022-Spanish-Full-Base", WindowsVersion2.WINDOWS_SERVER_2022_ENGLISH_CORE_ECS_OPTIMIZED = "Windows_Server-2022-English-Core-ECS_Optimized", WindowsVersion2.WINDOWS_SERVER_2022_ENGLISH_FULL_SQL_2017_STANDARD = "Windows_Server-2022-English-Full-SQL_2017_Standard", WindowsVersion2.WINDOWS_SERVER_2022_CHINESE_TRADITIONAL_FULL_BASE = "Windows_Server-2022-Chinese_Traditional-Full-Base", WindowsVersion2.WINDOWS_SERVER_2022_ENGLISH_FULL_SQL_2019_ENTERPRISE = "Windows_Server-2022-English-Full-SQL_2019_Enterprise", WindowsVersion2.WINDOWS_SERVER_2022_FRENCH_FULL_BASE = "Windows_Server-2022-French-Full-Base", WindowsVersion2.WINDOWS_SERVER_2022_JAPANESE_FULL_SQL_2017_STANDARD = "Windows_Server-2022-Japanese-Full-SQL_2017_Standard", WindowsVersion2.WINDOWS_SERVER_2022_ENGLISH_FULL_BASE = "Windows_Server-2022-English-Full-Base", WindowsVersion2.WINDOWS_SERVER_2022_JAPANESE_FULL_SQL_2019_WEB = "Windows_Server-2022-Japanese-Full-SQL_2019_Web", WindowsVersion2.WINDOWS_SERVER_2022_TURKISH_FULL_BASE = "Windows_Server-2022-Turkish-Full-Base", WindowsVersion2.WINDOWS_SERVER_2022_ENGLISH_FULL_SQL_2017_ENTERPRISE = "Windows_Server-2022-English-Full-SQL_2017_Enterprise", WindowsVersion2.WINDOWS_SERVER_2022_PORTUGUESE_PORTUGAL_FULL_BASE = "Windows_Server-2022-Portuguese_Portugal-Full-Base", WindowsVersion2.WINDOWS_SERVER_2022_CZECH_FULL_BASE = "Windows_Server-2022-Czech-Full-Base", WindowsVersion2.WINDOWS_SERVER_2022_ENGLISH_FULL_ECS_OPTIMIZED = "Windows_Server-2022-English-Full-ECS_Optimized", WindowsVersion2.WINDOWS_SERVER_2022_DUTCH_FULL_BASE = "Windows_Server-2022-Dutch-Full-Base", WindowsVersion2.WINDOWS_SERVER_2022_SWEDISH_FULL_BASE = "Windows_Server-2022-Swedish-Full-Base";
    })(WindowsVersion = exports2.WindowsVersion || (exports2.WindowsVersion = {}));
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/machine-image/machine-image.js
var require_machine_image = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/machine-image/machine-image.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LookupMachineImage = exports2.GenericWindowsImage = exports2.GenericLinuxImage = exports2.AmazonLinuxKernel = exports2.AmazonLinuxImage = exports2.WindowsImage = exports2.GenericSSMParameterImage = exports2.MachineImage = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var amazon_linux_2022_1 = require_amazon_linux_2022();
    var amazon_linux_2023_1 = require_amazon_linux_2023();
    var amazon_linux2_1 = require_amazon_linux2();
    var common_1 = require_common2();
    var utils_1 = require_utils7();
    var ssm = require_aws_ssm();
    var cxschema = require_cloud_assembly_schema2();
    var core_1 = require_core2();
    var user_data_1 = require_user_data();
    var windows_versions_1 = require_windows_versions();
    var MachineImage = class {
      static latestWindows(version, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_WindowsVersion(version), jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_WindowsImageProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.latestWindows), error;
        }
        return new WindowsImage(version, props);
      }
      static latestAmazonLinux2(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_AmazonLinux2ImageSsmParameterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.latestAmazonLinux2), error;
        }
        return new amazon_linux2_1.AmazonLinux2ImageSsmParameter({ cachedInContext: false, ...props, kernel: amazon_linux2_1.AmazonLinux2Kernel.CDK_LATEST });
      }
      static latestAmazonLinux2022(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_AmazonLinux2022ImageSsmParameterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.latestAmazonLinux2022), error;
        }
        return new amazon_linux_2022_1.AmazonLinux2022ImageSsmParameter({ cachedInContext: false, ...props, kernel: amazon_linux_2022_1.AmazonLinux2022Kernel.CDK_LATEST });
      }
      static latestAmazonLinux2023(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_AmazonLinux2023ImageSsmParameterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.latestAmazonLinux2023), error;
        }
        return new amazon_linux_2023_1.AmazonLinux2023ImageSsmParameter({ cachedInContext: false, ...props, kernel: amazon_linux_2023_1.AmazonLinux2023Kernel.CDK_LATEST });
      }
      static latestAmazonLinux(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_ec2.MachineImage#latestAmazonLinux", "use MachineImage.latestAmazonLinux2 instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_AmazonLinuxImageProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.latestAmazonLinux), error;
        }
        return new AmazonLinuxImage(props);
      }
      static genericLinux(amiMap, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_GenericLinuxImageProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.genericLinux), error;
        }
        return new GenericLinuxImage(amiMap, props);
      }
      static genericWindows(amiMap, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_GenericWindowsImageProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.genericWindows), error;
        }
        return new GenericWindowsImage(amiMap, props);
      }
      static fromSSMParameter(parameterName, os, userData) {
        return new GenericSSMParameterImage(parameterName, os, userData);
      }
      static fromSsmParameter(parameterName, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_SsmParameterImageOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromSsmParameter), error;
        }
        return new GenericSsmParameterImage(parameterName, options);
      }
      static lookup(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_LookupMachineImageProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.lookup), error;
        }
        return new LookupMachineImage(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, MachineImage[_a] = { fqn: "aws-cdk-lib.aws_ec2.MachineImage", version: "2.80.0" }, exports2.MachineImage = MachineImage;
    var GenericSSMParameterImage = class _GenericSSMParameterImage {
      constructor(parameterName, os, userData) {
        this.os = os, this.userData = userData;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_OperatingSystemType(os), jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_UserData(userData);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _GenericSSMParameterImage), error;
        }
        this.parameterName = parameterName;
      }
      getImage(scope) {
        return { imageId: ssm.StringParameter.valueForTypedStringParameterV2(scope, this.parameterName, ssm.ParameterValueType.AWS_EC2_IMAGE_ID), osType: this.os, userData: this.userData ?? (this.os === common_1.OperatingSystemType.WINDOWS ? user_data_1.UserData.forWindows() : user_data_1.UserData.forLinux()) };
      }
    };
    _b = JSII_RTTI_SYMBOL_1, GenericSSMParameterImage[_b] = { fqn: "aws-cdk-lib.aws_ec2.GenericSSMParameterImage", version: "2.80.0" }, exports2.GenericSSMParameterImage = GenericSSMParameterImage;
    var GenericSsmParameterImage = class {
      constructor(parameterName, props = {}) {
        this.parameterName = parameterName, this.props = props;
      }
      getImage(scope) {
        const imageId = (0, utils_1.lookupImage)(scope, this.props.cachedInContext, this.parameterName), osType = this.props.os ?? common_1.OperatingSystemType.LINUX;
        return { imageId, osType, userData: this.props.userData ?? (osType === common_1.OperatingSystemType.WINDOWS ? user_data_1.UserData.forWindows() : user_data_1.UserData.forLinux()) };
      }
    };
    var WindowsImage = class _WindowsImage extends GenericSSMParameterImage {
      constructor(version, props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_WindowsVersion(version), jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_WindowsImageProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _WindowsImage), error;
        }
        const nonDeprecatedVersionName = _WindowsImage.DEPRECATED_VERSION_NAME_MAP[version] ?? version;
        super("/aws/service/ami-windows-latest/" + nonDeprecatedVersionName, common_1.OperatingSystemType.WINDOWS, props.userData);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, WindowsImage[_c] = { fqn: "aws-cdk-lib.aws_ec2.WindowsImage", version: "2.80.0" }, WindowsImage.DEPRECATED_VERSION_NAME_MAP = { [windows_versions_1.WindowsVersion.WINDOWS_SERVER_2016_GERMAL_FULL_BASE]: windows_versions_1.WindowsVersion.WINDOWS_SERVER_2016_GERMAN_FULL_BASE, [windows_versions_1.WindowsVersion.WINDOWS_SERVER_2012_R2_SP1_PORTUGESE_BRAZIL_64BIT_CORE]: windows_versions_1.WindowsVersion.WINDOWS_SERVER_2012_R2_SP1_PORTUGUESE_BRAZIL_64BIT_CORE, [windows_versions_1.WindowsVersion.WINDOWS_SERVER_2016_PORTUGESE_PORTUGAL_FULL_BASE]: windows_versions_1.WindowsVersion.WINDOWS_SERVER_2016_PORTUGUESE_PORTUGAL_FULL_BASE, [windows_versions_1.WindowsVersion.WINDOWS_SERVER_2012_R2_RTM_PORTUGESE_BRAZIL_64BIT_BASE]: windows_versions_1.WindowsVersion.WINDOWS_SERVER_2012_R2_RTM_PORTUGUESE_BRAZIL_64BIT_BASE, [windows_versions_1.WindowsVersion.WINDOWS_SERVER_2012_R2_RTM_PORTUGESE_PORTUGAL_64BIT_BASE]: windows_versions_1.WindowsVersion.WINDOWS_SERVER_2012_R2_RTM_PORTUGUESE_PORTUGAL_64BIT_BASE, [windows_versions_1.WindowsVersion.WINDOWS_SERVER_2016_PORTUGESE_BRAZIL_FULL_BASE]: windows_versions_1.WindowsVersion.WINDOWS_SERVER_2016_PORTUGUESE_BRAZIL_FULL_BASE, [windows_versions_1.WindowsVersion.WINDOWS_SERVER_2012_SP2_PORTUGESE_BRAZIL_64BIT_BASE]: windows_versions_1.WindowsVersion.WINDOWS_SERVER_2012_SP2_PORTUGUESE_BRAZIL_64BIT_BASE, [windows_versions_1.WindowsVersion.WINDOWS_SERVER_2012_RTM_PORTUGESE_BRAZIL_64BIT_BASE]: windows_versions_1.WindowsVersion.WINDOWS_SERVER_2012_RTM_PORTUGUESE_BRAZIL_64BIT_BASE, [windows_versions_1.WindowsVersion.WINDOWS_SERVER_2008_R2_SP1_PORTUGESE_BRAZIL_64BIT_BASE]: windows_versions_1.WindowsVersion.WINDOWS_SERVER_2008_R2_SP1_PORTUGUESE_BRAZIL_64BIT_BASE, [windows_versions_1.WindowsVersion.WINDOWS_SERVER_2008_SP2_PORTUGESE_BRAZIL_32BIT_BASE]: windows_versions_1.WindowsVersion.WINDOWS_SERVER_2008_SP2_PORTUGUESE_BRAZIL_32BIT_BASE, [windows_versions_1.WindowsVersion.WINDOWS_SERVER_2012_RTM_PORTUGESE_PORTUGAL_64BIT_BASE]: windows_versions_1.WindowsVersion.WINDOWS_SERVER_2012_RTM_PORTUGUESE_PORTUGAL_64BIT_BASE, [windows_versions_1.WindowsVersion.WINDOWS_SERVER_2019_PORTUGESE_BRAZIL_FULL_BASE]: windows_versions_1.WindowsVersion.WINDOWS_SERVER_2019_PORTUGUESE_BRAZIL_FULL_BASE, [windows_versions_1.WindowsVersion.WINDOWS_SERVER_2019_PORTUGESE_PORTUGAL_FULL_BASE]: windows_versions_1.WindowsVersion.WINDOWS_SERVER_2019_PORTUGUESE_PORTUGAL_FULL_BASE }, exports2.WindowsImage = WindowsImage;
    var AmazonLinuxImage = class _AmazonLinuxImage extends GenericSSMParameterImage {
      static ssmParameterName(props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_AmazonLinuxImageProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.ssmParameterName), error;
        }
        const generation = props && props.generation || common_1.AmazonLinuxGeneration.AMAZON_LINUX, edition = props && props.edition || common_1.AmazonLinuxEdition.STANDARD, cpu = props && props.cpuType || common_1.AmazonLinuxCpuType.X86_64;
        let kernel = props && props.kernel || void 0, virtualization, storage;
        if (generation === common_1.AmazonLinuxGeneration.AMAZON_LINUX_2022) {
          if (kernel = AmazonLinuxKernel.KERNEL5_X, props && props.storage)
            throw new Error("Storage parameter does not exist in smm parameter name for Amazon Linux 2022.");
          if (props && props.virtualization)
            throw new Error("Virtualization parameter does not exist in smm parameter name for Amazon Linux 2022.");
        } else
          virtualization = props && props.virtualization || common_1.AmazonLinuxVirt.HVM, storage = props && props.storage || common_1.AmazonLinuxStorage.GENERAL_PURPOSE;
        return "/aws/service/ami-amazon-linux-latest/" + [generation, "ami", edition !== common_1.AmazonLinuxEdition.STANDARD ? edition : void 0, kernel, virtualization, cpu, storage].filter((x) => x !== void 0).join("-");
      }
      constructor(props = {}) {
        super(_AmazonLinuxImage.ssmParameterName(props), common_1.OperatingSystemType.LINUX, props.userData), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_AmazonLinuxImageProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AmazonLinuxImage), error;
        }
        this.cachedInContext = props.cachedInContext ?? false;
      }
      getImage(scope) {
        const imageId = (0, utils_1.lookupImage)(scope, this.cachedInContext, this.parameterName), osType = common_1.OperatingSystemType.LINUX;
        return { imageId, osType, userData: this.props.userData ?? user_data_1.UserData.forLinux() };
      }
    };
    _d = JSII_RTTI_SYMBOL_1, AmazonLinuxImage[_d] = { fqn: "aws-cdk-lib.aws_ec2.AmazonLinuxImage", version: "2.80.0" }, exports2.AmazonLinuxImage = AmazonLinuxImage;
    var AmazonLinuxKernel;
    (function(AmazonLinuxKernel2) {
      AmazonLinuxKernel2.KERNEL5_X = "kernel-5.10";
    })(AmazonLinuxKernel = exports2.AmazonLinuxKernel || (exports2.AmazonLinuxKernel = {}));
    var GenericLinuxImage = class _GenericLinuxImage {
      constructor(amiMap, props = {}) {
        this.amiMap = amiMap, this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_GenericLinuxImageProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _GenericLinuxImage), error;
        }
      }
      getImage(scope) {
        const userData = this.props.userData ?? user_data_1.UserData.forLinux(), osType = common_1.OperatingSystemType.LINUX, region = core_1.Stack.of(scope).region;
        if (core_1.Token.isUnresolved(region)) {
          const mapping = {};
          for (const [rgn, ami] of Object.entries(this.amiMap))
            mapping[rgn] = { ami };
          return { imageId: new core_1.CfnMapping(scope, "AmiMap", { mapping }).findInMap(core_1.Aws.REGION, "ami"), userData, osType };
        }
        const imageId = region !== "test-region" ? this.amiMap[region] : "ami-12345";
        if (!imageId)
          throw new Error(`Unable to find AMI in AMI map: no AMI specified for region '${region}'`);
        return { imageId, userData, osType };
      }
    };
    _e = JSII_RTTI_SYMBOL_1, GenericLinuxImage[_e] = { fqn: "aws-cdk-lib.aws_ec2.GenericLinuxImage", version: "2.80.0" }, exports2.GenericLinuxImage = GenericLinuxImage;
    var GenericWindowsImage = class _GenericWindowsImage {
      constructor(amiMap, props = {}) {
        this.amiMap = amiMap, this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_GenericWindowsImageProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _GenericWindowsImage), error;
        }
      }
      getImage(scope) {
        const userData = this.props.userData ?? user_data_1.UserData.forWindows(), osType = common_1.OperatingSystemType.WINDOWS, region = core_1.Stack.of(scope).region;
        if (core_1.Token.isUnresolved(region)) {
          const mapping = {};
          for (const [rgn, ami] of Object.entries(this.amiMap))
            mapping[rgn] = { ami };
          return { imageId: new core_1.CfnMapping(scope, "AmiMap", { mapping }).findInMap(core_1.Aws.REGION, "ami"), userData, osType };
        }
        const imageId = region !== "test-region" ? this.amiMap[region] : "ami-12345";
        if (!imageId)
          throw new Error(`Unable to find AMI in AMI map: no AMI specified for region '${region}'`);
        return { imageId, userData, osType };
      }
    };
    _f = JSII_RTTI_SYMBOL_1, GenericWindowsImage[_f] = { fqn: "aws-cdk-lib.aws_ec2.GenericWindowsImage", version: "2.80.0" }, exports2.GenericWindowsImage = GenericWindowsImage;
    var LookupMachineImage = class _LookupMachineImage {
      constructor(props) {
        this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_LookupMachineImageProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _LookupMachineImage), error;
        }
      }
      getImage(scope) {
        const filters = { name: [this.props.name], state: ["available"], "image-type": ["machine"], platform: this.props.windows ? ["windows"] : void 0 };
        Object.assign(filters, this.props.filters);
        const value = core_1.ContextProvider.getValue(scope, { provider: cxschema.ContextProvider.AMI_PROVIDER, props: { owners: this.props.owners, filters }, dummyValue: "ami-1234" }).value;
        if (typeof value != "string")
          throw new Error(`Response to AMI lookup invalid, got: ${value}`);
        const osType = this.props.windows ? common_1.OperatingSystemType.WINDOWS : common_1.OperatingSystemType.LINUX;
        return { imageId: value, osType, userData: this.props.userData ?? user_data_1.UserData.forOperatingSystem(osType) };
      }
    };
    _g = JSII_RTTI_SYMBOL_1, LookupMachineImage[_g] = { fqn: "aws-cdk-lib.aws_ec2.LookupMachineImage", version: "2.80.0" }, exports2.LookupMachineImage = LookupMachineImage;
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/machine-image/index.js
var require_machine_image2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/machine-image/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_common2(), exports2), __exportStar(require_amazon_linux2(), exports2), __exportStar(require_machine_image(), exports2), __exportStar(require_amazon_linux_2022(), exports2), __exportStar(require_amazon_linux_2023(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/nat.js
var require_nat = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/nat.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.NatInstanceImage = exports2.NatInstanceProvider = exports2.NatProvider = exports2.NatTrafficDirection = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var connections_1 = require_connections();
    var instance_1 = require_instance();
    var machine_image_1 = require_machine_image2();
    var port_1 = require_port();
    var security_group_1 = require_security_group2();
    var vpc_1 = require_vpc2();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var NatTrafficDirection;
    (function(NatTrafficDirection2) {
      NatTrafficDirection2.OUTBOUND_ONLY = "OUTBOUND_ONLY", NatTrafficDirection2.INBOUND_AND_OUTBOUND = "INBOUND_AND_OUTBOUND", NatTrafficDirection2.NONE = "NONE";
    })(NatTrafficDirection = exports2.NatTrafficDirection || (exports2.NatTrafficDirection = {}));
    var NatProvider = class {
      static gateway(props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_NatGatewayProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.gateway), error;
        }
        return new NatGatewayProvider(props);
      }
      static instance(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_NatInstanceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.instance), error;
        }
        return new NatInstanceProvider(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, NatProvider[_a] = { fqn: "aws-cdk-lib.aws_ec2.NatProvider", version: "2.80.0" }, exports2.NatProvider = NatProvider;
    var NatGatewayProvider = class extends NatProvider {
      constructor(props = {}) {
        super(), this.props = props, this.gateways = new PrefSet();
      }
      configureNat(options) {
        if (this.props.eipAllocationIds != null && !core_1.Token.isUnresolved(this.props.eipAllocationIds) && this.props.eipAllocationIds.length < options.natSubnets.length)
          throw new Error(`Not enough NAT gateway EIP allocation IDs (${this.props.eipAllocationIds.length} provided) for the requested subnet count (${options.natSubnets.length} needed).`);
        let i = 0;
        for (const sub of options.natSubnets) {
          const eipAllocationId = this.props.eipAllocationIds ? pickN(i, this.props.eipAllocationIds) : void 0, gateway = sub.addNatGateway(eipAllocationId);
          this.gateways.add(sub.availabilityZone, gateway.ref), i++;
        }
        for (const sub of options.privateSubnets)
          this.configureSubnet(sub);
      }
      configureSubnet(subnet) {
        const az = subnet.availabilityZone, gatewayId = this.gateways.pick(az);
        subnet.addRoute("DefaultRoute", { routerType: vpc_1.RouterType.NAT_GATEWAY, routerId: gatewayId, enablesInternetConnectivity: true });
      }
      get configuredGateways() {
        return this.gateways.values().map((x) => ({ az: x[0], gatewayId: x[1] }));
      }
    };
    var NatInstanceProvider = class _NatInstanceProvider extends NatProvider {
      constructor(props) {
        super(), this.props = props, this.gateways = new PrefSet();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_NatInstanceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _NatInstanceProvider), error;
        }
        if (props.defaultAllowedTraffic !== void 0 && props.allowAllTraffic !== void 0)
          throw new Error("Can not specify both of 'defaultAllowedTraffic' and 'defaultAllowedTraffic'; prefer 'defaultAllowedTraffic'");
      }
      configureNat(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_ConfigureNatOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.configureNat), error;
        }
        const defaultDirection = this.props.defaultAllowedTraffic ?? (this.props.allowAllTraffic ?? true ? NatTrafficDirection.INBOUND_AND_OUTBOUND : NatTrafficDirection.OUTBOUND_ONLY), machineImage = this.props.machineImage || new NatInstanceImage();
        this._securityGroup = this.props.securityGroup ?? new security_group_1.SecurityGroup(options.vpc, "NatSecurityGroup", { vpc: options.vpc, description: "Security Group for NAT instances", allowAllOutbound: isOutboundAllowed(defaultDirection) }), this._connections = new connections_1.Connections({ securityGroups: [this._securityGroup] }), isInboundAllowed(defaultDirection) && this.connections.allowFromAnyIpv4(port_1.Port.allTraffic());
        const role = new iam.Role(options.vpc, "NatRole", { assumedBy: new iam.ServicePrincipal("ec2.amazonaws.com") });
        for (const sub of options.natSubnets) {
          const natInstance = new instance_1.Instance(sub, "NatInstance", { instanceType: this.props.instanceType, machineImage, sourceDestCheck: false, vpc: options.vpc, vpcSubnets: { subnets: [sub] }, securityGroup: this._securityGroup, role, keyName: this.props.keyName });
          this.gateways.add(sub.availabilityZone, natInstance);
        }
        for (const sub of options.privateSubnets)
          this.configureSubnet(sub);
      }
      get securityGroup() {
        if (!this._securityGroup)
          throw new Error("Pass the NatInstanceProvider to a Vpc before accessing 'securityGroup'");
        return this._securityGroup;
      }
      get connections() {
        if (!this._connections)
          throw new Error("Pass the NatInstanceProvider to a Vpc before accessing 'connections'");
        return this._connections;
      }
      get configuredGateways() {
        return this.gateways.values().map((x) => ({ az: x[0], gatewayId: x[1].instanceId }));
      }
      configureSubnet(subnet) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_PrivateSubnet(subnet);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.configureSubnet), error;
        }
        const az = subnet.availabilityZone, gatewayId = this.gateways.pick(az).instanceId;
        subnet.addRoute("DefaultRoute", { routerType: vpc_1.RouterType.INSTANCE, routerId: gatewayId, enablesInternetConnectivity: true });
      }
    };
    _b = JSII_RTTI_SYMBOL_1, NatInstanceProvider[_b] = { fqn: "aws-cdk-lib.aws_ec2.NatInstanceProvider", version: "2.80.0" }, exports2.NatInstanceProvider = NatInstanceProvider;
    var PrefSet = class {
      constructor() {
        this.map = {}, this.vals = new Array(), this.next = 0;
      }
      add(pref, value) {
        this.map[pref] = value, this.vals.push([pref, value]);
      }
      pick(pref) {
        if (this.vals.length === 0)
          throw new Error("Cannot pick, set is empty");
        return pref in this.map ? this.map[pref] : this.vals[this.next++ % this.vals.length][1];
      }
      values() {
        return this.vals;
      }
    };
    var NatInstanceImage = class extends machine_image_1.LookupMachineImage {
      constructor() {
        super({ name: "amzn-ami-vpc-nat-*", owners: ["amazon"] });
      }
    };
    _c = JSII_RTTI_SYMBOL_1, NatInstanceImage[_c] = { fqn: "aws-cdk-lib.aws_ec2.NatInstanceImage", version: "2.80.0" }, exports2.NatInstanceImage = NatInstanceImage;
    function isOutboundAllowed(direction) {
      return direction === NatTrafficDirection.INBOUND_AND_OUTBOUND || direction === NatTrafficDirection.OUTBOUND_ONLY;
    }
    function isInboundAllowed(direction) {
      return direction === NatTrafficDirection.INBOUND_AND_OUTBOUND;
    }
    function pickN(i, xs) {
      if (core_1.Token.isUnresolved(xs))
        return core_1.Fn.select(i, xs);
      if (i >= xs.length)
        throw new Error(`Cannot get element ${i} from ${xs}`);
      return xs[i];
    }
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/network-acl.js
var require_network_acl = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/network-acl.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SubnetNetworkAclAssociation = exports2.NetworkAclEntry = exports2.TrafficDirection = exports2.Action = exports2.NetworkAcl = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var ec2_generated_1 = require_ec2_generated();
    var core_1 = require_core2();
    var NetworkAclBase = class extends core_1.Resource {
      addEntry(id, options) {
        return new NetworkAclEntry(this, id, { networkAcl: this, ...options });
      }
    };
    var NetworkAcl = class _NetworkAcl extends NetworkAclBase {
      static fromNetworkAclId(scope, id, networkAclId) {
        class Import extends NetworkAclBase {
          constructor() {
            super(...arguments), this.networkAclId = networkAclId;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.networkAclName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_NetworkAclProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _NetworkAcl), error;
        }
        this.vpc = props.vpc, this.networkAcl = new ec2_generated_1.CfnNetworkAcl(this, "Resource", { vpcId: props.vpc.vpcId }), this.networkAclId = this.networkAcl.ref, this.networkAclVpcId = this.networkAcl.vpcId, props.subnetSelection !== void 0 && this.associateWithSubnet("DefaultAssociation", props.subnetSelection);
      }
      associateWithSubnet(id, selection) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_SubnetSelection(selection);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.associateWithSubnet), error;
        }
        const subnets = this.vpc.selectSubnets(selection);
        for (const subnet of subnets.subnets)
          subnet.associateNetworkAcl(id, this);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, NetworkAcl[_a] = { fqn: "aws-cdk-lib.aws_ec2.NetworkAcl", version: "2.80.0" }, exports2.NetworkAcl = NetworkAcl;
    var Action;
    (function(Action2) {
      Action2.ALLOW = "allow", Action2.DENY = "deny";
    })(Action = exports2.Action || (exports2.Action = {}));
    var NetworkAclEntryBase = class extends core_1.Resource {
    };
    var TrafficDirection;
    (function(TrafficDirection2) {
      TrafficDirection2[TrafficDirection2.EGRESS = 0] = "EGRESS", TrafficDirection2[TrafficDirection2.INGRESS = 1] = "INGRESS";
    })(TrafficDirection = exports2.TrafficDirection || (exports2.TrafficDirection = {}));
    var NetworkAclEntry = class _NetworkAclEntry extends NetworkAclEntryBase {
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.networkAclEntryName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_NetworkAclEntryProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _NetworkAclEntry), error;
        }
        this.networkAcl = props.networkAcl, new ec2_generated_1.CfnNetworkAclEntry(this, "Resource", { networkAclId: this.networkAcl.networkAclId, ruleNumber: props.ruleNumber, ruleAction: props.ruleAction ?? Action.ALLOW, egress: props.direction !== void 0 ? props.direction === TrafficDirection.EGRESS : void 0, ...props.traffic.toTrafficConfig(), ...props.cidr.toCidrConfig() });
      }
    };
    _b = JSII_RTTI_SYMBOL_1, NetworkAclEntry[_b] = { fqn: "aws-cdk-lib.aws_ec2.NetworkAclEntry", version: "2.80.0" }, exports2.NetworkAclEntry = NetworkAclEntry;
    var SubnetNetworkAclAssociationBase = class extends core_1.Resource {
    };
    var SubnetNetworkAclAssociation = class _SubnetNetworkAclAssociation extends SubnetNetworkAclAssociationBase {
      static fromSubnetNetworkAclAssociationAssociationId(scope, id, subnetNetworkAclAssociationAssociationId) {
        class Import extends SubnetNetworkAclAssociationBase {
          constructor() {
            super(...arguments), this.subnetNetworkAclAssociationAssociationId = subnetNetworkAclAssociationAssociationId;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.subnetNetworkAclAssociationName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_SubnetNetworkAclAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SubnetNetworkAclAssociation), error;
        }
        this.association = new ec2_generated_1.CfnSubnetNetworkAclAssociation(this, "Resource", { networkAclId: props.networkAcl.networkAclId, subnetId: props.subnet.subnetId }), this.networkAcl = props.networkAcl, this.subnet = props.subnet, this.subnetNetworkAclAssociationAssociationId = this.association.attrAssociationId;
      }
    };
    _c = JSII_RTTI_SYMBOL_1, SubnetNetworkAclAssociation[_c] = { fqn: "aws-cdk-lib.aws_ec2.SubnetNetworkAclAssociation", version: "2.80.0" }, exports2.SubnetNetworkAclAssociation = SubnetNetworkAclAssociation;
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/subnet.js
var require_subnet = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/subnet.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SubnetFilter = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var network_util_1 = require_network_util();
    var core_1 = require_core2();
    var SubnetFilter = class {
      static byIds(subnetIds) {
        return new SubnetIdSubnetFilter(subnetIds);
      }
      static availabilityZones(availabilityZones) {
        return new AvailabilityZoneSubnetFilter(availabilityZones);
      }
      static onePerAz() {
        return new OnePerAZSubnetFilter();
      }
      static containsIpAddresses(ipv4addrs) {
        return new ContainsIpAddressesSubnetFilter(ipv4addrs);
      }
      static byCidrMask(mask) {
        return new CidrMaskSubnetFilter(mask);
      }
      selectSubnets(_subnets) {
        throw new Error("Cannot select subnets with an abstract SubnetFilter. `selectSubnets` needs to be implmemented.");
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SubnetFilter[_a] = { fqn: "aws-cdk-lib.aws_ec2.SubnetFilter", version: "2.80.0" }, exports2.SubnetFilter = SubnetFilter;
    var AvailabilityZoneSubnetFilter = class extends SubnetFilter {
      constructor(availabilityZones) {
        super(), this.availabilityZones = availabilityZones;
      }
      selectSubnets(subnets) {
        return subnets.filter((s) => this.availabilityZones.includes(s.availabilityZone));
      }
    };
    var OnePerAZSubnetFilter = class extends SubnetFilter {
      constructor() {
        super();
      }
      selectSubnets(subnets) {
        return this.retainOnePerAz(subnets);
      }
      retainOnePerAz(subnets) {
        const azsSeen = /* @__PURE__ */ new Set();
        return subnets.filter((subnet) => azsSeen.has(subnet.availabilityZone) ? false : (azsSeen.add(subnet.availabilityZone), true));
      }
    };
    var ContainsIpAddressesSubnetFilter = class extends SubnetFilter {
      constructor(ipAddresses) {
        super(), this.ipAddresses = ipAddresses;
      }
      selectSubnets(subnets) {
        return this.retainByIp(subnets, this.ipAddresses);
      }
      retainByIp(subnets, ips) {
        const cidrBlockObjs = ips.map((ip) => {
          const ipNum = network_util_1.NetworkUtils.ipToNum(ip);
          return new network_util_1.CidrBlock(ipNum, 32);
        });
        return subnets.filter((s) => {
          const subnetCidrBlock = new network_util_1.CidrBlock(s.ipv4CidrBlock);
          return cidrBlockObjs.some((cidr) => subnetCidrBlock.containsCidr(cidr));
        });
      }
    };
    var SubnetIdSubnetFilter = class extends SubnetFilter {
      constructor(subnetIds) {
        super(), this.subnetIds = subnetIds;
      }
      selectSubnets(subnets) {
        return subnets.filter((subnet) => this.subnetIds.includes(core_1.Token.asString(subnet.subnetId)));
      }
    };
    var CidrMaskSubnetFilter = class extends SubnetFilter {
      constructor(mask) {
        super(), this.mask = mask;
      }
      selectSubnets(subnets) {
        return subnets.filter((subnet) => new network_util_1.CidrBlock(subnet.ipv4CidrBlock).mask === this.mask);
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/util.js
var require_util9 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/util.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.flatten = exports2.allRouteTableIds = exports2.range = exports2.ImportSubnetGroup = exports2.subnetId = exports2.subnetGroupNameFromConstructId = exports2.defaultSubnetName = exports2.slugify = void 0;
    var vpc_1 = require_vpc2();
    function slugify(x) {
      return x.replace(/[^a-zA-Z0-9]/g, "");
    }
    exports2.slugify = slugify;
    function defaultSubnetName(type) {
      switch (type) {
        case vpc_1.SubnetType.PUBLIC:
          return "Public";
        case vpc_1.SubnetType.PRIVATE_WITH_NAT:
        case vpc_1.SubnetType.PRIVATE_WITH_EGRESS:
        case vpc_1.SubnetType.PRIVATE:
          return "Private";
        case vpc_1.SubnetType.PRIVATE_ISOLATED:
        case vpc_1.SubnetType.ISOLATED:
          return "Isolated";
      }
    }
    exports2.defaultSubnetName = defaultSubnetName;
    function subnetGroupNameFromConstructId(subnet) {
      return subnet.node.id.replace(/Subnet\d+$/, "");
    }
    exports2.subnetGroupNameFromConstructId = subnetGroupNameFromConstructId;
    function subnetId(name, i) {
      return `${name}Subnet${i + 1}`;
    }
    exports2.subnetId = subnetId;
    var ImportSubnetGroup = class {
      constructor(subnetIds, names, routeTableIds, ipv4CidrBlocks, type, availabilityZones, idField, nameField, routeTableIdField, ipv4CidrBlockField) {
        if (this.availabilityZones = availabilityZones, this.subnetIds = subnetIds || [], this.routeTableIds = routeTableIds || [], this.ipv4CidrBlocks = ipv4CidrBlocks || [], this.groups = this.subnetIds.length / this.availabilityZones.length, Math.floor(this.groups) !== this.groups)
          throw new Error(`Number of ${idField} (${this.subnetIds.length}) must be a multiple of availability zones (${this.availabilityZones.length}).`);
        if (this.routeTableIds.length !== this.subnetIds.length && routeTableIds != null)
          throw new Error(`Number of ${routeTableIdField} (${this.routeTableIds.length}) must be equal to the amount of ${idField} (${this.subnetIds.length}).`);
        if (this.ipv4CidrBlocks.length !== this.subnetIds.length && ipv4CidrBlocks != null)
          throw new Error(`Number of ${ipv4CidrBlockField} (${this.ipv4CidrBlocks.length}) must be equal to the amount of ${idField} (${this.subnetIds.length}).`);
        this.names = this.normalizeNames(names, defaultSubnetName(type), nameField);
      }
      import(scope) {
        return range(this.subnetIds.length).map((i) => {
          const k = Math.floor(i / this.availabilityZones.length);
          return vpc_1.Subnet.fromSubnetAttributes(scope, subnetId(this.names[k], i), { availabilityZone: this.pickAZ(i), subnetId: this.subnetIds[i], routeTableId: this.routeTableIds[i], ipv4CidrBlock: this.ipv4CidrBlocks[i] });
        });
      }
      normalizeNames(names, defaultName, fieldName) {
        if (names === void 0 || names.length === 0)
          return [defaultName];
        if (names.length !== this.groups)
          throw new Error(`${fieldName} must have an entry for every corresponding subnet group, got: ${JSON.stringify(names)}`);
        return names;
      }
      pickAZ(i) {
        return this.availabilityZones[i % this.availabilityZones.length];
      }
    };
    exports2.ImportSubnetGroup = ImportSubnetGroup;
    function range(n) {
      const ret = [];
      for (let i = 0; i < n; i++)
        ret.push(i);
      return ret;
    }
    exports2.range = range;
    function allRouteTableIds(subnets) {
      const ret = /* @__PURE__ */ new Set();
      for (const subnet of subnets)
        subnet.routeTable && subnet.routeTable.routeTableId && ret.add(subnet.routeTable.routeTableId);
      return Array.from(ret);
    }
    exports2.allRouteTableIds = allRouteTableIds;
    function flatten(xs) {
      return Array.prototype.concat.apply([], xs);
    }
    exports2.flatten = flatten;
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/vpc-endpoint.js
var require_vpc_endpoint = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/vpc-endpoint.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.InterfaceVpcEndpoint = exports2.InterfaceVpcEndpointAwsService = exports2.InterfaceVpcEndpointService = exports2.GatewayVpcEndpoint = exports2.GatewayVpcEndpointAwsService = exports2.VpcEndpointType = exports2.VpcEndpoint = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var connections_1 = require_connections();
    var ec2_generated_1 = require_ec2_generated();
    var peer_1 = require_peer();
    var port_1 = require_port();
    var security_group_1 = require_security_group2();
    var util_1 = require_util9();
    var iam = require_aws_iam();
    var cxschema = require_cloud_assembly_schema2();
    var core_1 = require_core2();
    var VpcEndpoint = class extends core_1.Resource {
      addToPolicy(statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToPolicy), error;
        }
        if (!statement.hasPrincipal)
          throw new Error("Statement must have a `Principal`.");
        this.policyDocument || (this.policyDocument = new iam.PolicyDocument()), this.policyDocument.addStatements(statement);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, VpcEndpoint[_a] = { fqn: "aws-cdk-lib.aws_ec2.VpcEndpoint", version: "2.80.0" }, exports2.VpcEndpoint = VpcEndpoint;
    var VpcEndpointType;
    (function(VpcEndpointType2) {
      VpcEndpointType2.INTERFACE = "Interface", VpcEndpointType2.GATEWAY = "Gateway";
    })(VpcEndpointType = exports2.VpcEndpointType || (exports2.VpcEndpointType = {}));
    var GatewayVpcEndpointAwsService = class {
      constructor(name, prefix) {
        this.name = `${prefix || "com.amazonaws"}.${core_1.Aws.REGION}.${name}`;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, GatewayVpcEndpointAwsService[_b] = { fqn: "aws-cdk-lib.aws_ec2.GatewayVpcEndpointAwsService", version: "2.80.0" }, GatewayVpcEndpointAwsService.DYNAMODB = new GatewayVpcEndpointAwsService("dynamodb"), GatewayVpcEndpointAwsService.S3 = new GatewayVpcEndpointAwsService("s3"), exports2.GatewayVpcEndpointAwsService = GatewayVpcEndpointAwsService;
    var GatewayVpcEndpoint = class _GatewayVpcEndpoint extends VpcEndpoint {
      static fromGatewayVpcEndpointId(scope, id, gatewayVpcEndpointId) {
        class Import extends VpcEndpoint {
          constructor() {
            super(...arguments), this.vpcEndpointId = gatewayVpcEndpointId;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_GatewayVpcEndpointProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _GatewayVpcEndpoint), error;
        }
        const subnets = props.subnets ? (0, util_1.flatten)(props.subnets.map((s) => props.vpc.selectSubnets(s).subnets)) : [...props.vpc.privateSubnets, ...props.vpc.publicSubnets, ...props.vpc.isolatedSubnets], routeTableIds = (0, util_1.allRouteTableIds)(subnets);
        if (routeTableIds.length === 0)
          throw new Error("Can't add a gateway endpoint to VPC; route table IDs are not available");
        const endpoint = new ec2_generated_1.CfnVPCEndpoint(this, "Resource", { policyDocument: core_1.Lazy.any({ produce: () => this.policyDocument }), routeTableIds, serviceName: props.service.name, vpcEndpointType: VpcEndpointType.GATEWAY, vpcId: props.vpc.vpcId });
        this.vpcEndpointId = endpoint.ref, this.vpcEndpointCreationTimestamp = endpoint.attrCreationTimestamp, this.vpcEndpointDnsEntries = endpoint.attrDnsEntries, this.vpcEndpointNetworkInterfaceIds = endpoint.attrNetworkInterfaceIds;
      }
    };
    _c = JSII_RTTI_SYMBOL_1, GatewayVpcEndpoint[_c] = { fqn: "aws-cdk-lib.aws_ec2.GatewayVpcEndpoint", version: "2.80.0" }, exports2.GatewayVpcEndpoint = GatewayVpcEndpoint;
    var InterfaceVpcEndpointService = class {
      constructor(name, port) {
        this.privateDnsDefault = false, this.name = name, this.port = port || 443;
      }
    };
    _d = JSII_RTTI_SYMBOL_1, InterfaceVpcEndpointService[_d] = { fqn: "aws-cdk-lib.aws_ec2.InterfaceVpcEndpointService", version: "2.80.0" }, exports2.InterfaceVpcEndpointService = InterfaceVpcEndpointService;
    var InterfaceVpcEndpointAwsService = class {
      constructor(name, prefix, port) {
        this.privateDnsDefault = true;
        const region = core_1.Lazy.uncachedString({ produce: (context) => core_1.Stack.of(context.scope).region }), defaultEndpointPrefix = core_1.Lazy.uncachedString({ produce: (context) => {
          const regionName = core_1.Stack.of(context.scope).region;
          return this.getDefaultEndpointPrefix(name, regionName);
        } }), defaultEndpointSuffix = core_1.Lazy.uncachedString({ produce: (context) => {
          const regionName = core_1.Stack.of(context.scope).region;
          return this.getDefaultEndpointSuffix(name, regionName);
        } });
        this.name = `${prefix || defaultEndpointPrefix}.${region}.${name}${defaultEndpointSuffix}`, this.shortName = name, this.port = port || 443;
      }
      getDefaultEndpointPrefix(name, region) {
        return { "cn-north-1": ["application-autoscaling", "appmesh-envoy-management", "athena", "autoscaling", "awsconnector", "backup", "batch", "cassandra", "cloudcontrolapi", "cloudformation", "codedeploy-commands-secure", "databrew", "dms", "ebs", "ec2", "ecr.api", "ecr.dkr", "eks", "elasticache", "elasticbeanstalk", "elasticfilesystem", "elasticfilesystem-fips", "emr-containers", "execute-api", "fsx", "imagebuilder", "iot.data", "iotsitewise.api", "iotsitewise.data", "kinesis-streams", "lambda", "license-manager", "monitoring", "rds", "redshift", "redshift-data", "s3", "sagemaker.api", "sagemaker.featurestore-runtime", "sagemaker.runtime", "securityhub", "servicecatalog", "sms", "sqs", "states", "sts", "sync-states", "synthetics", "transcribe", "transcribestreaming", "transfer", "xray"], "cn-northwest-1": ["account", "application-autoscaling", "appmesh-envoy-management", "athena", "autoscaling", "awsconnector", "backup", "batch", "cassandra", "cloudcontrolapi", "cloudformation", "codedeploy-commands-secure", "databrew", "dms", "ebs", "ec2", "ecr.api", "ecr.dkr", "eks", "elasticache", "elasticbeanstalk", "elasticfilesystem", "elasticfilesystem-fips", "emr-containers", "execute-api", "fsx", "imagebuilder", "iot.data", "kinesis-streams", "lambda", "license-manager", "monitoring", "polly", "rds", "redshift", "redshift-data", "s3", "sagemaker.api", "sagemaker.featurestore-runtime", "sagemaker.runtime", "securityhub", "servicecatalog", "sms", "sqs", "states", "sts", "sync-states", "synthetics", "transcribe", "transcribestreaming", "transfer", "workspaces", "xray"] }[region]?.includes(name) ? "cn.com.amazonaws" : "com.amazonaws";
      }
      getDefaultEndpointSuffix(name, region) {
        return { "cn-north-1": ["transcribe"], "cn-northwest-1": ["transcribe"] }[region]?.includes(name) ? ".cn" : "";
      }
    };
    _e = JSII_RTTI_SYMBOL_1, InterfaceVpcEndpointAwsService[_e] = { fqn: "aws-cdk-lib.aws_ec2.InterfaceVpcEndpointAwsService", version: "2.80.0" }, InterfaceVpcEndpointAwsService.SAGEMAKER_STUDIO = new InterfaceVpcEndpointAwsService("studio", "aws.sagemaker"), InterfaceVpcEndpointAwsService.SAGEMAKER_NOTEBOOK = new InterfaceVpcEndpointAwsService("notebook", "aws.sagemaker"), InterfaceVpcEndpointAwsService.KENDRA_RANKING = new InterfaceVpcEndpointAwsService("kendra-ranking", "aws.api"), InterfaceVpcEndpointAwsService.ACCESS_ANALYZER = new InterfaceVpcEndpointAwsService("access-analyzer"), InterfaceVpcEndpointAwsService.ACCOUNT_MANAGEMENT = new InterfaceVpcEndpointAwsService("account"), InterfaceVpcEndpointAwsService.APP_MESH = new InterfaceVpcEndpointAwsService("appmesh-envoy-management"), InterfaceVpcEndpointAwsService.APP_RUNNER = new InterfaceVpcEndpointAwsService("apprunner"), InterfaceVpcEndpointAwsService.APP_RUNNER_REQUESTS = new InterfaceVpcEndpointAwsService("apprunner.requests"), InterfaceVpcEndpointAwsService.APPLICATION_MIGRATION_SERVICE = new InterfaceVpcEndpointAwsService("mgn"), InterfaceVpcEndpointAwsService.APPSTREAM_API = new InterfaceVpcEndpointAwsService("appstream.api"), InterfaceVpcEndpointAwsService.APPSTREAM_STREAMING = new InterfaceVpcEndpointAwsService("appstream.streaming"), InterfaceVpcEndpointAwsService.ATHENA = new InterfaceVpcEndpointAwsService("athena"), InterfaceVpcEndpointAwsService.AUDIT_MANAGER = new InterfaceVpcEndpointAwsService("auditmanager"), InterfaceVpcEndpointAwsService.APPLICATION_AUTOSCALING = new InterfaceVpcEndpointAwsService("application-autoscaling"), InterfaceVpcEndpointAwsService.AUTOSCALING = new InterfaceVpcEndpointAwsService("autoscaling"), InterfaceVpcEndpointAwsService.AUTOSCALING_PLANS = new InterfaceVpcEndpointAwsService("autoscaling-plans"), InterfaceVpcEndpointAwsService.BACKUP = new InterfaceVpcEndpointAwsService("backup"), InterfaceVpcEndpointAwsService.BACKUP_GATEWAY = new InterfaceVpcEndpointAwsService("backup-gateway"), InterfaceVpcEndpointAwsService.BATCH = new InterfaceVpcEndpointAwsService("batch"), InterfaceVpcEndpointAwsService.BILLING_CONDUCTOR = new InterfaceVpcEndpointAwsService("billingconductor"), InterfaceVpcEndpointAwsService.BRAKET = new InterfaceVpcEndpointAwsService("braket"), InterfaceVpcEndpointAwsService.PRIVATE_CERTIFICATE_AUTHORITY = new InterfaceVpcEndpointAwsService("acm-pca"), InterfaceVpcEndpointAwsService.CLOUD_CONTROL_API = new InterfaceVpcEndpointAwsService("cloudcontrolapi"), InterfaceVpcEndpointAwsService.CLOUD_CONTROL_API_FIPS = new InterfaceVpcEndpointAwsService("cloudcontrolapi-fips"), InterfaceVpcEndpointAwsService.CLOUD_DIRECTORY = new InterfaceVpcEndpointAwsService("clouddirectory"), InterfaceVpcEndpointAwsService.CLOUDFORMATION = new InterfaceVpcEndpointAwsService("cloudformation"), InterfaceVpcEndpointAwsService.CLOUDHSM = new InterfaceVpcEndpointAwsService("cloudhsmv2"), InterfaceVpcEndpointAwsService.CLOUDTRAIL = new InterfaceVpcEndpointAwsService("cloudtrail"), InterfaceVpcEndpointAwsService.CLOUDWATCH_EVIDENTLY = new InterfaceVpcEndpointAwsService("evidently"), InterfaceVpcEndpointAwsService.CLOUDWATCH_EVIDENTLY_DATAPLANE = new InterfaceVpcEndpointAwsService("evidently-dataplane"), InterfaceVpcEndpointAwsService.CLOUDWATCH_MONITORING = new InterfaceVpcEndpointAwsService("monitoring"), InterfaceVpcEndpointAwsService.CLOUDWATCH_RUM = new InterfaceVpcEndpointAwsService("rum"), InterfaceVpcEndpointAwsService.CLOUDWATCH_RUM_DATAPLANE = new InterfaceVpcEndpointAwsService("rum-dataplane"), InterfaceVpcEndpointAwsService.CLOUDWATCH_SYNTHETICS = new InterfaceVpcEndpointAwsService("synthetics"), InterfaceVpcEndpointAwsService.CODEARTIFACT_API = new InterfaceVpcEndpointAwsService("codeartifact.api"), InterfaceVpcEndpointAwsService.CODEARTIFACT_REPOSITORIES = new InterfaceVpcEndpointAwsService("codeartifact.repositories"), InterfaceVpcEndpointAwsService.CODEBUILD = new InterfaceVpcEndpointAwsService("codebuild"), InterfaceVpcEndpointAwsService.CODEBUILD_FIPS = new InterfaceVpcEndpointAwsService("codebuild-fips"), InterfaceVpcEndpointAwsService.CODECOMMIT = new InterfaceVpcEndpointAwsService("codecommit"), InterfaceVpcEndpointAwsService.CODECOMMIT_FIPS = new InterfaceVpcEndpointAwsService("codecommit-fips"), InterfaceVpcEndpointAwsService.CODEDEPLOY = new InterfaceVpcEndpointAwsService("codedeploy"), InterfaceVpcEndpointAwsService.CODEDEPLOY_COMMANDS_SECURE = new InterfaceVpcEndpointAwsService("codedeploy-commands-secure"), InterfaceVpcEndpointAwsService.CODEGURU_PROFILER = new InterfaceVpcEndpointAwsService("codeguru-profiler"), InterfaceVpcEndpointAwsService.CODEGURU_REVIEWER = new InterfaceVpcEndpointAwsService("codeguru-reviewer"), InterfaceVpcEndpointAwsService.CODEPIPELINE = new InterfaceVpcEndpointAwsService("codepipeline"), InterfaceVpcEndpointAwsService.CODESTAR_CONNECTIONS = new InterfaceVpcEndpointAwsService("codestar-connections.api"), InterfaceVpcEndpointAwsService.COMPREHEND = new InterfaceVpcEndpointAwsService("comprehend"), InterfaceVpcEndpointAwsService.COMPREHEND_MEDICAL = new InterfaceVpcEndpointAwsService("comprehendmedical"), InterfaceVpcEndpointAwsService.CONFIG = new InterfaceVpcEndpointAwsService("config"), InterfaceVpcEndpointAwsService.CONNECT_APP_INTEGRATIONS = new InterfaceVpcEndpointAwsService("app-integrations"), InterfaceVpcEndpointAwsService.CONNECT_CASES = new InterfaceVpcEndpointAwsService("cases"), InterfaceVpcEndpointAwsService.CONNECT_CONNECT_CAMPAIGNS = new InterfaceVpcEndpointAwsService("connect-campaigns"), InterfaceVpcEndpointAwsService.CONNECT_PROFILE = new InterfaceVpcEndpointAwsService("profile"), InterfaceVpcEndpointAwsService.CONNECT_VOICEID = new InterfaceVpcEndpointAwsService("voiceid"), InterfaceVpcEndpointAwsService.CONNECT_WISDOM = new InterfaceVpcEndpointAwsService("wisdom"), InterfaceVpcEndpointAwsService.DATA_EXCHANGE = new InterfaceVpcEndpointAwsService("dataexchange"), InterfaceVpcEndpointAwsService.DATABASE_MIGRATION_SERVICE = new InterfaceVpcEndpointAwsService("dms"), InterfaceVpcEndpointAwsService.DATABASE_MIGRATION_SERVICE_FIPS = new InterfaceVpcEndpointAwsService("dms-fips"), InterfaceVpcEndpointAwsService.DATASYNC = new InterfaceVpcEndpointAwsService("datasync"), InterfaceVpcEndpointAwsService.DEVOPS_GURU = new InterfaceVpcEndpointAwsService("devops-guru"), InterfaceVpcEndpointAwsService.EBS_DIRECT = new InterfaceVpcEndpointAwsService("ebs"), InterfaceVpcEndpointAwsService.EC2 = new InterfaceVpcEndpointAwsService("ec2"), InterfaceVpcEndpointAwsService.EC2_MESSAGES = new InterfaceVpcEndpointAwsService("ec2messages"), InterfaceVpcEndpointAwsService.IMAGE_BUILDER = new InterfaceVpcEndpointAwsService("imagebuilder"), InterfaceVpcEndpointAwsService.ECR = new InterfaceVpcEndpointAwsService("ecr.api"), InterfaceVpcEndpointAwsService.ECR_DOCKER = new InterfaceVpcEndpointAwsService("ecr.dkr"), InterfaceVpcEndpointAwsService.ECS = new InterfaceVpcEndpointAwsService("ecs"), InterfaceVpcEndpointAwsService.ECS_AGENT = new InterfaceVpcEndpointAwsService("ecs-agent"), InterfaceVpcEndpointAwsService.ECS_TELEMETRY = new InterfaceVpcEndpointAwsService("ecs-telemetry"), InterfaceVpcEndpointAwsService.EKS = new InterfaceVpcEndpointAwsService("eks"), InterfaceVpcEndpointAwsService.ELASTIC_BEANSTALK = new InterfaceVpcEndpointAwsService("elasticbeanstalk"), InterfaceVpcEndpointAwsService.ELASTIC_BEANSTALK_HEALTH = new InterfaceVpcEndpointAwsService("elasticbeanstalk-health"), InterfaceVpcEndpointAwsService.ELASTIC_DISASTER_RECOVERY = new InterfaceVpcEndpointAwsService("drs"), InterfaceVpcEndpointAwsService.ELASTIC_FILESYSTEM = new InterfaceVpcEndpointAwsService("elasticfilesystem"), InterfaceVpcEndpointAwsService.ELASTIC_FILESYSTEM_FIPS = new InterfaceVpcEndpointAwsService("elasticfilesystem-fips"), InterfaceVpcEndpointAwsService.ELASTIC_INFERENCE_RUNTIME = new InterfaceVpcEndpointAwsService("elastic-inference.runtime"), InterfaceVpcEndpointAwsService.ELASTIC_LOAD_BALANCING = new InterfaceVpcEndpointAwsService("elasticloadbalancing"), InterfaceVpcEndpointAwsService.ELASTICACHE = new InterfaceVpcEndpointAwsService("elasticache"), InterfaceVpcEndpointAwsService.ELASTICACHE_FIPS = new InterfaceVpcEndpointAwsService("elasticache-fips"), InterfaceVpcEndpointAwsService.EMR = new InterfaceVpcEndpointAwsService("elasticmapreduce"), InterfaceVpcEndpointAwsService.EMR_EKS = new InterfaceVpcEndpointAwsService("emr-containers"), InterfaceVpcEndpointAwsService.EMR_SERVERLESS = new InterfaceVpcEndpointAwsService("emr-serverless"), InterfaceVpcEndpointAwsService.CLOUDWATCH_EVENTS = new InterfaceVpcEndpointAwsService("events"), InterfaceVpcEndpointAwsService.EVENTBRIDGE = new InterfaceVpcEndpointAwsService("events"), InterfaceVpcEndpointAwsService.APIGATEWAY = new InterfaceVpcEndpointAwsService("execute-api"), InterfaceVpcEndpointAwsService.FAULT_INJECTION_SIMULATOR = new InterfaceVpcEndpointAwsService("fis"), InterfaceVpcEndpointAwsService.FINSPACE = new InterfaceVpcEndpointAwsService("finspace"), InterfaceVpcEndpointAwsService.FINSPACE_API = new InterfaceVpcEndpointAwsService("finspace-api"), InterfaceVpcEndpointAwsService.FORECAST = new InterfaceVpcEndpointAwsService("forecast"), InterfaceVpcEndpointAwsService.FORECAST_QUERY = new InterfaceVpcEndpointAwsService("forecastquery"), InterfaceVpcEndpointAwsService.FORECAST_FIPS = new InterfaceVpcEndpointAwsService("forecast-fips"), InterfaceVpcEndpointAwsService.FORECAST_QUERY_FIPS = new InterfaceVpcEndpointAwsService("forecastquery-fips"), InterfaceVpcEndpointAwsService.FRAUD_DETECTOR = new InterfaceVpcEndpointAwsService("frauddetector"), InterfaceVpcEndpointAwsService.FSX = new InterfaceVpcEndpointAwsService("fsx"), InterfaceVpcEndpointAwsService.FSX_FIPS = new InterfaceVpcEndpointAwsService("fsx-fips"), InterfaceVpcEndpointAwsService.CODECOMMIT_GIT = new InterfaceVpcEndpointAwsService("git-codecommit"), InterfaceVpcEndpointAwsService.CODECOMMIT_GIT_FIPS = new InterfaceVpcEndpointAwsService("git-codecommit-fips"), InterfaceVpcEndpointAwsService.GLUE = new InterfaceVpcEndpointAwsService("glue"), InterfaceVpcEndpointAwsService.GLUE_DATABREW = new InterfaceVpcEndpointAwsService("databrew"), InterfaceVpcEndpointAwsService.GRAFANA = new InterfaceVpcEndpointAwsService("grafana"), InterfaceVpcEndpointAwsService.GRAFANA_WORKSPACE = new InterfaceVpcEndpointAwsService("grafana-workspace"), InterfaceVpcEndpointAwsService.GROUNDSTATION = new InterfaceVpcEndpointAwsService("groundstation"), InterfaceVpcEndpointAwsService.HEALTHLAKE = new InterfaceVpcEndpointAwsService("healthlake"), InterfaceVpcEndpointAwsService.IAM_IDENTITY_CENTER = new InterfaceVpcEndpointAwsService("identitystore"), InterfaceVpcEndpointAwsService.IAM_ROLES_ANYWHERE = new InterfaceVpcEndpointAwsService("rolesanywhere"), InterfaceVpcEndpointAwsService.INSPECTOR = new InterfaceVpcEndpointAwsService("inspector2"), InterfaceVpcEndpointAwsService.IOT_CORE = new InterfaceVpcEndpointAwsService("iot.data"), InterfaceVpcEndpointAwsService.IOT_CORE_DEVICE_ADVISOR = new InterfaceVpcEndpointAwsService("deviceadvisor.iot"), InterfaceVpcEndpointAwsService.IOT_CORE_FOR_LORAWAN = new InterfaceVpcEndpointAwsService("iotwireless.api"), InterfaceVpcEndpointAwsService.IOT_LORAWAN_CUPS = new InterfaceVpcEndpointAwsService("lorawan.cups"), InterfaceVpcEndpointAwsService.IOT_LORAWAN_LNS = new InterfaceVpcEndpointAwsService("lorawan.lns"), InterfaceVpcEndpointAwsService.IOT_GREENGRASS = new InterfaceVpcEndpointAwsService("greengrass"), InterfaceVpcEndpointAwsService.IOT_ROBORUNNER = new InterfaceVpcEndpointAwsService("iotroborunner"), InterfaceVpcEndpointAwsService.IOT_SITEWISE_API = new InterfaceVpcEndpointAwsService("iotsitewise.api"), InterfaceVpcEndpointAwsService.IOT_SITEWISE_DATA = new InterfaceVpcEndpointAwsService("iotsitewise.data"), InterfaceVpcEndpointAwsService.IOT_TWINMAKER_API = new InterfaceVpcEndpointAwsService("iottwinmaker.api"), InterfaceVpcEndpointAwsService.IOT_TWINMAKER_DATA = new InterfaceVpcEndpointAwsService("iottwinmaker.data"), InterfaceVpcEndpointAwsService.KENDRA = new InterfaceVpcEndpointAwsService("kendra"), InterfaceVpcEndpointAwsService.KEYSPACES = new InterfaceVpcEndpointAwsService("cassandra", "", 9142), InterfaceVpcEndpointAwsService.KEYSPACES_FIPS = new InterfaceVpcEndpointAwsService("cassandra-fips", "", 9142), InterfaceVpcEndpointAwsService.KINESIS_STREAMS = new InterfaceVpcEndpointAwsService("kinesis-streams"), InterfaceVpcEndpointAwsService.KINESIS_FIREHOSE = new InterfaceVpcEndpointAwsService("kinesis-firehose"), InterfaceVpcEndpointAwsService.KMS = new InterfaceVpcEndpointAwsService("kms"), InterfaceVpcEndpointAwsService.KMS_FIPS = new InterfaceVpcEndpointAwsService("kms-fips"), InterfaceVpcEndpointAwsService.LAKE_FORMATION = new InterfaceVpcEndpointAwsService("lakeformation"), InterfaceVpcEndpointAwsService.CLOUDWATCH_LOGS = new InterfaceVpcEndpointAwsService("logs"), InterfaceVpcEndpointAwsService.CLOUDWATCH = new InterfaceVpcEndpointAwsService("monitoring"), InterfaceVpcEndpointAwsService.LAMBDA = new InterfaceVpcEndpointAwsService("lambda"), InterfaceVpcEndpointAwsService.LEX_MODELS = new InterfaceVpcEndpointAwsService("models-v2-lex"), InterfaceVpcEndpointAwsService.LEX_RUNTIME = new InterfaceVpcEndpointAwsService("runtime-v2-lex"), InterfaceVpcEndpointAwsService.LICENSE_MANAGER = new InterfaceVpcEndpointAwsService("license-manager"), InterfaceVpcEndpointAwsService.LICENSE_MANAGER_FIPS = new InterfaceVpcEndpointAwsService("license-manager-fips"), InterfaceVpcEndpointAwsService.LOOKOUT_EQUIPMENT = new InterfaceVpcEndpointAwsService("lookoutequipment"), InterfaceVpcEndpointAwsService.LOOKOUT_METRICS = new InterfaceVpcEndpointAwsService("lookoutmetrics"), InterfaceVpcEndpointAwsService.LOOKOUT_VISION = new InterfaceVpcEndpointAwsService("lookoutvision"), InterfaceVpcEndpointAwsService.MACIE = new InterfaceVpcEndpointAwsService("macie2"), InterfaceVpcEndpointAwsService.MAINFRAME_MODERNIZATION = new InterfaceVpcEndpointAwsService("m2"), InterfaceVpcEndpointAwsService.PROMETHEUS = new InterfaceVpcEndpointAwsService("aps"), InterfaceVpcEndpointAwsService.PROMETHEUS_WORKSPACES = new InterfaceVpcEndpointAwsService("aps-workspaces"), InterfaceVpcEndpointAwsService.AIRFLOW_API = new InterfaceVpcEndpointAwsService("airflow.api"), InterfaceVpcEndpointAwsService.AIRFLOW_ENV = new InterfaceVpcEndpointAwsService("airflow.env"), InterfaceVpcEndpointAwsService.AIRFLOW_OPS = new InterfaceVpcEndpointAwsService("airflow.ops"), InterfaceVpcEndpointAwsService.MEMORY_DB = new InterfaceVpcEndpointAwsService("memory-db"), InterfaceVpcEndpointAwsService.MEMORY_DB_FIPS = new InterfaceVpcEndpointAwsService("memorydb-fips"), InterfaceVpcEndpointAwsService.MIGRATIONHUB_ORCHESTRATOR = new InterfaceVpcEndpointAwsService("migrationhub-orchestrator"), InterfaceVpcEndpointAwsService.MIGRATIONHUB_REFACTOR_SPACES = new InterfaceVpcEndpointAwsService("refactor-spaces"), InterfaceVpcEndpointAwsService.MIGRATIONHUB_STRATEGY = new InterfaceVpcEndpointAwsService("migrationhub-strategy"), InterfaceVpcEndpointAwsService.NIMBLE_STUDIO = new InterfaceVpcEndpointAwsService("nimble"), InterfaceVpcEndpointAwsService.OMICS_ANALYTICS = new InterfaceVpcEndpointAwsService("analytics-omics"), InterfaceVpcEndpointAwsService.OMICS_CONTROL_STORAGE = new InterfaceVpcEndpointAwsService("control-storage-omics"), InterfaceVpcEndpointAwsService.OMICS_STORAGE = new InterfaceVpcEndpointAwsService("storage-omics"), InterfaceVpcEndpointAwsService.OMICS_TAGS = new InterfaceVpcEndpointAwsService("tags-omics"), InterfaceVpcEndpointAwsService.OMICS_WORKFLOWS = new InterfaceVpcEndpointAwsService("workflows-omics"), InterfaceVpcEndpointAwsService.PANORAMA = new InterfaceVpcEndpointAwsService("panorama"), InterfaceVpcEndpointAwsService.PINPOINT = new InterfaceVpcEndpointAwsService("pinpoint-sms-voice-v2"), InterfaceVpcEndpointAwsService.POLLY = new InterfaceVpcEndpointAwsService("polly"), InterfaceVpcEndpointAwsService.PRIVATE_5G = new InterfaceVpcEndpointAwsService("private-networks"), InterfaceVpcEndpointAwsService.PROTON = new InterfaceVpcEndpointAwsService("proton"), InterfaceVpcEndpointAwsService.QLDB = new InterfaceVpcEndpointAwsService("qldb.session"), InterfaceVpcEndpointAwsService.RDS = new InterfaceVpcEndpointAwsService("rds"), InterfaceVpcEndpointAwsService.RDS_DATA = new InterfaceVpcEndpointAwsService("rds-data"), InterfaceVpcEndpointAwsService.ROBOMAKER = new InterfaceVpcEndpointAwsService("robomaker"), InterfaceVpcEndpointAwsService.REDSHIFT = new InterfaceVpcEndpointAwsService("redshift"), InterfaceVpcEndpointAwsService.REDSHIFT_FIPS = new InterfaceVpcEndpointAwsService("redshift-fips"), InterfaceVpcEndpointAwsService.REDSHIFT_DATA = new InterfaceVpcEndpointAwsService("redshift-data"), InterfaceVpcEndpointAwsService.S3 = new InterfaceVpcEndpointAwsService("s3"), InterfaceVpcEndpointAwsService.S3_MULTI_REGION_ACCESS_POINTS = new InterfaceVpcEndpointAwsService("s3-global.accesspoint", "com.amazonaws"), InterfaceVpcEndpointAwsService.S3_OUTPOSTS = new InterfaceVpcEndpointAwsService("s3-outposts"), InterfaceVpcEndpointAwsService.SAGEMAKER_API = new InterfaceVpcEndpointAwsService("sagemaker.api"), InterfaceVpcEndpointAwsService.SAGEMAKER_FEATURESTORE_RUNTIME = new InterfaceVpcEndpointAwsService("sagemaker.featurestore-runtime"), InterfaceVpcEndpointAwsService.SAGEMAKER_METRICS = new InterfaceVpcEndpointAwsService("sagemaker.metrics"), InterfaceVpcEndpointAwsService.SAGEMAKER_RUNTIME = new InterfaceVpcEndpointAwsService("sagemaker.runtime"), InterfaceVpcEndpointAwsService.SAGEMAKER_RUNTIME_FIPS = new InterfaceVpcEndpointAwsService("sagemaker.runtime-fips"), InterfaceVpcEndpointAwsService.SECRETS_MANAGER = new InterfaceVpcEndpointAwsService("secretsmanager"), InterfaceVpcEndpointAwsService.SERVICE_CATALOG = new InterfaceVpcEndpointAwsService("servicecatalog"), InterfaceVpcEndpointAwsService.SERVICE_CATALOG_APPREGISTRY = new InterfaceVpcEndpointAwsService("servicecatalog-appregistry"), InterfaceVpcEndpointAwsService.SERVER_MIGRATION_SERVICE = new InterfaceVpcEndpointAwsService("sms"), InterfaceVpcEndpointAwsService.SERVER_MIGRATION_SERVICE_FIPS = new InterfaceVpcEndpointAwsService("sms-fips"), InterfaceVpcEndpointAwsService.SERVER_MIGRATION_SERVICE_AWSCONNECTOR = new InterfaceVpcEndpointAwsService("awsconnector"), InterfaceVpcEndpointAwsService.SES = new InterfaceVpcEndpointAwsService("email-smtp"), InterfaceVpcEndpointAwsService.SNS = new InterfaceVpcEndpointAwsService("sns"), InterfaceVpcEndpointAwsService.SQS = new InterfaceVpcEndpointAwsService("sqs"), InterfaceVpcEndpointAwsService.SSM = new InterfaceVpcEndpointAwsService("ssm"), InterfaceVpcEndpointAwsService.SSM_MESSAGES = new InterfaceVpcEndpointAwsService("ssmmessages"), InterfaceVpcEndpointAwsService.SSM_CONTACTS = new InterfaceVpcEndpointAwsService("ssm-contacts"), InterfaceVpcEndpointAwsService.SSM_INCIDENTS = new InterfaceVpcEndpointAwsService("ssm-incidents"), InterfaceVpcEndpointAwsService.STS = new InterfaceVpcEndpointAwsService("sts"), InterfaceVpcEndpointAwsService.SNOW_DEVICE_MANAGEMENT = new InterfaceVpcEndpointAwsService("snow-device-management"), InterfaceVpcEndpointAwsService.TEXTRACT = new InterfaceVpcEndpointAwsService("textract"), InterfaceVpcEndpointAwsService.TEXTRACT_FIPS = new InterfaceVpcEndpointAwsService("textract-fips"), InterfaceVpcEndpointAwsService.TRANSFER = new InterfaceVpcEndpointAwsService("transfer"), InterfaceVpcEndpointAwsService.TRANSFER_SERVER = new InterfaceVpcEndpointAwsService("transfer.server"), InterfaceVpcEndpointAwsService.TRANSLATE = new InterfaceVpcEndpointAwsService("translate"), InterfaceVpcEndpointAwsService.STORAGE_GATEWAY = new InterfaceVpcEndpointAwsService("storagegateway"), InterfaceVpcEndpointAwsService.REKOGNITION = new InterfaceVpcEndpointAwsService("rekognition"), InterfaceVpcEndpointAwsService.REKOGNITION_FIPS = new InterfaceVpcEndpointAwsService("rekognition-fips"), InterfaceVpcEndpointAwsService.STEP_FUNCTIONS = new InterfaceVpcEndpointAwsService("states"), InterfaceVpcEndpointAwsService.STEP_FUNCTIONS_SYNC = new InterfaceVpcEndpointAwsService("sync-states"), InterfaceVpcEndpointAwsService.TRANSCRIBE = new InterfaceVpcEndpointAwsService("transcribe"), InterfaceVpcEndpointAwsService.TRANSCRIBE_STREAMING = new InterfaceVpcEndpointAwsService("transcribestreaming"), InterfaceVpcEndpointAwsService.WORKSPACES = new InterfaceVpcEndpointAwsService("workspaces"), InterfaceVpcEndpointAwsService.XRAY = new InterfaceVpcEndpointAwsService("xray"), InterfaceVpcEndpointAwsService.SECURITYHUB = new InterfaceVpcEndpointAwsService("securityhub"), InterfaceVpcEndpointAwsService.EMAIL_SMTP = new InterfaceVpcEndpointAwsService("email-smtp"), exports2.InterfaceVpcEndpointAwsService = InterfaceVpcEndpointAwsService;
    var InterfaceVpcEndpoint = class _InterfaceVpcEndpoint extends VpcEndpoint {
      static fromInterfaceVpcEndpointAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InterfaceVpcEndpointAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromInterfaceVpcEndpointAttributes), error;
        }
        const securityGroups = attrs.securityGroupId ? [security_group_1.SecurityGroup.fromSecurityGroupId(scope, "SecurityGroup", attrs.securityGroupId)] : attrs.securityGroups;
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.vpcEndpointId = attrs.vpcEndpointId, this.connections = new connections_1.Connections({ defaultPort: port_1.Port.tcp(attrs.port), securityGroups });
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InterfaceVpcEndpointProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _InterfaceVpcEndpoint), error;
        }
        const securityGroups = props.securityGroups || [new security_group_1.SecurityGroup(this, "SecurityGroup", { vpc: props.vpc })];
        this.securityGroupId = securityGroups[0].securityGroupId, this.connections = new connections_1.Connections({ defaultPort: port_1.Port.tcp(props.service.port), securityGroups }), props.open !== false && this.connections.allowDefaultPortFrom(peer_1.Peer.ipv4(props.vpc.vpcCidrBlock));
        const subnetIds = this.endpointSubnets(props), endpoint = new ec2_generated_1.CfnVPCEndpoint(this, "Resource", { privateDnsEnabled: props.privateDnsEnabled ?? props.service.privateDnsDefault ?? true, policyDocument: core_1.Lazy.any({ produce: () => this.policyDocument }), securityGroupIds: securityGroups.map((s) => s.securityGroupId), serviceName: props.service.name, vpcEndpointType: VpcEndpointType.INTERFACE, subnetIds, vpcId: props.vpc.vpcId });
        this.vpcEndpointId = endpoint.ref, this.vpcEndpointCreationTimestamp = endpoint.attrCreationTimestamp, this.vpcEndpointDnsEntries = endpoint.attrDnsEntries, this.vpcEndpointNetworkInterfaceIds = endpoint.attrNetworkInterfaceIds;
      }
      endpointSubnets(props) {
        const lookupSupportedAzs = props.lookupSupportedAzs ?? false, subnetSelection = props.vpc.selectSubnets({ ...props.subnets, onePerAz: true }), subnets = subnetSelection.subnets;
        if (!subnetSelection.isPendingLookup && subnetSelection.subnets.length == 0)
          throw new Error("Cannot create a VPC Endpoint with no subnets");
        if (!lookupSupportedAzs)
          return subnetSelection.subnetIds;
        const lookupServiceName = core_1.Token.isUnresolved(props.service.name) && props.service instanceof InterfaceVpcEndpointAwsService ? core_1.Stack.of(this).resolve(props.service.name) : props.service.name;
        this.validateCanLookupSupportedAzs(subnets, lookupServiceName);
        const availableAZs = this.availableAvailabilityZones(lookupServiceName), filteredSubnets = subnets.filter((s) => availableAZs.includes(s.availabilityZone));
        if (filteredSubnets.length == 0)
          throw new Error(`lookupSupportedAzs returned ${availableAZs} but subnets have AZs ${subnets.map((s) => s.availabilityZone)}`);
        return filteredSubnets.map((s) => s.subnetId);
      }
      validateCanLookupSupportedAzs(subnets, serviceName) {
        const agnosticAcct = core_1.Token.isUnresolved(this.env.account), agnosticRegion = core_1.Token.isUnresolved(this.env.region), agnosticService = core_1.Token.isUnresolved(serviceName), agnosticSubnets = subnets.some((s) => core_1.Token.isUnresolved(s.availabilityZone)), agnosticSubnetList = core_1.Token.isUnresolved(subnets.map((s) => s.availabilityZone));
        if (agnosticAcct || agnosticRegion)
          throw new Error("Cannot look up VPC endpoint availability zones if account/region are not specified");
        if (agnosticService)
          throw new Error(`Cannot lookup AZs for a service name with a Token: ${serviceName}`);
        if (agnosticSubnets || agnosticSubnetList) {
          const agnostic = subnets.filter((s) => core_1.Token.isUnresolved(s.availabilityZone));
          throw new Error(`lookupSupportedAzs cannot filter on subnets with Token AZs: ${agnostic}`);
        }
      }
      availableAvailabilityZones(serviceName) {
        const availableAZs = core_1.ContextProvider.getValue(this, { provider: cxschema.ContextProvider.ENDPOINT_SERVICE_AVAILABILITY_ZONE_PROVIDER, dummyValue: this.stack.availabilityZones, props: { serviceName } }).value;
        if (!Array.isArray(availableAZs))
          throw new Error(`Discovered AZs for endpoint service ${serviceName} must be an array`);
        return availableAZs;
      }
    };
    _f = JSII_RTTI_SYMBOL_1, InterfaceVpcEndpoint[_f] = { fqn: "aws-cdk-lib.aws_ec2.InterfaceVpcEndpoint", version: "2.80.0" }, exports2.InterfaceVpcEndpoint = InterfaceVpcEndpoint;
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/vpc-flow-logs.js
var require_vpc_flow_logs = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/vpc-flow-logs.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FlowLog = exports2.LogFormat = exports2.FlowLogMaxAggregationInterval = exports2.FlowLogDestination = exports2.FlowLogFileFormat = exports2.FlowLogResourceType = exports2.FlowLogDestinationType = exports2.FlowLogTrafficType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var ec2_generated_1 = require_ec2_generated();
    var iam = require_aws_iam();
    var logs = require_aws_logs();
    var s3 = require_aws_s3();
    var core_1 = require_core2();
    var cx_api_1 = require_cx_api();
    var FlowLogTrafficType;
    (function(FlowLogTrafficType2) {
      FlowLogTrafficType2.ACCEPT = "ACCEPT", FlowLogTrafficType2.ALL = "ALL", FlowLogTrafficType2.REJECT = "REJECT";
    })(FlowLogTrafficType = exports2.FlowLogTrafficType || (exports2.FlowLogTrafficType = {}));
    var FlowLogDestinationType;
    (function(FlowLogDestinationType2) {
      FlowLogDestinationType2.CLOUD_WATCH_LOGS = "cloud-watch-logs", FlowLogDestinationType2.S3 = "s3";
    })(FlowLogDestinationType = exports2.FlowLogDestinationType || (exports2.FlowLogDestinationType = {}));
    var FlowLogResourceType = class {
      static fromSubnet(subnet) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_ISubnet(subnet);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromSubnet), error;
        }
        return { resourceType: "Subnet", resourceId: subnet.subnetId };
      }
      static fromVpc(vpc) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_IVpc(vpc);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromVpc), error;
        }
        return { resourceType: "VPC", resourceId: vpc.vpcId };
      }
      static fromNetworkInterfaceId(id) {
        return { resourceType: "NetworkInterface", resourceId: id };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, FlowLogResourceType[_a] = { fqn: "aws-cdk-lib.aws_ec2.FlowLogResourceType", version: "2.80.0" }, exports2.FlowLogResourceType = FlowLogResourceType;
    var FlowLogFileFormat;
    (function(FlowLogFileFormat2) {
      FlowLogFileFormat2.PLAIN_TEXT = "plain-text", FlowLogFileFormat2.PARQUET = "parquet";
    })(FlowLogFileFormat = exports2.FlowLogFileFormat || (exports2.FlowLogFileFormat = {}));
    var FlowLogDestination = class {
      static toCloudWatchLogs(logGroup, iamRole) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_logs_ILogGroup(logGroup), jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IRole(iamRole);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.toCloudWatchLogs), error;
        }
        return new CloudWatchLogsDestination({ logDestinationType: FlowLogDestinationType.CLOUD_WATCH_LOGS, logGroup, iamRole });
      }
      static toS3(bucket, keyPrefix, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_IBucket(bucket), jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_S3DestinationOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.toS3), error;
        }
        return new S3Destination({ logDestinationType: FlowLogDestinationType.S3, s3Bucket: bucket, keyPrefix, destinationOptions: options });
      }
    };
    _b = JSII_RTTI_SYMBOL_1, FlowLogDestination[_b] = { fqn: "aws-cdk-lib.aws_ec2.FlowLogDestination", version: "2.80.0" }, exports2.FlowLogDestination = FlowLogDestination;
    var S3Destination = class extends FlowLogDestination {
      constructor(props) {
        super(), this.props = props;
      }
      bind(scope, _flowLog) {
        let s3Bucket;
        if (this.props.s3Bucket === void 0 ? s3Bucket = new s3.Bucket(scope, "Bucket", { removalPolicy: core_1.RemovalPolicy.RETAIN }) : s3Bucket = this.props.s3Bucket, core_1.FeatureFlags.of(scope).isEnabled(cx_api_1.S3_CREATE_DEFAULT_LOGGING_POLICY)) {
          const stack = core_1.Stack.of(scope);
          let keyPrefix = this.props.keyPrefix ?? "";
          keyPrefix && !keyPrefix.endsWith("/") && (keyPrefix = keyPrefix + "/");
          const prefix = this.props.destinationOptions?.hiveCompatiblePartitions ? s3Bucket.arnForObjects(`${keyPrefix}AWSLogs/aws-account-id=${stack.account}/*`) : s3Bucket.arnForObjects(`${keyPrefix}AWSLogs/${stack.account}/*`);
          s3Bucket.addToResourcePolicy(new iam.PolicyStatement({ effect: iam.Effect.ALLOW, principals: [new iam.ServicePrincipal("delivery.logs.amazonaws.com")], resources: [prefix], actions: ["s3:PutObject"], conditions: { StringEquals: { "s3:x-amz-acl": "bucket-owner-full-control", "aws:SourceAccount": stack.account }, ArnLike: { "aws:SourceArn": stack.formatArn({ service: "logs", resource: "*" }) } } })), s3Bucket.addToResourcePolicy(new iam.PolicyStatement({ effect: iam.Effect.ALLOW, principals: [new iam.ServicePrincipal("delivery.logs.amazonaws.com")], resources: [s3Bucket.bucketArn], actions: ["s3:GetBucketAcl", "s3:ListBucket"], conditions: { StringEquals: { "aws:SourceAccount": stack.account }, ArnLike: { "aws:SourceArn": stack.formatArn({ service: "logs", resource: "*" }) } } }));
        }
        return { logDestinationType: FlowLogDestinationType.S3, s3Bucket, keyPrefix: this.props.keyPrefix, destinationOptions: this.props.destinationOptions?.fileFormat || this.props.destinationOptions?.perHourPartition || this.props.destinationOptions?.hiveCompatiblePartitions ? { fileFormat: this.props.destinationOptions.fileFormat ?? FlowLogFileFormat.PLAIN_TEXT, perHourPartition: this.props.destinationOptions.perHourPartition ?? false, hiveCompatiblePartitions: this.props.destinationOptions.hiveCompatiblePartitions ?? false } : void 0 };
      }
    };
    var CloudWatchLogsDestination = class extends FlowLogDestination {
      constructor(props) {
        super(), this.props = props;
      }
      bind(scope, _flowLog) {
        let iamRole, logGroup;
        return this.props.iamRole === void 0 ? iamRole = new iam.Role(scope, "IAMRole", { roleName: core_1.PhysicalName.GENERATE_IF_NEEDED, assumedBy: new iam.ServicePrincipal("vpc-flow-logs.amazonaws.com") }) : iamRole = this.props.iamRole, this.props.logGroup === void 0 ? logGroup = new logs.LogGroup(scope, "LogGroup") : logGroup = this.props.logGroup, iamRole.addToPrincipalPolicy(new iam.PolicyStatement({ actions: ["logs:CreateLogStream", "logs:PutLogEvents", "logs:DescribeLogStreams"], effect: iam.Effect.ALLOW, resources: [logGroup.logGroupArn] })), iamRole.addToPrincipalPolicy(new iam.PolicyStatement({ actions: ["iam:PassRole"], effect: iam.Effect.ALLOW, resources: [iamRole.roleArn] })), { logDestinationType: FlowLogDestinationType.CLOUD_WATCH_LOGS, logGroup, iamRole };
      }
    };
    var FlowLogMaxAggregationInterval;
    (function(FlowLogMaxAggregationInterval2) {
      FlowLogMaxAggregationInterval2[FlowLogMaxAggregationInterval2.ONE_MINUTE = 60] = "ONE_MINUTE", FlowLogMaxAggregationInterval2[FlowLogMaxAggregationInterval2.TEN_MINUTES = 600] = "TEN_MINUTES";
    })(FlowLogMaxAggregationInterval = exports2.FlowLogMaxAggregationInterval || (exports2.FlowLogMaxAggregationInterval = {}));
    var LogFormat = class _LogFormat {
      static custom(formatString) {
        return new _LogFormat(formatString);
      }
      static field(field) {
        return new _LogFormat(`\${${field}}`);
      }
      constructor(value) {
        this.value = value;
      }
    };
    _c = JSII_RTTI_SYMBOL_1, LogFormat[_c] = { fqn: "aws-cdk-lib.aws_ec2.LogFormat", version: "2.80.0" }, LogFormat.VERSION = LogFormat.field("version"), LogFormat.ACCOUNT_ID = LogFormat.field("account-id"), LogFormat.INTERFACE_ID = LogFormat.field("interface-id"), LogFormat.SRC_ADDR = LogFormat.field("srcaddr"), LogFormat.DST_ADDR = LogFormat.field("dstaddr"), LogFormat.SRC_PORT = LogFormat.field("srcport"), LogFormat.DST_PORT = LogFormat.field("dstport"), LogFormat.PROTOCOL = LogFormat.field("protocol"), LogFormat.PACKETS = LogFormat.field("packets"), LogFormat.BYTES = LogFormat.field("bytes"), LogFormat.START_TIMESTAMP = LogFormat.field("start"), LogFormat.END_TIMESTAMP = LogFormat.field("end"), LogFormat.ACTION = LogFormat.field("action"), LogFormat.LOG_STATUS = LogFormat.field("log-status"), LogFormat.VPC_ID = LogFormat.field("vpc-id"), LogFormat.SUBNET_ID = LogFormat.field("subnet-id"), LogFormat.INSTANCE_ID = LogFormat.field("instance-id"), LogFormat.TCP_FLAGS = LogFormat.field("tcp-flags"), LogFormat.TRAFFIC_TYPE = LogFormat.field("type"), LogFormat.PKT_SRC_ADDR = LogFormat.field("pkt-srcaddr"), LogFormat.PKT_DST_ADDR = LogFormat.field("pkt-dstaddr"), LogFormat.REGION = LogFormat.field("region"), LogFormat.AZ_ID = LogFormat.field("az-id"), LogFormat.SUBLOCATION_TYPE = LogFormat.field("sublocation-type"), LogFormat.SUBLOCATION_ID = LogFormat.field("sublocation-id"), LogFormat.PKT_SRC_AWS_SERVICE = LogFormat.field("pkt-src-aws-service"), LogFormat.PKT_DST_AWS_SERVICE = LogFormat.field("pkt-dst-aws-service"), LogFormat.FLOW_DIRECTION = LogFormat.field("flow-direction"), LogFormat.TRAFFIC_PATH = LogFormat.field("traffic-path"), LogFormat.ALL_DEFAULT_FIELDS = new LogFormat("${version} ${account-id} ${interface-id} ${srcaddr} ${dstaddr} ${srcport} ${dstport} ${protocol} ${packets} ${bytes} ${start} ${end} ${action} ${log-status}"), exports2.LogFormat = LogFormat;
    var FlowLogBase = class extends core_1.Resource {
    };
    var FlowLog = class _FlowLog extends FlowLogBase {
      static fromFlowLogId(scope, id, flowLogId) {
        class Import extends FlowLogBase {
          constructor() {
            super(...arguments), this.flowLogId = flowLogId;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.flowLogName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_FlowLogProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _FlowLog), error;
        }
        const destinationConfig = (props.destination || FlowLogDestination.toCloudWatchLogs()).bind(this, this);
        this.logGroup = destinationConfig.logGroup, this.bucket = destinationConfig.s3Bucket, this.iamRole = destinationConfig.iamRole, this.keyPrefix = destinationConfig.keyPrefix;
        let logDestination;
        this.bucket && (logDestination = this.keyPrefix ? this.bucket.arnForObjects(this.keyPrefix) : this.bucket.bucketArn);
        let customLogFormat;
        props.logFormat && (customLogFormat = props.logFormat.map((elm) => elm.value).join(" "));
        const flowLog = new ec2_generated_1.CfnFlowLog(this, "FlowLog", { destinationOptions: destinationConfig.destinationOptions, deliverLogsPermissionArn: this.iamRole ? this.iamRole.roleArn : void 0, logDestinationType: destinationConfig.logDestinationType, logGroupName: this.logGroup ? this.logGroup.logGroupName : void 0, maxAggregationInterval: props.maxAggregationInterval, resourceId: props.resourceType.resourceId, resourceType: props.resourceType.resourceType, trafficType: props.trafficType ? props.trafficType : FlowLogTrafficType.ALL, logFormat: customLogFormat, logDestination });
        this.bucket?.policy?.node.defaultChild instanceof core_1.CfnResource && flowLog.addDependency(this.bucket?.policy.node.defaultChild);
        const deleteObjects = this.bucket?.node.tryFindChild("AutoDeleteObjectsCustomResource")?.node.defaultChild;
        deleteObjects instanceof core_1.CfnResource && flowLog.addDependency(deleteObjects), this.flowLogId = flowLog.ref, this.node.defaultChild = flowLog;
      }
    };
    _d = JSII_RTTI_SYMBOL_1, FlowLog[_d] = { fqn: "aws-cdk-lib.aws_ec2.FlowLog", version: "2.80.0" }, exports2.FlowLog = FlowLog;
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/vpn.js
var require_vpn = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/vpn.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.RESERVED_TUNNEL_INSIDE_CIDR = exports2.VpnConnection = exports2.VpnConnectionBase = exports2.VpnGateway = exports2.VpnConnectionType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var net = require("net");
    var ec2_generated_1 = require_ec2_generated();
    var cloudwatch = require_aws_cloudwatch();
    var core_1 = require_core2();
    var VpnConnectionType;
    (function(VpnConnectionType2) {
      VpnConnectionType2.IPSEC_1 = "ipsec.1", VpnConnectionType2.DUMMY = "dummy";
    })(VpnConnectionType = exports2.VpnConnectionType || (exports2.VpnConnectionType = {}));
    var VpnGateway = class _VpnGateway extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_VpnGatewayProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _VpnGateway), error;
        }
        const vpnGW = new ec2_generated_1.CfnVPNGateway(this, "Default", props);
        this.gatewayId = vpnGW.ref;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, VpnGateway[_a] = { fqn: "aws-cdk-lib.aws_ec2.VpnGateway", version: "2.80.0" }, exports2.VpnGateway = VpnGateway;
    var VpnConnectionBase = class extends core_1.Resource {
    };
    _b = JSII_RTTI_SYMBOL_1, VpnConnectionBase[_b] = { fqn: "aws-cdk-lib.aws_ec2.VpnConnectionBase", version: "2.80.0" }, exports2.VpnConnectionBase = VpnConnectionBase;
    var VpnConnection = class _VpnConnection extends VpnConnectionBase {
      static fromVpnConnectionAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_VpnConnectionAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromVpnConnectionAttributes), error;
        }
        class Import extends VpnConnectionBase {
          constructor() {
            super(...arguments), this.vpnId = attrs.vpnId, this.customerGatewayId = attrs.customerGatewayId, this.customerGatewayIp = attrs.customerGatewayIp, this.customerGatewayAsn = attrs.customerGatewayAsn;
          }
        }
        return new Import(scope, id);
      }
      static metricAll(metricName, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricAll), error;
        }
        return new cloudwatch.Metric({ namespace: "AWS/VPN", metricName, ...props });
      }
      static metricAllTunnelState(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricAllTunnelState), error;
        }
        return this.metricAll("TunnelState", { statistic: "avg", ...props });
      }
      static metricAllTunnelDataIn(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricAllTunnelDataIn), error;
        }
        return this.metricAll("TunnelDataIn", { statistic: "sum", ...props });
      }
      static metricAllTunnelDataOut(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricAllTunnelDataOut), error;
        }
        return this.metricAll("TunnelDataOut", { statistic: "sum", ...props });
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_VpnConnectionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _VpnConnection), error;
        }
        if (props.vpc.vpnGatewayId || props.vpc.enableVpnGateway({ type: "ipsec.1", amazonSideAsn: props.asn }), !core_1.Token.isUnresolved(props.ip) && !net.isIPv4(props.ip))
          throw new Error(`The \`ip\` ${props.ip} is not a valid IPv4 address.`);
        const type = VpnConnectionType.IPSEC_1, bgpAsn = props.asn || 65e3, customerGateway = new ec2_generated_1.CfnCustomerGateway(this, "CustomerGateway", { bgpAsn, ipAddress: props.ip, type });
        if (this.customerGatewayId = customerGateway.ref, this.customerGatewayAsn = bgpAsn, this.customerGatewayIp = props.ip, props.tunnelOptions) {
          if (props.tunnelOptions.length > 2)
            throw new Error("Cannot specify more than two `tunnelOptions`");
          if (props.tunnelOptions.length === 2 && props.tunnelOptions[0].tunnelInsideCidr === props.tunnelOptions[1].tunnelInsideCidr)
            throw new Error(`Same ${props.tunnelOptions[0].tunnelInsideCidr} \`tunnelInsideCidr\` cannot be used for both tunnels.`);
          props.tunnelOptions.forEach((options, index) => {
            if (options.preSharedKey && options.preSharedKeySecret)
              throw new Error("Specify at most one of 'preSharedKey' and 'preSharedKeySecret'.");
            if (options.preSharedKey && !core_1.Token.isUnresolved(options.preSharedKey) && !/^[a-zA-Z1-9._][a-zA-Z\d._]{7,63}$/.test(options.preSharedKey))
              throw new Error(`The \`preSharedKey\` ${options.preSharedKey} for tunnel ${index + 1} is invalid. Allowed characters are alphanumeric characters and ._. Must be between 8 and 64 characters in length and cannot start with zero (0).`);
            if (options.tunnelInsideCidr) {
              if (exports2.RESERVED_TUNNEL_INSIDE_CIDR.includes(options.tunnelInsideCidr))
                throw new Error(`The \`tunnelInsideCidr\` ${options.tunnelInsideCidr} for tunnel ${index + 1} is a reserved inside CIDR.`);
              if (!/^169\.254\.\d{1,3}\.\d{1,3}\/30$/.test(options.tunnelInsideCidr))
                throw new Error(`The \`tunnelInsideCidr\` ${options.tunnelInsideCidr} for tunnel ${index + 1} is not a size /30 CIDR block from the 169.254.0.0/16 range.`);
            }
          });
        }
        const vpnConnection = new ec2_generated_1.CfnVPNConnection(this, "Resource", { type, customerGatewayId: customerGateway.ref, staticRoutesOnly: !!props.staticRoutes, vpnGatewayId: props.vpc.vpnGatewayId, vpnTunnelOptionsSpecifications: props.tunnelOptions?.map((t) => ({ preSharedKey: t.preSharedKeySecret?.unsafeUnwrap() ?? t.preSharedKey, tunnelInsideCidr: t.tunnelInsideCidr })) });
        this.vpnId = vpnConnection.ref, props.staticRoutes && props.staticRoutes.forEach((route) => {
          new ec2_generated_1.CfnVPNConnectionRoute(this, `Route${route.replace(/[^\d]/g, "")}`, { destinationCidrBlock: route, vpnConnectionId: this.vpnId });
        });
      }
    };
    _c = JSII_RTTI_SYMBOL_1, VpnConnection[_c] = { fqn: "aws-cdk-lib.aws_ec2.VpnConnection", version: "2.80.0" }, exports2.VpnConnection = VpnConnection, exports2.RESERVED_TUNNEL_INSIDE_CIDR = ["169.254.0.0/30", "169.254.1.0/30", "169.254.2.0/30", "169.254.3.0/30", "169.254.4.0/30", "169.254.5.0/30", "169.254.169.252/30"];
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/vpc.js
var require_vpc2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/vpc.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PrivateSubnet = exports2.PublicSubnet = exports2.RouterType = exports2.Subnet = exports2.Vpc = exports2.DefaultInstanceTenancy = exports2.SubnetType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var path = require("path");
    var constructs_1 = require_lib2();
    var client_vpn_endpoint_1 = require_client_vpn_endpoint();
    var ec2_generated_1 = require_ec2_generated();
    var ip_addresses_1 = require_ip_addresses();
    var nat_1 = require_nat();
    var network_acl_1 = require_network_acl();
    var subnet_1 = require_subnet();
    var util_1 = require_util9();
    var vpc_endpoint_1 = require_vpc_endpoint();
    var vpc_flow_logs_1 = require_vpc_flow_logs();
    var vpn_1 = require_vpn();
    var cxschema = require_cloud_assembly_schema2();
    var core_1 = require_core2();
    var cxapi = require_cx_api();
    var cx_api_1 = require_cx_api();
    var VPC_SUBNET_SYMBOL = Symbol.for("@aws-cdk/aws-ec2.VpcSubnet");
    var FAKE_AZ_NAME = "fake-az";
    var SubnetType;
    (function(SubnetType2) {
      SubnetType2.PRIVATE_ISOLATED = "Isolated", SubnetType2.ISOLATED = "Deprecated_Isolated", SubnetType2.PRIVATE_WITH_EGRESS = "Private", SubnetType2.PRIVATE_WITH_NAT = "Deprecated_Private_NAT", SubnetType2.PRIVATE = "Deprecated_Private", SubnetType2.PUBLIC = "Public";
    })(SubnetType = exports2.SubnetType || (exports2.SubnetType = {}));
    var VpcBase = class extends core_1.Resource {
      constructor() {
        super(...arguments), this.natDependencies = new Array(), this.incompleteSubnetDefinition = false;
      }
      selectSubnets(selection = {}) {
        const subnets = this.selectSubnetObjects(selection), pubs = new Set(this.publicSubnets);
        return { subnetIds: subnets.map((s) => s.subnetId), get availabilityZones() {
          return subnets.map((s) => s.availabilityZone);
        }, internetConnectivityEstablished: tap(new CompositeDependable(), (d) => subnets.forEach((s) => d.add(s.internetConnectivityEstablished))), subnets, hasPublic: subnets.some((s) => pubs.has(s)), isPendingLookup: this.incompleteSubnetDefinition };
      }
      enableVpnGateway(options) {
        if (this.vpnGatewayId)
          throw new Error("The VPN Gateway has already been enabled.");
        const vpnGateway = new vpn_1.VpnGateway(this, "VpnGateway", { amazonSideAsn: options.amazonSideAsn, type: vpn_1.VpnConnectionType.IPSEC_1 });
        this._vpnGatewayId = vpnGateway.gatewayId;
        const attachment = new ec2_generated_1.CfnVPCGatewayAttachment(this, "VPCVPNGW", { vpcId: this.vpcId, vpnGatewayId: this._vpnGatewayId }), vpnRoutePropagation = options.vpnRoutePropagation ?? [{}], routeTableIds = (0, util_1.allRouteTableIds)((0, util_1.flatten)(vpnRoutePropagation.map((s) => this.selectSubnets(s).subnets)));
        routeTableIds.length === 0 && core_1.Annotations.of(this).addError(`enableVpnGateway: no subnets matching selection: '${JSON.stringify(vpnRoutePropagation)}'. Select other subnets to add routes to.`), new ec2_generated_1.CfnVPNGatewayRoutePropagation(this, "RoutePropagation", { routeTableIds, vpnGatewayId: this._vpnGatewayId }).node.addDependency(attachment);
      }
      addVpnConnection(id, options) {
        return new vpn_1.VpnConnection(this, id, { vpc: this, ...options });
      }
      addClientVpnEndpoint(id, options) {
        return new client_vpn_endpoint_1.ClientVpnEndpoint(this, id, { ...options, vpc: this });
      }
      addInterfaceEndpoint(id, options) {
        return new vpc_endpoint_1.InterfaceVpcEndpoint(this, id, { vpc: this, ...options });
      }
      addGatewayEndpoint(id, options) {
        return new vpc_endpoint_1.GatewayVpcEndpoint(this, id, { vpc: this, ...options });
      }
      addFlowLog(id, options) {
        return new vpc_flow_logs_1.FlowLog(this, id, { resourceType: vpc_flow_logs_1.FlowLogResourceType.fromVpc(this), ...options });
      }
      get vpnGatewayId() {
        return this._vpnGatewayId;
      }
      selectSubnetObjects(selection = {}) {
        if (selection = this.reifySelectionDefaults(selection), selection.subnets !== void 0)
          return selection.subnets;
        let subnets;
        if (selection.subnetGroupName !== void 0)
          subnets = this.selectSubnetObjectsByName(selection.subnetGroupName);
        else {
          const type = selection.subnetType || SubnetType.PRIVATE_WITH_EGRESS;
          subnets = this.selectSubnetObjectsByType(type);
        }
        return subnets = this.applySubnetFilters(subnets, selection.subnetFilters ?? []), subnets;
      }
      applySubnetFilters(subnets, filters) {
        let filtered = subnets;
        for (const filter of filters)
          filtered = filter.selectSubnets(filtered);
        return filtered;
      }
      selectSubnetObjectsByName(groupName) {
        const allSubnets = [...this.publicSubnets, ...this.privateSubnets, ...this.isolatedSubnets], subnets = allSubnets.filter((s) => (0, util_1.subnetGroupNameFromConstructId)(s) === groupName);
        if (subnets.length === 0 && !this.incompleteSubnetDefinition) {
          const names = Array.from(new Set(allSubnets.map(util_1.subnetGroupNameFromConstructId)));
          throw new Error(`There are no subnet groups with name '${groupName}' in this VPC. Available names: ${names}`);
        }
        return subnets;
      }
      selectSubnetObjectsByType(subnetType) {
        const allSubnets = { [SubnetType.PRIVATE_ISOLATED]: this.isolatedSubnets, [SubnetType.ISOLATED]: this.isolatedSubnets, [SubnetType.PRIVATE_WITH_NAT]: this.privateSubnets, [SubnetType.PRIVATE_WITH_EGRESS]: this.privateSubnets, [SubnetType.PRIVATE]: this.privateSubnets, [SubnetType.PUBLIC]: this.publicSubnets }, subnets = allSubnets[subnetType];
        if (subnets.length === 0 && !this.incompleteSubnetDefinition) {
          const availableTypes = Object.entries(allSubnets).filter(([_, subs]) => subs.length > 0).map(([typeName, _]) => typeName);
          throw new Error(`There are no '${subnetType}' subnet groups in this VPC. Available types: ${availableTypes}`);
        }
        return subnets;
      }
      reifySelectionDefaults(placement) {
        if (placement.subnetName !== void 0) {
          if (placement.subnetGroupName !== void 0)
            throw new Error("Please use only 'subnetGroupName' ('subnetName' is deprecated and has the same behavior)");
          core_1.Annotations.of(this).addWarning("Usage of 'subnetName' in SubnetSelection is deprecated, use 'subnetGroupName' instead"), placement = { ...placement, subnetGroupName: placement.subnetName };
        }
        const providedSelections = ["subnets", "subnetType", "subnetGroupName"].filter((key) => placement[key] !== void 0);
        if (providedSelections.length > 1)
          throw new Error(`Only one of '${providedSelections}' can be supplied to subnet selection.`);
        if (placement.subnetType === void 0 && placement.subnetGroupName === void 0 && placement.subnets === void 0) {
          let subnetType = this.privateSubnets.length ? SubnetType.PRIVATE_WITH_EGRESS : this.isolatedSubnets.length ? SubnetType.PRIVATE_ISOLATED : SubnetType.PUBLIC;
          placement = { ...placement, subnetType };
        }
        let subnetFilters = placement.subnetFilters ?? [];
        placement.availabilityZones !== void 0 && subnetFilters.push(subnet_1.SubnetFilter.availabilityZones(placement.availabilityZones)), placement.onePerAz && subnetFilters.push(subnet_1.SubnetFilter.onePerAz()), placement = { ...placement, subnetFilters, availabilityZones: void 0, onePerAz: void 0 };
        const { availabilityZones, onePerAz, ...rest } = placement;
        return rest;
      }
    };
    var NAME_TAG = "Name";
    var DefaultInstanceTenancy;
    (function(DefaultInstanceTenancy2) {
      DefaultInstanceTenancy2.DEFAULT = "default", DefaultInstanceTenancy2.DEDICATED = "dedicated";
    })(DefaultInstanceTenancy = exports2.DefaultInstanceTenancy || (exports2.DefaultInstanceTenancy = {}));
    var Vpc = class _Vpc extends VpcBase {
      static fromVpcAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_VpcAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromVpcAttributes), error;
        }
        return new ImportedVpc(scope, id, attrs, false);
      }
      static fromLookup(scope, id, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_VpcLookupOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromLookup), error;
        }
        if (core_1.Token.isUnresolved(options.vpcId) || core_1.Token.isUnresolved(options.vpcName) || Object.values(options.tags || {}).some(core_1.Token.isUnresolved) || Object.keys(options.tags || {}).some(core_1.Token.isUnresolved))
          throw new Error("All arguments to Vpc.fromLookup() must be concrete (no Tokens)");
        const filter = makeTagFilter(options.tags);
        options.vpcId && (filter["vpc-id"] = options.vpcId), options.vpcName && (filter["tag:Name"] = options.vpcName), options.ownerAccountId && (filter["owner-id"] = options.ownerAccountId), options.isDefault !== void 0 && (filter.isDefault = options.isDefault ? "true" : "false");
        const overrides = {};
        options.region && (overrides.region = options.region);
        const attributes = core_1.ContextProvider.getValue(scope, { provider: cxschema.ContextProvider.VPC_PROVIDER, props: { ...overrides, filter, returnAsymmetricSubnets: true, returnVpnGateways: options.returnVpnGateways, subnetGroupNameTag: options.subnetGroupNameTag }, dummyValue: void 0 }).value;
        return new LookedUpVpc(scope, id, attributes ?? DUMMY_VPC_PROPS, attributes === void 0);
        function makeTagFilter(tags) {
          const result = {};
          for (const [name, value] of Object.entries(tags || {}))
            result[`tag:${name}`] = value;
          return result;
        }
      }
      constructor(scope, id, props = {}) {
        super(scope, id), this.publicSubnets = [], this.privateSubnets = [], this.isolatedSubnets = [], this.subnetConfiguration = [], this._internetConnectivityEstablished = new constructs_1.DependencyGroup();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_VpcProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Vpc), error;
        }
        const stack = core_1.Stack.of(this);
        if (props.enableDnsHostnames && !props.enableDnsSupport)
          throw new Error("To use DNS Hostnames, DNS Support must be enabled, however, it was explicitly disabled.");
        if (props.availabilityZones && props.maxAzs)
          throw new Error("Vpc supports 'availabilityZones' or 'maxAzs', but not both.");
        const cidrBlock = ifUndefined(props.cidr, _Vpc.DEFAULT_CIDR_RANGE);
        if (core_1.Token.isUnresolved(cidrBlock))
          throw new Error("'cidr' property must be a concrete CIDR string, got a Token (we need to parse it for automatic subdivision)");
        if (props.ipAddresses && props.cidr)
          throw new Error("supply at most one of ipAddresses or cidr");
        this.ipAddresses = props.ipAddresses ?? ip_addresses_1.IpAddresses.cidr(cidrBlock), this.dnsHostnamesEnabled = props.enableDnsHostnames == null ? true : props.enableDnsHostnames, this.dnsSupportEnabled = props.enableDnsSupport == null ? true : props.enableDnsSupport;
        const instanceTenancy = props.defaultInstanceTenancy || "default";
        this.internetConnectivityEstablished = this._internetConnectivityEstablished;
        const vpcIpAddressOptions = this.ipAddresses.allocateVpcCidr();
        if (this.resource = new ec2_generated_1.CfnVPC(this, "Resource", { cidrBlock: vpcIpAddressOptions.cidrBlock, ipv4IpamPoolId: vpcIpAddressOptions.ipv4IpamPoolId, ipv4NetmaskLength: vpcIpAddressOptions.ipv4NetmaskLength, enableDnsHostnames: this.dnsHostnamesEnabled, enableDnsSupport: this.dnsSupportEnabled, instanceTenancy }), this.vpcDefaultNetworkAcl = this.resource.attrDefaultNetworkAcl, this.vpcCidrBlockAssociations = this.resource.attrCidrBlockAssociations, this.vpcCidrBlock = this.resource.attrCidrBlock, this.vpcDefaultSecurityGroup = this.resource.attrDefaultSecurityGroup, this.vpcIpv6CidrBlocks = this.resource.attrIpv6CidrBlocks, core_1.Tags.of(this).add(NAME_TAG, props.vpcName || this.node.path), props.availabilityZones) {
          const resolvedStackAzs = stack.availabilityZones.filter((az) => !core_1.Token.isUnresolved(az));
          if (!(resolvedStackAzs.length === 0 || props.availabilityZones.every((az) => core_1.Token.isUnresolved(az) || resolvedStackAzs.includes(az))))
            throw new Error(`Given VPC 'availabilityZones' ${props.availabilityZones} must be a subset of the stack's availability zones ${stack.availabilityZones}`);
          this.availabilityZones = props.availabilityZones;
        } else {
          const maxAZs = props.maxAzs ?? 3;
          this.availabilityZones = stack.availabilityZones.slice(0, maxAZs);
        }
        for (let i = 0; props.reservedAzs && i < props.reservedAzs; i++)
          this.availabilityZones.push(FAKE_AZ_NAME);
        this.vpcId = this.resource.ref, this.vpcArn = core_1.Arn.format({ service: "ec2", resource: "vpc", resourceName: this.vpcId }, stack);
        const defaultSubnet = props.natGateways === 0 ? _Vpc.DEFAULT_SUBNETS_NO_NAT : _Vpc.DEFAULT_SUBNETS;
        this.subnetConfiguration = ifUndefined(props.subnetConfiguration, defaultSubnet);
        const natGatewayPlacement = props.natGatewaySubnets || { subnetType: SubnetType.PUBLIC }, natGatewayCount = determineNatGatewayCount(props.natGateways, this.subnetConfiguration, this.availabilityZones.length);
        if (this.createSubnets(), this.subnetConfiguration.filter((subnet) => subnet.subnetType !== SubnetType.PRIVATE_ISOLATED && subnet.subnetType !== SubnetType.ISOLATED).length > 0) {
          const igw = new ec2_generated_1.CfnInternetGateway(this, "IGW", {});
          this.internetGatewayId = igw.ref, this._internetConnectivityEstablished.add(igw);
          const att = new ec2_generated_1.CfnVPCGatewayAttachment(this, "VPCGW", { internetGatewayId: igw.ref, vpcId: this.resource.ref });
          if (this.publicSubnets.forEach((publicSubnet) => {
            publicSubnet.addDefaultInternetRoute(igw.ref, att);
          }), natGatewayCount > 0) {
            const provider = props.natGatewayProvider || nat_1.NatProvider.gateway();
            this.createNatGateways(provider, natGatewayCount, natGatewayPlacement);
          }
        }
        if (props.vpnGateway && this.publicSubnets.length === 0 && this.privateSubnets.length === 0 && this.isolatedSubnets.length === 0)
          throw new Error("Can not enable the VPN gateway while the VPC has no subnets at all");
        if ((props.vpnConnections || props.vpnGatewayAsn) && props.vpnGateway === false)
          throw new Error("Cannot specify `vpnConnections` or `vpnGatewayAsn` when `vpnGateway` is set to false.");
        if (props.vpnGateway || props.vpnConnections || props.vpnGatewayAsn) {
          this.enableVpnGateway({ amazonSideAsn: props.vpnGatewayAsn, type: vpn_1.VpnConnectionType.IPSEC_1, vpnRoutePropagation: props.vpnRoutePropagation });
          const vpnConnections = props.vpnConnections || {};
          for (const [connectionId, connection] of Object.entries(vpnConnections))
            this.addVpnConnection(connectionId, connection);
        }
        if (props.gatewayEndpoints) {
          const gatewayEndpoints = props.gatewayEndpoints || {};
          for (const [endpointId, endpoint] of Object.entries(gatewayEndpoints))
            this.addGatewayEndpoint(endpointId, endpoint);
        }
        if (props.flowLogs) {
          const flowLogs = props.flowLogs || {};
          for (const [flowLogId, flowLog] of Object.entries(flowLogs))
            this.addFlowLog(flowLogId, flowLog);
        }
        (core_1.FeatureFlags.of(this).isEnabled(cx_api_1.EC2_RESTRICT_DEFAULT_SECURITY_GROUP) && props.restrictDefaultSecurityGroup !== false || props.restrictDefaultSecurityGroup) && this.restrictDefaultSecurityGroup();
      }
      addS3Endpoint(id, subnets) {
        return new vpc_endpoint_1.GatewayVpcEndpoint(this, id, { service: vpc_endpoint_1.GatewayVpcEndpointAwsService.S3, vpc: this, subnets });
      }
      addDynamoDbEndpoint(id, subnets) {
        return new vpc_endpoint_1.GatewayVpcEndpoint(this, id, { service: vpc_endpoint_1.GatewayVpcEndpointAwsService.DYNAMODB, vpc: this, subnets });
      }
      createNatGateways(provider, natCount, placement) {
        const natSubnets = this.selectSubnetObjects(placement);
        for (const sub of natSubnets)
          if (this.publicSubnets.indexOf(sub) === -1)
            throw new Error(`natGatewayPlacement ${placement} contains non public subnet ${sub}`);
        provider.configureNat({ vpc: this, natSubnets: natSubnets.slice(0, natCount), privateSubnets: this.privateSubnets });
      }
      createSubnets() {
        const requestedSubnets = [];
        this.subnetConfiguration.forEach((configuration) => this.availabilityZones.forEach((az, index) => {
          requestedSubnets.push({ availabilityZone: az, subnetConstructId: (0, util_1.subnetId)(configuration.name, index), configuration });
        }));
        const { allocatedSubnets } = this.ipAddresses.allocateSubnetsCidr({ vpcCidr: this.vpcCidrBlock, requestedSubnets });
        if (allocatedSubnets.length != requestedSubnets.length)
          throw new Error("Incomplete Subnet Allocation; response array dose not equal input array");
        this.createSubnetResources(requestedSubnets, allocatedSubnets);
      }
      createSubnetResources(requestedSubnets, allocatedSubnets) {
        allocatedSubnets.forEach((allocated, i) => {
          const { configuration: subnetConfig, subnetConstructId, availabilityZone } = requestedSubnets[i];
          if (subnetConfig.reserved === true || availabilityZone === FAKE_AZ_NAME)
            return;
          let mapPublicIpOnLaunch = false;
          if (subnetConfig.subnetType !== SubnetType.PUBLIC && subnetConfig.mapPublicIpOnLaunch !== void 0)
            throw new Error(`${subnetConfig.subnetType} subnet cannot include mapPublicIpOnLaunch parameter`);
          subnetConfig.subnetType === SubnetType.PUBLIC && (mapPublicIpOnLaunch = subnetConfig.mapPublicIpOnLaunch !== void 0 ? subnetConfig.mapPublicIpOnLaunch : true);
          const subnetProps = { availabilityZone, vpcId: this.vpcId, cidrBlock: allocated.cidr, mapPublicIpOnLaunch };
          let subnet;
          switch (subnetConfig.subnetType) {
            case SubnetType.PUBLIC:
              const publicSubnet = new PublicSubnet(this, subnetConstructId, subnetProps);
              this.publicSubnets.push(publicSubnet), subnet = publicSubnet;
              break;
            case SubnetType.PRIVATE_WITH_EGRESS:
            case SubnetType.PRIVATE_WITH_NAT:
            case SubnetType.PRIVATE:
              const privateSubnet = new PrivateSubnet(this, subnetConstructId, subnetProps);
              this.privateSubnets.push(privateSubnet), subnet = privateSubnet;
              break;
            case SubnetType.PRIVATE_ISOLATED:
            case SubnetType.ISOLATED:
              const isolatedSubnet = new PrivateSubnet(this, subnetConstructId, subnetProps);
              this.isolatedSubnets.push(isolatedSubnet), subnet = isolatedSubnet;
              break;
            default:
              throw new Error(`Unrecognized subnet type: ${subnetConfig.subnetType}`);
          }
          const includeResourceTypes = [ec2_generated_1.CfnSubnet.CFN_RESOURCE_TYPE_NAME];
          core_1.Tags.of(subnet).add(SUBNETNAME_TAG, subnetConfig.name, { includeResourceTypes }), core_1.Tags.of(subnet).add(SUBNETTYPE_TAG, subnetTypeTagValue(subnetConfig.subnetType), { includeResourceTypes });
        });
      }
      restrictDefaultSecurityGroup() {
        const id = "Custom::VpcRestrictDefaultSG", provider = core_1.CustomResourceProvider.getOrCreateProvider(this, id, { codeDirectory: path.join(__dirname, "restrict-default-security-group-handler"), runtime: core_1.CustomResourceProviderRuntime.NODEJS_16_X, description: "Lambda function for removing all inbound/outbound rules from the VPC default security group" });
        provider.addToRolePolicy({ Effect: "Allow", Action: ["ec2:AuthorizeSecurityGroupIngress", "ec2:AuthorizeSecurityGroupEgress", "ec2:RevokeSecurityGroupIngress", "ec2:RevokeSecurityGroupEgress"], Resource: [core_1.Stack.of(this).formatArn({ resource: "security-group", service: "ec2", resourceName: this.vpcDefaultSecurityGroup })] }), new core_1.CustomResource(this, "RestrictDefaultSecurityGroupCustomResource", { resourceType: id, serviceToken: provider.serviceToken, properties: { DefaultSecurityGroupId: this.vpcDefaultSecurityGroup, Account: core_1.Stack.of(this).account } });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Vpc[_a] = { fqn: "aws-cdk-lib.aws_ec2.Vpc", version: "2.80.0" }, Vpc.DEFAULT_CIDR_RANGE = "10.0.0.0/16", Vpc.DEFAULT_SUBNETS = [{ subnetType: SubnetType.PUBLIC, name: (0, util_1.defaultSubnetName)(SubnetType.PUBLIC) }, { subnetType: SubnetType.PRIVATE_WITH_EGRESS, name: (0, util_1.defaultSubnetName)(SubnetType.PRIVATE_WITH_EGRESS) }], Vpc.DEFAULT_SUBNETS_NO_NAT = [{ subnetType: SubnetType.PUBLIC, name: (0, util_1.defaultSubnetName)(SubnetType.PUBLIC) }, { subnetType: SubnetType.PRIVATE_ISOLATED, name: (0, util_1.defaultSubnetName)(SubnetType.PRIVATE_ISOLATED) }], exports2.Vpc = Vpc;
    var SUBNETTYPE_TAG = "aws-cdk:subnet-type";
    var SUBNETNAME_TAG = "aws-cdk:subnet-name";
    function subnetTypeTagValue(type) {
      switch (type) {
        case SubnetType.PUBLIC:
          return "Public";
        case SubnetType.PRIVATE_WITH_EGRESS:
        case SubnetType.PRIVATE_WITH_NAT:
        case SubnetType.PRIVATE:
          return "Private";
        case SubnetType.PRIVATE_ISOLATED:
        case SubnetType.ISOLATED:
          return "Isolated";
      }
    }
    var Subnet = class _Subnet extends core_1.Resource {
      static isVpcSubnet(x) {
        return VPC_SUBNET_SYMBOL in x;
      }
      static fromSubnetAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_SubnetAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromSubnetAttributes), error;
        }
        return new ImportedSubnet(scope, id, attrs);
      }
      static fromSubnetId(scope, id, subnetId) {
        return this.fromSubnetAttributes(scope, id, { subnetId });
      }
      constructor(scope, id, props) {
        super(scope, id), this.dependencyElements = [], this._internetConnectivityEstablished = new constructs_1.DependencyGroup();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_SubnetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Subnet), error;
        }
        Object.defineProperty(this, VPC_SUBNET_SYMBOL, { value: true }), core_1.Tags.of(this).add(NAME_TAG, this.node.path), this.availabilityZone = props.availabilityZone, this.ipv4CidrBlock = props.cidrBlock;
        const subnet = new ec2_generated_1.CfnSubnet(this, "Subnet", { vpcId: props.vpcId, cidrBlock: props.cidrBlock, availabilityZone: props.availabilityZone, mapPublicIpOnLaunch: props.mapPublicIpOnLaunch });
        this.subnetId = subnet.ref, this.subnetVpcId = subnet.attrVpcId, this.subnetAvailabilityZone = subnet.attrAvailabilityZone, this.subnetIpv6CidrBlocks = subnet.attrIpv6CidrBlocks, this.subnetOutpostArn = subnet.attrOutpostArn, this._networkAcl = network_acl_1.NetworkAcl.fromNetworkAclId(this, "Acl", subnet.attrNetworkAclAssociationId), this.subnetNetworkAclAssociationId = core_1.Lazy.string({ produce: () => this._networkAcl.networkAclId }), this.node.defaultChild = subnet;
        const table = new ec2_generated_1.CfnRouteTable(this, "RouteTable", { vpcId: props.vpcId });
        this.routeTable = { routeTableId: table.ref };
        const routeAssoc = new ec2_generated_1.CfnSubnetRouteTableAssociation(this, "RouteTableAssociation", { subnetId: this.subnetId, routeTableId: table.ref });
        this._internetConnectivityEstablished.add(routeAssoc), this.internetConnectivityEstablished = this._internetConnectivityEstablished;
      }
      addDefaultInternetRoute(gatewayId, gatewayAttachment) {
        const route = new ec2_generated_1.CfnRoute(this, "DefaultRoute", { routeTableId: this.routeTable.routeTableId, destinationCidrBlock: "0.0.0.0/0", gatewayId });
        route.node.addDependency(gatewayAttachment), this._internetConnectivityEstablished.add(route);
      }
      get networkAcl() {
        return this._networkAcl;
      }
      addDefaultNatRoute(natGatewayId) {
        this.addRoute("DefaultRoute", { routerType: RouterType.NAT_GATEWAY, routerId: natGatewayId, enablesInternetConnectivity: true });
      }
      addRoute(id, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_AddRouteOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addRoute), error;
        }
        if (options.destinationCidrBlock && options.destinationIpv6CidrBlock)
          throw new Error("Cannot specify both 'destinationCidrBlock' and 'destinationIpv6CidrBlock'");
        const route = new ec2_generated_1.CfnRoute(this, id, { routeTableId: this.routeTable.routeTableId, destinationCidrBlock: options.destinationCidrBlock || (options.destinationIpv6CidrBlock === void 0 ? "0.0.0.0/0" : void 0), destinationIpv6CidrBlock: options.destinationIpv6CidrBlock, [routerTypeToPropName(options.routerType)]: options.routerId });
        options.enablesInternetConnectivity && this._internetConnectivityEstablished.add(route);
      }
      associateNetworkAcl(id, networkAcl) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_INetworkAcl(networkAcl);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.associateNetworkAcl), error;
        }
        this._networkAcl = networkAcl;
        const scope = networkAcl instanceof constructs_1.Construct ? networkAcl : this, other = networkAcl instanceof constructs_1.Construct ? this : networkAcl;
        new network_acl_1.SubnetNetworkAclAssociation(scope, id + core_1.Names.nodeUniqueId(other.node), { networkAcl, subnet: this });
      }
    };
    _b = JSII_RTTI_SYMBOL_1, Subnet[_b] = { fqn: "aws-cdk-lib.aws_ec2.Subnet", version: "2.80.0" }, exports2.Subnet = Subnet;
    var RouterType;
    (function(RouterType2) {
      RouterType2.CARRIER_GATEWAY = "CarrierGateway", RouterType2.EGRESS_ONLY_INTERNET_GATEWAY = "EgressOnlyInternetGateway", RouterType2.GATEWAY = "Gateway", RouterType2.INSTANCE = "Instance", RouterType2.LOCAL_GATEWAY = "LocalGateway", RouterType2.NAT_GATEWAY = "NatGateway", RouterType2.NETWORK_INTERFACE = "NetworkInterface", RouterType2.TRANSIT_GATEWAY = "TransitGateway", RouterType2.VPC_PEERING_CONNECTION = "VpcPeeringConnection", RouterType2.VPC_ENDPOINT = "VpcEndpoint";
    })(RouterType = exports2.RouterType || (exports2.RouterType = {}));
    function routerTypeToPropName(routerType) {
      return { [RouterType.CARRIER_GATEWAY]: "carrierGatewayId", [RouterType.EGRESS_ONLY_INTERNET_GATEWAY]: "egressOnlyInternetGatewayId", [RouterType.GATEWAY]: "gatewayId", [RouterType.INSTANCE]: "instanceId", [RouterType.LOCAL_GATEWAY]: "localGatewayId", [RouterType.NAT_GATEWAY]: "natGatewayId", [RouterType.NETWORK_INTERFACE]: "networkInterfaceId", [RouterType.TRANSIT_GATEWAY]: "transitGatewayId", [RouterType.VPC_PEERING_CONNECTION]: "vpcPeeringConnectionId", [RouterType.VPC_ENDPOINT]: "vpcEndpointId" }[routerType];
    }
    var PublicSubnet = class _PublicSubnet extends Subnet {
      static fromPublicSubnetAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_PublicSubnetAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromPublicSubnetAttributes), error;
        }
        return new ImportedSubnet(scope, id, attrs);
      }
      constructor(scope, id, props) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_PublicSubnetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _PublicSubnet), error;
        }
      }
      addNatGateway(eipAllocationId) {
        const ngw = new ec2_generated_1.CfnNatGateway(this, "NATGateway", { subnetId: this.subnetId, allocationId: eipAllocationId ?? new ec2_generated_1.CfnEIP(this, "EIP", { domain: "vpc" }).attrAllocationId });
        return ngw.node.addDependency(this.internetConnectivityEstablished), ngw;
      }
    };
    _c = JSII_RTTI_SYMBOL_1, PublicSubnet[_c] = { fqn: "aws-cdk-lib.aws_ec2.PublicSubnet", version: "2.80.0" }, exports2.PublicSubnet = PublicSubnet;
    var PrivateSubnet = class _PrivateSubnet extends Subnet {
      static fromPrivateSubnetAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_PrivateSubnetAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromPrivateSubnetAttributes), error;
        }
        return new ImportedSubnet(scope, id, attrs);
      }
      constructor(scope, id, props) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_PrivateSubnetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _PrivateSubnet), error;
        }
      }
    };
    _d = JSII_RTTI_SYMBOL_1, PrivateSubnet[_d] = { fqn: "aws-cdk-lib.aws_ec2.PrivateSubnet", version: "2.80.0" }, exports2.PrivateSubnet = PrivateSubnet;
    function ifUndefined(value, defaultValue) {
      return value ?? defaultValue;
    }
    var ImportedVpc = class extends VpcBase {
      constructor(scope, id, props, isIncomplete) {
        super(scope, id, { region: props.region }), this.internetConnectivityEstablished = new constructs_1.DependencyGroup(), this.vpcId = props.vpcId, this.vpcArn = core_1.Arn.format({ service: "ec2", resource: "vpc", resourceName: this.vpcId }, core_1.Stack.of(this)), this.cidr = props.vpcCidrBlock, this.availabilityZones = props.availabilityZones, this._vpnGatewayId = props.vpnGatewayId, this.incompleteSubnetDefinition = isIncomplete;
        for (const k of Object.keys(props))
          Array.isArray(props[k]) && core_1.Token.isUnresolved(props[k]) && core_1.Annotations.of(this).addWarning(`fromVpcAttributes: '${k}' is a list token: the imported VPC will not work with constructs that require a list of subnets at synthesis time. Use 'Vpc.fromLookup()' or 'Fn.importListValue' instead.`);
        const pub = new util_1.ImportSubnetGroup(props.publicSubnetIds, props.publicSubnetNames, props.publicSubnetRouteTableIds, props.publicSubnetIpv4CidrBlocks, SubnetType.PUBLIC, this.availabilityZones, "publicSubnetIds", "publicSubnetNames", "publicSubnetRouteTableIds", "publicSubnetIpv4CidrBlocks"), priv = new util_1.ImportSubnetGroup(props.privateSubnetIds, props.privateSubnetNames, props.privateSubnetRouteTableIds, props.privateSubnetIpv4CidrBlocks, SubnetType.PRIVATE_WITH_EGRESS, this.availabilityZones, "privateSubnetIds", "privateSubnetNames", "privateSubnetRouteTableIds", "privateSubnetIpv4CidrBlocks"), iso = new util_1.ImportSubnetGroup(props.isolatedSubnetIds, props.isolatedSubnetNames, props.isolatedSubnetRouteTableIds, props.isolatedSubnetIpv4CidrBlocks, SubnetType.PRIVATE_ISOLATED, this.availabilityZones, "isolatedSubnetIds", "isolatedSubnetNames", "isolatedSubnetRouteTableIds", "isolatedSubnetIpv4CidrBlocks");
        this.publicSubnets = pub.import(this), this.privateSubnets = priv.import(this), this.isolatedSubnets = iso.import(this);
      }
      get vpcCidrBlock() {
        if (this.cidr === void 0)
          throw new Error("Cannot perform this operation: 'vpcCidrBlock' was not supplied when creating this VPC");
        return this.cidr;
      }
    };
    var LookedUpVpc = class extends VpcBase {
      constructor(scope, id, props, isIncomplete) {
        super(scope, id, { region: props.region, account: props.ownerAccountId }), this.internetConnectivityEstablished = new constructs_1.DependencyGroup(), this.vpcId = props.vpcId, this.vpcArn = core_1.Arn.format({ service: "ec2", resource: "vpc", resourceName: this.vpcId, region: this.env.region, account: this.env.account }, core_1.Stack.of(this)), this.cidr = props.vpcCidrBlock, this._vpnGatewayId = props.vpnGatewayId, this.incompleteSubnetDefinition = isIncomplete;
        const subnetGroups = props.subnetGroups || [], availabilityZones = Array.from(new Set(flatMap(subnetGroups, (subnetGroup) => subnetGroup.subnets.map((subnet) => subnet.availabilityZone))));
        availabilityZones.sort((az1, az2) => az1.localeCompare(az2)), this.availabilityZones = availabilityZones, this.publicSubnets = this.extractSubnetsOfType(subnetGroups, cxapi.VpcSubnetGroupType.PUBLIC), this.privateSubnets = this.extractSubnetsOfType(subnetGroups, cxapi.VpcSubnetGroupType.PRIVATE), this.isolatedSubnets = this.extractSubnetsOfType(subnetGroups, cxapi.VpcSubnetGroupType.ISOLATED);
      }
      get vpcCidrBlock() {
        if (this.cidr === void 0)
          throw new Error("Cannot perform this operation: 'vpcCidrBlock' was not found when looking up this VPC. Use a newer version of the CDK CLI and clear the old context value.");
        return this.cidr;
      }
      extractSubnetsOfType(subnetGroups, subnetGroupType) {
        return flatMap(subnetGroups.filter((subnetGroup) => subnetGroup.type === subnetGroupType), (subnetGroup) => this.subnetGroupToSubnets(subnetGroup));
      }
      subnetGroupToSubnets(subnetGroup) {
        const ret = new Array();
        for (let i = 0; i < subnetGroup.subnets.length; i++) {
          const vpcSubnet = subnetGroup.subnets[i];
          ret.push(Subnet.fromSubnetAttributes(this, `${subnetGroup.name}Subnet${i + 1}`, { availabilityZone: vpcSubnet.availabilityZone, subnetId: vpcSubnet.subnetId, routeTableId: vpcSubnet.routeTableId, ipv4CidrBlock: vpcSubnet.cidr }));
        }
        return ret;
      }
    };
    function flatMap(xs, fn) {
      const ret = new Array();
      for (const x of xs)
        ret.push(...fn(x));
      return ret;
    }
    var CompositeDependable = class {
      constructor() {
        this.dependables = new Array();
        const self2 = this;
        constructs_1.Dependable.implement(this, { get dependencyRoots() {
          const ret = new Array();
          for (const dep of self2.dependables)
            ret.push(...constructs_1.Dependable.of(dep).dependencyRoots);
          return ret;
        } });
      }
      add(dep) {
        this.dependables.push(dep);
      }
    };
    function tap(x, fn) {
      return fn(x), x;
    }
    var ImportedSubnet = class extends core_1.Resource {
      constructor(scope, id, attrs) {
        if (super(scope, id), this.internetConnectivityEstablished = new constructs_1.DependencyGroup(), !attrs.routeTableId) {
          const ref = core_1.Token.isUnresolved(attrs.subnetId) || core_1.Token.isUnresolved([attrs.subnetId]) ? `at '${constructs_1.Node.of(scope).path}/${id}'` : `'${attrs.subnetId}'`;
          core_1.Annotations.of(this).addWarning(`No routeTableId was provided to the subnet ${ref}. Attempting to read its .routeTable.routeTableId will return null/undefined. (More info: https://github.com/aws/aws-cdk/pull/3171)`);
        }
        this._ipv4CidrBlock = attrs.ipv4CidrBlock, this._availabilityZone = attrs.availabilityZone, this.subnetId = attrs.subnetId, this.routeTable = { routeTableId: attrs.routeTableId };
      }
      get availabilityZone() {
        if (!this._availabilityZone)
          throw new Error("You cannot reference a Subnet's availability zone if it was not supplied. Add the availabilityZone when importing using Subnet.fromSubnetAttributes()");
        return this._availabilityZone;
      }
      get ipv4CidrBlock() {
        if (!this._ipv4CidrBlock)
          throw new Error("You cannot reference an imported Subnet's IPv4 CIDR if it was not supplied. Add the ipv4CidrBlock when importing using Subnet.fromSubnetAttributes()");
        return this._ipv4CidrBlock;
      }
      associateNetworkAcl(id, networkAcl) {
        const scope = networkAcl instanceof constructs_1.Construct ? networkAcl : this, other = networkAcl instanceof constructs_1.Construct ? this : networkAcl;
        new network_acl_1.SubnetNetworkAclAssociation(scope, id + core_1.Names.nodeUniqueId(other.node), { networkAcl, subnet: this });
      }
    };
    function determineNatGatewayCount(requestedCount, subnetConfig, azCount) {
      const hasPrivateSubnets = subnetConfig.some((c) => (c.subnetType === SubnetType.PRIVATE_WITH_EGRESS || c.subnetType === SubnetType.PRIVATE || c.subnetType === SubnetType.PRIVATE_WITH_NAT) && !c.reserved), hasPublicSubnets = subnetConfig.some((c) => c.subnetType === SubnetType.PUBLIC), hasCustomEgress = subnetConfig.some((c) => c.subnetType === SubnetType.PRIVATE_WITH_EGRESS), count = requestedCount !== void 0 ? Math.min(requestedCount, azCount) : hasPrivateSubnets ? azCount : 0;
      if (count === 0 && hasPrivateSubnets && !hasCustomEgress)
        throw new Error("If you do not want NAT gateways (natGateways=0), make sure you don't configure any PRIVATE(_WITH_NAT) subnets in 'subnetConfiguration' (make them PUBLIC or ISOLATED instead)");
      if (count > 0 && !hasPublicSubnets)
        throw new Error(`If you configure PRIVATE subnets in 'subnetConfiguration', you must also configure PUBLIC subnets to put the NAT gateways into (got ${JSON.stringify(subnetConfig)}.`);
      return count;
    }
    var DUMMY_VPC_PROPS = { availabilityZones: [], vpcCidrBlock: "1.2.3.4/5", isolatedSubnetIds: void 0, isolatedSubnetNames: void 0, isolatedSubnetRouteTableIds: void 0, privateSubnetIds: void 0, privateSubnetNames: void 0, privateSubnetRouteTableIds: void 0, publicSubnetIds: void 0, publicSubnetNames: void 0, publicSubnetRouteTableIds: void 0, subnetGroups: [{ name: "Public", type: cxapi.VpcSubnetGroupType.PUBLIC, subnets: [{ availabilityZone: "dummy1a", subnetId: "s-12345", routeTableId: "rtb-12345s", cidr: "1.2.3.4/5" }, { availabilityZone: "dummy1b", subnetId: "s-67890", routeTableId: "rtb-67890s", cidr: "1.2.3.4/5" }] }, { name: "Private", type: cxapi.VpcSubnetGroupType.PRIVATE, subnets: [{ availabilityZone: "dummy1a", subnetId: "p-12345", routeTableId: "rtb-12345p", cidr: "1.2.3.4/5" }, { availabilityZone: "dummy1b", subnetId: "p-67890", routeTableId: "rtb-57890p", cidr: "1.2.3.4/5" }] }, { name: "Isolated", type: cxapi.VpcSubnetGroupType.ISOLATED, subnets: [{ availabilityZone: "dummy1a", subnetId: "p-12345", routeTableId: "rtb-12345p", cidr: "1.2.3.4/5" }, { availabilityZone: "dummy1b", subnetId: "p-67890", routeTableId: "rtb-57890p", cidr: "1.2.3.4/5" }] }], vpcId: "vpc-12345" };
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/instance.js
var require_instance = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/instance.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Instance = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var aspects_1 = require_aspects();
    var connections_1 = require_connections();
    var ec2_generated_1 = require_ec2_generated();
    var ebs_util_1 = require_ebs_util();
    var security_group_1 = require_security_group2();
    var vpc_1 = require_vpc2();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var helpers_internal_1 = require_helpers_internal();
    var NAME_TAG = "Name";
    var Instance = class _Instance extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id), this.securityGroups = [];
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InstanceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Instance), error;
        }
        if (props.initOptions && !props.init)
          throw new Error("Setting 'initOptions' requires that 'init' is also set");
        props.securityGroup ? this.securityGroup = props.securityGroup : this.securityGroup = new security_group_1.SecurityGroup(this, "InstanceSecurityGroup", { vpc: props.vpc, allowAllOutbound: props.allowAllOutbound !== false }), this.connections = new connections_1.Connections({ securityGroups: [this.securityGroup] }), this.securityGroups.push(this.securityGroup), core_1.Tags.of(this).add(NAME_TAG, props.instanceName || this.node.path), this.role = props.role || new iam.Role(this, "InstanceRole", { assumedBy: new iam.ServicePrincipal("ec2.amazonaws.com") }), this.grantPrincipal = this.role, props.ssmSessionPermissions && this.role.addManagedPolicy(iam.ManagedPolicy.fromAwsManagedPolicyName("AmazonSSMManagedInstanceCore"));
        const iamProfile = new iam.CfnInstanceProfile(this, "InstanceProfile", { roles: [this.role.roleName] }), imageConfig = props.machineImage.getImage(this);
        this.userData = props.userData ?? imageConfig.userData;
        const userDataToken = core_1.Lazy.string({ produce: () => core_1.Fn.base64(this.userData.render()) }), securityGroupsToken = core_1.Lazy.list({ produce: () => this.securityGroups.map((sg) => sg.securityGroupId) }), { subnets } = props.vpc.selectSubnets(props.vpcSubnets);
        let subnet;
        if (props.availabilityZone) {
          const selected = subnets.filter((sn) => sn.availabilityZone === props.availabilityZone);
          selected.length === 1 ? subnet = selected[0] : core_1.Annotations.of(this).addError(`Need exactly 1 subnet to match AZ '${props.availabilityZone}', found ${selected.length}. Use a different availabilityZone.`);
        } else
          subnets.length > 0 ? subnet = subnets[0] : core_1.Annotations.of(this).addError(`Did not find any subnets matching '${JSON.stringify(props.vpcSubnets)}', please use a different selection.`);
        subnet || (subnet = vpc_1.Subnet.fromSubnetAttributes(this, "DummySubnet", { subnetId: "s-notfound", availabilityZone: "az-notfound" })), this.instance = new ec2_generated_1.CfnInstance(this, "Resource", { imageId: imageConfig.imageId, keyName: props.keyName, instanceType: props.instanceType.toString(), securityGroupIds: securityGroupsToken, iamInstanceProfile: iamProfile.ref, userData: userDataToken, subnetId: subnet.subnetId, availabilityZone: subnet.availabilityZone, sourceDestCheck: props.sourceDestCheck, blockDeviceMappings: props.blockDevices !== void 0 ? (0, ebs_util_1.instanceBlockDeviceMappings)(this, props.blockDevices) : void 0, privateIpAddress: props.privateIpAddress, propagateTagsToVolumeOnCreation: props.propagateTagsToVolumeOnCreation, monitoring: props.detailedMonitoring }), this.instance.node.addDependency(this.role), this.osType = imageConfig.osType, this.node.defaultChild = this.instance, this.instanceId = this.instance.ref, this.instanceAvailabilityZone = this.instance.attrAvailabilityZone, this.instancePrivateDnsName = this.instance.attrPrivateDnsName, this.instancePrivateIp = this.instance.attrPrivateIp, this.instancePublicDnsName = this.instance.attrPublicDnsName, this.instancePublicIp = this.instance.attrPublicIp, props.init && this.applyCloudFormationInit(props.init, props.initOptions), this.applyUpdatePolicies(props);
        const originalLogicalId = core_1.Stack.of(this).getLogicalId(this.instance);
        let recursing = false;
        this.instance.overrideLogicalId(core_1.Lazy.uncachedString({ produce: (context) => {
          if (recursing || !(props.userDataCausesReplacement ?? props.initOptions))
            return originalLogicalId;
          const fragments = new Array();
          recursing = true;
          try {
            fragments.push(JSON.stringify(context.resolve(this.userData.render())));
          } finally {
            recursing = false;
          }
          const digest = (0, helpers_internal_1.md5hash)(fragments.join("")).slice(0, 16);
          return `${originalLogicalId}${digest}`;
        } })), props.requireImdsv2 && core_1.Aspects.of(this).add(new aspects_1.InstanceRequireImdsv2Aspect());
      }
      addSecurityGroup(securityGroup) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_ISecurityGroup(securityGroup);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addSecurityGroup), error;
        }
        this.securityGroups.push(securityGroup);
      }
      addUserData(...commands) {
        this.userData.addCommands(...commands);
      }
      addToRolePolicy(statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToRolePolicy), error;
        }
        this.role.addToPrincipalPolicy(statement);
      }
      applyCloudFormationInit(init, options = {}) {
        init.attach(this.instance, { platform: this.osType, instanceRole: this.role, userData: this.userData, configSets: options.configSets, embedFingerprint: options.embedFingerprint, printLog: options.printLog, ignoreFailures: options.ignoreFailures, includeRole: options.includeRole, includeUrl: options.includeUrl }), this.waitForResourceSignal(options.timeout ?? core_1.Duration.minutes(5));
      }
      waitForResourceSignal(timeout) {
        const oldResourceSignal = this.instance.cfnOptions.creationPolicy?.resourceSignal;
        this.instance.cfnOptions.creationPolicy = { ...this.instance.cfnOptions.creationPolicy, resourceSignal: { count: (oldResourceSignal?.count ?? 0) + 1, timeout: (oldResourceSignal?.timeout ? core_1.Duration.parse(oldResourceSignal?.timeout).plus(timeout) : timeout).toIsoString() } };
      }
      applyUpdatePolicies(props) {
        props.resourceSignalTimeout !== void 0 && (this.instance.cfnOptions.creationPolicy = { ...this.instance.cfnOptions.creationPolicy, resourceSignal: { timeout: props.resourceSignalTimeout && props.resourceSignalTimeout.toIsoString() } });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Instance[_a] = { fqn: "aws-cdk-lib.aws_ec2.Instance", version: "2.80.0" }, exports2.Instance = Instance;
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/launch-template.js
var require_launch_template = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/launch-template.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LaunchTemplate = exports2.LaunchTemplateSpecialVersions = exports2.LaunchTemplateHttpTokens = exports2.SpotRequestType = exports2.SpotInstanceInterruption = exports2.InstanceInitiatedShutdownBehavior = exports2.CpuCredits = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var connections_1 = require_connections();
    var ec2_generated_1 = require_ec2_generated();
    var ebs_util_1 = require_ebs_util();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var cxapi = require_cx_api();
    var NAME_TAG = "Name";
    var CpuCredits;
    (function(CpuCredits2) {
      CpuCredits2.STANDARD = "standard", CpuCredits2.UNLIMITED = "unlimited";
    })(CpuCredits = exports2.CpuCredits || (exports2.CpuCredits = {}));
    var InstanceInitiatedShutdownBehavior;
    (function(InstanceInitiatedShutdownBehavior2) {
      InstanceInitiatedShutdownBehavior2.STOP = "stop", InstanceInitiatedShutdownBehavior2.TERMINATE = "terminate";
    })(InstanceInitiatedShutdownBehavior = exports2.InstanceInitiatedShutdownBehavior || (exports2.InstanceInitiatedShutdownBehavior = {}));
    var SpotInstanceInterruption;
    (function(SpotInstanceInterruption2) {
      SpotInstanceInterruption2.STOP = "stop", SpotInstanceInterruption2.TERMINATE = "terminate", SpotInstanceInterruption2.HIBERNATE = "hibernate";
    })(SpotInstanceInterruption = exports2.SpotInstanceInterruption || (exports2.SpotInstanceInterruption = {}));
    var SpotRequestType;
    (function(SpotRequestType2) {
      SpotRequestType2.ONE_TIME = "one-time", SpotRequestType2.PERSISTENT = "persistent";
    })(SpotRequestType = exports2.SpotRequestType || (exports2.SpotRequestType = {}));
    var LaunchTemplateHttpTokens;
    (function(LaunchTemplateHttpTokens2) {
      LaunchTemplateHttpTokens2.OPTIONAL = "optional", LaunchTemplateHttpTokens2.REQUIRED = "required";
    })(LaunchTemplateHttpTokens = exports2.LaunchTemplateHttpTokens || (exports2.LaunchTemplateHttpTokens = {}));
    var LaunchTemplateSpecialVersions = class {
    };
    _a = JSII_RTTI_SYMBOL_1, LaunchTemplateSpecialVersions[_a] = { fqn: "aws-cdk-lib.aws_ec2.LaunchTemplateSpecialVersions", version: "2.80.0" }, LaunchTemplateSpecialVersions.LATEST_VERSION = "$Latest", LaunchTemplateSpecialVersions.DEFAULT_VERSION = "$Default", exports2.LaunchTemplateSpecialVersions = LaunchTemplateSpecialVersions;
    var LaunchTemplate = class _LaunchTemplate extends core_1.Resource {
      static fromLaunchTemplateAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_LaunchTemplateAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromLaunchTemplateAttributes), error;
        }
        const haveId = !!attrs.launchTemplateId, haveName = !!attrs.launchTemplateName;
        if (haveId == haveName)
          throw new Error("LaunchTemplate.fromLaunchTemplateAttributes() requires exactly one of launchTemplateId or launchTemplateName be provided.");
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.versionNumber = attrs.versionNumber ?? LaunchTemplateSpecialVersions.DEFAULT_VERSION, this.launchTemplateId = attrs.launchTemplateId, this.launchTemplateName = attrs.launchTemplateName;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props = {}) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_LaunchTemplateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _LaunchTemplate), error;
        }
        const spotDuration = props?.spotOptions?.blockDuration?.toHours({ integral: true });
        spotDuration !== void 0 && (spotDuration < 1 || spotDuration > 6) && core_1.Annotations.of(this).addError("Spot block duration must be exactly 1, 2, 3, 4, 5, or 6 hours."), props.httpPutResponseHopLimit !== void 0 && (props.httpPutResponseHopLimit < 1 || props.httpPutResponseHopLimit > 64) && core_1.Annotations.of(this).addError("HttpPutResponseHopLimit must between 1 and 64"), this.role = props.role, this._grantPrincipal = this.role;
        const iamProfile = this.role ? new iam.CfnInstanceProfile(this, "Profile", { roles: [this.role.roleName] }) : void 0;
        props.securityGroup && (this._connections = new connections_1.Connections({ securityGroups: [props.securityGroup] }));
        const securityGroupsToken = core_1.Lazy.list({ produce: () => {
          if (this._connections && this._connections.securityGroups.length > 0)
            return this._connections.securityGroups.map((sg) => sg.securityGroupId);
        } }), imageConfig = props.machineImage?.getImage(this);
        imageConfig && (this.osType = imageConfig.osType, this.imageId = imageConfig.imageId), core_1.FeatureFlags.of(this).isEnabled(cxapi.EC2_LAUNCH_TEMPLATE_DEFAULT_USER_DATA) ? this.userData = props.userData ?? imageConfig?.userData : props.userData && (this.userData = props.userData);
        const userDataToken = core_1.Lazy.string({ produce: () => {
          if (this.userData)
            return core_1.Fn.base64(this.userData.render());
        } });
        this.instanceType = props.instanceType;
        let marketOptions;
        props?.spotOptions && (marketOptions = { marketType: "spot", spotOptions: { blockDurationMinutes: spotDuration !== void 0 ? spotDuration * 60 : void 0, instanceInterruptionBehavior: props.spotOptions.interruptionBehavior, maxPrice: props.spotOptions.maxPrice?.toString(), spotInstanceType: props.spotOptions.requestType, validUntil: props.spotOptions.validUntil?.date.toUTCString() } }, Object.keys(marketOptions.spotOptions).filter((k) => marketOptions.spotOptions[k]).length == 0 && (marketOptions.spotOptions = void 0)), this.tags = new core_1.TagManager(core_1.TagType.KEY_VALUE, "AWS::EC2::LaunchTemplate");
        const tagsToken = core_1.Lazy.any({ produce: () => {
          if (this.tags.hasTags()) {
            const lowerCaseRenderedTags = this.tags.renderTags().map((tag) => ({ key: tag.Key, value: tag.Value }));
            return [{ resourceType: "instance", tags: lowerCaseRenderedTags }, { resourceType: "volume", tags: lowerCaseRenderedTags }];
          }
        } }), ltTagsToken = core_1.Lazy.any({ produce: () => {
          if (this.tags.hasTags())
            return [{ resourceType: "launch-template", tags: this.tags.renderTags().map((tag) => ({ key: tag.Key, value: tag.Value })) }];
        } }), resource = new ec2_generated_1.CfnLaunchTemplate(this, "Resource", { launchTemplateName: props?.launchTemplateName, launchTemplateData: { blockDeviceMappings: props?.blockDevices !== void 0 ? (0, ebs_util_1.launchTemplateBlockDeviceMappings)(this, props.blockDevices) : void 0, creditSpecification: props?.cpuCredits !== void 0 ? { cpuCredits: props.cpuCredits } : void 0, disableApiTermination: props?.disableApiTermination, ebsOptimized: props?.ebsOptimized, enclaveOptions: props?.nitroEnclaveEnabled !== void 0 ? { enabled: props.nitroEnclaveEnabled } : void 0, hibernationOptions: props?.hibernationConfigured !== void 0 ? { configured: props.hibernationConfigured } : void 0, iamInstanceProfile: iamProfile !== void 0 ? { arn: iamProfile.getAtt("Arn").toString() } : void 0, imageId: imageConfig?.imageId, instanceType: props?.instanceType?.toString(), instanceInitiatedShutdownBehavior: props?.instanceInitiatedShutdownBehavior, instanceMarketOptions: marketOptions, keyName: props?.keyName, monitoring: props?.detailedMonitoring !== void 0 ? { enabled: props.detailedMonitoring } : void 0, securityGroupIds: securityGroupsToken, tagSpecifications: tagsToken, userData: userDataToken, metadataOptions: this.renderMetadataOptions(props) }, tagSpecifications: ltTagsToken });
        core_1.Tags.of(this).add(NAME_TAG, this.node.path), this.defaultVersionNumber = resource.attrDefaultVersionNumber, this.latestVersionNumber = resource.attrLatestVersionNumber, this.launchTemplateId = resource.ref, this.versionNumber = core_1.Token.asString(resource.getAtt("LatestVersionNumber"));
      }
      renderMetadataOptions(props) {
        let requireMetadataOptions = false;
        if (props.requireImdsv2 === true && props.httpTokens === LaunchTemplateHttpTokens.OPTIONAL && core_1.Annotations.of(this).addError("httpTokens must be required when requireImdsv2 is true"), (props.httpEndpoint !== void 0 || props.httpProtocolIpv6 !== void 0 || props.httpPutResponseHopLimit !== void 0 || props.httpTokens !== void 0 || props.instanceMetadataTags !== void 0 || props.requireImdsv2 === true) && (requireMetadataOptions = true), requireMetadataOptions)
          return { httpEndpoint: props.httpEndpoint === true ? "enabled" : props.httpEndpoint === false ? "disabled" : void 0, httpProtocolIpv6: props.httpProtocolIpv6 === true ? "enabled" : props.httpProtocolIpv6 === false ? "disabled" : void 0, httpPutResponseHopLimit: props.httpPutResponseHopLimit, httpTokens: props.requireImdsv2 === true ? LaunchTemplateHttpTokens.REQUIRED : props.httpTokens, instanceMetadataTags: props.instanceMetadataTags === true ? "enabled" : props.instanceMetadataTags === false ? "disabled" : void 0 };
      }
      get connections() {
        if (!this._connections)
          throw new Error("LaunchTemplate can only be used as IConnectable if a securityGroup is provided when constructing it.");
        return this._connections;
      }
      get grantPrincipal() {
        if (!this._grantPrincipal)
          throw new Error("LaunchTemplate can only be used as IGrantable if a role is provided when constructing it.");
        return this._grantPrincipal;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, LaunchTemplate[_b] = { fqn: "aws-cdk-lib.aws_ec2.LaunchTemplate", version: "2.80.0" }, exports2.LaunchTemplate = LaunchTemplate;
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/aspects/require-imdsv2-aspect.js
var require_require_imdsv2_aspect = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/aspects/require-imdsv2-aspect.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LaunchTemplateRequireImdsv2Aspect = exports2.InstanceRequireImdsv2Aspect = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cxapi = require_cx_api();
    var ec2_generated_1 = require_ec2_generated();
    var instance_1 = require_instance();
    var launch_template_1 = require_launch_template();
    var RequireImdsv2Aspect = class _RequireImdsv2Aspect {
      constructor(props) {
        this.suppressWarnings = props?.suppressWarnings ?? false;
      }
      warn(node, message) {
        this.suppressWarnings !== true && cdk.Annotations.of(node).addWarning(`${_RequireImdsv2Aspect.name} failed on node ${node.node.id}: ${message}`);
      }
    };
    var InstanceRequireImdsv2Aspect = class _InstanceRequireImdsv2Aspect extends RequireImdsv2Aspect {
      constructor(props) {
        super(props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InstanceRequireImdsv2AspectProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _InstanceRequireImdsv2Aspect), error;
        }
        this.suppressLaunchTemplateWarning = props?.suppressLaunchTemplateWarning ?? false;
      }
      visit(node) {
        if (!(node instanceof instance_1.Instance))
          return;
        if (node.instance.launchTemplate !== void 0) {
          this.warn(node, "Cannot toggle IMDSv1 because this Instance is associated with an existing Launch Template.");
          return;
        }
        const launchTemplate = new ec2_generated_1.CfnLaunchTemplate(node, "LaunchTemplate", { launchTemplateData: { metadataOptions: { httpTokens: "required" } } });
        cdk.FeatureFlags.of(node).isEnabled(cxapi.EC2_UNIQUE_IMDSV2_LAUNCH_TEMPLATE_NAME) ? launchTemplate.launchTemplateName = cdk.Names.uniqueId(launchTemplate) : launchTemplate.launchTemplateName = `${node.node.id}LaunchTemplate`, node.instance.launchTemplate = { launchTemplateName: launchTemplate.launchTemplateName, version: launchTemplate.getAtt("LatestVersionNumber").toString() };
      }
      warn(node, message) {
        this.suppressLaunchTemplateWarning !== true && super.warn(node, message);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, InstanceRequireImdsv2Aspect[_a] = { fqn: "aws-cdk-lib.aws_ec2.InstanceRequireImdsv2Aspect", version: "2.80.0" }, exports2.InstanceRequireImdsv2Aspect = InstanceRequireImdsv2Aspect;
    var LaunchTemplateRequireImdsv2Aspect = class _LaunchTemplateRequireImdsv2Aspect extends RequireImdsv2Aspect {
      constructor(props) {
        super(props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_LaunchTemplateRequireImdsv2AspectProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _LaunchTemplateRequireImdsv2Aspect), error;
        }
      }
      visit(node) {
        if (!(node instanceof launch_template_1.LaunchTemplate))
          return;
        const launchTemplate = node.node.tryFindChild("Resource"), data = launchTemplate.launchTemplateData;
        if (cdk.isResolvableObject(data)) {
          this.warn(node, "LaunchTemplateData is a CDK token.");
          return;
        }
        const metadataOptions = data.metadataOptions;
        if (cdk.isResolvableObject(metadataOptions)) {
          this.warn(node, "LaunchTemplateData.MetadataOptions is a CDK token.");
          return;
        }
        const newData = { ...data, metadataOptions: { ...metadataOptions, httpTokens: "required" } };
        launchTemplate.launchTemplateData = newData;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, LaunchTemplateRequireImdsv2Aspect[_b] = { fqn: "aws-cdk-lib.aws_ec2.LaunchTemplateRequireImdsv2Aspect", version: "2.80.0" }, exports2.LaunchTemplateRequireImdsv2Aspect = LaunchTemplateRequireImdsv2Aspect;
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/aspects/index.js
var require_aspects = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/aspects/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_require_imdsv2_aspect(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/bastion-host.js
var require_bastion_host = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/bastion-host.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.BastionHostLinux = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var _1 = require_lib19();
    var instance_1 = require_instance();
    var machine_image_1 = require_machine_image2();
    var port_1 = require_port();
    var aws_iam_1 = require_aws_iam();
    var core_1 = require_core2();
    var BastionHostLinux = class _BastionHostLinux extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_BastionHostLinuxProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _BastionHostLinux), error;
        }
        this.stack = core_1.Stack.of(scope);
        const instanceType = props.instanceType ?? _1.InstanceType.of(_1.InstanceClass.T3, _1.InstanceSize.NANO);
        this.instance = new instance_1.Instance(this, "Resource", { vpc: props.vpc, availabilityZone: props.availabilityZone, securityGroup: props.securityGroup, instanceName: props.instanceName ?? "BastionHost", instanceType, machineImage: props.machineImage ?? machine_image_1.MachineImage.latestAmazonLinux({ generation: _1.AmazonLinuxGeneration.AMAZON_LINUX_2, cpuType: this.toAmazonLinuxCpuType(instanceType.architecture) }), vpcSubnets: props.subnetSelection ?? {}, blockDevices: props.blockDevices ?? void 0, init: props.init, initOptions: props.initOptions, requireImdsv2: props.requireImdsv2 ?? false }), this.instance.addToRolePolicy(new aws_iam_1.PolicyStatement({ actions: ["ssmmessages:*", "ssm:UpdateInstanceInformation", "ec2messages:*"], resources: ["*"] })), this.connections = this.instance.connections, this.role = this.instance.role, this.grantPrincipal = this.instance.role, this.instanceId = this.instance.instanceId, this.instancePrivateIp = this.instance.instancePrivateIp, this.instanceAvailabilityZone = this.instance.instanceAvailabilityZone, this.instancePrivateDnsName = this.instance.instancePrivateDnsName, this.instancePublicIp = this.instance.instancePublicIp, this.instancePublicDnsName = this.instance.instancePublicDnsName, new core_1.CfnOutput(this, "BastionHostId", { description: "Instance ID of the bastion host. Use this to connect via SSM Session Manager", value: this.instanceId });
      }
      toAmazonLinuxCpuType(architecture) {
        if (architecture === _1.InstanceArchitecture.ARM_64)
          return machine_image_1.AmazonLinuxCpuType.ARM_64;
        if (architecture === _1.InstanceArchitecture.X86_64)
          return machine_image_1.AmazonLinuxCpuType.X86_64;
        throw new Error(`Unsupported instance architecture '${architecture}'`);
      }
      allowSshAccessFrom(...peer) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_IPeer(peer);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.allowSshAccessFrom), error;
        }
        peer.forEach((p) => {
          this.connections.allowFrom(p, port_1.Port.tcp(22), "SSH access");
        });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, BastionHostLinux[_a] = { fqn: "aws-cdk-lib.aws_ec2.BastionHostLinux", version: "2.80.0" }, exports2.BastionHostLinux = BastionHostLinux;
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/private/cfn-init-internal.js
var require_cfn_init_internal = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/private/cfn-init-internal.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.InitPlatform = exports2.InitElementType = void 0;
    var InitElementType;
    (function(InitElementType2) {
      InitElementType2.PACKAGE = "PACKAGE", InitElementType2.GROUP = "GROUP", InitElementType2.USER = "USER", InitElementType2.SOURCE = "SOURCE", InitElementType2.FILE = "FILE", InitElementType2.COMMAND = "COMMAND", InitElementType2.SERVICE = "SERVICE";
    })(InitElementType = exports2.InitElementType || (exports2.InitElementType = {}));
    var InitPlatform;
    (function(InitPlatform2) {
      InitPlatform2.WINDOWS = "WINDOWS", InitPlatform2.LINUX = "LINUX";
    })(InitPlatform = exports2.InitPlatform || (exports2.InitPlatform = {}));
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/cfn-init.js
var require_cfn_init = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/cfn-init.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.InitConfig = exports2.CloudFormationInit = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var crypto = require("crypto");
    var machine_image_1 = require_machine_image2();
    var cfn_init_internal_1 = require_cfn_init_internal();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var CloudFormationInit = class _CloudFormationInit {
      static fromElements(...elements) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InitElement(elements);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromElements), error;
        }
        return _CloudFormationInit.fromConfig(new InitConfig(elements));
      }
      static fromConfig(config) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InitConfig(config);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromConfig), error;
        }
        return _CloudFormationInit.fromConfigSets({ configSets: { default: ["config"] }, configs: { config } });
      }
      static fromConfigSets(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_ConfigSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromConfigSets), error;
        }
        return new _CloudFormationInit(props.configSets, props.configs);
      }
      constructor(configSets, configs) {
        this._configSets = {}, this._configs = {}, Object.assign(this._configSets, configSets), Object.assign(this._configs, configs);
      }
      addConfig(configName, config) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InitConfig(config);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addConfig), error;
        }
        if (this._configs[configName])
          throw new Error(`CloudFormationInit already contains a config named '${configName}'`);
        this._configs[configName] = config;
      }
      addConfigSet(configSetName, configNames = []) {
        if (this._configSets[configSetName])
          throw new Error(`CloudFormationInit already contains a configSet named '${configSetName}'`);
        const unk = configNames.filter((c) => !this._configs[c]);
        if (unk.length > 0)
          throw new Error(`Unknown configs referenced in definition of '${configSetName}': ${unk}`);
        this._configSets[configSetName] = [...configNames];
      }
      attach(attachedResource, attachOptions) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnResource(attachedResource), jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_AttachInitOptions(attachOptions);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.attach), error;
        }
        if (attachOptions.platform === machine_image_1.OperatingSystemType.UNKNOWN)
          throw new Error("Cannot attach CloudFormationInit to an unknown OS type");
        const CFN_INIT_METADATA_KEY = "AWS::CloudFormation::Init";
        if (attachedResource.getMetadata(CFN_INIT_METADATA_KEY) !== void 0)
          throw new Error(`Cannot bind CfnInit: resource '${attachedResource.node.path}' already has '${CFN_INIT_METADATA_KEY}' attached`);
        const bindResult = this.bind(attachedResource.stack, attachOptions);
        attachedResource.addMetadata(CFN_INIT_METADATA_KEY, bindResult.configData);
        const fingerprintInput = { config: attachedResource.stack.resolve(bindResult.configData), assetHash: bindResult.assetHash }, fingerprint = contentHash(JSON.stringify(fingerprintInput)).slice(0, 16);
        attachOptions.instanceRole.addToPrincipalPolicy(new iam.PolicyStatement({ actions: ["cloudformation:DescribeStackResource", "cloudformation:SignalResource"], resources: [core_1.Aws.STACK_ID] })), bindResult.authData && attachedResource.addMetadata("AWS::CloudFormation::Authentication", bindResult.authData);
        let resourceLocator = `--region ${core_1.Aws.REGION} --stack ${core_1.Aws.STACK_NAME} --resource ${attachedResource.logicalId}`;
        const signalResource = attachOptions.signalResource?.logicalId ?? attachedResource.logicalId;
        let notifyResourceLocator = `--region ${core_1.Aws.REGION} --stack ${core_1.Aws.STACK_NAME} --resource ${signalResource}`;
        attachOptions.includeUrl && (resourceLocator = `${resourceLocator} --url https://cloudformation.${core_1.Aws.REGION}.${core_1.Aws.URL_SUFFIX}`, notifyResourceLocator = `${notifyResourceLocator} --url https://cloudformation.${core_1.Aws.REGION}.${core_1.Aws.URL_SUFFIX}`), attachOptions.includeRole && (resourceLocator = `${resourceLocator} --role ${attachOptions.instanceRole.roleName}`, notifyResourceLocator = `${notifyResourceLocator} --role ${attachOptions.instanceRole.roleName}`);
        const configSets = (attachOptions.configSets ?? ["default"]).join(","), printLog = attachOptions.printLog ?? true;
        if ((attachOptions.embedFingerprint ?? true) && attachOptions.userData.addCommands(`# fingerprint: ${fingerprint}`), attachOptions.platform === machine_image_1.OperatingSystemType.WINDOWS) {
          const errCode = attachOptions.ignoreFailures ? "0" : "$LASTEXITCODE";
          attachOptions.userData.addCommands(`cfn-init.exe -v ${resourceLocator} -c ${configSets}`, `cfn-signal.exe -e ${errCode} ${notifyResourceLocator}`, ...printLog ? ["type C:\\cfn\\log\\cfn-init.log"] : []);
        } else {
          const errCode = attachOptions.ignoreFailures ? "0" : "$?";
          attachOptions.userData.addCommands("(", "  set +e", `  /opt/aws/bin/cfn-init -v ${resourceLocator} -c ${configSets}`, `  /opt/aws/bin/cfn-signal -e ${errCode} ${notifyResourceLocator}`, ...printLog ? ["  cat /var/log/cfn-init.log >&2"] : [], ")");
        }
      }
      bind(scope, options) {
        const nonEmptyConfigs = mapValues(this._configs, (c) => c.isEmpty() ? void 0 : c), configNameToBindResult = mapValues(nonEmptyConfigs, (c) => c._bind(scope, options));
        return { configData: { configSets: mapValues(this._configSets, (configNames) => configNames.filter((name) => nonEmptyConfigs[name] !== void 0)), ...mapValues(configNameToBindResult, (c) => c.config) }, authData: Object.values(configNameToBindResult).map((c) => c.authentication).reduce(deepMerge, void 0), assetHash: combineAssetHashesOrUndefined(Object.values(configNameToBindResult).map((c) => c.assetHash)) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CloudFormationInit[_a] = { fqn: "aws-cdk-lib.aws_ec2.CloudFormationInit", version: "2.80.0" }, exports2.CloudFormationInit = CloudFormationInit;
    var InitConfig = class {
      constructor(elements) {
        this.elements = new Array(), this.add(...elements);
      }
      isEmpty() {
        return this.elements.length === 0;
      }
      add(...elements) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InitElement(elements);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.add), error;
        }
        this.elements.push(...elements);
      }
      _bind(scope, options) {
        const bindOptions = { instanceRole: options.instanceRole, platform: this.initPlatformFromOSType(options.platform), scope }, packageConfig = this.bindForType(cfn_init_internal_1.InitElementType.PACKAGE, bindOptions), groupsConfig = this.bindForType(cfn_init_internal_1.InitElementType.GROUP, bindOptions), usersConfig = this.bindForType(cfn_init_internal_1.InitElementType.USER, bindOptions), sourcesConfig = this.bindForType(cfn_init_internal_1.InitElementType.SOURCE, bindOptions), filesConfig = this.bindForType(cfn_init_internal_1.InitElementType.FILE, bindOptions), commandsConfig = this.bindForType(cfn_init_internal_1.InitElementType.COMMAND, bindOptions), servicesConfig = this.bindForType(cfn_init_internal_1.InitElementType.SERVICE, bindOptions), allConfig = [packageConfig, groupsConfig, usersConfig, sourcesConfig, filesConfig, commandsConfig, servicesConfig], authentication = allConfig.map((c) => c?.authentication).reduce(deepMerge, void 0), assetHash = combineAssetHashesOrUndefined(allConfig.map((c) => c?.assetHash));
        return { config: { packages: packageConfig?.config, groups: groupsConfig?.config, users: usersConfig?.config, sources: sourcesConfig?.config, files: filesConfig?.config, commands: commandsConfig?.config, services: servicesConfig?.config }, authentication, assetHash };
      }
      bindForType(elementType, renderOptions) {
        const elements = this.elements.filter((elem) => elem.elementType === elementType);
        if (elements.length === 0)
          return;
        const bindResults = elements.map((e, index) => e._bind({ index, ...renderOptions }));
        return { config: bindResults.map((r) => r.config).reduce(deepMerge, void 0) ?? {}, authentication: bindResults.map((r) => r.authentication).reduce(deepMerge, void 0), assetHash: combineAssetHashesOrUndefined(bindResults.map((r) => r.assetHash)) };
      }
      initPlatformFromOSType(osType) {
        switch (osType) {
          case machine_image_1.OperatingSystemType.LINUX:
            return cfn_init_internal_1.InitPlatform.LINUX;
          case machine_image_1.OperatingSystemType.WINDOWS:
            return cfn_init_internal_1.InitPlatform.WINDOWS;
          default:
            throw new Error("Cannot attach CloudFormationInit to an unknown OS type");
        }
      }
    };
    _b = JSII_RTTI_SYMBOL_1, InitConfig[_b] = { fqn: "aws-cdk-lib.aws_ec2.InitConfig", version: "2.80.0" }, exports2.InitConfig = InitConfig;
    function deepMerge(target, src) {
      if (target == null)
        return src;
      if (src == null)
        return target;
      for (const [key, value] of Object.entries(src)) {
        if (Array.isArray(value)) {
          if (target[key] && !Array.isArray(target[key]))
            throw new Error(`Trying to merge array [${value}] into a non-array '${target[key]}'`);
          target[key] = Array.from(/* @__PURE__ */ new Set([...target[key] ?? [], ...value]));
          continue;
        }
        if (typeof value == "object" && value) {
          target[key] = deepMerge(target[key] ?? {}, value);
          continue;
        }
        value !== void 0 && (target[key] = value);
      }
      return target;
    }
    function mapValues(xs, fn) {
      const ret = {};
      for (const [k, v] of Object.entries(xs)) {
        const mapped = fn(v);
        mapped !== void 0 && (ret[k] = mapped);
      }
      return ret;
    }
    function combineAssetHashesOrUndefined(hashes) {
      const hashArray = hashes.filter((x) => x !== void 0);
      return hashArray.length > 0 ? hashArray.join("") : void 0;
    }
    function contentHash(content) {
      return crypto.createHash("sha256").update(content).digest("hex");
    }
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/cfn-init-elements.js
var require_cfn_init_elements = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/cfn-init-elements.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ServiceManager = exports2.InitSource = exports2.InitService = exports2.InitPackage = exports2.InitUser = exports2.InitGroup = exports2.InitFile = exports2.InitCommand = exports2.InitCommandWaitDuration = exports2.InitElement = exports2.InitServiceRestartHandle = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var fs = require("fs");
    var cfn_init_internal_1 = require_cfn_init_internal();
    var s3_assets = require_aws_s3_assets();
    var core_1 = require_core2();
    var InitServiceRestartHandle = class {
      constructor() {
        this.commands = new Array(), this.files = new Array(), this.sources = new Array(), this.packages = {};
      }
      _addCommand(key) {
        return this.commands.push(key);
      }
      _addFile(key) {
        return this.files.push(key);
      }
      _addSource(key) {
        return this.sources.push(key);
      }
      _addPackage(packageType, key) {
        this.packages[packageType] || (this.packages[packageType] = []), this.packages[packageType].push(key);
      }
      _renderRestartHandles() {
        const nonEmpty = (x) => x.length > 0 ? x : void 0;
        return { commands: nonEmpty(this.commands), files: nonEmpty(this.files), packages: Object.keys(this.packages).length > 0 ? this.packages : void 0, sources: nonEmpty(this.sources) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, InitServiceRestartHandle[_a] = { fqn: "aws-cdk-lib.aws_ec2.InitServiceRestartHandle", version: "2.80.0" }, exports2.InitServiceRestartHandle = InitServiceRestartHandle;
    var InitElement = class {
    };
    _b = JSII_RTTI_SYMBOL_1, InitElement[_b] = { fqn: "aws-cdk-lib.aws_ec2.InitElement", version: "2.80.0" }, exports2.InitElement = InitElement;
    var InitCommandWaitDuration = class _InitCommandWaitDuration {
      static of(duration) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Duration(duration);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.of), error;
        }
        return new class extends _InitCommandWaitDuration {
          _render() {
            return duration.toSeconds();
          }
        }();
      }
      static none() {
        return _InitCommandWaitDuration.of(core_1.Duration.seconds(0));
      }
      static forever() {
        return new class extends _InitCommandWaitDuration {
          _render() {
            return "forever";
          }
        }();
      }
    };
    _c = JSII_RTTI_SYMBOL_1, InitCommandWaitDuration[_c] = { fqn: "aws-cdk-lib.aws_ec2.InitCommandWaitDuration", version: "2.80.0" }, exports2.InitCommandWaitDuration = InitCommandWaitDuration;
    var InitCommand = class _InitCommand extends InitElement {
      static shellCommand(shellCommand, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InitCommandOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.shellCommand), error;
        }
        return new _InitCommand(shellCommand, options);
      }
      static argvCommand(argv, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InitCommandOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.argvCommand), error;
        }
        if (argv.length === 0)
          throw new Error("Cannot define argvCommand with an empty arguments");
        return new _InitCommand(argv, options);
      }
      constructor(command, options) {
        super(), this.command = command, this.options = options, this.elementType = cfn_init_internal_1.InitElementType.COMMAND.toString();
      }
      _bind(options) {
        const commandKey = this.options.key || `${options.index}`.padStart(3, "0");
        if (options.platform !== cfn_init_internal_1.InitPlatform.WINDOWS && this.options.waitAfterCompletion !== void 0)
          throw new Error(`Command '${this.command}': 'waitAfterCompletion' is only valid for Windows systems.`);
        for (const handle of this.options.serviceRestartHandles ?? [])
          handle._addCommand(commandKey);
        return { config: { [commandKey]: { command: this.command, env: this.options.env, cwd: this.options.cwd, test: this.options.testCmd, ignoreErrors: this.options.ignoreErrors, waitAfterCompletion: this.options.waitAfterCompletion?._render() } } };
      }
    };
    _d = JSII_RTTI_SYMBOL_1, InitCommand[_d] = { fqn: "aws-cdk-lib.aws_ec2.InitCommand", version: "2.80.0" }, exports2.InitCommand = InitCommand;
    var InitFile = class _InitFile extends InitElement {
      static fromString(fileName, content, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InitFileOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromString), error;
        }
        if (!content)
          throw new Error(`InitFile ${fileName}: cannot create empty file. Please supply at least one character of content.`);
        return new class extends _InitFile {
          _doBind(bindOptions) {
            return { config: this._standardConfig(options, bindOptions.platform, { content, encoding: this.options.base64Encoded ? "base64" : "plain" }) };
          }
        }(fileName, options);
      }
      static symlink(fileName, target, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InitFileOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.symlink), error;
        }
        const { mode, ...otherOptions } = options;
        if (mode && mode.slice(0, 3) !== "120")
          throw new Error("File mode for symlinks must begin with 120XXX");
        return _InitFile.fromString(fileName, target, { mode: mode || "120644", ...otherOptions });
      }
      static fromObject(fileName, obj, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InitFileOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromObject), error;
        }
        return new class extends _InitFile {
          _doBind(bindOptions) {
            return { config: this._standardConfig(options, bindOptions.platform, { content: obj }) };
          }
        }(fileName, options);
      }
      static fromFileInline(targetFileName, sourceFileName, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InitFileOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromFileInline), error;
        }
        const encoding = options.base64Encoded ? "base64" : "utf8", fileContents = fs.readFileSync(sourceFileName).toString(encoding);
        return _InitFile.fromString(targetFileName, fileContents, options);
      }
      static fromUrl(fileName, url, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InitFileOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromUrl), error;
        }
        return new class extends _InitFile {
          _doBind(bindOptions) {
            return { config: this._standardConfig(options, bindOptions.platform, { source: url }) };
          }
        }(fileName, options);
      }
      static fromS3Object(fileName, bucket, key, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_IBucket(bucket), jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InitFileOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromS3Object), error;
        }
        return new class extends _InitFile {
          _doBind(bindOptions) {
            return bucket.grantRead(bindOptions.instanceRole, key), { config: this._standardConfig(options, bindOptions.platform, { source: bucket.urlForObject(key) }), authentication: standardS3Auth(bindOptions.instanceRole, bucket.bucketName) };
          }
        }(fileName, options);
      }
      static fromAsset(targetFileName, path, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InitFileAssetOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromAsset), error;
        }
        return new class extends _InitFile {
          _doBind(bindOptions) {
            const asset = new s3_assets.Asset(bindOptions.scope, `${targetFileName}Asset`, { path, ...options });
            return asset.grantRead(bindOptions.instanceRole), { config: this._standardConfig(options, bindOptions.platform, { source: asset.httpUrl }), authentication: standardS3Auth(bindOptions.instanceRole, asset.s3BucketName), assetHash: asset.assetHash };
          }
        }(targetFileName, options);
      }
      static fromExistingAsset(targetFileName, asset, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_assets_Asset(asset), jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InitFileOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromExistingAsset), error;
        }
        return new class extends _InitFile {
          _doBind(bindOptions) {
            return asset.grantRead(bindOptions.instanceRole), { config: this._standardConfig(options, bindOptions.platform, { source: asset.httpUrl }), authentication: standardS3Auth(bindOptions.instanceRole, asset.s3BucketName), assetHash: asset.assetHash };
          }
        }(targetFileName, options);
      }
      constructor(fileName, options) {
        super(), this.fileName = fileName, this.options = options, this.elementType = cfn_init_internal_1.InitElementType.FILE.toString();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InitFileOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _InitFile), error;
        }
      }
      _bind(bindOptions) {
        for (const handle of this.options.serviceRestartHandles ?? [])
          handle._addFile(this.fileName);
        return this._doBind(bindOptions);
      }
      _standardConfig(fileOptions, platform, contentVars) {
        if (platform === cfn_init_internal_1.InitPlatform.WINDOWS) {
          if (fileOptions.group || fileOptions.owner || fileOptions.mode)
            throw new Error("Owner, group, and mode options not supported for Windows.");
          return { [this.fileName]: { ...contentVars } };
        }
        return { [this.fileName]: { ...contentVars, mode: fileOptions.mode || "000644", owner: fileOptions.owner || "root", group: fileOptions.group || "root" } };
      }
    };
    _e = JSII_RTTI_SYMBOL_1, InitFile[_e] = { fqn: "aws-cdk-lib.aws_ec2.InitFile", version: "2.80.0" }, exports2.InitFile = InitFile;
    var InitGroup = class _InitGroup extends InitElement {
      static fromName(groupName, groupId) {
        return new _InitGroup(groupName, groupId);
      }
      constructor(groupName, groupId) {
        super(), this.groupName = groupName, this.groupId = groupId, this.elementType = cfn_init_internal_1.InitElementType.GROUP.toString();
      }
      _bind(options) {
        if (options.platform === cfn_init_internal_1.InitPlatform.WINDOWS)
          throw new Error("Init groups are not supported on Windows");
        return { config: { [this.groupName]: this.groupId !== void 0 ? { gid: this.groupId } : {} } };
      }
    };
    _f = JSII_RTTI_SYMBOL_1, InitGroup[_f] = { fqn: "aws-cdk-lib.aws_ec2.InitGroup", version: "2.80.0" }, exports2.InitGroup = InitGroup;
    var InitUser = class _InitUser extends InitElement {
      static fromName(userName, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InitUserOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromName), error;
        }
        return new _InitUser(userName, options);
      }
      constructor(userName, userOptions) {
        super(), this.userName = userName, this.userOptions = userOptions, this.elementType = cfn_init_internal_1.InitElementType.USER.toString();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InitUserOptions(userOptions);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _InitUser), error;
        }
      }
      _bind(options) {
        if (options.platform === cfn_init_internal_1.InitPlatform.WINDOWS)
          throw new Error("Init users are not supported on Windows");
        return { config: { [this.userName]: { uid: this.userOptions.userId, groups: this.userOptions.groups, homeDir: this.userOptions.homeDir } } };
      }
    };
    _g = JSII_RTTI_SYMBOL_1, InitUser[_g] = { fqn: "aws-cdk-lib.aws_ec2.InitUser", version: "2.80.0" }, exports2.InitUser = InitUser;
    var InitPackage = class _InitPackage extends InitElement {
      static rpm(location, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_LocationPackageOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.rpm), error;
        }
        return new _InitPackage("rpm", [location], options.key, options.serviceRestartHandles);
      }
      static yum(packageName, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_NamedPackageOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.yum), error;
        }
        return new _InitPackage("yum", options.version ?? [], packageName, options.serviceRestartHandles);
      }
      static rubyGem(gemName, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_NamedPackageOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.rubyGem), error;
        }
        return new _InitPackage("rubygems", options.version ?? [], gemName, options.serviceRestartHandles);
      }
      static python(packageName, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_NamedPackageOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.python), error;
        }
        return new _InitPackage("python", options.version ?? [], packageName, options.serviceRestartHandles);
      }
      static apt(packageName, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_NamedPackageOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.apt), error;
        }
        return new _InitPackage("apt", options.version ?? [], packageName, options.serviceRestartHandles);
      }
      static msi(location, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_LocationPackageOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.msi), error;
        }
        return new class extends _InitPackage {
          renderPackageVersions() {
            return location;
          }
        }("msi", [location], options.key, options.serviceRestartHandles);
      }
      constructor(type, versions, packageName, serviceHandles) {
        super(), this.type = type, this.versions = versions, this.packageName = packageName, this.serviceHandles = serviceHandles, this.elementType = cfn_init_internal_1.InitElementType.PACKAGE.toString();
      }
      _bind(options) {
        if (this.type === "msi" != (options.platform === cfn_init_internal_1.InitPlatform.WINDOWS))
          throw this.type === "msi" ? new Error("MSI installers are only supported on Windows systems.") : new Error("Windows only supports the MSI package type");
        if (!this.packageName && !["rpm", "msi"].includes(this.type))
          throw new Error("Package name must be specified for all package types besides RPM and MSI.");
        const packageName = this.packageName || `${options.index}`.padStart(3, "0");
        for (const handle of this.serviceHandles ?? [])
          handle._addPackage(this.type, packageName);
        return { config: { [this.type]: { [packageName]: this.renderPackageVersions() } } };
      }
      renderPackageVersions() {
        return this.versions;
      }
    };
    _h = JSII_RTTI_SYMBOL_1, InitPackage[_h] = { fqn: "aws-cdk-lib.aws_ec2.InitPackage", version: "2.80.0" }, exports2.InitPackage = InitPackage;
    var InitService = class _InitService extends InitElement {
      static enable(serviceName, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InitServiceOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.enable), error;
        }
        const { enabled, ensureRunning, ...otherOptions } = options;
        return new _InitService(serviceName, { enabled: enabled ?? true, ensureRunning: ensureRunning ?? enabled ?? true, ...otherOptions });
      }
      static disable(serviceName) {
        return new _InitService(serviceName, { enabled: false, ensureRunning: false });
      }
      static systemdConfigFile(serviceName, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_SystemdConfigFileOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.systemdConfigFile), error;
        }
        if (!options.command.startsWith("/"))
          throw new Error(`SystemD executables must use an absolute path, got '${options.command}'`);
        const lines = ["[Unit]", ...options.description ? [`Description=${options.description}`] : [], ...options.afterNetwork ?? true ? ["After=network.target"] : [], "[Service]", `ExecStart=${options.command}`, ...options.cwd ? [`WorkingDirectory=${options.cwd}`] : [], ...options.user ? [`User=${options.user}`] : [], ...options.group ? [`Group=${options.user}`] : [], ...options.keepRunning ?? true ? ["Restart=always"] : [], "[Install]", "WantedBy=multi-user.target"];
        return InitFile.fromString(`/etc/systemd/system/${serviceName}.service`, lines.join(`
`));
      }
      constructor(serviceName, serviceOptions) {
        super(), this.serviceName = serviceName, this.serviceOptions = serviceOptions, this.elementType = cfn_init_internal_1.InitElementType.SERVICE.toString();
      }
      _bind(options) {
        const serviceManager = this.serviceOptions.serviceManager ?? (options.platform === cfn_init_internal_1.InitPlatform.LINUX ? ServiceManager.SYSVINIT : ServiceManager.WINDOWS);
        return { config: { [serviceManagerToString(serviceManager)]: { [this.serviceName]: { enabled: this.serviceOptions.enabled, ensureRunning: this.serviceOptions.ensureRunning, ...this.serviceOptions.serviceRestartHandle?._renderRestartHandles() } } } };
      }
    };
    _j = JSII_RTTI_SYMBOL_1, InitService[_j] = { fqn: "aws-cdk-lib.aws_ec2.InitService", version: "2.80.0" }, exports2.InitService = InitService;
    var InitSource = class _InitSource extends InitElement {
      static fromUrl(targetDirectory, url, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InitSourceOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromUrl), error;
        }
        return new class extends _InitSource {
          _doBind() {
            return { config: { [this.targetDirectory]: url } };
          }
        }(targetDirectory, options.serviceRestartHandles);
      }
      static fromGitHub(targetDirectory, owner, repo, refSpec, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InitSourceOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromGitHub), error;
        }
        return _InitSource.fromUrl(targetDirectory, `https://github.com/${owner}/${repo}/tarball/${refSpec ?? "master"}`, options);
      }
      static fromS3Object(targetDirectory, bucket, key, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_IBucket(bucket), jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InitSourceOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromS3Object), error;
        }
        return new class extends _InitSource {
          _doBind(bindOptions) {
            return bucket.grantRead(bindOptions.instanceRole, key), { config: { [this.targetDirectory]: bucket.urlForObject(key) }, authentication: standardS3Auth(bindOptions.instanceRole, bucket.bucketName) };
          }
        }(targetDirectory, options.serviceRestartHandles);
      }
      static fromAsset(targetDirectory, path, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InitSourceAssetOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromAsset), error;
        }
        return new class extends _InitSource {
          _doBind(bindOptions) {
            const asset = new s3_assets.Asset(bindOptions.scope, `${targetDirectory}Asset`, { path, ...bindOptions });
            return asset.grantRead(bindOptions.instanceRole), { config: { [this.targetDirectory]: asset.httpUrl }, authentication: standardS3Auth(bindOptions.instanceRole, asset.s3BucketName), assetHash: asset.assetHash };
          }
        }(targetDirectory, options.serviceRestartHandles);
      }
      static fromExistingAsset(targetDirectory, asset, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_assets_Asset(asset), jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InitSourceOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromExistingAsset), error;
        }
        return new class extends _InitSource {
          _doBind(bindOptions) {
            return asset.grantRead(bindOptions.instanceRole), { config: { [this.targetDirectory]: asset.httpUrl }, authentication: standardS3Auth(bindOptions.instanceRole, asset.s3BucketName), assetHash: asset.assetHash };
          }
        }(targetDirectory, options.serviceRestartHandles);
      }
      constructor(targetDirectory, serviceHandles) {
        super(), this.targetDirectory = targetDirectory, this.serviceHandles = serviceHandles, this.elementType = cfn_init_internal_1.InitElementType.SOURCE.toString();
      }
      _bind(options) {
        for (const handle of this.serviceHandles ?? [])
          handle._addSource(this.targetDirectory);
        return this._doBind(options);
      }
    };
    _k = JSII_RTTI_SYMBOL_1, InitSource[_k] = { fqn: "aws-cdk-lib.aws_ec2.InitSource", version: "2.80.0" }, exports2.InitSource = InitSource;
    function standardS3Auth(role, bucketName) {
      return { S3AccessCreds: { type: "S3", roleName: role.roleName, buckets: [bucketName] } };
    }
    var ServiceManager;
    (function(ServiceManager2) {
      ServiceManager2[ServiceManager2.SYSVINIT = 0] = "SYSVINIT", ServiceManager2[ServiceManager2.WINDOWS = 1] = "WINDOWS", ServiceManager2[ServiceManager2.SYSTEMD = 2] = "SYSTEMD";
    })(ServiceManager = exports2.ServiceManager || (exports2.ServiceManager = {}));
    function serviceManagerToString(x) {
      switch (x) {
        case ServiceManager.SYSTEMD:
          return "systemd";
        case ServiceManager.SYSVINIT:
          return "sysvinit";
        case ServiceManager.WINDOWS:
          return "windows";
      }
    }
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/instance-types.js
var require_instance_types = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/instance-types.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.InstanceType = exports2.InstanceSize = exports2.InstanceArchitecture = exports2.InstanceClass = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var InstanceClass;
    (function(InstanceClass2) {
      InstanceClass2.STANDARD3 = "standard3", InstanceClass2.M3 = "m3", InstanceClass2.STANDARD4 = "standard4", InstanceClass2.M4 = "m4", InstanceClass2.STANDARD5 = "standard5", InstanceClass2.M5 = "m5", InstanceClass2.STANDARD5_NVME_DRIVE = "standard5-nvme-drive", InstanceClass2.M5D = "m5d", InstanceClass2.STANDARD5_AMD = "standard5-amd", InstanceClass2.M5A = "m5a", InstanceClass2.STANDARD5_AMD_NVME_DRIVE = "standard5-amd-nvme-drive", InstanceClass2.M5AD = "m5ad", InstanceClass2.STANDARD5_HIGH_PERFORMANCE = "standard5-high-performance", InstanceClass2.M5N = "m5n", InstanceClass2.STANDARD5_NVME_DRIVE_HIGH_PERFORMANCE = "standard5-nvme-drive-high-performance", InstanceClass2.M5DN = "m5dn", InstanceClass2.STANDARD5_HIGH_COMPUTE = "standard5-high-compute", InstanceClass2.M5ZN = "m5zn", InstanceClass2.MEMORY3 = "memory3", InstanceClass2.R3 = "r3", InstanceClass2.MEMORY4 = "memory4", InstanceClass2.R4 = "r4", InstanceClass2.MEMORY5 = "memory5", InstanceClass2.R5 = "r5", InstanceClass2.MEMORY6_AMD = "memory6-amd", InstanceClass2.R6A = "r6a", InstanceClass2.MEMORY6_INTEL = "memory6-intel", InstanceClass2.R6I = "r6i", InstanceClass2.MEMORY6_INTEL_NVME_DRIVE = "memory6-intel-nvme-drive", InstanceClass2.R6ID = "r6id", InstanceClass2.MEMORY5_HIGH_PERFORMANCE = "memory5-high-performance", InstanceClass2.R5N = "r5n", InstanceClass2.MEMORY5_NVME_DRIVE = "memory5-nvme-drive", InstanceClass2.R5D = "r5d", InstanceClass2.MEMORY5_NVME_DRIVE_HIGH_PERFORMANCE = "memory5-nvme-drive-high-performance", InstanceClass2.R5DN = "r5dn", InstanceClass2.MEMORY5_AMD = "memory5-amd", InstanceClass2.R5A = "r5a", InstanceClass2.MEMORY5_AMD_NVME_DRIVE = "memory5-amd-nvme-drive", InstanceClass2.HIGH_MEMORY_3TB_1 = "high-memory-3tb-1", InstanceClass2.U_3TB1 = "u-3tb1", InstanceClass2.HIGH_MEMORY_6TB_1 = "high-memory-6tb-1", InstanceClass2.U_6TB1 = "u-6tb1", InstanceClass2.HIGH_MEMORY_9TB_1 = "high-memory-9tb-1", InstanceClass2.U_9TB1 = "u-9tb1", InstanceClass2.HIGH_MEMORY_12TB_1 = "high-memory-12tb-1", InstanceClass2.U_12TB1 = "u-12tb1", InstanceClass2.HIGH_MEMORY_18TB_1 = "high-memory-18tb-1", InstanceClass2.U_18TB1 = "u-18tb1", InstanceClass2.HIGH_MEMORY_24TB_1 = "high-memory-24tb-1", InstanceClass2.U_24TB1 = "u-24tb1", InstanceClass2.R5AD = "r5ad", InstanceClass2.MEMORY5_EBS_OPTIMIZED = "memory5-ebs-optimized", InstanceClass2.R5B = "r5b", InstanceClass2.MEMORY6_GRAVITON = "memory6-graviton", InstanceClass2.R6G = "r6g", InstanceClass2.MEMORY6_GRAVITON2_NVME_DRIVE = "memory6-graviton2-nvme-drive", InstanceClass2.R6GD = "r6gd", InstanceClass2.MEMORY7_GRAVITON = "memory7-graviton", InstanceClass2.R7G = "r7g", InstanceClass2.COMPUTE3 = "compute3", InstanceClass2.C3 = "c3", InstanceClass2.COMPUTE4 = "compute4", InstanceClass2.C4 = "c4", InstanceClass2.COMPUTE5 = "compute5", InstanceClass2.C5 = "c5", InstanceClass2.COMPUTE5_NVME_DRIVE = "compute5-nvme-drive", InstanceClass2.C5D = "c5d", InstanceClass2.COMPUTE5_AMD = "compute5-amd", InstanceClass2.C5A = "c5a", InstanceClass2.COMPUTE5_AMD_NVME_DRIVE = "compute5-amd-nvme-drive", InstanceClass2.C5AD = "c5ad", InstanceClass2.COMPUTE5_HIGH_PERFORMANCE = "compute5-high-performance", InstanceClass2.C5N = "c5n", InstanceClass2.COMPUTE6_INTEL = "compute6-intel", InstanceClass2.C6I = "c6i", InstanceClass2.COMPUTE6_INTEL_NVME_DRIVE = "compute6-intel-nvme-drive", InstanceClass2.C6ID = "c6id", InstanceClass2.COMPUTE6_INTEL_HIGH_PERFORMANCE = "compute6-intel-high-performance", InstanceClass2.C6IN = "c6in", InstanceClass2.COMPUTE6_AMD = "compute6-amd", InstanceClass2.C6A = "c6a", InstanceClass2.COMPUTE6_GRAVITON2 = "compute6-graviton2", InstanceClass2.C6G = "c6g", InstanceClass2.COMPUTE7_GRAVITON3 = "compute7-graviton3", InstanceClass2.C7G = "c7g", InstanceClass2.COMPUTE6_GRAVITON2_NVME_DRIVE = "compute6-graviton2-nvme-drive", InstanceClass2.C6GD = "c6gd", InstanceClass2.COMPUTE6_GRAVITON2_HIGH_NETWORK_BANDWIDTH = "compute6-graviton2-high-network-bandwidth", InstanceClass2.C6GN = "c6gn", InstanceClass2.STORAGE2 = "storage2", InstanceClass2.D2 = "d2", InstanceClass2.STORAGE3 = "storage3", InstanceClass2.D3 = "d3", InstanceClass2.STORAGE3_ENHANCED_NETWORK = "storage3-enhanced-network", InstanceClass2.D3EN = "d3en", InstanceClass2.STORAGE_COMPUTE_1 = "storage-compute-1", InstanceClass2.H1 = "h1", InstanceClass2.IO3 = "io3", InstanceClass2.I3 = "i3", InstanceClass2.IO3_DENSE_NVME_DRIVE = "io3-dense-nvme-drive", InstanceClass2.I3EN = "i3en", InstanceClass2.IO4_INTEL = "io4_intel", InstanceClass2.I4I = "i4i", InstanceClass2.STORAGE4_GRAVITON_NETWORK_OPTIMIZED = "storage4-graviton-network-optimized", InstanceClass2.IM4GN = "im4gn", InstanceClass2.STORAGE4_GRAVITON_NETWORK_STORAGE_OPTIMIZED = "storage4-graviton-network-storage-optimized", InstanceClass2.IS4GEN = "is4gen", InstanceClass2.BURSTABLE2 = "burstable2", InstanceClass2.T2 = "t2", InstanceClass2.BURSTABLE3 = "burstable3", InstanceClass2.T3 = "t3", InstanceClass2.BURSTABLE3_AMD = "burstable3-amd", InstanceClass2.T3A = "t3a", InstanceClass2.BURSTABLE4_GRAVITON = "burstable4-graviton", InstanceClass2.T4G = "t4g", InstanceClass2.MEMORY_INTENSIVE_1 = "memory-intensive-1", InstanceClass2.X1 = "x1", InstanceClass2.MEMORY_INTENSIVE_1_EXTENDED = "memory-intensive-1-extended", InstanceClass2.X1E = "x1e", InstanceClass2.MEMORY_INTENSIVE_2_GRAVITON2 = "memory-intensive-2-graviton2", InstanceClass2.X2G = "x2g", InstanceClass2.MEMORY_INTENSIVE_2_GRAVITON2_NVME_DRIVE = "memory-intensive-2-graviton2-nvme-drive", InstanceClass2.X2GD = "x2gd", InstanceClass2.MEMORY_INTENSIVE_2_XT_INTEL = "memory_intensive_2_xt_intel", InstanceClass2.X2IEDN = "x2iedn", InstanceClass2.MEMORY_INTENSIVE_2_INTEL = "memory_intensive_2_intel", InstanceClass2.X2IDN = "x2idn", InstanceClass2.MEMORY_INTENSIVE_2_XTZ_INTEL = "memory_intensive_2_xtz_intel", InstanceClass2.X2IEZN = "x2iezn", InstanceClass2.FPGA1 = "fpga1", InstanceClass2.F1 = "f1", InstanceClass2.GRAPHICS3_SMALL = "graphics3-small", InstanceClass2.G3S = "g3s", InstanceClass2.GRAPHICS3 = "graphics3", InstanceClass2.G3 = "g3", InstanceClass2.GRAPHICS4_NVME_DRIVE_HIGH_PERFORMANCE = "graphics4-nvme-drive-high-performance", InstanceClass2.G4DN = "g4dn", InstanceClass2.GRAPHICS4_AMD_NVME_DRIVE = "graphics4-amd-nvme-drive", InstanceClass2.G4AD = "g4ad", InstanceClass2.GRAPHICS5 = "graphics5", InstanceClass2.G5 = "g5", InstanceClass2.GRAPHICS5_GRAVITON2 = "graphics5-graviton2", InstanceClass2.G5G = "g5g", InstanceClass2.PARALLEL2 = "parallel2", InstanceClass2.P2 = "p2", InstanceClass2.PARALLEL3 = "parallel3", InstanceClass2.P3 = "p3", InstanceClass2.PARALLEL3_NVME_DRIVE_HIGH_PERFORMANCE = "parallel3-nvme-drive-high-performance", InstanceClass2.P3DN = "p3dn", InstanceClass2.PARALLEL4_NVME_DRIVE_EXTENDED = "parallel4-nvme-drive-extended", InstanceClass2.P4DE = "p4de", InstanceClass2.PARALLEL4 = "parallel4", InstanceClass2.P4D = "p4d", InstanceClass2.ARM1 = "arm1", InstanceClass2.A1 = "a1", InstanceClass2.STANDARD6_GRAVITON = "standard6-graviton", InstanceClass2.M6G = "m6g", InstanceClass2.STANDARD6_INTEL = "standard6-intel", InstanceClass2.M6I = "m6i", InstanceClass2.STANDARD6_INTEL_NVME_DRIVE = "standard6-intel-nvme-drive", InstanceClass2.M6ID = "m6id", InstanceClass2.STANDARD6_AMD = "standard6-amd", InstanceClass2.M6A = "m6a", InstanceClass2.STANDARD6_GRAVITON2_NVME_DRIVE = "standard6-graviton2-nvme-drive", InstanceClass2.M6GD = "m6gd", InstanceClass2.STANDARD7_GRAVITON = "standard7-graviton", InstanceClass2.M7G = "m7g", InstanceClass2.HIGH_COMPUTE_MEMORY1 = "high-compute-memory1", InstanceClass2.Z1D = "z1d", InstanceClass2.INFERENCE1 = "inference1", InstanceClass2.INF1 = "inf1", InstanceClass2.INFERENCE2 = "inference2", InstanceClass2.INF2 = "inf2", InstanceClass2.MACINTOSH1_INTEL = "macintosh1-intel", InstanceClass2.MAC1 = "mac1", InstanceClass2.VIDEO_TRANSCODING1 = "video-transcoding1", InstanceClass2.VT1 = "vt1", InstanceClass2.HIGH_PERFORMANCE_COMPUTING6_AMD = "high-performance-computing6-amd", InstanceClass2.HPC6A = "hpc6a", InstanceClass2.DEEP_LEARNING1 = "deep-learning1", InstanceClass2.DL1 = "dl1";
    })(InstanceClass = exports2.InstanceClass || (exports2.InstanceClass = {}));
    var InstanceArchitecture;
    (function(InstanceArchitecture2) {
      InstanceArchitecture2.ARM_64 = "arm64", InstanceArchitecture2.X86_64 = "x86_64";
    })(InstanceArchitecture = exports2.InstanceArchitecture || (exports2.InstanceArchitecture = {}));
    var InstanceSize;
    (function(InstanceSize2) {
      InstanceSize2.NANO = "nano", InstanceSize2.MICRO = "micro", InstanceSize2.SMALL = "small", InstanceSize2.MEDIUM = "medium", InstanceSize2.LARGE = "large", InstanceSize2.XLARGE = "xlarge", InstanceSize2.XLARGE2 = "2xlarge", InstanceSize2.XLARGE3 = "3xlarge", InstanceSize2.XLARGE4 = "4xlarge", InstanceSize2.XLARGE6 = "6xlarge", InstanceSize2.XLARGE8 = "8xlarge", InstanceSize2.XLARGE9 = "9xlarge", InstanceSize2.XLARGE10 = "10xlarge", InstanceSize2.XLARGE12 = "12xlarge", InstanceSize2.XLARGE16 = "16xlarge", InstanceSize2.XLARGE18 = "18xlarge", InstanceSize2.XLARGE24 = "24xlarge", InstanceSize2.XLARGE32 = "32xlarge", InstanceSize2.XLARGE48 = "48xlarge", InstanceSize2.XLARGE56 = "56xlarge", InstanceSize2.XLARGE112 = "112xlarge", InstanceSize2.METAL = "metal";
    })(InstanceSize = exports2.InstanceSize || (exports2.InstanceSize = {}));
    var InstanceType = class _InstanceType {
      static of(instanceClass, instanceSize) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InstanceClass(instanceClass), jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InstanceSize(instanceSize);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.of), error;
        }
        const instanceClassMap = { [InstanceClass.STANDARD3]: "m3", [InstanceClass.M3]: "m3", [InstanceClass.STANDARD4]: "m4", [InstanceClass.M4]: "m4", [InstanceClass.STANDARD5]: "m5", [InstanceClass.M5]: "m5", [InstanceClass.STANDARD5_NVME_DRIVE]: "m5d", [InstanceClass.M5D]: "m5d", [InstanceClass.STANDARD5_AMD]: "m5a", [InstanceClass.M5A]: "m5a", [InstanceClass.STANDARD5_AMD_NVME_DRIVE]: "m5ad", [InstanceClass.M5AD]: "m5ad", [InstanceClass.STANDARD5_HIGH_PERFORMANCE]: "m5n", [InstanceClass.M5N]: "m5n", [InstanceClass.STANDARD5_NVME_DRIVE_HIGH_PERFORMANCE]: "m5dn", [InstanceClass.M5DN]: "m5dn", [InstanceClass.STANDARD5_HIGH_COMPUTE]: "m5zn", [InstanceClass.M5ZN]: "m5zn", [InstanceClass.MEMORY3]: "r3", [InstanceClass.R3]: "r3", [InstanceClass.MEMORY4]: "r4", [InstanceClass.R4]: "r4", [InstanceClass.MEMORY5]: "r5", [InstanceClass.R5]: "r5", [InstanceClass.MEMORY6_AMD]: "r6a", [InstanceClass.R6A]: "r6a", [InstanceClass.MEMORY6_INTEL]: "r6i", [InstanceClass.R6I]: "r6i", [InstanceClass.MEMORY6_INTEL_NVME_DRIVE]: "r6id", [InstanceClass.R6ID]: "r6id", [InstanceClass.MEMORY5_HIGH_PERFORMANCE]: "r5n", [InstanceClass.R5N]: "r5n", [InstanceClass.MEMORY5_NVME_DRIVE]: "r5d", [InstanceClass.R5D]: "r5d", [InstanceClass.MEMORY5_NVME_DRIVE_HIGH_PERFORMANCE]: "r5dn", [InstanceClass.R5DN]: "r5dn", [InstanceClass.MEMORY5_AMD]: "r5a", [InstanceClass.R5A]: "r5a", [InstanceClass.MEMORY5_AMD_NVME_DRIVE]: "r5ad", [InstanceClass.R5AD]: "r5ad", [InstanceClass.HIGH_MEMORY_3TB_1]: "u-3tb1", [InstanceClass.U_3TB1]: "u-3tb1", [InstanceClass.HIGH_MEMORY_6TB_1]: "u-6tb1", [InstanceClass.U_6TB1]: "u-6tb1", [InstanceClass.HIGH_MEMORY_9TB_1]: "u-9tb1", [InstanceClass.U_9TB1]: "u-9tb1", [InstanceClass.HIGH_MEMORY_12TB_1]: "u-12tb1", [InstanceClass.U_12TB1]: "u-12tb1", [InstanceClass.HIGH_MEMORY_18TB_1]: "u-18tb1", [InstanceClass.U_18TB1]: "u-18tb1", [InstanceClass.HIGH_MEMORY_24TB_1]: "u-24tb1", [InstanceClass.U_24TB1]: "u-24tb1", [InstanceClass.MEMORY5_EBS_OPTIMIZED]: "r5b", [InstanceClass.R5B]: "r5b", [InstanceClass.MEMORY6_GRAVITON]: "r6g", [InstanceClass.R6G]: "r6g", [InstanceClass.MEMORY6_GRAVITON2_NVME_DRIVE]: "r6gd", [InstanceClass.R6GD]: "r6gd", [InstanceClass.MEMORY7_GRAVITON]: "r7g", [InstanceClass.R7G]: "r7g", [InstanceClass.COMPUTE3]: "c3", [InstanceClass.C3]: "c3", [InstanceClass.COMPUTE4]: "c4", [InstanceClass.C4]: "c4", [InstanceClass.COMPUTE5]: "c5", [InstanceClass.C5]: "c5", [InstanceClass.COMPUTE5_NVME_DRIVE]: "c5d", [InstanceClass.C5D]: "c5d", [InstanceClass.COMPUTE5_AMD]: "c5a", [InstanceClass.C5A]: "c5a", [InstanceClass.COMPUTE5_AMD_NVME_DRIVE]: "c5ad", [InstanceClass.C5AD]: "c5ad", [InstanceClass.COMPUTE5_HIGH_PERFORMANCE]: "c5n", [InstanceClass.C5N]: "c5n", [InstanceClass.COMPUTE6_INTEL]: "c6i", [InstanceClass.C6I]: "c6i", [InstanceClass.COMPUTE6_INTEL_HIGH_PERFORMANCE]: "c6in", [InstanceClass.C6IN]: "c6in", [InstanceClass.COMPUTE6_INTEL_NVME_DRIVE]: "c6id", [InstanceClass.C6ID]: "c6id", [InstanceClass.COMPUTE6_AMD]: "c6a", [InstanceClass.C6A]: "c6a", [InstanceClass.COMPUTE6_GRAVITON2]: "c6g", [InstanceClass.C6G]: "c6g", [InstanceClass.COMPUTE6_GRAVITON2_NVME_DRIVE]: "c6gd", [InstanceClass.C6GD]: "c6gd", [InstanceClass.COMPUTE6_GRAVITON2_HIGH_NETWORK_BANDWIDTH]: "c6gn", [InstanceClass.C6GN]: "c6gn", [InstanceClass.COMPUTE7_GRAVITON3]: "c7g", [InstanceClass.C7G]: "c7g", [InstanceClass.STORAGE2]: "d2", [InstanceClass.D2]: "d2", [InstanceClass.STORAGE3]: "d3", [InstanceClass.D3]: "d3", [InstanceClass.STORAGE3_ENHANCED_NETWORK]: "d3en", [InstanceClass.D3EN]: "d3en", [InstanceClass.STORAGE_COMPUTE_1]: "h1", [InstanceClass.H1]: "h1", [InstanceClass.IO3]: "i3", [InstanceClass.I3]: "i3", [InstanceClass.IO3_DENSE_NVME_DRIVE]: "i3en", [InstanceClass.I3EN]: "i3en", [InstanceClass.STORAGE4_GRAVITON_NETWORK_OPTIMIZED]: "im4gn", [InstanceClass.IM4GN]: "im4gn", [InstanceClass.STORAGE4_GRAVITON_NETWORK_STORAGE_OPTIMIZED]: "is4gen", [InstanceClass.IS4GEN]: "is4gen", [InstanceClass.BURSTABLE2]: "t2", [InstanceClass.T2]: "t2", [InstanceClass.BURSTABLE3]: "t3", [InstanceClass.T3]: "t3", [InstanceClass.BURSTABLE3_AMD]: "t3a", [InstanceClass.T3A]: "t3a", [InstanceClass.BURSTABLE4_GRAVITON]: "t4g", [InstanceClass.T4G]: "t4g", [InstanceClass.MEMORY_INTENSIVE_1]: "x1", [InstanceClass.X1]: "x1", [InstanceClass.MEMORY_INTENSIVE_1_EXTENDED]: "x1e", [InstanceClass.X1E]: "x1e", [InstanceClass.MEMORY_INTENSIVE_2_GRAVITON2]: "x2g", [InstanceClass.X2G]: "x2g", [InstanceClass.MEMORY_INTENSIVE_2_GRAVITON2_NVME_DRIVE]: "x2gd", [InstanceClass.X2GD]: "x2gd", [InstanceClass.FPGA1]: "f1", [InstanceClass.F1]: "f1", [InstanceClass.GRAPHICS3_SMALL]: "g3s", [InstanceClass.G3S]: "g3s", [InstanceClass.GRAPHICS3]: "g3", [InstanceClass.G3]: "g3", [InstanceClass.GRAPHICS4_NVME_DRIVE_HIGH_PERFORMANCE]: "g4dn", [InstanceClass.G4DN]: "g4dn", [InstanceClass.GRAPHICS4_AMD_NVME_DRIVE]: "g4ad", [InstanceClass.G4AD]: "g4ad", [InstanceClass.GRAPHICS5]: "g5", [InstanceClass.G5]: "g5", [InstanceClass.GRAPHICS5_GRAVITON2]: "g5g", [InstanceClass.G5G]: "g5g", [InstanceClass.PARALLEL2]: "p2", [InstanceClass.P2]: "p2", [InstanceClass.PARALLEL3]: "p3", [InstanceClass.P3]: "p3", [InstanceClass.PARALLEL3_NVME_DRIVE_HIGH_PERFORMANCE]: "p3dn", [InstanceClass.P3DN]: "p3dn", [InstanceClass.PARALLEL4_NVME_DRIVE_EXTENDED]: "p4de", [InstanceClass.P4DE]: "p4de", [InstanceClass.PARALLEL4]: "p4d", [InstanceClass.P4D]: "p4d", [InstanceClass.ARM1]: "a1", [InstanceClass.A1]: "a1", [InstanceClass.STANDARD6_GRAVITON]: "m6g", [InstanceClass.M6G]: "m6g", [InstanceClass.STANDARD6_INTEL]: "m6i", [InstanceClass.M6I]: "m6i", [InstanceClass.STANDARD6_INTEL_NVME_DRIVE]: "m6id", [InstanceClass.M6ID]: "m6id", [InstanceClass.STANDARD6_AMD]: "m6a", [InstanceClass.M6A]: "m6a", [InstanceClass.STANDARD6_GRAVITON2_NVME_DRIVE]: "m6gd", [InstanceClass.M6GD]: "m6gd", [InstanceClass.STANDARD7_GRAVITON]: "m7g", [InstanceClass.M7G]: "m7g", [InstanceClass.HIGH_COMPUTE_MEMORY1]: "z1d", [InstanceClass.Z1D]: "z1d", [InstanceClass.INFERENCE1]: "inf1", [InstanceClass.INF1]: "inf1", [InstanceClass.INFERENCE2]: "inf2", [InstanceClass.INF2]: "inf2", [InstanceClass.MACINTOSH1_INTEL]: "mac1", [InstanceClass.MAC1]: "mac1", [InstanceClass.VIDEO_TRANSCODING1]: "vt1", [InstanceClass.VT1]: "vt1", [InstanceClass.HIGH_PERFORMANCE_COMPUTING6_AMD]: "hpc6a", [InstanceClass.HPC6A]: "hpc6a", [InstanceClass.I4I]: "i4i", [InstanceClass.IO4_INTEL]: "i4i", [InstanceClass.X2IEDN]: "x2iedn", [InstanceClass.MEMORY_INTENSIVE_2_XT_INTEL]: "x2iedn", [InstanceClass.X2IDN]: "x2idn", [InstanceClass.MEMORY_INTENSIVE_2_INTEL]: "x2idn", [InstanceClass.X2IEZN]: "x2iezn", [InstanceClass.MEMORY_INTENSIVE_2_XTZ_INTEL]: "x2iezn", [InstanceClass.DEEP_LEARNING1]: "dl1", [InstanceClass.DL1]: "dl1" };
        return new _InstanceType(`${instanceClassMap[instanceClass] ?? instanceClass}.${instanceSize}`);
      }
      constructor(instanceTypeIdentifier) {
        this.instanceTypeIdentifier = instanceTypeIdentifier;
      }
      toString() {
        return this.instanceTypeIdentifier;
      }
      get architecture() {
        const instanceTypeComponents = this.instanceTypeIdentifier.match(/^([a-z]+)(\d{1,2})([a-z]*)\.([a-z0-9]+)$/);
        if (instanceTypeComponents == null)
          throw new Error("Malformed instance type identifier");
        const family = instanceTypeComponents[1], capabilities = instanceTypeComponents[3];
        return family === "a" || capabilities.includes("g") ? InstanceArchitecture.ARM_64 : InstanceArchitecture.X86_64;
      }
      sameInstanceClassAs(other) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InstanceType(other);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.sameInstanceClassAs), error;
        }
        const instanceClass = /^([a-z]+\d{1,2}[a-z]*)\.([a-z0-9]+)$/, instanceClassId = this.instanceTypeIdentifier.match(instanceClass), otherInstanceClassId = other.instanceTypeIdentifier.match(instanceClass);
        if (instanceClassId == null || otherInstanceClassId == null)
          throw new Error("Malformed instance type identifier");
        return instanceClassId[1] === otherInstanceClassId[1];
      }
    };
    _a = JSII_RTTI_SYMBOL_1, InstanceType[_a] = { fqn: "aws-cdk-lib.aws_ec2.InstanceType", version: "2.80.0" }, exports2.InstanceType = InstanceType;
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/network-acl-types.js
var require_network_acl_types = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/network-acl-types.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AclTraffic = exports2.AclCidr = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var AclCidr = class _AclCidr {
      static ipv4(ipv4Cidr) {
        return new AclCidrImpl({ cidrBlock: ipv4Cidr });
      }
      static anyIpv4() {
        return _AclCidr.ipv4("0.0.0.0/0");
      }
      static ipv6(ipv6Cidr) {
        return new AclCidrImpl({ ipv6CidrBlock: ipv6Cidr });
      }
      static anyIpv6() {
        return _AclCidr.ipv6("::/0");
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AclCidr[_a] = { fqn: "aws-cdk-lib.aws_ec2.AclCidr", version: "2.80.0" }, exports2.AclCidr = AclCidr;
    var AclCidrImpl = class extends AclCidr {
      constructor(config) {
        super(), this.config = config;
      }
      toCidrConfig() {
        return this.config;
      }
    };
    var AclTraffic = class {
      static allTraffic() {
        return new AclTrafficImpl({ protocol: -1 });
      }
      static icmp(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_AclIcmp(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.icmp), error;
        }
        return new AclTrafficImpl({ protocol: 1, icmp: props });
      }
      static icmpv6(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_AclIcmp(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.icmpv6), error;
        }
        return new AclTrafficImpl({ protocol: 58, icmp: props });
      }
      static tcpPort(port) {
        return new AclTrafficImpl({ protocol: 6, portRange: { from: port, to: port } });
      }
      static tcpPortRange(startPort, endPort) {
        return new AclTrafficImpl({ protocol: 6, portRange: { from: startPort, to: endPort } });
      }
      static udpPort(port) {
        return new AclTrafficImpl({ protocol: 17, portRange: { from: port, to: port } });
      }
      static udpPortRange(startPort, endPort) {
        return new AclTrafficImpl({ protocol: 17, portRange: { from: startPort, to: endPort } });
      }
    };
    _b = JSII_RTTI_SYMBOL_1, AclTraffic[_b] = { fqn: "aws-cdk-lib.aws_ec2.AclTraffic", version: "2.80.0" }, exports2.AclTraffic = AclTraffic;
    var AclTrafficImpl = class extends AclTraffic {
      constructor(config) {
        super(), this.config = config;
      }
      toTrafficConfig() {
        return this.config;
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/prefix-list.js
var require_prefix_list = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/prefix-list.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PrefixList = exports2.AddressFamily = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var ec2_generated_1 = require_ec2_generated();
    var core_1 = require_core2();
    var AddressFamily;
    (function(AddressFamily2) {
      AddressFamily2.IP_V4 = "IPv4", AddressFamily2.IP_V6 = "IPv6";
    })(AddressFamily = exports2.AddressFamily || (exports2.AddressFamily = {}));
    var PrefixListBase = class extends core_1.Resource {
    };
    var PrefixList = class _PrefixList extends PrefixListBase {
      static fromPrefixListId(scope, id, prefixListId) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.prefixListId = prefixListId;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props?.prefixListName ?? core_1.Lazy.string({ produce: () => core_1.Names.uniqueResourceName(this, { maxLength: 255, allowedSpecialCharacters: ".-_" }) }) });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_PrefixListProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _PrefixList), error;
        }
        if (props?.prefixListName) {
          if (props.prefixListName.startsWith("com.amazonaws"))
            throw new Error("The name cannot start with 'com.amazonaws.'");
          if (props.prefixListName.length > 255)
            throw new Error("Lengths exceeding 255 characters cannot be set.");
        }
        this.prefixListName = this.physicalName;
        let defaultMaxEntries = 1;
        if (props?.entries && props.entries.length > 0) {
          const entries = props.entries;
          if (props?.addressFamily === AddressFamily.IP_V6) {
            const ipv6Regex = /^s*((([0-9A-Fa-f]{1,4}:){7}([0-9A-Fa-f]{1,4}|:))|(([0-9A-Fa-f]{1,4}:){6}(:[0-9A-Fa-f]{1,4}|((25[0-5]|2[0-4]d|1dd|[1-9]?d)(.(25[0-5]|2[0-4]d|1dd|[1-9]?d)){3})|:))|(([0-9A-Fa-f]{1,4}:){5}(((:[0-9A-Fa-f]{1,4}){1,2})|:((25[0-5]|2[0-4]d|1dd|[1-9]?d)(.(25[0-5]|2[0-4]d|1dd|[1-9]?d)){3})|:))|(([0-9A-Fa-f]{1,4}:){4}(((:[0-9A-Fa-f]{1,4}){1,3})|((:[0-9A-Fa-f]{1,4})?:((25[0-5]|2[0-4]d|1dd|[1-9]?d)(.(25[0-5]|2[0-4]d|1dd|[1-9]?d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){3}(((:[0-9A-Fa-f]{1,4}){1,4})|((:[0-9A-Fa-f]{1,4}){0,2}:((25[0-5]|2[0-4]d|1dd|[1-9]?d)(.(25[0-5]|2[0-4]d|1dd|[1-9]?d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){2}(((:[0-9A-Fa-f]{1,4}){1,5})|((:[0-9A-Fa-f]{1,4}){0,3}:((25[0-5]|2[0-4]d|1dd|[1-9]?d)(.(25[0-5]|2[0-4]d|1dd|[1-9]?d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){1}(((:[0-9A-Fa-f]{1,4}){1,6})|((:[0-9A-Fa-f]{1,4}){0,4}:((25[0-5]|2[0-4]d|1dd|[1-9]?d)(.(25[0-5]|2[0-4]d|1dd|[1-9]?d)){3}))|:))|(:(((:[0-9A-Fa-f]{1,4}){1,7})|((:[0-9A-Fa-f]{1,4}){0,5}:((25[0-5]|2[0-4]d|1dd|[1-9]?d)(.(25[0-5]|2[0-4]d|1dd|[1-9]?d)){3}))|:)))(%.+)?s*(\/([0-9]|[1-9][0-9]|1[0-1][0-9]|12[0-8]))?$/i;
            for (const entry of entries)
              if (!ipv6Regex.test(entry.cidr))
                throw new Error(`Invalid IPv6 address range: ${entry.cidr}`);
          } else {
            const ipv4Regex = /^([0-9]{1,3}\.){3}[0-9]{1,3}(\/([0-9]|[1-2][0-9]|3[0-2]))?$/i;
            for (const entry of entries)
              if (!ipv4Regex.test(entry.cidr))
                throw new Error(`Invalid IPv4 address range: ${entry.cidr}`);
          }
          defaultMaxEntries = props.entries.length;
        }
        const prefixList = new ec2_generated_1.CfnPrefixList(this, "Resource", { addressFamily: props?.addressFamily || AddressFamily.IP_V4, maxEntries: props?.maxEntries || defaultMaxEntries, prefixListName: this.prefixListName, entries: props?.entries || [] });
        this.prefixListId = prefixList.attrPrefixListId, this.prefixListArn = prefixList.attrArn, this.ownerId = prefixList.attrOwnerId, this.version = prefixList.attrVersion, this.addressFamily = prefixList.addressFamily;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, PrefixList[_a] = { fqn: "aws-cdk-lib.aws_ec2.PrefixList", version: "2.80.0" }, exports2.PrefixList = PrefixList;
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/vpc-lookup.js
var require_vpc_lookup = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/vpc-lookup.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/vpc-endpoint-service.js
var require_vpc_endpoint_service = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/vpc-endpoint-service.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.VpcEndpointService = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var ec2_generated_1 = require_ec2_generated();
    var core_1 = require_core2();
    var region_info_1 = require_region_info2();
    var VpcEndpointService = class _VpcEndpointService extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_VpcEndpointServiceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _VpcEndpointService), error;
        }
        if (props.vpcEndpointServiceLoadBalancers === void 0 || props.vpcEndpointServiceLoadBalancers.length === 0)
          throw new Error("VPC Endpoint Service must have at least one load balancer specified.");
        if (this.vpcEndpointServiceLoadBalancers = props.vpcEndpointServiceLoadBalancers, this.acceptanceRequired = props.acceptanceRequired ?? true, props.allowedPrincipals && props.whitelistedPrincipals)
          throw new Error("`whitelistedPrincipals` is deprecated; please use `allowedPrincipals` instead");
        this.allowedPrincipals = props.allowedPrincipals ?? props.whitelistedPrincipals ?? [], this.whitelistedPrincipals = this.allowedPrincipals, this.endpointService = new ec2_generated_1.CfnVPCEndpointService(this, id, { networkLoadBalancerArns: this.vpcEndpointServiceLoadBalancers.map((lb) => lb.loadBalancerArn), acceptanceRequired: this.acceptanceRequired }), this.vpcEndpointServiceId = this.endpointService.ref;
        const { region } = core_1.Stack.of(this), serviceNamePrefix = core_1.Token.isUnresolved(region) ? region_info_1.Default.VPC_ENDPOINT_SERVICE_NAME_PREFIX : region_info_1.RegionInfo.get(region).vpcEndpointServiceNamePrefix ?? region_info_1.Default.VPC_ENDPOINT_SERVICE_NAME_PREFIX;
        this.vpcEndpointServiceName = core_1.Fn.join(".", [serviceNamePrefix, core_1.Aws.REGION, this.vpcEndpointServiceId]), this.allowedPrincipals.length > 0 && new ec2_generated_1.CfnVPCEndpointServicePermissions(this, "Permissions", { serviceId: this.endpointService.ref, allowedPrincipals: this.allowedPrincipals.map((x) => x.arn) });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, VpcEndpointService[_a] = { fqn: "aws-cdk-lib.aws_ec2.VpcEndpointService", version: "2.80.0" }, exports2.VpcEndpointService = VpcEndpointService;
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/client-vpn-endpoint-types.js
var require_client_vpn_endpoint_types = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/client-vpn-endpoint-types.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.VpnPort = exports2.TransportProtocol = void 0;
    var TransportProtocol;
    (function(TransportProtocol2) {
      TransportProtocol2.TCP = "tcp", TransportProtocol2.UDP = "udp";
    })(TransportProtocol = exports2.TransportProtocol || (exports2.TransportProtocol = {}));
    var VpnPort;
    (function(VpnPort2) {
      VpnPort2[VpnPort2.HTTPS = 443] = "HTTPS", VpnPort2[VpnPort2.OPENVPN = 1194] = "OPENVPN";
    })(VpnPort = exports2.VpnPort || (exports2.VpnPort = {}));
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/placement-group.js
var require_placement_group = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/placement-group.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PlacementGroup = exports2.PlacementGroupStrategy = exports2.PlacementGroupSpreadLevel = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var ec2_generated_1 = require_ec2_generated();
    var core_1 = require_core2();
    var PlacementGroupSpreadLevel;
    (function(PlacementGroupSpreadLevel2) {
      PlacementGroupSpreadLevel2.HOST = "host", PlacementGroupSpreadLevel2.RACK = "rack";
    })(PlacementGroupSpreadLevel = exports2.PlacementGroupSpreadLevel || (exports2.PlacementGroupSpreadLevel = {}));
    var PlacementGroupStrategy;
    (function(PlacementGroupStrategy2) {
      PlacementGroupStrategy2.CLUSTER = "cluster", PlacementGroupStrategy2.PARTITION = "partition", PlacementGroupStrategy2.SPREAD = "spread";
    })(PlacementGroupStrategy = exports2.PlacementGroupStrategy || (exports2.PlacementGroupStrategy = {}));
    var PlacementGroup = class _PlacementGroup extends core_1.Resource {
      static fromPlacementGroupName(scope, id, placementGroupName) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.placementGroupName = placementGroupName;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: void 0 });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_PlacementGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _PlacementGroup), error;
        }
        if (this.partitions = props?.partitions, this.spreadLevel = props?.spreadLevel, this.strategy = props?.strategy, this.partitions && this.strategy) {
          if (this.strategy !== PlacementGroupStrategy.PARTITION)
            throw new Error(`PlacementGroup '${id}' can only specify 'partitions' with the 'PARTITION' strategy`);
        } else
          this.partitions && !this.strategy && (this.strategy = PlacementGroupStrategy.PARTITION);
        if (this.spreadLevel && (this.strategy || (this.strategy = PlacementGroupStrategy.SPREAD), this.strategy !== PlacementGroupStrategy.SPREAD))
          throw new Error(`PlacementGroup '${id}' can only specify 'spreadLevel' with the 'SPREAD' strategy`);
        const resource = new ec2_generated_1.CfnPlacementGroup(this, "Resource", { partitionCount: this.partitions, spreadLevel: this.spreadLevel, strategy: this.strategy });
        this.placementGroupName = this.getResourceArnAttribute(resource.attrGroupName, { service: "batch", resource: "compute-environment", resourceName: this.physicalName });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, PlacementGroup[_a] = { fqn: "aws-cdk-lib.aws_ec2.PlacementGroup", version: "2.80.0" }, exports2.PlacementGroup = PlacementGroup;
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/ec2-augmentations.generated.js
var require_ec2_augmentations_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/ec2-augmentations.generated.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var cloudwatch = require_aws_cloudwatch();
    var vpn_1 = require_vpn();
    vpn_1.VpnConnectionBase.prototype.metric = function(metricName, props) {
      return new cloudwatch.Metric({ namespace: "AWS/VPN", metricName, dimensionsMap: { VpnId: this.vpnId }, ...props }).attachTo(this);
    }, vpn_1.VpnConnectionBase.prototype.metricTunnelState = function(props) {
      return this.metric("TunnelState", { statistic: "Average", ...props });
    }, vpn_1.VpnConnectionBase.prototype.metricTunnelDataIn = function(props) {
      return this.metric("TunnelDataIn", { statistic: "Sum", ...props });
    }, vpn_1.VpnConnectionBase.prototype.metricTunnelDataOut = function(props) {
      return this.metric("TunnelDataOut", { statistic: "Sum", ...props });
    };
  }
});

// node_modules/aws-cdk-lib/aws-ec2/lib/index.js
var require_lib19 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_aspects(), exports2), __exportStar(require_bastion_host(), exports2), __exportStar(require_connections(), exports2), __exportStar(require_cfn_init(), exports2), __exportStar(require_cfn_init_elements(), exports2), __exportStar(require_instance_types(), exports2), __exportStar(require_instance(), exports2), __exportStar(require_launch_template(), exports2), __exportStar(require_machine_image2(), exports2), __exportStar(require_nat(), exports2), __exportStar(require_network_acl(), exports2), __exportStar(require_network_acl_types(), exports2), __exportStar(require_port(), exports2), __exportStar(require_prefix_list(), exports2), __exportStar(require_security_group2(), exports2), __exportStar(require_subnet(), exports2), __exportStar(require_peer(), exports2), __exportStar(require_volume(), exports2), __exportStar(require_vpc2(), exports2), __exportStar(require_vpc_lookup(), exports2), __exportStar(require_vpn(), exports2), __exportStar(require_vpc_endpoint(), exports2), __exportStar(require_vpc_endpoint_service(), exports2), __exportStar(require_user_data(), exports2), __exportStar(require_windows_versions(), exports2), __exportStar(require_vpc_flow_logs(), exports2), __exportStar(require_client_vpn_endpoint_types(), exports2), __exportStar(require_client_vpn_endpoint(), exports2), __exportStar(require_client_vpn_authorization_rule(), exports2), __exportStar(require_client_vpn_route(), exports2), __exportStar(require_ip_addresses(), exports2), __exportStar(require_machine_image2(), exports2), __exportStar(require_placement_group(), exports2), __exportStar(require_ec2_generated(), exports2), require_ec2_augmentations_generated();
  }
});

// node_modules/aws-cdk-lib/aws-ec2/index.js
var require_aws_ec2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ec2/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib19(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-sqs/lib/sqs.generated.js
var require_sqs_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-sqs/lib/sqs.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnQueuePolicy = exports2.CfnQueue = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnQueuePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contentBasedDeduplication", cdk.validateBoolean)(properties.contentBasedDeduplication)), errors.collect(cdk.propertyValidator("deduplicationScope", cdk.validateString)(properties.deduplicationScope)), errors.collect(cdk.propertyValidator("delaySeconds", cdk.validateNumber)(properties.delaySeconds)), errors.collect(cdk.propertyValidator("fifoQueue", cdk.validateBoolean)(properties.fifoQueue)), errors.collect(cdk.propertyValidator("fifoThroughputLimit", cdk.validateString)(properties.fifoThroughputLimit)), errors.collect(cdk.propertyValidator("kmsDataKeyReusePeriodSeconds", cdk.validateNumber)(properties.kmsDataKeyReusePeriodSeconds)), errors.collect(cdk.propertyValidator("kmsMasterKeyId", cdk.validateString)(properties.kmsMasterKeyId)), errors.collect(cdk.propertyValidator("maximumMessageSize", cdk.validateNumber)(properties.maximumMessageSize)), errors.collect(cdk.propertyValidator("messageRetentionPeriod", cdk.validateNumber)(properties.messageRetentionPeriod)), errors.collect(cdk.propertyValidator("queueName", cdk.validateString)(properties.queueName)), errors.collect(cdk.propertyValidator("receiveMessageWaitTimeSeconds", cdk.validateNumber)(properties.receiveMessageWaitTimeSeconds)), errors.collect(cdk.propertyValidator("redriveAllowPolicy", cdk.validateObject)(properties.redriveAllowPolicy)), errors.collect(cdk.propertyValidator("redrivePolicy", cdk.validateObject)(properties.redrivePolicy)), errors.collect(cdk.propertyValidator("sqsManagedSseEnabled", cdk.validateBoolean)(properties.sqsManagedSseEnabled)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("visibilityTimeout", cdk.validateNumber)(properties.visibilityTimeout)), errors.wrap('supplied properties not correct for "CfnQueueProps"');
    }
    function cfnQueuePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnQueuePropsValidator(properties).assertSuccess(), { ContentBasedDeduplication: cdk.booleanToCloudFormation(properties.contentBasedDeduplication), DeduplicationScope: cdk.stringToCloudFormation(properties.deduplicationScope), DelaySeconds: cdk.numberToCloudFormation(properties.delaySeconds), FifoQueue: cdk.booleanToCloudFormation(properties.fifoQueue), FifoThroughputLimit: cdk.stringToCloudFormation(properties.fifoThroughputLimit), KmsDataKeyReusePeriodSeconds: cdk.numberToCloudFormation(properties.kmsDataKeyReusePeriodSeconds), KmsMasterKeyId: cdk.stringToCloudFormation(properties.kmsMasterKeyId), MaximumMessageSize: cdk.numberToCloudFormation(properties.maximumMessageSize), MessageRetentionPeriod: cdk.numberToCloudFormation(properties.messageRetentionPeriod), QueueName: cdk.stringToCloudFormation(properties.queueName), ReceiveMessageWaitTimeSeconds: cdk.numberToCloudFormation(properties.receiveMessageWaitTimeSeconds), RedriveAllowPolicy: cdk.objectToCloudFormation(properties.redriveAllowPolicy), RedrivePolicy: cdk.objectToCloudFormation(properties.redrivePolicy), SqsManagedSseEnabled: cdk.booleanToCloudFormation(properties.sqsManagedSseEnabled), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VisibilityTimeout: cdk.numberToCloudFormation(properties.visibilityTimeout) }) : properties;
    }
    function CfnQueuePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contentBasedDeduplication", "ContentBasedDeduplication", properties.ContentBasedDeduplication != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ContentBasedDeduplication) : void 0), ret.addPropertyResult("deduplicationScope", "DeduplicationScope", properties.DeduplicationScope != null ? cfn_parse.FromCloudFormation.getString(properties.DeduplicationScope) : void 0), ret.addPropertyResult("delaySeconds", "DelaySeconds", properties.DelaySeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.DelaySeconds) : void 0), ret.addPropertyResult("fifoQueue", "FifoQueue", properties.FifoQueue != null ? cfn_parse.FromCloudFormation.getBoolean(properties.FifoQueue) : void 0), ret.addPropertyResult("fifoThroughputLimit", "FifoThroughputLimit", properties.FifoThroughputLimit != null ? cfn_parse.FromCloudFormation.getString(properties.FifoThroughputLimit) : void 0), ret.addPropertyResult("kmsDataKeyReusePeriodSeconds", "KmsDataKeyReusePeriodSeconds", properties.KmsDataKeyReusePeriodSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.KmsDataKeyReusePeriodSeconds) : void 0), ret.addPropertyResult("kmsMasterKeyId", "KmsMasterKeyId", properties.KmsMasterKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsMasterKeyId) : void 0), ret.addPropertyResult("maximumMessageSize", "MaximumMessageSize", properties.MaximumMessageSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumMessageSize) : void 0), ret.addPropertyResult("messageRetentionPeriod", "MessageRetentionPeriod", properties.MessageRetentionPeriod != null ? cfn_parse.FromCloudFormation.getNumber(properties.MessageRetentionPeriod) : void 0), ret.addPropertyResult("queueName", "QueueName", properties.QueueName != null ? cfn_parse.FromCloudFormation.getString(properties.QueueName) : void 0), ret.addPropertyResult("receiveMessageWaitTimeSeconds", "ReceiveMessageWaitTimeSeconds", properties.ReceiveMessageWaitTimeSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.ReceiveMessageWaitTimeSeconds) : void 0), ret.addPropertyResult("redriveAllowPolicy", "RedriveAllowPolicy", properties.RedriveAllowPolicy != null ? cfn_parse.FromCloudFormation.getAny(properties.RedriveAllowPolicy) : void 0), ret.addPropertyResult("redrivePolicy", "RedrivePolicy", properties.RedrivePolicy != null ? cfn_parse.FromCloudFormation.getAny(properties.RedrivePolicy) : void 0), ret.addPropertyResult("sqsManagedSseEnabled", "SqsManagedSseEnabled", properties.SqsManagedSseEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SqsManagedSseEnabled) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("visibilityTimeout", "VisibilityTimeout", properties.VisibilityTimeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.VisibilityTimeout) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnQueue = class _CfnQueue extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnQueuePropsFromCloudFormation(resourceProperties), ret = new _CfnQueue(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnQueue.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sqs_CfnQueueProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnQueue), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrQueueName = cdk.Token.asString(this.getAtt("QueueName", cdk.ResolutionTypeHint.STRING)), this.attrQueueUrl = cdk.Token.asString(this.getAtt("QueueUrl", cdk.ResolutionTypeHint.STRING)), this.contentBasedDeduplication = props.contentBasedDeduplication, this.deduplicationScope = props.deduplicationScope, this.delaySeconds = props.delaySeconds, this.fifoQueue = props.fifoQueue, this.fifoThroughputLimit = props.fifoThroughputLimit, this.kmsDataKeyReusePeriodSeconds = props.kmsDataKeyReusePeriodSeconds, this.kmsMasterKeyId = props.kmsMasterKeyId, this.maximumMessageSize = props.maximumMessageSize, this.messageRetentionPeriod = props.messageRetentionPeriod, this.queueName = props.queueName, this.receiveMessageWaitTimeSeconds = props.receiveMessageWaitTimeSeconds, this.redriveAllowPolicy = props.redriveAllowPolicy, this.redrivePolicy = props.redrivePolicy, this.sqsManagedSseEnabled = props.sqsManagedSseEnabled, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SQS::Queue", props.tags, { tagPropertyName: "tags" }), this.visibilityTimeout = props.visibilityTimeout, this.node.scope && cdk.Resource.isResource(this.node.scope) && this.node.addValidation({ validate: () => this.cfnOptions.deletionPolicy === void 0 ? ["'AWS::SQS::Queue' is a stateful resource type, and you must specify a Removal Policy for it. Call 'resource.applyRemovalPolicy()'."] : [] });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnQueue.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { contentBasedDeduplication: this.contentBasedDeduplication, deduplicationScope: this.deduplicationScope, delaySeconds: this.delaySeconds, fifoQueue: this.fifoQueue, fifoThroughputLimit: this.fifoThroughputLimit, kmsDataKeyReusePeriodSeconds: this.kmsDataKeyReusePeriodSeconds, kmsMasterKeyId: this.kmsMasterKeyId, maximumMessageSize: this.maximumMessageSize, messageRetentionPeriod: this.messageRetentionPeriod, queueName: this.queueName, receiveMessageWaitTimeSeconds: this.receiveMessageWaitTimeSeconds, redriveAllowPolicy: this.redriveAllowPolicy, redrivePolicy: this.redrivePolicy, sqsManagedSseEnabled: this.sqsManagedSseEnabled, tags: this.tags.renderTags(), visibilityTimeout: this.visibilityTimeout };
      }
      renderProperties(props) {
        return cfnQueuePropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnQueue[_a] = { fqn: "aws-cdk-lib.aws_sqs.CfnQueue", version: "2.80.0" }, CfnQueue.CFN_RESOURCE_TYPE_NAME = "AWS::SQS::Queue", exports2.CfnQueue = CfnQueue;
    function CfnQueuePolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("policyDocument", cdk.requiredValidator)(properties.policyDocument)), errors.collect(cdk.propertyValidator("policyDocument", cdk.validateObject)(properties.policyDocument)), errors.collect(cdk.propertyValidator("queues", cdk.requiredValidator)(properties.queues)), errors.collect(cdk.propertyValidator("queues", cdk.listValidator(cdk.validateString))(properties.queues)), errors.wrap('supplied properties not correct for "CfnQueuePolicyProps"');
    }
    function cfnQueuePolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnQueuePolicyPropsValidator(properties).assertSuccess(), { PolicyDocument: cdk.objectToCloudFormation(properties.policyDocument), Queues: cdk.listMapper(cdk.stringToCloudFormation)(properties.queues) }) : properties;
    }
    function CfnQueuePolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("policyDocument", "PolicyDocument", cfn_parse.FromCloudFormation.getAny(properties.PolicyDocument)), ret.addPropertyResult("queues", "Queues", cfn_parse.FromCloudFormation.getStringArray(properties.Queues)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnQueuePolicy = class _CfnQueuePolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnQueuePolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnQueuePolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnQueuePolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sqs_CfnQueuePolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnQueuePolicy), error;
        }
        cdk.requireProperty(props, "policyDocument", this), cdk.requireProperty(props, "queues", this), this.policyDocument = props.policyDocument, this.queues = props.queues;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnQueuePolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { policyDocument: this.policyDocument, queues: this.queues };
      }
      renderProperties(props) {
        return cfnQueuePolicyPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnQueuePolicy[_b] = { fqn: "aws-cdk-lib.aws_sqs.CfnQueuePolicy", version: "2.80.0" }, CfnQueuePolicy.CFN_RESOURCE_TYPE_NAME = "AWS::SQS::QueuePolicy", exports2.CfnQueuePolicy = CfnQueuePolicy;
  }
});

// node_modules/aws-cdk-lib/aws-sqs/lib/policy.js
var require_policy3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-sqs/lib/policy.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.QueuePolicy = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var sqs_generated_1 = require_sqs_generated();
    var aws_iam_1 = require_aws_iam();
    var core_1 = require_core2();
    var QueuePolicy = class _QueuePolicy extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id), this.document = new aws_iam_1.PolicyDocument();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sqs_QueuePolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _QueuePolicy), error;
        }
        new sqs_generated_1.CfnQueuePolicy(this, "Resource", { policyDocument: this.document, queues: props.queues.map((q) => q.queueUrl) });
      }
      get queuePolicyId() {
        throw new Error("QueuePolicy.queuePolicyId has been removed from CloudFormation");
      }
    };
    _a = JSII_RTTI_SYMBOL_1, QueuePolicy[_a] = { fqn: "aws-cdk-lib.aws_sqs.QueuePolicy", version: "2.80.0" }, exports2.QueuePolicy = QueuePolicy;
  }
});

// node_modules/aws-cdk-lib/aws-sqs/lib/queue-base.js
var require_queue_base = __commonJS({
  "node_modules/aws-cdk-lib/aws-sqs/lib/queue-base.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.QueueBase = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var policy_1 = require_policy3();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var QueueBase = class _QueueBase extends core_1.Resource {
      constructor(scope, id, props = {}) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ResourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _QueueBase), error;
        }
        this.node.addValidation({ validate: () => this.policy?.document.validateForResourcePolicy() ?? [] });
      }
      addToResourcePolicy(statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToResourcePolicy), error;
        }
        return !this.policy && this.autoCreatePolicy && (this.policy = new policy_1.QueuePolicy(this, "Policy", { queues: [this] })), this.policy ? (this.policy.document.addStatements(statement), { statementAdded: true, policyDependable: this.policy }) : { statementAdded: false };
      }
      grantConsumeMessages(grantee) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(grantee);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantConsumeMessages), error;
        }
        const ret = this.grant(grantee, "sqs:ReceiveMessage", "sqs:ChangeMessageVisibility", "sqs:GetQueueUrl", "sqs:DeleteMessage", "sqs:GetQueueAttributes");
        return this.encryptionMasterKey && this.encryptionMasterKey.grantDecrypt(grantee), ret;
      }
      grantSendMessages(grantee) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(grantee);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantSendMessages), error;
        }
        const ret = this.grant(grantee, "sqs:SendMessage", "sqs:GetQueueAttributes", "sqs:GetQueueUrl");
        return this.encryptionMasterKey && this.encryptionMasterKey.grantEncryptDecrypt(grantee), ret;
      }
      grantPurge(grantee) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(grantee);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantPurge), error;
        }
        return this.grant(grantee, "sqs:PurgeQueue", "sqs:GetQueueAttributes", "sqs:GetQueueUrl");
      }
      grant(grantee, ...actions) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(grantee);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grant), error;
        }
        return iam.Grant.addToPrincipalOrResource({ grantee, actions, resourceArns: [this.queueArn], resource: this });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, QueueBase[_a] = { fqn: "aws-cdk-lib.aws_sqs.QueueBase", version: "2.80.0" }, exports2.QueueBase = QueueBase;
  }
});

// node_modules/aws-cdk-lib/aws-sqs/lib/validate-props.js
var require_validate_props = __commonJS({
  "node_modules/aws-cdk-lib/aws-sqs/lib/validate-props.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.validateProps = void 0;
    var core_1 = require_core2();
    function validateProps(props) {
      validateRange("delivery delay", props.deliveryDelay && props.deliveryDelay.toSeconds(), 0, 900, "seconds"), validateRange("maximum message size", props.maxMessageSizeBytes, 1024, 262144, "bytes"), validateRange("message retention period", props.retentionPeriod && props.retentionPeriod.toSeconds(), 60, 1209600, "seconds"), validateRange("receive wait time", props.receiveMessageWaitTime && props.receiveMessageWaitTime.toSeconds(), 0, 20, "seconds"), validateRange("visibility timeout", props.visibilityTimeout && props.visibilityTimeout.toSeconds(), 0, 43200, "seconds"), validateRange("dead letter target maximum receive count", props.deadLetterQueue && props.deadLetterQueue.maxReceiveCount, 1, 1 / 0);
    }
    exports2.validateProps = validateProps;
    function validateRange(label, value, minValue, maxValue, unit) {
      if (value === void 0 || core_1.Token.isUnresolved(value))
        return;
      const unitSuffix = unit ? ` ${unit}` : "";
      if (value < minValue)
        throw new Error(`${label} must be ${minValue}${unitSuffix} or more, but ${value} was provided`);
      if (value > maxValue)
        throw new Error(`${label} must be ${maxValue}${unitSuffix} or less, but ${value} was provided`);
    }
  }
});

// node_modules/aws-cdk-lib/aws-sqs/lib/queue.js
var require_queue = __commonJS({
  "node_modules/aws-cdk-lib/aws-sqs/lib/queue.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Queue = exports2.FifoThroughputLimit = exports2.DeduplicationScope = exports2.QueueEncryption = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var queue_base_1 = require_queue_base();
    var sqs_generated_1 = require_sqs_generated();
    var validate_props_1 = require_validate_props();
    var iam = require_aws_iam();
    var kms = require_aws_kms();
    var core_1 = require_core2();
    var QueueEncryption;
    (function(QueueEncryption2) {
      QueueEncryption2.UNENCRYPTED = "NONE", QueueEncryption2.KMS_MANAGED = "KMS_MANAGED", QueueEncryption2.KMS = "KMS", QueueEncryption2.SQS_MANAGED = "SQS_MANAGED";
    })(QueueEncryption = exports2.QueueEncryption || (exports2.QueueEncryption = {}));
    var DeduplicationScope;
    (function(DeduplicationScope2) {
      DeduplicationScope2.MESSAGE_GROUP = "messageGroup", DeduplicationScope2.QUEUE = "queue";
    })(DeduplicationScope = exports2.DeduplicationScope || (exports2.DeduplicationScope = {}));
    var FifoThroughputLimit;
    (function(FifoThroughputLimit2) {
      FifoThroughputLimit2.PER_QUEUE = "perQueue", FifoThroughputLimit2.PER_MESSAGE_GROUP_ID = "perMessageGroupId";
    })(FifoThroughputLimit = exports2.FifoThroughputLimit || (exports2.FifoThroughputLimit = {}));
    var Queue = class _Queue extends queue_base_1.QueueBase {
      static fromQueueArn(scope, id, queueArn) {
        return _Queue.fromQueueAttributes(scope, id, { queueArn });
      }
      static fromQueueAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sqs_QueueAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromQueueAttributes), error;
        }
        const stack = core_1.Stack.of(scope), parsedArn = stack.splitArn(attrs.queueArn, core_1.ArnFormat.NO_RESOURCE_NAME), queueName = attrs.queueName || parsedArn.resource, queueUrl = attrs.queueUrl || `https://sqs.${parsedArn.region}.${stack.urlSuffix}/${parsedArn.account}/${queueName}`;
        class Import extends queue_base_1.QueueBase {
          constructor() {
            super(...arguments), this.queueArn = attrs.queueArn, this.queueUrl = queueUrl, this.queueName = queueName, this.encryptionMasterKey = attrs.keyArn ? kms.Key.fromKeyArn(this, "Key", attrs.keyArn) : void 0, this.fifo = this.determineFifo(), this.autoCreatePolicy = false;
          }
          determineFifo() {
            if (core_1.Token.isUnresolved(this.queueArn))
              return attrs.fifo || false;
            if (typeof attrs.fifo < "u") {
              if (attrs.fifo && !queueName.endsWith(".fifo"))
                throw new Error("FIFO queue names must end in '.fifo'");
              if (!attrs.fifo && queueName.endsWith(".fifo"))
                throw new Error("Non-FIFO queue name may not end in '.fifo'");
            }
            return !!queueName.endsWith(".fifo");
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.queueName }), this.autoCreatePolicy = true;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sqs_QueueProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Queue), error;
        }
        (0, validate_props_1.validateProps)(props);
        const redrivePolicy = props.deadLetterQueue ? { deadLetterTargetArn: props.deadLetterQueue.queue.queueArn, maxReceiveCount: props.deadLetterQueue.maxReceiveCount } : void 0, { encryptionMasterKey, encryptionProps } = _determineEncryptionProps.call(this), fifoProps = this.determineFifoProps(props);
        this.fifo = fifoProps.fifoQueue || false;
        const queue = new sqs_generated_1.CfnQueue(this, "Resource", { queueName: this.physicalName, ...fifoProps, ...encryptionProps, redrivePolicy, delaySeconds: props.deliveryDelay && props.deliveryDelay.toSeconds(), maximumMessageSize: props.maxMessageSizeBytes, messageRetentionPeriod: props.retentionPeriod && props.retentionPeriod.toSeconds(), receiveMessageWaitTimeSeconds: props.receiveMessageWaitTime && props.receiveMessageWaitTime.toSeconds(), visibilityTimeout: props.visibilityTimeout && props.visibilityTimeout.toSeconds() });
        queue.applyRemovalPolicy(props.removalPolicy ?? core_1.RemovalPolicy.DESTROY), this.queueArn = this.getResourceArnAttribute(queue.attrArn, { service: "sqs", resource: this.physicalName }), this.queueName = this.getResourceNameAttribute(queue.attrQueueName), this.encryptionMasterKey = encryptionMasterKey, this.queueUrl = queue.ref, this.deadLetterQueue = props.deadLetterQueue;
        function _determineEncryptionProps() {
          let encryption = props.encryption;
          if (encryption === QueueEncryption.SQS_MANAGED && props.encryptionMasterKey)
            throw new Error("'encryptionMasterKey' is not supported if encryption type 'SQS_MANAGED' is used");
          if (encryption !== QueueEncryption.KMS && props.encryptionMasterKey && (encryption = QueueEncryption.KMS), !encryption)
            return { encryptionProps: {} };
          if (encryption === QueueEncryption.UNENCRYPTED)
            return { encryptionProps: { sqsManagedSseEnabled: false } };
          if (encryption === QueueEncryption.KMS_MANAGED)
            return { encryptionProps: { kmsMasterKeyId: "alias/aws/sqs", kmsDataKeyReusePeriodSeconds: props.dataKeyReuse && props.dataKeyReuse.toSeconds() } };
          if (encryption === QueueEncryption.KMS) {
            const masterKey = props.encryptionMasterKey || new kms.Key(this, "Key", { description: `Created by ${this.node.path}` });
            return { encryptionMasterKey: masterKey, encryptionProps: { kmsMasterKeyId: masterKey.keyArn, kmsDataKeyReusePeriodSeconds: props.dataKeyReuse && props.dataKeyReuse.toSeconds() } };
          }
          if (encryption === QueueEncryption.SQS_MANAGED)
            return { encryptionProps: { sqsManagedSseEnabled: true } };
          throw new Error(`Unexpected 'encryptionType': ${encryption}`);
        }
        props.enforceSSL && this.enforceSSLStatement();
      }
      determineFifoProps(props) {
        let fifoQueue = props.fifo;
        const queueName = props.queueName;
        if (typeof fifoQueue > "u" && queueName && !core_1.Token.isUnresolved(queueName) && queueName.endsWith(".fifo") && (fifoQueue = true), typeof fifoQueue > "u" && props.contentBasedDeduplication && (fifoQueue = true), typeof fifoQueue > "u" && props.deduplicationScope && (fifoQueue = true), typeof fifoQueue > "u" && props.fifoThroughputLimit && (fifoQueue = true), typeof queueName == "string") {
          if (fifoQueue && !queueName.endsWith(".fifo"))
            throw new Error("FIFO queue names must end in '.fifo'");
          if (!fifoQueue && queueName.endsWith(".fifo"))
            throw new Error("Non-FIFO queue name may not end in '.fifo'");
        }
        if (props.contentBasedDeduplication && !fifoQueue)
          throw new Error("Content-based deduplication can only be defined for FIFO queues");
        if (props.deduplicationScope && !fifoQueue)
          throw new Error("Deduplication scope can only be defined for FIFO queues");
        if (props.fifoThroughputLimit && !fifoQueue)
          throw new Error("FIFO throughput limit can only be defined for FIFO queues");
        return { contentBasedDeduplication: props.contentBasedDeduplication, deduplicationScope: props.deduplicationScope, fifoThroughputLimit: props.fifoThroughputLimit, fifoQueue };
      }
      enforceSSLStatement() {
        const statement = new iam.PolicyStatement({ actions: ["sqs:*"], conditions: { Bool: { "aws:SecureTransport": "false" } }, effect: iam.Effect.DENY, resources: [this.queueArn], principals: [new iam.AnyPrincipal()] });
        this.addToResourcePolicy(statement);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Queue[_a] = { fqn: "aws-cdk-lib.aws_sqs.Queue", version: "2.80.0" }, exports2.Queue = Queue;
  }
});

// node_modules/aws-cdk-lib/aws-sqs/lib/sqs-augmentations.generated.js
var require_sqs_augmentations_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-sqs/lib/sqs-augmentations.generated.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var cloudwatch = require_aws_cloudwatch();
    var queue_base_1 = require_queue_base();
    queue_base_1.QueueBase.prototype.metric = function(metricName, props) {
      return new cloudwatch.Metric({ namespace: "AWS/SQS", metricName, dimensionsMap: { QueueName: this.queueName }, ...props }).attachTo(this);
    }, queue_base_1.QueueBase.prototype.metricApproximateAgeOfOldestMessage = function(props) {
      return this.metric("ApproximateAgeOfOldestMessage", { statistic: "Maximum", ...props });
    }, queue_base_1.QueueBase.prototype.metricApproximateNumberOfMessagesDelayed = function(props) {
      return this.metric("ApproximateNumberOfMessagesDelayed", { statistic: "Maximum", ...props });
    }, queue_base_1.QueueBase.prototype.metricApproximateNumberOfMessagesNotVisible = function(props) {
      return this.metric("ApproximateNumberOfMessagesNotVisible", { statistic: "Maximum", ...props });
    }, queue_base_1.QueueBase.prototype.metricApproximateNumberOfMessagesVisible = function(props) {
      return this.metric("ApproximateNumberOfMessagesVisible", { statistic: "Maximum", ...props });
    }, queue_base_1.QueueBase.prototype.metricNumberOfEmptyReceives = function(props) {
      return this.metric("NumberOfEmptyReceives", { statistic: "Sum", ...props });
    }, queue_base_1.QueueBase.prototype.metricNumberOfMessagesDeleted = function(props) {
      return this.metric("NumberOfMessagesDeleted", { statistic: "Sum", ...props });
    }, queue_base_1.QueueBase.prototype.metricNumberOfMessagesReceived = function(props) {
      return this.metric("NumberOfMessagesReceived", { statistic: "Sum", ...props });
    }, queue_base_1.QueueBase.prototype.metricNumberOfMessagesSent = function(props) {
      return this.metric("NumberOfMessagesSent", { statistic: "Sum", ...props });
    }, queue_base_1.QueueBase.prototype.metricSentMessageSize = function(props) {
      return this.metric("SentMessageSize", { statistic: "Average", ...props });
    };
  }
});

// node_modules/aws-cdk-lib/aws-sqs/lib/index.js
var require_lib20 = __commonJS({
  "node_modules/aws-cdk-lib/aws-sqs/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_policy3(), exports2), __exportStar(require_queue(), exports2), __exportStar(require_queue_base(), exports2), __exportStar(require_sqs_generated(), exports2), require_sqs_augmentations_generated();
  }
});

// node_modules/aws-cdk-lib/aws-sqs/index.js
var require_aws_sqs = __commonJS({
  "node_modules/aws-cdk-lib/aws-sqs/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib20(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/function.js
var require_function = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/function.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FunctionVersionUpgrade = exports2.verifyCodeConfig = exports2.Function = exports2.Tracing = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var architecture_1 = require_architecture();
    var function_base_1 = require_function_base();
    var function_hash_1 = require_function_hash();
    var handler_1 = require_handler();
    var lambda_version_1 = require_lambda_version();
    var lambda_generated_1 = require_lambda_generated();
    var layers_1 = require_layers();
    var runtime_1 = require_runtime3();
    var util_1 = require_util5();
    var cloudwatch = require_aws_cloudwatch();
    var aws_codeguruprofiler_1 = require_aws_codeguruprofiler();
    var ec2 = require_aws_ec2();
    var iam = require_aws_iam();
    var logs = require_aws_logs();
    var sqs = require_aws_sqs();
    var core_1 = require_core2();
    var cx_api_1 = require_cx_api();
    var Tracing;
    (function(Tracing2) {
      Tracing2.ACTIVE = "Active", Tracing2.PASS_THROUGH = "PassThrough", Tracing2.DISABLED = "Disabled";
    })(Tracing = exports2.Tracing || (exports2.Tracing = {}));
    var Function3 = class _Function extends function_base_1.FunctionBase {
      get currentVersion() {
        if (this._currentVersion)
          return this._currentVersion;
        this._warnIfCurrentVersionCalled && this.warnInvokeFunctionPermissions(this), this._currentVersion = new lambda_version_1.Version(this, "CurrentVersion", { lambda: this, ...this.currentVersionOptions });
        const cfn = this._currentVersion.node.defaultChild, originalLogicalId = this.stack.resolve(cfn.logicalId);
        return cfn.overrideLogicalId(core_1.Lazy.uncachedString({ produce: () => {
          const hash = (0, function_hash_1.calculateFunctionHash)(this, this.hashMixins.join(""));
          return `${(0, function_hash_1.trimFromStart)(originalLogicalId, 255 - 32)}${hash}`;
        } })), this._currentVersion;
      }
      get resourceArnsForGrantInvoke() {
        return [this.functionArn, `${this.functionArn}:*`];
      }
      static classifyVersionProperty(propertyName, locked) {
        this._VER_PROPS[propertyName] = locked;
      }
      static fromFunctionName(scope, id, functionName) {
        return _Function.fromFunctionAttributes(scope, id, { functionArn: core_1.Stack.of(scope).formatArn({ service: "lambda", resource: "function", resourceName: functionName, arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME }) });
      }
      static fromFunctionArn(scope, id, functionArn) {
        return _Function.fromFunctionAttributes(scope, id, { functionArn });
      }
      static fromFunctionAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_FunctionAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromFunctionAttributes), error;
        }
        const functionArn = attrs.functionArn, functionName = extractNameFromArn(attrs.functionArn), role = attrs.role;
        class Import extends function_base_1.FunctionBase {
          constructor(s, i) {
            super(s, i, { environmentFromArn: functionArn }), this.functionName = functionName, this.functionArn = functionArn, this.role = role, this.permissionsNode = this.node, this.architecture = attrs.architecture ?? architecture_1.Architecture.X86_64, this.resourceArnsForGrantInvoke = [this.functionArn, `${this.functionArn}:*`], this.canCreatePermissions = attrs.sameEnvironment ?? this._isStackAccount(), this._skipPermissions = attrs.skipPermissions ?? false, this.grantPrincipal = role || new iam.UnknownPrincipal({ resource: this }), attrs.securityGroup ? this._connections = new ec2.Connections({ securityGroups: [attrs.securityGroup] }) : attrs.securityGroupId && (this._connections = new ec2.Connections({ securityGroups: [ec2.SecurityGroup.fromSecurityGroupId(scope, "SecurityGroup", attrs.securityGroupId)] }));
          }
        }
        return new Import(scope, id);
      }
      static metricAll(metricName, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricAll), error;
        }
        return new cloudwatch.Metric({ namespace: "AWS/Lambda", metricName, ...props });
      }
      static metricAllErrors(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricAllErrors), error;
        }
        return this.metricAll("Errors", { statistic: "sum", ...props });
      }
      static metricAllDuration(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricAllDuration), error;
        }
        return this.metricAll("Duration", props);
      }
      static metricAllInvocations(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricAllInvocations), error;
        }
        return this.metricAll("Invocations", { statistic: "sum", ...props });
      }
      static metricAllThrottles(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricAllThrottles), error;
        }
        return this.metricAll("Throttles", { statistic: "sum", ...props });
      }
      static metricAllConcurrentExecutions(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricAllConcurrentExecutions), error;
        }
        return this.metricAll("ConcurrentExecutions", { statistic: "max", ...props });
      }
      static metricAllUnreservedConcurrentExecutions(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricAllUnreservedConcurrentExecutions), error;
        }
        return this.metricAll("UnreservedConcurrentExecutions", { statistic: "max", ...props });
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.functionName }), this.permissionsNode = this.node, this.canCreatePermissions = true, this._layers = [], this.environment = {}, this.hashMixins = new Array();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_FunctionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Function), error;
        }
        if (props.functionName && !core_1.Token.isUnresolved(props.functionName)) {
          if (props.functionName.length > 64)
            throw new Error(`Function name can not be longer than 64 characters but has ${props.functionName.length} characters.`);
          if (!/^[a-zA-Z0-9-_]+$/.test(props.functionName))
            throw new Error(`Function name ${props.functionName} can contain only letters, numbers, hyphens, or underscores with no spaces.`);
        }
        if (props.description && !core_1.Token.isUnresolved(props.description) && props.description.length > 256)
          throw new Error(`Function description can not be longer than 256 characters but has ${props.description.length} characters.`);
        const managedPolicies = new Array();
        if (managedPolicies.push(iam.ManagedPolicy.fromAwsManagedPolicyName("service-role/AWSLambdaBasicExecutionRole")), props.vpc && managedPolicies.push(iam.ManagedPolicy.fromAwsManagedPolicyName("service-role/AWSLambdaVPCAccessExecutionRole")), this.role = props.role || new iam.Role(this, "ServiceRole", { assumedBy: new iam.ServicePrincipal("lambda.amazonaws.com"), managedPolicies }), this.grantPrincipal = this.role, props.filesystem) {
          const config = props.filesystem.config;
          config.policies && config.policies.forEach((p) => {
            this.role?.addToPrincipalPolicy(p);
          });
        }
        for (const statement of props.initialPolicy || [])
          this.role.addToPrincipalPolicy(statement);
        const code = props.code.bind(this);
        verifyCodeConfig(code, props);
        let profilingGroupEnvironmentVariables = {};
        if (props.profilingGroup && props.profiling !== false)
          this.validateProfiling(props), props.profilingGroup.grantPublish(this.role), profilingGroupEnvironmentVariables = { AWS_CODEGURU_PROFILER_GROUP_ARN: core_1.Stack.of(scope).formatArn({ service: "codeguru-profiler", resource: "profilingGroup", resourceName: props.profilingGroup.profilingGroupName }), AWS_CODEGURU_PROFILER_ENABLED: "TRUE" };
        else if (props.profiling) {
          this.validateProfiling(props);
          const profilingGroup = new aws_codeguruprofiler_1.ProfilingGroup(this, "ProfilingGroup", { computePlatform: aws_codeguruprofiler_1.ComputePlatform.AWS_LAMBDA });
          profilingGroup.grantPublish(this.role), profilingGroupEnvironmentVariables = { AWS_CODEGURU_PROFILER_GROUP_ARN: profilingGroup.profilingGroupArn, AWS_CODEGURU_PROFILER_ENABLED: "TRUE" };
        }
        const env = { ...profilingGroupEnvironmentVariables, ...props.environment };
        for (const [key, value] of Object.entries(env))
          this.addEnvironment(key, value);
        const dlqTopicOrQueue = this.buildDeadLetterQueue(props);
        dlqTopicOrQueue !== void 0 && (this.isQueue(dlqTopicOrQueue) ? this.deadLetterQueue = dlqTopicOrQueue : this.deadLetterTopic = dlqTopicOrQueue);
        let fileSystemConfigs;
        if (props.filesystem && (fileSystemConfigs = [{ arn: props.filesystem.config.arn, localMountPath: props.filesystem.config.localMountPath }]), props.architecture && props.architectures !== void 0)
          throw new Error("Either architecture or architectures must be specified but not both.");
        if (props.architectures && props.architectures.length > 1)
          throw new Error("Only one architecture must be specified.");
        if (this._architecture = props.architecture ?? (props.architectures && props.architectures[0]), props.ephemeralStorageSize && !props.ephemeralStorageSize.isUnresolved() && (props.ephemeralStorageSize.toMebibytes() < 512 || props.ephemeralStorageSize.toMebibytes() > 10240))
          throw new Error(`Ephemeral storage size must be between 512 and 10240 MB, received ${props.ephemeralStorageSize}.`);
        const resource = new lambda_generated_1.CfnFunction(this, "Resource", { functionName: this.physicalName, description: props.description, code: { s3Bucket: code.s3Location && code.s3Location.bucketName, s3Key: code.s3Location && code.s3Location.objectKey, s3ObjectVersion: code.s3Location && code.s3Location.objectVersion, zipFile: code.inlineCode, imageUri: code.image?.imageUri }, layers: core_1.Lazy.list({ produce: () => this.renderLayers() }), handler: props.handler === handler_1.Handler.FROM_IMAGE ? void 0 : props.handler, timeout: props.timeout && props.timeout.toSeconds(), packageType: props.runtime === runtime_1.Runtime.FROM_IMAGE ? "Image" : void 0, runtime: props.runtime === runtime_1.Runtime.FROM_IMAGE ? void 0 : props.runtime.name, role: this.role.roleArn, environment: core_1.Lazy.uncachedAny({ produce: () => this.renderEnvironment() }), memorySize: props.memorySize, ephemeralStorage: props.ephemeralStorageSize ? { size: props.ephemeralStorageSize.toMebibytes() } : void 0, vpcConfig: this.configureVpc(props), deadLetterConfig: this.buildDeadLetterConfig(dlqTopicOrQueue), reservedConcurrentExecutions: props.reservedConcurrentExecutions, imageConfig: undefinedIfNoKeys({ command: code.image?.cmd, entryPoint: code.image?.entrypoint, workingDirectory: code.image?.workingDirectory }), kmsKeyArn: props.environmentEncryption?.keyArn, fileSystemConfigs, codeSigningConfigArn: props.codeSigningConfig?.codeSigningConfigArn, architectures: this._architecture ? [this._architecture.name] : void 0, runtimeManagementConfig: props.runtimeManagementMode?.runtimeManagementConfig });
        if ((props.tracing !== void 0 || props.adotInstrumentation !== void 0) && (resource.tracingConfig = this.buildTracingConfig(props.tracing ?? Tracing.ACTIVE)), resource.node.addDependency(this.role), this.functionName = this.getResourceNameAttribute(resource.ref), this.functionArn = this.getResourceArnAttribute(resource.attrArn, { service: "lambda", resource: "function", resourceName: this.physicalName, arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME }), this.runtime = props.runtime, this.timeout = props.timeout, this.architecture = props.architecture ?? architecture_1.Architecture.X86_64, props.layers) {
          if (props.runtime === runtime_1.Runtime.FROM_IMAGE)
            throw new Error("Layers are not supported for container image functions");
          this.addLayers(...props.layers);
        }
        for (const event of props.events || [])
          this.addEventSource(event);
        if (props.logRetention) {
          const logRetention = new logs.LogRetention(this, "LogRetention", { logGroupName: `/aws/lambda/${this.functionName}`, retention: props.logRetention, role: props.logRetentionRole, logRetentionRetryOptions: props.logRetentionRetryOptions });
          this._logGroup = logs.LogGroup.fromLogGroupArn(this, "LogGroup", logRetention.logGroupArn);
        }
        if (props.code.bindToResource(resource), (props.onFailure || props.onSuccess || props.maxEventAge || props.retryAttempts !== void 0) && this.configureAsyncInvoke({ onFailure: props.onFailure, onSuccess: props.onSuccess, maxEventAge: props.maxEventAge, retryAttempts: props.retryAttempts }), this.currentVersionOptions = props.currentVersionOptions, props.filesystem) {
          if (!props.vpc)
            throw new Error("Cannot configure 'filesystem' without configuring a VPC.");
          const config = props.filesystem.config;
          config.dependency && this.node.addDependency(...config.dependency), this.connections.securityGroups.forEach((sg) => {
            sg.node.findAll().forEach((child) => {
              child instanceof core_1.CfnResource && child.cfnResourceType === "AWS::EC2::SecurityGroupEgress" && resource.node.addDependency(child);
            });
          }), config.connections?.securityGroups.forEach((sg) => {
            sg.node.findAll().forEach((child) => {
              child instanceof core_1.CfnResource && child.cfnResourceType === "AWS::EC2::SecurityGroupIngress" && resource.node.addDependency(child);
            });
          });
        }
        this.configureLambdaInsights(props), this.configureAdotInstrumentation(props);
      }
      addEnvironment(key, value, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_EnvironmentOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addEnvironment), error;
        }
        if (["_HANDLER", "_X_AMZN_TRACE_ID", "AWS_REGION", "AWS_EXECUTION_ENV", "AWS_LAMBDA_FUNCTION_NAME", "AWS_LAMBDA_FUNCTION_MEMORY_SIZE", "AWS_LAMBDA_FUNCTION_VERSION", "AWS_LAMBDA_INITIALIZATION_TYPE", "AWS_LAMBDA_LOG_GROUP_NAME", "AWS_LAMBDA_LOG_STREAM_NAME", "AWS_ACCESS_KEY", "AWS_ACCESS_KEY_ID", "AWS_SECRET_ACCESS_KEY", "AWS_SESSION_TOKEN", "AWS_LAMBDA_RUNTIME_API", "LAMBDA_TASK_ROOT", "LAMBDA_RUNTIME_DIR"].includes(key))
          throw new Error(`${key} environment variable is reserved by the lambda runtime and can not be set manually. See https://docs.aws.amazon.com/lambda/latest/dg/configuration-envvars.html`);
        return this.environment[key] = { value, ...options }, this;
      }
      invalidateVersionBasedOn(x) {
        if (core_1.Token.isUnresolved(x))
          throw new Error("invalidateVersionOn: input may not contain unresolved tokens");
        this.hashMixins.push(x);
      }
      addLayers(...layers) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_ILayerVersion(layers);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addLayers), error;
        }
        for (const layer of layers) {
          if (this._layers.length === 5)
            throw new Error("Unable to add layer: this lambda function already uses 5 layers.");
          if (layer.compatibleRuntimes && !layer.compatibleRuntimes.find((runtime) => runtime.runtimeEquals(this.runtime))) {
            const runtimes = layer.compatibleRuntimes.map((runtime) => runtime.name).join(", ");
            throw new Error(`This lambda function uses a runtime that is incompatible with this layer (${this.runtime.name} is not in [${runtimes}])`);
          }
          this._layers.push(layer);
        }
      }
      addVersion(name, codeSha256, description, provisionedExecutions, asyncInvokeConfig = {}) {
        return new lambda_version_1.Version(this, "Version" + name, { lambda: this, codeSha256, description, provisionedConcurrentExecutions: provisionedExecutions, ...asyncInvokeConfig });
      }
      addAlias(aliasName, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_AliasOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addAlias), error;
        }
        return (0, util_1.addAlias)(this, this.currentVersion, aliasName, options);
      }
      get logGroup() {
        if (!this._logGroup) {
          const logRetention = new logs.LogRetention(this, "LogRetention", { logGroupName: `/aws/lambda/${this.functionName}`, retention: logs.RetentionDays.INFINITE });
          this._logGroup = logs.LogGroup.fromLogGroupArn(this, `${this.node.id}-LogGroup`, logRetention.logGroupArn);
        }
        return this._logGroup;
      }
      _checkEdgeCompatibility() {
        const envEntries = Object.entries(this.environment);
        for (const [key, config] of envEntries)
          config.removeInEdge && (delete this.environment[key], core_1.Annotations.of(this).addInfo(`Removed ${key} environment variable for Lambda@Edge compatibility`));
        const envKeys = Object.keys(this.environment);
        if (envKeys.length !== 0)
          throw new Error(`The function ${this.node.path} contains environment variables [${envKeys}] and is not compatible with Lambda@Edge. Environment variables can be marked for removal when used in Lambda@Edge by setting the 'removeInEdge' property in the 'addEnvironment()' API.`);
      }
      configureLambdaInsights(props) {
        props.insightsVersion !== void 0 && (props.runtime !== runtime_1.Runtime.FROM_IMAGE && this.addLayers(layers_1.LayerVersion.fromLayerVersionArn(this, "LambdaInsightsLayer", props.insightsVersion._bind(this, this).arn)), this.role?.addManagedPolicy(iam.ManagedPolicy.fromAwsManagedPolicyName("CloudWatchLambdaInsightsExecutionRolePolicy")));
      }
      configureAdotInstrumentation(props) {
        if (props.adotInstrumentation !== void 0) {
          if (props.runtime === runtime_1.Runtime.FROM_IMAGE)
            throw new Error("ADOT Lambda layer can't be configured with container image package type");
          if (this.runtime === runtime_1.Runtime.GO_1_X)
            throw new Error("Runtime go1.x is not supported by the ADOT Lambda Go SDK");
          this.addLayers(layers_1.LayerVersion.fromLayerVersionArn(this, "AdotLayer", props.adotInstrumentation.layerVersion._bind(this).arn)), this.addEnvironment("AWS_LAMBDA_EXEC_WRAPPER", props.adotInstrumentation.execWrapper);
        }
      }
      renderLayers() {
        if (!(!this._layers || this._layers.length === 0))
          return core_1.FeatureFlags.of(this).isEnabled(cx_api_1.LAMBDA_RECOGNIZE_LAYER_VERSION) && this._layers.sort(), this._layers.map((layer) => layer.layerVersionArn);
      }
      renderEnvironment() {
        if (!this.environment || Object.keys(this.environment).length === 0)
          return;
        const variables = {}, keys = this._currentVersion ? Object.keys(this.environment).sort() : Object.keys(this.environment);
        for (const key of keys)
          variables[key] = this.environment[key].value;
        return { variables };
      }
      configureVpc(props) {
        if ((props.securityGroup || props.allowAllOutbound !== void 0) && !props.vpc)
          throw new Error("Cannot configure 'securityGroup' or 'allowAllOutbound' without configuring a VPC");
        if (!props.vpc) {
          if (props.vpcSubnets)
            throw new Error("Cannot configure 'vpcSubnets' without configuring a VPC");
          return;
        }
        if (props.securityGroup && props.allowAllOutbound !== void 0)
          throw new Error("Configure 'allowAllOutbound' directly on the supplied SecurityGroup.");
        let securityGroups;
        if (props.securityGroup && props.securityGroups)
          throw new Error("Only one of the function props, securityGroup or securityGroups, is allowed");
        props.securityGroups ? securityGroups = props.securityGroups : securityGroups = [props.securityGroup || new ec2.SecurityGroup(this, "SecurityGroup", { vpc: props.vpc, description: "Automatic security group for Lambda Function " + core_1.Names.uniqueId(this), allowAllOutbound: props.allowAllOutbound })], this._connections = new ec2.Connections({ securityGroups }), props.filesystem && props.filesystem.config.connections && props.filesystem.config.connections.allowDefaultPortFrom(this);
        const allowPublicSubnet = props.allowPublicSubnet ?? false, selectedSubnets = props.vpc.selectSubnets(props.vpcSubnets), publicSubnetIds = new Set(props.vpc.publicSubnets.map((s) => s.subnetId));
        for (const subnetId of selectedSubnets.subnetIds)
          if (publicSubnetIds.has(subnetId) && !allowPublicSubnet)
            throw new Error("Lambda Functions in a public subnet can NOT access the internet. If you are aware of this limitation and would still like to place the function in a public subnet, set `allowPublicSubnet` to true");
        return this.node.addDependency(selectedSubnets.internetConnectivityEstablished), { subnetIds: selectedSubnets.subnetIds, securityGroupIds: securityGroups.map((sg) => sg.securityGroupId) };
      }
      isQueue(deadLetterQueue) {
        return deadLetterQueue.queueArn !== void 0;
      }
      buildDeadLetterQueue(props) {
        if (!props.deadLetterQueue && !props.deadLetterQueueEnabled && !props.deadLetterTopic)
          return;
        if (props.deadLetterQueue && props.deadLetterQueueEnabled === false)
          throw Error("deadLetterQueue defined but deadLetterQueueEnabled explicitly set to false");
        if (props.deadLetterTopic && (props.deadLetterQueue || props.deadLetterQueueEnabled !== void 0))
          throw new Error("deadLetterQueue and deadLetterTopic cannot be specified together at the same time");
        let deadLetterQueue;
        return props.deadLetterTopic ? (deadLetterQueue = props.deadLetterTopic, this.addToRolePolicy(new iam.PolicyStatement({ actions: ["sns:Publish"], resources: [deadLetterQueue.topicArn] }))) : (deadLetterQueue = props.deadLetterQueue || new sqs.Queue(this, "DeadLetterQueue", { retentionPeriod: core_1.Duration.days(14) }), this.addToRolePolicy(new iam.PolicyStatement({ actions: ["sqs:SendMessage"], resources: [deadLetterQueue.queueArn] }))), deadLetterQueue;
      }
      buildDeadLetterConfig(deadLetterQueue) {
        if (deadLetterQueue)
          return { targetArn: this.isQueue(deadLetterQueue) ? deadLetterQueue.queueArn : deadLetterQueue.topicArn };
      }
      buildTracingConfig(tracing) {
        if (!(tracing === void 0 || tracing === Tracing.DISABLED))
          return this.addToRolePolicy(new iam.PolicyStatement({ actions: ["xray:PutTraceSegments", "xray:PutTelemetryRecords"], resources: ["*"] })), { mode: tracing };
      }
      validateProfiling(props) {
        if (!props.runtime.supportsCodeGuruProfiling)
          throw new Error(`CodeGuru profiling is not supported by runtime ${props.runtime.name}`);
        if (props.environment && (props.environment.AWS_CODEGURU_PROFILER_GROUP_ARN || props.environment.AWS_CODEGURU_PROFILER_ENABLED))
          throw new Error("AWS_CODEGURU_PROFILER_GROUP_ARN and AWS_CODEGURU_PROFILER_ENABLED must not be set when profiling options enabled");
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Function3[_a] = { fqn: "aws-cdk-lib.aws_lambda.Function", version: "2.80.0" }, Function3._VER_PROPS = {}, exports2.Function = Function3;
    function extractNameFromArn(arn) {
      return core_1.Fn.select(6, core_1.Fn.split(":", arn));
    }
    function verifyCodeConfig(code, props) {
      if ([code.inlineCode, code.s3Location, code.image].filter((x) => !!x).length !== 1)
        throw new Error('lambda.Code must specify exactly one of: "inlineCode", "s3Location", or "image"');
      if (!!code.image == (props.handler !== handler_1.Handler.FROM_IMAGE))
        throw new Error("handler must be `Handler.FROM_IMAGE` when using image asset for Lambda function");
      if (!!code.image == (props.runtime !== runtime_1.Runtime.FROM_IMAGE))
        throw new Error("runtime must be `Runtime.FROM_IMAGE` when using image asset for Lambda function");
      if (code.inlineCode && !props.runtime.supportsInlineCode)
        throw new Error(`Inline source not allowed for ${props.runtime.name}`);
    }
    exports2.verifyCodeConfig = verifyCodeConfig;
    function undefinedIfNoKeys(struct) {
      return Object.values(struct).every((val) => val === void 0) ? void 0 : struct;
    }
    var FunctionVersionUpgrade = class {
      constructor(featureFlag, enabled = true) {
        this.featureFlag = featureFlag, this.enabled = enabled;
      }
      visit(node) {
        if (node instanceof Function3 && this.enabled === core_1.FeatureFlags.of(node).isEnabled(this.featureFlag)) {
          const cfnFunction = node.node.defaultChild, desc = cfnFunction.description ? `${cfnFunction.description} ` : "";
          cfnFunction.addPropertyOverride("Description", `${desc}version-hash:${(0, function_hash_1.calculateFunctionHash)(node)}`);
        }
      }
    };
    _b = JSII_RTTI_SYMBOL_1, FunctionVersionUpgrade[_b] = { fqn: "aws-cdk-lib.aws_lambda.FunctionVersionUpgrade", version: "2.80.0" }, exports2.FunctionVersionUpgrade = FunctionVersionUpgrade;
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/lambda-version.js
var require_lambda_version = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/lambda-version.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.extractQualifierFromArn = exports2.Version = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var function_1 = require_function();
    var function_base_1 = require_function_base();
    var lambda_generated_1 = require_lambda_generated();
    var util_1 = require_util5();
    var core_1 = require_core2();
    var Version = class _Version extends function_base_1.QualifiedFunctionBase {
      static fromVersionArn(scope, id, versionArn) {
        const version = extractQualifierFromArn(versionArn), lambda2 = function_1.Function.fromFunctionArn(scope, `${id}Function`, versionArn);
        class Import extends function_base_1.QualifiedFunctionBase {
          constructor() {
            super(...arguments), this.version = version, this.lambda = lambda2, this.functionName = `${lambda2.functionName}:${version}`, this.functionArn = versionArn, this.grantPrincipal = lambda2.grantPrincipal, this.role = lambda2.role, this.architecture = lambda2.architecture, this.qualifier = version, this.canCreatePermissions = this._isStackAccount();
          }
          addAlias(name, opts = {}) {
            return (0, util_1.addAlias)(this, this, name, opts);
          }
          get edgeArn() {
            if (version === "$LATEST")
              throw new Error("$LATEST function version cannot be used for Lambda@Edge");
            return this.functionArn;
          }
        }
        return new Import(scope, id);
      }
      static fromVersionAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_VersionAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromVersionAttributes), error;
        }
        class Import extends function_base_1.QualifiedFunctionBase {
          constructor() {
            super(...arguments), this.version = attrs.version, this.lambda = attrs.lambda, this.functionName = `${attrs.lambda.functionName}:${attrs.version}`, this.functionArn = `${attrs.lambda.functionArn}:${attrs.version}`, this.grantPrincipal = attrs.lambda.grantPrincipal, this.role = attrs.lambda.role, this.architecture = attrs.lambda.architecture, this.qualifier = attrs.version, this.canCreatePermissions = this._isStackAccount();
          }
          addAlias(name, opts = {}) {
            return (0, util_1.addAlias)(this, this, name, opts);
          }
          get edgeArn() {
            if (attrs.version === "$LATEST")
              throw new Error("$LATEST function version cannot be used for Lambda@Edge");
            return this.functionArn;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id), this.canCreatePermissions = true;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_VersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Version), error;
        }
        this.lambda = props.lambda, this.architecture = props.lambda.architecture;
        const version = new lambda_generated_1.CfnVersion(this, "Resource", { codeSha256: props.codeSha256, description: props.description, functionName: props.lambda.functionName, provisionedConcurrencyConfig: this.determineProvisionedConcurrency(props) });
        props.removalPolicy && version.applyRemovalPolicy(props.removalPolicy, { default: core_1.RemovalPolicy.DESTROY }), this.version = version.attrVersion, this.functionArn = version.ref, this.functionName = `${this.lambda.functionName}:${this.version}`, this.qualifier = version.attrVersion, (props.onFailure || props.onSuccess || props.maxEventAge || props.retryAttempts !== void 0) && this.configureAsyncInvoke({ onFailure: props.onFailure, onSuccess: props.onSuccess, maxEventAge: props.maxEventAge, retryAttempts: props.retryAttempts });
      }
      get grantPrincipal() {
        return this.lambda.grantPrincipal;
      }
      get role() {
        return this.lambda.role;
      }
      metric(metricName, props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metric), error;
        }
        return super.metric(metricName, { dimensions: { FunctionName: this.lambda.functionName, Resource: `${this.lambda.functionArn}:${this.version}` }, ...props });
      }
      addAlias(aliasName, options = {}) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_lambda.Version#addAlias", "Calling `addAlias` on a `Version` object will cause the Alias to be replaced on every function update. Call `function.addAlias()` or `new Alias()` instead."), jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_AliasOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addAlias), error;
        }
        return (0, util_1.addAlias)(this, this, aliasName, options);
      }
      get edgeArn() {
        if (this.version === "$LATEST")
          throw new Error("$LATEST function version cannot be used for Lambda@Edge");
        return core_1.Lazy.string({ produce: () => (this.lambda instanceof function_1.Function && this.lambda._checkEdgeCompatibility(), this.functionArn) });
      }
      determineProvisionedConcurrency(props) {
        if (props.provisionedConcurrentExecutions) {
          if (props.provisionedConcurrentExecutions <= 0)
            throw new Error("provisionedConcurrentExecutions must have value greater than or equal to 1");
          return { provisionedConcurrentExecutions: props.provisionedConcurrentExecutions };
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Version[_a] = { fqn: "aws-cdk-lib.aws_lambda.Version", version: "2.80.0" }, exports2.Version = Version;
    function extractQualifierFromArn(arn) {
      return core_1.Fn.select(7, core_1.Fn.split(":", arn));
    }
    exports2.extractQualifierFromArn = extractQualifierFromArn;
  }
});

// node_modules/aws-cdk-lib/aws-applicationautoscaling/lib/step-scaling-action.js
var require_step_scaling_action = __commonJS({
  "node_modules/aws-cdk-lib/aws-applicationautoscaling/lib/step-scaling-action.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.MetricAggregationType = exports2.AdjustmentType = exports2.StepScalingAction = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var applicationautoscaling_generated_1 = require_applicationautoscaling_generated();
    var cdk = require_core2();
    var StepScalingAction = class _StepScalingAction extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id), this.adjustments = new Array();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_applicationautoscaling_StepScalingActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _StepScalingAction), error;
        }
        const resource = new applicationautoscaling_generated_1.CfnScalingPolicy(this, "Resource", { policyName: props.policyName || cdk.Names.uniqueId(this), policyType: "StepScaling", scalingTargetId: props.scalingTarget.scalableTargetId, stepScalingPolicyConfiguration: { adjustmentType: props.adjustmentType, cooldown: props.cooldown && props.cooldown.toSeconds(), minAdjustmentMagnitude: props.minAdjustmentMagnitude, metricAggregationType: props.metricAggregationType, stepAdjustments: cdk.Lazy.any({ produce: () => this.adjustments }) } });
        this.scalingPolicyArn = resource.ref;
      }
      addAdjustment(adjustment) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_applicationautoscaling_AdjustmentTier(adjustment);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addAdjustment), error;
        }
        if (adjustment.lowerBound === void 0 && adjustment.upperBound === void 0)
          throw new Error("At least one of lowerBound or upperBound is required");
        this.adjustments.push({ metricIntervalLowerBound: adjustment.lowerBound, metricIntervalUpperBound: adjustment.upperBound, scalingAdjustment: adjustment.adjustment });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, StepScalingAction[_a] = { fqn: "aws-cdk-lib.aws_applicationautoscaling.StepScalingAction", version: "2.80.0" }, exports2.StepScalingAction = StepScalingAction;
    var AdjustmentType;
    (function(AdjustmentType2) {
      AdjustmentType2.CHANGE_IN_CAPACITY = "ChangeInCapacity", AdjustmentType2.PERCENT_CHANGE_IN_CAPACITY = "PercentChangeInCapacity", AdjustmentType2.EXACT_CAPACITY = "ExactCapacity";
    })(AdjustmentType = exports2.AdjustmentType || (exports2.AdjustmentType = {}));
    var MetricAggregationType;
    (function(MetricAggregationType2) {
      MetricAggregationType2.AVERAGE = "Average", MetricAggregationType2.MINIMUM = "Minimum", MetricAggregationType2.MAXIMUM = "Maximum";
    })(MetricAggregationType = exports2.MetricAggregationType || (exports2.MetricAggregationType = {}));
  }
});

// node_modules/aws-cdk-lib/aws-autoscaling-common/lib/types.js
var require_types6 = __commonJS({
  "node_modules/aws-cdk-lib/aws-autoscaling-common/lib/types.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-autoscaling-common/lib/interval-utils.js
var require_interval_utils = __commonJS({
  "node_modules/aws-cdk-lib/aws-autoscaling-common/lib/interval-utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.findAlarmThresholds = exports2.normalizeIntervals = void 0;
    function normalizeIntervals(intervals, changesAreAbsolute) {
      const full = orderAndCompleteIntervals(intervals);
      return makeGapsUndefined(full), changesAreAbsolute || makeZerosUndefined(full), combineUndefineds(full), validateAtMostOneUndefined(full), full;
    }
    exports2.normalizeIntervals = normalizeIntervals;
    function orderAndCompleteIntervals(intervals) {
      if (intervals.length < 2)
        throw new Error("Require at least 2 intervals");
      for (const interval of intervals)
        if (interval.lower === void 0 && interval.upper === void 0)
          throw new Error(`Must supply at least one of 'upper' or 'lower', got: ${JSON.stringify(interval)}`);
      for (intervals = intervals.map((x) => ({ ...x })), intervals.sort(comparatorFromKey((x) => x.lower ?? x.upper)); propagateBounds(intervals); )
        ;
      const lastIndex = intervals.length - 1;
      intervals[0].lower === void 0 && (intervals[0] = { ...intervals[0], lower: 0 }), intervals[lastIndex].upper === void 0 && (intervals[lastIndex] = { ...intervals[lastIndex], upper: 1 / 0 });
      for (const interval of intervals)
        if (interval.lower === void 0 || interval.upper === void 0)
          throw new Error(`Could not determine the lower and upper bounds for ${JSON.stringify(interval)}`);
      const completeIntervals = intervals;
      for (let i = 0; i < completeIntervals.length - 1; i++)
        if (overlap(completeIntervals[i], completeIntervals[i + 1]))
          throw new Error(`Two intervals overlap: ${JSON.stringify(completeIntervals[i])} and ${JSON.stringify(completeIntervals[i + 1])}`);
      return completeIntervals;
    }
    function makeGapsUndefined(intervals) {
      intervals[0].lower !== 0 && intervals.splice(0, 0, { lower: 0, upper: intervals[0].lower, change: void 0 }), last(intervals).upper !== 1 / 0 && intervals.push({ lower: last(intervals).upper, upper: 1 / 0, change: void 0 });
      let i = 1;
      for (; i < intervals.length; )
        intervals[i - 1].upper < intervals[i].lower ? intervals.splice(i, 0, { lower: intervals[i - 1].upper, upper: intervals[i].lower, change: void 0 }) : i++;
    }
    function makeZerosUndefined(intervals) {
      for (let i = 0; i < intervals.length; ++i) {
        const interval = intervals[i];
        interval.change === 0 && (intervals[i] = { ...interval, change: void 0 });
      }
    }
    function combineUndefineds(intervals) {
      let i = 0;
      for (; i < intervals.length - 1; )
        intervals[i].change === void 0 && intervals[i + 1].change === void 0 ? (intervals[i] = { ...intervals[i], upper: intervals[i + 1].upper }, intervals.splice(i + 1, 1)) : i++;
    }
    function validateAtMostOneUndefined(intervals) {
      const undef = intervals.filter((x) => x.change === void 0);
      if (undef.length > 1)
        throw new Error(`Can have at most one no-change interval, got ${JSON.stringify(undef)}`);
    }
    function comparatorFromKey(keyFn) {
      return (a, b) => {
        const keyA = keyFn(a), keyB = keyFn(b);
        return keyA < keyB ? -1 : keyA === keyB ? 0 : 1;
      };
    }
    function propagateBounds(intervals) {
      let ret = false;
      for (let i = 0; i < intervals.length - 1; i++)
        intervals[i].upper !== void 0 && intervals[i + 1].lower === void 0 && (intervals[i + 1] = { ...intervals[i + 1], lower: intervals[i].upper }, ret = true);
      for (let i = intervals.length - 1; i >= 1; i--)
        intervals[i].lower !== void 0 && intervals[i - 1].upper === void 0 && (intervals[i - 1] = { ...intervals[i - 1], upper: intervals[i].lower }, ret = true);
      return ret;
    }
    function overlap(a, b) {
      return a.lower < b.upper && a.upper > b.lower;
    }
    function last(xs) {
      return xs[xs.length - 1];
    }
    function findAlarmThresholds(intervals) {
      const gapIndex = intervals.findIndex((x) => x.change === void 0);
      if (gapIndex !== -1)
        return { lowerAlarmIntervalIndex: gapIndex > 0 ? gapIndex - 1 : void 0, upperAlarmIntervalIndex: gapIndex < intervals.length - 1 ? gapIndex + 1 : void 0 };
      if (intervals.length === 1)
        return { upperAlarmIntervalIndex: 0 };
      const middleIndex = Math.floor(intervals.length / 2);
      return { lowerAlarmIntervalIndex: middleIndex - 1, upperAlarmIntervalIndex: middleIndex };
    }
    exports2.findAlarmThresholds = findAlarmThresholds;
  }
});

// node_modules/aws-cdk-lib/aws-autoscaling-common/lib/test-utils.js
var require_test_utils = __commonJS({
  "node_modules/aws-cdk-lib/aws-autoscaling-common/lib/test-utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.generateArbitraryIntervals = void 0;
    function generateArbitraryIntervals(mrng) {
      const ret = new Array(), absolute = mrng.nextBoolean(), factor = (mrng.nextBoolean() ? 1 : -1) * (absolute ? 10 : 1), bias = absolute ? 50 : 0;
      ret.push({ lower: 0, upper: 10, change: -2 * factor + bias }), ret.push({ lower: 10, upper: 20, change: -1 * factor + bias }), ret.push({ lower: 20, upper: 60, change: 0 + bias }), ret.push({ lower: 60, upper: 80, change: 0 + bias }), ret.push({ lower: 80, upper: 90, change: 1 * factor + bias }), ret.push({ lower: 90, upper: 1 / 0, change: 2 * factor + bias });
      const noChanges = ret.filter((x) => x.change === bias);
      if (absolute ? mrng.nextBoolean() ? (ret.splice(ret.indexOf(noChanges[0]), 1), ret.splice(ret.indexOf(noChanges[1]), 1)) : (noChanges[0] = { ...noChanges[0], change: -1 * factor + bias }, noChanges[1] = { ...noChanges[1], change: 1 * factor + bias }) : (mrng.nextBoolean() && (mrng.nextBoolean() ? ret.splice(ret.indexOf(noChanges[0]), 1) : noChanges[0] = { ...noChanges[0], change: -1 * factor + bias }), mrng.nextBoolean() && (mrng.nextBoolean() ? ret.splice(ret.indexOf(noChanges[1]), 1) : noChanges[1] = { ...noChanges[1], change: 1 * factor + bias })), mrng.nextInt(0, 2) === 0) {
        const signToStrip = mrng.nextBoolean() ? -1 : 1;
        let ix = ret.findIndex((x) => Math.sign(x.change - bias) === signToStrip);
        for (; ix >= 0; )
          ret.splice(ix, 1), ix = ret.findIndex((x) => Math.sign(x.change - bias) === signToStrip);
      }
      const iterations = mrng.nextInt(0, 10);
      for (let iter = 0; iter < iterations; iter++) {
        const i = mrng.nextInt(0, ret.length - 1);
        mrng.nextBoolean() ? ret[i].upper !== void 0 && (i === 0 || ret[i - 1].upper !== void 0) && (ret[i] = { ...ret[i], lower: void 0 }) : ret[i].lower !== void 0 && (i === ret.length - 1 || ret[i + 1].lower !== void 0) && (ret[i] = { ...ret[i], upper: void 0 });
      }
      return { absolute, intervals: ret };
    }
    exports2.generateArbitraryIntervals = generateArbitraryIntervals;
  }
});

// node_modules/aws-cdk-lib/aws-autoscaling-common/lib/index.js
var require_lib21 = __commonJS({
  "node_modules/aws-cdk-lib/aws-autoscaling-common/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_types6(), exports2), __exportStar(require_interval_utils(), exports2), __exportStar(require_test_utils(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-autoscaling-common/index.js
var require_aws_autoscaling_common = __commonJS({
  "node_modules/aws-cdk-lib/aws-autoscaling-common/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib21(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-applicationautoscaling/lib/step-scaling-policy.js
var require_step_scaling_policy = __commonJS({
  "node_modules/aws-cdk-lib/aws-applicationautoscaling/lib/step-scaling-policy.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.StepScalingPolicy = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var step_scaling_action_1 = require_step_scaling_action();
    var aws_autoscaling_common_1 = require_aws_autoscaling_common();
    var cloudwatch = require_aws_cloudwatch();
    var StepScalingPolicy = class _StepScalingPolicy extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_applicationautoscaling_StepScalingPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _StepScalingPolicy), error;
        }
        if (props.scalingSteps.length < 2)
          throw new Error("You must supply at least 2 intervals for autoscaling");
        if (props.datapointsToAlarm !== void 0 && props.datapointsToAlarm < 1)
          throw new RangeError(`datapointsToAlarm cannot be less than 1, got: ${props.datapointsToAlarm}`);
        const adjustmentType = props.adjustmentType || step_scaling_action_1.AdjustmentType.CHANGE_IN_CAPACITY, changesAreAbsolute = adjustmentType === step_scaling_action_1.AdjustmentType.EXACT_CAPACITY, intervals = (0, aws_autoscaling_common_1.normalizeIntervals)(props.scalingSteps, changesAreAbsolute), alarms = (0, aws_autoscaling_common_1.findAlarmThresholds)(intervals);
        if (alarms.lowerAlarmIntervalIndex !== void 0) {
          const threshold = intervals[alarms.lowerAlarmIntervalIndex].upper;
          this.lowerAction = new step_scaling_action_1.StepScalingAction(this, "LowerPolicy", { adjustmentType, cooldown: props.cooldown, metricAggregationType: props.metricAggregationType ?? aggregationTypeFromMetric(props.metric), minAdjustmentMagnitude: props.minAdjustmentMagnitude, scalingTarget: props.scalingTarget });
          for (let i = alarms.lowerAlarmIntervalIndex; i >= 0; i--)
            this.lowerAction.addAdjustment({ adjustment: intervals[i].change, lowerBound: i !== 0 ? intervals[i].lower - threshold : void 0, upperBound: intervals[i].upper - threshold });
          this.lowerAlarm = new cloudwatch.Alarm(this, "LowerAlarm", { metric: props.metric, alarmDescription: "Lower threshold scaling alarm", comparisonOperator: cloudwatch.ComparisonOperator.LESS_THAN_OR_EQUAL_TO_THRESHOLD, evaluationPeriods: props.evaluationPeriods ?? 1, datapointsToAlarm: props.datapointsToAlarm, threshold }), this.lowerAlarm.addAlarmAction(new StepScalingAlarmAction(this.lowerAction));
        }
        if (alarms.upperAlarmIntervalIndex !== void 0) {
          const threshold = intervals[alarms.upperAlarmIntervalIndex].lower;
          this.upperAction = new step_scaling_action_1.StepScalingAction(this, "UpperPolicy", { adjustmentType, cooldown: props.cooldown, metricAggregationType: props.metricAggregationType ?? aggregationTypeFromMetric(props.metric), minAdjustmentMagnitude: props.minAdjustmentMagnitude, scalingTarget: props.scalingTarget });
          for (let i = alarms.upperAlarmIntervalIndex; i < intervals.length; i++)
            this.upperAction.addAdjustment({ adjustment: intervals[i].change, lowerBound: intervals[i].lower - threshold, upperBound: i !== intervals.length - 1 ? intervals[i].upper - threshold : void 0 });
          this.upperAlarm = new cloudwatch.Alarm(this, "UpperAlarm", { metric: props.metric, alarmDescription: "Upper threshold scaling alarm", comparisonOperator: cloudwatch.ComparisonOperator.GREATER_THAN_OR_EQUAL_TO_THRESHOLD, evaluationPeriods: props.evaluationPeriods ?? 1, datapointsToAlarm: props.datapointsToAlarm, threshold }), this.upperAlarm.addAlarmAction(new StepScalingAlarmAction(this.upperAction));
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, StepScalingPolicy[_a] = { fqn: "aws-cdk-lib.aws_applicationautoscaling.StepScalingPolicy", version: "2.80.0" }, exports2.StepScalingPolicy = StepScalingPolicy;
    function aggregationTypeFromMetric(metric) {
      const statistic = metric.toMetricConfig().metricStat?.statistic;
      if (statistic != null)
        switch (statistic) {
          case "Average":
            return step_scaling_action_1.MetricAggregationType.AVERAGE;
          case "Minimum":
            return step_scaling_action_1.MetricAggregationType.MINIMUM;
          case "Maximum":
            return step_scaling_action_1.MetricAggregationType.MAXIMUM;
          default:
            return step_scaling_action_1.MetricAggregationType.AVERAGE;
        }
    }
    var StepScalingAlarmAction = class {
      constructor(stepScalingAction) {
        this.stepScalingAction = stepScalingAction;
      }
      bind(_scope, _alarm) {
        return { alarmActionArn: this.stepScalingAction.scalingPolicyArn };
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-applicationautoscaling/lib/scalable-target.js
var require_scalable_target = __commonJS({
  "node_modules/aws-cdk-lib/aws-applicationautoscaling/lib/scalable-target.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ServiceNamespace = exports2.ScalableTarget = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var applicationautoscaling_generated_1 = require_applicationautoscaling_generated();
    var step_scaling_policy_1 = require_step_scaling_policy();
    var target_tracking_scaling_policy_1 = require_target_tracking_scaling_policy();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var ScalableTarget = class _ScalableTarget extends core_1.Resource {
      static fromScalableTargetId(scope, id, scalableTargetId) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.scalableTargetId = scalableTargetId;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id), this.actions = new Array();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_applicationautoscaling_ScalableTargetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ScalableTarget), error;
        }
        (0, core_1.withResolved)(props.maxCapacity, (max) => {
          if (max < 0)
            throw new RangeError(`maxCapacity cannot be negative, got: ${props.maxCapacity}`);
        }), (0, core_1.withResolved)(props.minCapacity, (min) => {
          if (min < 0)
            throw new RangeError(`minCapacity cannot be negative, got: ${props.minCapacity}`);
        }), (0, core_1.withResolved)(props.minCapacity, props.maxCapacity, (min, max) => {
          if (max < min)
            throw new RangeError(`minCapacity (${props.minCapacity}) should be lower than maxCapacity (${props.maxCapacity})`);
        }), this.role = props.role || new iam.Role(this, "Role", { assumedBy: new iam.ServicePrincipal("application-autoscaling.amazonaws.com") });
        const resource = new applicationautoscaling_generated_1.CfnScalableTarget(this, "Resource", { maxCapacity: props.maxCapacity, minCapacity: props.minCapacity, resourceId: props.resourceId, roleArn: this.role.roleArn, scalableDimension: props.scalableDimension, scheduledActions: core_1.Lazy.any({ produce: () => this.actions }, { omitEmptyArray: true }), serviceNamespace: props.serviceNamespace });
        this.scalableTargetId = resource.ref;
      }
      addToRolePolicy(statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToRolePolicy), error;
        }
        this.role.addToPrincipalPolicy(statement);
      }
      scaleOnSchedule(id, action) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_applicationautoscaling_ScalingSchedule(action);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.scaleOnSchedule), error;
        }
        if (action.minCapacity === void 0 && action.maxCapacity === void 0)
          throw new Error(`You must supply at least one of minCapacity or maxCapacity, got ${JSON.stringify(action)}`);
        action.schedule._bind(this), this.actions.push({ scheduledActionName: id, schedule: action.schedule.expressionString, startTime: action.startTime, endTime: action.endTime, scalableTargetAction: { maxCapacity: action.maxCapacity, minCapacity: action.minCapacity } });
      }
      scaleOnMetric(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_applicationautoscaling_BasicStepScalingPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.scaleOnMetric), error;
        }
        return new step_scaling_policy_1.StepScalingPolicy(this, id, { ...props, scalingTarget: this });
      }
      scaleToTrackMetric(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_applicationautoscaling_BasicTargetTrackingScalingPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.scaleToTrackMetric), error;
        }
        return new target_tracking_scaling_policy_1.TargetTrackingScalingPolicy(this, id, { ...props, scalingTarget: this });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ScalableTarget[_a] = { fqn: "aws-cdk-lib.aws_applicationautoscaling.ScalableTarget", version: "2.80.0" }, exports2.ScalableTarget = ScalableTarget;
    var ServiceNamespace;
    (function(ServiceNamespace2) {
      ServiceNamespace2.ECS = "ecs", ServiceNamespace2.ELASTIC_MAP_REDUCE = "elasticmapreduce", ServiceNamespace2.EC2 = "ec2", ServiceNamespace2.APPSTREAM = "appstream", ServiceNamespace2.DYNAMODB = "dynamodb", ServiceNamespace2.RDS = "rds", ServiceNamespace2.SAGEMAKER = "sagemaker", ServiceNamespace2.CUSTOM_RESOURCE = "custom-resource", ServiceNamespace2.LAMBDA = "lambda", ServiceNamespace2.COMPREHEND = "comprehend", ServiceNamespace2.KAFKA = "kafka", ServiceNamespace2.ELASTICACHE = "elasticache", ServiceNamespace2.NEPTUNE = "neptune";
    })(ServiceNamespace = exports2.ServiceNamespace || (exports2.ServiceNamespace = {}));
  }
});

// node_modules/aws-cdk-lib/aws-applicationautoscaling/lib/base-scalable-attribute.js
var require_base_scalable_attribute = __commonJS({
  "node_modules/aws-cdk-lib/aws-applicationautoscaling/lib/base-scalable-attribute.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.BaseScalableAttribute = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var scalable_target_1 = require_scalable_target();
    var BaseScalableAttribute = class _BaseScalableAttribute extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_applicationautoscaling_BaseScalableAttributeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _BaseScalableAttribute), error;
        }
        this.target = new scalable_target_1.ScalableTarget(this, "Target", { serviceNamespace: this.props.serviceNamespace, scalableDimension: this.props.dimension, resourceId: this.props.resourceId, role: this.props.role, minCapacity: props.minCapacity ?? 1, maxCapacity: props.maxCapacity });
      }
      doScaleOnSchedule(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_applicationautoscaling_ScalingSchedule(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.doScaleOnSchedule), error;
        }
        this.target.scaleOnSchedule(id, props);
      }
      doScaleOnMetric(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_applicationautoscaling_BasicStepScalingPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.doScaleOnMetric), error;
        }
        this.target.scaleOnMetric(id, props);
      }
      doScaleToTrackMetric(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_applicationautoscaling_BasicTargetTrackingScalingPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.doScaleToTrackMetric), error;
        }
        this.target.scaleToTrackMetric(id, props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, BaseScalableAttribute[_a] = { fqn: "aws-cdk-lib.aws_applicationautoscaling.BaseScalableAttribute", version: "2.80.0" }, exports2.BaseScalableAttribute = BaseScalableAttribute;
  }
});

// node_modules/aws-cdk-lib/aws-applicationautoscaling/lib/schedule.js
var require_schedule2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-applicationautoscaling/lib/schedule.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Schedule = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core_1 = require_core2();
    var Schedule = class _Schedule {
      static expression(expression) {
        return new LiteralSchedule(expression);
      }
      static rate(duration) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Duration(duration);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.rate), error;
        }
        if (duration.isUnresolved()) {
          if (!["minute", "minutes", "hour", "hours", "day", "days"].includes(duration.unitLabel()))
            throw new Error("Allowed units for scheduling are: 'minute', 'minutes', 'hour', 'hours', 'day' or 'days'");
          return new LiteralSchedule(`rate(${duration.formatTokenToNumber()})`);
        }
        if (duration.toSeconds() === 0)
          throw new Error("Duration cannot be 0");
        let rate = maybeRate(duration.toDays({ integral: false }), "day");
        return rate === void 0 && (rate = maybeRate(duration.toHours({ integral: false }), "hour")), rate === void 0 && (rate = makeRate(duration.toMinutes({ integral: true }), "minute")), new LiteralSchedule(rate);
      }
      static at(moment) {
        return new LiteralSchedule(`at(${formatISO(moment)})`);
      }
      static cron(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_applicationautoscaling_CronOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.cron), error;
        }
        if (options.weekDay !== void 0 && options.day !== void 0)
          throw new Error("Cannot supply both 'day' and 'weekDay', use at most one");
        const minute = fallback(options.minute, "*"), hour = fallback(options.hour, "*"), month = fallback(options.month, "*"), year = fallback(options.year, "*"), day = fallback(options.day, options.weekDay !== void 0 ? "?" : "*"), weekDay = fallback(options.weekDay, "?");
        return new class extends _Schedule {
          constructor() {
            super(...arguments), this.expressionString = `cron(${minute} ${hour} ${day} ${month} ${weekDay} ${year})`;
          }
          _bind(scope) {
            return options.minute || core_1.Annotations.of(scope).addWarning("cron: If you don't pass 'minute', by default the event runs every minute. Pass 'minute: '*'' if that's what you intend, or 'minute: 0' to run once per hour instead."), new LiteralSchedule(this.expressionString);
          }
        }();
      }
      constructor() {
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Schedule[_a] = { fqn: "aws-cdk-lib.aws_applicationautoscaling.Schedule", version: "2.80.0" }, exports2.Schedule = Schedule;
    var LiteralSchedule = class extends Schedule {
      constructor(expressionString) {
        super(), this.expressionString = expressionString;
      }
      _bind() {
      }
    };
    function fallback(x, def) {
      return x === void 0 ? def : x;
    }
    function formatISO(date) {
      if (!date)
        return;
      return date.getUTCFullYear() + "-" + pad(date.getUTCMonth() + 1) + "-" + pad(date.getUTCDate()) + "T" + pad(date.getUTCHours()) + ":" + pad(date.getUTCMinutes()) + ":" + pad(date.getUTCSeconds());
      function pad(num) {
        return num < 10 ? "0" + num : num;
      }
    }
    function maybeRate(interval, singular) {
      if (!(interval === 0 || !Number.isInteger(interval)))
        return makeRate(interval, singular);
    }
    function makeRate(interval, singular) {
      return interval === 1 ? `rate(1 ${singular})` : `rate(${interval} ${singular}s)`;
    }
  }
});

// node_modules/aws-cdk-lib/aws-applicationautoscaling/lib/index.js
var require_lib22 = __commonJS({
  "node_modules/aws-cdk-lib/aws-applicationautoscaling/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_applicationautoscaling_generated(), exports2), __exportStar(require_base_scalable_attribute(), exports2), __exportStar(require_schedule2(), exports2), __exportStar(require_scalable_target(), exports2), __exportStar(require_step_scaling_policy(), exports2), __exportStar(require_step_scaling_action(), exports2), __exportStar(require_target_tracking_scaling_policy(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-applicationautoscaling/index.js
var require_aws_applicationautoscaling = __commonJS({
  "node_modules/aws-cdk-lib/aws-applicationautoscaling/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib22(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/private/scalable-function-attribute.js
var require_scalable_function_attribute = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/private/scalable-function-attribute.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ScalableFunctionAttribute = void 0;
    var appscaling = require_aws_applicationautoscaling();
    var core_1 = require_core2();
    var ScalableFunctionAttribute = class extends appscaling.BaseScalableAttribute {
      constructor(scope, id, props) {
        super(scope, id, props);
      }
      scaleOnUtilization(options) {
        if (!core_1.Token.isUnresolved(options.utilizationTarget) && (options.utilizationTarget < 0.1 || options.utilizationTarget > 0.9))
          throw new Error(`Utilization Target should be between 0.1 and 0.9. Found ${options.utilizationTarget}.`);
        super.doScaleToTrackMetric("Tracking", { targetValue: options.utilizationTarget, predefinedMetric: appscaling.PredefinedMetric.LAMBDA_PROVISIONED_CONCURRENCY_UTILIZATION, ...options });
      }
      scaleOnSchedule(id, action) {
        super.doScaleOnSchedule(id, action);
      }
    };
    exports2.ScalableFunctionAttribute = ScalableFunctionAttribute;
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/alias.js
var require_alias2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/alias.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Alias = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var function_base_1 = require_function_base();
    var lambda_version_1 = require_lambda_version();
    var lambda_generated_1 = require_lambda_generated();
    var scalable_function_attribute_1 = require_scalable_function_attribute();
    var appscaling = require_aws_applicationautoscaling();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var Alias = class _Alias extends function_base_1.QualifiedFunctionBase {
      static fromAliasAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_AliasAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromAliasAttributes), error;
        }
        class Imported extends function_base_1.QualifiedFunctionBase {
          constructor() {
            super(...arguments), this.aliasName = attrs.aliasName, this.version = attrs.aliasVersion, this.lambda = attrs.aliasVersion.lambda, this.functionArn = `${attrs.aliasVersion.lambda.functionArn}:${attrs.aliasName}`, this.functionName = `${attrs.aliasVersion.lambda.functionName}:${attrs.aliasName}`, this.grantPrincipal = attrs.aliasVersion.grantPrincipal, this.role = attrs.aliasVersion.role, this.architecture = attrs.aliasVersion.lambda.architecture, this.canCreatePermissions = this._isStackAccount(), this.qualifier = attrs.aliasName;
          }
        }
        return new Imported(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.aliasName }), this.canCreatePermissions = true;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_AliasProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Alias), error;
        }
        this.lambda = props.version.lambda, this.aliasName = this.physicalName, this.version = props.version, this.architecture = this.lambda.architecture;
        const alias = new lambda_generated_1.CfnAlias(this, "Resource", { name: this.aliasName, description: props.description, functionName: this.version.lambda.functionName, functionVersion: props.version.version, routingConfig: this.determineRoutingConfig(props), provisionedConcurrencyConfig: this.determineProvisionedConcurrency(props) });
        this.scalingRole = iam.Role.fromRoleArn(this, "ScalingRole", this.stack.formatArn({ service: "iam", region: "", resource: "role/aws-service-role/lambda.application-autoscaling.amazonaws.com", resourceName: "AWSServiceRoleForApplicationAutoScaling_LambdaConcurrency" })), this.functionArn = this.getResourceArnAttribute(alias.ref, { service: "lambda", resource: "function", resourceName: `${this.lambda.functionName}:${this.physicalName}`, arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME }), this.qualifier = (0, lambda_version_1.extractQualifierFromArn)(alias.ref), (props.onFailure || props.onSuccess || props.maxEventAge || props.retryAttempts !== void 0) && this.configureAsyncInvoke({ onFailure: props.onFailure, onSuccess: props.onSuccess, maxEventAge: props.maxEventAge, retryAttempts: props.retryAttempts }), this.functionName = `${this.stack.splitArn(this.functionArn, core_1.ArnFormat.COLON_RESOURCE_NAME).resourceName}:${this.aliasName}`;
      }
      get grantPrincipal() {
        return this.version.grantPrincipal;
      }
      get role() {
        return this.version.role;
      }
      metric(metricName, props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metric), error;
        }
        return super.metric(metricName, { dimensionsMap: { FunctionName: this.lambda.functionName, Resource: `${this.lambda.functionName}:${this.aliasName}` }, ...props });
      }
      addAutoScaling(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_AutoScalingOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addAutoScaling), error;
        }
        if (this.scalableAlias)
          throw new Error("AutoScaling already enabled for this alias");
        return this.scalableAlias = new scalable_function_attribute_1.ScalableFunctionAttribute(this, "AliasScaling", { minCapacity: options.minCapacity ?? 1, maxCapacity: options.maxCapacity, resourceId: `function:${this.functionName}`, dimension: "lambda:function:ProvisionedConcurrency", serviceNamespace: appscaling.ServiceNamespace.LAMBDA, role: this.scalingRole });
      }
      determineRoutingConfig(props) {
        if (!(!props.additionalVersions || props.additionalVersions.length === 0))
          return this.validateAdditionalWeights(props.additionalVersions), { additionalVersionWeights: props.additionalVersions.map((vw) => ({ functionVersion: vw.version.version, functionWeight: vw.weight })) };
      }
      validateAdditionalWeights(weights) {
        const total = weights.map((w) => {
          if (w.weight < 0 || w.weight > 1)
            throw new Error(`Additional version weight must be between 0 and 1, got: ${w.weight}`);
          return w.weight;
        }).reduce((a, x) => a + x);
        if (total > 1)
          throw new Error(`Sum of additional version weights must not exceed 1, got: ${total}`);
      }
      determineProvisionedConcurrency(props) {
        if (props.provisionedConcurrentExecutions) {
          if (props.provisionedConcurrentExecutions <= 0)
            throw new Error("provisionedConcurrentExecutions must have value greater than or equal to 1");
          return { provisionedConcurrentExecutions: props.provisionedConcurrentExecutions };
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Alias[_a] = { fqn: "aws-cdk-lib.aws_lambda.Alias", version: "2.80.0" }, exports2.Alias = Alias;
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/dlq.js
var require_dlq = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/dlq.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-ecr/lib/ecr.generated.js
var require_ecr_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecr/lib/ecr.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnRepository = exports2.CfnReplicationConfiguration = exports2.CfnRegistryPolicy = exports2.CfnPullThroughCacheRule = exports2.CfnPublicRepository = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnPublicRepositoryPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("repositoryCatalogData", cdk.validateObject)(properties.repositoryCatalogData)), errors.collect(cdk.propertyValidator("repositoryName", cdk.validateString)(properties.repositoryName)), errors.collect(cdk.propertyValidator("repositoryPolicyText", cdk.validateObject)(properties.repositoryPolicyText)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnPublicRepositoryProps"');
    }
    function cfnPublicRepositoryPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPublicRepositoryPropsValidator(properties).assertSuccess(), { RepositoryCatalogData: cdk.objectToCloudFormation(properties.repositoryCatalogData), RepositoryName: cdk.stringToCloudFormation(properties.repositoryName), RepositoryPolicyText: cdk.objectToCloudFormation(properties.repositoryPolicyText), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnPublicRepositoryPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("repositoryCatalogData", "RepositoryCatalogData", properties.RepositoryCatalogData != null ? cfn_parse.FromCloudFormation.getAny(properties.RepositoryCatalogData) : void 0), ret.addPropertyResult("repositoryName", "RepositoryName", properties.RepositoryName != null ? cfn_parse.FromCloudFormation.getString(properties.RepositoryName) : void 0), ret.addPropertyResult("repositoryPolicyText", "RepositoryPolicyText", properties.RepositoryPolicyText != null ? cfn_parse.FromCloudFormation.getAny(properties.RepositoryPolicyText) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPublicRepository = class _CfnPublicRepository extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPublicRepositoryPropsFromCloudFormation(resourceProperties), ret = new _CfnPublicRepository(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnPublicRepository.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecr_CfnPublicRepositoryProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPublicRepository), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.repositoryCatalogData = props.repositoryCatalogData, this.repositoryName = props.repositoryName, this.repositoryPolicyText = props.repositoryPolicyText, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ECR::PublicRepository", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPublicRepository.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { repositoryCatalogData: this.repositoryCatalogData, repositoryName: this.repositoryName, repositoryPolicyText: this.repositoryPolicyText, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnPublicRepositoryPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnPublicRepository[_a] = { fqn: "aws-cdk-lib.aws_ecr.CfnPublicRepository", version: "2.80.0" }, CfnPublicRepository.CFN_RESOURCE_TYPE_NAME = "AWS::ECR::PublicRepository", exports2.CfnPublicRepository = CfnPublicRepository;
    function CfnPullThroughCacheRulePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ecrRepositoryPrefix", cdk.validateString)(properties.ecrRepositoryPrefix)), errors.collect(cdk.propertyValidator("upstreamRegistryUrl", cdk.validateString)(properties.upstreamRegistryUrl)), errors.wrap('supplied properties not correct for "CfnPullThroughCacheRuleProps"');
    }
    function cfnPullThroughCacheRulePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPullThroughCacheRulePropsValidator(properties).assertSuccess(), { EcrRepositoryPrefix: cdk.stringToCloudFormation(properties.ecrRepositoryPrefix), UpstreamRegistryUrl: cdk.stringToCloudFormation(properties.upstreamRegistryUrl) }) : properties;
    }
    function CfnPullThroughCacheRulePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ecrRepositoryPrefix", "EcrRepositoryPrefix", properties.EcrRepositoryPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.EcrRepositoryPrefix) : void 0), ret.addPropertyResult("upstreamRegistryUrl", "UpstreamRegistryUrl", properties.UpstreamRegistryUrl != null ? cfn_parse.FromCloudFormation.getString(properties.UpstreamRegistryUrl) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPullThroughCacheRule = class _CfnPullThroughCacheRule extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPullThroughCacheRulePropsFromCloudFormation(resourceProperties), ret = new _CfnPullThroughCacheRule(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnPullThroughCacheRule.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecr_CfnPullThroughCacheRuleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPullThroughCacheRule), error;
        }
        this.ecrRepositoryPrefix = props.ecrRepositoryPrefix, this.upstreamRegistryUrl = props.upstreamRegistryUrl;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPullThroughCacheRule.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { ecrRepositoryPrefix: this.ecrRepositoryPrefix, upstreamRegistryUrl: this.upstreamRegistryUrl };
      }
      renderProperties(props) {
        return cfnPullThroughCacheRulePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnPullThroughCacheRule[_b] = { fqn: "aws-cdk-lib.aws_ecr.CfnPullThroughCacheRule", version: "2.80.0" }, CfnPullThroughCacheRule.CFN_RESOURCE_TYPE_NAME = "AWS::ECR::PullThroughCacheRule", exports2.CfnPullThroughCacheRule = CfnPullThroughCacheRule;
    function CfnRegistryPolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("policyText", cdk.requiredValidator)(properties.policyText)), errors.collect(cdk.propertyValidator("policyText", cdk.validateObject)(properties.policyText)), errors.wrap('supplied properties not correct for "CfnRegistryPolicyProps"');
    }
    function cfnRegistryPolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRegistryPolicyPropsValidator(properties).assertSuccess(), { PolicyText: cdk.objectToCloudFormation(properties.policyText) }) : properties;
    }
    function CfnRegistryPolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("policyText", "PolicyText", cfn_parse.FromCloudFormation.getAny(properties.PolicyText)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRegistryPolicy = class _CfnRegistryPolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRegistryPolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnRegistryPolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRegistryPolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecr_CfnRegistryPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRegistryPolicy), error;
        }
        cdk.requireProperty(props, "policyText", this), this.attrRegistryId = cdk.Token.asString(this.getAtt("RegistryId", cdk.ResolutionTypeHint.STRING)), this.policyText = props.policyText;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRegistryPolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { policyText: this.policyText };
      }
      renderProperties(props) {
        return cfnRegistryPolicyPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnRegistryPolicy[_c] = { fqn: "aws-cdk-lib.aws_ecr.CfnRegistryPolicy", version: "2.80.0" }, CfnRegistryPolicy.CFN_RESOURCE_TYPE_NAME = "AWS::ECR::RegistryPolicy", exports2.CfnRegistryPolicy = CfnRegistryPolicy;
    function CfnReplicationConfigurationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("replicationConfiguration", cdk.requiredValidator)(properties.replicationConfiguration)), errors.collect(cdk.propertyValidator("replicationConfiguration", CfnReplicationConfiguration_ReplicationConfigurationPropertyValidator)(properties.replicationConfiguration)), errors.wrap('supplied properties not correct for "CfnReplicationConfigurationProps"');
    }
    function cfnReplicationConfigurationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReplicationConfigurationPropsValidator(properties).assertSuccess(), { ReplicationConfiguration: cfnReplicationConfigurationReplicationConfigurationPropertyToCloudFormation(properties.replicationConfiguration) }) : properties;
    }
    function CfnReplicationConfigurationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("replicationConfiguration", "ReplicationConfiguration", CfnReplicationConfigurationReplicationConfigurationPropertyFromCloudFormation(properties.ReplicationConfiguration)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnReplicationConfiguration = class _CfnReplicationConfiguration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnReplicationConfigurationPropsFromCloudFormation(resourceProperties), ret = new _CfnReplicationConfiguration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnReplicationConfiguration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecr_CfnReplicationConfigurationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnReplicationConfiguration), error;
        }
        cdk.requireProperty(props, "replicationConfiguration", this), this.attrRegistryId = cdk.Token.asString(this.getAtt("RegistryId", cdk.ResolutionTypeHint.STRING)), this.replicationConfiguration = props.replicationConfiguration;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnReplicationConfiguration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { replicationConfiguration: this.replicationConfiguration };
      }
      renderProperties(props) {
        return cfnReplicationConfigurationPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnReplicationConfiguration[_d] = { fqn: "aws-cdk-lib.aws_ecr.CfnReplicationConfiguration", version: "2.80.0" }, CfnReplicationConfiguration.CFN_RESOURCE_TYPE_NAME = "AWS::ECR::ReplicationConfiguration", exports2.CfnReplicationConfiguration = CfnReplicationConfiguration;
    function CfnReplicationConfiguration_ReplicationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("rules", cdk.requiredValidator)(properties.rules)), errors.collect(cdk.propertyValidator("rules", cdk.listValidator(CfnReplicationConfiguration_ReplicationRulePropertyValidator))(properties.rules)), errors.wrap('supplied properties not correct for "ReplicationConfigurationProperty"');
    }
    function cfnReplicationConfigurationReplicationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReplicationConfiguration_ReplicationConfigurationPropertyValidator(properties).assertSuccess(), { Rules: cdk.listMapper(cfnReplicationConfigurationReplicationRulePropertyToCloudFormation)(properties.rules) }) : properties;
    }
    function CfnReplicationConfigurationReplicationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("rules", "Rules", cfn_parse.FromCloudFormation.getArray(CfnReplicationConfigurationReplicationRulePropertyFromCloudFormation)(properties.Rules)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnReplicationConfiguration_ReplicationDestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("region", cdk.requiredValidator)(properties.region)), errors.collect(cdk.propertyValidator("region", cdk.validateString)(properties.region)), errors.collect(cdk.propertyValidator("registryId", cdk.requiredValidator)(properties.registryId)), errors.collect(cdk.propertyValidator("registryId", cdk.validateString)(properties.registryId)), errors.wrap('supplied properties not correct for "ReplicationDestinationProperty"');
    }
    function cfnReplicationConfigurationReplicationDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReplicationConfiguration_ReplicationDestinationPropertyValidator(properties).assertSuccess(), { Region: cdk.stringToCloudFormation(properties.region), RegistryId: cdk.stringToCloudFormation(properties.registryId) }) : properties;
    }
    function CfnReplicationConfigurationReplicationDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("region", "Region", cfn_parse.FromCloudFormation.getString(properties.Region)), ret.addPropertyResult("registryId", "RegistryId", cfn_parse.FromCloudFormation.getString(properties.RegistryId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnReplicationConfiguration_ReplicationRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinations", cdk.requiredValidator)(properties.destinations)), errors.collect(cdk.propertyValidator("destinations", cdk.listValidator(CfnReplicationConfiguration_ReplicationDestinationPropertyValidator))(properties.destinations)), errors.collect(cdk.propertyValidator("repositoryFilters", cdk.listValidator(CfnReplicationConfiguration_RepositoryFilterPropertyValidator))(properties.repositoryFilters)), errors.wrap('supplied properties not correct for "ReplicationRuleProperty"');
    }
    function cfnReplicationConfigurationReplicationRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReplicationConfiguration_ReplicationRulePropertyValidator(properties).assertSuccess(), { Destinations: cdk.listMapper(cfnReplicationConfigurationReplicationDestinationPropertyToCloudFormation)(properties.destinations), RepositoryFilters: cdk.listMapper(cfnReplicationConfigurationRepositoryFilterPropertyToCloudFormation)(properties.repositoryFilters) }) : properties;
    }
    function CfnReplicationConfigurationReplicationRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinations", "Destinations", cfn_parse.FromCloudFormation.getArray(CfnReplicationConfigurationReplicationDestinationPropertyFromCloudFormation)(properties.Destinations)), ret.addPropertyResult("repositoryFilters", "RepositoryFilters", properties.RepositoryFilters != null ? cfn_parse.FromCloudFormation.getArray(CfnReplicationConfigurationRepositoryFilterPropertyFromCloudFormation)(properties.RepositoryFilters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnReplicationConfiguration_RepositoryFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("filter", cdk.requiredValidator)(properties.filter)), errors.collect(cdk.propertyValidator("filter", cdk.validateString)(properties.filter)), errors.collect(cdk.propertyValidator("filterType", cdk.requiredValidator)(properties.filterType)), errors.collect(cdk.propertyValidator("filterType", cdk.validateString)(properties.filterType)), errors.wrap('supplied properties not correct for "RepositoryFilterProperty"');
    }
    function cfnReplicationConfigurationRepositoryFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReplicationConfiguration_RepositoryFilterPropertyValidator(properties).assertSuccess(), { Filter: cdk.stringToCloudFormation(properties.filter), FilterType: cdk.stringToCloudFormation(properties.filterType) }) : properties;
    }
    function CfnReplicationConfigurationRepositoryFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("filter", "Filter", cfn_parse.FromCloudFormation.getString(properties.Filter)), ret.addPropertyResult("filterType", "FilterType", cfn_parse.FromCloudFormation.getString(properties.FilterType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRepositoryPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("encryptionConfiguration", CfnRepository_EncryptionConfigurationPropertyValidator)(properties.encryptionConfiguration)), errors.collect(cdk.propertyValidator("imageScanningConfiguration", CfnRepository_ImageScanningConfigurationPropertyValidator)(properties.imageScanningConfiguration)), errors.collect(cdk.propertyValidator("imageTagMutability", cdk.validateString)(properties.imageTagMutability)), errors.collect(cdk.propertyValidator("lifecyclePolicy", CfnRepository_LifecyclePolicyPropertyValidator)(properties.lifecyclePolicy)), errors.collect(cdk.propertyValidator("repositoryName", cdk.validateString)(properties.repositoryName)), errors.collect(cdk.propertyValidator("repositoryPolicyText", cdk.validateObject)(properties.repositoryPolicyText)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnRepositoryProps"');
    }
    function cfnRepositoryPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRepositoryPropsValidator(properties).assertSuccess(), { EncryptionConfiguration: cfnRepositoryEncryptionConfigurationPropertyToCloudFormation(properties.encryptionConfiguration), ImageScanningConfiguration: cfnRepositoryImageScanningConfigurationPropertyToCloudFormation(properties.imageScanningConfiguration), ImageTagMutability: cdk.stringToCloudFormation(properties.imageTagMutability), LifecyclePolicy: cfnRepositoryLifecyclePolicyPropertyToCloudFormation(properties.lifecyclePolicy), RepositoryName: cdk.stringToCloudFormation(properties.repositoryName), RepositoryPolicyText: cdk.objectToCloudFormation(properties.repositoryPolicyText), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnRepositoryPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("encryptionConfiguration", "EncryptionConfiguration", properties.EncryptionConfiguration != null ? CfnRepositoryEncryptionConfigurationPropertyFromCloudFormation(properties.EncryptionConfiguration) : void 0), ret.addPropertyResult("imageScanningConfiguration", "ImageScanningConfiguration", properties.ImageScanningConfiguration != null ? CfnRepositoryImageScanningConfigurationPropertyFromCloudFormation(properties.ImageScanningConfiguration) : void 0), ret.addPropertyResult("imageTagMutability", "ImageTagMutability", properties.ImageTagMutability != null ? cfn_parse.FromCloudFormation.getString(properties.ImageTagMutability) : void 0), ret.addPropertyResult("lifecyclePolicy", "LifecyclePolicy", properties.LifecyclePolicy != null ? CfnRepositoryLifecyclePolicyPropertyFromCloudFormation(properties.LifecyclePolicy) : void 0), ret.addPropertyResult("repositoryName", "RepositoryName", properties.RepositoryName != null ? cfn_parse.FromCloudFormation.getString(properties.RepositoryName) : void 0), ret.addPropertyResult("repositoryPolicyText", "RepositoryPolicyText", properties.RepositoryPolicyText != null ? cfn_parse.FromCloudFormation.getAny(properties.RepositoryPolicyText) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRepository = class _CfnRepository extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRepositoryPropsFromCloudFormation(resourceProperties), ret = new _CfnRepository(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnRepository.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecr_CfnRepositoryProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRepository), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrRepositoryUri = cdk.Token.asString(this.getAtt("RepositoryUri", cdk.ResolutionTypeHint.STRING)), this.encryptionConfiguration = props.encryptionConfiguration, this.imageScanningConfiguration = props.imageScanningConfiguration, this.imageTagMutability = props.imageTagMutability, this.lifecyclePolicy = props.lifecyclePolicy, this.repositoryName = props.repositoryName, this.repositoryPolicyText = props.repositoryPolicyText, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ECR::Repository", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRepository.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { encryptionConfiguration: this.encryptionConfiguration, imageScanningConfiguration: this.imageScanningConfiguration, imageTagMutability: this.imageTagMutability, lifecyclePolicy: this.lifecyclePolicy, repositoryName: this.repositoryName, repositoryPolicyText: this.repositoryPolicyText, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnRepositoryPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnRepository[_e] = { fqn: "aws-cdk-lib.aws_ecr.CfnRepository", version: "2.80.0" }, CfnRepository.CFN_RESOURCE_TYPE_NAME = "AWS::ECR::Repository", exports2.CfnRepository = CfnRepository;
    function CfnRepository_EncryptionConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("encryptionType", cdk.requiredValidator)(properties.encryptionType)), errors.collect(cdk.propertyValidator("encryptionType", cdk.validateString)(properties.encryptionType)), errors.collect(cdk.propertyValidator("kmsKey", cdk.validateString)(properties.kmsKey)), errors.wrap('supplied properties not correct for "EncryptionConfigurationProperty"');
    }
    function cfnRepositoryEncryptionConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRepository_EncryptionConfigurationPropertyValidator(properties).assertSuccess(), { EncryptionType: cdk.stringToCloudFormation(properties.encryptionType), KmsKey: cdk.stringToCloudFormation(properties.kmsKey) }) : properties;
    }
    function CfnRepositoryEncryptionConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("encryptionType", "EncryptionType", cfn_parse.FromCloudFormation.getString(properties.EncryptionType)), ret.addPropertyResult("kmsKey", "KmsKey", properties.KmsKey != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKey) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRepository_ImageScanningConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("scanOnPush", cdk.validateBoolean)(properties.scanOnPush)), errors.wrap('supplied properties not correct for "ImageScanningConfigurationProperty"');
    }
    function cfnRepositoryImageScanningConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRepository_ImageScanningConfigurationPropertyValidator(properties).assertSuccess(), { ScanOnPush: cdk.booleanToCloudFormation(properties.scanOnPush) }) : properties;
    }
    function CfnRepositoryImageScanningConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("scanOnPush", "ScanOnPush", properties.ScanOnPush != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ScanOnPush) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRepository_LifecyclePolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("lifecyclePolicyText", cdk.validateString)(properties.lifecyclePolicyText)), errors.collect(cdk.propertyValidator("registryId", cdk.validateString)(properties.registryId)), errors.wrap('supplied properties not correct for "LifecyclePolicyProperty"');
    }
    function cfnRepositoryLifecyclePolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRepository_LifecyclePolicyPropertyValidator(properties).assertSuccess(), { LifecyclePolicyText: cdk.stringToCloudFormation(properties.lifecyclePolicyText), RegistryId: cdk.stringToCloudFormation(properties.registryId) }) : properties;
    }
    function CfnRepositoryLifecyclePolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("lifecyclePolicyText", "LifecyclePolicyText", properties.LifecyclePolicyText != null ? cfn_parse.FromCloudFormation.getString(properties.LifecyclePolicyText) : void 0), ret.addPropertyResult("registryId", "RegistryId", properties.RegistryId != null ? cfn_parse.FromCloudFormation.getString(properties.RegistryId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-ecr/lib/lifecycle.js
var require_lifecycle = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecr/lib/lifecycle.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.TagStatus = void 0;
    var TagStatus;
    (function(TagStatus2) {
      TagStatus2.ANY = "any", TagStatus2.TAGGED = "tagged", TagStatus2.UNTAGGED = "untagged";
    })(TagStatus = exports2.TagStatus || (exports2.TagStatus = {}));
  }
});

// node_modules/aws-cdk-lib/aws-ecr/lib/repository.js
var require_repository = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecr/lib/repository.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.RepositoryEncryption = exports2.TagMutability = exports2.Repository = exports2.RepositoryBase = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var os_1 = require("os");
    var path = require("path");
    var ecr_generated_1 = require_ecr_generated();
    var lifecycle_1 = require_lifecycle();
    var events = require_aws_events();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var AUTO_DELETE_IMAGES_RESOURCE_TYPE = "Custom::ECRAutoDeleteImages";
    var AUTO_DELETE_IMAGES_TAG = "aws-cdk:auto-delete-images";
    var RepositoryBase = class extends core_1.Resource {
      get repositoryUri() {
        return this.repositoryUriForTag();
      }
      repositoryUriForTag(tag) {
        const tagSuffix = tag ? `:${tag}` : "";
        return this.repositoryUriWithSuffix(tagSuffix);
      }
      repositoryUriForDigest(digest) {
        const digestSuffix = digest ? `@${digest}` : "";
        return this.repositoryUriWithSuffix(digestSuffix);
      }
      repositoryUriForTagOrDigest(tagOrDigest) {
        return tagOrDigest?.startsWith("sha256:") ? this.repositoryUriForDigest(tagOrDigest) : this.repositoryUriForTag(tagOrDigest);
      }
      repositoryUriWithSuffix(suffix) {
        const parts = this.stack.splitArn(this.repositoryArn, core_1.ArnFormat.SLASH_RESOURCE_NAME);
        return `${parts.account}.dkr.ecr.${parts.region}.${this.stack.urlSuffix}/${this.repositoryName}${suffix}`;
      }
      onCloudTrailEvent(id, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_OnEventOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.onCloudTrailEvent), error;
        }
        const rule = new events.Rule(this, id, options);
        return rule.addTarget(options.target), rule.addEventPattern({ source: ["aws.ecr"], detailType: ["AWS API Call via CloudTrail"], detail: { requestParameters: { repositoryName: [this.repositoryName] } } }), rule;
      }
      onCloudTrailImagePushed(id, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecr_OnCloudTrailImagePushedOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.onCloudTrailImagePushed), error;
        }
        const rule = this.onCloudTrailEvent(id, options);
        return rule.addEventPattern({ detail: { eventName: ["PutImage"], requestParameters: { imageTag: options.imageTag ? [options.imageTag] : void 0 } } }), rule;
      }
      onImageScanCompleted(id, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecr_OnImageScanCompletedOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.onImageScanCompleted), error;
        }
        const rule = new events.Rule(this, id, options);
        return rule.addTarget(options.target), rule.addEventPattern({ source: ["aws.ecr"], detailType: ["ECR Image Scan"], detail: { "repository-name": [this.repositoryName], "scan-status": ["COMPLETE"], "image-tags": options.imageTags ?? void 0 } }), rule;
      }
      onEvent(id, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_OnEventOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.onEvent), error;
        }
        const rule = new events.Rule(this, id, options);
        return rule.addEventPattern({ source: ["aws.ecr"], resources: [this.repositoryArn] }), rule.addTarget(options.target), rule;
      }
      grant(grantee, ...actions) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(grantee);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grant), error;
        }
        const crossAccountPrincipal = this.unsafeCrossAccountResourcePolicyPrincipal(grantee);
        if (crossAccountPrincipal) {
          const crossAccountPrincipalStack = core_1.Stack.of(crossAccountPrincipal), roleTag = `${crossAccountPrincipalStack.stackName}_${crossAccountPrincipal.node.addr}`;
          return core_1.Tags.of(crossAccountPrincipal).add("aws-cdk:id", roleTag), this.addToResourcePolicy(new iam.PolicyStatement({ actions, principals: [new iam.AccountPrincipal(crossAccountPrincipalStack.account)], conditions: { StringEquals: { "aws:PrincipalTag/aws-cdk:id": roleTag } } })), iam.Grant.addToPrincipal({ grantee, actions, resourceArns: [this.repositoryArn], scope: this });
        } else
          return iam.Grant.addToPrincipalOrResource({ grantee, actions, resourceArns: [this.repositoryArn], resourceSelfArns: [], resource: this });
      }
      grantRead(grantee) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(grantee);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantRead), error;
        }
        return this.grant(grantee, "ecr:DescribeRepositories", "ecr:DescribeImages");
      }
      grantPull(grantee) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(grantee);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantPull), error;
        }
        const ret = this.grant(grantee, "ecr:BatchCheckLayerAvailability", "ecr:GetDownloadUrlForLayer", "ecr:BatchGetImage");
        return iam.Grant.addToPrincipal({ grantee, actions: ["ecr:GetAuthorizationToken"], resourceArns: ["*"], scope: this }), ret;
      }
      grantPullPush(grantee) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(grantee);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantPullPush), error;
        }
        return this.grantPull(grantee), this.grant(grantee, "ecr:PutImage", "ecr:InitiateLayerUpload", "ecr:UploadLayerPart", "ecr:CompleteLayerUpload");
      }
      unsafeCrossAccountResourcePolicyPrincipal(grantee) {
        const principal = grantee.grantPrincipal, principalAccount = principal.principalAccount;
        if (!principalAccount)
          return;
        const repoAndPrincipalAccountCompare = core_1.Token.compareStrings(this.env.account, principalAccount);
        if (repoAndPrincipalAccountCompare === core_1.TokenComparison.BOTH_UNRESOLVED || repoAndPrincipalAccountCompare === core_1.TokenComparison.SAME || !iam.principalIsOwnedResource(principal))
          return;
        const principalStack = core_1.Stack.of(principal);
        if (!this.stack.dependencies.includes(principalStack))
          return principal;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, RepositoryBase[_a] = { fqn: "aws-cdk-lib.aws_ecr.RepositoryBase", version: "2.80.0" }, exports2.RepositoryBase = RepositoryBase;
    var Repository = class _Repository extends RepositoryBase {
      static fromRepositoryAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecr_RepositoryAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromRepositoryAttributes), error;
        }
        class Import extends RepositoryBase {
          constructor() {
            super(...arguments), this.repositoryName = attrs.repositoryName, this.repositoryArn = attrs.repositoryArn;
          }
          addToResourcePolicy(_statement) {
            return { statementAdded: false };
          }
        }
        return new Import(scope, id);
      }
      static fromRepositoryArn(scope, id, repositoryArn) {
        if (core_1.Token.isUnresolved(repositoryArn))
          throw new Error('"repositoryArn" is a late-bound value, and therefore "repositoryName" is required. Use `fromRepositoryAttributes` instead');
        const repositoryName = repositoryArn.split("/").slice(1).join("/");
        class Import extends RepositoryBase {
          constructor() {
            super(...arguments), this.repositoryName = repositoryName, this.repositoryArn = repositoryArn;
          }
          addToResourcePolicy(_statement) {
            return { statementAdded: false };
          }
        }
        return new Import(scope, id, { environmentFromArn: repositoryArn });
      }
      static fromRepositoryName(scope, id, repositoryName) {
        class Import extends RepositoryBase {
          constructor() {
            super(...arguments), this.repositoryName = repositoryName, this.repositoryArn = _Repository.arnForLocalRepository(repositoryName, scope);
          }
          addToResourcePolicy(_statement) {
            return { statementAdded: false };
          }
        }
        return new Import(scope, id);
      }
      static arnForLocalRepository(repositoryName, scope, account) {
        return core_1.Stack.of(scope).formatArn({ account, service: "ecr", resource: "repository", resourceName: repositoryName });
      }
      static validateRepositoryName(physicalName) {
        const repositoryName = physicalName;
        if (!repositoryName || core_1.Token.isUnresolved(repositoryName))
          return;
        const errors = [];
        if ((repositoryName.length < 2 || repositoryName.length > 256) && errors.push("Repository name must be at least 2 and no more than 256 characters"), /^(?:[a-z0-9]+(?:[._-][a-z0-9]+)*\/)*[a-z0-9]+(?:[._-][a-z0-9]+)*$/.test(repositoryName) || errors.push("Repository name must follow the specified pattern: (?:[a-z0-9]+(?:[._-][a-z0-9]+)*/)*[a-z0-9]+(?:[._-][a-z0-9]+)*"), errors.length > 0)
          throw new Error(`Invalid ECR repository name (value: ${repositoryName})${os_1.EOL}${errors.join(os_1.EOL)}`);
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.repositoryName }), this.lifecycleRules = new Array();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecr_RepositoryProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Repository), error;
        }
        _Repository.validateRepositoryName(this.physicalName);
        const resource = new ecr_generated_1.CfnRepository(this, "Resource", { repositoryName: this.physicalName, repositoryPolicyText: core_1.Lazy.any({ produce: () => this.policyDocument }), lifecyclePolicy: core_1.Lazy.any({ produce: () => this.renderLifecyclePolicy() }), imageScanningConfiguration: props.imageScanOnPush !== void 0 ? { scanOnPush: props.imageScanOnPush } : void 0, imageTagMutability: props.imageTagMutability || void 0, encryptionConfiguration: this.parseEncryption(props) });
        if (this._resource = resource, props.autoDeleteImages) {
          if (props.removalPolicy !== core_1.RemovalPolicy.DESTROY)
            throw new Error("Cannot use 'autoDeleteImages' property on a repository without setting removal policy to 'DESTROY'.");
          this.enableAutoDeleteImages();
        }
        resource.applyRemovalPolicy(props.removalPolicy), this.registryId = props.lifecycleRegistryId, props.lifecycleRules && props.lifecycleRules.forEach(this.addLifecycleRule.bind(this)), this.repositoryName = this.getResourceNameAttribute(resource.ref), this.repositoryArn = this.getResourceArnAttribute(resource.attrArn, { service: "ecr", resource: "repository", resourceName: this.physicalName }), this.node.addValidation({ validate: () => this.policyDocument?.validateForResourcePolicy() ?? [] });
      }
      addToResourcePolicy(statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToResourcePolicy), error;
        }
        return statement.resources.length && core_1.Annotations.of(this).addWarning("ECR resource policy does not allow resource statements."), this.policyDocument === void 0 && (this.policyDocument = new iam.PolicyDocument()), this.policyDocument.addStatements(statement), { statementAdded: true, policyDependable: this.policyDocument };
      }
      addLifecycleRule(rule) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecr_LifecycleRule(rule);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addLifecycleRule), error;
        }
        if (rule.tagStatus === void 0 && (rule = { ...rule, tagStatus: rule.tagPrefixList === void 0 ? lifecycle_1.TagStatus.ANY : lifecycle_1.TagStatus.TAGGED }), rule.tagStatus === lifecycle_1.TagStatus.TAGGED && (rule.tagPrefixList === void 0 || rule.tagPrefixList.length === 0))
          throw new Error("TagStatus.Tagged requires the specification of a tagPrefixList");
        if (rule.tagStatus !== lifecycle_1.TagStatus.TAGGED && rule.tagPrefixList !== void 0)
          throw new Error("tagPrefixList can only be specified when tagStatus is set to Tagged");
        if (rule.maxImageAge !== void 0 == (rule.maxImageCount !== void 0))
          throw new Error(`Life cycle rule must contain exactly one of 'maxImageAge' and 'maxImageCount', got: ${JSON.stringify(rule)}`);
        if (rule.tagStatus === lifecycle_1.TagStatus.ANY && this.lifecycleRules.filter((r) => r.tagStatus === lifecycle_1.TagStatus.ANY).length > 0)
          throw new Error("Life cycle can only have one TagStatus.Any rule");
        this.lifecycleRules.push({ ...rule });
      }
      renderLifecyclePolicy() {
        const stack = core_1.Stack.of(this);
        let lifecyclePolicyText;
        if (!(this.lifecycleRules.length === 0 && !this.registryId))
          return this.lifecycleRules.length > 0 && (lifecyclePolicyText = JSON.stringify(stack.resolve({ rules: this.orderedLifecycleRules().map(renderLifecycleRule) }))), { lifecyclePolicyText, registryId: this.registryId };
      }
      orderedLifecycleRules() {
        if (this.lifecycleRules.length === 0)
          return [];
        const prioritizedRules = this.lifecycleRules.filter((r) => r.rulePriority !== void 0 && r.tagStatus !== lifecycle_1.TagStatus.ANY), autoPrioritizedRules = this.lifecycleRules.filter((r) => r.rulePriority === void 0 && r.tagStatus !== lifecycle_1.TagStatus.ANY), anyRules = this.lifecycleRules.filter((r) => r.tagStatus === lifecycle_1.TagStatus.ANY);
        if (anyRules.length > 0 && anyRules[0].rulePriority !== void 0 && autoPrioritizedRules.length > 0)
          throw new Error("Cannot combine prioritized TagStatus.Any rule with unprioritized rules. Remove rulePriority from the 'Any' rule.");
        const prios = prioritizedRules.map((r) => r.rulePriority);
        let autoPrio = (prios.length > 0 ? Math.max(...prios) : 0) + 1;
        const ret = new Array();
        for (const rule of prioritizedRules.concat(autoPrioritizedRules).concat(anyRules))
          ret.push({ ...rule, rulePriority: rule.rulePriority ?? autoPrio++ });
        return validateAnyRuleLast(ret), ret;
      }
      parseEncryption(props) {
        const encryptionType = props.encryption ?? (props.encryptionKey ? RepositoryEncryption.KMS : RepositoryEncryption.AES_256);
        if (encryptionType !== RepositoryEncryption.KMS && props.encryptionKey)
          throw new Error(`encryptionKey is specified, so 'encryption' must be set to KMS (value: ${encryptionType.value})`);
        if (encryptionType !== RepositoryEncryption.AES_256) {
          if (encryptionType === RepositoryEncryption.KMS)
            return { encryptionType: "KMS", kmsKey: props.encryptionKey?.keyArn };
          throw new Error(`Unexpected 'encryptionType': ${encryptionType}`);
        }
      }
      enableAutoDeleteImages() {
        const provider = core_1.CustomResourceProvider.getOrCreateProvider(this, AUTO_DELETE_IMAGES_RESOURCE_TYPE, { codeDirectory: path.join(__dirname, "auto-delete-images-handler"), runtime: (0, core_1.builtInCustomResourceProviderNodeRuntime)(this), description: `Lambda function for auto-deleting images in ${this.repositoryName} repository.`, policyStatements: [{ Effect: "Allow", Action: ["ecr:BatchDeleteImage", "ecr:DescribeRepositories", "ecr:ListImages", "ecr:ListTagsForResource"], Resource: [this._resource.attrArn] }] });
        new core_1.CustomResource(this, "AutoDeleteImagesCustomResource", { resourceType: AUTO_DELETE_IMAGES_RESOURCE_TYPE, serviceToken: provider.serviceToken, properties: { RepositoryName: core_1.Lazy.any({ produce: () => this.repositoryName }) } }).node.addDependency(this), core_1.Tags.of(this._resource).add(AUTO_DELETE_IMAGES_TAG, "true");
      }
    };
    _b = JSII_RTTI_SYMBOL_1, Repository[_b] = { fqn: "aws-cdk-lib.aws_ecr.Repository", version: "2.80.0" }, exports2.Repository = Repository;
    function validateAnyRuleLast(rules) {
      const anyRules = rules.filter((r) => r.tagStatus === lifecycle_1.TagStatus.ANY);
      if (anyRules.length === 1) {
        const maxPrio = Math.max(...rules.map((r) => r.rulePriority));
        if (anyRules[0].rulePriority !== maxPrio)
          throw new Error(`TagStatus.Any rule must have highest priority, has ${anyRules[0].rulePriority} which is smaller than ${maxPrio}`);
      }
    }
    function renderLifecycleRule(rule) {
      return { rulePriority: rule.rulePriority, description: rule.description, selection: { tagStatus: rule.tagStatus || lifecycle_1.TagStatus.ANY, tagPrefixList: rule.tagPrefixList, countType: rule.maxImageAge !== void 0 ? "sinceImagePushed" : "imageCountMoreThan", countNumber: rule.maxImageAge?.toDays() ?? rule.maxImageCount, countUnit: rule.maxImageAge !== void 0 ? "days" : void 0 }, action: { type: "expire" } };
    }
    var TagMutability;
    (function(TagMutability2) {
      TagMutability2.MUTABLE = "MUTABLE", TagMutability2.IMMUTABLE = "IMMUTABLE";
    })(TagMutability = exports2.TagMutability || (exports2.TagMutability = {}));
    var RepositoryEncryption = class {
      constructor(value) {
        this.value = value;
      }
    };
    _c = JSII_RTTI_SYMBOL_1, RepositoryEncryption[_c] = { fqn: "aws-cdk-lib.aws_ecr.RepositoryEncryption", version: "2.80.0" }, RepositoryEncryption.AES_256 = new RepositoryEncryption("AES256"), RepositoryEncryption.KMS = new RepositoryEncryption("KMS"), exports2.RepositoryEncryption = RepositoryEncryption;
  }
});

// node_modules/aws-cdk-lib/aws-ecr/lib/auth-token.js
var require_auth_token = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecr/lib/auth-token.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PublicGalleryAuthorizationToken = exports2.AuthorizationToken = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var AuthorizationToken = class {
      static grantRead(grantee) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(grantee);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantRead), error;
        }
        grantee.grantPrincipal.addToPrincipalPolicy(new iam.PolicyStatement({ actions: ["ecr:GetAuthorizationToken"], resources: ["*"] }));
      }
      constructor() {
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AuthorizationToken[_a] = { fqn: "aws-cdk-lib.aws_ecr.AuthorizationToken", version: "2.80.0" }, exports2.AuthorizationToken = AuthorizationToken;
    var PublicGalleryAuthorizationToken = class {
      static grantRead(grantee) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(grantee);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantRead), error;
        }
        grantee.grantPrincipal.addToPrincipalPolicy(new iam.PolicyStatement({ actions: ["ecr-public:GetAuthorizationToken", "sts:GetServiceBearerToken"], resources: ["*"] }));
      }
      constructor() {
      }
    };
    _b = JSII_RTTI_SYMBOL_1, PublicGalleryAuthorizationToken[_b] = { fqn: "aws-cdk-lib.aws_ecr.PublicGalleryAuthorizationToken", version: "2.80.0" }, exports2.PublicGalleryAuthorizationToken = PublicGalleryAuthorizationToken;
  }
});

// node_modules/aws-cdk-lib/aws-ecr/lib/index.js
var require_lib23 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecr/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_ecr_generated(), exports2), __exportStar(require_repository(), exports2), __exportStar(require_lifecycle(), exports2), __exportStar(require_auth_token(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-ecr/index.js
var require_aws_ecr = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecr/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib23(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-ecr-assets/lib/image-asset.js
var require_image_asset = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecr-assets/lib/image-asset.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DockerImageAsset = exports2.Platform = exports2.NetworkMode = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var fs = require("fs");
    var path = require("path");
    var constructs_1 = require_lib2();
    var assets_1 = require_assets4();
    var ecr = require_aws_ecr();
    var core_1 = require_core2();
    var cxapi = require_cx_api();
    var NetworkMode = class _NetworkMode {
      static fromContainer(containerId) {
        return new _NetworkMode(`container:${containerId}`);
      }
      static custom(mode) {
        return new _NetworkMode(mode);
      }
      constructor(mode) {
        this.mode = mode;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, NetworkMode[_a] = { fqn: "aws-cdk-lib.aws_ecr_assets.NetworkMode", version: "2.80.0" }, NetworkMode.DEFAULT = new NetworkMode("default"), NetworkMode.HOST = new NetworkMode("host"), NetworkMode.NONE = new NetworkMode("none"), exports2.NetworkMode = NetworkMode;
    var Platform = class _Platform {
      static custom(platform) {
        return new _Platform(platform);
      }
      constructor(platform) {
        this.platform = platform;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, Platform[_b] = { fqn: "aws-cdk-lib.aws_ecr_assets.Platform", version: "2.80.0" }, Platform.LINUX_AMD64 = new Platform("linux/amd64"), Platform.LINUX_ARM64 = new Platform("linux/arm64"), exports2.Platform = Platform;
    var DockerImageAsset = class _DockerImageAsset extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecr_assets_DockerImageAssetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _DockerImageAsset), error;
        }
        validateProps(props);
        const dir = path.resolve(props.directory);
        if (!fs.existsSync(dir))
          throw new Error(`Cannot find image directory at ${dir}`);
        this.dockerfilePath = props.file || "Dockerfile";
        const file = path.join(dir, this.dockerfilePath);
        if (!fs.existsSync(file))
          throw new Error(`Cannot find file at ${file}`);
        const defaultIgnoreMode = core_1.FeatureFlags.of(this).isEnabled(cxapi.DOCKER_IGNORE_SUPPORT) ? core_1.IgnoreMode.DOCKER : core_1.IgnoreMode.GLOB;
        let ignoreMode = props.ignoreMode ?? defaultIgnoreMode, exclude = props.exclude || [];
        const ignore = path.join(dir, ".dockerignore");
        fs.existsSync(ignore) && (exclude = [...fs.readFileSync(ignore).toString().split(`
`).filter((e) => !!e), ...exclude, "!.dockerignore"]), exclude.push("!" + path.basename(file));
        const cdkout = core_1.Stage.of(this)?.outdir ?? "cdk.out";
        exclude.push(cdkout), props.repositoryName && core_1.Annotations.of(this).addWarning('DockerImageAsset.repositoryName is deprecated. Override "core.Stack.addDockerImageAsset" to control asset locations');
        const extraHash = {};
        props.invalidation?.extraHash !== false && props.extraHash && (extraHash.user = props.extraHash), props.invalidation?.buildArgs !== false && props.buildArgs && (extraHash.buildArgs = props.buildArgs), props.invalidation?.buildSecrets !== false && props.buildSecrets && (extraHash.buildSecrets = props.buildSecrets), props.invalidation?.target !== false && props.target && (extraHash.target = props.target), props.invalidation?.file !== false && props.file && (extraHash.file = props.file), props.invalidation?.repositoryName !== false && props.repositoryName && (extraHash.repositoryName = props.repositoryName), props.invalidation?.networkMode !== false && props.networkMode && (extraHash.networkMode = props.networkMode), props.invalidation?.platform !== false && props.platform && (extraHash.platform = props.platform), props.invalidation?.outputs !== false && props.outputs && (extraHash.outputs = props.outputs), extraHash.version = "1.21.0";
        const staging = new core_1.AssetStaging(this, "Staging", { ...props, follow: props.followSymlinks ?? toSymlinkFollow(props.follow), exclude, ignoreMode, sourcePath: dir, extraHash: Object.keys(extraHash).length === 0 ? void 0 : JSON.stringify(extraHash) });
        this.sourceHash = staging.assetHash, this.assetHash = staging.assetHash;
        const stack = core_1.Stack.of(this);
        this.assetPath = staging.relativeStagedPath(stack), this.dockerBuildArgs = props.buildArgs, this.dockerBuildSecrets = props.buildSecrets, this.dockerBuildTarget = props.target, this.dockerOutputs = props.outputs, this.dockerCacheFrom = props.cacheFrom, this.dockerCacheTo = props.cacheTo;
        const location = stack.synthesizer.addDockerImageAsset({ directoryName: this.assetPath, dockerBuildArgs: this.dockerBuildArgs, dockerBuildSecrets: this.dockerBuildSecrets, dockerBuildTarget: this.dockerBuildTarget, dockerFile: props.file, sourceHash: staging.assetHash, networkMode: props.networkMode?.mode, platform: props.platform?.platform, dockerOutputs: this.dockerOutputs, dockerCacheFrom: this.dockerCacheFrom, dockerCacheTo: this.dockerCacheTo });
        this.repository = ecr.Repository.fromRepositoryName(this, "Repository", location.repositoryName), this.imageUri = location.imageUri, this.imageTag = location.imageTag ?? this.assetHash;
      }
      addResourceMetadata(resource, resourceProperty) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnResource(resource);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addResourceMetadata), error;
        }
        this.node.tryGetContext(cxapi.ASSET_RESOURCE_METADATA_ENABLED_CONTEXT) && (resource.cfnOptions.metadata = resource.cfnOptions.metadata || {}, resource.cfnOptions.metadata[cxapi.ASSET_RESOURCE_METADATA_PATH_KEY] = this.assetPath, resource.cfnOptions.metadata[cxapi.ASSET_RESOURCE_METADATA_DOCKERFILE_PATH_KEY] = this.dockerfilePath, resource.cfnOptions.metadata[cxapi.ASSET_RESOURCE_METADATA_DOCKER_BUILD_ARGS_KEY] = this.dockerBuildArgs, resource.cfnOptions.metadata[cxapi.ASSET_RESOURCE_METADATA_DOCKER_BUILD_SECRETS_KEY] = this.dockerBuildSecrets, resource.cfnOptions.metadata[cxapi.ASSET_RESOURCE_METADATA_DOCKER_BUILD_TARGET_KEY] = this.dockerBuildTarget, resource.cfnOptions.metadata[cxapi.ASSET_RESOURCE_METADATA_PROPERTY_KEY] = resourceProperty, resource.cfnOptions.metadata[cxapi.ASSET_RESOURCE_METADATA_DOCKER_OUTPUTS_KEY] = this.dockerOutputs, resource.cfnOptions.metadata[cxapi.ASSET_RESOURCE_METADATA_DOCKER_CACHE_FROM_KEY] = this.dockerCacheFrom, resource.cfnOptions.metadata[cxapi.ASSET_RESOURCE_METADATA_DOCKER_CACHE_TO_KEY] = this.dockerCacheTo);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, DockerImageAsset[_c] = { fqn: "aws-cdk-lib.aws_ecr_assets.DockerImageAsset", version: "2.80.0" }, exports2.DockerImageAsset = DockerImageAsset;
    function validateProps(props) {
      for (const [key, value] of Object.entries(props))
        if (core_1.Token.isUnresolved(value))
          throw new Error(`Cannot use Token as value of '${key}': this value is used before deployment starts`);
      validateBuildArgs(props.buildArgs), validateBuildSecrets(props.buildSecrets);
    }
    function validateBuildProps(buildPropName, buildProps) {
      for (const [key, value] of Object.entries(buildProps || {}))
        if (core_1.Token.isUnresolved(key) || core_1.Token.isUnresolved(value))
          throw new Error(`Cannot use tokens in keys or values of "${buildPropName}" since they are needed before deployment`);
    }
    function validateBuildArgs(buildArgs) {
      validateBuildProps("buildArgs", buildArgs);
    }
    function validateBuildSecrets(buildSecrets) {
      validateBuildProps("buildSecrets", buildSecrets);
    }
    function toSymlinkFollow(follow) {
      switch (follow) {
        case void 0:
          return;
        case assets_1.FollowMode.NEVER:
          return core_1.SymlinkFollowMode.NEVER;
        case assets_1.FollowMode.ALWAYS:
          return core_1.SymlinkFollowMode.ALWAYS;
        case assets_1.FollowMode.BLOCK_EXTERNAL:
          return core_1.SymlinkFollowMode.BLOCK_EXTERNAL;
        case assets_1.FollowMode.EXTERNAL:
          return core_1.SymlinkFollowMode.EXTERNAL;
      }
    }
  }
});

// node_modules/aws-cdk-lib/aws-ecr-assets/lib/tarball-asset.js
var require_tarball_asset = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecr-assets/lib/tarball-asset.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.TarballImageAsset = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var fs = require("fs");
    var path = require("path");
    var constructs_1 = require_lib2();
    var ecr = require_aws_ecr();
    var core_1 = require_core2();
    var TarballImageAsset = class _TarballImageAsset extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecr_assets_TarballImageAssetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _TarballImageAsset), error;
        }
        if (!fs.existsSync(props.tarballFile))
          throw new Error(`Cannot find file at ${props.tarballFile}`);
        const stagedTarball = new core_1.AssetStaging(this, "Staging", { sourcePath: props.tarballFile });
        this.sourceHash = stagedTarball.assetHash, this.assetHash = stagedTarball.assetHash;
        const stage = core_1.Stage.of(this), relativePathInOutDir = stage ? path.relative(stage.assetOutdir, stagedTarball.absoluteStagedPath) : stagedTarball.absoluteStagedPath, location = core_1.Stack.of(this).synthesizer.addDockerImageAsset({ sourceHash: stagedTarball.assetHash, executable: ["sh", "-c", `docker load -i ${relativePathInOutDir} | tail -n 1 | sed "s/Loaded image: //g"`] });
        this.repository = ecr.Repository.fromRepositoryName(this, "Repository", location.repositoryName), this.imageUri = location.imageUri, this.imageTag = location.imageTag ?? this.assetHash;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, TarballImageAsset[_a] = { fqn: "aws-cdk-lib.aws_ecr_assets.TarballImageAsset", version: "2.80.0" }, exports2.TarballImageAsset = TarballImageAsset;
  }
});

// node_modules/aws-cdk-lib/aws-ecr-assets/lib/index.js
var require_lib24 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecr-assets/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_image_asset(), exports2), __exportStar(require_tarball_asset(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-ecr-assets/index.js
var require_aws_ecr_assets = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecr-assets/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib24(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/code.js
var require_code = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/code.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AssetImageCode = exports2.EcrImageCode = exports2.CfnParametersCode = exports2.AssetCode = exports2.InlineCode = exports2.S3Code = exports2.Code = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var ecr_assets = require_aws_ecr_assets();
    var iam = require_aws_iam();
    var s3_assets = require_aws_s3_assets();
    var cdk = require_core2();
    var Code2 = class {
      static fromBucket(bucket, key, objectVersion) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_IBucket(bucket);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromBucket), error;
        }
        return new S3Code(bucket, key, objectVersion);
      }
      static bucket(bucket, key, objectVersion) {
        return this.fromBucket(bucket, key, objectVersion);
      }
      static fromInline(code) {
        return new InlineCode(code);
      }
      static inline(code) {
        return this.fromInline(code);
      }
      static fromAsset(path, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_assets_AssetOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromAsset), error;
        }
        return new AssetCode(path, options);
      }
      static fromDockerBuild(path, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_DockerBuildAssetOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromDockerBuild), error;
        }
        let imagePath = options.imagePath ?? "/asset/.";
        imagePath.endsWith("/") ? imagePath = `${imagePath}.` : imagePath.endsWith("/.") || (imagePath = `${imagePath}/.`);
        const assetPath = cdk.DockerImage.fromBuild(path, options).cp(imagePath, options.outputPath);
        return new AssetCode(assetPath);
      }
      static asset(path) {
        return this.fromAsset(path);
      }
      static fromCfnParameters(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_CfnParametersCodeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromCfnParameters), error;
        }
        return new CfnParametersCode(props);
      }
      static cfnParameters(props) {
        return this.fromCfnParameters(props);
      }
      static fromEcrImage(repository, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecr_IRepository(repository), jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_EcrImageCodeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromEcrImage), error;
        }
        return new EcrImageCode(repository, props);
      }
      static fromAssetImage(directory, props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_AssetImageCodeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromAssetImage), error;
        }
        return new AssetImageCode(directory, props);
      }
      bindToResource(_resource, _options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnResource(_resource), jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_ResourceBindOptions(_options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bindToResource), error;
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Code2[_a] = { fqn: "aws-cdk-lib.aws_lambda.Code", version: "2.80.0" }, exports2.Code = Code2;
    var S3Code = class _S3Code extends Code2 {
      constructor(bucket, key, objectVersion) {
        super(), this.key = key, this.objectVersion = objectVersion, this.isInline = false;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_IBucket(bucket);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _S3Code), error;
        }
        if (!bucket.bucketName)
          throw new Error("bucketName is undefined for the provided bucket");
        this.bucketName = bucket.bucketName;
      }
      bind(_scope) {
        return { s3Location: { bucketName: this.bucketName, objectKey: this.key, objectVersion: this.objectVersion } };
      }
    };
    _b = JSII_RTTI_SYMBOL_1, S3Code[_b] = { fqn: "aws-cdk-lib.aws_lambda.S3Code", version: "2.80.0" }, exports2.S3Code = S3Code;
    var InlineCode = class extends Code2 {
      constructor(code) {
        if (super(), this.code = code, this.isInline = true, code.length === 0)
          throw new Error("Lambda inline code cannot be empty");
      }
      bind(_scope) {
        return { inlineCode: this.code };
      }
    };
    _c = JSII_RTTI_SYMBOL_1, InlineCode[_c] = { fqn: "aws-cdk-lib.aws_lambda.InlineCode", version: "2.80.0" }, exports2.InlineCode = InlineCode;
    var AssetCode = class _AssetCode extends Code2 {
      constructor(path, options = {}) {
        super(), this.path = path, this.options = options, this.isInline = false;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_assets_AssetOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AssetCode), error;
        }
      }
      bind(scope) {
        if (!this.asset)
          this.asset = new s3_assets.Asset(scope, "Code", { path: this.path, ...this.options });
        else if (cdk.Stack.of(this.asset) !== cdk.Stack.of(scope))
          throw new Error(`Asset is already associated with another stack '${cdk.Stack.of(this.asset).stackName}'. Create a new Code instance for every stack.`);
        if (!this.asset.isZipArchive)
          throw new Error(`Asset must be a .zip file or a directory (${this.path})`);
        return { s3Location: { bucketName: this.asset.s3BucketName, objectKey: this.asset.s3ObjectKey } };
      }
      bindToResource(resource, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnResource(resource), jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_ResourceBindOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bindToResource), error;
        }
        if (!this.asset)
          throw new Error("bindToResource() must be called after bind()");
        const resourceProperty = options.resourceProperty || "Code";
        this.asset.addResourceMetadata(resource, resourceProperty);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, AssetCode[_d] = { fqn: "aws-cdk-lib.aws_lambda.AssetCode", version: "2.80.0" }, exports2.AssetCode = AssetCode;
    var CfnParametersCode = class _CfnParametersCode extends Code2 {
      constructor(props = {}) {
        super(), this.isInline = false;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_CfnParametersCodeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnParametersCode), error;
        }
        this._bucketNameParam = props.bucketNameParam, this._objectKeyParam = props.objectKeyParam;
      }
      bind(scope) {
        return this._bucketNameParam || (this._bucketNameParam = new cdk.CfnParameter(scope, "LambdaSourceBucketNameParameter", { type: "String" })), this._objectKeyParam || (this._objectKeyParam = new cdk.CfnParameter(scope, "LambdaSourceObjectKeyParameter", { type: "String" })), { s3Location: { bucketName: this._bucketNameParam.valueAsString, objectKey: this._objectKeyParam.valueAsString } };
      }
      assign(location) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_Location(location);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.assign), error;
        }
        const ret = {};
        return ret[this.bucketNameParam] = location.bucketName, ret[this.objectKeyParam] = location.objectKey, ret;
      }
      get bucketNameParam() {
        if (this._bucketNameParam)
          return this._bucketNameParam.logicalId;
        throw new Error("Pass CfnParametersCode to a Lambda Function before accessing the bucketNameParam property");
      }
      get objectKeyParam() {
        if (this._objectKeyParam)
          return this._objectKeyParam.logicalId;
        throw new Error("Pass CfnParametersCode to a Lambda Function before accessing the objectKeyParam property");
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnParametersCode[_e] = { fqn: "aws-cdk-lib.aws_lambda.CfnParametersCode", version: "2.80.0" }, exports2.CfnParametersCode = CfnParametersCode;
    var EcrImageCode = class _EcrImageCode extends Code2 {
      constructor(repository, props = {}) {
        super(), this.repository = repository, this.props = props, this.isInline = false;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecr_IRepository(repository), jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_EcrImageCodeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EcrImageCode), error;
        }
      }
      bind(_scope) {
        return this.repository.grantPull(new iam.ServicePrincipal("lambda.amazonaws.com")), { image: { imageUri: this.repository.repositoryUriForTagOrDigest(this.props?.tagOrDigest ?? this.props?.tag ?? "latest"), cmd: this.props.cmd, entrypoint: this.props.entrypoint, workingDirectory: this.props.workingDirectory } };
      }
    };
    _f = JSII_RTTI_SYMBOL_1, EcrImageCode[_f] = { fqn: "aws-cdk-lib.aws_lambda.EcrImageCode", version: "2.80.0" }, exports2.EcrImageCode = EcrImageCode;
    var AssetImageCode = class _AssetImageCode extends Code2 {
      constructor(directory, props) {
        super(), this.directory = directory, this.props = props, this.isInline = false;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_AssetImageCodeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AssetImageCode), error;
        }
      }
      bind(scope) {
        if (!this.asset)
          this.asset = new ecr_assets.DockerImageAsset(scope, "AssetImage", { directory: this.directory, ...this.props }), this.asset.repository.grantPull(new iam.ServicePrincipal("lambda.amazonaws.com"));
        else if (cdk.Stack.of(this.asset) !== cdk.Stack.of(scope))
          throw new Error(`Asset is already associated with another stack '${cdk.Stack.of(this.asset).stackName}'. Create a new Code instance for every stack.`);
        return { image: { imageUri: this.asset.imageUri, entrypoint: this.props.entrypoint, cmd: this.props.cmd, workingDirectory: this.props.workingDirectory } };
      }
      bindToResource(resource, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnResource(resource), jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_ResourceBindOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bindToResource), error;
        }
        if (!this.asset)
          throw new Error("bindToResource() must be called after bind()");
        const resourceProperty = options.resourceProperty || "Code.ImageUri";
        this.asset.addResourceMetadata(resource, resourceProperty);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, AssetImageCode[_g] = { fqn: "aws-cdk-lib.aws_lambda.AssetImageCode", version: "2.80.0" }, exports2.AssetImageCode = AssetImageCode;
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/image-function.js
var require_image_function = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/image-function.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DockerImageFunction = exports2.DockerImageCode = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var code_1 = require_code();
    var function_1 = require_function();
    var handler_1 = require_handler();
    var runtime_1 = require_runtime3();
    var aws_ecr_assets_1 = require_aws_ecr_assets();
    var DockerImageCode = class {
      static fromEcr(repository, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecr_IRepository(repository), jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_EcrImageCodeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromEcr), error;
        }
        return { _bind() {
          return new code_1.EcrImageCode(repository, props);
        } };
      }
      static fromImageAsset(directory, props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_AssetImageCodeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromImageAsset), error;
        }
        return { _bind(architecture) {
          return new code_1.AssetImageCode(directory, { ...architecture?.dockerPlatform ? { platform: aws_ecr_assets_1.Platform.custom(architecture.dockerPlatform) } : {}, ...props });
        } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, DockerImageCode[_a] = { fqn: "aws-cdk-lib.aws_lambda.DockerImageCode", version: "2.80.0" }, exports2.DockerImageCode = DockerImageCode;
    var DockerImageFunction = class _DockerImageFunction extends function_1.Function {
      constructor(scope, id, props) {
        super(scope, id, { ...props, handler: handler_1.Handler.FROM_IMAGE, runtime: runtime_1.Runtime.FROM_IMAGE, code: props.code._bind(props.architecture) });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_DockerImageFunctionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _DockerImageFunction), error;
        }
      }
    };
    _b = JSII_RTTI_SYMBOL_1, DockerImageFunction[_b] = { fqn: "aws-cdk-lib.aws_lambda.DockerImageFunction", version: "2.80.0" }, exports2.DockerImageFunction = DockerImageFunction;
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/permission.js
var require_permission = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/permission.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/filesystem.js
var require_filesystem = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/filesystem.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FileSystem = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var FileSystem = class _FileSystem {
      static fromEfsAccessPoint(ap, mountPath) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_efs_IAccessPoint(ap);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromEfsAccessPoint), error;
        }
        return new _FileSystem({ localMountPath: mountPath, arn: ap.accessPointArn, dependency: [ap.fileSystem.mountTargetsAvailable], connections: ap.fileSystem.connections, policies: [new iam.PolicyStatement({ actions: ["elasticfilesystem:ClientMount"], resources: ["*"], conditions: { StringEquals: { "elasticfilesystem:AccessPointArn": ap.accessPointArn } } }), new iam.PolicyStatement({ actions: ["elasticfilesystem:ClientWrite"], resources: [core_1.Stack.of(ap).formatArn({ service: "elasticfilesystem", resource: "file-system", resourceName: ap.fileSystem.fileSystemId })] })] });
      }
      constructor(config) {
        this.config = config;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_FileSystemConfig(config);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _FileSystem), error;
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, FileSystem[_a] = { fqn: "aws-cdk-lib.aws_lambda.FileSystem", version: "2.80.0" }, exports2.FileSystem = FileSystem;
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/singleton-lambda.js
var require_singleton_lambda = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/singleton-lambda.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SingletonFunction = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var function_1 = require_function();
    var function_base_1 = require_function_base();
    var cdk = require_core2();
    var SingletonFunction = class _SingletonFunction extends function_base_1.FunctionBase {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_SingletonFunctionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SingletonFunction), error;
        }
        this.lambdaFunction = this.ensureLambda(props), this.permissionsNode = this.lambdaFunction.node, this.architecture = this.lambdaFunction.architecture, this.functionArn = this.lambdaFunction.functionArn, this.functionName = this.lambdaFunction.functionName, this.role = this.lambdaFunction.role, this.runtime = this.lambdaFunction.runtime, this.grantPrincipal = this.lambdaFunction.grantPrincipal, this.canCreatePermissions = true;
      }
      get isBoundToVpc() {
        return this.lambdaFunction.isBoundToVpc;
      }
      get connections() {
        return this.lambdaFunction.connections;
      }
      get logGroup() {
        return this.lambdaFunction.logGroup;
      }
      get currentVersion() {
        return this.lambdaFunction.currentVersion;
      }
      get resourceArnsForGrantInvoke() {
        return [this.functionArn, `${this.functionArn}:*`];
      }
      addEnvironment(key, value, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_EnvironmentOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addEnvironment), error;
        }
        return this.lambdaFunction.addEnvironment(key, value, options);
      }
      addLayers(...layers) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_ILayerVersion(layers);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addLayers), error;
        }
        return this.lambdaFunction.addLayers(...layers);
      }
      addPermission(name, permission) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_Permission(permission);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addPermission), error;
        }
        return this.lambdaFunction.addPermission(name, permission);
      }
      addDependency(...up) {
        this.lambdaFunction.node.addDependency(...up);
      }
      dependOn(down) {
        down.node.addDependency(this.lambdaFunction);
      }
      _checkEdgeCompatibility() {
        return this.lambdaFunction._checkEdgeCompatibility();
      }
      _functionNode() {
        return this.lambdaFunction.node;
      }
      ensureLambda(props) {
        const constructName = (props.lambdaPurpose || "SingletonLambda") + slugify(props.uuid), existing = cdk.Stack.of(this).node.tryFindChild(constructName);
        return existing || new function_1.Function(cdk.Stack.of(this), constructName, props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SingletonFunction[_a] = { fqn: "aws-cdk-lib.aws_lambda.SingletonFunction", version: "2.80.0" }, exports2.SingletonFunction = SingletonFunction;
    function slugify(x) {
      return x.replace(/[^a-zA-Z0-9]/g, "");
    }
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/event-source.js
var require_event_source = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/event-source.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/event-source-filter.js
var require_event_source_filter = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/event-source-filter.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FilterCriteria = exports2.FilterRule = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var FilterRule = class {
      static null() {
        return [];
      }
      static empty() {
        return [""];
      }
      static isEqual(item) {
        return typeof item == "number" ? [{ numeric: ["=", item] }] : [item];
      }
      static or(...elem) {
        return elem;
      }
      static notEquals(elem) {
        return [{ "anything-but": [elem] }];
      }
      static between(first, second) {
        return [{ numeric: [">", first, "<=", second] }];
      }
      static exists() {
        return [{ exists: true }];
      }
      static notExists() {
        return [{ exists: false }];
      }
      static beginsWith(elem) {
        return [{ prefix: elem }];
      }
    };
    _a = JSII_RTTI_SYMBOL_1, FilterRule[_a] = { fqn: "aws-cdk-lib.aws_lambda.FilterRule", version: "2.80.0" }, exports2.FilterRule = FilterRule;
    var FilterCriteria = class {
      static filter(filter) {
        return { pattern: JSON.stringify(filter) };
      }
    };
    _b = JSII_RTTI_SYMBOL_1, FilterCriteria[_b] = { fqn: "aws-cdk-lib.aws_lambda.FilterCriteria", version: "2.80.0" }, exports2.FilterCriteria = FilterCriteria;
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/scalable-attribute-api.js
var require_scalable_attribute_api = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/scalable-attribute-api.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/code-signing-config.js
var require_code_signing_config = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/code-signing-config.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CodeSigningConfig = exports2.UntrustedArtifactOnDeployment = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var lambda_generated_1 = require_lambda_generated();
    var core_1 = require_core2();
    var UntrustedArtifactOnDeployment;
    (function(UntrustedArtifactOnDeployment2) {
      UntrustedArtifactOnDeployment2.ENFORCE = "Enforce", UntrustedArtifactOnDeployment2.WARN = "Warn";
    })(UntrustedArtifactOnDeployment = exports2.UntrustedArtifactOnDeployment || (exports2.UntrustedArtifactOnDeployment = {}));
    var CodeSigningConfig = class _CodeSigningConfig extends core_1.Resource {
      static fromCodeSigningConfigArn(scope, id, codeSigningConfigArn) {
        const codeSigningProfileId = core_1.Stack.of(scope).splitArn(codeSigningConfigArn, core_1.ArnFormat.SLASH_RESOURCE_NAME).resourceName;
        if (!codeSigningProfileId)
          throw new Error(`Code signing config ARN must be in the format 'arn:<partition>:lambda:<region>:<account>:code-signing-config:<codeSigningConfigArn>', got: '${codeSigningConfigArn}'`);
        const assertedCodeSigningProfileId = codeSigningProfileId;
        class Import extends core_1.Resource {
          constructor() {
            super(scope, id), this.codeSigningConfigArn = codeSigningConfigArn, this.codeSigningConfigId = assertedCodeSigningProfileId;
          }
        }
        return new Import();
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_CodeSigningConfigProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CodeSigningConfig), error;
        }
        const signingProfileVersionArns = props.signingProfiles.map((signingProfile) => signingProfile.signingProfileVersionArn), resource = new lambda_generated_1.CfnCodeSigningConfig(this, "Resource", { allowedPublishers: { signingProfileVersionArns }, codeSigningPolicies: { untrustedArtifactOnDeployment: props.untrustedArtifactOnDeployment ?? UntrustedArtifactOnDeployment.WARN }, description: props.description });
        this.codeSigningConfigArn = resource.attrCodeSigningConfigArn, this.codeSigningConfigId = resource.attrCodeSigningConfigId;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CodeSigningConfig[_a] = { fqn: "aws-cdk-lib.aws_lambda.CodeSigningConfig", version: "2.80.0" }, exports2.CodeSigningConfig = CodeSigningConfig;
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/lambda-insights.js
var require_lambda_insights = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/lambda-insights.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LambdaInsightsVersion = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var architecture_1 = require_architecture();
    var core_1 = require_core2();
    var region_info_1 = require_region_info2();
    var LambdaInsightsVersion = class _LambdaInsightsVersion {
      constructor() {
        this.layerVersionArn = "";
      }
      static fromInsightVersionArn(arn) {
        class InsightsArn extends _LambdaInsightsVersion {
          constructor() {
            super(...arguments), this.layerVersionArn = arn;
          }
          _bind(_scope, _function) {
            return { arn };
          }
        }
        return new InsightsArn();
      }
      static fromInsightsVersion(insightsVersion) {
        class InsightsVersion extends _LambdaInsightsVersion {
          constructor() {
            super(...arguments), this.layerVersionArn = core_1.Lazy.uncachedString({ produce: (context) => getVersionArn(context.scope, insightsVersion) });
          }
          _bind(_scope, _function) {
            const arch = _function.architecture?.name ?? architecture_1.Architecture.X86_64.name;
            if (!region_info_1.RegionInfo.regions.some((regionInfo) => regionInfo.cloudwatchLambdaInsightsArn(insightsVersion, arch)))
              throw new Error(`Insights version ${insightsVersion} does not exist.`);
            return { arn: getVersionArn(_scope, insightsVersion, arch) };
          }
        }
        return new InsightsVersion();
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LambdaInsightsVersion[_a] = { fqn: "aws-cdk-lib.aws_lambda.LambdaInsightsVersion", version: "2.80.0" }, LambdaInsightsVersion.VERSION_1_0_54_0 = LambdaInsightsVersion.fromInsightsVersion("1.0.54.0"), LambdaInsightsVersion.VERSION_1_0_86_0 = LambdaInsightsVersion.fromInsightsVersion("1.0.86.0"), LambdaInsightsVersion.VERSION_1_0_89_0 = LambdaInsightsVersion.fromInsightsVersion("1.0.89.0"), LambdaInsightsVersion.VERSION_1_0_98_0 = LambdaInsightsVersion.fromInsightsVersion("1.0.98.0"), LambdaInsightsVersion.VERSION_1_0_119_0 = LambdaInsightsVersion.fromInsightsVersion("1.0.119.0"), LambdaInsightsVersion.VERSION_1_0_135_0 = LambdaInsightsVersion.fromInsightsVersion("1.0.135.0"), LambdaInsightsVersion.VERSION_1_0_143_0 = LambdaInsightsVersion.fromInsightsVersion("1.0.143.0"), LambdaInsightsVersion.VERSION_1_0_178_0 = LambdaInsightsVersion.fromInsightsVersion("1.0.178.0"), exports2.LambdaInsightsVersion = LambdaInsightsVersion;
    function getVersionArn(scope, insightsVersion, architecture) {
      const scopeStack = core_1.Stack.of(scope), region = scopeStack.region, arch = architecture ?? architecture_1.Architecture.X86_64.name;
      if (region !== void 0 && !core_1.Token.isUnresolved(region)) {
        const arn = region_info_1.RegionInfo.get(region).cloudwatchLambdaInsightsArn(insightsVersion, arch);
        if (arn === void 0)
          throw new Error(`Insights version ${insightsVersion} is not supported in region ${region}`);
        return arn;
      }
      return scopeStack.regionalFact(region_info_1.FactName.cloudwatchLambdaInsightsVersion(insightsVersion, arch));
    }
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/log-retention.js
var require_log_retention2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/log-retention.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LogRetention = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var logs = require_aws_logs();
    var LogRetention = class extends logs.LogRetention {
      constructor(scope, id, props) {
        super(scope, id, { ...props });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LogRetention[_a] = { fqn: "aws-cdk-lib.aws_lambda.LogRetention", version: "2.80.0" }, exports2.LogRetention = LogRetention;
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/runtime-management.js
var require_runtime_management = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/runtime-management.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.RuntimeManagementMode = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var RuntimeManagementMode = class _RuntimeManagementMode {
      static manual(arn) {
        return new _RuntimeManagementMode("Manual", arn);
      }
      constructor(mode, arn) {
        this.mode = mode, this.arn = arn, arn ? this.runtimeManagementConfig = { runtimeVersionArn: arn, updateRuntimeOn: mode } : this.runtimeManagementConfig = { updateRuntimeOn: mode };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, RuntimeManagementMode[_a] = { fqn: "aws-cdk-lib.aws_lambda.RuntimeManagementMode", version: "2.80.0" }, RuntimeManagementMode.AUTO = new RuntimeManagementMode("Auto"), RuntimeManagementMode.FUNCTION_UPDATE = new RuntimeManagementMode("FunctionUpdate"), exports2.RuntimeManagementMode = RuntimeManagementMode;
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/lambda-augmentations.generated.js
var require_lambda_augmentations_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/lambda-augmentations.generated.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var cloudwatch = require_aws_cloudwatch();
    var function_base_1 = require_function_base();
    function_base_1.FunctionBase.prototype.metric = function(metricName, props) {
      return new cloudwatch.Metric({ namespace: "AWS/Lambda", metricName, dimensionsMap: { FunctionName: this.functionName }, ...props }).attachTo(this);
    }, function_base_1.FunctionBase.prototype.metricThrottles = function(props) {
      return this.metric("Throttles", { statistic: "Sum", ...props });
    }, function_base_1.FunctionBase.prototype.metricInvocations = function(props) {
      return this.metric("Invocations", { statistic: "Sum", ...props });
    }, function_base_1.FunctionBase.prototype.metricErrors = function(props) {
      return this.metric("Errors", { statistic: "Sum", ...props });
    }, function_base_1.FunctionBase.prototype.metricDuration = function(props) {
      return this.metric("Duration", { statistic: "Average", ...props });
    };
  }
});

// node_modules/aws-cdk-lib/aws-lambda/lib/index.js
var require_lib25 = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_adot_layers(), exports2), __exportStar(require_alias2(), exports2), __exportStar(require_dlq(), exports2), __exportStar(require_function_base(), exports2), __exportStar(require_function(), exports2), __exportStar(require_handler(), exports2), __exportStar(require_image_function(), exports2), __exportStar(require_layers(), exports2), __exportStar(require_permission(), exports2), __exportStar(require_runtime3(), exports2), __exportStar(require_code(), exports2), __exportStar(require_filesystem(), exports2), __exportStar(require_lambda_version(), exports2), __exportStar(require_singleton_lambda(), exports2), __exportStar(require_event_source(), exports2), __exportStar(require_event_source_mapping(), exports2), __exportStar(require_event_source_filter(), exports2), __exportStar(require_destination(), exports2), __exportStar(require_event_invoke_config(), exports2), __exportStar(require_scalable_attribute_api(), exports2), __exportStar(require_code_signing_config(), exports2), __exportStar(require_lambda_insights(), exports2), __exportStar(require_log_retention2(), exports2), __exportStar(require_architecture(), exports2), __exportStar(require_function_url(), exports2), __exportStar(require_runtime_management(), exports2), __exportStar(require_lambda_generated(), exports2), require_lambda_augmentations_generated();
  }
});

// node_modules/aws-cdk-lib/aws-lambda/index.js
var require_aws_lambda = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib25(), exports2);
  }
});

// node_modules/aws-cdk-lib/custom-resources/lib/aws-custom-resource/aws-custom-resource.js
var require_aws_custom_resource = __commonJS({
  "node_modules/aws-cdk-lib/custom-resources/lib/aws-custom-resource/aws-custom-resource.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AwsCustomResource = exports2.AwsCustomResourcePolicy = exports2.PhysicalResourceId = exports2.PhysicalResourceIdReference = exports2.builtInCustomResourceNodeRuntime = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var fs = require("fs");
    var path = require("path");
    var constructs_1 = require_lib2();
    var runtime_1 = require_runtime2();
    var iam = require_aws_iam();
    var lambda2 = require_aws_lambda();
    var cdk = require_core2();
    var core_1 = require_core2();
    var cxapi = require_cx_api();
    var region_info_1 = require_region_info2();
    function builtInCustomResourceNodeRuntime(scope) {
      const runtimeName = cdk.Stack.of(scope).regionalFact(region_info_1.FactName.DEFAULT_CR_NODE_VERSION, "nodejs16.x");
      return runtimeName ? new lambda2.Runtime(runtimeName, lambda2.RuntimeFamily.NODEJS, { supportsInlineCode: true }) : lambda2.Runtime.NODEJS_16_X;
    }
    exports2.builtInCustomResourceNodeRuntime = builtInCustomResourceNodeRuntime;
    var PhysicalResourceIdReference = class {
      constructor() {
        this.creationStack = cdk.captureStackTrace();
      }
      toJSON() {
        return runtime_1.PHYSICAL_RESOURCE_ID_REFERENCE;
      }
      resolve(_context) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_IResolveContext(_context);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.resolve), error;
        }
        return runtime_1.PHYSICAL_RESOURCE_ID_REFERENCE;
      }
      toString() {
        return runtime_1.PHYSICAL_RESOURCE_ID_REFERENCE;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, PhysicalResourceIdReference[_a] = { fqn: "aws-cdk-lib.custom_resources.PhysicalResourceIdReference", version: "2.80.0" }, exports2.PhysicalResourceIdReference = PhysicalResourceIdReference;
    var PhysicalResourceId = class _PhysicalResourceId {
      static fromResponse(responsePath) {
        return new _PhysicalResourceId(responsePath, void 0);
      }
      static of(id) {
        return new _PhysicalResourceId(void 0, id);
      }
      constructor(responsePath, id) {
        this.responsePath = responsePath, this.id = id;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, PhysicalResourceId[_b] = { fqn: "aws-cdk-lib.custom_resources.PhysicalResourceId", version: "2.80.0" }, exports2.PhysicalResourceId = PhysicalResourceId;
    var AwsCustomResourcePolicy = class _AwsCustomResourcePolicy {
      static fromStatements(statements) {
        return new _AwsCustomResourcePolicy(statements, void 0);
      }
      static fromSdkCalls(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_custom_resources_SdkCallsPolicyOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromSdkCalls), error;
        }
        return new _AwsCustomResourcePolicy([], options.resources);
      }
      constructor(statements, resources) {
        this.statements = statements, this.resources = resources;
      }
    };
    _c = JSII_RTTI_SYMBOL_1, AwsCustomResourcePolicy[_c] = { fqn: "aws-cdk-lib.custom_resources.AwsCustomResourcePolicy", version: "2.80.0" }, AwsCustomResourcePolicy.ANY_RESOURCE = ["*"], exports2.AwsCustomResourcePolicy = AwsCustomResourcePolicy;
    var AwsCustomResource = class _AwsCustomResource extends constructs_1.Construct {
      static breakIgnoreErrorsCircuit(sdkCalls, caller) {
        for (const call of sdkCalls)
          if (call?.ignoreErrorCodesMatching)
            throw new Error(`\`${caller}\` cannot be called along with \`ignoreErrorCodesMatching\`.`);
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_custom_resources_AwsCustomResourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AwsCustomResource), error;
        }
        if (!props.onCreate && !props.onUpdate && !props.onDelete)
          throw new Error("At least `onCreate`, `onUpdate` or `onDelete` must be specified.");
        if (!props.role && !props.policy)
          throw new Error("At least one of `policy` or `role` (or both) must be specified.");
        if (props.onCreate && !props.onCreate.physicalResourceId)
          throw new Error("'physicalResourceId' must be specified for 'onCreate' call.");
        if (!props.onCreate && props.onUpdate && !props.onUpdate.physicalResourceId)
          throw new Error("'physicalResourceId' must be specified for 'onUpdate' call when 'onCreate' is omitted.");
        for (const call of [props.onCreate, props.onUpdate, props.onDelete])
          call?.physicalResourceId?.responsePath && _AwsCustomResource.breakIgnoreErrorsCircuit([call], "PhysicalResourceId.fromResponse");
        if (includesPhysicalResourceIdRef(props.onCreate?.parameters))
          throw new Error("`PhysicalResourceIdReference` must not be specified in `onCreate` parameters.");
        this.props = props;
        const provider = new lambda2.SingletonFunction(this, "Provider", { code: lambda2.Code.fromAsset(path.join(__dirname, "runtime"), { exclude: ["*.ts"] }), runtime: builtInCustomResourceNodeRuntime(scope), handler: "index.handler", uuid: _AwsCustomResource.PROVIDER_FUNCTION_UUID, lambdaPurpose: "AWS", timeout: props.timeout || cdk.Duration.minutes(2), role: props.role, logRetention: props.logRetention, functionName: props.functionName, vpc: props.vpc, vpcSubnets: props.vpcSubnets });
        this.grantPrincipal = provider.grantPrincipal;
        const installLatestAwsSdk = props.installLatestAwsSdk ?? this.node.tryGetContext(cxapi.AWS_CUSTOM_RESOURCE_LATEST_SDK_DEFAULT) ?? true;
        installLatestAwsSdk && props.installLatestAwsSdk === void 0 && core_1.Annotations.of(this).addWarning(["installLatestAwsSdk was not specified, and defaults to true. You probably do not want this.", `Set the global context flag '${cxapi.AWS_CUSTOM_RESOURCE_LATEST_SDK_DEFAULT}' to false to switch this behavior off project-wide,`, "or set the property explicitly to true if you know you need to call APIs that are not in Lambda's built-in SDK version."].join(" "));
        const create = props.onCreate || props.onUpdate;
        if (this.customResource = new cdk.CustomResource(this, "Resource", { resourceType: props.resourceType || "Custom::AWS", serviceToken: provider.functionArn, pascalCaseProperties: true, removalPolicy: props.removalPolicy, properties: { create: create && this.encodeJson(create), update: props.onUpdate && this.encodeJson(props.onUpdate), delete: props.onDelete && this.encodeJson(props.onDelete), installLatestAwsSdk } }), props.policy) {
          const statements = [];
          if (props.policy.statements.length !== 0)
            for (const statement of props.policy.statements)
              statements.push(statement);
          else
            for (const call of [props.onCreate, props.onUpdate, props.onDelete])
              if (call && call.assumedRoleArn == null) {
                const statement = new iam.PolicyStatement({ actions: [awsSdkToIamAction(call.service, call.action)], resources: props.policy.resources });
                statements.push(statement);
              } else if (call && call.assumedRoleArn != null) {
                const statement = new iam.PolicyStatement({ actions: ["sts:AssumeRole"], resources: [call.assumedRoleArn] });
                statements.push(statement);
              }
          const policy = new iam.Policy(this, "CustomResourcePolicy", { statements });
          provider.role !== void 0 && policy.attachToRole(provider.role), this.customResource.node.addDependency(policy);
        }
      }
      getResponseFieldReference(dataPath) {
        return _AwsCustomResource.breakIgnoreErrorsCircuit([this.props.onCreate, this.props.onUpdate], "getData"), this.customResource.getAtt(dataPath);
      }
      getResponseField(dataPath) {
        return _AwsCustomResource.breakIgnoreErrorsCircuit([this.props.onCreate, this.props.onUpdate], "getDataString"), this.customResource.getAttString(dataPath);
      }
      encodeJson(obj) {
        return cdk.Lazy.uncachedString({ produce: () => cdk.Stack.of(this).toJsonString(obj) });
      }
    };
    _d = JSII_RTTI_SYMBOL_1, AwsCustomResource[_d] = { fqn: "aws-cdk-lib.custom_resources.AwsCustomResource", version: "2.80.0" }, AwsCustomResource.PROVIDER_FUNCTION_UUID = "679f53fa-c002-430c-b0da-5b7982bd2287", exports2.AwsCustomResource = AwsCustomResource;
    var getAwsSdkMetadata = /* @__PURE__ */ (() => {
      let _awsSdkMetadata;
      return function() {
        return _awsSdkMetadata || (_awsSdkMetadata = JSON.parse(fs.readFileSync(path.join(__dirname, "sdk-api-metadata.json"), "utf-8")));
      };
    })();
    function includesPhysicalResourceIdRef(obj) {
      if (obj === void 0)
        return false;
      let foundRef = false;
      return JSON.stringify(obj, (_, v) => (v === runtime_1.PHYSICAL_RESOURCE_ID_REFERENCE && (foundRef = true), v)), foundRef;
    }
    function awsSdkToIamAction(service, action) {
      const srv = service.toLowerCase(), awsSdkMetadata = getAwsSdkMetadata(), iamService = awsSdkMetadata[srv] && awsSdkMetadata[srv].prefix || srv, iamAction = action.charAt(0).toUpperCase() + action.slice(1);
      return `${iamService}:${iamAction}`;
    }
  }
});

// node_modules/aws-cdk-lib/custom-resources/lib/aws-custom-resource/index.js
var require_aws_custom_resource2 = __commonJS({
  "node_modules/aws-cdk-lib/custom-resources/lib/aws-custom-resource/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_aws_custom_resource(), exports2);
  }
});

// node_modules/aws-cdk-lib/custom-resources/lib/provider-framework/runtime/consts.js
var require_consts = __commonJS({
  "node_modules/aws-cdk-lib/custom-resources/lib/provider-framework/runtime/consts.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FRAMEWORK_ON_TIMEOUT_HANDLER_NAME = exports2.FRAMEWORK_IS_COMPLETE_HANDLER_NAME = exports2.FRAMEWORK_ON_EVENT_HANDLER_NAME = exports2.WAITER_STATE_MACHINE_ARN_ENV = exports2.USER_IS_COMPLETE_FUNCTION_ARN_ENV = exports2.USER_ON_EVENT_FUNCTION_ARN_ENV = void 0, exports2.USER_ON_EVENT_FUNCTION_ARN_ENV = "USER_ON_EVENT_FUNCTION_ARN", exports2.USER_IS_COMPLETE_FUNCTION_ARN_ENV = "USER_IS_COMPLETE_FUNCTION_ARN", exports2.WAITER_STATE_MACHINE_ARN_ENV = "WAITER_STATE_MACHINE_ARN", exports2.FRAMEWORK_ON_EVENT_HANDLER_NAME = "onEvent", exports2.FRAMEWORK_IS_COMPLETE_HANDLER_NAME = "isComplete", exports2.FRAMEWORK_ON_TIMEOUT_HANDLER_NAME = "onTimeout";
  }
});

// node_modules/aws-cdk-lib/custom-resources/lib/provider-framework/util.js
var require_util10 = __commonJS({
  "node_modules/aws-cdk-lib/custom-resources/lib/provider-framework/util.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.calculateRetryPolicy = void 0;
    var core_1 = require_core2();
    var DEFAULT_TIMEOUT = core_1.Duration.minutes(30);
    var DEFAULT_INTERVAL = core_1.Duration.seconds(5);
    function calculateRetryPolicy(props = {}) {
      const totalTimeout = props.totalTimeout || DEFAULT_TIMEOUT, interval = props.queryInterval || DEFAULT_INTERVAL, maxAttempts = totalTimeout.toSeconds() / interval.toSeconds();
      if (Math.round(maxAttempts) !== maxAttempts)
        throw new Error(`Cannot determine retry count since totalTimeout=${totalTimeout.toSeconds()}s is not integrally dividable by queryInterval=${interval.toSeconds()}s`);
      return { maxAttempts, interval, backoffRate: 1 };
    }
    exports2.calculateRetryPolicy = calculateRetryPolicy;
  }
});

// node_modules/aws-cdk-lib/custom-resources/lib/provider-framework/waiter-state-machine.js
var require_waiter_state_machine = __commonJS({
  "node_modules/aws-cdk-lib/custom-resources/lib/provider-framework/waiter-state-machine.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.WaiterStateMachine = void 0;
    var constructs_1 = require_lib2();
    var aws_iam_1 = require_aws_iam();
    var core_1 = require_core2();
    var WaiterStateMachine = class extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id);
        const role = new aws_iam_1.Role(this, "Role", { assumedBy: new aws_iam_1.ServicePrincipal("states.amazonaws.com") });
        props.isCompleteHandler.grantInvoke(role), props.timeoutHandler.grantInvoke(role);
        const definition = core_1.Stack.of(this).toJsonString({ StartAt: "framework-isComplete-task", States: { "framework-isComplete-task": { End: true, Retry: [{ ErrorEquals: ["States.ALL"], IntervalSeconds: props.interval.toSeconds(), MaxAttempts: props.maxAttempts, BackoffRate: props.backoffRate }], Catch: [{ ErrorEquals: ["States.ALL"], Next: "framework-onTimeout-task" }], Type: "Task", Resource: props.isCompleteHandler.functionArn }, "framework-onTimeout-task": { End: true, Type: "Task", Resource: props.timeoutHandler.functionArn } } }), resource = new core_1.CfnResource(this, "Resource", { type: "AWS::StepFunctions::StateMachine", properties: { DefinitionString: definition, RoleArn: role.roleArn } });
        resource.node.addDependency(role), this.stateMachineArn = resource.ref;
      }
      grantStartExecution(identity) {
        return aws_iam_1.Grant.addToPrincipal({ grantee: identity, actions: ["states:StartExecution"], resourceArns: [this.stateMachineArn] });
      }
    };
    exports2.WaiterStateMachine = WaiterStateMachine;
  }
});

// node_modules/aws-cdk-lib/custom-resources/lib/provider-framework/provider.js
var require_provider = __commonJS({
  "node_modules/aws-cdk-lib/custom-resources/lib/provider-framework/provider.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Provider = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var path = require("path");
    var constructs_1 = require_lib2();
    var consts = require_consts();
    var util_1 = require_util10();
    var waiter_state_machine_1 = require_waiter_state_machine();
    var lambda2 = require_aws_lambda();
    var core_1 = require_core2();
    var RUNTIME_HANDLER_PATH = path.join(__dirname, "runtime");
    var FRAMEWORK_HANDLER_TIMEOUT = core_1.Duration.minutes(15);
    var Provider2 = class _Provider extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_custom_resources_ProviderProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Provider), error;
        }
        if (!props.isCompleteHandler && (props.queryInterval || props.totalTimeout))
          throw new Error('"queryInterval" and "totalTimeout" can only be configured if "isCompleteHandler" is specified. Otherwise, they have no meaning');
        this.onEventHandler = props.onEventHandler, this.isCompleteHandler = props.isCompleteHandler, this.logRetention = props.logRetention, this.vpc = props.vpc, this.vpcSubnets = props.vpcSubnets, this.securityGroups = props.securityGroups, this.role = props.role;
        const onEventFunction = this.createFunction(consts.FRAMEWORK_ON_EVENT_HANDLER_NAME, props.providerFunctionName);
        if (this.isCompleteHandler) {
          const isCompleteFunction = this.createFunction(consts.FRAMEWORK_IS_COMPLETE_HANDLER_NAME), timeoutFunction = this.createFunction(consts.FRAMEWORK_ON_TIMEOUT_HANDLER_NAME), retry = (0, util_1.calculateRetryPolicy)(props), waiterStateMachine = new waiter_state_machine_1.WaiterStateMachine(this, "waiter-state-machine", { isCompleteHandler: isCompleteFunction, timeoutHandler: timeoutFunction, backoffRate: retry.backoffRate, interval: retry.interval, maxAttempts: retry.maxAttempts });
          onEventFunction.addEnvironment(consts.WAITER_STATE_MACHINE_ARN_ENV, waiterStateMachine.stateMachineArn), waiterStateMachine.grantStartExecution(onEventFunction);
        }
        this.entrypoint = onEventFunction, this.serviceToken = this.entrypoint.functionArn;
      }
      bind(_scope) {
        return { serviceToken: this.entrypoint.functionArn };
      }
      createFunction(entrypoint, name) {
        const fn = new lambda2.Function(this, `framework-${entrypoint}`, { code: lambda2.Code.fromAsset(RUNTIME_HANDLER_PATH, { exclude: ["*.ts"] }), description: `AWS CDK resource provider framework - ${entrypoint} (${this.node.path})`.slice(0, 256), runtime: lambda2.Runtime.NODEJS_14_X, handler: `framework.${entrypoint}`, timeout: FRAMEWORK_HANDLER_TIMEOUT, logRetention: this.logRetention, vpc: this.vpc, vpcSubnets: this.vpcSubnets, securityGroups: this.securityGroups, role: this.role, functionName: name });
        return fn.addEnvironment(consts.USER_ON_EVENT_FUNCTION_ARN_ENV, this.onEventHandler.functionArn), this.onEventHandler.grantInvoke(fn), this.isCompleteHandler && (fn.addEnvironment(consts.USER_IS_COMPLETE_FUNCTION_ARN_ENV, this.isCompleteHandler.functionArn), this.isCompleteHandler.grantInvoke(fn)), fn;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Provider2[_a] = { fqn: "aws-cdk-lib.custom_resources.Provider", version: "2.80.0" }, exports2.Provider = Provider2;
  }
});

// node_modules/aws-cdk-lib/custom-resources/lib/provider-framework/index.js
var require_provider_framework = __commonJS({
  "node_modules/aws-cdk-lib/custom-resources/lib/provider-framework/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_provider(), exports2);
  }
});

// node_modules/aws-cdk-lib/custom-resources/lib/index.js
var require_lib26 = __commonJS({
  "node_modules/aws-cdk-lib/custom-resources/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_aws_custom_resource2(), exports2), __exportStar(require_provider_framework(), exports2);
  }
});

// node_modules/aws-cdk-lib/custom-resources/index.js
var require_custom_resources = __commonJS({
  "node_modules/aws-cdk-lib/custom-resources/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib26(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-codedeploy/lib/private/utils.js
var require_utils8 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codedeploy/lib/private/utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.validateName = exports2.renderAutoRollbackConfiguration = exports2.deploymentConfig = exports2.renderAlarmConfiguration = exports2.arnForDeploymentConfig = exports2.nameFromDeploymentGroupArn = exports2.arnForApplication = void 0;
    var core_1 = require_core2();
    function arnForApplication(stack, applicationName) {
      return stack.formatArn({ service: "codedeploy", resource: "application", resourceName: applicationName, arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME });
    }
    exports2.arnForApplication = arnForApplication;
    function nameFromDeploymentGroupArn(deploymentGroupArn) {
      const components = core_1.Arn.split(deploymentGroupArn, core_1.ArnFormat.COLON_RESOURCE_NAME);
      return core_1.Fn.select(1, core_1.Fn.split("/", components.resourceName ?? ""));
    }
    exports2.nameFromDeploymentGroupArn = nameFromDeploymentGroupArn;
    function arnForDeploymentConfig(name, resource) {
      return core_1.Arn.format({ partition: core_1.Aws.PARTITION, account: resource?.env.account ?? core_1.Aws.ACCOUNT_ID, region: resource?.env.region ?? core_1.Aws.REGION, service: "codedeploy", resource: "deploymentconfig", resourceName: name, arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME });
    }
    exports2.arnForDeploymentConfig = arnForDeploymentConfig;
    function renderAlarmConfiguration(alarms, ignorePollAlarmFailure, removeAlarms = true) {
      return removeAlarms ? { alarms: alarms.length > 0 ? alarms.map((a) => ({ name: a.alarmName })) : void 0, enabled: alarms.length > 0, ignorePollAlarmFailure } : alarms.length === 0 ? void 0 : { alarms: alarms.map((a) => ({ name: a.alarmName })), enabled: true, ignorePollAlarmFailure };
    }
    exports2.renderAlarmConfiguration = renderAlarmConfiguration;
    function deploymentConfig(name) {
      return { deploymentConfigName: name, deploymentConfigArn: arnForDeploymentConfig(name), bindEnvironment: (resource) => ({ deploymentConfigName: name, deploymentConfigArn: arnForDeploymentConfig(name, resource) }) };
    }
    exports2.deploymentConfig = deploymentConfig;
    var AutoRollbackEvent;
    (function(AutoRollbackEvent2) {
      AutoRollbackEvent2.DEPLOYMENT_FAILURE = "DEPLOYMENT_FAILURE", AutoRollbackEvent2.DEPLOYMENT_STOP_ON_ALARM = "DEPLOYMENT_STOP_ON_ALARM", AutoRollbackEvent2.DEPLOYMENT_STOP_ON_REQUEST = "DEPLOYMENT_STOP_ON_REQUEST";
    })(AutoRollbackEvent || (AutoRollbackEvent = {}));
    function renderAutoRollbackConfiguration(alarms, autoRollbackConfig = {}) {
      const events = new Array();
      if (autoRollbackConfig.failedDeployment !== false && events.push(AutoRollbackEvent.DEPLOYMENT_FAILURE), autoRollbackConfig.stoppedDeployment === true && events.push(AutoRollbackEvent.DEPLOYMENT_STOP_ON_REQUEST), autoRollbackConfig.deploymentInAlarm !== false) {
        if (alarms.length > 0)
          events.push(AutoRollbackEvent.DEPLOYMENT_STOP_ON_ALARM);
        else if (autoRollbackConfig.deploymentInAlarm === true)
          throw new Error("The auto-rollback setting 'deploymentInAlarm' does not have any effect unless you associate at least one CloudWatch alarm with the Deployment Group");
      }
      return autoRollbackConfig.failedDeployment === false && autoRollbackConfig.stoppedDeployment !== true && autoRollbackConfig.deploymentInAlarm === false ? { enabled: false } : events.length > 0 ? { enabled: true, events } : void 0;
    }
    exports2.renderAutoRollbackConfiguration = renderAutoRollbackConfiguration;
    function validateName(type, name) {
      const ret = [];
      return !core_1.Token.isUnresolved(name) && name !== void 0 && (name.length > 100 && ret.push(`${type} name: "${name}" can be a max of 100 characters.`), /^[a-z0-9._+=,@-]+$/i.test(name) || ret.push(`${type} name: "${name}" can only contain letters (a-z, A-Z), numbers (0-9), periods (.), underscores (_), + (plus signs), = (equals signs), , (commas), @ (at signs), - (minus signs).`)), ret;
    }
    exports2.validateName = validateName;
  }
});

// node_modules/aws-cdk-lib/aws-codedeploy/lib/lambda/custom-deployment-config.js
var require_custom_deployment_config = __commonJS({
  "node_modules/aws-cdk-lib/aws-codedeploy/lib/lambda/custom-deployment-config.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CustomLambdaDeploymentConfig = exports2.CustomLambdaDeploymentConfigType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core_1 = require_core2();
    var custom_resources_1 = require_custom_resources();
    var utils_1 = require_utils8();
    var CustomLambdaDeploymentConfigType;
    (function(CustomLambdaDeploymentConfigType2) {
      CustomLambdaDeploymentConfigType2.CANARY = "Canary", CustomLambdaDeploymentConfigType2.LINEAR = "Linear";
    })(CustomLambdaDeploymentConfigType = exports2.CustomLambdaDeploymentConfigType || (exports2.CustomLambdaDeploymentConfigType = {}));
    var CustomLambdaDeploymentConfig = class _CustomLambdaDeploymentConfig extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_codedeploy.CustomLambdaDeploymentConfig", "CloudFormation now supports Lambda deployment configurations without custom resources. Use `LambdaDeploymentConfig`."), jsiiDeprecationWarnings.aws_cdk_lib_aws_codedeploy_CustomLambdaDeploymentConfigProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CustomLambdaDeploymentConfig), error;
        }
        this.validateParameters(props);
        const deploymentType = "TimeBased" + props.type.toString(), intervalMinutes = props.interval.toMinutes().toString(), percentage = props.percentage.toString();
        let routingConfig;
        props.type == CustomLambdaDeploymentConfigType.CANARY ? routingConfig = { type: deploymentType, timeBasedCanary: { canaryInterval: intervalMinutes, canaryPercentage: percentage } } : props.type == CustomLambdaDeploymentConfigType.LINEAR && (routingConfig = { type: deploymentType, timeBasedLinear: { linearInterval: intervalMinutes, linearPercentage: percentage } }), this.deploymentConfigName = props.deploymentConfigName ?? `${core_1.Names.uniqueId(this)}.Lambda${props.type}${props.percentage}Percent${props.type === CustomLambdaDeploymentConfigType.LINEAR ? "Every" : ""}${props.interval.toMinutes()}Minutes`, this.deploymentConfigArn = (0, utils_1.arnForDeploymentConfig)(this.deploymentConfigName), new custom_resources_1.AwsCustomResource(this, "DeploymentConfig", { onCreate: { service: "CodeDeploy", action: "createDeploymentConfig", parameters: { deploymentConfigName: this.deploymentConfigName, computePlatform: "Lambda", trafficRoutingConfig: routingConfig }, physicalResourceId: custom_resources_1.PhysicalResourceId.of(this.deploymentConfigName) }, onUpdate: { service: "CodeDeploy", action: "createDeploymentConfig", parameters: { deploymentConfigName: this.deploymentConfigName, computePlatform: "Lambda", trafficRoutingConfig: routingConfig }, physicalResourceId: custom_resources_1.PhysicalResourceId.of(this.deploymentConfigName) }, onDelete: { service: "CodeDeploy", action: "deleteDeploymentConfig", parameters: { deploymentConfigName: this.deploymentConfigName } }, policy: custom_resources_1.AwsCustomResourcePolicy.fromSdkCalls({ resources: custom_resources_1.AwsCustomResourcePolicy.ANY_RESOURCE }), installLatestAwsSdk: false }), this.node.addValidation({ validate: () => (0, utils_1.validateName)("Deployment config", this.deploymentConfigName) });
      }
      validateParameters(props) {
        if (!(1 <= props.percentage && props.percentage <= 99))
          throw new Error(`Invalid deployment config percentage "${props.percentage.toString()}".         Step percentage must be an integer between 1 and 99.`);
        if (props.interval.toMinutes() > 2880)
          throw new Error(`Invalid deployment config interval "${props.interval.toString()}".         Traffic shifting intervals must be positive integers up to 2880 (2 days).`);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CustomLambdaDeploymentConfig[_a] = { fqn: "aws-cdk-lib.aws_codedeploy.CustomLambdaDeploymentConfig", version: "2.80.0" }, exports2.CustomLambdaDeploymentConfig = CustomLambdaDeploymentConfig;
  }
});

// node_modules/aws-cdk-lib/aws-elasticsearch/lib/elasticsearch-access-policy.js
var require_elasticsearch_access_policy = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticsearch/lib/elasticsearch-access-policy.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ElasticsearchAccessPolicy = void 0;
    var iam = require_aws_iam();
    var cdk = require_core2();
    var cr = require_custom_resources();
    var ElasticsearchAccessPolicy = class extends cr.AwsCustomResource {
      constructor(scope, id, props) {
        super(scope, id, { resourceType: "Custom::ElasticsearchAccessPolicy", onUpdate: { action: "updateElasticsearchDomainConfig", service: "ES", parameters: { DomainName: props.domainName, AccessPolicies: cdk.Lazy.string({ produce: () => JSON.stringify(new iam.PolicyDocument({ statements: this.accessPolicyStatements }).toJSON()) }) }, outputPaths: ["DomainConfig.ElasticsearchClusterConfig.AccessPolicies"], physicalResourceId: cr.PhysicalResourceId.of(`${props.domainName}AccessPolicy`) }, policy: cr.AwsCustomResourcePolicy.fromSdkCalls({ resources: [props.domainArn] }) }), this.accessPolicyStatements = [], this.addAccessPolicies(...props.accessPolicies);
      }
      addAccessPolicies(...accessPolicyStatements) {
        this.accessPolicyStatements.push(...accessPolicyStatements);
      }
    };
    exports2.ElasticsearchAccessPolicy = ElasticsearchAccessPolicy;
  }
});

// node_modules/aws-cdk-lib/aws-elasticsearch/lib/elasticsearch.generated.js
var require_elasticsearch_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticsearch/lib/elasticsearch.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnDomain = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnDomainPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessPolicies", cdk.validateObject)(properties.accessPolicies)), errors.collect(cdk.propertyValidator("advancedOptions", cdk.hashValidator(cdk.validateString))(properties.advancedOptions)), errors.collect(cdk.propertyValidator("advancedSecurityOptions", CfnDomain_AdvancedSecurityOptionsInputPropertyValidator)(properties.advancedSecurityOptions)), errors.collect(cdk.propertyValidator("cognitoOptions", CfnDomain_CognitoOptionsPropertyValidator)(properties.cognitoOptions)), errors.collect(cdk.propertyValidator("domainEndpointOptions", CfnDomain_DomainEndpointOptionsPropertyValidator)(properties.domainEndpointOptions)), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.collect(cdk.propertyValidator("ebsOptions", CfnDomain_EBSOptionsPropertyValidator)(properties.ebsOptions)), errors.collect(cdk.propertyValidator("elasticsearchClusterConfig", CfnDomain_ElasticsearchClusterConfigPropertyValidator)(properties.elasticsearchClusterConfig)), errors.collect(cdk.propertyValidator("elasticsearchVersion", cdk.validateString)(properties.elasticsearchVersion)), errors.collect(cdk.propertyValidator("encryptionAtRestOptions", CfnDomain_EncryptionAtRestOptionsPropertyValidator)(properties.encryptionAtRestOptions)), errors.collect(cdk.propertyValidator("logPublishingOptions", cdk.hashValidator(CfnDomain_LogPublishingOptionPropertyValidator))(properties.logPublishingOptions)), errors.collect(cdk.propertyValidator("nodeToNodeEncryptionOptions", CfnDomain_NodeToNodeEncryptionOptionsPropertyValidator)(properties.nodeToNodeEncryptionOptions)), errors.collect(cdk.propertyValidator("snapshotOptions", CfnDomain_SnapshotOptionsPropertyValidator)(properties.snapshotOptions)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpcOptions", CfnDomain_VPCOptionsPropertyValidator)(properties.vpcOptions)), errors.wrap('supplied properties not correct for "CfnDomainProps"');
    }
    function cfnDomainPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomainPropsValidator(properties).assertSuccess(), { AccessPolicies: cdk.objectToCloudFormation(properties.accessPolicies), AdvancedOptions: cdk.hashMapper(cdk.stringToCloudFormation)(properties.advancedOptions), AdvancedSecurityOptions: cfnDomainAdvancedSecurityOptionsInputPropertyToCloudFormation(properties.advancedSecurityOptions), CognitoOptions: cfnDomainCognitoOptionsPropertyToCloudFormation(properties.cognitoOptions), DomainEndpointOptions: cfnDomainDomainEndpointOptionsPropertyToCloudFormation(properties.domainEndpointOptions), DomainName: cdk.stringToCloudFormation(properties.domainName), EBSOptions: cfnDomainEBSOptionsPropertyToCloudFormation(properties.ebsOptions), ElasticsearchClusterConfig: cfnDomainElasticsearchClusterConfigPropertyToCloudFormation(properties.elasticsearchClusterConfig), ElasticsearchVersion: cdk.stringToCloudFormation(properties.elasticsearchVersion), EncryptionAtRestOptions: cfnDomainEncryptionAtRestOptionsPropertyToCloudFormation(properties.encryptionAtRestOptions), LogPublishingOptions: cdk.hashMapper(cfnDomainLogPublishingOptionPropertyToCloudFormation)(properties.logPublishingOptions), NodeToNodeEncryptionOptions: cfnDomainNodeToNodeEncryptionOptionsPropertyToCloudFormation(properties.nodeToNodeEncryptionOptions), SnapshotOptions: cfnDomainSnapshotOptionsPropertyToCloudFormation(properties.snapshotOptions), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VPCOptions: cfnDomainVPCOptionsPropertyToCloudFormation(properties.vpcOptions) }) : properties;
    }
    function CfnDomainPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessPolicies", "AccessPolicies", properties.AccessPolicies != null ? cfn_parse.FromCloudFormation.getAny(properties.AccessPolicies) : void 0), ret.addPropertyResult("advancedOptions", "AdvancedOptions", properties.AdvancedOptions != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.AdvancedOptions) : void 0), ret.addPropertyResult("advancedSecurityOptions", "AdvancedSecurityOptions", properties.AdvancedSecurityOptions != null ? CfnDomainAdvancedSecurityOptionsInputPropertyFromCloudFormation(properties.AdvancedSecurityOptions) : void 0), ret.addPropertyResult("cognitoOptions", "CognitoOptions", properties.CognitoOptions != null ? CfnDomainCognitoOptionsPropertyFromCloudFormation(properties.CognitoOptions) : void 0), ret.addPropertyResult("domainEndpointOptions", "DomainEndpointOptions", properties.DomainEndpointOptions != null ? CfnDomainDomainEndpointOptionsPropertyFromCloudFormation(properties.DomainEndpointOptions) : void 0), ret.addPropertyResult("domainName", "DomainName", properties.DomainName != null ? cfn_parse.FromCloudFormation.getString(properties.DomainName) : void 0), ret.addPropertyResult("ebsOptions", "EBSOptions", properties.EBSOptions != null ? CfnDomainEBSOptionsPropertyFromCloudFormation(properties.EBSOptions) : void 0), ret.addPropertyResult("elasticsearchClusterConfig", "ElasticsearchClusterConfig", properties.ElasticsearchClusterConfig != null ? CfnDomainElasticsearchClusterConfigPropertyFromCloudFormation(properties.ElasticsearchClusterConfig) : void 0), ret.addPropertyResult("elasticsearchVersion", "ElasticsearchVersion", properties.ElasticsearchVersion != null ? cfn_parse.FromCloudFormation.getString(properties.ElasticsearchVersion) : void 0), ret.addPropertyResult("encryptionAtRestOptions", "EncryptionAtRestOptions", properties.EncryptionAtRestOptions != null ? CfnDomainEncryptionAtRestOptionsPropertyFromCloudFormation(properties.EncryptionAtRestOptions) : void 0), ret.addPropertyResult("logPublishingOptions", "LogPublishingOptions", properties.LogPublishingOptions != null ? cfn_parse.FromCloudFormation.getMap(CfnDomainLogPublishingOptionPropertyFromCloudFormation)(properties.LogPublishingOptions) : void 0), ret.addPropertyResult("nodeToNodeEncryptionOptions", "NodeToNodeEncryptionOptions", properties.NodeToNodeEncryptionOptions != null ? CfnDomainNodeToNodeEncryptionOptionsPropertyFromCloudFormation(properties.NodeToNodeEncryptionOptions) : void 0), ret.addPropertyResult("snapshotOptions", "SnapshotOptions", properties.SnapshotOptions != null ? CfnDomainSnapshotOptionsPropertyFromCloudFormation(properties.SnapshotOptions) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("vpcOptions", "VPCOptions", properties.VPCOptions != null ? CfnDomainVPCOptionsPropertyFromCloudFormation(properties.VPCOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDomain = class _CfnDomain extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDomainPropsFromCloudFormation(resourceProperties), ret = new _CfnDomain(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnDomain.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticsearch_CfnDomainProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDomain), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrDomainEndpoint = cdk.Token.asString(this.getAtt("DomainEndpoint", cdk.ResolutionTypeHint.STRING)), this.accessPolicies = props.accessPolicies, this.advancedOptions = props.advancedOptions, this.advancedSecurityOptions = props.advancedSecurityOptions, this.cognitoOptions = props.cognitoOptions, this.domainEndpointOptions = props.domainEndpointOptions, this.domainName = props.domainName, this.ebsOptions = props.ebsOptions, this.elasticsearchClusterConfig = props.elasticsearchClusterConfig, this.elasticsearchVersion = props.elasticsearchVersion, this.encryptionAtRestOptions = props.encryptionAtRestOptions, this.logPublishingOptions = props.logPublishingOptions, this.nodeToNodeEncryptionOptions = props.nodeToNodeEncryptionOptions, this.snapshotOptions = props.snapshotOptions, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Elasticsearch::Domain", props.tags, { tagPropertyName: "tags" }), this.vpcOptions = props.vpcOptions, this.node.scope && cdk.Resource.isResource(this.node.scope) && this.node.addValidation({ validate: () => this.cfnOptions.deletionPolicy === void 0 ? ["'AWS::Elasticsearch::Domain' is a stateful resource type, and you must specify a Removal Policy for it. Call 'resource.applyRemovalPolicy()'."] : [] });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDomain.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { accessPolicies: this.accessPolicies, advancedOptions: this.advancedOptions, advancedSecurityOptions: this.advancedSecurityOptions, cognitoOptions: this.cognitoOptions, domainEndpointOptions: this.domainEndpointOptions, domainName: this.domainName, ebsOptions: this.ebsOptions, elasticsearchClusterConfig: this.elasticsearchClusterConfig, elasticsearchVersion: this.elasticsearchVersion, encryptionAtRestOptions: this.encryptionAtRestOptions, logPublishingOptions: this.logPublishingOptions, nodeToNodeEncryptionOptions: this.nodeToNodeEncryptionOptions, snapshotOptions: this.snapshotOptions, tags: this.tags.renderTags(), vpcOptions: this.vpcOptions };
      }
      renderProperties(props) {
        return cfnDomainPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnDomain[_a] = { fqn: "aws-cdk-lib.aws_elasticsearch.CfnDomain", version: "2.80.0" }, CfnDomain.CFN_RESOURCE_TYPE_NAME = "AWS::Elasticsearch::Domain", exports2.CfnDomain = CfnDomain;
    function CfnDomain_AdvancedSecurityOptionsInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("anonymousAuthEnabled", cdk.validateBoolean)(properties.anonymousAuthEnabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("internalUserDatabaseEnabled", cdk.validateBoolean)(properties.internalUserDatabaseEnabled)), errors.collect(cdk.propertyValidator("masterUserOptions", CfnDomain_MasterUserOptionsPropertyValidator)(properties.masterUserOptions)), errors.wrap('supplied properties not correct for "AdvancedSecurityOptionsInputProperty"');
    }
    function cfnDomainAdvancedSecurityOptionsInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_AdvancedSecurityOptionsInputPropertyValidator(properties).assertSuccess(), { AnonymousAuthEnabled: cdk.booleanToCloudFormation(properties.anonymousAuthEnabled), Enabled: cdk.booleanToCloudFormation(properties.enabled), InternalUserDatabaseEnabled: cdk.booleanToCloudFormation(properties.internalUserDatabaseEnabled), MasterUserOptions: cfnDomainMasterUserOptionsPropertyToCloudFormation(properties.masterUserOptions) }) : properties;
    }
    function CfnDomainAdvancedSecurityOptionsInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("anonymousAuthEnabled", "AnonymousAuthEnabled", properties.AnonymousAuthEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AnonymousAuthEnabled) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("internalUserDatabaseEnabled", "InternalUserDatabaseEnabled", properties.InternalUserDatabaseEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.InternalUserDatabaseEnabled) : void 0), ret.addPropertyResult("masterUserOptions", "MasterUserOptions", properties.MasterUserOptions != null ? CfnDomainMasterUserOptionsPropertyFromCloudFormation(properties.MasterUserOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_CognitoOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("identityPoolId", cdk.validateString)(properties.identityPoolId)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("userPoolId", cdk.validateString)(properties.userPoolId)), errors.wrap('supplied properties not correct for "CognitoOptionsProperty"');
    }
    function cfnDomainCognitoOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_CognitoOptionsPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled), IdentityPoolId: cdk.stringToCloudFormation(properties.identityPoolId), RoleArn: cdk.stringToCloudFormation(properties.roleArn), UserPoolId: cdk.stringToCloudFormation(properties.userPoolId) }) : properties;
    }
    function CfnDomainCognitoOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("identityPoolId", "IdentityPoolId", properties.IdentityPoolId != null ? cfn_parse.FromCloudFormation.getString(properties.IdentityPoolId) : void 0), ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addPropertyResult("userPoolId", "UserPoolId", properties.UserPoolId != null ? cfn_parse.FromCloudFormation.getString(properties.UserPoolId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_ColdStorageOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "ColdStorageOptionsProperty"');
    }
    function cfnDomainColdStorageOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_ColdStorageOptionsPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnDomainColdStorageOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_DomainEndpointOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customEndpoint", cdk.validateString)(properties.customEndpoint)), errors.collect(cdk.propertyValidator("customEndpointCertificateArn", cdk.validateString)(properties.customEndpointCertificateArn)), errors.collect(cdk.propertyValidator("customEndpointEnabled", cdk.validateBoolean)(properties.customEndpointEnabled)), errors.collect(cdk.propertyValidator("enforceHttps", cdk.validateBoolean)(properties.enforceHttps)), errors.collect(cdk.propertyValidator("tlsSecurityPolicy", cdk.validateString)(properties.tlsSecurityPolicy)), errors.wrap('supplied properties not correct for "DomainEndpointOptionsProperty"');
    }
    function cfnDomainDomainEndpointOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_DomainEndpointOptionsPropertyValidator(properties).assertSuccess(), { CustomEndpoint: cdk.stringToCloudFormation(properties.customEndpoint), CustomEndpointCertificateArn: cdk.stringToCloudFormation(properties.customEndpointCertificateArn), CustomEndpointEnabled: cdk.booleanToCloudFormation(properties.customEndpointEnabled), EnforceHTTPS: cdk.booleanToCloudFormation(properties.enforceHttps), TLSSecurityPolicy: cdk.stringToCloudFormation(properties.tlsSecurityPolicy) }) : properties;
    }
    function CfnDomainDomainEndpointOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customEndpoint", "CustomEndpoint", properties.CustomEndpoint != null ? cfn_parse.FromCloudFormation.getString(properties.CustomEndpoint) : void 0), ret.addPropertyResult("customEndpointCertificateArn", "CustomEndpointCertificateArn", properties.CustomEndpointCertificateArn != null ? cfn_parse.FromCloudFormation.getString(properties.CustomEndpointCertificateArn) : void 0), ret.addPropertyResult("customEndpointEnabled", "CustomEndpointEnabled", properties.CustomEndpointEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CustomEndpointEnabled) : void 0), ret.addPropertyResult("enforceHttps", "EnforceHTTPS", properties.EnforceHTTPS != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnforceHTTPS) : void 0), ret.addPropertyResult("tlsSecurityPolicy", "TLSSecurityPolicy", properties.TLSSecurityPolicy != null ? cfn_parse.FromCloudFormation.getString(properties.TLSSecurityPolicy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_EBSOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ebsEnabled", cdk.validateBoolean)(properties.ebsEnabled)), errors.collect(cdk.propertyValidator("iops", cdk.validateNumber)(properties.iops)), errors.collect(cdk.propertyValidator("volumeSize", cdk.validateNumber)(properties.volumeSize)), errors.collect(cdk.propertyValidator("volumeType", cdk.validateString)(properties.volumeType)), errors.wrap('supplied properties not correct for "EBSOptionsProperty"');
    }
    function cfnDomainEBSOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_EBSOptionsPropertyValidator(properties).assertSuccess(), { EBSEnabled: cdk.booleanToCloudFormation(properties.ebsEnabled), Iops: cdk.numberToCloudFormation(properties.iops), VolumeSize: cdk.numberToCloudFormation(properties.volumeSize), VolumeType: cdk.stringToCloudFormation(properties.volumeType) }) : properties;
    }
    function CfnDomainEBSOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ebsEnabled", "EBSEnabled", properties.EBSEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EBSEnabled) : void 0), ret.addPropertyResult("iops", "Iops", properties.Iops != null ? cfn_parse.FromCloudFormation.getNumber(properties.Iops) : void 0), ret.addPropertyResult("volumeSize", "VolumeSize", properties.VolumeSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.VolumeSize) : void 0), ret.addPropertyResult("volumeType", "VolumeType", properties.VolumeType != null ? cfn_parse.FromCloudFormation.getString(properties.VolumeType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_ElasticsearchClusterConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("coldStorageOptions", CfnDomain_ColdStorageOptionsPropertyValidator)(properties.coldStorageOptions)), errors.collect(cdk.propertyValidator("dedicatedMasterCount", cdk.validateNumber)(properties.dedicatedMasterCount)), errors.collect(cdk.propertyValidator("dedicatedMasterEnabled", cdk.validateBoolean)(properties.dedicatedMasterEnabled)), errors.collect(cdk.propertyValidator("dedicatedMasterType", cdk.validateString)(properties.dedicatedMasterType)), errors.collect(cdk.propertyValidator("instanceCount", cdk.validateNumber)(properties.instanceCount)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("warmCount", cdk.validateNumber)(properties.warmCount)), errors.collect(cdk.propertyValidator("warmEnabled", cdk.validateBoolean)(properties.warmEnabled)), errors.collect(cdk.propertyValidator("warmType", cdk.validateString)(properties.warmType)), errors.collect(cdk.propertyValidator("zoneAwarenessConfig", CfnDomain_ZoneAwarenessConfigPropertyValidator)(properties.zoneAwarenessConfig)), errors.collect(cdk.propertyValidator("zoneAwarenessEnabled", cdk.validateBoolean)(properties.zoneAwarenessEnabled)), errors.wrap('supplied properties not correct for "ElasticsearchClusterConfigProperty"');
    }
    function cfnDomainElasticsearchClusterConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_ElasticsearchClusterConfigPropertyValidator(properties).assertSuccess(), { ColdStorageOptions: cfnDomainColdStorageOptionsPropertyToCloudFormation(properties.coldStorageOptions), DedicatedMasterCount: cdk.numberToCloudFormation(properties.dedicatedMasterCount), DedicatedMasterEnabled: cdk.booleanToCloudFormation(properties.dedicatedMasterEnabled), DedicatedMasterType: cdk.stringToCloudFormation(properties.dedicatedMasterType), InstanceCount: cdk.numberToCloudFormation(properties.instanceCount), InstanceType: cdk.stringToCloudFormation(properties.instanceType), WarmCount: cdk.numberToCloudFormation(properties.warmCount), WarmEnabled: cdk.booleanToCloudFormation(properties.warmEnabled), WarmType: cdk.stringToCloudFormation(properties.warmType), ZoneAwarenessConfig: cfnDomainZoneAwarenessConfigPropertyToCloudFormation(properties.zoneAwarenessConfig), ZoneAwarenessEnabled: cdk.booleanToCloudFormation(properties.zoneAwarenessEnabled) }) : properties;
    }
    function CfnDomainElasticsearchClusterConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("coldStorageOptions", "ColdStorageOptions", properties.ColdStorageOptions != null ? CfnDomainColdStorageOptionsPropertyFromCloudFormation(properties.ColdStorageOptions) : void 0), ret.addPropertyResult("dedicatedMasterCount", "DedicatedMasterCount", properties.DedicatedMasterCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.DedicatedMasterCount) : void 0), ret.addPropertyResult("dedicatedMasterEnabled", "DedicatedMasterEnabled", properties.DedicatedMasterEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DedicatedMasterEnabled) : void 0), ret.addPropertyResult("dedicatedMasterType", "DedicatedMasterType", properties.DedicatedMasterType != null ? cfn_parse.FromCloudFormation.getString(properties.DedicatedMasterType) : void 0), ret.addPropertyResult("instanceCount", "InstanceCount", properties.InstanceCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.InstanceCount) : void 0), ret.addPropertyResult("instanceType", "InstanceType", properties.InstanceType != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceType) : void 0), ret.addPropertyResult("warmCount", "WarmCount", properties.WarmCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.WarmCount) : void 0), ret.addPropertyResult("warmEnabled", "WarmEnabled", properties.WarmEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.WarmEnabled) : void 0), ret.addPropertyResult("warmType", "WarmType", properties.WarmType != null ? cfn_parse.FromCloudFormation.getString(properties.WarmType) : void 0), ret.addPropertyResult("zoneAwarenessConfig", "ZoneAwarenessConfig", properties.ZoneAwarenessConfig != null ? CfnDomainZoneAwarenessConfigPropertyFromCloudFormation(properties.ZoneAwarenessConfig) : void 0), ret.addPropertyResult("zoneAwarenessEnabled", "ZoneAwarenessEnabled", properties.ZoneAwarenessEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ZoneAwarenessEnabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_EncryptionAtRestOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.wrap('supplied properties not correct for "EncryptionAtRestOptionsProperty"');
    }
    function cfnDomainEncryptionAtRestOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_EncryptionAtRestOptionsPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId) }) : properties;
    }
    function CfnDomainEncryptionAtRestOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_LogPublishingOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchLogsLogGroupArn", cdk.validateString)(properties.cloudWatchLogsLogGroupArn)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "LogPublishingOptionProperty"');
    }
    function cfnDomainLogPublishingOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_LogPublishingOptionPropertyValidator(properties).assertSuccess(), { CloudWatchLogsLogGroupArn: cdk.stringToCloudFormation(properties.cloudWatchLogsLogGroupArn), Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnDomainLogPublishingOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchLogsLogGroupArn", "CloudWatchLogsLogGroupArn", properties.CloudWatchLogsLogGroupArn != null ? cfn_parse.FromCloudFormation.getString(properties.CloudWatchLogsLogGroupArn) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_MasterUserOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("masterUserArn", cdk.validateString)(properties.masterUserArn)), errors.collect(cdk.propertyValidator("masterUserName", cdk.validateString)(properties.masterUserName)), errors.collect(cdk.propertyValidator("masterUserPassword", cdk.validateString)(properties.masterUserPassword)), errors.wrap('supplied properties not correct for "MasterUserOptionsProperty"');
    }
    function cfnDomainMasterUserOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_MasterUserOptionsPropertyValidator(properties).assertSuccess(), { MasterUserARN: cdk.stringToCloudFormation(properties.masterUserArn), MasterUserName: cdk.stringToCloudFormation(properties.masterUserName), MasterUserPassword: cdk.stringToCloudFormation(properties.masterUserPassword) }) : properties;
    }
    function CfnDomainMasterUserOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("masterUserArn", "MasterUserARN", properties.MasterUserARN != null ? cfn_parse.FromCloudFormation.getString(properties.MasterUserARN) : void 0), ret.addPropertyResult("masterUserName", "MasterUserName", properties.MasterUserName != null ? cfn_parse.FromCloudFormation.getString(properties.MasterUserName) : void 0), ret.addPropertyResult("masterUserPassword", "MasterUserPassword", properties.MasterUserPassword != null ? cfn_parse.FromCloudFormation.getString(properties.MasterUserPassword) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_NodeToNodeEncryptionOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "NodeToNodeEncryptionOptionsProperty"');
    }
    function cfnDomainNodeToNodeEncryptionOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_NodeToNodeEncryptionOptionsPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnDomainNodeToNodeEncryptionOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_SnapshotOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("automatedSnapshotStartHour", cdk.validateNumber)(properties.automatedSnapshotStartHour)), errors.wrap('supplied properties not correct for "SnapshotOptionsProperty"');
    }
    function cfnDomainSnapshotOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_SnapshotOptionsPropertyValidator(properties).assertSuccess(), { AutomatedSnapshotStartHour: cdk.numberToCloudFormation(properties.automatedSnapshotStartHour) }) : properties;
    }
    function CfnDomainSnapshotOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("automatedSnapshotStartHour", "AutomatedSnapshotStartHour", properties.AutomatedSnapshotStartHour != null ? cfn_parse.FromCloudFormation.getNumber(properties.AutomatedSnapshotStartHour) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_VPCOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.wrap('supplied properties not correct for "VPCOptionsProperty"');
    }
    function cfnDomainVPCOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_VPCOptionsPropertyValidator(properties).assertSuccess(), { SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds) }) : properties;
    }
    function CfnDomainVPCOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("subnetIds", "SubnetIds", properties.SubnetIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_ZoneAwarenessConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availabilityZoneCount", cdk.validateNumber)(properties.availabilityZoneCount)), errors.wrap('supplied properties not correct for "ZoneAwarenessConfigProperty"');
    }
    function cfnDomainZoneAwarenessConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_ZoneAwarenessConfigPropertyValidator(properties).assertSuccess(), { AvailabilityZoneCount: cdk.numberToCloudFormation(properties.availabilityZoneCount) }) : properties;
    }
    function CfnDomainZoneAwarenessConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("availabilityZoneCount", "AvailabilityZoneCount", properties.AvailabilityZoneCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.AvailabilityZoneCount) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-elasticsearch/lib/log-group-resource-policy.js
var require_log_group_resource_policy = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticsearch/lib/log-group-resource-policy.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LogGroupResourcePolicy = void 0;
    var iam = require_aws_iam();
    var cr = require_custom_resources();
    var LogGroupResourcePolicy = class extends cr.AwsCustomResource {
      constructor(scope, id, props) {
        const policyDocument = new iam.PolicyDocument({ statements: props.policyStatements });
        super(scope, id, { resourceType: "Custom::CloudwatchLogResourcePolicy", onUpdate: { service: "CloudWatchLogs", action: "putResourcePolicy", parameters: { policyName: props.policyName, policyDocument: JSON.stringify(policyDocument) }, physicalResourceId: cr.PhysicalResourceId.of(id) }, onDelete: { service: "CloudWatchLogs", action: "deleteResourcePolicy", parameters: { policyName: props.policyName }, ignoreErrorCodesMatching: "ResourceNotFoundException" }, policy: cr.AwsCustomResourcePolicy.fromSdkCalls({ resources: ["*"] }) });
      }
    };
    exports2.LogGroupResourcePolicy = LogGroupResourcePolicy;
  }
});

// node_modules/aws-cdk-lib/aws-elasticsearch/lib/perms.js
var require_perms3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticsearch/lib/perms.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ES_READ_WRITE_ACTIONS = exports2.ES_WRITE_ACTIONS = exports2.ES_READ_ACTIONS = void 0, exports2.ES_READ_ACTIONS = ["es:ESHttpGet", "es:ESHttpHead"], exports2.ES_WRITE_ACTIONS = ["es:ESHttpDelete", "es:ESHttpPost", "es:ESHttpPut", "es:ESHttpPatch"], exports2.ES_READ_WRITE_ACTIONS = [...exports2.ES_READ_ACTIONS, ...exports2.ES_WRITE_ACTIONS];
  }
});

// node_modules/aws-cdk-lib/aws-certificatemanager/lib/certificate-base.js
var require_certificate_base = __commonJS({
  "node_modules/aws-cdk-lib/aws-certificatemanager/lib/certificate-base.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CertificateBase = void 0;
    var cloudwatch = require_aws_cloudwatch();
    var aws_cloudwatch_1 = require_aws_cloudwatch();
    var core_1 = require_core2();
    var CertificateBase = class extends core_1.Resource {
      metricDaysToExpiry(props) {
        return new cloudwatch.Metric({ period: core_1.Duration.days(1), ...props, dimensionsMap: { CertificateArn: this.certificateArn }, metricName: "DaysToExpiry", namespace: "AWS/CertificateManager", region: this.region, statistic: aws_cloudwatch_1.Stats.MINIMUM });
      }
    };
    exports2.CertificateBase = CertificateBase;
  }
});

// node_modules/aws-cdk-lib/aws-certificatemanager/lib/certificatemanager.generated.js
var require_certificatemanager_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-certificatemanager/lib/certificatemanager.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnCertificate = exports2.CfnAccount = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAccountPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("expiryEventsConfiguration", cdk.requiredValidator)(properties.expiryEventsConfiguration)), errors.collect(cdk.propertyValidator("expiryEventsConfiguration", CfnAccount_ExpiryEventsConfigurationPropertyValidator)(properties.expiryEventsConfiguration)), errors.wrap('supplied properties not correct for "CfnAccountProps"');
    }
    function cfnAccountPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccountPropsValidator(properties).assertSuccess(), { ExpiryEventsConfiguration: cfnAccountExpiryEventsConfigurationPropertyToCloudFormation(properties.expiryEventsConfiguration) }) : properties;
    }
    function CfnAccountPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("expiryEventsConfiguration", "ExpiryEventsConfiguration", CfnAccountExpiryEventsConfigurationPropertyFromCloudFormation(properties.ExpiryEventsConfiguration)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAccount = class _CfnAccount extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAccountPropsFromCloudFormation(resourceProperties), ret = new _CfnAccount(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAccount.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_certificatemanager_CfnAccountProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAccount), error;
        }
        cdk.requireProperty(props, "expiryEventsConfiguration", this), this.attrAccountId = cdk.Token.asString(this.getAtt("AccountId", cdk.ResolutionTypeHint.STRING)), this.expiryEventsConfiguration = props.expiryEventsConfiguration;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAccount.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { expiryEventsConfiguration: this.expiryEventsConfiguration };
      }
      renderProperties(props) {
        return cfnAccountPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAccount[_a] = { fqn: "aws-cdk-lib.aws_certificatemanager.CfnAccount", version: "2.80.0" }, CfnAccount.CFN_RESOURCE_TYPE_NAME = "AWS::CertificateManager::Account", exports2.CfnAccount = CfnAccount;
    function CfnAccount_ExpiryEventsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("daysBeforeExpiry", cdk.validateNumber)(properties.daysBeforeExpiry)), errors.wrap('supplied properties not correct for "ExpiryEventsConfigurationProperty"');
    }
    function cfnAccountExpiryEventsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccount_ExpiryEventsConfigurationPropertyValidator(properties).assertSuccess(), { DaysBeforeExpiry: cdk.numberToCloudFormation(properties.daysBeforeExpiry) }) : properties;
    }
    function CfnAccountExpiryEventsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("daysBeforeExpiry", "DaysBeforeExpiry", properties.DaysBeforeExpiry != null ? cfn_parse.FromCloudFormation.getNumber(properties.DaysBeforeExpiry) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCertificatePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateAuthorityArn", cdk.validateString)(properties.certificateAuthorityArn)), errors.collect(cdk.propertyValidator("certificateTransparencyLoggingPreference", cdk.validateString)(properties.certificateTransparencyLoggingPreference)), errors.collect(cdk.propertyValidator("domainName", cdk.requiredValidator)(properties.domainName)), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.collect(cdk.propertyValidator("domainValidationOptions", cdk.listValidator(CfnCertificate_DomainValidationOptionPropertyValidator))(properties.domainValidationOptions)), errors.collect(cdk.propertyValidator("subjectAlternativeNames", cdk.listValidator(cdk.validateString))(properties.subjectAlternativeNames)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("validationMethod", cdk.validateString)(properties.validationMethod)), errors.wrap('supplied properties not correct for "CfnCertificateProps"');
    }
    function cfnCertificatePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificatePropsValidator(properties).assertSuccess(), { DomainName: cdk.stringToCloudFormation(properties.domainName), CertificateAuthorityArn: cdk.stringToCloudFormation(properties.certificateAuthorityArn), CertificateTransparencyLoggingPreference: cdk.stringToCloudFormation(properties.certificateTransparencyLoggingPreference), DomainValidationOptions: cdk.listMapper(cfnCertificateDomainValidationOptionPropertyToCloudFormation)(properties.domainValidationOptions), SubjectAlternativeNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.subjectAlternativeNames), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), ValidationMethod: cdk.stringToCloudFormation(properties.validationMethod) }) : properties;
    }
    function CfnCertificatePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("domainName", "DomainName", cfn_parse.FromCloudFormation.getString(properties.DomainName)), ret.addPropertyResult("certificateAuthorityArn", "CertificateAuthorityArn", properties.CertificateAuthorityArn != null ? cfn_parse.FromCloudFormation.getString(properties.CertificateAuthorityArn) : void 0), ret.addPropertyResult("certificateTransparencyLoggingPreference", "CertificateTransparencyLoggingPreference", properties.CertificateTransparencyLoggingPreference != null ? cfn_parse.FromCloudFormation.getString(properties.CertificateTransparencyLoggingPreference) : void 0), ret.addPropertyResult("domainValidationOptions", "DomainValidationOptions", properties.DomainValidationOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnCertificateDomainValidationOptionPropertyFromCloudFormation)(properties.DomainValidationOptions) : void 0), ret.addPropertyResult("subjectAlternativeNames", "SubjectAlternativeNames", properties.SubjectAlternativeNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SubjectAlternativeNames) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("validationMethod", "ValidationMethod", properties.ValidationMethod != null ? cfn_parse.FromCloudFormation.getString(properties.ValidationMethod) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCertificate = class _CfnCertificate extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCertificatePropsFromCloudFormation(resourceProperties), ret = new _CfnCertificate(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCertificate.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_certificatemanager_CfnCertificateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCertificate), error;
        }
        cdk.requireProperty(props, "domainName", this), this.domainName = props.domainName, this.certificateAuthorityArn = props.certificateAuthorityArn, this.certificateTransparencyLoggingPreference = props.certificateTransparencyLoggingPreference, this.domainValidationOptions = props.domainValidationOptions, this.subjectAlternativeNames = props.subjectAlternativeNames, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::CertificateManager::Certificate", props.tags, { tagPropertyName: "tags" }), this.validationMethod = props.validationMethod;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCertificate.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { domainName: this.domainName, certificateAuthorityArn: this.certificateAuthorityArn, certificateTransparencyLoggingPreference: this.certificateTransparencyLoggingPreference, domainValidationOptions: this.domainValidationOptions, subjectAlternativeNames: this.subjectAlternativeNames, tags: this.tags.renderTags(), validationMethod: this.validationMethod };
      }
      renderProperties(props) {
        return cfnCertificatePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnCertificate[_b] = { fqn: "aws-cdk-lib.aws_certificatemanager.CfnCertificate", version: "2.80.0" }, CfnCertificate.CFN_RESOURCE_TYPE_NAME = "AWS::CertificateManager::Certificate", exports2.CfnCertificate = CfnCertificate;
    function CfnCertificate_DomainValidationOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("domainName", cdk.requiredValidator)(properties.domainName)), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.collect(cdk.propertyValidator("hostedZoneId", cdk.validateString)(properties.hostedZoneId)), errors.collect(cdk.propertyValidator("validationDomain", cdk.validateString)(properties.validationDomain)), errors.wrap('supplied properties not correct for "DomainValidationOptionProperty"');
    }
    function cfnCertificateDomainValidationOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificate_DomainValidationOptionPropertyValidator(properties).assertSuccess(), { DomainName: cdk.stringToCloudFormation(properties.domainName), HostedZoneId: cdk.stringToCloudFormation(properties.hostedZoneId), ValidationDomain: cdk.stringToCloudFormation(properties.validationDomain) }) : properties;
    }
    function CfnCertificateDomainValidationOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("domainName", "DomainName", cfn_parse.FromCloudFormation.getString(properties.DomainName)), ret.addPropertyResult("hostedZoneId", "HostedZoneId", properties.HostedZoneId != null ? cfn_parse.FromCloudFormation.getString(properties.HostedZoneId) : void 0), ret.addPropertyResult("validationDomain", "ValidationDomain", properties.ValidationDomain != null ? cfn_parse.FromCloudFormation.getString(properties.ValidationDomain) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-certificatemanager/lib/public-suffixes.js
var require_public_suffixes = __commonJS({
  "node_modules/aws-cdk-lib/aws-certificatemanager/lib/public-suffixes.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.publicSuffixes = void 0, exports2.publicSuffixes = { ac: { com: {}, edu: {}, gov: {}, net: {}, mil: {}, org: {} }, ad: { nom: {} }, ae: { co: {}, net: {}, org: {}, sch: {}, ac: {}, gov: {}, mil: {}, blogspot: {}, nom: {} }, aero: { aerobatic: {}, aeroclub: {}, aerodrome: {}, agents: {}, aircraft: {}, airline: {}, airport: {}, airtraffic: {}, ambulance: {}, amusement: {}, association: {}, author: {}, ballooning: {}, broker: {}, caa: {}, cargo: {}, catering: {}, certification: {}, championship: {}, charter: {}, civilaviation: {}, club: {}, conference: {}, consultant: {}, consulting: {}, control: {}, council: {}, crew: {}, design: {}, dgca: {}, educator: {}, emergency: {}, engine: {}, engineer: {}, entertainment: {}, equipment: {}, exchange: {}, express: {}, federation: {}, flight: {}, freight: {}, fuel: {}, gliding: {}, government: {}, groundhandling: {}, group: {}, hanggliding: {}, homebuilt: {}, insurance: {}, journal: {}, journalist: {}, leasing: {}, logistics: {}, magazine: {}, maintenance: {}, media: {}, microlight: {}, modelling: {}, navigation: {}, parachuting: {}, paragliding: {}, pilot: {}, press: {}, production: {}, recreation: {}, repbody: {}, res: {}, research: {}, rotorcraft: {}, safety: {}, scientist: {}, services: {}, show: {}, skydiving: {}, software: {}, student: {}, trader: {}, trading: {}, trainer: {}, union: {}, workinggroup: {}, works: {} }, af: { gov: {}, com: {}, org: {}, net: {}, edu: {} }, ag: { com: {}, org: {}, net: {}, co: {}, nom: {} }, ai: { off: {}, com: {}, net: {}, org: {}, nom: {} }, al: { com: {}, edu: {}, gov: {}, mil: {}, net: {}, org: {}, blogspot: {}, nom: {} }, am: { blogspot: {} }, ao: { ed: {}, gv: {}, og: {}, co: {}, pb: {}, it: {} }, aq: {}, ar: { com: { blogspot: {} }, edu: {}, gob: {}, gov: {}, int: {}, mil: {}, musica: {}, net: {}, org: {}, tur: {} }, arpa: { e164: {}, ip6: {}, iris: {}, uri: {}, urn: {} }, as: { gov: {} }, asia: { cloudns: {} }, at: { ac: {}, co: { blogspot: {} }, gv: {}, or: {}, futurehosting: {}, futuremailing: {}, biz: {}, info: {}, priv: {}, "12hp": {}, "2ix": {}, "4lima": {} }, au: { com: { blogspot: {} }, net: {}, org: {}, edu: { act: {}, nsw: {}, nt: {}, qld: {}, sa: {}, tas: {}, vic: {}, wa: {} }, gov: { qld: {}, sa: {}, tas: {}, vic: {}, wa: {} }, asn: {}, id: {}, info: {}, conf: {}, oz: {}, act: {}, nsw: {}, nt: {}, qld: {}, sa: {}, tas: {}, vic: {}, wa: {} }, aw: { com: {} }, ax: {}, az: { com: {}, net: {}, int: {}, gov: {}, org: {}, edu: {}, info: {}, pp: {}, mil: {}, name: {}, pro: {}, biz: {} }, ba: { com: {}, edu: {}, gov: {}, mil: {}, net: {}, org: {}, blogspot: {} }, bb: { biz: {}, co: {}, com: {}, edu: {}, gov: {}, info: {}, net: {}, org: {}, store: {}, tv: {} }, be: { ac: {}, webhosting: {}, blogspot: {} }, bf: { gov: {} }, bg: { a: {}, b: {}, c: {}, d: {}, e: {}, f: {}, g: {}, h: {}, i: {}, j: {}, k: {}, l: {}, m: {}, n: {}, o: {}, p: {}, q: {}, r: {}, s: {}, t: {}, u: {}, v: {}, w: {}, x: {}, y: {}, z: {}, 0: {}, 1: {}, 2: {}, 3: {}, 4: {}, 5: {}, 6: {}, 7: {}, 8: {}, 9: {}, blogspot: {}, barsy: {} }, bh: { com: {}, edu: {}, net: {}, org: {}, gov: {} }, bi: { co: {}, com: {}, edu: {}, or: {}, org: {} }, biz: { cloudns: {}, dyndns: {}, selfip: {}, webhop: {}, mmafan: {}, myftp: {}, dscloud: {} }, bj: { asso: {}, barreau: {}, gouv: {}, blogspot: {} }, bm: { com: {}, edu: {}, gov: {}, net: {}, org: {} }, bo: { com: {}, edu: {}, gob: {}, int: {}, org: {}, net: {}, mil: {}, tv: {}, web: {}, academia: {}, agro: {}, arte: {}, blog: {}, bolivia: {}, ciencia: {}, cooperativa: {}, democracia: {}, deporte: {}, ecologia: {}, economia: {}, empresa: {}, indigena: {}, industria: {}, info: {}, medicina: {}, movimiento: {}, musica: {}, natural: {}, nombre: {}, noticias: {}, patria: {}, politica: {}, profesional: {}, plurinacional: {}, pueblo: {}, revista: {}, salud: {}, tecnologia: {}, tksat: {}, transporte: {}, wiki: {} }, br: { "9guacu": {}, abc: {}, adm: {}, adv: {}, agr: {}, aju: {}, am: {}, anani: {}, aparecida: {}, arq: {}, art: {}, ato: {}, b: {}, barueri: {}, belem: {}, bhz: {}, bio: {}, blog: {}, bmd: {}, boavista: {}, bsb: {}, campinagrande: {}, campinas: {}, caxias: {}, cim: {}, cng: {}, cnt: {}, com: { blogspot: {} }, contagem: {}, coop: {}, cri: {}, cuiaba: {}, curitiba: {}, def: {}, ecn: {}, eco: {}, edu: {}, emp: {}, eng: {}, esp: {}, etc: {}, eti: {}, far: {}, feira: {}, flog: {}, floripa: {}, fm: {}, fnd: {}, fortal: {}, fot: {}, foz: {}, fst: {}, g12: {}, ggf: {}, goiania: {}, gov: { ac: {}, al: {}, am: {}, ap: {}, ba: {}, ce: {}, df: {}, es: {}, go: {}, ma: {}, mg: {}, ms: {}, mt: {}, pa: {}, pb: {}, pe: {}, pi: {}, pr: {}, rj: {}, rn: {}, ro: {}, rr: {}, rs: {}, sc: {}, se: {}, sp: {}, to: {} }, gru: {}, imb: {}, ind: {}, inf: {}, jab: {}, jampa: {}, jdf: {}, joinville: {}, jor: {}, jus: {}, leg: { ac: {}, al: {}, am: {}, ap: {}, ba: {}, ce: {}, df: {}, es: {}, go: {}, ma: {}, mg: {}, ms: {}, mt: {}, pa: {}, pb: {}, pe: {}, pi: {}, pr: {}, rj: {}, rn: {}, ro: {}, rr: {}, rs: {}, sc: {}, se: {}, sp: {}, to: {} }, lel: {}, londrina: {}, macapa: {}, maceio: {}, manaus: {}, maringa: {}, mat: {}, med: {}, mil: {}, morena: {}, mp: {}, mus: {}, natal: {}, net: {}, niteroi: {}, not: {}, ntr: {}, odo: {}, org: {}, osasco: {}, palmas: {}, poa: {}, ppg: {}, pro: {}, psc: {}, psi: {}, pvh: {}, qsl: {}, radio: {}, rec: {}, recife: {}, ribeirao: {}, rio: {}, riobranco: {}, riopreto: {}, salvador: {}, sampa: {}, santamaria: {}, santoandre: {}, saobernardo: {}, saogonca: {}, sjc: {}, slg: {}, slz: {}, sorocaba: {}, srv: {}, taxi: {}, teo: {}, the: {}, tmp: {}, trd: {}, tur: {}, tv: {}, udi: {}, vet: {}, vix: {}, vlog: {}, wiki: {}, zlg: {} }, bs: { com: {}, net: {}, org: {}, edu: {}, gov: {}, we: {} }, bt: { com: {}, edu: {}, gov: {}, net: {}, org: {} }, bv: {}, bw: { co: {}, org: {} }, by: { gov: {}, mil: {}, com: { blogspot: {} }, of: {}, nym: {} }, bz: { com: {}, net: {}, org: {}, edu: {}, gov: {}, za: {}, nym: {} }, ca: { ab: {}, bc: {}, mb: {}, nb: {}, nf: {}, nl: {}, ns: {}, nt: {}, nu: {}, on: {}, pe: {}, qc: {}, sk: {}, yk: {}, gc: {}, co: {}, blogspot: {} }, cat: {}, cc: { cloudns: {}, ftpaccess: {}, myphotos: {}, scrapping: {}, twmail: {}, fantasyleague: {} }, cd: { gov: {} }, cf: { blogspot: {} }, cg: {}, ch: { square7: {}, blogspot: {}, gotdns: {}, "12hp": {}, "2ix": {}, "4lima": {} }, ci: { org: {}, or: {}, com: {}, co: {}, edu: {}, ed: {}, ac: {}, net: {}, go: {}, asso: {}, int: {}, presse: {}, md: {}, gouv: {} }, cl: { gov: {}, gob: {}, co: {}, mil: {}, blogspot: {}, nom: {} }, cm: { co: {}, com: {}, gov: {}, net: {} }, cn: { ac: {}, com: {}, edu: {}, gov: {}, net: {}, org: {}, mil: {}, ah: {}, bj: {}, cq: {}, fj: {}, gd: {}, gs: {}, gz: {}, gx: {}, ha: {}, hb: {}, he: {}, hi: {}, hl: {}, hn: {}, jl: {}, js: {}, jx: {}, ln: {}, nm: {}, nx: {}, qh: {}, sc: {}, sd: {}, sh: {}, sn: {}, sx: {}, tj: {}, xj: {}, xz: {}, yn: {}, zj: {}, hk: {}, mo: {}, tw: {} }, co: { arts: {}, com: { blogspot: {} }, edu: {}, firm: {}, gov: {}, info: {}, int: {}, mil: {}, net: {}, nom: {}, org: {}, rec: {}, web: {}, nodum: {} }, com: { elasticbeanstalk: {}, amazonaws: { s3: {} }, myasustor: {}, betainabox: {}, bplaced: {}, ar: {}, br: {}, cn: {}, de: {}, eu: {}, gb: {}, hu: {}, jpn: {}, kr: {}, mex: {}, no: {}, qc: {}, ru: {}, sa: {}, uk: {}, us: {}, uy: {}, za: {}, africa: {}, gr: {}, co: {}, xenapponazure: {}, jdevcloud: {}, wpdevcloud: {}, cloudcontrolled: {}, cloudcontrolapp: {}, drayddns: {}, dreamhosters: {}, mydrobo: {}, blogdns: {}, cechire: {}, dnsalias: {}, dnsdojo: {}, doesntexist: {}, dontexist: {}, doomdns: {}, dynalias: {}, getmyip: {}, gotdns: {}, homelinux: {}, homeunix: {}, iamallama: {}, issmarterthanyou: {}, likescandy: {}, selfip: {}, servebbs: {}, writesthisblog: {}, ddnsfree: {}, ddnsgeek: {}, giize: {}, gleeze: {}, kozow: {}, loseyourip: {}, ooguy: {}, theworkpc: {}, mytuleap: {}, fbsbx: { apps: {} }, firebaseapp: {}, flynnhub: {}, freeboxos: {}, githubusercontent: {}, appspot: {}, blogspot: {}, codespot: {}, googleapis: {}, googlecode: {}, pagespeedmobilizer: {}, publishproxy: {}, withgoogle: {}, withyoutube: {}, herokuapp: {}, herokussl: {}, myravendb: {}, pixolino: {}, barsyonline: {}, meteorapp: { eu: {} }, bitballoon: {}, netlify: {}, "4u": {}, nfshost: {}, blogsyte: {}, ciscofreak: {}, damnserver: {}, ditchyourip: {}, dnsiskinky: {}, dynns: {}, geekgalaxy: {}, homesecuritymac: {}, homesecuritypc: {}, myactivedirectory: {}, mysecuritycamera: {}, onthewifi: {}, point2this: {}, quicksytes: {}, securitytactics: {}, serveexchange: {}, servehumour: {}, servep2p: {}, servesarcasm: {}, stufftoread: {}, unusualperson: {}, workisboring: {}, "3utilities": {}, ddnsking: {}, myvnc: {}, servebeer: {}, servecounterstrike: {}, serveftp: {}, servegame: {}, servehalflife: {}, servehttp: {}, serveirc: {}, servemp3: {}, servepics: {}, servequake: {}, operaunite: {}, outsystemscloud: {}, ownprovider: {}, pgfog: {}, pagefrontapp: {}, gotpantheon: {}, prgmr: { xen: {} }, qa2: {}, myqnapcloud: {}, rackmaze: {}, rhcloud: {}, logoip: {}, scrysec: {}, myshopblocks: {}, "1kapp": {}, appchizi: {}, applinzi: {}, sinaapp: {}, vipsinaapp: {}, dsmynas: {}, familyds: {}, bloxcms: {}, hk: {}, remotewd: {}, xnbay: { u2: {} }, yolasite: {} }, coop: {}, cr: { ac: {}, co: {}, ed: {}, fi: {}, go: {}, or: {}, sa: {} }, cu: { com: {}, edu: {}, org: {}, net: {}, gov: {}, inf: {} }, cv: { blogspot: {} }, cw: { com: {}, edu: {}, net: {}, org: {} }, cx: { gov: {}, ath: {}, info: {} }, cy: { ac: {}, biz: {}, com: { blogspot: {} }, ekloges: {}, gov: {}, ltd: {}, name: {}, net: {}, org: {}, parliament: {}, press: {}, pro: {}, tm: {} }, cz: { co: {}, realm: {}, e4: {}, blogspot: {}, metacentrum: { cloud: {}, custom: {} }, muni: { cloud: { flt: {}, usr: {} } } }, de: { bplaced: {}, square7: {}, com: {}, cosidns: { dyn: {} }, dnsupdater: {}, dnshome: {}, fuettertdasnetz: {}, isteingeek: {}, istmein: {}, lebtimnetz: {}, leitungsen: {}, traeumtgerade: {}, ddnss: { dyn: {}, dyndns: {} }, dyndns1: {}, goip: {}, blogspot: {}, keymachine: {}, barsy: {}, logoip: {}, spdns: {}, speedpartner: { customer: {} }, "12hp": {}, "2ix": {}, "4lima": {}, draydns: {}, dynvpn: {} }, dj: {}, dk: { biz: {}, co: {}, firm: {}, reg: {}, store: {}, blogspot: {} }, dm: { com: {}, net: {}, org: {}, edu: {}, gov: {} }, do: { art: {}, com: {}, edu: {}, gob: {}, gov: {}, mil: {}, net: {}, org: {}, sld: {}, web: {} }, dz: { com: {}, org: {}, net: {}, gov: {}, edu: {}, asso: {}, pol: {}, art: {} }, ec: { com: {}, info: {}, net: {}, fin: {}, k12: {}, med: {}, pro: {}, org: {}, edu: {}, gov: {}, gob: {}, mil: {} }, edu: {}, ee: { edu: {}, gov: {}, riik: {}, lib: {}, med: {}, com: { blogspot: {} }, pri: {}, aip: {}, org: {}, fie: {} }, eg: { com: { blogspot: {} }, edu: {}, eun: {}, gov: {}, mil: {}, name: {}, net: {}, org: {}, sci: {} }, es: { com: { blogspot: {} }, nom: {}, org: {}, gob: {}, edu: {} }, et: { com: {}, gov: {}, org: {}, edu: {}, biz: {}, name: {}, info: {}, net: {} }, eu: { mycd: {}, cloudns: {}, barsy: {}, wellbeingzone: {}, spdns: {}, diskstation: {} }, fi: { aland: {}, dy: {}, blogspot: {}, iki: {} }, fm: {}, fo: {}, fr: { com: {}, asso: {}, nom: {}, prd: {}, presse: {}, tm: {}, aeroport: {}, assedic: {}, avocat: {}, avoues: {}, cci: {}, chambagri: {}, gouv: {}, greta: {}, medecin: {}, notaires: {}, pharmacien: {}, port: {}, veterinaire: {}, fbxos: {}, freeboxos: {}, blogspot: {} }, ga: {}, gb: {}, gd: { nom: {} }, ge: { com: {}, edu: {}, gov: {}, org: {}, mil: {}, net: {}, pvt: {} }, gf: {}, gg: { co: {}, net: {}, org: {}, cya: {} }, gh: { com: {}, edu: {}, gov: {}, org: {}, mil: {} }, gi: { com: {}, ltd: {}, gov: {}, mod: {}, edu: {}, org: {} }, gl: { co: {}, com: {}, edu: {}, net: {}, org: {}, nom: {} }, gm: {}, gn: { ac: {}, com: {}, edu: {}, gov: {}, org: {}, net: {} }, gov: {}, gp: { com: {}, net: {}, mobi: {}, edu: {}, org: {}, asso: {} }, gq: {}, gr: { com: {}, edu: {}, net: {}, org: {}, gov: {}, blogspot: {}, nym: {} }, gs: {}, gt: { com: {}, edu: {}, gob: {}, ind: {}, mil: {}, net: {}, org: {}, nom: {} }, gw: {}, gy: { co: {}, com: {}, edu: {}, gov: {}, net: {}, org: {} }, hk: { com: {}, edu: {}, gov: {}, idv: {}, net: {}, org: {}, blogspot: {}, ltd: {}, inc: {} }, hm: {}, hn: { com: {}, edu: {}, org: {}, net: {}, mil: {}, gob: {}, nom: {} }, hr: { iz: {}, from: {}, name: {}, com: {}, blogspot: {} }, ht: { com: {}, shop: {}, firm: {}, info: {}, adult: {}, net: {}, pro: {}, org: {}, med: {}, art: {}, coop: {}, pol: {}, asso: {}, edu: {}, rel: {}, gouv: {}, perso: {} }, hu: { co: {}, info: {}, org: {}, priv: {}, sport: {}, tm: {}, 2e3: {}, agrar: {}, bolt: {}, casino: {}, city: {}, erotica: {}, erotika: {}, film: {}, forum: {}, games: {}, hotel: {}, ingatlan: {}, jogasz: {}, konyvelo: {}, lakas: {}, media: {}, news: {}, reklam: {}, sex: {}, shop: {}, suli: {}, szex: {}, tozsde: {}, utazas: {}, video: {}, blogspot: {} }, id: { ac: {}, biz: {}, co: { blogspot: {} }, desa: {}, go: {}, mil: {}, my: {}, net: {}, or: {}, sch: {}, web: {} }, ie: { gov: {}, blogspot: {} }, il: { ac: {}, co: { blogspot: {} }, gov: {}, idf: {}, k12: {}, muni: {}, net: {}, org: {} }, im: { ac: {}, co: { ltd: {}, plc: {} }, com: {}, net: {}, org: {}, tt: {}, tv: {}, ro: {}, nom: {} }, in: { co: {}, firm: {}, net: {}, org: {}, gen: {}, ind: {}, nic: {}, ac: {}, edu: {}, res: {}, gov: {}, mil: {}, cloudns: {}, blogspot: {}, barsy: {} }, info: { cloudns: {}, dyndns: {}, knowsitall: {}, selfip: {}, webhop: {}, nsupdate: {}, dvrcam: {}, ilovecollege: {} }, int: { eu: {} }, io: { com: {}, backplaneapp: {}, boxfuse: {}, browsersafetymark: {}, cleverapps: {}, dedyn: {}, drud: {}, definima: {}, enonic: { customer: {} }, github: {}, gitlab: {}, azurecontainer: {}, ngrok: {}, nodeart: { stage: {} }, nodum: {}, nid: {}, pantheonsite: {}, protonet: {}, vaporcloud: {}, resindevice: {}, resinstaging: { devices: {} }, hzc: {}, sandcats: {}, shiftedit: {}, lair: { apps: {} }, spacekit: {}, thingdust: { dev: { cust: {} }, disrec: { cust: {} }, prod: { cust: {} }, testing: { cust: {} } }, 2038: {}, wedeploy: {} }, iq: { gov: {}, edu: {}, mil: {}, com: {}, org: {}, net: {} }, ir: { ac: {}, co: {}, gov: {}, id: {}, net: {}, org: {}, sch: {} }, is: { net: {}, com: {}, edu: {}, gov: {}, org: {}, int: {}, cupcake: {}, blogspot: {} }, it: { gov: {}, edu: {}, abr: {}, abruzzo: {}, aostavalley: {}, bas: {}, basilicata: {}, cal: {}, calabria: {}, cam: {}, campania: {}, emiliaromagna: {}, emr: {}, friulivegiulia: {}, friuliveneziagiulia: {}, friulivgiulia: {}, fvg: {}, laz: {}, lazio: {}, lig: {}, liguria: {}, lom: {}, lombardia: {}, lombardy: {}, lucania: {}, mar: {}, marche: {}, mol: {}, molise: {}, piedmont: {}, piemonte: {}, pmn: {}, pug: {}, puglia: {}, sar: {}, sardegna: {}, sardinia: {}, sic: {}, sicilia: {}, sicily: {}, taa: {}, tos: {}, toscana: {}, trentinoaadige: {}, trentinoaltoadige: {}, trentinostirol: {}, trentinosudtirol: {}, trentinosuedtirol: {}, tuscany: {}, umb: {}, umbria: {}, valdaosta: {}, valleaosta: {}, valledaosta: {}, valleeaoste: {}, vao: {}, vda: {}, ven: {}, veneto: {}, ag: {}, agrigento: {}, al: {}, alessandria: {}, altoadige: {}, an: {}, ancona: {}, andriabarlettatrani: {}, andriatranibarletta: {}, ao: {}, aosta: {}, aoste: {}, ap: {}, aq: {}, aquila: {}, ar: {}, arezzo: {}, ascolipiceno: {}, asti: {}, at: {}, av: {}, avellino: {}, ba: {}, balsan: {}, bari: {}, barlettatraniandria: {}, belluno: {}, benevento: {}, bergamo: {}, bg: {}, bi: {}, biella: {}, bl: {}, bn: {}, bo: {}, bologna: {}, bolzano: {}, bozen: {}, br: {}, brescia: {}, brindisi: {}, bs: {}, bt: {}, bz: {}, ca: {}, cagliari: {}, caltanissetta: {}, campidanomedio: {}, campobasso: {}, carboniaiglesias: {}, carraramassa: {}, caserta: {}, catania: {}, catanzaro: {}, cb: {}, ce: {}, cesenaforli: {}, ch: {}, chieti: {}, ci: {}, cl: {}, cn: {}, co: {}, como: {}, cosenza: {}, cr: {}, cremona: {}, crotone: {}, cs: {}, ct: {}, cuneo: {}, cz: {}, dellogliastra: {}, en: {}, enna: {}, fc: {}, fe: {}, fermo: {}, ferrara: {}, fg: {}, fi: {}, firenze: {}, florence: {}, fm: {}, foggia: {}, forlicesena: {}, fr: {}, frosinone: {}, ge: {}, genoa: {}, genova: {}, go: {}, gorizia: {}, gr: {}, grosseto: {}, iglesiascarbonia: {}, im: {}, imperia: {}, is: {}, isernia: {}, kr: {}, laquila: {}, laspezia: {}, latina: {}, lc: {}, le: {}, lecce: {}, lecco: {}, li: {}, livorno: {}, lo: {}, lodi: {}, lt: {}, lu: {}, lucca: {}, macerata: {}, mantova: {}, massacarrara: {}, matera: {}, mb: {}, mc: {}, me: {}, mediocampidano: {}, messina: {}, mi: {}, milan: {}, milano: {}, mn: {}, mo: {}, modena: {}, monza: {}, monzabrianza: {}, monzaebrianza: {}, monzaedellabrianza: {}, ms: {}, mt: {}, na: {}, naples: {}, napoli: {}, no: {}, novara: {}, nu: {}, nuoro: {}, og: {}, ogliastra: {}, olbiatempio: {}, or: {}, oristano: {}, ot: {}, pa: {}, padova: {}, padua: {}, palermo: {}, parma: {}, pavia: {}, pc: {}, pd: {}, pe: {}, perugia: {}, pesarourbino: {}, pescara: {}, pg: {}, pi: {}, piacenza: {}, pisa: {}, pistoia: {}, pn: {}, po: {}, pordenone: {}, potenza: {}, pr: {}, prato: {}, pt: {}, pu: {}, pv: {}, pz: {}, ra: {}, ragusa: {}, ravenna: {}, rc: {}, re: {}, reggiocalabria: {}, reggioemilia: {}, rg: {}, ri: {}, rieti: {}, rimini: {}, rm: {}, rn: {}, ro: {}, roma: {}, rome: {}, rovigo: {}, sa: {}, salerno: {}, sassari: {}, savona: {}, si: {}, siena: {}, siracusa: {}, so: {}, sondrio: {}, sp: {}, sr: {}, ss: {}, suedtirol: {}, sv: {}, ta: {}, taranto: {}, te: {}, tempioolbia: {}, teramo: {}, terni: {}, tn: {}, to: {}, torino: {}, tp: {}, tr: {}, traniandriabarletta: {}, tranibarlettaandria: {}, trapani: {}, trentino: {}, trento: {}, treviso: {}, trieste: {}, ts: {}, turin: {}, tv: {}, ud: {}, udine: {}, urbinopesaro: {}, va: {}, varese: {}, vb: {}, vc: {}, ve: {}, venezia: {}, venice: {}, verbania: {}, vercelli: {}, verona: {}, vi: {}, vibovalentia: {}, vicenza: {}, viterbo: {}, vr: {}, vs: {}, vt: {}, vv: {}, blogspot: {} }, je: { co: {}, net: {}, org: {} }, jo: { com: {}, org: {}, net: {}, edu: {}, sch: {}, gov: {}, mil: {}, name: {} }, jobs: {}, jp: { ac: {}, ad: {}, co: {}, ed: {}, go: {}, gr: {}, lg: {}, ne: {}, or: {}, aichi: { aisai: {}, ama: {}, anjo: {}, asuke: {}, chiryu: {}, chita: {}, fuso: {}, gamagori: {}, handa: {}, hazu: {}, hekinan: {}, higashiura: {}, ichinomiya: {}, inazawa: {}, inuyama: {}, isshiki: {}, iwakura: {}, kanie: {}, kariya: {}, kasugai: {}, kira: {}, kiyosu: {}, komaki: {}, konan: {}, kota: {}, mihama: {}, miyoshi: {}, nishio: {}, nisshin: {}, obu: {}, oguchi: {}, oharu: {}, okazaki: {}, owariasahi: {}, seto: {}, shikatsu: {}, shinshiro: {}, shitara: {}, tahara: {}, takahama: {}, tobishima: {}, toei: {}, togo: {}, tokai: {}, tokoname: {}, toyoake: {}, toyohashi: {}, toyokawa: {}, toyone: {}, toyota: {}, tsushima: {}, yatomi: {} }, akita: { akita: {}, daisen: {}, fujisato: {}, gojome: {}, hachirogata: {}, happou: {}, higashinaruse: {}, honjo: {}, honjyo: {}, ikawa: {}, kamikoani: {}, kamioka: {}, katagami: {}, kazuno: {}, kitaakita: {}, kosaka: {}, kyowa: {}, misato: {}, mitane: {}, moriyoshi: {}, nikaho: {}, noshiro: {}, odate: {}, oga: {}, ogata: {}, semboku: {}, yokote: {}, yurihonjo: {} }, aomori: { aomori: {}, gonohe: {}, hachinohe: {}, hashikami: {}, hiranai: {}, hirosaki: {}, itayanagi: {}, kuroishi: {}, misawa: {}, mutsu: {}, nakadomari: {}, noheji: {}, oirase: {}, owani: {}, rokunohe: {}, sannohe: {}, shichinohe: {}, shingo: {}, takko: {}, towada: {}, tsugaru: {}, tsuruta: {} }, chiba: { abiko: {}, asahi: {}, chonan: {}, chosei: {}, choshi: {}, chuo: {}, funabashi: {}, futtsu: {}, hanamigawa: {}, ichihara: {}, ichikawa: {}, ichinomiya: {}, inzai: {}, isumi: {}, kamagaya: {}, kamogawa: {}, kashiwa: {}, katori: {}, katsuura: {}, kimitsu: {}, kisarazu: {}, kozaki: {}, kujukuri: {}, kyonan: {}, matsudo: {}, midori: {}, mihama: {}, minamiboso: {}, mobara: {}, mutsuzawa: {}, nagara: {}, nagareyama: {}, narashino: {}, narita: {}, noda: {}, oamishirasato: {}, omigawa: {}, onjuku: {}, otaki: {}, sakae: {}, sakura: {}, shimofusa: {}, shirako: {}, shiroi: {}, shisui: {}, sodegaura: {}, sosa: {}, tako: {}, tateyama: {}, togane: {}, tohnosho: {}, tomisato: {}, urayasu: {}, yachimata: {}, yachiyo: {}, yokaichiba: {}, yokoshibahikari: {}, yotsukaido: {} }, ehime: { ainan: {}, honai: {}, ikata: {}, imabari: {}, iyo: {}, kamijima: {}, kihoku: {}, kumakogen: {}, masaki: {}, matsuno: {}, matsuyama: {}, namikata: {}, niihama: {}, ozu: {}, saijo: {}, seiyo: {}, shikokuchuo: {}, tobe: {}, toon: {}, uchiko: {}, uwajima: {}, yawatahama: {} }, fukui: { echizen: {}, eiheiji: {}, fukui: {}, ikeda: {}, katsuyama: {}, mihama: {}, minamiechizen: {}, obama: {}, ohi: {}, ono: {}, sabae: {}, sakai: {}, takahama: {}, tsuruga: {}, wakasa: {} }, fukuoka: { ashiya: {}, buzen: {}, chikugo: {}, chikuho: {}, chikujo: {}, chikushino: {}, chikuzen: {}, chuo: {}, dazaifu: {}, fukuchi: {}, hakata: {}, higashi: {}, hirokawa: {}, hisayama: {}, iizuka: {}, inatsuki: {}, kaho: {}, kasuga: {}, kasuya: {}, kawara: {}, keisen: {}, koga: {}, kurate: {}, kurogi: {}, kurume: {}, minami: {}, miyako: {}, miyama: {}, miyawaka: {}, mizumaki: {}, munakata: {}, nakagawa: {}, nakama: {}, nishi: {}, nogata: {}, ogori: {}, okagaki: {}, okawa: {}, oki: {}, omuta: {}, onga: {}, onojo: {}, oto: {}, saigawa: {}, sasaguri: {}, shingu: {}, shinyoshitomi: {}, shonai: {}, soeda: {}, sue: {}, tachiarai: {}, tagawa: {}, takata: {}, toho: {}, toyotsu: {}, tsuiki: {}, ukiha: {}, umi: {}, usui: {}, yamada: {}, yame: {}, yanagawa: {}, yukuhashi: {} }, fukushima: { aizubange: {}, aizumisato: {}, aizuwakamatsu: {}, asakawa: {}, bandai: {}, date: {}, fukushima: {}, furudono: {}, futaba: {}, hanawa: {}, higashi: {}, hirata: {}, hirono: {}, iitate: {}, inawashiro: {}, ishikawa: {}, iwaki: {}, izumizaki: {}, kagamiishi: {}, kaneyama: {}, kawamata: {}, kitakata: {}, kitashiobara: {}, koori: {}, koriyama: {}, kunimi: {}, miharu: {}, mishima: {}, namie: {}, nango: {}, nishiaizu: {}, nishigo: {}, okuma: {}, omotego: {}, ono: {}, otama: {}, samegawa: {}, shimogo: {}, shirakawa: {}, showa: {}, soma: {}, sukagawa: {}, taishin: {}, tamakawa: {}, tanagura: {}, tenei: {}, yabuki: {}, yamato: {}, yamatsuri: {}, yanaizu: {}, yugawa: {} }, gifu: { anpachi: {}, ena: {}, gifu: {}, ginan: {}, godo: {}, gujo: {}, hashima: {}, hichiso: {}, hida: {}, higashishirakawa: {}, ibigawa: {}, ikeda: {}, kakamigahara: {}, kani: {}, kasahara: {}, kasamatsu: {}, kawaue: {}, kitagata: {}, mino: {}, minokamo: {}, mitake: {}, mizunami: {}, motosu: {}, nakatsugawa: {}, ogaki: {}, sakahogi: {}, seki: {}, sekigahara: {}, shirakawa: {}, tajimi: {}, takayama: {}, tarui: {}, toki: {}, tomika: {}, wanouchi: {}, yamagata: {}, yaotsu: {}, yoro: {} }, gunma: { annaka: {}, chiyoda: {}, fujioka: {}, higashiagatsuma: {}, isesaki: {}, itakura: {}, kanna: {}, kanra: {}, katashina: {}, kawaba: {}, kiryu: {}, kusatsu: {}, maebashi: {}, meiwa: {}, midori: {}, minakami: {}, naganohara: {}, nakanojo: {}, nanmoku: {}, numata: {}, oizumi: {}, ora: {}, ota: {}, shibukawa: {}, shimonita: {}, shinto: {}, showa: {}, takasaki: {}, takayama: {}, tamamura: {}, tatebayashi: {}, tomioka: {}, tsukiyono: {}, tsumagoi: {}, ueno: {}, yoshioka: {} }, hiroshima: { asaminami: {}, daiwa: {}, etajima: {}, fuchu: {}, fukuyama: {}, hatsukaichi: {}, higashihiroshima: {}, hongo: {}, jinsekikogen: {}, kaita: {}, kui: {}, kumano: {}, kure: {}, mihara: {}, miyoshi: {}, naka: {}, onomichi: {}, osakikamijima: {}, otake: {}, saka: {}, sera: {}, seranishi: {}, shinichi: {}, shobara: {}, takehara: {} }, hokkaido: { abashiri: {}, abira: {}, aibetsu: {}, akabira: {}, akkeshi: {}, asahikawa: {}, ashibetsu: {}, ashoro: {}, assabu: {}, atsuma: {}, bibai: {}, biei: {}, bifuka: {}, bihoro: {}, biratori: {}, chippubetsu: {}, chitose: {}, date: {}, ebetsu: {}, embetsu: {}, eniwa: {}, erimo: {}, esan: {}, esashi: {}, fukagawa: {}, fukushima: {}, furano: {}, furubira: {}, haboro: {}, hakodate: {}, hamatonbetsu: {}, hidaka: {}, higashikagura: {}, higashikawa: {}, hiroo: {}, hokuryu: {}, hokuto: {}, honbetsu: {}, horokanai: {}, horonobe: {}, ikeda: {}, imakane: {}, ishikari: {}, iwamizawa: {}, iwanai: {}, kamifurano: {}, kamikawa: {}, kamishihoro: {}, kamisunagawa: {}, kamoenai: {}, kayabe: {}, kembuchi: {}, kikonai: {}, kimobetsu: {}, kitahiroshima: {}, kitami: {}, kiyosato: {}, koshimizu: {}, kunneppu: {}, kuriyama: {}, kuromatsunai: {}, kushiro: {}, kutchan: {}, kyowa: {}, mashike: {}, matsumae: {}, mikasa: {}, minamifurano: {}, mombetsu: {}, moseushi: {}, mukawa: {}, muroran: {}, naie: {}, nakagawa: {}, nakasatsunai: {}, nakatombetsu: {}, nanae: {}, nanporo: {}, nayoro: {}, nemuro: {}, niikappu: {}, niki: {}, nishiokoppe: {}, noboribetsu: {}, numata: {}, obihiro: {}, obira: {}, oketo: {}, okoppe: {}, otaru: {}, otobe: {}, otofuke: {}, otoineppu: {}, oumu: {}, ozora: {}, pippu: {}, rankoshi: {}, rebun: {}, rikubetsu: {}, rishiri: {}, rishirifuji: {}, saroma: {}, sarufutsu: {}, shakotan: {}, shari: {}, shibecha: {}, shibetsu: {}, shikabe: {}, shikaoi: {}, shimamaki: {}, shimizu: {}, shimokawa: {}, shinshinotsu: {}, shintoku: {}, shiranuka: {}, shiraoi: {}, shiriuchi: {}, sobetsu: {}, sunagawa: {}, taiki: {}, takasu: {}, takikawa: {}, takinoue: {}, teshikaga: {}, tobetsu: {}, tohma: {}, tomakomai: {}, tomari: {}, toya: {}, toyako: {}, toyotomi: {}, toyoura: {}, tsubetsu: {}, tsukigata: {}, urakawa: {}, urausu: {}, uryu: {}, utashinai: {}, wakkanai: {}, wassamu: {}, yakumo: {}, yoichi: {} }, hyogo: { aioi: {}, akashi: {}, ako: {}, amagasaki: {}, aogaki: {}, asago: {}, ashiya: {}, awaji: {}, fukusaki: {}, goshiki: {}, harima: {}, himeji: {}, ichikawa: {}, inagawa: {}, itami: {}, kakogawa: {}, kamigori: {}, kamikawa: {}, kasai: {}, kasuga: {}, kawanishi: {}, miki: {}, minamiawaji: {}, nishinomiya: {}, nishiwaki: {}, ono: {}, sanda: {}, sannan: {}, sasayama: {}, sayo: {}, shingu: {}, shinonsen: {}, shiso: {}, sumoto: {}, taishi: {}, taka: {}, takarazuka: {}, takasago: {}, takino: {}, tamba: {}, tatsuno: {}, toyooka: {}, yabu: {}, yashiro: {}, yoka: {}, yokawa: {} }, ibaraki: { ami: {}, asahi: {}, bando: {}, chikusei: {}, daigo: {}, fujishiro: {}, hitachi: {}, hitachinaka: {}, hitachiomiya: {}, hitachiota: {}, ibaraki: {}, ina: {}, inashiki: {}, itako: {}, iwama: {}, joso: {}, kamisu: {}, kasama: {}, kashima: {}, kasumigaura: {}, koga: {}, miho: {}, mito: {}, moriya: {}, naka: {}, namegata: {}, oarai: {}, ogawa: {}, omitama: {}, ryugasaki: {}, sakai: {}, sakuragawa: {}, shimodate: {}, shimotsuma: {}, shirosato: {}, sowa: {}, suifu: {}, takahagi: {}, tamatsukuri: {}, tokai: {}, tomobe: {}, tone: {}, toride: {}, tsuchiura: {}, tsukuba: {}, uchihara: {}, ushiku: {}, yachiyo: {}, yamagata: {}, yawara: {}, yuki: {} }, ishikawa: { anamizu: {}, hakui: {}, hakusan: {}, kaga: {}, kahoku: {}, kanazawa: {}, kawakita: {}, komatsu: {}, nakanoto: {}, nanao: {}, nomi: {}, nonoichi: {}, noto: {}, shika: {}, suzu: {}, tsubata: {}, tsurugi: {}, uchinada: {}, wajima: {} }, iwate: { fudai: {}, fujisawa: {}, hanamaki: {}, hiraizumi: {}, hirono: {}, ichinohe: {}, ichinoseki: {}, iwaizumi: {}, iwate: {}, joboji: {}, kamaishi: {}, kanegasaki: {}, karumai: {}, kawai: {}, kitakami: {}, kuji: {}, kunohe: {}, kuzumaki: {}, miyako: {}, mizusawa: {}, morioka: {}, ninohe: {}, noda: {}, ofunato: {}, oshu: {}, otsuchi: {}, rikuzentakata: {}, shiwa: {}, shizukuishi: {}, sumita: {}, tanohata: {}, tono: {}, yahaba: {}, yamada: {} }, kagawa: { ayagawa: {}, higashikagawa: {}, kanonji: {}, kotohira: {}, manno: {}, marugame: {}, mitoyo: {}, naoshima: {}, sanuki: {}, tadotsu: {}, takamatsu: {}, tonosho: {}, uchinomi: {}, utazu: {}, zentsuji: {} }, kagoshima: { akune: {}, amami: {}, hioki: {}, isa: {}, isen: {}, izumi: {}, kagoshima: {}, kanoya: {}, kawanabe: {}, kinko: {}, kouyama: {}, makurazaki: {}, matsumoto: {}, minamitane: {}, nakatane: {}, nishinoomote: {}, satsumasendai: {}, soo: {}, tarumizu: {}, yusui: {} }, kanagawa: { aikawa: {}, atsugi: {}, ayase: {}, chigasaki: {}, ebina: {}, fujisawa: {}, hadano: {}, hakone: {}, hiratsuka: {}, isehara: {}, kaisei: {}, kamakura: {}, kiyokawa: {}, matsuda: {}, minamiashigara: {}, miura: {}, nakai: {}, ninomiya: {}, odawara: {}, oi: {}, oiso: {}, sagamihara: {}, samukawa: {}, tsukui: {}, yamakita: {}, yamato: {}, yokosuka: {}, yugawara: {}, zama: {}, zushi: {} }, kochi: { aki: {}, geisei: {}, hidaka: {}, higashitsuno: {}, ino: {}, kagami: {}, kami: {}, kitagawa: {}, kochi: {}, mihara: {}, motoyama: {}, muroto: {}, nahari: {}, nakamura: {}, nankoku: {}, nishitosa: {}, niyodogawa: {}, ochi: {}, okawa: {}, otoyo: {}, otsuki: {}, sakawa: {}, sukumo: {}, susaki: {}, tosa: {}, tosashimizu: {}, toyo: {}, tsuno: {}, umaji: {}, yasuda: {}, yusuhara: {} }, kumamoto: { amakusa: {}, arao: {}, aso: {}, choyo: {}, gyokuto: {}, kamiamakusa: {}, kikuchi: {}, kumamoto: {}, mashiki: {}, mifune: {}, minamata: {}, minamioguni: {}, nagasu: {}, nishihara: {}, oguni: {}, ozu: {}, sumoto: {}, takamori: {}, uki: {}, uto: {}, yamaga: {}, yamato: {}, yatsushiro: {} }, kyoto: { ayabe: {}, fukuchiyama: {}, higashiyama: {}, ide: {}, ine: {}, joyo: {}, kameoka: {}, kamo: {}, kita: {}, kizu: {}, kumiyama: {}, kyotamba: {}, kyotanabe: {}, kyotango: {}, maizuru: {}, minami: {}, minamiyamashiro: {}, miyazu: {}, muko: {}, nagaokakyo: {}, nakagyo: {}, nantan: {}, oyamazaki: {}, sakyo: {}, seika: {}, tanabe: {}, uji: {}, ujitawara: {}, wazuka: {}, yamashina: {}, yawata: {} }, mie: { asahi: {}, inabe: {}, ise: {}, kameyama: {}, kawagoe: {}, kiho: {}, kisosaki: {}, kiwa: {}, komono: {}, kumano: {}, kuwana: {}, matsusaka: {}, meiwa: {}, mihama: {}, minamiise: {}, misugi: {}, miyama: {}, nabari: {}, shima: {}, suzuka: {}, tado: {}, taiki: {}, taki: {}, tamaki: {}, toba: {}, tsu: {}, udono: {}, ureshino: {}, watarai: {}, yokkaichi: {} }, miyagi: { furukawa: {}, higashimatsushima: {}, ishinomaki: {}, iwanuma: {}, kakuda: {}, kami: {}, kawasaki: {}, marumori: {}, matsushima: {}, minamisanriku: {}, misato: {}, murata: {}, natori: {}, ogawara: {}, ohira: {}, onagawa: {}, osaki: {}, rifu: {}, semine: {}, shibata: {}, shichikashuku: {}, shikama: {}, shiogama: {}, shiroishi: {}, tagajo: {}, taiwa: {}, tome: {}, tomiya: {}, wakuya: {}, watari: {}, yamamoto: {}, zao: {} }, miyazaki: { aya: {}, ebino: {}, gokase: {}, hyuga: {}, kadogawa: {}, kawaminami: {}, kijo: {}, kitagawa: {}, kitakata: {}, kitaura: {}, kobayashi: {}, kunitomi: {}, kushima: {}, mimata: {}, miyakonojo: {}, miyazaki: {}, morotsuka: {}, nichinan: {}, nishimera: {}, nobeoka: {}, saito: {}, shiiba: {}, shintomi: {}, takaharu: {}, takanabe: {}, takazaki: {}, tsuno: {} }, nagano: { achi: {}, agematsu: {}, anan: {}, aoki: {}, asahi: {}, azumino: {}, chikuhoku: {}, chikuma: {}, chino: {}, fujimi: {}, hakuba: {}, hara: {}, hiraya: {}, iida: {}, iijima: {}, iiyama: {}, iizuna: {}, ikeda: {}, ikusaka: {}, ina: {}, karuizawa: {}, kawakami: {}, kiso: {}, kisofukushima: {}, kitaaiki: {}, komagane: {}, komoro: {}, matsukawa: {}, matsumoto: {}, miasa: {}, minamiaiki: {}, minamimaki: {}, minamiminowa: {}, minowa: {}, miyada: {}, miyota: {}, mochizuki: {}, nagano: {}, nagawa: {}, nagiso: {}, nakagawa: {}, nakano: {}, nozawaonsen: {}, obuse: {}, ogawa: {}, okaya: {}, omachi: {}, omi: {}, ookuwa: {}, ooshika: {}, otaki: {}, otari: {}, sakae: {}, sakaki: {}, saku: {}, sakuho: {}, shimosuwa: {}, shinanomachi: {}, shiojiri: {}, suwa: {}, suzaka: {}, takagi: {}, takamori: {}, takayama: {}, tateshina: {}, tatsuno: {}, togakushi: {}, togura: {}, tomi: {}, ueda: {}, wada: {}, yamagata: {}, yamanouchi: {}, yasaka: {}, yasuoka: {} }, nagasaki: { chijiwa: {}, futsu: {}, goto: {}, hasami: {}, hirado: {}, iki: {}, isahaya: {}, kawatana: {}, kuchinotsu: {}, matsuura: {}, nagasaki: {}, obama: {}, omura: {}, oseto: {}, saikai: {}, sasebo: {}, seihi: {}, shimabara: {}, shinkamigoto: {}, togitsu: {}, tsushima: {}, unzen: {} }, nara: { ando: {}, gose: {}, heguri: {}, higashiyoshino: {}, ikaruga: {}, ikoma: {}, kamikitayama: {}, kanmaki: {}, kashiba: {}, kashihara: {}, katsuragi: {}, kawai: {}, kawakami: {}, kawanishi: {}, koryo: {}, kurotaki: {}, mitsue: {}, miyake: {}, nara: {}, nosegawa: {}, oji: {}, ouda: {}, oyodo: {}, sakurai: {}, sango: {}, shimoichi: {}, shimokitayama: {}, shinjo: {}, soni: {}, takatori: {}, tawaramoto: {}, tenkawa: {}, tenri: {}, uda: {}, yamatokoriyama: {}, yamatotakada: {}, yamazoe: {}, yoshino: {} }, niigata: { aga: {}, agano: {}, gosen: {}, itoigawa: {}, izumozaki: {}, joetsu: {}, kamo: {}, kariwa: {}, kashiwazaki: {}, minamiuonuma: {}, mitsuke: {}, muika: {}, murakami: {}, myoko: {}, nagaoka: {}, niigata: {}, ojiya: {}, omi: {}, sado: {}, sanjo: {}, seiro: {}, seirou: {}, sekikawa: {}, shibata: {}, tagami: {}, tainai: {}, tochio: {}, tokamachi: {}, tsubame: {}, tsunan: {}, uonuma: {}, yahiko: {}, yoita: {}, yuzawa: {} }, oita: { beppu: {}, bungoono: {}, bungotakada: {}, hasama: {}, hiji: {}, himeshima: {}, hita: {}, kamitsue: {}, kokonoe: {}, kuju: {}, kunisaki: {}, kusu: {}, oita: {}, saiki: {}, taketa: {}, tsukumi: {}, usa: {}, usuki: {}, yufu: {} }, okayama: { akaiwa: {}, asakuchi: {}, bizen: {}, hayashima: {}, ibara: {}, kagamino: {}, kasaoka: {}, kibichuo: {}, kumenan: {}, kurashiki: {}, maniwa: {}, misaki: {}, nagi: {}, niimi: {}, nishiawakura: {}, okayama: {}, satosho: {}, setouchi: {}, shinjo: {}, shoo: {}, soja: {}, takahashi: {}, tamano: {}, tsuyama: {}, wake: {}, yakage: {} }, okinawa: { aguni: {}, ginowan: {}, ginoza: {}, gushikami: {}, haebaru: {}, higashi: {}, hirara: {}, iheya: {}, ishigaki: {}, ishikawa: {}, itoman: {}, izena: {}, kadena: {}, kin: {}, kitadaito: {}, kitanakagusuku: {}, kumejima: {}, kunigami: {}, minamidaito: {}, motobu: {}, nago: {}, naha: {}, nakagusuku: {}, nakijin: {}, nanjo: {}, nishihara: {}, ogimi: {}, okinawa: {}, onna: {}, shimoji: {}, taketomi: {}, tarama: {}, tokashiki: {}, tomigusuku: {}, tonaki: {}, urasoe: {}, uruma: {}, yaese: {}, yomitan: {}, yonabaru: {}, yonaguni: {}, zamami: {} }, osaka: { abeno: {}, chihayaakasaka: {}, chuo: {}, daito: {}, fujiidera: {}, habikino: {}, hannan: {}, higashiosaka: {}, higashisumiyoshi: {}, higashiyodogawa: {}, hirakata: {}, ibaraki: {}, ikeda: {}, izumi: {}, izumiotsu: {}, izumisano: {}, kadoma: {}, kaizuka: {}, kanan: {}, kashiwara: {}, katano: {}, kawachinagano: {}, kishiwada: {}, kita: {}, kumatori: {}, matsubara: {}, minato: {}, minoh: {}, misaki: {}, moriguchi: {}, neyagawa: {}, nishi: {}, nose: {}, osakasayama: {}, sakai: {}, sayama: {}, sennan: {}, settsu: {}, shijonawate: {}, shimamoto: {}, suita: {}, tadaoka: {}, taishi: {}, tajiri: {}, takaishi: {}, takatsuki: {}, tondabayashi: {}, toyonaka: {}, toyono: {}, yao: {} }, saga: { ariake: {}, arita: {}, fukudomi: {}, genkai: {}, hamatama: {}, hizen: {}, imari: {}, kamimine: {}, kanzaki: {}, karatsu: {}, kashima: {}, kitagata: {}, kitahata: {}, kiyama: {}, kouhoku: {}, kyuragi: {}, nishiarita: {}, ogi: {}, omachi: {}, ouchi: {}, saga: {}, shiroishi: {}, taku: {}, tara: {}, tosu: {}, yoshinogari: {} }, saitama: { arakawa: {}, asaka: {}, chichibu: {}, fujimi: {}, fujimino: {}, fukaya: {}, hanno: {}, hanyu: {}, hasuda: {}, hatogaya: {}, hatoyama: {}, hidaka: {}, higashichichibu: {}, higashimatsuyama: {}, honjo: {}, ina: {}, iruma: {}, iwatsuki: {}, kamiizumi: {}, kamikawa: {}, kamisato: {}, kasukabe: {}, kawagoe: {}, kawaguchi: {}, kawajima: {}, kazo: {}, kitamoto: {}, koshigaya: {}, kounosu: {}, kuki: {}, kumagaya: {}, matsubushi: {}, minano: {}, misato: {}, miyashiro: {}, miyoshi: {}, moroyama: {}, nagatoro: {}, namegawa: {}, niiza: {}, ogano: {}, ogawa: {}, ogose: {}, okegawa: {}, omiya: {}, otaki: {}, ranzan: {}, ryokami: {}, saitama: {}, sakado: {}, satte: {}, sayama: {}, shiki: {}, shiraoka: {}, soka: {}, sugito: {}, toda: {}, tokigawa: {}, tokorozawa: {}, tsurugashima: {}, urawa: {}, warabi: {}, yashio: {}, yokoze: {}, yono: {}, yorii: {}, yoshida: {}, yoshikawa: {}, yoshimi: {} }, shiga: { aisho: {}, gamo: {}, higashiomi: {}, hikone: {}, koka: {}, konan: {}, kosei: {}, koto: {}, kusatsu: {}, maibara: {}, moriyama: {}, nagahama: {}, nishiazai: {}, notogawa: {}, omihachiman: {}, otsu: {}, ritto: {}, ryuoh: {}, takashima: {}, takatsuki: {}, torahime: {}, toyosato: {}, yasu: {} }, shimane: { akagi: {}, ama: {}, gotsu: {}, hamada: {}, higashiizumo: {}, hikawa: {}, hikimi: {}, izumo: {}, kakinoki: {}, masuda: {}, matsue: {}, misato: {}, nishinoshima: {}, ohda: {}, okinoshima: {}, okuizumo: {}, shimane: {}, tamayu: {}, tsuwano: {}, unnan: {}, yakumo: {}, yasugi: {}, yatsuka: {} }, shizuoka: { arai: {}, atami: {}, fuji: {}, fujieda: {}, fujikawa: {}, fujinomiya: {}, fukuroi: {}, gotemba: {}, haibara: {}, hamamatsu: {}, higashiizu: {}, ito: {}, iwata: {}, izu: {}, izunokuni: {}, kakegawa: {}, kannami: {}, kawanehon: {}, kawazu: {}, kikugawa: {}, kosai: {}, makinohara: {}, matsuzaki: {}, minamiizu: {}, mishima: {}, morimachi: {}, nishiizu: {}, numazu: {}, omaezaki: {}, shimada: {}, shimizu: {}, shimoda: {}, shizuoka: {}, susono: {}, yaizu: {}, yoshida: {} }, tochigi: { ashikaga: {}, bato: {}, haga: {}, ichikai: {}, iwafune: {}, kaminokawa: {}, kanuma: {}, karasuyama: {}, kuroiso: {}, mashiko: {}, mibu: {}, moka: {}, motegi: {}, nasu: {}, nasushiobara: {}, nikko: {}, nishikata: {}, nogi: {}, ohira: {}, ohtawara: {}, oyama: {}, sakura: {}, sano: {}, shimotsuke: {}, shioya: {}, takanezawa: {}, tochigi: {}, tsuga: {}, ujiie: {}, utsunomiya: {}, yaita: {} }, tokushima: { aizumi: {}, anan: {}, ichiba: {}, itano: {}, kainan: {}, komatsushima: {}, matsushige: {}, mima: {}, minami: {}, miyoshi: {}, mugi: {}, nakagawa: {}, naruto: {}, sanagochi: {}, shishikui: {}, tokushima: {}, wajiki: {} }, tokyo: { adachi: {}, akiruno: {}, akishima: {}, aogashima: {}, arakawa: {}, bunkyo: {}, chiyoda: {}, chofu: {}, chuo: {}, edogawa: {}, fuchu: {}, fussa: {}, hachijo: {}, hachioji: {}, hamura: {}, higashikurume: {}, higashimurayama: {}, higashiyamato: {}, hino: {}, hinode: {}, hinohara: {}, inagi: {}, itabashi: {}, katsushika: {}, kita: {}, kiyose: {}, kodaira: {}, koganei: {}, kokubunji: {}, komae: {}, koto: {}, kouzushima: {}, kunitachi: {}, machida: {}, meguro: {}, minato: {}, mitaka: {}, mizuho: {}, musashimurayama: {}, musashino: {}, nakano: {}, nerima: {}, ogasawara: {}, okutama: {}, ome: {}, oshima: {}, ota: {}, setagaya: {}, shibuya: {}, shinagawa: {}, shinjuku: {}, suginami: {}, sumida: {}, tachikawa: {}, taito: {}, tama: {}, toshima: {} }, tottori: { chizu: {}, hino: {}, kawahara: {}, koge: {}, kotoura: {}, misasa: {}, nanbu: {}, nichinan: {}, sakaiminato: {}, tottori: {}, wakasa: {}, yazu: {}, yonago: {} }, toyama: { asahi: {}, fuchu: {}, fukumitsu: {}, funahashi: {}, himi: {}, imizu: {}, inami: {}, johana: {}, kamiichi: {}, kurobe: {}, nakaniikawa: {}, namerikawa: {}, nanto: {}, nyuzen: {}, oyabe: {}, taira: {}, takaoka: {}, tateyama: {}, toga: {}, tonami: {}, toyama: {}, unazuki: {}, uozu: {}, yamada: {} }, wakayama: { arida: {}, aridagawa: {}, gobo: {}, hashimoto: {}, hidaka: {}, hirogawa: {}, inami: {}, iwade: {}, kainan: {}, kamitonda: {}, katsuragi: {}, kimino: {}, kinokawa: {}, kitayama: {}, koya: {}, koza: {}, kozagawa: {}, kudoyama: {}, kushimoto: {}, mihama: {}, misato: {}, nachikatsuura: {}, shingu: {}, shirahama: {}, taiji: {}, tanabe: {}, wakayama: {}, yuasa: {}, yura: {} }, yamagata: { asahi: {}, funagata: {}, higashine: {}, iide: {}, kahoku: {}, kaminoyama: {}, kaneyama: {}, kawanishi: {}, mamurogawa: {}, mikawa: {}, murayama: {}, nagai: {}, nakayama: {}, nanyo: {}, nishikawa: {}, obanazawa: {}, oe: {}, oguni: {}, ohkura: {}, oishida: {}, sagae: {}, sakata: {}, sakegawa: {}, shinjo: {}, shirataka: {}, shonai: {}, takahata: {}, tendo: {}, tozawa: {}, tsuruoka: {}, yamagata: {}, yamanobe: {}, yonezawa: {}, yuza: {} }, yamaguchi: { abu: {}, hagi: {}, hikari: {}, hofu: {}, iwakuni: {}, kudamatsu: {}, mitou: {}, nagato: {}, oshima: {}, shimonoseki: {}, shunan: {}, tabuse: {}, tokuyama: {}, toyota: {}, ube: {}, yuu: {} }, yamanashi: { chuo: {}, doshi: {}, fuefuki: {}, fujikawa: {}, fujikawaguchiko: {}, fujiyoshida: {}, hayakawa: {}, hokuto: {}, ichikawamisato: {}, kai: {}, kofu: {}, koshu: {}, kosuge: {}, minobu: {}, nakamichi: {}, nanbu: {}, narusawa: {}, nirasaki: {}, nishikatsura: {}, oshino: {}, otsuki: {}, showa: {}, tabayama: {}, tsuru: {}, uenohara: {}, yamanakako: {}, yamanashi: {} }, blogspot: {} }, ke: { ac: {}, co: { blogspot: {} }, go: {}, info: {}, me: {}, mobi: {}, ne: {}, or: {}, sc: {} }, kg: { org: {}, net: {}, com: {}, edu: {}, gov: {}, mil: {} }, ki: { edu: {}, biz: {}, net: {}, org: {}, gov: {}, info: {}, com: {} }, km: { org: {}, nom: {}, gov: {}, prd: {}, tm: {}, edu: {}, mil: {}, ass: {}, com: {}, coop: {}, asso: {}, presse: {}, medecin: {}, notaires: {}, pharmaciens: {}, veterinaire: {}, gouv: {} }, kn: { net: {}, org: {}, edu: {}, gov: {} }, kp: { com: {}, edu: {}, gov: {}, org: {}, rep: {}, tra: {} }, kr: { ac: {}, co: {}, es: {}, go: {}, hs: {}, kg: {}, mil: {}, ms: {}, ne: {}, or: {}, pe: {}, re: {}, sc: {}, busan: {}, chungbuk: {}, chungnam: {}, daegu: {}, daejeon: {}, gangwon: {}, gwangju: {}, gyeongbuk: {}, gyeonggi: {}, gyeongnam: {}, incheon: {}, jeju: {}, jeonbuk: {}, jeonnam: {}, seoul: {}, ulsan: {}, blogspot: {} }, ky: { edu: {}, gov: {}, com: {}, org: {}, net: {} }, kz: { org: {}, edu: {}, net: {}, gov: {}, mil: {}, com: {}, nym: {} }, la: { int: {}, net: {}, info: {}, edu: {}, gov: {}, per: {}, com: {}, org: {}, bnr: {}, c: {}, nym: {} }, lb: { com: {}, edu: {}, gov: {}, net: {}, org: {} }, lc: { com: {}, net: {}, co: {}, org: {}, edu: {}, gov: {}, oy: {} }, li: { blogspot: {}, nom: {}, nym: {} }, lk: { gov: {}, sch: {}, net: {}, int: {}, com: {}, org: {}, edu: {}, ngo: {}, soc: {}, web: {}, ltd: {}, assn: {}, grp: {}, hotel: {}, ac: {} }, lr: { com: {}, edu: {}, gov: {}, org: {}, net: {} }, ls: { co: {}, org: {} }, lt: { gov: {}, blogspot: {}, nym: {} }, lu: { blogspot: {}, nym: {} }, lv: { com: {}, edu: {}, gov: {}, org: {}, mil: {}, id: {}, net: {}, asn: {}, conf: {} }, ly: { com: {}, net: {}, gov: {}, plc: {}, edu: {}, sch: {}, med: {}, org: {}, id: {} }, ma: { co: {}, net: {}, gov: {}, org: {}, ac: {}, press: {} }, mc: { tm: {}, asso: {} }, md: { blogspot: {} }, me: { co: {}, net: {}, org: {}, edu: {}, ac: {}, gov: {}, its: {}, priv: {}, c66: {}, daplie: { localhost: {} }, filegear: {}, ravendb: {}, brasilia: {}, ddns: {}, dnsfor: {}, hopto: {}, loginto: {}, noip: {}, webhop: {}, nym: {}, diskstation: {}, dscloud: {}, i234: {}, myds: {}, synology: {}, wedeploy: {}, yombo: {}, nohost: {} }, mg: { org: {}, nom: {}, gov: {}, prd: {}, tm: {}, edu: {}, mil: {}, com: {}, co: {} }, mh: {}, mil: {}, mk: { com: {}, org: {}, net: {}, edu: {}, gov: {}, inf: {}, name: {}, blogspot: {}, nom: {} }, ml: { com: {}, edu: {}, gouv: {}, gov: {}, net: {}, org: {}, presse: {} }, mn: { gov: {}, edu: {}, org: {}, nyc: {} }, mo: { com: {}, net: {}, org: {}, edu: {}, gov: {} }, mobi: { dscloud: {} }, mp: {}, mq: {}, mr: { gov: {}, blogspot: {} }, ms: { com: {}, edu: {}, gov: {}, net: {}, org: {} }, mt: { com: { blogspot: {} }, edu: {}, net: {}, org: {} }, mu: { com: {}, net: {}, org: {}, gov: {}, ac: {}, co: {}, or: {} }, museum: { academy: {}, agriculture: {}, air: {}, airguard: {}, alabama: {}, alaska: {}, amber: {}, ambulance: {}, american: {}, americana: {}, americanantiques: {}, americanart: {}, amsterdam: {}, and: {}, annefrank: {}, anthro: {}, anthropology: {}, antiques: {}, aquarium: {}, arboretum: {}, archaeological: {}, archaeology: {}, architecture: {}, art: {}, artanddesign: {}, artcenter: {}, artdeco: {}, arteducation: {}, artgallery: {}, arts: {}, artsandcrafts: {}, asmatart: {}, assassination: {}, assisi: {}, association: {}, astronomy: {}, atlanta: {}, austin: {}, australia: {}, automotive: {}, aviation: {}, axis: {}, badajoz: {}, baghdad: {}, bahn: {}, bale: {}, baltimore: {}, barcelona: {}, baseball: {}, basel: {}, baths: {}, bauern: {}, beauxarts: {}, beeldengeluid: {}, bellevue: {}, bergbau: {}, berkeley: {}, berlin: {}, bern: {}, bible: {}, bilbao: {}, bill: {}, birdart: {}, birthplace: {}, bonn: {}, boston: {}, botanical: {}, botanicalgarden: {}, botanicgarden: {}, botany: {}, brandywinevalley: {}, brasil: {}, bristol: {}, british: {}, britishcolumbia: {}, broadcast: {}, brunel: {}, brussel: {}, brussels: {}, bruxelles: {}, building: {}, burghof: {}, bus: {}, bushey: {}, cadaques: {}, california: {}, cambridge: {}, can: {}, canada: {}, capebreton: {}, carrier: {}, cartoonart: {}, casadelamoneda: {}, castle: {}, castres: {}, celtic: {}, center: {}, chattanooga: {}, cheltenham: {}, chesapeakebay: {}, chicago: {}, children: {}, childrens: {}, childrensgarden: {}, chiropractic: {}, chocolate: {}, christiansburg: {}, cincinnati: {}, cinema: {}, circus: {}, civilisation: {}, civilization: {}, civilwar: {}, clinton: {}, clock: {}, coal: {}, coastaldefence: {}, cody: {}, coldwar: {}, collection: {}, colonialwilliamsburg: {}, coloradoplateau: {}, columbia: {}, columbus: {}, communication: {}, communications: {}, community: {}, computer: {}, computerhistory: {}, contemporary: {}, contemporaryart: {}, convent: {}, copenhagen: {}, corporation: {}, corvette: {}, costume: {}, countryestate: {}, county: {}, crafts: {}, cranbrook: {}, creation: {}, cultural: {}, culturalcenter: {}, culture: {}, cyber: {}, cymru: {}, dali: {}, dallas: {}, database: {}, ddr: {}, decorativearts: {}, delaware: {}, delmenhorst: {}, denmark: {}, depot: {}, design: {}, detroit: {}, dinosaur: {}, discovery: {}, dolls: {}, donostia: {}, durham: {}, eastafrica: {}, eastcoast: {}, education: {}, educational: {}, egyptian: {}, eisenbahn: {}, elburg: {}, elvendrell: {}, embroidery: {}, encyclopedic: {}, england: {}, entomology: {}, environment: {}, environmentalconservation: {}, epilepsy: {}, essex: {}, estate: {}, ethnology: {}, exeter: {}, exhibition: {}, family: {}, farm: {}, farmequipment: {}, farmers: {}, farmstead: {}, field: {}, figueres: {}, filatelia: {}, film: {}, fineart: {}, finearts: {}, finland: {}, flanders: {}, florida: {}, force: {}, fortmissoula: {}, fortworth: {}, foundation: {}, francaise: {}, frankfurt: {}, franziskaner: {}, freemasonry: {}, freiburg: {}, fribourg: {}, frog: {}, fundacio: {}, furniture: {}, gallery: {}, garden: {}, gateway: {}, geelvinck: {}, gemological: {}, geology: {}, georgia: {}, giessen: {}, glas: {}, glass: {}, gorge: {}, grandrapids: {}, graz: {}, guernsey: {}, halloffame: {}, hamburg: {}, handson: {}, harvestcelebration: {}, hawaii: {}, health: {}, heimatunduhren: {}, hellas: {}, helsinki: {}, hembygdsforbund: {}, heritage: {}, histoire: {}, historical: {}, historicalsociety: {}, historichouses: {}, historisch: {}, historisches: {}, history: {}, historyofscience: {}, horology: {}, house: {}, humanities: {}, illustration: {}, imageandsound: {}, indian: {}, indiana: {}, indianapolis: {}, indianmarket: {}, intelligence: {}, interactive: {}, iraq: {}, iron: {}, isleofman: {}, jamison: {}, jefferson: {}, jerusalem: {}, jewelry: {}, jewish: {}, jewishart: {}, jfk: {}, journalism: {}, judaica: {}, judygarland: {}, juedisches: {}, juif: {}, karate: {}, karikatur: {}, kids: {}, koebenhavn: {}, koeln: {}, kunst: {}, kunstsammlung: {}, kunstunddesign: {}, labor: {}, labour: {}, lajolla: {}, lancashire: {}, landes: {}, lans: {}, larsson: {}, lewismiller: {}, lincoln: {}, linz: {}, living: {}, livinghistory: {}, localhistory: {}, london: {}, losangeles: {}, louvre: {}, loyalist: {}, lucerne: {}, luxembourg: {}, luzern: {}, mad: {}, madrid: {}, mallorca: {}, manchester: {}, mansion: {}, mansions: {}, manx: {}, marburg: {}, maritime: {}, maritimo: {}, maryland: {}, marylhurst: {}, media: {}, medical: {}, medizinhistorisches: {}, meeres: {}, memorial: {}, mesaverde: {}, michigan: {}, midatlantic: {}, military: {}, mill: {}, miners: {}, mining: {}, minnesota: {}, missile: {}, missoula: {}, modern: {}, moma: {}, money: {}, monmouth: {}, monticello: {}, montreal: {}, moscow: {}, motorcycle: {}, muenchen: {}, muenster: {}, mulhouse: {}, muncie: {}, museet: {}, museumcenter: {}, museumvereniging: {}, music: {}, national: {}, nationalfirearms: {}, nationalheritage: {}, nativeamerican: {}, naturalhistory: {}, naturalhistorymuseum: {}, naturalsciences: {}, nature: {}, naturhistorisches: {}, natuurwetenschappen: {}, naumburg: {}, naval: {}, nebraska: {}, neues: {}, newhampshire: {}, newjersey: {}, newmexico: {}, newport: {}, newspaper: {}, newyork: {}, niepce: {}, norfolk: {}, north: {}, nrw: {}, nuernberg: {}, nuremberg: {}, nyc: {}, nyny: {}, oceanographic: {}, oceanographique: {}, omaha: {}, online: {}, ontario: {}, openair: {}, oregon: {}, oregontrail: {}, otago: {}, oxford: {}, pacific: {}, paderborn: {}, palace: {}, paleo: {}, palmsprings: {}, panama: {}, paris: {}, pasadena: {}, pharmacy: {}, philadelphia: {}, philadelphiaarea: {}, philately: {}, phoenix: {}, photography: {}, pilots: {}, pittsburgh: {}, planetarium: {}, plantation: {}, plants: {}, plaza: {}, portal: {}, portland: {}, portlligat: {}, preservation: {}, presidio: {}, press: {}, project: {}, public: {}, pubol: {}, quebec: {}, railroad: {}, railway: {}, research: {}, resistance: {}, riodejaneiro: {}, rochester: {}, rockart: {}, roma: {}, russia: {}, saintlouis: {}, salem: {}, salvadordali: {}, salzburg: {}, sandiego: {}, sanfrancisco: {}, santabarbara: {}, santacruz: {}, santafe: {}, saskatchewan: {}, satx: {}, savannahga: {}, schlesisches: {}, schoenbrunn: {}, schokoladen: {}, school: {}, schweiz: {}, science: {}, scienceandhistory: {}, scienceandindustry: {}, sciencecenter: {}, sciencecenters: {}, sciencehistory: {}, sciences: {}, sciencesnaturelles: {}, scotland: {}, seaport: {}, settlement: {}, settlers: {}, shell: {}, sherbrooke: {}, sibenik: {}, silk: {}, ski: {}, skole: {}, society: {}, sologne: {}, soundandvision: {}, southcarolina: {}, southwest: {}, space: {}, spy: {}, square: {}, stadt: {}, stalbans: {}, starnberg: {}, state: {}, stateofdelaware: {}, station: {}, steam: {}, steiermark: {}, stjohn: {}, stockholm: {}, stpetersburg: {}, stuttgart: {}, suisse: {}, surgeonshall: {}, surrey: {}, svizzera: {}, sweden: {}, sydney: {}, tank: {}, tcm: {}, technology: {}, telekommunikation: {}, television: {}, texas: {}, textile: {}, theater: {}, time: {}, timekeeping: {}, topology: {}, torino: {}, touch: {}, town: {}, transport: {}, tree: {}, trolley: {}, trust: {}, trustee: {}, uhren: {}, ulm: {}, undersea: {}, university: {}, usa: {}, usantiques: {}, usarts: {}, uscountryestate: {}, usculture: {}, usdecorativearts: {}, usgarden: {}, ushistory: {}, ushuaia: {}, uslivinghistory: {}, utah: {}, uvic: {}, valley: {}, vantaa: {}, versailles: {}, viking: {}, village: {}, virginia: {}, virtual: {}, virtuel: {}, vlaanderen: {}, volkenkunde: {}, wales: {}, wallonie: {}, war: {}, washingtondc: {}, watchandclock: {}, western: {}, westfalen: {}, whaling: {}, wildlife: {}, williamsburg: {}, windmill: {}, workshop: {}, york: {}, yorkshire: {}, yosemite: {}, youth: {}, zoological: {}, zoology: {} }, mv: { aero: {}, biz: {}, com: {}, coop: {}, edu: {}, gov: {}, info: {}, int: {}, mil: {}, museum: {}, name: {}, net: {}, org: {}, pro: {} }, mw: { ac: {}, biz: {}, co: {}, com: {}, coop: {}, edu: {}, gov: {}, int: {}, museum: {}, net: {}, org: {} }, mx: { com: {}, org: {}, gob: {}, edu: {}, net: {}, blogspot: {}, nym: {} }, my: { com: {}, net: {}, org: {}, gov: {}, edu: {}, mil: {}, name: {}, blogspot: {} }, mz: { ac: {}, adv: {}, co: {}, edu: {}, gov: {}, mil: {}, net: {}, org: {} }, na: { info: {}, pro: {}, name: {}, school: {}, or: {}, dr: {}, us: {}, mx: {}, ca: {}, in: {}, cc: {}, tv: {}, ws: {}, mobi: {}, co: {}, com: {}, org: {} }, name: { her: { forgot: {} }, his: { forgot: {} } }, nc: { asso: {}, nom: {} }, ne: {}, net: { alwaysdata: {}, cloudfront: {}, t3l3p0rt: {}, myfritz: {}, boomla: {}, bplaced: {}, square7: {}, gb: {}, hu: {}, jp: {}, se: {}, uk: {}, in: {}, cloudaccess: {}, cdn77: { r: {} }, cloudeity: {}, debian: {}, blogdns: {}, buyshouses: {}, dnsalias: {}, dnsdojo: {}, dontexist: {}, dynalias: {}, dynathome: {}, endofinternet: {}, homeftp: {}, homeip: {}, homelinux: {}, homeunix: {}, podzone: {}, selfip: {}, servebbs: {}, serveftp: {}, thruhere: {}, webhop: {}, definima: {}, casacam: {}, dynu: {}, dynv6: {}, twmail: {}, ru: {}, channelsdvr: {}, fastlylb: { map: {} }, fastly: { freetls: {}, map: {}, prod: { a: {}, global: {} }, ssl: { a: {}, b: {}, global: {} } }, flynnhosting: {}, cloudfunctions: {}, moonscale: {}, ipifony: {}, barsy: {}, azurewebsites: {}, cloudapp: {}, mydissent: {}, myeffect: {}, mymediapc: {}, mypsx: {}, mysecuritycamera: {}, nhlfan: {}, pgafan: {}, privatizehealthinsurance: {}, bounceme: {}, ddns: {}, redirectme: {}, serveblog: {}, serveminecraft: {}, sytes: {}, rackmaze: {}, schokokeks: {}, dsmynas: {}, familyds: {}, za: {} }, nf: { com: {}, net: {}, per: {}, rec: {}, web: {}, arts: {}, firm: {}, info: {}, other: {}, store: {} }, ng: { com: { blogspot: {} }, edu: {}, gov: {}, i: {}, mil: {}, mobi: {}, name: {}, net: {}, org: {}, sch: {} }, ni: { ac: {}, biz: {}, co: {}, com: {}, edu: {}, gob: {}, in: {}, info: {}, int: {}, mil: {}, net: {}, nom: {}, org: {}, web: {} }, nl: { bv: {}, virtueeldomein: {}, co: {}, blogspot: {}, cistron: {}, demon: {} }, no: { fhs: {}, vgs: {}, fylkesbibl: {}, folkebibl: {}, museum: {}, idrett: {}, priv: {}, mil: {}, stat: {}, dep: {}, kommune: {}, herad: {}, aa: { gs: {} }, ah: { gs: {} }, bu: { gs: {} }, fm: { gs: {} }, hl: { gs: {} }, hm: { gs: {} }, mr: { gs: {} }, nl: { gs: {} }, nt: { gs: {} }, of: { gs: {} }, ol: { gs: {} }, oslo: { gs: {} }, rl: { gs: {} }, sf: { gs: {} }, st: { gs: {} }, svalbard: { gs: {} }, tm: { gs: {} }, tr: { gs: {} }, va: { gs: {} }, vf: { gs: {} }, akrehamn: {}, algard: {}, arna: {}, brumunddal: {}, bryne: {}, bronnoysund: {}, drobak: {}, egersund: {}, fetsund: {}, floro: {}, fredrikstad: {}, hokksund: {}, honefoss: {}, jessheim: {}, jorpeland: {}, kirkenes: {}, kopervik: {}, krokstadelva: {}, langevag: {}, leirvik: {}, mjondalen: {}, mosjoen: {}, nesoddtangen: {}, orkanger: {}, osoyro: {}, raholt: {}, sandnessjoen: {}, skedsmokorset: {}, slattum: {}, spjelkavik: {}, stathelle: {}, stavern: {}, stjordalshalsen: {}, tananger: {}, tranby: {}, vossevangen: {}, afjord: {}, agdenes: {}, al: {}, alesund: {}, alstahaug: {}, alta: {}, alaheadju: {}, alvdal: {}, amli: {}, amot: {}, andebu: {}, andoy: {}, andasuolo: {}, ardal: {}, aremark: {}, arendal: {}, aseral: {}, asker: {}, askim: {}, askvoll: {}, askoy: {}, asnes: {}, audnedaln: {}, aukra: {}, aure: {}, aurland: {}, austevoll: {}, austrheim: {}, averoy: {}, balestrand: {}, ballangen: {}, balat: {}, balsfjord: {}, bahccavuotna: {}, bamble: {}, bardu: {}, beardu: {}, beiarn: {}, bajddar: {}, baidar: {}, berg: {}, bergen: {}, berlevag: {}, bearalvahki: {}, bindal: {}, birkenes: {}, bjarkoy: {}, bjerkreim: {}, bjugn: {}, bodo: {}, badaddja: {}, budejju: {}, bokn: {}, bremanger: {}, bronnoy: {}, bygland: {}, bykle: {}, barum: {}, telemark: { bo: {} }, nordland: { bo: {}, heroy: {} }, bievat: {}, bomlo: {}, batsfjord: {}, bahcavuotna: {}, dovre: {}, drammen: {}, drangedal: {}, dyroy: {}, donna: {}, eid: {}, eidfjord: {}, eidsberg: {}, eidskog: {}, eidsvoll: {}, eigersund: {}, elverum: {}, enebakk: {}, engerdal: {}, etne: {}, etnedal: {}, evenes: {}, evenassi: {}, farsund: {}, fauske: {}, fuossko: {}, fuoisku: {}, fedje: {}, fet: {}, finnoy: {}, fitjar: {}, fjaler: {}, fjell: {}, flakstad: {}, flatanger: {}, flekkefjord: {}, flesberg: {}, flora: {}, fla: {}, folldal: {}, forsand: {}, fosnes: {}, frei: {}, frogn: {}, froland: {}, frosta: {}, frana: {}, froya: {}, fusa: {}, fyresdal: {}, forde: {}, gamvik: {}, gangaviika: {}, gaular: {}, gausdal: {}, gildeskal: {}, giske: {}, gjemnes: {}, gjerdrum: {}, gjerstad: {}, gjesdal: {}, gjovik: {}, gloppen: {}, gol: {}, gran: {}, grane: {}, granvin: {}, gratangen: {}, grimstad: {}, grong: {}, kraanghke: {}, grue: {}, gulen: {}, hadsel: {}, halden: {}, halsa: {}, hamar: {}, hamaroy: {}, habmer: {}, hapmir: {}, hammerfest: {}, hammarfeasta: {}, haram: {}, hareid: {}, harstad: {}, hasvik: {}, aknoluokta: {}, hattfjelldal: {}, aarborte: {}, haugesund: {}, hemne: {}, hemnes: {}, hemsedal: {}, hitra: {}, hjartdal: {}, hjelmeland: {}, hobol: {}, hof: {}, hol: {}, hole: {}, holmestrand: {}, holtalen: {}, hornindal: {}, horten: {}, hurdal: {}, hurum: {}, hvaler: {}, hyllestad: {}, hagebostad: {}, hoyanger: {}, hoylandet: {}, ha: {}, ibestad: {}, inderoy: {}, iveland: {}, jevnaker: {}, jondal: {}, jolster: {}, karasjok: {}, karasjohka: {}, karlsoy: {}, galsa: {}, karmoy: {}, kautokeino: {}, guovdageaidnu: {}, klepp: {}, klabu: {}, kongsberg: {}, kongsvinger: {}, kragero: {}, kristiansand: {}, kristiansund: {}, krodsherad: {}, kvalsund: {}, rahkkeravju: {}, kvam: {}, kvinesdal: {}, kvinnherad: {}, kviteseid: {}, kvitsoy: {}, kvafjord: {}, giehtavuoatna: {}, kvanangen: {}, navuotna: {}, kafjord: {}, gaivuotna: {}, larvik: {}, lavangen: {}, lavagis: {}, loabat: {}, lebesby: {}, davvesiida: {}, leikanger: {}, leirfjord: {}, leka: {}, leksvik: {}, lenvik: {}, leangaviika: {}, lesja: {}, levanger: {}, lier: {}, lierne: {}, lillehammer: {}, lillesand: {}, lindesnes: {}, lindas: {}, lom: {}, loppa: {}, lahppi: {}, lund: {}, lunner: {}, luroy: {}, luster: {}, lyngdal: {}, lyngen: {}, ivgu: {}, lardal: {}, lerdal: {}, lodingen: {}, lorenskog: {}, loten: {}, malvik: {}, masoy: {}, muosat: {}, mandal: {}, marker: {}, marnardal: {}, masfjorden: {}, meland: {}, meldal: {}, melhus: {}, meloy: {}, meraker: {}, moareke: {}, midsund: {}, modalen: {}, modum: {}, molde: {}, moskenes: {}, moss: {}, mosvik: {}, malselv: {}, malatvuopmi: {}, namdalseid: {}, aejrie: {}, namsos: {}, namsskogan: {}, naamesjevuemie: {}, laakesvuemie: {}, nannestad: {}, narvik: {}, narviika: {}, naustdal: {}, akershus: { nes: {} }, buskerud: { nes: {} }, nesna: {}, nesodden: {}, nesseby: {}, unjarga: {}, nesset: {}, nissedal: {}, nittedal: {}, norddal: {}, nordkapp: {}, davvenjarga: {}, nordreisa: {}, raisa: {}, notodden: {}, naroy: {}, notteroy: {}, odda: {}, oksnes: {}, oppdal: {}, oppegard: {}, orkdal: {}, orland: {}, orskog: {}, orsta: {}, hedmark: { os: {}, valer: {} }, hordaland: { os: {} }, osen: {}, osteroy: {}, overhalla: {}, oyer: {}, oygarden: {}, porsanger: {}, porsangu: {}, porsgrunn: {}, radoy: {}, rakkestad: {}, rana: {}, ruovat: {}, randaberg: {}, rauma: {}, rendalen: {}, rennebu: {}, rennesoy: {}, rindal: {}, ringebu: {}, ringerike: {}, ringsaker: {}, rissa: {}, risor: {}, roan: {}, rollag: {}, rygge: {}, ralingen: {}, rodoy: {}, romskog: {}, roros: {}, rost: {}, royken: {}, royrvik: {}, rade: {}, salangen: {}, siellak: {}, saltdal: {}, salat: {}, samnanger: {}, vestfold: { sande: {} }, sandefjord: {}, sandnes: {}, sandoy: {}, sarpsborg: {}, sauda: {}, sauherad: {}, sel: {}, selbu: {}, selje: {}, seljord: {}, sigdal: {}, siljan: {}, sirdal: {}, skaun: {}, skedsmo: {}, ski: {}, skien: {}, skiptvet: {}, skjervoy: {}, skierva: {}, skjak: {}, skodje: {}, skanland: {}, skanit: {}, smola: {}, snillfjord: {}, snasa: {}, snoasa: {}, snaase: {}, sogndal: {}, sokndal: {}, sola: {}, solund: {}, songdalen: {}, sortland: {}, spydeberg: {}, stange: {}, stavanger: {}, steigen: {}, steinkjer: {}, stjordal: {}, stokke: {}, stord: {}, stordal: {}, storfjord: {}, omasvuotna: {}, strand: {}, stranda: {}, stryn: {}, sula: {}, suldal: {}, sund: {}, sunndal: {}, surnadal: {}, sveio: {}, svelvik: {}, sykkylven: {}, sogne: {}, somna: {}, sorfold: {}, sorreisa: {}, sorum: {}, tana: {}, deatnu: {}, time: {}, tingvoll: {}, tinn: {}, tjeldsund: {}, dielddanuorri: {}, tjome: {}, tokke: {}, tolga: {}, torsken: {}, tranoy: {}, tromso: {}, tromsa: {}, romsa: {}, trondheim: {}, troandin: {}, trysil: {}, trana: {}, trogstad: {}, tvedestrand: {}, tydal: {}, tynset: {}, tysfjord: {}, divtasvuodna: {}, divttasvuotna: {}, tysnes: {}, tysvar: {}, tonsberg: {}, ullensaker: {}, ullensvang: {}, ulvik: {}, utsira: {}, vadso: {}, cahcesuolo: {}, vaksdal: {}, valle: {}, vang: {}, vanylven: {}, vardo: {}, varggat: {}, vefsn: {}, vaapste: {}, vega: {}, vegarshei: {}, vennesla: {}, verdal: {}, verran: {}, vestby: {}, vestnes: {}, vestvagoy: {}, vevelstad: {}, vik: {}, vikna: {}, vindafjord: {}, volda: {}, voss: {}, varoy: {}, vagan: {}, voagat: {}, vagsoy: {}, vaga: {}, ostfold: { valer: {} }, co: {}, blogspot: {} }, nr: { biz: {}, info: {}, gov: {}, edu: {}, org: {}, net: {}, com: {} }, nu: { merseine: {}, mine: {}, shacknet: {}, nom: {} }, nz: { ac: {}, co: { blogspot: {} }, cri: {}, geek: {}, gen: {}, govt: {}, health: {}, iwi: {}, kiwi: {}, maori: {}, mil: {}, net: {}, org: {}, parliament: {}, school: {}, nym: {} }, om: { co: {}, com: {}, edu: {}, gov: {}, med: {}, museum: {}, net: {}, org: {}, pro: {} }, onion: {}, org: { amune: { tele: {} }, pimienta: {}, poivron: {}, potager: {}, sweetpepper: {}, ae: {}, us: {}, certmgr: {}, cdn77: { c: {}, rsc: {} }, cloudns: {}, duckdns: {}, tunk: {}, dyndns: { go: {}, home: {} }, blogdns: {}, blogsite: {}, boldlygoingnowhere: {}, dnsalias: {}, dnsdojo: {}, doesntexist: {}, dontexist: {}, doomdns: {}, dvrdns: {}, dynalias: {}, endofinternet: {}, endoftheinternet: {}, gotdns: {}, homedns: {}, homeftp: {}, homelinux: {}, homeunix: {}, misconfused: {}, podzone: {}, readmyblog: {}, selfip: {}, sellsyourhome: {}, servebbs: {}, serveftp: {}, servegame: {}, webhop: {}, ddnss: {}, accesscam: {}, camdvr: {}, freeddns: {}, mywire: {}, webredirect: {}, eu: { al: {}, asso: {}, at: {}, au: {}, be: {}, bg: {}, ca: {}, cd: {}, ch: {}, cn: {}, cy: {}, cz: {}, de: {}, dk: {}, edu: {}, ee: {}, es: {}, fi: {}, fr: {}, gr: {}, hr: {}, hu: {}, ie: {}, il: {}, in: {}, int: {}, is: {}, it: {}, jp: {}, kr: {}, lt: {}, lu: {}, lv: {}, mc: {}, me: {}, mk: {}, mt: {}, my: {}, net: {}, ng: {}, nl: {}, no: {}, nz: {}, paris: {}, pl: {}, pt: {}, ro: {}, ru: {}, se: {}, si: {}, sk: {}, tr: {}, uk: {}, us: {} }, twmail: {}, fedorainfracloud: {}, fedorapeople: {}, fedoraproject: { cloud: {}, os: { app: {} }, stg: { os: { app: {} } } }, hepforge: {}, js: {}, uklugs: {}, bmoattachments: {}, collegefan: {}, couchpotatofries: {}, mlbfan: {}, mysecuritycamera: {}, nflfan: {}, ufcfan: {}, hopto: {}, myftp: {}, zapto: {}, myfirewall: {}, spdns: {}, dsmynas: {}, familyds: {}, tuxfamily: {}, diskstation: {}, hk: {}, wmflabs: {}, za: {} }, pa: { ac: {}, gob: {}, com: {}, org: {}, sld: {}, edu: {}, net: {}, ing: {}, abo: {}, med: {}, nom: {} }, pe: { edu: {}, gob: {}, nom: {}, mil: {}, org: {}, com: {}, net: {}, blogspot: {}, nym: {} }, pf: { com: {}, org: {}, edu: {} }, ph: { com: {}, net: {}, org: {}, gov: {}, edu: {}, ngo: {}, mil: {}, i: {} }, pk: { com: {}, net: {}, edu: {}, org: {}, fam: {}, biz: {}, web: {}, gov: {}, gob: {}, gok: {}, gon: {}, gop: {}, gos: {}, info: {} }, pl: { com: {}, net: {}, org: {}, aid: {}, agro: {}, atm: {}, auto: {}, biz: {}, edu: {}, gmina: {}, gsm: {}, info: {}, mail: {}, miasta: {}, media: {}, mil: {}, nieruchomosci: {}, nom: {}, pc: {}, powiat: {}, priv: {}, realestate: {}, rel: {}, sex: {}, shop: {}, sklep: {}, sos: {}, szkola: {}, targi: {}, tm: {}, tourism: {}, travel: {}, turystyka: {}, gov: { ap: {}, ic: {}, is: {}, us: {}, kmpsp: {}, kppsp: {}, kwpsp: {}, psp: {}, wskr: {}, kwp: {}, mw: {}, ug: {}, um: {}, umig: {}, ugim: {}, upow: {}, uw: {}, starostwo: {}, pa: {}, po: {}, psse: {}, pup: {}, rzgw: {}, sa: {}, so: {}, sr: {}, wsa: {}, sko: {}, uzs: {}, wiih: {}, winb: {}, pinb: {}, wios: {}, witd: {}, wzmiuw: {}, piw: {}, wiw: {}, griw: {}, wif: {}, oum: {}, sdn: {}, zp: {}, uppo: {}, mup: {}, wuoz: {}, konsulat: {}, oirm: {} }, augustow: {}, bedzin: {}, beskidy: {}, bialowieza: {}, bialystok: {}, bielawa: {}, bieszczady: {}, boleslawiec: {}, bydgoszcz: {}, bytom: {}, cieszyn: {}, czeladz: {}, czest: {}, dlugoleka: {}, elblag: {}, elk: {}, glogow: {}, gniezno: {}, gorlice: {}, grajewo: {}, ilawa: {}, jaworzno: {}, jgora: {}, kalisz: {}, karpacz: {}, kartuzy: {}, kaszuby: {}, katowice: {}, kepno: {}, ketrzyn: {}, klodzko: {}, kobierzyce: {}, kolobrzeg: {}, konin: {}, konskowola: {}, kutno: {}, lapy: {}, lebork: {}, legnica: {}, lezajsk: {}, limanowa: {}, lomza: {}, lowicz: {}, lubin: {}, lukow: {}, malbork: {}, malopolska: {}, mazowsze: {}, mazury: {}, mielec: {}, mielno: {}, mragowo: {}, naklo: {}, nowaruda: {}, nysa: {}, olawa: {}, olecko: {}, olkusz: {}, olsztyn: {}, opoczno: {}, opole: {}, ostroda: {}, ostroleka: {}, ostrowiec: {}, ostrowwlkp: {}, pila: {}, pisz: {}, podhale: {}, podlasie: {}, polkowice: {}, pomorze: {}, pomorskie: {}, prochowice: {}, pruszkow: {}, przeworsk: {}, pulawy: {}, radom: {}, rybnik: {}, rzeszow: {}, sanok: {}, sejny: {}, slask: {}, slupsk: {}, sosnowiec: {}, skoczow: {}, starachowice: {}, stargard: {}, suwalki: {}, swidnica: {}, swiebodzin: {}, swinoujscie: {}, szczecin: {}, szczytno: {}, tarnobrzeg: {}, tgory: {}, turek: {}, tychy: {}, ustka: {}, walbrzych: {}, warmia: {}, warszawa: {}, waw: {}, wegrow: {}, wielun: {}, wlocl: {}, wloclawek: {}, wodzislaw: {}, wolomin: {}, wroclaw: {}, zachpomor: {}, zagan: {}, zarow: {}, zgora: {}, zgorzelec: {}, beep: {}, co: {}, art: {}, gliwice: {}, krakow: {}, poznan: {}, wroc: {}, zakopane: {}, gda: {}, gdansk: {}, gdynia: {}, med: {}, sopot: {} }, pm: { own: {} }, pn: { gov: {}, co: {}, org: {}, edu: {}, net: {} }, post: {}, pr: { com: {}, net: {}, org: {}, gov: {}, edu: {}, isla: {}, pro: {}, biz: {}, info: {}, name: {}, est: {}, prof: {}, ac: {} }, pro: { aaa: {}, aca: {}, acct: {}, avocat: {}, bar: {}, cpa: {}, eng: {}, jur: {}, law: {}, med: {}, recht: {}, cloudns: {} }, ps: { edu: {}, gov: {}, sec: {}, plo: {}, com: {}, org: {}, net: {} }, pt: { net: {}, gov: {}, org: {}, edu: {}, int: {}, publ: {}, com: {}, nome: {}, blogspot: {}, nym: {} }, pw: { co: {}, ne: {}, or: {}, ed: {}, go: {}, belau: {}, cloudns: {}, nom: {} }, py: { com: {}, coop: {}, edu: {}, gov: {}, mil: {}, net: {}, org: {} }, qa: { com: {}, edu: {}, gov: {}, mil: {}, name: {}, net: {}, org: {}, sch: {}, blogspot: {}, nom: {} }, re: { asso: {}, com: {}, nom: {}, blogspot: {} }, ro: { arts: {}, com: {}, firm: {}, info: {}, nom: {}, nt: {}, org: {}, rec: {}, store: {}, tm: {}, www: {}, shop: {}, blogspot: {} }, rs: { ac: {}, co: {}, edu: {}, gov: {}, in: {}, org: {}, blogspot: {}, nom: {}, ox: {} }, ru: { ac: {}, edu: {}, gov: {}, int: {}, mil: {}, test: {}, adygeya: {}, bashkiria: {}, bir: {}, cbg: {}, com: {}, dagestan: {}, grozny: {}, kalmykia: {}, kustanai: {}, marine: {}, mordovia: {}, msk: {}, mytis: {}, nalchik: {}, nov: {}, pyatigorsk: {}, spb: {}, vladikavkaz: {}, vladimir: {}, blogspot: {}, myjino: {}, cldmail: { hb: {} }, net: {}, org: {}, pp: {}, ras: {} }, rw: { gov: {}, net: {}, edu: {}, ac: {}, com: {}, co: {}, int: {}, mil: {}, gouv: {} }, sa: { com: {}, net: {}, org: {}, gov: {}, med: {}, pub: {}, edu: {}, sch: {} }, sb: { com: {}, edu: {}, gov: {}, net: {}, org: {} }, sc: { com: {}, gov: {}, net: {}, org: {}, edu: {} }, sd: { com: {}, net: {}, org: {}, edu: {}, med: {}, tv: {}, gov: {}, info: {} }, se: { a: {}, ac: {}, b: {}, bd: {}, brand: {}, c: {}, d: {}, e: {}, f: {}, fh: {}, fhsk: {}, fhv: {}, g: {}, h: {}, i: {}, k: {}, komforb: {}, kommunalforbund: {}, komvux: {}, l: {}, lanbib: {}, m: {}, n: {}, naturbruksgymn: {}, o: {}, org: {}, p: {}, parti: {}, pp: {}, press: {}, r: {}, s: {}, t: {}, tm: {}, u: {}, w: {}, x: {}, y: {}, z: {}, com: {}, blogspot: {} }, sg: { com: {}, net: {}, org: {}, gov: {}, edu: {}, per: {}, blogspot: {} }, sh: { com: {}, net: {}, gov: {}, org: {}, mil: {}, hashbang: {}, wedeploy: {}, now: {} }, si: { blogspot: {}, nom: {} }, sj: {}, sk: { blogspot: {}, nym: {} }, sl: { com: {}, net: {}, edu: {}, gov: {}, org: {} }, sm: {}, sn: { art: {}, com: {}, edu: {}, gouv: {}, org: {}, perso: {}, univ: {}, blogspot: {} }, so: { com: {}, net: {}, org: {} }, sr: {}, st: { co: {}, com: {}, consulado: {}, edu: {}, embaixada: {}, gov: {}, mil: {}, net: {}, org: {}, principe: {}, saotome: {}, store: {}, noho: {} }, su: { abkhazia: {}, adygeya: {}, aktyubinsk: {}, arkhangelsk: {}, armenia: {}, ashgabad: {}, azerbaijan: {}, balashov: {}, bashkiria: {}, bryansk: {}, bukhara: {}, chimkent: {}, dagestan: {}, exnet: {}, georgia: {}, grozny: {}, ivanovo: {}, jambyl: {}, kalmykia: {}, kaluga: {}, karacol: {}, karaganda: {}, karelia: {}, khakassia: {}, krasnodar: {}, kurgan: {}, kustanai: {}, lenug: {}, mangyshlak: {}, mordovia: {}, msk: {}, murmansk: {}, nalchik: {}, navoi: {}, nov: {}, obninsk: {}, penza: {}, pokrovsk: {}, sochi: {}, spb: {}, tashkent: {}, termez: {}, togliatti: {}, troitsk: {}, tselinograd: {}, tula: {}, tuva: {}, vladikavkaz: {}, vladimir: {}, vologda: {}, nym: {} }, sv: { com: {}, edu: {}, gob: {}, org: {}, red: {} }, sx: { gov: {}, nym: {} }, sy: { edu: {}, gov: {}, net: {}, mil: {}, com: {}, org: {} }, sz: { co: {}, ac: {}, org: {} }, tc: {}, td: { blogspot: {} }, tel: {}, tf: {}, tg: {}, th: { ac: {}, co: {}, go: {}, in: {}, mi: {}, net: {}, or: {} }, tj: { ac: {}, biz: {}, co: {}, com: {}, edu: {}, go: {}, gov: {}, int: {}, mil: {}, name: {}, net: {}, nic: {}, org: {}, test: {}, web: {} }, tk: {}, tl: { gov: {} }, tm: { com: {}, co: {}, org: {}, net: {}, nom: {}, gov: {}, mil: {}, edu: {} }, tn: { com: {}, ens: {}, fin: {}, gov: {}, ind: {}, intl: {}, nat: {}, net: {}, org: {}, info: {}, perso: {}, tourism: {}, edunet: {}, rnrt: {}, rns: {}, rnu: {}, mincom: {}, agrinet: {}, defense: {}, turen: {} }, to: { com: {}, gov: {}, net: {}, org: {}, edu: {}, mil: {}, vpnplus: {} }, tr: { com: { blogspot: {} }, info: {}, biz: {}, net: {}, org: {}, web: {}, gen: {}, tv: {}, av: {}, dr: {}, bbs: {}, name: {}, tel: {}, gov: {}, bel: {}, pol: {}, mil: {}, k12: {}, edu: {}, kep: {}, nc: { gov: {} } }, travel: {}, tt: { co: {}, com: {}, org: {}, net: {}, biz: {}, info: {}, pro: {}, int: {}, coop: {}, jobs: {}, mobi: {}, travel: {}, museum: {}, aero: {}, name: {}, gov: {}, edu: {} }, tv: { dyndns: {} }, tw: { edu: {}, gov: {}, mil: {}, com: { mymailer: {} }, net: {}, org: {}, idv: {}, game: {}, ebiz: {}, club: {}, url: {}, blogspot: {}, nym: {} }, tz: { ac: {}, co: {}, go: {}, hotel: {}, info: {}, me: {}, mil: {}, mobi: {}, ne: {}, or: {}, sc: {}, tv: {} }, ua: { com: {}, edu: {}, gov: {}, in: {}, net: {}, org: {}, cherkassy: {}, cherkasy: {}, chernigov: {}, chernihiv: {}, chernivtsi: {}, chernovtsy: {}, ck: {}, cn: {}, cr: {}, crimea: {}, cv: {}, dn: {}, dnepropetrovsk: {}, dnipropetrovsk: {}, dominic: {}, donetsk: {}, dp: {}, if: {}, kh: {}, kharkiv: {}, kharkov: {}, kherson: {}, khmelnitskiy: {}, khmelnytskyi: {}, kiev: {}, kirovograd: {}, km: {}, kr: {}, krym: {}, ks: {}, kv: {}, kyiv: {}, lg: {}, lt: {}, lugansk: {}, lutsk: {}, lv: {}, lviv: {}, mk: {}, mykolaiv: {}, nikolaev: {}, od: {}, odesa: {}, odessa: {}, pl: {}, poltava: {}, rivne: {}, rovno: {}, rv: {}, sb: {}, sebastopol: {}, sevastopol: {}, sm: {}, sumy: {}, te: {}, ternopil: {}, uz: {}, uzhgorod: {}, vinnica: {}, vinnytsia: {}, vn: {}, volyn: {}, yalta: {}, zaporizhzhe: {}, zaporizhzhia: {}, zhitomir: {}, zhytomyr: {}, zp: {}, zt: {}, cc: {}, inf: {}, ltd: {}, biz: {}, co: {}, pp: {} }, ug: { co: {}, or: {}, ac: {}, sc: {}, go: {}, ne: {}, com: {}, org: {}, blogspot: {}, nom: {} }, uk: { ac: {}, co: { blogspot: {}, wellbeingzone: {}, gwiddle: {} }, gov: { service: {}, homeoffice: {} }, ltd: {}, me: {}, net: {}, nhs: {}, org: { glug: {}, lug: {}, lugs: {} }, plc: {}, police: {} }, us: { dni: {}, fed: {}, isa: {}, kids: {}, nsn: {}, ak: { k12: {}, cc: {}, lib: {} }, al: { k12: {}, cc: {}, lib: {} }, ar: { k12: {}, cc: {}, lib: {} }, as: { k12: {}, cc: {}, lib: {} }, az: { k12: {}, cc: {}, lib: {} }, ca: { k12: {}, cc: {}, lib: {} }, co: { k12: {}, cc: {}, lib: {} }, ct: { k12: {}, cc: {}, lib: {} }, dc: { k12: {}, cc: {}, lib: {} }, de: { k12: {}, cc: {}, lib: {} }, fl: { k12: {}, cc: {}, lib: {} }, ga: { k12: {}, cc: {}, lib: {} }, gu: { k12: {}, cc: {}, lib: {} }, hi: { cc: {}, lib: {} }, ia: { k12: {}, cc: {}, lib: {} }, id: { k12: {}, cc: {}, lib: {} }, il: { k12: {}, cc: {}, lib: {} }, in: { k12: {}, cc: {}, lib: {} }, ks: { k12: {}, cc: {}, lib: {} }, ky: { k12: {}, cc: {}, lib: {} }, la: { k12: {}, cc: {}, lib: {} }, ma: { k12: { pvt: {}, chtr: {}, paroch: {} }, cc: {}, lib: {} }, md: { k12: {}, cc: {}, lib: {} }, me: { k12: {}, cc: {}, lib: {} }, mi: { k12: {}, cc: {}, lib: {}, cog: {}, dst: {}, eaton: {}, gen: {}, mus: {}, tec: {}, washtenaw: {} }, mn: { k12: {}, cc: {}, lib: {} }, mo: { k12: {}, cc: {}, lib: {} }, ms: { k12: {}, cc: {}, lib: {} }, mt: { k12: {}, cc: {}, lib: {} }, nc: { k12: {}, cc: {}, lib: {} }, nd: { cc: {}, lib: {} }, ne: { k12: {}, cc: {}, lib: {} }, nh: { k12: {}, cc: {}, lib: {} }, nj: { k12: {}, cc: {}, lib: {} }, nm: { k12: {}, cc: {}, lib: {} }, nv: { k12: {}, cc: {}, lib: {} }, ny: { k12: {}, cc: {}, lib: {} }, oh: { k12: {}, cc: {}, lib: {} }, ok: { k12: {}, cc: {}, lib: {} }, or: { k12: {}, cc: {}, lib: {} }, pa: { k12: {}, cc: {}, lib: {} }, pr: { k12: {}, cc: {}, lib: {} }, ri: { k12: {}, cc: {}, lib: {} }, sc: { k12: {}, cc: {}, lib: {} }, sd: { cc: {}, lib: {} }, tn: { k12: {}, cc: {}, lib: {} }, tx: { k12: {}, cc: {}, lib: {} }, ut: { k12: {}, cc: {}, lib: {} }, vi: { k12: {}, cc: {}, lib: {} }, vt: { k12: {}, cc: {}, lib: {} }, va: { k12: {}, cc: {}, lib: {} }, wa: { k12: {}, cc: {}, lib: {} }, wi: { k12: {}, cc: {}, lib: {} }, wv: { cc: {} }, wy: { k12: {}, cc: {}, lib: {} }, cloudns: {}, drud: {}, golffan: {}, noip: {}, pointto: {} }, uy: { com: { blogspot: {} }, edu: {}, gub: {}, mil: {}, net: {}, org: {}, nom: {} }, uz: { co: {}, com: {}, net: {}, org: {} }, va: {}, vc: { com: {}, net: {}, org: {}, gov: {}, mil: {}, edu: {}, nom: {} }, ve: { arts: {}, co: {}, com: {}, e12: {}, edu: {}, firm: {}, gob: {}, gov: {}, info: {}, int: {}, mil: {}, net: {}, org: {}, rec: {}, store: {}, tec: {}, web: {} }, vg: { nom: {} }, vi: { co: {}, com: {}, k12: {}, net: {}, org: {} }, vn: { com: {}, net: {}, org: {}, edu: {}, gov: {}, int: {}, ac: {}, biz: {}, info: {}, name: {}, pro: {}, health: {}, blogspot: {} }, vu: { com: {}, edu: {}, net: {}, org: {} }, wf: {}, ws: { com: {}, net: {}, org: {}, gov: {}, edu: {}, cloud66: {}, dyndns: {}, mypets: {} }, yt: {}, xxx: {}, za: { ac: {}, agric: {}, alt: {}, co: { blogspot: {} }, edu: {}, gov: {}, grondar: {}, law: {}, mil: {}, net: {}, ngo: {}, nis: {}, nom: {}, org: {}, school: {}, tm: {}, web: {} }, zm: { ac: {}, biz: {}, co: {}, com: {}, edu: {}, gov: {}, info: {}, mil: {}, net: {}, org: {}, sch: {} }, zw: { ac: {}, co: {}, gov: {}, mil: {}, org: {} }, aaa: {}, aarp: {}, abarth: {}, abb: {}, abbott: {}, abbvie: {}, abc: {}, able: {}, abogado: {}, abudhabi: {}, academy: { official: {} }, accenture: {}, accountant: {}, accountants: {}, aco: {}, active: {}, actor: {}, adac: {}, ads: {}, adult: {}, aeg: {}, aetna: {}, afamilycompany: {}, afl: {}, africa: {}, agakhan: {}, agency: {}, aig: {}, aigo: {}, airbus: {}, airforce: {}, airtel: {}, akdn: {}, alfaromeo: {}, alibaba: {}, alipay: {}, allfinanz: {}, allstate: {}, ally: {}, alsace: {}, alstom: {}, americanexpress: {}, americanfamily: {}, amex: {}, amfam: {}, amica: {}, amsterdam: {}, analytics: {}, android: {}, anquan: {}, anz: {}, aol: {}, apartments: {}, app: {}, apple: {}, aquarelle: {}, arab: {}, aramco: {}, archi: {}, army: {}, art: {}, arte: {}, asda: {}, associates: {}, athleta: {}, attorney: {}, auction: {}, audi: {}, audible: {}, audio: {}, auspost: {}, author: {}, auto: {}, autos: {}, avianca: {}, aws: {}, axa: {}, azure: {}, baby: {}, baidu: {}, banamex: {}, bananarepublic: {}, band: {}, bank: {}, bar: {}, barcelona: {}, barclaycard: {}, barclays: {}, barefoot: {}, bargains: {}, baseball: {}, basketball: {}, bauhaus: {}, bayern: {}, bbc: {}, bbt: {}, bbva: {}, bcg: {}, bcn: {}, beats: {}, beauty: {}, beer: {}, bentley: {}, berlin: {}, best: {}, bestbuy: {}, bet: {}, bharti: {}, bible: {}, bid: {}, bike: {}, bing: {}, bingo: {}, bio: {}, black: {}, blackfriday: {}, blanco: {}, blockbuster: {}, blog: {}, bloomberg: {}, blue: {}, bms: {}, bmw: {}, bnl: {}, bnpparibas: {}, boats: {}, boehringer: {}, bofa: {}, bom: {}, bond: {}, boo: {}, book: {}, booking: {}, bosch: {}, bostik: {}, boston: {}, bot: {}, boutique: {}, box: {}, bradesco: {}, bridgestone: {}, broadway: {}, broker: {}, brother: {}, brussels: {}, budapest: {}, bugatti: {}, build: {}, builders: {}, business: {}, buy: {}, buzz: {}, bzh: {}, cab: {}, cafe: {}, cal: {}, call: {}, calvinklein: {}, cam: {}, camera: {}, camp: {}, cancerresearch: {}, canon: {}, capetown: {}, capital: {}, capitalone: {}, car: {}, caravan: {}, cards: {}, care: {}, career: {}, careers: {}, cars: {}, cartier: {}, casa: {}, case: {}, caseih: {}, cash: {}, casino: {}, catering: {}, catholic: {}, cba: {}, cbn: {}, cbre: {}, cbs: {}, ceb: {}, center: {}, ceo: {}, cern: {}, cfa: {}, cfd: {}, chanel: {}, channel: {}, charity: {}, chase: {}, chat: {}, cheap: {}, chintai: {}, christmas: {}, chrome: {}, chrysler: {}, church: {}, cipriani: {}, circle: {}, cisco: {}, citadel: {}, citi: {}, citic: {}, city: {}, cityeats: {}, claims: {}, cleaning: {}, click: {}, clinic: {}, clinique: {}, clothing: {}, cloud: { linkyard: {}, vapor: {}, trafficplex: {} }, club: { cloudns: {} }, clubmed: {}, coach: {}, codes: {}, coffee: {}, college: {}, cologne: {}, comcast: {}, commbank: {}, community: { ravendb: {} }, company: {}, compare: {}, computer: {}, comsec: {}, condos: {}, construction: {}, consulting: {}, contact: {}, contractors: {}, cooking: {}, cookingchannel: {}, cool: { de: {} }, corsica: {}, country: {}, coupon: {}, coupons: {}, courses: {}, credit: {}, creditcard: {}, creditunion: {}, cricket: {}, crown: {}, crs: {}, cruise: {}, cruises: {}, csc: {}, cuisinella: {}, cymru: {}, cyou: {}, dabur: {}, dad: {}, dance: {}, data: {}, date: {}, dating: {}, datsun: {}, day: {}, dclk: {}, dds: {}, deal: {}, dealer: {}, deals: {}, degree: {}, delivery: {}, dell: {}, deloitte: {}, delta: {}, democrat: {}, dental: {}, dentist: {}, desi: {}, design: {}, dev: {}, dhl: {}, diamonds: {}, diet: {}, digital: {}, direct: {}, directory: {}, discount: {}, discover: {}, dish: {}, diy: {}, dnp: {}, docs: {}, doctor: {}, dodge: {}, dog: {}, doha: {}, domains: {}, dot: {}, download: {}, drive: {}, dtv: {}, dubai: {}, duck: {}, dunlop: {}, duns: {}, dupont: {}, durban: {}, dvag: {}, dvr: {}, earth: {}, eat: {}, eco: {}, edeka: {}, education: {}, email: {}, emerck: {}, energy: {}, engineer: {}, engineering: {}, enterprises: {}, epost: {}, epson: {}, equipment: {}, ericsson: {}, erni: {}, esq: {}, estate: {}, esurance: {}, etisalat: {}, eurovision: {}, eus: { party: { user: {} } }, events: {}, everbank: {}, exchange: {}, expert: {}, exposed: {}, express: {}, extraspace: {}, fage: {}, fail: {}, fairwinds: {}, faith: { ybo: {} }, family: {}, fan: {}, fans: {}, farm: { storj: {} }, farmers: {}, fashion: {}, fast: {}, fedex: {}, feedback: {}, ferrari: {}, ferrero: {}, fiat: {}, fidelity: {}, fido: {}, film: {}, final: {}, finance: {}, financial: {}, fire: {}, firestone: {}, firmdale: {}, fish: {}, fishing: {}, fit: { ptplus: {} }, fitness: {}, flickr: {}, flights: {}, flir: {}, florist: {}, flowers: {}, fly: {}, foo: {}, food: {}, foodnetwork: {}, football: {}, ford: {}, forex: {}, forsale: {}, forum: {}, foundation: {}, fox: {}, free: {}, fresenius: {}, frl: {}, frogans: {}, frontdoor: {}, frontier: {}, ftr: {}, fujitsu: {}, fujixerox: {}, fun: {}, fund: {}, furniture: {}, futbol: {}, fyi: {}, gal: {}, gallery: {}, gallo: {}, gallup: {}, game: {}, games: {}, gap: {}, garden: {}, gbiz: {}, gdn: {}, gea: {}, gent: {}, genting: {}, george: {}, ggee: {}, gift: {}, gifts: {}, gives: {}, giving: {}, glade: {}, glass: {}, gle: {}, global: {}, globo: {}, gmail: {}, gmbh: {}, gmo: {}, gmx: {}, godaddy: {}, gold: {}, goldpoint: {}, golf: {}, goo: {}, goodhands: {}, goodyear: {}, goog: { cloud: {} }, google: {}, gop: {}, got: {}, grainger: {}, graphics: {}, gratis: {}, green: {}, gripe: {}, grocery: {}, group: {}, guardian: {}, gucci: {}, guge: {}, guide: {}, guitars: {}, guru: {}, hair: {}, hamburg: {}, hangout: {}, haus: {}, hbo: {}, hdfc: {}, hdfcbank: {}, health: {}, healthcare: {}, help: {}, helsinki: {}, here: {}, hermes: {}, hgtv: {}, hiphop: {}, hisamitsu: {}, hitachi: {}, hiv: {}, hkt: {}, hockey: {}, holdings: {}, holiday: {}, homedepot: {}, homegoods: {}, homes: {}, homesense: {}, honda: {}, honeywell: {}, horse: {}, hospital: {}, host: { cloudaccess: {}, freesite: {}, pcloud: {} }, hosting: { opencraft: {} }, hot: {}, hoteles: {}, hotels: {}, hotmail: {}, house: {}, how: {}, hsbc: {}, hughes: {}, hyatt: {}, hyundai: {}, ibm: {}, icbc: {}, ice: {}, icu: {}, ieee: {}, ifm: {}, ikano: {}, imamat: {}, imdb: {}, immo: {}, immobilien: {}, inc: {}, industries: {}, infiniti: {}, ing: {}, ink: {}, institute: {}, insurance: {}, insure: {}, intel: {}, international: {}, intuit: {}, investments: {}, ipiranga: {}, irish: {}, iselect: {}, ismaili: {}, ist: {}, istanbul: {}, itau: {}, itv: {}, iveco: {}, iwc: {}, jaguar: {}, java: {}, jcb: {}, jcp: {}, jeep: {}, jetzt: {}, jewelry: {}, jio: {}, jlc: {}, jll: {}, jmp: {}, jnj: {}, joburg: {}, jot: {}, joy: {}, jpmorgan: {}, jprs: {}, juegos: {}, juniper: {}, kaufen: {}, kddi: {}, kerryhotels: {}, kerrylogistics: {}, kerryproperties: {}, kfh: {}, kia: {}, kim: {}, kinder: {}, kindle: {}, kitchen: {}, kiwi: {}, koeln: {}, komatsu: {}, kosher: {}, kpmg: {}, kpn: {}, krd: { co: {}, edu: {} }, kred: {}, kuokgroup: {}, kyoto: {}, lacaixa: {}, ladbrokes: {}, lamborghini: {}, lamer: {}, lancaster: {}, lancia: {}, lancome: {}, land: { static: { dev: {}, sites: {} } }, landrover: {}, lanxess: {}, lasalle: {}, lat: {}, latino: {}, latrobe: {}, law: {}, lawyer: {}, lds: {}, lease: {}, leclerc: {}, lefrak: {}, legal: {}, lego: {}, lexus: {}, lgbt: {}, liaison: {}, lidl: {}, life: {}, lifeinsurance: {}, lifestyle: {}, lighting: {}, like: {}, lilly: {}, limited: {}, limo: {}, lincoln: {}, linde: {}, link: { cyon: {}, mypep: {} }, lipsy: {}, live: {}, living: {}, lixil: {}, llc: {}, loan: {}, loans: {}, locker: {}, locus: {}, loft: {}, lol: {}, london: {}, lotte: {}, lotto: {}, love: {}, lpl: {}, lplfinancial: {}, ltd: {}, ltda: {}, lundbeck: {}, lupin: {}, luxe: {}, luxury: {}, macys: {}, madrid: {}, maif: {}, maison: {}, makeup: {}, man: {}, management: { router: {} }, mango: {}, map: {}, market: {}, marketing: {}, markets: {}, marriott: {}, marshalls: {}, maserati: {}, mattel: {}, mba: {}, mckinsey: {}, med: {}, media: {}, meet: {}, melbourne: {}, meme: {}, memorial: {}, men: {}, menu: {}, meo: {}, merckmsd: {}, metlife: {}, miami: {}, microsoft: {}, mini: {}, mint: {}, mit: {}, mitsubishi: {}, mlb: {}, mls: {}, mma: {}, mobile: {}, mobily: {}, moda: {}, moe: {}, moi: {}, mom: {}, monash: {}, money: {}, monster: {}, mopar: {}, mormon: {}, mortgage: {}, moscow: {}, moto: {}, motorcycles: {}, mov: {}, movie: {}, movistar: {}, msd: {}, mtn: {}, mtr: {}, mutual: {}, nab: {}, nadex: {}, nagoya: {}, nationwide: {}, natura: {}, navy: {}, nba: {}, nec: {}, netbank: {}, netflix: {}, network: {}, neustar: {}, new: {}, newholland: {}, news: {}, next: {}, nextdirect: {}, nexus: {}, nfl: {}, ngo: {}, nhk: {}, nico: {}, nike: {}, nikon: {}, ninja: {}, nissan: {}, nissay: {}, nokia: {}, northwesternmutual: {}, norton: {}, now: {}, nowruz: {}, nowtv: {}, nra: {}, nrw: {}, ntt: {}, nyc: {}, obi: {}, observer: {}, off: {}, office: {}, okinawa: {}, olayan: {}, olayangroup: {}, oldnavy: {}, ollo: {}, omega: {}, one: { homelink: {} }, ong: {}, onl: {}, online: { barsy: {} }, onyourside: {}, ooo: {}, open: {}, oracle: {}, orange: {}, organic: {}, origins: {}, osaka: {}, otsuka: {}, ott: {}, ovh: { nerdpol: {} }, page: {}, panasonic: {}, panerai: {}, paris: {}, pars: {}, partners: {}, parts: {}, party: { ybo: {} }, passagens: {}, pay: {}, pccw: {}, pet: {}, pfizer: {}, pharmacy: {}, phd: {}, philips: {}, phone: {}, photo: {}, photography: {}, photos: {}, physio: {}, piaget: {}, pics: {}, pictet: {}, pictures: { 1337: {} }, pid: {}, pin: {}, ping: {}, pink: {}, pioneer: {}, pizza: {}, place: {}, play: {}, playstation: {}, plumbing: {}, plus: {}, pnc: {}, pohl: {}, poker: {}, politie: {}, porn: {}, pramerica: {}, praxi: {}, press: {}, prime: {}, prod: {}, productions: {}, prof: {}, progressive: {}, promo: {}, properties: {}, property: {}, protection: {}, pru: {}, prudential: {}, pub: {}, pwc: {}, qpon: {}, quebec: {}, quest: {}, qvc: {}, racing: {}, radio: {}, raid: {}, read: {}, realestate: {}, realtor: {}, realty: {}, recipes: {}, red: {}, redstone: {}, redumbrella: {}, rehab: {}, reise: {}, reisen: {}, reit: {}, reliance: {}, ren: {}, rent: {}, rentals: {}, repair: {}, report: {}, republican: {}, rest: {}, restaurant: {}, review: { ybo: {} }, reviews: {}, rexroth: {}, rich: {}, richardli: {}, ricoh: {}, rightathome: {}, ril: {}, rio: {}, rip: { clan: {} }, rmit: {}, rocher: {}, rocks: { myddns: {}, webspace: {} }, rodeo: {}, rogers: {}, room: {}, rsvp: {}, rugby: {}, ruhr: {}, run: { development: {}, ravendb: {} }, rwe: {}, ryukyu: {}, saarland: {}, safe: {}, safety: {}, sakura: {}, sale: {}, salon: {}, samsclub: {}, samsung: {}, sandvik: {}, sandvikcoromant: {}, sanofi: {}, sap: {}, sapo: {}, sarl: {}, sas: {}, save: {}, saxo: {}, sbi: {}, sbs: {}, sca: {}, scb: {}, schaeffler: {}, schmidt: {}, scholarships: {}, school: {}, schule: {}, schwarz: {}, science: { ybo: {} }, scjohnson: {}, scor: {}, scot: {}, search: {}, seat: {}, secure: {}, security: {}, seek: {}, select: {}, sener: {}, services: {}, ses: {}, seven: {}, sew: {}, sex: {}, sexy: {}, sfr: {}, shangrila: {}, sharp: {}, shaw: {}, shell: {}, shia: {}, shiksha: {}, shoes: {}, shop: {}, shopping: {}, shouji: {}, show: {}, showtime: {}, shriram: {}, silk: {}, sina: {}, singles: {}, site: { cyon: {}, byen: {} }, ski: {}, skin: {}, sky: {}, skype: {}, sling: {}, smart: {}, smile: {}, sncf: {}, soccer: {}, social: {}, softbank: {}, software: {}, sohu: {}, solar: {}, solutions: {}, song: {}, sony: {}, soy: {}, space: { stackspace: {}, uber: {}, xs4all: {} }, spiegel: {}, sport: {}, spot: {}, spreadbetting: {}, srl: {}, srt: {}, stada: {}, staples: {}, star: {}, starhub: {}, statebank: {}, statefarm: {}, statoil: {}, stc: {}, stcgroup: {}, stockholm: {}, storage: {}, store: {}, stream: {}, studio: {}, study: {}, style: {}, sucks: {}, supplies: {}, supply: {}, support: { barsy: {} }, surf: {}, surgery: {}, suzuki: {}, swatch: {}, swiftcover: {}, swiss: {}, sydney: {}, symantec: {}, systems: { knightpoint: {} }, tab: {}, taipei: {}, talk: {}, taobao: {}, target: {}, tatamotors: {}, tatar: {}, tattoo: {}, tax: {}, taxi: {}, tci: {}, tdk: {}, team: {}, tech: {}, technology: {}, telecity: {}, telefonica: {}, temasek: {}, tennis: {}, teva: {}, thd: {}, theater: {}, theatre: {}, tiaa: {}, tickets: {}, tienda: {}, tiffany: {}, tips: {}, tires: {}, tirol: {}, tjmaxx: {}, tjx: {}, tkmaxx: {}, tmall: {}, today: {}, tokyo: {}, tools: {}, top: {}, toray: {}, toshiba: {}, total: {}, tours: {}, town: {}, toyota: {}, toys: {}, trade: { ybo: {} }, trading: {}, training: {}, travelchannel: {}, travelers: {}, travelersinsurance: {}, trust: {}, trv: {}, tube: {}, tui: {}, tunes: {}, tushu: {}, tvs: {}, ubank: {}, ubs: {}, uconnect: {}, unicom: {}, university: {}, uno: {}, uol: {}, ups: {}, vacations: {}, vana: {}, vanguard: {}, vegas: {}, ventures: {}, verisign: {}, versicherung: {}, vet: {}, viajes: {}, video: {}, vig: {}, viking: {}, villas: {}, vin: {}, vip: {}, virgin: {}, visa: {}, vision: {}, vista: {}, vistaprint: {}, viva: {}, vivo: {}, vlaanderen: {}, vodka: {}, volkswagen: {}, volvo: {}, vote: {}, voting: {}, voto: {}, voyage: {}, vuelos: {}, wales: {}, walmart: {}, walter: {}, wang: {}, wanggou: {}, warman: {}, watch: {}, watches: {}, weather: {}, weatherchannel: {}, webcam: {}, weber: {}, website: {}, wed: {}, wedding: {}, weibo: {}, weir: {}, whoswho: {}, wien: {}, wiki: {}, williamhill: {}, win: {}, windows: {}, wine: {}, winners: {}, wme: {}, wolterskluwer: {}, woodside: {}, work: {}, works: {}, world: {}, wow: {}, wtc: {}, wtf: {}, xbox: {}, xerox: {}, xfinity: {}, xihuan: {}, xin: {}, xperia: {}, xyz: { blogsite: {}, fhapp: {} }, yachts: {}, yahoo: {}, yamaxun: {}, yandex: {}, yodobashi: {}, yoga: {}, yokohama: {}, you: {}, youtube: {}, yun: {}, zappos: {}, zara: {}, zero: {}, zip: {}, zippo: {}, zone: { lima: {} }, zuerich: {} };
  }
});

// node_modules/aws-cdk-lib/aws-certificatemanager/lib/util.js
var require_util11 = __commonJS({
  "node_modules/aws-cdk-lib/aws-certificatemanager/lib/util.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.getCertificateRegion = exports2.isDnsValidatedCertificate = exports2.apexDomain = void 0;
    var public_suffixes_1 = require_public_suffixes();
    var core_1 = require_core2();
    function apexDomain(domainName) {
      const parts = domainName.split(".").reverse();
      let curr = public_suffixes_1.publicSuffixes;
      const accumulated = [];
      for (const part of parts) {
        if (accumulated.push(part), !(part in curr))
          break;
        curr = curr[part];
      }
      return accumulated.reverse().join(".");
    }
    exports2.apexDomain = apexDomain;
    function isDnsValidatedCertificate(cert) {
      return cert.hasOwnProperty("domainName");
    }
    exports2.isDnsValidatedCertificate = isDnsValidatedCertificate;
    function getCertificateRegion(cert) {
      const { certificateArn, stack } = cert;
      if (isDnsValidatedCertificate(cert)) {
        const requestResource = cert.node.findChild("CertificateRequestorResource").node.defaultChild, { _cfnProperties: properties } = requestResource, { Region: region } = properties;
        if (region && !core_1.Token.isUnresolved(region))
          return region;
      }
      {
        const { region } = core_1.Arn.split(certificateArn, core_1.ArnFormat.SLASH_RESOURCE_NAME);
        if (region && !core_1.Token.isUnresolved(region))
          return region;
      }
      return core_1.Stack.of(stack).region;
    }
    exports2.getCertificateRegion = getCertificateRegion;
  }
});

// node_modules/aws-cdk-lib/aws-certificatemanager/lib/certificate.js
var require_certificate = __commonJS({
  "node_modules/aws-cdk-lib/aws-certificatemanager/lib/certificate.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ValidationMethod = exports2.Certificate = exports2.CertificateValidation = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var certificate_base_1 = require_certificate_base();
    var certificatemanager_generated_1 = require_certificatemanager_generated();
    var util_1 = require_util11();
    var core_1 = require_core2();
    var NAME_TAG = "Name";
    var CertificateValidation = class _CertificateValidation {
      static fromDns(hostedZone) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_IHostedZone(hostedZone);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromDns), error;
        }
        return new _CertificateValidation({ method: ValidationMethod.DNS, hostedZone });
      }
      static fromDnsMultiZone(hostedZones) {
        return new _CertificateValidation({ method: ValidationMethod.DNS, hostedZones });
      }
      static fromEmail(validationDomains) {
        return new _CertificateValidation({ method: ValidationMethod.EMAIL, validationDomains });
      }
      constructor(props) {
        this.props = props, this.method = props.method ?? ValidationMethod.EMAIL;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CertificateValidation[_a] = { fqn: "aws-cdk-lib.aws_certificatemanager.CertificateValidation", version: "2.80.0" }, exports2.CertificateValidation = CertificateValidation;
    var Certificate = class _Certificate extends certificate_base_1.CertificateBase {
      static fromCertificateArn(scope, id, certificateArn) {
        class Import extends certificate_base_1.CertificateBase {
          constructor() {
            super(...arguments), this.certificateArn = certificateArn;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_certificatemanager_CertificateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Certificate), error;
        }
        let validation;
        if (props.validation ? validation = props.validation : props.validationMethod === ValidationMethod.DNS ? validation = CertificateValidation.fromDns() : validation = CertificateValidation.fromEmail(props.validationDomains), !core_1.Token.isUnresolved(props.domainName) && props.domainName.length > 64)
          throw new Error("Domain name must be 64 characters or less");
        const allDomainNames = [props.domainName].concat(props.subjectAlternativeNames || []);
        let certificateTransparencyLoggingPreference;
        props.transparencyLoggingEnabled !== void 0 && (certificateTransparencyLoggingPreference = props.transparencyLoggingEnabled ? "ENABLED" : "DISABLED");
        const cert = new certificatemanager_generated_1.CfnCertificate(this, "Resource", { domainName: props.domainName, subjectAlternativeNames: props.subjectAlternativeNames, domainValidationOptions: renderDomainValidation(validation, allDomainNames), validationMethod: validation.method, certificateTransparencyLoggingPreference });
        core_1.Tags.of(cert).add(NAME_TAG, props.certificateName || this.node.path.slice(0, 255)), this.certificateArn = cert.ref;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, Certificate[_b] = { fqn: "aws-cdk-lib.aws_certificatemanager.Certificate", version: "2.80.0" }, exports2.Certificate = Certificate;
    var ValidationMethod;
    (function(ValidationMethod2) {
      ValidationMethod2.EMAIL = "EMAIL", ValidationMethod2.DNS = "DNS";
    })(ValidationMethod = exports2.ValidationMethod || (exports2.ValidationMethod = {}));
    function renderDomainValidation(validation, domainNames) {
      const domainValidation = [];
      switch (validation.method) {
        case ValidationMethod.DNS:
          for (const domainName of getUniqueDnsDomainNames(domainNames)) {
            const hostedZone = validation.props.hostedZones?.[domainName] ?? validation.props.hostedZone;
            hostedZone && domainValidation.push({ domainName, hostedZoneId: hostedZone.hostedZoneId });
          }
          break;
        case ValidationMethod.EMAIL:
          for (const domainName of domainNames) {
            const validationDomain = validation.props.validationDomains?.[domainName];
            if (!validationDomain && core_1.Token.isUnresolved(domainName))
              throw new Error("When using Tokens for domain names, 'validationDomains' needs to be supplied");
            domainValidation.push({ domainName, validationDomain: validationDomain ?? (0, util_1.apexDomain)(domainName) });
          }
          break;
        default:
          throw new Error(`Unknown validation method ${validation.method}`);
      }
      return domainValidation.length !== 0 ? domainValidation : void 0;
    }
    function getUniqueDnsDomainNames(domainNames) {
      return domainNames.filter((domain) => core_1.Token.isUnresolved(domain) || !domain.startsWith("*.") || !domainNames.includes(domain.replace("*.", "")));
    }
  }
});

// node_modules/aws-cdk-lib/aws-certificatemanager/lib/dns-validated-certificate.js
var require_dns_validated_certificate = __commonJS({
  "node_modules/aws-cdk-lib/aws-certificatemanager/lib/dns-validated-certificate.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DnsValidatedCertificate = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var path = require("path");
    var certificate_base_1 = require_certificate_base();
    var iam = require_aws_iam();
    var lambda2 = require_aws_lambda();
    var cdk = require_core2();
    var core_1 = require_core2();
    var custom_resources_1 = require_custom_resources();
    var DnsValidatedCertificate = class _DnsValidatedCertificate extends certificate_base_1.CertificateBase {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_certificatemanager.DnsValidatedCertificate", "use {@link Certificate } instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_certificatemanager_DnsValidatedCertificateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _DnsValidatedCertificate), error;
        }
        if (this.region = props.region, this.domainName = props.domainName, !core_1.Token.isUnresolved(props.domainName) && props.domainName.length > 64)
          throw new Error("Domain name must be 64 characters or less");
        this.normalizedZoneName = props.hostedZone.zoneName, this.normalizedZoneName.endsWith(".") && (this.normalizedZoneName = this.normalizedZoneName.substring(0, this.normalizedZoneName.length - 1)), this.hostedZoneId = props.hostedZone.hostedZoneId.replace(/^\/hostedzone\//, ""), this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::CertificateManager::Certificate");
        let certificateTransparencyLoggingPreference;
        props.transparencyLoggingEnabled !== void 0 && (certificateTransparencyLoggingPreference = props.transparencyLoggingEnabled ? "ENABLED" : "DISABLED");
        const requestorFunction = new lambda2.Function(this, "CertificateRequestorFunction", { code: lambda2.Code.fromAsset(path.resolve(__dirname, "..", "lambda-packages", "dns_validated_certificate_handler", "lib")), handler: "index.certificateRequestHandler", runtime: (0, custom_resources_1.builtInCustomResourceNodeRuntime)(this), timeout: cdk.Duration.minutes(15), role: props.customResourceRole });
        requestorFunction.addToRolePolicy(new iam.PolicyStatement({ actions: ["acm:RequestCertificate", "acm:DescribeCertificate", "acm:DeleteCertificate", "acm:AddTagsToCertificate"], resources: ["*"] })), requestorFunction.addToRolePolicy(new iam.PolicyStatement({ actions: ["route53:GetChange"], resources: ["*"] })), requestorFunction.addToRolePolicy(new iam.PolicyStatement({ actions: ["route53:changeResourceRecordSets"], resources: [`arn:${cdk.Stack.of(requestorFunction).partition}:route53:::hostedzone/${this.hostedZoneId}`], conditions: { "ForAllValues:StringEquals": { "route53:ChangeResourceRecordSetsRecordTypes": ["CNAME"], "route53:ChangeResourceRecordSetsActions": props.cleanupRoute53Records ? ["UPSERT", "DELETE"] : ["UPSERT"] }, "ForAllValues:StringLike": { "route53:ChangeResourceRecordSetsNormalizedRecordNames": [addWildcard(props.domainName), ...(props.subjectAlternativeNames ?? []).map((d) => addWildcard(d))] } } }));
        const certificate = new cdk.CustomResource(this, "CertificateRequestorResource", { serviceToken: requestorFunction.functionArn, properties: { DomainName: props.domainName, SubjectAlternativeNames: cdk.Lazy.list({ produce: () => props.subjectAlternativeNames }, { omitEmpty: true }), CertificateTransparencyLoggingPreference: certificateTransparencyLoggingPreference, HostedZoneId: this.hostedZoneId, Region: props.region, Route53Endpoint: props.route53Endpoint, RemovalPolicy: cdk.Lazy.any({ produce: () => this._removalPolicy }), CleanupRecords: props.cleanupRoute53Records ? "true" : void 0, Tags: cdk.Lazy.list({ produce: () => this.tags.renderTags() }) } });
        this.certificateArn = certificate.getAtt("Arn").toString(), this.node.addValidation({ validate: () => this.validateDnsValidatedCertificate() });
      }
      applyRemovalPolicy(policy) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_certificatemanager.DnsValidatedCertificate#applyRemovalPolicy", "use {@link Certificate } instead"), jsiiDeprecationWarnings.aws_cdk_lib_RemovalPolicy(policy);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.applyRemovalPolicy), error;
        }
        this._removalPolicy = policy;
      }
      validateDnsValidatedCertificate() {
        const errors = [];
        return !cdk.Token.isUnresolved(this.normalizedZoneName) && this.domainName !== this.normalizedZoneName && !this.domainName.endsWith("." + this.normalizedZoneName) && errors.push(`DNS zone ${this.normalizedZoneName} is not authoritative for certificate domain name ${this.domainName}`), errors;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, DnsValidatedCertificate[_a] = { fqn: "aws-cdk-lib.aws_certificatemanager.DnsValidatedCertificate", version: "2.80.0" }, exports2.DnsValidatedCertificate = DnsValidatedCertificate;
    function addWildcard(domainName) {
      return domainName.startsWith("*.") ? domainName : `*.${domainName}`;
    }
  }
});

// node_modules/aws-cdk-lib/aws-certificatemanager/lib/private-certificate.js
var require_private_certificate = __commonJS({
  "node_modules/aws-cdk-lib/aws-certificatemanager/lib/private-certificate.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PrivateCertificate = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var certificate_base_1 = require_certificate_base();
    var certificatemanager_generated_1 = require_certificatemanager_generated();
    var PrivateCertificate = class _PrivateCertificate extends certificate_base_1.CertificateBase {
      static fromCertificateArn(scope, id, certificateArn) {
        class Import extends certificate_base_1.CertificateBase {
          constructor() {
            super(...arguments), this.certificateArn = certificateArn;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_certificatemanager_PrivateCertificateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _PrivateCertificate), error;
        }
        const cert = new certificatemanager_generated_1.CfnCertificate(this, "Resource", { domainName: props.domainName, subjectAlternativeNames: props.subjectAlternativeNames, certificateAuthorityArn: props.certificateAuthority.certificateAuthorityArn });
        this.certificateArn = cert.ref;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, PrivateCertificate[_a] = { fqn: "aws-cdk-lib.aws_certificatemanager.PrivateCertificate", version: "2.80.0" }, exports2.PrivateCertificate = PrivateCertificate;
  }
});

// node_modules/aws-cdk-lib/aws-certificatemanager/lib/index.js
var require_lib27 = __commonJS({
  "node_modules/aws-cdk-lib/aws-certificatemanager/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_certificate(), exports2), __exportStar(require_dns_validated_certificate(), exports2), __exportStar(require_private_certificate(), exports2), __exportStar(require_util11(), exports2), __exportStar(require_certificatemanager_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-certificatemanager/index.js
var require_aws_certificatemanager = __commonJS({
  "node_modules/aws-cdk-lib/aws-certificatemanager/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib27(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-route53/lib/alias-record-target.js
var require_alias_record_target = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53/lib/alias-record-target.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-route53/lib/route53.generated.js
var require_route53_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53/lib/route53.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnRecordSetGroup = exports2.CfnRecordSet = exports2.CfnKeySigningKey = exports2.CfnHostedZone = exports2.CfnHealthCheck = exports2.CfnDNSSEC = exports2.CfnCidrCollection = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnCidrCollectionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("locations", cdk.listValidator(CfnCidrCollection_LocationPropertyValidator))(properties.locations)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "CfnCidrCollectionProps"');
    }
    function cfnCidrCollectionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCidrCollectionPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Locations: cdk.listMapper(cfnCidrCollectionLocationPropertyToCloudFormation)(properties.locations) }) : properties;
    }
    function CfnCidrCollectionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("locations", "Locations", properties.Locations != null ? cfn_parse.FromCloudFormation.getArray(CfnCidrCollectionLocationPropertyFromCloudFormation)(properties.Locations) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCidrCollection = class _CfnCidrCollection extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCidrCollectionPropsFromCloudFormation(resourceProperties), ret = new _CfnCidrCollection(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCidrCollection.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_CfnCidrCollectionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCidrCollection), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.locations = props.locations;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCidrCollection.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, locations: this.locations };
      }
      renderProperties(props) {
        return cfnCidrCollectionPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnCidrCollection[_a] = { fqn: "aws-cdk-lib.aws_route53.CfnCidrCollection", version: "2.80.0" }, CfnCidrCollection.CFN_RESOURCE_TYPE_NAME = "AWS::Route53::CidrCollection", exports2.CfnCidrCollection = CfnCidrCollection;
    function CfnCidrCollection_LocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cidrList", cdk.requiredValidator)(properties.cidrList)), errors.collect(cdk.propertyValidator("cidrList", cdk.listValidator(cdk.validateString))(properties.cidrList)), errors.collect(cdk.propertyValidator("locationName", cdk.requiredValidator)(properties.locationName)), errors.collect(cdk.propertyValidator("locationName", cdk.validateString)(properties.locationName)), errors.wrap('supplied properties not correct for "LocationProperty"');
    }
    function cfnCidrCollectionLocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCidrCollection_LocationPropertyValidator(properties).assertSuccess(), { CidrList: cdk.listMapper(cdk.stringToCloudFormation)(properties.cidrList), LocationName: cdk.stringToCloudFormation(properties.locationName) }) : properties;
    }
    function CfnCidrCollectionLocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cidrList", "CidrList", cfn_parse.FromCloudFormation.getStringArray(properties.CidrList)), ret.addPropertyResult("locationName", "LocationName", cfn_parse.FromCloudFormation.getString(properties.LocationName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDNSSECPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("hostedZoneId", cdk.requiredValidator)(properties.hostedZoneId)), errors.collect(cdk.propertyValidator("hostedZoneId", cdk.validateString)(properties.hostedZoneId)), errors.wrap('supplied properties not correct for "CfnDNSSECProps"');
    }
    function cfnDNSSECPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDNSSECPropsValidator(properties).assertSuccess(), { HostedZoneId: cdk.stringToCloudFormation(properties.hostedZoneId) }) : properties;
    }
    function CfnDNSSECPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("hostedZoneId", "HostedZoneId", cfn_parse.FromCloudFormation.getString(properties.HostedZoneId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDNSSEC = class _CfnDNSSEC extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDNSSECPropsFromCloudFormation(resourceProperties), ret = new _CfnDNSSEC(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDNSSEC.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_CfnDNSSECProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDNSSEC), error;
        }
        cdk.requireProperty(props, "hostedZoneId", this), this.hostedZoneId = props.hostedZoneId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDNSSEC.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { hostedZoneId: this.hostedZoneId };
      }
      renderProperties(props) {
        return cfnDNSSECPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnDNSSEC[_b] = { fqn: "aws-cdk-lib.aws_route53.CfnDNSSEC", version: "2.80.0" }, CfnDNSSEC.CFN_RESOURCE_TYPE_NAME = "AWS::Route53::DNSSEC", exports2.CfnDNSSEC = CfnDNSSEC;
    function CfnHealthCheckPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("healthCheckConfig", cdk.requiredValidator)(properties.healthCheckConfig)), errors.collect(cdk.propertyValidator("healthCheckConfig", CfnHealthCheck_HealthCheckConfigPropertyValidator)(properties.healthCheckConfig)), errors.collect(cdk.propertyValidator("healthCheckTags", cdk.listValidator(CfnHealthCheck_HealthCheckTagPropertyValidator))(properties.healthCheckTags)), errors.wrap('supplied properties not correct for "CfnHealthCheckProps"');
    }
    function cfnHealthCheckPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHealthCheckPropsValidator(properties).assertSuccess(), { HealthCheckConfig: cfnHealthCheckHealthCheckConfigPropertyToCloudFormation(properties.healthCheckConfig), HealthCheckTags: cdk.listMapper(cfnHealthCheckHealthCheckTagPropertyToCloudFormation)(properties.healthCheckTags) }) : properties;
    }
    function CfnHealthCheckPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("healthCheckConfig", "HealthCheckConfig", CfnHealthCheckHealthCheckConfigPropertyFromCloudFormation(properties.HealthCheckConfig)), ret.addPropertyResult("healthCheckTags", "HealthCheckTags", properties.HealthCheckTags != null ? cfn_parse.FromCloudFormation.getArray(CfnHealthCheckHealthCheckTagPropertyFromCloudFormation)(properties.HealthCheckTags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnHealthCheck = class _CfnHealthCheck extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnHealthCheckPropsFromCloudFormation(resourceProperties), ret = new _CfnHealthCheck(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnHealthCheck.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_CfnHealthCheckProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnHealthCheck), error;
        }
        cdk.requireProperty(props, "healthCheckConfig", this), this.attrHealthCheckId = cdk.Token.asString(this.getAtt("HealthCheckId", cdk.ResolutionTypeHint.STRING)), this.healthCheckConfig = props.healthCheckConfig, this.healthCheckTags = props.healthCheckTags;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnHealthCheck.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { healthCheckConfig: this.healthCheckConfig, healthCheckTags: this.healthCheckTags };
      }
      renderProperties(props) {
        return cfnHealthCheckPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnHealthCheck[_c] = { fqn: "aws-cdk-lib.aws_route53.CfnHealthCheck", version: "2.80.0" }, CfnHealthCheck.CFN_RESOURCE_TYPE_NAME = "AWS::Route53::HealthCheck", exports2.CfnHealthCheck = CfnHealthCheck;
    function CfnHealthCheck_AlarmIdentifierPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("region", cdk.requiredValidator)(properties.region)), errors.collect(cdk.propertyValidator("region", cdk.validateString)(properties.region)), errors.wrap('supplied properties not correct for "AlarmIdentifierProperty"');
    }
    function cfnHealthCheckAlarmIdentifierPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHealthCheck_AlarmIdentifierPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Region: cdk.stringToCloudFormation(properties.region) }) : properties;
    }
    function CfnHealthCheckAlarmIdentifierPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("region", "Region", cfn_parse.FromCloudFormation.getString(properties.Region)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnHealthCheck_HealthCheckConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alarmIdentifier", CfnHealthCheck_AlarmIdentifierPropertyValidator)(properties.alarmIdentifier)), errors.collect(cdk.propertyValidator("childHealthChecks", cdk.listValidator(cdk.validateString))(properties.childHealthChecks)), errors.collect(cdk.propertyValidator("enableSni", cdk.validateBoolean)(properties.enableSni)), errors.collect(cdk.propertyValidator("failureThreshold", cdk.validateNumber)(properties.failureThreshold)), errors.collect(cdk.propertyValidator("fullyQualifiedDomainName", cdk.validateString)(properties.fullyQualifiedDomainName)), errors.collect(cdk.propertyValidator("healthThreshold", cdk.validateNumber)(properties.healthThreshold)), errors.collect(cdk.propertyValidator("ipAddress", cdk.validateString)(properties.ipAddress)), errors.collect(cdk.propertyValidator("insufficientDataHealthStatus", cdk.validateString)(properties.insufficientDataHealthStatus)), errors.collect(cdk.propertyValidator("inverted", cdk.validateBoolean)(properties.inverted)), errors.collect(cdk.propertyValidator("measureLatency", cdk.validateBoolean)(properties.measureLatency)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("regions", cdk.listValidator(cdk.validateString))(properties.regions)), errors.collect(cdk.propertyValidator("requestInterval", cdk.validateNumber)(properties.requestInterval)), errors.collect(cdk.propertyValidator("resourcePath", cdk.validateString)(properties.resourcePath)), errors.collect(cdk.propertyValidator("routingControlArn", cdk.validateString)(properties.routingControlArn)), errors.collect(cdk.propertyValidator("searchString", cdk.validateString)(properties.searchString)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "HealthCheckConfigProperty"');
    }
    function cfnHealthCheckHealthCheckConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHealthCheck_HealthCheckConfigPropertyValidator(properties).assertSuccess(), { AlarmIdentifier: cfnHealthCheckAlarmIdentifierPropertyToCloudFormation(properties.alarmIdentifier), ChildHealthChecks: cdk.listMapper(cdk.stringToCloudFormation)(properties.childHealthChecks), EnableSNI: cdk.booleanToCloudFormation(properties.enableSni), FailureThreshold: cdk.numberToCloudFormation(properties.failureThreshold), FullyQualifiedDomainName: cdk.stringToCloudFormation(properties.fullyQualifiedDomainName), HealthThreshold: cdk.numberToCloudFormation(properties.healthThreshold), IPAddress: cdk.stringToCloudFormation(properties.ipAddress), InsufficientDataHealthStatus: cdk.stringToCloudFormation(properties.insufficientDataHealthStatus), Inverted: cdk.booleanToCloudFormation(properties.inverted), MeasureLatency: cdk.booleanToCloudFormation(properties.measureLatency), Port: cdk.numberToCloudFormation(properties.port), Regions: cdk.listMapper(cdk.stringToCloudFormation)(properties.regions), RequestInterval: cdk.numberToCloudFormation(properties.requestInterval), ResourcePath: cdk.stringToCloudFormation(properties.resourcePath), RoutingControlArn: cdk.stringToCloudFormation(properties.routingControlArn), SearchString: cdk.stringToCloudFormation(properties.searchString), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnHealthCheckHealthCheckConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alarmIdentifier", "AlarmIdentifier", properties.AlarmIdentifier != null ? CfnHealthCheckAlarmIdentifierPropertyFromCloudFormation(properties.AlarmIdentifier) : void 0), ret.addPropertyResult("childHealthChecks", "ChildHealthChecks", properties.ChildHealthChecks != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ChildHealthChecks) : void 0), ret.addPropertyResult("enableSni", "EnableSNI", properties.EnableSNI != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableSNI) : void 0), ret.addPropertyResult("failureThreshold", "FailureThreshold", properties.FailureThreshold != null ? cfn_parse.FromCloudFormation.getNumber(properties.FailureThreshold) : void 0), ret.addPropertyResult("fullyQualifiedDomainName", "FullyQualifiedDomainName", properties.FullyQualifiedDomainName != null ? cfn_parse.FromCloudFormation.getString(properties.FullyQualifiedDomainName) : void 0), ret.addPropertyResult("healthThreshold", "HealthThreshold", properties.HealthThreshold != null ? cfn_parse.FromCloudFormation.getNumber(properties.HealthThreshold) : void 0), ret.addPropertyResult("ipAddress", "IPAddress", properties.IPAddress != null ? cfn_parse.FromCloudFormation.getString(properties.IPAddress) : void 0), ret.addPropertyResult("insufficientDataHealthStatus", "InsufficientDataHealthStatus", properties.InsufficientDataHealthStatus != null ? cfn_parse.FromCloudFormation.getString(properties.InsufficientDataHealthStatus) : void 0), ret.addPropertyResult("inverted", "Inverted", properties.Inverted != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Inverted) : void 0), ret.addPropertyResult("measureLatency", "MeasureLatency", properties.MeasureLatency != null ? cfn_parse.FromCloudFormation.getBoolean(properties.MeasureLatency) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addPropertyResult("regions", "Regions", properties.Regions != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Regions) : void 0), ret.addPropertyResult("requestInterval", "RequestInterval", properties.RequestInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.RequestInterval) : void 0), ret.addPropertyResult("resourcePath", "ResourcePath", properties.ResourcePath != null ? cfn_parse.FromCloudFormation.getString(properties.ResourcePath) : void 0), ret.addPropertyResult("routingControlArn", "RoutingControlArn", properties.RoutingControlArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoutingControlArn) : void 0), ret.addPropertyResult("searchString", "SearchString", properties.SearchString != null ? cfn_parse.FromCloudFormation.getString(properties.SearchString) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnHealthCheck_HealthCheckTagPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "HealthCheckTagProperty"');
    }
    function cfnHealthCheckHealthCheckTagPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHealthCheck_HealthCheckTagPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnHealthCheckHealthCheckTagPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnHostedZonePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("hostedZoneConfig", CfnHostedZone_HostedZoneConfigPropertyValidator)(properties.hostedZoneConfig)), errors.collect(cdk.propertyValidator("hostedZoneTags", cdk.listValidator(CfnHostedZone_HostedZoneTagPropertyValidator))(properties.hostedZoneTags)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("queryLoggingConfig", CfnHostedZone_QueryLoggingConfigPropertyValidator)(properties.queryLoggingConfig)), errors.collect(cdk.propertyValidator("vpcs", cdk.listValidator(CfnHostedZone_VPCPropertyValidator))(properties.vpcs)), errors.wrap('supplied properties not correct for "CfnHostedZoneProps"');
    }
    function cfnHostedZonePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHostedZonePropsValidator(properties).assertSuccess(), { HostedZoneConfig: cfnHostedZoneHostedZoneConfigPropertyToCloudFormation(properties.hostedZoneConfig), HostedZoneTags: cdk.listMapper(cfnHostedZoneHostedZoneTagPropertyToCloudFormation)(properties.hostedZoneTags), Name: cdk.stringToCloudFormation(properties.name), QueryLoggingConfig: cfnHostedZoneQueryLoggingConfigPropertyToCloudFormation(properties.queryLoggingConfig), VPCs: cdk.listMapper(cfnHostedZoneVPCPropertyToCloudFormation)(properties.vpcs) }) : properties;
    }
    function CfnHostedZonePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("hostedZoneConfig", "HostedZoneConfig", properties.HostedZoneConfig != null ? CfnHostedZoneHostedZoneConfigPropertyFromCloudFormation(properties.HostedZoneConfig) : void 0), ret.addPropertyResult("hostedZoneTags", "HostedZoneTags", properties.HostedZoneTags != null ? cfn_parse.FromCloudFormation.getArray(CfnHostedZoneHostedZoneTagPropertyFromCloudFormation)(properties.HostedZoneTags) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("queryLoggingConfig", "QueryLoggingConfig", properties.QueryLoggingConfig != null ? CfnHostedZoneQueryLoggingConfigPropertyFromCloudFormation(properties.QueryLoggingConfig) : void 0), ret.addPropertyResult("vpcs", "VPCs", properties.VPCs != null ? cfn_parse.FromCloudFormation.getArray(CfnHostedZoneVPCPropertyFromCloudFormation)(properties.VPCs) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnHostedZone = class _CfnHostedZone extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnHostedZonePropsFromCloudFormation(resourceProperties), ret = new _CfnHostedZone(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnHostedZone.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_CfnHostedZoneProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnHostedZone), error;
        }
        this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrNameServers = cdk.Token.asList(this.getAtt("NameServers", cdk.ResolutionTypeHint.STRING_LIST)), this.hostedZoneConfig = props.hostedZoneConfig, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Route53::HostedZone", props.hostedZoneTags, { tagPropertyName: "hostedZoneTags" }), this.name = props.name, this.queryLoggingConfig = props.queryLoggingConfig, this.vpcs = props.vpcs;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnHostedZone.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { hostedZoneConfig: this.hostedZoneConfig, hostedZoneTags: this.tags.renderTags(), name: this.name, queryLoggingConfig: this.queryLoggingConfig, vpcs: this.vpcs };
      }
      renderProperties(props) {
        return cfnHostedZonePropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnHostedZone[_d] = { fqn: "aws-cdk-lib.aws_route53.CfnHostedZone", version: "2.80.0" }, CfnHostedZone.CFN_RESOURCE_TYPE_NAME = "AWS::Route53::HostedZone", exports2.CfnHostedZone = CfnHostedZone;
    function CfnHostedZone_HostedZoneConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("comment", cdk.validateString)(properties.comment)), errors.wrap('supplied properties not correct for "HostedZoneConfigProperty"');
    }
    function cfnHostedZoneHostedZoneConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHostedZone_HostedZoneConfigPropertyValidator(properties).assertSuccess(), { Comment: cdk.stringToCloudFormation(properties.comment) }) : properties;
    }
    function CfnHostedZoneHostedZoneConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("comment", "Comment", properties.Comment != null ? cfn_parse.FromCloudFormation.getString(properties.Comment) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnHostedZone_HostedZoneTagPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "HostedZoneTagProperty"');
    }
    function cfnHostedZoneHostedZoneTagPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHostedZone_HostedZoneTagPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnHostedZoneHostedZoneTagPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnHostedZone_QueryLoggingConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchLogsLogGroupArn", cdk.requiredValidator)(properties.cloudWatchLogsLogGroupArn)), errors.collect(cdk.propertyValidator("cloudWatchLogsLogGroupArn", cdk.validateString)(properties.cloudWatchLogsLogGroupArn)), errors.wrap('supplied properties not correct for "QueryLoggingConfigProperty"');
    }
    function cfnHostedZoneQueryLoggingConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHostedZone_QueryLoggingConfigPropertyValidator(properties).assertSuccess(), { CloudWatchLogsLogGroupArn: cdk.stringToCloudFormation(properties.cloudWatchLogsLogGroupArn) }) : properties;
    }
    function CfnHostedZoneQueryLoggingConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchLogsLogGroupArn", "CloudWatchLogsLogGroupArn", cfn_parse.FromCloudFormation.getString(properties.CloudWatchLogsLogGroupArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnHostedZone_VPCPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("vpcId", cdk.requiredValidator)(properties.vpcId)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.collect(cdk.propertyValidator("vpcRegion", cdk.requiredValidator)(properties.vpcRegion)), errors.collect(cdk.propertyValidator("vpcRegion", cdk.validateString)(properties.vpcRegion)), errors.wrap('supplied properties not correct for "VPCProperty"');
    }
    function cfnHostedZoneVPCPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHostedZone_VPCPropertyValidator(properties).assertSuccess(), { VPCId: cdk.stringToCloudFormation(properties.vpcId), VPCRegion: cdk.stringToCloudFormation(properties.vpcRegion) }) : properties;
    }
    function CfnHostedZoneVPCPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("vpcId", "VPCId", cfn_parse.FromCloudFormation.getString(properties.VPCId)), ret.addPropertyResult("vpcRegion", "VPCRegion", cfn_parse.FromCloudFormation.getString(properties.VPCRegion)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnKeySigningKeyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("hostedZoneId", cdk.requiredValidator)(properties.hostedZoneId)), errors.collect(cdk.propertyValidator("hostedZoneId", cdk.validateString)(properties.hostedZoneId)), errors.collect(cdk.propertyValidator("keyManagementServiceArn", cdk.requiredValidator)(properties.keyManagementServiceArn)), errors.collect(cdk.propertyValidator("keyManagementServiceArn", cdk.validateString)(properties.keyManagementServiceArn)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("status", cdk.requiredValidator)(properties.status)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "CfnKeySigningKeyProps"');
    }
    function cfnKeySigningKeyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnKeySigningKeyPropsValidator(properties).assertSuccess(), { HostedZoneId: cdk.stringToCloudFormation(properties.hostedZoneId), KeyManagementServiceArn: cdk.stringToCloudFormation(properties.keyManagementServiceArn), Name: cdk.stringToCloudFormation(properties.name), Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnKeySigningKeyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("hostedZoneId", "HostedZoneId", cfn_parse.FromCloudFormation.getString(properties.HostedZoneId)), ret.addPropertyResult("keyManagementServiceArn", "KeyManagementServiceArn", cfn_parse.FromCloudFormation.getString(properties.KeyManagementServiceArn)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("status", "Status", cfn_parse.FromCloudFormation.getString(properties.Status)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnKeySigningKey = class _CfnKeySigningKey extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnKeySigningKeyPropsFromCloudFormation(resourceProperties), ret = new _CfnKeySigningKey(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnKeySigningKey.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_CfnKeySigningKeyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnKeySigningKey), error;
        }
        cdk.requireProperty(props, "hostedZoneId", this), cdk.requireProperty(props, "keyManagementServiceArn", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "status", this), this.hostedZoneId = props.hostedZoneId, this.keyManagementServiceArn = props.keyManagementServiceArn, this.name = props.name, this.status = props.status;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnKeySigningKey.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { hostedZoneId: this.hostedZoneId, keyManagementServiceArn: this.keyManagementServiceArn, name: this.name, status: this.status };
      }
      renderProperties(props) {
        return cfnKeySigningKeyPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnKeySigningKey[_e] = { fqn: "aws-cdk-lib.aws_route53.CfnKeySigningKey", version: "2.80.0" }, CfnKeySigningKey.CFN_RESOURCE_TYPE_NAME = "AWS::Route53::KeySigningKey", exports2.CfnKeySigningKey = CfnKeySigningKey;
    function CfnRecordSetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aliasTarget", CfnRecordSet_AliasTargetPropertyValidator)(properties.aliasTarget)), errors.collect(cdk.propertyValidator("cidrRoutingConfig", CfnRecordSet_CidrRoutingConfigPropertyValidator)(properties.cidrRoutingConfig)), errors.collect(cdk.propertyValidator("comment", cdk.validateString)(properties.comment)), errors.collect(cdk.propertyValidator("failover", cdk.validateString)(properties.failover)), errors.collect(cdk.propertyValidator("geoLocation", CfnRecordSet_GeoLocationPropertyValidator)(properties.geoLocation)), errors.collect(cdk.propertyValidator("healthCheckId", cdk.validateString)(properties.healthCheckId)), errors.collect(cdk.propertyValidator("hostedZoneId", cdk.validateString)(properties.hostedZoneId)), errors.collect(cdk.propertyValidator("hostedZoneName", cdk.validateString)(properties.hostedZoneName)), errors.collect(cdk.propertyValidator("multiValueAnswer", cdk.validateBoolean)(properties.multiValueAnswer)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("region", cdk.validateString)(properties.region)), errors.collect(cdk.propertyValidator("resourceRecords", cdk.listValidator(cdk.validateString))(properties.resourceRecords)), errors.collect(cdk.propertyValidator("setIdentifier", cdk.validateString)(properties.setIdentifier)), errors.collect(cdk.propertyValidator("ttl", cdk.validateString)(properties.ttl)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("weight", cdk.validateNumber)(properties.weight)), errors.wrap('supplied properties not correct for "CfnRecordSetProps"');
    }
    function cfnRecordSetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRecordSetPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Type: cdk.stringToCloudFormation(properties.type), AliasTarget: cfnRecordSetAliasTargetPropertyToCloudFormation(properties.aliasTarget), CidrRoutingConfig: cfnRecordSetCidrRoutingConfigPropertyToCloudFormation(properties.cidrRoutingConfig), Comment: cdk.stringToCloudFormation(properties.comment), Failover: cdk.stringToCloudFormation(properties.failover), GeoLocation: cfnRecordSetGeoLocationPropertyToCloudFormation(properties.geoLocation), HealthCheckId: cdk.stringToCloudFormation(properties.healthCheckId), HostedZoneId: cdk.stringToCloudFormation(properties.hostedZoneId), HostedZoneName: cdk.stringToCloudFormation(properties.hostedZoneName), MultiValueAnswer: cdk.booleanToCloudFormation(properties.multiValueAnswer), Region: cdk.stringToCloudFormation(properties.region), ResourceRecords: cdk.listMapper(cdk.stringToCloudFormation)(properties.resourceRecords), SetIdentifier: cdk.stringToCloudFormation(properties.setIdentifier), TTL: cdk.stringToCloudFormation(properties.ttl), Weight: cdk.numberToCloudFormation(properties.weight) }) : properties;
    }
    function CfnRecordSetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("aliasTarget", "AliasTarget", properties.AliasTarget != null ? CfnRecordSetAliasTargetPropertyFromCloudFormation(properties.AliasTarget) : void 0), ret.addPropertyResult("cidrRoutingConfig", "CidrRoutingConfig", properties.CidrRoutingConfig != null ? CfnRecordSetCidrRoutingConfigPropertyFromCloudFormation(properties.CidrRoutingConfig) : void 0), ret.addPropertyResult("comment", "Comment", properties.Comment != null ? cfn_parse.FromCloudFormation.getString(properties.Comment) : void 0), ret.addPropertyResult("failover", "Failover", properties.Failover != null ? cfn_parse.FromCloudFormation.getString(properties.Failover) : void 0), ret.addPropertyResult("geoLocation", "GeoLocation", properties.GeoLocation != null ? CfnRecordSetGeoLocationPropertyFromCloudFormation(properties.GeoLocation) : void 0), ret.addPropertyResult("healthCheckId", "HealthCheckId", properties.HealthCheckId != null ? cfn_parse.FromCloudFormation.getString(properties.HealthCheckId) : void 0), ret.addPropertyResult("hostedZoneId", "HostedZoneId", properties.HostedZoneId != null ? cfn_parse.FromCloudFormation.getString(properties.HostedZoneId) : void 0), ret.addPropertyResult("hostedZoneName", "HostedZoneName", properties.HostedZoneName != null ? cfn_parse.FromCloudFormation.getString(properties.HostedZoneName) : void 0), ret.addPropertyResult("multiValueAnswer", "MultiValueAnswer", properties.MultiValueAnswer != null ? cfn_parse.FromCloudFormation.getBoolean(properties.MultiValueAnswer) : void 0), ret.addPropertyResult("region", "Region", properties.Region != null ? cfn_parse.FromCloudFormation.getString(properties.Region) : void 0), ret.addPropertyResult("resourceRecords", "ResourceRecords", properties.ResourceRecords != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ResourceRecords) : void 0), ret.addPropertyResult("setIdentifier", "SetIdentifier", properties.SetIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.SetIdentifier) : void 0), ret.addPropertyResult("ttl", "TTL", properties.TTL != null ? cfn_parse.FromCloudFormation.getString(properties.TTL) : void 0), ret.addPropertyResult("weight", "Weight", properties.Weight != null ? cfn_parse.FromCloudFormation.getNumber(properties.Weight) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRecordSet = class _CfnRecordSet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRecordSetPropsFromCloudFormation(resourceProperties), ret = new _CfnRecordSet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRecordSet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_CfnRecordSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRecordSet), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "type", this), this.name = props.name, this.type = props.type, this.aliasTarget = props.aliasTarget, this.cidrRoutingConfig = props.cidrRoutingConfig, this.comment = props.comment, this.failover = props.failover, this.geoLocation = props.geoLocation, this.healthCheckId = props.healthCheckId, this.hostedZoneId = props.hostedZoneId, this.hostedZoneName = props.hostedZoneName, this.multiValueAnswer = props.multiValueAnswer, this.region = props.region, this.resourceRecords = props.resourceRecords, this.setIdentifier = props.setIdentifier, this.ttl = props.ttl, this.weight = props.weight;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRecordSet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, type: this.type, aliasTarget: this.aliasTarget, cidrRoutingConfig: this.cidrRoutingConfig, comment: this.comment, failover: this.failover, geoLocation: this.geoLocation, healthCheckId: this.healthCheckId, hostedZoneId: this.hostedZoneId, hostedZoneName: this.hostedZoneName, multiValueAnswer: this.multiValueAnswer, region: this.region, resourceRecords: this.resourceRecords, setIdentifier: this.setIdentifier, ttl: this.ttl, weight: this.weight };
      }
      renderProperties(props) {
        return cfnRecordSetPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnRecordSet[_f] = { fqn: "aws-cdk-lib.aws_route53.CfnRecordSet", version: "2.80.0" }, CfnRecordSet.CFN_RESOURCE_TYPE_NAME = "AWS::Route53::RecordSet", exports2.CfnRecordSet = CfnRecordSet;
    function CfnRecordSet_AliasTargetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dnsName", cdk.requiredValidator)(properties.dnsName)), errors.collect(cdk.propertyValidator("dnsName", cdk.validateString)(properties.dnsName)), errors.collect(cdk.propertyValidator("evaluateTargetHealth", cdk.validateBoolean)(properties.evaluateTargetHealth)), errors.collect(cdk.propertyValidator("hostedZoneId", cdk.requiredValidator)(properties.hostedZoneId)), errors.collect(cdk.propertyValidator("hostedZoneId", cdk.validateString)(properties.hostedZoneId)), errors.wrap('supplied properties not correct for "AliasTargetProperty"');
    }
    function cfnRecordSetAliasTargetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRecordSet_AliasTargetPropertyValidator(properties).assertSuccess(), { DNSName: cdk.stringToCloudFormation(properties.dnsName), EvaluateTargetHealth: cdk.booleanToCloudFormation(properties.evaluateTargetHealth), HostedZoneId: cdk.stringToCloudFormation(properties.hostedZoneId) }) : properties;
    }
    function CfnRecordSetAliasTargetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dnsName", "DNSName", cfn_parse.FromCloudFormation.getString(properties.DNSName)), ret.addPropertyResult("evaluateTargetHealth", "EvaluateTargetHealth", properties.EvaluateTargetHealth != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EvaluateTargetHealth) : void 0), ret.addPropertyResult("hostedZoneId", "HostedZoneId", cfn_parse.FromCloudFormation.getString(properties.HostedZoneId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRecordSet_CidrRoutingConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("collectionId", cdk.requiredValidator)(properties.collectionId)), errors.collect(cdk.propertyValidator("collectionId", cdk.validateString)(properties.collectionId)), errors.collect(cdk.propertyValidator("locationName", cdk.requiredValidator)(properties.locationName)), errors.collect(cdk.propertyValidator("locationName", cdk.validateString)(properties.locationName)), errors.wrap('supplied properties not correct for "CidrRoutingConfigProperty"');
    }
    function cfnRecordSetCidrRoutingConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRecordSet_CidrRoutingConfigPropertyValidator(properties).assertSuccess(), { CollectionId: cdk.stringToCloudFormation(properties.collectionId), LocationName: cdk.stringToCloudFormation(properties.locationName) }) : properties;
    }
    function CfnRecordSetCidrRoutingConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("collectionId", "CollectionId", cfn_parse.FromCloudFormation.getString(properties.CollectionId)), ret.addPropertyResult("locationName", "LocationName", cfn_parse.FromCloudFormation.getString(properties.LocationName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRecordSet_GeoLocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("continentCode", cdk.validateString)(properties.continentCode)), errors.collect(cdk.propertyValidator("countryCode", cdk.validateString)(properties.countryCode)), errors.collect(cdk.propertyValidator("subdivisionCode", cdk.validateString)(properties.subdivisionCode)), errors.wrap('supplied properties not correct for "GeoLocationProperty"');
    }
    function cfnRecordSetGeoLocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRecordSet_GeoLocationPropertyValidator(properties).assertSuccess(), { ContinentCode: cdk.stringToCloudFormation(properties.continentCode), CountryCode: cdk.stringToCloudFormation(properties.countryCode), SubdivisionCode: cdk.stringToCloudFormation(properties.subdivisionCode) }) : properties;
    }
    function CfnRecordSetGeoLocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("continentCode", "ContinentCode", properties.ContinentCode != null ? cfn_parse.FromCloudFormation.getString(properties.ContinentCode) : void 0), ret.addPropertyResult("countryCode", "CountryCode", properties.CountryCode != null ? cfn_parse.FromCloudFormation.getString(properties.CountryCode) : void 0), ret.addPropertyResult("subdivisionCode", "SubdivisionCode", properties.SubdivisionCode != null ? cfn_parse.FromCloudFormation.getString(properties.SubdivisionCode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRecordSetGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("comment", cdk.validateString)(properties.comment)), errors.collect(cdk.propertyValidator("hostedZoneId", cdk.validateString)(properties.hostedZoneId)), errors.collect(cdk.propertyValidator("hostedZoneName", cdk.validateString)(properties.hostedZoneName)), errors.collect(cdk.propertyValidator("recordSets", cdk.listValidator(CfnRecordSetGroup_RecordSetPropertyValidator))(properties.recordSets)), errors.wrap('supplied properties not correct for "CfnRecordSetGroupProps"');
    }
    function cfnRecordSetGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRecordSetGroupPropsValidator(properties).assertSuccess(), { Comment: cdk.stringToCloudFormation(properties.comment), HostedZoneId: cdk.stringToCloudFormation(properties.hostedZoneId), HostedZoneName: cdk.stringToCloudFormation(properties.hostedZoneName), RecordSets: cdk.listMapper(cfnRecordSetGroupRecordSetPropertyToCloudFormation)(properties.recordSets) }) : properties;
    }
    function CfnRecordSetGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("comment", "Comment", properties.Comment != null ? cfn_parse.FromCloudFormation.getString(properties.Comment) : void 0), ret.addPropertyResult("hostedZoneId", "HostedZoneId", properties.HostedZoneId != null ? cfn_parse.FromCloudFormation.getString(properties.HostedZoneId) : void 0), ret.addPropertyResult("hostedZoneName", "HostedZoneName", properties.HostedZoneName != null ? cfn_parse.FromCloudFormation.getString(properties.HostedZoneName) : void 0), ret.addPropertyResult("recordSets", "RecordSets", properties.RecordSets != null ? cfn_parse.FromCloudFormation.getArray(CfnRecordSetGroupRecordSetPropertyFromCloudFormation)(properties.RecordSets) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRecordSetGroup = class _CfnRecordSetGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRecordSetGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnRecordSetGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnRecordSetGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_CfnRecordSetGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRecordSetGroup), error;
        }
        this.comment = props.comment, this.hostedZoneId = props.hostedZoneId, this.hostedZoneName = props.hostedZoneName, this.recordSets = props.recordSets;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRecordSetGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { comment: this.comment, hostedZoneId: this.hostedZoneId, hostedZoneName: this.hostedZoneName, recordSets: this.recordSets };
      }
      renderProperties(props) {
        return cfnRecordSetGroupPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnRecordSetGroup[_g] = { fqn: "aws-cdk-lib.aws_route53.CfnRecordSetGroup", version: "2.80.0" }, CfnRecordSetGroup.CFN_RESOURCE_TYPE_NAME = "AWS::Route53::RecordSetGroup", exports2.CfnRecordSetGroup = CfnRecordSetGroup;
    function CfnRecordSetGroup_AliasTargetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dnsName", cdk.requiredValidator)(properties.dnsName)), errors.collect(cdk.propertyValidator("dnsName", cdk.validateString)(properties.dnsName)), errors.collect(cdk.propertyValidator("evaluateTargetHealth", cdk.validateBoolean)(properties.evaluateTargetHealth)), errors.collect(cdk.propertyValidator("hostedZoneId", cdk.requiredValidator)(properties.hostedZoneId)), errors.collect(cdk.propertyValidator("hostedZoneId", cdk.validateString)(properties.hostedZoneId)), errors.wrap('supplied properties not correct for "AliasTargetProperty"');
    }
    function cfnRecordSetGroupAliasTargetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRecordSetGroup_AliasTargetPropertyValidator(properties).assertSuccess(), { DNSName: cdk.stringToCloudFormation(properties.dnsName), EvaluateTargetHealth: cdk.booleanToCloudFormation(properties.evaluateTargetHealth), HostedZoneId: cdk.stringToCloudFormation(properties.hostedZoneId) }) : properties;
    }
    function CfnRecordSetGroupAliasTargetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dnsName", "DNSName", cfn_parse.FromCloudFormation.getString(properties.DNSName)), ret.addPropertyResult("evaluateTargetHealth", "EvaluateTargetHealth", properties.EvaluateTargetHealth != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EvaluateTargetHealth) : void 0), ret.addPropertyResult("hostedZoneId", "HostedZoneId", cfn_parse.FromCloudFormation.getString(properties.HostedZoneId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRecordSetGroup_CidrRoutingConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("collectionId", cdk.requiredValidator)(properties.collectionId)), errors.collect(cdk.propertyValidator("collectionId", cdk.validateString)(properties.collectionId)), errors.collect(cdk.propertyValidator("locationName", cdk.requiredValidator)(properties.locationName)), errors.collect(cdk.propertyValidator("locationName", cdk.validateString)(properties.locationName)), errors.wrap('supplied properties not correct for "CidrRoutingConfigProperty"');
    }
    function cfnRecordSetGroupCidrRoutingConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRecordSetGroup_CidrRoutingConfigPropertyValidator(properties).assertSuccess(), { CollectionId: cdk.stringToCloudFormation(properties.collectionId), LocationName: cdk.stringToCloudFormation(properties.locationName) }) : properties;
    }
    function CfnRecordSetGroupCidrRoutingConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("collectionId", "CollectionId", cfn_parse.FromCloudFormation.getString(properties.CollectionId)), ret.addPropertyResult("locationName", "LocationName", cfn_parse.FromCloudFormation.getString(properties.LocationName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRecordSetGroup_GeoLocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("continentCode", cdk.validateString)(properties.continentCode)), errors.collect(cdk.propertyValidator("countryCode", cdk.validateString)(properties.countryCode)), errors.collect(cdk.propertyValidator("subdivisionCode", cdk.validateString)(properties.subdivisionCode)), errors.wrap('supplied properties not correct for "GeoLocationProperty"');
    }
    function cfnRecordSetGroupGeoLocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRecordSetGroup_GeoLocationPropertyValidator(properties).assertSuccess(), { ContinentCode: cdk.stringToCloudFormation(properties.continentCode), CountryCode: cdk.stringToCloudFormation(properties.countryCode), SubdivisionCode: cdk.stringToCloudFormation(properties.subdivisionCode) }) : properties;
    }
    function CfnRecordSetGroupGeoLocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("continentCode", "ContinentCode", properties.ContinentCode != null ? cfn_parse.FromCloudFormation.getString(properties.ContinentCode) : void 0), ret.addPropertyResult("countryCode", "CountryCode", properties.CountryCode != null ? cfn_parse.FromCloudFormation.getString(properties.CountryCode) : void 0), ret.addPropertyResult("subdivisionCode", "SubdivisionCode", properties.SubdivisionCode != null ? cfn_parse.FromCloudFormation.getString(properties.SubdivisionCode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRecordSetGroup_RecordSetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aliasTarget", CfnRecordSetGroup_AliasTargetPropertyValidator)(properties.aliasTarget)), errors.collect(cdk.propertyValidator("cidrRoutingConfig", CfnRecordSetGroup_CidrRoutingConfigPropertyValidator)(properties.cidrRoutingConfig)), errors.collect(cdk.propertyValidator("failover", cdk.validateString)(properties.failover)), errors.collect(cdk.propertyValidator("geoLocation", CfnRecordSetGroup_GeoLocationPropertyValidator)(properties.geoLocation)), errors.collect(cdk.propertyValidator("healthCheckId", cdk.validateString)(properties.healthCheckId)), errors.collect(cdk.propertyValidator("hostedZoneId", cdk.validateString)(properties.hostedZoneId)), errors.collect(cdk.propertyValidator("hostedZoneName", cdk.validateString)(properties.hostedZoneName)), errors.collect(cdk.propertyValidator("multiValueAnswer", cdk.validateBoolean)(properties.multiValueAnswer)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("region", cdk.validateString)(properties.region)), errors.collect(cdk.propertyValidator("resourceRecords", cdk.listValidator(cdk.validateString))(properties.resourceRecords)), errors.collect(cdk.propertyValidator("setIdentifier", cdk.validateString)(properties.setIdentifier)), errors.collect(cdk.propertyValidator("ttl", cdk.validateString)(properties.ttl)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("weight", cdk.validateNumber)(properties.weight)), errors.wrap('supplied properties not correct for "RecordSetProperty"');
    }
    function cfnRecordSetGroupRecordSetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRecordSetGroup_RecordSetPropertyValidator(properties).assertSuccess(), { AliasTarget: cfnRecordSetGroupAliasTargetPropertyToCloudFormation(properties.aliasTarget), CidrRoutingConfig: cfnRecordSetGroupCidrRoutingConfigPropertyToCloudFormation(properties.cidrRoutingConfig), Failover: cdk.stringToCloudFormation(properties.failover), GeoLocation: cfnRecordSetGroupGeoLocationPropertyToCloudFormation(properties.geoLocation), HealthCheckId: cdk.stringToCloudFormation(properties.healthCheckId), HostedZoneId: cdk.stringToCloudFormation(properties.hostedZoneId), HostedZoneName: cdk.stringToCloudFormation(properties.hostedZoneName), MultiValueAnswer: cdk.booleanToCloudFormation(properties.multiValueAnswer), Name: cdk.stringToCloudFormation(properties.name), Region: cdk.stringToCloudFormation(properties.region), ResourceRecords: cdk.listMapper(cdk.stringToCloudFormation)(properties.resourceRecords), SetIdentifier: cdk.stringToCloudFormation(properties.setIdentifier), TTL: cdk.stringToCloudFormation(properties.ttl), Type: cdk.stringToCloudFormation(properties.type), Weight: cdk.numberToCloudFormation(properties.weight) }) : properties;
    }
    function CfnRecordSetGroupRecordSetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aliasTarget", "AliasTarget", properties.AliasTarget != null ? CfnRecordSetGroupAliasTargetPropertyFromCloudFormation(properties.AliasTarget) : void 0), ret.addPropertyResult("cidrRoutingConfig", "CidrRoutingConfig", properties.CidrRoutingConfig != null ? CfnRecordSetGroupCidrRoutingConfigPropertyFromCloudFormation(properties.CidrRoutingConfig) : void 0), ret.addPropertyResult("failover", "Failover", properties.Failover != null ? cfn_parse.FromCloudFormation.getString(properties.Failover) : void 0), ret.addPropertyResult("geoLocation", "GeoLocation", properties.GeoLocation != null ? CfnRecordSetGroupGeoLocationPropertyFromCloudFormation(properties.GeoLocation) : void 0), ret.addPropertyResult("healthCheckId", "HealthCheckId", properties.HealthCheckId != null ? cfn_parse.FromCloudFormation.getString(properties.HealthCheckId) : void 0), ret.addPropertyResult("hostedZoneId", "HostedZoneId", properties.HostedZoneId != null ? cfn_parse.FromCloudFormation.getString(properties.HostedZoneId) : void 0), ret.addPropertyResult("hostedZoneName", "HostedZoneName", properties.HostedZoneName != null ? cfn_parse.FromCloudFormation.getString(properties.HostedZoneName) : void 0), ret.addPropertyResult("multiValueAnswer", "MultiValueAnswer", properties.MultiValueAnswer != null ? cfn_parse.FromCloudFormation.getBoolean(properties.MultiValueAnswer) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("region", "Region", properties.Region != null ? cfn_parse.FromCloudFormation.getString(properties.Region) : void 0), ret.addPropertyResult("resourceRecords", "ResourceRecords", properties.ResourceRecords != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ResourceRecords) : void 0), ret.addPropertyResult("setIdentifier", "SetIdentifier", properties.SetIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.SetIdentifier) : void 0), ret.addPropertyResult("ttl", "TTL", properties.TTL != null ? cfn_parse.FromCloudFormation.getString(properties.TTL) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("weight", "Weight", properties.Weight != null ? cfn_parse.FromCloudFormation.getNumber(properties.Weight) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-route53/lib/util.js
var require_util12 = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53/lib/util.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.makeHostedZoneArn = exports2.determineFullyQualifiedDomainName = exports2.validateZoneName = void 0;
    var core_1 = require_core2();
    function validateZoneName(zoneName) {
      if (zoneName.endsWith("."))
        throw new ValidationError("zone name must not end with a trailing dot");
      if (zoneName.length > 255)
        throw new ValidationError("zone name cannot be more than 255 bytes long");
      if (zoneName.split(".").find((label) => label.length > 63))
        throw new ValidationError("zone name labels cannot be more than 63 bytes long");
      if (!zoneName.match(/^[a-z0-9!"#$%&'()*+,/:;<=>?@[\\\]^_`{|}~.-]+$/i))
        throw new ValidationError("zone names can only contain a-z, 0-9, -, ! \" # $ % & ' ( ) * + , - / : ; < = > ? @ [  ] ^ _ ` { | } ~ .");
    }
    exports2.validateZoneName = validateZoneName;
    var ValidationError = class extends Error {
      constructor(message) {
        super(message);
      }
    };
    function determineFullyQualifiedDomainName(providedName, hostedZone) {
      if (providedName.endsWith("."))
        return providedName;
      const hostedZoneName = hostedZone.zoneName.endsWith(".") ? hostedZone.zoneName.substring(0, hostedZone.zoneName.length - 1) : hostedZone.zoneName, suffix = `.${hostedZoneName}`;
      return providedName.endsWith(suffix) || providedName === hostedZoneName ? `${providedName}.` : `${providedName}${suffix}.`;
    }
    exports2.determineFullyQualifiedDomainName = determineFullyQualifiedDomainName;
    function makeHostedZoneArn(construct, hostedZoneId) {
      return core_1.Stack.of(construct).formatArn({ account: "", region: "", service: "route53", resource: "hostedzone", resourceName: hostedZoneId });
    }
    exports2.makeHostedZoneArn = makeHostedZoneArn;
  }
});

// node_modules/aws-cdk-lib/aws-route53/lib/record-set.js
var require_record_set = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53/lib/record-set.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    var _l;
    var _m;
    var _o;
    var _p;
    var _q;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CrossAccountZoneDelegationRecord = exports2.ZoneDelegationRecord = exports2.DsRecord = exports2.NsRecord = exports2.MxRecord = exports2.CaaAmazonRecord = exports2.CaaRecord = exports2.CaaTag = exports2.SrvRecord = exports2.TxtRecord = exports2.CnameRecord = exports2.AaaaRecord = exports2.ARecord = exports2.AddressRecordTarget = exports2.RecordSet = exports2.RecordTarget = exports2.RecordType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var path = require("path");
    var constructs_1 = require_lib2();
    var route53_generated_1 = require_route53_generated();
    var util_1 = require_util12();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var CROSS_ACCOUNT_ZONE_DELEGATION_RESOURCE_TYPE = "Custom::CrossAccountZoneDelegation";
    var DELETE_EXISTING_RECORD_SET_RESOURCE_TYPE = "Custom::DeleteExistingRecordSet";
    var USE_REGIONAL_STS_ENDPOINT_CONTEXT_KEY = "@aws-cdk/aws-route53:useRegionalStsEndpoint";
    var RecordType;
    (function(RecordType2) {
      RecordType2.A = "A", RecordType2.AAAA = "AAAA", RecordType2.CAA = "CAA", RecordType2.CNAME = "CNAME", RecordType2.DS = "DS", RecordType2.MX = "MX", RecordType2.NAPTR = "NAPTR", RecordType2.NS = "NS", RecordType2.PTR = "PTR", RecordType2.SOA = "SOA", RecordType2.SPF = "SPF", RecordType2.SRV = "SRV", RecordType2.TXT = "TXT";
    })(RecordType = exports2.RecordType || (exports2.RecordType = {}));
    var RecordTarget = class _RecordTarget {
      static fromValues(...values) {
        return new _RecordTarget(values);
      }
      static fromAlias(aliasTarget) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_IAliasRecordTarget(aliasTarget);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromAlias), error;
        }
        return new _RecordTarget(void 0, aliasTarget);
      }
      static fromIpAddresses(...ipAddresses) {
        return _RecordTarget.fromValues(...ipAddresses);
      }
      constructor(values, aliasTarget) {
        this.values = values, this.aliasTarget = aliasTarget;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_IAliasRecordTarget(aliasTarget);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _RecordTarget), error;
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, RecordTarget[_a] = { fqn: "aws-cdk-lib.aws_route53.RecordTarget", version: "2.80.0" }, exports2.RecordTarget = RecordTarget;
    var RecordSet = class _RecordSet extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_RecordSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _RecordSet), error;
        }
        const ttl = props.target.aliasTarget ? void 0 : ((props.ttl && props.ttl.toSeconds()) ?? 1800).toString(), recordName = (0, util_1.determineFullyQualifiedDomainName)(props.recordName || props.zone.zoneName, props.zone), recordSet = new route53_generated_1.CfnRecordSet(this, "Resource", { hostedZoneId: props.zone.hostedZoneId, name: recordName, type: props.recordType, resourceRecords: props.target.values, aliasTarget: props.target.aliasTarget && props.target.aliasTarget.bind(this, props.zone), ttl, comment: props.comment });
        if (this.domainName = recordSet.ref, props.deleteExisting) {
          const provider = core_1.CustomResourceProvider.getOrCreateProvider(this, DELETE_EXISTING_RECORD_SET_RESOURCE_TYPE, { codeDirectory: path.join(__dirname, "delete-existing-record-set-handler"), runtime: (0, core_1.builtInCustomResourceProviderNodeRuntime)(this), policyStatements: [{ Effect: "Allow", Action: "route53:GetChange", Resource: "*" }] });
          provider.addToRolePolicy({ Effect: "Allow", Action: "route53:ListResourceRecordSets", Resource: props.zone.hostedZoneArn }), provider.addToRolePolicy({ Effect: "Allow", Action: "route53:ChangeResourceRecordSets", Resource: props.zone.hostedZoneArn, Condition: { "ForAllValues:StringEquals": { "route53:ChangeResourceRecordSetsRecordTypes": [props.recordType], "route53:ChangeResourceRecordSetsActions": ["DELETE"] } } });
          const customResource = new core_1.CustomResource(this, "DeleteExistingRecordSetCustomResource", { resourceType: DELETE_EXISTING_RECORD_SET_RESOURCE_TYPE, serviceToken: provider.serviceToken, properties: { HostedZoneId: props.zone.hostedZoneId, RecordName: recordName, RecordType: props.recordType } });
          recordSet.node.addDependency(customResource);
        }
      }
    };
    _b = JSII_RTTI_SYMBOL_1, RecordSet[_b] = { fqn: "aws-cdk-lib.aws_route53.RecordSet", version: "2.80.0" }, exports2.RecordSet = RecordSet;
    var AddressRecordTarget = class extends RecordTarget {
    };
    _c = JSII_RTTI_SYMBOL_1, AddressRecordTarget[_c] = { fqn: "aws-cdk-lib.aws_route53.AddressRecordTarget", version: "2.80.0" }, exports2.AddressRecordTarget = AddressRecordTarget;
    var ARecord = class _ARecord extends RecordSet {
      constructor(scope, id, props) {
        super(scope, id, { ...props, recordType: RecordType.A, target: props.target });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_ARecordProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ARecord), error;
        }
      }
    };
    _d = JSII_RTTI_SYMBOL_1, ARecord[_d] = { fqn: "aws-cdk-lib.aws_route53.ARecord", version: "2.80.0" }, exports2.ARecord = ARecord;
    var AaaaRecord = class _AaaaRecord extends RecordSet {
      constructor(scope, id, props) {
        super(scope, id, { ...props, recordType: RecordType.AAAA, target: props.target });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_AaaaRecordProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AaaaRecord), error;
        }
      }
    };
    _e = JSII_RTTI_SYMBOL_1, AaaaRecord[_e] = { fqn: "aws-cdk-lib.aws_route53.AaaaRecord", version: "2.80.0" }, exports2.AaaaRecord = AaaaRecord;
    var CnameRecord = class _CnameRecord extends RecordSet {
      constructor(scope, id, props) {
        super(scope, id, { ...props, recordType: RecordType.CNAME, target: RecordTarget.fromValues(props.domainName) });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_CnameRecordProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CnameRecord), error;
        }
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CnameRecord[_f] = { fqn: "aws-cdk-lib.aws_route53.CnameRecord", version: "2.80.0" }, exports2.CnameRecord = CnameRecord;
    var TxtRecord = class _TxtRecord extends RecordSet {
      constructor(scope, id, props) {
        super(scope, id, { ...props, recordType: RecordType.TXT, target: RecordTarget.fromValues(...props.values.map((v) => formatTxt(v))) });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_TxtRecordProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _TxtRecord), error;
        }
      }
    };
    _g = JSII_RTTI_SYMBOL_1, TxtRecord[_g] = { fqn: "aws-cdk-lib.aws_route53.TxtRecord", version: "2.80.0" }, exports2.TxtRecord = TxtRecord;
    function formatTxt(string) {
      const result = [];
      let idx = 0;
      for (; idx < string.length; )
        result.push(string.slice(idx, idx += 255));
      return result.map((r) => JSON.stringify(r)).join("");
    }
    var SrvRecord = class _SrvRecord extends RecordSet {
      constructor(scope, id, props) {
        super(scope, id, { ...props, recordType: RecordType.SRV, target: RecordTarget.fromValues(...props.values.map((v) => `${v.priority} ${v.weight} ${v.port} ${v.hostName}`)) });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_SrvRecordProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SrvRecord), error;
        }
      }
    };
    _h = JSII_RTTI_SYMBOL_1, SrvRecord[_h] = { fqn: "aws-cdk-lib.aws_route53.SrvRecord", version: "2.80.0" }, exports2.SrvRecord = SrvRecord;
    var CaaTag;
    (function(CaaTag2) {
      CaaTag2.ISSUE = "issue", CaaTag2.ISSUEWILD = "issuewild", CaaTag2.IODEF = "iodef";
    })(CaaTag = exports2.CaaTag || (exports2.CaaTag = {}));
    var CaaRecord = class _CaaRecord extends RecordSet {
      constructor(scope, id, props) {
        super(scope, id, { ...props, recordType: RecordType.CAA, target: RecordTarget.fromValues(...props.values.map((v) => `${v.flag} ${v.tag} "${v.value}"`)) });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_CaaRecordProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CaaRecord), error;
        }
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CaaRecord[_j] = { fqn: "aws-cdk-lib.aws_route53.CaaRecord", version: "2.80.0" }, exports2.CaaRecord = CaaRecord;
    var CaaAmazonRecord = class _CaaAmazonRecord extends CaaRecord {
      constructor(scope, id, props) {
        super(scope, id, { ...props, values: [{ flag: 0, tag: CaaTag.ISSUE, value: "amazon.com" }] });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_CaaAmazonRecordProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CaaAmazonRecord), error;
        }
      }
    };
    _k = JSII_RTTI_SYMBOL_1, CaaAmazonRecord[_k] = { fqn: "aws-cdk-lib.aws_route53.CaaAmazonRecord", version: "2.80.0" }, exports2.CaaAmazonRecord = CaaAmazonRecord;
    var MxRecord = class _MxRecord extends RecordSet {
      constructor(scope, id, props) {
        super(scope, id, { ...props, recordType: RecordType.MX, target: RecordTarget.fromValues(...props.values.map((v) => `${v.priority} ${v.hostName}`)) });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_MxRecordProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _MxRecord), error;
        }
      }
    };
    _l = JSII_RTTI_SYMBOL_1, MxRecord[_l] = { fqn: "aws-cdk-lib.aws_route53.MxRecord", version: "2.80.0" }, exports2.MxRecord = MxRecord;
    var NsRecord = class _NsRecord extends RecordSet {
      constructor(scope, id, props) {
        super(scope, id, { ...props, recordType: RecordType.NS, target: RecordTarget.fromValues(...props.values) });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_NsRecordProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _NsRecord), error;
        }
      }
    };
    _m = JSII_RTTI_SYMBOL_1, NsRecord[_m] = { fqn: "aws-cdk-lib.aws_route53.NsRecord", version: "2.80.0" }, exports2.NsRecord = NsRecord;
    var DsRecord = class _DsRecord extends RecordSet {
      constructor(scope, id, props) {
        super(scope, id, { ...props, recordType: RecordType.DS, target: RecordTarget.fromValues(...props.values) });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_DsRecordProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _DsRecord), error;
        }
      }
    };
    _o = JSII_RTTI_SYMBOL_1, DsRecord[_o] = { fqn: "aws-cdk-lib.aws_route53.DsRecord", version: "2.80.0" }, exports2.DsRecord = DsRecord;
    var ZoneDelegationRecord = class _ZoneDelegationRecord extends RecordSet {
      constructor(scope, id, props) {
        super(scope, id, { ...props, recordType: RecordType.NS, target: RecordTarget.fromValues(...core_1.Token.isUnresolved(props.nameServers) ? props.nameServers : props.nameServers.map((ns) => core_1.Token.isUnresolved(ns) || ns.endsWith(".") ? ns : `${ns}.`)), ttl: props.ttl || core_1.Duration.days(2) });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_ZoneDelegationRecordProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ZoneDelegationRecord), error;
        }
      }
    };
    _p = JSII_RTTI_SYMBOL_1, ZoneDelegationRecord[_p] = { fqn: "aws-cdk-lib.aws_route53.ZoneDelegationRecord", version: "2.80.0" }, exports2.ZoneDelegationRecord = ZoneDelegationRecord;
    var CrossAccountZoneDelegationRecord = class _CrossAccountZoneDelegationRecord extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_CrossAccountZoneDelegationRecordProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CrossAccountZoneDelegationRecord), error;
        }
        if (!props.parentHostedZoneName && !props.parentHostedZoneId)
          throw Error("At least one of parentHostedZoneName or parentHostedZoneId is required");
        if (props.parentHostedZoneName && props.parentHostedZoneId)
          throw Error("Only one of parentHostedZoneName and parentHostedZoneId is supported");
        const provider = core_1.CustomResourceProvider.getOrCreateProvider(this, CROSS_ACCOUNT_ZONE_DELEGATION_RESOURCE_TYPE, { codeDirectory: path.join(__dirname, "cross-account-zone-delegation-handler"), runtime: (0, core_1.builtInCustomResourceProviderNodeRuntime)(this) }), addToPrinciplePolicyResult = iam.Role.fromRoleArn(this, "cross-account-zone-delegation-handler-role", provider.roleArn).addToPrincipalPolicy(new iam.PolicyStatement({ effect: iam.Effect.ALLOW, actions: ["sts:AssumeRole"], resources: [props.delegationRole.roleArn] })), useRegionalStsEndpoint = this.node.tryGetContext(USE_REGIONAL_STS_ENDPOINT_CONTEXT_KEY), customResource = new core_1.CustomResource(this, "CrossAccountZoneDelegationCustomResource", { resourceType: CROSS_ACCOUNT_ZONE_DELEGATION_RESOURCE_TYPE, serviceToken: provider.serviceToken, removalPolicy: props.removalPolicy, properties: { AssumeRoleArn: props.delegationRole.roleArn, ParentZoneName: props.parentHostedZoneName, ParentZoneId: props.parentHostedZoneId, DelegatedZoneName: props.delegatedZone.zoneName, DelegatedZoneNameServers: props.delegatedZone.hostedZoneNameServers, TTL: (props.ttl || core_1.Duration.days(2)).toSeconds(), UseRegionalStsEndpoint: useRegionalStsEndpoint ? "true" : void 0 } });
        addToPrinciplePolicyResult.policyDependable && customResource.node.addDependency(addToPrinciplePolicyResult.policyDependable);
      }
    };
    _q = JSII_RTTI_SYMBOL_1, CrossAccountZoneDelegationRecord[_q] = { fqn: "aws-cdk-lib.aws_route53.CrossAccountZoneDelegationRecord", version: "2.80.0" }, exports2.CrossAccountZoneDelegationRecord = CrossAccountZoneDelegationRecord;
  }
});

// node_modules/aws-cdk-lib/aws-route53/lib/hosted-zone.js
var require_hosted_zone = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53/lib/hosted-zone.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PrivateHostedZone = exports2.PublicHostedZone = exports2.HostedZone = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var record_set_1 = require_record_set();
    var route53_generated_1 = require_route53_generated();
    var util_1 = require_util12();
    var iam = require_aws_iam();
    var cxschema = require_cloud_assembly_schema2();
    var core_1 = require_core2();
    var HostedZone = class _HostedZone extends core_1.Resource {
      get hostedZoneArn() {
        return (0, util_1.makeHostedZoneArn)(this, this.hostedZoneId);
      }
      static fromHostedZoneId(scope, id, hostedZoneId) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.hostedZoneId = hostedZoneId;
          }
          get zoneName() {
            throw new Error("Cannot reference `zoneName` when using `HostedZone.fromHostedZoneId()`. A construct consuming this hosted zone may be trying to reference its `zoneName`. If this is the case, use `fromHostedZoneAttributes()` or `fromLookup()` instead.");
          }
          get hostedZoneArn() {
            return (0, util_1.makeHostedZoneArn)(this, this.hostedZoneId);
          }
        }
        return new Import(scope, id);
      }
      static fromHostedZoneAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_HostedZoneAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromHostedZoneAttributes), error;
        }
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.hostedZoneId = attrs.hostedZoneId, this.zoneName = attrs.zoneName;
          }
          get hostedZoneArn() {
            return (0, util_1.makeHostedZoneArn)(this, this.hostedZoneId);
          }
        }
        return new Import(scope, id);
      }
      static fromLookup(scope, id, query) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_HostedZoneProviderProps(query);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromLookup), error;
        }
        if (!query.domainName)
          throw new Error("Cannot use undefined value for attribute `domainName`");
        const DEFAULT_HOSTED_ZONE = { Id: "DUMMY", Name: query.domainName }, response = core_1.ContextProvider.getValue(scope, { provider: cxschema.ContextProvider.HOSTED_ZONE_PROVIDER, dummyValue: DEFAULT_HOSTED_ZONE, props: query }).value;
        return response.Name.endsWith(".") && (response.Name = response.Name.substring(0, response.Name.length - 1)), response.Id = response.Id.replace("/hostedzone/", ""), _HostedZone.fromHostedZoneAttributes(scope, id, { hostedZoneId: response.Id, zoneName: response.Name });
      }
      constructor(scope, id, props) {
        super(scope, id), this.vpcs = new Array();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_HostedZoneProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _HostedZone), error;
        }
        (0, util_1.validateZoneName)(props.zoneName);
        const resource = new route53_generated_1.CfnHostedZone(this, "Resource", { name: props.zoneName + ".", hostedZoneConfig: props.comment ? { comment: props.comment } : void 0, queryLoggingConfig: props.queryLogsLogGroupArn ? { cloudWatchLogsLogGroupArn: props.queryLogsLogGroupArn } : void 0, vpcs: core_1.Lazy.any({ produce: () => this.vpcs.length === 0 ? void 0 : this.vpcs }) });
        this.hostedZoneId = resource.ref, this.hostedZoneNameServers = resource.attrNameServers, this.zoneName = props.zoneName;
        for (const vpc of props.vpcs || [])
          this.addVpc(vpc);
      }
      addVpc(vpc) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_IVpc(vpc);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addVpc), error;
        }
        this.vpcs.push({ vpcId: vpc.vpcId, vpcRegion: vpc.env.region ?? core_1.Stack.of(vpc).region });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, HostedZone[_a] = { fqn: "aws-cdk-lib.aws_route53.HostedZone", version: "2.80.0" }, exports2.HostedZone = HostedZone;
    var PublicHostedZone = class _PublicHostedZone extends HostedZone {
      static fromPublicHostedZoneId(scope, id, publicHostedZoneId) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.hostedZoneId = publicHostedZoneId;
          }
          get zoneName() {
            throw new Error("Cannot reference `zoneName` when using `PublicHostedZone.fromPublicHostedZoneId()`. A construct consuming this hosted zone may be trying to reference its `zoneName`. If this is the case, use `fromPublicHostedZoneAttributes()` instead");
          }
          get hostedZoneArn() {
            return (0, util_1.makeHostedZoneArn)(this, this.hostedZoneId);
          }
        }
        return new Import(scope, id);
      }
      static fromPublicHostedZoneAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_PublicHostedZoneAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromPublicHostedZoneAttributes), error;
        }
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.hostedZoneId = attrs.hostedZoneId, this.zoneName = attrs.zoneName;
          }
          get hostedZoneArn() {
            return (0, util_1.makeHostedZoneArn)(this, this.hostedZoneId);
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_PublicHostedZoneProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _PublicHostedZone), error;
        }
        if (props.caaAmazon && new record_set_1.CaaAmazonRecord(this, "CaaAmazon", { zone: this }), !props.crossAccountZoneDelegationPrincipal && props.crossAccountZoneDelegationRoleName)
          throw Error("crossAccountZoneDelegationRoleName property is not supported without crossAccountZoneDelegationPrincipal");
        props.crossAccountZoneDelegationPrincipal && (this.crossAccountZoneDelegationRole = new iam.Role(this, "CrossAccountZoneDelegationRole", { roleName: props.crossAccountZoneDelegationRoleName, assumedBy: props.crossAccountZoneDelegationPrincipal, inlinePolicies: { delegation: new iam.PolicyDocument({ statements: [new iam.PolicyStatement({ actions: ["route53:ChangeResourceRecordSets"], resources: [this.hostedZoneArn], conditions: { "ForAllValues:StringEquals": { "route53:ChangeResourceRecordSetsRecordTypes": ["NS"], "route53:ChangeResourceRecordSetsActions": ["UPSERT", "DELETE"] } } }), new iam.PolicyStatement({ actions: ["route53:ListHostedZonesByName"], resources: ["*"] })] }) } }));
      }
      addVpc(_vpc) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_IVpc(_vpc);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addVpc), error;
        }
        throw new Error("Cannot associate public hosted zones with a VPC");
      }
      addDelegation(delegate, opts = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_IPublicHostedZone(delegate), jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_ZoneDelegationOptions(opts);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addDelegation), error;
        }
        new record_set_1.ZoneDelegationRecord(this, `${this.zoneName} -> ${delegate.zoneName}`, { zone: this, recordName: delegate.zoneName, nameServers: delegate.hostedZoneNameServers, comment: opts.comment, ttl: opts.ttl });
      }
      grantDelegation(grantee) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(grantee);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantDelegation), error;
        }
        const g1 = iam.Grant.addToPrincipal({ grantee, actions: ["route53:ChangeResourceRecordSets"], resourceArns: [this.hostedZoneArn], conditions: { "ForAllValues:StringEquals": { "route53:ChangeResourceRecordSetsRecordTypes": ["NS"], "route53:ChangeResourceRecordSetsActions": ["UPSERT", "DELETE"] } } }), g2 = iam.Grant.addToPrincipal({ grantee, actions: ["route53:ListHostedZonesByName"], resourceArns: ["*"] });
        return g1.combine(g2);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, PublicHostedZone[_b] = { fqn: "aws-cdk-lib.aws_route53.PublicHostedZone", version: "2.80.0" }, exports2.PublicHostedZone = PublicHostedZone;
    var PrivateHostedZone = class _PrivateHostedZone extends HostedZone {
      static fromPrivateHostedZoneId(scope, id, privateHostedZoneId) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.hostedZoneId = privateHostedZoneId;
          }
          get zoneName() {
            throw new Error("Cannot reference `zoneName` when using `PrivateHostedZone.fromPrivateHostedZoneId()`. A construct consuming this hosted zone may be trying to reference its `zoneName`");
          }
          get hostedZoneArn() {
            return (0, util_1.makeHostedZoneArn)(this, this.hostedZoneId);
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_PrivateHostedZoneProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _PrivateHostedZone), error;
        }
        this.addVpc(props.vpc);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, PrivateHostedZone[_c] = { fqn: "aws-cdk-lib.aws_route53.PrivateHostedZone", version: "2.80.0" }, exports2.PrivateHostedZone = PrivateHostedZone;
  }
});

// node_modules/aws-cdk-lib/aws-route53/lib/hosted-zone-provider.js
var require_hosted_zone_provider = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53/lib/hosted-zone-provider.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-route53/lib/hosted-zone-ref.js
var require_hosted_zone_ref = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53/lib/hosted-zone-ref.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-route53/lib/vpc-endpoint-service-domain-name.js
var require_vpc_endpoint_service_domain_name = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53/lib/vpc-endpoint-service-domain-name.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.VpcEndpointServiceDomainName = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var core_1 = require_core2();
    var helpers_internal_1 = require_helpers_internal();
    var custom_resources_1 = require_custom_resources();
    var lib_1 = require_lib28();
    var VpcEndpointServiceDomainName = class _VpcEndpointServiceDomainName extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_VpcEndpointServiceDomainNameProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _VpcEndpointServiceDomainName), error;
        }
        const serviceUniqueId = core_1.Names.nodeUniqueId(props.endpointService.node), serviceId = props.endpointService.vpcEndpointServiceId;
        this.domainName = props.domainName, this.validateProps(props), _VpcEndpointServiceDomainName.endpointServicesMap[serviceUniqueId] = this.domainName, _VpcEndpointServiceDomainName.endpointServices.push(props.endpointService);
        const privateDnsConfiguration = this.getPrivateDnsConfiguration(serviceUniqueId, serviceId, this.domainName);
        this.verifyPrivateDnsConfiguration(privateDnsConfiguration, props.publicHostedZone), this.node.addDependency(props.endpointService);
      }
      validateProps(props) {
        const serviceUniqueId = core_1.Names.nodeUniqueId(props.endpointService.node);
        if (serviceUniqueId in _VpcEndpointServiceDomainName.endpointServicesMap) {
          const endpoint = _VpcEndpointServiceDomainName.endpointServicesMap[serviceUniqueId];
          throw new Error(`Cannot create a VpcEndpointServiceDomainName for service ${serviceUniqueId}, another VpcEndpointServiceDomainName (${endpoint}) is already associated with it`);
        }
      }
      getPrivateDnsConfiguration(serviceUniqueId, serviceId, privateDnsName) {
        const enablePrivateDnsAction = { service: "EC2", action: "modifyVpcEndpointServiceConfiguration", parameters: { ServiceId: serviceId, PrivateDnsName: privateDnsName }, physicalResourceId: custom_resources_1.PhysicalResourceId.of(serviceUniqueId) }, removePrivateDnsAction = { service: "EC2", action: "modifyVpcEndpointServiceConfiguration", parameters: { ServiceId: serviceId, RemovePrivateDnsName: true } }, enable = new custom_resources_1.AwsCustomResource(this, "EnableDns", { onCreate: enablePrivateDnsAction, onUpdate: enablePrivateDnsAction, onDelete: removePrivateDnsAction, policy: custom_resources_1.AwsCustomResourcePolicy.fromSdkCalls({ resources: [core_1.Fn.join(":", ["arn", core_1.Stack.of(this).partition, "ec2", core_1.Stack.of(this).region, core_1.Stack.of(this).account, core_1.Fn.join("/", ["vpc-endpoint-service", serviceId])])] }), installLatestAwsSdk: false }), lookup = hashcode(core_1.Names.uniqueId(this) + serviceUniqueId + privateDnsName), retrieveNameValuePairAction = { service: "EC2", action: "describeVpcEndpointServiceConfigurations", parameters: { ServiceIds: [serviceId] }, physicalResourceId: custom_resources_1.PhysicalResourceId.of(lookup) }, getNames = new custom_resources_1.AwsCustomResource(this, "GetNames", { onCreate: retrieveNameValuePairAction, onUpdate: retrieveNameValuePairAction, policy: custom_resources_1.AwsCustomResourcePolicy.fromSdkCalls({ resources: custom_resources_1.AwsCustomResourcePolicy.ANY_RESOURCE }), installLatestAwsSdk: false });
        getNames.node.addDependency(enable);
        const name = getNames.getResponseField("ServiceConfigurations.0.PrivateDnsNameConfiguration.Name"), value = getNames.getResponseField("ServiceConfigurations.0.PrivateDnsNameConfiguration.Value");
        return { name, value, serviceId };
      }
      verifyPrivateDnsConfiguration(config, publicHostedZone) {
        const verificationRecord = new lib_1.TxtRecord(this, "DnsVerificationRecord", { recordName: config.name, values: [config.value], zone: publicHostedZone }), startVerificationAction = { service: "EC2", action: "startVpcEndpointServicePrivateDnsVerification", parameters: { ServiceId: config.serviceId }, physicalResourceId: custom_resources_1.PhysicalResourceId.of(core_1.Fn.join(":", [config.name, config.value])) };
        new custom_resources_1.AwsCustomResource(this, "StartVerification", { onCreate: startVerificationAction, onUpdate: startVerificationAction, policy: custom_resources_1.AwsCustomResourcePolicy.fromSdkCalls({ resources: [core_1.Fn.join(":", ["arn", core_1.Stack.of(this).partition, "ec2", core_1.Stack.of(this).region, core_1.Stack.of(this).account, core_1.Fn.join("/", ["vpc-endpoint-service", config.serviceId])])] }), installLatestAwsSdk: false }).node.addDependency(verificationRecord);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, VpcEndpointServiceDomainName[_a] = { fqn: "aws-cdk-lib.aws_route53.VpcEndpointServiceDomainName", version: "2.80.0" }, VpcEndpointServiceDomainName.endpointServices = [], VpcEndpointServiceDomainName.endpointServicesMap = {}, exports2.VpcEndpointServiceDomainName = VpcEndpointServiceDomainName;
    function hashcode(s) {
      return (0, helpers_internal_1.md5hash)(s);
    }
  }
});

// node_modules/aws-cdk-lib/aws-route53/lib/index.js
var require_lib28 = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_alias_record_target(), exports2), __exportStar(require_hosted_zone(), exports2), __exportStar(require_hosted_zone_provider(), exports2), __exportStar(require_hosted_zone_ref(), exports2), __exportStar(require_record_set(), exports2), __exportStar(require_vpc_endpoint_service_domain_name(), exports2), __exportStar(require_route53_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-route53/index.js
var require_aws_route53 = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib28(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-secretsmanager/lib/secretsmanager.generated.js
var require_secretsmanager_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-secretsmanager/lib/secretsmanager.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnSecretTargetAttachment = exports2.CfnSecret = exports2.CfnRotationSchedule = exports2.CfnResourcePolicy = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnResourcePolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("blockPublicPolicy", cdk.validateBoolean)(properties.blockPublicPolicy)), errors.collect(cdk.propertyValidator("resourcePolicy", cdk.requiredValidator)(properties.resourcePolicy)), errors.collect(cdk.propertyValidator("resourcePolicy", cdk.validateObject)(properties.resourcePolicy)), errors.collect(cdk.propertyValidator("secretId", cdk.requiredValidator)(properties.secretId)), errors.collect(cdk.propertyValidator("secretId", cdk.validateString)(properties.secretId)), errors.wrap('supplied properties not correct for "CfnResourcePolicyProps"');
    }
    function cfnResourcePolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourcePolicyPropsValidator(properties).assertSuccess(), { ResourcePolicy: cdk.objectToCloudFormation(properties.resourcePolicy), SecretId: cdk.stringToCloudFormation(properties.secretId), BlockPublicPolicy: cdk.booleanToCloudFormation(properties.blockPublicPolicy) }) : properties;
    }
    function CfnResourcePolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourcePolicy", "ResourcePolicy", cfn_parse.FromCloudFormation.getAny(properties.ResourcePolicy)), ret.addPropertyResult("secretId", "SecretId", cfn_parse.FromCloudFormation.getString(properties.SecretId)), ret.addPropertyResult("blockPublicPolicy", "BlockPublicPolicy", properties.BlockPublicPolicy != null ? cfn_parse.FromCloudFormation.getBoolean(properties.BlockPublicPolicy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResourcePolicy = class _CfnResourcePolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResourcePolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnResourcePolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnResourcePolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_CfnResourcePolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResourcePolicy), error;
        }
        cdk.requireProperty(props, "resourcePolicy", this), cdk.requireProperty(props, "secretId", this), this.resourcePolicy = props.resourcePolicy, this.secretId = props.secretId, this.blockPublicPolicy = props.blockPublicPolicy;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResourcePolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { resourcePolicy: this.resourcePolicy, secretId: this.secretId, blockPublicPolicy: this.blockPublicPolicy };
      }
      renderProperties(props) {
        return cfnResourcePolicyPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnResourcePolicy[_a] = { fqn: "aws-cdk-lib.aws_secretsmanager.CfnResourcePolicy", version: "2.80.0" }, CfnResourcePolicy.CFN_RESOURCE_TYPE_NAME = "AWS::SecretsManager::ResourcePolicy", exports2.CfnResourcePolicy = CfnResourcePolicy;
    function CfnRotationSchedulePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("hostedRotationLambda", CfnRotationSchedule_HostedRotationLambdaPropertyValidator)(properties.hostedRotationLambda)), errors.collect(cdk.propertyValidator("rotateImmediatelyOnUpdate", cdk.validateBoolean)(properties.rotateImmediatelyOnUpdate)), errors.collect(cdk.propertyValidator("rotationLambdaArn", cdk.validateString)(properties.rotationLambdaArn)), errors.collect(cdk.propertyValidator("rotationRules", CfnRotationSchedule_RotationRulesPropertyValidator)(properties.rotationRules)), errors.collect(cdk.propertyValidator("secretId", cdk.requiredValidator)(properties.secretId)), errors.collect(cdk.propertyValidator("secretId", cdk.validateString)(properties.secretId)), errors.wrap('supplied properties not correct for "CfnRotationScheduleProps"');
    }
    function cfnRotationSchedulePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRotationSchedulePropsValidator(properties).assertSuccess(), { SecretId: cdk.stringToCloudFormation(properties.secretId), HostedRotationLambda: cfnRotationScheduleHostedRotationLambdaPropertyToCloudFormation(properties.hostedRotationLambda), RotateImmediatelyOnUpdate: cdk.booleanToCloudFormation(properties.rotateImmediatelyOnUpdate), RotationLambdaARN: cdk.stringToCloudFormation(properties.rotationLambdaArn), RotationRules: cfnRotationScheduleRotationRulesPropertyToCloudFormation(properties.rotationRules) }) : properties;
    }
    function CfnRotationSchedulePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("secretId", "SecretId", cfn_parse.FromCloudFormation.getString(properties.SecretId)), ret.addPropertyResult("hostedRotationLambda", "HostedRotationLambda", properties.HostedRotationLambda != null ? CfnRotationScheduleHostedRotationLambdaPropertyFromCloudFormation(properties.HostedRotationLambda) : void 0), ret.addPropertyResult("rotateImmediatelyOnUpdate", "RotateImmediatelyOnUpdate", properties.RotateImmediatelyOnUpdate != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RotateImmediatelyOnUpdate) : void 0), ret.addPropertyResult("rotationLambdaArn", "RotationLambdaARN", properties.RotationLambdaARN != null ? cfn_parse.FromCloudFormation.getString(properties.RotationLambdaARN) : void 0), ret.addPropertyResult("rotationRules", "RotationRules", properties.RotationRules != null ? CfnRotationScheduleRotationRulesPropertyFromCloudFormation(properties.RotationRules) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRotationSchedule = class _CfnRotationSchedule extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRotationSchedulePropsFromCloudFormation(resourceProperties), ret = new _CfnRotationSchedule(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRotationSchedule.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_CfnRotationScheduleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRotationSchedule), error;
        }
        cdk.requireProperty(props, "secretId", this), this.secretId = props.secretId, this.hostedRotationLambda = props.hostedRotationLambda, this.rotateImmediatelyOnUpdate = props.rotateImmediatelyOnUpdate, this.rotationLambdaArn = props.rotationLambdaArn, this.rotationRules = props.rotationRules;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRotationSchedule.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { secretId: this.secretId, hostedRotationLambda: this.hostedRotationLambda, rotateImmediatelyOnUpdate: this.rotateImmediatelyOnUpdate, rotationLambdaArn: this.rotationLambdaArn, rotationRules: this.rotationRules };
      }
      renderProperties(props) {
        return cfnRotationSchedulePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnRotationSchedule[_b] = { fqn: "aws-cdk-lib.aws_secretsmanager.CfnRotationSchedule", version: "2.80.0" }, CfnRotationSchedule.CFN_RESOURCE_TYPE_NAME = "AWS::SecretsManager::RotationSchedule", exports2.CfnRotationSchedule = CfnRotationSchedule;
    function CfnRotationSchedule_HostedRotationLambdaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("excludeCharacters", cdk.validateString)(properties.excludeCharacters)), errors.collect(cdk.propertyValidator("kmsKeyArn", cdk.validateString)(properties.kmsKeyArn)), errors.collect(cdk.propertyValidator("masterSecretArn", cdk.validateString)(properties.masterSecretArn)), errors.collect(cdk.propertyValidator("masterSecretKmsKeyArn", cdk.validateString)(properties.masterSecretKmsKeyArn)), errors.collect(cdk.propertyValidator("rotationLambdaName", cdk.validateString)(properties.rotationLambdaName)), errors.collect(cdk.propertyValidator("rotationType", cdk.requiredValidator)(properties.rotationType)), errors.collect(cdk.propertyValidator("rotationType", cdk.validateString)(properties.rotationType)), errors.collect(cdk.propertyValidator("runtime", cdk.validateString)(properties.runtime)), errors.collect(cdk.propertyValidator("superuserSecretArn", cdk.validateString)(properties.superuserSecretArn)), errors.collect(cdk.propertyValidator("superuserSecretKmsKeyArn", cdk.validateString)(properties.superuserSecretKmsKeyArn)), errors.collect(cdk.propertyValidator("vpcSecurityGroupIds", cdk.validateString)(properties.vpcSecurityGroupIds)), errors.collect(cdk.propertyValidator("vpcSubnetIds", cdk.validateString)(properties.vpcSubnetIds)), errors.wrap('supplied properties not correct for "HostedRotationLambdaProperty"');
    }
    function cfnRotationScheduleHostedRotationLambdaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRotationSchedule_HostedRotationLambdaPropertyValidator(properties).assertSuccess(), { ExcludeCharacters: cdk.stringToCloudFormation(properties.excludeCharacters), KmsKeyArn: cdk.stringToCloudFormation(properties.kmsKeyArn), MasterSecretArn: cdk.stringToCloudFormation(properties.masterSecretArn), MasterSecretKmsKeyArn: cdk.stringToCloudFormation(properties.masterSecretKmsKeyArn), RotationLambdaName: cdk.stringToCloudFormation(properties.rotationLambdaName), RotationType: cdk.stringToCloudFormation(properties.rotationType), Runtime: cdk.stringToCloudFormation(properties.runtime), SuperuserSecretArn: cdk.stringToCloudFormation(properties.superuserSecretArn), SuperuserSecretKmsKeyArn: cdk.stringToCloudFormation(properties.superuserSecretKmsKeyArn), VpcSecurityGroupIds: cdk.stringToCloudFormation(properties.vpcSecurityGroupIds), VpcSubnetIds: cdk.stringToCloudFormation(properties.vpcSubnetIds) }) : properties;
    }
    function CfnRotationScheduleHostedRotationLambdaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("excludeCharacters", "ExcludeCharacters", properties.ExcludeCharacters != null ? cfn_parse.FromCloudFormation.getString(properties.ExcludeCharacters) : void 0), ret.addPropertyResult("kmsKeyArn", "KmsKeyArn", properties.KmsKeyArn != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyArn) : void 0), ret.addPropertyResult("masterSecretArn", "MasterSecretArn", properties.MasterSecretArn != null ? cfn_parse.FromCloudFormation.getString(properties.MasterSecretArn) : void 0), ret.addPropertyResult("masterSecretKmsKeyArn", "MasterSecretKmsKeyArn", properties.MasterSecretKmsKeyArn != null ? cfn_parse.FromCloudFormation.getString(properties.MasterSecretKmsKeyArn) : void 0), ret.addPropertyResult("rotationLambdaName", "RotationLambdaName", properties.RotationLambdaName != null ? cfn_parse.FromCloudFormation.getString(properties.RotationLambdaName) : void 0), ret.addPropertyResult("rotationType", "RotationType", cfn_parse.FromCloudFormation.getString(properties.RotationType)), ret.addPropertyResult("runtime", "Runtime", properties.Runtime != null ? cfn_parse.FromCloudFormation.getString(properties.Runtime) : void 0), ret.addPropertyResult("superuserSecretArn", "SuperuserSecretArn", properties.SuperuserSecretArn != null ? cfn_parse.FromCloudFormation.getString(properties.SuperuserSecretArn) : void 0), ret.addPropertyResult("superuserSecretKmsKeyArn", "SuperuserSecretKmsKeyArn", properties.SuperuserSecretKmsKeyArn != null ? cfn_parse.FromCloudFormation.getString(properties.SuperuserSecretKmsKeyArn) : void 0), ret.addPropertyResult("vpcSecurityGroupIds", "VpcSecurityGroupIds", properties.VpcSecurityGroupIds != null ? cfn_parse.FromCloudFormation.getString(properties.VpcSecurityGroupIds) : void 0), ret.addPropertyResult("vpcSubnetIds", "VpcSubnetIds", properties.VpcSubnetIds != null ? cfn_parse.FromCloudFormation.getString(properties.VpcSubnetIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRotationSchedule_RotationRulesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("automaticallyAfterDays", cdk.validateNumber)(properties.automaticallyAfterDays)), errors.collect(cdk.propertyValidator("duration", cdk.validateString)(properties.duration)), errors.collect(cdk.propertyValidator("scheduleExpression", cdk.validateString)(properties.scheduleExpression)), errors.wrap('supplied properties not correct for "RotationRulesProperty"');
    }
    function cfnRotationScheduleRotationRulesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRotationSchedule_RotationRulesPropertyValidator(properties).assertSuccess(), { AutomaticallyAfterDays: cdk.numberToCloudFormation(properties.automaticallyAfterDays), Duration: cdk.stringToCloudFormation(properties.duration), ScheduleExpression: cdk.stringToCloudFormation(properties.scheduleExpression) }) : properties;
    }
    function CfnRotationScheduleRotationRulesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("automaticallyAfterDays", "AutomaticallyAfterDays", properties.AutomaticallyAfterDays != null ? cfn_parse.FromCloudFormation.getNumber(properties.AutomaticallyAfterDays) : void 0), ret.addPropertyResult("duration", "Duration", properties.Duration != null ? cfn_parse.FromCloudFormation.getString(properties.Duration) : void 0), ret.addPropertyResult("scheduleExpression", "ScheduleExpression", properties.ScheduleExpression != null ? cfn_parse.FromCloudFormation.getString(properties.ScheduleExpression) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSecretPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("generateSecretString", CfnSecret_GenerateSecretStringPropertyValidator)(properties.generateSecretString)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("replicaRegions", cdk.listValidator(CfnSecret_ReplicaRegionPropertyValidator))(properties.replicaRegions)), errors.collect(cdk.propertyValidator("secretString", cdk.validateString)(properties.secretString)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnSecretProps"');
    }
    function cfnSecretPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSecretPropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), GenerateSecretString: cfnSecretGenerateSecretStringPropertyToCloudFormation(properties.generateSecretString), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), Name: cdk.stringToCloudFormation(properties.name), ReplicaRegions: cdk.listMapper(cfnSecretReplicaRegionPropertyToCloudFormation)(properties.replicaRegions), SecretString: cdk.stringToCloudFormation(properties.secretString), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnSecretPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("generateSecretString", "GenerateSecretString", properties.GenerateSecretString != null ? CfnSecretGenerateSecretStringPropertyFromCloudFormation(properties.GenerateSecretString) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("replicaRegions", "ReplicaRegions", properties.ReplicaRegions != null ? cfn_parse.FromCloudFormation.getArray(CfnSecretReplicaRegionPropertyFromCloudFormation)(properties.ReplicaRegions) : void 0), ret.addPropertyResult("secretString", "SecretString", properties.SecretString != null ? cfn_parse.FromCloudFormation.getString(properties.SecretString) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSecret = class _CfnSecret extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSecretPropsFromCloudFormation(resourceProperties), ret = new _CfnSecret(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnSecret.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_CfnSecretProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSecret), error;
        }
        this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.description = props.description, this.generateSecretString = props.generateSecretString, this.kmsKeyId = props.kmsKeyId, this.name = props.name, this.replicaRegions = props.replicaRegions, this.secretString = props.secretString, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SecretsManager::Secret", props.tags, { tagPropertyName: "tags" }), this.node.scope && cdk.Resource.isResource(this.node.scope) && this.node.addValidation({ validate: () => this.cfnOptions.deletionPolicy === void 0 ? ["'AWS::SecretsManager::Secret' is a stateful resource type, and you must specify a Removal Policy for it. Call 'resource.applyRemovalPolicy()'."] : [] });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSecret.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, generateSecretString: this.generateSecretString, kmsKeyId: this.kmsKeyId, name: this.name, replicaRegions: this.replicaRegions, secretString: this.secretString, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnSecretPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnSecret[_c] = { fqn: "aws-cdk-lib.aws_secretsmanager.CfnSecret", version: "2.80.0" }, CfnSecret.CFN_RESOURCE_TYPE_NAME = "AWS::SecretsManager::Secret", exports2.CfnSecret = CfnSecret;
    function CfnSecret_GenerateSecretStringPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("excludeCharacters", cdk.validateString)(properties.excludeCharacters)), errors.collect(cdk.propertyValidator("excludeLowercase", cdk.validateBoolean)(properties.excludeLowercase)), errors.collect(cdk.propertyValidator("excludeNumbers", cdk.validateBoolean)(properties.excludeNumbers)), errors.collect(cdk.propertyValidator("excludePunctuation", cdk.validateBoolean)(properties.excludePunctuation)), errors.collect(cdk.propertyValidator("excludeUppercase", cdk.validateBoolean)(properties.excludeUppercase)), errors.collect(cdk.propertyValidator("generateStringKey", cdk.validateString)(properties.generateStringKey)), errors.collect(cdk.propertyValidator("includeSpace", cdk.validateBoolean)(properties.includeSpace)), errors.collect(cdk.propertyValidator("passwordLength", cdk.validateNumber)(properties.passwordLength)), errors.collect(cdk.propertyValidator("requireEachIncludedType", cdk.validateBoolean)(properties.requireEachIncludedType)), errors.collect(cdk.propertyValidator("secretStringTemplate", cdk.validateString)(properties.secretStringTemplate)), errors.wrap('supplied properties not correct for "GenerateSecretStringProperty"');
    }
    function cfnSecretGenerateSecretStringPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSecret_GenerateSecretStringPropertyValidator(properties).assertSuccess(), { ExcludeCharacters: cdk.stringToCloudFormation(properties.excludeCharacters), ExcludeLowercase: cdk.booleanToCloudFormation(properties.excludeLowercase), ExcludeNumbers: cdk.booleanToCloudFormation(properties.excludeNumbers), ExcludePunctuation: cdk.booleanToCloudFormation(properties.excludePunctuation), ExcludeUppercase: cdk.booleanToCloudFormation(properties.excludeUppercase), GenerateStringKey: cdk.stringToCloudFormation(properties.generateStringKey), IncludeSpace: cdk.booleanToCloudFormation(properties.includeSpace), PasswordLength: cdk.numberToCloudFormation(properties.passwordLength), RequireEachIncludedType: cdk.booleanToCloudFormation(properties.requireEachIncludedType), SecretStringTemplate: cdk.stringToCloudFormation(properties.secretStringTemplate) }) : properties;
    }
    function CfnSecretGenerateSecretStringPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("excludeCharacters", "ExcludeCharacters", properties.ExcludeCharacters != null ? cfn_parse.FromCloudFormation.getString(properties.ExcludeCharacters) : void 0), ret.addPropertyResult("excludeLowercase", "ExcludeLowercase", properties.ExcludeLowercase != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ExcludeLowercase) : void 0), ret.addPropertyResult("excludeNumbers", "ExcludeNumbers", properties.ExcludeNumbers != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ExcludeNumbers) : void 0), ret.addPropertyResult("excludePunctuation", "ExcludePunctuation", properties.ExcludePunctuation != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ExcludePunctuation) : void 0), ret.addPropertyResult("excludeUppercase", "ExcludeUppercase", properties.ExcludeUppercase != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ExcludeUppercase) : void 0), ret.addPropertyResult("generateStringKey", "GenerateStringKey", properties.GenerateStringKey != null ? cfn_parse.FromCloudFormation.getString(properties.GenerateStringKey) : void 0), ret.addPropertyResult("includeSpace", "IncludeSpace", properties.IncludeSpace != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeSpace) : void 0), ret.addPropertyResult("passwordLength", "PasswordLength", properties.PasswordLength != null ? cfn_parse.FromCloudFormation.getNumber(properties.PasswordLength) : void 0), ret.addPropertyResult("requireEachIncludedType", "RequireEachIncludedType", properties.RequireEachIncludedType != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RequireEachIncludedType) : void 0), ret.addPropertyResult("secretStringTemplate", "SecretStringTemplate", properties.SecretStringTemplate != null ? cfn_parse.FromCloudFormation.getString(properties.SecretStringTemplate) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSecret_ReplicaRegionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("region", cdk.requiredValidator)(properties.region)), errors.collect(cdk.propertyValidator("region", cdk.validateString)(properties.region)), errors.wrap('supplied properties not correct for "ReplicaRegionProperty"');
    }
    function cfnSecretReplicaRegionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSecret_ReplicaRegionPropertyValidator(properties).assertSuccess(), { KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), Region: cdk.stringToCloudFormation(properties.region) }) : properties;
    }
    function CfnSecretReplicaRegionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("region", "Region", cfn_parse.FromCloudFormation.getString(properties.Region)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSecretTargetAttachmentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("secretId", cdk.requiredValidator)(properties.secretId)), errors.collect(cdk.propertyValidator("secretId", cdk.validateString)(properties.secretId)), errors.collect(cdk.propertyValidator("targetId", cdk.requiredValidator)(properties.targetId)), errors.collect(cdk.propertyValidator("targetId", cdk.validateString)(properties.targetId)), errors.collect(cdk.propertyValidator("targetType", cdk.requiredValidator)(properties.targetType)), errors.collect(cdk.propertyValidator("targetType", cdk.validateString)(properties.targetType)), errors.wrap('supplied properties not correct for "CfnSecretTargetAttachmentProps"');
    }
    function cfnSecretTargetAttachmentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSecretTargetAttachmentPropsValidator(properties).assertSuccess(), { SecretId: cdk.stringToCloudFormation(properties.secretId), TargetId: cdk.stringToCloudFormation(properties.targetId), TargetType: cdk.stringToCloudFormation(properties.targetType) }) : properties;
    }
    function CfnSecretTargetAttachmentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("secretId", "SecretId", cfn_parse.FromCloudFormation.getString(properties.SecretId)), ret.addPropertyResult("targetId", "TargetId", cfn_parse.FromCloudFormation.getString(properties.TargetId)), ret.addPropertyResult("targetType", "TargetType", cfn_parse.FromCloudFormation.getString(properties.TargetType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSecretTargetAttachment = class _CfnSecretTargetAttachment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSecretTargetAttachmentPropsFromCloudFormation(resourceProperties), ret = new _CfnSecretTargetAttachment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSecretTargetAttachment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_CfnSecretTargetAttachmentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSecretTargetAttachment), error;
        }
        cdk.requireProperty(props, "secretId", this), cdk.requireProperty(props, "targetId", this), cdk.requireProperty(props, "targetType", this), this.secretId = props.secretId, this.targetId = props.targetId, this.targetType = props.targetType;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSecretTargetAttachment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { secretId: this.secretId, targetId: this.targetId, targetType: this.targetType };
      }
      renderProperties(props) {
        return cfnSecretTargetAttachmentPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnSecretTargetAttachment[_d] = { fqn: "aws-cdk-lib.aws_secretsmanager.CfnSecretTargetAttachment", version: "2.80.0" }, CfnSecretTargetAttachment.CFN_RESOURCE_TYPE_NAME = "AWS::SecretsManager::SecretTargetAttachment", exports2.CfnSecretTargetAttachment = CfnSecretTargetAttachment;
  }
});

// node_modules/aws-cdk-lib/aws-secretsmanager/lib/policy.js
var require_policy4 = __commonJS({
  "node_modules/aws-cdk-lib/aws-secretsmanager/lib/policy.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ResourcePolicy = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var secretsmanager_generated_1 = require_secretsmanager_generated();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var ResourcePolicy = class _ResourcePolicy extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id), this.document = new iam.PolicyDocument();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_ResourcePolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ResourcePolicy), error;
        }
        new secretsmanager_generated_1.CfnResourcePolicy(this, "Resource", { resourcePolicy: this.document, secretId: props.secret.secretArn });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ResourcePolicy[_a] = { fqn: "aws-cdk-lib.aws_secretsmanager.ResourcePolicy", version: "2.80.0" }, exports2.ResourcePolicy = ResourcePolicy;
  }
});

// node_modules/aws-cdk-lib/aws-secretsmanager/lib/rotation-schedule.js
var require_rotation_schedule = __commonJS({
  "node_modules/aws-cdk-lib/aws-secretsmanager/lib/rotation-schedule.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.HostedRotationType = exports2.HostedRotation = exports2.RotationSchedule = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var secret_1 = require_secret();
    var secretsmanager_generated_1 = require_secretsmanager_generated();
    var ec2 = require_aws_ec2();
    var iam = require_aws_iam();
    var kms = require_aws_kms();
    var core_1 = require_core2();
    var DEFAULT_PASSWORD_EXCLUDE_CHARS = " %+~`#$&*()|[]{}:;<>?!'/@\"\\";
    var RotationSchedule = class _RotationSchedule extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_RotationScheduleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _RotationSchedule), error;
        }
        if (!props.rotationLambda && !props.hostedRotation || props.rotationLambda && props.hostedRotation)
          throw new Error("One of `rotationLambda` or `hostedRotation` must be specified.");
        props.rotationLambda?.permissionsNode.defaultChild && (props.secret.encryptionKey && props.secret.encryptionKey.grantEncryptDecrypt(new kms.ViaServicePrincipal(`secretsmanager.${core_1.Stack.of(this).region}.amazonaws.com`, props.rotationLambda.grantPrincipal)), props.rotationLambda.grantInvoke(new iam.ServicePrincipal("secretsmanager.amazonaws.com")), props.rotationLambda.addToRolePolicy(new iam.PolicyStatement({ actions: ["secretsmanager:DescribeSecret", "secretsmanager:GetSecretValue", "secretsmanager:PutSecretValue", "secretsmanager:UpdateSecretVersionStage"], resources: [props.secret.secretFullArn ? props.secret.secretFullArn : `${props.secret.secretArn}-??????`] })), props.rotationLambda.addToRolePolicy(new iam.PolicyStatement({ actions: ["secretsmanager:GetRandomPassword"], resources: ["*"] })));
        let automaticallyAfterDays;
        props.automaticallyAfter?.toMilliseconds() !== 0 && (automaticallyAfterDays = props.automaticallyAfter?.toDays() || 30);
        let rotationRules;
        automaticallyAfterDays !== void 0 && (rotationRules = { automaticallyAfterDays }), new secretsmanager_generated_1.CfnRotationSchedule(this, "Resource", { secretId: props.secret.secretArn, rotationLambdaArn: props.rotationLambda?.functionArn, hostedRotationLambda: props.hostedRotation?.bind(props.secret, this), rotationRules }), props.secret.denyAccountRootDelete();
      }
    };
    _a = JSII_RTTI_SYMBOL_1, RotationSchedule[_a] = { fqn: "aws-cdk-lib.aws_secretsmanager.RotationSchedule", version: "2.80.0" }, exports2.RotationSchedule = RotationSchedule;
    var HostedRotation = class _HostedRotation {
      static mysqlSingleUser(options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_SingleUserHostedRotationOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.mysqlSingleUser), error;
        }
        return new _HostedRotation(HostedRotationType.MYSQL_SINGLE_USER, options);
      }
      static mysqlMultiUser(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_MultiUserHostedRotationOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.mysqlMultiUser), error;
        }
        return new _HostedRotation(HostedRotationType.MYSQL_MULTI_USER, options, options.masterSecret);
      }
      static postgreSqlSingleUser(options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_SingleUserHostedRotationOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.postgreSqlSingleUser), error;
        }
        return new _HostedRotation(HostedRotationType.POSTGRESQL_SINGLE_USER, options);
      }
      static postgreSqlMultiUser(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_MultiUserHostedRotationOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.postgreSqlMultiUser), error;
        }
        return new _HostedRotation(HostedRotationType.POSTGRESQL_MULTI_USER, options, options.masterSecret);
      }
      static oracleSingleUser(options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_SingleUserHostedRotationOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.oracleSingleUser), error;
        }
        return new _HostedRotation(HostedRotationType.ORACLE_SINGLE_USER, options);
      }
      static oracleMultiUser(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_MultiUserHostedRotationOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.oracleMultiUser), error;
        }
        return new _HostedRotation(HostedRotationType.ORACLE_MULTI_USER, options, options.masterSecret);
      }
      static mariaDbSingleUser(options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_SingleUserHostedRotationOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.mariaDbSingleUser), error;
        }
        return new _HostedRotation(HostedRotationType.MARIADB_SINGLE_USER, options);
      }
      static mariaDbMultiUser(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_MultiUserHostedRotationOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.mariaDbMultiUser), error;
        }
        return new _HostedRotation(HostedRotationType.MARIADB_MULTI_USER, options, options.masterSecret);
      }
      static sqlServerSingleUser(options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_SingleUserHostedRotationOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.sqlServerSingleUser), error;
        }
        return new _HostedRotation(HostedRotationType.SQLSERVER_SINGLE_USER, options);
      }
      static sqlServerMultiUser(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_MultiUserHostedRotationOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.sqlServerMultiUser), error;
        }
        return new _HostedRotation(HostedRotationType.SQLSERVER_MULTI_USER, options, options.masterSecret);
      }
      static redshiftSingleUser(options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_SingleUserHostedRotationOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.redshiftSingleUser), error;
        }
        return new _HostedRotation(HostedRotationType.REDSHIFT_SINGLE_USER, options);
      }
      static redshiftMultiUser(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_MultiUserHostedRotationOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.redshiftMultiUser), error;
        }
        return new _HostedRotation(HostedRotationType.REDSHIFT_MULTI_USER, options, options.masterSecret);
      }
      static mongoDbSingleUser(options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_SingleUserHostedRotationOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.mongoDbSingleUser), error;
        }
        return new _HostedRotation(HostedRotationType.MONGODB_SINGLE_USER, options);
      }
      static mongoDbMultiUser(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_MultiUserHostedRotationOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.mongoDbMultiUser), error;
        }
        return new _HostedRotation(HostedRotationType.MONGODB_MULTI_USER, options, options.masterSecret);
      }
      constructor(type, props, masterSecret) {
        if (this.type = type, this.props = props, this.masterSecret = masterSecret, type.isMultiUser && !masterSecret)
          throw new Error("The `masterSecret` must be specified when using the multi user scheme.");
      }
      bind(secret, scope) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_ISecret(secret);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        if (core_1.Stack.of(scope).addTransform("AWS::SecretsManager-2020-07-23"), !this.props.vpc && this.props.securityGroups)
          throw new Error("`vpc` must be specified when specifying `securityGroups`.");
        this.props.vpc && (this._connections = new ec2.Connections({ securityGroups: this.props.securityGroups || [new ec2.SecurityGroup(scope, "SecurityGroup", { vpc: this.props.vpc })] })), this.masterSecret && this.masterSecret.denyAccountRootDelete();
        const defaultExcludeCharacters = secret_1.Secret.isSecret(secret) ? secret.excludeCharacters ?? DEFAULT_PASSWORD_EXCLUDE_CHARS : DEFAULT_PASSWORD_EXCLUDE_CHARS;
        return { rotationType: this.type.name, kmsKeyArn: secret.encryptionKey?.keyArn, masterSecretArn: this.masterSecret?.secretArn, masterSecretKmsKeyArn: this.masterSecret?.encryptionKey?.keyArn, rotationLambdaName: this.props.functionName, vpcSecurityGroupIds: this._connections?.securityGroups?.map((s) => s.securityGroupId).join(","), vpcSubnetIds: this.props.vpc?.selectSubnets(this.props.vpcSubnets).subnetIds.join(","), excludeCharacters: this.props.excludeCharacters ?? defaultExcludeCharacters };
      }
      get connections() {
        if (!this.props.vpc)
          throw new Error("Cannot use connections for a hosted rotation that is not deployed in a VPC");
        if (!this._connections)
          throw new Error("Cannot use connections for a hosted rotation that has not been bound to a secret");
        return this._connections;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, HostedRotation[_b] = { fqn: "aws-cdk-lib.aws_secretsmanager.HostedRotation", version: "2.80.0" }, exports2.HostedRotation = HostedRotation;
    var HostedRotationType = class {
      constructor(name, isMultiUser) {
        this.name = name, this.isMultiUser = isMultiUser;
      }
    };
    _c = JSII_RTTI_SYMBOL_1, HostedRotationType[_c] = { fqn: "aws-cdk-lib.aws_secretsmanager.HostedRotationType", version: "2.80.0" }, HostedRotationType.MYSQL_SINGLE_USER = new HostedRotationType("MySQLSingleUser"), HostedRotationType.MYSQL_MULTI_USER = new HostedRotationType("MySQLMultiUser", true), HostedRotationType.POSTGRESQL_SINGLE_USER = new HostedRotationType("PostgreSQLSingleUser"), HostedRotationType.POSTGRESQL_MULTI_USER = new HostedRotationType("PostgreSQLMultiUser", true), HostedRotationType.ORACLE_SINGLE_USER = new HostedRotationType("OracleSingleUser"), HostedRotationType.ORACLE_MULTI_USER = new HostedRotationType("OracleMultiUser", true), HostedRotationType.MARIADB_SINGLE_USER = new HostedRotationType("MariaDBSingleUser"), HostedRotationType.MARIADB_MULTI_USER = new HostedRotationType("MariaDBMultiUser", true), HostedRotationType.SQLSERVER_SINGLE_USER = new HostedRotationType("SQLServerSingleUser"), HostedRotationType.SQLSERVER_MULTI_USER = new HostedRotationType("SQLServerMultiUser", true), HostedRotationType.REDSHIFT_SINGLE_USER = new HostedRotationType("RedshiftSingleUser"), HostedRotationType.REDSHIFT_MULTI_USER = new HostedRotationType("RedshiftMultiUser", true), HostedRotationType.MONGODB_SINGLE_USER = new HostedRotationType("MongoDBSingleUser"), HostedRotationType.MONGODB_MULTI_USER = new HostedRotationType("MongoDBMultiUser", true), exports2.HostedRotationType = HostedRotationType;
  }
});

// node_modules/aws-cdk-lib/aws-secretsmanager/lib/secret.js
var require_secret = __commonJS({
  "node_modules/aws-cdk-lib/aws-secretsmanager/lib/secret.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SecretTargetAttachment = exports2.AttachmentTargetType = exports2.Secret = exports2.SecretStringValueBeta1 = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var policy_1 = require_policy4();
    var rotation_schedule_1 = require_rotation_schedule();
    var secretsmanager = require_secretsmanager_generated();
    var iam = require_aws_iam();
    var kms = require_aws_kms();
    var core_1 = require_core2();
    var cxapi = require_cx_api();
    var SECRET_SYMBOL = Symbol.for("@aws-cdk/secretsmanager.Secret");
    var SecretStringValueBeta1 = class _SecretStringValueBeta1 {
      static fromUnsafePlaintext(secretValue) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_secretsmanager.SecretStringValueBeta1#fromUnsafePlaintext", "Use `cdk.SecretValue` instead.");
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromUnsafePlaintext), error;
        }
        return new _SecretStringValueBeta1(secretValue);
      }
      static fromToken(secretValueFromToken) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_secretsmanager.SecretStringValueBeta1#fromToken", "Use `cdk.SecretValue` instead.");
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromToken), error;
        }
        if (!core_1.Token.isUnresolved(secretValueFromToken))
          throw new Error("SecretStringValueBeta1 appears to be plaintext (unsafe) string (or resolved Token); use fromUnsafePlaintext if this is intentional");
        return new _SecretStringValueBeta1(secretValueFromToken);
      }
      constructor(_secretValue) {
        this._secretValue = _secretValue;
      }
      secretValue() {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_secretsmanager.SecretStringValueBeta1#secretValue", "Use `cdk.SecretValue` instead.");
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.secretValue), error;
        }
        return this._secretValue;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SecretStringValueBeta1[_a] = { fqn: "aws-cdk-lib.aws_secretsmanager.SecretStringValueBeta1", version: "2.80.0" }, exports2.SecretStringValueBeta1 = SecretStringValueBeta1;
    var SecretBase = class extends core_1.Resource {
      constructor(scope, id, props = {}) {
        super(scope, id, props), this.node.addValidation({ validate: () => this.policy?.document.validateForResourcePolicy() ?? [] });
      }
      get secretFullArn() {
        return this.secretArn;
      }
      grantRead(grantee, versionStages) {
        const result = iam.Grant.addToPrincipalOrResource({ grantee, actions: ["secretsmanager:GetSecretValue", "secretsmanager:DescribeSecret"], resourceArns: [this.arnForPolicies], resource: this }), statement = result.principalStatement || result.resourceStatement;
        versionStages != null && statement && statement.addCondition("ForAnyValue:StringEquals", { "secretsmanager:VersionStage": versionStages }), this.encryptionKey && this.encryptionKey.grantDecrypt(new kms.ViaServicePrincipal(`secretsmanager.${core_1.Stack.of(this).region}.amazonaws.com`, grantee.grantPrincipal));
        const crossAccount = core_1.Token.compareStrings(core_1.Stack.of(this).account, grantee.grantPrincipal.principalAccount || "");
        if (this instanceof Secret && result.resourceStatement && !this.encryptionKey && crossAccount === core_1.TokenComparison.DIFFERENT)
          throw new Error("KMS Key must be provided for cross account access to Secret");
        return result;
      }
      grantWrite(grantee) {
        const result = iam.Grant.addToPrincipalOrResource({ grantee, actions: ["secretsmanager:PutSecretValue", "secretsmanager:UpdateSecret"], resourceArns: [this.arnForPolicies], resource: this });
        if (this.encryptionKey && this.encryptionKey.grantEncrypt(new kms.ViaServicePrincipal(`secretsmanager.${core_1.Stack.of(this).region}.amazonaws.com`, grantee.grantPrincipal)), this instanceof Secret && result.resourceStatement && !this.encryptionKey)
          throw new Error("KMS Key must be provided for cross account access to Secret");
        return result;
      }
      get secretValue() {
        return this.secretValueFromJson("");
      }
      secretValueFromJson(jsonField) {
        return core_1.SecretValue.secretsManager(this.secretArn, { jsonField });
      }
      addRotationSchedule(id, options) {
        return new rotation_schedule_1.RotationSchedule(this, id, { secret: this, ...options });
      }
      addToResourcePolicy(statement) {
        return !this.policy && this.autoCreatePolicy && (this.policy = new policy_1.ResourcePolicy(this, "Policy", { secret: this })), this.policy ? (this.policy.document.addStatements(statement), { statementAdded: true, policyDependable: this.policy }) : { statementAdded: false };
      }
      denyAccountRootDelete() {
        this.addToResourcePolicy(new iam.PolicyStatement({ actions: ["secretsmanager:DeleteSecret"], effect: iam.Effect.DENY, resources: ["*"], principals: [new iam.AccountRootPrincipal()] }));
      }
      get arnForPolicies() {
        return this.secretFullArn ? this.secretFullArn : `${this.secretArn}-??????`;
      }
      attach(target) {
        const id = "Attachment";
        if (this.node.tryFindChild(id))
          throw new Error("Secret is already attached to a target.");
        return new SecretTargetAttachment(this, id, { secret: this, target });
      }
    };
    var Secret = class _Secret extends SecretBase {
      static isSecret(x) {
        return x !== null && typeof x == "object" && SECRET_SYMBOL in x;
      }
      static fromSecretArn(scope, id, secretArn) {
        const attrs = arnIsComplete(secretArn) ? { secretCompleteArn: secretArn } : { secretPartialArn: secretArn };
        return _Secret.fromSecretAttributes(scope, id, attrs);
      }
      static fromSecretCompleteArn(scope, id, secretCompleteArn) {
        return _Secret.fromSecretAttributes(scope, id, { secretCompleteArn });
      }
      static fromSecretPartialArn(scope, id, secretPartialArn) {
        return _Secret.fromSecretAttributes(scope, id, { secretPartialArn });
      }
      static fromSecretName(scope, id, secretName) {
        return new class extends SecretBase {
          constructor() {
            super(...arguments), this.encryptionKey = void 0, this.secretArn = secretName, this.secretName = secretName, this.autoCreatePolicy = false;
          }
          get secretFullArn() {
          }
          get arnForPolicies() {
            return core_1.Stack.of(this).formatArn({ service: "secretsmanager", resource: "secret", resourceName: this.secretName + "*", arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME });
          }
        }(scope, id);
      }
      static fromSecretNameV2(scope, id, secretName) {
        return new class extends SecretBase {
          constructor() {
            super(...arguments), this.encryptionKey = void 0, this.secretName = secretName, this.secretArn = this.partialArn, this.autoCreatePolicy = false;
          }
          get secretFullArn() {
          }
          get partialArn() {
            return core_1.Stack.of(this).formatArn({ service: "secretsmanager", resource: "secret", resourceName: secretName, arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME });
          }
        }(scope, id);
      }
      static fromSecretAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_SecretAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromSecretAttributes), error;
        }
        let secretArn, secretArnIsPartial;
        if (attrs.secretArn) {
          if (attrs.secretCompleteArn || attrs.secretPartialArn)
            throw new Error("cannot use `secretArn` with `secretCompleteArn` or `secretPartialArn`");
          secretArn = attrs.secretArn, secretArnIsPartial = false;
        } else {
          if (attrs.secretCompleteArn && attrs.secretPartialArn || !attrs.secretCompleteArn && !attrs.secretPartialArn)
            throw new Error("must use only one of `secretCompleteArn` or `secretPartialArn`");
          if (attrs.secretCompleteArn && !arnIsComplete(attrs.secretCompleteArn))
            throw new Error("`secretCompleteArn` does not appear to be complete; missing 6-character suffix");
          [secretArn, secretArnIsPartial] = attrs.secretCompleteArn ? [attrs.secretCompleteArn, false] : [attrs.secretPartialArn, true];
        }
        return new class extends SecretBase {
          constructor() {
            super(...arguments), this.encryptionKey = attrs.encryptionKey, this.secretArn = secretArn, this.secretName = parseSecretName(scope, secretArn), this.autoCreatePolicy = false;
          }
          get secretFullArn() {
            return secretArnIsPartial ? void 0 : secretArn;
          }
        }(scope, id, { environmentFromArn: secretArn });
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.secretName }), this.replicaRegions = [], this.autoCreatePolicy = true;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_SecretProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Secret), error;
        }
        if (props.generateSecretString && (props.generateSecretString.secretStringTemplate || props.generateSecretString.generateStringKey) && !(props.generateSecretString.secretStringTemplate && props.generateSecretString.generateStringKey))
          throw new Error("`secretStringTemplate` and `generateStringKey` must be specified together.");
        if ((props.generateSecretString ? 1 : 0) + (props.secretStringBeta1 ? 1 : 0) + (props.secretStringValue ? 1 : 0) + (props.secretObjectValue ? 1 : 0) > 1)
          throw new Error("Cannot specify more than one of `generateSecretString`, `secretStringValue`, `secretObjectValue`, and `secretStringBeta1`.");
        const secretString = props.secretObjectValue ? this.resolveSecretObjectValue(props.secretObjectValue) : props.secretStringValue?.unsafeUnwrap() ?? props.secretStringBeta1?.secretValue(), resource = new secretsmanager.CfnSecret(this, "Resource", { description: props.description, kmsKeyId: props.encryptionKey && props.encryptionKey.keyArn, generateSecretString: props.generateSecretString ?? (secretString ? void 0 : {}), secretString, name: this.physicalName, replicaRegions: core_1.Lazy.any({ produce: () => this.replicaRegions }, { omitEmptyArray: true }) });
        resource.applyRemovalPolicy(props.removalPolicy, { default: core_1.RemovalPolicy.DESTROY }), this.secretArn = this.getResourceArnAttribute(resource.ref, { service: "secretsmanager", resource: "secret", resourceName: this.physicalName, arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME }), this.encryptionKey = props.encryptionKey;
        const parseOwnedSecretName = core_1.FeatureFlags.of(this).isEnabled(cxapi.SECRETS_MANAGER_PARSE_OWNED_SECRET_NAME);
        this.secretName = parseOwnedSecretName ? parseSecretNameForOwnedSecret(this, this.secretArn, props.secretName) : parseSecretName(this, this.secretArn);
        const principal = new kms.ViaServicePrincipal(`secretsmanager.${core_1.Stack.of(this).region}.amazonaws.com`, new iam.AccountPrincipal(core_1.Stack.of(this).account));
        this.encryptionKey?.grantEncryptDecrypt(principal), this.encryptionKey?.grant(principal, "kms:CreateGrant", "kms:DescribeKey");
        for (const replica of props.replicaRegions ?? [])
          this.addReplicaRegion(replica.region, replica.encryptionKey);
        this.excludeCharacters = props.generateSecretString?.excludeCharacters;
      }
      resolveSecretObjectValue(secretObject) {
        const resolvedObject = {};
        for (const [key, value] of Object.entries(secretObject))
          resolvedObject[key] = value.unsafeUnwrap();
        return JSON.stringify(resolvedObject);
      }
      addTargetAttachment(id, options) {
        return new SecretTargetAttachment(this, id, { secret: this, ...options });
      }
      addReplicaRegion(region, encryptionKey) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kms_IKey(encryptionKey);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addReplicaRegion), error;
        }
        const stack = core_1.Stack.of(this);
        if (!core_1.Token.isUnresolved(stack.region) && !core_1.Token.isUnresolved(region) && region === stack.region)
          throw new Error("Cannot add the region where this stack is deployed as a replica region.");
        this.replicaRegions.push({ region, kmsKeyId: encryptionKey?.keyArn });
      }
    };
    _b = JSII_RTTI_SYMBOL_1, Secret[_b] = { fqn: "aws-cdk-lib.aws_secretsmanager.Secret", version: "2.80.0" }, exports2.Secret = Secret;
    var AttachmentTargetType;
    (function(AttachmentTargetType2) {
      AttachmentTargetType2.RDS_DB_INSTANCE = "AWS::RDS::DBInstance", AttachmentTargetType2.INSTANCE = "deprecated_AWS::RDS::DBInstance", AttachmentTargetType2.RDS_DB_CLUSTER = "AWS::RDS::DBCluster", AttachmentTargetType2.CLUSTER = "deprecated_AWS::RDS::DBCluster", AttachmentTargetType2.RDS_DB_PROXY = "AWS::RDS::DBProxy", AttachmentTargetType2.REDSHIFT_CLUSTER = "AWS::Redshift::Cluster", AttachmentTargetType2.DOCDB_DB_INSTANCE = "AWS::DocDB::DBInstance", AttachmentTargetType2.DOCDB_DB_CLUSTER = "AWS::DocDB::DBCluster";
    })(AttachmentTargetType = exports2.AttachmentTargetType || (exports2.AttachmentTargetType = {}));
    var SecretTargetAttachment = class _SecretTargetAttachment extends SecretBase {
      static fromSecretTargetAttachmentSecretArn(scope, id, secretTargetAttachmentSecretArn) {
        class Import extends SecretBase {
          constructor() {
            super(...arguments), this.secretArn = secretTargetAttachmentSecretArn, this.secretTargetAttachmentSecretArn = secretTargetAttachmentSecretArn, this.secretName = parseSecretName(scope, secretTargetAttachmentSecretArn), this.autoCreatePolicy = false;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id), this.autoCreatePolicy = true;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_SecretTargetAttachmentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SecretTargetAttachment), error;
        }
        this.attachedSecret = props.secret;
        const attachment = new secretsmanager.CfnSecretTargetAttachment(this, "Resource", { secretId: this.attachedSecret.secretArn, targetId: props.target.asSecretAttachmentTarget().targetId, targetType: attachmentTargetTypeToString(props.target.asSecretAttachmentTarget().targetType) });
        this.encryptionKey = this.attachedSecret.encryptionKey, this.secretName = this.attachedSecret.secretName, this.secretArn = attachment.ref, this.secretTargetAttachmentSecretArn = attachment.ref;
      }
      addToResourcePolicy(statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToResourcePolicy), error;
        }
        return core_1.FeatureFlags.of(this).isEnabled(cxapi.SECRETS_MANAGER_TARGET_ATTACHMENT_RESOURCE_POLICY) ? this.attachedSecret.addToResourcePolicy(statement) : super.addToResourcePolicy(statement);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, SecretTargetAttachment[_c] = { fqn: "aws-cdk-lib.aws_secretsmanager.SecretTargetAttachment", version: "2.80.0" }, exports2.SecretTargetAttachment = SecretTargetAttachment;
    function parseSecretName(construct, secretArn) {
      const resourceName = core_1.Stack.of(construct).splitArn(secretArn, core_1.ArnFormat.COLON_RESOURCE_NAME).resourceName;
      if (resourceName) {
        if (core_1.Token.isUnresolved(resourceName))
          return resourceName;
        const lastHyphenIndex = resourceName.lastIndexOf("-");
        return lastHyphenIndex !== -1 && resourceName.slice(lastHyphenIndex + 1).length === 6 ? resourceName.slice(0, lastHyphenIndex) : resourceName;
      }
      throw new Error("invalid ARN format; no secret name provided");
    }
    function parseSecretNameForOwnedSecret(construct, secretArn, secretName) {
      const resourceName = core_1.Stack.of(construct).splitArn(secretArn, core_1.ArnFormat.COLON_RESOURCE_NAME).resourceName;
      if (!resourceName)
        throw new Error("invalid ARN format; no secret name provided");
      if (secretName && core_1.Token.isUnresolved(secretName))
        return secretName;
      const secretNameHyphenatedSegments = secretName ? secretName.split("-").length : 2, segmentIndexes = [...new Array(secretNameHyphenatedSegments)].map((_, i) => i);
      return core_1.Fn.join("-", segmentIndexes.map((i) => core_1.Fn.select(i, core_1.Fn.split("-", resourceName))));
    }
    function arnIsComplete(secretArn) {
      return core_1.Token.isUnresolved(secretArn) || /-[a-z0-9]{6}$/i.test(secretArn);
    }
    Object.defineProperty(Secret.prototype, SECRET_SYMBOL, { value: true, enumerable: false, writable: false });
    function attachmentTargetTypeToString(x) {
      switch (x) {
        case AttachmentTargetType.RDS_DB_INSTANCE:
        case AttachmentTargetType.INSTANCE:
          return "AWS::RDS::DBInstance";
        case AttachmentTargetType.RDS_DB_CLUSTER:
        case AttachmentTargetType.CLUSTER:
          return "AWS::RDS::DBCluster";
        case AttachmentTargetType.RDS_DB_PROXY:
          return "AWS::RDS::DBProxy";
        case AttachmentTargetType.REDSHIFT_CLUSTER:
          return "AWS::Redshift::Cluster";
        case AttachmentTargetType.DOCDB_DB_INSTANCE:
          return "AWS::DocDB::DBInstance";
        case AttachmentTargetType.DOCDB_DB_CLUSTER:
          return "AWS::DocDB::DBCluster";
      }
    }
  }
});

// node_modules/aws-cdk-lib/aws-sam/lib/sam.generated.js
var require_sam_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-sam/lib/sam.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnStateMachine = exports2.CfnSimpleTable = exports2.CfnLayerVersion = exports2.CfnHttpApi = exports2.CfnFunction = exports2.CfnApplication = exports2.CfnApi = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnApiPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessLogSetting", CfnApi_AccessLogSettingPropertyValidator)(properties.accessLogSetting)), errors.collect(cdk.propertyValidator("auth", CfnApi_AuthPropertyValidator)(properties.auth)), errors.collect(cdk.propertyValidator("binaryMediaTypes", cdk.listValidator(cdk.validateString))(properties.binaryMediaTypes)), errors.collect(cdk.propertyValidator("cacheClusterEnabled", cdk.validateBoolean)(properties.cacheClusterEnabled)), errors.collect(cdk.propertyValidator("cacheClusterSize", cdk.validateString)(properties.cacheClusterSize)), errors.collect(cdk.propertyValidator("canarySetting", CfnApi_CanarySettingPropertyValidator)(properties.canarySetting)), errors.collect(cdk.propertyValidator("cors", cdk.unionValidator(CfnApi_CorsConfigurationPropertyValidator, cdk.validateString))(properties.cors)), errors.collect(cdk.propertyValidator("definitionBody", cdk.validateObject)(properties.definitionBody)), errors.collect(cdk.propertyValidator("definitionUri", cdk.unionValidator(CfnApi_S3LocationPropertyValidator, cdk.validateString))(properties.definitionUri)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("disableExecuteApiEndpoint", cdk.validateBoolean)(properties.disableExecuteApiEndpoint)), errors.collect(cdk.propertyValidator("domain", CfnApi_DomainConfigurationPropertyValidator)(properties.domain)), errors.collect(cdk.propertyValidator("endpointConfiguration", cdk.unionValidator(CfnApi_EndpointConfigurationPropertyValidator, cdk.validateString))(properties.endpointConfiguration)), errors.collect(cdk.propertyValidator("gatewayResponses", cdk.validateObject)(properties.gatewayResponses)), errors.collect(cdk.propertyValidator("methodSettings", cdk.listValidator(cdk.validateObject))(properties.methodSettings)), errors.collect(cdk.propertyValidator("minimumCompressionSize", cdk.validateNumber)(properties.minimumCompressionSize)), errors.collect(cdk.propertyValidator("models", cdk.validateObject)(properties.models)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("openApiVersion", cdk.validateString)(properties.openApiVersion)), errors.collect(cdk.propertyValidator("stageName", cdk.requiredValidator)(properties.stageName)), errors.collect(cdk.propertyValidator("stageName", cdk.validateString)(properties.stageName)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.collect(cdk.propertyValidator("tracingEnabled", cdk.validateBoolean)(properties.tracingEnabled)), errors.collect(cdk.propertyValidator("variables", cdk.hashValidator(cdk.validateString))(properties.variables)), errors.wrap('supplied properties not correct for "CfnApiProps"');
    }
    function cfnApiPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApiPropsValidator(properties).assertSuccess(), { StageName: cdk.stringToCloudFormation(properties.stageName), AccessLogSetting: cfnApiAccessLogSettingPropertyToCloudFormation(properties.accessLogSetting), Auth: cfnApiAuthPropertyToCloudFormation(properties.auth), BinaryMediaTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.binaryMediaTypes), CacheClusterEnabled: cdk.booleanToCloudFormation(properties.cacheClusterEnabled), CacheClusterSize: cdk.stringToCloudFormation(properties.cacheClusterSize), CanarySetting: cfnApiCanarySettingPropertyToCloudFormation(properties.canarySetting), Cors: cdk.unionMapper([CfnApi_CorsConfigurationPropertyValidator, cdk.validateString], [cfnApiCorsConfigurationPropertyToCloudFormation, cdk.stringToCloudFormation])(properties.cors), DefinitionBody: cdk.objectToCloudFormation(properties.definitionBody), DefinitionUri: cdk.unionMapper([CfnApi_S3LocationPropertyValidator, cdk.validateString], [cfnApiS3LocationPropertyToCloudFormation, cdk.stringToCloudFormation])(properties.definitionUri), Description: cdk.stringToCloudFormation(properties.description), DisableExecuteApiEndpoint: cdk.booleanToCloudFormation(properties.disableExecuteApiEndpoint), Domain: cfnApiDomainConfigurationPropertyToCloudFormation(properties.domain), EndpointConfiguration: cdk.unionMapper([CfnApi_EndpointConfigurationPropertyValidator, cdk.validateString], [cfnApiEndpointConfigurationPropertyToCloudFormation, cdk.stringToCloudFormation])(properties.endpointConfiguration), GatewayResponses: cdk.objectToCloudFormation(properties.gatewayResponses), MethodSettings: cdk.listMapper(cdk.objectToCloudFormation)(properties.methodSettings), MinimumCompressionSize: cdk.numberToCloudFormation(properties.minimumCompressionSize), Models: cdk.objectToCloudFormation(properties.models), Name: cdk.stringToCloudFormation(properties.name), OpenApiVersion: cdk.stringToCloudFormation(properties.openApiVersion), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags), TracingEnabled: cdk.booleanToCloudFormation(properties.tracingEnabled), Variables: cdk.hashMapper(cdk.stringToCloudFormation)(properties.variables) }) : properties;
    }
    function CfnApiPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("stageName", "StageName", cfn_parse.FromCloudFormation.getString(properties.StageName)), ret.addPropertyResult("accessLogSetting", "AccessLogSetting", properties.AccessLogSetting != null ? CfnApiAccessLogSettingPropertyFromCloudFormation(properties.AccessLogSetting) : void 0), ret.addPropertyResult("auth", "Auth", properties.Auth != null ? CfnApiAuthPropertyFromCloudFormation(properties.Auth) : void 0), ret.addPropertyResult("binaryMediaTypes", "BinaryMediaTypes", properties.BinaryMediaTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.BinaryMediaTypes) : void 0), ret.addPropertyResult("cacheClusterEnabled", "CacheClusterEnabled", properties.CacheClusterEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CacheClusterEnabled) : void 0), ret.addPropertyResult("cacheClusterSize", "CacheClusterSize", properties.CacheClusterSize != null ? cfn_parse.FromCloudFormation.getString(properties.CacheClusterSize) : void 0), ret.addPropertyResult("canarySetting", "CanarySetting", properties.CanarySetting != null ? CfnApiCanarySettingPropertyFromCloudFormation(properties.CanarySetting) : void 0), ret.addPropertyResult("cors", "Cors", properties.Cors != null ? cfn_parse.FromCloudFormation.getTypeUnion([CfnApi_CorsConfigurationPropertyValidator, cdk.validateString], [CfnApiCorsConfigurationPropertyFromCloudFormation, cfn_parse.FromCloudFormation.getString])(properties.Cors) : void 0), ret.addPropertyResult("definitionBody", "DefinitionBody", properties.DefinitionBody != null ? cfn_parse.FromCloudFormation.getAny(properties.DefinitionBody) : void 0), ret.addPropertyResult("definitionUri", "DefinitionUri", properties.DefinitionUri != null ? cfn_parse.FromCloudFormation.getTypeUnion([CfnApi_S3LocationPropertyValidator, cdk.validateString], [CfnApiS3LocationPropertyFromCloudFormation, cfn_parse.FromCloudFormation.getString])(properties.DefinitionUri) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("disableExecuteApiEndpoint", "DisableExecuteApiEndpoint", properties.DisableExecuteApiEndpoint != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DisableExecuteApiEndpoint) : void 0), ret.addPropertyResult("domain", "Domain", properties.Domain != null ? CfnApiDomainConfigurationPropertyFromCloudFormation(properties.Domain) : void 0), ret.addPropertyResult("endpointConfiguration", "EndpointConfiguration", properties.EndpointConfiguration != null ? cfn_parse.FromCloudFormation.getTypeUnion([CfnApi_EndpointConfigurationPropertyValidator, cdk.validateString], [CfnApiEndpointConfigurationPropertyFromCloudFormation, cfn_parse.FromCloudFormation.getString])(properties.EndpointConfiguration) : void 0), ret.addPropertyResult("gatewayResponses", "GatewayResponses", properties.GatewayResponses != null ? cfn_parse.FromCloudFormation.getAny(properties.GatewayResponses) : void 0), ret.addPropertyResult("methodSettings", "MethodSettings", properties.MethodSettings != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getAny)(properties.MethodSettings) : void 0), ret.addPropertyResult("minimumCompressionSize", "MinimumCompressionSize", properties.MinimumCompressionSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinimumCompressionSize) : void 0), ret.addPropertyResult("models", "Models", properties.Models != null ? cfn_parse.FromCloudFormation.getAny(properties.Models) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("openApiVersion", "OpenApiVersion", properties.OpenApiVersion != null ? cfn_parse.FromCloudFormation.getString(properties.OpenApiVersion) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addPropertyResult("tracingEnabled", "TracingEnabled", properties.TracingEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.TracingEnabled) : void 0), ret.addPropertyResult("variables", "Variables", properties.Variables != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Variables) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApi = class _CfnApi extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApiPropsFromCloudFormation(resourceProperties), ret = new _CfnApi(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApi.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sam_CfnApiProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApi), error;
        }
        cdk.requireProperty(props, "stageName", this), this.stack.addTransform(_CfnApi.REQUIRED_TRANSFORM), this.stageName = props.stageName, this.accessLogSetting = props.accessLogSetting, this.auth = props.auth, this.binaryMediaTypes = props.binaryMediaTypes, this.cacheClusterEnabled = props.cacheClusterEnabled, this.cacheClusterSize = props.cacheClusterSize, this.canarySetting = props.canarySetting, this.cors = props.cors, this.definitionBody = props.definitionBody, this.definitionUri = props.definitionUri, this.description = props.description, this.disableExecuteApiEndpoint = props.disableExecuteApiEndpoint, this.domain = props.domain, this.endpointConfiguration = props.endpointConfiguration, this.gatewayResponses = props.gatewayResponses, this.methodSettings = props.methodSettings, this.minimumCompressionSize = props.minimumCompressionSize, this.models = props.models, this.name = props.name, this.openApiVersion = props.openApiVersion, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Serverless::Api", props.tags, { tagPropertyName: "tags" }), this.tracingEnabled = props.tracingEnabled, this.variables = props.variables;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApi.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { stageName: this.stageName, accessLogSetting: this.accessLogSetting, auth: this.auth, binaryMediaTypes: this.binaryMediaTypes, cacheClusterEnabled: this.cacheClusterEnabled, cacheClusterSize: this.cacheClusterSize, canarySetting: this.canarySetting, cors: this.cors, definitionBody: this.definitionBody, definitionUri: this.definitionUri, description: this.description, disableExecuteApiEndpoint: this.disableExecuteApiEndpoint, domain: this.domain, endpointConfiguration: this.endpointConfiguration, gatewayResponses: this.gatewayResponses, methodSettings: this.methodSettings, minimumCompressionSize: this.minimumCompressionSize, models: this.models, name: this.name, openApiVersion: this.openApiVersion, tags: this.tags.renderTags(), tracingEnabled: this.tracingEnabled, variables: this.variables };
      }
      renderProperties(props) {
        return cfnApiPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnApi[_a] = { fqn: "aws-cdk-lib.aws_sam.CfnApi", version: "2.80.0" }, CfnApi.CFN_RESOURCE_TYPE_NAME = "AWS::Serverless::Api", CfnApi.REQUIRED_TRANSFORM = "AWS::Serverless-2016-10-31", exports2.CfnApi = CfnApi;
    function CfnApi_AccessLogSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationArn", cdk.validateString)(properties.destinationArn)), errors.collect(cdk.propertyValidator("format", cdk.validateString)(properties.format)), errors.wrap('supplied properties not correct for "AccessLogSettingProperty"');
    }
    function cfnApiAccessLogSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApi_AccessLogSettingPropertyValidator(properties).assertSuccess(), { DestinationArn: cdk.stringToCloudFormation(properties.destinationArn), Format: cdk.stringToCloudFormation(properties.format) }) : properties;
    }
    function CfnApiAccessLogSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationArn", "DestinationArn", properties.DestinationArn != null ? cfn_parse.FromCloudFormation.getString(properties.DestinationArn) : void 0), ret.addPropertyResult("format", "Format", properties.Format != null ? cfn_parse.FromCloudFormation.getString(properties.Format) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApi_AuthPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("addDefaultAuthorizerToCorsPreflight", cdk.validateBoolean)(properties.addDefaultAuthorizerToCorsPreflight)), errors.collect(cdk.propertyValidator("authorizers", cdk.validateObject)(properties.authorizers)), errors.collect(cdk.propertyValidator("defaultAuthorizer", cdk.validateString)(properties.defaultAuthorizer)), errors.wrap('supplied properties not correct for "AuthProperty"');
    }
    function cfnApiAuthPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApi_AuthPropertyValidator(properties).assertSuccess(), { AddDefaultAuthorizerToCorsPreflight: cdk.booleanToCloudFormation(properties.addDefaultAuthorizerToCorsPreflight), Authorizers: cdk.objectToCloudFormation(properties.authorizers), DefaultAuthorizer: cdk.stringToCloudFormation(properties.defaultAuthorizer) }) : properties;
    }
    function CfnApiAuthPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("addDefaultAuthorizerToCorsPreflight", "AddDefaultAuthorizerToCorsPreflight", properties.AddDefaultAuthorizerToCorsPreflight != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AddDefaultAuthorizerToCorsPreflight) : void 0), ret.addPropertyResult("authorizers", "Authorizers", properties.Authorizers != null ? cfn_parse.FromCloudFormation.getAny(properties.Authorizers) : void 0), ret.addPropertyResult("defaultAuthorizer", "DefaultAuthorizer", properties.DefaultAuthorizer != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultAuthorizer) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApi_CanarySettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deploymentId", cdk.validateString)(properties.deploymentId)), errors.collect(cdk.propertyValidator("percentTraffic", cdk.validateNumber)(properties.percentTraffic)), errors.collect(cdk.propertyValidator("stageVariableOverrides", cdk.hashValidator(cdk.validateString))(properties.stageVariableOverrides)), errors.collect(cdk.propertyValidator("useStageCache", cdk.validateBoolean)(properties.useStageCache)), errors.wrap('supplied properties not correct for "CanarySettingProperty"');
    }
    function cfnApiCanarySettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApi_CanarySettingPropertyValidator(properties).assertSuccess(), { DeploymentId: cdk.stringToCloudFormation(properties.deploymentId), PercentTraffic: cdk.numberToCloudFormation(properties.percentTraffic), StageVariableOverrides: cdk.hashMapper(cdk.stringToCloudFormation)(properties.stageVariableOverrides), UseStageCache: cdk.booleanToCloudFormation(properties.useStageCache) }) : properties;
    }
    function CfnApiCanarySettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deploymentId", "DeploymentId", properties.DeploymentId != null ? cfn_parse.FromCloudFormation.getString(properties.DeploymentId) : void 0), ret.addPropertyResult("percentTraffic", "PercentTraffic", properties.PercentTraffic != null ? cfn_parse.FromCloudFormation.getNumber(properties.PercentTraffic) : void 0), ret.addPropertyResult("stageVariableOverrides", "StageVariableOverrides", properties.StageVariableOverrides != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.StageVariableOverrides) : void 0), ret.addPropertyResult("useStageCache", "UseStageCache", properties.UseStageCache != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseStageCache) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApi_CorsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowCredentials", cdk.validateBoolean)(properties.allowCredentials)), errors.collect(cdk.propertyValidator("allowHeaders", cdk.validateString)(properties.allowHeaders)), errors.collect(cdk.propertyValidator("allowMethods", cdk.validateString)(properties.allowMethods)), errors.collect(cdk.propertyValidator("allowOrigin", cdk.requiredValidator)(properties.allowOrigin)), errors.collect(cdk.propertyValidator("allowOrigin", cdk.validateString)(properties.allowOrigin)), errors.collect(cdk.propertyValidator("maxAge", cdk.validateString)(properties.maxAge)), errors.wrap('supplied properties not correct for "CorsConfigurationProperty"');
    }
    function cfnApiCorsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApi_CorsConfigurationPropertyValidator(properties).assertSuccess(), { AllowCredentials: cdk.booleanToCloudFormation(properties.allowCredentials), AllowHeaders: cdk.stringToCloudFormation(properties.allowHeaders), AllowMethods: cdk.stringToCloudFormation(properties.allowMethods), AllowOrigin: cdk.stringToCloudFormation(properties.allowOrigin), MaxAge: cdk.stringToCloudFormation(properties.maxAge) }) : properties;
    }
    function CfnApiCorsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowCredentials", "AllowCredentials", properties.AllowCredentials != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllowCredentials) : void 0), ret.addPropertyResult("allowHeaders", "AllowHeaders", properties.AllowHeaders != null ? cfn_parse.FromCloudFormation.getString(properties.AllowHeaders) : void 0), ret.addPropertyResult("allowMethods", "AllowMethods", properties.AllowMethods != null ? cfn_parse.FromCloudFormation.getString(properties.AllowMethods) : void 0), ret.addPropertyResult("allowOrigin", "AllowOrigin", cfn_parse.FromCloudFormation.getString(properties.AllowOrigin)), ret.addPropertyResult("maxAge", "MaxAge", properties.MaxAge != null ? cfn_parse.FromCloudFormation.getString(properties.MaxAge) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApi_DomainConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("basePath", cdk.listValidator(cdk.validateString))(properties.basePath)), errors.collect(cdk.propertyValidator("certificateArn", cdk.requiredValidator)(properties.certificateArn)), errors.collect(cdk.propertyValidator("certificateArn", cdk.validateString)(properties.certificateArn)), errors.collect(cdk.propertyValidator("domainName", cdk.requiredValidator)(properties.domainName)), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.collect(cdk.propertyValidator("endpointConfiguration", cdk.validateString)(properties.endpointConfiguration)), errors.collect(cdk.propertyValidator("mutualTlsAuthentication", CfnApi_MutualTlsAuthenticationPropertyValidator)(properties.mutualTlsAuthentication)), errors.collect(cdk.propertyValidator("ownershipVerificationCertificateArn", cdk.validateString)(properties.ownershipVerificationCertificateArn)), errors.collect(cdk.propertyValidator("route53", CfnApi_Route53ConfigurationPropertyValidator)(properties.route53)), errors.collect(cdk.propertyValidator("securityPolicy", cdk.validateString)(properties.securityPolicy)), errors.wrap('supplied properties not correct for "DomainConfigurationProperty"');
    }
    function cfnApiDomainConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApi_DomainConfigurationPropertyValidator(properties).assertSuccess(), { BasePath: cdk.listMapper(cdk.stringToCloudFormation)(properties.basePath), CertificateArn: cdk.stringToCloudFormation(properties.certificateArn), DomainName: cdk.stringToCloudFormation(properties.domainName), EndpointConfiguration: cdk.stringToCloudFormation(properties.endpointConfiguration), MutualTlsAuthentication: cfnApiMutualTlsAuthenticationPropertyToCloudFormation(properties.mutualTlsAuthentication), OwnershipVerificationCertificateArn: cdk.stringToCloudFormation(properties.ownershipVerificationCertificateArn), Route53: cfnApiRoute53ConfigurationPropertyToCloudFormation(properties.route53), SecurityPolicy: cdk.stringToCloudFormation(properties.securityPolicy) }) : properties;
    }
    function CfnApiDomainConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("basePath", "BasePath", properties.BasePath != null ? cfn_parse.FromCloudFormation.getStringArray(properties.BasePath) : void 0), ret.addPropertyResult("certificateArn", "CertificateArn", cfn_parse.FromCloudFormation.getString(properties.CertificateArn)), ret.addPropertyResult("domainName", "DomainName", cfn_parse.FromCloudFormation.getString(properties.DomainName)), ret.addPropertyResult("endpointConfiguration", "EndpointConfiguration", properties.EndpointConfiguration != null ? cfn_parse.FromCloudFormation.getString(properties.EndpointConfiguration) : void 0), ret.addPropertyResult("mutualTlsAuthentication", "MutualTlsAuthentication", properties.MutualTlsAuthentication != null ? CfnApiMutualTlsAuthenticationPropertyFromCloudFormation(properties.MutualTlsAuthentication) : void 0), ret.addPropertyResult("ownershipVerificationCertificateArn", "OwnershipVerificationCertificateArn", properties.OwnershipVerificationCertificateArn != null ? cfn_parse.FromCloudFormation.getString(properties.OwnershipVerificationCertificateArn) : void 0), ret.addPropertyResult("route53", "Route53", properties.Route53 != null ? CfnApiRoute53ConfigurationPropertyFromCloudFormation(properties.Route53) : void 0), ret.addPropertyResult("securityPolicy", "SecurityPolicy", properties.SecurityPolicy != null ? cfn_parse.FromCloudFormation.getString(properties.SecurityPolicy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApi_EndpointConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("vpcEndpointIds", cdk.listValidator(cdk.validateString))(properties.vpcEndpointIds)), errors.wrap('supplied properties not correct for "EndpointConfigurationProperty"');
    }
    function cfnApiEndpointConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApi_EndpointConfigurationPropertyValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type), VpcEndpointIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.vpcEndpointIds) }) : properties;
    }
    function CfnApiEndpointConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addPropertyResult("vpcEndpointIds", "VpcEndpointIds", properties.VpcEndpointIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.VpcEndpointIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApi_MutualTlsAuthenticationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("truststoreUri", cdk.validateString)(properties.truststoreUri)), errors.collect(cdk.propertyValidator("truststoreVersion", cdk.validateString)(properties.truststoreVersion)), errors.wrap('supplied properties not correct for "MutualTlsAuthenticationProperty"');
    }
    function cfnApiMutualTlsAuthenticationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApi_MutualTlsAuthenticationPropertyValidator(properties).assertSuccess(), { TruststoreUri: cdk.stringToCloudFormation(properties.truststoreUri), TruststoreVersion: cdk.stringToCloudFormation(properties.truststoreVersion) }) : properties;
    }
    function CfnApiMutualTlsAuthenticationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("truststoreUri", "TruststoreUri", properties.TruststoreUri != null ? cfn_parse.FromCloudFormation.getString(properties.TruststoreUri) : void 0), ret.addPropertyResult("truststoreVersion", "TruststoreVersion", properties.TruststoreVersion != null ? cfn_parse.FromCloudFormation.getString(properties.TruststoreVersion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApi_Route53ConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("distributedDomainName", cdk.validateString)(properties.distributedDomainName)), errors.collect(cdk.propertyValidator("evaluateTargetHealth", cdk.validateBoolean)(properties.evaluateTargetHealth)), errors.collect(cdk.propertyValidator("hostedZoneId", cdk.validateString)(properties.hostedZoneId)), errors.collect(cdk.propertyValidator("hostedZoneName", cdk.validateString)(properties.hostedZoneName)), errors.collect(cdk.propertyValidator("ipV6", cdk.validateBoolean)(properties.ipV6)), errors.wrap('supplied properties not correct for "Route53ConfigurationProperty"');
    }
    function cfnApiRoute53ConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApi_Route53ConfigurationPropertyValidator(properties).assertSuccess(), { DistributedDomainName: cdk.stringToCloudFormation(properties.distributedDomainName), EvaluateTargetHealth: cdk.booleanToCloudFormation(properties.evaluateTargetHealth), HostedZoneId: cdk.stringToCloudFormation(properties.hostedZoneId), HostedZoneName: cdk.stringToCloudFormation(properties.hostedZoneName), IpV6: cdk.booleanToCloudFormation(properties.ipV6) }) : properties;
    }
    function CfnApiRoute53ConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("distributedDomainName", "DistributedDomainName", properties.DistributedDomainName != null ? cfn_parse.FromCloudFormation.getString(properties.DistributedDomainName) : void 0), ret.addPropertyResult("evaluateTargetHealth", "EvaluateTargetHealth", properties.EvaluateTargetHealth != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EvaluateTargetHealth) : void 0), ret.addPropertyResult("hostedZoneId", "HostedZoneId", properties.HostedZoneId != null ? cfn_parse.FromCloudFormation.getString(properties.HostedZoneId) : void 0), ret.addPropertyResult("hostedZoneName", "HostedZoneName", properties.HostedZoneName != null ? cfn_parse.FromCloudFormation.getString(properties.HostedZoneName) : void 0), ret.addPropertyResult("ipV6", "IpV6", properties.IpV6 != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IpV6) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApi_S3LocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.requiredValidator)(properties.bucket)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("version", cdk.requiredValidator)(properties.version)), errors.collect(cdk.propertyValidator("version", cdk.validateNumber)(properties.version)), errors.wrap('supplied properties not correct for "S3LocationProperty"');
    }
    function cfnApiS3LocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApi_S3LocationPropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), Key: cdk.stringToCloudFormation(properties.key), Version: cdk.numberToCloudFormation(properties.version) }) : properties;
    }
    function CfnApiS3LocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", cfn_parse.FromCloudFormation.getString(properties.Bucket)), ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("version", "Version", cfn_parse.FromCloudFormation.getNumber(properties.Version)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("location", cdk.requiredValidator)(properties.location)), errors.collect(cdk.propertyValidator("location", cdk.unionValidator(CfnApplication_ApplicationLocationPropertyValidator, cdk.validateString))(properties.location)), errors.collect(cdk.propertyValidator("notificationArns", cdk.listValidator(cdk.validateString))(properties.notificationArns)), errors.collect(cdk.propertyValidator("parameters", cdk.hashValidator(cdk.validateString))(properties.parameters)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.collect(cdk.propertyValidator("timeoutInMinutes", cdk.validateNumber)(properties.timeoutInMinutes)), errors.wrap('supplied properties not correct for "CfnApplicationProps"');
    }
    function cfnApplicationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationPropsValidator(properties).assertSuccess(), { Location: cdk.unionMapper([CfnApplication_ApplicationLocationPropertyValidator, cdk.validateString], [cfnApplicationApplicationLocationPropertyToCloudFormation, cdk.stringToCloudFormation])(properties.location), NotificationArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.notificationArns), Parameters: cdk.hashMapper(cdk.stringToCloudFormation)(properties.parameters), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags), TimeoutInMinutes: cdk.numberToCloudFormation(properties.timeoutInMinutes) }) : properties;
    }
    function CfnApplicationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("location", "Location", cfn_parse.FromCloudFormation.getTypeUnion([CfnApplication_ApplicationLocationPropertyValidator, cdk.validateString], [CfnApplicationApplicationLocationPropertyFromCloudFormation, cfn_parse.FromCloudFormation.getString])(properties.Location)), ret.addPropertyResult("notificationArns", "NotificationArns", properties.NotificationArns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.NotificationArns) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Parameters) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addPropertyResult("timeoutInMinutes", "TimeoutInMinutes", properties.TimeoutInMinutes != null ? cfn_parse.FromCloudFormation.getNumber(properties.TimeoutInMinutes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApplication = class _CfnApplication extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApplicationPropsFromCloudFormation(resourceProperties), ret = new _CfnApplication(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApplication.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sam_CfnApplicationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApplication), error;
        }
        cdk.requireProperty(props, "location", this), this.stack.addTransform(_CfnApplication.REQUIRED_TRANSFORM), this.location = props.location, this.notificationArns = props.notificationArns, this.parameters = props.parameters, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Serverless::Application", props.tags, { tagPropertyName: "tags" }), this.timeoutInMinutes = props.timeoutInMinutes;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApplication.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { location: this.location, notificationArns: this.notificationArns, parameters: this.parameters, tags: this.tags.renderTags(), timeoutInMinutes: this.timeoutInMinutes };
      }
      renderProperties(props) {
        return cfnApplicationPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnApplication[_b] = { fqn: "aws-cdk-lib.aws_sam.CfnApplication", version: "2.80.0" }, CfnApplication.CFN_RESOURCE_TYPE_NAME = "AWS::Serverless::Application", CfnApplication.REQUIRED_TRANSFORM = "AWS::Serverless-2016-10-31", exports2.CfnApplication = CfnApplication;
    function CfnApplication_ApplicationLocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationId", cdk.requiredValidator)(properties.applicationId)), errors.collect(cdk.propertyValidator("applicationId", cdk.validateString)(properties.applicationId)), errors.collect(cdk.propertyValidator("semanticVersion", cdk.requiredValidator)(properties.semanticVersion)), errors.collect(cdk.propertyValidator("semanticVersion", cdk.validateString)(properties.semanticVersion)), errors.wrap('supplied properties not correct for "ApplicationLocationProperty"');
    }
    function cfnApplicationApplicationLocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_ApplicationLocationPropertyValidator(properties).assertSuccess(), { ApplicationId: cdk.stringToCloudFormation(properties.applicationId), SemanticVersion: cdk.stringToCloudFormation(properties.semanticVersion) }) : properties;
    }
    function CfnApplicationApplicationLocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationId", "ApplicationId", cfn_parse.FromCloudFormation.getString(properties.ApplicationId)), ret.addPropertyResult("semanticVersion", "SemanticVersion", cfn_parse.FromCloudFormation.getString(properties.SemanticVersion)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunctionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("architectures", cdk.listValidator(cdk.validateString))(properties.architectures)), errors.collect(cdk.propertyValidator("assumeRolePolicyDocument", cdk.validateObject)(properties.assumeRolePolicyDocument)), errors.collect(cdk.propertyValidator("autoPublishAlias", cdk.validateString)(properties.autoPublishAlias)), errors.collect(cdk.propertyValidator("autoPublishCodeSha256", cdk.validateString)(properties.autoPublishCodeSha256)), errors.collect(cdk.propertyValidator("codeSigningConfigArn", cdk.validateString)(properties.codeSigningConfigArn)), errors.collect(cdk.propertyValidator("codeUri", cdk.unionValidator(CfnFunction_S3LocationPropertyValidator, cdk.validateString))(properties.codeUri)), errors.collect(cdk.propertyValidator("deadLetterQueue", CfnFunction_DeadLetterQueuePropertyValidator)(properties.deadLetterQueue)), errors.collect(cdk.propertyValidator("deploymentPreference", CfnFunction_DeploymentPreferencePropertyValidator)(properties.deploymentPreference)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("environment", CfnFunction_FunctionEnvironmentPropertyValidator)(properties.environment)), errors.collect(cdk.propertyValidator("eventInvokeConfig", CfnFunction_EventInvokeConfigPropertyValidator)(properties.eventInvokeConfig)), errors.collect(cdk.propertyValidator("events", cdk.hashValidator(CfnFunction_EventSourcePropertyValidator))(properties.events)), errors.collect(cdk.propertyValidator("fileSystemConfigs", cdk.listValidator(CfnFunction_FileSystemConfigPropertyValidator))(properties.fileSystemConfigs)), errors.collect(cdk.propertyValidator("functionName", cdk.validateString)(properties.functionName)), errors.collect(cdk.propertyValidator("handler", cdk.validateString)(properties.handler)), errors.collect(cdk.propertyValidator("imageConfig", CfnFunction_ImageConfigPropertyValidator)(properties.imageConfig)), errors.collect(cdk.propertyValidator("imageUri", cdk.validateString)(properties.imageUri)), errors.collect(cdk.propertyValidator("inlineCode", cdk.validateString)(properties.inlineCode)), errors.collect(cdk.propertyValidator("kmsKeyArn", cdk.validateString)(properties.kmsKeyArn)), errors.collect(cdk.propertyValidator("layers", cdk.listValidator(cdk.validateString))(properties.layers)), errors.collect(cdk.propertyValidator("memorySize", cdk.validateNumber)(properties.memorySize)), errors.collect(cdk.propertyValidator("packageType", cdk.validateString)(properties.packageType)), errors.collect(cdk.propertyValidator("permissionsBoundary", cdk.validateString)(properties.permissionsBoundary)), errors.collect(cdk.propertyValidator("policies", cdk.unionValidator(cdk.unionValidator(CfnFunction_IAMPolicyDocumentPropertyValidator, cdk.validateString), cdk.listValidator(cdk.unionValidator(CfnFunction_IAMPolicyDocumentPropertyValidator, CfnFunction_SAMPolicyTemplatePropertyValidator, cdk.validateString))))(properties.policies)), errors.collect(cdk.propertyValidator("provisionedConcurrencyConfig", CfnFunction_ProvisionedConcurrencyConfigPropertyValidator)(properties.provisionedConcurrencyConfig)), errors.collect(cdk.propertyValidator("reservedConcurrentExecutions", cdk.validateNumber)(properties.reservedConcurrentExecutions)), errors.collect(cdk.propertyValidator("role", cdk.validateString)(properties.role)), errors.collect(cdk.propertyValidator("runtime", cdk.validateString)(properties.runtime)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.collect(cdk.propertyValidator("timeout", cdk.validateNumber)(properties.timeout)), errors.collect(cdk.propertyValidator("tracing", cdk.validateString)(properties.tracing)), errors.collect(cdk.propertyValidator("versionDescription", cdk.validateString)(properties.versionDescription)), errors.collect(cdk.propertyValidator("vpcConfig", CfnFunction_VpcConfigPropertyValidator)(properties.vpcConfig)), errors.wrap('supplied properties not correct for "CfnFunctionProps"');
    }
    function cfnFunctionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunctionPropsValidator(properties).assertSuccess(), { Architectures: cdk.listMapper(cdk.stringToCloudFormation)(properties.architectures), AssumeRolePolicyDocument: cdk.objectToCloudFormation(properties.assumeRolePolicyDocument), AutoPublishAlias: cdk.stringToCloudFormation(properties.autoPublishAlias), AutoPublishCodeSha256: cdk.stringToCloudFormation(properties.autoPublishCodeSha256), CodeSigningConfigArn: cdk.stringToCloudFormation(properties.codeSigningConfigArn), CodeUri: cdk.unionMapper([CfnFunction_S3LocationPropertyValidator, cdk.validateString], [cfnFunctionS3LocationPropertyToCloudFormation, cdk.stringToCloudFormation])(properties.codeUri), DeadLetterQueue: cfnFunctionDeadLetterQueuePropertyToCloudFormation(properties.deadLetterQueue), DeploymentPreference: cfnFunctionDeploymentPreferencePropertyToCloudFormation(properties.deploymentPreference), Description: cdk.stringToCloudFormation(properties.description), Environment: cfnFunctionFunctionEnvironmentPropertyToCloudFormation(properties.environment), EventInvokeConfig: cfnFunctionEventInvokeConfigPropertyToCloudFormation(properties.eventInvokeConfig), Events: cdk.hashMapper(cfnFunctionEventSourcePropertyToCloudFormation)(properties.events), FileSystemConfigs: cdk.listMapper(cfnFunctionFileSystemConfigPropertyToCloudFormation)(properties.fileSystemConfigs), FunctionName: cdk.stringToCloudFormation(properties.functionName), Handler: cdk.stringToCloudFormation(properties.handler), ImageConfig: cfnFunctionImageConfigPropertyToCloudFormation(properties.imageConfig), ImageUri: cdk.stringToCloudFormation(properties.imageUri), InlineCode: cdk.stringToCloudFormation(properties.inlineCode), KmsKeyArn: cdk.stringToCloudFormation(properties.kmsKeyArn), Layers: cdk.listMapper(cdk.stringToCloudFormation)(properties.layers), MemorySize: cdk.numberToCloudFormation(properties.memorySize), PackageType: cdk.stringToCloudFormation(properties.packageType), PermissionsBoundary: cdk.stringToCloudFormation(properties.permissionsBoundary), Policies: cdk.unionMapper([cdk.unionValidator(CfnFunction_IAMPolicyDocumentPropertyValidator, cdk.validateString), cdk.listValidator(cdk.unionValidator(CfnFunction_IAMPolicyDocumentPropertyValidator, CfnFunction_SAMPolicyTemplatePropertyValidator, cdk.validateString))], [cdk.unionMapper([CfnFunction_IAMPolicyDocumentPropertyValidator, cdk.validateString], [cfnFunctionIAMPolicyDocumentPropertyToCloudFormation, cdk.stringToCloudFormation]), cdk.listMapper(cdk.unionMapper([CfnFunction_IAMPolicyDocumentPropertyValidator, CfnFunction_SAMPolicyTemplatePropertyValidator, cdk.validateString], [cfnFunctionIAMPolicyDocumentPropertyToCloudFormation, cfnFunctionSAMPolicyTemplatePropertyToCloudFormation, cdk.stringToCloudFormation]))])(properties.policies), ProvisionedConcurrencyConfig: cfnFunctionProvisionedConcurrencyConfigPropertyToCloudFormation(properties.provisionedConcurrencyConfig), ReservedConcurrentExecutions: cdk.numberToCloudFormation(properties.reservedConcurrentExecutions), Role: cdk.stringToCloudFormation(properties.role), Runtime: cdk.stringToCloudFormation(properties.runtime), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags), Timeout: cdk.numberToCloudFormation(properties.timeout), Tracing: cdk.stringToCloudFormation(properties.tracing), VersionDescription: cdk.stringToCloudFormation(properties.versionDescription), VpcConfig: cfnFunctionVpcConfigPropertyToCloudFormation(properties.vpcConfig) }) : properties;
    }
    function CfnFunctionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("architectures", "Architectures", properties.Architectures != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Architectures) : void 0), ret.addPropertyResult("assumeRolePolicyDocument", "AssumeRolePolicyDocument", properties.AssumeRolePolicyDocument != null ? cfn_parse.FromCloudFormation.getAny(properties.AssumeRolePolicyDocument) : void 0), ret.addPropertyResult("autoPublishAlias", "AutoPublishAlias", properties.AutoPublishAlias != null ? cfn_parse.FromCloudFormation.getString(properties.AutoPublishAlias) : void 0), ret.addPropertyResult("autoPublishCodeSha256", "AutoPublishCodeSha256", properties.AutoPublishCodeSha256 != null ? cfn_parse.FromCloudFormation.getString(properties.AutoPublishCodeSha256) : void 0), ret.addPropertyResult("codeSigningConfigArn", "CodeSigningConfigArn", properties.CodeSigningConfigArn != null ? cfn_parse.FromCloudFormation.getString(properties.CodeSigningConfigArn) : void 0), ret.addPropertyResult("codeUri", "CodeUri", properties.CodeUri != null ? cfn_parse.FromCloudFormation.getTypeUnion([CfnFunction_S3LocationPropertyValidator, cdk.validateString], [CfnFunctionS3LocationPropertyFromCloudFormation, cfn_parse.FromCloudFormation.getString])(properties.CodeUri) : void 0), ret.addPropertyResult("deadLetterQueue", "DeadLetterQueue", properties.DeadLetterQueue != null ? CfnFunctionDeadLetterQueuePropertyFromCloudFormation(properties.DeadLetterQueue) : void 0), ret.addPropertyResult("deploymentPreference", "DeploymentPreference", properties.DeploymentPreference != null ? CfnFunctionDeploymentPreferencePropertyFromCloudFormation(properties.DeploymentPreference) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("environment", "Environment", properties.Environment != null ? CfnFunctionFunctionEnvironmentPropertyFromCloudFormation(properties.Environment) : void 0), ret.addPropertyResult("eventInvokeConfig", "EventInvokeConfig", properties.EventInvokeConfig != null ? CfnFunctionEventInvokeConfigPropertyFromCloudFormation(properties.EventInvokeConfig) : void 0), ret.addPropertyResult("events", "Events", properties.Events != null ? cfn_parse.FromCloudFormation.getMap(CfnFunctionEventSourcePropertyFromCloudFormation)(properties.Events) : void 0), ret.addPropertyResult("fileSystemConfigs", "FileSystemConfigs", properties.FileSystemConfigs != null ? cfn_parse.FromCloudFormation.getArray(CfnFunctionFileSystemConfigPropertyFromCloudFormation)(properties.FileSystemConfigs) : void 0), ret.addPropertyResult("functionName", "FunctionName", properties.FunctionName != null ? cfn_parse.FromCloudFormation.getString(properties.FunctionName) : void 0), ret.addPropertyResult("handler", "Handler", properties.Handler != null ? cfn_parse.FromCloudFormation.getString(properties.Handler) : void 0), ret.addPropertyResult("imageConfig", "ImageConfig", properties.ImageConfig != null ? CfnFunctionImageConfigPropertyFromCloudFormation(properties.ImageConfig) : void 0), ret.addPropertyResult("imageUri", "ImageUri", properties.ImageUri != null ? cfn_parse.FromCloudFormation.getString(properties.ImageUri) : void 0), ret.addPropertyResult("inlineCode", "InlineCode", properties.InlineCode != null ? cfn_parse.FromCloudFormation.getString(properties.InlineCode) : void 0), ret.addPropertyResult("kmsKeyArn", "KmsKeyArn", properties.KmsKeyArn != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyArn) : void 0), ret.addPropertyResult("layers", "Layers", properties.Layers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Layers) : void 0), ret.addPropertyResult("memorySize", "MemorySize", properties.MemorySize != null ? cfn_parse.FromCloudFormation.getNumber(properties.MemorySize) : void 0), ret.addPropertyResult("packageType", "PackageType", properties.PackageType != null ? cfn_parse.FromCloudFormation.getString(properties.PackageType) : void 0), ret.addPropertyResult("permissionsBoundary", "PermissionsBoundary", properties.PermissionsBoundary != null ? cfn_parse.FromCloudFormation.getString(properties.PermissionsBoundary) : void 0), ret.addPropertyResult("policies", "Policies", properties.Policies != null ? cfn_parse.FromCloudFormation.getTypeUnion([cdk.unionValidator(CfnFunction_IAMPolicyDocumentPropertyValidator, cdk.validateString), cdk.listValidator(cdk.unionValidator(CfnFunction_IAMPolicyDocumentPropertyValidator, CfnFunction_SAMPolicyTemplatePropertyValidator, cdk.validateString))], [cfn_parse.FromCloudFormation.getTypeUnion([CfnFunction_IAMPolicyDocumentPropertyValidator, cdk.validateString], [CfnFunctionIAMPolicyDocumentPropertyFromCloudFormation, cfn_parse.FromCloudFormation.getString]), cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getTypeUnion([CfnFunction_IAMPolicyDocumentPropertyValidator, CfnFunction_SAMPolicyTemplatePropertyValidator, cdk.validateString], [CfnFunctionIAMPolicyDocumentPropertyFromCloudFormation, CfnFunctionSAMPolicyTemplatePropertyFromCloudFormation, cfn_parse.FromCloudFormation.getString]))])(properties.Policies) : void 0), ret.addPropertyResult("provisionedConcurrencyConfig", "ProvisionedConcurrencyConfig", properties.ProvisionedConcurrencyConfig != null ? CfnFunctionProvisionedConcurrencyConfigPropertyFromCloudFormation(properties.ProvisionedConcurrencyConfig) : void 0), ret.addPropertyResult("reservedConcurrentExecutions", "ReservedConcurrentExecutions", properties.ReservedConcurrentExecutions != null ? cfn_parse.FromCloudFormation.getNumber(properties.ReservedConcurrentExecutions) : void 0), ret.addPropertyResult("role", "Role", properties.Role != null ? cfn_parse.FromCloudFormation.getString(properties.Role) : void 0), ret.addPropertyResult("runtime", "Runtime", properties.Runtime != null ? cfn_parse.FromCloudFormation.getString(properties.Runtime) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addPropertyResult("timeout", "Timeout", properties.Timeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.Timeout) : void 0), ret.addPropertyResult("tracing", "Tracing", properties.Tracing != null ? cfn_parse.FromCloudFormation.getString(properties.Tracing) : void 0), ret.addPropertyResult("versionDescription", "VersionDescription", properties.VersionDescription != null ? cfn_parse.FromCloudFormation.getString(properties.VersionDescription) : void 0), ret.addPropertyResult("vpcConfig", "VpcConfig", properties.VpcConfig != null ? CfnFunctionVpcConfigPropertyFromCloudFormation(properties.VpcConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFunction = class _CfnFunction extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFunctionPropsFromCloudFormation(resourceProperties), ret = new _CfnFunction(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnFunction.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sam_CfnFunctionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFunction), error;
        }
        this.stack.addTransform(_CfnFunction.REQUIRED_TRANSFORM), this.architectures = props.architectures, this.assumeRolePolicyDocument = props.assumeRolePolicyDocument, this.autoPublishAlias = props.autoPublishAlias, this.autoPublishCodeSha256 = props.autoPublishCodeSha256, this.codeSigningConfigArn = props.codeSigningConfigArn, this.codeUri = props.codeUri, this.deadLetterQueue = props.deadLetterQueue, this.deploymentPreference = props.deploymentPreference, this.description = props.description, this.environment = props.environment, this.eventInvokeConfig = props.eventInvokeConfig, this.events = props.events, this.fileSystemConfigs = props.fileSystemConfigs, this.functionName = props.functionName, this.handler = props.handler, this.imageConfig = props.imageConfig, this.imageUri = props.imageUri, this.inlineCode = props.inlineCode, this.kmsKeyArn = props.kmsKeyArn, this.layers = props.layers, this.memorySize = props.memorySize, this.packageType = props.packageType, this.permissionsBoundary = props.permissionsBoundary, this.policies = props.policies, this.provisionedConcurrencyConfig = props.provisionedConcurrencyConfig, this.reservedConcurrentExecutions = props.reservedConcurrentExecutions, this.role = props.role, this.runtime = props.runtime, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Serverless::Function", props.tags, { tagPropertyName: "tags" }), this.timeout = props.timeout, this.tracing = props.tracing, this.versionDescription = props.versionDescription, this.vpcConfig = props.vpcConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFunction.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { architectures: this.architectures, assumeRolePolicyDocument: this.assumeRolePolicyDocument, autoPublishAlias: this.autoPublishAlias, autoPublishCodeSha256: this.autoPublishCodeSha256, codeSigningConfigArn: this.codeSigningConfigArn, codeUri: this.codeUri, deadLetterQueue: this.deadLetterQueue, deploymentPreference: this.deploymentPreference, description: this.description, environment: this.environment, eventInvokeConfig: this.eventInvokeConfig, events: this.events, fileSystemConfigs: this.fileSystemConfigs, functionName: this.functionName, handler: this.handler, imageConfig: this.imageConfig, imageUri: this.imageUri, inlineCode: this.inlineCode, kmsKeyArn: this.kmsKeyArn, layers: this.layers, memorySize: this.memorySize, packageType: this.packageType, permissionsBoundary: this.permissionsBoundary, policies: this.policies, provisionedConcurrencyConfig: this.provisionedConcurrencyConfig, reservedConcurrentExecutions: this.reservedConcurrentExecutions, role: this.role, runtime: this.runtime, tags: this.tags.renderTags(), timeout: this.timeout, tracing: this.tracing, versionDescription: this.versionDescription, vpcConfig: this.vpcConfig };
      }
      renderProperties(props) {
        return cfnFunctionPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnFunction[_c] = { fqn: "aws-cdk-lib.aws_sam.CfnFunction", version: "2.80.0" }, CfnFunction.CFN_RESOURCE_TYPE_NAME = "AWS::Serverless::Function", CfnFunction.REQUIRED_TRANSFORM = "AWS::Serverless-2016-10-31", exports2.CfnFunction = CfnFunction;
    function CfnFunction_AlexaSkillEventPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("variables", cdk.hashValidator(cdk.validateString))(properties.variables)), errors.wrap('supplied properties not correct for "AlexaSkillEventProperty"');
    }
    function cfnFunctionAlexaSkillEventPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_AlexaSkillEventPropertyValidator(properties).assertSuccess(), { Variables: cdk.hashMapper(cdk.stringToCloudFormation)(properties.variables) }) : properties;
    }
    function CfnFunctionAlexaSkillEventPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("variables", "Variables", properties.Variables != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Variables) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_ApiEventPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("auth", CfnFunction_AuthPropertyValidator)(properties.auth)), errors.collect(cdk.propertyValidator("method", cdk.requiredValidator)(properties.method)), errors.collect(cdk.propertyValidator("method", cdk.validateString)(properties.method)), errors.collect(cdk.propertyValidator("path", cdk.requiredValidator)(properties.path)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.collect(cdk.propertyValidator("requestModel", CfnFunction_RequestModelPropertyValidator)(properties.requestModel)), errors.collect(cdk.propertyValidator("requestParameters", cdk.listValidator(cdk.unionValidator(CfnFunction_RequestParameterPropertyValidator, cdk.validateString)))(properties.requestParameters)), errors.collect(cdk.propertyValidator("restApiId", cdk.validateString)(properties.restApiId)), errors.wrap('supplied properties not correct for "ApiEventProperty"');
    }
    function cfnFunctionApiEventPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_ApiEventPropertyValidator(properties).assertSuccess(), { Auth: cfnFunctionAuthPropertyToCloudFormation(properties.auth), Method: cdk.stringToCloudFormation(properties.method), Path: cdk.stringToCloudFormation(properties.path), RequestModel: cfnFunctionRequestModelPropertyToCloudFormation(properties.requestModel), RequestParameters: cdk.listMapper(cdk.unionMapper([CfnFunction_RequestParameterPropertyValidator, cdk.validateString], [cfnFunctionRequestParameterPropertyToCloudFormation, cdk.stringToCloudFormation]))(properties.requestParameters), RestApiId: cdk.stringToCloudFormation(properties.restApiId) }) : properties;
    }
    function CfnFunctionApiEventPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("auth", "Auth", properties.Auth != null ? CfnFunctionAuthPropertyFromCloudFormation(properties.Auth) : void 0), ret.addPropertyResult("method", "Method", cfn_parse.FromCloudFormation.getString(properties.Method)), ret.addPropertyResult("path", "Path", cfn_parse.FromCloudFormation.getString(properties.Path)), ret.addPropertyResult("requestModel", "RequestModel", properties.RequestModel != null ? CfnFunctionRequestModelPropertyFromCloudFormation(properties.RequestModel) : void 0), ret.addPropertyResult("requestParameters", "RequestParameters", properties.RequestParameters != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getTypeUnion([CfnFunction_RequestParameterPropertyValidator, cdk.validateString], [CfnFunctionRequestParameterPropertyFromCloudFormation, cfn_parse.FromCloudFormation.getString]))(properties.RequestParameters) : void 0), ret.addPropertyResult("restApiId", "RestApiId", properties.RestApiId != null ? cfn_parse.FromCloudFormation.getString(properties.RestApiId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_AuthPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiKeyRequired", cdk.validateBoolean)(properties.apiKeyRequired)), errors.collect(cdk.propertyValidator("authorizationScopes", cdk.listValidator(cdk.validateString))(properties.authorizationScopes)), errors.collect(cdk.propertyValidator("authorizer", cdk.validateString)(properties.authorizer)), errors.collect(cdk.propertyValidator("resourcePolicy", CfnFunction_AuthResourcePolicyPropertyValidator)(properties.resourcePolicy)), errors.wrap('supplied properties not correct for "AuthProperty"');
    }
    function cfnFunctionAuthPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_AuthPropertyValidator(properties).assertSuccess(), { ApiKeyRequired: cdk.booleanToCloudFormation(properties.apiKeyRequired), AuthorizationScopes: cdk.listMapper(cdk.stringToCloudFormation)(properties.authorizationScopes), Authorizer: cdk.stringToCloudFormation(properties.authorizer), ResourcePolicy: cfnFunctionAuthResourcePolicyPropertyToCloudFormation(properties.resourcePolicy) }) : properties;
    }
    function CfnFunctionAuthPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiKeyRequired", "ApiKeyRequired", properties.ApiKeyRequired != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ApiKeyRequired) : void 0), ret.addPropertyResult("authorizationScopes", "AuthorizationScopes", properties.AuthorizationScopes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AuthorizationScopes) : void 0), ret.addPropertyResult("authorizer", "Authorizer", properties.Authorizer != null ? cfn_parse.FromCloudFormation.getString(properties.Authorizer) : void 0), ret.addPropertyResult("resourcePolicy", "ResourcePolicy", properties.ResourcePolicy != null ? CfnFunctionAuthResourcePolicyPropertyFromCloudFormation(properties.ResourcePolicy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_AuthResourcePolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("awsAccountBlacklist", cdk.listValidator(cdk.validateString))(properties.awsAccountBlacklist)), errors.collect(cdk.propertyValidator("awsAccountWhitelist", cdk.listValidator(cdk.validateString))(properties.awsAccountWhitelist)), errors.collect(cdk.propertyValidator("customStatements", cdk.listValidator(cdk.validateObject))(properties.customStatements)), errors.collect(cdk.propertyValidator("intrinsicVpcBlacklist", cdk.listValidator(cdk.validateString))(properties.intrinsicVpcBlacklist)), errors.collect(cdk.propertyValidator("intrinsicVpcWhitelist", cdk.listValidator(cdk.validateString))(properties.intrinsicVpcWhitelist)), errors.collect(cdk.propertyValidator("intrinsicVpceBlacklist", cdk.listValidator(cdk.validateString))(properties.intrinsicVpceBlacklist)), errors.collect(cdk.propertyValidator("intrinsicVpceWhitelist", cdk.listValidator(cdk.validateString))(properties.intrinsicVpceWhitelist)), errors.collect(cdk.propertyValidator("ipRangeBlacklist", cdk.listValidator(cdk.validateString))(properties.ipRangeBlacklist)), errors.collect(cdk.propertyValidator("ipRangeWhitelist", cdk.listValidator(cdk.validateString))(properties.ipRangeWhitelist)), errors.collect(cdk.propertyValidator("sourceVpcBlacklist", cdk.listValidator(cdk.validateString))(properties.sourceVpcBlacklist)), errors.collect(cdk.propertyValidator("sourceVpcWhitelist", cdk.listValidator(cdk.validateString))(properties.sourceVpcWhitelist)), errors.wrap('supplied properties not correct for "AuthResourcePolicyProperty"');
    }
    function cfnFunctionAuthResourcePolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_AuthResourcePolicyPropertyValidator(properties).assertSuccess(), { AwsAccountBlacklist: cdk.listMapper(cdk.stringToCloudFormation)(properties.awsAccountBlacklist), AwsAccountWhitelist: cdk.listMapper(cdk.stringToCloudFormation)(properties.awsAccountWhitelist), CustomStatements: cdk.listMapper(cdk.objectToCloudFormation)(properties.customStatements), IntrinsicVpcBlacklist: cdk.listMapper(cdk.stringToCloudFormation)(properties.intrinsicVpcBlacklist), IntrinsicVpcWhitelist: cdk.listMapper(cdk.stringToCloudFormation)(properties.intrinsicVpcWhitelist), IntrinsicVpceBlacklist: cdk.listMapper(cdk.stringToCloudFormation)(properties.intrinsicVpceBlacklist), IntrinsicVpceWhitelist: cdk.listMapper(cdk.stringToCloudFormation)(properties.intrinsicVpceWhitelist), IpRangeBlacklist: cdk.listMapper(cdk.stringToCloudFormation)(properties.ipRangeBlacklist), IpRangeWhitelist: cdk.listMapper(cdk.stringToCloudFormation)(properties.ipRangeWhitelist), SourceVpcBlacklist: cdk.listMapper(cdk.stringToCloudFormation)(properties.sourceVpcBlacklist), SourceVpcWhitelist: cdk.listMapper(cdk.stringToCloudFormation)(properties.sourceVpcWhitelist) }) : properties;
    }
    function CfnFunctionAuthResourcePolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("awsAccountBlacklist", "AwsAccountBlacklist", properties.AwsAccountBlacklist != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AwsAccountBlacklist) : void 0), ret.addPropertyResult("awsAccountWhitelist", "AwsAccountWhitelist", properties.AwsAccountWhitelist != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AwsAccountWhitelist) : void 0), ret.addPropertyResult("customStatements", "CustomStatements", properties.CustomStatements != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getAny)(properties.CustomStatements) : void 0), ret.addPropertyResult("intrinsicVpcBlacklist", "IntrinsicVpcBlacklist", properties.IntrinsicVpcBlacklist != null ? cfn_parse.FromCloudFormation.getStringArray(properties.IntrinsicVpcBlacklist) : void 0), ret.addPropertyResult("intrinsicVpcWhitelist", "IntrinsicVpcWhitelist", properties.IntrinsicVpcWhitelist != null ? cfn_parse.FromCloudFormation.getStringArray(properties.IntrinsicVpcWhitelist) : void 0), ret.addPropertyResult("intrinsicVpceBlacklist", "IntrinsicVpceBlacklist", properties.IntrinsicVpceBlacklist != null ? cfn_parse.FromCloudFormation.getStringArray(properties.IntrinsicVpceBlacklist) : void 0), ret.addPropertyResult("intrinsicVpceWhitelist", "IntrinsicVpceWhitelist", properties.IntrinsicVpceWhitelist != null ? cfn_parse.FromCloudFormation.getStringArray(properties.IntrinsicVpceWhitelist) : void 0), ret.addPropertyResult("ipRangeBlacklist", "IpRangeBlacklist", properties.IpRangeBlacklist != null ? cfn_parse.FromCloudFormation.getStringArray(properties.IpRangeBlacklist) : void 0), ret.addPropertyResult("ipRangeWhitelist", "IpRangeWhitelist", properties.IpRangeWhitelist != null ? cfn_parse.FromCloudFormation.getStringArray(properties.IpRangeWhitelist) : void 0), ret.addPropertyResult("sourceVpcBlacklist", "SourceVpcBlacklist", properties.SourceVpcBlacklist != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SourceVpcBlacklist) : void 0), ret.addPropertyResult("sourceVpcWhitelist", "SourceVpcWhitelist", properties.SourceVpcWhitelist != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SourceVpcWhitelist) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_BucketSAMPTPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketName", cdk.requiredValidator)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.wrap('supplied properties not correct for "BucketSAMPTProperty"');
    }
    function cfnFunctionBucketSAMPTPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_BucketSAMPTPropertyValidator(properties).assertSuccess(), { BucketName: cdk.stringToCloudFormation(properties.bucketName) }) : properties;
    }
    function CfnFunctionBucketSAMPTPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketName", "BucketName", cfn_parse.FromCloudFormation.getString(properties.BucketName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_CloudWatchEventEventPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("input", cdk.validateString)(properties.input)), errors.collect(cdk.propertyValidator("inputPath", cdk.validateString)(properties.inputPath)), errors.collect(cdk.propertyValidator("pattern", cdk.requiredValidator)(properties.pattern)), errors.collect(cdk.propertyValidator("pattern", cdk.validateObject)(properties.pattern)), errors.wrap('supplied properties not correct for "CloudWatchEventEventProperty"');
    }
    function cfnFunctionCloudWatchEventEventPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_CloudWatchEventEventPropertyValidator(properties).assertSuccess(), { Input: cdk.stringToCloudFormation(properties.input), InputPath: cdk.stringToCloudFormation(properties.inputPath), Pattern: cdk.objectToCloudFormation(properties.pattern) }) : properties;
    }
    function CfnFunctionCloudWatchEventEventPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("input", "Input", properties.Input != null ? cfn_parse.FromCloudFormation.getString(properties.Input) : void 0), ret.addPropertyResult("inputPath", "InputPath", properties.InputPath != null ? cfn_parse.FromCloudFormation.getString(properties.InputPath) : void 0), ret.addPropertyResult("pattern", "Pattern", cfn_parse.FromCloudFormation.getAny(properties.Pattern)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_CloudWatchLogsEventPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("filterPattern", cdk.requiredValidator)(properties.filterPattern)), errors.collect(cdk.propertyValidator("filterPattern", cdk.validateString)(properties.filterPattern)), errors.collect(cdk.propertyValidator("logGroupName", cdk.requiredValidator)(properties.logGroupName)), errors.collect(cdk.propertyValidator("logGroupName", cdk.validateString)(properties.logGroupName)), errors.wrap('supplied properties not correct for "CloudWatchLogsEventProperty"');
    }
    function cfnFunctionCloudWatchLogsEventPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_CloudWatchLogsEventPropertyValidator(properties).assertSuccess(), { FilterPattern: cdk.stringToCloudFormation(properties.filterPattern), LogGroupName: cdk.stringToCloudFormation(properties.logGroupName) }) : properties;
    }
    function CfnFunctionCloudWatchLogsEventPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("filterPattern", "FilterPattern", cfn_parse.FromCloudFormation.getString(properties.FilterPattern)), ret.addPropertyResult("logGroupName", "LogGroupName", cfn_parse.FromCloudFormation.getString(properties.LogGroupName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_CognitoEventPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("trigger", cdk.requiredValidator)(properties.trigger)), errors.collect(cdk.propertyValidator("trigger", cdk.unionValidator(cdk.unionValidator(cdk.validateString), cdk.listValidator(cdk.unionValidator(cdk.validateString))))(properties.trigger)), errors.collect(cdk.propertyValidator("userPool", cdk.requiredValidator)(properties.userPool)), errors.collect(cdk.propertyValidator("userPool", cdk.validateString)(properties.userPool)), errors.wrap('supplied properties not correct for "CognitoEventProperty"');
    }
    function cfnFunctionCognitoEventPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_CognitoEventPropertyValidator(properties).assertSuccess(), { Trigger: cdk.unionMapper([cdk.unionValidator(cdk.validateString), cdk.listValidator(cdk.unionValidator(cdk.validateString))], [cdk.unionMapper([cdk.validateString], [cdk.stringToCloudFormation]), cdk.listMapper(cdk.unionMapper([cdk.validateString], [cdk.stringToCloudFormation]))])(properties.trigger), UserPool: cdk.stringToCloudFormation(properties.userPool) }) : properties;
    }
    function CfnFunctionCognitoEventPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("trigger", "Trigger", cfn_parse.FromCloudFormation.getTypeUnion([cdk.unionValidator(cdk.validateString), cdk.listValidator(cdk.unionValidator(cdk.validateString))], [cfn_parse.FromCloudFormation.getTypeUnion([cdk.validateString], [cfn_parse.FromCloudFormation.getString]), cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getTypeUnion([cdk.validateString], [cfn_parse.FromCloudFormation.getString]))])(properties.Trigger)), ret.addPropertyResult("userPool", "UserPool", cfn_parse.FromCloudFormation.getString(properties.UserPool)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_CollectionSAMPTPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("collectionId", cdk.requiredValidator)(properties.collectionId)), errors.collect(cdk.propertyValidator("collectionId", cdk.validateString)(properties.collectionId)), errors.wrap('supplied properties not correct for "CollectionSAMPTProperty"');
    }
    function cfnFunctionCollectionSAMPTPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_CollectionSAMPTPropertyValidator(properties).assertSuccess(), { CollectionId: cdk.stringToCloudFormation(properties.collectionId) }) : properties;
    }
    function CfnFunctionCollectionSAMPTPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("collectionId", "CollectionId", cfn_parse.FromCloudFormation.getString(properties.CollectionId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_DeadLetterQueuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("targetArn", cdk.requiredValidator)(properties.targetArn)), errors.collect(cdk.propertyValidator("targetArn", cdk.validateString)(properties.targetArn)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "DeadLetterQueueProperty"');
    }
    function cfnFunctionDeadLetterQueuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_DeadLetterQueuePropertyValidator(properties).assertSuccess(), { TargetArn: cdk.stringToCloudFormation(properties.targetArn), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnFunctionDeadLetterQueuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("targetArn", "TargetArn", cfn_parse.FromCloudFormation.getString(properties.TargetArn)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_DeploymentPreferencePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alarms", cdk.listValidator(cdk.validateString))(properties.alarms)), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("hooks", CfnFunction_HooksPropertyValidator)(properties.hooks)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "DeploymentPreferenceProperty"');
    }
    function cfnFunctionDeploymentPreferencePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_DeploymentPreferencePropertyValidator(properties).assertSuccess(), { Alarms: cdk.listMapper(cdk.stringToCloudFormation)(properties.alarms), Enabled: cdk.booleanToCloudFormation(properties.enabled), Hooks: cfnFunctionHooksPropertyToCloudFormation(properties.hooks), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnFunctionDeploymentPreferencePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alarms", "Alarms", properties.Alarms != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Alarms) : void 0), ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addPropertyResult("hooks", "Hooks", properties.Hooks != null ? CfnFunctionHooksPropertyFromCloudFormation(properties.Hooks) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_DestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destination", cdk.requiredValidator)(properties.destination)), errors.collect(cdk.propertyValidator("destination", cdk.validateString)(properties.destination)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "DestinationProperty"');
    }
    function cfnFunctionDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_DestinationPropertyValidator(properties).assertSuccess(), { Destination: cdk.stringToCloudFormation(properties.destination), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnFunctionDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destination", "Destination", cfn_parse.FromCloudFormation.getString(properties.Destination)), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_DestinationConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("onFailure", cdk.requiredValidator)(properties.onFailure)), errors.collect(cdk.propertyValidator("onFailure", CfnFunction_DestinationPropertyValidator)(properties.onFailure)), errors.wrap('supplied properties not correct for "DestinationConfigProperty"');
    }
    function cfnFunctionDestinationConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_DestinationConfigPropertyValidator(properties).assertSuccess(), { OnFailure: cfnFunctionDestinationPropertyToCloudFormation(properties.onFailure) }) : properties;
    }
    function CfnFunctionDestinationConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("onFailure", "OnFailure", CfnFunctionDestinationPropertyFromCloudFormation(properties.OnFailure)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_DomainSAMPTPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("domainName", cdk.requiredValidator)(properties.domainName)), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.wrap('supplied properties not correct for "DomainSAMPTProperty"');
    }
    function cfnFunctionDomainSAMPTPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_DomainSAMPTPropertyValidator(properties).assertSuccess(), { DomainName: cdk.stringToCloudFormation(properties.domainName) }) : properties;
    }
    function CfnFunctionDomainSAMPTPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("domainName", "DomainName", cfn_parse.FromCloudFormation.getString(properties.DomainName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_DynamoDBEventPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("batchSize", cdk.validateNumber)(properties.batchSize)), errors.collect(cdk.propertyValidator("bisectBatchOnFunctionError", cdk.validateBoolean)(properties.bisectBatchOnFunctionError)), errors.collect(cdk.propertyValidator("destinationConfig", CfnFunction_DestinationConfigPropertyValidator)(properties.destinationConfig)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("maximumBatchingWindowInSeconds", cdk.validateNumber)(properties.maximumBatchingWindowInSeconds)), errors.collect(cdk.propertyValidator("maximumRecordAgeInSeconds", cdk.validateNumber)(properties.maximumRecordAgeInSeconds)), errors.collect(cdk.propertyValidator("maximumRetryAttempts", cdk.validateNumber)(properties.maximumRetryAttempts)), errors.collect(cdk.propertyValidator("parallelizationFactor", cdk.validateNumber)(properties.parallelizationFactor)), errors.collect(cdk.propertyValidator("startingPosition", cdk.requiredValidator)(properties.startingPosition)), errors.collect(cdk.propertyValidator("startingPosition", cdk.validateString)(properties.startingPosition)), errors.collect(cdk.propertyValidator("stream", cdk.requiredValidator)(properties.stream)), errors.collect(cdk.propertyValidator("stream", cdk.validateString)(properties.stream)), errors.wrap('supplied properties not correct for "DynamoDBEventProperty"');
    }
    function cfnFunctionDynamoDBEventPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_DynamoDBEventPropertyValidator(properties).assertSuccess(), { BatchSize: cdk.numberToCloudFormation(properties.batchSize), BisectBatchOnFunctionError: cdk.booleanToCloudFormation(properties.bisectBatchOnFunctionError), DestinationConfig: cfnFunctionDestinationConfigPropertyToCloudFormation(properties.destinationConfig), Enabled: cdk.booleanToCloudFormation(properties.enabled), MaximumBatchingWindowInSeconds: cdk.numberToCloudFormation(properties.maximumBatchingWindowInSeconds), MaximumRecordAgeInSeconds: cdk.numberToCloudFormation(properties.maximumRecordAgeInSeconds), MaximumRetryAttempts: cdk.numberToCloudFormation(properties.maximumRetryAttempts), ParallelizationFactor: cdk.numberToCloudFormation(properties.parallelizationFactor), StartingPosition: cdk.stringToCloudFormation(properties.startingPosition), Stream: cdk.stringToCloudFormation(properties.stream) }) : properties;
    }
    function CfnFunctionDynamoDBEventPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("batchSize", "BatchSize", properties.BatchSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.BatchSize) : void 0), ret.addPropertyResult("bisectBatchOnFunctionError", "BisectBatchOnFunctionError", properties.BisectBatchOnFunctionError != null ? cfn_parse.FromCloudFormation.getBoolean(properties.BisectBatchOnFunctionError) : void 0), ret.addPropertyResult("destinationConfig", "DestinationConfig", properties.DestinationConfig != null ? CfnFunctionDestinationConfigPropertyFromCloudFormation(properties.DestinationConfig) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("maximumBatchingWindowInSeconds", "MaximumBatchingWindowInSeconds", properties.MaximumBatchingWindowInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumBatchingWindowInSeconds) : void 0), ret.addPropertyResult("maximumRecordAgeInSeconds", "MaximumRecordAgeInSeconds", properties.MaximumRecordAgeInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumRecordAgeInSeconds) : void 0), ret.addPropertyResult("maximumRetryAttempts", "MaximumRetryAttempts", properties.MaximumRetryAttempts != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumRetryAttempts) : void 0), ret.addPropertyResult("parallelizationFactor", "ParallelizationFactor", properties.ParallelizationFactor != null ? cfn_parse.FromCloudFormation.getNumber(properties.ParallelizationFactor) : void 0), ret.addPropertyResult("startingPosition", "StartingPosition", cfn_parse.FromCloudFormation.getString(properties.StartingPosition)), ret.addPropertyResult("stream", "Stream", cfn_parse.FromCloudFormation.getString(properties.Stream)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_EmptySAMPTPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.wrap('supplied properties not correct for "EmptySAMPTProperty"');
    }
    function cfnFunctionEmptySAMPTPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_EmptySAMPTPropertyValidator(properties).assertSuccess(), {}) : properties;
    }
    function CfnFunctionEmptySAMPTPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_EventBridgeRuleEventPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("eventBusName", cdk.validateString)(properties.eventBusName)), errors.collect(cdk.propertyValidator("input", cdk.validateString)(properties.input)), errors.collect(cdk.propertyValidator("inputPath", cdk.validateString)(properties.inputPath)), errors.collect(cdk.propertyValidator("pattern", cdk.requiredValidator)(properties.pattern)), errors.collect(cdk.propertyValidator("pattern", cdk.validateObject)(properties.pattern)), errors.wrap('supplied properties not correct for "EventBridgeRuleEventProperty"');
    }
    function cfnFunctionEventBridgeRuleEventPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_EventBridgeRuleEventPropertyValidator(properties).assertSuccess(), { EventBusName: cdk.stringToCloudFormation(properties.eventBusName), Input: cdk.stringToCloudFormation(properties.input), InputPath: cdk.stringToCloudFormation(properties.inputPath), Pattern: cdk.objectToCloudFormation(properties.pattern) }) : properties;
    }
    function CfnFunctionEventBridgeRuleEventPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("eventBusName", "EventBusName", properties.EventBusName != null ? cfn_parse.FromCloudFormation.getString(properties.EventBusName) : void 0), ret.addPropertyResult("input", "Input", properties.Input != null ? cfn_parse.FromCloudFormation.getString(properties.Input) : void 0), ret.addPropertyResult("inputPath", "InputPath", properties.InputPath != null ? cfn_parse.FromCloudFormation.getString(properties.InputPath) : void 0), ret.addPropertyResult("pattern", "Pattern", cfn_parse.FromCloudFormation.getAny(properties.Pattern)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_EventInvokeConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationConfig", CfnFunction_EventInvokeDestinationConfigPropertyValidator)(properties.destinationConfig)), errors.collect(cdk.propertyValidator("maximumEventAgeInSeconds", cdk.validateNumber)(properties.maximumEventAgeInSeconds)), errors.collect(cdk.propertyValidator("maximumRetryAttempts", cdk.validateNumber)(properties.maximumRetryAttempts)), errors.wrap('supplied properties not correct for "EventInvokeConfigProperty"');
    }
    function cfnFunctionEventInvokeConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_EventInvokeConfigPropertyValidator(properties).assertSuccess(), { DestinationConfig: cfnFunctionEventInvokeDestinationConfigPropertyToCloudFormation(properties.destinationConfig), MaximumEventAgeInSeconds: cdk.numberToCloudFormation(properties.maximumEventAgeInSeconds), MaximumRetryAttempts: cdk.numberToCloudFormation(properties.maximumRetryAttempts) }) : properties;
    }
    function CfnFunctionEventInvokeConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationConfig", "DestinationConfig", properties.DestinationConfig != null ? CfnFunctionEventInvokeDestinationConfigPropertyFromCloudFormation(properties.DestinationConfig) : void 0), ret.addPropertyResult("maximumEventAgeInSeconds", "MaximumEventAgeInSeconds", properties.MaximumEventAgeInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumEventAgeInSeconds) : void 0), ret.addPropertyResult("maximumRetryAttempts", "MaximumRetryAttempts", properties.MaximumRetryAttempts != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumRetryAttempts) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_EventInvokeDestinationConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("onFailure", cdk.requiredValidator)(properties.onFailure)), errors.collect(cdk.propertyValidator("onFailure", CfnFunction_DestinationPropertyValidator)(properties.onFailure)), errors.collect(cdk.propertyValidator("onSuccess", cdk.requiredValidator)(properties.onSuccess)), errors.collect(cdk.propertyValidator("onSuccess", CfnFunction_DestinationPropertyValidator)(properties.onSuccess)), errors.wrap('supplied properties not correct for "EventInvokeDestinationConfigProperty"');
    }
    function cfnFunctionEventInvokeDestinationConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_EventInvokeDestinationConfigPropertyValidator(properties).assertSuccess(), { OnFailure: cfnFunctionDestinationPropertyToCloudFormation(properties.onFailure), OnSuccess: cfnFunctionDestinationPropertyToCloudFormation(properties.onSuccess) }) : properties;
    }
    function CfnFunctionEventInvokeDestinationConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("onFailure", "OnFailure", CfnFunctionDestinationPropertyFromCloudFormation(properties.OnFailure)), ret.addPropertyResult("onSuccess", "OnSuccess", CfnFunctionDestinationPropertyFromCloudFormation(properties.OnSuccess)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_EventSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("properties", cdk.requiredValidator)(properties.properties)), errors.collect(cdk.propertyValidator("properties", cdk.unionValidator(CfnFunction_S3EventPropertyValidator, CfnFunction_SNSEventPropertyValidator, CfnFunction_SQSEventPropertyValidator, CfnFunction_KinesisEventPropertyValidator, CfnFunction_DynamoDBEventPropertyValidator, CfnFunction_ApiEventPropertyValidator, CfnFunction_ScheduleEventPropertyValidator, CfnFunction_CloudWatchEventEventPropertyValidator, CfnFunction_CloudWatchLogsEventPropertyValidator, CfnFunction_IoTRuleEventPropertyValidator, CfnFunction_AlexaSkillEventPropertyValidator, CfnFunction_EventBridgeRuleEventPropertyValidator, CfnFunction_HttpApiEventPropertyValidator, CfnFunction_CognitoEventPropertyValidator))(properties.properties)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "EventSourceProperty"');
    }
    function cfnFunctionEventSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_EventSourcePropertyValidator(properties).assertSuccess(), { Properties: cdk.unionMapper([CfnFunction_S3EventPropertyValidator, CfnFunction_SNSEventPropertyValidator, CfnFunction_SQSEventPropertyValidator, CfnFunction_KinesisEventPropertyValidator, CfnFunction_DynamoDBEventPropertyValidator, CfnFunction_ApiEventPropertyValidator, CfnFunction_ScheduleEventPropertyValidator, CfnFunction_CloudWatchEventEventPropertyValidator, CfnFunction_CloudWatchLogsEventPropertyValidator, CfnFunction_IoTRuleEventPropertyValidator, CfnFunction_AlexaSkillEventPropertyValidator, CfnFunction_EventBridgeRuleEventPropertyValidator, CfnFunction_HttpApiEventPropertyValidator, CfnFunction_CognitoEventPropertyValidator], [cfnFunctionS3EventPropertyToCloudFormation, cfnFunctionSNSEventPropertyToCloudFormation, cfnFunctionSQSEventPropertyToCloudFormation, cfnFunctionKinesisEventPropertyToCloudFormation, cfnFunctionDynamoDBEventPropertyToCloudFormation, cfnFunctionApiEventPropertyToCloudFormation, cfnFunctionScheduleEventPropertyToCloudFormation, cfnFunctionCloudWatchEventEventPropertyToCloudFormation, cfnFunctionCloudWatchLogsEventPropertyToCloudFormation, cfnFunctionIoTRuleEventPropertyToCloudFormation, cfnFunctionAlexaSkillEventPropertyToCloudFormation, cfnFunctionEventBridgeRuleEventPropertyToCloudFormation, cfnFunctionHttpApiEventPropertyToCloudFormation, cfnFunctionCognitoEventPropertyToCloudFormation])(properties.properties), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnFunctionEventSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("properties", "Properties", cfn_parse.FromCloudFormation.getTypeUnion([CfnFunction_S3EventPropertyValidator, CfnFunction_SNSEventPropertyValidator, CfnFunction_SQSEventPropertyValidator, CfnFunction_KinesisEventPropertyValidator, CfnFunction_DynamoDBEventPropertyValidator, CfnFunction_ApiEventPropertyValidator, CfnFunction_ScheduleEventPropertyValidator, CfnFunction_CloudWatchEventEventPropertyValidator, CfnFunction_CloudWatchLogsEventPropertyValidator, CfnFunction_IoTRuleEventPropertyValidator, CfnFunction_AlexaSkillEventPropertyValidator, CfnFunction_EventBridgeRuleEventPropertyValidator, CfnFunction_HttpApiEventPropertyValidator, CfnFunction_CognitoEventPropertyValidator], [CfnFunctionS3EventPropertyFromCloudFormation, CfnFunctionSNSEventPropertyFromCloudFormation, CfnFunctionSQSEventPropertyFromCloudFormation, CfnFunctionKinesisEventPropertyFromCloudFormation, CfnFunctionDynamoDBEventPropertyFromCloudFormation, CfnFunctionApiEventPropertyFromCloudFormation, CfnFunctionScheduleEventPropertyFromCloudFormation, CfnFunctionCloudWatchEventEventPropertyFromCloudFormation, CfnFunctionCloudWatchLogsEventPropertyFromCloudFormation, CfnFunctionIoTRuleEventPropertyFromCloudFormation, CfnFunctionAlexaSkillEventPropertyFromCloudFormation, CfnFunctionEventBridgeRuleEventPropertyFromCloudFormation, CfnFunctionHttpApiEventPropertyFromCloudFormation, CfnFunctionCognitoEventPropertyFromCloudFormation])(properties.Properties)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_FileSystemConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("localMountPath", cdk.validateString)(properties.localMountPath)), errors.wrap('supplied properties not correct for "FileSystemConfigProperty"');
    }
    function cfnFunctionFileSystemConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_FileSystemConfigPropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn), LocalMountPath: cdk.stringToCloudFormation(properties.localMountPath) }) : properties;
    }
    function CfnFunctionFileSystemConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", properties.Arn != null ? cfn_parse.FromCloudFormation.getString(properties.Arn) : void 0), ret.addPropertyResult("localMountPath", "LocalMountPath", properties.LocalMountPath != null ? cfn_parse.FromCloudFormation.getString(properties.LocalMountPath) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_FunctionEnvironmentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("variables", cdk.requiredValidator)(properties.variables)), errors.collect(cdk.propertyValidator("variables", cdk.hashValidator(cdk.validateString))(properties.variables)), errors.wrap('supplied properties not correct for "FunctionEnvironmentProperty"');
    }
    function cfnFunctionFunctionEnvironmentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_FunctionEnvironmentPropertyValidator(properties).assertSuccess(), { Variables: cdk.hashMapper(cdk.stringToCloudFormation)(properties.variables) }) : properties;
    }
    function CfnFunctionFunctionEnvironmentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("variables", "Variables", cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Variables)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_FunctionSAMPTPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("functionName", cdk.requiredValidator)(properties.functionName)), errors.collect(cdk.propertyValidator("functionName", cdk.validateString)(properties.functionName)), errors.wrap('supplied properties not correct for "FunctionSAMPTProperty"');
    }
    function cfnFunctionFunctionSAMPTPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_FunctionSAMPTPropertyValidator(properties).assertSuccess(), { FunctionName: cdk.stringToCloudFormation(properties.functionName) }) : properties;
    }
    function CfnFunctionFunctionSAMPTPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("functionName", "FunctionName", cfn_parse.FromCloudFormation.getString(properties.FunctionName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_HooksPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("postTraffic", cdk.validateString)(properties.postTraffic)), errors.collect(cdk.propertyValidator("preTraffic", cdk.validateString)(properties.preTraffic)), errors.wrap('supplied properties not correct for "HooksProperty"');
    }
    function cfnFunctionHooksPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_HooksPropertyValidator(properties).assertSuccess(), { PostTraffic: cdk.stringToCloudFormation(properties.postTraffic), PreTraffic: cdk.stringToCloudFormation(properties.preTraffic) }) : properties;
    }
    function CfnFunctionHooksPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("postTraffic", "PostTraffic", properties.PostTraffic != null ? cfn_parse.FromCloudFormation.getString(properties.PostTraffic) : void 0), ret.addPropertyResult("preTraffic", "PreTraffic", properties.PreTraffic != null ? cfn_parse.FromCloudFormation.getString(properties.PreTraffic) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_HttpApiEventPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiId", cdk.validateString)(properties.apiId)), errors.collect(cdk.propertyValidator("auth", CfnFunction_HttpApiFunctionAuthPropertyValidator)(properties.auth)), errors.collect(cdk.propertyValidator("method", cdk.validateString)(properties.method)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.collect(cdk.propertyValidator("payloadFormatVersion", cdk.validateString)(properties.payloadFormatVersion)), errors.collect(cdk.propertyValidator("routeSettings", CfnFunction_RouteSettingsPropertyValidator)(properties.routeSettings)), errors.collect(cdk.propertyValidator("timeoutInMillis", cdk.validateNumber)(properties.timeoutInMillis)), errors.wrap('supplied properties not correct for "HttpApiEventProperty"');
    }
    function cfnFunctionHttpApiEventPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_HttpApiEventPropertyValidator(properties).assertSuccess(), { ApiId: cdk.stringToCloudFormation(properties.apiId), Auth: cfnFunctionHttpApiFunctionAuthPropertyToCloudFormation(properties.auth), Method: cdk.stringToCloudFormation(properties.method), Path: cdk.stringToCloudFormation(properties.path), PayloadFormatVersion: cdk.stringToCloudFormation(properties.payloadFormatVersion), RouteSettings: cfnFunctionRouteSettingsPropertyToCloudFormation(properties.routeSettings), TimeoutInMillis: cdk.numberToCloudFormation(properties.timeoutInMillis) }) : properties;
    }
    function CfnFunctionHttpApiEventPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiId", "ApiId", properties.ApiId != null ? cfn_parse.FromCloudFormation.getString(properties.ApiId) : void 0), ret.addPropertyResult("auth", "Auth", properties.Auth != null ? CfnFunctionHttpApiFunctionAuthPropertyFromCloudFormation(properties.Auth) : void 0), ret.addPropertyResult("method", "Method", properties.Method != null ? cfn_parse.FromCloudFormation.getString(properties.Method) : void 0), ret.addPropertyResult("path", "Path", properties.Path != null ? cfn_parse.FromCloudFormation.getString(properties.Path) : void 0), ret.addPropertyResult("payloadFormatVersion", "PayloadFormatVersion", properties.PayloadFormatVersion != null ? cfn_parse.FromCloudFormation.getString(properties.PayloadFormatVersion) : void 0), ret.addPropertyResult("routeSettings", "RouteSettings", properties.RouteSettings != null ? CfnFunctionRouteSettingsPropertyFromCloudFormation(properties.RouteSettings) : void 0), ret.addPropertyResult("timeoutInMillis", "TimeoutInMillis", properties.TimeoutInMillis != null ? cfn_parse.FromCloudFormation.getNumber(properties.TimeoutInMillis) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_HttpApiFunctionAuthPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authorizationScopes", cdk.listValidator(cdk.validateString))(properties.authorizationScopes)), errors.collect(cdk.propertyValidator("authorizer", cdk.validateString)(properties.authorizer)), errors.wrap('supplied properties not correct for "HttpApiFunctionAuthProperty"');
    }
    function cfnFunctionHttpApiFunctionAuthPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_HttpApiFunctionAuthPropertyValidator(properties).assertSuccess(), { AuthorizationScopes: cdk.listMapper(cdk.stringToCloudFormation)(properties.authorizationScopes), Authorizer: cdk.stringToCloudFormation(properties.authorizer) }) : properties;
    }
    function CfnFunctionHttpApiFunctionAuthPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authorizationScopes", "AuthorizationScopes", properties.AuthorizationScopes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AuthorizationScopes) : void 0), ret.addPropertyResult("authorizer", "Authorizer", properties.Authorizer != null ? cfn_parse.FromCloudFormation.getString(properties.Authorizer) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_IAMPolicyDocumentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("statement", cdk.requiredValidator)(properties.statement)), errors.collect(cdk.propertyValidator("statement", cdk.validateObject)(properties.statement)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "IAMPolicyDocumentProperty"');
    }
    function cfnFunctionIAMPolicyDocumentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_IAMPolicyDocumentPropertyValidator(properties).assertSuccess(), { Statement: cdk.objectToCloudFormation(properties.statement), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnFunctionIAMPolicyDocumentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("statement", "Statement", cfn_parse.FromCloudFormation.getAny(properties.Statement)), ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getString(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_IdentitySAMPTPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("identityName", cdk.requiredValidator)(properties.identityName)), errors.collect(cdk.propertyValidator("identityName", cdk.validateString)(properties.identityName)), errors.wrap('supplied properties not correct for "IdentitySAMPTProperty"');
    }
    function cfnFunctionIdentitySAMPTPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_IdentitySAMPTPropertyValidator(properties).assertSuccess(), { IdentityName: cdk.stringToCloudFormation(properties.identityName) }) : properties;
    }
    function CfnFunctionIdentitySAMPTPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("identityName", "IdentityName", cfn_parse.FromCloudFormation.getString(properties.IdentityName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_ImageConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("command", cdk.listValidator(cdk.validateString))(properties.command)), errors.collect(cdk.propertyValidator("entryPoint", cdk.listValidator(cdk.validateString))(properties.entryPoint)), errors.collect(cdk.propertyValidator("workingDirectory", cdk.validateString)(properties.workingDirectory)), errors.wrap('supplied properties not correct for "ImageConfigProperty"');
    }
    function cfnFunctionImageConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_ImageConfigPropertyValidator(properties).assertSuccess(), { Command: cdk.listMapper(cdk.stringToCloudFormation)(properties.command), EntryPoint: cdk.listMapper(cdk.stringToCloudFormation)(properties.entryPoint), WorkingDirectory: cdk.stringToCloudFormation(properties.workingDirectory) }) : properties;
    }
    function CfnFunctionImageConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("command", "Command", properties.Command != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Command) : void 0), ret.addPropertyResult("entryPoint", "EntryPoint", properties.EntryPoint != null ? cfn_parse.FromCloudFormation.getStringArray(properties.EntryPoint) : void 0), ret.addPropertyResult("workingDirectory", "WorkingDirectory", properties.WorkingDirectory != null ? cfn_parse.FromCloudFormation.getString(properties.WorkingDirectory) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_IoTRuleEventPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("awsIotSqlVersion", cdk.validateString)(properties.awsIotSqlVersion)), errors.collect(cdk.propertyValidator("sql", cdk.requiredValidator)(properties.sql)), errors.collect(cdk.propertyValidator("sql", cdk.validateString)(properties.sql)), errors.wrap('supplied properties not correct for "IoTRuleEventProperty"');
    }
    function cfnFunctionIoTRuleEventPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_IoTRuleEventPropertyValidator(properties).assertSuccess(), { AwsIotSqlVersion: cdk.stringToCloudFormation(properties.awsIotSqlVersion), Sql: cdk.stringToCloudFormation(properties.sql) }) : properties;
    }
    function CfnFunctionIoTRuleEventPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("awsIotSqlVersion", "AwsIotSqlVersion", properties.AwsIotSqlVersion != null ? cfn_parse.FromCloudFormation.getString(properties.AwsIotSqlVersion) : void 0), ret.addPropertyResult("sql", "Sql", cfn_parse.FromCloudFormation.getString(properties.Sql)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_KeySAMPTPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("keyId", cdk.requiredValidator)(properties.keyId)), errors.collect(cdk.propertyValidator("keyId", cdk.validateString)(properties.keyId)), errors.wrap('supplied properties not correct for "KeySAMPTProperty"');
    }
    function cfnFunctionKeySAMPTPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_KeySAMPTPropertyValidator(properties).assertSuccess(), { KeyId: cdk.stringToCloudFormation(properties.keyId) }) : properties;
    }
    function CfnFunctionKeySAMPTPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("keyId", "KeyId", cfn_parse.FromCloudFormation.getString(properties.KeyId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_KinesisEventPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("batchSize", cdk.validateNumber)(properties.batchSize)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("functionResponseTypes", cdk.listValidator(cdk.validateString))(properties.functionResponseTypes)), errors.collect(cdk.propertyValidator("startingPosition", cdk.requiredValidator)(properties.startingPosition)), errors.collect(cdk.propertyValidator("startingPosition", cdk.validateString)(properties.startingPosition)), errors.collect(cdk.propertyValidator("stream", cdk.requiredValidator)(properties.stream)), errors.collect(cdk.propertyValidator("stream", cdk.validateString)(properties.stream)), errors.wrap('supplied properties not correct for "KinesisEventProperty"');
    }
    function cfnFunctionKinesisEventPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_KinesisEventPropertyValidator(properties).assertSuccess(), { BatchSize: cdk.numberToCloudFormation(properties.batchSize), Enabled: cdk.booleanToCloudFormation(properties.enabled), FunctionResponseTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.functionResponseTypes), StartingPosition: cdk.stringToCloudFormation(properties.startingPosition), Stream: cdk.stringToCloudFormation(properties.stream) }) : properties;
    }
    function CfnFunctionKinesisEventPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("batchSize", "BatchSize", properties.BatchSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.BatchSize) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("functionResponseTypes", "FunctionResponseTypes", properties.FunctionResponseTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.FunctionResponseTypes) : void 0), ret.addPropertyResult("startingPosition", "StartingPosition", cfn_parse.FromCloudFormation.getString(properties.StartingPosition)), ret.addPropertyResult("stream", "Stream", cfn_parse.FromCloudFormation.getString(properties.Stream)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_LogGroupSAMPTPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logGroupName", cdk.requiredValidator)(properties.logGroupName)), errors.collect(cdk.propertyValidator("logGroupName", cdk.validateString)(properties.logGroupName)), errors.wrap('supplied properties not correct for "LogGroupSAMPTProperty"');
    }
    function cfnFunctionLogGroupSAMPTPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_LogGroupSAMPTPropertyValidator(properties).assertSuccess(), { LogGroupName: cdk.stringToCloudFormation(properties.logGroupName) }) : properties;
    }
    function CfnFunctionLogGroupSAMPTPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logGroupName", "LogGroupName", cfn_parse.FromCloudFormation.getString(properties.LogGroupName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_ParameterNameSAMPTPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("parameterName", cdk.requiredValidator)(properties.parameterName)), errors.collect(cdk.propertyValidator("parameterName", cdk.validateString)(properties.parameterName)), errors.wrap('supplied properties not correct for "ParameterNameSAMPTProperty"');
    }
    function cfnFunctionParameterNameSAMPTPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_ParameterNameSAMPTPropertyValidator(properties).assertSuccess(), { ParameterName: cdk.stringToCloudFormation(properties.parameterName) }) : properties;
    }
    function CfnFunctionParameterNameSAMPTPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("parameterName", "ParameterName", cfn_parse.FromCloudFormation.getString(properties.ParameterName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_ProvisionedConcurrencyConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("provisionedConcurrentExecutions", cdk.requiredValidator)(properties.provisionedConcurrentExecutions)), errors.collect(cdk.propertyValidator("provisionedConcurrentExecutions", cdk.validateString)(properties.provisionedConcurrentExecutions)), errors.wrap('supplied properties not correct for "ProvisionedConcurrencyConfigProperty"');
    }
    function cfnFunctionProvisionedConcurrencyConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_ProvisionedConcurrencyConfigPropertyValidator(properties).assertSuccess(), { ProvisionedConcurrentExecutions: cdk.stringToCloudFormation(properties.provisionedConcurrentExecutions) }) : properties;
    }
    function CfnFunctionProvisionedConcurrencyConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("provisionedConcurrentExecutions", "ProvisionedConcurrentExecutions", cfn_parse.FromCloudFormation.getString(properties.ProvisionedConcurrentExecutions)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_QueueSAMPTPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("queueName", cdk.requiredValidator)(properties.queueName)), errors.collect(cdk.propertyValidator("queueName", cdk.validateString)(properties.queueName)), errors.wrap('supplied properties not correct for "QueueSAMPTProperty"');
    }
    function cfnFunctionQueueSAMPTPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_QueueSAMPTPropertyValidator(properties).assertSuccess(), { QueueName: cdk.stringToCloudFormation(properties.queueName) }) : properties;
    }
    function CfnFunctionQueueSAMPTPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("queueName", "QueueName", cfn_parse.FromCloudFormation.getString(properties.QueueName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_RequestModelPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("model", cdk.requiredValidator)(properties.model)), errors.collect(cdk.propertyValidator("model", cdk.validateString)(properties.model)), errors.collect(cdk.propertyValidator("required", cdk.validateBoolean)(properties.required)), errors.collect(cdk.propertyValidator("validateBody", cdk.validateBoolean)(properties.validateBody)), errors.collect(cdk.propertyValidator("validateParameters", cdk.validateBoolean)(properties.validateParameters)), errors.wrap('supplied properties not correct for "RequestModelProperty"');
    }
    function cfnFunctionRequestModelPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_RequestModelPropertyValidator(properties).assertSuccess(), { Model: cdk.stringToCloudFormation(properties.model), Required: cdk.booleanToCloudFormation(properties.required), ValidateBody: cdk.booleanToCloudFormation(properties.validateBody), ValidateParameters: cdk.booleanToCloudFormation(properties.validateParameters) }) : properties;
    }
    function CfnFunctionRequestModelPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("model", "Model", cfn_parse.FromCloudFormation.getString(properties.Model)), ret.addPropertyResult("required", "Required", properties.Required != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Required) : void 0), ret.addPropertyResult("validateBody", "ValidateBody", properties.ValidateBody != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ValidateBody) : void 0), ret.addPropertyResult("validateParameters", "ValidateParameters", properties.ValidateParameters != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ValidateParameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_RequestParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("caching", cdk.validateBoolean)(properties.caching)), errors.collect(cdk.propertyValidator("required", cdk.validateBoolean)(properties.required)), errors.wrap('supplied properties not correct for "RequestParameterProperty"');
    }
    function cfnFunctionRequestParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_RequestParameterPropertyValidator(properties).assertSuccess(), { Caching: cdk.booleanToCloudFormation(properties.caching), Required: cdk.booleanToCloudFormation(properties.required) }) : properties;
    }
    function CfnFunctionRequestParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("caching", "Caching", properties.Caching != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Caching) : void 0), ret.addPropertyResult("required", "Required", properties.Required != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Required) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_RouteSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataTraceEnabled", cdk.validateBoolean)(properties.dataTraceEnabled)), errors.collect(cdk.propertyValidator("detailedMetricsEnabled", cdk.validateBoolean)(properties.detailedMetricsEnabled)), errors.collect(cdk.propertyValidator("loggingLevel", cdk.validateString)(properties.loggingLevel)), errors.collect(cdk.propertyValidator("throttlingBurstLimit", cdk.validateNumber)(properties.throttlingBurstLimit)), errors.collect(cdk.propertyValidator("throttlingRateLimit", cdk.validateNumber)(properties.throttlingRateLimit)), errors.wrap('supplied properties not correct for "RouteSettingsProperty"');
    }
    function cfnFunctionRouteSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_RouteSettingsPropertyValidator(properties).assertSuccess(), { DataTraceEnabled: cdk.booleanToCloudFormation(properties.dataTraceEnabled), DetailedMetricsEnabled: cdk.booleanToCloudFormation(properties.detailedMetricsEnabled), LoggingLevel: cdk.stringToCloudFormation(properties.loggingLevel), ThrottlingBurstLimit: cdk.numberToCloudFormation(properties.throttlingBurstLimit), ThrottlingRateLimit: cdk.numberToCloudFormation(properties.throttlingRateLimit) }) : properties;
    }
    function CfnFunctionRouteSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataTraceEnabled", "DataTraceEnabled", properties.DataTraceEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DataTraceEnabled) : void 0), ret.addPropertyResult("detailedMetricsEnabled", "DetailedMetricsEnabled", properties.DetailedMetricsEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DetailedMetricsEnabled) : void 0), ret.addPropertyResult("loggingLevel", "LoggingLevel", properties.LoggingLevel != null ? cfn_parse.FromCloudFormation.getString(properties.LoggingLevel) : void 0), ret.addPropertyResult("throttlingBurstLimit", "ThrottlingBurstLimit", properties.ThrottlingBurstLimit != null ? cfn_parse.FromCloudFormation.getNumber(properties.ThrottlingBurstLimit) : void 0), ret.addPropertyResult("throttlingRateLimit", "ThrottlingRateLimit", properties.ThrottlingRateLimit != null ? cfn_parse.FromCloudFormation.getNumber(properties.ThrottlingRateLimit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_S3EventPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.requiredValidator)(properties.bucket)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("events", cdk.requiredValidator)(properties.events)), errors.collect(cdk.propertyValidator("events", cdk.unionValidator(cdk.unionValidator(cdk.validateString), cdk.listValidator(cdk.unionValidator(cdk.validateString))))(properties.events)), errors.collect(cdk.propertyValidator("filter", CfnFunction_S3NotificationFilterPropertyValidator)(properties.filter)), errors.wrap('supplied properties not correct for "S3EventProperty"');
    }
    function cfnFunctionS3EventPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_S3EventPropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), Events: cdk.unionMapper([cdk.unionValidator(cdk.validateString), cdk.listValidator(cdk.unionValidator(cdk.validateString))], [cdk.unionMapper([cdk.validateString], [cdk.stringToCloudFormation]), cdk.listMapper(cdk.unionMapper([cdk.validateString], [cdk.stringToCloudFormation]))])(properties.events), Filter: cfnFunctionS3NotificationFilterPropertyToCloudFormation(properties.filter) }) : properties;
    }
    function CfnFunctionS3EventPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", cfn_parse.FromCloudFormation.getString(properties.Bucket)), ret.addPropertyResult("events", "Events", cfn_parse.FromCloudFormation.getTypeUnion([cdk.unionValidator(cdk.validateString), cdk.listValidator(cdk.unionValidator(cdk.validateString))], [cfn_parse.FromCloudFormation.getTypeUnion([cdk.validateString], [cfn_parse.FromCloudFormation.getString]), cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getTypeUnion([cdk.validateString], [cfn_parse.FromCloudFormation.getString]))])(properties.Events)), ret.addPropertyResult("filter", "Filter", properties.Filter != null ? CfnFunctionS3NotificationFilterPropertyFromCloudFormation(properties.Filter) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_S3KeyFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("rules", cdk.requiredValidator)(properties.rules)), errors.collect(cdk.propertyValidator("rules", cdk.listValidator(CfnFunction_S3KeyFilterRulePropertyValidator))(properties.rules)), errors.wrap('supplied properties not correct for "S3KeyFilterProperty"');
    }
    function cfnFunctionS3KeyFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_S3KeyFilterPropertyValidator(properties).assertSuccess(), { Rules: cdk.listMapper(cfnFunctionS3KeyFilterRulePropertyToCloudFormation)(properties.rules) }) : properties;
    }
    function CfnFunctionS3KeyFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("rules", "Rules", cfn_parse.FromCloudFormation.getArray(CfnFunctionS3KeyFilterRulePropertyFromCloudFormation)(properties.Rules)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_S3KeyFilterRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "S3KeyFilterRuleProperty"');
    }
    function cfnFunctionS3KeyFilterRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_S3KeyFilterRulePropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnFunctionS3KeyFilterRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_S3LocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.requiredValidator)(properties.bucket)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("version", cdk.validateNumber)(properties.version)), errors.wrap('supplied properties not correct for "S3LocationProperty"');
    }
    function cfnFunctionS3LocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_S3LocationPropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), Key: cdk.stringToCloudFormation(properties.key), Version: cdk.numberToCloudFormation(properties.version) }) : properties;
    }
    function CfnFunctionS3LocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", cfn_parse.FromCloudFormation.getString(properties.Bucket)), ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getNumber(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_S3NotificationFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3Key", cdk.requiredValidator)(properties.s3Key)), errors.collect(cdk.propertyValidator("s3Key", CfnFunction_S3KeyFilterPropertyValidator)(properties.s3Key)), errors.wrap('supplied properties not correct for "S3NotificationFilterProperty"');
    }
    function cfnFunctionS3NotificationFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_S3NotificationFilterPropertyValidator(properties).assertSuccess(), { S3Key: cfnFunctionS3KeyFilterPropertyToCloudFormation(properties.s3Key) }) : properties;
    }
    function CfnFunctionS3NotificationFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Key", "S3Key", CfnFunctionS3KeyFilterPropertyFromCloudFormation(properties.S3Key)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_SAMPolicyTemplatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("amiDescribePolicy", CfnFunction_EmptySAMPTPropertyValidator)(properties.amiDescribePolicy)), errors.collect(cdk.propertyValidator("awsSecretsManagerGetSecretValuePolicy", CfnFunction_SecretArnSAMPTPropertyValidator)(properties.awsSecretsManagerGetSecretValuePolicy)), errors.collect(cdk.propertyValidator("cloudFormationDescribeStacksPolicy", CfnFunction_EmptySAMPTPropertyValidator)(properties.cloudFormationDescribeStacksPolicy)), errors.collect(cdk.propertyValidator("cloudWatchPutMetricPolicy", CfnFunction_EmptySAMPTPropertyValidator)(properties.cloudWatchPutMetricPolicy)), errors.collect(cdk.propertyValidator("dynamoDbCrudPolicy", CfnFunction_TableSAMPTPropertyValidator)(properties.dynamoDbCrudPolicy)), errors.collect(cdk.propertyValidator("dynamoDbReadPolicy", CfnFunction_TableSAMPTPropertyValidator)(properties.dynamoDbReadPolicy)), errors.collect(cdk.propertyValidator("dynamoDbStreamReadPolicy", CfnFunction_TableStreamSAMPTPropertyValidator)(properties.dynamoDbStreamReadPolicy)), errors.collect(cdk.propertyValidator("dynamoDbWritePolicy", CfnFunction_TableSAMPTPropertyValidator)(properties.dynamoDbWritePolicy)), errors.collect(cdk.propertyValidator("ec2DescribePolicy", CfnFunction_EmptySAMPTPropertyValidator)(properties.ec2DescribePolicy)), errors.collect(cdk.propertyValidator("elasticsearchHttpPostPolicy", CfnFunction_DomainSAMPTPropertyValidator)(properties.elasticsearchHttpPostPolicy)), errors.collect(cdk.propertyValidator("filterLogEventsPolicy", CfnFunction_LogGroupSAMPTPropertyValidator)(properties.filterLogEventsPolicy)), errors.collect(cdk.propertyValidator("kmsDecryptPolicy", CfnFunction_KeySAMPTPropertyValidator)(properties.kmsDecryptPolicy)), errors.collect(cdk.propertyValidator("kinesisCrudPolicy", CfnFunction_StreamSAMPTPropertyValidator)(properties.kinesisCrudPolicy)), errors.collect(cdk.propertyValidator("kinesisStreamReadPolicy", CfnFunction_StreamSAMPTPropertyValidator)(properties.kinesisStreamReadPolicy)), errors.collect(cdk.propertyValidator("lambdaInvokePolicy", CfnFunction_FunctionSAMPTPropertyValidator)(properties.lambdaInvokePolicy)), errors.collect(cdk.propertyValidator("rekognitionDetectOnlyPolicy", CfnFunction_EmptySAMPTPropertyValidator)(properties.rekognitionDetectOnlyPolicy)), errors.collect(cdk.propertyValidator("rekognitionLabelsPolicy", CfnFunction_EmptySAMPTPropertyValidator)(properties.rekognitionLabelsPolicy)), errors.collect(cdk.propertyValidator("rekognitionNoDataAccessPolicy", CfnFunction_CollectionSAMPTPropertyValidator)(properties.rekognitionNoDataAccessPolicy)), errors.collect(cdk.propertyValidator("rekognitionReadPolicy", CfnFunction_CollectionSAMPTPropertyValidator)(properties.rekognitionReadPolicy)), errors.collect(cdk.propertyValidator("rekognitionWriteOnlyAccessPolicy", CfnFunction_CollectionSAMPTPropertyValidator)(properties.rekognitionWriteOnlyAccessPolicy)), errors.collect(cdk.propertyValidator("s3CrudPolicy", CfnFunction_BucketSAMPTPropertyValidator)(properties.s3CrudPolicy)), errors.collect(cdk.propertyValidator("s3ReadPolicy", CfnFunction_BucketSAMPTPropertyValidator)(properties.s3ReadPolicy)), errors.collect(cdk.propertyValidator("s3WritePolicy", CfnFunction_BucketSAMPTPropertyValidator)(properties.s3WritePolicy)), errors.collect(cdk.propertyValidator("sesBulkTemplatedCrudPolicy", CfnFunction_IdentitySAMPTPropertyValidator)(properties.sesBulkTemplatedCrudPolicy)), errors.collect(cdk.propertyValidator("sesCrudPolicy", CfnFunction_IdentitySAMPTPropertyValidator)(properties.sesCrudPolicy)), errors.collect(cdk.propertyValidator("sesEmailTemplateCrudPolicy", CfnFunction_EmptySAMPTPropertyValidator)(properties.sesEmailTemplateCrudPolicy)), errors.collect(cdk.propertyValidator("sesSendBouncePolicy", CfnFunction_IdentitySAMPTPropertyValidator)(properties.sesSendBouncePolicy)), errors.collect(cdk.propertyValidator("snsCrudPolicy", CfnFunction_TopicSAMPTPropertyValidator)(properties.snsCrudPolicy)), errors.collect(cdk.propertyValidator("snsPublishMessagePolicy", CfnFunction_TopicSAMPTPropertyValidator)(properties.snsPublishMessagePolicy)), errors.collect(cdk.propertyValidator("sqsPollerPolicy", CfnFunction_QueueSAMPTPropertyValidator)(properties.sqsPollerPolicy)), errors.collect(cdk.propertyValidator("sqsSendMessagePolicy", CfnFunction_QueueSAMPTPropertyValidator)(properties.sqsSendMessagePolicy)), errors.collect(cdk.propertyValidator("ssmParameterReadPolicy", CfnFunction_ParameterNameSAMPTPropertyValidator)(properties.ssmParameterReadPolicy)), errors.collect(cdk.propertyValidator("stepFunctionsExecutionPolicy", CfnFunction_StateMachineSAMPTPropertyValidator)(properties.stepFunctionsExecutionPolicy)), errors.collect(cdk.propertyValidator("vpcAccessPolicy", CfnFunction_EmptySAMPTPropertyValidator)(properties.vpcAccessPolicy)), errors.wrap('supplied properties not correct for "SAMPolicyTemplateProperty"');
    }
    function cfnFunctionSAMPolicyTemplatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_SAMPolicyTemplatePropertyValidator(properties).assertSuccess(), { AMIDescribePolicy: cfnFunctionEmptySAMPTPropertyToCloudFormation(properties.amiDescribePolicy), AWSSecretsManagerGetSecretValuePolicy: cfnFunctionSecretArnSAMPTPropertyToCloudFormation(properties.awsSecretsManagerGetSecretValuePolicy), CloudFormationDescribeStacksPolicy: cfnFunctionEmptySAMPTPropertyToCloudFormation(properties.cloudFormationDescribeStacksPolicy), CloudWatchPutMetricPolicy: cfnFunctionEmptySAMPTPropertyToCloudFormation(properties.cloudWatchPutMetricPolicy), DynamoDBCrudPolicy: cfnFunctionTableSAMPTPropertyToCloudFormation(properties.dynamoDbCrudPolicy), DynamoDBReadPolicy: cfnFunctionTableSAMPTPropertyToCloudFormation(properties.dynamoDbReadPolicy), DynamoDBStreamReadPolicy: cfnFunctionTableStreamSAMPTPropertyToCloudFormation(properties.dynamoDbStreamReadPolicy), DynamoDBWritePolicy: cfnFunctionTableSAMPTPropertyToCloudFormation(properties.dynamoDbWritePolicy), EC2DescribePolicy: cfnFunctionEmptySAMPTPropertyToCloudFormation(properties.ec2DescribePolicy), ElasticsearchHttpPostPolicy: cfnFunctionDomainSAMPTPropertyToCloudFormation(properties.elasticsearchHttpPostPolicy), FilterLogEventsPolicy: cfnFunctionLogGroupSAMPTPropertyToCloudFormation(properties.filterLogEventsPolicy), KMSDecryptPolicy: cfnFunctionKeySAMPTPropertyToCloudFormation(properties.kmsDecryptPolicy), KinesisCrudPolicy: cfnFunctionStreamSAMPTPropertyToCloudFormation(properties.kinesisCrudPolicy), KinesisStreamReadPolicy: cfnFunctionStreamSAMPTPropertyToCloudFormation(properties.kinesisStreamReadPolicy), LambdaInvokePolicy: cfnFunctionFunctionSAMPTPropertyToCloudFormation(properties.lambdaInvokePolicy), RekognitionDetectOnlyPolicy: cfnFunctionEmptySAMPTPropertyToCloudFormation(properties.rekognitionDetectOnlyPolicy), RekognitionLabelsPolicy: cfnFunctionEmptySAMPTPropertyToCloudFormation(properties.rekognitionLabelsPolicy), RekognitionNoDataAccessPolicy: cfnFunctionCollectionSAMPTPropertyToCloudFormation(properties.rekognitionNoDataAccessPolicy), RekognitionReadPolicy: cfnFunctionCollectionSAMPTPropertyToCloudFormation(properties.rekognitionReadPolicy), RekognitionWriteOnlyAccessPolicy: cfnFunctionCollectionSAMPTPropertyToCloudFormation(properties.rekognitionWriteOnlyAccessPolicy), S3CrudPolicy: cfnFunctionBucketSAMPTPropertyToCloudFormation(properties.s3CrudPolicy), S3ReadPolicy: cfnFunctionBucketSAMPTPropertyToCloudFormation(properties.s3ReadPolicy), S3WritePolicy: cfnFunctionBucketSAMPTPropertyToCloudFormation(properties.s3WritePolicy), SESBulkTemplatedCrudPolicy: cfnFunctionIdentitySAMPTPropertyToCloudFormation(properties.sesBulkTemplatedCrudPolicy), SESCrudPolicy: cfnFunctionIdentitySAMPTPropertyToCloudFormation(properties.sesCrudPolicy), SESEmailTemplateCrudPolicy: cfnFunctionEmptySAMPTPropertyToCloudFormation(properties.sesEmailTemplateCrudPolicy), SESSendBouncePolicy: cfnFunctionIdentitySAMPTPropertyToCloudFormation(properties.sesSendBouncePolicy), SNSCrudPolicy: cfnFunctionTopicSAMPTPropertyToCloudFormation(properties.snsCrudPolicy), SNSPublishMessagePolicy: cfnFunctionTopicSAMPTPropertyToCloudFormation(properties.snsPublishMessagePolicy), SQSPollerPolicy: cfnFunctionQueueSAMPTPropertyToCloudFormation(properties.sqsPollerPolicy), SQSSendMessagePolicy: cfnFunctionQueueSAMPTPropertyToCloudFormation(properties.sqsSendMessagePolicy), SSMParameterReadPolicy: cfnFunctionParameterNameSAMPTPropertyToCloudFormation(properties.ssmParameterReadPolicy), StepFunctionsExecutionPolicy: cfnFunctionStateMachineSAMPTPropertyToCloudFormation(properties.stepFunctionsExecutionPolicy), VPCAccessPolicy: cfnFunctionEmptySAMPTPropertyToCloudFormation(properties.vpcAccessPolicy) }) : properties;
    }
    function CfnFunctionSAMPolicyTemplatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("amiDescribePolicy", "AMIDescribePolicy", properties.AMIDescribePolicy != null ? CfnFunctionEmptySAMPTPropertyFromCloudFormation(properties.AMIDescribePolicy) : void 0), ret.addPropertyResult("awsSecretsManagerGetSecretValuePolicy", "AWSSecretsManagerGetSecretValuePolicy", properties.AWSSecretsManagerGetSecretValuePolicy != null ? CfnFunctionSecretArnSAMPTPropertyFromCloudFormation(properties.AWSSecretsManagerGetSecretValuePolicy) : void 0), ret.addPropertyResult("cloudFormationDescribeStacksPolicy", "CloudFormationDescribeStacksPolicy", properties.CloudFormationDescribeStacksPolicy != null ? CfnFunctionEmptySAMPTPropertyFromCloudFormation(properties.CloudFormationDescribeStacksPolicy) : void 0), ret.addPropertyResult("cloudWatchPutMetricPolicy", "CloudWatchPutMetricPolicy", properties.CloudWatchPutMetricPolicy != null ? CfnFunctionEmptySAMPTPropertyFromCloudFormation(properties.CloudWatchPutMetricPolicy) : void 0), ret.addPropertyResult("dynamoDbCrudPolicy", "DynamoDBCrudPolicy", properties.DynamoDBCrudPolicy != null ? CfnFunctionTableSAMPTPropertyFromCloudFormation(properties.DynamoDBCrudPolicy) : void 0), ret.addPropertyResult("dynamoDbReadPolicy", "DynamoDBReadPolicy", properties.DynamoDBReadPolicy != null ? CfnFunctionTableSAMPTPropertyFromCloudFormation(properties.DynamoDBReadPolicy) : void 0), ret.addPropertyResult("dynamoDbStreamReadPolicy", "DynamoDBStreamReadPolicy", properties.DynamoDBStreamReadPolicy != null ? CfnFunctionTableStreamSAMPTPropertyFromCloudFormation(properties.DynamoDBStreamReadPolicy) : void 0), ret.addPropertyResult("dynamoDbWritePolicy", "DynamoDBWritePolicy", properties.DynamoDBWritePolicy != null ? CfnFunctionTableSAMPTPropertyFromCloudFormation(properties.DynamoDBWritePolicy) : void 0), ret.addPropertyResult("ec2DescribePolicy", "EC2DescribePolicy", properties.EC2DescribePolicy != null ? CfnFunctionEmptySAMPTPropertyFromCloudFormation(properties.EC2DescribePolicy) : void 0), ret.addPropertyResult("elasticsearchHttpPostPolicy", "ElasticsearchHttpPostPolicy", properties.ElasticsearchHttpPostPolicy != null ? CfnFunctionDomainSAMPTPropertyFromCloudFormation(properties.ElasticsearchHttpPostPolicy) : void 0), ret.addPropertyResult("filterLogEventsPolicy", "FilterLogEventsPolicy", properties.FilterLogEventsPolicy != null ? CfnFunctionLogGroupSAMPTPropertyFromCloudFormation(properties.FilterLogEventsPolicy) : void 0), ret.addPropertyResult("kmsDecryptPolicy", "KMSDecryptPolicy", properties.KMSDecryptPolicy != null ? CfnFunctionKeySAMPTPropertyFromCloudFormation(properties.KMSDecryptPolicy) : void 0), ret.addPropertyResult("kinesisCrudPolicy", "KinesisCrudPolicy", properties.KinesisCrudPolicy != null ? CfnFunctionStreamSAMPTPropertyFromCloudFormation(properties.KinesisCrudPolicy) : void 0), ret.addPropertyResult("kinesisStreamReadPolicy", "KinesisStreamReadPolicy", properties.KinesisStreamReadPolicy != null ? CfnFunctionStreamSAMPTPropertyFromCloudFormation(properties.KinesisStreamReadPolicy) : void 0), ret.addPropertyResult("lambdaInvokePolicy", "LambdaInvokePolicy", properties.LambdaInvokePolicy != null ? CfnFunctionFunctionSAMPTPropertyFromCloudFormation(properties.LambdaInvokePolicy) : void 0), ret.addPropertyResult("rekognitionDetectOnlyPolicy", "RekognitionDetectOnlyPolicy", properties.RekognitionDetectOnlyPolicy != null ? CfnFunctionEmptySAMPTPropertyFromCloudFormation(properties.RekognitionDetectOnlyPolicy) : void 0), ret.addPropertyResult("rekognitionLabelsPolicy", "RekognitionLabelsPolicy", properties.RekognitionLabelsPolicy != null ? CfnFunctionEmptySAMPTPropertyFromCloudFormation(properties.RekognitionLabelsPolicy) : void 0), ret.addPropertyResult("rekognitionNoDataAccessPolicy", "RekognitionNoDataAccessPolicy", properties.RekognitionNoDataAccessPolicy != null ? CfnFunctionCollectionSAMPTPropertyFromCloudFormation(properties.RekognitionNoDataAccessPolicy) : void 0), ret.addPropertyResult("rekognitionReadPolicy", "RekognitionReadPolicy", properties.RekognitionReadPolicy != null ? CfnFunctionCollectionSAMPTPropertyFromCloudFormation(properties.RekognitionReadPolicy) : void 0), ret.addPropertyResult("rekognitionWriteOnlyAccessPolicy", "RekognitionWriteOnlyAccessPolicy", properties.RekognitionWriteOnlyAccessPolicy != null ? CfnFunctionCollectionSAMPTPropertyFromCloudFormation(properties.RekognitionWriteOnlyAccessPolicy) : void 0), ret.addPropertyResult("s3CrudPolicy", "S3CrudPolicy", properties.S3CrudPolicy != null ? CfnFunctionBucketSAMPTPropertyFromCloudFormation(properties.S3CrudPolicy) : void 0), ret.addPropertyResult("s3ReadPolicy", "S3ReadPolicy", properties.S3ReadPolicy != null ? CfnFunctionBucketSAMPTPropertyFromCloudFormation(properties.S3ReadPolicy) : void 0), ret.addPropertyResult("s3WritePolicy", "S3WritePolicy", properties.S3WritePolicy != null ? CfnFunctionBucketSAMPTPropertyFromCloudFormation(properties.S3WritePolicy) : void 0), ret.addPropertyResult("sesBulkTemplatedCrudPolicy", "SESBulkTemplatedCrudPolicy", properties.SESBulkTemplatedCrudPolicy != null ? CfnFunctionIdentitySAMPTPropertyFromCloudFormation(properties.SESBulkTemplatedCrudPolicy) : void 0), ret.addPropertyResult("sesCrudPolicy", "SESCrudPolicy", properties.SESCrudPolicy != null ? CfnFunctionIdentitySAMPTPropertyFromCloudFormation(properties.SESCrudPolicy) : void 0), ret.addPropertyResult("sesEmailTemplateCrudPolicy", "SESEmailTemplateCrudPolicy", properties.SESEmailTemplateCrudPolicy != null ? CfnFunctionEmptySAMPTPropertyFromCloudFormation(properties.SESEmailTemplateCrudPolicy) : void 0), ret.addPropertyResult("sesSendBouncePolicy", "SESSendBouncePolicy", properties.SESSendBouncePolicy != null ? CfnFunctionIdentitySAMPTPropertyFromCloudFormation(properties.SESSendBouncePolicy) : void 0), ret.addPropertyResult("snsCrudPolicy", "SNSCrudPolicy", properties.SNSCrudPolicy != null ? CfnFunctionTopicSAMPTPropertyFromCloudFormation(properties.SNSCrudPolicy) : void 0), ret.addPropertyResult("snsPublishMessagePolicy", "SNSPublishMessagePolicy", properties.SNSPublishMessagePolicy != null ? CfnFunctionTopicSAMPTPropertyFromCloudFormation(properties.SNSPublishMessagePolicy) : void 0), ret.addPropertyResult("sqsPollerPolicy", "SQSPollerPolicy", properties.SQSPollerPolicy != null ? CfnFunctionQueueSAMPTPropertyFromCloudFormation(properties.SQSPollerPolicy) : void 0), ret.addPropertyResult("sqsSendMessagePolicy", "SQSSendMessagePolicy", properties.SQSSendMessagePolicy != null ? CfnFunctionQueueSAMPTPropertyFromCloudFormation(properties.SQSSendMessagePolicy) : void 0), ret.addPropertyResult("ssmParameterReadPolicy", "SSMParameterReadPolicy", properties.SSMParameterReadPolicy != null ? CfnFunctionParameterNameSAMPTPropertyFromCloudFormation(properties.SSMParameterReadPolicy) : void 0), ret.addPropertyResult("stepFunctionsExecutionPolicy", "StepFunctionsExecutionPolicy", properties.StepFunctionsExecutionPolicy != null ? CfnFunctionStateMachineSAMPTPropertyFromCloudFormation(properties.StepFunctionsExecutionPolicy) : void 0), ret.addPropertyResult("vpcAccessPolicy", "VPCAccessPolicy", properties.VPCAccessPolicy != null ? CfnFunctionEmptySAMPTPropertyFromCloudFormation(properties.VPCAccessPolicy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_SNSEventPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("topic", cdk.requiredValidator)(properties.topic)), errors.collect(cdk.propertyValidator("topic", cdk.validateString)(properties.topic)), errors.wrap('supplied properties not correct for "SNSEventProperty"');
    }
    function cfnFunctionSNSEventPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_SNSEventPropertyValidator(properties).assertSuccess(), { Topic: cdk.stringToCloudFormation(properties.topic) }) : properties;
    }
    function CfnFunctionSNSEventPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("topic", "Topic", cfn_parse.FromCloudFormation.getString(properties.Topic)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_SQSEventPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("batchSize", cdk.validateNumber)(properties.batchSize)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("queue", cdk.requiredValidator)(properties.queue)), errors.collect(cdk.propertyValidator("queue", cdk.validateString)(properties.queue)), errors.wrap('supplied properties not correct for "SQSEventProperty"');
    }
    function cfnFunctionSQSEventPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_SQSEventPropertyValidator(properties).assertSuccess(), { BatchSize: cdk.numberToCloudFormation(properties.batchSize), Enabled: cdk.booleanToCloudFormation(properties.enabled), Queue: cdk.stringToCloudFormation(properties.queue) }) : properties;
    }
    function CfnFunctionSQSEventPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("batchSize", "BatchSize", properties.BatchSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.BatchSize) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("queue", "Queue", cfn_parse.FromCloudFormation.getString(properties.Queue)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_ScheduleEventPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("input", cdk.validateString)(properties.input)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("schedule", cdk.requiredValidator)(properties.schedule)), errors.collect(cdk.propertyValidator("schedule", cdk.validateString)(properties.schedule)), errors.wrap('supplied properties not correct for "ScheduleEventProperty"');
    }
    function cfnFunctionScheduleEventPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_ScheduleEventPropertyValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), Enabled: cdk.booleanToCloudFormation(properties.enabled), Input: cdk.stringToCloudFormation(properties.input), Name: cdk.stringToCloudFormation(properties.name), Schedule: cdk.stringToCloudFormation(properties.schedule) }) : properties;
    }
    function CfnFunctionScheduleEventPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("input", "Input", properties.Input != null ? cfn_parse.FromCloudFormation.getString(properties.Input) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("schedule", "Schedule", cfn_parse.FromCloudFormation.getString(properties.Schedule)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_SecretArnSAMPTPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("secretArn", cdk.requiredValidator)(properties.secretArn)), errors.collect(cdk.propertyValidator("secretArn", cdk.validateString)(properties.secretArn)), errors.wrap('supplied properties not correct for "SecretArnSAMPTProperty"');
    }
    function cfnFunctionSecretArnSAMPTPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_SecretArnSAMPTPropertyValidator(properties).assertSuccess(), { SecretArn: cdk.stringToCloudFormation(properties.secretArn) }) : properties;
    }
    function CfnFunctionSecretArnSAMPTPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("secretArn", "SecretArn", cfn_parse.FromCloudFormation.getString(properties.SecretArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_StateMachineSAMPTPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("stateMachineName", cdk.requiredValidator)(properties.stateMachineName)), errors.collect(cdk.propertyValidator("stateMachineName", cdk.validateString)(properties.stateMachineName)), errors.wrap('supplied properties not correct for "StateMachineSAMPTProperty"');
    }
    function cfnFunctionStateMachineSAMPTPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_StateMachineSAMPTPropertyValidator(properties).assertSuccess(), { StateMachineName: cdk.stringToCloudFormation(properties.stateMachineName) }) : properties;
    }
    function CfnFunctionStateMachineSAMPTPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("stateMachineName", "StateMachineName", cfn_parse.FromCloudFormation.getString(properties.StateMachineName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_StreamSAMPTPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("streamName", cdk.requiredValidator)(properties.streamName)), errors.collect(cdk.propertyValidator("streamName", cdk.validateString)(properties.streamName)), errors.wrap('supplied properties not correct for "StreamSAMPTProperty"');
    }
    function cfnFunctionStreamSAMPTPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_StreamSAMPTPropertyValidator(properties).assertSuccess(), { StreamName: cdk.stringToCloudFormation(properties.streamName) }) : properties;
    }
    function CfnFunctionStreamSAMPTPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("streamName", "StreamName", cfn_parse.FromCloudFormation.getString(properties.StreamName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_TableSAMPTPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("tableName", cdk.requiredValidator)(properties.tableName)), errors.collect(cdk.propertyValidator("tableName", cdk.validateString)(properties.tableName)), errors.wrap('supplied properties not correct for "TableSAMPTProperty"');
    }
    function cfnFunctionTableSAMPTPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_TableSAMPTPropertyValidator(properties).assertSuccess(), { TableName: cdk.stringToCloudFormation(properties.tableName) }) : properties;
    }
    function CfnFunctionTableSAMPTPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("tableName", "TableName", cfn_parse.FromCloudFormation.getString(properties.TableName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_TableStreamSAMPTPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("streamName", cdk.requiredValidator)(properties.streamName)), errors.collect(cdk.propertyValidator("streamName", cdk.validateString)(properties.streamName)), errors.collect(cdk.propertyValidator("tableName", cdk.requiredValidator)(properties.tableName)), errors.collect(cdk.propertyValidator("tableName", cdk.validateString)(properties.tableName)), errors.wrap('supplied properties not correct for "TableStreamSAMPTProperty"');
    }
    function cfnFunctionTableStreamSAMPTPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_TableStreamSAMPTPropertyValidator(properties).assertSuccess(), { StreamName: cdk.stringToCloudFormation(properties.streamName), TableName: cdk.stringToCloudFormation(properties.tableName) }) : properties;
    }
    function CfnFunctionTableStreamSAMPTPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("streamName", "StreamName", cfn_parse.FromCloudFormation.getString(properties.StreamName)), ret.addPropertyResult("tableName", "TableName", cfn_parse.FromCloudFormation.getString(properties.TableName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_TopicSAMPTPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("topicName", cdk.requiredValidator)(properties.topicName)), errors.collect(cdk.propertyValidator("topicName", cdk.validateString)(properties.topicName)), errors.wrap('supplied properties not correct for "TopicSAMPTProperty"');
    }
    function cfnFunctionTopicSAMPTPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_TopicSAMPTPropertyValidator(properties).assertSuccess(), { TopicName: cdk.stringToCloudFormation(properties.topicName) }) : properties;
    }
    function CfnFunctionTopicSAMPTPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("topicName", "TopicName", cfn_parse.FromCloudFormation.getString(properties.TopicName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_VpcConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.requiredValidator)(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.requiredValidator)(properties.subnetIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.wrap('supplied properties not correct for "VpcConfigProperty"');
    }
    function cfnFunctionVpcConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_VpcConfigPropertyValidator(properties).assertSuccess(), { SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds) }) : properties;
    }
    function CfnFunctionVpcConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds)), ret.addPropertyResult("subnetIds", "SubnetIds", cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnHttpApiPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessLogSetting", CfnHttpApi_AccessLogSettingPropertyValidator)(properties.accessLogSetting)), errors.collect(cdk.propertyValidator("auth", CfnHttpApi_HttpApiAuthPropertyValidator)(properties.auth)), errors.collect(cdk.propertyValidator("corsConfiguration", cdk.unionValidator(CfnHttpApi_CorsConfigurationObjectPropertyValidator, cdk.validateBoolean))(properties.corsConfiguration)), errors.collect(cdk.propertyValidator("defaultRouteSettings", CfnHttpApi_RouteSettingsPropertyValidator)(properties.defaultRouteSettings)), errors.collect(cdk.propertyValidator("definitionBody", cdk.validateObject)(properties.definitionBody)), errors.collect(cdk.propertyValidator("definitionUri", cdk.unionValidator(CfnHttpApi_S3LocationPropertyValidator, cdk.validateString))(properties.definitionUri)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("disableExecuteApiEndpoint", cdk.validateBoolean)(properties.disableExecuteApiEndpoint)), errors.collect(cdk.propertyValidator("domain", CfnHttpApi_HttpApiDomainConfigurationPropertyValidator)(properties.domain)), errors.collect(cdk.propertyValidator("failOnWarnings", cdk.validateBoolean)(properties.failOnWarnings)), errors.collect(cdk.propertyValidator("routeSettings", CfnHttpApi_RouteSettingsPropertyValidator)(properties.routeSettings)), errors.collect(cdk.propertyValidator("stageName", cdk.validateString)(properties.stageName)), errors.collect(cdk.propertyValidator("stageVariables", cdk.hashValidator(cdk.validateString))(properties.stageVariables)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.wrap('supplied properties not correct for "CfnHttpApiProps"');
    }
    function cfnHttpApiPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHttpApiPropsValidator(properties).assertSuccess(), { AccessLogSetting: cfnHttpApiAccessLogSettingPropertyToCloudFormation(properties.accessLogSetting), Auth: cfnHttpApiHttpApiAuthPropertyToCloudFormation(properties.auth), CorsConfiguration: cdk.unionMapper([CfnHttpApi_CorsConfigurationObjectPropertyValidator, cdk.validateBoolean], [cfnHttpApiCorsConfigurationObjectPropertyToCloudFormation, cdk.booleanToCloudFormation])(properties.corsConfiguration), DefaultRouteSettings: cfnHttpApiRouteSettingsPropertyToCloudFormation(properties.defaultRouteSettings), DefinitionBody: cdk.objectToCloudFormation(properties.definitionBody), DefinitionUri: cdk.unionMapper([CfnHttpApi_S3LocationPropertyValidator, cdk.validateString], [cfnHttpApiS3LocationPropertyToCloudFormation, cdk.stringToCloudFormation])(properties.definitionUri), Description: cdk.stringToCloudFormation(properties.description), DisableExecuteApiEndpoint: cdk.booleanToCloudFormation(properties.disableExecuteApiEndpoint), Domain: cfnHttpApiHttpApiDomainConfigurationPropertyToCloudFormation(properties.domain), FailOnWarnings: cdk.booleanToCloudFormation(properties.failOnWarnings), RouteSettings: cfnHttpApiRouteSettingsPropertyToCloudFormation(properties.routeSettings), StageName: cdk.stringToCloudFormation(properties.stageName), StageVariables: cdk.hashMapper(cdk.stringToCloudFormation)(properties.stageVariables), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnHttpApiPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessLogSetting", "AccessLogSetting", properties.AccessLogSetting != null ? CfnHttpApiAccessLogSettingPropertyFromCloudFormation(properties.AccessLogSetting) : void 0), ret.addPropertyResult("auth", "Auth", properties.Auth != null ? CfnHttpApiHttpApiAuthPropertyFromCloudFormation(properties.Auth) : void 0), ret.addPropertyResult("corsConfiguration", "CorsConfiguration", properties.CorsConfiguration != null ? cfn_parse.FromCloudFormation.getTypeUnion([CfnHttpApi_CorsConfigurationObjectPropertyValidator, cdk.validateBoolean], [CfnHttpApiCorsConfigurationObjectPropertyFromCloudFormation, cfn_parse.FromCloudFormation.getBoolean])(properties.CorsConfiguration) : void 0), ret.addPropertyResult("defaultRouteSettings", "DefaultRouteSettings", properties.DefaultRouteSettings != null ? CfnHttpApiRouteSettingsPropertyFromCloudFormation(properties.DefaultRouteSettings) : void 0), ret.addPropertyResult("definitionBody", "DefinitionBody", properties.DefinitionBody != null ? cfn_parse.FromCloudFormation.getAny(properties.DefinitionBody) : void 0), ret.addPropertyResult("definitionUri", "DefinitionUri", properties.DefinitionUri != null ? cfn_parse.FromCloudFormation.getTypeUnion([CfnHttpApi_S3LocationPropertyValidator, cdk.validateString], [CfnHttpApiS3LocationPropertyFromCloudFormation, cfn_parse.FromCloudFormation.getString])(properties.DefinitionUri) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("disableExecuteApiEndpoint", "DisableExecuteApiEndpoint", properties.DisableExecuteApiEndpoint != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DisableExecuteApiEndpoint) : void 0), ret.addPropertyResult("domain", "Domain", properties.Domain != null ? CfnHttpApiHttpApiDomainConfigurationPropertyFromCloudFormation(properties.Domain) : void 0), ret.addPropertyResult("failOnWarnings", "FailOnWarnings", properties.FailOnWarnings != null ? cfn_parse.FromCloudFormation.getBoolean(properties.FailOnWarnings) : void 0), ret.addPropertyResult("routeSettings", "RouteSettings", properties.RouteSettings != null ? CfnHttpApiRouteSettingsPropertyFromCloudFormation(properties.RouteSettings) : void 0), ret.addPropertyResult("stageName", "StageName", properties.StageName != null ? cfn_parse.FromCloudFormation.getString(properties.StageName) : void 0), ret.addPropertyResult("stageVariables", "StageVariables", properties.StageVariables != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.StageVariables) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnHttpApi = class _CfnHttpApi extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnHttpApiPropsFromCloudFormation(resourceProperties), ret = new _CfnHttpApi(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnHttpApi.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sam_CfnHttpApiProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnHttpApi), error;
        }
        this.stack.addTransform(_CfnHttpApi.REQUIRED_TRANSFORM), this.accessLogSetting = props.accessLogSetting, this.auth = props.auth, this.corsConfiguration = props.corsConfiguration, this.defaultRouteSettings = props.defaultRouteSettings, this.definitionBody = props.definitionBody, this.definitionUri = props.definitionUri, this.description = props.description, this.disableExecuteApiEndpoint = props.disableExecuteApiEndpoint, this.domain = props.domain, this.failOnWarnings = props.failOnWarnings, this.routeSettings = props.routeSettings, this.stageName = props.stageName, this.stageVariables = props.stageVariables, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Serverless::HttpApi", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnHttpApi.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { accessLogSetting: this.accessLogSetting, auth: this.auth, corsConfiguration: this.corsConfiguration, defaultRouteSettings: this.defaultRouteSettings, definitionBody: this.definitionBody, definitionUri: this.definitionUri, description: this.description, disableExecuteApiEndpoint: this.disableExecuteApiEndpoint, domain: this.domain, failOnWarnings: this.failOnWarnings, routeSettings: this.routeSettings, stageName: this.stageName, stageVariables: this.stageVariables, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnHttpApiPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnHttpApi[_d] = { fqn: "aws-cdk-lib.aws_sam.CfnHttpApi", version: "2.80.0" }, CfnHttpApi.CFN_RESOURCE_TYPE_NAME = "AWS::Serverless::HttpApi", CfnHttpApi.REQUIRED_TRANSFORM = "AWS::Serverless-2016-10-31", exports2.CfnHttpApi = CfnHttpApi;
    function CfnHttpApi_AccessLogSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationArn", cdk.validateString)(properties.destinationArn)), errors.collect(cdk.propertyValidator("format", cdk.validateString)(properties.format)), errors.wrap('supplied properties not correct for "AccessLogSettingProperty"');
    }
    function cfnHttpApiAccessLogSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHttpApi_AccessLogSettingPropertyValidator(properties).assertSuccess(), { DestinationArn: cdk.stringToCloudFormation(properties.destinationArn), Format: cdk.stringToCloudFormation(properties.format) }) : properties;
    }
    function CfnHttpApiAccessLogSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationArn", "DestinationArn", properties.DestinationArn != null ? cfn_parse.FromCloudFormation.getString(properties.DestinationArn) : void 0), ret.addPropertyResult("format", "Format", properties.Format != null ? cfn_parse.FromCloudFormation.getString(properties.Format) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnHttpApi_CorsConfigurationObjectPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowCredentials", cdk.validateBoolean)(properties.allowCredentials)), errors.collect(cdk.propertyValidator("allowHeaders", cdk.listValidator(cdk.validateString))(properties.allowHeaders)), errors.collect(cdk.propertyValidator("allowMethods", cdk.listValidator(cdk.validateString))(properties.allowMethods)), errors.collect(cdk.propertyValidator("allowOrigins", cdk.listValidator(cdk.validateString))(properties.allowOrigins)), errors.collect(cdk.propertyValidator("exposeHeaders", cdk.listValidator(cdk.validateString))(properties.exposeHeaders)), errors.collect(cdk.propertyValidator("maxAge", cdk.validateNumber)(properties.maxAge)), errors.wrap('supplied properties not correct for "CorsConfigurationObjectProperty"');
    }
    function cfnHttpApiCorsConfigurationObjectPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHttpApi_CorsConfigurationObjectPropertyValidator(properties).assertSuccess(), { AllowCredentials: cdk.booleanToCloudFormation(properties.allowCredentials), AllowHeaders: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowHeaders), AllowMethods: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowMethods), AllowOrigins: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowOrigins), ExposeHeaders: cdk.listMapper(cdk.stringToCloudFormation)(properties.exposeHeaders), MaxAge: cdk.numberToCloudFormation(properties.maxAge) }) : properties;
    }
    function CfnHttpApiCorsConfigurationObjectPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowCredentials", "AllowCredentials", properties.AllowCredentials != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllowCredentials) : void 0), ret.addPropertyResult("allowHeaders", "AllowHeaders", properties.AllowHeaders != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AllowHeaders) : void 0), ret.addPropertyResult("allowMethods", "AllowMethods", properties.AllowMethods != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AllowMethods) : void 0), ret.addPropertyResult("allowOrigins", "AllowOrigins", properties.AllowOrigins != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AllowOrigins) : void 0), ret.addPropertyResult("exposeHeaders", "ExposeHeaders", properties.ExposeHeaders != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExposeHeaders) : void 0), ret.addPropertyResult("maxAge", "MaxAge", properties.MaxAge != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxAge) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnHttpApi_HttpApiAuthPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authorizers", cdk.validateObject)(properties.authorizers)), errors.collect(cdk.propertyValidator("defaultAuthorizer", cdk.validateString)(properties.defaultAuthorizer)), errors.wrap('supplied properties not correct for "HttpApiAuthProperty"');
    }
    function cfnHttpApiHttpApiAuthPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHttpApi_HttpApiAuthPropertyValidator(properties).assertSuccess(), { Authorizers: cdk.objectToCloudFormation(properties.authorizers), DefaultAuthorizer: cdk.stringToCloudFormation(properties.defaultAuthorizer) }) : properties;
    }
    function CfnHttpApiHttpApiAuthPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authorizers", "Authorizers", properties.Authorizers != null ? cfn_parse.FromCloudFormation.getAny(properties.Authorizers) : void 0), ret.addPropertyResult("defaultAuthorizer", "DefaultAuthorizer", properties.DefaultAuthorizer != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultAuthorizer) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnHttpApi_HttpApiDomainConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("basePath", cdk.validateString)(properties.basePath)), errors.collect(cdk.propertyValidator("certificateArn", cdk.requiredValidator)(properties.certificateArn)), errors.collect(cdk.propertyValidator("certificateArn", cdk.validateString)(properties.certificateArn)), errors.collect(cdk.propertyValidator("domainName", cdk.requiredValidator)(properties.domainName)), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.collect(cdk.propertyValidator("endpointConfiguration", cdk.validateString)(properties.endpointConfiguration)), errors.collect(cdk.propertyValidator("mutualTlsAuthentication", CfnHttpApi_MutualTlsAuthenticationPropertyValidator)(properties.mutualTlsAuthentication)), errors.collect(cdk.propertyValidator("route53", CfnHttpApi_Route53ConfigurationPropertyValidator)(properties.route53)), errors.collect(cdk.propertyValidator("securityPolicy", cdk.validateString)(properties.securityPolicy)), errors.wrap('supplied properties not correct for "HttpApiDomainConfigurationProperty"');
    }
    function cfnHttpApiHttpApiDomainConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHttpApi_HttpApiDomainConfigurationPropertyValidator(properties).assertSuccess(), { BasePath: cdk.stringToCloudFormation(properties.basePath), CertificateArn: cdk.stringToCloudFormation(properties.certificateArn), DomainName: cdk.stringToCloudFormation(properties.domainName), EndpointConfiguration: cdk.stringToCloudFormation(properties.endpointConfiguration), MutualTlsAuthentication: cfnHttpApiMutualTlsAuthenticationPropertyToCloudFormation(properties.mutualTlsAuthentication), Route53: cfnHttpApiRoute53ConfigurationPropertyToCloudFormation(properties.route53), SecurityPolicy: cdk.stringToCloudFormation(properties.securityPolicy) }) : properties;
    }
    function CfnHttpApiHttpApiDomainConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("basePath", "BasePath", properties.BasePath != null ? cfn_parse.FromCloudFormation.getString(properties.BasePath) : void 0), ret.addPropertyResult("certificateArn", "CertificateArn", cfn_parse.FromCloudFormation.getString(properties.CertificateArn)), ret.addPropertyResult("domainName", "DomainName", cfn_parse.FromCloudFormation.getString(properties.DomainName)), ret.addPropertyResult("endpointConfiguration", "EndpointConfiguration", properties.EndpointConfiguration != null ? cfn_parse.FromCloudFormation.getString(properties.EndpointConfiguration) : void 0), ret.addPropertyResult("mutualTlsAuthentication", "MutualTlsAuthentication", properties.MutualTlsAuthentication != null ? CfnHttpApiMutualTlsAuthenticationPropertyFromCloudFormation(properties.MutualTlsAuthentication) : void 0), ret.addPropertyResult("route53", "Route53", properties.Route53 != null ? CfnHttpApiRoute53ConfigurationPropertyFromCloudFormation(properties.Route53) : void 0), ret.addPropertyResult("securityPolicy", "SecurityPolicy", properties.SecurityPolicy != null ? cfn_parse.FromCloudFormation.getString(properties.SecurityPolicy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnHttpApi_MutualTlsAuthenticationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("truststoreUri", cdk.validateString)(properties.truststoreUri)), errors.collect(cdk.propertyValidator("truststoreVersion", cdk.validateBoolean)(properties.truststoreVersion)), errors.wrap('supplied properties not correct for "MutualTlsAuthenticationProperty"');
    }
    function cfnHttpApiMutualTlsAuthenticationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHttpApi_MutualTlsAuthenticationPropertyValidator(properties).assertSuccess(), { TruststoreUri: cdk.stringToCloudFormation(properties.truststoreUri), TruststoreVersion: cdk.booleanToCloudFormation(properties.truststoreVersion) }) : properties;
    }
    function CfnHttpApiMutualTlsAuthenticationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("truststoreUri", "TruststoreUri", properties.TruststoreUri != null ? cfn_parse.FromCloudFormation.getString(properties.TruststoreUri) : void 0), ret.addPropertyResult("truststoreVersion", "TruststoreVersion", properties.TruststoreVersion != null ? cfn_parse.FromCloudFormation.getBoolean(properties.TruststoreVersion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnHttpApi_Route53ConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("distributedDomainName", cdk.validateString)(properties.distributedDomainName)), errors.collect(cdk.propertyValidator("evaluateTargetHealth", cdk.validateBoolean)(properties.evaluateTargetHealth)), errors.collect(cdk.propertyValidator("hostedZoneId", cdk.validateString)(properties.hostedZoneId)), errors.collect(cdk.propertyValidator("hostedZoneName", cdk.validateString)(properties.hostedZoneName)), errors.collect(cdk.propertyValidator("ipV6", cdk.validateBoolean)(properties.ipV6)), errors.wrap('supplied properties not correct for "Route53ConfigurationProperty"');
    }
    function cfnHttpApiRoute53ConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHttpApi_Route53ConfigurationPropertyValidator(properties).assertSuccess(), { DistributedDomainName: cdk.stringToCloudFormation(properties.distributedDomainName), EvaluateTargetHealth: cdk.booleanToCloudFormation(properties.evaluateTargetHealth), HostedZoneId: cdk.stringToCloudFormation(properties.hostedZoneId), HostedZoneName: cdk.stringToCloudFormation(properties.hostedZoneName), IpV6: cdk.booleanToCloudFormation(properties.ipV6) }) : properties;
    }
    function CfnHttpApiRoute53ConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("distributedDomainName", "DistributedDomainName", properties.DistributedDomainName != null ? cfn_parse.FromCloudFormation.getString(properties.DistributedDomainName) : void 0), ret.addPropertyResult("evaluateTargetHealth", "EvaluateTargetHealth", properties.EvaluateTargetHealth != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EvaluateTargetHealth) : void 0), ret.addPropertyResult("hostedZoneId", "HostedZoneId", properties.HostedZoneId != null ? cfn_parse.FromCloudFormation.getString(properties.HostedZoneId) : void 0), ret.addPropertyResult("hostedZoneName", "HostedZoneName", properties.HostedZoneName != null ? cfn_parse.FromCloudFormation.getString(properties.HostedZoneName) : void 0), ret.addPropertyResult("ipV6", "IpV6", properties.IpV6 != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IpV6) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnHttpApi_RouteSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataTraceEnabled", cdk.validateBoolean)(properties.dataTraceEnabled)), errors.collect(cdk.propertyValidator("detailedMetricsEnabled", cdk.validateBoolean)(properties.detailedMetricsEnabled)), errors.collect(cdk.propertyValidator("loggingLevel", cdk.validateString)(properties.loggingLevel)), errors.collect(cdk.propertyValidator("throttlingBurstLimit", cdk.validateNumber)(properties.throttlingBurstLimit)), errors.collect(cdk.propertyValidator("throttlingRateLimit", cdk.validateNumber)(properties.throttlingRateLimit)), errors.wrap('supplied properties not correct for "RouteSettingsProperty"');
    }
    function cfnHttpApiRouteSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHttpApi_RouteSettingsPropertyValidator(properties).assertSuccess(), { DataTraceEnabled: cdk.booleanToCloudFormation(properties.dataTraceEnabled), DetailedMetricsEnabled: cdk.booleanToCloudFormation(properties.detailedMetricsEnabled), LoggingLevel: cdk.stringToCloudFormation(properties.loggingLevel), ThrottlingBurstLimit: cdk.numberToCloudFormation(properties.throttlingBurstLimit), ThrottlingRateLimit: cdk.numberToCloudFormation(properties.throttlingRateLimit) }) : properties;
    }
    function CfnHttpApiRouteSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataTraceEnabled", "DataTraceEnabled", properties.DataTraceEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DataTraceEnabled) : void 0), ret.addPropertyResult("detailedMetricsEnabled", "DetailedMetricsEnabled", properties.DetailedMetricsEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DetailedMetricsEnabled) : void 0), ret.addPropertyResult("loggingLevel", "LoggingLevel", properties.LoggingLevel != null ? cfn_parse.FromCloudFormation.getString(properties.LoggingLevel) : void 0), ret.addPropertyResult("throttlingBurstLimit", "ThrottlingBurstLimit", properties.ThrottlingBurstLimit != null ? cfn_parse.FromCloudFormation.getNumber(properties.ThrottlingBurstLimit) : void 0), ret.addPropertyResult("throttlingRateLimit", "ThrottlingRateLimit", properties.ThrottlingRateLimit != null ? cfn_parse.FromCloudFormation.getNumber(properties.ThrottlingRateLimit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnHttpApi_S3LocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.requiredValidator)(properties.bucket)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("version", cdk.requiredValidator)(properties.version)), errors.collect(cdk.propertyValidator("version", cdk.validateNumber)(properties.version)), errors.wrap('supplied properties not correct for "S3LocationProperty"');
    }
    function cfnHttpApiS3LocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHttpApi_S3LocationPropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), Key: cdk.stringToCloudFormation(properties.key), Version: cdk.numberToCloudFormation(properties.version) }) : properties;
    }
    function CfnHttpApiS3LocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", cfn_parse.FromCloudFormation.getString(properties.Bucket)), ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("version", "Version", cfn_parse.FromCloudFormation.getNumber(properties.Version)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLayerVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("compatibleRuntimes", cdk.listValidator(cdk.validateString))(properties.compatibleRuntimes)), errors.collect(cdk.propertyValidator("contentUri", cdk.unionValidator(CfnLayerVersion_S3LocationPropertyValidator, cdk.validateString))(properties.contentUri)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("layerName", cdk.validateString)(properties.layerName)), errors.collect(cdk.propertyValidator("licenseInfo", cdk.validateString)(properties.licenseInfo)), errors.collect(cdk.propertyValidator("retentionPolicy", cdk.validateString)(properties.retentionPolicy)), errors.wrap('supplied properties not correct for "CfnLayerVersionProps"');
    }
    function cfnLayerVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLayerVersionPropsValidator(properties).assertSuccess(), { CompatibleRuntimes: cdk.listMapper(cdk.stringToCloudFormation)(properties.compatibleRuntimes), ContentUri: cdk.unionMapper([CfnLayerVersion_S3LocationPropertyValidator, cdk.validateString], [cfnLayerVersionS3LocationPropertyToCloudFormation, cdk.stringToCloudFormation])(properties.contentUri), Description: cdk.stringToCloudFormation(properties.description), LayerName: cdk.stringToCloudFormation(properties.layerName), LicenseInfo: cdk.stringToCloudFormation(properties.licenseInfo), RetentionPolicy: cdk.stringToCloudFormation(properties.retentionPolicy) }) : properties;
    }
    function CfnLayerVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("compatibleRuntimes", "CompatibleRuntimes", properties.CompatibleRuntimes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CompatibleRuntimes) : void 0), ret.addPropertyResult("contentUri", "ContentUri", properties.ContentUri != null ? cfn_parse.FromCloudFormation.getTypeUnion([CfnLayerVersion_S3LocationPropertyValidator, cdk.validateString], [CfnLayerVersionS3LocationPropertyFromCloudFormation, cfn_parse.FromCloudFormation.getString])(properties.ContentUri) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("layerName", "LayerName", properties.LayerName != null ? cfn_parse.FromCloudFormation.getString(properties.LayerName) : void 0), ret.addPropertyResult("licenseInfo", "LicenseInfo", properties.LicenseInfo != null ? cfn_parse.FromCloudFormation.getString(properties.LicenseInfo) : void 0), ret.addPropertyResult("retentionPolicy", "RetentionPolicy", properties.RetentionPolicy != null ? cfn_parse.FromCloudFormation.getString(properties.RetentionPolicy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLayerVersion = class _CfnLayerVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLayerVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnLayerVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnLayerVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sam_CfnLayerVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLayerVersion), error;
        }
        this.stack.addTransform(_CfnLayerVersion.REQUIRED_TRANSFORM), this.compatibleRuntimes = props.compatibleRuntimes, this.contentUri = props.contentUri, this.description = props.description, this.layerName = props.layerName, this.licenseInfo = props.licenseInfo, this.retentionPolicy = props.retentionPolicy;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLayerVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { compatibleRuntimes: this.compatibleRuntimes, contentUri: this.contentUri, description: this.description, layerName: this.layerName, licenseInfo: this.licenseInfo, retentionPolicy: this.retentionPolicy };
      }
      renderProperties(props) {
        return cfnLayerVersionPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnLayerVersion[_e] = { fqn: "aws-cdk-lib.aws_sam.CfnLayerVersion", version: "2.80.0" }, CfnLayerVersion.CFN_RESOURCE_TYPE_NAME = "AWS::Serverless::LayerVersion", CfnLayerVersion.REQUIRED_TRANSFORM = "AWS::Serverless-2016-10-31", exports2.CfnLayerVersion = CfnLayerVersion;
    function CfnLayerVersion_S3LocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.requiredValidator)(properties.bucket)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("version", cdk.validateNumber)(properties.version)), errors.wrap('supplied properties not correct for "S3LocationProperty"');
    }
    function cfnLayerVersionS3LocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLayerVersion_S3LocationPropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), Key: cdk.stringToCloudFormation(properties.key), Version: cdk.numberToCloudFormation(properties.version) }) : properties;
    }
    function CfnLayerVersionS3LocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", cfn_parse.FromCloudFormation.getString(properties.Bucket)), ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getNumber(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSimpleTablePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("primaryKey", CfnSimpleTable_PrimaryKeyPropertyValidator)(properties.primaryKey)), errors.collect(cdk.propertyValidator("provisionedThroughput", CfnSimpleTable_ProvisionedThroughputPropertyValidator)(properties.provisionedThroughput)), errors.collect(cdk.propertyValidator("sseSpecification", CfnSimpleTable_SSESpecificationPropertyValidator)(properties.sseSpecification)), errors.collect(cdk.propertyValidator("tableName", cdk.validateString)(properties.tableName)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.wrap('supplied properties not correct for "CfnSimpleTableProps"');
    }
    function cfnSimpleTablePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSimpleTablePropsValidator(properties).assertSuccess(), { PrimaryKey: cfnSimpleTablePrimaryKeyPropertyToCloudFormation(properties.primaryKey), ProvisionedThroughput: cfnSimpleTableProvisionedThroughputPropertyToCloudFormation(properties.provisionedThroughput), SSESpecification: cfnSimpleTableSSESpecificationPropertyToCloudFormation(properties.sseSpecification), TableName: cdk.stringToCloudFormation(properties.tableName), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnSimpleTablePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("primaryKey", "PrimaryKey", properties.PrimaryKey != null ? CfnSimpleTablePrimaryKeyPropertyFromCloudFormation(properties.PrimaryKey) : void 0), ret.addPropertyResult("provisionedThroughput", "ProvisionedThroughput", properties.ProvisionedThroughput != null ? CfnSimpleTableProvisionedThroughputPropertyFromCloudFormation(properties.ProvisionedThroughput) : void 0), ret.addPropertyResult("sseSpecification", "SSESpecification", properties.SSESpecification != null ? CfnSimpleTableSSESpecificationPropertyFromCloudFormation(properties.SSESpecification) : void 0), ret.addPropertyResult("tableName", "TableName", properties.TableName != null ? cfn_parse.FromCloudFormation.getString(properties.TableName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSimpleTable = class _CfnSimpleTable extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSimpleTablePropsFromCloudFormation(resourceProperties), ret = new _CfnSimpleTable(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnSimpleTable.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sam_CfnSimpleTableProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSimpleTable), error;
        }
        this.stack.addTransform(_CfnSimpleTable.REQUIRED_TRANSFORM), this.primaryKey = props.primaryKey, this.provisionedThroughput = props.provisionedThroughput, this.sseSpecification = props.sseSpecification, this.tableName = props.tableName, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Serverless::SimpleTable", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSimpleTable.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { primaryKey: this.primaryKey, provisionedThroughput: this.provisionedThroughput, sseSpecification: this.sseSpecification, tableName: this.tableName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnSimpleTablePropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnSimpleTable[_f] = { fqn: "aws-cdk-lib.aws_sam.CfnSimpleTable", version: "2.80.0" }, CfnSimpleTable.CFN_RESOURCE_TYPE_NAME = "AWS::Serverless::SimpleTable", CfnSimpleTable.REQUIRED_TRANSFORM = "AWS::Serverless-2016-10-31", exports2.CfnSimpleTable = CfnSimpleTable;
    function CfnSimpleTable_PrimaryKeyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "PrimaryKeyProperty"');
    }
    function cfnSimpleTablePrimaryKeyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSimpleTable_PrimaryKeyPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnSimpleTablePrimaryKeyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSimpleTable_ProvisionedThroughputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("readCapacityUnits", cdk.validateNumber)(properties.readCapacityUnits)), errors.collect(cdk.propertyValidator("writeCapacityUnits", cdk.requiredValidator)(properties.writeCapacityUnits)), errors.collect(cdk.propertyValidator("writeCapacityUnits", cdk.validateNumber)(properties.writeCapacityUnits)), errors.wrap('supplied properties not correct for "ProvisionedThroughputProperty"');
    }
    function cfnSimpleTableProvisionedThroughputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSimpleTable_ProvisionedThroughputPropertyValidator(properties).assertSuccess(), { ReadCapacityUnits: cdk.numberToCloudFormation(properties.readCapacityUnits), WriteCapacityUnits: cdk.numberToCloudFormation(properties.writeCapacityUnits) }) : properties;
    }
    function CfnSimpleTableProvisionedThroughputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("readCapacityUnits", "ReadCapacityUnits", properties.ReadCapacityUnits != null ? cfn_parse.FromCloudFormation.getNumber(properties.ReadCapacityUnits) : void 0), ret.addPropertyResult("writeCapacityUnits", "WriteCapacityUnits", cfn_parse.FromCloudFormation.getNumber(properties.WriteCapacityUnits)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSimpleTable_SSESpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sseEnabled", cdk.validateBoolean)(properties.sseEnabled)), errors.wrap('supplied properties not correct for "SSESpecificationProperty"');
    }
    function cfnSimpleTableSSESpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSimpleTable_SSESpecificationPropertyValidator(properties).assertSuccess(), { SSEEnabled: cdk.booleanToCloudFormation(properties.sseEnabled) }) : properties;
    }
    function CfnSimpleTableSSESpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sseEnabled", "SSEEnabled", properties.SSEEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SSEEnabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStateMachinePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("definition", cdk.validateObject)(properties.definition)), errors.collect(cdk.propertyValidator("definitionSubstitutions", cdk.hashValidator(cdk.validateString))(properties.definitionSubstitutions)), errors.collect(cdk.propertyValidator("definitionUri", cdk.unionValidator(CfnStateMachine_S3LocationPropertyValidator, cdk.validateString))(properties.definitionUri)), errors.collect(cdk.propertyValidator("events", cdk.hashValidator(CfnStateMachine_EventSourcePropertyValidator))(properties.events)), errors.collect(cdk.propertyValidator("logging", CfnStateMachine_LoggingConfigurationPropertyValidator)(properties.logging)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("permissionsBoundaries", cdk.validateString)(properties.permissionsBoundaries)), errors.collect(cdk.propertyValidator("policies", cdk.unionValidator(cdk.unionValidator(CfnStateMachine_IAMPolicyDocumentPropertyValidator, cdk.validateString), cdk.listValidator(cdk.unionValidator(CfnStateMachine_IAMPolicyDocumentPropertyValidator, CfnStateMachine_SAMPolicyTemplatePropertyValidator, cdk.validateString))))(properties.policies)), errors.collect(cdk.propertyValidator("role", cdk.validateString)(properties.role)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.collect(cdk.propertyValidator("tracing", CfnStateMachine_TracingConfigurationPropertyValidator)(properties.tracing)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnStateMachineProps"');
    }
    function cfnStateMachinePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStateMachinePropsValidator(properties).assertSuccess(), { Definition: cdk.objectToCloudFormation(properties.definition), DefinitionSubstitutions: cdk.hashMapper(cdk.stringToCloudFormation)(properties.definitionSubstitutions), DefinitionUri: cdk.unionMapper([CfnStateMachine_S3LocationPropertyValidator, cdk.validateString], [cfnStateMachineS3LocationPropertyToCloudFormation, cdk.stringToCloudFormation])(properties.definitionUri), Events: cdk.hashMapper(cfnStateMachineEventSourcePropertyToCloudFormation)(properties.events), Logging: cfnStateMachineLoggingConfigurationPropertyToCloudFormation(properties.logging), Name: cdk.stringToCloudFormation(properties.name), PermissionsBoundaries: cdk.stringToCloudFormation(properties.permissionsBoundaries), Policies: cdk.unionMapper([cdk.unionValidator(CfnStateMachine_IAMPolicyDocumentPropertyValidator, cdk.validateString), cdk.listValidator(cdk.unionValidator(CfnStateMachine_IAMPolicyDocumentPropertyValidator, CfnStateMachine_SAMPolicyTemplatePropertyValidator, cdk.validateString))], [cdk.unionMapper([CfnStateMachine_IAMPolicyDocumentPropertyValidator, cdk.validateString], [cfnStateMachineIAMPolicyDocumentPropertyToCloudFormation, cdk.stringToCloudFormation]), cdk.listMapper(cdk.unionMapper([CfnStateMachine_IAMPolicyDocumentPropertyValidator, CfnStateMachine_SAMPolicyTemplatePropertyValidator, cdk.validateString], [cfnStateMachineIAMPolicyDocumentPropertyToCloudFormation, cfnStateMachineSAMPolicyTemplatePropertyToCloudFormation, cdk.stringToCloudFormation]))])(properties.policies), Role: cdk.stringToCloudFormation(properties.role), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags), Tracing: cfnStateMachineTracingConfigurationPropertyToCloudFormation(properties.tracing), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnStateMachinePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("definition", "Definition", properties.Definition != null ? cfn_parse.FromCloudFormation.getAny(properties.Definition) : void 0), ret.addPropertyResult("definitionSubstitutions", "DefinitionSubstitutions", properties.DefinitionSubstitutions != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.DefinitionSubstitutions) : void 0), ret.addPropertyResult("definitionUri", "DefinitionUri", properties.DefinitionUri != null ? cfn_parse.FromCloudFormation.getTypeUnion([CfnStateMachine_S3LocationPropertyValidator, cdk.validateString], [CfnStateMachineS3LocationPropertyFromCloudFormation, cfn_parse.FromCloudFormation.getString])(properties.DefinitionUri) : void 0), ret.addPropertyResult("events", "Events", properties.Events != null ? cfn_parse.FromCloudFormation.getMap(CfnStateMachineEventSourcePropertyFromCloudFormation)(properties.Events) : void 0), ret.addPropertyResult("logging", "Logging", properties.Logging != null ? CfnStateMachineLoggingConfigurationPropertyFromCloudFormation(properties.Logging) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("permissionsBoundaries", "PermissionsBoundaries", properties.PermissionsBoundaries != null ? cfn_parse.FromCloudFormation.getString(properties.PermissionsBoundaries) : void 0), ret.addPropertyResult("policies", "Policies", properties.Policies != null ? cfn_parse.FromCloudFormation.getTypeUnion([cdk.unionValidator(CfnStateMachine_IAMPolicyDocumentPropertyValidator, cdk.validateString), cdk.listValidator(cdk.unionValidator(CfnStateMachine_IAMPolicyDocumentPropertyValidator, CfnStateMachine_SAMPolicyTemplatePropertyValidator, cdk.validateString))], [cfn_parse.FromCloudFormation.getTypeUnion([CfnStateMachine_IAMPolicyDocumentPropertyValidator, cdk.validateString], [CfnStateMachineIAMPolicyDocumentPropertyFromCloudFormation, cfn_parse.FromCloudFormation.getString]), cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getTypeUnion([CfnStateMachine_IAMPolicyDocumentPropertyValidator, CfnStateMachine_SAMPolicyTemplatePropertyValidator, cdk.validateString], [CfnStateMachineIAMPolicyDocumentPropertyFromCloudFormation, CfnStateMachineSAMPolicyTemplatePropertyFromCloudFormation, cfn_parse.FromCloudFormation.getString]))])(properties.Policies) : void 0), ret.addPropertyResult("role", "Role", properties.Role != null ? cfn_parse.FromCloudFormation.getString(properties.Role) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addPropertyResult("tracing", "Tracing", properties.Tracing != null ? CfnStateMachineTracingConfigurationPropertyFromCloudFormation(properties.Tracing) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnStateMachine = class _CfnStateMachine extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnStateMachinePropsFromCloudFormation(resourceProperties), ret = new _CfnStateMachine(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnStateMachine.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sam_CfnStateMachineProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnStateMachine), error;
        }
        this.stack.addTransform(_CfnStateMachine.REQUIRED_TRANSFORM), this.definition = props.definition, this.definitionSubstitutions = props.definitionSubstitutions, this.definitionUri = props.definitionUri, this.events = props.events, this.logging = props.logging, this.name = props.name, this.permissionsBoundaries = props.permissionsBoundaries, this.policies = props.policies, this.role = props.role, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Serverless::StateMachine", props.tags, { tagPropertyName: "tags" }), this.tracing = props.tracing, this.type = props.type;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStateMachine.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { definition: this.definition, definitionSubstitutions: this.definitionSubstitutions, definitionUri: this.definitionUri, events: this.events, logging: this.logging, name: this.name, permissionsBoundaries: this.permissionsBoundaries, policies: this.policies, role: this.role, tags: this.tags.renderTags(), tracing: this.tracing, type: this.type };
      }
      renderProperties(props) {
        return cfnStateMachinePropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnStateMachine[_g] = { fqn: "aws-cdk-lib.aws_sam.CfnStateMachine", version: "2.80.0" }, CfnStateMachine.CFN_RESOURCE_TYPE_NAME = "AWS::Serverless::StateMachine", CfnStateMachine.REQUIRED_TRANSFORM = "AWS::Serverless-2016-10-31", exports2.CfnStateMachine = CfnStateMachine;
    function CfnStateMachine_ApiEventPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("method", cdk.requiredValidator)(properties.method)), errors.collect(cdk.propertyValidator("method", cdk.validateString)(properties.method)), errors.collect(cdk.propertyValidator("path", cdk.requiredValidator)(properties.path)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.collect(cdk.propertyValidator("restApiId", cdk.validateString)(properties.restApiId)), errors.wrap('supplied properties not correct for "ApiEventProperty"');
    }
    function cfnStateMachineApiEventPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStateMachine_ApiEventPropertyValidator(properties).assertSuccess(), { Method: cdk.stringToCloudFormation(properties.method), Path: cdk.stringToCloudFormation(properties.path), RestApiId: cdk.stringToCloudFormation(properties.restApiId) }) : properties;
    }
    function CfnStateMachineApiEventPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("method", "Method", cfn_parse.FromCloudFormation.getString(properties.Method)), ret.addPropertyResult("path", "Path", cfn_parse.FromCloudFormation.getString(properties.Path)), ret.addPropertyResult("restApiId", "RestApiId", properties.RestApiId != null ? cfn_parse.FromCloudFormation.getString(properties.RestApiId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStateMachine_CloudWatchEventEventPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("eventBusName", cdk.validateString)(properties.eventBusName)), errors.collect(cdk.propertyValidator("input", cdk.validateString)(properties.input)), errors.collect(cdk.propertyValidator("inputPath", cdk.validateString)(properties.inputPath)), errors.collect(cdk.propertyValidator("pattern", cdk.requiredValidator)(properties.pattern)), errors.collect(cdk.propertyValidator("pattern", cdk.validateObject)(properties.pattern)), errors.wrap('supplied properties not correct for "CloudWatchEventEventProperty"');
    }
    function cfnStateMachineCloudWatchEventEventPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStateMachine_CloudWatchEventEventPropertyValidator(properties).assertSuccess(), { EventBusName: cdk.stringToCloudFormation(properties.eventBusName), Input: cdk.stringToCloudFormation(properties.input), InputPath: cdk.stringToCloudFormation(properties.inputPath), Pattern: cdk.objectToCloudFormation(properties.pattern) }) : properties;
    }
    function CfnStateMachineCloudWatchEventEventPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("eventBusName", "EventBusName", properties.EventBusName != null ? cfn_parse.FromCloudFormation.getString(properties.EventBusName) : void 0), ret.addPropertyResult("input", "Input", properties.Input != null ? cfn_parse.FromCloudFormation.getString(properties.Input) : void 0), ret.addPropertyResult("inputPath", "InputPath", properties.InputPath != null ? cfn_parse.FromCloudFormation.getString(properties.InputPath) : void 0), ret.addPropertyResult("pattern", "Pattern", cfn_parse.FromCloudFormation.getAny(properties.Pattern)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStateMachine_CloudWatchLogsLogGroupPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logGroupArn", cdk.requiredValidator)(properties.logGroupArn)), errors.collect(cdk.propertyValidator("logGroupArn", cdk.validateString)(properties.logGroupArn)), errors.wrap('supplied properties not correct for "CloudWatchLogsLogGroupProperty"');
    }
    function cfnStateMachineCloudWatchLogsLogGroupPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStateMachine_CloudWatchLogsLogGroupPropertyValidator(properties).assertSuccess(), { LogGroupArn: cdk.stringToCloudFormation(properties.logGroupArn) }) : properties;
    }
    function CfnStateMachineCloudWatchLogsLogGroupPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logGroupArn", "LogGroupArn", cfn_parse.FromCloudFormation.getString(properties.LogGroupArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStateMachine_EventBridgeRuleEventPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("eventBusName", cdk.validateString)(properties.eventBusName)), errors.collect(cdk.propertyValidator("input", cdk.validateString)(properties.input)), errors.collect(cdk.propertyValidator("inputPath", cdk.validateString)(properties.inputPath)), errors.collect(cdk.propertyValidator("pattern", cdk.requiredValidator)(properties.pattern)), errors.collect(cdk.propertyValidator("pattern", cdk.validateObject)(properties.pattern)), errors.wrap('supplied properties not correct for "EventBridgeRuleEventProperty"');
    }
    function cfnStateMachineEventBridgeRuleEventPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStateMachine_EventBridgeRuleEventPropertyValidator(properties).assertSuccess(), { EventBusName: cdk.stringToCloudFormation(properties.eventBusName), Input: cdk.stringToCloudFormation(properties.input), InputPath: cdk.stringToCloudFormation(properties.inputPath), Pattern: cdk.objectToCloudFormation(properties.pattern) }) : properties;
    }
    function CfnStateMachineEventBridgeRuleEventPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("eventBusName", "EventBusName", properties.EventBusName != null ? cfn_parse.FromCloudFormation.getString(properties.EventBusName) : void 0), ret.addPropertyResult("input", "Input", properties.Input != null ? cfn_parse.FromCloudFormation.getString(properties.Input) : void 0), ret.addPropertyResult("inputPath", "InputPath", properties.InputPath != null ? cfn_parse.FromCloudFormation.getString(properties.InputPath) : void 0), ret.addPropertyResult("pattern", "Pattern", cfn_parse.FromCloudFormation.getAny(properties.Pattern)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStateMachine_EventSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("properties", cdk.requiredValidator)(properties.properties)), errors.collect(cdk.propertyValidator("properties", cdk.unionValidator(CfnStateMachine_CloudWatchEventEventPropertyValidator, CfnStateMachine_EventBridgeRuleEventPropertyValidator, CfnStateMachine_ScheduleEventPropertyValidator, CfnStateMachine_ApiEventPropertyValidator))(properties.properties)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "EventSourceProperty"');
    }
    function cfnStateMachineEventSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStateMachine_EventSourcePropertyValidator(properties).assertSuccess(), { Properties: cdk.unionMapper([CfnStateMachine_CloudWatchEventEventPropertyValidator, CfnStateMachine_EventBridgeRuleEventPropertyValidator, CfnStateMachine_ScheduleEventPropertyValidator, CfnStateMachine_ApiEventPropertyValidator], [cfnStateMachineCloudWatchEventEventPropertyToCloudFormation, cfnStateMachineEventBridgeRuleEventPropertyToCloudFormation, cfnStateMachineScheduleEventPropertyToCloudFormation, cfnStateMachineApiEventPropertyToCloudFormation])(properties.properties), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnStateMachineEventSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("properties", "Properties", cfn_parse.FromCloudFormation.getTypeUnion([CfnStateMachine_CloudWatchEventEventPropertyValidator, CfnStateMachine_EventBridgeRuleEventPropertyValidator, CfnStateMachine_ScheduleEventPropertyValidator, CfnStateMachine_ApiEventPropertyValidator], [CfnStateMachineCloudWatchEventEventPropertyFromCloudFormation, CfnStateMachineEventBridgeRuleEventPropertyFromCloudFormation, CfnStateMachineScheduleEventPropertyFromCloudFormation, CfnStateMachineApiEventPropertyFromCloudFormation])(properties.Properties)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStateMachine_FunctionSAMPTPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("functionName", cdk.requiredValidator)(properties.functionName)), errors.collect(cdk.propertyValidator("functionName", cdk.validateString)(properties.functionName)), errors.wrap('supplied properties not correct for "FunctionSAMPTProperty"');
    }
    function cfnStateMachineFunctionSAMPTPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStateMachine_FunctionSAMPTPropertyValidator(properties).assertSuccess(), { FunctionName: cdk.stringToCloudFormation(properties.functionName) }) : properties;
    }
    function CfnStateMachineFunctionSAMPTPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("functionName", "FunctionName", cfn_parse.FromCloudFormation.getString(properties.FunctionName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStateMachine_IAMPolicyDocumentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("statement", cdk.requiredValidator)(properties.statement)), errors.collect(cdk.propertyValidator("statement", cdk.validateObject)(properties.statement)), errors.collect(cdk.propertyValidator("version", cdk.requiredValidator)(properties.version)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "IAMPolicyDocumentProperty"');
    }
    function cfnStateMachineIAMPolicyDocumentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStateMachine_IAMPolicyDocumentPropertyValidator(properties).assertSuccess(), { Statement: cdk.objectToCloudFormation(properties.statement), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnStateMachineIAMPolicyDocumentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("statement", "Statement", cfn_parse.FromCloudFormation.getAny(properties.Statement)), ret.addPropertyResult("version", "Version", cfn_parse.FromCloudFormation.getString(properties.Version)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStateMachine_LogDestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchLogsLogGroup", cdk.requiredValidator)(properties.cloudWatchLogsLogGroup)), errors.collect(cdk.propertyValidator("cloudWatchLogsLogGroup", CfnStateMachine_CloudWatchLogsLogGroupPropertyValidator)(properties.cloudWatchLogsLogGroup)), errors.wrap('supplied properties not correct for "LogDestinationProperty"');
    }
    function cfnStateMachineLogDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStateMachine_LogDestinationPropertyValidator(properties).assertSuccess(), { CloudWatchLogsLogGroup: cfnStateMachineCloudWatchLogsLogGroupPropertyToCloudFormation(properties.cloudWatchLogsLogGroup) }) : properties;
    }
    function CfnStateMachineLogDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchLogsLogGroup", "CloudWatchLogsLogGroup", CfnStateMachineCloudWatchLogsLogGroupPropertyFromCloudFormation(properties.CloudWatchLogsLogGroup)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStateMachine_LoggingConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinations", cdk.requiredValidator)(properties.destinations)), errors.collect(cdk.propertyValidator("destinations", cdk.listValidator(CfnStateMachine_LogDestinationPropertyValidator))(properties.destinations)), errors.collect(cdk.propertyValidator("includeExecutionData", cdk.requiredValidator)(properties.includeExecutionData)), errors.collect(cdk.propertyValidator("includeExecutionData", cdk.validateBoolean)(properties.includeExecutionData)), errors.collect(cdk.propertyValidator("level", cdk.requiredValidator)(properties.level)), errors.collect(cdk.propertyValidator("level", cdk.validateString)(properties.level)), errors.wrap('supplied properties not correct for "LoggingConfigurationProperty"');
    }
    function cfnStateMachineLoggingConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStateMachine_LoggingConfigurationPropertyValidator(properties).assertSuccess(), { Destinations: cdk.listMapper(cfnStateMachineLogDestinationPropertyToCloudFormation)(properties.destinations), IncludeExecutionData: cdk.booleanToCloudFormation(properties.includeExecutionData), Level: cdk.stringToCloudFormation(properties.level) }) : properties;
    }
    function CfnStateMachineLoggingConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinations", "Destinations", cfn_parse.FromCloudFormation.getArray(CfnStateMachineLogDestinationPropertyFromCloudFormation)(properties.Destinations)), ret.addPropertyResult("includeExecutionData", "IncludeExecutionData", cfn_parse.FromCloudFormation.getBoolean(properties.IncludeExecutionData)), ret.addPropertyResult("level", "Level", cfn_parse.FromCloudFormation.getString(properties.Level)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStateMachine_S3LocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.requiredValidator)(properties.bucket)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("version", cdk.validateNumber)(properties.version)), errors.wrap('supplied properties not correct for "S3LocationProperty"');
    }
    function cfnStateMachineS3LocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStateMachine_S3LocationPropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), Key: cdk.stringToCloudFormation(properties.key), Version: cdk.numberToCloudFormation(properties.version) }) : properties;
    }
    function CfnStateMachineS3LocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", cfn_parse.FromCloudFormation.getString(properties.Bucket)), ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getNumber(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStateMachine_SAMPolicyTemplatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("lambdaInvokePolicy", CfnStateMachine_FunctionSAMPTPropertyValidator)(properties.lambdaInvokePolicy)), errors.collect(cdk.propertyValidator("stepFunctionsExecutionPolicy", CfnStateMachine_StateMachineSAMPTPropertyValidator)(properties.stepFunctionsExecutionPolicy)), errors.wrap('supplied properties not correct for "SAMPolicyTemplateProperty"');
    }
    function cfnStateMachineSAMPolicyTemplatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStateMachine_SAMPolicyTemplatePropertyValidator(properties).assertSuccess(), { LambdaInvokePolicy: cfnStateMachineFunctionSAMPTPropertyToCloudFormation(properties.lambdaInvokePolicy), StepFunctionsExecutionPolicy: cfnStateMachineStateMachineSAMPTPropertyToCloudFormation(properties.stepFunctionsExecutionPolicy) }) : properties;
    }
    function CfnStateMachineSAMPolicyTemplatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("lambdaInvokePolicy", "LambdaInvokePolicy", properties.LambdaInvokePolicy != null ? CfnStateMachineFunctionSAMPTPropertyFromCloudFormation(properties.LambdaInvokePolicy) : void 0), ret.addPropertyResult("stepFunctionsExecutionPolicy", "StepFunctionsExecutionPolicy", properties.StepFunctionsExecutionPolicy != null ? CfnStateMachineStateMachineSAMPTPropertyFromCloudFormation(properties.StepFunctionsExecutionPolicy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStateMachine_ScheduleEventPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("input", cdk.validateString)(properties.input)), errors.collect(cdk.propertyValidator("schedule", cdk.requiredValidator)(properties.schedule)), errors.collect(cdk.propertyValidator("schedule", cdk.validateString)(properties.schedule)), errors.wrap('supplied properties not correct for "ScheduleEventProperty"');
    }
    function cfnStateMachineScheduleEventPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStateMachine_ScheduleEventPropertyValidator(properties).assertSuccess(), { Input: cdk.stringToCloudFormation(properties.input), Schedule: cdk.stringToCloudFormation(properties.schedule) }) : properties;
    }
    function CfnStateMachineScheduleEventPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("input", "Input", properties.Input != null ? cfn_parse.FromCloudFormation.getString(properties.Input) : void 0), ret.addPropertyResult("schedule", "Schedule", cfn_parse.FromCloudFormation.getString(properties.Schedule)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStateMachine_StateMachineSAMPTPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("stateMachineName", cdk.requiredValidator)(properties.stateMachineName)), errors.collect(cdk.propertyValidator("stateMachineName", cdk.validateString)(properties.stateMachineName)), errors.wrap('supplied properties not correct for "StateMachineSAMPTProperty"');
    }
    function cfnStateMachineStateMachineSAMPTPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStateMachine_StateMachineSAMPTPropertyValidator(properties).assertSuccess(), { StateMachineName: cdk.stringToCloudFormation(properties.stateMachineName) }) : properties;
    }
    function CfnStateMachineStateMachineSAMPTPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("stateMachineName", "StateMachineName", cfn_parse.FromCloudFormation.getString(properties.StateMachineName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStateMachine_TracingConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "TracingConfigurationProperty"');
    }
    function cfnStateMachineTracingConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStateMachine_TracingConfigurationPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnStateMachineTracingConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-sam/lib/index.js
var require_lib29 = __commonJS({
  "node_modules/aws-cdk-lib/aws-sam/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_sam_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-sam/index.js
var require_aws_sam = __commonJS({
  "node_modules/aws-cdk-lib/aws-sam/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib29(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-secretsmanager/lib/secret-rotation.js
var require_secret_rotation = __commonJS({
  "node_modules/aws-cdk-lib/aws-secretsmanager/lib/secret-rotation.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SecretRotation = exports2.SecretRotationApplication = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var ec2 = require_aws_ec2();
    var lambda2 = require_aws_lambda();
    var serverless = require_aws_sam();
    var core_1 = require_core2();
    var SecretRotationApplication = class _SecretRotationApplication {
      constructor(applicationId, semanticVersion, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_SecretRotationApplicationOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SecretRotationApplication), error;
        }
        this.applicationId = `arn:aws:serverlessrepo:us-east-1:297356227824:applications/${applicationId}`, this.semanticVersion = semanticVersion, this.applicationName = applicationId, this.isMultiUser = options && options.isMultiUser;
      }
      applicationArnForPartition(partition) {
        if (partition === "aws")
          return this.applicationId;
        if (partition === "aws-cn")
          return `arn:aws-cn:serverlessrepo:cn-north-1:193023089310:applications/${this.applicationName}`;
        if (partition === "aws-us-gov")
          return `arn:aws-us-gov:serverlessrepo:us-gov-west-1:023102451235:applications/${this.applicationName}`;
        throw new Error(`unsupported partition: ${partition}`);
      }
      semanticVersionForPartition(partition) {
        if (partition === "aws")
          return this.semanticVersion;
        if (partition === "aws-cn")
          return "1.1.37";
        if (partition === "aws-us-gov")
          return "1.1.93";
        throw new Error(`unsupported partition: ${partition}`);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SecretRotationApplication[_a] = { fqn: "aws-cdk-lib.aws_secretsmanager.SecretRotationApplication", version: "2.80.0" }, SecretRotationApplication.MARIADB_ROTATION_SINGLE_USER = new SecretRotationApplication("SecretsManagerRDSMariaDBRotationSingleUser", "1.1.225"), SecretRotationApplication.MARIADB_ROTATION_MULTI_USER = new SecretRotationApplication("SecretsManagerRDSMariaDBRotationMultiUser", "1.1.225", { isMultiUser: true }), SecretRotationApplication.MYSQL_ROTATION_SINGLE_USER = new SecretRotationApplication("SecretsManagerRDSMySQLRotationSingleUser", "1.1.225"), SecretRotationApplication.MYSQL_ROTATION_MULTI_USER = new SecretRotationApplication("SecretsManagerRDSMySQLRotationMultiUser", "1.1.225", { isMultiUser: true }), SecretRotationApplication.ORACLE_ROTATION_SINGLE_USER = new SecretRotationApplication("SecretsManagerRDSOracleRotationSingleUser", "1.1.225"), SecretRotationApplication.ORACLE_ROTATION_MULTI_USER = new SecretRotationApplication("SecretsManagerRDSOracleRotationMultiUser", "1.1.225", { isMultiUser: true }), SecretRotationApplication.POSTGRES_ROTATION_SINGLE_USER = new SecretRotationApplication("SecretsManagerRDSPostgreSQLRotationSingleUser", "1.1.225"), SecretRotationApplication.POSTGRES_ROTATION_MULTI_USER = new SecretRotationApplication("SecretsManagerRDSPostgreSQLRotationMultiUser", "1.1.225", { isMultiUser: true }), SecretRotationApplication.SQLSERVER_ROTATION_SINGLE_USER = new SecretRotationApplication("SecretsManagerRDSSQLServerRotationSingleUser", "1.1.225"), SecretRotationApplication.SQLSERVER_ROTATION_MULTI_USER = new SecretRotationApplication("SecretsManagerRDSSQLServerRotationMultiUser", "1.1.225", { isMultiUser: true }), SecretRotationApplication.REDSHIFT_ROTATION_SINGLE_USER = new SecretRotationApplication("SecretsManagerRedshiftRotationSingleUser", "1.1.225"), SecretRotationApplication.REDSHIFT_ROTATION_MULTI_USER = new SecretRotationApplication("SecretsManagerRedshiftRotationMultiUser", "1.1.225", { isMultiUser: true }), SecretRotationApplication.MONGODB_ROTATION_SINGLE_USER = new SecretRotationApplication("SecretsManagerMongoDBRotationSingleUser", "1.1.225"), SecretRotationApplication.MONGODB_ROTATION_MULTI_USER = new SecretRotationApplication("SecretsManagerMongoDBRotationMultiUser", "1.1.225", { isMultiUser: true }), exports2.SecretRotationApplication = SecretRotationApplication;
    var SecretRotation = class _SecretRotation extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_SecretRotationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SecretRotation), error;
        }
        if (!props.target.connections.defaultPort)
          throw new Error("The `target` connections must have a default port range.");
        if (props.application.isMultiUser && !props.masterSecret)
          throw new Error("The `masterSecret` must be specified for application using the multi user scheme.");
        const uniqueId = core_1.Names.uniqueId(this), rotationFunctionName = uniqueId.substring(Math.max(uniqueId.length - 64, 0), uniqueId.length), securityGroup = props.securityGroup || new ec2.SecurityGroup(this, "SecurityGroup", { vpc: props.vpc });
        props.target.connections.allowDefaultPortFrom(securityGroup);
        const parameters = { endpoint: `https://${props.endpoint ? `${props.endpoint.vpcEndpointId}.` : ""}secretsmanager.${core_1.Stack.of(this).region}.${core_1.Stack.of(this).urlSuffix}`, functionName: rotationFunctionName, vpcSubnetIds: props.vpc.selectSubnets(props.vpcSubnets).subnetIds.join(","), vpcSecurityGroupIds: securityGroup.securityGroupId };
        props.excludeCharacters !== void 0 && (parameters.excludeCharacters = props.excludeCharacters), props.secret.encryptionKey && (parameters.kmsKeyArn = props.secret.encryptionKey.keyArn), props.masterSecret && (parameters.masterSecretArn = props.masterSecret.secretArn, props.masterSecret.encryptionKey && (parameters.masterSecretKmsKeyArn = props.masterSecret.encryptionKey.keyArn));
        const sarMapping = new core_1.CfnMapping(this, "SARMapping", { mapping: { aws: { applicationId: props.application.applicationArnForPartition("aws"), semanticVersion: props.application.semanticVersionForPartition("aws") }, "aws-cn": { applicationId: props.application.applicationArnForPartition("aws-cn"), semanticVersion: props.application.semanticVersionForPartition("aws-cn") }, "aws-us-gov": { applicationId: props.application.applicationArnForPartition("aws-us-gov"), semanticVersion: props.application.semanticVersionForPartition("aws-us-gov") } } }), application = new serverless.CfnApplication(this, "Resource", { location: { applicationId: sarMapping.findInMap(core_1.Aws.PARTITION, "applicationId"), semanticVersion: sarMapping.findInMap(core_1.Aws.PARTITION, "semanticVersion") }, parameters });
        application.applyRemovalPolicy(core_1.RemovalPolicy.DESTROY);
        const rotationLambda = lambda2.Function.fromFunctionArn(this, "RotationLambda", core_1.Token.asString(application.getAtt("Outputs.RotationLambdaARN")));
        props.secret.addRotationSchedule("RotationSchedule", { rotationLambda, automaticallyAfter: props.automaticallyAfter }), props.masterSecret && props.masterSecret.denyAccountRootDelete();
      }
    };
    _b = JSII_RTTI_SYMBOL_1, SecretRotation[_b] = { fqn: "aws-cdk-lib.aws_secretsmanager.SecretRotation", version: "2.80.0" }, exports2.SecretRotation = SecretRotation;
  }
});

// node_modules/aws-cdk-lib/aws-secretsmanager/lib/index.js
var require_lib30 = __commonJS({
  "node_modules/aws-cdk-lib/aws-secretsmanager/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_secret(), exports2), __exportStar(require_rotation_schedule(), exports2), __exportStar(require_policy4(), exports2), __exportStar(require_secret_rotation(), exports2), __exportStar(require_secretsmanager_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-secretsmanager/index.js
var require_aws_secretsmanager = __commonJS({
  "node_modules/aws-cdk-lib/aws-secretsmanager/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib30(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-elasticsearch/lib/domain.js
var require_domain = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticsearch/lib/domain.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Domain = exports2.TLSSecurityPolicy = exports2.ElasticsearchVersion = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var url_1 = require("url");
    var elasticsearch_access_policy_1 = require_elasticsearch_access_policy();
    var elasticsearch_generated_1 = require_elasticsearch_generated();
    var log_group_resource_policy_1 = require_log_group_resource_policy();
    var perms = require_perms3();
    var acm = require_aws_certificatemanager();
    var aws_cloudwatch_1 = require_aws_cloudwatch();
    var ec2 = require_aws_ec2();
    var iam = require_aws_iam();
    var logs = require_aws_logs();
    var route53 = require_aws_route53();
    var secretsmanager = require_aws_secretsmanager();
    var cdk = require_core2();
    var ElasticsearchVersion = class _ElasticsearchVersion {
      static of(version) {
        return new _ElasticsearchVersion(version);
      }
      constructor(version) {
        this.version = version;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ElasticsearchVersion[_a] = { fqn: "aws-cdk-lib.aws_elasticsearch.ElasticsearchVersion", version: "2.80.0" }, ElasticsearchVersion.V1_5 = ElasticsearchVersion.of("1.5"), ElasticsearchVersion.V2_3 = ElasticsearchVersion.of("2.3"), ElasticsearchVersion.V5_1 = ElasticsearchVersion.of("5.1"), ElasticsearchVersion.V5_3 = ElasticsearchVersion.of("5.3"), ElasticsearchVersion.V5_5 = ElasticsearchVersion.of("5.5"), ElasticsearchVersion.V5_6 = ElasticsearchVersion.of("5.6"), ElasticsearchVersion.V6_0 = ElasticsearchVersion.of("6.0"), ElasticsearchVersion.V6_2 = ElasticsearchVersion.of("6.2"), ElasticsearchVersion.V6_3 = ElasticsearchVersion.of("6.3"), ElasticsearchVersion.V6_4 = ElasticsearchVersion.of("6.4"), ElasticsearchVersion.V6_5 = ElasticsearchVersion.of("6.5"), ElasticsearchVersion.V6_7 = ElasticsearchVersion.of("6.7"), ElasticsearchVersion.V6_8 = ElasticsearchVersion.of("6.8"), ElasticsearchVersion.V7_1 = ElasticsearchVersion.of("7.1"), ElasticsearchVersion.V7_4 = ElasticsearchVersion.of("7.4"), ElasticsearchVersion.V7_7 = ElasticsearchVersion.of("7.7"), ElasticsearchVersion.V7_8 = ElasticsearchVersion.of("7.8"), ElasticsearchVersion.V7_9 = ElasticsearchVersion.of("7.9"), ElasticsearchVersion.V7_10 = ElasticsearchVersion.of("7.10"), exports2.ElasticsearchVersion = ElasticsearchVersion;
    var TLSSecurityPolicy;
    (function(TLSSecurityPolicy2) {
      TLSSecurityPolicy2.TLS_1_0 = "Policy-Min-TLS-1-0-2019-07", TLSSecurityPolicy2.TLS_1_2 = "Policy-Min-TLS-1-2-2019-07";
    })(TLSSecurityPolicy = exports2.TLSSecurityPolicy || (exports2.TLSSecurityPolicy = {}));
    var DomainBase = class extends cdk.Resource {
      grantRead(identity) {
        return this.grant(identity, perms.ES_READ_ACTIONS, this.domainArn, `${this.domainArn}/*`);
      }
      grantWrite(identity) {
        return this.grant(identity, perms.ES_WRITE_ACTIONS, this.domainArn, `${this.domainArn}/*`);
      }
      grantReadWrite(identity) {
        return this.grant(identity, perms.ES_READ_WRITE_ACTIONS, this.domainArn, `${this.domainArn}/*`);
      }
      grantIndexRead(index, identity) {
        return this.grant(identity, perms.ES_READ_ACTIONS, `${this.domainArn}/${index}`, `${this.domainArn}/${index}/*`);
      }
      grantIndexWrite(index, identity) {
        return this.grant(identity, perms.ES_WRITE_ACTIONS, `${this.domainArn}/${index}`, `${this.domainArn}/${index}/*`);
      }
      grantIndexReadWrite(index, identity) {
        return this.grant(identity, perms.ES_READ_WRITE_ACTIONS, `${this.domainArn}/${index}`, `${this.domainArn}/${index}/*`);
      }
      grantPathRead(path, identity) {
        return this.grant(identity, perms.ES_READ_ACTIONS, `${this.domainArn}/${path}`);
      }
      grantPathWrite(path, identity) {
        return this.grant(identity, perms.ES_WRITE_ACTIONS, `${this.domainArn}/${path}`);
      }
      grantPathReadWrite(path, identity) {
        return this.grant(identity, perms.ES_READ_WRITE_ACTIONS, `${this.domainArn}/${path}`);
      }
      metric(metricName, props) {
        return new aws_cloudwatch_1.Metric({ namespace: "AWS/ES", metricName, dimensionsMap: { DomainName: this.domainName, ClientId: this.env.account }, ...props }).attachTo(this);
      }
      metricClusterStatusRed(props) {
        return this.metric("ClusterStatus.red", { statistic: aws_cloudwatch_1.Statistic.MAXIMUM, ...props });
      }
      metricClusterStatusYellow(props) {
        return this.metric("ClusterStatus.yellow", { statistic: aws_cloudwatch_1.Statistic.MAXIMUM, ...props });
      }
      metricFreeStorageSpace(props) {
        return this.metric("FreeStorageSpace", { statistic: aws_cloudwatch_1.Statistic.MINIMUM, ...props });
      }
      metricClusterIndexWritesBlocked(props) {
        return this.metric("ClusterIndexWritesBlocked", { statistic: aws_cloudwatch_1.Statistic.MAXIMUM, period: cdk.Duration.minutes(1), ...props });
      }
      metricNodes(props) {
        return this.metric("Nodes", { statistic: aws_cloudwatch_1.Statistic.MINIMUM, period: cdk.Duration.hours(1), ...props });
      }
      metricAutomatedSnapshotFailure(props) {
        return this.metric("AutomatedSnapshotFailure", { statistic: aws_cloudwatch_1.Statistic.MAXIMUM, ...props });
      }
      metricCPUUtilization(props) {
        return this.metric("CPUUtilization", { statistic: aws_cloudwatch_1.Statistic.MAXIMUM, ...props });
      }
      metricJVMMemoryPressure(props) {
        return this.metric("JVMMemoryPressure", { statistic: aws_cloudwatch_1.Statistic.MAXIMUM, ...props });
      }
      metricMasterCPUUtilization(props) {
        return this.metric("MasterCPUUtilization", { statistic: aws_cloudwatch_1.Statistic.MAXIMUM, ...props });
      }
      metricMasterJVMMemoryPressure(props) {
        return this.metric("MasterJVMMemoryPressure", { statistic: aws_cloudwatch_1.Statistic.MAXIMUM, ...props });
      }
      metricKMSKeyError(props) {
        return this.metric("KMSKeyError", { statistic: aws_cloudwatch_1.Statistic.MAXIMUM, ...props });
      }
      metricKMSKeyInaccessible(props) {
        return this.metric("KMSKeyInaccessible", { statistic: aws_cloudwatch_1.Statistic.MAXIMUM, ...props });
      }
      metricSearchableDocuments(props) {
        return this.metric("SearchableDocuments", { statistic: aws_cloudwatch_1.Statistic.MAXIMUM, ...props });
      }
      metricSearchLatency(props) {
        return this.metric("SearchLatency", { statistic: "p99", ...props });
      }
      metricIndexingLatency(props) {
        return this.metric("IndexingLatency", { statistic: "p99", ...props });
      }
      grant(grantee, domainActions, resourceArn, ...otherResourceArns) {
        const resourceArns = [resourceArn, ...otherResourceArns];
        return iam.Grant.addToPrincipal({ grantee, actions: domainActions, resourceArns, scope: this });
      }
    };
    var Domain = class _Domain extends DomainBase {
      static fromDomainEndpoint(scope, id, domainEndpoint) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticsearch.Domain#fromDomainEndpoint", "use opensearchservice module instead");
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromDomainEndpoint), error;
        }
        const stack = cdk.Stack.of(scope), domainName = extractNameFromEndpoint(domainEndpoint), domainArn = stack.formatArn({ service: "es", resource: "domain", resourceName: domainName });
        return _Domain.fromDomainAttributes(scope, id, { domainArn, domainEndpoint });
      }
      static fromDomainAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticsearch.Domain#fromDomainAttributes", "use opensearchservice module instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticsearch_DomainAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromDomainAttributes), error;
        }
        const { domainArn, domainEndpoint } = attrs, domainName = cdk.Stack.of(scope).splitArn(domainArn, cdk.ArnFormat.SLASH_RESOURCE_NAME).resourceName ?? extractNameFromEndpoint(domainEndpoint);
        return new class extends DomainBase {
          constructor() {
            super(scope, id), this.domainArn = domainArn, this.domainName = domainName, this.domainEndpoint = domainEndpoint.replace(/^https?:\/\//, "");
          }
        }();
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.domainName });
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticsearch.Domain", "use opensearchservice module instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticsearch_DomainProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Domain), error;
        }
        const defaultInstanceType = "r5.large.elasticsearch", warmDefaultInstanceType = "ultrawarm1.medium.elasticsearch", dedicatedMasterType = initializeInstanceType(defaultInstanceType, props.capacity?.masterNodeInstanceType), dedicatedMasterCount = props.capacity?.masterNodes ?? 0, dedicatedMasterEnabled = cdk.Token.isUnresolved(dedicatedMasterCount) ? true : dedicatedMasterCount > 0, instanceType = initializeInstanceType(defaultInstanceType, props.capacity?.dataNodeInstanceType), instanceCount = props.capacity?.dataNodes ?? 1, warmType = initializeInstanceType(warmDefaultInstanceType, props.capacity?.warmInstanceType), warmCount = props.capacity?.warmNodes ?? 0, warmEnabled = cdk.Token.isUnresolved(warmCount) ? true : warmCount > 0, availabilityZoneCount = props.zoneAwareness?.availabilityZoneCount ?? 2;
        if (![2, 3].includes(availabilityZoneCount))
          throw new Error("Invalid zone awareness configuration; availabilityZoneCount must be 2 or 3");
        const zoneAwarenessEnabled = props.zoneAwareness?.enabled ?? props.zoneAwareness?.availabilityZoneCount != null;
        let securityGroups, subnets;
        if (props.vpc && (subnets = selectSubnets(props.vpc, props.vpcSubnets ?? [{ subnetType: ec2.SubnetType.PRIVATE_WITH_EGRESS }]), securityGroups = props.securityGroups ?? [new ec2.SecurityGroup(this, "SecurityGroup", { vpc: props.vpc, description: `Security group for domain ${this.node.id}` })], this._connections = new ec2.Connections({ securityGroups })), subnets && zoneAwarenessEnabled && new Set(subnets.map((subnet) => subnet.availabilityZone)).size < availabilityZoneCount)
          throw new Error("When providing vpc options you need to provide a subnet for each AZ you are using");
        if ([dedicatedMasterType, instanceType, warmType].some((t) => !cdk.Token.isUnresolved(t) && !t.endsWith(".elasticsearch")))
          throw new Error('Master, data and UltraWarm node instance types must end with ".elasticsearch".');
        if (!cdk.Token.isUnresolved(warmType) && !warmType.startsWith("ultrawarm"))
          throw new Error('UltraWarm node instance type must start with "ultrawarm".');
        const elasticsearchVersion = props.version.version, elasticsearchVersionNum = parseVersion(props.version);
        if (elasticsearchVersionNum <= 7.7 && ![1.5, 2.3, 5.1, 5.3, 5.5, 5.6, 6, 6.2, 6.3, 6.4, 6.5, 6.7, 6.8, 7.1, 7.4, 7.7].includes(elasticsearchVersionNum))
          throw new Error(`Unknown Elasticsearch version: ${elasticsearchVersion}`);
        const unsignedBasicAuthEnabled = props.useUnsignedBasicAuth ?? false;
        if (unsignedBasicAuthEnabled) {
          if (props.enforceHttps == false)
            throw new Error("You cannot disable HTTPS and use unsigned basic auth");
          if (props.nodeToNodeEncryption == false)
            throw new Error("You cannot disable node to node encryption and use unsigned basic auth");
          if (props.encryptionAtRest?.enabled == false)
            throw new Error("You cannot disable encryption at rest and use unsigned basic auth");
        }
        const unsignedAccessPolicy = new iam.PolicyStatement({ effect: iam.Effect.ALLOW, actions: ["es:ESHttp*"], principals: [new iam.AnyPrincipal()], resources: [cdk.Lazy.string({ produce: () => `${this.domainArn}/*` })] }), masterUserArn = props.fineGrainedAccessControl?.masterUserArn, masterUserNameProps = props.fineGrainedAccessControl?.masterUserName, masterUserName = unsignedBasicAuthEnabled ? masterUserArn == null ? masterUserNameProps ?? "admin" : void 0 : masterUserNameProps;
        if (masterUserArn != null && masterUserName != null)
          throw new Error("Invalid fine grained access control settings. Only provide one of master user ARN or master user name. Not both.");
        const advancedSecurityEnabled = (masterUserArn ?? masterUserName) != null, internalUserDatabaseEnabled = masterUserName != null, masterUserPasswordProp = props.fineGrainedAccessControl?.masterUserPassword, createMasterUserPassword = () => new secretsmanager.Secret(this, "MasterUser", { generateSecretString: { secretStringTemplate: JSON.stringify({ username: masterUserName }), generateStringKey: "password", excludeCharacters: "{}'\\*[]()`" } }).secretValueFromJson("password");
        this.masterUserPassword = internalUserDatabaseEnabled ? masterUserPasswordProp ?? createMasterUserPassword() : void 0;
        const encryptionAtRestEnabled = props.encryptionAtRest?.enabled ?? (props.encryptionAtRest?.kmsKey != null || unsignedBasicAuthEnabled), nodeToNodeEncryptionEnabled = props.nodeToNodeEncryption ?? unsignedBasicAuthEnabled, volumeSize = props.ebs?.volumeSize ?? 10, volumeType = props.ebs?.volumeType ?? ec2.EbsDeviceVolumeType.GENERAL_PURPOSE_SSD, ebsEnabled = props.ebs?.enabled ?? true, enforceHttps = props.enforceHttps ?? unsignedBasicAuthEnabled;
        function isInstanceType(t) {
          return dedicatedMasterType.startsWith(t) || instanceType.startsWith(t);
        }
        function isSomeInstanceType(...instanceTypes) {
          return instanceTypes.some(isInstanceType);
        }
        function isEveryDatanodeInstanceType(...instanceTypes) {
          return instanceTypes.some((t) => instanceType.startsWith(t));
        }
        if (elasticsearchVersionNum < 5.1) {
          if (props.logging?.appLogEnabled)
            throw new Error("Error logs publishing requires Elasticsearch version 5.1 or later.");
          if (props.encryptionAtRest?.enabled)
            throw new Error("Encryption of data at rest requires Elasticsearch version 5.1 or later.");
          if (props.cognitoKibanaAuth != null)
            throw new Error("Cognito authentication for Kibana requires Elasticsearch version 5.1 or later.");
          if (isSomeInstanceType("c5", "i3", "m5", "r5"))
            throw new Error("C5, I3, M5, and R5 instance types require Elasticsearch version 5.1 or later.");
        }
        if (elasticsearchVersionNum < 6 && props.nodeToNodeEncryption)
          throw new Error("Node-to-node encryption requires Elasticsearch version 6.0 or later.");
        if (elasticsearchVersionNum < 6.7) {
          if (unsignedBasicAuthEnabled)
            throw new Error("Using unsigned basic auth requires Elasticsearch version 6.7 or later.");
          if (advancedSecurityEnabled)
            throw new Error("Fine-grained access control requires Elasticsearch version 6.7 or later.");
        }
        if (elasticsearchVersionNum < 6.8 && warmEnabled)
          throw new Error("UltraWarm requires Elasticsearch 6.8 or later.");
        if (isSomeInstanceType("i3", "r6gd") && ebsEnabled)
          throw new Error("I3 and R6GD instance types do not support EBS storage volumes.");
        if (isSomeInstanceType("m3", "r3", "t2") && encryptionAtRestEnabled)
          throw new Error("M3, R3, and T2 instance types do not support encryption of data at rest.");
        if (isInstanceType("t2.micro") && elasticsearchVersionNum > 2.3)
          throw new Error("The t2.micro.elasticsearch instance type supports only Elasticsearch 1.5 and 2.3.");
        if (isSomeInstanceType("t2", "t3") && warmEnabled)
          throw new Error("T2 and T3 instance types do not support UltraWarm storage.");
        if (!ebsEnabled && !isEveryDatanodeInstanceType("r3", "i3", "r6gd"))
          throw new Error("EBS volumes are required when using instance types other than r3, i3 or r6gd.");
        if (advancedSecurityEnabled) {
          if (!nodeToNodeEncryptionEnabled)
            throw new Error("Node-to-node encryption is required when fine-grained access control is enabled.");
          if (!encryptionAtRestEnabled)
            throw new Error("Encryption-at-rest is required when fine-grained access control is enabled.");
          if (!enforceHttps)
            throw new Error("Enforce HTTPS is required when fine-grained access control is enabled.");
        }
        if (props.logging?.auditLogEnabled && !advancedSecurityEnabled)
          throw new Error("Fine-grained access control is required when audit logs publishing is enabled.");
        if (warmEnabled && !dedicatedMasterEnabled)
          throw new Error("Dedicated master node is required when UltraWarm storage is enabled.");
        let cfnVpcOptions;
        securityGroups && subnets && (cfnVpcOptions = { securityGroupIds: securityGroups.map((sg) => sg.securityGroupId), subnetIds: subnets.map((subnet) => subnet.subnetId) });
        const logGroups = [];
        props.logging?.slowSearchLogEnabled && (this.slowSearchLogGroup = props.logging.slowSearchLogGroup ?? new logs.LogGroup(this, "SlowSearchLogs", { retention: logs.RetentionDays.ONE_MONTH }), logGroups.push(this.slowSearchLogGroup)), props.logging?.slowIndexLogEnabled && (this.slowIndexLogGroup = props.logging.slowIndexLogGroup ?? new logs.LogGroup(this, "SlowIndexLogs", { retention: logs.RetentionDays.ONE_MONTH }), logGroups.push(this.slowIndexLogGroup)), props.logging?.appLogEnabled && (this.appLogGroup = props.logging.appLogGroup ?? new logs.LogGroup(this, "AppLogs", { retention: logs.RetentionDays.ONE_MONTH }), logGroups.push(this.appLogGroup)), props.logging?.auditLogEnabled && (this.auditLogGroup = props.logging.auditLogGroup ?? new logs.LogGroup(this, "AuditLogs", { retention: logs.RetentionDays.ONE_MONTH }), logGroups.push(this.auditLogGroup));
        let logGroupResourcePolicy = null;
        if (logGroups.length > 0) {
          const logPolicyStatement = new iam.PolicyStatement({ effect: iam.Effect.ALLOW, actions: ["logs:PutLogEvents", "logs:CreateLogStream"], resources: logGroups.map((lg) => lg.logGroupArn), principals: [new iam.ServicePrincipal("es.amazonaws.com")] });
          logGroupResourcePolicy = new log_group_resource_policy_1.LogGroupResourcePolicy(this, `ESLogGroupPolicy${this.node.addr}`, { policyName: `ESLogPolicy${this.node.addr}`, policyStatements: [logPolicyStatement] });
        }
        const logPublishing = {};
        this.appLogGroup && (logPublishing.ES_APPLICATION_LOGS = { enabled: true, cloudWatchLogsLogGroupArn: this.appLogGroup.logGroupArn }), this.slowSearchLogGroup && (logPublishing.SEARCH_SLOW_LOGS = { enabled: true, cloudWatchLogsLogGroupArn: this.slowSearchLogGroup.logGroupArn }), this.slowIndexLogGroup && (logPublishing.INDEX_SLOW_LOGS = { enabled: true, cloudWatchLogsLogGroupArn: this.slowIndexLogGroup.logGroupArn }), this.auditLogGroup && (logPublishing.AUDIT_LOGS = { enabled: this.auditLogGroup != null, cloudWatchLogsLogGroupArn: this.auditLogGroup?.logGroupArn });
        let customEndpointCertificate;
        if (props.customEndpoint && (props.customEndpoint.certificate ? customEndpointCertificate = props.customEndpoint.certificate : customEndpointCertificate = new acm.Certificate(this, "CustomEndpointCertificate", { domainName: props.customEndpoint.domainName, validation: props.customEndpoint.hostedZone ? acm.CertificateValidation.fromDns(props.customEndpoint.hostedZone) : void 0 })), this.domain = new elasticsearch_generated_1.CfnDomain(this, "Resource", { domainName: this.physicalName, elasticsearchVersion, elasticsearchClusterConfig: { dedicatedMasterEnabled, dedicatedMasterCount: dedicatedMasterEnabled ? dedicatedMasterCount : void 0, dedicatedMasterType: dedicatedMasterEnabled ? dedicatedMasterType : void 0, instanceCount, instanceType, warmEnabled: warmEnabled || void 0, warmCount: warmEnabled ? warmCount : void 0, warmType: warmEnabled ? warmType : void 0, zoneAwarenessEnabled, zoneAwarenessConfig: zoneAwarenessEnabled ? { availabilityZoneCount } : void 0 }, ebsOptions: { ebsEnabled, volumeSize: ebsEnabled ? volumeSize : void 0, volumeType: ebsEnabled ? volumeType : void 0, iops: ebsEnabled ? props.ebs?.iops : void 0 }, encryptionAtRestOptions: { enabled: encryptionAtRestEnabled, kmsKeyId: encryptionAtRestEnabled ? props.encryptionAtRest?.kmsKey?.keyId : void 0 }, nodeToNodeEncryptionOptions: { enabled: nodeToNodeEncryptionEnabled }, logPublishingOptions: logPublishing, cognitoOptions: { enabled: props.cognitoKibanaAuth != null, identityPoolId: props.cognitoKibanaAuth?.identityPoolId, roleArn: props.cognitoKibanaAuth?.role.roleArn, userPoolId: props.cognitoKibanaAuth?.userPoolId }, vpcOptions: cfnVpcOptions, snapshotOptions: props.automatedSnapshotStartHour ? { automatedSnapshotStartHour: props.automatedSnapshotStartHour } : void 0, domainEndpointOptions: { enforceHttps, tlsSecurityPolicy: props.tlsSecurityPolicy ?? TLSSecurityPolicy.TLS_1_0, ...props.customEndpoint && { customEndpointEnabled: true, customEndpoint: props.customEndpoint.domainName, customEndpointCertificateArn: customEndpointCertificate.certificateArn } }, advancedSecurityOptions: advancedSecurityEnabled ? { enabled: true, internalUserDatabaseEnabled, masterUserOptions: { masterUserArn, masterUserName, masterUserPassword: this.masterUserPassword?.unsafeUnwrap() } } : void 0, advancedOptions: props.advancedOptions }), this.domain.applyRemovalPolicy(props.removalPolicy), props.enableVersionUpgrade && (this.domain.cfnOptions.updatePolicy = { ...this.domain.cfnOptions.updatePolicy, enableVersionUpgrade: props.enableVersionUpgrade }), logGroupResourcePolicy && this.domain.node.addDependency(logGroupResourcePolicy), props.domainName) {
          if (!cdk.Token.isUnresolved(props.domainName)) {
            if (!props.domainName.match(/^[a-z0-9\-]+$/))
              throw new Error(`Invalid domainName '${props.domainName}'. Valid characters are a-z (lowercase only), 0-9, and \u2013 (hyphen).`);
            if (props.domainName.length < 3 || props.domainName.length > 28)
              throw new Error(`Invalid domainName '${props.domainName}'. It must be between 3 and 28 characters`);
            if (props.domainName[0] < "a" || props.domainName[0] > "z")
              throw new Error(`Invalid domainName '${props.domainName}'. It must start with a lowercase letter`);
          }
          this.node.addMetadata("aws:cdk:hasPhysicalName", props.domainName);
        }
        this.domainName = this.getResourceNameAttribute(this.domain.ref), this.domainEndpoint = this.domain.getAtt("DomainEndpoint").toString(), this.domainArn = this.getResourceArnAttribute(this.domain.attrArn, { service: "es", resource: "domain", resourceName: this.physicalName }), props.customEndpoint?.hostedZone && new route53.CnameRecord(this, "CnameRecord", { recordName: props.customEndpoint.domainName, zone: props.customEndpoint.hostedZone, domainName: this.domainEndpoint }), this.encryptionAtRestOptions = props.encryptionAtRest, props.accessPolicies && this.addAccessPolicies(...props.accessPolicies), unsignedBasicAuthEnabled && this.addAccessPolicies(unsignedAccessPolicy);
      }
      get connections() {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticsearch.Domain#connections", "use opensearchservice module instead");
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, jsiiDeprecationWarnings.getPropertyDescriptor(this, "connections").get), error;
        }
        if (!this._connections)
          throw new Error("Connections are only available on VPC enabled domains. Use the 'vpc' property to place a domain inside a VPC");
        return this._connections;
      }
      addAccessPolicies(...accessPolicyStatements) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticsearch.Domain#addAccessPolicies", "use opensearchservice module instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(accessPolicyStatements);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addAccessPolicies), error;
        }
        accessPolicyStatements.length > 0 && (this.accessPolicy ? this.accessPolicy.addAccessPolicies(...accessPolicyStatements) : (this.accessPolicy = new elasticsearch_access_policy_1.ElasticsearchAccessPolicy(this, "ESAccessPolicy", { domainName: this.domainName, domainArn: this.domainArn, accessPolicies: accessPolicyStatements }), this.encryptionAtRestOptions?.kmsKey && this.accessPolicy.grantPrincipal.addToPrincipalPolicy(new iam.PolicyStatement({ actions: ["kms:List*", "kms:Describe*", "kms:CreateGrant"], resources: [this.encryptionAtRestOptions.kmsKey.keyArn], effect: iam.Effect.ALLOW }))));
      }
    };
    _b = JSII_RTTI_SYMBOL_1, Domain[_b] = { fqn: "aws-cdk-lib.aws_elasticsearch.Domain", version: "2.80.0" }, exports2.Domain = Domain;
    function extractNameFromEndpoint(domainEndpoint) {
      const { hostname } = new url_1.URL(domainEndpoint), domain = hostname.split(".")[0], suffix = "-" + domain.split("-").slice(-1)[0];
      return domain.split(suffix)[0];
    }
    function parseVersion(version) {
      const versionStr = version.version, firstDot = versionStr.indexOf(".");
      if (firstDot < 1)
        throw new Error(`Invalid Elasticsearch version: ${versionStr}. Version string needs to start with major and minor version (x.y).`);
      const secondDot = versionStr.indexOf(".", firstDot + 1);
      try {
        return secondDot == -1 ? parseFloat(versionStr) : parseFloat(versionStr.substring(0, secondDot));
      } catch {
        throw new Error(`Invalid Elasticsearch version: ${versionStr}. Version string needs to start with major and minor version (x.y).`);
      }
    }
    function selectSubnets(vpc, vpcSubnets) {
      const selected = [];
      for (const selection of vpcSubnets)
        selected.push(...vpc.selectSubnets(selection).subnets);
      return selected;
    }
    function initializeInstanceType(defaultInstanceType, instanceType) {
      return instanceType ? cdk.Token.isUnresolved(instanceType) ? instanceType : instanceType.toLowerCase() : defaultInstanceType;
    }
  }
});

// node_modules/aws-cdk-lib/.warnings.jsii.js
var require_warnings_jsii = __commonJS({
  "node_modules/aws-cdk-lib/.warnings.jsii.js"(exports2, module2) {
    "use strict";
    function aws_cdk_lib_alexa_ask_CfnSkillProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.authenticationConfiguration) || (p.authenticationConfiguration, void 0), visitedObjects.has(p.skillPackage) || (p.skillPackage, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_alexa_ask_CfnSkill(p) {
    }
    function aws_cdk_lib_alexa_ask_CfnSkill_AuthenticationConfigurationProperty(p) {
    }
    function aws_cdk_lib_alexa_ask_CfnSkill_OverridesProperty(p) {
    }
    function aws_cdk_lib_alexa_ask_CfnSkill_SkillPackageProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.overrides) || (p.overrides, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_assertions_Capture(p) {
    }
    function aws_cdk_lib_assertions_Template(p) {
    }
    function aws_cdk_lib_assertions_TemplateParsingOptions(p) {
    }
    function aws_cdk_lib_assertions_Match(p) {
    }
    function aws_cdk_lib_assertions_Matcher(p) {
    }
    function aws_cdk_lib_assertions_MatchFailure(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.matcher) || (p.matcher, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_assertions_MatchCapture(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.capture) || (p.capture, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_assertions_MatchResult(p) {
    }
    function aws_cdk_lib_assertions_Annotations(p) {
    }
    function aws_cdk_lib_aws_accessanalyzer_CfnAnalyzerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.archiveRules) || (p.archiveRules, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_accessanalyzer_CfnAnalyzer(p) {
    }
    function aws_cdk_lib_aws_accessanalyzer_CfnAnalyzer_ArchiveRuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.filter) || (p.filter, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_accessanalyzer_CfnAnalyzer_FilterProperty(p) {
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificateProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.validity) || (p.validity, void 0), visitedObjects.has(p.apiPassthrough) || (p.apiPassthrough, void 0), visitedObjects.has(p.validityNotBefore) || (p.validityNotBefore, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificate(p) {
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificate_ApiPassthroughProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.extensions) || (p.extensions, void 0), visitedObjects.has(p.subject) || (p.subject, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificate_CustomAttributeProperty(p) {
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificate_CustomExtensionProperty(p) {
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificate_EdiPartyNameProperty(p) {
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificate_ExtendedKeyUsageProperty(p) {
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificate_ExtensionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.certificatePolicies) || (p.certificatePolicies, void 0), visitedObjects.has(p.customExtensions) || (p.customExtensions, void 0), visitedObjects.has(p.extendedKeyUsage) || (p.extendedKeyUsage, void 0), visitedObjects.has(p.keyUsage) || (p.keyUsage, void 0), visitedObjects.has(p.subjectAlternativeNames) || (p.subjectAlternativeNames, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificate_GeneralNameProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.directoryName) || (p.directoryName, void 0), visitedObjects.has(p.ediPartyName) || (p.ediPartyName, void 0), visitedObjects.has(p.otherName) || (p.otherName, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificate_KeyUsageProperty(p) {
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificate_OtherNameProperty(p) {
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificate_PolicyInformationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.policyQualifiers) || (p.policyQualifiers, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificate_PolicyQualifierInfoProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.qualifier) || (p.qualifier, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificate_QualifierProperty(p) {
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificate_SubjectProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customAttributes) || (p.customAttributes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificate_ValidityProperty(p) {
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificateAuthorityProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.subject) || (p.subject, void 0), visitedObjects.has(p.csrExtensions) || (p.csrExtensions, void 0), visitedObjects.has(p.revocationConfiguration) || (p.revocationConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificateAuthority(p) {
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificateAuthority_AccessDescriptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.accessLocation) || (p.accessLocation, void 0), visitedObjects.has(p.accessMethod) || (p.accessMethod, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificateAuthority_AccessMethodProperty(p) {
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificateAuthority_CrlConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificateAuthority_CsrExtensionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.keyUsage) || (p.keyUsage, void 0), visitedObjects.has(p.subjectInformationAccess) || (p.subjectInformationAccess, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificateAuthority_CustomAttributeProperty(p) {
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificateAuthority_EdiPartyNameProperty(p) {
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificateAuthority_GeneralNameProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.directoryName) || (p.directoryName, void 0), visitedObjects.has(p.ediPartyName) || (p.ediPartyName, void 0), visitedObjects.has(p.otherName) || (p.otherName, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificateAuthority_KeyUsageProperty(p) {
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificateAuthority_OcspConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificateAuthority_OtherNameProperty(p) {
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificateAuthority_RevocationConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.crlConfiguration) || (p.crlConfiguration, void 0), visitedObjects.has(p.ocspConfiguration) || (p.ocspConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificateAuthority_SubjectProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customAttributes) || (p.customAttributes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificateAuthorityActivationProps(p) {
    }
    function aws_cdk_lib_aws_acmpca_CfnCertificateAuthorityActivation(p) {
    }
    function aws_cdk_lib_aws_acmpca_CfnPermissionProps(p) {
    }
    function aws_cdk_lib_aws_acmpca_CfnPermission(p) {
    }
    function aws_cdk_lib_aws_acmpca_ICertificateAuthority(p) {
    }
    function aws_cdk_lib_aws_acmpca_CertificateAuthority(p) {
    }
    function aws_cdk_lib_aws_amazonmq_CfnBrokerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.users) || (p.users, void 0), visitedObjects.has(p.configuration) || (p.configuration, void 0), visitedObjects.has(p.encryptionOptions) || (p.encryptionOptions, void 0), visitedObjects.has(p.ldapServerMetadata) || (p.ldapServerMetadata, void 0), visitedObjects.has(p.logs) || (p.logs, void 0), visitedObjects.has(p.maintenanceWindowStartTime) || (p.maintenanceWindowStartTime, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_amazonmq_CfnBroker(p) {
    }
    function aws_cdk_lib_aws_amazonmq_CfnBroker_ConfigurationIdProperty(p) {
    }
    function aws_cdk_lib_aws_amazonmq_CfnBroker_EncryptionOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_amazonmq_CfnBroker_LdapServerMetadataProperty(p) {
    }
    function aws_cdk_lib_aws_amazonmq_CfnBroker_LogListProperty(p) {
    }
    function aws_cdk_lib_aws_amazonmq_CfnBroker_MaintenanceWindowProperty(p) {
    }
    function aws_cdk_lib_aws_amazonmq_CfnBroker_TagsEntryProperty(p) {
    }
    function aws_cdk_lib_aws_amazonmq_CfnBroker_UserProperty(p) {
    }
    function aws_cdk_lib_aws_amazonmq_CfnConfigurationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_amazonmq_CfnConfiguration(p) {
    }
    function aws_cdk_lib_aws_amazonmq_CfnConfiguration_TagsEntryProperty(p) {
    }
    function aws_cdk_lib_aws_amazonmq_CfnConfigurationAssociationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.configuration) || (p.configuration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_amazonmq_CfnConfigurationAssociation(p) {
    }
    function aws_cdk_lib_aws_amazonmq_CfnConfigurationAssociation_ConfigurationIdProperty(p) {
    }
    function aws_cdk_lib_aws_amplify_CfnAppProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.autoBranchCreationConfig) || (p.autoBranchCreationConfig, void 0), visitedObjects.has(p.basicAuthConfig) || (p.basicAuthConfig, void 0), visitedObjects.has(p.customRules) || (p.customRules, void 0), visitedObjects.has(p.environmentVariables) || (p.environmentVariables, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_amplify_CfnApp(p) {
    }
    function aws_cdk_lib_aws_amplify_CfnApp_AutoBranchCreationConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.basicAuthConfig) || (p.basicAuthConfig, void 0), visitedObjects.has(p.environmentVariables) || (p.environmentVariables, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_amplify_CfnApp_BasicAuthConfigProperty(p) {
    }
    function aws_cdk_lib_aws_amplify_CfnApp_CustomRuleProperty(p) {
    }
    function aws_cdk_lib_aws_amplify_CfnApp_EnvironmentVariableProperty(p) {
    }
    function aws_cdk_lib_aws_amplify_CfnBranchProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.basicAuthConfig) || (p.basicAuthConfig, void 0), visitedObjects.has(p.environmentVariables) || (p.environmentVariables, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_amplify_CfnBranch(p) {
    }
    function aws_cdk_lib_aws_amplify_CfnBranch_BasicAuthConfigProperty(p) {
    }
    function aws_cdk_lib_aws_amplify_CfnBranch_EnvironmentVariableProperty(p) {
    }
    function aws_cdk_lib_aws_amplify_CfnDomainProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.subDomainSettings) || (p.subDomainSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_amplify_CfnDomain(p) {
    }
    function aws_cdk_lib_aws_amplify_CfnDomain_SubDomainSettingProperty(p) {
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnComponentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bindingProperties) || (p.bindingProperties, void 0), visitedObjects.has(p.properties) || (p.properties, void 0), visitedObjects.has(p.variants) || (p.variants, void 0), visitedObjects.has(p.children) || (p.children, void 0), visitedObjects.has(p.collectionProperties) || (p.collectionProperties, void 0), visitedObjects.has(p.events) || (p.events, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnComponent(p) {
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnComponent_ActionParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.anchor) || (p.anchor, void 0), visitedObjects.has(p.fields) || (p.fields, void 0), visitedObjects.has(p.global) || (p.global, void 0), visitedObjects.has(p.id) || (p.id, void 0), visitedObjects.has(p.state) || (p.state, void 0), visitedObjects.has(p.target) || (p.target, void 0), visitedObjects.has(p.type) || (p.type, void 0), visitedObjects.has(p.url) || (p.url, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnComponent_ComponentBindingPropertiesValueProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bindingProperties) || (p.bindingProperties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnComponent_ComponentBindingPropertiesValuePropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.predicates) || (p.predicates, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnComponent_ComponentChildProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.properties) || (p.properties, void 0), visitedObjects.has(p.children) || (p.children, void 0), visitedObjects.has(p.events) || (p.events, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnComponent_ComponentConditionPropertyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.else) || (p.else, void 0), visitedObjects.has(p.then) || (p.then, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnComponent_ComponentDataConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.predicate) || (p.predicate, void 0), visitedObjects.has(p.sort) || (p.sort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnComponent_ComponentEventProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.parameters) || (p.parameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnComponent_ComponentPropertyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bindingProperties) || (p.bindingProperties, void 0), visitedObjects.has(p.bindings) || (p.bindings, void 0), visitedObjects.has(p.collectionBindingProperties) || (p.collectionBindingProperties, void 0), visitedObjects.has(p.concat) || (p.concat, void 0), visitedObjects.has(p.condition) || (p.condition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnComponent_ComponentPropertyBindingPropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnComponent_ComponentVariantProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.variantValues) || (p.variantValues, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnComponent_FormBindingElementProperty(p) {
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnComponent_MutationActionSetStateParameterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.set) || (p.set, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnComponent_PredicateProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.and) || (p.and, void 0), visitedObjects.has(p.or) || (p.or, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnComponent_SortPropertyProperty(p) {
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnFormProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataType) || (p.dataType, void 0), visitedObjects.has(p.fields) || (p.fields, void 0), visitedObjects.has(p.sectionalElements) || (p.sectionalElements, void 0), visitedObjects.has(p.style) || (p.style, void 0), visitedObjects.has(p.cta) || (p.cta, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnForm(p) {
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnForm_FieldConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.inputType) || (p.inputType, void 0), visitedObjects.has(p.position) || (p.position, void 0), visitedObjects.has(p.validations) || (p.validations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnForm_FieldInputConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fileUploaderConfig) || (p.fileUploaderConfig, void 0), visitedObjects.has(p.valueMappings) || (p.valueMappings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnForm_FieldPositionProperty(p) {
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnForm_FieldValidationConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnForm_FileUploaderFieldConfigProperty(p) {
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnForm_FormButtonProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.position) || (p.position, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnForm_FormCTAProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cancel) || (p.cancel, void 0), visitedObjects.has(p.clear) || (p.clear, void 0), visitedObjects.has(p.submit) || (p.submit, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnForm_FormDataTypeConfigProperty(p) {
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnForm_FormInputValuePropertyProperty(p) {
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnForm_FormStyleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.horizontalGap) || (p.horizontalGap, void 0), visitedObjects.has(p.outerPadding) || (p.outerPadding, void 0), visitedObjects.has(p.verticalGap) || (p.verticalGap, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnForm_FormStyleConfigProperty(p) {
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnForm_SectionalElementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.position) || (p.position, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnForm_ValueMappingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.value) || (p.value, void 0), visitedObjects.has(p.displayValue) || (p.displayValue, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnForm_ValueMappingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnThemeProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.values) || (p.values, void 0), visitedObjects.has(p.overrides) || (p.overrides, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnTheme(p) {
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnTheme_ThemeValueProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.children) || (p.children, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_amplifyuibuilder_CfnTheme_ThemeValuesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_IRestApi(p) {
    }
    function aws_cdk_lib_aws_apigateway_RestApiBaseProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.deployOptions) || aws_cdk_lib_aws_apigateway_StageOptions(p.deployOptions), visitedObjects.has(p.domainName) || aws_cdk_lib_aws_apigateway_DomainNameOptions(p.domainName), p.endpointTypes != null)
            for (const o of p.endpointTypes)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.policy) || (p.policy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_RestApiProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.apiKeySourceType) || (p.apiKeySourceType, void 0), visitedObjects.has(p.cloneFrom) || (p.cloneFrom, void 0), visitedObjects.has(p.endpointConfiguration) || aws_cdk_lib_aws_apigateway_EndpointConfiguration(p.endpointConfiguration), visitedObjects.has(p.minCompressionSize) || (p.minCompressionSize, void 0), "minimumCompressionSize" in p && print("aws-cdk-lib.aws_apigateway.RestApiProps#minimumCompressionSize", "- superseded by `minCompressionSize`"), visitedObjects.has(p.defaultCorsPreflightOptions) || aws_cdk_lib_aws_apigateway_CorsOptions(p.defaultCorsPreflightOptions), visitedObjects.has(p.defaultIntegration) || (p.defaultIntegration, void 0), visitedObjects.has(p.defaultMethodOptions) || aws_cdk_lib_aws_apigateway_MethodOptions(p.defaultMethodOptions), visitedObjects.has(p.deployOptions) || aws_cdk_lib_aws_apigateway_StageOptions(p.deployOptions), visitedObjects.has(p.domainName) || aws_cdk_lib_aws_apigateway_DomainNameOptions(p.domainName), p.endpointTypes != null)
            for (const o of p.endpointTypes)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.policy) || (p.policy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_SpecRestApiProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.apiDefinition) || (p.apiDefinition, void 0), visitedObjects.has(p.minCompressionSize) || (p.minCompressionSize, void 0), visitedObjects.has(p.deployOptions) || aws_cdk_lib_aws_apigateway_StageOptions(p.deployOptions), visitedObjects.has(p.domainName) || aws_cdk_lib_aws_apigateway_DomainNameOptions(p.domainName), p.endpointTypes != null)
            for (const o of p.endpointTypes)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.policy) || (p.policy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_RestApiBase(p) {
    }
    function aws_cdk_lib_aws_apigateway_SpecRestApi(p) {
    }
    function aws_cdk_lib_aws_apigateway_RestApiAttributes(p) {
    }
    function aws_cdk_lib_aws_apigateway_RestApi(p) {
    }
    function aws_cdk_lib_aws_apigateway_EndpointConfiguration(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.types != null)
            for (const o of p.types)
              visitedObjects.has(o) || void 0;
          if (p.vpcEndpoints != null)
            for (const o of p.vpcEndpoints)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_ApiKeySourceType(p) {
    }
    function aws_cdk_lib_aws_apigateway_EndpointType(p) {
    }
    function aws_cdk_lib_aws_apigateway_IResource(p) {
    }
    function aws_cdk_lib_aws_apigateway_ResourceOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultCorsPreflightOptions) || aws_cdk_lib_aws_apigateway_CorsOptions(p.defaultCorsPreflightOptions), visitedObjects.has(p.defaultIntegration) || (p.defaultIntegration, void 0), visitedObjects.has(p.defaultMethodOptions) || aws_cdk_lib_aws_apigateway_MethodOptions(p.defaultMethodOptions);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_ResourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.parent) || (p.parent, void 0), visitedObjects.has(p.defaultCorsPreflightOptions) || aws_cdk_lib_aws_apigateway_CorsOptions(p.defaultCorsPreflightOptions), visitedObjects.has(p.defaultIntegration) || (p.defaultIntegration, void 0), visitedObjects.has(p.defaultMethodOptions) || aws_cdk_lib_aws_apigateway_MethodOptions(p.defaultMethodOptions);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_ResourceBase(p) {
    }
    function aws_cdk_lib_aws_apigateway_ResourceAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.restApi) || (p.restApi, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_Resource(p) {
    }
    function aws_cdk_lib_aws_apigateway_ProxyResourceOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultCorsPreflightOptions) || aws_cdk_lib_aws_apigateway_CorsOptions(p.defaultCorsPreflightOptions), visitedObjects.has(p.defaultIntegration) || (p.defaultIntegration, void 0), visitedObjects.has(p.defaultMethodOptions) || aws_cdk_lib_aws_apigateway_MethodOptions(p.defaultMethodOptions);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_ProxyResourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.parent) || (p.parent, void 0), visitedObjects.has(p.defaultCorsPreflightOptions) || aws_cdk_lib_aws_apigateway_CorsOptions(p.defaultCorsPreflightOptions), visitedObjects.has(p.defaultIntegration) || (p.defaultIntegration, void 0), visitedObjects.has(p.defaultMethodOptions) || aws_cdk_lib_aws_apigateway_MethodOptions(p.defaultMethodOptions);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_ProxyResource(p) {
    }
    function aws_cdk_lib_aws_apigateway_MethodOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.authorizationType) || (p.authorizationType, void 0), visitedObjects.has(p.authorizer) || (p.authorizer, void 0), p.methodResponses != null)
            for (const o of p.methodResponses)
              visitedObjects.has(o) || aws_cdk_lib_aws_apigateway_MethodResponse(o);
          if (p.requestModels != null)
            for (const o of Object.values(p.requestModels))
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.requestValidator) || (p.requestValidator, void 0), visitedObjects.has(p.requestValidatorOptions) || (p.requestValidatorOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_MethodProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.resource) || (p.resource, void 0), visitedObjects.has(p.integration) || (p.integration, void 0), visitedObjects.has(p.options) || aws_cdk_lib_aws_apigateway_MethodOptions(p.options);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_Method(p) {
    }
    function aws_cdk_lib_aws_apigateway_AuthorizationType(p) {
    }
    function aws_cdk_lib_aws_apigateway_IntegrationOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.connectionType) || (p.connectionType, void 0), visitedObjects.has(p.contentHandling) || (p.contentHandling, void 0), visitedObjects.has(p.credentialsRole) || (p.credentialsRole, void 0), p.integrationResponses != null)
            for (const o of p.integrationResponses)
              visitedObjects.has(o) || aws_cdk_lib_aws_apigateway_IntegrationResponse(o);
          visitedObjects.has(p.passthroughBehavior) || (p.passthroughBehavior, void 0), visitedObjects.has(p.timeout) || (p.timeout, void 0), visitedObjects.has(p.vpcLink) || (p.vpcLink, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_IntegrationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.type) || (p.type, void 0), visitedObjects.has(p.options) || aws_cdk_lib_aws_apigateway_IntegrationOptions(p.options);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_IntegrationConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.type) || (p.type, void 0), visitedObjects.has(p.options) || aws_cdk_lib_aws_apigateway_IntegrationOptions(p.options);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_Integration(p) {
    }
    function aws_cdk_lib_aws_apigateway_ContentHandling(p) {
    }
    function aws_cdk_lib_aws_apigateway_IntegrationType(p) {
    }
    function aws_cdk_lib_aws_apigateway_PassthroughBehavior(p) {
    }
    function aws_cdk_lib_aws_apigateway_ConnectionType(p) {
    }
    function aws_cdk_lib_aws_apigateway_IntegrationResponse(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.contentHandling) || (p.contentHandling, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_DeploymentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.api) || (p.api, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_Deployment(p) {
    }
    function aws_cdk_lib_aws_apigateway_IStage(p) {
    }
    function aws_cdk_lib_aws_apigateway_StageOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.accessLogDestination) || (p.accessLogDestination, void 0), visitedObjects.has(p.accessLogFormat) || (p.accessLogFormat, void 0), p.methodOptions != null)
            for (const o of Object.values(p.methodOptions))
              visitedObjects.has(o) || aws_cdk_lib_aws_apigateway_MethodDeploymentOptions(o);
          visitedObjects.has(p.cacheTtl) || (p.cacheTtl, void 0), visitedObjects.has(p.loggingLevel) || (p.loggingLevel, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_StageProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.deployment) || (p.deployment, void 0), visitedObjects.has(p.accessLogDestination) || (p.accessLogDestination, void 0), visitedObjects.has(p.accessLogFormat) || (p.accessLogFormat, void 0), p.methodOptions != null)
            for (const o of Object.values(p.methodOptions))
              visitedObjects.has(o) || aws_cdk_lib_aws_apigateway_MethodDeploymentOptions(o);
          visitedObjects.has(p.cacheTtl) || (p.cacheTtl, void 0), visitedObjects.has(p.loggingLevel) || (p.loggingLevel, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_MethodLoggingLevel(p) {
    }
    function aws_cdk_lib_aws_apigateway_MethodDeploymentOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cacheTtl) || (p.cacheTtl, void 0), visitedObjects.has(p.loggingLevel) || (p.loggingLevel, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_StageAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.restApi) || (p.restApi, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_StageBase(p) {
    }
    function aws_cdk_lib_aws_apigateway_Stage(p) {
    }
    function aws_cdk_lib_aws_apigateway_AwsIntegrationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.options) || aws_cdk_lib_aws_apigateway_IntegrationOptions(p.options);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_AwsIntegration(p) {
    }
    function aws_cdk_lib_aws_apigateway_LambdaIntegrationOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.connectionType) || (p.connectionType, void 0), visitedObjects.has(p.contentHandling) || (p.contentHandling, void 0), visitedObjects.has(p.credentialsRole) || (p.credentialsRole, void 0), p.integrationResponses != null)
            for (const o of p.integrationResponses)
              visitedObjects.has(o) || aws_cdk_lib_aws_apigateway_IntegrationResponse(o);
          visitedObjects.has(p.passthroughBehavior) || (p.passthroughBehavior, void 0), visitedObjects.has(p.timeout) || (p.timeout, void 0), visitedObjects.has(p.vpcLink) || (p.vpcLink, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_LambdaIntegration(p) {
    }
    function aws_cdk_lib_aws_apigateway_HttpIntegrationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.options) || aws_cdk_lib_aws_apigateway_IntegrationOptions(p.options);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_HttpIntegration(p) {
    }
    function aws_cdk_lib_aws_apigateway_MockIntegration(p) {
    }
    function aws_cdk_lib_aws_apigateway_StepFunctionsExecutionIntegrationOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.requestContext) || (p.requestContext, void 0), visitedObjects.has(p.connectionType) || (p.connectionType, void 0), visitedObjects.has(p.contentHandling) || (p.contentHandling, void 0), visitedObjects.has(p.credentialsRole) || (p.credentialsRole, void 0), p.integrationResponses != null)
            for (const o of p.integrationResponses)
              visitedObjects.has(o) || aws_cdk_lib_aws_apigateway_IntegrationResponse(o);
          visitedObjects.has(p.passthroughBehavior) || (p.passthroughBehavior, void 0), visitedObjects.has(p.timeout) || (p.timeout, void 0), visitedObjects.has(p.vpcLink) || (p.vpcLink, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_StepFunctionsIntegration(p) {
    }
    function aws_cdk_lib_aws_apigateway_RequestContext(p) {
    }
    function aws_cdk_lib_aws_apigateway_LambdaRestApiProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.handler) || (p.handler, void 0), visitedObjects.has(p.integrationOptions) || aws_cdk_lib_aws_apigateway_LambdaIntegrationOptions(p.integrationOptions), visitedObjects.has(p.apiKeySourceType) || (p.apiKeySourceType, void 0), visitedObjects.has(p.cloneFrom) || (p.cloneFrom, void 0), visitedObjects.has(p.endpointConfiguration) || aws_cdk_lib_aws_apigateway_EndpointConfiguration(p.endpointConfiguration), visitedObjects.has(p.minCompressionSize) || (p.minCompressionSize, void 0), "minimumCompressionSize" in p && print("aws-cdk-lib.aws_apigateway.RestApiProps#minimumCompressionSize", "- superseded by `minCompressionSize`"), visitedObjects.has(p.defaultCorsPreflightOptions) || aws_cdk_lib_aws_apigateway_CorsOptions(p.defaultCorsPreflightOptions), visitedObjects.has(p.defaultIntegration) || (p.defaultIntegration, void 0), visitedObjects.has(p.defaultMethodOptions) || aws_cdk_lib_aws_apigateway_MethodOptions(p.defaultMethodOptions), visitedObjects.has(p.deployOptions) || aws_cdk_lib_aws_apigateway_StageOptions(p.deployOptions), visitedObjects.has(p.domainName) || aws_cdk_lib_aws_apigateway_DomainNameOptions(p.domainName), p.endpointTypes != null)
            for (const o of p.endpointTypes)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.policy) || (p.policy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_LambdaRestApi(p) {
    }
    function aws_cdk_lib_aws_apigateway_IApiKey(p) {
    }
    function aws_cdk_lib_aws_apigateway_ApiKeyOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultCorsPreflightOptions) || aws_cdk_lib_aws_apigateway_CorsOptions(p.defaultCorsPreflightOptions), visitedObjects.has(p.defaultIntegration) || (p.defaultIntegration, void 0), visitedObjects.has(p.defaultMethodOptions) || aws_cdk_lib_aws_apigateway_MethodOptions(p.defaultMethodOptions);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_ApiKeyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if ("resources" in p && print("aws-cdk-lib.aws_apigateway.ApiKeyProps#resources", "- use `stages` instead"), p.resources != null)
            for (const o of p.resources)
              visitedObjects.has(o) || void 0;
          if (p.stages != null)
            for (const o of p.stages)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.defaultCorsPreflightOptions) || aws_cdk_lib_aws_apigateway_CorsOptions(p.defaultCorsPreflightOptions), visitedObjects.has(p.defaultIntegration) || (p.defaultIntegration, void 0), visitedObjects.has(p.defaultMethodOptions) || aws_cdk_lib_aws_apigateway_MethodOptions(p.defaultMethodOptions);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_ApiKey(p) {
    }
    function aws_cdk_lib_aws_apigateway_RateLimitedApiKeyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.apiStages != null)
            for (const o of p.apiStages)
              visitedObjects.has(o) || aws_cdk_lib_aws_apigateway_UsagePlanPerApiStage(o);
          if (visitedObjects.has(p.quota) || aws_cdk_lib_aws_apigateway_QuotaSettings(p.quota), visitedObjects.has(p.throttle) || (p.throttle, void 0), "resources" in p && print("aws-cdk-lib.aws_apigateway.ApiKeyProps#resources", "- use `stages` instead"), p.resources != null)
            for (const o of p.resources)
              visitedObjects.has(o) || void 0;
          if (p.stages != null)
            for (const o of p.stages)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.defaultCorsPreflightOptions) || aws_cdk_lib_aws_apigateway_CorsOptions(p.defaultCorsPreflightOptions), visitedObjects.has(p.defaultIntegration) || (p.defaultIntegration, void 0), visitedObjects.has(p.defaultMethodOptions) || aws_cdk_lib_aws_apigateway_MethodOptions(p.defaultMethodOptions);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_RateLimitedApiKey(p) {
    }
    function aws_cdk_lib_aws_apigateway_ThrottleSettings(p) {
    }
    function aws_cdk_lib_aws_apigateway_Period(p) {
    }
    function aws_cdk_lib_aws_apigateway_QuotaSettings(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.period) || (p.period, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_ThrottlingPerMethod(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.method) || (p.method, void 0), visitedObjects.has(p.throttle) || (p.throttle, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_UsagePlanPerApiStage(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.api) || (p.api, void 0), visitedObjects.has(p.stage) || (p.stage, void 0), p.throttle != null)
            for (const o of p.throttle)
              visitedObjects.has(o) || aws_cdk_lib_aws_apigateway_ThrottlingPerMethod(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_UsagePlanProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.apiStages != null)
            for (const o of p.apiStages)
              visitedObjects.has(o) || aws_cdk_lib_aws_apigateway_UsagePlanPerApiStage(o);
          visitedObjects.has(p.quota) || aws_cdk_lib_aws_apigateway_QuotaSettings(p.quota), visitedObjects.has(p.throttle) || (p.throttle, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_AddApiKeyOptions(p) {
    }
    function aws_cdk_lib_aws_apigateway_IUsagePlan(p) {
    }
    function aws_cdk_lib_aws_apigateway_UsagePlan(p) {
    }
    function aws_cdk_lib_aws_apigateway_IVpcLink(p) {
    }
    function aws_cdk_lib_aws_apigateway_VpcLinkProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.targets != null)
            for (const o of p.targets)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_VpcLink(p) {
    }
    function aws_cdk_lib_aws_apigateway_MethodResponse(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.responseModels != null)
            for (const o of Object.values(p.responseModels))
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_IModel(p) {
    }
    function aws_cdk_lib_aws_apigateway_ModelOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.schema) || aws_cdk_lib_aws_apigateway_JsonSchema(p.schema);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_ModelProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.restApi) || (p.restApi, void 0), visitedObjects.has(p.schema) || aws_cdk_lib_aws_apigateway_JsonSchema(p.schema);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_Model(p) {
    }
    function aws_cdk_lib_aws_apigateway_IRequestValidator(p) {
    }
    function aws_cdk_lib_aws_apigateway_RequestValidatorOptions(p) {
    }
    function aws_cdk_lib_aws_apigateway_RequestValidatorProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.restApi) || (p.restApi, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_RequestValidator(p) {
    }
    function aws_cdk_lib_aws_apigateway_Authorizer(p) {
    }
    function aws_cdk_lib_aws_apigateway_IAuthorizer(p) {
    }
    function aws_cdk_lib_aws_apigateway_JsonSchemaVersion(p) {
    }
    function aws_cdk_lib_aws_apigateway_JsonSchemaType(p) {
    }
    function aws_cdk_lib_aws_apigateway_JsonSchema(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.additionalItems != null)
            for (const o of p.additionalItems)
              visitedObjects.has(o) || aws_cdk_lib_aws_apigateway_JsonSchema(o);
          if (p.allOf != null)
            for (const o of p.allOf)
              visitedObjects.has(o) || aws_cdk_lib_aws_apigateway_JsonSchema(o);
          if (p.anyOf != null)
            for (const o of p.anyOf)
              visitedObjects.has(o) || aws_cdk_lib_aws_apigateway_JsonSchema(o);
          if (visitedObjects.has(p.contains) || aws_cdk_lib_aws_apigateway_JsonSchema(p.contains), p.definitions != null)
            for (const o of Object.values(p.definitions))
              visitedObjects.has(o) || aws_cdk_lib_aws_apigateway_JsonSchema(o);
          if (visitedObjects.has(p.items) || aws_cdk_lib_aws_apigateway_JsonSchema(p.items), visitedObjects.has(p.not) || aws_cdk_lib_aws_apigateway_JsonSchema(p.not), p.oneOf != null)
            for (const o of p.oneOf)
              visitedObjects.has(o) || aws_cdk_lib_aws_apigateway_JsonSchema(o);
          if (p.patternProperties != null)
            for (const o of Object.values(p.patternProperties))
              visitedObjects.has(o) || aws_cdk_lib_aws_apigateway_JsonSchema(o);
          if (p.properties != null)
            for (const o of Object.values(p.properties))
              visitedObjects.has(o) || aws_cdk_lib_aws_apigateway_JsonSchema(o);
          visitedObjects.has(p.propertyNames) || aws_cdk_lib_aws_apigateway_JsonSchema(p.propertyNames), visitedObjects.has(p.schema) || (p.schema, void 0), visitedObjects.has(p.type) || (p.type, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_ApiMappingOptions(p) {
    }
    function aws_cdk_lib_aws_apigateway_SecurityPolicy(p) {
    }
    function aws_cdk_lib_aws_apigateway_DomainNameOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.certificate) || (p.certificate, void 0), visitedObjects.has(p.endpointType) || (p.endpointType, void 0), visitedObjects.has(p.mtls) || aws_cdk_lib_aws_apigateway_MTLSConfig(p.mtls), visitedObjects.has(p.securityPolicy) || (p.securityPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_DomainNameProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.mapping) || (p.mapping, void 0), visitedObjects.has(p.certificate) || (p.certificate, void 0), visitedObjects.has(p.endpointType) || (p.endpointType, void 0), visitedObjects.has(p.mtls) || aws_cdk_lib_aws_apigateway_MTLSConfig(p.mtls), visitedObjects.has(p.securityPolicy) || (p.securityPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_IDomainName(p) {
    }
    function aws_cdk_lib_aws_apigateway_DomainName(p) {
    }
    function aws_cdk_lib_aws_apigateway_DomainNameAttributes(p) {
    }
    function aws_cdk_lib_aws_apigateway_MTLSConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bucket) || (p.bucket, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_BasePathMappingOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.stage) || (p.stage, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_BasePathMappingProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.domainName) || (p.domainName, void 0), visitedObjects.has(p.restApi) || (p.restApi, void 0), visitedObjects.has(p.stage) || (p.stage, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_BasePathMapping(p) {
    }
    function aws_cdk_lib_aws_apigateway_CorsOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.maxAge) || (p.maxAge, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_Cors(p) {
    }
    function aws_cdk_lib_aws_apigateway_LambdaAuthorizerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.handler) || (p.handler, void 0), visitedObjects.has(p.assumeRole) || (p.assumeRole, void 0), visitedObjects.has(p.resultsCacheTtl) || (p.resultsCacheTtl, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_TokenAuthorizerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.handler) || (p.handler, void 0), visitedObjects.has(p.assumeRole) || (p.assumeRole, void 0), visitedObjects.has(p.resultsCacheTtl) || (p.resultsCacheTtl, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_TokenAuthorizer(p) {
    }
    function aws_cdk_lib_aws_apigateway_RequestAuthorizerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.handler) || (p.handler, void 0), visitedObjects.has(p.assumeRole) || (p.assumeRole, void 0), visitedObjects.has(p.resultsCacheTtl) || (p.resultsCacheTtl, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_RequestAuthorizer(p) {
    }
    function aws_cdk_lib_aws_apigateway_IdentitySource(p) {
    }
    function aws_cdk_lib_aws_apigateway_CognitoUserPoolsAuthorizerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.cognitoUserPools != null)
            for (const o of p.cognitoUserPools)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.resultsCacheTtl) || (p.resultsCacheTtl, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_CognitoUserPoolsAuthorizer(p) {
    }
    function aws_cdk_lib_aws_apigateway_IAccessLogDestination(p) {
    }
    function aws_cdk_lib_aws_apigateway_AccessLogDestinationConfig(p) {
    }
    function aws_cdk_lib_aws_apigateway_LogGroupLogDestination(p) {
    }
    function aws_cdk_lib_aws_apigateway_AccessLogField(p) {
    }
    function aws_cdk_lib_aws_apigateway_JsonWithStandardFieldProps(p) {
    }
    function aws_cdk_lib_aws_apigateway_AccessLogFormat(p) {
    }
    function aws_cdk_lib_aws_apigateway_ApiDefinition(p) {
    }
    function aws_cdk_lib_aws_apigateway_ApiDefinitionS3Location(p) {
    }
    function aws_cdk_lib_aws_apigateway_ApiDefinitionConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3Location) || (p.s3Location, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_S3ApiDefinition(p) {
    }
    function aws_cdk_lib_aws_apigateway_InlineApiDefinition(p) {
    }
    function aws_cdk_lib_aws_apigateway_AssetApiDefinition(p) {
    }
    function aws_cdk_lib_aws_apigateway_IGatewayResponse(p) {
    }
    function aws_cdk_lib_aws_apigateway_GatewayResponseProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.restApi) || (p.restApi, void 0), visitedObjects.has(p.type) || (p.type, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_GatewayResponseOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.type) || (p.type, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_GatewayResponse(p) {
    }
    function aws_cdk_lib_aws_apigateway_ResponseType(p) {
    }
    function aws_cdk_lib_aws_apigateway_StepFunctionsRestApiProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.stateMachine) || (p.stateMachine, void 0), visitedObjects.has(p.requestContext) || (p.requestContext, void 0), visitedObjects.has(p.role) || (p.role, void 0), visitedObjects.has(p.apiKeySourceType) || (p.apiKeySourceType, void 0), visitedObjects.has(p.cloneFrom) || (p.cloneFrom, void 0), visitedObjects.has(p.endpointConfiguration) || aws_cdk_lib_aws_apigateway_EndpointConfiguration(p.endpointConfiguration), visitedObjects.has(p.minCompressionSize) || (p.minCompressionSize, void 0), "minimumCompressionSize" in p && print("aws-cdk-lib.aws_apigateway.RestApiProps#minimumCompressionSize", "- superseded by `minCompressionSize`"), visitedObjects.has(p.defaultCorsPreflightOptions) || aws_cdk_lib_aws_apigateway_CorsOptions(p.defaultCorsPreflightOptions), visitedObjects.has(p.defaultIntegration) || (p.defaultIntegration, void 0), visitedObjects.has(p.defaultMethodOptions) || aws_cdk_lib_aws_apigateway_MethodOptions(p.defaultMethodOptions), visitedObjects.has(p.deployOptions) || aws_cdk_lib_aws_apigateway_StageOptions(p.deployOptions), visitedObjects.has(p.domainName) || aws_cdk_lib_aws_apigateway_DomainNameOptions(p.domainName), p.endpointTypes != null)
            for (const o of p.endpointTypes)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.policy) || (p.policy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_StepFunctionsRestApi(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnAccountProps(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnAccount(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnApiKeyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.stageKeys) || (p.stageKeys, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_CfnApiKey(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnApiKey_StageKeyProperty(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnAuthorizerProps(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnAuthorizer(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnBasePathMappingProps(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnBasePathMapping(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnClientCertificateProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_CfnClientCertificate(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnDeploymentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.deploymentCanarySettings) || (p.deploymentCanarySettings, void 0), visitedObjects.has(p.stageDescription) || (p.stageDescription, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_CfnDeployment(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnDeployment_AccessLogSettingProperty(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnDeployment_CanarySettingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.stageVariableOverrides) || (p.stageVariableOverrides, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_CfnDeployment_DeploymentCanarySettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.stageVariableOverrides) || (p.stageVariableOverrides, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_CfnDeployment_MethodSettingProperty(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnDeployment_StageDescriptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.accessLogSetting) || (p.accessLogSetting, void 0), visitedObjects.has(p.canarySetting) || (p.canarySetting, void 0), visitedObjects.has(p.methodSettings) || (p.methodSettings, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.variables) || (p.variables, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_CfnDocumentationPartProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.location) || (p.location, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_CfnDocumentationPart(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnDocumentationPart_LocationProperty(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnDocumentationVersionProps(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnDocumentationVersion(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnDomainNameProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.endpointConfiguration) || (p.endpointConfiguration, void 0), visitedObjects.has(p.mutualTlsAuthentication) || (p.mutualTlsAuthentication, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_CfnDomainName(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnDomainName_EndpointConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnDomainName_MutualTlsAuthenticationProperty(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnGatewayResponseProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.responseParameters) || (p.responseParameters, void 0), visitedObjects.has(p.responseTemplates) || (p.responseTemplates, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_CfnGatewayResponse(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnMethodProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.integration) || (p.integration, void 0), visitedObjects.has(p.methodResponses) || (p.methodResponses, void 0), visitedObjects.has(p.requestModels) || (p.requestModels, void 0), visitedObjects.has(p.requestParameters) || (p.requestParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_CfnMethod(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnMethod_IntegrationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.integrationResponses) || (p.integrationResponses, void 0), visitedObjects.has(p.requestParameters) || (p.requestParameters, void 0), visitedObjects.has(p.requestTemplates) || (p.requestTemplates, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_CfnMethod_IntegrationResponseProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.responseParameters) || (p.responseParameters, void 0), visitedObjects.has(p.responseTemplates) || (p.responseTemplates, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_CfnMethod_MethodResponseProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.responseModels) || (p.responseModels, void 0), visitedObjects.has(p.responseParameters) || (p.responseParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_CfnModelProps(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnModel(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnRequestValidatorProps(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnRequestValidator(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnResourceProps(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnResource(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnRestApiProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.bodyS3Location) || (p.bodyS3Location, void 0), visitedObjects.has(p.endpointConfiguration) || (p.endpointConfiguration, void 0), visitedObjects.has(p.parameters) || (p.parameters, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_CfnRestApi(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnRestApi_EndpointConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnRestApi_S3LocationProperty(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnStageProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.accessLogSetting) || (p.accessLogSetting, void 0), visitedObjects.has(p.canarySetting) || (p.canarySetting, void 0), visitedObjects.has(p.methodSettings) || (p.methodSettings, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.variables) || (p.variables, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_CfnStage(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnStage_AccessLogSettingProperty(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnStage_CanarySettingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.stageVariableOverrides) || (p.stageVariableOverrides, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_CfnStage_MethodSettingProperty(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnUsagePlanProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.apiStages) || (p.apiStages, void 0), visitedObjects.has(p.quota) || (p.quota, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.throttle) || (p.throttle, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_CfnUsagePlan(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnUsagePlan_ApiStageProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.throttle) || (p.throttle, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_CfnUsagePlan_QuotaSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnUsagePlan_ThrottleSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnUsagePlanKeyProps(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnUsagePlanKey(p) {
    }
    function aws_cdk_lib_aws_apigateway_CfnVpcLinkProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigateway_CfnVpcLink(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnApiProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bodyS3Location) || (p.bodyS3Location, void 0), visitedObjects.has(p.corsConfiguration) || (p.corsConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnApi(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnApi_BodyS3LocationProperty(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnApi_CorsProperty(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnApiGatewayManagedOverridesProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.integration) || (p.integration, void 0), visitedObjects.has(p.route) || (p.route, void 0), visitedObjects.has(p.stage) || (p.stage, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnApiGatewayManagedOverrides(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnApiGatewayManagedOverrides_AccessLogSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnApiGatewayManagedOverrides_IntegrationOverridesProperty(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnApiGatewayManagedOverrides_RouteOverridesProperty(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnApiGatewayManagedOverrides_RouteSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnApiGatewayManagedOverrides_StageOverridesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.accessLogSettings) || (p.accessLogSettings, void 0), visitedObjects.has(p.defaultRouteSettings) || (p.defaultRouteSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnApiMappingProps(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnApiMapping(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnAuthorizerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.jwtConfiguration) || (p.jwtConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnAuthorizer(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnAuthorizer_JWTConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnDeploymentProps(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnDeployment(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnDomainNameProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.domainNameConfigurations) || (p.domainNameConfigurations, void 0), visitedObjects.has(p.mutualTlsAuthentication) || (p.mutualTlsAuthentication, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnDomainName(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnDomainName_DomainNameConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnDomainName_MutualTlsAuthenticationProperty(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnIntegrationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tlsConfig) || (p.tlsConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnIntegration(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnIntegration_ResponseParameterProperty(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnIntegration_ResponseParameterListProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.responseParameters) || (p.responseParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnIntegration_TlsConfigProperty(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnIntegrationResponseProps(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnIntegrationResponse(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnModelProps(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnModel(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnRouteProps(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnRoute(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnRoute_ParameterConstraintsProperty(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnRouteResponseProps(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnRouteResponse(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnRouteResponse_ParameterConstraintsProperty(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnStageProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.accessLogSettings) || (p.accessLogSettings, void 0), visitedObjects.has(p.defaultRouteSettings) || (p.defaultRouteSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnStage(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnStage_AccessLogSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnStage_RouteSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnVpcLinkProps(p) {
    }
    function aws_cdk_lib_aws_apigatewayv2_CfnVpcLink(p) {
    }
    function aws_cdk_lib_aws_appconfig_CfnApplicationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appconfig_CfnApplication(p) {
    }
    function aws_cdk_lib_aws_appconfig_CfnApplication_TagsProperty(p) {
    }
    function aws_cdk_lib_aws_appconfig_CfnConfigurationProfileProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.validators) || (p.validators, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appconfig_CfnConfigurationProfile(p) {
    }
    function aws_cdk_lib_aws_appconfig_CfnConfigurationProfile_TagsProperty(p) {
    }
    function aws_cdk_lib_aws_appconfig_CfnConfigurationProfile_ValidatorsProperty(p) {
    }
    function aws_cdk_lib_aws_appconfig_CfnDeploymentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appconfig_CfnDeployment(p) {
    }
    function aws_cdk_lib_aws_appconfig_CfnDeployment_TagsProperty(p) {
    }
    function aws_cdk_lib_aws_appconfig_CfnDeploymentStrategyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appconfig_CfnDeploymentStrategy(p) {
    }
    function aws_cdk_lib_aws_appconfig_CfnDeploymentStrategy_TagsProperty(p) {
    }
    function aws_cdk_lib_aws_appconfig_CfnEnvironmentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.monitors) || (p.monitors, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appconfig_CfnEnvironment(p) {
    }
    function aws_cdk_lib_aws_appconfig_CfnEnvironment_MonitorsProperty(p) {
    }
    function aws_cdk_lib_aws_appconfig_CfnEnvironment_TagsProperty(p) {
    }
    function aws_cdk_lib_aws_appconfig_CfnExtensionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.parameters) || (p.parameters, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appconfig_CfnExtension(p) {
    }
    function aws_cdk_lib_aws_appconfig_CfnExtension_ParameterProperty(p) {
    }
    function aws_cdk_lib_aws_appconfig_CfnExtensionAssociationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.parameters) || (p.parameters, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appconfig_CfnExtensionAssociation(p) {
    }
    function aws_cdk_lib_aws_appconfig_CfnHostedConfigurationVersionProps(p) {
    }
    function aws_cdk_lib_aws_appconfig_CfnHostedConfigurationVersion(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.connectorProvisioningConfig) || (p.connectorProvisioningConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnConnector(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnConnector_ConnectorProvisioningConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.lambda) || (p.lambda, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnConnector_LambdaConnectorProvisioningConfigProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfileProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.connectorProfileConfig) || (p.connectorProfileConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_AmplitudeConnectorProfileCredentialsProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_ApiKeyCredentialsProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_BasicAuthCredentialsProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_ConnectorOAuthRequestProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_ConnectorProfileConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.connectorProfileCredentials) || (p.connectorProfileCredentials, void 0), visitedObjects.has(p.connectorProfileProperties) || (p.connectorProfileProperties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_ConnectorProfileCredentialsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.amplitude) || (p.amplitude, void 0), visitedObjects.has(p.customConnector) || (p.customConnector, void 0), visitedObjects.has(p.datadog) || (p.datadog, void 0), visitedObjects.has(p.dynatrace) || (p.dynatrace, void 0), visitedObjects.has(p.googleAnalytics) || (p.googleAnalytics, void 0), visitedObjects.has(p.inforNexus) || (p.inforNexus, void 0), visitedObjects.has(p.marketo) || (p.marketo, void 0), visitedObjects.has(p.pardot) || (p.pardot, void 0), visitedObjects.has(p.redshift) || (p.redshift, void 0), visitedObjects.has(p.salesforce) || (p.salesforce, void 0), visitedObjects.has(p.sapoData) || (p.sapoData, void 0), visitedObjects.has(p.serviceNow) || (p.serviceNow, void 0), visitedObjects.has(p.singular) || (p.singular, void 0), visitedObjects.has(p.slack) || (p.slack, void 0), visitedObjects.has(p.snowflake) || (p.snowflake, void 0), visitedObjects.has(p.trendmicro) || (p.trendmicro, void 0), visitedObjects.has(p.veeva) || (p.veeva, void 0), visitedObjects.has(p.zendesk) || (p.zendesk, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_ConnectorProfilePropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customConnector) || (p.customConnector, void 0), visitedObjects.has(p.datadog) || (p.datadog, void 0), visitedObjects.has(p.dynatrace) || (p.dynatrace, void 0), visitedObjects.has(p.inforNexus) || (p.inforNexus, void 0), visitedObjects.has(p.marketo) || (p.marketo, void 0), visitedObjects.has(p.pardot) || (p.pardot, void 0), visitedObjects.has(p.redshift) || (p.redshift, void 0), visitedObjects.has(p.salesforce) || (p.salesforce, void 0), visitedObjects.has(p.sapoData) || (p.sapoData, void 0), visitedObjects.has(p.serviceNow) || (p.serviceNow, void 0), visitedObjects.has(p.slack) || (p.slack, void 0), visitedObjects.has(p.snowflake) || (p.snowflake, void 0), visitedObjects.has(p.veeva) || (p.veeva, void 0), visitedObjects.has(p.zendesk) || (p.zendesk, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_CustomAuthCredentialsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.credentialsMap) || (p.credentialsMap, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_CustomConnectorProfileCredentialsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.apiKey) || (p.apiKey, void 0), visitedObjects.has(p.basic) || (p.basic, void 0), visitedObjects.has(p.custom) || (p.custom, void 0), visitedObjects.has(p.oauth2) || (p.oauth2, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_CustomConnectorProfilePropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.oAuth2Properties) || (p.oAuth2Properties, void 0), visitedObjects.has(p.profileProperties) || (p.profileProperties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_DatadogConnectorProfileCredentialsProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_DatadogConnectorProfilePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_DynatraceConnectorProfileCredentialsProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_DynatraceConnectorProfilePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_GoogleAnalyticsConnectorProfileCredentialsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.connectorOAuthRequest) || (p.connectorOAuthRequest, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_InforNexusConnectorProfileCredentialsProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_InforNexusConnectorProfilePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_MarketoConnectorProfileCredentialsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.connectorOAuthRequest) || (p.connectorOAuthRequest, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_MarketoConnectorProfilePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_OAuth2CredentialsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.oAuthRequest) || (p.oAuthRequest, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_OAuth2PropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tokenUrlCustomProperties) || (p.tokenUrlCustomProperties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_OAuthCredentialsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.connectorOAuthRequest) || (p.connectorOAuthRequest, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_OAuthPropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_PardotConnectorProfileCredentialsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.connectorOAuthRequest) || (p.connectorOAuthRequest, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_PardotConnectorProfilePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_RedshiftConnectorProfileCredentialsProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_RedshiftConnectorProfilePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_SAPODataConnectorProfileCredentialsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.basicAuthCredentials) || (p.basicAuthCredentials, void 0), visitedObjects.has(p.oAuthCredentials) || (p.oAuthCredentials, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_SAPODataConnectorProfilePropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.oAuthProperties) || (p.oAuthProperties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_SalesforceConnectorProfileCredentialsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.connectorOAuthRequest) || (p.connectorOAuthRequest, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_SalesforceConnectorProfilePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_ServiceNowConnectorProfileCredentialsProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_ServiceNowConnectorProfilePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_SingularConnectorProfileCredentialsProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_SlackConnectorProfileCredentialsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.connectorOAuthRequest) || (p.connectorOAuthRequest, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_SlackConnectorProfilePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_SnowflakeConnectorProfileCredentialsProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_SnowflakeConnectorProfilePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_TrendmicroConnectorProfileCredentialsProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_VeevaConnectorProfileCredentialsProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_VeevaConnectorProfilePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_ZendeskConnectorProfileCredentialsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.connectorOAuthRequest) || (p.connectorOAuthRequest, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnConnectorProfile_ZendeskConnectorProfilePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnFlowProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.destinationFlowConfigList) || (p.destinationFlowConfigList, void 0), visitedObjects.has(p.sourceFlowConfig) || (p.sourceFlowConfig, void 0), visitedObjects.has(p.tasks) || (p.tasks, void 0), visitedObjects.has(p.triggerConfig) || (p.triggerConfig, void 0), visitedObjects.has(p.metadataCatalogConfig) || (p.metadataCatalogConfig, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnFlow(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_AggregationConfigProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_AmplitudeSourcePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_ConnectorOperatorProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_CustomConnectorDestinationPropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customProperties) || (p.customProperties, void 0), visitedObjects.has(p.errorHandlingConfig) || (p.errorHandlingConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_CustomConnectorSourcePropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customProperties) || (p.customProperties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_DatadogSourcePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_DestinationConnectorPropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customConnector) || (p.customConnector, void 0), visitedObjects.has(p.eventBridge) || (p.eventBridge, void 0), visitedObjects.has(p.lookoutMetrics) || (p.lookoutMetrics, void 0), visitedObjects.has(p.marketo) || (p.marketo, void 0), visitedObjects.has(p.redshift) || (p.redshift, void 0), visitedObjects.has(p.s3) || (p.s3, void 0), visitedObjects.has(p.salesforce) || (p.salesforce, void 0), visitedObjects.has(p.sapoData) || (p.sapoData, void 0), visitedObjects.has(p.snowflake) || (p.snowflake, void 0), visitedObjects.has(p.upsolver) || (p.upsolver, void 0), visitedObjects.has(p.zendesk) || (p.zendesk, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_DestinationFlowConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destinationConnectorProperties) || (p.destinationConnectorProperties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_DynatraceSourcePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_ErrorHandlingConfigProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_EventBridgeDestinationPropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.errorHandlingConfig) || (p.errorHandlingConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_GlueDataCatalogProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_GoogleAnalyticsSourcePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_IncrementalPullConfigProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_InforNexusSourcePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_LookoutMetricsDestinationPropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_MarketoDestinationPropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.errorHandlingConfig) || (p.errorHandlingConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_MarketoSourcePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_MetadataCatalogConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.glueDataCatalog) || (p.glueDataCatalog, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_PardotSourcePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_PrefixConfigProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_RedshiftDestinationPropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.errorHandlingConfig) || (p.errorHandlingConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_S3DestinationPropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3OutputFormatConfig) || (p.s3OutputFormatConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_S3InputFormatConfigProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_S3OutputFormatConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.aggregationConfig) || (p.aggregationConfig, void 0), visitedObjects.has(p.prefixConfig) || (p.prefixConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_S3SourcePropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3InputFormatConfig) || (p.s3InputFormatConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_SAPODataDestinationPropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.errorHandlingConfig) || (p.errorHandlingConfig, void 0), visitedObjects.has(p.successResponseHandlingConfig) || (p.successResponseHandlingConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_SAPODataSourcePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_SalesforceDestinationPropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.errorHandlingConfig) || (p.errorHandlingConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_SalesforceSourcePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_ScheduledTriggerPropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_ServiceNowSourcePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_SingularSourcePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_SlackSourcePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_SnowflakeDestinationPropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.errorHandlingConfig) || (p.errorHandlingConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_SourceConnectorPropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.amplitude) || (p.amplitude, void 0), visitedObjects.has(p.customConnector) || (p.customConnector, void 0), visitedObjects.has(p.datadog) || (p.datadog, void 0), visitedObjects.has(p.dynatrace) || (p.dynatrace, void 0), visitedObjects.has(p.googleAnalytics) || (p.googleAnalytics, void 0), visitedObjects.has(p.inforNexus) || (p.inforNexus, void 0), visitedObjects.has(p.marketo) || (p.marketo, void 0), visitedObjects.has(p.pardot) || (p.pardot, void 0), visitedObjects.has(p.s3) || (p.s3, void 0), visitedObjects.has(p.salesforce) || (p.salesforce, void 0), visitedObjects.has(p.sapoData) || (p.sapoData, void 0), visitedObjects.has(p.serviceNow) || (p.serviceNow, void 0), visitedObjects.has(p.singular) || (p.singular, void 0), visitedObjects.has(p.slack) || (p.slack, void 0), visitedObjects.has(p.trendmicro) || (p.trendmicro, void 0), visitedObjects.has(p.veeva) || (p.veeva, void 0), visitedObjects.has(p.zendesk) || (p.zendesk, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_SourceFlowConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sourceConnectorProperties) || (p.sourceConnectorProperties, void 0), visitedObjects.has(p.incrementalPullConfig) || (p.incrementalPullConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_SuccessResponseHandlingConfigProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_TaskProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.connectorOperator) || (p.connectorOperator, void 0), visitedObjects.has(p.taskProperties) || (p.taskProperties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_TaskPropertiesObjectProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_TrendmicroSourcePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_TriggerConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.triggerProperties) || (p.triggerProperties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_UpsolverDestinationPropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3OutputFormatConfig) || (p.s3OutputFormatConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_UpsolverS3OutputFormatConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.prefixConfig) || (p.prefixConfig, void 0), visitedObjects.has(p.aggregationConfig) || (p.aggregationConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_VeevaSourcePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_ZendeskDestinationPropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.errorHandlingConfig) || (p.errorHandlingConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appflow_CfnFlow_ZendeskSourcePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_appintegrations_CfnDataIntegrationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.scheduleConfig) || (p.scheduleConfig, void 0), visitedObjects.has(p.fileConfiguration) || (p.fileConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appintegrations_CfnDataIntegration(p) {
    }
    function aws_cdk_lib_aws_appintegrations_CfnDataIntegration_FileConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_appintegrations_CfnDataIntegration_ScheduleConfigProperty(p) {
    }
    function aws_cdk_lib_aws_appintegrations_CfnEventIntegrationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.eventFilter) || (p.eventFilter, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appintegrations_CfnEventIntegration(p) {
    }
    function aws_cdk_lib_aws_appintegrations_CfnEventIntegration_EventFilterProperty(p) {
    }
    function aws_cdk_lib_aws_applicationautoscaling_CfnScalableTargetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.scheduledActions) || (p.scheduledActions, void 0), visitedObjects.has(p.suspendedState) || (p.suspendedState, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_applicationautoscaling_CfnScalableTarget(p) {
    }
    function aws_cdk_lib_aws_applicationautoscaling_CfnScalableTarget_ScalableTargetActionProperty(p) {
    }
    function aws_cdk_lib_aws_applicationautoscaling_CfnScalableTarget_ScheduledActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.endTime) || (p.endTime, void 0), visitedObjects.has(p.scalableTargetAction) || (p.scalableTargetAction, void 0), visitedObjects.has(p.startTime) || (p.startTime, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_applicationautoscaling_CfnScalableTarget_SuspendedStateProperty(p) {
    }
    function aws_cdk_lib_aws_applicationautoscaling_CfnScalingPolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.stepScalingPolicyConfiguration) || (p.stepScalingPolicyConfiguration, void 0), visitedObjects.has(p.targetTrackingScalingPolicyConfiguration) || (p.targetTrackingScalingPolicyConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_applicationautoscaling_CfnScalingPolicy(p) {
    }
    function aws_cdk_lib_aws_applicationautoscaling_CfnScalingPolicy_CustomizedMetricSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dimensions) || (p.dimensions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_applicationautoscaling_CfnScalingPolicy_MetricDimensionProperty(p) {
    }
    function aws_cdk_lib_aws_applicationautoscaling_CfnScalingPolicy_PredefinedMetricSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_applicationautoscaling_CfnScalingPolicy_StepAdjustmentProperty(p) {
    }
    function aws_cdk_lib_aws_applicationautoscaling_CfnScalingPolicy_StepScalingPolicyConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.stepAdjustments) || (p.stepAdjustments, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_applicationautoscaling_CfnScalingPolicy_TargetTrackingScalingPolicyConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customizedMetricSpecification) || (p.customizedMetricSpecification, void 0), visitedObjects.has(p.predefinedMetricSpecification) || (p.predefinedMetricSpecification, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_applicationautoscaling_BaseScalableAttributeProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.role) || (p.role, void 0), visitedObjects.has(p.serviceNamespace) || (p.serviceNamespace, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_applicationautoscaling_BaseScalableAttribute(p) {
    }
    function aws_cdk_lib_aws_applicationautoscaling_EnableScalingProps(p) {
    }
    function aws_cdk_lib_aws_applicationautoscaling_Schedule(p) {
    }
    function aws_cdk_lib_aws_applicationautoscaling_CronOptions(p) {
    }
    function aws_cdk_lib_aws_applicationautoscaling_IScalableTarget(p) {
    }
    function aws_cdk_lib_aws_applicationautoscaling_ScalableTargetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.serviceNamespace) || (p.serviceNamespace, void 0), visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_applicationautoscaling_ScalableTarget(p) {
    }
    function aws_cdk_lib_aws_applicationautoscaling_ScalingSchedule(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.schedule) || (p.schedule, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_applicationautoscaling_ServiceNamespace(p) {
    }
    function aws_cdk_lib_aws_applicationautoscaling_BasicStepScalingPolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.metric) || (p.metric, void 0), p.scalingSteps != null)
            for (const o of p.scalingSteps)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.adjustmentType) || (p.adjustmentType, void 0), visitedObjects.has(p.cooldown) || (p.cooldown, void 0), visitedObjects.has(p.metricAggregationType) || (p.metricAggregationType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_applicationautoscaling_StepScalingPolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.scalingTarget) || (p.scalingTarget, void 0), visitedObjects.has(p.metric) || (p.metric, void 0), p.scalingSteps != null)
            for (const o of p.scalingSteps)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.adjustmentType) || (p.adjustmentType, void 0), visitedObjects.has(p.cooldown) || (p.cooldown, void 0), visitedObjects.has(p.metricAggregationType) || (p.metricAggregationType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_applicationautoscaling_StepScalingPolicy(p) {
    }
    function aws_cdk_lib_aws_applicationautoscaling_ScalingInterval(p) {
    }
    function aws_cdk_lib_aws_applicationautoscaling_StepScalingActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.scalingTarget) || (p.scalingTarget, void 0), visitedObjects.has(p.adjustmentType) || (p.adjustmentType, void 0), visitedObjects.has(p.cooldown) || (p.cooldown, void 0), visitedObjects.has(p.metricAggregationType) || (p.metricAggregationType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_applicationautoscaling_StepScalingAction(p) {
    }
    function aws_cdk_lib_aws_applicationautoscaling_AdjustmentType(p) {
    }
    function aws_cdk_lib_aws_applicationautoscaling_MetricAggregationType(p) {
    }
    function aws_cdk_lib_aws_applicationautoscaling_AdjustmentTier(p) {
    }
    function aws_cdk_lib_aws_applicationautoscaling_BaseTargetTrackingProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.scaleInCooldown) || (p.scaleInCooldown, void 0), visitedObjects.has(p.scaleOutCooldown) || (p.scaleOutCooldown, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_applicationautoscaling_BasicTargetTrackingScalingPolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customMetric) || (p.customMetric, void 0), visitedObjects.has(p.predefinedMetric) || aws_cdk_lib_aws_applicationautoscaling_PredefinedMetric(p.predefinedMetric), visitedObjects.has(p.scaleInCooldown) || (p.scaleInCooldown, void 0), visitedObjects.has(p.scaleOutCooldown) || (p.scaleOutCooldown, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_applicationautoscaling_TargetTrackingScalingPolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.scalingTarget) || (p.scalingTarget, void 0), visitedObjects.has(p.customMetric) || (p.customMetric, void 0), visitedObjects.has(p.predefinedMetric) || aws_cdk_lib_aws_applicationautoscaling_PredefinedMetric(p.predefinedMetric), visitedObjects.has(p.scaleInCooldown) || (p.scaleInCooldown, void 0), visitedObjects.has(p.scaleOutCooldown) || (p.scaleOutCooldown, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_applicationautoscaling_TargetTrackingScalingPolicy(p) {
    }
    function aws_cdk_lib_aws_applicationautoscaling_PredefinedMetric(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          const ns = require_target_tracking_scaling_policy();
          if (Object.values(ns.PredefinedMetric).filter((x) => x === p).length > 1)
            return;
          p === ns.PredefinedMetric.DYANMODB_WRITE_CAPACITY_UTILIZATION && print("aws-cdk-lib.aws_applicationautoscaling.PredefinedMetric#DYANMODB_WRITE_CAPACITY_UTILIZATION", "use `PredefinedMetric.DYNAMODB_WRITE_CAPACITY_UTILIZATION`");
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_applicationinsights_CfnApplicationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.componentMonitoringSettings) || (p.componentMonitoringSettings, void 0), visitedObjects.has(p.customComponents) || (p.customComponents, void 0), visitedObjects.has(p.logPatternSets) || (p.logPatternSets, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_applicationinsights_CfnApplication(p) {
    }
    function aws_cdk_lib_aws_applicationinsights_CfnApplication_AlarmProperty(p) {
    }
    function aws_cdk_lib_aws_applicationinsights_CfnApplication_AlarmMetricProperty(p) {
    }
    function aws_cdk_lib_aws_applicationinsights_CfnApplication_ComponentConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.configurationDetails) || (p.configurationDetails, void 0), visitedObjects.has(p.subComponentTypeConfigurations) || (p.subComponentTypeConfigurations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_applicationinsights_CfnApplication_ComponentMonitoringSettingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customComponentConfiguration) || (p.customComponentConfiguration, void 0), visitedObjects.has(p.defaultOverwriteComponentConfiguration) || (p.defaultOverwriteComponentConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_applicationinsights_CfnApplication_ConfigurationDetailsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.alarmMetrics) || (p.alarmMetrics, void 0), visitedObjects.has(p.alarms) || (p.alarms, void 0), visitedObjects.has(p.haClusterPrometheusExporter) || (p.haClusterPrometheusExporter, void 0), visitedObjects.has(p.hanaPrometheusExporter) || (p.hanaPrometheusExporter, void 0), visitedObjects.has(p.jmxPrometheusExporter) || (p.jmxPrometheusExporter, void 0), visitedObjects.has(p.logs) || (p.logs, void 0), visitedObjects.has(p.windowsEvents) || (p.windowsEvents, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_applicationinsights_CfnApplication_CustomComponentProperty(p) {
    }
    function aws_cdk_lib_aws_applicationinsights_CfnApplication_HAClusterPrometheusExporterProperty(p) {
    }
    function aws_cdk_lib_aws_applicationinsights_CfnApplication_HANAPrometheusExporterProperty(p) {
    }
    function aws_cdk_lib_aws_applicationinsights_CfnApplication_JMXPrometheusExporterProperty(p) {
    }
    function aws_cdk_lib_aws_applicationinsights_CfnApplication_LogProperty(p) {
    }
    function aws_cdk_lib_aws_applicationinsights_CfnApplication_LogPatternProperty(p) {
    }
    function aws_cdk_lib_aws_applicationinsights_CfnApplication_LogPatternSetProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.logPatterns) || (p.logPatterns, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_applicationinsights_CfnApplication_SubComponentConfigurationDetailsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.alarmMetrics) || (p.alarmMetrics, void 0), visitedObjects.has(p.logs) || (p.logs, void 0), visitedObjects.has(p.windowsEvents) || (p.windowsEvents, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_applicationinsights_CfnApplication_SubComponentTypeConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.subComponentConfigurationDetails) || (p.subComponentConfigurationDetails, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_applicationinsights_CfnApplication_WindowsEventProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnGatewayRouteProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.spec) || (p.spec, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnGatewayRoute(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnGatewayRoute_GatewayRouteHostnameMatchProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnGatewayRoute_GatewayRouteHostnameRewriteProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnGatewayRoute_GatewayRouteMetadataMatchProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.range) || (p.range, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnGatewayRoute_GatewayRouteRangeMatchProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnGatewayRoute_GatewayRouteSpecProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.grpcRoute) || (p.grpcRoute, void 0), visitedObjects.has(p.http2Route) || (p.http2Route, void 0), visitedObjects.has(p.httpRoute) || (p.httpRoute, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnGatewayRoute_GatewayRouteTargetProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.virtualService) || (p.virtualService, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnGatewayRoute_GatewayRouteVirtualServiceProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnGatewayRoute_GrpcGatewayRouteProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.action) || (p.action, void 0), visitedObjects.has(p.match) || (p.match, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnGatewayRoute_GrpcGatewayRouteActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.target) || (p.target, void 0), visitedObjects.has(p.rewrite) || (p.rewrite, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnGatewayRoute_GrpcGatewayRouteMatchProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.hostname) || (p.hostname, void 0), visitedObjects.has(p.metadata) || (p.metadata, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnGatewayRoute_GrpcGatewayRouteMetadataProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.match) || (p.match, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnGatewayRoute_GrpcGatewayRouteRewriteProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.hostname) || (p.hostname, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnGatewayRoute_HttpGatewayRouteProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.action) || (p.action, void 0), visitedObjects.has(p.match) || (p.match, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnGatewayRoute_HttpGatewayRouteActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.target) || (p.target, void 0), visitedObjects.has(p.rewrite) || (p.rewrite, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnGatewayRoute_HttpGatewayRouteHeaderProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.match) || (p.match, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnGatewayRoute_HttpGatewayRouteHeaderMatchProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.range) || (p.range, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnGatewayRoute_HttpGatewayRouteMatchProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.headers) || (p.headers, void 0), visitedObjects.has(p.hostname) || (p.hostname, void 0), visitedObjects.has(p.path) || (p.path, void 0), visitedObjects.has(p.queryParameters) || (p.queryParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnGatewayRoute_HttpGatewayRoutePathRewriteProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnGatewayRoute_HttpGatewayRoutePrefixRewriteProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnGatewayRoute_HttpGatewayRouteRewriteProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.hostname) || (p.hostname, void 0), visitedObjects.has(p.path) || (p.path, void 0), visitedObjects.has(p.prefix) || (p.prefix, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnGatewayRoute_HttpPathMatchProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnGatewayRoute_HttpQueryParameterMatchProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnGatewayRoute_QueryParameterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.match) || (p.match, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnMeshProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.spec) || (p.spec, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnMesh(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnMesh_EgressFilterProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnMesh_MeshServiceDiscoveryProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnMesh_MeshSpecProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.egressFilter) || (p.egressFilter, void 0), visitedObjects.has(p.serviceDiscovery) || (p.serviceDiscovery, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnRouteProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.spec) || (p.spec, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnRoute(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnRoute_DurationProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnRoute_GrpcRetryPolicyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.perRetryTimeout) || (p.perRetryTimeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnRoute_GrpcRouteProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.action) || (p.action, void 0), visitedObjects.has(p.match) || (p.match, void 0), visitedObjects.has(p.retryPolicy) || (p.retryPolicy, void 0), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnRoute_GrpcRouteActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.weightedTargets) || (p.weightedTargets, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnRoute_GrpcRouteMatchProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.metadata) || (p.metadata, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnRoute_GrpcRouteMetadataProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.match) || (p.match, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnRoute_GrpcRouteMetadataMatchMethodProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.range) || (p.range, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnRoute_GrpcTimeoutProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.idle) || (p.idle, void 0), visitedObjects.has(p.perRequest) || (p.perRequest, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnRoute_HeaderMatchMethodProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.range) || (p.range, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnRoute_HttpPathMatchProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnRoute_HttpQueryParameterMatchProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnRoute_HttpRetryPolicyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.perRetryTimeout) || (p.perRetryTimeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnRoute_HttpRouteProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.action) || (p.action, void 0), visitedObjects.has(p.match) || (p.match, void 0), visitedObjects.has(p.retryPolicy) || (p.retryPolicy, void 0), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnRoute_HttpRouteActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.weightedTargets) || (p.weightedTargets, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnRoute_HttpRouteHeaderProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.match) || (p.match, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnRoute_HttpRouteMatchProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.headers) || (p.headers, void 0), visitedObjects.has(p.path) || (p.path, void 0), visitedObjects.has(p.queryParameters) || (p.queryParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnRoute_HttpTimeoutProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.idle) || (p.idle, void 0), visitedObjects.has(p.perRequest) || (p.perRequest, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnRoute_MatchRangeProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnRoute_QueryParameterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.match) || (p.match, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnRoute_RouteSpecProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.grpcRoute) || (p.grpcRoute, void 0), visitedObjects.has(p.http2Route) || (p.http2Route, void 0), visitedObjects.has(p.httpRoute) || (p.httpRoute, void 0), visitedObjects.has(p.tcpRoute) || (p.tcpRoute, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnRoute_TcpRouteProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.action) || (p.action, void 0), visitedObjects.has(p.match) || (p.match, void 0), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnRoute_TcpRouteActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.weightedTargets) || (p.weightedTargets, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnRoute_TcpRouteMatchProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnRoute_TcpTimeoutProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.idle) || (p.idle, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnRoute_WeightedTargetProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGatewayProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.spec) || (p.spec, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway_JsonFormatRefProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway_LoggingFormatProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.json) || (p.json, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway_SubjectAlternativeNameMatchersProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway_SubjectAlternativeNamesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.match) || (p.match, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayAccessLogProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.file) || (p.file, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayBackendDefaultsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.clientPolicy) || (p.clientPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayClientPolicyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tls) || (p.tls, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayClientPolicyTlsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.validation) || (p.validation, void 0), visitedObjects.has(p.certificate) || (p.certificate, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayClientTlsCertificateProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.file) || (p.file, void 0), visitedObjects.has(p.sds) || (p.sds, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayConnectionPoolProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.grpc) || (p.grpc, void 0), visitedObjects.has(p.http) || (p.http, void 0), visitedObjects.has(p.http2) || (p.http2, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayFileAccessLogProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.format) || (p.format, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayGrpcConnectionPoolProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayHealthCheckPolicyProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayHttp2ConnectionPoolProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayHttpConnectionPoolProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayListenerProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.portMapping) || (p.portMapping, void 0), visitedObjects.has(p.connectionPool) || (p.connectionPool, void 0), visitedObjects.has(p.healthCheck) || (p.healthCheck, void 0), visitedObjects.has(p.tls) || (p.tls, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayListenerTlsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.certificate) || (p.certificate, void 0), visitedObjects.has(p.validation) || (p.validation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayListenerTlsAcmCertificateProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayListenerTlsCertificateProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.acm) || (p.acm, void 0), visitedObjects.has(p.file) || (p.file, void 0), visitedObjects.has(p.sds) || (p.sds, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayListenerTlsFileCertificateProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayListenerTlsSdsCertificateProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayListenerTlsValidationContextProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.trust) || (p.trust, void 0), visitedObjects.has(p.subjectAlternativeNames) || (p.subjectAlternativeNames, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayListenerTlsValidationContextTrustProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.file) || (p.file, void 0), visitedObjects.has(p.sds) || (p.sds, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayLoggingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.accessLog) || (p.accessLog, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayPortMappingProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewaySpecProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.listeners) || (p.listeners, void 0), visitedObjects.has(p.backendDefaults) || (p.backendDefaults, void 0), visitedObjects.has(p.logging) || (p.logging, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayTlsValidationContextProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.trust) || (p.trust, void 0), visitedObjects.has(p.subjectAlternativeNames) || (p.subjectAlternativeNames, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayTlsValidationContextAcmTrustProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayTlsValidationContextFileTrustProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayTlsValidationContextSdsTrustProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayTlsValidationContextTrustProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.acm) || (p.acm, void 0), visitedObjects.has(p.file) || (p.file, void 0), visitedObjects.has(p.sds) || (p.sds, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNodeProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.spec) || (p.spec, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_AccessLogProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.file) || (p.file, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_AwsCloudMapInstanceAttributeProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_AwsCloudMapServiceDiscoveryProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.attributes) || (p.attributes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_BackendProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.virtualService) || (p.virtualService, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_BackendDefaultsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.clientPolicy) || (p.clientPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_ClientPolicyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tls) || (p.tls, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_ClientPolicyTlsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.validation) || (p.validation, void 0), visitedObjects.has(p.certificate) || (p.certificate, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_ClientTlsCertificateProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.file) || (p.file, void 0), visitedObjects.has(p.sds) || (p.sds, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_DnsServiceDiscoveryProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_DurationProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_FileAccessLogProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.format) || (p.format, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_GrpcTimeoutProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.idle) || (p.idle, void 0), visitedObjects.has(p.perRequest) || (p.perRequest, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_HealthCheckProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_HttpTimeoutProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.idle) || (p.idle, void 0), visitedObjects.has(p.perRequest) || (p.perRequest, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_JsonFormatRefProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_ListenerProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.portMapping) || (p.portMapping, void 0), visitedObjects.has(p.connectionPool) || (p.connectionPool, void 0), visitedObjects.has(p.healthCheck) || (p.healthCheck, void 0), visitedObjects.has(p.outlierDetection) || (p.outlierDetection, void 0), visitedObjects.has(p.timeout) || (p.timeout, void 0), visitedObjects.has(p.tls) || (p.tls, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_ListenerTimeoutProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.grpc) || (p.grpc, void 0), visitedObjects.has(p.http) || (p.http, void 0), visitedObjects.has(p.http2) || (p.http2, void 0), visitedObjects.has(p.tcp) || (p.tcp, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_ListenerTlsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.certificate) || (p.certificate, void 0), visitedObjects.has(p.validation) || (p.validation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_ListenerTlsAcmCertificateProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_ListenerTlsCertificateProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.acm) || (p.acm, void 0), visitedObjects.has(p.file) || (p.file, void 0), visitedObjects.has(p.sds) || (p.sds, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_ListenerTlsFileCertificateProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_ListenerTlsSdsCertificateProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_ListenerTlsValidationContextProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.trust) || (p.trust, void 0), visitedObjects.has(p.subjectAlternativeNames) || (p.subjectAlternativeNames, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_ListenerTlsValidationContextTrustProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.file) || (p.file, void 0), visitedObjects.has(p.sds) || (p.sds, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_LoggingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.accessLog) || (p.accessLog, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_LoggingFormatProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.json) || (p.json, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_OutlierDetectionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.baseEjectionDuration) || (p.baseEjectionDuration, void 0), visitedObjects.has(p.interval) || (p.interval, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_PortMappingProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_ServiceDiscoveryProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.awsCloudMap) || (p.awsCloudMap, void 0), visitedObjects.has(p.dns) || (p.dns, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_SubjectAlternativeNameMatchersProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_SubjectAlternativeNamesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.match) || (p.match, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_TcpTimeoutProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.idle) || (p.idle, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_TlsValidationContextProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.trust) || (p.trust, void 0), visitedObjects.has(p.subjectAlternativeNames) || (p.subjectAlternativeNames, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_TlsValidationContextAcmTrustProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_TlsValidationContextFileTrustProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_TlsValidationContextSdsTrustProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_TlsValidationContextTrustProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.acm) || (p.acm, void 0), visitedObjects.has(p.file) || (p.file, void 0), visitedObjects.has(p.sds) || (p.sds, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_VirtualNodeConnectionPoolProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.grpc) || (p.grpc, void 0), visitedObjects.has(p.http) || (p.http, void 0), visitedObjects.has(p.http2) || (p.http2, void 0), visitedObjects.has(p.tcp) || (p.tcp, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_VirtualNodeGrpcConnectionPoolProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_VirtualNodeHttp2ConnectionPoolProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_VirtualNodeHttpConnectionPoolProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_VirtualNodeSpecProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.backendDefaults) || (p.backendDefaults, void 0), visitedObjects.has(p.backends) || (p.backends, void 0), visitedObjects.has(p.listeners) || (p.listeners, void 0), visitedObjects.has(p.logging) || (p.logging, void 0), visitedObjects.has(p.serviceDiscovery) || (p.serviceDiscovery, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_VirtualNodeTcpConnectionPoolProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualNode_VirtualServiceBackendProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.clientPolicy) || (p.clientPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualRouterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.spec) || (p.spec, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualRouter(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualRouter_PortMappingProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualRouter_VirtualRouterListenerProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.portMapping) || (p.portMapping, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualRouter_VirtualRouterSpecProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.listeners) || (p.listeners, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualServiceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.spec) || (p.spec, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualService(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualService_VirtualNodeServiceProviderProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualService_VirtualRouterServiceProviderProperty(p) {
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualService_VirtualServiceProviderProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.virtualNode) || (p.virtualNode, void 0), visitedObjects.has(p.virtualRouter) || (p.virtualRouter, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CfnVirtualService_VirtualServiceSpecProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.provider) || (p.provider, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_MeshFilterType(p) {
    }
    function aws_cdk_lib_aws_appmesh_IMesh(p) {
    }
    function aws_cdk_lib_aws_appmesh_MeshProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.egressFilter) || (p.egressFilter, void 0), visitedObjects.has(p.serviceDiscovery) || aws_cdk_lib_aws_appmesh_MeshServiceDiscovery(p.serviceDiscovery);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_Mesh(p) {
    }
    function aws_cdk_lib_aws_appmesh_IRoute(p) {
    }
    function aws_cdk_lib_aws_appmesh_RouteBaseProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.routeSpec) || (p.routeSpec, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_RouteProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.mesh) || (p.mesh, void 0), visitedObjects.has(p.virtualRouter) || (p.virtualRouter, void 0), visitedObjects.has(p.routeSpec) || (p.routeSpec, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_Route(p) {
    }
    function aws_cdk_lib_aws_appmesh_RouteAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.virtualRouter) || (p.virtualRouter, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_IpPreference(p) {
    }
    function aws_cdk_lib_aws_appmesh_MeshServiceDiscovery(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ipPreference) || (p.ipPreference, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_ServiceDiscoveryConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cloudmap) || aws_cdk_lib_aws_appmesh_CfnVirtualNode_AwsCloudMapServiceDiscoveryProperty(p.cloudmap), visitedObjects.has(p.dns) || (p.dns, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_DnsResponseType(p) {
    }
    function aws_cdk_lib_aws_appmesh_ServiceDiscovery(p) {
    }
    function aws_cdk_lib_aws_appmesh_WeightedTarget(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.virtualNode) || (p.virtualNode, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_HttpRouteMatch(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.headers != null)
            for (const o of p.headers)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.method) || (p.method, void 0), visitedObjects.has(p.path) || (p.path, void 0), visitedObjects.has(p.protocol) || (p.protocol, void 0), p.queryParameters != null)
            for (const o of p.queryParameters)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_HttpRouteProtocol(p) {
    }
    function aws_cdk_lib_aws_appmesh_GrpcRouteMatch(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.metadata != null)
            for (const o of p.metadata)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_RouteSpecOptionsBase(p) {
    }
    function aws_cdk_lib_aws_appmesh_HttpRouteSpecOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.weightedTargets != null)
            for (const o of p.weightedTargets)
              visitedObjects.has(o) || aws_cdk_lib_aws_appmesh_WeightedTarget(o);
          visitedObjects.has(p.match) || aws_cdk_lib_aws_appmesh_HttpRouteMatch(p.match), visitedObjects.has(p.retryPolicy) || aws_cdk_lib_aws_appmesh_HttpRetryPolicy(p.retryPolicy), visitedObjects.has(p.timeout) || aws_cdk_lib_aws_appmesh_HttpTimeout(p.timeout);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_HttpRetryPolicy(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.retryTimeout) || (p.retryTimeout, void 0), p.httpRetryEvents != null)
            for (const o of p.httpRetryEvents)
              visitedObjects.has(o) || void 0;
          if (p.tcpRetryEvents != null)
            for (const o of p.tcpRetryEvents)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_HttpRetryEvent(p) {
    }
    function aws_cdk_lib_aws_appmesh_TcpRetryEvent(p) {
    }
    function aws_cdk_lib_aws_appmesh_TcpRouteSpecOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.weightedTargets != null)
            for (const o of p.weightedTargets)
              visitedObjects.has(o) || aws_cdk_lib_aws_appmesh_WeightedTarget(o);
          visitedObjects.has(p.timeout) || aws_cdk_lib_aws_appmesh_TcpTimeout(p.timeout);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_GrpcRouteSpecOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.match) || aws_cdk_lib_aws_appmesh_GrpcRouteMatch(p.match), p.weightedTargets != null)
            for (const o of p.weightedTargets)
              visitedObjects.has(o) || aws_cdk_lib_aws_appmesh_WeightedTarget(o);
          visitedObjects.has(p.retryPolicy) || aws_cdk_lib_aws_appmesh_GrpcRetryPolicy(p.retryPolicy), visitedObjects.has(p.timeout) || aws_cdk_lib_aws_appmesh_GrpcTimeout(p.timeout);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_GrpcRetryPolicy(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.grpcRetryEvents != null)
            for (const o of p.grpcRetryEvents)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.retryTimeout) || (p.retryTimeout, void 0), p.httpRetryEvents != null)
            for (const o of p.httpRetryEvents)
              visitedObjects.has(o) || void 0;
          if (p.tcpRetryEvents != null)
            for (const o of p.tcpRetryEvents)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_GrpcRetryEvent(p) {
    }
    function aws_cdk_lib_aws_appmesh_RouteSpecConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.grpcRouteSpec) || aws_cdk_lib_aws_appmesh_CfnRoute_GrpcRouteProperty(p.grpcRouteSpec), visitedObjects.has(p.http2RouteSpec) || aws_cdk_lib_aws_appmesh_CfnRoute_HttpRouteProperty(p.http2RouteSpec), visitedObjects.has(p.httpRouteSpec) || aws_cdk_lib_aws_appmesh_CfnRoute_HttpRouteProperty(p.httpRouteSpec), visitedObjects.has(p.tcpRouteSpec) || aws_cdk_lib_aws_appmesh_CfnRoute_TcpRouteProperty(p.tcpRouteSpec);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_RouteSpec(p) {
    }
    function aws_cdk_lib_aws_appmesh_HttpTimeout(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.idle) || (p.idle, void 0), visitedObjects.has(p.perRequest) || (p.perRequest, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_GrpcTimeout(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.idle) || (p.idle, void 0), visitedObjects.has(p.perRequest) || (p.perRequest, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_TcpTimeout(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.idle) || (p.idle, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_OutlierDetection(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.baseEjectionDuration) || (p.baseEjectionDuration, void 0), visitedObjects.has(p.interval) || (p.interval, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_AccessLogConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.virtualGatewayAccessLog) || aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayAccessLogProperty(p.virtualGatewayAccessLog), visitedObjects.has(p.virtualNodeAccessLog) || aws_cdk_lib_aws_appmesh_CfnVirtualNode_AccessLogProperty(p.virtualNodeAccessLog);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_AccessLog(p) {
    }
    function aws_cdk_lib_aws_appmesh_LoggingFormatConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.formatConfig) || aws_cdk_lib_aws_appmesh_CfnVirtualNode_LoggingFormatProperty(p.formatConfig);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_LoggingFormat(p) {
    }
    function aws_cdk_lib_aws_appmesh_BackendDefaults(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tlsClientPolicy) || aws_cdk_lib_aws_appmesh_TlsClientPolicy(p.tlsClientPolicy);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_VirtualServiceBackendOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tlsClientPolicy) || aws_cdk_lib_aws_appmesh_TlsClientPolicy(p.tlsClientPolicy);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_BackendConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.virtualServiceBackend) || aws_cdk_lib_aws_appmesh_CfnVirtualNode_BackendProperty(p.virtualServiceBackend);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_Backend(p) {
    }
    function aws_cdk_lib_aws_appmesh_HttpConnectionPool(p) {
    }
    function aws_cdk_lib_aws_appmesh_TcpConnectionPool(p) {
    }
    function aws_cdk_lib_aws_appmesh_GrpcConnectionPool(p) {
    }
    function aws_cdk_lib_aws_appmesh_Http2ConnectionPool(p) {
    }
    function aws_cdk_lib_aws_appmesh_TlsCertificateConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tlsCertificate) || aws_cdk_lib_aws_appmesh_CfnVirtualNode_ListenerTlsCertificateProperty(p.tlsCertificate);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_TlsCertificate(p) {
    }
    function aws_cdk_lib_aws_appmesh_MutualTlsCertificate(p) {
    }
    function aws_cdk_lib_aws_appmesh_IVirtualNode(p) {
    }
    function aws_cdk_lib_aws_appmesh_VirtualNodeBaseProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.accessLog) || (p.accessLog, void 0), visitedObjects.has(p.backendDefaults) || aws_cdk_lib_aws_appmesh_BackendDefaults(p.backendDefaults), p.backends != null)
            for (const o of p.backends)
              visitedObjects.has(o) || void 0;
          if (p.listeners != null)
            for (const o of p.listeners)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.serviceDiscovery) || (p.serviceDiscovery, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_VirtualNodeProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.mesh) || (p.mesh, void 0), visitedObjects.has(p.accessLog) || (p.accessLog, void 0), visitedObjects.has(p.backendDefaults) || aws_cdk_lib_aws_appmesh_BackendDefaults(p.backendDefaults), p.backends != null)
            for (const o of p.backends)
              visitedObjects.has(o) || void 0;
          if (p.listeners != null)
            for (const o of p.listeners)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.serviceDiscovery) || (p.serviceDiscovery, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_VirtualNode(p) {
    }
    function aws_cdk_lib_aws_appmesh_VirtualNodeAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.mesh) || (p.mesh, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_IVirtualRouter(p) {
    }
    function aws_cdk_lib_aws_appmesh_VirtualRouterBaseProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.listeners != null)
            for (const o of p.listeners)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_VirtualRouterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.mesh) || (p.mesh, void 0), p.listeners != null)
            for (const o of p.listeners)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_VirtualRouter(p) {
    }
    function aws_cdk_lib_aws_appmesh_VirtualRouterAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.mesh) || (p.mesh, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_VirtualRouterListenerConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.listener) || aws_cdk_lib_aws_appmesh_CfnVirtualRouter_VirtualRouterListenerProperty(p.listener);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_VirtualRouterListener(p) {
    }
    function aws_cdk_lib_aws_appmesh_IVirtualService(p) {
    }
    function aws_cdk_lib_aws_appmesh_VirtualServiceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.virtualServiceProvider) || (p.virtualServiceProvider, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_VirtualService(p) {
    }
    function aws_cdk_lib_aws_appmesh_VirtualServiceAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.mesh) || (p.mesh, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_VirtualServiceProviderConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.mesh) || (p.mesh, void 0), visitedObjects.has(p.virtualNodeProvider) || (p.virtualNodeProvider, void 0), visitedObjects.has(p.virtualRouterProvider) || (p.virtualRouterProvider, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_VirtualServiceProvider(p) {
    }
    function aws_cdk_lib_aws_appmesh_VirtualNodeListenerConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.listener) || aws_cdk_lib_aws_appmesh_CfnVirtualNode_ListenerProperty(p.listener);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_HttpVirtualNodeListenerOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.connectionPool) || (p.connectionPool, void 0), visitedObjects.has(p.healthCheck) || (p.healthCheck, void 0), visitedObjects.has(p.outlierDetection) || aws_cdk_lib_aws_appmesh_OutlierDetection(p.outlierDetection), visitedObjects.has(p.timeout) || aws_cdk_lib_aws_appmesh_HttpTimeout(p.timeout), visitedObjects.has(p.tls) || aws_cdk_lib_aws_appmesh_ListenerTlsOptions(p.tls);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_Http2VirtualNodeListenerOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.connectionPool) || (p.connectionPool, void 0), visitedObjects.has(p.healthCheck) || (p.healthCheck, void 0), visitedObjects.has(p.outlierDetection) || aws_cdk_lib_aws_appmesh_OutlierDetection(p.outlierDetection), visitedObjects.has(p.timeout) || aws_cdk_lib_aws_appmesh_HttpTimeout(p.timeout), visitedObjects.has(p.tls) || aws_cdk_lib_aws_appmesh_ListenerTlsOptions(p.tls);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_GrpcVirtualNodeListenerOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.connectionPool) || (p.connectionPool, void 0), visitedObjects.has(p.healthCheck) || (p.healthCheck, void 0), visitedObjects.has(p.outlierDetection) || aws_cdk_lib_aws_appmesh_OutlierDetection(p.outlierDetection), visitedObjects.has(p.timeout) || aws_cdk_lib_aws_appmesh_GrpcTimeout(p.timeout), visitedObjects.has(p.tls) || aws_cdk_lib_aws_appmesh_ListenerTlsOptions(p.tls);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_TcpVirtualNodeListenerOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.connectionPool) || (p.connectionPool, void 0), visitedObjects.has(p.healthCheck) || (p.healthCheck, void 0), visitedObjects.has(p.outlierDetection) || aws_cdk_lib_aws_appmesh_OutlierDetection(p.outlierDetection), visitedObjects.has(p.timeout) || aws_cdk_lib_aws_appmesh_TcpTimeout(p.timeout), visitedObjects.has(p.tls) || aws_cdk_lib_aws_appmesh_ListenerTlsOptions(p.tls);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_VirtualNodeListener(p) {
    }
    function aws_cdk_lib_aws_appmesh_IVirtualGateway(p) {
    }
    function aws_cdk_lib_aws_appmesh_VirtualGatewayBaseProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.accessLog) || (p.accessLog, void 0), visitedObjects.has(p.backendDefaults) || aws_cdk_lib_aws_appmesh_BackendDefaults(p.backendDefaults), p.listeners != null)
            for (const o of p.listeners)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_VirtualGatewayProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.mesh) || (p.mesh, void 0), visitedObjects.has(p.accessLog) || (p.accessLog, void 0), visitedObjects.has(p.backendDefaults) || aws_cdk_lib_aws_appmesh_BackendDefaults(p.backendDefaults), p.listeners != null)
            for (const o of p.listeners)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_VirtualGateway(p) {
    }
    function aws_cdk_lib_aws_appmesh_VirtualGatewayAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.mesh) || (p.mesh, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_HttpGatewayListenerOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.connectionPool) || (p.connectionPool, void 0), visitedObjects.has(p.healthCheck) || (p.healthCheck, void 0), visitedObjects.has(p.tls) || aws_cdk_lib_aws_appmesh_ListenerTlsOptions(p.tls);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_Http2GatewayListenerOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.connectionPool) || (p.connectionPool, void 0), visitedObjects.has(p.healthCheck) || (p.healthCheck, void 0), visitedObjects.has(p.tls) || aws_cdk_lib_aws_appmesh_ListenerTlsOptions(p.tls);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_GrpcGatewayListenerOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.connectionPool) || (p.connectionPool, void 0), visitedObjects.has(p.healthCheck) || (p.healthCheck, void 0), visitedObjects.has(p.tls) || aws_cdk_lib_aws_appmesh_ListenerTlsOptions(p.tls);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_VirtualGatewayListenerConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.listener) || aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayListenerProperty(p.listener);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_VirtualGatewayListener(p) {
    }
    function aws_cdk_lib_aws_appmesh_IGatewayRoute(p) {
    }
    function aws_cdk_lib_aws_appmesh_GatewayRouteBaseProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.routeSpec) || (p.routeSpec, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_GatewayRouteProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.virtualGateway) || (p.virtualGateway, void 0), visitedObjects.has(p.routeSpec) || (p.routeSpec, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_GatewayRoute(p) {
    }
    function aws_cdk_lib_aws_appmesh_GatewayRouteAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.virtualGateway) || (p.virtualGateway, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_GatewayRouteHostnameMatchConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.hostnameMatch) || (p.hostnameMatch, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_GatewayRouteHostnameMatch(p) {
    }
    function aws_cdk_lib_aws_appmesh_HttpGatewayRouteMatch(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.headers != null)
            for (const o of p.headers)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.hostname) || (p.hostname, void 0), visitedObjects.has(p.method) || (p.method, void 0), visitedObjects.has(p.path) || (p.path, void 0), p.queryParameters != null)
            for (const o of p.queryParameters)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_GrpcGatewayRouteMatch(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.hostname) || (p.hostname, void 0), p.metadata != null)
            for (const o of p.metadata)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_CommonGatewayRouteSpecOptions(p) {
    }
    function aws_cdk_lib_aws_appmesh_HttpGatewayRouteSpecOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.routeTarget) || (p.routeTarget, void 0), visitedObjects.has(p.match) || aws_cdk_lib_aws_appmesh_HttpGatewayRouteMatch(p.match);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_GrpcGatewayRouteSpecOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.match) || aws_cdk_lib_aws_appmesh_GrpcGatewayRouteMatch(p.match), visitedObjects.has(p.routeTarget) || (p.routeTarget, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_GatewayRouteSpecConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.grpcSpecConfig) || aws_cdk_lib_aws_appmesh_CfnGatewayRoute_GrpcGatewayRouteProperty(p.grpcSpecConfig), visitedObjects.has(p.http2SpecConfig) || aws_cdk_lib_aws_appmesh_CfnGatewayRoute_HttpGatewayRouteProperty(p.http2SpecConfig), visitedObjects.has(p.httpSpecConfig) || aws_cdk_lib_aws_appmesh_CfnGatewayRoute_HttpGatewayRouteProperty(p.httpSpecConfig);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_GatewayRouteSpec(p) {
    }
    function aws_cdk_lib_aws_appmesh_HttpHealthCheckOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.interval) || (p.interval, void 0), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_GrpcHealthCheckOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.interval) || (p.interval, void 0), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_TcpHealthCheckOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.interval) || (p.interval, void 0), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_HealthCheckConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.virtualGatewayHealthCheck) || (p.virtualGatewayHealthCheck, void 0), visitedObjects.has(p.virtualNodeHealthCheck) || (p.virtualNodeHealthCheck, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_HealthCheckBindOptions(p) {
    }
    function aws_cdk_lib_aws_appmesh_HealthCheck(p) {
    }
    function aws_cdk_lib_aws_appmesh_TlsMode(p) {
    }
    function aws_cdk_lib_aws_appmesh_ListenerTlsOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.certificate) || (p.certificate, void 0), visitedObjects.has(p.mode) || (p.mode, void 0), visitedObjects.has(p.mutualTlsValidation) || aws_cdk_lib_aws_appmesh_MutualTlsValidation(p.mutualTlsValidation);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_TlsValidation(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.trust) || (p.trust, void 0), visitedObjects.has(p.subjectAlternativeNames) || (p.subjectAlternativeNames, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_MutualTlsValidation(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.trust) || (p.trust, void 0), visitedObjects.has(p.subjectAlternativeNames) || (p.subjectAlternativeNames, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_TlsValidationTrustConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tlsValidationTrust) || aws_cdk_lib_aws_appmesh_CfnVirtualNode_TlsValidationContextTrustProperty(p.tlsValidationTrust);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_TlsValidationTrust(p) {
    }
    function aws_cdk_lib_aws_appmesh_MutualTlsValidationTrust(p) {
    }
    function aws_cdk_lib_aws_appmesh_SubjectAlternativeNamesMatcherConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.subjectAlternativeNamesMatch) || (p.subjectAlternativeNamesMatch, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_SubjectAlternativeNames(p) {
    }
    function aws_cdk_lib_aws_appmesh_TlsClientPolicy(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.validation) || aws_cdk_lib_aws_appmesh_TlsValidation(p.validation), visitedObjects.has(p.mutualTlsCertificate) || (p.mutualTlsCertificate, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_HttpRouteMethod(p) {
    }
    function aws_cdk_lib_aws_appmesh_HeaderMatchConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.headerMatch) || aws_cdk_lib_aws_appmesh_CfnRoute_HttpRouteHeaderProperty(p.headerMatch);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_HeaderMatch(p) {
    }
    function aws_cdk_lib_aws_appmesh_QueryParameterMatchConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.queryParameterMatch) || aws_cdk_lib_aws_appmesh_CfnRoute_QueryParameterProperty(p.queryParameterMatch);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_QueryParameterMatch(p) {
    }
    function aws_cdk_lib_aws_appmesh_HttpRoutePathMatchConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.wholePathMatch) || (p.wholePathMatch, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_HttpRoutePathMatch(p) {
    }
    function aws_cdk_lib_aws_appmesh_HttpGatewayRoutePathMatchConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.prefixPathRewrite) || (p.prefixPathRewrite, void 0), visitedObjects.has(p.wholePathMatch) || (p.wholePathMatch, void 0), visitedObjects.has(p.wholePathRewrite) || (p.wholePathRewrite, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appmesh_HttpGatewayRoutePathMatch(p) {
    }
    function aws_cdk_lib_aws_apprunner_CfnObservabilityConfigurationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.traceConfiguration) || (p.traceConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apprunner_CfnObservabilityConfiguration(p) {
    }
    function aws_cdk_lib_aws_apprunner_CfnObservabilityConfiguration_TraceConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_apprunner_CfnServiceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.sourceConfiguration) || (p.sourceConfiguration, void 0), visitedObjects.has(p.encryptionConfiguration) || (p.encryptionConfiguration, void 0), visitedObjects.has(p.healthCheckConfiguration) || (p.healthCheckConfiguration, void 0), visitedObjects.has(p.instanceConfiguration) || (p.instanceConfiguration, void 0), visitedObjects.has(p.networkConfiguration) || (p.networkConfiguration, void 0), visitedObjects.has(p.observabilityConfiguration) || (p.observabilityConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apprunner_CfnService(p) {
    }
    function aws_cdk_lib_aws_apprunner_CfnService_AuthenticationConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_apprunner_CfnService_CodeConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.codeConfigurationValues) || (p.codeConfigurationValues, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apprunner_CfnService_CodeConfigurationValuesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.runtimeEnvironmentSecrets) || (p.runtimeEnvironmentSecrets, void 0), visitedObjects.has(p.runtimeEnvironmentVariables) || (p.runtimeEnvironmentVariables, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apprunner_CfnService_CodeRepositoryProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sourceCodeVersion) || (p.sourceCodeVersion, void 0), visitedObjects.has(p.codeConfiguration) || (p.codeConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apprunner_CfnService_EgressConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_apprunner_CfnService_EncryptionConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_apprunner_CfnService_HealthCheckConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_apprunner_CfnService_ImageConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.runtimeEnvironmentSecrets) || (p.runtimeEnvironmentSecrets, void 0), visitedObjects.has(p.runtimeEnvironmentVariables) || (p.runtimeEnvironmentVariables, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apprunner_CfnService_ImageRepositoryProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.imageConfiguration) || (p.imageConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apprunner_CfnService_IngressConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_apprunner_CfnService_InstanceConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_apprunner_CfnService_KeyValuePairProperty(p) {
    }
    function aws_cdk_lib_aws_apprunner_CfnService_NetworkConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.egressConfiguration) || (p.egressConfiguration, void 0), visitedObjects.has(p.ingressConfiguration) || (p.ingressConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apprunner_CfnService_ServiceObservabilityConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_apprunner_CfnService_SourceCodeVersionProperty(p) {
    }
    function aws_cdk_lib_aws_apprunner_CfnService_SourceConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.authenticationConfiguration) || (p.authenticationConfiguration, void 0), visitedObjects.has(p.codeRepository) || (p.codeRepository, void 0), visitedObjects.has(p.imageRepository) || (p.imageRepository, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apprunner_CfnVpcConnectorProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apprunner_CfnVpcConnector(p) {
    }
    function aws_cdk_lib_aws_apprunner_CfnVpcIngressConnectionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.ingressVpcConfiguration) || (p.ingressVpcConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_apprunner_CfnVpcIngressConnection(p) {
    }
    function aws_cdk_lib_aws_apprunner_CfnVpcIngressConnection_IngressVpcConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnAppBlockProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.setupScriptDetails) || (p.setupScriptDetails, void 0), visitedObjects.has(p.sourceS3Location) || (p.sourceS3Location, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appstream_CfnAppBlock(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnAppBlock_S3LocationProperty(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnAppBlock_ScriptDetailsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.scriptS3Location) || (p.scriptS3Location, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appstream_CfnApplicationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.iconS3Location) || (p.iconS3Location, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appstream_CfnApplication(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnApplication_S3LocationProperty(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnApplicationEntitlementAssociationProps(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnApplicationEntitlementAssociation(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnApplicationFleetAssociationProps(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnApplicationFleetAssociation(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnDirectoryConfigProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.serviceAccountCredentials) || (p.serviceAccountCredentials, void 0), visitedObjects.has(p.certificateBasedAuthProperties) || (p.certificateBasedAuthProperties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appstream_CfnDirectoryConfig(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnDirectoryConfig_CertificateBasedAuthPropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnDirectoryConfig_ServiceAccountCredentialsProperty(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnEntitlementProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.attributes) || (p.attributes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appstream_CfnEntitlement(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnEntitlement_AttributeProperty(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnFleetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.computeCapacity) || (p.computeCapacity, void 0), visitedObjects.has(p.domainJoinInfo) || (p.domainJoinInfo, void 0), visitedObjects.has(p.sessionScriptS3Location) || (p.sessionScriptS3Location, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.vpcConfig) || (p.vpcConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appstream_CfnFleet(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnFleet_ComputeCapacityProperty(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnFleet_DomainJoinInfoProperty(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnFleet_S3LocationProperty(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnFleet_VpcConfigProperty(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnImageBuilderProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.accessEndpoints) || (p.accessEndpoints, void 0), visitedObjects.has(p.domainJoinInfo) || (p.domainJoinInfo, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.vpcConfig) || (p.vpcConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appstream_CfnImageBuilder(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnImageBuilder_AccessEndpointProperty(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnImageBuilder_DomainJoinInfoProperty(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnImageBuilder_VpcConfigProperty(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnStackProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.accessEndpoints) || (p.accessEndpoints, void 0), visitedObjects.has(p.applicationSettings) || (p.applicationSettings, void 0), visitedObjects.has(p.storageConnectors) || (p.storageConnectors, void 0), visitedObjects.has(p.streamingExperienceSettings) || (p.streamingExperienceSettings, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.userSettings) || (p.userSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appstream_CfnStack(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnStack_AccessEndpointProperty(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnStack_ApplicationSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnStack_StorageConnectorProperty(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnStack_StreamingExperienceSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnStack_UserSettingProperty(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnStackFleetAssociationProps(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnStackFleetAssociation(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnStackUserAssociationProps(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnStackUserAssociation(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnUserProps(p) {
    }
    function aws_cdk_lib_aws_appstream_CfnUser(p) {
    }
    function aws_cdk_lib_aws_appsync_BaseAppsyncFunctionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.code) || (p.code, void 0), visitedObjects.has(p.requestMappingTemplate) || (p.requestMappingTemplate, void 0), visitedObjects.has(p.responseMappingTemplate) || (p.responseMappingTemplate, void 0), visitedObjects.has(p.runtime) || (p.runtime, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_AppsyncFunctionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.api) || (p.api, void 0), visitedObjects.has(p.dataSource) || (p.dataSource, void 0), visitedObjects.has(p.code) || (p.code, void 0), visitedObjects.has(p.requestMappingTemplate) || (p.requestMappingTemplate, void 0), visitedObjects.has(p.responseMappingTemplate) || (p.responseMappingTemplate, void 0), visitedObjects.has(p.runtime) || (p.runtime, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_AppsyncFunctionAttributes(p) {
    }
    function aws_cdk_lib_aws_appsync_IAppsyncFunction(p) {
    }
    function aws_cdk_lib_aws_appsync_AppsyncFunction(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnApiCacheProps(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnApiCache(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnApiKeyProps(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnApiKey(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnDataSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dynamoDbConfig) || (p.dynamoDbConfig, void 0), visitedObjects.has(p.elasticsearchConfig) || (p.elasticsearchConfig, void 0), visitedObjects.has(p.eventBridgeConfig) || (p.eventBridgeConfig, void 0), visitedObjects.has(p.httpConfig) || (p.httpConfig, void 0), visitedObjects.has(p.lambdaConfig) || (p.lambdaConfig, void 0), visitedObjects.has(p.openSearchServiceConfig) || (p.openSearchServiceConfig, void 0), visitedObjects.has(p.relationalDatabaseConfig) || (p.relationalDatabaseConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_CfnDataSource(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnDataSource_AuthorizationConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.awsIamConfig) || (p.awsIamConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_CfnDataSource_AwsIamConfigProperty(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnDataSource_DeltaSyncConfigProperty(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnDataSource_DynamoDBConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.deltaSyncConfig) || (p.deltaSyncConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_CfnDataSource_ElasticsearchConfigProperty(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnDataSource_EventBridgeConfigProperty(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnDataSource_HttpConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.authorizationConfig) || (p.authorizationConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_CfnDataSource_LambdaConfigProperty(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnDataSource_OpenSearchServiceConfigProperty(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnDataSource_RdsHttpEndpointConfigProperty(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnDataSource_RelationalDatabaseConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.rdsHttpEndpointConfig) || (p.rdsHttpEndpointConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_CfnDomainNameProps(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnDomainName(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnDomainNameApiAssociationProps(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnDomainNameApiAssociation(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnFunctionConfigurationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.runtime) || (p.runtime, void 0), visitedObjects.has(p.syncConfig) || (p.syncConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_CfnFunctionConfiguration(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnFunctionConfiguration_AppSyncRuntimeProperty(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnFunctionConfiguration_LambdaConflictHandlerConfigProperty(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnFunctionConfiguration_SyncConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.lambdaConflictHandlerConfig) || (p.lambdaConflictHandlerConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_CfnGraphQLApiProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.additionalAuthenticationProviders) || (p.additionalAuthenticationProviders, void 0), visitedObjects.has(p.lambdaAuthorizerConfig) || (p.lambdaAuthorizerConfig, void 0), visitedObjects.has(p.logConfig) || (p.logConfig, void 0), visitedObjects.has(p.openIdConnectConfig) || (p.openIdConnectConfig, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.userPoolConfig) || (p.userPoolConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_CfnGraphQLApi(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnGraphQLApi_AdditionalAuthenticationProviderProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.lambdaAuthorizerConfig) || (p.lambdaAuthorizerConfig, void 0), visitedObjects.has(p.openIdConnectConfig) || (p.openIdConnectConfig, void 0), visitedObjects.has(p.userPoolConfig) || (p.userPoolConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_CfnGraphQLApi_CognitoUserPoolConfigProperty(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnGraphQLApi_LambdaAuthorizerConfigProperty(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnGraphQLApi_LogConfigProperty(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnGraphQLApi_OpenIDConnectConfigProperty(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnGraphQLApi_UserPoolConfigProperty(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnGraphQLSchemaProps(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnGraphQLSchema(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnResolverProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cachingConfig) || (p.cachingConfig, void 0), visitedObjects.has(p.pipelineConfig) || (p.pipelineConfig, void 0), visitedObjects.has(p.runtime) || (p.runtime, void 0), visitedObjects.has(p.syncConfig) || (p.syncConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_CfnResolver(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnResolver_AppSyncRuntimeProperty(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnResolver_CachingConfigProperty(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnResolver_LambdaConflictHandlerConfigProperty(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnResolver_PipelineConfigProperty(p) {
    }
    function aws_cdk_lib_aws_appsync_CfnResolver_SyncConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.lambdaConflictHandlerConfig) || (p.lambdaConflictHandlerConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_CachingConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ttl) || (p.ttl, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_KeyCondition(p) {
    }
    function aws_cdk_lib_aws_appsync_Assign(p) {
    }
    function aws_cdk_lib_aws_appsync_PartitionKeyStep(p) {
    }
    function aws_cdk_lib_aws_appsync_SortKeyStep(p) {
    }
    function aws_cdk_lib_aws_appsync_PrimaryKey(p) {
    }
    function aws_cdk_lib_aws_appsync_PartitionKey(p) {
    }
    function aws_cdk_lib_aws_appsync_AttributeValues(p) {
    }
    function aws_cdk_lib_aws_appsync_AttributeValuesStep(p) {
    }
    function aws_cdk_lib_aws_appsync_Values(p) {
    }
    function aws_cdk_lib_aws_appsync_BaseDataSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.api) || (p.api, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_BackedDataSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.serviceRole) || (p.serviceRole, void 0), visitedObjects.has(p.api) || (p.api, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_ExtendedDataSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dynamoDbConfig) || (p.dynamoDbConfig, void 0), "elasticsearchConfig" in p && print("aws-cdk-lib.aws_appsync.ExtendedDataSourceProps#elasticsearchConfig", "- use `openSearchConfig`"), visitedObjects.has(p.elasticsearchConfig) || (p.elasticsearchConfig, void 0), visitedObjects.has(p.eventBridgeConfig) || (p.eventBridgeConfig, void 0), visitedObjects.has(p.httpConfig) || (p.httpConfig, void 0), visitedObjects.has(p.lambdaConfig) || (p.lambdaConfig, void 0), visitedObjects.has(p.openSearchServiceConfig) || (p.openSearchServiceConfig, void 0), visitedObjects.has(p.relationalDatabaseConfig) || (p.relationalDatabaseConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_BaseDataSource(p) {
    }
    function aws_cdk_lib_aws_appsync_BackedDataSource(p) {
    }
    function aws_cdk_lib_aws_appsync_NoneDataSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.api) || (p.api, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_NoneDataSource(p) {
    }
    function aws_cdk_lib_aws_appsync_DynamoDbDataSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.table) || (p.table, void 0), visitedObjects.has(p.serviceRole) || (p.serviceRole, void 0), visitedObjects.has(p.api) || (p.api, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_DynamoDbDataSource(p) {
    }
    function aws_cdk_lib_aws_appsync_AwsIamConfig(p) {
    }
    function aws_cdk_lib_aws_appsync_HttpDataSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.authorizationConfig) || (p.authorizationConfig, void 0), visitedObjects.has(p.api) || (p.api, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_HttpDataSource(p) {
    }
    function aws_cdk_lib_aws_appsync_EventBridgeDataSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.eventBus) || (p.eventBus, void 0), visitedObjects.has(p.serviceRole) || (p.serviceRole, void 0), visitedObjects.has(p.api) || (p.api, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_EventBridgeDataSource(p) {
    }
    function aws_cdk_lib_aws_appsync_LambdaDataSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.lambdaFunction) || (p.lambdaFunction, void 0), visitedObjects.has(p.serviceRole) || (p.serviceRole, void 0), visitedObjects.has(p.api) || (p.api, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_LambdaDataSource(p) {
    }
    function aws_cdk_lib_aws_appsync_RdsDataSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.secretStore) || (p.secretStore, void 0), visitedObjects.has(p.serverlessCluster) || (p.serverlessCluster, void 0), visitedObjects.has(p.serviceRole) || (p.serviceRole, void 0), visitedObjects.has(p.api) || (p.api, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_RdsDataSource(p) {
    }
    function aws_cdk_lib_aws_appsync_ElasticsearchDataSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          "domain" in p && print("aws-cdk-lib.aws_appsync.ElasticsearchDataSourceProps#domain", "- use `OpenSearchDataSourceProps` with `OpenSearchDataSource`"), visitedObjects.has(p.domain) || (p.domain, void 0), visitedObjects.has(p.serviceRole) || (p.serviceRole, void 0), visitedObjects.has(p.api) || (p.api, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_ElasticsearchDataSource(p) {
    }
    function aws_cdk_lib_aws_appsync_OpenSearchDataSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.domain) || (p.domain, void 0), visitedObjects.has(p.serviceRole) || (p.serviceRole, void 0), visitedObjects.has(p.api) || (p.api, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_OpenSearchDataSource(p) {
    }
    function aws_cdk_lib_aws_appsync_MappingTemplate(p) {
    }
    function aws_cdk_lib_aws_appsync_BaseResolverProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.cachingConfig) || aws_cdk_lib_aws_appsync_CachingConfig(p.cachingConfig), visitedObjects.has(p.code) || (p.code, void 0), p.pipelineConfig != null)
            for (const o of p.pipelineConfig)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.requestMappingTemplate) || (p.requestMappingTemplate, void 0), visitedObjects.has(p.responseMappingTemplate) || (p.responseMappingTemplate, void 0), visitedObjects.has(p.runtime) || (p.runtime, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_ExtendedResolverProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.dataSource) || (p.dataSource, void 0), visitedObjects.has(p.cachingConfig) || aws_cdk_lib_aws_appsync_CachingConfig(p.cachingConfig), visitedObjects.has(p.code) || (p.code, void 0), p.pipelineConfig != null)
            for (const o of p.pipelineConfig)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.requestMappingTemplate) || (p.requestMappingTemplate, void 0), visitedObjects.has(p.responseMappingTemplate) || (p.responseMappingTemplate, void 0), visitedObjects.has(p.runtime) || (p.runtime, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_ResolverProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.api) || (p.api, void 0), visitedObjects.has(p.dataSource) || (p.dataSource, void 0), visitedObjects.has(p.cachingConfig) || aws_cdk_lib_aws_appsync_CachingConfig(p.cachingConfig), visitedObjects.has(p.code) || (p.code, void 0), p.pipelineConfig != null)
            for (const o of p.pipelineConfig)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.requestMappingTemplate) || (p.requestMappingTemplate, void 0), visitedObjects.has(p.responseMappingTemplate) || (p.responseMappingTemplate, void 0), visitedObjects.has(p.runtime) || (p.runtime, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_Resolver(p) {
    }
    function aws_cdk_lib_aws_appsync_ISchemaConfig(p) {
    }
    function aws_cdk_lib_aws_appsync_SchemaBindOptions(p) {
    }
    function aws_cdk_lib_aws_appsync_ISchema(p) {
    }
    function aws_cdk_lib_aws_appsync_SchemaProps(p) {
    }
    function aws_cdk_lib_aws_appsync_SchemaFile(p) {
    }
    function aws_cdk_lib_aws_appsync_AuthorizationType(p) {
    }
    function aws_cdk_lib_aws_appsync_AuthorizationMode(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.authorizationType) || (p.authorizationType, void 0), visitedObjects.has(p.apiKeyConfig) || aws_cdk_lib_aws_appsync_ApiKeyConfig(p.apiKeyConfig), visitedObjects.has(p.lambdaAuthorizerConfig) || aws_cdk_lib_aws_appsync_LambdaAuthorizerConfig(p.lambdaAuthorizerConfig), visitedObjects.has(p.openIdConnectConfig) || (p.openIdConnectConfig, void 0), visitedObjects.has(p.userPoolConfig) || aws_cdk_lib_aws_appsync_UserPoolConfig(p.userPoolConfig);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_UserPoolDefaultAction(p) {
    }
    function aws_cdk_lib_aws_appsync_UserPoolConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.userPool) || (p.userPool, void 0), visitedObjects.has(p.defaultAction) || (p.defaultAction, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_ApiKeyConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.expires) || (p.expires, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_OpenIdConnectConfig(p) {
    }
    function aws_cdk_lib_aws_appsync_LambdaAuthorizerConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.handler) || (p.handler, void 0), visitedObjects.has(p.resultsCacheTtl) || (p.resultsCacheTtl, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_AuthorizationConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.additionalAuthorizationModes != null)
            for (const o of p.additionalAuthorizationModes)
              visitedObjects.has(o) || aws_cdk_lib_aws_appsync_AuthorizationMode(o);
          visitedObjects.has(p.defaultAuthorization) || aws_cdk_lib_aws_appsync_AuthorizationMode(p.defaultAuthorization);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_FieldLogLevel(p) {
    }
    function aws_cdk_lib_aws_appsync_LogConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldLogLevel) || (p.fieldLogLevel, void 0), visitedObjects.has(p.retention) || (p.retention, void 0), visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_Visibility(p) {
    }
    function aws_cdk_lib_aws_appsync_DomainOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.certificate) || (p.certificate, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_GraphqlApiProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.schema) || (p.schema, void 0), visitedObjects.has(p.authorizationConfig) || aws_cdk_lib_aws_appsync_AuthorizationConfig(p.authorizationConfig), visitedObjects.has(p.domainName) || aws_cdk_lib_aws_appsync_DomainOptions(p.domainName), visitedObjects.has(p.logConfig) || aws_cdk_lib_aws_appsync_LogConfig(p.logConfig), visitedObjects.has(p.visibility) || (p.visibility, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_IamResource(p) {
    }
    function aws_cdk_lib_aws_appsync_GraphqlApiAttributes(p) {
    }
    function aws_cdk_lib_aws_appsync_GraphqlApi(p) {
    }
    function aws_cdk_lib_aws_appsync_DataSourceOptions(p) {
    }
    function aws_cdk_lib_aws_appsync_HttpDataSourceOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.authorizationConfig) || (p.authorizationConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_appsync_IGraphqlApi(p) {
    }
    function aws_cdk_lib_aws_appsync_GraphqlApiBase(p) {
    }
    function aws_cdk_lib_aws_appsync_CodeConfig(p) {
    }
    function aws_cdk_lib_aws_appsync_Code(p) {
    }
    function aws_cdk_lib_aws_appsync_AssetCode(p) {
    }
    function aws_cdk_lib_aws_appsync_InlineCode(p) {
    }
    function aws_cdk_lib_aws_appsync_RuntimeConfig(p) {
    }
    function aws_cdk_lib_aws_appsync_FunctionRuntimeFamily(p) {
    }
    function aws_cdk_lib_aws_appsync_FunctionRuntime(p) {
    }
    function aws_cdk_lib_aws_aps_CfnRuleGroupsNamespaceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_aps_CfnRuleGroupsNamespace(p) {
    }
    function aws_cdk_lib_aws_aps_CfnWorkspaceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.loggingConfiguration) || (p.loggingConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_aps_CfnWorkspace(p) {
    }
    function aws_cdk_lib_aws_aps_CfnWorkspace_LoggingConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_athena_CfnDataCatalogProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.parameters) || (p.parameters, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_athena_CfnDataCatalog(p) {
    }
    function aws_cdk_lib_aws_athena_CfnNamedQueryProps(p) {
    }
    function aws_cdk_lib_aws_athena_CfnNamedQuery(p) {
    }
    function aws_cdk_lib_aws_athena_CfnPreparedStatementProps(p) {
    }
    function aws_cdk_lib_aws_athena_CfnPreparedStatement(p) {
    }
    function aws_cdk_lib_aws_athena_CfnWorkGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.workGroupConfiguration) || (p.workGroupConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_athena_CfnWorkGroup(p) {
    }
    function aws_cdk_lib_aws_athena_CfnWorkGroup_AclConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_athena_CfnWorkGroup_CustomerContentEncryptionConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_athena_CfnWorkGroup_EncryptionConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_athena_CfnWorkGroup_EngineVersionProperty(p) {
    }
    function aws_cdk_lib_aws_athena_CfnWorkGroup_ResultConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.aclConfiguration) || (p.aclConfiguration, void 0), visitedObjects.has(p.encryptionConfiguration) || (p.encryptionConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_athena_CfnWorkGroup_WorkGroupConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customerContentEncryptionConfiguration) || (p.customerContentEncryptionConfiguration, void 0), visitedObjects.has(p.engineVersion) || (p.engineVersion, void 0), visitedObjects.has(p.resultConfiguration) || (p.resultConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_auditmanager_CfnAssessmentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.assessmentReportsDestination) || (p.assessmentReportsDestination, void 0), visitedObjects.has(p.awsAccount) || (p.awsAccount, void 0), visitedObjects.has(p.delegations) || (p.delegations, void 0), visitedObjects.has(p.roles) || (p.roles, void 0), visitedObjects.has(p.scope) || (p.scope, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_auditmanager_CfnAssessment(p) {
    }
    function aws_cdk_lib_aws_auditmanager_CfnAssessment_AWSAccountProperty(p) {
    }
    function aws_cdk_lib_aws_auditmanager_CfnAssessment_AWSServiceProperty(p) {
    }
    function aws_cdk_lib_aws_auditmanager_CfnAssessment_AssessmentReportsDestinationProperty(p) {
    }
    function aws_cdk_lib_aws_auditmanager_CfnAssessment_DelegationProperty(p) {
    }
    function aws_cdk_lib_aws_auditmanager_CfnAssessment_RoleProperty(p) {
    }
    function aws_cdk_lib_aws_auditmanager_CfnAssessment_ScopeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.awsAccounts) || (p.awsAccounts, void 0), visitedObjects.has(p.awsServices) || (p.awsServices, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_AutoScalingGroupRequireImdsv2Aspect(p) {
    }
    function aws_cdk_lib_aws_autoscaling_Monitoring(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CommonAutoScalingGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.blockDevices != null)
            for (const o of p.blockDevices)
              visitedObjects.has(o) || aws_cdk_lib_aws_autoscaling_BlockDevice(o);
          if (visitedObjects.has(p.cooldown) || (p.cooldown, void 0), visitedObjects.has(p.defaultInstanceWarmup) || (p.defaultInstanceWarmup, void 0), p.groupMetrics != null)
            for (const o of p.groupMetrics)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.healthCheck) || (p.healthCheck, void 0), visitedObjects.has(p.instanceMonitoring) || (p.instanceMonitoring, void 0), visitedObjects.has(p.maxInstanceLifetime) || (p.maxInstanceLifetime, void 0), p.notifications != null)
            for (const o of p.notifications)
              visitedObjects.has(o) || aws_cdk_lib_aws_autoscaling_NotificationConfiguration(o);
          if (visitedObjects.has(p.signals) || (p.signals, void 0), p.terminationPolicies != null)
            for (const o of p.terminationPolicies)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.updatePolicy) || (p.updatePolicy, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_MixedInstancesPolicy(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.launchTemplate) || (p.launchTemplate, void 0), visitedObjects.has(p.instancesDistribution) || aws_cdk_lib_aws_autoscaling_InstancesDistribution(p.instancesDistribution), p.launchTemplateOverrides != null)
            for (const o of p.launchTemplateOverrides)
              visitedObjects.has(o) || aws_cdk_lib_aws_autoscaling_LaunchTemplateOverrides(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_OnDemandAllocationStrategy(p) {
    }
    function aws_cdk_lib_aws_autoscaling_SpotAllocationStrategy(p) {
    }
    function aws_cdk_lib_aws_autoscaling_InstancesDistribution(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.onDemandAllocationStrategy) || (p.onDemandAllocationStrategy, void 0), visitedObjects.has(p.spotAllocationStrategy) || (p.spotAllocationStrategy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_LaunchTemplateOverrides(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.instanceType) || (p.instanceType, void 0), visitedObjects.has(p.launchTemplate) || (p.launchTemplate, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_AutoScalingGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.init) || (p.init, void 0), visitedObjects.has(p.initOptions) || (p.initOptions, void 0), visitedObjects.has(p.instanceType) || (p.instanceType, void 0), visitedObjects.has(p.launchTemplate) || (p.launchTemplate, void 0), visitedObjects.has(p.machineImage) || (p.machineImage, void 0), visitedObjects.has(p.mixedInstancesPolicy) || aws_cdk_lib_aws_autoscaling_MixedInstancesPolicy(p.mixedInstancesPolicy), visitedObjects.has(p.role) || (p.role, void 0), visitedObjects.has(p.securityGroup) || (p.securityGroup, void 0), visitedObjects.has(p.userData) || (p.userData, void 0), p.blockDevices != null)
            for (const o of p.blockDevices)
              visitedObjects.has(o) || aws_cdk_lib_aws_autoscaling_BlockDevice(o);
          if (visitedObjects.has(p.cooldown) || (p.cooldown, void 0), visitedObjects.has(p.defaultInstanceWarmup) || (p.defaultInstanceWarmup, void 0), p.groupMetrics != null)
            for (const o of p.groupMetrics)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.healthCheck) || (p.healthCheck, void 0), visitedObjects.has(p.instanceMonitoring) || (p.instanceMonitoring, void 0), visitedObjects.has(p.maxInstanceLifetime) || (p.maxInstanceLifetime, void 0), p.notifications != null)
            for (const o of p.notifications)
              visitedObjects.has(o) || aws_cdk_lib_aws_autoscaling_NotificationConfiguration(o);
          if (visitedObjects.has(p.signals) || (p.signals, void 0), p.terminationPolicies != null)
            for (const o of p.terminationPolicies)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.updatePolicy) || (p.updatePolicy, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_Signals(p) {
    }
    function aws_cdk_lib_aws_autoscaling_RenderSignalsOptions(p) {
    }
    function aws_cdk_lib_aws_autoscaling_SignalsOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_UpdatePolicy(p) {
    }
    function aws_cdk_lib_aws_autoscaling_RollingUpdateOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.pauseTime) || (p.pauseTime, void 0), p.suspendProcesses != null)
            for (const o of p.suspendProcesses)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_GroupMetrics(p) {
    }
    function aws_cdk_lib_aws_autoscaling_GroupMetric(p) {
    }
    function aws_cdk_lib_aws_autoscaling_AutoScalingGroup(p) {
    }
    function aws_cdk_lib_aws_autoscaling_NotificationConfiguration(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.topic) || (p.topic, void 0), visitedObjects.has(p.scalingEvents) || (p.scalingEvents, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_ScalingEvent(p) {
    }
    function aws_cdk_lib_aws_autoscaling_ScalingEvents(p) {
    }
    function aws_cdk_lib_aws_autoscaling_ScalingProcess(p) {
    }
    function aws_cdk_lib_aws_autoscaling_Ec2HealthCheckOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.grace) || (p.grace, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_ElbHealthCheckOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.grace) || (p.grace, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_HealthCheck(p) {
    }
    function aws_cdk_lib_aws_autoscaling_IAutoScalingGroup(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CpuUtilizationScalingProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cooldown) || (p.cooldown, void 0), visitedObjects.has(p.estimatedInstanceWarmup) || (p.estimatedInstanceWarmup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_NetworkUtilizationScalingProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cooldown) || (p.cooldown, void 0), visitedObjects.has(p.estimatedInstanceWarmup) || (p.estimatedInstanceWarmup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_RequestCountScalingProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cooldown) || (p.cooldown, void 0), visitedObjects.has(p.estimatedInstanceWarmup) || (p.estimatedInstanceWarmup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_MetricTargetTrackingProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.metric) || (p.metric, void 0), visitedObjects.has(p.cooldown) || (p.cooldown, void 0), visitedObjects.has(p.estimatedInstanceWarmup) || (p.estimatedInstanceWarmup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_ApplyCloudFormationInitOptions(p) {
    }
    function aws_cdk_lib_aws_autoscaling_Schedule(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CronOptions(p) {
    }
    function aws_cdk_lib_aws_autoscaling_BasicLifecycleHookProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.lifecycleTransition) || (p.lifecycleTransition, void 0), visitedObjects.has(p.defaultResult) || (p.defaultResult, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.notificationTarget) || (p.notificationTarget, void 0), visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_LifecycleHookProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.autoScalingGroup) || (p.autoScalingGroup, void 0), visitedObjects.has(p.lifecycleTransition) || (p.lifecycleTransition, void 0), visitedObjects.has(p.defaultResult) || (p.defaultResult, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.notificationTarget) || (p.notificationTarget, void 0), visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_ILifecycleHook(p) {
    }
    function aws_cdk_lib_aws_autoscaling_LifecycleHook(p) {
    }
    function aws_cdk_lib_aws_autoscaling_DefaultResult(p) {
    }
    function aws_cdk_lib_aws_autoscaling_LifecycleTransition(p) {
    }
    function aws_cdk_lib_aws_autoscaling_BindHookTargetOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.lifecycleHook) || (p.lifecycleHook, void 0), visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_LifecycleHookTargetConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.createdRole) || (p.createdRole, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_ILifecycleHookTarget(p) {
    }
    function aws_cdk_lib_aws_autoscaling_BasicScheduledActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.schedule) || (p.schedule, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_ScheduledActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.autoScalingGroup) || (p.autoScalingGroup, void 0), visitedObjects.has(p.schedule) || (p.schedule, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_ScheduledAction(p) {
    }
    function aws_cdk_lib_aws_autoscaling_StepScalingActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.autoScalingGroup) || (p.autoScalingGroup, void 0), visitedObjects.has(p.adjustmentType) || (p.adjustmentType, void 0), visitedObjects.has(p.cooldown) || (p.cooldown, void 0), visitedObjects.has(p.estimatedInstanceWarmup) || (p.estimatedInstanceWarmup, void 0), visitedObjects.has(p.metricAggregationType) || (p.metricAggregationType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_StepScalingAction(p) {
    }
    function aws_cdk_lib_aws_autoscaling_AdjustmentType(p) {
    }
    function aws_cdk_lib_aws_autoscaling_MetricAggregationType(p) {
    }
    function aws_cdk_lib_aws_autoscaling_AdjustmentTier(p) {
    }
    function aws_cdk_lib_aws_autoscaling_BasicStepScalingPolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.metric) || (p.metric, void 0), p.scalingSteps != null)
            for (const o of p.scalingSteps)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.adjustmentType) || (p.adjustmentType, void 0), visitedObjects.has(p.cooldown) || (p.cooldown, void 0), visitedObjects.has(p.estimatedInstanceWarmup) || (p.estimatedInstanceWarmup, void 0), visitedObjects.has(p.metricAggregationType) || (p.metricAggregationType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_StepScalingPolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.autoScalingGroup) || (p.autoScalingGroup, void 0), visitedObjects.has(p.metric) || (p.metric, void 0), p.scalingSteps != null)
            for (const o of p.scalingSteps)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.adjustmentType) || (p.adjustmentType, void 0), visitedObjects.has(p.cooldown) || (p.cooldown, void 0), visitedObjects.has(p.estimatedInstanceWarmup) || (p.estimatedInstanceWarmup, void 0), visitedObjects.has(p.metricAggregationType) || (p.metricAggregationType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_StepScalingPolicy(p) {
    }
    function aws_cdk_lib_aws_autoscaling_ScalingInterval(p) {
    }
    function aws_cdk_lib_aws_autoscaling_BaseTargetTrackingProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cooldown) || (p.cooldown, void 0), visitedObjects.has(p.estimatedInstanceWarmup) || (p.estimatedInstanceWarmup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_BasicTargetTrackingScalingPolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customMetric) || (p.customMetric, void 0), visitedObjects.has(p.predefinedMetric) || (p.predefinedMetric, void 0), visitedObjects.has(p.cooldown) || (p.cooldown, void 0), visitedObjects.has(p.estimatedInstanceWarmup) || (p.estimatedInstanceWarmup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_TargetTrackingScalingPolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.autoScalingGroup) || (p.autoScalingGroup, void 0), visitedObjects.has(p.customMetric) || (p.customMetric, void 0), visitedObjects.has(p.predefinedMetric) || (p.predefinedMetric, void 0), visitedObjects.has(p.cooldown) || (p.cooldown, void 0), visitedObjects.has(p.estimatedInstanceWarmup) || (p.estimatedInstanceWarmup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_TargetTrackingScalingPolicy(p) {
    }
    function aws_cdk_lib_aws_autoscaling_PredefinedMetric(p) {
    }
    function aws_cdk_lib_aws_autoscaling_TerminationPolicy(p) {
    }
    function aws_cdk_lib_aws_autoscaling_BlockDevice(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.volume) || (p.volume, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_EbsDeviceOptionsBase(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.volumeType) || (p.volumeType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_EbsDeviceOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.volumeType) || (p.volumeType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_EbsDeviceSnapshotOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.volumeType) || (p.volumeType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_EbsDeviceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.volumeType) || (p.volumeType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_BlockDeviceVolume(p) {
    }
    function aws_cdk_lib_aws_autoscaling_EbsDeviceVolumeType(p) {
    }
    function aws_cdk_lib_aws_autoscaling_WarmPoolOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.poolState) || (p.poolState, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_WarmPoolProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.autoScalingGroup) || (p.autoScalingGroup, void 0), visitedObjects.has(p.poolState) || (p.poolState, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_WarmPool(p) {
    }
    function aws_cdk_lib_aws_autoscaling_PoolState(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.launchTemplate) || (p.launchTemplate, void 0), visitedObjects.has(p.lifecycleHookSpecificationList) || (p.lifecycleHookSpecificationList, void 0), visitedObjects.has(p.metricsCollection) || (p.metricsCollection, void 0), visitedObjects.has(p.mixedInstancesPolicy) || (p.mixedInstancesPolicy, void 0), visitedObjects.has(p.notificationConfigurations) || (p.notificationConfigurations, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_AcceleratorCountRequestProperty(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_AcceleratorTotalMemoryMiBRequestProperty(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_BaselineEbsBandwidthMbpsRequestProperty(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_InstanceRequirementsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.acceleratorCount) || (p.acceleratorCount, void 0), visitedObjects.has(p.acceleratorTotalMemoryMiB) || (p.acceleratorTotalMemoryMiB, void 0), visitedObjects.has(p.baselineEbsBandwidthMbps) || (p.baselineEbsBandwidthMbps, void 0), visitedObjects.has(p.memoryGiBPerVCpu) || (p.memoryGiBPerVCpu, void 0), visitedObjects.has(p.memoryMiB) || (p.memoryMiB, void 0), visitedObjects.has(p.networkBandwidthGbps) || (p.networkBandwidthGbps, void 0), visitedObjects.has(p.networkInterfaceCount) || (p.networkInterfaceCount, void 0), visitedObjects.has(p.totalLocalStorageGb) || (p.totalLocalStorageGb, void 0), visitedObjects.has(p.vCpuCount) || (p.vCpuCount, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_InstancesDistributionProperty(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_LaunchTemplateProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.launchTemplateSpecification) || (p.launchTemplateSpecification, void 0), visitedObjects.has(p.overrides) || (p.overrides, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_LaunchTemplateOverridesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.instanceRequirements) || (p.instanceRequirements, void 0), visitedObjects.has(p.launchTemplateSpecification) || (p.launchTemplateSpecification, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_LaunchTemplateSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_LifecycleHookSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_MemoryGiBPerVCpuRequestProperty(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_MemoryMiBRequestProperty(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_MetricsCollectionProperty(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_MixedInstancesPolicyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.launchTemplate) || (p.launchTemplate, void 0), visitedObjects.has(p.instancesDistribution) || (p.instancesDistribution, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_NetworkBandwidthGbpsRequestProperty(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_NetworkInterfaceCountRequestProperty(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_NotificationConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_TagPropertyProperty(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_TotalLocalStorageGBRequestProperty(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_VCpuCountRequestProperty(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnLaunchConfigurationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.blockDeviceMappings) || (p.blockDeviceMappings, void 0), visitedObjects.has(p.metadataOptions) || (p.metadataOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_CfnLaunchConfiguration(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnLaunchConfiguration_BlockDeviceProperty(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnLaunchConfiguration_BlockDeviceMappingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ebs) || (p.ebs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_CfnLaunchConfiguration_MetadataOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnLifecycleHookProps(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnLifecycleHook(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnScalingPolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.predictiveScalingConfiguration) || (p.predictiveScalingConfiguration, void 0), visitedObjects.has(p.stepAdjustments) || (p.stepAdjustments, void 0), visitedObjects.has(p.targetTrackingConfiguration) || (p.targetTrackingConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_CfnScalingPolicy(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_CustomizedMetricSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dimensions) || (p.dimensions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_MetricProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dimensions) || (p.dimensions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_MetricDataQueryProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.metricStat) || (p.metricStat, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_MetricDimensionProperty(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_MetricStatProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.metric) || (p.metric, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_PredefinedMetricSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_PredictiveScalingConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.metricSpecifications) || (p.metricSpecifications, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_PredictiveScalingCustomizedCapacityMetricProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.metricDataQueries) || (p.metricDataQueries, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_PredictiveScalingCustomizedLoadMetricProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.metricDataQueries) || (p.metricDataQueries, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_PredictiveScalingCustomizedScalingMetricProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.metricDataQueries) || (p.metricDataQueries, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_PredictiveScalingMetricSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customizedCapacityMetricSpecification) || (p.customizedCapacityMetricSpecification, void 0), visitedObjects.has(p.customizedLoadMetricSpecification) || (p.customizedLoadMetricSpecification, void 0), visitedObjects.has(p.customizedScalingMetricSpecification) || (p.customizedScalingMetricSpecification, void 0), visitedObjects.has(p.predefinedLoadMetricSpecification) || (p.predefinedLoadMetricSpecification, void 0), visitedObjects.has(p.predefinedMetricPairSpecification) || (p.predefinedMetricPairSpecification, void 0), visitedObjects.has(p.predefinedScalingMetricSpecification) || (p.predefinedScalingMetricSpecification, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_PredictiveScalingPredefinedLoadMetricProperty(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_PredictiveScalingPredefinedMetricPairProperty(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_PredictiveScalingPredefinedScalingMetricProperty(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_StepAdjustmentProperty(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_TargetTrackingConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customizedMetricSpecification) || (p.customizedMetricSpecification, void 0), visitedObjects.has(p.predefinedMetricSpecification) || (p.predefinedMetricSpecification, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_CfnScheduledActionProps(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnScheduledAction(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnWarmPoolProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.instanceReusePolicy) || (p.instanceReusePolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_CfnWarmPool(p) {
    }
    function aws_cdk_lib_aws_autoscaling_CfnWarmPool_InstanceReusePolicyProperty(p) {
    }
    function aws_cdk_lib_aws_autoscaling_common_ScalingInterval(p) {
    }
    function aws_cdk_lib_aws_autoscaling_common_CompleteScalingInterval(p) {
    }
    function aws_cdk_lib_aws_autoscaling_common_Alarms(p) {
    }
    function aws_cdk_lib_aws_autoscaling_common_IRandomGenerator(p) {
    }
    function aws_cdk_lib_aws_autoscaling_common_ArbitraryIntervals(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.intervals != null)
            for (const o of p.intervals)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscaling_hooktargets_QueueHook(p) {
    }
    function aws_cdk_lib_aws_autoscaling_hooktargets_TopicHook(p) {
    }
    function aws_cdk_lib_aws_autoscaling_hooktargets_FunctionHook(p) {
    }
    function aws_cdk_lib_aws_autoscalingplans_CfnScalingPlanProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.applicationSource) || (p.applicationSource, void 0), visitedObjects.has(p.scalingInstructions) || (p.scalingInstructions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscalingplans_CfnScalingPlan(p) {
    }
    function aws_cdk_lib_aws_autoscalingplans_CfnScalingPlan_ApplicationSourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tagFilters) || (p.tagFilters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscalingplans_CfnScalingPlan_CustomizedLoadMetricSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dimensions) || (p.dimensions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscalingplans_CfnScalingPlan_CustomizedScalingMetricSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dimensions) || (p.dimensions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscalingplans_CfnScalingPlan_MetricDimensionProperty(p) {
    }
    function aws_cdk_lib_aws_autoscalingplans_CfnScalingPlan_PredefinedLoadMetricSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_autoscalingplans_CfnScalingPlan_PredefinedScalingMetricSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_autoscalingplans_CfnScalingPlan_ScalingInstructionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.targetTrackingConfigurations) || (p.targetTrackingConfigurations, void 0), visitedObjects.has(p.customizedLoadMetricSpecification) || (p.customizedLoadMetricSpecification, void 0), visitedObjects.has(p.predefinedLoadMetricSpecification) || (p.predefinedLoadMetricSpecification, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_autoscalingplans_CfnScalingPlan_TagFilterProperty(p) {
    }
    function aws_cdk_lib_aws_autoscalingplans_CfnScalingPlan_TargetTrackingConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customizedScalingMetricSpecification) || (p.customizedScalingMetricSpecification, void 0), visitedObjects.has(p.predefinedScalingMetricSpecification) || (p.predefinedScalingMetricSpecification, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_backup_IBackupVault(p) {
    }
    function aws_cdk_lib_aws_backup_BackupVaultProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.accessPolicy) || (p.accessPolicy, void 0), visitedObjects.has(p.encryptionKey) || (p.encryptionKey, void 0), visitedObjects.has(p.lockConfiguration) || aws_cdk_lib_aws_backup_LockConfiguration(p.lockConfiguration), p.notificationEvents != null)
            for (const o of p.notificationEvents)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.notificationTopic) || (p.notificationTopic, void 0), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_backup_BackupVaultEvents(p) {
    }
    function aws_cdk_lib_aws_backup_LockConfiguration(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.minRetention) || (p.minRetention, void 0), visitedObjects.has(p.changeableFor) || (p.changeableFor, void 0), visitedObjects.has(p.maxRetention) || (p.maxRetention, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_backup_BackupVault(p) {
    }
    function aws_cdk_lib_aws_backup_IBackupPlan(p) {
    }
    function aws_cdk_lib_aws_backup_BackupPlanProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.backupPlanRules != null)
            for (const o of p.backupPlanRules)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.backupVault) || (p.backupVault, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_backup_BackupPlan(p) {
    }
    function aws_cdk_lib_aws_backup_BackupPlanRuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.backupVault) || (p.backupVault, void 0), visitedObjects.has(p.completionWindow) || (p.completionWindow, void 0), p.copyActions != null)
            for (const o of p.copyActions)
              visitedObjects.has(o) || aws_cdk_lib_aws_backup_BackupPlanCopyActionProps(o);
          visitedObjects.has(p.deleteAfter) || (p.deleteAfter, void 0), visitedObjects.has(p.moveToColdStorageAfter) || (p.moveToColdStorageAfter, void 0), visitedObjects.has(p.scheduleExpression) || (p.scheduleExpression, void 0), visitedObjects.has(p.startWindow) || (p.startWindow, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_backup_BackupPlanCopyActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destinationBackupVault) || (p.destinationBackupVault, void 0), visitedObjects.has(p.deleteAfter) || (p.deleteAfter, void 0), visitedObjects.has(p.moveToColdStorageAfter) || (p.moveToColdStorageAfter, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_backup_BackupPlanRule(p) {
    }
    function aws_cdk_lib_aws_backup_BackupSelectionOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.resources != null)
            for (const o of p.resources)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_backup_BackupSelectionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.backupPlan) || (p.backupPlan, void 0), p.resources != null)
            for (const o of p.resources)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_backup_BackupSelection(p) {
    }
    function aws_cdk_lib_aws_backup_TagOperation(p) {
    }
    function aws_cdk_lib_aws_backup_TagCondition(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.operation) || (p.operation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_backup_BackupResource(p) {
    }
    function aws_cdk_lib_aws_backup_CfnBackupPlanProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.backupPlan) || (p.backupPlan, void 0), visitedObjects.has(p.backupPlanTags) || (p.backupPlanTags, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_backup_CfnBackupPlan(p) {
    }
    function aws_cdk_lib_aws_backup_CfnBackupPlan_AdvancedBackupSettingResourceTypeProperty(p) {
    }
    function aws_cdk_lib_aws_backup_CfnBackupPlan_BackupPlanResourceTypeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.backupPlanRule) || (p.backupPlanRule, void 0), visitedObjects.has(p.advancedBackupSettings) || (p.advancedBackupSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_backup_CfnBackupPlan_BackupRuleResourceTypeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.copyActions) || (p.copyActions, void 0), visitedObjects.has(p.lifecycle) || (p.lifecycle, void 0), visitedObjects.has(p.recoveryPointTags) || (p.recoveryPointTags, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_backup_CfnBackupPlan_CopyActionResourceTypeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.lifecycle) || (p.lifecycle, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_backup_CfnBackupPlan_LifecycleResourceTypeProperty(p) {
    }
    function aws_cdk_lib_aws_backup_CfnBackupSelectionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.backupSelection) || (p.backupSelection, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_backup_CfnBackupSelection(p) {
    }
    function aws_cdk_lib_aws_backup_CfnBackupSelection_BackupSelectionResourceTypeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.listOfTags) || (p.listOfTags, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_backup_CfnBackupSelection_ConditionParameterProperty(p) {
    }
    function aws_cdk_lib_aws_backup_CfnBackupSelection_ConditionResourceTypeProperty(p) {
    }
    function aws_cdk_lib_aws_backup_CfnBackupSelection_ConditionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.stringEquals) || (p.stringEquals, void 0), visitedObjects.has(p.stringLike) || (p.stringLike, void 0), visitedObjects.has(p.stringNotEquals) || (p.stringNotEquals, void 0), visitedObjects.has(p.stringNotLike) || (p.stringNotLike, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_backup_CfnBackupVaultProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.backupVaultTags) || (p.backupVaultTags, void 0), visitedObjects.has(p.lockConfiguration) || (p.lockConfiguration, void 0), visitedObjects.has(p.notifications) || (p.notifications, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_backup_CfnBackupVault(p) {
    }
    function aws_cdk_lib_aws_backup_CfnBackupVault_LockConfigurationTypeProperty(p) {
    }
    function aws_cdk_lib_aws_backup_CfnBackupVault_NotificationObjectTypeProperty(p) {
    }
    function aws_cdk_lib_aws_backup_CfnFrameworkProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.frameworkControls) || (p.frameworkControls, void 0), visitedObjects.has(p.frameworkTags) || (p.frameworkTags, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_backup_CfnFramework(p) {
    }
    function aws_cdk_lib_aws_backup_CfnFramework_ControlInputParameterProperty(p) {
    }
    function aws_cdk_lib_aws_backup_CfnFramework_ControlScopeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_backup_CfnFramework_FrameworkControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.controlInputParameters) || (p.controlInputParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_backup_CfnReportPlanProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.reportPlanTags) || (p.reportPlanTags, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_backup_CfnReportPlan(p) {
    }
    function aws_cdk_lib_aws_backup_CfnReportPlan_ReportDeliveryChannelProperty(p) {
    }
    function aws_cdk_lib_aws_backup_CfnReportPlan_ReportSettingProperty(p) {
    }
    function aws_cdk_lib_aws_backupgateway_CfnHypervisorProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_backupgateway_CfnHypervisor(p) {
    }
    function aws_cdk_lib_aws_batch_CfnComputeEnvironmentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.computeResources) || (p.computeResources, void 0), visitedObjects.has(p.eksConfiguration) || (p.eksConfiguration, void 0), visitedObjects.has(p.updatePolicy) || (p.updatePolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_batch_CfnComputeEnvironment(p) {
    }
    function aws_cdk_lib_aws_batch_CfnComputeEnvironment_ComputeResourcesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ec2Configuration) || (p.ec2Configuration, void 0), visitedObjects.has(p.launchTemplate) || (p.launchTemplate, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_batch_CfnComputeEnvironment_Ec2ConfigurationObjectProperty(p) {
    }
    function aws_cdk_lib_aws_batch_CfnComputeEnvironment_EksConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_batch_CfnComputeEnvironment_LaunchTemplateSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_batch_CfnComputeEnvironment_UpdatePolicyProperty(p) {
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinitionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.containerProperties) || (p.containerProperties, void 0), visitedObjects.has(p.eksProperties) || (p.eksProperties, void 0), visitedObjects.has(p.nodeProperties) || (p.nodeProperties, void 0), visitedObjects.has(p.retryStrategy) || (p.retryStrategy, void 0), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition(p) {
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_AuthorizationConfigProperty(p) {
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_ContainerPropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.environment) || (p.environment, void 0), visitedObjects.has(p.ephemeralStorage) || (p.ephemeralStorage, void 0), visitedObjects.has(p.fargatePlatformConfiguration) || (p.fargatePlatformConfiguration, void 0), visitedObjects.has(p.linuxParameters) || (p.linuxParameters, void 0), visitedObjects.has(p.logConfiguration) || (p.logConfiguration, void 0), visitedObjects.has(p.mountPoints) || (p.mountPoints, void 0), visitedObjects.has(p.networkConfiguration) || (p.networkConfiguration, void 0), visitedObjects.has(p.resourceRequirements) || (p.resourceRequirements, void 0), visitedObjects.has(p.secrets) || (p.secrets, void 0), visitedObjects.has(p.ulimits) || (p.ulimits, void 0), visitedObjects.has(p.volumes) || (p.volumes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_DeviceProperty(p) {
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_EfsVolumeConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.authorizationConfig) || (p.authorizationConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_EksContainerProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.env) || (p.env, void 0), visitedObjects.has(p.resources) || (p.resources, void 0), visitedObjects.has(p.securityContext) || (p.securityContext, void 0), visitedObjects.has(p.volumeMounts) || (p.volumeMounts, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_EksContainerEnvironmentVariableProperty(p) {
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_EksContainerVolumeMountProperty(p) {
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_EksPropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.podProperties) || (p.podProperties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_EksSecretProperty(p) {
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_EksVolumeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.emptyDir) || (p.emptyDir, void 0), visitedObjects.has(p.hostPath) || (p.hostPath, void 0), visitedObjects.has(p.secret) || (p.secret, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_EmptyDirProperty(p) {
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_EnvironmentProperty(p) {
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_EphemeralStorageProperty(p) {
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_EvaluateOnExitProperty(p) {
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_FargatePlatformConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_HostPathProperty(p) {
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_LinuxParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.devices) || (p.devices, void 0), visitedObjects.has(p.tmpfs) || (p.tmpfs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_LogConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.secretOptions) || (p.secretOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_MetadataProperty(p) {
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_MountPointsProperty(p) {
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_NetworkConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_NodePropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.nodeRangeProperties) || (p.nodeRangeProperties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_NodeRangePropertyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.container) || (p.container, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_PodPropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.containers) || (p.containers, void 0), visitedObjects.has(p.metadata) || (p.metadata, void 0), visitedObjects.has(p.volumes) || (p.volumes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_ResourceRequirementProperty(p) {
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_ResourcesProperty(p) {
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_RetryStrategyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.evaluateOnExit) || (p.evaluateOnExit, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_SecretProperty(p) {
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_SecurityContextProperty(p) {
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_TimeoutProperty(p) {
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_TmpfsProperty(p) {
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_UlimitProperty(p) {
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_VolumesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.efsVolumeConfiguration) || (p.efsVolumeConfiguration, void 0), visitedObjects.has(p.host) || (p.host, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_batch_CfnJobDefinition_VolumesHostProperty(p) {
    }
    function aws_cdk_lib_aws_batch_CfnJobQueueProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.computeEnvironmentOrder) || (p.computeEnvironmentOrder, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_batch_CfnJobQueue(p) {
    }
    function aws_cdk_lib_aws_batch_CfnJobQueue_ComputeEnvironmentOrderProperty(p) {
    }
    function aws_cdk_lib_aws_batch_CfnSchedulingPolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fairsharePolicy) || (p.fairsharePolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_batch_CfnSchedulingPolicy(p) {
    }
    function aws_cdk_lib_aws_batch_CfnSchedulingPolicy_FairsharePolicyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.shareDistribution) || (p.shareDistribution, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_batch_CfnSchedulingPolicy_ShareAttributesProperty(p) {
    }
    function aws_cdk_lib_aws_billingconductor_CfnBillingGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.accountGrouping) || (p.accountGrouping, void 0), visitedObjects.has(p.computationPreference) || (p.computationPreference, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_billingconductor_CfnBillingGroup(p) {
    }
    function aws_cdk_lib_aws_billingconductor_CfnBillingGroup_AccountGroupingProperty(p) {
    }
    function aws_cdk_lib_aws_billingconductor_CfnBillingGroup_ComputationPreferenceProperty(p) {
    }
    function aws_cdk_lib_aws_billingconductor_CfnCustomLineItemProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.billingPeriodRange) || (p.billingPeriodRange, void 0), visitedObjects.has(p.customLineItemChargeDetails) || (p.customLineItemChargeDetails, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_billingconductor_CfnCustomLineItem(p) {
    }
    function aws_cdk_lib_aws_billingconductor_CfnCustomLineItem_BillingPeriodRangeProperty(p) {
    }
    function aws_cdk_lib_aws_billingconductor_CfnCustomLineItem_CustomLineItemChargeDetailsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.flat) || (p.flat, void 0), visitedObjects.has(p.percentage) || (p.percentage, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_billingconductor_CfnCustomLineItem_CustomLineItemFlatChargeDetailsProperty(p) {
    }
    function aws_cdk_lib_aws_billingconductor_CfnCustomLineItem_CustomLineItemPercentageChargeDetailsProperty(p) {
    }
    function aws_cdk_lib_aws_billingconductor_CfnPricingPlanProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_billingconductor_CfnPricingPlan(p) {
    }
    function aws_cdk_lib_aws_billingconductor_CfnPricingRuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.tiering) || (p.tiering, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_billingconductor_CfnPricingRule(p) {
    }
    function aws_cdk_lib_aws_billingconductor_CfnPricingRule_FreeTierProperty(p) {
    }
    function aws_cdk_lib_aws_billingconductor_CfnPricingRule_TieringProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.freeTier) || (p.freeTier, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_budgets_CfnBudgetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.budget) || (p.budget, void 0), visitedObjects.has(p.notificationsWithSubscribers) || (p.notificationsWithSubscribers, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_budgets_CfnBudget(p) {
    }
    function aws_cdk_lib_aws_budgets_CfnBudget_AutoAdjustDataProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.historicalOptions) || (p.historicalOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_budgets_CfnBudget_BudgetDataProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.autoAdjustData) || (p.autoAdjustData, void 0), visitedObjects.has(p.budgetLimit) || (p.budgetLimit, void 0), visitedObjects.has(p.costTypes) || (p.costTypes, void 0), visitedObjects.has(p.timePeriod) || (p.timePeriod, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_budgets_CfnBudget_CostTypesProperty(p) {
    }
    function aws_cdk_lib_aws_budgets_CfnBudget_HistoricalOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_budgets_CfnBudget_NotificationProperty(p) {
    }
    function aws_cdk_lib_aws_budgets_CfnBudget_NotificationWithSubscribersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.notification) || (p.notification, void 0), visitedObjects.has(p.subscribers) || (p.subscribers, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_budgets_CfnBudget_SpendProperty(p) {
    }
    function aws_cdk_lib_aws_budgets_CfnBudget_SubscriberProperty(p) {
    }
    function aws_cdk_lib_aws_budgets_CfnBudget_TimePeriodProperty(p) {
    }
    function aws_cdk_lib_aws_budgets_CfnBudgetsActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actionThreshold) || (p.actionThreshold, void 0), visitedObjects.has(p.definition) || (p.definition, void 0), visitedObjects.has(p.subscribers) || (p.subscribers, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_budgets_CfnBudgetsAction(p) {
    }
    function aws_cdk_lib_aws_budgets_CfnBudgetsAction_ActionThresholdProperty(p) {
    }
    function aws_cdk_lib_aws_budgets_CfnBudgetsAction_DefinitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.iamActionDefinition) || (p.iamActionDefinition, void 0), visitedObjects.has(p.scpActionDefinition) || (p.scpActionDefinition, void 0), visitedObjects.has(p.ssmActionDefinition) || (p.ssmActionDefinition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_budgets_CfnBudgetsAction_IamActionDefinitionProperty(p) {
    }
    function aws_cdk_lib_aws_budgets_CfnBudgetsAction_ScpActionDefinitionProperty(p) {
    }
    function aws_cdk_lib_aws_budgets_CfnBudgetsAction_SsmActionDefinitionProperty(p) {
    }
    function aws_cdk_lib_aws_budgets_CfnBudgetsAction_SubscriberProperty(p) {
    }
    function aws_cdk_lib_aws_cassandra_CfnKeyspaceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cassandra_CfnKeyspace(p) {
    }
    function aws_cdk_lib_aws_cassandra_CfnTableProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.partitionKeyColumns) || (p.partitionKeyColumns, void 0), visitedObjects.has(p.billingMode) || (p.billingMode, void 0), visitedObjects.has(p.clusteringKeyColumns) || (p.clusteringKeyColumns, void 0), visitedObjects.has(p.encryptionSpecification) || (p.encryptionSpecification, void 0), visitedObjects.has(p.regularColumns) || (p.regularColumns, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cassandra_CfnTable(p) {
    }
    function aws_cdk_lib_aws_cassandra_CfnTable_BillingModeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.provisionedThroughput) || (p.provisionedThroughput, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cassandra_CfnTable_ClusteringKeyColumnProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cassandra_CfnTable_ColumnProperty(p) {
    }
    function aws_cdk_lib_aws_cassandra_CfnTable_EncryptionSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_cassandra_CfnTable_ProvisionedThroughputProperty(p) {
    }
    function aws_cdk_lib_aws_ce_CfnAnomalyMonitorProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.resourceTags) || (p.resourceTags, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ce_CfnAnomalyMonitor(p) {
    }
    function aws_cdk_lib_aws_ce_CfnAnomalyMonitor_ResourceTagProperty(p) {
    }
    function aws_cdk_lib_aws_ce_CfnAnomalySubscriptionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.subscribers) || (p.subscribers, void 0), visitedObjects.has(p.resourceTags) || (p.resourceTags, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ce_CfnAnomalySubscription(p) {
    }
    function aws_cdk_lib_aws_ce_CfnAnomalySubscription_ResourceTagProperty(p) {
    }
    function aws_cdk_lib_aws_ce_CfnAnomalySubscription_SubscriberProperty(p) {
    }
    function aws_cdk_lib_aws_ce_CfnCostCategoryProps(p) {
    }
    function aws_cdk_lib_aws_ce_CfnCostCategory(p) {
    }
    function aws_cdk_lib_aws_certificatemanager_ICertificate(p) {
    }
    function aws_cdk_lib_aws_certificatemanager_CertificateProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.validation) || (p.validation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_certificatemanager_CertificationValidationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.hostedZone) || (p.hostedZone, void 0), p.hostedZones != null)
            for (const o of Object.values(p.hostedZones))
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.method) || (p.method, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_certificatemanager_CertificateValidation(p) {
    }
    function aws_cdk_lib_aws_certificatemanager_Certificate(p) {
    }
    function aws_cdk_lib_aws_certificatemanager_ValidationMethod(p) {
    }
    function aws_cdk_lib_aws_certificatemanager_DnsValidatedCertificateProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.hostedZone) || (p.hostedZone, void 0), visitedObjects.has(p.customResourceRole) || (p.customResourceRole, void 0), visitedObjects.has(p.validation) || (p.validation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_certificatemanager_DnsValidatedCertificate(p) {
    }
    function aws_cdk_lib_aws_certificatemanager_PrivateCertificateProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.certificateAuthority) || (p.certificateAuthority, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_certificatemanager_PrivateCertificate(p) {
    }
    function aws_cdk_lib_aws_certificatemanager_CfnAccountProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.expiryEventsConfiguration) || (p.expiryEventsConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_certificatemanager_CfnAccount(p) {
    }
    function aws_cdk_lib_aws_certificatemanager_CfnAccount_ExpiryEventsConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_certificatemanager_CfnCertificateProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.domainValidationOptions) || (p.domainValidationOptions, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_certificatemanager_CfnCertificate(p) {
    }
    function aws_cdk_lib_aws_certificatemanager_CfnCertificate_DomainValidationOptionProperty(p) {
    }
    function aws_cdk_lib_aws_chatbot_CfnMicrosoftTeamsChannelConfigurationProps(p) {
    }
    function aws_cdk_lib_aws_chatbot_CfnMicrosoftTeamsChannelConfiguration(p) {
    }
    function aws_cdk_lib_aws_chatbot_CfnSlackChannelConfigurationProps(p) {
    }
    function aws_cdk_lib_aws_chatbot_CfnSlackChannelConfiguration(p) {
    }
    function aws_cdk_lib_aws_chatbot_SlackChannelConfigurationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.guardrailPolicies != null)
            for (const o of p.guardrailPolicies)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.loggingLevel) || (p.loggingLevel, void 0), visitedObjects.has(p.logRetention) || (p.logRetention, void 0), visitedObjects.has(p.logRetentionRetryOptions) || aws_cdk_lib_aws_logs_LogRetentionRetryOptions(p.logRetentionRetryOptions), visitedObjects.has(p.logRetentionRole) || (p.logRetentionRole, void 0), p.notificationTopics != null)
            for (const o of p.notificationTopics)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_chatbot_LoggingLevel(p) {
    }
    function aws_cdk_lib_aws_chatbot_ISlackChannelConfiguration(p) {
    }
    function aws_cdk_lib_aws_chatbot_SlackChannelConfiguration(p) {
    }
    function aws_cdk_lib_aws_cloud9_CfnEnvironmentEC2Props(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.repositories) || (p.repositories, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloud9_CfnEnvironmentEC2(p) {
    }
    function aws_cdk_lib_aws_cloud9_CfnEnvironmentEC2_RepositoryProperty(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnCustomResourceProps(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnCustomResource(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnHookDefaultVersionProps(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnHookDefaultVersion(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnHookTypeConfigProps(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnHookTypeConfig(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnHookVersionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.loggingConfig) || (p.loggingConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudformation_CfnHookVersion(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnHookVersion_LoggingConfigProperty(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnMacroProps(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnMacro(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnModuleDefaultVersionProps(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnModuleDefaultVersion(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnModuleVersionProps(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnModuleVersion(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnPublicTypeVersionProps(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnPublicTypeVersion(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnPublisherProps(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnPublisher(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnResourceDefaultVersionProps(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnResourceDefaultVersion(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnResourceVersionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.loggingConfig) || (p.loggingConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudformation_CfnResourceVersion(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnResourceVersion_LoggingConfigProperty(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnStackProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.parameters) || (p.parameters, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudformation_CfnStack(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnStackSetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.autoDeployment) || (p.autoDeployment, void 0), visitedObjects.has(p.operationPreferences) || (p.operationPreferences, void 0), visitedObjects.has(p.parameters) || (p.parameters, void 0), visitedObjects.has(p.stackInstancesGroup) || (p.stackInstancesGroup, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudformation_CfnStackSet(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnStackSet_AutoDeploymentProperty(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnStackSet_DeploymentTargetsProperty(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnStackSet_ManagedExecutionProperty(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnStackSet_OperationPreferencesProperty(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnStackSet_ParameterProperty(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnStackSet_StackInstancesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.deploymentTargets) || (p.deploymentTargets, void 0), visitedObjects.has(p.parameterOverrides) || (p.parameterOverrides, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudformation_CfnTypeActivationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.loggingConfig) || (p.loggingConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudformation_CfnTypeActivation(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnTypeActivation_LoggingConfigProperty(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnWaitConditionProps(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnWaitCondition(p) {
    }
    function aws_cdk_lib_aws_cloudformation_CfnWaitConditionHandle(p) {
    }
    function aws_cdk_lib_aws_cloudfront_experimental_EdgeFunctionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.code) || (p.code, void 0), visitedObjects.has(p.runtime) || (p.runtime, void 0), visitedObjects.has(p.adotInstrumentation) || aws_cdk_lib_aws_lambda_AdotInstrumentationConfig(p.adotInstrumentation), visitedObjects.has(p.architecture) || (p.architecture, void 0), visitedObjects.has(p.codeSigningConfig) || (p.codeSigningConfig, void 0), visitedObjects.has(p.currentVersionOptions) || aws_cdk_lib_aws_lambda_VersionOptions(p.currentVersionOptions), visitedObjects.has(p.deadLetterQueue) || (p.deadLetterQueue, void 0), visitedObjects.has(p.deadLetterTopic) || (p.deadLetterTopic, void 0), visitedObjects.has(p.environmentEncryption) || (p.environmentEncryption, void 0), visitedObjects.has(p.ephemeralStorageSize) || (p.ephemeralStorageSize, void 0), p.events != null)
            for (const o of p.events)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.filesystem) || (p.filesystem, void 0), p.initialPolicy != null)
            for (const o of p.initialPolicy)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.insightsVersion) || (p.insightsVersion, void 0), p.layers != null)
            for (const o of p.layers)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.logRetention) || (p.logRetention, void 0), visitedObjects.has(p.logRetentionRetryOptions) || aws_cdk_lib_aws_lambda_LogRetentionRetryOptions(p.logRetentionRetryOptions), visitedObjects.has(p.logRetentionRole) || (p.logRetentionRole, void 0), visitedObjects.has(p.profilingGroup) || (p.profilingGroup, void 0), visitedObjects.has(p.role) || (p.role, void 0), visitedObjects.has(p.runtimeManagementMode) || (p.runtimeManagementMode, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.timeout) || (p.timeout, void 0), visitedObjects.has(p.tracing) || (p.tracing, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets), visitedObjects.has(p.maxEventAge) || (p.maxEventAge, void 0), visitedObjects.has(p.onFailure) || (p.onFailure, void 0), visitedObjects.has(p.onSuccess) || (p.onSuccess, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_experimental_EdgeFunction(p) {
    }
    function aws_cdk_lib_aws_cloudfront_ICachePolicy(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CachePolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cookieBehavior) || (p.cookieBehavior, void 0), visitedObjects.has(p.defaultTtl) || (p.defaultTtl, void 0), visitedObjects.has(p.headerBehavior) || (p.headerBehavior, void 0), visitedObjects.has(p.maxTtl) || (p.maxTtl, void 0), visitedObjects.has(p.minTtl) || (p.minTtl, void 0), visitedObjects.has(p.queryStringBehavior) || (p.queryStringBehavior, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CachePolicy(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CacheCookieBehavior(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CacheHeaderBehavior(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CacheQueryStringBehavior(p) {
    }
    function aws_cdk_lib_aws_cloudfront_IDistribution(p) {
    }
    function aws_cdk_lib_aws_cloudfront_DistributionAttributes(p) {
    }
    function aws_cdk_lib_aws_cloudfront_DistributionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.defaultBehavior) || aws_cdk_lib_aws_cloudfront_BehaviorOptions(p.defaultBehavior), p.additionalBehaviors != null)
            for (const o of Object.values(p.additionalBehaviors))
              visitedObjects.has(o) || aws_cdk_lib_aws_cloudfront_BehaviorOptions(o);
          if (visitedObjects.has(p.certificate) || (p.certificate, void 0), p.errorResponses != null)
            for (const o of p.errorResponses)
              visitedObjects.has(o) || aws_cdk_lib_aws_cloudfront_ErrorResponse(o);
          visitedObjects.has(p.geoRestriction) || (p.geoRestriction, void 0), visitedObjects.has(p.httpVersion) || (p.httpVersion, void 0), visitedObjects.has(p.logBucket) || (p.logBucket, void 0), visitedObjects.has(p.minimumProtocolVersion) || (p.minimumProtocolVersion, void 0), visitedObjects.has(p.priceClass) || (p.priceClass, void 0), visitedObjects.has(p.sslSupportMethod) || (p.sslSupportMethod, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_Distribution(p) {
    }
    function aws_cdk_lib_aws_cloudfront_HttpVersion(p) {
    }
    function aws_cdk_lib_aws_cloudfront_PriceClass(p) {
    }
    function aws_cdk_lib_aws_cloudfront_ViewerProtocolPolicy(p) {
    }
    function aws_cdk_lib_aws_cloudfront_OriginProtocolPolicy(p) {
    }
    function aws_cdk_lib_aws_cloudfront_SSLMethod(p) {
    }
    function aws_cdk_lib_aws_cloudfront_SecurityPolicyProtocol(p) {
    }
    function aws_cdk_lib_aws_cloudfront_AllowedMethods(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CachedMethods(p) {
    }
    function aws_cdk_lib_aws_cloudfront_ErrorResponse(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ttl) || (p.ttl, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_LambdaEdgeEventType(p) {
    }
    function aws_cdk_lib_aws_cloudfront_EdgeLambda(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.eventType) || (p.eventType, void 0), visitedObjects.has(p.functionVersion) || (p.functionVersion, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_AddBehaviorOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.allowedMethods) || (p.allowedMethods, void 0), visitedObjects.has(p.cachedMethods) || (p.cachedMethods, void 0), visitedObjects.has(p.cachePolicy) || (p.cachePolicy, void 0), p.edgeLambdas != null)
            for (const o of p.edgeLambdas)
              visitedObjects.has(o) || aws_cdk_lib_aws_cloudfront_EdgeLambda(o);
          if (p.functionAssociations != null)
            for (const o of p.functionAssociations)
              visitedObjects.has(o) || aws_cdk_lib_aws_cloudfront_FunctionAssociation(o);
          if (visitedObjects.has(p.originRequestPolicy) || (p.originRequestPolicy, void 0), visitedObjects.has(p.responseHeadersPolicy) || (p.responseHeadersPolicy, void 0), p.trustedKeyGroups != null)
            for (const o of p.trustedKeyGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.viewerProtocolPolicy) || (p.viewerProtocolPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_BehaviorOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.origin) || (p.origin, void 0), visitedObjects.has(p.allowedMethods) || (p.allowedMethods, void 0), visitedObjects.has(p.cachedMethods) || (p.cachedMethods, void 0), visitedObjects.has(p.cachePolicy) || (p.cachePolicy, void 0), p.edgeLambdas != null)
            for (const o of p.edgeLambdas)
              visitedObjects.has(o) || aws_cdk_lib_aws_cloudfront_EdgeLambda(o);
          if (p.functionAssociations != null)
            for (const o of p.functionAssociations)
              visitedObjects.has(o) || aws_cdk_lib_aws_cloudfront_FunctionAssociation(o);
          if (visitedObjects.has(p.originRequestPolicy) || (p.originRequestPolicy, void 0), visitedObjects.has(p.responseHeadersPolicy) || (p.responseHeadersPolicy, void 0), p.trustedKeyGroups != null)
            for (const o of p.trustedKeyGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.viewerProtocolPolicy) || (p.viewerProtocolPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_FunctionCode(p) {
    }
    function aws_cdk_lib_aws_cloudfront_FileCodeOptions(p) {
    }
    function aws_cdk_lib_aws_cloudfront_IFunction(p) {
    }
    function aws_cdk_lib_aws_cloudfront_FunctionAttributes(p) {
    }
    function aws_cdk_lib_aws_cloudfront_FunctionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.code) || (p.code, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_Function(p) {
    }
    function aws_cdk_lib_aws_cloudfront_FunctionEventType(p) {
    }
    function aws_cdk_lib_aws_cloudfront_FunctionAssociation(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.eventType) || (p.eventType, void 0), visitedObjects.has(p.function) || (p.function, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_GeoRestriction(p) {
    }
    function aws_cdk_lib_aws_cloudfront_IKeyGroup(p) {
    }
    function aws_cdk_lib_aws_cloudfront_KeyGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.items != null)
            for (const o of p.items)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_KeyGroup(p) {
    }
    function aws_cdk_lib_aws_cloudfront_OriginFailoverConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.failoverOrigin) || (p.failoverOrigin, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_OriginBindConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.failoverConfig) || aws_cdk_lib_aws_cloudfront_OriginFailoverConfig(p.failoverConfig), visitedObjects.has(p.originProperty) || aws_cdk_lib_aws_cloudfront_CfnDistribution_OriginProperty(p.originProperty);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_IOrigin(p) {
    }
    function aws_cdk_lib_aws_cloudfront_OriginOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.connectionTimeout) || (p.connectionTimeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_OriginProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.connectionTimeout) || (p.connectionTimeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_OriginBindOptions(p) {
    }
    function aws_cdk_lib_aws_cloudfront_OriginBase(p) {
    }
    function aws_cdk_lib_aws_cloudfront_OriginAccessIdentityProps(p) {
    }
    function aws_cdk_lib_aws_cloudfront_IOriginAccessIdentity(p) {
    }
    function aws_cdk_lib_aws_cloudfront_OriginAccessIdentity(p) {
    }
    function aws_cdk_lib_aws_cloudfront_IOriginRequestPolicy(p) {
    }
    function aws_cdk_lib_aws_cloudfront_OriginRequestPolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cookieBehavior) || (p.cookieBehavior, void 0), visitedObjects.has(p.headerBehavior) || (p.headerBehavior, void 0), visitedObjects.has(p.queryStringBehavior) || (p.queryStringBehavior, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_OriginRequestPolicy(p) {
    }
    function aws_cdk_lib_aws_cloudfront_OriginRequestCookieBehavior(p) {
    }
    function aws_cdk_lib_aws_cloudfront_OriginRequestHeaderBehavior(p) {
    }
    function aws_cdk_lib_aws_cloudfront_OriginRequestQueryStringBehavior(p) {
    }
    function aws_cdk_lib_aws_cloudfront_IPublicKey(p) {
    }
    function aws_cdk_lib_aws_cloudfront_PublicKeyProps(p) {
    }
    function aws_cdk_lib_aws_cloudfront_PublicKey(p) {
    }
    function aws_cdk_lib_aws_cloudfront_IResponseHeadersPolicy(p) {
    }
    function aws_cdk_lib_aws_cloudfront_ResponseHeadersPolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.corsBehavior) || aws_cdk_lib_aws_cloudfront_ResponseHeadersCorsBehavior(p.corsBehavior), visitedObjects.has(p.customHeadersBehavior) || aws_cdk_lib_aws_cloudfront_ResponseCustomHeadersBehavior(p.customHeadersBehavior), visitedObjects.has(p.securityHeadersBehavior) || aws_cdk_lib_aws_cloudfront_ResponseSecurityHeadersBehavior(p.securityHeadersBehavior);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_ResponseHeadersPolicy(p) {
    }
    function aws_cdk_lib_aws_cloudfront_ResponseHeadersCorsBehavior(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.accessControlMaxAge) || (p.accessControlMaxAge, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_ResponseCustomHeadersBehavior(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.customHeaders != null)
            for (const o of p.customHeaders)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_ResponseCustomHeader(p) {
    }
    function aws_cdk_lib_aws_cloudfront_ResponseSecurityHeadersBehavior(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.contentSecurityPolicy) || (p.contentSecurityPolicy, void 0), visitedObjects.has(p.contentTypeOptions) || (p.contentTypeOptions, void 0), visitedObjects.has(p.frameOptions) || aws_cdk_lib_aws_cloudfront_ResponseHeadersFrameOptions(p.frameOptions), visitedObjects.has(p.referrerPolicy) || aws_cdk_lib_aws_cloudfront_ResponseHeadersReferrerPolicy(p.referrerPolicy), visitedObjects.has(p.strictTransportSecurity) || aws_cdk_lib_aws_cloudfront_ResponseHeadersStrictTransportSecurity(p.strictTransportSecurity), visitedObjects.has(p.xssProtection) || (p.xssProtection, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_ResponseHeadersContentSecurityPolicy(p) {
    }
    function aws_cdk_lib_aws_cloudfront_ResponseHeadersContentTypeOptions(p) {
    }
    function aws_cdk_lib_aws_cloudfront_ResponseHeadersFrameOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.frameOption) || (p.frameOption, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_ResponseHeadersReferrerPolicy(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.referrerPolicy) || (p.referrerPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_ResponseHeadersStrictTransportSecurity(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.accessControlMaxAge) || (p.accessControlMaxAge, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_ResponseHeadersXSSProtection(p) {
    }
    function aws_cdk_lib_aws_cloudfront_HeadersFrameOption(p) {
    }
    function aws_cdk_lib_aws_cloudfront_HeadersReferrerPolicy(p) {
    }
    function aws_cdk_lib_aws_cloudfront_FailoverStatusCode(p) {
    }
    function aws_cdk_lib_aws_cloudfront_LoggingConfiguration(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bucket) || (p.bucket, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_SourceConfiguration(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.behaviors != null)
            for (const o of p.behaviors)
              visitedObjects.has(o) || aws_cdk_lib_aws_cloudfront_Behavior(o);
          if (visitedObjects.has(p.connectionTimeout) || (p.connectionTimeout, void 0), visitedObjects.has(p.customOriginSource) || aws_cdk_lib_aws_cloudfront_CustomOriginConfig(p.customOriginSource), p.failoverCriteriaStatusCodes != null)
            for (const o of p.failoverCriteriaStatusCodes)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.failoverCustomOriginSource) || aws_cdk_lib_aws_cloudfront_CustomOriginConfig(p.failoverCustomOriginSource), visitedObjects.has(p.failoverS3OriginSource) || aws_cdk_lib_aws_cloudfront_S3OriginConfig(p.failoverS3OriginSource), visitedObjects.has(p.s3OriginSource) || aws_cdk_lib_aws_cloudfront_S3OriginConfig(p.s3OriginSource);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CustomOriginConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.allowedOriginSSLVersions != null)
            for (const o of p.allowedOriginSSLVersions)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.originKeepaliveTimeout) || (p.originKeepaliveTimeout, void 0), visitedObjects.has(p.originProtocolPolicy) || (p.originProtocolPolicy, void 0), visitedObjects.has(p.originReadTimeout) || (p.originReadTimeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_OriginSslPolicy(p) {
    }
    function aws_cdk_lib_aws_cloudfront_S3OriginConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3BucketSource) || (p.s3BucketSource, void 0), visitedObjects.has(p.originAccessIdentity) || (p.originAccessIdentity, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CloudFrontAllowedMethods(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CloudFrontAllowedCachedMethods(p) {
    }
    function aws_cdk_lib_aws_cloudfront_Behavior(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.allowedMethods) || (p.allowedMethods, void 0), visitedObjects.has(p.cachedMethods) || (p.cachedMethods, void 0), visitedObjects.has(p.defaultTtl) || (p.defaultTtl, void 0), visitedObjects.has(p.forwardedValues) || aws_cdk_lib_aws_cloudfront_CfnDistribution_ForwardedValuesProperty(p.forwardedValues), p.functionAssociations != null)
            for (const o of p.functionAssociations)
              visitedObjects.has(o) || aws_cdk_lib_aws_cloudfront_FunctionAssociation(o);
          if (p.lambdaFunctionAssociations != null)
            for (const o of p.lambdaFunctionAssociations)
              visitedObjects.has(o) || aws_cdk_lib_aws_cloudfront_LambdaFunctionAssociation(o);
          if (visitedObjects.has(p.maxTtl) || (p.maxTtl, void 0), visitedObjects.has(p.minTtl) || (p.minTtl, void 0), p.trustedKeyGroups != null)
            for (const o of p.trustedKeyGroups)
              visitedObjects.has(o) || void 0;
          "trustedSigners" in p && print("aws-cdk-lib.aws_cloudfront.Behavior#trustedSigners", "- We recommend using trustedKeyGroups instead of trustedSigners."), visitedObjects.has(p.viewerProtocolPolicy) || (p.viewerProtocolPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_LambdaFunctionAssociation(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.eventType) || (p.eventType, void 0), visitedObjects.has(p.lambdaFunction) || (p.lambdaFunction, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_ViewerCertificateOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.securityPolicy) || (p.securityPolicy, void 0), visitedObjects.has(p.sslMethod) || (p.sslMethod, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_ViewerCertificate(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CloudFrontWebDistributionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.originConfigs != null)
            for (const o of p.originConfigs)
              visitedObjects.has(o) || aws_cdk_lib_aws_cloudfront_SourceConfiguration(o);
          if (p.errorConfigurations != null)
            for (const o of p.errorConfigurations)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.geoRestriction) || (p.geoRestriction, void 0), visitedObjects.has(p.httpVersion) || (p.httpVersion, void 0), visitedObjects.has(p.loggingConfig) || aws_cdk_lib_aws_cloudfront_LoggingConfiguration(p.loggingConfig), visitedObjects.has(p.priceClass) || (p.priceClass, void 0), visitedObjects.has(p.viewerCertificate) || (p.viewerCertificate, void 0), visitedObjects.has(p.viewerProtocolPolicy) || (p.viewerProtocolPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CloudFrontWebDistributionAttributes(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CloudFrontWebDistribution(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnCachePolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cachePolicyConfig) || (p.cachePolicyConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnCachePolicy(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnCachePolicy_CachePolicyConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.parametersInCacheKeyAndForwardedToOrigin) || (p.parametersInCacheKeyAndForwardedToOrigin, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnCachePolicy_CookiesConfigProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnCachePolicy_HeadersConfigProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnCachePolicy_ParametersInCacheKeyAndForwardedToOriginProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cookiesConfig) || (p.cookiesConfig, void 0), visitedObjects.has(p.headersConfig) || (p.headersConfig, void 0), visitedObjects.has(p.queryStringsConfig) || (p.queryStringsConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnCachePolicy_QueryStringsConfigProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnCloudFrontOriginAccessIdentityProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cloudFrontOriginAccessIdentityConfig) || (p.cloudFrontOriginAccessIdentityConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnCloudFrontOriginAccessIdentity(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnCloudFrontOriginAccessIdentity_CloudFrontOriginAccessIdentityConfigProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnContinuousDeploymentPolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.continuousDeploymentPolicyConfig) || (p.continuousDeploymentPolicyConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnContinuousDeploymentPolicy(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnContinuousDeploymentPolicy_ContinuousDeploymentPolicyConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.trafficConfig) || (p.trafficConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnContinuousDeploymentPolicy_SessionStickinessConfigProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnContinuousDeploymentPolicy_SingleHeaderConfigProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnContinuousDeploymentPolicy_SingleWeightConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sessionStickinessConfig) || (p.sessionStickinessConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnContinuousDeploymentPolicy_TrafficConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.singleHeaderConfig) || (p.singleHeaderConfig, void 0), visitedObjects.has(p.singleWeightConfig) || (p.singleWeightConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnDistributionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.distributionConfig) || (p.distributionConfig, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnDistribution(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnDistribution_CacheBehaviorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.forwardedValues) || (p.forwardedValues, void 0), visitedObjects.has(p.functionAssociations) || (p.functionAssociations, void 0), visitedObjects.has(p.lambdaFunctionAssociations) || (p.lambdaFunctionAssociations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnDistribution_CookiesProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnDistribution_CustomErrorResponseProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnDistribution_CustomOriginConfigProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnDistribution_DefaultCacheBehaviorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.forwardedValues) || (p.forwardedValues, void 0), visitedObjects.has(p.functionAssociations) || (p.functionAssociations, void 0), visitedObjects.has(p.lambdaFunctionAssociations) || (p.lambdaFunctionAssociations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnDistribution_DistributionConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultCacheBehavior) || (p.defaultCacheBehavior, void 0), visitedObjects.has(p.cacheBehaviors) || (p.cacheBehaviors, void 0), visitedObjects.has(p.customErrorResponses) || (p.customErrorResponses, void 0), visitedObjects.has(p.customOrigin) || (p.customOrigin, void 0), visitedObjects.has(p.logging) || (p.logging, void 0), visitedObjects.has(p.originGroups) || (p.originGroups, void 0), visitedObjects.has(p.origins) || (p.origins, void 0), visitedObjects.has(p.restrictions) || (p.restrictions, void 0), visitedObjects.has(p.s3Origin) || (p.s3Origin, void 0), visitedObjects.has(p.viewerCertificate) || (p.viewerCertificate, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnDistribution_ForwardedValuesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cookies) || (p.cookies, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnDistribution_FunctionAssociationProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnDistribution_GeoRestrictionProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnDistribution_LambdaFunctionAssociationProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnDistribution_LegacyCustomOriginProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnDistribution_LegacyS3OriginProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnDistribution_LoggingProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnDistribution_OriginProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customOriginConfig) || (p.customOriginConfig, void 0), visitedObjects.has(p.originCustomHeaders) || (p.originCustomHeaders, void 0), visitedObjects.has(p.originShield) || (p.originShield, void 0), visitedObjects.has(p.s3OriginConfig) || (p.s3OriginConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnDistribution_OriginCustomHeaderProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnDistribution_OriginGroupProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.failoverCriteria) || (p.failoverCriteria, void 0), visitedObjects.has(p.members) || (p.members, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnDistribution_OriginGroupFailoverCriteriaProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.statusCodes) || (p.statusCodes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnDistribution_OriginGroupMemberProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnDistribution_OriginGroupMembersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.items) || (p.items, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnDistribution_OriginGroupsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.items) || (p.items, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnDistribution_OriginShieldProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnDistribution_RestrictionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.geoRestriction) || (p.geoRestriction, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnDistribution_S3OriginConfigProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnDistribution_StatusCodesProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnDistribution_ViewerCertificateProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnFunctionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.functionConfig) || (p.functionConfig, void 0), visitedObjects.has(p.functionMetadata) || (p.functionMetadata, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnFunction(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnFunction_FunctionConfigProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnFunction_FunctionMetadataProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnKeyGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.keyGroupConfig) || (p.keyGroupConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnKeyGroup(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnKeyGroup_KeyGroupConfigProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnMonitoringSubscriptionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.monitoringSubscription) || (p.monitoringSubscription, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnMonitoringSubscription(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnMonitoringSubscription_MonitoringSubscriptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.realtimeMetricsSubscriptionConfig) || (p.realtimeMetricsSubscriptionConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnMonitoringSubscription_RealtimeMetricsSubscriptionConfigProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnOriginAccessControlProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.originAccessControlConfig) || (p.originAccessControlConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnOriginAccessControl(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnOriginAccessControl_OriginAccessControlConfigProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnOriginRequestPolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.originRequestPolicyConfig) || (p.originRequestPolicyConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnOriginRequestPolicy(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnOriginRequestPolicy_CookiesConfigProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnOriginRequestPolicy_HeadersConfigProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnOriginRequestPolicy_OriginRequestPolicyConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cookiesConfig) || (p.cookiesConfig, void 0), visitedObjects.has(p.headersConfig) || (p.headersConfig, void 0), visitedObjects.has(p.queryStringsConfig) || (p.queryStringsConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnOriginRequestPolicy_QueryStringsConfigProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnPublicKeyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.publicKeyConfig) || (p.publicKeyConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnPublicKey(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnPublicKey_PublicKeyConfigProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnRealtimeLogConfigProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.endPoints) || (p.endPoints, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnRealtimeLogConfig(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnRealtimeLogConfig_EndPointProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.kinesisStreamConfig) || (p.kinesisStreamConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnRealtimeLogConfig_KinesisStreamConfigProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.responseHeadersPolicyConfig) || (p.responseHeadersPolicyConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_AccessControlAllowHeadersProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_AccessControlAllowMethodsProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_AccessControlAllowOriginsProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_AccessControlExposeHeadersProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_ContentSecurityPolicyProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_ContentTypeOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_CorsConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.accessControlAllowHeaders) || (p.accessControlAllowHeaders, void 0), visitedObjects.has(p.accessControlAllowMethods) || (p.accessControlAllowMethods, void 0), visitedObjects.has(p.accessControlAllowOrigins) || (p.accessControlAllowOrigins, void 0), visitedObjects.has(p.accessControlExposeHeaders) || (p.accessControlExposeHeaders, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_CustomHeaderProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_CustomHeadersConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.items) || (p.items, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_FrameOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_ReferrerPolicyProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_RemoveHeaderProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_RemoveHeadersConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.items) || (p.items, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_ResponseHeadersPolicyConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.corsConfig) || (p.corsConfig, void 0), visitedObjects.has(p.customHeadersConfig) || (p.customHeadersConfig, void 0), visitedObjects.has(p.removeHeadersConfig) || (p.removeHeadersConfig, void 0), visitedObjects.has(p.securityHeadersConfig) || (p.securityHeadersConfig, void 0), visitedObjects.has(p.serverTimingHeadersConfig) || (p.serverTimingHeadersConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_SecurityHeadersConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.contentSecurityPolicy) || (p.contentSecurityPolicy, void 0), visitedObjects.has(p.contentTypeOptions) || (p.contentTypeOptions, void 0), visitedObjects.has(p.frameOptions) || (p.frameOptions, void 0), visitedObjects.has(p.referrerPolicy) || (p.referrerPolicy, void 0), visitedObjects.has(p.strictTransportSecurity) || (p.strictTransportSecurity, void 0), visitedObjects.has(p.xssProtection) || (p.xssProtection, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_ServerTimingHeadersConfigProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_StrictTransportSecurityProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_XSSProtectionProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnStreamingDistributionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.streamingDistributionConfig) || (p.streamingDistributionConfig, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnStreamingDistribution(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnStreamingDistribution_LoggingProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnStreamingDistribution_S3OriginProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_CfnStreamingDistribution_StreamingDistributionConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3Origin) || (p.s3Origin, void 0), visitedObjects.has(p.trustedSigners) || (p.trustedSigners, void 0), visitedObjects.has(p.logging) || (p.logging, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_CfnStreamingDistribution_TrustedSignersProperty(p) {
    }
    function aws_cdk_lib_aws_cloudfront_origins_HttpOriginProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.keepaliveTimeout) || (p.keepaliveTimeout, void 0), p.originSslProtocols != null)
            for (const o of p.originSslProtocols)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.protocolPolicy) || (p.protocolPolicy, void 0), visitedObjects.has(p.readTimeout) || (p.readTimeout, void 0), visitedObjects.has(p.connectionTimeout) || (p.connectionTimeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_origins_HttpOrigin(p) {
    }
    function aws_cdk_lib_aws_cloudfront_origins_LoadBalancerV2OriginProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.keepaliveTimeout) || (p.keepaliveTimeout, void 0), p.originSslProtocols != null)
            for (const o of p.originSslProtocols)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.protocolPolicy) || (p.protocolPolicy, void 0), visitedObjects.has(p.readTimeout) || (p.readTimeout, void 0), visitedObjects.has(p.connectionTimeout) || (p.connectionTimeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_origins_LoadBalancerV2Origin(p) {
    }
    function aws_cdk_lib_aws_cloudfront_origins_S3OriginProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.originAccessIdentity) || (p.originAccessIdentity, void 0), visitedObjects.has(p.connectionTimeout) || (p.connectionTimeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_origins_S3Origin(p) {
    }
    function aws_cdk_lib_aws_cloudfront_origins_OriginGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fallbackOrigin) || (p.fallbackOrigin, void 0), visitedObjects.has(p.primaryOrigin) || (p.primaryOrigin, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_origins_OriginGroup(p) {
    }
    function aws_cdk_lib_aws_cloudfront_origins_RestApiOriginProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.keepaliveTimeout) || (p.keepaliveTimeout, void 0), visitedObjects.has(p.readTimeout) || (p.readTimeout, void 0), visitedObjects.has(p.connectionTimeout) || (p.connectionTimeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudfront_origins_RestApiOrigin(p) {
    }
    function aws_cdk_lib_aws_cloudtrail_TrailProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.bucket) || (p.bucket, void 0), visitedObjects.has(p.cloudWatchLogGroup) || (p.cloudWatchLogGroup, void 0), visitedObjects.has(p.cloudWatchLogsRetention) || (p.cloudWatchLogsRetention, void 0), visitedObjects.has(p.encryptionKey) || (p.encryptionKey, void 0), p.insightTypes != null)
            for (const o of p.insightTypes)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.managementEvents) || (p.managementEvents, void 0), visitedObjects.has(p.snsTopic) || (p.snsTopic, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudtrail_ReadWriteType(p) {
    }
    function aws_cdk_lib_aws_cloudtrail_InsightType(p) {
    }
    function aws_cdk_lib_aws_cloudtrail_Trail(p) {
    }
    function aws_cdk_lib_aws_cloudtrail_AddEventSelectorOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.excludeManagementEventSources != null)
            for (const o of p.excludeManagementEventSources)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.readWriteType) || (p.readWriteType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudtrail_ManagementEventSources(p) {
    }
    function aws_cdk_lib_aws_cloudtrail_S3EventSelector(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bucket) || (p.bucket, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudtrail_DataResourceType(p) {
    }
    function aws_cdk_lib_aws_cloudtrail_CfnChannelProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.destinations) || (p.destinations, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudtrail_CfnChannel(p) {
    }
    function aws_cdk_lib_aws_cloudtrail_CfnChannel_DestinationProperty(p) {
    }
    function aws_cdk_lib_aws_cloudtrail_CfnEventDataStoreProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.advancedEventSelectors) || (p.advancedEventSelectors, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudtrail_CfnEventDataStore(p) {
    }
    function aws_cdk_lib_aws_cloudtrail_CfnEventDataStore_AdvancedEventSelectorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldSelectors) || (p.fieldSelectors, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudtrail_CfnEventDataStore_AdvancedFieldSelectorProperty(p) {
    }
    function aws_cdk_lib_aws_cloudtrail_CfnResourcePolicyProps(p) {
    }
    function aws_cdk_lib_aws_cloudtrail_CfnResourcePolicy(p) {
    }
    function aws_cdk_lib_aws_cloudtrail_CfnTrailProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.eventSelectors) || (p.eventSelectors, void 0), visitedObjects.has(p.insightSelectors) || (p.insightSelectors, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudtrail_CfnTrail(p) {
    }
    function aws_cdk_lib_aws_cloudtrail_CfnTrail_DataResourceProperty(p) {
    }
    function aws_cdk_lib_aws_cloudtrail_CfnTrail_EventSelectorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataResources) || (p.dataResources, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudtrail_CfnTrail_InsightSelectorProperty(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_AlarmProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.metric) || (p.metric, void 0), visitedObjects.has(p.comparisonOperator) || (p.comparisonOperator, void 0), visitedObjects.has(p.treatMissingData) || (p.treatMissingData, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_ComparisonOperator(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_TreatMissingData(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_Alarm(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_IAlarmAction(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_AlarmActionConfig(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_IAlarmRule(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_IAlarm(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_AlarmBase(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_AlarmState(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_AlarmRule(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_CompositeAlarmProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.alarmRule) || (p.alarmRule, void 0), visitedObjects.has(p.actionsSuppressor) || (p.actionsSuppressor, void 0), visitedObjects.has(p.actionsSuppressorExtensionPeriod) || (p.actionsSuppressorExtensionPeriod, void 0), visitedObjects.has(p.actionsSuppressorWaitPeriod) || (p.actionsSuppressorWaitPeriod, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_CompositeAlarm(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_PeriodOverride(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_DashboardProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultInterval) || (p.defaultInterval, void 0), visitedObjects.has(p.periodOverride) || (p.periodOverride, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_Dashboard(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_MetricWidgetProps(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_YAxisProps(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_AlarmWidgetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.alarm) || (p.alarm, void 0), visitedObjects.has(p.leftYAxis) || (p.leftYAxis, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_AlarmWidget(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_GraphWidgetView(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_GaugeWidgetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.annotations != null)
            for (const o of p.annotations)
              visitedObjects.has(o) || aws_cdk_lib_aws_cloudwatch_HorizontalAnnotation(o);
          if (visitedObjects.has(p.leftYAxis) || (p.leftYAxis, void 0), visitedObjects.has(p.legendPosition) || (p.legendPosition, void 0), p.metrics != null)
            for (const o of p.metrics)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.period) || (p.period, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_GaugeWidget(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_GraphWidgetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.left != null)
            for (const o of p.left)
              visitedObjects.has(o) || void 0;
          if (p.leftAnnotations != null)
            for (const o of p.leftAnnotations)
              visitedObjects.has(o) || aws_cdk_lib_aws_cloudwatch_HorizontalAnnotation(o);
          if (visitedObjects.has(p.leftYAxis) || (p.leftYAxis, void 0), visitedObjects.has(p.legendPosition) || (p.legendPosition, void 0), visitedObjects.has(p.period) || (p.period, void 0), p.right != null)
            for (const o of p.right)
              visitedObjects.has(o) || void 0;
          if (p.rightAnnotations != null)
            for (const o of p.rightAnnotations)
              visitedObjects.has(o) || aws_cdk_lib_aws_cloudwatch_HorizontalAnnotation(o);
          visitedObjects.has(p.rightYAxis) || (p.rightYAxis, void 0), visitedObjects.has(p.view) || (p.view, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_GraphWidget(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_SingleValueWidgetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.metrics != null)
            for (const o of p.metrics)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_SingleValueWidget(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_CustomWidgetProps(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_CustomWidget(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_HorizontalAnnotation(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fill) || (p.fill, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_Shading(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_Color(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_LegendPosition(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_Row(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_Column(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_SpacerProps(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_Spacer(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_CommonMetricOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.period) || (p.period, void 0), visitedObjects.has(p.unit) || (p.unit, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_MetricProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.period) || (p.period, void 0), visitedObjects.has(p.unit) || (p.unit, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_MetricOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.period) || (p.period, void 0), visitedObjects.has(p.unit) || (p.unit, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_MathExpressionOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.period) || (p.period, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_MathExpressionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.usingMetrics != null)
            for (const o of Object.values(p.usingMetrics))
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.period) || (p.period, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_Metric(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_MathExpression(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_CreateAlarmOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.comparisonOperator) || (p.comparisonOperator, void 0), visitedObjects.has(p.treatMissingData) || (p.treatMissingData, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_IMetric(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_Dimension(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_Statistic(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          print("aws-cdk-lib.aws_cloudwatch.Statistic", "Use one of the factory methods on `Stats` to produce statistics strings");
          const ns = require_metric_types();
          if (Object.values(ns.Statistic).filter((x) => x === p).length > 1)
            return;
          p === ns.Statistic.SAMPLE_COUNT && print("aws-cdk-lib.aws_cloudwatch.Statistic#SAMPLE_COUNT", ""), p === ns.Statistic.AVERAGE && print("aws-cdk-lib.aws_cloudwatch.Statistic#AVERAGE", ""), p === ns.Statistic.SUM && print("aws-cdk-lib.aws_cloudwatch.Statistic#SUM", ""), p === ns.Statistic.MINIMUM && print("aws-cdk-lib.aws_cloudwatch.Statistic#MINIMUM", ""), p === ns.Statistic.MAXIMUM && print("aws-cdk-lib.aws_cloudwatch.Statistic#MAXIMUM", "");
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_Unit(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_MetricConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.mathExpression) || aws_cdk_lib_aws_cloudwatch_MetricExpressionConfig(p.mathExpression), visitedObjects.has(p.metricStat) || aws_cdk_lib_aws_cloudwatch_MetricStatConfig(p.metricStat);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_MetricStatConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.period) || (p.period, void 0), p.dimensions != null)
            for (const o of p.dimensions)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.unitFilter) || (p.unitFilter, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_MetricExpressionConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.usingMetrics != null)
            for (const o of Object.values(p.usingMetrics))
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_LogQueryVisualizationType(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_LogQueryWidgetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.view) || (p.view, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_LogQueryWidget(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_TextWidgetBackground(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_TextWidgetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.background) || (p.background, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_TextWidget(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_IWidget(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_ConcreteWidget(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_AlarmStatusWidgetSortBy(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_AlarmStatusWidgetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.alarms != null)
            for (const o of p.alarms)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.sortBy) || (p.sortBy, void 0), p.states != null)
            for (const o of p.states)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_AlarmStatusWidget(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_Stats(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_CfnAlarmProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dimensions) || (p.dimensions, void 0), visitedObjects.has(p.metrics) || (p.metrics, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_CfnAlarm(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_CfnAlarm_DimensionProperty(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_CfnAlarm_MetricProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dimensions) || (p.dimensions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_CfnAlarm_MetricDataQueryProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.metricStat) || (p.metricStat, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_CfnAlarm_MetricStatProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.metric) || (p.metric, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_CfnAnomalyDetectorProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.configuration) || (p.configuration, void 0), visitedObjects.has(p.dimensions) || (p.dimensions, void 0), visitedObjects.has(p.metricMathAnomalyDetector) || (p.metricMathAnomalyDetector, void 0), visitedObjects.has(p.singleMetricAnomalyDetector) || (p.singleMetricAnomalyDetector, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_CfnAnomalyDetector(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_CfnAnomalyDetector_ConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.excludedTimeRanges) || (p.excludedTimeRanges, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_CfnAnomalyDetector_DimensionProperty(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_CfnAnomalyDetector_MetricProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dimensions) || (p.dimensions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_CfnAnomalyDetector_MetricDataQueryProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.metricStat) || (p.metricStat, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_CfnAnomalyDetector_MetricMathAnomalyDetectorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.metricDataQueries) || (p.metricDataQueries, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_CfnAnomalyDetector_MetricStatProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.metric) || (p.metric, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_CfnAnomalyDetector_RangeProperty(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_CfnAnomalyDetector_SingleMetricAnomalyDetectorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dimensions) || (p.dimensions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_CfnCompositeAlarmProps(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_CfnCompositeAlarm(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_CfnDashboardProps(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_CfnDashboard(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_CfnInsightRuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tags) || (p.tags, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_CfnInsightRule(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_CfnMetricStreamProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.excludeFilters) || (p.excludeFilters, void 0), visitedObjects.has(p.includeFilters) || (p.includeFilters, void 0), visitedObjects.has(p.statisticsConfigurations) || (p.statisticsConfigurations, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_CfnMetricStream(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_CfnMetricStream_MetricStreamFilterProperty(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_CfnMetricStream_MetricStreamStatisticsConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.includeMetrics) || (p.includeMetrics, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cloudwatch_CfnMetricStream_MetricStreamStatisticsMetricProperty(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_actions_ApplicationScalingAction(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_actions_AutoScalingAction(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_actions_SnsAction(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_actions_Ec2InstanceAction(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_actions_Ec2Action(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_actions_OpsItemSeverity(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_actions_OpsItemCategory(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_actions_SsmAction(p) {
    }
    function aws_cdk_lib_aws_cloudwatch_actions_SsmIncidentAction(p) {
    }
    function aws_cdk_lib_aws_codeartifact_CfnDomainProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codeartifact_CfnDomain(p) {
    }
    function aws_cdk_lib_aws_codeartifact_CfnRepositoryProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codeartifact_CfnRepository(p) {
    }
    function aws_cdk_lib_aws_codebuild_StateChangeEvent(p) {
    }
    function aws_cdk_lib_aws_codebuild_PhaseChangeEvent(p) {
    }
    function aws_cdk_lib_aws_codebuild_PipelineProjectProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.buildSpec) || (p.buildSpec, void 0), visitedObjects.has(p.cache) || (p.cache, void 0), visitedObjects.has(p.encryptionKey) || (p.encryptionKey, void 0), visitedObjects.has(p.environment) || aws_cdk_lib_aws_codebuild_BuildEnvironment(p.environment), p.environmentVariables != null)
            for (const o of Object.values(p.environmentVariables))
              visitedObjects.has(o) || aws_cdk_lib_aws_codebuild_BuildEnvironmentVariable(o);
          if (p.fileSystemLocations != null)
            for (const o of p.fileSystemLocations)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.logging) || aws_cdk_lib_aws_codebuild_LoggingOptions(p.logging), visitedObjects.has(p.queuedTimeout) || (p.queuedTimeout, void 0), visitedObjects.has(p.role) || (p.role, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.subnetSelection) || aws_cdk_lib_aws_ec2_SubnetSelection(p.subnetSelection), visitedObjects.has(p.timeout) || (p.timeout, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_PipelineProject(p) {
    }
    function aws_cdk_lib_aws_codebuild_BatchBuildConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_BuildEnvironmentCertificate(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bucket) || (p.bucket, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_ProjectNotifyOnOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.events != null)
            for (const o of p.events)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.detailType) || (p.detailType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_IProject(p) {
    }
    function aws_cdk_lib_aws_codebuild_CommonProjectProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.buildSpec) || (p.buildSpec, void 0), visitedObjects.has(p.cache) || (p.cache, void 0), visitedObjects.has(p.encryptionKey) || (p.encryptionKey, void 0), visitedObjects.has(p.environment) || aws_cdk_lib_aws_codebuild_BuildEnvironment(p.environment), p.environmentVariables != null)
            for (const o of Object.values(p.environmentVariables))
              visitedObjects.has(o) || aws_cdk_lib_aws_codebuild_BuildEnvironmentVariable(o);
          if (p.fileSystemLocations != null)
            for (const o of p.fileSystemLocations)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.logging) || aws_cdk_lib_aws_codebuild_LoggingOptions(p.logging), visitedObjects.has(p.queuedTimeout) || (p.queuedTimeout, void 0), visitedObjects.has(p.role) || (p.role, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.subnetSelection) || aws_cdk_lib_aws_ec2_SubnetSelection(p.subnetSelection), visitedObjects.has(p.timeout) || (p.timeout, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_ProjectProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.artifacts) || (p.artifacts, void 0), p.secondaryArtifacts != null)
            for (const o of p.secondaryArtifacts)
              visitedObjects.has(o) || void 0;
          if (p.secondarySources != null)
            for (const o of p.secondarySources)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.source) || (p.source, void 0), visitedObjects.has(p.buildSpec) || (p.buildSpec, void 0), visitedObjects.has(p.cache) || (p.cache, void 0), visitedObjects.has(p.encryptionKey) || (p.encryptionKey, void 0), visitedObjects.has(p.environment) || aws_cdk_lib_aws_codebuild_BuildEnvironment(p.environment), p.environmentVariables != null)
            for (const o of Object.values(p.environmentVariables))
              visitedObjects.has(o) || aws_cdk_lib_aws_codebuild_BuildEnvironmentVariable(o);
          if (p.fileSystemLocations != null)
            for (const o of p.fileSystemLocations)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.logging) || aws_cdk_lib_aws_codebuild_LoggingOptions(p.logging), visitedObjects.has(p.queuedTimeout) || (p.queuedTimeout, void 0), visitedObjects.has(p.role) || (p.role, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.subnetSelection) || aws_cdk_lib_aws_ec2_SubnetSelection(p.subnetSelection), visitedObjects.has(p.timeout) || (p.timeout, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_BindToCodePipelineOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.artifactBucket) || (p.artifactBucket, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_Project(p) {
    }
    function aws_cdk_lib_aws_codebuild_ComputeType(p) {
    }
    function aws_cdk_lib_aws_codebuild_ImagePullPrincipalType(p) {
    }
    function aws_cdk_lib_aws_codebuild_BuildEnvironment(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.buildImage) || (p.buildImage, void 0), visitedObjects.has(p.certificate) || aws_cdk_lib_aws_codebuild_BuildEnvironmentCertificate(p.certificate), visitedObjects.has(p.computeType) || (p.computeType, void 0), p.environmentVariables != null)
            for (const o of Object.values(p.environmentVariables))
              visitedObjects.has(o) || aws_cdk_lib_aws_codebuild_BuildEnvironmentVariable(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_IBuildImage(p) {
    }
    function aws_cdk_lib_aws_codebuild_BuildImageBindOptions(p) {
    }
    function aws_cdk_lib_aws_codebuild_BuildImageConfig(p) {
    }
    function aws_cdk_lib_aws_codebuild_IBindableBuildImage(p) {
    }
    function aws_cdk_lib_aws_codebuild_DockerImageOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.secretsManagerCredentials) || (p.secretsManagerCredentials, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_LinuxBuildImage(p) {
    }
    function aws_cdk_lib_aws_codebuild_WindowsImageType(p) {
    }
    function aws_cdk_lib_aws_codebuild_WindowsBuildImage(p) {
    }
    function aws_cdk_lib_aws_codebuild_BuildEnvironmentVariable(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.type) || (p.type, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_BuildEnvironmentVariableType(p) {
    }
    function aws_cdk_lib_aws_codebuild_ProjectNotificationEvents(p) {
    }
    function aws_cdk_lib_aws_codebuild_S3LoggingOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bucket) || (p.bucket, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_CloudWatchLoggingOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.logGroup) || (p.logGroup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_LoggingOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cloudWatch) || aws_cdk_lib_aws_codebuild_CloudWatchLoggingOptions(p.cloudWatch), visitedObjects.has(p.s3) || aws_cdk_lib_aws_codebuild_S3LoggingOptions(p.s3);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_IReportGroup(p) {
    }
    function aws_cdk_lib_aws_codebuild_ReportGroupType(p) {
    }
    function aws_cdk_lib_aws_codebuild_ReportGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.exportBucket) || (p.exportBucket, void 0), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), visitedObjects.has(p.type) || (p.type, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_ReportGroup(p) {
    }
    function aws_cdk_lib_aws_codebuild_SourceConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sourceProperty) || aws_cdk_lib_aws_codebuild_CfnProject_SourceProperty(p.sourceProperty), visitedObjects.has(p.buildTriggers) || aws_cdk_lib_aws_codebuild_CfnProject_ProjectTriggersProperty(p.buildTriggers);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_ISource(p) {
    }
    function aws_cdk_lib_aws_codebuild_SourceProps(p) {
    }
    function aws_cdk_lib_aws_codebuild_Source(p) {
    }
    function aws_cdk_lib_aws_codebuild_EventAction(p) {
    }
    function aws_cdk_lib_aws_codebuild_FilterGroup(p) {
    }
    function aws_cdk_lib_aws_codebuild_CodeCommitSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.repository) || (p.repository, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_S3SourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bucket) || (p.bucket, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_GitHubSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.webhookFilters != null)
            for (const o of p.webhookFilters)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_GitHubEnterpriseSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.webhookFilters != null)
            for (const o of p.webhookFilters)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_BitBucketSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.webhookFilters != null)
            for (const o of p.webhookFilters)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_GitHubSourceCredentialsProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.accessToken) || (p.accessToken, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_GitHubSourceCredentials(p) {
    }
    function aws_cdk_lib_aws_codebuild_GitHubEnterpriseSourceCredentialsProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.accessToken) || (p.accessToken, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_GitHubEnterpriseSourceCredentials(p) {
    }
    function aws_cdk_lib_aws_codebuild_BitBucketSourceCredentialsProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.password) || (p.password, void 0), visitedObjects.has(p.username) || (p.username, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_BitBucketSourceCredentials(p) {
    }
    function aws_cdk_lib_aws_codebuild_ArtifactsConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.artifactsProperty) || (p.artifactsProperty, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_IArtifacts(p) {
    }
    function aws_cdk_lib_aws_codebuild_ArtifactsProps(p) {
    }
    function aws_cdk_lib_aws_codebuild_Artifacts(p) {
    }
    function aws_cdk_lib_aws_codebuild_S3ArtifactsProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bucket) || (p.bucket, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_BucketCacheOptions(p) {
    }
    function aws_cdk_lib_aws_codebuild_LocalCacheMode(p) {
    }
    function aws_cdk_lib_aws_codebuild_Cache(p) {
    }
    function aws_cdk_lib_aws_codebuild_BuildSpec(p) {
    }
    function aws_cdk_lib_aws_codebuild_FileSystemConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.location) || (p.location, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_IFileSystemLocation(p) {
    }
    function aws_cdk_lib_aws_codebuild_FileSystemLocation(p) {
    }
    function aws_cdk_lib_aws_codebuild_EfsFileSystemLocationProps(p) {
    }
    function aws_cdk_lib_aws_codebuild_LinuxGpuBuildImage(p) {
    }
    function aws_cdk_lib_aws_codebuild_UntrustedCodeBoundaryPolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.additionalStatements != null)
            for (const o of p.additionalStatements)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_UntrustedCodeBoundaryPolicy(p) {
    }
    function aws_cdk_lib_aws_codebuild_LinuxArmBuildImage(p) {
    }
    function aws_cdk_lib_aws_codebuild_CfnProjectProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.artifacts) || (p.artifacts, void 0), visitedObjects.has(p.environment) || (p.environment, void 0), visitedObjects.has(p.source) || (p.source, void 0), visitedObjects.has(p.buildBatchConfig) || (p.buildBatchConfig, void 0), visitedObjects.has(p.cache) || (p.cache, void 0), visitedObjects.has(p.fileSystemLocations) || (p.fileSystemLocations, void 0), visitedObjects.has(p.logsConfig) || (p.logsConfig, void 0), visitedObjects.has(p.secondaryArtifacts) || (p.secondaryArtifacts, void 0), visitedObjects.has(p.secondarySources) || (p.secondarySources, void 0), visitedObjects.has(p.secondarySourceVersions) || (p.secondarySourceVersions, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.triggers) || (p.triggers, void 0), visitedObjects.has(p.vpcConfig) || (p.vpcConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_CfnProject(p) {
    }
    function aws_cdk_lib_aws_codebuild_CfnProject_ArtifactsProperty(p) {
    }
    function aws_cdk_lib_aws_codebuild_CfnProject_BatchRestrictionsProperty(p) {
    }
    function aws_cdk_lib_aws_codebuild_CfnProject_BuildStatusConfigProperty(p) {
    }
    function aws_cdk_lib_aws_codebuild_CfnProject_CloudWatchLogsConfigProperty(p) {
    }
    function aws_cdk_lib_aws_codebuild_CfnProject_EnvironmentProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.environmentVariables) || (p.environmentVariables, void 0), visitedObjects.has(p.registryCredential) || (p.registryCredential, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_CfnProject_EnvironmentVariableProperty(p) {
    }
    function aws_cdk_lib_aws_codebuild_CfnProject_GitSubmodulesConfigProperty(p) {
    }
    function aws_cdk_lib_aws_codebuild_CfnProject_LogsConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cloudWatchLogs) || (p.cloudWatchLogs, void 0), visitedObjects.has(p.s3Logs) || (p.s3Logs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_CfnProject_ProjectBuildBatchConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.restrictions) || (p.restrictions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_CfnProject_ProjectCacheProperty(p) {
    }
    function aws_cdk_lib_aws_codebuild_CfnProject_ProjectFileSystemLocationProperty(p) {
    }
    function aws_cdk_lib_aws_codebuild_CfnProject_ProjectSourceVersionProperty(p) {
    }
    function aws_cdk_lib_aws_codebuild_CfnProject_ProjectTriggersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.filterGroups) || (p.filterGroups, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_CfnProject_RegistryCredentialProperty(p) {
    }
    function aws_cdk_lib_aws_codebuild_CfnProject_S3LogsConfigProperty(p) {
    }
    function aws_cdk_lib_aws_codebuild_CfnProject_SourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.auth) || (p.auth, void 0), visitedObjects.has(p.buildStatusConfig) || (p.buildStatusConfig, void 0), visitedObjects.has(p.gitSubmodulesConfig) || (p.gitSubmodulesConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_CfnProject_SourceAuthProperty(p) {
    }
    function aws_cdk_lib_aws_codebuild_CfnProject_VpcConfigProperty(p) {
    }
    function aws_cdk_lib_aws_codebuild_CfnProject_WebhookFilterProperty(p) {
    }
    function aws_cdk_lib_aws_codebuild_CfnReportGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.exportConfig) || (p.exportConfig, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_CfnReportGroup(p) {
    }
    function aws_cdk_lib_aws_codebuild_CfnReportGroup_ReportExportConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3Destination) || (p.s3Destination, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codebuild_CfnReportGroup_S3ReportExportConfigProperty(p) {
    }
    function aws_cdk_lib_aws_codebuild_CfnSourceCredentialProps(p) {
    }
    function aws_cdk_lib_aws_codebuild_CfnSourceCredential(p) {
    }
    function aws_cdk_lib_aws_codecommit_ReferenceEvent(p) {
    }
    function aws_cdk_lib_aws_codecommit_RepositoryNotifyOnOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.events != null)
            for (const o of p.events)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.detailType) || (p.detailType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codecommit_IRepository(p) {
    }
    function aws_cdk_lib_aws_codecommit_OnCommitOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.target) || (p.target, void 0), visitedObjects.has(p.eventPattern) || (p.eventPattern, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codecommit_RepositoryProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.code) || (p.code, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codecommit_Repository(p) {
    }
    function aws_cdk_lib_aws_codecommit_RepositoryTriggerOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.events != null)
            for (const o of p.events)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codecommit_RepositoryEventTrigger(p) {
    }
    function aws_cdk_lib_aws_codecommit_RepositoryNotificationEvents(p) {
    }
    function aws_cdk_lib_aws_codecommit_CodeConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.code) || aws_cdk_lib_aws_codecommit_CfnRepository_CodeProperty(p.code);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codecommit_Code(p) {
    }
    function aws_cdk_lib_aws_codecommit_CfnRepositoryProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.code) || (p.code, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.triggers) || (p.triggers, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codecommit_CfnRepository(p) {
    }
    function aws_cdk_lib_aws_codecommit_CfnRepository_CodeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3) || (p.s3, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codecommit_CfnRepository_RepositoryTriggerProperty(p) {
    }
    function aws_cdk_lib_aws_codecommit_CfnRepository_S3Property(p) {
    }
    function aws_cdk_lib_aws_codedeploy_IBaseDeploymentConfig(p) {
    }
    function aws_cdk_lib_aws_codedeploy_BaseDeploymentConfigOptions(p) {
    }
    function aws_cdk_lib_aws_codedeploy_ComputePlatform(p) {
    }
    function aws_cdk_lib_aws_codedeploy_BaseDeploymentConfigProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.computePlatform) || (p.computePlatform, void 0), visitedObjects.has(p.minimumHealthyHosts) || (p.minimumHealthyHosts, void 0), visitedObjects.has(p.trafficRouting) || (p.trafficRouting, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codedeploy_BaseDeploymentConfig(p) {
    }
    function aws_cdk_lib_aws_codedeploy_MinimumHealthyHosts(p) {
    }
    function aws_cdk_lib_aws_codedeploy_AutoRollbackConfig(p) {
    }
    function aws_cdk_lib_aws_codedeploy_TrafficRoutingConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.timeBasedCanary) || (p.timeBasedCanary, void 0), visitedObjects.has(p.timeBasedLinear) || (p.timeBasedLinear, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codedeploy_CanaryTrafficRoutingConfig(p) {
    }
    function aws_cdk_lib_aws_codedeploy_LinearTrafficRoutingConfig(p) {
    }
    function aws_cdk_lib_aws_codedeploy_TrafficRouting(p) {
    }
    function aws_cdk_lib_aws_codedeploy_BaseTrafficShiftingConfigProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.interval) || (p.interval, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codedeploy_AllAtOnceTrafficRouting(p) {
    }
    function aws_cdk_lib_aws_codedeploy_TimeBasedCanaryTrafficRoutingProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.interval) || (p.interval, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codedeploy_TimeBasedCanaryTrafficRouting(p) {
    }
    function aws_cdk_lib_aws_codedeploy_TimeBasedLinearTrafficRoutingProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.interval) || (p.interval, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codedeploy_TimeBasedLinearTrafficRouting(p) {
    }
    function aws_cdk_lib_aws_codedeploy_IEcsApplication(p) {
    }
    function aws_cdk_lib_aws_codedeploy_EcsApplicationProps(p) {
    }
    function aws_cdk_lib_aws_codedeploy_EcsApplication(p) {
    }
    function aws_cdk_lib_aws_codedeploy_IEcsDeploymentConfig(p) {
    }
    function aws_cdk_lib_aws_codedeploy_EcsDeploymentConfigProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.trafficRouting) || (p.trafficRouting, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codedeploy_EcsDeploymentConfig(p) {
    }
    function aws_cdk_lib_aws_codedeploy_IEcsDeploymentGroup(p) {
    }
    function aws_cdk_lib_aws_codedeploy_EcsBlueGreenDeploymentConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.blueTargetGroup) || (p.blueTargetGroup, void 0), visitedObjects.has(p.greenTargetGroup) || (p.greenTargetGroup, void 0), visitedObjects.has(p.listener) || (p.listener, void 0), visitedObjects.has(p.deploymentApprovalWaitTime) || (p.deploymentApprovalWaitTime, void 0), visitedObjects.has(p.terminationWaitTime) || (p.terminationWaitTime, void 0), visitedObjects.has(p.testListener) || (p.testListener, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codedeploy_EcsDeploymentGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.blueGreenDeploymentConfig) || aws_cdk_lib_aws_codedeploy_EcsBlueGreenDeploymentConfig(p.blueGreenDeploymentConfig), visitedObjects.has(p.service) || (p.service, void 0), p.alarms != null)
            for (const o of p.alarms)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.application) || (p.application, void 0), visitedObjects.has(p.autoRollback) || (p.autoRollback, void 0), visitedObjects.has(p.deploymentConfig) || (p.deploymentConfig, void 0), visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codedeploy_EcsDeploymentGroup(p) {
    }
    function aws_cdk_lib_aws_codedeploy_EcsDeploymentGroupAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.application) || (p.application, void 0), visitedObjects.has(p.deploymentConfig) || (p.deploymentConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codedeploy_ILambdaApplication(p) {
    }
    function aws_cdk_lib_aws_codedeploy_LambdaApplicationProps(p) {
    }
    function aws_cdk_lib_aws_codedeploy_LambdaApplication(p) {
    }
    function aws_cdk_lib_aws_codedeploy_CustomLambdaDeploymentConfigType(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          print("aws-cdk-lib.aws_codedeploy.CustomLambdaDeploymentConfigType", "Use `LambdaDeploymentConfig`");
          const ns = require_custom_deployment_config();
          if (Object.values(ns.CustomLambdaDeploymentConfigType).filter((x) => x === p).length > 1)
            return;
          p === ns.CustomLambdaDeploymentConfigType.CANARY && print("aws-cdk-lib.aws_codedeploy.CustomLambdaDeploymentConfigType#CANARY", "Use `LambdaDeploymentConfig`"), p === ns.CustomLambdaDeploymentConfigType.LINEAR && print("aws-cdk-lib.aws_codedeploy.CustomLambdaDeploymentConfigType#LINEAR", "Use `LambdaDeploymentConfig`");
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codedeploy_CustomLambdaDeploymentConfigProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          "interval" in p && print("aws-cdk-lib.aws_codedeploy.CustomLambdaDeploymentConfigProps#interval", "Use `LambdaDeploymentConfig`"), visitedObjects.has(p.interval) || (p.interval, void 0), "percentage" in p && print("aws-cdk-lib.aws_codedeploy.CustomLambdaDeploymentConfigProps#percentage", "Use `LambdaDeploymentConfig`"), "type" in p && print("aws-cdk-lib.aws_codedeploy.CustomLambdaDeploymentConfigProps#type", "Use `LambdaDeploymentConfig`"), visitedObjects.has(p.type) || aws_cdk_lib_aws_codedeploy_CustomLambdaDeploymentConfigType(p.type), "deploymentConfigName" in p && print("aws-cdk-lib.aws_codedeploy.CustomLambdaDeploymentConfigProps#deploymentConfigName", "Use `LambdaDeploymentConfig`");
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codedeploy_CustomLambdaDeploymentConfig(p) {
    }
    function aws_cdk_lib_aws_codedeploy_ILambdaDeploymentConfig(p) {
    }
    function aws_cdk_lib_aws_codedeploy_LambdaDeploymentConfigImportProps(p) {
    }
    function aws_cdk_lib_aws_codedeploy_LambdaDeploymentConfigProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.trafficRouting) || (p.trafficRouting, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codedeploy_LambdaDeploymentConfig(p) {
    }
    function aws_cdk_lib_aws_codedeploy_ILambdaDeploymentGroup(p) {
    }
    function aws_cdk_lib_aws_codedeploy_LambdaDeploymentGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.alias) || (p.alias, void 0), p.alarms != null)
            for (const o of p.alarms)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.application) || (p.application, void 0), visitedObjects.has(p.autoRollback) || (p.autoRollback, void 0), visitedObjects.has(p.deploymentConfig) || (p.deploymentConfig, void 0), visitedObjects.has(p.postHook) || (p.postHook, void 0), visitedObjects.has(p.preHook) || (p.preHook, void 0), visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codedeploy_LambdaDeploymentGroup(p) {
    }
    function aws_cdk_lib_aws_codedeploy_LambdaDeploymentGroupAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.application) || (p.application, void 0), visitedObjects.has(p.deploymentConfig) || (p.deploymentConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codedeploy_IServerApplication(p) {
    }
    function aws_cdk_lib_aws_codedeploy_ServerApplicationProps(p) {
    }
    function aws_cdk_lib_aws_codedeploy_ServerApplication(p) {
    }
    function aws_cdk_lib_aws_codedeploy_IServerDeploymentConfig(p) {
    }
    function aws_cdk_lib_aws_codedeploy_ServerDeploymentConfigProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.minimumHealthyHosts) || (p.minimumHealthyHosts, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codedeploy_ServerDeploymentConfig(p) {
    }
    function aws_cdk_lib_aws_codedeploy_IServerDeploymentGroup(p) {
    }
    function aws_cdk_lib_aws_codedeploy_ServerDeploymentGroupAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.application) || (p.application, void 0), visitedObjects.has(p.deploymentConfig) || (p.deploymentConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codedeploy_InstanceTagSet(p) {
    }
    function aws_cdk_lib_aws_codedeploy_ServerDeploymentGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.alarms != null)
            for (const o of p.alarms)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.application) || (p.application, void 0), visitedObjects.has(p.autoRollback) || (p.autoRollback, void 0), p.autoScalingGroups != null)
            for (const o of p.autoScalingGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.deploymentConfig) || (p.deploymentConfig, void 0), visitedObjects.has(p.ec2InstanceTags) || (p.ec2InstanceTags, void 0), visitedObjects.has(p.loadBalancer) || (p.loadBalancer, void 0), visitedObjects.has(p.onPremiseInstanceTags) || (p.onPremiseInstanceTags, void 0), visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codedeploy_ServerDeploymentGroup(p) {
    }
    function aws_cdk_lib_aws_codedeploy_LoadBalancerGeneration(p) {
    }
    function aws_cdk_lib_aws_codedeploy_LoadBalancer(p) {
    }
    function aws_cdk_lib_aws_codedeploy_CfnApplicationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codedeploy_CfnApplication(p) {
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentConfigProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.minimumHealthyHosts) || (p.minimumHealthyHosts, void 0), visitedObjects.has(p.trafficRoutingConfig) || (p.trafficRoutingConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentConfig(p) {
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentConfig_MinimumHealthyHostsProperty(p) {
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentConfig_TimeBasedCanaryProperty(p) {
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentConfig_TimeBasedLinearProperty(p) {
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentConfig_TrafficRoutingConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.timeBasedCanary) || (p.timeBasedCanary, void 0), visitedObjects.has(p.timeBasedLinear) || (p.timeBasedLinear, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.alarmConfiguration) || (p.alarmConfiguration, void 0), visitedObjects.has(p.autoRollbackConfiguration) || (p.autoRollbackConfiguration, void 0), visitedObjects.has(p.blueGreenDeploymentConfiguration) || (p.blueGreenDeploymentConfiguration, void 0), visitedObjects.has(p.deployment) || (p.deployment, void 0), visitedObjects.has(p.deploymentStyle) || (p.deploymentStyle, void 0), visitedObjects.has(p.ec2TagFilters) || (p.ec2TagFilters, void 0), visitedObjects.has(p.ec2TagSet) || (p.ec2TagSet, void 0), visitedObjects.has(p.ecsServices) || (p.ecsServices, void 0), visitedObjects.has(p.loadBalancerInfo) || (p.loadBalancerInfo, void 0), visitedObjects.has(p.onPremisesInstanceTagFilters) || (p.onPremisesInstanceTagFilters, void 0), visitedObjects.has(p.onPremisesTagSet) || (p.onPremisesTagSet, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.triggerConfigurations) || (p.triggerConfigurations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup(p) {
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_AlarmProperty(p) {
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_AlarmConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.alarms) || (p.alarms, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_AutoRollbackConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_BlueGreenDeploymentConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.deploymentReadyOption) || (p.deploymentReadyOption, void 0), visitedObjects.has(p.greenFleetProvisioningOption) || (p.greenFleetProvisioningOption, void 0), visitedObjects.has(p.terminateBlueInstancesOnDeploymentSuccess) || (p.terminateBlueInstancesOnDeploymentSuccess, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_BlueInstanceTerminationOptionProperty(p) {
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_DeploymentProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.revision) || (p.revision, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_DeploymentReadyOptionProperty(p) {
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_DeploymentStyleProperty(p) {
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_EC2TagFilterProperty(p) {
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_EC2TagSetProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ec2TagSetList) || (p.ec2TagSetList, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_EC2TagSetListObjectProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ec2TagGroup) || (p.ec2TagGroup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_ECSServiceProperty(p) {
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_ELBInfoProperty(p) {
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_GitHubLocationProperty(p) {
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_GreenFleetProvisioningOptionProperty(p) {
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_LoadBalancerInfoProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.elbInfoList) || (p.elbInfoList, void 0), visitedObjects.has(p.targetGroupInfoList) || (p.targetGroupInfoList, void 0), visitedObjects.has(p.targetGroupPairInfoList) || (p.targetGroupPairInfoList, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_OnPremisesTagSetProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.onPremisesTagSetList) || (p.onPremisesTagSetList, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_OnPremisesTagSetListObjectProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.onPremisesTagGroup) || (p.onPremisesTagGroup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_RevisionLocationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.gitHubLocation) || (p.gitHubLocation, void 0), visitedObjects.has(p.s3Location) || (p.s3Location, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_S3LocationProperty(p) {
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_TagFilterProperty(p) {
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_TargetGroupInfoProperty(p) {
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_TargetGroupPairInfoProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.prodTrafficRoute) || (p.prodTrafficRoute, void 0), visitedObjects.has(p.targetGroups) || (p.targetGroups, void 0), visitedObjects.has(p.testTrafficRoute) || (p.testTrafficRoute, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_TrafficRouteProperty(p) {
    }
    function aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_TriggerConfigProperty(p) {
    }
    function aws_cdk_lib_aws_codeguruprofiler_CfnProfilingGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.anomalyDetectionNotificationConfiguration) || (p.anomalyDetectionNotificationConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codeguruprofiler_CfnProfilingGroup(p) {
    }
    function aws_cdk_lib_aws_codeguruprofiler_CfnProfilingGroup_AgentPermissionsProperty(p) {
    }
    function aws_cdk_lib_aws_codeguruprofiler_CfnProfilingGroup_ChannelProperty(p) {
    }
    function aws_cdk_lib_aws_codeguruprofiler_ComputePlatform(p) {
    }
    function aws_cdk_lib_aws_codeguruprofiler_IProfilingGroup(p) {
    }
    function aws_cdk_lib_aws_codeguruprofiler_ProfilingGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.computePlatform) || (p.computePlatform, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codeguruprofiler_ProfilingGroup(p) {
    }
    function aws_cdk_lib_aws_codegurureviewer_CfnRepositoryAssociationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codegurureviewer_CfnRepositoryAssociation(p) {
    }
    function aws_cdk_lib_aws_codepipeline_ActionCategory(p) {
    }
    function aws_cdk_lib_aws_codepipeline_ActionArtifactBounds(p) {
    }
    function aws_cdk_lib_aws_codepipeline_GlobalVariables(p) {
    }
    function aws_cdk_lib_aws_codepipeline_ActionProperties(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.artifactBounds) || (p.artifactBounds, void 0), visitedObjects.has(p.category) || (p.category, void 0), p.inputs != null)
            for (const o of p.inputs)
              visitedObjects.has(o) || void 0;
          if (p.outputs != null)
            for (const o of p.outputs)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.resource) || (p.resource, void 0), visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_ActionBindOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bucket) || (p.bucket, void 0), visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_ActionConfig(p) {
    }
    function aws_cdk_lib_aws_codepipeline_PipelineNotifyOnOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.events != null)
            for (const o of p.events)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.detailType) || (p.detailType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_IAction(p) {
    }
    function aws_cdk_lib_aws_codepipeline_IPipeline(p) {
    }
    function aws_cdk_lib_aws_codepipeline_IStage(p) {
    }
    function aws_cdk_lib_aws_codepipeline_CommonActionProps(p) {
    }
    function aws_cdk_lib_aws_codepipeline_CommonAwsActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_Action(p) {
    }
    function aws_cdk_lib_aws_codepipeline_PipelineNotificationEvents(p) {
    }
    function aws_cdk_lib_aws_codepipeline_Artifact(p) {
    }
    function aws_cdk_lib_aws_codepipeline_ArtifactPath(p) {
    }
    function aws_cdk_lib_aws_codepipeline_StagePlacement(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.justAfter) || (p.justAfter, void 0), visitedObjects.has(p.rightBefore) || (p.rightBefore, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_StageProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.actions != null)
            for (const o of p.actions)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_StageOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.placement) || aws_cdk_lib_aws_codepipeline_StagePlacement(p.placement), p.actions != null)
            for (const o of p.actions)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_PipelineProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.artifactBucket) || (p.artifactBucket, void 0), p.crossRegionReplicationBuckets != null)
            for (const o of Object.values(p.crossRegionReplicationBuckets))
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.role) || (p.role, void 0), p.stages != null)
            for (const o of p.stages)
              visitedObjects.has(o) || aws_cdk_lib_aws_codepipeline_StageProps(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_Pipeline(p) {
    }
    function aws_cdk_lib_aws_codepipeline_CrossRegionSupport(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.replicationBucket) || (p.replicationBucket, void 0), visitedObjects.has(p.stack) || (p.stack, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_CustomActionProperty(p) {
    }
    function aws_cdk_lib_aws_codepipeline_CustomActionRegistrationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.artifactBounds) || (p.artifactBounds, void 0), visitedObjects.has(p.category) || (p.category, void 0), p.actionProperties != null)
            for (const o of p.actionProperties)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_CustomActionRegistration(p) {
    }
    function aws_cdk_lib_aws_codepipeline_CfnCustomActionTypeProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.inputArtifactDetails) || (p.inputArtifactDetails, void 0), visitedObjects.has(p.outputArtifactDetails) || (p.outputArtifactDetails, void 0), visitedObjects.has(p.configurationProperties) || (p.configurationProperties, void 0), visitedObjects.has(p.settings) || (p.settings, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_CfnCustomActionType(p) {
    }
    function aws_cdk_lib_aws_codepipeline_CfnCustomActionType_ArtifactDetailsProperty(p) {
    }
    function aws_cdk_lib_aws_codepipeline_CfnCustomActionType_ConfigurationPropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_codepipeline_CfnCustomActionType_SettingsProperty(p) {
    }
    function aws_cdk_lib_aws_codepipeline_CfnPipelineProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.stages) || (p.stages, void 0), visitedObjects.has(p.artifactStore) || (p.artifactStore, void 0), visitedObjects.has(p.artifactStores) || (p.artifactStores, void 0), visitedObjects.has(p.disableInboundStageTransitions) || (p.disableInboundStageTransitions, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_CfnPipeline(p) {
    }
    function aws_cdk_lib_aws_codepipeline_CfnPipeline_ActionDeclarationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actionTypeId) || (p.actionTypeId, void 0), visitedObjects.has(p.inputArtifacts) || (p.inputArtifacts, void 0), visitedObjects.has(p.outputArtifacts) || (p.outputArtifacts, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_CfnPipeline_ActionTypeIdProperty(p) {
    }
    function aws_cdk_lib_aws_codepipeline_CfnPipeline_ArtifactStoreProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.encryptionKey) || (p.encryptionKey, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_CfnPipeline_ArtifactStoreMapProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.artifactStore) || (p.artifactStore, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_CfnPipeline_BlockerDeclarationProperty(p) {
    }
    function aws_cdk_lib_aws_codepipeline_CfnPipeline_EncryptionKeyProperty(p) {
    }
    function aws_cdk_lib_aws_codepipeline_CfnPipeline_InputArtifactProperty(p) {
    }
    function aws_cdk_lib_aws_codepipeline_CfnPipeline_OutputArtifactProperty(p) {
    }
    function aws_cdk_lib_aws_codepipeline_CfnPipeline_StageDeclarationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.blockers) || (p.blockers, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_CfnPipeline_StageTransitionProperty(p) {
    }
    function aws_cdk_lib_aws_codepipeline_CfnWebhookProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.authenticationConfiguration) || (p.authenticationConfiguration, void 0), visitedObjects.has(p.filters) || (p.filters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_CfnWebhook(p) {
    }
    function aws_cdk_lib_aws_codepipeline_CfnWebhook_WebhookAuthConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_codepipeline_CfnWebhook_WebhookFilterRuleProperty(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_AlexaSkillDeployActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.clientSecret) || (p.clientSecret, void 0), visitedObjects.has(p.input) || (p.input, void 0), visitedObjects.has(p.refreshToken) || (p.refreshToken, void 0), visitedObjects.has(p.parameterOverridesArtifact) || (p.parameterOverridesArtifact, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_actions_AlexaSkillDeployAction(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_CodeStarSourceVariables(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_CodeStarConnectionsSourceActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.output) || (p.output, void 0), visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_actions_CodeStarConnectionsSourceAction(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_CloudFormationExecuteChangeSetActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.output) || (p.output, void 0), visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_actions_CloudFormationExecuteChangeSetAction(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_CloudFormationCreateReplaceChangeSetActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.templatePath) || (p.templatePath, void 0), p.cfnCapabilities != null)
            for (const o of p.cfnCapabilities)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.deploymentRole) || (p.deploymentRole, void 0), p.extraInputs != null)
            for (const o of p.extraInputs)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.output) || (p.output, void 0), visitedObjects.has(p.templateConfiguration) || (p.templateConfiguration, void 0), visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_actions_CloudFormationCreateReplaceChangeSetAction(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_CloudFormationCreateUpdateStackActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.templatePath) || (p.templatePath, void 0), p.cfnCapabilities != null)
            for (const o of p.cfnCapabilities)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.deploymentRole) || (p.deploymentRole, void 0), p.extraInputs != null)
            for (const o of p.extraInputs)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.output) || (p.output, void 0), visitedObjects.has(p.templateConfiguration) || (p.templateConfiguration, void 0), visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_actions_CloudFormationCreateUpdateStackAction(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_CloudFormationDeleteStackActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.cfnCapabilities != null)
            for (const o of p.cfnCapabilities)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.deploymentRole) || (p.deploymentRole, void 0), p.extraInputs != null)
            for (const o of p.extraInputs)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.output) || (p.output, void 0), visitedObjects.has(p.templateConfiguration) || (p.templateConfiguration, void 0), visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_actions_CloudFormationDeleteStackAction(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_CloudFormationDeployStackSetActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.template) || (p.template, void 0), p.cfnCapabilities != null)
            for (const o of p.cfnCapabilities)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.deploymentModel) || (p.deploymentModel, void 0), visitedObjects.has(p.parameters) || (p.parameters, void 0), visitedObjects.has(p.stackInstances) || (p.stackInstances, void 0), visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_actions_CloudFormationDeployStackSetAction(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_CloudFormationDeployStackInstancesActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.stackInstances) || (p.stackInstances, void 0), visitedObjects.has(p.parameterOverrides) || (p.parameterOverrides, void 0), visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_actions_CloudFormationDeployStackInstancesAction(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_CommonCloudFormationStackSetOptions(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_StackSetTemplate(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_StackInstances(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_StackSetParameters(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_StackSetDeploymentModel(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_OrganizationsDeploymentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.autoDeployment) || (p.autoDeployment, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_actions_StackSetOrganizationsAutoDeployment(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_SelfManagedDeploymentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.administrationRole) || (p.administrationRole, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_actions_CodeBuildActionType(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_CodeBuildActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.input) || (p.input, void 0), visitedObjects.has(p.project) || (p.project, void 0), p.environmentVariables != null)
            for (const o of Object.values(p.environmentVariables))
              visitedObjects.has(o) || aws_cdk_lib_aws_codebuild_BuildEnvironmentVariable(o);
          if (p.extraInputs != null)
            for (const o of p.extraInputs)
              visitedObjects.has(o) || void 0;
          if (p.outputs != null)
            for (const o of p.outputs)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.type) || (p.type, void 0), visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_actions_CodeBuildAction(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_CodeCommitTrigger(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_CodeCommitSourceVariables(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_CodeCommitSourceActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.output) || (p.output, void 0), visitedObjects.has(p.repository) || (p.repository, void 0), visitedObjects.has(p.eventRole) || (p.eventRole, void 0), visitedObjects.has(p.trigger) || (p.trigger, void 0), visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_actions_CodeCommitSourceAction(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_CodeDeployEcsContainerImageInput(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.input) || (p.input, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_actions_CodeDeployEcsDeployActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.deploymentGroup) || (p.deploymentGroup, void 0), visitedObjects.has(p.appSpecTemplateFile) || (p.appSpecTemplateFile, void 0), visitedObjects.has(p.appSpecTemplateInput) || (p.appSpecTemplateInput, void 0), p.containerImageInputs != null)
            for (const o of p.containerImageInputs)
              visitedObjects.has(o) || aws_cdk_lib_aws_codepipeline_actions_CodeDeployEcsContainerImageInput(o);
          visitedObjects.has(p.taskDefinitionTemplateFile) || (p.taskDefinitionTemplateFile, void 0), visitedObjects.has(p.taskDefinitionTemplateInput) || (p.taskDefinitionTemplateInput, void 0), visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_actions_CodeDeployEcsDeployAction(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_CodeDeployServerDeployActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.deploymentGroup) || (p.deploymentGroup, void 0), visitedObjects.has(p.input) || (p.input, void 0), visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_actions_CodeDeployServerDeployAction(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_EcrSourceVariables(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_EcrSourceActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.output) || (p.output, void 0), visitedObjects.has(p.repository) || (p.repository, void 0), visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_actions_EcrSourceAction(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_EcsDeployActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.service) || (p.service, void 0), visitedObjects.has(p.deploymentTimeout) || (p.deploymentTimeout, void 0), visitedObjects.has(p.imageFile) || (p.imageFile, void 0), visitedObjects.has(p.input) || (p.input, void 0), visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_actions_EcsDeployAction(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_ElasticBeanstalkDeployActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.input) || (p.input, void 0), visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_actions_ElasticBeanstalkDeployAction(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_GitHubTrigger(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_GitHubSourceVariables(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_GitHubSourceActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.oauthToken) || (p.oauthToken, void 0), visitedObjects.has(p.output) || (p.output, void 0), visitedObjects.has(p.trigger) || (p.trigger, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_actions_GitHubSourceAction(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_JenkinsActionType(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_JenkinsActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.jenkinsProvider) || (p.jenkinsProvider, void 0), visitedObjects.has(p.type) || (p.type, void 0), p.inputs != null)
            for (const o of p.inputs)
              visitedObjects.has(o) || void 0;
          if (p.outputs != null)
            for (const o of p.outputs)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_actions_JenkinsAction(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_IJenkinsProvider(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_JenkinsProviderAttributes(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_JenkinsProviderProps(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_BaseJenkinsProvider(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_JenkinsProvider(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_LambdaInvokeActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.lambda) || (p.lambda, void 0), p.inputs != null)
            for (const o of p.inputs)
              visitedObjects.has(o) || void 0;
          if (p.outputs != null)
            for (const o of p.outputs)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_actions_LambdaInvokeAction(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_ManualApprovalActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.notificationTopic) || (p.notificationTopic, void 0), visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_actions_ManualApprovalAction(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_CacheControl(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_S3DeployActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.bucket) || (p.bucket, void 0), visitedObjects.has(p.input) || (p.input, void 0), visitedObjects.has(p.accessControl) || (p.accessControl, void 0), p.cacheControl != null)
            for (const o of p.cacheControl)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.encryptionKey) || (p.encryptionKey, void 0), visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_actions_S3DeployAction(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_S3Trigger(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_S3SourceVariables(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_S3SourceActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bucket) || (p.bucket, void 0), visitedObjects.has(p.output) || (p.output, void 0), visitedObjects.has(p.trigger) || (p.trigger, void 0), visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_actions_S3SourceAction(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_StateMachineInput(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_StepFunctionsInvokeActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.stateMachine) || (p.stateMachine, void 0), visitedObjects.has(p.output) || (p.output, void 0), visitedObjects.has(p.stateMachineInput) || (p.stateMachineInput, void 0), visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_actions_StepFunctionInvokeAction(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_ServiceCatalogDeployActionBeta1Props(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.templatePath) || (p.templatePath, void 0), visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codepipeline_actions_ServiceCatalogDeployActionBeta1(p) {
    }
    function aws_cdk_lib_aws_codepipeline_actions_Action(p) {
    }
    function aws_cdk_lib_aws_codestar_CfnGitHubRepositoryProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.code) || (p.code, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codestar_CfnGitHubRepository(p) {
    }
    function aws_cdk_lib_aws_codestar_CfnGitHubRepository_CodeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3) || (p.s3, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codestar_CfnGitHubRepository_S3Property(p) {
    }
    function aws_cdk_lib_aws_codestarconnections_CfnConnectionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codestarconnections_CfnConnection(p) {
    }
    function aws_cdk_lib_aws_codestarnotifications_CfnNotificationRuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.targets) || (p.targets, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codestarnotifications_CfnNotificationRule(p) {
    }
    function aws_cdk_lib_aws_codestarnotifications_CfnNotificationRule_TargetProperty(p) {
    }
    function aws_cdk_lib_aws_codestarnotifications_DetailType(p) {
    }
    function aws_cdk_lib_aws_codestarnotifications_NotificationRuleOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.detailType) || (p.detailType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codestarnotifications_NotificationRuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.source) || (p.source, void 0), p.targets != null)
            for (const o of p.targets)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.detailType) || (p.detailType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_codestarnotifications_INotificationRule(p) {
    }
    function aws_cdk_lib_aws_codestarnotifications_NotificationRule(p) {
    }
    function aws_cdk_lib_aws_codestarnotifications_NotificationRuleSourceConfig(p) {
    }
    function aws_cdk_lib_aws_codestarnotifications_INotificationRuleSource(p) {
    }
    function aws_cdk_lib_aws_codestarnotifications_NotificationRuleTargetConfig(p) {
    }
    function aws_cdk_lib_aws_codestarnotifications_INotificationRuleTarget(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnIdentityPoolProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cognitoIdentityProviders) || (p.cognitoIdentityProviders, void 0), visitedObjects.has(p.cognitoStreams) || (p.cognitoStreams, void 0), visitedObjects.has(p.pushSync) || (p.pushSync, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_CfnIdentityPool(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnIdentityPool_CognitoIdentityProviderProperty(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnIdentityPool_CognitoStreamsProperty(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnIdentityPool_PushSyncProperty(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnIdentityPoolRoleAttachmentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.roleMappings) || (p.roleMappings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_CfnIdentityPoolRoleAttachment(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnIdentityPoolRoleAttachment_MappingRuleProperty(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnIdentityPoolRoleAttachment_RoleMappingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.rulesConfiguration) || (p.rulesConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_CfnIdentityPoolRoleAttachment_RulesConfigurationTypeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.rules) || (p.rules, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.accountRecoverySetting) || (p.accountRecoverySetting, void 0), visitedObjects.has(p.adminCreateUserConfig) || (p.adminCreateUserConfig, void 0), visitedObjects.has(p.deviceConfiguration) || (p.deviceConfiguration, void 0), visitedObjects.has(p.emailConfiguration) || (p.emailConfiguration, void 0), visitedObjects.has(p.lambdaConfig) || (p.lambdaConfig, void 0), visitedObjects.has(p.policies) || (p.policies, void 0), visitedObjects.has(p.schema) || (p.schema, void 0), visitedObjects.has(p.smsConfiguration) || (p.smsConfiguration, void 0), visitedObjects.has(p.userAttributeUpdateSettings) || (p.userAttributeUpdateSettings, void 0), visitedObjects.has(p.usernameConfiguration) || (p.usernameConfiguration, void 0), visitedObjects.has(p.userPoolAddOns) || (p.userPoolAddOns, void 0), visitedObjects.has(p.verificationMessageTemplate) || (p.verificationMessageTemplate, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_CfnUserPool(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPool_AccountRecoverySettingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.recoveryMechanisms) || (p.recoveryMechanisms, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_CfnUserPool_AdminCreateUserConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.inviteMessageTemplate) || (p.inviteMessageTemplate, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_CfnUserPool_CustomEmailSenderProperty(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPool_CustomSMSSenderProperty(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPool_DeviceConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPool_EmailConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPool_InviteMessageTemplateProperty(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPool_LambdaConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customEmailSender) || (p.customEmailSender, void 0), visitedObjects.has(p.customSmsSender) || (p.customSmsSender, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_CfnUserPool_NumberAttributeConstraintsProperty(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPool_PasswordPolicyProperty(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPool_PoliciesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.passwordPolicy) || (p.passwordPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_CfnUserPool_RecoveryOptionProperty(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPool_SchemaAttributeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.numberAttributeConstraints) || (p.numberAttributeConstraints, void 0), visitedObjects.has(p.stringAttributeConstraints) || (p.stringAttributeConstraints, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_CfnUserPool_SmsConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPool_StringAttributeConstraintsProperty(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPool_UserAttributeUpdateSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPool_UserPoolAddOnsProperty(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPool_UsernameConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPool_VerificationMessageTemplateProperty(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolClientProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.analyticsConfiguration) || (p.analyticsConfiguration, void 0), visitedObjects.has(p.tokenValidityUnits) || (p.tokenValidityUnits, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolClient(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolClient_AnalyticsConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolClient_TokenValidityUnitsProperty(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolDomainProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customDomainConfig) || (p.customDomainConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolDomain(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolDomain_CustomDomainConfigTypeProperty(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolGroupProps(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolGroup(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolIdentityProviderProps(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolIdentityProvider(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolResourceServerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.scopes) || (p.scopes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolResourceServer(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolResourceServer_ResourceServerScopeTypeProperty(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolRiskConfigurationAttachmentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.accountTakeoverRiskConfiguration) || (p.accountTakeoverRiskConfiguration, void 0), visitedObjects.has(p.compromisedCredentialsRiskConfiguration) || (p.compromisedCredentialsRiskConfiguration, void 0), visitedObjects.has(p.riskExceptionConfiguration) || (p.riskExceptionConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolRiskConfigurationAttachment(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolRiskConfigurationAttachment_AccountTakeoverActionTypeProperty(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolRiskConfigurationAttachment_AccountTakeoverActionsTypeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.highAction) || (p.highAction, void 0), visitedObjects.has(p.lowAction) || (p.lowAction, void 0), visitedObjects.has(p.mediumAction) || (p.mediumAction, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolRiskConfigurationAttachment_AccountTakeoverRiskConfigurationTypeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.notifyConfiguration) || (p.notifyConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolRiskConfigurationAttachment_CompromisedCredentialsActionsTypeProperty(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolRiskConfigurationAttachment_CompromisedCredentialsRiskConfigurationTypeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolRiskConfigurationAttachment_NotifyConfigurationTypeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.blockEmail) || (p.blockEmail, void 0), visitedObjects.has(p.mfaEmail) || (p.mfaEmail, void 0), visitedObjects.has(p.noActionEmail) || (p.noActionEmail, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolRiskConfigurationAttachment_NotifyEmailTypeProperty(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolRiskConfigurationAttachment_RiskExceptionConfigurationTypeProperty(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolUICustomizationAttachmentProps(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolUICustomizationAttachment(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolUserProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.userAttributes) || (p.userAttributes, void 0), visitedObjects.has(p.validationData) || (p.validationData, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolUser(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolUser_AttributeTypeProperty(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolUserToGroupAttachmentProps(p) {
    }
    function aws_cdk_lib_aws_cognito_CfnUserPoolUserToGroupAttachment(p) {
    }
    function aws_cdk_lib_aws_cognito_SignInAliases(p) {
    }
    function aws_cdk_lib_aws_cognito_AutoVerifiedAttrs(p) {
    }
    function aws_cdk_lib_aws_cognito_KeepOriginalAttrs(p) {
    }
    function aws_cdk_lib_aws_cognito_UserPoolTriggers(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.createAuthChallenge) || (p.createAuthChallenge, void 0), visitedObjects.has(p.customEmailSender) || (p.customEmailSender, void 0), visitedObjects.has(p.customMessage) || (p.customMessage, void 0), visitedObjects.has(p.customSmsSender) || (p.customSmsSender, void 0), visitedObjects.has(p.defineAuthChallenge) || (p.defineAuthChallenge, void 0), visitedObjects.has(p.postAuthentication) || (p.postAuthentication, void 0), visitedObjects.has(p.postConfirmation) || (p.postConfirmation, void 0), visitedObjects.has(p.preAuthentication) || (p.preAuthentication, void 0), visitedObjects.has(p.preSignUp) || (p.preSignUp, void 0), visitedObjects.has(p.preTokenGeneration) || (p.preTokenGeneration, void 0), visitedObjects.has(p.userMigration) || (p.userMigration, void 0), visitedObjects.has(p.verifyAuthChallengeResponse) || (p.verifyAuthChallengeResponse, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_UserPoolOperation(p) {
    }
    function aws_cdk_lib_aws_cognito_VerificationEmailStyle(p) {
    }
    function aws_cdk_lib_aws_cognito_UserVerificationConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.emailStyle) || (p.emailStyle, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_UserInvitationConfig(p) {
    }
    function aws_cdk_lib_aws_cognito_Mfa(p) {
    }
    function aws_cdk_lib_aws_cognito_MfaSecondFactor(p) {
    }
    function aws_cdk_lib_aws_cognito_PasswordPolicy(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tempPasswordValidity) || (p.tempPasswordValidity, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_EmailSettings(p) {
    }
    function aws_cdk_lib_aws_cognito_AccountRecovery(p) {
    }
    function aws_cdk_lib_aws_cognito_DeviceTracking(p) {
    }
    function aws_cdk_lib_aws_cognito_AdvancedSecurityMode(p) {
    }
    function aws_cdk_lib_aws_cognito_UserPoolProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.accountRecovery) || (p.accountRecovery, void 0), visitedObjects.has(p.advancedSecurityMode) || (p.advancedSecurityMode, void 0), visitedObjects.has(p.autoVerify) || (p.autoVerify, void 0), p.customAttributes != null)
            for (const o of Object.values(p.customAttributes))
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.customSenderKmsKey) || (p.customSenderKmsKey, void 0), visitedObjects.has(p.deviceTracking) || (p.deviceTracking, void 0), visitedObjects.has(p.email) || (p.email, void 0), visitedObjects.has(p.keepOriginal) || (p.keepOriginal, void 0), visitedObjects.has(p.lambdaTriggers) || aws_cdk_lib_aws_cognito_UserPoolTriggers(p.lambdaTriggers), visitedObjects.has(p.mfa) || (p.mfa, void 0), visitedObjects.has(p.mfaSecondFactor) || (p.mfaSecondFactor, void 0), visitedObjects.has(p.passwordPolicy) || aws_cdk_lib_aws_cognito_PasswordPolicy(p.passwordPolicy), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), visitedObjects.has(p.signInAliases) || (p.signInAliases, void 0), visitedObjects.has(p.smsRole) || (p.smsRole, void 0), visitedObjects.has(p.standardAttributes) || aws_cdk_lib_aws_cognito_StandardAttributes(p.standardAttributes), visitedObjects.has(p.userInvitation) || (p.userInvitation, void 0), visitedObjects.has(p.userVerification) || aws_cdk_lib_aws_cognito_UserVerificationConfig(p.userVerification);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_IUserPool(p) {
    }
    function aws_cdk_lib_aws_cognito_UserPool(p) {
    }
    function aws_cdk_lib_aws_cognito_StandardAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.address) || (p.address, void 0), visitedObjects.has(p.birthdate) || (p.birthdate, void 0), visitedObjects.has(p.email) || (p.email, void 0), visitedObjects.has(p.familyName) || (p.familyName, void 0), visitedObjects.has(p.fullname) || (p.fullname, void 0), visitedObjects.has(p.gender) || (p.gender, void 0), visitedObjects.has(p.givenName) || (p.givenName, void 0), visitedObjects.has(p.lastUpdateTime) || (p.lastUpdateTime, void 0), visitedObjects.has(p.locale) || (p.locale, void 0), visitedObjects.has(p.middleName) || (p.middleName, void 0), visitedObjects.has(p.nickname) || (p.nickname, void 0), visitedObjects.has(p.phoneNumber) || (p.phoneNumber, void 0), visitedObjects.has(p.preferredUsername) || (p.preferredUsername, void 0), visitedObjects.has(p.profilePage) || (p.profilePage, void 0), visitedObjects.has(p.profilePicture) || (p.profilePicture, void 0), visitedObjects.has(p.timezone) || (p.timezone, void 0), visitedObjects.has(p.website) || (p.website, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_StandardAttribute(p) {
    }
    function aws_cdk_lib_aws_cognito_ICustomAttribute(p) {
    }
    function aws_cdk_lib_aws_cognito_CustomAttributeConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.numberConstraints) || (p.numberConstraints, void 0), visitedObjects.has(p.stringConstraints) || (p.stringConstraints, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_CustomAttributeProps(p) {
    }
    function aws_cdk_lib_aws_cognito_StringAttributeConstraints(p) {
    }
    function aws_cdk_lib_aws_cognito_StringAttributeProps(p) {
    }
    function aws_cdk_lib_aws_cognito_StringAttribute(p) {
    }
    function aws_cdk_lib_aws_cognito_NumberAttributeConstraints(p) {
    }
    function aws_cdk_lib_aws_cognito_NumberAttributeProps(p) {
    }
    function aws_cdk_lib_aws_cognito_NumberAttribute(p) {
    }
    function aws_cdk_lib_aws_cognito_BooleanAttribute(p) {
    }
    function aws_cdk_lib_aws_cognito_DateTimeAttribute(p) {
    }
    function aws_cdk_lib_aws_cognito_StandardAttributesMask(p) {
    }
    function aws_cdk_lib_aws_cognito_ClientAttributes(p) {
    }
    function aws_cdk_lib_aws_cognito_AuthFlow(p) {
    }
    function aws_cdk_lib_aws_cognito_OAuthSettings(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.flows) || (p.flows, void 0), p.scopes != null)
            for (const o of p.scopes)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_OAuthFlows(p) {
    }
    function aws_cdk_lib_aws_cognito_OAuthScope(p) {
    }
    function aws_cdk_lib_aws_cognito_UserPoolClientIdentityProvider(p) {
    }
    function aws_cdk_lib_aws_cognito_UserPoolClientOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.accessTokenValidity) || (p.accessTokenValidity, void 0), visitedObjects.has(p.authFlows) || (p.authFlows, void 0), visitedObjects.has(p.authSessionValidity) || (p.authSessionValidity, void 0), visitedObjects.has(p.idTokenValidity) || (p.idTokenValidity, void 0), visitedObjects.has(p.oAuth) || aws_cdk_lib_aws_cognito_OAuthSettings(p.oAuth), visitedObjects.has(p.readAttributes) || (p.readAttributes, void 0), visitedObjects.has(p.refreshTokenValidity) || (p.refreshTokenValidity, void 0), p.supportedIdentityProviders != null)
            for (const o of p.supportedIdentityProviders)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.writeAttributes) || (p.writeAttributes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_UserPoolClientProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.userPool) || (p.userPool, void 0), visitedObjects.has(p.accessTokenValidity) || (p.accessTokenValidity, void 0), visitedObjects.has(p.authFlows) || (p.authFlows, void 0), visitedObjects.has(p.authSessionValidity) || (p.authSessionValidity, void 0), visitedObjects.has(p.idTokenValidity) || (p.idTokenValidity, void 0), visitedObjects.has(p.oAuth) || aws_cdk_lib_aws_cognito_OAuthSettings(p.oAuth), visitedObjects.has(p.readAttributes) || (p.readAttributes, void 0), visitedObjects.has(p.refreshTokenValidity) || (p.refreshTokenValidity, void 0), p.supportedIdentityProviders != null)
            for (const o of p.supportedIdentityProviders)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.writeAttributes) || (p.writeAttributes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_IUserPoolClient(p) {
    }
    function aws_cdk_lib_aws_cognito_UserPoolClient(p) {
    }
    function aws_cdk_lib_aws_cognito_IUserPoolDomain(p) {
    }
    function aws_cdk_lib_aws_cognito_CustomDomainOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.certificate) || (p.certificate, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_CognitoDomainOptions(p) {
    }
    function aws_cdk_lib_aws_cognito_UserPoolDomainOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cognitoDomain) || (p.cognitoDomain, void 0), visitedObjects.has(p.customDomain) || aws_cdk_lib_aws_cognito_CustomDomainOptions(p.customDomain);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_UserPoolDomainProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.userPool) || (p.userPool, void 0), visitedObjects.has(p.cognitoDomain) || (p.cognitoDomain, void 0), visitedObjects.has(p.customDomain) || aws_cdk_lib_aws_cognito_CustomDomainOptions(p.customDomain);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_UserPoolDomain(p) {
    }
    function aws_cdk_lib_aws_cognito_BaseUrlOptions(p) {
    }
    function aws_cdk_lib_aws_cognito_SignInUrlOptions(p) {
    }
    function aws_cdk_lib_aws_cognito_UserPoolSESOptions(p) {
    }
    function aws_cdk_lib_aws_cognito_UserPoolEmail(p) {
    }
    function aws_cdk_lib_aws_cognito_IUserPoolIdentityProvider(p) {
    }
    function aws_cdk_lib_aws_cognito_UserPoolIdentityProvider(p) {
    }
    function aws_cdk_lib_aws_cognito_ProviderAttribute(p) {
    }
    function aws_cdk_lib_aws_cognito_AttributeMapping(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.address) || (p.address, void 0), visitedObjects.has(p.birthdate) || (p.birthdate, void 0), p.custom != null)
            for (const o of Object.values(p.custom))
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.email) || (p.email, void 0), visitedObjects.has(p.familyName) || (p.familyName, void 0), visitedObjects.has(p.fullname) || (p.fullname, void 0), visitedObjects.has(p.gender) || (p.gender, void 0), visitedObjects.has(p.givenName) || (p.givenName, void 0), visitedObjects.has(p.lastUpdateTime) || (p.lastUpdateTime, void 0), visitedObjects.has(p.locale) || (p.locale, void 0), visitedObjects.has(p.middleName) || (p.middleName, void 0), visitedObjects.has(p.nickname) || (p.nickname, void 0), visitedObjects.has(p.phoneNumber) || (p.phoneNumber, void 0), visitedObjects.has(p.preferredUsername) || (p.preferredUsername, void 0), visitedObjects.has(p.profilePage) || (p.profilePage, void 0), visitedObjects.has(p.profilePicture) || (p.profilePicture, void 0), visitedObjects.has(p.timezone) || (p.timezone, void 0), visitedObjects.has(p.website) || (p.website, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_UserPoolIdentityProviderProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.userPool) || (p.userPool, void 0), visitedObjects.has(p.attributeMapping) || aws_cdk_lib_aws_cognito_AttributeMapping(p.attributeMapping);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_UserPoolIdentityProviderAppleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.userPool) || (p.userPool, void 0), visitedObjects.has(p.attributeMapping) || aws_cdk_lib_aws_cognito_AttributeMapping(p.attributeMapping);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_UserPoolIdentityProviderApple(p) {
    }
    function aws_cdk_lib_aws_cognito_UserPoolIdentityProviderAmazonProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.userPool) || (p.userPool, void 0), visitedObjects.has(p.attributeMapping) || aws_cdk_lib_aws_cognito_AttributeMapping(p.attributeMapping);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_UserPoolIdentityProviderAmazon(p) {
    }
    function aws_cdk_lib_aws_cognito_UserPoolIdentityProviderFacebookProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.userPool) || (p.userPool, void 0), visitedObjects.has(p.attributeMapping) || aws_cdk_lib_aws_cognito_AttributeMapping(p.attributeMapping);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_UserPoolIdentityProviderFacebook(p) {
    }
    function aws_cdk_lib_aws_cognito_UserPoolIdentityProviderGoogleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          "clientSecret" in p && print("aws-cdk-lib.aws_cognito.UserPoolIdentityProviderGoogleProps#clientSecret", "use clientSecretValue instead"), visitedObjects.has(p.clientSecretValue) || (p.clientSecretValue, void 0), visitedObjects.has(p.userPool) || (p.userPool, void 0), visitedObjects.has(p.attributeMapping) || aws_cdk_lib_aws_cognito_AttributeMapping(p.attributeMapping);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_UserPoolIdentityProviderGoogle(p) {
    }
    function aws_cdk_lib_aws_cognito_UserPoolIdentityProviderOidcProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.attributeRequestMethod) || (p.attributeRequestMethod, void 0), visitedObjects.has(p.endpoints) || (p.endpoints, void 0), visitedObjects.has(p.userPool) || (p.userPool, void 0), visitedObjects.has(p.attributeMapping) || aws_cdk_lib_aws_cognito_AttributeMapping(p.attributeMapping);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_OidcEndpoints(p) {
    }
    function aws_cdk_lib_aws_cognito_OidcAttributeRequestMethod(p) {
    }
    function aws_cdk_lib_aws_cognito_UserPoolIdentityProviderOidc(p) {
    }
    function aws_cdk_lib_aws_cognito_UserPoolIdentityProviderSamlProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.metadata) || (p.metadata, void 0), visitedObjects.has(p.userPool) || (p.userPool, void 0), visitedObjects.has(p.attributeMapping) || aws_cdk_lib_aws_cognito_AttributeMapping(p.attributeMapping);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_UserPoolIdentityProviderSamlMetadataType(p) {
    }
    function aws_cdk_lib_aws_cognito_UserPoolIdentityProviderSamlMetadata(p) {
    }
    function aws_cdk_lib_aws_cognito_UserPoolIdentityProviderSaml(p) {
    }
    function aws_cdk_lib_aws_cognito_IUserPoolResourceServer(p) {
    }
    function aws_cdk_lib_aws_cognito_ResourceServerScopeProps(p) {
    }
    function aws_cdk_lib_aws_cognito_ResourceServerScope(p) {
    }
    function aws_cdk_lib_aws_cognito_UserPoolResourceServerOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.scopes != null)
            for (const o of p.scopes)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_UserPoolResourceServerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.userPool) || (p.userPool, void 0), p.scopes != null)
            for (const o of p.scopes)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_cognito_UserPoolResourceServer(p) {
    }
    function aws_cdk_lib_aws_comprehend_CfnFlywheelProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.dataSecurityConfig) || (p.dataSecurityConfig, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.taskConfig) || (p.taskConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_comprehend_CfnFlywheel(p) {
    }
    function aws_cdk_lib_aws_comprehend_CfnFlywheel_DataSecurityConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.vpcConfig) || (p.vpcConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_comprehend_CfnFlywheel_DocumentClassificationConfigProperty(p) {
    }
    function aws_cdk_lib_aws_comprehend_CfnFlywheel_EntityRecognitionConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.entityTypes) || (p.entityTypes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_comprehend_CfnFlywheel_EntityTypesListItemProperty(p) {
    }
    function aws_cdk_lib_aws_comprehend_CfnFlywheel_TaskConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.documentClassificationConfig) || (p.documentClassificationConfig, void 0), visitedObjects.has(p.entityRecognitionConfig) || (p.entityRecognitionConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_comprehend_CfnFlywheel_VpcConfigProperty(p) {
    }
    function aws_cdk_lib_aws_config_IRule(p) {
    }
    function aws_cdk_lib_aws_config_RuleScope(p) {
    }
    function aws_cdk_lib_aws_config_MaximumExecutionFrequency(p) {
    }
    function aws_cdk_lib_aws_config_RuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.maximumExecutionFrequency) || (p.maximumExecutionFrequency, void 0), visitedObjects.has(p.ruleScope) || (p.ruleScope, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_config_ManagedRuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.maximumExecutionFrequency) || (p.maximumExecutionFrequency, void 0), visitedObjects.has(p.ruleScope) || (p.ruleScope, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_config_ManagedRule(p) {
    }
    function aws_cdk_lib_aws_config_CustomRuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.lambdaFunction) || (p.lambdaFunction, void 0), visitedObjects.has(p.maximumExecutionFrequency) || (p.maximumExecutionFrequency, void 0), visitedObjects.has(p.ruleScope) || (p.ruleScope, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_config_CustomRule(p) {
    }
    function aws_cdk_lib_aws_config_CustomPolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.maximumExecutionFrequency) || (p.maximumExecutionFrequency, void 0), visitedObjects.has(p.ruleScope) || (p.ruleScope, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_config_CustomPolicy(p) {
    }
    function aws_cdk_lib_aws_config_ManagedRuleIdentifiers(p) {
    }
    function aws_cdk_lib_aws_config_ResourceType(p) {
    }
    function aws_cdk_lib_aws_config_AccessKeysRotatedProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.maxAge) || (p.maxAge, void 0), visitedObjects.has(p.maximumExecutionFrequency) || (p.maximumExecutionFrequency, void 0), visitedObjects.has(p.ruleScope) || (p.ruleScope, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_config_AccessKeysRotated(p) {
    }
    function aws_cdk_lib_aws_config_CloudFormationStackDriftDetectionCheckProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.role) || (p.role, void 0), visitedObjects.has(p.maximumExecutionFrequency) || (p.maximumExecutionFrequency, void 0), visitedObjects.has(p.ruleScope) || (p.ruleScope, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_config_CloudFormationStackDriftDetectionCheck(p) {
    }
    function aws_cdk_lib_aws_config_CloudFormationStackNotificationCheckProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.topics != null)
            for (const o of p.topics)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.maximumExecutionFrequency) || (p.maximumExecutionFrequency, void 0), visitedObjects.has(p.ruleScope) || (p.ruleScope, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_config_CloudFormationStackNotificationCheck(p) {
    }
    function aws_cdk_lib_aws_config_CfnAggregationAuthorizationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_config_CfnAggregationAuthorization(p) {
    }
    function aws_cdk_lib_aws_config_CfnConfigRuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.source) || (p.source, void 0), visitedObjects.has(p.scope) || (p.scope, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_config_CfnConfigRule(p) {
    }
    function aws_cdk_lib_aws_config_CfnConfigRule_CustomPolicyDetailsProperty(p) {
    }
    function aws_cdk_lib_aws_config_CfnConfigRule_ScopeProperty(p) {
    }
    function aws_cdk_lib_aws_config_CfnConfigRule_SourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customPolicyDetails) || (p.customPolicyDetails, void 0), visitedObjects.has(p.sourceDetails) || (p.sourceDetails, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_config_CfnConfigRule_SourceDetailProperty(p) {
    }
    function aws_cdk_lib_aws_config_CfnConfigurationAggregatorProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.accountAggregationSources) || (p.accountAggregationSources, void 0), visitedObjects.has(p.organizationAggregationSource) || (p.organizationAggregationSource, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_config_CfnConfigurationAggregator(p) {
    }
    function aws_cdk_lib_aws_config_CfnConfigurationAggregator_AccountAggregationSourceProperty(p) {
    }
    function aws_cdk_lib_aws_config_CfnConfigurationAggregator_OrganizationAggregationSourceProperty(p) {
    }
    function aws_cdk_lib_aws_config_CfnConfigurationRecorderProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.recordingGroup) || (p.recordingGroup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_config_CfnConfigurationRecorder(p) {
    }
    function aws_cdk_lib_aws_config_CfnConfigurationRecorder_RecordingGroupProperty(p) {
    }
    function aws_cdk_lib_aws_config_CfnConformancePackProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.conformancePackInputParameters) || (p.conformancePackInputParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_config_CfnConformancePack(p) {
    }
    function aws_cdk_lib_aws_config_CfnConformancePack_ConformancePackInputParameterProperty(p) {
    }
    function aws_cdk_lib_aws_config_CfnConformancePack_TemplateSSMDocumentDetailsProperty(p) {
    }
    function aws_cdk_lib_aws_config_CfnDeliveryChannelProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.configSnapshotDeliveryProperties) || (p.configSnapshotDeliveryProperties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_config_CfnDeliveryChannel(p) {
    }
    function aws_cdk_lib_aws_config_CfnDeliveryChannel_ConfigSnapshotDeliveryPropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_config_CfnOrganizationConfigRuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.organizationCustomPolicyRuleMetadata) || (p.organizationCustomPolicyRuleMetadata, void 0), visitedObjects.has(p.organizationCustomRuleMetadata) || (p.organizationCustomRuleMetadata, void 0), visitedObjects.has(p.organizationManagedRuleMetadata) || (p.organizationManagedRuleMetadata, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_config_CfnOrganizationConfigRule(p) {
    }
    function aws_cdk_lib_aws_config_CfnOrganizationConfigRule_OrganizationCustomPolicyRuleMetadataProperty(p) {
    }
    function aws_cdk_lib_aws_config_CfnOrganizationConfigRule_OrganizationCustomRuleMetadataProperty(p) {
    }
    function aws_cdk_lib_aws_config_CfnOrganizationConfigRule_OrganizationManagedRuleMetadataProperty(p) {
    }
    function aws_cdk_lib_aws_config_CfnOrganizationConformancePackProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.conformancePackInputParameters) || (p.conformancePackInputParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_config_CfnOrganizationConformancePack(p) {
    }
    function aws_cdk_lib_aws_config_CfnOrganizationConformancePack_ConformancePackInputParameterProperty(p) {
    }
    function aws_cdk_lib_aws_config_CfnRemediationConfigurationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.executionControls) || (p.executionControls, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_config_CfnRemediationConfiguration(p) {
    }
    function aws_cdk_lib_aws_config_CfnRemediationConfiguration_ExecutionControlsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ssmControls) || (p.ssmControls, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_config_CfnRemediationConfiguration_RemediationParameterValueProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.resourceValue) || (p.resourceValue, void 0), visitedObjects.has(p.staticValue) || (p.staticValue, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_config_CfnRemediationConfiguration_ResourceValueProperty(p) {
    }
    function aws_cdk_lib_aws_config_CfnRemediationConfiguration_SsmControlsProperty(p) {
    }
    function aws_cdk_lib_aws_config_CfnRemediationConfiguration_StaticValueProperty(p) {
    }
    function aws_cdk_lib_aws_config_CfnStoredQueryProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_config_CfnStoredQuery(p) {
    }
    function aws_cdk_lib_aws_connect_CfnApprovedOriginProps(p) {
    }
    function aws_cdk_lib_aws_connect_CfnApprovedOrigin(p) {
    }
    function aws_cdk_lib_aws_connect_CfnContactFlowProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnContactFlow(p) {
    }
    function aws_cdk_lib_aws_connect_CfnContactFlowModuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnContactFlowModule(p) {
    }
    function aws_cdk_lib_aws_connect_CfnEvaluationFormProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.items) || (p.items, void 0), visitedObjects.has(p.scoringStrategy) || (p.scoringStrategy, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnEvaluationForm(p) {
    }
    function aws_cdk_lib_aws_connect_CfnEvaluationForm_EvaluationFormBaseItemProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.section) || (p.section, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnEvaluationForm_EvaluationFormItemProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.question) || (p.question, void 0), visitedObjects.has(p.section) || (p.section, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnEvaluationForm_EvaluationFormNumericQuestionAutomationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.propertyValue) || (p.propertyValue, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnEvaluationForm_EvaluationFormNumericQuestionOptionProperty(p) {
    }
    function aws_cdk_lib_aws_connect_CfnEvaluationForm_EvaluationFormNumericQuestionPropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.automation) || (p.automation, void 0), visitedObjects.has(p.options) || (p.options, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnEvaluationForm_EvaluationFormQuestionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.questionTypeProperties) || (p.questionTypeProperties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnEvaluationForm_EvaluationFormQuestionTypePropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.numeric) || (p.numeric, void 0), visitedObjects.has(p.singleSelect) || (p.singleSelect, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnEvaluationForm_EvaluationFormSectionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.items) || (p.items, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnEvaluationForm_EvaluationFormSingleSelectQuestionAutomationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.options) || (p.options, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnEvaluationForm_EvaluationFormSingleSelectQuestionAutomationOptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ruleCategory) || (p.ruleCategory, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnEvaluationForm_EvaluationFormSingleSelectQuestionOptionProperty(p) {
    }
    function aws_cdk_lib_aws_connect_CfnEvaluationForm_EvaluationFormSingleSelectQuestionPropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.options) || (p.options, void 0), visitedObjects.has(p.automation) || (p.automation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnEvaluationForm_NumericQuestionPropertyValueAutomationProperty(p) {
    }
    function aws_cdk_lib_aws_connect_CfnEvaluationForm_ScoringStrategyProperty(p) {
    }
    function aws_cdk_lib_aws_connect_CfnEvaluationForm_SingleSelectQuestionRuleCategoryAutomationProperty(p) {
    }
    function aws_cdk_lib_aws_connect_CfnHoursOfOperationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.config) || (p.config, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnHoursOfOperation(p) {
    }
    function aws_cdk_lib_aws_connect_CfnHoursOfOperation_HoursOfOperationConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.endTime) || (p.endTime, void 0), visitedObjects.has(p.startTime) || (p.startTime, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnHoursOfOperation_HoursOfOperationTimeSliceProperty(p) {
    }
    function aws_cdk_lib_aws_connect_CfnInstanceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.attributes) || (p.attributes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnInstance(p) {
    }
    function aws_cdk_lib_aws_connect_CfnInstance_AttributesProperty(p) {
    }
    function aws_cdk_lib_aws_connect_CfnInstanceStorageConfigProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.kinesisFirehoseConfig) || (p.kinesisFirehoseConfig, void 0), visitedObjects.has(p.kinesisStreamConfig) || (p.kinesisStreamConfig, void 0), visitedObjects.has(p.kinesisVideoStreamConfig) || (p.kinesisVideoStreamConfig, void 0), visitedObjects.has(p.s3Config) || (p.s3Config, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnInstanceStorageConfig(p) {
    }
    function aws_cdk_lib_aws_connect_CfnInstanceStorageConfig_EncryptionConfigProperty(p) {
    }
    function aws_cdk_lib_aws_connect_CfnInstanceStorageConfig_KinesisFirehoseConfigProperty(p) {
    }
    function aws_cdk_lib_aws_connect_CfnInstanceStorageConfig_KinesisStreamConfigProperty(p) {
    }
    function aws_cdk_lib_aws_connect_CfnInstanceStorageConfig_KinesisVideoStreamConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.encryptionConfig) || (p.encryptionConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnInstanceStorageConfig_S3ConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.encryptionConfig) || (p.encryptionConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnIntegrationAssociationProps(p) {
    }
    function aws_cdk_lib_aws_connect_CfnIntegrationAssociation(p) {
    }
    function aws_cdk_lib_aws_connect_CfnPhoneNumberProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnPhoneNumber(p) {
    }
    function aws_cdk_lib_aws_connect_CfnQuickConnectProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.quickConnectConfig) || (p.quickConnectConfig, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnQuickConnect(p) {
    }
    function aws_cdk_lib_aws_connect_CfnQuickConnect_PhoneNumberQuickConnectConfigProperty(p) {
    }
    function aws_cdk_lib_aws_connect_CfnQuickConnect_QueueQuickConnectConfigProperty(p) {
    }
    function aws_cdk_lib_aws_connect_CfnQuickConnect_QuickConnectConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.phoneConfig) || (p.phoneConfig, void 0), visitedObjects.has(p.queueConfig) || (p.queueConfig, void 0), visitedObjects.has(p.userConfig) || (p.userConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnQuickConnect_UserQuickConnectConfigProperty(p) {
    }
    function aws_cdk_lib_aws_connect_CfnRuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.triggerEventSource) || (p.triggerEventSource, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnRule(p) {
    }
    function aws_cdk_lib_aws_connect_CfnRule_ActionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.eventBridgeActions) || (p.eventBridgeActions, void 0), visitedObjects.has(p.sendNotificationActions) || (p.sendNotificationActions, void 0), visitedObjects.has(p.taskActions) || (p.taskActions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnRule_EventBridgeActionProperty(p) {
    }
    function aws_cdk_lib_aws_connect_CfnRule_NotificationRecipientTypeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.userTags) || (p.userTags, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnRule_ReferenceProperty(p) {
    }
    function aws_cdk_lib_aws_connect_CfnRule_RuleTriggerEventSourceProperty(p) {
    }
    function aws_cdk_lib_aws_connect_CfnRule_SendNotificationActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.recipient) || (p.recipient, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnRule_TaskActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.references) || (p.references, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnSecurityKeyProps(p) {
    }
    function aws_cdk_lib_aws_connect_CfnSecurityKey(p) {
    }
    function aws_cdk_lib_aws_connect_CfnTaskTemplateProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.defaults) || (p.defaults, void 0), visitedObjects.has(p.fields) || (p.fields, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnTaskTemplate(p) {
    }
    function aws_cdk_lib_aws_connect_CfnTaskTemplate_ConstraintsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.invisibleFields) || (p.invisibleFields, void 0), visitedObjects.has(p.readOnlyFields) || (p.readOnlyFields, void 0), visitedObjects.has(p.requiredFields) || (p.requiredFields, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnTaskTemplate_DefaultFieldValueProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.id) || (p.id, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnTaskTemplate_FieldProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.id) || (p.id, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnTaskTemplate_FieldIdentifierProperty(p) {
    }
    function aws_cdk_lib_aws_connect_CfnTaskTemplate_InvisibleFieldInfoProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.id) || (p.id, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnTaskTemplate_ReadOnlyFieldInfoProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.id) || (p.id, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnTaskTemplate_RequiredFieldInfoProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.id) || (p.id, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnUserProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.phoneConfig) || (p.phoneConfig, void 0), visitedObjects.has(p.identityInfo) || (p.identityInfo, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connect_CfnUser(p) {
    }
    function aws_cdk_lib_aws_connect_CfnUser_UserIdentityInfoProperty(p) {
    }
    function aws_cdk_lib_aws_connect_CfnUser_UserPhoneConfigProperty(p) {
    }
    function aws_cdk_lib_aws_connect_CfnUserHierarchyGroupProps(p) {
    }
    function aws_cdk_lib_aws_connect_CfnUserHierarchyGroup(p) {
    }
    function aws_cdk_lib_aws_connectcampaigns_CfnCampaignProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.dialerConfig) || (p.dialerConfig, void 0), visitedObjects.has(p.outboundCallConfig) || (p.outboundCallConfig, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connectcampaigns_CfnCampaign(p) {
    }
    function aws_cdk_lib_aws_connectcampaigns_CfnCampaign_AnswerMachineDetectionConfigProperty(p) {
    }
    function aws_cdk_lib_aws_connectcampaigns_CfnCampaign_DialerConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.predictiveDialerConfig) || (p.predictiveDialerConfig, void 0), visitedObjects.has(p.progressiveDialerConfig) || (p.progressiveDialerConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connectcampaigns_CfnCampaign_OutboundCallConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.answerMachineDetectionConfig) || (p.answerMachineDetectionConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_connectcampaigns_CfnCampaign_PredictiveDialerConfigProperty(p) {
    }
    function aws_cdk_lib_aws_connectcampaigns_CfnCampaign_ProgressiveDialerConfigProperty(p) {
    }
    function aws_cdk_lib_aws_controltower_CfnEnabledControlProps(p) {
    }
    function aws_cdk_lib_aws_controltower_CfnEnabledControl(p) {
    }
    function aws_cdk_lib_aws_cur_CfnReportDefinitionProps(p) {
    }
    function aws_cdk_lib_aws_cur_CfnReportDefinition(p) {
    }
    function aws_cdk_lib_aws_customerprofiles_CfnDomainProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_customerprofiles_CfnDomain(p) {
    }
    function aws_cdk_lib_aws_customerprofiles_CfnIntegrationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.flowDefinition) || (p.flowDefinition, void 0), visitedObjects.has(p.objectTypeNames) || (p.objectTypeNames, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_customerprofiles_CfnIntegration(p) {
    }
    function aws_cdk_lib_aws_customerprofiles_CfnIntegration_ConnectorOperatorProperty(p) {
    }
    function aws_cdk_lib_aws_customerprofiles_CfnIntegration_FlowDefinitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sourceFlowConfig) || (p.sourceFlowConfig, void 0), visitedObjects.has(p.tasks) || (p.tasks, void 0), visitedObjects.has(p.triggerConfig) || (p.triggerConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_customerprofiles_CfnIntegration_IncrementalPullConfigProperty(p) {
    }
    function aws_cdk_lib_aws_customerprofiles_CfnIntegration_MarketoSourcePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_customerprofiles_CfnIntegration_ObjectTypeMappingProperty(p) {
    }
    function aws_cdk_lib_aws_customerprofiles_CfnIntegration_S3SourcePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_customerprofiles_CfnIntegration_SalesforceSourcePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_customerprofiles_CfnIntegration_ScheduledTriggerPropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_customerprofiles_CfnIntegration_ServiceNowSourcePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_customerprofiles_CfnIntegration_SourceConnectorPropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.marketo) || (p.marketo, void 0), visitedObjects.has(p.s3) || (p.s3, void 0), visitedObjects.has(p.salesforce) || (p.salesforce, void 0), visitedObjects.has(p.serviceNow) || (p.serviceNow, void 0), visitedObjects.has(p.zendesk) || (p.zendesk, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_customerprofiles_CfnIntegration_SourceFlowConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sourceConnectorProperties) || (p.sourceConnectorProperties, void 0), visitedObjects.has(p.incrementalPullConfig) || (p.incrementalPullConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_customerprofiles_CfnIntegration_TaskProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.connectorOperator) || (p.connectorOperator, void 0), visitedObjects.has(p.taskProperties) || (p.taskProperties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_customerprofiles_CfnIntegration_TaskPropertiesMapProperty(p) {
    }
    function aws_cdk_lib_aws_customerprofiles_CfnIntegration_TriggerConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.triggerProperties) || (p.triggerProperties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_customerprofiles_CfnIntegration_TriggerPropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.scheduled) || (p.scheduled, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_customerprofiles_CfnIntegration_ZendeskSourcePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_customerprofiles_CfnObjectTypeProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.fields) || (p.fields, void 0), visitedObjects.has(p.keys) || (p.keys, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_customerprofiles_CfnObjectType(p) {
    }
    function aws_cdk_lib_aws_customerprofiles_CfnObjectType_FieldMapProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.objectTypeField) || (p.objectTypeField, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_customerprofiles_CfnObjectType_KeyMapProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.objectTypeKeyList) || (p.objectTypeKeyList, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_customerprofiles_CfnObjectType_ObjectTypeFieldProperty(p) {
    }
    function aws_cdk_lib_aws_customerprofiles_CfnObjectType_ObjectTypeKeyProperty(p) {
    }
    function aws_cdk_lib_aws_databrew_CfnDatasetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.input) || (p.input, void 0), visitedObjects.has(p.formatOptions) || (p.formatOptions, void 0), visitedObjects.has(p.pathOptions) || (p.pathOptions, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnDataset(p) {
    }
    function aws_cdk_lib_aws_databrew_CfnDataset_CsvOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_databrew_CfnDataset_DataCatalogInputDefinitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tempDirectory) || (p.tempDirectory, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnDataset_DatabaseInputDefinitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tempDirectory) || (p.tempDirectory, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnDataset_DatasetParameterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.datetimeOptions) || (p.datetimeOptions, void 0), visitedObjects.has(p.filter) || (p.filter, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnDataset_DatetimeOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_databrew_CfnDataset_ExcelOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_databrew_CfnDataset_FilesLimitProperty(p) {
    }
    function aws_cdk_lib_aws_databrew_CfnDataset_FilterExpressionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.valuesMap) || (p.valuesMap, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnDataset_FilterValueProperty(p) {
    }
    function aws_cdk_lib_aws_databrew_CfnDataset_FormatOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.csv) || (p.csv, void 0), visitedObjects.has(p.excel) || (p.excel, void 0), visitedObjects.has(p.json) || (p.json, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnDataset_InputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.databaseInputDefinition) || (p.databaseInputDefinition, void 0), visitedObjects.has(p.dataCatalogInputDefinition) || (p.dataCatalogInputDefinition, void 0), visitedObjects.has(p.metadata) || (p.metadata, void 0), visitedObjects.has(p.s3InputDefinition) || (p.s3InputDefinition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnDataset_JsonOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_databrew_CfnDataset_MetadataProperty(p) {
    }
    function aws_cdk_lib_aws_databrew_CfnDataset_PathOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.filesLimit) || (p.filesLimit, void 0), visitedObjects.has(p.lastModifiedDateCondition) || (p.lastModifiedDateCondition, void 0), visitedObjects.has(p.parameters) || (p.parameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnDataset_PathParameterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.datasetParameter) || (p.datasetParameter, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnDataset_S3LocationProperty(p) {
    }
    function aws_cdk_lib_aws_databrew_CfnJobProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.databaseOutputs) || (p.databaseOutputs, void 0), visitedObjects.has(p.dataCatalogOutputs) || (p.dataCatalogOutputs, void 0), visitedObjects.has(p.jobSample) || (p.jobSample, void 0), visitedObjects.has(p.outputLocation) || (p.outputLocation, void 0), visitedObjects.has(p.outputs) || (p.outputs, void 0), visitedObjects.has(p.profileConfiguration) || (p.profileConfiguration, void 0), visitedObjects.has(p.recipe) || (p.recipe, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.validationConfigurations) || (p.validationConfigurations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnJob(p) {
    }
    function aws_cdk_lib_aws_databrew_CfnJob_AllowedStatisticsProperty(p) {
    }
    function aws_cdk_lib_aws_databrew_CfnJob_ColumnSelectorProperty(p) {
    }
    function aws_cdk_lib_aws_databrew_CfnJob_ColumnStatisticsConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.statistics) || (p.statistics, void 0), visitedObjects.has(p.selectors) || (p.selectors, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnJob_CsvOutputOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_databrew_CfnJob_DataCatalogOutputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.databaseOptions) || (p.databaseOptions, void 0), visitedObjects.has(p.s3Options) || (p.s3Options, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnJob_DatabaseOutputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.databaseOptions) || (p.databaseOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnJob_DatabaseTableOutputOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tempDirectory) || (p.tempDirectory, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnJob_EntityDetectorConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.allowedStatistics) || (p.allowedStatistics, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnJob_JobSampleProperty(p) {
    }
    function aws_cdk_lib_aws_databrew_CfnJob_OutputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.location) || (p.location, void 0), visitedObjects.has(p.formatOptions) || (p.formatOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnJob_OutputFormatOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.csv) || (p.csv, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnJob_OutputLocationProperty(p) {
    }
    function aws_cdk_lib_aws_databrew_CfnJob_ProfileConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columnStatisticsConfigurations) || (p.columnStatisticsConfigurations, void 0), visitedObjects.has(p.datasetStatisticsConfiguration) || (p.datasetStatisticsConfiguration, void 0), visitedObjects.has(p.entityDetectorConfiguration) || (p.entityDetectorConfiguration, void 0), visitedObjects.has(p.profileColumns) || (p.profileColumns, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnJob_RecipeProperty(p) {
    }
    function aws_cdk_lib_aws_databrew_CfnJob_S3LocationProperty(p) {
    }
    function aws_cdk_lib_aws_databrew_CfnJob_S3TableOutputOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.location) || (p.location, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnJob_StatisticOverrideProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.parameters) || (p.parameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnJob_StatisticsConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.overrides) || (p.overrides, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnJob_ValidationConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_databrew_CfnProjectProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.sample) || (p.sample, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnProject(p) {
    }
    function aws_cdk_lib_aws_databrew_CfnProject_SampleProperty(p) {
    }
    function aws_cdk_lib_aws_databrew_CfnRecipeProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.steps) || (p.steps, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnRecipe(p) {
    }
    function aws_cdk_lib_aws_databrew_CfnRecipe_ActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.parameters) || (p.parameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnRecipe_ConditionExpressionProperty(p) {
    }
    function aws_cdk_lib_aws_databrew_CfnRecipe_DataCatalogInputDefinitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tempDirectory) || (p.tempDirectory, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnRecipe_InputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataCatalogInputDefinition) || (p.dataCatalogInputDefinition, void 0), visitedObjects.has(p.s3InputDefinition) || (p.s3InputDefinition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnRecipe_RecipeParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.secondaryInputs) || (p.secondaryInputs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnRecipe_RecipeStepProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.action) || (p.action, void 0), visitedObjects.has(p.conditionExpressions) || (p.conditionExpressions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnRecipe_S3LocationProperty(p) {
    }
    function aws_cdk_lib_aws_databrew_CfnRecipe_SecondaryInputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataCatalogInputDefinition) || (p.dataCatalogInputDefinition, void 0), visitedObjects.has(p.s3InputDefinition) || (p.s3InputDefinition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnRulesetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.rules) || (p.rules, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnRuleset(p) {
    }
    function aws_cdk_lib_aws_databrew_CfnRuleset_ColumnSelectorProperty(p) {
    }
    function aws_cdk_lib_aws_databrew_CfnRuleset_RuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columnSelectors) || (p.columnSelectors, void 0), visitedObjects.has(p.substitutionMap) || (p.substitutionMap, void 0), visitedObjects.has(p.threshold) || (p.threshold, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnRuleset_SubstitutionValueProperty(p) {
    }
    function aws_cdk_lib_aws_databrew_CfnRuleset_ThresholdProperty(p) {
    }
    function aws_cdk_lib_aws_databrew_CfnScheduleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_databrew_CfnSchedule(p) {
    }
    function aws_cdk_lib_aws_datapipeline_CfnPipelineProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.parameterObjects) || (p.parameterObjects, void 0), visitedObjects.has(p.parameterValues) || (p.parameterValues, void 0), visitedObjects.has(p.pipelineObjects) || (p.pipelineObjects, void 0), visitedObjects.has(p.pipelineTags) || (p.pipelineTags, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_datapipeline_CfnPipeline(p) {
    }
    function aws_cdk_lib_aws_datapipeline_CfnPipeline_FieldProperty(p) {
    }
    function aws_cdk_lib_aws_datapipeline_CfnPipeline_ParameterAttributeProperty(p) {
    }
    function aws_cdk_lib_aws_datapipeline_CfnPipeline_ParameterObjectProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.attributes) || (p.attributes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_datapipeline_CfnPipeline_ParameterValueProperty(p) {
    }
    function aws_cdk_lib_aws_datapipeline_CfnPipeline_PipelineObjectProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fields) || (p.fields, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_datapipeline_CfnPipeline_PipelineTagProperty(p) {
    }
    function aws_cdk_lib_aws_datasync_CfnAgentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_datasync_CfnAgent(p) {
    }
    function aws_cdk_lib_aws_datasync_CfnLocationEFSProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.ec2Config) || (p.ec2Config, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_datasync_CfnLocationEFS(p) {
    }
    function aws_cdk_lib_aws_datasync_CfnLocationEFS_Ec2ConfigProperty(p) {
    }
    function aws_cdk_lib_aws_datasync_CfnLocationFSxLustreProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_datasync_CfnLocationFSxLustre(p) {
    }
    function aws_cdk_lib_aws_datasync_CfnLocationFSxONTAPProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.protocol) || (p.protocol, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_datasync_CfnLocationFSxONTAP(p) {
    }
    function aws_cdk_lib_aws_datasync_CfnLocationFSxONTAP_NFSProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.mountOptions) || (p.mountOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_datasync_CfnLocationFSxONTAP_NfsMountOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_datasync_CfnLocationFSxONTAP_ProtocolProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.nfs) || (p.nfs, void 0), visitedObjects.has(p.smb) || (p.smb, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_datasync_CfnLocationFSxONTAP_SMBProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.mountOptions) || (p.mountOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_datasync_CfnLocationFSxONTAP_SmbMountOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_datasync_CfnLocationFSxOpenZFSProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.protocol) || (p.protocol, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_datasync_CfnLocationFSxOpenZFS(p) {
    }
    function aws_cdk_lib_aws_datasync_CfnLocationFSxOpenZFS_MountOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_datasync_CfnLocationFSxOpenZFS_NFSProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.mountOptions) || (p.mountOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_datasync_CfnLocationFSxOpenZFS_ProtocolProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.nfs) || (p.nfs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_datasync_CfnLocationFSxWindowsProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_datasync_CfnLocationFSxWindows(p) {
    }
    function aws_cdk_lib_aws_datasync_CfnLocationHDFSProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.nameNodes) || (p.nameNodes, void 0), visitedObjects.has(p.qopConfiguration) || (p.qopConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_datasync_CfnLocationHDFS(p) {
    }
    function aws_cdk_lib_aws_datasync_CfnLocationHDFS_NameNodeProperty(p) {
    }
    function aws_cdk_lib_aws_datasync_CfnLocationHDFS_QopConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_datasync_CfnLocationNFSProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.onPremConfig) || (p.onPremConfig, void 0), visitedObjects.has(p.mountOptions) || (p.mountOptions, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_datasync_CfnLocationNFS(p) {
    }
    function aws_cdk_lib_aws_datasync_CfnLocationNFS_MountOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_datasync_CfnLocationNFS_OnPremConfigProperty(p) {
    }
    function aws_cdk_lib_aws_datasync_CfnLocationObjectStorageProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_datasync_CfnLocationObjectStorage(p) {
    }
    function aws_cdk_lib_aws_datasync_CfnLocationS3Props(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.s3Config) || (p.s3Config, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_datasync_CfnLocationS3(p) {
    }
    function aws_cdk_lib_aws_datasync_CfnLocationS3_S3ConfigProperty(p) {
    }
    function aws_cdk_lib_aws_datasync_CfnLocationSMBProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.mountOptions) || (p.mountOptions, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_datasync_CfnLocationSMB(p) {
    }
    function aws_cdk_lib_aws_datasync_CfnLocationSMB_MountOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_datasync_CfnStorageSystemProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.serverConfiguration) || (p.serverConfiguration, void 0), visitedObjects.has(p.serverCredentials) || (p.serverCredentials, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_datasync_CfnStorageSystem(p) {
    }
    function aws_cdk_lib_aws_datasync_CfnStorageSystem_ServerConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_datasync_CfnStorageSystem_ServerCredentialsProperty(p) {
    }
    function aws_cdk_lib_aws_datasync_CfnTaskProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.excludes) || (p.excludes, void 0), visitedObjects.has(p.includes) || (p.includes, void 0), visitedObjects.has(p.options) || (p.options, void 0), visitedObjects.has(p.schedule) || (p.schedule, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_datasync_CfnTask(p) {
    }
    function aws_cdk_lib_aws_datasync_CfnTask_FilterRuleProperty(p) {
    }
    function aws_cdk_lib_aws_datasync_CfnTask_OptionsProperty(p) {
    }
    function aws_cdk_lib_aws_datasync_CfnTask_TaskScheduleProperty(p) {
    }
    function aws_cdk_lib_aws_dax_CfnClusterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sseSpecification) || (p.sseSpecification, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dax_CfnCluster(p) {
    }
    function aws_cdk_lib_aws_dax_CfnCluster_SSESpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_dax_CfnParameterGroupProps(p) {
    }
    function aws_cdk_lib_aws_dax_CfnParameterGroup(p) {
    }
    function aws_cdk_lib_aws_dax_CfnSubnetGroupProps(p) {
    }
    function aws_cdk_lib_aws_dax_CfnSubnetGroup(p) {
    }
    function aws_cdk_lib_aws_detective_CfnGraphProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_detective_CfnGraph(p) {
    }
    function aws_cdk_lib_aws_detective_CfnMemberInvitationProps(p) {
    }
    function aws_cdk_lib_aws_detective_CfnMemberInvitation(p) {
    }
    function aws_cdk_lib_aws_devicefarm_CfnDevicePoolProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.rules) || (p.rules, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_devicefarm_CfnDevicePool(p) {
    }
    function aws_cdk_lib_aws_devicefarm_CfnDevicePool_RuleProperty(p) {
    }
    function aws_cdk_lib_aws_devicefarm_CfnInstanceProfileProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_devicefarm_CfnInstanceProfile(p) {
    }
    function aws_cdk_lib_aws_devicefarm_CfnNetworkProfileProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_devicefarm_CfnNetworkProfile(p) {
    }
    function aws_cdk_lib_aws_devicefarm_CfnProjectProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.vpcConfig) || (p.vpcConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_devicefarm_CfnProject(p) {
    }
    function aws_cdk_lib_aws_devicefarm_CfnProject_VpcConfigProperty(p) {
    }
    function aws_cdk_lib_aws_devicefarm_CfnTestGridProjectProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.vpcConfig) || (p.vpcConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_devicefarm_CfnTestGridProject(p) {
    }
    function aws_cdk_lib_aws_devicefarm_CfnTestGridProject_VpcConfigProperty(p) {
    }
    function aws_cdk_lib_aws_devicefarm_CfnVPCEConfigurationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_devicefarm_CfnVPCEConfiguration(p) {
    }
    function aws_cdk_lib_aws_devopsguru_CfnLogAnomalyDetectionIntegration(p) {
    }
    function aws_cdk_lib_aws_devopsguru_CfnNotificationChannelProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.config) || (p.config, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_devopsguru_CfnNotificationChannel(p) {
    }
    function aws_cdk_lib_aws_devopsguru_CfnNotificationChannel_NotificationChannelConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.filters) || (p.filters, void 0), visitedObjects.has(p.sns) || (p.sns, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_devopsguru_CfnNotificationChannel_NotificationFilterConfigProperty(p) {
    }
    function aws_cdk_lib_aws_devopsguru_CfnNotificationChannel_SnsChannelConfigProperty(p) {
    }
    function aws_cdk_lib_aws_devopsguru_CfnResourceCollectionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.resourceCollectionFilter) || (p.resourceCollectionFilter, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_devopsguru_CfnResourceCollection(p) {
    }
    function aws_cdk_lib_aws_devopsguru_CfnResourceCollection_CloudFormationCollectionFilterProperty(p) {
    }
    function aws_cdk_lib_aws_devopsguru_CfnResourceCollection_ResourceCollectionFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.cloudFormation) || (p.cloudFormation, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_devopsguru_CfnResourceCollection_TagCollectionProperty(p) {
    }
    function aws_cdk_lib_aws_directoryservice_CfnMicrosoftADProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.vpcSettings) || (p.vpcSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_directoryservice_CfnMicrosoftAD(p) {
    }
    function aws_cdk_lib_aws_directoryservice_CfnMicrosoftAD_VpcSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_directoryservice_CfnSimpleADProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.vpcSettings) || (p.vpcSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_directoryservice_CfnSimpleAD(p) {
    }
    function aws_cdk_lib_aws_directoryservice_CfnSimpleAD_VpcSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_dlm_CfnLifecyclePolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.policyDetails) || (p.policyDetails, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dlm_CfnLifecyclePolicy(p) {
    }
    function aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_ActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.crossRegionCopy) || (p.crossRegionCopy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_ArchiveRetainRuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.retentionArchiveTier) || (p.retentionArchiveTier, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_ArchiveRuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.retainRule) || (p.retainRule, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_CreateRuleProperty(p) {
    }
    function aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_CrossRegionCopyActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.encryptionConfiguration) || (p.encryptionConfiguration, void 0), visitedObjects.has(p.retainRule) || (p.retainRule, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_CrossRegionCopyDeprecateRuleProperty(p) {
    }
    function aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_CrossRegionCopyRetainRuleProperty(p) {
    }
    function aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_CrossRegionCopyRuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.deprecateRule) || (p.deprecateRule, void 0), visitedObjects.has(p.retainRule) || (p.retainRule, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_DeprecateRuleProperty(p) {
    }
    function aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_EncryptionConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_EventParametersProperty(p) {
    }
    function aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_EventSourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.parameters) || (p.parameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_FastRestoreRuleProperty(p) {
    }
    function aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_ParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.excludeDataVolumeTags) || (p.excludeDataVolumeTags, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_PolicyDetailsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.eventSource) || (p.eventSource, void 0), visitedObjects.has(p.parameters) || (p.parameters, void 0), visitedObjects.has(p.schedules) || (p.schedules, void 0), visitedObjects.has(p.targetTags) || (p.targetTags, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_RetainRuleProperty(p) {
    }
    function aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_RetentionArchiveTierProperty(p) {
    }
    function aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_ScheduleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.archiveRule) || (p.archiveRule, void 0), visitedObjects.has(p.createRule) || (p.createRule, void 0), visitedObjects.has(p.crossRegionCopyRules) || (p.crossRegionCopyRules, void 0), visitedObjects.has(p.deprecateRule) || (p.deprecateRule, void 0), visitedObjects.has(p.fastRestoreRule) || (p.fastRestoreRule, void 0), visitedObjects.has(p.retainRule) || (p.retainRule, void 0), visitedObjects.has(p.shareRules) || (p.shareRules, void 0), visitedObjects.has(p.tagsToAdd) || (p.tagsToAdd, void 0), visitedObjects.has(p.variableTags) || (p.variableTags, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_ShareRuleProperty(p) {
    }
    function aws_cdk_lib_aws_dms_CfnCertificateProps(p) {
    }
    function aws_cdk_lib_aws_dms_CfnCertificate(p) {
    }
    function aws_cdk_lib_aws_dms_CfnEndpointProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.docDbSettings) || (p.docDbSettings, void 0), visitedObjects.has(p.dynamoDbSettings) || (p.dynamoDbSettings, void 0), visitedObjects.has(p.elasticsearchSettings) || (p.elasticsearchSettings, void 0), visitedObjects.has(p.gcpMySqlSettings) || (p.gcpMySqlSettings, void 0), visitedObjects.has(p.ibmDb2Settings) || (p.ibmDb2Settings, void 0), visitedObjects.has(p.kafkaSettings) || (p.kafkaSettings, void 0), visitedObjects.has(p.kinesisSettings) || (p.kinesisSettings, void 0), visitedObjects.has(p.microsoftSqlServerSettings) || (p.microsoftSqlServerSettings, void 0), visitedObjects.has(p.mongoDbSettings) || (p.mongoDbSettings, void 0), visitedObjects.has(p.mySqlSettings) || (p.mySqlSettings, void 0), visitedObjects.has(p.neptuneSettings) || (p.neptuneSettings, void 0), visitedObjects.has(p.oracleSettings) || (p.oracleSettings, void 0), visitedObjects.has(p.postgreSqlSettings) || (p.postgreSqlSettings, void 0), visitedObjects.has(p.redisSettings) || (p.redisSettings, void 0), visitedObjects.has(p.redshiftSettings) || (p.redshiftSettings, void 0), visitedObjects.has(p.s3Settings) || (p.s3Settings, void 0), visitedObjects.has(p.sybaseSettings) || (p.sybaseSettings, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dms_CfnEndpoint(p) {
    }
    function aws_cdk_lib_aws_dms_CfnEndpoint_DocDbSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_dms_CfnEndpoint_DynamoDbSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_dms_CfnEndpoint_ElasticsearchSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_dms_CfnEndpoint_GcpMySQLSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_dms_CfnEndpoint_IbmDb2SettingsProperty(p) {
    }
    function aws_cdk_lib_aws_dms_CfnEndpoint_KafkaSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_dms_CfnEndpoint_KinesisSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_dms_CfnEndpoint_MicrosoftSqlServerSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_dms_CfnEndpoint_MongoDbSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_dms_CfnEndpoint_MySqlSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_dms_CfnEndpoint_NeptuneSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_dms_CfnEndpoint_OracleSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_dms_CfnEndpoint_PostgreSqlSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_dms_CfnEndpoint_RedisSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_dms_CfnEndpoint_RedshiftSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_dms_CfnEndpoint_S3SettingsProperty(p) {
    }
    function aws_cdk_lib_aws_dms_CfnEndpoint_SybaseSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_dms_CfnEventSubscriptionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dms_CfnEventSubscription(p) {
    }
    function aws_cdk_lib_aws_dms_CfnReplicationInstanceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dms_CfnReplicationInstance(p) {
    }
    function aws_cdk_lib_aws_dms_CfnReplicationSubnetGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dms_CfnReplicationSubnetGroup(p) {
    }
    function aws_cdk_lib_aws_dms_CfnReplicationTaskProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dms_CfnReplicationTask(p) {
    }
    function aws_cdk_lib_aws_docdb_DatabaseClusterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.instanceType) || (p.instanceType, void 0), visitedObjects.has(p.masterUser) || aws_cdk_lib_aws_docdb_Login(p.masterUser), visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.backup) || aws_cdk_lib_aws_docdb_BackupProps(p.backup), visitedObjects.has(p.cloudWatchLogsRetention) || (p.cloudWatchLogsRetention, void 0), visitedObjects.has(p.cloudWatchLogsRetentionRole) || (p.cloudWatchLogsRetentionRole, void 0), visitedObjects.has(p.kmsKey) || (p.kmsKey, void 0), visitedObjects.has(p.parameterGroup) || (p.parameterGroup, void 0), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), visitedObjects.has(p.securityGroup) || (p.securityGroup, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_docdb_DatabaseCluster(p) {
    }
    function aws_cdk_lib_aws_docdb_IDatabaseCluster(p) {
    }
    function aws_cdk_lib_aws_docdb_DatabaseClusterAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.securityGroup) || (p.securityGroup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_docdb_DatabaseSecretProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.encryptionKey) || (p.encryptionKey, void 0), visitedObjects.has(p.masterSecret) || (p.masterSecret, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_docdb_DatabaseSecret(p) {
    }
    function aws_cdk_lib_aws_docdb_Endpoint(p) {
    }
    function aws_cdk_lib_aws_docdb_IDatabaseInstance(p) {
    }
    function aws_cdk_lib_aws_docdb_DatabaseInstanceAttributes(p) {
    }
    function aws_cdk_lib_aws_docdb_DatabaseInstanceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cluster) || (p.cluster, void 0), visitedObjects.has(p.instanceType) || (p.instanceType, void 0), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_docdb_DatabaseInstance(p) {
    }
    function aws_cdk_lib_aws_docdb_IClusterParameterGroup(p) {
    }
    function aws_cdk_lib_aws_docdb_ClusterParameterGroupProps(p) {
    }
    function aws_cdk_lib_aws_docdb_ClusterParameterGroup(p) {
    }
    function aws_cdk_lib_aws_docdb_BackupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.retention) || (p.retention, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_docdb_Login(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.kmsKey) || (p.kmsKey, void 0), visitedObjects.has(p.password) || (p.password, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_docdb_RotationMultiUserOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.secret) || (p.secret, void 0), visitedObjects.has(p.automaticallyAfter) || (p.automaticallyAfter, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_docdb_CfnDBClusterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_docdb_CfnDBCluster(p) {
    }
    function aws_cdk_lib_aws_docdb_CfnDBClusterParameterGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_docdb_CfnDBClusterParameterGroup(p) {
    }
    function aws_cdk_lib_aws_docdb_CfnDBInstanceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_docdb_CfnDBInstance(p) {
    }
    function aws_cdk_lib_aws_docdb_CfnDBSubnetGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_docdb_CfnDBSubnetGroup(p) {
    }
    function aws_cdk_lib_aws_docdbelastic_CfnClusterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_docdbelastic_CfnCluster(p) {
    }
    function aws_cdk_lib_aws_dynamodb_CfnGlobalTableProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.attributeDefinitions) || (p.attributeDefinitions, void 0), visitedObjects.has(p.keySchema) || (p.keySchema, void 0), visitedObjects.has(p.replicas) || (p.replicas, void 0), visitedObjects.has(p.globalSecondaryIndexes) || (p.globalSecondaryIndexes, void 0), visitedObjects.has(p.localSecondaryIndexes) || (p.localSecondaryIndexes, void 0), visitedObjects.has(p.sseSpecification) || (p.sseSpecification, void 0), visitedObjects.has(p.streamSpecification) || (p.streamSpecification, void 0), visitedObjects.has(p.timeToLiveSpecification) || (p.timeToLiveSpecification, void 0), visitedObjects.has(p.writeProvisionedThroughputSettings) || (p.writeProvisionedThroughputSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dynamodb_CfnGlobalTable(p) {
    }
    function aws_cdk_lib_aws_dynamodb_CfnGlobalTable_AttributeDefinitionProperty(p) {
    }
    function aws_cdk_lib_aws_dynamodb_CfnGlobalTable_CapacityAutoScalingSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.targetTrackingScalingPolicyConfiguration) || (p.targetTrackingScalingPolicyConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dynamodb_CfnGlobalTable_ContributorInsightsSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_dynamodb_CfnGlobalTable_GlobalSecondaryIndexProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.keySchema) || (p.keySchema, void 0), visitedObjects.has(p.projection) || (p.projection, void 0), visitedObjects.has(p.writeProvisionedThroughputSettings) || (p.writeProvisionedThroughputSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dynamodb_CfnGlobalTable_KeySchemaProperty(p) {
    }
    function aws_cdk_lib_aws_dynamodb_CfnGlobalTable_KinesisStreamSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_dynamodb_CfnGlobalTable_LocalSecondaryIndexProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.keySchema) || (p.keySchema, void 0), visitedObjects.has(p.projection) || (p.projection, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dynamodb_CfnGlobalTable_PointInTimeRecoverySpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_dynamodb_CfnGlobalTable_ProjectionProperty(p) {
    }
    function aws_cdk_lib_aws_dynamodb_CfnGlobalTable_ReadProvisionedThroughputSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.readCapacityAutoScalingSettings) || (p.readCapacityAutoScalingSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dynamodb_CfnGlobalTable_ReplicaGlobalSecondaryIndexSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.contributorInsightsSpecification) || (p.contributorInsightsSpecification, void 0), visitedObjects.has(p.readProvisionedThroughputSettings) || (p.readProvisionedThroughputSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dynamodb_CfnGlobalTable_ReplicaSSESpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_dynamodb_CfnGlobalTable_ReplicaSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.contributorInsightsSpecification) || (p.contributorInsightsSpecification, void 0), visitedObjects.has(p.globalSecondaryIndexes) || (p.globalSecondaryIndexes, void 0), visitedObjects.has(p.kinesisStreamSpecification) || (p.kinesisStreamSpecification, void 0), visitedObjects.has(p.pointInTimeRecoverySpecification) || (p.pointInTimeRecoverySpecification, void 0), visitedObjects.has(p.readProvisionedThroughputSettings) || (p.readProvisionedThroughputSettings, void 0), visitedObjects.has(p.sseSpecification) || (p.sseSpecification, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dynamodb_CfnGlobalTable_SSESpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_dynamodb_CfnGlobalTable_StreamSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_dynamodb_CfnGlobalTable_TargetTrackingScalingPolicyConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_dynamodb_CfnGlobalTable_TimeToLiveSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_dynamodb_CfnGlobalTable_WriteProvisionedThroughputSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.writeCapacityAutoScalingSettings) || (p.writeCapacityAutoScalingSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dynamodb_CfnTableProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.keySchema) || (p.keySchema, void 0), visitedObjects.has(p.attributeDefinitions) || (p.attributeDefinitions, void 0), visitedObjects.has(p.contributorInsightsSpecification) || (p.contributorInsightsSpecification, void 0), visitedObjects.has(p.globalSecondaryIndexes) || (p.globalSecondaryIndexes, void 0), visitedObjects.has(p.importSourceSpecification) || (p.importSourceSpecification, void 0), visitedObjects.has(p.kinesisStreamSpecification) || (p.kinesisStreamSpecification, void 0), visitedObjects.has(p.localSecondaryIndexes) || (p.localSecondaryIndexes, void 0), visitedObjects.has(p.pointInTimeRecoverySpecification) || (p.pointInTimeRecoverySpecification, void 0), visitedObjects.has(p.provisionedThroughput) || (p.provisionedThroughput, void 0), visitedObjects.has(p.sseSpecification) || (p.sseSpecification, void 0), visitedObjects.has(p.streamSpecification) || (p.streamSpecification, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.timeToLiveSpecification) || (p.timeToLiveSpecification, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dynamodb_CfnTable(p) {
    }
    function aws_cdk_lib_aws_dynamodb_CfnTable_AttributeDefinitionProperty(p) {
    }
    function aws_cdk_lib_aws_dynamodb_CfnTable_ContributorInsightsSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_dynamodb_CfnTable_CsvProperty(p) {
    }
    function aws_cdk_lib_aws_dynamodb_CfnTable_GlobalSecondaryIndexProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.keySchema) || (p.keySchema, void 0), visitedObjects.has(p.projection) || (p.projection, void 0), visitedObjects.has(p.contributorInsightsSpecification) || (p.contributorInsightsSpecification, void 0), visitedObjects.has(p.provisionedThroughput) || (p.provisionedThroughput, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dynamodb_CfnTable_ImportSourceSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3BucketSource) || (p.s3BucketSource, void 0), visitedObjects.has(p.inputFormatOptions) || (p.inputFormatOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dynamodb_CfnTable_InputFormatOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.csv) || (p.csv, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dynamodb_CfnTable_KeySchemaProperty(p) {
    }
    function aws_cdk_lib_aws_dynamodb_CfnTable_KinesisStreamSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_dynamodb_CfnTable_LocalSecondaryIndexProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.keySchema) || (p.keySchema, void 0), visitedObjects.has(p.projection) || (p.projection, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dynamodb_CfnTable_PointInTimeRecoverySpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_dynamodb_CfnTable_ProjectionProperty(p) {
    }
    function aws_cdk_lib_aws_dynamodb_CfnTable_ProvisionedThroughputProperty(p) {
    }
    function aws_cdk_lib_aws_dynamodb_CfnTable_S3BucketSourceProperty(p) {
    }
    function aws_cdk_lib_aws_dynamodb_CfnTable_SSESpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_dynamodb_CfnTable_StreamSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_dynamodb_CfnTable_TimeToLiveSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_dynamodb_SystemErrorsForOperationsMetricOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.operations != null)
            for (const o of p.operations)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.period) || (p.period, void 0), visitedObjects.has(p.unit) || (p.unit, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dynamodb_OperationsMetricOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.operations != null)
            for (const o of p.operations)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.period) || (p.period, void 0), visitedObjects.has(p.unit) || (p.unit, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dynamodb_Operation(p) {
    }
    function aws_cdk_lib_aws_dynamodb_Attribute(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.type) || (p.type, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dynamodb_TableEncryption(p) {
    }
    function aws_cdk_lib_aws_dynamodb_SchemaOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.partitionKey) || aws_cdk_lib_aws_dynamodb_Attribute(p.partitionKey), visitedObjects.has(p.sortKey) || aws_cdk_lib_aws_dynamodb_Attribute(p.sortKey);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dynamodb_TableOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.billingMode) || (p.billingMode, void 0), visitedObjects.has(p.encryption) || (p.encryption, void 0), visitedObjects.has(p.encryptionKey) || (p.encryptionKey, void 0), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), visitedObjects.has(p.replicationTimeout) || (p.replicationTimeout, void 0), visitedObjects.has(p.stream) || (p.stream, void 0), visitedObjects.has(p.tableClass) || (p.tableClass, void 0), visitedObjects.has(p.partitionKey) || aws_cdk_lib_aws_dynamodb_Attribute(p.partitionKey), visitedObjects.has(p.sortKey) || aws_cdk_lib_aws_dynamodb_Attribute(p.sortKey);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dynamodb_TableProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.kinesisStream) || (p.kinesisStream, void 0), visitedObjects.has(p.billingMode) || (p.billingMode, void 0), visitedObjects.has(p.encryption) || (p.encryption, void 0), visitedObjects.has(p.encryptionKey) || (p.encryptionKey, void 0), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), visitedObjects.has(p.replicationTimeout) || (p.replicationTimeout, void 0), visitedObjects.has(p.stream) || (p.stream, void 0), visitedObjects.has(p.tableClass) || (p.tableClass, void 0), visitedObjects.has(p.partitionKey) || aws_cdk_lib_aws_dynamodb_Attribute(p.partitionKey), visitedObjects.has(p.sortKey) || aws_cdk_lib_aws_dynamodb_Attribute(p.sortKey);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dynamodb_SecondaryIndexProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.projectionType) || (p.projectionType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dynamodb_GlobalSecondaryIndexProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.projectionType) || (p.projectionType, void 0), visitedObjects.has(p.partitionKey) || aws_cdk_lib_aws_dynamodb_Attribute(p.partitionKey), visitedObjects.has(p.sortKey) || aws_cdk_lib_aws_dynamodb_Attribute(p.sortKey);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dynamodb_LocalSecondaryIndexProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sortKey) || aws_cdk_lib_aws_dynamodb_Attribute(p.sortKey), visitedObjects.has(p.projectionType) || (p.projectionType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dynamodb_ITable(p) {
    }
    function aws_cdk_lib_aws_dynamodb_TableAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.encryptionKey) || (p.encryptionKey, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_dynamodb_Table(p) {
    }
    function aws_cdk_lib_aws_dynamodb_AttributeType(p) {
    }
    function aws_cdk_lib_aws_dynamodb_BillingMode(p) {
    }
    function aws_cdk_lib_aws_dynamodb_ProjectionType(p) {
    }
    function aws_cdk_lib_aws_dynamodb_StreamViewType(p) {
    }
    function aws_cdk_lib_aws_dynamodb_TableClass(p) {
    }
    function aws_cdk_lib_aws_dynamodb_IScalableTableAttribute(p) {
    }
    function aws_cdk_lib_aws_dynamodb_EnableScalingProps(p) {
    }
    function aws_cdk_lib_aws_dynamodb_UtilizationScalingProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.scaleInCooldown) || (p.scaleInCooldown, void 0), visitedObjects.has(p.scaleOutCooldown) || (p.scaleOutCooldown, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_InstanceRequireImdsv2AspectProps(p) {
    }
    function aws_cdk_lib_aws_ec2_InstanceRequireImdsv2Aspect(p) {
    }
    function aws_cdk_lib_aws_ec2_LaunchTemplateRequireImdsv2AspectProps(p) {
    }
    function aws_cdk_lib_aws_ec2_LaunchTemplateRequireImdsv2Aspect(p) {
    }
    function aws_cdk_lib_aws_ec2_BastionHostLinuxProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.vpc) || (p.vpc, void 0), p.blockDevices != null)
            for (const o of p.blockDevices)
              visitedObjects.has(o) || aws_cdk_lib_aws_ec2_BlockDevice(o);
          visitedObjects.has(p.init) || (p.init, void 0), visitedObjects.has(p.initOptions) || aws_cdk_lib_aws_ec2_ApplyCloudFormationInitOptions(p.initOptions), visitedObjects.has(p.instanceType) || (p.instanceType, void 0), visitedObjects.has(p.machineImage) || (p.machineImage, void 0), visitedObjects.has(p.securityGroup) || (p.securityGroup, void 0), visitedObjects.has(p.subnetSelection) || aws_cdk_lib_aws_ec2_SubnetSelection(p.subnetSelection);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_BastionHostLinux(p) {
    }
    function aws_cdk_lib_aws_ec2_IConnectable(p) {
    }
    function aws_cdk_lib_aws_ec2_ConnectionsProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.defaultPort) || (p.defaultPort, void 0), visitedObjects.has(p.peer) || (p.peer, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_Connections(p) {
    }
    function aws_cdk_lib_aws_ec2_CloudFormationInit(p) {
    }
    function aws_cdk_lib_aws_ec2_InitConfig(p) {
    }
    function aws_cdk_lib_aws_ec2_ConfigSetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.configs != null)
            for (const o of Object.values(p.configs))
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_AttachInitOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.instanceRole) || (p.instanceRole, void 0), visitedObjects.has(p.platform) || (p.platform, void 0), visitedObjects.has(p.userData) || (p.userData, void 0), visitedObjects.has(p.signalResource) || (p.signalResource, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_InitServiceRestartHandle(p) {
    }
    function aws_cdk_lib_aws_ec2_InitElement(p) {
    }
    function aws_cdk_lib_aws_ec2_InitCommandOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.serviceRestartHandles != null)
            for (const o of p.serviceRestartHandles)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.waitAfterCompletion) || (p.waitAfterCompletion, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_InitCommandWaitDuration(p) {
    }
    function aws_cdk_lib_aws_ec2_InitCommand(p) {
    }
    function aws_cdk_lib_aws_ec2_InitFileOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.serviceRestartHandles != null)
            for (const o of p.serviceRestartHandles)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_InitFileAssetOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.serviceRestartHandles != null)
            for (const o of p.serviceRestartHandles)
              visitedObjects.has(o) || void 0;
          if (p.readers != null)
            for (const o of p.readers)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.assetHashType) || (p.assetHashType, void 0), visitedObjects.has(p.bundling) || aws_cdk_lib_BundlingOptions(p.bundling), visitedObjects.has(p.followSymlinks) || (p.followSymlinks, void 0), visitedObjects.has(p.ignoreMode) || (p.ignoreMode, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_InitFile(p) {
    }
    function aws_cdk_lib_aws_ec2_InitGroup(p) {
    }
    function aws_cdk_lib_aws_ec2_InitUserOptions(p) {
    }
    function aws_cdk_lib_aws_ec2_InitUser(p) {
    }
    function aws_cdk_lib_aws_ec2_LocationPackageOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.serviceRestartHandles != null)
            for (const o of p.serviceRestartHandles)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_NamedPackageOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.serviceRestartHandles != null)
            for (const o of p.serviceRestartHandles)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_InitPackage(p) {
    }
    function aws_cdk_lib_aws_ec2_InitServiceOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.serviceManager) || (p.serviceManager, void 0), visitedObjects.has(p.serviceRestartHandle) || (p.serviceRestartHandle, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_InitService(p) {
    }
    function aws_cdk_lib_aws_ec2_InitSourceOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.serviceRestartHandles != null)
            for (const o of p.serviceRestartHandles)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_InitSourceAssetOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.serviceRestartHandles != null)
            for (const o of p.serviceRestartHandles)
              visitedObjects.has(o) || void 0;
          if (p.readers != null)
            for (const o of p.readers)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.assetHashType) || (p.assetHashType, void 0), visitedObjects.has(p.bundling) || aws_cdk_lib_BundlingOptions(p.bundling), visitedObjects.has(p.followSymlinks) || (p.followSymlinks, void 0), visitedObjects.has(p.ignoreMode) || (p.ignoreMode, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_InitSource(p) {
    }
    function aws_cdk_lib_aws_ec2_ServiceManager(p) {
    }
    function aws_cdk_lib_aws_ec2_SystemdConfigFileOptions(p) {
    }
    function aws_cdk_lib_aws_ec2_InstanceClass(p) {
    }
    function aws_cdk_lib_aws_ec2_InstanceArchitecture(p) {
    }
    function aws_cdk_lib_aws_ec2_InstanceSize(p) {
    }
    function aws_cdk_lib_aws_ec2_InstanceType(p) {
    }
    function aws_cdk_lib_aws_ec2_IInstance(p) {
    }
    function aws_cdk_lib_aws_ec2_InstanceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.instanceType) || (p.instanceType, void 0), visitedObjects.has(p.machineImage) || (p.machineImage, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0), p.blockDevices != null)
            for (const o of p.blockDevices)
              visitedObjects.has(o) || aws_cdk_lib_aws_ec2_BlockDevice(o);
          visitedObjects.has(p.init) || (p.init, void 0), visitedObjects.has(p.initOptions) || aws_cdk_lib_aws_ec2_ApplyCloudFormationInitOptions(p.initOptions), visitedObjects.has(p.resourceSignalTimeout) || (p.resourceSignalTimeout, void 0), visitedObjects.has(p.role) || (p.role, void 0), visitedObjects.has(p.securityGroup) || (p.securityGroup, void 0), visitedObjects.has(p.userData) || (p.userData, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_Instance(p) {
    }
    function aws_cdk_lib_aws_ec2_ApplyCloudFormationInitOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CpuCredits(p) {
    }
    function aws_cdk_lib_aws_ec2_InstanceInitiatedShutdownBehavior(p) {
    }
    function aws_cdk_lib_aws_ec2_ILaunchTemplate(p) {
    }
    function aws_cdk_lib_aws_ec2_SpotInstanceInterruption(p) {
    }
    function aws_cdk_lib_aws_ec2_SpotRequestType(p) {
    }
    function aws_cdk_lib_aws_ec2_LaunchTemplateSpotOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.blockDuration) || (p.blockDuration, void 0), visitedObjects.has(p.interruptionBehavior) || (p.interruptionBehavior, void 0), visitedObjects.has(p.requestType) || (p.requestType, void 0), visitedObjects.has(p.validUntil) || (p.validUntil, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_LaunchTemplateHttpTokens(p) {
    }
    function aws_cdk_lib_aws_ec2_LaunchTemplateProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.blockDevices != null)
            for (const o of p.blockDevices)
              visitedObjects.has(o) || aws_cdk_lib_aws_ec2_BlockDevice(o);
          visitedObjects.has(p.cpuCredits) || (p.cpuCredits, void 0), visitedObjects.has(p.httpTokens) || (p.httpTokens, void 0), visitedObjects.has(p.instanceInitiatedShutdownBehavior) || (p.instanceInitiatedShutdownBehavior, void 0), visitedObjects.has(p.instanceType) || (p.instanceType, void 0), visitedObjects.has(p.machineImage) || (p.machineImage, void 0), visitedObjects.has(p.role) || (p.role, void 0), visitedObjects.has(p.securityGroup) || (p.securityGroup, void 0), visitedObjects.has(p.spotOptions) || aws_cdk_lib_aws_ec2_LaunchTemplateSpotOptions(p.spotOptions), visitedObjects.has(p.userData) || (p.userData, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_LaunchTemplateSpecialVersions(p) {
    }
    function aws_cdk_lib_aws_ec2_LaunchTemplateAttributes(p) {
    }
    function aws_cdk_lib_aws_ec2_LaunchTemplate(p) {
    }
    function aws_cdk_lib_aws_ec2_AmazonLinuxImageSsmParameterCommonOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cpuType) || (p.cpuType, void 0), visitedObjects.has(p.edition) || (p.edition, void 0), visitedObjects.has(p.userData) || (p.userData, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_AmazonLinuxImageSsmParameterBaseOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.userData) || (p.userData, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_AmazonLinuxImageSsmParameterBaseProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.userData) || (p.userData, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_AmazonLinuxImageSsmParameterBase(p) {
    }
    function aws_cdk_lib_aws_ec2_AmazonLinuxGeneration(p) {
    }
    function aws_cdk_lib_aws_ec2_IMachineImage(p) {
    }
    function aws_cdk_lib_aws_ec2_MachineImageConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.osType) || (p.osType, void 0), visitedObjects.has(p.userData) || (p.userData, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_OperatingSystemType(p) {
    }
    function aws_cdk_lib_aws_ec2_AmazonLinuxCpuType(p) {
    }
    function aws_cdk_lib_aws_ec2_AmazonLinuxEdition(p) {
    }
    function aws_cdk_lib_aws_ec2_AmazonLinuxVirt(p) {
    }
    function aws_cdk_lib_aws_ec2_AmazonLinuxStorage(p) {
    }
    function aws_cdk_lib_aws_ec2_AmazonLinux2Kernel(p) {
    }
    function aws_cdk_lib_aws_ec2_AmazonLinux2ImageSsmParameterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.kernel) || (p.kernel, void 0), visitedObjects.has(p.storage) || (p.storage, void 0), visitedObjects.has(p.virtualization) || (p.virtualization, void 0), visitedObjects.has(p.cpuType) || (p.cpuType, void 0), visitedObjects.has(p.edition) || (p.edition, void 0), visitedObjects.has(p.userData) || (p.userData, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_AmazonLinux2ImageSsmParameter(p) {
    }
    function aws_cdk_lib_aws_ec2_MachineImage(p) {
    }
    function aws_cdk_lib_aws_ec2_GenericSSMParameterImage(p) {
    }
    function aws_cdk_lib_aws_ec2_SsmParameterImageOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.os) || (p.os, void 0), visitedObjects.has(p.userData) || (p.userData, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_WindowsImageProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.userData) || (p.userData, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_WindowsImage(p) {
    }
    function aws_cdk_lib_aws_ec2_AmazonLinuxImageProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cpuType) || (p.cpuType, void 0), visitedObjects.has(p.edition) || (p.edition, void 0), visitedObjects.has(p.generation) || (p.generation, void 0), visitedObjects.has(p.kernel) || (p.kernel, void 0), visitedObjects.has(p.storage) || (p.storage, void 0), visitedObjects.has(p.userData) || (p.userData, void 0), visitedObjects.has(p.virtualization) || (p.virtualization, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_AmazonLinuxImage(p) {
    }
    function aws_cdk_lib_aws_ec2_AmazonLinuxKernel(p) {
    }
    function aws_cdk_lib_aws_ec2_GenericLinuxImageProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.userData) || (p.userData, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_GenericWindowsImageProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.userData) || (p.userData, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_GenericLinuxImage(p) {
    }
    function aws_cdk_lib_aws_ec2_GenericWindowsImage(p) {
    }
    function aws_cdk_lib_aws_ec2_LookupMachineImage(p) {
    }
    function aws_cdk_lib_aws_ec2_LookupMachineImageProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.userData) || (p.userData, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_AmazonLinux2022Kernel(p) {
    }
    function aws_cdk_lib_aws_ec2_AmazonLinux2022ImageSsmParameterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.kernel) || (p.kernel, void 0), visitedObjects.has(p.cpuType) || (p.cpuType, void 0), visitedObjects.has(p.edition) || (p.edition, void 0), visitedObjects.has(p.userData) || (p.userData, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_AmazonLinux2022ImageSsmParameter(p) {
    }
    function aws_cdk_lib_aws_ec2_AmazonLinux2023Kernel(p) {
    }
    function aws_cdk_lib_aws_ec2_AmazonLinux2023ImageSsmParameterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.kernel) || (p.kernel, void 0), visitedObjects.has(p.cpuType) || (p.cpuType, void 0), visitedObjects.has(p.edition) || (p.edition, void 0), visitedObjects.has(p.userData) || (p.userData, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_AmazonLinux2023ImageSsmParameter(p) {
    }
    function aws_cdk_lib_aws_ec2_NatTrafficDirection(p) {
    }
    function aws_cdk_lib_aws_ec2_GatewayConfig(p) {
    }
    function aws_cdk_lib_aws_ec2_NatProvider(p) {
    }
    function aws_cdk_lib_aws_ec2_ConfigureNatOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.natSubnets != null)
            for (const o of p.natSubnets)
              visitedObjects.has(o) || void 0;
          if (p.privateSubnets != null)
            for (const o of p.privateSubnets)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_NatGatewayProps(p) {
    }
    function aws_cdk_lib_aws_ec2_NatInstanceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.instanceType) || (p.instanceType, void 0), visitedObjects.has(p.defaultAllowedTraffic) || (p.defaultAllowedTraffic, void 0), visitedObjects.has(p.machineImage) || (p.machineImage, void 0), visitedObjects.has(p.securityGroup) || (p.securityGroup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_NatInstanceProvider(p) {
    }
    function aws_cdk_lib_aws_ec2_NatInstanceImage(p) {
    }
    function aws_cdk_lib_aws_ec2_INetworkAcl(p) {
    }
    function aws_cdk_lib_aws_ec2_NetworkAclProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.subnetSelection) || aws_cdk_lib_aws_ec2_SubnetSelection(p.subnetSelection);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_NetworkAcl(p) {
    }
    function aws_cdk_lib_aws_ec2_Action(p) {
    }
    function aws_cdk_lib_aws_ec2_INetworkAclEntry(p) {
    }
    function aws_cdk_lib_aws_ec2_TrafficDirection(p) {
    }
    function aws_cdk_lib_aws_ec2_CommonNetworkAclEntryOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cidr) || (p.cidr, void 0), visitedObjects.has(p.traffic) || (p.traffic, void 0), visitedObjects.has(p.direction) || (p.direction, void 0), visitedObjects.has(p.ruleAction) || (p.ruleAction, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_NetworkAclEntryProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.networkAcl) || (p.networkAcl, void 0), visitedObjects.has(p.cidr) || (p.cidr, void 0), visitedObjects.has(p.traffic) || (p.traffic, void 0), visitedObjects.has(p.direction) || (p.direction, void 0), visitedObjects.has(p.ruleAction) || (p.ruleAction, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_NetworkAclEntry(p) {
    }
    function aws_cdk_lib_aws_ec2_ISubnetNetworkAclAssociation(p) {
    }
    function aws_cdk_lib_aws_ec2_SubnetNetworkAclAssociationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.networkAcl) || (p.networkAcl, void 0), visitedObjects.has(p.subnet) || (p.subnet, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_SubnetNetworkAclAssociation(p) {
    }
    function aws_cdk_lib_aws_ec2_AclCidr(p) {
    }
    function aws_cdk_lib_aws_ec2_AclCidrConfig(p) {
    }
    function aws_cdk_lib_aws_ec2_AclTraffic(p) {
    }
    function aws_cdk_lib_aws_ec2_AclTrafficConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.icmp) || (p.icmp, void 0), visitedObjects.has(p.portRange) || (p.portRange, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_AclIcmp(p) {
    }
    function aws_cdk_lib_aws_ec2_AclPortRange(p) {
    }
    function aws_cdk_lib_aws_ec2_Protocol(p) {
    }
    function aws_cdk_lib_aws_ec2_PortProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.protocol) || (p.protocol, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_Port(p) {
    }
    function aws_cdk_lib_aws_ec2_IPrefixList(p) {
    }
    function aws_cdk_lib_aws_ec2_AddressFamily(p) {
    }
    function aws_cdk_lib_aws_ec2_PrefixListOptions(p) {
    }
    function aws_cdk_lib_aws_ec2_PrefixListProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.addressFamily) || (p.addressFamily, void 0), p.entries != null)
            for (const o of p.entries)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_PrefixList(p) {
    }
    function aws_cdk_lib_aws_ec2_ISecurityGroup(p) {
    }
    function aws_cdk_lib_aws_ec2_RuleScope(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.scope) || (p.scope, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_SecurityGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_SecurityGroupImportOptions(p) {
    }
    function aws_cdk_lib_aws_ec2_SecurityGroup(p) {
    }
    function aws_cdk_lib_aws_ec2_ConnectionRule(p) {
    }
    function aws_cdk_lib_aws_ec2_SubnetFilter(p) {
    }
    function aws_cdk_lib_aws_ec2_IPeer(p) {
    }
    function aws_cdk_lib_aws_ec2_Peer(p) {
    }
    function aws_cdk_lib_aws_ec2_BlockDevice(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.volume) || (p.volume, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_EbsDeviceOptionsBase(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.volumeType) || (p.volumeType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_EbsDeviceOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.kmsKey) || (p.kmsKey, void 0), visitedObjects.has(p.volumeType) || (p.volumeType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_EbsDeviceSnapshotOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.volumeType) || (p.volumeType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_EbsDeviceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.volumeType) || (p.volumeType, void 0), visitedObjects.has(p.kmsKey) || (p.kmsKey, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_BlockDeviceVolume(p) {
    }
    function aws_cdk_lib_aws_ec2_EbsDeviceVolumeType(p) {
    }
    function aws_cdk_lib_aws_ec2_IVolume(p) {
    }
    function aws_cdk_lib_aws_ec2_VolumeProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.encryptionKey) || (p.encryptionKey, void 0), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), visitedObjects.has(p.size) || (p.size, void 0), visitedObjects.has(p.volumeType) || (p.volumeType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_VolumeAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.encryptionKey) || (p.encryptionKey, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_Volume(p) {
    }
    function aws_cdk_lib_aws_ec2_ISubnet(p) {
    }
    function aws_cdk_lib_aws_ec2_IRouteTable(p) {
    }
    function aws_cdk_lib_aws_ec2_IVpc(p) {
    }
    function aws_cdk_lib_aws_ec2_SubnetType(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          const ns = require_vpc2();
          if (Object.values(ns.SubnetType).filter((x) => x === p).length > 1)
            return;
          p === ns.SubnetType.PRIVATE_WITH_NAT && print("aws-cdk-lib.aws_ec2.SubnetType#PRIVATE_WITH_NAT", "use `PRIVATE_WITH_EGRESS`");
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_SubnetSelection(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.subnetFilters != null)
            for (const o of p.subnetFilters)
              visitedObjects.has(o) || void 0;
          if (p.subnets != null)
            for (const o of p.subnets)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.subnetType) || aws_cdk_lib_aws_ec2_SubnetType(p.subnetType);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_SelectedSubnets(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.subnets != null)
            for (const o of p.subnets)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_VpcAttributes(p) {
    }
    function aws_cdk_lib_aws_ec2_SubnetAttributes(p) {
    }
    function aws_cdk_lib_aws_ec2_VpcProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if ("cidr" in p && print("aws-cdk-lib.aws_ec2.VpcProps#cidr", "Use ipAddresses instead"), visitedObjects.has(p.defaultInstanceTenancy) || (p.defaultInstanceTenancy, void 0), p.flowLogs != null)
            for (const o of Object.values(p.flowLogs))
              visitedObjects.has(o) || aws_cdk_lib_aws_ec2_FlowLogOptions(o);
          if (p.gatewayEndpoints != null)
            for (const o of Object.values(p.gatewayEndpoints))
              visitedObjects.has(o) || aws_cdk_lib_aws_ec2_GatewayVpcEndpointOptions(o);
          if (visitedObjects.has(p.ipAddresses) || (p.ipAddresses, void 0), visitedObjects.has(p.natGatewayProvider) || (p.natGatewayProvider, void 0), visitedObjects.has(p.natGatewaySubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.natGatewaySubnets), p.subnetConfiguration != null)
            for (const o of p.subnetConfiguration)
              visitedObjects.has(o) || aws_cdk_lib_aws_ec2_SubnetConfiguration(o);
          if (p.vpnConnections != null)
            for (const o of Object.values(p.vpnConnections))
              visitedObjects.has(o) || aws_cdk_lib_aws_ec2_VpnConnectionOptions(o);
          if (p.vpnRoutePropagation != null)
            for (const o of p.vpnRoutePropagation)
              visitedObjects.has(o) || aws_cdk_lib_aws_ec2_SubnetSelection(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_DefaultInstanceTenancy(p) {
    }
    function aws_cdk_lib_aws_ec2_SubnetConfiguration(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.subnetType) || aws_cdk_lib_aws_ec2_SubnetType(p.subnetType);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_Vpc(p) {
    }
    function aws_cdk_lib_aws_ec2_SubnetProps(p) {
    }
    function aws_cdk_lib_aws_ec2_Subnet(p) {
    }
    function aws_cdk_lib_aws_ec2_AddRouteOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.routerType) || (p.routerType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_RouterType(p) {
    }
    function aws_cdk_lib_aws_ec2_PublicSubnetProps(p) {
    }
    function aws_cdk_lib_aws_ec2_IPublicSubnet(p) {
    }
    function aws_cdk_lib_aws_ec2_PublicSubnetAttributes(p) {
    }
    function aws_cdk_lib_aws_ec2_PublicSubnet(p) {
    }
    function aws_cdk_lib_aws_ec2_PrivateSubnetProps(p) {
    }
    function aws_cdk_lib_aws_ec2_IPrivateSubnet(p) {
    }
    function aws_cdk_lib_aws_ec2_PrivateSubnetAttributes(p) {
    }
    function aws_cdk_lib_aws_ec2_PrivateSubnet(p) {
    }
    function aws_cdk_lib_aws_ec2_VpcLookupOptions(p) {
    }
    function aws_cdk_lib_aws_ec2_IVpnConnection(p) {
    }
    function aws_cdk_lib_aws_ec2_IVpnGateway(p) {
    }
    function aws_cdk_lib_aws_ec2_VpnTunnelOption(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          "preSharedKey" in p && print("aws-cdk-lib.aws_ec2.VpnTunnelOption#preSharedKey", "Use `preSharedKeySecret` instead"), visitedObjects.has(p.preSharedKeySecret) || (p.preSharedKeySecret, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_VpnConnectionOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tunnelOptions != null)
            for (const o of p.tunnelOptions)
              visitedObjects.has(o) || aws_cdk_lib_aws_ec2_VpnTunnelOption(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_VpnGatewayProps(p) {
    }
    function aws_cdk_lib_aws_ec2_EnableVpnGatewayOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.vpnRoutePropagation != null)
            for (const o of p.vpnRoutePropagation)
              visitedObjects.has(o) || aws_cdk_lib_aws_ec2_SubnetSelection(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_VpnConnectionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.vpc) || (p.vpc, void 0), p.tunnelOptions != null)
            for (const o of p.tunnelOptions)
              visitedObjects.has(o) || aws_cdk_lib_aws_ec2_VpnTunnelOption(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_VpnConnectionType(p) {
    }
    function aws_cdk_lib_aws_ec2_VpnGateway(p) {
    }
    function aws_cdk_lib_aws_ec2_VpnConnectionAttributes(p) {
    }
    function aws_cdk_lib_aws_ec2_VpnConnectionBase(p) {
    }
    function aws_cdk_lib_aws_ec2_VpnConnection(p) {
    }
    function aws_cdk_lib_aws_ec2_IVpcEndpoint(p) {
    }
    function aws_cdk_lib_aws_ec2_VpcEndpoint(p) {
    }
    function aws_cdk_lib_aws_ec2_IGatewayVpcEndpoint(p) {
    }
    function aws_cdk_lib_aws_ec2_VpcEndpointType(p) {
    }
    function aws_cdk_lib_aws_ec2_IGatewayVpcEndpointService(p) {
    }
    function aws_cdk_lib_aws_ec2_GatewayVpcEndpointAwsService(p) {
    }
    function aws_cdk_lib_aws_ec2_GatewayVpcEndpointOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.service) || (p.service, void 0), p.subnets != null)
            for (const o of p.subnets)
              visitedObjects.has(o) || aws_cdk_lib_aws_ec2_SubnetSelection(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_GatewayVpcEndpointProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.service) || (p.service, void 0), p.subnets != null)
            for (const o of p.subnets)
              visitedObjects.has(o) || aws_cdk_lib_aws_ec2_SubnetSelection(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_GatewayVpcEndpoint(p) {
    }
    function aws_cdk_lib_aws_ec2_IInterfaceVpcEndpointService(p) {
    }
    function aws_cdk_lib_aws_ec2_InterfaceVpcEndpointService(p) {
    }
    function aws_cdk_lib_aws_ec2_InterfaceVpcEndpointAwsService(p) {
    }
    function aws_cdk_lib_aws_ec2_InterfaceVpcEndpointOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.service) || (p.service, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.subnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.subnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_InterfaceVpcEndpointProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.service) || (p.service, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.subnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.subnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_IInterfaceVpcEndpoint(p) {
    }
    function aws_cdk_lib_aws_ec2_InterfaceVpcEndpoint(p) {
    }
    function aws_cdk_lib_aws_ec2_InterfaceVpcEndpointAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_IVpcEndpointServiceLoadBalancer(p) {
    }
    function aws_cdk_lib_aws_ec2_IVpcEndpointService(p) {
    }
    function aws_cdk_lib_aws_ec2_VpcEndpointService(p) {
    }
    function aws_cdk_lib_aws_ec2_VpcEndpointServiceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.vpcEndpointServiceLoadBalancers != null)
            for (const o of p.vpcEndpointServiceLoadBalancers)
              visitedObjects.has(o) || void 0;
          if (p.allowedPrincipals != null)
            for (const o of p.allowedPrincipals)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_LinuxUserDataOptions(p) {
    }
    function aws_cdk_lib_aws_ec2_WindowsUserDataOptions(p) {
    }
    function aws_cdk_lib_aws_ec2_S3DownloadOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bucket) || (p.bucket, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_ExecuteFileOptions(p) {
    }
    function aws_cdk_lib_aws_ec2_UserData(p) {
    }
    function aws_cdk_lib_aws_ec2_MultipartBodyOptions(p) {
    }
    function aws_cdk_lib_aws_ec2_MultipartBody(p) {
    }
    function aws_cdk_lib_aws_ec2_MultipartUserDataOptions(p) {
    }
    function aws_cdk_lib_aws_ec2_MultipartUserData(p) {
    }
    function aws_cdk_lib_aws_ec2_WindowsVersion(p) {
    }
    function aws_cdk_lib_aws_ec2_IFlowLog(p) {
    }
    function aws_cdk_lib_aws_ec2_FlowLogTrafficType(p) {
    }
    function aws_cdk_lib_aws_ec2_FlowLogDestinationType(p) {
    }
    function aws_cdk_lib_aws_ec2_FlowLogResourceType(p) {
    }
    function aws_cdk_lib_aws_ec2_FlowLogFileFormat(p) {
    }
    function aws_cdk_lib_aws_ec2_S3DestinationOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fileFormat) || (p.fileFormat, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_DestinationOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fileFormat) || (p.fileFormat, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_FlowLogDestination(p) {
    }
    function aws_cdk_lib_aws_ec2_FlowLogDestinationConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.logDestinationType) || (p.logDestinationType, void 0), visitedObjects.has(p.destinationOptions) || aws_cdk_lib_aws_ec2_DestinationOptions(p.destinationOptions), visitedObjects.has(p.iamRole) || (p.iamRole, void 0), visitedObjects.has(p.logGroup) || (p.logGroup, void 0), visitedObjects.has(p.s3Bucket) || (p.s3Bucket, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_FlowLogMaxAggregationInterval(p) {
    }
    function aws_cdk_lib_aws_ec2_LogFormat(p) {
    }
    function aws_cdk_lib_aws_ec2_FlowLogOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.destination) || (p.destination, void 0), p.logFormat != null)
            for (const o of p.logFormat)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.maxAggregationInterval) || (p.maxAggregationInterval, void 0), visitedObjects.has(p.trafficType) || (p.trafficType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_FlowLogProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.resourceType) || (p.resourceType, void 0), visitedObjects.has(p.destination) || (p.destination, void 0), p.logFormat != null)
            for (const o of p.logFormat)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.maxAggregationInterval) || (p.maxAggregationInterval, void 0), visitedObjects.has(p.trafficType) || (p.trafficType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_FlowLog(p) {
    }
    function aws_cdk_lib_aws_ec2_IClientVpnEndpoint(p) {
    }
    function aws_cdk_lib_aws_ec2_IClientVpnConnectionHandler(p) {
    }
    function aws_cdk_lib_aws_ec2_TransportProtocol(p) {
    }
    function aws_cdk_lib_aws_ec2_VpnPort(p) {
    }
    function aws_cdk_lib_aws_ec2_ClientVpnEndpointOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.clientConnectionHandler) || (p.clientConnectionHandler, void 0), visitedObjects.has(p.logGroup) || (p.logGroup, void 0), visitedObjects.has(p.logStream) || (p.logStream, void 0), visitedObjects.has(p.port) || (p.port, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.sessionTimeout) || (p.sessionTimeout, void 0), visitedObjects.has(p.transportProtocol) || (p.transportProtocol, void 0), visitedObjects.has(p.userBasedAuthentication) || (p.userBasedAuthentication, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_ClientVpnSessionTimeout(p) {
    }
    function aws_cdk_lib_aws_ec2_ClientVpnUserBasedAuthentication(p) {
    }
    function aws_cdk_lib_aws_ec2_ClientVpnEndpointProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.clientConnectionHandler) || (p.clientConnectionHandler, void 0), visitedObjects.has(p.logGroup) || (p.logGroup, void 0), visitedObjects.has(p.logStream) || (p.logStream, void 0), visitedObjects.has(p.port) || (p.port, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.sessionTimeout) || (p.sessionTimeout, void 0), visitedObjects.has(p.transportProtocol) || (p.transportProtocol, void 0), visitedObjects.has(p.userBasedAuthentication) || (p.userBasedAuthentication, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_ClientVpnEndpointAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_ClientVpnEndpoint(p) {
    }
    function aws_cdk_lib_aws_ec2_ClientVpnAuthorizationRuleOptions(p) {
    }
    function aws_cdk_lib_aws_ec2_ClientVpnAuthorizationRuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.clientVpnEndpoint) || (p.clientVpnEndpoint, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_ClientVpnAuthorizationRule(p) {
    }
    function aws_cdk_lib_aws_ec2_ClientVpnRouteOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.target) || (p.target, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_ClientVpnRouteTarget(p) {
    }
    function aws_cdk_lib_aws_ec2_ClientVpnRouteProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.clientVpnEndpoint) || (p.clientVpnEndpoint, void 0), visitedObjects.has(p.target) || (p.target, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_ClientVpnRoute(p) {
    }
    function aws_cdk_lib_aws_ec2_IpAddresses(p) {
    }
    function aws_cdk_lib_aws_ec2_IIpAddresses(p) {
    }
    function aws_cdk_lib_aws_ec2_VpcIpamOptions(p) {
    }
    function aws_cdk_lib_aws_ec2_RequestedSubnet(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.configuration) || aws_cdk_lib_aws_ec2_SubnetConfiguration(p.configuration);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_AllocateCidrRequest(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.requestedSubnets != null)
            for (const o of p.requestedSubnets)
              visitedObjects.has(o) || aws_cdk_lib_aws_ec2_RequestedSubnet(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_SubnetIpamOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.allocatedSubnets != null)
            for (const o of p.allocatedSubnets)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_AllocatedSubnet(p) {
    }
    function aws_cdk_lib_aws_ec2_AwsIpamProps(p) {
    }
    function aws_cdk_lib_aws_ec2_IPlacementGroup(p) {
    }
    function aws_cdk_lib_aws_ec2_PlacementGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.spreadLevel) || (p.spreadLevel, void 0), visitedObjects.has(p.strategy) || (p.strategy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_PlacementGroupSpreadLevel(p) {
    }
    function aws_cdk_lib_aws_ec2_PlacementGroupStrategy(p) {
    }
    function aws_cdk_lib_aws_ec2_PlacementGroup(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnCapacityReservationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tagSpecifications) || (p.tagSpecifications, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnCapacityReservation(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnCapacityReservation_TagSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnCapacityReservationFleetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.instanceTypeSpecifications) || (p.instanceTypeSpecifications, void 0), visitedObjects.has(p.tagSpecifications) || (p.tagSpecifications, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnCapacityReservationFleet(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnCapacityReservationFleet_InstanceTypeSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnCapacityReservationFleet_TagSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnCarrierGatewayProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnCarrierGateway(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnClientVpnAuthorizationRuleProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnClientVpnAuthorizationRule(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnClientVpnEndpointProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.authenticationOptions) || (p.authenticationOptions, void 0), visitedObjects.has(p.connectionLogOptions) || (p.connectionLogOptions, void 0), visitedObjects.has(p.clientConnectOptions) || (p.clientConnectOptions, void 0), visitedObjects.has(p.clientLoginBannerOptions) || (p.clientLoginBannerOptions, void 0), visitedObjects.has(p.tagSpecifications) || (p.tagSpecifications, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnClientVpnEndpoint(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnClientVpnEndpoint_CertificateAuthenticationRequestProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnClientVpnEndpoint_ClientAuthenticationRequestProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.activeDirectory) || (p.activeDirectory, void 0), visitedObjects.has(p.federatedAuthentication) || (p.federatedAuthentication, void 0), visitedObjects.has(p.mutualAuthentication) || (p.mutualAuthentication, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnClientVpnEndpoint_ClientConnectOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnClientVpnEndpoint_ClientLoginBannerOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnClientVpnEndpoint_ConnectionLogOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnClientVpnEndpoint_DirectoryServiceAuthenticationRequestProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnClientVpnEndpoint_FederatedAuthenticationRequestProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnClientVpnEndpoint_TagSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnClientVpnRouteProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnClientVpnRoute(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnClientVpnTargetNetworkAssociationProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnClientVpnTargetNetworkAssociation(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnCustomerGatewayProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnCustomerGateway(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnDHCPOptionsProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnDHCPOptions(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnEC2FleetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.launchTemplateConfigs) || (p.launchTemplateConfigs, void 0), visitedObjects.has(p.targetCapacitySpecification) || (p.targetCapacitySpecification, void 0), visitedObjects.has(p.onDemandOptions) || (p.onDemandOptions, void 0), visitedObjects.has(p.spotOptions) || (p.spotOptions, void 0), visitedObjects.has(p.tagSpecifications) || (p.tagSpecifications, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnEC2Fleet(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnEC2Fleet_AcceleratorCountRequestProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnEC2Fleet_AcceleratorTotalMemoryMiBRequestProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnEC2Fleet_BaselineEbsBandwidthMbpsRequestProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnEC2Fleet_CapacityRebalanceProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnEC2Fleet_CapacityReservationOptionsRequestProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnEC2Fleet_FleetLaunchTemplateConfigRequestProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.launchTemplateSpecification) || (p.launchTemplateSpecification, void 0), visitedObjects.has(p.overrides) || (p.overrides, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnEC2Fleet_FleetLaunchTemplateOverridesRequestProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.instanceRequirements) || (p.instanceRequirements, void 0), visitedObjects.has(p.placement) || (p.placement, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnEC2Fleet_FleetLaunchTemplateSpecificationRequestProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnEC2Fleet_InstanceRequirementsRequestProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.acceleratorCount) || (p.acceleratorCount, void 0), visitedObjects.has(p.acceleratorTotalMemoryMiB) || (p.acceleratorTotalMemoryMiB, void 0), visitedObjects.has(p.baselineEbsBandwidthMbps) || (p.baselineEbsBandwidthMbps, void 0), visitedObjects.has(p.memoryGiBPerVCpu) || (p.memoryGiBPerVCpu, void 0), visitedObjects.has(p.memoryMiB) || (p.memoryMiB, void 0), visitedObjects.has(p.networkBandwidthGbps) || (p.networkBandwidthGbps, void 0), visitedObjects.has(p.networkInterfaceCount) || (p.networkInterfaceCount, void 0), visitedObjects.has(p.totalLocalStorageGb) || (p.totalLocalStorageGb, void 0), visitedObjects.has(p.vCpuCount) || (p.vCpuCount, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnEC2Fleet_MaintenanceStrategiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.capacityRebalance) || (p.capacityRebalance, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnEC2Fleet_MemoryGiBPerVCpuRequestProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnEC2Fleet_MemoryMiBRequestProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnEC2Fleet_NetworkBandwidthGbpsRequestProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnEC2Fleet_NetworkInterfaceCountRequestProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnEC2Fleet_OnDemandOptionsRequestProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.capacityReservationOptions) || (p.capacityReservationOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnEC2Fleet_PlacementProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnEC2Fleet_SpotOptionsRequestProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.maintenanceStrategies) || (p.maintenanceStrategies, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnEC2Fleet_TagSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnEC2Fleet_TargetCapacitySpecificationRequestProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnEC2Fleet_TotalLocalStorageGBRequestProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnEC2Fleet_VCpuCountRangeRequestProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnEIPProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnEIP(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnEIPAssociationProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnEIPAssociation(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnEgressOnlyInternetGatewayProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnEgressOnlyInternetGateway(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnEnclaveCertificateIamRoleAssociationProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnEnclaveCertificateIamRoleAssociation(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnFlowLogProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnFlowLog(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnFlowLog_DestinationOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnGatewayRouteTableAssociationProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnGatewayRouteTableAssociation(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnHostProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnHost(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnIPAMProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.operatingRegions) || (p.operatingRegions, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnIPAM(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnIPAM_IpamOperatingRegionProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnIPAMAllocationProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnIPAMAllocation(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnIPAMPoolProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.allocationResourceTags) || (p.allocationResourceTags, void 0), visitedObjects.has(p.provisionedCidrs) || (p.provisionedCidrs, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnIPAMPool(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnIPAMPool_ProvisionedCidrProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnIPAMPoolCidrProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnIPAMPoolCidr(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnIPAMResourceDiscoveryProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.operatingRegions) || (p.operatingRegions, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnIPAMResourceDiscovery(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnIPAMResourceDiscovery_IpamOperatingRegionProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnIPAMResourceDiscoveryAssociationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnIPAMResourceDiscoveryAssociation(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnIPAMScopeProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnIPAMScope(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnInstanceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.blockDeviceMappings) || (p.blockDeviceMappings, void 0), visitedObjects.has(p.cpuOptions) || (p.cpuOptions, void 0), visitedObjects.has(p.creditSpecification) || (p.creditSpecification, void 0), visitedObjects.has(p.elasticGpuSpecifications) || (p.elasticGpuSpecifications, void 0), visitedObjects.has(p.elasticInferenceAccelerators) || (p.elasticInferenceAccelerators, void 0), visitedObjects.has(p.enclaveOptions) || (p.enclaveOptions, void 0), visitedObjects.has(p.hibernationOptions) || (p.hibernationOptions, void 0), visitedObjects.has(p.ipv6Addresses) || (p.ipv6Addresses, void 0), visitedObjects.has(p.launchTemplate) || (p.launchTemplate, void 0), visitedObjects.has(p.licenseSpecifications) || (p.licenseSpecifications, void 0), visitedObjects.has(p.networkInterfaces) || (p.networkInterfaces, void 0), visitedObjects.has(p.privateDnsNameOptions) || (p.privateDnsNameOptions, void 0), visitedObjects.has(p.ssmAssociations) || (p.ssmAssociations, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.volumes) || (p.volumes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnInstance(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnInstance_AssociationParameterProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnInstance_BlockDeviceMappingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ebs) || (p.ebs, void 0), visitedObjects.has(p.noDevice) || (p.noDevice, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnInstance_CpuOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnInstance_CreditSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnInstance_EbsProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnInstance_ElasticGpuSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnInstance_ElasticInferenceAcceleratorProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnInstance_EnclaveOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnInstance_HibernationOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnInstance_InstanceIpv6AddressProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnInstance_LaunchTemplateSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnInstance_LicenseSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnInstance_NetworkInterfaceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ipv6Addresses) || (p.ipv6Addresses, void 0), visitedObjects.has(p.privateIpAddresses) || (p.privateIpAddresses, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnInstance_NoDeviceProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnInstance_PrivateDnsNameOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnInstance_PrivateIpAddressSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnInstance_SsmAssociationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.associationParameters) || (p.associationParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnInstance_VolumeProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnInternetGatewayProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnInternetGateway(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnKeyPairProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnKeyPair(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplateProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.launchTemplateData) || (p.launchTemplateData, void 0), visitedObjects.has(p.tagSpecifications) || (p.tagSpecifications, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_AcceleratorCountProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_AcceleratorTotalMemoryMiBProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_BaselineEbsBandwidthMbpsProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_BlockDeviceMappingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ebs) || (p.ebs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_CapacityReservationSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.capacityReservationTarget) || (p.capacityReservationTarget, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_CapacityReservationTargetProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_CpuOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_CreditSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_EbsProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_ElasticGpuSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_EnclaveOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_HibernationOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_IamInstanceProfileProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_InstanceMarketOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.spotOptions) || (p.spotOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_InstanceRequirementsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.acceleratorCount) || (p.acceleratorCount, void 0), visitedObjects.has(p.acceleratorTotalMemoryMiB) || (p.acceleratorTotalMemoryMiB, void 0), visitedObjects.has(p.baselineEbsBandwidthMbps) || (p.baselineEbsBandwidthMbps, void 0), visitedObjects.has(p.memoryGiBPerVCpu) || (p.memoryGiBPerVCpu, void 0), visitedObjects.has(p.memoryMiB) || (p.memoryMiB, void 0), visitedObjects.has(p.networkBandwidthGbps) || (p.networkBandwidthGbps, void 0), visitedObjects.has(p.networkInterfaceCount) || (p.networkInterfaceCount, void 0), visitedObjects.has(p.totalLocalStorageGb) || (p.totalLocalStorageGb, void 0), visitedObjects.has(p.vCpuCount) || (p.vCpuCount, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_Ipv4PrefixSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_Ipv6AddProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_Ipv6PrefixSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_LaunchTemplateDataProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.blockDeviceMappings) || (p.blockDeviceMappings, void 0), visitedObjects.has(p.capacityReservationSpecification) || (p.capacityReservationSpecification, void 0), visitedObjects.has(p.cpuOptions) || (p.cpuOptions, void 0), visitedObjects.has(p.creditSpecification) || (p.creditSpecification, void 0), visitedObjects.has(p.elasticGpuSpecifications) || (p.elasticGpuSpecifications, void 0), visitedObjects.has(p.elasticInferenceAccelerators) || (p.elasticInferenceAccelerators, void 0), visitedObjects.has(p.enclaveOptions) || (p.enclaveOptions, void 0), visitedObjects.has(p.hibernationOptions) || (p.hibernationOptions, void 0), visitedObjects.has(p.iamInstanceProfile) || (p.iamInstanceProfile, void 0), visitedObjects.has(p.instanceMarketOptions) || (p.instanceMarketOptions, void 0), visitedObjects.has(p.instanceRequirements) || (p.instanceRequirements, void 0), visitedObjects.has(p.licenseSpecifications) || (p.licenseSpecifications, void 0), visitedObjects.has(p.maintenanceOptions) || (p.maintenanceOptions, void 0), visitedObjects.has(p.metadataOptions) || (p.metadataOptions, void 0), visitedObjects.has(p.monitoring) || (p.monitoring, void 0), visitedObjects.has(p.networkInterfaces) || (p.networkInterfaces, void 0), visitedObjects.has(p.placement) || (p.placement, void 0), visitedObjects.has(p.privateDnsNameOptions) || (p.privateDnsNameOptions, void 0), visitedObjects.has(p.tagSpecifications) || (p.tagSpecifications, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_LaunchTemplateElasticInferenceAcceleratorProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_LaunchTemplateTagSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_LicenseSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_MaintenanceOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_MemoryGiBPerVCpuProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_MemoryMiBProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_MetadataOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_MonitoringProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_NetworkBandwidthGbpsProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_NetworkInterfaceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ipv4Prefixes) || (p.ipv4Prefixes, void 0), visitedObjects.has(p.ipv6Addresses) || (p.ipv6Addresses, void 0), visitedObjects.has(p.ipv6Prefixes) || (p.ipv6Prefixes, void 0), visitedObjects.has(p.privateIpAddresses) || (p.privateIpAddresses, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_NetworkInterfaceCountProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_PlacementProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_PrivateDnsNameOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_PrivateIpAddProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_SpotOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_TagSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_TotalLocalStorageGBProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLaunchTemplate_VCpuCountProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLocalGatewayRouteProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLocalGatewayRoute(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLocalGatewayRouteTableProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnLocalGatewayRouteTable(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLocalGatewayRouteTableVPCAssociationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnLocalGatewayRouteTableVPCAssociation(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnLocalGatewayRouteTableVirtualInterfaceGroupAssociationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnLocalGatewayRouteTableVirtualInterfaceGroupAssociation(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnNatGatewayProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnNatGateway(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkAclProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkAcl(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkAclEntryProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.icmp) || (p.icmp, void 0), visitedObjects.has(p.portRange) || (p.portRange, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkAclEntry(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkAclEntry_IcmpProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkAclEntry_PortRangeProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInsightsAccessScopeProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.excludePaths) || (p.excludePaths, void 0), visitedObjects.has(p.matchPaths) || (p.matchPaths, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInsightsAccessScope(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInsightsAccessScope_AccessScopePathRequestProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destination) || (p.destination, void 0), visitedObjects.has(p.source) || (p.source, void 0), visitedObjects.has(p.throughResources) || (p.throughResources, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInsightsAccessScope_PacketHeaderStatementRequestProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInsightsAccessScope_PathStatementRequestProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.packetHeaderStatement) || (p.packetHeaderStatement, void 0), visitedObjects.has(p.resourceStatement) || (p.resourceStatement, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInsightsAccessScope_ResourceStatementRequestProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInsightsAccessScope_ThroughResourcesStatementRequestProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.resourceStatement) || (p.resourceStatement, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInsightsAccessScopeAnalysisProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInsightsAccessScopeAnalysis(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInsightsAnalysisProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInsightsAnalysis(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInsightsAnalysis_AdditionalDetailProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.component) || (p.component, void 0), visitedObjects.has(p.loadBalancers) || (p.loadBalancers, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInsightsAnalysis_AlternatePathHintProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInsightsAnalysis_AnalysisAclRuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.portRange) || (p.portRange, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInsightsAnalysis_AnalysisComponentProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInsightsAnalysis_AnalysisLoadBalancerListenerProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInsightsAnalysis_AnalysisLoadBalancerTargetProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.instance) || (p.instance, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInsightsAnalysis_AnalysisPacketHeaderProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destinationPortRanges) || (p.destinationPortRanges, void 0), visitedObjects.has(p.sourcePortRanges) || (p.sourcePortRanges, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInsightsAnalysis_AnalysisRouteTableRouteProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInsightsAnalysis_AnalysisSecurityGroupRuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.portRange) || (p.portRange, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInsightsAnalysis_ExplanationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.acl) || (p.acl, void 0), visitedObjects.has(p.aclRule) || (p.aclRule, void 0), visitedObjects.has(p.attachedTo) || (p.attachedTo, void 0), visitedObjects.has(p.classicLoadBalancerListener) || (p.classicLoadBalancerListener, void 0), visitedObjects.has(p.component) || (p.component, void 0), visitedObjects.has(p.customerGateway) || (p.customerGateway, void 0), visitedObjects.has(p.destination) || (p.destination, void 0), visitedObjects.has(p.destinationVpc) || (p.destinationVpc, void 0), visitedObjects.has(p.elasticLoadBalancerListener) || (p.elasticLoadBalancerListener, void 0), visitedObjects.has(p.ingressRouteTable) || (p.ingressRouteTable, void 0), visitedObjects.has(p.internetGateway) || (p.internetGateway, void 0), visitedObjects.has(p.loadBalancerTarget) || (p.loadBalancerTarget, void 0), visitedObjects.has(p.loadBalancerTargetGroup) || (p.loadBalancerTargetGroup, void 0), visitedObjects.has(p.loadBalancerTargetGroups) || (p.loadBalancerTargetGroups, void 0), visitedObjects.has(p.natGateway) || (p.natGateway, void 0), visitedObjects.has(p.networkInterface) || (p.networkInterface, void 0), visitedObjects.has(p.portRanges) || (p.portRanges, void 0), visitedObjects.has(p.prefixList) || (p.prefixList, void 0), visitedObjects.has(p.routeTable) || (p.routeTable, void 0), visitedObjects.has(p.routeTableRoute) || (p.routeTableRoute, void 0), visitedObjects.has(p.securityGroup) || (p.securityGroup, void 0), visitedObjects.has(p.securityGroupRule) || (p.securityGroupRule, void 0), visitedObjects.has(p.securityGroups) || (p.securityGroups, void 0), visitedObjects.has(p.sourceVpc) || (p.sourceVpc, void 0), visitedObjects.has(p.subnet) || (p.subnet, void 0), visitedObjects.has(p.subnetRouteTable) || (p.subnetRouteTable, void 0), visitedObjects.has(p.transitGateway) || (p.transitGateway, void 0), visitedObjects.has(p.transitGatewayAttachment) || (p.transitGatewayAttachment, void 0), visitedObjects.has(p.transitGatewayRouteTable) || (p.transitGatewayRouteTable, void 0), visitedObjects.has(p.transitGatewayRouteTableRoute) || (p.transitGatewayRouteTableRoute, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.vpcEndpoint) || (p.vpcEndpoint, void 0), visitedObjects.has(p.vpcPeeringConnection) || (p.vpcPeeringConnection, void 0), visitedObjects.has(p.vpnConnection) || (p.vpnConnection, void 0), visitedObjects.has(p.vpnGateway) || (p.vpnGateway, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInsightsAnalysis_PathComponentProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.aclRule) || (p.aclRule, void 0), visitedObjects.has(p.additionalDetails) || (p.additionalDetails, void 0), visitedObjects.has(p.component) || (p.component, void 0), visitedObjects.has(p.destinationVpc) || (p.destinationVpc, void 0), visitedObjects.has(p.elasticLoadBalancerListener) || (p.elasticLoadBalancerListener, void 0), visitedObjects.has(p.explanations) || (p.explanations, void 0), visitedObjects.has(p.inboundHeader) || (p.inboundHeader, void 0), visitedObjects.has(p.outboundHeader) || (p.outboundHeader, void 0), visitedObjects.has(p.routeTableRoute) || (p.routeTableRoute, void 0), visitedObjects.has(p.securityGroupRule) || (p.securityGroupRule, void 0), visitedObjects.has(p.sourceVpc) || (p.sourceVpc, void 0), visitedObjects.has(p.subnet) || (p.subnet, void 0), visitedObjects.has(p.transitGateway) || (p.transitGateway, void 0), visitedObjects.has(p.transitGatewayRouteTableRoute) || (p.transitGatewayRouteTableRoute, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInsightsAnalysis_PortRangeProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInsightsAnalysis_TransitGatewayRouteTableRouteProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInsightsPathProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.filterAtDestination) || (p.filterAtDestination, void 0), visitedObjects.has(p.filterAtSource) || (p.filterAtSource, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInsightsPath(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInsightsPath_FilterPortRangeProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInsightsPath_PathFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destinationPortRange) || (p.destinationPortRange, void 0), visitedObjects.has(p.sourcePortRange) || (p.sourcePortRange, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInterfaceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.ipv6Addresses) || (p.ipv6Addresses, void 0), visitedObjects.has(p.privateIpAddresses) || (p.privateIpAddresses, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInterface(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInterface_InstanceIpv6AddressProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInterface_PrivateIpAddressSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInterfaceAttachmentProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInterfaceAttachment(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInterfacePermissionProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkInterfacePermission(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkPerformanceMetricSubscriptionProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnNetworkPerformanceMetricSubscription(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnPlacementGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnPlacementGroup(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnPrefixListProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.entries) || (p.entries, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnPrefixList(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnPrefixList_EntryProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnRouteProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnRoute(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnRouteTableProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnRouteTable(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSecurityGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.securityGroupEgress) || (p.securityGroupEgress, void 0), visitedObjects.has(p.securityGroupIngress) || (p.securityGroupIngress, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnSecurityGroup(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSecurityGroup_EgressProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSecurityGroup_IngressProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSecurityGroupEgressProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSecurityGroupEgress(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSecurityGroupIngressProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSecurityGroupIngress(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.spotFleetRequestConfigData) || (p.spotFleetRequestConfigData, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_AcceleratorCountRequestProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_AcceleratorTotalMemoryMiBRequestProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_BaselineEbsBandwidthMbpsRequestProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_BlockDeviceMappingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ebs) || (p.ebs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_ClassicLoadBalancerProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_ClassicLoadBalancersConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.classicLoadBalancers) || (p.classicLoadBalancers, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_EbsBlockDeviceProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_FleetLaunchTemplateSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_GroupIdentifierProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_IamInstanceProfileSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_InstanceIpv6AddressProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_InstanceNetworkInterfaceSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ipv6Addresses) || (p.ipv6Addresses, void 0), visitedObjects.has(p.privateIpAddresses) || (p.privateIpAddresses, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_InstanceRequirementsRequestProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.acceleratorCount) || (p.acceleratorCount, void 0), visitedObjects.has(p.acceleratorTotalMemoryMiB) || (p.acceleratorTotalMemoryMiB, void 0), visitedObjects.has(p.baselineEbsBandwidthMbps) || (p.baselineEbsBandwidthMbps, void 0), visitedObjects.has(p.memoryGiBPerVCpu) || (p.memoryGiBPerVCpu, void 0), visitedObjects.has(p.memoryMiB) || (p.memoryMiB, void 0), visitedObjects.has(p.networkBandwidthGbps) || (p.networkBandwidthGbps, void 0), visitedObjects.has(p.networkInterfaceCount) || (p.networkInterfaceCount, void 0), visitedObjects.has(p.totalLocalStorageGb) || (p.totalLocalStorageGb, void 0), visitedObjects.has(p.vCpuCount) || (p.vCpuCount, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_LaunchTemplateConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.launchTemplateSpecification) || (p.launchTemplateSpecification, void 0), visitedObjects.has(p.overrides) || (p.overrides, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_LaunchTemplateOverridesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.instanceRequirements) || (p.instanceRequirements, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_LoadBalancersConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.classicLoadBalancersConfig) || (p.classicLoadBalancersConfig, void 0), visitedObjects.has(p.targetGroupsConfig) || (p.targetGroupsConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_MemoryGiBPerVCpuRequestProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_MemoryMiBRequestProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_NetworkBandwidthGbpsRequestProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_NetworkInterfaceCountRequestProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_PrivateIpAddressSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_SpotCapacityRebalanceProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_SpotFleetLaunchSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.blockDeviceMappings) || (p.blockDeviceMappings, void 0), visitedObjects.has(p.iamInstanceProfile) || (p.iamInstanceProfile, void 0), visitedObjects.has(p.instanceRequirements) || (p.instanceRequirements, void 0), visitedObjects.has(p.monitoring) || (p.monitoring, void 0), visitedObjects.has(p.networkInterfaces) || (p.networkInterfaces, void 0), visitedObjects.has(p.placement) || (p.placement, void 0), visitedObjects.has(p.securityGroups) || (p.securityGroups, void 0), visitedObjects.has(p.tagSpecifications) || (p.tagSpecifications, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_SpotFleetMonitoringProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_SpotFleetRequestConfigDataProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.launchSpecifications) || (p.launchSpecifications, void 0), visitedObjects.has(p.launchTemplateConfigs) || (p.launchTemplateConfigs, void 0), visitedObjects.has(p.loadBalancersConfig) || (p.loadBalancersConfig, void 0), visitedObjects.has(p.spotMaintenanceStrategies) || (p.spotMaintenanceStrategies, void 0), visitedObjects.has(p.tagSpecifications) || (p.tagSpecifications, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_SpotFleetTagSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_SpotMaintenanceStrategiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.capacityRebalance) || (p.capacityRebalance, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_SpotPlacementProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_TargetGroupProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_TargetGroupsConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.targetGroups) || (p.targetGroups, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_TotalLocalStorageGBRequestProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSpotFleet_VCpuCountRangeRequestProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSubnetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnSubnet(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSubnet_PrivateDnsNameOptionsOnLaunchProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSubnetCidrBlockProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSubnetCidrBlock(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSubnetNetworkAclAssociationProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSubnetNetworkAclAssociation(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSubnetRouteTableAssociationProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnSubnetRouteTableAssociation(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnTrafficMirrorFilterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnTrafficMirrorFilter(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnTrafficMirrorFilterRuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destinationPortRange) || (p.destinationPortRange, void 0), visitedObjects.has(p.sourcePortRange) || (p.sourcePortRange, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnTrafficMirrorFilterRule(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnTrafficMirrorFilterRule_TrafficMirrorPortRangeProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnTrafficMirrorSessionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnTrafficMirrorSession(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnTrafficMirrorTargetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnTrafficMirrorTarget(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnTransitGatewayProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnTransitGateway(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnTransitGatewayAttachmentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnTransitGatewayAttachment(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnTransitGatewayAttachment_OptionsProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnTransitGatewayConnectProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.options) || (p.options, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnTransitGatewayConnect(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnTransitGatewayConnect_TransitGatewayConnectOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnTransitGatewayMulticastDomainProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnTransitGatewayMulticastDomain(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnTransitGatewayMulticastDomain_OptionsProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnTransitGatewayMulticastDomainAssociationProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnTransitGatewayMulticastDomainAssociation(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnTransitGatewayMulticastGroupMemberProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnTransitGatewayMulticastGroupMember(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnTransitGatewayMulticastGroupSourceProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnTransitGatewayMulticastGroupSource(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnTransitGatewayPeeringAttachmentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnTransitGatewayPeeringAttachment(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnTransitGatewayPeeringAttachment_PeeringAttachmentStatusProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnTransitGatewayRouteProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnTransitGatewayRoute(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnTransitGatewayRouteTableProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnTransitGatewayRouteTable(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnTransitGatewayRouteTableAssociationProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnTransitGatewayRouteTableAssociation(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnTransitGatewayRouteTablePropagationProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnTransitGatewayRouteTablePropagation(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnTransitGatewayVpcAttachmentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnTransitGatewayVpcAttachment(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnTransitGatewayVpcAttachment_OptionsProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVPCProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnVPC(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVPCCidrBlockProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVPCCidrBlock(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVPCDHCPOptionsAssociationProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVPCDHCPOptionsAssociation(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVPCEndpointProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVPCEndpoint(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVPCEndpointConnectionNotificationProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVPCEndpointConnectionNotification(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVPCEndpointServiceProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVPCEndpointService(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVPCEndpointServicePermissionsProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVPCEndpointServicePermissions(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVPCGatewayAttachmentProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVPCGatewayAttachment(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVPCPeeringConnectionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnVPCPeeringConnection(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVPNConnectionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.vpnTunnelOptionsSpecifications) || (p.vpnTunnelOptionsSpecifications, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnVPNConnection(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVPNConnection_VpnTunnelOptionsSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVPNConnectionRouteProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVPNConnectionRoute(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVPNGatewayProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnVPNGateway(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVPNGatewayRoutePropagationProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVPNGatewayRoutePropagation(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVerifiedAccessEndpointProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.loadBalancerOptions) || (p.loadBalancerOptions, void 0), visitedObjects.has(p.networkInterfaceOptions) || (p.networkInterfaceOptions, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnVerifiedAccessEndpoint(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVerifiedAccessEndpoint_LoadBalancerOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVerifiedAccessEndpoint_NetworkInterfaceOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVerifiedAccessGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnVerifiedAccessGroup(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVerifiedAccessInstanceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.loggingConfigurations) || (p.loggingConfigurations, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.verifiedAccessTrustProviders) || (p.verifiedAccessTrustProviders, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnVerifiedAccessInstance(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVerifiedAccessInstance_CloudWatchLogsProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVerifiedAccessInstance_KinesisDataFirehoseProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVerifiedAccessInstance_S3Property(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVerifiedAccessInstance_VerifiedAccessLogsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cloudWatchLogs) || (p.cloudWatchLogs, void 0), visitedObjects.has(p.kinesisDataFirehose) || (p.kinesisDataFirehose, void 0), visitedObjects.has(p.s3) || (p.s3, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnVerifiedAccessInstance_VerifiedAccessTrustProviderProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVerifiedAccessTrustProviderProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.deviceOptions) || (p.deviceOptions, void 0), visitedObjects.has(p.oidcOptions) || (p.oidcOptions, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnVerifiedAccessTrustProvider(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVerifiedAccessTrustProvider_DeviceOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVerifiedAccessTrustProvider_OidcOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVolumeProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ec2_CfnVolume(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVolumeAttachmentProps(p) {
    }
    function aws_cdk_lib_aws_ec2_CfnVolumeAttachment(p) {
    }
    function aws_cdk_lib_aws_ecr_CfnPublicRepositoryProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecr_CfnPublicRepository(p) {
    }
    function aws_cdk_lib_aws_ecr_CfnPublicRepository_RepositoryCatalogDataProperty(p) {
    }
    function aws_cdk_lib_aws_ecr_CfnPullThroughCacheRuleProps(p) {
    }
    function aws_cdk_lib_aws_ecr_CfnPullThroughCacheRule(p) {
    }
    function aws_cdk_lib_aws_ecr_CfnRegistryPolicyProps(p) {
    }
    function aws_cdk_lib_aws_ecr_CfnRegistryPolicy(p) {
    }
    function aws_cdk_lib_aws_ecr_CfnReplicationConfigurationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.replicationConfiguration) || (p.replicationConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecr_CfnReplicationConfiguration(p) {
    }
    function aws_cdk_lib_aws_ecr_CfnReplicationConfiguration_ReplicationConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.rules) || (p.rules, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecr_CfnReplicationConfiguration_ReplicationDestinationProperty(p) {
    }
    function aws_cdk_lib_aws_ecr_CfnReplicationConfiguration_ReplicationRuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destinations) || (p.destinations, void 0), visitedObjects.has(p.repositoryFilters) || (p.repositoryFilters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecr_CfnReplicationConfiguration_RepositoryFilterProperty(p) {
    }
    function aws_cdk_lib_aws_ecr_CfnRepositoryProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.encryptionConfiguration) || (p.encryptionConfiguration, void 0), visitedObjects.has(p.imageScanningConfiguration) || (p.imageScanningConfiguration, void 0), visitedObjects.has(p.lifecyclePolicy) || (p.lifecyclePolicy, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecr_CfnRepository(p) {
    }
    function aws_cdk_lib_aws_ecr_CfnRepository_EncryptionConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_ecr_CfnRepository_ImageScanningConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_ecr_CfnRepository_LifecyclePolicyProperty(p) {
    }
    function aws_cdk_lib_aws_ecr_IRepository(p) {
    }
    function aws_cdk_lib_aws_ecr_RepositoryBase(p) {
    }
    function aws_cdk_lib_aws_ecr_OnCloudTrailImagePushedOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.target) || (p.target, void 0), visitedObjects.has(p.eventPattern) || (p.eventPattern, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecr_OnImageScanCompletedOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.target) || (p.target, void 0), visitedObjects.has(p.eventPattern) || (p.eventPattern, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecr_RepositoryProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.encryption) || (p.encryption, void 0), visitedObjects.has(p.encryptionKey) || (p.encryptionKey, void 0), visitedObjects.has(p.imageTagMutability) || (p.imageTagMutability, void 0), p.lifecycleRules != null)
            for (const o of p.lifecycleRules)
              visitedObjects.has(o) || aws_cdk_lib_aws_ecr_LifecycleRule(o);
          visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecr_RepositoryAttributes(p) {
    }
    function aws_cdk_lib_aws_ecr_Repository(p) {
    }
    function aws_cdk_lib_aws_ecr_TagMutability(p) {
    }
    function aws_cdk_lib_aws_ecr_RepositoryEncryption(p) {
    }
    function aws_cdk_lib_aws_ecr_LifecycleRule(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.maxImageAge) || (p.maxImageAge, void 0), visitedObjects.has(p.tagStatus) || (p.tagStatus, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecr_TagStatus(p) {
    }
    function aws_cdk_lib_aws_ecr_AuthorizationToken(p) {
    }
    function aws_cdk_lib_aws_ecr_PublicGalleryAuthorizationToken(p) {
    }
    function aws_cdk_lib_aws_ecr_assets_NetworkMode(p) {
    }
    function aws_cdk_lib_aws_ecr_assets_Platform(p) {
    }
    function aws_cdk_lib_aws_ecr_assets_DockerImageAssetInvalidationOptions(p) {
    }
    function aws_cdk_lib_aws_ecr_assets_DockerCacheOption(p) {
    }
    function aws_cdk_lib_aws_ecr_assets_DockerImageAssetOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.cacheFrom != null)
            for (const o of p.cacheFrom)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.cacheTo) || (p.cacheTo, void 0), visitedObjects.has(p.invalidation) || (p.invalidation, void 0), visitedObjects.has(p.networkMode) || (p.networkMode, void 0), visitedObjects.has(p.platform) || (p.platform, void 0), visitedObjects.has(p.followSymlinks) || (p.followSymlinks, void 0), visitedObjects.has(p.ignoreMode) || (p.ignoreMode, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecr_assets_DockerImageAssetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.cacheFrom != null)
            for (const o of p.cacheFrom)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.cacheTo) || (p.cacheTo, void 0), visitedObjects.has(p.invalidation) || (p.invalidation, void 0), visitedObjects.has(p.networkMode) || (p.networkMode, void 0), visitedObjects.has(p.platform) || (p.platform, void 0), visitedObjects.has(p.followSymlinks) || (p.followSymlinks, void 0), visitedObjects.has(p.ignoreMode) || (p.ignoreMode, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecr_assets_DockerImageAsset(p) {
    }
    function aws_cdk_lib_aws_ecr_assets_TarballImageAssetProps(p) {
    }
    function aws_cdk_lib_aws_ecr_assets_TarballImageAsset(p) {
    }
    function aws_cdk_lib_aws_ecs_IService(p) {
    }
    function aws_cdk_lib_aws_ecs_DeploymentController(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.type) || (p.type, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_DeploymentCircuitBreaker(p) {
    }
    function aws_cdk_lib_aws_ecs_EcsTarget(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.listener) || (p.listener, void 0), visitedObjects.has(p.protocol) || (p.protocol, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_IEcsLoadBalancerTarget(p) {
    }
    function aws_cdk_lib_aws_ecs_ServiceConnectProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.logDriver) || (p.logDriver, void 0), p.services != null)
            for (const o of p.services)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_ServiceConnectService(p) {
    }
    function aws_cdk_lib_aws_ecs_BaseServiceOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.cluster) || (p.cluster, void 0), p.capacityProviderStrategies != null)
            for (const o of p.capacityProviderStrategies)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.circuitBreaker) || (p.circuitBreaker, void 0), visitedObjects.has(p.cloudMapOptions) || aws_cdk_lib_aws_ecs_CloudMapOptions(p.cloudMapOptions), visitedObjects.has(p.deploymentController) || aws_cdk_lib_aws_ecs_DeploymentController(p.deploymentController), visitedObjects.has(p.healthCheckGracePeriod) || (p.healthCheckGracePeriod, void 0), visitedObjects.has(p.propagateTags) || (p.propagateTags, void 0), visitedObjects.has(p.serviceConnectConfiguration) || aws_cdk_lib_aws_ecs_ServiceConnectProps(p.serviceConnectConfiguration);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_BaseServiceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.launchType) || (p.launchType, void 0), visitedObjects.has(p.cluster) || (p.cluster, void 0), p.capacityProviderStrategies != null)
            for (const o of p.capacityProviderStrategies)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.circuitBreaker) || (p.circuitBreaker, void 0), visitedObjects.has(p.cloudMapOptions) || aws_cdk_lib_aws_ecs_CloudMapOptions(p.cloudMapOptions), visitedObjects.has(p.deploymentController) || aws_cdk_lib_aws_ecs_DeploymentController(p.deploymentController), visitedObjects.has(p.healthCheckGracePeriod) || (p.healthCheckGracePeriod, void 0), visitedObjects.has(p.propagateTags) || (p.propagateTags, void 0), visitedObjects.has(p.serviceConnectConfiguration) || aws_cdk_lib_aws_ecs_ServiceConnectProps(p.serviceConnectConfiguration);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_ListenerConfig(p) {
    }
    function aws_cdk_lib_aws_ecs_IBaseService(p) {
    }
    function aws_cdk_lib_aws_ecs_BaseService(p) {
    }
    function aws_cdk_lib_aws_ecs_CloudMapOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cloudMapNamespace) || (p.cloudMapNamespace, void 0), visitedObjects.has(p.container) || (p.container, void 0), visitedObjects.has(p.dnsRecordType) || (p.dnsRecordType, void 0), visitedObjects.has(p.dnsTtl) || (p.dnsTtl, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_AssociateCloudMapServiceOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.service) || (p.service, void 0), visitedObjects.has(p.container) || (p.container, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_LaunchType(p) {
    }
    function aws_cdk_lib_aws_ecs_DeploymentControllerType(p) {
    }
    function aws_cdk_lib_aws_ecs_PropagatedTagSource(p) {
    }
    function aws_cdk_lib_aws_ecs_ScalableTaskCountProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.role) || (p.role, void 0), visitedObjects.has(p.serviceNamespace) || (p.serviceNamespace, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_ScalableTaskCount(p) {
    }
    function aws_cdk_lib_aws_ecs_CpuUtilizationScalingProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.scaleInCooldown) || (p.scaleInCooldown, void 0), visitedObjects.has(p.scaleOutCooldown) || (p.scaleOutCooldown, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_MemoryUtilizationScalingProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.scaleInCooldown) || (p.scaleInCooldown, void 0), visitedObjects.has(p.scaleOutCooldown) || (p.scaleOutCooldown, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_RequestCountScalingProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.targetGroup) || (p.targetGroup, void 0), visitedObjects.has(p.scaleInCooldown) || (p.scaleInCooldown, void 0), visitedObjects.has(p.scaleOutCooldown) || (p.scaleOutCooldown, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_TrackCustomMetricProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.metric) || (p.metric, void 0), visitedObjects.has(p.scaleInCooldown) || (p.scaleInCooldown, void 0), visitedObjects.has(p.scaleOutCooldown) || (p.scaleOutCooldown, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_ITaskDefinition(p) {
    }
    function aws_cdk_lib_aws_ecs_CommonTaskDefinitionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.executionRole) || (p.executionRole, void 0), visitedObjects.has(p.proxyConfiguration) || (p.proxyConfiguration, void 0), visitedObjects.has(p.taskRole) || (p.taskRole, void 0), p.volumes != null)
            for (const o of p.volumes)
              visitedObjects.has(o) || aws_cdk_lib_aws_ecs_Volume(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_TaskDefinitionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.compatibility) || (p.compatibility, void 0), p.inferenceAccelerators != null)
            for (const o of p.inferenceAccelerators)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.ipcMode) || (p.ipcMode, void 0), visitedObjects.has(p.networkMode) || (p.networkMode, void 0), visitedObjects.has(p.pidMode) || (p.pidMode, void 0), p.placementConstraints != null)
            for (const o of p.placementConstraints)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.runtimePlatform) || aws_cdk_lib_aws_ecs_RuntimePlatform(p.runtimePlatform), visitedObjects.has(p.executionRole) || (p.executionRole, void 0), visitedObjects.has(p.proxyConfiguration) || (p.proxyConfiguration, void 0), visitedObjects.has(p.taskRole) || (p.taskRole, void 0), p.volumes != null)
            for (const o of p.volumes)
              visitedObjects.has(o) || aws_cdk_lib_aws_ecs_Volume(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_CommonTaskDefinitionAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.executionRole) || (p.executionRole, void 0), visitedObjects.has(p.networkMode) || (p.networkMode, void 0), visitedObjects.has(p.taskRole) || (p.taskRole, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_TaskDefinitionAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.compatibility) || (p.compatibility, void 0), visitedObjects.has(p.executionRole) || (p.executionRole, void 0), visitedObjects.has(p.networkMode) || (p.networkMode, void 0), visitedObjects.has(p.taskRole) || (p.taskRole, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_TaskDefinition(p) {
    }
    function aws_cdk_lib_aws_ecs_NetworkMode(p) {
    }
    function aws_cdk_lib_aws_ecs_IpcMode(p) {
    }
    function aws_cdk_lib_aws_ecs_PidMode(p) {
    }
    function aws_cdk_lib_aws_ecs_InferenceAccelerator(p) {
    }
    function aws_cdk_lib_aws_ecs_Volume(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dockerVolumeConfiguration) || aws_cdk_lib_aws_ecs_DockerVolumeConfiguration(p.dockerVolumeConfiguration), visitedObjects.has(p.efsVolumeConfiguration) || aws_cdk_lib_aws_ecs_EfsVolumeConfiguration(p.efsVolumeConfiguration), visitedObjects.has(p.host) || (p.host, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_Host(p) {
    }
    function aws_cdk_lib_aws_ecs_LoadBalancerTargetOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.protocol) || (p.protocol, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_DockerVolumeConfiguration(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.scope) || (p.scope, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_AuthorizationConfig(p) {
    }
    function aws_cdk_lib_aws_ecs_EfsVolumeConfiguration(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.authorizationConfig) || (p.authorizationConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_Scope(p) {
    }
    function aws_cdk_lib_aws_ecs_Compatibility(p) {
    }
    function aws_cdk_lib_aws_ecs_ITaskDefinitionExtension(p) {
    }
    function aws_cdk_lib_aws_ecs_SecretVersionInfo(p) {
    }
    function aws_cdk_lib_aws_ecs_Secret(p) {
    }
    function aws_cdk_lib_aws_ecs_ContainerDefinitionOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.image) || (p.image, void 0), p.environmentFiles != null)
            for (const o of p.environmentFiles)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.healthCheck) || aws_cdk_lib_aws_ecs_HealthCheck(p.healthCheck), visitedObjects.has(p.linuxParameters) || (p.linuxParameters, void 0), visitedObjects.has(p.logging) || (p.logging, void 0), p.portMappings != null)
            for (const o of p.portMappings)
              visitedObjects.has(o) || aws_cdk_lib_aws_ecs_PortMapping(o);
          if (p.secrets != null)
            for (const o of Object.values(p.secrets))
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.startTimeout) || (p.startTimeout, void 0), visitedObjects.has(p.stopTimeout) || (p.stopTimeout, void 0), p.systemControls != null)
            for (const o of p.systemControls)
              visitedObjects.has(o) || void 0;
          if (p.ulimits != null)
            for (const o of p.ulimits)
              visitedObjects.has(o) || aws_cdk_lib_aws_ecs_Ulimit(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_ContainerDefinitionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.taskDefinition) || (p.taskDefinition, void 0), visitedObjects.has(p.image) || (p.image, void 0), p.environmentFiles != null)
            for (const o of p.environmentFiles)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.healthCheck) || aws_cdk_lib_aws_ecs_HealthCheck(p.healthCheck), visitedObjects.has(p.linuxParameters) || (p.linuxParameters, void 0), visitedObjects.has(p.logging) || (p.logging, void 0), p.portMappings != null)
            for (const o of p.portMappings)
              visitedObjects.has(o) || aws_cdk_lib_aws_ecs_PortMapping(o);
          if (p.secrets != null)
            for (const o of Object.values(p.secrets))
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.startTimeout) || (p.startTimeout, void 0), visitedObjects.has(p.stopTimeout) || (p.stopTimeout, void 0), p.systemControls != null)
            for (const o of p.systemControls)
              visitedObjects.has(o) || void 0;
          if (p.ulimits != null)
            for (const o of p.ulimits)
              visitedObjects.has(o) || aws_cdk_lib_aws_ecs_Ulimit(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_ContainerDefinition(p) {
    }
    function aws_cdk_lib_aws_ecs_HealthCheck(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.interval) || (p.interval, void 0), visitedObjects.has(p.startPeriod) || (p.startPeriod, void 0), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_Ulimit(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.name) || (p.name, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_UlimitName(p) {
    }
    function aws_cdk_lib_aws_ecs_ContainerDependency(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.container) || (p.container, void 0), visitedObjects.has(p.condition) || (p.condition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_ContainerDependencyCondition(p) {
    }
    function aws_cdk_lib_aws_ecs_PortMapping(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.appProtocol) || (p.appProtocol, void 0), visitedObjects.has(p.protocol) || (p.protocol, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_PortMap(p) {
    }
    function aws_cdk_lib_aws_ecs_ServiceConnect(p) {
    }
    function aws_cdk_lib_aws_ecs_Protocol(p) {
    }
    function aws_cdk_lib_aws_ecs_AppProtocol(p) {
    }
    function aws_cdk_lib_aws_ecs_ScratchSpace(p) {
    }
    function aws_cdk_lib_aws_ecs_MountPoint(p) {
    }
    function aws_cdk_lib_aws_ecs_VolumeFrom(p) {
    }
    function aws_cdk_lib_aws_ecs_SystemControl(p) {
    }
    function aws_cdk_lib_aws_ecs_ContainerImage(p) {
    }
    function aws_cdk_lib_aws_ecs_ContainerImageConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.repositoryCredentials) || (p.repositoryCredentials, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_AmiHardwareType(p) {
    }
    function aws_cdk_lib_aws_ecs_WindowsOptimizedVersion(p) {
    }
    function aws_cdk_lib_aws_ecs_EcsOptimizedImageOptions(p) {
    }
    function aws_cdk_lib_aws_ecs_EcsOptimizedImage(p) {
    }
    function aws_cdk_lib_aws_ecs_BottlerocketEcsVariant(p) {
    }
    function aws_cdk_lib_aws_ecs_BottleRocketImageProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.architecture) || (p.architecture, void 0), visitedObjects.has(p.variant) || (p.variant, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_BottleRocketImage(p) {
    }
    function aws_cdk_lib_aws_ecs_ClusterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.capacity) || aws_cdk_lib_aws_ecs_AddCapacityOptions(p.capacity), visitedObjects.has(p.defaultCloudMapNamespace) || aws_cdk_lib_aws_ecs_CloudMapNamespaceOptions(p.defaultCloudMapNamespace), visitedObjects.has(p.executeCommandConfiguration) || aws_cdk_lib_aws_ecs_ExecuteCommandConfiguration(p.executeCommandConfiguration), visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_MachineImageType(p) {
    }
    function aws_cdk_lib_aws_ecs_Cluster(p) {
    }
    function aws_cdk_lib_aws_ecs_ICluster(p) {
    }
    function aws_cdk_lib_aws_ecs_ClusterAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.autoscalingGroup) || (p.autoscalingGroup, void 0), visitedObjects.has(p.defaultCloudMapNamespace) || (p.defaultCloudMapNamespace, void 0), visitedObjects.has(p.executeCommandConfiguration) || aws_cdk_lib_aws_ecs_ExecuteCommandConfiguration(p.executeCommandConfiguration);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_AddAutoScalingGroupCapacityOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.machineImageType) || (p.machineImageType, void 0), visitedObjects.has(p.topicEncryptionKey) || (p.topicEncryptionKey, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_AddCapacityOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.instanceType) || (p.instanceType, void 0), visitedObjects.has(p.machineImage) || (p.machineImage, void 0), visitedObjects.has(p.machineImageType) || (p.machineImageType, void 0), visitedObjects.has(p.topicEncryptionKey) || (p.topicEncryptionKey, void 0), p.blockDevices != null)
            for (const o of p.blockDevices)
              visitedObjects.has(o) || aws_cdk_lib_aws_autoscaling_BlockDevice(o);
          if (visitedObjects.has(p.cooldown) || (p.cooldown, void 0), visitedObjects.has(p.defaultInstanceWarmup) || (p.defaultInstanceWarmup, void 0), p.groupMetrics != null)
            for (const o of p.groupMetrics)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.healthCheck) || (p.healthCheck, void 0), visitedObjects.has(p.instanceMonitoring) || (p.instanceMonitoring, void 0), visitedObjects.has(p.maxInstanceLifetime) || (p.maxInstanceLifetime, void 0), p.notifications != null)
            for (const o of p.notifications)
              visitedObjects.has(o) || aws_cdk_lib_aws_autoscaling_NotificationConfiguration(o);
          if (visitedObjects.has(p.signals) || (p.signals, void 0), p.terminationPolicies != null)
            for (const o of p.terminationPolicies)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.updatePolicy) || (p.updatePolicy, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_CloudMapNamespaceOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.type) || (p.type, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_CapacityProviderStrategy(p) {
    }
    function aws_cdk_lib_aws_ecs_ExecuteCommandConfiguration(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.kmsKey) || (p.kmsKey, void 0), visitedObjects.has(p.logConfiguration) || aws_cdk_lib_aws_ecs_ExecuteCommandLogConfiguration(p.logConfiguration), visitedObjects.has(p.logging) || (p.logging, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_ExecuteCommandLogging(p) {
    }
    function aws_cdk_lib_aws_ecs_ExecuteCommandLogConfiguration(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cloudWatchLogGroup) || (p.cloudWatchLogGroup, void 0), visitedObjects.has(p.s3Bucket) || (p.s3Bucket, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_AsgCapacityProviderProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.autoScalingGroup) || (p.autoScalingGroup, void 0), visitedObjects.has(p.machineImageType) || (p.machineImageType, void 0), visitedObjects.has(p.topicEncryptionKey) || (p.topicEncryptionKey, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_AsgCapacityProvider(p) {
    }
    function aws_cdk_lib_aws_ecs_EnvironmentFile(p) {
    }
    function aws_cdk_lib_aws_ecs_AssetEnvironmentFile(p) {
    }
    function aws_cdk_lib_aws_ecs_S3EnvironmentFile(p) {
    }
    function aws_cdk_lib_aws_ecs_EnvironmentFileConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fileType) || (p.fileType, void 0), visitedObjects.has(p.s3Location) || (p.s3Location, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_EnvironmentFileType(p) {
    }
    function aws_cdk_lib_aws_ecs_FirelensLogRouterType(p) {
    }
    function aws_cdk_lib_aws_ecs_FirelensConfigFileType(p) {
    }
    function aws_cdk_lib_aws_ecs_FirelensOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.configFileType) || (p.configFileType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_FirelensConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.type) || (p.type, void 0), visitedObjects.has(p.options) || aws_cdk_lib_aws_ecs_FirelensOptions(p.options);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_FirelensLogRouterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.firelensConfig) || aws_cdk_lib_aws_ecs_FirelensConfig(p.firelensConfig), visitedObjects.has(p.taskDefinition) || (p.taskDefinition, void 0), visitedObjects.has(p.image) || (p.image, void 0), p.environmentFiles != null)
            for (const o of p.environmentFiles)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.healthCheck) || aws_cdk_lib_aws_ecs_HealthCheck(p.healthCheck), visitedObjects.has(p.linuxParameters) || (p.linuxParameters, void 0), visitedObjects.has(p.logging) || (p.logging, void 0), p.portMappings != null)
            for (const o of p.portMappings)
              visitedObjects.has(o) || aws_cdk_lib_aws_ecs_PortMapping(o);
          if (p.secrets != null)
            for (const o of Object.values(p.secrets))
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.startTimeout) || (p.startTimeout, void 0), visitedObjects.has(p.stopTimeout) || (p.stopTimeout, void 0), p.systemControls != null)
            for (const o of p.systemControls)
              visitedObjects.has(o) || void 0;
          if (p.ulimits != null)
            for (const o of p.ulimits)
              visitedObjects.has(o) || aws_cdk_lib_aws_ecs_Ulimit(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_FirelensLogRouterDefinitionOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.firelensConfig) || aws_cdk_lib_aws_ecs_FirelensConfig(p.firelensConfig), visitedObjects.has(p.image) || (p.image, void 0), p.environmentFiles != null)
            for (const o of p.environmentFiles)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.healthCheck) || aws_cdk_lib_aws_ecs_HealthCheck(p.healthCheck), visitedObjects.has(p.linuxParameters) || (p.linuxParameters, void 0), visitedObjects.has(p.logging) || (p.logging, void 0), p.portMappings != null)
            for (const o of p.portMappings)
              visitedObjects.has(o) || aws_cdk_lib_aws_ecs_PortMapping(o);
          if (p.secrets != null)
            for (const o of Object.values(p.secrets))
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.startTimeout) || (p.startTimeout, void 0), visitedObjects.has(p.stopTimeout) || (p.stopTimeout, void 0), p.systemControls != null)
            for (const o of p.systemControls)
              visitedObjects.has(o) || void 0;
          if (p.ulimits != null)
            for (const o of p.ulimits)
              visitedObjects.has(o) || aws_cdk_lib_aws_ecs_Ulimit(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_FirelensLogRouter(p) {
    }
    function aws_cdk_lib_aws_ecs_BinPackResource(p) {
    }
    function aws_cdk_lib_aws_ecs_PlacementStrategy(p) {
    }
    function aws_cdk_lib_aws_ecs_PlacementConstraint(p) {
    }
    function aws_cdk_lib_aws_ecs_Ec2ServiceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.taskDefinition) || (p.taskDefinition, void 0), p.placementConstraints != null)
            for (const o of p.placementConstraints)
              visitedObjects.has(o) || void 0;
          if (p.placementStrategies != null)
            for (const o of p.placementStrategies)
              visitedObjects.has(o) || void 0;
          if (p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets), visitedObjects.has(p.cluster) || (p.cluster, void 0), p.capacityProviderStrategies != null)
            for (const o of p.capacityProviderStrategies)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.circuitBreaker) || (p.circuitBreaker, void 0), visitedObjects.has(p.cloudMapOptions) || aws_cdk_lib_aws_ecs_CloudMapOptions(p.cloudMapOptions), visitedObjects.has(p.deploymentController) || aws_cdk_lib_aws_ecs_DeploymentController(p.deploymentController), visitedObjects.has(p.healthCheckGracePeriod) || (p.healthCheckGracePeriod, void 0), visitedObjects.has(p.propagateTags) || (p.propagateTags, void 0), visitedObjects.has(p.serviceConnectConfiguration) || aws_cdk_lib_aws_ecs_ServiceConnectProps(p.serviceConnectConfiguration);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_IEc2Service(p) {
    }
    function aws_cdk_lib_aws_ecs_Ec2ServiceAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cluster) || (p.cluster, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_Ec2Service(p) {
    }
    function aws_cdk_lib_aws_ecs_BuiltInAttributes(p) {
    }
    function aws_cdk_lib_aws_ecs_Ec2TaskDefinitionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.inferenceAccelerators != null)
            for (const o of p.inferenceAccelerators)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.ipcMode) || (p.ipcMode, void 0), visitedObjects.has(p.networkMode) || (p.networkMode, void 0), visitedObjects.has(p.pidMode) || (p.pidMode, void 0), p.placementConstraints != null)
            for (const o of p.placementConstraints)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.executionRole) || (p.executionRole, void 0), visitedObjects.has(p.proxyConfiguration) || (p.proxyConfiguration, void 0), visitedObjects.has(p.taskRole) || (p.taskRole, void 0), p.volumes != null)
            for (const o of p.volumes)
              visitedObjects.has(o) || aws_cdk_lib_aws_ecs_Volume(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_IEc2TaskDefinition(p) {
    }
    function aws_cdk_lib_aws_ecs_Ec2TaskDefinitionAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.executionRole) || (p.executionRole, void 0), visitedObjects.has(p.networkMode) || (p.networkMode, void 0), visitedObjects.has(p.taskRole) || (p.taskRole, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_Ec2TaskDefinition(p) {
    }
    function aws_cdk_lib_aws_ecs_FargateServiceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.taskDefinition) || (p.taskDefinition, void 0), visitedObjects.has(p.platformVersion) || (p.platformVersion, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets), visitedObjects.has(p.cluster) || (p.cluster, void 0), p.capacityProviderStrategies != null)
            for (const o of p.capacityProviderStrategies)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.circuitBreaker) || (p.circuitBreaker, void 0), visitedObjects.has(p.cloudMapOptions) || aws_cdk_lib_aws_ecs_CloudMapOptions(p.cloudMapOptions), visitedObjects.has(p.deploymentController) || aws_cdk_lib_aws_ecs_DeploymentController(p.deploymentController), visitedObjects.has(p.healthCheckGracePeriod) || (p.healthCheckGracePeriod, void 0), visitedObjects.has(p.propagateTags) || (p.propagateTags, void 0), visitedObjects.has(p.serviceConnectConfiguration) || aws_cdk_lib_aws_ecs_ServiceConnectProps(p.serviceConnectConfiguration);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_IFargateService(p) {
    }
    function aws_cdk_lib_aws_ecs_FargateServiceAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cluster) || (p.cluster, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_FargateService(p) {
    }
    function aws_cdk_lib_aws_ecs_FargatePlatformVersion(p) {
    }
    function aws_cdk_lib_aws_ecs_FargateTaskDefinitionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.runtimePlatform) || aws_cdk_lib_aws_ecs_RuntimePlatform(p.runtimePlatform), visitedObjects.has(p.executionRole) || (p.executionRole, void 0), visitedObjects.has(p.proxyConfiguration) || (p.proxyConfiguration, void 0), visitedObjects.has(p.taskRole) || (p.taskRole, void 0), p.volumes != null)
            for (const o of p.volumes)
              visitedObjects.has(o) || aws_cdk_lib_aws_ecs_Volume(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_IFargateTaskDefinition(p) {
    }
    function aws_cdk_lib_aws_ecs_FargateTaskDefinitionAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.executionRole) || (p.executionRole, void 0), visitedObjects.has(p.networkMode) || (p.networkMode, void 0), visitedObjects.has(p.taskRole) || (p.taskRole, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_FargateTaskDefinition(p) {
    }
    function aws_cdk_lib_aws_ecs_ExternalServiceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.taskDefinition) || (p.taskDefinition, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.cluster) || (p.cluster, void 0), p.capacityProviderStrategies != null)
            for (const o of p.capacityProviderStrategies)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.circuitBreaker) || (p.circuitBreaker, void 0), visitedObjects.has(p.cloudMapOptions) || aws_cdk_lib_aws_ecs_CloudMapOptions(p.cloudMapOptions), visitedObjects.has(p.deploymentController) || aws_cdk_lib_aws_ecs_DeploymentController(p.deploymentController), visitedObjects.has(p.healthCheckGracePeriod) || (p.healthCheckGracePeriod, void 0), visitedObjects.has(p.propagateTags) || (p.propagateTags, void 0), visitedObjects.has(p.serviceConnectConfiguration) || aws_cdk_lib_aws_ecs_ServiceConnectProps(p.serviceConnectConfiguration);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_IExternalService(p) {
    }
    function aws_cdk_lib_aws_ecs_ExternalServiceAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cluster) || (p.cluster, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_ExternalService(p) {
    }
    function aws_cdk_lib_aws_ecs_ExternalTaskDefinitionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.networkMode) || (p.networkMode, void 0), visitedObjects.has(p.executionRole) || (p.executionRole, void 0), visitedObjects.has(p.proxyConfiguration) || (p.proxyConfiguration, void 0), visitedObjects.has(p.taskRole) || (p.taskRole, void 0), p.volumes != null)
            for (const o of p.volumes)
              visitedObjects.has(o) || aws_cdk_lib_aws_ecs_Volume(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_IExternalTaskDefinition(p) {
    }
    function aws_cdk_lib_aws_ecs_ExternalTaskDefinitionAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.executionRole) || (p.executionRole, void 0), visitedObjects.has(p.networkMode) || (p.networkMode, void 0), visitedObjects.has(p.taskRole) || (p.taskRole, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_ExternalTaskDefinition(p) {
    }
    function aws_cdk_lib_aws_ecs_LinuxParametersProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.maxSwap) || (p.maxSwap, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_LinuxParameters(p) {
    }
    function aws_cdk_lib_aws_ecs_Device(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.permissions != null)
            for (const o of p.permissions)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_Tmpfs(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.mountOptions != null)
            for (const o of p.mountOptions)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_Capability(p) {
    }
    function aws_cdk_lib_aws_ecs_DevicePermission(p) {
    }
    function aws_cdk_lib_aws_ecs_TmpfsMountOption(p) {
    }
    function aws_cdk_lib_aws_ecs_AssetImageProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.cacheFrom != null)
            for (const o of p.cacheFrom)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.cacheTo) || (p.cacheTo, void 0), visitedObjects.has(p.invalidation) || (p.invalidation, void 0), visitedObjects.has(p.networkMode) || (p.networkMode, void 0), visitedObjects.has(p.platform) || (p.platform, void 0), visitedObjects.has(p.followSymlinks) || (p.followSymlinks, void 0), visitedObjects.has(p.ignoreMode) || (p.ignoreMode, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_AssetImage(p) {
    }
    function aws_cdk_lib_aws_ecs_RepositoryImageProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.credentials) || (p.credentials, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_RepositoryImage(p) {
    }
    function aws_cdk_lib_aws_ecs_EcrImage(p) {
    }
    function aws_cdk_lib_aws_ecs_TagParameterContainerImage(p) {
    }
    function aws_cdk_lib_aws_ecs_AwsLogDriverMode(p) {
    }
    function aws_cdk_lib_aws_ecs_AwsLogDriverProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.logGroup) || (p.logGroup, void 0), visitedObjects.has(p.logRetention) || (p.logRetention, void 0), visitedObjects.has(p.mode) || (p.mode, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_AwsLogDriver(p) {
    }
    function aws_cdk_lib_aws_ecs_BaseLogDriverProps(p) {
    }
    function aws_cdk_lib_aws_ecs_FireLensLogDriverProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.secretOptions != null)
            for (const o of Object.values(p.secretOptions))
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_FireLensLogDriver(p) {
    }
    function aws_cdk_lib_aws_ecs_FluentdLogDriverProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.retryWait) || (p.retryWait, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_FluentdLogDriver(p) {
    }
    function aws_cdk_lib_aws_ecs_GelfCompressionType(p) {
    }
    function aws_cdk_lib_aws_ecs_GelfLogDriverProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.compressionType) || (p.compressionType, void 0), visitedObjects.has(p.tcpReconnectDelay) || (p.tcpReconnectDelay, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_GelfLogDriver(p) {
    }
    function aws_cdk_lib_aws_ecs_JournaldLogDriverProps(p) {
    }
    function aws_cdk_lib_aws_ecs_JournaldLogDriver(p) {
    }
    function aws_cdk_lib_aws_ecs_JsonFileLogDriverProps(p) {
    }
    function aws_cdk_lib_aws_ecs_JsonFileLogDriver(p) {
    }
    function aws_cdk_lib_aws_ecs_SplunkLogFormat(p) {
    }
    function aws_cdk_lib_aws_ecs_SplunkLogDriverProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.secretToken) || (p.secretToken, void 0), visitedObjects.has(p.format) || (p.format, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_SplunkLogDriver(p) {
    }
    function aws_cdk_lib_aws_ecs_SyslogLogDriverProps(p) {
    }
    function aws_cdk_lib_aws_ecs_SyslogLogDriver(p) {
    }
    function aws_cdk_lib_aws_ecs_LogDriver(p) {
    }
    function aws_cdk_lib_aws_ecs_LogDriverConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.secretOptions != null)
            for (const o of p.secretOptions)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_GenericLogDriverProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.secretOptions != null)
            for (const o of Object.values(p.secretOptions))
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_GenericLogDriver(p) {
    }
    function aws_cdk_lib_aws_ecs_LogDrivers(p) {
    }
    function aws_cdk_lib_aws_ecs_AppMeshProxyConfigurationProps(p) {
    }
    function aws_cdk_lib_aws_ecs_AppMeshProxyConfigurationConfigProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.properties) || (p.properties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_AppMeshProxyConfiguration(p) {
    }
    function aws_cdk_lib_aws_ecs_ProxyConfiguration(p) {
    }
    function aws_cdk_lib_aws_ecs_ProxyConfigurations(p) {
    }
    function aws_cdk_lib_aws_ecs_CpuArchitecture(p) {
    }
    function aws_cdk_lib_aws_ecs_OperatingSystemFamily(p) {
    }
    function aws_cdk_lib_aws_ecs_RuntimePlatform(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cpuArchitecture) || (p.cpuArchitecture, void 0), visitedObjects.has(p.operatingSystemFamily) || (p.operatingSystemFamily, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_CfnCapacityProviderProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.autoScalingGroupProvider) || (p.autoScalingGroupProvider, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_CfnCapacityProvider(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnCapacityProvider_AutoScalingGroupProviderProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.managedScaling) || (p.managedScaling, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_CfnCapacityProvider_ManagedScalingProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnClusterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.clusterSettings) || (p.clusterSettings, void 0), visitedObjects.has(p.configuration) || (p.configuration, void 0), visitedObjects.has(p.defaultCapacityProviderStrategy) || (p.defaultCapacityProviderStrategy, void 0), visitedObjects.has(p.serviceConnectDefaults) || (p.serviceConnectDefaults, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_CfnCluster(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnCluster_CapacityProviderStrategyItemProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnCluster_ClusterConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.executeCommandConfiguration) || (p.executeCommandConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_CfnCluster_ClusterSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnCluster_ExecuteCommandConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.logConfiguration) || (p.logConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_CfnCluster_ExecuteCommandLogConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnCluster_ServiceConnectDefaultsProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnClusterCapacityProviderAssociationsProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultCapacityProviderStrategy) || (p.defaultCapacityProviderStrategy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_CfnClusterCapacityProviderAssociations(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnClusterCapacityProviderAssociations_CapacityProviderStrategyProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnPrimaryTaskSetProps(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnPrimaryTaskSet(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnServiceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.capacityProviderStrategy) || (p.capacityProviderStrategy, void 0), visitedObjects.has(p.deploymentConfiguration) || (p.deploymentConfiguration, void 0), visitedObjects.has(p.deploymentController) || (p.deploymentController, void 0), visitedObjects.has(p.loadBalancers) || (p.loadBalancers, void 0), visitedObjects.has(p.networkConfiguration) || (p.networkConfiguration, void 0), visitedObjects.has(p.placementConstraints) || (p.placementConstraints, void 0), visitedObjects.has(p.placementStrategies) || (p.placementStrategies, void 0), visitedObjects.has(p.serviceConnectConfiguration) || (p.serviceConnectConfiguration, void 0), visitedObjects.has(p.serviceRegistries) || (p.serviceRegistries, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_CfnService(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnService_AwsVpcConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnService_CapacityProviderStrategyItemProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnService_DeploymentAlarmsProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnService_DeploymentCircuitBreakerProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnService_DeploymentConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.alarms) || (p.alarms, void 0), visitedObjects.has(p.deploymentCircuitBreaker) || (p.deploymentCircuitBreaker, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_CfnService_DeploymentControllerProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnService_LoadBalancerProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnService_LogConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.options) || (p.options, void 0), visitedObjects.has(p.secretOptions) || (p.secretOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_CfnService_NetworkConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.awsvpcConfiguration) || (p.awsvpcConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_CfnService_PlacementConstraintProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnService_PlacementStrategyProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnService_SecretProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnService_ServiceConnectClientAliasProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnService_ServiceConnectConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.logConfiguration) || (p.logConfiguration, void 0), visitedObjects.has(p.services) || (p.services, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_CfnService_ServiceConnectServiceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.clientAliases) || (p.clientAliases, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_CfnService_ServiceRegistryProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinitionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.containerDefinitions) || (p.containerDefinitions, void 0), visitedObjects.has(p.ephemeralStorage) || (p.ephemeralStorage, void 0), visitedObjects.has(p.inferenceAccelerators) || (p.inferenceAccelerators, void 0), visitedObjects.has(p.placementConstraints) || (p.placementConstraints, void 0), visitedObjects.has(p.proxyConfiguration) || (p.proxyConfiguration, void 0), visitedObjects.has(p.runtimePlatform) || (p.runtimePlatform, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.volumes) || (p.volumes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinition(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinition_AuthorizationConfigProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinition_ContainerDefinitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dependsOn) || (p.dependsOn, void 0), visitedObjects.has(p.dockerLabels) || (p.dockerLabels, void 0), visitedObjects.has(p.environment) || (p.environment, void 0), visitedObjects.has(p.environmentFiles) || (p.environmentFiles, void 0), visitedObjects.has(p.extraHosts) || (p.extraHosts, void 0), visitedObjects.has(p.firelensConfiguration) || (p.firelensConfiguration, void 0), visitedObjects.has(p.healthCheck) || (p.healthCheck, void 0), visitedObjects.has(p.linuxParameters) || (p.linuxParameters, void 0), visitedObjects.has(p.logConfiguration) || (p.logConfiguration, void 0), visitedObjects.has(p.mountPoints) || (p.mountPoints, void 0), visitedObjects.has(p.portMappings) || (p.portMappings, void 0), visitedObjects.has(p.repositoryCredentials) || (p.repositoryCredentials, void 0), visitedObjects.has(p.resourceRequirements) || (p.resourceRequirements, void 0), visitedObjects.has(p.secrets) || (p.secrets, void 0), visitedObjects.has(p.systemControls) || (p.systemControls, void 0), visitedObjects.has(p.ulimits) || (p.ulimits, void 0), visitedObjects.has(p.volumesFrom) || (p.volumesFrom, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinition_ContainerDependencyProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinition_DeviceProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinition_DockerVolumeConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.driverOpts) || (p.driverOpts, void 0), visitedObjects.has(p.labels) || (p.labels, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinition_EFSVolumeConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.authorizationConfig) || (p.authorizationConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinition_EnvironmentFileProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinition_EphemeralStorageProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinition_FirelensConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.options) || (p.options, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinition_HealthCheckProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinition_HostEntryProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinition_HostVolumePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinition_InferenceAcceleratorProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinition_KernelCapabilitiesProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinition_KeyValuePairProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinition_LinuxParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.capabilities) || (p.capabilities, void 0), visitedObjects.has(p.devices) || (p.devices, void 0), visitedObjects.has(p.tmpfs) || (p.tmpfs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinition_LogConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.options) || (p.options, void 0), visitedObjects.has(p.secretOptions) || (p.secretOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinition_MountPointProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinition_PortMappingProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinition_ProxyConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.proxyConfigurationProperties) || (p.proxyConfigurationProperties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinition_RepositoryCredentialsProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinition_ResourceRequirementProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinition_RuntimePlatformProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinition_SecretProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinition_SystemControlProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinition_TaskDefinitionPlacementConstraintProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinition_TmpfsProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinition_UlimitProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinition_VolumeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dockerVolumeConfiguration) || (p.dockerVolumeConfiguration, void 0), visitedObjects.has(p.efsVolumeConfiguration) || (p.efsVolumeConfiguration, void 0), visitedObjects.has(p.host) || (p.host, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_CfnTaskDefinition_VolumeFromProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnTaskSetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.loadBalancers) || (p.loadBalancers, void 0), visitedObjects.has(p.networkConfiguration) || (p.networkConfiguration, void 0), visitedObjects.has(p.scale) || (p.scale, void 0), visitedObjects.has(p.serviceRegistries) || (p.serviceRegistries, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_CfnTaskSet(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnTaskSet_AwsVpcConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnTaskSet_LoadBalancerProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnTaskSet_NetworkConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.awsVpcConfiguration) || (p.awsVpcConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_CfnTaskSet_ScaleProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_CfnTaskSet_ServiceRegistryProperty(p) {
    }
    function aws_cdk_lib_aws_ecs_patterns_QueueProcessingEc2ServiceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.placementConstraints != null)
            for (const o of p.placementConstraints)
              visitedObjects.has(o) || void 0;
          if (p.placementStrategies != null)
            for (const o of p.placementStrategies)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.image) || (p.image, void 0), p.capacityProviderStrategies != null)
            for (const o of p.capacityProviderStrategies)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.circuitBreaker) || (p.circuitBreaker, void 0), visitedObjects.has(p.cluster) || (p.cluster, void 0), visitedObjects.has(p.deploymentController) || aws_cdk_lib_aws_ecs_DeploymentController(p.deploymentController), visitedObjects.has(p.logDriver) || (p.logDriver, void 0), visitedObjects.has(p.propagateTags) || (p.propagateTags, void 0), visitedObjects.has(p.queue) || (p.queue, void 0), visitedObjects.has(p.retentionPeriod) || (p.retentionPeriod, void 0), p.scalingSteps != null)
            for (const o of p.scalingSteps)
              visitedObjects.has(o) || void 0;
          if (p.secrets != null)
            for (const o of Object.values(p.secrets))
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.visibilityTimeout) || (p.visibilityTimeout, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_QueueProcessingEc2Service(p) {
    }
    function aws_cdk_lib_aws_ecs_patterns_QueueProcessingFargateServiceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.healthCheck) || aws_cdk_lib_aws_ecs_HealthCheck(p.healthCheck), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.taskSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.taskSubnets), visitedObjects.has(p.image) || (p.image, void 0), p.capacityProviderStrategies != null)
            for (const o of p.capacityProviderStrategies)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.circuitBreaker) || (p.circuitBreaker, void 0), visitedObjects.has(p.cluster) || (p.cluster, void 0), visitedObjects.has(p.deploymentController) || aws_cdk_lib_aws_ecs_DeploymentController(p.deploymentController), visitedObjects.has(p.logDriver) || (p.logDriver, void 0), visitedObjects.has(p.propagateTags) || (p.propagateTags, void 0), visitedObjects.has(p.queue) || (p.queue, void 0), visitedObjects.has(p.retentionPeriod) || (p.retentionPeriod, void 0), p.scalingSteps != null)
            for (const o of p.scalingSteps)
              visitedObjects.has(o) || void 0;
          if (p.secrets != null)
            for (const o of Object.values(p.secrets))
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.visibilityTimeout) || (p.visibilityTimeout, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.platformVersion) || (p.platformVersion, void 0), visitedObjects.has(p.runtimePlatform) || aws_cdk_lib_aws_ecs_RuntimePlatform(p.runtimePlatform), visitedObjects.has(p.taskDefinition) || (p.taskDefinition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_QueueProcessingFargateService(p) {
    }
    function aws_cdk_lib_aws_ecs_patterns_QueueProcessingServiceBaseProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.image) || (p.image, void 0), p.capacityProviderStrategies != null)
            for (const o of p.capacityProviderStrategies)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.circuitBreaker) || (p.circuitBreaker, void 0), visitedObjects.has(p.cluster) || (p.cluster, void 0), visitedObjects.has(p.deploymentController) || aws_cdk_lib_aws_ecs_DeploymentController(p.deploymentController), visitedObjects.has(p.logDriver) || (p.logDriver, void 0), visitedObjects.has(p.propagateTags) || (p.propagateTags, void 0), visitedObjects.has(p.queue) || (p.queue, void 0), visitedObjects.has(p.retentionPeriod) || (p.retentionPeriod, void 0), p.scalingSteps != null)
            for (const o of p.scalingSteps)
              visitedObjects.has(o) || void 0;
          if (p.secrets != null)
            for (const o of Object.values(p.secrets))
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.visibilityTimeout) || (p.visibilityTimeout, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_QueueProcessingServiceBase(p) {
    }
    function aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancedEc2ServiceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.placementConstraints != null)
            for (const o of p.placementConstraints)
              visitedObjects.has(o) || void 0;
          if (p.placementStrategies != null)
            for (const o of p.placementStrategies)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.taskDefinition) || (p.taskDefinition, void 0), p.capacityProviderStrategies != null)
            for (const o of p.capacityProviderStrategies)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.circuitBreaker) || (p.circuitBreaker, void 0), visitedObjects.has(p.cloudMapOptions) || aws_cdk_lib_aws_ecs_CloudMapOptions(p.cloudMapOptions), visitedObjects.has(p.cluster) || (p.cluster, void 0), visitedObjects.has(p.deploymentController) || aws_cdk_lib_aws_ecs_DeploymentController(p.deploymentController), visitedObjects.has(p.domainZone) || (p.domainZone, void 0), visitedObjects.has(p.healthCheckGracePeriod) || (p.healthCheckGracePeriod, void 0), visitedObjects.has(p.loadBalancer) || (p.loadBalancer, void 0), visitedObjects.has(p.propagateTags) || (p.propagateTags, void 0), visitedObjects.has(p.recordType) || (p.recordType, void 0), visitedObjects.has(p.taskImageOptions) || aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancedTaskImageOptions(p.taskImageOptions), visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancedEc2Service(p) {
    }
    function aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancedFargateServiceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.taskSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.taskSubnets), p.capacityProviderStrategies != null)
            for (const o of p.capacityProviderStrategies)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.circuitBreaker) || (p.circuitBreaker, void 0), visitedObjects.has(p.cloudMapOptions) || aws_cdk_lib_aws_ecs_CloudMapOptions(p.cloudMapOptions), visitedObjects.has(p.cluster) || (p.cluster, void 0), visitedObjects.has(p.deploymentController) || aws_cdk_lib_aws_ecs_DeploymentController(p.deploymentController), visitedObjects.has(p.domainZone) || (p.domainZone, void 0), visitedObjects.has(p.healthCheckGracePeriod) || (p.healthCheckGracePeriod, void 0), visitedObjects.has(p.loadBalancer) || (p.loadBalancer, void 0), visitedObjects.has(p.propagateTags) || (p.propagateTags, void 0), visitedObjects.has(p.recordType) || (p.recordType, void 0), visitedObjects.has(p.taskImageOptions) || aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancedTaskImageOptions(p.taskImageOptions), visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.platformVersion) || (p.platformVersion, void 0), visitedObjects.has(p.runtimePlatform) || aws_cdk_lib_aws_ecs_RuntimePlatform(p.runtimePlatform), visitedObjects.has(p.taskDefinition) || (p.taskDefinition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancedFargateService(p) {
    }
    function aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancedServiceRecordType(p) {
    }
    function aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancedServiceBaseProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.capacityProviderStrategies != null)
            for (const o of p.capacityProviderStrategies)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.circuitBreaker) || (p.circuitBreaker, void 0), visitedObjects.has(p.cloudMapOptions) || aws_cdk_lib_aws_ecs_CloudMapOptions(p.cloudMapOptions), visitedObjects.has(p.cluster) || (p.cluster, void 0), visitedObjects.has(p.deploymentController) || aws_cdk_lib_aws_ecs_DeploymentController(p.deploymentController), visitedObjects.has(p.domainZone) || (p.domainZone, void 0), visitedObjects.has(p.healthCheckGracePeriod) || (p.healthCheckGracePeriod, void 0), visitedObjects.has(p.loadBalancer) || (p.loadBalancer, void 0), visitedObjects.has(p.propagateTags) || (p.propagateTags, void 0), visitedObjects.has(p.recordType) || (p.recordType, void 0), visitedObjects.has(p.taskImageOptions) || aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancedTaskImageOptions(p.taskImageOptions), visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancedTaskImageOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.image) || (p.image, void 0), visitedObjects.has(p.executionRole) || (p.executionRole, void 0), visitedObjects.has(p.logDriver) || (p.logDriver, void 0), p.secrets != null)
            for (const o of Object.values(p.secrets))
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.taskRole) || (p.taskRole, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancedServiceBase(p) {
    }
    function aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancedEc2ServiceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.placementConstraints != null)
            for (const o of p.placementConstraints)
              visitedObjects.has(o) || void 0;
          if (p.placementStrategies != null)
            for (const o of p.placementStrategies)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.taskDefinition) || (p.taskDefinition, void 0), p.capacityProviderStrategies != null)
            for (const o of p.capacityProviderStrategies)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.certificate) || (p.certificate, void 0), visitedObjects.has(p.circuitBreaker) || (p.circuitBreaker, void 0), visitedObjects.has(p.cloudMapOptions) || aws_cdk_lib_aws_ecs_CloudMapOptions(p.cloudMapOptions), visitedObjects.has(p.cluster) || (p.cluster, void 0), visitedObjects.has(p.deploymentController) || aws_cdk_lib_aws_ecs_DeploymentController(p.deploymentController), visitedObjects.has(p.domainZone) || (p.domainZone, void 0), visitedObjects.has(p.healthCheckGracePeriod) || (p.healthCheckGracePeriod, void 0), visitedObjects.has(p.idleTimeout) || (p.idleTimeout, void 0), visitedObjects.has(p.loadBalancer) || (p.loadBalancer, void 0), visitedObjects.has(p.propagateTags) || (p.propagateTags, void 0), visitedObjects.has(p.protocol) || (p.protocol, void 0), visitedObjects.has(p.protocolVersion) || (p.protocolVersion, void 0), visitedObjects.has(p.recordType) || (p.recordType, void 0), visitedObjects.has(p.sslPolicy) || (p.sslPolicy, void 0), visitedObjects.has(p.targetProtocol) || (p.targetProtocol, void 0), visitedObjects.has(p.taskImageOptions) || aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancedTaskImageOptions(p.taskImageOptions), visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancedEc2Service(p) {
    }
    function aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancedFargateServiceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.taskSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.taskSubnets), p.capacityProviderStrategies != null)
            for (const o of p.capacityProviderStrategies)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.certificate) || (p.certificate, void 0), visitedObjects.has(p.circuitBreaker) || (p.circuitBreaker, void 0), visitedObjects.has(p.cloudMapOptions) || aws_cdk_lib_aws_ecs_CloudMapOptions(p.cloudMapOptions), visitedObjects.has(p.cluster) || (p.cluster, void 0), visitedObjects.has(p.deploymentController) || aws_cdk_lib_aws_ecs_DeploymentController(p.deploymentController), visitedObjects.has(p.domainZone) || (p.domainZone, void 0), visitedObjects.has(p.healthCheckGracePeriod) || (p.healthCheckGracePeriod, void 0), visitedObjects.has(p.idleTimeout) || (p.idleTimeout, void 0), visitedObjects.has(p.loadBalancer) || (p.loadBalancer, void 0), visitedObjects.has(p.propagateTags) || (p.propagateTags, void 0), visitedObjects.has(p.protocol) || (p.protocol, void 0), visitedObjects.has(p.protocolVersion) || (p.protocolVersion, void 0), visitedObjects.has(p.recordType) || (p.recordType, void 0), visitedObjects.has(p.sslPolicy) || (p.sslPolicy, void 0), visitedObjects.has(p.targetProtocol) || (p.targetProtocol, void 0), visitedObjects.has(p.taskImageOptions) || aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancedTaskImageOptions(p.taskImageOptions), visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.platformVersion) || (p.platformVersion, void 0), visitedObjects.has(p.runtimePlatform) || aws_cdk_lib_aws_ecs_RuntimePlatform(p.runtimePlatform), visitedObjects.has(p.taskDefinition) || (p.taskDefinition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancedFargateService(p) {
    }
    function aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancedServiceRecordType(p) {
    }
    function aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancedServiceBaseProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.capacityProviderStrategies != null)
            for (const o of p.capacityProviderStrategies)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.certificate) || (p.certificate, void 0), visitedObjects.has(p.circuitBreaker) || (p.circuitBreaker, void 0), visitedObjects.has(p.cloudMapOptions) || aws_cdk_lib_aws_ecs_CloudMapOptions(p.cloudMapOptions), visitedObjects.has(p.cluster) || (p.cluster, void 0), visitedObjects.has(p.deploymentController) || aws_cdk_lib_aws_ecs_DeploymentController(p.deploymentController), visitedObjects.has(p.domainZone) || (p.domainZone, void 0), visitedObjects.has(p.healthCheckGracePeriod) || (p.healthCheckGracePeriod, void 0), visitedObjects.has(p.idleTimeout) || (p.idleTimeout, void 0), visitedObjects.has(p.loadBalancer) || (p.loadBalancer, void 0), visitedObjects.has(p.propagateTags) || (p.propagateTags, void 0), visitedObjects.has(p.protocol) || (p.protocol, void 0), visitedObjects.has(p.protocolVersion) || (p.protocolVersion, void 0), visitedObjects.has(p.recordType) || (p.recordType, void 0), visitedObjects.has(p.sslPolicy) || (p.sslPolicy, void 0), visitedObjects.has(p.targetProtocol) || (p.targetProtocol, void 0), visitedObjects.has(p.taskImageOptions) || aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancedTaskImageOptions(p.taskImageOptions), visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancedTaskImageOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.image) || (p.image, void 0), visitedObjects.has(p.executionRole) || (p.executionRole, void 0), visitedObjects.has(p.logDriver) || (p.logDriver, void 0), p.secrets != null)
            for (const o of Object.values(p.secrets))
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.taskRole) || (p.taskRole, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancedServiceBase(p) {
    }
    function aws_cdk_lib_aws_ecs_patterns_FargateServiceBaseProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.platformVersion) || (p.platformVersion, void 0), visitedObjects.has(p.runtimePlatform) || aws_cdk_lib_aws_ecs_RuntimePlatform(p.runtimePlatform), visitedObjects.has(p.taskDefinition) || (p.taskDefinition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_ScheduledEc2TaskProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.scheduledEc2TaskDefinitionOptions) || aws_cdk_lib_aws_ecs_patterns_ScheduledEc2TaskDefinitionOptions(p.scheduledEc2TaskDefinitionOptions), visitedObjects.has(p.scheduledEc2TaskImageOptions) || aws_cdk_lib_aws_ecs_patterns_ScheduledEc2TaskImageOptions(p.scheduledEc2TaskImageOptions), visitedObjects.has(p.schedule) || (p.schedule, void 0), visitedObjects.has(p.cluster) || (p.cluster, void 0), visitedObjects.has(p.propagateTags) || (p.propagateTags, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.subnetSelection) || aws_cdk_lib_aws_ec2_SubnetSelection(p.subnetSelection), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_ScheduledEc2TaskImageOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.image) || (p.image, void 0), visitedObjects.has(p.logDriver) || (p.logDriver, void 0), p.secrets != null)
            for (const o of Object.values(p.secrets))
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_ScheduledEc2TaskDefinitionOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.taskDefinition) || (p.taskDefinition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_ScheduledEc2Task(p) {
    }
    function aws_cdk_lib_aws_ecs_patterns_ScheduledFargateTaskProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.scheduledFargateTaskDefinitionOptions) || aws_cdk_lib_aws_ecs_patterns_ScheduledFargateTaskDefinitionOptions(p.scheduledFargateTaskDefinitionOptions), visitedObjects.has(p.scheduledFargateTaskImageOptions) || aws_cdk_lib_aws_ecs_patterns_ScheduledFargateTaskImageOptions(p.scheduledFargateTaskImageOptions), visitedObjects.has(p.schedule) || (p.schedule, void 0), visitedObjects.has(p.cluster) || (p.cluster, void 0), visitedObjects.has(p.propagateTags) || (p.propagateTags, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.subnetSelection) || aws_cdk_lib_aws_ec2_SubnetSelection(p.subnetSelection), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.platformVersion) || (p.platformVersion, void 0), visitedObjects.has(p.runtimePlatform) || aws_cdk_lib_aws_ecs_RuntimePlatform(p.runtimePlatform), visitedObjects.has(p.taskDefinition) || (p.taskDefinition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_ScheduledFargateTaskImageOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.image) || (p.image, void 0), visitedObjects.has(p.logDriver) || (p.logDriver, void 0), p.secrets != null)
            for (const o of Object.values(p.secrets))
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.platformVersion) || (p.platformVersion, void 0), visitedObjects.has(p.runtimePlatform) || aws_cdk_lib_aws_ecs_RuntimePlatform(p.runtimePlatform), visitedObjects.has(p.taskDefinition) || (p.taskDefinition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_ScheduledFargateTaskDefinitionOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.taskDefinition) || (p.taskDefinition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_ScheduledFargateTask(p) {
    }
    function aws_cdk_lib_aws_ecs_patterns_ScheduledTaskBaseProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.schedule) || (p.schedule, void 0), visitedObjects.has(p.cluster) || (p.cluster, void 0), visitedObjects.has(p.propagateTags) || (p.propagateTags, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.subnetSelection) || aws_cdk_lib_aws_ec2_SubnetSelection(p.subnetSelection), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_ScheduledTaskImageProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.image) || (p.image, void 0), visitedObjects.has(p.logDriver) || (p.logDriver, void 0), p.secrets != null)
            for (const o of Object.values(p.secrets))
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_ScheduledTaskBase(p) {
    }
    function aws_cdk_lib_aws_ecs_patterns_ApplicationMultipleTargetGroupsServiceBaseProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.cloudMapOptions) || aws_cdk_lib_aws_ecs_CloudMapOptions(p.cloudMapOptions), visitedObjects.has(p.cluster) || (p.cluster, void 0), visitedObjects.has(p.healthCheckGracePeriod) || (p.healthCheckGracePeriod, void 0), p.loadBalancers != null)
            for (const o of p.loadBalancers)
              visitedObjects.has(o) || aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancerProps(o);
          if (visitedObjects.has(p.propagateTags) || (p.propagateTags, void 0), p.targetGroups != null)
            for (const o of p.targetGroups)
              visitedObjects.has(o) || aws_cdk_lib_aws_ecs_patterns_ApplicationTargetProps(o);
          visitedObjects.has(p.taskImageOptions) || aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancedTaskImageProps(p.taskImageOptions), visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancedTaskImageProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.image) || (p.image, void 0), visitedObjects.has(p.executionRole) || (p.executionRole, void 0), visitedObjects.has(p.logDriver) || (p.logDriver, void 0), p.secrets != null)
            for (const o of Object.values(p.secrets))
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.taskRole) || (p.taskRole, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_ApplicationTargetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.protocol) || (p.protocol, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.listeners != null)
            for (const o of p.listeners)
              visitedObjects.has(o) || aws_cdk_lib_aws_ecs_patterns_ApplicationListenerProps(o);
          visitedObjects.has(p.domainZone) || (p.domainZone, void 0), visitedObjects.has(p.idleTimeout) || (p.idleTimeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_ApplicationListenerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.certificate) || (p.certificate, void 0), visitedObjects.has(p.protocol) || (p.protocol, void 0), visitedObjects.has(p.sslPolicy) || (p.sslPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_ApplicationMultipleTargetGroupsServiceBase(p) {
    }
    function aws_cdk_lib_aws_ecs_patterns_ApplicationMultipleTargetGroupsEc2ServiceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.placementConstraints != null)
            for (const o of p.placementConstraints)
              visitedObjects.has(o) || void 0;
          if (p.placementStrategies != null)
            for (const o of p.placementStrategies)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.taskDefinition) || (p.taskDefinition, void 0), visitedObjects.has(p.cloudMapOptions) || aws_cdk_lib_aws_ecs_CloudMapOptions(p.cloudMapOptions), visitedObjects.has(p.cluster) || (p.cluster, void 0), visitedObjects.has(p.healthCheckGracePeriod) || (p.healthCheckGracePeriod, void 0), p.loadBalancers != null)
            for (const o of p.loadBalancers)
              visitedObjects.has(o) || aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancerProps(o);
          if (visitedObjects.has(p.propagateTags) || (p.propagateTags, void 0), p.targetGroups != null)
            for (const o of p.targetGroups)
              visitedObjects.has(o) || aws_cdk_lib_aws_ecs_patterns_ApplicationTargetProps(o);
          visitedObjects.has(p.taskImageOptions) || aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancedTaskImageProps(p.taskImageOptions), visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_ApplicationMultipleTargetGroupsEc2Service(p) {
    }
    function aws_cdk_lib_aws_ecs_patterns_ApplicationMultipleTargetGroupsFargateServiceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.cloudMapOptions) || aws_cdk_lib_aws_ecs_CloudMapOptions(p.cloudMapOptions), visitedObjects.has(p.cluster) || (p.cluster, void 0), visitedObjects.has(p.healthCheckGracePeriod) || (p.healthCheckGracePeriod, void 0), p.loadBalancers != null)
            for (const o of p.loadBalancers)
              visitedObjects.has(o) || aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancerProps(o);
          if (visitedObjects.has(p.propagateTags) || (p.propagateTags, void 0), p.targetGroups != null)
            for (const o of p.targetGroups)
              visitedObjects.has(o) || aws_cdk_lib_aws_ecs_patterns_ApplicationTargetProps(o);
          visitedObjects.has(p.taskImageOptions) || aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancedTaskImageProps(p.taskImageOptions), visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.platformVersion) || (p.platformVersion, void 0), visitedObjects.has(p.runtimePlatform) || aws_cdk_lib_aws_ecs_RuntimePlatform(p.runtimePlatform), visitedObjects.has(p.taskDefinition) || (p.taskDefinition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_ApplicationMultipleTargetGroupsFargateService(p) {
    }
    function aws_cdk_lib_aws_ecs_patterns_NetworkMultipleTargetGroupsServiceBaseProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.cloudMapOptions) || aws_cdk_lib_aws_ecs_CloudMapOptions(p.cloudMapOptions), visitedObjects.has(p.cluster) || (p.cluster, void 0), visitedObjects.has(p.healthCheckGracePeriod) || (p.healthCheckGracePeriod, void 0), p.loadBalancers != null)
            for (const o of p.loadBalancers)
              visitedObjects.has(o) || aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancerProps(o);
          if (visitedObjects.has(p.propagateTags) || (p.propagateTags, void 0), p.targetGroups != null)
            for (const o of p.targetGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.taskImageOptions) || aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancedTaskImageProps(p.taskImageOptions), visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancedTaskImageProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.image) || (p.image, void 0), visitedObjects.has(p.executionRole) || (p.executionRole, void 0), visitedObjects.has(p.logDriver) || (p.logDriver, void 0), p.secrets != null)
            for (const o of Object.values(p.secrets))
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.taskRole) || (p.taskRole, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.listeners != null)
            for (const o of p.listeners)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.domainZone) || (p.domainZone, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_NetworkListenerProps(p) {
    }
    function aws_cdk_lib_aws_ecs_patterns_NetworkTargetProps(p) {
    }
    function aws_cdk_lib_aws_ecs_patterns_NetworkMultipleTargetGroupsServiceBase(p) {
    }
    function aws_cdk_lib_aws_ecs_patterns_NetworkMultipleTargetGroupsEc2ServiceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.placementConstraints != null)
            for (const o of p.placementConstraints)
              visitedObjects.has(o) || void 0;
          if (p.placementStrategies != null)
            for (const o of p.placementStrategies)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.taskDefinition) || (p.taskDefinition, void 0), visitedObjects.has(p.cloudMapOptions) || aws_cdk_lib_aws_ecs_CloudMapOptions(p.cloudMapOptions), visitedObjects.has(p.cluster) || (p.cluster, void 0), visitedObjects.has(p.healthCheckGracePeriod) || (p.healthCheckGracePeriod, void 0), p.loadBalancers != null)
            for (const o of p.loadBalancers)
              visitedObjects.has(o) || aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancerProps(o);
          if (visitedObjects.has(p.propagateTags) || (p.propagateTags, void 0), p.targetGroups != null)
            for (const o of p.targetGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.taskImageOptions) || aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancedTaskImageProps(p.taskImageOptions), visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_NetworkMultipleTargetGroupsEc2Service(p) {
    }
    function aws_cdk_lib_aws_ecs_patterns_NetworkMultipleTargetGroupsFargateServiceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.cloudMapOptions) || aws_cdk_lib_aws_ecs_CloudMapOptions(p.cloudMapOptions), visitedObjects.has(p.cluster) || (p.cluster, void 0), visitedObjects.has(p.healthCheckGracePeriod) || (p.healthCheckGracePeriod, void 0), p.loadBalancers != null)
            for (const o of p.loadBalancers)
              visitedObjects.has(o) || aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancerProps(o);
          if (visitedObjects.has(p.propagateTags) || (p.propagateTags, void 0), p.targetGroups != null)
            for (const o of p.targetGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.taskImageOptions) || aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancedTaskImageProps(p.taskImageOptions), visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.platformVersion) || (p.platformVersion, void 0), visitedObjects.has(p.runtimePlatform) || aws_cdk_lib_aws_ecs_RuntimePlatform(p.runtimePlatform), visitedObjects.has(p.taskDefinition) || (p.taskDefinition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ecs_patterns_NetworkMultipleTargetGroupsFargateService(p) {
    }
    function aws_cdk_lib_aws_efs_IAccessPoint(p) {
    }
    function aws_cdk_lib_aws_efs_Acl(p) {
    }
    function aws_cdk_lib_aws_efs_PosixUser(p) {
    }
    function aws_cdk_lib_aws_efs_AccessPointOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.createAcl) || (p.createAcl, void 0), visitedObjects.has(p.posixUser) || (p.posixUser, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_efs_AccessPointProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fileSystem) || (p.fileSystem, void 0), visitedObjects.has(p.createAcl) || (p.createAcl, void 0), visitedObjects.has(p.posixUser) || (p.posixUser, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_efs_AccessPointAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fileSystem) || (p.fileSystem, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_efs_AccessPoint(p) {
    }
    function aws_cdk_lib_aws_efs_LifecyclePolicy(p) {
    }
    function aws_cdk_lib_aws_efs_OutOfInfrequentAccessPolicy(p) {
    }
    function aws_cdk_lib_aws_efs_PerformanceMode(p) {
    }
    function aws_cdk_lib_aws_efs_ThroughputMode(p) {
    }
    function aws_cdk_lib_aws_efs_IFileSystem(p) {
    }
    function aws_cdk_lib_aws_efs_FileSystemProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.fileSystemPolicy) || (p.fileSystemPolicy, void 0), visitedObjects.has(p.kmsKey) || (p.kmsKey, void 0), visitedObjects.has(p.lifecyclePolicy) || (p.lifecyclePolicy, void 0), visitedObjects.has(p.outOfInfrequentAccessPolicy) || (p.outOfInfrequentAccessPolicy, void 0), visitedObjects.has(p.performanceMode) || (p.performanceMode, void 0), visitedObjects.has(p.provisionedThroughputPerSecond) || (p.provisionedThroughputPerSecond, void 0), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), visitedObjects.has(p.securityGroup) || (p.securityGroup, void 0), visitedObjects.has(p.throughputMode) || (p.throughputMode, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_efs_FileSystemAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.securityGroup) || (p.securityGroup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_efs_FileSystem(p) {
    }
    function aws_cdk_lib_aws_efs_CfnAccessPointProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.accessPointTags != null)
            for (const o of p.accessPointTags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.posixUser) || (p.posixUser, void 0), visitedObjects.has(p.rootDirectory) || (p.rootDirectory, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_efs_CfnAccessPoint(p) {
    }
    function aws_cdk_lib_aws_efs_CfnAccessPoint_AccessPointTagProperty(p) {
    }
    function aws_cdk_lib_aws_efs_CfnAccessPoint_CreationInfoProperty(p) {
    }
    function aws_cdk_lib_aws_efs_CfnAccessPoint_PosixUserProperty(p) {
    }
    function aws_cdk_lib_aws_efs_CfnAccessPoint_RootDirectoryProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.creationInfo) || (p.creationInfo, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_efs_CfnFileSystemProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.backupPolicy) || (p.backupPolicy, void 0), p.fileSystemTags != null)
            for (const o of p.fileSystemTags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.lifecyclePolicies) || (p.lifecyclePolicies, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_efs_CfnFileSystem(p) {
    }
    function aws_cdk_lib_aws_efs_CfnFileSystem_BackupPolicyProperty(p) {
    }
    function aws_cdk_lib_aws_efs_CfnFileSystem_ElasticFileSystemTagProperty(p) {
    }
    function aws_cdk_lib_aws_efs_CfnFileSystem_LifecyclePolicyProperty(p) {
    }
    function aws_cdk_lib_aws_efs_CfnMountTargetProps(p) {
    }
    function aws_cdk_lib_aws_efs_CfnMountTarget(p) {
    }
    function aws_cdk_lib_aws_eks_AwsAuthProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cluster) || (p.cluster, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_AwsAuth(p) {
    }
    function aws_cdk_lib_aws_eks_AwsAuthMapping(p) {
    }
    function aws_cdk_lib_aws_eks_ICluster(p) {
    }
    function aws_cdk_lib_aws_eks_ClusterAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.awscliLayer) || (p.awscliLayer, void 0), visitedObjects.has(p.kubectlLambdaRole) || (p.kubectlLambdaRole, void 0), visitedObjects.has(p.kubectlLayer) || (p.kubectlLayer, void 0), visitedObjects.has(p.kubectlMemory) || (p.kubectlMemory, void 0), visitedObjects.has(p.kubectlProvider) || (p.kubectlProvider, void 0), visitedObjects.has(p.onEventLayer) || (p.onEventLayer, void 0), visitedObjects.has(p.openIdConnectProvider) || (p.openIdConnectProvider, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_CommonClusterOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.version) || (p.version, void 0), visitedObjects.has(p.role) || (p.role, void 0), visitedObjects.has(p.securityGroup) || (p.securityGroup, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0), p.vpcSubnets != null)
            for (const o of p.vpcSubnets)
              visitedObjects.has(o) || aws_cdk_lib_aws_ec2_SubnetSelection(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_ClusterOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.albController) || aws_cdk_lib_aws_eks_AlbControllerOptions(p.albController), visitedObjects.has(p.awscliLayer) || (p.awscliLayer, void 0), visitedObjects.has(p.clusterHandlerSecurityGroup) || (p.clusterHandlerSecurityGroup, void 0), p.clusterLogging != null)
            for (const o of p.clusterLogging)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.coreDnsComputeType) || (p.coreDnsComputeType, void 0), visitedObjects.has(p.endpointAccess) || (p.endpointAccess, void 0), visitedObjects.has(p.kubectlLayer) || (p.kubectlLayer, void 0), visitedObjects.has(p.kubectlMemory) || (p.kubectlMemory, void 0), visitedObjects.has(p.mastersRole) || (p.mastersRole, void 0), visitedObjects.has(p.onEventLayer) || (p.onEventLayer, void 0), visitedObjects.has(p.secretsEncryptionKey) || (p.secretsEncryptionKey, void 0), visitedObjects.has(p.version) || (p.version, void 0), visitedObjects.has(p.role) || (p.role, void 0), visitedObjects.has(p.securityGroup) || (p.securityGroup, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0), p.vpcSubnets != null)
            for (const o of p.vpcSubnets)
              visitedObjects.has(o) || aws_cdk_lib_aws_ec2_SubnetSelection(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_EndpointAccess(p) {
    }
    function aws_cdk_lib_aws_eks_ClusterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.defaultCapacityInstance) || (p.defaultCapacityInstance, void 0), visitedObjects.has(p.defaultCapacityType) || (p.defaultCapacityType, void 0), visitedObjects.has(p.kubectlLambdaRole) || (p.kubectlLambdaRole, void 0), visitedObjects.has(p.albController) || aws_cdk_lib_aws_eks_AlbControllerOptions(p.albController), visitedObjects.has(p.awscliLayer) || (p.awscliLayer, void 0), visitedObjects.has(p.clusterHandlerSecurityGroup) || (p.clusterHandlerSecurityGroup, void 0), p.clusterLogging != null)
            for (const o of p.clusterLogging)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.coreDnsComputeType) || (p.coreDnsComputeType, void 0), visitedObjects.has(p.endpointAccess) || (p.endpointAccess, void 0), visitedObjects.has(p.kubectlLayer) || (p.kubectlLayer, void 0), visitedObjects.has(p.kubectlMemory) || (p.kubectlMemory, void 0), visitedObjects.has(p.mastersRole) || (p.mastersRole, void 0), visitedObjects.has(p.onEventLayer) || (p.onEventLayer, void 0), visitedObjects.has(p.secretsEncryptionKey) || (p.secretsEncryptionKey, void 0), visitedObjects.has(p.version) || (p.version, void 0), visitedObjects.has(p.role) || (p.role, void 0), visitedObjects.has(p.securityGroup) || (p.securityGroup, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0), p.vpcSubnets != null)
            for (const o of p.vpcSubnets)
              visitedObjects.has(o) || aws_cdk_lib_aws_ec2_SubnetSelection(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_KubernetesVersion(p) {
    }
    function aws_cdk_lib_aws_eks_ClusterLoggingTypes(p) {
    }
    function aws_cdk_lib_aws_eks_ServiceLoadBalancerAddressOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_IngressLoadBalancerAddressOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_Cluster(p) {
    }
    function aws_cdk_lib_aws_eks_AutoScalingGroupCapacityOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.instanceType) || (p.instanceType, void 0), visitedObjects.has(p.bootstrapOptions) || (p.bootstrapOptions, void 0), visitedObjects.has(p.machineImageType) || (p.machineImageType, void 0), p.blockDevices != null)
            for (const o of p.blockDevices)
              visitedObjects.has(o) || aws_cdk_lib_aws_autoscaling_BlockDevice(o);
          if (visitedObjects.has(p.cooldown) || (p.cooldown, void 0), visitedObjects.has(p.defaultInstanceWarmup) || (p.defaultInstanceWarmup, void 0), p.groupMetrics != null)
            for (const o of p.groupMetrics)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.healthCheck) || (p.healthCheck, void 0), visitedObjects.has(p.instanceMonitoring) || (p.instanceMonitoring, void 0), visitedObjects.has(p.maxInstanceLifetime) || (p.maxInstanceLifetime, void 0), p.notifications != null)
            for (const o of p.notifications)
              visitedObjects.has(o) || aws_cdk_lib_aws_autoscaling_NotificationConfiguration(o);
          if (visitedObjects.has(p.signals) || (p.signals, void 0), p.terminationPolicies != null)
            for (const o of p.terminationPolicies)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.updatePolicy) || (p.updatePolicy, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_BootstrapOptions(p) {
    }
    function aws_cdk_lib_aws_eks_AutoScalingGroupOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bootstrapOptions) || (p.bootstrapOptions, void 0), visitedObjects.has(p.machineImageType) || (p.machineImageType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_EksOptimizedImageProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cpuArch) || (p.cpuArch, void 0), visitedObjects.has(p.nodeType) || (p.nodeType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_EksOptimizedImage(p) {
    }
    function aws_cdk_lib_aws_eks_NodeType(p) {
    }
    function aws_cdk_lib_aws_eks_CpuArch(p) {
    }
    function aws_cdk_lib_aws_eks_CoreDnsComputeType(p) {
    }
    function aws_cdk_lib_aws_eks_DefaultCapacityType(p) {
    }
    function aws_cdk_lib_aws_eks_MachineImageType(p) {
    }
    function aws_cdk_lib_aws_eks_CfnAddonProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_CfnAddon(p) {
    }
    function aws_cdk_lib_aws_eks_CfnClusterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.resourcesVpcConfig) || (p.resourcesVpcConfig, void 0), visitedObjects.has(p.encryptionConfig) || (p.encryptionConfig, void 0), visitedObjects.has(p.kubernetesNetworkConfig) || (p.kubernetesNetworkConfig, void 0), visitedObjects.has(p.logging) || (p.logging, void 0), visitedObjects.has(p.outpostConfig) || (p.outpostConfig, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_CfnCluster(p) {
    }
    function aws_cdk_lib_aws_eks_CfnCluster_ClusterLoggingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.enabledTypes) || (p.enabledTypes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_CfnCluster_ControlPlanePlacementProperty(p) {
    }
    function aws_cdk_lib_aws_eks_CfnCluster_EncryptionConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.provider) || (p.provider, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_CfnCluster_KubernetesNetworkConfigProperty(p) {
    }
    function aws_cdk_lib_aws_eks_CfnCluster_LoggingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.clusterLogging) || (p.clusterLogging, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_CfnCluster_LoggingTypeConfigProperty(p) {
    }
    function aws_cdk_lib_aws_eks_CfnCluster_OutpostConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.controlPlanePlacement) || (p.controlPlanePlacement, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_CfnCluster_ProviderProperty(p) {
    }
    function aws_cdk_lib_aws_eks_CfnCluster_ResourcesVpcConfigProperty(p) {
    }
    function aws_cdk_lib_aws_eks_CfnFargateProfileProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.selectors) || (p.selectors, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_CfnFargateProfile(p) {
    }
    function aws_cdk_lib_aws_eks_CfnFargateProfile_LabelProperty(p) {
    }
    function aws_cdk_lib_aws_eks_CfnFargateProfile_SelectorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.labels) || (p.labels, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_CfnIdentityProviderConfigProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.oidc) || (p.oidc, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_CfnIdentityProviderConfig(p) {
    }
    function aws_cdk_lib_aws_eks_CfnIdentityProviderConfig_OidcIdentityProviderConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.requiredClaims) || (p.requiredClaims, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_CfnIdentityProviderConfig_RequiredClaimProperty(p) {
    }
    function aws_cdk_lib_aws_eks_CfnNodegroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.labels) || (p.labels, void 0), visitedObjects.has(p.launchTemplate) || (p.launchTemplate, void 0), visitedObjects.has(p.remoteAccess) || (p.remoteAccess, void 0), visitedObjects.has(p.scalingConfig) || (p.scalingConfig, void 0), visitedObjects.has(p.taints) || (p.taints, void 0), visitedObjects.has(p.updateConfig) || (p.updateConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_CfnNodegroup(p) {
    }
    function aws_cdk_lib_aws_eks_CfnNodegroup_LaunchTemplateSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_eks_CfnNodegroup_RemoteAccessProperty(p) {
    }
    function aws_cdk_lib_aws_eks_CfnNodegroup_ScalingConfigProperty(p) {
    }
    function aws_cdk_lib_aws_eks_CfnNodegroup_TaintProperty(p) {
    }
    function aws_cdk_lib_aws_eks_CfnNodegroup_UpdateConfigProperty(p) {
    }
    function aws_cdk_lib_aws_eks_FargateProfileOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.selectors != null)
            for (const o of p.selectors)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.podExecutionRole) || (p.podExecutionRole, void 0), visitedObjects.has(p.subnetSelection) || aws_cdk_lib_aws_ec2_SubnetSelection(p.subnetSelection), visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_FargateProfileProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.cluster) || (p.cluster, void 0), p.selectors != null)
            for (const o of p.selectors)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.podExecutionRole) || (p.podExecutionRole, void 0), visitedObjects.has(p.subnetSelection) || aws_cdk_lib_aws_ec2_SubnetSelection(p.subnetSelection), visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_Selector(p) {
    }
    function aws_cdk_lib_aws_eks_FargateProfile(p) {
    }
    function aws_cdk_lib_aws_eks_HelmChartOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.chartAsset) || (p.chartAsset, void 0), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_HelmChartProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cluster) || (p.cluster, void 0), visitedObjects.has(p.chartAsset) || (p.chartAsset, void 0), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_HelmChart(p) {
    }
    function aws_cdk_lib_aws_eks_KubernetesPatchProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cluster) || (p.cluster, void 0), visitedObjects.has(p.patchType) || (p.patchType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_PatchType(p) {
    }
    function aws_cdk_lib_aws_eks_KubernetesPatch(p) {
    }
    function aws_cdk_lib_aws_eks_KubernetesManifestOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ingressAlbScheme) || (p.ingressAlbScheme, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_KubernetesManifestProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cluster) || (p.cluster, void 0), visitedObjects.has(p.ingressAlbScheme) || (p.ingressAlbScheme, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_KubernetesManifest(p) {
    }
    function aws_cdk_lib_aws_eks_KubernetesObjectValueProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cluster) || (p.cluster, void 0), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_KubernetesObjectValue(p) {
    }
    function aws_cdk_lib_aws_eks_KubectlProviderProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cluster) || (p.cluster, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_KubectlProviderAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.handlerRole) || (p.handlerRole, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_IKubectlProvider(p) {
    }
    function aws_cdk_lib_aws_eks_KubectlProvider(p) {
    }
    function aws_cdk_lib_aws_eks_FargateClusterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.defaultProfile) || aws_cdk_lib_aws_eks_FargateProfileOptions(p.defaultProfile), visitedObjects.has(p.albController) || aws_cdk_lib_aws_eks_AlbControllerOptions(p.albController), visitedObjects.has(p.awscliLayer) || (p.awscliLayer, void 0), visitedObjects.has(p.clusterHandlerSecurityGroup) || (p.clusterHandlerSecurityGroup, void 0), p.clusterLogging != null)
            for (const o of p.clusterLogging)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.coreDnsComputeType) || (p.coreDnsComputeType, void 0), visitedObjects.has(p.endpointAccess) || (p.endpointAccess, void 0), visitedObjects.has(p.kubectlLayer) || (p.kubectlLayer, void 0), visitedObjects.has(p.kubectlMemory) || (p.kubectlMemory, void 0), visitedObjects.has(p.mastersRole) || (p.mastersRole, void 0), visitedObjects.has(p.onEventLayer) || (p.onEventLayer, void 0), visitedObjects.has(p.secretsEncryptionKey) || (p.secretsEncryptionKey, void 0), visitedObjects.has(p.version) || (p.version, void 0), visitedObjects.has(p.role) || (p.role, void 0), visitedObjects.has(p.securityGroup) || (p.securityGroup, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0), p.vpcSubnets != null)
            for (const o of p.vpcSubnets)
              visitedObjects.has(o) || aws_cdk_lib_aws_ec2_SubnetSelection(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_FargateCluster(p) {
    }
    function aws_cdk_lib_aws_eks_ServiceAccountOptions(p) {
    }
    function aws_cdk_lib_aws_eks_ServiceAccountProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cluster) || (p.cluster, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_ServiceAccount(p) {
    }
    function aws_cdk_lib_aws_eks_INodegroup(p) {
    }
    function aws_cdk_lib_aws_eks_NodegroupAmiType(p) {
    }
    function aws_cdk_lib_aws_eks_CapacityType(p) {
    }
    function aws_cdk_lib_aws_eks_NodegroupRemoteAccess(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.sourceSecurityGroups != null)
            for (const o of p.sourceSecurityGroups)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_LaunchTemplateSpec(p) {
    }
    function aws_cdk_lib_aws_eks_TaintEffect(p) {
    }
    function aws_cdk_lib_aws_eks_TaintSpec(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.effect) || (p.effect, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_NodegroupOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.amiType) || (p.amiType, void 0), visitedObjects.has(p.capacityType) || (p.capacityType, void 0), p.instanceTypes != null)
            for (const o of p.instanceTypes)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.launchTemplateSpec) || (p.launchTemplateSpec, void 0), visitedObjects.has(p.nodeRole) || (p.nodeRole, void 0), visitedObjects.has(p.remoteAccess) || aws_cdk_lib_aws_eks_NodegroupRemoteAccess(p.remoteAccess), visitedObjects.has(p.subnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.subnets), p.taints != null)
            for (const o of p.taints)
              visitedObjects.has(o) || aws_cdk_lib_aws_eks_TaintSpec(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_NodegroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.cluster) || (p.cluster, void 0), visitedObjects.has(p.amiType) || (p.amiType, void 0), visitedObjects.has(p.capacityType) || (p.capacityType, void 0), p.instanceTypes != null)
            for (const o of p.instanceTypes)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.launchTemplateSpec) || (p.launchTemplateSpec, void 0), visitedObjects.has(p.nodeRole) || (p.nodeRole, void 0), visitedObjects.has(p.remoteAccess) || aws_cdk_lib_aws_eks_NodegroupRemoteAccess(p.remoteAccess), visitedObjects.has(p.subnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.subnets), p.taints != null)
            for (const o of p.taints)
              visitedObjects.has(o) || aws_cdk_lib_aws_eks_TaintSpec(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_Nodegroup(p) {
    }
    function aws_cdk_lib_aws_eks_OpenIdConnectProviderProps(p) {
    }
    function aws_cdk_lib_aws_eks_OpenIdConnectProvider(p) {
    }
    function aws_cdk_lib_aws_eks_AlbControllerVersion(p) {
    }
    function aws_cdk_lib_aws_eks_AlbScheme(p) {
    }
    function aws_cdk_lib_aws_eks_AlbControllerOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.version) || (p.version, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_AlbControllerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cluster) || (p.cluster, void 0), visitedObjects.has(p.version) || (p.version, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eks_AlbController(p) {
    }
    function aws_cdk_lib_aws_elasticache_CfnCacheClusterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.logDeliveryConfigurations) || (p.logDeliveryConfigurations, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticache_CfnCacheCluster(p) {
    }
    function aws_cdk_lib_aws_elasticache_CfnCacheCluster_CloudWatchLogsDestinationDetailsProperty(p) {
    }
    function aws_cdk_lib_aws_elasticache_CfnCacheCluster_DestinationDetailsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cloudWatchLogsDetails) || (p.cloudWatchLogsDetails, void 0), visitedObjects.has(p.kinesisFirehoseDetails) || (p.kinesisFirehoseDetails, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticache_CfnCacheCluster_KinesisFirehoseDestinationDetailsProperty(p) {
    }
    function aws_cdk_lib_aws_elasticache_CfnCacheCluster_LogDeliveryConfigurationRequestProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destinationDetails) || (p.destinationDetails, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticache_CfnGlobalReplicationGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.members) || (p.members, void 0), visitedObjects.has(p.regionalConfigurations) || (p.regionalConfigurations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticache_CfnGlobalReplicationGroup(p) {
    }
    function aws_cdk_lib_aws_elasticache_CfnGlobalReplicationGroup_GlobalReplicationGroupMemberProperty(p) {
    }
    function aws_cdk_lib_aws_elasticache_CfnGlobalReplicationGroup_RegionalConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.reshardingConfigurations) || (p.reshardingConfigurations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticache_CfnGlobalReplicationGroup_ReshardingConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_elasticache_CfnParameterGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.properties) || (p.properties, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticache_CfnParameterGroup(p) {
    }
    function aws_cdk_lib_aws_elasticache_CfnReplicationGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.logDeliveryConfigurations) || (p.logDeliveryConfigurations, void 0), visitedObjects.has(p.nodeGroupConfiguration) || (p.nodeGroupConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticache_CfnReplicationGroup(p) {
    }
    function aws_cdk_lib_aws_elasticache_CfnReplicationGroup_CloudWatchLogsDestinationDetailsProperty(p) {
    }
    function aws_cdk_lib_aws_elasticache_CfnReplicationGroup_DestinationDetailsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cloudWatchLogsDetails) || (p.cloudWatchLogsDetails, void 0), visitedObjects.has(p.kinesisFirehoseDetails) || (p.kinesisFirehoseDetails, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticache_CfnReplicationGroup_KinesisFirehoseDestinationDetailsProperty(p) {
    }
    function aws_cdk_lib_aws_elasticache_CfnReplicationGroup_LogDeliveryConfigurationRequestProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destinationDetails) || (p.destinationDetails, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticache_CfnReplicationGroup_NodeGroupConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_elasticache_CfnSecurityGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticache_CfnSecurityGroup(p) {
    }
    function aws_cdk_lib_aws_elasticache_CfnSecurityGroupIngressProps(p) {
    }
    function aws_cdk_lib_aws_elasticache_CfnSecurityGroupIngress(p) {
    }
    function aws_cdk_lib_aws_elasticache_CfnSubnetGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticache_CfnSubnetGroup(p) {
    }
    function aws_cdk_lib_aws_elasticache_CfnUserProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticache_CfnUser(p) {
    }
    function aws_cdk_lib_aws_elasticache_CfnUser_AuthenticationModeProperty(p) {
    }
    function aws_cdk_lib_aws_elasticache_CfnUserGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticache_CfnUserGroup(p) {
    }
    function aws_cdk_lib_aws_elasticbeanstalk_CfnApplicationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.resourceLifecycleConfig) || (p.resourceLifecycleConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticbeanstalk_CfnApplication(p) {
    }
    function aws_cdk_lib_aws_elasticbeanstalk_CfnApplication_ApplicationResourceLifecycleConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.versionLifecycleConfig) || (p.versionLifecycleConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticbeanstalk_CfnApplication_ApplicationVersionLifecycleConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.maxAgeRule) || (p.maxAgeRule, void 0), visitedObjects.has(p.maxCountRule) || (p.maxCountRule, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticbeanstalk_CfnApplication_MaxAgeRuleProperty(p) {
    }
    function aws_cdk_lib_aws_elasticbeanstalk_CfnApplication_MaxCountRuleProperty(p) {
    }
    function aws_cdk_lib_aws_elasticbeanstalk_CfnApplicationVersionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sourceBundle) || (p.sourceBundle, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticbeanstalk_CfnApplicationVersion(p) {
    }
    function aws_cdk_lib_aws_elasticbeanstalk_CfnApplicationVersion_SourceBundleProperty(p) {
    }
    function aws_cdk_lib_aws_elasticbeanstalk_CfnConfigurationTemplateProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.optionSettings) || (p.optionSettings, void 0), visitedObjects.has(p.sourceConfiguration) || (p.sourceConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticbeanstalk_CfnConfigurationTemplate(p) {
    }
    function aws_cdk_lib_aws_elasticbeanstalk_CfnConfigurationTemplate_ConfigurationOptionSettingProperty(p) {
    }
    function aws_cdk_lib_aws_elasticbeanstalk_CfnConfigurationTemplate_SourceConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_elasticbeanstalk_CfnEnvironmentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.optionSettings) || (p.optionSettings, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.tier) || (p.tier, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticbeanstalk_CfnEnvironment(p) {
    }
    function aws_cdk_lib_aws_elasticbeanstalk_CfnEnvironment_OptionSettingProperty(p) {
    }
    function aws_cdk_lib_aws_elasticbeanstalk_CfnEnvironment_TierProperty(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancing_CfnLoadBalancerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.listeners) || (p.listeners, void 0), visitedObjects.has(p.accessLoggingPolicy) || (p.accessLoggingPolicy, void 0), visitedObjects.has(p.appCookieStickinessPolicy) || (p.appCookieStickinessPolicy, void 0), visitedObjects.has(p.connectionDrainingPolicy) || (p.connectionDrainingPolicy, void 0), visitedObjects.has(p.connectionSettings) || (p.connectionSettings, void 0), visitedObjects.has(p.healthCheck) || (p.healthCheck, void 0), visitedObjects.has(p.lbCookieStickinessPolicy) || (p.lbCookieStickinessPolicy, void 0), visitedObjects.has(p.policies) || (p.policies, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancing_CfnLoadBalancer(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancing_CfnLoadBalancer_AccessLoggingPolicyProperty(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancing_CfnLoadBalancer_AppCookieStickinessPolicyProperty(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancing_CfnLoadBalancer_ConnectionDrainingPolicyProperty(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancing_CfnLoadBalancer_ConnectionSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancing_CfnLoadBalancer_HealthCheckProperty(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancing_CfnLoadBalancer_LBCookieStickinessPolicyProperty(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancing_CfnLoadBalancer_ListenersProperty(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancing_CfnLoadBalancer_PoliciesProperty(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancing_LoadBalancerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.accessLoggingPolicy) || (p.accessLoggingPolicy, void 0), visitedObjects.has(p.healthCheck) || aws_cdk_lib_aws_elasticloadbalancing_HealthCheck(p.healthCheck), p.listeners != null)
            for (const o of p.listeners)
              visitedObjects.has(o) || aws_cdk_lib_aws_elasticloadbalancing_LoadBalancerListener(o);
          if (visitedObjects.has(p.subnetSelection) || aws_cdk_lib_aws_ec2_SubnetSelection(p.subnetSelection), p.targets != null)
            for (const o of p.targets)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancing_HealthCheck(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.interval) || (p.interval, void 0), visitedObjects.has(p.protocol) || (p.protocol, void 0), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancing_ILoadBalancerTarget(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancing_LoadBalancerListener(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.allowConnectionsFrom != null)
            for (const o of p.allowConnectionsFrom)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.externalProtocol) || (p.externalProtocol, void 0), visitedObjects.has(p.internalProtocol) || (p.internalProtocol, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancing_LoadBalancingProtocol(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancing_LoadBalancer(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancing_InstanceTarget(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancing_ListenerPort(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultActions) || (p.defaultActions, void 0), visitedObjects.has(p.certificates) || (p.certificates, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListener(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListener_ActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.authenticateCognitoConfig) || (p.authenticateCognitoConfig, void 0), visitedObjects.has(p.authenticateOidcConfig) || (p.authenticateOidcConfig, void 0), visitedObjects.has(p.fixedResponseConfig) || (p.fixedResponseConfig, void 0), visitedObjects.has(p.forwardConfig) || (p.forwardConfig, void 0), visitedObjects.has(p.redirectConfig) || (p.redirectConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListener_AuthenticateCognitoConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.authenticationRequestExtraParams) || (p.authenticationRequestExtraParams, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListener_AuthenticateOidcConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.authenticationRequestExtraParams) || (p.authenticationRequestExtraParams, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListener_CertificateProperty(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListener_FixedResponseConfigProperty(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListener_ForwardConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.targetGroups) || (p.targetGroups, void 0), visitedObjects.has(p.targetGroupStickinessConfig) || (p.targetGroupStickinessConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListener_RedirectConfigProperty(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListener_TargetGroupStickinessConfigProperty(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListener_TargetGroupTupleProperty(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerCertificateProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.certificates) || (p.certificates, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerCertificate(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerCertificate_CertificateProperty(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.conditions) || (p.conditions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_ActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.authenticateCognitoConfig) || (p.authenticateCognitoConfig, void 0), visitedObjects.has(p.authenticateOidcConfig) || (p.authenticateOidcConfig, void 0), visitedObjects.has(p.fixedResponseConfig) || (p.fixedResponseConfig, void 0), visitedObjects.has(p.forwardConfig) || (p.forwardConfig, void 0), visitedObjects.has(p.redirectConfig) || (p.redirectConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_AuthenticateCognitoConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.authenticationRequestExtraParams) || (p.authenticationRequestExtraParams, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_AuthenticateOidcConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.authenticationRequestExtraParams) || (p.authenticationRequestExtraParams, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_FixedResponseConfigProperty(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_ForwardConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.targetGroups) || (p.targetGroups, void 0), visitedObjects.has(p.targetGroupStickinessConfig) || (p.targetGroupStickinessConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_HostHeaderConfigProperty(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_HttpHeaderConfigProperty(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_HttpRequestMethodConfigProperty(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_PathPatternConfigProperty(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_QueryStringConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_QueryStringKeyValueProperty(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_RedirectConfigProperty(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_RuleConditionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.hostHeaderConfig) || (p.hostHeaderConfig, void 0), visitedObjects.has(p.httpHeaderConfig) || (p.httpHeaderConfig, void 0), visitedObjects.has(p.httpRequestMethodConfig) || (p.httpRequestMethodConfig, void 0), visitedObjects.has(p.pathPatternConfig) || (p.pathPatternConfig, void 0), visitedObjects.has(p.queryStringConfig) || (p.queryStringConfig, void 0), visitedObjects.has(p.sourceIpConfig) || (p.sourceIpConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_SourceIpConfigProperty(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_TargetGroupStickinessConfigProperty(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_TargetGroupTupleProperty(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnLoadBalancerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.loadBalancerAttributes) || (p.loadBalancerAttributes, void 0), visitedObjects.has(p.subnetMappings) || (p.subnetMappings, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnLoadBalancer(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnLoadBalancer_LoadBalancerAttributeProperty(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnLoadBalancer_SubnetMappingProperty(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnTargetGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.matcher) || (p.matcher, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.targetGroupAttributes) || (p.targetGroupAttributes, void 0), visitedObjects.has(p.targets) || (p.targets, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnTargetGroup(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnTargetGroup_MatcherProperty(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnTargetGroup_TargetDescriptionProperty(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_CfnTargetGroup_TargetGroupAttributeProperty(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_BaseApplicationListenerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.certificates != null)
            for (const o of p.certificates)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.defaultAction) || (p.defaultAction, void 0), p.defaultTargetGroups != null)
            for (const o of p.defaultTargetGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.protocol) || (p.protocol, void 0), visitedObjects.has(p.sslPolicy) || (p.sslPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationListenerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.loadBalancer) || (p.loadBalancer, void 0), p.certificates != null)
            for (const o of p.certificates)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.defaultAction) || (p.defaultAction, void 0), p.defaultTargetGroups != null)
            for (const o of p.defaultTargetGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.protocol) || (p.protocol, void 0), visitedObjects.has(p.sslPolicy) || (p.sslPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationListenerLookupOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.listenerProtocol) || (p.listenerProtocol, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationListener(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_IApplicationListener(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationListenerAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.securityGroup) || (p.securityGroup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_AddRuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.conditions != null)
            for (const o of p.conditions)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_AddApplicationTargetGroupsProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.targetGroups != null)
            for (const o of p.targetGroups)
              visitedObjects.has(o) || void 0;
          if (p.conditions != null)
            for (const o of p.conditions)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_AddApplicationActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.action) || (p.action, void 0), p.conditions != null)
            for (const o of p.conditions)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_AddApplicationTargetsProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.deregistrationDelay) || (p.deregistrationDelay, void 0), visitedObjects.has(p.healthCheck) || aws_cdk_lib_aws_elasticloadbalancingv2_HealthCheck(p.healthCheck), visitedObjects.has(p.loadBalancingAlgorithmType) || (p.loadBalancingAlgorithmType, void 0), visitedObjects.has(p.protocol) || (p.protocol, void 0), visitedObjects.has(p.protocolVersion) || (p.protocolVersion, void 0), visitedObjects.has(p.slowStart) || (p.slowStart, void 0), visitedObjects.has(p.stickinessCookieDuration) || (p.stickinessCookieDuration, void 0), p.targets != null)
            for (const o of p.targets)
              visitedObjects.has(o) || void 0;
          if (p.conditions != null)
            for (const o of p.conditions)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationListenerCertificateProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.listener) || (p.listener, void 0), p.certificates != null)
            for (const o of p.certificates)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationListenerCertificate(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_BaseApplicationListenerRuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.action) || (p.action, void 0), p.conditions != null)
            for (const o of p.conditions)
              visitedObjects.has(o) || void 0;
          if (p.targetGroups != null)
            for (const o of p.targetGroups)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationListenerRuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.listener) || (p.listener, void 0), visitedObjects.has(p.action) || (p.action, void 0), p.conditions != null)
            for (const o of p.conditions)
              visitedObjects.has(o) || void 0;
          if (p.targetGroups != null)
            for (const o of p.targetGroups)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationListenerRule(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationLoadBalancerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.desyncMitigationMode) || (p.desyncMitigationMode, void 0), visitedObjects.has(p.idleTimeout) || (p.idleTimeout, void 0), visitedObjects.has(p.ipAddressType) || (p.ipAddressType, void 0), visitedObjects.has(p.securityGroup) || (p.securityGroup, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationLoadBalancerLookupOptions(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationLoadBalancer(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_HttpCodeElb(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_HttpCodeTarget(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_IApplicationLoadBalancerMetrics(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_IApplicationLoadBalancer(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationLoadBalancerAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationLoadBalancerRedirectConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sourceProtocol) || (p.sourceProtocol, void 0), visitedObjects.has(p.targetProtocol) || (p.targetProtocol, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationTargetGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.loadBalancingAlgorithmType) || (p.loadBalancingAlgorithmType, void 0), visitedObjects.has(p.protocol) || (p.protocol, void 0), visitedObjects.has(p.protocolVersion) || (p.protocolVersion, void 0), visitedObjects.has(p.slowStart) || (p.slowStart, void 0), visitedObjects.has(p.stickinessCookieDuration) || (p.stickinessCookieDuration, void 0), p.targets != null)
            for (const o of p.targets)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.deregistrationDelay) || (p.deregistrationDelay, void 0), visitedObjects.has(p.healthCheck) || aws_cdk_lib_aws_elasticloadbalancingv2_HealthCheck(p.healthCheck), visitedObjects.has(p.targetType) || (p.targetType, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_IApplicationTargetGroupMetrics(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationTargetGroup(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_IApplicationTargetGroup(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_IApplicationLoadBalancerTarget(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_ListenerAction(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_ForwardOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.stickinessDuration) || (p.stickinessDuration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_WeightedTargetGroup(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.targetGroup) || (p.targetGroup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_FixedResponseOptions(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_RedirectOptions(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_AuthenticateOidcOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.clientSecret) || (p.clientSecret, void 0), visitedObjects.has(p.next) || (p.next, void 0), visitedObjects.has(p.onUnauthenticatedRequest) || (p.onUnauthenticatedRequest, void 0), visitedObjects.has(p.sessionTimeout) || (p.sessionTimeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_UnauthenticatedAction(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_ListenerCondition(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_QueryStringCondition(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_BaseNetworkListenerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.alpnPolicy) || (p.alpnPolicy, void 0), p.certificates != null)
            for (const o of p.certificates)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.defaultAction) || (p.defaultAction, void 0), p.defaultTargetGroups != null)
            for (const o of p.defaultTargetGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.protocol) || (p.protocol, void 0), visitedObjects.has(p.sslPolicy) || (p.sslPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_NetworkListenerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.loadBalancer) || (p.loadBalancer, void 0), visitedObjects.has(p.alpnPolicy) || (p.alpnPolicy, void 0), p.certificates != null)
            for (const o of p.certificates)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.defaultAction) || (p.defaultAction, void 0), p.defaultTargetGroups != null)
            for (const o of p.defaultTargetGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.protocol) || (p.protocol, void 0), visitedObjects.has(p.sslPolicy) || (p.sslPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_NetworkListenerLookupOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.listenerProtocol) || (p.listenerProtocol, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_NetworkListener(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_INetworkListener(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_AddNetworkActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.action) || (p.action, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_AddNetworkTargetsProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.deregistrationDelay) || (p.deregistrationDelay, void 0), visitedObjects.has(p.healthCheck) || aws_cdk_lib_aws_elasticloadbalancingv2_HealthCheck(p.healthCheck), visitedObjects.has(p.protocol) || (p.protocol, void 0), p.targets != null)
            for (const o of p.targets)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_NetworkLoadBalancerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_NetworkLoadBalancerAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_NetworkLoadBalancerLookupOptions(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_NetworkLoadBalancer(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_INetworkLoadBalancerMetrics(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_INetworkLoadBalancer(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_NetworkTargetGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.protocol) || (p.protocol, void 0), p.targets != null)
            for (const o of p.targets)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.deregistrationDelay) || (p.deregistrationDelay, void 0), visitedObjects.has(p.healthCheck) || aws_cdk_lib_aws_elasticloadbalancingv2_HealthCheck(p.healthCheck), visitedObjects.has(p.targetType) || (p.targetType, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_INetworkTargetGroupMetrics(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_NetworkTargetGroup(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_INetworkTargetGroup(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_INetworkLoadBalancerTarget(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_NetworkListenerAction(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_NetworkForwardOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.stickinessDuration) || (p.stickinessDuration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_NetworkWeightedTargetGroup(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.targetGroup) || (p.targetGroup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_BaseListenerLookupOptions(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_IListener(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_BaseListener(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_BaseLoadBalancerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_ILoadBalancerV2(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_BaseLoadBalancerLookupOptions(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_BaseLoadBalancer(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_BaseTargetGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.deregistrationDelay) || (p.deregistrationDelay, void 0), visitedObjects.has(p.healthCheck) || aws_cdk_lib_aws_elasticloadbalancingv2_HealthCheck(p.healthCheck), visitedObjects.has(p.targetType) || (p.targetType, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_HealthCheck(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.interval) || (p.interval, void 0), visitedObjects.has(p.protocol) || (p.protocol, void 0), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_TargetGroupBase(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_TargetGroupAttributes(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_ITargetGroup(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_LoadBalancerTargetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.targetType) || (p.targetType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_IpAddressType(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_Protocol(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationProtocol(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationProtocolVersion(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_SslPolicy(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_TargetType(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_AlpnPolicy(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_TargetGroupLoadBalancingAlgorithmType(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_DesyncMitigationMode(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_IListenerCertificate(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_ListenerCertificate(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_IListenerAction(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_actions_AuthenticateCognitoActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.next) || (p.next, void 0), visitedObjects.has(p.userPool) || (p.userPool, void 0), visitedObjects.has(p.userPoolClient) || (p.userPoolClient, void 0), visitedObjects.has(p.userPoolDomain) || (p.userPoolDomain, void 0), visitedObjects.has(p.onUnauthenticatedRequest) || (p.onUnauthenticatedRequest, void 0), visitedObjects.has(p.sessionTimeout) || (p.sessionTimeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_actions_AuthenticateCognitoAction(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_targets_AlbArnTarget(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_targets_AlbTarget(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_targets_IpTarget(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_targets_InstanceIdTarget(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_targets_InstanceTarget(p) {
    }
    function aws_cdk_lib_aws_elasticloadbalancingv2_targets_LambdaTarget(p) {
    }
    function aws_cdk_lib_aws_elasticsearch_ElasticsearchVersion(p) {
    }
    function aws_cdk_lib_aws_elasticsearch_CapacityConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          "dataNodeInstanceType" in p && print("aws-cdk-lib.aws_elasticsearch.CapacityConfig#dataNodeInstanceType", "use opensearchservice module instead"), "dataNodes" in p && print("aws-cdk-lib.aws_elasticsearch.CapacityConfig#dataNodes", "use opensearchservice module instead"), "masterNodeInstanceType" in p && print("aws-cdk-lib.aws_elasticsearch.CapacityConfig#masterNodeInstanceType", "use opensearchservice module instead"), "masterNodes" in p && print("aws-cdk-lib.aws_elasticsearch.CapacityConfig#masterNodes", "use opensearchservice module instead"), "warmInstanceType" in p && print("aws-cdk-lib.aws_elasticsearch.CapacityConfig#warmInstanceType", "use opensearchservice module instead"), "warmNodes" in p && print("aws-cdk-lib.aws_elasticsearch.CapacityConfig#warmNodes", "use opensearchservice module instead");
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticsearch_ZoneAwarenessConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          "availabilityZoneCount" in p && print("aws-cdk-lib.aws_elasticsearch.ZoneAwarenessConfig#availabilityZoneCount", "use opensearchservice module instead"), "enabled" in p && print("aws-cdk-lib.aws_elasticsearch.ZoneAwarenessConfig#enabled", "use opensearchservice module instead");
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticsearch_EbsOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          "enabled" in p && print("aws-cdk-lib.aws_elasticsearch.EbsOptions#enabled", "use opensearchservice module instead"), "iops" in p && print("aws-cdk-lib.aws_elasticsearch.EbsOptions#iops", "use opensearchservice module instead"), "volumeSize" in p && print("aws-cdk-lib.aws_elasticsearch.EbsOptions#volumeSize", "use opensearchservice module instead"), "volumeType" in p && print("aws-cdk-lib.aws_elasticsearch.EbsOptions#volumeType", "use opensearchservice module instead"), visitedObjects.has(p.volumeType) || (p.volumeType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticsearch_LoggingOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          "appLogEnabled" in p && print("aws-cdk-lib.aws_elasticsearch.LoggingOptions#appLogEnabled", "use opensearchservice module instead"), "appLogGroup" in p && print("aws-cdk-lib.aws_elasticsearch.LoggingOptions#appLogGroup", "use opensearchservice module instead"), visitedObjects.has(p.appLogGroup) || (p.appLogGroup, void 0), "auditLogEnabled" in p && print("aws-cdk-lib.aws_elasticsearch.LoggingOptions#auditLogEnabled", "use opensearchservice module instead"), "auditLogGroup" in p && print("aws-cdk-lib.aws_elasticsearch.LoggingOptions#auditLogGroup", "use opensearchservice module instead"), visitedObjects.has(p.auditLogGroup) || (p.auditLogGroup, void 0), "slowIndexLogEnabled" in p && print("aws-cdk-lib.aws_elasticsearch.LoggingOptions#slowIndexLogEnabled", "use opensearchservice module instead"), "slowIndexLogGroup" in p && print("aws-cdk-lib.aws_elasticsearch.LoggingOptions#slowIndexLogGroup", "use opensearchservice module instead"), visitedObjects.has(p.slowIndexLogGroup) || (p.slowIndexLogGroup, void 0), "slowSearchLogEnabled" in p && print("aws-cdk-lib.aws_elasticsearch.LoggingOptions#slowSearchLogEnabled", "use opensearchservice module instead"), "slowSearchLogGroup" in p && print("aws-cdk-lib.aws_elasticsearch.LoggingOptions#slowSearchLogGroup", "use opensearchservice module instead"), visitedObjects.has(p.slowSearchLogGroup) || (p.slowSearchLogGroup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticsearch_EncryptionAtRestOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          "enabled" in p && print("aws-cdk-lib.aws_elasticsearch.EncryptionAtRestOptions#enabled", "use opensearchservice module instead"), "kmsKey" in p && print("aws-cdk-lib.aws_elasticsearch.EncryptionAtRestOptions#kmsKey", "use opensearchservice module instead"), visitedObjects.has(p.kmsKey) || (p.kmsKey, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticsearch_CognitoOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          "identityPoolId" in p && print("aws-cdk-lib.aws_elasticsearch.CognitoOptions#identityPoolId", "use opensearchservice module instead"), "role" in p && print("aws-cdk-lib.aws_elasticsearch.CognitoOptions#role", "use opensearchservice module instead"), visitedObjects.has(p.role) || (p.role, void 0), "userPoolId" in p && print("aws-cdk-lib.aws_elasticsearch.CognitoOptions#userPoolId", "use opensearchservice module instead");
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticsearch_TLSSecurityPolicy(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          print("aws-cdk-lib.aws_elasticsearch.TLSSecurityPolicy", "use opensearchservice module instead");
          const ns = require_domain();
          if (Object.values(ns.TLSSecurityPolicy).filter((x) => x === p).length > 1)
            return;
          p === ns.TLSSecurityPolicy.TLS_1_0 && print("aws-cdk-lib.aws_elasticsearch.TLSSecurityPolicy#TLS_1_0", ""), p === ns.TLSSecurityPolicy.TLS_1_2 && print("aws-cdk-lib.aws_elasticsearch.TLSSecurityPolicy#TLS_1_2", "");
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticsearch_AdvancedSecurityOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          "masterUserArn" in p && print("aws-cdk-lib.aws_elasticsearch.AdvancedSecurityOptions#masterUserArn", "use opensearchservice module instead"), "masterUserName" in p && print("aws-cdk-lib.aws_elasticsearch.AdvancedSecurityOptions#masterUserName", "use opensearchservice module instead"), "masterUserPassword" in p && print("aws-cdk-lib.aws_elasticsearch.AdvancedSecurityOptions#masterUserPassword", "use opensearchservice module instead"), visitedObjects.has(p.masterUserPassword) || (p.masterUserPassword, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticsearch_CustomEndpointOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          "domainName" in p && print("aws-cdk-lib.aws_elasticsearch.CustomEndpointOptions#domainName", "use opensearchservice module instead"), "certificate" in p && print("aws-cdk-lib.aws_elasticsearch.CustomEndpointOptions#certificate", "use opensearchservice module instead"), visitedObjects.has(p.certificate) || (p.certificate, void 0), "hostedZone" in p && print("aws-cdk-lib.aws_elasticsearch.CustomEndpointOptions#hostedZone", "use opensearchservice module instead"), visitedObjects.has(p.hostedZone) || (p.hostedZone, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticsearch_DomainProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if ("version" in p && print("aws-cdk-lib.aws_elasticsearch.DomainProps#version", "use opensearchservice module instead"), visitedObjects.has(p.version) || (p.version, void 0), "accessPolicies" in p && print("aws-cdk-lib.aws_elasticsearch.DomainProps#accessPolicies", "use opensearchservice module instead"), p.accessPolicies != null)
            for (const o of p.accessPolicies)
              visitedObjects.has(o) || void 0;
          if ("advancedOptions" in p && print("aws-cdk-lib.aws_elasticsearch.DomainProps#advancedOptions", "use opensearchservice module instead"), "automatedSnapshotStartHour" in p && print("aws-cdk-lib.aws_elasticsearch.DomainProps#automatedSnapshotStartHour", "use opensearchservice module instead"), "capacity" in p && print("aws-cdk-lib.aws_elasticsearch.DomainProps#capacity", "use opensearchservice module instead"), visitedObjects.has(p.capacity) || aws_cdk_lib_aws_elasticsearch_CapacityConfig(p.capacity), "cognitoKibanaAuth" in p && print("aws-cdk-lib.aws_elasticsearch.DomainProps#cognitoKibanaAuth", "use opensearchservice module instead"), visitedObjects.has(p.cognitoKibanaAuth) || aws_cdk_lib_aws_elasticsearch_CognitoOptions(p.cognitoKibanaAuth), "customEndpoint" in p && print("aws-cdk-lib.aws_elasticsearch.DomainProps#customEndpoint", "use opensearchservice module instead"), visitedObjects.has(p.customEndpoint) || aws_cdk_lib_aws_elasticsearch_CustomEndpointOptions(p.customEndpoint), "domainName" in p && print("aws-cdk-lib.aws_elasticsearch.DomainProps#domainName", "use opensearchservice module instead"), "ebs" in p && print("aws-cdk-lib.aws_elasticsearch.DomainProps#ebs", "use opensearchservice module instead"), visitedObjects.has(p.ebs) || aws_cdk_lib_aws_elasticsearch_EbsOptions(p.ebs), "enableVersionUpgrade" in p && print("aws-cdk-lib.aws_elasticsearch.DomainProps#enableVersionUpgrade", "use opensearchservice module instead"), "encryptionAtRest" in p && print("aws-cdk-lib.aws_elasticsearch.DomainProps#encryptionAtRest", "use opensearchservice module instead"), visitedObjects.has(p.encryptionAtRest) || aws_cdk_lib_aws_elasticsearch_EncryptionAtRestOptions(p.encryptionAtRest), "enforceHttps" in p && print("aws-cdk-lib.aws_elasticsearch.DomainProps#enforceHttps", "use opensearchservice module instead"), "fineGrainedAccessControl" in p && print("aws-cdk-lib.aws_elasticsearch.DomainProps#fineGrainedAccessControl", "use opensearchservice module instead"), visitedObjects.has(p.fineGrainedAccessControl) || aws_cdk_lib_aws_elasticsearch_AdvancedSecurityOptions(p.fineGrainedAccessControl), "logging" in p && print("aws-cdk-lib.aws_elasticsearch.DomainProps#logging", "use opensearchservice module instead"), visitedObjects.has(p.logging) || aws_cdk_lib_aws_elasticsearch_LoggingOptions(p.logging), "nodeToNodeEncryption" in p && print("aws-cdk-lib.aws_elasticsearch.DomainProps#nodeToNodeEncryption", "use opensearchservice module instead"), "removalPolicy" in p && print("aws-cdk-lib.aws_elasticsearch.DomainProps#removalPolicy", "use opensearchservice module instead"), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), "securityGroups" in p && print("aws-cdk-lib.aws_elasticsearch.DomainProps#securityGroups", "use opensearchservice module instead"), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          if ("tlsSecurityPolicy" in p && print("aws-cdk-lib.aws_elasticsearch.DomainProps#tlsSecurityPolicy", "use opensearchservice module instead"), visitedObjects.has(p.tlsSecurityPolicy) || aws_cdk_lib_aws_elasticsearch_TLSSecurityPolicy(p.tlsSecurityPolicy), "useUnsignedBasicAuth" in p && print("aws-cdk-lib.aws_elasticsearch.DomainProps#useUnsignedBasicAuth", "use opensearchservice module instead"), "vpc" in p && print("aws-cdk-lib.aws_elasticsearch.DomainProps#vpc", "use opensearchservice module instead"), visitedObjects.has(p.vpc) || (p.vpc, void 0), "vpcSubnets" in p && print("aws-cdk-lib.aws_elasticsearch.DomainProps#vpcSubnets", "use opensearchservice module instead"), p.vpcSubnets != null)
            for (const o of p.vpcSubnets)
              visitedObjects.has(o) || aws_cdk_lib_aws_ec2_SubnetSelection(o);
          "zoneAwareness" in p && print("aws-cdk-lib.aws_elasticsearch.DomainProps#zoneAwareness", "use opensearchservice module instead"), visitedObjects.has(p.zoneAwareness) || aws_cdk_lib_aws_elasticsearch_ZoneAwarenessConfig(p.zoneAwareness);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticsearch_IDomain(p) {
    }
    function aws_cdk_lib_aws_elasticsearch_DomainAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          "domainArn" in p && print("aws-cdk-lib.aws_elasticsearch.DomainAttributes#domainArn", "use opensearchservice module instead"), "domainEndpoint" in p && print("aws-cdk-lib.aws_elasticsearch.DomainAttributes#domainEndpoint", "use opensearchservice module instead");
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticsearch_Domain(p) {
    }
    function aws_cdk_lib_aws_elasticsearch_CfnDomainProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.advancedOptions) || (p.advancedOptions, void 0), visitedObjects.has(p.advancedSecurityOptions) || (p.advancedSecurityOptions, void 0), visitedObjects.has(p.cognitoOptions) || (p.cognitoOptions, void 0), visitedObjects.has(p.domainEndpointOptions) || (p.domainEndpointOptions, void 0), visitedObjects.has(p.ebsOptions) || (p.ebsOptions, void 0), visitedObjects.has(p.elasticsearchClusterConfig) || (p.elasticsearchClusterConfig, void 0), visitedObjects.has(p.encryptionAtRestOptions) || (p.encryptionAtRestOptions, void 0), visitedObjects.has(p.logPublishingOptions) || (p.logPublishingOptions, void 0), visitedObjects.has(p.nodeToNodeEncryptionOptions) || (p.nodeToNodeEncryptionOptions, void 0), visitedObjects.has(p.snapshotOptions) || (p.snapshotOptions, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.vpcOptions) || (p.vpcOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticsearch_CfnDomain(p) {
    }
    function aws_cdk_lib_aws_elasticsearch_CfnDomain_AdvancedSecurityOptionsInputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.masterUserOptions) || (p.masterUserOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticsearch_CfnDomain_CognitoOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_elasticsearch_CfnDomain_ColdStorageOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_elasticsearch_CfnDomain_DomainEndpointOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_elasticsearch_CfnDomain_EBSOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_elasticsearch_CfnDomain_ElasticsearchClusterConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.coldStorageOptions) || (p.coldStorageOptions, void 0), visitedObjects.has(p.zoneAwarenessConfig) || (p.zoneAwarenessConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_elasticsearch_CfnDomain_EncryptionAtRestOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_elasticsearch_CfnDomain_LogPublishingOptionProperty(p) {
    }
    function aws_cdk_lib_aws_elasticsearch_CfnDomain_MasterUserOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_elasticsearch_CfnDomain_NodeToNodeEncryptionOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_elasticsearch_CfnDomain_SnapshotOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_elasticsearch_CfnDomain_VPCOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_elasticsearch_CfnDomain_ZoneAwarenessConfigProperty(p) {
    }
    function aws_cdk_lib_aws_emr_CfnClusterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.instances) || (p.instances, void 0), visitedObjects.has(p.applications) || (p.applications, void 0), visitedObjects.has(p.autoTerminationPolicy) || (p.autoTerminationPolicy, void 0), visitedObjects.has(p.bootstrapActions) || (p.bootstrapActions, void 0), visitedObjects.has(p.configurations) || (p.configurations, void 0), visitedObjects.has(p.kerberosAttributes) || (p.kerberosAttributes, void 0), visitedObjects.has(p.managedScalingPolicy) || (p.managedScalingPolicy, void 0), visitedObjects.has(p.steps) || (p.steps, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnCluster(p) {
    }
    function aws_cdk_lib_aws_emr_CfnCluster_ApplicationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.additionalInfo) || (p.additionalInfo, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnCluster_AutoScalingPolicyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.constraints) || (p.constraints, void 0), visitedObjects.has(p.rules) || (p.rules, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnCluster_AutoTerminationPolicyProperty(p) {
    }
    function aws_cdk_lib_aws_emr_CfnCluster_BootstrapActionConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.scriptBootstrapAction) || (p.scriptBootstrapAction, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnCluster_CloudWatchAlarmDefinitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dimensions) || (p.dimensions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnCluster_ComputeLimitsProperty(p) {
    }
    function aws_cdk_lib_aws_emr_CfnCluster_ConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.configurationProperties) || (p.configurationProperties, void 0), visitedObjects.has(p.configurations) || (p.configurations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnCluster_EbsBlockDeviceConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.volumeSpecification) || (p.volumeSpecification, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnCluster_EbsConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ebsBlockDeviceConfigs) || (p.ebsBlockDeviceConfigs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnCluster_HadoopJarStepConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.stepProperties) || (p.stepProperties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnCluster_InstanceFleetConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.instanceTypeConfigs) || (p.instanceTypeConfigs, void 0), visitedObjects.has(p.launchSpecifications) || (p.launchSpecifications, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnCluster_InstanceFleetProvisioningSpecificationsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.onDemandSpecification) || (p.onDemandSpecification, void 0), visitedObjects.has(p.spotSpecification) || (p.spotSpecification, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnCluster_InstanceGroupConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.autoScalingPolicy) || (p.autoScalingPolicy, void 0), visitedObjects.has(p.configurations) || (p.configurations, void 0), visitedObjects.has(p.ebsConfiguration) || (p.ebsConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnCluster_InstanceTypeConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.configurations) || (p.configurations, void 0), visitedObjects.has(p.ebsConfiguration) || (p.ebsConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnCluster_JobFlowInstancesConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.coreInstanceFleet) || (p.coreInstanceFleet, void 0), visitedObjects.has(p.coreInstanceGroup) || (p.coreInstanceGroup, void 0), visitedObjects.has(p.masterInstanceFleet) || (p.masterInstanceFleet, void 0), visitedObjects.has(p.masterInstanceGroup) || (p.masterInstanceGroup, void 0), visitedObjects.has(p.placement) || (p.placement, void 0), visitedObjects.has(p.taskInstanceFleets) || (p.taskInstanceFleets, void 0), visitedObjects.has(p.taskInstanceGroups) || (p.taskInstanceGroups, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnCluster_KerberosAttributesProperty(p) {
    }
    function aws_cdk_lib_aws_emr_CfnCluster_KeyValueProperty(p) {
    }
    function aws_cdk_lib_aws_emr_CfnCluster_ManagedScalingPolicyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.computeLimits) || (p.computeLimits, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnCluster_MetricDimensionProperty(p) {
    }
    function aws_cdk_lib_aws_emr_CfnCluster_OnDemandProvisioningSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_emr_CfnCluster_PlacementTypeProperty(p) {
    }
    function aws_cdk_lib_aws_emr_CfnCluster_ScalingActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.simpleScalingPolicyConfiguration) || (p.simpleScalingPolicyConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnCluster_ScalingConstraintsProperty(p) {
    }
    function aws_cdk_lib_aws_emr_CfnCluster_ScalingRuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.action) || (p.action, void 0), visitedObjects.has(p.trigger) || (p.trigger, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnCluster_ScalingTriggerProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cloudWatchAlarmDefinition) || (p.cloudWatchAlarmDefinition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnCluster_ScriptBootstrapActionConfigProperty(p) {
    }
    function aws_cdk_lib_aws_emr_CfnCluster_SimpleScalingPolicyConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_emr_CfnCluster_SpotProvisioningSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_emr_CfnCluster_StepConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.hadoopJarStep) || (p.hadoopJarStep, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnCluster_VolumeSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_emr_CfnInstanceFleetConfigProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.instanceTypeConfigs) || (p.instanceTypeConfigs, void 0), visitedObjects.has(p.launchSpecifications) || (p.launchSpecifications, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnInstanceFleetConfig(p) {
    }
    function aws_cdk_lib_aws_emr_CfnInstanceFleetConfig_ConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.configurationProperties) || (p.configurationProperties, void 0), visitedObjects.has(p.configurations) || (p.configurations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnInstanceFleetConfig_EbsBlockDeviceConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.volumeSpecification) || (p.volumeSpecification, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnInstanceFleetConfig_EbsConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ebsBlockDeviceConfigs) || (p.ebsBlockDeviceConfigs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnInstanceFleetConfig_InstanceFleetProvisioningSpecificationsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.onDemandSpecification) || (p.onDemandSpecification, void 0), visitedObjects.has(p.spotSpecification) || (p.spotSpecification, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnInstanceFleetConfig_InstanceTypeConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.configurations) || (p.configurations, void 0), visitedObjects.has(p.ebsConfiguration) || (p.ebsConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnInstanceFleetConfig_OnDemandProvisioningSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_emr_CfnInstanceFleetConfig_SpotProvisioningSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_emr_CfnInstanceFleetConfig_VolumeSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_emr_CfnInstanceGroupConfigProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.autoScalingPolicy) || (p.autoScalingPolicy, void 0), visitedObjects.has(p.configurations) || (p.configurations, void 0), visitedObjects.has(p.ebsConfiguration) || (p.ebsConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnInstanceGroupConfig(p) {
    }
    function aws_cdk_lib_aws_emr_CfnInstanceGroupConfig_AutoScalingPolicyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.constraints) || (p.constraints, void 0), visitedObjects.has(p.rules) || (p.rules, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnInstanceGroupConfig_CloudWatchAlarmDefinitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dimensions) || (p.dimensions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnInstanceGroupConfig_ConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.configurationProperties) || (p.configurationProperties, void 0), visitedObjects.has(p.configurations) || (p.configurations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnInstanceGroupConfig_EbsBlockDeviceConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.volumeSpecification) || (p.volumeSpecification, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnInstanceGroupConfig_EbsConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ebsBlockDeviceConfigs) || (p.ebsBlockDeviceConfigs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnInstanceGroupConfig_MetricDimensionProperty(p) {
    }
    function aws_cdk_lib_aws_emr_CfnInstanceGroupConfig_ScalingActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.simpleScalingPolicyConfiguration) || (p.simpleScalingPolicyConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnInstanceGroupConfig_ScalingConstraintsProperty(p) {
    }
    function aws_cdk_lib_aws_emr_CfnInstanceGroupConfig_ScalingRuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.action) || (p.action, void 0), visitedObjects.has(p.trigger) || (p.trigger, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnInstanceGroupConfig_ScalingTriggerProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cloudWatchAlarmDefinition) || (p.cloudWatchAlarmDefinition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnInstanceGroupConfig_SimpleScalingPolicyConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_emr_CfnInstanceGroupConfig_VolumeSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_emr_CfnSecurityConfigurationProps(p) {
    }
    function aws_cdk_lib_aws_emr_CfnSecurityConfiguration(p) {
    }
    function aws_cdk_lib_aws_emr_CfnStepProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.hadoopJarStep) || (p.hadoopJarStep, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnStep(p) {
    }
    function aws_cdk_lib_aws_emr_CfnStep_HadoopJarStepConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.stepProperties) || (p.stepProperties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnStep_KeyValueProperty(p) {
    }
    function aws_cdk_lib_aws_emr_CfnStudioProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emr_CfnStudio(p) {
    }
    function aws_cdk_lib_aws_emr_CfnStudioSessionMappingProps(p) {
    }
    function aws_cdk_lib_aws_emr_CfnStudioSessionMapping(p) {
    }
    function aws_cdk_lib_aws_emrcontainers_CfnVirtualClusterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.containerProvider) || (p.containerProvider, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emrcontainers_CfnVirtualCluster(p) {
    }
    function aws_cdk_lib_aws_emrcontainers_CfnVirtualCluster_ContainerInfoProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.eksInfo) || (p.eksInfo, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emrcontainers_CfnVirtualCluster_ContainerProviderProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.info) || (p.info, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emrcontainers_CfnVirtualCluster_EksInfoProperty(p) {
    }
    function aws_cdk_lib_aws_emrserverless_CfnApplicationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.autoStartConfiguration) || (p.autoStartConfiguration, void 0), visitedObjects.has(p.autoStopConfiguration) || (p.autoStopConfiguration, void 0), visitedObjects.has(p.imageConfiguration) || (p.imageConfiguration, void 0), visitedObjects.has(p.initialCapacity) || (p.initialCapacity, void 0), visitedObjects.has(p.maximumCapacity) || (p.maximumCapacity, void 0), visitedObjects.has(p.networkConfiguration) || (p.networkConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.workerTypeSpecifications) || (p.workerTypeSpecifications, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emrserverless_CfnApplication(p) {
    }
    function aws_cdk_lib_aws_emrserverless_CfnApplication_AutoStartConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_emrserverless_CfnApplication_AutoStopConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_emrserverless_CfnApplication_ImageConfigurationInputProperty(p) {
    }
    function aws_cdk_lib_aws_emrserverless_CfnApplication_InitialCapacityConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.workerConfiguration) || (p.workerConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emrserverless_CfnApplication_InitialCapacityConfigKeyValuePairProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_emrserverless_CfnApplication_MaximumAllowedResourcesProperty(p) {
    }
    function aws_cdk_lib_aws_emrserverless_CfnApplication_NetworkConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_emrserverless_CfnApplication_WorkerConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_emrserverless_CfnApplication_WorkerTypeSpecificationInputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.imageConfiguration) || (p.imageConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_RuleTargetInput(p) {
    }
    function aws_cdk_lib_aws_events_RuleTargetInputProperties(p) {
    }
    function aws_cdk_lib_aws_events_EventField(p) {
    }
    function aws_cdk_lib_aws_events_RuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.eventBus) || (p.eventBus, void 0), visitedObjects.has(p.schedule) || (p.schedule, void 0), p.targets != null)
            for (const o of p.targets)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.eventPattern) || (p.eventPattern, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_Rule(p) {
    }
    function aws_cdk_lib_aws_events_IRule(p) {
    }
    function aws_cdk_lib_aws_events_IRuleTarget(p) {
    }
    function aws_cdk_lib_aws_events_RuleTargetConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.batchParameters) || aws_cdk_lib_aws_events_CfnRule_BatchParametersProperty(p.batchParameters), visitedObjects.has(p.deadLetterConfig) || (p.deadLetterConfig, void 0), visitedObjects.has(p.ecsParameters) || aws_cdk_lib_aws_events_CfnRule_EcsParametersProperty(p.ecsParameters), visitedObjects.has(p.httpParameters) || aws_cdk_lib_aws_events_CfnRule_HttpParametersProperty(p.httpParameters), visitedObjects.has(p.input) || (p.input, void 0), visitedObjects.has(p.kinesisParameters) || (p.kinesisParameters, void 0), visitedObjects.has(p.retryPolicy) || (p.retryPolicy, void 0), visitedObjects.has(p.role) || (p.role, void 0), visitedObjects.has(p.runCommandParameters) || aws_cdk_lib_aws_events_CfnRule_RunCommandParametersProperty(p.runCommandParameters), visitedObjects.has(p.sqsParameters) || (p.sqsParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_IEventBus(p) {
    }
    function aws_cdk_lib_aws_events_EventBusProps(p) {
    }
    function aws_cdk_lib_aws_events_EventBusAttributes(p) {
    }
    function aws_cdk_lib_aws_events_EventBus(p) {
    }
    function aws_cdk_lib_aws_events_EventBusPolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.eventBus) || (p.eventBus, void 0), visitedObjects.has(p.statement) || (p.statement, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_EventBusPolicy(p) {
    }
    function aws_cdk_lib_aws_events_Match(p) {
    }
    function aws_cdk_lib_aws_events_EventPattern(p) {
    }
    function aws_cdk_lib_aws_events_Schedule(p) {
    }
    function aws_cdk_lib_aws_events_CronOptions(p) {
    }
    function aws_cdk_lib_aws_events_EventCommonOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.eventPattern) || (p.eventPattern, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_OnEventOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.target) || (p.target, void 0), visitedObjects.has(p.eventPattern) || (p.eventPattern, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_BaseArchiveProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.eventPattern) || (p.eventPattern, void 0), visitedObjects.has(p.retention) || (p.retention, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_ArchiveProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sourceEventBus) || (p.sourceEventBus, void 0), visitedObjects.has(p.eventPattern) || (p.eventPattern, void 0), visitedObjects.has(p.retention) || (p.retention, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_Archive(p) {
    }
    function aws_cdk_lib_aws_events_ConnectionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.authorization) || (p.authorization, void 0), p.bodyParameters != null)
            for (const o of Object.values(p.bodyParameters))
              visitedObjects.has(o) || void 0;
          if (p.headerParameters != null)
            for (const o of Object.values(p.headerParameters))
              visitedObjects.has(o) || void 0;
          if (p.queryStringParameters != null)
            for (const o of Object.values(p.queryStringParameters))
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_Authorization(p) {
    }
    function aws_cdk_lib_aws_events_OAuthAuthorizationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.clientSecret) || (p.clientSecret, void 0), visitedObjects.has(p.httpMethod) || (p.httpMethod, void 0), p.bodyParameters != null)
            for (const o of Object.values(p.bodyParameters))
              visitedObjects.has(o) || void 0;
          if (p.headerParameters != null)
            for (const o of Object.values(p.headerParameters))
              visitedObjects.has(o) || void 0;
          if (p.queryStringParameters != null)
            for (const o of Object.values(p.queryStringParameters))
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_HttpParameter(p) {
    }
    function aws_cdk_lib_aws_events_IConnection(p) {
    }
    function aws_cdk_lib_aws_events_ConnectionAttributes(p) {
    }
    function aws_cdk_lib_aws_events_Connection(p) {
    }
    function aws_cdk_lib_aws_events_HttpMethod(p) {
    }
    function aws_cdk_lib_aws_events_ApiDestinationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.connection) || (p.connection, void 0), visitedObjects.has(p.httpMethod) || (p.httpMethod, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_IApiDestination(p) {
    }
    function aws_cdk_lib_aws_events_ApiDestination(p) {
    }
    function aws_cdk_lib_aws_events_CfnApiDestinationProps(p) {
    }
    function aws_cdk_lib_aws_events_CfnApiDestination(p) {
    }
    function aws_cdk_lib_aws_events_CfnArchiveProps(p) {
    }
    function aws_cdk_lib_aws_events_CfnArchive(p) {
    }
    function aws_cdk_lib_aws_events_CfnConnectionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.authParameters) || (p.authParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_CfnConnection(p) {
    }
    function aws_cdk_lib_aws_events_CfnConnection_ApiKeyAuthParametersProperty(p) {
    }
    function aws_cdk_lib_aws_events_CfnConnection_AuthParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.apiKeyAuthParameters) || (p.apiKeyAuthParameters, void 0), visitedObjects.has(p.basicAuthParameters) || (p.basicAuthParameters, void 0), visitedObjects.has(p.invocationHttpParameters) || (p.invocationHttpParameters, void 0), visitedObjects.has(p.oAuthParameters) || (p.oAuthParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_CfnConnection_BasicAuthParametersProperty(p) {
    }
    function aws_cdk_lib_aws_events_CfnConnection_ClientParametersProperty(p) {
    }
    function aws_cdk_lib_aws_events_CfnConnection_ConnectionHttpParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bodyParameters) || (p.bodyParameters, void 0), visitedObjects.has(p.headerParameters) || (p.headerParameters, void 0), visitedObjects.has(p.queryStringParameters) || (p.queryStringParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_CfnConnection_OAuthParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.clientParameters) || (p.clientParameters, void 0), visitedObjects.has(p.oAuthHttpParameters) || (p.oAuthHttpParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_CfnConnection_ParameterProperty(p) {
    }
    function aws_cdk_lib_aws_events_CfnEndpointProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.eventBuses) || (p.eventBuses, void 0), visitedObjects.has(p.routingConfig) || (p.routingConfig, void 0), visitedObjects.has(p.replicationConfig) || (p.replicationConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_CfnEndpoint(p) {
    }
    function aws_cdk_lib_aws_events_CfnEndpoint_EndpointEventBusProperty(p) {
    }
    function aws_cdk_lib_aws_events_CfnEndpoint_FailoverConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.primary) || (p.primary, void 0), visitedObjects.has(p.secondary) || (p.secondary, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_CfnEndpoint_PrimaryProperty(p) {
    }
    function aws_cdk_lib_aws_events_CfnEndpoint_ReplicationConfigProperty(p) {
    }
    function aws_cdk_lib_aws_events_CfnEndpoint_RoutingConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.failoverConfig) || (p.failoverConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_CfnEndpoint_SecondaryProperty(p) {
    }
    function aws_cdk_lib_aws_events_CfnEventBusProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_CfnEventBus(p) {
    }
    function aws_cdk_lib_aws_events_CfnEventBus_TagEntryProperty(p) {
    }
    function aws_cdk_lib_aws_events_CfnEventBusPolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.condition) || (p.condition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_CfnEventBusPolicy(p) {
    }
    function aws_cdk_lib_aws_events_CfnEventBusPolicy_ConditionProperty(p) {
    }
    function aws_cdk_lib_aws_events_CfnRuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.targets) || (p.targets, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_CfnRule(p) {
    }
    function aws_cdk_lib_aws_events_CfnRule_AwsVpcConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_events_CfnRule_BatchArrayPropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_events_CfnRule_BatchParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.arrayProperties) || (p.arrayProperties, void 0), visitedObjects.has(p.retryStrategy) || (p.retryStrategy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_CfnRule_BatchRetryStrategyProperty(p) {
    }
    function aws_cdk_lib_aws_events_CfnRule_CapacityProviderStrategyItemProperty(p) {
    }
    function aws_cdk_lib_aws_events_CfnRule_DeadLetterConfigProperty(p) {
    }
    function aws_cdk_lib_aws_events_CfnRule_EcsParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.capacityProviderStrategy) || (p.capacityProviderStrategy, void 0), visitedObjects.has(p.networkConfiguration) || (p.networkConfiguration, void 0), visitedObjects.has(p.placementConstraints) || (p.placementConstraints, void 0), visitedObjects.has(p.placementStrategies) || (p.placementStrategies, void 0), visitedObjects.has(p.tagList) || (p.tagList, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_CfnRule_HttpParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.headerParameters) || (p.headerParameters, void 0), visitedObjects.has(p.queryStringParameters) || (p.queryStringParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_CfnRule_InputTransformerProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.inputPathsMap) || (p.inputPathsMap, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_CfnRule_KinesisParametersProperty(p) {
    }
    function aws_cdk_lib_aws_events_CfnRule_NetworkConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.awsVpcConfiguration) || (p.awsVpcConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_CfnRule_PlacementConstraintProperty(p) {
    }
    function aws_cdk_lib_aws_events_CfnRule_PlacementStrategyProperty(p) {
    }
    function aws_cdk_lib_aws_events_CfnRule_RedshiftDataParametersProperty(p) {
    }
    function aws_cdk_lib_aws_events_CfnRule_RetryPolicyProperty(p) {
    }
    function aws_cdk_lib_aws_events_CfnRule_RunCommandParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.runCommandTargets) || (p.runCommandTargets, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_CfnRule_RunCommandTargetProperty(p) {
    }
    function aws_cdk_lib_aws_events_CfnRule_SageMakerPipelineParameterProperty(p) {
    }
    function aws_cdk_lib_aws_events_CfnRule_SageMakerPipelineParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.pipelineParameterList) || (p.pipelineParameterList, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_CfnRule_SqsParametersProperty(p) {
    }
    function aws_cdk_lib_aws_events_CfnRule_TagProperty(p) {
    }
    function aws_cdk_lib_aws_events_CfnRule_TargetProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.batchParameters) || (p.batchParameters, void 0), visitedObjects.has(p.deadLetterConfig) || (p.deadLetterConfig, void 0), visitedObjects.has(p.ecsParameters) || (p.ecsParameters, void 0), visitedObjects.has(p.httpParameters) || (p.httpParameters, void 0), visitedObjects.has(p.inputTransformer) || (p.inputTransformer, void 0), visitedObjects.has(p.kinesisParameters) || (p.kinesisParameters, void 0), visitedObjects.has(p.redshiftDataParameters) || (p.redshiftDataParameters, void 0), visitedObjects.has(p.retryPolicy) || (p.retryPolicy, void 0), visitedObjects.has(p.runCommandParameters) || (p.runCommandParameters, void 0), visitedObjects.has(p.sageMakerPipelineParameters) || (p.sageMakerPipelineParameters, void 0), visitedObjects.has(p.sqsParameters) || (p.sqsParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_targets_BatchJobProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.event) || (p.event, void 0), visitedObjects.has(p.deadLetterQueue) || (p.deadLetterQueue, void 0), visitedObjects.has(p.maxEventAge) || (p.maxEventAge, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_targets_BatchJob(p) {
    }
    function aws_cdk_lib_aws_events_targets_CodePipelineTargetOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.eventRole) || (p.eventRole, void 0), visitedObjects.has(p.deadLetterQueue) || (p.deadLetterQueue, void 0), visitedObjects.has(p.maxEventAge) || (p.maxEventAge, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_targets_CodePipeline(p) {
    }
    function aws_cdk_lib_aws_events_targets_SnsTopicProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.message) || (p.message, void 0), visitedObjects.has(p.deadLetterQueue) || (p.deadLetterQueue, void 0), visitedObjects.has(p.maxEventAge) || (p.maxEventAge, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_targets_SnsTopic(p) {
    }
    function aws_cdk_lib_aws_events_targets_SqsQueueProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.message) || (p.message, void 0), visitedObjects.has(p.deadLetterQueue) || (p.deadLetterQueue, void 0), visitedObjects.has(p.maxEventAge) || (p.maxEventAge, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_targets_SqsQueue(p) {
    }
    function aws_cdk_lib_aws_events_targets_CodeBuildProjectProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.event) || (p.event, void 0), visitedObjects.has(p.eventRole) || (p.eventRole, void 0), visitedObjects.has(p.deadLetterQueue) || (p.deadLetterQueue, void 0), visitedObjects.has(p.maxEventAge) || (p.maxEventAge, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_targets_CodeBuildProject(p) {
    }
    function aws_cdk_lib_aws_events_targets_AwsApiInput(p) {
    }
    function aws_cdk_lib_aws_events_targets_AwsApiProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.policyStatement) || (p.policyStatement, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_targets_AwsApi(p) {
    }
    function aws_cdk_lib_aws_events_targets_LambdaFunctionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.event) || (p.event, void 0), visitedObjects.has(p.deadLetterQueue) || (p.deadLetterQueue, void 0), visitedObjects.has(p.maxEventAge) || (p.maxEventAge, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_targets_LambdaFunction(p) {
    }
    function aws_cdk_lib_aws_events_targets_ContainerOverride(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.environment != null)
            for (const o of p.environment)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_targets_TaskEnvironmentVariable(p) {
    }
    function aws_cdk_lib_aws_events_targets_Tag(p) {
    }
    function aws_cdk_lib_aws_events_targets_EcsTaskProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.cluster) || (p.cluster, void 0), visitedObjects.has(p.taskDefinition) || (p.taskDefinition, void 0), p.containerOverrides != null)
            for (const o of p.containerOverrides)
              visitedObjects.has(o) || aws_cdk_lib_aws_events_targets_ContainerOverride(o);
          if (visitedObjects.has(p.platformVersion) || (p.platformVersion, void 0), visitedObjects.has(p.propagateTags) || (p.propagateTags, void 0), visitedObjects.has(p.role) || (p.role, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.subnetSelection) || aws_cdk_lib_aws_ec2_SubnetSelection(p.subnetSelection), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.deadLetterQueue) || (p.deadLetterQueue, void 0), visitedObjects.has(p.maxEventAge) || (p.maxEventAge, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_targets_EcsTask(p) {
    }
    function aws_cdk_lib_aws_events_targets_EventBusProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.deadLetterQueue) || (p.deadLetterQueue, void 0), visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_targets_EventBus(p) {
    }
    function aws_cdk_lib_aws_events_targets_SfnStateMachineProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.input) || (p.input, void 0), visitedObjects.has(p.role) || (p.role, void 0), visitedObjects.has(p.deadLetterQueue) || (p.deadLetterQueue, void 0), visitedObjects.has(p.maxEventAge) || (p.maxEventAge, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_targets_SfnStateMachine(p) {
    }
    function aws_cdk_lib_aws_events_targets_KinesisStreamProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.message) || (p.message, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_targets_KinesisStream(p) {
    }
    function aws_cdk_lib_aws_events_targets_LogGroupTargetInputOptions(p) {
    }
    function aws_cdk_lib_aws_events_targets_LogGroupTargetInput(p) {
    }
    function aws_cdk_lib_aws_events_targets_LogGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          "event" in p && print("aws-cdk-lib.aws_events_targets.LogGroupProps#event", "use logEvent instead"), visitedObjects.has(p.event) || (p.event, void 0), visitedObjects.has(p.logEvent) || (p.logEvent, void 0), visitedObjects.has(p.deadLetterQueue) || (p.deadLetterQueue, void 0), visitedObjects.has(p.maxEventAge) || (p.maxEventAge, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_targets_CloudWatchLogGroup(p) {
    }
    function aws_cdk_lib_aws_events_targets_KinesisFirehoseStreamProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.message) || (p.message, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_targets_KinesisFirehoseStream(p) {
    }
    function aws_cdk_lib_aws_events_targets_ApiGatewayProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.eventRole) || (p.eventRole, void 0), visitedObjects.has(p.postBody) || (p.postBody, void 0), visitedObjects.has(p.deadLetterQueue) || (p.deadLetterQueue, void 0), visitedObjects.has(p.maxEventAge) || (p.maxEventAge, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_targets_ApiGateway(p) {
    }
    function aws_cdk_lib_aws_events_targets_ApiDestinationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.event) || (p.event, void 0), visitedObjects.has(p.eventRole) || (p.eventRole, void 0), visitedObjects.has(p.deadLetterQueue) || (p.deadLetterQueue, void 0), visitedObjects.has(p.maxEventAge) || (p.maxEventAge, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_events_targets_ApiDestination(p) {
    }
    function aws_cdk_lib_aws_events_targets_TargetBaseProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.deadLetterQueue) || (p.deadLetterQueue, void 0), visitedObjects.has(p.maxEventAge) || (p.maxEventAge, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eventschemas_CfnDiscovererProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eventschemas_CfnDiscoverer(p) {
    }
    function aws_cdk_lib_aws_eventschemas_CfnDiscoverer_TagsEntryProperty(p) {
    }
    function aws_cdk_lib_aws_eventschemas_CfnRegistryProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eventschemas_CfnRegistry(p) {
    }
    function aws_cdk_lib_aws_eventschemas_CfnRegistry_TagsEntryProperty(p) {
    }
    function aws_cdk_lib_aws_eventschemas_CfnRegistryPolicyProps(p) {
    }
    function aws_cdk_lib_aws_eventschemas_CfnRegistryPolicy(p) {
    }
    function aws_cdk_lib_aws_eventschemas_CfnSchemaProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_eventschemas_CfnSchema(p) {
    }
    function aws_cdk_lib_aws_eventschemas_CfnSchema_TagsEntryProperty(p) {
    }
    function aws_cdk_lib_aws_evidently_CfnExperimentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.metricGoals) || (p.metricGoals, void 0), visitedObjects.has(p.onlineAbConfig) || (p.onlineAbConfig, void 0), visitedObjects.has(p.treatments) || (p.treatments, void 0), visitedObjects.has(p.runningStatus) || (p.runningStatus, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_evidently_CfnExperiment(p) {
    }
    function aws_cdk_lib_aws_evidently_CfnExperiment_MetricGoalObjectProperty(p) {
    }
    function aws_cdk_lib_aws_evidently_CfnExperiment_OnlineAbConfigObjectProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.treatmentWeights) || (p.treatmentWeights, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_evidently_CfnExperiment_RunningStatusObjectProperty(p) {
    }
    function aws_cdk_lib_aws_evidently_CfnExperiment_TreatmentObjectProperty(p) {
    }
    function aws_cdk_lib_aws_evidently_CfnExperiment_TreatmentToWeightProperty(p) {
    }
    function aws_cdk_lib_aws_evidently_CfnFeatureProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.variations) || (p.variations, void 0), visitedObjects.has(p.entityOverrides) || (p.entityOverrides, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_evidently_CfnFeature(p) {
    }
    function aws_cdk_lib_aws_evidently_CfnFeature_EntityOverrideProperty(p) {
    }
    function aws_cdk_lib_aws_evidently_CfnFeature_VariationObjectProperty(p) {
    }
    function aws_cdk_lib_aws_evidently_CfnLaunchProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.groups) || (p.groups, void 0), visitedObjects.has(p.scheduledSplitsConfig) || (p.scheduledSplitsConfig, void 0), visitedObjects.has(p.executionStatus) || (p.executionStatus, void 0), visitedObjects.has(p.metricMonitors) || (p.metricMonitors, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_evidently_CfnLaunch(p) {
    }
    function aws_cdk_lib_aws_evidently_CfnLaunch_ExecutionStatusObjectProperty(p) {
    }
    function aws_cdk_lib_aws_evidently_CfnLaunch_GroupToWeightProperty(p) {
    }
    function aws_cdk_lib_aws_evidently_CfnLaunch_LaunchGroupObjectProperty(p) {
    }
    function aws_cdk_lib_aws_evidently_CfnLaunch_MetricDefinitionObjectProperty(p) {
    }
    function aws_cdk_lib_aws_evidently_CfnLaunch_SegmentOverrideProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.weights) || (p.weights, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_evidently_CfnLaunch_StepConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.groupWeights) || (p.groupWeights, void 0), visitedObjects.has(p.segmentOverrides) || (p.segmentOverrides, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_evidently_CfnProjectProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.appConfigResource) || (p.appConfigResource, void 0), visitedObjects.has(p.dataDelivery) || (p.dataDelivery, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_evidently_CfnProject(p) {
    }
    function aws_cdk_lib_aws_evidently_CfnProject_AppConfigResourceObjectProperty(p) {
    }
    function aws_cdk_lib_aws_evidently_CfnProject_DataDeliveryObjectProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3) || (p.s3, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_evidently_CfnProject_S3DestinationProperty(p) {
    }
    function aws_cdk_lib_aws_evidently_CfnSegmentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_evidently_CfnSegment(p) {
    }
    function aws_cdk_lib_aws_finspace_CfnEnvironmentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.federationParameters) || (p.federationParameters, void 0), visitedObjects.has(p.superuserParameters) || (p.superuserParameters, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_finspace_CfnEnvironment(p) {
    }
    function aws_cdk_lib_aws_finspace_CfnEnvironment_AttributeMapItemsProperty(p) {
    }
    function aws_cdk_lib_aws_finspace_CfnEnvironment_FederationParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.attributeMap) || (p.attributeMap, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_finspace_CfnEnvironment_SuperuserParametersProperty(p) {
    }
    function aws_cdk_lib_aws_fis_CfnExperimentTemplateProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.stopConditions) || (p.stopConditions, void 0), visitedObjects.has(p.targets) || (p.targets, void 0), visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.logConfiguration) || (p.logConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_fis_CfnExperimentTemplate(p) {
    }
    function aws_cdk_lib_aws_fis_CfnExperimentTemplate_CloudWatchLogsConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_fis_CfnExperimentTemplate_ExperimentTemplateActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.parameters) || (p.parameters, void 0), visitedObjects.has(p.targets) || (p.targets, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_fis_CfnExperimentTemplate_ExperimentTemplateLogConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_fis_CfnExperimentTemplate_ExperimentTemplateStopConditionProperty(p) {
    }
    function aws_cdk_lib_aws_fis_CfnExperimentTemplate_ExperimentTemplateTargetProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.filters) || (p.filters, void 0), visitedObjects.has(p.parameters) || (p.parameters, void 0), visitedObjects.has(p.resourceTags) || (p.resourceTags, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_fis_CfnExperimentTemplate_ExperimentTemplateTargetFilterProperty(p) {
    }
    function aws_cdk_lib_aws_fis_CfnExperimentTemplate_S3ConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_fms_CfnNotificationChannelProps(p) {
    }
    function aws_cdk_lib_aws_fms_CfnNotificationChannel(p) {
    }
    function aws_cdk_lib_aws_fms_CfnPolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.securityServicePolicyData) || (p.securityServicePolicyData, void 0), visitedObjects.has(p.excludeMap) || (p.excludeMap, void 0), visitedObjects.has(p.includeMap) || (p.includeMap, void 0), visitedObjects.has(p.resourceTags) || (p.resourceTags, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_fms_CfnPolicy(p) {
    }
    function aws_cdk_lib_aws_fms_CfnPolicy_IEMapProperty(p) {
    }
    function aws_cdk_lib_aws_fms_CfnPolicy_NetworkFirewallPolicyProperty(p) {
    }
    function aws_cdk_lib_aws_fms_CfnPolicy_PolicyOptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.networkFirewallPolicy) || (p.networkFirewallPolicy, void 0), visitedObjects.has(p.thirdPartyFirewallPolicy) || (p.thirdPartyFirewallPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_fms_CfnPolicy_PolicyTagProperty(p) {
    }
    function aws_cdk_lib_aws_fms_CfnPolicy_ResourceTagProperty(p) {
    }
    function aws_cdk_lib_aws_fms_CfnPolicy_SecurityServicePolicyDataProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.policyOption) || (p.policyOption, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_fms_CfnPolicy_ThirdPartyFirewallPolicyProperty(p) {
    }
    function aws_cdk_lib_aws_fms_CfnResourceSetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_fms_CfnResourceSet(p) {
    }
    function aws_cdk_lib_aws_forecast_CfnDatasetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_forecast_CfnDataset(p) {
    }
    function aws_cdk_lib_aws_forecast_CfnDataset_AttributesItemsProperty(p) {
    }
    function aws_cdk_lib_aws_forecast_CfnDataset_EncryptionConfigProperty(p) {
    }
    function aws_cdk_lib_aws_forecast_CfnDataset_SchemaProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.attributes) || (p.attributes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_forecast_CfnDataset_TagsItemsProperty(p) {
    }
    function aws_cdk_lib_aws_forecast_CfnDatasetGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_forecast_CfnDatasetGroup(p) {
    }
    function aws_cdk_lib_aws_frauddetector_CfnDetectorProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.eventType) || (p.eventType, void 0), visitedObjects.has(p.rules) || (p.rules, void 0), visitedObjects.has(p.associatedModels) || (p.associatedModels, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_frauddetector_CfnDetector(p) {
    }
    function aws_cdk_lib_aws_frauddetector_CfnDetector_EntityTypeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_frauddetector_CfnDetector_EventTypeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.entityTypes) || (p.entityTypes, void 0), visitedObjects.has(p.eventVariables) || (p.eventVariables, void 0), visitedObjects.has(p.labels) || (p.labels, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_frauddetector_CfnDetector_EventVariableProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_frauddetector_CfnDetector_LabelProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_frauddetector_CfnDetector_ModelProperty(p) {
    }
    function aws_cdk_lib_aws_frauddetector_CfnDetector_OutcomeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_frauddetector_CfnDetector_RuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.outcomes) || (p.outcomes, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_frauddetector_CfnEntityTypeProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_frauddetector_CfnEntityType(p) {
    }
    function aws_cdk_lib_aws_frauddetector_CfnEventTypeProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.entityTypes) || (p.entityTypes, void 0), visitedObjects.has(p.eventVariables) || (p.eventVariables, void 0), visitedObjects.has(p.labels) || (p.labels, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_frauddetector_CfnEventType(p) {
    }
    function aws_cdk_lib_aws_frauddetector_CfnEventType_EntityTypeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_frauddetector_CfnEventType_EventVariableProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_frauddetector_CfnEventType_LabelProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_frauddetector_CfnLabelProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_frauddetector_CfnLabel(p) {
    }
    function aws_cdk_lib_aws_frauddetector_CfnListProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_frauddetector_CfnList(p) {
    }
    function aws_cdk_lib_aws_frauddetector_CfnOutcomeProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_frauddetector_CfnOutcome(p) {
    }
    function aws_cdk_lib_aws_frauddetector_CfnVariableProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_frauddetector_CfnVariable(p) {
    }
    function aws_cdk_lib_aws_fsx_IFileSystem(p) {
    }
    function aws_cdk_lib_aws_fsx_FileSystemProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.kmsKey) || (p.kmsKey, void 0), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), visitedObjects.has(p.securityGroup) || (p.securityGroup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_fsx_FileSystemBase(p) {
    }
    function aws_cdk_lib_aws_fsx_FileSystemAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.securityGroup) || (p.securityGroup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_fsx_CfnDataRepositoryAssociationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.s3) || (p.s3, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_fsx_CfnDataRepositoryAssociation(p) {
    }
    function aws_cdk_lib_aws_fsx_CfnDataRepositoryAssociation_AutoExportPolicyProperty(p) {
    }
    function aws_cdk_lib_aws_fsx_CfnDataRepositoryAssociation_AutoImportPolicyProperty(p) {
    }
    function aws_cdk_lib_aws_fsx_CfnDataRepositoryAssociation_S3Property(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.autoExportPolicy) || (p.autoExportPolicy, void 0), visitedObjects.has(p.autoImportPolicy) || (p.autoImportPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_fsx_CfnFileSystemProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.lustreConfiguration) || (p.lustreConfiguration, void 0), visitedObjects.has(p.ontapConfiguration) || (p.ontapConfiguration, void 0), visitedObjects.has(p.openZfsConfiguration) || (p.openZfsConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.windowsConfiguration) || (p.windowsConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_fsx_CfnFileSystem(p) {
    }
    function aws_cdk_lib_aws_fsx_CfnFileSystem_AuditLogConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_fsx_CfnFileSystem_ClientConfigurationsProperty(p) {
    }
    function aws_cdk_lib_aws_fsx_CfnFileSystem_DiskIopsConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_fsx_CfnFileSystem_LustreConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_fsx_CfnFileSystem_NfsExportsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.clientConfigurations) || (p.clientConfigurations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_fsx_CfnFileSystem_OntapConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.diskIopsConfiguration) || (p.diskIopsConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_fsx_CfnFileSystem_OpenZFSConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.diskIopsConfiguration) || (p.diskIopsConfiguration, void 0), visitedObjects.has(p.rootVolumeConfiguration) || (p.rootVolumeConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_fsx_CfnFileSystem_RootVolumeConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.nfsExports) || (p.nfsExports, void 0), visitedObjects.has(p.userAndGroupQuotas) || (p.userAndGroupQuotas, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_fsx_CfnFileSystem_SelfManagedActiveDirectoryConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_fsx_CfnFileSystem_UserAndGroupQuotasProperty(p) {
    }
    function aws_cdk_lib_aws_fsx_CfnFileSystem_WindowsConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.auditLogConfiguration) || (p.auditLogConfiguration, void 0), visitedObjects.has(p.selfManagedActiveDirectoryConfiguration) || (p.selfManagedActiveDirectoryConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_fsx_CfnSnapshotProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_fsx_CfnSnapshot(p) {
    }
    function aws_cdk_lib_aws_fsx_CfnStorageVirtualMachineProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.activeDirectoryConfiguration) || (p.activeDirectoryConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_fsx_CfnStorageVirtualMachine(p) {
    }
    function aws_cdk_lib_aws_fsx_CfnStorageVirtualMachine_ActiveDirectoryConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.selfManagedActiveDirectoryConfiguration) || (p.selfManagedActiveDirectoryConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_fsx_CfnStorageVirtualMachine_SelfManagedActiveDirectoryConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_fsx_CfnVolumeProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.ontapConfiguration) || (p.ontapConfiguration, void 0), visitedObjects.has(p.openZfsConfiguration) || (p.openZfsConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_fsx_CfnVolume(p) {
    }
    function aws_cdk_lib_aws_fsx_CfnVolume_ClientConfigurationsProperty(p) {
    }
    function aws_cdk_lib_aws_fsx_CfnVolume_NfsExportsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.clientConfigurations) || (p.clientConfigurations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_fsx_CfnVolume_OntapConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tieringPolicy) || (p.tieringPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_fsx_CfnVolume_OpenZFSConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.nfsExports) || (p.nfsExports, void 0), visitedObjects.has(p.originSnapshot) || (p.originSnapshot, void 0), visitedObjects.has(p.userAndGroupQuotas) || (p.userAndGroupQuotas, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_fsx_CfnVolume_OriginSnapshotProperty(p) {
    }
    function aws_cdk_lib_aws_fsx_CfnVolume_TieringPolicyProperty(p) {
    }
    function aws_cdk_lib_aws_fsx_CfnVolume_UserAndGroupQuotasProperty(p) {
    }
    function aws_cdk_lib_aws_fsx_LustreDeploymentType(p) {
    }
    function aws_cdk_lib_aws_fsx_LustreAutoImportPolicy(p) {
    }
    function aws_cdk_lib_aws_fsx_LustreDataCompressionType(p) {
    }
    function aws_cdk_lib_aws_fsx_LustreConfiguration(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.deploymentType) || (p.deploymentType, void 0), visitedObjects.has(p.autoImportPolicy) || (p.autoImportPolicy, void 0), visitedObjects.has(p.dataCompressionType) || (p.dataCompressionType, void 0), visitedObjects.has(p.weeklyMaintenanceStartTime) || (p.weeklyMaintenanceStartTime, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_fsx_LustreFileSystemProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.lustreConfiguration) || aws_cdk_lib_aws_fsx_LustreConfiguration(p.lustreConfiguration), visitedObjects.has(p.vpcSubnet) || (p.vpcSubnet, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.kmsKey) || (p.kmsKey, void 0), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), visitedObjects.has(p.securityGroup) || (p.securityGroup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_fsx_LustreFileSystem(p) {
    }
    function aws_cdk_lib_aws_fsx_Weekday(p) {
    }
    function aws_cdk_lib_aws_fsx_LustreMaintenanceTimeProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.day) || (p.day, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_fsx_LustreMaintenanceTime(p) {
    }
    function aws_cdk_lib_aws_gamelift_CfnAliasProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.routingStrategy) || (p.routingStrategy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_gamelift_CfnAlias(p) {
    }
    function aws_cdk_lib_aws_gamelift_CfnAlias_RoutingStrategyProperty(p) {
    }
    function aws_cdk_lib_aws_gamelift_CfnBuildProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.storageLocation) || (p.storageLocation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_gamelift_CfnBuild(p) {
    }
    function aws_cdk_lib_aws_gamelift_CfnBuild_StorageLocationProperty(p) {
    }
    function aws_cdk_lib_aws_gamelift_CfnFleetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.anywhereConfiguration) || (p.anywhereConfiguration, void 0), visitedObjects.has(p.certificateConfiguration) || (p.certificateConfiguration, void 0), visitedObjects.has(p.ec2InboundPermissions) || (p.ec2InboundPermissions, void 0), visitedObjects.has(p.locations) || (p.locations, void 0), visitedObjects.has(p.resourceCreationLimitPolicy) || (p.resourceCreationLimitPolicy, void 0), visitedObjects.has(p.runtimeConfiguration) || (p.runtimeConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_gamelift_CfnFleet(p) {
    }
    function aws_cdk_lib_aws_gamelift_CfnFleet_AnywhereConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_gamelift_CfnFleet_CertificateConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_gamelift_CfnFleet_IpPermissionProperty(p) {
    }
    function aws_cdk_lib_aws_gamelift_CfnFleet_LocationCapacityProperty(p) {
    }
    function aws_cdk_lib_aws_gamelift_CfnFleet_LocationConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.locationCapacity) || (p.locationCapacity, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_gamelift_CfnFleet_ResourceCreationLimitPolicyProperty(p) {
    }
    function aws_cdk_lib_aws_gamelift_CfnFleet_RuntimeConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.serverProcesses) || (p.serverProcesses, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_gamelift_CfnFleet_ServerProcessProperty(p) {
    }
    function aws_cdk_lib_aws_gamelift_CfnGameServerGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.instanceDefinitions) || (p.instanceDefinitions, void 0), visitedObjects.has(p.autoScalingPolicy) || (p.autoScalingPolicy, void 0), visitedObjects.has(p.launchTemplate) || (p.launchTemplate, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_gamelift_CfnGameServerGroup(p) {
    }
    function aws_cdk_lib_aws_gamelift_CfnGameServerGroup_AutoScalingPolicyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.targetTrackingConfiguration) || (p.targetTrackingConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_gamelift_CfnGameServerGroup_InstanceDefinitionProperty(p) {
    }
    function aws_cdk_lib_aws_gamelift_CfnGameServerGroup_LaunchTemplateProperty(p) {
    }
    function aws_cdk_lib_aws_gamelift_CfnGameServerGroup_TargetTrackingConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_gamelift_CfnGameSessionQueueProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.destinations) || (p.destinations, void 0), visitedObjects.has(p.filterConfiguration) || (p.filterConfiguration, void 0), visitedObjects.has(p.playerLatencyPolicies) || (p.playerLatencyPolicies, void 0), visitedObjects.has(p.priorityConfiguration) || (p.priorityConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_gamelift_CfnGameSessionQueue(p) {
    }
    function aws_cdk_lib_aws_gamelift_CfnGameSessionQueue_DestinationProperty(p) {
    }
    function aws_cdk_lib_aws_gamelift_CfnGameSessionQueue_FilterConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_gamelift_CfnGameSessionQueue_PlayerLatencyPolicyProperty(p) {
    }
    function aws_cdk_lib_aws_gamelift_CfnGameSessionQueue_PriorityConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_gamelift_CfnLocationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_gamelift_CfnLocation(p) {
    }
    function aws_cdk_lib_aws_gamelift_CfnMatchmakingConfigurationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.gameProperties) || (p.gameProperties, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_gamelift_CfnMatchmakingConfiguration(p) {
    }
    function aws_cdk_lib_aws_gamelift_CfnMatchmakingConfiguration_GamePropertyProperty(p) {
    }
    function aws_cdk_lib_aws_gamelift_CfnMatchmakingRuleSetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_gamelift_CfnMatchmakingRuleSet(p) {
    }
    function aws_cdk_lib_aws_gamelift_CfnScriptProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.storageLocation) || (p.storageLocation, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_gamelift_CfnScript(p) {
    }
    function aws_cdk_lib_aws_gamelift_CfnScript_S3LocationProperty(p) {
    }
    function aws_cdk_lib_aws_globalaccelerator_CfnAcceleratorProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_globalaccelerator_CfnAccelerator(p) {
    }
    function aws_cdk_lib_aws_globalaccelerator_CfnEndpointGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.endpointConfigurations) || (p.endpointConfigurations, void 0), visitedObjects.has(p.portOverrides) || (p.portOverrides, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_globalaccelerator_CfnEndpointGroup(p) {
    }
    function aws_cdk_lib_aws_globalaccelerator_CfnEndpointGroup_EndpointConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_globalaccelerator_CfnEndpointGroup_PortOverrideProperty(p) {
    }
    function aws_cdk_lib_aws_globalaccelerator_CfnListenerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.portRanges) || (p.portRanges, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_globalaccelerator_CfnListener(p) {
    }
    function aws_cdk_lib_aws_globalaccelerator_CfnListener_PortRangeProperty(p) {
    }
    function aws_cdk_lib_aws_globalaccelerator_IAccelerator(p) {
    }
    function aws_cdk_lib_aws_globalaccelerator_AcceleratorProps(p) {
    }
    function aws_cdk_lib_aws_globalaccelerator_AcceleratorAttributes(p) {
    }
    function aws_cdk_lib_aws_globalaccelerator_Accelerator(p) {
    }
    function aws_cdk_lib_aws_globalaccelerator_IListener(p) {
    }
    function aws_cdk_lib_aws_globalaccelerator_ListenerOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.portRanges != null)
            for (const o of p.portRanges)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.clientAffinity) || (p.clientAffinity, void 0), visitedObjects.has(p.protocol) || (p.protocol, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_globalaccelerator_ListenerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.accelerator) || (p.accelerator, void 0), p.portRanges != null)
            for (const o of p.portRanges)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.clientAffinity) || (p.clientAffinity, void 0), visitedObjects.has(p.protocol) || (p.protocol, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_globalaccelerator_PortRange(p) {
    }
    function aws_cdk_lib_aws_globalaccelerator_ConnectionProtocol(p) {
    }
    function aws_cdk_lib_aws_globalaccelerator_ClientAffinity(p) {
    }
    function aws_cdk_lib_aws_globalaccelerator_Listener(p) {
    }
    function aws_cdk_lib_aws_globalaccelerator_IEndpointGroup(p) {
    }
    function aws_cdk_lib_aws_globalaccelerator_EndpointGroupOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.endpoints != null)
            for (const o of p.endpoints)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.healthCheckInterval) || (p.healthCheckInterval, void 0), visitedObjects.has(p.healthCheckProtocol) || (p.healthCheckProtocol, void 0), p.portOverrides != null)
            for (const o of p.portOverrides)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_globalaccelerator_PortOverride(p) {
    }
    function aws_cdk_lib_aws_globalaccelerator_HealthCheckProtocol(p) {
    }
    function aws_cdk_lib_aws_globalaccelerator_EndpointGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.listener) || (p.listener, void 0), p.endpoints != null)
            for (const o of p.endpoints)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.healthCheckInterval) || (p.healthCheckInterval, void 0), visitedObjects.has(p.healthCheckProtocol) || (p.healthCheckProtocol, void 0), p.portOverrides != null)
            for (const o of p.portOverrides)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_globalaccelerator_EndpointGroup(p) {
    }
    function aws_cdk_lib_aws_globalaccelerator_IEndpoint(p) {
    }
    function aws_cdk_lib_aws_globalaccelerator_RawEndpointProps(p) {
    }
    function aws_cdk_lib_aws_globalaccelerator_RawEndpoint(p) {
    }
    function aws_cdk_lib_aws_globalaccelerator_endpoints_ApplicationLoadBalancerEndpointOptions(p) {
    }
    function aws_cdk_lib_aws_globalaccelerator_endpoints_ApplicationLoadBalancerEndpoint(p) {
    }
    function aws_cdk_lib_aws_globalaccelerator_endpoints_NetworkLoadBalancerEndpointProps(p) {
    }
    function aws_cdk_lib_aws_globalaccelerator_endpoints_NetworkLoadBalancerEndpoint(p) {
    }
    function aws_cdk_lib_aws_globalaccelerator_endpoints_InstanceEndpointProps(p) {
    }
    function aws_cdk_lib_aws_globalaccelerator_endpoints_InstanceEndpoint(p) {
    }
    function aws_cdk_lib_aws_globalaccelerator_endpoints_CfnEipEndpointProps(p) {
    }
    function aws_cdk_lib_aws_globalaccelerator_endpoints_CfnEipEndpoint(p) {
    }
    function aws_cdk_lib_aws_glue_CfnClassifierProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.csvClassifier) || (p.csvClassifier, void 0), visitedObjects.has(p.grokClassifier) || (p.grokClassifier, void 0), visitedObjects.has(p.jsonClassifier) || (p.jsonClassifier, void 0), visitedObjects.has(p.xmlClassifier) || (p.xmlClassifier, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_glue_CfnClassifier(p) {
    }
    function aws_cdk_lib_aws_glue_CfnClassifier_CsvClassifierProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnClassifier_GrokClassifierProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnClassifier_JsonClassifierProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnClassifier_XMLClassifierProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnConnectionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.connectionInput) || (p.connectionInput, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_glue_CfnConnection(p) {
    }
    function aws_cdk_lib_aws_glue_CfnConnection_ConnectionInputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.physicalConnectionRequirements) || (p.physicalConnectionRequirements, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_glue_CfnConnection_PhysicalConnectionRequirementsProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnCrawlerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.targets) || (p.targets, void 0), visitedObjects.has(p.recrawlPolicy) || (p.recrawlPolicy, void 0), visitedObjects.has(p.schedule) || (p.schedule, void 0), visitedObjects.has(p.schemaChangePolicy) || (p.schemaChangePolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_glue_CfnCrawler(p) {
    }
    function aws_cdk_lib_aws_glue_CfnCrawler_CatalogTargetProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnCrawler_DeltaTargetProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnCrawler_DynamoDBTargetProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnCrawler_JdbcTargetProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnCrawler_MongoDBTargetProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnCrawler_RecrawlPolicyProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnCrawler_S3TargetProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnCrawler_ScheduleProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnCrawler_SchemaChangePolicyProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnCrawler_TargetsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.catalogTargets) || (p.catalogTargets, void 0), visitedObjects.has(p.deltaTargets) || (p.deltaTargets, void 0), visitedObjects.has(p.dynamoDbTargets) || (p.dynamoDbTargets, void 0), visitedObjects.has(p.jdbcTargets) || (p.jdbcTargets, void 0), visitedObjects.has(p.mongoDbTargets) || (p.mongoDbTargets, void 0), visitedObjects.has(p.s3Targets) || (p.s3Targets, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_glue_CfnDataCatalogEncryptionSettingsProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataCatalogEncryptionSettings) || (p.dataCatalogEncryptionSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_glue_CfnDataCatalogEncryptionSettings(p) {
    }
    function aws_cdk_lib_aws_glue_CfnDataCatalogEncryptionSettings_ConnectionPasswordEncryptionProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnDataCatalogEncryptionSettings_DataCatalogEncryptionSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.connectionPasswordEncryption) || (p.connectionPasswordEncryption, void 0), visitedObjects.has(p.encryptionAtRest) || (p.encryptionAtRest, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_glue_CfnDataCatalogEncryptionSettings_EncryptionAtRestProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnDatabaseProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.databaseInput) || (p.databaseInput, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_glue_CfnDatabase(p) {
    }
    function aws_cdk_lib_aws_glue_CfnDatabase_DataLakePrincipalProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnDatabase_DatabaseIdentifierProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnDatabase_DatabaseInputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.createTableDefaultPermissions) || (p.createTableDefaultPermissions, void 0), visitedObjects.has(p.federatedDatabase) || (p.federatedDatabase, void 0), visitedObjects.has(p.targetDatabase) || (p.targetDatabase, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_glue_CfnDatabase_FederatedDatabaseProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnDatabase_PrincipalPrivilegesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.principal) || (p.principal, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_glue_CfnDevEndpointProps(p) {
    }
    function aws_cdk_lib_aws_glue_CfnDevEndpoint(p) {
    }
    function aws_cdk_lib_aws_glue_CfnJobProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.command) || (p.command, void 0), visitedObjects.has(p.connections) || (p.connections, void 0), visitedObjects.has(p.executionProperty) || (p.executionProperty, void 0), visitedObjects.has(p.notificationProperty) || (p.notificationProperty, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_glue_CfnJob(p) {
    }
    function aws_cdk_lib_aws_glue_CfnJob_ConnectionsListProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnJob_ExecutionPropertyProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnJob_JobCommandProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnJob_NotificationPropertyProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnMLTransformProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.inputRecordTables) || (p.inputRecordTables, void 0), visitedObjects.has(p.transformParameters) || (p.transformParameters, void 0), visitedObjects.has(p.transformEncryption) || (p.transformEncryption, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_glue_CfnMLTransform(p) {
    }
    function aws_cdk_lib_aws_glue_CfnMLTransform_FindMatchesParametersProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnMLTransform_GlueTablesProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnMLTransform_InputRecordTablesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.glueTables) || (p.glueTables, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_glue_CfnMLTransform_MLUserDataEncryptionProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnMLTransform_TransformEncryptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.mlUserDataEncryption) || (p.mlUserDataEncryption, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_glue_CfnMLTransform_TransformParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.findMatchesParameters) || (p.findMatchesParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_glue_CfnPartitionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.partitionInput) || (p.partitionInput, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_glue_CfnPartition(p) {
    }
    function aws_cdk_lib_aws_glue_CfnPartition_ColumnProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnPartition_OrderProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnPartition_PartitionInputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.storageDescriptor) || (p.storageDescriptor, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_glue_CfnPartition_SchemaIdProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnPartition_SchemaReferenceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.schemaId) || (p.schemaId, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_glue_CfnPartition_SerdeInfoProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnPartition_SkewedInfoProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnPartition_StorageDescriptorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columns) || (p.columns, void 0), visitedObjects.has(p.schemaReference) || (p.schemaReference, void 0), visitedObjects.has(p.serdeInfo) || (p.serdeInfo, void 0), visitedObjects.has(p.skewedInfo) || (p.skewedInfo, void 0), visitedObjects.has(p.sortColumns) || (p.sortColumns, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_glue_CfnRegistryProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_glue_CfnRegistry(p) {
    }
    function aws_cdk_lib_aws_glue_CfnSchemaProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.checkpointVersion) || (p.checkpointVersion, void 0), visitedObjects.has(p.registry) || (p.registry, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_glue_CfnSchema(p) {
    }
    function aws_cdk_lib_aws_glue_CfnSchema_RegistryProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnSchema_SchemaVersionProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnSchemaVersionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.schema) || (p.schema, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_glue_CfnSchemaVersion(p) {
    }
    function aws_cdk_lib_aws_glue_CfnSchemaVersion_SchemaProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnSchemaVersionMetadataProps(p) {
    }
    function aws_cdk_lib_aws_glue_CfnSchemaVersionMetadata(p) {
    }
    function aws_cdk_lib_aws_glue_CfnSecurityConfigurationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.encryptionConfiguration) || (p.encryptionConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_glue_CfnSecurityConfiguration(p) {
    }
    function aws_cdk_lib_aws_glue_CfnSecurityConfiguration_CloudWatchEncryptionProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnSecurityConfiguration_EncryptionConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cloudWatchEncryption) || (p.cloudWatchEncryption, void 0), visitedObjects.has(p.jobBookmarksEncryption) || (p.jobBookmarksEncryption, void 0), visitedObjects.has(p.s3Encryptions) || (p.s3Encryptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_glue_CfnSecurityConfiguration_JobBookmarksEncryptionProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnSecurityConfiguration_S3EncryptionProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnTableProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tableInput) || (p.tableInput, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_glue_CfnTable(p) {
    }
    function aws_cdk_lib_aws_glue_CfnTable_ColumnProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnTable_OrderProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnTable_SchemaIdProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnTable_SchemaReferenceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.schemaId) || (p.schemaId, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_glue_CfnTable_SerdeInfoProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnTable_SkewedInfoProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnTable_StorageDescriptorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columns) || (p.columns, void 0), visitedObjects.has(p.schemaReference) || (p.schemaReference, void 0), visitedObjects.has(p.serdeInfo) || (p.serdeInfo, void 0), visitedObjects.has(p.skewedInfo) || (p.skewedInfo, void 0), visitedObjects.has(p.sortColumns) || (p.sortColumns, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_glue_CfnTable_TableIdentifierProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnTable_TableInputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.partitionKeys) || (p.partitionKeys, void 0), visitedObjects.has(p.storageDescriptor) || (p.storageDescriptor, void 0), visitedObjects.has(p.targetTable) || (p.targetTable, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_glue_CfnTriggerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.eventBatchingCondition) || (p.eventBatchingCondition, void 0), visitedObjects.has(p.predicate) || (p.predicate, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_glue_CfnTrigger(p) {
    }
    function aws_cdk_lib_aws_glue_CfnTrigger_ActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.notificationProperty) || (p.notificationProperty, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_glue_CfnTrigger_ConditionProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnTrigger_EventBatchingConditionProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnTrigger_NotificationPropertyProperty(p) {
    }
    function aws_cdk_lib_aws_glue_CfnTrigger_PredicateProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.conditions) || (p.conditions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_glue_CfnWorkflowProps(p) {
    }
    function aws_cdk_lib_aws_glue_CfnWorkflow(p) {
    }
    function aws_cdk_lib_aws_grafana_CfnWorkspaceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.networkAccessControl) || (p.networkAccessControl, void 0), visitedObjects.has(p.samlConfiguration) || (p.samlConfiguration, void 0), visitedObjects.has(p.vpcConfiguration) || (p.vpcConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_grafana_CfnWorkspace(p) {
    }
    function aws_cdk_lib_aws_grafana_CfnWorkspace_AssertionAttributesProperty(p) {
    }
    function aws_cdk_lib_aws_grafana_CfnWorkspace_IdpMetadataProperty(p) {
    }
    function aws_cdk_lib_aws_grafana_CfnWorkspace_NetworkAccessControlProperty(p) {
    }
    function aws_cdk_lib_aws_grafana_CfnWorkspace_RoleValuesProperty(p) {
    }
    function aws_cdk_lib_aws_grafana_CfnWorkspace_SamlConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.idpMetadata) || (p.idpMetadata, void 0), visitedObjects.has(p.assertionAttributes) || (p.assertionAttributes, void 0), visitedObjects.has(p.roleValues) || (p.roleValues, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_grafana_CfnWorkspace_VpcConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnConnectorDefinitionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.initialVersion) || (p.initialVersion, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnConnectorDefinition(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnConnectorDefinition_ConnectorProperty(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnConnectorDefinition_ConnectorDefinitionVersionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.connectors) || (p.connectors, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnConnectorDefinitionVersionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.connectors) || (p.connectors, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnConnectorDefinitionVersion(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnConnectorDefinitionVersion_ConnectorProperty(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnCoreDefinitionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.initialVersion) || (p.initialVersion, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnCoreDefinition(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnCoreDefinition_CoreProperty(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnCoreDefinition_CoreDefinitionVersionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cores) || (p.cores, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnCoreDefinitionVersionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cores) || (p.cores, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnCoreDefinitionVersion(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnCoreDefinitionVersion_CoreProperty(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnDeviceDefinitionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.initialVersion) || (p.initialVersion, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnDeviceDefinition(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnDeviceDefinition_DeviceProperty(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnDeviceDefinition_DeviceDefinitionVersionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.devices) || (p.devices, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnDeviceDefinitionVersionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.devices) || (p.devices, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnDeviceDefinitionVersion(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnDeviceDefinitionVersion_DeviceProperty(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnFunctionDefinitionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.initialVersion) || (p.initialVersion, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnFunctionDefinition(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnFunctionDefinition_DefaultConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.execution) || (p.execution, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnFunctionDefinition_EnvironmentProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.execution) || (p.execution, void 0), visitedObjects.has(p.resourceAccessPolicies) || (p.resourceAccessPolicies, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnFunctionDefinition_ExecutionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.runAs) || (p.runAs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnFunctionDefinition_FunctionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.functionConfiguration) || (p.functionConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnFunctionDefinition_FunctionConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.environment) || (p.environment, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnFunctionDefinition_FunctionDefinitionVersionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.functions) || (p.functions, void 0), visitedObjects.has(p.defaultConfig) || (p.defaultConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnFunctionDefinition_ResourceAccessPolicyProperty(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnFunctionDefinition_RunAsProperty(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnFunctionDefinitionVersionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.functions) || (p.functions, void 0), visitedObjects.has(p.defaultConfig) || (p.defaultConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnFunctionDefinitionVersion(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnFunctionDefinitionVersion_DefaultConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.execution) || (p.execution, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnFunctionDefinitionVersion_EnvironmentProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.execution) || (p.execution, void 0), visitedObjects.has(p.resourceAccessPolicies) || (p.resourceAccessPolicies, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnFunctionDefinitionVersion_ExecutionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.runAs) || (p.runAs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnFunctionDefinitionVersion_FunctionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.functionConfiguration) || (p.functionConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnFunctionDefinitionVersion_FunctionConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.environment) || (p.environment, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnFunctionDefinitionVersion_ResourceAccessPolicyProperty(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnFunctionDefinitionVersion_RunAsProperty(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.initialVersion) || (p.initialVersion, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnGroup(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnGroup_GroupVersionProperty(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnGroupVersionProps(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnGroupVersion(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnLoggerDefinitionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.initialVersion) || (p.initialVersion, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnLoggerDefinition(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnLoggerDefinition_LoggerProperty(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnLoggerDefinition_LoggerDefinitionVersionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.loggers) || (p.loggers, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnLoggerDefinitionVersionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.loggers) || (p.loggers, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnLoggerDefinitionVersion(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnLoggerDefinitionVersion_LoggerProperty(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnResourceDefinitionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.initialVersion) || (p.initialVersion, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnResourceDefinition(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnResourceDefinition_GroupOwnerSettingProperty(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnResourceDefinition_LocalDeviceResourceDataProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.groupOwnerSetting) || (p.groupOwnerSetting, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnResourceDefinition_LocalVolumeResourceDataProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.groupOwnerSetting) || (p.groupOwnerSetting, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnResourceDefinition_ResourceDataContainerProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.localDeviceResourceData) || (p.localDeviceResourceData, void 0), visitedObjects.has(p.localVolumeResourceData) || (p.localVolumeResourceData, void 0), visitedObjects.has(p.s3MachineLearningModelResourceData) || (p.s3MachineLearningModelResourceData, void 0), visitedObjects.has(p.sageMakerMachineLearningModelResourceData) || (p.sageMakerMachineLearningModelResourceData, void 0), visitedObjects.has(p.secretsManagerSecretResourceData) || (p.secretsManagerSecretResourceData, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnResourceDefinition_ResourceDefinitionVersionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.resources) || (p.resources, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnResourceDefinition_ResourceDownloadOwnerSettingProperty(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnResourceDefinition_ResourceInstanceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.resourceDataContainer) || (p.resourceDataContainer, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnResourceDefinition_S3MachineLearningModelResourceDataProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ownerSetting) || (p.ownerSetting, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnResourceDefinition_SageMakerMachineLearningModelResourceDataProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ownerSetting) || (p.ownerSetting, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnResourceDefinition_SecretsManagerSecretResourceDataProperty(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnResourceDefinitionVersionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.resources) || (p.resources, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnResourceDefinitionVersion(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnResourceDefinitionVersion_GroupOwnerSettingProperty(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnResourceDefinitionVersion_LocalDeviceResourceDataProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.groupOwnerSetting) || (p.groupOwnerSetting, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnResourceDefinitionVersion_LocalVolumeResourceDataProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.groupOwnerSetting) || (p.groupOwnerSetting, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnResourceDefinitionVersion_ResourceDataContainerProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.localDeviceResourceData) || (p.localDeviceResourceData, void 0), visitedObjects.has(p.localVolumeResourceData) || (p.localVolumeResourceData, void 0), visitedObjects.has(p.s3MachineLearningModelResourceData) || (p.s3MachineLearningModelResourceData, void 0), visitedObjects.has(p.sageMakerMachineLearningModelResourceData) || (p.sageMakerMachineLearningModelResourceData, void 0), visitedObjects.has(p.secretsManagerSecretResourceData) || (p.secretsManagerSecretResourceData, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnResourceDefinitionVersion_ResourceDownloadOwnerSettingProperty(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnResourceDefinitionVersion_ResourceInstanceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.resourceDataContainer) || (p.resourceDataContainer, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnResourceDefinitionVersion_S3MachineLearningModelResourceDataProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ownerSetting) || (p.ownerSetting, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnResourceDefinitionVersion_SageMakerMachineLearningModelResourceDataProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ownerSetting) || (p.ownerSetting, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnResourceDefinitionVersion_SecretsManagerSecretResourceDataProperty(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnSubscriptionDefinitionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.initialVersion) || (p.initialVersion, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnSubscriptionDefinition(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnSubscriptionDefinition_SubscriptionProperty(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnSubscriptionDefinition_SubscriptionDefinitionVersionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.subscriptions) || (p.subscriptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnSubscriptionDefinitionVersionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.subscriptions) || (p.subscriptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrass_CfnSubscriptionDefinitionVersion(p) {
    }
    function aws_cdk_lib_aws_greengrass_CfnSubscriptionDefinitionVersion_SubscriptionProperty(p) {
    }
    function aws_cdk_lib_aws_greengrassv2_CfnComponentVersionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.lambdaFunction) || (p.lambdaFunction, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrassv2_CfnComponentVersion(p) {
    }
    function aws_cdk_lib_aws_greengrassv2_CfnComponentVersion_ComponentDependencyRequirementProperty(p) {
    }
    function aws_cdk_lib_aws_greengrassv2_CfnComponentVersion_ComponentPlatformProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.attributes) || (p.attributes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrassv2_CfnComponentVersion_LambdaContainerParamsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.devices) || (p.devices, void 0), visitedObjects.has(p.volumes) || (p.volumes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrassv2_CfnComponentVersion_LambdaDeviceMountProperty(p) {
    }
    function aws_cdk_lib_aws_greengrassv2_CfnComponentVersion_LambdaEventSourceProperty(p) {
    }
    function aws_cdk_lib_aws_greengrassv2_CfnComponentVersion_LambdaExecutionParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.environmentVariables) || (p.environmentVariables, void 0), visitedObjects.has(p.eventSources) || (p.eventSources, void 0), visitedObjects.has(p.linuxProcessParams) || (p.linuxProcessParams, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrassv2_CfnComponentVersion_LambdaFunctionRecipeSourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.componentDependencies) || (p.componentDependencies, void 0), visitedObjects.has(p.componentLambdaParameters) || (p.componentLambdaParameters, void 0), visitedObjects.has(p.componentPlatforms) || (p.componentPlatforms, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrassv2_CfnComponentVersion_LambdaLinuxProcessParamsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.containerParams) || (p.containerParams, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrassv2_CfnComponentVersion_LambdaVolumeMountProperty(p) {
    }
    function aws_cdk_lib_aws_greengrassv2_CfnDeploymentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.components) || (p.components, void 0), visitedObjects.has(p.deploymentPolicies) || (p.deploymentPolicies, void 0), visitedObjects.has(p.iotJobConfiguration) || (p.iotJobConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrassv2_CfnDeployment(p) {
    }
    function aws_cdk_lib_aws_greengrassv2_CfnDeployment_ComponentConfigurationUpdateProperty(p) {
    }
    function aws_cdk_lib_aws_greengrassv2_CfnDeployment_ComponentDeploymentSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.configurationUpdate) || (p.configurationUpdate, void 0), visitedObjects.has(p.runWith) || (p.runWith, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrassv2_CfnDeployment_ComponentRunWithProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.systemResourceLimits) || (p.systemResourceLimits, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrassv2_CfnDeployment_DeploymentComponentUpdatePolicyProperty(p) {
    }
    function aws_cdk_lib_aws_greengrassv2_CfnDeployment_DeploymentConfigurationValidationPolicyProperty(p) {
    }
    function aws_cdk_lib_aws_greengrassv2_CfnDeployment_DeploymentIoTJobConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.abortConfig) || (p.abortConfig, void 0), visitedObjects.has(p.jobExecutionsRolloutConfig) || (p.jobExecutionsRolloutConfig, void 0), visitedObjects.has(p.timeoutConfig) || (p.timeoutConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrassv2_CfnDeployment_DeploymentPoliciesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.componentUpdatePolicy) || (p.componentUpdatePolicy, void 0), visitedObjects.has(p.configurationValidationPolicy) || (p.configurationValidationPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrassv2_CfnDeployment_IoTJobAbortConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.criteriaList) || (p.criteriaList, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrassv2_CfnDeployment_IoTJobAbortCriteriaProperty(p) {
    }
    function aws_cdk_lib_aws_greengrassv2_CfnDeployment_IoTJobExecutionsRolloutConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.exponentialRate) || (p.exponentialRate, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_greengrassv2_CfnDeployment_IoTJobExponentialRolloutRateProperty(p) {
    }
    function aws_cdk_lib_aws_greengrassv2_CfnDeployment_IoTJobTimeoutConfigProperty(p) {
    }
    function aws_cdk_lib_aws_greengrassv2_CfnDeployment_SystemResourceLimitsProperty(p) {
    }
    function aws_cdk_lib_aws_groundstation_CfnConfigProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.configData) || (p.configData, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_groundstation_CfnConfig(p) {
    }
    function aws_cdk_lib_aws_groundstation_CfnConfig_AntennaDownlinkConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.spectrumConfig) || (p.spectrumConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_groundstation_CfnConfig_AntennaDownlinkDemodDecodeConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.decodeConfig) || (p.decodeConfig, void 0), visitedObjects.has(p.demodulationConfig) || (p.demodulationConfig, void 0), visitedObjects.has(p.spectrumConfig) || (p.spectrumConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_groundstation_CfnConfig_AntennaUplinkConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.spectrumConfig) || (p.spectrumConfig, void 0), visitedObjects.has(p.targetEirp) || (p.targetEirp, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_groundstation_CfnConfig_ConfigDataProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.antennaDownlinkConfig) || (p.antennaDownlinkConfig, void 0), visitedObjects.has(p.antennaDownlinkDemodDecodeConfig) || (p.antennaDownlinkDemodDecodeConfig, void 0), visitedObjects.has(p.antennaUplinkConfig) || (p.antennaUplinkConfig, void 0), visitedObjects.has(p.dataflowEndpointConfig) || (p.dataflowEndpointConfig, void 0), visitedObjects.has(p.s3RecordingConfig) || (p.s3RecordingConfig, void 0), visitedObjects.has(p.trackingConfig) || (p.trackingConfig, void 0), visitedObjects.has(p.uplinkEchoConfig) || (p.uplinkEchoConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_groundstation_CfnConfig_DataflowEndpointConfigProperty(p) {
    }
    function aws_cdk_lib_aws_groundstation_CfnConfig_DecodeConfigProperty(p) {
    }
    function aws_cdk_lib_aws_groundstation_CfnConfig_DemodulationConfigProperty(p) {
    }
    function aws_cdk_lib_aws_groundstation_CfnConfig_EirpProperty(p) {
    }
    function aws_cdk_lib_aws_groundstation_CfnConfig_FrequencyProperty(p) {
    }
    function aws_cdk_lib_aws_groundstation_CfnConfig_FrequencyBandwidthProperty(p) {
    }
    function aws_cdk_lib_aws_groundstation_CfnConfig_S3RecordingConfigProperty(p) {
    }
    function aws_cdk_lib_aws_groundstation_CfnConfig_SpectrumConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bandwidth) || (p.bandwidth, void 0), visitedObjects.has(p.centerFrequency) || (p.centerFrequency, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_groundstation_CfnConfig_TrackingConfigProperty(p) {
    }
    function aws_cdk_lib_aws_groundstation_CfnConfig_UplinkEchoConfigProperty(p) {
    }
    function aws_cdk_lib_aws_groundstation_CfnConfig_UplinkSpectrumConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.centerFrequency) || (p.centerFrequency, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_groundstation_CfnDataflowEndpointGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.endpointDetails) || (p.endpointDetails, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_groundstation_CfnDataflowEndpointGroup(p) {
    }
    function aws_cdk_lib_aws_groundstation_CfnDataflowEndpointGroup_AwsGroundStationAgentEndpointProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.egressAddress) || (p.egressAddress, void 0), visitedObjects.has(p.ingressAddress) || (p.ingressAddress, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_groundstation_CfnDataflowEndpointGroup_ConnectionDetailsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.socketAddress) || (p.socketAddress, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_groundstation_CfnDataflowEndpointGroup_DataflowEndpointProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.address) || (p.address, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_groundstation_CfnDataflowEndpointGroup_EndpointDetailsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.awsGroundStationAgentEndpoint) || (p.awsGroundStationAgentEndpoint, void 0), visitedObjects.has(p.endpoint) || (p.endpoint, void 0), visitedObjects.has(p.securityDetails) || (p.securityDetails, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_groundstation_CfnDataflowEndpointGroup_IntegerRangeProperty(p) {
    }
    function aws_cdk_lib_aws_groundstation_CfnDataflowEndpointGroup_RangedConnectionDetailsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.socketAddress) || (p.socketAddress, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_groundstation_CfnDataflowEndpointGroup_RangedSocketAddressProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.portRange) || (p.portRange, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_groundstation_CfnDataflowEndpointGroup_SecurityDetailsProperty(p) {
    }
    function aws_cdk_lib_aws_groundstation_CfnDataflowEndpointGroup_SocketAddressProperty(p) {
    }
    function aws_cdk_lib_aws_groundstation_CfnMissionProfileProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.dataflowEdges) || (p.dataflowEdges, void 0), visitedObjects.has(p.streamsKmsKey) || (p.streamsKmsKey, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_groundstation_CfnMissionProfile(p) {
    }
    function aws_cdk_lib_aws_groundstation_CfnMissionProfile_DataflowEdgeProperty(p) {
    }
    function aws_cdk_lib_aws_groundstation_CfnMissionProfile_StreamsKmsKeyProperty(p) {
    }
    function aws_cdk_lib_aws_guardduty_CfnDetectorProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.dataSources) || (p.dataSources, void 0), visitedObjects.has(p.features) || (p.features, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_guardduty_CfnDetector(p) {
    }
    function aws_cdk_lib_aws_guardduty_CfnDetector_CFNDataSourceConfigurationsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.kubernetes) || (p.kubernetes, void 0), visitedObjects.has(p.malwareProtection) || (p.malwareProtection, void 0), visitedObjects.has(p.s3Logs) || (p.s3Logs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_guardduty_CfnDetector_CFNKubernetesAuditLogsConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_guardduty_CfnDetector_CFNKubernetesConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.auditLogs) || (p.auditLogs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_guardduty_CfnDetector_CFNMalwareProtectionConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.scanEc2InstanceWithFindings) || (p.scanEc2InstanceWithFindings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_guardduty_CfnDetector_CFNS3LogsConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_guardduty_CfnDetector_CFNScanEc2InstanceWithFindingsConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_guardduty_CfnDetector_FeatureAdditionalConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_guardduty_CfnDetector_FeatureConfigurationsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.additionalConfiguration) || (p.additionalConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_guardduty_CfnFilterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.findingCriteria) || (p.findingCriteria, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_guardduty_CfnFilter(p) {
    }
    function aws_cdk_lib_aws_guardduty_CfnFilter_ConditionProperty(p) {
    }
    function aws_cdk_lib_aws_guardduty_CfnFilter_FindingCriteriaProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.itemType) || (p.itemType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_guardduty_CfnIPSetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_guardduty_CfnIPSet(p) {
    }
    function aws_cdk_lib_aws_guardduty_CfnMasterProps(p) {
    }
    function aws_cdk_lib_aws_guardduty_CfnMaster(p) {
    }
    function aws_cdk_lib_aws_guardduty_CfnMemberProps(p) {
    }
    function aws_cdk_lib_aws_guardduty_CfnMember(p) {
    }
    function aws_cdk_lib_aws_guardduty_CfnThreatIntelSetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_guardduty_CfnThreatIntelSet(p) {
    }
    function aws_cdk_lib_aws_healthlake_CfnFHIRDatastoreProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.preloadDataConfig) || (p.preloadDataConfig, void 0), visitedObjects.has(p.sseConfiguration) || (p.sseConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_healthlake_CfnFHIRDatastore(p) {
    }
    function aws_cdk_lib_aws_healthlake_CfnFHIRDatastore_CreatedAtProperty(p) {
    }
    function aws_cdk_lib_aws_healthlake_CfnFHIRDatastore_KmsEncryptionConfigProperty(p) {
    }
    function aws_cdk_lib_aws_healthlake_CfnFHIRDatastore_PreloadDataConfigProperty(p) {
    }
    function aws_cdk_lib_aws_healthlake_CfnFHIRDatastore_SseConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.kmsEncryptionConfig) || (p.kmsEncryptionConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iam_PolicyDocumentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.statements != null)
            for (const o of p.statements)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iam_PolicyDocument(p) {
    }
    function aws_cdk_lib_aws_iam_PolicyStatement(p) {
    }
    function aws_cdk_lib_aws_iam_Effect(p) {
    }
    function aws_cdk_lib_aws_iam_PolicyStatementProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.effect) || (p.effect, void 0), p.notPrincipals != null)
            for (const o of p.notPrincipals)
              visitedObjects.has(o) || void 0;
          if (p.principals != null)
            for (const o of p.principals)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iam_IManagedPolicy(p) {
    }
    function aws_cdk_lib_aws_iam_ManagedPolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.document) || (p.document, void 0), p.groups != null)
            for (const o of p.groups)
              visitedObjects.has(o) || void 0;
          if (p.roles != null)
            for (const o of p.roles)
              visitedObjects.has(o) || void 0;
          if (p.statements != null)
            for (const o of p.statements)
              visitedObjects.has(o) || void 0;
          if (p.users != null)
            for (const o of p.users)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iam_ManagedPolicy(p) {
    }
    function aws_cdk_lib_aws_iam_RoleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.assumedBy) || (p.assumedBy, void 0), p.inlinePolicies != null)
            for (const o of Object.values(p.inlinePolicies))
              visitedObjects.has(o) || void 0;
          if (p.managedPolicies != null)
            for (const o of p.managedPolicies)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.maxSessionDuration) || (p.maxSessionDuration, void 0), visitedObjects.has(p.permissionsBoundary) || (p.permissionsBoundary, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iam_FromRoleArnOptions(p) {
    }
    function aws_cdk_lib_aws_iam_CustomizeRolesOptions(p) {
    }
    function aws_cdk_lib_aws_iam_FromRoleNameOptions(p) {
    }
    function aws_cdk_lib_aws_iam_Role(p) {
    }
    function aws_cdk_lib_aws_iam_IRole(p) {
    }
    function aws_cdk_lib_aws_iam_WithoutPolicyUpdatesOptions(p) {
    }
    function aws_cdk_lib_aws_iam_IPolicy(p) {
    }
    function aws_cdk_lib_aws_iam_PolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.document) || (p.document, void 0), p.groups != null)
            for (const o of p.groups)
              visitedObjects.has(o) || void 0;
          if (p.roles != null)
            for (const o of p.roles)
              visitedObjects.has(o) || void 0;
          if (p.statements != null)
            for (const o of p.statements)
              visitedObjects.has(o) || void 0;
          if (p.users != null)
            for (const o of p.users)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iam_Policy(p) {
    }
    function aws_cdk_lib_aws_iam_IUser(p) {
    }
    function aws_cdk_lib_aws_iam_UserProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.groups != null)
            for (const o of p.groups)
              visitedObjects.has(o) || void 0;
          if (p.managedPolicies != null)
            for (const o of p.managedPolicies)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.password) || (p.password, void 0), visitedObjects.has(p.permissionsBoundary) || (p.permissionsBoundary, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iam_UserAttributes(p) {
    }
    function aws_cdk_lib_aws_iam_User(p) {
    }
    function aws_cdk_lib_aws_iam_IGroup(p) {
    }
    function aws_cdk_lib_aws_iam_GroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.managedPolicies != null)
            for (const o of p.managedPolicies)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iam_Group(p) {
    }
    function aws_cdk_lib_aws_iam_LazyRoleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.assumedBy) || (p.assumedBy, void 0), p.inlinePolicies != null)
            for (const o of Object.values(p.inlinePolicies))
              visitedObjects.has(o) || void 0;
          if (p.managedPolicies != null)
            for (const o of p.managedPolicies)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.maxSessionDuration) || (p.maxSessionDuration, void 0), visitedObjects.has(p.permissionsBoundary) || (p.permissionsBoundary, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iam_LazyRole(p) {
    }
    function aws_cdk_lib_aws_iam_IGrantable(p) {
    }
    function aws_cdk_lib_aws_iam_IPrincipal(p) {
    }
    function aws_cdk_lib_aws_iam_IComparablePrincipal(p) {
    }
    function aws_cdk_lib_aws_iam_ComparablePrincipal(p) {
    }
    function aws_cdk_lib_aws_iam_IAssumeRolePrincipal(p) {
    }
    function aws_cdk_lib_aws_iam_AddToPrincipalPolicyResult(p) {
    }
    function aws_cdk_lib_aws_iam_PrincipalBase(p) {
    }
    function aws_cdk_lib_aws_iam_PrincipalWithConditions(p) {
    }
    function aws_cdk_lib_aws_iam_SessionTagsPrincipal(p) {
    }
    function aws_cdk_lib_aws_iam_PrincipalPolicyFragment(p) {
    }
    function aws_cdk_lib_aws_iam_ArnPrincipal(p) {
    }
    function aws_cdk_lib_aws_iam_AccountPrincipal(p) {
    }
    function aws_cdk_lib_aws_iam_ServicePrincipalOpts(p) {
    }
    function aws_cdk_lib_aws_iam_ServicePrincipal(p) {
    }
    function aws_cdk_lib_aws_iam_OrganizationPrincipal(p) {
    }
    function aws_cdk_lib_aws_iam_CanonicalUserPrincipal(p) {
    }
    function aws_cdk_lib_aws_iam_FederatedPrincipal(p) {
    }
    function aws_cdk_lib_aws_iam_WebIdentityPrincipal(p) {
    }
    function aws_cdk_lib_aws_iam_OpenIdConnectPrincipal(p) {
    }
    function aws_cdk_lib_aws_iam_SamlPrincipal(p) {
    }
    function aws_cdk_lib_aws_iam_SamlConsolePrincipal(p) {
    }
    function aws_cdk_lib_aws_iam_AccountRootPrincipal(p) {
    }
    function aws_cdk_lib_aws_iam_AnyPrincipal(p) {
    }
    function aws_cdk_lib_aws_iam_StarPrincipal(p) {
    }
    function aws_cdk_lib_aws_iam_CompositePrincipal(p) {
    }
    function aws_cdk_lib_aws_iam_IIdentity(p) {
    }
    function aws_cdk_lib_aws_iam_CommonGrantOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.grantee) || (p.grantee, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iam_GrantWithResourceOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.resource) || (p.resource, void 0), visitedObjects.has(p.grantee) || (p.grantee, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iam_GrantOnPrincipalOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.grantee) || (p.grantee, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iam_GrantOnPrincipalAndResourceOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.resource) || (p.resource, void 0), visitedObjects.has(p.resourcePolicyPrincipal) || (p.resourcePolicyPrincipal, void 0), visitedObjects.has(p.grantee) || (p.grantee, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iam_Grant(p) {
    }
    function aws_cdk_lib_aws_iam_IResourceWithPolicy(p) {
    }
    function aws_cdk_lib_aws_iam_AddToResourcePolicyResult(p) {
    }
    function aws_cdk_lib_aws_iam_CompositeDependable(p) {
    }
    function aws_cdk_lib_aws_iam_UnknownPrincipalProps(p) {
    }
    function aws_cdk_lib_aws_iam_UnknownPrincipal(p) {
    }
    function aws_cdk_lib_aws_iam_IOpenIdConnectProvider(p) {
    }
    function aws_cdk_lib_aws_iam_OpenIdConnectProviderProps(p) {
    }
    function aws_cdk_lib_aws_iam_OpenIdConnectProvider(p) {
    }
    function aws_cdk_lib_aws_iam_PermissionsBoundary(p) {
    }
    function aws_cdk_lib_aws_iam_ISamlProvider(p) {
    }
    function aws_cdk_lib_aws_iam_SamlProviderProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.metadataDocument) || (p.metadataDocument, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iam_SamlMetadataDocument(p) {
    }
    function aws_cdk_lib_aws_iam_SamlProvider(p) {
    }
    function aws_cdk_lib_aws_iam_AccessKeyStatus(p) {
    }
    function aws_cdk_lib_aws_iam_IAccessKey(p) {
    }
    function aws_cdk_lib_aws_iam_AccessKeyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.user) || (p.user, void 0), visitedObjects.has(p.status) || (p.status, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iam_AccessKey(p) {
    }
    function aws_cdk_lib_aws_iam_CfnAccessKeyProps(p) {
    }
    function aws_cdk_lib_aws_iam_CfnAccessKey(p) {
    }
    function aws_cdk_lib_aws_iam_CfnGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.policies) || (p.policies, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iam_CfnGroup(p) {
    }
    function aws_cdk_lib_aws_iam_CfnGroup_PolicyProperty(p) {
    }
    function aws_cdk_lib_aws_iam_CfnInstanceProfileProps(p) {
    }
    function aws_cdk_lib_aws_iam_CfnInstanceProfile(p) {
    }
    function aws_cdk_lib_aws_iam_CfnManagedPolicyProps(p) {
    }
    function aws_cdk_lib_aws_iam_CfnManagedPolicy(p) {
    }
    function aws_cdk_lib_aws_iam_CfnOIDCProviderProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iam_CfnOIDCProvider(p) {
    }
    function aws_cdk_lib_aws_iam_CfnPolicyProps(p) {
    }
    function aws_cdk_lib_aws_iam_CfnPolicy(p) {
    }
    function aws_cdk_lib_aws_iam_CfnRoleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.policies) || (p.policies, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iam_CfnRole(p) {
    }
    function aws_cdk_lib_aws_iam_CfnRole_PolicyProperty(p) {
    }
    function aws_cdk_lib_aws_iam_CfnSAMLProviderProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iam_CfnSAMLProvider(p) {
    }
    function aws_cdk_lib_aws_iam_CfnServerCertificateProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iam_CfnServerCertificate(p) {
    }
    function aws_cdk_lib_aws_iam_CfnServiceLinkedRoleProps(p) {
    }
    function aws_cdk_lib_aws_iam_CfnServiceLinkedRole(p) {
    }
    function aws_cdk_lib_aws_iam_CfnUserProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.loginProfile) || (p.loginProfile, void 0), visitedObjects.has(p.policies) || (p.policies, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iam_CfnUser(p) {
    }
    function aws_cdk_lib_aws_iam_CfnUser_LoginProfileProperty(p) {
    }
    function aws_cdk_lib_aws_iam_CfnUser_PolicyProperty(p) {
    }
    function aws_cdk_lib_aws_iam_CfnUserToGroupAdditionProps(p) {
    }
    function aws_cdk_lib_aws_iam_CfnUserToGroupAddition(p) {
    }
    function aws_cdk_lib_aws_iam_CfnVirtualMFADeviceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iam_CfnVirtualMFADevice(p) {
    }
    function aws_cdk_lib_aws_identitystore_CfnGroupProps(p) {
    }
    function aws_cdk_lib_aws_identitystore_CfnGroup(p) {
    }
    function aws_cdk_lib_aws_identitystore_CfnGroupMembershipProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.memberId) || (p.memberId, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_identitystore_CfnGroupMembership(p) {
    }
    function aws_cdk_lib_aws_identitystore_CfnGroupMembership_MemberIdProperty(p) {
    }
    function aws_cdk_lib_aws_imagebuilder_CfnComponentProps(p) {
    }
    function aws_cdk_lib_aws_imagebuilder_CfnComponent(p) {
    }
    function aws_cdk_lib_aws_imagebuilder_CfnContainerRecipeProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.components) || (p.components, void 0), visitedObjects.has(p.targetRepository) || (p.targetRepository, void 0), visitedObjects.has(p.instanceConfiguration) || (p.instanceConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_imagebuilder_CfnContainerRecipe(p) {
    }
    function aws_cdk_lib_aws_imagebuilder_CfnContainerRecipe_ComponentConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.parameters) || (p.parameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_imagebuilder_CfnContainerRecipe_ComponentParameterProperty(p) {
    }
    function aws_cdk_lib_aws_imagebuilder_CfnContainerRecipe_EbsInstanceBlockDeviceSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_imagebuilder_CfnContainerRecipe_InstanceBlockDeviceMappingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ebs) || (p.ebs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_imagebuilder_CfnContainerRecipe_InstanceConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.blockDeviceMappings) || (p.blockDeviceMappings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_imagebuilder_CfnContainerRecipe_TargetContainerRepositoryProperty(p) {
    }
    function aws_cdk_lib_aws_imagebuilder_CfnDistributionConfigurationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.distributions) || (p.distributions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_imagebuilder_CfnDistributionConfiguration(p) {
    }
    function aws_cdk_lib_aws_imagebuilder_CfnDistributionConfiguration_AmiDistributionConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.amiTags) || (p.amiTags, void 0), visitedObjects.has(p.launchPermissionConfiguration) || (p.launchPermissionConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_imagebuilder_CfnDistributionConfiguration_ContainerDistributionConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.targetRepository) || (p.targetRepository, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_imagebuilder_CfnDistributionConfiguration_DistributionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fastLaunchConfigurations) || (p.fastLaunchConfigurations, void 0), visitedObjects.has(p.launchTemplateConfigurations) || (p.launchTemplateConfigurations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_imagebuilder_CfnDistributionConfiguration_FastLaunchConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.launchTemplate) || (p.launchTemplate, void 0), visitedObjects.has(p.snapshotConfiguration) || (p.snapshotConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_imagebuilder_CfnDistributionConfiguration_FastLaunchLaunchTemplateSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_imagebuilder_CfnDistributionConfiguration_FastLaunchSnapshotConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_imagebuilder_CfnDistributionConfiguration_LaunchPermissionConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_imagebuilder_CfnDistributionConfiguration_LaunchTemplateConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_imagebuilder_CfnDistributionConfiguration_TargetContainerRepositoryProperty(p) {
    }
    function aws_cdk_lib_aws_imagebuilder_CfnImageProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.imageScanningConfiguration) || (p.imageScanningConfiguration, void 0), visitedObjects.has(p.imageTestsConfiguration) || (p.imageTestsConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_imagebuilder_CfnImage(p) {
    }
    function aws_cdk_lib_aws_imagebuilder_CfnImage_EcrConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_imagebuilder_CfnImage_ImageScanningConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ecrConfiguration) || (p.ecrConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_imagebuilder_CfnImage_ImageTestsConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_imagebuilder_CfnImagePipelineProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.imageScanningConfiguration) || (p.imageScanningConfiguration, void 0), visitedObjects.has(p.imageTestsConfiguration) || (p.imageTestsConfiguration, void 0), visitedObjects.has(p.schedule) || (p.schedule, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_imagebuilder_CfnImagePipeline(p) {
    }
    function aws_cdk_lib_aws_imagebuilder_CfnImagePipeline_EcrConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_imagebuilder_CfnImagePipeline_ImageScanningConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ecrConfiguration) || (p.ecrConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_imagebuilder_CfnImagePipeline_ImageTestsConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_imagebuilder_CfnImagePipeline_ScheduleProperty(p) {
    }
    function aws_cdk_lib_aws_imagebuilder_CfnImageRecipeProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.components) || (p.components, void 0), visitedObjects.has(p.additionalInstanceConfiguration) || (p.additionalInstanceConfiguration, void 0), visitedObjects.has(p.blockDeviceMappings) || (p.blockDeviceMappings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_imagebuilder_CfnImageRecipe(p) {
    }
    function aws_cdk_lib_aws_imagebuilder_CfnImageRecipe_AdditionalInstanceConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.systemsManagerAgent) || (p.systemsManagerAgent, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_imagebuilder_CfnImageRecipe_ComponentConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.parameters) || (p.parameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_imagebuilder_CfnImageRecipe_ComponentParameterProperty(p) {
    }
    function aws_cdk_lib_aws_imagebuilder_CfnImageRecipe_EbsInstanceBlockDeviceSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_imagebuilder_CfnImageRecipe_InstanceBlockDeviceMappingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ebs) || (p.ebs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_imagebuilder_CfnImageRecipe_SystemsManagerAgentProperty(p) {
    }
    function aws_cdk_lib_aws_imagebuilder_CfnInfrastructureConfigurationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.instanceMetadataOptions) || (p.instanceMetadataOptions, void 0), visitedObjects.has(p.logging) || (p.logging, void 0), visitedObjects.has(p.resourceTags) || (p.resourceTags, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_imagebuilder_CfnInfrastructureConfiguration(p) {
    }
    function aws_cdk_lib_aws_imagebuilder_CfnInfrastructureConfiguration_InstanceMetadataOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_imagebuilder_CfnInfrastructureConfiguration_LoggingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3Logs) || (p.s3Logs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_imagebuilder_CfnInfrastructureConfiguration_S3LogsProperty(p) {
    }
    function aws_cdk_lib_aws_inspector_CfnAssessmentTargetProps(p) {
    }
    function aws_cdk_lib_aws_inspector_CfnAssessmentTarget(p) {
    }
    function aws_cdk_lib_aws_inspector_CfnAssessmentTemplateProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.userAttributesForFindings) || (p.userAttributesForFindings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_inspector_CfnAssessmentTemplate(p) {
    }
    function aws_cdk_lib_aws_inspector_CfnResourceGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.resourceGroupTags) || (p.resourceGroupTags, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_inspector_CfnResourceGroup(p) {
    }
    function aws_cdk_lib_aws_inspectorv2_CfnFilterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.filterCriteria) || (p.filterCriteria, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_inspectorv2_CfnFilter(p) {
    }
    function aws_cdk_lib_aws_inspectorv2_CfnFilter_DateFilterProperty(p) {
    }
    function aws_cdk_lib_aws_inspectorv2_CfnFilter_FilterCriteriaProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.awsAccountId) || (p.awsAccountId, void 0), visitedObjects.has(p.componentId) || (p.componentId, void 0), visitedObjects.has(p.componentType) || (p.componentType, void 0), visitedObjects.has(p.ec2InstanceImageId) || (p.ec2InstanceImageId, void 0), visitedObjects.has(p.ec2InstanceSubnetId) || (p.ec2InstanceSubnetId, void 0), visitedObjects.has(p.ec2InstanceVpcId) || (p.ec2InstanceVpcId, void 0), visitedObjects.has(p.ecrImageArchitecture) || (p.ecrImageArchitecture, void 0), visitedObjects.has(p.ecrImageHash) || (p.ecrImageHash, void 0), visitedObjects.has(p.ecrImagePushedAt) || (p.ecrImagePushedAt, void 0), visitedObjects.has(p.ecrImageRegistry) || (p.ecrImageRegistry, void 0), visitedObjects.has(p.ecrImageRepositoryName) || (p.ecrImageRepositoryName, void 0), visitedObjects.has(p.ecrImageTags) || (p.ecrImageTags, void 0), visitedObjects.has(p.findingArn) || (p.findingArn, void 0), visitedObjects.has(p.findingStatus) || (p.findingStatus, void 0), visitedObjects.has(p.findingType) || (p.findingType, void 0), visitedObjects.has(p.firstObservedAt) || (p.firstObservedAt, void 0), visitedObjects.has(p.inspectorScore) || (p.inspectorScore, void 0), visitedObjects.has(p.lastObservedAt) || (p.lastObservedAt, void 0), visitedObjects.has(p.networkProtocol) || (p.networkProtocol, void 0), visitedObjects.has(p.portRange) || (p.portRange, void 0), visitedObjects.has(p.relatedVulnerabilities) || (p.relatedVulnerabilities, void 0), visitedObjects.has(p.resourceId) || (p.resourceId, void 0), visitedObjects.has(p.resourceTags) || (p.resourceTags, void 0), visitedObjects.has(p.resourceType) || (p.resourceType, void 0), visitedObjects.has(p.severity) || (p.severity, void 0), visitedObjects.has(p.title) || (p.title, void 0), visitedObjects.has(p.updatedAt) || (p.updatedAt, void 0), visitedObjects.has(p.vendorSeverity) || (p.vendorSeverity, void 0), visitedObjects.has(p.vulnerabilityId) || (p.vulnerabilityId, void 0), visitedObjects.has(p.vulnerabilitySource) || (p.vulnerabilitySource, void 0), visitedObjects.has(p.vulnerablePackages) || (p.vulnerablePackages, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_inspectorv2_CfnFilter_MapFilterProperty(p) {
    }
    function aws_cdk_lib_aws_inspectorv2_CfnFilter_NumberFilterProperty(p) {
    }
    function aws_cdk_lib_aws_inspectorv2_CfnFilter_PackageFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.architecture) || (p.architecture, void 0), visitedObjects.has(p.epoch) || (p.epoch, void 0), visitedObjects.has(p.name) || (p.name, void 0), visitedObjects.has(p.release) || (p.release, void 0), visitedObjects.has(p.sourceLayerHash) || (p.sourceLayerHash, void 0), visitedObjects.has(p.version) || (p.version, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_inspectorv2_CfnFilter_PortRangeFilterProperty(p) {
    }
    function aws_cdk_lib_aws_inspectorv2_CfnFilter_StringFilterProperty(p) {
    }
    function aws_cdk_lib_aws_internetmonitor_CfnMonitorProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.internetMeasurementsLogDelivery) || (p.internetMeasurementsLogDelivery, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_internetmonitor_CfnMonitor(p) {
    }
    function aws_cdk_lib_aws_internetmonitor_CfnMonitor_InternetMeasurementsLogDeliveryProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3Config) || (p.s3Config, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_internetmonitor_CfnMonitor_S3ConfigProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnAccountAuditConfigurationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.auditCheckConfigurations) || (p.auditCheckConfigurations, void 0), visitedObjects.has(p.auditNotificationTargetConfigurations) || (p.auditNotificationTargetConfigurations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnAccountAuditConfiguration(p) {
    }
    function aws_cdk_lib_aws_iot_CfnAccountAuditConfiguration_AuditCheckConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnAccountAuditConfiguration_AuditCheckConfigurationsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.authenticatedCognitoRoleOverlyPermissiveCheck) || (p.authenticatedCognitoRoleOverlyPermissiveCheck, void 0), visitedObjects.has(p.caCertificateExpiringCheck) || (p.caCertificateExpiringCheck, void 0), visitedObjects.has(p.caCertificateKeyQualityCheck) || (p.caCertificateKeyQualityCheck, void 0), visitedObjects.has(p.conflictingClientIdsCheck) || (p.conflictingClientIdsCheck, void 0), visitedObjects.has(p.deviceCertificateExpiringCheck) || (p.deviceCertificateExpiringCheck, void 0), visitedObjects.has(p.deviceCertificateKeyQualityCheck) || (p.deviceCertificateKeyQualityCheck, void 0), visitedObjects.has(p.deviceCertificateSharedCheck) || (p.deviceCertificateSharedCheck, void 0), visitedObjects.has(p.intermediateCaRevokedForActiveDeviceCertificatesCheck) || (p.intermediateCaRevokedForActiveDeviceCertificatesCheck, void 0), visitedObjects.has(p.iotPolicyOverlyPermissiveCheck) || (p.iotPolicyOverlyPermissiveCheck, void 0), visitedObjects.has(p.ioTPolicyPotentialMisConfigurationCheck) || (p.ioTPolicyPotentialMisConfigurationCheck, void 0), visitedObjects.has(p.iotRoleAliasAllowsAccessToUnusedServicesCheck) || (p.iotRoleAliasAllowsAccessToUnusedServicesCheck, void 0), visitedObjects.has(p.iotRoleAliasOverlyPermissiveCheck) || (p.iotRoleAliasOverlyPermissiveCheck, void 0), visitedObjects.has(p.loggingDisabledCheck) || (p.loggingDisabledCheck, void 0), visitedObjects.has(p.revokedCaCertificateStillActiveCheck) || (p.revokedCaCertificateStillActiveCheck, void 0), visitedObjects.has(p.revokedDeviceCertificateStillActiveCheck) || (p.revokedDeviceCertificateStillActiveCheck, void 0), visitedObjects.has(p.unauthenticatedCognitoRoleOverlyPermissiveCheck) || (p.unauthenticatedCognitoRoleOverlyPermissiveCheck, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnAccountAuditConfiguration_AuditNotificationTargetProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnAccountAuditConfiguration_AuditNotificationTargetConfigurationsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sns) || (p.sns, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnAuthorizerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.tokenSigningPublicKeys) || (p.tokenSigningPublicKeys, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnAuthorizer(p) {
    }
    function aws_cdk_lib_aws_iot_CfnBillingGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.billingGroupProperties) || (p.billingGroupProperties, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnBillingGroup(p) {
    }
    function aws_cdk_lib_aws_iot_CfnBillingGroup_BillingGroupPropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnCACertificateProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.registrationConfig) || (p.registrationConfig, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnCACertificate(p) {
    }
    function aws_cdk_lib_aws_iot_CfnCACertificate_RegistrationConfigProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnCertificateProps(p) {
    }
    function aws_cdk_lib_aws_iot_CfnCertificate(p) {
    }
    function aws_cdk_lib_aws_iot_CfnCustomMetricProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnCustomMetric(p) {
    }
    function aws_cdk_lib_aws_iot_CfnDimensionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnDimension(p) {
    }
    function aws_cdk_lib_aws_iot_CfnDomainConfigurationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.authorizerConfig) || (p.authorizerConfig, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.tlsConfig) || (p.tlsConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnDomainConfiguration(p) {
    }
    function aws_cdk_lib_aws_iot_CfnDomainConfiguration_AuthorizerConfigProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnDomainConfiguration_ServerCertificateSummaryProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnDomainConfiguration_TlsConfigProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnFleetMetricProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.aggregationType) || (p.aggregationType, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnFleetMetric(p) {
    }
    function aws_cdk_lib_aws_iot_CfnFleetMetric_AggregationTypeProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnJobTemplateProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.jobExecutionsRetryConfig) || (p.jobExecutionsRetryConfig, void 0), visitedObjects.has(p.maintenanceWindows) || (p.maintenanceWindows, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnJobTemplate(p) {
    }
    function aws_cdk_lib_aws_iot_CfnJobTemplate_AbortConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.criteriaList) || (p.criteriaList, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnJobTemplate_AbortCriteriaProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnJobTemplate_ExponentialRolloutRateProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.rateIncreaseCriteria) || (p.rateIncreaseCriteria, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnJobTemplate_JobExecutionsRetryConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.retryCriteriaList) || (p.retryCriteriaList, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnJobTemplate_JobExecutionsRolloutConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.exponentialRolloutRate) || (p.exponentialRolloutRate, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnJobTemplate_MaintenanceWindowProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnJobTemplate_PresignedUrlConfigProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnJobTemplate_RateIncreaseCriteriaProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnJobTemplate_RetryCriteriaProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnJobTemplate_TimeoutConfigProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnLoggingProps(p) {
    }
    function aws_cdk_lib_aws_iot_CfnLogging(p) {
    }
    function aws_cdk_lib_aws_iot_CfnMitigationActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.actionParams) || (p.actionParams, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnMitigationAction(p) {
    }
    function aws_cdk_lib_aws_iot_CfnMitigationAction_ActionParamsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.addThingsToThingGroupParams) || (p.addThingsToThingGroupParams, void 0), visitedObjects.has(p.enableIoTLoggingParams) || (p.enableIoTLoggingParams, void 0), visitedObjects.has(p.publishFindingToSnsParams) || (p.publishFindingToSnsParams, void 0), visitedObjects.has(p.replaceDefaultPolicyVersionParams) || (p.replaceDefaultPolicyVersionParams, void 0), visitedObjects.has(p.updateCaCertificateParams) || (p.updateCaCertificateParams, void 0), visitedObjects.has(p.updateDeviceCertificateParams) || (p.updateDeviceCertificateParams, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnMitigationAction_AddThingsToThingGroupParamsProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnMitigationAction_EnableIoTLoggingParamsProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnMitigationAction_PublishFindingToSnsParamsProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnMitigationAction_ReplaceDefaultPolicyVersionParamsProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnMitigationAction_UpdateCACertificateParamsProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnMitigationAction_UpdateDeviceCertificateParamsProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnPolicyProps(p) {
    }
    function aws_cdk_lib_aws_iot_CfnPolicy(p) {
    }
    function aws_cdk_lib_aws_iot_CfnPolicyPrincipalAttachmentProps(p) {
    }
    function aws_cdk_lib_aws_iot_CfnPolicyPrincipalAttachment(p) {
    }
    function aws_cdk_lib_aws_iot_CfnProvisioningTemplateProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.preProvisioningHook) || (p.preProvisioningHook, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnProvisioningTemplate(p) {
    }
    function aws_cdk_lib_aws_iot_CfnProvisioningTemplate_ProvisioningHookProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnResourceSpecificLoggingProps(p) {
    }
    function aws_cdk_lib_aws_iot_CfnResourceSpecificLogging(p) {
    }
    function aws_cdk_lib_aws_iot_CfnRoleAliasProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnRoleAlias(p) {
    }
    function aws_cdk_lib_aws_iot_CfnScheduledAuditProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnScheduledAudit(p) {
    }
    function aws_cdk_lib_aws_iot_CfnSecurityProfileProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.additionalMetricsToRetainV2) || (p.additionalMetricsToRetainV2, void 0), visitedObjects.has(p.alertTargets) || (p.alertTargets, void 0), visitedObjects.has(p.behaviors) || (p.behaviors, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnSecurityProfile(p) {
    }
    function aws_cdk_lib_aws_iot_CfnSecurityProfile_AlertTargetProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnSecurityProfile_BehaviorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.criteria) || (p.criteria, void 0), visitedObjects.has(p.metricDimension) || (p.metricDimension, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnSecurityProfile_BehaviorCriteriaProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.mlDetectionConfig) || (p.mlDetectionConfig, void 0), visitedObjects.has(p.statisticalThreshold) || (p.statisticalThreshold, void 0), visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnSecurityProfile_MachineLearningDetectionConfigProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnSecurityProfile_MetricDimensionProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnSecurityProfile_MetricToRetainProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.metricDimension) || (p.metricDimension, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnSecurityProfile_MetricValueProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnSecurityProfile_StatisticalThresholdProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnThingProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.attributePayload) || (p.attributePayload, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnThing(p) {
    }
    function aws_cdk_lib_aws_iot_CfnThing_AttributePayloadProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.attributes) || (p.attributes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnThingGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.thingGroupProperties) || (p.thingGroupProperties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnThingGroup(p) {
    }
    function aws_cdk_lib_aws_iot_CfnThingGroup_AttributePayloadProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.attributes) || (p.attributes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnThingGroup_ThingGroupPropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.attributePayload) || (p.attributePayload, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnThingPrincipalAttachmentProps(p) {
    }
    function aws_cdk_lib_aws_iot_CfnThingPrincipalAttachment(p) {
    }
    function aws_cdk_lib_aws_iot_CfnThingTypeProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.thingTypeProperties) || (p.thingTypeProperties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnThingType(p) {
    }
    function aws_cdk_lib_aws_iot_CfnThingType_ThingTypePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnTopicRuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.topicRulePayload) || (p.topicRulePayload, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule(p) {
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_ActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cloudwatchAlarm) || (p.cloudwatchAlarm, void 0), visitedObjects.has(p.cloudwatchLogs) || (p.cloudwatchLogs, void 0), visitedObjects.has(p.cloudwatchMetric) || (p.cloudwatchMetric, void 0), visitedObjects.has(p.dynamoDb) || (p.dynamoDb, void 0), visitedObjects.has(p.dynamoDBv2) || (p.dynamoDBv2, void 0), visitedObjects.has(p.elasticsearch) || (p.elasticsearch, void 0), visitedObjects.has(p.firehose) || (p.firehose, void 0), visitedObjects.has(p.http) || (p.http, void 0), visitedObjects.has(p.iotAnalytics) || (p.iotAnalytics, void 0), visitedObjects.has(p.iotEvents) || (p.iotEvents, void 0), visitedObjects.has(p.iotSiteWise) || (p.iotSiteWise, void 0), visitedObjects.has(p.kafka) || (p.kafka, void 0), visitedObjects.has(p.kinesis) || (p.kinesis, void 0), visitedObjects.has(p.lambda) || (p.lambda, void 0), visitedObjects.has(p.location) || (p.location, void 0), visitedObjects.has(p.openSearch) || (p.openSearch, void 0), visitedObjects.has(p.republish) || (p.republish, void 0), visitedObjects.has(p.s3) || (p.s3, void 0), visitedObjects.has(p.sns) || (p.sns, void 0), visitedObjects.has(p.sqs) || (p.sqs, void 0), visitedObjects.has(p.stepFunctions) || (p.stepFunctions, void 0), visitedObjects.has(p.timestream) || (p.timestream, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_AssetPropertyTimestampProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_AssetPropertyValueProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.timestamp) || (p.timestamp, void 0), visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_AssetPropertyVariantProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_CloudwatchAlarmActionProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_CloudwatchLogsActionProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_CloudwatchMetricActionProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_DynamoDBActionProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_DynamoDBv2ActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.putItem) || (p.putItem, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_ElasticsearchActionProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_FirehoseActionProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_HttpActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.auth) || (p.auth, void 0), visitedObjects.has(p.headers) || (p.headers, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_HttpActionHeaderProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_HttpAuthorizationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sigv4) || (p.sigv4, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_IotAnalyticsActionProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_IotEventsActionProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_IotSiteWiseActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.putAssetPropertyValueEntries) || (p.putAssetPropertyValueEntries, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_KafkaActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.clientProperties) || (p.clientProperties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_KinesisActionProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_LambdaActionProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_LocationActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.timestamp) || (p.timestamp, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_OpenSearchActionProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_PutAssetPropertyValueEntryProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.propertyValues) || (p.propertyValues, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_PutItemInputProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_RepublishActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.headers) || (p.headers, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_RepublishActionHeadersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.userProperties) || (p.userProperties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_S3ActionProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_SigV4AuthorizationProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_SnsActionProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_SqsActionProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_StepFunctionsActionProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_TimestampProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_TimestreamActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dimensions) || (p.dimensions, void 0), visitedObjects.has(p.timestamp) || (p.timestamp, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_TimestreamDimensionProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_TimestreamTimestampProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_TopicRulePayloadProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.errorAction) || (p.errorAction, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnTopicRule_UserPropertyProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnTopicRuleDestinationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.httpUrlProperties) || (p.httpUrlProperties, void 0), visitedObjects.has(p.vpcProperties) || (p.vpcProperties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot_CfnTopicRuleDestination(p) {
    }
    function aws_cdk_lib_aws_iot_CfnTopicRuleDestination_HttpUrlDestinationSummaryProperty(p) {
    }
    function aws_cdk_lib_aws_iot_CfnTopicRuleDestination_VpcDestinationPropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_iot1click_CfnDeviceProps(p) {
    }
    function aws_cdk_lib_aws_iot1click_CfnDevice(p) {
    }
    function aws_cdk_lib_aws_iot1click_CfnPlacementProps(p) {
    }
    function aws_cdk_lib_aws_iot1click_CfnPlacement(p) {
    }
    function aws_cdk_lib_aws_iot1click_CfnProjectProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.placementTemplate) || (p.placementTemplate, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iot1click_CfnProject(p) {
    }
    function aws_cdk_lib_aws_iot1click_CfnProject_DeviceTemplateProperty(p) {
    }
    function aws_cdk_lib_aws_iot1click_CfnProject_PlacementTemplateProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.deviceTemplates) || (p.deviceTemplates, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotanalytics_CfnChannelProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.channelStorage) || (p.channelStorage, void 0), visitedObjects.has(p.retentionPeriod) || (p.retentionPeriod, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotanalytics_CfnChannel(p) {
    }
    function aws_cdk_lib_aws_iotanalytics_CfnChannel_ChannelStorageProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customerManagedS3) || (p.customerManagedS3, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotanalytics_CfnChannel_CustomerManagedS3Property(p) {
    }
    function aws_cdk_lib_aws_iotanalytics_CfnChannel_RetentionPeriodProperty(p) {
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDatasetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.contentDeliveryRules) || (p.contentDeliveryRules, void 0), visitedObjects.has(p.lateDataRules) || (p.lateDataRules, void 0), visitedObjects.has(p.retentionPeriod) || (p.retentionPeriod, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.triggers) || (p.triggers, void 0), visitedObjects.has(p.versioningConfiguration) || (p.versioningConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDataset(p) {
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDataset_ActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.containerAction) || (p.containerAction, void 0), visitedObjects.has(p.queryAction) || (p.queryAction, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDataset_ContainerActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.resourceConfiguration) || (p.resourceConfiguration, void 0), visitedObjects.has(p.variables) || (p.variables, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDataset_DatasetContentDeliveryRuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destination) || (p.destination, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDataset_DatasetContentDeliveryRuleDestinationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.iotEventsDestinationConfiguration) || (p.iotEventsDestinationConfiguration, void 0), visitedObjects.has(p.s3DestinationConfiguration) || (p.s3DestinationConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDataset_DatasetContentVersionValueProperty(p) {
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDataset_DeltaTimeProperty(p) {
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDataset_DeltaTimeSessionWindowConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDataset_FilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.deltaTime) || (p.deltaTime, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDataset_GlueConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDataset_IotEventsDestinationConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDataset_LateDataRuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ruleConfiguration) || (p.ruleConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDataset_LateDataRuleConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.deltaTimeSessionWindowConfiguration) || (p.deltaTimeSessionWindowConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDataset_OutputFileUriValueProperty(p) {
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDataset_QueryActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.filters) || (p.filters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDataset_ResourceConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDataset_RetentionPeriodProperty(p) {
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDataset_S3DestinationConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.glueConfiguration) || (p.glueConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDataset_ScheduleProperty(p) {
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDataset_TriggerProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.schedule) || (p.schedule, void 0), visitedObjects.has(p.triggeringDataset) || (p.triggeringDataset, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDataset_TriggeringDatasetProperty(p) {
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDataset_VariableProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.datasetContentVersionValue) || (p.datasetContentVersionValue, void 0), visitedObjects.has(p.outputFileUriValue) || (p.outputFileUriValue, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDataset_VersioningConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDatastoreProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.datastorePartitions) || (p.datastorePartitions, void 0), visitedObjects.has(p.datastoreStorage) || (p.datastoreStorage, void 0), visitedObjects.has(p.fileFormatConfiguration) || (p.fileFormatConfiguration, void 0), visitedObjects.has(p.retentionPeriod) || (p.retentionPeriod, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDatastore(p) {
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDatastore_ColumnProperty(p) {
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDatastore_CustomerManagedS3Property(p) {
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDatastore_CustomerManagedS3StorageProperty(p) {
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDatastore_DatastorePartitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.partition) || (p.partition, void 0), visitedObjects.has(p.timestampPartition) || (p.timestampPartition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDatastore_DatastorePartitionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.partitions) || (p.partitions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDatastore_DatastoreStorageProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customerManagedS3) || (p.customerManagedS3, void 0), visitedObjects.has(p.iotSiteWiseMultiLayerStorage) || (p.iotSiteWiseMultiLayerStorage, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDatastore_FileFormatConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.parquetConfiguration) || (p.parquetConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDatastore_IotSiteWiseMultiLayerStorageProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customerManagedS3Storage) || (p.customerManagedS3Storage, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDatastore_ParquetConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.schemaDefinition) || (p.schemaDefinition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDatastore_PartitionProperty(p) {
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDatastore_RetentionPeriodProperty(p) {
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDatastore_SchemaDefinitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columns) || (p.columns, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotanalytics_CfnDatastore_TimestampPartitionProperty(p) {
    }
    function aws_cdk_lib_aws_iotanalytics_CfnPipelineProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.pipelineActivities) || (p.pipelineActivities, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotanalytics_CfnPipeline(p) {
    }
    function aws_cdk_lib_aws_iotanalytics_CfnPipeline_ActivityProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.addAttributes) || (p.addAttributes, void 0), visitedObjects.has(p.channel) || (p.channel, void 0), visitedObjects.has(p.datastore) || (p.datastore, void 0), visitedObjects.has(p.deviceRegistryEnrich) || (p.deviceRegistryEnrich, void 0), visitedObjects.has(p.deviceShadowEnrich) || (p.deviceShadowEnrich, void 0), visitedObjects.has(p.filter) || (p.filter, void 0), visitedObjects.has(p.lambda) || (p.lambda, void 0), visitedObjects.has(p.math) || (p.math, void 0), visitedObjects.has(p.removeAttributes) || (p.removeAttributes, void 0), visitedObjects.has(p.selectAttributes) || (p.selectAttributes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotanalytics_CfnPipeline_AddAttributesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.attributes) || (p.attributes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotanalytics_CfnPipeline_ChannelProperty(p) {
    }
    function aws_cdk_lib_aws_iotanalytics_CfnPipeline_DatastoreProperty(p) {
    }
    function aws_cdk_lib_aws_iotanalytics_CfnPipeline_DeviceRegistryEnrichProperty(p) {
    }
    function aws_cdk_lib_aws_iotanalytics_CfnPipeline_DeviceShadowEnrichProperty(p) {
    }
    function aws_cdk_lib_aws_iotanalytics_CfnPipeline_FilterProperty(p) {
    }
    function aws_cdk_lib_aws_iotanalytics_CfnPipeline_LambdaProperty(p) {
    }
    function aws_cdk_lib_aws_iotanalytics_CfnPipeline_MathProperty(p) {
    }
    function aws_cdk_lib_aws_iotanalytics_CfnPipeline_RemoveAttributesProperty(p) {
    }
    function aws_cdk_lib_aws_iotanalytics_CfnPipeline_SelectAttributesProperty(p) {
    }
    function aws_cdk_lib_aws_iotcoredeviceadvisor_CfnSuiteDefinitionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotcoredeviceadvisor_CfnSuiteDefinition(p) {
    }
    function aws_cdk_lib_aws_iotcoredeviceadvisor_CfnSuiteDefinition_DeviceUnderTestProperty(p) {
    }
    function aws_cdk_lib_aws_iotcoredeviceadvisor_CfnSuiteDefinition_SuiteDefinitionConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.devices) || (p.devices, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnAlarmModelProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.alarmRule) || (p.alarmRule, void 0), visitedObjects.has(p.alarmCapabilities) || (p.alarmCapabilities, void 0), visitedObjects.has(p.alarmEventActions) || (p.alarmEventActions, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnAlarmModel(p) {
    }
    function aws_cdk_lib_aws_iotevents_CfnAlarmModel_AcknowledgeFlowProperty(p) {
    }
    function aws_cdk_lib_aws_iotevents_CfnAlarmModel_AlarmActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dynamoDb) || (p.dynamoDb, void 0), visitedObjects.has(p.dynamoDBv2) || (p.dynamoDBv2, void 0), visitedObjects.has(p.firehose) || (p.firehose, void 0), visitedObjects.has(p.iotEvents) || (p.iotEvents, void 0), visitedObjects.has(p.iotSiteWise) || (p.iotSiteWise, void 0), visitedObjects.has(p.iotTopicPublish) || (p.iotTopicPublish, void 0), visitedObjects.has(p.lambda) || (p.lambda, void 0), visitedObjects.has(p.sns) || (p.sns, void 0), visitedObjects.has(p.sqs) || (p.sqs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnAlarmModel_AlarmCapabilitiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.acknowledgeFlow) || (p.acknowledgeFlow, void 0), visitedObjects.has(p.initializationConfiguration) || (p.initializationConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnAlarmModel_AlarmEventActionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.alarmActions) || (p.alarmActions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnAlarmModel_AlarmRuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.simpleRule) || (p.simpleRule, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnAlarmModel_AssetPropertyTimestampProperty(p) {
    }
    function aws_cdk_lib_aws_iotevents_CfnAlarmModel_AssetPropertyValueProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.value) || (p.value, void 0), visitedObjects.has(p.timestamp) || (p.timestamp, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnAlarmModel_AssetPropertyVariantProperty(p) {
    }
    function aws_cdk_lib_aws_iotevents_CfnAlarmModel_DynamoDBProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.payload) || (p.payload, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnAlarmModel_DynamoDBv2Property(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.payload) || (p.payload, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnAlarmModel_FirehoseProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.payload) || (p.payload, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnAlarmModel_InitializationConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_iotevents_CfnAlarmModel_IotEventsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.payload) || (p.payload, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnAlarmModel_IotSiteWiseProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.propertyValue) || (p.propertyValue, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnAlarmModel_IotTopicPublishProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.payload) || (p.payload, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnAlarmModel_LambdaProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.payload) || (p.payload, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnAlarmModel_PayloadProperty(p) {
    }
    function aws_cdk_lib_aws_iotevents_CfnAlarmModel_SimpleRuleProperty(p) {
    }
    function aws_cdk_lib_aws_iotevents_CfnAlarmModel_SnsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.payload) || (p.payload, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnAlarmModel_SqsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.payload) || (p.payload, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnDetectorModelProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.detectorModelDefinition) || (p.detectorModelDefinition, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnDetectorModel(p) {
    }
    function aws_cdk_lib_aws_iotevents_CfnDetectorModel_ActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.clearTimer) || (p.clearTimer, void 0), visitedObjects.has(p.dynamoDb) || (p.dynamoDb, void 0), visitedObjects.has(p.dynamoDBv2) || (p.dynamoDBv2, void 0), visitedObjects.has(p.firehose) || (p.firehose, void 0), visitedObjects.has(p.iotEvents) || (p.iotEvents, void 0), visitedObjects.has(p.iotSiteWise) || (p.iotSiteWise, void 0), visitedObjects.has(p.iotTopicPublish) || (p.iotTopicPublish, void 0), visitedObjects.has(p.lambda) || (p.lambda, void 0), visitedObjects.has(p.resetTimer) || (p.resetTimer, void 0), visitedObjects.has(p.setTimer) || (p.setTimer, void 0), visitedObjects.has(p.setVariable) || (p.setVariable, void 0), visitedObjects.has(p.sns) || (p.sns, void 0), visitedObjects.has(p.sqs) || (p.sqs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnDetectorModel_AssetPropertyTimestampProperty(p) {
    }
    function aws_cdk_lib_aws_iotevents_CfnDetectorModel_AssetPropertyValueProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.value) || (p.value, void 0), visitedObjects.has(p.timestamp) || (p.timestamp, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnDetectorModel_AssetPropertyVariantProperty(p) {
    }
    function aws_cdk_lib_aws_iotevents_CfnDetectorModel_ClearTimerProperty(p) {
    }
    function aws_cdk_lib_aws_iotevents_CfnDetectorModel_DetectorModelDefinitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.states) || (p.states, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnDetectorModel_DynamoDBProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.payload) || (p.payload, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnDetectorModel_DynamoDBv2Property(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.payload) || (p.payload, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnDetectorModel_EventProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnDetectorModel_FirehoseProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.payload) || (p.payload, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnDetectorModel_IotEventsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.payload) || (p.payload, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnDetectorModel_IotSiteWiseProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.propertyValue) || (p.propertyValue, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnDetectorModel_IotTopicPublishProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.payload) || (p.payload, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnDetectorModel_LambdaProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.payload) || (p.payload, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnDetectorModel_OnEnterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.events) || (p.events, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnDetectorModel_OnExitProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.events) || (p.events, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnDetectorModel_OnInputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.events) || (p.events, void 0), visitedObjects.has(p.transitionEvents) || (p.transitionEvents, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnDetectorModel_PayloadProperty(p) {
    }
    function aws_cdk_lib_aws_iotevents_CfnDetectorModel_ResetTimerProperty(p) {
    }
    function aws_cdk_lib_aws_iotevents_CfnDetectorModel_SetTimerProperty(p) {
    }
    function aws_cdk_lib_aws_iotevents_CfnDetectorModel_SetVariableProperty(p) {
    }
    function aws_cdk_lib_aws_iotevents_CfnDetectorModel_SnsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.payload) || (p.payload, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnDetectorModel_SqsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.payload) || (p.payload, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnDetectorModel_StateProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.onEnter) || (p.onEnter, void 0), visitedObjects.has(p.onExit) || (p.onExit, void 0), visitedObjects.has(p.onInput) || (p.onInput, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnDetectorModel_TransitionEventProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnInputProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.inputDefinition) || (p.inputDefinition, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotevents_CfnInput(p) {
    }
    function aws_cdk_lib_aws_iotevents_CfnInput_AttributeProperty(p) {
    }
    function aws_cdk_lib_aws_iotevents_CfnInput_InputDefinitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.attributes) || (p.attributes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotfleethub_CfnApplicationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotfleethub_CfnApplication(p) {
    }
    function aws_cdk_lib_aws_iotfleetwise_CfnCampaignProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.collectionScheme) || (p.collectionScheme, void 0), visitedObjects.has(p.signalsToCollect) || (p.signalsToCollect, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotfleetwise_CfnCampaign(p) {
    }
    function aws_cdk_lib_aws_iotfleetwise_CfnCampaign_CollectionSchemeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.conditionBasedCollectionScheme) || (p.conditionBasedCollectionScheme, void 0), visitedObjects.has(p.timeBasedCollectionScheme) || (p.timeBasedCollectionScheme, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotfleetwise_CfnCampaign_ConditionBasedCollectionSchemeProperty(p) {
    }
    function aws_cdk_lib_aws_iotfleetwise_CfnCampaign_SignalInformationProperty(p) {
    }
    function aws_cdk_lib_aws_iotfleetwise_CfnCampaign_TimeBasedCollectionSchemeProperty(p) {
    }
    function aws_cdk_lib_aws_iotfleetwise_CfnDecoderManifestProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.networkInterfaces) || (p.networkInterfaces, void 0), visitedObjects.has(p.signalDecoders) || (p.signalDecoders, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotfleetwise_CfnDecoderManifest(p) {
    }
    function aws_cdk_lib_aws_iotfleetwise_CfnDecoderManifest_CanInterfaceProperty(p) {
    }
    function aws_cdk_lib_aws_iotfleetwise_CfnDecoderManifest_CanSignalProperty(p) {
    }
    function aws_cdk_lib_aws_iotfleetwise_CfnDecoderManifest_NetworkInterfacesItemsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.canInterface) || (p.canInterface, void 0), visitedObjects.has(p.obdInterface) || (p.obdInterface, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotfleetwise_CfnDecoderManifest_ObdInterfaceProperty(p) {
    }
    function aws_cdk_lib_aws_iotfleetwise_CfnDecoderManifest_ObdSignalProperty(p) {
    }
    function aws_cdk_lib_aws_iotfleetwise_CfnDecoderManifest_SignalDecodersItemsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.canSignal) || (p.canSignal, void 0), visitedObjects.has(p.obdSignal) || (p.obdSignal, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotfleetwise_CfnFleetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotfleetwise_CfnFleet(p) {
    }
    function aws_cdk_lib_aws_iotfleetwise_CfnModelManifestProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotfleetwise_CfnModelManifest(p) {
    }
    function aws_cdk_lib_aws_iotfleetwise_CfnSignalCatalogProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.nodeCounts) || (p.nodeCounts, void 0), visitedObjects.has(p.nodes) || (p.nodes, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotfleetwise_CfnSignalCatalog(p) {
    }
    function aws_cdk_lib_aws_iotfleetwise_CfnSignalCatalog_ActuatorProperty(p) {
    }
    function aws_cdk_lib_aws_iotfleetwise_CfnSignalCatalog_AttributeProperty(p) {
    }
    function aws_cdk_lib_aws_iotfleetwise_CfnSignalCatalog_BranchProperty(p) {
    }
    function aws_cdk_lib_aws_iotfleetwise_CfnSignalCatalog_NodeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actuator) || (p.actuator, void 0), visitedObjects.has(p.attribute) || (p.attribute, void 0), visitedObjects.has(p.branch) || (p.branch, void 0), visitedObjects.has(p.sensor) || (p.sensor, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotfleetwise_CfnSignalCatalog_NodeCountsProperty(p) {
    }
    function aws_cdk_lib_aws_iotfleetwise_CfnSignalCatalog_SensorProperty(p) {
    }
    function aws_cdk_lib_aws_iotfleetwise_CfnVehicleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.attributes) || (p.attributes, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotfleetwise_CfnVehicle(p) {
    }
    function aws_cdk_lib_aws_iotsitewise_CfnAccessPolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.accessPolicyIdentity) || (p.accessPolicyIdentity, void 0), visitedObjects.has(p.accessPolicyResource) || (p.accessPolicyResource, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotsitewise_CfnAccessPolicy(p) {
    }
    function aws_cdk_lib_aws_iotsitewise_CfnAccessPolicy_AccessPolicyIdentityProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.iamRole) || (p.iamRole, void 0), visitedObjects.has(p.iamUser) || (p.iamUser, void 0), visitedObjects.has(p.user) || (p.user, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotsitewise_CfnAccessPolicy_AccessPolicyResourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.portal) || (p.portal, void 0), visitedObjects.has(p.project) || (p.project, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotsitewise_CfnAccessPolicy_IamRoleProperty(p) {
    }
    function aws_cdk_lib_aws_iotsitewise_CfnAccessPolicy_IamUserProperty(p) {
    }
    function aws_cdk_lib_aws_iotsitewise_CfnAccessPolicy_PortalProperty(p) {
    }
    function aws_cdk_lib_aws_iotsitewise_CfnAccessPolicy_ProjectProperty(p) {
    }
    function aws_cdk_lib_aws_iotsitewise_CfnAccessPolicy_UserProperty(p) {
    }
    function aws_cdk_lib_aws_iotsitewise_CfnAssetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.assetHierarchies) || (p.assetHierarchies, void 0), visitedObjects.has(p.assetProperties) || (p.assetProperties, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotsitewise_CfnAsset(p) {
    }
    function aws_cdk_lib_aws_iotsitewise_CfnAsset_AssetHierarchyProperty(p) {
    }
    function aws_cdk_lib_aws_iotsitewise_CfnAsset_AssetPropertyProperty(p) {
    }
    function aws_cdk_lib_aws_iotsitewise_CfnAssetModelProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.assetModelCompositeModels) || (p.assetModelCompositeModels, void 0), visitedObjects.has(p.assetModelHierarchies) || (p.assetModelHierarchies, void 0), visitedObjects.has(p.assetModelProperties) || (p.assetModelProperties, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotsitewise_CfnAssetModel(p) {
    }
    function aws_cdk_lib_aws_iotsitewise_CfnAssetModel_AssetModelCompositeModelProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.compositeModelProperties) || (p.compositeModelProperties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotsitewise_CfnAssetModel_AssetModelHierarchyProperty(p) {
    }
    function aws_cdk_lib_aws_iotsitewise_CfnAssetModel_AssetModelPropertyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.type) || (p.type, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotsitewise_CfnAssetModel_AttributeProperty(p) {
    }
    function aws_cdk_lib_aws_iotsitewise_CfnAssetModel_ExpressionVariableProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotsitewise_CfnAssetModel_MetricProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.variables) || (p.variables, void 0), visitedObjects.has(p.window) || (p.window, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotsitewise_CfnAssetModel_MetricWindowProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tumbling) || (p.tumbling, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotsitewise_CfnAssetModel_PropertyTypeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.attribute) || (p.attribute, void 0), visitedObjects.has(p.metric) || (p.metric, void 0), visitedObjects.has(p.transform) || (p.transform, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotsitewise_CfnAssetModel_TransformProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.variables) || (p.variables, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotsitewise_CfnAssetModel_TumblingWindowProperty(p) {
    }
    function aws_cdk_lib_aws_iotsitewise_CfnAssetModel_VariableValueProperty(p) {
    }
    function aws_cdk_lib_aws_iotsitewise_CfnDashboardProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotsitewise_CfnDashboard(p) {
    }
    function aws_cdk_lib_aws_iotsitewise_CfnGatewayProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.gatewayPlatform) || (p.gatewayPlatform, void 0), visitedObjects.has(p.gatewayCapabilitySummaries) || (p.gatewayCapabilitySummaries, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotsitewise_CfnGateway(p) {
    }
    function aws_cdk_lib_aws_iotsitewise_CfnGateway_GatewayCapabilitySummaryProperty(p) {
    }
    function aws_cdk_lib_aws_iotsitewise_CfnGateway_GatewayPlatformProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.greengrass) || (p.greengrass, void 0), visitedObjects.has(p.greengrassV2) || (p.greengrassV2, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotsitewise_CfnGateway_GreengrassProperty(p) {
    }
    function aws_cdk_lib_aws_iotsitewise_CfnGateway_GreengrassV2Property(p) {
    }
    function aws_cdk_lib_aws_iotsitewise_CfnPortalProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotsitewise_CfnPortal(p) {
    }
    function aws_cdk_lib_aws_iotsitewise_CfnPortal_AlarmsProperty(p) {
    }
    function aws_cdk_lib_aws_iotsitewise_CfnProjectProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotsitewise_CfnProject(p) {
    }
    function aws_cdk_lib_aws_iotthingsgraph_CfnFlowTemplateProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.definition) || (p.definition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotthingsgraph_CfnFlowTemplate(p) {
    }
    function aws_cdk_lib_aws_iotthingsgraph_CfnFlowTemplate_DefinitionDocumentProperty(p) {
    }
    function aws_cdk_lib_aws_iottwinmaker_CfnComponentTypeProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.functions) || (p.functions, void 0), visitedObjects.has(p.propertyDefinitions) || (p.propertyDefinitions, void 0), visitedObjects.has(p.propertyGroups) || (p.propertyGroups, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iottwinmaker_CfnComponentType(p) {
    }
    function aws_cdk_lib_aws_iottwinmaker_CfnComponentType_DataConnectorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.lambda) || (p.lambda, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iottwinmaker_CfnComponentType_DataTypeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.allowedValues) || (p.allowedValues, void 0), visitedObjects.has(p.nestedType) || (p.nestedType, void 0), visitedObjects.has(p.relationship) || (p.relationship, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iottwinmaker_CfnComponentType_DataValueProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.listValue) || (p.listValue, void 0), visitedObjects.has(p.mapValue) || (p.mapValue, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iottwinmaker_CfnComponentType_ErrorProperty(p) {
    }
    function aws_cdk_lib_aws_iottwinmaker_CfnComponentType_FunctionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.implementedBy) || (p.implementedBy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iottwinmaker_CfnComponentType_LambdaFunctionProperty(p) {
    }
    function aws_cdk_lib_aws_iottwinmaker_CfnComponentType_PropertyDefinitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.configurations) || (p.configurations, void 0), visitedObjects.has(p.dataType) || (p.dataType, void 0), visitedObjects.has(p.defaultValue) || (p.defaultValue, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iottwinmaker_CfnComponentType_PropertyGroupProperty(p) {
    }
    function aws_cdk_lib_aws_iottwinmaker_CfnComponentType_RelationshipProperty(p) {
    }
    function aws_cdk_lib_aws_iottwinmaker_CfnComponentType_RelationshipValueProperty(p) {
    }
    function aws_cdk_lib_aws_iottwinmaker_CfnComponentType_StatusProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.error) || (p.error, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iottwinmaker_CfnEntityProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.components) || (p.components, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iottwinmaker_CfnEntity(p) {
    }
    function aws_cdk_lib_aws_iottwinmaker_CfnEntity_ComponentProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.properties) || (p.properties, void 0), visitedObjects.has(p.propertyGroups) || (p.propertyGroups, void 0), visitedObjects.has(p.status) || (p.status, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iottwinmaker_CfnEntity_DataTypeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.allowedValues) || (p.allowedValues, void 0), visitedObjects.has(p.nestedType) || (p.nestedType, void 0), visitedObjects.has(p.relationship) || (p.relationship, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iottwinmaker_CfnEntity_DataValueProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.listValue) || (p.listValue, void 0), visitedObjects.has(p.mapValue) || (p.mapValue, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iottwinmaker_CfnEntity_DefinitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.configuration) || (p.configuration, void 0), visitedObjects.has(p.dataType) || (p.dataType, void 0), visitedObjects.has(p.defaultValue) || (p.defaultValue, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iottwinmaker_CfnEntity_ErrorProperty(p) {
    }
    function aws_cdk_lib_aws_iottwinmaker_CfnEntity_PropertyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iottwinmaker_CfnEntity_PropertyGroupProperty(p) {
    }
    function aws_cdk_lib_aws_iottwinmaker_CfnEntity_RelationshipProperty(p) {
    }
    function aws_cdk_lib_aws_iottwinmaker_CfnEntity_RelationshipValueProperty(p) {
    }
    function aws_cdk_lib_aws_iottwinmaker_CfnEntity_StatusProperty(p) {
    }
    function aws_cdk_lib_aws_iottwinmaker_CfnSceneProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sceneMetadata) || (p.sceneMetadata, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iottwinmaker_CfnScene(p) {
    }
    function aws_cdk_lib_aws_iottwinmaker_CfnSyncJobProps(p) {
    }
    function aws_cdk_lib_aws_iottwinmaker_CfnSyncJob(p) {
    }
    function aws_cdk_lib_aws_iottwinmaker_CfnWorkspaceProps(p) {
    }
    function aws_cdk_lib_aws_iottwinmaker_CfnWorkspace(p) {
    }
    function aws_cdk_lib_aws_iotwireless_CfnDestinationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotwireless_CfnDestination(p) {
    }
    function aws_cdk_lib_aws_iotwireless_CfnDeviceProfileProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.loRaWan) || (p.loRaWan, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotwireless_CfnDeviceProfile(p) {
    }
    function aws_cdk_lib_aws_iotwireless_CfnDeviceProfile_LoRaWANDeviceProfileProperty(p) {
    }
    function aws_cdk_lib_aws_iotwireless_CfnFuotaTaskProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.loRaWan) || (p.loRaWan, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotwireless_CfnFuotaTask(p) {
    }
    function aws_cdk_lib_aws_iotwireless_CfnFuotaTask_LoRaWANProperty(p) {
    }
    function aws_cdk_lib_aws_iotwireless_CfnMulticastGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.loRaWan) || (p.loRaWan, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotwireless_CfnMulticastGroup(p) {
    }
    function aws_cdk_lib_aws_iotwireless_CfnMulticastGroup_LoRaWANProperty(p) {
    }
    function aws_cdk_lib_aws_iotwireless_CfnNetworkAnalyzerConfigurationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotwireless_CfnNetworkAnalyzerConfiguration(p) {
    }
    function aws_cdk_lib_aws_iotwireless_CfnNetworkAnalyzerConfiguration_TraceContentProperty(p) {
    }
    function aws_cdk_lib_aws_iotwireless_CfnPartnerAccountProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.sidewalk) || (p.sidewalk, void 0), visitedObjects.has(p.sidewalkResponse) || (p.sidewalkResponse, void 0), visitedObjects.has(p.sidewalkUpdate) || (p.sidewalkUpdate, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotwireless_CfnPartnerAccount(p) {
    }
    function aws_cdk_lib_aws_iotwireless_CfnPartnerAccount_SidewalkAccountInfoProperty(p) {
    }
    function aws_cdk_lib_aws_iotwireless_CfnPartnerAccount_SidewalkAccountInfoWithFingerprintProperty(p) {
    }
    function aws_cdk_lib_aws_iotwireless_CfnPartnerAccount_SidewalkUpdateAccountProperty(p) {
    }
    function aws_cdk_lib_aws_iotwireless_CfnServiceProfileProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.loRaWan) || (p.loRaWan, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotwireless_CfnServiceProfile(p) {
    }
    function aws_cdk_lib_aws_iotwireless_CfnServiceProfile_LoRaWANServiceProfileProperty(p) {
    }
    function aws_cdk_lib_aws_iotwireless_CfnTaskDefinitionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.loRaWanUpdateGatewayTaskEntry) || (p.loRaWanUpdateGatewayTaskEntry, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.update) || (p.update, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotwireless_CfnTaskDefinition(p) {
    }
    function aws_cdk_lib_aws_iotwireless_CfnTaskDefinition_LoRaWANGatewayVersionProperty(p) {
    }
    function aws_cdk_lib_aws_iotwireless_CfnTaskDefinition_LoRaWANUpdateGatewayTaskCreateProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.currentVersion) || (p.currentVersion, void 0), visitedObjects.has(p.updateVersion) || (p.updateVersion, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotwireless_CfnTaskDefinition_LoRaWANUpdateGatewayTaskEntryProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.currentVersion) || (p.currentVersion, void 0), visitedObjects.has(p.updateVersion) || (p.updateVersion, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotwireless_CfnTaskDefinition_UpdateWirelessGatewayTaskCreateProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.loRaWan) || (p.loRaWan, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotwireless_CfnWirelessDeviceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.loRaWan) || (p.loRaWan, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotwireless_CfnWirelessDevice(p) {
    }
    function aws_cdk_lib_aws_iotwireless_CfnWirelessDevice_AbpV10xProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sessionKeys) || (p.sessionKeys, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotwireless_CfnWirelessDevice_AbpV11Property(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sessionKeys) || (p.sessionKeys, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotwireless_CfnWirelessDevice_LoRaWANDeviceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.abpV10X) || (p.abpV10X, void 0), visitedObjects.has(p.abpV11) || (p.abpV11, void 0), visitedObjects.has(p.otaaV10X) || (p.otaaV10X, void 0), visitedObjects.has(p.otaaV11) || (p.otaaV11, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotwireless_CfnWirelessDevice_OtaaV10xProperty(p) {
    }
    function aws_cdk_lib_aws_iotwireless_CfnWirelessDevice_OtaaV11Property(p) {
    }
    function aws_cdk_lib_aws_iotwireless_CfnWirelessDevice_SessionKeysAbpV10xProperty(p) {
    }
    function aws_cdk_lib_aws_iotwireless_CfnWirelessDevice_SessionKeysAbpV11Property(p) {
    }
    function aws_cdk_lib_aws_iotwireless_CfnWirelessDeviceImportTaskProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.sidewalk) || (p.sidewalk, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotwireless_CfnWirelessDeviceImportTask(p) {
    }
    function aws_cdk_lib_aws_iotwireless_CfnWirelessDeviceImportTask_SidewalkProperty(p) {
    }
    function aws_cdk_lib_aws_iotwireless_CfnWirelessGatewayProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.loRaWan) || (p.loRaWan, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_iotwireless_CfnWirelessGateway(p) {
    }
    function aws_cdk_lib_aws_iotwireless_CfnWirelessGateway_LoRaWANGatewayProperty(p) {
    }
    function aws_cdk_lib_aws_ivs_CfnChannelProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ivs_CfnChannel(p) {
    }
    function aws_cdk_lib_aws_ivs_CfnPlaybackKeyPairProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ivs_CfnPlaybackKeyPair(p) {
    }
    function aws_cdk_lib_aws_ivs_CfnRecordingConfigurationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.destinationConfiguration) || (p.destinationConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.thumbnailConfiguration) || (p.thumbnailConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ivs_CfnRecordingConfiguration(p) {
    }
    function aws_cdk_lib_aws_ivs_CfnRecordingConfiguration_DestinationConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3) || (p.s3, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ivs_CfnRecordingConfiguration_S3DestinationConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_ivs_CfnRecordingConfiguration_ThumbnailConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_ivs_CfnStreamKeyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ivs_CfnStreamKey(p) {
    }
    function aws_cdk_lib_aws_ivschat_CfnLoggingConfigurationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.destinationConfiguration) || (p.destinationConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ivschat_CfnLoggingConfiguration(p) {
    }
    function aws_cdk_lib_aws_ivschat_CfnLoggingConfiguration_CloudWatchLogsDestinationConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_ivschat_CfnLoggingConfiguration_DestinationConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cloudWatchLogs) || (p.cloudWatchLogs, void 0), visitedObjects.has(p.firehose) || (p.firehose, void 0), visitedObjects.has(p.s3) || (p.s3, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ivschat_CfnLoggingConfiguration_FirehoseDestinationConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_ivschat_CfnLoggingConfiguration_S3DestinationConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_ivschat_CfnRoomProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.messageReviewHandler) || (p.messageReviewHandler, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ivschat_CfnRoom(p) {
    }
    function aws_cdk_lib_aws_ivschat_CfnRoom_MessageReviewHandlerProperty(p) {
    }
    function aws_cdk_lib_aws_kafkaconnect_CfnConnectorProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.capacity) || (p.capacity, void 0), visitedObjects.has(p.connectorConfiguration) || (p.connectorConfiguration, void 0), visitedObjects.has(p.kafkaCluster) || (p.kafkaCluster, void 0), visitedObjects.has(p.kafkaClusterClientAuthentication) || (p.kafkaClusterClientAuthentication, void 0), visitedObjects.has(p.kafkaClusterEncryptionInTransit) || (p.kafkaClusterEncryptionInTransit, void 0), visitedObjects.has(p.plugins) || (p.plugins, void 0), visitedObjects.has(p.logDelivery) || (p.logDelivery, void 0), visitedObjects.has(p.workerConfiguration) || (p.workerConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kafkaconnect_CfnConnector(p) {
    }
    function aws_cdk_lib_aws_kafkaconnect_CfnConnector_ApacheKafkaClusterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kafkaconnect_CfnConnector_AutoScalingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.scaleInPolicy) || (p.scaleInPolicy, void 0), visitedObjects.has(p.scaleOutPolicy) || (p.scaleOutPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kafkaconnect_CfnConnector_CapacityProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.autoScaling) || (p.autoScaling, void 0), visitedObjects.has(p.provisionedCapacity) || (p.provisionedCapacity, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kafkaconnect_CfnConnector_CloudWatchLogsLogDeliveryProperty(p) {
    }
    function aws_cdk_lib_aws_kafkaconnect_CfnConnector_CustomPluginProperty(p) {
    }
    function aws_cdk_lib_aws_kafkaconnect_CfnConnector_FirehoseLogDeliveryProperty(p) {
    }
    function aws_cdk_lib_aws_kafkaconnect_CfnConnector_KafkaClusterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.apacheKafkaCluster) || (p.apacheKafkaCluster, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kafkaconnect_CfnConnector_KafkaClusterClientAuthenticationProperty(p) {
    }
    function aws_cdk_lib_aws_kafkaconnect_CfnConnector_KafkaClusterEncryptionInTransitProperty(p) {
    }
    function aws_cdk_lib_aws_kafkaconnect_CfnConnector_LogDeliveryProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.workerLogDelivery) || (p.workerLogDelivery, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kafkaconnect_CfnConnector_PluginProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customPlugin) || (p.customPlugin, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kafkaconnect_CfnConnector_ProvisionedCapacityProperty(p) {
    }
    function aws_cdk_lib_aws_kafkaconnect_CfnConnector_S3LogDeliveryProperty(p) {
    }
    function aws_cdk_lib_aws_kafkaconnect_CfnConnector_ScaleInPolicyProperty(p) {
    }
    function aws_cdk_lib_aws_kafkaconnect_CfnConnector_ScaleOutPolicyProperty(p) {
    }
    function aws_cdk_lib_aws_kafkaconnect_CfnConnector_VpcProperty(p) {
    }
    function aws_cdk_lib_aws_kafkaconnect_CfnConnector_WorkerConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kafkaconnect_CfnConnector_WorkerLogDeliveryProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cloudWatchLogs) || (p.cloudWatchLogs, void 0), visitedObjects.has(p.firehose) || (p.firehose, void 0), visitedObjects.has(p.s3) || (p.s3, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.customDocumentEnrichmentConfiguration) || (p.customDocumentEnrichmentConfiguration, void 0), visitedObjects.has(p.dataSourceConfiguration) || (p.dataSourceConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource(p) {
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_AccessControlListConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_AclConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_ColumnConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldMappings) || (p.fieldMappings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_ConfluenceAttachmentConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.attachmentFieldMappings) || (p.attachmentFieldMappings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_ConfluenceAttachmentToIndexFieldMappingProperty(p) {
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_ConfluenceBlogConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.blogFieldMappings) || (p.blogFieldMappings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_ConfluenceBlogToIndexFieldMappingProperty(p) {
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_ConfluenceConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.attachmentConfiguration) || (p.attachmentConfiguration, void 0), visitedObjects.has(p.blogConfiguration) || (p.blogConfiguration, void 0), visitedObjects.has(p.pageConfiguration) || (p.pageConfiguration, void 0), visitedObjects.has(p.spaceConfiguration) || (p.spaceConfiguration, void 0), visitedObjects.has(p.vpcConfiguration) || (p.vpcConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_ConfluencePageConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.pageFieldMappings) || (p.pageFieldMappings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_ConfluencePageToIndexFieldMappingProperty(p) {
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_ConfluenceSpaceConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.spaceFieldMappings) || (p.spaceFieldMappings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_ConfluenceSpaceToIndexFieldMappingProperty(p) {
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_ConnectionConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_CustomDocumentEnrichmentConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.inlineConfigurations) || (p.inlineConfigurations, void 0), visitedObjects.has(p.postExtractionHookConfiguration) || (p.postExtractionHookConfiguration, void 0), visitedObjects.has(p.preExtractionHookConfiguration) || (p.preExtractionHookConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_DataSourceConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.confluenceConfiguration) || (p.confluenceConfiguration, void 0), visitedObjects.has(p.databaseConfiguration) || (p.databaseConfiguration, void 0), visitedObjects.has(p.googleDriveConfiguration) || (p.googleDriveConfiguration, void 0), visitedObjects.has(p.oneDriveConfiguration) || (p.oneDriveConfiguration, void 0), visitedObjects.has(p.s3Configuration) || (p.s3Configuration, void 0), visitedObjects.has(p.salesforceConfiguration) || (p.salesforceConfiguration, void 0), visitedObjects.has(p.serviceNowConfiguration) || (p.serviceNowConfiguration, void 0), visitedObjects.has(p.sharePointConfiguration) || (p.sharePointConfiguration, void 0), visitedObjects.has(p.webCrawlerConfiguration) || (p.webCrawlerConfiguration, void 0), visitedObjects.has(p.workDocsConfiguration) || (p.workDocsConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_DataSourceToIndexFieldMappingProperty(p) {
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_DataSourceVpcConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_DatabaseConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columnConfiguration) || (p.columnConfiguration, void 0), visitedObjects.has(p.connectionConfiguration) || (p.connectionConfiguration, void 0), visitedObjects.has(p.aclConfiguration) || (p.aclConfiguration, void 0), visitedObjects.has(p.sqlConfiguration) || (p.sqlConfiguration, void 0), visitedObjects.has(p.vpcConfiguration) || (p.vpcConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_DocumentAttributeConditionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.conditionOnValue) || (p.conditionOnValue, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_DocumentAttributeTargetProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.targetDocumentAttributeValue) || (p.targetDocumentAttributeValue, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_DocumentAttributeValueProperty(p) {
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_DocumentsMetadataConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_GoogleDriveConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldMappings) || (p.fieldMappings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_HookConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.invocationCondition) || (p.invocationCondition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_InlineCustomDocumentEnrichmentConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.condition) || (p.condition, void 0), visitedObjects.has(p.target) || (p.target, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_OneDriveConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.oneDriveUsers) || (p.oneDriveUsers, void 0), visitedObjects.has(p.fieldMappings) || (p.fieldMappings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_OneDriveUsersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.oneDriveUserS3Path) || (p.oneDriveUserS3Path, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_ProxyConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_S3DataSourceConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.accessControlListConfiguration) || (p.accessControlListConfiguration, void 0), visitedObjects.has(p.documentsMetadataConfiguration) || (p.documentsMetadataConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_S3PathProperty(p) {
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_SalesforceChatterFeedConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldMappings) || (p.fieldMappings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_SalesforceConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.chatterFeedConfiguration) || (p.chatterFeedConfiguration, void 0), visitedObjects.has(p.knowledgeArticleConfiguration) || (p.knowledgeArticleConfiguration, void 0), visitedObjects.has(p.standardObjectAttachmentConfiguration) || (p.standardObjectAttachmentConfiguration, void 0), visitedObjects.has(p.standardObjectConfigurations) || (p.standardObjectConfigurations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_SalesforceCustomKnowledgeArticleTypeConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldMappings) || (p.fieldMappings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_SalesforceKnowledgeArticleConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customKnowledgeArticleTypeConfigurations) || (p.customKnowledgeArticleTypeConfigurations, void 0), visitedObjects.has(p.standardKnowledgeArticleTypeConfiguration) || (p.standardKnowledgeArticleTypeConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_SalesforceStandardKnowledgeArticleTypeConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldMappings) || (p.fieldMappings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_SalesforceStandardObjectAttachmentConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldMappings) || (p.fieldMappings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_SalesforceStandardObjectConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldMappings) || (p.fieldMappings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_ServiceNowConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.knowledgeArticleConfiguration) || (p.knowledgeArticleConfiguration, void 0), visitedObjects.has(p.serviceCatalogConfiguration) || (p.serviceCatalogConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_ServiceNowKnowledgeArticleConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldMappings) || (p.fieldMappings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_ServiceNowServiceCatalogConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldMappings) || (p.fieldMappings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_SharePointConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldMappings) || (p.fieldMappings, void 0), visitedObjects.has(p.sslCertificateS3Path) || (p.sslCertificateS3Path, void 0), visitedObjects.has(p.vpcConfiguration) || (p.vpcConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_SqlConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_WebCrawlerAuthenticationConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.basicAuthentication) || (p.basicAuthentication, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_WebCrawlerBasicAuthenticationProperty(p) {
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_WebCrawlerConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.urls) || (p.urls, void 0), visitedObjects.has(p.authenticationConfiguration) || (p.authenticationConfiguration, void 0), visitedObjects.has(p.proxyConfiguration) || (p.proxyConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_WebCrawlerSeedUrlConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_WebCrawlerSiteMapsConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_WebCrawlerUrlsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.seedUrlConfiguration) || (p.seedUrlConfiguration, void 0), visitedObjects.has(p.siteMapsConfiguration) || (p.siteMapsConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnDataSource_WorkDocsConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldMappings) || (p.fieldMappings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnFaqProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.s3Path) || (p.s3Path, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnFaq(p) {
    }
    function aws_cdk_lib_aws_kendra_CfnFaq_S3PathProperty(p) {
    }
    function aws_cdk_lib_aws_kendra_CfnIndexProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.capacityUnits) || (p.capacityUnits, void 0), visitedObjects.has(p.documentMetadataConfigurations) || (p.documentMetadataConfigurations, void 0), visitedObjects.has(p.serverSideEncryptionConfiguration) || (p.serverSideEncryptionConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.userTokenConfigurations) || (p.userTokenConfigurations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnIndex(p) {
    }
    function aws_cdk_lib_aws_kendra_CfnIndex_CapacityUnitsConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kendra_CfnIndex_DocumentMetadataConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.relevance) || (p.relevance, void 0), visitedObjects.has(p.search) || (p.search, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnIndex_JsonTokenTypeConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kendra_CfnIndex_JwtTokenTypeConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kendra_CfnIndex_RelevanceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.valueImportanceItems) || (p.valueImportanceItems, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnIndex_SearchProperty(p) {
    }
    function aws_cdk_lib_aws_kendra_CfnIndex_ServerSideEncryptionConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kendra_CfnIndex_UserTokenConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.jsonTokenTypeConfiguration) || (p.jsonTokenTypeConfiguration, void 0), visitedObjects.has(p.jwtTokenTypeConfiguration) || (p.jwtTokenTypeConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendra_CfnIndex_ValueImportanceItemProperty(p) {
    }
    function aws_cdk_lib_aws_kendraranking_CfnExecutionPlanProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.capacityUnits) || (p.capacityUnits, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kendraranking_CfnExecutionPlan(p) {
    }
    function aws_cdk_lib_aws_kendraranking_CfnExecutionPlan_CapacityUnitsConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kinesis_IStream(p) {
    }
    function aws_cdk_lib_aws_kinesis_StreamAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.encryptionKey) || (p.encryptionKey, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesis_StreamProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.encryption) || (p.encryption, void 0), visitedObjects.has(p.encryptionKey) || (p.encryptionKey, void 0), visitedObjects.has(p.retentionPeriod) || (p.retentionPeriod, void 0), visitedObjects.has(p.streamMode) || (p.streamMode, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesis_Stream(p) {
    }
    function aws_cdk_lib_aws_kinesis_StreamEncryption(p) {
    }
    function aws_cdk_lib_aws_kinesis_StreamMode(p) {
    }
    function aws_cdk_lib_aws_kinesis_CfnStreamProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.streamEncryption) || (p.streamEncryption, void 0), visitedObjects.has(p.streamModeDetails) || (p.streamModeDetails, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesis_CfnStream(p) {
    }
    function aws_cdk_lib_aws_kinesis_CfnStream_StreamEncryptionProperty(p) {
    }
    function aws_cdk_lib_aws_kinesis_CfnStream_StreamModeDetailsProperty(p) {
    }
    function aws_cdk_lib_aws_kinesis_CfnStreamConsumerProps(p) {
    }
    function aws_cdk_lib_aws_kinesis_CfnStreamConsumer(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.inputs) || (p.inputs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplication(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplication_CSVMappingParametersProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplication_InputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.inputSchema) || (p.inputSchema, void 0), visitedObjects.has(p.inputParallelism) || (p.inputParallelism, void 0), visitedObjects.has(p.inputProcessingConfiguration) || (p.inputProcessingConfiguration, void 0), visitedObjects.has(p.kinesisFirehoseInput) || (p.kinesisFirehoseInput, void 0), visitedObjects.has(p.kinesisStreamsInput) || (p.kinesisStreamsInput, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplication_InputLambdaProcessorProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplication_InputParallelismProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplication_InputProcessingConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.inputLambdaProcessor) || (p.inputLambdaProcessor, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplication_InputSchemaProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.recordColumns) || (p.recordColumns, void 0), visitedObjects.has(p.recordFormat) || (p.recordFormat, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplication_JSONMappingParametersProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplication_KinesisFirehoseInputProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplication_KinesisStreamsInputProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplication_MappingParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.csvMappingParameters) || (p.csvMappingParameters, void 0), visitedObjects.has(p.jsonMappingParameters) || (p.jsonMappingParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplication_RecordColumnProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplication_RecordFormatProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.mappingParameters) || (p.mappingParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationOutputProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.output) || (p.output, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationOutput(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationOutput_DestinationSchemaProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationOutput_KinesisFirehoseOutputProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationOutput_KinesisStreamsOutputProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationOutput_LambdaOutputProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationOutput_OutputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destinationSchema) || (p.destinationSchema, void 0), visitedObjects.has(p.kinesisFirehoseOutput) || (p.kinesisFirehoseOutput, void 0), visitedObjects.has(p.kinesisStreamsOutput) || (p.kinesisStreamsOutput, void 0), visitedObjects.has(p.lambdaOutput) || (p.lambdaOutput, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.referenceDataSource) || (p.referenceDataSource, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSource(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSource_CSVMappingParametersProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSource_JSONMappingParametersProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSource_MappingParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.csvMappingParameters) || (p.csvMappingParameters, void 0), visitedObjects.has(p.jsonMappingParameters) || (p.jsonMappingParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSource_RecordColumnProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSource_RecordFormatProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.mappingParameters) || (p.mappingParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSource_ReferenceDataSourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.referenceSchema) || (p.referenceSchema, void 0), visitedObjects.has(p.s3ReferenceDataSource) || (p.s3ReferenceDataSource, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSource_ReferenceSchemaProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.recordColumns) || (p.recordColumns, void 0), visitedObjects.has(p.recordFormat) || (p.recordFormat, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSource_S3ReferenceDataSourceProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2Props(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.applicationConfiguration) || (p.applicationConfiguration, void 0), visitedObjects.has(p.applicationMaintenanceConfiguration) || (p.applicationMaintenanceConfiguration, void 0), visitedObjects.has(p.runConfiguration) || (p.runConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_ApplicationCodeConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.codeContent) || (p.codeContent, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_ApplicationConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.applicationCodeConfiguration) || (p.applicationCodeConfiguration, void 0), visitedObjects.has(p.applicationSnapshotConfiguration) || (p.applicationSnapshotConfiguration, void 0), visitedObjects.has(p.environmentProperties) || (p.environmentProperties, void 0), visitedObjects.has(p.flinkApplicationConfiguration) || (p.flinkApplicationConfiguration, void 0), visitedObjects.has(p.sqlApplicationConfiguration) || (p.sqlApplicationConfiguration, void 0), visitedObjects.has(p.vpcConfigurations) || (p.vpcConfigurations, void 0), visitedObjects.has(p.zeppelinApplicationConfiguration) || (p.zeppelinApplicationConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_ApplicationMaintenanceConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_ApplicationRestoreConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_ApplicationSnapshotConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_CSVMappingParametersProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_CatalogConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.glueDataCatalogConfiguration) || (p.glueDataCatalogConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_CheckpointConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_CodeContentProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3ContentLocation) || (p.s3ContentLocation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_CustomArtifactConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.mavenReference) || (p.mavenReference, void 0), visitedObjects.has(p.s3ContentLocation) || (p.s3ContentLocation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_DeployAsApplicationConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3ContentLocation) || (p.s3ContentLocation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_EnvironmentPropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.propertyGroups) || (p.propertyGroups, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_FlinkApplicationConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.checkpointConfiguration) || (p.checkpointConfiguration, void 0), visitedObjects.has(p.monitoringConfiguration) || (p.monitoringConfiguration, void 0), visitedObjects.has(p.parallelismConfiguration) || (p.parallelismConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_FlinkRunConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_GlueDataCatalogConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_InputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.inputSchema) || (p.inputSchema, void 0), visitedObjects.has(p.inputParallelism) || (p.inputParallelism, void 0), visitedObjects.has(p.inputProcessingConfiguration) || (p.inputProcessingConfiguration, void 0), visitedObjects.has(p.kinesisFirehoseInput) || (p.kinesisFirehoseInput, void 0), visitedObjects.has(p.kinesisStreamsInput) || (p.kinesisStreamsInput, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_InputLambdaProcessorProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_InputParallelismProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_InputProcessingConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.inputLambdaProcessor) || (p.inputLambdaProcessor, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_InputSchemaProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.recordColumns) || (p.recordColumns, void 0), visitedObjects.has(p.recordFormat) || (p.recordFormat, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_JSONMappingParametersProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_KinesisFirehoseInputProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_KinesisStreamsInputProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_MappingParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.csvMappingParameters) || (p.csvMappingParameters, void 0), visitedObjects.has(p.jsonMappingParameters) || (p.jsonMappingParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_MavenReferenceProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_MonitoringConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_ParallelismConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_PropertyGroupProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.propertyMap) || (p.propertyMap, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_RecordColumnProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_RecordFormatProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.mappingParameters) || (p.mappingParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_RunConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.applicationRestoreConfiguration) || (p.applicationRestoreConfiguration, void 0), visitedObjects.has(p.flinkRunConfiguration) || (p.flinkRunConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_S3ContentBaseLocationProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_S3ContentLocationProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_SqlApplicationConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.inputs) || (p.inputs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_VpcConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_ZeppelinApplicationConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.catalogConfiguration) || (p.catalogConfiguration, void 0), visitedObjects.has(p.customArtifactsConfiguration) || (p.customArtifactsConfiguration, void 0), visitedObjects.has(p.deployAsApplicationConfiguration) || (p.deployAsApplicationConfiguration, void 0), visitedObjects.has(p.monitoringConfiguration) || (p.monitoringConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_ZeppelinMonitoringConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationCloudWatchLoggingOptionV2Props(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cloudWatchLoggingOption) || (p.cloudWatchLoggingOption, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationCloudWatchLoggingOptionV2(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationCloudWatchLoggingOptionV2_CloudWatchLoggingOptionProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationOutputV2Props(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.output) || (p.output, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationOutputV2(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationOutputV2_DestinationSchemaProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationOutputV2_KinesisFirehoseOutputProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationOutputV2_KinesisStreamsOutputProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationOutputV2_LambdaOutputProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationOutputV2_OutputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destinationSchema) || (p.destinationSchema, void 0), visitedObjects.has(p.kinesisFirehoseOutput) || (p.kinesisFirehoseOutput, void 0), visitedObjects.has(p.kinesisStreamsOutput) || (p.kinesisStreamsOutput, void 0), visitedObjects.has(p.lambdaOutput) || (p.lambdaOutput, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSourceV2Props(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.referenceDataSource) || (p.referenceDataSource, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSourceV2(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSourceV2_CSVMappingParametersProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSourceV2_JSONMappingParametersProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSourceV2_MappingParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.csvMappingParameters) || (p.csvMappingParameters, void 0), visitedObjects.has(p.jsonMappingParameters) || (p.jsonMappingParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSourceV2_RecordColumnProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSourceV2_RecordFormatProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.mappingParameters) || (p.mappingParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSourceV2_ReferenceDataSourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.referenceSchema) || (p.referenceSchema, void 0), visitedObjects.has(p.s3ReferenceDataSource) || (p.s3ReferenceDataSource, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSourceV2_ReferenceSchemaProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.recordColumns) || (p.recordColumns, void 0), visitedObjects.has(p.recordFormat) || (p.recordFormat, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSourceV2_S3ReferenceDataSourceProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.applicationConfiguration) || (p.applicationConfiguration, void 0), visitedObjects.has(p.applicationMaintenanceConfiguration) || (p.applicationMaintenanceConfiguration, void 0), visitedObjects.has(p.runConfiguration) || (p.runConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_ApplicationCodeConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.codeContent) || (p.codeContent, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_ApplicationConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.applicationCodeConfiguration) || (p.applicationCodeConfiguration, void 0), visitedObjects.has(p.applicationSnapshotConfiguration) || (p.applicationSnapshotConfiguration, void 0), visitedObjects.has(p.environmentProperties) || (p.environmentProperties, void 0), visitedObjects.has(p.flinkApplicationConfiguration) || (p.flinkApplicationConfiguration, void 0), visitedObjects.has(p.sqlApplicationConfiguration) || (p.sqlApplicationConfiguration, void 0), visitedObjects.has(p.vpcConfigurations) || (p.vpcConfigurations, void 0), visitedObjects.has(p.zeppelinApplicationConfiguration) || (p.zeppelinApplicationConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_ApplicationMaintenanceConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_ApplicationRestoreConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_ApplicationSnapshotConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_CSVMappingParametersProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_CatalogConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.glueDataCatalogConfiguration) || (p.glueDataCatalogConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_CheckpointConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_CodeContentProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3ContentLocation) || (p.s3ContentLocation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_CustomArtifactConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.mavenReference) || (p.mavenReference, void 0), visitedObjects.has(p.s3ContentLocation) || (p.s3ContentLocation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_DeployAsApplicationConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3ContentLocation) || (p.s3ContentLocation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_EnvironmentPropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.propertyGroups) || (p.propertyGroups, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_FlinkApplicationConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.checkpointConfiguration) || (p.checkpointConfiguration, void 0), visitedObjects.has(p.monitoringConfiguration) || (p.monitoringConfiguration, void 0), visitedObjects.has(p.parallelismConfiguration) || (p.parallelismConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_FlinkRunConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_GlueDataCatalogConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_InputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.inputSchema) || (p.inputSchema, void 0), visitedObjects.has(p.inputParallelism) || (p.inputParallelism, void 0), visitedObjects.has(p.inputProcessingConfiguration) || (p.inputProcessingConfiguration, void 0), visitedObjects.has(p.kinesisFirehoseInput) || (p.kinesisFirehoseInput, void 0), visitedObjects.has(p.kinesisStreamsInput) || (p.kinesisStreamsInput, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_InputLambdaProcessorProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_InputParallelismProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_InputProcessingConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.inputLambdaProcessor) || (p.inputLambdaProcessor, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_InputSchemaProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.recordColumns) || (p.recordColumns, void 0), visitedObjects.has(p.recordFormat) || (p.recordFormat, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_JSONMappingParametersProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_KinesisFirehoseInputProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_KinesisStreamsInputProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_MappingParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.csvMappingParameters) || (p.csvMappingParameters, void 0), visitedObjects.has(p.jsonMappingParameters) || (p.jsonMappingParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_MavenReferenceProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_MonitoringConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_ParallelismConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_PropertyGroupProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.propertyMap) || (p.propertyMap, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_RecordColumnProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_RecordFormatProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.mappingParameters) || (p.mappingParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_RunConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.applicationRestoreConfiguration) || (p.applicationRestoreConfiguration, void 0), visitedObjects.has(p.flinkRunConfiguration) || (p.flinkRunConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_S3ContentBaseLocationProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_S3ContentLocationProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_SqlApplicationConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.inputs) || (p.inputs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_VpcConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_ZeppelinApplicationConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.catalogConfiguration) || (p.catalogConfiguration, void 0), visitedObjects.has(p.customArtifactsConfiguration) || (p.customArtifactsConfiguration, void 0), visitedObjects.has(p.deployAsApplicationConfiguration) || (p.deployAsApplicationConfiguration, void 0), visitedObjects.has(p.monitoringConfiguration) || (p.monitoringConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_ZeppelinMonitoringConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationCloudWatchLoggingOptionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cloudWatchLoggingOption) || (p.cloudWatchLoggingOption, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationCloudWatchLoggingOption(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationCloudWatchLoggingOption_CloudWatchLoggingOptionProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationOutputProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.output) || (p.output, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationOutput(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationOutput_DestinationSchemaProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationOutput_KinesisFirehoseOutputProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationOutput_KinesisStreamsOutputProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationOutput_LambdaOutputProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationOutput_OutputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destinationSchema) || (p.destinationSchema, void 0), visitedObjects.has(p.kinesisFirehoseOutput) || (p.kinesisFirehoseOutput, void 0), visitedObjects.has(p.kinesisStreamsOutput) || (p.kinesisStreamsOutput, void 0), visitedObjects.has(p.lambdaOutput) || (p.lambdaOutput, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationReferenceDataSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.referenceDataSource) || (p.referenceDataSource, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationReferenceDataSource(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationReferenceDataSource_CSVMappingParametersProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationReferenceDataSource_JSONMappingParametersProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationReferenceDataSource_MappingParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.csvMappingParameters) || (p.csvMappingParameters, void 0), visitedObjects.has(p.jsonMappingParameters) || (p.jsonMappingParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationReferenceDataSource_RecordColumnProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationReferenceDataSource_RecordFormatProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.mappingParameters) || (p.mappingParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationReferenceDataSource_ReferenceDataSourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.referenceSchema) || (p.referenceSchema, void 0), visitedObjects.has(p.s3ReferenceDataSource) || (p.s3ReferenceDataSource, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationReferenceDataSource_ReferenceSchemaProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.recordColumns) || (p.recordColumns, void 0), visitedObjects.has(p.recordFormat) || (p.recordFormat, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationReferenceDataSource_S3ReferenceDataSourceProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStreamProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.amazonOpenSearchServerlessDestinationConfiguration) || (p.amazonOpenSearchServerlessDestinationConfiguration, void 0), visitedObjects.has(p.amazonopensearchserviceDestinationConfiguration) || (p.amazonopensearchserviceDestinationConfiguration, void 0), visitedObjects.has(p.deliveryStreamEncryptionConfigurationInput) || (p.deliveryStreamEncryptionConfigurationInput, void 0), visitedObjects.has(p.elasticsearchDestinationConfiguration) || (p.elasticsearchDestinationConfiguration, void 0), visitedObjects.has(p.extendedS3DestinationConfiguration) || (p.extendedS3DestinationConfiguration, void 0), visitedObjects.has(p.httpEndpointDestinationConfiguration) || (p.httpEndpointDestinationConfiguration, void 0), visitedObjects.has(p.kinesisStreamSourceConfiguration) || (p.kinesisStreamSourceConfiguration, void 0), visitedObjects.has(p.redshiftDestinationConfiguration) || (p.redshiftDestinationConfiguration, void 0), visitedObjects.has(p.s3DestinationConfiguration) || (p.s3DestinationConfiguration, void 0), visitedObjects.has(p.splunkDestinationConfiguration) || (p.splunkDestinationConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream(p) {
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_AmazonOpenSearchServerlessBufferingHintsProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_AmazonOpenSearchServerlessDestinationConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3Configuration) || (p.s3Configuration, void 0), visitedObjects.has(p.bufferingHints) || (p.bufferingHints, void 0), visitedObjects.has(p.cloudWatchLoggingOptions) || (p.cloudWatchLoggingOptions, void 0), visitedObjects.has(p.processingConfiguration) || (p.processingConfiguration, void 0), visitedObjects.has(p.retryOptions) || (p.retryOptions, void 0), visitedObjects.has(p.vpcConfiguration) || (p.vpcConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_AmazonOpenSearchServerlessRetryOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_AmazonopensearchserviceBufferingHintsProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_AmazonopensearchserviceDestinationConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3Configuration) || (p.s3Configuration, void 0), visitedObjects.has(p.bufferingHints) || (p.bufferingHints, void 0), visitedObjects.has(p.cloudWatchLoggingOptions) || (p.cloudWatchLoggingOptions, void 0), visitedObjects.has(p.documentIdOptions) || (p.documentIdOptions, void 0), visitedObjects.has(p.processingConfiguration) || (p.processingConfiguration, void 0), visitedObjects.has(p.retryOptions) || (p.retryOptions, void 0), visitedObjects.has(p.vpcConfiguration) || (p.vpcConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_AmazonopensearchserviceRetryOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_BufferingHintsProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_CloudWatchLoggingOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_CopyCommandProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_DataFormatConversionConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.inputFormatConfiguration) || (p.inputFormatConfiguration, void 0), visitedObjects.has(p.outputFormatConfiguration) || (p.outputFormatConfiguration, void 0), visitedObjects.has(p.schemaConfiguration) || (p.schemaConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_DeliveryStreamEncryptionConfigurationInputProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_DeserializerProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.hiveJsonSerDe) || (p.hiveJsonSerDe, void 0), visitedObjects.has(p.openXJsonSerDe) || (p.openXJsonSerDe, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_DocumentIdOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_DynamicPartitioningConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.retryOptions) || (p.retryOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_ElasticsearchBufferingHintsProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_ElasticsearchDestinationConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3Configuration) || (p.s3Configuration, void 0), visitedObjects.has(p.bufferingHints) || (p.bufferingHints, void 0), visitedObjects.has(p.cloudWatchLoggingOptions) || (p.cloudWatchLoggingOptions, void 0), visitedObjects.has(p.documentIdOptions) || (p.documentIdOptions, void 0), visitedObjects.has(p.processingConfiguration) || (p.processingConfiguration, void 0), visitedObjects.has(p.retryOptions) || (p.retryOptions, void 0), visitedObjects.has(p.vpcConfiguration) || (p.vpcConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_ElasticsearchRetryOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_EncryptionConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.kmsEncryptionConfig) || (p.kmsEncryptionConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_ExtendedS3DestinationConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bufferingHints) || (p.bufferingHints, void 0), visitedObjects.has(p.cloudWatchLoggingOptions) || (p.cloudWatchLoggingOptions, void 0), visitedObjects.has(p.dataFormatConversionConfiguration) || (p.dataFormatConversionConfiguration, void 0), visitedObjects.has(p.dynamicPartitioningConfiguration) || (p.dynamicPartitioningConfiguration, void 0), visitedObjects.has(p.encryptionConfiguration) || (p.encryptionConfiguration, void 0), visitedObjects.has(p.processingConfiguration) || (p.processingConfiguration, void 0), visitedObjects.has(p.s3BackupConfiguration) || (p.s3BackupConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_HiveJsonSerDeProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_HttpEndpointCommonAttributeProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_HttpEndpointConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_HttpEndpointDestinationConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.endpointConfiguration) || (p.endpointConfiguration, void 0), visitedObjects.has(p.s3Configuration) || (p.s3Configuration, void 0), visitedObjects.has(p.bufferingHints) || (p.bufferingHints, void 0), visitedObjects.has(p.cloudWatchLoggingOptions) || (p.cloudWatchLoggingOptions, void 0), visitedObjects.has(p.processingConfiguration) || (p.processingConfiguration, void 0), visitedObjects.has(p.requestConfiguration) || (p.requestConfiguration, void 0), visitedObjects.has(p.retryOptions) || (p.retryOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_HttpEndpointRequestConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.commonAttributes) || (p.commonAttributes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_InputFormatConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.deserializer) || (p.deserializer, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_KMSEncryptionConfigProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_KinesisStreamSourceConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_OpenXJsonSerDeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columnToJsonKeyMappings) || (p.columnToJsonKeyMappings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_OrcSerDeProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_OutputFormatConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.serializer) || (p.serializer, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_ParquetSerDeProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_ProcessingConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.processors) || (p.processors, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_ProcessorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.parameters) || (p.parameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_ProcessorParameterProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_RedshiftDestinationConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.copyCommand) || (p.copyCommand, void 0), visitedObjects.has(p.s3Configuration) || (p.s3Configuration, void 0), visitedObjects.has(p.cloudWatchLoggingOptions) || (p.cloudWatchLoggingOptions, void 0), visitedObjects.has(p.processingConfiguration) || (p.processingConfiguration, void 0), visitedObjects.has(p.retryOptions) || (p.retryOptions, void 0), visitedObjects.has(p.s3BackupConfiguration) || (p.s3BackupConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_RedshiftRetryOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_RetryOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_S3DestinationConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bufferingHints) || (p.bufferingHints, void 0), visitedObjects.has(p.cloudWatchLoggingOptions) || (p.cloudWatchLoggingOptions, void 0), visitedObjects.has(p.encryptionConfiguration) || (p.encryptionConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_SchemaConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_SerializerProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.orcSerDe) || (p.orcSerDe, void 0), visitedObjects.has(p.parquetSerDe) || (p.parquetSerDe, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_SplunkDestinationConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3Configuration) || (p.s3Configuration, void 0), visitedObjects.has(p.cloudWatchLoggingOptions) || (p.cloudWatchLoggingOptions, void 0), visitedObjects.has(p.processingConfiguration) || (p.processingConfiguration, void 0), visitedObjects.has(p.retryOptions) || (p.retryOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_SplunkRetryOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_VpcConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_kinesisvideo_CfnSignalingChannelProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisvideo_CfnSignalingChannel(p) {
    }
    function aws_cdk_lib_aws_kinesisvideo_CfnStreamProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kinesisvideo_CfnStream(p) {
    }
    function aws_cdk_lib_aws_kms_IKey(p) {
    }
    function aws_cdk_lib_aws_kms_KeySpec(p) {
    }
    function aws_cdk_lib_aws_kms_KeyUsage(p) {
    }
    function aws_cdk_lib_aws_kms_KeyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.admins != null)
            for (const o of p.admins)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.keySpec) || (p.keySpec, void 0), visitedObjects.has(p.keyUsage) || (p.keyUsage, void 0), visitedObjects.has(p.pendingWindow) || (p.pendingWindow, void 0), visitedObjects.has(p.policy) || (p.policy, void 0), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kms_Key(p) {
    }
    function aws_cdk_lib_aws_kms_KeyLookupOptions(p) {
    }
    function aws_cdk_lib_aws_kms_IAlias(p) {
    }
    function aws_cdk_lib_aws_kms_AliasProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.targetKey) || (p.targetKey, void 0), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kms_AliasAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.aliasTargetKey) || (p.aliasTargetKey, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kms_Alias(p) {
    }
    function aws_cdk_lib_aws_kms_ViaServicePrincipal(p) {
    }
    function aws_cdk_lib_aws_kms_CfnAliasProps(p) {
    }
    function aws_cdk_lib_aws_kms_CfnAlias(p) {
    }
    function aws_cdk_lib_aws_kms_CfnKeyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kms_CfnKey(p) {
    }
    function aws_cdk_lib_aws_kms_CfnReplicaKeyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_kms_CfnReplicaKey(p) {
    }
    function aws_cdk_lib_aws_lakeformation_CfnDataCellsFilterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columnWildcard) || (p.columnWildcard, void 0), visitedObjects.has(p.rowFilter) || (p.rowFilter, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lakeformation_CfnDataCellsFilter(p) {
    }
    function aws_cdk_lib_aws_lakeformation_CfnDataCellsFilter_ColumnWildcardProperty(p) {
    }
    function aws_cdk_lib_aws_lakeformation_CfnDataCellsFilter_RowFilterProperty(p) {
    }
    function aws_cdk_lib_aws_lakeformation_CfnDataLakeSettingsProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.admins) || (p.admins, void 0), visitedObjects.has(p.createDatabaseDefaultPermissions) || (p.createDatabaseDefaultPermissions, void 0), visitedObjects.has(p.createTableDefaultPermissions) || (p.createTableDefaultPermissions, void 0), visitedObjects.has(p.externalDataFilteringAllowList) || (p.externalDataFilteringAllowList, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lakeformation_CfnDataLakeSettings(p) {
    }
    function aws_cdk_lib_aws_lakeformation_CfnDataLakeSettings_DataLakePrincipalProperty(p) {
    }
    function aws_cdk_lib_aws_lakeformation_CfnDataLakeSettings_PrincipalPermissionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.principal) || (p.principal, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lakeformation_CfnPermissionsProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataLakePrincipal) || (p.dataLakePrincipal, void 0), visitedObjects.has(p.resource) || (p.resource, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lakeformation_CfnPermissions(p) {
    }
    function aws_cdk_lib_aws_lakeformation_CfnPermissions_ColumnWildcardProperty(p) {
    }
    function aws_cdk_lib_aws_lakeformation_CfnPermissions_DataLakePrincipalProperty(p) {
    }
    function aws_cdk_lib_aws_lakeformation_CfnPermissions_DataLocationResourceProperty(p) {
    }
    function aws_cdk_lib_aws_lakeformation_CfnPermissions_DatabaseResourceProperty(p) {
    }
    function aws_cdk_lib_aws_lakeformation_CfnPermissions_ResourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.databaseResource) || (p.databaseResource, void 0), visitedObjects.has(p.dataLocationResource) || (p.dataLocationResource, void 0), visitedObjects.has(p.tableResource) || (p.tableResource, void 0), visitedObjects.has(p.tableWithColumnsResource) || (p.tableWithColumnsResource, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lakeformation_CfnPermissions_TableResourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tableWildcard) || (p.tableWildcard, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lakeformation_CfnPermissions_TableWildcardProperty(p) {
    }
    function aws_cdk_lib_aws_lakeformation_CfnPermissions_TableWithColumnsResourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columnWildcard) || (p.columnWildcard, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lakeformation_CfnPrincipalPermissionsProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.principal) || (p.principal, void 0), visitedObjects.has(p.resource) || (p.resource, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lakeformation_CfnPrincipalPermissions(p) {
    }
    function aws_cdk_lib_aws_lakeformation_CfnPrincipalPermissions_ColumnWildcardProperty(p) {
    }
    function aws_cdk_lib_aws_lakeformation_CfnPrincipalPermissions_DataCellsFilterResourceProperty(p) {
    }
    function aws_cdk_lib_aws_lakeformation_CfnPrincipalPermissions_DataLakePrincipalProperty(p) {
    }
    function aws_cdk_lib_aws_lakeformation_CfnPrincipalPermissions_DataLocationResourceProperty(p) {
    }
    function aws_cdk_lib_aws_lakeformation_CfnPrincipalPermissions_DatabaseResourceProperty(p) {
    }
    function aws_cdk_lib_aws_lakeformation_CfnPrincipalPermissions_LFTagProperty(p) {
    }
    function aws_cdk_lib_aws_lakeformation_CfnPrincipalPermissions_LFTagKeyResourceProperty(p) {
    }
    function aws_cdk_lib_aws_lakeformation_CfnPrincipalPermissions_LFTagPolicyResourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.expression) || (p.expression, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lakeformation_CfnPrincipalPermissions_ResourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.database) || (p.database, void 0), visitedObjects.has(p.dataCellsFilter) || (p.dataCellsFilter, void 0), visitedObjects.has(p.dataLocation) || (p.dataLocation, void 0), visitedObjects.has(p.lfTag) || (p.lfTag, void 0), visitedObjects.has(p.lfTagPolicy) || (p.lfTagPolicy, void 0), visitedObjects.has(p.table) || (p.table, void 0), visitedObjects.has(p.tableWithColumns) || (p.tableWithColumns, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lakeformation_CfnPrincipalPermissions_TableResourceProperty(p) {
    }
    function aws_cdk_lib_aws_lakeformation_CfnPrincipalPermissions_TableWithColumnsResourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columnWildcard) || (p.columnWildcard, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lakeformation_CfnResourceProps(p) {
    }
    function aws_cdk_lib_aws_lakeformation_CfnResource(p) {
    }
    function aws_cdk_lib_aws_lakeformation_CfnTagProps(p) {
    }
    function aws_cdk_lib_aws_lakeformation_CfnTag(p) {
    }
    function aws_cdk_lib_aws_lakeformation_CfnTagAssociationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.lfTags) || (p.lfTags, void 0), visitedObjects.has(p.resource) || (p.resource, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lakeformation_CfnTagAssociation(p) {
    }
    function aws_cdk_lib_aws_lakeformation_CfnTagAssociation_DatabaseResourceProperty(p) {
    }
    function aws_cdk_lib_aws_lakeformation_CfnTagAssociation_LFTagPairProperty(p) {
    }
    function aws_cdk_lib_aws_lakeformation_CfnTagAssociation_ResourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.database) || (p.database, void 0), visitedObjects.has(p.table) || (p.table, void 0), visitedObjects.has(p.tableWithColumns) || (p.tableWithColumns, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lakeformation_CfnTagAssociation_TableResourceProperty(p) {
    }
    function aws_cdk_lib_aws_lakeformation_CfnTagAssociation_TableWithColumnsResourceProperty(p) {
    }
    function aws_cdk_lib_aws_lambda_AdotInstrumentationConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.execWrapper) || (p.execWrapper, void 0), visitedObjects.has(p.layerVersion) || (p.layerVersion, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_AdotLayerVersion(p) {
    }
    function aws_cdk_lib_aws_lambda_AdotLambdaExecWrapper(p) {
    }
    function aws_cdk_lib_aws_lambda_AdotLambdaLayerJavaSdkVersion(p) {
    }
    function aws_cdk_lib_aws_lambda_AdotLambdaLayerJavaAutoInstrumentationVersion(p) {
    }
    function aws_cdk_lib_aws_lambda_AdotLambdaLayerPythonSdkVersion(p) {
    }
    function aws_cdk_lib_aws_lambda_AdotLambdaLayerJavaScriptSdkVersion(p) {
    }
    function aws_cdk_lib_aws_lambda_AdotLambdaLayerGenericVersion(p) {
    }
    function aws_cdk_lib_aws_lambda_IAlias(p) {
    }
    function aws_cdk_lib_aws_lambda_AliasOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.additionalVersions != null)
            for (const o of p.additionalVersions)
              visitedObjects.has(o) || aws_cdk_lib_aws_lambda_VersionWeight(o);
          visitedObjects.has(p.maxEventAge) || (p.maxEventAge, void 0), visitedObjects.has(p.onFailure) || (p.onFailure, void 0), visitedObjects.has(p.onSuccess) || (p.onSuccess, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_AliasProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.version) || (p.version, void 0), p.additionalVersions != null)
            for (const o of p.additionalVersions)
              visitedObjects.has(o) || aws_cdk_lib_aws_lambda_VersionWeight(o);
          visitedObjects.has(p.maxEventAge) || (p.maxEventAge, void 0), visitedObjects.has(p.onFailure) || (p.onFailure, void 0), visitedObjects.has(p.onSuccess) || (p.onSuccess, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_AliasAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.aliasVersion) || (p.aliasVersion, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_Alias(p) {
    }
    function aws_cdk_lib_aws_lambda_VersionWeight(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.version) || (p.version, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_DlqDestinationConfig(p) {
    }
    function aws_cdk_lib_aws_lambda_IEventSourceDlq(p) {
    }
    function aws_cdk_lib_aws_lambda_IFunction(p) {
    }
    function aws_cdk_lib_aws_lambda_FunctionAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.architecture) || (p.architecture, void 0), visitedObjects.has(p.role) || (p.role, void 0), visitedObjects.has(p.securityGroup) || (p.securityGroup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_FunctionBase(p) {
    }
    function aws_cdk_lib_aws_lambda_QualifiedFunctionBase(p) {
    }
    function aws_cdk_lib_aws_lambda_Tracing(p) {
    }
    function aws_cdk_lib_aws_lambda_FunctionOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.adotInstrumentation) || aws_cdk_lib_aws_lambda_AdotInstrumentationConfig(p.adotInstrumentation), visitedObjects.has(p.architecture) || (p.architecture, void 0), visitedObjects.has(p.codeSigningConfig) || (p.codeSigningConfig, void 0), visitedObjects.has(p.currentVersionOptions) || aws_cdk_lib_aws_lambda_VersionOptions(p.currentVersionOptions), visitedObjects.has(p.deadLetterQueue) || (p.deadLetterQueue, void 0), visitedObjects.has(p.deadLetterTopic) || (p.deadLetterTopic, void 0), visitedObjects.has(p.environmentEncryption) || (p.environmentEncryption, void 0), visitedObjects.has(p.ephemeralStorageSize) || (p.ephemeralStorageSize, void 0), p.events != null)
            for (const o of p.events)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.filesystem) || (p.filesystem, void 0), p.initialPolicy != null)
            for (const o of p.initialPolicy)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.insightsVersion) || (p.insightsVersion, void 0), p.layers != null)
            for (const o of p.layers)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.logRetention) || (p.logRetention, void 0), visitedObjects.has(p.logRetentionRetryOptions) || aws_cdk_lib_aws_lambda_LogRetentionRetryOptions(p.logRetentionRetryOptions), visitedObjects.has(p.logRetentionRole) || (p.logRetentionRole, void 0), visitedObjects.has(p.profilingGroup) || (p.profilingGroup, void 0), visitedObjects.has(p.role) || (p.role, void 0), visitedObjects.has(p.runtimeManagementMode) || (p.runtimeManagementMode, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.timeout) || (p.timeout, void 0), visitedObjects.has(p.tracing) || (p.tracing, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets), visitedObjects.has(p.maxEventAge) || (p.maxEventAge, void 0), visitedObjects.has(p.onFailure) || (p.onFailure, void 0), visitedObjects.has(p.onSuccess) || (p.onSuccess, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_FunctionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.code) || (p.code, void 0), visitedObjects.has(p.runtime) || (p.runtime, void 0), visitedObjects.has(p.adotInstrumentation) || aws_cdk_lib_aws_lambda_AdotInstrumentationConfig(p.adotInstrumentation), visitedObjects.has(p.architecture) || (p.architecture, void 0), visitedObjects.has(p.codeSigningConfig) || (p.codeSigningConfig, void 0), visitedObjects.has(p.currentVersionOptions) || aws_cdk_lib_aws_lambda_VersionOptions(p.currentVersionOptions), visitedObjects.has(p.deadLetterQueue) || (p.deadLetterQueue, void 0), visitedObjects.has(p.deadLetterTopic) || (p.deadLetterTopic, void 0), visitedObjects.has(p.environmentEncryption) || (p.environmentEncryption, void 0), visitedObjects.has(p.ephemeralStorageSize) || (p.ephemeralStorageSize, void 0), p.events != null)
            for (const o of p.events)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.filesystem) || (p.filesystem, void 0), p.initialPolicy != null)
            for (const o of p.initialPolicy)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.insightsVersion) || (p.insightsVersion, void 0), p.layers != null)
            for (const o of p.layers)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.logRetention) || (p.logRetention, void 0), visitedObjects.has(p.logRetentionRetryOptions) || aws_cdk_lib_aws_lambda_LogRetentionRetryOptions(p.logRetentionRetryOptions), visitedObjects.has(p.logRetentionRole) || (p.logRetentionRole, void 0), visitedObjects.has(p.profilingGroup) || (p.profilingGroup, void 0), visitedObjects.has(p.role) || (p.role, void 0), visitedObjects.has(p.runtimeManagementMode) || (p.runtimeManagementMode, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.timeout) || (p.timeout, void 0), visitedObjects.has(p.tracing) || (p.tracing, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets), visitedObjects.has(p.maxEventAge) || (p.maxEventAge, void 0), visitedObjects.has(p.onFailure) || (p.onFailure, void 0), visitedObjects.has(p.onSuccess) || (p.onSuccess, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_Function(p) {
    }
    function aws_cdk_lib_aws_lambda_EnvironmentOptions(p) {
    }
    function aws_cdk_lib_aws_lambda_FunctionVersionUpgrade(p) {
    }
    function aws_cdk_lib_aws_lambda_Handler(p) {
    }
    function aws_cdk_lib_aws_lambda_DockerImageFunctionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.code) || (p.code, void 0), visitedObjects.has(p.adotInstrumentation) || aws_cdk_lib_aws_lambda_AdotInstrumentationConfig(p.adotInstrumentation), visitedObjects.has(p.architecture) || (p.architecture, void 0), visitedObjects.has(p.codeSigningConfig) || (p.codeSigningConfig, void 0), visitedObjects.has(p.currentVersionOptions) || aws_cdk_lib_aws_lambda_VersionOptions(p.currentVersionOptions), visitedObjects.has(p.deadLetterQueue) || (p.deadLetterQueue, void 0), visitedObjects.has(p.deadLetterTopic) || (p.deadLetterTopic, void 0), visitedObjects.has(p.environmentEncryption) || (p.environmentEncryption, void 0), visitedObjects.has(p.ephemeralStorageSize) || (p.ephemeralStorageSize, void 0), p.events != null)
            for (const o of p.events)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.filesystem) || (p.filesystem, void 0), p.initialPolicy != null)
            for (const o of p.initialPolicy)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.insightsVersion) || (p.insightsVersion, void 0), p.layers != null)
            for (const o of p.layers)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.logRetention) || (p.logRetention, void 0), visitedObjects.has(p.logRetentionRetryOptions) || aws_cdk_lib_aws_lambda_LogRetentionRetryOptions(p.logRetentionRetryOptions), visitedObjects.has(p.logRetentionRole) || (p.logRetentionRole, void 0), visitedObjects.has(p.profilingGroup) || (p.profilingGroup, void 0), visitedObjects.has(p.role) || (p.role, void 0), visitedObjects.has(p.runtimeManagementMode) || (p.runtimeManagementMode, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.timeout) || (p.timeout, void 0), visitedObjects.has(p.tracing) || (p.tracing, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets), visitedObjects.has(p.maxEventAge) || (p.maxEventAge, void 0), visitedObjects.has(p.onFailure) || (p.onFailure, void 0), visitedObjects.has(p.onSuccess) || (p.onSuccess, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_DockerImageCode(p) {
    }
    function aws_cdk_lib_aws_lambda_DockerImageFunction(p) {
    }
    function aws_cdk_lib_aws_lambda_LayerVersionOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_LayerVersionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.code) || (p.code, void 0), p.compatibleArchitectures != null)
            for (const o of p.compatibleArchitectures)
              visitedObjects.has(o) || void 0;
          if (p.compatibleRuntimes != null)
            for (const o of p.compatibleRuntimes)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_ILayerVersion(p) {
    }
    function aws_cdk_lib_aws_lambda_LayerVersionPermission(p) {
    }
    function aws_cdk_lib_aws_lambda_LayerVersionAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.compatibleRuntimes != null)
            for (const o of p.compatibleRuntimes)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_LayerVersion(p) {
    }
    function aws_cdk_lib_aws_lambda_Permission(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.principal) || (p.principal, void 0), visitedObjects.has(p.functionUrlAuthType) || (p.functionUrlAuthType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_LambdaRuntimeProps(p) {
    }
    function aws_cdk_lib_aws_lambda_RuntimeFamily(p) {
    }
    function aws_cdk_lib_aws_lambda_Runtime(p) {
    }
    function aws_cdk_lib_aws_lambda_Code(p) {
    }
    function aws_cdk_lib_aws_lambda_CodeConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.image) || (p.image, void 0), visitedObjects.has(p.s3Location) || (p.s3Location, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_CodeImageConfig(p) {
    }
    function aws_cdk_lib_aws_lambda_S3Code(p) {
    }
    function aws_cdk_lib_aws_lambda_InlineCode(p) {
    }
    function aws_cdk_lib_aws_lambda_AssetCode(p) {
    }
    function aws_cdk_lib_aws_lambda_ResourceBindOptions(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnParametersCodeProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bucketNameParam) || (p.bucketNameParam, void 0), visitedObjects.has(p.objectKeyParam) || (p.objectKeyParam, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_CfnParametersCode(p) {
    }
    function aws_cdk_lib_aws_lambda_EcrImageCodeProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          "tag" in p && print("aws-cdk-lib.aws_lambda.EcrImageCodeProps#tag", "use `tagOrDigest`");
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_EcrImageCode(p) {
    }
    function aws_cdk_lib_aws_lambda_AssetImageCodeProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.cacheFrom != null)
            for (const o of p.cacheFrom)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.cacheTo) || (p.cacheTo, void 0), visitedObjects.has(p.invalidation) || (p.invalidation, void 0), visitedObjects.has(p.networkMode) || (p.networkMode, void 0), visitedObjects.has(p.platform) || (p.platform, void 0), visitedObjects.has(p.followSymlinks) || (p.followSymlinks, void 0), visitedObjects.has(p.ignoreMode) || (p.ignoreMode, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_AssetImageCode(p) {
    }
    function aws_cdk_lib_aws_lambda_DockerBuildAssetOptions(p) {
    }
    function aws_cdk_lib_aws_lambda_FileSystemConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.connections) || (p.connections, void 0), p.policies != null)
            for (const o of p.policies)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_FileSystem(p) {
    }
    function aws_cdk_lib_aws_lambda_IVersion(p) {
    }
    function aws_cdk_lib_aws_lambda_VersionOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), visitedObjects.has(p.maxEventAge) || (p.maxEventAge, void 0), visitedObjects.has(p.onFailure) || (p.onFailure, void 0), visitedObjects.has(p.onSuccess) || (p.onSuccess, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_VersionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.lambda) || (p.lambda, void 0), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), visitedObjects.has(p.maxEventAge) || (p.maxEventAge, void 0), visitedObjects.has(p.onFailure) || (p.onFailure, void 0), visitedObjects.has(p.onSuccess) || (p.onSuccess, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_VersionAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.lambda) || (p.lambda, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_Version(p) {
    }
    function aws_cdk_lib_aws_lambda_SingletonFunctionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.code) || (p.code, void 0), visitedObjects.has(p.runtime) || (p.runtime, void 0), visitedObjects.has(p.adotInstrumentation) || aws_cdk_lib_aws_lambda_AdotInstrumentationConfig(p.adotInstrumentation), visitedObjects.has(p.architecture) || (p.architecture, void 0), visitedObjects.has(p.codeSigningConfig) || (p.codeSigningConfig, void 0), visitedObjects.has(p.currentVersionOptions) || aws_cdk_lib_aws_lambda_VersionOptions(p.currentVersionOptions), visitedObjects.has(p.deadLetterQueue) || (p.deadLetterQueue, void 0), visitedObjects.has(p.deadLetterTopic) || (p.deadLetterTopic, void 0), visitedObjects.has(p.environmentEncryption) || (p.environmentEncryption, void 0), visitedObjects.has(p.ephemeralStorageSize) || (p.ephemeralStorageSize, void 0), p.events != null)
            for (const o of p.events)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.filesystem) || (p.filesystem, void 0), p.initialPolicy != null)
            for (const o of p.initialPolicy)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.insightsVersion) || (p.insightsVersion, void 0), p.layers != null)
            for (const o of p.layers)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.logRetention) || (p.logRetention, void 0), visitedObjects.has(p.logRetentionRetryOptions) || aws_cdk_lib_aws_lambda_LogRetentionRetryOptions(p.logRetentionRetryOptions), visitedObjects.has(p.logRetentionRole) || (p.logRetentionRole, void 0), visitedObjects.has(p.profilingGroup) || (p.profilingGroup, void 0), visitedObjects.has(p.role) || (p.role, void 0), visitedObjects.has(p.runtimeManagementMode) || (p.runtimeManagementMode, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.timeout) || (p.timeout, void 0), visitedObjects.has(p.tracing) || (p.tracing, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets), visitedObjects.has(p.maxEventAge) || (p.maxEventAge, void 0), visitedObjects.has(p.onFailure) || (p.onFailure, void 0), visitedObjects.has(p.onSuccess) || (p.onSuccess, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_SingletonFunction(p) {
    }
    function aws_cdk_lib_aws_lambda_IEventSource(p) {
    }
    function aws_cdk_lib_aws_lambda_SourceAccessConfigurationType(p) {
    }
    function aws_cdk_lib_aws_lambda_SourceAccessConfiguration(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.type) || (p.type, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_EventSourceMappingOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.maxBatchingWindow) || (p.maxBatchingWindow, void 0), visitedObjects.has(p.maxRecordAge) || (p.maxRecordAge, void 0), visitedObjects.has(p.onFailure) || (p.onFailure, void 0), p.sourceAccessConfigurations != null)
            for (const o of p.sourceAccessConfigurations)
              visitedObjects.has(o) || aws_cdk_lib_aws_lambda_SourceAccessConfiguration(o);
          visitedObjects.has(p.startingPosition) || (p.startingPosition, void 0), visitedObjects.has(p.tumblingWindow) || (p.tumblingWindow, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_EventSourceMappingProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.target) || (p.target, void 0), visitedObjects.has(p.maxBatchingWindow) || (p.maxBatchingWindow, void 0), visitedObjects.has(p.maxRecordAge) || (p.maxRecordAge, void 0), visitedObjects.has(p.onFailure) || (p.onFailure, void 0), p.sourceAccessConfigurations != null)
            for (const o of p.sourceAccessConfigurations)
              visitedObjects.has(o) || aws_cdk_lib_aws_lambda_SourceAccessConfiguration(o);
          visitedObjects.has(p.startingPosition) || (p.startingPosition, void 0), visitedObjects.has(p.tumblingWindow) || (p.tumblingWindow, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_IEventSourceMapping(p) {
    }
    function aws_cdk_lib_aws_lambda_EventSourceMapping(p) {
    }
    function aws_cdk_lib_aws_lambda_StartingPosition(p) {
    }
    function aws_cdk_lib_aws_lambda_FilterRule(p) {
    }
    function aws_cdk_lib_aws_lambda_FilterCriteria(p) {
    }
    function aws_cdk_lib_aws_lambda_DestinationConfig(p) {
    }
    function aws_cdk_lib_aws_lambda_DestinationType(p) {
    }
    function aws_cdk_lib_aws_lambda_DestinationOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.type) || (p.type, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_IDestination(p) {
    }
    function aws_cdk_lib_aws_lambda_EventInvokeConfigOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.maxEventAge) || (p.maxEventAge, void 0), visitedObjects.has(p.onFailure) || (p.onFailure, void 0), visitedObjects.has(p.onSuccess) || (p.onSuccess, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_EventInvokeConfigProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.function) || (p.function, void 0), visitedObjects.has(p.maxEventAge) || (p.maxEventAge, void 0), visitedObjects.has(p.onFailure) || (p.onFailure, void 0), visitedObjects.has(p.onSuccess) || (p.onSuccess, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_EventInvokeConfig(p) {
    }
    function aws_cdk_lib_aws_lambda_IScalableFunctionAttribute(p) {
    }
    function aws_cdk_lib_aws_lambda_UtilizationScalingOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.scaleInCooldown) || (p.scaleInCooldown, void 0), visitedObjects.has(p.scaleOutCooldown) || (p.scaleOutCooldown, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_AutoScalingOptions(p) {
    }
    function aws_cdk_lib_aws_lambda_UntrustedArtifactOnDeployment(p) {
    }
    function aws_cdk_lib_aws_lambda_ICodeSigningConfig(p) {
    }
    function aws_cdk_lib_aws_lambda_CodeSigningConfigProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.signingProfiles != null)
            for (const o of p.signingProfiles)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.untrustedArtifactOnDeployment) || (p.untrustedArtifactOnDeployment, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_CodeSigningConfig(p) {
    }
    function aws_cdk_lib_aws_lambda_LambdaInsightsVersion(p) {
    }
    function aws_cdk_lib_aws_lambda_LogRetentionRetryOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.base) || (p.base, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_Architecture(p) {
    }
    function aws_cdk_lib_aws_lambda_FunctionUrlAuthType(p) {
    }
    function aws_cdk_lib_aws_lambda_HttpMethod(p) {
    }
    function aws_cdk_lib_aws_lambda_FunctionUrlCorsOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.allowedMethods != null)
            for (const o of p.allowedMethods)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.maxAge) || (p.maxAge, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_IFunctionUrl(p) {
    }
    function aws_cdk_lib_aws_lambda_FunctionUrlOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.authType) || (p.authType, void 0), visitedObjects.has(p.cors) || aws_cdk_lib_aws_lambda_FunctionUrlCorsOptions(p.cors);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_FunctionUrlProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.function) || (p.function, void 0), visitedObjects.has(p.authType) || (p.authType, void 0), visitedObjects.has(p.cors) || aws_cdk_lib_aws_lambda_FunctionUrlCorsOptions(p.cors);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_FunctionUrl(p) {
    }
    function aws_cdk_lib_aws_lambda_RuntimeManagementMode(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnAliasProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.provisionedConcurrencyConfig) || (p.provisionedConcurrencyConfig, void 0), visitedObjects.has(p.routingConfig) || (p.routingConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_CfnAlias(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnAlias_AliasRoutingConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.additionalVersionWeights) || (p.additionalVersionWeights, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_CfnAlias_ProvisionedConcurrencyConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnAlias_VersionWeightProperty(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnCodeSigningConfigProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.allowedPublishers) || (p.allowedPublishers, void 0), visitedObjects.has(p.codeSigningPolicies) || (p.codeSigningPolicies, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_CfnCodeSigningConfig(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnCodeSigningConfig_AllowedPublishersProperty(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnCodeSigningConfig_CodeSigningPoliciesProperty(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnEventInvokeConfigProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destinationConfig) || (p.destinationConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_CfnEventInvokeConfig(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnEventInvokeConfig_DestinationConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.onFailure) || (p.onFailure, void 0), visitedObjects.has(p.onSuccess) || (p.onSuccess, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_CfnEventInvokeConfig_OnFailureProperty(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnEventInvokeConfig_OnSuccessProperty(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnEventSourceMappingProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.amazonManagedKafkaEventSourceConfig) || (p.amazonManagedKafkaEventSourceConfig, void 0), visitedObjects.has(p.destinationConfig) || (p.destinationConfig, void 0), visitedObjects.has(p.documentDbEventSourceConfig) || (p.documentDbEventSourceConfig, void 0), visitedObjects.has(p.filterCriteria) || (p.filterCriteria, void 0), visitedObjects.has(p.scalingConfig) || (p.scalingConfig, void 0), visitedObjects.has(p.selfManagedEventSource) || (p.selfManagedEventSource, void 0), visitedObjects.has(p.selfManagedKafkaEventSourceConfig) || (p.selfManagedKafkaEventSourceConfig, void 0), visitedObjects.has(p.sourceAccessConfigurations) || (p.sourceAccessConfigurations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_CfnEventSourceMapping(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnEventSourceMapping_AmazonManagedKafkaEventSourceConfigProperty(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnEventSourceMapping_DestinationConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.onFailure) || (p.onFailure, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_CfnEventSourceMapping_DocumentDBEventSourceConfigProperty(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnEventSourceMapping_EndpointsProperty(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnEventSourceMapping_FilterProperty(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnEventSourceMapping_FilterCriteriaProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.filters) || (p.filters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_CfnEventSourceMapping_OnFailureProperty(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnEventSourceMapping_ScalingConfigProperty(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnEventSourceMapping_SelfManagedEventSourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.endpoints) || (p.endpoints, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_CfnEventSourceMapping_SelfManagedKafkaEventSourceConfigProperty(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnEventSourceMapping_SourceAccessConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnFunctionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.code) || (p.code, void 0), visitedObjects.has(p.deadLetterConfig) || (p.deadLetterConfig, void 0), visitedObjects.has(p.environment) || (p.environment, void 0), visitedObjects.has(p.ephemeralStorage) || (p.ephemeralStorage, void 0), visitedObjects.has(p.fileSystemConfigs) || (p.fileSystemConfigs, void 0), visitedObjects.has(p.imageConfig) || (p.imageConfig, void 0), visitedObjects.has(p.runtimeManagementConfig) || (p.runtimeManagementConfig, void 0), visitedObjects.has(p.snapStart) || (p.snapStart, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.tracingConfig) || (p.tracingConfig, void 0), visitedObjects.has(p.vpcConfig) || (p.vpcConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_CfnFunction(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnFunction_CodeProperty(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnFunction_DeadLetterConfigProperty(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnFunction_EnvironmentProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.variables) || (p.variables, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_CfnFunction_EphemeralStorageProperty(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnFunction_FileSystemConfigProperty(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnFunction_ImageConfigProperty(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnFunction_RuntimeManagementConfigProperty(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnFunction_SnapStartProperty(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnFunction_SnapStartResponseProperty(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnFunction_TracingConfigProperty(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnFunction_VpcConfigProperty(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnLayerVersionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.content) || (p.content, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_CfnLayerVersion(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnLayerVersion_ContentProperty(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnLayerVersionPermissionProps(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnLayerVersionPermission(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnPermissionProps(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnPermission(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnUrlProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cors) || (p.cors, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_CfnUrl(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnUrl_CorsProperty(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnVersionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.provisionedConcurrencyConfig) || (p.provisionedConcurrencyConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_CfnVersion(p) {
    }
    function aws_cdk_lib_aws_lambda_CfnVersion_ProvisionedConcurrencyConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_lambda_destinations_EventBridgeDestination(p) {
    }
    function aws_cdk_lib_aws_lambda_destinations_LambdaDestinationOptions(p) {
    }
    function aws_cdk_lib_aws_lambda_destinations_LambdaDestination(p) {
    }
    function aws_cdk_lib_aws_lambda_destinations_SnsDestination(p) {
    }
    function aws_cdk_lib_aws_lambda_destinations_SqsDestination(p) {
    }
    function aws_cdk_lib_aws_lambda_event_sources_ApiEventSource(p) {
    }
    function aws_cdk_lib_aws_lambda_event_sources_DynamoEventSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.maxRecordAge) || (p.maxRecordAge, void 0), visitedObjects.has(p.onFailure) || (p.onFailure, void 0), visitedObjects.has(p.tumblingWindow) || (p.tumblingWindow, void 0), visitedObjects.has(p.startingPosition) || (p.startingPosition, void 0), visitedObjects.has(p.maxBatchingWindow) || (p.maxBatchingWindow, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_event_sources_DynamoEventSource(p) {
    }
    function aws_cdk_lib_aws_lambda_event_sources_KafkaEventSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.secret) || (p.secret, void 0), visitedObjects.has(p.startingPosition) || (p.startingPosition, void 0), visitedObjects.has(p.maxBatchingWindow) || (p.maxBatchingWindow, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_event_sources_ManagedKafkaEventSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.secret) || (p.secret, void 0), visitedObjects.has(p.startingPosition) || (p.startingPosition, void 0), visitedObjects.has(p.maxBatchingWindow) || (p.maxBatchingWindow, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_event_sources_AuthenticationMethod(p) {
    }
    function aws_cdk_lib_aws_lambda_event_sources_SelfManagedKafkaEventSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.authenticationMethod) || (p.authenticationMethod, void 0), visitedObjects.has(p.rootCACertificate) || (p.rootCACertificate, void 0), visitedObjects.has(p.securityGroup) || (p.securityGroup, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets), visitedObjects.has(p.secret) || (p.secret, void 0), visitedObjects.has(p.startingPosition) || (p.startingPosition, void 0), visitedObjects.has(p.maxBatchingWindow) || (p.maxBatchingWindow, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_event_sources_ManagedKafkaEventSource(p) {
    }
    function aws_cdk_lib_aws_lambda_event_sources_SelfManagedKafkaEventSource(p) {
    }
    function aws_cdk_lib_aws_lambda_event_sources_KinesisEventSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.maxRecordAge) || (p.maxRecordAge, void 0), visitedObjects.has(p.onFailure) || (p.onFailure, void 0), visitedObjects.has(p.tumblingWindow) || (p.tumblingWindow, void 0), visitedObjects.has(p.startingPosition) || (p.startingPosition, void 0), visitedObjects.has(p.maxBatchingWindow) || (p.maxBatchingWindow, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_event_sources_KinesisEventSource(p) {
    }
    function aws_cdk_lib_aws_lambda_event_sources_S3EventSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.events != null)
            for (const o of p.events)
              visitedObjects.has(o) || void 0;
          if (p.filters != null)
            for (const o of p.filters)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_event_sources_S3EventSource(p) {
    }
    function aws_cdk_lib_aws_lambda_event_sources_SnsEventSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.deadLetterQueue) || (p.deadLetterQueue, void 0), p.filterPolicy != null)
            for (const o of Object.values(p.filterPolicy))
              visitedObjects.has(o) || void 0;
          if (p.filterPolicyWithMessageBody != null)
            for (const o of Object.values(p.filterPolicyWithMessageBody))
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_event_sources_SnsEventSource(p) {
    }
    function aws_cdk_lib_aws_lambda_event_sources_SnsDlq(p) {
    }
    function aws_cdk_lib_aws_lambda_event_sources_BaseStreamEventSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.startingPosition) || (p.startingPosition, void 0), visitedObjects.has(p.maxBatchingWindow) || (p.maxBatchingWindow, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_event_sources_StreamEventSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.maxRecordAge) || (p.maxRecordAge, void 0), visitedObjects.has(p.onFailure) || (p.onFailure, void 0), visitedObjects.has(p.tumblingWindow) || (p.tumblingWindow, void 0), visitedObjects.has(p.startingPosition) || (p.startingPosition, void 0), visitedObjects.has(p.maxBatchingWindow) || (p.maxBatchingWindow, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_event_sources_StreamEventSource(p) {
    }
    function aws_cdk_lib_aws_lambda_event_sources_SqsEventSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.maxBatchingWindow) || (p.maxBatchingWindow, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_event_sources_SqsEventSource(p) {
    }
    function aws_cdk_lib_aws_lambda_event_sources_SqsDlq(p) {
    }
    function aws_cdk_lib_aws_lambda_nodejs_NodejsFunctionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.bundling) || aws_cdk_lib_aws_lambda_nodejs_BundlingOptions(p.bundling), visitedObjects.has(p.runtime) || (p.runtime, void 0), visitedObjects.has(p.adotInstrumentation) || aws_cdk_lib_aws_lambda_AdotInstrumentationConfig(p.adotInstrumentation), visitedObjects.has(p.architecture) || (p.architecture, void 0), visitedObjects.has(p.codeSigningConfig) || (p.codeSigningConfig, void 0), visitedObjects.has(p.currentVersionOptions) || aws_cdk_lib_aws_lambda_VersionOptions(p.currentVersionOptions), visitedObjects.has(p.deadLetterQueue) || (p.deadLetterQueue, void 0), visitedObjects.has(p.deadLetterTopic) || (p.deadLetterTopic, void 0), visitedObjects.has(p.environmentEncryption) || (p.environmentEncryption, void 0), visitedObjects.has(p.ephemeralStorageSize) || (p.ephemeralStorageSize, void 0), p.events != null)
            for (const o of p.events)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.filesystem) || (p.filesystem, void 0), p.initialPolicy != null)
            for (const o of p.initialPolicy)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.insightsVersion) || (p.insightsVersion, void 0), p.layers != null)
            for (const o of p.layers)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.logRetention) || (p.logRetention, void 0), visitedObjects.has(p.logRetentionRetryOptions) || aws_cdk_lib_aws_lambda_LogRetentionRetryOptions(p.logRetentionRetryOptions), visitedObjects.has(p.logRetentionRole) || (p.logRetentionRole, void 0), visitedObjects.has(p.profilingGroup) || (p.profilingGroup, void 0), visitedObjects.has(p.role) || (p.role, void 0), visitedObjects.has(p.runtimeManagementMode) || (p.runtimeManagementMode, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.timeout) || (p.timeout, void 0), visitedObjects.has(p.tracing) || (p.tracing, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets), visitedObjects.has(p.maxEventAge) || (p.maxEventAge, void 0), visitedObjects.has(p.onFailure) || (p.onFailure, void 0), visitedObjects.has(p.onSuccess) || (p.onSuccess, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_nodejs_NodejsFunction(p) {
    }
    function aws_cdk_lib_aws_lambda_nodejs_BundlingOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.bundlingFileAccess) || (p.bundlingFileAccess, void 0), visitedObjects.has(p.charset) || (p.charset, void 0), visitedObjects.has(p.commandHooks) || (p.commandHooks, void 0), visitedObjects.has(p.dockerImage) || (p.dockerImage, void 0), visitedObjects.has(p.format) || (p.format, void 0), visitedObjects.has(p.logLevel) || (p.logLevel, void 0), visitedObjects.has(p.sourceMapMode) || (p.sourceMapMode, void 0), p.volumes != null)
            for (const o of p.volumes)
              visitedObjects.has(o) || aws_cdk_lib_DockerVolume(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lambda_nodejs_OutputFormat(p) {
    }
    function aws_cdk_lib_aws_lambda_nodejs_ICommandHooks(p) {
    }
    function aws_cdk_lib_aws_lambda_nodejs_LogLevel(p) {
    }
    function aws_cdk_lib_aws_lambda_nodejs_SourceMapMode(p) {
    }
    function aws_cdk_lib_aws_lambda_nodejs_Charset(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBotProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.botFileS3Location) || (p.botFileS3Location, void 0), visitedObjects.has(p.botLocales) || (p.botLocales, void 0), visitedObjects.has(p.botTags) || (p.botTags, void 0), visitedObjects.has(p.testBotAliasSettings) || (p.testBotAliasSettings, void 0), visitedObjects.has(p.testBotAliasTags) || (p.testBotAliasTags, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_AdvancedRecognitionSettingProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_AllowedInputTypesProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_AudioAndDTMFInputSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.audioSpecification) || (p.audioSpecification, void 0), visitedObjects.has(p.dtmfSpecification) || (p.dtmfSpecification, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_AudioLogDestinationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3Bucket) || (p.s3Bucket, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_AudioLogSettingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destination) || (p.destination, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_AudioSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_BotAliasLocaleSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.codeHookSpecification) || (p.codeHookSpecification, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_BotAliasLocaleSettingsItemProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.botAliasLocaleSetting) || (p.botAliasLocaleSetting, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_BotLocaleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customVocabulary) || (p.customVocabulary, void 0), visitedObjects.has(p.intents) || (p.intents, void 0), visitedObjects.has(p.slotTypes) || (p.slotTypes, void 0), visitedObjects.has(p.voiceSettings) || (p.voiceSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_ButtonProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_CloudWatchLogGroupLogDestinationProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_CodeHookSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.lambdaCodeHook) || (p.lambdaCodeHook, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_ConditionProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_ConditionalBranchProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.condition) || (p.condition, void 0), visitedObjects.has(p.nextStep) || (p.nextStep, void 0), visitedObjects.has(p.response) || (p.response, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_ConditionalSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.conditionalBranches) || (p.conditionalBranches, void 0), visitedObjects.has(p.defaultBranch) || (p.defaultBranch, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_ConversationLogSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.audioLogSettings) || (p.audioLogSettings, void 0), visitedObjects.has(p.textLogSettings) || (p.textLogSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_CustomPayloadProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_CustomVocabularyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customVocabularyItems) || (p.customVocabularyItems, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_CustomVocabularyItemProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_DTMFSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_DataPrivacyProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_DefaultConditionalBranchProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.nextStep) || (p.nextStep, void 0), visitedObjects.has(p.response) || (p.response, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_DialogActionProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_DialogCodeHookInvocationSettingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.postCodeHookSpecification) || (p.postCodeHookSpecification, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_DialogCodeHookSettingProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_DialogStateProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dialogAction) || (p.dialogAction, void 0), visitedObjects.has(p.intent) || (p.intent, void 0), visitedObjects.has(p.sessionAttributes) || (p.sessionAttributes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_ElicitationCodeHookInvocationSettingProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_ExternalSourceSettingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.grammarSlotTypeSetting) || (p.grammarSlotTypeSetting, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_FulfillmentCodeHookSettingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fulfillmentUpdatesSpecification) || (p.fulfillmentUpdatesSpecification, void 0), visitedObjects.has(p.postFulfillmentStatusSpecification) || (p.postFulfillmentStatusSpecification, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_FulfillmentStartResponseSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.messageGroups) || (p.messageGroups, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_FulfillmentUpdateResponseSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.messageGroups) || (p.messageGroups, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_FulfillmentUpdatesSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.startResponse) || (p.startResponse, void 0), visitedObjects.has(p.updateResponse) || (p.updateResponse, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_GrammarSlotTypeSettingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.source) || (p.source, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_GrammarSlotTypeSourceProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_ImageResponseCardProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.buttons) || (p.buttons, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_InitialResponseSettingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.codeHook) || (p.codeHook, void 0), visitedObjects.has(p.conditional) || (p.conditional, void 0), visitedObjects.has(p.initialResponse) || (p.initialResponse, void 0), visitedObjects.has(p.nextStep) || (p.nextStep, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_InputContextProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_IntentProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dialogCodeHook) || (p.dialogCodeHook, void 0), visitedObjects.has(p.fulfillmentCodeHook) || (p.fulfillmentCodeHook, void 0), visitedObjects.has(p.initialResponseSetting) || (p.initialResponseSetting, void 0), visitedObjects.has(p.inputContexts) || (p.inputContexts, void 0), visitedObjects.has(p.intentClosingSetting) || (p.intentClosingSetting, void 0), visitedObjects.has(p.intentConfirmationSetting) || (p.intentConfirmationSetting, void 0), visitedObjects.has(p.kendraConfiguration) || (p.kendraConfiguration, void 0), visitedObjects.has(p.outputContexts) || (p.outputContexts, void 0), visitedObjects.has(p.sampleUtterances) || (p.sampleUtterances, void 0), visitedObjects.has(p.slotPriorities) || (p.slotPriorities, void 0), visitedObjects.has(p.slots) || (p.slots, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_IntentClosingSettingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.closingResponse) || (p.closingResponse, void 0), visitedObjects.has(p.conditional) || (p.conditional, void 0), visitedObjects.has(p.nextStep) || (p.nextStep, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_IntentConfirmationSettingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.promptSpecification) || (p.promptSpecification, void 0), visitedObjects.has(p.codeHook) || (p.codeHook, void 0), visitedObjects.has(p.confirmationConditional) || (p.confirmationConditional, void 0), visitedObjects.has(p.confirmationNextStep) || (p.confirmationNextStep, void 0), visitedObjects.has(p.confirmationResponse) || (p.confirmationResponse, void 0), visitedObjects.has(p.declinationConditional) || (p.declinationConditional, void 0), visitedObjects.has(p.declinationNextStep) || (p.declinationNextStep, void 0), visitedObjects.has(p.declinationResponse) || (p.declinationResponse, void 0), visitedObjects.has(p.elicitationCodeHook) || (p.elicitationCodeHook, void 0), visitedObjects.has(p.failureConditional) || (p.failureConditional, void 0), visitedObjects.has(p.failureNextStep) || (p.failureNextStep, void 0), visitedObjects.has(p.failureResponse) || (p.failureResponse, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_IntentOverrideProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.slots) || (p.slots, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_KendraConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_LambdaCodeHookProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_MessageProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customPayload) || (p.customPayload, void 0), visitedObjects.has(p.imageResponseCard) || (p.imageResponseCard, void 0), visitedObjects.has(p.plainTextMessage) || (p.plainTextMessage, void 0), visitedObjects.has(p.ssmlMessage) || (p.ssmlMessage, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_MessageGroupProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.message) || (p.message, void 0), visitedObjects.has(p.variations) || (p.variations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_MultipleValuesSettingProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_ObfuscationSettingProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_OutputContextProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_PlainTextMessageProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_PostDialogCodeHookInvocationSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.failureConditional) || (p.failureConditional, void 0), visitedObjects.has(p.failureNextStep) || (p.failureNextStep, void 0), visitedObjects.has(p.failureResponse) || (p.failureResponse, void 0), visitedObjects.has(p.successConditional) || (p.successConditional, void 0), visitedObjects.has(p.successNextStep) || (p.successNextStep, void 0), visitedObjects.has(p.successResponse) || (p.successResponse, void 0), visitedObjects.has(p.timeoutConditional) || (p.timeoutConditional, void 0), visitedObjects.has(p.timeoutNextStep) || (p.timeoutNextStep, void 0), visitedObjects.has(p.timeoutResponse) || (p.timeoutResponse, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_PostFulfillmentStatusSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.failureConditional) || (p.failureConditional, void 0), visitedObjects.has(p.failureNextStep) || (p.failureNextStep, void 0), visitedObjects.has(p.failureResponse) || (p.failureResponse, void 0), visitedObjects.has(p.successConditional) || (p.successConditional, void 0), visitedObjects.has(p.successNextStep) || (p.successNextStep, void 0), visitedObjects.has(p.successResponse) || (p.successResponse, void 0), visitedObjects.has(p.timeoutConditional) || (p.timeoutConditional, void 0), visitedObjects.has(p.timeoutNextStep) || (p.timeoutNextStep, void 0), visitedObjects.has(p.timeoutResponse) || (p.timeoutResponse, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_PromptAttemptSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.allowedInputTypes) || (p.allowedInputTypes, void 0), visitedObjects.has(p.audioAndDtmfInputSpecification) || (p.audioAndDtmfInputSpecification, void 0), visitedObjects.has(p.textInputSpecification) || (p.textInputSpecification, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_PromptSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.messageGroupsList) || (p.messageGroupsList, void 0), visitedObjects.has(p.promptAttemptsSpecification) || (p.promptAttemptsSpecification, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_ResponseSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.messageGroupsList) || (p.messageGroupsList, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_S3BucketLogDestinationProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_S3LocationProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_SSMLMessageProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_SampleUtteranceProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_SampleValueProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_SentimentAnalysisSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_SessionAttributeProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_SlotProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.valueElicitationSetting) || (p.valueElicitationSetting, void 0), visitedObjects.has(p.multipleValuesSetting) || (p.multipleValuesSetting, void 0), visitedObjects.has(p.obfuscationSetting) || (p.obfuscationSetting, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_SlotCaptureSettingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.captureConditional) || (p.captureConditional, void 0), visitedObjects.has(p.captureNextStep) || (p.captureNextStep, void 0), visitedObjects.has(p.captureResponse) || (p.captureResponse, void 0), visitedObjects.has(p.codeHook) || (p.codeHook, void 0), visitedObjects.has(p.elicitationCodeHook) || (p.elicitationCodeHook, void 0), visitedObjects.has(p.failureConditional) || (p.failureConditional, void 0), visitedObjects.has(p.failureNextStep) || (p.failureNextStep, void 0), visitedObjects.has(p.failureResponse) || (p.failureResponse, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_SlotDefaultValueProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_SlotDefaultValueSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultValueList) || (p.defaultValueList, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_SlotPriorityProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_SlotTypeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.externalSourceSetting) || (p.externalSourceSetting, void 0), visitedObjects.has(p.slotTypeValues) || (p.slotTypeValues, void 0), visitedObjects.has(p.valueSelectionSetting) || (p.valueSelectionSetting, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_SlotTypeValueProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sampleValue) || (p.sampleValue, void 0), visitedObjects.has(p.synonyms) || (p.synonyms, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_SlotValueProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_SlotValueElicitationSettingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultValueSpecification) || (p.defaultValueSpecification, void 0), visitedObjects.has(p.promptSpecification) || (p.promptSpecification, void 0), visitedObjects.has(p.sampleUtterances) || (p.sampleUtterances, void 0), visitedObjects.has(p.slotCaptureSetting) || (p.slotCaptureSetting, void 0), visitedObjects.has(p.waitAndContinueSpecification) || (p.waitAndContinueSpecification, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_SlotValueOverrideProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.value) || (p.value, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_SlotValueOverrideMapProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.slotValueOverride) || (p.slotValueOverride, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_SlotValueRegexFilterProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_SlotValueSelectionSettingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.advancedRecognitionSetting) || (p.advancedRecognitionSetting, void 0), visitedObjects.has(p.regexFilter) || (p.regexFilter, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_StillWaitingResponseSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.messageGroupsList) || (p.messageGroupsList, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_TestBotAliasSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.botAliasLocaleSettings) || (p.botAliasLocaleSettings, void 0), visitedObjects.has(p.conversationLogSettings) || (p.conversationLogSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_TextInputSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_TextLogDestinationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cloudWatch) || (p.cloudWatch, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_TextLogSettingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destination) || (p.destination, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBot_VoiceSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBot_WaitAndContinueSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.continueResponse) || (p.continueResponse, void 0), visitedObjects.has(p.waitingResponse) || (p.waitingResponse, void 0), visitedObjects.has(p.stillWaitingResponse) || (p.stillWaitingResponse, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBotAliasProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.botAliasLocaleSettings) || (p.botAliasLocaleSettings, void 0), visitedObjects.has(p.botAliasTags) || (p.botAliasTags, void 0), visitedObjects.has(p.conversationLogSettings) || (p.conversationLogSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBotAlias(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBotAlias_AudioLogDestinationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3Bucket) || (p.s3Bucket, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBotAlias_AudioLogSettingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destination) || (p.destination, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBotAlias_BotAliasLocaleSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.codeHookSpecification) || (p.codeHookSpecification, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBotAlias_BotAliasLocaleSettingsItemProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.botAliasLocaleSetting) || (p.botAliasLocaleSetting, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBotAlias_CloudWatchLogGroupLogDestinationProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBotAlias_CodeHookSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.lambdaCodeHook) || (p.lambdaCodeHook, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBotAlias_ConversationLogSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.audioLogSettings) || (p.audioLogSettings, void 0), visitedObjects.has(p.textLogSettings) || (p.textLogSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBotAlias_LambdaCodeHookProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBotAlias_S3BucketLogDestinationProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBotAlias_SentimentAnalysisSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBotAlias_TextLogDestinationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cloudWatch) || (p.cloudWatch, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBotAlias_TextLogSettingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destination) || (p.destination, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBotVersionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.botVersionLocaleSpecification) || (p.botVersionLocaleSpecification, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnBotVersion(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBotVersion_BotVersionLocaleDetailsProperty(p) {
    }
    function aws_cdk_lib_aws_lex_CfnBotVersion_BotVersionLocaleSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.botVersionLocaleDetails) || (p.botVersionLocaleDetails, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lex_CfnResourcePolicyProps(p) {
    }
    function aws_cdk_lib_aws_lex_CfnResourcePolicy(p) {
    }
    function aws_cdk_lib_aws_licensemanager_CfnGrantProps(p) {
    }
    function aws_cdk_lib_aws_licensemanager_CfnGrant(p) {
    }
    function aws_cdk_lib_aws_licensemanager_CfnLicenseProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.consumptionConfiguration) || (p.consumptionConfiguration, void 0), visitedObjects.has(p.entitlements) || (p.entitlements, void 0), visitedObjects.has(p.issuer) || (p.issuer, void 0), visitedObjects.has(p.validity) || (p.validity, void 0), visitedObjects.has(p.licenseMetadata) || (p.licenseMetadata, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_licensemanager_CfnLicense(p) {
    }
    function aws_cdk_lib_aws_licensemanager_CfnLicense_BorrowConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_licensemanager_CfnLicense_ConsumptionConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.borrowConfiguration) || (p.borrowConfiguration, void 0), visitedObjects.has(p.provisionalConfiguration) || (p.provisionalConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_licensemanager_CfnLicense_EntitlementProperty(p) {
    }
    function aws_cdk_lib_aws_licensemanager_CfnLicense_IssuerDataProperty(p) {
    }
    function aws_cdk_lib_aws_licensemanager_CfnLicense_MetadataProperty(p) {
    }
    function aws_cdk_lib_aws_licensemanager_CfnLicense_ProvisionalConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_licensemanager_CfnLicense_ValidityDateFormatProperty(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnAlarmProps(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnAlarm(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnBucketProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.accessRules) || (p.accessRules, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lightsail_CfnBucket(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnBucket_AccessRulesProperty(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnCertificateProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lightsail_CfnCertificate(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnContainerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.containerServiceDeployment) || (p.containerServiceDeployment, void 0), visitedObjects.has(p.publicDomainNames) || (p.publicDomainNames, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lightsail_CfnContainer(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnContainer_ContainerProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.environment) || (p.environment, void 0), visitedObjects.has(p.ports) || (p.ports, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lightsail_CfnContainer_ContainerServiceDeploymentProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.containers) || (p.containers, void 0), visitedObjects.has(p.publicEndpoint) || (p.publicEndpoint, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lightsail_CfnContainer_EnvironmentVariableProperty(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnContainer_HealthCheckConfigProperty(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnContainer_PortInfoProperty(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnContainer_PublicDomainNameProperty(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnContainer_PublicEndpointProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.healthCheckConfig) || (p.healthCheckConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lightsail_CfnDatabaseProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.relationalDatabaseParameters) || (p.relationalDatabaseParameters, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lightsail_CfnDatabase(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnDatabase_RelationalDatabaseParameterProperty(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnDiskProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.addOns) || (p.addOns, void 0), visitedObjects.has(p.location) || (p.location, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lightsail_CfnDisk(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnDisk_AddOnProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.autoSnapshotAddOnRequest) || (p.autoSnapshotAddOnRequest, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lightsail_CfnDisk_AutoSnapshotAddOnProperty(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnDisk_LocationProperty(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnDistributionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.defaultCacheBehavior) || (p.defaultCacheBehavior, void 0), visitedObjects.has(p.origin) || (p.origin, void 0), visitedObjects.has(p.cacheBehaviors) || (p.cacheBehaviors, void 0), visitedObjects.has(p.cacheBehaviorSettings) || (p.cacheBehaviorSettings, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lightsail_CfnDistribution(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnDistribution_CacheBehaviorProperty(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnDistribution_CacheBehaviorPerPathProperty(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnDistribution_CacheSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.forwardedCookies) || (p.forwardedCookies, void 0), visitedObjects.has(p.forwardedHeaders) || (p.forwardedHeaders, void 0), visitedObjects.has(p.forwardedQueryStrings) || (p.forwardedQueryStrings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lightsail_CfnDistribution_CookieObjectProperty(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnDistribution_HeaderObjectProperty(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnDistribution_InputOriginProperty(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnDistribution_QueryStringObjectProperty(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnInstanceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.addOns) || (p.addOns, void 0), visitedObjects.has(p.hardware) || (p.hardware, void 0), visitedObjects.has(p.location) || (p.location, void 0), visitedObjects.has(p.networking) || (p.networking, void 0), visitedObjects.has(p.state) || (p.state, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lightsail_CfnInstance(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnInstance_AddOnProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.autoSnapshotAddOnRequest) || (p.autoSnapshotAddOnRequest, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lightsail_CfnInstance_AutoSnapshotAddOnProperty(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnInstance_DiskProperty(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnInstance_HardwareProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.disks) || (p.disks, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lightsail_CfnInstance_LocationProperty(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnInstance_MonthlyTransferProperty(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnInstance_NetworkingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ports) || (p.ports, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lightsail_CfnInstance_PortProperty(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnInstance_StateProperty(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnLoadBalancerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lightsail_CfnLoadBalancer(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnLoadBalancerTlsCertificateProps(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnLoadBalancerTlsCertificate(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnStaticIpProps(p) {
    }
    function aws_cdk_lib_aws_lightsail_CfnStaticIp(p) {
    }
    function aws_cdk_lib_aws_location_CfnGeofenceCollectionProps(p) {
    }
    function aws_cdk_lib_aws_location_CfnGeofenceCollection(p) {
    }
    function aws_cdk_lib_aws_location_CfnMapProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.configuration) || (p.configuration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_location_CfnMap(p) {
    }
    function aws_cdk_lib_aws_location_CfnMap_MapConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_location_CfnPlaceIndexProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataSourceConfiguration) || (p.dataSourceConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_location_CfnPlaceIndex(p) {
    }
    function aws_cdk_lib_aws_location_CfnPlaceIndex_DataSourceConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_location_CfnRouteCalculatorProps(p) {
    }
    function aws_cdk_lib_aws_location_CfnRouteCalculator(p) {
    }
    function aws_cdk_lib_aws_location_CfnTrackerProps(p) {
    }
    function aws_cdk_lib_aws_location_CfnTracker(p) {
    }
    function aws_cdk_lib_aws_location_CfnTrackerConsumerProps(p) {
    }
    function aws_cdk_lib_aws_location_CfnTrackerConsumer(p) {
    }
    function aws_cdk_lib_aws_logs_CrossAccountDestinationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_logs_CrossAccountDestination(p) {
    }
    function aws_cdk_lib_aws_logs_ILogGroup(p) {
    }
    function aws_cdk_lib_aws_logs_RetentionDays(p) {
    }
    function aws_cdk_lib_aws_logs_LogGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataProtectionPolicy) || (p.dataProtectionPolicy, void 0), visitedObjects.has(p.encryptionKey) || (p.encryptionKey, void 0), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), visitedObjects.has(p.retention) || (p.retention, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_logs_LogGroup(p) {
    }
    function aws_cdk_lib_aws_logs_StreamOptions(p) {
    }
    function aws_cdk_lib_aws_logs_SubscriptionFilterOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destination) || (p.destination, void 0), visitedObjects.has(p.filterPattern) || (p.filterPattern, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_logs_MetricFilterOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.filterPattern) || (p.filterPattern, void 0), visitedObjects.has(p.unit) || (p.unit, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_logs_ILogStream(p) {
    }
    function aws_cdk_lib_aws_logs_LogStreamProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.logGroup) || (p.logGroup, void 0), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_logs_LogStream(p) {
    }
    function aws_cdk_lib_aws_logs_MetricFilterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.logGroup) || (p.logGroup, void 0), visitedObjects.has(p.filterPattern) || (p.filterPattern, void 0), visitedObjects.has(p.unit) || (p.unit, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_logs_MetricFilter(p) {
    }
    function aws_cdk_lib_aws_logs_IFilterPattern(p) {
    }
    function aws_cdk_lib_aws_logs_JsonPattern(p) {
    }
    function aws_cdk_lib_aws_logs_FilterPattern(p) {
    }
    function aws_cdk_lib_aws_logs_SpaceDelimitedTextPattern(p) {
    }
    function aws_cdk_lib_aws_logs_ColumnRestriction(p) {
    }
    function aws_cdk_lib_aws_logs_ILogSubscriptionDestination(p) {
    }
    function aws_cdk_lib_aws_logs_LogSubscriptionDestinationConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_logs_SubscriptionFilterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.logGroup) || (p.logGroup, void 0), visitedObjects.has(p.destination) || (p.destination, void 0), visitedObjects.has(p.filterPattern) || (p.filterPattern, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_logs_SubscriptionFilter(p) {
    }
    function aws_cdk_lib_aws_logs_LogRetentionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.retention) || (p.retention, void 0), visitedObjects.has(p.logRetentionRetryOptions) || aws_cdk_lib_aws_logs_LogRetentionRetryOptions(p.logRetentionRetryOptions), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_logs_LogRetentionRetryOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.base) || (p.base, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_logs_LogRetention(p) {
    }
    function aws_cdk_lib_aws_logs_ResourcePolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.policyStatements != null)
            for (const o of p.policyStatements)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_logs_ResourcePolicy(p) {
    }
    function aws_cdk_lib_aws_logs_QueryStringProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          "filter" in p && print("aws-cdk-lib.aws_logs.QueryStringProps#filter", "Use `filterStatements` instead"), "parse" in p && print("aws-cdk-lib.aws_logs.QueryStringProps#parse", "Use `parseStatements` instead");
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_logs_QueryString(p) {
    }
    function aws_cdk_lib_aws_logs_QueryDefinitionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.queryString) || (p.queryString, void 0), p.logGroups != null)
            for (const o of p.logGroups)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_logs_QueryDefinition(p) {
    }
    function aws_cdk_lib_aws_logs_DataProtectionPolicy(p) {
    }
    function aws_cdk_lib_aws_logs_DataProtectionPolicyConfig(p) {
    }
    function aws_cdk_lib_aws_logs_DataProtectionPolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.identifiers != null)
            for (const o of p.identifiers)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.logGroupAuditDestination) || (p.logGroupAuditDestination, void 0), visitedObjects.has(p.s3BucketAuditDestination) || (p.s3BucketAuditDestination, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_logs_DataIdentifier(p) {
    }
    function aws_cdk_lib_aws_logs_CfnDestinationProps(p) {
    }
    function aws_cdk_lib_aws_logs_CfnDestination(p) {
    }
    function aws_cdk_lib_aws_logs_CfnLogGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_logs_CfnLogGroup(p) {
    }
    function aws_cdk_lib_aws_logs_CfnLogStreamProps(p) {
    }
    function aws_cdk_lib_aws_logs_CfnLogStream(p) {
    }
    function aws_cdk_lib_aws_logs_CfnMetricFilterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.metricTransformations) || (p.metricTransformations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_logs_CfnMetricFilter(p) {
    }
    function aws_cdk_lib_aws_logs_CfnMetricFilter_DimensionProperty(p) {
    }
    function aws_cdk_lib_aws_logs_CfnMetricFilter_MetricTransformationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dimensions) || (p.dimensions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_logs_CfnQueryDefinitionProps(p) {
    }
    function aws_cdk_lib_aws_logs_CfnQueryDefinition(p) {
    }
    function aws_cdk_lib_aws_logs_CfnResourcePolicyProps(p) {
    }
    function aws_cdk_lib_aws_logs_CfnResourcePolicy(p) {
    }
    function aws_cdk_lib_aws_logs_CfnSubscriptionFilterProps(p) {
    }
    function aws_cdk_lib_aws_logs_CfnSubscriptionFilter(p) {
    }
    function aws_cdk_lib_aws_logs_destinations_LambdaDestinationOptions(p) {
    }
    function aws_cdk_lib_aws_logs_destinations_LambdaDestination(p) {
    }
    function aws_cdk_lib_aws_logs_destinations_KinesisDestinationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_logs_destinations_KinesisDestination(p) {
    }
    function aws_cdk_lib_aws_lookoutequipment_CfnInferenceSchedulerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lookoutequipment_CfnInferenceScheduler(p) {
    }
    function aws_cdk_lib_aws_lookoutequipment_CfnInferenceScheduler_DataInputConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3InputConfiguration) || (p.s3InputConfiguration, void 0), visitedObjects.has(p.inferenceInputNameConfiguration) || (p.inferenceInputNameConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lookoutequipment_CfnInferenceScheduler_DataOutputConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3OutputConfiguration) || (p.s3OutputConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lookoutequipment_CfnInferenceScheduler_InputNameConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_lookoutequipment_CfnInferenceScheduler_S3InputConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_lookoutequipment_CfnInferenceScheduler_S3OutputConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_lookoutmetrics_CfnAlertProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.action) || (p.action, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lookoutmetrics_CfnAlert(p) {
    }
    function aws_cdk_lib_aws_lookoutmetrics_CfnAlert_ActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.lambdaConfiguration) || (p.lambdaConfiguration, void 0), visitedObjects.has(p.snsConfiguration) || (p.snsConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lookoutmetrics_CfnAlert_LambdaConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_lookoutmetrics_CfnAlert_SNSConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetectorProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.anomalyDetectorConfig) || (p.anomalyDetectorConfig, void 0), visitedObjects.has(p.metricSetList) || (p.metricSetList, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetector(p) {
    }
    function aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetector_AnomalyDetectorConfigProperty(p) {
    }
    function aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetector_AppFlowConfigProperty(p) {
    }
    function aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetector_CloudwatchConfigProperty(p) {
    }
    function aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetector_CsvFormatDescriptorProperty(p) {
    }
    function aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetector_FileFormatDescriptorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.csvFormatDescriptor) || (p.csvFormatDescriptor, void 0), visitedObjects.has(p.jsonFormatDescriptor) || (p.jsonFormatDescriptor, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetector_JsonFormatDescriptorProperty(p) {
    }
    function aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetector_MetricProperty(p) {
    }
    function aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetector_MetricSetProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.metricList) || (p.metricList, void 0), visitedObjects.has(p.metricSource) || (p.metricSource, void 0), visitedObjects.has(p.timestampColumn) || (p.timestampColumn, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetector_MetricSourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.appFlowConfig) || (p.appFlowConfig, void 0), visitedObjects.has(p.cloudwatchConfig) || (p.cloudwatchConfig, void 0), visitedObjects.has(p.rdsSourceConfig) || (p.rdsSourceConfig, void 0), visitedObjects.has(p.redshiftSourceConfig) || (p.redshiftSourceConfig, void 0), visitedObjects.has(p.s3SourceConfig) || (p.s3SourceConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetector_RDSSourceConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.vpcConfiguration) || (p.vpcConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetector_RedshiftSourceConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.vpcConfiguration) || (p.vpcConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetector_S3SourceConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fileFormatDescriptor) || (p.fileFormatDescriptor, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetector_TimestampColumnProperty(p) {
    }
    function aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetector_VpcConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_lookoutvision_CfnProjectProps(p) {
    }
    function aws_cdk_lib_aws_lookoutvision_CfnProject(p) {
    }
    function aws_cdk_lib_aws_m2_CfnApplicationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.definition) || (p.definition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_m2_CfnApplication(p) {
    }
    function aws_cdk_lib_aws_m2_CfnApplication_DefinitionProperty(p) {
    }
    function aws_cdk_lib_aws_m2_CfnEnvironmentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.highAvailabilityConfig) || (p.highAvailabilityConfig, void 0), visitedObjects.has(p.storageConfigurations) || (p.storageConfigurations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_m2_CfnEnvironment(p) {
    }
    function aws_cdk_lib_aws_m2_CfnEnvironment_EfsStorageConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_m2_CfnEnvironment_FsxStorageConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_m2_CfnEnvironment_HighAvailabilityConfigProperty(p) {
    }
    function aws_cdk_lib_aws_m2_CfnEnvironment_StorageConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.efs) || (p.efs, void 0), visitedObjects.has(p.fsx) || (p.fsx, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_macie_CfnAllowListProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.criteria) || (p.criteria, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_macie_CfnAllowList(p) {
    }
    function aws_cdk_lib_aws_macie_CfnAllowList_CriteriaProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3WordsList) || (p.s3WordsList, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_macie_CfnAllowList_S3WordsListProperty(p) {
    }
    function aws_cdk_lib_aws_macie_CfnCustomDataIdentifierProps(p) {
    }
    function aws_cdk_lib_aws_macie_CfnCustomDataIdentifier(p) {
    }
    function aws_cdk_lib_aws_macie_CfnFindingsFilterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.findingCriteria) || (p.findingCriteria, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_macie_CfnFindingsFilter(p) {
    }
    function aws_cdk_lib_aws_macie_CfnFindingsFilter_CriterionAdditionalPropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_macie_CfnFindingsFilter_FindingCriteriaProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.criterion) || (p.criterion, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_macie_CfnFindingsFilter_FindingsFilterListItemProperty(p) {
    }
    function aws_cdk_lib_aws_macie_CfnSessionProps(p) {
    }
    function aws_cdk_lib_aws_macie_CfnSession(p) {
    }
    function aws_cdk_lib_aws_managedblockchain_CfnAccessorProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_managedblockchain_CfnAccessor(p) {
    }
    function aws_cdk_lib_aws_managedblockchain_CfnMemberProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.memberConfiguration) || (p.memberConfiguration, void 0), visitedObjects.has(p.networkConfiguration) || (p.networkConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_managedblockchain_CfnMember(p) {
    }
    function aws_cdk_lib_aws_managedblockchain_CfnMember_ApprovalThresholdPolicyProperty(p) {
    }
    function aws_cdk_lib_aws_managedblockchain_CfnMember_MemberConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.memberFrameworkConfiguration) || (p.memberFrameworkConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_managedblockchain_CfnMember_MemberFabricConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_managedblockchain_CfnMember_MemberFrameworkConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.memberFabricConfiguration) || (p.memberFabricConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_managedblockchain_CfnMember_NetworkConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.votingPolicy) || (p.votingPolicy, void 0), visitedObjects.has(p.networkFrameworkConfiguration) || (p.networkFrameworkConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_managedblockchain_CfnMember_NetworkFabricConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_managedblockchain_CfnMember_NetworkFrameworkConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.networkFabricConfiguration) || (p.networkFabricConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_managedblockchain_CfnMember_VotingPolicyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.approvalThresholdPolicy) || (p.approvalThresholdPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_managedblockchain_CfnNodeProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.nodeConfiguration) || (p.nodeConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_managedblockchain_CfnNode(p) {
    }
    function aws_cdk_lib_aws_managedblockchain_CfnNode_NodeConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_mediaconnect_CfnFlowProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.source) || (p.source, void 0), visitedObjects.has(p.sourceFailoverConfig) || (p.sourceFailoverConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediaconnect_CfnFlow(p) {
    }
    function aws_cdk_lib_aws_mediaconnect_CfnFlow_EncryptionProperty(p) {
    }
    function aws_cdk_lib_aws_mediaconnect_CfnFlow_FailoverConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sourcePriority) || (p.sourcePriority, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediaconnect_CfnFlow_SourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.decryption) || (p.decryption, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediaconnect_CfnFlow_SourcePriorityProperty(p) {
    }
    function aws_cdk_lib_aws_mediaconnect_CfnFlowEntitlementProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.encryption) || (p.encryption, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediaconnect_CfnFlowEntitlement(p) {
    }
    function aws_cdk_lib_aws_mediaconnect_CfnFlowEntitlement_EncryptionProperty(p) {
    }
    function aws_cdk_lib_aws_mediaconnect_CfnFlowOutputProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.encryption) || (p.encryption, void 0), visitedObjects.has(p.vpcInterfaceAttachment) || (p.vpcInterfaceAttachment, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediaconnect_CfnFlowOutput(p) {
    }
    function aws_cdk_lib_aws_mediaconnect_CfnFlowOutput_EncryptionProperty(p) {
    }
    function aws_cdk_lib_aws_mediaconnect_CfnFlowOutput_VpcInterfaceAttachmentProperty(p) {
    }
    function aws_cdk_lib_aws_mediaconnect_CfnFlowSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.decryption) || (p.decryption, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediaconnect_CfnFlowSource(p) {
    }
    function aws_cdk_lib_aws_mediaconnect_CfnFlowSource_EncryptionProperty(p) {
    }
    function aws_cdk_lib_aws_mediaconnect_CfnFlowVpcInterfaceProps(p) {
    }
    function aws_cdk_lib_aws_mediaconnect_CfnFlowVpcInterface(p) {
    }
    function aws_cdk_lib_aws_mediaconvert_CfnJobTemplateProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.accelerationSettings) || (p.accelerationSettings, void 0), visitedObjects.has(p.hopDestinations) || (p.hopDestinations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediaconvert_CfnJobTemplate(p) {
    }
    function aws_cdk_lib_aws_mediaconvert_CfnJobTemplate_AccelerationSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_mediaconvert_CfnJobTemplate_HopDestinationProperty(p) {
    }
    function aws_cdk_lib_aws_mediaconvert_CfnPresetProps(p) {
    }
    function aws_cdk_lib_aws_mediaconvert_CfnPreset(p) {
    }
    function aws_cdk_lib_aws_mediaconvert_CfnQueueProps(p) {
    }
    function aws_cdk_lib_aws_mediaconvert_CfnQueue(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannelProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cdiInputSpecification) || (p.cdiInputSpecification, void 0), visitedObjects.has(p.destinations) || (p.destinations, void 0), visitedObjects.has(p.encoderSettings) || (p.encoderSettings, void 0), visitedObjects.has(p.inputAttachments) || (p.inputAttachments, void 0), visitedObjects.has(p.inputSpecification) || (p.inputSpecification, void 0), visitedObjects.has(p.maintenance) || (p.maintenance, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_AacSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_Ac3SettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_AncillarySourceSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_ArchiveCdnSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.archiveS3Settings) || (p.archiveS3Settings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_ArchiveContainerSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.m2TsSettings) || (p.m2TsSettings, void 0), visitedObjects.has(p.rawSettings) || (p.rawSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_ArchiveGroupSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.archiveCdnSettings) || (p.archiveCdnSettings, void 0), visitedObjects.has(p.destination) || (p.destination, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_ArchiveOutputSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.containerSettings) || (p.containerSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_ArchiveS3SettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_AribDestinationSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_AribSourceSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_AudioChannelMappingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.inputChannelLevels) || (p.inputChannelLevels, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_AudioCodecSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.aacSettings) || (p.aacSettings, void 0), visitedObjects.has(p.ac3Settings) || (p.ac3Settings, void 0), visitedObjects.has(p.eac3AtmosSettings) || (p.eac3AtmosSettings, void 0), visitedObjects.has(p.eac3Settings) || (p.eac3Settings, void 0), visitedObjects.has(p.mp2Settings) || (p.mp2Settings, void 0), visitedObjects.has(p.passThroughSettings) || (p.passThroughSettings, void 0), visitedObjects.has(p.wavSettings) || (p.wavSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_AudioDescriptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.audioNormalizationSettings) || (p.audioNormalizationSettings, void 0), visitedObjects.has(p.audioWatermarkingSettings) || (p.audioWatermarkingSettings, void 0), visitedObjects.has(p.codecSettings) || (p.codecSettings, void 0), visitedObjects.has(p.remixSettings) || (p.remixSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_AudioDolbyEDecodeProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_AudioHlsRenditionSelectionProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_AudioLanguageSelectionProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_AudioNormalizationSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_AudioOnlyHlsSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.audioOnlyImage) || (p.audioOnlyImage, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_AudioPidSelectionProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_AudioSelectorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.selectorSettings) || (p.selectorSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_AudioSelectorSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.audioHlsRenditionSelection) || (p.audioHlsRenditionSelection, void 0), visitedObjects.has(p.audioLanguageSelection) || (p.audioLanguageSelection, void 0), visitedObjects.has(p.audioPidSelection) || (p.audioPidSelection, void 0), visitedObjects.has(p.audioTrackSelection) || (p.audioTrackSelection, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_AudioSilenceFailoverSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_AudioTrackProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_AudioTrackSelectionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dolbyEDecode) || (p.dolbyEDecode, void 0), visitedObjects.has(p.tracks) || (p.tracks, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_AudioWatermarkSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.nielsenWatermarksSettings) || (p.nielsenWatermarksSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_AutomaticInputFailoverSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.failoverConditions) || (p.failoverConditions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_AvailBlankingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.availBlankingImage) || (p.availBlankingImage, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_AvailConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.availSettings) || (p.availSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_AvailSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.esam) || (p.esam, void 0), visitedObjects.has(p.scte35SpliceInsert) || (p.scte35SpliceInsert, void 0), visitedObjects.has(p.scte35TimeSignalApos) || (p.scte35TimeSignalApos, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_BlackoutSlateProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.blackoutSlateImage) || (p.blackoutSlateImage, void 0), visitedObjects.has(p.networkEndBlackoutImage) || (p.networkEndBlackoutImage, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_BurnInDestinationSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.font) || (p.font, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_CaptionDescriptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destinationSettings) || (p.destinationSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_CaptionDestinationSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.aribDestinationSettings) || (p.aribDestinationSettings, void 0), visitedObjects.has(p.burnInDestinationSettings) || (p.burnInDestinationSettings, void 0), visitedObjects.has(p.dvbSubDestinationSettings) || (p.dvbSubDestinationSettings, void 0), visitedObjects.has(p.ebuTtDDestinationSettings) || (p.ebuTtDDestinationSettings, void 0), visitedObjects.has(p.embeddedDestinationSettings) || (p.embeddedDestinationSettings, void 0), visitedObjects.has(p.embeddedPlusScte20DestinationSettings) || (p.embeddedPlusScte20DestinationSettings, void 0), visitedObjects.has(p.rtmpCaptionInfoDestinationSettings) || (p.rtmpCaptionInfoDestinationSettings, void 0), visitedObjects.has(p.scte20PlusEmbeddedDestinationSettings) || (p.scte20PlusEmbeddedDestinationSettings, void 0), visitedObjects.has(p.scte27DestinationSettings) || (p.scte27DestinationSettings, void 0), visitedObjects.has(p.smpteTtDestinationSettings) || (p.smpteTtDestinationSettings, void 0), visitedObjects.has(p.teletextDestinationSettings) || (p.teletextDestinationSettings, void 0), visitedObjects.has(p.ttmlDestinationSettings) || (p.ttmlDestinationSettings, void 0), visitedObjects.has(p.webvttDestinationSettings) || (p.webvttDestinationSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_CaptionLanguageMappingProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_CaptionRectangleProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_CaptionSelectorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.selectorSettings) || (p.selectorSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_CaptionSelectorSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ancillarySourceSettings) || (p.ancillarySourceSettings, void 0), visitedObjects.has(p.aribSourceSettings) || (p.aribSourceSettings, void 0), visitedObjects.has(p.dvbSubSourceSettings) || (p.dvbSubSourceSettings, void 0), visitedObjects.has(p.embeddedSourceSettings) || (p.embeddedSourceSettings, void 0), visitedObjects.has(p.scte20SourceSettings) || (p.scte20SourceSettings, void 0), visitedObjects.has(p.scte27SourceSettings) || (p.scte27SourceSettings, void 0), visitedObjects.has(p.teletextSourceSettings) || (p.teletextSourceSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_CdiInputSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_ColorSpacePassthroughSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_DolbyVision81SettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_DvbNitSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_DvbSdtSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_DvbSubDestinationSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.font) || (p.font, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_DvbSubSourceSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_DvbTdtSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_Eac3AtmosSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_Eac3SettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_EbuTtDDestinationSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_EmbeddedDestinationSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_EmbeddedPlusScte20DestinationSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_EmbeddedSourceSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_EncoderSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.audioDescriptions) || (p.audioDescriptions, void 0), visitedObjects.has(p.availBlanking) || (p.availBlanking, void 0), visitedObjects.has(p.availConfiguration) || (p.availConfiguration, void 0), visitedObjects.has(p.blackoutSlate) || (p.blackoutSlate, void 0), visitedObjects.has(p.captionDescriptions) || (p.captionDescriptions, void 0), visitedObjects.has(p.featureActivations) || (p.featureActivations, void 0), visitedObjects.has(p.globalConfiguration) || (p.globalConfiguration, void 0), visitedObjects.has(p.motionGraphicsConfiguration) || (p.motionGraphicsConfiguration, void 0), visitedObjects.has(p.nielsenConfiguration) || (p.nielsenConfiguration, void 0), visitedObjects.has(p.outputGroups) || (p.outputGroups, void 0), visitedObjects.has(p.timecodeConfig) || (p.timecodeConfig, void 0), visitedObjects.has(p.videoDescriptions) || (p.videoDescriptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_EsamProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_FailoverConditionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.failoverConditionSettings) || (p.failoverConditionSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_FailoverConditionSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.audioSilenceSettings) || (p.audioSilenceSettings, void 0), visitedObjects.has(p.inputLossSettings) || (p.inputLossSettings, void 0), visitedObjects.has(p.videoBlackSettings) || (p.videoBlackSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_FeatureActivationsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_FecOutputSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_Fmp4HlsSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_FrameCaptureCdnSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.frameCaptureS3Settings) || (p.frameCaptureS3Settings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_FrameCaptureGroupSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destination) || (p.destination, void 0), visitedObjects.has(p.frameCaptureCdnSettings) || (p.frameCaptureCdnSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_FrameCaptureHlsSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_FrameCaptureOutputSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_FrameCaptureS3SettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_FrameCaptureSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.timecodeBurninSettings) || (p.timecodeBurninSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_GlobalConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.inputLossBehavior) || (p.inputLossBehavior, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_H264ColorSpaceSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.colorSpacePassthroughSettings) || (p.colorSpacePassthroughSettings, void 0), visitedObjects.has(p.rec601Settings) || (p.rec601Settings, void 0), visitedObjects.has(p.rec709Settings) || (p.rec709Settings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_H264FilterSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.temporalFilterSettings) || (p.temporalFilterSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_H264SettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.colorSpaceSettings) || (p.colorSpaceSettings, void 0), visitedObjects.has(p.filterSettings) || (p.filterSettings, void 0), visitedObjects.has(p.timecodeBurninSettings) || (p.timecodeBurninSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_H265ColorSpaceSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.colorSpacePassthroughSettings) || (p.colorSpacePassthroughSettings, void 0), visitedObjects.has(p.dolbyVision81Settings) || (p.dolbyVision81Settings, void 0), visitedObjects.has(p.hdr10Settings) || (p.hdr10Settings, void 0), visitedObjects.has(p.rec601Settings) || (p.rec601Settings, void 0), visitedObjects.has(p.rec709Settings) || (p.rec709Settings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_H265FilterSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.temporalFilterSettings) || (p.temporalFilterSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_H265SettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.colorSpaceSettings) || (p.colorSpaceSettings, void 0), visitedObjects.has(p.filterSettings) || (p.filterSettings, void 0), visitedObjects.has(p.timecodeBurninSettings) || (p.timecodeBurninSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_Hdr10SettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_HlsAkamaiSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_HlsBasicPutSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_HlsCdnSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.hlsAkamaiSettings) || (p.hlsAkamaiSettings, void 0), visitedObjects.has(p.hlsBasicPutSettings) || (p.hlsBasicPutSettings, void 0), visitedObjects.has(p.hlsMediaStoreSettings) || (p.hlsMediaStoreSettings, void 0), visitedObjects.has(p.hlsS3Settings) || (p.hlsS3Settings, void 0), visitedObjects.has(p.hlsWebdavSettings) || (p.hlsWebdavSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_HlsGroupSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.captionLanguageMappings) || (p.captionLanguageMappings, void 0), visitedObjects.has(p.destination) || (p.destination, void 0), visitedObjects.has(p.hlsCdnSettings) || (p.hlsCdnSettings, void 0), visitedObjects.has(p.keyProviderSettings) || (p.keyProviderSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_HlsInputSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_HlsMediaStoreSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_HlsOutputSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.hlsSettings) || (p.hlsSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_HlsS3SettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_HlsSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.audioOnlyHlsSettings) || (p.audioOnlyHlsSettings, void 0), visitedObjects.has(p.fmp4HlsSettings) || (p.fmp4HlsSettings, void 0), visitedObjects.has(p.frameCaptureHlsSettings) || (p.frameCaptureHlsSettings, void 0), visitedObjects.has(p.standardHlsSettings) || (p.standardHlsSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_HlsWebdavSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_HtmlMotionGraphicsSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_InputAttachmentProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.automaticInputFailoverSettings) || (p.automaticInputFailoverSettings, void 0), visitedObjects.has(p.inputSettings) || (p.inputSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_InputChannelLevelProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_InputLocationProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_InputLossBehaviorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.inputLossImageSlate) || (p.inputLossImageSlate, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_InputLossFailoverSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_InputSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.audioSelectors) || (p.audioSelectors, void 0), visitedObjects.has(p.captionSelectors) || (p.captionSelectors, void 0), visitedObjects.has(p.networkInputSettings) || (p.networkInputSettings, void 0), visitedObjects.has(p.videoSelector) || (p.videoSelector, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_InputSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_KeyProviderSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.staticKeySettings) || (p.staticKeySettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_M2tsSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dvbNitSettings) || (p.dvbNitSettings, void 0), visitedObjects.has(p.dvbSdtSettings) || (p.dvbSdtSettings, void 0), visitedObjects.has(p.dvbTdtSettings) || (p.dvbTdtSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_M3u8SettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_MaintenanceCreateSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_MaintenanceUpdateSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_MediaPackageGroupSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destination) || (p.destination, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_MediaPackageOutputDestinationSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_MediaPackageOutputSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_MotionGraphicsConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.motionGraphicsSettings) || (p.motionGraphicsSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_MotionGraphicsSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.htmlMotionGraphicsSettings) || (p.htmlMotionGraphicsSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_Mp2SettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_Mpeg2FilterSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.temporalFilterSettings) || (p.temporalFilterSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_Mpeg2SettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.filterSettings) || (p.filterSettings, void 0), visitedObjects.has(p.timecodeBurninSettings) || (p.timecodeBurninSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_MsSmoothGroupSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destination) || (p.destination, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_MsSmoothOutputSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_MultiplexGroupSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_MultiplexOutputSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destination) || (p.destination, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_MultiplexProgramChannelDestinationSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_NetworkInputSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.hlsInputSettings) || (p.hlsInputSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_NielsenCBETProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_NielsenConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_NielsenNaesIiNwProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_NielsenWatermarksSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.nielsenCbetSettings) || (p.nielsenCbetSettings, void 0), visitedObjects.has(p.nielsenNaesIiNwSettings) || (p.nielsenNaesIiNwSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_OutputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.outputSettings) || (p.outputSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_OutputDestinationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.mediaPackageSettings) || (p.mediaPackageSettings, void 0), visitedObjects.has(p.multiplexSettings) || (p.multiplexSettings, void 0), visitedObjects.has(p.settings) || (p.settings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_OutputDestinationSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_OutputGroupProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.outputGroupSettings) || (p.outputGroupSettings, void 0), visitedObjects.has(p.outputs) || (p.outputs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_OutputGroupSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.archiveGroupSettings) || (p.archiveGroupSettings, void 0), visitedObjects.has(p.frameCaptureGroupSettings) || (p.frameCaptureGroupSettings, void 0), visitedObjects.has(p.hlsGroupSettings) || (p.hlsGroupSettings, void 0), visitedObjects.has(p.mediaPackageGroupSettings) || (p.mediaPackageGroupSettings, void 0), visitedObjects.has(p.msSmoothGroupSettings) || (p.msSmoothGroupSettings, void 0), visitedObjects.has(p.multiplexGroupSettings) || (p.multiplexGroupSettings, void 0), visitedObjects.has(p.rtmpGroupSettings) || (p.rtmpGroupSettings, void 0), visitedObjects.has(p.udpGroupSettings) || (p.udpGroupSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_OutputLocationRefProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_OutputSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.archiveOutputSettings) || (p.archiveOutputSettings, void 0), visitedObjects.has(p.frameCaptureOutputSettings) || (p.frameCaptureOutputSettings, void 0), visitedObjects.has(p.hlsOutputSettings) || (p.hlsOutputSettings, void 0), visitedObjects.has(p.mediaPackageOutputSettings) || (p.mediaPackageOutputSettings, void 0), visitedObjects.has(p.msSmoothOutputSettings) || (p.msSmoothOutputSettings, void 0), visitedObjects.has(p.multiplexOutputSettings) || (p.multiplexOutputSettings, void 0), visitedObjects.has(p.rtmpOutputSettings) || (p.rtmpOutputSettings, void 0), visitedObjects.has(p.udpOutputSettings) || (p.udpOutputSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_PassThroughSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_RawSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_Rec601SettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_Rec709SettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_RemixSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.channelMappings) || (p.channelMappings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_RtmpCaptionInfoDestinationSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_RtmpGroupSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_RtmpOutputSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destination) || (p.destination, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_Scte20PlusEmbeddedDestinationSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_Scte20SourceSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_Scte27DestinationSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_Scte27SourceSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_Scte35SpliceInsertProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_Scte35TimeSignalAposProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_SmpteTtDestinationSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_StandardHlsSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.m3U8Settings) || (p.m3U8Settings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_StaticKeySettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.keyProviderServer) || (p.keyProviderServer, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_TeletextDestinationSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_TeletextSourceSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.outputRectangle) || (p.outputRectangle, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_TemporalFilterSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_TimecodeBurninSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_TimecodeConfigProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_TtmlDestinationSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_UdpContainerSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.m2TsSettings) || (p.m2TsSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_UdpGroupSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_UdpOutputSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.containerSettings) || (p.containerSettings, void 0), visitedObjects.has(p.destination) || (p.destination, void 0), visitedObjects.has(p.fecOutputSettings) || (p.fecOutputSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_VideoBlackFailoverSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_VideoCodecSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.frameCaptureSettings) || (p.frameCaptureSettings, void 0), visitedObjects.has(p.h264Settings) || (p.h264Settings, void 0), visitedObjects.has(p.h265Settings) || (p.h265Settings, void 0), visitedObjects.has(p.mpeg2Settings) || (p.mpeg2Settings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_VideoDescriptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.codecSettings) || (p.codecSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_VideoSelectorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.colorSpaceSettings) || (p.colorSpaceSettings, void 0), visitedObjects.has(p.selectorSettings) || (p.selectorSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_VideoSelectorColorSpaceSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.hdr10Settings) || (p.hdr10Settings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_VideoSelectorPidProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_VideoSelectorProgramIdProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_VideoSelectorSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.videoSelectorPid) || (p.videoSelectorPid, void 0), visitedObjects.has(p.videoSelectorProgramId) || (p.videoSelectorProgramId, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_VpcOutputSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_WavSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnChannel_WebvttDestinationSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnInputProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destinations) || (p.destinations, void 0), visitedObjects.has(p.inputDevices) || (p.inputDevices, void 0), visitedObjects.has(p.mediaConnectFlows) || (p.mediaConnectFlows, void 0), visitedObjects.has(p.sources) || (p.sources, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnInput(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnInput_InputDestinationRequestProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnInput_InputDeviceRequestProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnInput_InputDeviceSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnInput_InputSourceRequestProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnInput_InputVpcRequestProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnInput_MediaConnectFlowRequestProperty(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnInputSecurityGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.whitelistRules) || (p.whitelistRules, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_medialive_CfnInputSecurityGroup(p) {
    }
    function aws_cdk_lib_aws_medialive_CfnInputSecurityGroup_InputWhitelistRuleCidrProperty(p) {
    }
    function aws_cdk_lib_aws_mediapackage_CfnAssetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.egressEndpoints) || (p.egressEndpoints, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediapackage_CfnAsset(p) {
    }
    function aws_cdk_lib_aws_mediapackage_CfnAsset_EgressEndpointProperty(p) {
    }
    function aws_cdk_lib_aws_mediapackage_CfnChannelProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.egressAccessLogs) || (p.egressAccessLogs, void 0), visitedObjects.has(p.hlsIngest) || (p.hlsIngest, void 0), visitedObjects.has(p.ingressAccessLogs) || (p.ingressAccessLogs, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediapackage_CfnChannel(p) {
    }
    function aws_cdk_lib_aws_mediapackage_CfnChannel_HlsIngestProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ingestEndpoints) || (p.ingestEndpoints, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediapackage_CfnChannel_IngestEndpointProperty(p) {
    }
    function aws_cdk_lib_aws_mediapackage_CfnChannel_LogConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_mediapackage_CfnOriginEndpointProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.authorization) || (p.authorization, void 0), visitedObjects.has(p.cmafPackage) || (p.cmafPackage, void 0), visitedObjects.has(p.dashPackage) || (p.dashPackage, void 0), visitedObjects.has(p.hlsPackage) || (p.hlsPackage, void 0), visitedObjects.has(p.mssPackage) || (p.mssPackage, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediapackage_CfnOriginEndpoint(p) {
    }
    function aws_cdk_lib_aws_mediapackage_CfnOriginEndpoint_AuthorizationProperty(p) {
    }
    function aws_cdk_lib_aws_mediapackage_CfnOriginEndpoint_CmafEncryptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.spekeKeyProvider) || (p.spekeKeyProvider, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediapackage_CfnOriginEndpoint_CmafPackageProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.encryption) || (p.encryption, void 0), visitedObjects.has(p.hlsManifests) || (p.hlsManifests, void 0), visitedObjects.has(p.streamSelection) || (p.streamSelection, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediapackage_CfnOriginEndpoint_DashEncryptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.spekeKeyProvider) || (p.spekeKeyProvider, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediapackage_CfnOriginEndpoint_DashPackageProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.encryption) || (p.encryption, void 0), visitedObjects.has(p.streamSelection) || (p.streamSelection, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediapackage_CfnOriginEndpoint_EncryptionContractConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_mediapackage_CfnOriginEndpoint_HlsEncryptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.spekeKeyProvider) || (p.spekeKeyProvider, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediapackage_CfnOriginEndpoint_HlsManifestProperty(p) {
    }
    function aws_cdk_lib_aws_mediapackage_CfnOriginEndpoint_HlsPackageProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.encryption) || (p.encryption, void 0), visitedObjects.has(p.streamSelection) || (p.streamSelection, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediapackage_CfnOriginEndpoint_MssEncryptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.spekeKeyProvider) || (p.spekeKeyProvider, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediapackage_CfnOriginEndpoint_MssPackageProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.encryption) || (p.encryption, void 0), visitedObjects.has(p.streamSelection) || (p.streamSelection, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediapackage_CfnOriginEndpoint_SpekeKeyProviderProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.encryptionContractConfiguration) || (p.encryptionContractConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediapackage_CfnOriginEndpoint_StreamSelectionProperty(p) {
    }
    function aws_cdk_lib_aws_mediapackage_CfnPackagingConfigurationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.cmafPackage) || (p.cmafPackage, void 0), visitedObjects.has(p.dashPackage) || (p.dashPackage, void 0), visitedObjects.has(p.hlsPackage) || (p.hlsPackage, void 0), visitedObjects.has(p.mssPackage) || (p.mssPackage, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediapackage_CfnPackagingConfiguration(p) {
    }
    function aws_cdk_lib_aws_mediapackage_CfnPackagingConfiguration_CmafEncryptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.spekeKeyProvider) || (p.spekeKeyProvider, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediapackage_CfnPackagingConfiguration_CmafPackageProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.hlsManifests) || (p.hlsManifests, void 0), visitedObjects.has(p.encryption) || (p.encryption, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediapackage_CfnPackagingConfiguration_DashEncryptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.spekeKeyProvider) || (p.spekeKeyProvider, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediapackage_CfnPackagingConfiguration_DashManifestProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.streamSelection) || (p.streamSelection, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediapackage_CfnPackagingConfiguration_DashPackageProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dashManifests) || (p.dashManifests, void 0), visitedObjects.has(p.encryption) || (p.encryption, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediapackage_CfnPackagingConfiguration_EncryptionContractConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_mediapackage_CfnPackagingConfiguration_HlsEncryptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.spekeKeyProvider) || (p.spekeKeyProvider, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediapackage_CfnPackagingConfiguration_HlsManifestProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.streamSelection) || (p.streamSelection, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediapackage_CfnPackagingConfiguration_HlsPackageProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.hlsManifests) || (p.hlsManifests, void 0), visitedObjects.has(p.encryption) || (p.encryption, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediapackage_CfnPackagingConfiguration_MssEncryptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.spekeKeyProvider) || (p.spekeKeyProvider, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediapackage_CfnPackagingConfiguration_MssManifestProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.streamSelection) || (p.streamSelection, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediapackage_CfnPackagingConfiguration_MssPackageProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.mssManifests) || (p.mssManifests, void 0), visitedObjects.has(p.encryption) || (p.encryption, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediapackage_CfnPackagingConfiguration_SpekeKeyProviderProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.encryptionContractConfiguration) || (p.encryptionContractConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediapackage_CfnPackagingConfiguration_StreamSelectionProperty(p) {
    }
    function aws_cdk_lib_aws_mediapackage_CfnPackagingGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.authorization) || (p.authorization, void 0), visitedObjects.has(p.egressAccessLogs) || (p.egressAccessLogs, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediapackage_CfnPackagingGroup(p) {
    }
    function aws_cdk_lib_aws_mediapackage_CfnPackagingGroup_AuthorizationProperty(p) {
    }
    function aws_cdk_lib_aws_mediapackage_CfnPackagingGroup_LogConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_mediastore_CfnContainerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.corsPolicy) || (p.corsPolicy, void 0), visitedObjects.has(p.metricPolicy) || (p.metricPolicy, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediastore_CfnContainer(p) {
    }
    function aws_cdk_lib_aws_mediastore_CfnContainer_CorsRuleProperty(p) {
    }
    function aws_cdk_lib_aws_mediastore_CfnContainer_MetricPolicyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.metricPolicyRules) || (p.metricPolicyRules, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediastore_CfnContainer_MetricPolicyRuleProperty(p) {
    }
    function aws_cdk_lib_aws_mediatailor_CfnPlaybackConfigurationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.availSuppression) || (p.availSuppression, void 0), visitedObjects.has(p.bumper) || (p.bumper, void 0), visitedObjects.has(p.cdnConfiguration) || (p.cdnConfiguration, void 0), visitedObjects.has(p.configurationAliases) || (p.configurationAliases, void 0), visitedObjects.has(p.dashConfiguration) || (p.dashConfiguration, void 0), visitedObjects.has(p.hlsConfiguration) || (p.hlsConfiguration, void 0), visitedObjects.has(p.livePreRollConfiguration) || (p.livePreRollConfiguration, void 0), visitedObjects.has(p.manifestProcessingRules) || (p.manifestProcessingRules, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mediatailor_CfnPlaybackConfiguration(p) {
    }
    function aws_cdk_lib_aws_mediatailor_CfnPlaybackConfiguration_AdMarkerPassthroughProperty(p) {
    }
    function aws_cdk_lib_aws_mediatailor_CfnPlaybackConfiguration_AvailSuppressionProperty(p) {
    }
    function aws_cdk_lib_aws_mediatailor_CfnPlaybackConfiguration_BumperProperty(p) {
    }
    function aws_cdk_lib_aws_mediatailor_CfnPlaybackConfiguration_CdnConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_mediatailor_CfnPlaybackConfiguration_DashConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_mediatailor_CfnPlaybackConfiguration_HlsConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_mediatailor_CfnPlaybackConfiguration_LivePreRollConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_mediatailor_CfnPlaybackConfiguration_ManifestProcessingRulesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.adMarkerPassthrough) || (p.adMarkerPassthrough, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_memorydb_CfnACLProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_memorydb_CfnACL(p) {
    }
    function aws_cdk_lib_aws_memorydb_CfnClusterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.clusterEndpoint) || (p.clusterEndpoint, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_memorydb_CfnCluster(p) {
    }
    function aws_cdk_lib_aws_memorydb_CfnCluster_EndpointProperty(p) {
    }
    function aws_cdk_lib_aws_memorydb_CfnParameterGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_memorydb_CfnParameterGroup(p) {
    }
    function aws_cdk_lib_aws_memorydb_CfnSubnetGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_memorydb_CfnSubnetGroup(p) {
    }
    function aws_cdk_lib_aws_memorydb_CfnUserProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_memorydb_CfnUser(p) {
    }
    function aws_cdk_lib_aws_memorydb_CfnUser_AuthenticationModeProperty(p) {
    }
    function aws_cdk_lib_aws_msk_CfnBatchScramSecretProps(p) {
    }
    function aws_cdk_lib_aws_msk_CfnBatchScramSecret(p) {
    }
    function aws_cdk_lib_aws_msk_CfnClusterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.brokerNodeGroupInfo) || (p.brokerNodeGroupInfo, void 0), visitedObjects.has(p.clientAuthentication) || (p.clientAuthentication, void 0), visitedObjects.has(p.configurationInfo) || (p.configurationInfo, void 0), visitedObjects.has(p.encryptionInfo) || (p.encryptionInfo, void 0), visitedObjects.has(p.loggingInfo) || (p.loggingInfo, void 0), visitedObjects.has(p.openMonitoring) || (p.openMonitoring, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_msk_CfnCluster(p) {
    }
    function aws_cdk_lib_aws_msk_CfnCluster_BrokerLogsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cloudWatchLogs) || (p.cloudWatchLogs, void 0), visitedObjects.has(p.firehose) || (p.firehose, void 0), visitedObjects.has(p.s3) || (p.s3, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_msk_CfnCluster_BrokerNodeGroupInfoProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.connectivityInfo) || (p.connectivityInfo, void 0), visitedObjects.has(p.storageInfo) || (p.storageInfo, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_msk_CfnCluster_ClientAuthenticationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sasl) || (p.sasl, void 0), visitedObjects.has(p.tls) || (p.tls, void 0), visitedObjects.has(p.unauthenticated) || (p.unauthenticated, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_msk_CfnCluster_CloudWatchLogsProperty(p) {
    }
    function aws_cdk_lib_aws_msk_CfnCluster_ConfigurationInfoProperty(p) {
    }
    function aws_cdk_lib_aws_msk_CfnCluster_ConnectivityInfoProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.publicAccess) || (p.publicAccess, void 0), visitedObjects.has(p.vpcConnectivity) || (p.vpcConnectivity, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_msk_CfnCluster_EBSStorageInfoProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.provisionedThroughput) || (p.provisionedThroughput, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_msk_CfnCluster_EncryptionAtRestProperty(p) {
    }
    function aws_cdk_lib_aws_msk_CfnCluster_EncryptionInTransitProperty(p) {
    }
    function aws_cdk_lib_aws_msk_CfnCluster_EncryptionInfoProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.encryptionAtRest) || (p.encryptionAtRest, void 0), visitedObjects.has(p.encryptionInTransit) || (p.encryptionInTransit, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_msk_CfnCluster_FirehoseProperty(p) {
    }
    function aws_cdk_lib_aws_msk_CfnCluster_IamProperty(p) {
    }
    function aws_cdk_lib_aws_msk_CfnCluster_JmxExporterProperty(p) {
    }
    function aws_cdk_lib_aws_msk_CfnCluster_LoggingInfoProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.brokerLogs) || (p.brokerLogs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_msk_CfnCluster_NodeExporterProperty(p) {
    }
    function aws_cdk_lib_aws_msk_CfnCluster_OpenMonitoringProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.prometheus) || (p.prometheus, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_msk_CfnCluster_PrometheusProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.jmxExporter) || (p.jmxExporter, void 0), visitedObjects.has(p.nodeExporter) || (p.nodeExporter, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_msk_CfnCluster_ProvisionedThroughputProperty(p) {
    }
    function aws_cdk_lib_aws_msk_CfnCluster_PublicAccessProperty(p) {
    }
    function aws_cdk_lib_aws_msk_CfnCluster_S3Property(p) {
    }
    function aws_cdk_lib_aws_msk_CfnCluster_SaslProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.iam) || (p.iam, void 0), visitedObjects.has(p.scram) || (p.scram, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_msk_CfnCluster_ScramProperty(p) {
    }
    function aws_cdk_lib_aws_msk_CfnCluster_StorageInfoProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ebsStorageInfo) || (p.ebsStorageInfo, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_msk_CfnCluster_TlsProperty(p) {
    }
    function aws_cdk_lib_aws_msk_CfnCluster_UnauthenticatedProperty(p) {
    }
    function aws_cdk_lib_aws_msk_CfnCluster_VpcConnectivityProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.clientAuthentication) || (p.clientAuthentication, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_msk_CfnCluster_VpcConnectivityClientAuthenticationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sasl) || (p.sasl, void 0), visitedObjects.has(p.tls) || (p.tls, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_msk_CfnCluster_VpcConnectivityIamProperty(p) {
    }
    function aws_cdk_lib_aws_msk_CfnCluster_VpcConnectivitySaslProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.iam) || (p.iam, void 0), visitedObjects.has(p.scram) || (p.scram, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_msk_CfnCluster_VpcConnectivityScramProperty(p) {
    }
    function aws_cdk_lib_aws_msk_CfnCluster_VpcConnectivityTlsProperty(p) {
    }
    function aws_cdk_lib_aws_msk_CfnClusterPolicyProps(p) {
    }
    function aws_cdk_lib_aws_msk_CfnClusterPolicy(p) {
    }
    function aws_cdk_lib_aws_msk_CfnConfigurationProps(p) {
    }
    function aws_cdk_lib_aws_msk_CfnConfiguration(p) {
    }
    function aws_cdk_lib_aws_msk_CfnServerlessClusterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.clientAuthentication) || (p.clientAuthentication, void 0), visitedObjects.has(p.vpcConfigs) || (p.vpcConfigs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_msk_CfnServerlessCluster(p) {
    }
    function aws_cdk_lib_aws_msk_CfnServerlessCluster_ClientAuthenticationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sasl) || (p.sasl, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_msk_CfnServerlessCluster_IamProperty(p) {
    }
    function aws_cdk_lib_aws_msk_CfnServerlessCluster_SaslProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.iam) || (p.iam, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_msk_CfnServerlessCluster_VpcConfigProperty(p) {
    }
    function aws_cdk_lib_aws_msk_CfnVpcConnectionProps(p) {
    }
    function aws_cdk_lib_aws_msk_CfnVpcConnection(p) {
    }
    function aws_cdk_lib_aws_mwaa_CfnEnvironmentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.loggingConfiguration) || (p.loggingConfiguration, void 0), visitedObjects.has(p.networkConfiguration) || (p.networkConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mwaa_CfnEnvironment(p) {
    }
    function aws_cdk_lib_aws_mwaa_CfnEnvironment_LoggingConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dagProcessingLogs) || (p.dagProcessingLogs, void 0), visitedObjects.has(p.schedulerLogs) || (p.schedulerLogs, void 0), visitedObjects.has(p.taskLogs) || (p.taskLogs, void 0), visitedObjects.has(p.webserverLogs) || (p.webserverLogs, void 0), visitedObjects.has(p.workerLogs) || (p.workerLogs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_mwaa_CfnEnvironment_ModuleLoggingConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_mwaa_CfnEnvironment_NetworkConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_neptune_CfnDBClusterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.associatedRoles) || (p.associatedRoles, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_neptune_CfnDBCluster(p) {
    }
    function aws_cdk_lib_aws_neptune_CfnDBCluster_DBClusterRoleProperty(p) {
    }
    function aws_cdk_lib_aws_neptune_CfnDBClusterParameterGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_neptune_CfnDBClusterParameterGroup(p) {
    }
    function aws_cdk_lib_aws_neptune_CfnDBInstanceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_neptune_CfnDBInstance(p) {
    }
    function aws_cdk_lib_aws_neptune_CfnDBParameterGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_neptune_CfnDBParameterGroup(p) {
    }
    function aws_cdk_lib_aws_neptune_CfnDBSubnetGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_neptune_CfnDBSubnetGroup(p) {
    }
    function aws_cdk_lib_aws_networkfirewall_CfnFirewallProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.subnetMappings) || (p.subnetMappings, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkfirewall_CfnFirewall(p) {
    }
    function aws_cdk_lib_aws_networkfirewall_CfnFirewall_SubnetMappingProperty(p) {
    }
    function aws_cdk_lib_aws_networkfirewall_CfnFirewallPolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.firewallPolicy) || (p.firewallPolicy, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkfirewall_CfnFirewallPolicy(p) {
    }
    function aws_cdk_lib_aws_networkfirewall_CfnFirewallPolicy_ActionDefinitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.publishMetricAction) || (p.publishMetricAction, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkfirewall_CfnFirewallPolicy_CustomActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actionDefinition) || (p.actionDefinition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkfirewall_CfnFirewallPolicy_DimensionProperty(p) {
    }
    function aws_cdk_lib_aws_networkfirewall_CfnFirewallPolicy_FirewallPolicyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.policyVariables) || (p.policyVariables, void 0), visitedObjects.has(p.statefulEngineOptions) || (p.statefulEngineOptions, void 0), visitedObjects.has(p.statefulRuleGroupReferences) || (p.statefulRuleGroupReferences, void 0), visitedObjects.has(p.statelessCustomActions) || (p.statelessCustomActions, void 0), visitedObjects.has(p.statelessRuleGroupReferences) || (p.statelessRuleGroupReferences, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkfirewall_CfnFirewallPolicy_IPSetProperty(p) {
    }
    function aws_cdk_lib_aws_networkfirewall_CfnFirewallPolicy_PolicyVariablesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ruleVariables) || (p.ruleVariables, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkfirewall_CfnFirewallPolicy_PublishMetricActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dimensions) || (p.dimensions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkfirewall_CfnFirewallPolicy_StatefulEngineOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_networkfirewall_CfnFirewallPolicy_StatefulRuleGroupOverrideProperty(p) {
    }
    function aws_cdk_lib_aws_networkfirewall_CfnFirewallPolicy_StatefulRuleGroupReferenceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.override) || (p.override, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkfirewall_CfnFirewallPolicy_StatelessRuleGroupReferenceProperty(p) {
    }
    function aws_cdk_lib_aws_networkfirewall_CfnLoggingConfigurationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.loggingConfiguration) || (p.loggingConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkfirewall_CfnLoggingConfiguration(p) {
    }
    function aws_cdk_lib_aws_networkfirewall_CfnLoggingConfiguration_LogDestinationConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.logDestination) || (p.logDestination, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkfirewall_CfnLoggingConfiguration_LoggingConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.logDestinationConfigs) || (p.logDestinationConfigs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkfirewall_CfnRuleGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.ruleGroup) || (p.ruleGroup, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkfirewall_CfnRuleGroup(p) {
    }
    function aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_ActionDefinitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.publishMetricAction) || (p.publishMetricAction, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_AddressProperty(p) {
    }
    function aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_CustomActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actionDefinition) || (p.actionDefinition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_DimensionProperty(p) {
    }
    function aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_HeaderProperty(p) {
    }
    function aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_IPSetProperty(p) {
    }
    function aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_IPSetReferenceProperty(p) {
    }
    function aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_MatchAttributesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destinationPorts) || (p.destinationPorts, void 0), visitedObjects.has(p.destinations) || (p.destinations, void 0), visitedObjects.has(p.sourcePorts) || (p.sourcePorts, void 0), visitedObjects.has(p.sources) || (p.sources, void 0), visitedObjects.has(p.tcpFlags) || (p.tcpFlags, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_PortRangeProperty(p) {
    }
    function aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_PortSetProperty(p) {
    }
    function aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_PublishMetricActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dimensions) || (p.dimensions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_ReferenceSetsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ipSetReferences) || (p.ipSetReferences, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_RuleDefinitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.matchAttributes) || (p.matchAttributes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_RuleGroupProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.rulesSource) || (p.rulesSource, void 0), visitedObjects.has(p.referenceSets) || (p.referenceSets, void 0), visitedObjects.has(p.ruleVariables) || (p.ruleVariables, void 0), visitedObjects.has(p.statefulRuleOptions) || (p.statefulRuleOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_RuleOptionProperty(p) {
    }
    function aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_RuleVariablesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ipSets) || (p.ipSets, void 0), visitedObjects.has(p.portSets) || (p.portSets, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_RulesSourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.rulesSourceList) || (p.rulesSourceList, void 0), visitedObjects.has(p.statefulRules) || (p.statefulRules, void 0), visitedObjects.has(p.statelessRulesAndCustomActions) || (p.statelessRulesAndCustomActions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_RulesSourceListProperty(p) {
    }
    function aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_StatefulRuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.header) || (p.header, void 0), visitedObjects.has(p.ruleOptions) || (p.ruleOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_StatefulRuleOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_StatelessRuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ruleDefinition) || (p.ruleDefinition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_StatelessRulesAndCustomActionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.statelessRules) || (p.statelessRules, void 0), visitedObjects.has(p.customActions) || (p.customActions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_TCPFlagFieldProperty(p) {
    }
    function aws_cdk_lib_aws_networkmanager_CfnConnectAttachmentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.options) || (p.options, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkmanager_CfnConnectAttachment(p) {
    }
    function aws_cdk_lib_aws_networkmanager_CfnConnectAttachment_ConnectAttachmentOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_networkmanager_CfnConnectAttachment_ProposedSegmentChangeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkmanager_CfnConnectPeerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.bgpOptions) || (p.bgpOptions, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkmanager_CfnConnectPeer(p) {
    }
    function aws_cdk_lib_aws_networkmanager_CfnConnectPeer_BgpOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_networkmanager_CfnConnectPeer_ConnectPeerBgpConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_networkmanager_CfnConnectPeer_ConnectPeerConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bgpConfigurations) || (p.bgpConfigurations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkmanager_CfnCoreNetworkProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkmanager_CfnCoreNetwork(p) {
    }
    function aws_cdk_lib_aws_networkmanager_CfnCoreNetwork_CoreNetworkEdgeProperty(p) {
    }
    function aws_cdk_lib_aws_networkmanager_CfnCoreNetwork_CoreNetworkSegmentProperty(p) {
    }
    function aws_cdk_lib_aws_networkmanager_CfnCustomerGatewayAssociationProps(p) {
    }
    function aws_cdk_lib_aws_networkmanager_CfnCustomerGatewayAssociation(p) {
    }
    function aws_cdk_lib_aws_networkmanager_CfnDeviceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.location) || (p.location, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkmanager_CfnDevice(p) {
    }
    function aws_cdk_lib_aws_networkmanager_CfnDevice_LocationProperty(p) {
    }
    function aws_cdk_lib_aws_networkmanager_CfnGlobalNetworkProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkmanager_CfnGlobalNetwork(p) {
    }
    function aws_cdk_lib_aws_networkmanager_CfnLinkProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.bandwidth) || (p.bandwidth, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkmanager_CfnLink(p) {
    }
    function aws_cdk_lib_aws_networkmanager_CfnLink_BandwidthProperty(p) {
    }
    function aws_cdk_lib_aws_networkmanager_CfnLinkAssociationProps(p) {
    }
    function aws_cdk_lib_aws_networkmanager_CfnLinkAssociation(p) {
    }
    function aws_cdk_lib_aws_networkmanager_CfnSiteProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.location) || (p.location, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkmanager_CfnSite(p) {
    }
    function aws_cdk_lib_aws_networkmanager_CfnSite_LocationProperty(p) {
    }
    function aws_cdk_lib_aws_networkmanager_CfnSiteToSiteVpnAttachmentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkmanager_CfnSiteToSiteVpnAttachment(p) {
    }
    function aws_cdk_lib_aws_networkmanager_CfnSiteToSiteVpnAttachment_ProposedSegmentChangeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkmanager_CfnTransitGatewayPeeringProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkmanager_CfnTransitGatewayPeering(p) {
    }
    function aws_cdk_lib_aws_networkmanager_CfnTransitGatewayRegistrationProps(p) {
    }
    function aws_cdk_lib_aws_networkmanager_CfnTransitGatewayRegistration(p) {
    }
    function aws_cdk_lib_aws_networkmanager_CfnTransitGatewayRouteTableAttachmentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.proposedSegmentChange) || (p.proposedSegmentChange, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkmanager_CfnTransitGatewayRouteTableAttachment(p) {
    }
    function aws_cdk_lib_aws_networkmanager_CfnTransitGatewayRouteTableAttachment_ProposedSegmentChangeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkmanager_CfnVpcAttachmentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.options) || (p.options, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkmanager_CfnVpcAttachment(p) {
    }
    function aws_cdk_lib_aws_networkmanager_CfnVpcAttachment_ProposedSegmentChangeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_networkmanager_CfnVpcAttachment_VpcOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_nimblestudio_CfnLaunchProfileProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.streamConfiguration) || (p.streamConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_nimblestudio_CfnLaunchProfile(p) {
    }
    function aws_cdk_lib_aws_nimblestudio_CfnLaunchProfile_StreamConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sessionBackup) || (p.sessionBackup, void 0), visitedObjects.has(p.sessionStorage) || (p.sessionStorage, void 0), visitedObjects.has(p.volumeConfiguration) || (p.volumeConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_nimblestudio_CfnLaunchProfile_StreamConfigurationSessionBackupProperty(p) {
    }
    function aws_cdk_lib_aws_nimblestudio_CfnLaunchProfile_StreamConfigurationSessionStorageProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.root) || (p.root, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_nimblestudio_CfnLaunchProfile_StreamingSessionStorageRootProperty(p) {
    }
    function aws_cdk_lib_aws_nimblestudio_CfnLaunchProfile_VolumeConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_nimblestudio_CfnStreamingImageProps(p) {
    }
    function aws_cdk_lib_aws_nimblestudio_CfnStreamingImage(p) {
    }
    function aws_cdk_lib_aws_nimblestudio_CfnStreamingImage_StreamingImageEncryptionConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_nimblestudio_CfnStudioProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.studioEncryptionConfiguration) || (p.studioEncryptionConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_nimblestudio_CfnStudio(p) {
    }
    function aws_cdk_lib_aws_nimblestudio_CfnStudio_StudioEncryptionConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_nimblestudio_CfnStudioComponentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.configuration) || (p.configuration, void 0), visitedObjects.has(p.initializationScripts) || (p.initializationScripts, void 0), visitedObjects.has(p.scriptParameters) || (p.scriptParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_nimblestudio_CfnStudioComponent(p) {
    }
    function aws_cdk_lib_aws_nimblestudio_CfnStudioComponent_ActiveDirectoryComputerAttributeProperty(p) {
    }
    function aws_cdk_lib_aws_nimblestudio_CfnStudioComponent_ActiveDirectoryConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.computerAttributes) || (p.computerAttributes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_nimblestudio_CfnStudioComponent_ComputeFarmConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_nimblestudio_CfnStudioComponent_LicenseServiceConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_nimblestudio_CfnStudioComponent_ScriptParameterKeyValueProperty(p) {
    }
    function aws_cdk_lib_aws_nimblestudio_CfnStudioComponent_SharedFileSystemConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_nimblestudio_CfnStudioComponent_StudioComponentConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.activeDirectoryConfiguration) || (p.activeDirectoryConfiguration, void 0), visitedObjects.has(p.computeFarmConfiguration) || (p.computeFarmConfiguration, void 0), visitedObjects.has(p.licenseServiceConfiguration) || (p.licenseServiceConfiguration, void 0), visitedObjects.has(p.sharedFileSystemConfiguration) || (p.sharedFileSystemConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_nimblestudio_CfnStudioComponent_StudioComponentInitializationScriptProperty(p) {
    }
    function aws_cdk_lib_aws_oam_CfnLinkProps(p) {
    }
    function aws_cdk_lib_aws_oam_CfnLink(p) {
    }
    function aws_cdk_lib_aws_oam_CfnSinkProps(p) {
    }
    function aws_cdk_lib_aws_oam_CfnSink(p) {
    }
    function aws_cdk_lib_aws_omics_CfnAnnotationStoreProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.reference) || (p.reference, void 0), visitedObjects.has(p.sseConfig) || (p.sseConfig, void 0), visitedObjects.has(p.storeOptions) || (p.storeOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_omics_CfnAnnotationStore(p) {
    }
    function aws_cdk_lib_aws_omics_CfnAnnotationStore_ReferenceItemProperty(p) {
    }
    function aws_cdk_lib_aws_omics_CfnAnnotationStore_SseConfigProperty(p) {
    }
    function aws_cdk_lib_aws_omics_CfnAnnotationStore_StoreOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tsvStoreOptions) || (p.tsvStoreOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_omics_CfnAnnotationStore_TsvStoreOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.formatToHeader) || (p.formatToHeader, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_omics_CfnReferenceStoreProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sseConfig) || (p.sseConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_omics_CfnReferenceStore(p) {
    }
    function aws_cdk_lib_aws_omics_CfnReferenceStore_SseConfigProperty(p) {
    }
    function aws_cdk_lib_aws_omics_CfnRunGroupProps(p) {
    }
    function aws_cdk_lib_aws_omics_CfnRunGroup(p) {
    }
    function aws_cdk_lib_aws_omics_CfnSequenceStoreProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sseConfig) || (p.sseConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_omics_CfnSequenceStore(p) {
    }
    function aws_cdk_lib_aws_omics_CfnSequenceStore_SseConfigProperty(p) {
    }
    function aws_cdk_lib_aws_omics_CfnVariantStoreProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.reference) || (p.reference, void 0), visitedObjects.has(p.sseConfig) || (p.sseConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_omics_CfnVariantStore(p) {
    }
    function aws_cdk_lib_aws_omics_CfnVariantStore_ReferenceItemProperty(p) {
    }
    function aws_cdk_lib_aws_omics_CfnVariantStore_SseConfigProperty(p) {
    }
    function aws_cdk_lib_aws_omics_CfnWorkflowProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.parameterTemplate) || (p.parameterTemplate, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_omics_CfnWorkflow(p) {
    }
    function aws_cdk_lib_aws_omics_CfnWorkflow_WorkflowParameterProperty(p) {
    }
    function aws_cdk_lib_aws_opensearchserverless_CfnAccessPolicyProps(p) {
    }
    function aws_cdk_lib_aws_opensearchserverless_CfnAccessPolicy(p) {
    }
    function aws_cdk_lib_aws_opensearchserverless_CfnCollectionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_opensearchserverless_CfnCollection(p) {
    }
    function aws_cdk_lib_aws_opensearchserverless_CfnSecurityConfigProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.samlOptions) || (p.samlOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_opensearchserverless_CfnSecurityConfig(p) {
    }
    function aws_cdk_lib_aws_opensearchserverless_CfnSecurityConfig_SamlConfigOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_opensearchserverless_CfnSecurityPolicyProps(p) {
    }
    function aws_cdk_lib_aws_opensearchserverless_CfnSecurityPolicy(p) {
    }
    function aws_cdk_lib_aws_opensearchserverless_CfnVpcEndpointProps(p) {
    }
    function aws_cdk_lib_aws_opensearchserverless_CfnVpcEndpoint(p) {
    }
    function aws_cdk_lib_aws_opensearchservice_CapacityConfig(p) {
    }
    function aws_cdk_lib_aws_opensearchservice_ZoneAwarenessConfig(p) {
    }
    function aws_cdk_lib_aws_opensearchservice_EbsOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.volumeType) || (p.volumeType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_opensearchservice_LoggingOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.appLogGroup) || (p.appLogGroup, void 0), visitedObjects.has(p.auditLogGroup) || (p.auditLogGroup, void 0), visitedObjects.has(p.slowIndexLogGroup) || (p.slowIndexLogGroup, void 0), visitedObjects.has(p.slowSearchLogGroup) || (p.slowSearchLogGroup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_opensearchservice_EncryptionAtRestOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.kmsKey) || (p.kmsKey, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_opensearchservice_CognitoOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_opensearchservice_TLSSecurityPolicy(p) {
    }
    function aws_cdk_lib_aws_opensearchservice_AdvancedSecurityOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.masterUserPassword) || (p.masterUserPassword, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_opensearchservice_CustomEndpointOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.certificate) || (p.certificate, void 0), visitedObjects.has(p.hostedZone) || (p.hostedZone, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_opensearchservice_DomainProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.version) || (p.version, void 0), p.accessPolicies != null)
            for (const o of p.accessPolicies)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.capacity) || (p.capacity, void 0), visitedObjects.has(p.cognitoDashboardsAuth) || aws_cdk_lib_aws_opensearchservice_CognitoOptions(p.cognitoDashboardsAuth), visitedObjects.has(p.customEndpoint) || aws_cdk_lib_aws_opensearchservice_CustomEndpointOptions(p.customEndpoint), visitedObjects.has(p.ebs) || aws_cdk_lib_aws_opensearchservice_EbsOptions(p.ebs), visitedObjects.has(p.encryptionAtRest) || aws_cdk_lib_aws_opensearchservice_EncryptionAtRestOptions(p.encryptionAtRest), visitedObjects.has(p.fineGrainedAccessControl) || aws_cdk_lib_aws_opensearchservice_AdvancedSecurityOptions(p.fineGrainedAccessControl), visitedObjects.has(p.logging) || aws_cdk_lib_aws_opensearchservice_LoggingOptions(p.logging), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.tlsSecurityPolicy) || (p.tlsSecurityPolicy, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0), p.vpcSubnets != null)
            for (const o of p.vpcSubnets)
              visitedObjects.has(o) || aws_cdk_lib_aws_ec2_SubnetSelection(o);
          visitedObjects.has(p.zoneAwareness) || (p.zoneAwareness, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_opensearchservice_IDomain(p) {
    }
    function aws_cdk_lib_aws_opensearchservice_DomainAttributes(p) {
    }
    function aws_cdk_lib_aws_opensearchservice_Domain(p) {
    }
    function aws_cdk_lib_aws_opensearchservice_EngineVersion(p) {
    }
    function aws_cdk_lib_aws_opensearchservice_CfnDomainProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.advancedOptions) || (p.advancedOptions, void 0), visitedObjects.has(p.advancedSecurityOptions) || (p.advancedSecurityOptions, void 0), visitedObjects.has(p.clusterConfig) || (p.clusterConfig, void 0), visitedObjects.has(p.cognitoOptions) || (p.cognitoOptions, void 0), visitedObjects.has(p.domainEndpointOptions) || (p.domainEndpointOptions, void 0), visitedObjects.has(p.ebsOptions) || (p.ebsOptions, void 0), visitedObjects.has(p.encryptionAtRestOptions) || (p.encryptionAtRestOptions, void 0), visitedObjects.has(p.logPublishingOptions) || (p.logPublishingOptions, void 0), visitedObjects.has(p.nodeToNodeEncryptionOptions) || (p.nodeToNodeEncryptionOptions, void 0), visitedObjects.has(p.offPeakWindowOptions) || (p.offPeakWindowOptions, void 0), visitedObjects.has(p.snapshotOptions) || (p.snapshotOptions, void 0), visitedObjects.has(p.softwareUpdateOptions) || (p.softwareUpdateOptions, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.vpcOptions) || (p.vpcOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_opensearchservice_CfnDomain(p) {
    }
    function aws_cdk_lib_aws_opensearchservice_CfnDomain_AdvancedSecurityOptionsInputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.masterUserOptions) || (p.masterUserOptions, void 0), visitedObjects.has(p.samlOptions) || (p.samlOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_opensearchservice_CfnDomain_ClusterConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.zoneAwarenessConfig) || (p.zoneAwarenessConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_opensearchservice_CfnDomain_CognitoOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_opensearchservice_CfnDomain_DomainEndpointOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_opensearchservice_CfnDomain_EBSOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_opensearchservice_CfnDomain_EncryptionAtRestOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_opensearchservice_CfnDomain_IdpProperty(p) {
    }
    function aws_cdk_lib_aws_opensearchservice_CfnDomain_LogPublishingOptionProperty(p) {
    }
    function aws_cdk_lib_aws_opensearchservice_CfnDomain_MasterUserOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_opensearchservice_CfnDomain_NodeToNodeEncryptionOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_opensearchservice_CfnDomain_OffPeakWindowProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.windowStartTime) || (p.windowStartTime, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_opensearchservice_CfnDomain_OffPeakWindowOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.offPeakWindow) || (p.offPeakWindow, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_opensearchservice_CfnDomain_SAMLOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.idp) || (p.idp, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_opensearchservice_CfnDomain_ServiceSoftwareOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_opensearchservice_CfnDomain_SnapshotOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_opensearchservice_CfnDomain_SoftwareUpdateOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_opensearchservice_CfnDomain_VPCOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_opensearchservice_CfnDomain_WindowStartTimeProperty(p) {
    }
    function aws_cdk_lib_aws_opensearchservice_CfnDomain_ZoneAwarenessConfigProperty(p) {
    }
    function aws_cdk_lib_aws_opsworks_CfnAppProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.appSource) || (p.appSource, void 0), visitedObjects.has(p.attributes) || (p.attributes, void 0), visitedObjects.has(p.dataSources) || (p.dataSources, void 0), visitedObjects.has(p.environment) || (p.environment, void 0), visitedObjects.has(p.sslConfiguration) || (p.sslConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_opsworks_CfnApp(p) {
    }
    function aws_cdk_lib_aws_opsworks_CfnApp_DataSourceProperty(p) {
    }
    function aws_cdk_lib_aws_opsworks_CfnApp_EnvironmentVariableProperty(p) {
    }
    function aws_cdk_lib_aws_opsworks_CfnApp_SourceProperty(p) {
    }
    function aws_cdk_lib_aws_opsworks_CfnApp_SslConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_opsworks_CfnElasticLoadBalancerAttachmentProps(p) {
    }
    function aws_cdk_lib_aws_opsworks_CfnElasticLoadBalancerAttachment(p) {
    }
    function aws_cdk_lib_aws_opsworks_CfnInstanceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.blockDeviceMappings) || (p.blockDeviceMappings, void 0), visitedObjects.has(p.timeBasedAutoScaling) || (p.timeBasedAutoScaling, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_opsworks_CfnInstance(p) {
    }
    function aws_cdk_lib_aws_opsworks_CfnInstance_BlockDeviceMappingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ebs) || (p.ebs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_opsworks_CfnInstance_EbsBlockDeviceProperty(p) {
    }
    function aws_cdk_lib_aws_opsworks_CfnInstance_TimeBasedAutoScalingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.friday) || (p.friday, void 0), visitedObjects.has(p.monday) || (p.monday, void 0), visitedObjects.has(p.saturday) || (p.saturday, void 0), visitedObjects.has(p.sunday) || (p.sunday, void 0), visitedObjects.has(p.thursday) || (p.thursday, void 0), visitedObjects.has(p.tuesday) || (p.tuesday, void 0), visitedObjects.has(p.wednesday) || (p.wednesday, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_opsworks_CfnLayerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.attributes) || (p.attributes, void 0), visitedObjects.has(p.customRecipes) || (p.customRecipes, void 0), visitedObjects.has(p.lifecycleEventConfiguration) || (p.lifecycleEventConfiguration, void 0), visitedObjects.has(p.loadBasedAutoScaling) || (p.loadBasedAutoScaling, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.volumeConfigurations) || (p.volumeConfigurations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_opsworks_CfnLayer(p) {
    }
    function aws_cdk_lib_aws_opsworks_CfnLayer_AutoScalingThresholdsProperty(p) {
    }
    function aws_cdk_lib_aws_opsworks_CfnLayer_LifecycleEventConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.shutdownEventConfiguration) || (p.shutdownEventConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_opsworks_CfnLayer_LoadBasedAutoScalingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.downScaling) || (p.downScaling, void 0), visitedObjects.has(p.upScaling) || (p.upScaling, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_opsworks_CfnLayer_RecipesProperty(p) {
    }
    function aws_cdk_lib_aws_opsworks_CfnLayer_ShutdownEventConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_opsworks_CfnLayer_VolumeConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_opsworks_CfnStackProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.attributes) || (p.attributes, void 0), visitedObjects.has(p.chefConfiguration) || (p.chefConfiguration, void 0), visitedObjects.has(p.configurationManager) || (p.configurationManager, void 0), visitedObjects.has(p.customCookbooksSource) || (p.customCookbooksSource, void 0), visitedObjects.has(p.elasticIps) || (p.elasticIps, void 0), visitedObjects.has(p.rdsDbInstances) || (p.rdsDbInstances, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_opsworks_CfnStack(p) {
    }
    function aws_cdk_lib_aws_opsworks_CfnStack_ChefConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_opsworks_CfnStack_ElasticIpProperty(p) {
    }
    function aws_cdk_lib_aws_opsworks_CfnStack_RdsDbInstanceProperty(p) {
    }
    function aws_cdk_lib_aws_opsworks_CfnStack_SourceProperty(p) {
    }
    function aws_cdk_lib_aws_opsworks_CfnStack_StackConfigurationManagerProperty(p) {
    }
    function aws_cdk_lib_aws_opsworks_CfnUserProfileProps(p) {
    }
    function aws_cdk_lib_aws_opsworks_CfnUserProfile(p) {
    }
    function aws_cdk_lib_aws_opsworks_CfnVolumeProps(p) {
    }
    function aws_cdk_lib_aws_opsworks_CfnVolume(p) {
    }
    function aws_cdk_lib_aws_opsworkscm_CfnServerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.engineAttributes) || (p.engineAttributes, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_opsworkscm_CfnServer(p) {
    }
    function aws_cdk_lib_aws_opsworkscm_CfnServer_EngineAttributeProperty(p) {
    }
    function aws_cdk_lib_aws_organizations_CfnAccountProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_organizations_CfnAccount(p) {
    }
    function aws_cdk_lib_aws_organizations_CfnOrganizationalUnitProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_organizations_CfnOrganizationalUnit(p) {
    }
    function aws_cdk_lib_aws_organizations_CfnPolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_organizations_CfnPolicy(p) {
    }
    function aws_cdk_lib_aws_organizations_CfnResourcePolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_organizations_CfnResourcePolicy(p) {
    }
    function aws_cdk_lib_aws_osis_CfnPipelineProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.logPublishingOptions) || (p.logPublishingOptions, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.vpcOptions) || (p.vpcOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_osis_CfnPipeline(p) {
    }
    function aws_cdk_lib_aws_osis_CfnPipeline_CloudWatchLogDestinationProperty(p) {
    }
    function aws_cdk_lib_aws_osis_CfnPipeline_LogPublishingOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cloudWatchLogDestination) || (p.cloudWatchLogDestination, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_osis_CfnPipeline_VpcEndpointProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.vpcOptions) || (p.vpcOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_osis_CfnPipeline_VpcOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_panorama_CfnApplicationInstanceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.manifestPayload) || (p.manifestPayload, void 0), visitedObjects.has(p.manifestOverridesPayload) || (p.manifestOverridesPayload, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_panorama_CfnApplicationInstance(p) {
    }
    function aws_cdk_lib_aws_panorama_CfnApplicationInstance_ManifestOverridesPayloadProperty(p) {
    }
    function aws_cdk_lib_aws_panorama_CfnApplicationInstance_ManifestPayloadProperty(p) {
    }
    function aws_cdk_lib_aws_panorama_CfnPackageProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.storageLocation) || (p.storageLocation, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_panorama_CfnPackage(p) {
    }
    function aws_cdk_lib_aws_panorama_CfnPackage_StorageLocationProperty(p) {
    }
    function aws_cdk_lib_aws_panorama_CfnPackageVersionProps(p) {
    }
    function aws_cdk_lib_aws_panorama_CfnPackageVersion(p) {
    }
    function aws_cdk_lib_aws_personalize_CfnDatasetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.datasetImportJob) || (p.datasetImportJob, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_personalize_CfnDataset(p) {
    }
    function aws_cdk_lib_aws_personalize_CfnDataset_DataSourceProperty(p) {
    }
    function aws_cdk_lib_aws_personalize_CfnDataset_DatasetImportJobProperty(p) {
    }
    function aws_cdk_lib_aws_personalize_CfnDatasetGroupProps(p) {
    }
    function aws_cdk_lib_aws_personalize_CfnDatasetGroup(p) {
    }
    function aws_cdk_lib_aws_personalize_CfnSchemaProps(p) {
    }
    function aws_cdk_lib_aws_personalize_CfnSchema(p) {
    }
    function aws_cdk_lib_aws_personalize_CfnSolutionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.solutionConfig) || (p.solutionConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_personalize_CfnSolution(p) {
    }
    function aws_cdk_lib_aws_personalize_CfnSolution_AlgorithmHyperParameterRangesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoricalHyperParameterRanges) || (p.categoricalHyperParameterRanges, void 0), visitedObjects.has(p.continuousHyperParameterRanges) || (p.continuousHyperParameterRanges, void 0), visitedObjects.has(p.integerHyperParameterRanges) || (p.integerHyperParameterRanges, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_personalize_CfnSolution_AutoMLConfigProperty(p) {
    }
    function aws_cdk_lib_aws_personalize_CfnSolution_CategoricalHyperParameterRangeProperty(p) {
    }
    function aws_cdk_lib_aws_personalize_CfnSolution_ContinuousHyperParameterRangeProperty(p) {
    }
    function aws_cdk_lib_aws_personalize_CfnSolution_HpoConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.algorithmHyperParameterRanges) || (p.algorithmHyperParameterRanges, void 0), visitedObjects.has(p.hpoObjective) || (p.hpoObjective, void 0), visitedObjects.has(p.hpoResourceConfig) || (p.hpoResourceConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_personalize_CfnSolution_HpoObjectiveProperty(p) {
    }
    function aws_cdk_lib_aws_personalize_CfnSolution_HpoResourceConfigProperty(p) {
    }
    function aws_cdk_lib_aws_personalize_CfnSolution_IntegerHyperParameterRangeProperty(p) {
    }
    function aws_cdk_lib_aws_personalize_CfnSolution_SolutionConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.algorithmHyperParameters) || (p.algorithmHyperParameters, void 0), visitedObjects.has(p.featureTransformationParameters) || (p.featureTransformationParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pinpoint_CfnADMChannelProps(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnADMChannel(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnAPNSChannelProps(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnAPNSChannel(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnAPNSSandboxChannelProps(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnAPNSSandboxChannel(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnAPNSVoipChannelProps(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnAPNSVoipChannel(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnAPNSVoipSandboxChannelProps(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnAPNSVoipSandboxChannel(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnAppProps(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnApp(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnApplicationSettingsProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.campaignHook) || (p.campaignHook, void 0), visitedObjects.has(p.limits) || (p.limits, void 0), visitedObjects.has(p.quietTime) || (p.quietTime, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pinpoint_CfnApplicationSettings(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnApplicationSettings_CampaignHookProperty(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnApplicationSettings_LimitsProperty(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnApplicationSettings_QuietTimeProperty(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnBaiduChannelProps(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnBaiduChannel(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnCampaignProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.schedule) || (p.schedule, void 0), visitedObjects.has(p.additionalTreatments) || (p.additionalTreatments, void 0), visitedObjects.has(p.campaignHook) || (p.campaignHook, void 0), visitedObjects.has(p.customDeliveryConfiguration) || (p.customDeliveryConfiguration, void 0), visitedObjects.has(p.limits) || (p.limits, void 0), visitedObjects.has(p.messageConfiguration) || (p.messageConfiguration, void 0), visitedObjects.has(p.templateConfiguration) || (p.templateConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pinpoint_CfnCampaign(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnCampaign_AttributeDimensionProperty(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnCampaign_CampaignCustomMessageProperty(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnCampaign_CampaignEmailMessageProperty(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnCampaign_CampaignEventFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dimensions) || (p.dimensions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pinpoint_CfnCampaign_CampaignHookProperty(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnCampaign_CampaignInAppMessageProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.content) || (p.content, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pinpoint_CfnCampaign_CampaignSmsMessageProperty(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnCampaign_CustomDeliveryConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnCampaign_DefaultButtonConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnCampaign_EventDimensionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.eventType) || (p.eventType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pinpoint_CfnCampaign_InAppMessageBodyConfigProperty(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnCampaign_InAppMessageButtonProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.android) || (p.android, void 0), visitedObjects.has(p.defaultConfig) || (p.defaultConfig, void 0), visitedObjects.has(p.ios) || (p.ios, void 0), visitedObjects.has(p.web) || (p.web, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pinpoint_CfnCampaign_InAppMessageContentProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bodyConfig) || (p.bodyConfig, void 0), visitedObjects.has(p.headerConfig) || (p.headerConfig, void 0), visitedObjects.has(p.primaryBtn) || (p.primaryBtn, void 0), visitedObjects.has(p.secondaryBtn) || (p.secondaryBtn, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pinpoint_CfnCampaign_InAppMessageHeaderConfigProperty(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnCampaign_LimitsProperty(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnCampaign_MessageProperty(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnCampaign_MessageConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.admMessage) || (p.admMessage, void 0), visitedObjects.has(p.apnsMessage) || (p.apnsMessage, void 0), visitedObjects.has(p.baiduMessage) || (p.baiduMessage, void 0), visitedObjects.has(p.customMessage) || (p.customMessage, void 0), visitedObjects.has(p.defaultMessage) || (p.defaultMessage, void 0), visitedObjects.has(p.emailMessage) || (p.emailMessage, void 0), visitedObjects.has(p.gcmMessage) || (p.gcmMessage, void 0), visitedObjects.has(p.inAppMessage) || (p.inAppMessage, void 0), visitedObjects.has(p.smsMessage) || (p.smsMessage, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pinpoint_CfnCampaign_MetricDimensionProperty(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnCampaign_OverrideButtonConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnCampaign_QuietTimeProperty(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnCampaign_ScheduleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.eventFilter) || (p.eventFilter, void 0), visitedObjects.has(p.quietTime) || (p.quietTime, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pinpoint_CfnCampaign_SetDimensionProperty(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnCampaign_TemplateProperty(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnCampaign_TemplateConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.emailTemplate) || (p.emailTemplate, void 0), visitedObjects.has(p.pushTemplate) || (p.pushTemplate, void 0), visitedObjects.has(p.smsTemplate) || (p.smsTemplate, void 0), visitedObjects.has(p.voiceTemplate) || (p.voiceTemplate, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pinpoint_CfnCampaign_WriteTreatmentResourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customDeliveryConfiguration) || (p.customDeliveryConfiguration, void 0), visitedObjects.has(p.messageConfiguration) || (p.messageConfiguration, void 0), visitedObjects.has(p.schedule) || (p.schedule, void 0), visitedObjects.has(p.templateConfiguration) || (p.templateConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pinpoint_CfnEmailChannelProps(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnEmailChannel(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnEmailTemplateProps(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnEmailTemplate(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnEventStreamProps(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnEventStream(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnGCMChannelProps(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnGCMChannel(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnInAppTemplateProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.content) || (p.content, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pinpoint_CfnInAppTemplate(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnInAppTemplate_BodyConfigProperty(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnInAppTemplate_ButtonConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.android) || (p.android, void 0), visitedObjects.has(p.defaultConfig) || (p.defaultConfig, void 0), visitedObjects.has(p.ios) || (p.ios, void 0), visitedObjects.has(p.web) || (p.web, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pinpoint_CfnInAppTemplate_DefaultButtonConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnInAppTemplate_HeaderConfigProperty(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnInAppTemplate_InAppMessageContentProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bodyConfig) || (p.bodyConfig, void 0), visitedObjects.has(p.headerConfig) || (p.headerConfig, void 0), visitedObjects.has(p.primaryBtn) || (p.primaryBtn, void 0), visitedObjects.has(p.secondaryBtn) || (p.secondaryBtn, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pinpoint_CfnInAppTemplate_OverrideButtonConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnPushTemplateProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.adm) || (p.adm, void 0), visitedObjects.has(p.apns) || (p.apns, void 0), visitedObjects.has(p.baidu) || (p.baidu, void 0), visitedObjects.has(p.default) || (p.default, void 0), visitedObjects.has(p.gcm) || (p.gcm, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pinpoint_CfnPushTemplate(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnPushTemplate_APNSPushNotificationTemplateProperty(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnPushTemplate_AndroidPushNotificationTemplateProperty(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnPushTemplate_DefaultPushNotificationTemplateProperty(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnSMSChannelProps(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnSMSChannel(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnSegmentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dimensions) || (p.dimensions, void 0), visitedObjects.has(p.segmentGroups) || (p.segmentGroups, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pinpoint_CfnSegment(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnSegment_AttributeDimensionProperty(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnSegment_BehaviorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.recency) || (p.recency, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pinpoint_CfnSegment_CoordinatesProperty(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnSegment_DemographicProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.appVersion) || (p.appVersion, void 0), visitedObjects.has(p.channel) || (p.channel, void 0), visitedObjects.has(p.deviceType) || (p.deviceType, void 0), visitedObjects.has(p.make) || (p.make, void 0), visitedObjects.has(p.model) || (p.model, void 0), visitedObjects.has(p.platform) || (p.platform, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pinpoint_CfnSegment_GPSPointProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.coordinates) || (p.coordinates, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pinpoint_CfnSegment_GroupsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dimensions) || (p.dimensions, void 0), visitedObjects.has(p.sourceSegments) || (p.sourceSegments, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pinpoint_CfnSegment_LocationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.country) || (p.country, void 0), visitedObjects.has(p.gpsPoint) || (p.gpsPoint, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pinpoint_CfnSegment_RecencyProperty(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnSegment_SegmentDimensionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.behavior) || (p.behavior, void 0), visitedObjects.has(p.demographic) || (p.demographic, void 0), visitedObjects.has(p.location) || (p.location, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pinpoint_CfnSegment_SegmentGroupsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.groups) || (p.groups, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pinpoint_CfnSegment_SetDimensionProperty(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnSegment_SourceSegmentsProperty(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnSmsTemplateProps(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnSmsTemplate(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnVoiceChannelProps(p) {
    }
    function aws_cdk_lib_aws_pinpoint_CfnVoiceChannel(p) {
    }
    function aws_cdk_lib_aws_pinpointemail_CfnConfigurationSetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.deliveryOptions) || (p.deliveryOptions, void 0), visitedObjects.has(p.reputationOptions) || (p.reputationOptions, void 0), visitedObjects.has(p.sendingOptions) || (p.sendingOptions, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.trackingOptions) || (p.trackingOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pinpointemail_CfnConfigurationSet(p) {
    }
    function aws_cdk_lib_aws_pinpointemail_CfnConfigurationSet_DeliveryOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_pinpointemail_CfnConfigurationSet_ReputationOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_pinpointemail_CfnConfigurationSet_SendingOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_pinpointemail_CfnConfigurationSet_TagsProperty(p) {
    }
    function aws_cdk_lib_aws_pinpointemail_CfnConfigurationSet_TrackingOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_pinpointemail_CfnConfigurationSetEventDestinationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.eventDestination) || (p.eventDestination, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pinpointemail_CfnConfigurationSetEventDestination(p) {
    }
    function aws_cdk_lib_aws_pinpointemail_CfnConfigurationSetEventDestination_CloudWatchDestinationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dimensionConfigurations) || (p.dimensionConfigurations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pinpointemail_CfnConfigurationSetEventDestination_DimensionConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_pinpointemail_CfnConfigurationSetEventDestination_EventDestinationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cloudWatchDestination) || (p.cloudWatchDestination, void 0), visitedObjects.has(p.kinesisFirehoseDestination) || (p.kinesisFirehoseDestination, void 0), visitedObjects.has(p.pinpointDestination) || (p.pinpointDestination, void 0), visitedObjects.has(p.snsDestination) || (p.snsDestination, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pinpointemail_CfnConfigurationSetEventDestination_KinesisFirehoseDestinationProperty(p) {
    }
    function aws_cdk_lib_aws_pinpointemail_CfnConfigurationSetEventDestination_PinpointDestinationProperty(p) {
    }
    function aws_cdk_lib_aws_pinpointemail_CfnConfigurationSetEventDestination_SnsDestinationProperty(p) {
    }
    function aws_cdk_lib_aws_pinpointemail_CfnDedicatedIpPoolProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pinpointemail_CfnDedicatedIpPool(p) {
    }
    function aws_cdk_lib_aws_pinpointemail_CfnDedicatedIpPool_TagsProperty(p) {
    }
    function aws_cdk_lib_aws_pinpointemail_CfnIdentityProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.mailFromAttributes) || (p.mailFromAttributes, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pinpointemail_CfnIdentity(p) {
    }
    function aws_cdk_lib_aws_pinpointemail_CfnIdentity_MailFromAttributesProperty(p) {
    }
    function aws_cdk_lib_aws_pinpointemail_CfnIdentity_TagsProperty(p) {
    }
    function aws_cdk_lib_aws_pipes_CfnPipeProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.enrichmentParameters) || (p.enrichmentParameters, void 0), visitedObjects.has(p.sourceParameters) || (p.sourceParameters, void 0), visitedObjects.has(p.targetParameters) || (p.targetParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pipes_CfnPipe(p) {
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_AwsVpcConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_BatchArrayPropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_BatchContainerOverridesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.environment) || (p.environment, void 0), visitedObjects.has(p.resourceRequirements) || (p.resourceRequirements, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_BatchEnvironmentVariableProperty(p) {
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_BatchJobDependencyProperty(p) {
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_BatchResourceRequirementProperty(p) {
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_BatchRetryStrategyProperty(p) {
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_CapacityProviderStrategyItemProperty(p) {
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_DeadLetterConfigProperty(p) {
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_EcsContainerOverrideProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.environment) || (p.environment, void 0), visitedObjects.has(p.environmentFiles) || (p.environmentFiles, void 0), visitedObjects.has(p.resourceRequirements) || (p.resourceRequirements, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_EcsEnvironmentFileProperty(p) {
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_EcsEnvironmentVariableProperty(p) {
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_EcsEphemeralStorageProperty(p) {
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_EcsInferenceAcceleratorOverrideProperty(p) {
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_EcsResourceRequirementProperty(p) {
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_EcsTaskOverrideProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.containerOverrides) || (p.containerOverrides, void 0), visitedObjects.has(p.ephemeralStorage) || (p.ephemeralStorage, void 0), visitedObjects.has(p.inferenceAcceleratorOverrides) || (p.inferenceAcceleratorOverrides, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_FilterProperty(p) {
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_FilterCriteriaProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.filters) || (p.filters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_MQBrokerAccessCredentialsProperty(p) {
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_MSKAccessCredentialsProperty(p) {
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_NetworkConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.awsvpcConfiguration) || (p.awsvpcConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_PipeEnrichmentHttpParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.headerParameters) || (p.headerParameters, void 0), visitedObjects.has(p.queryStringParameters) || (p.queryStringParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_PipeEnrichmentParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.httpParameters) || (p.httpParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_PipeSourceActiveMQBrokerParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.credentials) || (p.credentials, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_PipeSourceDynamoDBStreamParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.deadLetterConfig) || (p.deadLetterConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_PipeSourceKinesisStreamParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.deadLetterConfig) || (p.deadLetterConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_PipeSourceManagedStreamingKafkaParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.credentials) || (p.credentials, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_PipeSourceParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.activeMqBrokerParameters) || (p.activeMqBrokerParameters, void 0), visitedObjects.has(p.dynamoDbStreamParameters) || (p.dynamoDbStreamParameters, void 0), visitedObjects.has(p.filterCriteria) || (p.filterCriteria, void 0), visitedObjects.has(p.kinesisStreamParameters) || (p.kinesisStreamParameters, void 0), visitedObjects.has(p.managedStreamingKafkaParameters) || (p.managedStreamingKafkaParameters, void 0), visitedObjects.has(p.rabbitMqBrokerParameters) || (p.rabbitMqBrokerParameters, void 0), visitedObjects.has(p.selfManagedKafkaParameters) || (p.selfManagedKafkaParameters, void 0), visitedObjects.has(p.sqsQueueParameters) || (p.sqsQueueParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_PipeSourceRabbitMQBrokerParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.credentials) || (p.credentials, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_PipeSourceSelfManagedKafkaParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.credentials) || (p.credentials, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_PipeSourceSqsQueueParametersProperty(p) {
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_PipeTargetBatchJobParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.arrayProperties) || (p.arrayProperties, void 0), visitedObjects.has(p.containerOverrides) || (p.containerOverrides, void 0), visitedObjects.has(p.dependsOn) || (p.dependsOn, void 0), visitedObjects.has(p.parameters) || (p.parameters, void 0), visitedObjects.has(p.retryStrategy) || (p.retryStrategy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_PipeTargetCloudWatchLogsParametersProperty(p) {
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_PipeTargetEcsTaskParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.capacityProviderStrategy) || (p.capacityProviderStrategy, void 0), visitedObjects.has(p.networkConfiguration) || (p.networkConfiguration, void 0), visitedObjects.has(p.overrides) || (p.overrides, void 0), visitedObjects.has(p.placementConstraints) || (p.placementConstraints, void 0), visitedObjects.has(p.placementStrategy) || (p.placementStrategy, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_PipeTargetEventBridgeEventBusParametersProperty(p) {
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_PipeTargetHttpParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.headerParameters) || (p.headerParameters, void 0), visitedObjects.has(p.queryStringParameters) || (p.queryStringParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_PipeTargetKinesisStreamParametersProperty(p) {
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_PipeTargetLambdaFunctionParametersProperty(p) {
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_PipeTargetParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.batchJobParameters) || (p.batchJobParameters, void 0), visitedObjects.has(p.cloudWatchLogsParameters) || (p.cloudWatchLogsParameters, void 0), visitedObjects.has(p.ecsTaskParameters) || (p.ecsTaskParameters, void 0), visitedObjects.has(p.eventBridgeEventBusParameters) || (p.eventBridgeEventBusParameters, void 0), visitedObjects.has(p.httpParameters) || (p.httpParameters, void 0), visitedObjects.has(p.kinesisStreamParameters) || (p.kinesisStreamParameters, void 0), visitedObjects.has(p.lambdaFunctionParameters) || (p.lambdaFunctionParameters, void 0), visitedObjects.has(p.redshiftDataParameters) || (p.redshiftDataParameters, void 0), visitedObjects.has(p.sageMakerPipelineParameters) || (p.sageMakerPipelineParameters, void 0), visitedObjects.has(p.sqsQueueParameters) || (p.sqsQueueParameters, void 0), visitedObjects.has(p.stepFunctionStateMachineParameters) || (p.stepFunctionStateMachineParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_PipeTargetRedshiftDataParametersProperty(p) {
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_PipeTargetSageMakerPipelineParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.pipelineParameterList) || (p.pipelineParameterList, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_PipeTargetSqsQueueParametersProperty(p) {
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_PipeTargetStateMachineParametersProperty(p) {
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_PlacementConstraintProperty(p) {
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_PlacementStrategyProperty(p) {
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_SageMakerPipelineParameterProperty(p) {
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_SelfManagedKafkaAccessConfigurationCredentialsProperty(p) {
    }
    function aws_cdk_lib_aws_pipes_CfnPipe_SelfManagedKafkaAccessConfigurationVpcProperty(p) {
    }
    function aws_cdk_lib_aws_proton_CfnEnvironmentAccountConnectionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_proton_CfnEnvironmentAccountConnection(p) {
    }
    function aws_cdk_lib_aws_proton_CfnEnvironmentTemplateProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_proton_CfnEnvironmentTemplate(p) {
    }
    function aws_cdk_lib_aws_proton_CfnServiceTemplateProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_proton_CfnServiceTemplate(p) {
    }
    function aws_cdk_lib_aws_qldb_CfnLedgerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_qldb_CfnLedger(p) {
    }
    function aws_cdk_lib_aws_qldb_CfnStreamProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.kinesisConfiguration) || (p.kinesisConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_qldb_CfnStream(p) {
    }
    function aws_cdk_lib_aws_qldb_CfnStream_KinesisConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysisProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.definition) || (p.definition, void 0), visitedObjects.has(p.parameters) || (p.parameters, void 0), visitedObjects.has(p.permissions) || (p.permissions, void 0), visitedObjects.has(p.sourceEntity) || (p.sourceEntity, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_AggregationFunctionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.numericalAggregationFunction) || (p.numericalAggregationFunction, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_AggregationSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.aggregationFunction) || (p.aggregationFunction, void 0), visitedObjects.has(p.column) || (p.column, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_AnalysisDefaultsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultNewSheetConfiguration) || (p.defaultNewSheetConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_AnalysisDefinitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataSetIdentifierDeclarations) || (p.dataSetIdentifierDeclarations, void 0), visitedObjects.has(p.analysisDefaults) || (p.analysisDefaults, void 0), visitedObjects.has(p.calculatedFields) || (p.calculatedFields, void 0), visitedObjects.has(p.columnConfigurations) || (p.columnConfigurations, void 0), visitedObjects.has(p.filterGroups) || (p.filterGroups, void 0), visitedObjects.has(p.parameterDeclarations) || (p.parameterDeclarations, void 0), visitedObjects.has(p.sheets) || (p.sheets, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_AnalysisErrorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.violatedEntities) || (p.violatedEntities, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_AnalysisSourceEntityProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sourceTemplate) || (p.sourceTemplate, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_AnalysisSourceTemplateProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataSetReferences) || (p.dataSetReferences, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_AnchorDateConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ArcAxisConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.range) || (p.range, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ArcAxisDisplayRangeProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ArcConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ArcOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_AxisDataOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dateAxisOptions) || (p.dateAxisOptions, void 0), visitedObjects.has(p.numericAxisOptions) || (p.numericAxisOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_AxisDisplayMinMaxRangeProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_AxisDisplayOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataOptions) || (p.dataOptions, void 0), visitedObjects.has(p.scrollbarOptions) || (p.scrollbarOptions, void 0), visitedObjects.has(p.tickLabelOptions) || (p.tickLabelOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_AxisDisplayRangeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.minMax) || (p.minMax, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_AxisLabelOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.applyTo) || (p.applyTo, void 0), visitedObjects.has(p.fontConfiguration) || (p.fontConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_AxisLabelReferenceOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_AxisLinearScaleProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_AxisLogarithmicScaleProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_AxisScaleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.linear) || (p.linear, void 0), visitedObjects.has(p.logarithmic) || (p.logarithmic, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_AxisTickLabelOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.labelOptions) || (p.labelOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_BarChartAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.category) || (p.category, void 0), visitedObjects.has(p.colors) || (p.colors, void 0), visitedObjects.has(p.smallMultiples) || (p.smallMultiples, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_BarChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryAxis) || (p.categoryAxis, void 0), visitedObjects.has(p.categoryLabelOptions) || (p.categoryLabelOptions, void 0), visitedObjects.has(p.colorLabelOptions) || (p.colorLabelOptions, void 0), visitedObjects.has(p.contributionAnalysisDefaults) || (p.contributionAnalysisDefaults, void 0), visitedObjects.has(p.dataLabels) || (p.dataLabels, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.referenceLines) || (p.referenceLines, void 0), visitedObjects.has(p.smallMultiplesOptions) || (p.smallMultiplesOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0), visitedObjects.has(p.valueAxis) || (p.valueAxis, void 0), visitedObjects.has(p.valueLabelOptions) || (p.valueLabelOptions, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_BarChartFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.barChartAggregatedFieldWells) || (p.barChartAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_BarChartSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryItemsLimit) || (p.categoryItemsLimit, void 0), visitedObjects.has(p.categorySort) || (p.categorySort, void 0), visitedObjects.has(p.colorItemsLimit) || (p.colorItemsLimit, void 0), visitedObjects.has(p.colorSort) || (p.colorSort, void 0), visitedObjects.has(p.smallMultiplesLimitConfiguration) || (p.smallMultiplesLimitConfiguration, void 0), visitedObjects.has(p.smallMultiplesSort) || (p.smallMultiplesSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_BarChartVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_BinCountOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_BinWidthOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_BodySectionConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.content) || (p.content, void 0), visitedObjects.has(p.pageBreakConfiguration) || (p.pageBreakConfiguration, void 0), visitedObjects.has(p.style) || (p.style, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_BodySectionContentProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.layout) || (p.layout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_BoxPlotAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.groupBy) || (p.groupBy, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_BoxPlotChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.boxPlotOptions) || (p.boxPlotOptions, void 0), visitedObjects.has(p.categoryAxis) || (p.categoryAxis, void 0), visitedObjects.has(p.categoryLabelOptions) || (p.categoryLabelOptions, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.primaryYAxisDisplayOptions) || (p.primaryYAxisDisplayOptions, void 0), visitedObjects.has(p.primaryYAxisLabelOptions) || (p.primaryYAxisLabelOptions, void 0), visitedObjects.has(p.referenceLines) || (p.referenceLines, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_BoxPlotFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.boxPlotAggregatedFieldWells) || (p.boxPlotAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_BoxPlotOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.styleOptions) || (p.styleOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_BoxPlotSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categorySort) || (p.categorySort, void 0), visitedObjects.has(p.paginationConfiguration) || (p.paginationConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_BoxPlotStyleOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_BoxPlotVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_CalculatedFieldProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_CalculatedMeasureFieldProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_CascadingControlConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sourceControls) || (p.sourceControls, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_CascadingControlSourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columnToMatch) || (p.columnToMatch, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_CategoricalDimensionFieldProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.formatConfiguration) || (p.formatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_CategoricalMeasureFieldProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.formatConfiguration) || (p.formatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_CategoryDrillDownFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_CategoryFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.configuration) || (p.configuration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_CategoryFilterConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customFilterConfiguration) || (p.customFilterConfiguration, void 0), visitedObjects.has(p.customFilterListConfiguration) || (p.customFilterListConfiguration, void 0), visitedObjects.has(p.filterListConfiguration) || (p.filterListConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ChartAxisLabelOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.axisLabelOptions) || (p.axisLabelOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ClusterMarkerProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.simpleClusterMarker) || (p.simpleClusterMarker, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ClusterMarkerConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.clusterMarker) || (p.clusterMarker, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ColorScaleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.colors) || (p.colors, void 0), visitedObjects.has(p.nullValueColor) || (p.nullValueColor, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ColorsConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customColors) || (p.customColors, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ColumnConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.colorsConfiguration) || (p.colorsConfiguration, void 0), visitedObjects.has(p.formatConfiguration) || (p.formatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ColumnHierarchyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dateTimeHierarchy) || (p.dateTimeHierarchy, void 0), visitedObjects.has(p.explicitHierarchy) || (p.explicitHierarchy, void 0), visitedObjects.has(p.predefinedHierarchy) || (p.predefinedHierarchy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ColumnIdentifierProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ColumnSortProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sortBy) || (p.sortBy, void 0), visitedObjects.has(p.aggregationFunction) || (p.aggregationFunction, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ColumnTooltipItemProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.aggregation) || (p.aggregation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ComboChartAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.barValues) || (p.barValues, void 0), visitedObjects.has(p.category) || (p.category, void 0), visitedObjects.has(p.colors) || (p.colors, void 0), visitedObjects.has(p.lineValues) || (p.lineValues, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ComboChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.barDataLabels) || (p.barDataLabels, void 0), visitedObjects.has(p.categoryAxis) || (p.categoryAxis, void 0), visitedObjects.has(p.categoryLabelOptions) || (p.categoryLabelOptions, void 0), visitedObjects.has(p.colorLabelOptions) || (p.colorLabelOptions, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.lineDataLabels) || (p.lineDataLabels, void 0), visitedObjects.has(p.primaryYAxisDisplayOptions) || (p.primaryYAxisDisplayOptions, void 0), visitedObjects.has(p.primaryYAxisLabelOptions) || (p.primaryYAxisLabelOptions, void 0), visitedObjects.has(p.referenceLines) || (p.referenceLines, void 0), visitedObjects.has(p.secondaryYAxisDisplayOptions) || (p.secondaryYAxisDisplayOptions, void 0), visitedObjects.has(p.secondaryYAxisLabelOptions) || (p.secondaryYAxisLabelOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ComboChartFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.comboChartAggregatedFieldWells) || (p.comboChartAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ComboChartSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryItemsLimit) || (p.categoryItemsLimit, void 0), visitedObjects.has(p.categorySort) || (p.categorySort, void 0), visitedObjects.has(p.colorItemsLimit) || (p.colorItemsLimit, void 0), visitedObjects.has(p.colorSort) || (p.colorSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ComboChartVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ComparisonConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.comparisonFormat) || (p.comparisonFormat, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ComparisonFormatConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.numberDisplayFormatConfiguration) || (p.numberDisplayFormatConfiguration, void 0), visitedObjects.has(p.percentageDisplayFormatConfiguration) || (p.percentageDisplayFormatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.forecast) || (p.forecast, void 0), visitedObjects.has(p.growthRate) || (p.growthRate, void 0), visitedObjects.has(p.maximumMinimum) || (p.maximumMinimum, void 0), visitedObjects.has(p.metricComparison) || (p.metricComparison, void 0), visitedObjects.has(p.periodOverPeriod) || (p.periodOverPeriod, void 0), visitedObjects.has(p.periodToDate) || (p.periodToDate, void 0), visitedObjects.has(p.topBottomMovers) || (p.topBottomMovers, void 0), visitedObjects.has(p.topBottomRanked) || (p.topBottomRanked, void 0), visitedObjects.has(p.totalAggregation) || (p.totalAggregation, void 0), visitedObjects.has(p.uniqueValues) || (p.uniqueValues, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ConditionalFormattingColorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.gradient) || (p.gradient, void 0), visitedObjects.has(p.solid) || (p.solid, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ConditionalFormattingCustomIconConditionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.iconOptions) || (p.iconOptions, void 0), visitedObjects.has(p.displayConfiguration) || (p.displayConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ConditionalFormattingCustomIconOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ConditionalFormattingGradientColorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.color) || (p.color, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ConditionalFormattingIconProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customCondition) || (p.customCondition, void 0), visitedObjects.has(p.iconSet) || (p.iconSet, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ConditionalFormattingIconDisplayConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ConditionalFormattingIconSetProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ConditionalFormattingSolidColorProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ContributionAnalysisDefaultProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.contributorDimensions) || (p.contributorDimensions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_CurrencyDisplayFormatConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.decimalPlacesConfiguration) || (p.decimalPlacesConfiguration, void 0), visitedObjects.has(p.negativeValueConfiguration) || (p.negativeValueConfiguration, void 0), visitedObjects.has(p.nullValueFormatConfiguration) || (p.nullValueFormatConfiguration, void 0), visitedObjects.has(p.separatorConfiguration) || (p.separatorConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_CustomActionFilterOperationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.selectedFieldsConfiguration) || (p.selectedFieldsConfiguration, void 0), visitedObjects.has(p.targetVisualsConfiguration) || (p.targetVisualsConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_CustomActionNavigationOperationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.localNavigationConfiguration) || (p.localNavigationConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_CustomActionSetParametersOperationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.parameterValueConfigurations) || (p.parameterValueConfigurations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_CustomActionURLOperationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_CustomColorProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_CustomContentConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_CustomContentVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_CustomFilterConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_CustomFilterListConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_CustomNarrativeOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_CustomParameterValuesProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_CustomValuesConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customValues) || (p.customValues, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DataBarsOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DataColorProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DataFieldSeriesItemProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.settings) || (p.settings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DataLabelOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataLabelTypes) || (p.dataLabelTypes, void 0), visitedObjects.has(p.labelFontConfiguration) || (p.labelFontConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DataLabelTypeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataPathLabelType) || (p.dataPathLabelType, void 0), visitedObjects.has(p.fieldLabelType) || (p.fieldLabelType, void 0), visitedObjects.has(p.maximumLabelType) || (p.maximumLabelType, void 0), visitedObjects.has(p.minimumLabelType) || (p.minimumLabelType, void 0), visitedObjects.has(p.rangeEndsLabelType) || (p.rangeEndsLabelType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DataPathColorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.element) || (p.element, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DataPathLabelTypeProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DataPathSortProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sortPaths) || (p.sortPaths, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DataPathValueProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DataSetIdentifierDeclarationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DataSetReferenceProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DateAxisOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DateDimensionFieldProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.formatConfiguration) || (p.formatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DateMeasureFieldProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.formatConfiguration) || (p.formatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DateTimeDefaultValuesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dynamicValue) || (p.dynamicValue, void 0), visitedObjects.has(p.rollingDate) || (p.rollingDate, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DateTimeFormatConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.nullValueFormatConfiguration) || (p.nullValueFormatConfiguration, void 0), visitedObjects.has(p.numericFormatConfiguration) || (p.numericFormatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DateTimeHierarchyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.drillDownFilters) || (p.drillDownFilters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DateTimeParameterProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DateTimeParameterDeclarationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultValues) || (p.defaultValues, void 0), visitedObjects.has(p.mappedDataSetParameters) || (p.mappedDataSetParameters, void 0), visitedObjects.has(p.valueWhenUnset) || (p.valueWhenUnset, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DateTimePickerControlDisplayOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.titleOptions) || (p.titleOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DateTimeValueWhenUnsetConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DecimalDefaultValuesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dynamicValue) || (p.dynamicValue, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DecimalParameterProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DecimalParameterDeclarationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultValues) || (p.defaultValues, void 0), visitedObjects.has(p.mappedDataSetParameters) || (p.mappedDataSetParameters, void 0), visitedObjects.has(p.valueWhenUnset) || (p.valueWhenUnset, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DecimalPlacesConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DecimalValueWhenUnsetConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DefaultFreeFormLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.canvasSizeOptions) || (p.canvasSizeOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DefaultGridLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.canvasSizeOptions) || (p.canvasSizeOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DefaultInteractiveLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.freeForm) || (p.freeForm, void 0), visitedObjects.has(p.grid) || (p.grid, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DefaultNewSheetConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.interactiveLayoutConfiguration) || (p.interactiveLayoutConfiguration, void 0), visitedObjects.has(p.paginatedLayoutConfiguration) || (p.paginatedLayoutConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DefaultPaginatedLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sectionBased) || (p.sectionBased, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DefaultSectionBasedLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.canvasSizeOptions) || (p.canvasSizeOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DestinationParameterValueConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customValuesConfiguration) || (p.customValuesConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DimensionFieldProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoricalDimensionField) || (p.categoricalDimensionField, void 0), visitedObjects.has(p.dateDimensionField) || (p.dateDimensionField, void 0), visitedObjects.has(p.numericalDimensionField) || (p.numericalDimensionField, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DonutCenterOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DonutOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.arcOptions) || (p.arcOptions, void 0), visitedObjects.has(p.donutCenterOptions) || (p.donutCenterOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DrillDownFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryFilter) || (p.categoryFilter, void 0), visitedObjects.has(p.numericEqualityFilter) || (p.numericEqualityFilter, void 0), visitedObjects.has(p.timeRangeFilter) || (p.timeRangeFilter, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DropDownControlDisplayOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.selectAllOptions) || (p.selectAllOptions, void 0), visitedObjects.has(p.titleOptions) || (p.titleOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_DynamicDefaultValueProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultValueColumn) || (p.defaultValueColumn, void 0), visitedObjects.has(p.groupNameColumn) || (p.groupNameColumn, void 0), visitedObjects.has(p.userNameColumn) || (p.userNameColumn, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_EmptyVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_EntityProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ExcludePeriodConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ExplicitHierarchyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columns) || (p.columns, void 0), visitedObjects.has(p.drillDownFilters) || (p.drillDownFilters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FieldBasedTooltipProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tooltipFields) || (p.tooltipFields, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FieldLabelTypeProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FieldSeriesItemProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.settings) || (p.settings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FieldSortProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FieldSortOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columnSort) || (p.columnSort, void 0), visitedObjects.has(p.fieldSort) || (p.fieldSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FieldTooltipItemProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FilledMapAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.geospatial) || (p.geospatial, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FilledMapConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.conditionalFormattingOptions) || (p.conditionalFormattingOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FilledMapConditionalFormattingOptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.shape) || (p.shape, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FilledMapConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.mapStyleOptions) || (p.mapStyleOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0), visitedObjects.has(p.windowOptions) || (p.windowOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FilledMapFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.filledMapAggregatedFieldWells) || (p.filledMapAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FilledMapShapeConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.format) || (p.format, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FilledMapSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categorySort) || (p.categorySort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FilledMapVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.conditionalFormatting) || (p.conditionalFormatting, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryFilter) || (p.categoryFilter, void 0), visitedObjects.has(p.numericEqualityFilter) || (p.numericEqualityFilter, void 0), visitedObjects.has(p.numericRangeFilter) || (p.numericRangeFilter, void 0), visitedObjects.has(p.relativeDatesFilter) || (p.relativeDatesFilter, void 0), visitedObjects.has(p.timeEqualityFilter) || (p.timeEqualityFilter, void 0), visitedObjects.has(p.timeRangeFilter) || (p.timeRangeFilter, void 0), visitedObjects.has(p.topBottomFilter) || (p.topBottomFilter, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FilterControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dateTimePicker) || (p.dateTimePicker, void 0), visitedObjects.has(p.dropdown) || (p.dropdown, void 0), visitedObjects.has(p.list) || (p.list, void 0), visitedObjects.has(p.relativeDateTime) || (p.relativeDateTime, void 0), visitedObjects.has(p.slider) || (p.slider, void 0), visitedObjects.has(p.textArea) || (p.textArea, void 0), visitedObjects.has(p.textField) || (p.textField, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FilterDateTimePickerControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FilterDropDownControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cascadingControlConfiguration) || (p.cascadingControlConfiguration, void 0), visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0), visitedObjects.has(p.selectableValues) || (p.selectableValues, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FilterGroupProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.filters) || (p.filters, void 0), visitedObjects.has(p.scopeConfiguration) || (p.scopeConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FilterListConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FilterListControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cascadingControlConfiguration) || (p.cascadingControlConfiguration, void 0), visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0), visitedObjects.has(p.selectableValues) || (p.selectableValues, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FilterOperationSelectedFieldsConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FilterOperationTargetVisualsConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sameSheetTargetVisualConfiguration) || (p.sameSheetTargetVisualConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FilterRelativeDateTimeControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FilterScopeConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.selectedSheets) || (p.selectedSheets, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FilterSelectableValuesProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FilterSliderControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FilterTextAreaControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FilterTextFieldControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FontConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fontSize) || (p.fontSize, void 0), visitedObjects.has(p.fontWeight) || (p.fontWeight, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FontSizeProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FontWeightProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ForecastComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.time) || (p.time, void 0), visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ForecastConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.forecastProperties) || (p.forecastProperties, void 0), visitedObjects.has(p.scenario) || (p.scenario, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ForecastScenarioProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.whatIfPointScenario) || (p.whatIfPointScenario, void 0), visitedObjects.has(p.whatIfRangeScenario) || (p.whatIfRangeScenario, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FormatConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dateTimeFormatConfiguration) || (p.dateTimeFormatConfiguration, void 0), visitedObjects.has(p.numberFormatConfiguration) || (p.numberFormatConfiguration, void 0), visitedObjects.has(p.stringFormatConfiguration) || (p.stringFormatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FreeFormLayoutCanvasSizeOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.screenCanvasSizeOptions) || (p.screenCanvasSizeOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FreeFormLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.elements) || (p.elements, void 0), visitedObjects.has(p.canvasSizeOptions) || (p.canvasSizeOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FreeFormLayoutElementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.backgroundStyle) || (p.backgroundStyle, void 0), visitedObjects.has(p.borderStyle) || (p.borderStyle, void 0), visitedObjects.has(p.loadingAnimation) || (p.loadingAnimation, void 0), visitedObjects.has(p.renderingRules) || (p.renderingRules, void 0), visitedObjects.has(p.selectedBorderStyle) || (p.selectedBorderStyle, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FreeFormLayoutElementBackgroundStyleProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FreeFormLayoutElementBorderStyleProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FreeFormLayoutScreenCanvasSizeOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FreeFormSectionLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.elements) || (p.elements, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FunnelChartAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.category) || (p.category, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FunnelChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryLabelOptions) || (p.categoryLabelOptions, void 0), visitedObjects.has(p.dataLabelOptions) || (p.dataLabelOptions, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0), visitedObjects.has(p.valueLabelOptions) || (p.valueLabelOptions, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FunnelChartDataLabelOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.labelFontConfiguration) || (p.labelFontConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FunnelChartFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.funnelChartAggregatedFieldWells) || (p.funnelChartAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FunnelChartSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryItemsLimit) || (p.categoryItemsLimit, void 0), visitedObjects.has(p.categorySort) || (p.categorySort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_FunnelChartVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_GaugeChartArcConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.foregroundColor) || (p.foregroundColor, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_GaugeChartConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.conditionalFormattingOptions) || (p.conditionalFormattingOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_GaugeChartConditionalFormattingOptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.arc) || (p.arc, void 0), visitedObjects.has(p.primaryValue) || (p.primaryValue, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_GaugeChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataLabels) || (p.dataLabels, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.gaugeChartOptions) || (p.gaugeChartOptions, void 0), visitedObjects.has(p.tooltipOptions) || (p.tooltipOptions, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_GaugeChartFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.targetValues) || (p.targetValues, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_GaugeChartOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.arc) || (p.arc, void 0), visitedObjects.has(p.arcAxis) || (p.arcAxis, void 0), visitedObjects.has(p.comparison) || (p.comparison, void 0), visitedObjects.has(p.primaryValueFontConfiguration) || (p.primaryValueFontConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_GaugeChartPrimaryValueConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.icon) || (p.icon, void 0), visitedObjects.has(p.textColor) || (p.textColor, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_GaugeChartVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.conditionalFormatting) || (p.conditionalFormatting, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_GeospatialCoordinateBoundsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_GeospatialMapAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.colors) || (p.colors, void 0), visitedObjects.has(p.geospatial) || (p.geospatial, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_GeospatialMapConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.mapStyleOptions) || (p.mapStyleOptions, void 0), visitedObjects.has(p.pointStyleOptions) || (p.pointStyleOptions, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0), visitedObjects.has(p.windowOptions) || (p.windowOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_GeospatialMapFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.geospatialMapAggregatedFieldWells) || (p.geospatialMapAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_GeospatialMapStyleOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_GeospatialMapVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_GeospatialPointStyleOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.clusterMarkerConfiguration) || (p.clusterMarkerConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_GeospatialWindowOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bounds) || (p.bounds, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_GlobalTableBorderOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sideSpecificBorder) || (p.sideSpecificBorder, void 0), visitedObjects.has(p.uniformBorder) || (p.uniformBorder, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_GradientColorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.stops) || (p.stops, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_GradientStopProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_GridLayoutCanvasSizeOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.screenCanvasSizeOptions) || (p.screenCanvasSizeOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_GridLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.elements) || (p.elements, void 0), visitedObjects.has(p.canvasSizeOptions) || (p.canvasSizeOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_GridLayoutElementProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_GridLayoutScreenCanvasSizeOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_GrowthRateComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.time) || (p.time, void 0), visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_HeaderFooterSectionConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.layout) || (p.layout, void 0), visitedObjects.has(p.style) || (p.style, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_HeatMapAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columns) || (p.columns, void 0), visitedObjects.has(p.rows) || (p.rows, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_HeatMapConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.colorScale) || (p.colorScale, void 0), visitedObjects.has(p.columnLabelOptions) || (p.columnLabelOptions, void 0), visitedObjects.has(p.dataLabels) || (p.dataLabels, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.rowLabelOptions) || (p.rowLabelOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_HeatMapFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.heatMapAggregatedFieldWells) || (p.heatMapAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_HeatMapSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.heatMapColumnItemsLimitConfiguration) || (p.heatMapColumnItemsLimitConfiguration, void 0), visitedObjects.has(p.heatMapColumnSort) || (p.heatMapColumnSort, void 0), visitedObjects.has(p.heatMapRowItemsLimitConfiguration) || (p.heatMapRowItemsLimitConfiguration, void 0), visitedObjects.has(p.heatMapRowSort) || (p.heatMapRowSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_HeatMapVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_HistogramAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_HistogramBinOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.binCount) || (p.binCount, void 0), visitedObjects.has(p.binWidth) || (p.binWidth, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_HistogramConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.binOptions) || (p.binOptions, void 0), visitedObjects.has(p.dataLabels) || (p.dataLabels, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0), visitedObjects.has(p.xAxisDisplayOptions) || (p.xAxisDisplayOptions, void 0), visitedObjects.has(p.xAxisLabelOptions) || (p.xAxisLabelOptions, void 0), visitedObjects.has(p.yAxisDisplayOptions) || (p.yAxisDisplayOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_HistogramFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.histogramAggregatedFieldWells) || (p.histogramAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_HistogramVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_InsightConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.computations) || (p.computations, void 0), visitedObjects.has(p.customNarrative) || (p.customNarrative, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_InsightVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.insightConfiguration) || (p.insightConfiguration, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_IntegerDefaultValuesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dynamicValue) || (p.dynamicValue, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_IntegerParameterProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_IntegerParameterDeclarationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultValues) || (p.defaultValues, void 0), visitedObjects.has(p.mappedDataSetParameters) || (p.mappedDataSetParameters, void 0), visitedObjects.has(p.valueWhenUnset) || (p.valueWhenUnset, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_IntegerValueWhenUnsetConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ItemsLimitConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_KPIConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.conditionalFormattingOptions) || (p.conditionalFormattingOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_KPIConditionalFormattingOptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.primaryValue) || (p.primaryValue, void 0), visitedObjects.has(p.progressBar) || (p.progressBar, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_KPIConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.kpiOptions) || (p.kpiOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_KPIFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.targetValues) || (p.targetValues, void 0), visitedObjects.has(p.trendGroups) || (p.trendGroups, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_KPIOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.comparison) || (p.comparison, void 0), visitedObjects.has(p.primaryValueFontConfiguration) || (p.primaryValueFontConfiguration, void 0), visitedObjects.has(p.progressBar) || (p.progressBar, void 0), visitedObjects.has(p.secondaryValue) || (p.secondaryValue, void 0), visitedObjects.has(p.secondaryValueFontConfiguration) || (p.secondaryValueFontConfiguration, void 0), visitedObjects.has(p.trendArrows) || (p.trendArrows, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_KPIPrimaryValueConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.icon) || (p.icon, void 0), visitedObjects.has(p.textColor) || (p.textColor, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_KPIProgressBarConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.foregroundColor) || (p.foregroundColor, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_KPISortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.trendGroupSort) || (p.trendGroupSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_KPIVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.conditionalFormatting) || (p.conditionalFormatting, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_LabelOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fontConfiguration) || (p.fontConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_LayoutProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.configuration) || (p.configuration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_LayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.freeFormLayout) || (p.freeFormLayout, void 0), visitedObjects.has(p.gridLayout) || (p.gridLayout, void 0), visitedObjects.has(p.sectionBasedLayout) || (p.sectionBasedLayout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_LegendOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_LineChartAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.category) || (p.category, void 0), visitedObjects.has(p.colors) || (p.colors, void 0), visitedObjects.has(p.smallMultiples) || (p.smallMultiples, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_LineChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.contributionAnalysisDefaults) || (p.contributionAnalysisDefaults, void 0), visitedObjects.has(p.dataLabels) || (p.dataLabels, void 0), visitedObjects.has(p.defaultSeriesSettings) || (p.defaultSeriesSettings, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.forecastConfigurations) || (p.forecastConfigurations, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.primaryYAxisDisplayOptions) || (p.primaryYAxisDisplayOptions, void 0), visitedObjects.has(p.primaryYAxisLabelOptions) || (p.primaryYAxisLabelOptions, void 0), visitedObjects.has(p.referenceLines) || (p.referenceLines, void 0), visitedObjects.has(p.secondaryYAxisDisplayOptions) || (p.secondaryYAxisDisplayOptions, void 0), visitedObjects.has(p.secondaryYAxisLabelOptions) || (p.secondaryYAxisLabelOptions, void 0), visitedObjects.has(p.series) || (p.series, void 0), visitedObjects.has(p.smallMultiplesOptions) || (p.smallMultiplesOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0), visitedObjects.has(p.xAxisDisplayOptions) || (p.xAxisDisplayOptions, void 0), visitedObjects.has(p.xAxisLabelOptions) || (p.xAxisLabelOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_LineChartDefaultSeriesSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.lineStyleSettings) || (p.lineStyleSettings, void 0), visitedObjects.has(p.markerStyleSettings) || (p.markerStyleSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_LineChartFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.lineChartAggregatedFieldWells) || (p.lineChartAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_LineChartLineStyleSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_LineChartMarkerStyleSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_LineChartSeriesSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.lineStyleSettings) || (p.lineStyleSettings, void 0), visitedObjects.has(p.markerStyleSettings) || (p.markerStyleSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_LineChartSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryItemsLimitConfiguration) || (p.categoryItemsLimitConfiguration, void 0), visitedObjects.has(p.categorySort) || (p.categorySort, void 0), visitedObjects.has(p.colorItemsLimitConfiguration) || (p.colorItemsLimitConfiguration, void 0), visitedObjects.has(p.smallMultiplesLimitConfiguration) || (p.smallMultiplesLimitConfiguration, void 0), visitedObjects.has(p.smallMultiplesSort) || (p.smallMultiplesSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_LineChartVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_LineSeriesAxisDisplayOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.axisOptions) || (p.axisOptions, void 0), visitedObjects.has(p.missingDataConfigurations) || (p.missingDataConfigurations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ListControlDisplayOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.searchOptions) || (p.searchOptions, void 0), visitedObjects.has(p.selectAllOptions) || (p.selectAllOptions, void 0), visitedObjects.has(p.titleOptions) || (p.titleOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ListControlSearchOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ListControlSelectAllOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_LoadingAnimationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_LocalNavigationConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_LongFormatTextProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_MappedDataSetParameterProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_MaximumLabelTypeProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_MaximumMinimumComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.time) || (p.time, void 0), visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_MeasureFieldProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.calculatedMeasureField) || (p.calculatedMeasureField, void 0), visitedObjects.has(p.categoricalMeasureField) || (p.categoricalMeasureField, void 0), visitedObjects.has(p.dateMeasureField) || (p.dateMeasureField, void 0), visitedObjects.has(p.numericalMeasureField) || (p.numericalMeasureField, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_MetricComparisonComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fromValue) || (p.fromValue, void 0), visitedObjects.has(p.targetValue) || (p.targetValue, void 0), visitedObjects.has(p.time) || (p.time, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_MinimumLabelTypeProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_MissingDataConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_NegativeValueConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_NullValueFormatConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_NumberDisplayFormatConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.decimalPlacesConfiguration) || (p.decimalPlacesConfiguration, void 0), visitedObjects.has(p.negativeValueConfiguration) || (p.negativeValueConfiguration, void 0), visitedObjects.has(p.nullValueFormatConfiguration) || (p.nullValueFormatConfiguration, void 0), visitedObjects.has(p.separatorConfiguration) || (p.separatorConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_NumberFormatConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.formatConfiguration) || (p.formatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_NumericAxisOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.range) || (p.range, void 0), visitedObjects.has(p.scale) || (p.scale, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_NumericEqualityDrillDownFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_NumericEqualityFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.aggregationFunction) || (p.aggregationFunction, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_NumericFormatConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.currencyDisplayFormatConfiguration) || (p.currencyDisplayFormatConfiguration, void 0), visitedObjects.has(p.numberDisplayFormatConfiguration) || (p.numberDisplayFormatConfiguration, void 0), visitedObjects.has(p.percentageDisplayFormatConfiguration) || (p.percentageDisplayFormatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_NumericRangeFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.aggregationFunction) || (p.aggregationFunction, void 0), visitedObjects.has(p.rangeMaximum) || (p.rangeMaximum, void 0), visitedObjects.has(p.rangeMinimum) || (p.rangeMinimum, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_NumericRangeFilterValueProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_NumericSeparatorConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.thousandsSeparator) || (p.thousandsSeparator, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_NumericalAggregationFunctionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.percentileAggregation) || (p.percentileAggregation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_NumericalDimensionFieldProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.formatConfiguration) || (p.formatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_NumericalMeasureFieldProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.aggregationFunction) || (p.aggregationFunction, void 0), visitedObjects.has(p.formatConfiguration) || (p.formatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PaginationConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PanelConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PanelTitleOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fontConfiguration) || (p.fontConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ParameterControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dateTimePicker) || (p.dateTimePicker, void 0), visitedObjects.has(p.dropdown) || (p.dropdown, void 0), visitedObjects.has(p.list) || (p.list, void 0), visitedObjects.has(p.slider) || (p.slider, void 0), visitedObjects.has(p.textArea) || (p.textArea, void 0), visitedObjects.has(p.textField) || (p.textField, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ParameterDateTimePickerControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ParameterDeclarationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dateTimeParameterDeclaration) || (p.dateTimeParameterDeclaration, void 0), visitedObjects.has(p.decimalParameterDeclaration) || (p.decimalParameterDeclaration, void 0), visitedObjects.has(p.integerParameterDeclaration) || (p.integerParameterDeclaration, void 0), visitedObjects.has(p.stringParameterDeclaration) || (p.stringParameterDeclaration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ParameterDropDownControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cascadingControlConfiguration) || (p.cascadingControlConfiguration, void 0), visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0), visitedObjects.has(p.selectableValues) || (p.selectableValues, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ParameterListControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cascadingControlConfiguration) || (p.cascadingControlConfiguration, void 0), visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0), visitedObjects.has(p.selectableValues) || (p.selectableValues, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ParameterSelectableValuesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.linkToDataSetColumn) || (p.linkToDataSetColumn, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ParameterSliderControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ParameterTextAreaControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ParameterTextFieldControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dateTimeParameters) || (p.dateTimeParameters, void 0), visitedObjects.has(p.decimalParameters) || (p.decimalParameters, void 0), visitedObjects.has(p.integerParameters) || (p.integerParameters, void 0), visitedObjects.has(p.stringParameters) || (p.stringParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PercentVisibleRangeProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PercentageDisplayFormatConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.decimalPlacesConfiguration) || (p.decimalPlacesConfiguration, void 0), visitedObjects.has(p.negativeValueConfiguration) || (p.negativeValueConfiguration, void 0), visitedObjects.has(p.nullValueFormatConfiguration) || (p.nullValueFormatConfiguration, void 0), visitedObjects.has(p.separatorConfiguration) || (p.separatorConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PercentileAggregationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PeriodOverPeriodComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.time) || (p.time, void 0), visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PeriodToDateComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.time) || (p.time, void 0), visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PieChartAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.category) || (p.category, void 0), visitedObjects.has(p.smallMultiples) || (p.smallMultiples, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PieChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryLabelOptions) || (p.categoryLabelOptions, void 0), visitedObjects.has(p.contributionAnalysisDefaults) || (p.contributionAnalysisDefaults, void 0), visitedObjects.has(p.dataLabels) || (p.dataLabels, void 0), visitedObjects.has(p.donutOptions) || (p.donutOptions, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.smallMultiplesOptions) || (p.smallMultiplesOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0), visitedObjects.has(p.valueLabelOptions) || (p.valueLabelOptions, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PieChartFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.pieChartAggregatedFieldWells) || (p.pieChartAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PieChartSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryItemsLimit) || (p.categoryItemsLimit, void 0), visitedObjects.has(p.categorySort) || (p.categorySort, void 0), visitedObjects.has(p.smallMultiplesLimitConfiguration) || (p.smallMultiplesLimitConfiguration, void 0), visitedObjects.has(p.smallMultiplesSort) || (p.smallMultiplesSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PieChartVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotFieldSortOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sortBy) || (p.sortBy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columns) || (p.columns, void 0), visitedObjects.has(p.rows) || (p.rows, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableCellConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.scope) || (p.scope, void 0), visitedObjects.has(p.textFormat) || (p.textFormat, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.conditionalFormattingOptions) || (p.conditionalFormattingOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableConditionalFormattingOptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cell) || (p.cell, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableConditionalFormattingScopeProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldOptions) || (p.fieldOptions, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.paginatedReportOptions) || (p.paginatedReportOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tableOptions) || (p.tableOptions, void 0), visitedObjects.has(p.totalOptions) || (p.totalOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableDataPathOptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataPathList) || (p.dataPathList, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableFieldOptionProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableFieldOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataPathOptions) || (p.dataPathOptions, void 0), visitedObjects.has(p.selectedFieldOptions) || (p.selectedFieldOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableFieldSubtotalOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.pivotTableAggregatedFieldWells) || (p.pivotTableAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cellStyle) || (p.cellStyle, void 0), visitedObjects.has(p.columnHeaderStyle) || (p.columnHeaderStyle, void 0), visitedObjects.has(p.rowAlternateColorOptions) || (p.rowAlternateColorOptions, void 0), visitedObjects.has(p.rowFieldNamesStyle) || (p.rowFieldNamesStyle, void 0), visitedObjects.has(p.rowHeaderStyle) || (p.rowHeaderStyle, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTablePaginatedReportOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableSortByProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.dataPath) || (p.dataPath, void 0), visitedObjects.has(p.field) || (p.field, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldSortOptions) || (p.fieldSortOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableTotalOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columnSubtotalOptions) || (p.columnSubtotalOptions, void 0), visitedObjects.has(p.columnTotalOptions) || (p.columnTotalOptions, void 0), visitedObjects.has(p.rowSubtotalOptions) || (p.rowSubtotalOptions, void 0), visitedObjects.has(p.rowTotalOptions) || (p.rowTotalOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.conditionalFormatting) || (p.conditionalFormatting, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTotalOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.metricHeaderCellStyle) || (p.metricHeaderCellStyle, void 0), visitedObjects.has(p.totalCellStyle) || (p.totalCellStyle, void 0), visitedObjects.has(p.valueCellStyle) || (p.valueCellStyle, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_PredefinedHierarchyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columns) || (p.columns, void 0), visitedObjects.has(p.drillDownFilters) || (p.drillDownFilters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ProgressBarOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_RadarChartAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.category) || (p.category, void 0), visitedObjects.has(p.color) || (p.color, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_RadarChartAreaStyleSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_RadarChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.baseSeriesSettings) || (p.baseSeriesSettings, void 0), visitedObjects.has(p.categoryAxis) || (p.categoryAxis, void 0), visitedObjects.has(p.categoryLabelOptions) || (p.categoryLabelOptions, void 0), visitedObjects.has(p.colorAxis) || (p.colorAxis, void 0), visitedObjects.has(p.colorLabelOptions) || (p.colorLabelOptions, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_RadarChartFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.radarChartAggregatedFieldWells) || (p.radarChartAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_RadarChartSeriesSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.areaStyleSettings) || (p.areaStyleSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_RadarChartSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryItemsLimit) || (p.categoryItemsLimit, void 0), visitedObjects.has(p.categorySort) || (p.categorySort, void 0), visitedObjects.has(p.colorItemsLimit) || (p.colorItemsLimit, void 0), visitedObjects.has(p.colorSort) || (p.colorSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_RadarChartVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_RangeEndsLabelTypeProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ReferenceLineProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataConfiguration) || (p.dataConfiguration, void 0), visitedObjects.has(p.labelConfiguration) || (p.labelConfiguration, void 0), visitedObjects.has(p.styleConfiguration) || (p.styleConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ReferenceLineCustomLabelConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ReferenceLineDataConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dynamicConfiguration) || (p.dynamicConfiguration, void 0), visitedObjects.has(p.staticConfiguration) || (p.staticConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ReferenceLineDynamicDataConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.calculation) || (p.calculation, void 0), visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.measureAggregationFunction) || (p.measureAggregationFunction, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ReferenceLineLabelConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customLabelConfiguration) || (p.customLabelConfiguration, void 0), visitedObjects.has(p.fontConfiguration) || (p.fontConfiguration, void 0), visitedObjects.has(p.valueLabelConfiguration) || (p.valueLabelConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ReferenceLineStaticDataConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ReferenceLineStyleConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ReferenceLineValueLabelConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.formatConfiguration) || (p.formatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_RelativeDateTimeControlDisplayOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.titleOptions) || (p.titleOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_RelativeDatesFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.anchorDateConfiguration) || (p.anchorDateConfiguration, void 0), visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.excludePeriodConfiguration) || (p.excludePeriodConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ResourcePermissionProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_RollingDateConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_RowAlternateColorOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_SameSheetTargetVisualConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_SankeyDiagramAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destination) || (p.destination, void 0), visitedObjects.has(p.source) || (p.source, void 0), visitedObjects.has(p.weight) || (p.weight, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_SankeyDiagramChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataLabels) || (p.dataLabels, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_SankeyDiagramFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sankeyDiagramAggregatedFieldWells) || (p.sankeyDiagramAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_SankeyDiagramSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destinationItemsLimit) || (p.destinationItemsLimit, void 0), visitedObjects.has(p.sourceItemsLimit) || (p.sourceItemsLimit, void 0), visitedObjects.has(p.weightSort) || (p.weightSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_SankeyDiagramVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ScatterPlotCategoricallyAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.category) || (p.category, void 0), visitedObjects.has(p.size) || (p.size, void 0), visitedObjects.has(p.xAxis) || (p.xAxis, void 0), visitedObjects.has(p.yAxis) || (p.yAxis, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ScatterPlotConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataLabels) || (p.dataLabels, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0), visitedObjects.has(p.xAxisDisplayOptions) || (p.xAxisDisplayOptions, void 0), visitedObjects.has(p.xAxisLabelOptions) || (p.xAxisLabelOptions, void 0), visitedObjects.has(p.yAxisDisplayOptions) || (p.yAxisDisplayOptions, void 0), visitedObjects.has(p.yAxisLabelOptions) || (p.yAxisLabelOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ScatterPlotFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.scatterPlotCategoricallyAggregatedFieldWells) || (p.scatterPlotCategoricallyAggregatedFieldWells, void 0), visitedObjects.has(p.scatterPlotUnaggregatedFieldWells) || (p.scatterPlotUnaggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ScatterPlotUnaggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.size) || (p.size, void 0), visitedObjects.has(p.xAxis) || (p.xAxis, void 0), visitedObjects.has(p.yAxis) || (p.yAxis, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ScatterPlotVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ScrollBarOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.visibleRange) || (p.visibleRange, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_SecondaryValueOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_SectionAfterPageBreakProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_SectionBasedLayoutCanvasSizeOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.paperCanvasSizeOptions) || (p.paperCanvasSizeOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_SectionBasedLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bodySections) || (p.bodySections, void 0), visitedObjects.has(p.canvasSizeOptions) || (p.canvasSizeOptions, void 0), visitedObjects.has(p.footerSections) || (p.footerSections, void 0), visitedObjects.has(p.headerSections) || (p.headerSections, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_SectionBasedLayoutPaperCanvasSizeOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.paperMargin) || (p.paperMargin, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_SectionLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.freeFormLayout) || (p.freeFormLayout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_SectionPageBreakConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.after) || (p.after, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_SectionStyleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.padding) || (p.padding, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_SelectedSheetsFilterScopeConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sheetVisualScopingConfigurations) || (p.sheetVisualScopingConfigurations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_SeriesItemProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataFieldSeriesItem) || (p.dataFieldSeriesItem, void 0), visitedObjects.has(p.fieldSeriesItem) || (p.fieldSeriesItem, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_SetParameterValueConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ShapeConditionalFormatProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.backgroundColor) || (p.backgroundColor, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_SheetProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_SheetControlLayoutProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.configuration) || (p.configuration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_SheetControlLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.gridLayout) || (p.gridLayout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_SheetDefinitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.filterControls) || (p.filterControls, void 0), visitedObjects.has(p.layouts) || (p.layouts, void 0), visitedObjects.has(p.parameterControls) || (p.parameterControls, void 0), visitedObjects.has(p.sheetControlLayouts) || (p.sheetControlLayouts, void 0), visitedObjects.has(p.textBoxes) || (p.textBoxes, void 0), visitedObjects.has(p.visuals) || (p.visuals, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_SheetElementConfigurationOverridesProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_SheetElementRenderingRuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.configurationOverrides) || (p.configurationOverrides, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_SheetTextBoxProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_SheetVisualScopingConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ShortFormatTextProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_SimpleClusterMarkerProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_SliderControlDisplayOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.titleOptions) || (p.titleOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_SmallMultiplesOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.panelConfiguration) || (p.panelConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_SpacingProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_StringDefaultValuesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dynamicValue) || (p.dynamicValue, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_StringFormatConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.nullValueFormatConfiguration) || (p.nullValueFormatConfiguration, void 0), visitedObjects.has(p.numericFormatConfiguration) || (p.numericFormatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_StringParameterProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_StringParameterDeclarationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultValues) || (p.defaultValues, void 0), visitedObjects.has(p.mappedDataSetParameters) || (p.mappedDataSetParameters, void 0), visitedObjects.has(p.valueWhenUnset) || (p.valueWhenUnset, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_StringValueWhenUnsetConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_SubtotalOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldLevelOptions) || (p.fieldLevelOptions, void 0), visitedObjects.has(p.metricHeaderCellStyle) || (p.metricHeaderCellStyle, void 0), visitedObjects.has(p.totalCellStyle) || (p.totalCellStyle, void 0), visitedObjects.has(p.valueCellStyle) || (p.valueCellStyle, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TableAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.groupBy) || (p.groupBy, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TableBorderOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TableCellConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.textFormat) || (p.textFormat, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TableCellImageSizingConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TableCellStyleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.border) || (p.border, void 0), visitedObjects.has(p.fontConfiguration) || (p.fontConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TableConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.conditionalFormattingOptions) || (p.conditionalFormattingOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TableConditionalFormattingOptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cell) || (p.cell, void 0), visitedObjects.has(p.row) || (p.row, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TableConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldOptions) || (p.fieldOptions, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.paginatedReportOptions) || (p.paginatedReportOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tableInlineVisualizations) || (p.tableInlineVisualizations, void 0), visitedObjects.has(p.tableOptions) || (p.tableOptions, void 0), visitedObjects.has(p.totalOptions) || (p.totalOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TableFieldCustomIconContentProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TableFieldCustomTextContentProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fontConfiguration) || (p.fontConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TableFieldImageConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sizingOptions) || (p.sizingOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TableFieldLinkConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.content) || (p.content, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TableFieldLinkContentConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customIconContent) || (p.customIconContent, void 0), visitedObjects.has(p.customTextContent) || (p.customTextContent, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TableFieldOptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.urlStyling) || (p.urlStyling, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TableFieldOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.selectedFieldOptions) || (p.selectedFieldOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TableFieldURLConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.imageConfiguration) || (p.imageConfiguration, void 0), visitedObjects.has(p.linkConfiguration) || (p.linkConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TableFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tableAggregatedFieldWells) || (p.tableAggregatedFieldWells, void 0), visitedObjects.has(p.tableUnaggregatedFieldWells) || (p.tableUnaggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TableInlineVisualizationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataBars) || (p.dataBars, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TableOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cellStyle) || (p.cellStyle, void 0), visitedObjects.has(p.headerStyle) || (p.headerStyle, void 0), visitedObjects.has(p.rowAlternateColorOptions) || (p.rowAlternateColorOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TablePaginatedReportOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TableRowConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.backgroundColor) || (p.backgroundColor, void 0), visitedObjects.has(p.textColor) || (p.textColor, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TableSideBorderOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bottom) || (p.bottom, void 0), visitedObjects.has(p.innerHorizontal) || (p.innerHorizontal, void 0), visitedObjects.has(p.innerVertical) || (p.innerVertical, void 0), visitedObjects.has(p.left) || (p.left, void 0), visitedObjects.has(p.right) || (p.right, void 0), visitedObjects.has(p.top) || (p.top, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TableSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.paginationConfiguration) || (p.paginationConfiguration, void 0), visitedObjects.has(p.rowSort) || (p.rowSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TableUnaggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TableVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.conditionalFormatting) || (p.conditionalFormatting, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TextAreaControlDisplayOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.placeholderOptions) || (p.placeholderOptions, void 0), visitedObjects.has(p.titleOptions) || (p.titleOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TextConditionalFormatProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.backgroundColor) || (p.backgroundColor, void 0), visitedObjects.has(p.icon) || (p.icon, void 0), visitedObjects.has(p.textColor) || (p.textColor, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TextControlPlaceholderOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TextFieldControlDisplayOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.placeholderOptions) || (p.placeholderOptions, void 0), visitedObjects.has(p.titleOptions) || (p.titleOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_ThousandSeparatorOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TimeBasedForecastPropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TimeEqualityFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TimeRangeDrillDownFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TimeRangeFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.excludePeriodConfiguration) || (p.excludePeriodConfiguration, void 0), visitedObjects.has(p.rangeMaximumValue) || (p.rangeMaximumValue, void 0), visitedObjects.has(p.rangeMinimumValue) || (p.rangeMinimumValue, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TimeRangeFilterValueProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.rollingDate) || (p.rollingDate, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TooltipItemProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columnTooltipItem) || (p.columnTooltipItem, void 0), visitedObjects.has(p.fieldTooltipItem) || (p.fieldTooltipItem, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TooltipOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldBasedTooltip) || (p.fieldBasedTooltip, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TopBottomFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.aggregationSortConfigurations) || (p.aggregationSortConfigurations, void 0), visitedObjects.has(p.column) || (p.column, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TopBottomMoversComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.category) || (p.category, void 0), visitedObjects.has(p.time) || (p.time, void 0), visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TopBottomRankedComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.category) || (p.category, void 0), visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TotalAggregationComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TotalOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.totalCellStyle) || (p.totalCellStyle, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TreeMapAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.colors) || (p.colors, void 0), visitedObjects.has(p.groups) || (p.groups, void 0), visitedObjects.has(p.sizes) || (p.sizes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TreeMapConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.colorLabelOptions) || (p.colorLabelOptions, void 0), visitedObjects.has(p.colorScale) || (p.colorScale, void 0), visitedObjects.has(p.dataLabels) || (p.dataLabels, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.groupLabelOptions) || (p.groupLabelOptions, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.sizeLabelOptions) || (p.sizeLabelOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TreeMapFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.treeMapAggregatedFieldWells) || (p.treeMapAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TreeMapSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.treeMapGroupItemsLimitConfiguration) || (p.treeMapGroupItemsLimitConfiguration, void 0), visitedObjects.has(p.treeMapSort) || (p.treeMapSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TreeMapVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_TrendArrowOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_UnaggregatedFieldProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.formatConfiguration) || (p.formatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_UniqueValuesComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.category) || (p.category, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_VisibleRangeOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.percentRange) || (p.percentRange, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_VisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.barChartVisual) || (p.barChartVisual, void 0), visitedObjects.has(p.boxPlotVisual) || (p.boxPlotVisual, void 0), visitedObjects.has(p.comboChartVisual) || (p.comboChartVisual, void 0), visitedObjects.has(p.customContentVisual) || (p.customContentVisual, void 0), visitedObjects.has(p.emptyVisual) || (p.emptyVisual, void 0), visitedObjects.has(p.filledMapVisual) || (p.filledMapVisual, void 0), visitedObjects.has(p.funnelChartVisual) || (p.funnelChartVisual, void 0), visitedObjects.has(p.gaugeChartVisual) || (p.gaugeChartVisual, void 0), visitedObjects.has(p.geospatialMapVisual) || (p.geospatialMapVisual, void 0), visitedObjects.has(p.heatMapVisual) || (p.heatMapVisual, void 0), visitedObjects.has(p.histogramVisual) || (p.histogramVisual, void 0), visitedObjects.has(p.insightVisual) || (p.insightVisual, void 0), visitedObjects.has(p.kpiVisual) || (p.kpiVisual, void 0), visitedObjects.has(p.lineChartVisual) || (p.lineChartVisual, void 0), visitedObjects.has(p.pieChartVisual) || (p.pieChartVisual, void 0), visitedObjects.has(p.pivotTableVisual) || (p.pivotTableVisual, void 0), visitedObjects.has(p.radarChartVisual) || (p.radarChartVisual, void 0), visitedObjects.has(p.sankeyDiagramVisual) || (p.sankeyDiagramVisual, void 0), visitedObjects.has(p.scatterPlotVisual) || (p.scatterPlotVisual, void 0), visitedObjects.has(p.tableVisual) || (p.tableVisual, void 0), visitedObjects.has(p.treeMapVisual) || (p.treeMapVisual, void 0), visitedObjects.has(p.waterfallVisual) || (p.waterfallVisual, void 0), visitedObjects.has(p.wordCloudVisual) || (p.wordCloudVisual, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_VisualCustomActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actionOperations) || (p.actionOperations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_VisualCustomActionOperationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.filterOperation) || (p.filterOperation, void 0), visitedObjects.has(p.navigationOperation) || (p.navigationOperation, void 0), visitedObjects.has(p.setParametersOperation) || (p.setParametersOperation, void 0), visitedObjects.has(p.urlOperation) || (p.urlOperation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_VisualPaletteProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.colorMap) || (p.colorMap, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_VisualSubtitleLabelOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.formatText) || (p.formatText, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_VisualTitleLabelOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.formatText) || (p.formatText, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_WaterfallChartAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.breakdowns) || (p.breakdowns, void 0), visitedObjects.has(p.categories) || (p.categories, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_WaterfallChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryAxisDisplayOptions) || (p.categoryAxisDisplayOptions, void 0), visitedObjects.has(p.categoryAxisLabelOptions) || (p.categoryAxisLabelOptions, void 0), visitedObjects.has(p.dataLabels) || (p.dataLabels, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.primaryYAxisDisplayOptions) || (p.primaryYAxisDisplayOptions, void 0), visitedObjects.has(p.primaryYAxisLabelOptions) || (p.primaryYAxisLabelOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0), visitedObjects.has(p.waterfallChartOptions) || (p.waterfallChartOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_WaterfallChartFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.waterfallChartAggregatedFieldWells) || (p.waterfallChartAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_WaterfallChartOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_WaterfallChartSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.breakdownItemsLimit) || (p.breakdownItemsLimit, void 0), visitedObjects.has(p.categorySort) || (p.categorySort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_WaterfallVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_WhatIfPointScenarioProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_WhatIfRangeScenarioProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_WordCloudAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.groupBy) || (p.groupBy, void 0), visitedObjects.has(p.size) || (p.size, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_WordCloudChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryLabelOptions) || (p.categoryLabelOptions, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.wordCloudOptions) || (p.wordCloudOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_WordCloudFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.wordCloudAggregatedFieldWells) || (p.wordCloudAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_WordCloudOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_WordCloudSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryItemsLimit) || (p.categoryItemsLimit, void 0), visitedObjects.has(p.categorySort) || (p.categorySort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnAnalysis_WordCloudVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboardProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.dashboardPublishOptions) || (p.dashboardPublishOptions, void 0), visitedObjects.has(p.definition) || (p.definition, void 0), visitedObjects.has(p.parameters) || (p.parameters, void 0), visitedObjects.has(p.permissions) || (p.permissions, void 0), visitedObjects.has(p.sourceEntity) || (p.sourceEntity, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_AdHocFilteringOptionProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_AggregationFunctionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.numericalAggregationFunction) || (p.numericalAggregationFunction, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_AggregationSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.aggregationFunction) || (p.aggregationFunction, void 0), visitedObjects.has(p.column) || (p.column, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_AnalysisDefaultsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultNewSheetConfiguration) || (p.defaultNewSheetConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_AnchorDateConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ArcAxisConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.range) || (p.range, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ArcAxisDisplayRangeProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ArcConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ArcOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_AxisDataOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dateAxisOptions) || (p.dateAxisOptions, void 0), visitedObjects.has(p.numericAxisOptions) || (p.numericAxisOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_AxisDisplayMinMaxRangeProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_AxisDisplayOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataOptions) || (p.dataOptions, void 0), visitedObjects.has(p.scrollbarOptions) || (p.scrollbarOptions, void 0), visitedObjects.has(p.tickLabelOptions) || (p.tickLabelOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_AxisDisplayRangeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.minMax) || (p.minMax, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_AxisLabelOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.applyTo) || (p.applyTo, void 0), visitedObjects.has(p.fontConfiguration) || (p.fontConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_AxisLabelReferenceOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_AxisLinearScaleProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_AxisLogarithmicScaleProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_AxisScaleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.linear) || (p.linear, void 0), visitedObjects.has(p.logarithmic) || (p.logarithmic, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_AxisTickLabelOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.labelOptions) || (p.labelOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_BarChartAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.category) || (p.category, void 0), visitedObjects.has(p.colors) || (p.colors, void 0), visitedObjects.has(p.smallMultiples) || (p.smallMultiples, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_BarChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryAxis) || (p.categoryAxis, void 0), visitedObjects.has(p.categoryLabelOptions) || (p.categoryLabelOptions, void 0), visitedObjects.has(p.colorLabelOptions) || (p.colorLabelOptions, void 0), visitedObjects.has(p.contributionAnalysisDefaults) || (p.contributionAnalysisDefaults, void 0), visitedObjects.has(p.dataLabels) || (p.dataLabels, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.referenceLines) || (p.referenceLines, void 0), visitedObjects.has(p.smallMultiplesOptions) || (p.smallMultiplesOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0), visitedObjects.has(p.valueAxis) || (p.valueAxis, void 0), visitedObjects.has(p.valueLabelOptions) || (p.valueLabelOptions, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_BarChartFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.barChartAggregatedFieldWells) || (p.barChartAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_BarChartSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryItemsLimit) || (p.categoryItemsLimit, void 0), visitedObjects.has(p.categorySort) || (p.categorySort, void 0), visitedObjects.has(p.colorItemsLimit) || (p.colorItemsLimit, void 0), visitedObjects.has(p.colorSort) || (p.colorSort, void 0), visitedObjects.has(p.smallMultiplesLimitConfiguration) || (p.smallMultiplesLimitConfiguration, void 0), visitedObjects.has(p.smallMultiplesSort) || (p.smallMultiplesSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_BarChartVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_BinCountOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_BinWidthOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_BodySectionConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.content) || (p.content, void 0), visitedObjects.has(p.pageBreakConfiguration) || (p.pageBreakConfiguration, void 0), visitedObjects.has(p.style) || (p.style, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_BodySectionContentProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.layout) || (p.layout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_BoxPlotAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.groupBy) || (p.groupBy, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_BoxPlotChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.boxPlotOptions) || (p.boxPlotOptions, void 0), visitedObjects.has(p.categoryAxis) || (p.categoryAxis, void 0), visitedObjects.has(p.categoryLabelOptions) || (p.categoryLabelOptions, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.primaryYAxisDisplayOptions) || (p.primaryYAxisDisplayOptions, void 0), visitedObjects.has(p.primaryYAxisLabelOptions) || (p.primaryYAxisLabelOptions, void 0), visitedObjects.has(p.referenceLines) || (p.referenceLines, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_BoxPlotFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.boxPlotAggregatedFieldWells) || (p.boxPlotAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_BoxPlotOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.styleOptions) || (p.styleOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_BoxPlotSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categorySort) || (p.categorySort, void 0), visitedObjects.has(p.paginationConfiguration) || (p.paginationConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_BoxPlotStyleOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_BoxPlotVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_CalculatedFieldProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_CalculatedMeasureFieldProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_CascadingControlConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sourceControls) || (p.sourceControls, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_CascadingControlSourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columnToMatch) || (p.columnToMatch, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_CategoricalDimensionFieldProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.formatConfiguration) || (p.formatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_CategoricalMeasureFieldProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.formatConfiguration) || (p.formatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_CategoryDrillDownFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_CategoryFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.configuration) || (p.configuration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_CategoryFilterConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customFilterConfiguration) || (p.customFilterConfiguration, void 0), visitedObjects.has(p.customFilterListConfiguration) || (p.customFilterListConfiguration, void 0), visitedObjects.has(p.filterListConfiguration) || (p.filterListConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ChartAxisLabelOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.axisLabelOptions) || (p.axisLabelOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ClusterMarkerProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.simpleClusterMarker) || (p.simpleClusterMarker, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ClusterMarkerConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.clusterMarker) || (p.clusterMarker, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ColorScaleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.colors) || (p.colors, void 0), visitedObjects.has(p.nullValueColor) || (p.nullValueColor, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ColorsConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customColors) || (p.customColors, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ColumnConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.colorsConfiguration) || (p.colorsConfiguration, void 0), visitedObjects.has(p.formatConfiguration) || (p.formatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ColumnHierarchyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dateTimeHierarchy) || (p.dateTimeHierarchy, void 0), visitedObjects.has(p.explicitHierarchy) || (p.explicitHierarchy, void 0), visitedObjects.has(p.predefinedHierarchy) || (p.predefinedHierarchy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ColumnIdentifierProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ColumnSortProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sortBy) || (p.sortBy, void 0), visitedObjects.has(p.aggregationFunction) || (p.aggregationFunction, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ColumnTooltipItemProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.aggregation) || (p.aggregation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ComboChartAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.barValues) || (p.barValues, void 0), visitedObjects.has(p.category) || (p.category, void 0), visitedObjects.has(p.colors) || (p.colors, void 0), visitedObjects.has(p.lineValues) || (p.lineValues, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ComboChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.barDataLabels) || (p.barDataLabels, void 0), visitedObjects.has(p.categoryAxis) || (p.categoryAxis, void 0), visitedObjects.has(p.categoryLabelOptions) || (p.categoryLabelOptions, void 0), visitedObjects.has(p.colorLabelOptions) || (p.colorLabelOptions, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.lineDataLabels) || (p.lineDataLabels, void 0), visitedObjects.has(p.primaryYAxisDisplayOptions) || (p.primaryYAxisDisplayOptions, void 0), visitedObjects.has(p.primaryYAxisLabelOptions) || (p.primaryYAxisLabelOptions, void 0), visitedObjects.has(p.referenceLines) || (p.referenceLines, void 0), visitedObjects.has(p.secondaryYAxisDisplayOptions) || (p.secondaryYAxisDisplayOptions, void 0), visitedObjects.has(p.secondaryYAxisLabelOptions) || (p.secondaryYAxisLabelOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ComboChartFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.comboChartAggregatedFieldWells) || (p.comboChartAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ComboChartSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryItemsLimit) || (p.categoryItemsLimit, void 0), visitedObjects.has(p.categorySort) || (p.categorySort, void 0), visitedObjects.has(p.colorItemsLimit) || (p.colorItemsLimit, void 0), visitedObjects.has(p.colorSort) || (p.colorSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ComboChartVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ComparisonConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.comparisonFormat) || (p.comparisonFormat, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ComparisonFormatConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.numberDisplayFormatConfiguration) || (p.numberDisplayFormatConfiguration, void 0), visitedObjects.has(p.percentageDisplayFormatConfiguration) || (p.percentageDisplayFormatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.forecast) || (p.forecast, void 0), visitedObjects.has(p.growthRate) || (p.growthRate, void 0), visitedObjects.has(p.maximumMinimum) || (p.maximumMinimum, void 0), visitedObjects.has(p.metricComparison) || (p.metricComparison, void 0), visitedObjects.has(p.periodOverPeriod) || (p.periodOverPeriod, void 0), visitedObjects.has(p.periodToDate) || (p.periodToDate, void 0), visitedObjects.has(p.topBottomMovers) || (p.topBottomMovers, void 0), visitedObjects.has(p.topBottomRanked) || (p.topBottomRanked, void 0), visitedObjects.has(p.totalAggregation) || (p.totalAggregation, void 0), visitedObjects.has(p.uniqueValues) || (p.uniqueValues, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ConditionalFormattingColorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.gradient) || (p.gradient, void 0), visitedObjects.has(p.solid) || (p.solid, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ConditionalFormattingCustomIconConditionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.iconOptions) || (p.iconOptions, void 0), visitedObjects.has(p.displayConfiguration) || (p.displayConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ConditionalFormattingCustomIconOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ConditionalFormattingGradientColorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.color) || (p.color, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ConditionalFormattingIconProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customCondition) || (p.customCondition, void 0), visitedObjects.has(p.iconSet) || (p.iconSet, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ConditionalFormattingIconDisplayConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ConditionalFormattingIconSetProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ConditionalFormattingSolidColorProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ContributionAnalysisDefaultProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.contributorDimensions) || (p.contributorDimensions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_CurrencyDisplayFormatConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.decimalPlacesConfiguration) || (p.decimalPlacesConfiguration, void 0), visitedObjects.has(p.negativeValueConfiguration) || (p.negativeValueConfiguration, void 0), visitedObjects.has(p.nullValueFormatConfiguration) || (p.nullValueFormatConfiguration, void 0), visitedObjects.has(p.separatorConfiguration) || (p.separatorConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_CustomActionFilterOperationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.selectedFieldsConfiguration) || (p.selectedFieldsConfiguration, void 0), visitedObjects.has(p.targetVisualsConfiguration) || (p.targetVisualsConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_CustomActionNavigationOperationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.localNavigationConfiguration) || (p.localNavigationConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_CustomActionSetParametersOperationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.parameterValueConfigurations) || (p.parameterValueConfigurations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_CustomActionURLOperationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_CustomColorProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_CustomContentConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_CustomContentVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_CustomFilterConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_CustomFilterListConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_CustomNarrativeOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_CustomParameterValuesProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_CustomValuesConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customValues) || (p.customValues, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DashboardErrorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.violatedEntities) || (p.violatedEntities, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DashboardPublishOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.adHocFilteringOption) || (p.adHocFilteringOption, void 0), visitedObjects.has(p.dataPointDrillUpDownOption) || (p.dataPointDrillUpDownOption, void 0), visitedObjects.has(p.dataPointMenuLabelOption) || (p.dataPointMenuLabelOption, void 0), visitedObjects.has(p.dataPointTooltipOption) || (p.dataPointTooltipOption, void 0), visitedObjects.has(p.exportToCsvOption) || (p.exportToCsvOption, void 0), visitedObjects.has(p.exportWithHiddenFieldsOption) || (p.exportWithHiddenFieldsOption, void 0), visitedObjects.has(p.sheetControlsOption) || (p.sheetControlsOption, void 0), visitedObjects.has(p.sheetLayoutElementMaximizationOption) || (p.sheetLayoutElementMaximizationOption, void 0), visitedObjects.has(p.visualAxisSortOption) || (p.visualAxisSortOption, void 0), visitedObjects.has(p.visualMenuOption) || (p.visualMenuOption, void 0), visitedObjects.has(p.visualPublishOptions) || (p.visualPublishOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DashboardSourceEntityProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sourceTemplate) || (p.sourceTemplate, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DashboardSourceTemplateProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataSetReferences) || (p.dataSetReferences, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DashboardVersionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.errors) || (p.errors, void 0), visitedObjects.has(p.sheets) || (p.sheets, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DashboardVersionDefinitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataSetIdentifierDeclarations) || (p.dataSetIdentifierDeclarations, void 0), visitedObjects.has(p.analysisDefaults) || (p.analysisDefaults, void 0), visitedObjects.has(p.calculatedFields) || (p.calculatedFields, void 0), visitedObjects.has(p.columnConfigurations) || (p.columnConfigurations, void 0), visitedObjects.has(p.filterGroups) || (p.filterGroups, void 0), visitedObjects.has(p.parameterDeclarations) || (p.parameterDeclarations, void 0), visitedObjects.has(p.sheets) || (p.sheets, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DashboardVisualPublishOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.exportHiddenFieldsOption) || (p.exportHiddenFieldsOption, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DataBarsOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DataColorProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DataFieldSeriesItemProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.settings) || (p.settings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DataLabelOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataLabelTypes) || (p.dataLabelTypes, void 0), visitedObjects.has(p.labelFontConfiguration) || (p.labelFontConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DataLabelTypeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataPathLabelType) || (p.dataPathLabelType, void 0), visitedObjects.has(p.fieldLabelType) || (p.fieldLabelType, void 0), visitedObjects.has(p.maximumLabelType) || (p.maximumLabelType, void 0), visitedObjects.has(p.minimumLabelType) || (p.minimumLabelType, void 0), visitedObjects.has(p.rangeEndsLabelType) || (p.rangeEndsLabelType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DataPathColorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.element) || (p.element, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DataPathLabelTypeProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DataPathSortProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sortPaths) || (p.sortPaths, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DataPathValueProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DataPointDrillUpDownOptionProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DataPointMenuLabelOptionProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DataPointTooltipOptionProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DataSetIdentifierDeclarationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DataSetReferenceProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DateAxisOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DateDimensionFieldProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.formatConfiguration) || (p.formatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DateMeasureFieldProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.formatConfiguration) || (p.formatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DateTimeDefaultValuesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dynamicValue) || (p.dynamicValue, void 0), visitedObjects.has(p.rollingDate) || (p.rollingDate, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DateTimeFormatConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.nullValueFormatConfiguration) || (p.nullValueFormatConfiguration, void 0), visitedObjects.has(p.numericFormatConfiguration) || (p.numericFormatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DateTimeHierarchyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.drillDownFilters) || (p.drillDownFilters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DateTimeParameterProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DateTimeParameterDeclarationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultValues) || (p.defaultValues, void 0), visitedObjects.has(p.mappedDataSetParameters) || (p.mappedDataSetParameters, void 0), visitedObjects.has(p.valueWhenUnset) || (p.valueWhenUnset, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DateTimePickerControlDisplayOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.titleOptions) || (p.titleOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DateTimeValueWhenUnsetConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DecimalDefaultValuesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dynamicValue) || (p.dynamicValue, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DecimalParameterProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DecimalParameterDeclarationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultValues) || (p.defaultValues, void 0), visitedObjects.has(p.mappedDataSetParameters) || (p.mappedDataSetParameters, void 0), visitedObjects.has(p.valueWhenUnset) || (p.valueWhenUnset, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DecimalPlacesConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DecimalValueWhenUnsetConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DefaultFreeFormLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.canvasSizeOptions) || (p.canvasSizeOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DefaultGridLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.canvasSizeOptions) || (p.canvasSizeOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DefaultInteractiveLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.freeForm) || (p.freeForm, void 0), visitedObjects.has(p.grid) || (p.grid, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DefaultNewSheetConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.interactiveLayoutConfiguration) || (p.interactiveLayoutConfiguration, void 0), visitedObjects.has(p.paginatedLayoutConfiguration) || (p.paginatedLayoutConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DefaultPaginatedLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sectionBased) || (p.sectionBased, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DefaultSectionBasedLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.canvasSizeOptions) || (p.canvasSizeOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DestinationParameterValueConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customValuesConfiguration) || (p.customValuesConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DimensionFieldProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoricalDimensionField) || (p.categoricalDimensionField, void 0), visitedObjects.has(p.dateDimensionField) || (p.dateDimensionField, void 0), visitedObjects.has(p.numericalDimensionField) || (p.numericalDimensionField, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DonutCenterOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DonutOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.arcOptions) || (p.arcOptions, void 0), visitedObjects.has(p.donutCenterOptions) || (p.donutCenterOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DrillDownFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryFilter) || (p.categoryFilter, void 0), visitedObjects.has(p.numericEqualityFilter) || (p.numericEqualityFilter, void 0), visitedObjects.has(p.timeRangeFilter) || (p.timeRangeFilter, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DropDownControlDisplayOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.selectAllOptions) || (p.selectAllOptions, void 0), visitedObjects.has(p.titleOptions) || (p.titleOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_DynamicDefaultValueProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultValueColumn) || (p.defaultValueColumn, void 0), visitedObjects.has(p.groupNameColumn) || (p.groupNameColumn, void 0), visitedObjects.has(p.userNameColumn) || (p.userNameColumn, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_EmptyVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_EntityProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ExcludePeriodConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ExplicitHierarchyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columns) || (p.columns, void 0), visitedObjects.has(p.drillDownFilters) || (p.drillDownFilters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ExportHiddenFieldsOptionProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ExportToCSVOptionProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ExportWithHiddenFieldsOptionProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FieldBasedTooltipProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tooltipFields) || (p.tooltipFields, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FieldLabelTypeProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FieldSeriesItemProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.settings) || (p.settings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FieldSortProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FieldSortOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columnSort) || (p.columnSort, void 0), visitedObjects.has(p.fieldSort) || (p.fieldSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FieldTooltipItemProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FilledMapAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.geospatial) || (p.geospatial, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FilledMapConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.conditionalFormattingOptions) || (p.conditionalFormattingOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FilledMapConditionalFormattingOptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.shape) || (p.shape, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FilledMapConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.mapStyleOptions) || (p.mapStyleOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0), visitedObjects.has(p.windowOptions) || (p.windowOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FilledMapFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.filledMapAggregatedFieldWells) || (p.filledMapAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FilledMapShapeConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.format) || (p.format, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FilledMapSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categorySort) || (p.categorySort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FilledMapVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.conditionalFormatting) || (p.conditionalFormatting, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryFilter) || (p.categoryFilter, void 0), visitedObjects.has(p.numericEqualityFilter) || (p.numericEqualityFilter, void 0), visitedObjects.has(p.numericRangeFilter) || (p.numericRangeFilter, void 0), visitedObjects.has(p.relativeDatesFilter) || (p.relativeDatesFilter, void 0), visitedObjects.has(p.timeEqualityFilter) || (p.timeEqualityFilter, void 0), visitedObjects.has(p.timeRangeFilter) || (p.timeRangeFilter, void 0), visitedObjects.has(p.topBottomFilter) || (p.topBottomFilter, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FilterControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dateTimePicker) || (p.dateTimePicker, void 0), visitedObjects.has(p.dropdown) || (p.dropdown, void 0), visitedObjects.has(p.list) || (p.list, void 0), visitedObjects.has(p.relativeDateTime) || (p.relativeDateTime, void 0), visitedObjects.has(p.slider) || (p.slider, void 0), visitedObjects.has(p.textArea) || (p.textArea, void 0), visitedObjects.has(p.textField) || (p.textField, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FilterDateTimePickerControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FilterDropDownControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cascadingControlConfiguration) || (p.cascadingControlConfiguration, void 0), visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0), visitedObjects.has(p.selectableValues) || (p.selectableValues, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FilterGroupProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.filters) || (p.filters, void 0), visitedObjects.has(p.scopeConfiguration) || (p.scopeConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FilterListConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FilterListControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cascadingControlConfiguration) || (p.cascadingControlConfiguration, void 0), visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0), visitedObjects.has(p.selectableValues) || (p.selectableValues, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FilterOperationSelectedFieldsConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FilterOperationTargetVisualsConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sameSheetTargetVisualConfiguration) || (p.sameSheetTargetVisualConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FilterRelativeDateTimeControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FilterScopeConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.selectedSheets) || (p.selectedSheets, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FilterSelectableValuesProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FilterSliderControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FilterTextAreaControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FilterTextFieldControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FontConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fontSize) || (p.fontSize, void 0), visitedObjects.has(p.fontWeight) || (p.fontWeight, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FontSizeProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FontWeightProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ForecastComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.time) || (p.time, void 0), visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ForecastConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.forecastProperties) || (p.forecastProperties, void 0), visitedObjects.has(p.scenario) || (p.scenario, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ForecastScenarioProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.whatIfPointScenario) || (p.whatIfPointScenario, void 0), visitedObjects.has(p.whatIfRangeScenario) || (p.whatIfRangeScenario, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FormatConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dateTimeFormatConfiguration) || (p.dateTimeFormatConfiguration, void 0), visitedObjects.has(p.numberFormatConfiguration) || (p.numberFormatConfiguration, void 0), visitedObjects.has(p.stringFormatConfiguration) || (p.stringFormatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FreeFormLayoutCanvasSizeOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.screenCanvasSizeOptions) || (p.screenCanvasSizeOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FreeFormLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.elements) || (p.elements, void 0), visitedObjects.has(p.canvasSizeOptions) || (p.canvasSizeOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FreeFormLayoutElementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.backgroundStyle) || (p.backgroundStyle, void 0), visitedObjects.has(p.borderStyle) || (p.borderStyle, void 0), visitedObjects.has(p.loadingAnimation) || (p.loadingAnimation, void 0), visitedObjects.has(p.renderingRules) || (p.renderingRules, void 0), visitedObjects.has(p.selectedBorderStyle) || (p.selectedBorderStyle, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FreeFormLayoutElementBackgroundStyleProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FreeFormLayoutElementBorderStyleProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FreeFormLayoutScreenCanvasSizeOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FreeFormSectionLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.elements) || (p.elements, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FunnelChartAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.category) || (p.category, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FunnelChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryLabelOptions) || (p.categoryLabelOptions, void 0), visitedObjects.has(p.dataLabelOptions) || (p.dataLabelOptions, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0), visitedObjects.has(p.valueLabelOptions) || (p.valueLabelOptions, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FunnelChartDataLabelOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.labelFontConfiguration) || (p.labelFontConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FunnelChartFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.funnelChartAggregatedFieldWells) || (p.funnelChartAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FunnelChartSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryItemsLimit) || (p.categoryItemsLimit, void 0), visitedObjects.has(p.categorySort) || (p.categorySort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_FunnelChartVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_GaugeChartArcConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.foregroundColor) || (p.foregroundColor, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_GaugeChartConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.conditionalFormattingOptions) || (p.conditionalFormattingOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_GaugeChartConditionalFormattingOptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.arc) || (p.arc, void 0), visitedObjects.has(p.primaryValue) || (p.primaryValue, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_GaugeChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataLabels) || (p.dataLabels, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.gaugeChartOptions) || (p.gaugeChartOptions, void 0), visitedObjects.has(p.tooltipOptions) || (p.tooltipOptions, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_GaugeChartFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.targetValues) || (p.targetValues, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_GaugeChartOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.arc) || (p.arc, void 0), visitedObjects.has(p.arcAxis) || (p.arcAxis, void 0), visitedObjects.has(p.comparison) || (p.comparison, void 0), visitedObjects.has(p.primaryValueFontConfiguration) || (p.primaryValueFontConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_GaugeChartPrimaryValueConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.icon) || (p.icon, void 0), visitedObjects.has(p.textColor) || (p.textColor, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_GaugeChartVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.conditionalFormatting) || (p.conditionalFormatting, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_GeospatialCoordinateBoundsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_GeospatialMapAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.colors) || (p.colors, void 0), visitedObjects.has(p.geospatial) || (p.geospatial, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_GeospatialMapConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.mapStyleOptions) || (p.mapStyleOptions, void 0), visitedObjects.has(p.pointStyleOptions) || (p.pointStyleOptions, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0), visitedObjects.has(p.windowOptions) || (p.windowOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_GeospatialMapFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.geospatialMapAggregatedFieldWells) || (p.geospatialMapAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_GeospatialMapStyleOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_GeospatialMapVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_GeospatialPointStyleOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.clusterMarkerConfiguration) || (p.clusterMarkerConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_GeospatialWindowOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bounds) || (p.bounds, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_GlobalTableBorderOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sideSpecificBorder) || (p.sideSpecificBorder, void 0), visitedObjects.has(p.uniformBorder) || (p.uniformBorder, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_GradientColorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.stops) || (p.stops, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_GradientStopProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_GridLayoutCanvasSizeOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.screenCanvasSizeOptions) || (p.screenCanvasSizeOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_GridLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.elements) || (p.elements, void 0), visitedObjects.has(p.canvasSizeOptions) || (p.canvasSizeOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_GridLayoutElementProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_GridLayoutScreenCanvasSizeOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_GrowthRateComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.time) || (p.time, void 0), visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_HeaderFooterSectionConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.layout) || (p.layout, void 0), visitedObjects.has(p.style) || (p.style, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_HeatMapAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columns) || (p.columns, void 0), visitedObjects.has(p.rows) || (p.rows, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_HeatMapConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.colorScale) || (p.colorScale, void 0), visitedObjects.has(p.columnLabelOptions) || (p.columnLabelOptions, void 0), visitedObjects.has(p.dataLabels) || (p.dataLabels, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.rowLabelOptions) || (p.rowLabelOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_HeatMapFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.heatMapAggregatedFieldWells) || (p.heatMapAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_HeatMapSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.heatMapColumnItemsLimitConfiguration) || (p.heatMapColumnItemsLimitConfiguration, void 0), visitedObjects.has(p.heatMapColumnSort) || (p.heatMapColumnSort, void 0), visitedObjects.has(p.heatMapRowItemsLimitConfiguration) || (p.heatMapRowItemsLimitConfiguration, void 0), visitedObjects.has(p.heatMapRowSort) || (p.heatMapRowSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_HeatMapVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_HistogramAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_HistogramBinOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.binCount) || (p.binCount, void 0), visitedObjects.has(p.binWidth) || (p.binWidth, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_HistogramConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.binOptions) || (p.binOptions, void 0), visitedObjects.has(p.dataLabels) || (p.dataLabels, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0), visitedObjects.has(p.xAxisDisplayOptions) || (p.xAxisDisplayOptions, void 0), visitedObjects.has(p.xAxisLabelOptions) || (p.xAxisLabelOptions, void 0), visitedObjects.has(p.yAxisDisplayOptions) || (p.yAxisDisplayOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_HistogramFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.histogramAggregatedFieldWells) || (p.histogramAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_HistogramVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_InsightConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.computations) || (p.computations, void 0), visitedObjects.has(p.customNarrative) || (p.customNarrative, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_InsightVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.insightConfiguration) || (p.insightConfiguration, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_IntegerDefaultValuesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dynamicValue) || (p.dynamicValue, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_IntegerParameterProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_IntegerParameterDeclarationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultValues) || (p.defaultValues, void 0), visitedObjects.has(p.mappedDataSetParameters) || (p.mappedDataSetParameters, void 0), visitedObjects.has(p.valueWhenUnset) || (p.valueWhenUnset, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_IntegerValueWhenUnsetConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ItemsLimitConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_KPIConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.conditionalFormattingOptions) || (p.conditionalFormattingOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_KPIConditionalFormattingOptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.primaryValue) || (p.primaryValue, void 0), visitedObjects.has(p.progressBar) || (p.progressBar, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_KPIConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.kpiOptions) || (p.kpiOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_KPIFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.targetValues) || (p.targetValues, void 0), visitedObjects.has(p.trendGroups) || (p.trendGroups, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_KPIOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.comparison) || (p.comparison, void 0), visitedObjects.has(p.primaryValueFontConfiguration) || (p.primaryValueFontConfiguration, void 0), visitedObjects.has(p.progressBar) || (p.progressBar, void 0), visitedObjects.has(p.secondaryValue) || (p.secondaryValue, void 0), visitedObjects.has(p.secondaryValueFontConfiguration) || (p.secondaryValueFontConfiguration, void 0), visitedObjects.has(p.trendArrows) || (p.trendArrows, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_KPIPrimaryValueConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.icon) || (p.icon, void 0), visitedObjects.has(p.textColor) || (p.textColor, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_KPIProgressBarConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.foregroundColor) || (p.foregroundColor, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_KPISortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.trendGroupSort) || (p.trendGroupSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_KPIVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.conditionalFormatting) || (p.conditionalFormatting, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_LabelOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fontConfiguration) || (p.fontConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_LayoutProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.configuration) || (p.configuration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_LayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.freeFormLayout) || (p.freeFormLayout, void 0), visitedObjects.has(p.gridLayout) || (p.gridLayout, void 0), visitedObjects.has(p.sectionBasedLayout) || (p.sectionBasedLayout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_LegendOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_LineChartAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.category) || (p.category, void 0), visitedObjects.has(p.colors) || (p.colors, void 0), visitedObjects.has(p.smallMultiples) || (p.smallMultiples, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_LineChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.contributionAnalysisDefaults) || (p.contributionAnalysisDefaults, void 0), visitedObjects.has(p.dataLabels) || (p.dataLabels, void 0), visitedObjects.has(p.defaultSeriesSettings) || (p.defaultSeriesSettings, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.forecastConfigurations) || (p.forecastConfigurations, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.primaryYAxisDisplayOptions) || (p.primaryYAxisDisplayOptions, void 0), visitedObjects.has(p.primaryYAxisLabelOptions) || (p.primaryYAxisLabelOptions, void 0), visitedObjects.has(p.referenceLines) || (p.referenceLines, void 0), visitedObjects.has(p.secondaryYAxisDisplayOptions) || (p.secondaryYAxisDisplayOptions, void 0), visitedObjects.has(p.secondaryYAxisLabelOptions) || (p.secondaryYAxisLabelOptions, void 0), visitedObjects.has(p.series) || (p.series, void 0), visitedObjects.has(p.smallMultiplesOptions) || (p.smallMultiplesOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0), visitedObjects.has(p.xAxisDisplayOptions) || (p.xAxisDisplayOptions, void 0), visitedObjects.has(p.xAxisLabelOptions) || (p.xAxisLabelOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_LineChartDefaultSeriesSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.lineStyleSettings) || (p.lineStyleSettings, void 0), visitedObjects.has(p.markerStyleSettings) || (p.markerStyleSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_LineChartFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.lineChartAggregatedFieldWells) || (p.lineChartAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_LineChartLineStyleSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_LineChartMarkerStyleSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_LineChartSeriesSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.lineStyleSettings) || (p.lineStyleSettings, void 0), visitedObjects.has(p.markerStyleSettings) || (p.markerStyleSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_LineChartSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryItemsLimitConfiguration) || (p.categoryItemsLimitConfiguration, void 0), visitedObjects.has(p.categorySort) || (p.categorySort, void 0), visitedObjects.has(p.colorItemsLimitConfiguration) || (p.colorItemsLimitConfiguration, void 0), visitedObjects.has(p.smallMultiplesLimitConfiguration) || (p.smallMultiplesLimitConfiguration, void 0), visitedObjects.has(p.smallMultiplesSort) || (p.smallMultiplesSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_LineChartVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_LineSeriesAxisDisplayOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.axisOptions) || (p.axisOptions, void 0), visitedObjects.has(p.missingDataConfigurations) || (p.missingDataConfigurations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ListControlDisplayOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.searchOptions) || (p.searchOptions, void 0), visitedObjects.has(p.selectAllOptions) || (p.selectAllOptions, void 0), visitedObjects.has(p.titleOptions) || (p.titleOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ListControlSearchOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ListControlSelectAllOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_LoadingAnimationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_LocalNavigationConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_LongFormatTextProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_MappedDataSetParameterProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_MaximumLabelTypeProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_MaximumMinimumComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.time) || (p.time, void 0), visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_MeasureFieldProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.calculatedMeasureField) || (p.calculatedMeasureField, void 0), visitedObjects.has(p.categoricalMeasureField) || (p.categoricalMeasureField, void 0), visitedObjects.has(p.dateMeasureField) || (p.dateMeasureField, void 0), visitedObjects.has(p.numericalMeasureField) || (p.numericalMeasureField, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_MetricComparisonComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fromValue) || (p.fromValue, void 0), visitedObjects.has(p.targetValue) || (p.targetValue, void 0), visitedObjects.has(p.time) || (p.time, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_MinimumLabelTypeProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_MissingDataConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_NegativeValueConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_NullValueFormatConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_NumberDisplayFormatConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.decimalPlacesConfiguration) || (p.decimalPlacesConfiguration, void 0), visitedObjects.has(p.negativeValueConfiguration) || (p.negativeValueConfiguration, void 0), visitedObjects.has(p.nullValueFormatConfiguration) || (p.nullValueFormatConfiguration, void 0), visitedObjects.has(p.separatorConfiguration) || (p.separatorConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_NumberFormatConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.formatConfiguration) || (p.formatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_NumericAxisOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.range) || (p.range, void 0), visitedObjects.has(p.scale) || (p.scale, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_NumericEqualityDrillDownFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_NumericEqualityFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.aggregationFunction) || (p.aggregationFunction, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_NumericFormatConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.currencyDisplayFormatConfiguration) || (p.currencyDisplayFormatConfiguration, void 0), visitedObjects.has(p.numberDisplayFormatConfiguration) || (p.numberDisplayFormatConfiguration, void 0), visitedObjects.has(p.percentageDisplayFormatConfiguration) || (p.percentageDisplayFormatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_NumericRangeFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.aggregationFunction) || (p.aggregationFunction, void 0), visitedObjects.has(p.rangeMaximum) || (p.rangeMaximum, void 0), visitedObjects.has(p.rangeMinimum) || (p.rangeMinimum, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_NumericRangeFilterValueProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_NumericSeparatorConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.thousandsSeparator) || (p.thousandsSeparator, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_NumericalAggregationFunctionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.percentileAggregation) || (p.percentileAggregation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_NumericalDimensionFieldProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.formatConfiguration) || (p.formatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_NumericalMeasureFieldProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.aggregationFunction) || (p.aggregationFunction, void 0), visitedObjects.has(p.formatConfiguration) || (p.formatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PaginationConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PanelConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PanelTitleOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fontConfiguration) || (p.fontConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ParameterControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dateTimePicker) || (p.dateTimePicker, void 0), visitedObjects.has(p.dropdown) || (p.dropdown, void 0), visitedObjects.has(p.list) || (p.list, void 0), visitedObjects.has(p.slider) || (p.slider, void 0), visitedObjects.has(p.textArea) || (p.textArea, void 0), visitedObjects.has(p.textField) || (p.textField, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ParameterDateTimePickerControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ParameterDeclarationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dateTimeParameterDeclaration) || (p.dateTimeParameterDeclaration, void 0), visitedObjects.has(p.decimalParameterDeclaration) || (p.decimalParameterDeclaration, void 0), visitedObjects.has(p.integerParameterDeclaration) || (p.integerParameterDeclaration, void 0), visitedObjects.has(p.stringParameterDeclaration) || (p.stringParameterDeclaration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ParameterDropDownControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cascadingControlConfiguration) || (p.cascadingControlConfiguration, void 0), visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0), visitedObjects.has(p.selectableValues) || (p.selectableValues, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ParameterListControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cascadingControlConfiguration) || (p.cascadingControlConfiguration, void 0), visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0), visitedObjects.has(p.selectableValues) || (p.selectableValues, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ParameterSelectableValuesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.linkToDataSetColumn) || (p.linkToDataSetColumn, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ParameterSliderControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ParameterTextAreaControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ParameterTextFieldControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dateTimeParameters) || (p.dateTimeParameters, void 0), visitedObjects.has(p.decimalParameters) || (p.decimalParameters, void 0), visitedObjects.has(p.integerParameters) || (p.integerParameters, void 0), visitedObjects.has(p.stringParameters) || (p.stringParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PercentVisibleRangeProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PercentageDisplayFormatConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.decimalPlacesConfiguration) || (p.decimalPlacesConfiguration, void 0), visitedObjects.has(p.negativeValueConfiguration) || (p.negativeValueConfiguration, void 0), visitedObjects.has(p.nullValueFormatConfiguration) || (p.nullValueFormatConfiguration, void 0), visitedObjects.has(p.separatorConfiguration) || (p.separatorConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PercentileAggregationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PeriodOverPeriodComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.time) || (p.time, void 0), visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PeriodToDateComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.time) || (p.time, void 0), visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PieChartAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.category) || (p.category, void 0), visitedObjects.has(p.smallMultiples) || (p.smallMultiples, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PieChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryLabelOptions) || (p.categoryLabelOptions, void 0), visitedObjects.has(p.contributionAnalysisDefaults) || (p.contributionAnalysisDefaults, void 0), visitedObjects.has(p.dataLabels) || (p.dataLabels, void 0), visitedObjects.has(p.donutOptions) || (p.donutOptions, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.smallMultiplesOptions) || (p.smallMultiplesOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0), visitedObjects.has(p.valueLabelOptions) || (p.valueLabelOptions, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PieChartFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.pieChartAggregatedFieldWells) || (p.pieChartAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PieChartSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryItemsLimit) || (p.categoryItemsLimit, void 0), visitedObjects.has(p.categorySort) || (p.categorySort, void 0), visitedObjects.has(p.smallMultiplesLimitConfiguration) || (p.smallMultiplesLimitConfiguration, void 0), visitedObjects.has(p.smallMultiplesSort) || (p.smallMultiplesSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PieChartVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PivotFieldSortOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sortBy) || (p.sortBy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columns) || (p.columns, void 0), visitedObjects.has(p.rows) || (p.rows, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableCellConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.scope) || (p.scope, void 0), visitedObjects.has(p.textFormat) || (p.textFormat, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.conditionalFormattingOptions) || (p.conditionalFormattingOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableConditionalFormattingOptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cell) || (p.cell, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableConditionalFormattingScopeProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldOptions) || (p.fieldOptions, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.paginatedReportOptions) || (p.paginatedReportOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tableOptions) || (p.tableOptions, void 0), visitedObjects.has(p.totalOptions) || (p.totalOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableDataPathOptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataPathList) || (p.dataPathList, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableFieldOptionProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableFieldOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataPathOptions) || (p.dataPathOptions, void 0), visitedObjects.has(p.selectedFieldOptions) || (p.selectedFieldOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableFieldSubtotalOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.pivotTableAggregatedFieldWells) || (p.pivotTableAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cellStyle) || (p.cellStyle, void 0), visitedObjects.has(p.columnHeaderStyle) || (p.columnHeaderStyle, void 0), visitedObjects.has(p.rowAlternateColorOptions) || (p.rowAlternateColorOptions, void 0), visitedObjects.has(p.rowFieldNamesStyle) || (p.rowFieldNamesStyle, void 0), visitedObjects.has(p.rowHeaderStyle) || (p.rowHeaderStyle, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTablePaginatedReportOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableSortByProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.dataPath) || (p.dataPath, void 0), visitedObjects.has(p.field) || (p.field, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldSortOptions) || (p.fieldSortOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableTotalOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columnSubtotalOptions) || (p.columnSubtotalOptions, void 0), visitedObjects.has(p.columnTotalOptions) || (p.columnTotalOptions, void 0), visitedObjects.has(p.rowSubtotalOptions) || (p.rowSubtotalOptions, void 0), visitedObjects.has(p.rowTotalOptions) || (p.rowTotalOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.conditionalFormatting) || (p.conditionalFormatting, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTotalOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.metricHeaderCellStyle) || (p.metricHeaderCellStyle, void 0), visitedObjects.has(p.totalCellStyle) || (p.totalCellStyle, void 0), visitedObjects.has(p.valueCellStyle) || (p.valueCellStyle, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_PredefinedHierarchyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columns) || (p.columns, void 0), visitedObjects.has(p.drillDownFilters) || (p.drillDownFilters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ProgressBarOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_RadarChartAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.category) || (p.category, void 0), visitedObjects.has(p.color) || (p.color, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_RadarChartAreaStyleSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_RadarChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.baseSeriesSettings) || (p.baseSeriesSettings, void 0), visitedObjects.has(p.categoryAxis) || (p.categoryAxis, void 0), visitedObjects.has(p.categoryLabelOptions) || (p.categoryLabelOptions, void 0), visitedObjects.has(p.colorAxis) || (p.colorAxis, void 0), visitedObjects.has(p.colorLabelOptions) || (p.colorLabelOptions, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_RadarChartFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.radarChartAggregatedFieldWells) || (p.radarChartAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_RadarChartSeriesSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.areaStyleSettings) || (p.areaStyleSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_RadarChartSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryItemsLimit) || (p.categoryItemsLimit, void 0), visitedObjects.has(p.categorySort) || (p.categorySort, void 0), visitedObjects.has(p.colorItemsLimit) || (p.colorItemsLimit, void 0), visitedObjects.has(p.colorSort) || (p.colorSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_RadarChartVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_RangeEndsLabelTypeProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ReferenceLineProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataConfiguration) || (p.dataConfiguration, void 0), visitedObjects.has(p.labelConfiguration) || (p.labelConfiguration, void 0), visitedObjects.has(p.styleConfiguration) || (p.styleConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ReferenceLineCustomLabelConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ReferenceLineDataConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dynamicConfiguration) || (p.dynamicConfiguration, void 0), visitedObjects.has(p.staticConfiguration) || (p.staticConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ReferenceLineDynamicDataConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.calculation) || (p.calculation, void 0), visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.measureAggregationFunction) || (p.measureAggregationFunction, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ReferenceLineLabelConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customLabelConfiguration) || (p.customLabelConfiguration, void 0), visitedObjects.has(p.fontConfiguration) || (p.fontConfiguration, void 0), visitedObjects.has(p.valueLabelConfiguration) || (p.valueLabelConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ReferenceLineStaticDataConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ReferenceLineStyleConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ReferenceLineValueLabelConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.formatConfiguration) || (p.formatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_RelativeDateTimeControlDisplayOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.titleOptions) || (p.titleOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_RelativeDatesFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.anchorDateConfiguration) || (p.anchorDateConfiguration, void 0), visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.excludePeriodConfiguration) || (p.excludePeriodConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ResourcePermissionProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_RollingDateConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_RowAlternateColorOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SameSheetTargetVisualConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SankeyDiagramAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destination) || (p.destination, void 0), visitedObjects.has(p.source) || (p.source, void 0), visitedObjects.has(p.weight) || (p.weight, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SankeyDiagramChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataLabels) || (p.dataLabels, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SankeyDiagramFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sankeyDiagramAggregatedFieldWells) || (p.sankeyDiagramAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SankeyDiagramSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destinationItemsLimit) || (p.destinationItemsLimit, void 0), visitedObjects.has(p.sourceItemsLimit) || (p.sourceItemsLimit, void 0), visitedObjects.has(p.weightSort) || (p.weightSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SankeyDiagramVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ScatterPlotCategoricallyAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.category) || (p.category, void 0), visitedObjects.has(p.size) || (p.size, void 0), visitedObjects.has(p.xAxis) || (p.xAxis, void 0), visitedObjects.has(p.yAxis) || (p.yAxis, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ScatterPlotConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataLabels) || (p.dataLabels, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0), visitedObjects.has(p.xAxisDisplayOptions) || (p.xAxisDisplayOptions, void 0), visitedObjects.has(p.xAxisLabelOptions) || (p.xAxisLabelOptions, void 0), visitedObjects.has(p.yAxisDisplayOptions) || (p.yAxisDisplayOptions, void 0), visitedObjects.has(p.yAxisLabelOptions) || (p.yAxisLabelOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ScatterPlotFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.scatterPlotCategoricallyAggregatedFieldWells) || (p.scatterPlotCategoricallyAggregatedFieldWells, void 0), visitedObjects.has(p.scatterPlotUnaggregatedFieldWells) || (p.scatterPlotUnaggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ScatterPlotUnaggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.size) || (p.size, void 0), visitedObjects.has(p.xAxis) || (p.xAxis, void 0), visitedObjects.has(p.yAxis) || (p.yAxis, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ScatterPlotVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ScrollBarOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.visibleRange) || (p.visibleRange, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SecondaryValueOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SectionAfterPageBreakProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SectionBasedLayoutCanvasSizeOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.paperCanvasSizeOptions) || (p.paperCanvasSizeOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SectionBasedLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bodySections) || (p.bodySections, void 0), visitedObjects.has(p.canvasSizeOptions) || (p.canvasSizeOptions, void 0), visitedObjects.has(p.footerSections) || (p.footerSections, void 0), visitedObjects.has(p.headerSections) || (p.headerSections, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SectionBasedLayoutPaperCanvasSizeOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.paperMargin) || (p.paperMargin, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SectionLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.freeFormLayout) || (p.freeFormLayout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SectionPageBreakConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.after) || (p.after, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SectionStyleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.padding) || (p.padding, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SelectedSheetsFilterScopeConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sheetVisualScopingConfigurations) || (p.sheetVisualScopingConfigurations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SeriesItemProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataFieldSeriesItem) || (p.dataFieldSeriesItem, void 0), visitedObjects.has(p.fieldSeriesItem) || (p.fieldSeriesItem, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SetParameterValueConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ShapeConditionalFormatProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.backgroundColor) || (p.backgroundColor, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SheetProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SheetControlLayoutProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.configuration) || (p.configuration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SheetControlLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.gridLayout) || (p.gridLayout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SheetControlsOptionProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SheetDefinitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.filterControls) || (p.filterControls, void 0), visitedObjects.has(p.layouts) || (p.layouts, void 0), visitedObjects.has(p.parameterControls) || (p.parameterControls, void 0), visitedObjects.has(p.sheetControlLayouts) || (p.sheetControlLayouts, void 0), visitedObjects.has(p.textBoxes) || (p.textBoxes, void 0), visitedObjects.has(p.visuals) || (p.visuals, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SheetElementConfigurationOverridesProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SheetElementRenderingRuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.configurationOverrides) || (p.configurationOverrides, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SheetLayoutElementMaximizationOptionProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SheetTextBoxProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SheetVisualScopingConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ShortFormatTextProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SimpleClusterMarkerProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SliderControlDisplayOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.titleOptions) || (p.titleOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SmallMultiplesOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.panelConfiguration) || (p.panelConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SpacingProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_StringDefaultValuesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dynamicValue) || (p.dynamicValue, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_StringFormatConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.nullValueFormatConfiguration) || (p.nullValueFormatConfiguration, void 0), visitedObjects.has(p.numericFormatConfiguration) || (p.numericFormatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_StringParameterProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_StringParameterDeclarationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultValues) || (p.defaultValues, void 0), visitedObjects.has(p.mappedDataSetParameters) || (p.mappedDataSetParameters, void 0), visitedObjects.has(p.valueWhenUnset) || (p.valueWhenUnset, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_StringValueWhenUnsetConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_SubtotalOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldLevelOptions) || (p.fieldLevelOptions, void 0), visitedObjects.has(p.metricHeaderCellStyle) || (p.metricHeaderCellStyle, void 0), visitedObjects.has(p.totalCellStyle) || (p.totalCellStyle, void 0), visitedObjects.has(p.valueCellStyle) || (p.valueCellStyle, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TableAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.groupBy) || (p.groupBy, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TableBorderOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TableCellConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.textFormat) || (p.textFormat, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TableCellImageSizingConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TableCellStyleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.border) || (p.border, void 0), visitedObjects.has(p.fontConfiguration) || (p.fontConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TableConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.conditionalFormattingOptions) || (p.conditionalFormattingOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TableConditionalFormattingOptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cell) || (p.cell, void 0), visitedObjects.has(p.row) || (p.row, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TableConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldOptions) || (p.fieldOptions, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.paginatedReportOptions) || (p.paginatedReportOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tableInlineVisualizations) || (p.tableInlineVisualizations, void 0), visitedObjects.has(p.tableOptions) || (p.tableOptions, void 0), visitedObjects.has(p.totalOptions) || (p.totalOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TableFieldCustomIconContentProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TableFieldCustomTextContentProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fontConfiguration) || (p.fontConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TableFieldImageConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sizingOptions) || (p.sizingOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TableFieldLinkConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.content) || (p.content, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TableFieldLinkContentConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customIconContent) || (p.customIconContent, void 0), visitedObjects.has(p.customTextContent) || (p.customTextContent, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TableFieldOptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.urlStyling) || (p.urlStyling, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TableFieldOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.selectedFieldOptions) || (p.selectedFieldOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TableFieldURLConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.imageConfiguration) || (p.imageConfiguration, void 0), visitedObjects.has(p.linkConfiguration) || (p.linkConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TableFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tableAggregatedFieldWells) || (p.tableAggregatedFieldWells, void 0), visitedObjects.has(p.tableUnaggregatedFieldWells) || (p.tableUnaggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TableInlineVisualizationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataBars) || (p.dataBars, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TableOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cellStyle) || (p.cellStyle, void 0), visitedObjects.has(p.headerStyle) || (p.headerStyle, void 0), visitedObjects.has(p.rowAlternateColorOptions) || (p.rowAlternateColorOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TablePaginatedReportOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TableRowConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.backgroundColor) || (p.backgroundColor, void 0), visitedObjects.has(p.textColor) || (p.textColor, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TableSideBorderOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bottom) || (p.bottom, void 0), visitedObjects.has(p.innerHorizontal) || (p.innerHorizontal, void 0), visitedObjects.has(p.innerVertical) || (p.innerVertical, void 0), visitedObjects.has(p.left) || (p.left, void 0), visitedObjects.has(p.right) || (p.right, void 0), visitedObjects.has(p.top) || (p.top, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TableSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.paginationConfiguration) || (p.paginationConfiguration, void 0), visitedObjects.has(p.rowSort) || (p.rowSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TableUnaggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TableVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.conditionalFormatting) || (p.conditionalFormatting, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TextAreaControlDisplayOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.placeholderOptions) || (p.placeholderOptions, void 0), visitedObjects.has(p.titleOptions) || (p.titleOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TextConditionalFormatProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.backgroundColor) || (p.backgroundColor, void 0), visitedObjects.has(p.icon) || (p.icon, void 0), visitedObjects.has(p.textColor) || (p.textColor, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TextControlPlaceholderOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TextFieldControlDisplayOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.placeholderOptions) || (p.placeholderOptions, void 0), visitedObjects.has(p.titleOptions) || (p.titleOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_ThousandSeparatorOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TimeBasedForecastPropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TimeEqualityFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TimeRangeDrillDownFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TimeRangeFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.excludePeriodConfiguration) || (p.excludePeriodConfiguration, void 0), visitedObjects.has(p.rangeMaximumValue) || (p.rangeMaximumValue, void 0), visitedObjects.has(p.rangeMinimumValue) || (p.rangeMinimumValue, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TimeRangeFilterValueProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.rollingDate) || (p.rollingDate, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TooltipItemProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columnTooltipItem) || (p.columnTooltipItem, void 0), visitedObjects.has(p.fieldTooltipItem) || (p.fieldTooltipItem, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TooltipOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldBasedTooltip) || (p.fieldBasedTooltip, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TopBottomFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.aggregationSortConfigurations) || (p.aggregationSortConfigurations, void 0), visitedObjects.has(p.column) || (p.column, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TopBottomMoversComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.category) || (p.category, void 0), visitedObjects.has(p.time) || (p.time, void 0), visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TopBottomRankedComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.category) || (p.category, void 0), visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TotalAggregationComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TotalOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.totalCellStyle) || (p.totalCellStyle, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TreeMapAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.colors) || (p.colors, void 0), visitedObjects.has(p.groups) || (p.groups, void 0), visitedObjects.has(p.sizes) || (p.sizes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TreeMapConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.colorLabelOptions) || (p.colorLabelOptions, void 0), visitedObjects.has(p.colorScale) || (p.colorScale, void 0), visitedObjects.has(p.dataLabels) || (p.dataLabels, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.groupLabelOptions) || (p.groupLabelOptions, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.sizeLabelOptions) || (p.sizeLabelOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TreeMapFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.treeMapAggregatedFieldWells) || (p.treeMapAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TreeMapSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.treeMapGroupItemsLimitConfiguration) || (p.treeMapGroupItemsLimitConfiguration, void 0), visitedObjects.has(p.treeMapSort) || (p.treeMapSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TreeMapVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_TrendArrowOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_UnaggregatedFieldProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.formatConfiguration) || (p.formatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_UniqueValuesComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.category) || (p.category, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_VisibleRangeOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.percentRange) || (p.percentRange, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_VisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.barChartVisual) || (p.barChartVisual, void 0), visitedObjects.has(p.boxPlotVisual) || (p.boxPlotVisual, void 0), visitedObjects.has(p.comboChartVisual) || (p.comboChartVisual, void 0), visitedObjects.has(p.customContentVisual) || (p.customContentVisual, void 0), visitedObjects.has(p.emptyVisual) || (p.emptyVisual, void 0), visitedObjects.has(p.filledMapVisual) || (p.filledMapVisual, void 0), visitedObjects.has(p.funnelChartVisual) || (p.funnelChartVisual, void 0), visitedObjects.has(p.gaugeChartVisual) || (p.gaugeChartVisual, void 0), visitedObjects.has(p.geospatialMapVisual) || (p.geospatialMapVisual, void 0), visitedObjects.has(p.heatMapVisual) || (p.heatMapVisual, void 0), visitedObjects.has(p.histogramVisual) || (p.histogramVisual, void 0), visitedObjects.has(p.insightVisual) || (p.insightVisual, void 0), visitedObjects.has(p.kpiVisual) || (p.kpiVisual, void 0), visitedObjects.has(p.lineChartVisual) || (p.lineChartVisual, void 0), visitedObjects.has(p.pieChartVisual) || (p.pieChartVisual, void 0), visitedObjects.has(p.pivotTableVisual) || (p.pivotTableVisual, void 0), visitedObjects.has(p.radarChartVisual) || (p.radarChartVisual, void 0), visitedObjects.has(p.sankeyDiagramVisual) || (p.sankeyDiagramVisual, void 0), visitedObjects.has(p.scatterPlotVisual) || (p.scatterPlotVisual, void 0), visitedObjects.has(p.tableVisual) || (p.tableVisual, void 0), visitedObjects.has(p.treeMapVisual) || (p.treeMapVisual, void 0), visitedObjects.has(p.waterfallVisual) || (p.waterfallVisual, void 0), visitedObjects.has(p.wordCloudVisual) || (p.wordCloudVisual, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_VisualAxisSortOptionProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_VisualCustomActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actionOperations) || (p.actionOperations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_VisualCustomActionOperationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.filterOperation) || (p.filterOperation, void 0), visitedObjects.has(p.navigationOperation) || (p.navigationOperation, void 0), visitedObjects.has(p.setParametersOperation) || (p.setParametersOperation, void 0), visitedObjects.has(p.urlOperation) || (p.urlOperation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_VisualMenuOptionProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_VisualPaletteProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.colorMap) || (p.colorMap, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_VisualSubtitleLabelOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.formatText) || (p.formatText, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_VisualTitleLabelOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.formatText) || (p.formatText, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_WaterfallChartAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.breakdowns) || (p.breakdowns, void 0), visitedObjects.has(p.categories) || (p.categories, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_WaterfallChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryAxisDisplayOptions) || (p.categoryAxisDisplayOptions, void 0), visitedObjects.has(p.categoryAxisLabelOptions) || (p.categoryAxisLabelOptions, void 0), visitedObjects.has(p.dataLabels) || (p.dataLabels, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.primaryYAxisDisplayOptions) || (p.primaryYAxisDisplayOptions, void 0), visitedObjects.has(p.primaryYAxisLabelOptions) || (p.primaryYAxisLabelOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0), visitedObjects.has(p.waterfallChartOptions) || (p.waterfallChartOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_WaterfallChartFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.waterfallChartAggregatedFieldWells) || (p.waterfallChartAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_WaterfallChartOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_WaterfallChartSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.breakdownItemsLimit) || (p.breakdownItemsLimit, void 0), visitedObjects.has(p.categorySort) || (p.categorySort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_WaterfallVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_WhatIfPointScenarioProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_WhatIfRangeScenarioProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_WordCloudAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.groupBy) || (p.groupBy, void 0), visitedObjects.has(p.size) || (p.size, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_WordCloudChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryLabelOptions) || (p.categoryLabelOptions, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.wordCloudOptions) || (p.wordCloudOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_WordCloudFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.wordCloudAggregatedFieldWells) || (p.wordCloudAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_WordCloudOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_WordCloudSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryItemsLimit) || (p.categoryItemsLimit, void 0), visitedObjects.has(p.categorySort) || (p.categorySort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDashboard_WordCloudVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.columnGroups) || (p.columnGroups, void 0), visitedObjects.has(p.columnLevelPermissionRules) || (p.columnLevelPermissionRules, void 0), visitedObjects.has(p.dataSetUsageConfiguration) || (p.dataSetUsageConfiguration, void 0), visitedObjects.has(p.fieldFolders) || (p.fieldFolders, void 0), visitedObjects.has(p.ingestionWaitPolicy) || (p.ingestionWaitPolicy, void 0), visitedObjects.has(p.logicalTableMap) || (p.logicalTableMap, void 0), visitedObjects.has(p.permissions) || (p.permissions, void 0), visitedObjects.has(p.physicalTableMap) || (p.physicalTableMap, void 0), visitedObjects.has(p.rowLevelPermissionDataSet) || (p.rowLevelPermissionDataSet, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSet(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSet_CalculatedColumnProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSet_CastColumnTypeOperationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSet_ColumnDescriptionProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSet_ColumnGroupProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.geoSpatialColumnGroup) || (p.geoSpatialColumnGroup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSet_ColumnLevelPermissionRuleProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSet_ColumnTagProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columnDescription) || (p.columnDescription, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSet_CreateColumnsOperationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columns) || (p.columns, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSet_CustomSqlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columns) || (p.columns, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSet_DataSetUsageConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSet_FieldFolderProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSet_FilterOperationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSet_GeoSpatialColumnGroupProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSet_IngestionWaitPolicyProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSet_InputColumnProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSet_JoinInstructionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.leftJoinKeyProperties) || (p.leftJoinKeyProperties, void 0), visitedObjects.has(p.rightJoinKeyProperties) || (p.rightJoinKeyProperties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSet_JoinKeyPropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSet_LogicalTableProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.source) || (p.source, void 0), visitedObjects.has(p.dataTransforms) || (p.dataTransforms, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSet_LogicalTableSourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.joinInstruction) || (p.joinInstruction, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSet_OutputColumnProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSet_PhysicalTableProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customSql) || (p.customSql, void 0), visitedObjects.has(p.relationalTable) || (p.relationalTable, void 0), visitedObjects.has(p.s3Source) || (p.s3Source, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSet_ProjectOperationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSet_RelationalTableProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.inputColumns) || (p.inputColumns, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSet_RenameColumnOperationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSet_ResourcePermissionProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSet_RowLevelPermissionDataSetProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSet_S3SourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.inputColumns) || (p.inputColumns, void 0), visitedObjects.has(p.uploadSettings) || (p.uploadSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSet_TagColumnOperationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || aws_cdk_lib_aws_quicksight_CfnDataSet_ColumnTagProperty(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSet_TransformOperationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.castColumnTypeOperation) || (p.castColumnTypeOperation, void 0), visitedObjects.has(p.createColumnsOperation) || (p.createColumnsOperation, void 0), visitedObjects.has(p.filterOperation) || (p.filterOperation, void 0), visitedObjects.has(p.projectOperation) || (p.projectOperation, void 0), visitedObjects.has(p.renameColumnOperation) || (p.renameColumnOperation, void 0), visitedObjects.has(p.tagColumnOperation) || (p.tagColumnOperation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSet_UploadSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.alternateDataSourceParameters) || (p.alternateDataSourceParameters, void 0), visitedObjects.has(p.credentials) || (p.credentials, void 0), visitedObjects.has(p.dataSourceParameters) || (p.dataSourceParameters, void 0), visitedObjects.has(p.errorInfo) || (p.errorInfo, void 0), visitedObjects.has(p.permissions) || (p.permissions, void 0), visitedObjects.has(p.sslProperties) || (p.sslProperties, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.vpcConnectionProperties) || (p.vpcConnectionProperties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSource(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSource_AmazonElasticsearchParametersProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSource_AmazonOpenSearchParametersProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSource_AthenaParametersProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSource_AuroraParametersProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSource_AuroraPostgreSqlParametersProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSource_CredentialPairProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.alternateDataSourceParameters) || (p.alternateDataSourceParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSource_DataSourceCredentialsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.credentialPair) || (p.credentialPair, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSource_DataSourceErrorInfoProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSource_DataSourceParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.amazonElasticsearchParameters) || (p.amazonElasticsearchParameters, void 0), visitedObjects.has(p.amazonOpenSearchParameters) || (p.amazonOpenSearchParameters, void 0), visitedObjects.has(p.athenaParameters) || (p.athenaParameters, void 0), visitedObjects.has(p.auroraParameters) || (p.auroraParameters, void 0), visitedObjects.has(p.auroraPostgreSqlParameters) || (p.auroraPostgreSqlParameters, void 0), visitedObjects.has(p.databricksParameters) || (p.databricksParameters, void 0), visitedObjects.has(p.mariaDbParameters) || (p.mariaDbParameters, void 0), visitedObjects.has(p.mySqlParameters) || (p.mySqlParameters, void 0), visitedObjects.has(p.oracleParameters) || (p.oracleParameters, void 0), visitedObjects.has(p.postgreSqlParameters) || (p.postgreSqlParameters, void 0), visitedObjects.has(p.prestoParameters) || (p.prestoParameters, void 0), visitedObjects.has(p.rdsParameters) || (p.rdsParameters, void 0), visitedObjects.has(p.redshiftParameters) || (p.redshiftParameters, void 0), visitedObjects.has(p.s3Parameters) || (p.s3Parameters, void 0), visitedObjects.has(p.snowflakeParameters) || (p.snowflakeParameters, void 0), visitedObjects.has(p.sparkParameters) || (p.sparkParameters, void 0), visitedObjects.has(p.sqlServerParameters) || (p.sqlServerParameters, void 0), visitedObjects.has(p.teradataParameters) || (p.teradataParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSource_DatabricksParametersProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSource_ManifestFileLocationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSource_MariaDbParametersProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSource_MySqlParametersProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSource_OracleParametersProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSource_PostgreSqlParametersProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSource_PrestoParametersProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSource_RdsParametersProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSource_RedshiftParametersProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSource_ResourcePermissionProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSource_S3ParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.manifestFileLocation) || (p.manifestFileLocation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSource_SnowflakeParametersProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSource_SparkParametersProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSource_SqlServerParametersProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSource_SslPropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSource_TeradataParametersProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnDataSource_VpcConnectionPropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnRefreshScheduleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.schedule) || (p.schedule, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnRefreshSchedule(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnRefreshSchedule_RefreshOnDayProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnRefreshSchedule_RefreshScheduleMapProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.scheduleFrequency) || (p.scheduleFrequency, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnRefreshSchedule_ScheduleFrequencyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.refreshOnDay) || (p.refreshOnDay, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplateProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.definition) || (p.definition, void 0), visitedObjects.has(p.permissions) || (p.permissions, void 0), visitedObjects.has(p.sourceEntity) || (p.sourceEntity, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_AggregationFunctionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.numericalAggregationFunction) || (p.numericalAggregationFunction, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_AggregationSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.aggregationFunction) || (p.aggregationFunction, void 0), visitedObjects.has(p.column) || (p.column, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_AnalysisDefaultsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultNewSheetConfiguration) || (p.defaultNewSheetConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_AnchorDateConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ArcAxisConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.range) || (p.range, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ArcAxisDisplayRangeProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ArcConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ArcOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_AxisDataOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dateAxisOptions) || (p.dateAxisOptions, void 0), visitedObjects.has(p.numericAxisOptions) || (p.numericAxisOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_AxisDisplayMinMaxRangeProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_AxisDisplayOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataOptions) || (p.dataOptions, void 0), visitedObjects.has(p.scrollbarOptions) || (p.scrollbarOptions, void 0), visitedObjects.has(p.tickLabelOptions) || (p.tickLabelOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_AxisDisplayRangeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.minMax) || (p.minMax, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_AxisLabelOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.applyTo) || (p.applyTo, void 0), visitedObjects.has(p.fontConfiguration) || (p.fontConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_AxisLabelReferenceOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_AxisLinearScaleProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_AxisLogarithmicScaleProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_AxisScaleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.linear) || (p.linear, void 0), visitedObjects.has(p.logarithmic) || (p.logarithmic, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_AxisTickLabelOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.labelOptions) || (p.labelOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_BarChartAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.category) || (p.category, void 0), visitedObjects.has(p.colors) || (p.colors, void 0), visitedObjects.has(p.smallMultiples) || (p.smallMultiples, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_BarChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryAxis) || (p.categoryAxis, void 0), visitedObjects.has(p.categoryLabelOptions) || (p.categoryLabelOptions, void 0), visitedObjects.has(p.colorLabelOptions) || (p.colorLabelOptions, void 0), visitedObjects.has(p.contributionAnalysisDefaults) || (p.contributionAnalysisDefaults, void 0), visitedObjects.has(p.dataLabels) || (p.dataLabels, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.referenceLines) || (p.referenceLines, void 0), visitedObjects.has(p.smallMultiplesOptions) || (p.smallMultiplesOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0), visitedObjects.has(p.valueAxis) || (p.valueAxis, void 0), visitedObjects.has(p.valueLabelOptions) || (p.valueLabelOptions, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_BarChartFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.barChartAggregatedFieldWells) || (p.barChartAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_BarChartSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryItemsLimit) || (p.categoryItemsLimit, void 0), visitedObjects.has(p.categorySort) || (p.categorySort, void 0), visitedObjects.has(p.colorItemsLimit) || (p.colorItemsLimit, void 0), visitedObjects.has(p.colorSort) || (p.colorSort, void 0), visitedObjects.has(p.smallMultiplesLimitConfiguration) || (p.smallMultiplesLimitConfiguration, void 0), visitedObjects.has(p.smallMultiplesSort) || (p.smallMultiplesSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_BarChartVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_BinCountOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_BinWidthOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_BodySectionConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.content) || (p.content, void 0), visitedObjects.has(p.pageBreakConfiguration) || (p.pageBreakConfiguration, void 0), visitedObjects.has(p.style) || (p.style, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_BodySectionContentProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.layout) || (p.layout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_BoxPlotAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.groupBy) || (p.groupBy, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_BoxPlotChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.boxPlotOptions) || (p.boxPlotOptions, void 0), visitedObjects.has(p.categoryAxis) || (p.categoryAxis, void 0), visitedObjects.has(p.categoryLabelOptions) || (p.categoryLabelOptions, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.primaryYAxisDisplayOptions) || (p.primaryYAxisDisplayOptions, void 0), visitedObjects.has(p.primaryYAxisLabelOptions) || (p.primaryYAxisLabelOptions, void 0), visitedObjects.has(p.referenceLines) || (p.referenceLines, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_BoxPlotFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.boxPlotAggregatedFieldWells) || (p.boxPlotAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_BoxPlotOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.styleOptions) || (p.styleOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_BoxPlotSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categorySort) || (p.categorySort, void 0), visitedObjects.has(p.paginationConfiguration) || (p.paginationConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_BoxPlotStyleOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_BoxPlotVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_CalculatedFieldProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_CalculatedMeasureFieldProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_CascadingControlConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sourceControls) || (p.sourceControls, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_CascadingControlSourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columnToMatch) || (p.columnToMatch, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_CategoricalDimensionFieldProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.formatConfiguration) || (p.formatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_CategoricalMeasureFieldProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.formatConfiguration) || (p.formatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_CategoryDrillDownFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_CategoryFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.configuration) || (p.configuration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_CategoryFilterConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customFilterConfiguration) || (p.customFilterConfiguration, void 0), visitedObjects.has(p.customFilterListConfiguration) || (p.customFilterListConfiguration, void 0), visitedObjects.has(p.filterListConfiguration) || (p.filterListConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ChartAxisLabelOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.axisLabelOptions) || (p.axisLabelOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ClusterMarkerProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.simpleClusterMarker) || (p.simpleClusterMarker, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ClusterMarkerConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.clusterMarker) || (p.clusterMarker, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ColorScaleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.colors) || (p.colors, void 0), visitedObjects.has(p.nullValueColor) || (p.nullValueColor, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ColorsConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customColors) || (p.customColors, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ColumnConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.colorsConfiguration) || (p.colorsConfiguration, void 0), visitedObjects.has(p.formatConfiguration) || (p.formatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ColumnGroupColumnSchemaProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ColumnGroupSchemaProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columnGroupColumnSchemaList) || (p.columnGroupColumnSchemaList, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ColumnHierarchyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dateTimeHierarchy) || (p.dateTimeHierarchy, void 0), visitedObjects.has(p.explicitHierarchy) || (p.explicitHierarchy, void 0), visitedObjects.has(p.predefinedHierarchy) || (p.predefinedHierarchy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ColumnIdentifierProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ColumnSchemaProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ColumnSortProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sortBy) || (p.sortBy, void 0), visitedObjects.has(p.aggregationFunction) || (p.aggregationFunction, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ColumnTooltipItemProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.aggregation) || (p.aggregation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ComboChartAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.barValues) || (p.barValues, void 0), visitedObjects.has(p.category) || (p.category, void 0), visitedObjects.has(p.colors) || (p.colors, void 0), visitedObjects.has(p.lineValues) || (p.lineValues, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ComboChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.barDataLabels) || (p.barDataLabels, void 0), visitedObjects.has(p.categoryAxis) || (p.categoryAxis, void 0), visitedObjects.has(p.categoryLabelOptions) || (p.categoryLabelOptions, void 0), visitedObjects.has(p.colorLabelOptions) || (p.colorLabelOptions, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.lineDataLabels) || (p.lineDataLabels, void 0), visitedObjects.has(p.primaryYAxisDisplayOptions) || (p.primaryYAxisDisplayOptions, void 0), visitedObjects.has(p.primaryYAxisLabelOptions) || (p.primaryYAxisLabelOptions, void 0), visitedObjects.has(p.referenceLines) || (p.referenceLines, void 0), visitedObjects.has(p.secondaryYAxisDisplayOptions) || (p.secondaryYAxisDisplayOptions, void 0), visitedObjects.has(p.secondaryYAxisLabelOptions) || (p.secondaryYAxisLabelOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ComboChartFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.comboChartAggregatedFieldWells) || (p.comboChartAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ComboChartSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryItemsLimit) || (p.categoryItemsLimit, void 0), visitedObjects.has(p.categorySort) || (p.categorySort, void 0), visitedObjects.has(p.colorItemsLimit) || (p.colorItemsLimit, void 0), visitedObjects.has(p.colorSort) || (p.colorSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ComboChartVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ComparisonConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.comparisonFormat) || (p.comparisonFormat, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ComparisonFormatConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.numberDisplayFormatConfiguration) || (p.numberDisplayFormatConfiguration, void 0), visitedObjects.has(p.percentageDisplayFormatConfiguration) || (p.percentageDisplayFormatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.forecast) || (p.forecast, void 0), visitedObjects.has(p.growthRate) || (p.growthRate, void 0), visitedObjects.has(p.maximumMinimum) || (p.maximumMinimum, void 0), visitedObjects.has(p.metricComparison) || (p.metricComparison, void 0), visitedObjects.has(p.periodOverPeriod) || (p.periodOverPeriod, void 0), visitedObjects.has(p.periodToDate) || (p.periodToDate, void 0), visitedObjects.has(p.topBottomMovers) || (p.topBottomMovers, void 0), visitedObjects.has(p.topBottomRanked) || (p.topBottomRanked, void 0), visitedObjects.has(p.totalAggregation) || (p.totalAggregation, void 0), visitedObjects.has(p.uniqueValues) || (p.uniqueValues, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ConditionalFormattingColorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.gradient) || (p.gradient, void 0), visitedObjects.has(p.solid) || (p.solid, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ConditionalFormattingCustomIconConditionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.iconOptions) || (p.iconOptions, void 0), visitedObjects.has(p.displayConfiguration) || (p.displayConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ConditionalFormattingCustomIconOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ConditionalFormattingGradientColorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.color) || (p.color, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ConditionalFormattingIconProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customCondition) || (p.customCondition, void 0), visitedObjects.has(p.iconSet) || (p.iconSet, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ConditionalFormattingIconDisplayConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ConditionalFormattingIconSetProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ConditionalFormattingSolidColorProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ContributionAnalysisDefaultProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.contributorDimensions) || (p.contributorDimensions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_CurrencyDisplayFormatConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.decimalPlacesConfiguration) || (p.decimalPlacesConfiguration, void 0), visitedObjects.has(p.negativeValueConfiguration) || (p.negativeValueConfiguration, void 0), visitedObjects.has(p.nullValueFormatConfiguration) || (p.nullValueFormatConfiguration, void 0), visitedObjects.has(p.separatorConfiguration) || (p.separatorConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_CustomActionFilterOperationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.selectedFieldsConfiguration) || (p.selectedFieldsConfiguration, void 0), visitedObjects.has(p.targetVisualsConfiguration) || (p.targetVisualsConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_CustomActionNavigationOperationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.localNavigationConfiguration) || (p.localNavigationConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_CustomActionSetParametersOperationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.parameterValueConfigurations) || (p.parameterValueConfigurations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_CustomActionURLOperationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_CustomColorProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_CustomContentConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_CustomContentVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_CustomFilterConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_CustomFilterListConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_CustomNarrativeOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_CustomParameterValuesProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_CustomValuesConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customValues) || (p.customValues, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DataBarsOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DataColorProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DataFieldSeriesItemProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.settings) || (p.settings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DataLabelOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataLabelTypes) || (p.dataLabelTypes, void 0), visitedObjects.has(p.labelFontConfiguration) || (p.labelFontConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DataLabelTypeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataPathLabelType) || (p.dataPathLabelType, void 0), visitedObjects.has(p.fieldLabelType) || (p.fieldLabelType, void 0), visitedObjects.has(p.maximumLabelType) || (p.maximumLabelType, void 0), visitedObjects.has(p.minimumLabelType) || (p.minimumLabelType, void 0), visitedObjects.has(p.rangeEndsLabelType) || (p.rangeEndsLabelType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DataPathColorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.element) || (p.element, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DataPathLabelTypeProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DataPathSortProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sortPaths) || (p.sortPaths, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DataPathValueProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DataSetConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columnGroupSchemaList) || (p.columnGroupSchemaList, void 0), visitedObjects.has(p.dataSetSchema) || (p.dataSetSchema, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DataSetReferenceProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DataSetSchemaProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columnSchemaList) || (p.columnSchemaList, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DateAxisOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DateDimensionFieldProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.formatConfiguration) || (p.formatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DateMeasureFieldProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.formatConfiguration) || (p.formatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DateTimeDefaultValuesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dynamicValue) || (p.dynamicValue, void 0), visitedObjects.has(p.rollingDate) || (p.rollingDate, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DateTimeFormatConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.nullValueFormatConfiguration) || (p.nullValueFormatConfiguration, void 0), visitedObjects.has(p.numericFormatConfiguration) || (p.numericFormatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DateTimeHierarchyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.drillDownFilters) || (p.drillDownFilters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DateTimeParameterDeclarationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultValues) || (p.defaultValues, void 0), visitedObjects.has(p.mappedDataSetParameters) || (p.mappedDataSetParameters, void 0), visitedObjects.has(p.valueWhenUnset) || (p.valueWhenUnset, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DateTimePickerControlDisplayOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.titleOptions) || (p.titleOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DateTimeValueWhenUnsetConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DecimalDefaultValuesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dynamicValue) || (p.dynamicValue, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DecimalParameterDeclarationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultValues) || (p.defaultValues, void 0), visitedObjects.has(p.mappedDataSetParameters) || (p.mappedDataSetParameters, void 0), visitedObjects.has(p.valueWhenUnset) || (p.valueWhenUnset, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DecimalPlacesConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DecimalValueWhenUnsetConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DefaultFreeFormLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.canvasSizeOptions) || (p.canvasSizeOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DefaultGridLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.canvasSizeOptions) || (p.canvasSizeOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DefaultInteractiveLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.freeForm) || (p.freeForm, void 0), visitedObjects.has(p.grid) || (p.grid, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DefaultNewSheetConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.interactiveLayoutConfiguration) || (p.interactiveLayoutConfiguration, void 0), visitedObjects.has(p.paginatedLayoutConfiguration) || (p.paginatedLayoutConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DefaultPaginatedLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sectionBased) || (p.sectionBased, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DefaultSectionBasedLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.canvasSizeOptions) || (p.canvasSizeOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DestinationParameterValueConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customValuesConfiguration) || (p.customValuesConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DimensionFieldProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoricalDimensionField) || (p.categoricalDimensionField, void 0), visitedObjects.has(p.dateDimensionField) || (p.dateDimensionField, void 0), visitedObjects.has(p.numericalDimensionField) || (p.numericalDimensionField, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DonutCenterOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DonutOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.arcOptions) || (p.arcOptions, void 0), visitedObjects.has(p.donutCenterOptions) || (p.donutCenterOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DrillDownFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryFilter) || (p.categoryFilter, void 0), visitedObjects.has(p.numericEqualityFilter) || (p.numericEqualityFilter, void 0), visitedObjects.has(p.timeRangeFilter) || (p.timeRangeFilter, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DropDownControlDisplayOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.selectAllOptions) || (p.selectAllOptions, void 0), visitedObjects.has(p.titleOptions) || (p.titleOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_DynamicDefaultValueProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultValueColumn) || (p.defaultValueColumn, void 0), visitedObjects.has(p.groupNameColumn) || (p.groupNameColumn, void 0), visitedObjects.has(p.userNameColumn) || (p.userNameColumn, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_EmptyVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_EntityProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ExcludePeriodConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ExplicitHierarchyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columns) || (p.columns, void 0), visitedObjects.has(p.drillDownFilters) || (p.drillDownFilters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FieldBasedTooltipProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tooltipFields) || (p.tooltipFields, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FieldLabelTypeProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FieldSeriesItemProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.settings) || (p.settings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FieldSortProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FieldSortOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columnSort) || (p.columnSort, void 0), visitedObjects.has(p.fieldSort) || (p.fieldSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FieldTooltipItemProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FilledMapAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.geospatial) || (p.geospatial, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FilledMapConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.conditionalFormattingOptions) || (p.conditionalFormattingOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FilledMapConditionalFormattingOptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.shape) || (p.shape, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FilledMapConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.mapStyleOptions) || (p.mapStyleOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0), visitedObjects.has(p.windowOptions) || (p.windowOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FilledMapFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.filledMapAggregatedFieldWells) || (p.filledMapAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FilledMapShapeConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.format) || (p.format, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FilledMapSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categorySort) || (p.categorySort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FilledMapVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.conditionalFormatting) || (p.conditionalFormatting, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryFilter) || (p.categoryFilter, void 0), visitedObjects.has(p.numericEqualityFilter) || (p.numericEqualityFilter, void 0), visitedObjects.has(p.numericRangeFilter) || (p.numericRangeFilter, void 0), visitedObjects.has(p.relativeDatesFilter) || (p.relativeDatesFilter, void 0), visitedObjects.has(p.timeEqualityFilter) || (p.timeEqualityFilter, void 0), visitedObjects.has(p.timeRangeFilter) || (p.timeRangeFilter, void 0), visitedObjects.has(p.topBottomFilter) || (p.topBottomFilter, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FilterControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dateTimePicker) || (p.dateTimePicker, void 0), visitedObjects.has(p.dropdown) || (p.dropdown, void 0), visitedObjects.has(p.list) || (p.list, void 0), visitedObjects.has(p.relativeDateTime) || (p.relativeDateTime, void 0), visitedObjects.has(p.slider) || (p.slider, void 0), visitedObjects.has(p.textArea) || (p.textArea, void 0), visitedObjects.has(p.textField) || (p.textField, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FilterDateTimePickerControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FilterDropDownControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cascadingControlConfiguration) || (p.cascadingControlConfiguration, void 0), visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0), visitedObjects.has(p.selectableValues) || (p.selectableValues, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FilterGroupProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.filters) || (p.filters, void 0), visitedObjects.has(p.scopeConfiguration) || (p.scopeConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FilterListConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FilterListControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cascadingControlConfiguration) || (p.cascadingControlConfiguration, void 0), visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0), visitedObjects.has(p.selectableValues) || (p.selectableValues, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FilterOperationSelectedFieldsConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FilterOperationTargetVisualsConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sameSheetTargetVisualConfiguration) || (p.sameSheetTargetVisualConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FilterRelativeDateTimeControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FilterScopeConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.selectedSheets) || (p.selectedSheets, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FilterSelectableValuesProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FilterSliderControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FilterTextAreaControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FilterTextFieldControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FontConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fontSize) || (p.fontSize, void 0), visitedObjects.has(p.fontWeight) || (p.fontWeight, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FontSizeProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FontWeightProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ForecastComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.time) || (p.time, void 0), visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ForecastConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.forecastProperties) || (p.forecastProperties, void 0), visitedObjects.has(p.scenario) || (p.scenario, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ForecastScenarioProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.whatIfPointScenario) || (p.whatIfPointScenario, void 0), visitedObjects.has(p.whatIfRangeScenario) || (p.whatIfRangeScenario, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FormatConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dateTimeFormatConfiguration) || (p.dateTimeFormatConfiguration, void 0), visitedObjects.has(p.numberFormatConfiguration) || (p.numberFormatConfiguration, void 0), visitedObjects.has(p.stringFormatConfiguration) || (p.stringFormatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FreeFormLayoutCanvasSizeOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.screenCanvasSizeOptions) || (p.screenCanvasSizeOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FreeFormLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.elements) || (p.elements, void 0), visitedObjects.has(p.canvasSizeOptions) || (p.canvasSizeOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FreeFormLayoutElementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.backgroundStyle) || (p.backgroundStyle, void 0), visitedObjects.has(p.borderStyle) || (p.borderStyle, void 0), visitedObjects.has(p.loadingAnimation) || (p.loadingAnimation, void 0), visitedObjects.has(p.renderingRules) || (p.renderingRules, void 0), visitedObjects.has(p.selectedBorderStyle) || (p.selectedBorderStyle, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FreeFormLayoutElementBackgroundStyleProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FreeFormLayoutElementBorderStyleProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FreeFormLayoutScreenCanvasSizeOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FreeFormSectionLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.elements) || (p.elements, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FunnelChartAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.category) || (p.category, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FunnelChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryLabelOptions) || (p.categoryLabelOptions, void 0), visitedObjects.has(p.dataLabelOptions) || (p.dataLabelOptions, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0), visitedObjects.has(p.valueLabelOptions) || (p.valueLabelOptions, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FunnelChartDataLabelOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.labelFontConfiguration) || (p.labelFontConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FunnelChartFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.funnelChartAggregatedFieldWells) || (p.funnelChartAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FunnelChartSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryItemsLimit) || (p.categoryItemsLimit, void 0), visitedObjects.has(p.categorySort) || (p.categorySort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_FunnelChartVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_GaugeChartArcConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.foregroundColor) || (p.foregroundColor, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_GaugeChartConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.conditionalFormattingOptions) || (p.conditionalFormattingOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_GaugeChartConditionalFormattingOptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.arc) || (p.arc, void 0), visitedObjects.has(p.primaryValue) || (p.primaryValue, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_GaugeChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataLabels) || (p.dataLabels, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.gaugeChartOptions) || (p.gaugeChartOptions, void 0), visitedObjects.has(p.tooltipOptions) || (p.tooltipOptions, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_GaugeChartFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.targetValues) || (p.targetValues, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_GaugeChartOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.arc) || (p.arc, void 0), visitedObjects.has(p.arcAxis) || (p.arcAxis, void 0), visitedObjects.has(p.comparison) || (p.comparison, void 0), visitedObjects.has(p.primaryValueFontConfiguration) || (p.primaryValueFontConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_GaugeChartPrimaryValueConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.icon) || (p.icon, void 0), visitedObjects.has(p.textColor) || (p.textColor, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_GaugeChartVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.conditionalFormatting) || (p.conditionalFormatting, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_GeospatialCoordinateBoundsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_GeospatialMapAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.colors) || (p.colors, void 0), visitedObjects.has(p.geospatial) || (p.geospatial, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_GeospatialMapConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.mapStyleOptions) || (p.mapStyleOptions, void 0), visitedObjects.has(p.pointStyleOptions) || (p.pointStyleOptions, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0), visitedObjects.has(p.windowOptions) || (p.windowOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_GeospatialMapFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.geospatialMapAggregatedFieldWells) || (p.geospatialMapAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_GeospatialMapStyleOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_GeospatialMapVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_GeospatialPointStyleOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.clusterMarkerConfiguration) || (p.clusterMarkerConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_GeospatialWindowOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bounds) || (p.bounds, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_GlobalTableBorderOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sideSpecificBorder) || (p.sideSpecificBorder, void 0), visitedObjects.has(p.uniformBorder) || (p.uniformBorder, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_GradientColorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.stops) || (p.stops, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_GradientStopProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_GridLayoutCanvasSizeOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.screenCanvasSizeOptions) || (p.screenCanvasSizeOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_GridLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.elements) || (p.elements, void 0), visitedObjects.has(p.canvasSizeOptions) || (p.canvasSizeOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_GridLayoutElementProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_GridLayoutScreenCanvasSizeOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_GrowthRateComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.time) || (p.time, void 0), visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_HeaderFooterSectionConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.layout) || (p.layout, void 0), visitedObjects.has(p.style) || (p.style, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_HeatMapAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columns) || (p.columns, void 0), visitedObjects.has(p.rows) || (p.rows, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_HeatMapConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.colorScale) || (p.colorScale, void 0), visitedObjects.has(p.columnLabelOptions) || (p.columnLabelOptions, void 0), visitedObjects.has(p.dataLabels) || (p.dataLabels, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.rowLabelOptions) || (p.rowLabelOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_HeatMapFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.heatMapAggregatedFieldWells) || (p.heatMapAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_HeatMapSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.heatMapColumnItemsLimitConfiguration) || (p.heatMapColumnItemsLimitConfiguration, void 0), visitedObjects.has(p.heatMapColumnSort) || (p.heatMapColumnSort, void 0), visitedObjects.has(p.heatMapRowItemsLimitConfiguration) || (p.heatMapRowItemsLimitConfiguration, void 0), visitedObjects.has(p.heatMapRowSort) || (p.heatMapRowSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_HeatMapVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_HistogramAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_HistogramBinOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.binCount) || (p.binCount, void 0), visitedObjects.has(p.binWidth) || (p.binWidth, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_HistogramConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.binOptions) || (p.binOptions, void 0), visitedObjects.has(p.dataLabels) || (p.dataLabels, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0), visitedObjects.has(p.xAxisDisplayOptions) || (p.xAxisDisplayOptions, void 0), visitedObjects.has(p.xAxisLabelOptions) || (p.xAxisLabelOptions, void 0), visitedObjects.has(p.yAxisDisplayOptions) || (p.yAxisDisplayOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_HistogramFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.histogramAggregatedFieldWells) || (p.histogramAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_HistogramVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_InsightConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.computations) || (p.computations, void 0), visitedObjects.has(p.customNarrative) || (p.customNarrative, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_InsightVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.insightConfiguration) || (p.insightConfiguration, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_IntegerDefaultValuesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dynamicValue) || (p.dynamicValue, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_IntegerParameterDeclarationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultValues) || (p.defaultValues, void 0), visitedObjects.has(p.mappedDataSetParameters) || (p.mappedDataSetParameters, void 0), visitedObjects.has(p.valueWhenUnset) || (p.valueWhenUnset, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_IntegerValueWhenUnsetConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ItemsLimitConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_KPIConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.conditionalFormattingOptions) || (p.conditionalFormattingOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_KPIConditionalFormattingOptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.primaryValue) || (p.primaryValue, void 0), visitedObjects.has(p.progressBar) || (p.progressBar, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_KPIConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.kpiOptions) || (p.kpiOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_KPIFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.targetValues) || (p.targetValues, void 0), visitedObjects.has(p.trendGroups) || (p.trendGroups, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_KPIOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.comparison) || (p.comparison, void 0), visitedObjects.has(p.primaryValueFontConfiguration) || (p.primaryValueFontConfiguration, void 0), visitedObjects.has(p.progressBar) || (p.progressBar, void 0), visitedObjects.has(p.secondaryValue) || (p.secondaryValue, void 0), visitedObjects.has(p.secondaryValueFontConfiguration) || (p.secondaryValueFontConfiguration, void 0), visitedObjects.has(p.trendArrows) || (p.trendArrows, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_KPIPrimaryValueConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.icon) || (p.icon, void 0), visitedObjects.has(p.textColor) || (p.textColor, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_KPIProgressBarConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.foregroundColor) || (p.foregroundColor, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_KPISortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.trendGroupSort) || (p.trendGroupSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_KPIVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.conditionalFormatting) || (p.conditionalFormatting, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_LabelOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fontConfiguration) || (p.fontConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_LayoutProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.configuration) || (p.configuration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_LayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.freeFormLayout) || (p.freeFormLayout, void 0), visitedObjects.has(p.gridLayout) || (p.gridLayout, void 0), visitedObjects.has(p.sectionBasedLayout) || (p.sectionBasedLayout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_LegendOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_LineChartAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.category) || (p.category, void 0), visitedObjects.has(p.colors) || (p.colors, void 0), visitedObjects.has(p.smallMultiples) || (p.smallMultiples, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_LineChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.contributionAnalysisDefaults) || (p.contributionAnalysisDefaults, void 0), visitedObjects.has(p.dataLabels) || (p.dataLabels, void 0), visitedObjects.has(p.defaultSeriesSettings) || (p.defaultSeriesSettings, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.forecastConfigurations) || (p.forecastConfigurations, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.primaryYAxisDisplayOptions) || (p.primaryYAxisDisplayOptions, void 0), visitedObjects.has(p.primaryYAxisLabelOptions) || (p.primaryYAxisLabelOptions, void 0), visitedObjects.has(p.referenceLines) || (p.referenceLines, void 0), visitedObjects.has(p.secondaryYAxisDisplayOptions) || (p.secondaryYAxisDisplayOptions, void 0), visitedObjects.has(p.secondaryYAxisLabelOptions) || (p.secondaryYAxisLabelOptions, void 0), visitedObjects.has(p.series) || (p.series, void 0), visitedObjects.has(p.smallMultiplesOptions) || (p.smallMultiplesOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0), visitedObjects.has(p.xAxisDisplayOptions) || (p.xAxisDisplayOptions, void 0), visitedObjects.has(p.xAxisLabelOptions) || (p.xAxisLabelOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_LineChartDefaultSeriesSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.lineStyleSettings) || (p.lineStyleSettings, void 0), visitedObjects.has(p.markerStyleSettings) || (p.markerStyleSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_LineChartFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.lineChartAggregatedFieldWells) || (p.lineChartAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_LineChartLineStyleSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_LineChartMarkerStyleSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_LineChartSeriesSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.lineStyleSettings) || (p.lineStyleSettings, void 0), visitedObjects.has(p.markerStyleSettings) || (p.markerStyleSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_LineChartSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryItemsLimitConfiguration) || (p.categoryItemsLimitConfiguration, void 0), visitedObjects.has(p.categorySort) || (p.categorySort, void 0), visitedObjects.has(p.colorItemsLimitConfiguration) || (p.colorItemsLimitConfiguration, void 0), visitedObjects.has(p.smallMultiplesLimitConfiguration) || (p.smallMultiplesLimitConfiguration, void 0), visitedObjects.has(p.smallMultiplesSort) || (p.smallMultiplesSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_LineChartVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_LineSeriesAxisDisplayOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.axisOptions) || (p.axisOptions, void 0), visitedObjects.has(p.missingDataConfigurations) || (p.missingDataConfigurations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ListControlDisplayOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.searchOptions) || (p.searchOptions, void 0), visitedObjects.has(p.selectAllOptions) || (p.selectAllOptions, void 0), visitedObjects.has(p.titleOptions) || (p.titleOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ListControlSearchOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ListControlSelectAllOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_LoadingAnimationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_LocalNavigationConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_LongFormatTextProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_MappedDataSetParameterProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_MaximumLabelTypeProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_MaximumMinimumComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.time) || (p.time, void 0), visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_MeasureFieldProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.calculatedMeasureField) || (p.calculatedMeasureField, void 0), visitedObjects.has(p.categoricalMeasureField) || (p.categoricalMeasureField, void 0), visitedObjects.has(p.dateMeasureField) || (p.dateMeasureField, void 0), visitedObjects.has(p.numericalMeasureField) || (p.numericalMeasureField, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_MetricComparisonComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fromValue) || (p.fromValue, void 0), visitedObjects.has(p.targetValue) || (p.targetValue, void 0), visitedObjects.has(p.time) || (p.time, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_MinimumLabelTypeProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_MissingDataConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_NegativeValueConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_NullValueFormatConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_NumberDisplayFormatConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.decimalPlacesConfiguration) || (p.decimalPlacesConfiguration, void 0), visitedObjects.has(p.negativeValueConfiguration) || (p.negativeValueConfiguration, void 0), visitedObjects.has(p.nullValueFormatConfiguration) || (p.nullValueFormatConfiguration, void 0), visitedObjects.has(p.separatorConfiguration) || (p.separatorConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_NumberFormatConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.formatConfiguration) || (p.formatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_NumericAxisOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.range) || (p.range, void 0), visitedObjects.has(p.scale) || (p.scale, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_NumericEqualityDrillDownFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_NumericEqualityFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.aggregationFunction) || (p.aggregationFunction, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_NumericFormatConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.currencyDisplayFormatConfiguration) || (p.currencyDisplayFormatConfiguration, void 0), visitedObjects.has(p.numberDisplayFormatConfiguration) || (p.numberDisplayFormatConfiguration, void 0), visitedObjects.has(p.percentageDisplayFormatConfiguration) || (p.percentageDisplayFormatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_NumericRangeFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.aggregationFunction) || (p.aggregationFunction, void 0), visitedObjects.has(p.rangeMaximum) || (p.rangeMaximum, void 0), visitedObjects.has(p.rangeMinimum) || (p.rangeMinimum, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_NumericRangeFilterValueProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_NumericSeparatorConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.thousandsSeparator) || (p.thousandsSeparator, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_NumericalAggregationFunctionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.percentileAggregation) || (p.percentileAggregation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_NumericalDimensionFieldProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.formatConfiguration) || (p.formatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_NumericalMeasureFieldProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.aggregationFunction) || (p.aggregationFunction, void 0), visitedObjects.has(p.formatConfiguration) || (p.formatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PaginationConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PanelConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PanelTitleOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fontConfiguration) || (p.fontConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ParameterControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dateTimePicker) || (p.dateTimePicker, void 0), visitedObjects.has(p.dropdown) || (p.dropdown, void 0), visitedObjects.has(p.list) || (p.list, void 0), visitedObjects.has(p.slider) || (p.slider, void 0), visitedObjects.has(p.textArea) || (p.textArea, void 0), visitedObjects.has(p.textField) || (p.textField, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ParameterDateTimePickerControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ParameterDeclarationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dateTimeParameterDeclaration) || (p.dateTimeParameterDeclaration, void 0), visitedObjects.has(p.decimalParameterDeclaration) || (p.decimalParameterDeclaration, void 0), visitedObjects.has(p.integerParameterDeclaration) || (p.integerParameterDeclaration, void 0), visitedObjects.has(p.stringParameterDeclaration) || (p.stringParameterDeclaration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ParameterDropDownControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cascadingControlConfiguration) || (p.cascadingControlConfiguration, void 0), visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0), visitedObjects.has(p.selectableValues) || (p.selectableValues, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ParameterListControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cascadingControlConfiguration) || (p.cascadingControlConfiguration, void 0), visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0), visitedObjects.has(p.selectableValues) || (p.selectableValues, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ParameterSelectableValuesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.linkToDataSetColumn) || (p.linkToDataSetColumn, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ParameterSliderControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ParameterTextAreaControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ParameterTextFieldControlProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.displayOptions) || (p.displayOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PercentVisibleRangeProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PercentageDisplayFormatConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.decimalPlacesConfiguration) || (p.decimalPlacesConfiguration, void 0), visitedObjects.has(p.negativeValueConfiguration) || (p.negativeValueConfiguration, void 0), visitedObjects.has(p.nullValueFormatConfiguration) || (p.nullValueFormatConfiguration, void 0), visitedObjects.has(p.separatorConfiguration) || (p.separatorConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PercentileAggregationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PeriodOverPeriodComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.time) || (p.time, void 0), visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PeriodToDateComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.time) || (p.time, void 0), visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PieChartAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.category) || (p.category, void 0), visitedObjects.has(p.smallMultiples) || (p.smallMultiples, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PieChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryLabelOptions) || (p.categoryLabelOptions, void 0), visitedObjects.has(p.contributionAnalysisDefaults) || (p.contributionAnalysisDefaults, void 0), visitedObjects.has(p.dataLabels) || (p.dataLabels, void 0), visitedObjects.has(p.donutOptions) || (p.donutOptions, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.smallMultiplesOptions) || (p.smallMultiplesOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0), visitedObjects.has(p.valueLabelOptions) || (p.valueLabelOptions, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PieChartFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.pieChartAggregatedFieldWells) || (p.pieChartAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PieChartSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryItemsLimit) || (p.categoryItemsLimit, void 0), visitedObjects.has(p.categorySort) || (p.categorySort, void 0), visitedObjects.has(p.smallMultiplesLimitConfiguration) || (p.smallMultiplesLimitConfiguration, void 0), visitedObjects.has(p.smallMultiplesSort) || (p.smallMultiplesSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PieChartVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PivotFieldSortOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sortBy) || (p.sortBy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columns) || (p.columns, void 0), visitedObjects.has(p.rows) || (p.rows, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableCellConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.scope) || (p.scope, void 0), visitedObjects.has(p.textFormat) || (p.textFormat, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.conditionalFormattingOptions) || (p.conditionalFormattingOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableConditionalFormattingOptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cell) || (p.cell, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableConditionalFormattingScopeProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldOptions) || (p.fieldOptions, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.paginatedReportOptions) || (p.paginatedReportOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tableOptions) || (p.tableOptions, void 0), visitedObjects.has(p.totalOptions) || (p.totalOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableDataPathOptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataPathList) || (p.dataPathList, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableFieldOptionProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableFieldOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataPathOptions) || (p.dataPathOptions, void 0), visitedObjects.has(p.selectedFieldOptions) || (p.selectedFieldOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableFieldSubtotalOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.pivotTableAggregatedFieldWells) || (p.pivotTableAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cellStyle) || (p.cellStyle, void 0), visitedObjects.has(p.columnHeaderStyle) || (p.columnHeaderStyle, void 0), visitedObjects.has(p.rowAlternateColorOptions) || (p.rowAlternateColorOptions, void 0), visitedObjects.has(p.rowFieldNamesStyle) || (p.rowFieldNamesStyle, void 0), visitedObjects.has(p.rowHeaderStyle) || (p.rowHeaderStyle, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTablePaginatedReportOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableSortByProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.dataPath) || (p.dataPath, void 0), visitedObjects.has(p.field) || (p.field, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldSortOptions) || (p.fieldSortOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableTotalOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columnSubtotalOptions) || (p.columnSubtotalOptions, void 0), visitedObjects.has(p.columnTotalOptions) || (p.columnTotalOptions, void 0), visitedObjects.has(p.rowSubtotalOptions) || (p.rowSubtotalOptions, void 0), visitedObjects.has(p.rowTotalOptions) || (p.rowTotalOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.conditionalFormatting) || (p.conditionalFormatting, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTotalOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.metricHeaderCellStyle) || (p.metricHeaderCellStyle, void 0), visitedObjects.has(p.totalCellStyle) || (p.totalCellStyle, void 0), visitedObjects.has(p.valueCellStyle) || (p.valueCellStyle, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_PredefinedHierarchyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columns) || (p.columns, void 0), visitedObjects.has(p.drillDownFilters) || (p.drillDownFilters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ProgressBarOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_RadarChartAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.category) || (p.category, void 0), visitedObjects.has(p.color) || (p.color, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_RadarChartAreaStyleSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_RadarChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.baseSeriesSettings) || (p.baseSeriesSettings, void 0), visitedObjects.has(p.categoryAxis) || (p.categoryAxis, void 0), visitedObjects.has(p.categoryLabelOptions) || (p.categoryLabelOptions, void 0), visitedObjects.has(p.colorAxis) || (p.colorAxis, void 0), visitedObjects.has(p.colorLabelOptions) || (p.colorLabelOptions, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_RadarChartFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.radarChartAggregatedFieldWells) || (p.radarChartAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_RadarChartSeriesSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.areaStyleSettings) || (p.areaStyleSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_RadarChartSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryItemsLimit) || (p.categoryItemsLimit, void 0), visitedObjects.has(p.categorySort) || (p.categorySort, void 0), visitedObjects.has(p.colorItemsLimit) || (p.colorItemsLimit, void 0), visitedObjects.has(p.colorSort) || (p.colorSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_RadarChartVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_RangeEndsLabelTypeProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ReferenceLineProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataConfiguration) || (p.dataConfiguration, void 0), visitedObjects.has(p.labelConfiguration) || (p.labelConfiguration, void 0), visitedObjects.has(p.styleConfiguration) || (p.styleConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ReferenceLineCustomLabelConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ReferenceLineDataConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dynamicConfiguration) || (p.dynamicConfiguration, void 0), visitedObjects.has(p.staticConfiguration) || (p.staticConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ReferenceLineDynamicDataConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.calculation) || (p.calculation, void 0), visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.measureAggregationFunction) || (p.measureAggregationFunction, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ReferenceLineLabelConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customLabelConfiguration) || (p.customLabelConfiguration, void 0), visitedObjects.has(p.fontConfiguration) || (p.fontConfiguration, void 0), visitedObjects.has(p.valueLabelConfiguration) || (p.valueLabelConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ReferenceLineStaticDataConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ReferenceLineStyleConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ReferenceLineValueLabelConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.formatConfiguration) || (p.formatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_RelativeDateTimeControlDisplayOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.titleOptions) || (p.titleOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_RelativeDatesFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.anchorDateConfiguration) || (p.anchorDateConfiguration, void 0), visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.excludePeriodConfiguration) || (p.excludePeriodConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ResourcePermissionProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_RollingDateConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_RowAlternateColorOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_SameSheetTargetVisualConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_SankeyDiagramAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destination) || (p.destination, void 0), visitedObjects.has(p.source) || (p.source, void 0), visitedObjects.has(p.weight) || (p.weight, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_SankeyDiagramChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataLabels) || (p.dataLabels, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_SankeyDiagramFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sankeyDiagramAggregatedFieldWells) || (p.sankeyDiagramAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_SankeyDiagramSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destinationItemsLimit) || (p.destinationItemsLimit, void 0), visitedObjects.has(p.sourceItemsLimit) || (p.sourceItemsLimit, void 0), visitedObjects.has(p.weightSort) || (p.weightSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_SankeyDiagramVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ScatterPlotCategoricallyAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.category) || (p.category, void 0), visitedObjects.has(p.size) || (p.size, void 0), visitedObjects.has(p.xAxis) || (p.xAxis, void 0), visitedObjects.has(p.yAxis) || (p.yAxis, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ScatterPlotConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataLabels) || (p.dataLabels, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0), visitedObjects.has(p.xAxisDisplayOptions) || (p.xAxisDisplayOptions, void 0), visitedObjects.has(p.xAxisLabelOptions) || (p.xAxisLabelOptions, void 0), visitedObjects.has(p.yAxisDisplayOptions) || (p.yAxisDisplayOptions, void 0), visitedObjects.has(p.yAxisLabelOptions) || (p.yAxisLabelOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ScatterPlotFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.scatterPlotCategoricallyAggregatedFieldWells) || (p.scatterPlotCategoricallyAggregatedFieldWells, void 0), visitedObjects.has(p.scatterPlotUnaggregatedFieldWells) || (p.scatterPlotUnaggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ScatterPlotUnaggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.size) || (p.size, void 0), visitedObjects.has(p.xAxis) || (p.xAxis, void 0), visitedObjects.has(p.yAxis) || (p.yAxis, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ScatterPlotVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ScrollBarOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.visibleRange) || (p.visibleRange, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_SecondaryValueOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_SectionAfterPageBreakProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_SectionBasedLayoutCanvasSizeOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.paperCanvasSizeOptions) || (p.paperCanvasSizeOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_SectionBasedLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bodySections) || (p.bodySections, void 0), visitedObjects.has(p.canvasSizeOptions) || (p.canvasSizeOptions, void 0), visitedObjects.has(p.footerSections) || (p.footerSections, void 0), visitedObjects.has(p.headerSections) || (p.headerSections, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_SectionBasedLayoutPaperCanvasSizeOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.paperMargin) || (p.paperMargin, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_SectionLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.freeFormLayout) || (p.freeFormLayout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_SectionPageBreakConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.after) || (p.after, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_SectionStyleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.padding) || (p.padding, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_SelectedSheetsFilterScopeConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sheetVisualScopingConfigurations) || (p.sheetVisualScopingConfigurations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_SeriesItemProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataFieldSeriesItem) || (p.dataFieldSeriesItem, void 0), visitedObjects.has(p.fieldSeriesItem) || (p.fieldSeriesItem, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_SetParameterValueConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ShapeConditionalFormatProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.backgroundColor) || (p.backgroundColor, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_SheetProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_SheetControlLayoutProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.configuration) || (p.configuration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_SheetControlLayoutConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.gridLayout) || (p.gridLayout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_SheetDefinitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.filterControls) || (p.filterControls, void 0), visitedObjects.has(p.layouts) || (p.layouts, void 0), visitedObjects.has(p.parameterControls) || (p.parameterControls, void 0), visitedObjects.has(p.sheetControlLayouts) || (p.sheetControlLayouts, void 0), visitedObjects.has(p.textBoxes) || (p.textBoxes, void 0), visitedObjects.has(p.visuals) || (p.visuals, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_SheetElementConfigurationOverridesProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_SheetElementRenderingRuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.configurationOverrides) || (p.configurationOverrides, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_SheetTextBoxProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_SheetVisualScopingConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ShortFormatTextProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_SimpleClusterMarkerProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_SliderControlDisplayOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.titleOptions) || (p.titleOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_SmallMultiplesOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.panelConfiguration) || (p.panelConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_SpacingProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_StringDefaultValuesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dynamicValue) || (p.dynamicValue, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_StringFormatConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.nullValueFormatConfiguration) || (p.nullValueFormatConfiguration, void 0), visitedObjects.has(p.numericFormatConfiguration) || (p.numericFormatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_StringParameterDeclarationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultValues) || (p.defaultValues, void 0), visitedObjects.has(p.mappedDataSetParameters) || (p.mappedDataSetParameters, void 0), visitedObjects.has(p.valueWhenUnset) || (p.valueWhenUnset, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_StringValueWhenUnsetConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_SubtotalOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldLevelOptions) || (p.fieldLevelOptions, void 0), visitedObjects.has(p.metricHeaderCellStyle) || (p.metricHeaderCellStyle, void 0), visitedObjects.has(p.totalCellStyle) || (p.totalCellStyle, void 0), visitedObjects.has(p.valueCellStyle) || (p.valueCellStyle, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TableAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.groupBy) || (p.groupBy, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TableBorderOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TableCellConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.textFormat) || (p.textFormat, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TableCellImageSizingConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TableCellStyleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.border) || (p.border, void 0), visitedObjects.has(p.fontConfiguration) || (p.fontConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TableConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.conditionalFormattingOptions) || (p.conditionalFormattingOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TableConditionalFormattingOptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cell) || (p.cell, void 0), visitedObjects.has(p.row) || (p.row, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TableConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldOptions) || (p.fieldOptions, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.paginatedReportOptions) || (p.paginatedReportOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tableInlineVisualizations) || (p.tableInlineVisualizations, void 0), visitedObjects.has(p.tableOptions) || (p.tableOptions, void 0), visitedObjects.has(p.totalOptions) || (p.totalOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TableFieldCustomIconContentProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TableFieldCustomTextContentProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fontConfiguration) || (p.fontConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TableFieldImageConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sizingOptions) || (p.sizingOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TableFieldLinkConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.content) || (p.content, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TableFieldLinkContentConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customIconContent) || (p.customIconContent, void 0), visitedObjects.has(p.customTextContent) || (p.customTextContent, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TableFieldOptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.urlStyling) || (p.urlStyling, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TableFieldOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.selectedFieldOptions) || (p.selectedFieldOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TableFieldURLConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.imageConfiguration) || (p.imageConfiguration, void 0), visitedObjects.has(p.linkConfiguration) || (p.linkConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TableFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tableAggregatedFieldWells) || (p.tableAggregatedFieldWells, void 0), visitedObjects.has(p.tableUnaggregatedFieldWells) || (p.tableUnaggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TableInlineVisualizationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataBars) || (p.dataBars, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TableOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cellStyle) || (p.cellStyle, void 0), visitedObjects.has(p.headerStyle) || (p.headerStyle, void 0), visitedObjects.has(p.rowAlternateColorOptions) || (p.rowAlternateColorOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TablePaginatedReportOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TableRowConditionalFormattingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.backgroundColor) || (p.backgroundColor, void 0), visitedObjects.has(p.textColor) || (p.textColor, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TableSideBorderOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bottom) || (p.bottom, void 0), visitedObjects.has(p.innerHorizontal) || (p.innerHorizontal, void 0), visitedObjects.has(p.innerVertical) || (p.innerVertical, void 0), visitedObjects.has(p.left) || (p.left, void 0), visitedObjects.has(p.right) || (p.right, void 0), visitedObjects.has(p.top) || (p.top, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TableSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.paginationConfiguration) || (p.paginationConfiguration, void 0), visitedObjects.has(p.rowSort) || (p.rowSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TableUnaggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TableVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.conditionalFormatting) || (p.conditionalFormatting, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TemplateErrorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.violatedEntities) || (p.violatedEntities, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TemplateSourceAnalysisProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataSetReferences) || (p.dataSetReferences, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TemplateSourceEntityProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sourceAnalysis) || (p.sourceAnalysis, void 0), visitedObjects.has(p.sourceTemplate) || (p.sourceTemplate, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TemplateSourceTemplateProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TemplateVersionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataSetConfigurations) || (p.dataSetConfigurations, void 0), visitedObjects.has(p.errors) || (p.errors, void 0), visitedObjects.has(p.sheets) || (p.sheets, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TemplateVersionDefinitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataSetConfigurations) || (p.dataSetConfigurations, void 0), visitedObjects.has(p.analysisDefaults) || (p.analysisDefaults, void 0), visitedObjects.has(p.calculatedFields) || (p.calculatedFields, void 0), visitedObjects.has(p.columnConfigurations) || (p.columnConfigurations, void 0), visitedObjects.has(p.filterGroups) || (p.filterGroups, void 0), visitedObjects.has(p.parameterDeclarations) || (p.parameterDeclarations, void 0), visitedObjects.has(p.sheets) || (p.sheets, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TextAreaControlDisplayOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.placeholderOptions) || (p.placeholderOptions, void 0), visitedObjects.has(p.titleOptions) || (p.titleOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TextConditionalFormatProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.backgroundColor) || (p.backgroundColor, void 0), visitedObjects.has(p.icon) || (p.icon, void 0), visitedObjects.has(p.textColor) || (p.textColor, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TextControlPlaceholderOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TextFieldControlDisplayOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.placeholderOptions) || (p.placeholderOptions, void 0), visitedObjects.has(p.titleOptions) || (p.titleOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_ThousandSeparatorOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TimeBasedForecastPropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TimeEqualityFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TimeRangeDrillDownFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TimeRangeFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.excludePeriodConfiguration) || (p.excludePeriodConfiguration, void 0), visitedObjects.has(p.rangeMaximumValue) || (p.rangeMaximumValue, void 0), visitedObjects.has(p.rangeMinimumValue) || (p.rangeMinimumValue, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TimeRangeFilterValueProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.rollingDate) || (p.rollingDate, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TooltipItemProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.columnTooltipItem) || (p.columnTooltipItem, void 0), visitedObjects.has(p.fieldTooltipItem) || (p.fieldTooltipItem, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TooltipOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldBasedTooltip) || (p.fieldBasedTooltip, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TopBottomFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.aggregationSortConfigurations) || (p.aggregationSortConfigurations, void 0), visitedObjects.has(p.column) || (p.column, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TopBottomMoversComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.category) || (p.category, void 0), visitedObjects.has(p.time) || (p.time, void 0), visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TopBottomRankedComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.category) || (p.category, void 0), visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TotalAggregationComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TotalOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.totalCellStyle) || (p.totalCellStyle, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TreeMapAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.colors) || (p.colors, void 0), visitedObjects.has(p.groups) || (p.groups, void 0), visitedObjects.has(p.sizes) || (p.sizes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TreeMapConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.colorLabelOptions) || (p.colorLabelOptions, void 0), visitedObjects.has(p.colorScale) || (p.colorScale, void 0), visitedObjects.has(p.dataLabels) || (p.dataLabels, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.groupLabelOptions) || (p.groupLabelOptions, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.sizeLabelOptions) || (p.sizeLabelOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.tooltip) || (p.tooltip, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TreeMapFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.treeMapAggregatedFieldWells) || (p.treeMapAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TreeMapSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.treeMapGroupItemsLimitConfiguration) || (p.treeMapGroupItemsLimitConfiguration, void 0), visitedObjects.has(p.treeMapSort) || (p.treeMapSort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TreeMapVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_TrendArrowOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_UnaggregatedFieldProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.column) || (p.column, void 0), visitedObjects.has(p.formatConfiguration) || (p.formatConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_UniqueValuesComputationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.category) || (p.category, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_VisibleRangeOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.percentRange) || (p.percentRange, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_VisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.barChartVisual) || (p.barChartVisual, void 0), visitedObjects.has(p.boxPlotVisual) || (p.boxPlotVisual, void 0), visitedObjects.has(p.comboChartVisual) || (p.comboChartVisual, void 0), visitedObjects.has(p.customContentVisual) || (p.customContentVisual, void 0), visitedObjects.has(p.emptyVisual) || (p.emptyVisual, void 0), visitedObjects.has(p.filledMapVisual) || (p.filledMapVisual, void 0), visitedObjects.has(p.funnelChartVisual) || (p.funnelChartVisual, void 0), visitedObjects.has(p.gaugeChartVisual) || (p.gaugeChartVisual, void 0), visitedObjects.has(p.geospatialMapVisual) || (p.geospatialMapVisual, void 0), visitedObjects.has(p.heatMapVisual) || (p.heatMapVisual, void 0), visitedObjects.has(p.histogramVisual) || (p.histogramVisual, void 0), visitedObjects.has(p.insightVisual) || (p.insightVisual, void 0), visitedObjects.has(p.kpiVisual) || (p.kpiVisual, void 0), visitedObjects.has(p.lineChartVisual) || (p.lineChartVisual, void 0), visitedObjects.has(p.pieChartVisual) || (p.pieChartVisual, void 0), visitedObjects.has(p.pivotTableVisual) || (p.pivotTableVisual, void 0), visitedObjects.has(p.radarChartVisual) || (p.radarChartVisual, void 0), visitedObjects.has(p.sankeyDiagramVisual) || (p.sankeyDiagramVisual, void 0), visitedObjects.has(p.scatterPlotVisual) || (p.scatterPlotVisual, void 0), visitedObjects.has(p.tableVisual) || (p.tableVisual, void 0), visitedObjects.has(p.treeMapVisual) || (p.treeMapVisual, void 0), visitedObjects.has(p.waterfallVisual) || (p.waterfallVisual, void 0), visitedObjects.has(p.wordCloudVisual) || (p.wordCloudVisual, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_VisualCustomActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actionOperations) || (p.actionOperations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_VisualCustomActionOperationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.filterOperation) || (p.filterOperation, void 0), visitedObjects.has(p.navigationOperation) || (p.navigationOperation, void 0), visitedObjects.has(p.setParametersOperation) || (p.setParametersOperation, void 0), visitedObjects.has(p.urlOperation) || (p.urlOperation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_VisualPaletteProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.colorMap) || (p.colorMap, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_VisualSubtitleLabelOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.formatText) || (p.formatText, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_VisualTitleLabelOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.formatText) || (p.formatText, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_WaterfallChartAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.breakdowns) || (p.breakdowns, void 0), visitedObjects.has(p.categories) || (p.categories, void 0), visitedObjects.has(p.values) || (p.values, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_WaterfallChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryAxisDisplayOptions) || (p.categoryAxisDisplayOptions, void 0), visitedObjects.has(p.categoryAxisLabelOptions) || (p.categoryAxisLabelOptions, void 0), visitedObjects.has(p.dataLabels) || (p.dataLabels, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.legend) || (p.legend, void 0), visitedObjects.has(p.primaryYAxisDisplayOptions) || (p.primaryYAxisDisplayOptions, void 0), visitedObjects.has(p.primaryYAxisLabelOptions) || (p.primaryYAxisLabelOptions, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.visualPalette) || (p.visualPalette, void 0), visitedObjects.has(p.waterfallChartOptions) || (p.waterfallChartOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_WaterfallChartFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.waterfallChartAggregatedFieldWells) || (p.waterfallChartAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_WaterfallChartOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_WaterfallChartSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.breakdownItemsLimit) || (p.breakdownItemsLimit, void 0), visitedObjects.has(p.categorySort) || (p.categorySort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_WaterfallVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_WhatIfPointScenarioProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_WhatIfRangeScenarioProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_WordCloudAggregatedFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.groupBy) || (p.groupBy, void 0), visitedObjects.has(p.size) || (p.size, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_WordCloudChartConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryLabelOptions) || (p.categoryLabelOptions, void 0), visitedObjects.has(p.fieldWells) || (p.fieldWells, void 0), visitedObjects.has(p.sortConfiguration) || (p.sortConfiguration, void 0), visitedObjects.has(p.wordCloudOptions) || (p.wordCloudOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_WordCloudFieldWellsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.wordCloudAggregatedFieldWells) || (p.wordCloudAggregatedFieldWells, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_WordCloudOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_WordCloudSortConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.categoryItemsLimit) || (p.categoryItemsLimit, void 0), visitedObjects.has(p.categorySort) || (p.categorySort, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTemplate_WordCloudVisualProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chartConfiguration) || (p.chartConfiguration, void 0), visitedObjects.has(p.columnHierarchies) || (p.columnHierarchies, void 0), visitedObjects.has(p.subtitle) || (p.subtitle, void 0), visitedObjects.has(p.title) || (p.title, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnThemeProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.configuration) || (p.configuration, void 0), visitedObjects.has(p.permissions) || (p.permissions, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTheme(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTheme_BorderStyleProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTheme_DataColorPaletteProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTheme_FontProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTheme_GutterStyleProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTheme_MarginStyleProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTheme_ResourcePermissionProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTheme_SheetStyleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tile) || (p.tile, void 0), visitedObjects.has(p.tileLayout) || (p.tileLayout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTheme_ThemeConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataColorPalette) || (p.dataColorPalette, void 0), visitedObjects.has(p.sheet) || (p.sheet, void 0), visitedObjects.has(p.typography) || (p.typography, void 0), visitedObjects.has(p.uiColorPalette) || (p.uiColorPalette, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTheme_ThemeErrorProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnTheme_ThemeVersionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.configuration) || (p.configuration, void 0), visitedObjects.has(p.errors) || (p.errors, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTheme_TileLayoutStyleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.gutter) || (p.gutter, void 0), visitedObjects.has(p.margin) || (p.margin, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTheme_TileStyleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.border) || (p.border, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTheme_TypographyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fontFamilies) || (p.fontFamilies, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnTheme_UIColorPaletteProperty(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnVPCConnectionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_quicksight_CfnVPCConnection(p) {
    }
    function aws_cdk_lib_aws_quicksight_CfnVPCConnection_NetworkInterfaceProperty(p) {
    }
    function aws_cdk_lib_aws_ram_CfnPermissionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ram_CfnPermission(p) {
    }
    function aws_cdk_lib_aws_ram_CfnResourceShareProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ram_CfnResourceShare(p) {
    }
    function aws_cdk_lib_aws_rds_IEngine(p) {
    }
    function aws_cdk_lib_aws_rds_EngineVersion(p) {
    }
    function aws_cdk_lib_aws_rds_InstanceUpdateBehaviour(p) {
    }
    function aws_cdk_lib_aws_rds_DatabaseClusterBase(p) {
    }
    function aws_cdk_lib_aws_rds_DatabaseClusterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.engine) || (p.engine, void 0), visitedObjects.has(p.instanceProps) || aws_cdk_lib_aws_rds_InstanceProps(p.instanceProps), visitedObjects.has(p.backtrackWindow) || (p.backtrackWindow, void 0), visitedObjects.has(p.backup) || aws_cdk_lib_aws_rds_BackupProps(p.backup), visitedObjects.has(p.cloudwatchLogsRetention) || (p.cloudwatchLogsRetention, void 0), visitedObjects.has(p.cloudwatchLogsRetentionRole) || (p.cloudwatchLogsRetentionRole, void 0), visitedObjects.has(p.credentials) || (p.credentials, void 0), visitedObjects.has(p.instanceUpdateBehaviour) || (p.instanceUpdateBehaviour, void 0), visitedObjects.has(p.monitoringInterval) || (p.monitoringInterval, void 0), visitedObjects.has(p.monitoringRole) || (p.monitoringRole, void 0), visitedObjects.has(p.networkType) || (p.networkType, void 0), visitedObjects.has(p.parameterGroup) || (p.parameterGroup, void 0), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), p.s3ExportBuckets != null)
            for (const o of p.s3ExportBuckets)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.s3ExportRole) || (p.s3ExportRole, void 0), p.s3ImportBuckets != null)
            for (const o of p.s3ImportBuckets)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.s3ImportRole) || (p.s3ImportRole, void 0), visitedObjects.has(p.storageEncryptionKey) || (p.storageEncryptionKey, void 0), visitedObjects.has(p.subnetGroup) || (p.subnetGroup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_DatabaseCluster(p) {
    }
    function aws_cdk_lib_aws_rds_DatabaseClusterFromSnapshotProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.engine) || (p.engine, void 0), visitedObjects.has(p.instanceProps) || aws_cdk_lib_aws_rds_InstanceProps(p.instanceProps), visitedObjects.has(p.backtrackWindow) || (p.backtrackWindow, void 0), visitedObjects.has(p.backup) || aws_cdk_lib_aws_rds_BackupProps(p.backup), visitedObjects.has(p.cloudwatchLogsRetention) || (p.cloudwatchLogsRetention, void 0), visitedObjects.has(p.cloudwatchLogsRetentionRole) || (p.cloudwatchLogsRetentionRole, void 0), "credentials" in p && print("aws-cdk-lib.aws_rds.DatabaseClusterFromSnapshotProps#credentials", "use `snapshotCredentials` which allows to generate a new password"), visitedObjects.has(p.credentials) || (p.credentials, void 0), visitedObjects.has(p.instanceUpdateBehaviour) || (p.instanceUpdateBehaviour, void 0), visitedObjects.has(p.monitoringInterval) || (p.monitoringInterval, void 0), visitedObjects.has(p.monitoringRole) || (p.monitoringRole, void 0), visitedObjects.has(p.networkType) || (p.networkType, void 0), visitedObjects.has(p.parameterGroup) || (p.parameterGroup, void 0), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), p.s3ExportBuckets != null)
            for (const o of p.s3ExportBuckets)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.s3ExportRole) || (p.s3ExportRole, void 0), p.s3ImportBuckets != null)
            for (const o of p.s3ImportBuckets)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.s3ImportRole) || (p.s3ImportRole, void 0), visitedObjects.has(p.snapshotCredentials) || (p.snapshotCredentials, void 0), visitedObjects.has(p.storageEncryptionKey) || (p.storageEncryptionKey, void 0), visitedObjects.has(p.subnetGroup) || (p.subnetGroup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_DatabaseClusterFromSnapshot(p) {
    }
    function aws_cdk_lib_aws_rds_IDatabaseCluster(p) {
    }
    function aws_cdk_lib_aws_rds_DatabaseClusterAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.engine) || (p.engine, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_ClusterEngineBindOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.parameterGroup) || (p.parameterGroup, void 0), visitedObjects.has(p.s3ExportRole) || (p.s3ExportRole, void 0), visitedObjects.has(p.s3ImportRole) || (p.s3ImportRole, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_ClusterEngineConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.features) || (p.features, void 0), visitedObjects.has(p.parameterGroup) || (p.parameterGroup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_ClusterEngineFeatures(p) {
    }
    function aws_cdk_lib_aws_rds_IClusterEngine(p) {
    }
    function aws_cdk_lib_aws_rds_AuroraEngineVersion(p) {
    }
    function aws_cdk_lib_aws_rds_AuroraClusterEngineProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.version) || (p.version, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_AuroraMysqlEngineVersion(p) {
    }
    function aws_cdk_lib_aws_rds_AuroraMysqlClusterEngineProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.version) || (p.version, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_AuroraPostgresEngineFeatures(p) {
    }
    function aws_cdk_lib_aws_rds_AuroraPostgresEngineVersion(p) {
    }
    function aws_cdk_lib_aws_rds_AuroraPostgresClusterEngineProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.version) || (p.version, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_DatabaseClusterEngine(p) {
    }
    function aws_cdk_lib_aws_rds_InstanceEngineBindOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.optionGroup) || (p.optionGroup, void 0), visitedObjects.has(p.s3ExportRole) || (p.s3ExportRole, void 0), visitedObjects.has(p.s3ImportRole) || (p.s3ImportRole, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_InstanceEngineConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.features) || (p.features, void 0), visitedObjects.has(p.optionGroup) || (p.optionGroup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_InstanceEngineFeatures(p) {
    }
    function aws_cdk_lib_aws_rds_IInstanceEngine(p) {
    }
    function aws_cdk_lib_aws_rds_MariaDbEngineVersion(p) {
    }
    function aws_cdk_lib_aws_rds_MariaDbInstanceEngineProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.version) || (p.version, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_MysqlEngineVersion(p) {
    }
    function aws_cdk_lib_aws_rds_MySqlInstanceEngineProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.version) || (p.version, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_PostgresEngineFeatures(p) {
    }
    function aws_cdk_lib_aws_rds_PostgresEngineVersion(p) {
    }
    function aws_cdk_lib_aws_rds_PostgresInstanceEngineProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.version) || (p.version, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_OracleEngineVersion(p) {
    }
    function aws_cdk_lib_aws_rds_OracleSe2InstanceEngineProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.version) || (p.version, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_OracleSe2CdbInstanceEngineProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.version) || (p.version, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_OracleEeInstanceEngineProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.version) || (p.version, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_OracleEeCdbInstanceEngineProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.version) || (p.version, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_SqlServerEngineVersion(p) {
    }
    function aws_cdk_lib_aws_rds_SqlServerSeInstanceEngineProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.version) || (p.version, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_SqlServerExInstanceEngineProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.version) || (p.version, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_SqlServerWebInstanceEngineProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.version) || (p.version, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_SqlServerEeInstanceEngineProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.version) || (p.version, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_DatabaseInstanceEngine(p) {
    }
    function aws_cdk_lib_aws_rds_InstanceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.instanceType) || (p.instanceType, void 0), visitedObjects.has(p.parameterGroup) || (p.parameterGroup, void 0), visitedObjects.has(p.performanceInsightEncryptionKey) || (p.performanceInsightEncryptionKey, void 0), visitedObjects.has(p.performanceInsightRetention) || (p.performanceInsightRetention, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_BackupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.retention) || (p.retention, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_CredentialsBaseOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.encryptionKey) || (p.encryptionKey, void 0), p.replicaRegions != null)
            for (const o of p.replicaRegions)
              visitedObjects.has(o) || aws_cdk_lib_aws_secretsmanager_ReplicaRegion(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_CredentialsFromUsernameOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.password) || (p.password, void 0), visitedObjects.has(p.encryptionKey) || (p.encryptionKey, void 0), p.replicaRegions != null)
            for (const o of p.replicaRegions)
              visitedObjects.has(o) || aws_cdk_lib_aws_secretsmanager_ReplicaRegion(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_Credentials(p) {
    }
    function aws_cdk_lib_aws_rds_SnapshotCredentialsFromGeneratedPasswordOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.encryptionKey) || (p.encryptionKey, void 0), p.replicaRegions != null)
            for (const o of p.replicaRegions)
              visitedObjects.has(o) || aws_cdk_lib_aws_secretsmanager_ReplicaRegion(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_SnapshotCredentials(p) {
    }
    function aws_cdk_lib_aws_rds_CommonRotationUserOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.automaticallyAfter) || (p.automaticallyAfter, void 0), visitedObjects.has(p.endpoint) || (p.endpoint, void 0), visitedObjects.has(p.securityGroup) || (p.securityGroup, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_RotationSingleUserOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.automaticallyAfter) || (p.automaticallyAfter, void 0), visitedObjects.has(p.endpoint) || (p.endpoint, void 0), visitedObjects.has(p.securityGroup) || (p.securityGroup, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_RotationMultiUserOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.secret) || (p.secret, void 0), visitedObjects.has(p.automaticallyAfter) || (p.automaticallyAfter, void 0), visitedObjects.has(p.endpoint) || (p.endpoint, void 0), visitedObjects.has(p.securityGroup) || (p.securityGroup, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_PerformanceInsightRetention(p) {
    }
    function aws_cdk_lib_aws_rds_ParameterGroupClusterBindOptions(p) {
    }
    function aws_cdk_lib_aws_rds_ParameterGroupClusterConfig(p) {
    }
    function aws_cdk_lib_aws_rds_ParameterGroupInstanceBindOptions(p) {
    }
    function aws_cdk_lib_aws_rds_ParameterGroupInstanceConfig(p) {
    }
    function aws_cdk_lib_aws_rds_IParameterGroup(p) {
    }
    function aws_cdk_lib_aws_rds_ParameterGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.engine) || (p.engine, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_ParameterGroup(p) {
    }
    function aws_cdk_lib_aws_rds_DatabaseSecretProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.encryptionKey) || (p.encryptionKey, void 0), visitedObjects.has(p.masterSecret) || (p.masterSecret, void 0), p.replicaRegions != null)
            for (const o of p.replicaRegions)
              visitedObjects.has(o) || aws_cdk_lib_aws_secretsmanager_ReplicaRegion(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_DatabaseSecret(p) {
    }
    function aws_cdk_lib_aws_rds_Endpoint(p) {
    }
    function aws_cdk_lib_aws_rds_IOptionGroup(p) {
    }
    function aws_cdk_lib_aws_rds_OptionConfiguration(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_OptionGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.configurations != null)
            for (const o of p.configurations)
              visitedObjects.has(o) || aws_cdk_lib_aws_rds_OptionConfiguration(o);
          visitedObjects.has(p.engine) || (p.engine, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_OptionGroup(p) {
    }
    function aws_cdk_lib_aws_rds_IDatabaseInstance(p) {
    }
    function aws_cdk_lib_aws_rds_DatabaseInstanceAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.engine) || (p.engine, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_DatabaseInstanceBase(p) {
    }
    function aws_cdk_lib_aws_rds_LicenseModel(p) {
    }
    function aws_cdk_lib_aws_rds_ProcessorFeatures(p) {
    }
    function aws_cdk_lib_aws_rds_StorageType(p) {
    }
    function aws_cdk_lib_aws_rds_NetworkType(p) {
    }
    function aws_cdk_lib_aws_rds_DatabaseInstanceNewProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.backupRetention) || (p.backupRetention, void 0), visitedObjects.has(p.cloudwatchLogsRetention) || (p.cloudwatchLogsRetention, void 0), visitedObjects.has(p.cloudwatchLogsRetentionRole) || (p.cloudwatchLogsRetentionRole, void 0), visitedObjects.has(p.domainRole) || (p.domainRole, void 0), visitedObjects.has(p.monitoringInterval) || (p.monitoringInterval, void 0), visitedObjects.has(p.monitoringRole) || (p.monitoringRole, void 0), visitedObjects.has(p.networkType) || (p.networkType, void 0), visitedObjects.has(p.optionGroup) || (p.optionGroup, void 0), visitedObjects.has(p.parameterGroup) || (p.parameterGroup, void 0), visitedObjects.has(p.performanceInsightEncryptionKey) || (p.performanceInsightEncryptionKey, void 0), visitedObjects.has(p.performanceInsightRetention) || (p.performanceInsightRetention, void 0), visitedObjects.has(p.processorFeatures) || (p.processorFeatures, void 0), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), p.s3ExportBuckets != null)
            for (const o of p.s3ExportBuckets)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.s3ExportRole) || (p.s3ExportRole, void 0), p.s3ImportBuckets != null)
            for (const o of p.s3ImportBuckets)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.s3ImportRole) || (p.s3ImportRole, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.storageType) || (p.storageType, void 0), visitedObjects.has(p.subnetGroup) || (p.subnetGroup, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_DatabaseInstanceSourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.engine) || (p.engine, void 0), visitedObjects.has(p.instanceType) || (p.instanceType, void 0), visitedObjects.has(p.licenseModel) || (p.licenseModel, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.backupRetention) || (p.backupRetention, void 0), visitedObjects.has(p.cloudwatchLogsRetention) || (p.cloudwatchLogsRetention, void 0), visitedObjects.has(p.cloudwatchLogsRetentionRole) || (p.cloudwatchLogsRetentionRole, void 0), visitedObjects.has(p.domainRole) || (p.domainRole, void 0), visitedObjects.has(p.monitoringInterval) || (p.monitoringInterval, void 0), visitedObjects.has(p.monitoringRole) || (p.monitoringRole, void 0), visitedObjects.has(p.networkType) || (p.networkType, void 0), visitedObjects.has(p.optionGroup) || (p.optionGroup, void 0), visitedObjects.has(p.parameterGroup) || (p.parameterGroup, void 0), visitedObjects.has(p.performanceInsightEncryptionKey) || (p.performanceInsightEncryptionKey, void 0), visitedObjects.has(p.performanceInsightRetention) || (p.performanceInsightRetention, void 0), visitedObjects.has(p.processorFeatures) || (p.processorFeatures, void 0), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), p.s3ExportBuckets != null)
            for (const o of p.s3ExportBuckets)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.s3ExportRole) || (p.s3ExportRole, void 0), p.s3ImportBuckets != null)
            for (const o of p.s3ImportBuckets)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.s3ImportRole) || (p.s3ImportRole, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.storageType) || (p.storageType, void 0), visitedObjects.has(p.subnetGroup) || (p.subnetGroup, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_DatabaseInstanceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.credentials) || (p.credentials, void 0), visitedObjects.has(p.storageEncryptionKey) || (p.storageEncryptionKey, void 0), visitedObjects.has(p.engine) || (p.engine, void 0), visitedObjects.has(p.instanceType) || (p.instanceType, void 0), visitedObjects.has(p.licenseModel) || (p.licenseModel, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.backupRetention) || (p.backupRetention, void 0), visitedObjects.has(p.cloudwatchLogsRetention) || (p.cloudwatchLogsRetention, void 0), visitedObjects.has(p.cloudwatchLogsRetentionRole) || (p.cloudwatchLogsRetentionRole, void 0), visitedObjects.has(p.domainRole) || (p.domainRole, void 0), visitedObjects.has(p.monitoringInterval) || (p.monitoringInterval, void 0), visitedObjects.has(p.monitoringRole) || (p.monitoringRole, void 0), visitedObjects.has(p.networkType) || (p.networkType, void 0), visitedObjects.has(p.optionGroup) || (p.optionGroup, void 0), visitedObjects.has(p.parameterGroup) || (p.parameterGroup, void 0), visitedObjects.has(p.performanceInsightEncryptionKey) || (p.performanceInsightEncryptionKey, void 0), visitedObjects.has(p.performanceInsightRetention) || (p.performanceInsightRetention, void 0), visitedObjects.has(p.processorFeatures) || (p.processorFeatures, void 0), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), p.s3ExportBuckets != null)
            for (const o of p.s3ExportBuckets)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.s3ExportRole) || (p.s3ExportRole, void 0), p.s3ImportBuckets != null)
            for (const o of p.s3ImportBuckets)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.s3ImportRole) || (p.s3ImportRole, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.storageType) || (p.storageType, void 0), visitedObjects.has(p.subnetGroup) || (p.subnetGroup, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_DatabaseInstance(p) {
    }
    function aws_cdk_lib_aws_rds_DatabaseInstanceFromSnapshotProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.credentials) || (p.credentials, void 0), visitedObjects.has(p.engine) || (p.engine, void 0), visitedObjects.has(p.instanceType) || (p.instanceType, void 0), visitedObjects.has(p.licenseModel) || (p.licenseModel, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.backupRetention) || (p.backupRetention, void 0), visitedObjects.has(p.cloudwatchLogsRetention) || (p.cloudwatchLogsRetention, void 0), visitedObjects.has(p.cloudwatchLogsRetentionRole) || (p.cloudwatchLogsRetentionRole, void 0), visitedObjects.has(p.domainRole) || (p.domainRole, void 0), visitedObjects.has(p.monitoringInterval) || (p.monitoringInterval, void 0), visitedObjects.has(p.monitoringRole) || (p.monitoringRole, void 0), visitedObjects.has(p.networkType) || (p.networkType, void 0), visitedObjects.has(p.optionGroup) || (p.optionGroup, void 0), visitedObjects.has(p.parameterGroup) || (p.parameterGroup, void 0), visitedObjects.has(p.performanceInsightEncryptionKey) || (p.performanceInsightEncryptionKey, void 0), visitedObjects.has(p.performanceInsightRetention) || (p.performanceInsightRetention, void 0), visitedObjects.has(p.processorFeatures) || (p.processorFeatures, void 0), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), p.s3ExportBuckets != null)
            for (const o of p.s3ExportBuckets)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.s3ExportRole) || (p.s3ExportRole, void 0), p.s3ImportBuckets != null)
            for (const o of p.s3ImportBuckets)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.s3ImportRole) || (p.s3ImportRole, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.storageType) || (p.storageType, void 0), visitedObjects.has(p.subnetGroup) || (p.subnetGroup, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_DatabaseInstanceFromSnapshot(p) {
    }
    function aws_cdk_lib_aws_rds_DatabaseInstanceReadReplicaProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.instanceType) || (p.instanceType, void 0), visitedObjects.has(p.sourceDatabaseInstance) || (p.sourceDatabaseInstance, void 0), visitedObjects.has(p.storageEncryptionKey) || (p.storageEncryptionKey, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.backupRetention) || (p.backupRetention, void 0), visitedObjects.has(p.cloudwatchLogsRetention) || (p.cloudwatchLogsRetention, void 0), visitedObjects.has(p.cloudwatchLogsRetentionRole) || (p.cloudwatchLogsRetentionRole, void 0), visitedObjects.has(p.domainRole) || (p.domainRole, void 0), visitedObjects.has(p.monitoringInterval) || (p.monitoringInterval, void 0), visitedObjects.has(p.monitoringRole) || (p.monitoringRole, void 0), visitedObjects.has(p.networkType) || (p.networkType, void 0), visitedObjects.has(p.optionGroup) || (p.optionGroup, void 0), visitedObjects.has(p.parameterGroup) || (p.parameterGroup, void 0), visitedObjects.has(p.performanceInsightEncryptionKey) || (p.performanceInsightEncryptionKey, void 0), visitedObjects.has(p.performanceInsightRetention) || (p.performanceInsightRetention, void 0), visitedObjects.has(p.processorFeatures) || (p.processorFeatures, void 0), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), p.s3ExportBuckets != null)
            for (const o of p.s3ExportBuckets)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.s3ExportRole) || (p.s3ExportRole, void 0), p.s3ImportBuckets != null)
            for (const o of p.s3ImportBuckets)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.s3ImportRole) || (p.s3ImportRole, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.storageType) || (p.storageType, void 0), visitedObjects.has(p.subnetGroup) || (p.subnetGroup, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_DatabaseInstanceReadReplica(p) {
    }
    function aws_cdk_lib_aws_rds_SessionPinningFilter(p) {
    }
    function aws_cdk_lib_aws_rds_ProxyTarget(p) {
    }
    function aws_cdk_lib_aws_rds_ProxyTargetConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.dbClusters != null)
            for (const o of p.dbClusters)
              visitedObjects.has(o) || void 0;
          if (p.dbInstances != null)
            for (const o of p.dbInstances)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_DatabaseProxyOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.secrets != null)
            for (const o of p.secrets)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.borrowTimeout) || (p.borrowTimeout, void 0), visitedObjects.has(p.idleClientTimeout) || (p.idleClientTimeout, void 0), visitedObjects.has(p.role) || (p.role, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          if (p.sessionPinningFilters != null)
            for (const o of p.sessionPinningFilters)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_DatabaseProxyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.proxyTarget) || (p.proxyTarget, void 0), p.secrets != null)
            for (const o of p.secrets)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.borrowTimeout) || (p.borrowTimeout, void 0), visitedObjects.has(p.idleClientTimeout) || (p.idleClientTimeout, void 0), visitedObjects.has(p.role) || (p.role, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          if (p.sessionPinningFilters != null)
            for (const o of p.sessionPinningFilters)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_DatabaseProxyAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_IDatabaseProxy(p) {
    }
    function aws_cdk_lib_aws_rds_DatabaseProxy(p) {
    }
    function aws_cdk_lib_aws_rds_IServerlessCluster(p) {
    }
    function aws_cdk_lib_aws_rds_ServerlessClusterAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.secret) || (p.secret, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_AuroraCapacityUnit(p) {
    }
    function aws_cdk_lib_aws_rds_ServerlessScalingOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.autoPause) || (p.autoPause, void 0), visitedObjects.has(p.maxCapacity) || (p.maxCapacity, void 0), visitedObjects.has(p.minCapacity) || (p.minCapacity, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_ServerlessClusterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.engine) || (p.engine, void 0), visitedObjects.has(p.backupRetention) || (p.backupRetention, void 0), visitedObjects.has(p.credentials) || (p.credentials, void 0), visitedObjects.has(p.parameterGroup) || (p.parameterGroup, void 0), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), visitedObjects.has(p.scaling) || aws_cdk_lib_aws_rds_ServerlessScalingOptions(p.scaling), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.storageEncryptionKey) || (p.storageEncryptionKey, void 0), visitedObjects.has(p.subnetGroup) || (p.subnetGroup, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_ServerlessCluster(p) {
    }
    function aws_cdk_lib_aws_rds_ServerlessClusterFromSnapshotProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.engine) || (p.engine, void 0), visitedObjects.has(p.backupRetention) || (p.backupRetention, void 0), visitedObjects.has(p.credentials) || (p.credentials, void 0), visitedObjects.has(p.parameterGroup) || (p.parameterGroup, void 0), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), visitedObjects.has(p.scaling) || aws_cdk_lib_aws_rds_ServerlessScalingOptions(p.scaling), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.subnetGroup) || (p.subnetGroup, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_ServerlessClusterFromSnapshot(p) {
    }
    function aws_cdk_lib_aws_rds_ISubnetGroup(p) {
    }
    function aws_cdk_lib_aws_rds_SubnetGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_SubnetGroup(p) {
    }
    function aws_cdk_lib_aws_rds_CfnDBClusterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.associatedRoles) || (p.associatedRoles, void 0), visitedObjects.has(p.masterUserSecret) || (p.masterUserSecret, void 0), visitedObjects.has(p.scalingConfiguration) || (p.scalingConfiguration, void 0), visitedObjects.has(p.serverlessV2ScalingConfiguration) || (p.serverlessV2ScalingConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_CfnDBCluster(p) {
    }
    function aws_cdk_lib_aws_rds_CfnDBCluster_DBClusterRoleProperty(p) {
    }
    function aws_cdk_lib_aws_rds_CfnDBCluster_EndpointProperty(p) {
    }
    function aws_cdk_lib_aws_rds_CfnDBCluster_MasterUserSecretProperty(p) {
    }
    function aws_cdk_lib_aws_rds_CfnDBCluster_ReadEndpointProperty(p) {
    }
    function aws_cdk_lib_aws_rds_CfnDBCluster_ScalingConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_rds_CfnDBCluster_ServerlessV2ScalingConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_rds_CfnDBClusterParameterGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_CfnDBClusterParameterGroup(p) {
    }
    function aws_cdk_lib_aws_rds_CfnDBInstanceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.associatedRoles) || (p.associatedRoles, void 0), visitedObjects.has(p.certificateDetails) || (p.certificateDetails, void 0), visitedObjects.has(p.endpoint) || (p.endpoint, void 0), visitedObjects.has(p.masterUserSecret) || (p.masterUserSecret, void 0), visitedObjects.has(p.processorFeatures) || (p.processorFeatures, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_CfnDBInstance(p) {
    }
    function aws_cdk_lib_aws_rds_CfnDBInstance_CertificateDetailsProperty(p) {
    }
    function aws_cdk_lib_aws_rds_CfnDBInstance_DBInstanceRoleProperty(p) {
    }
    function aws_cdk_lib_aws_rds_CfnDBInstance_EndpointProperty(p) {
    }
    function aws_cdk_lib_aws_rds_CfnDBInstance_MasterUserSecretProperty(p) {
    }
    function aws_cdk_lib_aws_rds_CfnDBInstance_ProcessorFeatureProperty(p) {
    }
    function aws_cdk_lib_aws_rds_CfnDBParameterGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_CfnDBParameterGroup(p) {
    }
    function aws_cdk_lib_aws_rds_CfnDBProxyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.auth) || (p.auth, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_CfnDBProxy(p) {
    }
    function aws_cdk_lib_aws_rds_CfnDBProxy_AuthFormatProperty(p) {
    }
    function aws_cdk_lib_aws_rds_CfnDBProxy_TagFormatProperty(p) {
    }
    function aws_cdk_lib_aws_rds_CfnDBProxyEndpointProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_CfnDBProxyEndpoint(p) {
    }
    function aws_cdk_lib_aws_rds_CfnDBProxyEndpoint_TagFormatProperty(p) {
    }
    function aws_cdk_lib_aws_rds_CfnDBProxyTargetGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.connectionPoolConfigurationInfo) || (p.connectionPoolConfigurationInfo, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_CfnDBProxyTargetGroup(p) {
    }
    function aws_cdk_lib_aws_rds_CfnDBProxyTargetGroup_ConnectionPoolConfigurationInfoFormatProperty(p) {
    }
    function aws_cdk_lib_aws_rds_CfnDBSecurityGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.dbSecurityGroupIngress) || (p.dbSecurityGroupIngress, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_CfnDBSecurityGroup(p) {
    }
    function aws_cdk_lib_aws_rds_CfnDBSecurityGroup_IngressProperty(p) {
    }
    function aws_cdk_lib_aws_rds_CfnDBSecurityGroupIngressProps(p) {
    }
    function aws_cdk_lib_aws_rds_CfnDBSecurityGroupIngress(p) {
    }
    function aws_cdk_lib_aws_rds_CfnDBSubnetGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_CfnDBSubnetGroup(p) {
    }
    function aws_cdk_lib_aws_rds_CfnEventSubscriptionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_CfnEventSubscription(p) {
    }
    function aws_cdk_lib_aws_rds_CfnGlobalClusterProps(p) {
    }
    function aws_cdk_lib_aws_rds_CfnGlobalCluster(p) {
    }
    function aws_cdk_lib_aws_rds_CfnOptionGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.optionConfigurations) || (p.optionConfigurations, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_CfnOptionGroup(p) {
    }
    function aws_cdk_lib_aws_rds_CfnOptionGroup_OptionConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.optionSettings) || (p.optionSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rds_CfnOptionGroup_OptionSettingProperty(p) {
    }
    function aws_cdk_lib_aws_redshift_CfnClusterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.endpoint) || (p.endpoint, void 0), visitedObjects.has(p.loggingProperties) || (p.loggingProperties, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_redshift_CfnCluster(p) {
    }
    function aws_cdk_lib_aws_redshift_CfnCluster_EndpointProperty(p) {
    }
    function aws_cdk_lib_aws_redshift_CfnCluster_LoggingPropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_redshift_CfnClusterParameterGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.parameters) || (p.parameters, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_redshift_CfnClusterParameterGroup(p) {
    }
    function aws_cdk_lib_aws_redshift_CfnClusterParameterGroup_ParameterProperty(p) {
    }
    function aws_cdk_lib_aws_redshift_CfnClusterSecurityGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_redshift_CfnClusterSecurityGroup(p) {
    }
    function aws_cdk_lib_aws_redshift_CfnClusterSecurityGroupIngressProps(p) {
    }
    function aws_cdk_lib_aws_redshift_CfnClusterSecurityGroupIngress(p) {
    }
    function aws_cdk_lib_aws_redshift_CfnClusterSubnetGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_redshift_CfnClusterSubnetGroup(p) {
    }
    function aws_cdk_lib_aws_redshift_CfnEndpointAccessProps(p) {
    }
    function aws_cdk_lib_aws_redshift_CfnEndpointAccess(p) {
    }
    function aws_cdk_lib_aws_redshift_CfnEndpointAccess_NetworkInterfaceProperty(p) {
    }
    function aws_cdk_lib_aws_redshift_CfnEndpointAccess_VpcEndpointProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.networkInterfaces) || (p.networkInterfaces, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_redshift_CfnEndpointAccess_VpcSecurityGroupProperty(p) {
    }
    function aws_cdk_lib_aws_redshift_CfnEndpointAuthorizationProps(p) {
    }
    function aws_cdk_lib_aws_redshift_CfnEndpointAuthorization(p) {
    }
    function aws_cdk_lib_aws_redshift_CfnEventSubscriptionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_redshift_CfnEventSubscription(p) {
    }
    function aws_cdk_lib_aws_redshift_CfnScheduledActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.targetAction) || (p.targetAction, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_redshift_CfnScheduledAction(p) {
    }
    function aws_cdk_lib_aws_redshift_CfnScheduledAction_PauseClusterMessageProperty(p) {
    }
    function aws_cdk_lib_aws_redshift_CfnScheduledAction_ResizeClusterMessageProperty(p) {
    }
    function aws_cdk_lib_aws_redshift_CfnScheduledAction_ResumeClusterMessageProperty(p) {
    }
    function aws_cdk_lib_aws_redshift_CfnScheduledAction_ScheduledActionTypeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.pauseCluster) || (p.pauseCluster, void 0), visitedObjects.has(p.resizeCluster) || (p.resizeCluster, void 0), visitedObjects.has(p.resumeCluster) || (p.resumeCluster, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_redshiftserverless_CfnNamespaceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_redshiftserverless_CfnNamespace(p) {
    }
    function aws_cdk_lib_aws_redshiftserverless_CfnNamespace_NamespaceProperty(p) {
    }
    function aws_cdk_lib_aws_redshiftserverless_CfnWorkgroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.configParameters) || (p.configParameters, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_redshiftserverless_CfnWorkgroup(p) {
    }
    function aws_cdk_lib_aws_redshiftserverless_CfnWorkgroup_ConfigParameterProperty(p) {
    }
    function aws_cdk_lib_aws_redshiftserverless_CfnWorkgroup_EndpointProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.vpcEndpoints) || (p.vpcEndpoints, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_redshiftserverless_CfnWorkgroup_NetworkInterfaceProperty(p) {
    }
    function aws_cdk_lib_aws_redshiftserverless_CfnWorkgroup_VpcEndpointProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.networkInterfaces) || (p.networkInterfaces, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_redshiftserverless_CfnWorkgroup_WorkgroupProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.configParameters) || (p.configParameters, void 0), visitedObjects.has(p.endpoint) || (p.endpoint, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_refactorspaces_CfnApplicationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.apiGatewayProxy) || (p.apiGatewayProxy, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_refactorspaces_CfnApplication(p) {
    }
    function aws_cdk_lib_aws_refactorspaces_CfnApplication_ApiGatewayProxyInputProperty(p) {
    }
    function aws_cdk_lib_aws_refactorspaces_CfnEnvironmentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_refactorspaces_CfnEnvironment(p) {
    }
    function aws_cdk_lib_aws_refactorspaces_CfnRouteProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.defaultRoute) || (p.defaultRoute, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.uriPathRoute) || (p.uriPathRoute, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_refactorspaces_CfnRoute(p) {
    }
    function aws_cdk_lib_aws_refactorspaces_CfnRoute_DefaultRouteInputProperty(p) {
    }
    function aws_cdk_lib_aws_refactorspaces_CfnRoute_UriPathRouteInputProperty(p) {
    }
    function aws_cdk_lib_aws_refactorspaces_CfnServiceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.lambdaEndpoint) || (p.lambdaEndpoint, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.urlEndpoint) || (p.urlEndpoint, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_refactorspaces_CfnService(p) {
    }
    function aws_cdk_lib_aws_refactorspaces_CfnService_LambdaEndpointInputProperty(p) {
    }
    function aws_cdk_lib_aws_refactorspaces_CfnService_UrlEndpointInputProperty(p) {
    }
    function aws_cdk_lib_aws_rekognition_CfnCollectionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rekognition_CfnCollection(p) {
    }
    function aws_cdk_lib_aws_rekognition_CfnProjectProps(p) {
    }
    function aws_cdk_lib_aws_rekognition_CfnProject(p) {
    }
    function aws_cdk_lib_aws_rekognition_CfnStreamProcessorProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.kinesisVideoStream) || (p.kinesisVideoStream, void 0), visitedObjects.has(p.boundingBoxRegionsOfInterest) || (p.boundingBoxRegionsOfInterest, void 0), visitedObjects.has(p.connectedHomeSettings) || (p.connectedHomeSettings, void 0), visitedObjects.has(p.dataSharingPreference) || (p.dataSharingPreference, void 0), visitedObjects.has(p.faceSearchSettings) || (p.faceSearchSettings, void 0), visitedObjects.has(p.kinesisDataStream) || (p.kinesisDataStream, void 0), visitedObjects.has(p.notificationChannel) || (p.notificationChannel, void 0), visitedObjects.has(p.s3Destination) || (p.s3Destination, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rekognition_CfnStreamProcessor(p) {
    }
    function aws_cdk_lib_aws_rekognition_CfnStreamProcessor_BoundingBoxProperty(p) {
    }
    function aws_cdk_lib_aws_rekognition_CfnStreamProcessor_ConnectedHomeSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_rekognition_CfnStreamProcessor_DataSharingPreferenceProperty(p) {
    }
    function aws_cdk_lib_aws_rekognition_CfnStreamProcessor_FaceSearchSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_rekognition_CfnStreamProcessor_KinesisDataStreamProperty(p) {
    }
    function aws_cdk_lib_aws_rekognition_CfnStreamProcessor_KinesisVideoStreamProperty(p) {
    }
    function aws_cdk_lib_aws_rekognition_CfnStreamProcessor_NotificationChannelProperty(p) {
    }
    function aws_cdk_lib_aws_rekognition_CfnStreamProcessor_S3DestinationProperty(p) {
    }
    function aws_cdk_lib_aws_resiliencehub_CfnAppProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.resourceMappings) || (p.resourceMappings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_resiliencehub_CfnApp(p) {
    }
    function aws_cdk_lib_aws_resiliencehub_CfnApp_PhysicalResourceIdProperty(p) {
    }
    function aws_cdk_lib_aws_resiliencehub_CfnApp_ResourceMappingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.physicalResourceId) || (p.physicalResourceId, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_resiliencehub_CfnResiliencyPolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.policy) || (p.policy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_resiliencehub_CfnResiliencyPolicy(p) {
    }
    function aws_cdk_lib_aws_resiliencehub_CfnResiliencyPolicy_FailurePolicyProperty(p) {
    }
    function aws_cdk_lib_aws_resourceexplorer2_CfnDefaultViewAssociationProps(p) {
    }
    function aws_cdk_lib_aws_resourceexplorer2_CfnDefaultViewAssociation(p) {
    }
    function aws_cdk_lib_aws_resourceexplorer2_CfnIndexProps(p) {
    }
    function aws_cdk_lib_aws_resourceexplorer2_CfnIndex(p) {
    }
    function aws_cdk_lib_aws_resourceexplorer2_CfnViewProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.filters) || (p.filters, void 0), visitedObjects.has(p.includedProperties) || (p.includedProperties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_resourceexplorer2_CfnView(p) {
    }
    function aws_cdk_lib_aws_resourceexplorer2_CfnView_FiltersProperty(p) {
    }
    function aws_cdk_lib_aws_resourceexplorer2_CfnView_IncludedPropertyProperty(p) {
    }
    function aws_cdk_lib_aws_resourcegroups_CfnGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.configuration) || (p.configuration, void 0), visitedObjects.has(p.resourceQuery) || (p.resourceQuery, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_resourcegroups_CfnGroup(p) {
    }
    function aws_cdk_lib_aws_resourcegroups_CfnGroup_ConfigurationItemProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.parameters) || (p.parameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_resourcegroups_CfnGroup_ConfigurationParameterProperty(p) {
    }
    function aws_cdk_lib_aws_resourcegroups_CfnGroup_QueryProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tagFilters) || (p.tagFilters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_resourcegroups_CfnGroup_ResourceQueryProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.query) || (p.query, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_resourcegroups_CfnGroup_TagFilterProperty(p) {
    }
    function aws_cdk_lib_aws_robomaker_CfnFleetProps(p) {
    }
    function aws_cdk_lib_aws_robomaker_CfnFleet(p) {
    }
    function aws_cdk_lib_aws_robomaker_CfnRobotProps(p) {
    }
    function aws_cdk_lib_aws_robomaker_CfnRobot(p) {
    }
    function aws_cdk_lib_aws_robomaker_CfnRobotApplicationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.robotSoftwareSuite) || (p.robotSoftwareSuite, void 0), visitedObjects.has(p.sources) || (p.sources, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_robomaker_CfnRobotApplication(p) {
    }
    function aws_cdk_lib_aws_robomaker_CfnRobotApplication_RobotSoftwareSuiteProperty(p) {
    }
    function aws_cdk_lib_aws_robomaker_CfnRobotApplication_SourceConfigProperty(p) {
    }
    function aws_cdk_lib_aws_robomaker_CfnRobotApplicationVersionProps(p) {
    }
    function aws_cdk_lib_aws_robomaker_CfnRobotApplicationVersion(p) {
    }
    function aws_cdk_lib_aws_robomaker_CfnSimulationApplicationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.robotSoftwareSuite) || (p.robotSoftwareSuite, void 0), visitedObjects.has(p.simulationSoftwareSuite) || (p.simulationSoftwareSuite, void 0), visitedObjects.has(p.renderingEngine) || (p.renderingEngine, void 0), visitedObjects.has(p.sources) || (p.sources, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_robomaker_CfnSimulationApplication(p) {
    }
    function aws_cdk_lib_aws_robomaker_CfnSimulationApplication_RenderingEngineProperty(p) {
    }
    function aws_cdk_lib_aws_robomaker_CfnSimulationApplication_RobotSoftwareSuiteProperty(p) {
    }
    function aws_cdk_lib_aws_robomaker_CfnSimulationApplication_SimulationSoftwareSuiteProperty(p) {
    }
    function aws_cdk_lib_aws_robomaker_CfnSimulationApplication_SourceConfigProperty(p) {
    }
    function aws_cdk_lib_aws_robomaker_CfnSimulationApplicationVersionProps(p) {
    }
    function aws_cdk_lib_aws_robomaker_CfnSimulationApplicationVersion(p) {
    }
    function aws_cdk_lib_aws_rolesanywhere_CfnCRLProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rolesanywhere_CfnCRL(p) {
    }
    function aws_cdk_lib_aws_rolesanywhere_CfnProfileProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rolesanywhere_CfnProfile(p) {
    }
    function aws_cdk_lib_aws_rolesanywhere_CfnTrustAnchorProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.source) || (p.source, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rolesanywhere_CfnTrustAnchor(p) {
    }
    function aws_cdk_lib_aws_rolesanywhere_CfnTrustAnchor_SourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sourceData) || (p.sourceData, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rolesanywhere_CfnTrustAnchor_SourceDataProperty(p) {
    }
    function aws_cdk_lib_aws_route53_IAliasRecordTarget(p) {
    }
    function aws_cdk_lib_aws_route53_AliasRecordTargetConfig(p) {
    }
    function aws_cdk_lib_aws_route53_CommonHostedZoneProps(p) {
    }
    function aws_cdk_lib_aws_route53_HostedZoneProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.vpcs != null)
            for (const o of p.vpcs)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53_HostedZone(p) {
    }
    function aws_cdk_lib_aws_route53_PublicHostedZoneProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          "crossAccountZoneDelegationPrincipal" in p && print("aws-cdk-lib.aws_route53.PublicHostedZoneProps#crossAccountZoneDelegationPrincipal", "Create the Role yourself and call `hostedZone.grantDelegation()`."), visitedObjects.has(p.crossAccountZoneDelegationPrincipal) || (p.crossAccountZoneDelegationPrincipal, void 0), "crossAccountZoneDelegationRoleName" in p && print("aws-cdk-lib.aws_route53.PublicHostedZoneProps#crossAccountZoneDelegationRoleName", "Create the Role yourself and call `hostedZone.grantDelegation()`.");
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53_IPublicHostedZone(p) {
    }
    function aws_cdk_lib_aws_route53_PublicHostedZone(p) {
    }
    function aws_cdk_lib_aws_route53_ZoneDelegationOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ttl) || (p.ttl, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53_PrivateHostedZoneProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53_IPrivateHostedZone(p) {
    }
    function aws_cdk_lib_aws_route53_PrivateHostedZone(p) {
    }
    function aws_cdk_lib_aws_route53_HostedZoneProviderProps(p) {
    }
    function aws_cdk_lib_aws_route53_IHostedZone(p) {
    }
    function aws_cdk_lib_aws_route53_HostedZoneAttributes(p) {
    }
    function aws_cdk_lib_aws_route53_PublicHostedZoneAttributes(p) {
    }
    function aws_cdk_lib_aws_route53_IRecordSet(p) {
    }
    function aws_cdk_lib_aws_route53_RecordType(p) {
    }
    function aws_cdk_lib_aws_route53_RecordSetOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.zone) || (p.zone, void 0), visitedObjects.has(p.ttl) || (p.ttl, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53_RecordTarget(p) {
    }
    function aws_cdk_lib_aws_route53_RecordSetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.recordType) || (p.recordType, void 0), visitedObjects.has(p.target) || (p.target, void 0), visitedObjects.has(p.zone) || (p.zone, void 0), visitedObjects.has(p.ttl) || (p.ttl, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53_RecordSet(p) {
    }
    function aws_cdk_lib_aws_route53_ARecordProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.target) || (p.target, void 0), visitedObjects.has(p.zone) || (p.zone, void 0), visitedObjects.has(p.ttl) || (p.ttl, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53_ARecord(p) {
    }
    function aws_cdk_lib_aws_route53_AaaaRecordProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.target) || (p.target, void 0), visitedObjects.has(p.zone) || (p.zone, void 0), visitedObjects.has(p.ttl) || (p.ttl, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53_AaaaRecord(p) {
    }
    function aws_cdk_lib_aws_route53_CnameRecordProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.zone) || (p.zone, void 0), visitedObjects.has(p.ttl) || (p.ttl, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53_CnameRecord(p) {
    }
    function aws_cdk_lib_aws_route53_TxtRecordProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.zone) || (p.zone, void 0), visitedObjects.has(p.ttl) || (p.ttl, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53_TxtRecord(p) {
    }
    function aws_cdk_lib_aws_route53_SrvRecordValue(p) {
    }
    function aws_cdk_lib_aws_route53_SrvRecordProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.values != null)
            for (const o of p.values)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.zone) || (p.zone, void 0), visitedObjects.has(p.ttl) || (p.ttl, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53_SrvRecord(p) {
    }
    function aws_cdk_lib_aws_route53_CaaTag(p) {
    }
    function aws_cdk_lib_aws_route53_CaaRecordValue(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tag) || (p.tag, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53_CaaRecordProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.values != null)
            for (const o of p.values)
              visitedObjects.has(o) || aws_cdk_lib_aws_route53_CaaRecordValue(o);
          visitedObjects.has(p.zone) || (p.zone, void 0), visitedObjects.has(p.ttl) || (p.ttl, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53_CaaRecord(p) {
    }
    function aws_cdk_lib_aws_route53_CaaAmazonRecordProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.zone) || (p.zone, void 0), visitedObjects.has(p.ttl) || (p.ttl, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53_CaaAmazonRecord(p) {
    }
    function aws_cdk_lib_aws_route53_MxRecordValue(p) {
    }
    function aws_cdk_lib_aws_route53_MxRecordProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.values != null)
            for (const o of p.values)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.zone) || (p.zone, void 0), visitedObjects.has(p.ttl) || (p.ttl, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53_MxRecord(p) {
    }
    function aws_cdk_lib_aws_route53_NsRecordProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.zone) || (p.zone, void 0), visitedObjects.has(p.ttl) || (p.ttl, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53_NsRecord(p) {
    }
    function aws_cdk_lib_aws_route53_DsRecordProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.zone) || (p.zone, void 0), visitedObjects.has(p.ttl) || (p.ttl, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53_DsRecord(p) {
    }
    function aws_cdk_lib_aws_route53_ZoneDelegationRecordProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.zone) || (p.zone, void 0), visitedObjects.has(p.ttl) || (p.ttl, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53_ZoneDelegationRecord(p) {
    }
    function aws_cdk_lib_aws_route53_CrossAccountZoneDelegationRecordProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.delegatedZone) || (p.delegatedZone, void 0), visitedObjects.has(p.delegationRole) || (p.delegationRole, void 0), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), visitedObjects.has(p.ttl) || (p.ttl, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53_CrossAccountZoneDelegationRecord(p) {
    }
    function aws_cdk_lib_aws_route53_VpcEndpointServiceDomainNameProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.endpointService) || (p.endpointService, void 0), visitedObjects.has(p.publicHostedZone) || (p.publicHostedZone, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53_VpcEndpointServiceDomainName(p) {
    }
    function aws_cdk_lib_aws_route53_CfnCidrCollectionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.locations) || (p.locations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53_CfnCidrCollection(p) {
    }
    function aws_cdk_lib_aws_route53_CfnCidrCollection_LocationProperty(p) {
    }
    function aws_cdk_lib_aws_route53_CfnDNSSECProps(p) {
    }
    function aws_cdk_lib_aws_route53_CfnDNSSEC(p) {
    }
    function aws_cdk_lib_aws_route53_CfnHealthCheckProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.healthCheckConfig) || (p.healthCheckConfig, void 0), visitedObjects.has(p.healthCheckTags) || (p.healthCheckTags, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53_CfnHealthCheck(p) {
    }
    function aws_cdk_lib_aws_route53_CfnHealthCheck_AlarmIdentifierProperty(p) {
    }
    function aws_cdk_lib_aws_route53_CfnHealthCheck_HealthCheckConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.alarmIdentifier) || (p.alarmIdentifier, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53_CfnHealthCheck_HealthCheckTagProperty(p) {
    }
    function aws_cdk_lib_aws_route53_CfnHostedZoneProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.hostedZoneConfig) || (p.hostedZoneConfig, void 0), p.hostedZoneTags != null)
            for (const o of p.hostedZoneTags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.queryLoggingConfig) || (p.queryLoggingConfig, void 0), visitedObjects.has(p.vpcs) || (p.vpcs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53_CfnHostedZone(p) {
    }
    function aws_cdk_lib_aws_route53_CfnHostedZone_HostedZoneConfigProperty(p) {
    }
    function aws_cdk_lib_aws_route53_CfnHostedZone_HostedZoneTagProperty(p) {
    }
    function aws_cdk_lib_aws_route53_CfnHostedZone_QueryLoggingConfigProperty(p) {
    }
    function aws_cdk_lib_aws_route53_CfnHostedZone_VPCProperty(p) {
    }
    function aws_cdk_lib_aws_route53_CfnKeySigningKeyProps(p) {
    }
    function aws_cdk_lib_aws_route53_CfnKeySigningKey(p) {
    }
    function aws_cdk_lib_aws_route53_CfnRecordSetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.aliasTarget) || (p.aliasTarget, void 0), visitedObjects.has(p.cidrRoutingConfig) || (p.cidrRoutingConfig, void 0), visitedObjects.has(p.geoLocation) || (p.geoLocation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53_CfnRecordSet(p) {
    }
    function aws_cdk_lib_aws_route53_CfnRecordSet_AliasTargetProperty(p) {
    }
    function aws_cdk_lib_aws_route53_CfnRecordSet_CidrRoutingConfigProperty(p) {
    }
    function aws_cdk_lib_aws_route53_CfnRecordSet_GeoLocationProperty(p) {
    }
    function aws_cdk_lib_aws_route53_CfnRecordSetGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.recordSets) || (p.recordSets, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53_CfnRecordSetGroup(p) {
    }
    function aws_cdk_lib_aws_route53_CfnRecordSetGroup_AliasTargetProperty(p) {
    }
    function aws_cdk_lib_aws_route53_CfnRecordSetGroup_CidrRoutingConfigProperty(p) {
    }
    function aws_cdk_lib_aws_route53_CfnRecordSetGroup_GeoLocationProperty(p) {
    }
    function aws_cdk_lib_aws_route53_CfnRecordSetGroup_RecordSetProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.aliasTarget) || (p.aliasTarget, void 0), visitedObjects.has(p.cidrRoutingConfig) || (p.cidrRoutingConfig, void 0), visitedObjects.has(p.geoLocation) || (p.geoLocation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53_patterns_HttpsRedirectProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.zone) || (p.zone, void 0), visitedObjects.has(p.certificate) || (p.certificate, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53_patterns_HttpsRedirect(p) {
    }
    function aws_cdk_lib_aws_route53_targets_ApiGatewayDomain(p) {
    }
    function aws_cdk_lib_aws_route53_targets_ApiGateway(p) {
    }
    function aws_cdk_lib_aws_route53_targets_ApiGatewayv2DomainProperties(p) {
    }
    function aws_cdk_lib_aws_route53_targets_BucketWebsiteTarget(p) {
    }
    function aws_cdk_lib_aws_route53_targets_ElasticBeanstalkEnvironmentEndpointTarget(p) {
    }
    function aws_cdk_lib_aws_route53_targets_ClassicLoadBalancerTarget(p) {
    }
    function aws_cdk_lib_aws_route53_targets_CloudFrontTarget(p) {
    }
    function aws_cdk_lib_aws_route53_targets_LoadBalancerTarget(p) {
    }
    function aws_cdk_lib_aws_route53_targets_InterfaceVpcEndpointTarget(p) {
    }
    function aws_cdk_lib_aws_route53_targets_UserPoolDomainTarget(p) {
    }
    function aws_cdk_lib_aws_route53_targets_GlobalAcceleratorDomainTarget(p) {
    }
    function aws_cdk_lib_aws_route53_targets_GlobalAcceleratorTarget(p) {
    }
    function aws_cdk_lib_aws_route53_targets_Route53RecordTarget(p) {
    }
    function aws_cdk_lib_aws_route53recoverycontrol_CfnClusterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53recoverycontrol_CfnCluster(p) {
    }
    function aws_cdk_lib_aws_route53recoverycontrol_CfnCluster_ClusterEndpointProperty(p) {
    }
    function aws_cdk_lib_aws_route53recoverycontrol_CfnControlPanelProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53recoverycontrol_CfnControlPanel(p) {
    }
    function aws_cdk_lib_aws_route53recoverycontrol_CfnRoutingControlProps(p) {
    }
    function aws_cdk_lib_aws_route53recoverycontrol_CfnRoutingControl(p) {
    }
    function aws_cdk_lib_aws_route53recoverycontrol_CfnSafetyRuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.ruleConfig) || (p.ruleConfig, void 0), visitedObjects.has(p.assertionRule) || (p.assertionRule, void 0), visitedObjects.has(p.gatingRule) || (p.gatingRule, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53recoverycontrol_CfnSafetyRule(p) {
    }
    function aws_cdk_lib_aws_route53recoverycontrol_CfnSafetyRule_AssertionRuleProperty(p) {
    }
    function aws_cdk_lib_aws_route53recoverycontrol_CfnSafetyRule_GatingRuleProperty(p) {
    }
    function aws_cdk_lib_aws_route53recoverycontrol_CfnSafetyRule_RuleConfigProperty(p) {
    }
    function aws_cdk_lib_aws_route53recoveryreadiness_CfnCellProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53recoveryreadiness_CfnCell(p) {
    }
    function aws_cdk_lib_aws_route53recoveryreadiness_CfnReadinessCheckProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53recoveryreadiness_CfnReadinessCheck(p) {
    }
    function aws_cdk_lib_aws_route53recoveryreadiness_CfnRecoveryGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53recoveryreadiness_CfnRecoveryGroup(p) {
    }
    function aws_cdk_lib_aws_route53recoveryreadiness_CfnResourceSetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.resources) || (p.resources, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53recoveryreadiness_CfnResourceSet(p) {
    }
    function aws_cdk_lib_aws_route53recoveryreadiness_CfnResourceSet_DNSTargetResourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.targetResource) || (p.targetResource, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53recoveryreadiness_CfnResourceSet_NLBResourceProperty(p) {
    }
    function aws_cdk_lib_aws_route53recoveryreadiness_CfnResourceSet_R53ResourceRecordProperty(p) {
    }
    function aws_cdk_lib_aws_route53recoveryreadiness_CfnResourceSet_ResourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dnsTargetResource) || (p.dnsTargetResource, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53recoveryreadiness_CfnResourceSet_TargetResourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.nlbResource) || (p.nlbResource, void 0), visitedObjects.has(p.r53Resource) || (p.r53Resource, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53resolver_CfnFirewallDomainListProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53resolver_CfnFirewallDomainList(p) {
    }
    function aws_cdk_lib_aws_route53resolver_CfnFirewallRuleGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.firewallRules) || (p.firewallRules, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53resolver_CfnFirewallRuleGroup(p) {
    }
    function aws_cdk_lib_aws_route53resolver_CfnFirewallRuleGroup_FirewallRuleProperty(p) {
    }
    function aws_cdk_lib_aws_route53resolver_CfnFirewallRuleGroupAssociationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53resolver_CfnFirewallRuleGroupAssociation(p) {
    }
    function aws_cdk_lib_aws_route53resolver_CfnResolverConfigProps(p) {
    }
    function aws_cdk_lib_aws_route53resolver_CfnResolverConfig(p) {
    }
    function aws_cdk_lib_aws_route53resolver_CfnResolverDNSSECConfigProps(p) {
    }
    function aws_cdk_lib_aws_route53resolver_CfnResolverDNSSECConfig(p) {
    }
    function aws_cdk_lib_aws_route53resolver_CfnResolverEndpointProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.ipAddresses) || (p.ipAddresses, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53resolver_CfnResolverEndpoint(p) {
    }
    function aws_cdk_lib_aws_route53resolver_CfnResolverEndpoint_IpAddressRequestProperty(p) {
    }
    function aws_cdk_lib_aws_route53resolver_CfnResolverQueryLoggingConfigProps(p) {
    }
    function aws_cdk_lib_aws_route53resolver_CfnResolverQueryLoggingConfig(p) {
    }
    function aws_cdk_lib_aws_route53resolver_CfnResolverQueryLoggingConfigAssociationProps(p) {
    }
    function aws_cdk_lib_aws_route53resolver_CfnResolverQueryLoggingConfigAssociation(p) {
    }
    function aws_cdk_lib_aws_route53resolver_CfnResolverRuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.targetIps) || (p.targetIps, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_route53resolver_CfnResolverRule(p) {
    }
    function aws_cdk_lib_aws_route53resolver_CfnResolverRule_TargetAddressProperty(p) {
    }
    function aws_cdk_lib_aws_route53resolver_CfnResolverRuleAssociationProps(p) {
    }
    function aws_cdk_lib_aws_route53resolver_CfnResolverRuleAssociation(p) {
    }
    function aws_cdk_lib_aws_rum_CfnAppMonitorProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.appMonitorConfiguration) || (p.appMonitorConfiguration, void 0), visitedObjects.has(p.customEvents) || (p.customEvents, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rum_CfnAppMonitor(p) {
    }
    function aws_cdk_lib_aws_rum_CfnAppMonitor_AppMonitorConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.metricDestinations) || (p.metricDestinations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rum_CfnAppMonitor_CustomEventsProperty(p) {
    }
    function aws_cdk_lib_aws_rum_CfnAppMonitor_MetricDefinitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dimensionKeys) || (p.dimensionKeys, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_rum_CfnAppMonitor_MetricDestinationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.metricDefinitions) || (p.metricDefinitions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_IBucket(p) {
    }
    function aws_cdk_lib_aws_s3_BucketAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          "bucketWebsiteNewUrlFormat" in p && print("aws-cdk-lib.aws_s3.BucketAttributes#bucketWebsiteNewUrlFormat", "The correct website url format can be inferred automatically from the bucket `region`.\nAlways provide the bucket region if the `bucketWebsiteUrl` will be used.\nAlternatively provide the full `bucketWebsiteUrl` manually."), visitedObjects.has(p.encryptionKey) || (p.encryptionKey, void 0), visitedObjects.has(p.notificationsHandlerRole) || (p.notificationsHandlerRole, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_BucketBase(p) {
    }
    function aws_cdk_lib_aws_s3_BlockPublicAccessOptions(p) {
    }
    function aws_cdk_lib_aws_s3_BlockPublicAccess(p) {
    }
    function aws_cdk_lib_aws_s3_BucketMetrics(p) {
    }
    function aws_cdk_lib_aws_s3_HttpMethods(p) {
    }
    function aws_cdk_lib_aws_s3_CorsRule(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.allowedMethods != null)
            for (const o of p.allowedMethods)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_RedirectProtocol(p) {
    }
    function aws_cdk_lib_aws_s3_RedirectTarget(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.protocol) || (p.protocol, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_InventoryFormat(p) {
    }
    function aws_cdk_lib_aws_s3_InventoryFrequency(p) {
    }
    function aws_cdk_lib_aws_s3_InventoryObjectVersion(p) {
    }
    function aws_cdk_lib_aws_s3_InventoryDestination(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bucket) || (p.bucket, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_Inventory(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destination) || aws_cdk_lib_aws_s3_InventoryDestination(p.destination), visitedObjects.has(p.format) || (p.format, void 0), visitedObjects.has(p.frequency) || (p.frequency, void 0), visitedObjects.has(p.includeObjectVersions) || (p.includeObjectVersions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_ObjectOwnership(p) {
    }
    function aws_cdk_lib_aws_s3_IntelligentTieringConfiguration(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.archiveAccessTierTime) || (p.archiveAccessTierTime, void 0), visitedObjects.has(p.deepArchiveAccessTierTime) || (p.deepArchiveAccessTierTime, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_BucketProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.accessControl) || (p.accessControl, void 0), visitedObjects.has(p.blockPublicAccess) || (p.blockPublicAccess, void 0), p.cors != null)
            for (const o of p.cors)
              visitedObjects.has(o) || aws_cdk_lib_aws_s3_CorsRule(o);
          if (visitedObjects.has(p.encryption) || aws_cdk_lib_aws_s3_BucketEncryption(p.encryption), visitedObjects.has(p.encryptionKey) || (p.encryptionKey, void 0), p.intelligentTieringConfigurations != null)
            for (const o of p.intelligentTieringConfigurations)
              visitedObjects.has(o) || aws_cdk_lib_aws_s3_IntelligentTieringConfiguration(o);
          if (p.inventories != null)
            for (const o of p.inventories)
              visitedObjects.has(o) || aws_cdk_lib_aws_s3_Inventory(o);
          if (p.lifecycleRules != null)
            for (const o of p.lifecycleRules)
              visitedObjects.has(o) || aws_cdk_lib_aws_s3_LifecycleRule(o);
          if (p.metrics != null)
            for (const o of p.metrics)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.notificationsHandlerRole) || (p.notificationsHandlerRole, void 0), visitedObjects.has(p.objectLockDefaultRetention) || (p.objectLockDefaultRetention, void 0), visitedObjects.has(p.objectOwnership) || (p.objectOwnership, void 0), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), visitedObjects.has(p.serverAccessLogsBucket) || (p.serverAccessLogsBucket, void 0), visitedObjects.has(p.websiteRedirect) || aws_cdk_lib_aws_s3_RedirectTarget(p.websiteRedirect), p.websiteRoutingRules != null)
            for (const o of p.websiteRoutingRules)
              visitedObjects.has(o) || aws_cdk_lib_aws_s3_RoutingRule(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_Tag(p) {
    }
    function aws_cdk_lib_aws_s3_Bucket(p) {
    }
    function aws_cdk_lib_aws_s3_BucketEncryption(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          const ns = require_bucket();
          if (Object.values(ns.BucketEncryption).filter((x) => x === p).length > 1)
            return;
          p === ns.BucketEncryption.UNENCRYPTED && print("aws-cdk-lib.aws_s3.BucketEncryption#UNENCRYPTED", `S3 applies server-side encryption with SSE-S3 for every bucket
that default encryption is not configured.`);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_EventType(p) {
    }
    function aws_cdk_lib_aws_s3_NotificationKeyFilter(p) {
    }
    function aws_cdk_lib_aws_s3_OnCloudTrailBucketEventOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.target) || (p.target, void 0), visitedObjects.has(p.eventPattern) || (p.eventPattern, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_BucketAccessControl(p) {
    }
    function aws_cdk_lib_aws_s3_RoutingRuleCondition(p) {
    }
    function aws_cdk_lib_aws_s3_ReplaceKey(p) {
    }
    function aws_cdk_lib_aws_s3_RoutingRule(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.condition) || (p.condition, void 0), visitedObjects.has(p.protocol) || (p.protocol, void 0), visitedObjects.has(p.replaceKey) || (p.replaceKey, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_ObjectLockMode(p) {
    }
    function aws_cdk_lib_aws_s3_ObjectLockRetention(p) {
    }
    function aws_cdk_lib_aws_s3_VirtualHostedStyleUrlOptions(p) {
    }
    function aws_cdk_lib_aws_s3_TransferAccelerationUrlOptions(p) {
    }
    function aws_cdk_lib_aws_s3_BucketPolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bucket) || (p.bucket, void 0), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_BucketPolicy(p) {
    }
    function aws_cdk_lib_aws_s3_IBucketNotificationDestination(p) {
    }
    function aws_cdk_lib_aws_s3_BucketNotificationDestinationConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.type) || (p.type, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_BucketNotificationDestinationType(p) {
    }
    function aws_cdk_lib_aws_s3_Location(p) {
    }
    function aws_cdk_lib_aws_s3_LifecycleRule(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.abortIncompleteMultipartUploadAfter) || (p.abortIncompleteMultipartUploadAfter, void 0), visitedObjects.has(p.expiration) || (p.expiration, void 0), visitedObjects.has(p.noncurrentVersionExpiration) || (p.noncurrentVersionExpiration, void 0), p.noncurrentVersionTransitions != null)
            for (const o of p.noncurrentVersionTransitions)
              visitedObjects.has(o) || aws_cdk_lib_aws_s3_NoncurrentVersionTransition(o);
          if (p.transitions != null)
            for (const o of p.transitions)
              visitedObjects.has(o) || aws_cdk_lib_aws_s3_Transition(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_Transition(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.storageClass) || (p.storageClass, void 0), visitedObjects.has(p.transitionAfter) || (p.transitionAfter, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_NoncurrentVersionTransition(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.storageClass) || (p.storageClass, void 0), visitedObjects.has(p.transitionAfter) || (p.transitionAfter, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_StorageClass(p) {
    }
    function aws_cdk_lib_aws_s3_CfnAccessPointProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.publicAccessBlockConfiguration) || (p.publicAccessBlockConfiguration, void 0), visitedObjects.has(p.vpcConfiguration) || (p.vpcConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnAccessPoint(p) {
    }
    function aws_cdk_lib_aws_s3_CfnAccessPoint_PolicyStatusProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnAccessPoint_PublicAccessBlockConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnAccessPoint_VpcConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnBucketProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.accelerateConfiguration) || (p.accelerateConfiguration, void 0), visitedObjects.has(p.analyticsConfigurations) || (p.analyticsConfigurations, void 0), visitedObjects.has(p.bucketEncryption) || (p.bucketEncryption, void 0), visitedObjects.has(p.corsConfiguration) || (p.corsConfiguration, void 0), visitedObjects.has(p.intelligentTieringConfigurations) || (p.intelligentTieringConfigurations, void 0), visitedObjects.has(p.inventoryConfigurations) || (p.inventoryConfigurations, void 0), visitedObjects.has(p.lifecycleConfiguration) || (p.lifecycleConfiguration, void 0), visitedObjects.has(p.loggingConfiguration) || (p.loggingConfiguration, void 0), visitedObjects.has(p.metricsConfigurations) || (p.metricsConfigurations, void 0), visitedObjects.has(p.notificationConfiguration) || (p.notificationConfiguration, void 0), visitedObjects.has(p.objectLockConfiguration) || (p.objectLockConfiguration, void 0), visitedObjects.has(p.ownershipControls) || (p.ownershipControls, void 0), visitedObjects.has(p.publicAccessBlockConfiguration) || (p.publicAccessBlockConfiguration, void 0), visitedObjects.has(p.replicationConfiguration) || (p.replicationConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.versioningConfiguration) || (p.versioningConfiguration, void 0), visitedObjects.has(p.websiteConfiguration) || (p.websiteConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucket(p) {
    }
    function aws_cdk_lib_aws_s3_CfnBucket_AbortIncompleteMultipartUploadProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnBucket_AccelerateConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnBucket_AccessControlTranslationProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnBucket_AnalyticsConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.storageClassAnalysis) || (p.storageClassAnalysis, void 0), visitedObjects.has(p.tagFilters) || (p.tagFilters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucket_BucketEncryptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.serverSideEncryptionConfiguration) || (p.serverSideEncryptionConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucket_CorsConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.corsRules) || (p.corsRules, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucket_CorsRuleProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnBucket_DataExportProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destination) || (p.destination, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucket_DefaultRetentionProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnBucket_DeleteMarkerReplicationProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnBucket_DestinationProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnBucket_EncryptionConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnBucket_EventBridgeConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnBucket_FilterRuleProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnBucket_IntelligentTieringConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tierings) || (p.tierings, void 0), visitedObjects.has(p.tagFilters) || (p.tagFilters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucket_InventoryConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destination) || (p.destination, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucket_LambdaConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.filter) || (p.filter, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucket_LifecycleConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.rules) || (p.rules, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucket_LoggingConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnBucket_MetricsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.eventThreshold) || (p.eventThreshold, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucket_MetricsConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tagFilters) || (p.tagFilters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucket_NoncurrentVersionExpirationProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnBucket_NoncurrentVersionTransitionProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnBucket_NotificationConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.eventBridgeConfiguration) || (p.eventBridgeConfiguration, void 0), visitedObjects.has(p.lambdaConfigurations) || (p.lambdaConfigurations, void 0), visitedObjects.has(p.queueConfigurations) || (p.queueConfigurations, void 0), visitedObjects.has(p.topicConfigurations) || (p.topicConfigurations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucket_NotificationFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3Key) || (p.s3Key, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucket_ObjectLockConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.rule) || (p.rule, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucket_ObjectLockRuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultRetention) || (p.defaultRetention, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucket_OwnershipControlsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.rules) || (p.rules, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucket_OwnershipControlsRuleProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnBucket_PublicAccessBlockConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnBucket_QueueConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.filter) || (p.filter, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucket_RedirectAllRequestsToProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnBucket_RedirectRuleProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnBucket_ReplicaModificationsProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnBucket_ReplicationConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.rules) || (p.rules, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucket_ReplicationDestinationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.accessControlTranslation) || (p.accessControlTranslation, void 0), visitedObjects.has(p.encryptionConfiguration) || (p.encryptionConfiguration, void 0), visitedObjects.has(p.metrics) || (p.metrics, void 0), visitedObjects.has(p.replicationTime) || (p.replicationTime, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucket_ReplicationRuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destination) || (p.destination, void 0), visitedObjects.has(p.deleteMarkerReplication) || (p.deleteMarkerReplication, void 0), visitedObjects.has(p.filter) || (p.filter, void 0), visitedObjects.has(p.sourceSelectionCriteria) || (p.sourceSelectionCriteria, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucket_ReplicationRuleAndOperatorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tagFilters) || (p.tagFilters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucket_ReplicationRuleFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.and) || (p.and, void 0), visitedObjects.has(p.tagFilter) || (p.tagFilter, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucket_ReplicationTimeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.time) || (p.time, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucket_ReplicationTimeValueProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnBucket_RoutingRuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.redirectRule) || (p.redirectRule, void 0), visitedObjects.has(p.routingRuleCondition) || (p.routingRuleCondition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucket_RoutingRuleConditionProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnBucket_RuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.abortIncompleteMultipartUpload) || (p.abortIncompleteMultipartUpload, void 0), visitedObjects.has(p.expirationDate) || (p.expirationDate, void 0), visitedObjects.has(p.noncurrentVersionExpiration) || (p.noncurrentVersionExpiration, void 0), visitedObjects.has(p.noncurrentVersionTransition) || (p.noncurrentVersionTransition, void 0), visitedObjects.has(p.noncurrentVersionTransitions) || (p.noncurrentVersionTransitions, void 0), visitedObjects.has(p.tagFilters) || (p.tagFilters, void 0), visitedObjects.has(p.transition) || (p.transition, void 0), visitedObjects.has(p.transitions) || (p.transitions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucket_S3KeyFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.rules) || (p.rules, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucket_ServerSideEncryptionByDefaultProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnBucket_ServerSideEncryptionRuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.serverSideEncryptionByDefault) || (p.serverSideEncryptionByDefault, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucket_SourceSelectionCriteriaProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.replicaModifications) || (p.replicaModifications, void 0), visitedObjects.has(p.sseKmsEncryptedObjects) || (p.sseKmsEncryptedObjects, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucket_SseKmsEncryptedObjectsProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnBucket_StorageClassAnalysisProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataExport) || (p.dataExport, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucket_TagFilterProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnBucket_TieringProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnBucket_TopicConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.filter) || (p.filter, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucket_TransitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.transitionDate) || (p.transitionDate, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucket_VersioningConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnBucket_WebsiteConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.redirectAllRequestsTo) || (p.redirectAllRequestsTo, void 0), visitedObjects.has(p.routingRules) || (p.routingRules, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnBucketPolicyProps(p) {
    }
    function aws_cdk_lib_aws_s3_CfnBucketPolicy(p) {
    }
    function aws_cdk_lib_aws_s3_CfnMultiRegionAccessPointProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.regions) || (p.regions, void 0), visitedObjects.has(p.publicAccessBlockConfiguration) || (p.publicAccessBlockConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnMultiRegionAccessPoint(p) {
    }
    function aws_cdk_lib_aws_s3_CfnMultiRegionAccessPoint_PublicAccessBlockConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnMultiRegionAccessPoint_RegionProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnMultiRegionAccessPointPolicyProps(p) {
    }
    function aws_cdk_lib_aws_s3_CfnMultiRegionAccessPointPolicy(p) {
    }
    function aws_cdk_lib_aws_s3_CfnMultiRegionAccessPointPolicy_PolicyStatusProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnStorageLensProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.storageLensConfiguration) || (p.storageLensConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnStorageLens(p) {
    }
    function aws_cdk_lib_aws_s3_CfnStorageLens_AccountLevelProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bucketLevel) || (p.bucketLevel, void 0), visitedObjects.has(p.activityMetrics) || (p.activityMetrics, void 0), visitedObjects.has(p.advancedCostOptimizationMetrics) || (p.advancedCostOptimizationMetrics, void 0), visitedObjects.has(p.advancedDataProtectionMetrics) || (p.advancedDataProtectionMetrics, void 0), visitedObjects.has(p.detailedStatusCodesMetrics) || (p.detailedStatusCodesMetrics, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnStorageLens_ActivityMetricsProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnStorageLens_AdvancedCostOptimizationMetricsProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnStorageLens_AdvancedDataProtectionMetricsProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnStorageLens_AwsOrgProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnStorageLens_BucketLevelProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.activityMetrics) || (p.activityMetrics, void 0), visitedObjects.has(p.advancedCostOptimizationMetrics) || (p.advancedCostOptimizationMetrics, void 0), visitedObjects.has(p.advancedDataProtectionMetrics) || (p.advancedDataProtectionMetrics, void 0), visitedObjects.has(p.detailedStatusCodesMetrics) || (p.detailedStatusCodesMetrics, void 0), visitedObjects.has(p.prefixLevel) || (p.prefixLevel, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnStorageLens_BucketsAndRegionsProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnStorageLens_CloudWatchMetricsProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnStorageLens_DataExportProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cloudWatchMetrics) || (p.cloudWatchMetrics, void 0), visitedObjects.has(p.s3BucketDestination) || (p.s3BucketDestination, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnStorageLens_DetailedStatusCodesMetricsProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnStorageLens_EncryptionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ssekms) || (p.ssekms, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnStorageLens_PrefixLevelProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.storageMetrics) || (p.storageMetrics, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnStorageLens_PrefixLevelStorageMetricsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.selectionCriteria) || (p.selectionCriteria, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnStorageLens_S3BucketDestinationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.encryption) || (p.encryption, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_CfnStorageLens_SSEKMSProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnStorageLens_SelectionCriteriaProperty(p) {
    }
    function aws_cdk_lib_aws_s3_CfnStorageLens_StorageLensConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.accountLevel) || (p.accountLevel, void 0), visitedObjects.has(p.awsOrg) || (p.awsOrg, void 0), visitedObjects.has(p.dataExport) || (p.dataExport, void 0), visitedObjects.has(p.exclude) || (p.exclude, void 0), visitedObjects.has(p.include) || (p.include, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_assets_AssetOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.readers != null)
            for (const o of p.readers)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.assetHashType) || (p.assetHashType, void 0), visitedObjects.has(p.bundling) || aws_cdk_lib_BundlingOptions(p.bundling), visitedObjects.has(p.followSymlinks) || (p.followSymlinks, void 0), visitedObjects.has(p.ignoreMode) || (p.ignoreMode, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_assets_AssetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.readers != null)
            for (const o of p.readers)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.assetHashType) || (p.assetHashType, void 0), visitedObjects.has(p.bundling) || aws_cdk_lib_BundlingOptions(p.bundling), visitedObjects.has(p.followSymlinks) || (p.followSymlinks, void 0), visitedObjects.has(p.ignoreMode) || (p.ignoreMode, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_assets_Asset(p) {
    }
    function aws_cdk_lib_aws_s3_deployment_BucketDeploymentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.destinationBucket) || (p.destinationBucket, void 0), p.sources != null)
            for (const o of p.sources)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.accessControl) || (p.accessControl, void 0), p.cacheControl != null)
            for (const o of p.cacheControl)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.distribution) || (p.distribution, void 0), visitedObjects.has(p.ephemeralStorageSize) || (p.ephemeralStorageSize, void 0), visitedObjects.has(p.expires) || (p.expires, void 0), visitedObjects.has(p.logRetention) || (p.logRetention, void 0), visitedObjects.has(p.role) || (p.role, void 0), visitedObjects.has(p.serverSideEncryption) || (p.serverSideEncryption, void 0), visitedObjects.has(p.storageClass) || (p.storageClass, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_deployment_BucketDeployment(p) {
    }
    function aws_cdk_lib_aws_s3_deployment_CacheControl(p) {
    }
    function aws_cdk_lib_aws_s3_deployment_ServerSideEncryption(p) {
    }
    function aws_cdk_lib_aws_s3_deployment_StorageClass(p) {
    }
    function aws_cdk_lib_aws_s3_deployment_UserDefinedObjectMetadata(p) {
    }
    function aws_cdk_lib_aws_s3_deployment_SourceConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bucket) || (p.bucket, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_deployment_DeploymentSourceContext(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.handlerRole) || (p.handlerRole, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3_deployment_ISource(p) {
    }
    function aws_cdk_lib_aws_s3_deployment_Source(p) {
    }
    function aws_cdk_lib_aws_s3_notifications_SqsDestination(p) {
    }
    function aws_cdk_lib_aws_s3_notifications_SnsDestination(p) {
    }
    function aws_cdk_lib_aws_s3_notifications_LambdaDestination(p) {
    }
    function aws_cdk_lib_aws_s3objectlambda_CfnAccessPointProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.objectLambdaConfiguration) || (p.objectLambdaConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3objectlambda_CfnAccessPoint(p) {
    }
    function aws_cdk_lib_aws_s3objectlambda_CfnAccessPoint_AliasProperty(p) {
    }
    function aws_cdk_lib_aws_s3objectlambda_CfnAccessPoint_AwsLambdaProperty(p) {
    }
    function aws_cdk_lib_aws_s3objectlambda_CfnAccessPoint_ContentTransformationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.awsLambda) || (p.awsLambda, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3objectlambda_CfnAccessPoint_ObjectLambdaConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.transformationConfigurations) || (p.transformationConfigurations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3objectlambda_CfnAccessPoint_PolicyStatusProperty(p) {
    }
    function aws_cdk_lib_aws_s3objectlambda_CfnAccessPoint_PublicAccessBlockConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_s3objectlambda_CfnAccessPoint_TransformationConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_s3objectlambda_CfnAccessPointPolicyProps(p) {
    }
    function aws_cdk_lib_aws_s3objectlambda_CfnAccessPointPolicy(p) {
    }
    function aws_cdk_lib_aws_s3outposts_CfnAccessPointProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.vpcConfiguration) || (p.vpcConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3outposts_CfnAccessPoint(p) {
    }
    function aws_cdk_lib_aws_s3outposts_CfnAccessPoint_VpcConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_s3outposts_CfnBucketProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.lifecycleConfiguration) || (p.lifecycleConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3outposts_CfnBucket(p) {
    }
    function aws_cdk_lib_aws_s3outposts_CfnBucket_AbortIncompleteMultipartUploadProperty(p) {
    }
    function aws_cdk_lib_aws_s3outposts_CfnBucket_FilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.andOperator) || (p.andOperator, void 0), visitedObjects.has(p.tag) || (p.tag, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3outposts_CfnBucket_FilterAndOperatorProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3outposts_CfnBucket_FilterTagProperty(p) {
    }
    function aws_cdk_lib_aws_s3outposts_CfnBucket_LifecycleConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.rules) || (p.rules, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3outposts_CfnBucket_RuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.abortIncompleteMultipartUpload) || (p.abortIncompleteMultipartUpload, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_s3outposts_CfnBucketPolicyProps(p) {
    }
    function aws_cdk_lib_aws_s3outposts_CfnBucketPolicy(p) {
    }
    function aws_cdk_lib_aws_s3outposts_CfnEndpointProps(p) {
    }
    function aws_cdk_lib_aws_s3outposts_CfnEndpoint(p) {
    }
    function aws_cdk_lib_aws_s3outposts_CfnEndpoint_NetworkInterfaceProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnAppProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.resourceSpec) || (p.resourceSpec, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnApp(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnApp_ResourceSpecProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnAppImageConfigProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.kernelGatewayImageConfig) || (p.kernelGatewayImageConfig, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnAppImageConfig(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnAppImageConfig_FileSystemConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnAppImageConfig_KernelGatewayImageConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.kernelSpecs) || (p.kernelSpecs, void 0), visitedObjects.has(p.fileSystemConfig) || (p.fileSystemConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnAppImageConfig_KernelSpecProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnCodeRepositoryProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.gitConfig) || (p.gitConfig, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnCodeRepository(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnCodeRepository_GitConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinitionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.dataQualityAppSpecification) || (p.dataQualityAppSpecification, void 0), visitedObjects.has(p.dataQualityJobInput) || (p.dataQualityJobInput, void 0), visitedObjects.has(p.dataQualityJobOutputConfig) || (p.dataQualityJobOutputConfig, void 0), visitedObjects.has(p.jobResources) || (p.jobResources, void 0), visitedObjects.has(p.dataQualityBaselineConfig) || (p.dataQualityBaselineConfig, void 0), visitedObjects.has(p.networkConfig) || (p.networkConfig, void 0), visitedObjects.has(p.stoppingCondition) || (p.stoppingCondition, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_BatchTransformInputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.datasetFormat) || (p.datasetFormat, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_ClusterConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_ConstraintsResourceProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_CsvProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_DataQualityAppSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.environment) || (p.environment, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_DataQualityBaselineConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.constraintsResource) || (p.constraintsResource, void 0), visitedObjects.has(p.statisticsResource) || (p.statisticsResource, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_DataQualityJobInputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.batchTransformInput) || (p.batchTransformInput, void 0), visitedObjects.has(p.endpointInput) || (p.endpointInput, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_DatasetFormatProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.csv) || (p.csv, void 0), visitedObjects.has(p.json) || (p.json, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_EndpointInputProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_JsonProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_MonitoringOutputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3Output) || (p.s3Output, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_MonitoringOutputConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.monitoringOutputs) || (p.monitoringOutputs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_MonitoringResourcesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.clusterConfig) || (p.clusterConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_NetworkConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.vpcConfig) || (p.vpcConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_S3OutputProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_StatisticsResourceProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_StoppingConditionProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_VpcConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnDeviceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.device) || (p.device, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnDevice(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnDevice_DeviceProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnDeviceFleetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.outputConfig) || (p.outputConfig, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnDeviceFleet(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnDeviceFleet_EdgeOutputConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnDomainProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.defaultUserSettings) || (p.defaultUserSettings, void 0), visitedObjects.has(p.defaultSpaceSettings) || (p.defaultSpaceSettings, void 0), visitedObjects.has(p.domainSettings) || (p.domainSettings, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnDomain(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnDomain_CustomImageProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnDomain_DefaultSpaceSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.jupyterServerAppSettings) || (p.jupyterServerAppSettings, void 0), visitedObjects.has(p.kernelGatewayAppSettings) || (p.kernelGatewayAppSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnDomain_DomainSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.rStudioServerProDomainSettings) || (p.rStudioServerProDomainSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnDomain_JupyterServerAppSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultResourceSpec) || (p.defaultResourceSpec, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnDomain_KernelGatewayAppSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customImages) || (p.customImages, void 0), visitedObjects.has(p.defaultResourceSpec) || (p.defaultResourceSpec, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnDomain_RSessionAppSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customImages) || (p.customImages, void 0), visitedObjects.has(p.defaultResourceSpec) || (p.defaultResourceSpec, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnDomain_RStudioServerProAppSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnDomain_RStudioServerProDomainSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultResourceSpec) || (p.defaultResourceSpec, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnDomain_ResourceSpecProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnDomain_SharingSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnDomain_UserSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.jupyterServerAppSettings) || (p.jupyterServerAppSettings, void 0), visitedObjects.has(p.kernelGatewayAppSettings) || (p.kernelGatewayAppSettings, void 0), visitedObjects.has(p.rSessionAppSettings) || (p.rSessionAppSettings, void 0), visitedObjects.has(p.rStudioServerProAppSettings) || (p.rStudioServerProAppSettings, void 0), visitedObjects.has(p.sharingSettings) || (p.sharingSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnEndpointProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.deploymentConfig) || (p.deploymentConfig, void 0), visitedObjects.has(p.excludeRetainedVariantProperties) || (p.excludeRetainedVariantProperties, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnEndpoint(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnEndpoint_AlarmProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnEndpoint_AutoRollbackConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.alarms) || (p.alarms, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnEndpoint_BlueGreenUpdatePolicyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.trafficRoutingConfiguration) || (p.trafficRoutingConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnEndpoint_CapacitySizeProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnEndpoint_DeploymentConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.blueGreenUpdatePolicy) || (p.blueGreenUpdatePolicy, void 0), visitedObjects.has(p.autoRollbackConfiguration) || (p.autoRollbackConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnEndpoint_TrafficRoutingConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.canarySize) || (p.canarySize, void 0), visitedObjects.has(p.linearStepSize) || (p.linearStepSize, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnEndpoint_VariantPropertyProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnEndpointConfigProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.productionVariants) || (p.productionVariants, void 0), visitedObjects.has(p.asyncInferenceConfig) || (p.asyncInferenceConfig, void 0), visitedObjects.has(p.dataCaptureConfig) || (p.dataCaptureConfig, void 0), visitedObjects.has(p.explainerConfig) || (p.explainerConfig, void 0), visitedObjects.has(p.shadowProductionVariants) || (p.shadowProductionVariants, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnEndpointConfig(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnEndpointConfig_AsyncInferenceClientConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnEndpointConfig_AsyncInferenceConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.outputConfig) || (p.outputConfig, void 0), visitedObjects.has(p.clientConfig) || (p.clientConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnEndpointConfig_AsyncInferenceNotificationConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnEndpointConfig_AsyncInferenceOutputConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.notificationConfig) || (p.notificationConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnEndpointConfig_CaptureContentTypeHeaderProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnEndpointConfig_CaptureOptionProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnEndpointConfig_ClarifyExplainerConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.shapConfig) || (p.shapConfig, void 0), visitedObjects.has(p.inferenceConfig) || (p.inferenceConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnEndpointConfig_ClarifyInferenceConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnEndpointConfig_ClarifyShapBaselineConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnEndpointConfig_ClarifyShapConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.shapBaselineConfig) || (p.shapBaselineConfig, void 0), visitedObjects.has(p.textConfig) || (p.textConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnEndpointConfig_ClarifyTextConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnEndpointConfig_DataCaptureConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.captureOptions) || (p.captureOptions, void 0), visitedObjects.has(p.captureContentTypeHeader) || (p.captureContentTypeHeader, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnEndpointConfig_ExplainerConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.clarifyExplainerConfig) || (p.clarifyExplainerConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnEndpointConfig_ProductionVariantProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.serverlessConfig) || (p.serverlessConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnEndpointConfig_ServerlessConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnFeatureGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.featureDefinitions) || (p.featureDefinitions, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnFeatureGroup(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnFeatureGroup_DataCatalogConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnFeatureGroup_FeatureDefinitionProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnFeatureGroup_OfflineStoreConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3StorageConfig) || (p.s3StorageConfig, void 0), visitedObjects.has(p.dataCatalogConfig) || (p.dataCatalogConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnFeatureGroup_OnlineStoreConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.securityConfig) || (p.securityConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnFeatureGroup_OnlineStoreSecurityConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnFeatureGroup_S3StorageConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnImageProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnImage(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnImageVersionProps(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnImageVersion(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnInferenceExperimentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.modelVariants) || (p.modelVariants, void 0), visitedObjects.has(p.dataStorageConfig) || (p.dataStorageConfig, void 0), visitedObjects.has(p.schedule) || (p.schedule, void 0), visitedObjects.has(p.shadowModeConfig) || (p.shadowModeConfig, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnInferenceExperiment(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnInferenceExperiment_CaptureContentTypeHeaderProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnInferenceExperiment_DataStorageConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.contentType) || (p.contentType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnInferenceExperiment_EndpointMetadataProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnInferenceExperiment_InferenceExperimentScheduleProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnInferenceExperiment_ModelInfrastructureConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.realTimeInferenceConfig) || (p.realTimeInferenceConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnInferenceExperiment_ModelVariantConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.infrastructureConfig) || (p.infrastructureConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnInferenceExperiment_RealTimeInferenceConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnInferenceExperiment_ShadowModeConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.shadowModelVariants) || (p.shadowModelVariants, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnInferenceExperiment_ShadowModelVariantConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.containers) || (p.containers, void 0), visitedObjects.has(p.inferenceExecutionConfig) || (p.inferenceExecutionConfig, void 0), visitedObjects.has(p.primaryContainer) || (p.primaryContainer, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.vpcConfig) || (p.vpcConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModel(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModel_ContainerDefinitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.imageConfig) || (p.imageConfig, void 0), visitedObjects.has(p.multiModelConfig) || (p.multiModelConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModel_ImageConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.repositoryAuthConfig) || (p.repositoryAuthConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModel_InferenceExecutionConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModel_MultiModelConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModel_RepositoryAuthConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModel_VpcConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinitionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.jobResources) || (p.jobResources, void 0), visitedObjects.has(p.modelBiasAppSpecification) || (p.modelBiasAppSpecification, void 0), visitedObjects.has(p.modelBiasJobInput) || (p.modelBiasJobInput, void 0), visitedObjects.has(p.modelBiasJobOutputConfig) || (p.modelBiasJobOutputConfig, void 0), visitedObjects.has(p.modelBiasBaselineConfig) || (p.modelBiasBaselineConfig, void 0), visitedObjects.has(p.networkConfig) || (p.networkConfig, void 0), visitedObjects.has(p.stoppingCondition) || (p.stoppingCondition, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_BatchTransformInputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.datasetFormat) || (p.datasetFormat, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_ClusterConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_ConstraintsResourceProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_CsvProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_DatasetFormatProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.csv) || (p.csv, void 0), visitedObjects.has(p.json) || (p.json, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_EndpointInputProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_JsonProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_ModelBiasAppSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.environment) || (p.environment, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_ModelBiasBaselineConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.constraintsResource) || (p.constraintsResource, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_ModelBiasJobInputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.groundTruthS3Input) || (p.groundTruthS3Input, void 0), visitedObjects.has(p.batchTransformInput) || (p.batchTransformInput, void 0), visitedObjects.has(p.endpointInput) || (p.endpointInput, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_MonitoringGroundTruthS3InputProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_MonitoringOutputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3Output) || (p.s3Output, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_MonitoringOutputConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.monitoringOutputs) || (p.monitoringOutputs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_MonitoringResourcesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.clusterConfig) || (p.clusterConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_NetworkConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.vpcConfig) || (p.vpcConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_S3OutputProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_StoppingConditionProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_VpcConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelCardProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.content) || (p.content, void 0), visitedObjects.has(p.createdBy) || (p.createdBy, void 0), visitedObjects.has(p.lastModifiedBy) || (p.lastModifiedBy, void 0), visitedObjects.has(p.securityConfig) || (p.securityConfig, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelCard(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelCard_AdditionalInformationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customDetails) || (p.customDetails, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelCard_BusinessDetailsProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelCard_ContainerProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelCard_ContentProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.additionalInformation) || (p.additionalInformation, void 0), visitedObjects.has(p.businessDetails) || (p.businessDetails, void 0), visitedObjects.has(p.evaluationDetails) || (p.evaluationDetails, void 0), visitedObjects.has(p.intendedUses) || (p.intendedUses, void 0), visitedObjects.has(p.modelOverview) || (p.modelOverview, void 0), visitedObjects.has(p.modelPackageDetails) || (p.modelPackageDetails, void 0), visitedObjects.has(p.trainingDetails) || (p.trainingDetails, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelCard_EvaluationDetailProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.metadata) || (p.metadata, void 0), visitedObjects.has(p.metricGroups) || (p.metricGroups, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelCard_FunctionProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelCard_InferenceEnvironmentProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelCard_InferenceSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.containers) || (p.containers, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelCard_IntendedUsesProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelCard_MetricDataItemsProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelCard_MetricGroupProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.metricData) || (p.metricData, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelCard_ModelOverviewProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.inferenceEnvironment) || (p.inferenceEnvironment, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelCard_ModelPackageCreatorProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelCard_ModelPackageDetailsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.createdBy) || (p.createdBy, void 0), visitedObjects.has(p.inferenceSpecification) || (p.inferenceSpecification, void 0), visitedObjects.has(p.sourceAlgorithms) || (p.sourceAlgorithms, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelCard_ObjectiveFunctionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.function) || (p.function, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelCard_SecurityConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelCard_SourceAlgorithmProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelCard_TrainingDetailsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.objectiveFunction) || (p.objectiveFunction, void 0), visitedObjects.has(p.trainingJobDetails) || (p.trainingJobDetails, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelCard_TrainingEnvironmentProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelCard_TrainingHyperParameterProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelCard_TrainingJobDetailsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.hyperParameters) || (p.hyperParameters, void 0), visitedObjects.has(p.trainingEnvironment) || (p.trainingEnvironment, void 0), visitedObjects.has(p.trainingMetrics) || (p.trainingMetrics, void 0), visitedObjects.has(p.userProvidedHyperParameters) || (p.userProvidedHyperParameters, void 0), visitedObjects.has(p.userProvidedTrainingMetrics) || (p.userProvidedTrainingMetrics, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelCard_TrainingMetricProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelCard_UserContextProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinitionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.jobResources) || (p.jobResources, void 0), visitedObjects.has(p.modelExplainabilityAppSpecification) || (p.modelExplainabilityAppSpecification, void 0), visitedObjects.has(p.modelExplainabilityJobInput) || (p.modelExplainabilityJobInput, void 0), visitedObjects.has(p.modelExplainabilityJobOutputConfig) || (p.modelExplainabilityJobOutputConfig, void 0), visitedObjects.has(p.modelExplainabilityBaselineConfig) || (p.modelExplainabilityBaselineConfig, void 0), visitedObjects.has(p.networkConfig) || (p.networkConfig, void 0), visitedObjects.has(p.stoppingCondition) || (p.stoppingCondition, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_BatchTransformInputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.datasetFormat) || (p.datasetFormat, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_ClusterConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_ConstraintsResourceProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_CsvProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_DatasetFormatProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.csv) || (p.csv, void 0), visitedObjects.has(p.json) || (p.json, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_EndpointInputProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_JsonProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_ModelExplainabilityAppSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.environment) || (p.environment, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_ModelExplainabilityBaselineConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.constraintsResource) || (p.constraintsResource, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_ModelExplainabilityJobInputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.batchTransformInput) || (p.batchTransformInput, void 0), visitedObjects.has(p.endpointInput) || (p.endpointInput, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_MonitoringOutputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3Output) || (p.s3Output, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_MonitoringOutputConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.monitoringOutputs) || (p.monitoringOutputs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_MonitoringResourcesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.clusterConfig) || (p.clusterConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_NetworkConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.vpcConfig) || (p.vpcConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_S3OutputProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_StoppingConditionProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_VpcConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackageProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.additionalInferenceSpecificationDefinition) || (p.additionalInferenceSpecificationDefinition, void 0), visitedObjects.has(p.additionalInferenceSpecifications) || (p.additionalInferenceSpecifications, void 0), visitedObjects.has(p.additionalInferenceSpecificationsToAdd) || (p.additionalInferenceSpecificationsToAdd, void 0), visitedObjects.has(p.createdBy) || (p.createdBy, void 0), visitedObjects.has(p.customerMetadataProperties) || (p.customerMetadataProperties, void 0), visitedObjects.has(p.driftCheckBaselines) || (p.driftCheckBaselines, void 0), visitedObjects.has(p.environment) || (p.environment, void 0), visitedObjects.has(p.inferenceSpecification) || (p.inferenceSpecification, void 0), visitedObjects.has(p.lastModifiedBy) || (p.lastModifiedBy, void 0), visitedObjects.has(p.metadataProperties) || (p.metadataProperties, void 0), visitedObjects.has(p.modelMetrics) || (p.modelMetrics, void 0), visitedObjects.has(p.modelPackageStatusDetails) || (p.modelPackageStatusDetails, void 0), visitedObjects.has(p.modelPackageStatusItem) || (p.modelPackageStatusItem, void 0), visitedObjects.has(p.sourceAlgorithmSpecification) || (p.sourceAlgorithmSpecification, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.validationSpecification) || (p.validationSpecification, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackage(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackage_AdditionalInferenceSpecificationDefinitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.containers) || (p.containers, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackage_BiasProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.postTrainingReport) || (p.postTrainingReport, void 0), visitedObjects.has(p.preTrainingReport) || (p.preTrainingReport, void 0), visitedObjects.has(p.report) || (p.report, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackage_DataSourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3DataSource) || (p.s3DataSource, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackage_DriftCheckBaselinesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bias) || (p.bias, void 0), visitedObjects.has(p.explainability) || (p.explainability, void 0), visitedObjects.has(p.modelDataQuality) || (p.modelDataQuality, void 0), visitedObjects.has(p.modelQuality) || (p.modelQuality, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackage_DriftCheckBiasProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.configFile) || (p.configFile, void 0), visitedObjects.has(p.postTrainingConstraints) || (p.postTrainingConstraints, void 0), visitedObjects.has(p.preTrainingConstraints) || (p.preTrainingConstraints, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackage_DriftCheckExplainabilityProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.configFile) || (p.configFile, void 0), visitedObjects.has(p.constraints) || (p.constraints, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackage_DriftCheckModelDataQualityProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.constraints) || (p.constraints, void 0), visitedObjects.has(p.statistics) || (p.statistics, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackage_DriftCheckModelQualityProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.constraints) || (p.constraints, void 0), visitedObjects.has(p.statistics) || (p.statistics, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackage_ExplainabilityProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.report) || (p.report, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackage_FileSourceProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackage_InferenceSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.containers) || (p.containers, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackage_MetadataPropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackage_MetricsSourceProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackage_ModelDataQualityProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.constraints) || (p.constraints, void 0), visitedObjects.has(p.statistics) || (p.statistics, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackage_ModelInputProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackage_ModelMetricsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bias) || (p.bias, void 0), visitedObjects.has(p.explainability) || (p.explainability, void 0), visitedObjects.has(p.modelDataQuality) || (p.modelDataQuality, void 0), visitedObjects.has(p.modelQuality) || (p.modelQuality, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackage_ModelPackageContainerDefinitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.environment) || (p.environment, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackage_ModelPackageStatusDetailsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.validationStatuses) || (p.validationStatuses, void 0), visitedObjects.has(p.imageScanStatuses) || (p.imageScanStatuses, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackage_ModelPackageStatusItemProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackage_ModelQualityProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.constraints) || (p.constraints, void 0), visitedObjects.has(p.statistics) || (p.statistics, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackage_S3DataSourceProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackage_SourceAlgorithmProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackage_SourceAlgorithmSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sourceAlgorithms) || (p.sourceAlgorithms, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackage_TransformInputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataSource) || (p.dataSource, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackage_TransformJobDefinitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.transformInput) || (p.transformInput, void 0), visitedObjects.has(p.transformOutput) || (p.transformOutput, void 0), visitedObjects.has(p.transformResources) || (p.transformResources, void 0), visitedObjects.has(p.environment) || (p.environment, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackage_TransformOutputProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackage_TransformResourcesProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackage_UserContextProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackage_ValidationProfileProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.transformJobDefinition) || (p.transformJobDefinition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackage_ValidationSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.validationProfiles) || (p.validationProfiles, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackageGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelPackageGroup(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinitionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.jobResources) || (p.jobResources, void 0), visitedObjects.has(p.modelQualityAppSpecification) || (p.modelQualityAppSpecification, void 0), visitedObjects.has(p.modelQualityJobInput) || (p.modelQualityJobInput, void 0), visitedObjects.has(p.modelQualityJobOutputConfig) || (p.modelQualityJobOutputConfig, void 0), visitedObjects.has(p.modelQualityBaselineConfig) || (p.modelQualityBaselineConfig, void 0), visitedObjects.has(p.networkConfig) || (p.networkConfig, void 0), visitedObjects.has(p.stoppingCondition) || (p.stoppingCondition, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_BatchTransformInputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.datasetFormat) || (p.datasetFormat, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_ClusterConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_ConstraintsResourceProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_CsvProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_DatasetFormatProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.csv) || (p.csv, void 0), visitedObjects.has(p.json) || (p.json, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_EndpointInputProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_JsonProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_ModelQualityAppSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.environment) || (p.environment, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_ModelQualityBaselineConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.constraintsResource) || (p.constraintsResource, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_ModelQualityJobInputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.groundTruthS3Input) || (p.groundTruthS3Input, void 0), visitedObjects.has(p.batchTransformInput) || (p.batchTransformInput, void 0), visitedObjects.has(p.endpointInput) || (p.endpointInput, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_MonitoringGroundTruthS3InputProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_MonitoringOutputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3Output) || (p.s3Output, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_MonitoringOutputConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.monitoringOutputs) || (p.monitoringOutputs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_MonitoringResourcesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.clusterConfig) || (p.clusterConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_NetworkConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.vpcConfig) || (p.vpcConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_S3OutputProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_StoppingConditionProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_VpcConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnMonitoringScheduleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.monitoringScheduleConfig) || (p.monitoringScheduleConfig, void 0), visitedObjects.has(p.lastMonitoringExecutionSummary) || (p.lastMonitoringExecutionSummary, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_BaselineConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.constraintsResource) || (p.constraintsResource, void 0), visitedObjects.has(p.statisticsResource) || (p.statisticsResource, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_BatchTransformInputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.datasetFormat) || (p.datasetFormat, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_ClusterConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_ConstraintsResourceProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_CsvProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_DatasetFormatProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.csv) || (p.csv, void 0), visitedObjects.has(p.json) || (p.json, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_EndpointInputProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_JsonProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_MonitoringAppSpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_MonitoringExecutionSummaryProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_MonitoringInputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.batchTransformInput) || (p.batchTransformInput, void 0), visitedObjects.has(p.endpointInput) || (p.endpointInput, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_MonitoringJobDefinitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.monitoringAppSpecification) || (p.monitoringAppSpecification, void 0), visitedObjects.has(p.monitoringInputs) || (p.monitoringInputs, void 0), visitedObjects.has(p.monitoringOutputConfig) || (p.monitoringOutputConfig, void 0), visitedObjects.has(p.monitoringResources) || (p.monitoringResources, void 0), visitedObjects.has(p.baselineConfig) || (p.baselineConfig, void 0), visitedObjects.has(p.environment) || (p.environment, void 0), visitedObjects.has(p.networkConfig) || (p.networkConfig, void 0), visitedObjects.has(p.stoppingCondition) || (p.stoppingCondition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_MonitoringOutputProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3Output) || (p.s3Output, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_MonitoringOutputConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.monitoringOutputs) || (p.monitoringOutputs, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_MonitoringResourcesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.clusterConfig) || (p.clusterConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_MonitoringScheduleConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.monitoringJobDefinition) || (p.monitoringJobDefinition, void 0), visitedObjects.has(p.scheduleConfig) || (p.scheduleConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_NetworkConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.vpcConfig) || (p.vpcConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_S3OutputProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_ScheduleConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_StatisticsResourceProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_StoppingConditionProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_VpcConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnNotebookInstanceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.instanceMetadataServiceConfiguration) || (p.instanceMetadataServiceConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnNotebookInstance(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnNotebookInstance_InstanceMetadataServiceConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnNotebookInstanceLifecycleConfigProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.onCreate) || (p.onCreate, void 0), visitedObjects.has(p.onStart) || (p.onStart, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnNotebookInstanceLifecycleConfig(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnNotebookInstanceLifecycleConfig_NotebookInstanceLifecycleHookProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnPipelineProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnPipeline(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnPipeline_ParallelismConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnPipeline_PipelineDefinitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.pipelineDefinitionS3Location) || (p.pipelineDefinitionS3Location, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnPipeline_S3LocationProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnProjectProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnProject(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnProject_ProvisioningParameterProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnProject_ServiceCatalogProvisionedProductDetailsProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnProject_ServiceCatalogProvisioningDetailsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.provisioningParameters) || (p.provisioningParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnSpaceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.spaceSettings) || (p.spaceSettings, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnSpace(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnSpace_CustomImageProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnSpace_JupyterServerAppSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultResourceSpec) || (p.defaultResourceSpec, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnSpace_KernelGatewayAppSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customImages) || (p.customImages, void 0), visitedObjects.has(p.defaultResourceSpec) || (p.defaultResourceSpec, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnSpace_ResourceSpecProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnSpace_SpaceSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.jupyterServerAppSettings) || (p.jupyterServerAppSettings, void 0), visitedObjects.has(p.kernelGatewayAppSettings) || (p.kernelGatewayAppSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnUserProfileProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.userSettings) || (p.userSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnUserProfile(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnUserProfile_CustomImageProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnUserProfile_JupyterServerAppSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultResourceSpec) || (p.defaultResourceSpec, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnUserProfile_KernelGatewayAppSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customImages) || (p.customImages, void 0), visitedObjects.has(p.defaultResourceSpec) || (p.defaultResourceSpec, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnUserProfile_RStudioServerProAppSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnUserProfile_ResourceSpecProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnUserProfile_SharingSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnUserProfile_UserSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.jupyterServerAppSettings) || (p.jupyterServerAppSettings, void 0), visitedObjects.has(p.kernelGatewayAppSettings) || (p.kernelGatewayAppSettings, void 0), visitedObjects.has(p.rStudioServerProAppSettings) || (p.rStudioServerProAppSettings, void 0), visitedObjects.has(p.sharingSettings) || (p.sharingSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnWorkteamProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.memberDefinitions) || (p.memberDefinitions, void 0), visitedObjects.has(p.notificationConfiguration) || (p.notificationConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnWorkteam(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnWorkteam_CognitoMemberDefinitionProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnWorkteam_MemberDefinitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cognitoMemberDefinition) || (p.cognitoMemberDefinition, void 0), visitedObjects.has(p.oidcMemberDefinition) || (p.oidcMemberDefinition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sagemaker_CfnWorkteam_NotificationConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_sagemaker_CfnWorkteam_OidcMemberDefinitionProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnApiProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.accessLogSetting) || (p.accessLogSetting, void 0), visitedObjects.has(p.auth) || (p.auth, void 0), visitedObjects.has(p.canarySetting) || (p.canarySetting, void 0), visitedObjects.has(p.domain) || (p.domain, void 0), visitedObjects.has(p.variables) || (p.variables, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sam_CfnApi(p) {
    }
    function aws_cdk_lib_aws_sam_CfnApi_AccessLogSettingProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnApi_AuthProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnApi_CanarySettingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.stageVariableOverrides) || (p.stageVariableOverrides, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sam_CfnApi_CorsConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnApi_DomainConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.mutualTlsAuthentication) || (p.mutualTlsAuthentication, void 0), visitedObjects.has(p.route53) || (p.route53, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sam_CfnApi_EndpointConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnApi_MutualTlsAuthenticationProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnApi_Route53ConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnApi_S3LocationProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnApplicationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.parameters) || (p.parameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sam_CfnApplication(p) {
    }
    function aws_cdk_lib_aws_sam_CfnApplication_ApplicationLocationProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunctionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.deadLetterQueue) || (p.deadLetterQueue, void 0), visitedObjects.has(p.deploymentPreference) || (p.deploymentPreference, void 0), visitedObjects.has(p.environment) || (p.environment, void 0), visitedObjects.has(p.eventInvokeConfig) || (p.eventInvokeConfig, void 0), visitedObjects.has(p.events) || (p.events, void 0), visitedObjects.has(p.fileSystemConfigs) || (p.fileSystemConfigs, void 0), visitedObjects.has(p.imageConfig) || (p.imageConfig, void 0), visitedObjects.has(p.provisionedConcurrencyConfig) || (p.provisionedConcurrencyConfig, void 0), visitedObjects.has(p.vpcConfig) || (p.vpcConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sam_CfnFunction(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_AlexaSkillEventProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.variables) || (p.variables, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sam_CfnFunction_ApiEventProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.auth) || (p.auth, void 0), visitedObjects.has(p.requestModel) || (p.requestModel, void 0), visitedObjects.has(p.requestParameters) || (p.requestParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sam_CfnFunction_AuthProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.resourcePolicy) || (p.resourcePolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sam_CfnFunction_AuthResourcePolicyProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_BucketSAMPTProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_CloudWatchEventEventProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_CloudWatchLogsEventProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_CognitoEventProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_CollectionSAMPTProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_DeadLetterQueueProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_DeploymentPreferenceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.hooks) || (p.hooks, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sam_CfnFunction_DestinationProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_DestinationConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.onFailure) || (p.onFailure, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sam_CfnFunction_DomainSAMPTProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_DynamoDBEventProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destinationConfig) || (p.destinationConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sam_CfnFunction_EmptySAMPTProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_EventBridgeRuleEventProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_EventInvokeConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destinationConfig) || (p.destinationConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sam_CfnFunction_EventInvokeDestinationConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.onFailure) || (p.onFailure, void 0), visitedObjects.has(p.onSuccess) || (p.onSuccess, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sam_CfnFunction_EventSourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.properties) || (p.properties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sam_CfnFunction_FileSystemConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_FunctionEnvironmentProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.variables) || (p.variables, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sam_CfnFunction_FunctionSAMPTProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_HooksProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_HttpApiEventProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.auth) || (p.auth, void 0), visitedObjects.has(p.routeSettings) || (p.routeSettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sam_CfnFunction_HttpApiFunctionAuthProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_IAMPolicyDocumentProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_IdentitySAMPTProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_ImageConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_IoTRuleEventProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_KeySAMPTProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_KinesisEventProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_LogGroupSAMPTProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_ParameterNameSAMPTProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_ProvisionedConcurrencyConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_QueueSAMPTProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_RequestModelProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_RequestParameterProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_RouteSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_S3EventProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.filter) || (p.filter, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sam_CfnFunction_S3KeyFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.rules) || (p.rules, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sam_CfnFunction_S3KeyFilterRuleProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_S3LocationProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_S3NotificationFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3Key) || (p.s3Key, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sam_CfnFunction_SAMPolicyTemplateProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.amiDescribePolicy) || (p.amiDescribePolicy, void 0), visitedObjects.has(p.awsSecretsManagerGetSecretValuePolicy) || (p.awsSecretsManagerGetSecretValuePolicy, void 0), visitedObjects.has(p.cloudFormationDescribeStacksPolicy) || (p.cloudFormationDescribeStacksPolicy, void 0), visitedObjects.has(p.cloudWatchPutMetricPolicy) || (p.cloudWatchPutMetricPolicy, void 0), visitedObjects.has(p.dynamoDbCrudPolicy) || (p.dynamoDbCrudPolicy, void 0), visitedObjects.has(p.dynamoDbReadPolicy) || (p.dynamoDbReadPolicy, void 0), visitedObjects.has(p.dynamoDbStreamReadPolicy) || (p.dynamoDbStreamReadPolicy, void 0), visitedObjects.has(p.dynamoDbWritePolicy) || (p.dynamoDbWritePolicy, void 0), visitedObjects.has(p.ec2DescribePolicy) || (p.ec2DescribePolicy, void 0), visitedObjects.has(p.elasticsearchHttpPostPolicy) || (p.elasticsearchHttpPostPolicy, void 0), visitedObjects.has(p.filterLogEventsPolicy) || (p.filterLogEventsPolicy, void 0), visitedObjects.has(p.kinesisCrudPolicy) || (p.kinesisCrudPolicy, void 0), visitedObjects.has(p.kinesisStreamReadPolicy) || (p.kinesisStreamReadPolicy, void 0), visitedObjects.has(p.kmsDecryptPolicy) || (p.kmsDecryptPolicy, void 0), visitedObjects.has(p.lambdaInvokePolicy) || (p.lambdaInvokePolicy, void 0), visitedObjects.has(p.rekognitionDetectOnlyPolicy) || (p.rekognitionDetectOnlyPolicy, void 0), visitedObjects.has(p.rekognitionLabelsPolicy) || (p.rekognitionLabelsPolicy, void 0), visitedObjects.has(p.rekognitionNoDataAccessPolicy) || (p.rekognitionNoDataAccessPolicy, void 0), visitedObjects.has(p.rekognitionReadPolicy) || (p.rekognitionReadPolicy, void 0), visitedObjects.has(p.rekognitionWriteOnlyAccessPolicy) || (p.rekognitionWriteOnlyAccessPolicy, void 0), visitedObjects.has(p.s3CrudPolicy) || (p.s3CrudPolicy, void 0), visitedObjects.has(p.s3ReadPolicy) || (p.s3ReadPolicy, void 0), visitedObjects.has(p.s3WritePolicy) || (p.s3WritePolicy, void 0), visitedObjects.has(p.sesBulkTemplatedCrudPolicy) || (p.sesBulkTemplatedCrudPolicy, void 0), visitedObjects.has(p.sesCrudPolicy) || (p.sesCrudPolicy, void 0), visitedObjects.has(p.sesEmailTemplateCrudPolicy) || (p.sesEmailTemplateCrudPolicy, void 0), visitedObjects.has(p.sesSendBouncePolicy) || (p.sesSendBouncePolicy, void 0), visitedObjects.has(p.snsCrudPolicy) || (p.snsCrudPolicy, void 0), visitedObjects.has(p.snsPublishMessagePolicy) || (p.snsPublishMessagePolicy, void 0), visitedObjects.has(p.sqsPollerPolicy) || (p.sqsPollerPolicy, void 0), visitedObjects.has(p.sqsSendMessagePolicy) || (p.sqsSendMessagePolicy, void 0), visitedObjects.has(p.ssmParameterReadPolicy) || (p.ssmParameterReadPolicy, void 0), visitedObjects.has(p.stepFunctionsExecutionPolicy) || (p.stepFunctionsExecutionPolicy, void 0), visitedObjects.has(p.vpcAccessPolicy) || (p.vpcAccessPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sam_CfnFunction_SNSEventProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_SQSEventProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_ScheduleEventProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_SecretArnSAMPTProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_StateMachineSAMPTProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_StreamSAMPTProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_TableSAMPTProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_TableStreamSAMPTProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_TopicSAMPTProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnFunction_VpcConfigProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnHttpApiProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.accessLogSetting) || (p.accessLogSetting, void 0), visitedObjects.has(p.auth) || (p.auth, void 0), visitedObjects.has(p.defaultRouteSettings) || (p.defaultRouteSettings, void 0), visitedObjects.has(p.domain) || (p.domain, void 0), visitedObjects.has(p.routeSettings) || (p.routeSettings, void 0), visitedObjects.has(p.stageVariables) || (p.stageVariables, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sam_CfnHttpApi(p) {
    }
    function aws_cdk_lib_aws_sam_CfnHttpApi_AccessLogSettingProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnHttpApi_CorsConfigurationObjectProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnHttpApi_HttpApiAuthProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnHttpApi_HttpApiDomainConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.mutualTlsAuthentication) || (p.mutualTlsAuthentication, void 0), visitedObjects.has(p.route53) || (p.route53, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sam_CfnHttpApi_MutualTlsAuthenticationProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnHttpApi_Route53ConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnHttpApi_RouteSettingsProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnHttpApi_S3LocationProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnLayerVersionProps(p) {
    }
    function aws_cdk_lib_aws_sam_CfnLayerVersion(p) {
    }
    function aws_cdk_lib_aws_sam_CfnLayerVersion_S3LocationProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnSimpleTableProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.primaryKey) || (p.primaryKey, void 0), visitedObjects.has(p.provisionedThroughput) || (p.provisionedThroughput, void 0), visitedObjects.has(p.sseSpecification) || (p.sseSpecification, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sam_CfnSimpleTable(p) {
    }
    function aws_cdk_lib_aws_sam_CfnSimpleTable_PrimaryKeyProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnSimpleTable_ProvisionedThroughputProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnSimpleTable_SSESpecificationProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnStateMachineProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.definitionSubstitutions) || (p.definitionSubstitutions, void 0), visitedObjects.has(p.events) || (p.events, void 0), visitedObjects.has(p.logging) || (p.logging, void 0), visitedObjects.has(p.tracing) || (p.tracing, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sam_CfnStateMachine(p) {
    }
    function aws_cdk_lib_aws_sam_CfnStateMachine_ApiEventProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnStateMachine_CloudWatchEventEventProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnStateMachine_CloudWatchLogsLogGroupProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnStateMachine_EventBridgeRuleEventProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnStateMachine_EventSourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.properties) || (p.properties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sam_CfnStateMachine_FunctionSAMPTProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnStateMachine_IAMPolicyDocumentProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnStateMachine_LogDestinationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cloudWatchLogsLogGroup) || (p.cloudWatchLogsLogGroup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sam_CfnStateMachine_LoggingConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destinations) || (p.destinations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sam_CfnStateMachine_S3LocationProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnStateMachine_SAMPolicyTemplateProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.lambdaInvokePolicy) || (p.lambdaInvokePolicy, void 0), visitedObjects.has(p.stepFunctionsExecutionPolicy) || (p.stepFunctionsExecutionPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sam_CfnStateMachine_ScheduleEventProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnStateMachine_StateMachineSAMPTProperty(p) {
    }
    function aws_cdk_lib_aws_sam_CfnStateMachine_TracingConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_scheduler_CfnScheduleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.flexibleTimeWindow) || (p.flexibleTimeWindow, void 0), visitedObjects.has(p.target) || (p.target, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_scheduler_CfnSchedule(p) {
    }
    function aws_cdk_lib_aws_scheduler_CfnSchedule_AwsVpcConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_scheduler_CfnSchedule_CapacityProviderStrategyItemProperty(p) {
    }
    function aws_cdk_lib_aws_scheduler_CfnSchedule_DeadLetterConfigProperty(p) {
    }
    function aws_cdk_lib_aws_scheduler_CfnSchedule_EcsParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.capacityProviderStrategy) || (p.capacityProviderStrategy, void 0), visitedObjects.has(p.networkConfiguration) || (p.networkConfiguration, void 0), visitedObjects.has(p.placementConstraints) || (p.placementConstraints, void 0), visitedObjects.has(p.placementStrategy) || (p.placementStrategy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_scheduler_CfnSchedule_EventBridgeParametersProperty(p) {
    }
    function aws_cdk_lib_aws_scheduler_CfnSchedule_FlexibleTimeWindowProperty(p) {
    }
    function aws_cdk_lib_aws_scheduler_CfnSchedule_KinesisParametersProperty(p) {
    }
    function aws_cdk_lib_aws_scheduler_CfnSchedule_NetworkConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.awsvpcConfiguration) || (p.awsvpcConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_scheduler_CfnSchedule_PlacementConstraintProperty(p) {
    }
    function aws_cdk_lib_aws_scheduler_CfnSchedule_PlacementStrategyProperty(p) {
    }
    function aws_cdk_lib_aws_scheduler_CfnSchedule_RetryPolicyProperty(p) {
    }
    function aws_cdk_lib_aws_scheduler_CfnSchedule_SageMakerPipelineParameterProperty(p) {
    }
    function aws_cdk_lib_aws_scheduler_CfnSchedule_SageMakerPipelineParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.pipelineParameterList) || (p.pipelineParameterList, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_scheduler_CfnSchedule_SqsParametersProperty(p) {
    }
    function aws_cdk_lib_aws_scheduler_CfnSchedule_TargetProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.deadLetterConfig) || (p.deadLetterConfig, void 0), visitedObjects.has(p.ecsParameters) || (p.ecsParameters, void 0), visitedObjects.has(p.eventBridgeParameters) || (p.eventBridgeParameters, void 0), visitedObjects.has(p.kinesisParameters) || (p.kinesisParameters, void 0), visitedObjects.has(p.retryPolicy) || (p.retryPolicy, void 0), visitedObjects.has(p.sageMakerPipelineParameters) || (p.sageMakerPipelineParameters, void 0), visitedObjects.has(p.sqsParameters) || (p.sqsParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_scheduler_CfnScheduleGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_scheduler_CfnScheduleGroup(p) {
    }
    function aws_cdk_lib_aws_sdb_CfnDomainProps(p) {
    }
    function aws_cdk_lib_aws_sdb_CfnDomain(p) {
    }
    function aws_cdk_lib_aws_secretsmanager_ISecret(p) {
    }
    function aws_cdk_lib_aws_secretsmanager_SecretProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.encryptionKey) || (p.encryptionKey, void 0), visitedObjects.has(p.generateSecretString) || (p.generateSecretString, void 0), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), p.replicaRegions != null)
            for (const o of p.replicaRegions)
              visitedObjects.has(o) || aws_cdk_lib_aws_secretsmanager_ReplicaRegion(o);
          if (p.secretObjectValue != null)
            for (const o of Object.values(p.secretObjectValue))
              visitedObjects.has(o) || void 0;
          "secretStringBeta1" in p && print("aws-cdk-lib.aws_secretsmanager.SecretProps#secretStringBeta1", "Use `secretStringValue` instead."), visitedObjects.has(p.secretStringBeta1) || (p.secretStringBeta1, void 0), visitedObjects.has(p.secretStringValue) || (p.secretStringValue, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_secretsmanager_ReplicaRegion(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.encryptionKey) || (p.encryptionKey, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_secretsmanager_SecretStringValueBeta1(p) {
    }
    function aws_cdk_lib_aws_secretsmanager_SecretAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.encryptionKey) || (p.encryptionKey, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_secretsmanager_Secret(p) {
    }
    function aws_cdk_lib_aws_secretsmanager_ISecretAttachmentTarget(p) {
    }
    function aws_cdk_lib_aws_secretsmanager_AttachmentTargetType(p) {
    }
    function aws_cdk_lib_aws_secretsmanager_SecretAttachmentTargetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.targetType) || (p.targetType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_secretsmanager_AttachedSecretOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.target) || (p.target, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_secretsmanager_SecretTargetAttachmentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.secret) || (p.secret, void 0), visitedObjects.has(p.target) || (p.target, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_secretsmanager_ISecretTargetAttachment(p) {
    }
    function aws_cdk_lib_aws_secretsmanager_SecretTargetAttachment(p) {
    }
    function aws_cdk_lib_aws_secretsmanager_SecretStringGenerator(p) {
    }
    function aws_cdk_lib_aws_secretsmanager_RotationScheduleOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.automaticallyAfter) || (p.automaticallyAfter, void 0), visitedObjects.has(p.hostedRotation) || (p.hostedRotation, void 0), visitedObjects.has(p.rotationLambda) || (p.rotationLambda, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_secretsmanager_RotationScheduleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.secret) || (p.secret, void 0), visitedObjects.has(p.automaticallyAfter) || (p.automaticallyAfter, void 0), visitedObjects.has(p.hostedRotation) || (p.hostedRotation, void 0), visitedObjects.has(p.rotationLambda) || (p.rotationLambda, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_secretsmanager_RotationSchedule(p) {
    }
    function aws_cdk_lib_aws_secretsmanager_SingleUserHostedRotationOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_secretsmanager_MultiUserHostedRotationOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.masterSecret) || (p.masterSecret, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_secretsmanager_HostedRotation(p) {
    }
    function aws_cdk_lib_aws_secretsmanager_HostedRotationType(p) {
    }
    function aws_cdk_lib_aws_secretsmanager_ResourcePolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.secret) || (p.secret, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_secretsmanager_ResourcePolicy(p) {
    }
    function aws_cdk_lib_aws_secretsmanager_SecretRotationApplicationOptions(p) {
    }
    function aws_cdk_lib_aws_secretsmanager_SecretRotationApplication(p) {
    }
    function aws_cdk_lib_aws_secretsmanager_SecretRotationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.application) || (p.application, void 0), visitedObjects.has(p.secret) || (p.secret, void 0), visitedObjects.has(p.target) || (p.target, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.automaticallyAfter) || (p.automaticallyAfter, void 0), visitedObjects.has(p.endpoint) || (p.endpoint, void 0), visitedObjects.has(p.masterSecret) || (p.masterSecret, void 0), visitedObjects.has(p.securityGroup) || (p.securityGroup, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_secretsmanager_SecretRotation(p) {
    }
    function aws_cdk_lib_aws_secretsmanager_CfnResourcePolicyProps(p) {
    }
    function aws_cdk_lib_aws_secretsmanager_CfnResourcePolicy(p) {
    }
    function aws_cdk_lib_aws_secretsmanager_CfnRotationScheduleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.hostedRotationLambda) || (p.hostedRotationLambda, void 0), visitedObjects.has(p.rotationRules) || (p.rotationRules, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_secretsmanager_CfnRotationSchedule(p) {
    }
    function aws_cdk_lib_aws_secretsmanager_CfnRotationSchedule_HostedRotationLambdaProperty(p) {
    }
    function aws_cdk_lib_aws_secretsmanager_CfnRotationSchedule_RotationRulesProperty(p) {
    }
    function aws_cdk_lib_aws_secretsmanager_CfnSecretProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.generateSecretString) || (p.generateSecretString, void 0), visitedObjects.has(p.replicaRegions) || (p.replicaRegions, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_secretsmanager_CfnSecret(p) {
    }
    function aws_cdk_lib_aws_secretsmanager_CfnSecret_GenerateSecretStringProperty(p) {
    }
    function aws_cdk_lib_aws_secretsmanager_CfnSecret_ReplicaRegionProperty(p) {
    }
    function aws_cdk_lib_aws_secretsmanager_CfnSecretTargetAttachmentProps(p) {
    }
    function aws_cdk_lib_aws_secretsmanager_CfnSecretTargetAttachment(p) {
    }
    function aws_cdk_lib_aws_securityhub_CfnHubProps(p) {
    }
    function aws_cdk_lib_aws_securityhub_CfnHub(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_MessageLanguage(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CommonConstraintOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.messageLanguage) || (p.messageLanguage, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicecatalog_StackSetsConstraintOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.adminRole) || (p.adminRole, void 0), visitedObjects.has(p.messageLanguage) || (p.messageLanguage, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicecatalog_TagUpdateConstraintOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.messageLanguage) || (p.messageLanguage, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicecatalog_TemplateRuleAssertion(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.assert) || (p.assert, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicecatalog_TemplateRule(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.assertions != null)
            for (const o of p.assertions)
              visitedObjects.has(o) || aws_cdk_lib_aws_servicecatalog_TemplateRuleAssertion(o);
          visitedObjects.has(p.condition) || (p.condition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicecatalog_CloudFormationRuleConstraintOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.rule) || aws_cdk_lib_aws_servicecatalog_TemplateRule(p.rule), visitedObjects.has(p.messageLanguage) || (p.messageLanguage, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicecatalog_CloudFormationTemplate(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CloudFormationTemplateConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.assetBucket) || (p.assetBucket, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicecatalog_PortfolioShareOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.messageLanguage) || (p.messageLanguage, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicecatalog_IPortfolio(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_PortfolioProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.messageLanguage) || (p.messageLanguage, void 0), visitedObjects.has(p.tagOptions) || (p.tagOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicecatalog_Portfolio(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_IProduct(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CloudFormationProductVersion(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cloudFormationTemplate) || (p.cloudFormationTemplate, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicecatalog_CloudFormationProductProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.productVersions != null)
            for (const o of p.productVersions)
              visitedObjects.has(o) || aws_cdk_lib_aws_servicecatalog_CloudFormationProductVersion(o);
          visitedObjects.has(p.messageLanguage) || (p.messageLanguage, void 0), visitedObjects.has(p.tagOptions) || (p.tagOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicecatalog_Product(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CloudFormationProduct(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_ProductStackProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.assetBucket) || (p.assetBucket, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicecatalog_ProductStack(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_ProductStackHistoryProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.productStack) || (p.productStack, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicecatalog_ProductStackHistory(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_TagOptionsProps(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_TagOptions(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnAcceptedPortfolioShareProps(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnAcceptedPortfolioShare(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnCloudFormationProductProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.provisioningArtifactParameters) || (p.provisioningArtifactParameters, void 0), visitedObjects.has(p.sourceConnection) || (p.sourceConnection, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicecatalog_CfnCloudFormationProduct(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnCloudFormationProduct_CodeStarParametersProperty(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnCloudFormationProduct_ConnectionParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.codeStar) || (p.codeStar, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicecatalog_CfnCloudFormationProduct_ProvisioningArtifactPropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnCloudFormationProduct_SourceConnectionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.connectionParameters) || (p.connectionParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicecatalog_CfnCloudFormationProvisionedProductProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.provisioningParameters) || (p.provisioningParameters, void 0), visitedObjects.has(p.provisioningPreferences) || (p.provisioningPreferences, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicecatalog_CfnCloudFormationProvisionedProduct(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnCloudFormationProvisionedProduct_ProvisioningParameterProperty(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnCloudFormationProvisionedProduct_ProvisioningPreferencesProperty(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnLaunchNotificationConstraintProps(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnLaunchNotificationConstraint(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnLaunchRoleConstraintProps(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnLaunchRoleConstraint(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnLaunchTemplateConstraintProps(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnLaunchTemplateConstraint(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnPortfolioProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicecatalog_CfnPortfolio(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnPortfolioPrincipalAssociationProps(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnPortfolioPrincipalAssociation(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnPortfolioProductAssociationProps(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnPortfolioProductAssociation(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnPortfolioShareProps(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnPortfolioShare(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnResourceUpdateConstraintProps(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnResourceUpdateConstraint(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnServiceActionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.definition) || (p.definition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicecatalog_CfnServiceAction(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnServiceAction_DefinitionParameterProperty(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnServiceActionAssociationProps(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnServiceActionAssociation(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnStackSetConstraintProps(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnStackSetConstraint(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnTagOptionProps(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnTagOption(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnTagOptionAssociationProps(p) {
    }
    function aws_cdk_lib_aws_servicecatalog_CfnTagOptionAssociation(p) {
    }
    function aws_cdk_lib_aws_servicecatalogappregistry_CfnApplicationProps(p) {
    }
    function aws_cdk_lib_aws_servicecatalogappregistry_CfnApplication(p) {
    }
    function aws_cdk_lib_aws_servicecatalogappregistry_CfnAttributeGroupProps(p) {
    }
    function aws_cdk_lib_aws_servicecatalogappregistry_CfnAttributeGroup(p) {
    }
    function aws_cdk_lib_aws_servicecatalogappregistry_CfnAttributeGroupAssociationProps(p) {
    }
    function aws_cdk_lib_aws_servicecatalogappregistry_CfnAttributeGroupAssociation(p) {
    }
    function aws_cdk_lib_aws_servicecatalogappregistry_CfnResourceAssociationProps(p) {
    }
    function aws_cdk_lib_aws_servicecatalogappregistry_CfnResourceAssociation(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_IInstance(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_BaseInstanceProps(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_InstanceBase(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_AliasTargetInstanceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.service) || (p.service, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicediscovery_AliasTargetInstance(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_CnameInstanceBaseProps(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_CnameInstanceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.service) || (p.service, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicediscovery_CnameInstance(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_IpInstanceBaseProps(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_IpInstanceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.service) || (p.service, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicediscovery_IpInstance(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_NonIpInstanceBaseProps(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_NonIpInstanceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.service) || (p.service, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicediscovery_NonIpInstance(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_INamespace(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_BaseNamespaceProps(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_NamespaceType(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_HttpNamespaceProps(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_IHttpNamespace(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_HttpNamespaceAttributes(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_HttpNamespace(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_PrivateDnsNamespaceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicediscovery_IPrivateDnsNamespace(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_PrivateDnsNamespaceAttributes(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_PrivateDnsNamespace(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_PublicDnsNamespaceProps(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_IPublicDnsNamespace(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_PublicDnsNamespaceAttributes(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_PublicDnsNamespace(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_IService(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_BaseServiceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customHealthCheck) || (p.customHealthCheck, void 0), visitedObjects.has(p.healthCheck) || aws_cdk_lib_aws_servicediscovery_HealthCheckConfig(p.healthCheck);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicediscovery_DnsServiceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.discoveryType) || (p.discoveryType, void 0), visitedObjects.has(p.dnsRecordType) || (p.dnsRecordType, void 0), visitedObjects.has(p.dnsTtl) || (p.dnsTtl, void 0), visitedObjects.has(p.routingPolicy) || (p.routingPolicy, void 0), visitedObjects.has(p.customHealthCheck) || (p.customHealthCheck, void 0), visitedObjects.has(p.healthCheck) || aws_cdk_lib_aws_servicediscovery_HealthCheckConfig(p.healthCheck);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicediscovery_ServiceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.namespace) || (p.namespace, void 0), visitedObjects.has(p.discoveryType) || (p.discoveryType, void 0), visitedObjects.has(p.dnsRecordType) || (p.dnsRecordType, void 0), visitedObjects.has(p.dnsTtl) || (p.dnsTtl, void 0), visitedObjects.has(p.routingPolicy) || (p.routingPolicy, void 0), visitedObjects.has(p.customHealthCheck) || (p.customHealthCheck, void 0), visitedObjects.has(p.healthCheck) || aws_cdk_lib_aws_servicediscovery_HealthCheckConfig(p.healthCheck);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicediscovery_ServiceAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dnsRecordType) || (p.dnsRecordType, void 0), visitedObjects.has(p.namespace) || (p.namespace, void 0), visitedObjects.has(p.routingPolicy) || (p.routingPolicy, void 0), visitedObjects.has(p.discoveryType) || (p.discoveryType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicediscovery_Service(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_HealthCheckConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.type) || (p.type, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicediscovery_HealthCheckCustomConfig(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_DiscoveryType(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_DnsRecordType(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_RoutingPolicy(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_HealthCheckType(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_CfnHttpNamespaceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicediscovery_CfnHttpNamespace(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_CfnInstanceProps(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_CfnInstance(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_CfnPrivateDnsNamespaceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.properties) || (p.properties, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicediscovery_CfnPrivateDnsNamespace(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_CfnPrivateDnsNamespace_PrivateDnsPropertiesMutableProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.soa) || (p.soa, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicediscovery_CfnPrivateDnsNamespace_PropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dnsProperties) || (p.dnsProperties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicediscovery_CfnPrivateDnsNamespace_SOAProperty(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_CfnPublicDnsNamespaceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.properties) || (p.properties, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicediscovery_CfnPublicDnsNamespace(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_CfnPublicDnsNamespace_PropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dnsProperties) || (p.dnsProperties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicediscovery_CfnPublicDnsNamespace_PublicDnsPropertiesMutableProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.soa) || (p.soa, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicediscovery_CfnPublicDnsNamespace_SOAProperty(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_CfnServiceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.dnsConfig) || (p.dnsConfig, void 0), visitedObjects.has(p.healthCheckConfig) || (p.healthCheckConfig, void 0), visitedObjects.has(p.healthCheckCustomConfig) || (p.healthCheckCustomConfig, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicediscovery_CfnService(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_CfnService_DnsConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dnsRecords) || (p.dnsRecords, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_servicediscovery_CfnService_DnsRecordProperty(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_CfnService_HealthCheckConfigProperty(p) {
    }
    function aws_cdk_lib_aws_servicediscovery_CfnService_HealthCheckCustomConfigProperty(p) {
    }
    function aws_cdk_lib_aws_ses_IReceiptRuleSet(p) {
    }
    function aws_cdk_lib_aws_ses_ReceiptRuleSetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.rules != null)
            for (const o of p.rules)
              visitedObjects.has(o) || aws_cdk_lib_aws_ses_ReceiptRuleOptions(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_ReceiptRuleSet(p) {
    }
    function aws_cdk_lib_aws_ses_IReceiptRule(p) {
    }
    function aws_cdk_lib_aws_ses_TlsPolicy(p) {
    }
    function aws_cdk_lib_aws_ses_ReceiptRuleOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.actions != null)
            for (const o of p.actions)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.after) || (p.after, void 0), visitedObjects.has(p.tlsPolicy) || (p.tlsPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_ReceiptRuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.ruleSet) || (p.ruleSet, void 0), p.actions != null)
            for (const o of p.actions)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.after) || (p.after, void 0), visitedObjects.has(p.tlsPolicy) || (p.tlsPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_ReceiptRule(p) {
    }
    function aws_cdk_lib_aws_ses_DropSpamReceiptRuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.ruleSet) || (p.ruleSet, void 0), p.actions != null)
            for (const o of p.actions)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.after) || (p.after, void 0), visitedObjects.has(p.tlsPolicy) || (p.tlsPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_DropSpamReceiptRule(p) {
    }
    function aws_cdk_lib_aws_ses_IReceiptRuleAction(p) {
    }
    function aws_cdk_lib_aws_ses_AddHeaderActionConfig(p) {
    }
    function aws_cdk_lib_aws_ses_BounceActionConfig(p) {
    }
    function aws_cdk_lib_aws_ses_LambdaActionConfig(p) {
    }
    function aws_cdk_lib_aws_ses_S3ActionConfig(p) {
    }
    function aws_cdk_lib_aws_ses_SNSActionConfig(p) {
    }
    function aws_cdk_lib_aws_ses_StopActionConfig(p) {
    }
    function aws_cdk_lib_aws_ses_WorkmailActionConfig(p) {
    }
    function aws_cdk_lib_aws_ses_ReceiptRuleActionConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.addHeaderAction) || (p.addHeaderAction, void 0), visitedObjects.has(p.bounceAction) || (p.bounceAction, void 0), visitedObjects.has(p.lambdaAction) || (p.lambdaAction, void 0), visitedObjects.has(p.s3Action) || (p.s3Action, void 0), visitedObjects.has(p.snsAction) || (p.snsAction, void 0), visitedObjects.has(p.stopAction) || (p.stopAction, void 0), visitedObjects.has(p.workmailAction) || (p.workmailAction, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_ReceiptFilterPolicy(p) {
    }
    function aws_cdk_lib_aws_ses_ReceiptFilterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.policy) || (p.policy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_ReceiptFilter(p) {
    }
    function aws_cdk_lib_aws_ses_AllowListReceiptFilterProps(p) {
    }
    function aws_cdk_lib_aws_ses_AllowListReceiptFilter(p) {
    }
    function aws_cdk_lib_aws_ses_IDedicatedIpPool(p) {
    }
    function aws_cdk_lib_aws_ses_DedicatedIpPoolProps(p) {
    }
    function aws_cdk_lib_aws_ses_DedicatedIpPool(p) {
    }
    function aws_cdk_lib_aws_ses_IConfigurationSet(p) {
    }
    function aws_cdk_lib_aws_ses_ConfigurationSetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dedicatedIpPool) || (p.dedicatedIpPool, void 0), visitedObjects.has(p.suppressionReasons) || (p.suppressionReasons, void 0), visitedObjects.has(p.tlsPolicy) || (p.tlsPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_ConfigurationSetTlsPolicy(p) {
    }
    function aws_cdk_lib_aws_ses_SuppressionReasons(p) {
    }
    function aws_cdk_lib_aws_ses_ConfigurationSet(p) {
    }
    function aws_cdk_lib_aws_ses_IEmailIdentity(p) {
    }
    function aws_cdk_lib_aws_ses_EmailIdentityProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.identity) || (p.identity, void 0), visitedObjects.has(p.configurationSet) || (p.configurationSet, void 0), visitedObjects.has(p.dkimIdentity) || (p.dkimIdentity, void 0), visitedObjects.has(p.mailFromBehaviorOnMxFailure) || (p.mailFromBehaviorOnMxFailure, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_Identity(p) {
    }
    function aws_cdk_lib_aws_ses_MailFromBehaviorOnMxFailure(p) {
    }
    function aws_cdk_lib_aws_ses_DkimIdentityConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.nextSigningKeyLength) || (p.nextSigningKeyLength, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_DkimIdentity(p) {
    }
    function aws_cdk_lib_aws_ses_ByoDkimOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.privateKey) || (p.privateKey, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_EasyDkimSigningKeyLength(p) {
    }
    function aws_cdk_lib_aws_ses_EmailIdentity(p) {
    }
    function aws_cdk_lib_aws_ses_DkimRecord(p) {
    }
    function aws_cdk_lib_aws_ses_IVdmAttributes(p) {
    }
    function aws_cdk_lib_aws_ses_VdmAttributesProps(p) {
    }
    function aws_cdk_lib_aws_ses_VdmAttributes(p) {
    }
    function aws_cdk_lib_aws_ses_IConfigurationSetEventDestination(p) {
    }
    function aws_cdk_lib_aws_ses_ConfigurationSetEventDestinationOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.destination) || (p.destination, void 0), p.events != null)
            for (const o of p.events)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_EventDestination(p) {
    }
    function aws_cdk_lib_aws_ses_ConfigurationSetEventDestinationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.configurationSet) || (p.configurationSet, void 0), visitedObjects.has(p.destination) || (p.destination, void 0), p.events != null)
            for (const o of p.events)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_EmailSendingEvent(p) {
    }
    function aws_cdk_lib_aws_ses_CloudWatchDimension(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.source) || (p.source, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_CloudWatchDimensionSource(p) {
    }
    function aws_cdk_lib_aws_ses_ConfigurationSetEventDestination(p) {
    }
    function aws_cdk_lib_aws_ses_CfnConfigurationSetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.deliveryOptions) || (p.deliveryOptions, void 0), visitedObjects.has(p.reputationOptions) || (p.reputationOptions, void 0), visitedObjects.has(p.sendingOptions) || (p.sendingOptions, void 0), visitedObjects.has(p.suppressionOptions) || (p.suppressionOptions, void 0), visitedObjects.has(p.trackingOptions) || (p.trackingOptions, void 0), visitedObjects.has(p.vdmOptions) || (p.vdmOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_CfnConfigurationSet(p) {
    }
    function aws_cdk_lib_aws_ses_CfnConfigurationSet_DashboardOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_ses_CfnConfigurationSet_DeliveryOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_ses_CfnConfigurationSet_GuardianOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_ses_CfnConfigurationSet_ReputationOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_ses_CfnConfigurationSet_SendingOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_ses_CfnConfigurationSet_SuppressionOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_ses_CfnConfigurationSet_TrackingOptionsProperty(p) {
    }
    function aws_cdk_lib_aws_ses_CfnConfigurationSet_VdmOptionsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dashboardOptions) || (p.dashboardOptions, void 0), visitedObjects.has(p.guardianOptions) || (p.guardianOptions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_CfnConfigurationSetEventDestinationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.eventDestination) || (p.eventDestination, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_CfnConfigurationSetEventDestination(p) {
    }
    function aws_cdk_lib_aws_ses_CfnConfigurationSetEventDestination_CloudWatchDestinationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dimensionConfigurations) || (p.dimensionConfigurations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_CfnConfigurationSetEventDestination_DimensionConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_ses_CfnConfigurationSetEventDestination_EventDestinationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cloudWatchDestination) || (p.cloudWatchDestination, void 0), visitedObjects.has(p.kinesisFirehoseDestination) || (p.kinesisFirehoseDestination, void 0), visitedObjects.has(p.snsDestination) || (p.snsDestination, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_CfnConfigurationSetEventDestination_KinesisFirehoseDestinationProperty(p) {
    }
    function aws_cdk_lib_aws_ses_CfnConfigurationSetEventDestination_SnsDestinationProperty(p) {
    }
    function aws_cdk_lib_aws_ses_CfnContactListProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.topics) || (p.topics, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_CfnContactList(p) {
    }
    function aws_cdk_lib_aws_ses_CfnContactList_TopicProperty(p) {
    }
    function aws_cdk_lib_aws_ses_CfnDedicatedIpPoolProps(p) {
    }
    function aws_cdk_lib_aws_ses_CfnDedicatedIpPool(p) {
    }
    function aws_cdk_lib_aws_ses_CfnEmailIdentityProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.configurationSetAttributes) || (p.configurationSetAttributes, void 0), visitedObjects.has(p.dkimAttributes) || (p.dkimAttributes, void 0), visitedObjects.has(p.dkimSigningAttributes) || (p.dkimSigningAttributes, void 0), visitedObjects.has(p.feedbackAttributes) || (p.feedbackAttributes, void 0), visitedObjects.has(p.mailFromAttributes) || (p.mailFromAttributes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_CfnEmailIdentity(p) {
    }
    function aws_cdk_lib_aws_ses_CfnEmailIdentity_ConfigurationSetAttributesProperty(p) {
    }
    function aws_cdk_lib_aws_ses_CfnEmailIdentity_DkimAttributesProperty(p) {
    }
    function aws_cdk_lib_aws_ses_CfnEmailIdentity_DkimSigningAttributesProperty(p) {
    }
    function aws_cdk_lib_aws_ses_CfnEmailIdentity_FeedbackAttributesProperty(p) {
    }
    function aws_cdk_lib_aws_ses_CfnEmailIdentity_MailFromAttributesProperty(p) {
    }
    function aws_cdk_lib_aws_ses_CfnReceiptFilterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.filter) || (p.filter, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_CfnReceiptFilter(p) {
    }
    function aws_cdk_lib_aws_ses_CfnReceiptFilter_FilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ipFilter) || (p.ipFilter, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_CfnReceiptFilter_IpFilterProperty(p) {
    }
    function aws_cdk_lib_aws_ses_CfnReceiptRuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.rule) || (p.rule, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_CfnReceiptRule(p) {
    }
    function aws_cdk_lib_aws_ses_CfnReceiptRule_ActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.addHeaderAction) || (p.addHeaderAction, void 0), visitedObjects.has(p.bounceAction) || (p.bounceAction, void 0), visitedObjects.has(p.lambdaAction) || (p.lambdaAction, void 0), visitedObjects.has(p.s3Action) || (p.s3Action, void 0), visitedObjects.has(p.snsAction) || (p.snsAction, void 0), visitedObjects.has(p.stopAction) || (p.stopAction, void 0), visitedObjects.has(p.workmailAction) || (p.workmailAction, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_CfnReceiptRule_AddHeaderActionProperty(p) {
    }
    function aws_cdk_lib_aws_ses_CfnReceiptRule_BounceActionProperty(p) {
    }
    function aws_cdk_lib_aws_ses_CfnReceiptRule_LambdaActionProperty(p) {
    }
    function aws_cdk_lib_aws_ses_CfnReceiptRule_RuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actions) || (p.actions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_CfnReceiptRule_S3ActionProperty(p) {
    }
    function aws_cdk_lib_aws_ses_CfnReceiptRule_SNSActionProperty(p) {
    }
    function aws_cdk_lib_aws_ses_CfnReceiptRule_StopActionProperty(p) {
    }
    function aws_cdk_lib_aws_ses_CfnReceiptRule_WorkmailActionProperty(p) {
    }
    function aws_cdk_lib_aws_ses_CfnReceiptRuleSetProps(p) {
    }
    function aws_cdk_lib_aws_ses_CfnReceiptRuleSet(p) {
    }
    function aws_cdk_lib_aws_ses_CfnTemplateProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.template) || (p.template, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_CfnTemplate(p) {
    }
    function aws_cdk_lib_aws_ses_CfnTemplate_TemplateProperty(p) {
    }
    function aws_cdk_lib_aws_ses_CfnVdmAttributesProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dashboardAttributes) || (p.dashboardAttributes, void 0), visitedObjects.has(p.guardianAttributes) || (p.guardianAttributes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_CfnVdmAttributes(p) {
    }
    function aws_cdk_lib_aws_ses_CfnVdmAttributes_DashboardAttributesProperty(p) {
    }
    function aws_cdk_lib_aws_ses_CfnVdmAttributes_GuardianAttributesProperty(p) {
    }
    function aws_cdk_lib_aws_ses_actions_AddHeaderProps(p) {
    }
    function aws_cdk_lib_aws_ses_actions_AddHeader(p) {
    }
    function aws_cdk_lib_aws_ses_actions_BounceTemplateProps(p) {
    }
    function aws_cdk_lib_aws_ses_actions_BounceTemplate(p) {
    }
    function aws_cdk_lib_aws_ses_actions_BounceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.template) || (p.template, void 0), visitedObjects.has(p.topic) || (p.topic, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_actions_Bounce(p) {
    }
    function aws_cdk_lib_aws_ses_actions_LambdaInvocationType(p) {
    }
    function aws_cdk_lib_aws_ses_actions_LambdaProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.function) || (p.function, void 0), visitedObjects.has(p.invocationType) || (p.invocationType, void 0), visitedObjects.has(p.topic) || (p.topic, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_actions_Lambda(p) {
    }
    function aws_cdk_lib_aws_ses_actions_S3Props(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bucket) || (p.bucket, void 0), visitedObjects.has(p.kmsKey) || (p.kmsKey, void 0), visitedObjects.has(p.topic) || (p.topic, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_actions_S3(p) {
    }
    function aws_cdk_lib_aws_ses_actions_EmailEncoding(p) {
    }
    function aws_cdk_lib_aws_ses_actions_SnsProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.topic) || (p.topic, void 0), visitedObjects.has(p.encoding) || (p.encoding, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_actions_Sns(p) {
    }
    function aws_cdk_lib_aws_ses_actions_StopProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.topic) || (p.topic, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ses_actions_Stop(p) {
    }
    function aws_cdk_lib_aws_signer_CfnProfilePermissionProps(p) {
    }
    function aws_cdk_lib_aws_signer_CfnProfilePermission(p) {
    }
    function aws_cdk_lib_aws_signer_CfnSigningProfileProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.signatureValidityPeriod) || (p.signatureValidityPeriod, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_signer_CfnSigningProfile(p) {
    }
    function aws_cdk_lib_aws_signer_CfnSigningProfile_SignatureValidityPeriodProperty(p) {
    }
    function aws_cdk_lib_aws_signer_Platform(p) {
    }
    function aws_cdk_lib_aws_signer_ISigningProfile(p) {
    }
    function aws_cdk_lib_aws_signer_SigningProfileProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.platform) || (p.platform, void 0), visitedObjects.has(p.signatureValidity) || (p.signatureValidity, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_signer_SigningProfileAttributes(p) {
    }
    function aws_cdk_lib_aws_signer_SigningProfile(p) {
    }
    function aws_cdk_lib_aws_simspaceweaver_CfnSimulationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.schemaS3Location) || (p.schemaS3Location, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_simspaceweaver_CfnSimulation(p) {
    }
    function aws_cdk_lib_aws_simspaceweaver_CfnSimulation_S3LocationProperty(p) {
    }
    function aws_cdk_lib_aws_sns_TopicPolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.topics != null)
            for (const o of p.topics)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.policyDocument) || (p.policyDocument, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sns_TopicPolicy(p) {
    }
    function aws_cdk_lib_aws_sns_TopicProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.masterKey) || (p.masterKey, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sns_Topic(p) {
    }
    function aws_cdk_lib_aws_sns_ITopic(p) {
    }
    function aws_cdk_lib_aws_sns_TopicBase(p) {
    }
    function aws_cdk_lib_aws_sns_SubscriptionOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.protocol) || (p.protocol, void 0), visitedObjects.has(p.deadLetterQueue) || (p.deadLetterQueue, void 0), p.filterPolicy != null)
            for (const o of Object.values(p.filterPolicy))
              visitedObjects.has(o) || void 0;
          if (p.filterPolicyWithMessageBody != null)
            for (const o of Object.values(p.filterPolicyWithMessageBody))
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sns_SubscriptionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.topic) || (p.topic, void 0), visitedObjects.has(p.protocol) || (p.protocol, void 0), visitedObjects.has(p.deadLetterQueue) || (p.deadLetterQueue, void 0), p.filterPolicy != null)
            for (const o of Object.values(p.filterPolicy))
              visitedObjects.has(o) || void 0;
          if (p.filterPolicyWithMessageBody != null)
            for (const o of Object.values(p.filterPolicyWithMessageBody))
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sns_Subscription(p) {
    }
    function aws_cdk_lib_aws_sns_SubscriptionProtocol(p) {
    }
    function aws_cdk_lib_aws_sns_FilterOrPolicyType(p) {
    }
    function aws_cdk_lib_aws_sns_FilterOrPolicy(p) {
    }
    function aws_cdk_lib_aws_sns_Filter(p) {
    }
    function aws_cdk_lib_aws_sns_Policy(p) {
    }
    function aws_cdk_lib_aws_sns_TopicSubscriptionConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.protocol) || (p.protocol, void 0), visitedObjects.has(p.deadLetterQueue) || (p.deadLetterQueue, void 0), p.filterPolicy != null)
            for (const o of Object.values(p.filterPolicy))
              visitedObjects.has(o) || void 0;
          if (p.filterPolicyWithMessageBody != null)
            for (const o of Object.values(p.filterPolicyWithMessageBody))
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sns_ITopicSubscription(p) {
    }
    function aws_cdk_lib_aws_sns_StringConditions(p) {
    }
    function aws_cdk_lib_aws_sns_BetweenCondition(p) {
    }
    function aws_cdk_lib_aws_sns_NumericConditions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.between) || (p.between, void 0), visitedObjects.has(p.betweenStrict) || (p.betweenStrict, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sns_SubscriptionFilter(p) {
    }
    function aws_cdk_lib_aws_sns_CfnSubscriptionProps(p) {
    }
    function aws_cdk_lib_aws_sns_CfnSubscription(p) {
    }
    function aws_cdk_lib_aws_sns_CfnTopicProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.subscription) || (p.subscription, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sns_CfnTopic(p) {
    }
    function aws_cdk_lib_aws_sns_CfnTopic_SubscriptionProperty(p) {
    }
    function aws_cdk_lib_aws_sns_CfnTopicPolicyProps(p) {
    }
    function aws_cdk_lib_aws_sns_CfnTopicPolicy(p) {
    }
    function aws_cdk_lib_aws_sns_subscriptions_SubscriptionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.deadLetterQueue) || (p.deadLetterQueue, void 0), p.filterPolicy != null)
            for (const o of Object.values(p.filterPolicy))
              visitedObjects.has(o) || void 0;
          if (p.filterPolicyWithMessageBody != null)
            for (const o of Object.values(p.filterPolicyWithMessageBody))
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sns_subscriptions_EmailSubscriptionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.deadLetterQueue) || (p.deadLetterQueue, void 0), p.filterPolicy != null)
            for (const o of Object.values(p.filterPolicy))
              visitedObjects.has(o) || void 0;
          if (p.filterPolicyWithMessageBody != null)
            for (const o of Object.values(p.filterPolicyWithMessageBody))
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sns_subscriptions_EmailSubscription(p) {
    }
    function aws_cdk_lib_aws_sns_subscriptions_LambdaSubscriptionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.deadLetterQueue) || (p.deadLetterQueue, void 0), p.filterPolicy != null)
            for (const o of Object.values(p.filterPolicy))
              visitedObjects.has(o) || void 0;
          if (p.filterPolicyWithMessageBody != null)
            for (const o of Object.values(p.filterPolicyWithMessageBody))
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sns_subscriptions_LambdaSubscription(p) {
    }
    function aws_cdk_lib_aws_sns_subscriptions_SqsSubscriptionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.deadLetterQueue) || (p.deadLetterQueue, void 0), p.filterPolicy != null)
            for (const o of Object.values(p.filterPolicy))
              visitedObjects.has(o) || void 0;
          if (p.filterPolicyWithMessageBody != null)
            for (const o of Object.values(p.filterPolicyWithMessageBody))
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sns_subscriptions_SqsSubscription(p) {
    }
    function aws_cdk_lib_aws_sns_subscriptions_UrlSubscriptionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.protocol) || (p.protocol, void 0), visitedObjects.has(p.deadLetterQueue) || (p.deadLetterQueue, void 0), p.filterPolicy != null)
            for (const o of Object.values(p.filterPolicy))
              visitedObjects.has(o) || void 0;
          if (p.filterPolicyWithMessageBody != null)
            for (const o of Object.values(p.filterPolicyWithMessageBody))
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sns_subscriptions_UrlSubscription(p) {
    }
    function aws_cdk_lib_aws_sns_subscriptions_SmsSubscriptionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.deadLetterQueue) || (p.deadLetterQueue, void 0), p.filterPolicy != null)
            for (const o of Object.values(p.filterPolicy))
              visitedObjects.has(o) || void 0;
          if (p.filterPolicyWithMessageBody != null)
            for (const o of Object.values(p.filterPolicyWithMessageBody))
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sns_subscriptions_SmsSubscription(p) {
    }
    function aws_cdk_lib_aws_sqs_QueuePolicyProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.queues != null)
            for (const o of p.queues)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sqs_QueuePolicy(p) {
    }
    function aws_cdk_lib_aws_sqs_QueueProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataKeyReuse) || (p.dataKeyReuse, void 0), visitedObjects.has(p.deadLetterQueue) || aws_cdk_lib_aws_sqs_DeadLetterQueue(p.deadLetterQueue), visitedObjects.has(p.deduplicationScope) || (p.deduplicationScope, void 0), visitedObjects.has(p.deliveryDelay) || (p.deliveryDelay, void 0), visitedObjects.has(p.encryption) || (p.encryption, void 0), visitedObjects.has(p.encryptionMasterKey) || (p.encryptionMasterKey, void 0), visitedObjects.has(p.fifoThroughputLimit) || (p.fifoThroughputLimit, void 0), visitedObjects.has(p.receiveMessageWaitTime) || (p.receiveMessageWaitTime, void 0), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), visitedObjects.has(p.retentionPeriod) || (p.retentionPeriod, void 0), visitedObjects.has(p.visibilityTimeout) || (p.visibilityTimeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sqs_DeadLetterQueue(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.queue) || (p.queue, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sqs_QueueEncryption(p) {
    }
    function aws_cdk_lib_aws_sqs_DeduplicationScope(p) {
    }
    function aws_cdk_lib_aws_sqs_FifoThroughputLimit(p) {
    }
    function aws_cdk_lib_aws_sqs_Queue(p) {
    }
    function aws_cdk_lib_aws_sqs_IQueue(p) {
    }
    function aws_cdk_lib_aws_sqs_QueueBase(p) {
    }
    function aws_cdk_lib_aws_sqs_QueueAttributes(p) {
    }
    function aws_cdk_lib_aws_sqs_CfnQueueProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sqs_CfnQueue(p) {
    }
    function aws_cdk_lib_aws_sqs_CfnQueuePolicyProps(p) {
    }
    function aws_cdk_lib_aws_sqs_CfnQueuePolicy(p) {
    }
    function aws_cdk_lib_aws_ssm_IParameter(p) {
    }
    function aws_cdk_lib_aws_ssm_IStringParameter(p) {
    }
    function aws_cdk_lib_aws_ssm_IStringListParameter(p) {
    }
    function aws_cdk_lib_aws_ssm_ParameterOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tier) || (p.tier, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssm_StringParameterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataType) || (p.dataType, void 0), "type" in p && print("aws-cdk-lib.aws_ssm.StringParameterProps#type", "- type will always be 'String'"), visitedObjects.has(p.type) || aws_cdk_lib_aws_ssm_ParameterType(p.type), visitedObjects.has(p.tier) || (p.tier, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssm_StringListParameterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tier) || (p.tier, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssm_ParameterValueType(p) {
    }
    function aws_cdk_lib_aws_ssm_ParameterType(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          print("aws-cdk-lib.aws_ssm.ParameterType", "these types are no longer used");
          const ns = require_parameter();
          if (Object.values(ns.ParameterType).filter((x) => x === p).length > 1)
            return;
          p === ns.ParameterType.STRING && print("aws-cdk-lib.aws_ssm.ParameterType#STRING", ""), p === ns.ParameterType.SECURE_STRING && print("aws-cdk-lib.aws_ssm.ParameterType#SECURE_STRING", ""), p === ns.ParameterType.STRING_LIST && print("aws-cdk-lib.aws_ssm.ParameterType#STRING_LIST", ""), p === ns.ParameterType.AWS_EC2_IMAGE_ID && print("aws-cdk-lib.aws_ssm.ParameterType#AWS_EC2_IMAGE_ID", "");
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssm_ParameterDataType(p) {
    }
    function aws_cdk_lib_aws_ssm_ParameterTier(p) {
    }
    function aws_cdk_lib_aws_ssm_CommonStringParameterAttributes(p) {
    }
    function aws_cdk_lib_aws_ssm_StringParameterAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          "type" in p && print("aws-cdk-lib.aws_ssm.StringParameterAttributes#type", "- use valueType instead"), visitedObjects.has(p.type) || aws_cdk_lib_aws_ssm_ParameterType(p.type), visitedObjects.has(p.valueType) || (p.valueType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssm_ListParameterAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.elementType) || (p.elementType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssm_SecureStringParameterAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.encryptionKey) || (p.encryptionKey, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssm_StringParameter(p) {
    }
    function aws_cdk_lib_aws_ssm_StringListParameter(p) {
    }
    function aws_cdk_lib_aws_ssm_CfnAssociationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.outputLocation) || (p.outputLocation, void 0), visitedObjects.has(p.targets) || (p.targets, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssm_CfnAssociation(p) {
    }
    function aws_cdk_lib_aws_ssm_CfnAssociation_InstanceAssociationOutputLocationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3Location) || (p.s3Location, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssm_CfnAssociation_S3OutputLocationProperty(p) {
    }
    function aws_cdk_lib_aws_ssm_CfnAssociation_TargetProperty(p) {
    }
    function aws_cdk_lib_aws_ssm_CfnDocumentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.attachments) || (p.attachments, void 0), visitedObjects.has(p.requires) || (p.requires, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssm_CfnDocument(p) {
    }
    function aws_cdk_lib_aws_ssm_CfnDocument_AttachmentsSourceProperty(p) {
    }
    function aws_cdk_lib_aws_ssm_CfnDocument_DocumentRequiresProperty(p) {
    }
    function aws_cdk_lib_aws_ssm_CfnMaintenanceWindowProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssm_CfnMaintenanceWindow(p) {
    }
    function aws_cdk_lib_aws_ssm_CfnMaintenanceWindowTargetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.targets) || (p.targets, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssm_CfnMaintenanceWindowTarget(p) {
    }
    function aws_cdk_lib_aws_ssm_CfnMaintenanceWindowTarget_TargetsProperty(p) {
    }
    function aws_cdk_lib_aws_ssm_CfnMaintenanceWindowTaskProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.loggingInfo) || (p.loggingInfo, void 0), visitedObjects.has(p.targets) || (p.targets, void 0), visitedObjects.has(p.taskInvocationParameters) || (p.taskInvocationParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssm_CfnMaintenanceWindowTask(p) {
    }
    function aws_cdk_lib_aws_ssm_CfnMaintenanceWindowTask_CloudWatchOutputConfigProperty(p) {
    }
    function aws_cdk_lib_aws_ssm_CfnMaintenanceWindowTask_LoggingInfoProperty(p) {
    }
    function aws_cdk_lib_aws_ssm_CfnMaintenanceWindowTask_MaintenanceWindowAutomationParametersProperty(p) {
    }
    function aws_cdk_lib_aws_ssm_CfnMaintenanceWindowTask_MaintenanceWindowLambdaParametersProperty(p) {
    }
    function aws_cdk_lib_aws_ssm_CfnMaintenanceWindowTask_MaintenanceWindowRunCommandParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cloudWatchOutputConfig) || (p.cloudWatchOutputConfig, void 0), visitedObjects.has(p.notificationConfig) || (p.notificationConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssm_CfnMaintenanceWindowTask_MaintenanceWindowStepFunctionsParametersProperty(p) {
    }
    function aws_cdk_lib_aws_ssm_CfnMaintenanceWindowTask_NotificationConfigProperty(p) {
    }
    function aws_cdk_lib_aws_ssm_CfnMaintenanceWindowTask_TargetProperty(p) {
    }
    function aws_cdk_lib_aws_ssm_CfnMaintenanceWindowTask_TaskInvocationParametersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.maintenanceWindowAutomationParameters) || (p.maintenanceWindowAutomationParameters, void 0), visitedObjects.has(p.maintenanceWindowLambdaParameters) || (p.maintenanceWindowLambdaParameters, void 0), visitedObjects.has(p.maintenanceWindowRunCommandParameters) || (p.maintenanceWindowRunCommandParameters, void 0), visitedObjects.has(p.maintenanceWindowStepFunctionsParameters) || (p.maintenanceWindowStepFunctionsParameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssm_CfnParameterProps(p) {
    }
    function aws_cdk_lib_aws_ssm_CfnParameter(p) {
    }
    function aws_cdk_lib_aws_ssm_CfnPatchBaselineProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.approvalRules) || (p.approvalRules, void 0), visitedObjects.has(p.globalFilters) || (p.globalFilters, void 0), visitedObjects.has(p.sources) || (p.sources, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssm_CfnPatchBaseline(p) {
    }
    function aws_cdk_lib_aws_ssm_CfnPatchBaseline_PatchFilterProperty(p) {
    }
    function aws_cdk_lib_aws_ssm_CfnPatchBaseline_PatchFilterGroupProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.patchFilters) || (p.patchFilters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssm_CfnPatchBaseline_PatchSourceProperty(p) {
    }
    function aws_cdk_lib_aws_ssm_CfnPatchBaseline_RuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.patchFilterGroup) || (p.patchFilterGroup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssm_CfnPatchBaseline_RuleGroupProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.patchRules) || (p.patchRules, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssm_CfnResourceDataSyncProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3Destination) || (p.s3Destination, void 0), visitedObjects.has(p.syncSource) || (p.syncSource, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssm_CfnResourceDataSync(p) {
    }
    function aws_cdk_lib_aws_ssm_CfnResourceDataSync_AwsOrganizationsSourceProperty(p) {
    }
    function aws_cdk_lib_aws_ssm_CfnResourceDataSync_S3DestinationProperty(p) {
    }
    function aws_cdk_lib_aws_ssm_CfnResourceDataSync_SyncSourceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.awsOrganizationsSource) || (p.awsOrganizationsSource, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssm_CfnResourcePolicyProps(p) {
    }
    function aws_cdk_lib_aws_ssm_CfnResourcePolicy(p) {
    }
    function aws_cdk_lib_aws_ssmcontacts_CfnContactProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.plan) || (p.plan, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssmcontacts_CfnContact(p) {
    }
    function aws_cdk_lib_aws_ssmcontacts_CfnContact_ChannelTargetInfoProperty(p) {
    }
    function aws_cdk_lib_aws_ssmcontacts_CfnContact_ContactTargetInfoProperty(p) {
    }
    function aws_cdk_lib_aws_ssmcontacts_CfnContact_StageProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.targets) || (p.targets, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssmcontacts_CfnContact_TargetsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.channelTargetInfo) || (p.channelTargetInfo, void 0), visitedObjects.has(p.contactTargetInfo) || (p.contactTargetInfo, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssmcontacts_CfnContactChannelProps(p) {
    }
    function aws_cdk_lib_aws_ssmcontacts_CfnContactChannel(p) {
    }
    function aws_cdk_lib_aws_ssmcontacts_CfnPlanProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.stages) || (p.stages, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssmcontacts_CfnPlan(p) {
    }
    function aws_cdk_lib_aws_ssmcontacts_CfnPlan_ChannelTargetInfoProperty(p) {
    }
    function aws_cdk_lib_aws_ssmcontacts_CfnPlan_ContactTargetInfoProperty(p) {
    }
    function aws_cdk_lib_aws_ssmcontacts_CfnPlan_StageProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.targets) || (p.targets, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssmcontacts_CfnPlan_TargetsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.channelTargetInfo) || (p.channelTargetInfo, void 0), visitedObjects.has(p.contactTargetInfo) || (p.contactTargetInfo, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssmcontacts_CfnRotationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.recurrence) || (p.recurrence, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssmcontacts_CfnRotation(p) {
    }
    function aws_cdk_lib_aws_ssmcontacts_CfnRotation_CoverageTimeProperty(p) {
    }
    function aws_cdk_lib_aws_ssmcontacts_CfnRotation_MonthlySettingProperty(p) {
    }
    function aws_cdk_lib_aws_ssmcontacts_CfnRotation_RecurrenceSettingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.monthlySettings) || (p.monthlySettings, void 0), visitedObjects.has(p.shiftCoverages) || (p.shiftCoverages, void 0), visitedObjects.has(p.weeklySettings) || (p.weeklySettings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssmcontacts_CfnRotation_ShiftCoverageProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.coverageTimes) || (p.coverageTimes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssmcontacts_CfnRotation_WeeklySettingProperty(p) {
    }
    function aws_cdk_lib_aws_ssmincidents_CfnReplicationSetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.regions) || (p.regions, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssmincidents_CfnReplicationSet(p) {
    }
    function aws_cdk_lib_aws_ssmincidents_CfnReplicationSet_RegionConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_ssmincidents_CfnReplicationSet_ReplicationRegionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.regionConfiguration) || (p.regionConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssmincidents_CfnResponsePlanProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.incidentTemplate) || (p.incidentTemplate, void 0), visitedObjects.has(p.actions) || (p.actions, void 0), visitedObjects.has(p.chatChannel) || (p.chatChannel, void 0), visitedObjects.has(p.integrations) || (p.integrations, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssmincidents_CfnResponsePlan(p) {
    }
    function aws_cdk_lib_aws_ssmincidents_CfnResponsePlan_ActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ssmAutomation) || (p.ssmAutomation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssmincidents_CfnResponsePlan_ChatChannelProperty(p) {
    }
    function aws_cdk_lib_aws_ssmincidents_CfnResponsePlan_DynamicSsmParameterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssmincidents_CfnResponsePlan_DynamicSsmParameterValueProperty(p) {
    }
    function aws_cdk_lib_aws_ssmincidents_CfnResponsePlan_IncidentTemplateProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.incidentTags) || (p.incidentTags, void 0), visitedObjects.has(p.notificationTargets) || (p.notificationTargets, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssmincidents_CfnResponsePlan_IntegrationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.pagerDutyConfiguration) || (p.pagerDutyConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssmincidents_CfnResponsePlan_NotificationTargetItemProperty(p) {
    }
    function aws_cdk_lib_aws_ssmincidents_CfnResponsePlan_PagerDutyConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.pagerDutyIncidentConfiguration) || (p.pagerDutyIncidentConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssmincidents_CfnResponsePlan_PagerDutyIncidentConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_ssmincidents_CfnResponsePlan_SsmAutomationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dynamicParameters) || (p.dynamicParameters, void 0), visitedObjects.has(p.parameters) || (p.parameters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_ssmincidents_CfnResponsePlan_SsmParameterProperty(p) {
    }
    function aws_cdk_lib_aws_sso_CfnAssignmentProps(p) {
    }
    function aws_cdk_lib_aws_sso_CfnAssignment(p) {
    }
    function aws_cdk_lib_aws_sso_CfnInstanceAccessControlAttributeConfigurationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.accessControlAttributes) || (p.accessControlAttributes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sso_CfnInstanceAccessControlAttributeConfiguration(p) {
    }
    function aws_cdk_lib_aws_sso_CfnInstanceAccessControlAttributeConfiguration_AccessControlAttributeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.value) || (p.value, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sso_CfnInstanceAccessControlAttributeConfiguration_AccessControlAttributeValueProperty(p) {
    }
    function aws_cdk_lib_aws_sso_CfnPermissionSetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.customerManagedPolicyReferences) || (p.customerManagedPolicyReferences, void 0), visitedObjects.has(p.permissionsBoundary) || (p.permissionsBoundary, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_sso_CfnPermissionSet(p) {
    }
    function aws_cdk_lib_aws_sso_CfnPermissionSet_CustomerManagedPolicyReferenceProperty(p) {
    }
    function aws_cdk_lib_aws_sso_CfnPermissionSet_PermissionsBoundaryProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customerManagedPolicyReference) || (p.customerManagedPolicyReference, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_JsonPath(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_FieldUtils(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_ActivityProps(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_Activity(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_IActivity(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_TaskInput(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_InputType(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_INextable(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_IChainable(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_Errors(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_RetryProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.interval) || (p.interval, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_CatchProps(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_Condition(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_StateMachineType(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_LogLevel(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_LogOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destination) || (p.destination, void 0), visitedObjects.has(p.level) || (p.level, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_StateMachineProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.definition) || (p.definition, void 0), visitedObjects.has(p.logs) || aws_cdk_lib_aws_stepfunctions_LogOptions(p.logs), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), visitedObjects.has(p.role) || (p.role, void 0), visitedObjects.has(p.stateMachineType) || (p.stateMachineType, void 0), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_StateMachine(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_IStateMachine(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_StateMachineFragment(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_SingleStateOptions(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_StateTransitionMetric(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_Chain(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_StateGraph(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_ServiceIntegrationPattern(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_ChoiceProps(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_Choice(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_AfterwardsOptions(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_FailProps(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_Fail(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_ParallelProps(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_Parallel(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_Result(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_PassProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.result) || (p.result, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_Pass(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_StateProps(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_State(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_FindStateOptions(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_SucceedProps(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_Succeed(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_WaitTime(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_WaitProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.time) || (p.time, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_Wait(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_MapProps(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_Map(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_CustomStateProps(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_CustomState(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_TaskStateBaseProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_TaskStateBase(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_TaskMetricsConfig(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_IntegrationPattern(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_Timeout(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_Credentials(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_TaskRole(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_CfnActivityProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_CfnActivity(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_CfnActivity_TagsEntryProperty(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_CfnStateMachineProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.definitionS3Location) || (p.definitionS3Location, void 0), visitedObjects.has(p.definitionSubstitutions) || (p.definitionSubstitutions, void 0), visitedObjects.has(p.loggingConfiguration) || (p.loggingConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.tracingConfiguration) || (p.tracingConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_CfnStateMachine(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_CfnStateMachine_CloudWatchLogsLogGroupProperty(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_CfnStateMachine_LogDestinationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cloudWatchLogsLogGroup) || (p.cloudWatchLogsLogGroup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_CfnStateMachine_LoggingConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destinations) || (p.destinations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_CfnStateMachine_S3LocationProperty(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_CfnStateMachine_TagsEntryProperty(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_CfnStateMachine_TracingConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_LambdaInvokeProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.lambdaFunction) || (p.lambdaFunction, void 0), visitedObjects.has(p.invocationType) || (p.invocationType, void 0), visitedObjects.has(p.payload) || (p.payload, void 0), "qualifier" in p && print("aws-cdk-lib.aws_stepfunctions_tasks.LambdaInvokeProps#qualifier", "pass a Version or Alias object as lambdaFunction instead"), visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_LambdaInvoke(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_LambdaInvocationType(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_CommonEcsRunTaskProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.cluster) || (p.cluster, void 0), visitedObjects.has(p.taskDefinition) || (p.taskDefinition, void 0), p.containerOverrides != null)
            for (const o of p.containerOverrides)
              visitedObjects.has(o) || aws_cdk_lib_aws_stepfunctions_tasks_ContainerOverride(o);
          visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_ContainerOverride(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.containerDefinition) || (p.containerDefinition, void 0), p.environment != null)
            for (const o of p.environment)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_TaskEnvironmentVariable(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_MessageAttributeDataType(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_MessageAttribute(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataType) || (p.dataType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_SnsPublishProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.message) || (p.message, void 0), visitedObjects.has(p.topic) || (p.topic, void 0), p.messageAttributes != null)
            for (const o of Object.values(p.messageAttributes))
              visitedObjects.has(o) || aws_cdk_lib_aws_stepfunctions_tasks_MessageAttribute(o);
          visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_SnsPublish(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_SqsSendMessageProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.messageBody) || (p.messageBody, void 0), visitedObjects.has(p.queue) || (p.queue, void 0), visitedObjects.has(p.delay) || (p.delay, void 0), visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_SqsSendMessage(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EcsRunTaskProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.cluster) || (p.cluster, void 0), visitedObjects.has(p.launchTarget) || (p.launchTarget, void 0), visitedObjects.has(p.taskDefinition) || (p.taskDefinition, void 0), p.containerOverrides != null)
            for (const o of p.containerOverrides)
              visitedObjects.has(o) || aws_cdk_lib_aws_stepfunctions_tasks_ContainerOverride(o);
          if (visitedObjects.has(p.propagatedTagSource) || (p.propagatedTagSource, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.subnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.subnets), visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_IEcsLaunchTarget(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_LaunchTargetBindOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.taskDefinition) || (p.taskDefinition, void 0), visitedObjects.has(p.cluster) || (p.cluster, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EcsLaunchTargetConfig(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EcsFargateLaunchTargetOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.platformVersion) || (p.platformVersion, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EcsEc2LaunchTargetOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.placementConstraints != null)
            for (const o of p.placementConstraints)
              visitedObjects.has(o) || void 0;
          if (p.placementStrategies != null)
            for (const o of p.placementStrategies)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EcsFargateLaunchTarget(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EcsEc2LaunchTarget(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EcsRunTask(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_ISageMakerTask(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_AlgorithmSpecification(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.metricDefinitions != null)
            for (const o of p.metricDefinitions)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.trainingImage) || (p.trainingImage, void 0), visitedObjects.has(p.trainingInputMode) || (p.trainingInputMode, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_Channel(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dataSource) || aws_cdk_lib_aws_stepfunctions_tasks_DataSource(p.dataSource), visitedObjects.has(p.compressionType) || (p.compressionType, void 0), visitedObjects.has(p.inputMode) || (p.inputMode, void 0), visitedObjects.has(p.recordWrapperType) || (p.recordWrapperType, void 0), visitedObjects.has(p.shuffleConfig) || (p.shuffleConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_ShuffleConfig(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_DataSource(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3DataSource) || aws_cdk_lib_aws_stepfunctions_tasks_S3DataSource(p.s3DataSource);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_S3DataSource(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3Location) || (p.s3Location, void 0), visitedObjects.has(p.s3DataDistributionType) || (p.s3DataDistributionType, void 0), visitedObjects.has(p.s3DataType) || (p.s3DataType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_OutputDataConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3OutputLocation) || (p.s3OutputLocation, void 0), visitedObjects.has(p.encryptionKey) || (p.encryptionKey, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_StoppingCondition(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.maxRuntime) || (p.maxRuntime, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_ResourceConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.instanceType) || (p.instanceType, void 0), visitedObjects.has(p.volumeSize) || (p.volumeSize, void 0), visitedObjects.has(p.volumeEncryptionKey) || (p.volumeEncryptionKey, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_VpcConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.subnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.subnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_MetricDefinition(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_S3LocationConfig(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_S3Location(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_S3LocationBindOptions(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_DockerImageConfig(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_DockerImage(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_S3DataType(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_S3DataDistributionType(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_RecordWrapperType(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_InputMode(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_CompressionType(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_ModelClientOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.invocationsTimeout) || (p.invocationsTimeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_TransformInput(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.transformDataSource) || aws_cdk_lib_aws_stepfunctions_tasks_TransformDataSource(p.transformDataSource), visitedObjects.has(p.compressionType) || (p.compressionType, void 0), visitedObjects.has(p.splitType) || (p.splitType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_TransformDataSource(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3DataSource) || aws_cdk_lib_aws_stepfunctions_tasks_TransformS3DataSource(p.s3DataSource);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_TransformS3DataSource(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3DataType) || (p.s3DataType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_TransformOutput(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.assembleWith) || (p.assembleWith, void 0), visitedObjects.has(p.encryptionKey) || (p.encryptionKey, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_TransformResources(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.instanceType) || (p.instanceType, void 0), visitedObjects.has(p.volumeEncryptionKey) || (p.volumeEncryptionKey, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_ContainerDefinitionOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.environmentVariables) || (p.environmentVariables, void 0), visitedObjects.has(p.image) || (p.image, void 0), visitedObjects.has(p.mode) || (p.mode, void 0), visitedObjects.has(p.modelS3Location) || (p.modelS3Location, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_ContainerDefinition(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_IContainerDefinition(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_ContainerDefinitionConfig(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_Mode(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_ProductionVariant(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.instanceType) || (p.instanceType, void 0), visitedObjects.has(p.acceleratorType) || (p.acceleratorType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_AcceleratorClass(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_AcceleratorType(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_BatchStrategy(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_SplitType(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_AssembleWith(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_SageMakerCreateTrainingJobProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.algorithmSpecification) || aws_cdk_lib_aws_stepfunctions_tasks_AlgorithmSpecification(p.algorithmSpecification), p.inputDataConfig != null)
            for (const o of p.inputDataConfig)
              visitedObjects.has(o) || aws_cdk_lib_aws_stepfunctions_tasks_Channel(o);
          visitedObjects.has(p.outputDataConfig) || aws_cdk_lib_aws_stepfunctions_tasks_OutputDataConfig(p.outputDataConfig), visitedObjects.has(p.resourceConfig) || aws_cdk_lib_aws_stepfunctions_tasks_ResourceConfig(p.resourceConfig), visitedObjects.has(p.role) || (p.role, void 0), visitedObjects.has(p.stoppingCondition) || aws_cdk_lib_aws_stepfunctions_tasks_StoppingCondition(p.stoppingCondition), visitedObjects.has(p.vpcConfig) || aws_cdk_lib_aws_stepfunctions_tasks_VpcConfig(p.vpcConfig), visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_SageMakerCreateTrainingJob(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_SageMakerCreateTransformJobProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.transformInput) || aws_cdk_lib_aws_stepfunctions_tasks_TransformInput(p.transformInput), visitedObjects.has(p.transformOutput) || aws_cdk_lib_aws_stepfunctions_tasks_TransformOutput(p.transformOutput), visitedObjects.has(p.batchStrategy) || (p.batchStrategy, void 0), visitedObjects.has(p.maxPayload) || (p.maxPayload, void 0), visitedObjects.has(p.modelClientOptions) || aws_cdk_lib_aws_stepfunctions_tasks_ModelClientOptions(p.modelClientOptions), visitedObjects.has(p.role) || (p.role, void 0), visitedObjects.has(p.transformResources) || aws_cdk_lib_aws_stepfunctions_tasks_TransformResources(p.transformResources), visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_SageMakerCreateTransformJob(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_SageMakerCreateEndpointProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.tags) || (p.tags, void 0), visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_SageMakerCreateEndpoint(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_SageMakerCreateEndpointConfigProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.productionVariants != null)
            for (const o of p.productionVariants)
              visitedObjects.has(o) || aws_cdk_lib_aws_stepfunctions_tasks_ProductionVariant(o);
          visitedObjects.has(p.kmsKey) || (p.kmsKey, void 0), visitedObjects.has(p.tags) || (p.tags, void 0), visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_SageMakerCreateEndpointConfig(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_SageMakerCreateModelProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.primaryContainer) || (p.primaryContainer, void 0), p.containers != null)
            for (const o of p.containers)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.role) || (p.role, void 0), visitedObjects.has(p.subnetSelection) || aws_cdk_lib_aws_ec2_SubnetSelection(p.subnetSelection), visitedObjects.has(p.tags) || (p.tags, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_SageMakerCreateModel(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_SageMakerUpdateEndpointProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_SageMakerUpdateEndpoint(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_StepFunctionsStartExecutionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.stateMachine) || (p.stateMachine, void 0), visitedObjects.has(p.input) || (p.input, void 0), visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_StepFunctionsStartExecution(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_StepFunctionsInvokeActivityProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.activity) || (p.activity, void 0), visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_StepFunctionsInvokeActivity(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EvaluateExpressionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.runtime) || (p.runtime, void 0), visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EvaluateExpression(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateClusterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.instances) || aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_InstancesConfigProperty(p.instances), p.applications != null)
            for (const o of p.applications)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.autoScalingRole) || (p.autoScalingRole, void 0), p.bootstrapActions != null)
            for (const o of p.bootstrapActions)
              visitedObjects.has(o) || aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_BootstrapActionConfigProperty(o);
          if (visitedObjects.has(p.clusterRole) || (p.clusterRole, void 0), p.configurations != null)
            for (const o of p.configurations)
              visitedObjects.has(o) || aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_ConfigurationProperty(o);
          visitedObjects.has(p.ebsRootVolumeSize) || (p.ebsRootVolumeSize, void 0), visitedObjects.has(p.kerberosAttributes) || (p.kerberosAttributes, void 0), visitedObjects.has(p.scaleDownBehavior) || (p.scaleDownBehavior, void 0), visitedObjects.has(p.serviceRole) || (p.serviceRole, void 0), visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_EmrClusterScaleDownBehavior(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_InstanceRoleType(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_EbsBlockDeviceVolumeType(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_VolumeSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.volumeSize) || (p.volumeSize, void 0), visitedObjects.has(p.volumeType) || (p.volumeType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_EbsBlockDeviceConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.volumeSpecification) || aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_VolumeSpecificationProperty(p.volumeSpecification);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_EbsConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.ebsBlockDeviceConfigs != null)
            for (const o of p.ebsBlockDeviceConfigs)
              visitedObjects.has(o) || aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_EbsBlockDeviceConfigProperty(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_InstanceTypeConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.configurations != null)
            for (const o of p.configurations)
              visitedObjects.has(o) || aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_ConfigurationProperty(o);
          visitedObjects.has(p.ebsConfiguration) || aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_EbsConfigurationProperty(p.ebsConfiguration);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_SpotTimeoutAction(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_SpotAllocationStrategy(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_SpotProvisioningSpecificationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.timeoutAction) || (p.timeoutAction, void 0), visitedObjects.has(p.allocationStrategy) || (p.allocationStrategy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_InstanceFleetProvisioningSpecificationsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.spotSpecification) || aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_SpotProvisioningSpecificationProperty(p.spotSpecification);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_InstanceFleetConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.instanceFleetType) || (p.instanceFleetType, void 0), p.instanceTypeConfigs != null)
            for (const o of p.instanceTypeConfigs)
              visitedObjects.has(o) || aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_InstanceTypeConfigProperty(o);
          visitedObjects.has(p.launchSpecifications) || aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_InstanceFleetProvisioningSpecificationsProperty(p.launchSpecifications);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_CloudWatchAlarmComparisonOperator(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_CloudWatchAlarmStatistic(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_CloudWatchAlarmUnit(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_MetricDimensionProperty(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_CloudWatchAlarmDefinitionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.comparisonOperator) || (p.comparisonOperator, void 0), visitedObjects.has(p.period) || (p.period, void 0), p.dimensions != null)
            for (const o of p.dimensions)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.statistic) || (p.statistic, void 0), visitedObjects.has(p.unit) || (p.unit, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_ScalingTriggerProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cloudWatchAlarmDefinition) || aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_CloudWatchAlarmDefinitionProperty(p.cloudWatchAlarmDefinition);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_InstanceMarket(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_ScalingAdjustmentType(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_SimpleScalingPolicyConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.adjustmentType) || (p.adjustmentType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_ScalingActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.simpleScalingPolicyConfiguration) || aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_SimpleScalingPolicyConfigurationProperty(p.simpleScalingPolicyConfiguration), visitedObjects.has(p.market) || (p.market, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_ScalingRuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.action) || aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_ScalingActionProperty(p.action), visitedObjects.has(p.trigger) || aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_ScalingTriggerProperty(p.trigger);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_ScalingConstraintsProperty(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_AutoScalingPolicyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.constraints) || (p.constraints, void 0), p.rules != null)
            for (const o of p.rules)
              visitedObjects.has(o) || aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_ScalingRuleProperty(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_InstanceGroupConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.instanceRole) || (p.instanceRole, void 0), visitedObjects.has(p.autoScalingPolicy) || aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_AutoScalingPolicyProperty(p.autoScalingPolicy), p.configurations != null)
            for (const o of p.configurations)
              visitedObjects.has(o) || aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_ConfigurationProperty(o);
          visitedObjects.has(p.ebsConfiguration) || aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_EbsConfigurationProperty(p.ebsConfiguration), visitedObjects.has(p.market) || (p.market, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_PlacementTypeProperty(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_InstancesConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.instanceFleets != null)
            for (const o of p.instanceFleets)
              visitedObjects.has(o) || aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_InstanceFleetConfigProperty(o);
          if (p.instanceGroups != null)
            for (const o of p.instanceGroups)
              visitedObjects.has(o) || aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_InstanceGroupConfigProperty(o);
          visitedObjects.has(p.placement) || (p.placement, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_ApplicationConfigProperty(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_ScriptBootstrapActionConfigProperty(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_BootstrapActionConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.scriptBootstrapAction) || (p.scriptBootstrapAction, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_ConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.configurations != null)
            for (const o of p.configurations)
              visitedObjects.has(o) || aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_ConfigurationProperty(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_KerberosAttributesProperty(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrSetClusterTerminationProtectionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrSetClusterTerminationProtection(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrTerminateClusterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrTerminateCluster(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_ActionOnFailure(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrAddStepProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actionOnFailure) || (p.actionOnFailure, void 0), visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrAddStep(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCancelStepProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrCancelStep(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrModifyInstanceFleetByNameProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrModifyInstanceFleetByName(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrModifyInstanceGroupByNameProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.instanceGroup) || aws_cdk_lib_aws_stepfunctions_tasks_EmrModifyInstanceGroupByName_InstanceGroupModifyConfigProperty(p.instanceGroup), visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrModifyInstanceGroupByName(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrModifyInstanceGroupByName_InstanceResizePolicyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.instanceTerminationTimeout) || (p.instanceTerminationTimeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrModifyInstanceGroupByName_ShrinkPolicyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.decommissionTimeout) || (p.decommissionTimeout, void 0), visitedObjects.has(p.instanceResizePolicy) || aws_cdk_lib_aws_stepfunctions_tasks_EmrModifyInstanceGroupByName_InstanceResizePolicyProperty(p.instanceResizePolicy);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrModifyInstanceGroupByName_InstanceGroupModifyConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.configurations != null)
            for (const o of p.configurations)
              visitedObjects.has(o) || aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_ConfigurationProperty(o);
          visitedObjects.has(p.shrinkPolicy) || aws_cdk_lib_aws_stepfunctions_tasks_EmrModifyInstanceGroupByName_ShrinkPolicyProperty(p.shrinkPolicy);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EksClusterInput(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrContainersCreateVirtualClusterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.eksCluster) || (p.eksCluster, void 0), visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrContainersCreateVirtualCluster(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrContainersDeleteVirtualClusterProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.virtualClusterId) || (p.virtualClusterId, void 0), visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrContainersDeleteVirtualCluster(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrContainersStartJobRunProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.jobDriver) || aws_cdk_lib_aws_stepfunctions_tasks_JobDriver(p.jobDriver), visitedObjects.has(p.releaseLabel) || (p.releaseLabel, void 0), visitedObjects.has(p.virtualCluster) || (p.virtualCluster, void 0), p.applicationConfig != null)
            for (const o of p.applicationConfig)
              visitedObjects.has(o) || aws_cdk_lib_aws_stepfunctions_tasks_ApplicationConfiguration(o);
          visitedObjects.has(p.executionRole) || (p.executionRole, void 0), visitedObjects.has(p.monitoring) || aws_cdk_lib_aws_stepfunctions_tasks_Monitoring(p.monitoring), visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EmrContainersStartJobRun(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_SparkSubmitJobDriver(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.entryPoint) || (p.entryPoint, void 0), visitedObjects.has(p.entryPointArguments) || (p.entryPointArguments, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_JobDriver(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sparkSubmitJobDriver) || aws_cdk_lib_aws_stepfunctions_tasks_SparkSubmitJobDriver(p.sparkSubmitJobDriver);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_Classification(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_ApplicationConfiguration(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.classification) || (p.classification, void 0), p.nestedConfig != null)
            for (const o of p.nestedConfig)
              visitedObjects.has(o) || aws_cdk_lib_aws_stepfunctions_tasks_ApplicationConfiguration(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_Monitoring(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.logBucket) || (p.logBucket, void 0), visitedObjects.has(p.logGroup) || (p.logGroup, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_ReleaseLabel(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_VirtualClusterInput(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_GlueStartJobRunProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.arguments) || (p.arguments, void 0), visitedObjects.has(p.notifyDelayAfter) || (p.notifyDelayAfter, void 0), visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_GlueStartJobRun(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_ContainerOverrides(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.instanceType) || (p.instanceType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_JobDependency(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_BatchContainerOverrides(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.instanceType) || (p.instanceType, void 0), visitedObjects.has(p.memory) || (p.memory, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_BatchJobDependency(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_BatchSubmitJobProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.containerOverrides) || aws_cdk_lib_aws_stepfunctions_tasks_BatchContainerOverrides(p.containerOverrides), p.dependsOn != null)
            for (const o of p.dependsOn)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.payload) || (p.payload, void 0), visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_BatchSubmitJob(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_DynamoGetItemProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.key != null)
            for (const o of Object.values(p.key))
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.table) || (p.table, void 0), p.projectionExpression != null)
            for (const o of p.projectionExpression)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.returnConsumedCapacity) || (p.returnConsumedCapacity, void 0), visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_DynamoGetItem(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_DynamoPutItemProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.item != null)
            for (const o of Object.values(p.item))
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.table) || (p.table, void 0), p.expressionAttributeValues != null)
            for (const o of Object.values(p.expressionAttributeValues))
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.returnConsumedCapacity) || (p.returnConsumedCapacity, void 0), visitedObjects.has(p.returnItemCollectionMetrics) || (p.returnItemCollectionMetrics, void 0), visitedObjects.has(p.returnValues) || (p.returnValues, void 0), visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_DynamoPutItem(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_DynamoUpdateItemProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.key != null)
            for (const o of Object.values(p.key))
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.table) || (p.table, void 0), p.expressionAttributeValues != null)
            for (const o of Object.values(p.expressionAttributeValues))
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.returnConsumedCapacity) || (p.returnConsumedCapacity, void 0), visitedObjects.has(p.returnItemCollectionMetrics) || (p.returnItemCollectionMetrics, void 0), visitedObjects.has(p.returnValues) || (p.returnValues, void 0), visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_DynamoUpdateItem(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_DynamoDeleteItemProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.key != null)
            for (const o of Object.values(p.key))
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.table) || (p.table, void 0), p.expressionAttributeValues != null)
            for (const o of Object.values(p.expressionAttributeValues))
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.returnConsumedCapacity) || (p.returnConsumedCapacity, void 0), visitedObjects.has(p.returnItemCollectionMetrics) || (p.returnItemCollectionMetrics, void 0), visitedObjects.has(p.returnValues) || (p.returnValues, void 0), visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_DynamoDeleteItem(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_DynamoConsumedCapacity(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_DynamoItemCollectionMetrics(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_DynamoReturnValues(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_DynamoProjectionExpression(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_DynamoAttributeValue(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_CodeBuildStartBuildProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.project) || (p.project, void 0), p.environmentVariablesOverride != null)
            for (const o of Object.values(p.environmentVariablesOverride))
              visitedObjects.has(o) || aws_cdk_lib_aws_codebuild_BuildEnvironmentVariable(o);
          visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_CodeBuildStartBuild(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_AthenaStartQueryExecutionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.queryExecutionContext) || (p.queryExecutionContext, void 0), visitedObjects.has(p.resultConfiguration) || aws_cdk_lib_aws_stepfunctions_tasks_ResultConfiguration(p.resultConfiguration), visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_AthenaStartQueryExecution(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_ResultConfiguration(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.encryptionConfiguration) || aws_cdk_lib_aws_stepfunctions_tasks_EncryptionConfiguration(p.encryptionConfiguration), visitedObjects.has(p.outputLocation) || (p.outputLocation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EncryptionConfiguration(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.encryptionOption) || (p.encryptionOption, void 0), visitedObjects.has(p.encryptionKey) || (p.encryptionKey, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EncryptionOption(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_QueryExecutionContext(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_AthenaStopQueryExecutionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_AthenaStopQueryExecution(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_AthenaGetQueryExecutionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_AthenaGetQueryExecution(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_AthenaGetQueryResultsProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_AthenaGetQueryResults(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_GlueDataBrewStartJobRunProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_GlueDataBrewStartJobRun(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EksCallProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cluster) || (p.cluster, void 0), visitedObjects.has(p.httpMethod) || (p.httpMethod, void 0), visitedObjects.has(p.requestBody) || (p.requestBody, void 0), visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EksCall(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_HttpMethods(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_HttpMethod(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_AuthType(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_CallApiGatewayEndpointBaseProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.method) || (p.method, void 0), visitedObjects.has(p.authType) || (p.authType, void 0), visitedObjects.has(p.headers) || (p.headers, void 0), visitedObjects.has(p.queryParameters) || (p.queryParameters, void 0), visitedObjects.has(p.requestBody) || (p.requestBody, void 0), visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_CallApiGatewayRestApiEndpointProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.api) || (p.api, void 0), visitedObjects.has(p.method) || (p.method, void 0), visitedObjects.has(p.authType) || (p.authType, void 0), visitedObjects.has(p.headers) || (p.headers, void 0), visitedObjects.has(p.queryParameters) || (p.queryParameters, void 0), visitedObjects.has(p.requestBody) || (p.requestBody, void 0), visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_CallApiGatewayRestApiEndpoint(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_CallApiGatewayHttpApiEndpointProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.apiStack) || (p.apiStack, void 0), visitedObjects.has(p.method) || (p.method, void 0), visitedObjects.has(p.authType) || (p.authType, void 0), visitedObjects.has(p.headers) || (p.headers, void 0), visitedObjects.has(p.queryParameters) || (p.queryParameters, void 0), visitedObjects.has(p.requestBody) || (p.requestBody, void 0), visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_CallApiGatewayHttpApiEndpoint(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EventBridgePutEventsEntry(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.detail) || (p.detail, void 0), visitedObjects.has(p.eventBus) || (p.eventBus, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EventBridgePutEventsProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.entries != null)
            for (const o of p.entries)
              visitedObjects.has(o) || aws_cdk_lib_aws_stepfunctions_tasks_EventBridgePutEventsEntry(o);
          visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_EventBridgePutEvents(p) {
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_CallAwsServiceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.additionalIamStatements != null)
            for (const o of p.additionalIamStatements)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.credentials) || aws_cdk_lib_aws_stepfunctions_Credentials(p.credentials), "heartbeat" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#heartbeat", "use `heartbeatTimeout`"), visitedObjects.has(p.heartbeat) || (p.heartbeat, void 0), visitedObjects.has(p.heartbeatTimeout) || (p.heartbeatTimeout, void 0), visitedObjects.has(p.integrationPattern) || (p.integrationPattern, void 0), visitedObjects.has(p.taskTimeout) || (p.taskTimeout, void 0), "timeout" in p && print("aws-cdk-lib.aws_stepfunctions.TaskStateBaseProps#timeout", "use `taskTimeout`"), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_stepfunctions_tasks_CallAwsService(p) {
    }
    function aws_cdk_lib_aws_supportapp_CfnAccountAliasProps(p) {
    }
    function aws_cdk_lib_aws_supportapp_CfnAccountAlias(p) {
    }
    function aws_cdk_lib_aws_supportapp_CfnSlackChannelConfigurationProps(p) {
    }
    function aws_cdk_lib_aws_supportapp_CfnSlackChannelConfiguration(p) {
    }
    function aws_cdk_lib_aws_supportapp_CfnSlackWorkspaceConfigurationProps(p) {
    }
    function aws_cdk_lib_aws_supportapp_CfnSlackWorkspaceConfiguration(p) {
    }
    function aws_cdk_lib_aws_synthetics_CfnCanaryProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.code) || (p.code, void 0), visitedObjects.has(p.schedule) || (p.schedule, void 0), visitedObjects.has(p.artifactConfig) || (p.artifactConfig, void 0), visitedObjects.has(p.runConfig) || (p.runConfig, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.visualReference) || (p.visualReference, void 0), visitedObjects.has(p.vpcConfig) || (p.vpcConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_synthetics_CfnCanary(p) {
    }
    function aws_cdk_lib_aws_synthetics_CfnCanary_ArtifactConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3Encryption) || (p.s3Encryption, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_synthetics_CfnCanary_BaseScreenshotProperty(p) {
    }
    function aws_cdk_lib_aws_synthetics_CfnCanary_CodeProperty(p) {
    }
    function aws_cdk_lib_aws_synthetics_CfnCanary_RunConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.environmentVariables) || (p.environmentVariables, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_synthetics_CfnCanary_S3EncryptionProperty(p) {
    }
    function aws_cdk_lib_aws_synthetics_CfnCanary_ScheduleProperty(p) {
    }
    function aws_cdk_lib_aws_synthetics_CfnCanary_VPCConfigProperty(p) {
    }
    function aws_cdk_lib_aws_synthetics_CfnCanary_VisualReferenceProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.baseScreenshots) || (p.baseScreenshots, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_synthetics_CfnGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_synthetics_CfnGroup(p) {
    }
    function aws_cdk_lib_aws_systemsmanagersap_CfnApplicationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.credentials) || (p.credentials, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_systemsmanagersap_CfnApplication(p) {
    }
    function aws_cdk_lib_aws_systemsmanagersap_CfnApplication_CredentialProperty(p) {
    }
    function aws_cdk_lib_aws_timestream_CfnDatabaseProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_timestream_CfnDatabase(p) {
    }
    function aws_cdk_lib_aws_timestream_CfnScheduledQueryProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.errorReportConfiguration) || (p.errorReportConfiguration, void 0), visitedObjects.has(p.notificationConfiguration) || (p.notificationConfiguration, void 0), visitedObjects.has(p.scheduleConfiguration) || (p.scheduleConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.targetConfiguration) || (p.targetConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_timestream_CfnScheduledQuery(p) {
    }
    function aws_cdk_lib_aws_timestream_CfnScheduledQuery_DimensionMappingProperty(p) {
    }
    function aws_cdk_lib_aws_timestream_CfnScheduledQuery_ErrorReportConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3Configuration) || (p.s3Configuration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_timestream_CfnScheduledQuery_MixedMeasureMappingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.multiMeasureAttributeMappings) || (p.multiMeasureAttributeMappings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_timestream_CfnScheduledQuery_MultiMeasureAttributeMappingProperty(p) {
    }
    function aws_cdk_lib_aws_timestream_CfnScheduledQuery_MultiMeasureMappingsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.multiMeasureAttributeMappings) || (p.multiMeasureAttributeMappings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_timestream_CfnScheduledQuery_NotificationConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.snsConfiguration) || (p.snsConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_timestream_CfnScheduledQuery_S3ConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_timestream_CfnScheduledQuery_ScheduleConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_timestream_CfnScheduledQuery_SnsConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_timestream_CfnScheduledQuery_TargetConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.timestreamConfiguration) || (p.timestreamConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_timestream_CfnScheduledQuery_TimestreamConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.dimensionMappings) || (p.dimensionMappings, void 0), visitedObjects.has(p.mixedMeasureMappings) || (p.mixedMeasureMappings, void 0), visitedObjects.has(p.multiMeasureMappings) || (p.multiMeasureMappings, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_timestream_CfnTableProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_timestream_CfnTable(p) {
    }
    function aws_cdk_lib_aws_timestream_CfnTable_MagneticStoreRejectedDataLocationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3Configuration) || (p.s3Configuration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_timestream_CfnTable_MagneticStoreWritePropertiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.magneticStoreRejectedDataLocation) || (p.magneticStoreRejectedDataLocation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_timestream_CfnTable_RetentionPropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_timestream_CfnTable_S3ConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_transfer_CfnAgreementProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_transfer_CfnAgreement(p) {
    }
    function aws_cdk_lib_aws_transfer_CfnCertificateProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_transfer_CfnCertificate(p) {
    }
    function aws_cdk_lib_aws_transfer_CfnConnectorProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_transfer_CfnConnector(p) {
    }
    function aws_cdk_lib_aws_transfer_CfnConnector_As2ConfigProperty(p) {
    }
    function aws_cdk_lib_aws_transfer_CfnProfileProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_transfer_CfnProfile(p) {
    }
    function aws_cdk_lib_aws_transfer_CfnServerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.endpointDetails) || (p.endpointDetails, void 0), visitedObjects.has(p.identityProviderDetails) || (p.identityProviderDetails, void 0), visitedObjects.has(p.protocolDetails) || (p.protocolDetails, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.workflowDetails) || (p.workflowDetails, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_transfer_CfnServer(p) {
    }
    function aws_cdk_lib_aws_transfer_CfnServer_EndpointDetailsProperty(p) {
    }
    function aws_cdk_lib_aws_transfer_CfnServer_IdentityProviderDetailsProperty(p) {
    }
    function aws_cdk_lib_aws_transfer_CfnServer_ProtocolDetailsProperty(p) {
    }
    function aws_cdk_lib_aws_transfer_CfnServer_WorkflowDetailProperty(p) {
    }
    function aws_cdk_lib_aws_transfer_CfnServer_WorkflowDetailsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.onPartialUpload) || (p.onPartialUpload, void 0), visitedObjects.has(p.onUpload) || (p.onUpload, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_transfer_CfnUserProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.homeDirectoryMappings) || (p.homeDirectoryMappings, void 0), visitedObjects.has(p.posixProfile) || (p.posixProfile, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_transfer_CfnUser(p) {
    }
    function aws_cdk_lib_aws_transfer_CfnUser_HomeDirectoryMapEntryProperty(p) {
    }
    function aws_cdk_lib_aws_transfer_CfnUser_PosixProfileProperty(p) {
    }
    function aws_cdk_lib_aws_transfer_CfnWorkflowProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.steps) || (p.steps, void 0), visitedObjects.has(p.onExceptionSteps) || (p.onExceptionSteps, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_transfer_CfnWorkflow(p) {
    }
    function aws_cdk_lib_aws_transfer_CfnWorkflow_CopyStepDetailsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destinationFileLocation) || (p.destinationFileLocation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_transfer_CfnWorkflow_CustomStepDetailsProperty(p) {
    }
    function aws_cdk_lib_aws_transfer_CfnWorkflow_DecryptStepDetailsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.destinationFileLocation) || (p.destinationFileLocation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_transfer_CfnWorkflow_DeleteStepDetailsProperty(p) {
    }
    function aws_cdk_lib_aws_transfer_CfnWorkflow_EfsInputFileLocationProperty(p) {
    }
    function aws_cdk_lib_aws_transfer_CfnWorkflow_InputFileLocationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.efsFileLocation) || (p.efsFileLocation, void 0), visitedObjects.has(p.s3FileLocation) || (p.s3FileLocation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_transfer_CfnWorkflow_S3FileLocationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.s3FileLocation) || (p.s3FileLocation, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_transfer_CfnWorkflow_S3InputFileLocationProperty(p) {
    }
    function aws_cdk_lib_aws_transfer_CfnWorkflow_S3TagProperty(p) {
    }
    function aws_cdk_lib_aws_transfer_CfnWorkflow_TagStepDetailsProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_transfer_CfnWorkflow_WorkflowStepProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.decryptStepDetails) || (p.decryptStepDetails, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_voiceid_CfnDomainProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.serverSideEncryptionConfiguration) || (p.serverSideEncryptionConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_voiceid_CfnDomain(p) {
    }
    function aws_cdk_lib_aws_voiceid_CfnDomain_ServerSideEncryptionConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_vpclattice_CfnAccessLogSubscriptionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_vpclattice_CfnAccessLogSubscription(p) {
    }
    function aws_cdk_lib_aws_vpclattice_CfnAuthPolicyProps(p) {
    }
    function aws_cdk_lib_aws_vpclattice_CfnAuthPolicy(p) {
    }
    function aws_cdk_lib_aws_vpclattice_CfnListenerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.defaultAction) || (p.defaultAction, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_vpclattice_CfnListener(p) {
    }
    function aws_cdk_lib_aws_vpclattice_CfnListener_DefaultActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fixedResponse) || (p.fixedResponse, void 0), visitedObjects.has(p.forward) || (p.forward, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_vpclattice_CfnListener_FixedResponseProperty(p) {
    }
    function aws_cdk_lib_aws_vpclattice_CfnListener_ForwardProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.targetGroups) || (p.targetGroups, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_vpclattice_CfnListener_WeightedTargetGroupProperty(p) {
    }
    function aws_cdk_lib_aws_vpclattice_CfnResourcePolicyProps(p) {
    }
    function aws_cdk_lib_aws_vpclattice_CfnResourcePolicy(p) {
    }
    function aws_cdk_lib_aws_vpclattice_CfnRuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.action) || (p.action, void 0), visitedObjects.has(p.match) || (p.match, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_vpclattice_CfnRule(p) {
    }
    function aws_cdk_lib_aws_vpclattice_CfnRule_ActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fixedResponse) || (p.fixedResponse, void 0), visitedObjects.has(p.forward) || (p.forward, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_vpclattice_CfnRule_FixedResponseProperty(p) {
    }
    function aws_cdk_lib_aws_vpclattice_CfnRule_ForwardProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.targetGroups) || (p.targetGroups, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_vpclattice_CfnRule_HeaderMatchProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.match) || (p.match, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_vpclattice_CfnRule_HeaderMatchTypeProperty(p) {
    }
    function aws_cdk_lib_aws_vpclattice_CfnRule_HttpMatchProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.headerMatches) || (p.headerMatches, void 0), visitedObjects.has(p.pathMatch) || (p.pathMatch, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_vpclattice_CfnRule_MatchProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.httpMatch) || (p.httpMatch, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_vpclattice_CfnRule_PathMatchProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.match) || (p.match, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_vpclattice_CfnRule_PathMatchTypeProperty(p) {
    }
    function aws_cdk_lib_aws_vpclattice_CfnRule_WeightedTargetGroupProperty(p) {
    }
    function aws_cdk_lib_aws_vpclattice_CfnServiceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.dnsEntry) || (p.dnsEntry, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_vpclattice_CfnService(p) {
    }
    function aws_cdk_lib_aws_vpclattice_CfnService_DnsEntryProperty(p) {
    }
    function aws_cdk_lib_aws_vpclattice_CfnServiceNetworkProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_vpclattice_CfnServiceNetwork(p) {
    }
    function aws_cdk_lib_aws_vpclattice_CfnServiceNetworkServiceAssociationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.dnsEntry) || (p.dnsEntry, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_vpclattice_CfnServiceNetworkServiceAssociation(p) {
    }
    function aws_cdk_lib_aws_vpclattice_CfnServiceNetworkServiceAssociation_DnsEntryProperty(p) {
    }
    function aws_cdk_lib_aws_vpclattice_CfnServiceNetworkVpcAssociationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_vpclattice_CfnServiceNetworkVpcAssociation(p) {
    }
    function aws_cdk_lib_aws_vpclattice_CfnTargetGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.config) || (p.config, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.targets) || (p.targets, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_vpclattice_CfnTargetGroup(p) {
    }
    function aws_cdk_lib_aws_vpclattice_CfnTargetGroup_HealthCheckConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.matcher) || (p.matcher, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_vpclattice_CfnTargetGroup_MatcherProperty(p) {
    }
    function aws_cdk_lib_aws_vpclattice_CfnTargetGroup_TargetProperty(p) {
    }
    function aws_cdk_lib_aws_vpclattice_CfnTargetGroup_TargetGroupConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.healthCheck) || (p.healthCheck, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_waf_CfnByteMatchSetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.byteMatchTuples) || (p.byteMatchTuples, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_waf_CfnByteMatchSet(p) {
    }
    function aws_cdk_lib_aws_waf_CfnByteMatchSet_ByteMatchTupleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldToMatch) || (p.fieldToMatch, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_waf_CfnByteMatchSet_FieldToMatchProperty(p) {
    }
    function aws_cdk_lib_aws_waf_CfnIPSetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ipSetDescriptors) || (p.ipSetDescriptors, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_waf_CfnIPSet(p) {
    }
    function aws_cdk_lib_aws_waf_CfnIPSet_IPSetDescriptorProperty(p) {
    }
    function aws_cdk_lib_aws_waf_CfnRuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.predicates) || (p.predicates, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_waf_CfnRule(p) {
    }
    function aws_cdk_lib_aws_waf_CfnRule_PredicateProperty(p) {
    }
    function aws_cdk_lib_aws_waf_CfnSizeConstraintSetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sizeConstraints) || (p.sizeConstraints, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_waf_CfnSizeConstraintSet(p) {
    }
    function aws_cdk_lib_aws_waf_CfnSizeConstraintSet_FieldToMatchProperty(p) {
    }
    function aws_cdk_lib_aws_waf_CfnSizeConstraintSet_SizeConstraintProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldToMatch) || (p.fieldToMatch, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_waf_CfnSqlInjectionMatchSetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sqlInjectionMatchTuples) || (p.sqlInjectionMatchTuples, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_waf_CfnSqlInjectionMatchSet(p) {
    }
    function aws_cdk_lib_aws_waf_CfnSqlInjectionMatchSet_FieldToMatchProperty(p) {
    }
    function aws_cdk_lib_aws_waf_CfnSqlInjectionMatchSet_SqlInjectionMatchTupleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldToMatch) || (p.fieldToMatch, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_waf_CfnWebACLProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultAction) || (p.defaultAction, void 0), visitedObjects.has(p.rules) || (p.rules, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_waf_CfnWebACL(p) {
    }
    function aws_cdk_lib_aws_waf_CfnWebACL_ActivatedRuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.action) || (p.action, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_waf_CfnWebACL_WafActionProperty(p) {
    }
    function aws_cdk_lib_aws_waf_CfnXssMatchSetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.xssMatchTuples) || (p.xssMatchTuples, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_waf_CfnXssMatchSet(p) {
    }
    function aws_cdk_lib_aws_waf_CfnXssMatchSet_FieldToMatchProperty(p) {
    }
    function aws_cdk_lib_aws_waf_CfnXssMatchSet_XssMatchTupleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldToMatch) || (p.fieldToMatch, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafregional_CfnByteMatchSetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.byteMatchTuples) || (p.byteMatchTuples, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafregional_CfnByteMatchSet(p) {
    }
    function aws_cdk_lib_aws_wafregional_CfnByteMatchSet_ByteMatchTupleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldToMatch) || (p.fieldToMatch, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafregional_CfnByteMatchSet_FieldToMatchProperty(p) {
    }
    function aws_cdk_lib_aws_wafregional_CfnGeoMatchSetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.geoMatchConstraints) || (p.geoMatchConstraints, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafregional_CfnGeoMatchSet(p) {
    }
    function aws_cdk_lib_aws_wafregional_CfnGeoMatchSet_GeoMatchConstraintProperty(p) {
    }
    function aws_cdk_lib_aws_wafregional_CfnIPSetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ipSetDescriptors) || (p.ipSetDescriptors, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafregional_CfnIPSet(p) {
    }
    function aws_cdk_lib_aws_wafregional_CfnIPSet_IPSetDescriptorProperty(p) {
    }
    function aws_cdk_lib_aws_wafregional_CfnRateBasedRuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.matchPredicates) || (p.matchPredicates, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafregional_CfnRateBasedRule(p) {
    }
    function aws_cdk_lib_aws_wafregional_CfnRateBasedRule_PredicateProperty(p) {
    }
    function aws_cdk_lib_aws_wafregional_CfnRegexPatternSetProps(p) {
    }
    function aws_cdk_lib_aws_wafregional_CfnRegexPatternSet(p) {
    }
    function aws_cdk_lib_aws_wafregional_CfnRuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.predicates) || (p.predicates, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafregional_CfnRule(p) {
    }
    function aws_cdk_lib_aws_wafregional_CfnRule_PredicateProperty(p) {
    }
    function aws_cdk_lib_aws_wafregional_CfnSizeConstraintSetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sizeConstraints) || (p.sizeConstraints, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafregional_CfnSizeConstraintSet(p) {
    }
    function aws_cdk_lib_aws_wafregional_CfnSizeConstraintSet_FieldToMatchProperty(p) {
    }
    function aws_cdk_lib_aws_wafregional_CfnSizeConstraintSet_SizeConstraintProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldToMatch) || (p.fieldToMatch, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafregional_CfnSqlInjectionMatchSetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.sqlInjectionMatchTuples) || (p.sqlInjectionMatchTuples, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafregional_CfnSqlInjectionMatchSet(p) {
    }
    function aws_cdk_lib_aws_wafregional_CfnSqlInjectionMatchSet_FieldToMatchProperty(p) {
    }
    function aws_cdk_lib_aws_wafregional_CfnSqlInjectionMatchSet_SqlInjectionMatchTupleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldToMatch) || (p.fieldToMatch, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafregional_CfnWebACLProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.defaultAction) || (p.defaultAction, void 0), visitedObjects.has(p.rules) || (p.rules, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafregional_CfnWebACL(p) {
    }
    function aws_cdk_lib_aws_wafregional_CfnWebACL_ActionProperty(p) {
    }
    function aws_cdk_lib_aws_wafregional_CfnWebACL_RuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.action) || (p.action, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafregional_CfnWebACLAssociationProps(p) {
    }
    function aws_cdk_lib_aws_wafregional_CfnWebACLAssociation(p) {
    }
    function aws_cdk_lib_aws_wafregional_CfnXssMatchSetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.xssMatchTuples) || (p.xssMatchTuples, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafregional_CfnXssMatchSet(p) {
    }
    function aws_cdk_lib_aws_wafregional_CfnXssMatchSet_FieldToMatchProperty(p) {
    }
    function aws_cdk_lib_aws_wafregional_CfnXssMatchSet_XssMatchTupleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldToMatch) || (p.fieldToMatch, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnIPSetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnIPSet(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnLoggingConfigurationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.redactedFields) || (p.redactedFields, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnLoggingConfiguration(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnLoggingConfiguration_ActionConditionProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnLoggingConfiguration_ConditionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actionCondition) || (p.actionCondition, void 0), visitedObjects.has(p.labelNameCondition) || (p.labelNameCondition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnLoggingConfiguration_FieldToMatchProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnLoggingConfiguration_FilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.conditions) || (p.conditions, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnLoggingConfiguration_JsonBodyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.matchPattern) || (p.matchPattern, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnLoggingConfiguration_LabelNameConditionProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnLoggingConfiguration_LoggingFilterProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.filters) || (p.filters, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnLoggingConfiguration_MatchPatternProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnLoggingConfiguration_SingleHeaderProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnRegexPatternSetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnRegexPatternSet(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.visibilityConfig) || (p.visibilityConfig, void 0), visitedObjects.has(p.availableLabels) || (p.availableLabels, void 0), visitedObjects.has(p.consumedLabels) || (p.consumedLabels, void 0), visitedObjects.has(p.customResponseBodies) || (p.customResponseBodies, void 0), visitedObjects.has(p.rules) || (p.rules, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_AllowProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customRequestHandling) || (p.customRequestHandling, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_AndStatementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.statements) || (p.statements, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_BlockProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customResponse) || (p.customResponse, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_BodyProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_ByteMatchStatementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldToMatch) || (p.fieldToMatch, void 0), visitedObjects.has(p.textTransformations) || (p.textTransformations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_CaptchaProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customRequestHandling) || (p.customRequestHandling, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_CaptchaConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.immunityTimeProperty) || (p.immunityTimeProperty, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_ChallengeProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customRequestHandling) || (p.customRequestHandling, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_ChallengeConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.immunityTimeProperty) || (p.immunityTimeProperty, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_CookieMatchPatternProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_CookiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.matchPattern) || (p.matchPattern, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_CountProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customRequestHandling) || (p.customRequestHandling, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_CustomHTTPHeaderProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_CustomRequestHandlingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.insertHeaders) || (p.insertHeaders, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_CustomResponseProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.responseHeaders) || (p.responseHeaders, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_CustomResponseBodyProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_FieldToMatchProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.body) || (p.body, void 0), visitedObjects.has(p.cookies) || (p.cookies, void 0), visitedObjects.has(p.headers) || (p.headers, void 0), visitedObjects.has(p.jsonBody) || (p.jsonBody, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_ForwardedIPConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_GeoMatchStatementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.forwardedIpConfig) || (p.forwardedIpConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_HeaderMatchPatternProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_HeadersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.matchPattern) || (p.matchPattern, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_IPSetForwardedIPConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_IPSetReferenceStatementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ipSetForwardedIpConfig) || (p.ipSetForwardedIpConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_ImmunityTimePropertyProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_JsonBodyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.matchPattern) || (p.matchPattern, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_JsonMatchPatternProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_LabelProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_LabelMatchStatementProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_LabelSummaryProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_NotStatementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.statement) || (p.statement, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_OrStatementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.statements) || (p.statements, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_RateBasedStatementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.forwardedIpConfig) || (p.forwardedIpConfig, void 0), visitedObjects.has(p.scopeDownStatement) || (p.scopeDownStatement, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_RegexMatchStatementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldToMatch) || (p.fieldToMatch, void 0), visitedObjects.has(p.textTransformations) || (p.textTransformations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_RegexPatternSetReferenceStatementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldToMatch) || (p.fieldToMatch, void 0), visitedObjects.has(p.textTransformations) || (p.textTransformations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_RuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.statement) || (p.statement, void 0), visitedObjects.has(p.visibilityConfig) || (p.visibilityConfig, void 0), visitedObjects.has(p.action) || (p.action, void 0), visitedObjects.has(p.captchaConfig) || (p.captchaConfig, void 0), visitedObjects.has(p.challengeConfig) || (p.challengeConfig, void 0), visitedObjects.has(p.ruleLabels) || (p.ruleLabels, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_RuleActionProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_SingleHeaderProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_SingleQueryArgumentProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_SizeConstraintStatementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldToMatch) || (p.fieldToMatch, void 0), visitedObjects.has(p.textTransformations) || (p.textTransformations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_SqliMatchStatementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldToMatch) || (p.fieldToMatch, void 0), visitedObjects.has(p.textTransformations) || (p.textTransformations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_StatementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.andStatement) || (p.andStatement, void 0), visitedObjects.has(p.byteMatchStatement) || (p.byteMatchStatement, void 0), visitedObjects.has(p.geoMatchStatement) || (p.geoMatchStatement, void 0), visitedObjects.has(p.ipSetReferenceStatement) || (p.ipSetReferenceStatement, void 0), visitedObjects.has(p.labelMatchStatement) || (p.labelMatchStatement, void 0), visitedObjects.has(p.notStatement) || (p.notStatement, void 0), visitedObjects.has(p.orStatement) || (p.orStatement, void 0), visitedObjects.has(p.rateBasedStatement) || (p.rateBasedStatement, void 0), visitedObjects.has(p.regexMatchStatement) || (p.regexMatchStatement, void 0), visitedObjects.has(p.regexPatternSetReferenceStatement) || (p.regexPatternSetReferenceStatement, void 0), visitedObjects.has(p.sizeConstraintStatement) || (p.sizeConstraintStatement, void 0), visitedObjects.has(p.sqliMatchStatement) || (p.sqliMatchStatement, void 0), visitedObjects.has(p.xssMatchStatement) || (p.xssMatchStatement, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_TextTransformationProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_VisibilityConfigProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnRuleGroup_XssMatchStatementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldToMatch) || (p.fieldToMatch, void 0), visitedObjects.has(p.textTransformations) || (p.textTransformations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACLProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.defaultAction) || (p.defaultAction, void 0), visitedObjects.has(p.visibilityConfig) || (p.visibilityConfig, void 0), visitedObjects.has(p.captchaConfig) || (p.captchaConfig, void 0), visitedObjects.has(p.challengeConfig) || (p.challengeConfig, void 0), visitedObjects.has(p.customResponseBodies) || (p.customResponseBodies, void 0), visitedObjects.has(p.rules) || (p.rules, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_AWSManagedRulesATPRuleSetProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.requestInspection) || (p.requestInspection, void 0), visitedObjects.has(p.responseInspection) || (p.responseInspection, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_AWSManagedRulesBotControlRuleSetProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_AllowActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customRequestHandling) || (p.customRequestHandling, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_AndStatementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.statements) || (p.statements, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_BlockActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customResponse) || (p.customResponse, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_BodyProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_ByteMatchStatementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldToMatch) || (p.fieldToMatch, void 0), visitedObjects.has(p.textTransformations) || (p.textTransformations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_CaptchaActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customRequestHandling) || (p.customRequestHandling, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_CaptchaConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.immunityTimeProperty) || (p.immunityTimeProperty, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_ChallengeActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customRequestHandling) || (p.customRequestHandling, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_ChallengeConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.immunityTimeProperty) || (p.immunityTimeProperty, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_CookieMatchPatternProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_CookiesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.matchPattern) || (p.matchPattern, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_CountActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.customRequestHandling) || (p.customRequestHandling, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_CustomHTTPHeaderProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_CustomRequestHandlingProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.insertHeaders) || (p.insertHeaders, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_CustomResponseProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.responseHeaders) || (p.responseHeaders, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_CustomResponseBodyProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_DefaultActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.allow) || (p.allow, void 0), visitedObjects.has(p.block) || (p.block, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_ExcludedRuleProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_FieldIdentifierProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_FieldToMatchProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.body) || (p.body, void 0), visitedObjects.has(p.cookies) || (p.cookies, void 0), visitedObjects.has(p.headers) || (p.headers, void 0), visitedObjects.has(p.jsonBody) || (p.jsonBody, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_ForwardedIPConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_GeoMatchStatementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.forwardedIpConfig) || (p.forwardedIpConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_HeaderMatchPatternProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_HeadersProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.matchPattern) || (p.matchPattern, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_IPSetForwardedIPConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_IPSetReferenceStatementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ipSetForwardedIpConfig) || (p.ipSetForwardedIpConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_ImmunityTimePropertyProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_JsonBodyProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.matchPattern) || (p.matchPattern, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_JsonMatchPatternProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_LabelProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_LabelMatchStatementProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_ManagedRuleGroupConfigProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.awsManagedRulesAtpRuleSet) || (p.awsManagedRulesAtpRuleSet, void 0), visitedObjects.has(p.awsManagedRulesBotControlRuleSet) || (p.awsManagedRulesBotControlRuleSet, void 0), visitedObjects.has(p.passwordField) || (p.passwordField, void 0), visitedObjects.has(p.usernameField) || (p.usernameField, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_ManagedRuleGroupStatementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.excludedRules) || (p.excludedRules, void 0), visitedObjects.has(p.managedRuleGroupConfigs) || (p.managedRuleGroupConfigs, void 0), visitedObjects.has(p.ruleActionOverrides) || (p.ruleActionOverrides, void 0), visitedObjects.has(p.scopeDownStatement) || (p.scopeDownStatement, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_NotStatementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.statement) || (p.statement, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_OrStatementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.statements) || (p.statements, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_OverrideActionProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_RateBasedStatementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.forwardedIpConfig) || (p.forwardedIpConfig, void 0), visitedObjects.has(p.scopeDownStatement) || (p.scopeDownStatement, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_RegexMatchStatementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldToMatch) || (p.fieldToMatch, void 0), visitedObjects.has(p.textTransformations) || (p.textTransformations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_RegexPatternSetReferenceStatementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldToMatch) || (p.fieldToMatch, void 0), visitedObjects.has(p.textTransformations) || (p.textTransformations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_RequestInspectionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.passwordField) || (p.passwordField, void 0), visitedObjects.has(p.usernameField) || (p.usernameField, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_ResponseInspectionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.bodyContains) || (p.bodyContains, void 0), visitedObjects.has(p.header) || (p.header, void 0), visitedObjects.has(p.json) || (p.json, void 0), visitedObjects.has(p.statusCode) || (p.statusCode, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_ResponseInspectionBodyContainsProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_ResponseInspectionHeaderProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_ResponseInspectionJsonProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_ResponseInspectionStatusCodeProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_RuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.statement) || (p.statement, void 0), visitedObjects.has(p.visibilityConfig) || (p.visibilityConfig, void 0), visitedObjects.has(p.action) || (p.action, void 0), visitedObjects.has(p.captchaConfig) || (p.captchaConfig, void 0), visitedObjects.has(p.challengeConfig) || (p.challengeConfig, void 0), visitedObjects.has(p.overrideAction) || (p.overrideAction, void 0), visitedObjects.has(p.ruleLabels) || (p.ruleLabels, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_RuleActionProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.allow) || (p.allow, void 0), visitedObjects.has(p.block) || (p.block, void 0), visitedObjects.has(p.captcha) || (p.captcha, void 0), visitedObjects.has(p.challenge) || (p.challenge, void 0), visitedObjects.has(p.count) || (p.count, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_RuleActionOverrideProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.actionToUse) || (p.actionToUse, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_RuleGroupReferenceStatementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.excludedRules) || (p.excludedRules, void 0), visitedObjects.has(p.ruleActionOverrides) || (p.ruleActionOverrides, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_SingleHeaderProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_SingleQueryArgumentProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_SizeConstraintStatementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldToMatch) || (p.fieldToMatch, void 0), visitedObjects.has(p.textTransformations) || (p.textTransformations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_SqliMatchStatementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldToMatch) || (p.fieldToMatch, void 0), visitedObjects.has(p.textTransformations) || (p.textTransformations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_StatementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.andStatement) || (p.andStatement, void 0), visitedObjects.has(p.byteMatchStatement) || (p.byteMatchStatement, void 0), visitedObjects.has(p.geoMatchStatement) || (p.geoMatchStatement, void 0), visitedObjects.has(p.ipSetReferenceStatement) || (p.ipSetReferenceStatement, void 0), visitedObjects.has(p.labelMatchStatement) || (p.labelMatchStatement, void 0), visitedObjects.has(p.managedRuleGroupStatement) || (p.managedRuleGroupStatement, void 0), visitedObjects.has(p.notStatement) || (p.notStatement, void 0), visitedObjects.has(p.orStatement) || (p.orStatement, void 0), visitedObjects.has(p.rateBasedStatement) || (p.rateBasedStatement, void 0), visitedObjects.has(p.regexMatchStatement) || (p.regexMatchStatement, void 0), visitedObjects.has(p.regexPatternSetReferenceStatement) || (p.regexPatternSetReferenceStatement, void 0), visitedObjects.has(p.ruleGroupReferenceStatement) || (p.ruleGroupReferenceStatement, void 0), visitedObjects.has(p.sizeConstraintStatement) || (p.sizeConstraintStatement, void 0), visitedObjects.has(p.sqliMatchStatement) || (p.sqliMatchStatement, void 0), visitedObjects.has(p.xssMatchStatement) || (p.xssMatchStatement, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_TextTransformationProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_VisibilityConfigProperty(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACL_XssMatchStatementProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fieldToMatch) || (p.fieldToMatch, void 0), visitedObjects.has(p.textTransformations) || (p.textTransformations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACLAssociationProps(p) {
    }
    function aws_cdk_lib_aws_wafv2_CfnWebACLAssociation(p) {
    }
    function aws_cdk_lib_aws_wisdom_CfnAssistantProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.serverSideEncryptionConfiguration) || (p.serverSideEncryptionConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wisdom_CfnAssistant(p) {
    }
    function aws_cdk_lib_aws_wisdom_CfnAssistant_ServerSideEncryptionConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_wisdom_CfnAssistantAssociationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.association) || (p.association, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wisdom_CfnAssistantAssociation(p) {
    }
    function aws_cdk_lib_aws_wisdom_CfnAssistantAssociation_AssociationDataProperty(p) {
    }
    function aws_cdk_lib_aws_wisdom_CfnKnowledgeBaseProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.renderingConfiguration) || (p.renderingConfiguration, void 0), visitedObjects.has(p.serverSideEncryptionConfiguration) || (p.serverSideEncryptionConfiguration, void 0), visitedObjects.has(p.sourceConfiguration) || (p.sourceConfiguration, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_wisdom_CfnKnowledgeBase(p) {
    }
    function aws_cdk_lib_aws_wisdom_CfnKnowledgeBase_AppIntegrationsConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_wisdom_CfnKnowledgeBase_RenderingConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_wisdom_CfnKnowledgeBase_ServerSideEncryptionConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_wisdom_CfnKnowledgeBase_SourceConfigurationProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.appIntegrations) || (p.appIntegrations, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_workspaces_CfnConnectionAliasProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_workspaces_CfnConnectionAlias(p) {
    }
    function aws_cdk_lib_aws_workspaces_CfnConnectionAlias_ConnectionAliasAssociationProperty(p) {
    }
    function aws_cdk_lib_aws_workspaces_CfnWorkspaceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.workspaceProperties) || (p.workspaceProperties, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_workspaces_CfnWorkspace(p) {
    }
    function aws_cdk_lib_aws_workspaces_CfnWorkspace_WorkspacePropertiesProperty(p) {
    }
    function aws_cdk_lib_aws_xray_CfnGroupProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.insightsConfiguration) || (p.insightsConfiguration, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_xray_CfnGroup(p) {
    }
    function aws_cdk_lib_aws_xray_CfnGroup_InsightsConfigurationProperty(p) {
    }
    function aws_cdk_lib_aws_xray_CfnGroup_TagsItemsProperty(p) {
    }
    function aws_cdk_lib_aws_xray_CfnResourcePolicyProps(p) {
    }
    function aws_cdk_lib_aws_xray_CfnResourcePolicy(p) {
    }
    function aws_cdk_lib_aws_xray_CfnSamplingRuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.samplingRule) || (p.samplingRule, void 0), visitedObjects.has(p.samplingRuleRecord) || (p.samplingRuleRecord, void 0), visitedObjects.has(p.samplingRuleUpdate) || (p.samplingRuleUpdate, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_xray_CfnSamplingRule(p) {
    }
    function aws_cdk_lib_aws_xray_CfnSamplingRule_SamplingRuleProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.attributes) || (p.attributes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_xray_CfnSamplingRule_SamplingRuleRecordProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.samplingRule) || (p.samplingRule, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_xray_CfnSamplingRule_SamplingRuleUpdateProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.attributes) || (p.attributes, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_aws_xray_CfnSamplingRule_TagsItemsProperty(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_ArtifactType(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_RuntimeInfo(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_MissingContext(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.props) || (p.props, void 0), visitedObjects.has(p.provider) || (p.provider, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_cloud_assembly_schema_ArtifactManifest(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.type) || (p.type, void 0), visitedObjects.has(p.properties) || aws_cdk_lib_cloud_assembly_schema_AwsCloudFormationStackProperties(p.properties);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_cloud_assembly_schema_AssemblyManifest(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.artifacts != null)
            for (const o of Object.values(p.artifacts))
              visitedObjects.has(o) || aws_cdk_lib_cloud_assembly_schema_ArtifactManifest(o);
          if (p.missing != null)
            for (const o of p.missing)
              visitedObjects.has(o) || aws_cdk_lib_cloud_assembly_schema_MissingContext(o);
          visitedObjects.has(p.runtime) || (p.runtime, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_cloud_assembly_schema_FileAssetMetadataEntry(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_Tag(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_ContainerImageAssetCacheOption(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_ContainerImageAssetMetadataEntry(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.cacheFrom != null)
            for (const o of p.cacheFrom)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.cacheTo) || (p.cacheTo, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_cloud_assembly_schema_ArtifactMetadataEntryType(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_MetadataEntry(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_BootstrapRole(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_AwsCloudFormationStackProperties(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.lookupRole) || (p.lookupRole, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_cloud_assembly_schema_AssetManifestOptions(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_AssetManifestProperties(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_TreeArtifactProperties(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_NestedCloudAssemblyProperties(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_ContextProvider(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_AmiContextQuery(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_AvailabilityZonesContextQuery(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_HostedZoneContextQuery(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_SSMParameterContextQuery(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_VpcContextQuery(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_EndpointServiceAvailabilityZonesContextQuery(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_LoadBalancerType(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_LoadBalancerFilter(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.loadBalancerType) || (p.loadBalancerType, void 0), p.loadBalancerTags != null)
            for (const o of p.loadBalancerTags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_cloud_assembly_schema_LoadBalancerContextQuery(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.loadBalancerType) || (p.loadBalancerType, void 0), p.loadBalancerTags != null)
            for (const o of p.loadBalancerTags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_cloud_assembly_schema_LoadBalancerListenerProtocol(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_LoadBalancerListenerContextQuery(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.listenerProtocol) || (p.listenerProtocol, void 0), visitedObjects.has(p.loadBalancerType) || (p.loadBalancerType, void 0), p.loadBalancerTags != null)
            for (const o of p.loadBalancerTags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_cloud_assembly_schema_SecurityGroupContextQuery(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_KeyContextQuery(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_PluginContextQuery(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_AssetManifest(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.dockerImages != null)
            for (const o of Object.values(p.dockerImages))
              visitedObjects.has(o) || aws_cdk_lib_cloud_assembly_schema_DockerImageAsset(o);
          if (p.files != null)
            for (const o of Object.values(p.files))
              visitedObjects.has(o) || aws_cdk_lib_cloud_assembly_schema_FileAsset(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_cloud_assembly_schema_DockerImageAsset(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.destinations != null)
            for (const o of Object.values(p.destinations))
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.source) || aws_cdk_lib_cloud_assembly_schema_DockerImageSource(p.source);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_cloud_assembly_schema_DockerImageSource(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.cacheFrom != null)
            for (const o of p.cacheFrom)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.cacheTo) || (p.cacheTo, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_cloud_assembly_schema_DockerImageDestination(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_DockerCacheOption(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_FileAsset(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.destinations != null)
            for (const o of Object.values(p.destinations))
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.source) || aws_cdk_lib_cloud_assembly_schema_FileSource(p.source);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_cloud_assembly_schema_FileAssetPackaging(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_FileSource(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.packaging) || (p.packaging, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_cloud_assembly_schema_FileDestination(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_AwsDestination(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_LoadManifestOptions(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_Manifest(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_IntegManifest(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.testCases != null)
            for (const o of Object.values(p.testCases))
              visitedObjects.has(o) || aws_cdk_lib_cloud_assembly_schema_TestCase(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_cloud_assembly_schema_RequireApproval(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_DefaultCdkOptions(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_DeployOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.requireApproval) || (p.requireApproval, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_cloud_assembly_schema_DestroyOptions(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_TestOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cdkCommandOptions) || aws_cdk_lib_cloud_assembly_schema_CdkCommands(p.cdkCommandOptions), visitedObjects.has(p.hooks) || (p.hooks, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_cloud_assembly_schema_TestCase(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.cdkCommandOptions) || aws_cdk_lib_cloud_assembly_schema_CdkCommands(p.cdkCommandOptions), visitedObjects.has(p.hooks) || (p.hooks, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_cloud_assembly_schema_Hooks(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_CdkCommand(p) {
    }
    function aws_cdk_lib_cloud_assembly_schema_DeployCommand(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.args) || aws_cdk_lib_cloud_assembly_schema_DeployOptions(p.args);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_cloud_assembly_schema_DestroyCommand(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.args) || (p.args, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_cloud_assembly_schema_CdkCommands(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.deploy) || aws_cdk_lib_cloud_assembly_schema_DeployCommand(p.deploy), visitedObjects.has(p.destroy) || aws_cdk_lib_cloud_assembly_schema_DestroyCommand(p.destroy);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_cloudformation_include_CfnIncludeProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.loadNestedStacks != null)
            for (const o of Object.values(p.loadNestedStacks))
              visitedObjects.has(o) || aws_cdk_lib_cloudformation_include_CfnIncludeProps(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_cloudformation_include_IncludedNestedStack(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.includedTemplate) || (p.includedTemplate, void 0), visitedObjects.has(p.stack) || (p.stack, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_cloudformation_include_CfnInclude(p) {
    }
    function aws_cdk_lib_custom_resources_PhysicalResourceIdReference(p) {
    }
    function aws_cdk_lib_custom_resources_PhysicalResourceId(p) {
    }
    function aws_cdk_lib_custom_resources_AwsSdkCall(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.physicalResourceId) || (p.physicalResourceId, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_custom_resources_SdkCallsPolicyOptions(p) {
    }
    function aws_cdk_lib_custom_resources_AwsCustomResourcePolicy(p) {
    }
    function aws_cdk_lib_custom_resources_AwsCustomResourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.logRetention) || (p.logRetention, void 0), visitedObjects.has(p.onCreate) || aws_cdk_lib_custom_resources_AwsSdkCall(p.onCreate), visitedObjects.has(p.onDelete) || aws_cdk_lib_custom_resources_AwsSdkCall(p.onDelete), visitedObjects.has(p.onUpdate) || aws_cdk_lib_custom_resources_AwsSdkCall(p.onUpdate), visitedObjects.has(p.policy) || (p.policy, void 0), visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), visitedObjects.has(p.role) || (p.role, void 0), visitedObjects.has(p.timeout) || (p.timeout, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_custom_resources_AwsCustomResource(p) {
    }
    function aws_cdk_lib_custom_resources_ProviderProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.onEventHandler) || (p.onEventHandler, void 0), visitedObjects.has(p.isCompleteHandler) || (p.isCompleteHandler, void 0), visitedObjects.has(p.logRetention) || (p.logRetention, void 0), visitedObjects.has(p.queryInterval) || (p.queryInterval, void 0), visitedObjects.has(p.role) || (p.role, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.totalTimeout) || (p.totalTimeout, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_custom_resources_Provider(p) {
    }
    function aws_cdk_lib_cx_api_VpcSubnetGroupType(p) {
    }
    function aws_cdk_lib_cx_api_VpcSubnet(p) {
    }
    function aws_cdk_lib_cx_api_VpcSubnetGroup(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.subnets != null)
            for (const o of p.subnets)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.type) || (p.type, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_cx_api_VpcContextResponse(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.subnetGroups != null)
            for (const o of p.subnetGroups)
              visitedObjects.has(o) || aws_cdk_lib_cx_api_VpcSubnetGroup(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_cx_api_LoadBalancerIpAddressType(p) {
    }
    function aws_cdk_lib_cx_api_LoadBalancerContextResponse(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ipAddressType) || (p.ipAddressType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_cx_api_LoadBalancerListenerContextResponse(p) {
    }
    function aws_cdk_lib_cx_api_EndpointServiceAvailabilityZonesContextQuery(p) {
    }
    function aws_cdk_lib_cx_api_SecurityGroupContextResponse(p) {
    }
    function aws_cdk_lib_cx_api_KeyContextResponse(p) {
    }
    function aws_cdk_lib_cx_api_AwsCloudFormationStackProperties(p) {
    }
    function aws_cdk_lib_cx_api_CloudArtifact(p) {
    }
    function aws_cdk_lib_cx_api_AssetManifestArtifact(p) {
    }
    function aws_cdk_lib_cx_api_CloudFormationStackArtifact(p) {
    }
    function aws_cdk_lib_cx_api_TreeCloudArtifact(p) {
    }
    function aws_cdk_lib_cx_api_NestedCloudAssemblyArtifact(p) {
    }
    function aws_cdk_lib_cx_api_CloudAssembly(p) {
    }
    function aws_cdk_lib_cx_api_CloudAssemblyBuilderProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.parentBuilder) || (p.parentBuilder, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_cx_api_CloudAssemblyBuilder(p) {
    }
    function aws_cdk_lib_cx_api_AssemblyBuildOptions(p) {
    }
    function aws_cdk_lib_cx_api_Environment(p) {
    }
    function aws_cdk_lib_cx_api_EnvironmentUtils(p) {
    }
    function aws_cdk_lib_cx_api_SynthesisMessageLevel(p) {
    }
    function aws_cdk_lib_cx_api_MetadataEntryResult(p) {
    }
    function aws_cdk_lib_cx_api_SynthesisMessage(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.entry) || (p.entry, void 0), visitedObjects.has(p.level) || (p.level, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_cx_api_EnvironmentPlaceholders(p) {
    }
    function aws_cdk_lib_cx_api_EnvironmentPlaceholderValues(p) {
    }
    function aws_cdk_lib_cx_api_IEnvironmentPlaceholderProvider(p) {
    }
    function aws_cdk_lib_lambda_layer_awscli_AwsCliLayer(p) {
    }
    function aws_cdk_lib_lambda_layer_kubectl_KubectlLayer(p) {
    }
    function aws_cdk_lib_lambda_layer_node_proxy_agent_NodeProxyAgentLayer(p) {
    }
    function aws_cdk_lib_pipelines_AssetType(p) {
    }
    function aws_cdk_lib_pipelines_FileSet(p) {
    }
    function aws_cdk_lib_pipelines_IFileSetProducer(p) {
    }
    function aws_cdk_lib_pipelines_ShellStepProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.additionalInputs != null)
            for (const o of Object.values(p.additionalInputs))
              visitedObjects.has(o) || void 0;
          if (p.envFromCfnOutputs != null)
            for (const o of Object.values(p.envFromCfnOutputs))
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.input) || (p.input, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_pipelines_ShellStep(p) {
    }
    function aws_cdk_lib_pipelines_FileSetLocation(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.fileSet) || (p.fileSet, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_pipelines_StackOutputReference(p) {
    }
    function aws_cdk_lib_pipelines_StackDeploymentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.assets != null)
            for (const o of p.assets)
              visitedObjects.has(o) || aws_cdk_lib_pipelines_StackAsset(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_pipelines_StackDeployment(p) {
    }
    function aws_cdk_lib_pipelines_StackAsset(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.assetType) || (p.assetType, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_pipelines_StageDeploymentProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.post != null)
            for (const o of p.post)
              visitedObjects.has(o) || void 0;
          if (p.pre != null)
            for (const o of p.pre)
              visitedObjects.has(o) || void 0;
          if (p.stackSteps != null)
            for (const o of p.stackSteps)
              visitedObjects.has(o) || aws_cdk_lib_pipelines_StackSteps(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_pipelines_StageDeployment(p) {
    }
    function aws_cdk_lib_pipelines_Step(p) {
    }
    function aws_cdk_lib_pipelines_StackSteps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.stack) || (p.stack, void 0), p.changeSet != null)
            for (const o of p.changeSet)
              visitedObjects.has(o) || void 0;
          if (p.post != null)
            for (const o of p.post)
              visitedObjects.has(o) || void 0;
          if (p.pre != null)
            for (const o of p.pre)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_pipelines_WaveProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.post != null)
            for (const o of p.post)
              visitedObjects.has(o) || void 0;
          if (p.pre != null)
            for (const o of p.pre)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_pipelines_Wave(p) {
    }
    function aws_cdk_lib_pipelines_AddStageOpts(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.post != null)
            for (const o of p.post)
              visitedObjects.has(o) || void 0;
          if (p.pre != null)
            for (const o of p.pre)
              visitedObjects.has(o) || void 0;
          if (p.stackSteps != null)
            for (const o of p.stackSteps)
              visitedObjects.has(o) || aws_cdk_lib_pipelines_StackSteps(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_pipelines_WaveOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.post != null)
            for (const o of p.post)
              visitedObjects.has(o) || void 0;
          if (p.pre != null)
            for (const o of p.pre)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_pipelines_ManualApprovalStepProps(p) {
    }
    function aws_cdk_lib_pipelines_ManualApprovalStep(p) {
    }
    function aws_cdk_lib_pipelines_ArtifactMap(p) {
    }
    function aws_cdk_lib_pipelines_CodePipelineFileSet(p) {
    }
    function aws_cdk_lib_pipelines_CodeBuildStepProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.actionRole) || (p.actionRole, void 0), visitedObjects.has(p.buildEnvironment) || aws_cdk_lib_aws_codebuild_BuildEnvironment(p.buildEnvironment), visitedObjects.has(p.cache) || (p.cache, void 0), p.fileSystemLocations != null)
            for (const o of p.fileSystemLocations)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.logging) || aws_cdk_lib_aws_codebuild_LoggingOptions(p.logging), visitedObjects.has(p.partialBuildSpec) || (p.partialBuildSpec, void 0), visitedObjects.has(p.role) || (p.role, void 0), p.rolePolicyStatements != null)
            for (const o of p.rolePolicyStatements)
              visitedObjects.has(o) || void 0;
          if (p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.subnetSelection) || aws_cdk_lib_aws_ec2_SubnetSelection(p.subnetSelection), visitedObjects.has(p.timeout) || (p.timeout, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0), p.additionalInputs != null)
            for (const o of Object.values(p.additionalInputs))
              visitedObjects.has(o) || void 0;
          if (p.envFromCfnOutputs != null)
            for (const o of Object.values(p.envFromCfnOutputs))
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.input) || (p.input, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_pipelines_CodeBuildStep(p) {
    }
    function aws_cdk_lib_pipelines_PermissionsBroadeningCheckProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.stage) || (p.stage, void 0), visitedObjects.has(p.notificationTopic) || (p.notificationTopic, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_pipelines_ConfirmPermissionsBroadening(p) {
    }
    function aws_cdk_lib_pipelines_CodePipelineProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.synth) || (p.synth, void 0), visitedObjects.has(p.artifactBucket) || (p.artifactBucket, void 0), visitedObjects.has(p.assetPublishingCodeBuildDefaults) || aws_cdk_lib_pipelines_CodeBuildOptions(p.assetPublishingCodeBuildDefaults), visitedObjects.has(p.codeBuildDefaults) || aws_cdk_lib_pipelines_CodeBuildOptions(p.codeBuildDefaults), visitedObjects.has(p.codePipeline) || (p.codePipeline, void 0), p.dockerCredentials != null)
            for (const o of p.dockerCredentials)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.role) || (p.role, void 0), visitedObjects.has(p.selfMutationCodeBuildDefaults) || aws_cdk_lib_pipelines_CodeBuildOptions(p.selfMutationCodeBuildDefaults), visitedObjects.has(p.synthCodeBuildDefaults) || aws_cdk_lib_pipelines_CodeBuildOptions(p.synthCodeBuildDefaults);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_pipelines_CodeBuildOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.buildEnvironment) || aws_cdk_lib_aws_codebuild_BuildEnvironment(p.buildEnvironment), visitedObjects.has(p.cache) || (p.cache, void 0), p.fileSystemLocations != null)
            for (const o of p.fileSystemLocations)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.logging) || aws_cdk_lib_aws_codebuild_LoggingOptions(p.logging), visitedObjects.has(p.partialBuildSpec) || (p.partialBuildSpec, void 0), p.rolePolicy != null)
            for (const o of p.rolePolicy)
              visitedObjects.has(o) || void 0;
          if (p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.subnetSelection) || aws_cdk_lib_aws_ec2_SubnetSelection(p.subnetSelection), visitedObjects.has(p.timeout) || (p.timeout, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_pipelines_CodePipeline(p) {
    }
    function aws_cdk_lib_pipelines_ProduceActionOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.artifacts) || (p.artifacts, void 0), visitedObjects.has(p.pipeline) || (p.pipeline, void 0), visitedObjects.has(p.stackOutputsMap) || (p.stackOutputsMap, void 0), visitedObjects.has(p.codeBuildDefaults) || aws_cdk_lib_pipelines_CodeBuildOptions(p.codeBuildDefaults), visitedObjects.has(p.fallbackArtifact) || (p.fallbackArtifact, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_pipelines_ICodePipelineActionFactory(p) {
    }
    function aws_cdk_lib_pipelines_CodePipelineActionFactoryResult(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.project) || (p.project, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_pipelines_CodePipelineSource(p) {
    }
    function aws_cdk_lib_pipelines_GitHubSourceOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.authentication) || (p.authentication, void 0), visitedObjects.has(p.trigger) || (p.trigger, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_pipelines_S3SourceOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.role) || (p.role, void 0), visitedObjects.has(p.trigger) || (p.trigger, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_pipelines_ECRSourceOptions(p) {
    }
    function aws_cdk_lib_pipelines_ConnectionSourceOptions(p) {
    }
    function aws_cdk_lib_pipelines_CodeCommitSourceOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.eventRole) || (p.eventRole, void 0), visitedObjects.has(p.trigger) || (p.trigger, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_pipelines_StackOutputsMap(p) {
    }
    function aws_cdk_lib_pipelines_PipelineBaseProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.synth) || (p.synth, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_pipelines_PipelineBase(p) {
    }
    function aws_cdk_lib_pipelines_DockerCredential(p) {
    }
    function aws_cdk_lib_pipelines_ExternalDockerCredentialOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.assumeRole) || (p.assumeRole, void 0), p.usages != null)
            for (const o of p.usages)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_pipelines_EcrDockerCredentialOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.assumeRole) || (p.assumeRole, void 0), p.usages != null)
            for (const o of p.usages)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_pipelines_DockerCredentialUsage(p) {
    }
    function aws_cdk_lib_region_info_Default(p) {
    }
    function aws_cdk_lib_region_info_Fact(p) {
    }
    function aws_cdk_lib_region_info_IFact(p) {
    }
    function aws_cdk_lib_region_info_FactName(p) {
    }
    function aws_cdk_lib_region_info_RegionInfo(p) {
    }
    function aws_cdk_lib_triggers_ITrigger(p) {
    }
    function aws_cdk_lib_triggers_TriggerOptions(p) {
    }
    function aws_cdk_lib_triggers_InvocationType(p) {
    }
    function aws_cdk_lib_triggers_TriggerProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.handler) || (p.handler, void 0), visitedObjects.has(p.invocationType) || (p.invocationType, void 0), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_triggers_Trigger(p) {
    }
    function aws_cdk_lib_triggers_TriggerInvalidation(p) {
    }
    function aws_cdk_lib_triggers_TriggerFunctionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.code) || (p.code, void 0), visitedObjects.has(p.runtime) || (p.runtime, void 0), visitedObjects.has(p.adotInstrumentation) || aws_cdk_lib_aws_lambda_AdotInstrumentationConfig(p.adotInstrumentation), visitedObjects.has(p.architecture) || (p.architecture, void 0), visitedObjects.has(p.codeSigningConfig) || (p.codeSigningConfig, void 0), visitedObjects.has(p.currentVersionOptions) || aws_cdk_lib_aws_lambda_VersionOptions(p.currentVersionOptions), visitedObjects.has(p.deadLetterQueue) || (p.deadLetterQueue, void 0), visitedObjects.has(p.deadLetterTopic) || (p.deadLetterTopic, void 0), visitedObjects.has(p.environmentEncryption) || (p.environmentEncryption, void 0), visitedObjects.has(p.ephemeralStorageSize) || (p.ephemeralStorageSize, void 0), p.events != null)
            for (const o of p.events)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.filesystem) || (p.filesystem, void 0), p.initialPolicy != null)
            for (const o of p.initialPolicy)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.insightsVersion) || (p.insightsVersion, void 0), p.layers != null)
            for (const o of p.layers)
              visitedObjects.has(o) || void 0;
          if (visitedObjects.has(p.logRetention) || (p.logRetention, void 0), visitedObjects.has(p.logRetentionRetryOptions) || aws_cdk_lib_aws_lambda_LogRetentionRetryOptions(p.logRetentionRetryOptions), visitedObjects.has(p.logRetentionRole) || (p.logRetentionRole, void 0), visitedObjects.has(p.profilingGroup) || (p.profilingGroup, void 0), visitedObjects.has(p.role) || (p.role, void 0), visitedObjects.has(p.runtimeManagementMode) || (p.runtimeManagementMode, void 0), p.securityGroups != null)
            for (const o of p.securityGroups)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.timeout) || (p.timeout, void 0), visitedObjects.has(p.tracing) || (p.tracing, void 0), visitedObjects.has(p.vpc) || (p.vpc, void 0), visitedObjects.has(p.vpcSubnets) || aws_cdk_lib_aws_ec2_SubnetSelection(p.vpcSubnets), visitedObjects.has(p.maxEventAge) || (p.maxEventAge, void 0), visitedObjects.has(p.onFailure) || (p.onFailure, void 0), visitedObjects.has(p.onSuccess) || (p.onSuccess, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_triggers_TriggerFunction(p) {
    }
    function aws_cdk_lib_IAspect(p) {
    }
    function aws_cdk_lib_Aspects(p) {
    }
    function aws_cdk_lib_TagProps(p) {
    }
    function aws_cdk_lib_Tag(p) {
    }
    function aws_cdk_lib_Tags(p) {
    }
    function aws_cdk_lib_RemoveTag(p) {
    }
    function aws_cdk_lib_TokenComparison(p) {
    }
    function aws_cdk_lib_Token(p) {
    }
    function aws_cdk_lib_Tokenization(p) {
    }
    function aws_cdk_lib_JsonNull(p) {
    }
    function aws_cdk_lib_ReverseOptions(p) {
    }
    function aws_cdk_lib_ResolveOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.resolver) || (p.resolver, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_EncodingOptions(p) {
    }
    function aws_cdk_lib_IResolveContext(p) {
    }
    function aws_cdk_lib_ResolveChangeContextOptions(p) {
    }
    function aws_cdk_lib_IResolvable(p) {
    }
    function aws_cdk_lib_IPostProcessor(p) {
    }
    function aws_cdk_lib_ITokenResolver(p) {
    }
    function aws_cdk_lib_IFragmentConcatenator(p) {
    }
    function aws_cdk_lib_StringConcat(p) {
    }
    function aws_cdk_lib_DefaultTokenResolver(p) {
    }
    function aws_cdk_lib_ResolutionTypeHint(p) {
    }
    function aws_cdk_lib_IStringProducer(p) {
    }
    function aws_cdk_lib_IStableStringProducer(p) {
    }
    function aws_cdk_lib_IListProducer(p) {
    }
    function aws_cdk_lib_IStableListProducer(p) {
    }
    function aws_cdk_lib_INumberProducer(p) {
    }
    function aws_cdk_lib_IStableNumberProducer(p) {
    }
    function aws_cdk_lib_IAnyProducer(p) {
    }
    function aws_cdk_lib_IStableAnyProducer(p) {
    }
    function aws_cdk_lib_LazyStringValueOptions(p) {
    }
    function aws_cdk_lib_LazyListValueOptions(p) {
    }
    function aws_cdk_lib_LazyAnyValueOptions(p) {
    }
    function aws_cdk_lib_Lazy(p) {
    }
    function aws_cdk_lib_ITaggable(p) {
    }
    function aws_cdk_lib_TagManagerOptions(p) {
    }
    function aws_cdk_lib_TagManager(p) {
    }
    function aws_cdk_lib_TokenizedStringFragments(p) {
    }
    function aws_cdk_lib_ITokenMapper(p) {
    }
    function aws_cdk_lib_IStackSynthesizer(p) {
    }
    function aws_cdk_lib_IReusableStackSynthesizer(p) {
    }
    function aws_cdk_lib_IBoundStackSynthesizer(p) {
    }
    function aws_cdk_lib_ISynthesisSession(p) {
    }
    function aws_cdk_lib_DefaultStackSynthesizerProps(p) {
    }
    function aws_cdk_lib_DefaultStackSynthesizer(p) {
    }
    function aws_cdk_lib_LegacyStackSynthesizer(p) {
    }
    function aws_cdk_lib_BootstraplessSynthesizerProps(p) {
    }
    function aws_cdk_lib_BootstraplessSynthesizer(p) {
    }
    function aws_cdk_lib_NestedStackSynthesizer(p) {
    }
    function aws_cdk_lib_StackSynthesizer(p) {
    }
    function aws_cdk_lib_SynthesizeStackArtifactOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.lookupRole) || (p.lookupRole, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_CliCredentialsStackSynthesizerProps(p) {
    }
    function aws_cdk_lib_CliCredentialsStackSynthesizer(p) {
    }
    function aws_cdk_lib_AssetManifestBuilder(p) {
    }
    function aws_cdk_lib_AssetManifestFileDestination(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_AssetManifestDockerImageDestination(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.role) || (p.role, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_RoleOptions(p) {
    }
    function aws_cdk_lib_Reference(p) {
    }
    function aws_cdk_lib_CfnConditionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.expression) || (p.expression, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_CfnCondition(p) {
    }
    function aws_cdk_lib_ICfnConditionExpression(p) {
    }
    function aws_cdk_lib_ICfnRuleConditionExpression(p) {
    }
    function aws_cdk_lib_Fn(p) {
    }
    function aws_cdk_lib_CfnHookProps(p) {
    }
    function aws_cdk_lib_CfnHook(p) {
    }
    function aws_cdk_lib_CfnTrafficRoutingType(p) {
    }
    function aws_cdk_lib_CfnTrafficRoutingTimeBasedCanary(p) {
    }
    function aws_cdk_lib_CfnTrafficRoutingTimeBasedLinear(p) {
    }
    function aws_cdk_lib_CfnTrafficRoutingConfig(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.type) || (p.type, void 0), visitedObjects.has(p.timeBasedCanary) || (p.timeBasedCanary, void 0), visitedObjects.has(p.timeBasedLinear) || (p.timeBasedLinear, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_CfnCodeDeployBlueGreenAdditionalOptions(p) {
    }
    function aws_cdk_lib_CfnCodeDeployBlueGreenLifecycleEventHooks(p) {
    }
    function aws_cdk_lib_CfnCodeDeployBlueGreenApplicationTarget(p) {
    }
    function aws_cdk_lib_CfnTrafficRoute(p) {
    }
    function aws_cdk_lib_CfnTrafficRouting(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.prodTrafficRoute) || (p.prodTrafficRoute, void 0), visitedObjects.has(p.testTrafficRoute) || (p.testTrafficRoute, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_CfnCodeDeployBlueGreenEcsAttributes(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.trafficRouting) || aws_cdk_lib_CfnTrafficRouting(p.trafficRouting);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_CfnCodeDeployBlueGreenApplication(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.ecsAttributes) || aws_cdk_lib_CfnCodeDeployBlueGreenEcsAttributes(p.ecsAttributes), visitedObjects.has(p.target) || (p.target, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_CfnCodeDeployBlueGreenHookProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.applications != null)
            for (const o of p.applications)
              visitedObjects.has(o) || aws_cdk_lib_CfnCodeDeployBlueGreenApplication(o);
          visitedObjects.has(p.additionalOptions) || (p.additionalOptions, void 0), visitedObjects.has(p.lifecycleEventHooks) || (p.lifecycleEventHooks, void 0), visitedObjects.has(p.trafficRoutingConfig) || aws_cdk_lib_CfnTrafficRoutingConfig(p.trafficRoutingConfig);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_CfnCodeDeployBlueGreenHook(p) {
    }
    function aws_cdk_lib_CfnMappingProps(p) {
    }
    function aws_cdk_lib_CfnMapping(p) {
    }
    function aws_cdk_lib_CfnOutputProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.condition) || (p.condition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_CfnOutput(p) {
    }
    function aws_cdk_lib_CfnParameterProps(p) {
    }
    function aws_cdk_lib_CfnParameter(p) {
    }
    function aws_cdk_lib_Aws(p) {
    }
    function aws_cdk_lib_ScopedAws(p) {
    }
    function aws_cdk_lib_CfnResourceProps(p) {
    }
    function aws_cdk_lib_CfnResource(p) {
    }
    function aws_cdk_lib_TagType(p) {
    }
    function aws_cdk_lib_ICfnResourceOptions(p) {
    }
    function aws_cdk_lib_CfnCreationPolicy(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.autoScalingCreationPolicy) || (p.autoScalingCreationPolicy, void 0), visitedObjects.has(p.resourceSignal) || (p.resourceSignal, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_CfnResourceAutoScalingCreationPolicy(p) {
    }
    function aws_cdk_lib_CfnResourceSignal(p) {
    }
    function aws_cdk_lib_CfnDeletionPolicy(p) {
    }
    function aws_cdk_lib_CfnUpdatePolicy(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.autoScalingReplacingUpdate) || (p.autoScalingReplacingUpdate, void 0), visitedObjects.has(p.autoScalingRollingUpdate) || (p.autoScalingRollingUpdate, void 0), visitedObjects.has(p.autoScalingScheduledAction) || (p.autoScalingScheduledAction, void 0), visitedObjects.has(p.codeDeployLambdaAliasUpdate) || (p.codeDeployLambdaAliasUpdate, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_CfnAutoScalingRollingUpdate(p) {
    }
    function aws_cdk_lib_CfnAutoScalingReplacingUpdate(p) {
    }
    function aws_cdk_lib_CfnAutoScalingScheduledAction(p) {
    }
    function aws_cdk_lib_CfnCodeDeployLambdaAliasUpdate(p) {
    }
    function aws_cdk_lib_CfnRuleProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.assertions != null)
            for (const o of p.assertions)
              visitedObjects.has(o) || aws_cdk_lib_CfnRuleAssertion(o);
          visitedObjects.has(p.ruleCondition) || (p.ruleCondition, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_CfnRule(p) {
    }
    function aws_cdk_lib_CfnRuleAssertion(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.assert) || (p.assert, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_StackProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.env) || (p.env, void 0), visitedObjects.has(p.permissionsBoundary) || (p.permissionsBoundary, void 0), visitedObjects.has(p.synthesizer) || (p.synthesizer, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_Stack(p) {
    }
    function aws_cdk_lib_ITemplateOptions(p) {
    }
    function aws_cdk_lib_ExportValueOptions(p) {
    }
    function aws_cdk_lib_StageProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.env) || (p.env, void 0), visitedObjects.has(p.permissionsBoundary) || (p.permissionsBoundary, void 0), p.policyValidationBeta1 != null)
            for (const o of p.policyValidationBeta1)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_Stage(p) {
    }
    function aws_cdk_lib_StageSynthesisOptions(p) {
    }
    function aws_cdk_lib_CfnElement(p) {
    }
    function aws_cdk_lib_CfnRefElement(p) {
    }
    function aws_cdk_lib_CfnDynamicReferenceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.service) || (p.service, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_CfnDynamicReference(p) {
    }
    function aws_cdk_lib_CfnDynamicReferenceService(p) {
    }
    function aws_cdk_lib_CfnTag(p) {
    }
    function aws_cdk_lib_CfnJsonProps(p) {
    }
    function aws_cdk_lib_CfnJson(p) {
    }
    function aws_cdk_lib_RemovalPolicy(p) {
    }
    function aws_cdk_lib_RemovalPolicyOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.default) || (p.default, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_ArnFormat(p) {
    }
    function aws_cdk_lib_ArnComponents(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.arnFormat) || (p.arnFormat, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_Arn(p) {
    }
    function aws_cdk_lib_Duration(p) {
    }
    function aws_cdk_lib_TimeConversionOptions(p) {
    }
    function aws_cdk_lib_Expiration(p) {
    }
    function aws_cdk_lib_Size(p) {
    }
    function aws_cdk_lib_SizeRoundingBehavior(p) {
    }
    function aws_cdk_lib_SizeConversionOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.rounding) || (p.rounding, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_AppProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.defaultStackSynthesizer) || (p.defaultStackSynthesizer, void 0), p.policyValidationBeta1 != null)
            for (const o of p.policyValidationBeta1)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_App(p) {
    }
    function aws_cdk_lib_GetContextKeyOptions(p) {
    }
    function aws_cdk_lib_GetContextValueOptions(p) {
    }
    function aws_cdk_lib_GetContextKeyResult(p) {
    }
    function aws_cdk_lib_GetContextValueResult(p) {
    }
    function aws_cdk_lib_ContextProvider(p) {
    }
    function aws_cdk_lib_Environment(p) {
    }
    function aws_cdk_lib_Annotations(p) {
    }
    function aws_cdk_lib_ValidationResult(p) {
    }
    function aws_cdk_lib_ValidationResults(p) {
    }
    function aws_cdk_lib_SecretValue(p) {
    }
    function aws_cdk_lib_SecretsManagerSecretOptions(p) {
    }
    function aws_cdk_lib_ResourceEnvironment(p) {
    }
    function aws_cdk_lib_IResource(p) {
    }
    function aws_cdk_lib_ResourceProps(p) {
    }
    function aws_cdk_lib_Resource(p) {
    }
    function aws_cdk_lib_PhysicalName(p) {
    }
    function aws_cdk_lib_IAsset(p) {
    }
    function aws_cdk_lib_AssetOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.assetHashType) || (p.assetHashType, void 0), visitedObjects.has(p.bundling) || aws_cdk_lib_BundlingOptions(p.bundling);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_AssetHashType(p) {
    }
    function aws_cdk_lib_FileAssetSource(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.packaging) || (p.packaging, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_DockerImageAssetSource(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.dockerCacheFrom != null)
            for (const o of p.dockerCacheFrom)
              visitedObjects.has(o) || void 0;
          visitedObjects.has(p.dockerCacheTo) || (p.dockerCacheTo, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_FileAssetPackaging(p) {
    }
    function aws_cdk_lib_FileAssetLocation(p) {
    }
    function aws_cdk_lib_DockerImageAssetLocation(p) {
    }
    function aws_cdk_lib_DockerCacheOption(p) {
    }
    function aws_cdk_lib_TreeInspector(p) {
    }
    function aws_cdk_lib_IInspectable(p) {
    }
    function aws_cdk_lib_AssetStagingProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.follow) || (p.follow, void 0), visitedObjects.has(p.ignoreMode) || (p.ignoreMode, void 0), visitedObjects.has(p.assetHashType) || (p.assetHashType, void 0), visitedObjects.has(p.bundling) || aws_cdk_lib_BundlingOptions(p.bundling);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_AssetStaging(p) {
    }
    function aws_cdk_lib_DockerBuildSecret(p) {
    }
    function aws_cdk_lib_BundlingOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.image) || (p.image, void 0), visitedObjects.has(p.bundlingFileAccess) || (p.bundlingFileAccess, void 0), visitedObjects.has(p.local) || (p.local, void 0), visitedObjects.has(p.outputType) || (p.outputType, void 0), p.volumes != null)
            for (const o of p.volumes)
              visitedObjects.has(o) || aws_cdk_lib_DockerVolume(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_BundlingOutput(p) {
    }
    function aws_cdk_lib_ILocalBundling(p) {
    }
    function aws_cdk_lib_BundlingFileAccess(p) {
    }
    function aws_cdk_lib_DockerImage(p) {
    }
    function aws_cdk_lib_DockerVolume(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.consistency) || (p.consistency, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_DockerVolumeConsistency(p) {
    }
    function aws_cdk_lib_DockerRunOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.volumes != null)
            for (const o of p.volumes)
              visitedObjects.has(o) || aws_cdk_lib_DockerVolume(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_DockerBuildOptions(p) {
    }
    function aws_cdk_lib_FileSystem(p) {
    }
    function aws_cdk_lib_IgnoreStrategy(p) {
    }
    function aws_cdk_lib_GlobIgnoreStrategy(p) {
    }
    function aws_cdk_lib_GitIgnoreStrategy(p) {
    }
    function aws_cdk_lib_DockerIgnoreStrategy(p) {
    }
    function aws_cdk_lib_SymlinkFollowMode(p) {
    }
    function aws_cdk_lib_IgnoreMode(p) {
    }
    function aws_cdk_lib_CopyOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.follow) || (p.follow, void 0), visitedObjects.has(p.ignoreMode) || (p.ignoreMode, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_FileCopyOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.followSymlinks) || (p.followSymlinks, void 0), visitedObjects.has(p.ignoreMode) || (p.ignoreMode, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_FingerprintOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.follow) || (p.follow, void 0), visitedObjects.has(p.ignoreMode) || (p.ignoreMode, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_FileFingerprintOptions(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.followSymlinks) || (p.followSymlinks, void 0), visitedObjects.has(p.ignoreMode) || (p.ignoreMode, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_CustomResourceProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_CustomResource(p) {
    }
    function aws_cdk_lib_NestedStackProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.removalPolicy) || (p.removalPolicy, void 0), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_NestedStack(p) {
    }
    function aws_cdk_lib_CustomResourceProviderProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.runtime) || (p.runtime, void 0), visitedObjects.has(p.memorySize) || (p.memorySize, void 0), visitedObjects.has(p.timeout) || (p.timeout, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_CustomResourceProviderRuntime(p) {
    }
    function aws_cdk_lib_CustomResourceProvider(p) {
    }
    function aws_cdk_lib_CfnCapabilities(p) {
    }
    function aws_cdk_lib_CfnCustomResourceProps(p) {
    }
    function aws_cdk_lib_CfnCustomResource(p) {
    }
    function aws_cdk_lib_CfnHookDefaultVersionProps(p) {
    }
    function aws_cdk_lib_CfnHookDefaultVersion(p) {
    }
    function aws_cdk_lib_CfnHookTypeConfigProps(p) {
    }
    function aws_cdk_lib_CfnHookTypeConfig(p) {
    }
    function aws_cdk_lib_CfnHookVersionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.loggingConfig) || (p.loggingConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_CfnHookVersion(p) {
    }
    function aws_cdk_lib_CfnHookVersion_LoggingConfigProperty(p) {
    }
    function aws_cdk_lib_CfnMacroProps(p) {
    }
    function aws_cdk_lib_CfnMacro(p) {
    }
    function aws_cdk_lib_CfnModuleDefaultVersionProps(p) {
    }
    function aws_cdk_lib_CfnModuleDefaultVersion(p) {
    }
    function aws_cdk_lib_CfnModuleVersionProps(p) {
    }
    function aws_cdk_lib_CfnModuleVersion(p) {
    }
    function aws_cdk_lib_CfnPublicTypeVersionProps(p) {
    }
    function aws_cdk_lib_CfnPublicTypeVersion(p) {
    }
    function aws_cdk_lib_CfnPublisherProps(p) {
    }
    function aws_cdk_lib_CfnPublisher(p) {
    }
    function aws_cdk_lib_CfnResourceDefaultVersionProps(p) {
    }
    function aws_cdk_lib_CfnResourceDefaultVersion(p) {
    }
    function aws_cdk_lib_CfnResourceVersionProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.loggingConfig) || (p.loggingConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_CfnResourceVersion(p) {
    }
    function aws_cdk_lib_CfnResourceVersion_LoggingConfigProperty(p) {
    }
    function aws_cdk_lib_CfnStackProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.parameters) || (p.parameters, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_CfnStack(p) {
    }
    function aws_cdk_lib_CfnStackSetProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (visitedObjects.has(p.autoDeployment) || (p.autoDeployment, void 0), visitedObjects.has(p.operationPreferences) || (p.operationPreferences, void 0), visitedObjects.has(p.parameters) || (p.parameters, void 0), visitedObjects.has(p.stackInstancesGroup) || (p.stackInstancesGroup, void 0), p.tags != null)
            for (const o of p.tags)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_CfnStackSet(p) {
    }
    function aws_cdk_lib_CfnStackSet_AutoDeploymentProperty(p) {
    }
    function aws_cdk_lib_CfnStackSet_DeploymentTargetsProperty(p) {
    }
    function aws_cdk_lib_CfnStackSet_ManagedExecutionProperty(p) {
    }
    function aws_cdk_lib_CfnStackSet_OperationPreferencesProperty(p) {
    }
    function aws_cdk_lib_CfnStackSet_ParameterProperty(p) {
    }
    function aws_cdk_lib_CfnStackSet_StackInstancesProperty(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.deploymentTargets) || (p.deploymentTargets, void 0), visitedObjects.has(p.parameterOverrides) || (p.parameterOverrides, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_CfnTypeActivationProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.loggingConfig) || (p.loggingConfig, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_CfnTypeActivation(p) {
    }
    function aws_cdk_lib_CfnTypeActivation_LoggingConfigProperty(p) {
    }
    function aws_cdk_lib_CfnWaitConditionProps(p) {
    }
    function aws_cdk_lib_CfnWaitCondition(p) {
    }
    function aws_cdk_lib_CfnWaitConditionHandle(p) {
    }
    function aws_cdk_lib_FeatureFlags(p) {
    }
    function aws_cdk_lib_PermissionsBoundaryBindOptions(p) {
    }
    function aws_cdk_lib_PermissionsBoundary(p) {
    }
    function aws_cdk_lib_IPolicyValidationPluginBeta1(p) {
    }
    function aws_cdk_lib_IPolicyValidationContextBeta1(p) {
    }
    function aws_cdk_lib_PolicyViolationBeta1(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.violatingResources != null)
            for (const o of p.violatingResources)
              visitedObjects.has(o) || void 0;
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_PolicyViolatingResourceBeta1(p) {
    }
    function aws_cdk_lib_PolicyValidationReportStatusBeta1(p) {
    }
    function aws_cdk_lib_PolicyValidationPluginReportBeta1(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          if (p.violations != null)
            for (const o of p.violations)
              visitedObjects.has(o) || aws_cdk_lib_PolicyViolationBeta1(o);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_IntrinsicProps(p) {
      if (p != null) {
        visitedObjects.add(p);
        try {
          visitedObjects.has(p.typeHint) || (p.typeHint, void 0);
        } finally {
          visitedObjects.delete(p);
        }
      }
    }
    function aws_cdk_lib_Intrinsic(p) {
    }
    function aws_cdk_lib_UniqueResourceNameOptions(p) {
    }
    function aws_cdk_lib_Names(p) {
    }
    function aws_cdk_lib_TimeZone(p) {
    }
    function print(name, deprecationMessage) {
      const deprecated = process.env.JSII_DEPRECATED, deprecationMode = ["warn", "fail", "quiet"].includes(deprecated) ? deprecated : "warn", message = `${name} is deprecated.
  ${deprecationMessage.trim()}
  This API will be removed in the next major release.`;
      switch (deprecationMode) {
        case "fail":
          throw new DeprecationError(message);
        case "warn":
          console.warn("[WARNING]", message);
          break;
      }
    }
    function getPropertyDescriptor(obj, prop) {
      const descriptor = Object.getOwnPropertyDescriptor(obj, prop);
      if (descriptor)
        return descriptor;
      const proto = Object.getPrototypeOf(obj), prototypeDescriptor = proto && getPropertyDescriptor(proto, prop);
      return prototypeDescriptor || {};
    }
    var visitedObjects = /* @__PURE__ */ new Set();
    var DeprecationError = class extends Error {
      constructor(...args) {
        super(...args), Object.defineProperty(this, "name", { configurable: false, enumerable: true, value: "DeprecationError", writable: false });
      }
    };
    module2.exports = { print, getPropertyDescriptor, DeprecationError, aws_cdk_lib_alexa_ask_CfnSkillProps, aws_cdk_lib_alexa_ask_CfnSkill, aws_cdk_lib_alexa_ask_CfnSkill_AuthenticationConfigurationProperty, aws_cdk_lib_alexa_ask_CfnSkill_OverridesProperty, aws_cdk_lib_alexa_ask_CfnSkill_SkillPackageProperty, aws_cdk_lib_assertions_Capture, aws_cdk_lib_assertions_Template, aws_cdk_lib_assertions_TemplateParsingOptions, aws_cdk_lib_assertions_Match, aws_cdk_lib_assertions_Matcher, aws_cdk_lib_assertions_MatchFailure, aws_cdk_lib_assertions_MatchCapture, aws_cdk_lib_assertions_MatchResult, aws_cdk_lib_assertions_Annotations, aws_cdk_lib_aws_accessanalyzer_CfnAnalyzerProps, aws_cdk_lib_aws_accessanalyzer_CfnAnalyzer, aws_cdk_lib_aws_accessanalyzer_CfnAnalyzer_ArchiveRuleProperty, aws_cdk_lib_aws_accessanalyzer_CfnAnalyzer_FilterProperty, aws_cdk_lib_aws_acmpca_CfnCertificateProps, aws_cdk_lib_aws_acmpca_CfnCertificate, aws_cdk_lib_aws_acmpca_CfnCertificate_ApiPassthroughProperty, aws_cdk_lib_aws_acmpca_CfnCertificate_CustomAttributeProperty, aws_cdk_lib_aws_acmpca_CfnCertificate_CustomExtensionProperty, aws_cdk_lib_aws_acmpca_CfnCertificate_EdiPartyNameProperty, aws_cdk_lib_aws_acmpca_CfnCertificate_ExtendedKeyUsageProperty, aws_cdk_lib_aws_acmpca_CfnCertificate_ExtensionsProperty, aws_cdk_lib_aws_acmpca_CfnCertificate_GeneralNameProperty, aws_cdk_lib_aws_acmpca_CfnCertificate_KeyUsageProperty, aws_cdk_lib_aws_acmpca_CfnCertificate_OtherNameProperty, aws_cdk_lib_aws_acmpca_CfnCertificate_PolicyInformationProperty, aws_cdk_lib_aws_acmpca_CfnCertificate_PolicyQualifierInfoProperty, aws_cdk_lib_aws_acmpca_CfnCertificate_QualifierProperty, aws_cdk_lib_aws_acmpca_CfnCertificate_SubjectProperty, aws_cdk_lib_aws_acmpca_CfnCertificate_ValidityProperty, aws_cdk_lib_aws_acmpca_CfnCertificateAuthorityProps, aws_cdk_lib_aws_acmpca_CfnCertificateAuthority, aws_cdk_lib_aws_acmpca_CfnCertificateAuthority_AccessDescriptionProperty, aws_cdk_lib_aws_acmpca_CfnCertificateAuthority_AccessMethodProperty, aws_cdk_lib_aws_acmpca_CfnCertificateAuthority_CrlConfigurationProperty, aws_cdk_lib_aws_acmpca_CfnCertificateAuthority_CsrExtensionsProperty, aws_cdk_lib_aws_acmpca_CfnCertificateAuthority_CustomAttributeProperty, aws_cdk_lib_aws_acmpca_CfnCertificateAuthority_EdiPartyNameProperty, aws_cdk_lib_aws_acmpca_CfnCertificateAuthority_GeneralNameProperty, aws_cdk_lib_aws_acmpca_CfnCertificateAuthority_KeyUsageProperty, aws_cdk_lib_aws_acmpca_CfnCertificateAuthority_OcspConfigurationProperty, aws_cdk_lib_aws_acmpca_CfnCertificateAuthority_OtherNameProperty, aws_cdk_lib_aws_acmpca_CfnCertificateAuthority_RevocationConfigurationProperty, aws_cdk_lib_aws_acmpca_CfnCertificateAuthority_SubjectProperty, aws_cdk_lib_aws_acmpca_CfnCertificateAuthorityActivationProps, aws_cdk_lib_aws_acmpca_CfnCertificateAuthorityActivation, aws_cdk_lib_aws_acmpca_CfnPermissionProps, aws_cdk_lib_aws_acmpca_CfnPermission, aws_cdk_lib_aws_acmpca_ICertificateAuthority, aws_cdk_lib_aws_acmpca_CertificateAuthority, aws_cdk_lib_aws_amazonmq_CfnBrokerProps, aws_cdk_lib_aws_amazonmq_CfnBroker, aws_cdk_lib_aws_amazonmq_CfnBroker_ConfigurationIdProperty, aws_cdk_lib_aws_amazonmq_CfnBroker_EncryptionOptionsProperty, aws_cdk_lib_aws_amazonmq_CfnBroker_LdapServerMetadataProperty, aws_cdk_lib_aws_amazonmq_CfnBroker_LogListProperty, aws_cdk_lib_aws_amazonmq_CfnBroker_MaintenanceWindowProperty, aws_cdk_lib_aws_amazonmq_CfnBroker_TagsEntryProperty, aws_cdk_lib_aws_amazonmq_CfnBroker_UserProperty, aws_cdk_lib_aws_amazonmq_CfnConfigurationProps, aws_cdk_lib_aws_amazonmq_CfnConfiguration, aws_cdk_lib_aws_amazonmq_CfnConfiguration_TagsEntryProperty, aws_cdk_lib_aws_amazonmq_CfnConfigurationAssociationProps, aws_cdk_lib_aws_amazonmq_CfnConfigurationAssociation, aws_cdk_lib_aws_amazonmq_CfnConfigurationAssociation_ConfigurationIdProperty, aws_cdk_lib_aws_amplify_CfnAppProps, aws_cdk_lib_aws_amplify_CfnApp, aws_cdk_lib_aws_amplify_CfnApp_AutoBranchCreationConfigProperty, aws_cdk_lib_aws_amplify_CfnApp_BasicAuthConfigProperty, aws_cdk_lib_aws_amplify_CfnApp_CustomRuleProperty, aws_cdk_lib_aws_amplify_CfnApp_EnvironmentVariableProperty, aws_cdk_lib_aws_amplify_CfnBranchProps, aws_cdk_lib_aws_amplify_CfnBranch, aws_cdk_lib_aws_amplify_CfnBranch_BasicAuthConfigProperty, aws_cdk_lib_aws_amplify_CfnBranch_EnvironmentVariableProperty, aws_cdk_lib_aws_amplify_CfnDomainProps, aws_cdk_lib_aws_amplify_CfnDomain, aws_cdk_lib_aws_amplify_CfnDomain_SubDomainSettingProperty, aws_cdk_lib_aws_amplifyuibuilder_CfnComponentProps, aws_cdk_lib_aws_amplifyuibuilder_CfnComponent, aws_cdk_lib_aws_amplifyuibuilder_CfnComponent_ActionParametersProperty, aws_cdk_lib_aws_amplifyuibuilder_CfnComponent_ComponentBindingPropertiesValueProperty, aws_cdk_lib_aws_amplifyuibuilder_CfnComponent_ComponentBindingPropertiesValuePropertiesProperty, aws_cdk_lib_aws_amplifyuibuilder_CfnComponent_ComponentChildProperty, aws_cdk_lib_aws_amplifyuibuilder_CfnComponent_ComponentConditionPropertyProperty, aws_cdk_lib_aws_amplifyuibuilder_CfnComponent_ComponentDataConfigurationProperty, aws_cdk_lib_aws_amplifyuibuilder_CfnComponent_ComponentEventProperty, aws_cdk_lib_aws_amplifyuibuilder_CfnComponent_ComponentPropertyProperty, aws_cdk_lib_aws_amplifyuibuilder_CfnComponent_ComponentPropertyBindingPropertiesProperty, aws_cdk_lib_aws_amplifyuibuilder_CfnComponent_ComponentVariantProperty, aws_cdk_lib_aws_amplifyuibuilder_CfnComponent_FormBindingElementProperty, aws_cdk_lib_aws_amplifyuibuilder_CfnComponent_MutationActionSetStateParameterProperty, aws_cdk_lib_aws_amplifyuibuilder_CfnComponent_PredicateProperty, aws_cdk_lib_aws_amplifyuibuilder_CfnComponent_SortPropertyProperty, aws_cdk_lib_aws_amplifyuibuilder_CfnFormProps, aws_cdk_lib_aws_amplifyuibuilder_CfnForm, aws_cdk_lib_aws_amplifyuibuilder_CfnForm_FieldConfigProperty, aws_cdk_lib_aws_amplifyuibuilder_CfnForm_FieldInputConfigProperty, aws_cdk_lib_aws_amplifyuibuilder_CfnForm_FieldPositionProperty, aws_cdk_lib_aws_amplifyuibuilder_CfnForm_FieldValidationConfigurationProperty, aws_cdk_lib_aws_amplifyuibuilder_CfnForm_FileUploaderFieldConfigProperty, aws_cdk_lib_aws_amplifyuibuilder_CfnForm_FormButtonProperty, aws_cdk_lib_aws_amplifyuibuilder_CfnForm_FormCTAProperty, aws_cdk_lib_aws_amplifyuibuilder_CfnForm_FormDataTypeConfigProperty, aws_cdk_lib_aws_amplifyuibuilder_CfnForm_FormInputValuePropertyProperty, aws_cdk_lib_aws_amplifyuibuilder_CfnForm_FormStyleProperty, aws_cdk_lib_aws_amplifyuibuilder_CfnForm_FormStyleConfigProperty, aws_cdk_lib_aws_amplifyuibuilder_CfnForm_SectionalElementProperty, aws_cdk_lib_aws_amplifyuibuilder_CfnForm_ValueMappingProperty, aws_cdk_lib_aws_amplifyuibuilder_CfnForm_ValueMappingsProperty, aws_cdk_lib_aws_amplifyuibuilder_CfnThemeProps, aws_cdk_lib_aws_amplifyuibuilder_CfnTheme, aws_cdk_lib_aws_amplifyuibuilder_CfnTheme_ThemeValueProperty, aws_cdk_lib_aws_amplifyuibuilder_CfnTheme_ThemeValuesProperty, aws_cdk_lib_aws_apigateway_IRestApi, aws_cdk_lib_aws_apigateway_RestApiBaseProps, aws_cdk_lib_aws_apigateway_RestApiProps, aws_cdk_lib_aws_apigateway_SpecRestApiProps, aws_cdk_lib_aws_apigateway_RestApiBase, aws_cdk_lib_aws_apigateway_SpecRestApi, aws_cdk_lib_aws_apigateway_RestApiAttributes, aws_cdk_lib_aws_apigateway_RestApi, aws_cdk_lib_aws_apigateway_EndpointConfiguration, aws_cdk_lib_aws_apigateway_ApiKeySourceType, aws_cdk_lib_aws_apigateway_EndpointType, aws_cdk_lib_aws_apigateway_IResource, aws_cdk_lib_aws_apigateway_ResourceOptions, aws_cdk_lib_aws_apigateway_ResourceProps, aws_cdk_lib_aws_apigateway_ResourceBase, aws_cdk_lib_aws_apigateway_ResourceAttributes, aws_cdk_lib_aws_apigateway_Resource, aws_cdk_lib_aws_apigateway_ProxyResourceOptions, aws_cdk_lib_aws_apigateway_ProxyResourceProps, aws_cdk_lib_aws_apigateway_ProxyResource, aws_cdk_lib_aws_apigateway_MethodOptions, aws_cdk_lib_aws_apigateway_MethodProps, aws_cdk_lib_aws_apigateway_Method, aws_cdk_lib_aws_apigateway_AuthorizationType, aws_cdk_lib_aws_apigateway_IntegrationOptions, aws_cdk_lib_aws_apigateway_IntegrationProps, aws_cdk_lib_aws_apigateway_IntegrationConfig, aws_cdk_lib_aws_apigateway_Integration, aws_cdk_lib_aws_apigateway_ContentHandling, aws_cdk_lib_aws_apigateway_IntegrationType, aws_cdk_lib_aws_apigateway_PassthroughBehavior, aws_cdk_lib_aws_apigateway_ConnectionType, aws_cdk_lib_aws_apigateway_IntegrationResponse, aws_cdk_lib_aws_apigateway_DeploymentProps, aws_cdk_lib_aws_apigateway_Deployment, aws_cdk_lib_aws_apigateway_IStage, aws_cdk_lib_aws_apigateway_StageOptions, aws_cdk_lib_aws_apigateway_StageProps, aws_cdk_lib_aws_apigateway_MethodLoggingLevel, aws_cdk_lib_aws_apigateway_MethodDeploymentOptions, aws_cdk_lib_aws_apigateway_StageAttributes, aws_cdk_lib_aws_apigateway_StageBase, aws_cdk_lib_aws_apigateway_Stage, aws_cdk_lib_aws_apigateway_AwsIntegrationProps, aws_cdk_lib_aws_apigateway_AwsIntegration, aws_cdk_lib_aws_apigateway_LambdaIntegrationOptions, aws_cdk_lib_aws_apigateway_LambdaIntegration, aws_cdk_lib_aws_apigateway_HttpIntegrationProps, aws_cdk_lib_aws_apigateway_HttpIntegration, aws_cdk_lib_aws_apigateway_MockIntegration, aws_cdk_lib_aws_apigateway_StepFunctionsExecutionIntegrationOptions, aws_cdk_lib_aws_apigateway_StepFunctionsIntegration, aws_cdk_lib_aws_apigateway_RequestContext, aws_cdk_lib_aws_apigateway_LambdaRestApiProps, aws_cdk_lib_aws_apigateway_LambdaRestApi, aws_cdk_lib_aws_apigateway_IApiKey, aws_cdk_lib_aws_apigateway_ApiKeyOptions, aws_cdk_lib_aws_apigateway_ApiKeyProps, aws_cdk_lib_aws_apigateway_ApiKey, aws_cdk_lib_aws_apigateway_RateLimitedApiKeyProps, aws_cdk_lib_aws_apigateway_RateLimitedApiKey, aws_cdk_lib_aws_apigateway_ThrottleSettings, aws_cdk_lib_aws_apigateway_Period, aws_cdk_lib_aws_apigateway_QuotaSettings, aws_cdk_lib_aws_apigateway_ThrottlingPerMethod, aws_cdk_lib_aws_apigateway_UsagePlanPerApiStage, aws_cdk_lib_aws_apigateway_UsagePlanProps, aws_cdk_lib_aws_apigateway_AddApiKeyOptions, aws_cdk_lib_aws_apigateway_IUsagePlan, aws_cdk_lib_aws_apigateway_UsagePlan, aws_cdk_lib_aws_apigateway_IVpcLink, aws_cdk_lib_aws_apigateway_VpcLinkProps, aws_cdk_lib_aws_apigateway_VpcLink, aws_cdk_lib_aws_apigateway_MethodResponse, aws_cdk_lib_aws_apigateway_IModel, aws_cdk_lib_aws_apigateway_ModelOptions, aws_cdk_lib_aws_apigateway_ModelProps, aws_cdk_lib_aws_apigateway_Model, aws_cdk_lib_aws_apigateway_IRequestValidator, aws_cdk_lib_aws_apigateway_RequestValidatorOptions, aws_cdk_lib_aws_apigateway_RequestValidatorProps, aws_cdk_lib_aws_apigateway_RequestValidator, aws_cdk_lib_aws_apigateway_Authorizer, aws_cdk_lib_aws_apigateway_IAuthorizer, aws_cdk_lib_aws_apigateway_JsonSchemaVersion, aws_cdk_lib_aws_apigateway_JsonSchemaType, aws_cdk_lib_aws_apigateway_JsonSchema, aws_cdk_lib_aws_apigateway_ApiMappingOptions, aws_cdk_lib_aws_apigateway_SecurityPolicy, aws_cdk_lib_aws_apigateway_DomainNameOptions, aws_cdk_lib_aws_apigateway_DomainNameProps, aws_cdk_lib_aws_apigateway_IDomainName, aws_cdk_lib_aws_apigateway_DomainName, aws_cdk_lib_aws_apigateway_DomainNameAttributes, aws_cdk_lib_aws_apigateway_MTLSConfig, aws_cdk_lib_aws_apigateway_BasePathMappingOptions, aws_cdk_lib_aws_apigateway_BasePathMappingProps, aws_cdk_lib_aws_apigateway_BasePathMapping, aws_cdk_lib_aws_apigateway_CorsOptions, aws_cdk_lib_aws_apigateway_Cors, aws_cdk_lib_aws_apigateway_LambdaAuthorizerProps, aws_cdk_lib_aws_apigateway_TokenAuthorizerProps, aws_cdk_lib_aws_apigateway_TokenAuthorizer, aws_cdk_lib_aws_apigateway_RequestAuthorizerProps, aws_cdk_lib_aws_apigateway_RequestAuthorizer, aws_cdk_lib_aws_apigateway_IdentitySource, aws_cdk_lib_aws_apigateway_CognitoUserPoolsAuthorizerProps, aws_cdk_lib_aws_apigateway_CognitoUserPoolsAuthorizer, aws_cdk_lib_aws_apigateway_IAccessLogDestination, aws_cdk_lib_aws_apigateway_AccessLogDestinationConfig, aws_cdk_lib_aws_apigateway_LogGroupLogDestination, aws_cdk_lib_aws_apigateway_AccessLogField, aws_cdk_lib_aws_apigateway_JsonWithStandardFieldProps, aws_cdk_lib_aws_apigateway_AccessLogFormat, aws_cdk_lib_aws_apigateway_ApiDefinition, aws_cdk_lib_aws_apigateway_ApiDefinitionS3Location, aws_cdk_lib_aws_apigateway_ApiDefinitionConfig, aws_cdk_lib_aws_apigateway_S3ApiDefinition, aws_cdk_lib_aws_apigateway_InlineApiDefinition, aws_cdk_lib_aws_apigateway_AssetApiDefinition, aws_cdk_lib_aws_apigateway_IGatewayResponse, aws_cdk_lib_aws_apigateway_GatewayResponseProps, aws_cdk_lib_aws_apigateway_GatewayResponseOptions, aws_cdk_lib_aws_apigateway_GatewayResponse, aws_cdk_lib_aws_apigateway_ResponseType, aws_cdk_lib_aws_apigateway_StepFunctionsRestApiProps, aws_cdk_lib_aws_apigateway_StepFunctionsRestApi, aws_cdk_lib_aws_apigateway_CfnAccountProps, aws_cdk_lib_aws_apigateway_CfnAccount, aws_cdk_lib_aws_apigateway_CfnApiKeyProps, aws_cdk_lib_aws_apigateway_CfnApiKey, aws_cdk_lib_aws_apigateway_CfnApiKey_StageKeyProperty, aws_cdk_lib_aws_apigateway_CfnAuthorizerProps, aws_cdk_lib_aws_apigateway_CfnAuthorizer, aws_cdk_lib_aws_apigateway_CfnBasePathMappingProps, aws_cdk_lib_aws_apigateway_CfnBasePathMapping, aws_cdk_lib_aws_apigateway_CfnClientCertificateProps, aws_cdk_lib_aws_apigateway_CfnClientCertificate, aws_cdk_lib_aws_apigateway_CfnDeploymentProps, aws_cdk_lib_aws_apigateway_CfnDeployment, aws_cdk_lib_aws_apigateway_CfnDeployment_AccessLogSettingProperty, aws_cdk_lib_aws_apigateway_CfnDeployment_CanarySettingProperty, aws_cdk_lib_aws_apigateway_CfnDeployment_DeploymentCanarySettingsProperty, aws_cdk_lib_aws_apigateway_CfnDeployment_MethodSettingProperty, aws_cdk_lib_aws_apigateway_CfnDeployment_StageDescriptionProperty, aws_cdk_lib_aws_apigateway_CfnDocumentationPartProps, aws_cdk_lib_aws_apigateway_CfnDocumentationPart, aws_cdk_lib_aws_apigateway_CfnDocumentationPart_LocationProperty, aws_cdk_lib_aws_apigateway_CfnDocumentationVersionProps, aws_cdk_lib_aws_apigateway_CfnDocumentationVersion, aws_cdk_lib_aws_apigateway_CfnDomainNameProps, aws_cdk_lib_aws_apigateway_CfnDomainName, aws_cdk_lib_aws_apigateway_CfnDomainName_EndpointConfigurationProperty, aws_cdk_lib_aws_apigateway_CfnDomainName_MutualTlsAuthenticationProperty, aws_cdk_lib_aws_apigateway_CfnGatewayResponseProps, aws_cdk_lib_aws_apigateway_CfnGatewayResponse, aws_cdk_lib_aws_apigateway_CfnMethodProps, aws_cdk_lib_aws_apigateway_CfnMethod, aws_cdk_lib_aws_apigateway_CfnMethod_IntegrationProperty, aws_cdk_lib_aws_apigateway_CfnMethod_IntegrationResponseProperty, aws_cdk_lib_aws_apigateway_CfnMethod_MethodResponseProperty, aws_cdk_lib_aws_apigateway_CfnModelProps, aws_cdk_lib_aws_apigateway_CfnModel, aws_cdk_lib_aws_apigateway_CfnRequestValidatorProps, aws_cdk_lib_aws_apigateway_CfnRequestValidator, aws_cdk_lib_aws_apigateway_CfnResourceProps, aws_cdk_lib_aws_apigateway_CfnResource, aws_cdk_lib_aws_apigateway_CfnRestApiProps, aws_cdk_lib_aws_apigateway_CfnRestApi, aws_cdk_lib_aws_apigateway_CfnRestApi_EndpointConfigurationProperty, aws_cdk_lib_aws_apigateway_CfnRestApi_S3LocationProperty, aws_cdk_lib_aws_apigateway_CfnStageProps, aws_cdk_lib_aws_apigateway_CfnStage, aws_cdk_lib_aws_apigateway_CfnStage_AccessLogSettingProperty, aws_cdk_lib_aws_apigateway_CfnStage_CanarySettingProperty, aws_cdk_lib_aws_apigateway_CfnStage_MethodSettingProperty, aws_cdk_lib_aws_apigateway_CfnUsagePlanProps, aws_cdk_lib_aws_apigateway_CfnUsagePlan, aws_cdk_lib_aws_apigateway_CfnUsagePlan_ApiStageProperty, aws_cdk_lib_aws_apigateway_CfnUsagePlan_QuotaSettingsProperty, aws_cdk_lib_aws_apigateway_CfnUsagePlan_ThrottleSettingsProperty, aws_cdk_lib_aws_apigateway_CfnUsagePlanKeyProps, aws_cdk_lib_aws_apigateway_CfnUsagePlanKey, aws_cdk_lib_aws_apigateway_CfnVpcLinkProps, aws_cdk_lib_aws_apigateway_CfnVpcLink, aws_cdk_lib_aws_apigatewayv2_CfnApiProps, aws_cdk_lib_aws_apigatewayv2_CfnApi, aws_cdk_lib_aws_apigatewayv2_CfnApi_BodyS3LocationProperty, aws_cdk_lib_aws_apigatewayv2_CfnApi_CorsProperty, aws_cdk_lib_aws_apigatewayv2_CfnApiGatewayManagedOverridesProps, aws_cdk_lib_aws_apigatewayv2_CfnApiGatewayManagedOverrides, aws_cdk_lib_aws_apigatewayv2_CfnApiGatewayManagedOverrides_AccessLogSettingsProperty, aws_cdk_lib_aws_apigatewayv2_CfnApiGatewayManagedOverrides_IntegrationOverridesProperty, aws_cdk_lib_aws_apigatewayv2_CfnApiGatewayManagedOverrides_RouteOverridesProperty, aws_cdk_lib_aws_apigatewayv2_CfnApiGatewayManagedOverrides_RouteSettingsProperty, aws_cdk_lib_aws_apigatewayv2_CfnApiGatewayManagedOverrides_StageOverridesProperty, aws_cdk_lib_aws_apigatewayv2_CfnApiMappingProps, aws_cdk_lib_aws_apigatewayv2_CfnApiMapping, aws_cdk_lib_aws_apigatewayv2_CfnAuthorizerProps, aws_cdk_lib_aws_apigatewayv2_CfnAuthorizer, aws_cdk_lib_aws_apigatewayv2_CfnAuthorizer_JWTConfigurationProperty, aws_cdk_lib_aws_apigatewayv2_CfnDeploymentProps, aws_cdk_lib_aws_apigatewayv2_CfnDeployment, aws_cdk_lib_aws_apigatewayv2_CfnDomainNameProps, aws_cdk_lib_aws_apigatewayv2_CfnDomainName, aws_cdk_lib_aws_apigatewayv2_CfnDomainName_DomainNameConfigurationProperty, aws_cdk_lib_aws_apigatewayv2_CfnDomainName_MutualTlsAuthenticationProperty, aws_cdk_lib_aws_apigatewayv2_CfnIntegrationProps, aws_cdk_lib_aws_apigatewayv2_CfnIntegration, aws_cdk_lib_aws_apigatewayv2_CfnIntegration_ResponseParameterProperty, aws_cdk_lib_aws_apigatewayv2_CfnIntegration_ResponseParameterListProperty, aws_cdk_lib_aws_apigatewayv2_CfnIntegration_TlsConfigProperty, aws_cdk_lib_aws_apigatewayv2_CfnIntegrationResponseProps, aws_cdk_lib_aws_apigatewayv2_CfnIntegrationResponse, aws_cdk_lib_aws_apigatewayv2_CfnModelProps, aws_cdk_lib_aws_apigatewayv2_CfnModel, aws_cdk_lib_aws_apigatewayv2_CfnRouteProps, aws_cdk_lib_aws_apigatewayv2_CfnRoute, aws_cdk_lib_aws_apigatewayv2_CfnRoute_ParameterConstraintsProperty, aws_cdk_lib_aws_apigatewayv2_CfnRouteResponseProps, aws_cdk_lib_aws_apigatewayv2_CfnRouteResponse, aws_cdk_lib_aws_apigatewayv2_CfnRouteResponse_ParameterConstraintsProperty, aws_cdk_lib_aws_apigatewayv2_CfnStageProps, aws_cdk_lib_aws_apigatewayv2_CfnStage, aws_cdk_lib_aws_apigatewayv2_CfnStage_AccessLogSettingsProperty, aws_cdk_lib_aws_apigatewayv2_CfnStage_RouteSettingsProperty, aws_cdk_lib_aws_apigatewayv2_CfnVpcLinkProps, aws_cdk_lib_aws_apigatewayv2_CfnVpcLink, aws_cdk_lib_aws_appconfig_CfnApplicationProps, aws_cdk_lib_aws_appconfig_CfnApplication, aws_cdk_lib_aws_appconfig_CfnApplication_TagsProperty, aws_cdk_lib_aws_appconfig_CfnConfigurationProfileProps, aws_cdk_lib_aws_appconfig_CfnConfigurationProfile, aws_cdk_lib_aws_appconfig_CfnConfigurationProfile_TagsProperty, aws_cdk_lib_aws_appconfig_CfnConfigurationProfile_ValidatorsProperty, aws_cdk_lib_aws_appconfig_CfnDeploymentProps, aws_cdk_lib_aws_appconfig_CfnDeployment, aws_cdk_lib_aws_appconfig_CfnDeployment_TagsProperty, aws_cdk_lib_aws_appconfig_CfnDeploymentStrategyProps, aws_cdk_lib_aws_appconfig_CfnDeploymentStrategy, aws_cdk_lib_aws_appconfig_CfnDeploymentStrategy_TagsProperty, aws_cdk_lib_aws_appconfig_CfnEnvironmentProps, aws_cdk_lib_aws_appconfig_CfnEnvironment, aws_cdk_lib_aws_appconfig_CfnEnvironment_MonitorsProperty, aws_cdk_lib_aws_appconfig_CfnEnvironment_TagsProperty, aws_cdk_lib_aws_appconfig_CfnExtensionProps, aws_cdk_lib_aws_appconfig_CfnExtension, aws_cdk_lib_aws_appconfig_CfnExtension_ParameterProperty, aws_cdk_lib_aws_appconfig_CfnExtensionAssociationProps, aws_cdk_lib_aws_appconfig_CfnExtensionAssociation, aws_cdk_lib_aws_appconfig_CfnHostedConfigurationVersionProps, aws_cdk_lib_aws_appconfig_CfnHostedConfigurationVersion, aws_cdk_lib_aws_appflow_CfnConnectorProps, aws_cdk_lib_aws_appflow_CfnConnector, aws_cdk_lib_aws_appflow_CfnConnector_ConnectorProvisioningConfigProperty, aws_cdk_lib_aws_appflow_CfnConnector_LambdaConnectorProvisioningConfigProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfileProps, aws_cdk_lib_aws_appflow_CfnConnectorProfile, aws_cdk_lib_aws_appflow_CfnConnectorProfile_AmplitudeConnectorProfileCredentialsProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_ApiKeyCredentialsProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_BasicAuthCredentialsProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_ConnectorOAuthRequestProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_ConnectorProfileConfigProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_ConnectorProfileCredentialsProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_ConnectorProfilePropertiesProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_CustomAuthCredentialsProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_CustomConnectorProfileCredentialsProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_CustomConnectorProfilePropertiesProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_DatadogConnectorProfileCredentialsProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_DatadogConnectorProfilePropertiesProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_DynatraceConnectorProfileCredentialsProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_DynatraceConnectorProfilePropertiesProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_GoogleAnalyticsConnectorProfileCredentialsProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_InforNexusConnectorProfileCredentialsProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_InforNexusConnectorProfilePropertiesProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_MarketoConnectorProfileCredentialsProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_MarketoConnectorProfilePropertiesProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_OAuth2CredentialsProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_OAuth2PropertiesProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_OAuthCredentialsProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_OAuthPropertiesProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_PardotConnectorProfileCredentialsProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_PardotConnectorProfilePropertiesProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_RedshiftConnectorProfileCredentialsProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_RedshiftConnectorProfilePropertiesProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_SAPODataConnectorProfileCredentialsProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_SAPODataConnectorProfilePropertiesProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_SalesforceConnectorProfileCredentialsProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_SalesforceConnectorProfilePropertiesProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_ServiceNowConnectorProfileCredentialsProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_ServiceNowConnectorProfilePropertiesProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_SingularConnectorProfileCredentialsProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_SlackConnectorProfileCredentialsProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_SlackConnectorProfilePropertiesProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_SnowflakeConnectorProfileCredentialsProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_SnowflakeConnectorProfilePropertiesProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_TrendmicroConnectorProfileCredentialsProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_VeevaConnectorProfileCredentialsProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_VeevaConnectorProfilePropertiesProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_ZendeskConnectorProfileCredentialsProperty, aws_cdk_lib_aws_appflow_CfnConnectorProfile_ZendeskConnectorProfilePropertiesProperty, aws_cdk_lib_aws_appflow_CfnFlowProps, aws_cdk_lib_aws_appflow_CfnFlow, aws_cdk_lib_aws_appflow_CfnFlow_AggregationConfigProperty, aws_cdk_lib_aws_appflow_CfnFlow_AmplitudeSourcePropertiesProperty, aws_cdk_lib_aws_appflow_CfnFlow_ConnectorOperatorProperty, aws_cdk_lib_aws_appflow_CfnFlow_CustomConnectorDestinationPropertiesProperty, aws_cdk_lib_aws_appflow_CfnFlow_CustomConnectorSourcePropertiesProperty, aws_cdk_lib_aws_appflow_CfnFlow_DatadogSourcePropertiesProperty, aws_cdk_lib_aws_appflow_CfnFlow_DestinationConnectorPropertiesProperty, aws_cdk_lib_aws_appflow_CfnFlow_DestinationFlowConfigProperty, aws_cdk_lib_aws_appflow_CfnFlow_DynatraceSourcePropertiesProperty, aws_cdk_lib_aws_appflow_CfnFlow_ErrorHandlingConfigProperty, aws_cdk_lib_aws_appflow_CfnFlow_EventBridgeDestinationPropertiesProperty, aws_cdk_lib_aws_appflow_CfnFlow_GlueDataCatalogProperty, aws_cdk_lib_aws_appflow_CfnFlow_GoogleAnalyticsSourcePropertiesProperty, aws_cdk_lib_aws_appflow_CfnFlow_IncrementalPullConfigProperty, aws_cdk_lib_aws_appflow_CfnFlow_InforNexusSourcePropertiesProperty, aws_cdk_lib_aws_appflow_CfnFlow_LookoutMetricsDestinationPropertiesProperty, aws_cdk_lib_aws_appflow_CfnFlow_MarketoDestinationPropertiesProperty, aws_cdk_lib_aws_appflow_CfnFlow_MarketoSourcePropertiesProperty, aws_cdk_lib_aws_appflow_CfnFlow_MetadataCatalogConfigProperty, aws_cdk_lib_aws_appflow_CfnFlow_PardotSourcePropertiesProperty, aws_cdk_lib_aws_appflow_CfnFlow_PrefixConfigProperty, aws_cdk_lib_aws_appflow_CfnFlow_RedshiftDestinationPropertiesProperty, aws_cdk_lib_aws_appflow_CfnFlow_S3DestinationPropertiesProperty, aws_cdk_lib_aws_appflow_CfnFlow_S3InputFormatConfigProperty, aws_cdk_lib_aws_appflow_CfnFlow_S3OutputFormatConfigProperty, aws_cdk_lib_aws_appflow_CfnFlow_S3SourcePropertiesProperty, aws_cdk_lib_aws_appflow_CfnFlow_SAPODataDestinationPropertiesProperty, aws_cdk_lib_aws_appflow_CfnFlow_SAPODataSourcePropertiesProperty, aws_cdk_lib_aws_appflow_CfnFlow_SalesforceDestinationPropertiesProperty, aws_cdk_lib_aws_appflow_CfnFlow_SalesforceSourcePropertiesProperty, aws_cdk_lib_aws_appflow_CfnFlow_ScheduledTriggerPropertiesProperty, aws_cdk_lib_aws_appflow_CfnFlow_ServiceNowSourcePropertiesProperty, aws_cdk_lib_aws_appflow_CfnFlow_SingularSourcePropertiesProperty, aws_cdk_lib_aws_appflow_CfnFlow_SlackSourcePropertiesProperty, aws_cdk_lib_aws_appflow_CfnFlow_SnowflakeDestinationPropertiesProperty, aws_cdk_lib_aws_appflow_CfnFlow_SourceConnectorPropertiesProperty, aws_cdk_lib_aws_appflow_CfnFlow_SourceFlowConfigProperty, aws_cdk_lib_aws_appflow_CfnFlow_SuccessResponseHandlingConfigProperty, aws_cdk_lib_aws_appflow_CfnFlow_TaskProperty, aws_cdk_lib_aws_appflow_CfnFlow_TaskPropertiesObjectProperty, aws_cdk_lib_aws_appflow_CfnFlow_TrendmicroSourcePropertiesProperty, aws_cdk_lib_aws_appflow_CfnFlow_TriggerConfigProperty, aws_cdk_lib_aws_appflow_CfnFlow_UpsolverDestinationPropertiesProperty, aws_cdk_lib_aws_appflow_CfnFlow_UpsolverS3OutputFormatConfigProperty, aws_cdk_lib_aws_appflow_CfnFlow_VeevaSourcePropertiesProperty, aws_cdk_lib_aws_appflow_CfnFlow_ZendeskDestinationPropertiesProperty, aws_cdk_lib_aws_appflow_CfnFlow_ZendeskSourcePropertiesProperty, aws_cdk_lib_aws_appintegrations_CfnDataIntegrationProps, aws_cdk_lib_aws_appintegrations_CfnDataIntegration, aws_cdk_lib_aws_appintegrations_CfnDataIntegration_FileConfigurationProperty, aws_cdk_lib_aws_appintegrations_CfnDataIntegration_ScheduleConfigProperty, aws_cdk_lib_aws_appintegrations_CfnEventIntegrationProps, aws_cdk_lib_aws_appintegrations_CfnEventIntegration, aws_cdk_lib_aws_appintegrations_CfnEventIntegration_EventFilterProperty, aws_cdk_lib_aws_applicationautoscaling_CfnScalableTargetProps, aws_cdk_lib_aws_applicationautoscaling_CfnScalableTarget, aws_cdk_lib_aws_applicationautoscaling_CfnScalableTarget_ScalableTargetActionProperty, aws_cdk_lib_aws_applicationautoscaling_CfnScalableTarget_ScheduledActionProperty, aws_cdk_lib_aws_applicationautoscaling_CfnScalableTarget_SuspendedStateProperty, aws_cdk_lib_aws_applicationautoscaling_CfnScalingPolicyProps, aws_cdk_lib_aws_applicationautoscaling_CfnScalingPolicy, aws_cdk_lib_aws_applicationautoscaling_CfnScalingPolicy_CustomizedMetricSpecificationProperty, aws_cdk_lib_aws_applicationautoscaling_CfnScalingPolicy_MetricDimensionProperty, aws_cdk_lib_aws_applicationautoscaling_CfnScalingPolicy_PredefinedMetricSpecificationProperty, aws_cdk_lib_aws_applicationautoscaling_CfnScalingPolicy_StepAdjustmentProperty, aws_cdk_lib_aws_applicationautoscaling_CfnScalingPolicy_StepScalingPolicyConfigurationProperty, aws_cdk_lib_aws_applicationautoscaling_CfnScalingPolicy_TargetTrackingScalingPolicyConfigurationProperty, aws_cdk_lib_aws_applicationautoscaling_BaseScalableAttributeProps, aws_cdk_lib_aws_applicationautoscaling_BaseScalableAttribute, aws_cdk_lib_aws_applicationautoscaling_EnableScalingProps, aws_cdk_lib_aws_applicationautoscaling_Schedule, aws_cdk_lib_aws_applicationautoscaling_CronOptions, aws_cdk_lib_aws_applicationautoscaling_IScalableTarget, aws_cdk_lib_aws_applicationautoscaling_ScalableTargetProps, aws_cdk_lib_aws_applicationautoscaling_ScalableTarget, aws_cdk_lib_aws_applicationautoscaling_ScalingSchedule, aws_cdk_lib_aws_applicationautoscaling_ServiceNamespace, aws_cdk_lib_aws_applicationautoscaling_BasicStepScalingPolicyProps, aws_cdk_lib_aws_applicationautoscaling_StepScalingPolicyProps, aws_cdk_lib_aws_applicationautoscaling_StepScalingPolicy, aws_cdk_lib_aws_applicationautoscaling_ScalingInterval, aws_cdk_lib_aws_applicationautoscaling_StepScalingActionProps, aws_cdk_lib_aws_applicationautoscaling_StepScalingAction, aws_cdk_lib_aws_applicationautoscaling_AdjustmentType, aws_cdk_lib_aws_applicationautoscaling_MetricAggregationType, aws_cdk_lib_aws_applicationautoscaling_AdjustmentTier, aws_cdk_lib_aws_applicationautoscaling_BaseTargetTrackingProps, aws_cdk_lib_aws_applicationautoscaling_BasicTargetTrackingScalingPolicyProps, aws_cdk_lib_aws_applicationautoscaling_TargetTrackingScalingPolicyProps, aws_cdk_lib_aws_applicationautoscaling_TargetTrackingScalingPolicy, aws_cdk_lib_aws_applicationautoscaling_PredefinedMetric, aws_cdk_lib_aws_applicationinsights_CfnApplicationProps, aws_cdk_lib_aws_applicationinsights_CfnApplication, aws_cdk_lib_aws_applicationinsights_CfnApplication_AlarmProperty, aws_cdk_lib_aws_applicationinsights_CfnApplication_AlarmMetricProperty, aws_cdk_lib_aws_applicationinsights_CfnApplication_ComponentConfigurationProperty, aws_cdk_lib_aws_applicationinsights_CfnApplication_ComponentMonitoringSettingProperty, aws_cdk_lib_aws_applicationinsights_CfnApplication_ConfigurationDetailsProperty, aws_cdk_lib_aws_applicationinsights_CfnApplication_CustomComponentProperty, aws_cdk_lib_aws_applicationinsights_CfnApplication_HAClusterPrometheusExporterProperty, aws_cdk_lib_aws_applicationinsights_CfnApplication_HANAPrometheusExporterProperty, aws_cdk_lib_aws_applicationinsights_CfnApplication_JMXPrometheusExporterProperty, aws_cdk_lib_aws_applicationinsights_CfnApplication_LogProperty, aws_cdk_lib_aws_applicationinsights_CfnApplication_LogPatternProperty, aws_cdk_lib_aws_applicationinsights_CfnApplication_LogPatternSetProperty, aws_cdk_lib_aws_applicationinsights_CfnApplication_SubComponentConfigurationDetailsProperty, aws_cdk_lib_aws_applicationinsights_CfnApplication_SubComponentTypeConfigurationProperty, aws_cdk_lib_aws_applicationinsights_CfnApplication_WindowsEventProperty, aws_cdk_lib_aws_appmesh_CfnGatewayRouteProps, aws_cdk_lib_aws_appmesh_CfnGatewayRoute, aws_cdk_lib_aws_appmesh_CfnGatewayRoute_GatewayRouteHostnameMatchProperty, aws_cdk_lib_aws_appmesh_CfnGatewayRoute_GatewayRouteHostnameRewriteProperty, aws_cdk_lib_aws_appmesh_CfnGatewayRoute_GatewayRouteMetadataMatchProperty, aws_cdk_lib_aws_appmesh_CfnGatewayRoute_GatewayRouteRangeMatchProperty, aws_cdk_lib_aws_appmesh_CfnGatewayRoute_GatewayRouteSpecProperty, aws_cdk_lib_aws_appmesh_CfnGatewayRoute_GatewayRouteTargetProperty, aws_cdk_lib_aws_appmesh_CfnGatewayRoute_GatewayRouteVirtualServiceProperty, aws_cdk_lib_aws_appmesh_CfnGatewayRoute_GrpcGatewayRouteProperty, aws_cdk_lib_aws_appmesh_CfnGatewayRoute_GrpcGatewayRouteActionProperty, aws_cdk_lib_aws_appmesh_CfnGatewayRoute_GrpcGatewayRouteMatchProperty, aws_cdk_lib_aws_appmesh_CfnGatewayRoute_GrpcGatewayRouteMetadataProperty, aws_cdk_lib_aws_appmesh_CfnGatewayRoute_GrpcGatewayRouteRewriteProperty, aws_cdk_lib_aws_appmesh_CfnGatewayRoute_HttpGatewayRouteProperty, aws_cdk_lib_aws_appmesh_CfnGatewayRoute_HttpGatewayRouteActionProperty, aws_cdk_lib_aws_appmesh_CfnGatewayRoute_HttpGatewayRouteHeaderProperty, aws_cdk_lib_aws_appmesh_CfnGatewayRoute_HttpGatewayRouteHeaderMatchProperty, aws_cdk_lib_aws_appmesh_CfnGatewayRoute_HttpGatewayRouteMatchProperty, aws_cdk_lib_aws_appmesh_CfnGatewayRoute_HttpGatewayRoutePathRewriteProperty, aws_cdk_lib_aws_appmesh_CfnGatewayRoute_HttpGatewayRoutePrefixRewriteProperty, aws_cdk_lib_aws_appmesh_CfnGatewayRoute_HttpGatewayRouteRewriteProperty, aws_cdk_lib_aws_appmesh_CfnGatewayRoute_HttpPathMatchProperty, aws_cdk_lib_aws_appmesh_CfnGatewayRoute_HttpQueryParameterMatchProperty, aws_cdk_lib_aws_appmesh_CfnGatewayRoute_QueryParameterProperty, aws_cdk_lib_aws_appmesh_CfnMeshProps, aws_cdk_lib_aws_appmesh_CfnMesh, aws_cdk_lib_aws_appmesh_CfnMesh_EgressFilterProperty, aws_cdk_lib_aws_appmesh_CfnMesh_MeshServiceDiscoveryProperty, aws_cdk_lib_aws_appmesh_CfnMesh_MeshSpecProperty, aws_cdk_lib_aws_appmesh_CfnRouteProps, aws_cdk_lib_aws_appmesh_CfnRoute, aws_cdk_lib_aws_appmesh_CfnRoute_DurationProperty, aws_cdk_lib_aws_appmesh_CfnRoute_GrpcRetryPolicyProperty, aws_cdk_lib_aws_appmesh_CfnRoute_GrpcRouteProperty, aws_cdk_lib_aws_appmesh_CfnRoute_GrpcRouteActionProperty, aws_cdk_lib_aws_appmesh_CfnRoute_GrpcRouteMatchProperty, aws_cdk_lib_aws_appmesh_CfnRoute_GrpcRouteMetadataProperty, aws_cdk_lib_aws_appmesh_CfnRoute_GrpcRouteMetadataMatchMethodProperty, aws_cdk_lib_aws_appmesh_CfnRoute_GrpcTimeoutProperty, aws_cdk_lib_aws_appmesh_CfnRoute_HeaderMatchMethodProperty, aws_cdk_lib_aws_appmesh_CfnRoute_HttpPathMatchProperty, aws_cdk_lib_aws_appmesh_CfnRoute_HttpQueryParameterMatchProperty, aws_cdk_lib_aws_appmesh_CfnRoute_HttpRetryPolicyProperty, aws_cdk_lib_aws_appmesh_CfnRoute_HttpRouteProperty, aws_cdk_lib_aws_appmesh_CfnRoute_HttpRouteActionProperty, aws_cdk_lib_aws_appmesh_CfnRoute_HttpRouteHeaderProperty, aws_cdk_lib_aws_appmesh_CfnRoute_HttpRouteMatchProperty, aws_cdk_lib_aws_appmesh_CfnRoute_HttpTimeoutProperty, aws_cdk_lib_aws_appmesh_CfnRoute_MatchRangeProperty, aws_cdk_lib_aws_appmesh_CfnRoute_QueryParameterProperty, aws_cdk_lib_aws_appmesh_CfnRoute_RouteSpecProperty, aws_cdk_lib_aws_appmesh_CfnRoute_TcpRouteProperty, aws_cdk_lib_aws_appmesh_CfnRoute_TcpRouteActionProperty, aws_cdk_lib_aws_appmesh_CfnRoute_TcpRouteMatchProperty, aws_cdk_lib_aws_appmesh_CfnRoute_TcpTimeoutProperty, aws_cdk_lib_aws_appmesh_CfnRoute_WeightedTargetProperty, aws_cdk_lib_aws_appmesh_CfnVirtualGatewayProps, aws_cdk_lib_aws_appmesh_CfnVirtualGateway, aws_cdk_lib_aws_appmesh_CfnVirtualGateway_JsonFormatRefProperty, aws_cdk_lib_aws_appmesh_CfnVirtualGateway_LoggingFormatProperty, aws_cdk_lib_aws_appmesh_CfnVirtualGateway_SubjectAlternativeNameMatchersProperty, aws_cdk_lib_aws_appmesh_CfnVirtualGateway_SubjectAlternativeNamesProperty, aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayAccessLogProperty, aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayBackendDefaultsProperty, aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayClientPolicyProperty, aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayClientPolicyTlsProperty, aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayClientTlsCertificateProperty, aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayConnectionPoolProperty, aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayFileAccessLogProperty, aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayGrpcConnectionPoolProperty, aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayHealthCheckPolicyProperty, aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayHttp2ConnectionPoolProperty, aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayHttpConnectionPoolProperty, aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayListenerProperty, aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayListenerTlsProperty, aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayListenerTlsAcmCertificateProperty, aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayListenerTlsCertificateProperty, aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayListenerTlsFileCertificateProperty, aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayListenerTlsSdsCertificateProperty, aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayListenerTlsValidationContextProperty, aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayListenerTlsValidationContextTrustProperty, aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayLoggingProperty, aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayPortMappingProperty, aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewaySpecProperty, aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayTlsValidationContextProperty, aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayTlsValidationContextAcmTrustProperty, aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayTlsValidationContextFileTrustProperty, aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayTlsValidationContextSdsTrustProperty, aws_cdk_lib_aws_appmesh_CfnVirtualGateway_VirtualGatewayTlsValidationContextTrustProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNodeProps, aws_cdk_lib_aws_appmesh_CfnVirtualNode, aws_cdk_lib_aws_appmesh_CfnVirtualNode_AccessLogProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_AwsCloudMapInstanceAttributeProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_AwsCloudMapServiceDiscoveryProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_BackendProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_BackendDefaultsProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_ClientPolicyProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_ClientPolicyTlsProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_ClientTlsCertificateProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_DnsServiceDiscoveryProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_DurationProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_FileAccessLogProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_GrpcTimeoutProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_HealthCheckProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_HttpTimeoutProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_JsonFormatRefProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_ListenerProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_ListenerTimeoutProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_ListenerTlsProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_ListenerTlsAcmCertificateProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_ListenerTlsCertificateProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_ListenerTlsFileCertificateProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_ListenerTlsSdsCertificateProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_ListenerTlsValidationContextProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_ListenerTlsValidationContextTrustProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_LoggingProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_LoggingFormatProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_OutlierDetectionProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_PortMappingProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_ServiceDiscoveryProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_SubjectAlternativeNameMatchersProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_SubjectAlternativeNamesProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_TcpTimeoutProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_TlsValidationContextProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_TlsValidationContextAcmTrustProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_TlsValidationContextFileTrustProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_TlsValidationContextSdsTrustProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_TlsValidationContextTrustProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_VirtualNodeConnectionPoolProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_VirtualNodeGrpcConnectionPoolProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_VirtualNodeHttp2ConnectionPoolProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_VirtualNodeHttpConnectionPoolProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_VirtualNodeSpecProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_VirtualNodeTcpConnectionPoolProperty, aws_cdk_lib_aws_appmesh_CfnVirtualNode_VirtualServiceBackendProperty, aws_cdk_lib_aws_appmesh_CfnVirtualRouterProps, aws_cdk_lib_aws_appmesh_CfnVirtualRouter, aws_cdk_lib_aws_appmesh_CfnVirtualRouter_PortMappingProperty, aws_cdk_lib_aws_appmesh_CfnVirtualRouter_VirtualRouterListenerProperty, aws_cdk_lib_aws_appmesh_CfnVirtualRouter_VirtualRouterSpecProperty, aws_cdk_lib_aws_appmesh_CfnVirtualServiceProps, aws_cdk_lib_aws_appmesh_CfnVirtualService, aws_cdk_lib_aws_appmesh_CfnVirtualService_VirtualNodeServiceProviderProperty, aws_cdk_lib_aws_appmesh_CfnVirtualService_VirtualRouterServiceProviderProperty, aws_cdk_lib_aws_appmesh_CfnVirtualService_VirtualServiceProviderProperty, aws_cdk_lib_aws_appmesh_CfnVirtualService_VirtualServiceSpecProperty, aws_cdk_lib_aws_appmesh_MeshFilterType, aws_cdk_lib_aws_appmesh_IMesh, aws_cdk_lib_aws_appmesh_MeshProps, aws_cdk_lib_aws_appmesh_Mesh, aws_cdk_lib_aws_appmesh_IRoute, aws_cdk_lib_aws_appmesh_RouteBaseProps, aws_cdk_lib_aws_appmesh_RouteProps, aws_cdk_lib_aws_appmesh_Route, aws_cdk_lib_aws_appmesh_RouteAttributes, aws_cdk_lib_aws_appmesh_IpPreference, aws_cdk_lib_aws_appmesh_MeshServiceDiscovery, aws_cdk_lib_aws_appmesh_ServiceDiscoveryConfig, aws_cdk_lib_aws_appmesh_DnsResponseType, aws_cdk_lib_aws_appmesh_ServiceDiscovery, aws_cdk_lib_aws_appmesh_WeightedTarget, aws_cdk_lib_aws_appmesh_HttpRouteMatch, aws_cdk_lib_aws_appmesh_HttpRouteProtocol, aws_cdk_lib_aws_appmesh_GrpcRouteMatch, aws_cdk_lib_aws_appmesh_RouteSpecOptionsBase, aws_cdk_lib_aws_appmesh_HttpRouteSpecOptions, aws_cdk_lib_aws_appmesh_HttpRetryPolicy, aws_cdk_lib_aws_appmesh_HttpRetryEvent, aws_cdk_lib_aws_appmesh_TcpRetryEvent, aws_cdk_lib_aws_appmesh_TcpRouteSpecOptions, aws_cdk_lib_aws_appmesh_GrpcRouteSpecOptions, aws_cdk_lib_aws_appmesh_GrpcRetryPolicy, aws_cdk_lib_aws_appmesh_GrpcRetryEvent, aws_cdk_lib_aws_appmesh_RouteSpecConfig, aws_cdk_lib_aws_appmesh_RouteSpec, aws_cdk_lib_aws_appmesh_HttpTimeout, aws_cdk_lib_aws_appmesh_GrpcTimeout, aws_cdk_lib_aws_appmesh_TcpTimeout, aws_cdk_lib_aws_appmesh_OutlierDetection, aws_cdk_lib_aws_appmesh_AccessLogConfig, aws_cdk_lib_aws_appmesh_AccessLog, aws_cdk_lib_aws_appmesh_LoggingFormatConfig, aws_cdk_lib_aws_appmesh_LoggingFormat, aws_cdk_lib_aws_appmesh_BackendDefaults, aws_cdk_lib_aws_appmesh_VirtualServiceBackendOptions, aws_cdk_lib_aws_appmesh_BackendConfig, aws_cdk_lib_aws_appmesh_Backend, aws_cdk_lib_aws_appmesh_HttpConnectionPool, aws_cdk_lib_aws_appmesh_TcpConnectionPool, aws_cdk_lib_aws_appmesh_GrpcConnectionPool, aws_cdk_lib_aws_appmesh_Http2ConnectionPool, aws_cdk_lib_aws_appmesh_TlsCertificateConfig, aws_cdk_lib_aws_appmesh_TlsCertificate, aws_cdk_lib_aws_appmesh_MutualTlsCertificate, aws_cdk_lib_aws_appmesh_IVirtualNode, aws_cdk_lib_aws_appmesh_VirtualNodeBaseProps, aws_cdk_lib_aws_appmesh_VirtualNodeProps, aws_cdk_lib_aws_appmesh_VirtualNode, aws_cdk_lib_aws_appmesh_VirtualNodeAttributes, aws_cdk_lib_aws_appmesh_IVirtualRouter, aws_cdk_lib_aws_appmesh_VirtualRouterBaseProps, aws_cdk_lib_aws_appmesh_VirtualRouterProps, aws_cdk_lib_aws_appmesh_VirtualRouter, aws_cdk_lib_aws_appmesh_VirtualRouterAttributes, aws_cdk_lib_aws_appmesh_VirtualRouterListenerConfig, aws_cdk_lib_aws_appmesh_VirtualRouterListener, aws_cdk_lib_aws_appmesh_IVirtualService, aws_cdk_lib_aws_appmesh_VirtualServiceProps, aws_cdk_lib_aws_appmesh_VirtualService, aws_cdk_lib_aws_appmesh_VirtualServiceAttributes, aws_cdk_lib_aws_appmesh_VirtualServiceProviderConfig, aws_cdk_lib_aws_appmesh_VirtualServiceProvider, aws_cdk_lib_aws_appmesh_VirtualNodeListenerConfig, aws_cdk_lib_aws_appmesh_HttpVirtualNodeListenerOptions, aws_cdk_lib_aws_appmesh_Http2VirtualNodeListenerOptions, aws_cdk_lib_aws_appmesh_GrpcVirtualNodeListenerOptions, aws_cdk_lib_aws_appmesh_TcpVirtualNodeListenerOptions, aws_cdk_lib_aws_appmesh_VirtualNodeListener, aws_cdk_lib_aws_appmesh_IVirtualGateway, aws_cdk_lib_aws_appmesh_VirtualGatewayBaseProps, aws_cdk_lib_aws_appmesh_VirtualGatewayProps, aws_cdk_lib_aws_appmesh_VirtualGateway, aws_cdk_lib_aws_appmesh_VirtualGatewayAttributes, aws_cdk_lib_aws_appmesh_HttpGatewayListenerOptions, aws_cdk_lib_aws_appmesh_Http2GatewayListenerOptions, aws_cdk_lib_aws_appmesh_GrpcGatewayListenerOptions, aws_cdk_lib_aws_appmesh_VirtualGatewayListenerConfig, aws_cdk_lib_aws_appmesh_VirtualGatewayListener, aws_cdk_lib_aws_appmesh_IGatewayRoute, aws_cdk_lib_aws_appmesh_GatewayRouteBaseProps, aws_cdk_lib_aws_appmesh_GatewayRouteProps, aws_cdk_lib_aws_appmesh_GatewayRoute, aws_cdk_lib_aws_appmesh_GatewayRouteAttributes, aws_cdk_lib_aws_appmesh_GatewayRouteHostnameMatchConfig, aws_cdk_lib_aws_appmesh_GatewayRouteHostnameMatch, aws_cdk_lib_aws_appmesh_HttpGatewayRouteMatch, aws_cdk_lib_aws_appmesh_GrpcGatewayRouteMatch, aws_cdk_lib_aws_appmesh_CommonGatewayRouteSpecOptions, aws_cdk_lib_aws_appmesh_HttpGatewayRouteSpecOptions, aws_cdk_lib_aws_appmesh_GrpcGatewayRouteSpecOptions, aws_cdk_lib_aws_appmesh_GatewayRouteSpecConfig, aws_cdk_lib_aws_appmesh_GatewayRouteSpec, aws_cdk_lib_aws_appmesh_HttpHealthCheckOptions, aws_cdk_lib_aws_appmesh_GrpcHealthCheckOptions, aws_cdk_lib_aws_appmesh_TcpHealthCheckOptions, aws_cdk_lib_aws_appmesh_HealthCheckConfig, aws_cdk_lib_aws_appmesh_HealthCheckBindOptions, aws_cdk_lib_aws_appmesh_HealthCheck, aws_cdk_lib_aws_appmesh_TlsMode, aws_cdk_lib_aws_appmesh_ListenerTlsOptions, aws_cdk_lib_aws_appmesh_TlsValidation, aws_cdk_lib_aws_appmesh_MutualTlsValidation, aws_cdk_lib_aws_appmesh_TlsValidationTrustConfig, aws_cdk_lib_aws_appmesh_TlsValidationTrust, aws_cdk_lib_aws_appmesh_MutualTlsValidationTrust, aws_cdk_lib_aws_appmesh_SubjectAlternativeNamesMatcherConfig, aws_cdk_lib_aws_appmesh_SubjectAlternativeNames, aws_cdk_lib_aws_appmesh_TlsClientPolicy, aws_cdk_lib_aws_appmesh_HttpRouteMethod, aws_cdk_lib_aws_appmesh_HeaderMatchConfig, aws_cdk_lib_aws_appmesh_HeaderMatch, aws_cdk_lib_aws_appmesh_QueryParameterMatchConfig, aws_cdk_lib_aws_appmesh_QueryParameterMatch, aws_cdk_lib_aws_appmesh_HttpRoutePathMatchConfig, aws_cdk_lib_aws_appmesh_HttpRoutePathMatch, aws_cdk_lib_aws_appmesh_HttpGatewayRoutePathMatchConfig, aws_cdk_lib_aws_appmesh_HttpGatewayRoutePathMatch, aws_cdk_lib_aws_apprunner_CfnObservabilityConfigurationProps, aws_cdk_lib_aws_apprunner_CfnObservabilityConfiguration, aws_cdk_lib_aws_apprunner_CfnObservabilityConfiguration_TraceConfigurationProperty, aws_cdk_lib_aws_apprunner_CfnServiceProps, aws_cdk_lib_aws_apprunner_CfnService, aws_cdk_lib_aws_apprunner_CfnService_AuthenticationConfigurationProperty, aws_cdk_lib_aws_apprunner_CfnService_CodeConfigurationProperty, aws_cdk_lib_aws_apprunner_CfnService_CodeConfigurationValuesProperty, aws_cdk_lib_aws_apprunner_CfnService_CodeRepositoryProperty, aws_cdk_lib_aws_apprunner_CfnService_EgressConfigurationProperty, aws_cdk_lib_aws_apprunner_CfnService_EncryptionConfigurationProperty, aws_cdk_lib_aws_apprunner_CfnService_HealthCheckConfigurationProperty, aws_cdk_lib_aws_apprunner_CfnService_ImageConfigurationProperty, aws_cdk_lib_aws_apprunner_CfnService_ImageRepositoryProperty, aws_cdk_lib_aws_apprunner_CfnService_IngressConfigurationProperty, aws_cdk_lib_aws_apprunner_CfnService_InstanceConfigurationProperty, aws_cdk_lib_aws_apprunner_CfnService_KeyValuePairProperty, aws_cdk_lib_aws_apprunner_CfnService_NetworkConfigurationProperty, aws_cdk_lib_aws_apprunner_CfnService_ServiceObservabilityConfigurationProperty, aws_cdk_lib_aws_apprunner_CfnService_SourceCodeVersionProperty, aws_cdk_lib_aws_apprunner_CfnService_SourceConfigurationProperty, aws_cdk_lib_aws_apprunner_CfnVpcConnectorProps, aws_cdk_lib_aws_apprunner_CfnVpcConnector, aws_cdk_lib_aws_apprunner_CfnVpcIngressConnectionProps, aws_cdk_lib_aws_apprunner_CfnVpcIngressConnection, aws_cdk_lib_aws_apprunner_CfnVpcIngressConnection_IngressVpcConfigurationProperty, aws_cdk_lib_aws_appstream_CfnAppBlockProps, aws_cdk_lib_aws_appstream_CfnAppBlock, aws_cdk_lib_aws_appstream_CfnAppBlock_S3LocationProperty, aws_cdk_lib_aws_appstream_CfnAppBlock_ScriptDetailsProperty, aws_cdk_lib_aws_appstream_CfnApplicationProps, aws_cdk_lib_aws_appstream_CfnApplication, aws_cdk_lib_aws_appstream_CfnApplication_S3LocationProperty, aws_cdk_lib_aws_appstream_CfnApplicationEntitlementAssociationProps, aws_cdk_lib_aws_appstream_CfnApplicationEntitlementAssociation, aws_cdk_lib_aws_appstream_CfnApplicationFleetAssociationProps, aws_cdk_lib_aws_appstream_CfnApplicationFleetAssociation, aws_cdk_lib_aws_appstream_CfnDirectoryConfigProps, aws_cdk_lib_aws_appstream_CfnDirectoryConfig, aws_cdk_lib_aws_appstream_CfnDirectoryConfig_CertificateBasedAuthPropertiesProperty, aws_cdk_lib_aws_appstream_CfnDirectoryConfig_ServiceAccountCredentialsProperty, aws_cdk_lib_aws_appstream_CfnEntitlementProps, aws_cdk_lib_aws_appstream_CfnEntitlement, aws_cdk_lib_aws_appstream_CfnEntitlement_AttributeProperty, aws_cdk_lib_aws_appstream_CfnFleetProps, aws_cdk_lib_aws_appstream_CfnFleet, aws_cdk_lib_aws_appstream_CfnFleet_ComputeCapacityProperty, aws_cdk_lib_aws_appstream_CfnFleet_DomainJoinInfoProperty, aws_cdk_lib_aws_appstream_CfnFleet_S3LocationProperty, aws_cdk_lib_aws_appstream_CfnFleet_VpcConfigProperty, aws_cdk_lib_aws_appstream_CfnImageBuilderProps, aws_cdk_lib_aws_appstream_CfnImageBuilder, aws_cdk_lib_aws_appstream_CfnImageBuilder_AccessEndpointProperty, aws_cdk_lib_aws_appstream_CfnImageBuilder_DomainJoinInfoProperty, aws_cdk_lib_aws_appstream_CfnImageBuilder_VpcConfigProperty, aws_cdk_lib_aws_appstream_CfnStackProps, aws_cdk_lib_aws_appstream_CfnStack, aws_cdk_lib_aws_appstream_CfnStack_AccessEndpointProperty, aws_cdk_lib_aws_appstream_CfnStack_ApplicationSettingsProperty, aws_cdk_lib_aws_appstream_CfnStack_StorageConnectorProperty, aws_cdk_lib_aws_appstream_CfnStack_StreamingExperienceSettingsProperty, aws_cdk_lib_aws_appstream_CfnStack_UserSettingProperty, aws_cdk_lib_aws_appstream_CfnStackFleetAssociationProps, aws_cdk_lib_aws_appstream_CfnStackFleetAssociation, aws_cdk_lib_aws_appstream_CfnStackUserAssociationProps, aws_cdk_lib_aws_appstream_CfnStackUserAssociation, aws_cdk_lib_aws_appstream_CfnUserProps, aws_cdk_lib_aws_appstream_CfnUser, aws_cdk_lib_aws_appsync_BaseAppsyncFunctionProps, aws_cdk_lib_aws_appsync_AppsyncFunctionProps, aws_cdk_lib_aws_appsync_AppsyncFunctionAttributes, aws_cdk_lib_aws_appsync_IAppsyncFunction, aws_cdk_lib_aws_appsync_AppsyncFunction, aws_cdk_lib_aws_appsync_CfnApiCacheProps, aws_cdk_lib_aws_appsync_CfnApiCache, aws_cdk_lib_aws_appsync_CfnApiKeyProps, aws_cdk_lib_aws_appsync_CfnApiKey, aws_cdk_lib_aws_appsync_CfnDataSourceProps, aws_cdk_lib_aws_appsync_CfnDataSource, aws_cdk_lib_aws_appsync_CfnDataSource_AuthorizationConfigProperty, aws_cdk_lib_aws_appsync_CfnDataSource_AwsIamConfigProperty, aws_cdk_lib_aws_appsync_CfnDataSource_DeltaSyncConfigProperty, aws_cdk_lib_aws_appsync_CfnDataSource_DynamoDBConfigProperty, aws_cdk_lib_aws_appsync_CfnDataSource_ElasticsearchConfigProperty, aws_cdk_lib_aws_appsync_CfnDataSource_EventBridgeConfigProperty, aws_cdk_lib_aws_appsync_CfnDataSource_HttpConfigProperty, aws_cdk_lib_aws_appsync_CfnDataSource_LambdaConfigProperty, aws_cdk_lib_aws_appsync_CfnDataSource_OpenSearchServiceConfigProperty, aws_cdk_lib_aws_appsync_CfnDataSource_RdsHttpEndpointConfigProperty, aws_cdk_lib_aws_appsync_CfnDataSource_RelationalDatabaseConfigProperty, aws_cdk_lib_aws_appsync_CfnDomainNameProps, aws_cdk_lib_aws_appsync_CfnDomainName, aws_cdk_lib_aws_appsync_CfnDomainNameApiAssociationProps, aws_cdk_lib_aws_appsync_CfnDomainNameApiAssociation, aws_cdk_lib_aws_appsync_CfnFunctionConfigurationProps, aws_cdk_lib_aws_appsync_CfnFunctionConfiguration, aws_cdk_lib_aws_appsync_CfnFunctionConfiguration_AppSyncRuntimeProperty, aws_cdk_lib_aws_appsync_CfnFunctionConfiguration_LambdaConflictHandlerConfigProperty, aws_cdk_lib_aws_appsync_CfnFunctionConfiguration_SyncConfigProperty, aws_cdk_lib_aws_appsync_CfnGraphQLApiProps, aws_cdk_lib_aws_appsync_CfnGraphQLApi, aws_cdk_lib_aws_appsync_CfnGraphQLApi_AdditionalAuthenticationProviderProperty, aws_cdk_lib_aws_appsync_CfnGraphQLApi_CognitoUserPoolConfigProperty, aws_cdk_lib_aws_appsync_CfnGraphQLApi_LambdaAuthorizerConfigProperty, aws_cdk_lib_aws_appsync_CfnGraphQLApi_LogConfigProperty, aws_cdk_lib_aws_appsync_CfnGraphQLApi_OpenIDConnectConfigProperty, aws_cdk_lib_aws_appsync_CfnGraphQLApi_UserPoolConfigProperty, aws_cdk_lib_aws_appsync_CfnGraphQLSchemaProps, aws_cdk_lib_aws_appsync_CfnGraphQLSchema, aws_cdk_lib_aws_appsync_CfnResolverProps, aws_cdk_lib_aws_appsync_CfnResolver, aws_cdk_lib_aws_appsync_CfnResolver_AppSyncRuntimeProperty, aws_cdk_lib_aws_appsync_CfnResolver_CachingConfigProperty, aws_cdk_lib_aws_appsync_CfnResolver_LambdaConflictHandlerConfigProperty, aws_cdk_lib_aws_appsync_CfnResolver_PipelineConfigProperty, aws_cdk_lib_aws_appsync_CfnResolver_SyncConfigProperty, aws_cdk_lib_aws_appsync_CachingConfig, aws_cdk_lib_aws_appsync_KeyCondition, aws_cdk_lib_aws_appsync_Assign, aws_cdk_lib_aws_appsync_PartitionKeyStep, aws_cdk_lib_aws_appsync_SortKeyStep, aws_cdk_lib_aws_appsync_PrimaryKey, aws_cdk_lib_aws_appsync_PartitionKey, aws_cdk_lib_aws_appsync_AttributeValues, aws_cdk_lib_aws_appsync_AttributeValuesStep, aws_cdk_lib_aws_appsync_Values, aws_cdk_lib_aws_appsync_BaseDataSourceProps, aws_cdk_lib_aws_appsync_BackedDataSourceProps, aws_cdk_lib_aws_appsync_ExtendedDataSourceProps, aws_cdk_lib_aws_appsync_BaseDataSource, aws_cdk_lib_aws_appsync_BackedDataSource, aws_cdk_lib_aws_appsync_NoneDataSourceProps, aws_cdk_lib_aws_appsync_NoneDataSource, aws_cdk_lib_aws_appsync_DynamoDbDataSourceProps, aws_cdk_lib_aws_appsync_DynamoDbDataSource, aws_cdk_lib_aws_appsync_AwsIamConfig, aws_cdk_lib_aws_appsync_HttpDataSourceProps, aws_cdk_lib_aws_appsync_HttpDataSource, aws_cdk_lib_aws_appsync_EventBridgeDataSourceProps, aws_cdk_lib_aws_appsync_EventBridgeDataSource, aws_cdk_lib_aws_appsync_LambdaDataSourceProps, aws_cdk_lib_aws_appsync_LambdaDataSource, aws_cdk_lib_aws_appsync_RdsDataSourceProps, aws_cdk_lib_aws_appsync_RdsDataSource, aws_cdk_lib_aws_appsync_ElasticsearchDataSourceProps, aws_cdk_lib_aws_appsync_ElasticsearchDataSource, aws_cdk_lib_aws_appsync_OpenSearchDataSourceProps, aws_cdk_lib_aws_appsync_OpenSearchDataSource, aws_cdk_lib_aws_appsync_MappingTemplate, aws_cdk_lib_aws_appsync_BaseResolverProps, aws_cdk_lib_aws_appsync_ExtendedResolverProps, aws_cdk_lib_aws_appsync_ResolverProps, aws_cdk_lib_aws_appsync_Resolver, aws_cdk_lib_aws_appsync_ISchemaConfig, aws_cdk_lib_aws_appsync_SchemaBindOptions, aws_cdk_lib_aws_appsync_ISchema, aws_cdk_lib_aws_appsync_SchemaProps, aws_cdk_lib_aws_appsync_SchemaFile, aws_cdk_lib_aws_appsync_AuthorizationType, aws_cdk_lib_aws_appsync_AuthorizationMode, aws_cdk_lib_aws_appsync_UserPoolDefaultAction, aws_cdk_lib_aws_appsync_UserPoolConfig, aws_cdk_lib_aws_appsync_ApiKeyConfig, aws_cdk_lib_aws_appsync_OpenIdConnectConfig, aws_cdk_lib_aws_appsync_LambdaAuthorizerConfig, aws_cdk_lib_aws_appsync_AuthorizationConfig, aws_cdk_lib_aws_appsync_FieldLogLevel, aws_cdk_lib_aws_appsync_LogConfig, aws_cdk_lib_aws_appsync_Visibility, aws_cdk_lib_aws_appsync_DomainOptions, aws_cdk_lib_aws_appsync_GraphqlApiProps, aws_cdk_lib_aws_appsync_IamResource, aws_cdk_lib_aws_appsync_GraphqlApiAttributes, aws_cdk_lib_aws_appsync_GraphqlApi, aws_cdk_lib_aws_appsync_DataSourceOptions, aws_cdk_lib_aws_appsync_HttpDataSourceOptions, aws_cdk_lib_aws_appsync_IGraphqlApi, aws_cdk_lib_aws_appsync_GraphqlApiBase, aws_cdk_lib_aws_appsync_CodeConfig, aws_cdk_lib_aws_appsync_Code, aws_cdk_lib_aws_appsync_AssetCode, aws_cdk_lib_aws_appsync_InlineCode, aws_cdk_lib_aws_appsync_RuntimeConfig, aws_cdk_lib_aws_appsync_FunctionRuntimeFamily, aws_cdk_lib_aws_appsync_FunctionRuntime, aws_cdk_lib_aws_aps_CfnRuleGroupsNamespaceProps, aws_cdk_lib_aws_aps_CfnRuleGroupsNamespace, aws_cdk_lib_aws_aps_CfnWorkspaceProps, aws_cdk_lib_aws_aps_CfnWorkspace, aws_cdk_lib_aws_aps_CfnWorkspace_LoggingConfigurationProperty, aws_cdk_lib_aws_athena_CfnDataCatalogProps, aws_cdk_lib_aws_athena_CfnDataCatalog, aws_cdk_lib_aws_athena_CfnNamedQueryProps, aws_cdk_lib_aws_athena_CfnNamedQuery, aws_cdk_lib_aws_athena_CfnPreparedStatementProps, aws_cdk_lib_aws_athena_CfnPreparedStatement, aws_cdk_lib_aws_athena_CfnWorkGroupProps, aws_cdk_lib_aws_athena_CfnWorkGroup, aws_cdk_lib_aws_athena_CfnWorkGroup_AclConfigurationProperty, aws_cdk_lib_aws_athena_CfnWorkGroup_CustomerContentEncryptionConfigurationProperty, aws_cdk_lib_aws_athena_CfnWorkGroup_EncryptionConfigurationProperty, aws_cdk_lib_aws_athena_CfnWorkGroup_EngineVersionProperty, aws_cdk_lib_aws_athena_CfnWorkGroup_ResultConfigurationProperty, aws_cdk_lib_aws_athena_CfnWorkGroup_WorkGroupConfigurationProperty, aws_cdk_lib_aws_auditmanager_CfnAssessmentProps, aws_cdk_lib_aws_auditmanager_CfnAssessment, aws_cdk_lib_aws_auditmanager_CfnAssessment_AWSAccountProperty, aws_cdk_lib_aws_auditmanager_CfnAssessment_AWSServiceProperty, aws_cdk_lib_aws_auditmanager_CfnAssessment_AssessmentReportsDestinationProperty, aws_cdk_lib_aws_auditmanager_CfnAssessment_DelegationProperty, aws_cdk_lib_aws_auditmanager_CfnAssessment_RoleProperty, aws_cdk_lib_aws_auditmanager_CfnAssessment_ScopeProperty, aws_cdk_lib_aws_autoscaling_AutoScalingGroupRequireImdsv2Aspect, aws_cdk_lib_aws_autoscaling_Monitoring, aws_cdk_lib_aws_autoscaling_CommonAutoScalingGroupProps, aws_cdk_lib_aws_autoscaling_MixedInstancesPolicy, aws_cdk_lib_aws_autoscaling_OnDemandAllocationStrategy, aws_cdk_lib_aws_autoscaling_SpotAllocationStrategy, aws_cdk_lib_aws_autoscaling_InstancesDistribution, aws_cdk_lib_aws_autoscaling_LaunchTemplateOverrides, aws_cdk_lib_aws_autoscaling_AutoScalingGroupProps, aws_cdk_lib_aws_autoscaling_Signals, aws_cdk_lib_aws_autoscaling_RenderSignalsOptions, aws_cdk_lib_aws_autoscaling_SignalsOptions, aws_cdk_lib_aws_autoscaling_UpdatePolicy, aws_cdk_lib_aws_autoscaling_RollingUpdateOptions, aws_cdk_lib_aws_autoscaling_GroupMetrics, aws_cdk_lib_aws_autoscaling_GroupMetric, aws_cdk_lib_aws_autoscaling_AutoScalingGroup, aws_cdk_lib_aws_autoscaling_NotificationConfiguration, aws_cdk_lib_aws_autoscaling_ScalingEvent, aws_cdk_lib_aws_autoscaling_ScalingEvents, aws_cdk_lib_aws_autoscaling_ScalingProcess, aws_cdk_lib_aws_autoscaling_Ec2HealthCheckOptions, aws_cdk_lib_aws_autoscaling_ElbHealthCheckOptions, aws_cdk_lib_aws_autoscaling_HealthCheck, aws_cdk_lib_aws_autoscaling_IAutoScalingGroup, aws_cdk_lib_aws_autoscaling_CpuUtilizationScalingProps, aws_cdk_lib_aws_autoscaling_NetworkUtilizationScalingProps, aws_cdk_lib_aws_autoscaling_RequestCountScalingProps, aws_cdk_lib_aws_autoscaling_MetricTargetTrackingProps, aws_cdk_lib_aws_autoscaling_ApplyCloudFormationInitOptions, aws_cdk_lib_aws_autoscaling_Schedule, aws_cdk_lib_aws_autoscaling_CronOptions, aws_cdk_lib_aws_autoscaling_BasicLifecycleHookProps, aws_cdk_lib_aws_autoscaling_LifecycleHookProps, aws_cdk_lib_aws_autoscaling_ILifecycleHook, aws_cdk_lib_aws_autoscaling_LifecycleHook, aws_cdk_lib_aws_autoscaling_DefaultResult, aws_cdk_lib_aws_autoscaling_LifecycleTransition, aws_cdk_lib_aws_autoscaling_BindHookTargetOptions, aws_cdk_lib_aws_autoscaling_LifecycleHookTargetConfig, aws_cdk_lib_aws_autoscaling_ILifecycleHookTarget, aws_cdk_lib_aws_autoscaling_BasicScheduledActionProps, aws_cdk_lib_aws_autoscaling_ScheduledActionProps, aws_cdk_lib_aws_autoscaling_ScheduledAction, aws_cdk_lib_aws_autoscaling_StepScalingActionProps, aws_cdk_lib_aws_autoscaling_StepScalingAction, aws_cdk_lib_aws_autoscaling_AdjustmentType, aws_cdk_lib_aws_autoscaling_MetricAggregationType, aws_cdk_lib_aws_autoscaling_AdjustmentTier, aws_cdk_lib_aws_autoscaling_BasicStepScalingPolicyProps, aws_cdk_lib_aws_autoscaling_StepScalingPolicyProps, aws_cdk_lib_aws_autoscaling_StepScalingPolicy, aws_cdk_lib_aws_autoscaling_ScalingInterval, aws_cdk_lib_aws_autoscaling_BaseTargetTrackingProps, aws_cdk_lib_aws_autoscaling_BasicTargetTrackingScalingPolicyProps, aws_cdk_lib_aws_autoscaling_TargetTrackingScalingPolicyProps, aws_cdk_lib_aws_autoscaling_TargetTrackingScalingPolicy, aws_cdk_lib_aws_autoscaling_PredefinedMetric, aws_cdk_lib_aws_autoscaling_TerminationPolicy, aws_cdk_lib_aws_autoscaling_BlockDevice, aws_cdk_lib_aws_autoscaling_EbsDeviceOptionsBase, aws_cdk_lib_aws_autoscaling_EbsDeviceOptions, aws_cdk_lib_aws_autoscaling_EbsDeviceSnapshotOptions, aws_cdk_lib_aws_autoscaling_EbsDeviceProps, aws_cdk_lib_aws_autoscaling_BlockDeviceVolume, aws_cdk_lib_aws_autoscaling_EbsDeviceVolumeType, aws_cdk_lib_aws_autoscaling_WarmPoolOptions, aws_cdk_lib_aws_autoscaling_WarmPoolProps, aws_cdk_lib_aws_autoscaling_WarmPool, aws_cdk_lib_aws_autoscaling_PoolState, aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroupProps, aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup, aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_AcceleratorCountRequestProperty, aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_AcceleratorTotalMemoryMiBRequestProperty, aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_BaselineEbsBandwidthMbpsRequestProperty, aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_InstanceRequirementsProperty, aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_InstancesDistributionProperty, aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_LaunchTemplateProperty, aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_LaunchTemplateOverridesProperty, aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_LaunchTemplateSpecificationProperty, aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_LifecycleHookSpecificationProperty, aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_MemoryGiBPerVCpuRequestProperty, aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_MemoryMiBRequestProperty, aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_MetricsCollectionProperty, aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_MixedInstancesPolicyProperty, aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_NetworkBandwidthGbpsRequestProperty, aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_NetworkInterfaceCountRequestProperty, aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_NotificationConfigurationProperty, aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_TagPropertyProperty, aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_TotalLocalStorageGBRequestProperty, aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroup_VCpuCountRequestProperty, aws_cdk_lib_aws_autoscaling_CfnLaunchConfigurationProps, aws_cdk_lib_aws_autoscaling_CfnLaunchConfiguration, aws_cdk_lib_aws_autoscaling_CfnLaunchConfiguration_BlockDeviceProperty, aws_cdk_lib_aws_autoscaling_CfnLaunchConfiguration_BlockDeviceMappingProperty, aws_cdk_lib_aws_autoscaling_CfnLaunchConfiguration_MetadataOptionsProperty, aws_cdk_lib_aws_autoscaling_CfnLifecycleHookProps, aws_cdk_lib_aws_autoscaling_CfnLifecycleHook, aws_cdk_lib_aws_autoscaling_CfnScalingPolicyProps, aws_cdk_lib_aws_autoscaling_CfnScalingPolicy, aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_CustomizedMetricSpecificationProperty, aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_MetricProperty, aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_MetricDataQueryProperty, aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_MetricDimensionProperty, aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_MetricStatProperty, aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_PredefinedMetricSpecificationProperty, aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_PredictiveScalingConfigurationProperty, aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_PredictiveScalingCustomizedCapacityMetricProperty, aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_PredictiveScalingCustomizedLoadMetricProperty, aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_PredictiveScalingCustomizedScalingMetricProperty, aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_PredictiveScalingMetricSpecificationProperty, aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_PredictiveScalingPredefinedLoadMetricProperty, aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_PredictiveScalingPredefinedMetricPairProperty, aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_PredictiveScalingPredefinedScalingMetricProperty, aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_StepAdjustmentProperty, aws_cdk_lib_aws_autoscaling_CfnScalingPolicy_TargetTrackingConfigurationProperty, aws_cdk_lib_aws_autoscaling_CfnScheduledActionProps, aws_cdk_lib_aws_autoscaling_CfnScheduledAction, aws_cdk_lib_aws_autoscaling_CfnWarmPoolProps, aws_cdk_lib_aws_autoscaling_CfnWarmPool, aws_cdk_lib_aws_autoscaling_CfnWarmPool_InstanceReusePolicyProperty, aws_cdk_lib_aws_autoscaling_common_ScalingInterval, aws_cdk_lib_aws_autoscaling_common_CompleteScalingInterval, aws_cdk_lib_aws_autoscaling_common_Alarms, aws_cdk_lib_aws_autoscaling_common_IRandomGenerator, aws_cdk_lib_aws_autoscaling_common_ArbitraryIntervals, aws_cdk_lib_aws_autoscaling_hooktargets_QueueHook, aws_cdk_lib_aws_autoscaling_hooktargets_TopicHook, aws_cdk_lib_aws_autoscaling_hooktargets_FunctionHook, aws_cdk_lib_aws_autoscalingplans_CfnScalingPlanProps, aws_cdk_lib_aws_autoscalingplans_CfnScalingPlan, aws_cdk_lib_aws_autoscalingplans_CfnScalingPlan_ApplicationSourceProperty, aws_cdk_lib_aws_autoscalingplans_CfnScalingPlan_CustomizedLoadMetricSpecificationProperty, aws_cdk_lib_aws_autoscalingplans_CfnScalingPlan_CustomizedScalingMetricSpecificationProperty, aws_cdk_lib_aws_autoscalingplans_CfnScalingPlan_MetricDimensionProperty, aws_cdk_lib_aws_autoscalingplans_CfnScalingPlan_PredefinedLoadMetricSpecificationProperty, aws_cdk_lib_aws_autoscalingplans_CfnScalingPlan_PredefinedScalingMetricSpecificationProperty, aws_cdk_lib_aws_autoscalingplans_CfnScalingPlan_ScalingInstructionProperty, aws_cdk_lib_aws_autoscalingplans_CfnScalingPlan_TagFilterProperty, aws_cdk_lib_aws_autoscalingplans_CfnScalingPlan_TargetTrackingConfigurationProperty, aws_cdk_lib_aws_backup_IBackupVault, aws_cdk_lib_aws_backup_BackupVaultProps, aws_cdk_lib_aws_backup_BackupVaultEvents, aws_cdk_lib_aws_backup_LockConfiguration, aws_cdk_lib_aws_backup_BackupVault, aws_cdk_lib_aws_backup_IBackupPlan, aws_cdk_lib_aws_backup_BackupPlanProps, aws_cdk_lib_aws_backup_BackupPlan, aws_cdk_lib_aws_backup_BackupPlanRuleProps, aws_cdk_lib_aws_backup_BackupPlanCopyActionProps, aws_cdk_lib_aws_backup_BackupPlanRule, aws_cdk_lib_aws_backup_BackupSelectionOptions, aws_cdk_lib_aws_backup_BackupSelectionProps, aws_cdk_lib_aws_backup_BackupSelection, aws_cdk_lib_aws_backup_TagOperation, aws_cdk_lib_aws_backup_TagCondition, aws_cdk_lib_aws_backup_BackupResource, aws_cdk_lib_aws_backup_CfnBackupPlanProps, aws_cdk_lib_aws_backup_CfnBackupPlan, aws_cdk_lib_aws_backup_CfnBackupPlan_AdvancedBackupSettingResourceTypeProperty, aws_cdk_lib_aws_backup_CfnBackupPlan_BackupPlanResourceTypeProperty, aws_cdk_lib_aws_backup_CfnBackupPlan_BackupRuleResourceTypeProperty, aws_cdk_lib_aws_backup_CfnBackupPlan_CopyActionResourceTypeProperty, aws_cdk_lib_aws_backup_CfnBackupPlan_LifecycleResourceTypeProperty, aws_cdk_lib_aws_backup_CfnBackupSelectionProps, aws_cdk_lib_aws_backup_CfnBackupSelection, aws_cdk_lib_aws_backup_CfnBackupSelection_BackupSelectionResourceTypeProperty, aws_cdk_lib_aws_backup_CfnBackupSelection_ConditionParameterProperty, aws_cdk_lib_aws_backup_CfnBackupSelection_ConditionResourceTypeProperty, aws_cdk_lib_aws_backup_CfnBackupSelection_ConditionsProperty, aws_cdk_lib_aws_backup_CfnBackupVaultProps, aws_cdk_lib_aws_backup_CfnBackupVault, aws_cdk_lib_aws_backup_CfnBackupVault_LockConfigurationTypeProperty, aws_cdk_lib_aws_backup_CfnBackupVault_NotificationObjectTypeProperty, aws_cdk_lib_aws_backup_CfnFrameworkProps, aws_cdk_lib_aws_backup_CfnFramework, aws_cdk_lib_aws_backup_CfnFramework_ControlInputParameterProperty, aws_cdk_lib_aws_backup_CfnFramework_ControlScopeProperty, aws_cdk_lib_aws_backup_CfnFramework_FrameworkControlProperty, aws_cdk_lib_aws_backup_CfnReportPlanProps, aws_cdk_lib_aws_backup_CfnReportPlan, aws_cdk_lib_aws_backup_CfnReportPlan_ReportDeliveryChannelProperty, aws_cdk_lib_aws_backup_CfnReportPlan_ReportSettingProperty, aws_cdk_lib_aws_backupgateway_CfnHypervisorProps, aws_cdk_lib_aws_backupgateway_CfnHypervisor, aws_cdk_lib_aws_batch_CfnComputeEnvironmentProps, aws_cdk_lib_aws_batch_CfnComputeEnvironment, aws_cdk_lib_aws_batch_CfnComputeEnvironment_ComputeResourcesProperty, aws_cdk_lib_aws_batch_CfnComputeEnvironment_Ec2ConfigurationObjectProperty, aws_cdk_lib_aws_batch_CfnComputeEnvironment_EksConfigurationProperty, aws_cdk_lib_aws_batch_CfnComputeEnvironment_LaunchTemplateSpecificationProperty, aws_cdk_lib_aws_batch_CfnComputeEnvironment_UpdatePolicyProperty, aws_cdk_lib_aws_batch_CfnJobDefinitionProps, aws_cdk_lib_aws_batch_CfnJobDefinition, aws_cdk_lib_aws_batch_CfnJobDefinition_AuthorizationConfigProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_ContainerPropertiesProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_DeviceProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_EfsVolumeConfigurationProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_EksContainerProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_EksContainerEnvironmentVariableProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_EksContainerVolumeMountProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_EksPropertiesProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_EksSecretProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_EksVolumeProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_EmptyDirProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_EnvironmentProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_EphemeralStorageProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_EvaluateOnExitProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_FargatePlatformConfigurationProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_HostPathProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_LinuxParametersProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_LogConfigurationProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_MetadataProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_MountPointsProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_NetworkConfigurationProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_NodePropertiesProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_NodeRangePropertyProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_PodPropertiesProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_ResourceRequirementProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_ResourcesProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_RetryStrategyProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_SecretProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_SecurityContextProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_TimeoutProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_TmpfsProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_UlimitProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_VolumesProperty, aws_cdk_lib_aws_batch_CfnJobDefinition_VolumesHostProperty, aws_cdk_lib_aws_batch_CfnJobQueueProps, aws_cdk_lib_aws_batch_CfnJobQueue, aws_cdk_lib_aws_batch_CfnJobQueue_ComputeEnvironmentOrderProperty, aws_cdk_lib_aws_batch_CfnSchedulingPolicyProps, aws_cdk_lib_aws_batch_CfnSchedulingPolicy, aws_cdk_lib_aws_batch_CfnSchedulingPolicy_FairsharePolicyProperty, aws_cdk_lib_aws_batch_CfnSchedulingPolicy_ShareAttributesProperty, aws_cdk_lib_aws_billingconductor_CfnBillingGroupProps, aws_cdk_lib_aws_billingconductor_CfnBillingGroup, aws_cdk_lib_aws_billingconductor_CfnBillingGroup_AccountGroupingProperty, aws_cdk_lib_aws_billingconductor_CfnBillingGroup_ComputationPreferenceProperty, aws_cdk_lib_aws_billingconductor_CfnCustomLineItemProps, aws_cdk_lib_aws_billingconductor_CfnCustomLineItem, aws_cdk_lib_aws_billingconductor_CfnCustomLineItem_BillingPeriodRangeProperty, aws_cdk_lib_aws_billingconductor_CfnCustomLineItem_CustomLineItemChargeDetailsProperty, aws_cdk_lib_aws_billingconductor_CfnCustomLineItem_CustomLineItemFlatChargeDetailsProperty, aws_cdk_lib_aws_billingconductor_CfnCustomLineItem_CustomLineItemPercentageChargeDetailsProperty, aws_cdk_lib_aws_billingconductor_CfnPricingPlanProps, aws_cdk_lib_aws_billingconductor_CfnPricingPlan, aws_cdk_lib_aws_billingconductor_CfnPricingRuleProps, aws_cdk_lib_aws_billingconductor_CfnPricingRule, aws_cdk_lib_aws_billingconductor_CfnPricingRule_FreeTierProperty, aws_cdk_lib_aws_billingconductor_CfnPricingRule_TieringProperty, aws_cdk_lib_aws_budgets_CfnBudgetProps, aws_cdk_lib_aws_budgets_CfnBudget, aws_cdk_lib_aws_budgets_CfnBudget_AutoAdjustDataProperty, aws_cdk_lib_aws_budgets_CfnBudget_BudgetDataProperty, aws_cdk_lib_aws_budgets_CfnBudget_CostTypesProperty, aws_cdk_lib_aws_budgets_CfnBudget_HistoricalOptionsProperty, aws_cdk_lib_aws_budgets_CfnBudget_NotificationProperty, aws_cdk_lib_aws_budgets_CfnBudget_NotificationWithSubscribersProperty, aws_cdk_lib_aws_budgets_CfnBudget_SpendProperty, aws_cdk_lib_aws_budgets_CfnBudget_SubscriberProperty, aws_cdk_lib_aws_budgets_CfnBudget_TimePeriodProperty, aws_cdk_lib_aws_budgets_CfnBudgetsActionProps, aws_cdk_lib_aws_budgets_CfnBudgetsAction, aws_cdk_lib_aws_budgets_CfnBudgetsAction_ActionThresholdProperty, aws_cdk_lib_aws_budgets_CfnBudgetsAction_DefinitionProperty, aws_cdk_lib_aws_budgets_CfnBudgetsAction_IamActionDefinitionProperty, aws_cdk_lib_aws_budgets_CfnBudgetsAction_ScpActionDefinitionProperty, aws_cdk_lib_aws_budgets_CfnBudgetsAction_SsmActionDefinitionProperty, aws_cdk_lib_aws_budgets_CfnBudgetsAction_SubscriberProperty, aws_cdk_lib_aws_cassandra_CfnKeyspaceProps, aws_cdk_lib_aws_cassandra_CfnKeyspace, aws_cdk_lib_aws_cassandra_CfnTableProps, aws_cdk_lib_aws_cassandra_CfnTable, aws_cdk_lib_aws_cassandra_CfnTable_BillingModeProperty, aws_cdk_lib_aws_cassandra_CfnTable_ClusteringKeyColumnProperty, aws_cdk_lib_aws_cassandra_CfnTable_ColumnProperty, aws_cdk_lib_aws_cassandra_CfnTable_EncryptionSpecificationProperty, aws_cdk_lib_aws_cassandra_CfnTable_ProvisionedThroughputProperty, aws_cdk_lib_aws_ce_CfnAnomalyMonitorProps, aws_cdk_lib_aws_ce_CfnAnomalyMonitor, aws_cdk_lib_aws_ce_CfnAnomalyMonitor_ResourceTagProperty, aws_cdk_lib_aws_ce_CfnAnomalySubscriptionProps, aws_cdk_lib_aws_ce_CfnAnomalySubscription, aws_cdk_lib_aws_ce_CfnAnomalySubscription_ResourceTagProperty, aws_cdk_lib_aws_ce_CfnAnomalySubscription_SubscriberProperty, aws_cdk_lib_aws_ce_CfnCostCategoryProps, aws_cdk_lib_aws_ce_CfnCostCategory, aws_cdk_lib_aws_certificatemanager_ICertificate, aws_cdk_lib_aws_certificatemanager_CertificateProps, aws_cdk_lib_aws_certificatemanager_CertificationValidationProps, aws_cdk_lib_aws_certificatemanager_CertificateValidation, aws_cdk_lib_aws_certificatemanager_Certificate, aws_cdk_lib_aws_certificatemanager_ValidationMethod, aws_cdk_lib_aws_certificatemanager_DnsValidatedCertificateProps, aws_cdk_lib_aws_certificatemanager_DnsValidatedCertificate, aws_cdk_lib_aws_certificatemanager_PrivateCertificateProps, aws_cdk_lib_aws_certificatemanager_PrivateCertificate, aws_cdk_lib_aws_certificatemanager_CfnAccountProps, aws_cdk_lib_aws_certificatemanager_CfnAccount, aws_cdk_lib_aws_certificatemanager_CfnAccount_ExpiryEventsConfigurationProperty, aws_cdk_lib_aws_certificatemanager_CfnCertificateProps, aws_cdk_lib_aws_certificatemanager_CfnCertificate, aws_cdk_lib_aws_certificatemanager_CfnCertificate_DomainValidationOptionProperty, aws_cdk_lib_aws_chatbot_CfnMicrosoftTeamsChannelConfigurationProps, aws_cdk_lib_aws_chatbot_CfnMicrosoftTeamsChannelConfiguration, aws_cdk_lib_aws_chatbot_CfnSlackChannelConfigurationProps, aws_cdk_lib_aws_chatbot_CfnSlackChannelConfiguration, aws_cdk_lib_aws_chatbot_SlackChannelConfigurationProps, aws_cdk_lib_aws_chatbot_LoggingLevel, aws_cdk_lib_aws_chatbot_ISlackChannelConfiguration, aws_cdk_lib_aws_chatbot_SlackChannelConfiguration, aws_cdk_lib_aws_cloud9_CfnEnvironmentEC2Props, aws_cdk_lib_aws_cloud9_CfnEnvironmentEC2, aws_cdk_lib_aws_cloud9_CfnEnvironmentEC2_RepositoryProperty, aws_cdk_lib_aws_cloudformation_CfnCustomResourceProps, aws_cdk_lib_aws_cloudformation_CfnCustomResource, aws_cdk_lib_aws_cloudformation_CfnHookDefaultVersionProps, aws_cdk_lib_aws_cloudformation_CfnHookDefaultVersion, aws_cdk_lib_aws_cloudformation_CfnHookTypeConfigProps, aws_cdk_lib_aws_cloudformation_CfnHookTypeConfig, aws_cdk_lib_aws_cloudformation_CfnHookVersionProps, aws_cdk_lib_aws_cloudformation_CfnHookVersion, aws_cdk_lib_aws_cloudformation_CfnHookVersion_LoggingConfigProperty, aws_cdk_lib_aws_cloudformation_CfnMacroProps, aws_cdk_lib_aws_cloudformation_CfnMacro, aws_cdk_lib_aws_cloudformation_CfnModuleDefaultVersionProps, aws_cdk_lib_aws_cloudformation_CfnModuleDefaultVersion, aws_cdk_lib_aws_cloudformation_CfnModuleVersionProps, aws_cdk_lib_aws_cloudformation_CfnModuleVersion, aws_cdk_lib_aws_cloudformation_CfnPublicTypeVersionProps, aws_cdk_lib_aws_cloudformation_CfnPublicTypeVersion, aws_cdk_lib_aws_cloudformation_CfnPublisherProps, aws_cdk_lib_aws_cloudformation_CfnPublisher, aws_cdk_lib_aws_cloudformation_CfnResourceDefaultVersionProps, aws_cdk_lib_aws_cloudformation_CfnResourceDefaultVersion, aws_cdk_lib_aws_cloudformation_CfnResourceVersionProps, aws_cdk_lib_aws_cloudformation_CfnResourceVersion, aws_cdk_lib_aws_cloudformation_CfnResourceVersion_LoggingConfigProperty, aws_cdk_lib_aws_cloudformation_CfnStackProps, aws_cdk_lib_aws_cloudformation_CfnStack, aws_cdk_lib_aws_cloudformation_CfnStackSetProps, aws_cdk_lib_aws_cloudformation_CfnStackSet, aws_cdk_lib_aws_cloudformation_CfnStackSet_AutoDeploymentProperty, aws_cdk_lib_aws_cloudformation_CfnStackSet_DeploymentTargetsProperty, aws_cdk_lib_aws_cloudformation_CfnStackSet_ManagedExecutionProperty, aws_cdk_lib_aws_cloudformation_CfnStackSet_OperationPreferencesProperty, aws_cdk_lib_aws_cloudformation_CfnStackSet_ParameterProperty, aws_cdk_lib_aws_cloudformation_CfnStackSet_StackInstancesProperty, aws_cdk_lib_aws_cloudformation_CfnTypeActivationProps, aws_cdk_lib_aws_cloudformation_CfnTypeActivation, aws_cdk_lib_aws_cloudformation_CfnTypeActivation_LoggingConfigProperty, aws_cdk_lib_aws_cloudformation_CfnWaitConditionProps, aws_cdk_lib_aws_cloudformation_CfnWaitCondition, aws_cdk_lib_aws_cloudformation_CfnWaitConditionHandle, aws_cdk_lib_aws_cloudfront_experimental_EdgeFunctionProps, aws_cdk_lib_aws_cloudfront_experimental_EdgeFunction, aws_cdk_lib_aws_cloudfront_ICachePolicy, aws_cdk_lib_aws_cloudfront_CachePolicyProps, aws_cdk_lib_aws_cloudfront_CachePolicy, aws_cdk_lib_aws_cloudfront_CacheCookieBehavior, aws_cdk_lib_aws_cloudfront_CacheHeaderBehavior, aws_cdk_lib_aws_cloudfront_CacheQueryStringBehavior, aws_cdk_lib_aws_cloudfront_IDistribution, aws_cdk_lib_aws_cloudfront_DistributionAttributes, aws_cdk_lib_aws_cloudfront_DistributionProps, aws_cdk_lib_aws_cloudfront_Distribution, aws_cdk_lib_aws_cloudfront_HttpVersion, aws_cdk_lib_aws_cloudfront_PriceClass, aws_cdk_lib_aws_cloudfront_ViewerProtocolPolicy, aws_cdk_lib_aws_cloudfront_OriginProtocolPolicy, aws_cdk_lib_aws_cloudfront_SSLMethod, aws_cdk_lib_aws_cloudfront_SecurityPolicyProtocol, aws_cdk_lib_aws_cloudfront_AllowedMethods, aws_cdk_lib_aws_cloudfront_CachedMethods, aws_cdk_lib_aws_cloudfront_ErrorResponse, aws_cdk_lib_aws_cloudfront_LambdaEdgeEventType, aws_cdk_lib_aws_cloudfront_EdgeLambda, aws_cdk_lib_aws_cloudfront_AddBehaviorOptions, aws_cdk_lib_aws_cloudfront_BehaviorOptions, aws_cdk_lib_aws_cloudfront_FunctionCode, aws_cdk_lib_aws_cloudfront_FileCodeOptions, aws_cdk_lib_aws_cloudfront_IFunction, aws_cdk_lib_aws_cloudfront_FunctionAttributes, aws_cdk_lib_aws_cloudfront_FunctionProps, aws_cdk_lib_aws_cloudfront_Function, aws_cdk_lib_aws_cloudfront_FunctionEventType, aws_cdk_lib_aws_cloudfront_FunctionAssociation, aws_cdk_lib_aws_cloudfront_GeoRestriction, aws_cdk_lib_aws_cloudfront_IKeyGroup, aws_cdk_lib_aws_cloudfront_KeyGroupProps, aws_cdk_lib_aws_cloudfront_KeyGroup, aws_cdk_lib_aws_cloudfront_OriginFailoverConfig, aws_cdk_lib_aws_cloudfront_OriginBindConfig, aws_cdk_lib_aws_cloudfront_IOrigin, aws_cdk_lib_aws_cloudfront_OriginOptions, aws_cdk_lib_aws_cloudfront_OriginProps, aws_cdk_lib_aws_cloudfront_OriginBindOptions, aws_cdk_lib_aws_cloudfront_OriginBase, aws_cdk_lib_aws_cloudfront_OriginAccessIdentityProps, aws_cdk_lib_aws_cloudfront_IOriginAccessIdentity, aws_cdk_lib_aws_cloudfront_OriginAccessIdentity, aws_cdk_lib_aws_cloudfront_IOriginRequestPolicy, aws_cdk_lib_aws_cloudfront_OriginRequestPolicyProps, aws_cdk_lib_aws_cloudfront_OriginRequestPolicy, aws_cdk_lib_aws_cloudfront_OriginRequestCookieBehavior, aws_cdk_lib_aws_cloudfront_OriginRequestHeaderBehavior, aws_cdk_lib_aws_cloudfront_OriginRequestQueryStringBehavior, aws_cdk_lib_aws_cloudfront_IPublicKey, aws_cdk_lib_aws_cloudfront_PublicKeyProps, aws_cdk_lib_aws_cloudfront_PublicKey, aws_cdk_lib_aws_cloudfront_IResponseHeadersPolicy, aws_cdk_lib_aws_cloudfront_ResponseHeadersPolicyProps, aws_cdk_lib_aws_cloudfront_ResponseHeadersPolicy, aws_cdk_lib_aws_cloudfront_ResponseHeadersCorsBehavior, aws_cdk_lib_aws_cloudfront_ResponseCustomHeadersBehavior, aws_cdk_lib_aws_cloudfront_ResponseCustomHeader, aws_cdk_lib_aws_cloudfront_ResponseSecurityHeadersBehavior, aws_cdk_lib_aws_cloudfront_ResponseHeadersContentSecurityPolicy, aws_cdk_lib_aws_cloudfront_ResponseHeadersContentTypeOptions, aws_cdk_lib_aws_cloudfront_ResponseHeadersFrameOptions, aws_cdk_lib_aws_cloudfront_ResponseHeadersReferrerPolicy, aws_cdk_lib_aws_cloudfront_ResponseHeadersStrictTransportSecurity, aws_cdk_lib_aws_cloudfront_ResponseHeadersXSSProtection, aws_cdk_lib_aws_cloudfront_HeadersFrameOption, aws_cdk_lib_aws_cloudfront_HeadersReferrerPolicy, aws_cdk_lib_aws_cloudfront_FailoverStatusCode, aws_cdk_lib_aws_cloudfront_LoggingConfiguration, aws_cdk_lib_aws_cloudfront_SourceConfiguration, aws_cdk_lib_aws_cloudfront_CustomOriginConfig, aws_cdk_lib_aws_cloudfront_OriginSslPolicy, aws_cdk_lib_aws_cloudfront_S3OriginConfig, aws_cdk_lib_aws_cloudfront_CloudFrontAllowedMethods, aws_cdk_lib_aws_cloudfront_CloudFrontAllowedCachedMethods, aws_cdk_lib_aws_cloudfront_Behavior, aws_cdk_lib_aws_cloudfront_LambdaFunctionAssociation, aws_cdk_lib_aws_cloudfront_ViewerCertificateOptions, aws_cdk_lib_aws_cloudfront_ViewerCertificate, aws_cdk_lib_aws_cloudfront_CloudFrontWebDistributionProps, aws_cdk_lib_aws_cloudfront_CloudFrontWebDistributionAttributes, aws_cdk_lib_aws_cloudfront_CloudFrontWebDistribution, aws_cdk_lib_aws_cloudfront_CfnCachePolicyProps, aws_cdk_lib_aws_cloudfront_CfnCachePolicy, aws_cdk_lib_aws_cloudfront_CfnCachePolicy_CachePolicyConfigProperty, aws_cdk_lib_aws_cloudfront_CfnCachePolicy_CookiesConfigProperty, aws_cdk_lib_aws_cloudfront_CfnCachePolicy_HeadersConfigProperty, aws_cdk_lib_aws_cloudfront_CfnCachePolicy_ParametersInCacheKeyAndForwardedToOriginProperty, aws_cdk_lib_aws_cloudfront_CfnCachePolicy_QueryStringsConfigProperty, aws_cdk_lib_aws_cloudfront_CfnCloudFrontOriginAccessIdentityProps, aws_cdk_lib_aws_cloudfront_CfnCloudFrontOriginAccessIdentity, aws_cdk_lib_aws_cloudfront_CfnCloudFrontOriginAccessIdentity_CloudFrontOriginAccessIdentityConfigProperty, aws_cdk_lib_aws_cloudfront_CfnContinuousDeploymentPolicyProps, aws_cdk_lib_aws_cloudfront_CfnContinuousDeploymentPolicy, aws_cdk_lib_aws_cloudfront_CfnContinuousDeploymentPolicy_ContinuousDeploymentPolicyConfigProperty, aws_cdk_lib_aws_cloudfront_CfnContinuousDeploymentPolicy_SessionStickinessConfigProperty, aws_cdk_lib_aws_cloudfront_CfnContinuousDeploymentPolicy_SingleHeaderConfigProperty, aws_cdk_lib_aws_cloudfront_CfnContinuousDeploymentPolicy_SingleWeightConfigProperty, aws_cdk_lib_aws_cloudfront_CfnContinuousDeploymentPolicy_TrafficConfigProperty, aws_cdk_lib_aws_cloudfront_CfnDistributionProps, aws_cdk_lib_aws_cloudfront_CfnDistribution, aws_cdk_lib_aws_cloudfront_CfnDistribution_CacheBehaviorProperty, aws_cdk_lib_aws_cloudfront_CfnDistribution_CookiesProperty, aws_cdk_lib_aws_cloudfront_CfnDistribution_CustomErrorResponseProperty, aws_cdk_lib_aws_cloudfront_CfnDistribution_CustomOriginConfigProperty, aws_cdk_lib_aws_cloudfront_CfnDistribution_DefaultCacheBehaviorProperty, aws_cdk_lib_aws_cloudfront_CfnDistribution_DistributionConfigProperty, aws_cdk_lib_aws_cloudfront_CfnDistribution_ForwardedValuesProperty, aws_cdk_lib_aws_cloudfront_CfnDistribution_FunctionAssociationProperty, aws_cdk_lib_aws_cloudfront_CfnDistribution_GeoRestrictionProperty, aws_cdk_lib_aws_cloudfront_CfnDistribution_LambdaFunctionAssociationProperty, aws_cdk_lib_aws_cloudfront_CfnDistribution_LegacyCustomOriginProperty, aws_cdk_lib_aws_cloudfront_CfnDistribution_LegacyS3OriginProperty, aws_cdk_lib_aws_cloudfront_CfnDistribution_LoggingProperty, aws_cdk_lib_aws_cloudfront_CfnDistribution_OriginProperty, aws_cdk_lib_aws_cloudfront_CfnDistribution_OriginCustomHeaderProperty, aws_cdk_lib_aws_cloudfront_CfnDistribution_OriginGroupProperty, aws_cdk_lib_aws_cloudfront_CfnDistribution_OriginGroupFailoverCriteriaProperty, aws_cdk_lib_aws_cloudfront_CfnDistribution_OriginGroupMemberProperty, aws_cdk_lib_aws_cloudfront_CfnDistribution_OriginGroupMembersProperty, aws_cdk_lib_aws_cloudfront_CfnDistribution_OriginGroupsProperty, aws_cdk_lib_aws_cloudfront_CfnDistribution_OriginShieldProperty, aws_cdk_lib_aws_cloudfront_CfnDistribution_RestrictionsProperty, aws_cdk_lib_aws_cloudfront_CfnDistribution_S3OriginConfigProperty, aws_cdk_lib_aws_cloudfront_CfnDistribution_StatusCodesProperty, aws_cdk_lib_aws_cloudfront_CfnDistribution_ViewerCertificateProperty, aws_cdk_lib_aws_cloudfront_CfnFunctionProps, aws_cdk_lib_aws_cloudfront_CfnFunction, aws_cdk_lib_aws_cloudfront_CfnFunction_FunctionConfigProperty, aws_cdk_lib_aws_cloudfront_CfnFunction_FunctionMetadataProperty, aws_cdk_lib_aws_cloudfront_CfnKeyGroupProps, aws_cdk_lib_aws_cloudfront_CfnKeyGroup, aws_cdk_lib_aws_cloudfront_CfnKeyGroup_KeyGroupConfigProperty, aws_cdk_lib_aws_cloudfront_CfnMonitoringSubscriptionProps, aws_cdk_lib_aws_cloudfront_CfnMonitoringSubscription, aws_cdk_lib_aws_cloudfront_CfnMonitoringSubscription_MonitoringSubscriptionProperty, aws_cdk_lib_aws_cloudfront_CfnMonitoringSubscription_RealtimeMetricsSubscriptionConfigProperty, aws_cdk_lib_aws_cloudfront_CfnOriginAccessControlProps, aws_cdk_lib_aws_cloudfront_CfnOriginAccessControl, aws_cdk_lib_aws_cloudfront_CfnOriginAccessControl_OriginAccessControlConfigProperty, aws_cdk_lib_aws_cloudfront_CfnOriginRequestPolicyProps, aws_cdk_lib_aws_cloudfront_CfnOriginRequestPolicy, aws_cdk_lib_aws_cloudfront_CfnOriginRequestPolicy_CookiesConfigProperty, aws_cdk_lib_aws_cloudfront_CfnOriginRequestPolicy_HeadersConfigProperty, aws_cdk_lib_aws_cloudfront_CfnOriginRequestPolicy_OriginRequestPolicyConfigProperty, aws_cdk_lib_aws_cloudfront_CfnOriginRequestPolicy_QueryStringsConfigProperty, aws_cdk_lib_aws_cloudfront_CfnPublicKeyProps, aws_cdk_lib_aws_cloudfront_CfnPublicKey, aws_cdk_lib_aws_cloudfront_CfnPublicKey_PublicKeyConfigProperty, aws_cdk_lib_aws_cloudfront_CfnRealtimeLogConfigProps, aws_cdk_lib_aws_cloudfront_CfnRealtimeLogConfig, aws_cdk_lib_aws_cloudfront_CfnRealtimeLogConfig_EndPointProperty, aws_cdk_lib_aws_cloudfront_CfnRealtimeLogConfig_KinesisStreamConfigProperty, aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicyProps, aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy, aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_AccessControlAllowHeadersProperty, aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_AccessControlAllowMethodsProperty, aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_AccessControlAllowOriginsProperty, aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_AccessControlExposeHeadersProperty, aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_ContentSecurityPolicyProperty, aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_ContentTypeOptionsProperty, aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_CorsConfigProperty, aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_CustomHeaderProperty, aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_CustomHeadersConfigProperty, aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_FrameOptionsProperty, aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_ReferrerPolicyProperty, aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_RemoveHeaderProperty, aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_RemoveHeadersConfigProperty, aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_ResponseHeadersPolicyConfigProperty, aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_SecurityHeadersConfigProperty, aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_ServerTimingHeadersConfigProperty, aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_StrictTransportSecurityProperty, aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicy_XSSProtectionProperty, aws_cdk_lib_aws_cloudfront_CfnStreamingDistributionProps, aws_cdk_lib_aws_cloudfront_CfnStreamingDistribution, aws_cdk_lib_aws_cloudfront_CfnStreamingDistribution_LoggingProperty, aws_cdk_lib_aws_cloudfront_CfnStreamingDistribution_S3OriginProperty, aws_cdk_lib_aws_cloudfront_CfnStreamingDistribution_StreamingDistributionConfigProperty, aws_cdk_lib_aws_cloudfront_CfnStreamingDistribution_TrustedSignersProperty, aws_cdk_lib_aws_cloudfront_origins_HttpOriginProps, aws_cdk_lib_aws_cloudfront_origins_HttpOrigin, aws_cdk_lib_aws_cloudfront_origins_LoadBalancerV2OriginProps, aws_cdk_lib_aws_cloudfront_origins_LoadBalancerV2Origin, aws_cdk_lib_aws_cloudfront_origins_S3OriginProps, aws_cdk_lib_aws_cloudfront_origins_S3Origin, aws_cdk_lib_aws_cloudfront_origins_OriginGroupProps, aws_cdk_lib_aws_cloudfront_origins_OriginGroup, aws_cdk_lib_aws_cloudfront_origins_RestApiOriginProps, aws_cdk_lib_aws_cloudfront_origins_RestApiOrigin, aws_cdk_lib_aws_cloudtrail_TrailProps, aws_cdk_lib_aws_cloudtrail_ReadWriteType, aws_cdk_lib_aws_cloudtrail_InsightType, aws_cdk_lib_aws_cloudtrail_Trail, aws_cdk_lib_aws_cloudtrail_AddEventSelectorOptions, aws_cdk_lib_aws_cloudtrail_ManagementEventSources, aws_cdk_lib_aws_cloudtrail_S3EventSelector, aws_cdk_lib_aws_cloudtrail_DataResourceType, aws_cdk_lib_aws_cloudtrail_CfnChannelProps, aws_cdk_lib_aws_cloudtrail_CfnChannel, aws_cdk_lib_aws_cloudtrail_CfnChannel_DestinationProperty, aws_cdk_lib_aws_cloudtrail_CfnEventDataStoreProps, aws_cdk_lib_aws_cloudtrail_CfnEventDataStore, aws_cdk_lib_aws_cloudtrail_CfnEventDataStore_AdvancedEventSelectorProperty, aws_cdk_lib_aws_cloudtrail_CfnEventDataStore_AdvancedFieldSelectorProperty, aws_cdk_lib_aws_cloudtrail_CfnResourcePolicyProps, aws_cdk_lib_aws_cloudtrail_CfnResourcePolicy, aws_cdk_lib_aws_cloudtrail_CfnTrailProps, aws_cdk_lib_aws_cloudtrail_CfnTrail, aws_cdk_lib_aws_cloudtrail_CfnTrail_DataResourceProperty, aws_cdk_lib_aws_cloudtrail_CfnTrail_EventSelectorProperty, aws_cdk_lib_aws_cloudtrail_CfnTrail_InsightSelectorProperty, aws_cdk_lib_aws_cloudwatch_AlarmProps, aws_cdk_lib_aws_cloudwatch_ComparisonOperator, aws_cdk_lib_aws_cloudwatch_TreatMissingData, aws_cdk_lib_aws_cloudwatch_Alarm, aws_cdk_lib_aws_cloudwatch_IAlarmAction, aws_cdk_lib_aws_cloudwatch_AlarmActionConfig, aws_cdk_lib_aws_cloudwatch_IAlarmRule, aws_cdk_lib_aws_cloudwatch_IAlarm, aws_cdk_lib_aws_cloudwatch_AlarmBase, aws_cdk_lib_aws_cloudwatch_AlarmState, aws_cdk_lib_aws_cloudwatch_AlarmRule, aws_cdk_lib_aws_cloudwatch_CompositeAlarmProps, aws_cdk_lib_aws_cloudwatch_CompositeAlarm, aws_cdk_lib_aws_cloudwatch_PeriodOverride, aws_cdk_lib_aws_cloudwatch_DashboardProps, aws_cdk_lib_aws_cloudwatch_Dashboard, aws_cdk_lib_aws_cloudwatch_MetricWidgetProps, aws_cdk_lib_aws_cloudwatch_YAxisProps, aws_cdk_lib_aws_cloudwatch_AlarmWidgetProps, aws_cdk_lib_aws_cloudwatch_AlarmWidget, aws_cdk_lib_aws_cloudwatch_GraphWidgetView, aws_cdk_lib_aws_cloudwatch_GaugeWidgetProps, aws_cdk_lib_aws_cloudwatch_GaugeWidget, aws_cdk_lib_aws_cloudwatch_GraphWidgetProps, aws_cdk_lib_aws_cloudwatch_GraphWidget, aws_cdk_lib_aws_cloudwatch_SingleValueWidgetProps, aws_cdk_lib_aws_cloudwatch_SingleValueWidget, aws_cdk_lib_aws_cloudwatch_CustomWidgetProps, aws_cdk_lib_aws_cloudwatch_CustomWidget, aws_cdk_lib_aws_cloudwatch_HorizontalAnnotation, aws_cdk_lib_aws_cloudwatch_Shading, aws_cdk_lib_aws_cloudwatch_Color, aws_cdk_lib_aws_cloudwatch_LegendPosition, aws_cdk_lib_aws_cloudwatch_Row, aws_cdk_lib_aws_cloudwatch_Column, aws_cdk_lib_aws_cloudwatch_SpacerProps, aws_cdk_lib_aws_cloudwatch_Spacer, aws_cdk_lib_aws_cloudwatch_CommonMetricOptions, aws_cdk_lib_aws_cloudwatch_MetricProps, aws_cdk_lib_aws_cloudwatch_MetricOptions, aws_cdk_lib_aws_cloudwatch_MathExpressionOptions, aws_cdk_lib_aws_cloudwatch_MathExpressionProps, aws_cdk_lib_aws_cloudwatch_Metric, aws_cdk_lib_aws_cloudwatch_MathExpression, aws_cdk_lib_aws_cloudwatch_CreateAlarmOptions, aws_cdk_lib_aws_cloudwatch_IMetric, aws_cdk_lib_aws_cloudwatch_Dimension, aws_cdk_lib_aws_cloudwatch_Statistic, aws_cdk_lib_aws_cloudwatch_Unit, aws_cdk_lib_aws_cloudwatch_MetricConfig, aws_cdk_lib_aws_cloudwatch_MetricStatConfig, aws_cdk_lib_aws_cloudwatch_MetricExpressionConfig, aws_cdk_lib_aws_cloudwatch_LogQueryVisualizationType, aws_cdk_lib_aws_cloudwatch_LogQueryWidgetProps, aws_cdk_lib_aws_cloudwatch_LogQueryWidget, aws_cdk_lib_aws_cloudwatch_TextWidgetBackground, aws_cdk_lib_aws_cloudwatch_TextWidgetProps, aws_cdk_lib_aws_cloudwatch_TextWidget, aws_cdk_lib_aws_cloudwatch_IWidget, aws_cdk_lib_aws_cloudwatch_ConcreteWidget, aws_cdk_lib_aws_cloudwatch_AlarmStatusWidgetSortBy, aws_cdk_lib_aws_cloudwatch_AlarmStatusWidgetProps, aws_cdk_lib_aws_cloudwatch_AlarmStatusWidget, aws_cdk_lib_aws_cloudwatch_Stats, aws_cdk_lib_aws_cloudwatch_CfnAlarmProps, aws_cdk_lib_aws_cloudwatch_CfnAlarm, aws_cdk_lib_aws_cloudwatch_CfnAlarm_DimensionProperty, aws_cdk_lib_aws_cloudwatch_CfnAlarm_MetricProperty, aws_cdk_lib_aws_cloudwatch_CfnAlarm_MetricDataQueryProperty, aws_cdk_lib_aws_cloudwatch_CfnAlarm_MetricStatProperty, aws_cdk_lib_aws_cloudwatch_CfnAnomalyDetectorProps, aws_cdk_lib_aws_cloudwatch_CfnAnomalyDetector, aws_cdk_lib_aws_cloudwatch_CfnAnomalyDetector_ConfigurationProperty, aws_cdk_lib_aws_cloudwatch_CfnAnomalyDetector_DimensionProperty, aws_cdk_lib_aws_cloudwatch_CfnAnomalyDetector_MetricProperty, aws_cdk_lib_aws_cloudwatch_CfnAnomalyDetector_MetricDataQueryProperty, aws_cdk_lib_aws_cloudwatch_CfnAnomalyDetector_MetricMathAnomalyDetectorProperty, aws_cdk_lib_aws_cloudwatch_CfnAnomalyDetector_MetricStatProperty, aws_cdk_lib_aws_cloudwatch_CfnAnomalyDetector_RangeProperty, aws_cdk_lib_aws_cloudwatch_CfnAnomalyDetector_SingleMetricAnomalyDetectorProperty, aws_cdk_lib_aws_cloudwatch_CfnCompositeAlarmProps, aws_cdk_lib_aws_cloudwatch_CfnCompositeAlarm, aws_cdk_lib_aws_cloudwatch_CfnDashboardProps, aws_cdk_lib_aws_cloudwatch_CfnDashboard, aws_cdk_lib_aws_cloudwatch_CfnInsightRuleProps, aws_cdk_lib_aws_cloudwatch_CfnInsightRule, aws_cdk_lib_aws_cloudwatch_CfnMetricStreamProps, aws_cdk_lib_aws_cloudwatch_CfnMetricStream, aws_cdk_lib_aws_cloudwatch_CfnMetricStream_MetricStreamFilterProperty, aws_cdk_lib_aws_cloudwatch_CfnMetricStream_MetricStreamStatisticsConfigurationProperty, aws_cdk_lib_aws_cloudwatch_CfnMetricStream_MetricStreamStatisticsMetricProperty, aws_cdk_lib_aws_cloudwatch_actions_ApplicationScalingAction, aws_cdk_lib_aws_cloudwatch_actions_AutoScalingAction, aws_cdk_lib_aws_cloudwatch_actions_SnsAction, aws_cdk_lib_aws_cloudwatch_actions_Ec2InstanceAction, aws_cdk_lib_aws_cloudwatch_actions_Ec2Action, aws_cdk_lib_aws_cloudwatch_actions_OpsItemSeverity, aws_cdk_lib_aws_cloudwatch_actions_OpsItemCategory, aws_cdk_lib_aws_cloudwatch_actions_SsmAction, aws_cdk_lib_aws_cloudwatch_actions_SsmIncidentAction, aws_cdk_lib_aws_codeartifact_CfnDomainProps, aws_cdk_lib_aws_codeartifact_CfnDomain, aws_cdk_lib_aws_codeartifact_CfnRepositoryProps, aws_cdk_lib_aws_codeartifact_CfnRepository, aws_cdk_lib_aws_codebuild_StateChangeEvent, aws_cdk_lib_aws_codebuild_PhaseChangeEvent, aws_cdk_lib_aws_codebuild_PipelineProjectProps, aws_cdk_lib_aws_codebuild_PipelineProject, aws_cdk_lib_aws_codebuild_BatchBuildConfig, aws_cdk_lib_aws_codebuild_BuildEnvironmentCertificate, aws_cdk_lib_aws_codebuild_ProjectNotifyOnOptions, aws_cdk_lib_aws_codebuild_IProject, aws_cdk_lib_aws_codebuild_CommonProjectProps, aws_cdk_lib_aws_codebuild_ProjectProps, aws_cdk_lib_aws_codebuild_BindToCodePipelineOptions, aws_cdk_lib_aws_codebuild_Project, aws_cdk_lib_aws_codebuild_ComputeType, aws_cdk_lib_aws_codebuild_ImagePullPrincipalType, aws_cdk_lib_aws_codebuild_BuildEnvironment, aws_cdk_lib_aws_codebuild_IBuildImage, aws_cdk_lib_aws_codebuild_BuildImageBindOptions, aws_cdk_lib_aws_codebuild_BuildImageConfig, aws_cdk_lib_aws_codebuild_IBindableBuildImage, aws_cdk_lib_aws_codebuild_DockerImageOptions, aws_cdk_lib_aws_codebuild_LinuxBuildImage, aws_cdk_lib_aws_codebuild_WindowsImageType, aws_cdk_lib_aws_codebuild_WindowsBuildImage, aws_cdk_lib_aws_codebuild_BuildEnvironmentVariable, aws_cdk_lib_aws_codebuild_BuildEnvironmentVariableType, aws_cdk_lib_aws_codebuild_ProjectNotificationEvents, aws_cdk_lib_aws_codebuild_S3LoggingOptions, aws_cdk_lib_aws_codebuild_CloudWatchLoggingOptions, aws_cdk_lib_aws_codebuild_LoggingOptions, aws_cdk_lib_aws_codebuild_IReportGroup, aws_cdk_lib_aws_codebuild_ReportGroupType, aws_cdk_lib_aws_codebuild_ReportGroupProps, aws_cdk_lib_aws_codebuild_ReportGroup, aws_cdk_lib_aws_codebuild_SourceConfig, aws_cdk_lib_aws_codebuild_ISource, aws_cdk_lib_aws_codebuild_SourceProps, aws_cdk_lib_aws_codebuild_Source, aws_cdk_lib_aws_codebuild_EventAction, aws_cdk_lib_aws_codebuild_FilterGroup, aws_cdk_lib_aws_codebuild_CodeCommitSourceProps, aws_cdk_lib_aws_codebuild_S3SourceProps, aws_cdk_lib_aws_codebuild_GitHubSourceProps, aws_cdk_lib_aws_codebuild_GitHubEnterpriseSourceProps, aws_cdk_lib_aws_codebuild_BitBucketSourceProps, aws_cdk_lib_aws_codebuild_GitHubSourceCredentialsProps, aws_cdk_lib_aws_codebuild_GitHubSourceCredentials, aws_cdk_lib_aws_codebuild_GitHubEnterpriseSourceCredentialsProps, aws_cdk_lib_aws_codebuild_GitHubEnterpriseSourceCredentials, aws_cdk_lib_aws_codebuild_BitBucketSourceCredentialsProps, aws_cdk_lib_aws_codebuild_BitBucketSourceCredentials, aws_cdk_lib_aws_codebuild_ArtifactsConfig, aws_cdk_lib_aws_codebuild_IArtifacts, aws_cdk_lib_aws_codebuild_ArtifactsProps, aws_cdk_lib_aws_codebuild_Artifacts, aws_cdk_lib_aws_codebuild_S3ArtifactsProps, aws_cdk_lib_aws_codebuild_BucketCacheOptions, aws_cdk_lib_aws_codebuild_LocalCacheMode, aws_cdk_lib_aws_codebuild_Cache, aws_cdk_lib_aws_codebuild_BuildSpec, aws_cdk_lib_aws_codebuild_FileSystemConfig, aws_cdk_lib_aws_codebuild_IFileSystemLocation, aws_cdk_lib_aws_codebuild_FileSystemLocation, aws_cdk_lib_aws_codebuild_EfsFileSystemLocationProps, aws_cdk_lib_aws_codebuild_LinuxGpuBuildImage, aws_cdk_lib_aws_codebuild_UntrustedCodeBoundaryPolicyProps, aws_cdk_lib_aws_codebuild_UntrustedCodeBoundaryPolicy, aws_cdk_lib_aws_codebuild_LinuxArmBuildImage, aws_cdk_lib_aws_codebuild_CfnProjectProps, aws_cdk_lib_aws_codebuild_CfnProject, aws_cdk_lib_aws_codebuild_CfnProject_ArtifactsProperty, aws_cdk_lib_aws_codebuild_CfnProject_BatchRestrictionsProperty, aws_cdk_lib_aws_codebuild_CfnProject_BuildStatusConfigProperty, aws_cdk_lib_aws_codebuild_CfnProject_CloudWatchLogsConfigProperty, aws_cdk_lib_aws_codebuild_CfnProject_EnvironmentProperty, aws_cdk_lib_aws_codebuild_CfnProject_EnvironmentVariableProperty, aws_cdk_lib_aws_codebuild_CfnProject_GitSubmodulesConfigProperty, aws_cdk_lib_aws_codebuild_CfnProject_LogsConfigProperty, aws_cdk_lib_aws_codebuild_CfnProject_ProjectBuildBatchConfigProperty, aws_cdk_lib_aws_codebuild_CfnProject_ProjectCacheProperty, aws_cdk_lib_aws_codebuild_CfnProject_ProjectFileSystemLocationProperty, aws_cdk_lib_aws_codebuild_CfnProject_ProjectSourceVersionProperty, aws_cdk_lib_aws_codebuild_CfnProject_ProjectTriggersProperty, aws_cdk_lib_aws_codebuild_CfnProject_RegistryCredentialProperty, aws_cdk_lib_aws_codebuild_CfnProject_S3LogsConfigProperty, aws_cdk_lib_aws_codebuild_CfnProject_SourceProperty, aws_cdk_lib_aws_codebuild_CfnProject_SourceAuthProperty, aws_cdk_lib_aws_codebuild_CfnProject_VpcConfigProperty, aws_cdk_lib_aws_codebuild_CfnProject_WebhookFilterProperty, aws_cdk_lib_aws_codebuild_CfnReportGroupProps, aws_cdk_lib_aws_codebuild_CfnReportGroup, aws_cdk_lib_aws_codebuild_CfnReportGroup_ReportExportConfigProperty, aws_cdk_lib_aws_codebuild_CfnReportGroup_S3ReportExportConfigProperty, aws_cdk_lib_aws_codebuild_CfnSourceCredentialProps, aws_cdk_lib_aws_codebuild_CfnSourceCredential, aws_cdk_lib_aws_codecommit_ReferenceEvent, aws_cdk_lib_aws_codecommit_RepositoryNotifyOnOptions, aws_cdk_lib_aws_codecommit_IRepository, aws_cdk_lib_aws_codecommit_OnCommitOptions, aws_cdk_lib_aws_codecommit_RepositoryProps, aws_cdk_lib_aws_codecommit_Repository, aws_cdk_lib_aws_codecommit_RepositoryTriggerOptions, aws_cdk_lib_aws_codecommit_RepositoryEventTrigger, aws_cdk_lib_aws_codecommit_RepositoryNotificationEvents, aws_cdk_lib_aws_codecommit_CodeConfig, aws_cdk_lib_aws_codecommit_Code, aws_cdk_lib_aws_codecommit_CfnRepositoryProps, aws_cdk_lib_aws_codecommit_CfnRepository, aws_cdk_lib_aws_codecommit_CfnRepository_CodeProperty, aws_cdk_lib_aws_codecommit_CfnRepository_RepositoryTriggerProperty, aws_cdk_lib_aws_codecommit_CfnRepository_S3Property, aws_cdk_lib_aws_codedeploy_IBaseDeploymentConfig, aws_cdk_lib_aws_codedeploy_BaseDeploymentConfigOptions, aws_cdk_lib_aws_codedeploy_ComputePlatform, aws_cdk_lib_aws_codedeploy_BaseDeploymentConfigProps, aws_cdk_lib_aws_codedeploy_BaseDeploymentConfig, aws_cdk_lib_aws_codedeploy_MinimumHealthyHosts, aws_cdk_lib_aws_codedeploy_AutoRollbackConfig, aws_cdk_lib_aws_codedeploy_TrafficRoutingConfig, aws_cdk_lib_aws_codedeploy_CanaryTrafficRoutingConfig, aws_cdk_lib_aws_codedeploy_LinearTrafficRoutingConfig, aws_cdk_lib_aws_codedeploy_TrafficRouting, aws_cdk_lib_aws_codedeploy_BaseTrafficShiftingConfigProps, aws_cdk_lib_aws_codedeploy_AllAtOnceTrafficRouting, aws_cdk_lib_aws_codedeploy_TimeBasedCanaryTrafficRoutingProps, aws_cdk_lib_aws_codedeploy_TimeBasedCanaryTrafficRouting, aws_cdk_lib_aws_codedeploy_TimeBasedLinearTrafficRoutingProps, aws_cdk_lib_aws_codedeploy_TimeBasedLinearTrafficRouting, aws_cdk_lib_aws_codedeploy_IEcsApplication, aws_cdk_lib_aws_codedeploy_EcsApplicationProps, aws_cdk_lib_aws_codedeploy_EcsApplication, aws_cdk_lib_aws_codedeploy_IEcsDeploymentConfig, aws_cdk_lib_aws_codedeploy_EcsDeploymentConfigProps, aws_cdk_lib_aws_codedeploy_EcsDeploymentConfig, aws_cdk_lib_aws_codedeploy_IEcsDeploymentGroup, aws_cdk_lib_aws_codedeploy_EcsBlueGreenDeploymentConfig, aws_cdk_lib_aws_codedeploy_EcsDeploymentGroupProps, aws_cdk_lib_aws_codedeploy_EcsDeploymentGroup, aws_cdk_lib_aws_codedeploy_EcsDeploymentGroupAttributes, aws_cdk_lib_aws_codedeploy_ILambdaApplication, aws_cdk_lib_aws_codedeploy_LambdaApplicationProps, aws_cdk_lib_aws_codedeploy_LambdaApplication, aws_cdk_lib_aws_codedeploy_CustomLambdaDeploymentConfigType, aws_cdk_lib_aws_codedeploy_CustomLambdaDeploymentConfigProps, aws_cdk_lib_aws_codedeploy_CustomLambdaDeploymentConfig, aws_cdk_lib_aws_codedeploy_ILambdaDeploymentConfig, aws_cdk_lib_aws_codedeploy_LambdaDeploymentConfigImportProps, aws_cdk_lib_aws_codedeploy_LambdaDeploymentConfigProps, aws_cdk_lib_aws_codedeploy_LambdaDeploymentConfig, aws_cdk_lib_aws_codedeploy_ILambdaDeploymentGroup, aws_cdk_lib_aws_codedeploy_LambdaDeploymentGroupProps, aws_cdk_lib_aws_codedeploy_LambdaDeploymentGroup, aws_cdk_lib_aws_codedeploy_LambdaDeploymentGroupAttributes, aws_cdk_lib_aws_codedeploy_IServerApplication, aws_cdk_lib_aws_codedeploy_ServerApplicationProps, aws_cdk_lib_aws_codedeploy_ServerApplication, aws_cdk_lib_aws_codedeploy_IServerDeploymentConfig, aws_cdk_lib_aws_codedeploy_ServerDeploymentConfigProps, aws_cdk_lib_aws_codedeploy_ServerDeploymentConfig, aws_cdk_lib_aws_codedeploy_IServerDeploymentGroup, aws_cdk_lib_aws_codedeploy_ServerDeploymentGroupAttributes, aws_cdk_lib_aws_codedeploy_InstanceTagSet, aws_cdk_lib_aws_codedeploy_ServerDeploymentGroupProps, aws_cdk_lib_aws_codedeploy_ServerDeploymentGroup, aws_cdk_lib_aws_codedeploy_LoadBalancerGeneration, aws_cdk_lib_aws_codedeploy_LoadBalancer, aws_cdk_lib_aws_codedeploy_CfnApplicationProps, aws_cdk_lib_aws_codedeploy_CfnApplication, aws_cdk_lib_aws_codedeploy_CfnDeploymentConfigProps, aws_cdk_lib_aws_codedeploy_CfnDeploymentConfig, aws_cdk_lib_aws_codedeploy_CfnDeploymentConfig_MinimumHealthyHostsProperty, aws_cdk_lib_aws_codedeploy_CfnDeploymentConfig_TimeBasedCanaryProperty, aws_cdk_lib_aws_codedeploy_CfnDeploymentConfig_TimeBasedLinearProperty, aws_cdk_lib_aws_codedeploy_CfnDeploymentConfig_TrafficRoutingConfigProperty, aws_cdk_lib_aws_codedeploy_CfnDeploymentGroupProps, aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup, aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_AlarmProperty, aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_AlarmConfigurationProperty, aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_AutoRollbackConfigurationProperty, aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_BlueGreenDeploymentConfigurationProperty, aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_BlueInstanceTerminationOptionProperty, aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_DeploymentProperty, aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_DeploymentReadyOptionProperty, aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_DeploymentStyleProperty, aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_EC2TagFilterProperty, aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_EC2TagSetProperty, aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_EC2TagSetListObjectProperty, aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_ECSServiceProperty, aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_ELBInfoProperty, aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_GitHubLocationProperty, aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_GreenFleetProvisioningOptionProperty, aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_LoadBalancerInfoProperty, aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_OnPremisesTagSetProperty, aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_OnPremisesTagSetListObjectProperty, aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_RevisionLocationProperty, aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_S3LocationProperty, aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_TagFilterProperty, aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_TargetGroupInfoProperty, aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_TargetGroupPairInfoProperty, aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_TrafficRouteProperty, aws_cdk_lib_aws_codedeploy_CfnDeploymentGroup_TriggerConfigProperty, aws_cdk_lib_aws_codeguruprofiler_CfnProfilingGroupProps, aws_cdk_lib_aws_codeguruprofiler_CfnProfilingGroup, aws_cdk_lib_aws_codeguruprofiler_CfnProfilingGroup_AgentPermissionsProperty, aws_cdk_lib_aws_codeguruprofiler_CfnProfilingGroup_ChannelProperty, aws_cdk_lib_aws_codeguruprofiler_ComputePlatform, aws_cdk_lib_aws_codeguruprofiler_IProfilingGroup, aws_cdk_lib_aws_codeguruprofiler_ProfilingGroupProps, aws_cdk_lib_aws_codeguruprofiler_ProfilingGroup, aws_cdk_lib_aws_codegurureviewer_CfnRepositoryAssociationProps, aws_cdk_lib_aws_codegurureviewer_CfnRepositoryAssociation, aws_cdk_lib_aws_codepipeline_ActionCategory, aws_cdk_lib_aws_codepipeline_ActionArtifactBounds, aws_cdk_lib_aws_codepipeline_GlobalVariables, aws_cdk_lib_aws_codepipeline_ActionProperties, aws_cdk_lib_aws_codepipeline_ActionBindOptions, aws_cdk_lib_aws_codepipeline_ActionConfig, aws_cdk_lib_aws_codepipeline_PipelineNotifyOnOptions, aws_cdk_lib_aws_codepipeline_IAction, aws_cdk_lib_aws_codepipeline_IPipeline, aws_cdk_lib_aws_codepipeline_IStage, aws_cdk_lib_aws_codepipeline_CommonActionProps, aws_cdk_lib_aws_codepipeline_CommonAwsActionProps, aws_cdk_lib_aws_codepipeline_Action, aws_cdk_lib_aws_codepipeline_PipelineNotificationEvents, aws_cdk_lib_aws_codepipeline_Artifact, aws_cdk_lib_aws_codepipeline_ArtifactPath, aws_cdk_lib_aws_codepipeline_StagePlacement, aws_cdk_lib_aws_codepipeline_StageProps, aws_cdk_lib_aws_codepipeline_StageOptions, aws_cdk_lib_aws_codepipeline_PipelineProps, aws_cdk_lib_aws_codepipeline_Pipeline, aws_cdk_lib_aws_codepipeline_CrossRegionSupport, aws_cdk_lib_aws_codepipeline_CustomActionProperty, aws_cdk_lib_aws_codepipeline_CustomActionRegistrationProps, aws_cdk_lib_aws_codepipeline_CustomActionRegistration, aws_cdk_lib_aws_codepipeline_CfnCustomActionTypeProps, aws_cdk_lib_aws_codepipeline_CfnCustomActionType, aws_cdk_lib_aws_codepipeline_CfnCustomActionType_ArtifactDetailsProperty, aws_cdk_lib_aws_codepipeline_CfnCustomActionType_ConfigurationPropertiesProperty, aws_cdk_lib_aws_codepipeline_CfnCustomActionType_SettingsProperty, aws_cdk_lib_aws_codepipeline_CfnPipelineProps, aws_cdk_lib_aws_codepipeline_CfnPipeline, aws_cdk_lib_aws_codepipeline_CfnPipeline_ActionDeclarationProperty, aws_cdk_lib_aws_codepipeline_CfnPipeline_ActionTypeIdProperty, aws_cdk_lib_aws_codepipeline_CfnPipeline_ArtifactStoreProperty, aws_cdk_lib_aws_codepipeline_CfnPipeline_ArtifactStoreMapProperty, aws_cdk_lib_aws_codepipeline_CfnPipeline_BlockerDeclarationProperty, aws_cdk_lib_aws_codepipeline_CfnPipeline_EncryptionKeyProperty, aws_cdk_lib_aws_codepipeline_CfnPipeline_InputArtifactProperty, aws_cdk_lib_aws_codepipeline_CfnPipeline_OutputArtifactProperty, aws_cdk_lib_aws_codepipeline_CfnPipeline_StageDeclarationProperty, aws_cdk_lib_aws_codepipeline_CfnPipeline_StageTransitionProperty, aws_cdk_lib_aws_codepipeline_CfnWebhookProps, aws_cdk_lib_aws_codepipeline_CfnWebhook, aws_cdk_lib_aws_codepipeline_CfnWebhook_WebhookAuthConfigurationProperty, aws_cdk_lib_aws_codepipeline_CfnWebhook_WebhookFilterRuleProperty, aws_cdk_lib_aws_codepipeline_actions_AlexaSkillDeployActionProps, aws_cdk_lib_aws_codepipeline_actions_AlexaSkillDeployAction, aws_cdk_lib_aws_codepipeline_actions_CodeStarSourceVariables, aws_cdk_lib_aws_codepipeline_actions_CodeStarConnectionsSourceActionProps, aws_cdk_lib_aws_codepipeline_actions_CodeStarConnectionsSourceAction, aws_cdk_lib_aws_codepipeline_actions_CloudFormationExecuteChangeSetActionProps, aws_cdk_lib_aws_codepipeline_actions_CloudFormationExecuteChangeSetAction, aws_cdk_lib_aws_codepipeline_actions_CloudFormationCreateReplaceChangeSetActionProps, aws_cdk_lib_aws_codepipeline_actions_CloudFormationCreateReplaceChangeSetAction, aws_cdk_lib_aws_codepipeline_actions_CloudFormationCreateUpdateStackActionProps, aws_cdk_lib_aws_codepipeline_actions_CloudFormationCreateUpdateStackAction, aws_cdk_lib_aws_codepipeline_actions_CloudFormationDeleteStackActionProps, aws_cdk_lib_aws_codepipeline_actions_CloudFormationDeleteStackAction, aws_cdk_lib_aws_codepipeline_actions_CloudFormationDeployStackSetActionProps, aws_cdk_lib_aws_codepipeline_actions_CloudFormationDeployStackSetAction, aws_cdk_lib_aws_codepipeline_actions_CloudFormationDeployStackInstancesActionProps, aws_cdk_lib_aws_codepipeline_actions_CloudFormationDeployStackInstancesAction, aws_cdk_lib_aws_codepipeline_actions_CommonCloudFormationStackSetOptions, aws_cdk_lib_aws_codepipeline_actions_StackSetTemplate, aws_cdk_lib_aws_codepipeline_actions_StackInstances, aws_cdk_lib_aws_codepipeline_actions_StackSetParameters, aws_cdk_lib_aws_codepipeline_actions_StackSetDeploymentModel, aws_cdk_lib_aws_codepipeline_actions_OrganizationsDeploymentProps, aws_cdk_lib_aws_codepipeline_actions_StackSetOrganizationsAutoDeployment, aws_cdk_lib_aws_codepipeline_actions_SelfManagedDeploymentProps, aws_cdk_lib_aws_codepipeline_actions_CodeBuildActionType, aws_cdk_lib_aws_codepipeline_actions_CodeBuildActionProps, aws_cdk_lib_aws_codepipeline_actions_CodeBuildAction, aws_cdk_lib_aws_codepipeline_actions_CodeCommitTrigger, aws_cdk_lib_aws_codepipeline_actions_CodeCommitSourceVariables, aws_cdk_lib_aws_codepipeline_actions_CodeCommitSourceActionProps, aws_cdk_lib_aws_codepipeline_actions_CodeCommitSourceAction, aws_cdk_lib_aws_codepipeline_actions_CodeDeployEcsContainerImageInput, aws_cdk_lib_aws_codepipeline_actions_CodeDeployEcsDeployActionProps, aws_cdk_lib_aws_codepipeline_actions_CodeDeployEcsDeployAction, aws_cdk_lib_aws_codepipeline_actions_CodeDeployServerDeployActionProps, aws_cdk_lib_aws_codepipeline_actions_CodeDeployServerDeployAction, aws_cdk_lib_aws_codepipeline_actions_EcrSourceVariables, aws_cdk_lib_aws_codepipeline_actions_EcrSourceActionProps, aws_cdk_lib_aws_codepipeline_actions_EcrSourceAction, aws_cdk_lib_aws_codepipeline_actions_EcsDeployActionProps, aws_cdk_lib_aws_codepipeline_actions_EcsDeployAction, aws_cdk_lib_aws_codepipeline_actions_ElasticBeanstalkDeployActionProps, aws_cdk_lib_aws_codepipeline_actions_ElasticBeanstalkDeployAction, aws_cdk_lib_aws_codepipeline_actions_GitHubTrigger, aws_cdk_lib_aws_codepipeline_actions_GitHubSourceVariables, aws_cdk_lib_aws_codepipeline_actions_GitHubSourceActionProps, aws_cdk_lib_aws_codepipeline_actions_GitHubSourceAction, aws_cdk_lib_aws_codepipeline_actions_JenkinsActionType, aws_cdk_lib_aws_codepipeline_actions_JenkinsActionProps, aws_cdk_lib_aws_codepipeline_actions_JenkinsAction, aws_cdk_lib_aws_codepipeline_actions_IJenkinsProvider, aws_cdk_lib_aws_codepipeline_actions_JenkinsProviderAttributes, aws_cdk_lib_aws_codepipeline_actions_JenkinsProviderProps, aws_cdk_lib_aws_codepipeline_actions_BaseJenkinsProvider, aws_cdk_lib_aws_codepipeline_actions_JenkinsProvider, aws_cdk_lib_aws_codepipeline_actions_LambdaInvokeActionProps, aws_cdk_lib_aws_codepipeline_actions_LambdaInvokeAction, aws_cdk_lib_aws_codepipeline_actions_ManualApprovalActionProps, aws_cdk_lib_aws_codepipeline_actions_ManualApprovalAction, aws_cdk_lib_aws_codepipeline_actions_CacheControl, aws_cdk_lib_aws_codepipeline_actions_S3DeployActionProps, aws_cdk_lib_aws_codepipeline_actions_S3DeployAction, aws_cdk_lib_aws_codepipeline_actions_S3Trigger, aws_cdk_lib_aws_codepipeline_actions_S3SourceVariables, aws_cdk_lib_aws_codepipeline_actions_S3SourceActionProps, aws_cdk_lib_aws_codepipeline_actions_S3SourceAction, aws_cdk_lib_aws_codepipeline_actions_StateMachineInput, aws_cdk_lib_aws_codepipeline_actions_StepFunctionsInvokeActionProps, aws_cdk_lib_aws_codepipeline_actions_StepFunctionInvokeAction, aws_cdk_lib_aws_codepipeline_actions_ServiceCatalogDeployActionBeta1Props, aws_cdk_lib_aws_codepipeline_actions_ServiceCatalogDeployActionBeta1, aws_cdk_lib_aws_codepipeline_actions_Action, aws_cdk_lib_aws_codestar_CfnGitHubRepositoryProps, aws_cdk_lib_aws_codestar_CfnGitHubRepository, aws_cdk_lib_aws_codestar_CfnGitHubRepository_CodeProperty, aws_cdk_lib_aws_codestar_CfnGitHubRepository_S3Property, aws_cdk_lib_aws_codestarconnections_CfnConnectionProps, aws_cdk_lib_aws_codestarconnections_CfnConnection, aws_cdk_lib_aws_codestarnotifications_CfnNotificationRuleProps, aws_cdk_lib_aws_codestarnotifications_CfnNotificationRule, aws_cdk_lib_aws_codestarnotifications_CfnNotificationRule_TargetProperty, aws_cdk_lib_aws_codestarnotifications_DetailType, aws_cdk_lib_aws_codestarnotifications_NotificationRuleOptions, aws_cdk_lib_aws_codestarnotifications_NotificationRuleProps, aws_cdk_lib_aws_codestarnotifications_INotificationRule, aws_cdk_lib_aws_codestarnotifications_NotificationRule, aws_cdk_lib_aws_codestarnotifications_NotificationRuleSourceConfig, aws_cdk_lib_aws_codestarnotifications_INotificationRuleSource, aws_cdk_lib_aws_codestarnotifications_NotificationRuleTargetConfig, aws_cdk_lib_aws_codestarnotifications_INotificationRuleTarget, aws_cdk_lib_aws_cognito_CfnIdentityPoolProps, aws_cdk_lib_aws_cognito_CfnIdentityPool, aws_cdk_lib_aws_cognito_CfnIdentityPool_CognitoIdentityProviderProperty, aws_cdk_lib_aws_cognito_CfnIdentityPool_CognitoStreamsProperty, aws_cdk_lib_aws_cognito_CfnIdentityPool_PushSyncProperty, aws_cdk_lib_aws_cognito_CfnIdentityPoolRoleAttachmentProps, aws_cdk_lib_aws_cognito_CfnIdentityPoolRoleAttachment, aws_cdk_lib_aws_cognito_CfnIdentityPoolRoleAttachment_MappingRuleProperty, aws_cdk_lib_aws_cognito_CfnIdentityPoolRoleAttachment_RoleMappingProperty, aws_cdk_lib_aws_cognito_CfnIdentityPoolRoleAttachment_RulesConfigurationTypeProperty, aws_cdk_lib_aws_cognito_CfnUserPoolProps, aws_cdk_lib_aws_cognito_CfnUserPool, aws_cdk_lib_aws_cognito_CfnUserPool_AccountRecoverySettingProperty, aws_cdk_lib_aws_cognito_CfnUserPool_AdminCreateUserConfigProperty, aws_cdk_lib_aws_cognito_CfnUserPool_CustomEmailSenderProperty, aws_cdk_lib_aws_cognito_CfnUserPool_CustomSMSSenderProperty, aws_cdk_lib_aws_cognito_CfnUserPool_DeviceConfigurationProperty, aws_cdk_lib_aws_cognito_CfnUserPool_EmailConfigurationProperty, aws_cdk_lib_aws_cognito_CfnUserPool_InviteMessageTemplateProperty, aws_cdk_lib_aws_cognito_CfnUserPool_LambdaConfigProperty, aws_cdk_lib_aws_cognito_CfnUserPool_NumberAttributeConstraintsProperty, aws_cdk_lib_aws_cognito_CfnUserPool_PasswordPolicyProperty, aws_cdk_lib_aws_cognito_CfnUserPool_PoliciesProperty, aws_cdk_lib_aws_cognito_CfnUserPool_RecoveryOptionProperty, aws_cdk_lib_aws_cognito_CfnUserPool_SchemaAttributeProperty, aws_cdk_lib_aws_cognito_CfnUserPool_SmsConfigurationProperty, aws_cdk_lib_aws_cognito_CfnUserPool_StringAttributeConstraintsProperty, aws_cdk_lib_aws_cognito_CfnUserPool_UserAttributeUpdateSettingsProperty, aws_cdk_lib_aws_cognito_CfnUserPool_UserPoolAddOnsProperty, aws_cdk_lib_aws_cognito_CfnUserPool_UsernameConfigurationProperty, aws_cdk_lib_aws_cognito_CfnUserPool_VerificationMessageTemplateProperty, aws_cdk_lib_aws_cognito_CfnUserPoolClientProps, aws_cdk_lib_aws_cognito_CfnUserPoolClient, aws_cdk_lib_aws_cognito_CfnUserPoolClient_AnalyticsConfigurationProperty, aws_cdk_lib_aws_cognito_CfnUserPoolClient_TokenValidityUnitsProperty, aws_cdk_lib_aws_cognito_CfnUserPoolDomainProps, aws_cdk_lib_aws_cognito_CfnUserPoolDomain, aws_cdk_lib_aws_cognito_CfnUserPoolDomain_CustomDomainConfigTypeProperty, aws_cdk_lib_aws_cognito_CfnUserPoolGroupProps, aws_cdk_lib_aws_cognito_CfnUserPoolGroup, aws_cdk_lib_aws_cognito_CfnUserPoolIdentityProviderProps, aws_cdk_lib_aws_cognito_CfnUserPoolIdentityProvider, aws_cdk_lib_aws_cognito_CfnUserPoolResourceServerProps, aws_cdk_lib_aws_cognito_CfnUserPoolResourceServer, aws_cdk_lib_aws_cognito_CfnUserPoolResourceServer_ResourceServerScopeTypeProperty, aws_cdk_lib_aws_cognito_CfnUserPoolRiskConfigurationAttachmentProps, aws_cdk_lib_aws_cognito_CfnUserPoolRiskConfigurationAttachment, aws_cdk_lib_aws_cognito_CfnUserPoolRiskConfigurationAttachment_AccountTakeoverActionTypeProperty, aws_cdk_lib_aws_cognito_CfnUserPoolRiskConfigurationAttachment_AccountTakeoverActionsTypeProperty, aws_cdk_lib_aws_cognito_CfnUserPoolRiskConfigurationAttachment_AccountTakeoverRiskConfigurationTypeProperty, aws_cdk_lib_aws_cognito_CfnUserPoolRiskConfigurationAttachment_CompromisedCredentialsActionsTypeProperty, aws_cdk_lib_aws_cognito_CfnUserPoolRiskConfigurationAttachment_CompromisedCredentialsRiskConfigurationTypeProperty, aws_cdk_lib_aws_cognito_CfnUserPoolRiskConfigurationAttachment_NotifyConfigurationTypeProperty, aws_cdk_lib_aws_cognito_CfnUserPoolRiskConfigurationAttachment_NotifyEmailTypeProperty, aws_cdk_lib_aws_cognito_CfnUserPoolRiskConfigurationAttachment_RiskExceptionConfigurationTypeProperty, aws_cdk_lib_aws_cognito_CfnUserPoolUICustomizationAttachmentProps, aws_cdk_lib_aws_cognito_CfnUserPoolUICustomizationAttachment, aws_cdk_lib_aws_cognito_CfnUserPoolUserProps, aws_cdk_lib_aws_cognito_CfnUserPoolUser, aws_cdk_lib_aws_cognito_CfnUserPoolUser_AttributeTypeProperty, aws_cdk_lib_aws_cognito_CfnUserPoolUserToGroupAttachmentProps, aws_cdk_lib_aws_cognito_CfnUserPoolUserToGroupAttachment, aws_cdk_lib_aws_cognito_SignInAliases, aws_cdk_lib_aws_cognito_AutoVerifiedAttrs, aws_cdk_lib_aws_cognito_KeepOriginalAttrs, aws_cdk_lib_aws_cognito_UserPoolTriggers, aws_cdk_lib_aws_cognito_UserPoolOperation, aws_cdk_lib_aws_cognito_VerificationEmailStyle, aws_cdk_lib_aws_cognito_UserVerificationConfig, aws_cdk_lib_aws_cognito_UserInvitationConfig, aws_cdk_lib_aws_cognito_Mfa, aws_cdk_lib_aws_cognito_MfaSecondFactor, aws_cdk_lib_aws_cognito_PasswordPolicy, aws_cdk_lib_aws_cognito_EmailSettings, aws_cdk_lib_aws_cognito_AccountRecovery, aws_cdk_lib_aws_cognito_DeviceTracking, aws_cdk_lib_aws_cognito_AdvancedSecurityMode, aws_cdk_lib_aws_cognito_UserPoolProps, aws_cdk_lib_aws_cognito_IUserPool, aws_cdk_lib_aws_cognito_UserPool, aws_cdk_lib_aws_cognito_StandardAttributes, aws_cdk_lib_aws_cognito_StandardAttribute, aws_cdk_lib_aws_cognito_ICustomAttribute, aws_cdk_lib_aws_cognito_CustomAttributeConfig, aws_cdk_lib_aws_cognito_CustomAttributeProps, aws_cdk_lib_aws_cognito_StringAttributeConstraints, aws_cdk_lib_aws_cognito_StringAttributeProps, aws_cdk_lib_aws_cognito_StringAttribute, aws_cdk_lib_aws_cognito_NumberAttributeConstraints, aws_cdk_lib_aws_cognito_NumberAttributeProps, aws_cdk_lib_aws_cognito_NumberAttribute, aws_cdk_lib_aws_cognito_BooleanAttribute, aws_cdk_lib_aws_cognito_DateTimeAttribute, aws_cdk_lib_aws_cognito_StandardAttributesMask, aws_cdk_lib_aws_cognito_ClientAttributes, aws_cdk_lib_aws_cognito_AuthFlow, aws_cdk_lib_aws_cognito_OAuthSettings, aws_cdk_lib_aws_cognito_OAuthFlows, aws_cdk_lib_aws_cognito_OAuthScope, aws_cdk_lib_aws_cognito_UserPoolClientIdentityProvider, aws_cdk_lib_aws_cognito_UserPoolClientOptions, aws_cdk_lib_aws_cognito_UserPoolClientProps, aws_cdk_lib_aws_cognito_IUserPoolClient, aws_cdk_lib_aws_cognito_UserPoolClient, aws_cdk_lib_aws_cognito_IUserPoolDomain, aws_cdk_lib_aws_cognito_CustomDomainOptions, aws_cdk_lib_aws_cognito_CognitoDomainOptions, aws_cdk_lib_aws_cognito_UserPoolDomainOptions, aws_cdk_lib_aws_cognito_UserPoolDomainProps, aws_cdk_lib_aws_cognito_UserPoolDomain, aws_cdk_lib_aws_cognito_BaseUrlOptions, aws_cdk_lib_aws_cognito_SignInUrlOptions, aws_cdk_lib_aws_cognito_UserPoolSESOptions, aws_cdk_lib_aws_cognito_UserPoolEmail, aws_cdk_lib_aws_cognito_IUserPoolIdentityProvider, aws_cdk_lib_aws_cognito_UserPoolIdentityProvider, aws_cdk_lib_aws_cognito_ProviderAttribute, aws_cdk_lib_aws_cognito_AttributeMapping, aws_cdk_lib_aws_cognito_UserPoolIdentityProviderProps, aws_cdk_lib_aws_cognito_UserPoolIdentityProviderAppleProps, aws_cdk_lib_aws_cognito_UserPoolIdentityProviderApple, aws_cdk_lib_aws_cognito_UserPoolIdentityProviderAmazonProps, aws_cdk_lib_aws_cognito_UserPoolIdentityProviderAmazon, aws_cdk_lib_aws_cognito_UserPoolIdentityProviderFacebookProps, aws_cdk_lib_aws_cognito_UserPoolIdentityProviderFacebook, aws_cdk_lib_aws_cognito_UserPoolIdentityProviderGoogleProps, aws_cdk_lib_aws_cognito_UserPoolIdentityProviderGoogle, aws_cdk_lib_aws_cognito_UserPoolIdentityProviderOidcProps, aws_cdk_lib_aws_cognito_OidcEndpoints, aws_cdk_lib_aws_cognito_OidcAttributeRequestMethod, aws_cdk_lib_aws_cognito_UserPoolIdentityProviderOidc, aws_cdk_lib_aws_cognito_UserPoolIdentityProviderSamlProps, aws_cdk_lib_aws_cognito_UserPoolIdentityProviderSamlMetadataType, aws_cdk_lib_aws_cognito_UserPoolIdentityProviderSamlMetadata, aws_cdk_lib_aws_cognito_UserPoolIdentityProviderSaml, aws_cdk_lib_aws_cognito_IUserPoolResourceServer, aws_cdk_lib_aws_cognito_ResourceServerScopeProps, aws_cdk_lib_aws_cognito_ResourceServerScope, aws_cdk_lib_aws_cognito_UserPoolResourceServerOptions, aws_cdk_lib_aws_cognito_UserPoolResourceServerProps, aws_cdk_lib_aws_cognito_UserPoolResourceServer, aws_cdk_lib_aws_comprehend_CfnFlywheelProps, aws_cdk_lib_aws_comprehend_CfnFlywheel, aws_cdk_lib_aws_comprehend_CfnFlywheel_DataSecurityConfigProperty, aws_cdk_lib_aws_comprehend_CfnFlywheel_DocumentClassificationConfigProperty, aws_cdk_lib_aws_comprehend_CfnFlywheel_EntityRecognitionConfigProperty, aws_cdk_lib_aws_comprehend_CfnFlywheel_EntityTypesListItemProperty, aws_cdk_lib_aws_comprehend_CfnFlywheel_TaskConfigProperty, aws_cdk_lib_aws_comprehend_CfnFlywheel_VpcConfigProperty, aws_cdk_lib_aws_config_IRule, aws_cdk_lib_aws_config_RuleScope, aws_cdk_lib_aws_config_MaximumExecutionFrequency, aws_cdk_lib_aws_config_RuleProps, aws_cdk_lib_aws_config_ManagedRuleProps, aws_cdk_lib_aws_config_ManagedRule, aws_cdk_lib_aws_config_CustomRuleProps, aws_cdk_lib_aws_config_CustomRule, aws_cdk_lib_aws_config_CustomPolicyProps, aws_cdk_lib_aws_config_CustomPolicy, aws_cdk_lib_aws_config_ManagedRuleIdentifiers, aws_cdk_lib_aws_config_ResourceType, aws_cdk_lib_aws_config_AccessKeysRotatedProps, aws_cdk_lib_aws_config_AccessKeysRotated, aws_cdk_lib_aws_config_CloudFormationStackDriftDetectionCheckProps, aws_cdk_lib_aws_config_CloudFormationStackDriftDetectionCheck, aws_cdk_lib_aws_config_CloudFormationStackNotificationCheckProps, aws_cdk_lib_aws_config_CloudFormationStackNotificationCheck, aws_cdk_lib_aws_config_CfnAggregationAuthorizationProps, aws_cdk_lib_aws_config_CfnAggregationAuthorization, aws_cdk_lib_aws_config_CfnConfigRuleProps, aws_cdk_lib_aws_config_CfnConfigRule, aws_cdk_lib_aws_config_CfnConfigRule_CustomPolicyDetailsProperty, aws_cdk_lib_aws_config_CfnConfigRule_ScopeProperty, aws_cdk_lib_aws_config_CfnConfigRule_SourceProperty, aws_cdk_lib_aws_config_CfnConfigRule_SourceDetailProperty, aws_cdk_lib_aws_config_CfnConfigurationAggregatorProps, aws_cdk_lib_aws_config_CfnConfigurationAggregator, aws_cdk_lib_aws_config_CfnConfigurationAggregator_AccountAggregationSourceProperty, aws_cdk_lib_aws_config_CfnConfigurationAggregator_OrganizationAggregationSourceProperty, aws_cdk_lib_aws_config_CfnConfigurationRecorderProps, aws_cdk_lib_aws_config_CfnConfigurationRecorder, aws_cdk_lib_aws_config_CfnConfigurationRecorder_RecordingGroupProperty, aws_cdk_lib_aws_config_CfnConformancePackProps, aws_cdk_lib_aws_config_CfnConformancePack, aws_cdk_lib_aws_config_CfnConformancePack_ConformancePackInputParameterProperty, aws_cdk_lib_aws_config_CfnConformancePack_TemplateSSMDocumentDetailsProperty, aws_cdk_lib_aws_config_CfnDeliveryChannelProps, aws_cdk_lib_aws_config_CfnDeliveryChannel, aws_cdk_lib_aws_config_CfnDeliveryChannel_ConfigSnapshotDeliveryPropertiesProperty, aws_cdk_lib_aws_config_CfnOrganizationConfigRuleProps, aws_cdk_lib_aws_config_CfnOrganizationConfigRule, aws_cdk_lib_aws_config_CfnOrganizationConfigRule_OrganizationCustomPolicyRuleMetadataProperty, aws_cdk_lib_aws_config_CfnOrganizationConfigRule_OrganizationCustomRuleMetadataProperty, aws_cdk_lib_aws_config_CfnOrganizationConfigRule_OrganizationManagedRuleMetadataProperty, aws_cdk_lib_aws_config_CfnOrganizationConformancePackProps, aws_cdk_lib_aws_config_CfnOrganizationConformancePack, aws_cdk_lib_aws_config_CfnOrganizationConformancePack_ConformancePackInputParameterProperty, aws_cdk_lib_aws_config_CfnRemediationConfigurationProps, aws_cdk_lib_aws_config_CfnRemediationConfiguration, aws_cdk_lib_aws_config_CfnRemediationConfiguration_ExecutionControlsProperty, aws_cdk_lib_aws_config_CfnRemediationConfiguration_RemediationParameterValueProperty, aws_cdk_lib_aws_config_CfnRemediationConfiguration_ResourceValueProperty, aws_cdk_lib_aws_config_CfnRemediationConfiguration_SsmControlsProperty, aws_cdk_lib_aws_config_CfnRemediationConfiguration_StaticValueProperty, aws_cdk_lib_aws_config_CfnStoredQueryProps, aws_cdk_lib_aws_config_CfnStoredQuery, aws_cdk_lib_aws_connect_CfnApprovedOriginProps, aws_cdk_lib_aws_connect_CfnApprovedOrigin, aws_cdk_lib_aws_connect_CfnContactFlowProps, aws_cdk_lib_aws_connect_CfnContactFlow, aws_cdk_lib_aws_connect_CfnContactFlowModuleProps, aws_cdk_lib_aws_connect_CfnContactFlowModule, aws_cdk_lib_aws_connect_CfnEvaluationFormProps, aws_cdk_lib_aws_connect_CfnEvaluationForm, aws_cdk_lib_aws_connect_CfnEvaluationForm_EvaluationFormBaseItemProperty, aws_cdk_lib_aws_connect_CfnEvaluationForm_EvaluationFormItemProperty, aws_cdk_lib_aws_connect_CfnEvaluationForm_EvaluationFormNumericQuestionAutomationProperty, aws_cdk_lib_aws_connect_CfnEvaluationForm_EvaluationFormNumericQuestionOptionProperty, aws_cdk_lib_aws_connect_CfnEvaluationForm_EvaluationFormNumericQuestionPropertiesProperty, aws_cdk_lib_aws_connect_CfnEvaluationForm_EvaluationFormQuestionProperty, aws_cdk_lib_aws_connect_CfnEvaluationForm_EvaluationFormQuestionTypePropertiesProperty, aws_cdk_lib_aws_connect_CfnEvaluationForm_EvaluationFormSectionProperty, aws_cdk_lib_aws_connect_CfnEvaluationForm_EvaluationFormSingleSelectQuestionAutomationProperty, aws_cdk_lib_aws_connect_CfnEvaluationForm_EvaluationFormSingleSelectQuestionAutomationOptionProperty, aws_cdk_lib_aws_connect_CfnEvaluationForm_EvaluationFormSingleSelectQuestionOptionProperty, aws_cdk_lib_aws_connect_CfnEvaluationForm_EvaluationFormSingleSelectQuestionPropertiesProperty, aws_cdk_lib_aws_connect_CfnEvaluationForm_NumericQuestionPropertyValueAutomationProperty, aws_cdk_lib_aws_connect_CfnEvaluationForm_ScoringStrategyProperty, aws_cdk_lib_aws_connect_CfnEvaluationForm_SingleSelectQuestionRuleCategoryAutomationProperty, aws_cdk_lib_aws_connect_CfnHoursOfOperationProps, aws_cdk_lib_aws_connect_CfnHoursOfOperation, aws_cdk_lib_aws_connect_CfnHoursOfOperation_HoursOfOperationConfigProperty, aws_cdk_lib_aws_connect_CfnHoursOfOperation_HoursOfOperationTimeSliceProperty, aws_cdk_lib_aws_connect_CfnInstanceProps, aws_cdk_lib_aws_connect_CfnInstance, aws_cdk_lib_aws_connect_CfnInstance_AttributesProperty, aws_cdk_lib_aws_connect_CfnInstanceStorageConfigProps, aws_cdk_lib_aws_connect_CfnInstanceStorageConfig, aws_cdk_lib_aws_connect_CfnInstanceStorageConfig_EncryptionConfigProperty, aws_cdk_lib_aws_connect_CfnInstanceStorageConfig_KinesisFirehoseConfigProperty, aws_cdk_lib_aws_connect_CfnInstanceStorageConfig_KinesisStreamConfigProperty, aws_cdk_lib_aws_connect_CfnInstanceStorageConfig_KinesisVideoStreamConfigProperty, aws_cdk_lib_aws_connect_CfnInstanceStorageConfig_S3ConfigProperty, aws_cdk_lib_aws_connect_CfnIntegrationAssociationProps, aws_cdk_lib_aws_connect_CfnIntegrationAssociation, aws_cdk_lib_aws_connect_CfnPhoneNumberProps, aws_cdk_lib_aws_connect_CfnPhoneNumber, aws_cdk_lib_aws_connect_CfnQuickConnectProps, aws_cdk_lib_aws_connect_CfnQuickConnect, aws_cdk_lib_aws_connect_CfnQuickConnect_PhoneNumberQuickConnectConfigProperty, aws_cdk_lib_aws_connect_CfnQuickConnect_QueueQuickConnectConfigProperty, aws_cdk_lib_aws_connect_CfnQuickConnect_QuickConnectConfigProperty, aws_cdk_lib_aws_connect_CfnQuickConnect_UserQuickConnectConfigProperty, aws_cdk_lib_aws_connect_CfnRuleProps, aws_cdk_lib_aws_connect_CfnRule, aws_cdk_lib_aws_connect_CfnRule_ActionsProperty, aws_cdk_lib_aws_connect_CfnRule_EventBridgeActionProperty, aws_cdk_lib_aws_connect_CfnRule_NotificationRecipientTypeProperty, aws_cdk_lib_aws_connect_CfnRule_ReferenceProperty, aws_cdk_lib_aws_connect_CfnRule_RuleTriggerEventSourceProperty, aws_cdk_lib_aws_connect_CfnRule_SendNotificationActionProperty, aws_cdk_lib_aws_connect_CfnRule_TaskActionProperty, aws_cdk_lib_aws_connect_CfnSecurityKeyProps, aws_cdk_lib_aws_connect_CfnSecurityKey, aws_cdk_lib_aws_connect_CfnTaskTemplateProps, aws_cdk_lib_aws_connect_CfnTaskTemplate, aws_cdk_lib_aws_connect_CfnTaskTemplate_ConstraintsProperty, aws_cdk_lib_aws_connect_CfnTaskTemplate_DefaultFieldValueProperty, aws_cdk_lib_aws_connect_CfnTaskTemplate_FieldProperty, aws_cdk_lib_aws_connect_CfnTaskTemplate_FieldIdentifierProperty, aws_cdk_lib_aws_connect_CfnTaskTemplate_InvisibleFieldInfoProperty, aws_cdk_lib_aws_connect_CfnTaskTemplate_ReadOnlyFieldInfoProperty, aws_cdk_lib_aws_connect_CfnTaskTemplate_RequiredFieldInfoProperty, aws_cdk_lib_aws_connect_CfnUserProps, aws_cdk_lib_aws_connect_CfnUser, aws_cdk_lib_aws_connect_CfnUser_UserIdentityInfoProperty, aws_cdk_lib_aws_connect_CfnUser_UserPhoneConfigProperty, aws_cdk_lib_aws_connect_CfnUserHierarchyGroupProps, aws_cdk_lib_aws_connect_CfnUserHierarchyGroup, aws_cdk_lib_aws_connectcampaigns_CfnCampaignProps, aws_cdk_lib_aws_connectcampaigns_CfnCampaign, aws_cdk_lib_aws_connectcampaigns_CfnCampaign_AnswerMachineDetectionConfigProperty, aws_cdk_lib_aws_connectcampaigns_CfnCampaign_DialerConfigProperty, aws_cdk_lib_aws_connectcampaigns_CfnCampaign_OutboundCallConfigProperty, aws_cdk_lib_aws_connectcampaigns_CfnCampaign_PredictiveDialerConfigProperty, aws_cdk_lib_aws_connectcampaigns_CfnCampaign_ProgressiveDialerConfigProperty, aws_cdk_lib_aws_controltower_CfnEnabledControlProps, aws_cdk_lib_aws_controltower_CfnEnabledControl, aws_cdk_lib_aws_cur_CfnReportDefinitionProps, aws_cdk_lib_aws_cur_CfnReportDefinition, aws_cdk_lib_aws_customerprofiles_CfnDomainProps, aws_cdk_lib_aws_customerprofiles_CfnDomain, aws_cdk_lib_aws_customerprofiles_CfnIntegrationProps, aws_cdk_lib_aws_customerprofiles_CfnIntegration, aws_cdk_lib_aws_customerprofiles_CfnIntegration_ConnectorOperatorProperty, aws_cdk_lib_aws_customerprofiles_CfnIntegration_FlowDefinitionProperty, aws_cdk_lib_aws_customerprofiles_CfnIntegration_IncrementalPullConfigProperty, aws_cdk_lib_aws_customerprofiles_CfnIntegration_MarketoSourcePropertiesProperty, aws_cdk_lib_aws_customerprofiles_CfnIntegration_ObjectTypeMappingProperty, aws_cdk_lib_aws_customerprofiles_CfnIntegration_S3SourcePropertiesProperty, aws_cdk_lib_aws_customerprofiles_CfnIntegration_SalesforceSourcePropertiesProperty, aws_cdk_lib_aws_customerprofiles_CfnIntegration_ScheduledTriggerPropertiesProperty, aws_cdk_lib_aws_customerprofiles_CfnIntegration_ServiceNowSourcePropertiesProperty, aws_cdk_lib_aws_customerprofiles_CfnIntegration_SourceConnectorPropertiesProperty, aws_cdk_lib_aws_customerprofiles_CfnIntegration_SourceFlowConfigProperty, aws_cdk_lib_aws_customerprofiles_CfnIntegration_TaskProperty, aws_cdk_lib_aws_customerprofiles_CfnIntegration_TaskPropertiesMapProperty, aws_cdk_lib_aws_customerprofiles_CfnIntegration_TriggerConfigProperty, aws_cdk_lib_aws_customerprofiles_CfnIntegration_TriggerPropertiesProperty, aws_cdk_lib_aws_customerprofiles_CfnIntegration_ZendeskSourcePropertiesProperty, aws_cdk_lib_aws_customerprofiles_CfnObjectTypeProps, aws_cdk_lib_aws_customerprofiles_CfnObjectType, aws_cdk_lib_aws_customerprofiles_CfnObjectType_FieldMapProperty, aws_cdk_lib_aws_customerprofiles_CfnObjectType_KeyMapProperty, aws_cdk_lib_aws_customerprofiles_CfnObjectType_ObjectTypeFieldProperty, aws_cdk_lib_aws_customerprofiles_CfnObjectType_ObjectTypeKeyProperty, aws_cdk_lib_aws_databrew_CfnDatasetProps, aws_cdk_lib_aws_databrew_CfnDataset, aws_cdk_lib_aws_databrew_CfnDataset_CsvOptionsProperty, aws_cdk_lib_aws_databrew_CfnDataset_DataCatalogInputDefinitionProperty, aws_cdk_lib_aws_databrew_CfnDataset_DatabaseInputDefinitionProperty, aws_cdk_lib_aws_databrew_CfnDataset_DatasetParameterProperty, aws_cdk_lib_aws_databrew_CfnDataset_DatetimeOptionsProperty, aws_cdk_lib_aws_databrew_CfnDataset_ExcelOptionsProperty, aws_cdk_lib_aws_databrew_CfnDataset_FilesLimitProperty, aws_cdk_lib_aws_databrew_CfnDataset_FilterExpressionProperty, aws_cdk_lib_aws_databrew_CfnDataset_FilterValueProperty, aws_cdk_lib_aws_databrew_CfnDataset_FormatOptionsProperty, aws_cdk_lib_aws_databrew_CfnDataset_InputProperty, aws_cdk_lib_aws_databrew_CfnDataset_JsonOptionsProperty, aws_cdk_lib_aws_databrew_CfnDataset_MetadataProperty, aws_cdk_lib_aws_databrew_CfnDataset_PathOptionsProperty, aws_cdk_lib_aws_databrew_CfnDataset_PathParameterProperty, aws_cdk_lib_aws_databrew_CfnDataset_S3LocationProperty, aws_cdk_lib_aws_databrew_CfnJobProps, aws_cdk_lib_aws_databrew_CfnJob, aws_cdk_lib_aws_databrew_CfnJob_AllowedStatisticsProperty, aws_cdk_lib_aws_databrew_CfnJob_ColumnSelectorProperty, aws_cdk_lib_aws_databrew_CfnJob_ColumnStatisticsConfigurationProperty, aws_cdk_lib_aws_databrew_CfnJob_CsvOutputOptionsProperty, aws_cdk_lib_aws_databrew_CfnJob_DataCatalogOutputProperty, aws_cdk_lib_aws_databrew_CfnJob_DatabaseOutputProperty, aws_cdk_lib_aws_databrew_CfnJob_DatabaseTableOutputOptionsProperty, aws_cdk_lib_aws_databrew_CfnJob_EntityDetectorConfigurationProperty, aws_cdk_lib_aws_databrew_CfnJob_JobSampleProperty, aws_cdk_lib_aws_databrew_CfnJob_OutputProperty, aws_cdk_lib_aws_databrew_CfnJob_OutputFormatOptionsProperty, aws_cdk_lib_aws_databrew_CfnJob_OutputLocationProperty, aws_cdk_lib_aws_databrew_CfnJob_ProfileConfigurationProperty, aws_cdk_lib_aws_databrew_CfnJob_RecipeProperty, aws_cdk_lib_aws_databrew_CfnJob_S3LocationProperty, aws_cdk_lib_aws_databrew_CfnJob_S3TableOutputOptionsProperty, aws_cdk_lib_aws_databrew_CfnJob_StatisticOverrideProperty, aws_cdk_lib_aws_databrew_CfnJob_StatisticsConfigurationProperty, aws_cdk_lib_aws_databrew_CfnJob_ValidationConfigurationProperty, aws_cdk_lib_aws_databrew_CfnProjectProps, aws_cdk_lib_aws_databrew_CfnProject, aws_cdk_lib_aws_databrew_CfnProject_SampleProperty, aws_cdk_lib_aws_databrew_CfnRecipeProps, aws_cdk_lib_aws_databrew_CfnRecipe, aws_cdk_lib_aws_databrew_CfnRecipe_ActionProperty, aws_cdk_lib_aws_databrew_CfnRecipe_ConditionExpressionProperty, aws_cdk_lib_aws_databrew_CfnRecipe_DataCatalogInputDefinitionProperty, aws_cdk_lib_aws_databrew_CfnRecipe_InputProperty, aws_cdk_lib_aws_databrew_CfnRecipe_RecipeParametersProperty, aws_cdk_lib_aws_databrew_CfnRecipe_RecipeStepProperty, aws_cdk_lib_aws_databrew_CfnRecipe_S3LocationProperty, aws_cdk_lib_aws_databrew_CfnRecipe_SecondaryInputProperty, aws_cdk_lib_aws_databrew_CfnRulesetProps, aws_cdk_lib_aws_databrew_CfnRuleset, aws_cdk_lib_aws_databrew_CfnRuleset_ColumnSelectorProperty, aws_cdk_lib_aws_databrew_CfnRuleset_RuleProperty, aws_cdk_lib_aws_databrew_CfnRuleset_SubstitutionValueProperty, aws_cdk_lib_aws_databrew_CfnRuleset_ThresholdProperty, aws_cdk_lib_aws_databrew_CfnScheduleProps, aws_cdk_lib_aws_databrew_CfnSchedule, aws_cdk_lib_aws_datapipeline_CfnPipelineProps, aws_cdk_lib_aws_datapipeline_CfnPipeline, aws_cdk_lib_aws_datapipeline_CfnPipeline_FieldProperty, aws_cdk_lib_aws_datapipeline_CfnPipeline_ParameterAttributeProperty, aws_cdk_lib_aws_datapipeline_CfnPipeline_ParameterObjectProperty, aws_cdk_lib_aws_datapipeline_CfnPipeline_ParameterValueProperty, aws_cdk_lib_aws_datapipeline_CfnPipeline_PipelineObjectProperty, aws_cdk_lib_aws_datapipeline_CfnPipeline_PipelineTagProperty, aws_cdk_lib_aws_datasync_CfnAgentProps, aws_cdk_lib_aws_datasync_CfnAgent, aws_cdk_lib_aws_datasync_CfnLocationEFSProps, aws_cdk_lib_aws_datasync_CfnLocationEFS, aws_cdk_lib_aws_datasync_CfnLocationEFS_Ec2ConfigProperty, aws_cdk_lib_aws_datasync_CfnLocationFSxLustreProps, aws_cdk_lib_aws_datasync_CfnLocationFSxLustre, aws_cdk_lib_aws_datasync_CfnLocationFSxONTAPProps, aws_cdk_lib_aws_datasync_CfnLocationFSxONTAP, aws_cdk_lib_aws_datasync_CfnLocationFSxONTAP_NFSProperty, aws_cdk_lib_aws_datasync_CfnLocationFSxONTAP_NfsMountOptionsProperty, aws_cdk_lib_aws_datasync_CfnLocationFSxONTAP_ProtocolProperty, aws_cdk_lib_aws_datasync_CfnLocationFSxONTAP_SMBProperty, aws_cdk_lib_aws_datasync_CfnLocationFSxONTAP_SmbMountOptionsProperty, aws_cdk_lib_aws_datasync_CfnLocationFSxOpenZFSProps, aws_cdk_lib_aws_datasync_CfnLocationFSxOpenZFS, aws_cdk_lib_aws_datasync_CfnLocationFSxOpenZFS_MountOptionsProperty, aws_cdk_lib_aws_datasync_CfnLocationFSxOpenZFS_NFSProperty, aws_cdk_lib_aws_datasync_CfnLocationFSxOpenZFS_ProtocolProperty, aws_cdk_lib_aws_datasync_CfnLocationFSxWindowsProps, aws_cdk_lib_aws_datasync_CfnLocationFSxWindows, aws_cdk_lib_aws_datasync_CfnLocationHDFSProps, aws_cdk_lib_aws_datasync_CfnLocationHDFS, aws_cdk_lib_aws_datasync_CfnLocationHDFS_NameNodeProperty, aws_cdk_lib_aws_datasync_CfnLocationHDFS_QopConfigurationProperty, aws_cdk_lib_aws_datasync_CfnLocationNFSProps, aws_cdk_lib_aws_datasync_CfnLocationNFS, aws_cdk_lib_aws_datasync_CfnLocationNFS_MountOptionsProperty, aws_cdk_lib_aws_datasync_CfnLocationNFS_OnPremConfigProperty, aws_cdk_lib_aws_datasync_CfnLocationObjectStorageProps, aws_cdk_lib_aws_datasync_CfnLocationObjectStorage, aws_cdk_lib_aws_datasync_CfnLocationS3Props, aws_cdk_lib_aws_datasync_CfnLocationS3, aws_cdk_lib_aws_datasync_CfnLocationS3_S3ConfigProperty, aws_cdk_lib_aws_datasync_CfnLocationSMBProps, aws_cdk_lib_aws_datasync_CfnLocationSMB, aws_cdk_lib_aws_datasync_CfnLocationSMB_MountOptionsProperty, aws_cdk_lib_aws_datasync_CfnStorageSystemProps, aws_cdk_lib_aws_datasync_CfnStorageSystem, aws_cdk_lib_aws_datasync_CfnStorageSystem_ServerConfigurationProperty, aws_cdk_lib_aws_datasync_CfnStorageSystem_ServerCredentialsProperty, aws_cdk_lib_aws_datasync_CfnTaskProps, aws_cdk_lib_aws_datasync_CfnTask, aws_cdk_lib_aws_datasync_CfnTask_FilterRuleProperty, aws_cdk_lib_aws_datasync_CfnTask_OptionsProperty, aws_cdk_lib_aws_datasync_CfnTask_TaskScheduleProperty, aws_cdk_lib_aws_dax_CfnClusterProps, aws_cdk_lib_aws_dax_CfnCluster, aws_cdk_lib_aws_dax_CfnCluster_SSESpecificationProperty, aws_cdk_lib_aws_dax_CfnParameterGroupProps, aws_cdk_lib_aws_dax_CfnParameterGroup, aws_cdk_lib_aws_dax_CfnSubnetGroupProps, aws_cdk_lib_aws_dax_CfnSubnetGroup, aws_cdk_lib_aws_detective_CfnGraphProps, aws_cdk_lib_aws_detective_CfnGraph, aws_cdk_lib_aws_detective_CfnMemberInvitationProps, aws_cdk_lib_aws_detective_CfnMemberInvitation, aws_cdk_lib_aws_devicefarm_CfnDevicePoolProps, aws_cdk_lib_aws_devicefarm_CfnDevicePool, aws_cdk_lib_aws_devicefarm_CfnDevicePool_RuleProperty, aws_cdk_lib_aws_devicefarm_CfnInstanceProfileProps, aws_cdk_lib_aws_devicefarm_CfnInstanceProfile, aws_cdk_lib_aws_devicefarm_CfnNetworkProfileProps, aws_cdk_lib_aws_devicefarm_CfnNetworkProfile, aws_cdk_lib_aws_devicefarm_CfnProjectProps, aws_cdk_lib_aws_devicefarm_CfnProject, aws_cdk_lib_aws_devicefarm_CfnProject_VpcConfigProperty, aws_cdk_lib_aws_devicefarm_CfnTestGridProjectProps, aws_cdk_lib_aws_devicefarm_CfnTestGridProject, aws_cdk_lib_aws_devicefarm_CfnTestGridProject_VpcConfigProperty, aws_cdk_lib_aws_devicefarm_CfnVPCEConfigurationProps, aws_cdk_lib_aws_devicefarm_CfnVPCEConfiguration, aws_cdk_lib_aws_devopsguru_CfnLogAnomalyDetectionIntegration, aws_cdk_lib_aws_devopsguru_CfnNotificationChannelProps, aws_cdk_lib_aws_devopsguru_CfnNotificationChannel, aws_cdk_lib_aws_devopsguru_CfnNotificationChannel_NotificationChannelConfigProperty, aws_cdk_lib_aws_devopsguru_CfnNotificationChannel_NotificationFilterConfigProperty, aws_cdk_lib_aws_devopsguru_CfnNotificationChannel_SnsChannelConfigProperty, aws_cdk_lib_aws_devopsguru_CfnResourceCollectionProps, aws_cdk_lib_aws_devopsguru_CfnResourceCollection, aws_cdk_lib_aws_devopsguru_CfnResourceCollection_CloudFormationCollectionFilterProperty, aws_cdk_lib_aws_devopsguru_CfnResourceCollection_ResourceCollectionFilterProperty, aws_cdk_lib_aws_devopsguru_CfnResourceCollection_TagCollectionProperty, aws_cdk_lib_aws_directoryservice_CfnMicrosoftADProps, aws_cdk_lib_aws_directoryservice_CfnMicrosoftAD, aws_cdk_lib_aws_directoryservice_CfnMicrosoftAD_VpcSettingsProperty, aws_cdk_lib_aws_directoryservice_CfnSimpleADProps, aws_cdk_lib_aws_directoryservice_CfnSimpleAD, aws_cdk_lib_aws_directoryservice_CfnSimpleAD_VpcSettingsProperty, aws_cdk_lib_aws_dlm_CfnLifecyclePolicyProps, aws_cdk_lib_aws_dlm_CfnLifecyclePolicy, aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_ActionProperty, aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_ArchiveRetainRuleProperty, aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_ArchiveRuleProperty, aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_CreateRuleProperty, aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_CrossRegionCopyActionProperty, aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_CrossRegionCopyDeprecateRuleProperty, aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_CrossRegionCopyRetainRuleProperty, aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_CrossRegionCopyRuleProperty, aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_DeprecateRuleProperty, aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_EncryptionConfigurationProperty, aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_EventParametersProperty, aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_EventSourceProperty, aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_FastRestoreRuleProperty, aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_ParametersProperty, aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_PolicyDetailsProperty, aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_RetainRuleProperty, aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_RetentionArchiveTierProperty, aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_ScheduleProperty, aws_cdk_lib_aws_dlm_CfnLifecyclePolicy_ShareRuleProperty, aws_cdk_lib_aws_dms_CfnCertificateProps, aws_cdk_lib_aws_dms_CfnCertificate, aws_cdk_lib_aws_dms_CfnEndpointProps, aws_cdk_lib_aws_dms_CfnEndpoint, aws_cdk_lib_aws_dms_CfnEndpoint_DocDbSettingsProperty, aws_cdk_lib_aws_dms_CfnEndpoint_DynamoDbSettingsProperty, aws_cdk_lib_aws_dms_CfnEndpoint_ElasticsearchSettingsProperty, aws_cdk_lib_aws_dms_CfnEndpoint_GcpMySQLSettingsProperty, aws_cdk_lib_aws_dms_CfnEndpoint_IbmDb2SettingsProperty, aws_cdk_lib_aws_dms_CfnEndpoint_KafkaSettingsProperty, aws_cdk_lib_aws_dms_CfnEndpoint_KinesisSettingsProperty, aws_cdk_lib_aws_dms_CfnEndpoint_MicrosoftSqlServerSettingsProperty, aws_cdk_lib_aws_dms_CfnEndpoint_MongoDbSettingsProperty, aws_cdk_lib_aws_dms_CfnEndpoint_MySqlSettingsProperty, aws_cdk_lib_aws_dms_CfnEndpoint_NeptuneSettingsProperty, aws_cdk_lib_aws_dms_CfnEndpoint_OracleSettingsProperty, aws_cdk_lib_aws_dms_CfnEndpoint_PostgreSqlSettingsProperty, aws_cdk_lib_aws_dms_CfnEndpoint_RedisSettingsProperty, aws_cdk_lib_aws_dms_CfnEndpoint_RedshiftSettingsProperty, aws_cdk_lib_aws_dms_CfnEndpoint_S3SettingsProperty, aws_cdk_lib_aws_dms_CfnEndpoint_SybaseSettingsProperty, aws_cdk_lib_aws_dms_CfnEventSubscriptionProps, aws_cdk_lib_aws_dms_CfnEventSubscription, aws_cdk_lib_aws_dms_CfnReplicationInstanceProps, aws_cdk_lib_aws_dms_CfnReplicationInstance, aws_cdk_lib_aws_dms_CfnReplicationSubnetGroupProps, aws_cdk_lib_aws_dms_CfnReplicationSubnetGroup, aws_cdk_lib_aws_dms_CfnReplicationTaskProps, aws_cdk_lib_aws_dms_CfnReplicationTask, aws_cdk_lib_aws_docdb_DatabaseClusterProps, aws_cdk_lib_aws_docdb_DatabaseCluster, aws_cdk_lib_aws_docdb_IDatabaseCluster, aws_cdk_lib_aws_docdb_DatabaseClusterAttributes, aws_cdk_lib_aws_docdb_DatabaseSecretProps, aws_cdk_lib_aws_docdb_DatabaseSecret, aws_cdk_lib_aws_docdb_Endpoint, aws_cdk_lib_aws_docdb_IDatabaseInstance, aws_cdk_lib_aws_docdb_DatabaseInstanceAttributes, aws_cdk_lib_aws_docdb_DatabaseInstanceProps, aws_cdk_lib_aws_docdb_DatabaseInstance, aws_cdk_lib_aws_docdb_IClusterParameterGroup, aws_cdk_lib_aws_docdb_ClusterParameterGroupProps, aws_cdk_lib_aws_docdb_ClusterParameterGroup, aws_cdk_lib_aws_docdb_BackupProps, aws_cdk_lib_aws_docdb_Login, aws_cdk_lib_aws_docdb_RotationMultiUserOptions, aws_cdk_lib_aws_docdb_CfnDBClusterProps, aws_cdk_lib_aws_docdb_CfnDBCluster, aws_cdk_lib_aws_docdb_CfnDBClusterParameterGroupProps, aws_cdk_lib_aws_docdb_CfnDBClusterParameterGroup, aws_cdk_lib_aws_docdb_CfnDBInstanceProps, aws_cdk_lib_aws_docdb_CfnDBInstance, aws_cdk_lib_aws_docdb_CfnDBSubnetGroupProps, aws_cdk_lib_aws_docdb_CfnDBSubnetGroup, aws_cdk_lib_aws_docdbelastic_CfnClusterProps, aws_cdk_lib_aws_docdbelastic_CfnCluster, aws_cdk_lib_aws_dynamodb_CfnGlobalTableProps, aws_cdk_lib_aws_dynamodb_CfnGlobalTable, aws_cdk_lib_aws_dynamodb_CfnGlobalTable_AttributeDefinitionProperty, aws_cdk_lib_aws_dynamodb_CfnGlobalTable_CapacityAutoScalingSettingsProperty, aws_cdk_lib_aws_dynamodb_CfnGlobalTable_ContributorInsightsSpecificationProperty, aws_cdk_lib_aws_dynamodb_CfnGlobalTable_GlobalSecondaryIndexProperty, aws_cdk_lib_aws_dynamodb_CfnGlobalTable_KeySchemaProperty, aws_cdk_lib_aws_dynamodb_CfnGlobalTable_KinesisStreamSpecificationProperty, aws_cdk_lib_aws_dynamodb_CfnGlobalTable_LocalSecondaryIndexProperty, aws_cdk_lib_aws_dynamodb_CfnGlobalTable_PointInTimeRecoverySpecificationProperty, aws_cdk_lib_aws_dynamodb_CfnGlobalTable_ProjectionProperty, aws_cdk_lib_aws_dynamodb_CfnGlobalTable_ReadProvisionedThroughputSettingsProperty, aws_cdk_lib_aws_dynamodb_CfnGlobalTable_ReplicaGlobalSecondaryIndexSpecificationProperty, aws_cdk_lib_aws_dynamodb_CfnGlobalTable_ReplicaSSESpecificationProperty, aws_cdk_lib_aws_dynamodb_CfnGlobalTable_ReplicaSpecificationProperty, aws_cdk_lib_aws_dynamodb_CfnGlobalTable_SSESpecificationProperty, aws_cdk_lib_aws_dynamodb_CfnGlobalTable_StreamSpecificationProperty, aws_cdk_lib_aws_dynamodb_CfnGlobalTable_TargetTrackingScalingPolicyConfigurationProperty, aws_cdk_lib_aws_dynamodb_CfnGlobalTable_TimeToLiveSpecificationProperty, aws_cdk_lib_aws_dynamodb_CfnGlobalTable_WriteProvisionedThroughputSettingsProperty, aws_cdk_lib_aws_dynamodb_CfnTableProps, aws_cdk_lib_aws_dynamodb_CfnTable, aws_cdk_lib_aws_dynamodb_CfnTable_AttributeDefinitionProperty, aws_cdk_lib_aws_dynamodb_CfnTable_ContributorInsightsSpecificationProperty, aws_cdk_lib_aws_dynamodb_CfnTable_CsvProperty, aws_cdk_lib_aws_dynamodb_CfnTable_GlobalSecondaryIndexProperty, aws_cdk_lib_aws_dynamodb_CfnTable_ImportSourceSpecificationProperty, aws_cdk_lib_aws_dynamodb_CfnTable_InputFormatOptionsProperty, aws_cdk_lib_aws_dynamodb_CfnTable_KeySchemaProperty, aws_cdk_lib_aws_dynamodb_CfnTable_KinesisStreamSpecificationProperty, aws_cdk_lib_aws_dynamodb_CfnTable_LocalSecondaryIndexProperty, aws_cdk_lib_aws_dynamodb_CfnTable_PointInTimeRecoverySpecificationProperty, aws_cdk_lib_aws_dynamodb_CfnTable_ProjectionProperty, aws_cdk_lib_aws_dynamodb_CfnTable_ProvisionedThroughputProperty, aws_cdk_lib_aws_dynamodb_CfnTable_S3BucketSourceProperty, aws_cdk_lib_aws_dynamodb_CfnTable_SSESpecificationProperty, aws_cdk_lib_aws_dynamodb_CfnTable_StreamSpecificationProperty, aws_cdk_lib_aws_dynamodb_CfnTable_TimeToLiveSpecificationProperty, aws_cdk_lib_aws_dynamodb_SystemErrorsForOperationsMetricOptions, aws_cdk_lib_aws_dynamodb_OperationsMetricOptions, aws_cdk_lib_aws_dynamodb_Operation, aws_cdk_lib_aws_dynamodb_Attribute, aws_cdk_lib_aws_dynamodb_TableEncryption, aws_cdk_lib_aws_dynamodb_SchemaOptions, aws_cdk_lib_aws_dynamodb_TableOptions, aws_cdk_lib_aws_dynamodb_TableProps, aws_cdk_lib_aws_dynamodb_SecondaryIndexProps, aws_cdk_lib_aws_dynamodb_GlobalSecondaryIndexProps, aws_cdk_lib_aws_dynamodb_LocalSecondaryIndexProps, aws_cdk_lib_aws_dynamodb_ITable, aws_cdk_lib_aws_dynamodb_TableAttributes, aws_cdk_lib_aws_dynamodb_Table, aws_cdk_lib_aws_dynamodb_AttributeType, aws_cdk_lib_aws_dynamodb_BillingMode, aws_cdk_lib_aws_dynamodb_ProjectionType, aws_cdk_lib_aws_dynamodb_StreamViewType, aws_cdk_lib_aws_dynamodb_TableClass, aws_cdk_lib_aws_dynamodb_IScalableTableAttribute, aws_cdk_lib_aws_dynamodb_EnableScalingProps, aws_cdk_lib_aws_dynamodb_UtilizationScalingProps, aws_cdk_lib_aws_ec2_InstanceRequireImdsv2AspectProps, aws_cdk_lib_aws_ec2_InstanceRequireImdsv2Aspect, aws_cdk_lib_aws_ec2_LaunchTemplateRequireImdsv2AspectProps, aws_cdk_lib_aws_ec2_LaunchTemplateRequireImdsv2Aspect, aws_cdk_lib_aws_ec2_BastionHostLinuxProps, aws_cdk_lib_aws_ec2_BastionHostLinux, aws_cdk_lib_aws_ec2_IConnectable, aws_cdk_lib_aws_ec2_ConnectionsProps, aws_cdk_lib_aws_ec2_Connections, aws_cdk_lib_aws_ec2_CloudFormationInit, aws_cdk_lib_aws_ec2_InitConfig, aws_cdk_lib_aws_ec2_ConfigSetProps, aws_cdk_lib_aws_ec2_AttachInitOptions, aws_cdk_lib_aws_ec2_InitServiceRestartHandle, aws_cdk_lib_aws_ec2_InitElement, aws_cdk_lib_aws_ec2_InitCommandOptions, aws_cdk_lib_aws_ec2_InitCommandWaitDuration, aws_cdk_lib_aws_ec2_InitCommand, aws_cdk_lib_aws_ec2_InitFileOptions, aws_cdk_lib_aws_ec2_InitFileAssetOptions, aws_cdk_lib_aws_ec2_InitFile, aws_cdk_lib_aws_ec2_InitGroup, aws_cdk_lib_aws_ec2_InitUserOptions, aws_cdk_lib_aws_ec2_InitUser, aws_cdk_lib_aws_ec2_LocationPackageOptions, aws_cdk_lib_aws_ec2_NamedPackageOptions, aws_cdk_lib_aws_ec2_InitPackage, aws_cdk_lib_aws_ec2_InitServiceOptions, aws_cdk_lib_aws_ec2_InitService, aws_cdk_lib_aws_ec2_InitSourceOptions, aws_cdk_lib_aws_ec2_InitSourceAssetOptions, aws_cdk_lib_aws_ec2_InitSource, aws_cdk_lib_aws_ec2_ServiceManager, aws_cdk_lib_aws_ec2_SystemdConfigFileOptions, aws_cdk_lib_aws_ec2_InstanceClass, aws_cdk_lib_aws_ec2_InstanceArchitecture, aws_cdk_lib_aws_ec2_InstanceSize, aws_cdk_lib_aws_ec2_InstanceType, aws_cdk_lib_aws_ec2_IInstance, aws_cdk_lib_aws_ec2_InstanceProps, aws_cdk_lib_aws_ec2_Instance, aws_cdk_lib_aws_ec2_ApplyCloudFormationInitOptions, aws_cdk_lib_aws_ec2_CpuCredits, aws_cdk_lib_aws_ec2_InstanceInitiatedShutdownBehavior, aws_cdk_lib_aws_ec2_ILaunchTemplate, aws_cdk_lib_aws_ec2_SpotInstanceInterruption, aws_cdk_lib_aws_ec2_SpotRequestType, aws_cdk_lib_aws_ec2_LaunchTemplateSpotOptions, aws_cdk_lib_aws_ec2_LaunchTemplateHttpTokens, aws_cdk_lib_aws_ec2_LaunchTemplateProps, aws_cdk_lib_aws_ec2_LaunchTemplateSpecialVersions, aws_cdk_lib_aws_ec2_LaunchTemplateAttributes, aws_cdk_lib_aws_ec2_LaunchTemplate, aws_cdk_lib_aws_ec2_AmazonLinuxImageSsmParameterCommonOptions, aws_cdk_lib_aws_ec2_AmazonLinuxImageSsmParameterBaseOptions, aws_cdk_lib_aws_ec2_AmazonLinuxImageSsmParameterBaseProps, aws_cdk_lib_aws_ec2_AmazonLinuxImageSsmParameterBase, aws_cdk_lib_aws_ec2_AmazonLinuxGeneration, aws_cdk_lib_aws_ec2_IMachineImage, aws_cdk_lib_aws_ec2_MachineImageConfig, aws_cdk_lib_aws_ec2_OperatingSystemType, aws_cdk_lib_aws_ec2_AmazonLinuxCpuType, aws_cdk_lib_aws_ec2_AmazonLinuxEdition, aws_cdk_lib_aws_ec2_AmazonLinuxVirt, aws_cdk_lib_aws_ec2_AmazonLinuxStorage, aws_cdk_lib_aws_ec2_AmazonLinux2Kernel, aws_cdk_lib_aws_ec2_AmazonLinux2ImageSsmParameterProps, aws_cdk_lib_aws_ec2_AmazonLinux2ImageSsmParameter, aws_cdk_lib_aws_ec2_MachineImage, aws_cdk_lib_aws_ec2_GenericSSMParameterImage, aws_cdk_lib_aws_ec2_SsmParameterImageOptions, aws_cdk_lib_aws_ec2_WindowsImageProps, aws_cdk_lib_aws_ec2_WindowsImage, aws_cdk_lib_aws_ec2_AmazonLinuxImageProps, aws_cdk_lib_aws_ec2_AmazonLinuxImage, aws_cdk_lib_aws_ec2_AmazonLinuxKernel, aws_cdk_lib_aws_ec2_GenericLinuxImageProps, aws_cdk_lib_aws_ec2_GenericWindowsImageProps, aws_cdk_lib_aws_ec2_GenericLinuxImage, aws_cdk_lib_aws_ec2_GenericWindowsImage, aws_cdk_lib_aws_ec2_LookupMachineImage, aws_cdk_lib_aws_ec2_LookupMachineImageProps, aws_cdk_lib_aws_ec2_AmazonLinux2022Kernel, aws_cdk_lib_aws_ec2_AmazonLinux2022ImageSsmParameterProps, aws_cdk_lib_aws_ec2_AmazonLinux2022ImageSsmParameter, aws_cdk_lib_aws_ec2_AmazonLinux2023Kernel, aws_cdk_lib_aws_ec2_AmazonLinux2023ImageSsmParameterProps, aws_cdk_lib_aws_ec2_AmazonLinux2023ImageSsmParameter, aws_cdk_lib_aws_ec2_NatTrafficDirection, aws_cdk_lib_aws_ec2_GatewayConfig, aws_cdk_lib_aws_ec2_NatProvider, aws_cdk_lib_aws_ec2_ConfigureNatOptions, aws_cdk_lib_aws_ec2_NatGatewayProps, aws_cdk_lib_aws_ec2_NatInstanceProps, aws_cdk_lib_aws_ec2_NatInstanceProvider, aws_cdk_lib_aws_ec2_NatInstanceImage, aws_cdk_lib_aws_ec2_INetworkAcl, aws_cdk_lib_aws_ec2_NetworkAclProps, aws_cdk_lib_aws_ec2_NetworkAcl, aws_cdk_lib_aws_ec2_Action, aws_cdk_lib_aws_ec2_INetworkAclEntry, aws_cdk_lib_aws_ec2_TrafficDirection, aws_cdk_lib_aws_ec2_CommonNetworkAclEntryOptions, aws_cdk_lib_aws_ec2_NetworkAclEntryProps, aws_cdk_lib_aws_ec2_NetworkAclEntry, aws_cdk_lib_aws_ec2_ISubnetNetworkAclAssociation, aws_cdk_lib_aws_ec2_SubnetNetworkAclAssociationProps, aws_cdk_lib_aws_ec2_SubnetNetworkAclAssociation, aws_cdk_lib_aws_ec2_AclCidr, aws_cdk_lib_aws_ec2_AclCidrConfig, aws_cdk_lib_aws_ec2_AclTraffic, aws_cdk_lib_aws_ec2_AclTrafficConfig, aws_cdk_lib_aws_ec2_AclIcmp, aws_cdk_lib_aws_ec2_AclPortRange, aws_cdk_lib_aws_ec2_Protocol, aws_cdk_lib_aws_ec2_PortProps, aws_cdk_lib_aws_ec2_Port, aws_cdk_lib_aws_ec2_IPrefixList, aws_cdk_lib_aws_ec2_AddressFamily, aws_cdk_lib_aws_ec2_PrefixListOptions, aws_cdk_lib_aws_ec2_PrefixListProps, aws_cdk_lib_aws_ec2_PrefixList, aws_cdk_lib_aws_ec2_ISecurityGroup, aws_cdk_lib_aws_ec2_RuleScope, aws_cdk_lib_aws_ec2_SecurityGroupProps, aws_cdk_lib_aws_ec2_SecurityGroupImportOptions, aws_cdk_lib_aws_ec2_SecurityGroup, aws_cdk_lib_aws_ec2_ConnectionRule, aws_cdk_lib_aws_ec2_SubnetFilter, aws_cdk_lib_aws_ec2_IPeer, aws_cdk_lib_aws_ec2_Peer, aws_cdk_lib_aws_ec2_BlockDevice, aws_cdk_lib_aws_ec2_EbsDeviceOptionsBase, aws_cdk_lib_aws_ec2_EbsDeviceOptions, aws_cdk_lib_aws_ec2_EbsDeviceSnapshotOptions, aws_cdk_lib_aws_ec2_EbsDeviceProps, aws_cdk_lib_aws_ec2_BlockDeviceVolume, aws_cdk_lib_aws_ec2_EbsDeviceVolumeType, aws_cdk_lib_aws_ec2_IVolume, aws_cdk_lib_aws_ec2_VolumeProps, aws_cdk_lib_aws_ec2_VolumeAttributes, aws_cdk_lib_aws_ec2_Volume, aws_cdk_lib_aws_ec2_ISubnet, aws_cdk_lib_aws_ec2_IRouteTable, aws_cdk_lib_aws_ec2_IVpc, aws_cdk_lib_aws_ec2_SubnetType, aws_cdk_lib_aws_ec2_SubnetSelection, aws_cdk_lib_aws_ec2_SelectedSubnets, aws_cdk_lib_aws_ec2_VpcAttributes, aws_cdk_lib_aws_ec2_SubnetAttributes, aws_cdk_lib_aws_ec2_VpcProps, aws_cdk_lib_aws_ec2_DefaultInstanceTenancy, aws_cdk_lib_aws_ec2_SubnetConfiguration, aws_cdk_lib_aws_ec2_Vpc, aws_cdk_lib_aws_ec2_SubnetProps, aws_cdk_lib_aws_ec2_Subnet, aws_cdk_lib_aws_ec2_AddRouteOptions, aws_cdk_lib_aws_ec2_RouterType, aws_cdk_lib_aws_ec2_PublicSubnetProps, aws_cdk_lib_aws_ec2_IPublicSubnet, aws_cdk_lib_aws_ec2_PublicSubnetAttributes, aws_cdk_lib_aws_ec2_PublicSubnet, aws_cdk_lib_aws_ec2_PrivateSubnetProps, aws_cdk_lib_aws_ec2_IPrivateSubnet, aws_cdk_lib_aws_ec2_PrivateSubnetAttributes, aws_cdk_lib_aws_ec2_PrivateSubnet, aws_cdk_lib_aws_ec2_VpcLookupOptions, aws_cdk_lib_aws_ec2_IVpnConnection, aws_cdk_lib_aws_ec2_IVpnGateway, aws_cdk_lib_aws_ec2_VpnTunnelOption, aws_cdk_lib_aws_ec2_VpnConnectionOptions, aws_cdk_lib_aws_ec2_VpnGatewayProps, aws_cdk_lib_aws_ec2_EnableVpnGatewayOptions, aws_cdk_lib_aws_ec2_VpnConnectionProps, aws_cdk_lib_aws_ec2_VpnConnectionType, aws_cdk_lib_aws_ec2_VpnGateway, aws_cdk_lib_aws_ec2_VpnConnectionAttributes, aws_cdk_lib_aws_ec2_VpnConnectionBase, aws_cdk_lib_aws_ec2_VpnConnection, aws_cdk_lib_aws_ec2_IVpcEndpoint, aws_cdk_lib_aws_ec2_VpcEndpoint, aws_cdk_lib_aws_ec2_IGatewayVpcEndpoint, aws_cdk_lib_aws_ec2_VpcEndpointType, aws_cdk_lib_aws_ec2_IGatewayVpcEndpointService, aws_cdk_lib_aws_ec2_GatewayVpcEndpointAwsService, aws_cdk_lib_aws_ec2_GatewayVpcEndpointOptions, aws_cdk_lib_aws_ec2_GatewayVpcEndpointProps, aws_cdk_lib_aws_ec2_GatewayVpcEndpoint, aws_cdk_lib_aws_ec2_IInterfaceVpcEndpointService, aws_cdk_lib_aws_ec2_InterfaceVpcEndpointService, aws_cdk_lib_aws_ec2_InterfaceVpcEndpointAwsService, aws_cdk_lib_aws_ec2_InterfaceVpcEndpointOptions, aws_cdk_lib_aws_ec2_InterfaceVpcEndpointProps, aws_cdk_lib_aws_ec2_IInterfaceVpcEndpoint, aws_cdk_lib_aws_ec2_InterfaceVpcEndpoint, aws_cdk_lib_aws_ec2_InterfaceVpcEndpointAttributes, aws_cdk_lib_aws_ec2_IVpcEndpointServiceLoadBalancer, aws_cdk_lib_aws_ec2_IVpcEndpointService, aws_cdk_lib_aws_ec2_VpcEndpointService, aws_cdk_lib_aws_ec2_VpcEndpointServiceProps, aws_cdk_lib_aws_ec2_LinuxUserDataOptions, aws_cdk_lib_aws_ec2_WindowsUserDataOptions, aws_cdk_lib_aws_ec2_S3DownloadOptions, aws_cdk_lib_aws_ec2_ExecuteFileOptions, aws_cdk_lib_aws_ec2_UserData, aws_cdk_lib_aws_ec2_MultipartBodyOptions, aws_cdk_lib_aws_ec2_MultipartBody, aws_cdk_lib_aws_ec2_MultipartUserDataOptions, aws_cdk_lib_aws_ec2_MultipartUserData, aws_cdk_lib_aws_ec2_WindowsVersion, aws_cdk_lib_aws_ec2_IFlowLog, aws_cdk_lib_aws_ec2_FlowLogTrafficType, aws_cdk_lib_aws_ec2_FlowLogDestinationType, aws_cdk_lib_aws_ec2_FlowLogResourceType, aws_cdk_lib_aws_ec2_FlowLogFileFormat, aws_cdk_lib_aws_ec2_S3DestinationOptions, aws_cdk_lib_aws_ec2_DestinationOptions, aws_cdk_lib_aws_ec2_FlowLogDestination, aws_cdk_lib_aws_ec2_FlowLogDestinationConfig, aws_cdk_lib_aws_ec2_FlowLogMaxAggregationInterval, aws_cdk_lib_aws_ec2_LogFormat, aws_cdk_lib_aws_ec2_FlowLogOptions, aws_cdk_lib_aws_ec2_FlowLogProps, aws_cdk_lib_aws_ec2_FlowLog, aws_cdk_lib_aws_ec2_IClientVpnEndpoint, aws_cdk_lib_aws_ec2_IClientVpnConnectionHandler, aws_cdk_lib_aws_ec2_TransportProtocol, aws_cdk_lib_aws_ec2_VpnPort, aws_cdk_lib_aws_ec2_ClientVpnEndpointOptions, aws_cdk_lib_aws_ec2_ClientVpnSessionTimeout, aws_cdk_lib_aws_ec2_ClientVpnUserBasedAuthentication, aws_cdk_lib_aws_ec2_ClientVpnEndpointProps, aws_cdk_lib_aws_ec2_ClientVpnEndpointAttributes, aws_cdk_lib_aws_ec2_ClientVpnEndpoint, aws_cdk_lib_aws_ec2_ClientVpnAuthorizationRuleOptions, aws_cdk_lib_aws_ec2_ClientVpnAuthorizationRuleProps, aws_cdk_lib_aws_ec2_ClientVpnAuthorizationRule, aws_cdk_lib_aws_ec2_ClientVpnRouteOptions, aws_cdk_lib_aws_ec2_ClientVpnRouteTarget, aws_cdk_lib_aws_ec2_ClientVpnRouteProps, aws_cdk_lib_aws_ec2_ClientVpnRoute, aws_cdk_lib_aws_ec2_IpAddresses, aws_cdk_lib_aws_ec2_IIpAddresses, aws_cdk_lib_aws_ec2_VpcIpamOptions, aws_cdk_lib_aws_ec2_RequestedSubnet, aws_cdk_lib_aws_ec2_AllocateCidrRequest, aws_cdk_lib_aws_ec2_SubnetIpamOptions, aws_cdk_lib_aws_ec2_AllocatedSubnet, aws_cdk_lib_aws_ec2_AwsIpamProps, aws_cdk_lib_aws_ec2_IPlacementGroup, aws_cdk_lib_aws_ec2_PlacementGroupProps, aws_cdk_lib_aws_ec2_PlacementGroupSpreadLevel, aws_cdk_lib_aws_ec2_PlacementGroupStrategy, aws_cdk_lib_aws_ec2_PlacementGroup, aws_cdk_lib_aws_ec2_CfnCapacityReservationProps, aws_cdk_lib_aws_ec2_CfnCapacityReservation, aws_cdk_lib_aws_ec2_CfnCapacityReservation_TagSpecificationProperty, aws_cdk_lib_aws_ec2_CfnCapacityReservationFleetProps, aws_cdk_lib_aws_ec2_CfnCapacityReservationFleet, aws_cdk_lib_aws_ec2_CfnCapacityReservationFleet_InstanceTypeSpecificationProperty, aws_cdk_lib_aws_ec2_CfnCapacityReservationFleet_TagSpecificationProperty, aws_cdk_lib_aws_ec2_CfnCarrierGatewayProps, aws_cdk_lib_aws_ec2_CfnCarrierGateway, aws_cdk_lib_aws_ec2_CfnClientVpnAuthorizationRuleProps, aws_cdk_lib_aws_ec2_CfnClientVpnAuthorizationRule, aws_cdk_lib_aws_ec2_CfnClientVpnEndpointProps, aws_cdk_lib_aws_ec2_CfnClientVpnEndpoint, aws_cdk_lib_aws_ec2_CfnClientVpnEndpoint_CertificateAuthenticationRequestProperty, aws_cdk_lib_aws_ec2_CfnClientVpnEndpoint_ClientAuthenticationRequestProperty, aws_cdk_lib_aws_ec2_CfnClientVpnEndpoint_ClientConnectOptionsProperty, aws_cdk_lib_aws_ec2_CfnClientVpnEndpoint_ClientLoginBannerOptionsProperty, aws_cdk_lib_aws_ec2_CfnClientVpnEndpoint_ConnectionLogOptionsProperty, aws_cdk_lib_aws_ec2_CfnClientVpnEndpoint_DirectoryServiceAuthenticationRequestProperty, aws_cdk_lib_aws_ec2_CfnClientVpnEndpoint_FederatedAuthenticationRequestProperty, aws_cdk_lib_aws_ec2_CfnClientVpnEndpoint_TagSpecificationProperty, aws_cdk_lib_aws_ec2_CfnClientVpnRouteProps, aws_cdk_lib_aws_ec2_CfnClientVpnRoute, aws_cdk_lib_aws_ec2_CfnClientVpnTargetNetworkAssociationProps, aws_cdk_lib_aws_ec2_CfnClientVpnTargetNetworkAssociation, aws_cdk_lib_aws_ec2_CfnCustomerGatewayProps, aws_cdk_lib_aws_ec2_CfnCustomerGateway, aws_cdk_lib_aws_ec2_CfnDHCPOptionsProps, aws_cdk_lib_aws_ec2_CfnDHCPOptions, aws_cdk_lib_aws_ec2_CfnEC2FleetProps, aws_cdk_lib_aws_ec2_CfnEC2Fleet, aws_cdk_lib_aws_ec2_CfnEC2Fleet_AcceleratorCountRequestProperty, aws_cdk_lib_aws_ec2_CfnEC2Fleet_AcceleratorTotalMemoryMiBRequestProperty, aws_cdk_lib_aws_ec2_CfnEC2Fleet_BaselineEbsBandwidthMbpsRequestProperty, aws_cdk_lib_aws_ec2_CfnEC2Fleet_CapacityRebalanceProperty, aws_cdk_lib_aws_ec2_CfnEC2Fleet_CapacityReservationOptionsRequestProperty, aws_cdk_lib_aws_ec2_CfnEC2Fleet_FleetLaunchTemplateConfigRequestProperty, aws_cdk_lib_aws_ec2_CfnEC2Fleet_FleetLaunchTemplateOverridesRequestProperty, aws_cdk_lib_aws_ec2_CfnEC2Fleet_FleetLaunchTemplateSpecificationRequestProperty, aws_cdk_lib_aws_ec2_CfnEC2Fleet_InstanceRequirementsRequestProperty, aws_cdk_lib_aws_ec2_CfnEC2Fleet_MaintenanceStrategiesProperty, aws_cdk_lib_aws_ec2_CfnEC2Fleet_MemoryGiBPerVCpuRequestProperty, aws_cdk_lib_aws_ec2_CfnEC2Fleet_MemoryMiBRequestProperty, aws_cdk_lib_aws_ec2_CfnEC2Fleet_NetworkBandwidthGbpsRequestProperty, aws_cdk_lib_aws_ec2_CfnEC2Fleet_NetworkInterfaceCountRequestProperty, aws_cdk_lib_aws_ec2_CfnEC2Fleet_OnDemandOptionsRequestProperty, aws_cdk_lib_aws_ec2_CfnEC2Fleet_PlacementProperty, aws_cdk_lib_aws_ec2_CfnEC2Fleet_SpotOptionsRequestProperty, aws_cdk_lib_aws_ec2_CfnEC2Fleet_TagSpecificationProperty, aws_cdk_lib_aws_ec2_CfnEC2Fleet_TargetCapacitySpecificationRequestProperty, aws_cdk_lib_aws_ec2_CfnEC2Fleet_TotalLocalStorageGBRequestProperty, aws_cdk_lib_aws_ec2_CfnEC2Fleet_VCpuCountRangeRequestProperty, aws_cdk_lib_aws_ec2_CfnEIPProps, aws_cdk_lib_aws_ec2_CfnEIP, aws_cdk_lib_aws_ec2_CfnEIPAssociationProps, aws_cdk_lib_aws_ec2_CfnEIPAssociation, aws_cdk_lib_aws_ec2_CfnEgressOnlyInternetGatewayProps, aws_cdk_lib_aws_ec2_CfnEgressOnlyInternetGateway, aws_cdk_lib_aws_ec2_CfnEnclaveCertificateIamRoleAssociationProps, aws_cdk_lib_aws_ec2_CfnEnclaveCertificateIamRoleAssociation, aws_cdk_lib_aws_ec2_CfnFlowLogProps, aws_cdk_lib_aws_ec2_CfnFlowLog, aws_cdk_lib_aws_ec2_CfnFlowLog_DestinationOptionsProperty, aws_cdk_lib_aws_ec2_CfnGatewayRouteTableAssociationProps, aws_cdk_lib_aws_ec2_CfnGatewayRouteTableAssociation, aws_cdk_lib_aws_ec2_CfnHostProps, aws_cdk_lib_aws_ec2_CfnHost, aws_cdk_lib_aws_ec2_CfnIPAMProps, aws_cdk_lib_aws_ec2_CfnIPAM, aws_cdk_lib_aws_ec2_CfnIPAM_IpamOperatingRegionProperty, aws_cdk_lib_aws_ec2_CfnIPAMAllocationProps, aws_cdk_lib_aws_ec2_CfnIPAMAllocation, aws_cdk_lib_aws_ec2_CfnIPAMPoolProps, aws_cdk_lib_aws_ec2_CfnIPAMPool, aws_cdk_lib_aws_ec2_CfnIPAMPool_ProvisionedCidrProperty, aws_cdk_lib_aws_ec2_CfnIPAMPoolCidrProps, aws_cdk_lib_aws_ec2_CfnIPAMPoolCidr, aws_cdk_lib_aws_ec2_CfnIPAMResourceDiscoveryProps, aws_cdk_lib_aws_ec2_CfnIPAMResourceDiscovery, aws_cdk_lib_aws_ec2_CfnIPAMResourceDiscovery_IpamOperatingRegionProperty, aws_cdk_lib_aws_ec2_CfnIPAMResourceDiscoveryAssociationProps, aws_cdk_lib_aws_ec2_CfnIPAMResourceDiscoveryAssociation, aws_cdk_lib_aws_ec2_CfnIPAMScopeProps, aws_cdk_lib_aws_ec2_CfnIPAMScope, aws_cdk_lib_aws_ec2_CfnInstanceProps, aws_cdk_lib_aws_ec2_CfnInstance, aws_cdk_lib_aws_ec2_CfnInstance_AssociationParameterProperty, aws_cdk_lib_aws_ec2_CfnInstance_BlockDeviceMappingProperty, aws_cdk_lib_aws_ec2_CfnInstance_CpuOptionsProperty, aws_cdk_lib_aws_ec2_CfnInstance_CreditSpecificationProperty, aws_cdk_lib_aws_ec2_CfnInstance_EbsProperty, aws_cdk_lib_aws_ec2_CfnInstance_ElasticGpuSpecificationProperty, aws_cdk_lib_aws_ec2_CfnInstance_ElasticInferenceAcceleratorProperty, aws_cdk_lib_aws_ec2_CfnInstance_EnclaveOptionsProperty, aws_cdk_lib_aws_ec2_CfnInstance_HibernationOptionsProperty, aws_cdk_lib_aws_ec2_CfnInstance_InstanceIpv6AddressProperty, aws_cdk_lib_aws_ec2_CfnInstance_LaunchTemplateSpecificationProperty, aws_cdk_lib_aws_ec2_CfnInstance_LicenseSpecificationProperty, aws_cdk_lib_aws_ec2_CfnInstance_NetworkInterfaceProperty, aws_cdk_lib_aws_ec2_CfnInstance_NoDeviceProperty, aws_cdk_lib_aws_ec2_CfnInstance_PrivateDnsNameOptionsProperty, aws_cdk_lib_aws_ec2_CfnInstance_PrivateIpAddressSpecificationProperty, aws_cdk_lib_aws_ec2_CfnInstance_SsmAssociationProperty, aws_cdk_lib_aws_ec2_CfnInstance_VolumeProperty, aws_cdk_lib_aws_ec2_CfnInternetGatewayProps, aws_cdk_lib_aws_ec2_CfnInternetGateway, aws_cdk_lib_aws_ec2_CfnKeyPairProps, aws_cdk_lib_aws_ec2_CfnKeyPair, aws_cdk_lib_aws_ec2_CfnLaunchTemplateProps, aws_cdk_lib_aws_ec2_CfnLaunchTemplate, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_AcceleratorCountProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_AcceleratorTotalMemoryMiBProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_BaselineEbsBandwidthMbpsProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_BlockDeviceMappingProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_CapacityReservationSpecificationProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_CapacityReservationTargetProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_CpuOptionsProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_CreditSpecificationProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_EbsProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_ElasticGpuSpecificationProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_EnclaveOptionsProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_HibernationOptionsProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_IamInstanceProfileProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_InstanceMarketOptionsProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_InstanceRequirementsProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_Ipv4PrefixSpecificationProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_Ipv6AddProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_Ipv6PrefixSpecificationProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_LaunchTemplateDataProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_LaunchTemplateElasticInferenceAcceleratorProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_LaunchTemplateTagSpecificationProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_LicenseSpecificationProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_MaintenanceOptionsProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_MemoryGiBPerVCpuProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_MemoryMiBProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_MetadataOptionsProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_MonitoringProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_NetworkBandwidthGbpsProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_NetworkInterfaceProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_NetworkInterfaceCountProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_PlacementProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_PrivateDnsNameOptionsProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_PrivateIpAddProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_SpotOptionsProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_TagSpecificationProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_TotalLocalStorageGBProperty, aws_cdk_lib_aws_ec2_CfnLaunchTemplate_VCpuCountProperty, aws_cdk_lib_aws_ec2_CfnLocalGatewayRouteProps, aws_cdk_lib_aws_ec2_CfnLocalGatewayRoute, aws_cdk_lib_aws_ec2_CfnLocalGatewayRouteTableProps, aws_cdk_lib_aws_ec2_CfnLocalGatewayRouteTable, aws_cdk_lib_aws_ec2_CfnLocalGatewayRouteTableVPCAssociationProps, aws_cdk_lib_aws_ec2_CfnLocalGatewayRouteTableVPCAssociation, aws_cdk_lib_aws_ec2_CfnLocalGatewayRouteTableVirtualInterfaceGroupAssociationProps, aws_cdk_lib_aws_ec2_CfnLocalGatewayRouteTableVirtualInterfaceGroupAssociation, aws_cdk_lib_aws_ec2_CfnNatGatewayProps, aws_cdk_lib_aws_ec2_CfnNatGateway, aws_cdk_lib_aws_ec2_CfnNetworkAclProps, aws_cdk_lib_aws_ec2_CfnNetworkAcl, aws_cdk_lib_aws_ec2_CfnNetworkAclEntryProps, aws_cdk_lib_aws_ec2_CfnNetworkAclEntry, aws_cdk_lib_aws_ec2_CfnNetworkAclEntry_IcmpProperty, aws_cdk_lib_aws_ec2_CfnNetworkAclEntry_PortRangeProperty, aws_cdk_lib_aws_ec2_CfnNetworkInsightsAccessScopeProps, aws_cdk_lib_aws_ec2_CfnNetworkInsightsAccessScope, aws_cdk_lib_aws_ec2_CfnNetworkInsightsAccessScope_AccessScopePathRequestProperty, aws_cdk_lib_aws_ec2_CfnNetworkInsightsAccessScope_PacketHeaderStatementRequestProperty, aws_cdk_lib_aws_ec2_CfnNetworkInsightsAccessScope_PathStatementRequestProperty, aws_cdk_lib_aws_ec2_CfnNetworkInsightsAccessScope_ResourceStatementRequestProperty, aws_cdk_lib_aws_ec2_CfnNetworkInsightsAccessScope_ThroughResourcesStatementRequestProperty, aws_cdk_lib_aws_ec2_CfnNetworkInsightsAccessScopeAnalysisProps, aws_cdk_lib_aws_ec2_CfnNetworkInsightsAccessScopeAnalysis, aws_cdk_lib_aws_ec2_CfnNetworkInsightsAnalysisProps, aws_cdk_lib_aws_ec2_CfnNetworkInsightsAnalysis, aws_cdk_lib_aws_ec2_CfnNetworkInsightsAnalysis_AdditionalDetailProperty, aws_cdk_lib_aws_ec2_CfnNetworkInsightsAnalysis_AlternatePathHintProperty, aws_cdk_lib_aws_ec2_CfnNetworkInsightsAnalysis_AnalysisAclRuleProperty, aws_cdk_lib_aws_ec2_CfnNetworkInsightsAnalysis_AnalysisComponentProperty, aws_cdk_lib_aws_ec2_CfnNetworkInsightsAnalysis_AnalysisLoadBalancerListenerProperty, aws_cdk_lib_aws_ec2_CfnNetworkInsightsAnalysis_AnalysisLoadBalancerTargetProperty, aws_cdk_lib_aws_ec2_CfnNetworkInsightsAnalysis_AnalysisPacketHeaderProperty, aws_cdk_lib_aws_ec2_CfnNetworkInsightsAnalysis_AnalysisRouteTableRouteProperty, aws_cdk_lib_aws_ec2_CfnNetworkInsightsAnalysis_AnalysisSecurityGroupRuleProperty, aws_cdk_lib_aws_ec2_CfnNetworkInsightsAnalysis_ExplanationProperty, aws_cdk_lib_aws_ec2_CfnNetworkInsightsAnalysis_PathComponentProperty, aws_cdk_lib_aws_ec2_CfnNetworkInsightsAnalysis_PortRangeProperty, aws_cdk_lib_aws_ec2_CfnNetworkInsightsAnalysis_TransitGatewayRouteTableRouteProperty, aws_cdk_lib_aws_ec2_CfnNetworkInsightsPathProps, aws_cdk_lib_aws_ec2_CfnNetworkInsightsPath, aws_cdk_lib_aws_ec2_CfnNetworkInsightsPath_FilterPortRangeProperty, aws_cdk_lib_aws_ec2_CfnNetworkInsightsPath_PathFilterProperty, aws_cdk_lib_aws_ec2_CfnNetworkInterfaceProps, aws_cdk_lib_aws_ec2_CfnNetworkInterface, aws_cdk_lib_aws_ec2_CfnNetworkInterface_InstanceIpv6AddressProperty, aws_cdk_lib_aws_ec2_CfnNetworkInterface_PrivateIpAddressSpecificationProperty, aws_cdk_lib_aws_ec2_CfnNetworkInterfaceAttachmentProps, aws_cdk_lib_aws_ec2_CfnNetworkInterfaceAttachment, aws_cdk_lib_aws_ec2_CfnNetworkInterfacePermissionProps, aws_cdk_lib_aws_ec2_CfnNetworkInterfacePermission, aws_cdk_lib_aws_ec2_CfnNetworkPerformanceMetricSubscriptionProps, aws_cdk_lib_aws_ec2_CfnNetworkPerformanceMetricSubscription, aws_cdk_lib_aws_ec2_CfnPlacementGroupProps, aws_cdk_lib_aws_ec2_CfnPlacementGroup, aws_cdk_lib_aws_ec2_CfnPrefixListProps, aws_cdk_lib_aws_ec2_CfnPrefixList, aws_cdk_lib_aws_ec2_CfnPrefixList_EntryProperty, aws_cdk_lib_aws_ec2_CfnRouteProps, aws_cdk_lib_aws_ec2_CfnRoute, aws_cdk_lib_aws_ec2_CfnRouteTableProps, aws_cdk_lib_aws_ec2_CfnRouteTable, aws_cdk_lib_aws_ec2_CfnSecurityGroupProps, aws_cdk_lib_aws_ec2_CfnSecurityGroup, aws_cdk_lib_aws_ec2_CfnSecurityGroup_EgressProperty, aws_cdk_lib_aws_ec2_CfnSecurityGroup_IngressProperty, aws_cdk_lib_aws_ec2_CfnSecurityGroupEgressProps, aws_cdk_lib_aws_ec2_CfnSecurityGroupEgress, aws_cdk_lib_aws_ec2_CfnSecurityGroupIngressProps, aws_cdk_lib_aws_ec2_CfnSecurityGroupIngress, aws_cdk_lib_aws_ec2_CfnSpotFleetProps, aws_cdk_lib_aws_ec2_CfnSpotFleet, aws_cdk_lib_aws_ec2_CfnSpotFleet_AcceleratorCountRequestProperty, aws_cdk_lib_aws_ec2_CfnSpotFleet_AcceleratorTotalMemoryMiBRequestProperty, aws_cdk_lib_aws_ec2_CfnSpotFleet_BaselineEbsBandwidthMbpsRequestProperty, aws_cdk_lib_aws_ec2_CfnSpotFleet_BlockDeviceMappingProperty, aws_cdk_lib_aws_ec2_CfnSpotFleet_ClassicLoadBalancerProperty, aws_cdk_lib_aws_ec2_CfnSpotFleet_ClassicLoadBalancersConfigProperty, aws_cdk_lib_aws_ec2_CfnSpotFleet_EbsBlockDeviceProperty, aws_cdk_lib_aws_ec2_CfnSpotFleet_FleetLaunchTemplateSpecificationProperty, aws_cdk_lib_aws_ec2_CfnSpotFleet_GroupIdentifierProperty, aws_cdk_lib_aws_ec2_CfnSpotFleet_IamInstanceProfileSpecificationProperty, aws_cdk_lib_aws_ec2_CfnSpotFleet_InstanceIpv6AddressProperty, aws_cdk_lib_aws_ec2_CfnSpotFleet_InstanceNetworkInterfaceSpecificationProperty, aws_cdk_lib_aws_ec2_CfnSpotFleet_InstanceRequirementsRequestProperty, aws_cdk_lib_aws_ec2_CfnSpotFleet_LaunchTemplateConfigProperty, aws_cdk_lib_aws_ec2_CfnSpotFleet_LaunchTemplateOverridesProperty, aws_cdk_lib_aws_ec2_CfnSpotFleet_LoadBalancersConfigProperty, aws_cdk_lib_aws_ec2_CfnSpotFleet_MemoryGiBPerVCpuRequestProperty, aws_cdk_lib_aws_ec2_CfnSpotFleet_MemoryMiBRequestProperty, aws_cdk_lib_aws_ec2_CfnSpotFleet_NetworkBandwidthGbpsRequestProperty, aws_cdk_lib_aws_ec2_CfnSpotFleet_NetworkInterfaceCountRequestProperty, aws_cdk_lib_aws_ec2_CfnSpotFleet_PrivateIpAddressSpecificationProperty, aws_cdk_lib_aws_ec2_CfnSpotFleet_SpotCapacityRebalanceProperty, aws_cdk_lib_aws_ec2_CfnSpotFleet_SpotFleetLaunchSpecificationProperty, aws_cdk_lib_aws_ec2_CfnSpotFleet_SpotFleetMonitoringProperty, aws_cdk_lib_aws_ec2_CfnSpotFleet_SpotFleetRequestConfigDataProperty, aws_cdk_lib_aws_ec2_CfnSpotFleet_SpotFleetTagSpecificationProperty, aws_cdk_lib_aws_ec2_CfnSpotFleet_SpotMaintenanceStrategiesProperty, aws_cdk_lib_aws_ec2_CfnSpotFleet_SpotPlacementProperty, aws_cdk_lib_aws_ec2_CfnSpotFleet_TargetGroupProperty, aws_cdk_lib_aws_ec2_CfnSpotFleet_TargetGroupsConfigProperty, aws_cdk_lib_aws_ec2_CfnSpotFleet_TotalLocalStorageGBRequestProperty, aws_cdk_lib_aws_ec2_CfnSpotFleet_VCpuCountRangeRequestProperty, aws_cdk_lib_aws_ec2_CfnSubnetProps, aws_cdk_lib_aws_ec2_CfnSubnet, aws_cdk_lib_aws_ec2_CfnSubnet_PrivateDnsNameOptionsOnLaunchProperty, aws_cdk_lib_aws_ec2_CfnSubnetCidrBlockProps, aws_cdk_lib_aws_ec2_CfnSubnetCidrBlock, aws_cdk_lib_aws_ec2_CfnSubnetNetworkAclAssociationProps, aws_cdk_lib_aws_ec2_CfnSubnetNetworkAclAssociation, aws_cdk_lib_aws_ec2_CfnSubnetRouteTableAssociationProps, aws_cdk_lib_aws_ec2_CfnSubnetRouteTableAssociation, aws_cdk_lib_aws_ec2_CfnTrafficMirrorFilterProps, aws_cdk_lib_aws_ec2_CfnTrafficMirrorFilter, aws_cdk_lib_aws_ec2_CfnTrafficMirrorFilterRuleProps, aws_cdk_lib_aws_ec2_CfnTrafficMirrorFilterRule, aws_cdk_lib_aws_ec2_CfnTrafficMirrorFilterRule_TrafficMirrorPortRangeProperty, aws_cdk_lib_aws_ec2_CfnTrafficMirrorSessionProps, aws_cdk_lib_aws_ec2_CfnTrafficMirrorSession, aws_cdk_lib_aws_ec2_CfnTrafficMirrorTargetProps, aws_cdk_lib_aws_ec2_CfnTrafficMirrorTarget, aws_cdk_lib_aws_ec2_CfnTransitGatewayProps, aws_cdk_lib_aws_ec2_CfnTransitGateway, aws_cdk_lib_aws_ec2_CfnTransitGatewayAttachmentProps, aws_cdk_lib_aws_ec2_CfnTransitGatewayAttachment, aws_cdk_lib_aws_ec2_CfnTransitGatewayAttachment_OptionsProperty, aws_cdk_lib_aws_ec2_CfnTransitGatewayConnectProps, aws_cdk_lib_aws_ec2_CfnTransitGatewayConnect, aws_cdk_lib_aws_ec2_CfnTransitGatewayConnect_TransitGatewayConnectOptionsProperty, aws_cdk_lib_aws_ec2_CfnTransitGatewayMulticastDomainProps, aws_cdk_lib_aws_ec2_CfnTransitGatewayMulticastDomain, aws_cdk_lib_aws_ec2_CfnTransitGatewayMulticastDomain_OptionsProperty, aws_cdk_lib_aws_ec2_CfnTransitGatewayMulticastDomainAssociationProps, aws_cdk_lib_aws_ec2_CfnTransitGatewayMulticastDomainAssociation, aws_cdk_lib_aws_ec2_CfnTransitGatewayMulticastGroupMemberProps, aws_cdk_lib_aws_ec2_CfnTransitGatewayMulticastGroupMember, aws_cdk_lib_aws_ec2_CfnTransitGatewayMulticastGroupSourceProps, aws_cdk_lib_aws_ec2_CfnTransitGatewayMulticastGroupSource, aws_cdk_lib_aws_ec2_CfnTransitGatewayPeeringAttachmentProps, aws_cdk_lib_aws_ec2_CfnTransitGatewayPeeringAttachment, aws_cdk_lib_aws_ec2_CfnTransitGatewayPeeringAttachment_PeeringAttachmentStatusProperty, aws_cdk_lib_aws_ec2_CfnTransitGatewayRouteProps, aws_cdk_lib_aws_ec2_CfnTransitGatewayRoute, aws_cdk_lib_aws_ec2_CfnTransitGatewayRouteTableProps, aws_cdk_lib_aws_ec2_CfnTransitGatewayRouteTable, aws_cdk_lib_aws_ec2_CfnTransitGatewayRouteTableAssociationProps, aws_cdk_lib_aws_ec2_CfnTransitGatewayRouteTableAssociation, aws_cdk_lib_aws_ec2_CfnTransitGatewayRouteTablePropagationProps, aws_cdk_lib_aws_ec2_CfnTransitGatewayRouteTablePropagation, aws_cdk_lib_aws_ec2_CfnTransitGatewayVpcAttachmentProps, aws_cdk_lib_aws_ec2_CfnTransitGatewayVpcAttachment, aws_cdk_lib_aws_ec2_CfnTransitGatewayVpcAttachment_OptionsProperty, aws_cdk_lib_aws_ec2_CfnVPCProps, aws_cdk_lib_aws_ec2_CfnVPC, aws_cdk_lib_aws_ec2_CfnVPCCidrBlockProps, aws_cdk_lib_aws_ec2_CfnVPCCidrBlock, aws_cdk_lib_aws_ec2_CfnVPCDHCPOptionsAssociationProps, aws_cdk_lib_aws_ec2_CfnVPCDHCPOptionsAssociation, aws_cdk_lib_aws_ec2_CfnVPCEndpointProps, aws_cdk_lib_aws_ec2_CfnVPCEndpoint, aws_cdk_lib_aws_ec2_CfnVPCEndpointConnectionNotificationProps, aws_cdk_lib_aws_ec2_CfnVPCEndpointConnectionNotification, aws_cdk_lib_aws_ec2_CfnVPCEndpointServiceProps, aws_cdk_lib_aws_ec2_CfnVPCEndpointService, aws_cdk_lib_aws_ec2_CfnVPCEndpointServicePermissionsProps, aws_cdk_lib_aws_ec2_CfnVPCEndpointServicePermissions, aws_cdk_lib_aws_ec2_CfnVPCGatewayAttachmentProps, aws_cdk_lib_aws_ec2_CfnVPCGatewayAttachment, aws_cdk_lib_aws_ec2_CfnVPCPeeringConnectionProps, aws_cdk_lib_aws_ec2_CfnVPCPeeringConnection, aws_cdk_lib_aws_ec2_CfnVPNConnectionProps, aws_cdk_lib_aws_ec2_CfnVPNConnection, aws_cdk_lib_aws_ec2_CfnVPNConnection_VpnTunnelOptionsSpecificationProperty, aws_cdk_lib_aws_ec2_CfnVPNConnectionRouteProps, aws_cdk_lib_aws_ec2_CfnVPNConnectionRoute, aws_cdk_lib_aws_ec2_CfnVPNGatewayProps, aws_cdk_lib_aws_ec2_CfnVPNGateway, aws_cdk_lib_aws_ec2_CfnVPNGatewayRoutePropagationProps, aws_cdk_lib_aws_ec2_CfnVPNGatewayRoutePropagation, aws_cdk_lib_aws_ec2_CfnVerifiedAccessEndpointProps, aws_cdk_lib_aws_ec2_CfnVerifiedAccessEndpoint, aws_cdk_lib_aws_ec2_CfnVerifiedAccessEndpoint_LoadBalancerOptionsProperty, aws_cdk_lib_aws_ec2_CfnVerifiedAccessEndpoint_NetworkInterfaceOptionsProperty, aws_cdk_lib_aws_ec2_CfnVerifiedAccessGroupProps, aws_cdk_lib_aws_ec2_CfnVerifiedAccessGroup, aws_cdk_lib_aws_ec2_CfnVerifiedAccessInstanceProps, aws_cdk_lib_aws_ec2_CfnVerifiedAccessInstance, aws_cdk_lib_aws_ec2_CfnVerifiedAccessInstance_CloudWatchLogsProperty, aws_cdk_lib_aws_ec2_CfnVerifiedAccessInstance_KinesisDataFirehoseProperty, aws_cdk_lib_aws_ec2_CfnVerifiedAccessInstance_S3Property, aws_cdk_lib_aws_ec2_CfnVerifiedAccessInstance_VerifiedAccessLogsProperty, aws_cdk_lib_aws_ec2_CfnVerifiedAccessInstance_VerifiedAccessTrustProviderProperty, aws_cdk_lib_aws_ec2_CfnVerifiedAccessTrustProviderProps, aws_cdk_lib_aws_ec2_CfnVerifiedAccessTrustProvider, aws_cdk_lib_aws_ec2_CfnVerifiedAccessTrustProvider_DeviceOptionsProperty, aws_cdk_lib_aws_ec2_CfnVerifiedAccessTrustProvider_OidcOptionsProperty, aws_cdk_lib_aws_ec2_CfnVolumeProps, aws_cdk_lib_aws_ec2_CfnVolume, aws_cdk_lib_aws_ec2_CfnVolumeAttachmentProps, aws_cdk_lib_aws_ec2_CfnVolumeAttachment, aws_cdk_lib_aws_ecr_CfnPublicRepositoryProps, aws_cdk_lib_aws_ecr_CfnPublicRepository, aws_cdk_lib_aws_ecr_CfnPublicRepository_RepositoryCatalogDataProperty, aws_cdk_lib_aws_ecr_CfnPullThroughCacheRuleProps, aws_cdk_lib_aws_ecr_CfnPullThroughCacheRule, aws_cdk_lib_aws_ecr_CfnRegistryPolicyProps, aws_cdk_lib_aws_ecr_CfnRegistryPolicy, aws_cdk_lib_aws_ecr_CfnReplicationConfigurationProps, aws_cdk_lib_aws_ecr_CfnReplicationConfiguration, aws_cdk_lib_aws_ecr_CfnReplicationConfiguration_ReplicationConfigurationProperty, aws_cdk_lib_aws_ecr_CfnReplicationConfiguration_ReplicationDestinationProperty, aws_cdk_lib_aws_ecr_CfnReplicationConfiguration_ReplicationRuleProperty, aws_cdk_lib_aws_ecr_CfnReplicationConfiguration_RepositoryFilterProperty, aws_cdk_lib_aws_ecr_CfnRepositoryProps, aws_cdk_lib_aws_ecr_CfnRepository, aws_cdk_lib_aws_ecr_CfnRepository_EncryptionConfigurationProperty, aws_cdk_lib_aws_ecr_CfnRepository_ImageScanningConfigurationProperty, aws_cdk_lib_aws_ecr_CfnRepository_LifecyclePolicyProperty, aws_cdk_lib_aws_ecr_IRepository, aws_cdk_lib_aws_ecr_RepositoryBase, aws_cdk_lib_aws_ecr_OnCloudTrailImagePushedOptions, aws_cdk_lib_aws_ecr_OnImageScanCompletedOptions, aws_cdk_lib_aws_ecr_RepositoryProps, aws_cdk_lib_aws_ecr_RepositoryAttributes, aws_cdk_lib_aws_ecr_Repository, aws_cdk_lib_aws_ecr_TagMutability, aws_cdk_lib_aws_ecr_RepositoryEncryption, aws_cdk_lib_aws_ecr_LifecycleRule, aws_cdk_lib_aws_ecr_TagStatus, aws_cdk_lib_aws_ecr_AuthorizationToken, aws_cdk_lib_aws_ecr_PublicGalleryAuthorizationToken, aws_cdk_lib_aws_ecr_assets_NetworkMode, aws_cdk_lib_aws_ecr_assets_Platform, aws_cdk_lib_aws_ecr_assets_DockerImageAssetInvalidationOptions, aws_cdk_lib_aws_ecr_assets_DockerCacheOption, aws_cdk_lib_aws_ecr_assets_DockerImageAssetOptions, aws_cdk_lib_aws_ecr_assets_DockerImageAssetProps, aws_cdk_lib_aws_ecr_assets_DockerImageAsset, aws_cdk_lib_aws_ecr_assets_TarballImageAssetProps, aws_cdk_lib_aws_ecr_assets_TarballImageAsset, aws_cdk_lib_aws_ecs_IService, aws_cdk_lib_aws_ecs_DeploymentController, aws_cdk_lib_aws_ecs_DeploymentCircuitBreaker, aws_cdk_lib_aws_ecs_EcsTarget, aws_cdk_lib_aws_ecs_IEcsLoadBalancerTarget, aws_cdk_lib_aws_ecs_ServiceConnectProps, aws_cdk_lib_aws_ecs_ServiceConnectService, aws_cdk_lib_aws_ecs_BaseServiceOptions, aws_cdk_lib_aws_ecs_BaseServiceProps, aws_cdk_lib_aws_ecs_ListenerConfig, aws_cdk_lib_aws_ecs_IBaseService, aws_cdk_lib_aws_ecs_BaseService, aws_cdk_lib_aws_ecs_CloudMapOptions, aws_cdk_lib_aws_ecs_AssociateCloudMapServiceOptions, aws_cdk_lib_aws_ecs_LaunchType, aws_cdk_lib_aws_ecs_DeploymentControllerType, aws_cdk_lib_aws_ecs_PropagatedTagSource, aws_cdk_lib_aws_ecs_ScalableTaskCountProps, aws_cdk_lib_aws_ecs_ScalableTaskCount, aws_cdk_lib_aws_ecs_CpuUtilizationScalingProps, aws_cdk_lib_aws_ecs_MemoryUtilizationScalingProps, aws_cdk_lib_aws_ecs_RequestCountScalingProps, aws_cdk_lib_aws_ecs_TrackCustomMetricProps, aws_cdk_lib_aws_ecs_ITaskDefinition, aws_cdk_lib_aws_ecs_CommonTaskDefinitionProps, aws_cdk_lib_aws_ecs_TaskDefinitionProps, aws_cdk_lib_aws_ecs_CommonTaskDefinitionAttributes, aws_cdk_lib_aws_ecs_TaskDefinitionAttributes, aws_cdk_lib_aws_ecs_TaskDefinition, aws_cdk_lib_aws_ecs_NetworkMode, aws_cdk_lib_aws_ecs_IpcMode, aws_cdk_lib_aws_ecs_PidMode, aws_cdk_lib_aws_ecs_InferenceAccelerator, aws_cdk_lib_aws_ecs_Volume, aws_cdk_lib_aws_ecs_Host, aws_cdk_lib_aws_ecs_LoadBalancerTargetOptions, aws_cdk_lib_aws_ecs_DockerVolumeConfiguration, aws_cdk_lib_aws_ecs_AuthorizationConfig, aws_cdk_lib_aws_ecs_EfsVolumeConfiguration, aws_cdk_lib_aws_ecs_Scope, aws_cdk_lib_aws_ecs_Compatibility, aws_cdk_lib_aws_ecs_ITaskDefinitionExtension, aws_cdk_lib_aws_ecs_SecretVersionInfo, aws_cdk_lib_aws_ecs_Secret, aws_cdk_lib_aws_ecs_ContainerDefinitionOptions, aws_cdk_lib_aws_ecs_ContainerDefinitionProps, aws_cdk_lib_aws_ecs_ContainerDefinition, aws_cdk_lib_aws_ecs_HealthCheck, aws_cdk_lib_aws_ecs_Ulimit, aws_cdk_lib_aws_ecs_UlimitName, aws_cdk_lib_aws_ecs_ContainerDependency, aws_cdk_lib_aws_ecs_ContainerDependencyCondition, aws_cdk_lib_aws_ecs_PortMapping, aws_cdk_lib_aws_ecs_PortMap, aws_cdk_lib_aws_ecs_ServiceConnect, aws_cdk_lib_aws_ecs_Protocol, aws_cdk_lib_aws_ecs_AppProtocol, aws_cdk_lib_aws_ecs_ScratchSpace, aws_cdk_lib_aws_ecs_MountPoint, aws_cdk_lib_aws_ecs_VolumeFrom, aws_cdk_lib_aws_ecs_SystemControl, aws_cdk_lib_aws_ecs_ContainerImage, aws_cdk_lib_aws_ecs_ContainerImageConfig, aws_cdk_lib_aws_ecs_AmiHardwareType, aws_cdk_lib_aws_ecs_WindowsOptimizedVersion, aws_cdk_lib_aws_ecs_EcsOptimizedImageOptions, aws_cdk_lib_aws_ecs_EcsOptimizedImage, aws_cdk_lib_aws_ecs_BottlerocketEcsVariant, aws_cdk_lib_aws_ecs_BottleRocketImageProps, aws_cdk_lib_aws_ecs_BottleRocketImage, aws_cdk_lib_aws_ecs_ClusterProps, aws_cdk_lib_aws_ecs_MachineImageType, aws_cdk_lib_aws_ecs_Cluster, aws_cdk_lib_aws_ecs_ICluster, aws_cdk_lib_aws_ecs_ClusterAttributes, aws_cdk_lib_aws_ecs_AddAutoScalingGroupCapacityOptions, aws_cdk_lib_aws_ecs_AddCapacityOptions, aws_cdk_lib_aws_ecs_CloudMapNamespaceOptions, aws_cdk_lib_aws_ecs_CapacityProviderStrategy, aws_cdk_lib_aws_ecs_ExecuteCommandConfiguration, aws_cdk_lib_aws_ecs_ExecuteCommandLogging, aws_cdk_lib_aws_ecs_ExecuteCommandLogConfiguration, aws_cdk_lib_aws_ecs_AsgCapacityProviderProps, aws_cdk_lib_aws_ecs_AsgCapacityProvider, aws_cdk_lib_aws_ecs_EnvironmentFile, aws_cdk_lib_aws_ecs_AssetEnvironmentFile, aws_cdk_lib_aws_ecs_S3EnvironmentFile, aws_cdk_lib_aws_ecs_EnvironmentFileConfig, aws_cdk_lib_aws_ecs_EnvironmentFileType, aws_cdk_lib_aws_ecs_FirelensLogRouterType, aws_cdk_lib_aws_ecs_FirelensConfigFileType, aws_cdk_lib_aws_ecs_FirelensOptions, aws_cdk_lib_aws_ecs_FirelensConfig, aws_cdk_lib_aws_ecs_FirelensLogRouterProps, aws_cdk_lib_aws_ecs_FirelensLogRouterDefinitionOptions, aws_cdk_lib_aws_ecs_FirelensLogRouter, aws_cdk_lib_aws_ecs_BinPackResource, aws_cdk_lib_aws_ecs_PlacementStrategy, aws_cdk_lib_aws_ecs_PlacementConstraint, aws_cdk_lib_aws_ecs_Ec2ServiceProps, aws_cdk_lib_aws_ecs_IEc2Service, aws_cdk_lib_aws_ecs_Ec2ServiceAttributes, aws_cdk_lib_aws_ecs_Ec2Service, aws_cdk_lib_aws_ecs_BuiltInAttributes, aws_cdk_lib_aws_ecs_Ec2TaskDefinitionProps, aws_cdk_lib_aws_ecs_IEc2TaskDefinition, aws_cdk_lib_aws_ecs_Ec2TaskDefinitionAttributes, aws_cdk_lib_aws_ecs_Ec2TaskDefinition, aws_cdk_lib_aws_ecs_FargateServiceProps, aws_cdk_lib_aws_ecs_IFargateService, aws_cdk_lib_aws_ecs_FargateServiceAttributes, aws_cdk_lib_aws_ecs_FargateService, aws_cdk_lib_aws_ecs_FargatePlatformVersion, aws_cdk_lib_aws_ecs_FargateTaskDefinitionProps, aws_cdk_lib_aws_ecs_IFargateTaskDefinition, aws_cdk_lib_aws_ecs_FargateTaskDefinitionAttributes, aws_cdk_lib_aws_ecs_FargateTaskDefinition, aws_cdk_lib_aws_ecs_ExternalServiceProps, aws_cdk_lib_aws_ecs_IExternalService, aws_cdk_lib_aws_ecs_ExternalServiceAttributes, aws_cdk_lib_aws_ecs_ExternalService, aws_cdk_lib_aws_ecs_ExternalTaskDefinitionProps, aws_cdk_lib_aws_ecs_IExternalTaskDefinition, aws_cdk_lib_aws_ecs_ExternalTaskDefinitionAttributes, aws_cdk_lib_aws_ecs_ExternalTaskDefinition, aws_cdk_lib_aws_ecs_LinuxParametersProps, aws_cdk_lib_aws_ecs_LinuxParameters, aws_cdk_lib_aws_ecs_Device, aws_cdk_lib_aws_ecs_Tmpfs, aws_cdk_lib_aws_ecs_Capability, aws_cdk_lib_aws_ecs_DevicePermission, aws_cdk_lib_aws_ecs_TmpfsMountOption, aws_cdk_lib_aws_ecs_AssetImageProps, aws_cdk_lib_aws_ecs_AssetImage, aws_cdk_lib_aws_ecs_RepositoryImageProps, aws_cdk_lib_aws_ecs_RepositoryImage, aws_cdk_lib_aws_ecs_EcrImage, aws_cdk_lib_aws_ecs_TagParameterContainerImage, aws_cdk_lib_aws_ecs_AwsLogDriverMode, aws_cdk_lib_aws_ecs_AwsLogDriverProps, aws_cdk_lib_aws_ecs_AwsLogDriver, aws_cdk_lib_aws_ecs_BaseLogDriverProps, aws_cdk_lib_aws_ecs_FireLensLogDriverProps, aws_cdk_lib_aws_ecs_FireLensLogDriver, aws_cdk_lib_aws_ecs_FluentdLogDriverProps, aws_cdk_lib_aws_ecs_FluentdLogDriver, aws_cdk_lib_aws_ecs_GelfCompressionType, aws_cdk_lib_aws_ecs_GelfLogDriverProps, aws_cdk_lib_aws_ecs_GelfLogDriver, aws_cdk_lib_aws_ecs_JournaldLogDriverProps, aws_cdk_lib_aws_ecs_JournaldLogDriver, aws_cdk_lib_aws_ecs_JsonFileLogDriverProps, aws_cdk_lib_aws_ecs_JsonFileLogDriver, aws_cdk_lib_aws_ecs_SplunkLogFormat, aws_cdk_lib_aws_ecs_SplunkLogDriverProps, aws_cdk_lib_aws_ecs_SplunkLogDriver, aws_cdk_lib_aws_ecs_SyslogLogDriverProps, aws_cdk_lib_aws_ecs_SyslogLogDriver, aws_cdk_lib_aws_ecs_LogDriver, aws_cdk_lib_aws_ecs_LogDriverConfig, aws_cdk_lib_aws_ecs_GenericLogDriverProps, aws_cdk_lib_aws_ecs_GenericLogDriver, aws_cdk_lib_aws_ecs_LogDrivers, aws_cdk_lib_aws_ecs_AppMeshProxyConfigurationProps, aws_cdk_lib_aws_ecs_AppMeshProxyConfigurationConfigProps, aws_cdk_lib_aws_ecs_AppMeshProxyConfiguration, aws_cdk_lib_aws_ecs_ProxyConfiguration, aws_cdk_lib_aws_ecs_ProxyConfigurations, aws_cdk_lib_aws_ecs_CpuArchitecture, aws_cdk_lib_aws_ecs_OperatingSystemFamily, aws_cdk_lib_aws_ecs_RuntimePlatform, aws_cdk_lib_aws_ecs_CfnCapacityProviderProps, aws_cdk_lib_aws_ecs_CfnCapacityProvider, aws_cdk_lib_aws_ecs_CfnCapacityProvider_AutoScalingGroupProviderProperty, aws_cdk_lib_aws_ecs_CfnCapacityProvider_ManagedScalingProperty, aws_cdk_lib_aws_ecs_CfnClusterProps, aws_cdk_lib_aws_ecs_CfnCluster, aws_cdk_lib_aws_ecs_CfnCluster_CapacityProviderStrategyItemProperty, aws_cdk_lib_aws_ecs_CfnCluster_ClusterConfigurationProperty, aws_cdk_lib_aws_ecs_CfnCluster_ClusterSettingsProperty, aws_cdk_lib_aws_ecs_CfnCluster_ExecuteCommandConfigurationProperty, aws_cdk_lib_aws_ecs_CfnCluster_ExecuteCommandLogConfigurationProperty, aws_cdk_lib_aws_ecs_CfnCluster_ServiceConnectDefaultsProperty, aws_cdk_lib_aws_ecs_CfnClusterCapacityProviderAssociationsProps, aws_cdk_lib_aws_ecs_CfnClusterCapacityProviderAssociations, aws_cdk_lib_aws_ecs_CfnClusterCapacityProviderAssociations_CapacityProviderStrategyProperty, aws_cdk_lib_aws_ecs_CfnPrimaryTaskSetProps, aws_cdk_lib_aws_ecs_CfnPrimaryTaskSet, aws_cdk_lib_aws_ecs_CfnServiceProps, aws_cdk_lib_aws_ecs_CfnService, aws_cdk_lib_aws_ecs_CfnService_AwsVpcConfigurationProperty, aws_cdk_lib_aws_ecs_CfnService_CapacityProviderStrategyItemProperty, aws_cdk_lib_aws_ecs_CfnService_DeploymentAlarmsProperty, aws_cdk_lib_aws_ecs_CfnService_DeploymentCircuitBreakerProperty, aws_cdk_lib_aws_ecs_CfnService_DeploymentConfigurationProperty, aws_cdk_lib_aws_ecs_CfnService_DeploymentControllerProperty, aws_cdk_lib_aws_ecs_CfnService_LoadBalancerProperty, aws_cdk_lib_aws_ecs_CfnService_LogConfigurationProperty, aws_cdk_lib_aws_ecs_CfnService_NetworkConfigurationProperty, aws_cdk_lib_aws_ecs_CfnService_PlacementConstraintProperty, aws_cdk_lib_aws_ecs_CfnService_PlacementStrategyProperty, aws_cdk_lib_aws_ecs_CfnService_SecretProperty, aws_cdk_lib_aws_ecs_CfnService_ServiceConnectClientAliasProperty, aws_cdk_lib_aws_ecs_CfnService_ServiceConnectConfigurationProperty, aws_cdk_lib_aws_ecs_CfnService_ServiceConnectServiceProperty, aws_cdk_lib_aws_ecs_CfnService_ServiceRegistryProperty, aws_cdk_lib_aws_ecs_CfnTaskDefinitionProps, aws_cdk_lib_aws_ecs_CfnTaskDefinition, aws_cdk_lib_aws_ecs_CfnTaskDefinition_AuthorizationConfigProperty, aws_cdk_lib_aws_ecs_CfnTaskDefinition_ContainerDefinitionProperty, aws_cdk_lib_aws_ecs_CfnTaskDefinition_ContainerDependencyProperty, aws_cdk_lib_aws_ecs_CfnTaskDefinition_DeviceProperty, aws_cdk_lib_aws_ecs_CfnTaskDefinition_DockerVolumeConfigurationProperty, aws_cdk_lib_aws_ecs_CfnTaskDefinition_EFSVolumeConfigurationProperty, aws_cdk_lib_aws_ecs_CfnTaskDefinition_EnvironmentFileProperty, aws_cdk_lib_aws_ecs_CfnTaskDefinition_EphemeralStorageProperty, aws_cdk_lib_aws_ecs_CfnTaskDefinition_FirelensConfigurationProperty, aws_cdk_lib_aws_ecs_CfnTaskDefinition_HealthCheckProperty, aws_cdk_lib_aws_ecs_CfnTaskDefinition_HostEntryProperty, aws_cdk_lib_aws_ecs_CfnTaskDefinition_HostVolumePropertiesProperty, aws_cdk_lib_aws_ecs_CfnTaskDefinition_InferenceAcceleratorProperty, aws_cdk_lib_aws_ecs_CfnTaskDefinition_KernelCapabilitiesProperty, aws_cdk_lib_aws_ecs_CfnTaskDefinition_KeyValuePairProperty, aws_cdk_lib_aws_ecs_CfnTaskDefinition_LinuxParametersProperty, aws_cdk_lib_aws_ecs_CfnTaskDefinition_LogConfigurationProperty, aws_cdk_lib_aws_ecs_CfnTaskDefinition_MountPointProperty, aws_cdk_lib_aws_ecs_CfnTaskDefinition_PortMappingProperty, aws_cdk_lib_aws_ecs_CfnTaskDefinition_ProxyConfigurationProperty, aws_cdk_lib_aws_ecs_CfnTaskDefinition_RepositoryCredentialsProperty, aws_cdk_lib_aws_ecs_CfnTaskDefinition_ResourceRequirementProperty, aws_cdk_lib_aws_ecs_CfnTaskDefinition_RuntimePlatformProperty, aws_cdk_lib_aws_ecs_CfnTaskDefinition_SecretProperty, aws_cdk_lib_aws_ecs_CfnTaskDefinition_SystemControlProperty, aws_cdk_lib_aws_ecs_CfnTaskDefinition_TaskDefinitionPlacementConstraintProperty, aws_cdk_lib_aws_ecs_CfnTaskDefinition_TmpfsProperty, aws_cdk_lib_aws_ecs_CfnTaskDefinition_UlimitProperty, aws_cdk_lib_aws_ecs_CfnTaskDefinition_VolumeProperty, aws_cdk_lib_aws_ecs_CfnTaskDefinition_VolumeFromProperty, aws_cdk_lib_aws_ecs_CfnTaskSetProps, aws_cdk_lib_aws_ecs_CfnTaskSet, aws_cdk_lib_aws_ecs_CfnTaskSet_AwsVpcConfigurationProperty, aws_cdk_lib_aws_ecs_CfnTaskSet_LoadBalancerProperty, aws_cdk_lib_aws_ecs_CfnTaskSet_NetworkConfigurationProperty, aws_cdk_lib_aws_ecs_CfnTaskSet_ScaleProperty, aws_cdk_lib_aws_ecs_CfnTaskSet_ServiceRegistryProperty, aws_cdk_lib_aws_ecs_patterns_QueueProcessingEc2ServiceProps, aws_cdk_lib_aws_ecs_patterns_QueueProcessingEc2Service, aws_cdk_lib_aws_ecs_patterns_QueueProcessingFargateServiceProps, aws_cdk_lib_aws_ecs_patterns_QueueProcessingFargateService, aws_cdk_lib_aws_ecs_patterns_QueueProcessingServiceBaseProps, aws_cdk_lib_aws_ecs_patterns_QueueProcessingServiceBase, aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancedEc2ServiceProps, aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancedEc2Service, aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancedFargateServiceProps, aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancedFargateService, aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancedServiceRecordType, aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancedServiceBaseProps, aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancedTaskImageOptions, aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancedServiceBase, aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancedEc2ServiceProps, aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancedEc2Service, aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancedFargateServiceProps, aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancedFargateService, aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancedServiceRecordType, aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancedServiceBaseProps, aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancedTaskImageOptions, aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancedServiceBase, aws_cdk_lib_aws_ecs_patterns_FargateServiceBaseProps, aws_cdk_lib_aws_ecs_patterns_ScheduledEc2TaskProps, aws_cdk_lib_aws_ecs_patterns_ScheduledEc2TaskImageOptions, aws_cdk_lib_aws_ecs_patterns_ScheduledEc2TaskDefinitionOptions, aws_cdk_lib_aws_ecs_patterns_ScheduledEc2Task, aws_cdk_lib_aws_ecs_patterns_ScheduledFargateTaskProps, aws_cdk_lib_aws_ecs_patterns_ScheduledFargateTaskImageOptions, aws_cdk_lib_aws_ecs_patterns_ScheduledFargateTaskDefinitionOptions, aws_cdk_lib_aws_ecs_patterns_ScheduledFargateTask, aws_cdk_lib_aws_ecs_patterns_ScheduledTaskBaseProps, aws_cdk_lib_aws_ecs_patterns_ScheduledTaskImageProps, aws_cdk_lib_aws_ecs_patterns_ScheduledTaskBase, aws_cdk_lib_aws_ecs_patterns_ApplicationMultipleTargetGroupsServiceBaseProps, aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancedTaskImageProps, aws_cdk_lib_aws_ecs_patterns_ApplicationTargetProps, aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancerProps, aws_cdk_lib_aws_ecs_patterns_ApplicationListenerProps, aws_cdk_lib_aws_ecs_patterns_ApplicationMultipleTargetGroupsServiceBase, aws_cdk_lib_aws_ecs_patterns_ApplicationMultipleTargetGroupsEc2ServiceProps, aws_cdk_lib_aws_ecs_patterns_ApplicationMultipleTargetGroupsEc2Service, aws_cdk_lib_aws_ecs_patterns_ApplicationMultipleTargetGroupsFargateServiceProps, aws_cdk_lib_aws_ecs_patterns_ApplicationMultipleTargetGroupsFargateService, aws_cdk_lib_aws_ecs_patterns_NetworkMultipleTargetGroupsServiceBaseProps, aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancedTaskImageProps, aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancerProps, aws_cdk_lib_aws_ecs_patterns_NetworkListenerProps, aws_cdk_lib_aws_ecs_patterns_NetworkTargetProps, aws_cdk_lib_aws_ecs_patterns_NetworkMultipleTargetGroupsServiceBase, aws_cdk_lib_aws_ecs_patterns_NetworkMultipleTargetGroupsEc2ServiceProps, aws_cdk_lib_aws_ecs_patterns_NetworkMultipleTargetGroupsEc2Service, aws_cdk_lib_aws_ecs_patterns_NetworkMultipleTargetGroupsFargateServiceProps, aws_cdk_lib_aws_ecs_patterns_NetworkMultipleTargetGroupsFargateService, aws_cdk_lib_aws_efs_IAccessPoint, aws_cdk_lib_aws_efs_Acl, aws_cdk_lib_aws_efs_PosixUser, aws_cdk_lib_aws_efs_AccessPointOptions, aws_cdk_lib_aws_efs_AccessPointProps, aws_cdk_lib_aws_efs_AccessPointAttributes, aws_cdk_lib_aws_efs_AccessPoint, aws_cdk_lib_aws_efs_LifecyclePolicy, aws_cdk_lib_aws_efs_OutOfInfrequentAccessPolicy, aws_cdk_lib_aws_efs_PerformanceMode, aws_cdk_lib_aws_efs_ThroughputMode, aws_cdk_lib_aws_efs_IFileSystem, aws_cdk_lib_aws_efs_FileSystemProps, aws_cdk_lib_aws_efs_FileSystemAttributes, aws_cdk_lib_aws_efs_FileSystem, aws_cdk_lib_aws_efs_CfnAccessPointProps, aws_cdk_lib_aws_efs_CfnAccessPoint, aws_cdk_lib_aws_efs_CfnAccessPoint_AccessPointTagProperty, aws_cdk_lib_aws_efs_CfnAccessPoint_CreationInfoProperty, aws_cdk_lib_aws_efs_CfnAccessPoint_PosixUserProperty, aws_cdk_lib_aws_efs_CfnAccessPoint_RootDirectoryProperty, aws_cdk_lib_aws_efs_CfnFileSystemProps, aws_cdk_lib_aws_efs_CfnFileSystem, aws_cdk_lib_aws_efs_CfnFileSystem_BackupPolicyProperty, aws_cdk_lib_aws_efs_CfnFileSystem_ElasticFileSystemTagProperty, aws_cdk_lib_aws_efs_CfnFileSystem_LifecyclePolicyProperty, aws_cdk_lib_aws_efs_CfnMountTargetProps, aws_cdk_lib_aws_efs_CfnMountTarget, aws_cdk_lib_aws_eks_AwsAuthProps, aws_cdk_lib_aws_eks_AwsAuth, aws_cdk_lib_aws_eks_AwsAuthMapping, aws_cdk_lib_aws_eks_ICluster, aws_cdk_lib_aws_eks_ClusterAttributes, aws_cdk_lib_aws_eks_CommonClusterOptions, aws_cdk_lib_aws_eks_ClusterOptions, aws_cdk_lib_aws_eks_EndpointAccess, aws_cdk_lib_aws_eks_ClusterProps, aws_cdk_lib_aws_eks_KubernetesVersion, aws_cdk_lib_aws_eks_ClusterLoggingTypes, aws_cdk_lib_aws_eks_ServiceLoadBalancerAddressOptions, aws_cdk_lib_aws_eks_IngressLoadBalancerAddressOptions, aws_cdk_lib_aws_eks_Cluster, aws_cdk_lib_aws_eks_AutoScalingGroupCapacityOptions, aws_cdk_lib_aws_eks_BootstrapOptions, aws_cdk_lib_aws_eks_AutoScalingGroupOptions, aws_cdk_lib_aws_eks_EksOptimizedImageProps, aws_cdk_lib_aws_eks_EksOptimizedImage, aws_cdk_lib_aws_eks_NodeType, aws_cdk_lib_aws_eks_CpuArch, aws_cdk_lib_aws_eks_CoreDnsComputeType, aws_cdk_lib_aws_eks_DefaultCapacityType, aws_cdk_lib_aws_eks_MachineImageType, aws_cdk_lib_aws_eks_CfnAddonProps, aws_cdk_lib_aws_eks_CfnAddon, aws_cdk_lib_aws_eks_CfnClusterProps, aws_cdk_lib_aws_eks_CfnCluster, aws_cdk_lib_aws_eks_CfnCluster_ClusterLoggingProperty, aws_cdk_lib_aws_eks_CfnCluster_ControlPlanePlacementProperty, aws_cdk_lib_aws_eks_CfnCluster_EncryptionConfigProperty, aws_cdk_lib_aws_eks_CfnCluster_KubernetesNetworkConfigProperty, aws_cdk_lib_aws_eks_CfnCluster_LoggingProperty, aws_cdk_lib_aws_eks_CfnCluster_LoggingTypeConfigProperty, aws_cdk_lib_aws_eks_CfnCluster_OutpostConfigProperty, aws_cdk_lib_aws_eks_CfnCluster_ProviderProperty, aws_cdk_lib_aws_eks_CfnCluster_ResourcesVpcConfigProperty, aws_cdk_lib_aws_eks_CfnFargateProfileProps, aws_cdk_lib_aws_eks_CfnFargateProfile, aws_cdk_lib_aws_eks_CfnFargateProfile_LabelProperty, aws_cdk_lib_aws_eks_CfnFargateProfile_SelectorProperty, aws_cdk_lib_aws_eks_CfnIdentityProviderConfigProps, aws_cdk_lib_aws_eks_CfnIdentityProviderConfig, aws_cdk_lib_aws_eks_CfnIdentityProviderConfig_OidcIdentityProviderConfigProperty, aws_cdk_lib_aws_eks_CfnIdentityProviderConfig_RequiredClaimProperty, aws_cdk_lib_aws_eks_CfnNodegroupProps, aws_cdk_lib_aws_eks_CfnNodegroup, aws_cdk_lib_aws_eks_CfnNodegroup_LaunchTemplateSpecificationProperty, aws_cdk_lib_aws_eks_CfnNodegroup_RemoteAccessProperty, aws_cdk_lib_aws_eks_CfnNodegroup_ScalingConfigProperty, aws_cdk_lib_aws_eks_CfnNodegroup_TaintProperty, aws_cdk_lib_aws_eks_CfnNodegroup_UpdateConfigProperty, aws_cdk_lib_aws_eks_FargateProfileOptions, aws_cdk_lib_aws_eks_FargateProfileProps, aws_cdk_lib_aws_eks_Selector, aws_cdk_lib_aws_eks_FargateProfile, aws_cdk_lib_aws_eks_HelmChartOptions, aws_cdk_lib_aws_eks_HelmChartProps, aws_cdk_lib_aws_eks_HelmChart, aws_cdk_lib_aws_eks_KubernetesPatchProps, aws_cdk_lib_aws_eks_PatchType, aws_cdk_lib_aws_eks_KubernetesPatch, aws_cdk_lib_aws_eks_KubernetesManifestOptions, aws_cdk_lib_aws_eks_KubernetesManifestProps, aws_cdk_lib_aws_eks_KubernetesManifest, aws_cdk_lib_aws_eks_KubernetesObjectValueProps, aws_cdk_lib_aws_eks_KubernetesObjectValue, aws_cdk_lib_aws_eks_KubectlProviderProps, aws_cdk_lib_aws_eks_KubectlProviderAttributes, aws_cdk_lib_aws_eks_IKubectlProvider, aws_cdk_lib_aws_eks_KubectlProvider, aws_cdk_lib_aws_eks_FargateClusterProps, aws_cdk_lib_aws_eks_FargateCluster, aws_cdk_lib_aws_eks_ServiceAccountOptions, aws_cdk_lib_aws_eks_ServiceAccountProps, aws_cdk_lib_aws_eks_ServiceAccount, aws_cdk_lib_aws_eks_INodegroup, aws_cdk_lib_aws_eks_NodegroupAmiType, aws_cdk_lib_aws_eks_CapacityType, aws_cdk_lib_aws_eks_NodegroupRemoteAccess, aws_cdk_lib_aws_eks_LaunchTemplateSpec, aws_cdk_lib_aws_eks_TaintEffect, aws_cdk_lib_aws_eks_TaintSpec, aws_cdk_lib_aws_eks_NodegroupOptions, aws_cdk_lib_aws_eks_NodegroupProps, aws_cdk_lib_aws_eks_Nodegroup, aws_cdk_lib_aws_eks_OpenIdConnectProviderProps, aws_cdk_lib_aws_eks_OpenIdConnectProvider, aws_cdk_lib_aws_eks_AlbControllerVersion, aws_cdk_lib_aws_eks_AlbScheme, aws_cdk_lib_aws_eks_AlbControllerOptions, aws_cdk_lib_aws_eks_AlbControllerProps, aws_cdk_lib_aws_eks_AlbController, aws_cdk_lib_aws_elasticache_CfnCacheClusterProps, aws_cdk_lib_aws_elasticache_CfnCacheCluster, aws_cdk_lib_aws_elasticache_CfnCacheCluster_CloudWatchLogsDestinationDetailsProperty, aws_cdk_lib_aws_elasticache_CfnCacheCluster_DestinationDetailsProperty, aws_cdk_lib_aws_elasticache_CfnCacheCluster_KinesisFirehoseDestinationDetailsProperty, aws_cdk_lib_aws_elasticache_CfnCacheCluster_LogDeliveryConfigurationRequestProperty, aws_cdk_lib_aws_elasticache_CfnGlobalReplicationGroupProps, aws_cdk_lib_aws_elasticache_CfnGlobalReplicationGroup, aws_cdk_lib_aws_elasticache_CfnGlobalReplicationGroup_GlobalReplicationGroupMemberProperty, aws_cdk_lib_aws_elasticache_CfnGlobalReplicationGroup_RegionalConfigurationProperty, aws_cdk_lib_aws_elasticache_CfnGlobalReplicationGroup_ReshardingConfigurationProperty, aws_cdk_lib_aws_elasticache_CfnParameterGroupProps, aws_cdk_lib_aws_elasticache_CfnParameterGroup, aws_cdk_lib_aws_elasticache_CfnReplicationGroupProps, aws_cdk_lib_aws_elasticache_CfnReplicationGroup, aws_cdk_lib_aws_elasticache_CfnReplicationGroup_CloudWatchLogsDestinationDetailsProperty, aws_cdk_lib_aws_elasticache_CfnReplicationGroup_DestinationDetailsProperty, aws_cdk_lib_aws_elasticache_CfnReplicationGroup_KinesisFirehoseDestinationDetailsProperty, aws_cdk_lib_aws_elasticache_CfnReplicationGroup_LogDeliveryConfigurationRequestProperty, aws_cdk_lib_aws_elasticache_CfnReplicationGroup_NodeGroupConfigurationProperty, aws_cdk_lib_aws_elasticache_CfnSecurityGroupProps, aws_cdk_lib_aws_elasticache_CfnSecurityGroup, aws_cdk_lib_aws_elasticache_CfnSecurityGroupIngressProps, aws_cdk_lib_aws_elasticache_CfnSecurityGroupIngress, aws_cdk_lib_aws_elasticache_CfnSubnetGroupProps, aws_cdk_lib_aws_elasticache_CfnSubnetGroup, aws_cdk_lib_aws_elasticache_CfnUserProps, aws_cdk_lib_aws_elasticache_CfnUser, aws_cdk_lib_aws_elasticache_CfnUser_AuthenticationModeProperty, aws_cdk_lib_aws_elasticache_CfnUserGroupProps, aws_cdk_lib_aws_elasticache_CfnUserGroup, aws_cdk_lib_aws_elasticbeanstalk_CfnApplicationProps, aws_cdk_lib_aws_elasticbeanstalk_CfnApplication, aws_cdk_lib_aws_elasticbeanstalk_CfnApplication_ApplicationResourceLifecycleConfigProperty, aws_cdk_lib_aws_elasticbeanstalk_CfnApplication_ApplicationVersionLifecycleConfigProperty, aws_cdk_lib_aws_elasticbeanstalk_CfnApplication_MaxAgeRuleProperty, aws_cdk_lib_aws_elasticbeanstalk_CfnApplication_MaxCountRuleProperty, aws_cdk_lib_aws_elasticbeanstalk_CfnApplicationVersionProps, aws_cdk_lib_aws_elasticbeanstalk_CfnApplicationVersion, aws_cdk_lib_aws_elasticbeanstalk_CfnApplicationVersion_SourceBundleProperty, aws_cdk_lib_aws_elasticbeanstalk_CfnConfigurationTemplateProps, aws_cdk_lib_aws_elasticbeanstalk_CfnConfigurationTemplate, aws_cdk_lib_aws_elasticbeanstalk_CfnConfigurationTemplate_ConfigurationOptionSettingProperty, aws_cdk_lib_aws_elasticbeanstalk_CfnConfigurationTemplate_SourceConfigurationProperty, aws_cdk_lib_aws_elasticbeanstalk_CfnEnvironmentProps, aws_cdk_lib_aws_elasticbeanstalk_CfnEnvironment, aws_cdk_lib_aws_elasticbeanstalk_CfnEnvironment_OptionSettingProperty, aws_cdk_lib_aws_elasticbeanstalk_CfnEnvironment_TierProperty, aws_cdk_lib_aws_elasticloadbalancing_CfnLoadBalancerProps, aws_cdk_lib_aws_elasticloadbalancing_CfnLoadBalancer, aws_cdk_lib_aws_elasticloadbalancing_CfnLoadBalancer_AccessLoggingPolicyProperty, aws_cdk_lib_aws_elasticloadbalancing_CfnLoadBalancer_AppCookieStickinessPolicyProperty, aws_cdk_lib_aws_elasticloadbalancing_CfnLoadBalancer_ConnectionDrainingPolicyProperty, aws_cdk_lib_aws_elasticloadbalancing_CfnLoadBalancer_ConnectionSettingsProperty, aws_cdk_lib_aws_elasticloadbalancing_CfnLoadBalancer_HealthCheckProperty, aws_cdk_lib_aws_elasticloadbalancing_CfnLoadBalancer_LBCookieStickinessPolicyProperty, aws_cdk_lib_aws_elasticloadbalancing_CfnLoadBalancer_ListenersProperty, aws_cdk_lib_aws_elasticloadbalancing_CfnLoadBalancer_PoliciesProperty, aws_cdk_lib_aws_elasticloadbalancing_LoadBalancerProps, aws_cdk_lib_aws_elasticloadbalancing_HealthCheck, aws_cdk_lib_aws_elasticloadbalancing_ILoadBalancerTarget, aws_cdk_lib_aws_elasticloadbalancing_LoadBalancerListener, aws_cdk_lib_aws_elasticloadbalancing_LoadBalancingProtocol, aws_cdk_lib_aws_elasticloadbalancing_LoadBalancer, aws_cdk_lib_aws_elasticloadbalancing_InstanceTarget, aws_cdk_lib_aws_elasticloadbalancing_ListenerPort, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerProps, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListener, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListener_ActionProperty, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListener_AuthenticateCognitoConfigProperty, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListener_AuthenticateOidcConfigProperty, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListener_CertificateProperty, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListener_FixedResponseConfigProperty, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListener_ForwardConfigProperty, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListener_RedirectConfigProperty, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListener_TargetGroupStickinessConfigProperty, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListener_TargetGroupTupleProperty, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerCertificateProps, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerCertificate, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerCertificate_CertificateProperty, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRuleProps, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_ActionProperty, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_AuthenticateCognitoConfigProperty, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_AuthenticateOidcConfigProperty, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_FixedResponseConfigProperty, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_ForwardConfigProperty, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_HostHeaderConfigProperty, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_HttpHeaderConfigProperty, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_HttpRequestMethodConfigProperty, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_PathPatternConfigProperty, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_QueryStringConfigProperty, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_QueryStringKeyValueProperty, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_RedirectConfigProperty, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_RuleConditionProperty, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_SourceIpConfigProperty, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_TargetGroupStickinessConfigProperty, aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_TargetGroupTupleProperty, aws_cdk_lib_aws_elasticloadbalancingv2_CfnLoadBalancerProps, aws_cdk_lib_aws_elasticloadbalancingv2_CfnLoadBalancer, aws_cdk_lib_aws_elasticloadbalancingv2_CfnLoadBalancer_LoadBalancerAttributeProperty, aws_cdk_lib_aws_elasticloadbalancingv2_CfnLoadBalancer_SubnetMappingProperty, aws_cdk_lib_aws_elasticloadbalancingv2_CfnTargetGroupProps, aws_cdk_lib_aws_elasticloadbalancingv2_CfnTargetGroup, aws_cdk_lib_aws_elasticloadbalancingv2_CfnTargetGroup_MatcherProperty, aws_cdk_lib_aws_elasticloadbalancingv2_CfnTargetGroup_TargetDescriptionProperty, aws_cdk_lib_aws_elasticloadbalancingv2_CfnTargetGroup_TargetGroupAttributeProperty, aws_cdk_lib_aws_elasticloadbalancingv2_BaseApplicationListenerProps, aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationListenerProps, aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationListenerLookupOptions, aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationListener, aws_cdk_lib_aws_elasticloadbalancingv2_IApplicationListener, aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationListenerAttributes, aws_cdk_lib_aws_elasticloadbalancingv2_AddRuleProps, aws_cdk_lib_aws_elasticloadbalancingv2_AddApplicationTargetGroupsProps, aws_cdk_lib_aws_elasticloadbalancingv2_AddApplicationActionProps, aws_cdk_lib_aws_elasticloadbalancingv2_AddApplicationTargetsProps, aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationListenerCertificateProps, aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationListenerCertificate, aws_cdk_lib_aws_elasticloadbalancingv2_BaseApplicationListenerRuleProps, aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationListenerRuleProps, aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationListenerRule, aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationLoadBalancerProps, aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationLoadBalancerLookupOptions, aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationLoadBalancer, aws_cdk_lib_aws_elasticloadbalancingv2_HttpCodeElb, aws_cdk_lib_aws_elasticloadbalancingv2_HttpCodeTarget, aws_cdk_lib_aws_elasticloadbalancingv2_IApplicationLoadBalancerMetrics, aws_cdk_lib_aws_elasticloadbalancingv2_IApplicationLoadBalancer, aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationLoadBalancerAttributes, aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationLoadBalancerRedirectConfig, aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationTargetGroupProps, aws_cdk_lib_aws_elasticloadbalancingv2_IApplicationTargetGroupMetrics, aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationTargetGroup, aws_cdk_lib_aws_elasticloadbalancingv2_IApplicationTargetGroup, aws_cdk_lib_aws_elasticloadbalancingv2_IApplicationLoadBalancerTarget, aws_cdk_lib_aws_elasticloadbalancingv2_ListenerAction, aws_cdk_lib_aws_elasticloadbalancingv2_ForwardOptions, aws_cdk_lib_aws_elasticloadbalancingv2_WeightedTargetGroup, aws_cdk_lib_aws_elasticloadbalancingv2_FixedResponseOptions, aws_cdk_lib_aws_elasticloadbalancingv2_RedirectOptions, aws_cdk_lib_aws_elasticloadbalancingv2_AuthenticateOidcOptions, aws_cdk_lib_aws_elasticloadbalancingv2_UnauthenticatedAction, aws_cdk_lib_aws_elasticloadbalancingv2_ListenerCondition, aws_cdk_lib_aws_elasticloadbalancingv2_QueryStringCondition, aws_cdk_lib_aws_elasticloadbalancingv2_BaseNetworkListenerProps, aws_cdk_lib_aws_elasticloadbalancingv2_NetworkListenerProps, aws_cdk_lib_aws_elasticloadbalancingv2_NetworkListenerLookupOptions, aws_cdk_lib_aws_elasticloadbalancingv2_NetworkListener, aws_cdk_lib_aws_elasticloadbalancingv2_INetworkListener, aws_cdk_lib_aws_elasticloadbalancingv2_AddNetworkActionProps, aws_cdk_lib_aws_elasticloadbalancingv2_AddNetworkTargetsProps, aws_cdk_lib_aws_elasticloadbalancingv2_NetworkLoadBalancerProps, aws_cdk_lib_aws_elasticloadbalancingv2_NetworkLoadBalancerAttributes, aws_cdk_lib_aws_elasticloadbalancingv2_NetworkLoadBalancerLookupOptions, aws_cdk_lib_aws_elasticloadbalancingv2_NetworkLoadBalancer, aws_cdk_lib_aws_elasticloadbalancingv2_INetworkLoadBalancerMetrics, aws_cdk_lib_aws_elasticloadbalancingv2_INetworkLoadBalancer, aws_cdk_lib_aws_elasticloadbalancingv2_NetworkTargetGroupProps, aws_cdk_lib_aws_elasticloadbalancingv2_INetworkTargetGroupMetrics, aws_cdk_lib_aws_elasticloadbalancingv2_NetworkTargetGroup, aws_cdk_lib_aws_elasticloadbalancingv2_INetworkTargetGroup, aws_cdk_lib_aws_elasticloadbalancingv2_INetworkLoadBalancerTarget, aws_cdk_lib_aws_elasticloadbalancingv2_NetworkListenerAction, aws_cdk_lib_aws_elasticloadbalancingv2_NetworkForwardOptions, aws_cdk_lib_aws_elasticloadbalancingv2_NetworkWeightedTargetGroup, aws_cdk_lib_aws_elasticloadbalancingv2_BaseListenerLookupOptions, aws_cdk_lib_aws_elasticloadbalancingv2_IListener, aws_cdk_lib_aws_elasticloadbalancingv2_BaseListener, aws_cdk_lib_aws_elasticloadbalancingv2_BaseLoadBalancerProps, aws_cdk_lib_aws_elasticloadbalancingv2_ILoadBalancerV2, aws_cdk_lib_aws_elasticloadbalancingv2_BaseLoadBalancerLookupOptions, aws_cdk_lib_aws_elasticloadbalancingv2_BaseLoadBalancer, aws_cdk_lib_aws_elasticloadbalancingv2_BaseTargetGroupProps, aws_cdk_lib_aws_elasticloadbalancingv2_HealthCheck, aws_cdk_lib_aws_elasticloadbalancingv2_TargetGroupBase, aws_cdk_lib_aws_elasticloadbalancingv2_TargetGroupAttributes, aws_cdk_lib_aws_elasticloadbalancingv2_ITargetGroup, aws_cdk_lib_aws_elasticloadbalancingv2_LoadBalancerTargetProps, aws_cdk_lib_aws_elasticloadbalancingv2_IpAddressType, aws_cdk_lib_aws_elasticloadbalancingv2_Protocol, aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationProtocol, aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationProtocolVersion, aws_cdk_lib_aws_elasticloadbalancingv2_SslPolicy, aws_cdk_lib_aws_elasticloadbalancingv2_TargetType, aws_cdk_lib_aws_elasticloadbalancingv2_AlpnPolicy, aws_cdk_lib_aws_elasticloadbalancingv2_TargetGroupLoadBalancingAlgorithmType, aws_cdk_lib_aws_elasticloadbalancingv2_DesyncMitigationMode, aws_cdk_lib_aws_elasticloadbalancingv2_IListenerCertificate, aws_cdk_lib_aws_elasticloadbalancingv2_ListenerCertificate, aws_cdk_lib_aws_elasticloadbalancingv2_IListenerAction, aws_cdk_lib_aws_elasticloadbalancingv2_actions_AuthenticateCognitoActionProps, aws_cdk_lib_aws_elasticloadbalancingv2_actions_AuthenticateCognitoAction, aws_cdk_lib_aws_elasticloadbalancingv2_targets_AlbArnTarget, aws_cdk_lib_aws_elasticloadbalancingv2_targets_AlbTarget, aws_cdk_lib_aws_elasticloadbalancingv2_targets_IpTarget, aws_cdk_lib_aws_elasticloadbalancingv2_targets_InstanceIdTarget, aws_cdk_lib_aws_elasticloadbalancingv2_targets_InstanceTarget, aws_cdk_lib_aws_elasticloadbalancingv2_targets_LambdaTarget, aws_cdk_lib_aws_elasticsearch_ElasticsearchVersion, aws_cdk_lib_aws_elasticsearch_CapacityConfig, aws_cdk_lib_aws_elasticsearch_ZoneAwarenessConfig, aws_cdk_lib_aws_elasticsearch_EbsOptions, aws_cdk_lib_aws_elasticsearch_LoggingOptions, aws_cdk_lib_aws_elasticsearch_EncryptionAtRestOptions, aws_cdk_lib_aws_elasticsearch_CognitoOptions, aws_cdk_lib_aws_elasticsearch_TLSSecurityPolicy, aws_cdk_lib_aws_elasticsearch_AdvancedSecurityOptions, aws_cdk_lib_aws_elasticsearch_CustomEndpointOptions, aws_cdk_lib_aws_elasticsearch_DomainProps, aws_cdk_lib_aws_elasticsearch_IDomain, aws_cdk_lib_aws_elasticsearch_DomainAttributes, aws_cdk_lib_aws_elasticsearch_Domain, aws_cdk_lib_aws_elasticsearch_CfnDomainProps, aws_cdk_lib_aws_elasticsearch_CfnDomain, aws_cdk_lib_aws_elasticsearch_CfnDomain_AdvancedSecurityOptionsInputProperty, aws_cdk_lib_aws_elasticsearch_CfnDomain_CognitoOptionsProperty, aws_cdk_lib_aws_elasticsearch_CfnDomain_ColdStorageOptionsProperty, aws_cdk_lib_aws_elasticsearch_CfnDomain_DomainEndpointOptionsProperty, aws_cdk_lib_aws_elasticsearch_CfnDomain_EBSOptionsProperty, aws_cdk_lib_aws_elasticsearch_CfnDomain_ElasticsearchClusterConfigProperty, aws_cdk_lib_aws_elasticsearch_CfnDomain_EncryptionAtRestOptionsProperty, aws_cdk_lib_aws_elasticsearch_CfnDomain_LogPublishingOptionProperty, aws_cdk_lib_aws_elasticsearch_CfnDomain_MasterUserOptionsProperty, aws_cdk_lib_aws_elasticsearch_CfnDomain_NodeToNodeEncryptionOptionsProperty, aws_cdk_lib_aws_elasticsearch_CfnDomain_SnapshotOptionsProperty, aws_cdk_lib_aws_elasticsearch_CfnDomain_VPCOptionsProperty, aws_cdk_lib_aws_elasticsearch_CfnDomain_ZoneAwarenessConfigProperty, aws_cdk_lib_aws_emr_CfnClusterProps, aws_cdk_lib_aws_emr_CfnCluster, aws_cdk_lib_aws_emr_CfnCluster_ApplicationProperty, aws_cdk_lib_aws_emr_CfnCluster_AutoScalingPolicyProperty, aws_cdk_lib_aws_emr_CfnCluster_AutoTerminationPolicyProperty, aws_cdk_lib_aws_emr_CfnCluster_BootstrapActionConfigProperty, aws_cdk_lib_aws_emr_CfnCluster_CloudWatchAlarmDefinitionProperty, aws_cdk_lib_aws_emr_CfnCluster_ComputeLimitsProperty, aws_cdk_lib_aws_emr_CfnCluster_ConfigurationProperty, aws_cdk_lib_aws_emr_CfnCluster_EbsBlockDeviceConfigProperty, aws_cdk_lib_aws_emr_CfnCluster_EbsConfigurationProperty, aws_cdk_lib_aws_emr_CfnCluster_HadoopJarStepConfigProperty, aws_cdk_lib_aws_emr_CfnCluster_InstanceFleetConfigProperty, aws_cdk_lib_aws_emr_CfnCluster_InstanceFleetProvisioningSpecificationsProperty, aws_cdk_lib_aws_emr_CfnCluster_InstanceGroupConfigProperty, aws_cdk_lib_aws_emr_CfnCluster_InstanceTypeConfigProperty, aws_cdk_lib_aws_emr_CfnCluster_JobFlowInstancesConfigProperty, aws_cdk_lib_aws_emr_CfnCluster_KerberosAttributesProperty, aws_cdk_lib_aws_emr_CfnCluster_KeyValueProperty, aws_cdk_lib_aws_emr_CfnCluster_ManagedScalingPolicyProperty, aws_cdk_lib_aws_emr_CfnCluster_MetricDimensionProperty, aws_cdk_lib_aws_emr_CfnCluster_OnDemandProvisioningSpecificationProperty, aws_cdk_lib_aws_emr_CfnCluster_PlacementTypeProperty, aws_cdk_lib_aws_emr_CfnCluster_ScalingActionProperty, aws_cdk_lib_aws_emr_CfnCluster_ScalingConstraintsProperty, aws_cdk_lib_aws_emr_CfnCluster_ScalingRuleProperty, aws_cdk_lib_aws_emr_CfnCluster_ScalingTriggerProperty, aws_cdk_lib_aws_emr_CfnCluster_ScriptBootstrapActionConfigProperty, aws_cdk_lib_aws_emr_CfnCluster_SimpleScalingPolicyConfigurationProperty, aws_cdk_lib_aws_emr_CfnCluster_SpotProvisioningSpecificationProperty, aws_cdk_lib_aws_emr_CfnCluster_StepConfigProperty, aws_cdk_lib_aws_emr_CfnCluster_VolumeSpecificationProperty, aws_cdk_lib_aws_emr_CfnInstanceFleetConfigProps, aws_cdk_lib_aws_emr_CfnInstanceFleetConfig, aws_cdk_lib_aws_emr_CfnInstanceFleetConfig_ConfigurationProperty, aws_cdk_lib_aws_emr_CfnInstanceFleetConfig_EbsBlockDeviceConfigProperty, aws_cdk_lib_aws_emr_CfnInstanceFleetConfig_EbsConfigurationProperty, aws_cdk_lib_aws_emr_CfnInstanceFleetConfig_InstanceFleetProvisioningSpecificationsProperty, aws_cdk_lib_aws_emr_CfnInstanceFleetConfig_InstanceTypeConfigProperty, aws_cdk_lib_aws_emr_CfnInstanceFleetConfig_OnDemandProvisioningSpecificationProperty, aws_cdk_lib_aws_emr_CfnInstanceFleetConfig_SpotProvisioningSpecificationProperty, aws_cdk_lib_aws_emr_CfnInstanceFleetConfig_VolumeSpecificationProperty, aws_cdk_lib_aws_emr_CfnInstanceGroupConfigProps, aws_cdk_lib_aws_emr_CfnInstanceGroupConfig, aws_cdk_lib_aws_emr_CfnInstanceGroupConfig_AutoScalingPolicyProperty, aws_cdk_lib_aws_emr_CfnInstanceGroupConfig_CloudWatchAlarmDefinitionProperty, aws_cdk_lib_aws_emr_CfnInstanceGroupConfig_ConfigurationProperty, aws_cdk_lib_aws_emr_CfnInstanceGroupConfig_EbsBlockDeviceConfigProperty, aws_cdk_lib_aws_emr_CfnInstanceGroupConfig_EbsConfigurationProperty, aws_cdk_lib_aws_emr_CfnInstanceGroupConfig_MetricDimensionProperty, aws_cdk_lib_aws_emr_CfnInstanceGroupConfig_ScalingActionProperty, aws_cdk_lib_aws_emr_CfnInstanceGroupConfig_ScalingConstraintsProperty, aws_cdk_lib_aws_emr_CfnInstanceGroupConfig_ScalingRuleProperty, aws_cdk_lib_aws_emr_CfnInstanceGroupConfig_ScalingTriggerProperty, aws_cdk_lib_aws_emr_CfnInstanceGroupConfig_SimpleScalingPolicyConfigurationProperty, aws_cdk_lib_aws_emr_CfnInstanceGroupConfig_VolumeSpecificationProperty, aws_cdk_lib_aws_emr_CfnSecurityConfigurationProps, aws_cdk_lib_aws_emr_CfnSecurityConfiguration, aws_cdk_lib_aws_emr_CfnStepProps, aws_cdk_lib_aws_emr_CfnStep, aws_cdk_lib_aws_emr_CfnStep_HadoopJarStepConfigProperty, aws_cdk_lib_aws_emr_CfnStep_KeyValueProperty, aws_cdk_lib_aws_emr_CfnStudioProps, aws_cdk_lib_aws_emr_CfnStudio, aws_cdk_lib_aws_emr_CfnStudioSessionMappingProps, aws_cdk_lib_aws_emr_CfnStudioSessionMapping, aws_cdk_lib_aws_emrcontainers_CfnVirtualClusterProps, aws_cdk_lib_aws_emrcontainers_CfnVirtualCluster, aws_cdk_lib_aws_emrcontainers_CfnVirtualCluster_ContainerInfoProperty, aws_cdk_lib_aws_emrcontainers_CfnVirtualCluster_ContainerProviderProperty, aws_cdk_lib_aws_emrcontainers_CfnVirtualCluster_EksInfoProperty, aws_cdk_lib_aws_emrserverless_CfnApplicationProps, aws_cdk_lib_aws_emrserverless_CfnApplication, aws_cdk_lib_aws_emrserverless_CfnApplication_AutoStartConfigurationProperty, aws_cdk_lib_aws_emrserverless_CfnApplication_AutoStopConfigurationProperty, aws_cdk_lib_aws_emrserverless_CfnApplication_ImageConfigurationInputProperty, aws_cdk_lib_aws_emrserverless_CfnApplication_InitialCapacityConfigProperty, aws_cdk_lib_aws_emrserverless_CfnApplication_InitialCapacityConfigKeyValuePairProperty, aws_cdk_lib_aws_emrserverless_CfnApplication_MaximumAllowedResourcesProperty, aws_cdk_lib_aws_emrserverless_CfnApplication_NetworkConfigurationProperty, aws_cdk_lib_aws_emrserverless_CfnApplication_WorkerConfigurationProperty, aws_cdk_lib_aws_emrserverless_CfnApplication_WorkerTypeSpecificationInputProperty, aws_cdk_lib_aws_events_RuleTargetInput, aws_cdk_lib_aws_events_RuleTargetInputProperties, aws_cdk_lib_aws_events_EventField, aws_cdk_lib_aws_events_RuleProps, aws_cdk_lib_aws_events_Rule, aws_cdk_lib_aws_events_IRule, aws_cdk_lib_aws_events_IRuleTarget, aws_cdk_lib_aws_events_RuleTargetConfig, aws_cdk_lib_aws_events_IEventBus, aws_cdk_lib_aws_events_EventBusProps, aws_cdk_lib_aws_events_EventBusAttributes, aws_cdk_lib_aws_events_EventBus, aws_cdk_lib_aws_events_EventBusPolicyProps, aws_cdk_lib_aws_events_EventBusPolicy, aws_cdk_lib_aws_events_Match, aws_cdk_lib_aws_events_EventPattern, aws_cdk_lib_aws_events_Schedule, aws_cdk_lib_aws_events_CronOptions, aws_cdk_lib_aws_events_EventCommonOptions, aws_cdk_lib_aws_events_OnEventOptions, aws_cdk_lib_aws_events_BaseArchiveProps, aws_cdk_lib_aws_events_ArchiveProps, aws_cdk_lib_aws_events_Archive, aws_cdk_lib_aws_events_ConnectionProps, aws_cdk_lib_aws_events_Authorization, aws_cdk_lib_aws_events_OAuthAuthorizationProps, aws_cdk_lib_aws_events_HttpParameter, aws_cdk_lib_aws_events_IConnection, aws_cdk_lib_aws_events_ConnectionAttributes, aws_cdk_lib_aws_events_Connection, aws_cdk_lib_aws_events_HttpMethod, aws_cdk_lib_aws_events_ApiDestinationProps, aws_cdk_lib_aws_events_IApiDestination, aws_cdk_lib_aws_events_ApiDestination, aws_cdk_lib_aws_events_CfnApiDestinationProps, aws_cdk_lib_aws_events_CfnApiDestination, aws_cdk_lib_aws_events_CfnArchiveProps, aws_cdk_lib_aws_events_CfnArchive, aws_cdk_lib_aws_events_CfnConnectionProps, aws_cdk_lib_aws_events_CfnConnection, aws_cdk_lib_aws_events_CfnConnection_ApiKeyAuthParametersProperty, aws_cdk_lib_aws_events_CfnConnection_AuthParametersProperty, aws_cdk_lib_aws_events_CfnConnection_BasicAuthParametersProperty, aws_cdk_lib_aws_events_CfnConnection_ClientParametersProperty, aws_cdk_lib_aws_events_CfnConnection_ConnectionHttpParametersProperty, aws_cdk_lib_aws_events_CfnConnection_OAuthParametersProperty, aws_cdk_lib_aws_events_CfnConnection_ParameterProperty, aws_cdk_lib_aws_events_CfnEndpointProps, aws_cdk_lib_aws_events_CfnEndpoint, aws_cdk_lib_aws_events_CfnEndpoint_EndpointEventBusProperty, aws_cdk_lib_aws_events_CfnEndpoint_FailoverConfigProperty, aws_cdk_lib_aws_events_CfnEndpoint_PrimaryProperty, aws_cdk_lib_aws_events_CfnEndpoint_ReplicationConfigProperty, aws_cdk_lib_aws_events_CfnEndpoint_RoutingConfigProperty, aws_cdk_lib_aws_events_CfnEndpoint_SecondaryProperty, aws_cdk_lib_aws_events_CfnEventBusProps, aws_cdk_lib_aws_events_CfnEventBus, aws_cdk_lib_aws_events_CfnEventBus_TagEntryProperty, aws_cdk_lib_aws_events_CfnEventBusPolicyProps, aws_cdk_lib_aws_events_CfnEventBusPolicy, aws_cdk_lib_aws_events_CfnEventBusPolicy_ConditionProperty, aws_cdk_lib_aws_events_CfnRuleProps, aws_cdk_lib_aws_events_CfnRule, aws_cdk_lib_aws_events_CfnRule_AwsVpcConfigurationProperty, aws_cdk_lib_aws_events_CfnRule_BatchArrayPropertiesProperty, aws_cdk_lib_aws_events_CfnRule_BatchParametersProperty, aws_cdk_lib_aws_events_CfnRule_BatchRetryStrategyProperty, aws_cdk_lib_aws_events_CfnRule_CapacityProviderStrategyItemProperty, aws_cdk_lib_aws_events_CfnRule_DeadLetterConfigProperty, aws_cdk_lib_aws_events_CfnRule_EcsParametersProperty, aws_cdk_lib_aws_events_CfnRule_HttpParametersProperty, aws_cdk_lib_aws_events_CfnRule_InputTransformerProperty, aws_cdk_lib_aws_events_CfnRule_KinesisParametersProperty, aws_cdk_lib_aws_events_CfnRule_NetworkConfigurationProperty, aws_cdk_lib_aws_events_CfnRule_PlacementConstraintProperty, aws_cdk_lib_aws_events_CfnRule_PlacementStrategyProperty, aws_cdk_lib_aws_events_CfnRule_RedshiftDataParametersProperty, aws_cdk_lib_aws_events_CfnRule_RetryPolicyProperty, aws_cdk_lib_aws_events_CfnRule_RunCommandParametersProperty, aws_cdk_lib_aws_events_CfnRule_RunCommandTargetProperty, aws_cdk_lib_aws_events_CfnRule_SageMakerPipelineParameterProperty, aws_cdk_lib_aws_events_CfnRule_SageMakerPipelineParametersProperty, aws_cdk_lib_aws_events_CfnRule_SqsParametersProperty, aws_cdk_lib_aws_events_CfnRule_TagProperty, aws_cdk_lib_aws_events_CfnRule_TargetProperty, aws_cdk_lib_aws_events_targets_BatchJobProps, aws_cdk_lib_aws_events_targets_BatchJob, aws_cdk_lib_aws_events_targets_CodePipelineTargetOptions, aws_cdk_lib_aws_events_targets_CodePipeline, aws_cdk_lib_aws_events_targets_SnsTopicProps, aws_cdk_lib_aws_events_targets_SnsTopic, aws_cdk_lib_aws_events_targets_SqsQueueProps, aws_cdk_lib_aws_events_targets_SqsQueue, aws_cdk_lib_aws_events_targets_CodeBuildProjectProps, aws_cdk_lib_aws_events_targets_CodeBuildProject, aws_cdk_lib_aws_events_targets_AwsApiInput, aws_cdk_lib_aws_events_targets_AwsApiProps, aws_cdk_lib_aws_events_targets_AwsApi, aws_cdk_lib_aws_events_targets_LambdaFunctionProps, aws_cdk_lib_aws_events_targets_LambdaFunction, aws_cdk_lib_aws_events_targets_ContainerOverride, aws_cdk_lib_aws_events_targets_TaskEnvironmentVariable, aws_cdk_lib_aws_events_targets_Tag, aws_cdk_lib_aws_events_targets_EcsTaskProps, aws_cdk_lib_aws_events_targets_EcsTask, aws_cdk_lib_aws_events_targets_EventBusProps, aws_cdk_lib_aws_events_targets_EventBus, aws_cdk_lib_aws_events_targets_SfnStateMachineProps, aws_cdk_lib_aws_events_targets_SfnStateMachine, aws_cdk_lib_aws_events_targets_KinesisStreamProps, aws_cdk_lib_aws_events_targets_KinesisStream, aws_cdk_lib_aws_events_targets_LogGroupTargetInputOptions, aws_cdk_lib_aws_events_targets_LogGroupTargetInput, aws_cdk_lib_aws_events_targets_LogGroupProps, aws_cdk_lib_aws_events_targets_CloudWatchLogGroup, aws_cdk_lib_aws_events_targets_KinesisFirehoseStreamProps, aws_cdk_lib_aws_events_targets_KinesisFirehoseStream, aws_cdk_lib_aws_events_targets_ApiGatewayProps, aws_cdk_lib_aws_events_targets_ApiGateway, aws_cdk_lib_aws_events_targets_ApiDestinationProps, aws_cdk_lib_aws_events_targets_ApiDestination, aws_cdk_lib_aws_events_targets_TargetBaseProps, aws_cdk_lib_aws_eventschemas_CfnDiscovererProps, aws_cdk_lib_aws_eventschemas_CfnDiscoverer, aws_cdk_lib_aws_eventschemas_CfnDiscoverer_TagsEntryProperty, aws_cdk_lib_aws_eventschemas_CfnRegistryProps, aws_cdk_lib_aws_eventschemas_CfnRegistry, aws_cdk_lib_aws_eventschemas_CfnRegistry_TagsEntryProperty, aws_cdk_lib_aws_eventschemas_CfnRegistryPolicyProps, aws_cdk_lib_aws_eventschemas_CfnRegistryPolicy, aws_cdk_lib_aws_eventschemas_CfnSchemaProps, aws_cdk_lib_aws_eventschemas_CfnSchema, aws_cdk_lib_aws_eventschemas_CfnSchema_TagsEntryProperty, aws_cdk_lib_aws_evidently_CfnExperimentProps, aws_cdk_lib_aws_evidently_CfnExperiment, aws_cdk_lib_aws_evidently_CfnExperiment_MetricGoalObjectProperty, aws_cdk_lib_aws_evidently_CfnExperiment_OnlineAbConfigObjectProperty, aws_cdk_lib_aws_evidently_CfnExperiment_RunningStatusObjectProperty, aws_cdk_lib_aws_evidently_CfnExperiment_TreatmentObjectProperty, aws_cdk_lib_aws_evidently_CfnExperiment_TreatmentToWeightProperty, aws_cdk_lib_aws_evidently_CfnFeatureProps, aws_cdk_lib_aws_evidently_CfnFeature, aws_cdk_lib_aws_evidently_CfnFeature_EntityOverrideProperty, aws_cdk_lib_aws_evidently_CfnFeature_VariationObjectProperty, aws_cdk_lib_aws_evidently_CfnLaunchProps, aws_cdk_lib_aws_evidently_CfnLaunch, aws_cdk_lib_aws_evidently_CfnLaunch_ExecutionStatusObjectProperty, aws_cdk_lib_aws_evidently_CfnLaunch_GroupToWeightProperty, aws_cdk_lib_aws_evidently_CfnLaunch_LaunchGroupObjectProperty, aws_cdk_lib_aws_evidently_CfnLaunch_MetricDefinitionObjectProperty, aws_cdk_lib_aws_evidently_CfnLaunch_SegmentOverrideProperty, aws_cdk_lib_aws_evidently_CfnLaunch_StepConfigProperty, aws_cdk_lib_aws_evidently_CfnProjectProps, aws_cdk_lib_aws_evidently_CfnProject, aws_cdk_lib_aws_evidently_CfnProject_AppConfigResourceObjectProperty, aws_cdk_lib_aws_evidently_CfnProject_DataDeliveryObjectProperty, aws_cdk_lib_aws_evidently_CfnProject_S3DestinationProperty, aws_cdk_lib_aws_evidently_CfnSegmentProps, aws_cdk_lib_aws_evidently_CfnSegment, aws_cdk_lib_aws_finspace_CfnEnvironmentProps, aws_cdk_lib_aws_finspace_CfnEnvironment, aws_cdk_lib_aws_finspace_CfnEnvironment_AttributeMapItemsProperty, aws_cdk_lib_aws_finspace_CfnEnvironment_FederationParametersProperty, aws_cdk_lib_aws_finspace_CfnEnvironment_SuperuserParametersProperty, aws_cdk_lib_aws_fis_CfnExperimentTemplateProps, aws_cdk_lib_aws_fis_CfnExperimentTemplate, aws_cdk_lib_aws_fis_CfnExperimentTemplate_CloudWatchLogsConfigurationProperty, aws_cdk_lib_aws_fis_CfnExperimentTemplate_ExperimentTemplateActionProperty, aws_cdk_lib_aws_fis_CfnExperimentTemplate_ExperimentTemplateLogConfigurationProperty, aws_cdk_lib_aws_fis_CfnExperimentTemplate_ExperimentTemplateStopConditionProperty, aws_cdk_lib_aws_fis_CfnExperimentTemplate_ExperimentTemplateTargetProperty, aws_cdk_lib_aws_fis_CfnExperimentTemplate_ExperimentTemplateTargetFilterProperty, aws_cdk_lib_aws_fis_CfnExperimentTemplate_S3ConfigurationProperty, aws_cdk_lib_aws_fms_CfnNotificationChannelProps, aws_cdk_lib_aws_fms_CfnNotificationChannel, aws_cdk_lib_aws_fms_CfnPolicyProps, aws_cdk_lib_aws_fms_CfnPolicy, aws_cdk_lib_aws_fms_CfnPolicy_IEMapProperty, aws_cdk_lib_aws_fms_CfnPolicy_NetworkFirewallPolicyProperty, aws_cdk_lib_aws_fms_CfnPolicy_PolicyOptionProperty, aws_cdk_lib_aws_fms_CfnPolicy_PolicyTagProperty, aws_cdk_lib_aws_fms_CfnPolicy_ResourceTagProperty, aws_cdk_lib_aws_fms_CfnPolicy_SecurityServicePolicyDataProperty, aws_cdk_lib_aws_fms_CfnPolicy_ThirdPartyFirewallPolicyProperty, aws_cdk_lib_aws_fms_CfnResourceSetProps, aws_cdk_lib_aws_fms_CfnResourceSet, aws_cdk_lib_aws_forecast_CfnDatasetProps, aws_cdk_lib_aws_forecast_CfnDataset, aws_cdk_lib_aws_forecast_CfnDataset_AttributesItemsProperty, aws_cdk_lib_aws_forecast_CfnDataset_EncryptionConfigProperty, aws_cdk_lib_aws_forecast_CfnDataset_SchemaProperty, aws_cdk_lib_aws_forecast_CfnDataset_TagsItemsProperty, aws_cdk_lib_aws_forecast_CfnDatasetGroupProps, aws_cdk_lib_aws_forecast_CfnDatasetGroup, aws_cdk_lib_aws_frauddetector_CfnDetectorProps, aws_cdk_lib_aws_frauddetector_CfnDetector, aws_cdk_lib_aws_frauddetector_CfnDetector_EntityTypeProperty, aws_cdk_lib_aws_frauddetector_CfnDetector_EventTypeProperty, aws_cdk_lib_aws_frauddetector_CfnDetector_EventVariableProperty, aws_cdk_lib_aws_frauddetector_CfnDetector_LabelProperty, aws_cdk_lib_aws_frauddetector_CfnDetector_ModelProperty, aws_cdk_lib_aws_frauddetector_CfnDetector_OutcomeProperty, aws_cdk_lib_aws_frauddetector_CfnDetector_RuleProperty, aws_cdk_lib_aws_frauddetector_CfnEntityTypeProps, aws_cdk_lib_aws_frauddetector_CfnEntityType, aws_cdk_lib_aws_frauddetector_CfnEventTypeProps, aws_cdk_lib_aws_frauddetector_CfnEventType, aws_cdk_lib_aws_frauddetector_CfnEventType_EntityTypeProperty, aws_cdk_lib_aws_frauddetector_CfnEventType_EventVariableProperty, aws_cdk_lib_aws_frauddetector_CfnEventType_LabelProperty, aws_cdk_lib_aws_frauddetector_CfnLabelProps, aws_cdk_lib_aws_frauddetector_CfnLabel, aws_cdk_lib_aws_frauddetector_CfnListProps, aws_cdk_lib_aws_frauddetector_CfnList, aws_cdk_lib_aws_frauddetector_CfnOutcomeProps, aws_cdk_lib_aws_frauddetector_CfnOutcome, aws_cdk_lib_aws_frauddetector_CfnVariableProps, aws_cdk_lib_aws_frauddetector_CfnVariable, aws_cdk_lib_aws_fsx_IFileSystem, aws_cdk_lib_aws_fsx_FileSystemProps, aws_cdk_lib_aws_fsx_FileSystemBase, aws_cdk_lib_aws_fsx_FileSystemAttributes, aws_cdk_lib_aws_fsx_CfnDataRepositoryAssociationProps, aws_cdk_lib_aws_fsx_CfnDataRepositoryAssociation, aws_cdk_lib_aws_fsx_CfnDataRepositoryAssociation_AutoExportPolicyProperty, aws_cdk_lib_aws_fsx_CfnDataRepositoryAssociation_AutoImportPolicyProperty, aws_cdk_lib_aws_fsx_CfnDataRepositoryAssociation_S3Property, aws_cdk_lib_aws_fsx_CfnFileSystemProps, aws_cdk_lib_aws_fsx_CfnFileSystem, aws_cdk_lib_aws_fsx_CfnFileSystem_AuditLogConfigurationProperty, aws_cdk_lib_aws_fsx_CfnFileSystem_ClientConfigurationsProperty, aws_cdk_lib_aws_fsx_CfnFileSystem_DiskIopsConfigurationProperty, aws_cdk_lib_aws_fsx_CfnFileSystem_LustreConfigurationProperty, aws_cdk_lib_aws_fsx_CfnFileSystem_NfsExportsProperty, aws_cdk_lib_aws_fsx_CfnFileSystem_OntapConfigurationProperty, aws_cdk_lib_aws_fsx_CfnFileSystem_OpenZFSConfigurationProperty, aws_cdk_lib_aws_fsx_CfnFileSystem_RootVolumeConfigurationProperty, aws_cdk_lib_aws_fsx_CfnFileSystem_SelfManagedActiveDirectoryConfigurationProperty, aws_cdk_lib_aws_fsx_CfnFileSystem_UserAndGroupQuotasProperty, aws_cdk_lib_aws_fsx_CfnFileSystem_WindowsConfigurationProperty, aws_cdk_lib_aws_fsx_CfnSnapshotProps, aws_cdk_lib_aws_fsx_CfnSnapshot, aws_cdk_lib_aws_fsx_CfnStorageVirtualMachineProps, aws_cdk_lib_aws_fsx_CfnStorageVirtualMachine, aws_cdk_lib_aws_fsx_CfnStorageVirtualMachine_ActiveDirectoryConfigurationProperty, aws_cdk_lib_aws_fsx_CfnStorageVirtualMachine_SelfManagedActiveDirectoryConfigurationProperty, aws_cdk_lib_aws_fsx_CfnVolumeProps, aws_cdk_lib_aws_fsx_CfnVolume, aws_cdk_lib_aws_fsx_CfnVolume_ClientConfigurationsProperty, aws_cdk_lib_aws_fsx_CfnVolume_NfsExportsProperty, aws_cdk_lib_aws_fsx_CfnVolume_OntapConfigurationProperty, aws_cdk_lib_aws_fsx_CfnVolume_OpenZFSConfigurationProperty, aws_cdk_lib_aws_fsx_CfnVolume_OriginSnapshotProperty, aws_cdk_lib_aws_fsx_CfnVolume_TieringPolicyProperty, aws_cdk_lib_aws_fsx_CfnVolume_UserAndGroupQuotasProperty, aws_cdk_lib_aws_fsx_LustreDeploymentType, aws_cdk_lib_aws_fsx_LustreAutoImportPolicy, aws_cdk_lib_aws_fsx_LustreDataCompressionType, aws_cdk_lib_aws_fsx_LustreConfiguration, aws_cdk_lib_aws_fsx_LustreFileSystemProps, aws_cdk_lib_aws_fsx_LustreFileSystem, aws_cdk_lib_aws_fsx_Weekday, aws_cdk_lib_aws_fsx_LustreMaintenanceTimeProps, aws_cdk_lib_aws_fsx_LustreMaintenanceTime, aws_cdk_lib_aws_gamelift_CfnAliasProps, aws_cdk_lib_aws_gamelift_CfnAlias, aws_cdk_lib_aws_gamelift_CfnAlias_RoutingStrategyProperty, aws_cdk_lib_aws_gamelift_CfnBuildProps, aws_cdk_lib_aws_gamelift_CfnBuild, aws_cdk_lib_aws_gamelift_CfnBuild_StorageLocationProperty, aws_cdk_lib_aws_gamelift_CfnFleetProps, aws_cdk_lib_aws_gamelift_CfnFleet, aws_cdk_lib_aws_gamelift_CfnFleet_AnywhereConfigurationProperty, aws_cdk_lib_aws_gamelift_CfnFleet_CertificateConfigurationProperty, aws_cdk_lib_aws_gamelift_CfnFleet_IpPermissionProperty, aws_cdk_lib_aws_gamelift_CfnFleet_LocationCapacityProperty, aws_cdk_lib_aws_gamelift_CfnFleet_LocationConfigurationProperty, aws_cdk_lib_aws_gamelift_CfnFleet_ResourceCreationLimitPolicyProperty, aws_cdk_lib_aws_gamelift_CfnFleet_RuntimeConfigurationProperty, aws_cdk_lib_aws_gamelift_CfnFleet_ServerProcessProperty, aws_cdk_lib_aws_gamelift_CfnGameServerGroupProps, aws_cdk_lib_aws_gamelift_CfnGameServerGroup, aws_cdk_lib_aws_gamelift_CfnGameServerGroup_AutoScalingPolicyProperty, aws_cdk_lib_aws_gamelift_CfnGameServerGroup_InstanceDefinitionProperty, aws_cdk_lib_aws_gamelift_CfnGameServerGroup_LaunchTemplateProperty, aws_cdk_lib_aws_gamelift_CfnGameServerGroup_TargetTrackingConfigurationProperty, aws_cdk_lib_aws_gamelift_CfnGameSessionQueueProps, aws_cdk_lib_aws_gamelift_CfnGameSessionQueue, aws_cdk_lib_aws_gamelift_CfnGameSessionQueue_DestinationProperty, aws_cdk_lib_aws_gamelift_CfnGameSessionQueue_FilterConfigurationProperty, aws_cdk_lib_aws_gamelift_CfnGameSessionQueue_PlayerLatencyPolicyProperty, aws_cdk_lib_aws_gamelift_CfnGameSessionQueue_PriorityConfigurationProperty, aws_cdk_lib_aws_gamelift_CfnLocationProps, aws_cdk_lib_aws_gamelift_CfnLocation, aws_cdk_lib_aws_gamelift_CfnMatchmakingConfigurationProps, aws_cdk_lib_aws_gamelift_CfnMatchmakingConfiguration, aws_cdk_lib_aws_gamelift_CfnMatchmakingConfiguration_GamePropertyProperty, aws_cdk_lib_aws_gamelift_CfnMatchmakingRuleSetProps, aws_cdk_lib_aws_gamelift_CfnMatchmakingRuleSet, aws_cdk_lib_aws_gamelift_CfnScriptProps, aws_cdk_lib_aws_gamelift_CfnScript, aws_cdk_lib_aws_gamelift_CfnScript_S3LocationProperty, aws_cdk_lib_aws_globalaccelerator_CfnAcceleratorProps, aws_cdk_lib_aws_globalaccelerator_CfnAccelerator, aws_cdk_lib_aws_globalaccelerator_CfnEndpointGroupProps, aws_cdk_lib_aws_globalaccelerator_CfnEndpointGroup, aws_cdk_lib_aws_globalaccelerator_CfnEndpointGroup_EndpointConfigurationProperty, aws_cdk_lib_aws_globalaccelerator_CfnEndpointGroup_PortOverrideProperty, aws_cdk_lib_aws_globalaccelerator_CfnListenerProps, aws_cdk_lib_aws_globalaccelerator_CfnListener, aws_cdk_lib_aws_globalaccelerator_CfnListener_PortRangeProperty, aws_cdk_lib_aws_globalaccelerator_IAccelerator, aws_cdk_lib_aws_globalaccelerator_AcceleratorProps, aws_cdk_lib_aws_globalaccelerator_AcceleratorAttributes, aws_cdk_lib_aws_globalaccelerator_Accelerator, aws_cdk_lib_aws_globalaccelerator_IListener, aws_cdk_lib_aws_globalaccelerator_ListenerOptions, aws_cdk_lib_aws_globalaccelerator_ListenerProps, aws_cdk_lib_aws_globalaccelerator_PortRange, aws_cdk_lib_aws_globalaccelerator_ConnectionProtocol, aws_cdk_lib_aws_globalaccelerator_ClientAffinity, aws_cdk_lib_aws_globalaccelerator_Listener, aws_cdk_lib_aws_globalaccelerator_IEndpointGroup, aws_cdk_lib_aws_globalaccelerator_EndpointGroupOptions, aws_cdk_lib_aws_globalaccelerator_PortOverride, aws_cdk_lib_aws_globalaccelerator_HealthCheckProtocol, aws_cdk_lib_aws_globalaccelerator_EndpointGroupProps, aws_cdk_lib_aws_globalaccelerator_EndpointGroup, aws_cdk_lib_aws_globalaccelerator_IEndpoint, aws_cdk_lib_aws_globalaccelerator_RawEndpointProps, aws_cdk_lib_aws_globalaccelerator_RawEndpoint, aws_cdk_lib_aws_globalaccelerator_endpoints_ApplicationLoadBalancerEndpointOptions, aws_cdk_lib_aws_globalaccelerator_endpoints_ApplicationLoadBalancerEndpoint, aws_cdk_lib_aws_globalaccelerator_endpoints_NetworkLoadBalancerEndpointProps, aws_cdk_lib_aws_globalaccelerator_endpoints_NetworkLoadBalancerEndpoint, aws_cdk_lib_aws_globalaccelerator_endpoints_InstanceEndpointProps, aws_cdk_lib_aws_globalaccelerator_endpoints_InstanceEndpoint, aws_cdk_lib_aws_globalaccelerator_endpoints_CfnEipEndpointProps, aws_cdk_lib_aws_globalaccelerator_endpoints_CfnEipEndpoint, aws_cdk_lib_aws_glue_CfnClassifierProps, aws_cdk_lib_aws_glue_CfnClassifier, aws_cdk_lib_aws_glue_CfnClassifier_CsvClassifierProperty, aws_cdk_lib_aws_glue_CfnClassifier_GrokClassifierProperty, aws_cdk_lib_aws_glue_CfnClassifier_JsonClassifierProperty, aws_cdk_lib_aws_glue_CfnClassifier_XMLClassifierProperty, aws_cdk_lib_aws_glue_CfnConnectionProps, aws_cdk_lib_aws_glue_CfnConnection, aws_cdk_lib_aws_glue_CfnConnection_ConnectionInputProperty, aws_cdk_lib_aws_glue_CfnConnection_PhysicalConnectionRequirementsProperty, aws_cdk_lib_aws_glue_CfnCrawlerProps, aws_cdk_lib_aws_glue_CfnCrawler, aws_cdk_lib_aws_glue_CfnCrawler_CatalogTargetProperty, aws_cdk_lib_aws_glue_CfnCrawler_DeltaTargetProperty, aws_cdk_lib_aws_glue_CfnCrawler_DynamoDBTargetProperty, aws_cdk_lib_aws_glue_CfnCrawler_JdbcTargetProperty, aws_cdk_lib_aws_glue_CfnCrawler_MongoDBTargetProperty, aws_cdk_lib_aws_glue_CfnCrawler_RecrawlPolicyProperty, aws_cdk_lib_aws_glue_CfnCrawler_S3TargetProperty, aws_cdk_lib_aws_glue_CfnCrawler_ScheduleProperty, aws_cdk_lib_aws_glue_CfnCrawler_SchemaChangePolicyProperty, aws_cdk_lib_aws_glue_CfnCrawler_TargetsProperty, aws_cdk_lib_aws_glue_CfnDataCatalogEncryptionSettingsProps, aws_cdk_lib_aws_glue_CfnDataCatalogEncryptionSettings, aws_cdk_lib_aws_glue_CfnDataCatalogEncryptionSettings_ConnectionPasswordEncryptionProperty, aws_cdk_lib_aws_glue_CfnDataCatalogEncryptionSettings_DataCatalogEncryptionSettingsProperty, aws_cdk_lib_aws_glue_CfnDataCatalogEncryptionSettings_EncryptionAtRestProperty, aws_cdk_lib_aws_glue_CfnDatabaseProps, aws_cdk_lib_aws_glue_CfnDatabase, aws_cdk_lib_aws_glue_CfnDatabase_DataLakePrincipalProperty, aws_cdk_lib_aws_glue_CfnDatabase_DatabaseIdentifierProperty, aws_cdk_lib_aws_glue_CfnDatabase_DatabaseInputProperty, aws_cdk_lib_aws_glue_CfnDatabase_FederatedDatabaseProperty, aws_cdk_lib_aws_glue_CfnDatabase_PrincipalPrivilegesProperty, aws_cdk_lib_aws_glue_CfnDevEndpointProps, aws_cdk_lib_aws_glue_CfnDevEndpoint, aws_cdk_lib_aws_glue_CfnJobProps, aws_cdk_lib_aws_glue_CfnJob, aws_cdk_lib_aws_glue_CfnJob_ConnectionsListProperty, aws_cdk_lib_aws_glue_CfnJob_ExecutionPropertyProperty, aws_cdk_lib_aws_glue_CfnJob_JobCommandProperty, aws_cdk_lib_aws_glue_CfnJob_NotificationPropertyProperty, aws_cdk_lib_aws_glue_CfnMLTransformProps, aws_cdk_lib_aws_glue_CfnMLTransform, aws_cdk_lib_aws_glue_CfnMLTransform_FindMatchesParametersProperty, aws_cdk_lib_aws_glue_CfnMLTransform_GlueTablesProperty, aws_cdk_lib_aws_glue_CfnMLTransform_InputRecordTablesProperty, aws_cdk_lib_aws_glue_CfnMLTransform_MLUserDataEncryptionProperty, aws_cdk_lib_aws_glue_CfnMLTransform_TransformEncryptionProperty, aws_cdk_lib_aws_glue_CfnMLTransform_TransformParametersProperty, aws_cdk_lib_aws_glue_CfnPartitionProps, aws_cdk_lib_aws_glue_CfnPartition, aws_cdk_lib_aws_glue_CfnPartition_ColumnProperty, aws_cdk_lib_aws_glue_CfnPartition_OrderProperty, aws_cdk_lib_aws_glue_CfnPartition_PartitionInputProperty, aws_cdk_lib_aws_glue_CfnPartition_SchemaIdProperty, aws_cdk_lib_aws_glue_CfnPartition_SchemaReferenceProperty, aws_cdk_lib_aws_glue_CfnPartition_SerdeInfoProperty, aws_cdk_lib_aws_glue_CfnPartition_SkewedInfoProperty, aws_cdk_lib_aws_glue_CfnPartition_StorageDescriptorProperty, aws_cdk_lib_aws_glue_CfnRegistryProps, aws_cdk_lib_aws_glue_CfnRegistry, aws_cdk_lib_aws_glue_CfnSchemaProps, aws_cdk_lib_aws_glue_CfnSchema, aws_cdk_lib_aws_glue_CfnSchema_RegistryProperty, aws_cdk_lib_aws_glue_CfnSchema_SchemaVersionProperty, aws_cdk_lib_aws_glue_CfnSchemaVersionProps, aws_cdk_lib_aws_glue_CfnSchemaVersion, aws_cdk_lib_aws_glue_CfnSchemaVersion_SchemaProperty, aws_cdk_lib_aws_glue_CfnSchemaVersionMetadataProps, aws_cdk_lib_aws_glue_CfnSchemaVersionMetadata, aws_cdk_lib_aws_glue_CfnSecurityConfigurationProps, aws_cdk_lib_aws_glue_CfnSecurityConfiguration, aws_cdk_lib_aws_glue_CfnSecurityConfiguration_CloudWatchEncryptionProperty, aws_cdk_lib_aws_glue_CfnSecurityConfiguration_EncryptionConfigurationProperty, aws_cdk_lib_aws_glue_CfnSecurityConfiguration_JobBookmarksEncryptionProperty, aws_cdk_lib_aws_glue_CfnSecurityConfiguration_S3EncryptionProperty, aws_cdk_lib_aws_glue_CfnTableProps, aws_cdk_lib_aws_glue_CfnTable, aws_cdk_lib_aws_glue_CfnTable_ColumnProperty, aws_cdk_lib_aws_glue_CfnTable_OrderProperty, aws_cdk_lib_aws_glue_CfnTable_SchemaIdProperty, aws_cdk_lib_aws_glue_CfnTable_SchemaReferenceProperty, aws_cdk_lib_aws_glue_CfnTable_SerdeInfoProperty, aws_cdk_lib_aws_glue_CfnTable_SkewedInfoProperty, aws_cdk_lib_aws_glue_CfnTable_StorageDescriptorProperty, aws_cdk_lib_aws_glue_CfnTable_TableIdentifierProperty, aws_cdk_lib_aws_glue_CfnTable_TableInputProperty, aws_cdk_lib_aws_glue_CfnTriggerProps, aws_cdk_lib_aws_glue_CfnTrigger, aws_cdk_lib_aws_glue_CfnTrigger_ActionProperty, aws_cdk_lib_aws_glue_CfnTrigger_ConditionProperty, aws_cdk_lib_aws_glue_CfnTrigger_EventBatchingConditionProperty, aws_cdk_lib_aws_glue_CfnTrigger_NotificationPropertyProperty, aws_cdk_lib_aws_glue_CfnTrigger_PredicateProperty, aws_cdk_lib_aws_glue_CfnWorkflowProps, aws_cdk_lib_aws_glue_CfnWorkflow, aws_cdk_lib_aws_grafana_CfnWorkspaceProps, aws_cdk_lib_aws_grafana_CfnWorkspace, aws_cdk_lib_aws_grafana_CfnWorkspace_AssertionAttributesProperty, aws_cdk_lib_aws_grafana_CfnWorkspace_IdpMetadataProperty, aws_cdk_lib_aws_grafana_CfnWorkspace_NetworkAccessControlProperty, aws_cdk_lib_aws_grafana_CfnWorkspace_RoleValuesProperty, aws_cdk_lib_aws_grafana_CfnWorkspace_SamlConfigurationProperty, aws_cdk_lib_aws_grafana_CfnWorkspace_VpcConfigurationProperty, aws_cdk_lib_aws_greengrass_CfnConnectorDefinitionProps, aws_cdk_lib_aws_greengrass_CfnConnectorDefinition, aws_cdk_lib_aws_greengrass_CfnConnectorDefinition_ConnectorProperty, aws_cdk_lib_aws_greengrass_CfnConnectorDefinition_ConnectorDefinitionVersionProperty, aws_cdk_lib_aws_greengrass_CfnConnectorDefinitionVersionProps, aws_cdk_lib_aws_greengrass_CfnConnectorDefinitionVersion, aws_cdk_lib_aws_greengrass_CfnConnectorDefinitionVersion_ConnectorProperty, aws_cdk_lib_aws_greengrass_CfnCoreDefinitionProps, aws_cdk_lib_aws_greengrass_CfnCoreDefinition, aws_cdk_lib_aws_greengrass_CfnCoreDefinition_CoreProperty, aws_cdk_lib_aws_greengrass_CfnCoreDefinition_CoreDefinitionVersionProperty, aws_cdk_lib_aws_greengrass_CfnCoreDefinitionVersionProps, aws_cdk_lib_aws_greengrass_CfnCoreDefinitionVersion, aws_cdk_lib_aws_greengrass_CfnCoreDefinitionVersion_CoreProperty, aws_cdk_lib_aws_greengrass_CfnDeviceDefinitionProps, aws_cdk_lib_aws_greengrass_CfnDeviceDefinition, aws_cdk_lib_aws_greengrass_CfnDeviceDefinition_DeviceProperty, aws_cdk_lib_aws_greengrass_CfnDeviceDefinition_DeviceDefinitionVersionProperty, aws_cdk_lib_aws_greengrass_CfnDeviceDefinitionVersionProps, aws_cdk_lib_aws_greengrass_CfnDeviceDefinitionVersion, aws_cdk_lib_aws_greengrass_CfnDeviceDefinitionVersion_DeviceProperty, aws_cdk_lib_aws_greengrass_CfnFunctionDefinitionProps, aws_cdk_lib_aws_greengrass_CfnFunctionDefinition, aws_cdk_lib_aws_greengrass_CfnFunctionDefinition_DefaultConfigProperty, aws_cdk_lib_aws_greengrass_CfnFunctionDefinition_EnvironmentProperty, aws_cdk_lib_aws_greengrass_CfnFunctionDefinition_ExecutionProperty, aws_cdk_lib_aws_greengrass_CfnFunctionDefinition_FunctionProperty, aws_cdk_lib_aws_greengrass_CfnFunctionDefinition_FunctionConfigurationProperty, aws_cdk_lib_aws_greengrass_CfnFunctionDefinition_FunctionDefinitionVersionProperty, aws_cdk_lib_aws_greengrass_CfnFunctionDefinition_ResourceAccessPolicyProperty, aws_cdk_lib_aws_greengrass_CfnFunctionDefinition_RunAsProperty, aws_cdk_lib_aws_greengrass_CfnFunctionDefinitionVersionProps, aws_cdk_lib_aws_greengrass_CfnFunctionDefinitionVersion, aws_cdk_lib_aws_greengrass_CfnFunctionDefinitionVersion_DefaultConfigProperty, aws_cdk_lib_aws_greengrass_CfnFunctionDefinitionVersion_EnvironmentProperty, aws_cdk_lib_aws_greengrass_CfnFunctionDefinitionVersion_ExecutionProperty, aws_cdk_lib_aws_greengrass_CfnFunctionDefinitionVersion_FunctionProperty, aws_cdk_lib_aws_greengrass_CfnFunctionDefinitionVersion_FunctionConfigurationProperty, aws_cdk_lib_aws_greengrass_CfnFunctionDefinitionVersion_ResourceAccessPolicyProperty, aws_cdk_lib_aws_greengrass_CfnFunctionDefinitionVersion_RunAsProperty, aws_cdk_lib_aws_greengrass_CfnGroupProps, aws_cdk_lib_aws_greengrass_CfnGroup, aws_cdk_lib_aws_greengrass_CfnGroup_GroupVersionProperty, aws_cdk_lib_aws_greengrass_CfnGroupVersionProps, aws_cdk_lib_aws_greengrass_CfnGroupVersion, aws_cdk_lib_aws_greengrass_CfnLoggerDefinitionProps, aws_cdk_lib_aws_greengrass_CfnLoggerDefinition, aws_cdk_lib_aws_greengrass_CfnLoggerDefinition_LoggerProperty, aws_cdk_lib_aws_greengrass_CfnLoggerDefinition_LoggerDefinitionVersionProperty, aws_cdk_lib_aws_greengrass_CfnLoggerDefinitionVersionProps, aws_cdk_lib_aws_greengrass_CfnLoggerDefinitionVersion, aws_cdk_lib_aws_greengrass_CfnLoggerDefinitionVersion_LoggerProperty, aws_cdk_lib_aws_greengrass_CfnResourceDefinitionProps, aws_cdk_lib_aws_greengrass_CfnResourceDefinition, aws_cdk_lib_aws_greengrass_CfnResourceDefinition_GroupOwnerSettingProperty, aws_cdk_lib_aws_greengrass_CfnResourceDefinition_LocalDeviceResourceDataProperty, aws_cdk_lib_aws_greengrass_CfnResourceDefinition_LocalVolumeResourceDataProperty, aws_cdk_lib_aws_greengrass_CfnResourceDefinition_ResourceDataContainerProperty, aws_cdk_lib_aws_greengrass_CfnResourceDefinition_ResourceDefinitionVersionProperty, aws_cdk_lib_aws_greengrass_CfnResourceDefinition_ResourceDownloadOwnerSettingProperty, aws_cdk_lib_aws_greengrass_CfnResourceDefinition_ResourceInstanceProperty, aws_cdk_lib_aws_greengrass_CfnResourceDefinition_S3MachineLearningModelResourceDataProperty, aws_cdk_lib_aws_greengrass_CfnResourceDefinition_SageMakerMachineLearningModelResourceDataProperty, aws_cdk_lib_aws_greengrass_CfnResourceDefinition_SecretsManagerSecretResourceDataProperty, aws_cdk_lib_aws_greengrass_CfnResourceDefinitionVersionProps, aws_cdk_lib_aws_greengrass_CfnResourceDefinitionVersion, aws_cdk_lib_aws_greengrass_CfnResourceDefinitionVersion_GroupOwnerSettingProperty, aws_cdk_lib_aws_greengrass_CfnResourceDefinitionVersion_LocalDeviceResourceDataProperty, aws_cdk_lib_aws_greengrass_CfnResourceDefinitionVersion_LocalVolumeResourceDataProperty, aws_cdk_lib_aws_greengrass_CfnResourceDefinitionVersion_ResourceDataContainerProperty, aws_cdk_lib_aws_greengrass_CfnResourceDefinitionVersion_ResourceDownloadOwnerSettingProperty, aws_cdk_lib_aws_greengrass_CfnResourceDefinitionVersion_ResourceInstanceProperty, aws_cdk_lib_aws_greengrass_CfnResourceDefinitionVersion_S3MachineLearningModelResourceDataProperty, aws_cdk_lib_aws_greengrass_CfnResourceDefinitionVersion_SageMakerMachineLearningModelResourceDataProperty, aws_cdk_lib_aws_greengrass_CfnResourceDefinitionVersion_SecretsManagerSecretResourceDataProperty, aws_cdk_lib_aws_greengrass_CfnSubscriptionDefinitionProps, aws_cdk_lib_aws_greengrass_CfnSubscriptionDefinition, aws_cdk_lib_aws_greengrass_CfnSubscriptionDefinition_SubscriptionProperty, aws_cdk_lib_aws_greengrass_CfnSubscriptionDefinition_SubscriptionDefinitionVersionProperty, aws_cdk_lib_aws_greengrass_CfnSubscriptionDefinitionVersionProps, aws_cdk_lib_aws_greengrass_CfnSubscriptionDefinitionVersion, aws_cdk_lib_aws_greengrass_CfnSubscriptionDefinitionVersion_SubscriptionProperty, aws_cdk_lib_aws_greengrassv2_CfnComponentVersionProps, aws_cdk_lib_aws_greengrassv2_CfnComponentVersion, aws_cdk_lib_aws_greengrassv2_CfnComponentVersion_ComponentDependencyRequirementProperty, aws_cdk_lib_aws_greengrassv2_CfnComponentVersion_ComponentPlatformProperty, aws_cdk_lib_aws_greengrassv2_CfnComponentVersion_LambdaContainerParamsProperty, aws_cdk_lib_aws_greengrassv2_CfnComponentVersion_LambdaDeviceMountProperty, aws_cdk_lib_aws_greengrassv2_CfnComponentVersion_LambdaEventSourceProperty, aws_cdk_lib_aws_greengrassv2_CfnComponentVersion_LambdaExecutionParametersProperty, aws_cdk_lib_aws_greengrassv2_CfnComponentVersion_LambdaFunctionRecipeSourceProperty, aws_cdk_lib_aws_greengrassv2_CfnComponentVersion_LambdaLinuxProcessParamsProperty, aws_cdk_lib_aws_greengrassv2_CfnComponentVersion_LambdaVolumeMountProperty, aws_cdk_lib_aws_greengrassv2_CfnDeploymentProps, aws_cdk_lib_aws_greengrassv2_CfnDeployment, aws_cdk_lib_aws_greengrassv2_CfnDeployment_ComponentConfigurationUpdateProperty, aws_cdk_lib_aws_greengrassv2_CfnDeployment_ComponentDeploymentSpecificationProperty, aws_cdk_lib_aws_greengrassv2_CfnDeployment_ComponentRunWithProperty, aws_cdk_lib_aws_greengrassv2_CfnDeployment_DeploymentComponentUpdatePolicyProperty, aws_cdk_lib_aws_greengrassv2_CfnDeployment_DeploymentConfigurationValidationPolicyProperty, aws_cdk_lib_aws_greengrassv2_CfnDeployment_DeploymentIoTJobConfigurationProperty, aws_cdk_lib_aws_greengrassv2_CfnDeployment_DeploymentPoliciesProperty, aws_cdk_lib_aws_greengrassv2_CfnDeployment_IoTJobAbortConfigProperty, aws_cdk_lib_aws_greengrassv2_CfnDeployment_IoTJobAbortCriteriaProperty, aws_cdk_lib_aws_greengrassv2_CfnDeployment_IoTJobExecutionsRolloutConfigProperty, aws_cdk_lib_aws_greengrassv2_CfnDeployment_IoTJobExponentialRolloutRateProperty, aws_cdk_lib_aws_greengrassv2_CfnDeployment_IoTJobTimeoutConfigProperty, aws_cdk_lib_aws_greengrassv2_CfnDeployment_SystemResourceLimitsProperty, aws_cdk_lib_aws_groundstation_CfnConfigProps, aws_cdk_lib_aws_groundstation_CfnConfig, aws_cdk_lib_aws_groundstation_CfnConfig_AntennaDownlinkConfigProperty, aws_cdk_lib_aws_groundstation_CfnConfig_AntennaDownlinkDemodDecodeConfigProperty, aws_cdk_lib_aws_groundstation_CfnConfig_AntennaUplinkConfigProperty, aws_cdk_lib_aws_groundstation_CfnConfig_ConfigDataProperty, aws_cdk_lib_aws_groundstation_CfnConfig_DataflowEndpointConfigProperty, aws_cdk_lib_aws_groundstation_CfnConfig_DecodeConfigProperty, aws_cdk_lib_aws_groundstation_CfnConfig_DemodulationConfigProperty, aws_cdk_lib_aws_groundstation_CfnConfig_EirpProperty, aws_cdk_lib_aws_groundstation_CfnConfig_FrequencyProperty, aws_cdk_lib_aws_groundstation_CfnConfig_FrequencyBandwidthProperty, aws_cdk_lib_aws_groundstation_CfnConfig_S3RecordingConfigProperty, aws_cdk_lib_aws_groundstation_CfnConfig_SpectrumConfigProperty, aws_cdk_lib_aws_groundstation_CfnConfig_TrackingConfigProperty, aws_cdk_lib_aws_groundstation_CfnConfig_UplinkEchoConfigProperty, aws_cdk_lib_aws_groundstation_CfnConfig_UplinkSpectrumConfigProperty, aws_cdk_lib_aws_groundstation_CfnDataflowEndpointGroupProps, aws_cdk_lib_aws_groundstation_CfnDataflowEndpointGroup, aws_cdk_lib_aws_groundstation_CfnDataflowEndpointGroup_AwsGroundStationAgentEndpointProperty, aws_cdk_lib_aws_groundstation_CfnDataflowEndpointGroup_ConnectionDetailsProperty, aws_cdk_lib_aws_groundstation_CfnDataflowEndpointGroup_DataflowEndpointProperty, aws_cdk_lib_aws_groundstation_CfnDataflowEndpointGroup_EndpointDetailsProperty, aws_cdk_lib_aws_groundstation_CfnDataflowEndpointGroup_IntegerRangeProperty, aws_cdk_lib_aws_groundstation_CfnDataflowEndpointGroup_RangedConnectionDetailsProperty, aws_cdk_lib_aws_groundstation_CfnDataflowEndpointGroup_RangedSocketAddressProperty, aws_cdk_lib_aws_groundstation_CfnDataflowEndpointGroup_SecurityDetailsProperty, aws_cdk_lib_aws_groundstation_CfnDataflowEndpointGroup_SocketAddressProperty, aws_cdk_lib_aws_groundstation_CfnMissionProfileProps, aws_cdk_lib_aws_groundstation_CfnMissionProfile, aws_cdk_lib_aws_groundstation_CfnMissionProfile_DataflowEdgeProperty, aws_cdk_lib_aws_groundstation_CfnMissionProfile_StreamsKmsKeyProperty, aws_cdk_lib_aws_guardduty_CfnDetectorProps, aws_cdk_lib_aws_guardduty_CfnDetector, aws_cdk_lib_aws_guardduty_CfnDetector_CFNDataSourceConfigurationsProperty, aws_cdk_lib_aws_guardduty_CfnDetector_CFNKubernetesAuditLogsConfigurationProperty, aws_cdk_lib_aws_guardduty_CfnDetector_CFNKubernetesConfigurationProperty, aws_cdk_lib_aws_guardduty_CfnDetector_CFNMalwareProtectionConfigurationProperty, aws_cdk_lib_aws_guardduty_CfnDetector_CFNS3LogsConfigurationProperty, aws_cdk_lib_aws_guardduty_CfnDetector_CFNScanEc2InstanceWithFindingsConfigurationProperty, aws_cdk_lib_aws_guardduty_CfnDetector_FeatureAdditionalConfigurationProperty, aws_cdk_lib_aws_guardduty_CfnDetector_FeatureConfigurationsProperty, aws_cdk_lib_aws_guardduty_CfnFilterProps, aws_cdk_lib_aws_guardduty_CfnFilter, aws_cdk_lib_aws_guardduty_CfnFilter_ConditionProperty, aws_cdk_lib_aws_guardduty_CfnFilter_FindingCriteriaProperty, aws_cdk_lib_aws_guardduty_CfnIPSetProps, aws_cdk_lib_aws_guardduty_CfnIPSet, aws_cdk_lib_aws_guardduty_CfnMasterProps, aws_cdk_lib_aws_guardduty_CfnMaster, aws_cdk_lib_aws_guardduty_CfnMemberProps, aws_cdk_lib_aws_guardduty_CfnMember, aws_cdk_lib_aws_guardduty_CfnThreatIntelSetProps, aws_cdk_lib_aws_guardduty_CfnThreatIntelSet, aws_cdk_lib_aws_healthlake_CfnFHIRDatastoreProps, aws_cdk_lib_aws_healthlake_CfnFHIRDatastore, aws_cdk_lib_aws_healthlake_CfnFHIRDatastore_CreatedAtProperty, aws_cdk_lib_aws_healthlake_CfnFHIRDatastore_KmsEncryptionConfigProperty, aws_cdk_lib_aws_healthlake_CfnFHIRDatastore_PreloadDataConfigProperty, aws_cdk_lib_aws_healthlake_CfnFHIRDatastore_SseConfigurationProperty, aws_cdk_lib_aws_iam_PolicyDocumentProps, aws_cdk_lib_aws_iam_PolicyDocument, aws_cdk_lib_aws_iam_PolicyStatement, aws_cdk_lib_aws_iam_Effect, aws_cdk_lib_aws_iam_PolicyStatementProps, aws_cdk_lib_aws_iam_IManagedPolicy, aws_cdk_lib_aws_iam_ManagedPolicyProps, aws_cdk_lib_aws_iam_ManagedPolicy, aws_cdk_lib_aws_iam_RoleProps, aws_cdk_lib_aws_iam_FromRoleArnOptions, aws_cdk_lib_aws_iam_CustomizeRolesOptions, aws_cdk_lib_aws_iam_FromRoleNameOptions, aws_cdk_lib_aws_iam_Role, aws_cdk_lib_aws_iam_IRole, aws_cdk_lib_aws_iam_WithoutPolicyUpdatesOptions, aws_cdk_lib_aws_iam_IPolicy, aws_cdk_lib_aws_iam_PolicyProps, aws_cdk_lib_aws_iam_Policy, aws_cdk_lib_aws_iam_IUser, aws_cdk_lib_aws_iam_UserProps, aws_cdk_lib_aws_iam_UserAttributes, aws_cdk_lib_aws_iam_User, aws_cdk_lib_aws_iam_IGroup, aws_cdk_lib_aws_iam_GroupProps, aws_cdk_lib_aws_iam_Group, aws_cdk_lib_aws_iam_LazyRoleProps, aws_cdk_lib_aws_iam_LazyRole, aws_cdk_lib_aws_iam_IGrantable, aws_cdk_lib_aws_iam_IPrincipal, aws_cdk_lib_aws_iam_IComparablePrincipal, aws_cdk_lib_aws_iam_ComparablePrincipal, aws_cdk_lib_aws_iam_IAssumeRolePrincipal, aws_cdk_lib_aws_iam_AddToPrincipalPolicyResult, aws_cdk_lib_aws_iam_PrincipalBase, aws_cdk_lib_aws_iam_PrincipalWithConditions, aws_cdk_lib_aws_iam_SessionTagsPrincipal, aws_cdk_lib_aws_iam_PrincipalPolicyFragment, aws_cdk_lib_aws_iam_ArnPrincipal, aws_cdk_lib_aws_iam_AccountPrincipal, aws_cdk_lib_aws_iam_ServicePrincipalOpts, aws_cdk_lib_aws_iam_ServicePrincipal, aws_cdk_lib_aws_iam_OrganizationPrincipal, aws_cdk_lib_aws_iam_CanonicalUserPrincipal, aws_cdk_lib_aws_iam_FederatedPrincipal, aws_cdk_lib_aws_iam_WebIdentityPrincipal, aws_cdk_lib_aws_iam_OpenIdConnectPrincipal, aws_cdk_lib_aws_iam_SamlPrincipal, aws_cdk_lib_aws_iam_SamlConsolePrincipal, aws_cdk_lib_aws_iam_AccountRootPrincipal, aws_cdk_lib_aws_iam_AnyPrincipal, aws_cdk_lib_aws_iam_StarPrincipal, aws_cdk_lib_aws_iam_CompositePrincipal, aws_cdk_lib_aws_iam_IIdentity, aws_cdk_lib_aws_iam_CommonGrantOptions, aws_cdk_lib_aws_iam_GrantWithResourceOptions, aws_cdk_lib_aws_iam_GrantOnPrincipalOptions, aws_cdk_lib_aws_iam_GrantOnPrincipalAndResourceOptions, aws_cdk_lib_aws_iam_Grant, aws_cdk_lib_aws_iam_IResourceWithPolicy, aws_cdk_lib_aws_iam_AddToResourcePolicyResult, aws_cdk_lib_aws_iam_CompositeDependable, aws_cdk_lib_aws_iam_UnknownPrincipalProps, aws_cdk_lib_aws_iam_UnknownPrincipal, aws_cdk_lib_aws_iam_IOpenIdConnectProvider, aws_cdk_lib_aws_iam_OpenIdConnectProviderProps, aws_cdk_lib_aws_iam_OpenIdConnectProvider, aws_cdk_lib_aws_iam_PermissionsBoundary, aws_cdk_lib_aws_iam_ISamlProvider, aws_cdk_lib_aws_iam_SamlProviderProps, aws_cdk_lib_aws_iam_SamlMetadataDocument, aws_cdk_lib_aws_iam_SamlProvider, aws_cdk_lib_aws_iam_AccessKeyStatus, aws_cdk_lib_aws_iam_IAccessKey, aws_cdk_lib_aws_iam_AccessKeyProps, aws_cdk_lib_aws_iam_AccessKey, aws_cdk_lib_aws_iam_CfnAccessKeyProps, aws_cdk_lib_aws_iam_CfnAccessKey, aws_cdk_lib_aws_iam_CfnGroupProps, aws_cdk_lib_aws_iam_CfnGroup, aws_cdk_lib_aws_iam_CfnGroup_PolicyProperty, aws_cdk_lib_aws_iam_CfnInstanceProfileProps, aws_cdk_lib_aws_iam_CfnInstanceProfile, aws_cdk_lib_aws_iam_CfnManagedPolicyProps, aws_cdk_lib_aws_iam_CfnManagedPolicy, aws_cdk_lib_aws_iam_CfnOIDCProviderProps, aws_cdk_lib_aws_iam_CfnOIDCProvider, aws_cdk_lib_aws_iam_CfnPolicyProps, aws_cdk_lib_aws_iam_CfnPolicy, aws_cdk_lib_aws_iam_CfnRoleProps, aws_cdk_lib_aws_iam_CfnRole, aws_cdk_lib_aws_iam_CfnRole_PolicyProperty, aws_cdk_lib_aws_iam_CfnSAMLProviderProps, aws_cdk_lib_aws_iam_CfnSAMLProvider, aws_cdk_lib_aws_iam_CfnServerCertificateProps, aws_cdk_lib_aws_iam_CfnServerCertificate, aws_cdk_lib_aws_iam_CfnServiceLinkedRoleProps, aws_cdk_lib_aws_iam_CfnServiceLinkedRole, aws_cdk_lib_aws_iam_CfnUserProps, aws_cdk_lib_aws_iam_CfnUser, aws_cdk_lib_aws_iam_CfnUser_LoginProfileProperty, aws_cdk_lib_aws_iam_CfnUser_PolicyProperty, aws_cdk_lib_aws_iam_CfnUserToGroupAdditionProps, aws_cdk_lib_aws_iam_CfnUserToGroupAddition, aws_cdk_lib_aws_iam_CfnVirtualMFADeviceProps, aws_cdk_lib_aws_iam_CfnVirtualMFADevice, aws_cdk_lib_aws_identitystore_CfnGroupProps, aws_cdk_lib_aws_identitystore_CfnGroup, aws_cdk_lib_aws_identitystore_CfnGroupMembershipProps, aws_cdk_lib_aws_identitystore_CfnGroupMembership, aws_cdk_lib_aws_identitystore_CfnGroupMembership_MemberIdProperty, aws_cdk_lib_aws_imagebuilder_CfnComponentProps, aws_cdk_lib_aws_imagebuilder_CfnComponent, aws_cdk_lib_aws_imagebuilder_CfnContainerRecipeProps, aws_cdk_lib_aws_imagebuilder_CfnContainerRecipe, aws_cdk_lib_aws_imagebuilder_CfnContainerRecipe_ComponentConfigurationProperty, aws_cdk_lib_aws_imagebuilder_CfnContainerRecipe_ComponentParameterProperty, aws_cdk_lib_aws_imagebuilder_CfnContainerRecipe_EbsInstanceBlockDeviceSpecificationProperty, aws_cdk_lib_aws_imagebuilder_CfnContainerRecipe_InstanceBlockDeviceMappingProperty, aws_cdk_lib_aws_imagebuilder_CfnContainerRecipe_InstanceConfigurationProperty, aws_cdk_lib_aws_imagebuilder_CfnContainerRecipe_TargetContainerRepositoryProperty, aws_cdk_lib_aws_imagebuilder_CfnDistributionConfigurationProps, aws_cdk_lib_aws_imagebuilder_CfnDistributionConfiguration, aws_cdk_lib_aws_imagebuilder_CfnDistributionConfiguration_AmiDistributionConfigurationProperty, aws_cdk_lib_aws_imagebuilder_CfnDistributionConfiguration_ContainerDistributionConfigurationProperty, aws_cdk_lib_aws_imagebuilder_CfnDistributionConfiguration_DistributionProperty, aws_cdk_lib_aws_imagebuilder_CfnDistributionConfiguration_FastLaunchConfigurationProperty, aws_cdk_lib_aws_imagebuilder_CfnDistributionConfiguration_FastLaunchLaunchTemplateSpecificationProperty, aws_cdk_lib_aws_imagebuilder_CfnDistributionConfiguration_FastLaunchSnapshotConfigurationProperty, aws_cdk_lib_aws_imagebuilder_CfnDistributionConfiguration_LaunchPermissionConfigurationProperty, aws_cdk_lib_aws_imagebuilder_CfnDistributionConfiguration_LaunchTemplateConfigurationProperty, aws_cdk_lib_aws_imagebuilder_CfnDistributionConfiguration_TargetContainerRepositoryProperty, aws_cdk_lib_aws_imagebuilder_CfnImageProps, aws_cdk_lib_aws_imagebuilder_CfnImage, aws_cdk_lib_aws_imagebuilder_CfnImage_EcrConfigurationProperty, aws_cdk_lib_aws_imagebuilder_CfnImage_ImageScanningConfigurationProperty, aws_cdk_lib_aws_imagebuilder_CfnImage_ImageTestsConfigurationProperty, aws_cdk_lib_aws_imagebuilder_CfnImagePipelineProps, aws_cdk_lib_aws_imagebuilder_CfnImagePipeline, aws_cdk_lib_aws_imagebuilder_CfnImagePipeline_EcrConfigurationProperty, aws_cdk_lib_aws_imagebuilder_CfnImagePipeline_ImageScanningConfigurationProperty, aws_cdk_lib_aws_imagebuilder_CfnImagePipeline_ImageTestsConfigurationProperty, aws_cdk_lib_aws_imagebuilder_CfnImagePipeline_ScheduleProperty, aws_cdk_lib_aws_imagebuilder_CfnImageRecipeProps, aws_cdk_lib_aws_imagebuilder_CfnImageRecipe, aws_cdk_lib_aws_imagebuilder_CfnImageRecipe_AdditionalInstanceConfigurationProperty, aws_cdk_lib_aws_imagebuilder_CfnImageRecipe_ComponentConfigurationProperty, aws_cdk_lib_aws_imagebuilder_CfnImageRecipe_ComponentParameterProperty, aws_cdk_lib_aws_imagebuilder_CfnImageRecipe_EbsInstanceBlockDeviceSpecificationProperty, aws_cdk_lib_aws_imagebuilder_CfnImageRecipe_InstanceBlockDeviceMappingProperty, aws_cdk_lib_aws_imagebuilder_CfnImageRecipe_SystemsManagerAgentProperty, aws_cdk_lib_aws_imagebuilder_CfnInfrastructureConfigurationProps, aws_cdk_lib_aws_imagebuilder_CfnInfrastructureConfiguration, aws_cdk_lib_aws_imagebuilder_CfnInfrastructureConfiguration_InstanceMetadataOptionsProperty, aws_cdk_lib_aws_imagebuilder_CfnInfrastructureConfiguration_LoggingProperty, aws_cdk_lib_aws_imagebuilder_CfnInfrastructureConfiguration_S3LogsProperty, aws_cdk_lib_aws_inspector_CfnAssessmentTargetProps, aws_cdk_lib_aws_inspector_CfnAssessmentTarget, aws_cdk_lib_aws_inspector_CfnAssessmentTemplateProps, aws_cdk_lib_aws_inspector_CfnAssessmentTemplate, aws_cdk_lib_aws_inspector_CfnResourceGroupProps, aws_cdk_lib_aws_inspector_CfnResourceGroup, aws_cdk_lib_aws_inspectorv2_CfnFilterProps, aws_cdk_lib_aws_inspectorv2_CfnFilter, aws_cdk_lib_aws_inspectorv2_CfnFilter_DateFilterProperty, aws_cdk_lib_aws_inspectorv2_CfnFilter_FilterCriteriaProperty, aws_cdk_lib_aws_inspectorv2_CfnFilter_MapFilterProperty, aws_cdk_lib_aws_inspectorv2_CfnFilter_NumberFilterProperty, aws_cdk_lib_aws_inspectorv2_CfnFilter_PackageFilterProperty, aws_cdk_lib_aws_inspectorv2_CfnFilter_PortRangeFilterProperty, aws_cdk_lib_aws_inspectorv2_CfnFilter_StringFilterProperty, aws_cdk_lib_aws_internetmonitor_CfnMonitorProps, aws_cdk_lib_aws_internetmonitor_CfnMonitor, aws_cdk_lib_aws_internetmonitor_CfnMonitor_InternetMeasurementsLogDeliveryProperty, aws_cdk_lib_aws_internetmonitor_CfnMonitor_S3ConfigProperty, aws_cdk_lib_aws_iot_CfnAccountAuditConfigurationProps, aws_cdk_lib_aws_iot_CfnAccountAuditConfiguration, aws_cdk_lib_aws_iot_CfnAccountAuditConfiguration_AuditCheckConfigurationProperty, aws_cdk_lib_aws_iot_CfnAccountAuditConfiguration_AuditCheckConfigurationsProperty, aws_cdk_lib_aws_iot_CfnAccountAuditConfiguration_AuditNotificationTargetProperty, aws_cdk_lib_aws_iot_CfnAccountAuditConfiguration_AuditNotificationTargetConfigurationsProperty, aws_cdk_lib_aws_iot_CfnAuthorizerProps, aws_cdk_lib_aws_iot_CfnAuthorizer, aws_cdk_lib_aws_iot_CfnBillingGroupProps, aws_cdk_lib_aws_iot_CfnBillingGroup, aws_cdk_lib_aws_iot_CfnBillingGroup_BillingGroupPropertiesProperty, aws_cdk_lib_aws_iot_CfnCACertificateProps, aws_cdk_lib_aws_iot_CfnCACertificate, aws_cdk_lib_aws_iot_CfnCACertificate_RegistrationConfigProperty, aws_cdk_lib_aws_iot_CfnCertificateProps, aws_cdk_lib_aws_iot_CfnCertificate, aws_cdk_lib_aws_iot_CfnCustomMetricProps, aws_cdk_lib_aws_iot_CfnCustomMetric, aws_cdk_lib_aws_iot_CfnDimensionProps, aws_cdk_lib_aws_iot_CfnDimension, aws_cdk_lib_aws_iot_CfnDomainConfigurationProps, aws_cdk_lib_aws_iot_CfnDomainConfiguration, aws_cdk_lib_aws_iot_CfnDomainConfiguration_AuthorizerConfigProperty, aws_cdk_lib_aws_iot_CfnDomainConfiguration_ServerCertificateSummaryProperty, aws_cdk_lib_aws_iot_CfnDomainConfiguration_TlsConfigProperty, aws_cdk_lib_aws_iot_CfnFleetMetricProps, aws_cdk_lib_aws_iot_CfnFleetMetric, aws_cdk_lib_aws_iot_CfnFleetMetric_AggregationTypeProperty, aws_cdk_lib_aws_iot_CfnJobTemplateProps, aws_cdk_lib_aws_iot_CfnJobTemplate, aws_cdk_lib_aws_iot_CfnJobTemplate_AbortConfigProperty, aws_cdk_lib_aws_iot_CfnJobTemplate_AbortCriteriaProperty, aws_cdk_lib_aws_iot_CfnJobTemplate_ExponentialRolloutRateProperty, aws_cdk_lib_aws_iot_CfnJobTemplate_JobExecutionsRetryConfigProperty, aws_cdk_lib_aws_iot_CfnJobTemplate_JobExecutionsRolloutConfigProperty, aws_cdk_lib_aws_iot_CfnJobTemplate_MaintenanceWindowProperty, aws_cdk_lib_aws_iot_CfnJobTemplate_PresignedUrlConfigProperty, aws_cdk_lib_aws_iot_CfnJobTemplate_RateIncreaseCriteriaProperty, aws_cdk_lib_aws_iot_CfnJobTemplate_RetryCriteriaProperty, aws_cdk_lib_aws_iot_CfnJobTemplate_TimeoutConfigProperty, aws_cdk_lib_aws_iot_CfnLoggingProps, aws_cdk_lib_aws_iot_CfnLogging, aws_cdk_lib_aws_iot_CfnMitigationActionProps, aws_cdk_lib_aws_iot_CfnMitigationAction, aws_cdk_lib_aws_iot_CfnMitigationAction_ActionParamsProperty, aws_cdk_lib_aws_iot_CfnMitigationAction_AddThingsToThingGroupParamsProperty, aws_cdk_lib_aws_iot_CfnMitigationAction_EnableIoTLoggingParamsProperty, aws_cdk_lib_aws_iot_CfnMitigationAction_PublishFindingToSnsParamsProperty, aws_cdk_lib_aws_iot_CfnMitigationAction_ReplaceDefaultPolicyVersionParamsProperty, aws_cdk_lib_aws_iot_CfnMitigationAction_UpdateCACertificateParamsProperty, aws_cdk_lib_aws_iot_CfnMitigationAction_UpdateDeviceCertificateParamsProperty, aws_cdk_lib_aws_iot_CfnPolicyProps, aws_cdk_lib_aws_iot_CfnPolicy, aws_cdk_lib_aws_iot_CfnPolicyPrincipalAttachmentProps, aws_cdk_lib_aws_iot_CfnPolicyPrincipalAttachment, aws_cdk_lib_aws_iot_CfnProvisioningTemplateProps, aws_cdk_lib_aws_iot_CfnProvisioningTemplate, aws_cdk_lib_aws_iot_CfnProvisioningTemplate_ProvisioningHookProperty, aws_cdk_lib_aws_iot_CfnResourceSpecificLoggingProps, aws_cdk_lib_aws_iot_CfnResourceSpecificLogging, aws_cdk_lib_aws_iot_CfnRoleAliasProps, aws_cdk_lib_aws_iot_CfnRoleAlias, aws_cdk_lib_aws_iot_CfnScheduledAuditProps, aws_cdk_lib_aws_iot_CfnScheduledAudit, aws_cdk_lib_aws_iot_CfnSecurityProfileProps, aws_cdk_lib_aws_iot_CfnSecurityProfile, aws_cdk_lib_aws_iot_CfnSecurityProfile_AlertTargetProperty, aws_cdk_lib_aws_iot_CfnSecurityProfile_BehaviorProperty, aws_cdk_lib_aws_iot_CfnSecurityProfile_BehaviorCriteriaProperty, aws_cdk_lib_aws_iot_CfnSecurityProfile_MachineLearningDetectionConfigProperty, aws_cdk_lib_aws_iot_CfnSecurityProfile_MetricDimensionProperty, aws_cdk_lib_aws_iot_CfnSecurityProfile_MetricToRetainProperty, aws_cdk_lib_aws_iot_CfnSecurityProfile_MetricValueProperty, aws_cdk_lib_aws_iot_CfnSecurityProfile_StatisticalThresholdProperty, aws_cdk_lib_aws_iot_CfnThingProps, aws_cdk_lib_aws_iot_CfnThing, aws_cdk_lib_aws_iot_CfnThing_AttributePayloadProperty, aws_cdk_lib_aws_iot_CfnThingGroupProps, aws_cdk_lib_aws_iot_CfnThingGroup, aws_cdk_lib_aws_iot_CfnThingGroup_AttributePayloadProperty, aws_cdk_lib_aws_iot_CfnThingGroup_ThingGroupPropertiesProperty, aws_cdk_lib_aws_iot_CfnThingPrincipalAttachmentProps, aws_cdk_lib_aws_iot_CfnThingPrincipalAttachment, aws_cdk_lib_aws_iot_CfnThingTypeProps, aws_cdk_lib_aws_iot_CfnThingType, aws_cdk_lib_aws_iot_CfnThingType_ThingTypePropertiesProperty, aws_cdk_lib_aws_iot_CfnTopicRuleProps, aws_cdk_lib_aws_iot_CfnTopicRule, aws_cdk_lib_aws_iot_CfnTopicRule_ActionProperty, aws_cdk_lib_aws_iot_CfnTopicRule_AssetPropertyTimestampProperty, aws_cdk_lib_aws_iot_CfnTopicRule_AssetPropertyValueProperty, aws_cdk_lib_aws_iot_CfnTopicRule_AssetPropertyVariantProperty, aws_cdk_lib_aws_iot_CfnTopicRule_CloudwatchAlarmActionProperty, aws_cdk_lib_aws_iot_CfnTopicRule_CloudwatchLogsActionProperty, aws_cdk_lib_aws_iot_CfnTopicRule_CloudwatchMetricActionProperty, aws_cdk_lib_aws_iot_CfnTopicRule_DynamoDBActionProperty, aws_cdk_lib_aws_iot_CfnTopicRule_DynamoDBv2ActionProperty, aws_cdk_lib_aws_iot_CfnTopicRule_ElasticsearchActionProperty, aws_cdk_lib_aws_iot_CfnTopicRule_FirehoseActionProperty, aws_cdk_lib_aws_iot_CfnTopicRule_HttpActionProperty, aws_cdk_lib_aws_iot_CfnTopicRule_HttpActionHeaderProperty, aws_cdk_lib_aws_iot_CfnTopicRule_HttpAuthorizationProperty, aws_cdk_lib_aws_iot_CfnTopicRule_IotAnalyticsActionProperty, aws_cdk_lib_aws_iot_CfnTopicRule_IotEventsActionProperty, aws_cdk_lib_aws_iot_CfnTopicRule_IotSiteWiseActionProperty, aws_cdk_lib_aws_iot_CfnTopicRule_KafkaActionProperty, aws_cdk_lib_aws_iot_CfnTopicRule_KinesisActionProperty, aws_cdk_lib_aws_iot_CfnTopicRule_LambdaActionProperty, aws_cdk_lib_aws_iot_CfnTopicRule_LocationActionProperty, aws_cdk_lib_aws_iot_CfnTopicRule_OpenSearchActionProperty, aws_cdk_lib_aws_iot_CfnTopicRule_PutAssetPropertyValueEntryProperty, aws_cdk_lib_aws_iot_CfnTopicRule_PutItemInputProperty, aws_cdk_lib_aws_iot_CfnTopicRule_RepublishActionProperty, aws_cdk_lib_aws_iot_CfnTopicRule_RepublishActionHeadersProperty, aws_cdk_lib_aws_iot_CfnTopicRule_S3ActionProperty, aws_cdk_lib_aws_iot_CfnTopicRule_SigV4AuthorizationProperty, aws_cdk_lib_aws_iot_CfnTopicRule_SnsActionProperty, aws_cdk_lib_aws_iot_CfnTopicRule_SqsActionProperty, aws_cdk_lib_aws_iot_CfnTopicRule_StepFunctionsActionProperty, aws_cdk_lib_aws_iot_CfnTopicRule_TimestampProperty, aws_cdk_lib_aws_iot_CfnTopicRule_TimestreamActionProperty, aws_cdk_lib_aws_iot_CfnTopicRule_TimestreamDimensionProperty, aws_cdk_lib_aws_iot_CfnTopicRule_TimestreamTimestampProperty, aws_cdk_lib_aws_iot_CfnTopicRule_TopicRulePayloadProperty, aws_cdk_lib_aws_iot_CfnTopicRule_UserPropertyProperty, aws_cdk_lib_aws_iot_CfnTopicRuleDestinationProps, aws_cdk_lib_aws_iot_CfnTopicRuleDestination, aws_cdk_lib_aws_iot_CfnTopicRuleDestination_HttpUrlDestinationSummaryProperty, aws_cdk_lib_aws_iot_CfnTopicRuleDestination_VpcDestinationPropertiesProperty, aws_cdk_lib_aws_iot1click_CfnDeviceProps, aws_cdk_lib_aws_iot1click_CfnDevice, aws_cdk_lib_aws_iot1click_CfnPlacementProps, aws_cdk_lib_aws_iot1click_CfnPlacement, aws_cdk_lib_aws_iot1click_CfnProjectProps, aws_cdk_lib_aws_iot1click_CfnProject, aws_cdk_lib_aws_iot1click_CfnProject_DeviceTemplateProperty, aws_cdk_lib_aws_iot1click_CfnProject_PlacementTemplateProperty, aws_cdk_lib_aws_iotanalytics_CfnChannelProps, aws_cdk_lib_aws_iotanalytics_CfnChannel, aws_cdk_lib_aws_iotanalytics_CfnChannel_ChannelStorageProperty, aws_cdk_lib_aws_iotanalytics_CfnChannel_CustomerManagedS3Property, aws_cdk_lib_aws_iotanalytics_CfnChannel_RetentionPeriodProperty, aws_cdk_lib_aws_iotanalytics_CfnDatasetProps, aws_cdk_lib_aws_iotanalytics_CfnDataset, aws_cdk_lib_aws_iotanalytics_CfnDataset_ActionProperty, aws_cdk_lib_aws_iotanalytics_CfnDataset_ContainerActionProperty, aws_cdk_lib_aws_iotanalytics_CfnDataset_DatasetContentDeliveryRuleProperty, aws_cdk_lib_aws_iotanalytics_CfnDataset_DatasetContentDeliveryRuleDestinationProperty, aws_cdk_lib_aws_iotanalytics_CfnDataset_DatasetContentVersionValueProperty, aws_cdk_lib_aws_iotanalytics_CfnDataset_DeltaTimeProperty, aws_cdk_lib_aws_iotanalytics_CfnDataset_DeltaTimeSessionWindowConfigurationProperty, aws_cdk_lib_aws_iotanalytics_CfnDataset_FilterProperty, aws_cdk_lib_aws_iotanalytics_CfnDataset_GlueConfigurationProperty, aws_cdk_lib_aws_iotanalytics_CfnDataset_IotEventsDestinationConfigurationProperty, aws_cdk_lib_aws_iotanalytics_CfnDataset_LateDataRuleProperty, aws_cdk_lib_aws_iotanalytics_CfnDataset_LateDataRuleConfigurationProperty, aws_cdk_lib_aws_iotanalytics_CfnDataset_OutputFileUriValueProperty, aws_cdk_lib_aws_iotanalytics_CfnDataset_QueryActionProperty, aws_cdk_lib_aws_iotanalytics_CfnDataset_ResourceConfigurationProperty, aws_cdk_lib_aws_iotanalytics_CfnDataset_RetentionPeriodProperty, aws_cdk_lib_aws_iotanalytics_CfnDataset_S3DestinationConfigurationProperty, aws_cdk_lib_aws_iotanalytics_CfnDataset_ScheduleProperty, aws_cdk_lib_aws_iotanalytics_CfnDataset_TriggerProperty, aws_cdk_lib_aws_iotanalytics_CfnDataset_TriggeringDatasetProperty, aws_cdk_lib_aws_iotanalytics_CfnDataset_VariableProperty, aws_cdk_lib_aws_iotanalytics_CfnDataset_VersioningConfigurationProperty, aws_cdk_lib_aws_iotanalytics_CfnDatastoreProps, aws_cdk_lib_aws_iotanalytics_CfnDatastore, aws_cdk_lib_aws_iotanalytics_CfnDatastore_ColumnProperty, aws_cdk_lib_aws_iotanalytics_CfnDatastore_CustomerManagedS3Property, aws_cdk_lib_aws_iotanalytics_CfnDatastore_CustomerManagedS3StorageProperty, aws_cdk_lib_aws_iotanalytics_CfnDatastore_DatastorePartitionProperty, aws_cdk_lib_aws_iotanalytics_CfnDatastore_DatastorePartitionsProperty, aws_cdk_lib_aws_iotanalytics_CfnDatastore_DatastoreStorageProperty, aws_cdk_lib_aws_iotanalytics_CfnDatastore_FileFormatConfigurationProperty, aws_cdk_lib_aws_iotanalytics_CfnDatastore_IotSiteWiseMultiLayerStorageProperty, aws_cdk_lib_aws_iotanalytics_CfnDatastore_ParquetConfigurationProperty, aws_cdk_lib_aws_iotanalytics_CfnDatastore_PartitionProperty, aws_cdk_lib_aws_iotanalytics_CfnDatastore_RetentionPeriodProperty, aws_cdk_lib_aws_iotanalytics_CfnDatastore_SchemaDefinitionProperty, aws_cdk_lib_aws_iotanalytics_CfnDatastore_TimestampPartitionProperty, aws_cdk_lib_aws_iotanalytics_CfnPipelineProps, aws_cdk_lib_aws_iotanalytics_CfnPipeline, aws_cdk_lib_aws_iotanalytics_CfnPipeline_ActivityProperty, aws_cdk_lib_aws_iotanalytics_CfnPipeline_AddAttributesProperty, aws_cdk_lib_aws_iotanalytics_CfnPipeline_ChannelProperty, aws_cdk_lib_aws_iotanalytics_CfnPipeline_DatastoreProperty, aws_cdk_lib_aws_iotanalytics_CfnPipeline_DeviceRegistryEnrichProperty, aws_cdk_lib_aws_iotanalytics_CfnPipeline_DeviceShadowEnrichProperty, aws_cdk_lib_aws_iotanalytics_CfnPipeline_FilterProperty, aws_cdk_lib_aws_iotanalytics_CfnPipeline_LambdaProperty, aws_cdk_lib_aws_iotanalytics_CfnPipeline_MathProperty, aws_cdk_lib_aws_iotanalytics_CfnPipeline_RemoveAttributesProperty, aws_cdk_lib_aws_iotanalytics_CfnPipeline_SelectAttributesProperty, aws_cdk_lib_aws_iotcoredeviceadvisor_CfnSuiteDefinitionProps, aws_cdk_lib_aws_iotcoredeviceadvisor_CfnSuiteDefinition, aws_cdk_lib_aws_iotcoredeviceadvisor_CfnSuiteDefinition_DeviceUnderTestProperty, aws_cdk_lib_aws_iotcoredeviceadvisor_CfnSuiteDefinition_SuiteDefinitionConfigurationProperty, aws_cdk_lib_aws_iotevents_CfnAlarmModelProps, aws_cdk_lib_aws_iotevents_CfnAlarmModel, aws_cdk_lib_aws_iotevents_CfnAlarmModel_AcknowledgeFlowProperty, aws_cdk_lib_aws_iotevents_CfnAlarmModel_AlarmActionProperty, aws_cdk_lib_aws_iotevents_CfnAlarmModel_AlarmCapabilitiesProperty, aws_cdk_lib_aws_iotevents_CfnAlarmModel_AlarmEventActionsProperty, aws_cdk_lib_aws_iotevents_CfnAlarmModel_AlarmRuleProperty, aws_cdk_lib_aws_iotevents_CfnAlarmModel_AssetPropertyTimestampProperty, aws_cdk_lib_aws_iotevents_CfnAlarmModel_AssetPropertyValueProperty, aws_cdk_lib_aws_iotevents_CfnAlarmModel_AssetPropertyVariantProperty, aws_cdk_lib_aws_iotevents_CfnAlarmModel_DynamoDBProperty, aws_cdk_lib_aws_iotevents_CfnAlarmModel_DynamoDBv2Property, aws_cdk_lib_aws_iotevents_CfnAlarmModel_FirehoseProperty, aws_cdk_lib_aws_iotevents_CfnAlarmModel_InitializationConfigurationProperty, aws_cdk_lib_aws_iotevents_CfnAlarmModel_IotEventsProperty, aws_cdk_lib_aws_iotevents_CfnAlarmModel_IotSiteWiseProperty, aws_cdk_lib_aws_iotevents_CfnAlarmModel_IotTopicPublishProperty, aws_cdk_lib_aws_iotevents_CfnAlarmModel_LambdaProperty, aws_cdk_lib_aws_iotevents_CfnAlarmModel_PayloadProperty, aws_cdk_lib_aws_iotevents_CfnAlarmModel_SimpleRuleProperty, aws_cdk_lib_aws_iotevents_CfnAlarmModel_SnsProperty, aws_cdk_lib_aws_iotevents_CfnAlarmModel_SqsProperty, aws_cdk_lib_aws_iotevents_CfnDetectorModelProps, aws_cdk_lib_aws_iotevents_CfnDetectorModel, aws_cdk_lib_aws_iotevents_CfnDetectorModel_ActionProperty, aws_cdk_lib_aws_iotevents_CfnDetectorModel_AssetPropertyTimestampProperty, aws_cdk_lib_aws_iotevents_CfnDetectorModel_AssetPropertyValueProperty, aws_cdk_lib_aws_iotevents_CfnDetectorModel_AssetPropertyVariantProperty, aws_cdk_lib_aws_iotevents_CfnDetectorModel_ClearTimerProperty, aws_cdk_lib_aws_iotevents_CfnDetectorModel_DetectorModelDefinitionProperty, aws_cdk_lib_aws_iotevents_CfnDetectorModel_DynamoDBProperty, aws_cdk_lib_aws_iotevents_CfnDetectorModel_DynamoDBv2Property, aws_cdk_lib_aws_iotevents_CfnDetectorModel_EventProperty, aws_cdk_lib_aws_iotevents_CfnDetectorModel_FirehoseProperty, aws_cdk_lib_aws_iotevents_CfnDetectorModel_IotEventsProperty, aws_cdk_lib_aws_iotevents_CfnDetectorModel_IotSiteWiseProperty, aws_cdk_lib_aws_iotevents_CfnDetectorModel_IotTopicPublishProperty, aws_cdk_lib_aws_iotevents_CfnDetectorModel_LambdaProperty, aws_cdk_lib_aws_iotevents_CfnDetectorModel_OnEnterProperty, aws_cdk_lib_aws_iotevents_CfnDetectorModel_OnExitProperty, aws_cdk_lib_aws_iotevents_CfnDetectorModel_OnInputProperty, aws_cdk_lib_aws_iotevents_CfnDetectorModel_PayloadProperty, aws_cdk_lib_aws_iotevents_CfnDetectorModel_ResetTimerProperty, aws_cdk_lib_aws_iotevents_CfnDetectorModel_SetTimerProperty, aws_cdk_lib_aws_iotevents_CfnDetectorModel_SetVariableProperty, aws_cdk_lib_aws_iotevents_CfnDetectorModel_SnsProperty, aws_cdk_lib_aws_iotevents_CfnDetectorModel_SqsProperty, aws_cdk_lib_aws_iotevents_CfnDetectorModel_StateProperty, aws_cdk_lib_aws_iotevents_CfnDetectorModel_TransitionEventProperty, aws_cdk_lib_aws_iotevents_CfnInputProps, aws_cdk_lib_aws_iotevents_CfnInput, aws_cdk_lib_aws_iotevents_CfnInput_AttributeProperty, aws_cdk_lib_aws_iotevents_CfnInput_InputDefinitionProperty, aws_cdk_lib_aws_iotfleethub_CfnApplicationProps, aws_cdk_lib_aws_iotfleethub_CfnApplication, aws_cdk_lib_aws_iotfleetwise_CfnCampaignProps, aws_cdk_lib_aws_iotfleetwise_CfnCampaign, aws_cdk_lib_aws_iotfleetwise_CfnCampaign_CollectionSchemeProperty, aws_cdk_lib_aws_iotfleetwise_CfnCampaign_ConditionBasedCollectionSchemeProperty, aws_cdk_lib_aws_iotfleetwise_CfnCampaign_SignalInformationProperty, aws_cdk_lib_aws_iotfleetwise_CfnCampaign_TimeBasedCollectionSchemeProperty, aws_cdk_lib_aws_iotfleetwise_CfnDecoderManifestProps, aws_cdk_lib_aws_iotfleetwise_CfnDecoderManifest, aws_cdk_lib_aws_iotfleetwise_CfnDecoderManifest_CanInterfaceProperty, aws_cdk_lib_aws_iotfleetwise_CfnDecoderManifest_CanSignalProperty, aws_cdk_lib_aws_iotfleetwise_CfnDecoderManifest_NetworkInterfacesItemsProperty, aws_cdk_lib_aws_iotfleetwise_CfnDecoderManifest_ObdInterfaceProperty, aws_cdk_lib_aws_iotfleetwise_CfnDecoderManifest_ObdSignalProperty, aws_cdk_lib_aws_iotfleetwise_CfnDecoderManifest_SignalDecodersItemsProperty, aws_cdk_lib_aws_iotfleetwise_CfnFleetProps, aws_cdk_lib_aws_iotfleetwise_CfnFleet, aws_cdk_lib_aws_iotfleetwise_CfnModelManifestProps, aws_cdk_lib_aws_iotfleetwise_CfnModelManifest, aws_cdk_lib_aws_iotfleetwise_CfnSignalCatalogProps, aws_cdk_lib_aws_iotfleetwise_CfnSignalCatalog, aws_cdk_lib_aws_iotfleetwise_CfnSignalCatalog_ActuatorProperty, aws_cdk_lib_aws_iotfleetwise_CfnSignalCatalog_AttributeProperty, aws_cdk_lib_aws_iotfleetwise_CfnSignalCatalog_BranchProperty, aws_cdk_lib_aws_iotfleetwise_CfnSignalCatalog_NodeProperty, aws_cdk_lib_aws_iotfleetwise_CfnSignalCatalog_NodeCountsProperty, aws_cdk_lib_aws_iotfleetwise_CfnSignalCatalog_SensorProperty, aws_cdk_lib_aws_iotfleetwise_CfnVehicleProps, aws_cdk_lib_aws_iotfleetwise_CfnVehicle, aws_cdk_lib_aws_iotsitewise_CfnAccessPolicyProps, aws_cdk_lib_aws_iotsitewise_CfnAccessPolicy, aws_cdk_lib_aws_iotsitewise_CfnAccessPolicy_AccessPolicyIdentityProperty, aws_cdk_lib_aws_iotsitewise_CfnAccessPolicy_AccessPolicyResourceProperty, aws_cdk_lib_aws_iotsitewise_CfnAccessPolicy_IamRoleProperty, aws_cdk_lib_aws_iotsitewise_CfnAccessPolicy_IamUserProperty, aws_cdk_lib_aws_iotsitewise_CfnAccessPolicy_PortalProperty, aws_cdk_lib_aws_iotsitewise_CfnAccessPolicy_ProjectProperty, aws_cdk_lib_aws_iotsitewise_CfnAccessPolicy_UserProperty, aws_cdk_lib_aws_iotsitewise_CfnAssetProps, aws_cdk_lib_aws_iotsitewise_CfnAsset, aws_cdk_lib_aws_iotsitewise_CfnAsset_AssetHierarchyProperty, aws_cdk_lib_aws_iotsitewise_CfnAsset_AssetPropertyProperty, aws_cdk_lib_aws_iotsitewise_CfnAssetModelProps, aws_cdk_lib_aws_iotsitewise_CfnAssetModel, aws_cdk_lib_aws_iotsitewise_CfnAssetModel_AssetModelCompositeModelProperty, aws_cdk_lib_aws_iotsitewise_CfnAssetModel_AssetModelHierarchyProperty, aws_cdk_lib_aws_iotsitewise_CfnAssetModel_AssetModelPropertyProperty, aws_cdk_lib_aws_iotsitewise_CfnAssetModel_AttributeProperty, aws_cdk_lib_aws_iotsitewise_CfnAssetModel_ExpressionVariableProperty, aws_cdk_lib_aws_iotsitewise_CfnAssetModel_MetricProperty, aws_cdk_lib_aws_iotsitewise_CfnAssetModel_MetricWindowProperty, aws_cdk_lib_aws_iotsitewise_CfnAssetModel_PropertyTypeProperty, aws_cdk_lib_aws_iotsitewise_CfnAssetModel_TransformProperty, aws_cdk_lib_aws_iotsitewise_CfnAssetModel_TumblingWindowProperty, aws_cdk_lib_aws_iotsitewise_CfnAssetModel_VariableValueProperty, aws_cdk_lib_aws_iotsitewise_CfnDashboardProps, aws_cdk_lib_aws_iotsitewise_CfnDashboard, aws_cdk_lib_aws_iotsitewise_CfnGatewayProps, aws_cdk_lib_aws_iotsitewise_CfnGateway, aws_cdk_lib_aws_iotsitewise_CfnGateway_GatewayCapabilitySummaryProperty, aws_cdk_lib_aws_iotsitewise_CfnGateway_GatewayPlatformProperty, aws_cdk_lib_aws_iotsitewise_CfnGateway_GreengrassProperty, aws_cdk_lib_aws_iotsitewise_CfnGateway_GreengrassV2Property, aws_cdk_lib_aws_iotsitewise_CfnPortalProps, aws_cdk_lib_aws_iotsitewise_CfnPortal, aws_cdk_lib_aws_iotsitewise_CfnPortal_AlarmsProperty, aws_cdk_lib_aws_iotsitewise_CfnProjectProps, aws_cdk_lib_aws_iotsitewise_CfnProject, aws_cdk_lib_aws_iotthingsgraph_CfnFlowTemplateProps, aws_cdk_lib_aws_iotthingsgraph_CfnFlowTemplate, aws_cdk_lib_aws_iotthingsgraph_CfnFlowTemplate_DefinitionDocumentProperty, aws_cdk_lib_aws_iottwinmaker_CfnComponentTypeProps, aws_cdk_lib_aws_iottwinmaker_CfnComponentType, aws_cdk_lib_aws_iottwinmaker_CfnComponentType_DataConnectorProperty, aws_cdk_lib_aws_iottwinmaker_CfnComponentType_DataTypeProperty, aws_cdk_lib_aws_iottwinmaker_CfnComponentType_DataValueProperty, aws_cdk_lib_aws_iottwinmaker_CfnComponentType_ErrorProperty, aws_cdk_lib_aws_iottwinmaker_CfnComponentType_FunctionProperty, aws_cdk_lib_aws_iottwinmaker_CfnComponentType_LambdaFunctionProperty, aws_cdk_lib_aws_iottwinmaker_CfnComponentType_PropertyDefinitionProperty, aws_cdk_lib_aws_iottwinmaker_CfnComponentType_PropertyGroupProperty, aws_cdk_lib_aws_iottwinmaker_CfnComponentType_RelationshipProperty, aws_cdk_lib_aws_iottwinmaker_CfnComponentType_RelationshipValueProperty, aws_cdk_lib_aws_iottwinmaker_CfnComponentType_StatusProperty, aws_cdk_lib_aws_iottwinmaker_CfnEntityProps, aws_cdk_lib_aws_iottwinmaker_CfnEntity, aws_cdk_lib_aws_iottwinmaker_CfnEntity_ComponentProperty, aws_cdk_lib_aws_iottwinmaker_CfnEntity_DataTypeProperty, aws_cdk_lib_aws_iottwinmaker_CfnEntity_DataValueProperty, aws_cdk_lib_aws_iottwinmaker_CfnEntity_DefinitionProperty, aws_cdk_lib_aws_iottwinmaker_CfnEntity_ErrorProperty, aws_cdk_lib_aws_iottwinmaker_CfnEntity_PropertyProperty, aws_cdk_lib_aws_iottwinmaker_CfnEntity_PropertyGroupProperty, aws_cdk_lib_aws_iottwinmaker_CfnEntity_RelationshipProperty, aws_cdk_lib_aws_iottwinmaker_CfnEntity_RelationshipValueProperty, aws_cdk_lib_aws_iottwinmaker_CfnEntity_StatusProperty, aws_cdk_lib_aws_iottwinmaker_CfnSceneProps, aws_cdk_lib_aws_iottwinmaker_CfnScene, aws_cdk_lib_aws_iottwinmaker_CfnSyncJobProps, aws_cdk_lib_aws_iottwinmaker_CfnSyncJob, aws_cdk_lib_aws_iottwinmaker_CfnWorkspaceProps, aws_cdk_lib_aws_iottwinmaker_CfnWorkspace, aws_cdk_lib_aws_iotwireless_CfnDestinationProps, aws_cdk_lib_aws_iotwireless_CfnDestination, aws_cdk_lib_aws_iotwireless_CfnDeviceProfileProps, aws_cdk_lib_aws_iotwireless_CfnDeviceProfile, aws_cdk_lib_aws_iotwireless_CfnDeviceProfile_LoRaWANDeviceProfileProperty, aws_cdk_lib_aws_iotwireless_CfnFuotaTaskProps, aws_cdk_lib_aws_iotwireless_CfnFuotaTask, aws_cdk_lib_aws_iotwireless_CfnFuotaTask_LoRaWANProperty, aws_cdk_lib_aws_iotwireless_CfnMulticastGroupProps, aws_cdk_lib_aws_iotwireless_CfnMulticastGroup, aws_cdk_lib_aws_iotwireless_CfnMulticastGroup_LoRaWANProperty, aws_cdk_lib_aws_iotwireless_CfnNetworkAnalyzerConfigurationProps, aws_cdk_lib_aws_iotwireless_CfnNetworkAnalyzerConfiguration, aws_cdk_lib_aws_iotwireless_CfnNetworkAnalyzerConfiguration_TraceContentProperty, aws_cdk_lib_aws_iotwireless_CfnPartnerAccountProps, aws_cdk_lib_aws_iotwireless_CfnPartnerAccount, aws_cdk_lib_aws_iotwireless_CfnPartnerAccount_SidewalkAccountInfoProperty, aws_cdk_lib_aws_iotwireless_CfnPartnerAccount_SidewalkAccountInfoWithFingerprintProperty, aws_cdk_lib_aws_iotwireless_CfnPartnerAccount_SidewalkUpdateAccountProperty, aws_cdk_lib_aws_iotwireless_CfnServiceProfileProps, aws_cdk_lib_aws_iotwireless_CfnServiceProfile, aws_cdk_lib_aws_iotwireless_CfnServiceProfile_LoRaWANServiceProfileProperty, aws_cdk_lib_aws_iotwireless_CfnTaskDefinitionProps, aws_cdk_lib_aws_iotwireless_CfnTaskDefinition, aws_cdk_lib_aws_iotwireless_CfnTaskDefinition_LoRaWANGatewayVersionProperty, aws_cdk_lib_aws_iotwireless_CfnTaskDefinition_LoRaWANUpdateGatewayTaskCreateProperty, aws_cdk_lib_aws_iotwireless_CfnTaskDefinition_LoRaWANUpdateGatewayTaskEntryProperty, aws_cdk_lib_aws_iotwireless_CfnTaskDefinition_UpdateWirelessGatewayTaskCreateProperty, aws_cdk_lib_aws_iotwireless_CfnWirelessDeviceProps, aws_cdk_lib_aws_iotwireless_CfnWirelessDevice, aws_cdk_lib_aws_iotwireless_CfnWirelessDevice_AbpV10xProperty, aws_cdk_lib_aws_iotwireless_CfnWirelessDevice_AbpV11Property, aws_cdk_lib_aws_iotwireless_CfnWirelessDevice_LoRaWANDeviceProperty, aws_cdk_lib_aws_iotwireless_CfnWirelessDevice_OtaaV10xProperty, aws_cdk_lib_aws_iotwireless_CfnWirelessDevice_OtaaV11Property, aws_cdk_lib_aws_iotwireless_CfnWirelessDevice_SessionKeysAbpV10xProperty, aws_cdk_lib_aws_iotwireless_CfnWirelessDevice_SessionKeysAbpV11Property, aws_cdk_lib_aws_iotwireless_CfnWirelessDeviceImportTaskProps, aws_cdk_lib_aws_iotwireless_CfnWirelessDeviceImportTask, aws_cdk_lib_aws_iotwireless_CfnWirelessDeviceImportTask_SidewalkProperty, aws_cdk_lib_aws_iotwireless_CfnWirelessGatewayProps, aws_cdk_lib_aws_iotwireless_CfnWirelessGateway, aws_cdk_lib_aws_iotwireless_CfnWirelessGateway_LoRaWANGatewayProperty, aws_cdk_lib_aws_ivs_CfnChannelProps, aws_cdk_lib_aws_ivs_CfnChannel, aws_cdk_lib_aws_ivs_CfnPlaybackKeyPairProps, aws_cdk_lib_aws_ivs_CfnPlaybackKeyPair, aws_cdk_lib_aws_ivs_CfnRecordingConfigurationProps, aws_cdk_lib_aws_ivs_CfnRecordingConfiguration, aws_cdk_lib_aws_ivs_CfnRecordingConfiguration_DestinationConfigurationProperty, aws_cdk_lib_aws_ivs_CfnRecordingConfiguration_S3DestinationConfigurationProperty, aws_cdk_lib_aws_ivs_CfnRecordingConfiguration_ThumbnailConfigurationProperty, aws_cdk_lib_aws_ivs_CfnStreamKeyProps, aws_cdk_lib_aws_ivs_CfnStreamKey, aws_cdk_lib_aws_ivschat_CfnLoggingConfigurationProps, aws_cdk_lib_aws_ivschat_CfnLoggingConfiguration, aws_cdk_lib_aws_ivschat_CfnLoggingConfiguration_CloudWatchLogsDestinationConfigurationProperty, aws_cdk_lib_aws_ivschat_CfnLoggingConfiguration_DestinationConfigurationProperty, aws_cdk_lib_aws_ivschat_CfnLoggingConfiguration_FirehoseDestinationConfigurationProperty, aws_cdk_lib_aws_ivschat_CfnLoggingConfiguration_S3DestinationConfigurationProperty, aws_cdk_lib_aws_ivschat_CfnRoomProps, aws_cdk_lib_aws_ivschat_CfnRoom, aws_cdk_lib_aws_ivschat_CfnRoom_MessageReviewHandlerProperty, aws_cdk_lib_aws_kafkaconnect_CfnConnectorProps, aws_cdk_lib_aws_kafkaconnect_CfnConnector, aws_cdk_lib_aws_kafkaconnect_CfnConnector_ApacheKafkaClusterProperty, aws_cdk_lib_aws_kafkaconnect_CfnConnector_AutoScalingProperty, aws_cdk_lib_aws_kafkaconnect_CfnConnector_CapacityProperty, aws_cdk_lib_aws_kafkaconnect_CfnConnector_CloudWatchLogsLogDeliveryProperty, aws_cdk_lib_aws_kafkaconnect_CfnConnector_CustomPluginProperty, aws_cdk_lib_aws_kafkaconnect_CfnConnector_FirehoseLogDeliveryProperty, aws_cdk_lib_aws_kafkaconnect_CfnConnector_KafkaClusterProperty, aws_cdk_lib_aws_kafkaconnect_CfnConnector_KafkaClusterClientAuthenticationProperty, aws_cdk_lib_aws_kafkaconnect_CfnConnector_KafkaClusterEncryptionInTransitProperty, aws_cdk_lib_aws_kafkaconnect_CfnConnector_LogDeliveryProperty, aws_cdk_lib_aws_kafkaconnect_CfnConnector_PluginProperty, aws_cdk_lib_aws_kafkaconnect_CfnConnector_ProvisionedCapacityProperty, aws_cdk_lib_aws_kafkaconnect_CfnConnector_S3LogDeliveryProperty, aws_cdk_lib_aws_kafkaconnect_CfnConnector_ScaleInPolicyProperty, aws_cdk_lib_aws_kafkaconnect_CfnConnector_ScaleOutPolicyProperty, aws_cdk_lib_aws_kafkaconnect_CfnConnector_VpcProperty, aws_cdk_lib_aws_kafkaconnect_CfnConnector_WorkerConfigurationProperty, aws_cdk_lib_aws_kafkaconnect_CfnConnector_WorkerLogDeliveryProperty, aws_cdk_lib_aws_kendra_CfnDataSourceProps, aws_cdk_lib_aws_kendra_CfnDataSource, aws_cdk_lib_aws_kendra_CfnDataSource_AccessControlListConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_AclConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_ColumnConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_ConfluenceAttachmentConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_ConfluenceAttachmentToIndexFieldMappingProperty, aws_cdk_lib_aws_kendra_CfnDataSource_ConfluenceBlogConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_ConfluenceBlogToIndexFieldMappingProperty, aws_cdk_lib_aws_kendra_CfnDataSource_ConfluenceConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_ConfluencePageConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_ConfluencePageToIndexFieldMappingProperty, aws_cdk_lib_aws_kendra_CfnDataSource_ConfluenceSpaceConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_ConfluenceSpaceToIndexFieldMappingProperty, aws_cdk_lib_aws_kendra_CfnDataSource_ConnectionConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_CustomDocumentEnrichmentConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_DataSourceConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_DataSourceToIndexFieldMappingProperty, aws_cdk_lib_aws_kendra_CfnDataSource_DataSourceVpcConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_DatabaseConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_DocumentAttributeConditionProperty, aws_cdk_lib_aws_kendra_CfnDataSource_DocumentAttributeTargetProperty, aws_cdk_lib_aws_kendra_CfnDataSource_DocumentAttributeValueProperty, aws_cdk_lib_aws_kendra_CfnDataSource_DocumentsMetadataConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_GoogleDriveConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_HookConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_InlineCustomDocumentEnrichmentConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_OneDriveConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_OneDriveUsersProperty, aws_cdk_lib_aws_kendra_CfnDataSource_ProxyConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_S3DataSourceConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_S3PathProperty, aws_cdk_lib_aws_kendra_CfnDataSource_SalesforceChatterFeedConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_SalesforceConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_SalesforceCustomKnowledgeArticleTypeConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_SalesforceKnowledgeArticleConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_SalesforceStandardKnowledgeArticleTypeConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_SalesforceStandardObjectAttachmentConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_SalesforceStandardObjectConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_ServiceNowConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_ServiceNowKnowledgeArticleConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_ServiceNowServiceCatalogConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_SharePointConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_SqlConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_WebCrawlerAuthenticationConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_WebCrawlerBasicAuthenticationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_WebCrawlerConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_WebCrawlerSeedUrlConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_WebCrawlerSiteMapsConfigurationProperty, aws_cdk_lib_aws_kendra_CfnDataSource_WebCrawlerUrlsProperty, aws_cdk_lib_aws_kendra_CfnDataSource_WorkDocsConfigurationProperty, aws_cdk_lib_aws_kendra_CfnFaqProps, aws_cdk_lib_aws_kendra_CfnFaq, aws_cdk_lib_aws_kendra_CfnFaq_S3PathProperty, aws_cdk_lib_aws_kendra_CfnIndexProps, aws_cdk_lib_aws_kendra_CfnIndex, aws_cdk_lib_aws_kendra_CfnIndex_CapacityUnitsConfigurationProperty, aws_cdk_lib_aws_kendra_CfnIndex_DocumentMetadataConfigurationProperty, aws_cdk_lib_aws_kendra_CfnIndex_JsonTokenTypeConfigurationProperty, aws_cdk_lib_aws_kendra_CfnIndex_JwtTokenTypeConfigurationProperty, aws_cdk_lib_aws_kendra_CfnIndex_RelevanceProperty, aws_cdk_lib_aws_kendra_CfnIndex_SearchProperty, aws_cdk_lib_aws_kendra_CfnIndex_ServerSideEncryptionConfigurationProperty, aws_cdk_lib_aws_kendra_CfnIndex_UserTokenConfigurationProperty, aws_cdk_lib_aws_kendra_CfnIndex_ValueImportanceItemProperty, aws_cdk_lib_aws_kendraranking_CfnExecutionPlanProps, aws_cdk_lib_aws_kendraranking_CfnExecutionPlan, aws_cdk_lib_aws_kendraranking_CfnExecutionPlan_CapacityUnitsConfigurationProperty, aws_cdk_lib_aws_kinesis_IStream, aws_cdk_lib_aws_kinesis_StreamAttributes, aws_cdk_lib_aws_kinesis_StreamProps, aws_cdk_lib_aws_kinesis_Stream, aws_cdk_lib_aws_kinesis_StreamEncryption, aws_cdk_lib_aws_kinesis_StreamMode, aws_cdk_lib_aws_kinesis_CfnStreamProps, aws_cdk_lib_aws_kinesis_CfnStream, aws_cdk_lib_aws_kinesis_CfnStream_StreamEncryptionProperty, aws_cdk_lib_aws_kinesis_CfnStream_StreamModeDetailsProperty, aws_cdk_lib_aws_kinesis_CfnStreamConsumerProps, aws_cdk_lib_aws_kinesis_CfnStreamConsumer, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationProps, aws_cdk_lib_aws_kinesisanalytics_CfnApplication, aws_cdk_lib_aws_kinesisanalytics_CfnApplication_CSVMappingParametersProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplication_InputProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplication_InputLambdaProcessorProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplication_InputParallelismProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplication_InputProcessingConfigurationProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplication_InputSchemaProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplication_JSONMappingParametersProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplication_KinesisFirehoseInputProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplication_KinesisStreamsInputProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplication_MappingParametersProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplication_RecordColumnProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplication_RecordFormatProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationOutputProps, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationOutput, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationOutput_DestinationSchemaProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationOutput_KinesisFirehoseOutputProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationOutput_KinesisStreamsOutputProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationOutput_LambdaOutputProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationOutput_OutputProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSourceProps, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSource, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSource_CSVMappingParametersProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSource_JSONMappingParametersProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSource_MappingParametersProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSource_RecordColumnProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSource_RecordFormatProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSource_ReferenceDataSourceProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSource_ReferenceSchemaProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSource_S3ReferenceDataSourceProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2Props, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_ApplicationCodeConfigurationProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_ApplicationConfigurationProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_ApplicationMaintenanceConfigurationProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_ApplicationRestoreConfigurationProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_ApplicationSnapshotConfigurationProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_CSVMappingParametersProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_CatalogConfigurationProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_CheckpointConfigurationProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_CodeContentProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_CustomArtifactConfigurationProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_DeployAsApplicationConfigurationProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_EnvironmentPropertiesProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_FlinkApplicationConfigurationProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_FlinkRunConfigurationProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_GlueDataCatalogConfigurationProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_InputProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_InputLambdaProcessorProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_InputParallelismProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_InputProcessingConfigurationProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_InputSchemaProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_JSONMappingParametersProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_KinesisFirehoseInputProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_KinesisStreamsInputProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_MappingParametersProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_MavenReferenceProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_MonitoringConfigurationProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_ParallelismConfigurationProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_PropertyGroupProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_RecordColumnProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_RecordFormatProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_RunConfigurationProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_S3ContentBaseLocationProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_S3ContentLocationProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_SqlApplicationConfigurationProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_VpcConfigurationProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_ZeppelinApplicationConfigurationProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2_ZeppelinMonitoringConfigurationProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationCloudWatchLoggingOptionV2Props, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationCloudWatchLoggingOptionV2, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationCloudWatchLoggingOptionV2_CloudWatchLoggingOptionProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationOutputV2Props, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationOutputV2, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationOutputV2_DestinationSchemaProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationOutputV2_KinesisFirehoseOutputProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationOutputV2_KinesisStreamsOutputProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationOutputV2_LambdaOutputProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationOutputV2_OutputProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSourceV2Props, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSourceV2, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSourceV2_CSVMappingParametersProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSourceV2_JSONMappingParametersProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSourceV2_MappingParametersProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSourceV2_RecordColumnProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSourceV2_RecordFormatProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSourceV2_ReferenceDataSourceProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSourceV2_ReferenceSchemaProperty, aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSourceV2_S3ReferenceDataSourceProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationProps, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_ApplicationCodeConfigurationProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_ApplicationConfigurationProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_ApplicationMaintenanceConfigurationProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_ApplicationRestoreConfigurationProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_ApplicationSnapshotConfigurationProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_CSVMappingParametersProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_CatalogConfigurationProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_CheckpointConfigurationProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_CodeContentProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_CustomArtifactConfigurationProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_DeployAsApplicationConfigurationProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_EnvironmentPropertiesProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_FlinkApplicationConfigurationProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_FlinkRunConfigurationProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_GlueDataCatalogConfigurationProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_InputProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_InputLambdaProcessorProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_InputParallelismProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_InputProcessingConfigurationProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_InputSchemaProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_JSONMappingParametersProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_KinesisFirehoseInputProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_KinesisStreamsInputProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_MappingParametersProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_MavenReferenceProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_MonitoringConfigurationProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_ParallelismConfigurationProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_PropertyGroupProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_RecordColumnProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_RecordFormatProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_RunConfigurationProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_S3ContentBaseLocationProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_S3ContentLocationProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_SqlApplicationConfigurationProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_VpcConfigurationProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_ZeppelinApplicationConfigurationProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplication_ZeppelinMonitoringConfigurationProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationCloudWatchLoggingOptionProps, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationCloudWatchLoggingOption, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationCloudWatchLoggingOption_CloudWatchLoggingOptionProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationOutputProps, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationOutput, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationOutput_DestinationSchemaProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationOutput_KinesisFirehoseOutputProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationOutput_KinesisStreamsOutputProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationOutput_LambdaOutputProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationOutput_OutputProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationReferenceDataSourceProps, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationReferenceDataSource, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationReferenceDataSource_CSVMappingParametersProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationReferenceDataSource_JSONMappingParametersProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationReferenceDataSource_MappingParametersProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationReferenceDataSource_RecordColumnProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationReferenceDataSource_RecordFormatProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationReferenceDataSource_ReferenceDataSourceProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationReferenceDataSource_ReferenceSchemaProperty, aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationReferenceDataSource_S3ReferenceDataSourceProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStreamProps, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_AmazonOpenSearchServerlessBufferingHintsProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_AmazonOpenSearchServerlessDestinationConfigurationProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_AmazonOpenSearchServerlessRetryOptionsProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_AmazonopensearchserviceBufferingHintsProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_AmazonopensearchserviceDestinationConfigurationProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_AmazonopensearchserviceRetryOptionsProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_BufferingHintsProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_CloudWatchLoggingOptionsProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_CopyCommandProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_DataFormatConversionConfigurationProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_DeliveryStreamEncryptionConfigurationInputProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_DeserializerProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_DocumentIdOptionsProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_DynamicPartitioningConfigurationProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_ElasticsearchBufferingHintsProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_ElasticsearchDestinationConfigurationProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_ElasticsearchRetryOptionsProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_EncryptionConfigurationProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_ExtendedS3DestinationConfigurationProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_HiveJsonSerDeProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_HttpEndpointCommonAttributeProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_HttpEndpointConfigurationProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_HttpEndpointDestinationConfigurationProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_HttpEndpointRequestConfigurationProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_InputFormatConfigurationProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_KMSEncryptionConfigProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_KinesisStreamSourceConfigurationProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_OpenXJsonSerDeProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_OrcSerDeProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_OutputFormatConfigurationProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_ParquetSerDeProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_ProcessingConfigurationProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_ProcessorProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_ProcessorParameterProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_RedshiftDestinationConfigurationProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_RedshiftRetryOptionsProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_RetryOptionsProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_S3DestinationConfigurationProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_SchemaConfigurationProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_SerializerProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_SplunkDestinationConfigurationProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_SplunkRetryOptionsProperty, aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream_VpcConfigurationProperty, aws_cdk_lib_aws_kinesisvideo_CfnSignalingChannelProps, aws_cdk_lib_aws_kinesisvideo_CfnSignalingChannel, aws_cdk_lib_aws_kinesisvideo_CfnStreamProps, aws_cdk_lib_aws_kinesisvideo_CfnStream, aws_cdk_lib_aws_kms_IKey, aws_cdk_lib_aws_kms_KeySpec, aws_cdk_lib_aws_kms_KeyUsage, aws_cdk_lib_aws_kms_KeyProps, aws_cdk_lib_aws_kms_Key, aws_cdk_lib_aws_kms_KeyLookupOptions, aws_cdk_lib_aws_kms_IAlias, aws_cdk_lib_aws_kms_AliasProps, aws_cdk_lib_aws_kms_AliasAttributes, aws_cdk_lib_aws_kms_Alias, aws_cdk_lib_aws_kms_ViaServicePrincipal, aws_cdk_lib_aws_kms_CfnAliasProps, aws_cdk_lib_aws_kms_CfnAlias, aws_cdk_lib_aws_kms_CfnKeyProps, aws_cdk_lib_aws_kms_CfnKey, aws_cdk_lib_aws_kms_CfnReplicaKeyProps, aws_cdk_lib_aws_kms_CfnReplicaKey, aws_cdk_lib_aws_lakeformation_CfnDataCellsFilterProps, aws_cdk_lib_aws_lakeformation_CfnDataCellsFilter, aws_cdk_lib_aws_lakeformation_CfnDataCellsFilter_ColumnWildcardProperty, aws_cdk_lib_aws_lakeformation_CfnDataCellsFilter_RowFilterProperty, aws_cdk_lib_aws_lakeformation_CfnDataLakeSettingsProps, aws_cdk_lib_aws_lakeformation_CfnDataLakeSettings, aws_cdk_lib_aws_lakeformation_CfnDataLakeSettings_DataLakePrincipalProperty, aws_cdk_lib_aws_lakeformation_CfnDataLakeSettings_PrincipalPermissionsProperty, aws_cdk_lib_aws_lakeformation_CfnPermissionsProps, aws_cdk_lib_aws_lakeformation_CfnPermissions, aws_cdk_lib_aws_lakeformation_CfnPermissions_ColumnWildcardProperty, aws_cdk_lib_aws_lakeformation_CfnPermissions_DataLakePrincipalProperty, aws_cdk_lib_aws_lakeformation_CfnPermissions_DataLocationResourceProperty, aws_cdk_lib_aws_lakeformation_CfnPermissions_DatabaseResourceProperty, aws_cdk_lib_aws_lakeformation_CfnPermissions_ResourceProperty, aws_cdk_lib_aws_lakeformation_CfnPermissions_TableResourceProperty, aws_cdk_lib_aws_lakeformation_CfnPermissions_TableWildcardProperty, aws_cdk_lib_aws_lakeformation_CfnPermissions_TableWithColumnsResourceProperty, aws_cdk_lib_aws_lakeformation_CfnPrincipalPermissionsProps, aws_cdk_lib_aws_lakeformation_CfnPrincipalPermissions, aws_cdk_lib_aws_lakeformation_CfnPrincipalPermissions_ColumnWildcardProperty, aws_cdk_lib_aws_lakeformation_CfnPrincipalPermissions_DataCellsFilterResourceProperty, aws_cdk_lib_aws_lakeformation_CfnPrincipalPermissions_DataLakePrincipalProperty, aws_cdk_lib_aws_lakeformation_CfnPrincipalPermissions_DataLocationResourceProperty, aws_cdk_lib_aws_lakeformation_CfnPrincipalPermissions_DatabaseResourceProperty, aws_cdk_lib_aws_lakeformation_CfnPrincipalPermissions_LFTagProperty, aws_cdk_lib_aws_lakeformation_CfnPrincipalPermissions_LFTagKeyResourceProperty, aws_cdk_lib_aws_lakeformation_CfnPrincipalPermissions_LFTagPolicyResourceProperty, aws_cdk_lib_aws_lakeformation_CfnPrincipalPermissions_ResourceProperty, aws_cdk_lib_aws_lakeformation_CfnPrincipalPermissions_TableResourceProperty, aws_cdk_lib_aws_lakeformation_CfnPrincipalPermissions_TableWithColumnsResourceProperty, aws_cdk_lib_aws_lakeformation_CfnResourceProps, aws_cdk_lib_aws_lakeformation_CfnResource, aws_cdk_lib_aws_lakeformation_CfnTagProps, aws_cdk_lib_aws_lakeformation_CfnTag, aws_cdk_lib_aws_lakeformation_CfnTagAssociationProps, aws_cdk_lib_aws_lakeformation_CfnTagAssociation, aws_cdk_lib_aws_lakeformation_CfnTagAssociation_DatabaseResourceProperty, aws_cdk_lib_aws_lakeformation_CfnTagAssociation_LFTagPairProperty, aws_cdk_lib_aws_lakeformation_CfnTagAssociation_ResourceProperty, aws_cdk_lib_aws_lakeformation_CfnTagAssociation_TableResourceProperty, aws_cdk_lib_aws_lakeformation_CfnTagAssociation_TableWithColumnsResourceProperty, aws_cdk_lib_aws_lambda_AdotInstrumentationConfig, aws_cdk_lib_aws_lambda_AdotLayerVersion, aws_cdk_lib_aws_lambda_AdotLambdaExecWrapper, aws_cdk_lib_aws_lambda_AdotLambdaLayerJavaSdkVersion, aws_cdk_lib_aws_lambda_AdotLambdaLayerJavaAutoInstrumentationVersion, aws_cdk_lib_aws_lambda_AdotLambdaLayerPythonSdkVersion, aws_cdk_lib_aws_lambda_AdotLambdaLayerJavaScriptSdkVersion, aws_cdk_lib_aws_lambda_AdotLambdaLayerGenericVersion, aws_cdk_lib_aws_lambda_IAlias, aws_cdk_lib_aws_lambda_AliasOptions, aws_cdk_lib_aws_lambda_AliasProps, aws_cdk_lib_aws_lambda_AliasAttributes, aws_cdk_lib_aws_lambda_Alias, aws_cdk_lib_aws_lambda_VersionWeight, aws_cdk_lib_aws_lambda_DlqDestinationConfig, aws_cdk_lib_aws_lambda_IEventSourceDlq, aws_cdk_lib_aws_lambda_IFunction, aws_cdk_lib_aws_lambda_FunctionAttributes, aws_cdk_lib_aws_lambda_FunctionBase, aws_cdk_lib_aws_lambda_QualifiedFunctionBase, aws_cdk_lib_aws_lambda_Tracing, aws_cdk_lib_aws_lambda_FunctionOptions, aws_cdk_lib_aws_lambda_FunctionProps, aws_cdk_lib_aws_lambda_Function, aws_cdk_lib_aws_lambda_EnvironmentOptions, aws_cdk_lib_aws_lambda_FunctionVersionUpgrade, aws_cdk_lib_aws_lambda_Handler, aws_cdk_lib_aws_lambda_DockerImageFunctionProps, aws_cdk_lib_aws_lambda_DockerImageCode, aws_cdk_lib_aws_lambda_DockerImageFunction, aws_cdk_lib_aws_lambda_LayerVersionOptions, aws_cdk_lib_aws_lambda_LayerVersionProps, aws_cdk_lib_aws_lambda_ILayerVersion, aws_cdk_lib_aws_lambda_LayerVersionPermission, aws_cdk_lib_aws_lambda_LayerVersionAttributes, aws_cdk_lib_aws_lambda_LayerVersion, aws_cdk_lib_aws_lambda_Permission, aws_cdk_lib_aws_lambda_LambdaRuntimeProps, aws_cdk_lib_aws_lambda_RuntimeFamily, aws_cdk_lib_aws_lambda_Runtime, aws_cdk_lib_aws_lambda_Code, aws_cdk_lib_aws_lambda_CodeConfig, aws_cdk_lib_aws_lambda_CodeImageConfig, aws_cdk_lib_aws_lambda_S3Code, aws_cdk_lib_aws_lambda_InlineCode, aws_cdk_lib_aws_lambda_AssetCode, aws_cdk_lib_aws_lambda_ResourceBindOptions, aws_cdk_lib_aws_lambda_CfnParametersCodeProps, aws_cdk_lib_aws_lambda_CfnParametersCode, aws_cdk_lib_aws_lambda_EcrImageCodeProps, aws_cdk_lib_aws_lambda_EcrImageCode, aws_cdk_lib_aws_lambda_AssetImageCodeProps, aws_cdk_lib_aws_lambda_AssetImageCode, aws_cdk_lib_aws_lambda_DockerBuildAssetOptions, aws_cdk_lib_aws_lambda_FileSystemConfig, aws_cdk_lib_aws_lambda_FileSystem, aws_cdk_lib_aws_lambda_IVersion, aws_cdk_lib_aws_lambda_VersionOptions, aws_cdk_lib_aws_lambda_VersionProps, aws_cdk_lib_aws_lambda_VersionAttributes, aws_cdk_lib_aws_lambda_Version, aws_cdk_lib_aws_lambda_SingletonFunctionProps, aws_cdk_lib_aws_lambda_SingletonFunction, aws_cdk_lib_aws_lambda_IEventSource, aws_cdk_lib_aws_lambda_SourceAccessConfigurationType, aws_cdk_lib_aws_lambda_SourceAccessConfiguration, aws_cdk_lib_aws_lambda_EventSourceMappingOptions, aws_cdk_lib_aws_lambda_EventSourceMappingProps, aws_cdk_lib_aws_lambda_IEventSourceMapping, aws_cdk_lib_aws_lambda_EventSourceMapping, aws_cdk_lib_aws_lambda_StartingPosition, aws_cdk_lib_aws_lambda_FilterRule, aws_cdk_lib_aws_lambda_FilterCriteria, aws_cdk_lib_aws_lambda_DestinationConfig, aws_cdk_lib_aws_lambda_DestinationType, aws_cdk_lib_aws_lambda_DestinationOptions, aws_cdk_lib_aws_lambda_IDestination, aws_cdk_lib_aws_lambda_EventInvokeConfigOptions, aws_cdk_lib_aws_lambda_EventInvokeConfigProps, aws_cdk_lib_aws_lambda_EventInvokeConfig, aws_cdk_lib_aws_lambda_IScalableFunctionAttribute, aws_cdk_lib_aws_lambda_UtilizationScalingOptions, aws_cdk_lib_aws_lambda_AutoScalingOptions, aws_cdk_lib_aws_lambda_UntrustedArtifactOnDeployment, aws_cdk_lib_aws_lambda_ICodeSigningConfig, aws_cdk_lib_aws_lambda_CodeSigningConfigProps, aws_cdk_lib_aws_lambda_CodeSigningConfig, aws_cdk_lib_aws_lambda_LambdaInsightsVersion, aws_cdk_lib_aws_lambda_LogRetentionRetryOptions, aws_cdk_lib_aws_lambda_Architecture, aws_cdk_lib_aws_lambda_FunctionUrlAuthType, aws_cdk_lib_aws_lambda_HttpMethod, aws_cdk_lib_aws_lambda_FunctionUrlCorsOptions, aws_cdk_lib_aws_lambda_IFunctionUrl, aws_cdk_lib_aws_lambda_FunctionUrlOptions, aws_cdk_lib_aws_lambda_FunctionUrlProps, aws_cdk_lib_aws_lambda_FunctionUrl, aws_cdk_lib_aws_lambda_RuntimeManagementMode, aws_cdk_lib_aws_lambda_CfnAliasProps, aws_cdk_lib_aws_lambda_CfnAlias, aws_cdk_lib_aws_lambda_CfnAlias_AliasRoutingConfigurationProperty, aws_cdk_lib_aws_lambda_CfnAlias_ProvisionedConcurrencyConfigurationProperty, aws_cdk_lib_aws_lambda_CfnAlias_VersionWeightProperty, aws_cdk_lib_aws_lambda_CfnCodeSigningConfigProps, aws_cdk_lib_aws_lambda_CfnCodeSigningConfig, aws_cdk_lib_aws_lambda_CfnCodeSigningConfig_AllowedPublishersProperty, aws_cdk_lib_aws_lambda_CfnCodeSigningConfig_CodeSigningPoliciesProperty, aws_cdk_lib_aws_lambda_CfnEventInvokeConfigProps, aws_cdk_lib_aws_lambda_CfnEventInvokeConfig, aws_cdk_lib_aws_lambda_CfnEventInvokeConfig_DestinationConfigProperty, aws_cdk_lib_aws_lambda_CfnEventInvokeConfig_OnFailureProperty, aws_cdk_lib_aws_lambda_CfnEventInvokeConfig_OnSuccessProperty, aws_cdk_lib_aws_lambda_CfnEventSourceMappingProps, aws_cdk_lib_aws_lambda_CfnEventSourceMapping, aws_cdk_lib_aws_lambda_CfnEventSourceMapping_AmazonManagedKafkaEventSourceConfigProperty, aws_cdk_lib_aws_lambda_CfnEventSourceMapping_DestinationConfigProperty, aws_cdk_lib_aws_lambda_CfnEventSourceMapping_DocumentDBEventSourceConfigProperty, aws_cdk_lib_aws_lambda_CfnEventSourceMapping_EndpointsProperty, aws_cdk_lib_aws_lambda_CfnEventSourceMapping_FilterProperty, aws_cdk_lib_aws_lambda_CfnEventSourceMapping_FilterCriteriaProperty, aws_cdk_lib_aws_lambda_CfnEventSourceMapping_OnFailureProperty, aws_cdk_lib_aws_lambda_CfnEventSourceMapping_ScalingConfigProperty, aws_cdk_lib_aws_lambda_CfnEventSourceMapping_SelfManagedEventSourceProperty, aws_cdk_lib_aws_lambda_CfnEventSourceMapping_SelfManagedKafkaEventSourceConfigProperty, aws_cdk_lib_aws_lambda_CfnEventSourceMapping_SourceAccessConfigurationProperty, aws_cdk_lib_aws_lambda_CfnFunctionProps, aws_cdk_lib_aws_lambda_CfnFunction, aws_cdk_lib_aws_lambda_CfnFunction_CodeProperty, aws_cdk_lib_aws_lambda_CfnFunction_DeadLetterConfigProperty, aws_cdk_lib_aws_lambda_CfnFunction_EnvironmentProperty, aws_cdk_lib_aws_lambda_CfnFunction_EphemeralStorageProperty, aws_cdk_lib_aws_lambda_CfnFunction_FileSystemConfigProperty, aws_cdk_lib_aws_lambda_CfnFunction_ImageConfigProperty, aws_cdk_lib_aws_lambda_CfnFunction_RuntimeManagementConfigProperty, aws_cdk_lib_aws_lambda_CfnFunction_SnapStartProperty, aws_cdk_lib_aws_lambda_CfnFunction_SnapStartResponseProperty, aws_cdk_lib_aws_lambda_CfnFunction_TracingConfigProperty, aws_cdk_lib_aws_lambda_CfnFunction_VpcConfigProperty, aws_cdk_lib_aws_lambda_CfnLayerVersionProps, aws_cdk_lib_aws_lambda_CfnLayerVersion, aws_cdk_lib_aws_lambda_CfnLayerVersion_ContentProperty, aws_cdk_lib_aws_lambda_CfnLayerVersionPermissionProps, aws_cdk_lib_aws_lambda_CfnLayerVersionPermission, aws_cdk_lib_aws_lambda_CfnPermissionProps, aws_cdk_lib_aws_lambda_CfnPermission, aws_cdk_lib_aws_lambda_CfnUrlProps, aws_cdk_lib_aws_lambda_CfnUrl, aws_cdk_lib_aws_lambda_CfnUrl_CorsProperty, aws_cdk_lib_aws_lambda_CfnVersionProps, aws_cdk_lib_aws_lambda_CfnVersion, aws_cdk_lib_aws_lambda_CfnVersion_ProvisionedConcurrencyConfigurationProperty, aws_cdk_lib_aws_lambda_destinations_EventBridgeDestination, aws_cdk_lib_aws_lambda_destinations_LambdaDestinationOptions, aws_cdk_lib_aws_lambda_destinations_LambdaDestination, aws_cdk_lib_aws_lambda_destinations_SnsDestination, aws_cdk_lib_aws_lambda_destinations_SqsDestination, aws_cdk_lib_aws_lambda_event_sources_ApiEventSource, aws_cdk_lib_aws_lambda_event_sources_DynamoEventSourceProps, aws_cdk_lib_aws_lambda_event_sources_DynamoEventSource, aws_cdk_lib_aws_lambda_event_sources_KafkaEventSourceProps, aws_cdk_lib_aws_lambda_event_sources_ManagedKafkaEventSourceProps, aws_cdk_lib_aws_lambda_event_sources_AuthenticationMethod, aws_cdk_lib_aws_lambda_event_sources_SelfManagedKafkaEventSourceProps, aws_cdk_lib_aws_lambda_event_sources_ManagedKafkaEventSource, aws_cdk_lib_aws_lambda_event_sources_SelfManagedKafkaEventSource, aws_cdk_lib_aws_lambda_event_sources_KinesisEventSourceProps, aws_cdk_lib_aws_lambda_event_sources_KinesisEventSource, aws_cdk_lib_aws_lambda_event_sources_S3EventSourceProps, aws_cdk_lib_aws_lambda_event_sources_S3EventSource, aws_cdk_lib_aws_lambda_event_sources_SnsEventSourceProps, aws_cdk_lib_aws_lambda_event_sources_SnsEventSource, aws_cdk_lib_aws_lambda_event_sources_SnsDlq, aws_cdk_lib_aws_lambda_event_sources_BaseStreamEventSourceProps, aws_cdk_lib_aws_lambda_event_sources_StreamEventSourceProps, aws_cdk_lib_aws_lambda_event_sources_StreamEventSource, aws_cdk_lib_aws_lambda_event_sources_SqsEventSourceProps, aws_cdk_lib_aws_lambda_event_sources_SqsEventSource, aws_cdk_lib_aws_lambda_event_sources_SqsDlq, aws_cdk_lib_aws_lambda_nodejs_NodejsFunctionProps, aws_cdk_lib_aws_lambda_nodejs_NodejsFunction, aws_cdk_lib_aws_lambda_nodejs_BundlingOptions, aws_cdk_lib_aws_lambda_nodejs_OutputFormat, aws_cdk_lib_aws_lambda_nodejs_ICommandHooks, aws_cdk_lib_aws_lambda_nodejs_LogLevel, aws_cdk_lib_aws_lambda_nodejs_SourceMapMode, aws_cdk_lib_aws_lambda_nodejs_Charset, aws_cdk_lib_aws_lex_CfnBotProps, aws_cdk_lib_aws_lex_CfnBot, aws_cdk_lib_aws_lex_CfnBot_AdvancedRecognitionSettingProperty, aws_cdk_lib_aws_lex_CfnBot_AllowedInputTypesProperty, aws_cdk_lib_aws_lex_CfnBot_AudioAndDTMFInputSpecificationProperty, aws_cdk_lib_aws_lex_CfnBot_AudioLogDestinationProperty, aws_cdk_lib_aws_lex_CfnBot_AudioLogSettingProperty, aws_cdk_lib_aws_lex_CfnBot_AudioSpecificationProperty, aws_cdk_lib_aws_lex_CfnBot_BotAliasLocaleSettingsProperty, aws_cdk_lib_aws_lex_CfnBot_BotAliasLocaleSettingsItemProperty, aws_cdk_lib_aws_lex_CfnBot_BotLocaleProperty, aws_cdk_lib_aws_lex_CfnBot_ButtonProperty, aws_cdk_lib_aws_lex_CfnBot_CloudWatchLogGroupLogDestinationProperty, aws_cdk_lib_aws_lex_CfnBot_CodeHookSpecificationProperty, aws_cdk_lib_aws_lex_CfnBot_ConditionProperty, aws_cdk_lib_aws_lex_CfnBot_ConditionalBranchProperty, aws_cdk_lib_aws_lex_CfnBot_ConditionalSpecificationProperty, aws_cdk_lib_aws_lex_CfnBot_ConversationLogSettingsProperty, aws_cdk_lib_aws_lex_CfnBot_CustomPayloadProperty, aws_cdk_lib_aws_lex_CfnBot_CustomVocabularyProperty, aws_cdk_lib_aws_lex_CfnBot_CustomVocabularyItemProperty, aws_cdk_lib_aws_lex_CfnBot_DTMFSpecificationProperty, aws_cdk_lib_aws_lex_CfnBot_DataPrivacyProperty, aws_cdk_lib_aws_lex_CfnBot_DefaultConditionalBranchProperty, aws_cdk_lib_aws_lex_CfnBot_DialogActionProperty, aws_cdk_lib_aws_lex_CfnBot_DialogCodeHookInvocationSettingProperty, aws_cdk_lib_aws_lex_CfnBot_DialogCodeHookSettingProperty, aws_cdk_lib_aws_lex_CfnBot_DialogStateProperty, aws_cdk_lib_aws_lex_CfnBot_ElicitationCodeHookInvocationSettingProperty, aws_cdk_lib_aws_lex_CfnBot_ExternalSourceSettingProperty, aws_cdk_lib_aws_lex_CfnBot_FulfillmentCodeHookSettingProperty, aws_cdk_lib_aws_lex_CfnBot_FulfillmentStartResponseSpecificationProperty, aws_cdk_lib_aws_lex_CfnBot_FulfillmentUpdateResponseSpecificationProperty, aws_cdk_lib_aws_lex_CfnBot_FulfillmentUpdatesSpecificationProperty, aws_cdk_lib_aws_lex_CfnBot_GrammarSlotTypeSettingProperty, aws_cdk_lib_aws_lex_CfnBot_GrammarSlotTypeSourceProperty, aws_cdk_lib_aws_lex_CfnBot_ImageResponseCardProperty, aws_cdk_lib_aws_lex_CfnBot_InitialResponseSettingProperty, aws_cdk_lib_aws_lex_CfnBot_InputContextProperty, aws_cdk_lib_aws_lex_CfnBot_IntentProperty, aws_cdk_lib_aws_lex_CfnBot_IntentClosingSettingProperty, aws_cdk_lib_aws_lex_CfnBot_IntentConfirmationSettingProperty, aws_cdk_lib_aws_lex_CfnBot_IntentOverrideProperty, aws_cdk_lib_aws_lex_CfnBot_KendraConfigurationProperty, aws_cdk_lib_aws_lex_CfnBot_LambdaCodeHookProperty, aws_cdk_lib_aws_lex_CfnBot_MessageProperty, aws_cdk_lib_aws_lex_CfnBot_MessageGroupProperty, aws_cdk_lib_aws_lex_CfnBot_MultipleValuesSettingProperty, aws_cdk_lib_aws_lex_CfnBot_ObfuscationSettingProperty, aws_cdk_lib_aws_lex_CfnBot_OutputContextProperty, aws_cdk_lib_aws_lex_CfnBot_PlainTextMessageProperty, aws_cdk_lib_aws_lex_CfnBot_PostDialogCodeHookInvocationSpecificationProperty, aws_cdk_lib_aws_lex_CfnBot_PostFulfillmentStatusSpecificationProperty, aws_cdk_lib_aws_lex_CfnBot_PromptAttemptSpecificationProperty, aws_cdk_lib_aws_lex_CfnBot_PromptSpecificationProperty, aws_cdk_lib_aws_lex_CfnBot_ResponseSpecificationProperty, aws_cdk_lib_aws_lex_CfnBot_S3BucketLogDestinationProperty, aws_cdk_lib_aws_lex_CfnBot_S3LocationProperty, aws_cdk_lib_aws_lex_CfnBot_SSMLMessageProperty, aws_cdk_lib_aws_lex_CfnBot_SampleUtteranceProperty, aws_cdk_lib_aws_lex_CfnBot_SampleValueProperty, aws_cdk_lib_aws_lex_CfnBot_SentimentAnalysisSettingsProperty, aws_cdk_lib_aws_lex_CfnBot_SessionAttributeProperty, aws_cdk_lib_aws_lex_CfnBot_SlotProperty, aws_cdk_lib_aws_lex_CfnBot_SlotCaptureSettingProperty, aws_cdk_lib_aws_lex_CfnBot_SlotDefaultValueProperty, aws_cdk_lib_aws_lex_CfnBot_SlotDefaultValueSpecificationProperty, aws_cdk_lib_aws_lex_CfnBot_SlotPriorityProperty, aws_cdk_lib_aws_lex_CfnBot_SlotTypeProperty, aws_cdk_lib_aws_lex_CfnBot_SlotTypeValueProperty, aws_cdk_lib_aws_lex_CfnBot_SlotValueProperty, aws_cdk_lib_aws_lex_CfnBot_SlotValueElicitationSettingProperty, aws_cdk_lib_aws_lex_CfnBot_SlotValueOverrideProperty, aws_cdk_lib_aws_lex_CfnBot_SlotValueOverrideMapProperty, aws_cdk_lib_aws_lex_CfnBot_SlotValueRegexFilterProperty, aws_cdk_lib_aws_lex_CfnBot_SlotValueSelectionSettingProperty, aws_cdk_lib_aws_lex_CfnBot_StillWaitingResponseSpecificationProperty, aws_cdk_lib_aws_lex_CfnBot_TestBotAliasSettingsProperty, aws_cdk_lib_aws_lex_CfnBot_TextInputSpecificationProperty, aws_cdk_lib_aws_lex_CfnBot_TextLogDestinationProperty, aws_cdk_lib_aws_lex_CfnBot_TextLogSettingProperty, aws_cdk_lib_aws_lex_CfnBot_VoiceSettingsProperty, aws_cdk_lib_aws_lex_CfnBot_WaitAndContinueSpecificationProperty, aws_cdk_lib_aws_lex_CfnBotAliasProps, aws_cdk_lib_aws_lex_CfnBotAlias, aws_cdk_lib_aws_lex_CfnBotAlias_AudioLogDestinationProperty, aws_cdk_lib_aws_lex_CfnBotAlias_AudioLogSettingProperty, aws_cdk_lib_aws_lex_CfnBotAlias_BotAliasLocaleSettingsProperty, aws_cdk_lib_aws_lex_CfnBotAlias_BotAliasLocaleSettingsItemProperty, aws_cdk_lib_aws_lex_CfnBotAlias_CloudWatchLogGroupLogDestinationProperty, aws_cdk_lib_aws_lex_CfnBotAlias_CodeHookSpecificationProperty, aws_cdk_lib_aws_lex_CfnBotAlias_ConversationLogSettingsProperty, aws_cdk_lib_aws_lex_CfnBotAlias_LambdaCodeHookProperty, aws_cdk_lib_aws_lex_CfnBotAlias_S3BucketLogDestinationProperty, aws_cdk_lib_aws_lex_CfnBotAlias_SentimentAnalysisSettingsProperty, aws_cdk_lib_aws_lex_CfnBotAlias_TextLogDestinationProperty, aws_cdk_lib_aws_lex_CfnBotAlias_TextLogSettingProperty, aws_cdk_lib_aws_lex_CfnBotVersionProps, aws_cdk_lib_aws_lex_CfnBotVersion, aws_cdk_lib_aws_lex_CfnBotVersion_BotVersionLocaleDetailsProperty, aws_cdk_lib_aws_lex_CfnBotVersion_BotVersionLocaleSpecificationProperty, aws_cdk_lib_aws_lex_CfnResourcePolicyProps, aws_cdk_lib_aws_lex_CfnResourcePolicy, aws_cdk_lib_aws_licensemanager_CfnGrantProps, aws_cdk_lib_aws_licensemanager_CfnGrant, aws_cdk_lib_aws_licensemanager_CfnLicenseProps, aws_cdk_lib_aws_licensemanager_CfnLicense, aws_cdk_lib_aws_licensemanager_CfnLicense_BorrowConfigurationProperty, aws_cdk_lib_aws_licensemanager_CfnLicense_ConsumptionConfigurationProperty, aws_cdk_lib_aws_licensemanager_CfnLicense_EntitlementProperty, aws_cdk_lib_aws_licensemanager_CfnLicense_IssuerDataProperty, aws_cdk_lib_aws_licensemanager_CfnLicense_MetadataProperty, aws_cdk_lib_aws_licensemanager_CfnLicense_ProvisionalConfigurationProperty, aws_cdk_lib_aws_licensemanager_CfnLicense_ValidityDateFormatProperty, aws_cdk_lib_aws_lightsail_CfnAlarmProps, aws_cdk_lib_aws_lightsail_CfnAlarm, aws_cdk_lib_aws_lightsail_CfnBucketProps, aws_cdk_lib_aws_lightsail_CfnBucket, aws_cdk_lib_aws_lightsail_CfnBucket_AccessRulesProperty, aws_cdk_lib_aws_lightsail_CfnCertificateProps, aws_cdk_lib_aws_lightsail_CfnCertificate, aws_cdk_lib_aws_lightsail_CfnContainerProps, aws_cdk_lib_aws_lightsail_CfnContainer, aws_cdk_lib_aws_lightsail_CfnContainer_ContainerProperty, aws_cdk_lib_aws_lightsail_CfnContainer_ContainerServiceDeploymentProperty, aws_cdk_lib_aws_lightsail_CfnContainer_EnvironmentVariableProperty, aws_cdk_lib_aws_lightsail_CfnContainer_HealthCheckConfigProperty, aws_cdk_lib_aws_lightsail_CfnContainer_PortInfoProperty, aws_cdk_lib_aws_lightsail_CfnContainer_PublicDomainNameProperty, aws_cdk_lib_aws_lightsail_CfnContainer_PublicEndpointProperty, aws_cdk_lib_aws_lightsail_CfnDatabaseProps, aws_cdk_lib_aws_lightsail_CfnDatabase, aws_cdk_lib_aws_lightsail_CfnDatabase_RelationalDatabaseParameterProperty, aws_cdk_lib_aws_lightsail_CfnDiskProps, aws_cdk_lib_aws_lightsail_CfnDisk, aws_cdk_lib_aws_lightsail_CfnDisk_AddOnProperty, aws_cdk_lib_aws_lightsail_CfnDisk_AutoSnapshotAddOnProperty, aws_cdk_lib_aws_lightsail_CfnDisk_LocationProperty, aws_cdk_lib_aws_lightsail_CfnDistributionProps, aws_cdk_lib_aws_lightsail_CfnDistribution, aws_cdk_lib_aws_lightsail_CfnDistribution_CacheBehaviorProperty, aws_cdk_lib_aws_lightsail_CfnDistribution_CacheBehaviorPerPathProperty, aws_cdk_lib_aws_lightsail_CfnDistribution_CacheSettingsProperty, aws_cdk_lib_aws_lightsail_CfnDistribution_CookieObjectProperty, aws_cdk_lib_aws_lightsail_CfnDistribution_HeaderObjectProperty, aws_cdk_lib_aws_lightsail_CfnDistribution_InputOriginProperty, aws_cdk_lib_aws_lightsail_CfnDistribution_QueryStringObjectProperty, aws_cdk_lib_aws_lightsail_CfnInstanceProps, aws_cdk_lib_aws_lightsail_CfnInstance, aws_cdk_lib_aws_lightsail_CfnInstance_AddOnProperty, aws_cdk_lib_aws_lightsail_CfnInstance_AutoSnapshotAddOnProperty, aws_cdk_lib_aws_lightsail_CfnInstance_DiskProperty, aws_cdk_lib_aws_lightsail_CfnInstance_HardwareProperty, aws_cdk_lib_aws_lightsail_CfnInstance_LocationProperty, aws_cdk_lib_aws_lightsail_CfnInstance_MonthlyTransferProperty, aws_cdk_lib_aws_lightsail_CfnInstance_NetworkingProperty, aws_cdk_lib_aws_lightsail_CfnInstance_PortProperty, aws_cdk_lib_aws_lightsail_CfnInstance_StateProperty, aws_cdk_lib_aws_lightsail_CfnLoadBalancerProps, aws_cdk_lib_aws_lightsail_CfnLoadBalancer, aws_cdk_lib_aws_lightsail_CfnLoadBalancerTlsCertificateProps, aws_cdk_lib_aws_lightsail_CfnLoadBalancerTlsCertificate, aws_cdk_lib_aws_lightsail_CfnStaticIpProps, aws_cdk_lib_aws_lightsail_CfnStaticIp, aws_cdk_lib_aws_location_CfnGeofenceCollectionProps, aws_cdk_lib_aws_location_CfnGeofenceCollection, aws_cdk_lib_aws_location_CfnMapProps, aws_cdk_lib_aws_location_CfnMap, aws_cdk_lib_aws_location_CfnMap_MapConfigurationProperty, aws_cdk_lib_aws_location_CfnPlaceIndexProps, aws_cdk_lib_aws_location_CfnPlaceIndex, aws_cdk_lib_aws_location_CfnPlaceIndex_DataSourceConfigurationProperty, aws_cdk_lib_aws_location_CfnRouteCalculatorProps, aws_cdk_lib_aws_location_CfnRouteCalculator, aws_cdk_lib_aws_location_CfnTrackerProps, aws_cdk_lib_aws_location_CfnTracker, aws_cdk_lib_aws_location_CfnTrackerConsumerProps, aws_cdk_lib_aws_location_CfnTrackerConsumer, aws_cdk_lib_aws_logs_CrossAccountDestinationProps, aws_cdk_lib_aws_logs_CrossAccountDestination, aws_cdk_lib_aws_logs_ILogGroup, aws_cdk_lib_aws_logs_RetentionDays, aws_cdk_lib_aws_logs_LogGroupProps, aws_cdk_lib_aws_logs_LogGroup, aws_cdk_lib_aws_logs_StreamOptions, aws_cdk_lib_aws_logs_SubscriptionFilterOptions, aws_cdk_lib_aws_logs_MetricFilterOptions, aws_cdk_lib_aws_logs_ILogStream, aws_cdk_lib_aws_logs_LogStreamProps, aws_cdk_lib_aws_logs_LogStream, aws_cdk_lib_aws_logs_MetricFilterProps, aws_cdk_lib_aws_logs_MetricFilter, aws_cdk_lib_aws_logs_IFilterPattern, aws_cdk_lib_aws_logs_JsonPattern, aws_cdk_lib_aws_logs_FilterPattern, aws_cdk_lib_aws_logs_SpaceDelimitedTextPattern, aws_cdk_lib_aws_logs_ColumnRestriction, aws_cdk_lib_aws_logs_ILogSubscriptionDestination, aws_cdk_lib_aws_logs_LogSubscriptionDestinationConfig, aws_cdk_lib_aws_logs_SubscriptionFilterProps, aws_cdk_lib_aws_logs_SubscriptionFilter, aws_cdk_lib_aws_logs_LogRetentionProps, aws_cdk_lib_aws_logs_LogRetentionRetryOptions, aws_cdk_lib_aws_logs_LogRetention, aws_cdk_lib_aws_logs_ResourcePolicyProps, aws_cdk_lib_aws_logs_ResourcePolicy, aws_cdk_lib_aws_logs_QueryStringProps, aws_cdk_lib_aws_logs_QueryString, aws_cdk_lib_aws_logs_QueryDefinitionProps, aws_cdk_lib_aws_logs_QueryDefinition, aws_cdk_lib_aws_logs_DataProtectionPolicy, aws_cdk_lib_aws_logs_DataProtectionPolicyConfig, aws_cdk_lib_aws_logs_DataProtectionPolicyProps, aws_cdk_lib_aws_logs_DataIdentifier, aws_cdk_lib_aws_logs_CfnDestinationProps, aws_cdk_lib_aws_logs_CfnDestination, aws_cdk_lib_aws_logs_CfnLogGroupProps, aws_cdk_lib_aws_logs_CfnLogGroup, aws_cdk_lib_aws_logs_CfnLogStreamProps, aws_cdk_lib_aws_logs_CfnLogStream, aws_cdk_lib_aws_logs_CfnMetricFilterProps, aws_cdk_lib_aws_logs_CfnMetricFilter, aws_cdk_lib_aws_logs_CfnMetricFilter_DimensionProperty, aws_cdk_lib_aws_logs_CfnMetricFilter_MetricTransformationProperty, aws_cdk_lib_aws_logs_CfnQueryDefinitionProps, aws_cdk_lib_aws_logs_CfnQueryDefinition, aws_cdk_lib_aws_logs_CfnResourcePolicyProps, aws_cdk_lib_aws_logs_CfnResourcePolicy, aws_cdk_lib_aws_logs_CfnSubscriptionFilterProps, aws_cdk_lib_aws_logs_CfnSubscriptionFilter, aws_cdk_lib_aws_logs_destinations_LambdaDestinationOptions, aws_cdk_lib_aws_logs_destinations_LambdaDestination, aws_cdk_lib_aws_logs_destinations_KinesisDestinationProps, aws_cdk_lib_aws_logs_destinations_KinesisDestination, aws_cdk_lib_aws_lookoutequipment_CfnInferenceSchedulerProps, aws_cdk_lib_aws_lookoutequipment_CfnInferenceScheduler, aws_cdk_lib_aws_lookoutequipment_CfnInferenceScheduler_DataInputConfigurationProperty, aws_cdk_lib_aws_lookoutequipment_CfnInferenceScheduler_DataOutputConfigurationProperty, aws_cdk_lib_aws_lookoutequipment_CfnInferenceScheduler_InputNameConfigurationProperty, aws_cdk_lib_aws_lookoutequipment_CfnInferenceScheduler_S3InputConfigurationProperty, aws_cdk_lib_aws_lookoutequipment_CfnInferenceScheduler_S3OutputConfigurationProperty, aws_cdk_lib_aws_lookoutmetrics_CfnAlertProps, aws_cdk_lib_aws_lookoutmetrics_CfnAlert, aws_cdk_lib_aws_lookoutmetrics_CfnAlert_ActionProperty, aws_cdk_lib_aws_lookoutmetrics_CfnAlert_LambdaConfigurationProperty, aws_cdk_lib_aws_lookoutmetrics_CfnAlert_SNSConfigurationProperty, aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetectorProps, aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetector, aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetector_AnomalyDetectorConfigProperty, aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetector_AppFlowConfigProperty, aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetector_CloudwatchConfigProperty, aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetector_CsvFormatDescriptorProperty, aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetector_FileFormatDescriptorProperty, aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetector_JsonFormatDescriptorProperty, aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetector_MetricProperty, aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetector_MetricSetProperty, aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetector_MetricSourceProperty, aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetector_RDSSourceConfigProperty, aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetector_RedshiftSourceConfigProperty, aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetector_S3SourceConfigProperty, aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetector_TimestampColumnProperty, aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetector_VpcConfigurationProperty, aws_cdk_lib_aws_lookoutvision_CfnProjectProps, aws_cdk_lib_aws_lookoutvision_CfnProject, aws_cdk_lib_aws_m2_CfnApplicationProps, aws_cdk_lib_aws_m2_CfnApplication, aws_cdk_lib_aws_m2_CfnApplication_DefinitionProperty, aws_cdk_lib_aws_m2_CfnEnvironmentProps, aws_cdk_lib_aws_m2_CfnEnvironment, aws_cdk_lib_aws_m2_CfnEnvironment_EfsStorageConfigurationProperty, aws_cdk_lib_aws_m2_CfnEnvironment_FsxStorageConfigurationProperty, aws_cdk_lib_aws_m2_CfnEnvironment_HighAvailabilityConfigProperty, aws_cdk_lib_aws_m2_CfnEnvironment_StorageConfigurationProperty, aws_cdk_lib_aws_macie_CfnAllowListProps, aws_cdk_lib_aws_macie_CfnAllowList, aws_cdk_lib_aws_macie_CfnAllowList_CriteriaProperty, aws_cdk_lib_aws_macie_CfnAllowList_S3WordsListProperty, aws_cdk_lib_aws_macie_CfnCustomDataIdentifierProps, aws_cdk_lib_aws_macie_CfnCustomDataIdentifier, aws_cdk_lib_aws_macie_CfnFindingsFilterProps, aws_cdk_lib_aws_macie_CfnFindingsFilter, aws_cdk_lib_aws_macie_CfnFindingsFilter_CriterionAdditionalPropertiesProperty, aws_cdk_lib_aws_macie_CfnFindingsFilter_FindingCriteriaProperty, aws_cdk_lib_aws_macie_CfnFindingsFilter_FindingsFilterListItemProperty, aws_cdk_lib_aws_macie_CfnSessionProps, aws_cdk_lib_aws_macie_CfnSession, aws_cdk_lib_aws_managedblockchain_CfnAccessorProps, aws_cdk_lib_aws_managedblockchain_CfnAccessor, aws_cdk_lib_aws_managedblockchain_CfnMemberProps, aws_cdk_lib_aws_managedblockchain_CfnMember, aws_cdk_lib_aws_managedblockchain_CfnMember_ApprovalThresholdPolicyProperty, aws_cdk_lib_aws_managedblockchain_CfnMember_MemberConfigurationProperty, aws_cdk_lib_aws_managedblockchain_CfnMember_MemberFabricConfigurationProperty, aws_cdk_lib_aws_managedblockchain_CfnMember_MemberFrameworkConfigurationProperty, aws_cdk_lib_aws_managedblockchain_CfnMember_NetworkConfigurationProperty, aws_cdk_lib_aws_managedblockchain_CfnMember_NetworkFabricConfigurationProperty, aws_cdk_lib_aws_managedblockchain_CfnMember_NetworkFrameworkConfigurationProperty, aws_cdk_lib_aws_managedblockchain_CfnMember_VotingPolicyProperty, aws_cdk_lib_aws_managedblockchain_CfnNodeProps, aws_cdk_lib_aws_managedblockchain_CfnNode, aws_cdk_lib_aws_managedblockchain_CfnNode_NodeConfigurationProperty, aws_cdk_lib_aws_mediaconnect_CfnFlowProps, aws_cdk_lib_aws_mediaconnect_CfnFlow, aws_cdk_lib_aws_mediaconnect_CfnFlow_EncryptionProperty, aws_cdk_lib_aws_mediaconnect_CfnFlow_FailoverConfigProperty, aws_cdk_lib_aws_mediaconnect_CfnFlow_SourceProperty, aws_cdk_lib_aws_mediaconnect_CfnFlow_SourcePriorityProperty, aws_cdk_lib_aws_mediaconnect_CfnFlowEntitlementProps, aws_cdk_lib_aws_mediaconnect_CfnFlowEntitlement, aws_cdk_lib_aws_mediaconnect_CfnFlowEntitlement_EncryptionProperty, aws_cdk_lib_aws_mediaconnect_CfnFlowOutputProps, aws_cdk_lib_aws_mediaconnect_CfnFlowOutput, aws_cdk_lib_aws_mediaconnect_CfnFlowOutput_EncryptionProperty, aws_cdk_lib_aws_mediaconnect_CfnFlowOutput_VpcInterfaceAttachmentProperty, aws_cdk_lib_aws_mediaconnect_CfnFlowSourceProps, aws_cdk_lib_aws_mediaconnect_CfnFlowSource, aws_cdk_lib_aws_mediaconnect_CfnFlowSource_EncryptionProperty, aws_cdk_lib_aws_mediaconnect_CfnFlowVpcInterfaceProps, aws_cdk_lib_aws_mediaconnect_CfnFlowVpcInterface, aws_cdk_lib_aws_mediaconvert_CfnJobTemplateProps, aws_cdk_lib_aws_mediaconvert_CfnJobTemplate, aws_cdk_lib_aws_mediaconvert_CfnJobTemplate_AccelerationSettingsProperty, aws_cdk_lib_aws_mediaconvert_CfnJobTemplate_HopDestinationProperty, aws_cdk_lib_aws_mediaconvert_CfnPresetProps, aws_cdk_lib_aws_mediaconvert_CfnPreset, aws_cdk_lib_aws_mediaconvert_CfnQueueProps, aws_cdk_lib_aws_mediaconvert_CfnQueue, aws_cdk_lib_aws_medialive_CfnChannelProps, aws_cdk_lib_aws_medialive_CfnChannel, aws_cdk_lib_aws_medialive_CfnChannel_AacSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_Ac3SettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_AncillarySourceSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_ArchiveCdnSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_ArchiveContainerSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_ArchiveGroupSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_ArchiveOutputSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_ArchiveS3SettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_AribDestinationSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_AribSourceSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_AudioChannelMappingProperty, aws_cdk_lib_aws_medialive_CfnChannel_AudioCodecSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_AudioDescriptionProperty, aws_cdk_lib_aws_medialive_CfnChannel_AudioDolbyEDecodeProperty, aws_cdk_lib_aws_medialive_CfnChannel_AudioHlsRenditionSelectionProperty, aws_cdk_lib_aws_medialive_CfnChannel_AudioLanguageSelectionProperty, aws_cdk_lib_aws_medialive_CfnChannel_AudioNormalizationSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_AudioOnlyHlsSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_AudioPidSelectionProperty, aws_cdk_lib_aws_medialive_CfnChannel_AudioSelectorProperty, aws_cdk_lib_aws_medialive_CfnChannel_AudioSelectorSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_AudioSilenceFailoverSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_AudioTrackProperty, aws_cdk_lib_aws_medialive_CfnChannel_AudioTrackSelectionProperty, aws_cdk_lib_aws_medialive_CfnChannel_AudioWatermarkSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_AutomaticInputFailoverSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_AvailBlankingProperty, aws_cdk_lib_aws_medialive_CfnChannel_AvailConfigurationProperty, aws_cdk_lib_aws_medialive_CfnChannel_AvailSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_BlackoutSlateProperty, aws_cdk_lib_aws_medialive_CfnChannel_BurnInDestinationSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_CaptionDescriptionProperty, aws_cdk_lib_aws_medialive_CfnChannel_CaptionDestinationSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_CaptionLanguageMappingProperty, aws_cdk_lib_aws_medialive_CfnChannel_CaptionRectangleProperty, aws_cdk_lib_aws_medialive_CfnChannel_CaptionSelectorProperty, aws_cdk_lib_aws_medialive_CfnChannel_CaptionSelectorSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_CdiInputSpecificationProperty, aws_cdk_lib_aws_medialive_CfnChannel_ColorSpacePassthroughSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_DolbyVision81SettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_DvbNitSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_DvbSdtSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_DvbSubDestinationSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_DvbSubSourceSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_DvbTdtSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_Eac3AtmosSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_Eac3SettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_EbuTtDDestinationSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_EmbeddedDestinationSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_EmbeddedPlusScte20DestinationSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_EmbeddedSourceSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_EncoderSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_EsamProperty, aws_cdk_lib_aws_medialive_CfnChannel_FailoverConditionProperty, aws_cdk_lib_aws_medialive_CfnChannel_FailoverConditionSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_FeatureActivationsProperty, aws_cdk_lib_aws_medialive_CfnChannel_FecOutputSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_Fmp4HlsSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_FrameCaptureCdnSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_FrameCaptureGroupSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_FrameCaptureHlsSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_FrameCaptureOutputSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_FrameCaptureS3SettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_FrameCaptureSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_GlobalConfigurationProperty, aws_cdk_lib_aws_medialive_CfnChannel_H264ColorSpaceSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_H264FilterSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_H264SettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_H265ColorSpaceSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_H265FilterSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_H265SettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_Hdr10SettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_HlsAkamaiSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_HlsBasicPutSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_HlsCdnSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_HlsGroupSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_HlsInputSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_HlsMediaStoreSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_HlsOutputSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_HlsS3SettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_HlsSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_HlsWebdavSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_HtmlMotionGraphicsSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_InputAttachmentProperty, aws_cdk_lib_aws_medialive_CfnChannel_InputChannelLevelProperty, aws_cdk_lib_aws_medialive_CfnChannel_InputLocationProperty, aws_cdk_lib_aws_medialive_CfnChannel_InputLossBehaviorProperty, aws_cdk_lib_aws_medialive_CfnChannel_InputLossFailoverSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_InputSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_InputSpecificationProperty, aws_cdk_lib_aws_medialive_CfnChannel_KeyProviderSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_M2tsSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_M3u8SettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_MaintenanceCreateSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_MaintenanceUpdateSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_MediaPackageGroupSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_MediaPackageOutputDestinationSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_MediaPackageOutputSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_MotionGraphicsConfigurationProperty, aws_cdk_lib_aws_medialive_CfnChannel_MotionGraphicsSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_Mp2SettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_Mpeg2FilterSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_Mpeg2SettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_MsSmoothGroupSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_MsSmoothOutputSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_MultiplexGroupSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_MultiplexOutputSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_MultiplexProgramChannelDestinationSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_NetworkInputSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_NielsenCBETProperty, aws_cdk_lib_aws_medialive_CfnChannel_NielsenConfigurationProperty, aws_cdk_lib_aws_medialive_CfnChannel_NielsenNaesIiNwProperty, aws_cdk_lib_aws_medialive_CfnChannel_NielsenWatermarksSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_OutputProperty, aws_cdk_lib_aws_medialive_CfnChannel_OutputDestinationProperty, aws_cdk_lib_aws_medialive_CfnChannel_OutputDestinationSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_OutputGroupProperty, aws_cdk_lib_aws_medialive_CfnChannel_OutputGroupSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_OutputLocationRefProperty, aws_cdk_lib_aws_medialive_CfnChannel_OutputSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_PassThroughSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_RawSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_Rec601SettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_Rec709SettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_RemixSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_RtmpCaptionInfoDestinationSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_RtmpGroupSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_RtmpOutputSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_Scte20PlusEmbeddedDestinationSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_Scte20SourceSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_Scte27DestinationSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_Scte27SourceSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_Scte35SpliceInsertProperty, aws_cdk_lib_aws_medialive_CfnChannel_Scte35TimeSignalAposProperty, aws_cdk_lib_aws_medialive_CfnChannel_SmpteTtDestinationSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_StandardHlsSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_StaticKeySettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_TeletextDestinationSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_TeletextSourceSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_TemporalFilterSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_TimecodeBurninSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_TimecodeConfigProperty, aws_cdk_lib_aws_medialive_CfnChannel_TtmlDestinationSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_UdpContainerSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_UdpGroupSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_UdpOutputSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_VideoBlackFailoverSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_VideoCodecSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_VideoDescriptionProperty, aws_cdk_lib_aws_medialive_CfnChannel_VideoSelectorProperty, aws_cdk_lib_aws_medialive_CfnChannel_VideoSelectorColorSpaceSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_VideoSelectorPidProperty, aws_cdk_lib_aws_medialive_CfnChannel_VideoSelectorProgramIdProperty, aws_cdk_lib_aws_medialive_CfnChannel_VideoSelectorSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_VpcOutputSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_WavSettingsProperty, aws_cdk_lib_aws_medialive_CfnChannel_WebvttDestinationSettingsProperty, aws_cdk_lib_aws_medialive_CfnInputProps, aws_cdk_lib_aws_medialive_CfnInput, aws_cdk_lib_aws_medialive_CfnInput_InputDestinationRequestProperty, aws_cdk_lib_aws_medialive_CfnInput_InputDeviceRequestProperty, aws_cdk_lib_aws_medialive_CfnInput_InputDeviceSettingsProperty, aws_cdk_lib_aws_medialive_CfnInput_InputSourceRequestProperty, aws_cdk_lib_aws_medialive_CfnInput_InputVpcRequestProperty, aws_cdk_lib_aws_medialive_CfnInput_MediaConnectFlowRequestProperty, aws_cdk_lib_aws_medialive_CfnInputSecurityGroupProps, aws_cdk_lib_aws_medialive_CfnInputSecurityGroup, aws_cdk_lib_aws_medialive_CfnInputSecurityGroup_InputWhitelistRuleCidrProperty, aws_cdk_lib_aws_mediapackage_CfnAssetProps, aws_cdk_lib_aws_mediapackage_CfnAsset, aws_cdk_lib_aws_mediapackage_CfnAsset_EgressEndpointProperty, aws_cdk_lib_aws_mediapackage_CfnChannelProps, aws_cdk_lib_aws_mediapackage_CfnChannel, aws_cdk_lib_aws_mediapackage_CfnChannel_HlsIngestProperty, aws_cdk_lib_aws_mediapackage_CfnChannel_IngestEndpointProperty, aws_cdk_lib_aws_mediapackage_CfnChannel_LogConfigurationProperty, aws_cdk_lib_aws_mediapackage_CfnOriginEndpointProps, aws_cdk_lib_aws_mediapackage_CfnOriginEndpoint, aws_cdk_lib_aws_mediapackage_CfnOriginEndpoint_AuthorizationProperty, aws_cdk_lib_aws_mediapackage_CfnOriginEndpoint_CmafEncryptionProperty, aws_cdk_lib_aws_mediapackage_CfnOriginEndpoint_CmafPackageProperty, aws_cdk_lib_aws_mediapackage_CfnOriginEndpoint_DashEncryptionProperty, aws_cdk_lib_aws_mediapackage_CfnOriginEndpoint_DashPackageProperty, aws_cdk_lib_aws_mediapackage_CfnOriginEndpoint_EncryptionContractConfigurationProperty, aws_cdk_lib_aws_mediapackage_CfnOriginEndpoint_HlsEncryptionProperty, aws_cdk_lib_aws_mediapackage_CfnOriginEndpoint_HlsManifestProperty, aws_cdk_lib_aws_mediapackage_CfnOriginEndpoint_HlsPackageProperty, aws_cdk_lib_aws_mediapackage_CfnOriginEndpoint_MssEncryptionProperty, aws_cdk_lib_aws_mediapackage_CfnOriginEndpoint_MssPackageProperty, aws_cdk_lib_aws_mediapackage_CfnOriginEndpoint_SpekeKeyProviderProperty, aws_cdk_lib_aws_mediapackage_CfnOriginEndpoint_StreamSelectionProperty, aws_cdk_lib_aws_mediapackage_CfnPackagingConfigurationProps, aws_cdk_lib_aws_mediapackage_CfnPackagingConfiguration, aws_cdk_lib_aws_mediapackage_CfnPackagingConfiguration_CmafEncryptionProperty, aws_cdk_lib_aws_mediapackage_CfnPackagingConfiguration_CmafPackageProperty, aws_cdk_lib_aws_mediapackage_CfnPackagingConfiguration_DashEncryptionProperty, aws_cdk_lib_aws_mediapackage_CfnPackagingConfiguration_DashManifestProperty, aws_cdk_lib_aws_mediapackage_CfnPackagingConfiguration_DashPackageProperty, aws_cdk_lib_aws_mediapackage_CfnPackagingConfiguration_EncryptionContractConfigurationProperty, aws_cdk_lib_aws_mediapackage_CfnPackagingConfiguration_HlsEncryptionProperty, aws_cdk_lib_aws_mediapackage_CfnPackagingConfiguration_HlsManifestProperty, aws_cdk_lib_aws_mediapackage_CfnPackagingConfiguration_HlsPackageProperty, aws_cdk_lib_aws_mediapackage_CfnPackagingConfiguration_MssEncryptionProperty, aws_cdk_lib_aws_mediapackage_CfnPackagingConfiguration_MssManifestProperty, aws_cdk_lib_aws_mediapackage_CfnPackagingConfiguration_MssPackageProperty, aws_cdk_lib_aws_mediapackage_CfnPackagingConfiguration_SpekeKeyProviderProperty, aws_cdk_lib_aws_mediapackage_CfnPackagingConfiguration_StreamSelectionProperty, aws_cdk_lib_aws_mediapackage_CfnPackagingGroupProps, aws_cdk_lib_aws_mediapackage_CfnPackagingGroup, aws_cdk_lib_aws_mediapackage_CfnPackagingGroup_AuthorizationProperty, aws_cdk_lib_aws_mediapackage_CfnPackagingGroup_LogConfigurationProperty, aws_cdk_lib_aws_mediastore_CfnContainerProps, aws_cdk_lib_aws_mediastore_CfnContainer, aws_cdk_lib_aws_mediastore_CfnContainer_CorsRuleProperty, aws_cdk_lib_aws_mediastore_CfnContainer_MetricPolicyProperty, aws_cdk_lib_aws_mediastore_CfnContainer_MetricPolicyRuleProperty, aws_cdk_lib_aws_mediatailor_CfnPlaybackConfigurationProps, aws_cdk_lib_aws_mediatailor_CfnPlaybackConfiguration, aws_cdk_lib_aws_mediatailor_CfnPlaybackConfiguration_AdMarkerPassthroughProperty, aws_cdk_lib_aws_mediatailor_CfnPlaybackConfiguration_AvailSuppressionProperty, aws_cdk_lib_aws_mediatailor_CfnPlaybackConfiguration_BumperProperty, aws_cdk_lib_aws_mediatailor_CfnPlaybackConfiguration_CdnConfigurationProperty, aws_cdk_lib_aws_mediatailor_CfnPlaybackConfiguration_DashConfigurationProperty, aws_cdk_lib_aws_mediatailor_CfnPlaybackConfiguration_HlsConfigurationProperty, aws_cdk_lib_aws_mediatailor_CfnPlaybackConfiguration_LivePreRollConfigurationProperty, aws_cdk_lib_aws_mediatailor_CfnPlaybackConfiguration_ManifestProcessingRulesProperty, aws_cdk_lib_aws_memorydb_CfnACLProps, aws_cdk_lib_aws_memorydb_CfnACL, aws_cdk_lib_aws_memorydb_CfnClusterProps, aws_cdk_lib_aws_memorydb_CfnCluster, aws_cdk_lib_aws_memorydb_CfnCluster_EndpointProperty, aws_cdk_lib_aws_memorydb_CfnParameterGroupProps, aws_cdk_lib_aws_memorydb_CfnParameterGroup, aws_cdk_lib_aws_memorydb_CfnSubnetGroupProps, aws_cdk_lib_aws_memorydb_CfnSubnetGroup, aws_cdk_lib_aws_memorydb_CfnUserProps, aws_cdk_lib_aws_memorydb_CfnUser, aws_cdk_lib_aws_memorydb_CfnUser_AuthenticationModeProperty, aws_cdk_lib_aws_msk_CfnBatchScramSecretProps, aws_cdk_lib_aws_msk_CfnBatchScramSecret, aws_cdk_lib_aws_msk_CfnClusterProps, aws_cdk_lib_aws_msk_CfnCluster, aws_cdk_lib_aws_msk_CfnCluster_BrokerLogsProperty, aws_cdk_lib_aws_msk_CfnCluster_BrokerNodeGroupInfoProperty, aws_cdk_lib_aws_msk_CfnCluster_ClientAuthenticationProperty, aws_cdk_lib_aws_msk_CfnCluster_CloudWatchLogsProperty, aws_cdk_lib_aws_msk_CfnCluster_ConfigurationInfoProperty, aws_cdk_lib_aws_msk_CfnCluster_ConnectivityInfoProperty, aws_cdk_lib_aws_msk_CfnCluster_EBSStorageInfoProperty, aws_cdk_lib_aws_msk_CfnCluster_EncryptionAtRestProperty, aws_cdk_lib_aws_msk_CfnCluster_EncryptionInTransitProperty, aws_cdk_lib_aws_msk_CfnCluster_EncryptionInfoProperty, aws_cdk_lib_aws_msk_CfnCluster_FirehoseProperty, aws_cdk_lib_aws_msk_CfnCluster_IamProperty, aws_cdk_lib_aws_msk_CfnCluster_JmxExporterProperty, aws_cdk_lib_aws_msk_CfnCluster_LoggingInfoProperty, aws_cdk_lib_aws_msk_CfnCluster_NodeExporterProperty, aws_cdk_lib_aws_msk_CfnCluster_OpenMonitoringProperty, aws_cdk_lib_aws_msk_CfnCluster_PrometheusProperty, aws_cdk_lib_aws_msk_CfnCluster_ProvisionedThroughputProperty, aws_cdk_lib_aws_msk_CfnCluster_PublicAccessProperty, aws_cdk_lib_aws_msk_CfnCluster_S3Property, aws_cdk_lib_aws_msk_CfnCluster_SaslProperty, aws_cdk_lib_aws_msk_CfnCluster_ScramProperty, aws_cdk_lib_aws_msk_CfnCluster_StorageInfoProperty, aws_cdk_lib_aws_msk_CfnCluster_TlsProperty, aws_cdk_lib_aws_msk_CfnCluster_UnauthenticatedProperty, aws_cdk_lib_aws_msk_CfnCluster_VpcConnectivityProperty, aws_cdk_lib_aws_msk_CfnCluster_VpcConnectivityClientAuthenticationProperty, aws_cdk_lib_aws_msk_CfnCluster_VpcConnectivityIamProperty, aws_cdk_lib_aws_msk_CfnCluster_VpcConnectivitySaslProperty, aws_cdk_lib_aws_msk_CfnCluster_VpcConnectivityScramProperty, aws_cdk_lib_aws_msk_CfnCluster_VpcConnectivityTlsProperty, aws_cdk_lib_aws_msk_CfnClusterPolicyProps, aws_cdk_lib_aws_msk_CfnClusterPolicy, aws_cdk_lib_aws_msk_CfnConfigurationProps, aws_cdk_lib_aws_msk_CfnConfiguration, aws_cdk_lib_aws_msk_CfnServerlessClusterProps, aws_cdk_lib_aws_msk_CfnServerlessCluster, aws_cdk_lib_aws_msk_CfnServerlessCluster_ClientAuthenticationProperty, aws_cdk_lib_aws_msk_CfnServerlessCluster_IamProperty, aws_cdk_lib_aws_msk_CfnServerlessCluster_SaslProperty, aws_cdk_lib_aws_msk_CfnServerlessCluster_VpcConfigProperty, aws_cdk_lib_aws_msk_CfnVpcConnectionProps, aws_cdk_lib_aws_msk_CfnVpcConnection, aws_cdk_lib_aws_mwaa_CfnEnvironmentProps, aws_cdk_lib_aws_mwaa_CfnEnvironment, aws_cdk_lib_aws_mwaa_CfnEnvironment_LoggingConfigurationProperty, aws_cdk_lib_aws_mwaa_CfnEnvironment_ModuleLoggingConfigurationProperty, aws_cdk_lib_aws_mwaa_CfnEnvironment_NetworkConfigurationProperty, aws_cdk_lib_aws_neptune_CfnDBClusterProps, aws_cdk_lib_aws_neptune_CfnDBCluster, aws_cdk_lib_aws_neptune_CfnDBCluster_DBClusterRoleProperty, aws_cdk_lib_aws_neptune_CfnDBClusterParameterGroupProps, aws_cdk_lib_aws_neptune_CfnDBClusterParameterGroup, aws_cdk_lib_aws_neptune_CfnDBInstanceProps, aws_cdk_lib_aws_neptune_CfnDBInstance, aws_cdk_lib_aws_neptune_CfnDBParameterGroupProps, aws_cdk_lib_aws_neptune_CfnDBParameterGroup, aws_cdk_lib_aws_neptune_CfnDBSubnetGroupProps, aws_cdk_lib_aws_neptune_CfnDBSubnetGroup, aws_cdk_lib_aws_networkfirewall_CfnFirewallProps, aws_cdk_lib_aws_networkfirewall_CfnFirewall, aws_cdk_lib_aws_networkfirewall_CfnFirewall_SubnetMappingProperty, aws_cdk_lib_aws_networkfirewall_CfnFirewallPolicyProps, aws_cdk_lib_aws_networkfirewall_CfnFirewallPolicy, aws_cdk_lib_aws_networkfirewall_CfnFirewallPolicy_ActionDefinitionProperty, aws_cdk_lib_aws_networkfirewall_CfnFirewallPolicy_CustomActionProperty, aws_cdk_lib_aws_networkfirewall_CfnFirewallPolicy_DimensionProperty, aws_cdk_lib_aws_networkfirewall_CfnFirewallPolicy_FirewallPolicyProperty, aws_cdk_lib_aws_networkfirewall_CfnFirewallPolicy_IPSetProperty, aws_cdk_lib_aws_networkfirewall_CfnFirewallPolicy_PolicyVariablesProperty, aws_cdk_lib_aws_networkfirewall_CfnFirewallPolicy_PublishMetricActionProperty, aws_cdk_lib_aws_networkfirewall_CfnFirewallPolicy_StatefulEngineOptionsProperty, aws_cdk_lib_aws_networkfirewall_CfnFirewallPolicy_StatefulRuleGroupOverrideProperty, aws_cdk_lib_aws_networkfirewall_CfnFirewallPolicy_StatefulRuleGroupReferenceProperty, aws_cdk_lib_aws_networkfirewall_CfnFirewallPolicy_StatelessRuleGroupReferenceProperty, aws_cdk_lib_aws_networkfirewall_CfnLoggingConfigurationProps, aws_cdk_lib_aws_networkfirewall_CfnLoggingConfiguration, aws_cdk_lib_aws_networkfirewall_CfnLoggingConfiguration_LogDestinationConfigProperty, aws_cdk_lib_aws_networkfirewall_CfnLoggingConfiguration_LoggingConfigurationProperty, aws_cdk_lib_aws_networkfirewall_CfnRuleGroupProps, aws_cdk_lib_aws_networkfirewall_CfnRuleGroup, aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_ActionDefinitionProperty, aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_AddressProperty, aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_CustomActionProperty, aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_DimensionProperty, aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_HeaderProperty, aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_IPSetProperty, aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_IPSetReferenceProperty, aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_MatchAttributesProperty, aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_PortRangeProperty, aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_PortSetProperty, aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_PublishMetricActionProperty, aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_ReferenceSetsProperty, aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_RuleDefinitionProperty, aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_RuleGroupProperty, aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_RuleOptionProperty, aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_RuleVariablesProperty, aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_RulesSourceProperty, aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_RulesSourceListProperty, aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_StatefulRuleProperty, aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_StatefulRuleOptionsProperty, aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_StatelessRuleProperty, aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_StatelessRulesAndCustomActionsProperty, aws_cdk_lib_aws_networkfirewall_CfnRuleGroup_TCPFlagFieldProperty, aws_cdk_lib_aws_networkmanager_CfnConnectAttachmentProps, aws_cdk_lib_aws_networkmanager_CfnConnectAttachment, aws_cdk_lib_aws_networkmanager_CfnConnectAttachment_ConnectAttachmentOptionsProperty, aws_cdk_lib_aws_networkmanager_CfnConnectAttachment_ProposedSegmentChangeProperty, aws_cdk_lib_aws_networkmanager_CfnConnectPeerProps, aws_cdk_lib_aws_networkmanager_CfnConnectPeer, aws_cdk_lib_aws_networkmanager_CfnConnectPeer_BgpOptionsProperty, aws_cdk_lib_aws_networkmanager_CfnConnectPeer_ConnectPeerBgpConfigurationProperty, aws_cdk_lib_aws_networkmanager_CfnConnectPeer_ConnectPeerConfigurationProperty, aws_cdk_lib_aws_networkmanager_CfnCoreNetworkProps, aws_cdk_lib_aws_networkmanager_CfnCoreNetwork, aws_cdk_lib_aws_networkmanager_CfnCoreNetwork_CoreNetworkEdgeProperty, aws_cdk_lib_aws_networkmanager_CfnCoreNetwork_CoreNetworkSegmentProperty, aws_cdk_lib_aws_networkmanager_CfnCustomerGatewayAssociationProps, aws_cdk_lib_aws_networkmanager_CfnCustomerGatewayAssociation, aws_cdk_lib_aws_networkmanager_CfnDeviceProps, aws_cdk_lib_aws_networkmanager_CfnDevice, aws_cdk_lib_aws_networkmanager_CfnDevice_LocationProperty, aws_cdk_lib_aws_networkmanager_CfnGlobalNetworkProps, aws_cdk_lib_aws_networkmanager_CfnGlobalNetwork, aws_cdk_lib_aws_networkmanager_CfnLinkProps, aws_cdk_lib_aws_networkmanager_CfnLink, aws_cdk_lib_aws_networkmanager_CfnLink_BandwidthProperty, aws_cdk_lib_aws_networkmanager_CfnLinkAssociationProps, aws_cdk_lib_aws_networkmanager_CfnLinkAssociation, aws_cdk_lib_aws_networkmanager_CfnSiteProps, aws_cdk_lib_aws_networkmanager_CfnSite, aws_cdk_lib_aws_networkmanager_CfnSite_LocationProperty, aws_cdk_lib_aws_networkmanager_CfnSiteToSiteVpnAttachmentProps, aws_cdk_lib_aws_networkmanager_CfnSiteToSiteVpnAttachment, aws_cdk_lib_aws_networkmanager_CfnSiteToSiteVpnAttachment_ProposedSegmentChangeProperty, aws_cdk_lib_aws_networkmanager_CfnTransitGatewayPeeringProps, aws_cdk_lib_aws_networkmanager_CfnTransitGatewayPeering, aws_cdk_lib_aws_networkmanager_CfnTransitGatewayRegistrationProps, aws_cdk_lib_aws_networkmanager_CfnTransitGatewayRegistration, aws_cdk_lib_aws_networkmanager_CfnTransitGatewayRouteTableAttachmentProps, aws_cdk_lib_aws_networkmanager_CfnTransitGatewayRouteTableAttachment, aws_cdk_lib_aws_networkmanager_CfnTransitGatewayRouteTableAttachment_ProposedSegmentChangeProperty, aws_cdk_lib_aws_networkmanager_CfnVpcAttachmentProps, aws_cdk_lib_aws_networkmanager_CfnVpcAttachment, aws_cdk_lib_aws_networkmanager_CfnVpcAttachment_ProposedSegmentChangeProperty, aws_cdk_lib_aws_networkmanager_CfnVpcAttachment_VpcOptionsProperty, aws_cdk_lib_aws_nimblestudio_CfnLaunchProfileProps, aws_cdk_lib_aws_nimblestudio_CfnLaunchProfile, aws_cdk_lib_aws_nimblestudio_CfnLaunchProfile_StreamConfigurationProperty, aws_cdk_lib_aws_nimblestudio_CfnLaunchProfile_StreamConfigurationSessionBackupProperty, aws_cdk_lib_aws_nimblestudio_CfnLaunchProfile_StreamConfigurationSessionStorageProperty, aws_cdk_lib_aws_nimblestudio_CfnLaunchProfile_StreamingSessionStorageRootProperty, aws_cdk_lib_aws_nimblestudio_CfnLaunchProfile_VolumeConfigurationProperty, aws_cdk_lib_aws_nimblestudio_CfnStreamingImageProps, aws_cdk_lib_aws_nimblestudio_CfnStreamingImage, aws_cdk_lib_aws_nimblestudio_CfnStreamingImage_StreamingImageEncryptionConfigurationProperty, aws_cdk_lib_aws_nimblestudio_CfnStudioProps, aws_cdk_lib_aws_nimblestudio_CfnStudio, aws_cdk_lib_aws_nimblestudio_CfnStudio_StudioEncryptionConfigurationProperty, aws_cdk_lib_aws_nimblestudio_CfnStudioComponentProps, aws_cdk_lib_aws_nimblestudio_CfnStudioComponent, aws_cdk_lib_aws_nimblestudio_CfnStudioComponent_ActiveDirectoryComputerAttributeProperty, aws_cdk_lib_aws_nimblestudio_CfnStudioComponent_ActiveDirectoryConfigurationProperty, aws_cdk_lib_aws_nimblestudio_CfnStudioComponent_ComputeFarmConfigurationProperty, aws_cdk_lib_aws_nimblestudio_CfnStudioComponent_LicenseServiceConfigurationProperty, aws_cdk_lib_aws_nimblestudio_CfnStudioComponent_ScriptParameterKeyValueProperty, aws_cdk_lib_aws_nimblestudio_CfnStudioComponent_SharedFileSystemConfigurationProperty, aws_cdk_lib_aws_nimblestudio_CfnStudioComponent_StudioComponentConfigurationProperty, aws_cdk_lib_aws_nimblestudio_CfnStudioComponent_StudioComponentInitializationScriptProperty, aws_cdk_lib_aws_oam_CfnLinkProps, aws_cdk_lib_aws_oam_CfnLink, aws_cdk_lib_aws_oam_CfnSinkProps, aws_cdk_lib_aws_oam_CfnSink, aws_cdk_lib_aws_omics_CfnAnnotationStoreProps, aws_cdk_lib_aws_omics_CfnAnnotationStore, aws_cdk_lib_aws_omics_CfnAnnotationStore_ReferenceItemProperty, aws_cdk_lib_aws_omics_CfnAnnotationStore_SseConfigProperty, aws_cdk_lib_aws_omics_CfnAnnotationStore_StoreOptionsProperty, aws_cdk_lib_aws_omics_CfnAnnotationStore_TsvStoreOptionsProperty, aws_cdk_lib_aws_omics_CfnReferenceStoreProps, aws_cdk_lib_aws_omics_CfnReferenceStore, aws_cdk_lib_aws_omics_CfnReferenceStore_SseConfigProperty, aws_cdk_lib_aws_omics_CfnRunGroupProps, aws_cdk_lib_aws_omics_CfnRunGroup, aws_cdk_lib_aws_omics_CfnSequenceStoreProps, aws_cdk_lib_aws_omics_CfnSequenceStore, aws_cdk_lib_aws_omics_CfnSequenceStore_SseConfigProperty, aws_cdk_lib_aws_omics_CfnVariantStoreProps, aws_cdk_lib_aws_omics_CfnVariantStore, aws_cdk_lib_aws_omics_CfnVariantStore_ReferenceItemProperty, aws_cdk_lib_aws_omics_CfnVariantStore_SseConfigProperty, aws_cdk_lib_aws_omics_CfnWorkflowProps, aws_cdk_lib_aws_omics_CfnWorkflow, aws_cdk_lib_aws_omics_CfnWorkflow_WorkflowParameterProperty, aws_cdk_lib_aws_opensearchserverless_CfnAccessPolicyProps, aws_cdk_lib_aws_opensearchserverless_CfnAccessPolicy, aws_cdk_lib_aws_opensearchserverless_CfnCollectionProps, aws_cdk_lib_aws_opensearchserverless_CfnCollection, aws_cdk_lib_aws_opensearchserverless_CfnSecurityConfigProps, aws_cdk_lib_aws_opensearchserverless_CfnSecurityConfig, aws_cdk_lib_aws_opensearchserverless_CfnSecurityConfig_SamlConfigOptionsProperty, aws_cdk_lib_aws_opensearchserverless_CfnSecurityPolicyProps, aws_cdk_lib_aws_opensearchserverless_CfnSecurityPolicy, aws_cdk_lib_aws_opensearchserverless_CfnVpcEndpointProps, aws_cdk_lib_aws_opensearchserverless_CfnVpcEndpoint, aws_cdk_lib_aws_opensearchservice_CapacityConfig, aws_cdk_lib_aws_opensearchservice_ZoneAwarenessConfig, aws_cdk_lib_aws_opensearchservice_EbsOptions, aws_cdk_lib_aws_opensearchservice_LoggingOptions, aws_cdk_lib_aws_opensearchservice_EncryptionAtRestOptions, aws_cdk_lib_aws_opensearchservice_CognitoOptions, aws_cdk_lib_aws_opensearchservice_TLSSecurityPolicy, aws_cdk_lib_aws_opensearchservice_AdvancedSecurityOptions, aws_cdk_lib_aws_opensearchservice_CustomEndpointOptions, aws_cdk_lib_aws_opensearchservice_DomainProps, aws_cdk_lib_aws_opensearchservice_IDomain, aws_cdk_lib_aws_opensearchservice_DomainAttributes, aws_cdk_lib_aws_opensearchservice_Domain, aws_cdk_lib_aws_opensearchservice_EngineVersion, aws_cdk_lib_aws_opensearchservice_CfnDomainProps, aws_cdk_lib_aws_opensearchservice_CfnDomain, aws_cdk_lib_aws_opensearchservice_CfnDomain_AdvancedSecurityOptionsInputProperty, aws_cdk_lib_aws_opensearchservice_CfnDomain_ClusterConfigProperty, aws_cdk_lib_aws_opensearchservice_CfnDomain_CognitoOptionsProperty, aws_cdk_lib_aws_opensearchservice_CfnDomain_DomainEndpointOptionsProperty, aws_cdk_lib_aws_opensearchservice_CfnDomain_EBSOptionsProperty, aws_cdk_lib_aws_opensearchservice_CfnDomain_EncryptionAtRestOptionsProperty, aws_cdk_lib_aws_opensearchservice_CfnDomain_IdpProperty, aws_cdk_lib_aws_opensearchservice_CfnDomain_LogPublishingOptionProperty, aws_cdk_lib_aws_opensearchservice_CfnDomain_MasterUserOptionsProperty, aws_cdk_lib_aws_opensearchservice_CfnDomain_NodeToNodeEncryptionOptionsProperty, aws_cdk_lib_aws_opensearchservice_CfnDomain_OffPeakWindowProperty, aws_cdk_lib_aws_opensearchservice_CfnDomain_OffPeakWindowOptionsProperty, aws_cdk_lib_aws_opensearchservice_CfnDomain_SAMLOptionsProperty, aws_cdk_lib_aws_opensearchservice_CfnDomain_ServiceSoftwareOptionsProperty, aws_cdk_lib_aws_opensearchservice_CfnDomain_SnapshotOptionsProperty, aws_cdk_lib_aws_opensearchservice_CfnDomain_SoftwareUpdateOptionsProperty, aws_cdk_lib_aws_opensearchservice_CfnDomain_VPCOptionsProperty, aws_cdk_lib_aws_opensearchservice_CfnDomain_WindowStartTimeProperty, aws_cdk_lib_aws_opensearchservice_CfnDomain_ZoneAwarenessConfigProperty, aws_cdk_lib_aws_opsworks_CfnAppProps, aws_cdk_lib_aws_opsworks_CfnApp, aws_cdk_lib_aws_opsworks_CfnApp_DataSourceProperty, aws_cdk_lib_aws_opsworks_CfnApp_EnvironmentVariableProperty, aws_cdk_lib_aws_opsworks_CfnApp_SourceProperty, aws_cdk_lib_aws_opsworks_CfnApp_SslConfigurationProperty, aws_cdk_lib_aws_opsworks_CfnElasticLoadBalancerAttachmentProps, aws_cdk_lib_aws_opsworks_CfnElasticLoadBalancerAttachment, aws_cdk_lib_aws_opsworks_CfnInstanceProps, aws_cdk_lib_aws_opsworks_CfnInstance, aws_cdk_lib_aws_opsworks_CfnInstance_BlockDeviceMappingProperty, aws_cdk_lib_aws_opsworks_CfnInstance_EbsBlockDeviceProperty, aws_cdk_lib_aws_opsworks_CfnInstance_TimeBasedAutoScalingProperty, aws_cdk_lib_aws_opsworks_CfnLayerProps, aws_cdk_lib_aws_opsworks_CfnLayer, aws_cdk_lib_aws_opsworks_CfnLayer_AutoScalingThresholdsProperty, aws_cdk_lib_aws_opsworks_CfnLayer_LifecycleEventConfigurationProperty, aws_cdk_lib_aws_opsworks_CfnLayer_LoadBasedAutoScalingProperty, aws_cdk_lib_aws_opsworks_CfnLayer_RecipesProperty, aws_cdk_lib_aws_opsworks_CfnLayer_ShutdownEventConfigurationProperty, aws_cdk_lib_aws_opsworks_CfnLayer_VolumeConfigurationProperty, aws_cdk_lib_aws_opsworks_CfnStackProps, aws_cdk_lib_aws_opsworks_CfnStack, aws_cdk_lib_aws_opsworks_CfnStack_ChefConfigurationProperty, aws_cdk_lib_aws_opsworks_CfnStack_ElasticIpProperty, aws_cdk_lib_aws_opsworks_CfnStack_RdsDbInstanceProperty, aws_cdk_lib_aws_opsworks_CfnStack_SourceProperty, aws_cdk_lib_aws_opsworks_CfnStack_StackConfigurationManagerProperty, aws_cdk_lib_aws_opsworks_CfnUserProfileProps, aws_cdk_lib_aws_opsworks_CfnUserProfile, aws_cdk_lib_aws_opsworks_CfnVolumeProps, aws_cdk_lib_aws_opsworks_CfnVolume, aws_cdk_lib_aws_opsworkscm_CfnServerProps, aws_cdk_lib_aws_opsworkscm_CfnServer, aws_cdk_lib_aws_opsworkscm_CfnServer_EngineAttributeProperty, aws_cdk_lib_aws_organizations_CfnAccountProps, aws_cdk_lib_aws_organizations_CfnAccount, aws_cdk_lib_aws_organizations_CfnOrganizationalUnitProps, aws_cdk_lib_aws_organizations_CfnOrganizationalUnit, aws_cdk_lib_aws_organizations_CfnPolicyProps, aws_cdk_lib_aws_organizations_CfnPolicy, aws_cdk_lib_aws_organizations_CfnResourcePolicyProps, aws_cdk_lib_aws_organizations_CfnResourcePolicy, aws_cdk_lib_aws_osis_CfnPipelineProps, aws_cdk_lib_aws_osis_CfnPipeline, aws_cdk_lib_aws_osis_CfnPipeline_CloudWatchLogDestinationProperty, aws_cdk_lib_aws_osis_CfnPipeline_LogPublishingOptionsProperty, aws_cdk_lib_aws_osis_CfnPipeline_VpcEndpointProperty, aws_cdk_lib_aws_osis_CfnPipeline_VpcOptionsProperty, aws_cdk_lib_aws_panorama_CfnApplicationInstanceProps, aws_cdk_lib_aws_panorama_CfnApplicationInstance, aws_cdk_lib_aws_panorama_CfnApplicationInstance_ManifestOverridesPayloadProperty, aws_cdk_lib_aws_panorama_CfnApplicationInstance_ManifestPayloadProperty, aws_cdk_lib_aws_panorama_CfnPackageProps, aws_cdk_lib_aws_panorama_CfnPackage, aws_cdk_lib_aws_panorama_CfnPackage_StorageLocationProperty, aws_cdk_lib_aws_panorama_CfnPackageVersionProps, aws_cdk_lib_aws_panorama_CfnPackageVersion, aws_cdk_lib_aws_personalize_CfnDatasetProps, aws_cdk_lib_aws_personalize_CfnDataset, aws_cdk_lib_aws_personalize_CfnDataset_DataSourceProperty, aws_cdk_lib_aws_personalize_CfnDataset_DatasetImportJobProperty, aws_cdk_lib_aws_personalize_CfnDatasetGroupProps, aws_cdk_lib_aws_personalize_CfnDatasetGroup, aws_cdk_lib_aws_personalize_CfnSchemaProps, aws_cdk_lib_aws_personalize_CfnSchema, aws_cdk_lib_aws_personalize_CfnSolutionProps, aws_cdk_lib_aws_personalize_CfnSolution, aws_cdk_lib_aws_personalize_CfnSolution_AlgorithmHyperParameterRangesProperty, aws_cdk_lib_aws_personalize_CfnSolution_AutoMLConfigProperty, aws_cdk_lib_aws_personalize_CfnSolution_CategoricalHyperParameterRangeProperty, aws_cdk_lib_aws_personalize_CfnSolution_ContinuousHyperParameterRangeProperty, aws_cdk_lib_aws_personalize_CfnSolution_HpoConfigProperty, aws_cdk_lib_aws_personalize_CfnSolution_HpoObjectiveProperty, aws_cdk_lib_aws_personalize_CfnSolution_HpoResourceConfigProperty, aws_cdk_lib_aws_personalize_CfnSolution_IntegerHyperParameterRangeProperty, aws_cdk_lib_aws_personalize_CfnSolution_SolutionConfigProperty, aws_cdk_lib_aws_pinpoint_CfnADMChannelProps, aws_cdk_lib_aws_pinpoint_CfnADMChannel, aws_cdk_lib_aws_pinpoint_CfnAPNSChannelProps, aws_cdk_lib_aws_pinpoint_CfnAPNSChannel, aws_cdk_lib_aws_pinpoint_CfnAPNSSandboxChannelProps, aws_cdk_lib_aws_pinpoint_CfnAPNSSandboxChannel, aws_cdk_lib_aws_pinpoint_CfnAPNSVoipChannelProps, aws_cdk_lib_aws_pinpoint_CfnAPNSVoipChannel, aws_cdk_lib_aws_pinpoint_CfnAPNSVoipSandboxChannelProps, aws_cdk_lib_aws_pinpoint_CfnAPNSVoipSandboxChannel, aws_cdk_lib_aws_pinpoint_CfnAppProps, aws_cdk_lib_aws_pinpoint_CfnApp, aws_cdk_lib_aws_pinpoint_CfnApplicationSettingsProps, aws_cdk_lib_aws_pinpoint_CfnApplicationSettings, aws_cdk_lib_aws_pinpoint_CfnApplicationSettings_CampaignHookProperty, aws_cdk_lib_aws_pinpoint_CfnApplicationSettings_LimitsProperty, aws_cdk_lib_aws_pinpoint_CfnApplicationSettings_QuietTimeProperty, aws_cdk_lib_aws_pinpoint_CfnBaiduChannelProps, aws_cdk_lib_aws_pinpoint_CfnBaiduChannel, aws_cdk_lib_aws_pinpoint_CfnCampaignProps, aws_cdk_lib_aws_pinpoint_CfnCampaign, aws_cdk_lib_aws_pinpoint_CfnCampaign_AttributeDimensionProperty, aws_cdk_lib_aws_pinpoint_CfnCampaign_CampaignCustomMessageProperty, aws_cdk_lib_aws_pinpoint_CfnCampaign_CampaignEmailMessageProperty, aws_cdk_lib_aws_pinpoint_CfnCampaign_CampaignEventFilterProperty, aws_cdk_lib_aws_pinpoint_CfnCampaign_CampaignHookProperty, aws_cdk_lib_aws_pinpoint_CfnCampaign_CampaignInAppMessageProperty, aws_cdk_lib_aws_pinpoint_CfnCampaign_CampaignSmsMessageProperty, aws_cdk_lib_aws_pinpoint_CfnCampaign_CustomDeliveryConfigurationProperty, aws_cdk_lib_aws_pinpoint_CfnCampaign_DefaultButtonConfigurationProperty, aws_cdk_lib_aws_pinpoint_CfnCampaign_EventDimensionsProperty, aws_cdk_lib_aws_pinpoint_CfnCampaign_InAppMessageBodyConfigProperty, aws_cdk_lib_aws_pinpoint_CfnCampaign_InAppMessageButtonProperty, aws_cdk_lib_aws_pinpoint_CfnCampaign_InAppMessageContentProperty, aws_cdk_lib_aws_pinpoint_CfnCampaign_InAppMessageHeaderConfigProperty, aws_cdk_lib_aws_pinpoint_CfnCampaign_LimitsProperty, aws_cdk_lib_aws_pinpoint_CfnCampaign_MessageProperty, aws_cdk_lib_aws_pinpoint_CfnCampaign_MessageConfigurationProperty, aws_cdk_lib_aws_pinpoint_CfnCampaign_MetricDimensionProperty, aws_cdk_lib_aws_pinpoint_CfnCampaign_OverrideButtonConfigurationProperty, aws_cdk_lib_aws_pinpoint_CfnCampaign_QuietTimeProperty, aws_cdk_lib_aws_pinpoint_CfnCampaign_ScheduleProperty, aws_cdk_lib_aws_pinpoint_CfnCampaign_SetDimensionProperty, aws_cdk_lib_aws_pinpoint_CfnCampaign_TemplateProperty, aws_cdk_lib_aws_pinpoint_CfnCampaign_TemplateConfigurationProperty, aws_cdk_lib_aws_pinpoint_CfnCampaign_WriteTreatmentResourceProperty, aws_cdk_lib_aws_pinpoint_CfnEmailChannelProps, aws_cdk_lib_aws_pinpoint_CfnEmailChannel, aws_cdk_lib_aws_pinpoint_CfnEmailTemplateProps, aws_cdk_lib_aws_pinpoint_CfnEmailTemplate, aws_cdk_lib_aws_pinpoint_CfnEventStreamProps, aws_cdk_lib_aws_pinpoint_CfnEventStream, aws_cdk_lib_aws_pinpoint_CfnGCMChannelProps, aws_cdk_lib_aws_pinpoint_CfnGCMChannel, aws_cdk_lib_aws_pinpoint_CfnInAppTemplateProps, aws_cdk_lib_aws_pinpoint_CfnInAppTemplate, aws_cdk_lib_aws_pinpoint_CfnInAppTemplate_BodyConfigProperty, aws_cdk_lib_aws_pinpoint_CfnInAppTemplate_ButtonConfigProperty, aws_cdk_lib_aws_pinpoint_CfnInAppTemplate_DefaultButtonConfigurationProperty, aws_cdk_lib_aws_pinpoint_CfnInAppTemplate_HeaderConfigProperty, aws_cdk_lib_aws_pinpoint_CfnInAppTemplate_InAppMessageContentProperty, aws_cdk_lib_aws_pinpoint_CfnInAppTemplate_OverrideButtonConfigurationProperty, aws_cdk_lib_aws_pinpoint_CfnPushTemplateProps, aws_cdk_lib_aws_pinpoint_CfnPushTemplate, aws_cdk_lib_aws_pinpoint_CfnPushTemplate_APNSPushNotificationTemplateProperty, aws_cdk_lib_aws_pinpoint_CfnPushTemplate_AndroidPushNotificationTemplateProperty, aws_cdk_lib_aws_pinpoint_CfnPushTemplate_DefaultPushNotificationTemplateProperty, aws_cdk_lib_aws_pinpoint_CfnSMSChannelProps, aws_cdk_lib_aws_pinpoint_CfnSMSChannel, aws_cdk_lib_aws_pinpoint_CfnSegmentProps, aws_cdk_lib_aws_pinpoint_CfnSegment, aws_cdk_lib_aws_pinpoint_CfnSegment_AttributeDimensionProperty, aws_cdk_lib_aws_pinpoint_CfnSegment_BehaviorProperty, aws_cdk_lib_aws_pinpoint_CfnSegment_CoordinatesProperty, aws_cdk_lib_aws_pinpoint_CfnSegment_DemographicProperty, aws_cdk_lib_aws_pinpoint_CfnSegment_GPSPointProperty, aws_cdk_lib_aws_pinpoint_CfnSegment_GroupsProperty, aws_cdk_lib_aws_pinpoint_CfnSegment_LocationProperty, aws_cdk_lib_aws_pinpoint_CfnSegment_RecencyProperty, aws_cdk_lib_aws_pinpoint_CfnSegment_SegmentDimensionsProperty, aws_cdk_lib_aws_pinpoint_CfnSegment_SegmentGroupsProperty, aws_cdk_lib_aws_pinpoint_CfnSegment_SetDimensionProperty, aws_cdk_lib_aws_pinpoint_CfnSegment_SourceSegmentsProperty, aws_cdk_lib_aws_pinpoint_CfnSmsTemplateProps, aws_cdk_lib_aws_pinpoint_CfnSmsTemplate, aws_cdk_lib_aws_pinpoint_CfnVoiceChannelProps, aws_cdk_lib_aws_pinpoint_CfnVoiceChannel, aws_cdk_lib_aws_pinpointemail_CfnConfigurationSetProps, aws_cdk_lib_aws_pinpointemail_CfnConfigurationSet, aws_cdk_lib_aws_pinpointemail_CfnConfigurationSet_DeliveryOptionsProperty, aws_cdk_lib_aws_pinpointemail_CfnConfigurationSet_ReputationOptionsProperty, aws_cdk_lib_aws_pinpointemail_CfnConfigurationSet_SendingOptionsProperty, aws_cdk_lib_aws_pinpointemail_CfnConfigurationSet_TagsProperty, aws_cdk_lib_aws_pinpointemail_CfnConfigurationSet_TrackingOptionsProperty, aws_cdk_lib_aws_pinpointemail_CfnConfigurationSetEventDestinationProps, aws_cdk_lib_aws_pinpointemail_CfnConfigurationSetEventDestination, aws_cdk_lib_aws_pinpointemail_CfnConfigurationSetEventDestination_CloudWatchDestinationProperty, aws_cdk_lib_aws_pinpointemail_CfnConfigurationSetEventDestination_DimensionConfigurationProperty, aws_cdk_lib_aws_pinpointemail_CfnConfigurationSetEventDestination_EventDestinationProperty, aws_cdk_lib_aws_pinpointemail_CfnConfigurationSetEventDestination_KinesisFirehoseDestinationProperty, aws_cdk_lib_aws_pinpointemail_CfnConfigurationSetEventDestination_PinpointDestinationProperty, aws_cdk_lib_aws_pinpointemail_CfnConfigurationSetEventDestination_SnsDestinationProperty, aws_cdk_lib_aws_pinpointemail_CfnDedicatedIpPoolProps, aws_cdk_lib_aws_pinpointemail_CfnDedicatedIpPool, aws_cdk_lib_aws_pinpointemail_CfnDedicatedIpPool_TagsProperty, aws_cdk_lib_aws_pinpointemail_CfnIdentityProps, aws_cdk_lib_aws_pinpointemail_CfnIdentity, aws_cdk_lib_aws_pinpointemail_CfnIdentity_MailFromAttributesProperty, aws_cdk_lib_aws_pinpointemail_CfnIdentity_TagsProperty, aws_cdk_lib_aws_pipes_CfnPipeProps, aws_cdk_lib_aws_pipes_CfnPipe, aws_cdk_lib_aws_pipes_CfnPipe_AwsVpcConfigurationProperty, aws_cdk_lib_aws_pipes_CfnPipe_BatchArrayPropertiesProperty, aws_cdk_lib_aws_pipes_CfnPipe_BatchContainerOverridesProperty, aws_cdk_lib_aws_pipes_CfnPipe_BatchEnvironmentVariableProperty, aws_cdk_lib_aws_pipes_CfnPipe_BatchJobDependencyProperty, aws_cdk_lib_aws_pipes_CfnPipe_BatchResourceRequirementProperty, aws_cdk_lib_aws_pipes_CfnPipe_BatchRetryStrategyProperty, aws_cdk_lib_aws_pipes_CfnPipe_CapacityProviderStrategyItemProperty, aws_cdk_lib_aws_pipes_CfnPipe_DeadLetterConfigProperty, aws_cdk_lib_aws_pipes_CfnPipe_EcsContainerOverrideProperty, aws_cdk_lib_aws_pipes_CfnPipe_EcsEnvironmentFileProperty, aws_cdk_lib_aws_pipes_CfnPipe_EcsEnvironmentVariableProperty, aws_cdk_lib_aws_pipes_CfnPipe_EcsEphemeralStorageProperty, aws_cdk_lib_aws_pipes_CfnPipe_EcsInferenceAcceleratorOverrideProperty, aws_cdk_lib_aws_pipes_CfnPipe_EcsResourceRequirementProperty, aws_cdk_lib_aws_pipes_CfnPipe_EcsTaskOverrideProperty, aws_cdk_lib_aws_pipes_CfnPipe_FilterProperty, aws_cdk_lib_aws_pipes_CfnPipe_FilterCriteriaProperty, aws_cdk_lib_aws_pipes_CfnPipe_MQBrokerAccessCredentialsProperty, aws_cdk_lib_aws_pipes_CfnPipe_MSKAccessCredentialsProperty, aws_cdk_lib_aws_pipes_CfnPipe_NetworkConfigurationProperty, aws_cdk_lib_aws_pipes_CfnPipe_PipeEnrichmentHttpParametersProperty, aws_cdk_lib_aws_pipes_CfnPipe_PipeEnrichmentParametersProperty, aws_cdk_lib_aws_pipes_CfnPipe_PipeSourceActiveMQBrokerParametersProperty, aws_cdk_lib_aws_pipes_CfnPipe_PipeSourceDynamoDBStreamParametersProperty, aws_cdk_lib_aws_pipes_CfnPipe_PipeSourceKinesisStreamParametersProperty, aws_cdk_lib_aws_pipes_CfnPipe_PipeSourceManagedStreamingKafkaParametersProperty, aws_cdk_lib_aws_pipes_CfnPipe_PipeSourceParametersProperty, aws_cdk_lib_aws_pipes_CfnPipe_PipeSourceRabbitMQBrokerParametersProperty, aws_cdk_lib_aws_pipes_CfnPipe_PipeSourceSelfManagedKafkaParametersProperty, aws_cdk_lib_aws_pipes_CfnPipe_PipeSourceSqsQueueParametersProperty, aws_cdk_lib_aws_pipes_CfnPipe_PipeTargetBatchJobParametersProperty, aws_cdk_lib_aws_pipes_CfnPipe_PipeTargetCloudWatchLogsParametersProperty, aws_cdk_lib_aws_pipes_CfnPipe_PipeTargetEcsTaskParametersProperty, aws_cdk_lib_aws_pipes_CfnPipe_PipeTargetEventBridgeEventBusParametersProperty, aws_cdk_lib_aws_pipes_CfnPipe_PipeTargetHttpParametersProperty, aws_cdk_lib_aws_pipes_CfnPipe_PipeTargetKinesisStreamParametersProperty, aws_cdk_lib_aws_pipes_CfnPipe_PipeTargetLambdaFunctionParametersProperty, aws_cdk_lib_aws_pipes_CfnPipe_PipeTargetParametersProperty, aws_cdk_lib_aws_pipes_CfnPipe_PipeTargetRedshiftDataParametersProperty, aws_cdk_lib_aws_pipes_CfnPipe_PipeTargetSageMakerPipelineParametersProperty, aws_cdk_lib_aws_pipes_CfnPipe_PipeTargetSqsQueueParametersProperty, aws_cdk_lib_aws_pipes_CfnPipe_PipeTargetStateMachineParametersProperty, aws_cdk_lib_aws_pipes_CfnPipe_PlacementConstraintProperty, aws_cdk_lib_aws_pipes_CfnPipe_PlacementStrategyProperty, aws_cdk_lib_aws_pipes_CfnPipe_SageMakerPipelineParameterProperty, aws_cdk_lib_aws_pipes_CfnPipe_SelfManagedKafkaAccessConfigurationCredentialsProperty, aws_cdk_lib_aws_pipes_CfnPipe_SelfManagedKafkaAccessConfigurationVpcProperty, aws_cdk_lib_aws_proton_CfnEnvironmentAccountConnectionProps, aws_cdk_lib_aws_proton_CfnEnvironmentAccountConnection, aws_cdk_lib_aws_proton_CfnEnvironmentTemplateProps, aws_cdk_lib_aws_proton_CfnEnvironmentTemplate, aws_cdk_lib_aws_proton_CfnServiceTemplateProps, aws_cdk_lib_aws_proton_CfnServiceTemplate, aws_cdk_lib_aws_qldb_CfnLedgerProps, aws_cdk_lib_aws_qldb_CfnLedger, aws_cdk_lib_aws_qldb_CfnStreamProps, aws_cdk_lib_aws_qldb_CfnStream, aws_cdk_lib_aws_qldb_CfnStream_KinesisConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysisProps, aws_cdk_lib_aws_quicksight_CfnAnalysis, aws_cdk_lib_aws_quicksight_CfnAnalysis_AggregationFunctionProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_AggregationSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_AnalysisDefaultsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_AnalysisDefinitionProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_AnalysisErrorProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_AnalysisSourceEntityProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_AnalysisSourceTemplateProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_AnchorDateConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ArcAxisConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ArcAxisDisplayRangeProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ArcConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ArcOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_AxisDataOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_AxisDisplayMinMaxRangeProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_AxisDisplayOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_AxisDisplayRangeProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_AxisLabelOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_AxisLabelReferenceOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_AxisLinearScaleProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_AxisLogarithmicScaleProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_AxisScaleProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_AxisTickLabelOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_BarChartAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_BarChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_BarChartFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_BarChartSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_BarChartVisualProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_BinCountOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_BinWidthOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_BodySectionConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_BodySectionContentProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_BoxPlotAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_BoxPlotChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_BoxPlotFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_BoxPlotOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_BoxPlotSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_BoxPlotStyleOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_BoxPlotVisualProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_CalculatedFieldProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_CalculatedMeasureFieldProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_CascadingControlConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_CascadingControlSourceProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_CategoricalDimensionFieldProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_CategoricalMeasureFieldProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_CategoryDrillDownFilterProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_CategoryFilterProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_CategoryFilterConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ChartAxisLabelOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ClusterMarkerProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ClusterMarkerConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ColorScaleProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ColorsConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ColumnConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ColumnHierarchyProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ColumnIdentifierProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ColumnSortProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ColumnTooltipItemProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ComboChartAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ComboChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ComboChartFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ComboChartSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ComboChartVisualProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ComparisonConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ComparisonFormatConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ComputationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ConditionalFormattingColorProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ConditionalFormattingCustomIconConditionProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ConditionalFormattingCustomIconOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ConditionalFormattingGradientColorProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ConditionalFormattingIconProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ConditionalFormattingIconDisplayConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ConditionalFormattingIconSetProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ConditionalFormattingSolidColorProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ContributionAnalysisDefaultProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_CurrencyDisplayFormatConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_CustomActionFilterOperationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_CustomActionNavigationOperationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_CustomActionSetParametersOperationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_CustomActionURLOperationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_CustomColorProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_CustomContentConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_CustomContentVisualProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_CustomFilterConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_CustomFilterListConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_CustomNarrativeOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_CustomParameterValuesProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_CustomValuesConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DataBarsOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DataColorProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DataFieldSeriesItemProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DataLabelOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DataLabelTypeProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DataPathColorProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DataPathLabelTypeProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DataPathSortProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DataPathValueProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DataSetIdentifierDeclarationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DataSetReferenceProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DateAxisOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DateDimensionFieldProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DateMeasureFieldProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DateTimeDefaultValuesProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DateTimeFormatConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DateTimeHierarchyProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DateTimeParameterProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DateTimeParameterDeclarationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DateTimePickerControlDisplayOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DateTimeValueWhenUnsetConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DecimalDefaultValuesProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DecimalParameterProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DecimalParameterDeclarationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DecimalPlacesConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DecimalValueWhenUnsetConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DefaultFreeFormLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DefaultGridLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DefaultInteractiveLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DefaultNewSheetConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DefaultPaginatedLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DefaultSectionBasedLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DestinationParameterValueConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DimensionFieldProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DonutCenterOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DonutOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DrillDownFilterProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DropDownControlDisplayOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_DynamicDefaultValueProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_EmptyVisualProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_EntityProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ExcludePeriodConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ExplicitHierarchyProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FieldBasedTooltipProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FieldLabelTypeProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FieldSeriesItemProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FieldSortProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FieldSortOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FieldTooltipItemProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FilledMapAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FilledMapConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FilledMapConditionalFormattingOptionProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FilledMapConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FilledMapFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FilledMapShapeConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FilledMapSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FilledMapVisualProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FilterProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FilterControlProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FilterDateTimePickerControlProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FilterDropDownControlProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FilterGroupProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FilterListConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FilterListControlProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FilterOperationSelectedFieldsConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FilterOperationTargetVisualsConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FilterRelativeDateTimeControlProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FilterScopeConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FilterSelectableValuesProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FilterSliderControlProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FilterTextAreaControlProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FilterTextFieldControlProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FontConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FontSizeProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FontWeightProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ForecastComputationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ForecastConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ForecastScenarioProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FormatConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FreeFormLayoutCanvasSizeOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FreeFormLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FreeFormLayoutElementProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FreeFormLayoutElementBackgroundStyleProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FreeFormLayoutElementBorderStyleProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FreeFormLayoutScreenCanvasSizeOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FreeFormSectionLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FunnelChartAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FunnelChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FunnelChartDataLabelOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FunnelChartFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FunnelChartSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_FunnelChartVisualProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_GaugeChartArcConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_GaugeChartConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_GaugeChartConditionalFormattingOptionProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_GaugeChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_GaugeChartFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_GaugeChartOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_GaugeChartPrimaryValueConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_GaugeChartVisualProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_GeospatialCoordinateBoundsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_GeospatialMapAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_GeospatialMapConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_GeospatialMapFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_GeospatialMapStyleOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_GeospatialMapVisualProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_GeospatialPointStyleOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_GeospatialWindowOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_GlobalTableBorderOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_GradientColorProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_GradientStopProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_GridLayoutCanvasSizeOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_GridLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_GridLayoutElementProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_GridLayoutScreenCanvasSizeOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_GrowthRateComputationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_HeaderFooterSectionConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_HeatMapAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_HeatMapConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_HeatMapFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_HeatMapSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_HeatMapVisualProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_HistogramAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_HistogramBinOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_HistogramConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_HistogramFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_HistogramVisualProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_InsightConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_InsightVisualProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_IntegerDefaultValuesProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_IntegerParameterProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_IntegerParameterDeclarationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_IntegerValueWhenUnsetConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ItemsLimitConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_KPIConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_KPIConditionalFormattingOptionProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_KPIConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_KPIFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_KPIOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_KPIPrimaryValueConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_KPIProgressBarConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_KPISortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_KPIVisualProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_LabelOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_LayoutProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_LayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_LegendOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_LineChartAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_LineChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_LineChartDefaultSeriesSettingsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_LineChartFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_LineChartLineStyleSettingsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_LineChartMarkerStyleSettingsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_LineChartSeriesSettingsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_LineChartSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_LineChartVisualProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_LineSeriesAxisDisplayOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ListControlDisplayOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ListControlSearchOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ListControlSelectAllOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_LoadingAnimationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_LocalNavigationConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_LongFormatTextProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_MappedDataSetParameterProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_MaximumLabelTypeProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_MaximumMinimumComputationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_MeasureFieldProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_MetricComparisonComputationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_MinimumLabelTypeProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_MissingDataConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_NegativeValueConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_NullValueFormatConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_NumberDisplayFormatConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_NumberFormatConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_NumericAxisOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_NumericEqualityDrillDownFilterProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_NumericEqualityFilterProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_NumericFormatConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_NumericRangeFilterProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_NumericRangeFilterValueProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_NumericSeparatorConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_NumericalAggregationFunctionProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_NumericalDimensionFieldProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_NumericalMeasureFieldProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PaginationConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PanelConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PanelTitleOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ParameterControlProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ParameterDateTimePickerControlProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ParameterDeclarationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ParameterDropDownControlProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ParameterListControlProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ParameterSelectableValuesProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ParameterSliderControlProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ParameterTextAreaControlProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ParameterTextFieldControlProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ParametersProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PercentVisibleRangeProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PercentageDisplayFormatConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PercentileAggregationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PeriodOverPeriodComputationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PeriodToDateComputationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PieChartAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PieChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PieChartFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PieChartSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PieChartVisualProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotFieldSortOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableCellConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableConditionalFormattingOptionProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableConditionalFormattingScopeProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableDataPathOptionProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableFieldOptionProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableFieldOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableFieldSubtotalOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTablePaginatedReportOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableSortByProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableTotalOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTableVisualProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PivotTotalOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_PredefinedHierarchyProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ProgressBarOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_RadarChartAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_RadarChartAreaStyleSettingsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_RadarChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_RadarChartFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_RadarChartSeriesSettingsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_RadarChartSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_RadarChartVisualProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_RangeEndsLabelTypeProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ReferenceLineProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ReferenceLineCustomLabelConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ReferenceLineDataConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ReferenceLineDynamicDataConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ReferenceLineLabelConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ReferenceLineStaticDataConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ReferenceLineStyleConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ReferenceLineValueLabelConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_RelativeDateTimeControlDisplayOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_RelativeDatesFilterProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ResourcePermissionProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_RollingDateConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_RowAlternateColorOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_SameSheetTargetVisualConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_SankeyDiagramAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_SankeyDiagramChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_SankeyDiagramFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_SankeyDiagramSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_SankeyDiagramVisualProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ScatterPlotCategoricallyAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ScatterPlotConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ScatterPlotFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ScatterPlotUnaggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ScatterPlotVisualProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ScrollBarOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_SecondaryValueOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_SectionAfterPageBreakProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_SectionBasedLayoutCanvasSizeOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_SectionBasedLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_SectionBasedLayoutPaperCanvasSizeOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_SectionLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_SectionPageBreakConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_SectionStyleProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_SelectedSheetsFilterScopeConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_SeriesItemProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_SetParameterValueConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ShapeConditionalFormatProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_SheetProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_SheetControlLayoutProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_SheetControlLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_SheetDefinitionProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_SheetElementConfigurationOverridesProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_SheetElementRenderingRuleProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_SheetTextBoxProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_SheetVisualScopingConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ShortFormatTextProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_SimpleClusterMarkerProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_SliderControlDisplayOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_SmallMultiplesOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_SpacingProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_StringDefaultValuesProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_StringFormatConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_StringParameterProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_StringParameterDeclarationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_StringValueWhenUnsetConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_SubtotalOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TableAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TableBorderOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TableCellConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TableCellImageSizingConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TableCellStyleProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TableConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TableConditionalFormattingOptionProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TableConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TableFieldCustomIconContentProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TableFieldCustomTextContentProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TableFieldImageConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TableFieldLinkConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TableFieldLinkContentConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TableFieldOptionProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TableFieldOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TableFieldURLConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TableFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TableInlineVisualizationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TableOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TablePaginatedReportOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TableRowConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TableSideBorderOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TableSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TableUnaggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TableVisualProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TextAreaControlDisplayOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TextConditionalFormatProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TextControlPlaceholderOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TextFieldControlDisplayOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_ThousandSeparatorOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TimeBasedForecastPropertiesProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TimeEqualityFilterProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TimeRangeDrillDownFilterProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TimeRangeFilterProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TimeRangeFilterValueProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TooltipItemProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TooltipOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TopBottomFilterProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TopBottomMoversComputationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TopBottomRankedComputationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TotalAggregationComputationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TotalOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TreeMapAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TreeMapConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TreeMapFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TreeMapSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TreeMapVisualProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_TrendArrowOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_UnaggregatedFieldProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_UniqueValuesComputationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_VisibleRangeOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_VisualProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_VisualCustomActionProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_VisualCustomActionOperationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_VisualPaletteProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_VisualSubtitleLabelOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_VisualTitleLabelOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_WaterfallChartAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_WaterfallChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_WaterfallChartFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_WaterfallChartOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_WaterfallChartSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_WaterfallVisualProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_WhatIfPointScenarioProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_WhatIfRangeScenarioProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_WordCloudAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_WordCloudChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_WordCloudFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_WordCloudOptionsProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_WordCloudSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnAnalysis_WordCloudVisualProperty, aws_cdk_lib_aws_quicksight_CfnDashboardProps, aws_cdk_lib_aws_quicksight_CfnDashboard, aws_cdk_lib_aws_quicksight_CfnDashboard_AdHocFilteringOptionProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_AggregationFunctionProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_AggregationSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_AnalysisDefaultsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_AnchorDateConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ArcAxisConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ArcAxisDisplayRangeProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ArcConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ArcOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_AxisDataOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_AxisDisplayMinMaxRangeProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_AxisDisplayOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_AxisDisplayRangeProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_AxisLabelOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_AxisLabelReferenceOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_AxisLinearScaleProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_AxisLogarithmicScaleProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_AxisScaleProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_AxisTickLabelOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_BarChartAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_BarChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_BarChartFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_BarChartSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_BarChartVisualProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_BinCountOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_BinWidthOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_BodySectionConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_BodySectionContentProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_BoxPlotAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_BoxPlotChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_BoxPlotFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_BoxPlotOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_BoxPlotSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_BoxPlotStyleOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_BoxPlotVisualProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_CalculatedFieldProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_CalculatedMeasureFieldProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_CascadingControlConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_CascadingControlSourceProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_CategoricalDimensionFieldProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_CategoricalMeasureFieldProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_CategoryDrillDownFilterProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_CategoryFilterProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_CategoryFilterConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ChartAxisLabelOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ClusterMarkerProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ClusterMarkerConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ColorScaleProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ColorsConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ColumnConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ColumnHierarchyProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ColumnIdentifierProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ColumnSortProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ColumnTooltipItemProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ComboChartAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ComboChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ComboChartFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ComboChartSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ComboChartVisualProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ComparisonConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ComparisonFormatConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ComputationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ConditionalFormattingColorProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ConditionalFormattingCustomIconConditionProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ConditionalFormattingCustomIconOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ConditionalFormattingGradientColorProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ConditionalFormattingIconProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ConditionalFormattingIconDisplayConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ConditionalFormattingIconSetProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ConditionalFormattingSolidColorProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ContributionAnalysisDefaultProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_CurrencyDisplayFormatConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_CustomActionFilterOperationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_CustomActionNavigationOperationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_CustomActionSetParametersOperationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_CustomActionURLOperationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_CustomColorProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_CustomContentConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_CustomContentVisualProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_CustomFilterConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_CustomFilterListConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_CustomNarrativeOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_CustomParameterValuesProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_CustomValuesConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DashboardErrorProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DashboardPublishOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DashboardSourceEntityProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DashboardSourceTemplateProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DashboardVersionProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DashboardVersionDefinitionProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DashboardVisualPublishOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DataBarsOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DataColorProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DataFieldSeriesItemProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DataLabelOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DataLabelTypeProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DataPathColorProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DataPathLabelTypeProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DataPathSortProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DataPathValueProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DataPointDrillUpDownOptionProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DataPointMenuLabelOptionProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DataPointTooltipOptionProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DataSetIdentifierDeclarationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DataSetReferenceProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DateAxisOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DateDimensionFieldProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DateMeasureFieldProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DateTimeDefaultValuesProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DateTimeFormatConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DateTimeHierarchyProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DateTimeParameterProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DateTimeParameterDeclarationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DateTimePickerControlDisplayOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DateTimeValueWhenUnsetConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DecimalDefaultValuesProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DecimalParameterProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DecimalParameterDeclarationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DecimalPlacesConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DecimalValueWhenUnsetConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DefaultFreeFormLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DefaultGridLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DefaultInteractiveLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DefaultNewSheetConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DefaultPaginatedLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DefaultSectionBasedLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DestinationParameterValueConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DimensionFieldProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DonutCenterOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DonutOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DrillDownFilterProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DropDownControlDisplayOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_DynamicDefaultValueProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_EmptyVisualProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_EntityProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ExcludePeriodConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ExplicitHierarchyProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ExportHiddenFieldsOptionProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ExportToCSVOptionProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ExportWithHiddenFieldsOptionProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FieldBasedTooltipProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FieldLabelTypeProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FieldSeriesItemProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FieldSortProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FieldSortOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FieldTooltipItemProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FilledMapAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FilledMapConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FilledMapConditionalFormattingOptionProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FilledMapConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FilledMapFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FilledMapShapeConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FilledMapSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FilledMapVisualProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FilterProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FilterControlProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FilterDateTimePickerControlProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FilterDropDownControlProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FilterGroupProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FilterListConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FilterListControlProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FilterOperationSelectedFieldsConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FilterOperationTargetVisualsConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FilterRelativeDateTimeControlProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FilterScopeConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FilterSelectableValuesProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FilterSliderControlProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FilterTextAreaControlProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FilterTextFieldControlProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FontConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FontSizeProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FontWeightProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ForecastComputationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ForecastConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ForecastScenarioProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FormatConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FreeFormLayoutCanvasSizeOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FreeFormLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FreeFormLayoutElementProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FreeFormLayoutElementBackgroundStyleProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FreeFormLayoutElementBorderStyleProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FreeFormLayoutScreenCanvasSizeOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FreeFormSectionLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FunnelChartAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FunnelChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FunnelChartDataLabelOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FunnelChartFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FunnelChartSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_FunnelChartVisualProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_GaugeChartArcConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_GaugeChartConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_GaugeChartConditionalFormattingOptionProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_GaugeChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_GaugeChartFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_GaugeChartOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_GaugeChartPrimaryValueConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_GaugeChartVisualProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_GeospatialCoordinateBoundsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_GeospatialMapAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_GeospatialMapConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_GeospatialMapFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_GeospatialMapStyleOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_GeospatialMapVisualProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_GeospatialPointStyleOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_GeospatialWindowOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_GlobalTableBorderOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_GradientColorProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_GradientStopProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_GridLayoutCanvasSizeOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_GridLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_GridLayoutElementProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_GridLayoutScreenCanvasSizeOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_GrowthRateComputationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_HeaderFooterSectionConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_HeatMapAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_HeatMapConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_HeatMapFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_HeatMapSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_HeatMapVisualProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_HistogramAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_HistogramBinOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_HistogramConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_HistogramFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_HistogramVisualProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_InsightConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_InsightVisualProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_IntegerDefaultValuesProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_IntegerParameterProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_IntegerParameterDeclarationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_IntegerValueWhenUnsetConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ItemsLimitConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_KPIConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_KPIConditionalFormattingOptionProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_KPIConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_KPIFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_KPIOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_KPIPrimaryValueConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_KPIProgressBarConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_KPISortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_KPIVisualProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_LabelOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_LayoutProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_LayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_LegendOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_LineChartAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_LineChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_LineChartDefaultSeriesSettingsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_LineChartFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_LineChartLineStyleSettingsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_LineChartMarkerStyleSettingsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_LineChartSeriesSettingsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_LineChartSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_LineChartVisualProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_LineSeriesAxisDisplayOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ListControlDisplayOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ListControlSearchOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ListControlSelectAllOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_LoadingAnimationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_LocalNavigationConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_LongFormatTextProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_MappedDataSetParameterProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_MaximumLabelTypeProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_MaximumMinimumComputationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_MeasureFieldProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_MetricComparisonComputationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_MinimumLabelTypeProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_MissingDataConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_NegativeValueConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_NullValueFormatConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_NumberDisplayFormatConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_NumberFormatConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_NumericAxisOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_NumericEqualityDrillDownFilterProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_NumericEqualityFilterProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_NumericFormatConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_NumericRangeFilterProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_NumericRangeFilterValueProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_NumericSeparatorConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_NumericalAggregationFunctionProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_NumericalDimensionFieldProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_NumericalMeasureFieldProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PaginationConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PanelConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PanelTitleOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ParameterControlProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ParameterDateTimePickerControlProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ParameterDeclarationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ParameterDropDownControlProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ParameterListControlProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ParameterSelectableValuesProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ParameterSliderControlProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ParameterTextAreaControlProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ParameterTextFieldControlProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ParametersProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PercentVisibleRangeProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PercentageDisplayFormatConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PercentileAggregationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PeriodOverPeriodComputationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PeriodToDateComputationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PieChartAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PieChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PieChartFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PieChartSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PieChartVisualProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PivotFieldSortOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableCellConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableConditionalFormattingOptionProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableConditionalFormattingScopeProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableDataPathOptionProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableFieldOptionProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableFieldOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableFieldSubtotalOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTablePaginatedReportOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableSortByProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableTotalOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTableVisualProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PivotTotalOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_PredefinedHierarchyProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ProgressBarOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_RadarChartAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_RadarChartAreaStyleSettingsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_RadarChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_RadarChartFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_RadarChartSeriesSettingsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_RadarChartSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_RadarChartVisualProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_RangeEndsLabelTypeProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ReferenceLineProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ReferenceLineCustomLabelConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ReferenceLineDataConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ReferenceLineDynamicDataConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ReferenceLineLabelConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ReferenceLineStaticDataConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ReferenceLineStyleConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ReferenceLineValueLabelConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_RelativeDateTimeControlDisplayOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_RelativeDatesFilterProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ResourcePermissionProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_RollingDateConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_RowAlternateColorOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SameSheetTargetVisualConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SankeyDiagramAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SankeyDiagramChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SankeyDiagramFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SankeyDiagramSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SankeyDiagramVisualProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ScatterPlotCategoricallyAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ScatterPlotConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ScatterPlotFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ScatterPlotUnaggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ScatterPlotVisualProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ScrollBarOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SecondaryValueOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SectionAfterPageBreakProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SectionBasedLayoutCanvasSizeOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SectionBasedLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SectionBasedLayoutPaperCanvasSizeOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SectionLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SectionPageBreakConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SectionStyleProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SelectedSheetsFilterScopeConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SeriesItemProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SetParameterValueConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ShapeConditionalFormatProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SheetProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SheetControlLayoutProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SheetControlLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SheetControlsOptionProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SheetDefinitionProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SheetElementConfigurationOverridesProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SheetElementRenderingRuleProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SheetLayoutElementMaximizationOptionProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SheetTextBoxProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SheetVisualScopingConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ShortFormatTextProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SimpleClusterMarkerProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SliderControlDisplayOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SmallMultiplesOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SpacingProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_StringDefaultValuesProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_StringFormatConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_StringParameterProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_StringParameterDeclarationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_StringValueWhenUnsetConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_SubtotalOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TableAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TableBorderOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TableCellConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TableCellImageSizingConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TableCellStyleProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TableConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TableConditionalFormattingOptionProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TableConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TableFieldCustomIconContentProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TableFieldCustomTextContentProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TableFieldImageConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TableFieldLinkConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TableFieldLinkContentConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TableFieldOptionProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TableFieldOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TableFieldURLConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TableFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TableInlineVisualizationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TableOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TablePaginatedReportOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TableRowConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TableSideBorderOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TableSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TableUnaggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TableVisualProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TextAreaControlDisplayOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TextConditionalFormatProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TextControlPlaceholderOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TextFieldControlDisplayOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_ThousandSeparatorOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TimeBasedForecastPropertiesProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TimeEqualityFilterProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TimeRangeDrillDownFilterProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TimeRangeFilterProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TimeRangeFilterValueProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TooltipItemProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TooltipOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TopBottomFilterProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TopBottomMoversComputationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TopBottomRankedComputationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TotalAggregationComputationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TotalOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TreeMapAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TreeMapConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TreeMapFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TreeMapSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TreeMapVisualProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_TrendArrowOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_UnaggregatedFieldProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_UniqueValuesComputationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_VisibleRangeOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_VisualProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_VisualAxisSortOptionProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_VisualCustomActionProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_VisualCustomActionOperationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_VisualMenuOptionProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_VisualPaletteProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_VisualSubtitleLabelOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_VisualTitleLabelOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_WaterfallChartAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_WaterfallChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_WaterfallChartFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_WaterfallChartOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_WaterfallChartSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_WaterfallVisualProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_WhatIfPointScenarioProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_WhatIfRangeScenarioProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_WordCloudAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_WordCloudChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_WordCloudFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_WordCloudOptionsProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_WordCloudSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDashboard_WordCloudVisualProperty, aws_cdk_lib_aws_quicksight_CfnDataSetProps, aws_cdk_lib_aws_quicksight_CfnDataSet, aws_cdk_lib_aws_quicksight_CfnDataSet_CalculatedColumnProperty, aws_cdk_lib_aws_quicksight_CfnDataSet_CastColumnTypeOperationProperty, aws_cdk_lib_aws_quicksight_CfnDataSet_ColumnDescriptionProperty, aws_cdk_lib_aws_quicksight_CfnDataSet_ColumnGroupProperty, aws_cdk_lib_aws_quicksight_CfnDataSet_ColumnLevelPermissionRuleProperty, aws_cdk_lib_aws_quicksight_CfnDataSet_ColumnTagProperty, aws_cdk_lib_aws_quicksight_CfnDataSet_CreateColumnsOperationProperty, aws_cdk_lib_aws_quicksight_CfnDataSet_CustomSqlProperty, aws_cdk_lib_aws_quicksight_CfnDataSet_DataSetUsageConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnDataSet_FieldFolderProperty, aws_cdk_lib_aws_quicksight_CfnDataSet_FilterOperationProperty, aws_cdk_lib_aws_quicksight_CfnDataSet_GeoSpatialColumnGroupProperty, aws_cdk_lib_aws_quicksight_CfnDataSet_IngestionWaitPolicyProperty, aws_cdk_lib_aws_quicksight_CfnDataSet_InputColumnProperty, aws_cdk_lib_aws_quicksight_CfnDataSet_JoinInstructionProperty, aws_cdk_lib_aws_quicksight_CfnDataSet_JoinKeyPropertiesProperty, aws_cdk_lib_aws_quicksight_CfnDataSet_LogicalTableProperty, aws_cdk_lib_aws_quicksight_CfnDataSet_LogicalTableSourceProperty, aws_cdk_lib_aws_quicksight_CfnDataSet_OutputColumnProperty, aws_cdk_lib_aws_quicksight_CfnDataSet_PhysicalTableProperty, aws_cdk_lib_aws_quicksight_CfnDataSet_ProjectOperationProperty, aws_cdk_lib_aws_quicksight_CfnDataSet_RelationalTableProperty, aws_cdk_lib_aws_quicksight_CfnDataSet_RenameColumnOperationProperty, aws_cdk_lib_aws_quicksight_CfnDataSet_ResourcePermissionProperty, aws_cdk_lib_aws_quicksight_CfnDataSet_RowLevelPermissionDataSetProperty, aws_cdk_lib_aws_quicksight_CfnDataSet_S3SourceProperty, aws_cdk_lib_aws_quicksight_CfnDataSet_TagColumnOperationProperty, aws_cdk_lib_aws_quicksight_CfnDataSet_TransformOperationProperty, aws_cdk_lib_aws_quicksight_CfnDataSet_UploadSettingsProperty, aws_cdk_lib_aws_quicksight_CfnDataSourceProps, aws_cdk_lib_aws_quicksight_CfnDataSource, aws_cdk_lib_aws_quicksight_CfnDataSource_AmazonElasticsearchParametersProperty, aws_cdk_lib_aws_quicksight_CfnDataSource_AmazonOpenSearchParametersProperty, aws_cdk_lib_aws_quicksight_CfnDataSource_AthenaParametersProperty, aws_cdk_lib_aws_quicksight_CfnDataSource_AuroraParametersProperty, aws_cdk_lib_aws_quicksight_CfnDataSource_AuroraPostgreSqlParametersProperty, aws_cdk_lib_aws_quicksight_CfnDataSource_CredentialPairProperty, aws_cdk_lib_aws_quicksight_CfnDataSource_DataSourceCredentialsProperty, aws_cdk_lib_aws_quicksight_CfnDataSource_DataSourceErrorInfoProperty, aws_cdk_lib_aws_quicksight_CfnDataSource_DataSourceParametersProperty, aws_cdk_lib_aws_quicksight_CfnDataSource_DatabricksParametersProperty, aws_cdk_lib_aws_quicksight_CfnDataSource_ManifestFileLocationProperty, aws_cdk_lib_aws_quicksight_CfnDataSource_MariaDbParametersProperty, aws_cdk_lib_aws_quicksight_CfnDataSource_MySqlParametersProperty, aws_cdk_lib_aws_quicksight_CfnDataSource_OracleParametersProperty, aws_cdk_lib_aws_quicksight_CfnDataSource_PostgreSqlParametersProperty, aws_cdk_lib_aws_quicksight_CfnDataSource_PrestoParametersProperty, aws_cdk_lib_aws_quicksight_CfnDataSource_RdsParametersProperty, aws_cdk_lib_aws_quicksight_CfnDataSource_RedshiftParametersProperty, aws_cdk_lib_aws_quicksight_CfnDataSource_ResourcePermissionProperty, aws_cdk_lib_aws_quicksight_CfnDataSource_S3ParametersProperty, aws_cdk_lib_aws_quicksight_CfnDataSource_SnowflakeParametersProperty, aws_cdk_lib_aws_quicksight_CfnDataSource_SparkParametersProperty, aws_cdk_lib_aws_quicksight_CfnDataSource_SqlServerParametersProperty, aws_cdk_lib_aws_quicksight_CfnDataSource_SslPropertiesProperty, aws_cdk_lib_aws_quicksight_CfnDataSource_TeradataParametersProperty, aws_cdk_lib_aws_quicksight_CfnDataSource_VpcConnectionPropertiesProperty, aws_cdk_lib_aws_quicksight_CfnRefreshScheduleProps, aws_cdk_lib_aws_quicksight_CfnRefreshSchedule, aws_cdk_lib_aws_quicksight_CfnRefreshSchedule_RefreshOnDayProperty, aws_cdk_lib_aws_quicksight_CfnRefreshSchedule_RefreshScheduleMapProperty, aws_cdk_lib_aws_quicksight_CfnRefreshSchedule_ScheduleFrequencyProperty, aws_cdk_lib_aws_quicksight_CfnTemplateProps, aws_cdk_lib_aws_quicksight_CfnTemplate, aws_cdk_lib_aws_quicksight_CfnTemplate_AggregationFunctionProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_AggregationSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_AnalysisDefaultsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_AnchorDateConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ArcAxisConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ArcAxisDisplayRangeProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ArcConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ArcOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_AxisDataOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_AxisDisplayMinMaxRangeProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_AxisDisplayOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_AxisDisplayRangeProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_AxisLabelOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_AxisLabelReferenceOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_AxisLinearScaleProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_AxisLogarithmicScaleProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_AxisScaleProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_AxisTickLabelOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_BarChartAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_BarChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_BarChartFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_BarChartSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_BarChartVisualProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_BinCountOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_BinWidthOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_BodySectionConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_BodySectionContentProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_BoxPlotAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_BoxPlotChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_BoxPlotFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_BoxPlotOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_BoxPlotSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_BoxPlotStyleOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_BoxPlotVisualProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_CalculatedFieldProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_CalculatedMeasureFieldProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_CascadingControlConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_CascadingControlSourceProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_CategoricalDimensionFieldProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_CategoricalMeasureFieldProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_CategoryDrillDownFilterProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_CategoryFilterProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_CategoryFilterConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ChartAxisLabelOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ClusterMarkerProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ClusterMarkerConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ColorScaleProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ColorsConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ColumnConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ColumnGroupColumnSchemaProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ColumnGroupSchemaProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ColumnHierarchyProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ColumnIdentifierProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ColumnSchemaProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ColumnSortProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ColumnTooltipItemProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ComboChartAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ComboChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ComboChartFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ComboChartSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ComboChartVisualProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ComparisonConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ComparisonFormatConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ComputationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ConditionalFormattingColorProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ConditionalFormattingCustomIconConditionProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ConditionalFormattingCustomIconOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ConditionalFormattingGradientColorProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ConditionalFormattingIconProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ConditionalFormattingIconDisplayConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ConditionalFormattingIconSetProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ConditionalFormattingSolidColorProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ContributionAnalysisDefaultProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_CurrencyDisplayFormatConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_CustomActionFilterOperationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_CustomActionNavigationOperationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_CustomActionSetParametersOperationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_CustomActionURLOperationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_CustomColorProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_CustomContentConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_CustomContentVisualProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_CustomFilterConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_CustomFilterListConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_CustomNarrativeOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_CustomParameterValuesProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_CustomValuesConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DataBarsOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DataColorProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DataFieldSeriesItemProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DataLabelOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DataLabelTypeProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DataPathColorProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DataPathLabelTypeProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DataPathSortProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DataPathValueProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DataSetConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DataSetReferenceProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DataSetSchemaProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DateAxisOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DateDimensionFieldProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DateMeasureFieldProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DateTimeDefaultValuesProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DateTimeFormatConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DateTimeHierarchyProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DateTimeParameterDeclarationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DateTimePickerControlDisplayOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DateTimeValueWhenUnsetConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DecimalDefaultValuesProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DecimalParameterDeclarationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DecimalPlacesConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DecimalValueWhenUnsetConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DefaultFreeFormLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DefaultGridLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DefaultInteractiveLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DefaultNewSheetConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DefaultPaginatedLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DefaultSectionBasedLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DestinationParameterValueConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DimensionFieldProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DonutCenterOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DonutOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DrillDownFilterProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DropDownControlDisplayOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_DynamicDefaultValueProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_EmptyVisualProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_EntityProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ExcludePeriodConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ExplicitHierarchyProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FieldBasedTooltipProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FieldLabelTypeProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FieldSeriesItemProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FieldSortProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FieldSortOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FieldTooltipItemProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FilledMapAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FilledMapConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FilledMapConditionalFormattingOptionProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FilledMapConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FilledMapFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FilledMapShapeConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FilledMapSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FilledMapVisualProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FilterProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FilterControlProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FilterDateTimePickerControlProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FilterDropDownControlProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FilterGroupProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FilterListConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FilterListControlProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FilterOperationSelectedFieldsConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FilterOperationTargetVisualsConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FilterRelativeDateTimeControlProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FilterScopeConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FilterSelectableValuesProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FilterSliderControlProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FilterTextAreaControlProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FilterTextFieldControlProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FontConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FontSizeProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FontWeightProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ForecastComputationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ForecastConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ForecastScenarioProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FormatConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FreeFormLayoutCanvasSizeOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FreeFormLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FreeFormLayoutElementProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FreeFormLayoutElementBackgroundStyleProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FreeFormLayoutElementBorderStyleProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FreeFormLayoutScreenCanvasSizeOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FreeFormSectionLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FunnelChartAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FunnelChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FunnelChartDataLabelOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FunnelChartFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FunnelChartSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_FunnelChartVisualProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_GaugeChartArcConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_GaugeChartConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_GaugeChartConditionalFormattingOptionProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_GaugeChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_GaugeChartFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_GaugeChartOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_GaugeChartPrimaryValueConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_GaugeChartVisualProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_GeospatialCoordinateBoundsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_GeospatialMapAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_GeospatialMapConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_GeospatialMapFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_GeospatialMapStyleOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_GeospatialMapVisualProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_GeospatialPointStyleOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_GeospatialWindowOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_GlobalTableBorderOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_GradientColorProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_GradientStopProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_GridLayoutCanvasSizeOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_GridLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_GridLayoutElementProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_GridLayoutScreenCanvasSizeOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_GrowthRateComputationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_HeaderFooterSectionConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_HeatMapAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_HeatMapConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_HeatMapFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_HeatMapSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_HeatMapVisualProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_HistogramAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_HistogramBinOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_HistogramConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_HistogramFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_HistogramVisualProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_InsightConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_InsightVisualProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_IntegerDefaultValuesProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_IntegerParameterDeclarationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_IntegerValueWhenUnsetConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ItemsLimitConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_KPIConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_KPIConditionalFormattingOptionProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_KPIConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_KPIFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_KPIOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_KPIPrimaryValueConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_KPIProgressBarConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_KPISortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_KPIVisualProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_LabelOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_LayoutProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_LayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_LegendOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_LineChartAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_LineChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_LineChartDefaultSeriesSettingsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_LineChartFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_LineChartLineStyleSettingsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_LineChartMarkerStyleSettingsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_LineChartSeriesSettingsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_LineChartSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_LineChartVisualProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_LineSeriesAxisDisplayOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ListControlDisplayOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ListControlSearchOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ListControlSelectAllOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_LoadingAnimationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_LocalNavigationConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_LongFormatTextProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_MappedDataSetParameterProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_MaximumLabelTypeProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_MaximumMinimumComputationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_MeasureFieldProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_MetricComparisonComputationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_MinimumLabelTypeProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_MissingDataConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_NegativeValueConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_NullValueFormatConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_NumberDisplayFormatConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_NumberFormatConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_NumericAxisOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_NumericEqualityDrillDownFilterProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_NumericEqualityFilterProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_NumericFormatConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_NumericRangeFilterProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_NumericRangeFilterValueProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_NumericSeparatorConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_NumericalAggregationFunctionProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_NumericalDimensionFieldProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_NumericalMeasureFieldProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PaginationConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PanelConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PanelTitleOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ParameterControlProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ParameterDateTimePickerControlProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ParameterDeclarationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ParameterDropDownControlProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ParameterListControlProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ParameterSelectableValuesProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ParameterSliderControlProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ParameterTextAreaControlProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ParameterTextFieldControlProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PercentVisibleRangeProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PercentageDisplayFormatConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PercentileAggregationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PeriodOverPeriodComputationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PeriodToDateComputationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PieChartAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PieChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PieChartFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PieChartSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PieChartVisualProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PivotFieldSortOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableCellConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableConditionalFormattingOptionProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableConditionalFormattingScopeProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableDataPathOptionProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableFieldOptionProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableFieldOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableFieldSubtotalOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTablePaginatedReportOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableSortByProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableTotalOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTableVisualProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PivotTotalOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_PredefinedHierarchyProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ProgressBarOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_RadarChartAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_RadarChartAreaStyleSettingsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_RadarChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_RadarChartFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_RadarChartSeriesSettingsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_RadarChartSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_RadarChartVisualProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_RangeEndsLabelTypeProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ReferenceLineProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ReferenceLineCustomLabelConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ReferenceLineDataConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ReferenceLineDynamicDataConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ReferenceLineLabelConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ReferenceLineStaticDataConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ReferenceLineStyleConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ReferenceLineValueLabelConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_RelativeDateTimeControlDisplayOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_RelativeDatesFilterProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ResourcePermissionProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_RollingDateConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_RowAlternateColorOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_SameSheetTargetVisualConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_SankeyDiagramAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_SankeyDiagramChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_SankeyDiagramFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_SankeyDiagramSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_SankeyDiagramVisualProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ScatterPlotCategoricallyAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ScatterPlotConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ScatterPlotFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ScatterPlotUnaggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ScatterPlotVisualProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ScrollBarOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_SecondaryValueOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_SectionAfterPageBreakProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_SectionBasedLayoutCanvasSizeOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_SectionBasedLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_SectionBasedLayoutPaperCanvasSizeOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_SectionLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_SectionPageBreakConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_SectionStyleProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_SelectedSheetsFilterScopeConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_SeriesItemProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_SetParameterValueConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ShapeConditionalFormatProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_SheetProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_SheetControlLayoutProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_SheetControlLayoutConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_SheetDefinitionProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_SheetElementConfigurationOverridesProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_SheetElementRenderingRuleProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_SheetTextBoxProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_SheetVisualScopingConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ShortFormatTextProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_SimpleClusterMarkerProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_SliderControlDisplayOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_SmallMultiplesOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_SpacingProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_StringDefaultValuesProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_StringFormatConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_StringParameterDeclarationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_StringValueWhenUnsetConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_SubtotalOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TableAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TableBorderOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TableCellConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TableCellImageSizingConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TableCellStyleProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TableConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TableConditionalFormattingOptionProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TableConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TableFieldCustomIconContentProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TableFieldCustomTextContentProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TableFieldImageConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TableFieldLinkConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TableFieldLinkContentConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TableFieldOptionProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TableFieldOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TableFieldURLConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TableFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TableInlineVisualizationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TableOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TablePaginatedReportOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TableRowConditionalFormattingProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TableSideBorderOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TableSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TableUnaggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TableVisualProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TemplateErrorProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TemplateSourceAnalysisProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TemplateSourceEntityProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TemplateSourceTemplateProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TemplateVersionProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TemplateVersionDefinitionProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TextAreaControlDisplayOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TextConditionalFormatProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TextControlPlaceholderOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TextFieldControlDisplayOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_ThousandSeparatorOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TimeBasedForecastPropertiesProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TimeEqualityFilterProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TimeRangeDrillDownFilterProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TimeRangeFilterProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TimeRangeFilterValueProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TooltipItemProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TooltipOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TopBottomFilterProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TopBottomMoversComputationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TopBottomRankedComputationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TotalAggregationComputationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TotalOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TreeMapAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TreeMapConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TreeMapFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TreeMapSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TreeMapVisualProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_TrendArrowOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_UnaggregatedFieldProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_UniqueValuesComputationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_VisibleRangeOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_VisualProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_VisualCustomActionProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_VisualCustomActionOperationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_VisualPaletteProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_VisualSubtitleLabelOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_VisualTitleLabelOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_WaterfallChartAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_WaterfallChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_WaterfallChartFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_WaterfallChartOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_WaterfallChartSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_WaterfallVisualProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_WhatIfPointScenarioProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_WhatIfRangeScenarioProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_WordCloudAggregatedFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_WordCloudChartConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_WordCloudFieldWellsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_WordCloudOptionsProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_WordCloudSortConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTemplate_WordCloudVisualProperty, aws_cdk_lib_aws_quicksight_CfnThemeProps, aws_cdk_lib_aws_quicksight_CfnTheme, aws_cdk_lib_aws_quicksight_CfnTheme_BorderStyleProperty, aws_cdk_lib_aws_quicksight_CfnTheme_DataColorPaletteProperty, aws_cdk_lib_aws_quicksight_CfnTheme_FontProperty, aws_cdk_lib_aws_quicksight_CfnTheme_GutterStyleProperty, aws_cdk_lib_aws_quicksight_CfnTheme_MarginStyleProperty, aws_cdk_lib_aws_quicksight_CfnTheme_ResourcePermissionProperty, aws_cdk_lib_aws_quicksight_CfnTheme_SheetStyleProperty, aws_cdk_lib_aws_quicksight_CfnTheme_ThemeConfigurationProperty, aws_cdk_lib_aws_quicksight_CfnTheme_ThemeErrorProperty, aws_cdk_lib_aws_quicksight_CfnTheme_ThemeVersionProperty, aws_cdk_lib_aws_quicksight_CfnTheme_TileLayoutStyleProperty, aws_cdk_lib_aws_quicksight_CfnTheme_TileStyleProperty, aws_cdk_lib_aws_quicksight_CfnTheme_TypographyProperty, aws_cdk_lib_aws_quicksight_CfnTheme_UIColorPaletteProperty, aws_cdk_lib_aws_quicksight_CfnVPCConnectionProps, aws_cdk_lib_aws_quicksight_CfnVPCConnection, aws_cdk_lib_aws_quicksight_CfnVPCConnection_NetworkInterfaceProperty, aws_cdk_lib_aws_ram_CfnPermissionProps, aws_cdk_lib_aws_ram_CfnPermission, aws_cdk_lib_aws_ram_CfnResourceShareProps, aws_cdk_lib_aws_ram_CfnResourceShare, aws_cdk_lib_aws_rds_IEngine, aws_cdk_lib_aws_rds_EngineVersion, aws_cdk_lib_aws_rds_InstanceUpdateBehaviour, aws_cdk_lib_aws_rds_DatabaseClusterBase, aws_cdk_lib_aws_rds_DatabaseClusterProps, aws_cdk_lib_aws_rds_DatabaseCluster, aws_cdk_lib_aws_rds_DatabaseClusterFromSnapshotProps, aws_cdk_lib_aws_rds_DatabaseClusterFromSnapshot, aws_cdk_lib_aws_rds_IDatabaseCluster, aws_cdk_lib_aws_rds_DatabaseClusterAttributes, aws_cdk_lib_aws_rds_ClusterEngineBindOptions, aws_cdk_lib_aws_rds_ClusterEngineConfig, aws_cdk_lib_aws_rds_ClusterEngineFeatures, aws_cdk_lib_aws_rds_IClusterEngine, aws_cdk_lib_aws_rds_AuroraEngineVersion, aws_cdk_lib_aws_rds_AuroraClusterEngineProps, aws_cdk_lib_aws_rds_AuroraMysqlEngineVersion, aws_cdk_lib_aws_rds_AuroraMysqlClusterEngineProps, aws_cdk_lib_aws_rds_AuroraPostgresEngineFeatures, aws_cdk_lib_aws_rds_AuroraPostgresEngineVersion, aws_cdk_lib_aws_rds_AuroraPostgresClusterEngineProps, aws_cdk_lib_aws_rds_DatabaseClusterEngine, aws_cdk_lib_aws_rds_InstanceEngineBindOptions, aws_cdk_lib_aws_rds_InstanceEngineConfig, aws_cdk_lib_aws_rds_InstanceEngineFeatures, aws_cdk_lib_aws_rds_IInstanceEngine, aws_cdk_lib_aws_rds_MariaDbEngineVersion, aws_cdk_lib_aws_rds_MariaDbInstanceEngineProps, aws_cdk_lib_aws_rds_MysqlEngineVersion, aws_cdk_lib_aws_rds_MySqlInstanceEngineProps, aws_cdk_lib_aws_rds_PostgresEngineFeatures, aws_cdk_lib_aws_rds_PostgresEngineVersion, aws_cdk_lib_aws_rds_PostgresInstanceEngineProps, aws_cdk_lib_aws_rds_OracleEngineVersion, aws_cdk_lib_aws_rds_OracleSe2InstanceEngineProps, aws_cdk_lib_aws_rds_OracleSe2CdbInstanceEngineProps, aws_cdk_lib_aws_rds_OracleEeInstanceEngineProps, aws_cdk_lib_aws_rds_OracleEeCdbInstanceEngineProps, aws_cdk_lib_aws_rds_SqlServerEngineVersion, aws_cdk_lib_aws_rds_SqlServerSeInstanceEngineProps, aws_cdk_lib_aws_rds_SqlServerExInstanceEngineProps, aws_cdk_lib_aws_rds_SqlServerWebInstanceEngineProps, aws_cdk_lib_aws_rds_SqlServerEeInstanceEngineProps, aws_cdk_lib_aws_rds_DatabaseInstanceEngine, aws_cdk_lib_aws_rds_InstanceProps, aws_cdk_lib_aws_rds_BackupProps, aws_cdk_lib_aws_rds_CredentialsBaseOptions, aws_cdk_lib_aws_rds_CredentialsFromUsernameOptions, aws_cdk_lib_aws_rds_Credentials, aws_cdk_lib_aws_rds_SnapshotCredentialsFromGeneratedPasswordOptions, aws_cdk_lib_aws_rds_SnapshotCredentials, aws_cdk_lib_aws_rds_CommonRotationUserOptions, aws_cdk_lib_aws_rds_RotationSingleUserOptions, aws_cdk_lib_aws_rds_RotationMultiUserOptions, aws_cdk_lib_aws_rds_PerformanceInsightRetention, aws_cdk_lib_aws_rds_ParameterGroupClusterBindOptions, aws_cdk_lib_aws_rds_ParameterGroupClusterConfig, aws_cdk_lib_aws_rds_ParameterGroupInstanceBindOptions, aws_cdk_lib_aws_rds_ParameterGroupInstanceConfig, aws_cdk_lib_aws_rds_IParameterGroup, aws_cdk_lib_aws_rds_ParameterGroupProps, aws_cdk_lib_aws_rds_ParameterGroup, aws_cdk_lib_aws_rds_DatabaseSecretProps, aws_cdk_lib_aws_rds_DatabaseSecret, aws_cdk_lib_aws_rds_Endpoint, aws_cdk_lib_aws_rds_IOptionGroup, aws_cdk_lib_aws_rds_OptionConfiguration, aws_cdk_lib_aws_rds_OptionGroupProps, aws_cdk_lib_aws_rds_OptionGroup, aws_cdk_lib_aws_rds_IDatabaseInstance, aws_cdk_lib_aws_rds_DatabaseInstanceAttributes, aws_cdk_lib_aws_rds_DatabaseInstanceBase, aws_cdk_lib_aws_rds_LicenseModel, aws_cdk_lib_aws_rds_ProcessorFeatures, aws_cdk_lib_aws_rds_StorageType, aws_cdk_lib_aws_rds_NetworkType, aws_cdk_lib_aws_rds_DatabaseInstanceNewProps, aws_cdk_lib_aws_rds_DatabaseInstanceSourceProps, aws_cdk_lib_aws_rds_DatabaseInstanceProps, aws_cdk_lib_aws_rds_DatabaseInstance, aws_cdk_lib_aws_rds_DatabaseInstanceFromSnapshotProps, aws_cdk_lib_aws_rds_DatabaseInstanceFromSnapshot, aws_cdk_lib_aws_rds_DatabaseInstanceReadReplicaProps, aws_cdk_lib_aws_rds_DatabaseInstanceReadReplica, aws_cdk_lib_aws_rds_SessionPinningFilter, aws_cdk_lib_aws_rds_ProxyTarget, aws_cdk_lib_aws_rds_ProxyTargetConfig, aws_cdk_lib_aws_rds_DatabaseProxyOptions, aws_cdk_lib_aws_rds_DatabaseProxyProps, aws_cdk_lib_aws_rds_DatabaseProxyAttributes, aws_cdk_lib_aws_rds_IDatabaseProxy, aws_cdk_lib_aws_rds_DatabaseProxy, aws_cdk_lib_aws_rds_IServerlessCluster, aws_cdk_lib_aws_rds_ServerlessClusterAttributes, aws_cdk_lib_aws_rds_AuroraCapacityUnit, aws_cdk_lib_aws_rds_ServerlessScalingOptions, aws_cdk_lib_aws_rds_ServerlessClusterProps, aws_cdk_lib_aws_rds_ServerlessCluster, aws_cdk_lib_aws_rds_ServerlessClusterFromSnapshotProps, aws_cdk_lib_aws_rds_ServerlessClusterFromSnapshot, aws_cdk_lib_aws_rds_ISubnetGroup, aws_cdk_lib_aws_rds_SubnetGroupProps, aws_cdk_lib_aws_rds_SubnetGroup, aws_cdk_lib_aws_rds_CfnDBClusterProps, aws_cdk_lib_aws_rds_CfnDBCluster, aws_cdk_lib_aws_rds_CfnDBCluster_DBClusterRoleProperty, aws_cdk_lib_aws_rds_CfnDBCluster_EndpointProperty, aws_cdk_lib_aws_rds_CfnDBCluster_MasterUserSecretProperty, aws_cdk_lib_aws_rds_CfnDBCluster_ReadEndpointProperty, aws_cdk_lib_aws_rds_CfnDBCluster_ScalingConfigurationProperty, aws_cdk_lib_aws_rds_CfnDBCluster_ServerlessV2ScalingConfigurationProperty, aws_cdk_lib_aws_rds_CfnDBClusterParameterGroupProps, aws_cdk_lib_aws_rds_CfnDBClusterParameterGroup, aws_cdk_lib_aws_rds_CfnDBInstanceProps, aws_cdk_lib_aws_rds_CfnDBInstance, aws_cdk_lib_aws_rds_CfnDBInstance_CertificateDetailsProperty, aws_cdk_lib_aws_rds_CfnDBInstance_DBInstanceRoleProperty, aws_cdk_lib_aws_rds_CfnDBInstance_EndpointProperty, aws_cdk_lib_aws_rds_CfnDBInstance_MasterUserSecretProperty, aws_cdk_lib_aws_rds_CfnDBInstance_ProcessorFeatureProperty, aws_cdk_lib_aws_rds_CfnDBParameterGroupProps, aws_cdk_lib_aws_rds_CfnDBParameterGroup, aws_cdk_lib_aws_rds_CfnDBProxyProps, aws_cdk_lib_aws_rds_CfnDBProxy, aws_cdk_lib_aws_rds_CfnDBProxy_AuthFormatProperty, aws_cdk_lib_aws_rds_CfnDBProxy_TagFormatProperty, aws_cdk_lib_aws_rds_CfnDBProxyEndpointProps, aws_cdk_lib_aws_rds_CfnDBProxyEndpoint, aws_cdk_lib_aws_rds_CfnDBProxyEndpoint_TagFormatProperty, aws_cdk_lib_aws_rds_CfnDBProxyTargetGroupProps, aws_cdk_lib_aws_rds_CfnDBProxyTargetGroup, aws_cdk_lib_aws_rds_CfnDBProxyTargetGroup_ConnectionPoolConfigurationInfoFormatProperty, aws_cdk_lib_aws_rds_CfnDBSecurityGroupProps, aws_cdk_lib_aws_rds_CfnDBSecurityGroup, aws_cdk_lib_aws_rds_CfnDBSecurityGroup_IngressProperty, aws_cdk_lib_aws_rds_CfnDBSecurityGroupIngressProps, aws_cdk_lib_aws_rds_CfnDBSecurityGroupIngress, aws_cdk_lib_aws_rds_CfnDBSubnetGroupProps, aws_cdk_lib_aws_rds_CfnDBSubnetGroup, aws_cdk_lib_aws_rds_CfnEventSubscriptionProps, aws_cdk_lib_aws_rds_CfnEventSubscription, aws_cdk_lib_aws_rds_CfnGlobalClusterProps, aws_cdk_lib_aws_rds_CfnGlobalCluster, aws_cdk_lib_aws_rds_CfnOptionGroupProps, aws_cdk_lib_aws_rds_CfnOptionGroup, aws_cdk_lib_aws_rds_CfnOptionGroup_OptionConfigurationProperty, aws_cdk_lib_aws_rds_CfnOptionGroup_OptionSettingProperty, aws_cdk_lib_aws_redshift_CfnClusterProps, aws_cdk_lib_aws_redshift_CfnCluster, aws_cdk_lib_aws_redshift_CfnCluster_EndpointProperty, aws_cdk_lib_aws_redshift_CfnCluster_LoggingPropertiesProperty, aws_cdk_lib_aws_redshift_CfnClusterParameterGroupProps, aws_cdk_lib_aws_redshift_CfnClusterParameterGroup, aws_cdk_lib_aws_redshift_CfnClusterParameterGroup_ParameterProperty, aws_cdk_lib_aws_redshift_CfnClusterSecurityGroupProps, aws_cdk_lib_aws_redshift_CfnClusterSecurityGroup, aws_cdk_lib_aws_redshift_CfnClusterSecurityGroupIngressProps, aws_cdk_lib_aws_redshift_CfnClusterSecurityGroupIngress, aws_cdk_lib_aws_redshift_CfnClusterSubnetGroupProps, aws_cdk_lib_aws_redshift_CfnClusterSubnetGroup, aws_cdk_lib_aws_redshift_CfnEndpointAccessProps, aws_cdk_lib_aws_redshift_CfnEndpointAccess, aws_cdk_lib_aws_redshift_CfnEndpointAccess_NetworkInterfaceProperty, aws_cdk_lib_aws_redshift_CfnEndpointAccess_VpcEndpointProperty, aws_cdk_lib_aws_redshift_CfnEndpointAccess_VpcSecurityGroupProperty, aws_cdk_lib_aws_redshift_CfnEndpointAuthorizationProps, aws_cdk_lib_aws_redshift_CfnEndpointAuthorization, aws_cdk_lib_aws_redshift_CfnEventSubscriptionProps, aws_cdk_lib_aws_redshift_CfnEventSubscription, aws_cdk_lib_aws_redshift_CfnScheduledActionProps, aws_cdk_lib_aws_redshift_CfnScheduledAction, aws_cdk_lib_aws_redshift_CfnScheduledAction_PauseClusterMessageProperty, aws_cdk_lib_aws_redshift_CfnScheduledAction_ResizeClusterMessageProperty, aws_cdk_lib_aws_redshift_CfnScheduledAction_ResumeClusterMessageProperty, aws_cdk_lib_aws_redshift_CfnScheduledAction_ScheduledActionTypeProperty, aws_cdk_lib_aws_redshiftserverless_CfnNamespaceProps, aws_cdk_lib_aws_redshiftserverless_CfnNamespace, aws_cdk_lib_aws_redshiftserverless_CfnNamespace_NamespaceProperty, aws_cdk_lib_aws_redshiftserverless_CfnWorkgroupProps, aws_cdk_lib_aws_redshiftserverless_CfnWorkgroup, aws_cdk_lib_aws_redshiftserverless_CfnWorkgroup_ConfigParameterProperty, aws_cdk_lib_aws_redshiftserverless_CfnWorkgroup_EndpointProperty, aws_cdk_lib_aws_redshiftserverless_CfnWorkgroup_NetworkInterfaceProperty, aws_cdk_lib_aws_redshiftserverless_CfnWorkgroup_VpcEndpointProperty, aws_cdk_lib_aws_redshiftserverless_CfnWorkgroup_WorkgroupProperty, aws_cdk_lib_aws_refactorspaces_CfnApplicationProps, aws_cdk_lib_aws_refactorspaces_CfnApplication, aws_cdk_lib_aws_refactorspaces_CfnApplication_ApiGatewayProxyInputProperty, aws_cdk_lib_aws_refactorspaces_CfnEnvironmentProps, aws_cdk_lib_aws_refactorspaces_CfnEnvironment, aws_cdk_lib_aws_refactorspaces_CfnRouteProps, aws_cdk_lib_aws_refactorspaces_CfnRoute, aws_cdk_lib_aws_refactorspaces_CfnRoute_DefaultRouteInputProperty, aws_cdk_lib_aws_refactorspaces_CfnRoute_UriPathRouteInputProperty, aws_cdk_lib_aws_refactorspaces_CfnServiceProps, aws_cdk_lib_aws_refactorspaces_CfnService, aws_cdk_lib_aws_refactorspaces_CfnService_LambdaEndpointInputProperty, aws_cdk_lib_aws_refactorspaces_CfnService_UrlEndpointInputProperty, aws_cdk_lib_aws_rekognition_CfnCollectionProps, aws_cdk_lib_aws_rekognition_CfnCollection, aws_cdk_lib_aws_rekognition_CfnProjectProps, aws_cdk_lib_aws_rekognition_CfnProject, aws_cdk_lib_aws_rekognition_CfnStreamProcessorProps, aws_cdk_lib_aws_rekognition_CfnStreamProcessor, aws_cdk_lib_aws_rekognition_CfnStreamProcessor_BoundingBoxProperty, aws_cdk_lib_aws_rekognition_CfnStreamProcessor_ConnectedHomeSettingsProperty, aws_cdk_lib_aws_rekognition_CfnStreamProcessor_DataSharingPreferenceProperty, aws_cdk_lib_aws_rekognition_CfnStreamProcessor_FaceSearchSettingsProperty, aws_cdk_lib_aws_rekognition_CfnStreamProcessor_KinesisDataStreamProperty, aws_cdk_lib_aws_rekognition_CfnStreamProcessor_KinesisVideoStreamProperty, aws_cdk_lib_aws_rekognition_CfnStreamProcessor_NotificationChannelProperty, aws_cdk_lib_aws_rekognition_CfnStreamProcessor_S3DestinationProperty, aws_cdk_lib_aws_resiliencehub_CfnAppProps, aws_cdk_lib_aws_resiliencehub_CfnApp, aws_cdk_lib_aws_resiliencehub_CfnApp_PhysicalResourceIdProperty, aws_cdk_lib_aws_resiliencehub_CfnApp_ResourceMappingProperty, aws_cdk_lib_aws_resiliencehub_CfnResiliencyPolicyProps, aws_cdk_lib_aws_resiliencehub_CfnResiliencyPolicy, aws_cdk_lib_aws_resiliencehub_CfnResiliencyPolicy_FailurePolicyProperty, aws_cdk_lib_aws_resourceexplorer2_CfnDefaultViewAssociationProps, aws_cdk_lib_aws_resourceexplorer2_CfnDefaultViewAssociation, aws_cdk_lib_aws_resourceexplorer2_CfnIndexProps, aws_cdk_lib_aws_resourceexplorer2_CfnIndex, aws_cdk_lib_aws_resourceexplorer2_CfnViewProps, aws_cdk_lib_aws_resourceexplorer2_CfnView, aws_cdk_lib_aws_resourceexplorer2_CfnView_FiltersProperty, aws_cdk_lib_aws_resourceexplorer2_CfnView_IncludedPropertyProperty, aws_cdk_lib_aws_resourcegroups_CfnGroupProps, aws_cdk_lib_aws_resourcegroups_CfnGroup, aws_cdk_lib_aws_resourcegroups_CfnGroup_ConfigurationItemProperty, aws_cdk_lib_aws_resourcegroups_CfnGroup_ConfigurationParameterProperty, aws_cdk_lib_aws_resourcegroups_CfnGroup_QueryProperty, aws_cdk_lib_aws_resourcegroups_CfnGroup_ResourceQueryProperty, aws_cdk_lib_aws_resourcegroups_CfnGroup_TagFilterProperty, aws_cdk_lib_aws_robomaker_CfnFleetProps, aws_cdk_lib_aws_robomaker_CfnFleet, aws_cdk_lib_aws_robomaker_CfnRobotProps, aws_cdk_lib_aws_robomaker_CfnRobot, aws_cdk_lib_aws_robomaker_CfnRobotApplicationProps, aws_cdk_lib_aws_robomaker_CfnRobotApplication, aws_cdk_lib_aws_robomaker_CfnRobotApplication_RobotSoftwareSuiteProperty, aws_cdk_lib_aws_robomaker_CfnRobotApplication_SourceConfigProperty, aws_cdk_lib_aws_robomaker_CfnRobotApplicationVersionProps, aws_cdk_lib_aws_robomaker_CfnRobotApplicationVersion, aws_cdk_lib_aws_robomaker_CfnSimulationApplicationProps, aws_cdk_lib_aws_robomaker_CfnSimulationApplication, aws_cdk_lib_aws_robomaker_CfnSimulationApplication_RenderingEngineProperty, aws_cdk_lib_aws_robomaker_CfnSimulationApplication_RobotSoftwareSuiteProperty, aws_cdk_lib_aws_robomaker_CfnSimulationApplication_SimulationSoftwareSuiteProperty, aws_cdk_lib_aws_robomaker_CfnSimulationApplication_SourceConfigProperty, aws_cdk_lib_aws_robomaker_CfnSimulationApplicationVersionProps, aws_cdk_lib_aws_robomaker_CfnSimulationApplicationVersion, aws_cdk_lib_aws_rolesanywhere_CfnCRLProps, aws_cdk_lib_aws_rolesanywhere_CfnCRL, aws_cdk_lib_aws_rolesanywhere_CfnProfileProps, aws_cdk_lib_aws_rolesanywhere_CfnProfile, aws_cdk_lib_aws_rolesanywhere_CfnTrustAnchorProps, aws_cdk_lib_aws_rolesanywhere_CfnTrustAnchor, aws_cdk_lib_aws_rolesanywhere_CfnTrustAnchor_SourceProperty, aws_cdk_lib_aws_rolesanywhere_CfnTrustAnchor_SourceDataProperty, aws_cdk_lib_aws_route53_IAliasRecordTarget, aws_cdk_lib_aws_route53_AliasRecordTargetConfig, aws_cdk_lib_aws_route53_CommonHostedZoneProps, aws_cdk_lib_aws_route53_HostedZoneProps, aws_cdk_lib_aws_route53_HostedZone, aws_cdk_lib_aws_route53_PublicHostedZoneProps, aws_cdk_lib_aws_route53_IPublicHostedZone, aws_cdk_lib_aws_route53_PublicHostedZone, aws_cdk_lib_aws_route53_ZoneDelegationOptions, aws_cdk_lib_aws_route53_PrivateHostedZoneProps, aws_cdk_lib_aws_route53_IPrivateHostedZone, aws_cdk_lib_aws_route53_PrivateHostedZone, aws_cdk_lib_aws_route53_HostedZoneProviderProps, aws_cdk_lib_aws_route53_IHostedZone, aws_cdk_lib_aws_route53_HostedZoneAttributes, aws_cdk_lib_aws_route53_PublicHostedZoneAttributes, aws_cdk_lib_aws_route53_IRecordSet, aws_cdk_lib_aws_route53_RecordType, aws_cdk_lib_aws_route53_RecordSetOptions, aws_cdk_lib_aws_route53_RecordTarget, aws_cdk_lib_aws_route53_RecordSetProps, aws_cdk_lib_aws_route53_RecordSet, aws_cdk_lib_aws_route53_ARecordProps, aws_cdk_lib_aws_route53_ARecord, aws_cdk_lib_aws_route53_AaaaRecordProps, aws_cdk_lib_aws_route53_AaaaRecord, aws_cdk_lib_aws_route53_CnameRecordProps, aws_cdk_lib_aws_route53_CnameRecord, aws_cdk_lib_aws_route53_TxtRecordProps, aws_cdk_lib_aws_route53_TxtRecord, aws_cdk_lib_aws_route53_SrvRecordValue, aws_cdk_lib_aws_route53_SrvRecordProps, aws_cdk_lib_aws_route53_SrvRecord, aws_cdk_lib_aws_route53_CaaTag, aws_cdk_lib_aws_route53_CaaRecordValue, aws_cdk_lib_aws_route53_CaaRecordProps, aws_cdk_lib_aws_route53_CaaRecord, aws_cdk_lib_aws_route53_CaaAmazonRecordProps, aws_cdk_lib_aws_route53_CaaAmazonRecord, aws_cdk_lib_aws_route53_MxRecordValue, aws_cdk_lib_aws_route53_MxRecordProps, aws_cdk_lib_aws_route53_MxRecord, aws_cdk_lib_aws_route53_NsRecordProps, aws_cdk_lib_aws_route53_NsRecord, aws_cdk_lib_aws_route53_DsRecordProps, aws_cdk_lib_aws_route53_DsRecord, aws_cdk_lib_aws_route53_ZoneDelegationRecordProps, aws_cdk_lib_aws_route53_ZoneDelegationRecord, aws_cdk_lib_aws_route53_CrossAccountZoneDelegationRecordProps, aws_cdk_lib_aws_route53_CrossAccountZoneDelegationRecord, aws_cdk_lib_aws_route53_VpcEndpointServiceDomainNameProps, aws_cdk_lib_aws_route53_VpcEndpointServiceDomainName, aws_cdk_lib_aws_route53_CfnCidrCollectionProps, aws_cdk_lib_aws_route53_CfnCidrCollection, aws_cdk_lib_aws_route53_CfnCidrCollection_LocationProperty, aws_cdk_lib_aws_route53_CfnDNSSECProps, aws_cdk_lib_aws_route53_CfnDNSSEC, aws_cdk_lib_aws_route53_CfnHealthCheckProps, aws_cdk_lib_aws_route53_CfnHealthCheck, aws_cdk_lib_aws_route53_CfnHealthCheck_AlarmIdentifierProperty, aws_cdk_lib_aws_route53_CfnHealthCheck_HealthCheckConfigProperty, aws_cdk_lib_aws_route53_CfnHealthCheck_HealthCheckTagProperty, aws_cdk_lib_aws_route53_CfnHostedZoneProps, aws_cdk_lib_aws_route53_CfnHostedZone, aws_cdk_lib_aws_route53_CfnHostedZone_HostedZoneConfigProperty, aws_cdk_lib_aws_route53_CfnHostedZone_HostedZoneTagProperty, aws_cdk_lib_aws_route53_CfnHostedZone_QueryLoggingConfigProperty, aws_cdk_lib_aws_route53_CfnHostedZone_VPCProperty, aws_cdk_lib_aws_route53_CfnKeySigningKeyProps, aws_cdk_lib_aws_route53_CfnKeySigningKey, aws_cdk_lib_aws_route53_CfnRecordSetProps, aws_cdk_lib_aws_route53_CfnRecordSet, aws_cdk_lib_aws_route53_CfnRecordSet_AliasTargetProperty, aws_cdk_lib_aws_route53_CfnRecordSet_CidrRoutingConfigProperty, aws_cdk_lib_aws_route53_CfnRecordSet_GeoLocationProperty, aws_cdk_lib_aws_route53_CfnRecordSetGroupProps, aws_cdk_lib_aws_route53_CfnRecordSetGroup, aws_cdk_lib_aws_route53_CfnRecordSetGroup_AliasTargetProperty, aws_cdk_lib_aws_route53_CfnRecordSetGroup_CidrRoutingConfigProperty, aws_cdk_lib_aws_route53_CfnRecordSetGroup_GeoLocationProperty, aws_cdk_lib_aws_route53_CfnRecordSetGroup_RecordSetProperty, aws_cdk_lib_aws_route53_patterns_HttpsRedirectProps, aws_cdk_lib_aws_route53_patterns_HttpsRedirect, aws_cdk_lib_aws_route53_targets_ApiGatewayDomain, aws_cdk_lib_aws_route53_targets_ApiGateway, aws_cdk_lib_aws_route53_targets_ApiGatewayv2DomainProperties, aws_cdk_lib_aws_route53_targets_BucketWebsiteTarget, aws_cdk_lib_aws_route53_targets_ElasticBeanstalkEnvironmentEndpointTarget, aws_cdk_lib_aws_route53_targets_ClassicLoadBalancerTarget, aws_cdk_lib_aws_route53_targets_CloudFrontTarget, aws_cdk_lib_aws_route53_targets_LoadBalancerTarget, aws_cdk_lib_aws_route53_targets_InterfaceVpcEndpointTarget, aws_cdk_lib_aws_route53_targets_UserPoolDomainTarget, aws_cdk_lib_aws_route53_targets_GlobalAcceleratorDomainTarget, aws_cdk_lib_aws_route53_targets_GlobalAcceleratorTarget, aws_cdk_lib_aws_route53_targets_Route53RecordTarget, aws_cdk_lib_aws_route53recoverycontrol_CfnClusterProps, aws_cdk_lib_aws_route53recoverycontrol_CfnCluster, aws_cdk_lib_aws_route53recoverycontrol_CfnCluster_ClusterEndpointProperty, aws_cdk_lib_aws_route53recoverycontrol_CfnControlPanelProps, aws_cdk_lib_aws_route53recoverycontrol_CfnControlPanel, aws_cdk_lib_aws_route53recoverycontrol_CfnRoutingControlProps, aws_cdk_lib_aws_route53recoverycontrol_CfnRoutingControl, aws_cdk_lib_aws_route53recoverycontrol_CfnSafetyRuleProps, aws_cdk_lib_aws_route53recoverycontrol_CfnSafetyRule, aws_cdk_lib_aws_route53recoverycontrol_CfnSafetyRule_AssertionRuleProperty, aws_cdk_lib_aws_route53recoverycontrol_CfnSafetyRule_GatingRuleProperty, aws_cdk_lib_aws_route53recoverycontrol_CfnSafetyRule_RuleConfigProperty, aws_cdk_lib_aws_route53recoveryreadiness_CfnCellProps, aws_cdk_lib_aws_route53recoveryreadiness_CfnCell, aws_cdk_lib_aws_route53recoveryreadiness_CfnReadinessCheckProps, aws_cdk_lib_aws_route53recoveryreadiness_CfnReadinessCheck, aws_cdk_lib_aws_route53recoveryreadiness_CfnRecoveryGroupProps, aws_cdk_lib_aws_route53recoveryreadiness_CfnRecoveryGroup, aws_cdk_lib_aws_route53recoveryreadiness_CfnResourceSetProps, aws_cdk_lib_aws_route53recoveryreadiness_CfnResourceSet, aws_cdk_lib_aws_route53recoveryreadiness_CfnResourceSet_DNSTargetResourceProperty, aws_cdk_lib_aws_route53recoveryreadiness_CfnResourceSet_NLBResourceProperty, aws_cdk_lib_aws_route53recoveryreadiness_CfnResourceSet_R53ResourceRecordProperty, aws_cdk_lib_aws_route53recoveryreadiness_CfnResourceSet_ResourceProperty, aws_cdk_lib_aws_route53recoveryreadiness_CfnResourceSet_TargetResourceProperty, aws_cdk_lib_aws_route53resolver_CfnFirewallDomainListProps, aws_cdk_lib_aws_route53resolver_CfnFirewallDomainList, aws_cdk_lib_aws_route53resolver_CfnFirewallRuleGroupProps, aws_cdk_lib_aws_route53resolver_CfnFirewallRuleGroup, aws_cdk_lib_aws_route53resolver_CfnFirewallRuleGroup_FirewallRuleProperty, aws_cdk_lib_aws_route53resolver_CfnFirewallRuleGroupAssociationProps, aws_cdk_lib_aws_route53resolver_CfnFirewallRuleGroupAssociation, aws_cdk_lib_aws_route53resolver_CfnResolverConfigProps, aws_cdk_lib_aws_route53resolver_CfnResolverConfig, aws_cdk_lib_aws_route53resolver_CfnResolverDNSSECConfigProps, aws_cdk_lib_aws_route53resolver_CfnResolverDNSSECConfig, aws_cdk_lib_aws_route53resolver_CfnResolverEndpointProps, aws_cdk_lib_aws_route53resolver_CfnResolverEndpoint, aws_cdk_lib_aws_route53resolver_CfnResolverEndpoint_IpAddressRequestProperty, aws_cdk_lib_aws_route53resolver_CfnResolverQueryLoggingConfigProps, aws_cdk_lib_aws_route53resolver_CfnResolverQueryLoggingConfig, aws_cdk_lib_aws_route53resolver_CfnResolverQueryLoggingConfigAssociationProps, aws_cdk_lib_aws_route53resolver_CfnResolverQueryLoggingConfigAssociation, aws_cdk_lib_aws_route53resolver_CfnResolverRuleProps, aws_cdk_lib_aws_route53resolver_CfnResolverRule, aws_cdk_lib_aws_route53resolver_CfnResolverRule_TargetAddressProperty, aws_cdk_lib_aws_route53resolver_CfnResolverRuleAssociationProps, aws_cdk_lib_aws_route53resolver_CfnResolverRuleAssociation, aws_cdk_lib_aws_rum_CfnAppMonitorProps, aws_cdk_lib_aws_rum_CfnAppMonitor, aws_cdk_lib_aws_rum_CfnAppMonitor_AppMonitorConfigurationProperty, aws_cdk_lib_aws_rum_CfnAppMonitor_CustomEventsProperty, aws_cdk_lib_aws_rum_CfnAppMonitor_MetricDefinitionProperty, aws_cdk_lib_aws_rum_CfnAppMonitor_MetricDestinationProperty, aws_cdk_lib_aws_s3_IBucket, aws_cdk_lib_aws_s3_BucketAttributes, aws_cdk_lib_aws_s3_BucketBase, aws_cdk_lib_aws_s3_BlockPublicAccessOptions, aws_cdk_lib_aws_s3_BlockPublicAccess, aws_cdk_lib_aws_s3_BucketMetrics, aws_cdk_lib_aws_s3_HttpMethods, aws_cdk_lib_aws_s3_CorsRule, aws_cdk_lib_aws_s3_RedirectProtocol, aws_cdk_lib_aws_s3_RedirectTarget, aws_cdk_lib_aws_s3_InventoryFormat, aws_cdk_lib_aws_s3_InventoryFrequency, aws_cdk_lib_aws_s3_InventoryObjectVersion, aws_cdk_lib_aws_s3_InventoryDestination, aws_cdk_lib_aws_s3_Inventory, aws_cdk_lib_aws_s3_ObjectOwnership, aws_cdk_lib_aws_s3_IntelligentTieringConfiguration, aws_cdk_lib_aws_s3_BucketProps, aws_cdk_lib_aws_s3_Tag, aws_cdk_lib_aws_s3_Bucket, aws_cdk_lib_aws_s3_BucketEncryption, aws_cdk_lib_aws_s3_EventType, aws_cdk_lib_aws_s3_NotificationKeyFilter, aws_cdk_lib_aws_s3_OnCloudTrailBucketEventOptions, aws_cdk_lib_aws_s3_BucketAccessControl, aws_cdk_lib_aws_s3_RoutingRuleCondition, aws_cdk_lib_aws_s3_ReplaceKey, aws_cdk_lib_aws_s3_RoutingRule, aws_cdk_lib_aws_s3_ObjectLockMode, aws_cdk_lib_aws_s3_ObjectLockRetention, aws_cdk_lib_aws_s3_VirtualHostedStyleUrlOptions, aws_cdk_lib_aws_s3_TransferAccelerationUrlOptions, aws_cdk_lib_aws_s3_BucketPolicyProps, aws_cdk_lib_aws_s3_BucketPolicy, aws_cdk_lib_aws_s3_IBucketNotificationDestination, aws_cdk_lib_aws_s3_BucketNotificationDestinationConfig, aws_cdk_lib_aws_s3_BucketNotificationDestinationType, aws_cdk_lib_aws_s3_Location, aws_cdk_lib_aws_s3_LifecycleRule, aws_cdk_lib_aws_s3_Transition, aws_cdk_lib_aws_s3_NoncurrentVersionTransition, aws_cdk_lib_aws_s3_StorageClass, aws_cdk_lib_aws_s3_CfnAccessPointProps, aws_cdk_lib_aws_s3_CfnAccessPoint, aws_cdk_lib_aws_s3_CfnAccessPoint_PolicyStatusProperty, aws_cdk_lib_aws_s3_CfnAccessPoint_PublicAccessBlockConfigurationProperty, aws_cdk_lib_aws_s3_CfnAccessPoint_VpcConfigurationProperty, aws_cdk_lib_aws_s3_CfnBucketProps, aws_cdk_lib_aws_s3_CfnBucket, aws_cdk_lib_aws_s3_CfnBucket_AbortIncompleteMultipartUploadProperty, aws_cdk_lib_aws_s3_CfnBucket_AccelerateConfigurationProperty, aws_cdk_lib_aws_s3_CfnBucket_AccessControlTranslationProperty, aws_cdk_lib_aws_s3_CfnBucket_AnalyticsConfigurationProperty, aws_cdk_lib_aws_s3_CfnBucket_BucketEncryptionProperty, aws_cdk_lib_aws_s3_CfnBucket_CorsConfigurationProperty, aws_cdk_lib_aws_s3_CfnBucket_CorsRuleProperty, aws_cdk_lib_aws_s3_CfnBucket_DataExportProperty, aws_cdk_lib_aws_s3_CfnBucket_DefaultRetentionProperty, aws_cdk_lib_aws_s3_CfnBucket_DeleteMarkerReplicationProperty, aws_cdk_lib_aws_s3_CfnBucket_DestinationProperty, aws_cdk_lib_aws_s3_CfnBucket_EncryptionConfigurationProperty, aws_cdk_lib_aws_s3_CfnBucket_EventBridgeConfigurationProperty, aws_cdk_lib_aws_s3_CfnBucket_FilterRuleProperty, aws_cdk_lib_aws_s3_CfnBucket_IntelligentTieringConfigurationProperty, aws_cdk_lib_aws_s3_CfnBucket_InventoryConfigurationProperty, aws_cdk_lib_aws_s3_CfnBucket_LambdaConfigurationProperty, aws_cdk_lib_aws_s3_CfnBucket_LifecycleConfigurationProperty, aws_cdk_lib_aws_s3_CfnBucket_LoggingConfigurationProperty, aws_cdk_lib_aws_s3_CfnBucket_MetricsProperty, aws_cdk_lib_aws_s3_CfnBucket_MetricsConfigurationProperty, aws_cdk_lib_aws_s3_CfnBucket_NoncurrentVersionExpirationProperty, aws_cdk_lib_aws_s3_CfnBucket_NoncurrentVersionTransitionProperty, aws_cdk_lib_aws_s3_CfnBucket_NotificationConfigurationProperty, aws_cdk_lib_aws_s3_CfnBucket_NotificationFilterProperty, aws_cdk_lib_aws_s3_CfnBucket_ObjectLockConfigurationProperty, aws_cdk_lib_aws_s3_CfnBucket_ObjectLockRuleProperty, aws_cdk_lib_aws_s3_CfnBucket_OwnershipControlsProperty, aws_cdk_lib_aws_s3_CfnBucket_OwnershipControlsRuleProperty, aws_cdk_lib_aws_s3_CfnBucket_PublicAccessBlockConfigurationProperty, aws_cdk_lib_aws_s3_CfnBucket_QueueConfigurationProperty, aws_cdk_lib_aws_s3_CfnBucket_RedirectAllRequestsToProperty, aws_cdk_lib_aws_s3_CfnBucket_RedirectRuleProperty, aws_cdk_lib_aws_s3_CfnBucket_ReplicaModificationsProperty, aws_cdk_lib_aws_s3_CfnBucket_ReplicationConfigurationProperty, aws_cdk_lib_aws_s3_CfnBucket_ReplicationDestinationProperty, aws_cdk_lib_aws_s3_CfnBucket_ReplicationRuleProperty, aws_cdk_lib_aws_s3_CfnBucket_ReplicationRuleAndOperatorProperty, aws_cdk_lib_aws_s3_CfnBucket_ReplicationRuleFilterProperty, aws_cdk_lib_aws_s3_CfnBucket_ReplicationTimeProperty, aws_cdk_lib_aws_s3_CfnBucket_ReplicationTimeValueProperty, aws_cdk_lib_aws_s3_CfnBucket_RoutingRuleProperty, aws_cdk_lib_aws_s3_CfnBucket_RoutingRuleConditionProperty, aws_cdk_lib_aws_s3_CfnBucket_RuleProperty, aws_cdk_lib_aws_s3_CfnBucket_S3KeyFilterProperty, aws_cdk_lib_aws_s3_CfnBucket_ServerSideEncryptionByDefaultProperty, aws_cdk_lib_aws_s3_CfnBucket_ServerSideEncryptionRuleProperty, aws_cdk_lib_aws_s3_CfnBucket_SourceSelectionCriteriaProperty, aws_cdk_lib_aws_s3_CfnBucket_SseKmsEncryptedObjectsProperty, aws_cdk_lib_aws_s3_CfnBucket_StorageClassAnalysisProperty, aws_cdk_lib_aws_s3_CfnBucket_TagFilterProperty, aws_cdk_lib_aws_s3_CfnBucket_TieringProperty, aws_cdk_lib_aws_s3_CfnBucket_TopicConfigurationProperty, aws_cdk_lib_aws_s3_CfnBucket_TransitionProperty, aws_cdk_lib_aws_s3_CfnBucket_VersioningConfigurationProperty, aws_cdk_lib_aws_s3_CfnBucket_WebsiteConfigurationProperty, aws_cdk_lib_aws_s3_CfnBucketPolicyProps, aws_cdk_lib_aws_s3_CfnBucketPolicy, aws_cdk_lib_aws_s3_CfnMultiRegionAccessPointProps, aws_cdk_lib_aws_s3_CfnMultiRegionAccessPoint, aws_cdk_lib_aws_s3_CfnMultiRegionAccessPoint_PublicAccessBlockConfigurationProperty, aws_cdk_lib_aws_s3_CfnMultiRegionAccessPoint_RegionProperty, aws_cdk_lib_aws_s3_CfnMultiRegionAccessPointPolicyProps, aws_cdk_lib_aws_s3_CfnMultiRegionAccessPointPolicy, aws_cdk_lib_aws_s3_CfnMultiRegionAccessPointPolicy_PolicyStatusProperty, aws_cdk_lib_aws_s3_CfnStorageLensProps, aws_cdk_lib_aws_s3_CfnStorageLens, aws_cdk_lib_aws_s3_CfnStorageLens_AccountLevelProperty, aws_cdk_lib_aws_s3_CfnStorageLens_ActivityMetricsProperty, aws_cdk_lib_aws_s3_CfnStorageLens_AdvancedCostOptimizationMetricsProperty, aws_cdk_lib_aws_s3_CfnStorageLens_AdvancedDataProtectionMetricsProperty, aws_cdk_lib_aws_s3_CfnStorageLens_AwsOrgProperty, aws_cdk_lib_aws_s3_CfnStorageLens_BucketLevelProperty, aws_cdk_lib_aws_s3_CfnStorageLens_BucketsAndRegionsProperty, aws_cdk_lib_aws_s3_CfnStorageLens_CloudWatchMetricsProperty, aws_cdk_lib_aws_s3_CfnStorageLens_DataExportProperty, aws_cdk_lib_aws_s3_CfnStorageLens_DetailedStatusCodesMetricsProperty, aws_cdk_lib_aws_s3_CfnStorageLens_EncryptionProperty, aws_cdk_lib_aws_s3_CfnStorageLens_PrefixLevelProperty, aws_cdk_lib_aws_s3_CfnStorageLens_PrefixLevelStorageMetricsProperty, aws_cdk_lib_aws_s3_CfnStorageLens_S3BucketDestinationProperty, aws_cdk_lib_aws_s3_CfnStorageLens_SSEKMSProperty, aws_cdk_lib_aws_s3_CfnStorageLens_SelectionCriteriaProperty, aws_cdk_lib_aws_s3_CfnStorageLens_StorageLensConfigurationProperty, aws_cdk_lib_aws_s3_assets_AssetOptions, aws_cdk_lib_aws_s3_assets_AssetProps, aws_cdk_lib_aws_s3_assets_Asset, aws_cdk_lib_aws_s3_deployment_BucketDeploymentProps, aws_cdk_lib_aws_s3_deployment_BucketDeployment, aws_cdk_lib_aws_s3_deployment_CacheControl, aws_cdk_lib_aws_s3_deployment_ServerSideEncryption, aws_cdk_lib_aws_s3_deployment_StorageClass, aws_cdk_lib_aws_s3_deployment_UserDefinedObjectMetadata, aws_cdk_lib_aws_s3_deployment_SourceConfig, aws_cdk_lib_aws_s3_deployment_DeploymentSourceContext, aws_cdk_lib_aws_s3_deployment_ISource, aws_cdk_lib_aws_s3_deployment_Source, aws_cdk_lib_aws_s3_notifications_SqsDestination, aws_cdk_lib_aws_s3_notifications_SnsDestination, aws_cdk_lib_aws_s3_notifications_LambdaDestination, aws_cdk_lib_aws_s3objectlambda_CfnAccessPointProps, aws_cdk_lib_aws_s3objectlambda_CfnAccessPoint, aws_cdk_lib_aws_s3objectlambda_CfnAccessPoint_AliasProperty, aws_cdk_lib_aws_s3objectlambda_CfnAccessPoint_AwsLambdaProperty, aws_cdk_lib_aws_s3objectlambda_CfnAccessPoint_ContentTransformationProperty, aws_cdk_lib_aws_s3objectlambda_CfnAccessPoint_ObjectLambdaConfigurationProperty, aws_cdk_lib_aws_s3objectlambda_CfnAccessPoint_PolicyStatusProperty, aws_cdk_lib_aws_s3objectlambda_CfnAccessPoint_PublicAccessBlockConfigurationProperty, aws_cdk_lib_aws_s3objectlambda_CfnAccessPoint_TransformationConfigurationProperty, aws_cdk_lib_aws_s3objectlambda_CfnAccessPointPolicyProps, aws_cdk_lib_aws_s3objectlambda_CfnAccessPointPolicy, aws_cdk_lib_aws_s3outposts_CfnAccessPointProps, aws_cdk_lib_aws_s3outposts_CfnAccessPoint, aws_cdk_lib_aws_s3outposts_CfnAccessPoint_VpcConfigurationProperty, aws_cdk_lib_aws_s3outposts_CfnBucketProps, aws_cdk_lib_aws_s3outposts_CfnBucket, aws_cdk_lib_aws_s3outposts_CfnBucket_AbortIncompleteMultipartUploadProperty, aws_cdk_lib_aws_s3outposts_CfnBucket_FilterProperty, aws_cdk_lib_aws_s3outposts_CfnBucket_FilterAndOperatorProperty, aws_cdk_lib_aws_s3outposts_CfnBucket_FilterTagProperty, aws_cdk_lib_aws_s3outposts_CfnBucket_LifecycleConfigurationProperty, aws_cdk_lib_aws_s3outposts_CfnBucket_RuleProperty, aws_cdk_lib_aws_s3outposts_CfnBucketPolicyProps, aws_cdk_lib_aws_s3outposts_CfnBucketPolicy, aws_cdk_lib_aws_s3outposts_CfnEndpointProps, aws_cdk_lib_aws_s3outposts_CfnEndpoint, aws_cdk_lib_aws_s3outposts_CfnEndpoint_NetworkInterfaceProperty, aws_cdk_lib_aws_sagemaker_CfnAppProps, aws_cdk_lib_aws_sagemaker_CfnApp, aws_cdk_lib_aws_sagemaker_CfnApp_ResourceSpecProperty, aws_cdk_lib_aws_sagemaker_CfnAppImageConfigProps, aws_cdk_lib_aws_sagemaker_CfnAppImageConfig, aws_cdk_lib_aws_sagemaker_CfnAppImageConfig_FileSystemConfigProperty, aws_cdk_lib_aws_sagemaker_CfnAppImageConfig_KernelGatewayImageConfigProperty, aws_cdk_lib_aws_sagemaker_CfnAppImageConfig_KernelSpecProperty, aws_cdk_lib_aws_sagemaker_CfnCodeRepositoryProps, aws_cdk_lib_aws_sagemaker_CfnCodeRepository, aws_cdk_lib_aws_sagemaker_CfnCodeRepository_GitConfigProperty, aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinitionProps, aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition, aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_BatchTransformInputProperty, aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_ClusterConfigProperty, aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_ConstraintsResourceProperty, aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_CsvProperty, aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_DataQualityAppSpecificationProperty, aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_DataQualityBaselineConfigProperty, aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_DataQualityJobInputProperty, aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_DatasetFormatProperty, aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_EndpointInputProperty, aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_JsonProperty, aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_MonitoringOutputProperty, aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_MonitoringOutputConfigProperty, aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_MonitoringResourcesProperty, aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_NetworkConfigProperty, aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_S3OutputProperty, aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_StatisticsResourceProperty, aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_StoppingConditionProperty, aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinition_VpcConfigProperty, aws_cdk_lib_aws_sagemaker_CfnDeviceProps, aws_cdk_lib_aws_sagemaker_CfnDevice, aws_cdk_lib_aws_sagemaker_CfnDevice_DeviceProperty, aws_cdk_lib_aws_sagemaker_CfnDeviceFleetProps, aws_cdk_lib_aws_sagemaker_CfnDeviceFleet, aws_cdk_lib_aws_sagemaker_CfnDeviceFleet_EdgeOutputConfigProperty, aws_cdk_lib_aws_sagemaker_CfnDomainProps, aws_cdk_lib_aws_sagemaker_CfnDomain, aws_cdk_lib_aws_sagemaker_CfnDomain_CustomImageProperty, aws_cdk_lib_aws_sagemaker_CfnDomain_DefaultSpaceSettingsProperty, aws_cdk_lib_aws_sagemaker_CfnDomain_DomainSettingsProperty, aws_cdk_lib_aws_sagemaker_CfnDomain_JupyterServerAppSettingsProperty, aws_cdk_lib_aws_sagemaker_CfnDomain_KernelGatewayAppSettingsProperty, aws_cdk_lib_aws_sagemaker_CfnDomain_RSessionAppSettingsProperty, aws_cdk_lib_aws_sagemaker_CfnDomain_RStudioServerProAppSettingsProperty, aws_cdk_lib_aws_sagemaker_CfnDomain_RStudioServerProDomainSettingsProperty, aws_cdk_lib_aws_sagemaker_CfnDomain_ResourceSpecProperty, aws_cdk_lib_aws_sagemaker_CfnDomain_SharingSettingsProperty, aws_cdk_lib_aws_sagemaker_CfnDomain_UserSettingsProperty, aws_cdk_lib_aws_sagemaker_CfnEndpointProps, aws_cdk_lib_aws_sagemaker_CfnEndpoint, aws_cdk_lib_aws_sagemaker_CfnEndpoint_AlarmProperty, aws_cdk_lib_aws_sagemaker_CfnEndpoint_AutoRollbackConfigProperty, aws_cdk_lib_aws_sagemaker_CfnEndpoint_BlueGreenUpdatePolicyProperty, aws_cdk_lib_aws_sagemaker_CfnEndpoint_CapacitySizeProperty, aws_cdk_lib_aws_sagemaker_CfnEndpoint_DeploymentConfigProperty, aws_cdk_lib_aws_sagemaker_CfnEndpoint_TrafficRoutingConfigProperty, aws_cdk_lib_aws_sagemaker_CfnEndpoint_VariantPropertyProperty, aws_cdk_lib_aws_sagemaker_CfnEndpointConfigProps, aws_cdk_lib_aws_sagemaker_CfnEndpointConfig, aws_cdk_lib_aws_sagemaker_CfnEndpointConfig_AsyncInferenceClientConfigProperty, aws_cdk_lib_aws_sagemaker_CfnEndpointConfig_AsyncInferenceConfigProperty, aws_cdk_lib_aws_sagemaker_CfnEndpointConfig_AsyncInferenceNotificationConfigProperty, aws_cdk_lib_aws_sagemaker_CfnEndpointConfig_AsyncInferenceOutputConfigProperty, aws_cdk_lib_aws_sagemaker_CfnEndpointConfig_CaptureContentTypeHeaderProperty, aws_cdk_lib_aws_sagemaker_CfnEndpointConfig_CaptureOptionProperty, aws_cdk_lib_aws_sagemaker_CfnEndpointConfig_ClarifyExplainerConfigProperty, aws_cdk_lib_aws_sagemaker_CfnEndpointConfig_ClarifyInferenceConfigProperty, aws_cdk_lib_aws_sagemaker_CfnEndpointConfig_ClarifyShapBaselineConfigProperty, aws_cdk_lib_aws_sagemaker_CfnEndpointConfig_ClarifyShapConfigProperty, aws_cdk_lib_aws_sagemaker_CfnEndpointConfig_ClarifyTextConfigProperty, aws_cdk_lib_aws_sagemaker_CfnEndpointConfig_DataCaptureConfigProperty, aws_cdk_lib_aws_sagemaker_CfnEndpointConfig_ExplainerConfigProperty, aws_cdk_lib_aws_sagemaker_CfnEndpointConfig_ProductionVariantProperty, aws_cdk_lib_aws_sagemaker_CfnEndpointConfig_ServerlessConfigProperty, aws_cdk_lib_aws_sagemaker_CfnFeatureGroupProps, aws_cdk_lib_aws_sagemaker_CfnFeatureGroup, aws_cdk_lib_aws_sagemaker_CfnFeatureGroup_DataCatalogConfigProperty, aws_cdk_lib_aws_sagemaker_CfnFeatureGroup_FeatureDefinitionProperty, aws_cdk_lib_aws_sagemaker_CfnFeatureGroup_OfflineStoreConfigProperty, aws_cdk_lib_aws_sagemaker_CfnFeatureGroup_OnlineStoreConfigProperty, aws_cdk_lib_aws_sagemaker_CfnFeatureGroup_OnlineStoreSecurityConfigProperty, aws_cdk_lib_aws_sagemaker_CfnFeatureGroup_S3StorageConfigProperty, aws_cdk_lib_aws_sagemaker_CfnImageProps, aws_cdk_lib_aws_sagemaker_CfnImage, aws_cdk_lib_aws_sagemaker_CfnImageVersionProps, aws_cdk_lib_aws_sagemaker_CfnImageVersion, aws_cdk_lib_aws_sagemaker_CfnInferenceExperimentProps, aws_cdk_lib_aws_sagemaker_CfnInferenceExperiment, aws_cdk_lib_aws_sagemaker_CfnInferenceExperiment_CaptureContentTypeHeaderProperty, aws_cdk_lib_aws_sagemaker_CfnInferenceExperiment_DataStorageConfigProperty, aws_cdk_lib_aws_sagemaker_CfnInferenceExperiment_EndpointMetadataProperty, aws_cdk_lib_aws_sagemaker_CfnInferenceExperiment_InferenceExperimentScheduleProperty, aws_cdk_lib_aws_sagemaker_CfnInferenceExperiment_ModelInfrastructureConfigProperty, aws_cdk_lib_aws_sagemaker_CfnInferenceExperiment_ModelVariantConfigProperty, aws_cdk_lib_aws_sagemaker_CfnInferenceExperiment_RealTimeInferenceConfigProperty, aws_cdk_lib_aws_sagemaker_CfnInferenceExperiment_ShadowModeConfigProperty, aws_cdk_lib_aws_sagemaker_CfnInferenceExperiment_ShadowModelVariantConfigProperty, aws_cdk_lib_aws_sagemaker_CfnModelProps, aws_cdk_lib_aws_sagemaker_CfnModel, aws_cdk_lib_aws_sagemaker_CfnModel_ContainerDefinitionProperty, aws_cdk_lib_aws_sagemaker_CfnModel_ImageConfigProperty, aws_cdk_lib_aws_sagemaker_CfnModel_InferenceExecutionConfigProperty, aws_cdk_lib_aws_sagemaker_CfnModel_MultiModelConfigProperty, aws_cdk_lib_aws_sagemaker_CfnModel_RepositoryAuthConfigProperty, aws_cdk_lib_aws_sagemaker_CfnModel_VpcConfigProperty, aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinitionProps, aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition, aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_BatchTransformInputProperty, aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_ClusterConfigProperty, aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_ConstraintsResourceProperty, aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_CsvProperty, aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_DatasetFormatProperty, aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_EndpointInputProperty, aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_JsonProperty, aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_ModelBiasAppSpecificationProperty, aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_ModelBiasBaselineConfigProperty, aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_ModelBiasJobInputProperty, aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_MonitoringGroundTruthS3InputProperty, aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_MonitoringOutputProperty, aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_MonitoringOutputConfigProperty, aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_MonitoringResourcesProperty, aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_NetworkConfigProperty, aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_S3OutputProperty, aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_StoppingConditionProperty, aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinition_VpcConfigProperty, aws_cdk_lib_aws_sagemaker_CfnModelCardProps, aws_cdk_lib_aws_sagemaker_CfnModelCard, aws_cdk_lib_aws_sagemaker_CfnModelCard_AdditionalInformationProperty, aws_cdk_lib_aws_sagemaker_CfnModelCard_BusinessDetailsProperty, aws_cdk_lib_aws_sagemaker_CfnModelCard_ContainerProperty, aws_cdk_lib_aws_sagemaker_CfnModelCard_ContentProperty, aws_cdk_lib_aws_sagemaker_CfnModelCard_EvaluationDetailProperty, aws_cdk_lib_aws_sagemaker_CfnModelCard_FunctionProperty, aws_cdk_lib_aws_sagemaker_CfnModelCard_InferenceEnvironmentProperty, aws_cdk_lib_aws_sagemaker_CfnModelCard_InferenceSpecificationProperty, aws_cdk_lib_aws_sagemaker_CfnModelCard_IntendedUsesProperty, aws_cdk_lib_aws_sagemaker_CfnModelCard_MetricDataItemsProperty, aws_cdk_lib_aws_sagemaker_CfnModelCard_MetricGroupProperty, aws_cdk_lib_aws_sagemaker_CfnModelCard_ModelOverviewProperty, aws_cdk_lib_aws_sagemaker_CfnModelCard_ModelPackageCreatorProperty, aws_cdk_lib_aws_sagemaker_CfnModelCard_ModelPackageDetailsProperty, aws_cdk_lib_aws_sagemaker_CfnModelCard_ObjectiveFunctionProperty, aws_cdk_lib_aws_sagemaker_CfnModelCard_SecurityConfigProperty, aws_cdk_lib_aws_sagemaker_CfnModelCard_SourceAlgorithmProperty, aws_cdk_lib_aws_sagemaker_CfnModelCard_TrainingDetailsProperty, aws_cdk_lib_aws_sagemaker_CfnModelCard_TrainingEnvironmentProperty, aws_cdk_lib_aws_sagemaker_CfnModelCard_TrainingHyperParameterProperty, aws_cdk_lib_aws_sagemaker_CfnModelCard_TrainingJobDetailsProperty, aws_cdk_lib_aws_sagemaker_CfnModelCard_TrainingMetricProperty, aws_cdk_lib_aws_sagemaker_CfnModelCard_UserContextProperty, aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinitionProps, aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition, aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_BatchTransformInputProperty, aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_ClusterConfigProperty, aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_ConstraintsResourceProperty, aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_CsvProperty, aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_DatasetFormatProperty, aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_EndpointInputProperty, aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_JsonProperty, aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_ModelExplainabilityAppSpecificationProperty, aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_ModelExplainabilityBaselineConfigProperty, aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_ModelExplainabilityJobInputProperty, aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_MonitoringOutputProperty, aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_MonitoringOutputConfigProperty, aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_MonitoringResourcesProperty, aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_NetworkConfigProperty, aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_S3OutputProperty, aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_StoppingConditionProperty, aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinition_VpcConfigProperty, aws_cdk_lib_aws_sagemaker_CfnModelPackageProps, aws_cdk_lib_aws_sagemaker_CfnModelPackage, aws_cdk_lib_aws_sagemaker_CfnModelPackage_AdditionalInferenceSpecificationDefinitionProperty, aws_cdk_lib_aws_sagemaker_CfnModelPackage_BiasProperty, aws_cdk_lib_aws_sagemaker_CfnModelPackage_DataSourceProperty, aws_cdk_lib_aws_sagemaker_CfnModelPackage_DriftCheckBaselinesProperty, aws_cdk_lib_aws_sagemaker_CfnModelPackage_DriftCheckBiasProperty, aws_cdk_lib_aws_sagemaker_CfnModelPackage_DriftCheckExplainabilityProperty, aws_cdk_lib_aws_sagemaker_CfnModelPackage_DriftCheckModelDataQualityProperty, aws_cdk_lib_aws_sagemaker_CfnModelPackage_DriftCheckModelQualityProperty, aws_cdk_lib_aws_sagemaker_CfnModelPackage_ExplainabilityProperty, aws_cdk_lib_aws_sagemaker_CfnModelPackage_FileSourceProperty, aws_cdk_lib_aws_sagemaker_CfnModelPackage_InferenceSpecificationProperty, aws_cdk_lib_aws_sagemaker_CfnModelPackage_MetadataPropertiesProperty, aws_cdk_lib_aws_sagemaker_CfnModelPackage_MetricsSourceProperty, aws_cdk_lib_aws_sagemaker_CfnModelPackage_ModelDataQualityProperty, aws_cdk_lib_aws_sagemaker_CfnModelPackage_ModelInputProperty, aws_cdk_lib_aws_sagemaker_CfnModelPackage_ModelMetricsProperty, aws_cdk_lib_aws_sagemaker_CfnModelPackage_ModelPackageContainerDefinitionProperty, aws_cdk_lib_aws_sagemaker_CfnModelPackage_ModelPackageStatusDetailsProperty, aws_cdk_lib_aws_sagemaker_CfnModelPackage_ModelPackageStatusItemProperty, aws_cdk_lib_aws_sagemaker_CfnModelPackage_ModelQualityProperty, aws_cdk_lib_aws_sagemaker_CfnModelPackage_S3DataSourceProperty, aws_cdk_lib_aws_sagemaker_CfnModelPackage_SourceAlgorithmProperty, aws_cdk_lib_aws_sagemaker_CfnModelPackage_SourceAlgorithmSpecificationProperty, aws_cdk_lib_aws_sagemaker_CfnModelPackage_TransformInputProperty, aws_cdk_lib_aws_sagemaker_CfnModelPackage_TransformJobDefinitionProperty, aws_cdk_lib_aws_sagemaker_CfnModelPackage_TransformOutputProperty, aws_cdk_lib_aws_sagemaker_CfnModelPackage_TransformResourcesProperty, aws_cdk_lib_aws_sagemaker_CfnModelPackage_UserContextProperty, aws_cdk_lib_aws_sagemaker_CfnModelPackage_ValidationProfileProperty, aws_cdk_lib_aws_sagemaker_CfnModelPackage_ValidationSpecificationProperty, aws_cdk_lib_aws_sagemaker_CfnModelPackageGroupProps, aws_cdk_lib_aws_sagemaker_CfnModelPackageGroup, aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinitionProps, aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition, aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_BatchTransformInputProperty, aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_ClusterConfigProperty, aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_ConstraintsResourceProperty, aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_CsvProperty, aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_DatasetFormatProperty, aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_EndpointInputProperty, aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_JsonProperty, aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_ModelQualityAppSpecificationProperty, aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_ModelQualityBaselineConfigProperty, aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_ModelQualityJobInputProperty, aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_MonitoringGroundTruthS3InputProperty, aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_MonitoringOutputProperty, aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_MonitoringOutputConfigProperty, aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_MonitoringResourcesProperty, aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_NetworkConfigProperty, aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_S3OutputProperty, aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_StoppingConditionProperty, aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinition_VpcConfigProperty, aws_cdk_lib_aws_sagemaker_CfnMonitoringScheduleProps, aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule, aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_BaselineConfigProperty, aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_BatchTransformInputProperty, aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_ClusterConfigProperty, aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_ConstraintsResourceProperty, aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_CsvProperty, aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_DatasetFormatProperty, aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_EndpointInputProperty, aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_JsonProperty, aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_MonitoringAppSpecificationProperty, aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_MonitoringExecutionSummaryProperty, aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_MonitoringInputProperty, aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_MonitoringJobDefinitionProperty, aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_MonitoringOutputProperty, aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_MonitoringOutputConfigProperty, aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_MonitoringResourcesProperty, aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_MonitoringScheduleConfigProperty, aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_NetworkConfigProperty, aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_S3OutputProperty, aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_ScheduleConfigProperty, aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_StatisticsResourceProperty, aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_StoppingConditionProperty, aws_cdk_lib_aws_sagemaker_CfnMonitoringSchedule_VpcConfigProperty, aws_cdk_lib_aws_sagemaker_CfnNotebookInstanceProps, aws_cdk_lib_aws_sagemaker_CfnNotebookInstance, aws_cdk_lib_aws_sagemaker_CfnNotebookInstance_InstanceMetadataServiceConfigurationProperty, aws_cdk_lib_aws_sagemaker_CfnNotebookInstanceLifecycleConfigProps, aws_cdk_lib_aws_sagemaker_CfnNotebookInstanceLifecycleConfig, aws_cdk_lib_aws_sagemaker_CfnNotebookInstanceLifecycleConfig_NotebookInstanceLifecycleHookProperty, aws_cdk_lib_aws_sagemaker_CfnPipelineProps, aws_cdk_lib_aws_sagemaker_CfnPipeline, aws_cdk_lib_aws_sagemaker_CfnPipeline_ParallelismConfigurationProperty, aws_cdk_lib_aws_sagemaker_CfnPipeline_PipelineDefinitionProperty, aws_cdk_lib_aws_sagemaker_CfnPipeline_S3LocationProperty, aws_cdk_lib_aws_sagemaker_CfnProjectProps, aws_cdk_lib_aws_sagemaker_CfnProject, aws_cdk_lib_aws_sagemaker_CfnProject_ProvisioningParameterProperty, aws_cdk_lib_aws_sagemaker_CfnProject_ServiceCatalogProvisionedProductDetailsProperty, aws_cdk_lib_aws_sagemaker_CfnProject_ServiceCatalogProvisioningDetailsProperty, aws_cdk_lib_aws_sagemaker_CfnSpaceProps, aws_cdk_lib_aws_sagemaker_CfnSpace, aws_cdk_lib_aws_sagemaker_CfnSpace_CustomImageProperty, aws_cdk_lib_aws_sagemaker_CfnSpace_JupyterServerAppSettingsProperty, aws_cdk_lib_aws_sagemaker_CfnSpace_KernelGatewayAppSettingsProperty, aws_cdk_lib_aws_sagemaker_CfnSpace_ResourceSpecProperty, aws_cdk_lib_aws_sagemaker_CfnSpace_SpaceSettingsProperty, aws_cdk_lib_aws_sagemaker_CfnUserProfileProps, aws_cdk_lib_aws_sagemaker_CfnUserProfile, aws_cdk_lib_aws_sagemaker_CfnUserProfile_CustomImageProperty, aws_cdk_lib_aws_sagemaker_CfnUserProfile_JupyterServerAppSettingsProperty, aws_cdk_lib_aws_sagemaker_CfnUserProfile_KernelGatewayAppSettingsProperty, aws_cdk_lib_aws_sagemaker_CfnUserProfile_RStudioServerProAppSettingsProperty, aws_cdk_lib_aws_sagemaker_CfnUserProfile_ResourceSpecProperty, aws_cdk_lib_aws_sagemaker_CfnUserProfile_SharingSettingsProperty, aws_cdk_lib_aws_sagemaker_CfnUserProfile_UserSettingsProperty, aws_cdk_lib_aws_sagemaker_CfnWorkteamProps, aws_cdk_lib_aws_sagemaker_CfnWorkteam, aws_cdk_lib_aws_sagemaker_CfnWorkteam_CognitoMemberDefinitionProperty, aws_cdk_lib_aws_sagemaker_CfnWorkteam_MemberDefinitionProperty, aws_cdk_lib_aws_sagemaker_CfnWorkteam_NotificationConfigurationProperty, aws_cdk_lib_aws_sagemaker_CfnWorkteam_OidcMemberDefinitionProperty, aws_cdk_lib_aws_sam_CfnApiProps, aws_cdk_lib_aws_sam_CfnApi, aws_cdk_lib_aws_sam_CfnApi_AccessLogSettingProperty, aws_cdk_lib_aws_sam_CfnApi_AuthProperty, aws_cdk_lib_aws_sam_CfnApi_CanarySettingProperty, aws_cdk_lib_aws_sam_CfnApi_CorsConfigurationProperty, aws_cdk_lib_aws_sam_CfnApi_DomainConfigurationProperty, aws_cdk_lib_aws_sam_CfnApi_EndpointConfigurationProperty, aws_cdk_lib_aws_sam_CfnApi_MutualTlsAuthenticationProperty, aws_cdk_lib_aws_sam_CfnApi_Route53ConfigurationProperty, aws_cdk_lib_aws_sam_CfnApi_S3LocationProperty, aws_cdk_lib_aws_sam_CfnApplicationProps, aws_cdk_lib_aws_sam_CfnApplication, aws_cdk_lib_aws_sam_CfnApplication_ApplicationLocationProperty, aws_cdk_lib_aws_sam_CfnFunctionProps, aws_cdk_lib_aws_sam_CfnFunction, aws_cdk_lib_aws_sam_CfnFunction_AlexaSkillEventProperty, aws_cdk_lib_aws_sam_CfnFunction_ApiEventProperty, aws_cdk_lib_aws_sam_CfnFunction_AuthProperty, aws_cdk_lib_aws_sam_CfnFunction_AuthResourcePolicyProperty, aws_cdk_lib_aws_sam_CfnFunction_BucketSAMPTProperty, aws_cdk_lib_aws_sam_CfnFunction_CloudWatchEventEventProperty, aws_cdk_lib_aws_sam_CfnFunction_CloudWatchLogsEventProperty, aws_cdk_lib_aws_sam_CfnFunction_CognitoEventProperty, aws_cdk_lib_aws_sam_CfnFunction_CollectionSAMPTProperty, aws_cdk_lib_aws_sam_CfnFunction_DeadLetterQueueProperty, aws_cdk_lib_aws_sam_CfnFunction_DeploymentPreferenceProperty, aws_cdk_lib_aws_sam_CfnFunction_DestinationProperty, aws_cdk_lib_aws_sam_CfnFunction_DestinationConfigProperty, aws_cdk_lib_aws_sam_CfnFunction_DomainSAMPTProperty, aws_cdk_lib_aws_sam_CfnFunction_DynamoDBEventProperty, aws_cdk_lib_aws_sam_CfnFunction_EmptySAMPTProperty, aws_cdk_lib_aws_sam_CfnFunction_EventBridgeRuleEventProperty, aws_cdk_lib_aws_sam_CfnFunction_EventInvokeConfigProperty, aws_cdk_lib_aws_sam_CfnFunction_EventInvokeDestinationConfigProperty, aws_cdk_lib_aws_sam_CfnFunction_EventSourceProperty, aws_cdk_lib_aws_sam_CfnFunction_FileSystemConfigProperty, aws_cdk_lib_aws_sam_CfnFunction_FunctionEnvironmentProperty, aws_cdk_lib_aws_sam_CfnFunction_FunctionSAMPTProperty, aws_cdk_lib_aws_sam_CfnFunction_HooksProperty, aws_cdk_lib_aws_sam_CfnFunction_HttpApiEventProperty, aws_cdk_lib_aws_sam_CfnFunction_HttpApiFunctionAuthProperty, aws_cdk_lib_aws_sam_CfnFunction_IAMPolicyDocumentProperty, aws_cdk_lib_aws_sam_CfnFunction_IdentitySAMPTProperty, aws_cdk_lib_aws_sam_CfnFunction_ImageConfigProperty, aws_cdk_lib_aws_sam_CfnFunction_IoTRuleEventProperty, aws_cdk_lib_aws_sam_CfnFunction_KeySAMPTProperty, aws_cdk_lib_aws_sam_CfnFunction_KinesisEventProperty, aws_cdk_lib_aws_sam_CfnFunction_LogGroupSAMPTProperty, aws_cdk_lib_aws_sam_CfnFunction_ParameterNameSAMPTProperty, aws_cdk_lib_aws_sam_CfnFunction_ProvisionedConcurrencyConfigProperty, aws_cdk_lib_aws_sam_CfnFunction_QueueSAMPTProperty, aws_cdk_lib_aws_sam_CfnFunction_RequestModelProperty, aws_cdk_lib_aws_sam_CfnFunction_RequestParameterProperty, aws_cdk_lib_aws_sam_CfnFunction_RouteSettingsProperty, aws_cdk_lib_aws_sam_CfnFunction_S3EventProperty, aws_cdk_lib_aws_sam_CfnFunction_S3KeyFilterProperty, aws_cdk_lib_aws_sam_CfnFunction_S3KeyFilterRuleProperty, aws_cdk_lib_aws_sam_CfnFunction_S3LocationProperty, aws_cdk_lib_aws_sam_CfnFunction_S3NotificationFilterProperty, aws_cdk_lib_aws_sam_CfnFunction_SAMPolicyTemplateProperty, aws_cdk_lib_aws_sam_CfnFunction_SNSEventProperty, aws_cdk_lib_aws_sam_CfnFunction_SQSEventProperty, aws_cdk_lib_aws_sam_CfnFunction_ScheduleEventProperty, aws_cdk_lib_aws_sam_CfnFunction_SecretArnSAMPTProperty, aws_cdk_lib_aws_sam_CfnFunction_StateMachineSAMPTProperty, aws_cdk_lib_aws_sam_CfnFunction_StreamSAMPTProperty, aws_cdk_lib_aws_sam_CfnFunction_TableSAMPTProperty, aws_cdk_lib_aws_sam_CfnFunction_TableStreamSAMPTProperty, aws_cdk_lib_aws_sam_CfnFunction_TopicSAMPTProperty, aws_cdk_lib_aws_sam_CfnFunction_VpcConfigProperty, aws_cdk_lib_aws_sam_CfnHttpApiProps, aws_cdk_lib_aws_sam_CfnHttpApi, aws_cdk_lib_aws_sam_CfnHttpApi_AccessLogSettingProperty, aws_cdk_lib_aws_sam_CfnHttpApi_CorsConfigurationObjectProperty, aws_cdk_lib_aws_sam_CfnHttpApi_HttpApiAuthProperty, aws_cdk_lib_aws_sam_CfnHttpApi_HttpApiDomainConfigurationProperty, aws_cdk_lib_aws_sam_CfnHttpApi_MutualTlsAuthenticationProperty, aws_cdk_lib_aws_sam_CfnHttpApi_Route53ConfigurationProperty, aws_cdk_lib_aws_sam_CfnHttpApi_RouteSettingsProperty, aws_cdk_lib_aws_sam_CfnHttpApi_S3LocationProperty, aws_cdk_lib_aws_sam_CfnLayerVersionProps, aws_cdk_lib_aws_sam_CfnLayerVersion, aws_cdk_lib_aws_sam_CfnLayerVersion_S3LocationProperty, aws_cdk_lib_aws_sam_CfnSimpleTableProps, aws_cdk_lib_aws_sam_CfnSimpleTable, aws_cdk_lib_aws_sam_CfnSimpleTable_PrimaryKeyProperty, aws_cdk_lib_aws_sam_CfnSimpleTable_ProvisionedThroughputProperty, aws_cdk_lib_aws_sam_CfnSimpleTable_SSESpecificationProperty, aws_cdk_lib_aws_sam_CfnStateMachineProps, aws_cdk_lib_aws_sam_CfnStateMachine, aws_cdk_lib_aws_sam_CfnStateMachine_ApiEventProperty, aws_cdk_lib_aws_sam_CfnStateMachine_CloudWatchEventEventProperty, aws_cdk_lib_aws_sam_CfnStateMachine_CloudWatchLogsLogGroupProperty, aws_cdk_lib_aws_sam_CfnStateMachine_EventBridgeRuleEventProperty, aws_cdk_lib_aws_sam_CfnStateMachine_EventSourceProperty, aws_cdk_lib_aws_sam_CfnStateMachine_FunctionSAMPTProperty, aws_cdk_lib_aws_sam_CfnStateMachine_IAMPolicyDocumentProperty, aws_cdk_lib_aws_sam_CfnStateMachine_LogDestinationProperty, aws_cdk_lib_aws_sam_CfnStateMachine_LoggingConfigurationProperty, aws_cdk_lib_aws_sam_CfnStateMachine_S3LocationProperty, aws_cdk_lib_aws_sam_CfnStateMachine_SAMPolicyTemplateProperty, aws_cdk_lib_aws_sam_CfnStateMachine_ScheduleEventProperty, aws_cdk_lib_aws_sam_CfnStateMachine_StateMachineSAMPTProperty, aws_cdk_lib_aws_sam_CfnStateMachine_TracingConfigurationProperty, aws_cdk_lib_aws_scheduler_CfnScheduleProps, aws_cdk_lib_aws_scheduler_CfnSchedule, aws_cdk_lib_aws_scheduler_CfnSchedule_AwsVpcConfigurationProperty, aws_cdk_lib_aws_scheduler_CfnSchedule_CapacityProviderStrategyItemProperty, aws_cdk_lib_aws_scheduler_CfnSchedule_DeadLetterConfigProperty, aws_cdk_lib_aws_scheduler_CfnSchedule_EcsParametersProperty, aws_cdk_lib_aws_scheduler_CfnSchedule_EventBridgeParametersProperty, aws_cdk_lib_aws_scheduler_CfnSchedule_FlexibleTimeWindowProperty, aws_cdk_lib_aws_scheduler_CfnSchedule_KinesisParametersProperty, aws_cdk_lib_aws_scheduler_CfnSchedule_NetworkConfigurationProperty, aws_cdk_lib_aws_scheduler_CfnSchedule_PlacementConstraintProperty, aws_cdk_lib_aws_scheduler_CfnSchedule_PlacementStrategyProperty, aws_cdk_lib_aws_scheduler_CfnSchedule_RetryPolicyProperty, aws_cdk_lib_aws_scheduler_CfnSchedule_SageMakerPipelineParameterProperty, aws_cdk_lib_aws_scheduler_CfnSchedule_SageMakerPipelineParametersProperty, aws_cdk_lib_aws_scheduler_CfnSchedule_SqsParametersProperty, aws_cdk_lib_aws_scheduler_CfnSchedule_TargetProperty, aws_cdk_lib_aws_scheduler_CfnScheduleGroupProps, aws_cdk_lib_aws_scheduler_CfnScheduleGroup, aws_cdk_lib_aws_sdb_CfnDomainProps, aws_cdk_lib_aws_sdb_CfnDomain, aws_cdk_lib_aws_secretsmanager_ISecret, aws_cdk_lib_aws_secretsmanager_SecretProps, aws_cdk_lib_aws_secretsmanager_ReplicaRegion, aws_cdk_lib_aws_secretsmanager_SecretStringValueBeta1, aws_cdk_lib_aws_secretsmanager_SecretAttributes, aws_cdk_lib_aws_secretsmanager_Secret, aws_cdk_lib_aws_secretsmanager_ISecretAttachmentTarget, aws_cdk_lib_aws_secretsmanager_AttachmentTargetType, aws_cdk_lib_aws_secretsmanager_SecretAttachmentTargetProps, aws_cdk_lib_aws_secretsmanager_AttachedSecretOptions, aws_cdk_lib_aws_secretsmanager_SecretTargetAttachmentProps, aws_cdk_lib_aws_secretsmanager_ISecretTargetAttachment, aws_cdk_lib_aws_secretsmanager_SecretTargetAttachment, aws_cdk_lib_aws_secretsmanager_SecretStringGenerator, aws_cdk_lib_aws_secretsmanager_RotationScheduleOptions, aws_cdk_lib_aws_secretsmanager_RotationScheduleProps, aws_cdk_lib_aws_secretsmanager_RotationSchedule, aws_cdk_lib_aws_secretsmanager_SingleUserHostedRotationOptions, aws_cdk_lib_aws_secretsmanager_MultiUserHostedRotationOptions, aws_cdk_lib_aws_secretsmanager_HostedRotation, aws_cdk_lib_aws_secretsmanager_HostedRotationType, aws_cdk_lib_aws_secretsmanager_ResourcePolicyProps, aws_cdk_lib_aws_secretsmanager_ResourcePolicy, aws_cdk_lib_aws_secretsmanager_SecretRotationApplicationOptions, aws_cdk_lib_aws_secretsmanager_SecretRotationApplication, aws_cdk_lib_aws_secretsmanager_SecretRotationProps, aws_cdk_lib_aws_secretsmanager_SecretRotation, aws_cdk_lib_aws_secretsmanager_CfnResourcePolicyProps, aws_cdk_lib_aws_secretsmanager_CfnResourcePolicy, aws_cdk_lib_aws_secretsmanager_CfnRotationScheduleProps, aws_cdk_lib_aws_secretsmanager_CfnRotationSchedule, aws_cdk_lib_aws_secretsmanager_CfnRotationSchedule_HostedRotationLambdaProperty, aws_cdk_lib_aws_secretsmanager_CfnRotationSchedule_RotationRulesProperty, aws_cdk_lib_aws_secretsmanager_CfnSecretProps, aws_cdk_lib_aws_secretsmanager_CfnSecret, aws_cdk_lib_aws_secretsmanager_CfnSecret_GenerateSecretStringProperty, aws_cdk_lib_aws_secretsmanager_CfnSecret_ReplicaRegionProperty, aws_cdk_lib_aws_secretsmanager_CfnSecretTargetAttachmentProps, aws_cdk_lib_aws_secretsmanager_CfnSecretTargetAttachment, aws_cdk_lib_aws_securityhub_CfnHubProps, aws_cdk_lib_aws_securityhub_CfnHub, aws_cdk_lib_aws_servicecatalog_MessageLanguage, aws_cdk_lib_aws_servicecatalog_CommonConstraintOptions, aws_cdk_lib_aws_servicecatalog_StackSetsConstraintOptions, aws_cdk_lib_aws_servicecatalog_TagUpdateConstraintOptions, aws_cdk_lib_aws_servicecatalog_TemplateRuleAssertion, aws_cdk_lib_aws_servicecatalog_TemplateRule, aws_cdk_lib_aws_servicecatalog_CloudFormationRuleConstraintOptions, aws_cdk_lib_aws_servicecatalog_CloudFormationTemplate, aws_cdk_lib_aws_servicecatalog_CloudFormationTemplateConfig, aws_cdk_lib_aws_servicecatalog_PortfolioShareOptions, aws_cdk_lib_aws_servicecatalog_IPortfolio, aws_cdk_lib_aws_servicecatalog_PortfolioProps, aws_cdk_lib_aws_servicecatalog_Portfolio, aws_cdk_lib_aws_servicecatalog_IProduct, aws_cdk_lib_aws_servicecatalog_CloudFormationProductVersion, aws_cdk_lib_aws_servicecatalog_CloudFormationProductProps, aws_cdk_lib_aws_servicecatalog_Product, aws_cdk_lib_aws_servicecatalog_CloudFormationProduct, aws_cdk_lib_aws_servicecatalog_ProductStackProps, aws_cdk_lib_aws_servicecatalog_ProductStack, aws_cdk_lib_aws_servicecatalog_ProductStackHistoryProps, aws_cdk_lib_aws_servicecatalog_ProductStackHistory, aws_cdk_lib_aws_servicecatalog_TagOptionsProps, aws_cdk_lib_aws_servicecatalog_TagOptions, aws_cdk_lib_aws_servicecatalog_CfnAcceptedPortfolioShareProps, aws_cdk_lib_aws_servicecatalog_CfnAcceptedPortfolioShare, aws_cdk_lib_aws_servicecatalog_CfnCloudFormationProductProps, aws_cdk_lib_aws_servicecatalog_CfnCloudFormationProduct, aws_cdk_lib_aws_servicecatalog_CfnCloudFormationProduct_CodeStarParametersProperty, aws_cdk_lib_aws_servicecatalog_CfnCloudFormationProduct_ConnectionParametersProperty, aws_cdk_lib_aws_servicecatalog_CfnCloudFormationProduct_ProvisioningArtifactPropertiesProperty, aws_cdk_lib_aws_servicecatalog_CfnCloudFormationProduct_SourceConnectionProperty, aws_cdk_lib_aws_servicecatalog_CfnCloudFormationProvisionedProductProps, aws_cdk_lib_aws_servicecatalog_CfnCloudFormationProvisionedProduct, aws_cdk_lib_aws_servicecatalog_CfnCloudFormationProvisionedProduct_ProvisioningParameterProperty, aws_cdk_lib_aws_servicecatalog_CfnCloudFormationProvisionedProduct_ProvisioningPreferencesProperty, aws_cdk_lib_aws_servicecatalog_CfnLaunchNotificationConstraintProps, aws_cdk_lib_aws_servicecatalog_CfnLaunchNotificationConstraint, aws_cdk_lib_aws_servicecatalog_CfnLaunchRoleConstraintProps, aws_cdk_lib_aws_servicecatalog_CfnLaunchRoleConstraint, aws_cdk_lib_aws_servicecatalog_CfnLaunchTemplateConstraintProps, aws_cdk_lib_aws_servicecatalog_CfnLaunchTemplateConstraint, aws_cdk_lib_aws_servicecatalog_CfnPortfolioProps, aws_cdk_lib_aws_servicecatalog_CfnPortfolio, aws_cdk_lib_aws_servicecatalog_CfnPortfolioPrincipalAssociationProps, aws_cdk_lib_aws_servicecatalog_CfnPortfolioPrincipalAssociation, aws_cdk_lib_aws_servicecatalog_CfnPortfolioProductAssociationProps, aws_cdk_lib_aws_servicecatalog_CfnPortfolioProductAssociation, aws_cdk_lib_aws_servicecatalog_CfnPortfolioShareProps, aws_cdk_lib_aws_servicecatalog_CfnPortfolioShare, aws_cdk_lib_aws_servicecatalog_CfnResourceUpdateConstraintProps, aws_cdk_lib_aws_servicecatalog_CfnResourceUpdateConstraint, aws_cdk_lib_aws_servicecatalog_CfnServiceActionProps, aws_cdk_lib_aws_servicecatalog_CfnServiceAction, aws_cdk_lib_aws_servicecatalog_CfnServiceAction_DefinitionParameterProperty, aws_cdk_lib_aws_servicecatalog_CfnServiceActionAssociationProps, aws_cdk_lib_aws_servicecatalog_CfnServiceActionAssociation, aws_cdk_lib_aws_servicecatalog_CfnStackSetConstraintProps, aws_cdk_lib_aws_servicecatalog_CfnStackSetConstraint, aws_cdk_lib_aws_servicecatalog_CfnTagOptionProps, aws_cdk_lib_aws_servicecatalog_CfnTagOption, aws_cdk_lib_aws_servicecatalog_CfnTagOptionAssociationProps, aws_cdk_lib_aws_servicecatalog_CfnTagOptionAssociation, aws_cdk_lib_aws_servicecatalogappregistry_CfnApplicationProps, aws_cdk_lib_aws_servicecatalogappregistry_CfnApplication, aws_cdk_lib_aws_servicecatalogappregistry_CfnAttributeGroupProps, aws_cdk_lib_aws_servicecatalogappregistry_CfnAttributeGroup, aws_cdk_lib_aws_servicecatalogappregistry_CfnAttributeGroupAssociationProps, aws_cdk_lib_aws_servicecatalogappregistry_CfnAttributeGroupAssociation, aws_cdk_lib_aws_servicecatalogappregistry_CfnResourceAssociationProps, aws_cdk_lib_aws_servicecatalogappregistry_CfnResourceAssociation, aws_cdk_lib_aws_servicediscovery_IInstance, aws_cdk_lib_aws_servicediscovery_BaseInstanceProps, aws_cdk_lib_aws_servicediscovery_InstanceBase, aws_cdk_lib_aws_servicediscovery_AliasTargetInstanceProps, aws_cdk_lib_aws_servicediscovery_AliasTargetInstance, aws_cdk_lib_aws_servicediscovery_CnameInstanceBaseProps, aws_cdk_lib_aws_servicediscovery_CnameInstanceProps, aws_cdk_lib_aws_servicediscovery_CnameInstance, aws_cdk_lib_aws_servicediscovery_IpInstanceBaseProps, aws_cdk_lib_aws_servicediscovery_IpInstanceProps, aws_cdk_lib_aws_servicediscovery_IpInstance, aws_cdk_lib_aws_servicediscovery_NonIpInstanceBaseProps, aws_cdk_lib_aws_servicediscovery_NonIpInstanceProps, aws_cdk_lib_aws_servicediscovery_NonIpInstance, aws_cdk_lib_aws_servicediscovery_INamespace, aws_cdk_lib_aws_servicediscovery_BaseNamespaceProps, aws_cdk_lib_aws_servicediscovery_NamespaceType, aws_cdk_lib_aws_servicediscovery_HttpNamespaceProps, aws_cdk_lib_aws_servicediscovery_IHttpNamespace, aws_cdk_lib_aws_servicediscovery_HttpNamespaceAttributes, aws_cdk_lib_aws_servicediscovery_HttpNamespace, aws_cdk_lib_aws_servicediscovery_PrivateDnsNamespaceProps, aws_cdk_lib_aws_servicediscovery_IPrivateDnsNamespace, aws_cdk_lib_aws_servicediscovery_PrivateDnsNamespaceAttributes, aws_cdk_lib_aws_servicediscovery_PrivateDnsNamespace, aws_cdk_lib_aws_servicediscovery_PublicDnsNamespaceProps, aws_cdk_lib_aws_servicediscovery_IPublicDnsNamespace, aws_cdk_lib_aws_servicediscovery_PublicDnsNamespaceAttributes, aws_cdk_lib_aws_servicediscovery_PublicDnsNamespace, aws_cdk_lib_aws_servicediscovery_IService, aws_cdk_lib_aws_servicediscovery_BaseServiceProps, aws_cdk_lib_aws_servicediscovery_DnsServiceProps, aws_cdk_lib_aws_servicediscovery_ServiceProps, aws_cdk_lib_aws_servicediscovery_ServiceAttributes, aws_cdk_lib_aws_servicediscovery_Service, aws_cdk_lib_aws_servicediscovery_HealthCheckConfig, aws_cdk_lib_aws_servicediscovery_HealthCheckCustomConfig, aws_cdk_lib_aws_servicediscovery_DiscoveryType, aws_cdk_lib_aws_servicediscovery_DnsRecordType, aws_cdk_lib_aws_servicediscovery_RoutingPolicy, aws_cdk_lib_aws_servicediscovery_HealthCheckType, aws_cdk_lib_aws_servicediscovery_CfnHttpNamespaceProps, aws_cdk_lib_aws_servicediscovery_CfnHttpNamespace, aws_cdk_lib_aws_servicediscovery_CfnInstanceProps, aws_cdk_lib_aws_servicediscovery_CfnInstance, aws_cdk_lib_aws_servicediscovery_CfnPrivateDnsNamespaceProps, aws_cdk_lib_aws_servicediscovery_CfnPrivateDnsNamespace, aws_cdk_lib_aws_servicediscovery_CfnPrivateDnsNamespace_PrivateDnsPropertiesMutableProperty, aws_cdk_lib_aws_servicediscovery_CfnPrivateDnsNamespace_PropertiesProperty, aws_cdk_lib_aws_servicediscovery_CfnPrivateDnsNamespace_SOAProperty, aws_cdk_lib_aws_servicediscovery_CfnPublicDnsNamespaceProps, aws_cdk_lib_aws_servicediscovery_CfnPublicDnsNamespace, aws_cdk_lib_aws_servicediscovery_CfnPublicDnsNamespace_PropertiesProperty, aws_cdk_lib_aws_servicediscovery_CfnPublicDnsNamespace_PublicDnsPropertiesMutableProperty, aws_cdk_lib_aws_servicediscovery_CfnPublicDnsNamespace_SOAProperty, aws_cdk_lib_aws_servicediscovery_CfnServiceProps, aws_cdk_lib_aws_servicediscovery_CfnService, aws_cdk_lib_aws_servicediscovery_CfnService_DnsConfigProperty, aws_cdk_lib_aws_servicediscovery_CfnService_DnsRecordProperty, aws_cdk_lib_aws_servicediscovery_CfnService_HealthCheckConfigProperty, aws_cdk_lib_aws_servicediscovery_CfnService_HealthCheckCustomConfigProperty, aws_cdk_lib_aws_ses_IReceiptRuleSet, aws_cdk_lib_aws_ses_ReceiptRuleSetProps, aws_cdk_lib_aws_ses_ReceiptRuleSet, aws_cdk_lib_aws_ses_IReceiptRule, aws_cdk_lib_aws_ses_TlsPolicy, aws_cdk_lib_aws_ses_ReceiptRuleOptions, aws_cdk_lib_aws_ses_ReceiptRuleProps, aws_cdk_lib_aws_ses_ReceiptRule, aws_cdk_lib_aws_ses_DropSpamReceiptRuleProps, aws_cdk_lib_aws_ses_DropSpamReceiptRule, aws_cdk_lib_aws_ses_IReceiptRuleAction, aws_cdk_lib_aws_ses_AddHeaderActionConfig, aws_cdk_lib_aws_ses_BounceActionConfig, aws_cdk_lib_aws_ses_LambdaActionConfig, aws_cdk_lib_aws_ses_S3ActionConfig, aws_cdk_lib_aws_ses_SNSActionConfig, aws_cdk_lib_aws_ses_StopActionConfig, aws_cdk_lib_aws_ses_WorkmailActionConfig, aws_cdk_lib_aws_ses_ReceiptRuleActionConfig, aws_cdk_lib_aws_ses_ReceiptFilterPolicy, aws_cdk_lib_aws_ses_ReceiptFilterProps, aws_cdk_lib_aws_ses_ReceiptFilter, aws_cdk_lib_aws_ses_AllowListReceiptFilterProps, aws_cdk_lib_aws_ses_AllowListReceiptFilter, aws_cdk_lib_aws_ses_IDedicatedIpPool, aws_cdk_lib_aws_ses_DedicatedIpPoolProps, aws_cdk_lib_aws_ses_DedicatedIpPool, aws_cdk_lib_aws_ses_IConfigurationSet, aws_cdk_lib_aws_ses_ConfigurationSetProps, aws_cdk_lib_aws_ses_ConfigurationSetTlsPolicy, aws_cdk_lib_aws_ses_SuppressionReasons, aws_cdk_lib_aws_ses_ConfigurationSet, aws_cdk_lib_aws_ses_IEmailIdentity, aws_cdk_lib_aws_ses_EmailIdentityProps, aws_cdk_lib_aws_ses_Identity, aws_cdk_lib_aws_ses_MailFromBehaviorOnMxFailure, aws_cdk_lib_aws_ses_DkimIdentityConfig, aws_cdk_lib_aws_ses_DkimIdentity, aws_cdk_lib_aws_ses_ByoDkimOptions, aws_cdk_lib_aws_ses_EasyDkimSigningKeyLength, aws_cdk_lib_aws_ses_EmailIdentity, aws_cdk_lib_aws_ses_DkimRecord, aws_cdk_lib_aws_ses_IVdmAttributes, aws_cdk_lib_aws_ses_VdmAttributesProps, aws_cdk_lib_aws_ses_VdmAttributes, aws_cdk_lib_aws_ses_IConfigurationSetEventDestination, aws_cdk_lib_aws_ses_ConfigurationSetEventDestinationOptions, aws_cdk_lib_aws_ses_EventDestination, aws_cdk_lib_aws_ses_ConfigurationSetEventDestinationProps, aws_cdk_lib_aws_ses_EmailSendingEvent, aws_cdk_lib_aws_ses_CloudWatchDimension, aws_cdk_lib_aws_ses_CloudWatchDimensionSource, aws_cdk_lib_aws_ses_ConfigurationSetEventDestination, aws_cdk_lib_aws_ses_CfnConfigurationSetProps, aws_cdk_lib_aws_ses_CfnConfigurationSet, aws_cdk_lib_aws_ses_CfnConfigurationSet_DashboardOptionsProperty, aws_cdk_lib_aws_ses_CfnConfigurationSet_DeliveryOptionsProperty, aws_cdk_lib_aws_ses_CfnConfigurationSet_GuardianOptionsProperty, aws_cdk_lib_aws_ses_CfnConfigurationSet_ReputationOptionsProperty, aws_cdk_lib_aws_ses_CfnConfigurationSet_SendingOptionsProperty, aws_cdk_lib_aws_ses_CfnConfigurationSet_SuppressionOptionsProperty, aws_cdk_lib_aws_ses_CfnConfigurationSet_TrackingOptionsProperty, aws_cdk_lib_aws_ses_CfnConfigurationSet_VdmOptionsProperty, aws_cdk_lib_aws_ses_CfnConfigurationSetEventDestinationProps, aws_cdk_lib_aws_ses_CfnConfigurationSetEventDestination, aws_cdk_lib_aws_ses_CfnConfigurationSetEventDestination_CloudWatchDestinationProperty, aws_cdk_lib_aws_ses_CfnConfigurationSetEventDestination_DimensionConfigurationProperty, aws_cdk_lib_aws_ses_CfnConfigurationSetEventDestination_EventDestinationProperty, aws_cdk_lib_aws_ses_CfnConfigurationSetEventDestination_KinesisFirehoseDestinationProperty, aws_cdk_lib_aws_ses_CfnConfigurationSetEventDestination_SnsDestinationProperty, aws_cdk_lib_aws_ses_CfnContactListProps, aws_cdk_lib_aws_ses_CfnContactList, aws_cdk_lib_aws_ses_CfnContactList_TopicProperty, aws_cdk_lib_aws_ses_CfnDedicatedIpPoolProps, aws_cdk_lib_aws_ses_CfnDedicatedIpPool, aws_cdk_lib_aws_ses_CfnEmailIdentityProps, aws_cdk_lib_aws_ses_CfnEmailIdentity, aws_cdk_lib_aws_ses_CfnEmailIdentity_ConfigurationSetAttributesProperty, aws_cdk_lib_aws_ses_CfnEmailIdentity_DkimAttributesProperty, aws_cdk_lib_aws_ses_CfnEmailIdentity_DkimSigningAttributesProperty, aws_cdk_lib_aws_ses_CfnEmailIdentity_FeedbackAttributesProperty, aws_cdk_lib_aws_ses_CfnEmailIdentity_MailFromAttributesProperty, aws_cdk_lib_aws_ses_CfnReceiptFilterProps, aws_cdk_lib_aws_ses_CfnReceiptFilter, aws_cdk_lib_aws_ses_CfnReceiptFilter_FilterProperty, aws_cdk_lib_aws_ses_CfnReceiptFilter_IpFilterProperty, aws_cdk_lib_aws_ses_CfnReceiptRuleProps, aws_cdk_lib_aws_ses_CfnReceiptRule, aws_cdk_lib_aws_ses_CfnReceiptRule_ActionProperty, aws_cdk_lib_aws_ses_CfnReceiptRule_AddHeaderActionProperty, aws_cdk_lib_aws_ses_CfnReceiptRule_BounceActionProperty, aws_cdk_lib_aws_ses_CfnReceiptRule_LambdaActionProperty, aws_cdk_lib_aws_ses_CfnReceiptRule_RuleProperty, aws_cdk_lib_aws_ses_CfnReceiptRule_S3ActionProperty, aws_cdk_lib_aws_ses_CfnReceiptRule_SNSActionProperty, aws_cdk_lib_aws_ses_CfnReceiptRule_StopActionProperty, aws_cdk_lib_aws_ses_CfnReceiptRule_WorkmailActionProperty, aws_cdk_lib_aws_ses_CfnReceiptRuleSetProps, aws_cdk_lib_aws_ses_CfnReceiptRuleSet, aws_cdk_lib_aws_ses_CfnTemplateProps, aws_cdk_lib_aws_ses_CfnTemplate, aws_cdk_lib_aws_ses_CfnTemplate_TemplateProperty, aws_cdk_lib_aws_ses_CfnVdmAttributesProps, aws_cdk_lib_aws_ses_CfnVdmAttributes, aws_cdk_lib_aws_ses_CfnVdmAttributes_DashboardAttributesProperty, aws_cdk_lib_aws_ses_CfnVdmAttributes_GuardianAttributesProperty, aws_cdk_lib_aws_ses_actions_AddHeaderProps, aws_cdk_lib_aws_ses_actions_AddHeader, aws_cdk_lib_aws_ses_actions_BounceTemplateProps, aws_cdk_lib_aws_ses_actions_BounceTemplate, aws_cdk_lib_aws_ses_actions_BounceProps, aws_cdk_lib_aws_ses_actions_Bounce, aws_cdk_lib_aws_ses_actions_LambdaInvocationType, aws_cdk_lib_aws_ses_actions_LambdaProps, aws_cdk_lib_aws_ses_actions_Lambda, aws_cdk_lib_aws_ses_actions_S3Props, aws_cdk_lib_aws_ses_actions_S3, aws_cdk_lib_aws_ses_actions_EmailEncoding, aws_cdk_lib_aws_ses_actions_SnsProps, aws_cdk_lib_aws_ses_actions_Sns, aws_cdk_lib_aws_ses_actions_StopProps, aws_cdk_lib_aws_ses_actions_Stop, aws_cdk_lib_aws_signer_CfnProfilePermissionProps, aws_cdk_lib_aws_signer_CfnProfilePermission, aws_cdk_lib_aws_signer_CfnSigningProfileProps, aws_cdk_lib_aws_signer_CfnSigningProfile, aws_cdk_lib_aws_signer_CfnSigningProfile_SignatureValidityPeriodProperty, aws_cdk_lib_aws_signer_Platform, aws_cdk_lib_aws_signer_ISigningProfile, aws_cdk_lib_aws_signer_SigningProfileProps, aws_cdk_lib_aws_signer_SigningProfileAttributes, aws_cdk_lib_aws_signer_SigningProfile, aws_cdk_lib_aws_simspaceweaver_CfnSimulationProps, aws_cdk_lib_aws_simspaceweaver_CfnSimulation, aws_cdk_lib_aws_simspaceweaver_CfnSimulation_S3LocationProperty, aws_cdk_lib_aws_sns_TopicPolicyProps, aws_cdk_lib_aws_sns_TopicPolicy, aws_cdk_lib_aws_sns_TopicProps, aws_cdk_lib_aws_sns_Topic, aws_cdk_lib_aws_sns_ITopic, aws_cdk_lib_aws_sns_TopicBase, aws_cdk_lib_aws_sns_SubscriptionOptions, aws_cdk_lib_aws_sns_SubscriptionProps, aws_cdk_lib_aws_sns_Subscription, aws_cdk_lib_aws_sns_SubscriptionProtocol, aws_cdk_lib_aws_sns_FilterOrPolicyType, aws_cdk_lib_aws_sns_FilterOrPolicy, aws_cdk_lib_aws_sns_Filter, aws_cdk_lib_aws_sns_Policy, aws_cdk_lib_aws_sns_TopicSubscriptionConfig, aws_cdk_lib_aws_sns_ITopicSubscription, aws_cdk_lib_aws_sns_StringConditions, aws_cdk_lib_aws_sns_BetweenCondition, aws_cdk_lib_aws_sns_NumericConditions, aws_cdk_lib_aws_sns_SubscriptionFilter, aws_cdk_lib_aws_sns_CfnSubscriptionProps, aws_cdk_lib_aws_sns_CfnSubscription, aws_cdk_lib_aws_sns_CfnTopicProps, aws_cdk_lib_aws_sns_CfnTopic, aws_cdk_lib_aws_sns_CfnTopic_SubscriptionProperty, aws_cdk_lib_aws_sns_CfnTopicPolicyProps, aws_cdk_lib_aws_sns_CfnTopicPolicy, aws_cdk_lib_aws_sns_subscriptions_SubscriptionProps, aws_cdk_lib_aws_sns_subscriptions_EmailSubscriptionProps, aws_cdk_lib_aws_sns_subscriptions_EmailSubscription, aws_cdk_lib_aws_sns_subscriptions_LambdaSubscriptionProps, aws_cdk_lib_aws_sns_subscriptions_LambdaSubscription, aws_cdk_lib_aws_sns_subscriptions_SqsSubscriptionProps, aws_cdk_lib_aws_sns_subscriptions_SqsSubscription, aws_cdk_lib_aws_sns_subscriptions_UrlSubscriptionProps, aws_cdk_lib_aws_sns_subscriptions_UrlSubscription, aws_cdk_lib_aws_sns_subscriptions_SmsSubscriptionProps, aws_cdk_lib_aws_sns_subscriptions_SmsSubscription, aws_cdk_lib_aws_sqs_QueuePolicyProps, aws_cdk_lib_aws_sqs_QueuePolicy, aws_cdk_lib_aws_sqs_QueueProps, aws_cdk_lib_aws_sqs_DeadLetterQueue, aws_cdk_lib_aws_sqs_QueueEncryption, aws_cdk_lib_aws_sqs_DeduplicationScope, aws_cdk_lib_aws_sqs_FifoThroughputLimit, aws_cdk_lib_aws_sqs_Queue, aws_cdk_lib_aws_sqs_IQueue, aws_cdk_lib_aws_sqs_QueueBase, aws_cdk_lib_aws_sqs_QueueAttributes, aws_cdk_lib_aws_sqs_CfnQueueProps, aws_cdk_lib_aws_sqs_CfnQueue, aws_cdk_lib_aws_sqs_CfnQueuePolicyProps, aws_cdk_lib_aws_sqs_CfnQueuePolicy, aws_cdk_lib_aws_ssm_IParameter, aws_cdk_lib_aws_ssm_IStringParameter, aws_cdk_lib_aws_ssm_IStringListParameter, aws_cdk_lib_aws_ssm_ParameterOptions, aws_cdk_lib_aws_ssm_StringParameterProps, aws_cdk_lib_aws_ssm_StringListParameterProps, aws_cdk_lib_aws_ssm_ParameterValueType, aws_cdk_lib_aws_ssm_ParameterType, aws_cdk_lib_aws_ssm_ParameterDataType, aws_cdk_lib_aws_ssm_ParameterTier, aws_cdk_lib_aws_ssm_CommonStringParameterAttributes, aws_cdk_lib_aws_ssm_StringParameterAttributes, aws_cdk_lib_aws_ssm_ListParameterAttributes, aws_cdk_lib_aws_ssm_SecureStringParameterAttributes, aws_cdk_lib_aws_ssm_StringParameter, aws_cdk_lib_aws_ssm_StringListParameter, aws_cdk_lib_aws_ssm_CfnAssociationProps, aws_cdk_lib_aws_ssm_CfnAssociation, aws_cdk_lib_aws_ssm_CfnAssociation_InstanceAssociationOutputLocationProperty, aws_cdk_lib_aws_ssm_CfnAssociation_S3OutputLocationProperty, aws_cdk_lib_aws_ssm_CfnAssociation_TargetProperty, aws_cdk_lib_aws_ssm_CfnDocumentProps, aws_cdk_lib_aws_ssm_CfnDocument, aws_cdk_lib_aws_ssm_CfnDocument_AttachmentsSourceProperty, aws_cdk_lib_aws_ssm_CfnDocument_DocumentRequiresProperty, aws_cdk_lib_aws_ssm_CfnMaintenanceWindowProps, aws_cdk_lib_aws_ssm_CfnMaintenanceWindow, aws_cdk_lib_aws_ssm_CfnMaintenanceWindowTargetProps, aws_cdk_lib_aws_ssm_CfnMaintenanceWindowTarget, aws_cdk_lib_aws_ssm_CfnMaintenanceWindowTarget_TargetsProperty, aws_cdk_lib_aws_ssm_CfnMaintenanceWindowTaskProps, aws_cdk_lib_aws_ssm_CfnMaintenanceWindowTask, aws_cdk_lib_aws_ssm_CfnMaintenanceWindowTask_CloudWatchOutputConfigProperty, aws_cdk_lib_aws_ssm_CfnMaintenanceWindowTask_LoggingInfoProperty, aws_cdk_lib_aws_ssm_CfnMaintenanceWindowTask_MaintenanceWindowAutomationParametersProperty, aws_cdk_lib_aws_ssm_CfnMaintenanceWindowTask_MaintenanceWindowLambdaParametersProperty, aws_cdk_lib_aws_ssm_CfnMaintenanceWindowTask_MaintenanceWindowRunCommandParametersProperty, aws_cdk_lib_aws_ssm_CfnMaintenanceWindowTask_MaintenanceWindowStepFunctionsParametersProperty, aws_cdk_lib_aws_ssm_CfnMaintenanceWindowTask_NotificationConfigProperty, aws_cdk_lib_aws_ssm_CfnMaintenanceWindowTask_TargetProperty, aws_cdk_lib_aws_ssm_CfnMaintenanceWindowTask_TaskInvocationParametersProperty, aws_cdk_lib_aws_ssm_CfnParameterProps, aws_cdk_lib_aws_ssm_CfnParameter, aws_cdk_lib_aws_ssm_CfnPatchBaselineProps, aws_cdk_lib_aws_ssm_CfnPatchBaseline, aws_cdk_lib_aws_ssm_CfnPatchBaseline_PatchFilterProperty, aws_cdk_lib_aws_ssm_CfnPatchBaseline_PatchFilterGroupProperty, aws_cdk_lib_aws_ssm_CfnPatchBaseline_PatchSourceProperty, aws_cdk_lib_aws_ssm_CfnPatchBaseline_RuleProperty, aws_cdk_lib_aws_ssm_CfnPatchBaseline_RuleGroupProperty, aws_cdk_lib_aws_ssm_CfnResourceDataSyncProps, aws_cdk_lib_aws_ssm_CfnResourceDataSync, aws_cdk_lib_aws_ssm_CfnResourceDataSync_AwsOrganizationsSourceProperty, aws_cdk_lib_aws_ssm_CfnResourceDataSync_S3DestinationProperty, aws_cdk_lib_aws_ssm_CfnResourceDataSync_SyncSourceProperty, aws_cdk_lib_aws_ssm_CfnResourcePolicyProps, aws_cdk_lib_aws_ssm_CfnResourcePolicy, aws_cdk_lib_aws_ssmcontacts_CfnContactProps, aws_cdk_lib_aws_ssmcontacts_CfnContact, aws_cdk_lib_aws_ssmcontacts_CfnContact_ChannelTargetInfoProperty, aws_cdk_lib_aws_ssmcontacts_CfnContact_ContactTargetInfoProperty, aws_cdk_lib_aws_ssmcontacts_CfnContact_StageProperty, aws_cdk_lib_aws_ssmcontacts_CfnContact_TargetsProperty, aws_cdk_lib_aws_ssmcontacts_CfnContactChannelProps, aws_cdk_lib_aws_ssmcontacts_CfnContactChannel, aws_cdk_lib_aws_ssmcontacts_CfnPlanProps, aws_cdk_lib_aws_ssmcontacts_CfnPlan, aws_cdk_lib_aws_ssmcontacts_CfnPlan_ChannelTargetInfoProperty, aws_cdk_lib_aws_ssmcontacts_CfnPlan_ContactTargetInfoProperty, aws_cdk_lib_aws_ssmcontacts_CfnPlan_StageProperty, aws_cdk_lib_aws_ssmcontacts_CfnPlan_TargetsProperty, aws_cdk_lib_aws_ssmcontacts_CfnRotationProps, aws_cdk_lib_aws_ssmcontacts_CfnRotation, aws_cdk_lib_aws_ssmcontacts_CfnRotation_CoverageTimeProperty, aws_cdk_lib_aws_ssmcontacts_CfnRotation_MonthlySettingProperty, aws_cdk_lib_aws_ssmcontacts_CfnRotation_RecurrenceSettingsProperty, aws_cdk_lib_aws_ssmcontacts_CfnRotation_ShiftCoverageProperty, aws_cdk_lib_aws_ssmcontacts_CfnRotation_WeeklySettingProperty, aws_cdk_lib_aws_ssmincidents_CfnReplicationSetProps, aws_cdk_lib_aws_ssmincidents_CfnReplicationSet, aws_cdk_lib_aws_ssmincidents_CfnReplicationSet_RegionConfigurationProperty, aws_cdk_lib_aws_ssmincidents_CfnReplicationSet_ReplicationRegionProperty, aws_cdk_lib_aws_ssmincidents_CfnResponsePlanProps, aws_cdk_lib_aws_ssmincidents_CfnResponsePlan, aws_cdk_lib_aws_ssmincidents_CfnResponsePlan_ActionProperty, aws_cdk_lib_aws_ssmincidents_CfnResponsePlan_ChatChannelProperty, aws_cdk_lib_aws_ssmincidents_CfnResponsePlan_DynamicSsmParameterProperty, aws_cdk_lib_aws_ssmincidents_CfnResponsePlan_DynamicSsmParameterValueProperty, aws_cdk_lib_aws_ssmincidents_CfnResponsePlan_IncidentTemplateProperty, aws_cdk_lib_aws_ssmincidents_CfnResponsePlan_IntegrationProperty, aws_cdk_lib_aws_ssmincidents_CfnResponsePlan_NotificationTargetItemProperty, aws_cdk_lib_aws_ssmincidents_CfnResponsePlan_PagerDutyConfigurationProperty, aws_cdk_lib_aws_ssmincidents_CfnResponsePlan_PagerDutyIncidentConfigurationProperty, aws_cdk_lib_aws_ssmincidents_CfnResponsePlan_SsmAutomationProperty, aws_cdk_lib_aws_ssmincidents_CfnResponsePlan_SsmParameterProperty, aws_cdk_lib_aws_sso_CfnAssignmentProps, aws_cdk_lib_aws_sso_CfnAssignment, aws_cdk_lib_aws_sso_CfnInstanceAccessControlAttributeConfigurationProps, aws_cdk_lib_aws_sso_CfnInstanceAccessControlAttributeConfiguration, aws_cdk_lib_aws_sso_CfnInstanceAccessControlAttributeConfiguration_AccessControlAttributeProperty, aws_cdk_lib_aws_sso_CfnInstanceAccessControlAttributeConfiguration_AccessControlAttributeValueProperty, aws_cdk_lib_aws_sso_CfnPermissionSetProps, aws_cdk_lib_aws_sso_CfnPermissionSet, aws_cdk_lib_aws_sso_CfnPermissionSet_CustomerManagedPolicyReferenceProperty, aws_cdk_lib_aws_sso_CfnPermissionSet_PermissionsBoundaryProperty, aws_cdk_lib_aws_stepfunctions_JsonPath, aws_cdk_lib_aws_stepfunctions_FieldUtils, aws_cdk_lib_aws_stepfunctions_ActivityProps, aws_cdk_lib_aws_stepfunctions_Activity, aws_cdk_lib_aws_stepfunctions_IActivity, aws_cdk_lib_aws_stepfunctions_TaskInput, aws_cdk_lib_aws_stepfunctions_InputType, aws_cdk_lib_aws_stepfunctions_INextable, aws_cdk_lib_aws_stepfunctions_IChainable, aws_cdk_lib_aws_stepfunctions_Errors, aws_cdk_lib_aws_stepfunctions_RetryProps, aws_cdk_lib_aws_stepfunctions_CatchProps, aws_cdk_lib_aws_stepfunctions_Condition, aws_cdk_lib_aws_stepfunctions_StateMachineType, aws_cdk_lib_aws_stepfunctions_LogLevel, aws_cdk_lib_aws_stepfunctions_LogOptions, aws_cdk_lib_aws_stepfunctions_StateMachineProps, aws_cdk_lib_aws_stepfunctions_StateMachine, aws_cdk_lib_aws_stepfunctions_IStateMachine, aws_cdk_lib_aws_stepfunctions_StateMachineFragment, aws_cdk_lib_aws_stepfunctions_SingleStateOptions, aws_cdk_lib_aws_stepfunctions_StateTransitionMetric, aws_cdk_lib_aws_stepfunctions_Chain, aws_cdk_lib_aws_stepfunctions_StateGraph, aws_cdk_lib_aws_stepfunctions_ServiceIntegrationPattern, aws_cdk_lib_aws_stepfunctions_ChoiceProps, aws_cdk_lib_aws_stepfunctions_Choice, aws_cdk_lib_aws_stepfunctions_AfterwardsOptions, aws_cdk_lib_aws_stepfunctions_FailProps, aws_cdk_lib_aws_stepfunctions_Fail, aws_cdk_lib_aws_stepfunctions_ParallelProps, aws_cdk_lib_aws_stepfunctions_Parallel, aws_cdk_lib_aws_stepfunctions_Result, aws_cdk_lib_aws_stepfunctions_PassProps, aws_cdk_lib_aws_stepfunctions_Pass, aws_cdk_lib_aws_stepfunctions_StateProps, aws_cdk_lib_aws_stepfunctions_State, aws_cdk_lib_aws_stepfunctions_FindStateOptions, aws_cdk_lib_aws_stepfunctions_SucceedProps, aws_cdk_lib_aws_stepfunctions_Succeed, aws_cdk_lib_aws_stepfunctions_WaitTime, aws_cdk_lib_aws_stepfunctions_WaitProps, aws_cdk_lib_aws_stepfunctions_Wait, aws_cdk_lib_aws_stepfunctions_MapProps, aws_cdk_lib_aws_stepfunctions_Map, aws_cdk_lib_aws_stepfunctions_CustomStateProps, aws_cdk_lib_aws_stepfunctions_CustomState, aws_cdk_lib_aws_stepfunctions_TaskStateBaseProps, aws_cdk_lib_aws_stepfunctions_TaskStateBase, aws_cdk_lib_aws_stepfunctions_TaskMetricsConfig, aws_cdk_lib_aws_stepfunctions_IntegrationPattern, aws_cdk_lib_aws_stepfunctions_Timeout, aws_cdk_lib_aws_stepfunctions_Credentials, aws_cdk_lib_aws_stepfunctions_TaskRole, aws_cdk_lib_aws_stepfunctions_CfnActivityProps, aws_cdk_lib_aws_stepfunctions_CfnActivity, aws_cdk_lib_aws_stepfunctions_CfnActivity_TagsEntryProperty, aws_cdk_lib_aws_stepfunctions_CfnStateMachineProps, aws_cdk_lib_aws_stepfunctions_CfnStateMachine, aws_cdk_lib_aws_stepfunctions_CfnStateMachine_CloudWatchLogsLogGroupProperty, aws_cdk_lib_aws_stepfunctions_CfnStateMachine_LogDestinationProperty, aws_cdk_lib_aws_stepfunctions_CfnStateMachine_LoggingConfigurationProperty, aws_cdk_lib_aws_stepfunctions_CfnStateMachine_S3LocationProperty, aws_cdk_lib_aws_stepfunctions_CfnStateMachine_TagsEntryProperty, aws_cdk_lib_aws_stepfunctions_CfnStateMachine_TracingConfigurationProperty, aws_cdk_lib_aws_stepfunctions_tasks_LambdaInvokeProps, aws_cdk_lib_aws_stepfunctions_tasks_LambdaInvoke, aws_cdk_lib_aws_stepfunctions_tasks_LambdaInvocationType, aws_cdk_lib_aws_stepfunctions_tasks_CommonEcsRunTaskProps, aws_cdk_lib_aws_stepfunctions_tasks_ContainerOverride, aws_cdk_lib_aws_stepfunctions_tasks_TaskEnvironmentVariable, aws_cdk_lib_aws_stepfunctions_tasks_MessageAttributeDataType, aws_cdk_lib_aws_stepfunctions_tasks_MessageAttribute, aws_cdk_lib_aws_stepfunctions_tasks_SnsPublishProps, aws_cdk_lib_aws_stepfunctions_tasks_SnsPublish, aws_cdk_lib_aws_stepfunctions_tasks_SqsSendMessageProps, aws_cdk_lib_aws_stepfunctions_tasks_SqsSendMessage, aws_cdk_lib_aws_stepfunctions_tasks_EcsRunTaskProps, aws_cdk_lib_aws_stepfunctions_tasks_IEcsLaunchTarget, aws_cdk_lib_aws_stepfunctions_tasks_LaunchTargetBindOptions, aws_cdk_lib_aws_stepfunctions_tasks_EcsLaunchTargetConfig, aws_cdk_lib_aws_stepfunctions_tasks_EcsFargateLaunchTargetOptions, aws_cdk_lib_aws_stepfunctions_tasks_EcsEc2LaunchTargetOptions, aws_cdk_lib_aws_stepfunctions_tasks_EcsFargateLaunchTarget, aws_cdk_lib_aws_stepfunctions_tasks_EcsEc2LaunchTarget, aws_cdk_lib_aws_stepfunctions_tasks_EcsRunTask, aws_cdk_lib_aws_stepfunctions_tasks_ISageMakerTask, aws_cdk_lib_aws_stepfunctions_tasks_AlgorithmSpecification, aws_cdk_lib_aws_stepfunctions_tasks_Channel, aws_cdk_lib_aws_stepfunctions_tasks_ShuffleConfig, aws_cdk_lib_aws_stepfunctions_tasks_DataSource, aws_cdk_lib_aws_stepfunctions_tasks_S3DataSource, aws_cdk_lib_aws_stepfunctions_tasks_OutputDataConfig, aws_cdk_lib_aws_stepfunctions_tasks_StoppingCondition, aws_cdk_lib_aws_stepfunctions_tasks_ResourceConfig, aws_cdk_lib_aws_stepfunctions_tasks_VpcConfig, aws_cdk_lib_aws_stepfunctions_tasks_MetricDefinition, aws_cdk_lib_aws_stepfunctions_tasks_S3LocationConfig, aws_cdk_lib_aws_stepfunctions_tasks_S3Location, aws_cdk_lib_aws_stepfunctions_tasks_S3LocationBindOptions, aws_cdk_lib_aws_stepfunctions_tasks_DockerImageConfig, aws_cdk_lib_aws_stepfunctions_tasks_DockerImage, aws_cdk_lib_aws_stepfunctions_tasks_S3DataType, aws_cdk_lib_aws_stepfunctions_tasks_S3DataDistributionType, aws_cdk_lib_aws_stepfunctions_tasks_RecordWrapperType, aws_cdk_lib_aws_stepfunctions_tasks_InputMode, aws_cdk_lib_aws_stepfunctions_tasks_CompressionType, aws_cdk_lib_aws_stepfunctions_tasks_ModelClientOptions, aws_cdk_lib_aws_stepfunctions_tasks_TransformInput, aws_cdk_lib_aws_stepfunctions_tasks_TransformDataSource, aws_cdk_lib_aws_stepfunctions_tasks_TransformS3DataSource, aws_cdk_lib_aws_stepfunctions_tasks_TransformOutput, aws_cdk_lib_aws_stepfunctions_tasks_TransformResources, aws_cdk_lib_aws_stepfunctions_tasks_ContainerDefinitionOptions, aws_cdk_lib_aws_stepfunctions_tasks_ContainerDefinition, aws_cdk_lib_aws_stepfunctions_tasks_IContainerDefinition, aws_cdk_lib_aws_stepfunctions_tasks_ContainerDefinitionConfig, aws_cdk_lib_aws_stepfunctions_tasks_Mode, aws_cdk_lib_aws_stepfunctions_tasks_ProductionVariant, aws_cdk_lib_aws_stepfunctions_tasks_AcceleratorClass, aws_cdk_lib_aws_stepfunctions_tasks_AcceleratorType, aws_cdk_lib_aws_stepfunctions_tasks_BatchStrategy, aws_cdk_lib_aws_stepfunctions_tasks_SplitType, aws_cdk_lib_aws_stepfunctions_tasks_AssembleWith, aws_cdk_lib_aws_stepfunctions_tasks_SageMakerCreateTrainingJobProps, aws_cdk_lib_aws_stepfunctions_tasks_SageMakerCreateTrainingJob, aws_cdk_lib_aws_stepfunctions_tasks_SageMakerCreateTransformJobProps, aws_cdk_lib_aws_stepfunctions_tasks_SageMakerCreateTransformJob, aws_cdk_lib_aws_stepfunctions_tasks_SageMakerCreateEndpointProps, aws_cdk_lib_aws_stepfunctions_tasks_SageMakerCreateEndpoint, aws_cdk_lib_aws_stepfunctions_tasks_SageMakerCreateEndpointConfigProps, aws_cdk_lib_aws_stepfunctions_tasks_SageMakerCreateEndpointConfig, aws_cdk_lib_aws_stepfunctions_tasks_SageMakerCreateModelProps, aws_cdk_lib_aws_stepfunctions_tasks_SageMakerCreateModel, aws_cdk_lib_aws_stepfunctions_tasks_SageMakerUpdateEndpointProps, aws_cdk_lib_aws_stepfunctions_tasks_SageMakerUpdateEndpoint, aws_cdk_lib_aws_stepfunctions_tasks_StepFunctionsStartExecutionProps, aws_cdk_lib_aws_stepfunctions_tasks_StepFunctionsStartExecution, aws_cdk_lib_aws_stepfunctions_tasks_StepFunctionsInvokeActivityProps, aws_cdk_lib_aws_stepfunctions_tasks_StepFunctionsInvokeActivity, aws_cdk_lib_aws_stepfunctions_tasks_EvaluateExpressionProps, aws_cdk_lib_aws_stepfunctions_tasks_EvaluateExpression, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateClusterProps, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_EmrClusterScaleDownBehavior, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_InstanceRoleType, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_EbsBlockDeviceVolumeType, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_VolumeSpecificationProperty, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_EbsBlockDeviceConfigProperty, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_EbsConfigurationProperty, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_InstanceTypeConfigProperty, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_SpotTimeoutAction, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_SpotAllocationStrategy, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_SpotProvisioningSpecificationProperty, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_InstanceFleetProvisioningSpecificationsProperty, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_InstanceFleetConfigProperty, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_CloudWatchAlarmComparisonOperator, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_CloudWatchAlarmStatistic, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_CloudWatchAlarmUnit, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_MetricDimensionProperty, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_CloudWatchAlarmDefinitionProperty, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_ScalingTriggerProperty, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_InstanceMarket, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_ScalingAdjustmentType, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_SimpleScalingPolicyConfigurationProperty, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_ScalingActionProperty, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_ScalingRuleProperty, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_ScalingConstraintsProperty, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_AutoScalingPolicyProperty, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_InstanceGroupConfigProperty, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_PlacementTypeProperty, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_InstancesConfigProperty, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_ApplicationConfigProperty, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_ScriptBootstrapActionConfigProperty, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_BootstrapActionConfigProperty, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_ConfigurationProperty, aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateCluster_KerberosAttributesProperty, aws_cdk_lib_aws_stepfunctions_tasks_EmrSetClusterTerminationProtectionProps, aws_cdk_lib_aws_stepfunctions_tasks_EmrSetClusterTerminationProtection, aws_cdk_lib_aws_stepfunctions_tasks_EmrTerminateClusterProps, aws_cdk_lib_aws_stepfunctions_tasks_EmrTerminateCluster, aws_cdk_lib_aws_stepfunctions_tasks_ActionOnFailure, aws_cdk_lib_aws_stepfunctions_tasks_EmrAddStepProps, aws_cdk_lib_aws_stepfunctions_tasks_EmrAddStep, aws_cdk_lib_aws_stepfunctions_tasks_EmrCancelStepProps, aws_cdk_lib_aws_stepfunctions_tasks_EmrCancelStep, aws_cdk_lib_aws_stepfunctions_tasks_EmrModifyInstanceFleetByNameProps, aws_cdk_lib_aws_stepfunctions_tasks_EmrModifyInstanceFleetByName, aws_cdk_lib_aws_stepfunctions_tasks_EmrModifyInstanceGroupByNameProps, aws_cdk_lib_aws_stepfunctions_tasks_EmrModifyInstanceGroupByName, aws_cdk_lib_aws_stepfunctions_tasks_EmrModifyInstanceGroupByName_InstanceResizePolicyProperty, aws_cdk_lib_aws_stepfunctions_tasks_EmrModifyInstanceGroupByName_ShrinkPolicyProperty, aws_cdk_lib_aws_stepfunctions_tasks_EmrModifyInstanceGroupByName_InstanceGroupModifyConfigProperty, aws_cdk_lib_aws_stepfunctions_tasks_EksClusterInput, aws_cdk_lib_aws_stepfunctions_tasks_EmrContainersCreateVirtualClusterProps, aws_cdk_lib_aws_stepfunctions_tasks_EmrContainersCreateVirtualCluster, aws_cdk_lib_aws_stepfunctions_tasks_EmrContainersDeleteVirtualClusterProps, aws_cdk_lib_aws_stepfunctions_tasks_EmrContainersDeleteVirtualCluster, aws_cdk_lib_aws_stepfunctions_tasks_EmrContainersStartJobRunProps, aws_cdk_lib_aws_stepfunctions_tasks_EmrContainersStartJobRun, aws_cdk_lib_aws_stepfunctions_tasks_SparkSubmitJobDriver, aws_cdk_lib_aws_stepfunctions_tasks_JobDriver, aws_cdk_lib_aws_stepfunctions_tasks_Classification, aws_cdk_lib_aws_stepfunctions_tasks_ApplicationConfiguration, aws_cdk_lib_aws_stepfunctions_tasks_Monitoring, aws_cdk_lib_aws_stepfunctions_tasks_ReleaseLabel, aws_cdk_lib_aws_stepfunctions_tasks_VirtualClusterInput, aws_cdk_lib_aws_stepfunctions_tasks_GlueStartJobRunProps, aws_cdk_lib_aws_stepfunctions_tasks_GlueStartJobRun, aws_cdk_lib_aws_stepfunctions_tasks_ContainerOverrides, aws_cdk_lib_aws_stepfunctions_tasks_JobDependency, aws_cdk_lib_aws_stepfunctions_tasks_BatchContainerOverrides, aws_cdk_lib_aws_stepfunctions_tasks_BatchJobDependency, aws_cdk_lib_aws_stepfunctions_tasks_BatchSubmitJobProps, aws_cdk_lib_aws_stepfunctions_tasks_BatchSubmitJob, aws_cdk_lib_aws_stepfunctions_tasks_DynamoGetItemProps, aws_cdk_lib_aws_stepfunctions_tasks_DynamoGetItem, aws_cdk_lib_aws_stepfunctions_tasks_DynamoPutItemProps, aws_cdk_lib_aws_stepfunctions_tasks_DynamoPutItem, aws_cdk_lib_aws_stepfunctions_tasks_DynamoUpdateItemProps, aws_cdk_lib_aws_stepfunctions_tasks_DynamoUpdateItem, aws_cdk_lib_aws_stepfunctions_tasks_DynamoDeleteItemProps, aws_cdk_lib_aws_stepfunctions_tasks_DynamoDeleteItem, aws_cdk_lib_aws_stepfunctions_tasks_DynamoConsumedCapacity, aws_cdk_lib_aws_stepfunctions_tasks_DynamoItemCollectionMetrics, aws_cdk_lib_aws_stepfunctions_tasks_DynamoReturnValues, aws_cdk_lib_aws_stepfunctions_tasks_DynamoProjectionExpression, aws_cdk_lib_aws_stepfunctions_tasks_DynamoAttributeValue, aws_cdk_lib_aws_stepfunctions_tasks_CodeBuildStartBuildProps, aws_cdk_lib_aws_stepfunctions_tasks_CodeBuildStartBuild, aws_cdk_lib_aws_stepfunctions_tasks_AthenaStartQueryExecutionProps, aws_cdk_lib_aws_stepfunctions_tasks_AthenaStartQueryExecution, aws_cdk_lib_aws_stepfunctions_tasks_ResultConfiguration, aws_cdk_lib_aws_stepfunctions_tasks_EncryptionConfiguration, aws_cdk_lib_aws_stepfunctions_tasks_EncryptionOption, aws_cdk_lib_aws_stepfunctions_tasks_QueryExecutionContext, aws_cdk_lib_aws_stepfunctions_tasks_AthenaStopQueryExecutionProps, aws_cdk_lib_aws_stepfunctions_tasks_AthenaStopQueryExecution, aws_cdk_lib_aws_stepfunctions_tasks_AthenaGetQueryExecutionProps, aws_cdk_lib_aws_stepfunctions_tasks_AthenaGetQueryExecution, aws_cdk_lib_aws_stepfunctions_tasks_AthenaGetQueryResultsProps, aws_cdk_lib_aws_stepfunctions_tasks_AthenaGetQueryResults, aws_cdk_lib_aws_stepfunctions_tasks_GlueDataBrewStartJobRunProps, aws_cdk_lib_aws_stepfunctions_tasks_GlueDataBrewStartJobRun, aws_cdk_lib_aws_stepfunctions_tasks_EksCallProps, aws_cdk_lib_aws_stepfunctions_tasks_EksCall, aws_cdk_lib_aws_stepfunctions_tasks_HttpMethods, aws_cdk_lib_aws_stepfunctions_tasks_HttpMethod, aws_cdk_lib_aws_stepfunctions_tasks_AuthType, aws_cdk_lib_aws_stepfunctions_tasks_CallApiGatewayEndpointBaseProps, aws_cdk_lib_aws_stepfunctions_tasks_CallApiGatewayRestApiEndpointProps, aws_cdk_lib_aws_stepfunctions_tasks_CallApiGatewayRestApiEndpoint, aws_cdk_lib_aws_stepfunctions_tasks_CallApiGatewayHttpApiEndpointProps, aws_cdk_lib_aws_stepfunctions_tasks_CallApiGatewayHttpApiEndpoint, aws_cdk_lib_aws_stepfunctions_tasks_EventBridgePutEventsEntry, aws_cdk_lib_aws_stepfunctions_tasks_EventBridgePutEventsProps, aws_cdk_lib_aws_stepfunctions_tasks_EventBridgePutEvents, aws_cdk_lib_aws_stepfunctions_tasks_CallAwsServiceProps, aws_cdk_lib_aws_stepfunctions_tasks_CallAwsService, aws_cdk_lib_aws_supportapp_CfnAccountAliasProps, aws_cdk_lib_aws_supportapp_CfnAccountAlias, aws_cdk_lib_aws_supportapp_CfnSlackChannelConfigurationProps, aws_cdk_lib_aws_supportapp_CfnSlackChannelConfiguration, aws_cdk_lib_aws_supportapp_CfnSlackWorkspaceConfigurationProps, aws_cdk_lib_aws_supportapp_CfnSlackWorkspaceConfiguration, aws_cdk_lib_aws_synthetics_CfnCanaryProps, aws_cdk_lib_aws_synthetics_CfnCanary, aws_cdk_lib_aws_synthetics_CfnCanary_ArtifactConfigProperty, aws_cdk_lib_aws_synthetics_CfnCanary_BaseScreenshotProperty, aws_cdk_lib_aws_synthetics_CfnCanary_CodeProperty, aws_cdk_lib_aws_synthetics_CfnCanary_RunConfigProperty, aws_cdk_lib_aws_synthetics_CfnCanary_S3EncryptionProperty, aws_cdk_lib_aws_synthetics_CfnCanary_ScheduleProperty, aws_cdk_lib_aws_synthetics_CfnCanary_VPCConfigProperty, aws_cdk_lib_aws_synthetics_CfnCanary_VisualReferenceProperty, aws_cdk_lib_aws_synthetics_CfnGroupProps, aws_cdk_lib_aws_synthetics_CfnGroup, aws_cdk_lib_aws_systemsmanagersap_CfnApplicationProps, aws_cdk_lib_aws_systemsmanagersap_CfnApplication, aws_cdk_lib_aws_systemsmanagersap_CfnApplication_CredentialProperty, aws_cdk_lib_aws_timestream_CfnDatabaseProps, aws_cdk_lib_aws_timestream_CfnDatabase, aws_cdk_lib_aws_timestream_CfnScheduledQueryProps, aws_cdk_lib_aws_timestream_CfnScheduledQuery, aws_cdk_lib_aws_timestream_CfnScheduledQuery_DimensionMappingProperty, aws_cdk_lib_aws_timestream_CfnScheduledQuery_ErrorReportConfigurationProperty, aws_cdk_lib_aws_timestream_CfnScheduledQuery_MixedMeasureMappingProperty, aws_cdk_lib_aws_timestream_CfnScheduledQuery_MultiMeasureAttributeMappingProperty, aws_cdk_lib_aws_timestream_CfnScheduledQuery_MultiMeasureMappingsProperty, aws_cdk_lib_aws_timestream_CfnScheduledQuery_NotificationConfigurationProperty, aws_cdk_lib_aws_timestream_CfnScheduledQuery_S3ConfigurationProperty, aws_cdk_lib_aws_timestream_CfnScheduledQuery_ScheduleConfigurationProperty, aws_cdk_lib_aws_timestream_CfnScheduledQuery_SnsConfigurationProperty, aws_cdk_lib_aws_timestream_CfnScheduledQuery_TargetConfigurationProperty, aws_cdk_lib_aws_timestream_CfnScheduledQuery_TimestreamConfigurationProperty, aws_cdk_lib_aws_timestream_CfnTableProps, aws_cdk_lib_aws_timestream_CfnTable, aws_cdk_lib_aws_timestream_CfnTable_MagneticStoreRejectedDataLocationProperty, aws_cdk_lib_aws_timestream_CfnTable_MagneticStoreWritePropertiesProperty, aws_cdk_lib_aws_timestream_CfnTable_RetentionPropertiesProperty, aws_cdk_lib_aws_timestream_CfnTable_S3ConfigurationProperty, aws_cdk_lib_aws_transfer_CfnAgreementProps, aws_cdk_lib_aws_transfer_CfnAgreement, aws_cdk_lib_aws_transfer_CfnCertificateProps, aws_cdk_lib_aws_transfer_CfnCertificate, aws_cdk_lib_aws_transfer_CfnConnectorProps, aws_cdk_lib_aws_transfer_CfnConnector, aws_cdk_lib_aws_transfer_CfnConnector_As2ConfigProperty, aws_cdk_lib_aws_transfer_CfnProfileProps, aws_cdk_lib_aws_transfer_CfnProfile, aws_cdk_lib_aws_transfer_CfnServerProps, aws_cdk_lib_aws_transfer_CfnServer, aws_cdk_lib_aws_transfer_CfnServer_EndpointDetailsProperty, aws_cdk_lib_aws_transfer_CfnServer_IdentityProviderDetailsProperty, aws_cdk_lib_aws_transfer_CfnServer_ProtocolDetailsProperty, aws_cdk_lib_aws_transfer_CfnServer_WorkflowDetailProperty, aws_cdk_lib_aws_transfer_CfnServer_WorkflowDetailsProperty, aws_cdk_lib_aws_transfer_CfnUserProps, aws_cdk_lib_aws_transfer_CfnUser, aws_cdk_lib_aws_transfer_CfnUser_HomeDirectoryMapEntryProperty, aws_cdk_lib_aws_transfer_CfnUser_PosixProfileProperty, aws_cdk_lib_aws_transfer_CfnWorkflowProps, aws_cdk_lib_aws_transfer_CfnWorkflow, aws_cdk_lib_aws_transfer_CfnWorkflow_CopyStepDetailsProperty, aws_cdk_lib_aws_transfer_CfnWorkflow_CustomStepDetailsProperty, aws_cdk_lib_aws_transfer_CfnWorkflow_DecryptStepDetailsProperty, aws_cdk_lib_aws_transfer_CfnWorkflow_DeleteStepDetailsProperty, aws_cdk_lib_aws_transfer_CfnWorkflow_EfsInputFileLocationProperty, aws_cdk_lib_aws_transfer_CfnWorkflow_InputFileLocationProperty, aws_cdk_lib_aws_transfer_CfnWorkflow_S3FileLocationProperty, aws_cdk_lib_aws_transfer_CfnWorkflow_S3InputFileLocationProperty, aws_cdk_lib_aws_transfer_CfnWorkflow_S3TagProperty, aws_cdk_lib_aws_transfer_CfnWorkflow_TagStepDetailsProperty, aws_cdk_lib_aws_transfer_CfnWorkflow_WorkflowStepProperty, aws_cdk_lib_aws_voiceid_CfnDomainProps, aws_cdk_lib_aws_voiceid_CfnDomain, aws_cdk_lib_aws_voiceid_CfnDomain_ServerSideEncryptionConfigurationProperty, aws_cdk_lib_aws_vpclattice_CfnAccessLogSubscriptionProps, aws_cdk_lib_aws_vpclattice_CfnAccessLogSubscription, aws_cdk_lib_aws_vpclattice_CfnAuthPolicyProps, aws_cdk_lib_aws_vpclattice_CfnAuthPolicy, aws_cdk_lib_aws_vpclattice_CfnListenerProps, aws_cdk_lib_aws_vpclattice_CfnListener, aws_cdk_lib_aws_vpclattice_CfnListener_DefaultActionProperty, aws_cdk_lib_aws_vpclattice_CfnListener_FixedResponseProperty, aws_cdk_lib_aws_vpclattice_CfnListener_ForwardProperty, aws_cdk_lib_aws_vpclattice_CfnListener_WeightedTargetGroupProperty, aws_cdk_lib_aws_vpclattice_CfnResourcePolicyProps, aws_cdk_lib_aws_vpclattice_CfnResourcePolicy, aws_cdk_lib_aws_vpclattice_CfnRuleProps, aws_cdk_lib_aws_vpclattice_CfnRule, aws_cdk_lib_aws_vpclattice_CfnRule_ActionProperty, aws_cdk_lib_aws_vpclattice_CfnRule_FixedResponseProperty, aws_cdk_lib_aws_vpclattice_CfnRule_ForwardProperty, aws_cdk_lib_aws_vpclattice_CfnRule_HeaderMatchProperty, aws_cdk_lib_aws_vpclattice_CfnRule_HeaderMatchTypeProperty, aws_cdk_lib_aws_vpclattice_CfnRule_HttpMatchProperty, aws_cdk_lib_aws_vpclattice_CfnRule_MatchProperty, aws_cdk_lib_aws_vpclattice_CfnRule_PathMatchProperty, aws_cdk_lib_aws_vpclattice_CfnRule_PathMatchTypeProperty, aws_cdk_lib_aws_vpclattice_CfnRule_WeightedTargetGroupProperty, aws_cdk_lib_aws_vpclattice_CfnServiceProps, aws_cdk_lib_aws_vpclattice_CfnService, aws_cdk_lib_aws_vpclattice_CfnService_DnsEntryProperty, aws_cdk_lib_aws_vpclattice_CfnServiceNetworkProps, aws_cdk_lib_aws_vpclattice_CfnServiceNetwork, aws_cdk_lib_aws_vpclattice_CfnServiceNetworkServiceAssociationProps, aws_cdk_lib_aws_vpclattice_CfnServiceNetworkServiceAssociation, aws_cdk_lib_aws_vpclattice_CfnServiceNetworkServiceAssociation_DnsEntryProperty, aws_cdk_lib_aws_vpclattice_CfnServiceNetworkVpcAssociationProps, aws_cdk_lib_aws_vpclattice_CfnServiceNetworkVpcAssociation, aws_cdk_lib_aws_vpclattice_CfnTargetGroupProps, aws_cdk_lib_aws_vpclattice_CfnTargetGroup, aws_cdk_lib_aws_vpclattice_CfnTargetGroup_HealthCheckConfigProperty, aws_cdk_lib_aws_vpclattice_CfnTargetGroup_MatcherProperty, aws_cdk_lib_aws_vpclattice_CfnTargetGroup_TargetProperty, aws_cdk_lib_aws_vpclattice_CfnTargetGroup_TargetGroupConfigProperty, aws_cdk_lib_aws_waf_CfnByteMatchSetProps, aws_cdk_lib_aws_waf_CfnByteMatchSet, aws_cdk_lib_aws_waf_CfnByteMatchSet_ByteMatchTupleProperty, aws_cdk_lib_aws_waf_CfnByteMatchSet_FieldToMatchProperty, aws_cdk_lib_aws_waf_CfnIPSetProps, aws_cdk_lib_aws_waf_CfnIPSet, aws_cdk_lib_aws_waf_CfnIPSet_IPSetDescriptorProperty, aws_cdk_lib_aws_waf_CfnRuleProps, aws_cdk_lib_aws_waf_CfnRule, aws_cdk_lib_aws_waf_CfnRule_PredicateProperty, aws_cdk_lib_aws_waf_CfnSizeConstraintSetProps, aws_cdk_lib_aws_waf_CfnSizeConstraintSet, aws_cdk_lib_aws_waf_CfnSizeConstraintSet_FieldToMatchProperty, aws_cdk_lib_aws_waf_CfnSizeConstraintSet_SizeConstraintProperty, aws_cdk_lib_aws_waf_CfnSqlInjectionMatchSetProps, aws_cdk_lib_aws_waf_CfnSqlInjectionMatchSet, aws_cdk_lib_aws_waf_CfnSqlInjectionMatchSet_FieldToMatchProperty, aws_cdk_lib_aws_waf_CfnSqlInjectionMatchSet_SqlInjectionMatchTupleProperty, aws_cdk_lib_aws_waf_CfnWebACLProps, aws_cdk_lib_aws_waf_CfnWebACL, aws_cdk_lib_aws_waf_CfnWebACL_ActivatedRuleProperty, aws_cdk_lib_aws_waf_CfnWebACL_WafActionProperty, aws_cdk_lib_aws_waf_CfnXssMatchSetProps, aws_cdk_lib_aws_waf_CfnXssMatchSet, aws_cdk_lib_aws_waf_CfnXssMatchSet_FieldToMatchProperty, aws_cdk_lib_aws_waf_CfnXssMatchSet_XssMatchTupleProperty, aws_cdk_lib_aws_wafregional_CfnByteMatchSetProps, aws_cdk_lib_aws_wafregional_CfnByteMatchSet, aws_cdk_lib_aws_wafregional_CfnByteMatchSet_ByteMatchTupleProperty, aws_cdk_lib_aws_wafregional_CfnByteMatchSet_FieldToMatchProperty, aws_cdk_lib_aws_wafregional_CfnGeoMatchSetProps, aws_cdk_lib_aws_wafregional_CfnGeoMatchSet, aws_cdk_lib_aws_wafregional_CfnGeoMatchSet_GeoMatchConstraintProperty, aws_cdk_lib_aws_wafregional_CfnIPSetProps, aws_cdk_lib_aws_wafregional_CfnIPSet, aws_cdk_lib_aws_wafregional_CfnIPSet_IPSetDescriptorProperty, aws_cdk_lib_aws_wafregional_CfnRateBasedRuleProps, aws_cdk_lib_aws_wafregional_CfnRateBasedRule, aws_cdk_lib_aws_wafregional_CfnRateBasedRule_PredicateProperty, aws_cdk_lib_aws_wafregional_CfnRegexPatternSetProps, aws_cdk_lib_aws_wafregional_CfnRegexPatternSet, aws_cdk_lib_aws_wafregional_CfnRuleProps, aws_cdk_lib_aws_wafregional_CfnRule, aws_cdk_lib_aws_wafregional_CfnRule_PredicateProperty, aws_cdk_lib_aws_wafregional_CfnSizeConstraintSetProps, aws_cdk_lib_aws_wafregional_CfnSizeConstraintSet, aws_cdk_lib_aws_wafregional_CfnSizeConstraintSet_FieldToMatchProperty, aws_cdk_lib_aws_wafregional_CfnSizeConstraintSet_SizeConstraintProperty, aws_cdk_lib_aws_wafregional_CfnSqlInjectionMatchSetProps, aws_cdk_lib_aws_wafregional_CfnSqlInjectionMatchSet, aws_cdk_lib_aws_wafregional_CfnSqlInjectionMatchSet_FieldToMatchProperty, aws_cdk_lib_aws_wafregional_CfnSqlInjectionMatchSet_SqlInjectionMatchTupleProperty, aws_cdk_lib_aws_wafregional_CfnWebACLProps, aws_cdk_lib_aws_wafregional_CfnWebACL, aws_cdk_lib_aws_wafregional_CfnWebACL_ActionProperty, aws_cdk_lib_aws_wafregional_CfnWebACL_RuleProperty, aws_cdk_lib_aws_wafregional_CfnWebACLAssociationProps, aws_cdk_lib_aws_wafregional_CfnWebACLAssociation, aws_cdk_lib_aws_wafregional_CfnXssMatchSetProps, aws_cdk_lib_aws_wafregional_CfnXssMatchSet, aws_cdk_lib_aws_wafregional_CfnXssMatchSet_FieldToMatchProperty, aws_cdk_lib_aws_wafregional_CfnXssMatchSet_XssMatchTupleProperty, aws_cdk_lib_aws_wafv2_CfnIPSetProps, aws_cdk_lib_aws_wafv2_CfnIPSet, aws_cdk_lib_aws_wafv2_CfnLoggingConfigurationProps, aws_cdk_lib_aws_wafv2_CfnLoggingConfiguration, aws_cdk_lib_aws_wafv2_CfnLoggingConfiguration_ActionConditionProperty, aws_cdk_lib_aws_wafv2_CfnLoggingConfiguration_ConditionProperty, aws_cdk_lib_aws_wafv2_CfnLoggingConfiguration_FieldToMatchProperty, aws_cdk_lib_aws_wafv2_CfnLoggingConfiguration_FilterProperty, aws_cdk_lib_aws_wafv2_CfnLoggingConfiguration_JsonBodyProperty, aws_cdk_lib_aws_wafv2_CfnLoggingConfiguration_LabelNameConditionProperty, aws_cdk_lib_aws_wafv2_CfnLoggingConfiguration_LoggingFilterProperty, aws_cdk_lib_aws_wafv2_CfnLoggingConfiguration_MatchPatternProperty, aws_cdk_lib_aws_wafv2_CfnLoggingConfiguration_SingleHeaderProperty, aws_cdk_lib_aws_wafv2_CfnRegexPatternSetProps, aws_cdk_lib_aws_wafv2_CfnRegexPatternSet, aws_cdk_lib_aws_wafv2_CfnRuleGroupProps, aws_cdk_lib_aws_wafv2_CfnRuleGroup, aws_cdk_lib_aws_wafv2_CfnRuleGroup_AllowProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_AndStatementProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_BlockProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_BodyProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_ByteMatchStatementProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_CaptchaProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_CaptchaConfigProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_ChallengeProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_ChallengeConfigProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_CookieMatchPatternProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_CookiesProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_CountProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_CustomHTTPHeaderProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_CustomRequestHandlingProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_CustomResponseProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_CustomResponseBodyProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_FieldToMatchProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_ForwardedIPConfigurationProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_GeoMatchStatementProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_HeaderMatchPatternProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_HeadersProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_IPSetForwardedIPConfigurationProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_IPSetReferenceStatementProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_ImmunityTimePropertyProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_JsonBodyProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_JsonMatchPatternProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_LabelProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_LabelMatchStatementProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_LabelSummaryProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_NotStatementProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_OrStatementProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_RateBasedStatementProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_RegexMatchStatementProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_RegexPatternSetReferenceStatementProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_RuleProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_RuleActionProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_SingleHeaderProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_SingleQueryArgumentProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_SizeConstraintStatementProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_SqliMatchStatementProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_StatementProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_TextTransformationProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_VisibilityConfigProperty, aws_cdk_lib_aws_wafv2_CfnRuleGroup_XssMatchStatementProperty, aws_cdk_lib_aws_wafv2_CfnWebACLProps, aws_cdk_lib_aws_wafv2_CfnWebACL, aws_cdk_lib_aws_wafv2_CfnWebACL_AWSManagedRulesATPRuleSetProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_AWSManagedRulesBotControlRuleSetProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_AllowActionProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_AndStatementProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_BlockActionProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_BodyProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_ByteMatchStatementProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_CaptchaActionProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_CaptchaConfigProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_ChallengeActionProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_ChallengeConfigProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_CookieMatchPatternProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_CookiesProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_CountActionProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_CustomHTTPHeaderProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_CustomRequestHandlingProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_CustomResponseProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_CustomResponseBodyProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_DefaultActionProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_ExcludedRuleProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_FieldIdentifierProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_FieldToMatchProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_ForwardedIPConfigurationProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_GeoMatchStatementProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_HeaderMatchPatternProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_HeadersProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_IPSetForwardedIPConfigurationProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_IPSetReferenceStatementProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_ImmunityTimePropertyProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_JsonBodyProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_JsonMatchPatternProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_LabelProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_LabelMatchStatementProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_ManagedRuleGroupConfigProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_ManagedRuleGroupStatementProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_NotStatementProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_OrStatementProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_OverrideActionProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_RateBasedStatementProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_RegexMatchStatementProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_RegexPatternSetReferenceStatementProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_RequestInspectionProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_ResponseInspectionProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_ResponseInspectionBodyContainsProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_ResponseInspectionHeaderProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_ResponseInspectionJsonProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_ResponseInspectionStatusCodeProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_RuleProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_RuleActionProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_RuleActionOverrideProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_RuleGroupReferenceStatementProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_SingleHeaderProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_SingleQueryArgumentProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_SizeConstraintStatementProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_SqliMatchStatementProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_StatementProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_TextTransformationProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_VisibilityConfigProperty, aws_cdk_lib_aws_wafv2_CfnWebACL_XssMatchStatementProperty, aws_cdk_lib_aws_wafv2_CfnWebACLAssociationProps, aws_cdk_lib_aws_wafv2_CfnWebACLAssociation, aws_cdk_lib_aws_wisdom_CfnAssistantProps, aws_cdk_lib_aws_wisdom_CfnAssistant, aws_cdk_lib_aws_wisdom_CfnAssistant_ServerSideEncryptionConfigurationProperty, aws_cdk_lib_aws_wisdom_CfnAssistantAssociationProps, aws_cdk_lib_aws_wisdom_CfnAssistantAssociation, aws_cdk_lib_aws_wisdom_CfnAssistantAssociation_AssociationDataProperty, aws_cdk_lib_aws_wisdom_CfnKnowledgeBaseProps, aws_cdk_lib_aws_wisdom_CfnKnowledgeBase, aws_cdk_lib_aws_wisdom_CfnKnowledgeBase_AppIntegrationsConfigurationProperty, aws_cdk_lib_aws_wisdom_CfnKnowledgeBase_RenderingConfigurationProperty, aws_cdk_lib_aws_wisdom_CfnKnowledgeBase_ServerSideEncryptionConfigurationProperty, aws_cdk_lib_aws_wisdom_CfnKnowledgeBase_SourceConfigurationProperty, aws_cdk_lib_aws_workspaces_CfnConnectionAliasProps, aws_cdk_lib_aws_workspaces_CfnConnectionAlias, aws_cdk_lib_aws_workspaces_CfnConnectionAlias_ConnectionAliasAssociationProperty, aws_cdk_lib_aws_workspaces_CfnWorkspaceProps, aws_cdk_lib_aws_workspaces_CfnWorkspace, aws_cdk_lib_aws_workspaces_CfnWorkspace_WorkspacePropertiesProperty, aws_cdk_lib_aws_xray_CfnGroupProps, aws_cdk_lib_aws_xray_CfnGroup, aws_cdk_lib_aws_xray_CfnGroup_InsightsConfigurationProperty, aws_cdk_lib_aws_xray_CfnGroup_TagsItemsProperty, aws_cdk_lib_aws_xray_CfnResourcePolicyProps, aws_cdk_lib_aws_xray_CfnResourcePolicy, aws_cdk_lib_aws_xray_CfnSamplingRuleProps, aws_cdk_lib_aws_xray_CfnSamplingRule, aws_cdk_lib_aws_xray_CfnSamplingRule_SamplingRuleProperty, aws_cdk_lib_aws_xray_CfnSamplingRule_SamplingRuleRecordProperty, aws_cdk_lib_aws_xray_CfnSamplingRule_SamplingRuleUpdateProperty, aws_cdk_lib_aws_xray_CfnSamplingRule_TagsItemsProperty, aws_cdk_lib_cloud_assembly_schema_ArtifactType, aws_cdk_lib_cloud_assembly_schema_RuntimeInfo, aws_cdk_lib_cloud_assembly_schema_MissingContext, aws_cdk_lib_cloud_assembly_schema_ArtifactManifest, aws_cdk_lib_cloud_assembly_schema_AssemblyManifest, aws_cdk_lib_cloud_assembly_schema_FileAssetMetadataEntry, aws_cdk_lib_cloud_assembly_schema_Tag, aws_cdk_lib_cloud_assembly_schema_ContainerImageAssetCacheOption, aws_cdk_lib_cloud_assembly_schema_ContainerImageAssetMetadataEntry, aws_cdk_lib_cloud_assembly_schema_ArtifactMetadataEntryType, aws_cdk_lib_cloud_assembly_schema_MetadataEntry, aws_cdk_lib_cloud_assembly_schema_BootstrapRole, aws_cdk_lib_cloud_assembly_schema_AwsCloudFormationStackProperties, aws_cdk_lib_cloud_assembly_schema_AssetManifestOptions, aws_cdk_lib_cloud_assembly_schema_AssetManifestProperties, aws_cdk_lib_cloud_assembly_schema_TreeArtifactProperties, aws_cdk_lib_cloud_assembly_schema_NestedCloudAssemblyProperties, aws_cdk_lib_cloud_assembly_schema_ContextProvider, aws_cdk_lib_cloud_assembly_schema_AmiContextQuery, aws_cdk_lib_cloud_assembly_schema_AvailabilityZonesContextQuery, aws_cdk_lib_cloud_assembly_schema_HostedZoneContextQuery, aws_cdk_lib_cloud_assembly_schema_SSMParameterContextQuery, aws_cdk_lib_cloud_assembly_schema_VpcContextQuery, aws_cdk_lib_cloud_assembly_schema_EndpointServiceAvailabilityZonesContextQuery, aws_cdk_lib_cloud_assembly_schema_LoadBalancerType, aws_cdk_lib_cloud_assembly_schema_LoadBalancerFilter, aws_cdk_lib_cloud_assembly_schema_LoadBalancerContextQuery, aws_cdk_lib_cloud_assembly_schema_LoadBalancerListenerProtocol, aws_cdk_lib_cloud_assembly_schema_LoadBalancerListenerContextQuery, aws_cdk_lib_cloud_assembly_schema_SecurityGroupContextQuery, aws_cdk_lib_cloud_assembly_schema_KeyContextQuery, aws_cdk_lib_cloud_assembly_schema_PluginContextQuery, aws_cdk_lib_cloud_assembly_schema_AssetManifest, aws_cdk_lib_cloud_assembly_schema_DockerImageAsset, aws_cdk_lib_cloud_assembly_schema_DockerImageSource, aws_cdk_lib_cloud_assembly_schema_DockerImageDestination, aws_cdk_lib_cloud_assembly_schema_DockerCacheOption, aws_cdk_lib_cloud_assembly_schema_FileAsset, aws_cdk_lib_cloud_assembly_schema_FileAssetPackaging, aws_cdk_lib_cloud_assembly_schema_FileSource, aws_cdk_lib_cloud_assembly_schema_FileDestination, aws_cdk_lib_cloud_assembly_schema_AwsDestination, aws_cdk_lib_cloud_assembly_schema_LoadManifestOptions, aws_cdk_lib_cloud_assembly_schema_Manifest, aws_cdk_lib_cloud_assembly_schema_IntegManifest, aws_cdk_lib_cloud_assembly_schema_RequireApproval, aws_cdk_lib_cloud_assembly_schema_DefaultCdkOptions, aws_cdk_lib_cloud_assembly_schema_DeployOptions, aws_cdk_lib_cloud_assembly_schema_DestroyOptions, aws_cdk_lib_cloud_assembly_schema_TestOptions, aws_cdk_lib_cloud_assembly_schema_TestCase, aws_cdk_lib_cloud_assembly_schema_Hooks, aws_cdk_lib_cloud_assembly_schema_CdkCommand, aws_cdk_lib_cloud_assembly_schema_DeployCommand, aws_cdk_lib_cloud_assembly_schema_DestroyCommand, aws_cdk_lib_cloud_assembly_schema_CdkCommands, aws_cdk_lib_cloudformation_include_CfnIncludeProps, aws_cdk_lib_cloudformation_include_IncludedNestedStack, aws_cdk_lib_cloudformation_include_CfnInclude, aws_cdk_lib_custom_resources_PhysicalResourceIdReference, aws_cdk_lib_custom_resources_PhysicalResourceId, aws_cdk_lib_custom_resources_AwsSdkCall, aws_cdk_lib_custom_resources_SdkCallsPolicyOptions, aws_cdk_lib_custom_resources_AwsCustomResourcePolicy, aws_cdk_lib_custom_resources_AwsCustomResourceProps, aws_cdk_lib_custom_resources_AwsCustomResource, aws_cdk_lib_custom_resources_ProviderProps, aws_cdk_lib_custom_resources_Provider, aws_cdk_lib_cx_api_VpcSubnetGroupType, aws_cdk_lib_cx_api_VpcSubnet, aws_cdk_lib_cx_api_VpcSubnetGroup, aws_cdk_lib_cx_api_VpcContextResponse, aws_cdk_lib_cx_api_LoadBalancerIpAddressType, aws_cdk_lib_cx_api_LoadBalancerContextResponse, aws_cdk_lib_cx_api_LoadBalancerListenerContextResponse, aws_cdk_lib_cx_api_EndpointServiceAvailabilityZonesContextQuery, aws_cdk_lib_cx_api_SecurityGroupContextResponse, aws_cdk_lib_cx_api_KeyContextResponse, aws_cdk_lib_cx_api_AwsCloudFormationStackProperties, aws_cdk_lib_cx_api_CloudArtifact, aws_cdk_lib_cx_api_AssetManifestArtifact, aws_cdk_lib_cx_api_CloudFormationStackArtifact, aws_cdk_lib_cx_api_TreeCloudArtifact, aws_cdk_lib_cx_api_NestedCloudAssemblyArtifact, aws_cdk_lib_cx_api_CloudAssembly, aws_cdk_lib_cx_api_CloudAssemblyBuilderProps, aws_cdk_lib_cx_api_CloudAssemblyBuilder, aws_cdk_lib_cx_api_AssemblyBuildOptions, aws_cdk_lib_cx_api_Environment, aws_cdk_lib_cx_api_EnvironmentUtils, aws_cdk_lib_cx_api_SynthesisMessageLevel, aws_cdk_lib_cx_api_MetadataEntryResult, aws_cdk_lib_cx_api_SynthesisMessage, aws_cdk_lib_cx_api_EnvironmentPlaceholders, aws_cdk_lib_cx_api_EnvironmentPlaceholderValues, aws_cdk_lib_cx_api_IEnvironmentPlaceholderProvider, aws_cdk_lib_lambda_layer_awscli_AwsCliLayer, aws_cdk_lib_lambda_layer_kubectl_KubectlLayer, aws_cdk_lib_lambda_layer_node_proxy_agent_NodeProxyAgentLayer, aws_cdk_lib_pipelines_AssetType, aws_cdk_lib_pipelines_FileSet, aws_cdk_lib_pipelines_IFileSetProducer, aws_cdk_lib_pipelines_ShellStepProps, aws_cdk_lib_pipelines_ShellStep, aws_cdk_lib_pipelines_FileSetLocation, aws_cdk_lib_pipelines_StackOutputReference, aws_cdk_lib_pipelines_StackDeploymentProps, aws_cdk_lib_pipelines_StackDeployment, aws_cdk_lib_pipelines_StackAsset, aws_cdk_lib_pipelines_StageDeploymentProps, aws_cdk_lib_pipelines_StageDeployment, aws_cdk_lib_pipelines_Step, aws_cdk_lib_pipelines_StackSteps, aws_cdk_lib_pipelines_WaveProps, aws_cdk_lib_pipelines_Wave, aws_cdk_lib_pipelines_AddStageOpts, aws_cdk_lib_pipelines_WaveOptions, aws_cdk_lib_pipelines_ManualApprovalStepProps, aws_cdk_lib_pipelines_ManualApprovalStep, aws_cdk_lib_pipelines_ArtifactMap, aws_cdk_lib_pipelines_CodePipelineFileSet, aws_cdk_lib_pipelines_CodeBuildStepProps, aws_cdk_lib_pipelines_CodeBuildStep, aws_cdk_lib_pipelines_PermissionsBroadeningCheckProps, aws_cdk_lib_pipelines_ConfirmPermissionsBroadening, aws_cdk_lib_pipelines_CodePipelineProps, aws_cdk_lib_pipelines_CodeBuildOptions, aws_cdk_lib_pipelines_CodePipeline, aws_cdk_lib_pipelines_ProduceActionOptions, aws_cdk_lib_pipelines_ICodePipelineActionFactory, aws_cdk_lib_pipelines_CodePipelineActionFactoryResult, aws_cdk_lib_pipelines_CodePipelineSource, aws_cdk_lib_pipelines_GitHubSourceOptions, aws_cdk_lib_pipelines_S3SourceOptions, aws_cdk_lib_pipelines_ECRSourceOptions, aws_cdk_lib_pipelines_ConnectionSourceOptions, aws_cdk_lib_pipelines_CodeCommitSourceOptions, aws_cdk_lib_pipelines_StackOutputsMap, aws_cdk_lib_pipelines_PipelineBaseProps, aws_cdk_lib_pipelines_PipelineBase, aws_cdk_lib_pipelines_DockerCredential, aws_cdk_lib_pipelines_ExternalDockerCredentialOptions, aws_cdk_lib_pipelines_EcrDockerCredentialOptions, aws_cdk_lib_pipelines_DockerCredentialUsage, aws_cdk_lib_region_info_Default, aws_cdk_lib_region_info_Fact, aws_cdk_lib_region_info_IFact, aws_cdk_lib_region_info_FactName, aws_cdk_lib_region_info_RegionInfo, aws_cdk_lib_triggers_ITrigger, aws_cdk_lib_triggers_TriggerOptions, aws_cdk_lib_triggers_InvocationType, aws_cdk_lib_triggers_TriggerProps, aws_cdk_lib_triggers_Trigger, aws_cdk_lib_triggers_TriggerInvalidation, aws_cdk_lib_triggers_TriggerFunctionProps, aws_cdk_lib_triggers_TriggerFunction, aws_cdk_lib_IAspect, aws_cdk_lib_Aspects, aws_cdk_lib_TagProps, aws_cdk_lib_Tag, aws_cdk_lib_Tags, aws_cdk_lib_RemoveTag, aws_cdk_lib_TokenComparison, aws_cdk_lib_Token, aws_cdk_lib_Tokenization, aws_cdk_lib_JsonNull, aws_cdk_lib_ReverseOptions, aws_cdk_lib_ResolveOptions, aws_cdk_lib_EncodingOptions, aws_cdk_lib_IResolveContext, aws_cdk_lib_ResolveChangeContextOptions, aws_cdk_lib_IResolvable, aws_cdk_lib_IPostProcessor, aws_cdk_lib_ITokenResolver, aws_cdk_lib_IFragmentConcatenator, aws_cdk_lib_StringConcat, aws_cdk_lib_DefaultTokenResolver, aws_cdk_lib_ResolutionTypeHint, aws_cdk_lib_IStringProducer, aws_cdk_lib_IStableStringProducer, aws_cdk_lib_IListProducer, aws_cdk_lib_IStableListProducer, aws_cdk_lib_INumberProducer, aws_cdk_lib_IStableNumberProducer, aws_cdk_lib_IAnyProducer, aws_cdk_lib_IStableAnyProducer, aws_cdk_lib_LazyStringValueOptions, aws_cdk_lib_LazyListValueOptions, aws_cdk_lib_LazyAnyValueOptions, aws_cdk_lib_Lazy, aws_cdk_lib_ITaggable, aws_cdk_lib_TagManagerOptions, aws_cdk_lib_TagManager, aws_cdk_lib_TokenizedStringFragments, aws_cdk_lib_ITokenMapper, aws_cdk_lib_IStackSynthesizer, aws_cdk_lib_IReusableStackSynthesizer, aws_cdk_lib_IBoundStackSynthesizer, aws_cdk_lib_ISynthesisSession, aws_cdk_lib_DefaultStackSynthesizerProps, aws_cdk_lib_DefaultStackSynthesizer, aws_cdk_lib_LegacyStackSynthesizer, aws_cdk_lib_BootstraplessSynthesizerProps, aws_cdk_lib_BootstraplessSynthesizer, aws_cdk_lib_NestedStackSynthesizer, aws_cdk_lib_StackSynthesizer, aws_cdk_lib_SynthesizeStackArtifactOptions, aws_cdk_lib_CliCredentialsStackSynthesizerProps, aws_cdk_lib_CliCredentialsStackSynthesizer, aws_cdk_lib_AssetManifestBuilder, aws_cdk_lib_AssetManifestFileDestination, aws_cdk_lib_AssetManifestDockerImageDestination, aws_cdk_lib_RoleOptions, aws_cdk_lib_Reference, aws_cdk_lib_CfnConditionProps, aws_cdk_lib_CfnCondition, aws_cdk_lib_ICfnConditionExpression, aws_cdk_lib_ICfnRuleConditionExpression, aws_cdk_lib_Fn, aws_cdk_lib_CfnHookProps, aws_cdk_lib_CfnHook, aws_cdk_lib_CfnTrafficRoutingType, aws_cdk_lib_CfnTrafficRoutingTimeBasedCanary, aws_cdk_lib_CfnTrafficRoutingTimeBasedLinear, aws_cdk_lib_CfnTrafficRoutingConfig, aws_cdk_lib_CfnCodeDeployBlueGreenAdditionalOptions, aws_cdk_lib_CfnCodeDeployBlueGreenLifecycleEventHooks, aws_cdk_lib_CfnCodeDeployBlueGreenApplicationTarget, aws_cdk_lib_CfnTrafficRoute, aws_cdk_lib_CfnTrafficRouting, aws_cdk_lib_CfnCodeDeployBlueGreenEcsAttributes, aws_cdk_lib_CfnCodeDeployBlueGreenApplication, aws_cdk_lib_CfnCodeDeployBlueGreenHookProps, aws_cdk_lib_CfnCodeDeployBlueGreenHook, aws_cdk_lib_CfnMappingProps, aws_cdk_lib_CfnMapping, aws_cdk_lib_CfnOutputProps, aws_cdk_lib_CfnOutput, aws_cdk_lib_CfnParameterProps, aws_cdk_lib_CfnParameter, aws_cdk_lib_Aws, aws_cdk_lib_ScopedAws, aws_cdk_lib_CfnResourceProps, aws_cdk_lib_CfnResource, aws_cdk_lib_TagType, aws_cdk_lib_ICfnResourceOptions, aws_cdk_lib_CfnCreationPolicy, aws_cdk_lib_CfnResourceAutoScalingCreationPolicy, aws_cdk_lib_CfnResourceSignal, aws_cdk_lib_CfnDeletionPolicy, aws_cdk_lib_CfnUpdatePolicy, aws_cdk_lib_CfnAutoScalingRollingUpdate, aws_cdk_lib_CfnAutoScalingReplacingUpdate, aws_cdk_lib_CfnAutoScalingScheduledAction, aws_cdk_lib_CfnCodeDeployLambdaAliasUpdate, aws_cdk_lib_CfnRuleProps, aws_cdk_lib_CfnRule, aws_cdk_lib_CfnRuleAssertion, aws_cdk_lib_StackProps, aws_cdk_lib_Stack, aws_cdk_lib_ITemplateOptions, aws_cdk_lib_ExportValueOptions, aws_cdk_lib_StageProps, aws_cdk_lib_Stage, aws_cdk_lib_StageSynthesisOptions, aws_cdk_lib_CfnElement, aws_cdk_lib_CfnRefElement, aws_cdk_lib_CfnDynamicReferenceProps, aws_cdk_lib_CfnDynamicReference, aws_cdk_lib_CfnDynamicReferenceService, aws_cdk_lib_CfnTag, aws_cdk_lib_CfnJsonProps, aws_cdk_lib_CfnJson, aws_cdk_lib_RemovalPolicy, aws_cdk_lib_RemovalPolicyOptions, aws_cdk_lib_ArnFormat, aws_cdk_lib_ArnComponents, aws_cdk_lib_Arn, aws_cdk_lib_Duration, aws_cdk_lib_TimeConversionOptions, aws_cdk_lib_Expiration, aws_cdk_lib_Size, aws_cdk_lib_SizeRoundingBehavior, aws_cdk_lib_SizeConversionOptions, aws_cdk_lib_AppProps, aws_cdk_lib_App, aws_cdk_lib_GetContextKeyOptions, aws_cdk_lib_GetContextValueOptions, aws_cdk_lib_GetContextKeyResult, aws_cdk_lib_GetContextValueResult, aws_cdk_lib_ContextProvider, aws_cdk_lib_Environment, aws_cdk_lib_Annotations, aws_cdk_lib_ValidationResult, aws_cdk_lib_ValidationResults, aws_cdk_lib_SecretValue, aws_cdk_lib_SecretsManagerSecretOptions, aws_cdk_lib_ResourceEnvironment, aws_cdk_lib_IResource, aws_cdk_lib_ResourceProps, aws_cdk_lib_Resource, aws_cdk_lib_PhysicalName, aws_cdk_lib_IAsset, aws_cdk_lib_AssetOptions, aws_cdk_lib_AssetHashType, aws_cdk_lib_FileAssetSource, aws_cdk_lib_DockerImageAssetSource, aws_cdk_lib_FileAssetPackaging, aws_cdk_lib_FileAssetLocation, aws_cdk_lib_DockerImageAssetLocation, aws_cdk_lib_DockerCacheOption, aws_cdk_lib_TreeInspector, aws_cdk_lib_IInspectable, aws_cdk_lib_AssetStagingProps, aws_cdk_lib_AssetStaging, aws_cdk_lib_DockerBuildSecret, aws_cdk_lib_BundlingOptions, aws_cdk_lib_BundlingOutput, aws_cdk_lib_ILocalBundling, aws_cdk_lib_BundlingFileAccess, aws_cdk_lib_DockerImage, aws_cdk_lib_DockerVolume, aws_cdk_lib_DockerVolumeConsistency, aws_cdk_lib_DockerRunOptions, aws_cdk_lib_DockerBuildOptions, aws_cdk_lib_FileSystem, aws_cdk_lib_IgnoreStrategy, aws_cdk_lib_GlobIgnoreStrategy, aws_cdk_lib_GitIgnoreStrategy, aws_cdk_lib_DockerIgnoreStrategy, aws_cdk_lib_SymlinkFollowMode, aws_cdk_lib_IgnoreMode, aws_cdk_lib_CopyOptions, aws_cdk_lib_FileCopyOptions, aws_cdk_lib_FingerprintOptions, aws_cdk_lib_FileFingerprintOptions, aws_cdk_lib_CustomResourceProps, aws_cdk_lib_CustomResource, aws_cdk_lib_NestedStackProps, aws_cdk_lib_NestedStack, aws_cdk_lib_CustomResourceProviderProps, aws_cdk_lib_CustomResourceProviderRuntime, aws_cdk_lib_CustomResourceProvider, aws_cdk_lib_CfnCapabilities, aws_cdk_lib_CfnCustomResourceProps, aws_cdk_lib_CfnCustomResource, aws_cdk_lib_CfnHookDefaultVersionProps, aws_cdk_lib_CfnHookDefaultVersion, aws_cdk_lib_CfnHookTypeConfigProps, aws_cdk_lib_CfnHookTypeConfig, aws_cdk_lib_CfnHookVersionProps, aws_cdk_lib_CfnHookVersion, aws_cdk_lib_CfnHookVersion_LoggingConfigProperty, aws_cdk_lib_CfnMacroProps, aws_cdk_lib_CfnMacro, aws_cdk_lib_CfnModuleDefaultVersionProps, aws_cdk_lib_CfnModuleDefaultVersion, aws_cdk_lib_CfnModuleVersionProps, aws_cdk_lib_CfnModuleVersion, aws_cdk_lib_CfnPublicTypeVersionProps, aws_cdk_lib_CfnPublicTypeVersion, aws_cdk_lib_CfnPublisherProps, aws_cdk_lib_CfnPublisher, aws_cdk_lib_CfnResourceDefaultVersionProps, aws_cdk_lib_CfnResourceDefaultVersion, aws_cdk_lib_CfnResourceVersionProps, aws_cdk_lib_CfnResourceVersion, aws_cdk_lib_CfnResourceVersion_LoggingConfigProperty, aws_cdk_lib_CfnStackProps, aws_cdk_lib_CfnStack, aws_cdk_lib_CfnStackSetProps, aws_cdk_lib_CfnStackSet, aws_cdk_lib_CfnStackSet_AutoDeploymentProperty, aws_cdk_lib_CfnStackSet_DeploymentTargetsProperty, aws_cdk_lib_CfnStackSet_ManagedExecutionProperty, aws_cdk_lib_CfnStackSet_OperationPreferencesProperty, aws_cdk_lib_CfnStackSet_ParameterProperty, aws_cdk_lib_CfnStackSet_StackInstancesProperty, aws_cdk_lib_CfnTypeActivationProps, aws_cdk_lib_CfnTypeActivation, aws_cdk_lib_CfnTypeActivation_LoggingConfigProperty, aws_cdk_lib_CfnWaitConditionProps, aws_cdk_lib_CfnWaitCondition, aws_cdk_lib_CfnWaitConditionHandle, aws_cdk_lib_FeatureFlags, aws_cdk_lib_PermissionsBoundaryBindOptions, aws_cdk_lib_PermissionsBoundary, aws_cdk_lib_IPolicyValidationPluginBeta1, aws_cdk_lib_IPolicyValidationContextBeta1, aws_cdk_lib_PolicyViolationBeta1, aws_cdk_lib_PolicyViolatingResourceBeta1, aws_cdk_lib_PolicyValidationReportStatusBeta1, aws_cdk_lib_PolicyValidationPluginReportBeta1, aws_cdk_lib_IntrinsicProps, aws_cdk_lib_Intrinsic, aws_cdk_lib_UniqueResourceNameOptions, aws_cdk_lib_Names, aws_cdk_lib_TimeZone };
  }
});

// node_modules/aws-cdk-lib/alexa-ask/lib/ask.generated.js
var require_ask_generated = __commonJS({
  "node_modules/aws-cdk-lib/alexa-ask/lib/ask.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnSkill = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnSkillPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authenticationConfiguration", cdk.requiredValidator)(properties.authenticationConfiguration)), errors.collect(cdk.propertyValidator("authenticationConfiguration", CfnSkill_AuthenticationConfigurationPropertyValidator)(properties.authenticationConfiguration)), errors.collect(cdk.propertyValidator("skillPackage", cdk.requiredValidator)(properties.skillPackage)), errors.collect(cdk.propertyValidator("skillPackage", CfnSkill_SkillPackagePropertyValidator)(properties.skillPackage)), errors.collect(cdk.propertyValidator("vendorId", cdk.requiredValidator)(properties.vendorId)), errors.collect(cdk.propertyValidator("vendorId", cdk.validateString)(properties.vendorId)), errors.wrap('supplied properties not correct for "CfnSkillProps"');
    }
    function cfnSkillPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSkillPropsValidator(properties).assertSuccess(), { AuthenticationConfiguration: cfnSkillAuthenticationConfigurationPropertyToCloudFormation(properties.authenticationConfiguration), SkillPackage: cfnSkillSkillPackagePropertyToCloudFormation(properties.skillPackage), VendorId: cdk.stringToCloudFormation(properties.vendorId) }) : properties;
    }
    function CfnSkillPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authenticationConfiguration", "AuthenticationConfiguration", CfnSkillAuthenticationConfigurationPropertyFromCloudFormation(properties.AuthenticationConfiguration)), ret.addPropertyResult("skillPackage", "SkillPackage", CfnSkillSkillPackagePropertyFromCloudFormation(properties.SkillPackage)), ret.addPropertyResult("vendorId", "VendorId", cfn_parse.FromCloudFormation.getString(properties.VendorId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSkill = class _CfnSkill extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSkillPropsFromCloudFormation(resourceProperties), ret = new _CfnSkill(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSkill.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_alexa_ask_CfnSkillProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSkill), error;
        }
        cdk.requireProperty(props, "authenticationConfiguration", this), cdk.requireProperty(props, "skillPackage", this), cdk.requireProperty(props, "vendorId", this), this.authenticationConfiguration = props.authenticationConfiguration, this.skillPackage = props.skillPackage, this.vendorId = props.vendorId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSkill.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { authenticationConfiguration: this.authenticationConfiguration, skillPackage: this.skillPackage, vendorId: this.vendorId };
      }
      renderProperties(props) {
        return cfnSkillPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnSkill[_a] = { fqn: "aws-cdk-lib.alexa_ask.CfnSkill", version: "2.80.0" }, CfnSkill.CFN_RESOURCE_TYPE_NAME = "Alexa::ASK::Skill", exports2.CfnSkill = CfnSkill;
    function CfnSkill_AuthenticationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clientId", cdk.requiredValidator)(properties.clientId)), errors.collect(cdk.propertyValidator("clientId", cdk.validateString)(properties.clientId)), errors.collect(cdk.propertyValidator("clientSecret", cdk.requiredValidator)(properties.clientSecret)), errors.collect(cdk.propertyValidator("clientSecret", cdk.validateString)(properties.clientSecret)), errors.collect(cdk.propertyValidator("refreshToken", cdk.requiredValidator)(properties.refreshToken)), errors.collect(cdk.propertyValidator("refreshToken", cdk.validateString)(properties.refreshToken)), errors.wrap('supplied properties not correct for "AuthenticationConfigurationProperty"');
    }
    function cfnSkillAuthenticationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSkill_AuthenticationConfigurationPropertyValidator(properties).assertSuccess(), { ClientId: cdk.stringToCloudFormation(properties.clientId), ClientSecret: cdk.stringToCloudFormation(properties.clientSecret), RefreshToken: cdk.stringToCloudFormation(properties.refreshToken) }) : properties;
    }
    function CfnSkillAuthenticationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clientId", "ClientId", cfn_parse.FromCloudFormation.getString(properties.ClientId)), ret.addPropertyResult("clientSecret", "ClientSecret", cfn_parse.FromCloudFormation.getString(properties.ClientSecret)), ret.addPropertyResult("refreshToken", "RefreshToken", cfn_parse.FromCloudFormation.getString(properties.RefreshToken)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSkill_OverridesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("manifest", cdk.validateObject)(properties.manifest)), errors.wrap('supplied properties not correct for "OverridesProperty"');
    }
    function cfnSkillOverridesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSkill_OverridesPropertyValidator(properties).assertSuccess(), { Manifest: cdk.objectToCloudFormation(properties.manifest) }) : properties;
    }
    function CfnSkillOverridesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("manifest", "Manifest", properties.Manifest != null ? cfn_parse.FromCloudFormation.getAny(properties.Manifest) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSkill_SkillPackagePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("overrides", CfnSkill_OverridesPropertyValidator)(properties.overrides)), errors.collect(cdk.propertyValidator("s3Bucket", cdk.requiredValidator)(properties.s3Bucket)), errors.collect(cdk.propertyValidator("s3Bucket", cdk.validateString)(properties.s3Bucket)), errors.collect(cdk.propertyValidator("s3BucketRole", cdk.validateString)(properties.s3BucketRole)), errors.collect(cdk.propertyValidator("s3Key", cdk.requiredValidator)(properties.s3Key)), errors.collect(cdk.propertyValidator("s3Key", cdk.validateString)(properties.s3Key)), errors.collect(cdk.propertyValidator("s3ObjectVersion", cdk.validateString)(properties.s3ObjectVersion)), errors.wrap('supplied properties not correct for "SkillPackageProperty"');
    }
    function cfnSkillSkillPackagePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSkill_SkillPackagePropertyValidator(properties).assertSuccess(), { Overrides: cfnSkillOverridesPropertyToCloudFormation(properties.overrides), S3Bucket: cdk.stringToCloudFormation(properties.s3Bucket), S3BucketRole: cdk.stringToCloudFormation(properties.s3BucketRole), S3Key: cdk.stringToCloudFormation(properties.s3Key), S3ObjectVersion: cdk.stringToCloudFormation(properties.s3ObjectVersion) }) : properties;
    }
    function CfnSkillSkillPackagePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("overrides", "Overrides", properties.Overrides != null ? CfnSkillOverridesPropertyFromCloudFormation(properties.Overrides) : void 0), ret.addPropertyResult("s3Bucket", "S3Bucket", cfn_parse.FromCloudFormation.getString(properties.S3Bucket)), ret.addPropertyResult("s3BucketRole", "S3BucketRole", properties.S3BucketRole != null ? cfn_parse.FromCloudFormation.getString(properties.S3BucketRole) : void 0), ret.addPropertyResult("s3Key", "S3Key", cfn_parse.FromCloudFormation.getString(properties.S3Key)), ret.addPropertyResult("s3ObjectVersion", "S3ObjectVersion", properties.S3ObjectVersion != null ? cfn_parse.FromCloudFormation.getString(properties.S3ObjectVersion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/alexa-ask/lib/index.js
var require_lib31 = __commonJS({
  "node_modules/aws-cdk-lib/alexa-ask/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_ask_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/alexa-ask/index.js
var require_alexa_ask = __commonJS({
  "node_modules/aws-cdk-lib/alexa-ask/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib31(), exports2);
  }
});

// node_modules/aws-cdk-lib/assertions/lib/matcher.js
var require_matcher = __commonJS({
  "node_modules/aws-cdk-lib/assertions/lib/matcher.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.MatchResult = exports2.Matcher = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var Matcher = class _Matcher {
      static isMatcher(x) {
        return x && x instanceof _Matcher;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Matcher[_a] = { fqn: "aws-cdk-lib.assertions.Matcher", version: "2.80.0" }, exports2.Matcher = Matcher;
    var MatchResult = class {
      constructor(target) {
        this.failuresHere = /* @__PURE__ */ new Map(), this.captures = /* @__PURE__ */ new Map(), this.finalized = false, this.innerMatchFailures = /* @__PURE__ */ new Map(), this._hasFailed = false, this._failCount = 0, this._cost = 0, this.target = target;
      }
      push(matcher, path, message) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.assertions.MatchResult#push", "use recordFailure()"), jsiiDeprecationWarnings.aws_cdk_lib_assertions_Matcher(matcher);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.push), error;
        }
        return this.recordFailure({ matcher, path, message });
      }
      recordFailure(failure) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_assertions_MatchFailure(failure);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.recordFailure), error;
        }
        const failKey = failure.path.join(".");
        let list = this.failuresHere.get(failKey);
        return list || (list = [], this.failuresHere.set(failKey, list)), this._failCount += 1, this._cost += failure.cost ?? 1, list.push(failure), this._hasFailed = true, this;
      }
      get isSuccess() {
        return !this._hasFailed;
      }
      hasFailed() {
        return this._hasFailed;
      }
      get failCount() {
        return this._failCount;
      }
      get failCost() {
        return this._cost;
      }
      compose(id, inner) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_assertions_MatchResult(inner);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.compose), error;
        }
        return inner.hasFailed() && (this._hasFailed = true, this._failCount += inner.failCount, this._cost += inner._cost, this.innerMatchFailures.set(id, inner)), inner.captures.forEach((vals, capture) => {
          vals.forEach((value) => this.recordCapture({ capture, value }));
        }), this;
      }
      finished() {
        return this.finalized ? this : (this.failCount === 0 && this.captures.forEach((vals, cap) => cap._captured.push(...vals)), this.finalized = true, this);
      }
      toHumanStrings() {
        const failures = new Array();
        debugger;
        return recurse(this, []), failures.map((r) => {
          const loc = r.path.length === 0 ? "" : ` at /${r.path.join("/")}`;
          return "" + r.message + loc + ` (using ${r.matcher.name} matcher)`;
        });
        function recurse(x, prefix) {
          for (const fail of Array.from(x.failuresHere.values()).flat())
            failures.push({ matcher: fail.matcher, message: fail.message, path: [...prefix, ...fail.path] });
          for (const [key, inner] of x.innerMatchFailures.entries())
            recurse(inner, [...prefix, key]);
        }
      }
      renderMismatch() {
        if (!this.hasFailed())
          return "<match>";
        const parts = new Array(), indents = new Array();
        return emitFailures(this, ""), recurse(this), moveMarkersToFront(parts.join("").trimEnd());
        function emit(x) {
          if (x === void 0)
            debugger;
          parts.push(x.replace(/\n/g, `
${indents.join("")}`));
        }
        function emitFailures(r, path, scrapSet) {
          for (const fail of r.failuresHere.get(path) ?? [])
            emit(`!! ${fail.message}
`);
          scrapSet?.delete(path);
        }
        function recurse(r) {
          const remainingFailures = new Set(Array.from(r.failuresHere.keys()).filter((x) => x !== ""));
          if (Array.isArray(r.target)) {
            indents.push("  "), emit(`[
`);
            for (const [first, i] of enumFirst(range(r.target.length))) {
              first || emit(`,
`), emitFailures(r, `${i}`, remainingFailures);
              const innerMatcher = r.innerMatchFailures.get(`${i}`);
              innerMatcher ? (emitFailures(innerMatcher, ""), recurseComparingValues(innerMatcher, r.target[i])) : emit(renderAbridged(r.target[i]));
            }
            emitRemaining(), indents.pop(), emit(`
]`);
            return;
          }
          if (r.target && typeof r.target == "object") {
            indents.push("  "), emit(`{
`);
            const keys = Array.from(/* @__PURE__ */ new Set([...Object.keys(r.target), ...Array.from(remainingFailures)])).sort();
            for (const [first, key] of enumFirst(keys)) {
              first || emit(`,
`), emitFailures(r, key, remainingFailures);
              const innerMatcher = r.innerMatchFailures.get(key);
              innerMatcher ? (emitFailures(innerMatcher, ""), emit(`${jsonify(key)}: `), recurseComparingValues(innerMatcher, r.target[key])) : (emit(`${jsonify(key)}: `), emit(renderAbridged(r.target[key])));
            }
            emitRemaining(), indents.pop(), emit(`
}`);
            return;
          }
          emitRemaining(), emit(jsonify(r.target));
          function emitRemaining() {
            remainingFailures.size > 0 && emit(`
`);
            for (const key of remainingFailures)
              emitFailures(r, key);
          }
        }
        function recurseComparingValues(inner, actualValue) {
          if (inner.target === actualValue)
            return recurse(inner);
          emit(renderAbridged(actualValue)), emit(" <*> "), recurse(inner);
        }
        function renderAbridged(x) {
          if (Array.isArray(x))
            switch (x.length) {
              case 0:
                return "[]";
              case 1:
                return `[ ${renderAbridged(x[0])} ]`;
              case 2:
                return x.every((e) => ["number", "boolean", "string"].includes(typeof e)) ? `[ ${x.map(renderAbridged).join(", ")} ]` : "[ ... ]";
              default:
                return "[ ... ]";
            }
          if (x && typeof x == "object") {
            const keys = Object.keys(x);
            switch (keys.length) {
              case 0:
                return "{}";
              case 1:
                return `{ ${JSON.stringify(keys[0])}: ${renderAbridged(x[keys[0]])} }`;
              default:
                return "{ ... }";
            }
          }
          return jsonify(x);
        }
        function jsonify(x) {
          return JSON.stringify(x) ?? "undefined";
        }
        function moveMarkersToFront(x) {
          const re = /^(\s+)!!/gm;
          return x.replace(re, (_, spaces) => `!!${spaces.substring(0, spaces.length - 2)}`);
        }
      }
      recordCapture(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_assertions_MatchCapture(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.recordCapture), error;
        }
        let values = this.captures.get(options.capture);
        values === void 0 && (values = []), values.push(options.value), this.captures.set(options.capture, values);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, MatchResult[_b] = { fqn: "aws-cdk-lib.assertions.MatchResult", version: "2.80.0" }, exports2.MatchResult = MatchResult;
    function* range(n) {
      for (let i = 0; i < n; i++)
        yield i;
    }
    function* enumFirst(xs) {
      let first = true;
      for (const x of xs)
        yield [first, x], first = false;
    }
  }
});

// node_modules/aws-cdk-lib/assertions/lib/private/type.js
var require_type = __commonJS({
  "node_modules/aws-cdk-lib/assertions/lib/private/type.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.getType = void 0;
    function getType(obj) {
      return Array.isArray(obj) ? "array" : typeof obj;
    }
    exports2.getType = getType;
  }
});

// node_modules/aws-cdk-lib/assertions/lib/capture.js
var require_capture = __commonJS({
  "node_modules/aws-cdk-lib/assertions/lib/capture.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Capture = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var _1 = require_lib32();
    var matcher_1 = require_matcher();
    var type_1 = require_type();
    var Capture = class extends matcher_1.Matcher {
      constructor(pattern) {
        super(), this.pattern = pattern, this._captured = [], this.idx = 0, this.name = "Capture";
      }
      test(actual) {
        const result = new matcher_1.MatchResult(actual);
        if (actual == null)
          return result.recordFailure({ matcher: this, path: [], message: `Can only capture non-nullish values. Found ${actual}` });
        if (this.pattern !== void 0) {
          const innerResult = (matcher_1.Matcher.isMatcher(this.pattern) ? this.pattern : _1.Match.objectLike(this.pattern)).test(actual);
          if (innerResult.hasFailed())
            return innerResult;
        }
        return result.recordCapture({ capture: this, value: actual }), result;
      }
      next() {
        return this.idx < this._captured.length - 1 ? (this.idx++, true) : false;
      }
      asString() {
        this.validate();
        const val = this._captured[this.idx];
        if ((0, type_1.getType)(val) === "string")
          return val;
        this.reportIncorrectType("string");
      }
      asNumber() {
        this.validate();
        const val = this._captured[this.idx];
        if ((0, type_1.getType)(val) === "number")
          return val;
        this.reportIncorrectType("number");
      }
      asBoolean() {
        this.validate();
        const val = this._captured[this.idx];
        if ((0, type_1.getType)(val) === "boolean")
          return val;
        this.reportIncorrectType("boolean");
      }
      asArray() {
        this.validate();
        const val = this._captured[this.idx];
        if ((0, type_1.getType)(val) === "array")
          return val;
        this.reportIncorrectType("array");
      }
      asObject() {
        this.validate();
        const val = this._captured[this.idx];
        if ((0, type_1.getType)(val) === "object")
          return val;
        this.reportIncorrectType("object");
      }
      validate() {
        if (this._captured.length === 0)
          throw new Error("No value captured");
      }
      reportIncorrectType(expected) {
        throw new Error(`Captured value is expected to be ${expected} but found ${(0, type_1.getType)(this._captured[this.idx])}. Value is ${JSON.stringify(this._captured[this.idx], void 0, 2)}`);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Capture[_a] = { fqn: "aws-cdk-lib.assertions.Capture", version: "2.80.0" }, exports2.Capture = Capture;
  }
});

// node_modules/aws-cdk-lib/assertions/lib/private/matchers/absent.js
var require_absent = __commonJS({
  "node_modules/aws-cdk-lib/assertions/lib/private/matchers/absent.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AbsentMatch = void 0;
    var matcher_1 = require_matcher();
    var AbsentMatch = class extends matcher_1.Matcher {
      constructor(name) {
        super(), this.name = name;
      }
      test(actual) {
        const result = new matcher_1.MatchResult(actual);
        return actual !== void 0 && result.recordFailure({ matcher: this, path: [], message: `Received ${actual}, but key should be absent` }), result;
      }
    };
    exports2.AbsentMatch = AbsentMatch;
  }
});

// node_modules/aws-cdk-lib/assertions/lib/private/sorting.js
var require_sorting = __commonJS({
  "node_modules/aws-cdk-lib/assertions/lib/private/sorting.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.sortKeyComparator = void 0;
    function sortKeyComparator(keyFn) {
      return (a, b) => {
        const ak = keyFn(a), bk = keyFn(b);
        for (let i = 0; i < ak.length && i < bk.length; i++) {
          const av = ak[i], bv = bk[i];
          let diff = 0;
          if (typeof av == "number" && typeof bv == "number" ? diff = av - bv : typeof av == "string" && typeof bv == "string" && (diff = av.localeCompare(bv)), diff !== 0)
            return diff;
        }
        return bk.length - ak.length;
      };
    }
    exports2.sortKeyComparator = sortKeyComparator;
  }
});

// node_modules/aws-cdk-lib/assertions/lib/private/sparse-matrix.js
var require_sparse_matrix = __commonJS({
  "node_modules/aws-cdk-lib/assertions/lib/private/sparse-matrix.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SparseMatrix = void 0;
    var SparseMatrix = class {
      constructor() {
        this.matrix = /* @__PURE__ */ new Map();
      }
      get(row, col) {
        return this.matrix.get(row)?.get(col);
      }
      row(row) {
        return Array.from(this.matrix.get(row)?.entries() ?? []);
      }
      set(row, col, value) {
        let r = this.matrix.get(row);
        r || (r = /* @__PURE__ */ new Map(), this.matrix.set(row, r)), r.set(col, value);
      }
    };
    exports2.SparseMatrix = SparseMatrix;
  }
});

// node_modules/aws-cdk-lib/assertions/lib/match.js
var require_match = __commonJS({
  "node_modules/aws-cdk-lib/assertions/lib/match.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Match = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var matcher_1 = require_matcher();
    var absent_1 = require_absent();
    var sorting_1 = require_sorting();
    var sparse_matrix_1 = require_sparse_matrix();
    var type_1 = require_type();
    var Match = class {
      static absent() {
        return new absent_1.AbsentMatch("absent");
      }
      static arrayWith(pattern) {
        return new ArrayMatch("arrayWith", pattern);
      }
      static arrayEquals(pattern) {
        return new ArrayMatch("arrayEquals", pattern, { subsequence: false });
      }
      static exact(pattern) {
        return new LiteralMatch("exact", pattern, { partialObjects: false });
      }
      static objectLike(pattern) {
        return new ObjectMatch("objectLike", pattern);
      }
      static objectEquals(pattern) {
        return new ObjectMatch("objectEquals", pattern, { partial: false });
      }
      static not(pattern) {
        return new NotMatch("not", pattern);
      }
      static serializedJson(pattern) {
        return new SerializedJson("serializedJson", pattern);
      }
      static anyValue() {
        return new AnyMatch("anyValue");
      }
      static stringLikeRegexp(pattern) {
        return new StringLikeRegexpMatch("stringLikeRegexp", pattern);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Match[_a] = { fqn: "aws-cdk-lib.assertions.Match", version: "2.80.0" }, exports2.Match = Match;
    var LiteralMatch = class extends matcher_1.Matcher {
      constructor(name, pattern, options = {}) {
        if (super(), this.name = name, this.pattern = pattern, this.partialObjects = options.partialObjects ?? false, matcher_1.Matcher.isMatcher(this.pattern))
          throw new Error("LiteralMatch cannot directly contain another matcher. Remove the top-level matcher or nest it more deeply.");
      }
      test(actual) {
        if (Array.isArray(this.pattern))
          return new ArrayMatch(this.name, this.pattern, { subsequence: false, partialObjects: this.partialObjects }).test(actual);
        if (typeof this.pattern == "object")
          return new ObjectMatch(this.name, this.pattern, { partial: this.partialObjects }).test(actual);
        const result = new matcher_1.MatchResult(actual);
        return typeof this.pattern != typeof actual ? (result.recordFailure({ matcher: this, path: [], message: `Expected type ${typeof this.pattern} but received ${(0, type_1.getType)(actual)}` }), result) : (actual !== this.pattern && result.recordFailure({ matcher: this, path: [], message: `Expected ${this.pattern} but received ${actual}` }), result);
      }
    };
    var ArrayMatch = class extends matcher_1.Matcher {
      constructor(name, pattern, options = {}) {
        super(), this.name = name, this.pattern = pattern, this.subsequence = options.subsequence ?? true, this.partialObjects = options.partialObjects ?? false;
      }
      test(actual) {
        return Array.isArray(actual) ? this.subsequence ? this.testSubsequence(actual) : this.testFullArray(actual) : new matcher_1.MatchResult(actual).recordFailure({ matcher: this, path: [], message: `Expected type array but received ${(0, type_1.getType)(actual)}` });
      }
      testFullArray(actual) {
        const result = new matcher_1.MatchResult(actual);
        let i = 0;
        for (; i < this.pattern.length && i < actual.length; i++) {
          const patternElement = this.pattern[i], innerResult = (matcher_1.Matcher.isMatcher(patternElement) ? patternElement : new LiteralMatch(this.name, patternElement, { partialObjects: this.partialObjects })).test(actual[i]);
          result.compose(`${i}`, innerResult);
        }
        return i < this.pattern.length && result.recordFailure({ matcher: this, message: `Not enough elements in array (expecting ${this.pattern.length}, got ${actual.length})`, path: [`${i}`] }), i < actual.length && result.recordFailure({ matcher: this, message: `Too many elements in array (expecting ${this.pattern.length}, got ${actual.length})`, path: [`${i}`] }), result;
      }
      testSubsequence(actual) {
        const result = new matcher_1.MatchResult(actual);
        let patternIdx = 0, actualIdx = 0;
        const matches = new sparse_matrix_1.SparseMatrix();
        for (; patternIdx < this.pattern.length && actualIdx < actual.length; ) {
          const patternElement = this.pattern[patternIdx], matcher = matcher_1.Matcher.isMatcher(patternElement) ? patternElement : new LiteralMatch(this.name, patternElement, { partialObjects: this.partialObjects }), matcherName = matcher.name;
          if (matcherName == "absent" || matcherName == "anyValue")
            throw new Error(`The Matcher ${matcherName}() cannot be nested within arrayWith()`);
          const innerResult = matcher.test(actual[actualIdx]);
          matches.set(patternIdx, actualIdx, innerResult), actualIdx++, innerResult.isSuccess && (result.compose(`${actualIdx}`, innerResult), patternIdx++);
        }
        if (patternIdx < this.pattern.length) {
          for (let spi = 0; spi < patternIdx; spi++) {
            const foundMatch = matches.row(spi).find(([, r]) => r.isSuccess);
            if (!foundMatch)
              continue;
            const [index] = foundMatch;
            result.compose(`${index}`, new matcher_1.MatchResult(actual[index]).recordFailure({ matcher: this, message: `arrayWith pattern ${spi} matched here`, path: [], cost: 0 }));
          }
          const failedMatches = matches.row(patternIdx);
          if (failedMatches.sort((0, sorting_1.sortKeyComparator)(([i, r]) => [r.failCost, i])), failedMatches.length > 0) {
            const [index, innerResult] = failedMatches[0];
            result.recordFailure({ matcher: this, message: `Could not match arrayWith pattern ${patternIdx}. This is the closest match`, path: [`${index}`], cost: 0 }), result.compose(`${index}`, innerResult);
          } else
            result.recordFailure({ matcher: this, message: `Could not match arrayWith pattern ${patternIdx}. No more elements to try`, path: [`${actual.length}`] });
        }
        return result;
      }
    };
    var ObjectMatch = class extends matcher_1.Matcher {
      constructor(name, pattern, options = {}) {
        super(), this.name = name, this.pattern = pattern, this.partial = options.partial ?? true;
      }
      test(actual) {
        if (typeof actual != "object" || Array.isArray(actual))
          return new matcher_1.MatchResult(actual).recordFailure({ matcher: this, path: [], message: `Expected type object but received ${(0, type_1.getType)(actual)}` });
        const result = new matcher_1.MatchResult(actual);
        if (!this.partial)
          for (const a of Object.keys(actual))
            a in this.pattern || result.recordFailure({ matcher: this, path: [a], message: `Unexpected key ${a}` });
        for (const [patternKey, patternVal] of Object.entries(this.pattern)) {
          if (!(patternKey in actual) && !(patternVal instanceof absent_1.AbsentMatch)) {
            result.recordFailure({ matcher: this, path: [patternKey], message: `Missing key '${patternKey}'` });
            continue;
          }
          const inner = (matcher_1.Matcher.isMatcher(patternVal) ? patternVal : new LiteralMatch(this.name, patternVal, { partialObjects: this.partial })).test(actual[patternKey]);
          result.compose(patternKey, inner);
        }
        return result;
      }
    };
    var SerializedJson = class extends matcher_1.Matcher {
      constructor(name, pattern) {
        super(), this.name = name, this.pattern = pattern;
      }
      test(actual) {
        if ((0, type_1.getType)(actual) !== "string")
          return new matcher_1.MatchResult(actual).recordFailure({ matcher: this, path: [], message: `Expected JSON as a string but found ${(0, type_1.getType)(actual)}` });
        let parsed;
        try {
          parsed = JSON.parse(actual);
        } catch (err) {
          if (err instanceof SyntaxError)
            return new matcher_1.MatchResult(actual).recordFailure({ matcher: this, path: [], message: `Invalid JSON string: ${actual}` });
          throw err;
        }
        const innerResult = (matcher_1.Matcher.isMatcher(this.pattern) ? this.pattern : new LiteralMatch(this.name, this.pattern)).test(parsed);
        return innerResult.hasFailed() && innerResult.recordFailure({ matcher: this, path: [], message: "Encoded JSON value does not match" }), innerResult;
      }
    };
    var NotMatch = class extends matcher_1.Matcher {
      constructor(name, pattern) {
        super(), this.name = name, this.pattern = pattern;
      }
      test(actual) {
        const innerResult = (matcher_1.Matcher.isMatcher(this.pattern) ? this.pattern : new LiteralMatch(this.name, this.pattern)).test(actual), result = new matcher_1.MatchResult(actual);
        return innerResult.failCount === 0 && result.recordFailure({ matcher: this, path: [], message: `Found unexpected match: ${JSON.stringify(actual, void 0, 2)}` }), result;
      }
    };
    var AnyMatch = class extends matcher_1.Matcher {
      constructor(name) {
        super(), this.name = name;
      }
      test(actual) {
        const result = new matcher_1.MatchResult(actual);
        return actual == null && result.recordFailure({ matcher: this, path: [], message: "Expected a value but found none" }), result;
      }
    };
    var StringLikeRegexpMatch = class extends matcher_1.Matcher {
      constructor(name, pattern) {
        super(), this.name = name, this.pattern = pattern;
      }
      test(actual) {
        const result = new matcher_1.MatchResult(actual), regex = new RegExp(this.pattern, "gm");
        return typeof actual != "string" && result.recordFailure({ matcher: this, path: [], message: `Expected a string, but got '${typeof actual}'` }), regex.test(actual) || result.recordFailure({ matcher: this, path: [], message: `String '${actual}' did not match pattern '${this.pattern}'` }), result;
      }
    };
  }
});

// node_modules/aws-cdk-lib/assertions/lib/private/section.js
var require_section = __commonJS({
  "node_modules/aws-cdk-lib/assertions/lib/private/section.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.filterLogicalId = exports2.formatFailure = exports2.formatSectionMatchFailure = exports2.formatAllMismatches = exports2.formatAllMatches = exports2.matchSection = void 0;
    var sorting_1 = require_sorting();
    var match_1 = require_match();
    var matcher_1 = require_matcher();
    function matchSection(section, props) {
      const matcher = matcher_1.Matcher.isMatcher(props) ? props : match_1.Match.objectLike(props), matching = {}, analyzed = {}, failures = new Array();
      return eachEntryInSection(section, (logicalId, entry) => {
        analyzed[logicalId] = entry;
        const result = matcher.test(entry);
        result.finished(), result.hasFailed() ? failures.push([logicalId, result]) : matching[logicalId] = entry;
      }), Object.keys(matching).length > 0 ? { match: true, matches: matching, analyzedCount: Object.keys(analyzed).length, analyzed } : (failures.sort((0, sorting_1.sortKeyComparator)(([logicalId, result]) => [result.failCost, logicalId])), { match: false, closestResults: Object.fromEntries(failures.slice(0, 3)), analyzedCount: Object.keys(analyzed).length, analyzed });
    }
    exports2.matchSection = matchSection;
    function eachEntryInSection(section, cb) {
      for (const logicalId of Object.keys(section ?? {})) {
        const resource = section[logicalId];
        cb(logicalId, resource);
      }
    }
    function formatAllMatches(matches) {
      return [leftPad(JSON.stringify(matches, void 0, 2))].join(`
`);
    }
    exports2.formatAllMatches = formatAllMatches;
    function formatAllMismatches(analyzed, matches = {}) {
      return ["The following resources do not match the given definition:", ...Object.keys(analyzed).filter((id) => !(id in matches)).map((id) => `	${id}`)].join(`
`);
    }
    exports2.formatAllMismatches = formatAllMismatches;
    function formatSectionMatchFailure(qualifier, result, what = "Template") {
      return [`${what} has ${result.analyzedCount} ${qualifier}`, result.analyzedCount > 0 ? ", but none match as expected" : "", `.
`, formatFailure(result.closestResults)].join("");
    }
    exports2.formatSectionMatchFailure = formatSectionMatchFailure;
    function formatFailure(closestResults) {
      const keys = Object.keys(closestResults);
      return keys.length === 0 ? "No matches found" : [`The ${keys.length} closest matches:`, ...keys.map((key) => `${key} :: ${closestResults[key].renderMismatch()}`)].join(`
`);
    }
    exports2.formatFailure = formatFailure;
    function leftPad(x, indent = 2) {
      const pad = " ".repeat(indent);
      return pad + x.split(`
`).join(`
${pad}`);
    }
    function filterLogicalId(section, logicalId) {
      return logicalId === "*" ? section : Object.entries(section ?? {}).filter(([k, _]) => k === logicalId).reduce((agg, [k, v]) => ({ ...agg, [k]: v }), {});
    }
    exports2.filterLogicalId = filterLogicalId;
  }
});

// node_modules/aws-cdk-lib/assertions/lib/private/conditions.js
var require_conditions = __commonJS({
  "node_modules/aws-cdk-lib/assertions/lib/private/conditions.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.hasCondition = exports2.findConditions = void 0;
    var section_1 = require_section();
    function findConditions(template, logicalId, props = {}) {
      const section = template.Conditions ?? {}, result = (0, section_1.matchSection)((0, section_1.filterLogicalId)(section, logicalId), props);
      return result.match ? result.matches : {};
    }
    exports2.findConditions = findConditions;
    function hasCondition(template, logicalId, props) {
      const section = template.Conditions ?? {}, result = (0, section_1.matchSection)((0, section_1.filterLogicalId)(section, logicalId), props);
      if (!result.match)
        return (0, section_1.formatSectionMatchFailure)(`conditions with logicalId ${logicalId}`, result);
    }
    exports2.hasCondition = hasCondition;
  }
});

// node_modules/aws-cdk-lib/assertions/lib/private/cyclic.js
var require_cyclic = __commonJS({
  "node_modules/aws-cdk-lib/assertions/lib/private/cyclic.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.checkTemplateForCyclicDependencies = void 0;
    function checkTemplateForCyclicDependencies(template) {
      const logicalIds = new Set(Object.keys(template.Resources ?? {})), dependencies = /* @__PURE__ */ new Map();
      for (const [logicalId, resource] of Object.entries(template.Resources ?? {}))
        dependencies.set(logicalId, intersect(findResourceDependencies(resource), logicalIds));
      for (; dependencies.size > 0; ) {
        const free = Array.from(dependencies.entries()).filter(([_, deps]) => deps.size === 0);
        if (free.length === 0) {
          const cycle = findCycle(dependencies), cycleResources = {};
          for (const logicalId of cycle)
            cycleResources[logicalId] = template.Resources?.[logicalId];
          throw new Error(`Template is undeployable, these resources have a dependency cycle: ${cycle.join(" -> ")}:

${JSON.stringify(cycleResources, void 0, 2)}`);
        }
        for (const [logicalId, _] of free) {
          for (const deps of dependencies.values())
            deps.delete(logicalId);
          dependencies.delete(logicalId);
        }
      }
    }
    exports2.checkTemplateForCyclicDependencies = checkTemplateForCyclicDependencies;
    function findResourceDependencies(res) {
      return /* @__PURE__ */ new Set([...toArray(res.DependsOn ?? []), ...findExpressionDependencies(res.Properties)]);
    }
    function toArray(x) {
      return Array.isArray(x) ? x : [x];
    }
    function findExpressionDependencies(obj) {
      const ret = /* @__PURE__ */ new Set();
      return recurse(obj), ret;
      function recurse(x) {
        if (x && (Array.isArray(x) && x.forEach(recurse), typeof x == "object")) {
          const keys = Object.keys(x);
          if (keys.length === 1 && keys[0] === "Ref")
            ret.add(x[keys[0]]);
          else if (keys.length === 1 && keys[0] === "Fn::GetAtt")
            ret.add(x[keys[0]][0]);
          else if (keys.length === 1 && keys[0] === "Fn::Sub") {
            const argument = x[keys[0]], pattern = Array.isArray(argument) ? argument[0] : argument;
            if (typeof pattern == "string")
              for (const logId of logicalIdsInSubString(pattern))
                ret.add(logId);
            const contextDict = Array.isArray(argument) ? argument[1] : void 0;
            contextDict && typeof contextDict == "object" && Object.values(contextDict).forEach(recurse);
          } else
            Object.values(x).forEach(recurse);
        }
      }
    }
    function logicalIdsInSubString(x) {
      return analyzeSubPattern(x).flatMap((fragment) => {
        switch (fragment.type) {
          case "getatt":
          case "ref":
            return [fragment.logicalId];
          case "literal":
            return [];
        }
      });
    }
    function analyzeSubPattern(pattern) {
      const ret = [];
      let start = 0, ph0 = pattern.indexOf("${", start);
      for (; ph0 > -1; ) {
        if (pattern[ph0 + 2] === "!") {
          start = ph0 + 3, ph0 = pattern.indexOf("${", start);
          continue;
        }
        const ph1 = pattern.indexOf("}", ph0 + 2);
        if (ph1 === -1)
          break;
        const placeholder = pattern.substring(ph0 + 2, ph1);
        if (ph0 > start && ret.push({ type: "literal", content: pattern.substring(start, ph0) }), placeholder.includes(".")) {
          const [logicalId, attr] = placeholder.split(".");
          ret.push({ type: "getatt", logicalId, attr });
        } else
          ret.push({ type: "ref", logicalId: placeholder });
        start = ph1 + 1, ph0 = pattern.indexOf("${", start);
      }
      return start < pattern.length - 1 && ret.push({ type: "literal", content: pattern.slice(start) }), ret;
    }
    function intersect(xs, ys) {
      return new Set(Array.from(xs).filter((x) => ys.has(x)));
    }
    function findCycle(deps) {
      for (const node of deps.keys()) {
        const cycle = recurse(node, [node]);
        if (cycle)
          return cycle;
      }
      throw new Error("No cycle found. Assertion failure!");
      function recurse(node, path) {
        for (const dep of deps.get(node) ?? []) {
          if (dep === path[0])
            return [...path, dep];
          const cycle = recurse(dep, [...path, dep]);
          if (cycle)
            return cycle;
        }
      }
    }
  }
});

// node_modules/aws-cdk-lib/assertions/lib/private/mappings.js
var require_mappings = __commonJS({
  "node_modules/aws-cdk-lib/assertions/lib/private/mappings.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.hasMapping = exports2.findMappings = void 0;
    var section_1 = require_section();
    function findMappings(template, logicalId, props = {}) {
      const section = template.Mappings ?? {}, result = (0, section_1.matchSection)((0, section_1.filterLogicalId)(section, logicalId), props);
      return result.match ? result.matches : {};
    }
    exports2.findMappings = findMappings;
    function hasMapping(template, logicalId, props) {
      const section = template.Mappings ?? {}, result = (0, section_1.matchSection)((0, section_1.filterLogicalId)(section, logicalId), props);
      if (!result.match)
        return (0, section_1.formatSectionMatchFailure)(`mappings with logicalId ${logicalId}`, result);
    }
    exports2.hasMapping = hasMapping;
  }
});

// node_modules/aws-cdk-lib/assertions/lib/private/outputs.js
var require_outputs = __commonJS({
  "node_modules/aws-cdk-lib/assertions/lib/private/outputs.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.hasOutput = exports2.findOutputs = void 0;
    var section_1 = require_section();
    function findOutputs(template, logicalId, props = {}) {
      const section = template.Outputs ?? {}, result = (0, section_1.matchSection)((0, section_1.filterLogicalId)(section, logicalId), props);
      return result.match ? result.matches : {};
    }
    exports2.findOutputs = findOutputs;
    function hasOutput(template, logicalId, props) {
      const section = template.Outputs ?? {}, result = (0, section_1.matchSection)((0, section_1.filterLogicalId)(section, logicalId), props);
      if (!result.match)
        return (0, section_1.formatSectionMatchFailure)(`outputs named ${logicalId}`, result);
    }
    exports2.hasOutput = hasOutput;
  }
});

// node_modules/aws-cdk-lib/assertions/lib/private/parameters.js
var require_parameters = __commonJS({
  "node_modules/aws-cdk-lib/assertions/lib/private/parameters.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.hasParameter = exports2.findParameters = void 0;
    var section_1 = require_section();
    function findParameters(template, logicalId, props = {}) {
      const section = template.Parameters ?? {}, result = (0, section_1.matchSection)((0, section_1.filterLogicalId)(section, logicalId), props);
      return result.match ? result.matches : {};
    }
    exports2.findParameters = findParameters;
    function hasParameter(template, logicalId, props) {
      const section = template.Parameters ?? {}, result = (0, section_1.matchSection)((0, section_1.filterLogicalId)(section, logicalId), props);
      if (!result.match)
        return (0, section_1.formatSectionMatchFailure)(`parameters with logicalId '${logicalId}'`, result);
    }
    exports2.hasParameter = hasParameter;
  }
});

// node_modules/aws-cdk-lib/assertions/lib/private/resources.js
var require_resources = __commonJS({
  "node_modules/aws-cdk-lib/assertions/lib/private/resources.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.countResourcesProperties = exports2.countResources = exports2.hasResourceProperties = exports2.hasResource = exports2.allResourcesProperties = exports2.allResources = exports2.findResources = void 0;
    var absent_1 = require_absent();
    var section_1 = require_section();
    var __1 = require_lib32();
    function findResources(template, type, props = {}) {
      const section = template.Resources ?? {}, result = (0, section_1.matchSection)(filterType(section, type), props);
      return result.match ? result.matches : {};
    }
    exports2.findResources = findResources;
    function allResources(template, type, props) {
      const section = template.Resources ?? {}, result = (0, section_1.matchSection)(filterType(section, type), props);
      if (result.match) {
        const matchCount = Object.keys(result.matches).length;
        if (result.analyzedCount > matchCount)
          return [`Template has ${result.analyzedCount} resource(s) with type ${type}, but only ${matchCount} match as expected.`, (0, section_1.formatAllMismatches)(result.analyzed, result.matches)].join(`
`);
      } else
        return [`Template has ${result.analyzedCount} resource(s) with type ${type}, but none match as expected.`, (0, section_1.formatAllMismatches)(result.analyzed)].join(`
`);
    }
    exports2.allResources = allResources;
    function allResourcesProperties(template, type, props) {
      let amended = template;
      return (!__1.Matcher.isMatcher(props) || !(props instanceof absent_1.AbsentMatch)) && (amended = JSON.parse(JSON.stringify(template)), amended = addEmptyProperties(amended)), allResources(amended, type, __1.Match.objectLike({ Properties: props }));
    }
    exports2.allResourcesProperties = allResourcesProperties;
    function hasResource(template, type, props) {
      const section = template.Resources ?? {}, result = (0, section_1.matchSection)(filterType(section, type), props);
      if (!result.match)
        return (0, section_1.formatSectionMatchFailure)(`resources with type ${type}`, result);
    }
    exports2.hasResource = hasResource;
    function hasResourceProperties(template, type, props) {
      let amended = template;
      return (!__1.Matcher.isMatcher(props) || !(props instanceof absent_1.AbsentMatch)) && (amended = JSON.parse(JSON.stringify(template)), amended = addEmptyProperties(amended)), hasResource(amended, type, __1.Match.objectLike({ Properties: props }));
    }
    exports2.hasResourceProperties = hasResourceProperties;
    function countResources(template, type) {
      const section = template.Resources ?? {}, types = filterType(section, type);
      return Object.entries(types).length;
    }
    exports2.countResources = countResources;
    function countResourcesProperties(template, type, props) {
      let amended = template;
      (!__1.Matcher.isMatcher(props) || !(props instanceof absent_1.AbsentMatch)) && (amended = JSON.parse(JSON.stringify(template)), amended = addEmptyProperties(amended));
      const section = amended.Resources ?? {}, result = (0, section_1.matchSection)(filterType(section, type), __1.Match.objectLike({ Properties: props }));
      return result.match ? Object.keys(result.matches).length : 0;
    }
    exports2.countResourcesProperties = countResourcesProperties;
    function addEmptyProperties(template) {
      let section = template.Resources ?? {};
      return Object.keys(section).map((key) => {
        section[key].hasOwnProperty("Properties") || (section[key].Properties = {});
      }), template;
    }
    function filterType(section, type) {
      return Object.entries(section ?? {}).filter(([_, v]) => v.Type === type).reduce((agg, [k, v]) => ({ ...agg, [k]: v }), {});
    }
  }
});

// node_modules/aws-cdk-lib/assertions/lib/template.js
var require_template = __commonJS({
  "node_modules/aws-cdk-lib/assertions/lib/template.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Template = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var path = require("path");
    var fs = require_lib6();
    var match_1 = require_match();
    var matcher_1 = require_matcher();
    var conditions_1 = require_conditions();
    var cyclic_1 = require_cyclic();
    var mappings_1 = require_mappings();
    var outputs_1 = require_outputs();
    var parameters_1 = require_parameters();
    var resources_1 = require_resources();
    var core_1 = require_core2();
    var Template = class _Template {
      static fromStack(stack, templateParsingOptions) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Stack(stack), jsiiDeprecationWarnings.aws_cdk_lib_assertions_TemplateParsingOptions(templateParsingOptions);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromStack), error;
        }
        return new _Template(toTemplate(stack), templateParsingOptions);
      }
      static fromJSON(template, templateParsingOptions) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_assertions_TemplateParsingOptions(templateParsingOptions);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromJSON), error;
        }
        return new _Template(template, templateParsingOptions);
      }
      static fromString(template, templateParsingOptions) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_assertions_TemplateParsingOptions(templateParsingOptions);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromString), error;
        }
        return new _Template(JSON.parse(template), templateParsingOptions);
      }
      constructor(template, templateParsingOptions = {}) {
        this.template = template, templateParsingOptions?.skipCyclicalDependenciesCheck || (0, cyclic_1.checkTemplateForCyclicDependencies)(this.template);
      }
      toJSON() {
        return this.template;
      }
      resourceCountIs(type, count) {
        const counted = (0, resources_1.countResources)(this.template, type);
        if (counted !== count)
          throw new Error(`Expected ${count} resources of type ${type} but found ${counted}`);
      }
      resourcePropertiesCountIs(type, props, count) {
        const counted = (0, resources_1.countResourcesProperties)(this.template, type, props);
        if (counted !== count)
          throw new Error(`Expected ${count} resources of type ${type} but found ${counted}`);
      }
      hasResourceProperties(type, props) {
        const matchError = (0, resources_1.hasResourceProperties)(this.template, type, props);
        if (matchError)
          throw new Error(matchError);
      }
      hasResource(type, props) {
        const matchError = (0, resources_1.hasResource)(this.template, type, props);
        if (matchError)
          throw new Error(matchError);
      }
      findResources(type, props = {}) {
        return (0, resources_1.findResources)(this.template, type, props);
      }
      allResources(type, props) {
        const matchError = (0, resources_1.allResources)(this.template, type, props);
        if (matchError)
          throw new Error(matchError);
      }
      allResourcesProperties(type, props) {
        const matchError = (0, resources_1.allResourcesProperties)(this.template, type, props);
        if (matchError)
          throw new Error(matchError);
      }
      hasParameter(logicalId, props) {
        const matchError = (0, parameters_1.hasParameter)(this.template, logicalId, props);
        if (matchError)
          throw new Error(matchError);
      }
      findParameters(logicalId, props = {}) {
        return (0, parameters_1.findParameters)(this.template, logicalId, props);
      }
      hasOutput(logicalId, props) {
        const matchError = (0, outputs_1.hasOutput)(this.template, logicalId, props);
        if (matchError)
          throw new Error(matchError);
      }
      findOutputs(logicalId, props = {}) {
        return (0, outputs_1.findOutputs)(this.template, logicalId, props);
      }
      hasMapping(logicalId, props) {
        const matchError = (0, mappings_1.hasMapping)(this.template, logicalId, props);
        if (matchError)
          throw new Error(matchError);
      }
      findMappings(logicalId, props = {}) {
        return (0, mappings_1.findMappings)(this.template, logicalId, props);
      }
      hasCondition(logicalId, props) {
        const matchError = (0, conditions_1.hasCondition)(this.template, logicalId, props);
        if (matchError)
          throw new Error(matchError);
      }
      findConditions(logicalId, props = {}) {
        return (0, conditions_1.findConditions)(this.template, logicalId, props);
      }
      templateMatches(expected) {
        const result = (matcher_1.Matcher.isMatcher(expected) ? expected : match_1.Match.objectLike(expected)).test(this.template);
        if (result.hasFailed())
          throw new Error(["Template did not match as expected. The following mismatches were found:", ...result.toHumanStrings().map((s) => `	${s}`)].join(`
`));
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Template[_a] = { fqn: "aws-cdk-lib.assertions.Template", version: "2.80.0" }, exports2.Template = Template;
    function toTemplate(stack) {
      const stage = core_1.Stage.of(stack);
      if (!core_1.Stage.isStage(stage))
        throw new Error("unexpected: all stacks must be part of a Stage or an App");
      const assembly = stage.synth();
      return stack.nestedStackParent ? JSON.parse(fs.readFileSync(path.join(assembly.directory, stack.templateFile)).toString("utf-8")) : assembly.getStackArtifact(stack.artifactId).template;
    }
  }
});

// node_modules/aws-cdk-lib/assertions/lib/private/messages.js
var require_messages = __commonJS({
  "node_modules/aws-cdk-lib/assertions/lib/private/messages.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.hasNoMessage = exports2.hasMessage = exports2.findMessage = void 0;
    var section_1 = require_section();
    function findMessage(messages, constructPath, props = {}) {
      const section = messages, result = (0, section_1.matchSection)(filterPath(section, constructPath), props);
      return result.match ? result.matches : {};
    }
    exports2.findMessage = findMessage;
    function hasMessage(messages, constructPath, props) {
      const section = messages, result = (0, section_1.matchSection)(filterPath(section, constructPath), props);
      if (!result.match) {
        for (const mr of Object.values(result.closestResults))
          redactTraces(mr.target);
        return (0, section_1.formatSectionMatchFailure)(`messages at path ${constructPath}`, result, "Stack");
      }
    }
    exports2.hasMessage = hasMessage;
    function hasNoMessage(messages, constructPath, props) {
      const section = messages, result = (0, section_1.matchSection)(filterPath(section, constructPath), props);
      if (result.match)
        return [`Expected no matches, but stack has ${Object.keys(result.matches).length} messages as follows:`, (0, section_1.formatAllMatches)(result.matches)].join(`
`);
    }
    exports2.hasNoMessage = hasNoMessage;
    function redactTraces(match, redact = true) {
      redact && match.entry?.trace !== void 0 && (match.entry.trace = "redacted");
    }
    function filterPath(section, path) {
      return path === "*" ? section : Object.entries(section ?? {}).filter(([_, v]) => v.id === path).reduce((agg, [k, v]) => ({ ...agg, [k]: v }), {});
    }
  }
});

// node_modules/aws-cdk-lib/assertions/lib/annotations.js
var require_annotations2 = __commonJS({
  "node_modules/aws-cdk-lib/assertions/lib/annotations.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Annotations = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var messages_1 = require_messages();
    var core_1 = require_core2();
    var Annotations = class _Annotations {
      static fromStack(stack) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Stack(stack);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromStack), error;
        }
        return new _Annotations(toMessages(stack));
      }
      constructor(messages) {
        this._messages = convertArrayToMessagesType(messages);
      }
      hasError(constructPath, message) {
        const matchError = (0, messages_1.hasMessage)(this._messages, constructPath, constructMessage("error", message));
        if (matchError)
          throw new Error(matchError);
      }
      hasNoError(constructPath, message) {
        const matchError = (0, messages_1.hasNoMessage)(this._messages, constructPath, constructMessage("error", message));
        if (matchError)
          throw new Error(matchError);
      }
      findError(constructPath, message) {
        return convertMessagesTypeToArray((0, messages_1.findMessage)(this._messages, constructPath, constructMessage("error", message)));
      }
      hasWarning(constructPath, message) {
        const matchError = (0, messages_1.hasMessage)(this._messages, constructPath, constructMessage("warning", message));
        if (matchError)
          throw new Error(matchError);
      }
      hasNoWarning(constructPath, message) {
        const matchError = (0, messages_1.hasNoMessage)(this._messages, constructPath, constructMessage("warning", message));
        if (matchError)
          throw new Error(matchError);
      }
      findWarning(constructPath, message) {
        return convertMessagesTypeToArray((0, messages_1.findMessage)(this._messages, constructPath, constructMessage("warning", message)));
      }
      hasInfo(constructPath, message) {
        const matchError = (0, messages_1.hasMessage)(this._messages, constructPath, constructMessage("info", message));
        if (matchError)
          throw new Error(matchError);
      }
      hasNoInfo(constructPath, message) {
        const matchError = (0, messages_1.hasNoMessage)(this._messages, constructPath, constructMessage("info", message));
        if (matchError)
          throw new Error(matchError);
      }
      findInfo(constructPath, message) {
        return convertMessagesTypeToArray((0, messages_1.findMessage)(this._messages, constructPath, constructMessage("info", message)));
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Annotations[_a] = { fqn: "aws-cdk-lib.assertions.Annotations", version: "2.80.0" }, exports2.Annotations = Annotations;
    function constructMessage(type, message) {
      return { level: type, entry: { data: message } };
    }
    function convertArrayToMessagesType(messages) {
      return messages.reduce((obj, item, index) => ({ ...obj, [index]: item }), {});
    }
    function convertMessagesTypeToArray(messages) {
      return Object.values(messages);
    }
    function toMessages(stack) {
      const root = stack.node.root;
      if (!core_1.Stage.isStage(root))
        throw new Error("unexpected: all stacks must be part of a Stage or an App");
      const force = true;
      return root.synth({ force }).getStackArtifact(stack.artifactId).messages;
    }
  }
});

// node_modules/aws-cdk-lib/assertions/lib/index.js
var require_lib32 = __commonJS({
  "node_modules/aws-cdk-lib/assertions/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_capture(), exports2), __exportStar(require_template(), exports2), __exportStar(require_match(), exports2), __exportStar(require_matcher(), exports2), __exportStar(require_annotations2(), exports2);
  }
});

// node_modules/aws-cdk-lib/assertions/index.js
var require_assertions = __commonJS({
  "node_modules/aws-cdk-lib/assertions/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib32(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-accessanalyzer/lib/accessanalyzer.generated.js
var require_accessanalyzer_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-accessanalyzer/lib/accessanalyzer.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnAnalyzer = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAnalyzerPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("analyzerName", cdk.validateString)(properties.analyzerName)), errors.collect(cdk.propertyValidator("archiveRules", cdk.listValidator(CfnAnalyzer_ArchiveRulePropertyValidator))(properties.archiveRules)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnAnalyzerProps"');
    }
    function cfnAnalyzerPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalyzerPropsValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type), AnalyzerName: cdk.stringToCloudFormation(properties.analyzerName), ArchiveRules: cdk.listMapper(cfnAnalyzerArchiveRulePropertyToCloudFormation)(properties.archiveRules), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnAnalyzerPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("analyzerName", "AnalyzerName", properties.AnalyzerName != null ? cfn_parse.FromCloudFormation.getString(properties.AnalyzerName) : void 0), ret.addPropertyResult("archiveRules", "ArchiveRules", properties.ArchiveRules != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalyzerArchiveRulePropertyFromCloudFormation)(properties.ArchiveRules) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAnalyzer = class _CfnAnalyzer extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAnalyzerPropsFromCloudFormation(resourceProperties), ret = new _CfnAnalyzer(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAnalyzer.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_accessanalyzer_CfnAnalyzerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAnalyzer), error;
        }
        cdk.requireProperty(props, "type", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.type = props.type, this.analyzerName = props.analyzerName, this.archiveRules = props.archiveRules, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::AccessAnalyzer::Analyzer", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAnalyzer.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { type: this.type, analyzerName: this.analyzerName, archiveRules: this.archiveRules, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnAnalyzerPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAnalyzer[_a] = { fqn: "aws-cdk-lib.aws_accessanalyzer.CfnAnalyzer", version: "2.80.0" }, CfnAnalyzer.CFN_RESOURCE_TYPE_NAME = "AWS::AccessAnalyzer::Analyzer", exports2.CfnAnalyzer = CfnAnalyzer;
    function CfnAnalyzer_ArchiveRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("filter", cdk.requiredValidator)(properties.filter)), errors.collect(cdk.propertyValidator("filter", cdk.listValidator(CfnAnalyzer_FilterPropertyValidator))(properties.filter)), errors.collect(cdk.propertyValidator("ruleName", cdk.requiredValidator)(properties.ruleName)), errors.collect(cdk.propertyValidator("ruleName", cdk.validateString)(properties.ruleName)), errors.wrap('supplied properties not correct for "ArchiveRuleProperty"');
    }
    function cfnAnalyzerArchiveRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalyzer_ArchiveRulePropertyValidator(properties).assertSuccess(), { Filter: cdk.listMapper(cfnAnalyzerFilterPropertyToCloudFormation)(properties.filter), RuleName: cdk.stringToCloudFormation(properties.ruleName) }) : properties;
    }
    function CfnAnalyzerArchiveRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("filter", "Filter", cfn_parse.FromCloudFormation.getArray(CfnAnalyzerFilterPropertyFromCloudFormation)(properties.Filter)), ret.addPropertyResult("ruleName", "RuleName", cfn_parse.FromCloudFormation.getString(properties.RuleName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalyzer_FilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contains", cdk.listValidator(cdk.validateString))(properties.contains)), errors.collect(cdk.propertyValidator("eq", cdk.listValidator(cdk.validateString))(properties.eq)), errors.collect(cdk.propertyValidator("exists", cdk.validateBoolean)(properties.exists)), errors.collect(cdk.propertyValidator("neq", cdk.listValidator(cdk.validateString))(properties.neq)), errors.collect(cdk.propertyValidator("property", cdk.requiredValidator)(properties.property)), errors.collect(cdk.propertyValidator("property", cdk.validateString)(properties.property)), errors.wrap('supplied properties not correct for "FilterProperty"');
    }
    function cfnAnalyzerFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalyzer_FilterPropertyValidator(properties).assertSuccess(), { Contains: cdk.listMapper(cdk.stringToCloudFormation)(properties.contains), Eq: cdk.listMapper(cdk.stringToCloudFormation)(properties.eq), Exists: cdk.booleanToCloudFormation(properties.exists), Neq: cdk.listMapper(cdk.stringToCloudFormation)(properties.neq), Property: cdk.stringToCloudFormation(properties.property) }) : properties;
    }
    function CfnAnalyzerFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contains", "Contains", properties.Contains != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Contains) : void 0), ret.addPropertyResult("eq", "Eq", properties.Eq != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Eq) : void 0), ret.addPropertyResult("exists", "Exists", properties.Exists != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Exists) : void 0), ret.addPropertyResult("neq", "Neq", properties.Neq != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Neq) : void 0), ret.addPropertyResult("property", "Property", cfn_parse.FromCloudFormation.getString(properties.Property)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-accessanalyzer/lib/index.js
var require_lib33 = __commonJS({
  "node_modules/aws-cdk-lib/aws-accessanalyzer/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_accessanalyzer_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-accessanalyzer/index.js
var require_aws_accessanalyzer = __commonJS({
  "node_modules/aws-cdk-lib/aws-accessanalyzer/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib33(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-acmpca/lib/acmpca.generated.js
var require_acmpca_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-acmpca/lib/acmpca.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnPermission = exports2.CfnCertificateAuthorityActivation = exports2.CfnCertificateAuthority = exports2.CfnCertificate = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnCertificatePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiPassthrough", CfnCertificate_ApiPassthroughPropertyValidator)(properties.apiPassthrough)), errors.collect(cdk.propertyValidator("certificateAuthorityArn", cdk.requiredValidator)(properties.certificateAuthorityArn)), errors.collect(cdk.propertyValidator("certificateAuthorityArn", cdk.validateString)(properties.certificateAuthorityArn)), errors.collect(cdk.propertyValidator("certificateSigningRequest", cdk.requiredValidator)(properties.certificateSigningRequest)), errors.collect(cdk.propertyValidator("certificateSigningRequest", cdk.validateString)(properties.certificateSigningRequest)), errors.collect(cdk.propertyValidator("signingAlgorithm", cdk.requiredValidator)(properties.signingAlgorithm)), errors.collect(cdk.propertyValidator("signingAlgorithm", cdk.validateString)(properties.signingAlgorithm)), errors.collect(cdk.propertyValidator("templateArn", cdk.validateString)(properties.templateArn)), errors.collect(cdk.propertyValidator("validity", cdk.requiredValidator)(properties.validity)), errors.collect(cdk.propertyValidator("validity", CfnCertificate_ValidityPropertyValidator)(properties.validity)), errors.collect(cdk.propertyValidator("validityNotBefore", CfnCertificate_ValidityPropertyValidator)(properties.validityNotBefore)), errors.wrap('supplied properties not correct for "CfnCertificateProps"');
    }
    function cfnCertificatePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificatePropsValidator(properties).assertSuccess(), { CertificateAuthorityArn: cdk.stringToCloudFormation(properties.certificateAuthorityArn), CertificateSigningRequest: cdk.stringToCloudFormation(properties.certificateSigningRequest), SigningAlgorithm: cdk.stringToCloudFormation(properties.signingAlgorithm), Validity: cfnCertificateValidityPropertyToCloudFormation(properties.validity), ApiPassthrough: cfnCertificateApiPassthroughPropertyToCloudFormation(properties.apiPassthrough), TemplateArn: cdk.stringToCloudFormation(properties.templateArn), ValidityNotBefore: cfnCertificateValidityPropertyToCloudFormation(properties.validityNotBefore) }) : properties;
    }
    function CfnCertificatePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificateAuthorityArn", "CertificateAuthorityArn", cfn_parse.FromCloudFormation.getString(properties.CertificateAuthorityArn)), ret.addPropertyResult("certificateSigningRequest", "CertificateSigningRequest", cfn_parse.FromCloudFormation.getString(properties.CertificateSigningRequest)), ret.addPropertyResult("signingAlgorithm", "SigningAlgorithm", cfn_parse.FromCloudFormation.getString(properties.SigningAlgorithm)), ret.addPropertyResult("validity", "Validity", CfnCertificateValidityPropertyFromCloudFormation(properties.Validity)), ret.addPropertyResult("apiPassthrough", "ApiPassthrough", properties.ApiPassthrough != null ? CfnCertificateApiPassthroughPropertyFromCloudFormation(properties.ApiPassthrough) : void 0), ret.addPropertyResult("templateArn", "TemplateArn", properties.TemplateArn != null ? cfn_parse.FromCloudFormation.getString(properties.TemplateArn) : void 0), ret.addPropertyResult("validityNotBefore", "ValidityNotBefore", properties.ValidityNotBefore != null ? CfnCertificateValidityPropertyFromCloudFormation(properties.ValidityNotBefore) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCertificate = class _CfnCertificate extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCertificatePropsFromCloudFormation(resourceProperties), ret = new _CfnCertificate(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCertificate.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_acmpca_CfnCertificateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCertificate), error;
        }
        cdk.requireProperty(props, "certificateAuthorityArn", this), cdk.requireProperty(props, "certificateSigningRequest", this), cdk.requireProperty(props, "signingAlgorithm", this), cdk.requireProperty(props, "validity", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCertificate = cdk.Token.asString(this.getAtt("Certificate", cdk.ResolutionTypeHint.STRING)), this.certificateAuthorityArn = props.certificateAuthorityArn, this.certificateSigningRequest = props.certificateSigningRequest, this.signingAlgorithm = props.signingAlgorithm, this.validity = props.validity, this.apiPassthrough = props.apiPassthrough, this.templateArn = props.templateArn, this.validityNotBefore = props.validityNotBefore;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCertificate.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { certificateAuthorityArn: this.certificateAuthorityArn, certificateSigningRequest: this.certificateSigningRequest, signingAlgorithm: this.signingAlgorithm, validity: this.validity, apiPassthrough: this.apiPassthrough, templateArn: this.templateArn, validityNotBefore: this.validityNotBefore };
      }
      renderProperties(props) {
        return cfnCertificatePropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnCertificate[_a] = { fqn: "aws-cdk-lib.aws_acmpca.CfnCertificate", version: "2.80.0" }, CfnCertificate.CFN_RESOURCE_TYPE_NAME = "AWS::ACMPCA::Certificate", exports2.CfnCertificate = CfnCertificate;
    function CfnCertificate_ApiPassthroughPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("extensions", CfnCertificate_ExtensionsPropertyValidator)(properties.extensions)), errors.collect(cdk.propertyValidator("subject", CfnCertificate_SubjectPropertyValidator)(properties.subject)), errors.wrap('supplied properties not correct for "ApiPassthroughProperty"');
    }
    function cfnCertificateApiPassthroughPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificate_ApiPassthroughPropertyValidator(properties).assertSuccess(), { Extensions: cfnCertificateExtensionsPropertyToCloudFormation(properties.extensions), Subject: cfnCertificateSubjectPropertyToCloudFormation(properties.subject) }) : properties;
    }
    function CfnCertificateApiPassthroughPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("extensions", "Extensions", properties.Extensions != null ? CfnCertificateExtensionsPropertyFromCloudFormation(properties.Extensions) : void 0), ret.addPropertyResult("subject", "Subject", properties.Subject != null ? CfnCertificateSubjectPropertyFromCloudFormation(properties.Subject) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCertificate_CustomAttributePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("objectIdentifier", cdk.requiredValidator)(properties.objectIdentifier)), errors.collect(cdk.propertyValidator("objectIdentifier", cdk.validateString)(properties.objectIdentifier)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "CustomAttributeProperty"');
    }
    function cfnCertificateCustomAttributePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificate_CustomAttributePropertyValidator(properties).assertSuccess(), { ObjectIdentifier: cdk.stringToCloudFormation(properties.objectIdentifier), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnCertificateCustomAttributePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("objectIdentifier", "ObjectIdentifier", cfn_parse.FromCloudFormation.getString(properties.ObjectIdentifier)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCertificate_CustomExtensionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("critical", cdk.validateBoolean)(properties.critical)), errors.collect(cdk.propertyValidator("objectIdentifier", cdk.requiredValidator)(properties.objectIdentifier)), errors.collect(cdk.propertyValidator("objectIdentifier", cdk.validateString)(properties.objectIdentifier)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "CustomExtensionProperty"');
    }
    function cfnCertificateCustomExtensionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificate_CustomExtensionPropertyValidator(properties).assertSuccess(), { Critical: cdk.booleanToCloudFormation(properties.critical), ObjectIdentifier: cdk.stringToCloudFormation(properties.objectIdentifier), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnCertificateCustomExtensionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("critical", "Critical", properties.Critical != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Critical) : void 0), ret.addPropertyResult("objectIdentifier", "ObjectIdentifier", cfn_parse.FromCloudFormation.getString(properties.ObjectIdentifier)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCertificate_EdiPartyNamePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("nameAssigner", cdk.requiredValidator)(properties.nameAssigner)), errors.collect(cdk.propertyValidator("nameAssigner", cdk.validateString)(properties.nameAssigner)), errors.collect(cdk.propertyValidator("partyName", cdk.requiredValidator)(properties.partyName)), errors.collect(cdk.propertyValidator("partyName", cdk.validateString)(properties.partyName)), errors.wrap('supplied properties not correct for "EdiPartyNameProperty"');
    }
    function cfnCertificateEdiPartyNamePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificate_EdiPartyNamePropertyValidator(properties).assertSuccess(), { NameAssigner: cdk.stringToCloudFormation(properties.nameAssigner), PartyName: cdk.stringToCloudFormation(properties.partyName) }) : properties;
    }
    function CfnCertificateEdiPartyNamePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("nameAssigner", "NameAssigner", cfn_parse.FromCloudFormation.getString(properties.NameAssigner)), ret.addPropertyResult("partyName", "PartyName", cfn_parse.FromCloudFormation.getString(properties.PartyName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCertificate_ExtendedKeyUsagePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("extendedKeyUsageObjectIdentifier", cdk.validateString)(properties.extendedKeyUsageObjectIdentifier)), errors.collect(cdk.propertyValidator("extendedKeyUsageType", cdk.validateString)(properties.extendedKeyUsageType)), errors.wrap('supplied properties not correct for "ExtendedKeyUsageProperty"');
    }
    function cfnCertificateExtendedKeyUsagePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificate_ExtendedKeyUsagePropertyValidator(properties).assertSuccess(), { ExtendedKeyUsageObjectIdentifier: cdk.stringToCloudFormation(properties.extendedKeyUsageObjectIdentifier), ExtendedKeyUsageType: cdk.stringToCloudFormation(properties.extendedKeyUsageType) }) : properties;
    }
    function CfnCertificateExtendedKeyUsagePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("extendedKeyUsageObjectIdentifier", "ExtendedKeyUsageObjectIdentifier", properties.ExtendedKeyUsageObjectIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.ExtendedKeyUsageObjectIdentifier) : void 0), ret.addPropertyResult("extendedKeyUsageType", "ExtendedKeyUsageType", properties.ExtendedKeyUsageType != null ? cfn_parse.FromCloudFormation.getString(properties.ExtendedKeyUsageType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCertificate_ExtensionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificatePolicies", cdk.listValidator(CfnCertificate_PolicyInformationPropertyValidator))(properties.certificatePolicies)), errors.collect(cdk.propertyValidator("customExtensions", cdk.listValidator(CfnCertificate_CustomExtensionPropertyValidator))(properties.customExtensions)), errors.collect(cdk.propertyValidator("extendedKeyUsage", cdk.listValidator(CfnCertificate_ExtendedKeyUsagePropertyValidator))(properties.extendedKeyUsage)), errors.collect(cdk.propertyValidator("keyUsage", CfnCertificate_KeyUsagePropertyValidator)(properties.keyUsage)), errors.collect(cdk.propertyValidator("subjectAlternativeNames", cdk.listValidator(CfnCertificate_GeneralNamePropertyValidator))(properties.subjectAlternativeNames)), errors.wrap('supplied properties not correct for "ExtensionsProperty"');
    }
    function cfnCertificateExtensionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificate_ExtensionsPropertyValidator(properties).assertSuccess(), { CertificatePolicies: cdk.listMapper(cfnCertificatePolicyInformationPropertyToCloudFormation)(properties.certificatePolicies), CustomExtensions: cdk.listMapper(cfnCertificateCustomExtensionPropertyToCloudFormation)(properties.customExtensions), ExtendedKeyUsage: cdk.listMapper(cfnCertificateExtendedKeyUsagePropertyToCloudFormation)(properties.extendedKeyUsage), KeyUsage: cfnCertificateKeyUsagePropertyToCloudFormation(properties.keyUsage), SubjectAlternativeNames: cdk.listMapper(cfnCertificateGeneralNamePropertyToCloudFormation)(properties.subjectAlternativeNames) }) : properties;
    }
    function CfnCertificateExtensionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificatePolicies", "CertificatePolicies", properties.CertificatePolicies != null ? cfn_parse.FromCloudFormation.getArray(CfnCertificatePolicyInformationPropertyFromCloudFormation)(properties.CertificatePolicies) : void 0), ret.addPropertyResult("customExtensions", "CustomExtensions", properties.CustomExtensions != null ? cfn_parse.FromCloudFormation.getArray(CfnCertificateCustomExtensionPropertyFromCloudFormation)(properties.CustomExtensions) : void 0), ret.addPropertyResult("extendedKeyUsage", "ExtendedKeyUsage", properties.ExtendedKeyUsage != null ? cfn_parse.FromCloudFormation.getArray(CfnCertificateExtendedKeyUsagePropertyFromCloudFormation)(properties.ExtendedKeyUsage) : void 0), ret.addPropertyResult("keyUsage", "KeyUsage", properties.KeyUsage != null ? CfnCertificateKeyUsagePropertyFromCloudFormation(properties.KeyUsage) : void 0), ret.addPropertyResult("subjectAlternativeNames", "SubjectAlternativeNames", properties.SubjectAlternativeNames != null ? cfn_parse.FromCloudFormation.getArray(CfnCertificateGeneralNamePropertyFromCloudFormation)(properties.SubjectAlternativeNames) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCertificate_GeneralNamePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("directoryName", CfnCertificate_SubjectPropertyValidator)(properties.directoryName)), errors.collect(cdk.propertyValidator("dnsName", cdk.validateString)(properties.dnsName)), errors.collect(cdk.propertyValidator("ediPartyName", CfnCertificate_EdiPartyNamePropertyValidator)(properties.ediPartyName)), errors.collect(cdk.propertyValidator("ipAddress", cdk.validateString)(properties.ipAddress)), errors.collect(cdk.propertyValidator("otherName", CfnCertificate_OtherNamePropertyValidator)(properties.otherName)), errors.collect(cdk.propertyValidator("registeredId", cdk.validateString)(properties.registeredId)), errors.collect(cdk.propertyValidator("rfc822Name", cdk.validateString)(properties.rfc822Name)), errors.collect(cdk.propertyValidator("uniformResourceIdentifier", cdk.validateString)(properties.uniformResourceIdentifier)), errors.wrap('supplied properties not correct for "GeneralNameProperty"');
    }
    function cfnCertificateGeneralNamePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificate_GeneralNamePropertyValidator(properties).assertSuccess(), { DirectoryName: cfnCertificateSubjectPropertyToCloudFormation(properties.directoryName), DnsName: cdk.stringToCloudFormation(properties.dnsName), EdiPartyName: cfnCertificateEdiPartyNamePropertyToCloudFormation(properties.ediPartyName), IpAddress: cdk.stringToCloudFormation(properties.ipAddress), OtherName: cfnCertificateOtherNamePropertyToCloudFormation(properties.otherName), RegisteredId: cdk.stringToCloudFormation(properties.registeredId), Rfc822Name: cdk.stringToCloudFormation(properties.rfc822Name), UniformResourceIdentifier: cdk.stringToCloudFormation(properties.uniformResourceIdentifier) }) : properties;
    }
    function CfnCertificateGeneralNamePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("directoryName", "DirectoryName", properties.DirectoryName != null ? CfnCertificateSubjectPropertyFromCloudFormation(properties.DirectoryName) : void 0), ret.addPropertyResult("dnsName", "DnsName", properties.DnsName != null ? cfn_parse.FromCloudFormation.getString(properties.DnsName) : void 0), ret.addPropertyResult("ediPartyName", "EdiPartyName", properties.EdiPartyName != null ? CfnCertificateEdiPartyNamePropertyFromCloudFormation(properties.EdiPartyName) : void 0), ret.addPropertyResult("ipAddress", "IpAddress", properties.IpAddress != null ? cfn_parse.FromCloudFormation.getString(properties.IpAddress) : void 0), ret.addPropertyResult("otherName", "OtherName", properties.OtherName != null ? CfnCertificateOtherNamePropertyFromCloudFormation(properties.OtherName) : void 0), ret.addPropertyResult("registeredId", "RegisteredId", properties.RegisteredId != null ? cfn_parse.FromCloudFormation.getString(properties.RegisteredId) : void 0), ret.addPropertyResult("rfc822Name", "Rfc822Name", properties.Rfc822Name != null ? cfn_parse.FromCloudFormation.getString(properties.Rfc822Name) : void 0), ret.addPropertyResult("uniformResourceIdentifier", "UniformResourceIdentifier", properties.UniformResourceIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.UniformResourceIdentifier) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCertificate_KeyUsagePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("crlSign", cdk.validateBoolean)(properties.crlSign)), errors.collect(cdk.propertyValidator("dataEncipherment", cdk.validateBoolean)(properties.dataEncipherment)), errors.collect(cdk.propertyValidator("decipherOnly", cdk.validateBoolean)(properties.decipherOnly)), errors.collect(cdk.propertyValidator("digitalSignature", cdk.validateBoolean)(properties.digitalSignature)), errors.collect(cdk.propertyValidator("encipherOnly", cdk.validateBoolean)(properties.encipherOnly)), errors.collect(cdk.propertyValidator("keyAgreement", cdk.validateBoolean)(properties.keyAgreement)), errors.collect(cdk.propertyValidator("keyCertSign", cdk.validateBoolean)(properties.keyCertSign)), errors.collect(cdk.propertyValidator("keyEncipherment", cdk.validateBoolean)(properties.keyEncipherment)), errors.collect(cdk.propertyValidator("nonRepudiation", cdk.validateBoolean)(properties.nonRepudiation)), errors.wrap('supplied properties not correct for "KeyUsageProperty"');
    }
    function cfnCertificateKeyUsagePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificate_KeyUsagePropertyValidator(properties).assertSuccess(), { CRLSign: cdk.booleanToCloudFormation(properties.crlSign), DataEncipherment: cdk.booleanToCloudFormation(properties.dataEncipherment), DecipherOnly: cdk.booleanToCloudFormation(properties.decipherOnly), DigitalSignature: cdk.booleanToCloudFormation(properties.digitalSignature), EncipherOnly: cdk.booleanToCloudFormation(properties.encipherOnly), KeyAgreement: cdk.booleanToCloudFormation(properties.keyAgreement), KeyCertSign: cdk.booleanToCloudFormation(properties.keyCertSign), KeyEncipherment: cdk.booleanToCloudFormation(properties.keyEncipherment), NonRepudiation: cdk.booleanToCloudFormation(properties.nonRepudiation) }) : properties;
    }
    function CfnCertificateKeyUsagePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("crlSign", "CRLSign", properties.CRLSign != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CRLSign) : void 0), ret.addPropertyResult("dataEncipherment", "DataEncipherment", properties.DataEncipherment != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DataEncipherment) : void 0), ret.addPropertyResult("decipherOnly", "DecipherOnly", properties.DecipherOnly != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DecipherOnly) : void 0), ret.addPropertyResult("digitalSignature", "DigitalSignature", properties.DigitalSignature != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DigitalSignature) : void 0), ret.addPropertyResult("encipherOnly", "EncipherOnly", properties.EncipherOnly != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EncipherOnly) : void 0), ret.addPropertyResult("keyAgreement", "KeyAgreement", properties.KeyAgreement != null ? cfn_parse.FromCloudFormation.getBoolean(properties.KeyAgreement) : void 0), ret.addPropertyResult("keyCertSign", "KeyCertSign", properties.KeyCertSign != null ? cfn_parse.FromCloudFormation.getBoolean(properties.KeyCertSign) : void 0), ret.addPropertyResult("keyEncipherment", "KeyEncipherment", properties.KeyEncipherment != null ? cfn_parse.FromCloudFormation.getBoolean(properties.KeyEncipherment) : void 0), ret.addPropertyResult("nonRepudiation", "NonRepudiation", properties.NonRepudiation != null ? cfn_parse.FromCloudFormation.getBoolean(properties.NonRepudiation) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCertificate_OtherNamePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("typeId", cdk.requiredValidator)(properties.typeId)), errors.collect(cdk.propertyValidator("typeId", cdk.validateString)(properties.typeId)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "OtherNameProperty"');
    }
    function cfnCertificateOtherNamePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificate_OtherNamePropertyValidator(properties).assertSuccess(), { TypeId: cdk.stringToCloudFormation(properties.typeId), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnCertificateOtherNamePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("typeId", "TypeId", cfn_parse.FromCloudFormation.getString(properties.TypeId)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCertificate_PolicyInformationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certPolicyId", cdk.requiredValidator)(properties.certPolicyId)), errors.collect(cdk.propertyValidator("certPolicyId", cdk.validateString)(properties.certPolicyId)), errors.collect(cdk.propertyValidator("policyQualifiers", cdk.listValidator(CfnCertificate_PolicyQualifierInfoPropertyValidator))(properties.policyQualifiers)), errors.wrap('supplied properties not correct for "PolicyInformationProperty"');
    }
    function cfnCertificatePolicyInformationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificate_PolicyInformationPropertyValidator(properties).assertSuccess(), { CertPolicyId: cdk.stringToCloudFormation(properties.certPolicyId), PolicyQualifiers: cdk.listMapper(cfnCertificatePolicyQualifierInfoPropertyToCloudFormation)(properties.policyQualifiers) }) : properties;
    }
    function CfnCertificatePolicyInformationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certPolicyId", "CertPolicyId", cfn_parse.FromCloudFormation.getString(properties.CertPolicyId)), ret.addPropertyResult("policyQualifiers", "PolicyQualifiers", properties.PolicyQualifiers != null ? cfn_parse.FromCloudFormation.getArray(CfnCertificatePolicyQualifierInfoPropertyFromCloudFormation)(properties.PolicyQualifiers) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCertificate_PolicyQualifierInfoPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("policyQualifierId", cdk.requiredValidator)(properties.policyQualifierId)), errors.collect(cdk.propertyValidator("policyQualifierId", cdk.validateString)(properties.policyQualifierId)), errors.collect(cdk.propertyValidator("qualifier", cdk.requiredValidator)(properties.qualifier)), errors.collect(cdk.propertyValidator("qualifier", CfnCertificate_QualifierPropertyValidator)(properties.qualifier)), errors.wrap('supplied properties not correct for "PolicyQualifierInfoProperty"');
    }
    function cfnCertificatePolicyQualifierInfoPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificate_PolicyQualifierInfoPropertyValidator(properties).assertSuccess(), { PolicyQualifierId: cdk.stringToCloudFormation(properties.policyQualifierId), Qualifier: cfnCertificateQualifierPropertyToCloudFormation(properties.qualifier) }) : properties;
    }
    function CfnCertificatePolicyQualifierInfoPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("policyQualifierId", "PolicyQualifierId", cfn_parse.FromCloudFormation.getString(properties.PolicyQualifierId)), ret.addPropertyResult("qualifier", "Qualifier", CfnCertificateQualifierPropertyFromCloudFormation(properties.Qualifier)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCertificate_QualifierPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cpsUri", cdk.requiredValidator)(properties.cpsUri)), errors.collect(cdk.propertyValidator("cpsUri", cdk.validateString)(properties.cpsUri)), errors.wrap('supplied properties not correct for "QualifierProperty"');
    }
    function cfnCertificateQualifierPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificate_QualifierPropertyValidator(properties).assertSuccess(), { CpsUri: cdk.stringToCloudFormation(properties.cpsUri) }) : properties;
    }
    function CfnCertificateQualifierPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cpsUri", "CpsUri", cfn_parse.FromCloudFormation.getString(properties.CpsUri)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCertificate_SubjectPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("commonName", cdk.validateString)(properties.commonName)), errors.collect(cdk.propertyValidator("country", cdk.validateString)(properties.country)), errors.collect(cdk.propertyValidator("customAttributes", cdk.listValidator(CfnCertificate_CustomAttributePropertyValidator))(properties.customAttributes)), errors.collect(cdk.propertyValidator("distinguishedNameQualifier", cdk.validateString)(properties.distinguishedNameQualifier)), errors.collect(cdk.propertyValidator("generationQualifier", cdk.validateString)(properties.generationQualifier)), errors.collect(cdk.propertyValidator("givenName", cdk.validateString)(properties.givenName)), errors.collect(cdk.propertyValidator("initials", cdk.validateString)(properties.initials)), errors.collect(cdk.propertyValidator("locality", cdk.validateString)(properties.locality)), errors.collect(cdk.propertyValidator("organization", cdk.validateString)(properties.organization)), errors.collect(cdk.propertyValidator("organizationalUnit", cdk.validateString)(properties.organizationalUnit)), errors.collect(cdk.propertyValidator("pseudonym", cdk.validateString)(properties.pseudonym)), errors.collect(cdk.propertyValidator("serialNumber", cdk.validateString)(properties.serialNumber)), errors.collect(cdk.propertyValidator("state", cdk.validateString)(properties.state)), errors.collect(cdk.propertyValidator("surname", cdk.validateString)(properties.surname)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.wrap('supplied properties not correct for "SubjectProperty"');
    }
    function cfnCertificateSubjectPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificate_SubjectPropertyValidator(properties).assertSuccess(), { CommonName: cdk.stringToCloudFormation(properties.commonName), Country: cdk.stringToCloudFormation(properties.country), CustomAttributes: cdk.listMapper(cfnCertificateCustomAttributePropertyToCloudFormation)(properties.customAttributes), DistinguishedNameQualifier: cdk.stringToCloudFormation(properties.distinguishedNameQualifier), GenerationQualifier: cdk.stringToCloudFormation(properties.generationQualifier), GivenName: cdk.stringToCloudFormation(properties.givenName), Initials: cdk.stringToCloudFormation(properties.initials), Locality: cdk.stringToCloudFormation(properties.locality), Organization: cdk.stringToCloudFormation(properties.organization), OrganizationalUnit: cdk.stringToCloudFormation(properties.organizationalUnit), Pseudonym: cdk.stringToCloudFormation(properties.pseudonym), SerialNumber: cdk.stringToCloudFormation(properties.serialNumber), State: cdk.stringToCloudFormation(properties.state), Surname: cdk.stringToCloudFormation(properties.surname), Title: cdk.stringToCloudFormation(properties.title) }) : properties;
    }
    function CfnCertificateSubjectPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("commonName", "CommonName", properties.CommonName != null ? cfn_parse.FromCloudFormation.getString(properties.CommonName) : void 0), ret.addPropertyResult("country", "Country", properties.Country != null ? cfn_parse.FromCloudFormation.getString(properties.Country) : void 0), ret.addPropertyResult("customAttributes", "CustomAttributes", properties.CustomAttributes != null ? cfn_parse.FromCloudFormation.getArray(CfnCertificateCustomAttributePropertyFromCloudFormation)(properties.CustomAttributes) : void 0), ret.addPropertyResult("distinguishedNameQualifier", "DistinguishedNameQualifier", properties.DistinguishedNameQualifier != null ? cfn_parse.FromCloudFormation.getString(properties.DistinguishedNameQualifier) : void 0), ret.addPropertyResult("generationQualifier", "GenerationQualifier", properties.GenerationQualifier != null ? cfn_parse.FromCloudFormation.getString(properties.GenerationQualifier) : void 0), ret.addPropertyResult("givenName", "GivenName", properties.GivenName != null ? cfn_parse.FromCloudFormation.getString(properties.GivenName) : void 0), ret.addPropertyResult("initials", "Initials", properties.Initials != null ? cfn_parse.FromCloudFormation.getString(properties.Initials) : void 0), ret.addPropertyResult("locality", "Locality", properties.Locality != null ? cfn_parse.FromCloudFormation.getString(properties.Locality) : void 0), ret.addPropertyResult("organization", "Organization", properties.Organization != null ? cfn_parse.FromCloudFormation.getString(properties.Organization) : void 0), ret.addPropertyResult("organizationalUnit", "OrganizationalUnit", properties.OrganizationalUnit != null ? cfn_parse.FromCloudFormation.getString(properties.OrganizationalUnit) : void 0), ret.addPropertyResult("pseudonym", "Pseudonym", properties.Pseudonym != null ? cfn_parse.FromCloudFormation.getString(properties.Pseudonym) : void 0), ret.addPropertyResult("serialNumber", "SerialNumber", properties.SerialNumber != null ? cfn_parse.FromCloudFormation.getString(properties.SerialNumber) : void 0), ret.addPropertyResult("state", "State", properties.State != null ? cfn_parse.FromCloudFormation.getString(properties.State) : void 0), ret.addPropertyResult("surname", "Surname", properties.Surname != null ? cfn_parse.FromCloudFormation.getString(properties.Surname) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? cfn_parse.FromCloudFormation.getString(properties.Title) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCertificate_ValidityPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "ValidityProperty"');
    }
    function cfnCertificateValidityPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificate_ValidityPropertyValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type), Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnCertificateValidityPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getNumber(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCertificateAuthorityPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("csrExtensions", CfnCertificateAuthority_CsrExtensionsPropertyValidator)(properties.csrExtensions)), errors.collect(cdk.propertyValidator("keyAlgorithm", cdk.requiredValidator)(properties.keyAlgorithm)), errors.collect(cdk.propertyValidator("keyAlgorithm", cdk.validateString)(properties.keyAlgorithm)), errors.collect(cdk.propertyValidator("keyStorageSecurityStandard", cdk.validateString)(properties.keyStorageSecurityStandard)), errors.collect(cdk.propertyValidator("revocationConfiguration", CfnCertificateAuthority_RevocationConfigurationPropertyValidator)(properties.revocationConfiguration)), errors.collect(cdk.propertyValidator("signingAlgorithm", cdk.requiredValidator)(properties.signingAlgorithm)), errors.collect(cdk.propertyValidator("signingAlgorithm", cdk.validateString)(properties.signingAlgorithm)), errors.collect(cdk.propertyValidator("subject", cdk.requiredValidator)(properties.subject)), errors.collect(cdk.propertyValidator("subject", CfnCertificateAuthority_SubjectPropertyValidator)(properties.subject)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("usageMode", cdk.validateString)(properties.usageMode)), errors.wrap('supplied properties not correct for "CfnCertificateAuthorityProps"');
    }
    function cfnCertificateAuthorityPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificateAuthorityPropsValidator(properties).assertSuccess(), { KeyAlgorithm: cdk.stringToCloudFormation(properties.keyAlgorithm), SigningAlgorithm: cdk.stringToCloudFormation(properties.signingAlgorithm), Subject: cfnCertificateAuthoritySubjectPropertyToCloudFormation(properties.subject), Type: cdk.stringToCloudFormation(properties.type), CsrExtensions: cfnCertificateAuthorityCsrExtensionsPropertyToCloudFormation(properties.csrExtensions), KeyStorageSecurityStandard: cdk.stringToCloudFormation(properties.keyStorageSecurityStandard), RevocationConfiguration: cfnCertificateAuthorityRevocationConfigurationPropertyToCloudFormation(properties.revocationConfiguration), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), UsageMode: cdk.stringToCloudFormation(properties.usageMode) }) : properties;
    }
    function CfnCertificateAuthorityPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("keyAlgorithm", "KeyAlgorithm", cfn_parse.FromCloudFormation.getString(properties.KeyAlgorithm)), ret.addPropertyResult("signingAlgorithm", "SigningAlgorithm", cfn_parse.FromCloudFormation.getString(properties.SigningAlgorithm)), ret.addPropertyResult("subject", "Subject", CfnCertificateAuthoritySubjectPropertyFromCloudFormation(properties.Subject)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("csrExtensions", "CsrExtensions", properties.CsrExtensions != null ? CfnCertificateAuthorityCsrExtensionsPropertyFromCloudFormation(properties.CsrExtensions) : void 0), ret.addPropertyResult("keyStorageSecurityStandard", "KeyStorageSecurityStandard", properties.KeyStorageSecurityStandard != null ? cfn_parse.FromCloudFormation.getString(properties.KeyStorageSecurityStandard) : void 0), ret.addPropertyResult("revocationConfiguration", "RevocationConfiguration", properties.RevocationConfiguration != null ? CfnCertificateAuthorityRevocationConfigurationPropertyFromCloudFormation(properties.RevocationConfiguration) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("usageMode", "UsageMode", properties.UsageMode != null ? cfn_parse.FromCloudFormation.getString(properties.UsageMode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCertificateAuthority = class _CfnCertificateAuthority extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCertificateAuthorityPropsFromCloudFormation(resourceProperties), ret = new _CfnCertificateAuthority(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCertificateAuthority.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_acmpca_CfnCertificateAuthorityProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCertificateAuthority), error;
        }
        cdk.requireProperty(props, "keyAlgorithm", this), cdk.requireProperty(props, "signingAlgorithm", this), cdk.requireProperty(props, "subject", this), cdk.requireProperty(props, "type", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCertificateSigningRequest = cdk.Token.asString(this.getAtt("CertificateSigningRequest", cdk.ResolutionTypeHint.STRING)), this.keyAlgorithm = props.keyAlgorithm, this.signingAlgorithm = props.signingAlgorithm, this.subject = props.subject, this.type = props.type, this.csrExtensions = props.csrExtensions, this.keyStorageSecurityStandard = props.keyStorageSecurityStandard, this.revocationConfiguration = props.revocationConfiguration, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ACMPCA::CertificateAuthority", props.tags, { tagPropertyName: "tags" }), this.usageMode = props.usageMode;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCertificateAuthority.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { keyAlgorithm: this.keyAlgorithm, signingAlgorithm: this.signingAlgorithm, subject: this.subject, type: this.type, csrExtensions: this.csrExtensions, keyStorageSecurityStandard: this.keyStorageSecurityStandard, revocationConfiguration: this.revocationConfiguration, tags: this.tags.renderTags(), usageMode: this.usageMode };
      }
      renderProperties(props) {
        return cfnCertificateAuthorityPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnCertificateAuthority[_b] = { fqn: "aws-cdk-lib.aws_acmpca.CfnCertificateAuthority", version: "2.80.0" }, CfnCertificateAuthority.CFN_RESOURCE_TYPE_NAME = "AWS::ACMPCA::CertificateAuthority", exports2.CfnCertificateAuthority = CfnCertificateAuthority;
    function CfnCertificateAuthority_AccessDescriptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessLocation", cdk.requiredValidator)(properties.accessLocation)), errors.collect(cdk.propertyValidator("accessLocation", CfnCertificateAuthority_GeneralNamePropertyValidator)(properties.accessLocation)), errors.collect(cdk.propertyValidator("accessMethod", cdk.requiredValidator)(properties.accessMethod)), errors.collect(cdk.propertyValidator("accessMethod", CfnCertificateAuthority_AccessMethodPropertyValidator)(properties.accessMethod)), errors.wrap('supplied properties not correct for "AccessDescriptionProperty"');
    }
    function cfnCertificateAuthorityAccessDescriptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificateAuthority_AccessDescriptionPropertyValidator(properties).assertSuccess(), { AccessLocation: cfnCertificateAuthorityGeneralNamePropertyToCloudFormation(properties.accessLocation), AccessMethod: cfnCertificateAuthorityAccessMethodPropertyToCloudFormation(properties.accessMethod) }) : properties;
    }
    function CfnCertificateAuthorityAccessDescriptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessLocation", "AccessLocation", CfnCertificateAuthorityGeneralNamePropertyFromCloudFormation(properties.AccessLocation)), ret.addPropertyResult("accessMethod", "AccessMethod", CfnCertificateAuthorityAccessMethodPropertyFromCloudFormation(properties.AccessMethod)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCertificateAuthority_AccessMethodPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessMethodType", cdk.validateString)(properties.accessMethodType)), errors.collect(cdk.propertyValidator("customObjectIdentifier", cdk.validateString)(properties.customObjectIdentifier)), errors.wrap('supplied properties not correct for "AccessMethodProperty"');
    }
    function cfnCertificateAuthorityAccessMethodPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificateAuthority_AccessMethodPropertyValidator(properties).assertSuccess(), { AccessMethodType: cdk.stringToCloudFormation(properties.accessMethodType), CustomObjectIdentifier: cdk.stringToCloudFormation(properties.customObjectIdentifier) }) : properties;
    }
    function CfnCertificateAuthorityAccessMethodPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessMethodType", "AccessMethodType", properties.AccessMethodType != null ? cfn_parse.FromCloudFormation.getString(properties.AccessMethodType) : void 0), ret.addPropertyResult("customObjectIdentifier", "CustomObjectIdentifier", properties.CustomObjectIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.CustomObjectIdentifier) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCertificateAuthority_CrlConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customCname", cdk.validateString)(properties.customCname)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("expirationInDays", cdk.validateNumber)(properties.expirationInDays)), errors.collect(cdk.propertyValidator("s3BucketName", cdk.validateString)(properties.s3BucketName)), errors.collect(cdk.propertyValidator("s3ObjectAcl", cdk.validateString)(properties.s3ObjectAcl)), errors.wrap('supplied properties not correct for "CrlConfigurationProperty"');
    }
    function cfnCertificateAuthorityCrlConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificateAuthority_CrlConfigurationPropertyValidator(properties).assertSuccess(), { CustomCname: cdk.stringToCloudFormation(properties.customCname), Enabled: cdk.booleanToCloudFormation(properties.enabled), ExpirationInDays: cdk.numberToCloudFormation(properties.expirationInDays), S3BucketName: cdk.stringToCloudFormation(properties.s3BucketName), S3ObjectAcl: cdk.stringToCloudFormation(properties.s3ObjectAcl) }) : properties;
    }
    function CfnCertificateAuthorityCrlConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customCname", "CustomCname", properties.CustomCname != null ? cfn_parse.FromCloudFormation.getString(properties.CustomCname) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("expirationInDays", "ExpirationInDays", properties.ExpirationInDays != null ? cfn_parse.FromCloudFormation.getNumber(properties.ExpirationInDays) : void 0), ret.addPropertyResult("s3BucketName", "S3BucketName", properties.S3BucketName != null ? cfn_parse.FromCloudFormation.getString(properties.S3BucketName) : void 0), ret.addPropertyResult("s3ObjectAcl", "S3ObjectAcl", properties.S3ObjectAcl != null ? cfn_parse.FromCloudFormation.getString(properties.S3ObjectAcl) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCertificateAuthority_CsrExtensionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("keyUsage", CfnCertificateAuthority_KeyUsagePropertyValidator)(properties.keyUsage)), errors.collect(cdk.propertyValidator("subjectInformationAccess", cdk.listValidator(CfnCertificateAuthority_AccessDescriptionPropertyValidator))(properties.subjectInformationAccess)), errors.wrap('supplied properties not correct for "CsrExtensionsProperty"');
    }
    function cfnCertificateAuthorityCsrExtensionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificateAuthority_CsrExtensionsPropertyValidator(properties).assertSuccess(), { KeyUsage: cfnCertificateAuthorityKeyUsagePropertyToCloudFormation(properties.keyUsage), SubjectInformationAccess: cdk.listMapper(cfnCertificateAuthorityAccessDescriptionPropertyToCloudFormation)(properties.subjectInformationAccess) }) : properties;
    }
    function CfnCertificateAuthorityCsrExtensionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("keyUsage", "KeyUsage", properties.KeyUsage != null ? CfnCertificateAuthorityKeyUsagePropertyFromCloudFormation(properties.KeyUsage) : void 0), ret.addPropertyResult("subjectInformationAccess", "SubjectInformationAccess", properties.SubjectInformationAccess != null ? cfn_parse.FromCloudFormation.getArray(CfnCertificateAuthorityAccessDescriptionPropertyFromCloudFormation)(properties.SubjectInformationAccess) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCertificateAuthority_CustomAttributePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("objectIdentifier", cdk.requiredValidator)(properties.objectIdentifier)), errors.collect(cdk.propertyValidator("objectIdentifier", cdk.validateString)(properties.objectIdentifier)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "CustomAttributeProperty"');
    }
    function cfnCertificateAuthorityCustomAttributePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificateAuthority_CustomAttributePropertyValidator(properties).assertSuccess(), { ObjectIdentifier: cdk.stringToCloudFormation(properties.objectIdentifier), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnCertificateAuthorityCustomAttributePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("objectIdentifier", "ObjectIdentifier", cfn_parse.FromCloudFormation.getString(properties.ObjectIdentifier)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCertificateAuthority_EdiPartyNamePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("nameAssigner", cdk.requiredValidator)(properties.nameAssigner)), errors.collect(cdk.propertyValidator("nameAssigner", cdk.validateString)(properties.nameAssigner)), errors.collect(cdk.propertyValidator("partyName", cdk.requiredValidator)(properties.partyName)), errors.collect(cdk.propertyValidator("partyName", cdk.validateString)(properties.partyName)), errors.wrap('supplied properties not correct for "EdiPartyNameProperty"');
    }
    function cfnCertificateAuthorityEdiPartyNamePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificateAuthority_EdiPartyNamePropertyValidator(properties).assertSuccess(), { NameAssigner: cdk.stringToCloudFormation(properties.nameAssigner), PartyName: cdk.stringToCloudFormation(properties.partyName) }) : properties;
    }
    function CfnCertificateAuthorityEdiPartyNamePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("nameAssigner", "NameAssigner", cfn_parse.FromCloudFormation.getString(properties.NameAssigner)), ret.addPropertyResult("partyName", "PartyName", cfn_parse.FromCloudFormation.getString(properties.PartyName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCertificateAuthority_GeneralNamePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("directoryName", CfnCertificateAuthority_SubjectPropertyValidator)(properties.directoryName)), errors.collect(cdk.propertyValidator("dnsName", cdk.validateString)(properties.dnsName)), errors.collect(cdk.propertyValidator("ediPartyName", CfnCertificateAuthority_EdiPartyNamePropertyValidator)(properties.ediPartyName)), errors.collect(cdk.propertyValidator("ipAddress", cdk.validateString)(properties.ipAddress)), errors.collect(cdk.propertyValidator("otherName", CfnCertificateAuthority_OtherNamePropertyValidator)(properties.otherName)), errors.collect(cdk.propertyValidator("registeredId", cdk.validateString)(properties.registeredId)), errors.collect(cdk.propertyValidator("rfc822Name", cdk.validateString)(properties.rfc822Name)), errors.collect(cdk.propertyValidator("uniformResourceIdentifier", cdk.validateString)(properties.uniformResourceIdentifier)), errors.wrap('supplied properties not correct for "GeneralNameProperty"');
    }
    function cfnCertificateAuthorityGeneralNamePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificateAuthority_GeneralNamePropertyValidator(properties).assertSuccess(), { DirectoryName: cfnCertificateAuthoritySubjectPropertyToCloudFormation(properties.directoryName), DnsName: cdk.stringToCloudFormation(properties.dnsName), EdiPartyName: cfnCertificateAuthorityEdiPartyNamePropertyToCloudFormation(properties.ediPartyName), IpAddress: cdk.stringToCloudFormation(properties.ipAddress), OtherName: cfnCertificateAuthorityOtherNamePropertyToCloudFormation(properties.otherName), RegisteredId: cdk.stringToCloudFormation(properties.registeredId), Rfc822Name: cdk.stringToCloudFormation(properties.rfc822Name), UniformResourceIdentifier: cdk.stringToCloudFormation(properties.uniformResourceIdentifier) }) : properties;
    }
    function CfnCertificateAuthorityGeneralNamePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("directoryName", "DirectoryName", properties.DirectoryName != null ? CfnCertificateAuthoritySubjectPropertyFromCloudFormation(properties.DirectoryName) : void 0), ret.addPropertyResult("dnsName", "DnsName", properties.DnsName != null ? cfn_parse.FromCloudFormation.getString(properties.DnsName) : void 0), ret.addPropertyResult("ediPartyName", "EdiPartyName", properties.EdiPartyName != null ? CfnCertificateAuthorityEdiPartyNamePropertyFromCloudFormation(properties.EdiPartyName) : void 0), ret.addPropertyResult("ipAddress", "IpAddress", properties.IpAddress != null ? cfn_parse.FromCloudFormation.getString(properties.IpAddress) : void 0), ret.addPropertyResult("otherName", "OtherName", properties.OtherName != null ? CfnCertificateAuthorityOtherNamePropertyFromCloudFormation(properties.OtherName) : void 0), ret.addPropertyResult("registeredId", "RegisteredId", properties.RegisteredId != null ? cfn_parse.FromCloudFormation.getString(properties.RegisteredId) : void 0), ret.addPropertyResult("rfc822Name", "Rfc822Name", properties.Rfc822Name != null ? cfn_parse.FromCloudFormation.getString(properties.Rfc822Name) : void 0), ret.addPropertyResult("uniformResourceIdentifier", "UniformResourceIdentifier", properties.UniformResourceIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.UniformResourceIdentifier) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCertificateAuthority_KeyUsagePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("crlSign", cdk.validateBoolean)(properties.crlSign)), errors.collect(cdk.propertyValidator("dataEncipherment", cdk.validateBoolean)(properties.dataEncipherment)), errors.collect(cdk.propertyValidator("decipherOnly", cdk.validateBoolean)(properties.decipherOnly)), errors.collect(cdk.propertyValidator("digitalSignature", cdk.validateBoolean)(properties.digitalSignature)), errors.collect(cdk.propertyValidator("encipherOnly", cdk.validateBoolean)(properties.encipherOnly)), errors.collect(cdk.propertyValidator("keyAgreement", cdk.validateBoolean)(properties.keyAgreement)), errors.collect(cdk.propertyValidator("keyCertSign", cdk.validateBoolean)(properties.keyCertSign)), errors.collect(cdk.propertyValidator("keyEncipherment", cdk.validateBoolean)(properties.keyEncipherment)), errors.collect(cdk.propertyValidator("nonRepudiation", cdk.validateBoolean)(properties.nonRepudiation)), errors.wrap('supplied properties not correct for "KeyUsageProperty"');
    }
    function cfnCertificateAuthorityKeyUsagePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificateAuthority_KeyUsagePropertyValidator(properties).assertSuccess(), { CRLSign: cdk.booleanToCloudFormation(properties.crlSign), DataEncipherment: cdk.booleanToCloudFormation(properties.dataEncipherment), DecipherOnly: cdk.booleanToCloudFormation(properties.decipherOnly), DigitalSignature: cdk.booleanToCloudFormation(properties.digitalSignature), EncipherOnly: cdk.booleanToCloudFormation(properties.encipherOnly), KeyAgreement: cdk.booleanToCloudFormation(properties.keyAgreement), KeyCertSign: cdk.booleanToCloudFormation(properties.keyCertSign), KeyEncipherment: cdk.booleanToCloudFormation(properties.keyEncipherment), NonRepudiation: cdk.booleanToCloudFormation(properties.nonRepudiation) }) : properties;
    }
    function CfnCertificateAuthorityKeyUsagePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("crlSign", "CRLSign", properties.CRLSign != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CRLSign) : void 0), ret.addPropertyResult("dataEncipherment", "DataEncipherment", properties.DataEncipherment != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DataEncipherment) : void 0), ret.addPropertyResult("decipherOnly", "DecipherOnly", properties.DecipherOnly != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DecipherOnly) : void 0), ret.addPropertyResult("digitalSignature", "DigitalSignature", properties.DigitalSignature != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DigitalSignature) : void 0), ret.addPropertyResult("encipherOnly", "EncipherOnly", properties.EncipherOnly != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EncipherOnly) : void 0), ret.addPropertyResult("keyAgreement", "KeyAgreement", properties.KeyAgreement != null ? cfn_parse.FromCloudFormation.getBoolean(properties.KeyAgreement) : void 0), ret.addPropertyResult("keyCertSign", "KeyCertSign", properties.KeyCertSign != null ? cfn_parse.FromCloudFormation.getBoolean(properties.KeyCertSign) : void 0), ret.addPropertyResult("keyEncipherment", "KeyEncipherment", properties.KeyEncipherment != null ? cfn_parse.FromCloudFormation.getBoolean(properties.KeyEncipherment) : void 0), ret.addPropertyResult("nonRepudiation", "NonRepudiation", properties.NonRepudiation != null ? cfn_parse.FromCloudFormation.getBoolean(properties.NonRepudiation) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCertificateAuthority_OcspConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("ocspCustomCname", cdk.validateString)(properties.ocspCustomCname)), errors.wrap('supplied properties not correct for "OcspConfigurationProperty"');
    }
    function cfnCertificateAuthorityOcspConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificateAuthority_OcspConfigurationPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled), OcspCustomCname: cdk.stringToCloudFormation(properties.ocspCustomCname) }) : properties;
    }
    function CfnCertificateAuthorityOcspConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("ocspCustomCname", "OcspCustomCname", properties.OcspCustomCname != null ? cfn_parse.FromCloudFormation.getString(properties.OcspCustomCname) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCertificateAuthority_OtherNamePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("typeId", cdk.requiredValidator)(properties.typeId)), errors.collect(cdk.propertyValidator("typeId", cdk.validateString)(properties.typeId)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "OtherNameProperty"');
    }
    function cfnCertificateAuthorityOtherNamePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificateAuthority_OtherNamePropertyValidator(properties).assertSuccess(), { TypeId: cdk.stringToCloudFormation(properties.typeId), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnCertificateAuthorityOtherNamePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("typeId", "TypeId", cfn_parse.FromCloudFormation.getString(properties.TypeId)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCertificateAuthority_RevocationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("crlConfiguration", CfnCertificateAuthority_CrlConfigurationPropertyValidator)(properties.crlConfiguration)), errors.collect(cdk.propertyValidator("ocspConfiguration", CfnCertificateAuthority_OcspConfigurationPropertyValidator)(properties.ocspConfiguration)), errors.wrap('supplied properties not correct for "RevocationConfigurationProperty"');
    }
    function cfnCertificateAuthorityRevocationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificateAuthority_RevocationConfigurationPropertyValidator(properties).assertSuccess(), { CrlConfiguration: cfnCertificateAuthorityCrlConfigurationPropertyToCloudFormation(properties.crlConfiguration), OcspConfiguration: cfnCertificateAuthorityOcspConfigurationPropertyToCloudFormation(properties.ocspConfiguration) }) : properties;
    }
    function CfnCertificateAuthorityRevocationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("crlConfiguration", "CrlConfiguration", properties.CrlConfiguration != null ? CfnCertificateAuthorityCrlConfigurationPropertyFromCloudFormation(properties.CrlConfiguration) : void 0), ret.addPropertyResult("ocspConfiguration", "OcspConfiguration", properties.OcspConfiguration != null ? CfnCertificateAuthorityOcspConfigurationPropertyFromCloudFormation(properties.OcspConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCertificateAuthority_SubjectPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("commonName", cdk.validateString)(properties.commonName)), errors.collect(cdk.propertyValidator("country", cdk.validateString)(properties.country)), errors.collect(cdk.propertyValidator("customAttributes", cdk.listValidator(CfnCertificateAuthority_CustomAttributePropertyValidator))(properties.customAttributes)), errors.collect(cdk.propertyValidator("distinguishedNameQualifier", cdk.validateString)(properties.distinguishedNameQualifier)), errors.collect(cdk.propertyValidator("generationQualifier", cdk.validateString)(properties.generationQualifier)), errors.collect(cdk.propertyValidator("givenName", cdk.validateString)(properties.givenName)), errors.collect(cdk.propertyValidator("initials", cdk.validateString)(properties.initials)), errors.collect(cdk.propertyValidator("locality", cdk.validateString)(properties.locality)), errors.collect(cdk.propertyValidator("organization", cdk.validateString)(properties.organization)), errors.collect(cdk.propertyValidator("organizationalUnit", cdk.validateString)(properties.organizationalUnit)), errors.collect(cdk.propertyValidator("pseudonym", cdk.validateString)(properties.pseudonym)), errors.collect(cdk.propertyValidator("serialNumber", cdk.validateString)(properties.serialNumber)), errors.collect(cdk.propertyValidator("state", cdk.validateString)(properties.state)), errors.collect(cdk.propertyValidator("surname", cdk.validateString)(properties.surname)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.wrap('supplied properties not correct for "SubjectProperty"');
    }
    function cfnCertificateAuthoritySubjectPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificateAuthority_SubjectPropertyValidator(properties).assertSuccess(), { CommonName: cdk.stringToCloudFormation(properties.commonName), Country: cdk.stringToCloudFormation(properties.country), CustomAttributes: cdk.listMapper(cfnCertificateAuthorityCustomAttributePropertyToCloudFormation)(properties.customAttributes), DistinguishedNameQualifier: cdk.stringToCloudFormation(properties.distinguishedNameQualifier), GenerationQualifier: cdk.stringToCloudFormation(properties.generationQualifier), GivenName: cdk.stringToCloudFormation(properties.givenName), Initials: cdk.stringToCloudFormation(properties.initials), Locality: cdk.stringToCloudFormation(properties.locality), Organization: cdk.stringToCloudFormation(properties.organization), OrganizationalUnit: cdk.stringToCloudFormation(properties.organizationalUnit), Pseudonym: cdk.stringToCloudFormation(properties.pseudonym), SerialNumber: cdk.stringToCloudFormation(properties.serialNumber), State: cdk.stringToCloudFormation(properties.state), Surname: cdk.stringToCloudFormation(properties.surname), Title: cdk.stringToCloudFormation(properties.title) }) : properties;
    }
    function CfnCertificateAuthoritySubjectPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("commonName", "CommonName", properties.CommonName != null ? cfn_parse.FromCloudFormation.getString(properties.CommonName) : void 0), ret.addPropertyResult("country", "Country", properties.Country != null ? cfn_parse.FromCloudFormation.getString(properties.Country) : void 0), ret.addPropertyResult("customAttributes", "CustomAttributes", properties.CustomAttributes != null ? cfn_parse.FromCloudFormation.getArray(CfnCertificateAuthorityCustomAttributePropertyFromCloudFormation)(properties.CustomAttributes) : void 0), ret.addPropertyResult("distinguishedNameQualifier", "DistinguishedNameQualifier", properties.DistinguishedNameQualifier != null ? cfn_parse.FromCloudFormation.getString(properties.DistinguishedNameQualifier) : void 0), ret.addPropertyResult("generationQualifier", "GenerationQualifier", properties.GenerationQualifier != null ? cfn_parse.FromCloudFormation.getString(properties.GenerationQualifier) : void 0), ret.addPropertyResult("givenName", "GivenName", properties.GivenName != null ? cfn_parse.FromCloudFormation.getString(properties.GivenName) : void 0), ret.addPropertyResult("initials", "Initials", properties.Initials != null ? cfn_parse.FromCloudFormation.getString(properties.Initials) : void 0), ret.addPropertyResult("locality", "Locality", properties.Locality != null ? cfn_parse.FromCloudFormation.getString(properties.Locality) : void 0), ret.addPropertyResult("organization", "Organization", properties.Organization != null ? cfn_parse.FromCloudFormation.getString(properties.Organization) : void 0), ret.addPropertyResult("organizationalUnit", "OrganizationalUnit", properties.OrganizationalUnit != null ? cfn_parse.FromCloudFormation.getString(properties.OrganizationalUnit) : void 0), ret.addPropertyResult("pseudonym", "Pseudonym", properties.Pseudonym != null ? cfn_parse.FromCloudFormation.getString(properties.Pseudonym) : void 0), ret.addPropertyResult("serialNumber", "SerialNumber", properties.SerialNumber != null ? cfn_parse.FromCloudFormation.getString(properties.SerialNumber) : void 0), ret.addPropertyResult("state", "State", properties.State != null ? cfn_parse.FromCloudFormation.getString(properties.State) : void 0), ret.addPropertyResult("surname", "Surname", properties.Surname != null ? cfn_parse.FromCloudFormation.getString(properties.Surname) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? cfn_parse.FromCloudFormation.getString(properties.Title) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCertificateAuthorityActivationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificate", cdk.requiredValidator)(properties.certificate)), errors.collect(cdk.propertyValidator("certificate", cdk.validateString)(properties.certificate)), errors.collect(cdk.propertyValidator("certificateAuthorityArn", cdk.requiredValidator)(properties.certificateAuthorityArn)), errors.collect(cdk.propertyValidator("certificateAuthorityArn", cdk.validateString)(properties.certificateAuthorityArn)), errors.collect(cdk.propertyValidator("certificateChain", cdk.validateString)(properties.certificateChain)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "CfnCertificateAuthorityActivationProps"');
    }
    function cfnCertificateAuthorityActivationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificateAuthorityActivationPropsValidator(properties).assertSuccess(), { Certificate: cdk.stringToCloudFormation(properties.certificate), CertificateAuthorityArn: cdk.stringToCloudFormation(properties.certificateAuthorityArn), CertificateChain: cdk.stringToCloudFormation(properties.certificateChain), Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnCertificateAuthorityActivationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificate", "Certificate", cfn_parse.FromCloudFormation.getString(properties.Certificate)), ret.addPropertyResult("certificateAuthorityArn", "CertificateAuthorityArn", cfn_parse.FromCloudFormation.getString(properties.CertificateAuthorityArn)), ret.addPropertyResult("certificateChain", "CertificateChain", properties.CertificateChain != null ? cfn_parse.FromCloudFormation.getString(properties.CertificateChain) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCertificateAuthorityActivation = class _CfnCertificateAuthorityActivation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCertificateAuthorityActivationPropsFromCloudFormation(resourceProperties), ret = new _CfnCertificateAuthorityActivation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCertificateAuthorityActivation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_acmpca_CfnCertificateAuthorityActivationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCertificateAuthorityActivation), error;
        }
        cdk.requireProperty(props, "certificate", this), cdk.requireProperty(props, "certificateAuthorityArn", this), this.attrCompleteCertificateChain = cdk.Token.asString(this.getAtt("CompleteCertificateChain", cdk.ResolutionTypeHint.STRING)), this.certificate = props.certificate, this.certificateAuthorityArn = props.certificateAuthorityArn, this.certificateChain = props.certificateChain, this.status = props.status;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCertificateAuthorityActivation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { certificate: this.certificate, certificateAuthorityArn: this.certificateAuthorityArn, certificateChain: this.certificateChain, status: this.status };
      }
      renderProperties(props) {
        return cfnCertificateAuthorityActivationPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnCertificateAuthorityActivation[_c] = { fqn: "aws-cdk-lib.aws_acmpca.CfnCertificateAuthorityActivation", version: "2.80.0" }, CfnCertificateAuthorityActivation.CFN_RESOURCE_TYPE_NAME = "AWS::ACMPCA::CertificateAuthorityActivation", exports2.CfnCertificateAuthorityActivation = CfnCertificateAuthorityActivation;
    function CfnPermissionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.requiredValidator)(properties.actions)), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(cdk.validateString))(properties.actions)), errors.collect(cdk.propertyValidator("certificateAuthorityArn", cdk.requiredValidator)(properties.certificateAuthorityArn)), errors.collect(cdk.propertyValidator("certificateAuthorityArn", cdk.validateString)(properties.certificateAuthorityArn)), errors.collect(cdk.propertyValidator("principal", cdk.requiredValidator)(properties.principal)), errors.collect(cdk.propertyValidator("principal", cdk.validateString)(properties.principal)), errors.collect(cdk.propertyValidator("sourceAccount", cdk.validateString)(properties.sourceAccount)), errors.wrap('supplied properties not correct for "CfnPermissionProps"');
    }
    function cfnPermissionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPermissionPropsValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cdk.stringToCloudFormation)(properties.actions), CertificateAuthorityArn: cdk.stringToCloudFormation(properties.certificateAuthorityArn), Principal: cdk.stringToCloudFormation(properties.principal), SourceAccount: cdk.stringToCloudFormation(properties.sourceAccount) }) : properties;
    }
    function CfnPermissionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", cfn_parse.FromCloudFormation.getStringArray(properties.Actions)), ret.addPropertyResult("certificateAuthorityArn", "CertificateAuthorityArn", cfn_parse.FromCloudFormation.getString(properties.CertificateAuthorityArn)), ret.addPropertyResult("principal", "Principal", cfn_parse.FromCloudFormation.getString(properties.Principal)), ret.addPropertyResult("sourceAccount", "SourceAccount", properties.SourceAccount != null ? cfn_parse.FromCloudFormation.getString(properties.SourceAccount) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPermission = class _CfnPermission extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPermissionPropsFromCloudFormation(resourceProperties), ret = new _CfnPermission(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPermission.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_acmpca_CfnPermissionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPermission), error;
        }
        cdk.requireProperty(props, "actions", this), cdk.requireProperty(props, "certificateAuthorityArn", this), cdk.requireProperty(props, "principal", this), this.actions = props.actions, this.certificateAuthorityArn = props.certificateAuthorityArn, this.principal = props.principal, this.sourceAccount = props.sourceAccount;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPermission.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { actions: this.actions, certificateAuthorityArn: this.certificateAuthorityArn, principal: this.principal, sourceAccount: this.sourceAccount };
      }
      renderProperties(props) {
        return cfnPermissionPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnPermission[_d] = { fqn: "aws-cdk-lib.aws_acmpca.CfnPermission", version: "2.80.0" }, CfnPermission.CFN_RESOURCE_TYPE_NAME = "AWS::ACMPCA::Permission", exports2.CfnPermission = CfnPermission;
  }
});

// node_modules/aws-cdk-lib/aws-acmpca/lib/certificate-authority.js
var require_certificate_authority = __commonJS({
  "node_modules/aws-cdk-lib/aws-acmpca/lib/certificate-authority.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CertificateAuthority = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var CertificateAuthority = class {
      static fromCertificateAuthorityArn(scope, id, certificateAuthorityArn) {
        return new class extends cdk.Resource {
          constructor() {
            super(...arguments), this.certificateAuthorityArn = certificateAuthorityArn;
          }
        }(scope, id);
      }
      constructor() {
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CertificateAuthority[_a] = { fqn: "aws-cdk-lib.aws_acmpca.CertificateAuthority", version: "2.80.0" }, exports2.CertificateAuthority = CertificateAuthority;
  }
});

// node_modules/aws-cdk-lib/aws-acmpca/lib/index.js
var require_lib34 = __commonJS({
  "node_modules/aws-cdk-lib/aws-acmpca/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_acmpca_generated(), exports2), __exportStar(require_certificate_authority(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-acmpca/index.js
var require_aws_acmpca = __commonJS({
  "node_modules/aws-cdk-lib/aws-acmpca/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib34(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-amazonmq/lib/amazonmq.generated.js
var require_amazonmq_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-amazonmq/lib/amazonmq.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnConfigurationAssociation = exports2.CfnConfiguration = exports2.CfnBroker = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnBrokerPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authenticationStrategy", cdk.validateString)(properties.authenticationStrategy)), errors.collect(cdk.propertyValidator("autoMinorVersionUpgrade", cdk.requiredValidator)(properties.autoMinorVersionUpgrade)), errors.collect(cdk.propertyValidator("autoMinorVersionUpgrade", cdk.validateBoolean)(properties.autoMinorVersionUpgrade)), errors.collect(cdk.propertyValidator("brokerName", cdk.requiredValidator)(properties.brokerName)), errors.collect(cdk.propertyValidator("brokerName", cdk.validateString)(properties.brokerName)), errors.collect(cdk.propertyValidator("configuration", CfnBroker_ConfigurationIdPropertyValidator)(properties.configuration)), errors.collect(cdk.propertyValidator("deploymentMode", cdk.requiredValidator)(properties.deploymentMode)), errors.collect(cdk.propertyValidator("deploymentMode", cdk.validateString)(properties.deploymentMode)), errors.collect(cdk.propertyValidator("encryptionOptions", CfnBroker_EncryptionOptionsPropertyValidator)(properties.encryptionOptions)), errors.collect(cdk.propertyValidator("engineType", cdk.requiredValidator)(properties.engineType)), errors.collect(cdk.propertyValidator("engineType", cdk.validateString)(properties.engineType)), errors.collect(cdk.propertyValidator("engineVersion", cdk.requiredValidator)(properties.engineVersion)), errors.collect(cdk.propertyValidator("engineVersion", cdk.validateString)(properties.engineVersion)), errors.collect(cdk.propertyValidator("hostInstanceType", cdk.requiredValidator)(properties.hostInstanceType)), errors.collect(cdk.propertyValidator("hostInstanceType", cdk.validateString)(properties.hostInstanceType)), errors.collect(cdk.propertyValidator("ldapServerMetadata", CfnBroker_LdapServerMetadataPropertyValidator)(properties.ldapServerMetadata)), errors.collect(cdk.propertyValidator("logs", CfnBroker_LogListPropertyValidator)(properties.logs)), errors.collect(cdk.propertyValidator("maintenanceWindowStartTime", CfnBroker_MaintenanceWindowPropertyValidator)(properties.maintenanceWindowStartTime)), errors.collect(cdk.propertyValidator("publiclyAccessible", cdk.requiredValidator)(properties.publiclyAccessible)), errors.collect(cdk.propertyValidator("publiclyAccessible", cdk.validateBoolean)(properties.publiclyAccessible)), errors.collect(cdk.propertyValidator("securityGroups", cdk.listValidator(cdk.validateString))(properties.securityGroups)), errors.collect(cdk.propertyValidator("storageType", cdk.validateString)(properties.storageType)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(CfnBroker_TagsEntryPropertyValidator))(properties.tags)), errors.collect(cdk.propertyValidator("users", cdk.requiredValidator)(properties.users)), errors.collect(cdk.propertyValidator("users", cdk.listValidator(CfnBroker_UserPropertyValidator))(properties.users)), errors.wrap('supplied properties not correct for "CfnBrokerProps"');
    }
    function cfnBrokerPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBrokerPropsValidator(properties).assertSuccess(), { AutoMinorVersionUpgrade: cdk.booleanToCloudFormation(properties.autoMinorVersionUpgrade), BrokerName: cdk.stringToCloudFormation(properties.brokerName), DeploymentMode: cdk.stringToCloudFormation(properties.deploymentMode), EngineType: cdk.stringToCloudFormation(properties.engineType), EngineVersion: cdk.stringToCloudFormation(properties.engineVersion), HostInstanceType: cdk.stringToCloudFormation(properties.hostInstanceType), PubliclyAccessible: cdk.booleanToCloudFormation(properties.publiclyAccessible), Users: cdk.listMapper(cfnBrokerUserPropertyToCloudFormation)(properties.users), AuthenticationStrategy: cdk.stringToCloudFormation(properties.authenticationStrategy), Configuration: cfnBrokerConfigurationIdPropertyToCloudFormation(properties.configuration), EncryptionOptions: cfnBrokerEncryptionOptionsPropertyToCloudFormation(properties.encryptionOptions), LdapServerMetadata: cfnBrokerLdapServerMetadataPropertyToCloudFormation(properties.ldapServerMetadata), Logs: cfnBrokerLogListPropertyToCloudFormation(properties.logs), MaintenanceWindowStartTime: cfnBrokerMaintenanceWindowPropertyToCloudFormation(properties.maintenanceWindowStartTime), SecurityGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroups), StorageType: cdk.stringToCloudFormation(properties.storageType), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds), Tags: cdk.listMapper(cfnBrokerTagsEntryPropertyToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnBrokerPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("autoMinorVersionUpgrade", "AutoMinorVersionUpgrade", cfn_parse.FromCloudFormation.getBoolean(properties.AutoMinorVersionUpgrade)), ret.addPropertyResult("brokerName", "BrokerName", cfn_parse.FromCloudFormation.getString(properties.BrokerName)), ret.addPropertyResult("deploymentMode", "DeploymentMode", cfn_parse.FromCloudFormation.getString(properties.DeploymentMode)), ret.addPropertyResult("engineType", "EngineType", cfn_parse.FromCloudFormation.getString(properties.EngineType)), ret.addPropertyResult("engineVersion", "EngineVersion", cfn_parse.FromCloudFormation.getString(properties.EngineVersion)), ret.addPropertyResult("hostInstanceType", "HostInstanceType", cfn_parse.FromCloudFormation.getString(properties.HostInstanceType)), ret.addPropertyResult("publiclyAccessible", "PubliclyAccessible", cfn_parse.FromCloudFormation.getBoolean(properties.PubliclyAccessible)), ret.addPropertyResult("users", "Users", cfn_parse.FromCloudFormation.getArray(CfnBrokerUserPropertyFromCloudFormation)(properties.Users)), ret.addPropertyResult("authenticationStrategy", "AuthenticationStrategy", properties.AuthenticationStrategy != null ? cfn_parse.FromCloudFormation.getString(properties.AuthenticationStrategy) : void 0), ret.addPropertyResult("configuration", "Configuration", properties.Configuration != null ? CfnBrokerConfigurationIdPropertyFromCloudFormation(properties.Configuration) : void 0), ret.addPropertyResult("encryptionOptions", "EncryptionOptions", properties.EncryptionOptions != null ? CfnBrokerEncryptionOptionsPropertyFromCloudFormation(properties.EncryptionOptions) : void 0), ret.addPropertyResult("ldapServerMetadata", "LdapServerMetadata", properties.LdapServerMetadata != null ? CfnBrokerLdapServerMetadataPropertyFromCloudFormation(properties.LdapServerMetadata) : void 0), ret.addPropertyResult("logs", "Logs", properties.Logs != null ? CfnBrokerLogListPropertyFromCloudFormation(properties.Logs) : void 0), ret.addPropertyResult("maintenanceWindowStartTime", "MaintenanceWindowStartTime", properties.MaintenanceWindowStartTime != null ? CfnBrokerMaintenanceWindowPropertyFromCloudFormation(properties.MaintenanceWindowStartTime) : void 0), ret.addPropertyResult("securityGroups", "SecurityGroups", properties.SecurityGroups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroups) : void 0), ret.addPropertyResult("storageType", "StorageType", properties.StorageType != null ? cfn_parse.FromCloudFormation.getString(properties.StorageType) : void 0), ret.addPropertyResult("subnetIds", "SubnetIds", properties.SubnetIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(CfnBrokerTagsEntryPropertyFromCloudFormation)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnBroker = class _CfnBroker extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnBrokerPropsFromCloudFormation(resourceProperties), ret = new _CfnBroker(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnBroker.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_amazonmq_CfnBrokerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnBroker), error;
        }
        cdk.requireProperty(props, "autoMinorVersionUpgrade", this), cdk.requireProperty(props, "brokerName", this), cdk.requireProperty(props, "deploymentMode", this), cdk.requireProperty(props, "engineType", this), cdk.requireProperty(props, "engineVersion", this), cdk.requireProperty(props, "hostInstanceType", this), cdk.requireProperty(props, "publiclyAccessible", this), cdk.requireProperty(props, "users", this), this.attrAmqpEndpoints = cdk.Token.asList(this.getAtt("AmqpEndpoints", cdk.ResolutionTypeHint.STRING_LIST)), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrConfigurationId = cdk.Token.asString(this.getAtt("ConfigurationId", cdk.ResolutionTypeHint.STRING)), this.attrConfigurationRevision = cdk.Token.asNumber(this.getAtt("ConfigurationRevision", cdk.ResolutionTypeHint.NUMBER)), this.attrIpAddresses = cdk.Token.asList(this.getAtt("IpAddresses", cdk.ResolutionTypeHint.STRING_LIST)), this.attrMqttEndpoints = cdk.Token.asList(this.getAtt("MqttEndpoints", cdk.ResolutionTypeHint.STRING_LIST)), this.attrOpenWireEndpoints = cdk.Token.asList(this.getAtt("OpenWireEndpoints", cdk.ResolutionTypeHint.STRING_LIST)), this.attrStompEndpoints = cdk.Token.asList(this.getAtt("StompEndpoints", cdk.ResolutionTypeHint.STRING_LIST)), this.attrWssEndpoints = cdk.Token.asList(this.getAtt("WssEndpoints", cdk.ResolutionTypeHint.STRING_LIST)), this.autoMinorVersionUpgrade = props.autoMinorVersionUpgrade, this.brokerName = props.brokerName, this.deploymentMode = props.deploymentMode, this.engineType = props.engineType, this.engineVersion = props.engineVersion, this.hostInstanceType = props.hostInstanceType, this.publiclyAccessible = props.publiclyAccessible, this.users = props.users, this.authenticationStrategy = props.authenticationStrategy, this.configuration = props.configuration, this.encryptionOptions = props.encryptionOptions, this.ldapServerMetadata = props.ldapServerMetadata, this.logs = props.logs, this.maintenanceWindowStartTime = props.maintenanceWindowStartTime, this.securityGroups = props.securityGroups, this.storageType = props.storageType, this.subnetIds = props.subnetIds, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::AmazonMQ::Broker", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnBroker.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { autoMinorVersionUpgrade: this.autoMinorVersionUpgrade, brokerName: this.brokerName, deploymentMode: this.deploymentMode, engineType: this.engineType, engineVersion: this.engineVersion, hostInstanceType: this.hostInstanceType, publiclyAccessible: this.publiclyAccessible, users: this.users, authenticationStrategy: this.authenticationStrategy, configuration: this.configuration, encryptionOptions: this.encryptionOptions, ldapServerMetadata: this.ldapServerMetadata, logs: this.logs, maintenanceWindowStartTime: this.maintenanceWindowStartTime, securityGroups: this.securityGroups, storageType: this.storageType, subnetIds: this.subnetIds, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnBrokerPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnBroker[_a] = { fqn: "aws-cdk-lib.aws_amazonmq.CfnBroker", version: "2.80.0" }, CfnBroker.CFN_RESOURCE_TYPE_NAME = "AWS::AmazonMQ::Broker", exports2.CfnBroker = CfnBroker;
    function CfnBroker_ConfigurationIdPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("revision", cdk.requiredValidator)(properties.revision)), errors.collect(cdk.propertyValidator("revision", cdk.validateNumber)(properties.revision)), errors.wrap('supplied properties not correct for "ConfigurationIdProperty"');
    }
    function cfnBrokerConfigurationIdPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBroker_ConfigurationIdPropertyValidator(properties).assertSuccess(), { Id: cdk.stringToCloudFormation(properties.id), Revision: cdk.numberToCloudFormation(properties.revision) }) : properties;
    }
    function CfnBrokerConfigurationIdPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("revision", "Revision", cfn_parse.FromCloudFormation.getNumber(properties.Revision)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBroker_EncryptionOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("useAwsOwnedKey", cdk.requiredValidator)(properties.useAwsOwnedKey)), errors.collect(cdk.propertyValidator("useAwsOwnedKey", cdk.validateBoolean)(properties.useAwsOwnedKey)), errors.wrap('supplied properties not correct for "EncryptionOptionsProperty"');
    }
    function cfnBrokerEncryptionOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBroker_EncryptionOptionsPropertyValidator(properties).assertSuccess(), { KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), UseAwsOwnedKey: cdk.booleanToCloudFormation(properties.useAwsOwnedKey) }) : properties;
    }
    function CfnBrokerEncryptionOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("useAwsOwnedKey", "UseAwsOwnedKey", cfn_parse.FromCloudFormation.getBoolean(properties.UseAwsOwnedKey)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBroker_LdapServerMetadataPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("hosts", cdk.requiredValidator)(properties.hosts)), errors.collect(cdk.propertyValidator("hosts", cdk.listValidator(cdk.validateString))(properties.hosts)), errors.collect(cdk.propertyValidator("roleBase", cdk.requiredValidator)(properties.roleBase)), errors.collect(cdk.propertyValidator("roleBase", cdk.validateString)(properties.roleBase)), errors.collect(cdk.propertyValidator("roleName", cdk.validateString)(properties.roleName)), errors.collect(cdk.propertyValidator("roleSearchMatching", cdk.requiredValidator)(properties.roleSearchMatching)), errors.collect(cdk.propertyValidator("roleSearchMatching", cdk.validateString)(properties.roleSearchMatching)), errors.collect(cdk.propertyValidator("roleSearchSubtree", cdk.validateBoolean)(properties.roleSearchSubtree)), errors.collect(cdk.propertyValidator("serviceAccountPassword", cdk.requiredValidator)(properties.serviceAccountPassword)), errors.collect(cdk.propertyValidator("serviceAccountPassword", cdk.validateString)(properties.serviceAccountPassword)), errors.collect(cdk.propertyValidator("serviceAccountUsername", cdk.requiredValidator)(properties.serviceAccountUsername)), errors.collect(cdk.propertyValidator("serviceAccountUsername", cdk.validateString)(properties.serviceAccountUsername)), errors.collect(cdk.propertyValidator("userBase", cdk.requiredValidator)(properties.userBase)), errors.collect(cdk.propertyValidator("userBase", cdk.validateString)(properties.userBase)), errors.collect(cdk.propertyValidator("userRoleName", cdk.validateString)(properties.userRoleName)), errors.collect(cdk.propertyValidator("userSearchMatching", cdk.requiredValidator)(properties.userSearchMatching)), errors.collect(cdk.propertyValidator("userSearchMatching", cdk.validateString)(properties.userSearchMatching)), errors.collect(cdk.propertyValidator("userSearchSubtree", cdk.validateBoolean)(properties.userSearchSubtree)), errors.wrap('supplied properties not correct for "LdapServerMetadataProperty"');
    }
    function cfnBrokerLdapServerMetadataPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBroker_LdapServerMetadataPropertyValidator(properties).assertSuccess(), { Hosts: cdk.listMapper(cdk.stringToCloudFormation)(properties.hosts), RoleBase: cdk.stringToCloudFormation(properties.roleBase), RoleName: cdk.stringToCloudFormation(properties.roleName), RoleSearchMatching: cdk.stringToCloudFormation(properties.roleSearchMatching), RoleSearchSubtree: cdk.booleanToCloudFormation(properties.roleSearchSubtree), ServiceAccountPassword: cdk.stringToCloudFormation(properties.serviceAccountPassword), ServiceAccountUsername: cdk.stringToCloudFormation(properties.serviceAccountUsername), UserBase: cdk.stringToCloudFormation(properties.userBase), UserRoleName: cdk.stringToCloudFormation(properties.userRoleName), UserSearchMatching: cdk.stringToCloudFormation(properties.userSearchMatching), UserSearchSubtree: cdk.booleanToCloudFormation(properties.userSearchSubtree) }) : properties;
    }
    function CfnBrokerLdapServerMetadataPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("hosts", "Hosts", cfn_parse.FromCloudFormation.getStringArray(properties.Hosts)), ret.addPropertyResult("roleBase", "RoleBase", cfn_parse.FromCloudFormation.getString(properties.RoleBase)), ret.addPropertyResult("roleName", "RoleName", properties.RoleName != null ? cfn_parse.FromCloudFormation.getString(properties.RoleName) : void 0), ret.addPropertyResult("roleSearchMatching", "RoleSearchMatching", cfn_parse.FromCloudFormation.getString(properties.RoleSearchMatching)), ret.addPropertyResult("roleSearchSubtree", "RoleSearchSubtree", properties.RoleSearchSubtree != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RoleSearchSubtree) : void 0), ret.addPropertyResult("serviceAccountPassword", "ServiceAccountPassword", cfn_parse.FromCloudFormation.getString(properties.ServiceAccountPassword)), ret.addPropertyResult("serviceAccountUsername", "ServiceAccountUsername", cfn_parse.FromCloudFormation.getString(properties.ServiceAccountUsername)), ret.addPropertyResult("userBase", "UserBase", cfn_parse.FromCloudFormation.getString(properties.UserBase)), ret.addPropertyResult("userRoleName", "UserRoleName", properties.UserRoleName != null ? cfn_parse.FromCloudFormation.getString(properties.UserRoleName) : void 0), ret.addPropertyResult("userSearchMatching", "UserSearchMatching", cfn_parse.FromCloudFormation.getString(properties.UserSearchMatching)), ret.addPropertyResult("userSearchSubtree", "UserSearchSubtree", properties.UserSearchSubtree != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UserSearchSubtree) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBroker_LogListPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("audit", cdk.validateBoolean)(properties.audit)), errors.collect(cdk.propertyValidator("general", cdk.validateBoolean)(properties.general)), errors.wrap('supplied properties not correct for "LogListProperty"');
    }
    function cfnBrokerLogListPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBroker_LogListPropertyValidator(properties).assertSuccess(), { Audit: cdk.booleanToCloudFormation(properties.audit), General: cdk.booleanToCloudFormation(properties.general) }) : properties;
    }
    function CfnBrokerLogListPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("audit", "Audit", properties.Audit != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Audit) : void 0), ret.addPropertyResult("general", "General", properties.General != null ? cfn_parse.FromCloudFormation.getBoolean(properties.General) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBroker_MaintenanceWindowPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dayOfWeek", cdk.requiredValidator)(properties.dayOfWeek)), errors.collect(cdk.propertyValidator("dayOfWeek", cdk.validateString)(properties.dayOfWeek)), errors.collect(cdk.propertyValidator("timeOfDay", cdk.requiredValidator)(properties.timeOfDay)), errors.collect(cdk.propertyValidator("timeOfDay", cdk.validateString)(properties.timeOfDay)), errors.collect(cdk.propertyValidator("timeZone", cdk.requiredValidator)(properties.timeZone)), errors.collect(cdk.propertyValidator("timeZone", cdk.validateString)(properties.timeZone)), errors.wrap('supplied properties not correct for "MaintenanceWindowProperty"');
    }
    function cfnBrokerMaintenanceWindowPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBroker_MaintenanceWindowPropertyValidator(properties).assertSuccess(), { DayOfWeek: cdk.stringToCloudFormation(properties.dayOfWeek), TimeOfDay: cdk.stringToCloudFormation(properties.timeOfDay), TimeZone: cdk.stringToCloudFormation(properties.timeZone) }) : properties;
    }
    function CfnBrokerMaintenanceWindowPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dayOfWeek", "DayOfWeek", cfn_parse.FromCloudFormation.getString(properties.DayOfWeek)), ret.addPropertyResult("timeOfDay", "TimeOfDay", cfn_parse.FromCloudFormation.getString(properties.TimeOfDay)), ret.addPropertyResult("timeZone", "TimeZone", cfn_parse.FromCloudFormation.getString(properties.TimeZone)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBroker_TagsEntryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TagsEntryProperty"');
    }
    function cfnBrokerTagsEntryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBroker_TagsEntryPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnBrokerTagsEntryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBroker_UserPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("consoleAccess", cdk.validateBoolean)(properties.consoleAccess)), errors.collect(cdk.propertyValidator("groups", cdk.listValidator(cdk.validateString))(properties.groups)), errors.collect(cdk.propertyValidator("password", cdk.requiredValidator)(properties.password)), errors.collect(cdk.propertyValidator("password", cdk.validateString)(properties.password)), errors.collect(cdk.propertyValidator("username", cdk.requiredValidator)(properties.username)), errors.collect(cdk.propertyValidator("username", cdk.validateString)(properties.username)), errors.wrap('supplied properties not correct for "UserProperty"');
    }
    function cfnBrokerUserPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBroker_UserPropertyValidator(properties).assertSuccess(), { ConsoleAccess: cdk.booleanToCloudFormation(properties.consoleAccess), Groups: cdk.listMapper(cdk.stringToCloudFormation)(properties.groups), Password: cdk.stringToCloudFormation(properties.password), Username: cdk.stringToCloudFormation(properties.username) }) : properties;
    }
    function CfnBrokerUserPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("consoleAccess", "ConsoleAccess", properties.ConsoleAccess != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ConsoleAccess) : void 0), ret.addPropertyResult("groups", "Groups", properties.Groups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Groups) : void 0), ret.addPropertyResult("password", "Password", cfn_parse.FromCloudFormation.getString(properties.Password)), ret.addPropertyResult("username", "Username", cfn_parse.FromCloudFormation.getString(properties.Username)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigurationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authenticationStrategy", cdk.validateString)(properties.authenticationStrategy)), errors.collect(cdk.propertyValidator("data", cdk.requiredValidator)(properties.data)), errors.collect(cdk.propertyValidator("data", cdk.validateString)(properties.data)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("engineType", cdk.requiredValidator)(properties.engineType)), errors.collect(cdk.propertyValidator("engineType", cdk.validateString)(properties.engineType)), errors.collect(cdk.propertyValidator("engineVersion", cdk.requiredValidator)(properties.engineVersion)), errors.collect(cdk.propertyValidator("engineVersion", cdk.validateString)(properties.engineVersion)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(CfnConfiguration_TagsEntryPropertyValidator))(properties.tags)), errors.wrap('supplied properties not correct for "CfnConfigurationProps"');
    }
    function cfnConfigurationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationPropsValidator(properties).assertSuccess(), { Data: cdk.stringToCloudFormation(properties.data), EngineType: cdk.stringToCloudFormation(properties.engineType), EngineVersion: cdk.stringToCloudFormation(properties.engineVersion), Name: cdk.stringToCloudFormation(properties.name), AuthenticationStrategy: cdk.stringToCloudFormation(properties.authenticationStrategy), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cfnConfigurationTagsEntryPropertyToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnConfigurationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("data", "Data", cfn_parse.FromCloudFormation.getString(properties.Data)), ret.addPropertyResult("engineType", "EngineType", cfn_parse.FromCloudFormation.getString(properties.EngineType)), ret.addPropertyResult("engineVersion", "EngineVersion", cfn_parse.FromCloudFormation.getString(properties.EngineVersion)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("authenticationStrategy", "AuthenticationStrategy", properties.AuthenticationStrategy != null ? cfn_parse.FromCloudFormation.getString(properties.AuthenticationStrategy) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(CfnConfigurationTagsEntryPropertyFromCloudFormation)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnConfiguration = class _CfnConfiguration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnConfigurationPropsFromCloudFormation(resourceProperties), ret = new _CfnConfiguration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnConfiguration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_amazonmq_CfnConfigurationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnConfiguration), error;
        }
        cdk.requireProperty(props, "data", this), cdk.requireProperty(props, "engineType", this), cdk.requireProperty(props, "engineVersion", this), cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrRevision = cdk.Token.asNumber(this.getAtt("Revision", cdk.ResolutionTypeHint.NUMBER)), this.data = props.data, this.engineType = props.engineType, this.engineVersion = props.engineVersion, this.name = props.name, this.authenticationStrategy = props.authenticationStrategy, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::AmazonMQ::Configuration", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnConfiguration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { data: this.data, engineType: this.engineType, engineVersion: this.engineVersion, name: this.name, authenticationStrategy: this.authenticationStrategy, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnConfigurationPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnConfiguration[_b] = { fqn: "aws-cdk-lib.aws_amazonmq.CfnConfiguration", version: "2.80.0" }, CfnConfiguration.CFN_RESOURCE_TYPE_NAME = "AWS::AmazonMQ::Configuration", exports2.CfnConfiguration = CfnConfiguration;
    function CfnConfiguration_TagsEntryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TagsEntryProperty"');
    }
    function cfnConfigurationTagsEntryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfiguration_TagsEntryPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnConfigurationTagsEntryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigurationAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("broker", cdk.requiredValidator)(properties.broker)), errors.collect(cdk.propertyValidator("broker", cdk.validateString)(properties.broker)), errors.collect(cdk.propertyValidator("configuration", cdk.requiredValidator)(properties.configuration)), errors.collect(cdk.propertyValidator("configuration", CfnConfigurationAssociation_ConfigurationIdPropertyValidator)(properties.configuration)), errors.wrap('supplied properties not correct for "CfnConfigurationAssociationProps"');
    }
    function cfnConfigurationAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationAssociationPropsValidator(properties).assertSuccess(), { Broker: cdk.stringToCloudFormation(properties.broker), Configuration: cfnConfigurationAssociationConfigurationIdPropertyToCloudFormation(properties.configuration) }) : properties;
    }
    function CfnConfigurationAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("broker", "Broker", cfn_parse.FromCloudFormation.getString(properties.Broker)), ret.addPropertyResult("configuration", "Configuration", CfnConfigurationAssociationConfigurationIdPropertyFromCloudFormation(properties.Configuration)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnConfigurationAssociation = class _CfnConfigurationAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnConfigurationAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnConfigurationAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnConfigurationAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_amazonmq_CfnConfigurationAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnConfigurationAssociation), error;
        }
        cdk.requireProperty(props, "broker", this), cdk.requireProperty(props, "configuration", this), this.broker = props.broker, this.configuration = props.configuration;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnConfigurationAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { broker: this.broker, configuration: this.configuration };
      }
      renderProperties(props) {
        return cfnConfigurationAssociationPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnConfigurationAssociation[_c] = { fqn: "aws-cdk-lib.aws_amazonmq.CfnConfigurationAssociation", version: "2.80.0" }, CfnConfigurationAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::AmazonMQ::ConfigurationAssociation", exports2.CfnConfigurationAssociation = CfnConfigurationAssociation;
    function CfnConfigurationAssociation_ConfigurationIdPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("revision", cdk.requiredValidator)(properties.revision)), errors.collect(cdk.propertyValidator("revision", cdk.validateNumber)(properties.revision)), errors.wrap('supplied properties not correct for "ConfigurationIdProperty"');
    }
    function cfnConfigurationAssociationConfigurationIdPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationAssociation_ConfigurationIdPropertyValidator(properties).assertSuccess(), { Id: cdk.stringToCloudFormation(properties.id), Revision: cdk.numberToCloudFormation(properties.revision) }) : properties;
    }
    function CfnConfigurationAssociationConfigurationIdPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("revision", "Revision", cfn_parse.FromCloudFormation.getNumber(properties.Revision)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-amazonmq/lib/index.js
var require_lib35 = __commonJS({
  "node_modules/aws-cdk-lib/aws-amazonmq/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_amazonmq_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-amazonmq/index.js
var require_aws_amazonmq = __commonJS({
  "node_modules/aws-cdk-lib/aws-amazonmq/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib35(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-amplify/lib/amplify.generated.js
var require_amplify_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-amplify/lib/amplify.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnDomain = exports2.CfnBranch = exports2.CfnApp = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAppPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessToken", cdk.validateString)(properties.accessToken)), errors.collect(cdk.propertyValidator("autoBranchCreationConfig", CfnApp_AutoBranchCreationConfigPropertyValidator)(properties.autoBranchCreationConfig)), errors.collect(cdk.propertyValidator("basicAuthConfig", CfnApp_BasicAuthConfigPropertyValidator)(properties.basicAuthConfig)), errors.collect(cdk.propertyValidator("buildSpec", cdk.validateString)(properties.buildSpec)), errors.collect(cdk.propertyValidator("customHeaders", cdk.validateString)(properties.customHeaders)), errors.collect(cdk.propertyValidator("customRules", cdk.listValidator(CfnApp_CustomRulePropertyValidator))(properties.customRules)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("enableBranchAutoDeletion", cdk.validateBoolean)(properties.enableBranchAutoDeletion)), errors.collect(cdk.propertyValidator("environmentVariables", cdk.listValidator(CfnApp_EnvironmentVariablePropertyValidator))(properties.environmentVariables)), errors.collect(cdk.propertyValidator("iamServiceRole", cdk.validateString)(properties.iamServiceRole)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("oauthToken", cdk.validateString)(properties.oauthToken)), errors.collect(cdk.propertyValidator("platform", cdk.validateString)(properties.platform)), errors.collect(cdk.propertyValidator("repository", cdk.validateString)(properties.repository)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnAppProps"');
    }
    function cfnAppPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAppPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), AccessToken: cdk.stringToCloudFormation(properties.accessToken), AutoBranchCreationConfig: cfnAppAutoBranchCreationConfigPropertyToCloudFormation(properties.autoBranchCreationConfig), BasicAuthConfig: cfnAppBasicAuthConfigPropertyToCloudFormation(properties.basicAuthConfig), BuildSpec: cdk.stringToCloudFormation(properties.buildSpec), CustomHeaders: cdk.stringToCloudFormation(properties.customHeaders), CustomRules: cdk.listMapper(cfnAppCustomRulePropertyToCloudFormation)(properties.customRules), Description: cdk.stringToCloudFormation(properties.description), EnableBranchAutoDeletion: cdk.booleanToCloudFormation(properties.enableBranchAutoDeletion), EnvironmentVariables: cdk.listMapper(cfnAppEnvironmentVariablePropertyToCloudFormation)(properties.environmentVariables), IAMServiceRole: cdk.stringToCloudFormation(properties.iamServiceRole), OauthToken: cdk.stringToCloudFormation(properties.oauthToken), Platform: cdk.stringToCloudFormation(properties.platform), Repository: cdk.stringToCloudFormation(properties.repository), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnAppPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("accessToken", "AccessToken", properties.AccessToken != null ? cfn_parse.FromCloudFormation.getString(properties.AccessToken) : void 0), ret.addPropertyResult("autoBranchCreationConfig", "AutoBranchCreationConfig", properties.AutoBranchCreationConfig != null ? CfnAppAutoBranchCreationConfigPropertyFromCloudFormation(properties.AutoBranchCreationConfig) : void 0), ret.addPropertyResult("basicAuthConfig", "BasicAuthConfig", properties.BasicAuthConfig != null ? CfnAppBasicAuthConfigPropertyFromCloudFormation(properties.BasicAuthConfig) : void 0), ret.addPropertyResult("buildSpec", "BuildSpec", properties.BuildSpec != null ? cfn_parse.FromCloudFormation.getString(properties.BuildSpec) : void 0), ret.addPropertyResult("customHeaders", "CustomHeaders", properties.CustomHeaders != null ? cfn_parse.FromCloudFormation.getString(properties.CustomHeaders) : void 0), ret.addPropertyResult("customRules", "CustomRules", properties.CustomRules != null ? cfn_parse.FromCloudFormation.getArray(CfnAppCustomRulePropertyFromCloudFormation)(properties.CustomRules) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("enableBranchAutoDeletion", "EnableBranchAutoDeletion", properties.EnableBranchAutoDeletion != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableBranchAutoDeletion) : void 0), ret.addPropertyResult("environmentVariables", "EnvironmentVariables", properties.EnvironmentVariables != null ? cfn_parse.FromCloudFormation.getArray(CfnAppEnvironmentVariablePropertyFromCloudFormation)(properties.EnvironmentVariables) : void 0), ret.addPropertyResult("iamServiceRole", "IAMServiceRole", properties.IAMServiceRole != null ? cfn_parse.FromCloudFormation.getString(properties.IAMServiceRole) : void 0), ret.addPropertyResult("oauthToken", "OauthToken", properties.OauthToken != null ? cfn_parse.FromCloudFormation.getString(properties.OauthToken) : void 0), ret.addPropertyResult("platform", "Platform", properties.Platform != null ? cfn_parse.FromCloudFormation.getString(properties.Platform) : void 0), ret.addPropertyResult("repository", "Repository", properties.Repository != null ? cfn_parse.FromCloudFormation.getString(properties.Repository) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApp = class _CfnApp extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAppPropsFromCloudFormation(resourceProperties), ret = new _CfnApp(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApp.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_amplify_CfnAppProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApp), error;
        }
        cdk.requireProperty(props, "name", this), this.attrAppId = cdk.Token.asString(this.getAtt("AppId", cdk.ResolutionTypeHint.STRING)), this.attrAppName = cdk.Token.asString(this.getAtt("AppName", cdk.ResolutionTypeHint.STRING)), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrDefaultDomain = cdk.Token.asString(this.getAtt("DefaultDomain", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.accessToken = props.accessToken, this.autoBranchCreationConfig = props.autoBranchCreationConfig, this.basicAuthConfig = props.basicAuthConfig, this.buildSpec = props.buildSpec, this.customHeaders = props.customHeaders, this.customRules = props.customRules, this.description = props.description, this.enableBranchAutoDeletion = props.enableBranchAutoDeletion, this.environmentVariables = props.environmentVariables, this.iamServiceRole = props.iamServiceRole, this.oauthToken = props.oauthToken, this.platform = props.platform, this.repository = props.repository, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Amplify::App", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApp.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, accessToken: this.accessToken, autoBranchCreationConfig: this.autoBranchCreationConfig, basicAuthConfig: this.basicAuthConfig, buildSpec: this.buildSpec, customHeaders: this.customHeaders, customRules: this.customRules, description: this.description, enableBranchAutoDeletion: this.enableBranchAutoDeletion, environmentVariables: this.environmentVariables, iamServiceRole: this.iamServiceRole, oauthToken: this.oauthToken, platform: this.platform, repository: this.repository, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnAppPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnApp[_a] = { fqn: "aws-cdk-lib.aws_amplify.CfnApp", version: "2.80.0" }, CfnApp.CFN_RESOURCE_TYPE_NAME = "AWS::Amplify::App", exports2.CfnApp = CfnApp;
    function CfnApp_AutoBranchCreationConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoBranchCreationPatterns", cdk.listValidator(cdk.validateString))(properties.autoBranchCreationPatterns)), errors.collect(cdk.propertyValidator("basicAuthConfig", CfnApp_BasicAuthConfigPropertyValidator)(properties.basicAuthConfig)), errors.collect(cdk.propertyValidator("buildSpec", cdk.validateString)(properties.buildSpec)), errors.collect(cdk.propertyValidator("enableAutoBranchCreation", cdk.validateBoolean)(properties.enableAutoBranchCreation)), errors.collect(cdk.propertyValidator("enableAutoBuild", cdk.validateBoolean)(properties.enableAutoBuild)), errors.collect(cdk.propertyValidator("enablePerformanceMode", cdk.validateBoolean)(properties.enablePerformanceMode)), errors.collect(cdk.propertyValidator("enablePullRequestPreview", cdk.validateBoolean)(properties.enablePullRequestPreview)), errors.collect(cdk.propertyValidator("environmentVariables", cdk.listValidator(CfnApp_EnvironmentVariablePropertyValidator))(properties.environmentVariables)), errors.collect(cdk.propertyValidator("framework", cdk.validateString)(properties.framework)), errors.collect(cdk.propertyValidator("pullRequestEnvironmentName", cdk.validateString)(properties.pullRequestEnvironmentName)), errors.collect(cdk.propertyValidator("stage", cdk.validateString)(properties.stage)), errors.wrap('supplied properties not correct for "AutoBranchCreationConfigProperty"');
    }
    function cfnAppAutoBranchCreationConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApp_AutoBranchCreationConfigPropertyValidator(properties).assertSuccess(), { AutoBranchCreationPatterns: cdk.listMapper(cdk.stringToCloudFormation)(properties.autoBranchCreationPatterns), BasicAuthConfig: cfnAppBasicAuthConfigPropertyToCloudFormation(properties.basicAuthConfig), BuildSpec: cdk.stringToCloudFormation(properties.buildSpec), EnableAutoBranchCreation: cdk.booleanToCloudFormation(properties.enableAutoBranchCreation), EnableAutoBuild: cdk.booleanToCloudFormation(properties.enableAutoBuild), EnablePerformanceMode: cdk.booleanToCloudFormation(properties.enablePerformanceMode), EnablePullRequestPreview: cdk.booleanToCloudFormation(properties.enablePullRequestPreview), EnvironmentVariables: cdk.listMapper(cfnAppEnvironmentVariablePropertyToCloudFormation)(properties.environmentVariables), Framework: cdk.stringToCloudFormation(properties.framework), PullRequestEnvironmentName: cdk.stringToCloudFormation(properties.pullRequestEnvironmentName), Stage: cdk.stringToCloudFormation(properties.stage) }) : properties;
    }
    function CfnAppAutoBranchCreationConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("autoBranchCreationPatterns", "AutoBranchCreationPatterns", properties.AutoBranchCreationPatterns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AutoBranchCreationPatterns) : void 0), ret.addPropertyResult("basicAuthConfig", "BasicAuthConfig", properties.BasicAuthConfig != null ? CfnAppBasicAuthConfigPropertyFromCloudFormation(properties.BasicAuthConfig) : void 0), ret.addPropertyResult("buildSpec", "BuildSpec", properties.BuildSpec != null ? cfn_parse.FromCloudFormation.getString(properties.BuildSpec) : void 0), ret.addPropertyResult("enableAutoBranchCreation", "EnableAutoBranchCreation", properties.EnableAutoBranchCreation != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableAutoBranchCreation) : void 0), ret.addPropertyResult("enableAutoBuild", "EnableAutoBuild", properties.EnableAutoBuild != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableAutoBuild) : void 0), ret.addPropertyResult("enablePerformanceMode", "EnablePerformanceMode", properties.EnablePerformanceMode != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnablePerformanceMode) : void 0), ret.addPropertyResult("enablePullRequestPreview", "EnablePullRequestPreview", properties.EnablePullRequestPreview != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnablePullRequestPreview) : void 0), ret.addPropertyResult("environmentVariables", "EnvironmentVariables", properties.EnvironmentVariables != null ? cfn_parse.FromCloudFormation.getArray(CfnAppEnvironmentVariablePropertyFromCloudFormation)(properties.EnvironmentVariables) : void 0), ret.addPropertyResult("framework", "Framework", properties.Framework != null ? cfn_parse.FromCloudFormation.getString(properties.Framework) : void 0), ret.addPropertyResult("pullRequestEnvironmentName", "PullRequestEnvironmentName", properties.PullRequestEnvironmentName != null ? cfn_parse.FromCloudFormation.getString(properties.PullRequestEnvironmentName) : void 0), ret.addPropertyResult("stage", "Stage", properties.Stage != null ? cfn_parse.FromCloudFormation.getString(properties.Stage) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApp_BasicAuthConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enableBasicAuth", cdk.validateBoolean)(properties.enableBasicAuth)), errors.collect(cdk.propertyValidator("password", cdk.validateString)(properties.password)), errors.collect(cdk.propertyValidator("username", cdk.validateString)(properties.username)), errors.wrap('supplied properties not correct for "BasicAuthConfigProperty"');
    }
    function cfnAppBasicAuthConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApp_BasicAuthConfigPropertyValidator(properties).assertSuccess(), { EnableBasicAuth: cdk.booleanToCloudFormation(properties.enableBasicAuth), Password: cdk.stringToCloudFormation(properties.password), Username: cdk.stringToCloudFormation(properties.username) }) : properties;
    }
    function CfnAppBasicAuthConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enableBasicAuth", "EnableBasicAuth", properties.EnableBasicAuth != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableBasicAuth) : void 0), ret.addPropertyResult("password", "Password", properties.Password != null ? cfn_parse.FromCloudFormation.getString(properties.Password) : void 0), ret.addPropertyResult("username", "Username", properties.Username != null ? cfn_parse.FromCloudFormation.getString(properties.Username) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApp_CustomRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("condition", cdk.validateString)(properties.condition)), errors.collect(cdk.propertyValidator("source", cdk.requiredValidator)(properties.source)), errors.collect(cdk.propertyValidator("source", cdk.validateString)(properties.source)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.collect(cdk.propertyValidator("target", cdk.requiredValidator)(properties.target)), errors.collect(cdk.propertyValidator("target", cdk.validateString)(properties.target)), errors.wrap('supplied properties not correct for "CustomRuleProperty"');
    }
    function cfnAppCustomRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApp_CustomRulePropertyValidator(properties).assertSuccess(), { Condition: cdk.stringToCloudFormation(properties.condition), Source: cdk.stringToCloudFormation(properties.source), Status: cdk.stringToCloudFormation(properties.status), Target: cdk.stringToCloudFormation(properties.target) }) : properties;
    }
    function CfnAppCustomRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("condition", "Condition", properties.Condition != null ? cfn_parse.FromCloudFormation.getString(properties.Condition) : void 0), ret.addPropertyResult("source", "Source", cfn_parse.FromCloudFormation.getString(properties.Source)), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addPropertyResult("target", "Target", cfn_parse.FromCloudFormation.getString(properties.Target)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApp_EnvironmentVariablePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "EnvironmentVariableProperty"');
    }
    function cfnAppEnvironmentVariablePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApp_EnvironmentVariablePropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnAppEnvironmentVariablePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBranchPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("appId", cdk.requiredValidator)(properties.appId)), errors.collect(cdk.propertyValidator("appId", cdk.validateString)(properties.appId)), errors.collect(cdk.propertyValidator("basicAuthConfig", CfnBranch_BasicAuthConfigPropertyValidator)(properties.basicAuthConfig)), errors.collect(cdk.propertyValidator("branchName", cdk.requiredValidator)(properties.branchName)), errors.collect(cdk.propertyValidator("branchName", cdk.validateString)(properties.branchName)), errors.collect(cdk.propertyValidator("buildSpec", cdk.validateString)(properties.buildSpec)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("enableAutoBuild", cdk.validateBoolean)(properties.enableAutoBuild)), errors.collect(cdk.propertyValidator("enablePerformanceMode", cdk.validateBoolean)(properties.enablePerformanceMode)), errors.collect(cdk.propertyValidator("enablePullRequestPreview", cdk.validateBoolean)(properties.enablePullRequestPreview)), errors.collect(cdk.propertyValidator("environmentVariables", cdk.listValidator(CfnBranch_EnvironmentVariablePropertyValidator))(properties.environmentVariables)), errors.collect(cdk.propertyValidator("framework", cdk.validateString)(properties.framework)), errors.collect(cdk.propertyValidator("pullRequestEnvironmentName", cdk.validateString)(properties.pullRequestEnvironmentName)), errors.collect(cdk.propertyValidator("stage", cdk.validateString)(properties.stage)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnBranchProps"');
    }
    function cfnBranchPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBranchPropsValidator(properties).assertSuccess(), { AppId: cdk.stringToCloudFormation(properties.appId), BranchName: cdk.stringToCloudFormation(properties.branchName), BasicAuthConfig: cfnBranchBasicAuthConfigPropertyToCloudFormation(properties.basicAuthConfig), BuildSpec: cdk.stringToCloudFormation(properties.buildSpec), Description: cdk.stringToCloudFormation(properties.description), EnableAutoBuild: cdk.booleanToCloudFormation(properties.enableAutoBuild), EnablePerformanceMode: cdk.booleanToCloudFormation(properties.enablePerformanceMode), EnablePullRequestPreview: cdk.booleanToCloudFormation(properties.enablePullRequestPreview), EnvironmentVariables: cdk.listMapper(cfnBranchEnvironmentVariablePropertyToCloudFormation)(properties.environmentVariables), Framework: cdk.stringToCloudFormation(properties.framework), PullRequestEnvironmentName: cdk.stringToCloudFormation(properties.pullRequestEnvironmentName), Stage: cdk.stringToCloudFormation(properties.stage), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnBranchPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("appId", "AppId", cfn_parse.FromCloudFormation.getString(properties.AppId)), ret.addPropertyResult("branchName", "BranchName", cfn_parse.FromCloudFormation.getString(properties.BranchName)), ret.addPropertyResult("basicAuthConfig", "BasicAuthConfig", properties.BasicAuthConfig != null ? CfnBranchBasicAuthConfigPropertyFromCloudFormation(properties.BasicAuthConfig) : void 0), ret.addPropertyResult("buildSpec", "BuildSpec", properties.BuildSpec != null ? cfn_parse.FromCloudFormation.getString(properties.BuildSpec) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("enableAutoBuild", "EnableAutoBuild", properties.EnableAutoBuild != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableAutoBuild) : void 0), ret.addPropertyResult("enablePerformanceMode", "EnablePerformanceMode", properties.EnablePerformanceMode != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnablePerformanceMode) : void 0), ret.addPropertyResult("enablePullRequestPreview", "EnablePullRequestPreview", properties.EnablePullRequestPreview != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnablePullRequestPreview) : void 0), ret.addPropertyResult("environmentVariables", "EnvironmentVariables", properties.EnvironmentVariables != null ? cfn_parse.FromCloudFormation.getArray(CfnBranchEnvironmentVariablePropertyFromCloudFormation)(properties.EnvironmentVariables) : void 0), ret.addPropertyResult("framework", "Framework", properties.Framework != null ? cfn_parse.FromCloudFormation.getString(properties.Framework) : void 0), ret.addPropertyResult("pullRequestEnvironmentName", "PullRequestEnvironmentName", properties.PullRequestEnvironmentName != null ? cfn_parse.FromCloudFormation.getString(properties.PullRequestEnvironmentName) : void 0), ret.addPropertyResult("stage", "Stage", properties.Stage != null ? cfn_parse.FromCloudFormation.getString(properties.Stage) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnBranch = class _CfnBranch extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnBranchPropsFromCloudFormation(resourceProperties), ret = new _CfnBranch(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnBranch.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_amplify_CfnBranchProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnBranch), error;
        }
        cdk.requireProperty(props, "appId", this), cdk.requireProperty(props, "branchName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrBranchName = cdk.Token.asString(this.getAtt("BranchName", cdk.ResolutionTypeHint.STRING)), this.appId = props.appId, this.branchName = props.branchName, this.basicAuthConfig = props.basicAuthConfig, this.buildSpec = props.buildSpec, this.description = props.description, this.enableAutoBuild = props.enableAutoBuild, this.enablePerformanceMode = props.enablePerformanceMode, this.enablePullRequestPreview = props.enablePullRequestPreview, this.environmentVariables = props.environmentVariables, this.framework = props.framework, this.pullRequestEnvironmentName = props.pullRequestEnvironmentName, this.stage = props.stage, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Amplify::Branch", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnBranch.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { appId: this.appId, branchName: this.branchName, basicAuthConfig: this.basicAuthConfig, buildSpec: this.buildSpec, description: this.description, enableAutoBuild: this.enableAutoBuild, enablePerformanceMode: this.enablePerformanceMode, enablePullRequestPreview: this.enablePullRequestPreview, environmentVariables: this.environmentVariables, framework: this.framework, pullRequestEnvironmentName: this.pullRequestEnvironmentName, stage: this.stage, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnBranchPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnBranch[_b] = { fqn: "aws-cdk-lib.aws_amplify.CfnBranch", version: "2.80.0" }, CfnBranch.CFN_RESOURCE_TYPE_NAME = "AWS::Amplify::Branch", exports2.CfnBranch = CfnBranch;
    function CfnBranch_BasicAuthConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enableBasicAuth", cdk.validateBoolean)(properties.enableBasicAuth)), errors.collect(cdk.propertyValidator("password", cdk.requiredValidator)(properties.password)), errors.collect(cdk.propertyValidator("password", cdk.validateString)(properties.password)), errors.collect(cdk.propertyValidator("username", cdk.requiredValidator)(properties.username)), errors.collect(cdk.propertyValidator("username", cdk.validateString)(properties.username)), errors.wrap('supplied properties not correct for "BasicAuthConfigProperty"');
    }
    function cfnBranchBasicAuthConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBranch_BasicAuthConfigPropertyValidator(properties).assertSuccess(), { EnableBasicAuth: cdk.booleanToCloudFormation(properties.enableBasicAuth), Password: cdk.stringToCloudFormation(properties.password), Username: cdk.stringToCloudFormation(properties.username) }) : properties;
    }
    function CfnBranchBasicAuthConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enableBasicAuth", "EnableBasicAuth", properties.EnableBasicAuth != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableBasicAuth) : void 0), ret.addPropertyResult("password", "Password", cfn_parse.FromCloudFormation.getString(properties.Password)), ret.addPropertyResult("username", "Username", cfn_parse.FromCloudFormation.getString(properties.Username)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBranch_EnvironmentVariablePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "EnvironmentVariableProperty"');
    }
    function cfnBranchEnvironmentVariablePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBranch_EnvironmentVariablePropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnBranchEnvironmentVariablePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomainPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("appId", cdk.requiredValidator)(properties.appId)), errors.collect(cdk.propertyValidator("appId", cdk.validateString)(properties.appId)), errors.collect(cdk.propertyValidator("autoSubDomainCreationPatterns", cdk.listValidator(cdk.validateString))(properties.autoSubDomainCreationPatterns)), errors.collect(cdk.propertyValidator("autoSubDomainIamRole", cdk.validateString)(properties.autoSubDomainIamRole)), errors.collect(cdk.propertyValidator("domainName", cdk.requiredValidator)(properties.domainName)), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.collect(cdk.propertyValidator("enableAutoSubDomain", cdk.validateBoolean)(properties.enableAutoSubDomain)), errors.collect(cdk.propertyValidator("subDomainSettings", cdk.requiredValidator)(properties.subDomainSettings)), errors.collect(cdk.propertyValidator("subDomainSettings", cdk.listValidator(CfnDomain_SubDomainSettingPropertyValidator))(properties.subDomainSettings)), errors.wrap('supplied properties not correct for "CfnDomainProps"');
    }
    function cfnDomainPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomainPropsValidator(properties).assertSuccess(), { AppId: cdk.stringToCloudFormation(properties.appId), DomainName: cdk.stringToCloudFormation(properties.domainName), SubDomainSettings: cdk.listMapper(cfnDomainSubDomainSettingPropertyToCloudFormation)(properties.subDomainSettings), AutoSubDomainCreationPatterns: cdk.listMapper(cdk.stringToCloudFormation)(properties.autoSubDomainCreationPatterns), AutoSubDomainIAMRole: cdk.stringToCloudFormation(properties.autoSubDomainIamRole), EnableAutoSubDomain: cdk.booleanToCloudFormation(properties.enableAutoSubDomain) }) : properties;
    }
    function CfnDomainPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("appId", "AppId", cfn_parse.FromCloudFormation.getString(properties.AppId)), ret.addPropertyResult("domainName", "DomainName", cfn_parse.FromCloudFormation.getString(properties.DomainName)), ret.addPropertyResult("subDomainSettings", "SubDomainSettings", cfn_parse.FromCloudFormation.getArray(CfnDomainSubDomainSettingPropertyFromCloudFormation)(properties.SubDomainSettings)), ret.addPropertyResult("autoSubDomainCreationPatterns", "AutoSubDomainCreationPatterns", properties.AutoSubDomainCreationPatterns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AutoSubDomainCreationPatterns) : void 0), ret.addPropertyResult("autoSubDomainIamRole", "AutoSubDomainIAMRole", properties.AutoSubDomainIAMRole != null ? cfn_parse.FromCloudFormation.getString(properties.AutoSubDomainIAMRole) : void 0), ret.addPropertyResult("enableAutoSubDomain", "EnableAutoSubDomain", properties.EnableAutoSubDomain != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableAutoSubDomain) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDomain = class _CfnDomain extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDomainPropsFromCloudFormation(resourceProperties), ret = new _CfnDomain(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDomain.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_amplify_CfnDomainProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDomain), error;
        }
        cdk.requireProperty(props, "appId", this), cdk.requireProperty(props, "domainName", this), cdk.requireProperty(props, "subDomainSettings", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrAutoSubDomainCreationPatterns = cdk.Token.asList(this.getAtt("AutoSubDomainCreationPatterns", cdk.ResolutionTypeHint.STRING_LIST)), this.attrAutoSubDomainIamRole = cdk.Token.asString(this.getAtt("AutoSubDomainIAMRole", cdk.ResolutionTypeHint.STRING)), this.attrCertificateRecord = cdk.Token.asString(this.getAtt("CertificateRecord", cdk.ResolutionTypeHint.STRING)), this.attrDomainName = cdk.Token.asString(this.getAtt("DomainName", cdk.ResolutionTypeHint.STRING)), this.attrDomainStatus = cdk.Token.asString(this.getAtt("DomainStatus", cdk.ResolutionTypeHint.STRING)), this.attrEnableAutoSubDomain = this.getAtt("EnableAutoSubDomain", cdk.ResolutionTypeHint.STRING), this.attrStatusReason = cdk.Token.asString(this.getAtt("StatusReason", cdk.ResolutionTypeHint.STRING)), this.appId = props.appId, this.domainName = props.domainName, this.subDomainSettings = props.subDomainSettings, this.autoSubDomainCreationPatterns = props.autoSubDomainCreationPatterns, this.autoSubDomainIamRole = props.autoSubDomainIamRole, this.enableAutoSubDomain = props.enableAutoSubDomain;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDomain.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { appId: this.appId, domainName: this.domainName, subDomainSettings: this.subDomainSettings, autoSubDomainCreationPatterns: this.autoSubDomainCreationPatterns, autoSubDomainIamRole: this.autoSubDomainIamRole, enableAutoSubDomain: this.enableAutoSubDomain };
      }
      renderProperties(props) {
        return cfnDomainPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnDomain[_c] = { fqn: "aws-cdk-lib.aws_amplify.CfnDomain", version: "2.80.0" }, CfnDomain.CFN_RESOURCE_TYPE_NAME = "AWS::Amplify::Domain", exports2.CfnDomain = CfnDomain;
    function CfnDomain_SubDomainSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("branchName", cdk.requiredValidator)(properties.branchName)), errors.collect(cdk.propertyValidator("branchName", cdk.validateString)(properties.branchName)), errors.collect(cdk.propertyValidator("prefix", cdk.requiredValidator)(properties.prefix)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.wrap('supplied properties not correct for "SubDomainSettingProperty"');
    }
    function cfnDomainSubDomainSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_SubDomainSettingPropertyValidator(properties).assertSuccess(), { BranchName: cdk.stringToCloudFormation(properties.branchName), Prefix: cdk.stringToCloudFormation(properties.prefix) }) : properties;
    }
    function CfnDomainSubDomainSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("branchName", "BranchName", cfn_parse.FromCloudFormation.getString(properties.BranchName)), ret.addPropertyResult("prefix", "Prefix", cfn_parse.FromCloudFormation.getString(properties.Prefix)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-amplify/lib/index.js
var require_lib36 = __commonJS({
  "node_modules/aws-cdk-lib/aws-amplify/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_amplify_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-amplify/index.js
var require_aws_amplify = __commonJS({
  "node_modules/aws-cdk-lib/aws-amplify/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib36(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-amplifyuibuilder/lib/amplifyuibuilder.generated.js
var require_amplifyuibuilder_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-amplifyuibuilder/lib/amplifyuibuilder.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnTheme = exports2.CfnForm = exports2.CfnComponent = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnComponentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("appId", cdk.validateString)(properties.appId)), errors.collect(cdk.propertyValidator("bindingProperties", cdk.requiredValidator)(properties.bindingProperties)), errors.collect(cdk.propertyValidator("bindingProperties", cdk.hashValidator(CfnComponent_ComponentBindingPropertiesValuePropertyValidator))(properties.bindingProperties)), errors.collect(cdk.propertyValidator("children", cdk.listValidator(CfnComponent_ComponentChildPropertyValidator))(properties.children)), errors.collect(cdk.propertyValidator("collectionProperties", cdk.hashValidator(CfnComponent_ComponentDataConfigurationPropertyValidator))(properties.collectionProperties)), errors.collect(cdk.propertyValidator("componentType", cdk.requiredValidator)(properties.componentType)), errors.collect(cdk.propertyValidator("componentType", cdk.validateString)(properties.componentType)), errors.collect(cdk.propertyValidator("environmentName", cdk.validateString)(properties.environmentName)), errors.collect(cdk.propertyValidator("events", cdk.hashValidator(CfnComponent_ComponentEventPropertyValidator))(properties.events)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("overrides", cdk.requiredValidator)(properties.overrides)), errors.collect(cdk.propertyValidator("overrides", cdk.validateObject)(properties.overrides)), errors.collect(cdk.propertyValidator("properties", cdk.requiredValidator)(properties.properties)), errors.collect(cdk.propertyValidator("properties", cdk.hashValidator(CfnComponent_ComponentPropertyPropertyValidator))(properties.properties)), errors.collect(cdk.propertyValidator("schemaVersion", cdk.validateString)(properties.schemaVersion)), errors.collect(cdk.propertyValidator("sourceId", cdk.validateString)(properties.sourceId)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.collect(cdk.propertyValidator("variants", cdk.requiredValidator)(properties.variants)), errors.collect(cdk.propertyValidator("variants", cdk.listValidator(CfnComponent_ComponentVariantPropertyValidator))(properties.variants)), errors.wrap('supplied properties not correct for "CfnComponentProps"');
    }
    function cfnComponentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponentPropsValidator(properties).assertSuccess(), { BindingProperties: cdk.hashMapper(cfnComponentComponentBindingPropertiesValuePropertyToCloudFormation)(properties.bindingProperties), ComponentType: cdk.stringToCloudFormation(properties.componentType), Name: cdk.stringToCloudFormation(properties.name), Overrides: cdk.objectToCloudFormation(properties.overrides), Properties: cdk.hashMapper(cfnComponentComponentPropertyPropertyToCloudFormation)(properties.properties), Variants: cdk.listMapper(cfnComponentComponentVariantPropertyToCloudFormation)(properties.variants), AppId: cdk.stringToCloudFormation(properties.appId), Children: cdk.listMapper(cfnComponentComponentChildPropertyToCloudFormation)(properties.children), CollectionProperties: cdk.hashMapper(cfnComponentComponentDataConfigurationPropertyToCloudFormation)(properties.collectionProperties), EnvironmentName: cdk.stringToCloudFormation(properties.environmentName), Events: cdk.hashMapper(cfnComponentComponentEventPropertyToCloudFormation)(properties.events), SchemaVersion: cdk.stringToCloudFormation(properties.schemaVersion), SourceId: cdk.stringToCloudFormation(properties.sourceId), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnComponentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bindingProperties", "BindingProperties", cfn_parse.FromCloudFormation.getMap(CfnComponentComponentBindingPropertiesValuePropertyFromCloudFormation)(properties.BindingProperties)), ret.addPropertyResult("componentType", "ComponentType", cfn_parse.FromCloudFormation.getString(properties.ComponentType)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("overrides", "Overrides", cfn_parse.FromCloudFormation.getAny(properties.Overrides)), ret.addPropertyResult("properties", "Properties", cfn_parse.FromCloudFormation.getMap(CfnComponentComponentPropertyPropertyFromCloudFormation)(properties.Properties)), ret.addPropertyResult("variants", "Variants", cfn_parse.FromCloudFormation.getArray(CfnComponentComponentVariantPropertyFromCloudFormation)(properties.Variants)), ret.addPropertyResult("appId", "AppId", properties.AppId != null ? cfn_parse.FromCloudFormation.getString(properties.AppId) : void 0), ret.addPropertyResult("children", "Children", properties.Children != null ? cfn_parse.FromCloudFormation.getArray(CfnComponentComponentChildPropertyFromCloudFormation)(properties.Children) : void 0), ret.addPropertyResult("collectionProperties", "CollectionProperties", properties.CollectionProperties != null ? cfn_parse.FromCloudFormation.getMap(CfnComponentComponentDataConfigurationPropertyFromCloudFormation)(properties.CollectionProperties) : void 0), ret.addPropertyResult("environmentName", "EnvironmentName", properties.EnvironmentName != null ? cfn_parse.FromCloudFormation.getString(properties.EnvironmentName) : void 0), ret.addPropertyResult("events", "Events", properties.Events != null ? cfn_parse.FromCloudFormation.getMap(CfnComponentComponentEventPropertyFromCloudFormation)(properties.Events) : void 0), ret.addPropertyResult("schemaVersion", "SchemaVersion", properties.SchemaVersion != null ? cfn_parse.FromCloudFormation.getString(properties.SchemaVersion) : void 0), ret.addPropertyResult("sourceId", "SourceId", properties.SourceId != null ? cfn_parse.FromCloudFormation.getString(properties.SourceId) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnComponent = class _CfnComponent extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnComponentPropsFromCloudFormation(resourceProperties), ret = new _CfnComponent(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnComponent.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_amplifyuibuilder_CfnComponentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnComponent), error;
        }
        cdk.requireProperty(props, "bindingProperties", this), cdk.requireProperty(props, "componentType", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "overrides", this), cdk.requireProperty(props, "properties", this), cdk.requireProperty(props, "variants", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.bindingProperties = props.bindingProperties, this.componentType = props.componentType, this.name = props.name, this.overrides = props.overrides, this.properties = props.properties, this.variants = props.variants, this.appId = props.appId, this.children = props.children, this.collectionProperties = props.collectionProperties, this.environmentName = props.environmentName, this.events = props.events, this.schemaVersion = props.schemaVersion, this.sourceId = props.sourceId, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::AmplifyUIBuilder::Component", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnComponent.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { bindingProperties: this.bindingProperties, componentType: this.componentType, name: this.name, overrides: this.overrides, properties: this.properties, variants: this.variants, appId: this.appId, children: this.children, collectionProperties: this.collectionProperties, environmentName: this.environmentName, events: this.events, schemaVersion: this.schemaVersion, sourceId: this.sourceId, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnComponentPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnComponent[_a] = { fqn: "aws-cdk-lib.aws_amplifyuibuilder.CfnComponent", version: "2.80.0" }, CfnComponent.CFN_RESOURCE_TYPE_NAME = "AWS::AmplifyUIBuilder::Component", exports2.CfnComponent = CfnComponent;
    function CfnComponent_ActionParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("anchor", CfnComponent_ComponentPropertyPropertyValidator)(properties.anchor)), errors.collect(cdk.propertyValidator("fields", cdk.hashValidator(CfnComponent_ComponentPropertyPropertyValidator))(properties.fields)), errors.collect(cdk.propertyValidator("global", CfnComponent_ComponentPropertyPropertyValidator)(properties.global)), errors.collect(cdk.propertyValidator("id", CfnComponent_ComponentPropertyPropertyValidator)(properties.id)), errors.collect(cdk.propertyValidator("model", cdk.validateString)(properties.model)), errors.collect(cdk.propertyValidator("state", CfnComponent_MutationActionSetStateParameterPropertyValidator)(properties.state)), errors.collect(cdk.propertyValidator("target", CfnComponent_ComponentPropertyPropertyValidator)(properties.target)), errors.collect(cdk.propertyValidator("type", CfnComponent_ComponentPropertyPropertyValidator)(properties.type)), errors.collect(cdk.propertyValidator("url", CfnComponent_ComponentPropertyPropertyValidator)(properties.url)), errors.wrap('supplied properties not correct for "ActionParametersProperty"');
    }
    function cfnComponentActionParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponent_ActionParametersPropertyValidator(properties).assertSuccess(), { Anchor: cfnComponentComponentPropertyPropertyToCloudFormation(properties.anchor), Fields: cdk.hashMapper(cfnComponentComponentPropertyPropertyToCloudFormation)(properties.fields), Global: cfnComponentComponentPropertyPropertyToCloudFormation(properties.global), Id: cfnComponentComponentPropertyPropertyToCloudFormation(properties.id), Model: cdk.stringToCloudFormation(properties.model), State: cfnComponentMutationActionSetStateParameterPropertyToCloudFormation(properties.state), Target: cfnComponentComponentPropertyPropertyToCloudFormation(properties.target), Type: cfnComponentComponentPropertyPropertyToCloudFormation(properties.type), Url: cfnComponentComponentPropertyPropertyToCloudFormation(properties.url) }) : properties;
    }
    function CfnComponentActionParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("anchor", "Anchor", properties.Anchor != null ? CfnComponentComponentPropertyPropertyFromCloudFormation(properties.Anchor) : void 0), ret.addPropertyResult("fields", "Fields", properties.Fields != null ? cfn_parse.FromCloudFormation.getMap(CfnComponentComponentPropertyPropertyFromCloudFormation)(properties.Fields) : void 0), ret.addPropertyResult("global", "Global", properties.Global != null ? CfnComponentComponentPropertyPropertyFromCloudFormation(properties.Global) : void 0), ret.addPropertyResult("id", "Id", properties.Id != null ? CfnComponentComponentPropertyPropertyFromCloudFormation(properties.Id) : void 0), ret.addPropertyResult("model", "Model", properties.Model != null ? cfn_parse.FromCloudFormation.getString(properties.Model) : void 0), ret.addPropertyResult("state", "State", properties.State != null ? CfnComponentMutationActionSetStateParameterPropertyFromCloudFormation(properties.State) : void 0), ret.addPropertyResult("target", "Target", properties.Target != null ? CfnComponentComponentPropertyPropertyFromCloudFormation(properties.Target) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? CfnComponentComponentPropertyPropertyFromCloudFormation(properties.Type) : void 0), ret.addPropertyResult("url", "Url", properties.Url != null ? CfnComponentComponentPropertyPropertyFromCloudFormation(properties.Url) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComponent_ComponentBindingPropertiesValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bindingProperties", CfnComponent_ComponentBindingPropertiesValuePropertiesPropertyValidator)(properties.bindingProperties)), errors.collect(cdk.propertyValidator("defaultValue", cdk.validateString)(properties.defaultValue)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "ComponentBindingPropertiesValueProperty"');
    }
    function cfnComponentComponentBindingPropertiesValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponent_ComponentBindingPropertiesValuePropertyValidator(properties).assertSuccess(), { BindingProperties: cfnComponentComponentBindingPropertiesValuePropertiesPropertyToCloudFormation(properties.bindingProperties), DefaultValue: cdk.stringToCloudFormation(properties.defaultValue), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnComponentComponentBindingPropertiesValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bindingProperties", "BindingProperties", properties.BindingProperties != null ? CfnComponentComponentBindingPropertiesValuePropertiesPropertyFromCloudFormation(properties.BindingProperties) : void 0), ret.addPropertyResult("defaultValue", "DefaultValue", properties.DefaultValue != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultValue) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComponent_ComponentBindingPropertiesValuePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("defaultValue", cdk.validateString)(properties.defaultValue)), errors.collect(cdk.propertyValidator("field", cdk.validateString)(properties.field)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("model", cdk.validateString)(properties.model)), errors.collect(cdk.propertyValidator("predicates", cdk.listValidator(CfnComponent_PredicatePropertyValidator))(properties.predicates)), errors.collect(cdk.propertyValidator("userAttribute", cdk.validateString)(properties.userAttribute)), errors.wrap('supplied properties not correct for "ComponentBindingPropertiesValuePropertiesProperty"');
    }
    function cfnComponentComponentBindingPropertiesValuePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponent_ComponentBindingPropertiesValuePropertiesPropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), DefaultValue: cdk.stringToCloudFormation(properties.defaultValue), Field: cdk.stringToCloudFormation(properties.field), Key: cdk.stringToCloudFormation(properties.key), Model: cdk.stringToCloudFormation(properties.model), Predicates: cdk.listMapper(cfnComponentPredicatePropertyToCloudFormation)(properties.predicates), UserAttribute: cdk.stringToCloudFormation(properties.userAttribute) }) : properties;
    }
    function CfnComponentComponentBindingPropertiesValuePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", properties.Bucket != null ? cfn_parse.FromCloudFormation.getString(properties.Bucket) : void 0), ret.addPropertyResult("defaultValue", "DefaultValue", properties.DefaultValue != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultValue) : void 0), ret.addPropertyResult("field", "Field", properties.Field != null ? cfn_parse.FromCloudFormation.getString(properties.Field) : void 0), ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("model", "Model", properties.Model != null ? cfn_parse.FromCloudFormation.getString(properties.Model) : void 0), ret.addPropertyResult("predicates", "Predicates", properties.Predicates != null ? cfn_parse.FromCloudFormation.getArray(CfnComponentPredicatePropertyFromCloudFormation)(properties.Predicates) : void 0), ret.addPropertyResult("userAttribute", "UserAttribute", properties.UserAttribute != null ? cfn_parse.FromCloudFormation.getString(properties.UserAttribute) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComponent_ComponentChildPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("children", cdk.listValidator(CfnComponent_ComponentChildPropertyValidator))(properties.children)), errors.collect(cdk.propertyValidator("componentType", cdk.requiredValidator)(properties.componentType)), errors.collect(cdk.propertyValidator("componentType", cdk.validateString)(properties.componentType)), errors.collect(cdk.propertyValidator("events", cdk.hashValidator(CfnComponent_ComponentEventPropertyValidator))(properties.events)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("properties", cdk.requiredValidator)(properties.properties)), errors.collect(cdk.propertyValidator("properties", cdk.hashValidator(CfnComponent_ComponentPropertyPropertyValidator))(properties.properties)), errors.wrap('supplied properties not correct for "ComponentChildProperty"');
    }
    function cfnComponentComponentChildPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponent_ComponentChildPropertyValidator(properties).assertSuccess(), { Children: cdk.listMapper(cfnComponentComponentChildPropertyToCloudFormation)(properties.children), ComponentType: cdk.stringToCloudFormation(properties.componentType), Events: cdk.hashMapper(cfnComponentComponentEventPropertyToCloudFormation)(properties.events), Name: cdk.stringToCloudFormation(properties.name), Properties: cdk.hashMapper(cfnComponentComponentPropertyPropertyToCloudFormation)(properties.properties) }) : properties;
    }
    function CfnComponentComponentChildPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("children", "Children", properties.Children != null ? cfn_parse.FromCloudFormation.getArray(CfnComponentComponentChildPropertyFromCloudFormation)(properties.Children) : void 0), ret.addPropertyResult("componentType", "ComponentType", cfn_parse.FromCloudFormation.getString(properties.ComponentType)), ret.addPropertyResult("events", "Events", properties.Events != null ? cfn_parse.FromCloudFormation.getMap(CfnComponentComponentEventPropertyFromCloudFormation)(properties.Events) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("properties", "Properties", cfn_parse.FromCloudFormation.getMap(CfnComponentComponentPropertyPropertyFromCloudFormation)(properties.Properties)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComponent_ComponentConditionPropertyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("else", CfnComponent_ComponentPropertyPropertyValidator)(properties.else)), errors.collect(cdk.propertyValidator("field", cdk.validateString)(properties.field)), errors.collect(cdk.propertyValidator("operand", cdk.validateString)(properties.operand)), errors.collect(cdk.propertyValidator("operandType", cdk.validateString)(properties.operandType)), errors.collect(cdk.propertyValidator("operator", cdk.validateString)(properties.operator)), errors.collect(cdk.propertyValidator("property", cdk.validateString)(properties.property)), errors.collect(cdk.propertyValidator("then", CfnComponent_ComponentPropertyPropertyValidator)(properties.then)), errors.wrap('supplied properties not correct for "ComponentConditionPropertyProperty"');
    }
    function cfnComponentComponentConditionPropertyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponent_ComponentConditionPropertyPropertyValidator(properties).assertSuccess(), { Else: cfnComponentComponentPropertyPropertyToCloudFormation(properties.else), Field: cdk.stringToCloudFormation(properties.field), Operand: cdk.stringToCloudFormation(properties.operand), OperandType: cdk.stringToCloudFormation(properties.operandType), Operator: cdk.stringToCloudFormation(properties.operator), Property: cdk.stringToCloudFormation(properties.property), Then: cfnComponentComponentPropertyPropertyToCloudFormation(properties.then) }) : properties;
    }
    function CfnComponentComponentConditionPropertyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("else", "Else", properties.Else != null ? CfnComponentComponentPropertyPropertyFromCloudFormation(properties.Else) : void 0), ret.addPropertyResult("field", "Field", properties.Field != null ? cfn_parse.FromCloudFormation.getString(properties.Field) : void 0), ret.addPropertyResult("operand", "Operand", properties.Operand != null ? cfn_parse.FromCloudFormation.getString(properties.Operand) : void 0), ret.addPropertyResult("operandType", "OperandType", properties.OperandType != null ? cfn_parse.FromCloudFormation.getString(properties.OperandType) : void 0), ret.addPropertyResult("operator", "Operator", properties.Operator != null ? cfn_parse.FromCloudFormation.getString(properties.Operator) : void 0), ret.addPropertyResult("property", "Property", properties.Property != null ? cfn_parse.FromCloudFormation.getString(properties.Property) : void 0), ret.addPropertyResult("then", "Then", properties.Then != null ? CfnComponentComponentPropertyPropertyFromCloudFormation(properties.Then) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComponent_ComponentDataConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("identifiers", cdk.listValidator(cdk.validateString))(properties.identifiers)), errors.collect(cdk.propertyValidator("model", cdk.requiredValidator)(properties.model)), errors.collect(cdk.propertyValidator("model", cdk.validateString)(properties.model)), errors.collect(cdk.propertyValidator("predicate", CfnComponent_PredicatePropertyValidator)(properties.predicate)), errors.collect(cdk.propertyValidator("sort", cdk.listValidator(CfnComponent_SortPropertyPropertyValidator))(properties.sort)), errors.wrap('supplied properties not correct for "ComponentDataConfigurationProperty"');
    }
    function cfnComponentComponentDataConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponent_ComponentDataConfigurationPropertyValidator(properties).assertSuccess(), { Identifiers: cdk.listMapper(cdk.stringToCloudFormation)(properties.identifiers), Model: cdk.stringToCloudFormation(properties.model), Predicate: cfnComponentPredicatePropertyToCloudFormation(properties.predicate), Sort: cdk.listMapper(cfnComponentSortPropertyPropertyToCloudFormation)(properties.sort) }) : properties;
    }
    function CfnComponentComponentDataConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("identifiers", "Identifiers", properties.Identifiers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Identifiers) : void 0), ret.addPropertyResult("model", "Model", cfn_parse.FromCloudFormation.getString(properties.Model)), ret.addPropertyResult("predicate", "Predicate", properties.Predicate != null ? CfnComponentPredicatePropertyFromCloudFormation(properties.Predicate) : void 0), ret.addPropertyResult("sort", "Sort", properties.Sort != null ? cfn_parse.FromCloudFormation.getArray(CfnComponentSortPropertyPropertyFromCloudFormation)(properties.Sort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComponent_ComponentEventPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.validateString)(properties.action)), errors.collect(cdk.propertyValidator("parameters", CfnComponent_ActionParametersPropertyValidator)(properties.parameters)), errors.wrap('supplied properties not correct for "ComponentEventProperty"');
    }
    function cfnComponentComponentEventPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponent_ComponentEventPropertyValidator(properties).assertSuccess(), { Action: cdk.stringToCloudFormation(properties.action), Parameters: cfnComponentActionParametersPropertyToCloudFormation(properties.parameters) }) : properties;
    }
    function CfnComponentComponentEventPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", properties.Action != null ? cfn_parse.FromCloudFormation.getString(properties.Action) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? CfnComponentActionParametersPropertyFromCloudFormation(properties.Parameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComponent_ComponentPropertyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bindingProperties", CfnComponent_ComponentPropertyBindingPropertiesPropertyValidator)(properties.bindingProperties)), errors.collect(cdk.propertyValidator("bindings", cdk.hashValidator(CfnComponent_FormBindingElementPropertyValidator))(properties.bindings)), errors.collect(cdk.propertyValidator("collectionBindingProperties", CfnComponent_ComponentPropertyBindingPropertiesPropertyValidator)(properties.collectionBindingProperties)), errors.collect(cdk.propertyValidator("componentName", cdk.validateString)(properties.componentName)), errors.collect(cdk.propertyValidator("concat", cdk.listValidator(CfnComponent_ComponentPropertyPropertyValidator))(properties.concat)), errors.collect(cdk.propertyValidator("condition", CfnComponent_ComponentConditionPropertyPropertyValidator)(properties.condition)), errors.collect(cdk.propertyValidator("configured", cdk.validateBoolean)(properties.configured)), errors.collect(cdk.propertyValidator("defaultValue", cdk.validateString)(properties.defaultValue)), errors.collect(cdk.propertyValidator("event", cdk.validateString)(properties.event)), errors.collect(cdk.propertyValidator("importedValue", cdk.validateString)(properties.importedValue)), errors.collect(cdk.propertyValidator("model", cdk.validateString)(properties.model)), errors.collect(cdk.propertyValidator("property", cdk.validateString)(properties.property)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("userAttribute", cdk.validateString)(properties.userAttribute)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "ComponentPropertyProperty"');
    }
    function cfnComponentComponentPropertyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponent_ComponentPropertyPropertyValidator(properties).assertSuccess(), { BindingProperties: cfnComponentComponentPropertyBindingPropertiesPropertyToCloudFormation(properties.bindingProperties), Bindings: cdk.hashMapper(cfnComponentFormBindingElementPropertyToCloudFormation)(properties.bindings), CollectionBindingProperties: cfnComponentComponentPropertyBindingPropertiesPropertyToCloudFormation(properties.collectionBindingProperties), ComponentName: cdk.stringToCloudFormation(properties.componentName), Concat: cdk.listMapper(cfnComponentComponentPropertyPropertyToCloudFormation)(properties.concat), Condition: cfnComponentComponentConditionPropertyPropertyToCloudFormation(properties.condition), Configured: cdk.booleanToCloudFormation(properties.configured), DefaultValue: cdk.stringToCloudFormation(properties.defaultValue), Event: cdk.stringToCloudFormation(properties.event), ImportedValue: cdk.stringToCloudFormation(properties.importedValue), Model: cdk.stringToCloudFormation(properties.model), Property: cdk.stringToCloudFormation(properties.property), Type: cdk.stringToCloudFormation(properties.type), UserAttribute: cdk.stringToCloudFormation(properties.userAttribute), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnComponentComponentPropertyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bindingProperties", "BindingProperties", properties.BindingProperties != null ? CfnComponentComponentPropertyBindingPropertiesPropertyFromCloudFormation(properties.BindingProperties) : void 0), ret.addPropertyResult("bindings", "Bindings", properties.Bindings != null ? cfn_parse.FromCloudFormation.getMap(CfnComponentFormBindingElementPropertyFromCloudFormation)(properties.Bindings) : void 0), ret.addPropertyResult("collectionBindingProperties", "CollectionBindingProperties", properties.CollectionBindingProperties != null ? CfnComponentComponentPropertyBindingPropertiesPropertyFromCloudFormation(properties.CollectionBindingProperties) : void 0), ret.addPropertyResult("componentName", "ComponentName", properties.ComponentName != null ? cfn_parse.FromCloudFormation.getString(properties.ComponentName) : void 0), ret.addPropertyResult("concat", "Concat", properties.Concat != null ? cfn_parse.FromCloudFormation.getArray(CfnComponentComponentPropertyPropertyFromCloudFormation)(properties.Concat) : void 0), ret.addPropertyResult("condition", "Condition", properties.Condition != null ? CfnComponentComponentConditionPropertyPropertyFromCloudFormation(properties.Condition) : void 0), ret.addPropertyResult("configured", "Configured", properties.Configured != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Configured) : void 0), ret.addPropertyResult("defaultValue", "DefaultValue", properties.DefaultValue != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultValue) : void 0), ret.addPropertyResult("event", "Event", properties.Event != null ? cfn_parse.FromCloudFormation.getString(properties.Event) : void 0), ret.addPropertyResult("importedValue", "ImportedValue", properties.ImportedValue != null ? cfn_parse.FromCloudFormation.getString(properties.ImportedValue) : void 0), ret.addPropertyResult("model", "Model", properties.Model != null ? cfn_parse.FromCloudFormation.getString(properties.Model) : void 0), ret.addPropertyResult("property", "Property", properties.Property != null ? cfn_parse.FromCloudFormation.getString(properties.Property) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addPropertyResult("userAttribute", "UserAttribute", properties.UserAttribute != null ? cfn_parse.FromCloudFormation.getString(properties.UserAttribute) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComponent_ComponentPropertyBindingPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("field", cdk.validateString)(properties.field)), errors.collect(cdk.propertyValidator("property", cdk.requiredValidator)(properties.property)), errors.collect(cdk.propertyValidator("property", cdk.validateString)(properties.property)), errors.wrap('supplied properties not correct for "ComponentPropertyBindingPropertiesProperty"');
    }
    function cfnComponentComponentPropertyBindingPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponent_ComponentPropertyBindingPropertiesPropertyValidator(properties).assertSuccess(), { Field: cdk.stringToCloudFormation(properties.field), Property: cdk.stringToCloudFormation(properties.property) }) : properties;
    }
    function CfnComponentComponentPropertyBindingPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("field", "Field", properties.Field != null ? cfn_parse.FromCloudFormation.getString(properties.Field) : void 0), ret.addPropertyResult("property", "Property", cfn_parse.FromCloudFormation.getString(properties.Property)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComponent_ComponentVariantPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("overrides", cdk.validateObject)(properties.overrides)), errors.collect(cdk.propertyValidator("variantValues", cdk.hashValidator(cdk.validateString))(properties.variantValues)), errors.wrap('supplied properties not correct for "ComponentVariantProperty"');
    }
    function cfnComponentComponentVariantPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponent_ComponentVariantPropertyValidator(properties).assertSuccess(), { Overrides: cdk.objectToCloudFormation(properties.overrides), VariantValues: cdk.hashMapper(cdk.stringToCloudFormation)(properties.variantValues) }) : properties;
    }
    function CfnComponentComponentVariantPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("overrides", "Overrides", properties.Overrides != null ? cfn_parse.FromCloudFormation.getAny(properties.Overrides) : void 0), ret.addPropertyResult("variantValues", "VariantValues", properties.VariantValues != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.VariantValues) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComponent_FormBindingElementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("element", cdk.requiredValidator)(properties.element)), errors.collect(cdk.propertyValidator("element", cdk.validateString)(properties.element)), errors.collect(cdk.propertyValidator("property", cdk.requiredValidator)(properties.property)), errors.collect(cdk.propertyValidator("property", cdk.validateString)(properties.property)), errors.wrap('supplied properties not correct for "FormBindingElementProperty"');
    }
    function cfnComponentFormBindingElementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponent_FormBindingElementPropertyValidator(properties).assertSuccess(), { Element: cdk.stringToCloudFormation(properties.element), Property: cdk.stringToCloudFormation(properties.property) }) : properties;
    }
    function CfnComponentFormBindingElementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("element", "Element", cfn_parse.FromCloudFormation.getString(properties.Element)), ret.addPropertyResult("property", "Property", cfn_parse.FromCloudFormation.getString(properties.Property)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComponent_MutationActionSetStateParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("componentName", cdk.requiredValidator)(properties.componentName)), errors.collect(cdk.propertyValidator("componentName", cdk.validateString)(properties.componentName)), errors.collect(cdk.propertyValidator("property", cdk.requiredValidator)(properties.property)), errors.collect(cdk.propertyValidator("property", cdk.validateString)(properties.property)), errors.collect(cdk.propertyValidator("set", cdk.requiredValidator)(properties.set)), errors.collect(cdk.propertyValidator("set", CfnComponent_ComponentPropertyPropertyValidator)(properties.set)), errors.wrap('supplied properties not correct for "MutationActionSetStateParameterProperty"');
    }
    function cfnComponentMutationActionSetStateParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponent_MutationActionSetStateParameterPropertyValidator(properties).assertSuccess(), { ComponentName: cdk.stringToCloudFormation(properties.componentName), Property: cdk.stringToCloudFormation(properties.property), Set: cfnComponentComponentPropertyPropertyToCloudFormation(properties.set) }) : properties;
    }
    function CfnComponentMutationActionSetStateParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("componentName", "ComponentName", cfn_parse.FromCloudFormation.getString(properties.ComponentName)), ret.addPropertyResult("property", "Property", cfn_parse.FromCloudFormation.getString(properties.Property)), ret.addPropertyResult("set", "Set", CfnComponentComponentPropertyPropertyFromCloudFormation(properties.Set)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComponent_PredicatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("and", cdk.listValidator(CfnComponent_PredicatePropertyValidator))(properties.and)), errors.collect(cdk.propertyValidator("field", cdk.validateString)(properties.field)), errors.collect(cdk.propertyValidator("operand", cdk.validateString)(properties.operand)), errors.collect(cdk.propertyValidator("operator", cdk.validateString)(properties.operator)), errors.collect(cdk.propertyValidator("or", cdk.listValidator(CfnComponent_PredicatePropertyValidator))(properties.or)), errors.wrap('supplied properties not correct for "PredicateProperty"');
    }
    function cfnComponentPredicatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponent_PredicatePropertyValidator(properties).assertSuccess(), { And: cdk.listMapper(cfnComponentPredicatePropertyToCloudFormation)(properties.and), Field: cdk.stringToCloudFormation(properties.field), Operand: cdk.stringToCloudFormation(properties.operand), Operator: cdk.stringToCloudFormation(properties.operator), Or: cdk.listMapper(cfnComponentPredicatePropertyToCloudFormation)(properties.or) }) : properties;
    }
    function CfnComponentPredicatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("and", "And", properties.And != null ? cfn_parse.FromCloudFormation.getArray(CfnComponentPredicatePropertyFromCloudFormation)(properties.And) : void 0), ret.addPropertyResult("field", "Field", properties.Field != null ? cfn_parse.FromCloudFormation.getString(properties.Field) : void 0), ret.addPropertyResult("operand", "Operand", properties.Operand != null ? cfn_parse.FromCloudFormation.getString(properties.Operand) : void 0), ret.addPropertyResult("operator", "Operator", properties.Operator != null ? cfn_parse.FromCloudFormation.getString(properties.Operator) : void 0), ret.addPropertyResult("or", "Or", properties.Or != null ? cfn_parse.FromCloudFormation.getArray(CfnComponentPredicatePropertyFromCloudFormation)(properties.Or) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComponent_SortPropertyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("direction", cdk.requiredValidator)(properties.direction)), errors.collect(cdk.propertyValidator("direction", cdk.validateString)(properties.direction)), errors.collect(cdk.propertyValidator("field", cdk.requiredValidator)(properties.field)), errors.collect(cdk.propertyValidator("field", cdk.validateString)(properties.field)), errors.wrap('supplied properties not correct for "SortPropertyProperty"');
    }
    function cfnComponentSortPropertyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponent_SortPropertyPropertyValidator(properties).assertSuccess(), { Direction: cdk.stringToCloudFormation(properties.direction), Field: cdk.stringToCloudFormation(properties.field) }) : properties;
    }
    function CfnComponentSortPropertyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("direction", "Direction", cfn_parse.FromCloudFormation.getString(properties.Direction)), ret.addPropertyResult("field", "Field", cfn_parse.FromCloudFormation.getString(properties.Field)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFormPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("appId", cdk.validateString)(properties.appId)), errors.collect(cdk.propertyValidator("cta", CfnForm_FormCTAPropertyValidator)(properties.cta)), errors.collect(cdk.propertyValidator("dataType", cdk.requiredValidator)(properties.dataType)), errors.collect(cdk.propertyValidator("dataType", CfnForm_FormDataTypeConfigPropertyValidator)(properties.dataType)), errors.collect(cdk.propertyValidator("environmentName", cdk.validateString)(properties.environmentName)), errors.collect(cdk.propertyValidator("fields", cdk.requiredValidator)(properties.fields)), errors.collect(cdk.propertyValidator("fields", cdk.hashValidator(CfnForm_FieldConfigPropertyValidator))(properties.fields)), errors.collect(cdk.propertyValidator("formActionType", cdk.requiredValidator)(properties.formActionType)), errors.collect(cdk.propertyValidator("formActionType", cdk.validateString)(properties.formActionType)), errors.collect(cdk.propertyValidator("labelDecorator", cdk.validateString)(properties.labelDecorator)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("schemaVersion", cdk.requiredValidator)(properties.schemaVersion)), errors.collect(cdk.propertyValidator("schemaVersion", cdk.validateString)(properties.schemaVersion)), errors.collect(cdk.propertyValidator("sectionalElements", cdk.requiredValidator)(properties.sectionalElements)), errors.collect(cdk.propertyValidator("sectionalElements", cdk.hashValidator(CfnForm_SectionalElementPropertyValidator))(properties.sectionalElements)), errors.collect(cdk.propertyValidator("style", cdk.requiredValidator)(properties.style)), errors.collect(cdk.propertyValidator("style", CfnForm_FormStylePropertyValidator)(properties.style)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.wrap('supplied properties not correct for "CfnFormProps"');
    }
    function cfnFormPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFormPropsValidator(properties).assertSuccess(), { DataType: cfnFormFormDataTypeConfigPropertyToCloudFormation(properties.dataType), Fields: cdk.hashMapper(cfnFormFieldConfigPropertyToCloudFormation)(properties.fields), FormActionType: cdk.stringToCloudFormation(properties.formActionType), Name: cdk.stringToCloudFormation(properties.name), SchemaVersion: cdk.stringToCloudFormation(properties.schemaVersion), SectionalElements: cdk.hashMapper(cfnFormSectionalElementPropertyToCloudFormation)(properties.sectionalElements), Style: cfnFormFormStylePropertyToCloudFormation(properties.style), AppId: cdk.stringToCloudFormation(properties.appId), Cta: cfnFormFormCTAPropertyToCloudFormation(properties.cta), EnvironmentName: cdk.stringToCloudFormation(properties.environmentName), LabelDecorator: cdk.stringToCloudFormation(properties.labelDecorator), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnFormPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataType", "DataType", CfnFormFormDataTypeConfigPropertyFromCloudFormation(properties.DataType)), ret.addPropertyResult("fields", "Fields", cfn_parse.FromCloudFormation.getMap(CfnFormFieldConfigPropertyFromCloudFormation)(properties.Fields)), ret.addPropertyResult("formActionType", "FormActionType", cfn_parse.FromCloudFormation.getString(properties.FormActionType)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("schemaVersion", "SchemaVersion", cfn_parse.FromCloudFormation.getString(properties.SchemaVersion)), ret.addPropertyResult("sectionalElements", "SectionalElements", cfn_parse.FromCloudFormation.getMap(CfnFormSectionalElementPropertyFromCloudFormation)(properties.SectionalElements)), ret.addPropertyResult("style", "Style", CfnFormFormStylePropertyFromCloudFormation(properties.Style)), ret.addPropertyResult("appId", "AppId", properties.AppId != null ? cfn_parse.FromCloudFormation.getString(properties.AppId) : void 0), ret.addPropertyResult("cta", "Cta", properties.Cta != null ? CfnFormFormCTAPropertyFromCloudFormation(properties.Cta) : void 0), ret.addPropertyResult("environmentName", "EnvironmentName", properties.EnvironmentName != null ? cfn_parse.FromCloudFormation.getString(properties.EnvironmentName) : void 0), ret.addPropertyResult("labelDecorator", "LabelDecorator", properties.LabelDecorator != null ? cfn_parse.FromCloudFormation.getString(properties.LabelDecorator) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnForm = class _CfnForm extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFormPropsFromCloudFormation(resourceProperties), ret = new _CfnForm(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnForm.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_amplifyuibuilder_CfnFormProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnForm), error;
        }
        cdk.requireProperty(props, "dataType", this), cdk.requireProperty(props, "fields", this), cdk.requireProperty(props, "formActionType", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "schemaVersion", this), cdk.requireProperty(props, "sectionalElements", this), cdk.requireProperty(props, "style", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.dataType = props.dataType, this.fields = props.fields, this.formActionType = props.formActionType, this.name = props.name, this.schemaVersion = props.schemaVersion, this.sectionalElements = props.sectionalElements, this.style = props.style, this.appId = props.appId, this.cta = props.cta, this.environmentName = props.environmentName, this.labelDecorator = props.labelDecorator, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::AmplifyUIBuilder::Form", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnForm.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { dataType: this.dataType, fields: this.fields, formActionType: this.formActionType, name: this.name, schemaVersion: this.schemaVersion, sectionalElements: this.sectionalElements, style: this.style, appId: this.appId, cta: this.cta, environmentName: this.environmentName, labelDecorator: this.labelDecorator, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnFormPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnForm[_b] = { fqn: "aws-cdk-lib.aws_amplifyuibuilder.CfnForm", version: "2.80.0" }, CfnForm.CFN_RESOURCE_TYPE_NAME = "AWS::AmplifyUIBuilder::Form", exports2.CfnForm = CfnForm;
    function CfnForm_FieldConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("excluded", cdk.validateBoolean)(properties.excluded)), errors.collect(cdk.propertyValidator("inputType", CfnForm_FieldInputConfigPropertyValidator)(properties.inputType)), errors.collect(cdk.propertyValidator("label", cdk.validateString)(properties.label)), errors.collect(cdk.propertyValidator("position", CfnForm_FieldPositionPropertyValidator)(properties.position)), errors.collect(cdk.propertyValidator("validations", cdk.listValidator(CfnForm_FieldValidationConfigurationPropertyValidator))(properties.validations)), errors.wrap('supplied properties not correct for "FieldConfigProperty"');
    }
    function cfnFormFieldConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnForm_FieldConfigPropertyValidator(properties).assertSuccess(), { Excluded: cdk.booleanToCloudFormation(properties.excluded), InputType: cfnFormFieldInputConfigPropertyToCloudFormation(properties.inputType), Label: cdk.stringToCloudFormation(properties.label), Position: cfnFormFieldPositionPropertyToCloudFormation(properties.position), Validations: cdk.listMapper(cfnFormFieldValidationConfigurationPropertyToCloudFormation)(properties.validations) }) : properties;
    }
    function CfnFormFieldConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("excluded", "Excluded", properties.Excluded != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Excluded) : void 0), ret.addPropertyResult("inputType", "InputType", properties.InputType != null ? CfnFormFieldInputConfigPropertyFromCloudFormation(properties.InputType) : void 0), ret.addPropertyResult("label", "Label", properties.Label != null ? cfn_parse.FromCloudFormation.getString(properties.Label) : void 0), ret.addPropertyResult("position", "Position", properties.Position != null ? CfnFormFieldPositionPropertyFromCloudFormation(properties.Position) : void 0), ret.addPropertyResult("validations", "Validations", properties.Validations != null ? cfn_parse.FromCloudFormation.getArray(CfnFormFieldValidationConfigurationPropertyFromCloudFormation)(properties.Validations) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnForm_FieldInputConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultChecked", cdk.validateBoolean)(properties.defaultChecked)), errors.collect(cdk.propertyValidator("defaultCountryCode", cdk.validateString)(properties.defaultCountryCode)), errors.collect(cdk.propertyValidator("defaultValue", cdk.validateString)(properties.defaultValue)), errors.collect(cdk.propertyValidator("descriptiveText", cdk.validateString)(properties.descriptiveText)), errors.collect(cdk.propertyValidator("fileUploaderConfig", CfnForm_FileUploaderFieldConfigPropertyValidator)(properties.fileUploaderConfig)), errors.collect(cdk.propertyValidator("isArray", cdk.validateBoolean)(properties.isArray)), errors.collect(cdk.propertyValidator("maxValue", cdk.validateNumber)(properties.maxValue)), errors.collect(cdk.propertyValidator("minValue", cdk.validateNumber)(properties.minValue)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("placeholder", cdk.validateString)(properties.placeholder)), errors.collect(cdk.propertyValidator("readOnly", cdk.validateBoolean)(properties.readOnly)), errors.collect(cdk.propertyValidator("required", cdk.validateBoolean)(properties.required)), errors.collect(cdk.propertyValidator("step", cdk.validateNumber)(properties.step)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.collect(cdk.propertyValidator("valueMappings", CfnForm_ValueMappingsPropertyValidator)(properties.valueMappings)), errors.wrap('supplied properties not correct for "FieldInputConfigProperty"');
    }
    function cfnFormFieldInputConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnForm_FieldInputConfigPropertyValidator(properties).assertSuccess(), { DefaultChecked: cdk.booleanToCloudFormation(properties.defaultChecked), DefaultCountryCode: cdk.stringToCloudFormation(properties.defaultCountryCode), DefaultValue: cdk.stringToCloudFormation(properties.defaultValue), DescriptiveText: cdk.stringToCloudFormation(properties.descriptiveText), FileUploaderConfig: cfnFormFileUploaderFieldConfigPropertyToCloudFormation(properties.fileUploaderConfig), IsArray: cdk.booleanToCloudFormation(properties.isArray), MaxValue: cdk.numberToCloudFormation(properties.maxValue), MinValue: cdk.numberToCloudFormation(properties.minValue), Name: cdk.stringToCloudFormation(properties.name), Placeholder: cdk.stringToCloudFormation(properties.placeholder), ReadOnly: cdk.booleanToCloudFormation(properties.readOnly), Required: cdk.booleanToCloudFormation(properties.required), Step: cdk.numberToCloudFormation(properties.step), Type: cdk.stringToCloudFormation(properties.type), Value: cdk.stringToCloudFormation(properties.value), ValueMappings: cfnFormValueMappingsPropertyToCloudFormation(properties.valueMappings) }) : properties;
    }
    function CfnFormFieldInputConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultChecked", "DefaultChecked", properties.DefaultChecked != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DefaultChecked) : void 0), ret.addPropertyResult("defaultCountryCode", "DefaultCountryCode", properties.DefaultCountryCode != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultCountryCode) : void 0), ret.addPropertyResult("defaultValue", "DefaultValue", properties.DefaultValue != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultValue) : void 0), ret.addPropertyResult("descriptiveText", "DescriptiveText", properties.DescriptiveText != null ? cfn_parse.FromCloudFormation.getString(properties.DescriptiveText) : void 0), ret.addPropertyResult("fileUploaderConfig", "FileUploaderConfig", properties.FileUploaderConfig != null ? CfnFormFileUploaderFieldConfigPropertyFromCloudFormation(properties.FileUploaderConfig) : void 0), ret.addPropertyResult("isArray", "IsArray", properties.IsArray != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsArray) : void 0), ret.addPropertyResult("maxValue", "MaxValue", properties.MaxValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxValue) : void 0), ret.addPropertyResult("minValue", "MinValue", properties.MinValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinValue) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("placeholder", "Placeholder", properties.Placeholder != null ? cfn_parse.FromCloudFormation.getString(properties.Placeholder) : void 0), ret.addPropertyResult("readOnly", "ReadOnly", properties.ReadOnly != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ReadOnly) : void 0), ret.addPropertyResult("required", "Required", properties.Required != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Required) : void 0), ret.addPropertyResult("step", "Step", properties.Step != null ? cfn_parse.FromCloudFormation.getNumber(properties.Step) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addPropertyResult("valueMappings", "ValueMappings", properties.ValueMappings != null ? CfnFormValueMappingsPropertyFromCloudFormation(properties.ValueMappings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnForm_FieldPositionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("below", cdk.validateString)(properties.below)), errors.collect(cdk.propertyValidator("fixed", cdk.validateString)(properties.fixed)), errors.collect(cdk.propertyValidator("rightOf", cdk.validateString)(properties.rightOf)), errors.wrap('supplied properties not correct for "FieldPositionProperty"');
    }
    function cfnFormFieldPositionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnForm_FieldPositionPropertyValidator(properties).assertSuccess(), { Below: cdk.stringToCloudFormation(properties.below), Fixed: cdk.stringToCloudFormation(properties.fixed), RightOf: cdk.stringToCloudFormation(properties.rightOf) }) : properties;
    }
    function CfnFormFieldPositionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("below", "Below", properties.Below != null ? cfn_parse.FromCloudFormation.getString(properties.Below) : void 0), ret.addPropertyResult("fixed", "Fixed", properties.Fixed != null ? cfn_parse.FromCloudFormation.getString(properties.Fixed) : void 0), ret.addPropertyResult("rightOf", "RightOf", properties.RightOf != null ? cfn_parse.FromCloudFormation.getString(properties.RightOf) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnForm_FieldValidationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("numValues", cdk.listValidator(cdk.validateNumber))(properties.numValues)), errors.collect(cdk.propertyValidator("strValues", cdk.listValidator(cdk.validateString))(properties.strValues)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("validationMessage", cdk.validateString)(properties.validationMessage)), errors.wrap('supplied properties not correct for "FieldValidationConfigurationProperty"');
    }
    function cfnFormFieldValidationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnForm_FieldValidationConfigurationPropertyValidator(properties).assertSuccess(), { NumValues: cdk.listMapper(cdk.numberToCloudFormation)(properties.numValues), StrValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.strValues), Type: cdk.stringToCloudFormation(properties.type), ValidationMessage: cdk.stringToCloudFormation(properties.validationMessage) }) : properties;
    }
    function CfnFormFieldValidationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("numValues", "NumValues", properties.NumValues != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getNumber)(properties.NumValues) : void 0), ret.addPropertyResult("strValues", "StrValues", properties.StrValues != null ? cfn_parse.FromCloudFormation.getStringArray(properties.StrValues) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("validationMessage", "ValidationMessage", properties.ValidationMessage != null ? cfn_parse.FromCloudFormation.getString(properties.ValidationMessage) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnForm_FileUploaderFieldConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acceptedFileTypes", cdk.requiredValidator)(properties.acceptedFileTypes)), errors.collect(cdk.propertyValidator("acceptedFileTypes", cdk.listValidator(cdk.validateString))(properties.acceptedFileTypes)), errors.collect(cdk.propertyValidator("accessLevel", cdk.requiredValidator)(properties.accessLevel)), errors.collect(cdk.propertyValidator("accessLevel", cdk.validateString)(properties.accessLevel)), errors.collect(cdk.propertyValidator("isResumable", cdk.validateBoolean)(properties.isResumable)), errors.collect(cdk.propertyValidator("maxFileCount", cdk.validateNumber)(properties.maxFileCount)), errors.collect(cdk.propertyValidator("maxSize", cdk.validateNumber)(properties.maxSize)), errors.collect(cdk.propertyValidator("showThumbnails", cdk.validateBoolean)(properties.showThumbnails)), errors.wrap('supplied properties not correct for "FileUploaderFieldConfigProperty"');
    }
    function cfnFormFileUploaderFieldConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnForm_FileUploaderFieldConfigPropertyValidator(properties).assertSuccess(), { AcceptedFileTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.acceptedFileTypes), AccessLevel: cdk.stringToCloudFormation(properties.accessLevel), IsResumable: cdk.booleanToCloudFormation(properties.isResumable), MaxFileCount: cdk.numberToCloudFormation(properties.maxFileCount), MaxSize: cdk.numberToCloudFormation(properties.maxSize), ShowThumbnails: cdk.booleanToCloudFormation(properties.showThumbnails) }) : properties;
    }
    function CfnFormFileUploaderFieldConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("acceptedFileTypes", "AcceptedFileTypes", cfn_parse.FromCloudFormation.getStringArray(properties.AcceptedFileTypes)), ret.addPropertyResult("accessLevel", "AccessLevel", cfn_parse.FromCloudFormation.getString(properties.AccessLevel)), ret.addPropertyResult("isResumable", "IsResumable", properties.IsResumable != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsResumable) : void 0), ret.addPropertyResult("maxFileCount", "MaxFileCount", properties.MaxFileCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxFileCount) : void 0), ret.addPropertyResult("maxSize", "MaxSize", properties.MaxSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxSize) : void 0), ret.addPropertyResult("showThumbnails", "ShowThumbnails", properties.ShowThumbnails != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ShowThumbnails) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnForm_FormButtonPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("children", cdk.validateString)(properties.children)), errors.collect(cdk.propertyValidator("excluded", cdk.validateBoolean)(properties.excluded)), errors.collect(cdk.propertyValidator("position", CfnForm_FieldPositionPropertyValidator)(properties.position)), errors.wrap('supplied properties not correct for "FormButtonProperty"');
    }
    function cfnFormFormButtonPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnForm_FormButtonPropertyValidator(properties).assertSuccess(), { Children: cdk.stringToCloudFormation(properties.children), Excluded: cdk.booleanToCloudFormation(properties.excluded), Position: cfnFormFieldPositionPropertyToCloudFormation(properties.position) }) : properties;
    }
    function CfnFormFormButtonPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("children", "Children", properties.Children != null ? cfn_parse.FromCloudFormation.getString(properties.Children) : void 0), ret.addPropertyResult("excluded", "Excluded", properties.Excluded != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Excluded) : void 0), ret.addPropertyResult("position", "Position", properties.Position != null ? CfnFormFieldPositionPropertyFromCloudFormation(properties.Position) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnForm_FormCTAPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cancel", CfnForm_FormButtonPropertyValidator)(properties.cancel)), errors.collect(cdk.propertyValidator("clear", CfnForm_FormButtonPropertyValidator)(properties.clear)), errors.collect(cdk.propertyValidator("position", cdk.validateString)(properties.position)), errors.collect(cdk.propertyValidator("submit", CfnForm_FormButtonPropertyValidator)(properties.submit)), errors.wrap('supplied properties not correct for "FormCTAProperty"');
    }
    function cfnFormFormCTAPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnForm_FormCTAPropertyValidator(properties).assertSuccess(), { Cancel: cfnFormFormButtonPropertyToCloudFormation(properties.cancel), Clear: cfnFormFormButtonPropertyToCloudFormation(properties.clear), Position: cdk.stringToCloudFormation(properties.position), Submit: cfnFormFormButtonPropertyToCloudFormation(properties.submit) }) : properties;
    }
    function CfnFormFormCTAPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cancel", "Cancel", properties.Cancel != null ? CfnFormFormButtonPropertyFromCloudFormation(properties.Cancel) : void 0), ret.addPropertyResult("clear", "Clear", properties.Clear != null ? CfnFormFormButtonPropertyFromCloudFormation(properties.Clear) : void 0), ret.addPropertyResult("position", "Position", properties.Position != null ? cfn_parse.FromCloudFormation.getString(properties.Position) : void 0), ret.addPropertyResult("submit", "Submit", properties.Submit != null ? CfnFormFormButtonPropertyFromCloudFormation(properties.Submit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnForm_FormDataTypeConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataSourceType", cdk.requiredValidator)(properties.dataSourceType)), errors.collect(cdk.propertyValidator("dataSourceType", cdk.validateString)(properties.dataSourceType)), errors.collect(cdk.propertyValidator("dataTypeName", cdk.requiredValidator)(properties.dataTypeName)), errors.collect(cdk.propertyValidator("dataTypeName", cdk.validateString)(properties.dataTypeName)), errors.wrap('supplied properties not correct for "FormDataTypeConfigProperty"');
    }
    function cfnFormFormDataTypeConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnForm_FormDataTypeConfigPropertyValidator(properties).assertSuccess(), { DataSourceType: cdk.stringToCloudFormation(properties.dataSourceType), DataTypeName: cdk.stringToCloudFormation(properties.dataTypeName) }) : properties;
    }
    function CfnFormFormDataTypeConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataSourceType", "DataSourceType", cfn_parse.FromCloudFormation.getString(properties.DataSourceType)), ret.addPropertyResult("dataTypeName", "DataTypeName", cfn_parse.FromCloudFormation.getString(properties.DataTypeName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnForm_FormInputValuePropertyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "FormInputValuePropertyProperty"');
    }
    function cfnFormFormInputValuePropertyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnForm_FormInputValuePropertyPropertyValidator(properties).assertSuccess(), { Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnFormFormInputValuePropertyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnForm_FormStylePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("horizontalGap", CfnForm_FormStyleConfigPropertyValidator)(properties.horizontalGap)), errors.collect(cdk.propertyValidator("outerPadding", CfnForm_FormStyleConfigPropertyValidator)(properties.outerPadding)), errors.collect(cdk.propertyValidator("verticalGap", CfnForm_FormStyleConfigPropertyValidator)(properties.verticalGap)), errors.wrap('supplied properties not correct for "FormStyleProperty"');
    }
    function cfnFormFormStylePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnForm_FormStylePropertyValidator(properties).assertSuccess(), { HorizontalGap: cfnFormFormStyleConfigPropertyToCloudFormation(properties.horizontalGap), OuterPadding: cfnFormFormStyleConfigPropertyToCloudFormation(properties.outerPadding), VerticalGap: cfnFormFormStyleConfigPropertyToCloudFormation(properties.verticalGap) }) : properties;
    }
    function CfnFormFormStylePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("horizontalGap", "HorizontalGap", properties.HorizontalGap != null ? CfnFormFormStyleConfigPropertyFromCloudFormation(properties.HorizontalGap) : void 0), ret.addPropertyResult("outerPadding", "OuterPadding", properties.OuterPadding != null ? CfnFormFormStyleConfigPropertyFromCloudFormation(properties.OuterPadding) : void 0), ret.addPropertyResult("verticalGap", "VerticalGap", properties.VerticalGap != null ? CfnFormFormStyleConfigPropertyFromCloudFormation(properties.VerticalGap) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnForm_FormStyleConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("tokenReference", cdk.validateString)(properties.tokenReference)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "FormStyleConfigProperty"');
    }
    function cfnFormFormStyleConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnForm_FormStyleConfigPropertyValidator(properties).assertSuccess(), { TokenReference: cdk.stringToCloudFormation(properties.tokenReference), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnFormFormStyleConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("tokenReference", "TokenReference", properties.TokenReference != null ? cfn_parse.FromCloudFormation.getString(properties.TokenReference) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnForm_SectionalElementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("excluded", cdk.validateBoolean)(properties.excluded)), errors.collect(cdk.propertyValidator("level", cdk.validateNumber)(properties.level)), errors.collect(cdk.propertyValidator("orientation", cdk.validateString)(properties.orientation)), errors.collect(cdk.propertyValidator("position", CfnForm_FieldPositionPropertyValidator)(properties.position)), errors.collect(cdk.propertyValidator("text", cdk.validateString)(properties.text)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "SectionalElementProperty"');
    }
    function cfnFormSectionalElementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnForm_SectionalElementPropertyValidator(properties).assertSuccess(), { Excluded: cdk.booleanToCloudFormation(properties.excluded), Level: cdk.numberToCloudFormation(properties.level), Orientation: cdk.stringToCloudFormation(properties.orientation), Position: cfnFormFieldPositionPropertyToCloudFormation(properties.position), Text: cdk.stringToCloudFormation(properties.text), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnFormSectionalElementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("excluded", "Excluded", properties.Excluded != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Excluded) : void 0), ret.addPropertyResult("level", "Level", properties.Level != null ? cfn_parse.FromCloudFormation.getNumber(properties.Level) : void 0), ret.addPropertyResult("orientation", "Orientation", properties.Orientation != null ? cfn_parse.FromCloudFormation.getString(properties.Orientation) : void 0), ret.addPropertyResult("position", "Position", properties.Position != null ? CfnFormFieldPositionPropertyFromCloudFormation(properties.Position) : void 0), ret.addPropertyResult("text", "Text", properties.Text != null ? cfn_parse.FromCloudFormation.getString(properties.Text) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnForm_ValueMappingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("displayValue", CfnForm_FormInputValuePropertyPropertyValidator)(properties.displayValue)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", CfnForm_FormInputValuePropertyPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "ValueMappingProperty"');
    }
    function cfnFormValueMappingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnForm_ValueMappingPropertyValidator(properties).assertSuccess(), { DisplayValue: cfnFormFormInputValuePropertyPropertyToCloudFormation(properties.displayValue), Value: cfnFormFormInputValuePropertyPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnFormValueMappingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("displayValue", "DisplayValue", properties.DisplayValue != null ? CfnFormFormInputValuePropertyPropertyFromCloudFormation(properties.DisplayValue) : void 0), ret.addPropertyResult("value", "Value", CfnFormFormInputValuePropertyPropertyFromCloudFormation(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnForm_ValueMappingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("values", cdk.requiredValidator)(properties.values)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnForm_ValueMappingPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "ValueMappingsProperty"');
    }
    function cfnFormValueMappingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnForm_ValueMappingsPropertyValidator(properties).assertSuccess(), { Values: cdk.listMapper(cfnFormValueMappingPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnFormValueMappingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("values", "Values", cfn_parse.FromCloudFormation.getArray(CfnFormValueMappingPropertyFromCloudFormation)(properties.Values)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnThemePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("appId", cdk.validateString)(properties.appId)), errors.collect(cdk.propertyValidator("environmentName", cdk.validateString)(properties.environmentName)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("overrides", cdk.listValidator(CfnTheme_ThemeValuesPropertyValidator))(properties.overrides)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.collect(cdk.propertyValidator("values", cdk.requiredValidator)(properties.values)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnTheme_ThemeValuesPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "CfnThemeProps"');
    }
    function cfnThemePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnThemePropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Values: cdk.listMapper(cfnThemeThemeValuesPropertyToCloudFormation)(properties.values), AppId: cdk.stringToCloudFormation(properties.appId), EnvironmentName: cdk.stringToCloudFormation(properties.environmentName), Overrides: cdk.listMapper(cfnThemeThemeValuesPropertyToCloudFormation)(properties.overrides), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnThemePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("values", "Values", cfn_parse.FromCloudFormation.getArray(CfnThemeThemeValuesPropertyFromCloudFormation)(properties.Values)), ret.addPropertyResult("appId", "AppId", properties.AppId != null ? cfn_parse.FromCloudFormation.getString(properties.AppId) : void 0), ret.addPropertyResult("environmentName", "EnvironmentName", properties.EnvironmentName != null ? cfn_parse.FromCloudFormation.getString(properties.EnvironmentName) : void 0), ret.addPropertyResult("overrides", "Overrides", properties.Overrides != null ? cfn_parse.FromCloudFormation.getArray(CfnThemeThemeValuesPropertyFromCloudFormation)(properties.Overrides) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTheme = class _CfnTheme extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnThemePropsFromCloudFormation(resourceProperties), ret = new _CfnTheme(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTheme.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_amplifyuibuilder_CfnThemeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTheme), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "values", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.values = props.values, this.appId = props.appId, this.environmentName = props.environmentName, this.overrides = props.overrides, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::AmplifyUIBuilder::Theme", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTheme.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, values: this.values, appId: this.appId, environmentName: this.environmentName, overrides: this.overrides, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnThemePropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnTheme[_c] = { fqn: "aws-cdk-lib.aws_amplifyuibuilder.CfnTheme", version: "2.80.0" }, CfnTheme.CFN_RESOURCE_TYPE_NAME = "AWS::AmplifyUIBuilder::Theme", exports2.CfnTheme = CfnTheme;
    function CfnTheme_ThemeValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("children", cdk.listValidator(CfnTheme_ThemeValuesPropertyValidator))(properties.children)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "ThemeValueProperty"');
    }
    function cfnThemeThemeValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTheme_ThemeValuePropertyValidator(properties).assertSuccess(), { Children: cdk.listMapper(cfnThemeThemeValuesPropertyToCloudFormation)(properties.children), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnThemeThemeValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("children", "Children", properties.Children != null ? cfn_parse.FromCloudFormation.getArray(CfnThemeThemeValuesPropertyFromCloudFormation)(properties.Children) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTheme_ThemeValuesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", CfnTheme_ThemeValuePropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "ThemeValuesProperty"');
    }
    function cfnThemeThemeValuesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTheme_ThemeValuesPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cfnThemeThemeValuePropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnThemeThemeValuesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? CfnThemeThemeValuePropertyFromCloudFormation(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-amplifyuibuilder/lib/index.js
var require_lib37 = __commonJS({
  "node_modules/aws-cdk-lib/aws-amplifyuibuilder/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_amplifyuibuilder_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-amplifyuibuilder/index.js
var require_aws_amplifyuibuilder = __commonJS({
  "node_modules/aws-cdk-lib/aws-amplifyuibuilder/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib37(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/apigateway.generated.js
var require_apigateway_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/apigateway.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    var _l;
    var _m;
    var _o;
    var _p;
    var _q;
    var _r;
    var _s;
    var _t;
    var _u;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnVpcLink = exports2.CfnUsagePlanKey = exports2.CfnUsagePlan = exports2.CfnStage = exports2.CfnRestApi = exports2.CfnResource = exports2.CfnRequestValidator = exports2.CfnModel = exports2.CfnMethod = exports2.CfnGatewayResponse = exports2.CfnDomainName = exports2.CfnDocumentationVersion = exports2.CfnDocumentationPart = exports2.CfnDeployment = exports2.CfnClientCertificate = exports2.CfnBasePathMapping = exports2.CfnAuthorizer = exports2.CfnApiKey = exports2.CfnAccount = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAccountPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchRoleArn", cdk.validateString)(properties.cloudWatchRoleArn)), errors.wrap('supplied properties not correct for "CfnAccountProps"');
    }
    function cfnAccountPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccountPropsValidator(properties).assertSuccess(), { CloudWatchRoleArn: cdk.stringToCloudFormation(properties.cloudWatchRoleArn) }) : properties;
    }
    function CfnAccountPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchRoleArn", "CloudWatchRoleArn", properties.CloudWatchRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.CloudWatchRoleArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAccount = class _CfnAccount extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAccountPropsFromCloudFormation(resourceProperties), ret = new _CfnAccount(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnAccount.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_CfnAccountProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAccount), error;
        }
        this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.cloudWatchRoleArn = props.cloudWatchRoleArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAccount.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { cloudWatchRoleArn: this.cloudWatchRoleArn };
      }
      renderProperties(props) {
        return cfnAccountPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAccount[_a] = { fqn: "aws-cdk-lib.aws_apigateway.CfnAccount", version: "2.80.0" }, CfnAccount.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGateway::Account", exports2.CfnAccount = CfnAccount;
    function CfnApiKeyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customerId", cdk.validateString)(properties.customerId)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("generateDistinctId", cdk.validateBoolean)(properties.generateDistinctId)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("stageKeys", cdk.listValidator(CfnApiKey_StageKeyPropertyValidator))(properties.stageKeys)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "CfnApiKeyProps"');
    }
    function cfnApiKeyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApiKeyPropsValidator(properties).assertSuccess(), { CustomerId: cdk.stringToCloudFormation(properties.customerId), Description: cdk.stringToCloudFormation(properties.description), Enabled: cdk.booleanToCloudFormation(properties.enabled), GenerateDistinctId: cdk.booleanToCloudFormation(properties.generateDistinctId), Name: cdk.stringToCloudFormation(properties.name), StageKeys: cdk.listMapper(cfnApiKeyStageKeyPropertyToCloudFormation)(properties.stageKeys), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnApiKeyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customerId", "CustomerId", properties.CustomerId != null ? cfn_parse.FromCloudFormation.getString(properties.CustomerId) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("generateDistinctId", "GenerateDistinctId", properties.GenerateDistinctId != null ? cfn_parse.FromCloudFormation.getBoolean(properties.GenerateDistinctId) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("stageKeys", "StageKeys", properties.StageKeys != null ? cfn_parse.FromCloudFormation.getArray(CfnApiKeyStageKeyPropertyFromCloudFormation)(properties.StageKeys) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApiKey = class _CfnApiKey extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApiKeyPropsFromCloudFormation(resourceProperties), ret = new _CfnApiKey(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnApiKey.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_CfnApiKeyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApiKey), error;
        }
        this.attrApiKeyId = cdk.Token.asString(this.getAtt("APIKeyId", cdk.ResolutionTypeHint.STRING)), this.customerId = props.customerId, this.description = props.description, this.enabled = props.enabled, this.generateDistinctId = props.generateDistinctId, this.name = props.name, this.stageKeys = props.stageKeys, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ApiGateway::ApiKey", props.tags, { tagPropertyName: "tags" }), this.value = props.value;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApiKey.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { customerId: this.customerId, description: this.description, enabled: this.enabled, generateDistinctId: this.generateDistinctId, name: this.name, stageKeys: this.stageKeys, tags: this.tags.renderTags(), value: this.value };
      }
      renderProperties(props) {
        return cfnApiKeyPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnApiKey[_b] = { fqn: "aws-cdk-lib.aws_apigateway.CfnApiKey", version: "2.80.0" }, CfnApiKey.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGateway::ApiKey", exports2.CfnApiKey = CfnApiKey;
    function CfnApiKey_StageKeyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("restApiId", cdk.validateString)(properties.restApiId)), errors.collect(cdk.propertyValidator("stageName", cdk.validateString)(properties.stageName)), errors.wrap('supplied properties not correct for "StageKeyProperty"');
    }
    function cfnApiKeyStageKeyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApiKey_StageKeyPropertyValidator(properties).assertSuccess(), { RestApiId: cdk.stringToCloudFormation(properties.restApiId), StageName: cdk.stringToCloudFormation(properties.stageName) }) : properties;
    }
    function CfnApiKeyStageKeyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("restApiId", "RestApiId", properties.RestApiId != null ? cfn_parse.FromCloudFormation.getString(properties.RestApiId) : void 0), ret.addPropertyResult("stageName", "StageName", properties.StageName != null ? cfn_parse.FromCloudFormation.getString(properties.StageName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAuthorizerPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authType", cdk.validateString)(properties.authType)), errors.collect(cdk.propertyValidator("authorizerCredentials", cdk.validateString)(properties.authorizerCredentials)), errors.collect(cdk.propertyValidator("authorizerResultTtlInSeconds", cdk.validateNumber)(properties.authorizerResultTtlInSeconds)), errors.collect(cdk.propertyValidator("authorizerUri", cdk.validateString)(properties.authorizerUri)), errors.collect(cdk.propertyValidator("identitySource", cdk.validateString)(properties.identitySource)), errors.collect(cdk.propertyValidator("identityValidationExpression", cdk.validateString)(properties.identityValidationExpression)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("providerArns", cdk.listValidator(cdk.validateString))(properties.providerArns)), errors.collect(cdk.propertyValidator("restApiId", cdk.requiredValidator)(properties.restApiId)), errors.collect(cdk.propertyValidator("restApiId", cdk.validateString)(properties.restApiId)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnAuthorizerProps"');
    }
    function cfnAuthorizerPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAuthorizerPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), RestApiId: cdk.stringToCloudFormation(properties.restApiId), Type: cdk.stringToCloudFormation(properties.type), AuthorizerCredentials: cdk.stringToCloudFormation(properties.authorizerCredentials), AuthorizerResultTtlInSeconds: cdk.numberToCloudFormation(properties.authorizerResultTtlInSeconds), AuthorizerUri: cdk.stringToCloudFormation(properties.authorizerUri), AuthType: cdk.stringToCloudFormation(properties.authType), IdentitySource: cdk.stringToCloudFormation(properties.identitySource), IdentityValidationExpression: cdk.stringToCloudFormation(properties.identityValidationExpression), ProviderARNs: cdk.listMapper(cdk.stringToCloudFormation)(properties.providerArns) }) : properties;
    }
    function CfnAuthorizerPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("restApiId", "RestApiId", cfn_parse.FromCloudFormation.getString(properties.RestApiId)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("authorizerCredentials", "AuthorizerCredentials", properties.AuthorizerCredentials != null ? cfn_parse.FromCloudFormation.getString(properties.AuthorizerCredentials) : void 0), ret.addPropertyResult("authorizerResultTtlInSeconds", "AuthorizerResultTtlInSeconds", properties.AuthorizerResultTtlInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.AuthorizerResultTtlInSeconds) : void 0), ret.addPropertyResult("authorizerUri", "AuthorizerUri", properties.AuthorizerUri != null ? cfn_parse.FromCloudFormation.getString(properties.AuthorizerUri) : void 0), ret.addPropertyResult("authType", "AuthType", properties.AuthType != null ? cfn_parse.FromCloudFormation.getString(properties.AuthType) : void 0), ret.addPropertyResult("identitySource", "IdentitySource", properties.IdentitySource != null ? cfn_parse.FromCloudFormation.getString(properties.IdentitySource) : void 0), ret.addPropertyResult("identityValidationExpression", "IdentityValidationExpression", properties.IdentityValidationExpression != null ? cfn_parse.FromCloudFormation.getString(properties.IdentityValidationExpression) : void 0), ret.addPropertyResult("providerArns", "ProviderARNs", properties.ProviderARNs != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ProviderARNs) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAuthorizer = class _CfnAuthorizer extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAuthorizerPropsFromCloudFormation(resourceProperties), ret = new _CfnAuthorizer(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAuthorizer.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_CfnAuthorizerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAuthorizer), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "restApiId", this), cdk.requireProperty(props, "type", this), this.attrAuthorizerId = cdk.Token.asString(this.getAtt("AuthorizerId", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.restApiId = props.restApiId, this.type = props.type, this.authorizerCredentials = props.authorizerCredentials, this.authorizerResultTtlInSeconds = props.authorizerResultTtlInSeconds, this.authorizerUri = props.authorizerUri, this.authType = props.authType, this.identitySource = props.identitySource, this.identityValidationExpression = props.identityValidationExpression, this.providerArns = props.providerArns;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAuthorizer.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, restApiId: this.restApiId, type: this.type, authorizerCredentials: this.authorizerCredentials, authorizerResultTtlInSeconds: this.authorizerResultTtlInSeconds, authorizerUri: this.authorizerUri, authType: this.authType, identitySource: this.identitySource, identityValidationExpression: this.identityValidationExpression, providerArns: this.providerArns };
      }
      renderProperties(props) {
        return cfnAuthorizerPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnAuthorizer[_c] = { fqn: "aws-cdk-lib.aws_apigateway.CfnAuthorizer", version: "2.80.0" }, CfnAuthorizer.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGateway::Authorizer", exports2.CfnAuthorizer = CfnAuthorizer;
    function CfnBasePathMappingPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("basePath", cdk.validateString)(properties.basePath)), errors.collect(cdk.propertyValidator("domainName", cdk.requiredValidator)(properties.domainName)), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("restApiId", cdk.validateString)(properties.restApiId)), errors.collect(cdk.propertyValidator("stage", cdk.validateString)(properties.stage)), errors.wrap('supplied properties not correct for "CfnBasePathMappingProps"');
    }
    function cfnBasePathMappingPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBasePathMappingPropsValidator(properties).assertSuccess(), { DomainName: cdk.stringToCloudFormation(properties.domainName), BasePath: cdk.stringToCloudFormation(properties.basePath), Id: cdk.stringToCloudFormation(properties.id), RestApiId: cdk.stringToCloudFormation(properties.restApiId), Stage: cdk.stringToCloudFormation(properties.stage) }) : properties;
    }
    function CfnBasePathMappingPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("domainName", "DomainName", cfn_parse.FromCloudFormation.getString(properties.DomainName)), ret.addPropertyResult("basePath", "BasePath", properties.BasePath != null ? cfn_parse.FromCloudFormation.getString(properties.BasePath) : void 0), ret.addPropertyResult("id", "Id", properties.Id != null ? cfn_parse.FromCloudFormation.getString(properties.Id) : void 0), ret.addPropertyResult("restApiId", "RestApiId", properties.RestApiId != null ? cfn_parse.FromCloudFormation.getString(properties.RestApiId) : void 0), ret.addPropertyResult("stage", "Stage", properties.Stage != null ? cfn_parse.FromCloudFormation.getString(properties.Stage) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnBasePathMapping = class _CfnBasePathMapping extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnBasePathMappingPropsFromCloudFormation(resourceProperties), ret = new _CfnBasePathMapping(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnBasePathMapping.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_CfnBasePathMappingProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnBasePathMapping), error;
        }
        cdk.requireProperty(props, "domainName", this), this.domainName = props.domainName, this.basePath = props.basePath, this.id = props.id, this.restApiId = props.restApiId, this.stage = props.stage;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnBasePathMapping.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { domainName: this.domainName, basePath: this.basePath, id: this.id, restApiId: this.restApiId, stage: this.stage };
      }
      renderProperties(props) {
        return cfnBasePathMappingPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnBasePathMapping[_d] = { fqn: "aws-cdk-lib.aws_apigateway.CfnBasePathMapping", version: "2.80.0" }, CfnBasePathMapping.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGateway::BasePathMapping", exports2.CfnBasePathMapping = CfnBasePathMapping;
    function CfnClientCertificatePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnClientCertificateProps"');
    }
    function cfnClientCertificatePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClientCertificatePropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnClientCertificatePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnClientCertificate = class _CfnClientCertificate extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnClientCertificatePropsFromCloudFormation(resourceProperties), ret = new _CfnClientCertificate(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnClientCertificate.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_CfnClientCertificateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnClientCertificate), error;
        }
        this.attrClientCertificateId = cdk.Token.asString(this.getAtt("ClientCertificateId", cdk.ResolutionTypeHint.STRING)), this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ApiGateway::ClientCertificate", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnClientCertificate.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnClientCertificatePropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnClientCertificate[_e] = { fqn: "aws-cdk-lib.aws_apigateway.CfnClientCertificate", version: "2.80.0" }, CfnClientCertificate.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGateway::ClientCertificate", exports2.CfnClientCertificate = CfnClientCertificate;
    function CfnDeploymentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deploymentCanarySettings", CfnDeployment_DeploymentCanarySettingsPropertyValidator)(properties.deploymentCanarySettings)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("restApiId", cdk.requiredValidator)(properties.restApiId)), errors.collect(cdk.propertyValidator("restApiId", cdk.validateString)(properties.restApiId)), errors.collect(cdk.propertyValidator("stageDescription", CfnDeployment_StageDescriptionPropertyValidator)(properties.stageDescription)), errors.collect(cdk.propertyValidator("stageName", cdk.validateString)(properties.stageName)), errors.wrap('supplied properties not correct for "CfnDeploymentProps"');
    }
    function cfnDeploymentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentPropsValidator(properties).assertSuccess(), { RestApiId: cdk.stringToCloudFormation(properties.restApiId), DeploymentCanarySettings: cfnDeploymentDeploymentCanarySettingsPropertyToCloudFormation(properties.deploymentCanarySettings), Description: cdk.stringToCloudFormation(properties.description), StageDescription: cfnDeploymentStageDescriptionPropertyToCloudFormation(properties.stageDescription), StageName: cdk.stringToCloudFormation(properties.stageName) }) : properties;
    }
    function CfnDeploymentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("restApiId", "RestApiId", cfn_parse.FromCloudFormation.getString(properties.RestApiId)), ret.addPropertyResult("deploymentCanarySettings", "DeploymentCanarySettings", properties.DeploymentCanarySettings != null ? CfnDeploymentDeploymentCanarySettingsPropertyFromCloudFormation(properties.DeploymentCanarySettings) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("stageDescription", "StageDescription", properties.StageDescription != null ? CfnDeploymentStageDescriptionPropertyFromCloudFormation(properties.StageDescription) : void 0), ret.addPropertyResult("stageName", "StageName", properties.StageName != null ? cfn_parse.FromCloudFormation.getString(properties.StageName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDeployment = class _CfnDeployment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDeploymentPropsFromCloudFormation(resourceProperties), ret = new _CfnDeployment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDeployment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_CfnDeploymentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDeployment), error;
        }
        cdk.requireProperty(props, "restApiId", this), this.attrDeploymentId = cdk.Token.asString(this.getAtt("DeploymentId", cdk.ResolutionTypeHint.STRING)), this.restApiId = props.restApiId, this.deploymentCanarySettings = props.deploymentCanarySettings, this.description = props.description, this.stageDescription = props.stageDescription, this.stageName = props.stageName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDeployment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { restApiId: this.restApiId, deploymentCanarySettings: this.deploymentCanarySettings, description: this.description, stageDescription: this.stageDescription, stageName: this.stageName };
      }
      renderProperties(props) {
        return cfnDeploymentPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnDeployment[_f] = { fqn: "aws-cdk-lib.aws_apigateway.CfnDeployment", version: "2.80.0" }, CfnDeployment.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGateway::Deployment", exports2.CfnDeployment = CfnDeployment;
    function CfnDeployment_AccessLogSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationArn", cdk.validateString)(properties.destinationArn)), errors.collect(cdk.propertyValidator("format", cdk.validateString)(properties.format)), errors.wrap('supplied properties not correct for "AccessLogSettingProperty"');
    }
    function cfnDeploymentAccessLogSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeployment_AccessLogSettingPropertyValidator(properties).assertSuccess(), { DestinationArn: cdk.stringToCloudFormation(properties.destinationArn), Format: cdk.stringToCloudFormation(properties.format) }) : properties;
    }
    function CfnDeploymentAccessLogSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationArn", "DestinationArn", properties.DestinationArn != null ? cfn_parse.FromCloudFormation.getString(properties.DestinationArn) : void 0), ret.addPropertyResult("format", "Format", properties.Format != null ? cfn_parse.FromCloudFormation.getString(properties.Format) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeployment_CanarySettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("percentTraffic", cdk.validateNumber)(properties.percentTraffic)), errors.collect(cdk.propertyValidator("stageVariableOverrides", cdk.hashValidator(cdk.validateString))(properties.stageVariableOverrides)), errors.collect(cdk.propertyValidator("useStageCache", cdk.validateBoolean)(properties.useStageCache)), errors.wrap('supplied properties not correct for "CanarySettingProperty"');
    }
    function cfnDeploymentCanarySettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeployment_CanarySettingPropertyValidator(properties).assertSuccess(), { PercentTraffic: cdk.numberToCloudFormation(properties.percentTraffic), StageVariableOverrides: cdk.hashMapper(cdk.stringToCloudFormation)(properties.stageVariableOverrides), UseStageCache: cdk.booleanToCloudFormation(properties.useStageCache) }) : properties;
    }
    function CfnDeploymentCanarySettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("percentTraffic", "PercentTraffic", properties.PercentTraffic != null ? cfn_parse.FromCloudFormation.getNumber(properties.PercentTraffic) : void 0), ret.addPropertyResult("stageVariableOverrides", "StageVariableOverrides", properties.StageVariableOverrides != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.StageVariableOverrides) : void 0), ret.addPropertyResult("useStageCache", "UseStageCache", properties.UseStageCache != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseStageCache) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeployment_DeploymentCanarySettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("percentTraffic", cdk.validateNumber)(properties.percentTraffic)), errors.collect(cdk.propertyValidator("stageVariableOverrides", cdk.hashValidator(cdk.validateString))(properties.stageVariableOverrides)), errors.collect(cdk.propertyValidator("useStageCache", cdk.validateBoolean)(properties.useStageCache)), errors.wrap('supplied properties not correct for "DeploymentCanarySettingsProperty"');
    }
    function cfnDeploymentDeploymentCanarySettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeployment_DeploymentCanarySettingsPropertyValidator(properties).assertSuccess(), { PercentTraffic: cdk.numberToCloudFormation(properties.percentTraffic), StageVariableOverrides: cdk.hashMapper(cdk.stringToCloudFormation)(properties.stageVariableOverrides), UseStageCache: cdk.booleanToCloudFormation(properties.useStageCache) }) : properties;
    }
    function CfnDeploymentDeploymentCanarySettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("percentTraffic", "PercentTraffic", properties.PercentTraffic != null ? cfn_parse.FromCloudFormation.getNumber(properties.PercentTraffic) : void 0), ret.addPropertyResult("stageVariableOverrides", "StageVariableOverrides", properties.StageVariableOverrides != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.StageVariableOverrides) : void 0), ret.addPropertyResult("useStageCache", "UseStageCache", properties.UseStageCache != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseStageCache) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeployment_MethodSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cacheDataEncrypted", cdk.validateBoolean)(properties.cacheDataEncrypted)), errors.collect(cdk.propertyValidator("cacheTtlInSeconds", cdk.validateNumber)(properties.cacheTtlInSeconds)), errors.collect(cdk.propertyValidator("cachingEnabled", cdk.validateBoolean)(properties.cachingEnabled)), errors.collect(cdk.propertyValidator("dataTraceEnabled", cdk.validateBoolean)(properties.dataTraceEnabled)), errors.collect(cdk.propertyValidator("httpMethod", cdk.validateString)(properties.httpMethod)), errors.collect(cdk.propertyValidator("loggingLevel", cdk.validateString)(properties.loggingLevel)), errors.collect(cdk.propertyValidator("metricsEnabled", cdk.validateBoolean)(properties.metricsEnabled)), errors.collect(cdk.propertyValidator("resourcePath", cdk.validateString)(properties.resourcePath)), errors.collect(cdk.propertyValidator("throttlingBurstLimit", cdk.validateNumber)(properties.throttlingBurstLimit)), errors.collect(cdk.propertyValidator("throttlingRateLimit", cdk.validateNumber)(properties.throttlingRateLimit)), errors.wrap('supplied properties not correct for "MethodSettingProperty"');
    }
    function cfnDeploymentMethodSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeployment_MethodSettingPropertyValidator(properties).assertSuccess(), { CacheDataEncrypted: cdk.booleanToCloudFormation(properties.cacheDataEncrypted), CacheTtlInSeconds: cdk.numberToCloudFormation(properties.cacheTtlInSeconds), CachingEnabled: cdk.booleanToCloudFormation(properties.cachingEnabled), DataTraceEnabled: cdk.booleanToCloudFormation(properties.dataTraceEnabled), HttpMethod: cdk.stringToCloudFormation(properties.httpMethod), LoggingLevel: cdk.stringToCloudFormation(properties.loggingLevel), MetricsEnabled: cdk.booleanToCloudFormation(properties.metricsEnabled), ResourcePath: cdk.stringToCloudFormation(properties.resourcePath), ThrottlingBurstLimit: cdk.numberToCloudFormation(properties.throttlingBurstLimit), ThrottlingRateLimit: cdk.numberToCloudFormation(properties.throttlingRateLimit) }) : properties;
    }
    function CfnDeploymentMethodSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cacheDataEncrypted", "CacheDataEncrypted", properties.CacheDataEncrypted != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CacheDataEncrypted) : void 0), ret.addPropertyResult("cacheTtlInSeconds", "CacheTtlInSeconds", properties.CacheTtlInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.CacheTtlInSeconds) : void 0), ret.addPropertyResult("cachingEnabled", "CachingEnabled", properties.CachingEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CachingEnabled) : void 0), ret.addPropertyResult("dataTraceEnabled", "DataTraceEnabled", properties.DataTraceEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DataTraceEnabled) : void 0), ret.addPropertyResult("httpMethod", "HttpMethod", properties.HttpMethod != null ? cfn_parse.FromCloudFormation.getString(properties.HttpMethod) : void 0), ret.addPropertyResult("loggingLevel", "LoggingLevel", properties.LoggingLevel != null ? cfn_parse.FromCloudFormation.getString(properties.LoggingLevel) : void 0), ret.addPropertyResult("metricsEnabled", "MetricsEnabled", properties.MetricsEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.MetricsEnabled) : void 0), ret.addPropertyResult("resourcePath", "ResourcePath", properties.ResourcePath != null ? cfn_parse.FromCloudFormation.getString(properties.ResourcePath) : void 0), ret.addPropertyResult("throttlingBurstLimit", "ThrottlingBurstLimit", properties.ThrottlingBurstLimit != null ? cfn_parse.FromCloudFormation.getNumber(properties.ThrottlingBurstLimit) : void 0), ret.addPropertyResult("throttlingRateLimit", "ThrottlingRateLimit", properties.ThrottlingRateLimit != null ? cfn_parse.FromCloudFormation.getNumber(properties.ThrottlingRateLimit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeployment_StageDescriptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessLogSetting", CfnDeployment_AccessLogSettingPropertyValidator)(properties.accessLogSetting)), errors.collect(cdk.propertyValidator("cacheClusterEnabled", cdk.validateBoolean)(properties.cacheClusterEnabled)), errors.collect(cdk.propertyValidator("cacheClusterSize", cdk.validateString)(properties.cacheClusterSize)), errors.collect(cdk.propertyValidator("cacheDataEncrypted", cdk.validateBoolean)(properties.cacheDataEncrypted)), errors.collect(cdk.propertyValidator("cacheTtlInSeconds", cdk.validateNumber)(properties.cacheTtlInSeconds)), errors.collect(cdk.propertyValidator("cachingEnabled", cdk.validateBoolean)(properties.cachingEnabled)), errors.collect(cdk.propertyValidator("canarySetting", CfnDeployment_CanarySettingPropertyValidator)(properties.canarySetting)), errors.collect(cdk.propertyValidator("clientCertificateId", cdk.validateString)(properties.clientCertificateId)), errors.collect(cdk.propertyValidator("dataTraceEnabled", cdk.validateBoolean)(properties.dataTraceEnabled)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("documentationVersion", cdk.validateString)(properties.documentationVersion)), errors.collect(cdk.propertyValidator("loggingLevel", cdk.validateString)(properties.loggingLevel)), errors.collect(cdk.propertyValidator("methodSettings", cdk.listValidator(CfnDeployment_MethodSettingPropertyValidator))(properties.methodSettings)), errors.collect(cdk.propertyValidator("metricsEnabled", cdk.validateBoolean)(properties.metricsEnabled)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("throttlingBurstLimit", cdk.validateNumber)(properties.throttlingBurstLimit)), errors.collect(cdk.propertyValidator("throttlingRateLimit", cdk.validateNumber)(properties.throttlingRateLimit)), errors.collect(cdk.propertyValidator("tracingEnabled", cdk.validateBoolean)(properties.tracingEnabled)), errors.collect(cdk.propertyValidator("variables", cdk.hashValidator(cdk.validateString))(properties.variables)), errors.wrap('supplied properties not correct for "StageDescriptionProperty"');
    }
    function cfnDeploymentStageDescriptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeployment_StageDescriptionPropertyValidator(properties).assertSuccess(), { AccessLogSetting: cfnDeploymentAccessLogSettingPropertyToCloudFormation(properties.accessLogSetting), CacheClusterEnabled: cdk.booleanToCloudFormation(properties.cacheClusterEnabled), CacheClusterSize: cdk.stringToCloudFormation(properties.cacheClusterSize), CacheDataEncrypted: cdk.booleanToCloudFormation(properties.cacheDataEncrypted), CacheTtlInSeconds: cdk.numberToCloudFormation(properties.cacheTtlInSeconds), CachingEnabled: cdk.booleanToCloudFormation(properties.cachingEnabled), CanarySetting: cfnDeploymentCanarySettingPropertyToCloudFormation(properties.canarySetting), ClientCertificateId: cdk.stringToCloudFormation(properties.clientCertificateId), DataTraceEnabled: cdk.booleanToCloudFormation(properties.dataTraceEnabled), Description: cdk.stringToCloudFormation(properties.description), DocumentationVersion: cdk.stringToCloudFormation(properties.documentationVersion), LoggingLevel: cdk.stringToCloudFormation(properties.loggingLevel), MethodSettings: cdk.listMapper(cfnDeploymentMethodSettingPropertyToCloudFormation)(properties.methodSettings), MetricsEnabled: cdk.booleanToCloudFormation(properties.metricsEnabled), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), ThrottlingBurstLimit: cdk.numberToCloudFormation(properties.throttlingBurstLimit), ThrottlingRateLimit: cdk.numberToCloudFormation(properties.throttlingRateLimit), TracingEnabled: cdk.booleanToCloudFormation(properties.tracingEnabled), Variables: cdk.hashMapper(cdk.stringToCloudFormation)(properties.variables) }) : properties;
    }
    function CfnDeploymentStageDescriptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessLogSetting", "AccessLogSetting", properties.AccessLogSetting != null ? CfnDeploymentAccessLogSettingPropertyFromCloudFormation(properties.AccessLogSetting) : void 0), ret.addPropertyResult("cacheClusterEnabled", "CacheClusterEnabled", properties.CacheClusterEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CacheClusterEnabled) : void 0), ret.addPropertyResult("cacheClusterSize", "CacheClusterSize", properties.CacheClusterSize != null ? cfn_parse.FromCloudFormation.getString(properties.CacheClusterSize) : void 0), ret.addPropertyResult("cacheDataEncrypted", "CacheDataEncrypted", properties.CacheDataEncrypted != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CacheDataEncrypted) : void 0), ret.addPropertyResult("cacheTtlInSeconds", "CacheTtlInSeconds", properties.CacheTtlInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.CacheTtlInSeconds) : void 0), ret.addPropertyResult("cachingEnabled", "CachingEnabled", properties.CachingEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CachingEnabled) : void 0), ret.addPropertyResult("canarySetting", "CanarySetting", properties.CanarySetting != null ? CfnDeploymentCanarySettingPropertyFromCloudFormation(properties.CanarySetting) : void 0), ret.addPropertyResult("clientCertificateId", "ClientCertificateId", properties.ClientCertificateId != null ? cfn_parse.FromCloudFormation.getString(properties.ClientCertificateId) : void 0), ret.addPropertyResult("dataTraceEnabled", "DataTraceEnabled", properties.DataTraceEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DataTraceEnabled) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("documentationVersion", "DocumentationVersion", properties.DocumentationVersion != null ? cfn_parse.FromCloudFormation.getString(properties.DocumentationVersion) : void 0), ret.addPropertyResult("loggingLevel", "LoggingLevel", properties.LoggingLevel != null ? cfn_parse.FromCloudFormation.getString(properties.LoggingLevel) : void 0), ret.addPropertyResult("methodSettings", "MethodSettings", properties.MethodSettings != null ? cfn_parse.FromCloudFormation.getArray(CfnDeploymentMethodSettingPropertyFromCloudFormation)(properties.MethodSettings) : void 0), ret.addPropertyResult("metricsEnabled", "MetricsEnabled", properties.MetricsEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.MetricsEnabled) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("throttlingBurstLimit", "ThrottlingBurstLimit", properties.ThrottlingBurstLimit != null ? cfn_parse.FromCloudFormation.getNumber(properties.ThrottlingBurstLimit) : void 0), ret.addPropertyResult("throttlingRateLimit", "ThrottlingRateLimit", properties.ThrottlingRateLimit != null ? cfn_parse.FromCloudFormation.getNumber(properties.ThrottlingRateLimit) : void 0), ret.addPropertyResult("tracingEnabled", "TracingEnabled", properties.TracingEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.TracingEnabled) : void 0), ret.addPropertyResult("variables", "Variables", properties.Variables != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Variables) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDocumentationPartPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("location", cdk.requiredValidator)(properties.location)), errors.collect(cdk.propertyValidator("location", CfnDocumentationPart_LocationPropertyValidator)(properties.location)), errors.collect(cdk.propertyValidator("properties", cdk.requiredValidator)(properties.properties)), errors.collect(cdk.propertyValidator("properties", cdk.validateString)(properties.properties)), errors.collect(cdk.propertyValidator("restApiId", cdk.requiredValidator)(properties.restApiId)), errors.collect(cdk.propertyValidator("restApiId", cdk.validateString)(properties.restApiId)), errors.wrap('supplied properties not correct for "CfnDocumentationPartProps"');
    }
    function cfnDocumentationPartPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDocumentationPartPropsValidator(properties).assertSuccess(), { Location: cfnDocumentationPartLocationPropertyToCloudFormation(properties.location), Properties: cdk.stringToCloudFormation(properties.properties), RestApiId: cdk.stringToCloudFormation(properties.restApiId) }) : properties;
    }
    function CfnDocumentationPartPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("location", "Location", CfnDocumentationPartLocationPropertyFromCloudFormation(properties.Location)), ret.addPropertyResult("properties", "Properties", cfn_parse.FromCloudFormation.getString(properties.Properties)), ret.addPropertyResult("restApiId", "RestApiId", cfn_parse.FromCloudFormation.getString(properties.RestApiId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDocumentationPart = class _CfnDocumentationPart extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDocumentationPartPropsFromCloudFormation(resourceProperties), ret = new _CfnDocumentationPart(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDocumentationPart.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_CfnDocumentationPartProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDocumentationPart), error;
        }
        cdk.requireProperty(props, "location", this), cdk.requireProperty(props, "properties", this), cdk.requireProperty(props, "restApiId", this), this.attrDocumentationPartId = cdk.Token.asString(this.getAtt("DocumentationPartId", cdk.ResolutionTypeHint.STRING)), this.location = props.location, this.properties = props.properties, this.restApiId = props.restApiId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDocumentationPart.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { location: this.location, properties: this.properties, restApiId: this.restApiId };
      }
      renderProperties(props) {
        return cfnDocumentationPartPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnDocumentationPart[_g] = { fqn: "aws-cdk-lib.aws_apigateway.CfnDocumentationPart", version: "2.80.0" }, CfnDocumentationPart.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGateway::DocumentationPart", exports2.CfnDocumentationPart = CfnDocumentationPart;
    function CfnDocumentationPart_LocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("method", cdk.validateString)(properties.method)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.collect(cdk.propertyValidator("statusCode", cdk.validateString)(properties.statusCode)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "LocationProperty"');
    }
    function cfnDocumentationPartLocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDocumentationPart_LocationPropertyValidator(properties).assertSuccess(), { Method: cdk.stringToCloudFormation(properties.method), Name: cdk.stringToCloudFormation(properties.name), Path: cdk.stringToCloudFormation(properties.path), StatusCode: cdk.stringToCloudFormation(properties.statusCode), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnDocumentationPartLocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("method", "Method", properties.Method != null ? cfn_parse.FromCloudFormation.getString(properties.Method) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("path", "Path", properties.Path != null ? cfn_parse.FromCloudFormation.getString(properties.Path) : void 0), ret.addPropertyResult("statusCode", "StatusCode", properties.StatusCode != null ? cfn_parse.FromCloudFormation.getString(properties.StatusCode) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDocumentationVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("documentationVersion", cdk.requiredValidator)(properties.documentationVersion)), errors.collect(cdk.propertyValidator("documentationVersion", cdk.validateString)(properties.documentationVersion)), errors.collect(cdk.propertyValidator("restApiId", cdk.requiredValidator)(properties.restApiId)), errors.collect(cdk.propertyValidator("restApiId", cdk.validateString)(properties.restApiId)), errors.wrap('supplied properties not correct for "CfnDocumentationVersionProps"');
    }
    function cfnDocumentationVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDocumentationVersionPropsValidator(properties).assertSuccess(), { DocumentationVersion: cdk.stringToCloudFormation(properties.documentationVersion), RestApiId: cdk.stringToCloudFormation(properties.restApiId), Description: cdk.stringToCloudFormation(properties.description) }) : properties;
    }
    function CfnDocumentationVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("documentationVersion", "DocumentationVersion", cfn_parse.FromCloudFormation.getString(properties.DocumentationVersion)), ret.addPropertyResult("restApiId", "RestApiId", cfn_parse.FromCloudFormation.getString(properties.RestApiId)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDocumentationVersion = class _CfnDocumentationVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDocumentationVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnDocumentationVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDocumentationVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_CfnDocumentationVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDocumentationVersion), error;
        }
        cdk.requireProperty(props, "documentationVersion", this), cdk.requireProperty(props, "restApiId", this), this.documentationVersion = props.documentationVersion, this.restApiId = props.restApiId, this.description = props.description;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDocumentationVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { documentationVersion: this.documentationVersion, restApiId: this.restApiId, description: this.description };
      }
      renderProperties(props) {
        return cfnDocumentationVersionPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnDocumentationVersion[_h] = { fqn: "aws-cdk-lib.aws_apigateway.CfnDocumentationVersion", version: "2.80.0" }, CfnDocumentationVersion.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGateway::DocumentationVersion", exports2.CfnDocumentationVersion = CfnDocumentationVersion;
    function CfnDomainNamePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateArn", cdk.validateString)(properties.certificateArn)), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.collect(cdk.propertyValidator("endpointConfiguration", CfnDomainName_EndpointConfigurationPropertyValidator)(properties.endpointConfiguration)), errors.collect(cdk.propertyValidator("mutualTlsAuthentication", CfnDomainName_MutualTlsAuthenticationPropertyValidator)(properties.mutualTlsAuthentication)), errors.collect(cdk.propertyValidator("ownershipVerificationCertificateArn", cdk.validateString)(properties.ownershipVerificationCertificateArn)), errors.collect(cdk.propertyValidator("regionalCertificateArn", cdk.validateString)(properties.regionalCertificateArn)), errors.collect(cdk.propertyValidator("securityPolicy", cdk.validateString)(properties.securityPolicy)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDomainNameProps"');
    }
    function cfnDomainNamePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomainNamePropsValidator(properties).assertSuccess(), { CertificateArn: cdk.stringToCloudFormation(properties.certificateArn), DomainName: cdk.stringToCloudFormation(properties.domainName), EndpointConfiguration: cfnDomainNameEndpointConfigurationPropertyToCloudFormation(properties.endpointConfiguration), MutualTlsAuthentication: cfnDomainNameMutualTlsAuthenticationPropertyToCloudFormation(properties.mutualTlsAuthentication), OwnershipVerificationCertificateArn: cdk.stringToCloudFormation(properties.ownershipVerificationCertificateArn), RegionalCertificateArn: cdk.stringToCloudFormation(properties.regionalCertificateArn), SecurityPolicy: cdk.stringToCloudFormation(properties.securityPolicy), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDomainNamePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificateArn", "CertificateArn", properties.CertificateArn != null ? cfn_parse.FromCloudFormation.getString(properties.CertificateArn) : void 0), ret.addPropertyResult("domainName", "DomainName", properties.DomainName != null ? cfn_parse.FromCloudFormation.getString(properties.DomainName) : void 0), ret.addPropertyResult("endpointConfiguration", "EndpointConfiguration", properties.EndpointConfiguration != null ? CfnDomainNameEndpointConfigurationPropertyFromCloudFormation(properties.EndpointConfiguration) : void 0), ret.addPropertyResult("mutualTlsAuthentication", "MutualTlsAuthentication", properties.MutualTlsAuthentication != null ? CfnDomainNameMutualTlsAuthenticationPropertyFromCloudFormation(properties.MutualTlsAuthentication) : void 0), ret.addPropertyResult("ownershipVerificationCertificateArn", "OwnershipVerificationCertificateArn", properties.OwnershipVerificationCertificateArn != null ? cfn_parse.FromCloudFormation.getString(properties.OwnershipVerificationCertificateArn) : void 0), ret.addPropertyResult("regionalCertificateArn", "RegionalCertificateArn", properties.RegionalCertificateArn != null ? cfn_parse.FromCloudFormation.getString(properties.RegionalCertificateArn) : void 0), ret.addPropertyResult("securityPolicy", "SecurityPolicy", properties.SecurityPolicy != null ? cfn_parse.FromCloudFormation.getString(properties.SecurityPolicy) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDomainName = class _CfnDomainName extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDomainNamePropsFromCloudFormation(resourceProperties), ret = new _CfnDomainName(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnDomainName.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_CfnDomainNameProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDomainName), error;
        }
        this.attrDistributionDomainName = cdk.Token.asString(this.getAtt("DistributionDomainName", cdk.ResolutionTypeHint.STRING)), this.attrDistributionHostedZoneId = cdk.Token.asString(this.getAtt("DistributionHostedZoneId", cdk.ResolutionTypeHint.STRING)), this.attrRegionalDomainName = cdk.Token.asString(this.getAtt("RegionalDomainName", cdk.ResolutionTypeHint.STRING)), this.attrRegionalHostedZoneId = cdk.Token.asString(this.getAtt("RegionalHostedZoneId", cdk.ResolutionTypeHint.STRING)), this.certificateArn = props.certificateArn, this.domainName = props.domainName, this.endpointConfiguration = props.endpointConfiguration, this.mutualTlsAuthentication = props.mutualTlsAuthentication, this.ownershipVerificationCertificateArn = props.ownershipVerificationCertificateArn, this.regionalCertificateArn = props.regionalCertificateArn, this.securityPolicy = props.securityPolicy, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ApiGateway::DomainName", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDomainName.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { certificateArn: this.certificateArn, domainName: this.domainName, endpointConfiguration: this.endpointConfiguration, mutualTlsAuthentication: this.mutualTlsAuthentication, ownershipVerificationCertificateArn: this.ownershipVerificationCertificateArn, regionalCertificateArn: this.regionalCertificateArn, securityPolicy: this.securityPolicy, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDomainNamePropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnDomainName[_j] = { fqn: "aws-cdk-lib.aws_apigateway.CfnDomainName", version: "2.80.0" }, CfnDomainName.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGateway::DomainName", exports2.CfnDomainName = CfnDomainName;
    function CfnDomainName_EndpointConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("types", cdk.listValidator(cdk.validateString))(properties.types)), errors.wrap('supplied properties not correct for "EndpointConfigurationProperty"');
    }
    function cfnDomainNameEndpointConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomainName_EndpointConfigurationPropertyValidator(properties).assertSuccess(), { Types: cdk.listMapper(cdk.stringToCloudFormation)(properties.types) }) : properties;
    }
    function CfnDomainNameEndpointConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("types", "Types", properties.Types != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Types) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomainName_MutualTlsAuthenticationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("truststoreUri", cdk.validateString)(properties.truststoreUri)), errors.collect(cdk.propertyValidator("truststoreVersion", cdk.validateString)(properties.truststoreVersion)), errors.wrap('supplied properties not correct for "MutualTlsAuthenticationProperty"');
    }
    function cfnDomainNameMutualTlsAuthenticationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomainName_MutualTlsAuthenticationPropertyValidator(properties).assertSuccess(), { TruststoreUri: cdk.stringToCloudFormation(properties.truststoreUri), TruststoreVersion: cdk.stringToCloudFormation(properties.truststoreVersion) }) : properties;
    }
    function CfnDomainNameMutualTlsAuthenticationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("truststoreUri", "TruststoreUri", properties.TruststoreUri != null ? cfn_parse.FromCloudFormation.getString(properties.TruststoreUri) : void 0), ret.addPropertyResult("truststoreVersion", "TruststoreVersion", properties.TruststoreVersion != null ? cfn_parse.FromCloudFormation.getString(properties.TruststoreVersion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGatewayResponsePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("responseParameters", cdk.hashValidator(cdk.validateString))(properties.responseParameters)), errors.collect(cdk.propertyValidator("responseTemplates", cdk.hashValidator(cdk.validateString))(properties.responseTemplates)), errors.collect(cdk.propertyValidator("responseType", cdk.requiredValidator)(properties.responseType)), errors.collect(cdk.propertyValidator("responseType", cdk.validateString)(properties.responseType)), errors.collect(cdk.propertyValidator("restApiId", cdk.requiredValidator)(properties.restApiId)), errors.collect(cdk.propertyValidator("restApiId", cdk.validateString)(properties.restApiId)), errors.collect(cdk.propertyValidator("statusCode", cdk.validateString)(properties.statusCode)), errors.wrap('supplied properties not correct for "CfnGatewayResponseProps"');
    }
    function cfnGatewayResponsePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGatewayResponsePropsValidator(properties).assertSuccess(), { ResponseType: cdk.stringToCloudFormation(properties.responseType), RestApiId: cdk.stringToCloudFormation(properties.restApiId), ResponseParameters: cdk.hashMapper(cdk.stringToCloudFormation)(properties.responseParameters), ResponseTemplates: cdk.hashMapper(cdk.stringToCloudFormation)(properties.responseTemplates), StatusCode: cdk.stringToCloudFormation(properties.statusCode) }) : properties;
    }
    function CfnGatewayResponsePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("responseType", "ResponseType", cfn_parse.FromCloudFormation.getString(properties.ResponseType)), ret.addPropertyResult("restApiId", "RestApiId", cfn_parse.FromCloudFormation.getString(properties.RestApiId)), ret.addPropertyResult("responseParameters", "ResponseParameters", properties.ResponseParameters != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.ResponseParameters) : void 0), ret.addPropertyResult("responseTemplates", "ResponseTemplates", properties.ResponseTemplates != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.ResponseTemplates) : void 0), ret.addPropertyResult("statusCode", "StatusCode", properties.StatusCode != null ? cfn_parse.FromCloudFormation.getString(properties.StatusCode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnGatewayResponse = class _CfnGatewayResponse extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnGatewayResponsePropsFromCloudFormation(resourceProperties), ret = new _CfnGatewayResponse(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnGatewayResponse.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_CfnGatewayResponseProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnGatewayResponse), error;
        }
        cdk.requireProperty(props, "responseType", this), cdk.requireProperty(props, "restApiId", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.responseType = props.responseType, this.restApiId = props.restApiId, this.responseParameters = props.responseParameters, this.responseTemplates = props.responseTemplates, this.statusCode = props.statusCode;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnGatewayResponse.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { responseType: this.responseType, restApiId: this.restApiId, responseParameters: this.responseParameters, responseTemplates: this.responseTemplates, statusCode: this.statusCode };
      }
      renderProperties(props) {
        return cfnGatewayResponsePropsToCloudFormation(props);
      }
    };
    _k = JSII_RTTI_SYMBOL_1, CfnGatewayResponse[_k] = { fqn: "aws-cdk-lib.aws_apigateway.CfnGatewayResponse", version: "2.80.0" }, CfnGatewayResponse.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGateway::GatewayResponse", exports2.CfnGatewayResponse = CfnGatewayResponse;
    function CfnMethodPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiKeyRequired", cdk.validateBoolean)(properties.apiKeyRequired)), errors.collect(cdk.propertyValidator("authorizationScopes", cdk.listValidator(cdk.validateString))(properties.authorizationScopes)), errors.collect(cdk.propertyValidator("authorizationType", cdk.validateString)(properties.authorizationType)), errors.collect(cdk.propertyValidator("authorizerId", cdk.validateString)(properties.authorizerId)), errors.collect(cdk.propertyValidator("httpMethod", cdk.requiredValidator)(properties.httpMethod)), errors.collect(cdk.propertyValidator("httpMethod", cdk.validateString)(properties.httpMethod)), errors.collect(cdk.propertyValidator("integration", CfnMethod_IntegrationPropertyValidator)(properties.integration)), errors.collect(cdk.propertyValidator("methodResponses", cdk.listValidator(CfnMethod_MethodResponsePropertyValidator))(properties.methodResponses)), errors.collect(cdk.propertyValidator("operationName", cdk.validateString)(properties.operationName)), errors.collect(cdk.propertyValidator("requestModels", cdk.hashValidator(cdk.validateString))(properties.requestModels)), errors.collect(cdk.propertyValidator("requestParameters", cdk.hashValidator(cdk.validateBoolean))(properties.requestParameters)), errors.collect(cdk.propertyValidator("requestValidatorId", cdk.validateString)(properties.requestValidatorId)), errors.collect(cdk.propertyValidator("resourceId", cdk.requiredValidator)(properties.resourceId)), errors.collect(cdk.propertyValidator("resourceId", cdk.validateString)(properties.resourceId)), errors.collect(cdk.propertyValidator("restApiId", cdk.requiredValidator)(properties.restApiId)), errors.collect(cdk.propertyValidator("restApiId", cdk.validateString)(properties.restApiId)), errors.wrap('supplied properties not correct for "CfnMethodProps"');
    }
    function cfnMethodPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMethodPropsValidator(properties).assertSuccess(), { HttpMethod: cdk.stringToCloudFormation(properties.httpMethod), ResourceId: cdk.stringToCloudFormation(properties.resourceId), RestApiId: cdk.stringToCloudFormation(properties.restApiId), ApiKeyRequired: cdk.booleanToCloudFormation(properties.apiKeyRequired), AuthorizationScopes: cdk.listMapper(cdk.stringToCloudFormation)(properties.authorizationScopes), AuthorizationType: cdk.stringToCloudFormation(properties.authorizationType), AuthorizerId: cdk.stringToCloudFormation(properties.authorizerId), Integration: cfnMethodIntegrationPropertyToCloudFormation(properties.integration), MethodResponses: cdk.listMapper(cfnMethodMethodResponsePropertyToCloudFormation)(properties.methodResponses), OperationName: cdk.stringToCloudFormation(properties.operationName), RequestModels: cdk.hashMapper(cdk.stringToCloudFormation)(properties.requestModels), RequestParameters: cdk.hashMapper(cdk.booleanToCloudFormation)(properties.requestParameters), RequestValidatorId: cdk.stringToCloudFormation(properties.requestValidatorId) }) : properties;
    }
    function CfnMethodPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("httpMethod", "HttpMethod", cfn_parse.FromCloudFormation.getString(properties.HttpMethod)), ret.addPropertyResult("resourceId", "ResourceId", cfn_parse.FromCloudFormation.getString(properties.ResourceId)), ret.addPropertyResult("restApiId", "RestApiId", cfn_parse.FromCloudFormation.getString(properties.RestApiId)), ret.addPropertyResult("apiKeyRequired", "ApiKeyRequired", properties.ApiKeyRequired != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ApiKeyRequired) : void 0), ret.addPropertyResult("authorizationScopes", "AuthorizationScopes", properties.AuthorizationScopes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AuthorizationScopes) : void 0), ret.addPropertyResult("authorizationType", "AuthorizationType", properties.AuthorizationType != null ? cfn_parse.FromCloudFormation.getString(properties.AuthorizationType) : void 0), ret.addPropertyResult("authorizerId", "AuthorizerId", properties.AuthorizerId != null ? cfn_parse.FromCloudFormation.getString(properties.AuthorizerId) : void 0), ret.addPropertyResult("integration", "Integration", properties.Integration != null ? CfnMethodIntegrationPropertyFromCloudFormation(properties.Integration) : void 0), ret.addPropertyResult("methodResponses", "MethodResponses", properties.MethodResponses != null ? cfn_parse.FromCloudFormation.getArray(CfnMethodMethodResponsePropertyFromCloudFormation)(properties.MethodResponses) : void 0), ret.addPropertyResult("operationName", "OperationName", properties.OperationName != null ? cfn_parse.FromCloudFormation.getString(properties.OperationName) : void 0), ret.addPropertyResult("requestModels", "RequestModels", properties.RequestModels != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.RequestModels) : void 0), ret.addPropertyResult("requestParameters", "RequestParameters", properties.RequestParameters != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getBoolean)(properties.RequestParameters) : void 0), ret.addPropertyResult("requestValidatorId", "RequestValidatorId", properties.RequestValidatorId != null ? cfn_parse.FromCloudFormation.getString(properties.RequestValidatorId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnMethod = class _CfnMethod extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnMethodPropsFromCloudFormation(resourceProperties), ret = new _CfnMethod(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnMethod.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_CfnMethodProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnMethod), error;
        }
        cdk.requireProperty(props, "httpMethod", this), cdk.requireProperty(props, "resourceId", this), cdk.requireProperty(props, "restApiId", this), this.httpMethod = props.httpMethod, this.resourceId = props.resourceId, this.restApiId = props.restApiId, this.apiKeyRequired = props.apiKeyRequired, this.authorizationScopes = props.authorizationScopes, this.authorizationType = props.authorizationType, this.authorizerId = props.authorizerId, this.integration = props.integration, this.methodResponses = props.methodResponses, this.operationName = props.operationName, this.requestModels = props.requestModels, this.requestParameters = props.requestParameters, this.requestValidatorId = props.requestValidatorId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnMethod.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { httpMethod: this.httpMethod, resourceId: this.resourceId, restApiId: this.restApiId, apiKeyRequired: this.apiKeyRequired, authorizationScopes: this.authorizationScopes, authorizationType: this.authorizationType, authorizerId: this.authorizerId, integration: this.integration, methodResponses: this.methodResponses, operationName: this.operationName, requestModels: this.requestModels, requestParameters: this.requestParameters, requestValidatorId: this.requestValidatorId };
      }
      renderProperties(props) {
        return cfnMethodPropsToCloudFormation(props);
      }
    };
    _l = JSII_RTTI_SYMBOL_1, CfnMethod[_l] = { fqn: "aws-cdk-lib.aws_apigateway.CfnMethod", version: "2.80.0" }, CfnMethod.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGateway::Method", exports2.CfnMethod = CfnMethod;
    function CfnMethod_IntegrationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cacheKeyParameters", cdk.listValidator(cdk.validateString))(properties.cacheKeyParameters)), errors.collect(cdk.propertyValidator("cacheNamespace", cdk.validateString)(properties.cacheNamespace)), errors.collect(cdk.propertyValidator("connectionId", cdk.validateString)(properties.connectionId)), errors.collect(cdk.propertyValidator("connectionType", cdk.validateString)(properties.connectionType)), errors.collect(cdk.propertyValidator("contentHandling", cdk.validateString)(properties.contentHandling)), errors.collect(cdk.propertyValidator("credentials", cdk.validateString)(properties.credentials)), errors.collect(cdk.propertyValidator("integrationHttpMethod", cdk.validateString)(properties.integrationHttpMethod)), errors.collect(cdk.propertyValidator("integrationResponses", cdk.listValidator(CfnMethod_IntegrationResponsePropertyValidator))(properties.integrationResponses)), errors.collect(cdk.propertyValidator("passthroughBehavior", cdk.validateString)(properties.passthroughBehavior)), errors.collect(cdk.propertyValidator("requestParameters", cdk.hashValidator(cdk.validateString))(properties.requestParameters)), errors.collect(cdk.propertyValidator("requestTemplates", cdk.hashValidator(cdk.validateString))(properties.requestTemplates)), errors.collect(cdk.propertyValidator("timeoutInMillis", cdk.validateNumber)(properties.timeoutInMillis)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("uri", cdk.validateString)(properties.uri)), errors.wrap('supplied properties not correct for "IntegrationProperty"');
    }
    function cfnMethodIntegrationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMethod_IntegrationPropertyValidator(properties).assertSuccess(), { CacheKeyParameters: cdk.listMapper(cdk.stringToCloudFormation)(properties.cacheKeyParameters), CacheNamespace: cdk.stringToCloudFormation(properties.cacheNamespace), ConnectionId: cdk.stringToCloudFormation(properties.connectionId), ConnectionType: cdk.stringToCloudFormation(properties.connectionType), ContentHandling: cdk.stringToCloudFormation(properties.contentHandling), Credentials: cdk.stringToCloudFormation(properties.credentials), IntegrationHttpMethod: cdk.stringToCloudFormation(properties.integrationHttpMethod), IntegrationResponses: cdk.listMapper(cfnMethodIntegrationResponsePropertyToCloudFormation)(properties.integrationResponses), PassthroughBehavior: cdk.stringToCloudFormation(properties.passthroughBehavior), RequestParameters: cdk.hashMapper(cdk.stringToCloudFormation)(properties.requestParameters), RequestTemplates: cdk.hashMapper(cdk.stringToCloudFormation)(properties.requestTemplates), TimeoutInMillis: cdk.numberToCloudFormation(properties.timeoutInMillis), Type: cdk.stringToCloudFormation(properties.type), Uri: cdk.stringToCloudFormation(properties.uri) }) : properties;
    }
    function CfnMethodIntegrationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cacheKeyParameters", "CacheKeyParameters", properties.CacheKeyParameters != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CacheKeyParameters) : void 0), ret.addPropertyResult("cacheNamespace", "CacheNamespace", properties.CacheNamespace != null ? cfn_parse.FromCloudFormation.getString(properties.CacheNamespace) : void 0), ret.addPropertyResult("connectionId", "ConnectionId", properties.ConnectionId != null ? cfn_parse.FromCloudFormation.getString(properties.ConnectionId) : void 0), ret.addPropertyResult("connectionType", "ConnectionType", properties.ConnectionType != null ? cfn_parse.FromCloudFormation.getString(properties.ConnectionType) : void 0), ret.addPropertyResult("contentHandling", "ContentHandling", properties.ContentHandling != null ? cfn_parse.FromCloudFormation.getString(properties.ContentHandling) : void 0), ret.addPropertyResult("credentials", "Credentials", properties.Credentials != null ? cfn_parse.FromCloudFormation.getString(properties.Credentials) : void 0), ret.addPropertyResult("integrationHttpMethod", "IntegrationHttpMethod", properties.IntegrationHttpMethod != null ? cfn_parse.FromCloudFormation.getString(properties.IntegrationHttpMethod) : void 0), ret.addPropertyResult("integrationResponses", "IntegrationResponses", properties.IntegrationResponses != null ? cfn_parse.FromCloudFormation.getArray(CfnMethodIntegrationResponsePropertyFromCloudFormation)(properties.IntegrationResponses) : void 0), ret.addPropertyResult("passthroughBehavior", "PassthroughBehavior", properties.PassthroughBehavior != null ? cfn_parse.FromCloudFormation.getString(properties.PassthroughBehavior) : void 0), ret.addPropertyResult("requestParameters", "RequestParameters", properties.RequestParameters != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.RequestParameters) : void 0), ret.addPropertyResult("requestTemplates", "RequestTemplates", properties.RequestTemplates != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.RequestTemplates) : void 0), ret.addPropertyResult("timeoutInMillis", "TimeoutInMillis", properties.TimeoutInMillis != null ? cfn_parse.FromCloudFormation.getNumber(properties.TimeoutInMillis) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addPropertyResult("uri", "Uri", properties.Uri != null ? cfn_parse.FromCloudFormation.getString(properties.Uri) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMethod_IntegrationResponsePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contentHandling", cdk.validateString)(properties.contentHandling)), errors.collect(cdk.propertyValidator("responseParameters", cdk.hashValidator(cdk.validateString))(properties.responseParameters)), errors.collect(cdk.propertyValidator("responseTemplates", cdk.hashValidator(cdk.validateString))(properties.responseTemplates)), errors.collect(cdk.propertyValidator("selectionPattern", cdk.validateString)(properties.selectionPattern)), errors.collect(cdk.propertyValidator("statusCode", cdk.requiredValidator)(properties.statusCode)), errors.collect(cdk.propertyValidator("statusCode", cdk.validateString)(properties.statusCode)), errors.wrap('supplied properties not correct for "IntegrationResponseProperty"');
    }
    function cfnMethodIntegrationResponsePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMethod_IntegrationResponsePropertyValidator(properties).assertSuccess(), { ContentHandling: cdk.stringToCloudFormation(properties.contentHandling), ResponseParameters: cdk.hashMapper(cdk.stringToCloudFormation)(properties.responseParameters), ResponseTemplates: cdk.hashMapper(cdk.stringToCloudFormation)(properties.responseTemplates), SelectionPattern: cdk.stringToCloudFormation(properties.selectionPattern), StatusCode: cdk.stringToCloudFormation(properties.statusCode) }) : properties;
    }
    function CfnMethodIntegrationResponsePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contentHandling", "ContentHandling", properties.ContentHandling != null ? cfn_parse.FromCloudFormation.getString(properties.ContentHandling) : void 0), ret.addPropertyResult("responseParameters", "ResponseParameters", properties.ResponseParameters != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.ResponseParameters) : void 0), ret.addPropertyResult("responseTemplates", "ResponseTemplates", properties.ResponseTemplates != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.ResponseTemplates) : void 0), ret.addPropertyResult("selectionPattern", "SelectionPattern", properties.SelectionPattern != null ? cfn_parse.FromCloudFormation.getString(properties.SelectionPattern) : void 0), ret.addPropertyResult("statusCode", "StatusCode", cfn_parse.FromCloudFormation.getString(properties.StatusCode)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMethod_MethodResponsePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("responseModels", cdk.hashValidator(cdk.validateString))(properties.responseModels)), errors.collect(cdk.propertyValidator("responseParameters", cdk.hashValidator(cdk.validateBoolean))(properties.responseParameters)), errors.collect(cdk.propertyValidator("statusCode", cdk.requiredValidator)(properties.statusCode)), errors.collect(cdk.propertyValidator("statusCode", cdk.validateString)(properties.statusCode)), errors.wrap('supplied properties not correct for "MethodResponseProperty"');
    }
    function cfnMethodMethodResponsePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMethod_MethodResponsePropertyValidator(properties).assertSuccess(), { ResponseModels: cdk.hashMapper(cdk.stringToCloudFormation)(properties.responseModels), ResponseParameters: cdk.hashMapper(cdk.booleanToCloudFormation)(properties.responseParameters), StatusCode: cdk.stringToCloudFormation(properties.statusCode) }) : properties;
    }
    function CfnMethodMethodResponsePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("responseModels", "ResponseModels", properties.ResponseModels != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.ResponseModels) : void 0), ret.addPropertyResult("responseParameters", "ResponseParameters", properties.ResponseParameters != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getBoolean)(properties.ResponseParameters) : void 0), ret.addPropertyResult("statusCode", "StatusCode", cfn_parse.FromCloudFormation.getString(properties.StatusCode)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contentType", cdk.validateString)(properties.contentType)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("restApiId", cdk.requiredValidator)(properties.restApiId)), errors.collect(cdk.propertyValidator("restApiId", cdk.validateString)(properties.restApiId)), errors.collect(cdk.propertyValidator("schema", cdk.validateObject)(properties.schema)), errors.wrap('supplied properties not correct for "CfnModelProps"');
    }
    function cfnModelPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPropsValidator(properties).assertSuccess(), { RestApiId: cdk.stringToCloudFormation(properties.restApiId), ContentType: cdk.stringToCloudFormation(properties.contentType), Description: cdk.stringToCloudFormation(properties.description), Name: cdk.stringToCloudFormation(properties.name), Schema: cdk.objectToCloudFormation(properties.schema) }) : properties;
    }
    function CfnModelPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("restApiId", "RestApiId", cfn_parse.FromCloudFormation.getString(properties.RestApiId)), ret.addPropertyResult("contentType", "ContentType", properties.ContentType != null ? cfn_parse.FromCloudFormation.getString(properties.ContentType) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("schema", "Schema", properties.Schema != null ? cfn_parse.FromCloudFormation.getAny(properties.Schema) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnModel = class _CfnModel extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnModelPropsFromCloudFormation(resourceProperties), ret = new _CfnModel(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnModel.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_CfnModelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnModel), error;
        }
        cdk.requireProperty(props, "restApiId", this), this.restApiId = props.restApiId, this.contentType = props.contentType, this.description = props.description, this.name = props.name, this.schema = props.schema;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnModel.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { restApiId: this.restApiId, contentType: this.contentType, description: this.description, name: this.name, schema: this.schema };
      }
      renderProperties(props) {
        return cfnModelPropsToCloudFormation(props);
      }
    };
    _m = JSII_RTTI_SYMBOL_1, CfnModel[_m] = { fqn: "aws-cdk-lib.aws_apigateway.CfnModel", version: "2.80.0" }, CfnModel.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGateway::Model", exports2.CfnModel = CfnModel;
    function CfnRequestValidatorPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("restApiId", cdk.requiredValidator)(properties.restApiId)), errors.collect(cdk.propertyValidator("restApiId", cdk.validateString)(properties.restApiId)), errors.collect(cdk.propertyValidator("validateRequestBody", cdk.validateBoolean)(properties.validateRequestBody)), errors.collect(cdk.propertyValidator("validateRequestParameters", cdk.validateBoolean)(properties.validateRequestParameters)), errors.wrap('supplied properties not correct for "CfnRequestValidatorProps"');
    }
    function cfnRequestValidatorPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRequestValidatorPropsValidator(properties).assertSuccess(), { RestApiId: cdk.stringToCloudFormation(properties.restApiId), Name: cdk.stringToCloudFormation(properties.name), ValidateRequestBody: cdk.booleanToCloudFormation(properties.validateRequestBody), ValidateRequestParameters: cdk.booleanToCloudFormation(properties.validateRequestParameters) }) : properties;
    }
    function CfnRequestValidatorPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("restApiId", "RestApiId", cfn_parse.FromCloudFormation.getString(properties.RestApiId)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("validateRequestBody", "ValidateRequestBody", properties.ValidateRequestBody != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ValidateRequestBody) : void 0), ret.addPropertyResult("validateRequestParameters", "ValidateRequestParameters", properties.ValidateRequestParameters != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ValidateRequestParameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRequestValidator = class _CfnRequestValidator extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRequestValidatorPropsFromCloudFormation(resourceProperties), ret = new _CfnRequestValidator(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRequestValidator.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_CfnRequestValidatorProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRequestValidator), error;
        }
        cdk.requireProperty(props, "restApiId", this), this.attrRequestValidatorId = cdk.Token.asString(this.getAtt("RequestValidatorId", cdk.ResolutionTypeHint.STRING)), this.restApiId = props.restApiId, this.name = props.name, this.validateRequestBody = props.validateRequestBody, this.validateRequestParameters = props.validateRequestParameters;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRequestValidator.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { restApiId: this.restApiId, name: this.name, validateRequestBody: this.validateRequestBody, validateRequestParameters: this.validateRequestParameters };
      }
      renderProperties(props) {
        return cfnRequestValidatorPropsToCloudFormation(props);
      }
    };
    _o = JSII_RTTI_SYMBOL_1, CfnRequestValidator[_o] = { fqn: "aws-cdk-lib.aws_apigateway.CfnRequestValidator", version: "2.80.0" }, CfnRequestValidator.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGateway::RequestValidator", exports2.CfnRequestValidator = CfnRequestValidator;
    function CfnResourcePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("parentId", cdk.requiredValidator)(properties.parentId)), errors.collect(cdk.propertyValidator("parentId", cdk.validateString)(properties.parentId)), errors.collect(cdk.propertyValidator("pathPart", cdk.requiredValidator)(properties.pathPart)), errors.collect(cdk.propertyValidator("pathPart", cdk.validateString)(properties.pathPart)), errors.collect(cdk.propertyValidator("restApiId", cdk.requiredValidator)(properties.restApiId)), errors.collect(cdk.propertyValidator("restApiId", cdk.validateString)(properties.restApiId)), errors.wrap('supplied properties not correct for "CfnResourceProps"');
    }
    function cfnResourcePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourcePropsValidator(properties).assertSuccess(), { ParentId: cdk.stringToCloudFormation(properties.parentId), PathPart: cdk.stringToCloudFormation(properties.pathPart), RestApiId: cdk.stringToCloudFormation(properties.restApiId) }) : properties;
    }
    function CfnResourcePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("parentId", "ParentId", cfn_parse.FromCloudFormation.getString(properties.ParentId)), ret.addPropertyResult("pathPart", "PathPart", cfn_parse.FromCloudFormation.getString(properties.PathPart)), ret.addPropertyResult("restApiId", "RestApiId", cfn_parse.FromCloudFormation.getString(properties.RestApiId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResource = class _CfnResource extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResourcePropsFromCloudFormation(resourceProperties), ret = new _CfnResource(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnResource.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_CfnResourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResource), error;
        }
        cdk.requireProperty(props, "parentId", this), cdk.requireProperty(props, "pathPart", this), cdk.requireProperty(props, "restApiId", this), this.attrResourceId = cdk.Token.asString(this.getAtt("ResourceId", cdk.ResolutionTypeHint.STRING)), this.parentId = props.parentId, this.pathPart = props.pathPart, this.restApiId = props.restApiId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResource.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { parentId: this.parentId, pathPart: this.pathPart, restApiId: this.restApiId };
      }
      renderProperties(props) {
        return cfnResourcePropsToCloudFormation(props);
      }
    };
    _p = JSII_RTTI_SYMBOL_1, CfnResource[_p] = { fqn: "aws-cdk-lib.aws_apigateway.CfnResource", version: "2.80.0" }, CfnResource.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGateway::Resource", exports2.CfnResource = CfnResource;
    function CfnRestApiPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiKeySourceType", cdk.validateString)(properties.apiKeySourceType)), errors.collect(cdk.propertyValidator("binaryMediaTypes", cdk.listValidator(cdk.validateString))(properties.binaryMediaTypes)), errors.collect(cdk.propertyValidator("body", cdk.validateObject)(properties.body)), errors.collect(cdk.propertyValidator("bodyS3Location", CfnRestApi_S3LocationPropertyValidator)(properties.bodyS3Location)), errors.collect(cdk.propertyValidator("cloneFrom", cdk.validateString)(properties.cloneFrom)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("disableExecuteApiEndpoint", cdk.validateBoolean)(properties.disableExecuteApiEndpoint)), errors.collect(cdk.propertyValidator("endpointConfiguration", CfnRestApi_EndpointConfigurationPropertyValidator)(properties.endpointConfiguration)), errors.collect(cdk.propertyValidator("failOnWarnings", cdk.validateBoolean)(properties.failOnWarnings)), errors.collect(cdk.propertyValidator("minimumCompressionSize", cdk.validateNumber)(properties.minimumCompressionSize)), errors.collect(cdk.propertyValidator("mode", cdk.validateString)(properties.mode)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("parameters", cdk.hashValidator(cdk.validateString))(properties.parameters)), errors.collect(cdk.propertyValidator("policy", cdk.validateObject)(properties.policy)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnRestApiProps"');
    }
    function cfnRestApiPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRestApiPropsValidator(properties).assertSuccess(), { ApiKeySourceType: cdk.stringToCloudFormation(properties.apiKeySourceType), BinaryMediaTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.binaryMediaTypes), Body: cdk.objectToCloudFormation(properties.body), BodyS3Location: cfnRestApiS3LocationPropertyToCloudFormation(properties.bodyS3Location), CloneFrom: cdk.stringToCloudFormation(properties.cloneFrom), Description: cdk.stringToCloudFormation(properties.description), DisableExecuteApiEndpoint: cdk.booleanToCloudFormation(properties.disableExecuteApiEndpoint), EndpointConfiguration: cfnRestApiEndpointConfigurationPropertyToCloudFormation(properties.endpointConfiguration), FailOnWarnings: cdk.booleanToCloudFormation(properties.failOnWarnings), MinimumCompressionSize: cdk.numberToCloudFormation(properties.minimumCompressionSize), Mode: cdk.stringToCloudFormation(properties.mode), Name: cdk.stringToCloudFormation(properties.name), Parameters: cdk.hashMapper(cdk.stringToCloudFormation)(properties.parameters), Policy: cdk.objectToCloudFormation(properties.policy), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnRestApiPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiKeySourceType", "ApiKeySourceType", properties.ApiKeySourceType != null ? cfn_parse.FromCloudFormation.getString(properties.ApiKeySourceType) : void 0), ret.addPropertyResult("binaryMediaTypes", "BinaryMediaTypes", properties.BinaryMediaTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.BinaryMediaTypes) : void 0), ret.addPropertyResult("body", "Body", properties.Body != null ? cfn_parse.FromCloudFormation.getAny(properties.Body) : void 0), ret.addPropertyResult("bodyS3Location", "BodyS3Location", properties.BodyS3Location != null ? CfnRestApiS3LocationPropertyFromCloudFormation(properties.BodyS3Location) : void 0), ret.addPropertyResult("cloneFrom", "CloneFrom", properties.CloneFrom != null ? cfn_parse.FromCloudFormation.getString(properties.CloneFrom) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("disableExecuteApiEndpoint", "DisableExecuteApiEndpoint", properties.DisableExecuteApiEndpoint != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DisableExecuteApiEndpoint) : void 0), ret.addPropertyResult("endpointConfiguration", "EndpointConfiguration", properties.EndpointConfiguration != null ? CfnRestApiEndpointConfigurationPropertyFromCloudFormation(properties.EndpointConfiguration) : void 0), ret.addPropertyResult("failOnWarnings", "FailOnWarnings", properties.FailOnWarnings != null ? cfn_parse.FromCloudFormation.getBoolean(properties.FailOnWarnings) : void 0), ret.addPropertyResult("minimumCompressionSize", "MinimumCompressionSize", properties.MinimumCompressionSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinimumCompressionSize) : void 0), ret.addPropertyResult("mode", "Mode", properties.Mode != null ? cfn_parse.FromCloudFormation.getString(properties.Mode) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Parameters) : void 0), ret.addPropertyResult("policy", "Policy", properties.Policy != null ? cfn_parse.FromCloudFormation.getAny(properties.Policy) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRestApi = class _CfnRestApi extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRestApiPropsFromCloudFormation(resourceProperties), ret = new _CfnRestApi(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnRestApi.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_CfnRestApiProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRestApi), error;
        }
        this.attrRestApiId = cdk.Token.asString(this.getAtt("RestApiId", cdk.ResolutionTypeHint.STRING)), this.attrRootResourceId = cdk.Token.asString(this.getAtt("RootResourceId", cdk.ResolutionTypeHint.STRING)), this.apiKeySourceType = props.apiKeySourceType, this.binaryMediaTypes = props.binaryMediaTypes, this.body = props.body, this.bodyS3Location = props.bodyS3Location, this.cloneFrom = props.cloneFrom, this.description = props.description, this.disableExecuteApiEndpoint = props.disableExecuteApiEndpoint, this.endpointConfiguration = props.endpointConfiguration, this.failOnWarnings = props.failOnWarnings, this.minimumCompressionSize = props.minimumCompressionSize, this.mode = props.mode, this.name = props.name, this.parameters = props.parameters, this.policy = props.policy, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ApiGateway::RestApi", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRestApi.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiKeySourceType: this.apiKeySourceType, binaryMediaTypes: this.binaryMediaTypes, body: this.body, bodyS3Location: this.bodyS3Location, cloneFrom: this.cloneFrom, description: this.description, disableExecuteApiEndpoint: this.disableExecuteApiEndpoint, endpointConfiguration: this.endpointConfiguration, failOnWarnings: this.failOnWarnings, minimumCompressionSize: this.minimumCompressionSize, mode: this.mode, name: this.name, parameters: this.parameters, policy: this.policy, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnRestApiPropsToCloudFormation(props);
      }
    };
    _q = JSII_RTTI_SYMBOL_1, CfnRestApi[_q] = { fqn: "aws-cdk-lib.aws_apigateway.CfnRestApi", version: "2.80.0" }, CfnRestApi.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGateway::RestApi", exports2.CfnRestApi = CfnRestApi;
    function CfnRestApi_EndpointConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("types", cdk.listValidator(cdk.validateString))(properties.types)), errors.collect(cdk.propertyValidator("vpcEndpointIds", cdk.listValidator(cdk.validateString))(properties.vpcEndpointIds)), errors.wrap('supplied properties not correct for "EndpointConfigurationProperty"');
    }
    function cfnRestApiEndpointConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRestApi_EndpointConfigurationPropertyValidator(properties).assertSuccess(), { Types: cdk.listMapper(cdk.stringToCloudFormation)(properties.types), VpcEndpointIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.vpcEndpointIds) }) : properties;
    }
    function CfnRestApiEndpointConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("types", "Types", properties.Types != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Types) : void 0), ret.addPropertyResult("vpcEndpointIds", "VpcEndpointIds", properties.VpcEndpointIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.VpcEndpointIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRestApi_S3LocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("eTag", cdk.validateString)(properties.eTag)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "S3LocationProperty"');
    }
    function cfnRestApiS3LocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRestApi_S3LocationPropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), ETag: cdk.stringToCloudFormation(properties.eTag), Key: cdk.stringToCloudFormation(properties.key), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnRestApiS3LocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", properties.Bucket != null ? cfn_parse.FromCloudFormation.getString(properties.Bucket) : void 0), ret.addPropertyResult("eTag", "ETag", properties.ETag != null ? cfn_parse.FromCloudFormation.getString(properties.ETag) : void 0), ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getString(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStagePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessLogSetting", CfnStage_AccessLogSettingPropertyValidator)(properties.accessLogSetting)), errors.collect(cdk.propertyValidator("cacheClusterEnabled", cdk.validateBoolean)(properties.cacheClusterEnabled)), errors.collect(cdk.propertyValidator("cacheClusterSize", cdk.validateString)(properties.cacheClusterSize)), errors.collect(cdk.propertyValidator("canarySetting", CfnStage_CanarySettingPropertyValidator)(properties.canarySetting)), errors.collect(cdk.propertyValidator("clientCertificateId", cdk.validateString)(properties.clientCertificateId)), errors.collect(cdk.propertyValidator("deploymentId", cdk.validateString)(properties.deploymentId)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("documentationVersion", cdk.validateString)(properties.documentationVersion)), errors.collect(cdk.propertyValidator("methodSettings", cdk.listValidator(CfnStage_MethodSettingPropertyValidator))(properties.methodSettings)), errors.collect(cdk.propertyValidator("restApiId", cdk.requiredValidator)(properties.restApiId)), errors.collect(cdk.propertyValidator("restApiId", cdk.validateString)(properties.restApiId)), errors.collect(cdk.propertyValidator("stageName", cdk.validateString)(properties.stageName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("tracingEnabled", cdk.validateBoolean)(properties.tracingEnabled)), errors.collect(cdk.propertyValidator("variables", cdk.hashValidator(cdk.validateString))(properties.variables)), errors.wrap('supplied properties not correct for "CfnStageProps"');
    }
    function cfnStagePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStagePropsValidator(properties).assertSuccess(), { RestApiId: cdk.stringToCloudFormation(properties.restApiId), AccessLogSetting: cfnStageAccessLogSettingPropertyToCloudFormation(properties.accessLogSetting), CacheClusterEnabled: cdk.booleanToCloudFormation(properties.cacheClusterEnabled), CacheClusterSize: cdk.stringToCloudFormation(properties.cacheClusterSize), CanarySetting: cfnStageCanarySettingPropertyToCloudFormation(properties.canarySetting), ClientCertificateId: cdk.stringToCloudFormation(properties.clientCertificateId), DeploymentId: cdk.stringToCloudFormation(properties.deploymentId), Description: cdk.stringToCloudFormation(properties.description), DocumentationVersion: cdk.stringToCloudFormation(properties.documentationVersion), MethodSettings: cdk.listMapper(cfnStageMethodSettingPropertyToCloudFormation)(properties.methodSettings), StageName: cdk.stringToCloudFormation(properties.stageName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TracingEnabled: cdk.booleanToCloudFormation(properties.tracingEnabled), Variables: cdk.hashMapper(cdk.stringToCloudFormation)(properties.variables) }) : properties;
    }
    function CfnStagePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("restApiId", "RestApiId", cfn_parse.FromCloudFormation.getString(properties.RestApiId)), ret.addPropertyResult("accessLogSetting", "AccessLogSetting", properties.AccessLogSetting != null ? CfnStageAccessLogSettingPropertyFromCloudFormation(properties.AccessLogSetting) : void 0), ret.addPropertyResult("cacheClusterEnabled", "CacheClusterEnabled", properties.CacheClusterEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CacheClusterEnabled) : void 0), ret.addPropertyResult("cacheClusterSize", "CacheClusterSize", properties.CacheClusterSize != null ? cfn_parse.FromCloudFormation.getString(properties.CacheClusterSize) : void 0), ret.addPropertyResult("canarySetting", "CanarySetting", properties.CanarySetting != null ? CfnStageCanarySettingPropertyFromCloudFormation(properties.CanarySetting) : void 0), ret.addPropertyResult("clientCertificateId", "ClientCertificateId", properties.ClientCertificateId != null ? cfn_parse.FromCloudFormation.getString(properties.ClientCertificateId) : void 0), ret.addPropertyResult("deploymentId", "DeploymentId", properties.DeploymentId != null ? cfn_parse.FromCloudFormation.getString(properties.DeploymentId) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("documentationVersion", "DocumentationVersion", properties.DocumentationVersion != null ? cfn_parse.FromCloudFormation.getString(properties.DocumentationVersion) : void 0), ret.addPropertyResult("methodSettings", "MethodSettings", properties.MethodSettings != null ? cfn_parse.FromCloudFormation.getArray(CfnStageMethodSettingPropertyFromCloudFormation)(properties.MethodSettings) : void 0), ret.addPropertyResult("stageName", "StageName", properties.StageName != null ? cfn_parse.FromCloudFormation.getString(properties.StageName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("tracingEnabled", "TracingEnabled", properties.TracingEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.TracingEnabled) : void 0), ret.addPropertyResult("variables", "Variables", properties.Variables != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Variables) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnStage = class _CfnStage extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnStagePropsFromCloudFormation(resourceProperties), ret = new _CfnStage(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnStage.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_CfnStageProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnStage), error;
        }
        cdk.requireProperty(props, "restApiId", this), this.restApiId = props.restApiId, this.accessLogSetting = props.accessLogSetting, this.cacheClusterEnabled = props.cacheClusterEnabled, this.cacheClusterSize = props.cacheClusterSize, this.canarySetting = props.canarySetting, this.clientCertificateId = props.clientCertificateId, this.deploymentId = props.deploymentId, this.description = props.description, this.documentationVersion = props.documentationVersion, this.methodSettings = props.methodSettings, this.stageName = props.stageName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ApiGateway::Stage", props.tags, { tagPropertyName: "tags" }), this.tracingEnabled = props.tracingEnabled, this.variables = props.variables;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStage.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { restApiId: this.restApiId, accessLogSetting: this.accessLogSetting, cacheClusterEnabled: this.cacheClusterEnabled, cacheClusterSize: this.cacheClusterSize, canarySetting: this.canarySetting, clientCertificateId: this.clientCertificateId, deploymentId: this.deploymentId, description: this.description, documentationVersion: this.documentationVersion, methodSettings: this.methodSettings, stageName: this.stageName, tags: this.tags.renderTags(), tracingEnabled: this.tracingEnabled, variables: this.variables };
      }
      renderProperties(props) {
        return cfnStagePropsToCloudFormation(props);
      }
    };
    _r = JSII_RTTI_SYMBOL_1, CfnStage[_r] = { fqn: "aws-cdk-lib.aws_apigateway.CfnStage", version: "2.80.0" }, CfnStage.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGateway::Stage", exports2.CfnStage = CfnStage;
    function CfnStage_AccessLogSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationArn", cdk.validateString)(properties.destinationArn)), errors.collect(cdk.propertyValidator("format", cdk.validateString)(properties.format)), errors.wrap('supplied properties not correct for "AccessLogSettingProperty"');
    }
    function cfnStageAccessLogSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStage_AccessLogSettingPropertyValidator(properties).assertSuccess(), { DestinationArn: cdk.stringToCloudFormation(properties.destinationArn), Format: cdk.stringToCloudFormation(properties.format) }) : properties;
    }
    function CfnStageAccessLogSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationArn", "DestinationArn", properties.DestinationArn != null ? cfn_parse.FromCloudFormation.getString(properties.DestinationArn) : void 0), ret.addPropertyResult("format", "Format", properties.Format != null ? cfn_parse.FromCloudFormation.getString(properties.Format) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStage_CanarySettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deploymentId", cdk.validateString)(properties.deploymentId)), errors.collect(cdk.propertyValidator("percentTraffic", cdk.validateNumber)(properties.percentTraffic)), errors.collect(cdk.propertyValidator("stageVariableOverrides", cdk.hashValidator(cdk.validateString))(properties.stageVariableOverrides)), errors.collect(cdk.propertyValidator("useStageCache", cdk.validateBoolean)(properties.useStageCache)), errors.wrap('supplied properties not correct for "CanarySettingProperty"');
    }
    function cfnStageCanarySettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStage_CanarySettingPropertyValidator(properties).assertSuccess(), { DeploymentId: cdk.stringToCloudFormation(properties.deploymentId), PercentTraffic: cdk.numberToCloudFormation(properties.percentTraffic), StageVariableOverrides: cdk.hashMapper(cdk.stringToCloudFormation)(properties.stageVariableOverrides), UseStageCache: cdk.booleanToCloudFormation(properties.useStageCache) }) : properties;
    }
    function CfnStageCanarySettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deploymentId", "DeploymentId", properties.DeploymentId != null ? cfn_parse.FromCloudFormation.getString(properties.DeploymentId) : void 0), ret.addPropertyResult("percentTraffic", "PercentTraffic", properties.PercentTraffic != null ? cfn_parse.FromCloudFormation.getNumber(properties.PercentTraffic) : void 0), ret.addPropertyResult("stageVariableOverrides", "StageVariableOverrides", properties.StageVariableOverrides != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.StageVariableOverrides) : void 0), ret.addPropertyResult("useStageCache", "UseStageCache", properties.UseStageCache != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseStageCache) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStage_MethodSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cacheDataEncrypted", cdk.validateBoolean)(properties.cacheDataEncrypted)), errors.collect(cdk.propertyValidator("cacheTtlInSeconds", cdk.validateNumber)(properties.cacheTtlInSeconds)), errors.collect(cdk.propertyValidator("cachingEnabled", cdk.validateBoolean)(properties.cachingEnabled)), errors.collect(cdk.propertyValidator("dataTraceEnabled", cdk.validateBoolean)(properties.dataTraceEnabled)), errors.collect(cdk.propertyValidator("httpMethod", cdk.validateString)(properties.httpMethod)), errors.collect(cdk.propertyValidator("loggingLevel", cdk.validateString)(properties.loggingLevel)), errors.collect(cdk.propertyValidator("metricsEnabled", cdk.validateBoolean)(properties.metricsEnabled)), errors.collect(cdk.propertyValidator("resourcePath", cdk.validateString)(properties.resourcePath)), errors.collect(cdk.propertyValidator("throttlingBurstLimit", cdk.validateNumber)(properties.throttlingBurstLimit)), errors.collect(cdk.propertyValidator("throttlingRateLimit", cdk.validateNumber)(properties.throttlingRateLimit)), errors.wrap('supplied properties not correct for "MethodSettingProperty"');
    }
    function cfnStageMethodSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStage_MethodSettingPropertyValidator(properties).assertSuccess(), { CacheDataEncrypted: cdk.booleanToCloudFormation(properties.cacheDataEncrypted), CacheTtlInSeconds: cdk.numberToCloudFormation(properties.cacheTtlInSeconds), CachingEnabled: cdk.booleanToCloudFormation(properties.cachingEnabled), DataTraceEnabled: cdk.booleanToCloudFormation(properties.dataTraceEnabled), HttpMethod: cdk.stringToCloudFormation(properties.httpMethod), LoggingLevel: cdk.stringToCloudFormation(properties.loggingLevel), MetricsEnabled: cdk.booleanToCloudFormation(properties.metricsEnabled), ResourcePath: cdk.stringToCloudFormation(properties.resourcePath), ThrottlingBurstLimit: cdk.numberToCloudFormation(properties.throttlingBurstLimit), ThrottlingRateLimit: cdk.numberToCloudFormation(properties.throttlingRateLimit) }) : properties;
    }
    function CfnStageMethodSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cacheDataEncrypted", "CacheDataEncrypted", properties.CacheDataEncrypted != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CacheDataEncrypted) : void 0), ret.addPropertyResult("cacheTtlInSeconds", "CacheTtlInSeconds", properties.CacheTtlInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.CacheTtlInSeconds) : void 0), ret.addPropertyResult("cachingEnabled", "CachingEnabled", properties.CachingEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CachingEnabled) : void 0), ret.addPropertyResult("dataTraceEnabled", "DataTraceEnabled", properties.DataTraceEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DataTraceEnabled) : void 0), ret.addPropertyResult("httpMethod", "HttpMethod", properties.HttpMethod != null ? cfn_parse.FromCloudFormation.getString(properties.HttpMethod) : void 0), ret.addPropertyResult("loggingLevel", "LoggingLevel", properties.LoggingLevel != null ? cfn_parse.FromCloudFormation.getString(properties.LoggingLevel) : void 0), ret.addPropertyResult("metricsEnabled", "MetricsEnabled", properties.MetricsEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.MetricsEnabled) : void 0), ret.addPropertyResult("resourcePath", "ResourcePath", properties.ResourcePath != null ? cfn_parse.FromCloudFormation.getString(properties.ResourcePath) : void 0), ret.addPropertyResult("throttlingBurstLimit", "ThrottlingBurstLimit", properties.ThrottlingBurstLimit != null ? cfn_parse.FromCloudFormation.getNumber(properties.ThrottlingBurstLimit) : void 0), ret.addPropertyResult("throttlingRateLimit", "ThrottlingRateLimit", properties.ThrottlingRateLimit != null ? cfn_parse.FromCloudFormation.getNumber(properties.ThrottlingRateLimit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUsagePlanPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiStages", cdk.listValidator(CfnUsagePlan_ApiStagePropertyValidator))(properties.apiStages)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("quota", CfnUsagePlan_QuotaSettingsPropertyValidator)(properties.quota)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("throttle", CfnUsagePlan_ThrottleSettingsPropertyValidator)(properties.throttle)), errors.collect(cdk.propertyValidator("usagePlanName", cdk.validateString)(properties.usagePlanName)), errors.wrap('supplied properties not correct for "CfnUsagePlanProps"');
    }
    function cfnUsagePlanPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUsagePlanPropsValidator(properties).assertSuccess(), { ApiStages: cdk.listMapper(cfnUsagePlanApiStagePropertyToCloudFormation)(properties.apiStages), Description: cdk.stringToCloudFormation(properties.description), Quota: cfnUsagePlanQuotaSettingsPropertyToCloudFormation(properties.quota), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), Throttle: cfnUsagePlanThrottleSettingsPropertyToCloudFormation(properties.throttle), UsagePlanName: cdk.stringToCloudFormation(properties.usagePlanName) }) : properties;
    }
    function CfnUsagePlanPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiStages", "ApiStages", properties.ApiStages != null ? cfn_parse.FromCloudFormation.getArray(CfnUsagePlanApiStagePropertyFromCloudFormation)(properties.ApiStages) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("quota", "Quota", properties.Quota != null ? CfnUsagePlanQuotaSettingsPropertyFromCloudFormation(properties.Quota) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("throttle", "Throttle", properties.Throttle != null ? CfnUsagePlanThrottleSettingsPropertyFromCloudFormation(properties.Throttle) : void 0), ret.addPropertyResult("usagePlanName", "UsagePlanName", properties.UsagePlanName != null ? cfn_parse.FromCloudFormation.getString(properties.UsagePlanName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnUsagePlan = class _CfnUsagePlan extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnUsagePlanPropsFromCloudFormation(resourceProperties), ret = new _CfnUsagePlan(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnUsagePlan.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_CfnUsagePlanProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnUsagePlan), error;
        }
        this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.apiStages = props.apiStages, this.description = props.description, this.quota = props.quota, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ApiGateway::UsagePlan", props.tags, { tagPropertyName: "tags" }), this.throttle = props.throttle, this.usagePlanName = props.usagePlanName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnUsagePlan.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiStages: this.apiStages, description: this.description, quota: this.quota, tags: this.tags.renderTags(), throttle: this.throttle, usagePlanName: this.usagePlanName };
      }
      renderProperties(props) {
        return cfnUsagePlanPropsToCloudFormation(props);
      }
    };
    _s = JSII_RTTI_SYMBOL_1, CfnUsagePlan[_s] = { fqn: "aws-cdk-lib.aws_apigateway.CfnUsagePlan", version: "2.80.0" }, CfnUsagePlan.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGateway::UsagePlan", exports2.CfnUsagePlan = CfnUsagePlan;
    function CfnUsagePlan_ApiStagePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiId", cdk.validateString)(properties.apiId)), errors.collect(cdk.propertyValidator("stage", cdk.validateString)(properties.stage)), errors.collect(cdk.propertyValidator("throttle", cdk.hashValidator(CfnUsagePlan_ThrottleSettingsPropertyValidator))(properties.throttle)), errors.wrap('supplied properties not correct for "ApiStageProperty"');
    }
    function cfnUsagePlanApiStagePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUsagePlan_ApiStagePropertyValidator(properties).assertSuccess(), { ApiId: cdk.stringToCloudFormation(properties.apiId), Stage: cdk.stringToCloudFormation(properties.stage), Throttle: cdk.hashMapper(cfnUsagePlanThrottleSettingsPropertyToCloudFormation)(properties.throttle) }) : properties;
    }
    function CfnUsagePlanApiStagePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiId", "ApiId", properties.ApiId != null ? cfn_parse.FromCloudFormation.getString(properties.ApiId) : void 0), ret.addPropertyResult("stage", "Stage", properties.Stage != null ? cfn_parse.FromCloudFormation.getString(properties.Stage) : void 0), ret.addPropertyResult("throttle", "Throttle", properties.Throttle != null ? cfn_parse.FromCloudFormation.getMap(CfnUsagePlanThrottleSettingsPropertyFromCloudFormation)(properties.Throttle) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUsagePlan_QuotaSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("limit", cdk.validateNumber)(properties.limit)), errors.collect(cdk.propertyValidator("offset", cdk.validateNumber)(properties.offset)), errors.collect(cdk.propertyValidator("period", cdk.validateString)(properties.period)), errors.wrap('supplied properties not correct for "QuotaSettingsProperty"');
    }
    function cfnUsagePlanQuotaSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUsagePlan_QuotaSettingsPropertyValidator(properties).assertSuccess(), { Limit: cdk.numberToCloudFormation(properties.limit), Offset: cdk.numberToCloudFormation(properties.offset), Period: cdk.stringToCloudFormation(properties.period) }) : properties;
    }
    function CfnUsagePlanQuotaSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("limit", "Limit", properties.Limit != null ? cfn_parse.FromCloudFormation.getNumber(properties.Limit) : void 0), ret.addPropertyResult("offset", "Offset", properties.Offset != null ? cfn_parse.FromCloudFormation.getNumber(properties.Offset) : void 0), ret.addPropertyResult("period", "Period", properties.Period != null ? cfn_parse.FromCloudFormation.getString(properties.Period) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUsagePlan_ThrottleSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("burstLimit", cdk.validateNumber)(properties.burstLimit)), errors.collect(cdk.propertyValidator("rateLimit", cdk.validateNumber)(properties.rateLimit)), errors.wrap('supplied properties not correct for "ThrottleSettingsProperty"');
    }
    function cfnUsagePlanThrottleSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUsagePlan_ThrottleSettingsPropertyValidator(properties).assertSuccess(), { BurstLimit: cdk.numberToCloudFormation(properties.burstLimit), RateLimit: cdk.numberToCloudFormation(properties.rateLimit) }) : properties;
    }
    function CfnUsagePlanThrottleSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("burstLimit", "BurstLimit", properties.BurstLimit != null ? cfn_parse.FromCloudFormation.getNumber(properties.BurstLimit) : void 0), ret.addPropertyResult("rateLimit", "RateLimit", properties.RateLimit != null ? cfn_parse.FromCloudFormation.getNumber(properties.RateLimit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUsagePlanKeyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("keyId", cdk.requiredValidator)(properties.keyId)), errors.collect(cdk.propertyValidator("keyId", cdk.validateString)(properties.keyId)), errors.collect(cdk.propertyValidator("keyType", cdk.requiredValidator)(properties.keyType)), errors.collect(cdk.propertyValidator("keyType", cdk.validateString)(properties.keyType)), errors.collect(cdk.propertyValidator("usagePlanId", cdk.requiredValidator)(properties.usagePlanId)), errors.collect(cdk.propertyValidator("usagePlanId", cdk.validateString)(properties.usagePlanId)), errors.wrap('supplied properties not correct for "CfnUsagePlanKeyProps"');
    }
    function cfnUsagePlanKeyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUsagePlanKeyPropsValidator(properties).assertSuccess(), { KeyId: cdk.stringToCloudFormation(properties.keyId), KeyType: cdk.stringToCloudFormation(properties.keyType), UsagePlanId: cdk.stringToCloudFormation(properties.usagePlanId) }) : properties;
    }
    function CfnUsagePlanKeyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("keyId", "KeyId", cfn_parse.FromCloudFormation.getString(properties.KeyId)), ret.addPropertyResult("keyType", "KeyType", cfn_parse.FromCloudFormation.getString(properties.KeyType)), ret.addPropertyResult("usagePlanId", "UsagePlanId", cfn_parse.FromCloudFormation.getString(properties.UsagePlanId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnUsagePlanKey = class _CfnUsagePlanKey extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnUsagePlanKeyPropsFromCloudFormation(resourceProperties), ret = new _CfnUsagePlanKey(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnUsagePlanKey.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_CfnUsagePlanKeyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnUsagePlanKey), error;
        }
        cdk.requireProperty(props, "keyId", this), cdk.requireProperty(props, "keyType", this), cdk.requireProperty(props, "usagePlanId", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.keyId = props.keyId, this.keyType = props.keyType, this.usagePlanId = props.usagePlanId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnUsagePlanKey.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { keyId: this.keyId, keyType: this.keyType, usagePlanId: this.usagePlanId };
      }
      renderProperties(props) {
        return cfnUsagePlanKeyPropsToCloudFormation(props);
      }
    };
    _t = JSII_RTTI_SYMBOL_1, CfnUsagePlanKey[_t] = { fqn: "aws-cdk-lib.aws_apigateway.CfnUsagePlanKey", version: "2.80.0" }, CfnUsagePlanKey.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGateway::UsagePlanKey", exports2.CfnUsagePlanKey = CfnUsagePlanKey;
    function CfnVpcLinkPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("targetArns", cdk.requiredValidator)(properties.targetArns)), errors.collect(cdk.propertyValidator("targetArns", cdk.listValidator(cdk.validateString))(properties.targetArns)), errors.wrap('supplied properties not correct for "CfnVpcLinkProps"');
    }
    function cfnVpcLinkPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVpcLinkPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), TargetArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.targetArns), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnVpcLinkPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("targetArns", "TargetArns", cfn_parse.FromCloudFormation.getStringArray(properties.TargetArns)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVpcLink = class _CfnVpcLink extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVpcLinkPropsFromCloudFormation(resourceProperties), ret = new _CfnVpcLink(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVpcLink.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_CfnVpcLinkProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVpcLink), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "targetArns", this), this.attrVpcLinkId = cdk.Token.asString(this.getAtt("VpcLinkId", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.targetArns = props.targetArns, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ApiGateway::VpcLink", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVpcLink.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, targetArns: this.targetArns, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnVpcLinkPropsToCloudFormation(props);
      }
    };
    _u = JSII_RTTI_SYMBOL_1, CfnVpcLink[_u] = { fqn: "aws-cdk-lib.aws_apigateway.CfnVpcLink", version: "2.80.0" }, CfnVpcLink.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGateway::VpcLink", exports2.CfnVpcLink = CfnVpcLink;
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/json-schema.js
var require_json_schema = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/json-schema.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.JsonSchemaType = exports2.JsonSchemaVersion = void 0;
    var JsonSchemaVersion;
    (function(JsonSchemaVersion2) {
      JsonSchemaVersion2.DRAFT4 = "http://json-schema.org/draft-04/schema#", JsonSchemaVersion2.DRAFT7 = "http://json-schema.org/draft-07/schema#";
    })(JsonSchemaVersion = exports2.JsonSchemaVersion || (exports2.JsonSchemaVersion = {}));
    var JsonSchemaType;
    (function(JsonSchemaType2) {
      JsonSchemaType2.NULL = "null", JsonSchemaType2.BOOLEAN = "boolean", JsonSchemaType2.OBJECT = "object", JsonSchemaType2.ARRAY = "array", JsonSchemaType2.NUMBER = "number", JsonSchemaType2.INTEGER = "integer", JsonSchemaType2.STRING = "string";
    })(JsonSchemaType = exports2.JsonSchemaType || (exports2.JsonSchemaType = {}));
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/util.js
var require_util13 = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/util.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.JsonSchemaMapper = exports2.validateDouble = exports2.validateInteger = exports2.parseAwsApiCall = exports2.parseMethodOptionsPath = exports2.validateHttpMethod = exports2.ALL_METHODS = void 0;
    var url_1 = require("url");
    var jsonSchema = require_json_schema();
    exports2.ALL_METHODS = ["OPTIONS", "GET", "PUT", "POST", "DELETE", "PATCH", "HEAD"];
    var ALLOWED_METHODS = ["ANY", ...exports2.ALL_METHODS];
    function validateHttpMethod(method, messagePrefix = "") {
      if (!ALLOWED_METHODS.includes(method))
        throw new Error(`${messagePrefix}Invalid HTTP method "${method}". Allowed methods: ${ALLOWED_METHODS.join(",")}`);
    }
    exports2.validateHttpMethod = validateHttpMethod;
    function parseMethodOptionsPath(originalPath) {
      if (!originalPath.startsWith("/"))
        throw new Error(`Method options path must start with '/': ${originalPath}`);
      const path = originalPath.slice(1), components = path.split("/");
      if (components.length < 2)
        throw new Error(`Method options path must include at least two components: /{resource}/{method} (i.e. /foo/bar/GET): ${path}`);
      const httpMethod = components.pop().toUpperCase();
      httpMethod !== "*" && validateHttpMethod(httpMethod, `${originalPath}: `);
      let resourcePath = "/~1" + components.join("~1");
      return components.length === 1 && components[0] === "*" ? resourcePath = "/*" : components.length === 1 && components[0] === "" && (resourcePath = "/"), { httpMethod, resourcePath };
    }
    exports2.parseMethodOptionsPath = parseMethodOptionsPath;
    function parseAwsApiCall(path, action, actionParams) {
      if (actionParams && !action)
        throw new Error('"actionParams" requires that "action" will be set');
      if (path && action)
        throw new Error(`"path" and "action" are mutually exclusive (path="${path}", action="${action}")`);
      if (path)
        return { apiType: "path", apiValue: path };
      if (action)
        return actionParams && (action += "&" + (0, url_1.format)({ query: actionParams }).slice(1)), { apiType: "action", apiValue: action };
      throw new Error('Either "path" or "action" are required');
    }
    exports2.parseAwsApiCall = parseAwsApiCall;
    function validateInteger(property, messagePrefix) {
      if (property && !Number.isInteger(property))
        throw new Error(`${messagePrefix} should be an integer`);
    }
    exports2.validateInteger = validateInteger;
    function validateDouble(property, messagePrefix) {
      if (property && isNaN(property) && isNaN(parseFloat(property.toString())))
        throw new Error(`${messagePrefix} should be an double`);
    }
    exports2.validateDouble = validateDouble;
    var JsonSchemaMapper = class _JsonSchemaMapper {
      static toCfnJsonSchema(schema) {
        const result = _JsonSchemaMapper._toCfnJsonSchema(schema);
        return "$schema" in result || (result.$schema = jsonSchema.JsonSchemaVersion.DRAFT4), result;
      }
      static _toCfnJsonSchema(schema, preserveKeys = false) {
        return schema == null || typeof schema != "object" ? schema : Array.isArray(schema) ? schema.map((entry) => _JsonSchemaMapper._toCfnJsonSchema(entry)) : Object.assign({}, ...Object.entries(schema).map(([key, value]) => {
          const newKey = !preserveKeys && key in _JsonSchemaMapper.SchemaPropsWithPrefix ? _JsonSchemaMapper.SchemaPropsWithPrefix[key] : key, newValue = _JsonSchemaMapper._toCfnJsonSchema(value, !preserveKeys && _JsonSchemaMapper.SchemaPropsWithUserDefinedChildren[key]);
          return { [newKey]: newValue };
        }));
      }
    };
    JsonSchemaMapper.SchemaPropsWithPrefix = { schema: "$schema", ref: "$ref" }, JsonSchemaMapper.SchemaPropsWithUserDefinedChildren = { definitions: true, properties: true, patternProperties: true, dependencies: true }, exports2.JsonSchemaMapper = JsonSchemaMapper;
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/usage-plan.js
var require_usage_plan = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/usage-plan.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.UsagePlan = exports2.Period = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var apigateway_generated_1 = require_apigateway_generated();
    var util_1 = require_util13();
    var core_1 = require_core2();
    var cx_api_1 = require_cx_api();
    var Period;
    (function(Period2) {
      Period2.DAY = "DAY", Period2.WEEK = "WEEK", Period2.MONTH = "MONTH";
    })(Period = exports2.Period || (exports2.Period = {}));
    var UsagePlanBase = class extends core_1.Resource {
      addApiKey(apiKey, options) {
        let id;
        const prefix = "UsagePlanKeyResource";
        core_1.FeatureFlags.of(this).isEnabled(cx_api_1.APIGATEWAY_USAGEPLANKEY_ORDERINSENSITIVE_ID) ? id = `${prefix}:${core_1.Names.nodeUniqueId(apiKey.node)}` : id = this.node.tryFindChild(prefix) ? `${prefix}:${core_1.Names.nodeUniqueId(apiKey.node)}` : prefix;
        const resource = new apigateway_generated_1.CfnUsagePlanKey(this, id, { keyId: apiKey.keyId, keyType: "API_KEY", usagePlanId: this.usagePlanId });
        options?.overrideLogicalId && resource.overrideLogicalId(options?.overrideLogicalId);
      }
    };
    var UsagePlan = class _UsagePlan extends UsagePlanBase {
      static fromUsagePlanId(scope, id, usagePlanId) {
        class Import extends UsagePlanBase {
          constructor() {
            super(scope, id), this.usagePlanId = usagePlanId;
          }
        }
        return new Import();
      }
      constructor(scope, id, props = {}) {
        super(scope, id), this.apiStages = new Array();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_UsagePlanProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _UsagePlan), error;
        }
        let resource;
        resource = new apigateway_generated_1.CfnUsagePlan(this, "Resource", { apiStages: core_1.Lazy.any({ produce: () => this.renderApiStages(this.apiStages) }), description: props.description, quota: this.renderQuota(props), throttle: this.renderThrottle(props.throttle), usagePlanName: props.name }), this.apiStages.push(...props.apiStages || []), this.usagePlanId = resource.ref, props.apiKey && this.addApiKey(props.apiKey);
      }
      addApiStage(apiStage) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_UsagePlanPerApiStage(apiStage);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addApiStage), error;
        }
        this.apiStages.push(apiStage);
      }
      renderApiStages(apiStages) {
        if (apiStages && apiStages.length > 0) {
          const stages = [];
          return apiStages.forEach((apiStage) => {
            stages.push(this.createStage(apiStage));
          }), stages;
        }
      }
      createStage(apiStage) {
        const stage = apiStage.stage ? apiStage.stage.stageName.toString() : void 0, apiId = apiStage.stage ? apiStage.stage.restApi.restApiId : void 0, throttle = this.renderThrottlePerMethod(apiStage.throttle);
        return { apiId, stage, throttle };
      }
      renderQuota(props) {
        if (props.quota !== void 0) {
          const limit = props.quota ? props.quota.limit : void 0;
          return (0, util_1.validateInteger)(limit, "Throttle quota limit"), { limit: limit || void 0, offset: props.quota ? props.quota.offset : void 0, period: props.quota ? props.quota.period : void 0 };
        }
      }
      renderThrottle(props) {
        let ret;
        if (props !== void 0) {
          const burstLimit = props.burstLimit;
          (0, util_1.validateInteger)(burstLimit, "Throttle burst limit");
          const rateLimit = props.rateLimit;
          (0, util_1.validateDouble)(rateLimit, "Throttle rate limit"), ret = { burstLimit, rateLimit };
        }
        return ret;
      }
      renderThrottlePerMethod(throttlePerMethod) {
        const ret = {};
        return throttlePerMethod && throttlePerMethod.length > 0 && throttlePerMethod.forEach((value) => {
          const method = value.method, methodId = `${method.resource.path}/${method.httpMethod}`;
          ret[methodId] = this.renderThrottle(value.throttle);
        }), ret;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, UsagePlan[_a] = { fqn: "aws-cdk-lib.aws_apigateway.UsagePlan", version: "2.80.0" }, exports2.UsagePlan = UsagePlan;
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/api-key.js
var require_api_key = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/api-key.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.RateLimitedApiKey = exports2.ApiKey = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var apigateway_generated_1 = require_apigateway_generated();
    var usage_plan_1 = require_usage_plan();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var ApiKeyBase = class extends core_1.Resource {
      grantRead(grantee) {
        return iam.Grant.addToPrincipal({ grantee, actions: readPermissions, resourceArns: [this.keyArn] });
      }
      grantWrite(grantee) {
        return iam.Grant.addToPrincipal({ grantee, actions: writePermissions, resourceArns: [this.keyArn] });
      }
      grantReadWrite(grantee) {
        return iam.Grant.addToPrincipal({ grantee, actions: [...readPermissions, ...writePermissions], resourceArns: [this.keyArn] });
      }
    };
    var ApiKey = class _ApiKey extends ApiKeyBase {
      static fromApiKeyId(scope, id, apiKeyId) {
        class Import extends ApiKeyBase {
          constructor() {
            super(...arguments), this.keyId = apiKeyId, this.keyArn = core_1.Stack.of(this).formatArn({ service: "apigateway", account: "", resource: "/apikeys", arnFormat: core_1.ArnFormat.SLASH_RESOURCE_NAME, resourceName: apiKeyId });
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.apiKeyName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_ApiKeyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ApiKey), error;
        }
        const resource = new apigateway_generated_1.CfnApiKey(this, "Resource", { customerId: props.customerId, description: props.description, enabled: props.enabled ?? true, generateDistinctId: props.generateDistinctId, name: this.physicalName, stageKeys: this.renderStageKeys(props.resources, props.stages), value: props.value });
        this.keyId = resource.ref, this.keyArn = core_1.Stack.of(this).formatArn({ service: "apigateway", account: "", resource: "/apikeys", arnFormat: core_1.ArnFormat.SLASH_RESOURCE_NAME, resourceName: this.keyId });
      }
      renderStageKeys(resources, stages) {
        if (!(!resources && !stages)) {
          if (resources && stages)
            throw new Error('Only one of "resources" or "stages" should be provided');
          return resources ? resources.map((resource) => {
            const restApi = resource;
            if (!restApi.deploymentStage)
              throw new Error(`Cannot add an ApiKey to a RestApi that does not contain a "deploymentStage".
Either set the RestApi.deploymentStage or create an ApiKey from a Stage`);
            const restApiId = restApi.restApiId, stageName = restApi.deploymentStage.stageName.toString();
            return { restApiId, stageName };
          }) : stages ? stages.map((stage) => ({ restApiId: stage.restApi.restApiId, stageName: stage.stageName })) : void 0;
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ApiKey[_a] = { fqn: "aws-cdk-lib.aws_apigateway.ApiKey", version: "2.80.0" }, exports2.ApiKey = ApiKey;
    var RateLimitedApiKey = class _RateLimitedApiKey extends ApiKeyBase {
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.apiKeyName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_RateLimitedApiKeyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _RateLimitedApiKey), error;
        }
        const resource = new ApiKey(this, "Resource", props);
        (props.apiStages || props.quota || props.throttle) && new usage_plan_1.UsagePlan(this, "UsagePlanResource", { apiStages: props.apiStages, quota: props.quota, throttle: props.throttle }).addApiKey(resource), this.keyId = resource.keyId, this.keyArn = resource.keyArn;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, RateLimitedApiKey[_b] = { fqn: "aws-cdk-lib.aws_apigateway.RateLimitedApiKey", version: "2.80.0" }, exports2.RateLimitedApiKey = RateLimitedApiKey;
    var readPermissions = ["apigateway:GET"];
    var writePermissions = ["apigateway:POST", "apigateway:PUT", "apigateway:PATCH", "apigateway:DELETE"];
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/apigateway-canned-metrics.generated.js
var require_apigateway_canned_metrics_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/apigateway-canned-metrics.generated.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ApiGatewayMetrics = void 0;
    var ApiGatewayMetrics = class {
      static _4XxErrorSum(dimensions) {
        return { namespace: "AWS/ApiGateway", metricName: "4XXError", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static _5XxErrorSum(dimensions) {
        return { namespace: "AWS/ApiGateway", metricName: "5XXError", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static cacheHitCountSum(dimensions) {
        return { namespace: "AWS/ApiGateway", metricName: "CacheHitCount", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static cacheMissCountSum(dimensions) {
        return { namespace: "AWS/ApiGateway", metricName: "CacheMissCount", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static countSum(dimensions) {
        return { namespace: "AWS/ApiGateway", metricName: "Count", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static integrationLatencyAverage(dimensions) {
        return { namespace: "AWS/ApiGateway", metricName: "IntegrationLatency", dimensionsMap: dimensions, statistic: "Average" };
      }
      static latencyAverage(dimensions) {
        return { namespace: "AWS/ApiGateway", metricName: "Latency", dimensionsMap: dimensions, statistic: "Average" };
      }
    };
    exports2.ApiGatewayMetrics = ApiGatewayMetrics;
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/deployment.js
var require_deployment = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/deployment.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Deployment = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var apigateway_generated_1 = require_apigateway_generated();
    var restapi_1 = require_restapi();
    var core_1 = require_core2();
    var helpers_internal_1 = require_helpers_internal();
    var Deployment = class _Deployment extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_DeploymentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Deployment), error;
        }
        this.resource = new LatestDeploymentResource(this, "Resource", { description: props.description, restApi: props.api }), props.retainDeployments && this.resource.applyRemovalPolicy(core_1.RemovalPolicy.RETAIN), this.api = props.api, this.deploymentId = core_1.Lazy.string({ produce: () => this.resource.ref }), props.api instanceof restapi_1.RestApiBase && props.api._attachDeployment(this);
      }
      addToLogicalId(data) {
        this.resource.addToLogicalId(data);
      }
      _addMethodDependency(method) {
        this.node.addDependency(method.node.defaultChild);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Deployment[_a] = { fqn: "aws-cdk-lib.aws_apigateway.Deployment", version: "2.80.0" }, exports2.Deployment = Deployment;
    var LatestDeploymentResource = class extends apigateway_generated_1.CfnDeployment {
      constructor(scope, id, props) {
        super(scope, id, { description: props.description, restApiId: props.restApi.restApiId }), this.hashComponents = new Array(), this.api = props.restApi, this.originalLogicalId = this.stack.getLogicalId(this), this.overrideLogicalId(core_1.Lazy.uncachedString({ produce: () => this.calculateLogicalId() }));
      }
      addToLogicalId(data) {
        if (this.node.locked)
          throw new Error("Cannot modify the logical ID when the construct is locked");
        this.hashComponents.push(data);
      }
      calculateLogicalId() {
        const hash = [...this.hashComponents];
        if (this.api instanceof restapi_1.RestApi || this.api instanceof restapi_1.SpecRestApi) {
          const cfnRestApiCF = this.api.node.defaultChild._toCloudFormation();
          hash.push(this.stack.resolve(cfnRestApiCF));
        }
        let lid = this.originalLogicalId;
        return hash.length > 0 && (lid += (0, helpers_internal_1.md5hash)(hash.map((x) => this.stack.resolve(x)).map((c) => JSON.stringify(c)).join(""))), lid;
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/base-path-mapping.js
var require_base_path_mapping = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/base-path-mapping.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.BasePathMapping = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var apigateway_generated_1 = require_apigateway_generated();
    var restapi_1 = require_restapi();
    var core_1 = require_core2();
    var BasePathMapping = class _BasePathMapping extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_BasePathMappingProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _BasePathMapping), error;
        }
        if (props.basePath && !core_1.Token.isUnresolved(props.basePath)) {
          if (props.basePath.startsWith("/") || props.basePath.endsWith("/"))
            throw new Error(`A base path cannot start or end with /", received: ${props.basePath}`);
          if (props.basePath.match(/\/{2,}/))
            throw new Error(`A base path cannot have more than one consecutive /", received: ${props.basePath}`);
          if (!props.basePath.match(/^[a-zA-Z0-9$_.+!*'()-/]+$/))
            throw new Error(`A base path may only contain letters, numbers, and one of "$-_.+!*'()/", received: ${props.basePath}`);
        }
        const attachToStage = props.attachToStage ?? true, stage = props.stage ?? (props.restApi instanceof restapi_1.RestApiBase && attachToStage ? props.restApi.deploymentStage : void 0);
        new apigateway_generated_1.CfnBasePathMapping(this, "Resource", { basePath: props.basePath, domainName: props.domainName.domainName, restApiId: props.restApi.restApiId, stage: stage?.stageName });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, BasePathMapping[_a] = { fqn: "aws-cdk-lib.aws_apigateway.BasePathMapping", version: "2.80.0" }, exports2.BasePathMapping = BasePathMapping;
  }
});

// node_modules/aws-cdk-lib/aws-apigatewayv2/lib/apigatewayv2.generated.js
var require_apigatewayv2_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigatewayv2/lib/apigatewayv2.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    var _l;
    var _m;
    var _o;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnVpcLink = exports2.CfnStage = exports2.CfnRouteResponse = exports2.CfnRoute = exports2.CfnModel = exports2.CfnIntegrationResponse = exports2.CfnIntegration = exports2.CfnDomainName = exports2.CfnDeployment = exports2.CfnAuthorizer = exports2.CfnApiMapping = exports2.CfnApiGatewayManagedOverrides = exports2.CfnApi = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnApiPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiKeySelectionExpression", cdk.validateString)(properties.apiKeySelectionExpression)), errors.collect(cdk.propertyValidator("basePath", cdk.validateString)(properties.basePath)), errors.collect(cdk.propertyValidator("body", cdk.validateObject)(properties.body)), errors.collect(cdk.propertyValidator("bodyS3Location", CfnApi_BodyS3LocationPropertyValidator)(properties.bodyS3Location)), errors.collect(cdk.propertyValidator("corsConfiguration", CfnApi_CorsPropertyValidator)(properties.corsConfiguration)), errors.collect(cdk.propertyValidator("credentialsArn", cdk.validateString)(properties.credentialsArn)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("disableExecuteApiEndpoint", cdk.validateBoolean)(properties.disableExecuteApiEndpoint)), errors.collect(cdk.propertyValidator("disableSchemaValidation", cdk.validateBoolean)(properties.disableSchemaValidation)), errors.collect(cdk.propertyValidator("failOnWarnings", cdk.validateBoolean)(properties.failOnWarnings)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("protocolType", cdk.validateString)(properties.protocolType)), errors.collect(cdk.propertyValidator("routeKey", cdk.validateString)(properties.routeKey)), errors.collect(cdk.propertyValidator("routeSelectionExpression", cdk.validateString)(properties.routeSelectionExpression)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.collect(cdk.propertyValidator("target", cdk.validateString)(properties.target)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "CfnApiProps"');
    }
    function cfnApiPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApiPropsValidator(properties).assertSuccess(), { ApiKeySelectionExpression: cdk.stringToCloudFormation(properties.apiKeySelectionExpression), BasePath: cdk.stringToCloudFormation(properties.basePath), Body: cdk.objectToCloudFormation(properties.body), BodyS3Location: cfnApiBodyS3LocationPropertyToCloudFormation(properties.bodyS3Location), CorsConfiguration: cfnApiCorsPropertyToCloudFormation(properties.corsConfiguration), CredentialsArn: cdk.stringToCloudFormation(properties.credentialsArn), Description: cdk.stringToCloudFormation(properties.description), DisableExecuteApiEndpoint: cdk.booleanToCloudFormation(properties.disableExecuteApiEndpoint), DisableSchemaValidation: cdk.booleanToCloudFormation(properties.disableSchemaValidation), FailOnWarnings: cdk.booleanToCloudFormation(properties.failOnWarnings), Name: cdk.stringToCloudFormation(properties.name), ProtocolType: cdk.stringToCloudFormation(properties.protocolType), RouteKey: cdk.stringToCloudFormation(properties.routeKey), RouteSelectionExpression: cdk.stringToCloudFormation(properties.routeSelectionExpression), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags), Target: cdk.stringToCloudFormation(properties.target), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnApiPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiKeySelectionExpression", "ApiKeySelectionExpression", properties.ApiKeySelectionExpression != null ? cfn_parse.FromCloudFormation.getString(properties.ApiKeySelectionExpression) : void 0), ret.addPropertyResult("basePath", "BasePath", properties.BasePath != null ? cfn_parse.FromCloudFormation.getString(properties.BasePath) : void 0), ret.addPropertyResult("body", "Body", properties.Body != null ? cfn_parse.FromCloudFormation.getAny(properties.Body) : void 0), ret.addPropertyResult("bodyS3Location", "BodyS3Location", properties.BodyS3Location != null ? CfnApiBodyS3LocationPropertyFromCloudFormation(properties.BodyS3Location) : void 0), ret.addPropertyResult("corsConfiguration", "CorsConfiguration", properties.CorsConfiguration != null ? CfnApiCorsPropertyFromCloudFormation(properties.CorsConfiguration) : void 0), ret.addPropertyResult("credentialsArn", "CredentialsArn", properties.CredentialsArn != null ? cfn_parse.FromCloudFormation.getString(properties.CredentialsArn) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("disableExecuteApiEndpoint", "DisableExecuteApiEndpoint", properties.DisableExecuteApiEndpoint != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DisableExecuteApiEndpoint) : void 0), ret.addPropertyResult("disableSchemaValidation", "DisableSchemaValidation", properties.DisableSchemaValidation != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DisableSchemaValidation) : void 0), ret.addPropertyResult("failOnWarnings", "FailOnWarnings", properties.FailOnWarnings != null ? cfn_parse.FromCloudFormation.getBoolean(properties.FailOnWarnings) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("protocolType", "ProtocolType", properties.ProtocolType != null ? cfn_parse.FromCloudFormation.getString(properties.ProtocolType) : void 0), ret.addPropertyResult("routeKey", "RouteKey", properties.RouteKey != null ? cfn_parse.FromCloudFormation.getString(properties.RouteKey) : void 0), ret.addPropertyResult("routeSelectionExpression", "RouteSelectionExpression", properties.RouteSelectionExpression != null ? cfn_parse.FromCloudFormation.getString(properties.RouteSelectionExpression) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addPropertyResult("target", "Target", properties.Target != null ? cfn_parse.FromCloudFormation.getString(properties.Target) : void 0), ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getString(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApi = class _CfnApi extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApiPropsFromCloudFormation(resourceProperties), ret = new _CfnApi(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnApi.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigatewayv2_CfnApiProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApi), error;
        }
        this.attrApiEndpoint = cdk.Token.asString(this.getAtt("ApiEndpoint", cdk.ResolutionTypeHint.STRING)), this.attrApiId = cdk.Token.asString(this.getAtt("ApiId", cdk.ResolutionTypeHint.STRING)), this.apiKeySelectionExpression = props.apiKeySelectionExpression, this.basePath = props.basePath, this.body = props.body, this.bodyS3Location = props.bodyS3Location, this.corsConfiguration = props.corsConfiguration, this.credentialsArn = props.credentialsArn, this.description = props.description, this.disableExecuteApiEndpoint = props.disableExecuteApiEndpoint, this.disableSchemaValidation = props.disableSchemaValidation, this.failOnWarnings = props.failOnWarnings, this.name = props.name, this.protocolType = props.protocolType, this.routeKey = props.routeKey, this.routeSelectionExpression = props.routeSelectionExpression, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::ApiGatewayV2::Api", props.tags, { tagPropertyName: "tags" }), this.target = props.target, this.version = props.version;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApi.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiKeySelectionExpression: this.apiKeySelectionExpression, basePath: this.basePath, body: this.body, bodyS3Location: this.bodyS3Location, corsConfiguration: this.corsConfiguration, credentialsArn: this.credentialsArn, description: this.description, disableExecuteApiEndpoint: this.disableExecuteApiEndpoint, disableSchemaValidation: this.disableSchemaValidation, failOnWarnings: this.failOnWarnings, name: this.name, protocolType: this.protocolType, routeKey: this.routeKey, routeSelectionExpression: this.routeSelectionExpression, tags: this.tags.renderTags(), target: this.target, version: this.version };
      }
      renderProperties(props) {
        return cfnApiPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnApi[_a] = { fqn: "aws-cdk-lib.aws_apigatewayv2.CfnApi", version: "2.80.0" }, CfnApi.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGatewayV2::Api", exports2.CfnApi = CfnApi;
    function CfnApi_BodyS3LocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("etag", cdk.validateString)(properties.etag)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "BodyS3LocationProperty"');
    }
    function cfnApiBodyS3LocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApi_BodyS3LocationPropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), Etag: cdk.stringToCloudFormation(properties.etag), Key: cdk.stringToCloudFormation(properties.key), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnApiBodyS3LocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", properties.Bucket != null ? cfn_parse.FromCloudFormation.getString(properties.Bucket) : void 0), ret.addPropertyResult("etag", "Etag", properties.Etag != null ? cfn_parse.FromCloudFormation.getString(properties.Etag) : void 0), ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getString(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApi_CorsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowCredentials", cdk.validateBoolean)(properties.allowCredentials)), errors.collect(cdk.propertyValidator("allowHeaders", cdk.listValidator(cdk.validateString))(properties.allowHeaders)), errors.collect(cdk.propertyValidator("allowMethods", cdk.listValidator(cdk.validateString))(properties.allowMethods)), errors.collect(cdk.propertyValidator("allowOrigins", cdk.listValidator(cdk.validateString))(properties.allowOrigins)), errors.collect(cdk.propertyValidator("exposeHeaders", cdk.listValidator(cdk.validateString))(properties.exposeHeaders)), errors.collect(cdk.propertyValidator("maxAge", cdk.validateNumber)(properties.maxAge)), errors.wrap('supplied properties not correct for "CorsProperty"');
    }
    function cfnApiCorsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApi_CorsPropertyValidator(properties).assertSuccess(), { AllowCredentials: cdk.booleanToCloudFormation(properties.allowCredentials), AllowHeaders: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowHeaders), AllowMethods: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowMethods), AllowOrigins: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowOrigins), ExposeHeaders: cdk.listMapper(cdk.stringToCloudFormation)(properties.exposeHeaders), MaxAge: cdk.numberToCloudFormation(properties.maxAge) }) : properties;
    }
    function CfnApiCorsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowCredentials", "AllowCredentials", properties.AllowCredentials != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllowCredentials) : void 0), ret.addPropertyResult("allowHeaders", "AllowHeaders", properties.AllowHeaders != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AllowHeaders) : void 0), ret.addPropertyResult("allowMethods", "AllowMethods", properties.AllowMethods != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AllowMethods) : void 0), ret.addPropertyResult("allowOrigins", "AllowOrigins", properties.AllowOrigins != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AllowOrigins) : void 0), ret.addPropertyResult("exposeHeaders", "ExposeHeaders", properties.ExposeHeaders != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExposeHeaders) : void 0), ret.addPropertyResult("maxAge", "MaxAge", properties.MaxAge != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxAge) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApiGatewayManagedOverridesPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiId", cdk.requiredValidator)(properties.apiId)), errors.collect(cdk.propertyValidator("apiId", cdk.validateString)(properties.apiId)), errors.collect(cdk.propertyValidator("integration", CfnApiGatewayManagedOverrides_IntegrationOverridesPropertyValidator)(properties.integration)), errors.collect(cdk.propertyValidator("route", CfnApiGatewayManagedOverrides_RouteOverridesPropertyValidator)(properties.route)), errors.collect(cdk.propertyValidator("stage", CfnApiGatewayManagedOverrides_StageOverridesPropertyValidator)(properties.stage)), errors.wrap('supplied properties not correct for "CfnApiGatewayManagedOverridesProps"');
    }
    function cfnApiGatewayManagedOverridesPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApiGatewayManagedOverridesPropsValidator(properties).assertSuccess(), { ApiId: cdk.stringToCloudFormation(properties.apiId), Integration: cfnApiGatewayManagedOverridesIntegrationOverridesPropertyToCloudFormation(properties.integration), Route: cfnApiGatewayManagedOverridesRouteOverridesPropertyToCloudFormation(properties.route), Stage: cfnApiGatewayManagedOverridesStageOverridesPropertyToCloudFormation(properties.stage) }) : properties;
    }
    function CfnApiGatewayManagedOverridesPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiId", "ApiId", cfn_parse.FromCloudFormation.getString(properties.ApiId)), ret.addPropertyResult("integration", "Integration", properties.Integration != null ? CfnApiGatewayManagedOverridesIntegrationOverridesPropertyFromCloudFormation(properties.Integration) : void 0), ret.addPropertyResult("route", "Route", properties.Route != null ? CfnApiGatewayManagedOverridesRouteOverridesPropertyFromCloudFormation(properties.Route) : void 0), ret.addPropertyResult("stage", "Stage", properties.Stage != null ? CfnApiGatewayManagedOverridesStageOverridesPropertyFromCloudFormation(properties.Stage) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApiGatewayManagedOverrides = class _CfnApiGatewayManagedOverrides extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApiGatewayManagedOverridesPropsFromCloudFormation(resourceProperties), ret = new _CfnApiGatewayManagedOverrides(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApiGatewayManagedOverrides.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigatewayv2_CfnApiGatewayManagedOverridesProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApiGatewayManagedOverrides), error;
        }
        cdk.requireProperty(props, "apiId", this), this.apiId = props.apiId, this.integration = props.integration, this.route = props.route, this.stage = props.stage;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApiGatewayManagedOverrides.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiId: this.apiId, integration: this.integration, route: this.route, stage: this.stage };
      }
      renderProperties(props) {
        return cfnApiGatewayManagedOverridesPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnApiGatewayManagedOverrides[_b] = { fqn: "aws-cdk-lib.aws_apigatewayv2.CfnApiGatewayManagedOverrides", version: "2.80.0" }, CfnApiGatewayManagedOverrides.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGatewayV2::ApiGatewayManagedOverrides", exports2.CfnApiGatewayManagedOverrides = CfnApiGatewayManagedOverrides;
    function CfnApiGatewayManagedOverrides_AccessLogSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationArn", cdk.validateString)(properties.destinationArn)), errors.collect(cdk.propertyValidator("format", cdk.validateString)(properties.format)), errors.wrap('supplied properties not correct for "AccessLogSettingsProperty"');
    }
    function cfnApiGatewayManagedOverridesAccessLogSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApiGatewayManagedOverrides_AccessLogSettingsPropertyValidator(properties).assertSuccess(), { DestinationArn: cdk.stringToCloudFormation(properties.destinationArn), Format: cdk.stringToCloudFormation(properties.format) }) : properties;
    }
    function CfnApiGatewayManagedOverridesAccessLogSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationArn", "DestinationArn", properties.DestinationArn != null ? cfn_parse.FromCloudFormation.getString(properties.DestinationArn) : void 0), ret.addPropertyResult("format", "Format", properties.Format != null ? cfn_parse.FromCloudFormation.getString(properties.Format) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApiGatewayManagedOverrides_IntegrationOverridesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("integrationMethod", cdk.validateString)(properties.integrationMethod)), errors.collect(cdk.propertyValidator("payloadFormatVersion", cdk.validateString)(properties.payloadFormatVersion)), errors.collect(cdk.propertyValidator("timeoutInMillis", cdk.validateNumber)(properties.timeoutInMillis)), errors.wrap('supplied properties not correct for "IntegrationOverridesProperty"');
    }
    function cfnApiGatewayManagedOverridesIntegrationOverridesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApiGatewayManagedOverrides_IntegrationOverridesPropertyValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), IntegrationMethod: cdk.stringToCloudFormation(properties.integrationMethod), PayloadFormatVersion: cdk.stringToCloudFormation(properties.payloadFormatVersion), TimeoutInMillis: cdk.numberToCloudFormation(properties.timeoutInMillis) }) : properties;
    }
    function CfnApiGatewayManagedOverridesIntegrationOverridesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("integrationMethod", "IntegrationMethod", properties.IntegrationMethod != null ? cfn_parse.FromCloudFormation.getString(properties.IntegrationMethod) : void 0), ret.addPropertyResult("payloadFormatVersion", "PayloadFormatVersion", properties.PayloadFormatVersion != null ? cfn_parse.FromCloudFormation.getString(properties.PayloadFormatVersion) : void 0), ret.addPropertyResult("timeoutInMillis", "TimeoutInMillis", properties.TimeoutInMillis != null ? cfn_parse.FromCloudFormation.getNumber(properties.TimeoutInMillis) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApiGatewayManagedOverrides_RouteOverridesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authorizationScopes", cdk.listValidator(cdk.validateString))(properties.authorizationScopes)), errors.collect(cdk.propertyValidator("authorizationType", cdk.validateString)(properties.authorizationType)), errors.collect(cdk.propertyValidator("authorizerId", cdk.validateString)(properties.authorizerId)), errors.collect(cdk.propertyValidator("operationName", cdk.validateString)(properties.operationName)), errors.collect(cdk.propertyValidator("target", cdk.validateString)(properties.target)), errors.wrap('supplied properties not correct for "RouteOverridesProperty"');
    }
    function cfnApiGatewayManagedOverridesRouteOverridesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApiGatewayManagedOverrides_RouteOverridesPropertyValidator(properties).assertSuccess(), { AuthorizationScopes: cdk.listMapper(cdk.stringToCloudFormation)(properties.authorizationScopes), AuthorizationType: cdk.stringToCloudFormation(properties.authorizationType), AuthorizerId: cdk.stringToCloudFormation(properties.authorizerId), OperationName: cdk.stringToCloudFormation(properties.operationName), Target: cdk.stringToCloudFormation(properties.target) }) : properties;
    }
    function CfnApiGatewayManagedOverridesRouteOverridesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authorizationScopes", "AuthorizationScopes", properties.AuthorizationScopes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AuthorizationScopes) : void 0), ret.addPropertyResult("authorizationType", "AuthorizationType", properties.AuthorizationType != null ? cfn_parse.FromCloudFormation.getString(properties.AuthorizationType) : void 0), ret.addPropertyResult("authorizerId", "AuthorizerId", properties.AuthorizerId != null ? cfn_parse.FromCloudFormation.getString(properties.AuthorizerId) : void 0), ret.addPropertyResult("operationName", "OperationName", properties.OperationName != null ? cfn_parse.FromCloudFormation.getString(properties.OperationName) : void 0), ret.addPropertyResult("target", "Target", properties.Target != null ? cfn_parse.FromCloudFormation.getString(properties.Target) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApiGatewayManagedOverrides_RouteSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataTraceEnabled", cdk.validateBoolean)(properties.dataTraceEnabled)), errors.collect(cdk.propertyValidator("detailedMetricsEnabled", cdk.validateBoolean)(properties.detailedMetricsEnabled)), errors.collect(cdk.propertyValidator("loggingLevel", cdk.validateString)(properties.loggingLevel)), errors.collect(cdk.propertyValidator("throttlingBurstLimit", cdk.validateNumber)(properties.throttlingBurstLimit)), errors.collect(cdk.propertyValidator("throttlingRateLimit", cdk.validateNumber)(properties.throttlingRateLimit)), errors.wrap('supplied properties not correct for "RouteSettingsProperty"');
    }
    function cfnApiGatewayManagedOverridesRouteSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApiGatewayManagedOverrides_RouteSettingsPropertyValidator(properties).assertSuccess(), { DataTraceEnabled: cdk.booleanToCloudFormation(properties.dataTraceEnabled), DetailedMetricsEnabled: cdk.booleanToCloudFormation(properties.detailedMetricsEnabled), LoggingLevel: cdk.stringToCloudFormation(properties.loggingLevel), ThrottlingBurstLimit: cdk.numberToCloudFormation(properties.throttlingBurstLimit), ThrottlingRateLimit: cdk.numberToCloudFormation(properties.throttlingRateLimit) }) : properties;
    }
    function CfnApiGatewayManagedOverridesRouteSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataTraceEnabled", "DataTraceEnabled", properties.DataTraceEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DataTraceEnabled) : void 0), ret.addPropertyResult("detailedMetricsEnabled", "DetailedMetricsEnabled", properties.DetailedMetricsEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DetailedMetricsEnabled) : void 0), ret.addPropertyResult("loggingLevel", "LoggingLevel", properties.LoggingLevel != null ? cfn_parse.FromCloudFormation.getString(properties.LoggingLevel) : void 0), ret.addPropertyResult("throttlingBurstLimit", "ThrottlingBurstLimit", properties.ThrottlingBurstLimit != null ? cfn_parse.FromCloudFormation.getNumber(properties.ThrottlingBurstLimit) : void 0), ret.addPropertyResult("throttlingRateLimit", "ThrottlingRateLimit", properties.ThrottlingRateLimit != null ? cfn_parse.FromCloudFormation.getNumber(properties.ThrottlingRateLimit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApiGatewayManagedOverrides_StageOverridesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessLogSettings", CfnApiGatewayManagedOverrides_AccessLogSettingsPropertyValidator)(properties.accessLogSettings)), errors.collect(cdk.propertyValidator("autoDeploy", cdk.validateBoolean)(properties.autoDeploy)), errors.collect(cdk.propertyValidator("defaultRouteSettings", CfnApiGatewayManagedOverrides_RouteSettingsPropertyValidator)(properties.defaultRouteSettings)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("routeSettings", cdk.validateObject)(properties.routeSettings)), errors.collect(cdk.propertyValidator("stageVariables", cdk.validateObject)(properties.stageVariables)), errors.wrap('supplied properties not correct for "StageOverridesProperty"');
    }
    function cfnApiGatewayManagedOverridesStageOverridesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApiGatewayManagedOverrides_StageOverridesPropertyValidator(properties).assertSuccess(), { AccessLogSettings: cfnApiGatewayManagedOverridesAccessLogSettingsPropertyToCloudFormation(properties.accessLogSettings), AutoDeploy: cdk.booleanToCloudFormation(properties.autoDeploy), DefaultRouteSettings: cfnApiGatewayManagedOverridesRouteSettingsPropertyToCloudFormation(properties.defaultRouteSettings), Description: cdk.stringToCloudFormation(properties.description), RouteSettings: cdk.objectToCloudFormation(properties.routeSettings), StageVariables: cdk.objectToCloudFormation(properties.stageVariables) }) : properties;
    }
    function CfnApiGatewayManagedOverridesStageOverridesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessLogSettings", "AccessLogSettings", properties.AccessLogSettings != null ? CfnApiGatewayManagedOverridesAccessLogSettingsPropertyFromCloudFormation(properties.AccessLogSettings) : void 0), ret.addPropertyResult("autoDeploy", "AutoDeploy", properties.AutoDeploy != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AutoDeploy) : void 0), ret.addPropertyResult("defaultRouteSettings", "DefaultRouteSettings", properties.DefaultRouteSettings != null ? CfnApiGatewayManagedOverridesRouteSettingsPropertyFromCloudFormation(properties.DefaultRouteSettings) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("routeSettings", "RouteSettings", properties.RouteSettings != null ? cfn_parse.FromCloudFormation.getAny(properties.RouteSettings) : void 0), ret.addPropertyResult("stageVariables", "StageVariables", properties.StageVariables != null ? cfn_parse.FromCloudFormation.getAny(properties.StageVariables) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApiMappingPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiId", cdk.requiredValidator)(properties.apiId)), errors.collect(cdk.propertyValidator("apiId", cdk.validateString)(properties.apiId)), errors.collect(cdk.propertyValidator("apiMappingKey", cdk.validateString)(properties.apiMappingKey)), errors.collect(cdk.propertyValidator("domainName", cdk.requiredValidator)(properties.domainName)), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.collect(cdk.propertyValidator("stage", cdk.requiredValidator)(properties.stage)), errors.collect(cdk.propertyValidator("stage", cdk.validateString)(properties.stage)), errors.wrap('supplied properties not correct for "CfnApiMappingProps"');
    }
    function cfnApiMappingPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApiMappingPropsValidator(properties).assertSuccess(), { ApiId: cdk.stringToCloudFormation(properties.apiId), DomainName: cdk.stringToCloudFormation(properties.domainName), Stage: cdk.stringToCloudFormation(properties.stage), ApiMappingKey: cdk.stringToCloudFormation(properties.apiMappingKey) }) : properties;
    }
    function CfnApiMappingPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiId", "ApiId", cfn_parse.FromCloudFormation.getString(properties.ApiId)), ret.addPropertyResult("domainName", "DomainName", cfn_parse.FromCloudFormation.getString(properties.DomainName)), ret.addPropertyResult("stage", "Stage", cfn_parse.FromCloudFormation.getString(properties.Stage)), ret.addPropertyResult("apiMappingKey", "ApiMappingKey", properties.ApiMappingKey != null ? cfn_parse.FromCloudFormation.getString(properties.ApiMappingKey) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApiMapping = class _CfnApiMapping extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApiMappingPropsFromCloudFormation(resourceProperties), ret = new _CfnApiMapping(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApiMapping.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigatewayv2_CfnApiMappingProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApiMapping), error;
        }
        cdk.requireProperty(props, "apiId", this), cdk.requireProperty(props, "domainName", this), cdk.requireProperty(props, "stage", this), this.apiId = props.apiId, this.domainName = props.domainName, this.stage = props.stage, this.apiMappingKey = props.apiMappingKey;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApiMapping.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiId: this.apiId, domainName: this.domainName, stage: this.stage, apiMappingKey: this.apiMappingKey };
      }
      renderProperties(props) {
        return cfnApiMappingPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnApiMapping[_c] = { fqn: "aws-cdk-lib.aws_apigatewayv2.CfnApiMapping", version: "2.80.0" }, CfnApiMapping.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGatewayV2::ApiMapping", exports2.CfnApiMapping = CfnApiMapping;
    function CfnAuthorizerPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiId", cdk.requiredValidator)(properties.apiId)), errors.collect(cdk.propertyValidator("apiId", cdk.validateString)(properties.apiId)), errors.collect(cdk.propertyValidator("authorizerCredentialsArn", cdk.validateString)(properties.authorizerCredentialsArn)), errors.collect(cdk.propertyValidator("authorizerPayloadFormatVersion", cdk.validateString)(properties.authorizerPayloadFormatVersion)), errors.collect(cdk.propertyValidator("authorizerResultTtlInSeconds", cdk.validateNumber)(properties.authorizerResultTtlInSeconds)), errors.collect(cdk.propertyValidator("authorizerType", cdk.requiredValidator)(properties.authorizerType)), errors.collect(cdk.propertyValidator("authorizerType", cdk.validateString)(properties.authorizerType)), errors.collect(cdk.propertyValidator("authorizerUri", cdk.validateString)(properties.authorizerUri)), errors.collect(cdk.propertyValidator("enableSimpleResponses", cdk.validateBoolean)(properties.enableSimpleResponses)), errors.collect(cdk.propertyValidator("identitySource", cdk.listValidator(cdk.validateString))(properties.identitySource)), errors.collect(cdk.propertyValidator("identityValidationExpression", cdk.validateString)(properties.identityValidationExpression)), errors.collect(cdk.propertyValidator("jwtConfiguration", CfnAuthorizer_JWTConfigurationPropertyValidator)(properties.jwtConfiguration)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "CfnAuthorizerProps"');
    }
    function cfnAuthorizerPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAuthorizerPropsValidator(properties).assertSuccess(), { ApiId: cdk.stringToCloudFormation(properties.apiId), AuthorizerType: cdk.stringToCloudFormation(properties.authorizerType), Name: cdk.stringToCloudFormation(properties.name), AuthorizerCredentialsArn: cdk.stringToCloudFormation(properties.authorizerCredentialsArn), AuthorizerPayloadFormatVersion: cdk.stringToCloudFormation(properties.authorizerPayloadFormatVersion), AuthorizerResultTtlInSeconds: cdk.numberToCloudFormation(properties.authorizerResultTtlInSeconds), AuthorizerUri: cdk.stringToCloudFormation(properties.authorizerUri), EnableSimpleResponses: cdk.booleanToCloudFormation(properties.enableSimpleResponses), IdentitySource: cdk.listMapper(cdk.stringToCloudFormation)(properties.identitySource), IdentityValidationExpression: cdk.stringToCloudFormation(properties.identityValidationExpression), JwtConfiguration: cfnAuthorizerJWTConfigurationPropertyToCloudFormation(properties.jwtConfiguration) }) : properties;
    }
    function CfnAuthorizerPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiId", "ApiId", cfn_parse.FromCloudFormation.getString(properties.ApiId)), ret.addPropertyResult("authorizerType", "AuthorizerType", cfn_parse.FromCloudFormation.getString(properties.AuthorizerType)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("authorizerCredentialsArn", "AuthorizerCredentialsArn", properties.AuthorizerCredentialsArn != null ? cfn_parse.FromCloudFormation.getString(properties.AuthorizerCredentialsArn) : void 0), ret.addPropertyResult("authorizerPayloadFormatVersion", "AuthorizerPayloadFormatVersion", properties.AuthorizerPayloadFormatVersion != null ? cfn_parse.FromCloudFormation.getString(properties.AuthorizerPayloadFormatVersion) : void 0), ret.addPropertyResult("authorizerResultTtlInSeconds", "AuthorizerResultTtlInSeconds", properties.AuthorizerResultTtlInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.AuthorizerResultTtlInSeconds) : void 0), ret.addPropertyResult("authorizerUri", "AuthorizerUri", properties.AuthorizerUri != null ? cfn_parse.FromCloudFormation.getString(properties.AuthorizerUri) : void 0), ret.addPropertyResult("enableSimpleResponses", "EnableSimpleResponses", properties.EnableSimpleResponses != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableSimpleResponses) : void 0), ret.addPropertyResult("identitySource", "IdentitySource", properties.IdentitySource != null ? cfn_parse.FromCloudFormation.getStringArray(properties.IdentitySource) : void 0), ret.addPropertyResult("identityValidationExpression", "IdentityValidationExpression", properties.IdentityValidationExpression != null ? cfn_parse.FromCloudFormation.getString(properties.IdentityValidationExpression) : void 0), ret.addPropertyResult("jwtConfiguration", "JwtConfiguration", properties.JwtConfiguration != null ? CfnAuthorizerJWTConfigurationPropertyFromCloudFormation(properties.JwtConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAuthorizer = class _CfnAuthorizer extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAuthorizerPropsFromCloudFormation(resourceProperties), ret = new _CfnAuthorizer(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAuthorizer.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigatewayv2_CfnAuthorizerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAuthorizer), error;
        }
        cdk.requireProperty(props, "apiId", this), cdk.requireProperty(props, "authorizerType", this), cdk.requireProperty(props, "name", this), this.attrAuthorizerId = cdk.Token.asString(this.getAtt("AuthorizerId", cdk.ResolutionTypeHint.STRING)), this.apiId = props.apiId, this.authorizerType = props.authorizerType, this.name = props.name, this.authorizerCredentialsArn = props.authorizerCredentialsArn, this.authorizerPayloadFormatVersion = props.authorizerPayloadFormatVersion, this.authorizerResultTtlInSeconds = props.authorizerResultTtlInSeconds, this.authorizerUri = props.authorizerUri, this.enableSimpleResponses = props.enableSimpleResponses, this.identitySource = props.identitySource, this.identityValidationExpression = props.identityValidationExpression, this.jwtConfiguration = props.jwtConfiguration;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAuthorizer.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiId: this.apiId, authorizerType: this.authorizerType, name: this.name, authorizerCredentialsArn: this.authorizerCredentialsArn, authorizerPayloadFormatVersion: this.authorizerPayloadFormatVersion, authorizerResultTtlInSeconds: this.authorizerResultTtlInSeconds, authorizerUri: this.authorizerUri, enableSimpleResponses: this.enableSimpleResponses, identitySource: this.identitySource, identityValidationExpression: this.identityValidationExpression, jwtConfiguration: this.jwtConfiguration };
      }
      renderProperties(props) {
        return cfnAuthorizerPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnAuthorizer[_d] = { fqn: "aws-cdk-lib.aws_apigatewayv2.CfnAuthorizer", version: "2.80.0" }, CfnAuthorizer.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGatewayV2::Authorizer", exports2.CfnAuthorizer = CfnAuthorizer;
    function CfnAuthorizer_JWTConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("audience", cdk.listValidator(cdk.validateString))(properties.audience)), errors.collect(cdk.propertyValidator("issuer", cdk.validateString)(properties.issuer)), errors.wrap('supplied properties not correct for "JWTConfigurationProperty"');
    }
    function cfnAuthorizerJWTConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAuthorizer_JWTConfigurationPropertyValidator(properties).assertSuccess(), { Audience: cdk.listMapper(cdk.stringToCloudFormation)(properties.audience), Issuer: cdk.stringToCloudFormation(properties.issuer) }) : properties;
    }
    function CfnAuthorizerJWTConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("audience", "Audience", properties.Audience != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Audience) : void 0), ret.addPropertyResult("issuer", "Issuer", properties.Issuer != null ? cfn_parse.FromCloudFormation.getString(properties.Issuer) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiId", cdk.requiredValidator)(properties.apiId)), errors.collect(cdk.propertyValidator("apiId", cdk.validateString)(properties.apiId)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("stageName", cdk.validateString)(properties.stageName)), errors.wrap('supplied properties not correct for "CfnDeploymentProps"');
    }
    function cfnDeploymentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentPropsValidator(properties).assertSuccess(), { ApiId: cdk.stringToCloudFormation(properties.apiId), Description: cdk.stringToCloudFormation(properties.description), StageName: cdk.stringToCloudFormation(properties.stageName) }) : properties;
    }
    function CfnDeploymentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiId", "ApiId", cfn_parse.FromCloudFormation.getString(properties.ApiId)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("stageName", "StageName", properties.StageName != null ? cfn_parse.FromCloudFormation.getString(properties.StageName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDeployment = class _CfnDeployment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDeploymentPropsFromCloudFormation(resourceProperties), ret = new _CfnDeployment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDeployment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigatewayv2_CfnDeploymentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDeployment), error;
        }
        cdk.requireProperty(props, "apiId", this), this.attrDeploymentId = cdk.Token.asString(this.getAtt("DeploymentId", cdk.ResolutionTypeHint.STRING)), this.apiId = props.apiId, this.description = props.description, this.stageName = props.stageName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDeployment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiId: this.apiId, description: this.description, stageName: this.stageName };
      }
      renderProperties(props) {
        return cfnDeploymentPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnDeployment[_e] = { fqn: "aws-cdk-lib.aws_apigatewayv2.CfnDeployment", version: "2.80.0" }, CfnDeployment.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGatewayV2::Deployment", exports2.CfnDeployment = CfnDeployment;
    function CfnDomainNamePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("domainName", cdk.requiredValidator)(properties.domainName)), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.collect(cdk.propertyValidator("domainNameConfigurations", cdk.listValidator(CfnDomainName_DomainNameConfigurationPropertyValidator))(properties.domainNameConfigurations)), errors.collect(cdk.propertyValidator("mutualTlsAuthentication", CfnDomainName_MutualTlsAuthenticationPropertyValidator)(properties.mutualTlsAuthentication)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.wrap('supplied properties not correct for "CfnDomainNameProps"');
    }
    function cfnDomainNamePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomainNamePropsValidator(properties).assertSuccess(), { DomainName: cdk.stringToCloudFormation(properties.domainName), DomainNameConfigurations: cdk.listMapper(cfnDomainNameDomainNameConfigurationPropertyToCloudFormation)(properties.domainNameConfigurations), MutualTlsAuthentication: cfnDomainNameMutualTlsAuthenticationPropertyToCloudFormation(properties.mutualTlsAuthentication), Tags: cdk.objectToCloudFormation(properties.tags) }) : properties;
    }
    function CfnDomainNamePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("domainName", "DomainName", cfn_parse.FromCloudFormation.getString(properties.DomainName)), ret.addPropertyResult("domainNameConfigurations", "DomainNameConfigurations", properties.DomainNameConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnDomainNameDomainNameConfigurationPropertyFromCloudFormation)(properties.DomainNameConfigurations) : void 0), ret.addPropertyResult("mutualTlsAuthentication", "MutualTlsAuthentication", properties.MutualTlsAuthentication != null ? CfnDomainNameMutualTlsAuthenticationPropertyFromCloudFormation(properties.MutualTlsAuthentication) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDomainName = class _CfnDomainName extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDomainNamePropsFromCloudFormation(resourceProperties), ret = new _CfnDomainName(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDomainName.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigatewayv2_CfnDomainNameProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDomainName), error;
        }
        cdk.requireProperty(props, "domainName", this), this.attrRegionalDomainName = cdk.Token.asString(this.getAtt("RegionalDomainName", cdk.ResolutionTypeHint.STRING)), this.attrRegionalHostedZoneId = cdk.Token.asString(this.getAtt("RegionalHostedZoneId", cdk.ResolutionTypeHint.STRING)), this.domainName = props.domainName, this.domainNameConfigurations = props.domainNameConfigurations, this.mutualTlsAuthentication = props.mutualTlsAuthentication, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::ApiGatewayV2::DomainName", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDomainName.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { domainName: this.domainName, domainNameConfigurations: this.domainNameConfigurations, mutualTlsAuthentication: this.mutualTlsAuthentication, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDomainNamePropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnDomainName[_f] = { fqn: "aws-cdk-lib.aws_apigatewayv2.CfnDomainName", version: "2.80.0" }, CfnDomainName.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGatewayV2::DomainName", exports2.CfnDomainName = CfnDomainName;
    function CfnDomainName_DomainNameConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateArn", cdk.validateString)(properties.certificateArn)), errors.collect(cdk.propertyValidator("certificateName", cdk.validateString)(properties.certificateName)), errors.collect(cdk.propertyValidator("endpointType", cdk.validateString)(properties.endpointType)), errors.collect(cdk.propertyValidator("ownershipVerificationCertificateArn", cdk.validateString)(properties.ownershipVerificationCertificateArn)), errors.collect(cdk.propertyValidator("securityPolicy", cdk.validateString)(properties.securityPolicy)), errors.wrap('supplied properties not correct for "DomainNameConfigurationProperty"');
    }
    function cfnDomainNameDomainNameConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomainName_DomainNameConfigurationPropertyValidator(properties).assertSuccess(), { CertificateArn: cdk.stringToCloudFormation(properties.certificateArn), CertificateName: cdk.stringToCloudFormation(properties.certificateName), EndpointType: cdk.stringToCloudFormation(properties.endpointType), OwnershipVerificationCertificateArn: cdk.stringToCloudFormation(properties.ownershipVerificationCertificateArn), SecurityPolicy: cdk.stringToCloudFormation(properties.securityPolicy) }) : properties;
    }
    function CfnDomainNameDomainNameConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificateArn", "CertificateArn", properties.CertificateArn != null ? cfn_parse.FromCloudFormation.getString(properties.CertificateArn) : void 0), ret.addPropertyResult("certificateName", "CertificateName", properties.CertificateName != null ? cfn_parse.FromCloudFormation.getString(properties.CertificateName) : void 0), ret.addPropertyResult("endpointType", "EndpointType", properties.EndpointType != null ? cfn_parse.FromCloudFormation.getString(properties.EndpointType) : void 0), ret.addPropertyResult("ownershipVerificationCertificateArn", "OwnershipVerificationCertificateArn", properties.OwnershipVerificationCertificateArn != null ? cfn_parse.FromCloudFormation.getString(properties.OwnershipVerificationCertificateArn) : void 0), ret.addPropertyResult("securityPolicy", "SecurityPolicy", properties.SecurityPolicy != null ? cfn_parse.FromCloudFormation.getString(properties.SecurityPolicy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomainName_MutualTlsAuthenticationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("truststoreUri", cdk.validateString)(properties.truststoreUri)), errors.collect(cdk.propertyValidator("truststoreVersion", cdk.validateString)(properties.truststoreVersion)), errors.wrap('supplied properties not correct for "MutualTlsAuthenticationProperty"');
    }
    function cfnDomainNameMutualTlsAuthenticationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomainName_MutualTlsAuthenticationPropertyValidator(properties).assertSuccess(), { TruststoreUri: cdk.stringToCloudFormation(properties.truststoreUri), TruststoreVersion: cdk.stringToCloudFormation(properties.truststoreVersion) }) : properties;
    }
    function CfnDomainNameMutualTlsAuthenticationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("truststoreUri", "TruststoreUri", properties.TruststoreUri != null ? cfn_parse.FromCloudFormation.getString(properties.TruststoreUri) : void 0), ret.addPropertyResult("truststoreVersion", "TruststoreVersion", properties.TruststoreVersion != null ? cfn_parse.FromCloudFormation.getString(properties.TruststoreVersion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIntegrationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiId", cdk.requiredValidator)(properties.apiId)), errors.collect(cdk.propertyValidator("apiId", cdk.validateString)(properties.apiId)), errors.collect(cdk.propertyValidator("connectionId", cdk.validateString)(properties.connectionId)), errors.collect(cdk.propertyValidator("connectionType", cdk.validateString)(properties.connectionType)), errors.collect(cdk.propertyValidator("contentHandlingStrategy", cdk.validateString)(properties.contentHandlingStrategy)), errors.collect(cdk.propertyValidator("credentialsArn", cdk.validateString)(properties.credentialsArn)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("integrationMethod", cdk.validateString)(properties.integrationMethod)), errors.collect(cdk.propertyValidator("integrationSubtype", cdk.validateString)(properties.integrationSubtype)), errors.collect(cdk.propertyValidator("integrationType", cdk.requiredValidator)(properties.integrationType)), errors.collect(cdk.propertyValidator("integrationType", cdk.validateString)(properties.integrationType)), errors.collect(cdk.propertyValidator("integrationUri", cdk.validateString)(properties.integrationUri)), errors.collect(cdk.propertyValidator("passthroughBehavior", cdk.validateString)(properties.passthroughBehavior)), errors.collect(cdk.propertyValidator("payloadFormatVersion", cdk.validateString)(properties.payloadFormatVersion)), errors.collect(cdk.propertyValidator("requestParameters", cdk.validateObject)(properties.requestParameters)), errors.collect(cdk.propertyValidator("requestTemplates", cdk.validateObject)(properties.requestTemplates)), errors.collect(cdk.propertyValidator("responseParameters", cdk.validateObject)(properties.responseParameters)), errors.collect(cdk.propertyValidator("templateSelectionExpression", cdk.validateString)(properties.templateSelectionExpression)), errors.collect(cdk.propertyValidator("timeoutInMillis", cdk.validateNumber)(properties.timeoutInMillis)), errors.collect(cdk.propertyValidator("tlsConfig", CfnIntegration_TlsConfigPropertyValidator)(properties.tlsConfig)), errors.wrap('supplied properties not correct for "CfnIntegrationProps"');
    }
    function cfnIntegrationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIntegrationPropsValidator(properties).assertSuccess(), { ApiId: cdk.stringToCloudFormation(properties.apiId), IntegrationType: cdk.stringToCloudFormation(properties.integrationType), ConnectionId: cdk.stringToCloudFormation(properties.connectionId), ConnectionType: cdk.stringToCloudFormation(properties.connectionType), ContentHandlingStrategy: cdk.stringToCloudFormation(properties.contentHandlingStrategy), CredentialsArn: cdk.stringToCloudFormation(properties.credentialsArn), Description: cdk.stringToCloudFormation(properties.description), IntegrationMethod: cdk.stringToCloudFormation(properties.integrationMethod), IntegrationSubtype: cdk.stringToCloudFormation(properties.integrationSubtype), IntegrationUri: cdk.stringToCloudFormation(properties.integrationUri), PassthroughBehavior: cdk.stringToCloudFormation(properties.passthroughBehavior), PayloadFormatVersion: cdk.stringToCloudFormation(properties.payloadFormatVersion), RequestParameters: cdk.objectToCloudFormation(properties.requestParameters), RequestTemplates: cdk.objectToCloudFormation(properties.requestTemplates), ResponseParameters: cdk.objectToCloudFormation(properties.responseParameters), TemplateSelectionExpression: cdk.stringToCloudFormation(properties.templateSelectionExpression), TimeoutInMillis: cdk.numberToCloudFormation(properties.timeoutInMillis), TlsConfig: cfnIntegrationTlsConfigPropertyToCloudFormation(properties.tlsConfig) }) : properties;
    }
    function CfnIntegrationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiId", "ApiId", cfn_parse.FromCloudFormation.getString(properties.ApiId)), ret.addPropertyResult("integrationType", "IntegrationType", cfn_parse.FromCloudFormation.getString(properties.IntegrationType)), ret.addPropertyResult("connectionId", "ConnectionId", properties.ConnectionId != null ? cfn_parse.FromCloudFormation.getString(properties.ConnectionId) : void 0), ret.addPropertyResult("connectionType", "ConnectionType", properties.ConnectionType != null ? cfn_parse.FromCloudFormation.getString(properties.ConnectionType) : void 0), ret.addPropertyResult("contentHandlingStrategy", "ContentHandlingStrategy", properties.ContentHandlingStrategy != null ? cfn_parse.FromCloudFormation.getString(properties.ContentHandlingStrategy) : void 0), ret.addPropertyResult("credentialsArn", "CredentialsArn", properties.CredentialsArn != null ? cfn_parse.FromCloudFormation.getString(properties.CredentialsArn) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("integrationMethod", "IntegrationMethod", properties.IntegrationMethod != null ? cfn_parse.FromCloudFormation.getString(properties.IntegrationMethod) : void 0), ret.addPropertyResult("integrationSubtype", "IntegrationSubtype", properties.IntegrationSubtype != null ? cfn_parse.FromCloudFormation.getString(properties.IntegrationSubtype) : void 0), ret.addPropertyResult("integrationUri", "IntegrationUri", properties.IntegrationUri != null ? cfn_parse.FromCloudFormation.getString(properties.IntegrationUri) : void 0), ret.addPropertyResult("passthroughBehavior", "PassthroughBehavior", properties.PassthroughBehavior != null ? cfn_parse.FromCloudFormation.getString(properties.PassthroughBehavior) : void 0), ret.addPropertyResult("payloadFormatVersion", "PayloadFormatVersion", properties.PayloadFormatVersion != null ? cfn_parse.FromCloudFormation.getString(properties.PayloadFormatVersion) : void 0), ret.addPropertyResult("requestParameters", "RequestParameters", properties.RequestParameters != null ? cfn_parse.FromCloudFormation.getAny(properties.RequestParameters) : void 0), ret.addPropertyResult("requestTemplates", "RequestTemplates", properties.RequestTemplates != null ? cfn_parse.FromCloudFormation.getAny(properties.RequestTemplates) : void 0), ret.addPropertyResult("responseParameters", "ResponseParameters", properties.ResponseParameters != null ? cfn_parse.FromCloudFormation.getAny(properties.ResponseParameters) : void 0), ret.addPropertyResult("templateSelectionExpression", "TemplateSelectionExpression", properties.TemplateSelectionExpression != null ? cfn_parse.FromCloudFormation.getString(properties.TemplateSelectionExpression) : void 0), ret.addPropertyResult("timeoutInMillis", "TimeoutInMillis", properties.TimeoutInMillis != null ? cfn_parse.FromCloudFormation.getNumber(properties.TimeoutInMillis) : void 0), ret.addPropertyResult("tlsConfig", "TlsConfig", properties.TlsConfig != null ? CfnIntegrationTlsConfigPropertyFromCloudFormation(properties.TlsConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnIntegration = class _CfnIntegration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnIntegrationPropsFromCloudFormation(resourceProperties), ret = new _CfnIntegration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnIntegration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigatewayv2_CfnIntegrationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnIntegration), error;
        }
        cdk.requireProperty(props, "apiId", this), cdk.requireProperty(props, "integrationType", this), this.apiId = props.apiId, this.integrationType = props.integrationType, this.connectionId = props.connectionId, this.connectionType = props.connectionType, this.contentHandlingStrategy = props.contentHandlingStrategy, this.credentialsArn = props.credentialsArn, this.description = props.description, this.integrationMethod = props.integrationMethod, this.integrationSubtype = props.integrationSubtype, this.integrationUri = props.integrationUri, this.passthroughBehavior = props.passthroughBehavior, this.payloadFormatVersion = props.payloadFormatVersion, this.requestParameters = props.requestParameters, this.requestTemplates = props.requestTemplates, this.responseParameters = props.responseParameters, this.templateSelectionExpression = props.templateSelectionExpression, this.timeoutInMillis = props.timeoutInMillis, this.tlsConfig = props.tlsConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnIntegration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiId: this.apiId, integrationType: this.integrationType, connectionId: this.connectionId, connectionType: this.connectionType, contentHandlingStrategy: this.contentHandlingStrategy, credentialsArn: this.credentialsArn, description: this.description, integrationMethod: this.integrationMethod, integrationSubtype: this.integrationSubtype, integrationUri: this.integrationUri, passthroughBehavior: this.passthroughBehavior, payloadFormatVersion: this.payloadFormatVersion, requestParameters: this.requestParameters, requestTemplates: this.requestTemplates, responseParameters: this.responseParameters, templateSelectionExpression: this.templateSelectionExpression, timeoutInMillis: this.timeoutInMillis, tlsConfig: this.tlsConfig };
      }
      renderProperties(props) {
        return cfnIntegrationPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnIntegration[_g] = { fqn: "aws-cdk-lib.aws_apigatewayv2.CfnIntegration", version: "2.80.0" }, CfnIntegration.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGatewayV2::Integration", exports2.CfnIntegration = CfnIntegration;
    function CfnIntegration_TlsConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("serverNameToVerify", cdk.validateString)(properties.serverNameToVerify)), errors.wrap('supplied properties not correct for "TlsConfigProperty"');
    }
    function cfnIntegrationTlsConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIntegration_TlsConfigPropertyValidator(properties).assertSuccess(), { ServerNameToVerify: cdk.stringToCloudFormation(properties.serverNameToVerify) }) : properties;
    }
    function CfnIntegrationTlsConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("serverNameToVerify", "ServerNameToVerify", properties.ServerNameToVerify != null ? cfn_parse.FromCloudFormation.getString(properties.ServerNameToVerify) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIntegrationResponsePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiId", cdk.requiredValidator)(properties.apiId)), errors.collect(cdk.propertyValidator("apiId", cdk.validateString)(properties.apiId)), errors.collect(cdk.propertyValidator("contentHandlingStrategy", cdk.validateString)(properties.contentHandlingStrategy)), errors.collect(cdk.propertyValidator("integrationId", cdk.requiredValidator)(properties.integrationId)), errors.collect(cdk.propertyValidator("integrationId", cdk.validateString)(properties.integrationId)), errors.collect(cdk.propertyValidator("integrationResponseKey", cdk.requiredValidator)(properties.integrationResponseKey)), errors.collect(cdk.propertyValidator("integrationResponseKey", cdk.validateString)(properties.integrationResponseKey)), errors.collect(cdk.propertyValidator("responseParameters", cdk.validateObject)(properties.responseParameters)), errors.collect(cdk.propertyValidator("responseTemplates", cdk.validateObject)(properties.responseTemplates)), errors.collect(cdk.propertyValidator("templateSelectionExpression", cdk.validateString)(properties.templateSelectionExpression)), errors.wrap('supplied properties not correct for "CfnIntegrationResponseProps"');
    }
    function cfnIntegrationResponsePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIntegrationResponsePropsValidator(properties).assertSuccess(), { ApiId: cdk.stringToCloudFormation(properties.apiId), IntegrationId: cdk.stringToCloudFormation(properties.integrationId), IntegrationResponseKey: cdk.stringToCloudFormation(properties.integrationResponseKey), ContentHandlingStrategy: cdk.stringToCloudFormation(properties.contentHandlingStrategy), ResponseParameters: cdk.objectToCloudFormation(properties.responseParameters), ResponseTemplates: cdk.objectToCloudFormation(properties.responseTemplates), TemplateSelectionExpression: cdk.stringToCloudFormation(properties.templateSelectionExpression) }) : properties;
    }
    function CfnIntegrationResponsePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiId", "ApiId", cfn_parse.FromCloudFormation.getString(properties.ApiId)), ret.addPropertyResult("integrationId", "IntegrationId", cfn_parse.FromCloudFormation.getString(properties.IntegrationId)), ret.addPropertyResult("integrationResponseKey", "IntegrationResponseKey", cfn_parse.FromCloudFormation.getString(properties.IntegrationResponseKey)), ret.addPropertyResult("contentHandlingStrategy", "ContentHandlingStrategy", properties.ContentHandlingStrategy != null ? cfn_parse.FromCloudFormation.getString(properties.ContentHandlingStrategy) : void 0), ret.addPropertyResult("responseParameters", "ResponseParameters", properties.ResponseParameters != null ? cfn_parse.FromCloudFormation.getAny(properties.ResponseParameters) : void 0), ret.addPropertyResult("responseTemplates", "ResponseTemplates", properties.ResponseTemplates != null ? cfn_parse.FromCloudFormation.getAny(properties.ResponseTemplates) : void 0), ret.addPropertyResult("templateSelectionExpression", "TemplateSelectionExpression", properties.TemplateSelectionExpression != null ? cfn_parse.FromCloudFormation.getString(properties.TemplateSelectionExpression) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnIntegrationResponse = class _CfnIntegrationResponse extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnIntegrationResponsePropsFromCloudFormation(resourceProperties), ret = new _CfnIntegrationResponse(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnIntegrationResponse.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigatewayv2_CfnIntegrationResponseProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnIntegrationResponse), error;
        }
        cdk.requireProperty(props, "apiId", this), cdk.requireProperty(props, "integrationId", this), cdk.requireProperty(props, "integrationResponseKey", this), this.attrIntegrationResponseId = cdk.Token.asString(this.getAtt("IntegrationResponseId", cdk.ResolutionTypeHint.STRING)), this.apiId = props.apiId, this.integrationId = props.integrationId, this.integrationResponseKey = props.integrationResponseKey, this.contentHandlingStrategy = props.contentHandlingStrategy, this.responseParameters = props.responseParameters, this.responseTemplates = props.responseTemplates, this.templateSelectionExpression = props.templateSelectionExpression;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnIntegrationResponse.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiId: this.apiId, integrationId: this.integrationId, integrationResponseKey: this.integrationResponseKey, contentHandlingStrategy: this.contentHandlingStrategy, responseParameters: this.responseParameters, responseTemplates: this.responseTemplates, templateSelectionExpression: this.templateSelectionExpression };
      }
      renderProperties(props) {
        return cfnIntegrationResponsePropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnIntegrationResponse[_h] = { fqn: "aws-cdk-lib.aws_apigatewayv2.CfnIntegrationResponse", version: "2.80.0" }, CfnIntegrationResponse.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGatewayV2::IntegrationResponse", exports2.CfnIntegrationResponse = CfnIntegrationResponse;
    function CfnModelPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiId", cdk.requiredValidator)(properties.apiId)), errors.collect(cdk.propertyValidator("apiId", cdk.validateString)(properties.apiId)), errors.collect(cdk.propertyValidator("contentType", cdk.validateString)(properties.contentType)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("schema", cdk.requiredValidator)(properties.schema)), errors.collect(cdk.propertyValidator("schema", cdk.validateObject)(properties.schema)), errors.wrap('supplied properties not correct for "CfnModelProps"');
    }
    function cfnModelPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPropsValidator(properties).assertSuccess(), { ApiId: cdk.stringToCloudFormation(properties.apiId), Name: cdk.stringToCloudFormation(properties.name), Schema: cdk.objectToCloudFormation(properties.schema), ContentType: cdk.stringToCloudFormation(properties.contentType), Description: cdk.stringToCloudFormation(properties.description) }) : properties;
    }
    function CfnModelPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiId", "ApiId", cfn_parse.FromCloudFormation.getString(properties.ApiId)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("schema", "Schema", cfn_parse.FromCloudFormation.getAny(properties.Schema)), ret.addPropertyResult("contentType", "ContentType", properties.ContentType != null ? cfn_parse.FromCloudFormation.getString(properties.ContentType) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnModel = class _CfnModel extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnModelPropsFromCloudFormation(resourceProperties), ret = new _CfnModel(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnModel.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigatewayv2_CfnModelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnModel), error;
        }
        cdk.requireProperty(props, "apiId", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "schema", this), this.attrModelId = cdk.Token.asString(this.getAtt("ModelId", cdk.ResolutionTypeHint.STRING)), this.apiId = props.apiId, this.name = props.name, this.schema = props.schema, this.contentType = props.contentType, this.description = props.description;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnModel.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiId: this.apiId, name: this.name, schema: this.schema, contentType: this.contentType, description: this.description };
      }
      renderProperties(props) {
        return cfnModelPropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnModel[_j] = { fqn: "aws-cdk-lib.aws_apigatewayv2.CfnModel", version: "2.80.0" }, CfnModel.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGatewayV2::Model", exports2.CfnModel = CfnModel;
    function CfnRoutePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiId", cdk.requiredValidator)(properties.apiId)), errors.collect(cdk.propertyValidator("apiId", cdk.validateString)(properties.apiId)), errors.collect(cdk.propertyValidator("apiKeyRequired", cdk.validateBoolean)(properties.apiKeyRequired)), errors.collect(cdk.propertyValidator("authorizationScopes", cdk.listValidator(cdk.validateString))(properties.authorizationScopes)), errors.collect(cdk.propertyValidator("authorizationType", cdk.validateString)(properties.authorizationType)), errors.collect(cdk.propertyValidator("authorizerId", cdk.validateString)(properties.authorizerId)), errors.collect(cdk.propertyValidator("modelSelectionExpression", cdk.validateString)(properties.modelSelectionExpression)), errors.collect(cdk.propertyValidator("operationName", cdk.validateString)(properties.operationName)), errors.collect(cdk.propertyValidator("requestModels", cdk.validateObject)(properties.requestModels)), errors.collect(cdk.propertyValidator("requestParameters", cdk.validateObject)(properties.requestParameters)), errors.collect(cdk.propertyValidator("routeKey", cdk.requiredValidator)(properties.routeKey)), errors.collect(cdk.propertyValidator("routeKey", cdk.validateString)(properties.routeKey)), errors.collect(cdk.propertyValidator("routeResponseSelectionExpression", cdk.validateString)(properties.routeResponseSelectionExpression)), errors.collect(cdk.propertyValidator("target", cdk.validateString)(properties.target)), errors.wrap('supplied properties not correct for "CfnRouteProps"');
    }
    function cfnRoutePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoutePropsValidator(properties).assertSuccess(), { ApiId: cdk.stringToCloudFormation(properties.apiId), RouteKey: cdk.stringToCloudFormation(properties.routeKey), ApiKeyRequired: cdk.booleanToCloudFormation(properties.apiKeyRequired), AuthorizationScopes: cdk.listMapper(cdk.stringToCloudFormation)(properties.authorizationScopes), AuthorizationType: cdk.stringToCloudFormation(properties.authorizationType), AuthorizerId: cdk.stringToCloudFormation(properties.authorizerId), ModelSelectionExpression: cdk.stringToCloudFormation(properties.modelSelectionExpression), OperationName: cdk.stringToCloudFormation(properties.operationName), RequestModels: cdk.objectToCloudFormation(properties.requestModels), RequestParameters: cdk.objectToCloudFormation(properties.requestParameters), RouteResponseSelectionExpression: cdk.stringToCloudFormation(properties.routeResponseSelectionExpression), Target: cdk.stringToCloudFormation(properties.target) }) : properties;
    }
    function CfnRoutePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiId", "ApiId", cfn_parse.FromCloudFormation.getString(properties.ApiId)), ret.addPropertyResult("routeKey", "RouteKey", cfn_parse.FromCloudFormation.getString(properties.RouteKey)), ret.addPropertyResult("apiKeyRequired", "ApiKeyRequired", properties.ApiKeyRequired != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ApiKeyRequired) : void 0), ret.addPropertyResult("authorizationScopes", "AuthorizationScopes", properties.AuthorizationScopes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AuthorizationScopes) : void 0), ret.addPropertyResult("authorizationType", "AuthorizationType", properties.AuthorizationType != null ? cfn_parse.FromCloudFormation.getString(properties.AuthorizationType) : void 0), ret.addPropertyResult("authorizerId", "AuthorizerId", properties.AuthorizerId != null ? cfn_parse.FromCloudFormation.getString(properties.AuthorizerId) : void 0), ret.addPropertyResult("modelSelectionExpression", "ModelSelectionExpression", properties.ModelSelectionExpression != null ? cfn_parse.FromCloudFormation.getString(properties.ModelSelectionExpression) : void 0), ret.addPropertyResult("operationName", "OperationName", properties.OperationName != null ? cfn_parse.FromCloudFormation.getString(properties.OperationName) : void 0), ret.addPropertyResult("requestModels", "RequestModels", properties.RequestModels != null ? cfn_parse.FromCloudFormation.getAny(properties.RequestModels) : void 0), ret.addPropertyResult("requestParameters", "RequestParameters", properties.RequestParameters != null ? cfn_parse.FromCloudFormation.getAny(properties.RequestParameters) : void 0), ret.addPropertyResult("routeResponseSelectionExpression", "RouteResponseSelectionExpression", properties.RouteResponseSelectionExpression != null ? cfn_parse.FromCloudFormation.getString(properties.RouteResponseSelectionExpression) : void 0), ret.addPropertyResult("target", "Target", properties.Target != null ? cfn_parse.FromCloudFormation.getString(properties.Target) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRoute = class _CfnRoute extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRoutePropsFromCloudFormation(resourceProperties), ret = new _CfnRoute(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRoute.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigatewayv2_CfnRouteProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRoute), error;
        }
        cdk.requireProperty(props, "apiId", this), cdk.requireProperty(props, "routeKey", this), this.attrRouteId = cdk.Token.asString(this.getAtt("RouteId", cdk.ResolutionTypeHint.STRING)), this.apiId = props.apiId, this.routeKey = props.routeKey, this.apiKeyRequired = props.apiKeyRequired, this.authorizationScopes = props.authorizationScopes, this.authorizationType = props.authorizationType, this.authorizerId = props.authorizerId, this.modelSelectionExpression = props.modelSelectionExpression, this.operationName = props.operationName, this.requestModels = props.requestModels, this.requestParameters = props.requestParameters, this.routeResponseSelectionExpression = props.routeResponseSelectionExpression, this.target = props.target;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRoute.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiId: this.apiId, routeKey: this.routeKey, apiKeyRequired: this.apiKeyRequired, authorizationScopes: this.authorizationScopes, authorizationType: this.authorizationType, authorizerId: this.authorizerId, modelSelectionExpression: this.modelSelectionExpression, operationName: this.operationName, requestModels: this.requestModels, requestParameters: this.requestParameters, routeResponseSelectionExpression: this.routeResponseSelectionExpression, target: this.target };
      }
      renderProperties(props) {
        return cfnRoutePropsToCloudFormation(props);
      }
    };
    _k = JSII_RTTI_SYMBOL_1, CfnRoute[_k] = { fqn: "aws-cdk-lib.aws_apigatewayv2.CfnRoute", version: "2.80.0" }, CfnRoute.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGatewayV2::Route", exports2.CfnRoute = CfnRoute;
    function CfnRouteResponsePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiId", cdk.requiredValidator)(properties.apiId)), errors.collect(cdk.propertyValidator("apiId", cdk.validateString)(properties.apiId)), errors.collect(cdk.propertyValidator("modelSelectionExpression", cdk.validateString)(properties.modelSelectionExpression)), errors.collect(cdk.propertyValidator("responseModels", cdk.validateObject)(properties.responseModels)), errors.collect(cdk.propertyValidator("responseParameters", cdk.validateObject)(properties.responseParameters)), errors.collect(cdk.propertyValidator("routeId", cdk.requiredValidator)(properties.routeId)), errors.collect(cdk.propertyValidator("routeId", cdk.validateString)(properties.routeId)), errors.collect(cdk.propertyValidator("routeResponseKey", cdk.requiredValidator)(properties.routeResponseKey)), errors.collect(cdk.propertyValidator("routeResponseKey", cdk.validateString)(properties.routeResponseKey)), errors.wrap('supplied properties not correct for "CfnRouteResponseProps"');
    }
    function cfnRouteResponsePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRouteResponsePropsValidator(properties).assertSuccess(), { ApiId: cdk.stringToCloudFormation(properties.apiId), RouteId: cdk.stringToCloudFormation(properties.routeId), RouteResponseKey: cdk.stringToCloudFormation(properties.routeResponseKey), ModelSelectionExpression: cdk.stringToCloudFormation(properties.modelSelectionExpression), ResponseModels: cdk.objectToCloudFormation(properties.responseModels), ResponseParameters: cdk.objectToCloudFormation(properties.responseParameters) }) : properties;
    }
    function CfnRouteResponsePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiId", "ApiId", cfn_parse.FromCloudFormation.getString(properties.ApiId)), ret.addPropertyResult("routeId", "RouteId", cfn_parse.FromCloudFormation.getString(properties.RouteId)), ret.addPropertyResult("routeResponseKey", "RouteResponseKey", cfn_parse.FromCloudFormation.getString(properties.RouteResponseKey)), ret.addPropertyResult("modelSelectionExpression", "ModelSelectionExpression", properties.ModelSelectionExpression != null ? cfn_parse.FromCloudFormation.getString(properties.ModelSelectionExpression) : void 0), ret.addPropertyResult("responseModels", "ResponseModels", properties.ResponseModels != null ? cfn_parse.FromCloudFormation.getAny(properties.ResponseModels) : void 0), ret.addPropertyResult("responseParameters", "ResponseParameters", properties.ResponseParameters != null ? cfn_parse.FromCloudFormation.getAny(properties.ResponseParameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRouteResponse = class _CfnRouteResponse extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRouteResponsePropsFromCloudFormation(resourceProperties), ret = new _CfnRouteResponse(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRouteResponse.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigatewayv2_CfnRouteResponseProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRouteResponse), error;
        }
        cdk.requireProperty(props, "apiId", this), cdk.requireProperty(props, "routeId", this), cdk.requireProperty(props, "routeResponseKey", this), this.apiId = props.apiId, this.routeId = props.routeId, this.routeResponseKey = props.routeResponseKey, this.modelSelectionExpression = props.modelSelectionExpression, this.responseModels = props.responseModels, this.responseParameters = props.responseParameters;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRouteResponse.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiId: this.apiId, routeId: this.routeId, routeResponseKey: this.routeResponseKey, modelSelectionExpression: this.modelSelectionExpression, responseModels: this.responseModels, responseParameters: this.responseParameters };
      }
      renderProperties(props) {
        return cfnRouteResponsePropsToCloudFormation(props);
      }
    };
    _l = JSII_RTTI_SYMBOL_1, CfnRouteResponse[_l] = { fqn: "aws-cdk-lib.aws_apigatewayv2.CfnRouteResponse", version: "2.80.0" }, CfnRouteResponse.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGatewayV2::RouteResponse", exports2.CfnRouteResponse = CfnRouteResponse;
    function CfnStagePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessLogSettings", CfnStage_AccessLogSettingsPropertyValidator)(properties.accessLogSettings)), errors.collect(cdk.propertyValidator("accessPolicyId", cdk.validateString)(properties.accessPolicyId)), errors.collect(cdk.propertyValidator("apiId", cdk.requiredValidator)(properties.apiId)), errors.collect(cdk.propertyValidator("apiId", cdk.validateString)(properties.apiId)), errors.collect(cdk.propertyValidator("autoDeploy", cdk.validateBoolean)(properties.autoDeploy)), errors.collect(cdk.propertyValidator("clientCertificateId", cdk.validateString)(properties.clientCertificateId)), errors.collect(cdk.propertyValidator("defaultRouteSettings", CfnStage_RouteSettingsPropertyValidator)(properties.defaultRouteSettings)), errors.collect(cdk.propertyValidator("deploymentId", cdk.validateString)(properties.deploymentId)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("routeSettings", cdk.validateObject)(properties.routeSettings)), errors.collect(cdk.propertyValidator("stageName", cdk.requiredValidator)(properties.stageName)), errors.collect(cdk.propertyValidator("stageName", cdk.validateString)(properties.stageName)), errors.collect(cdk.propertyValidator("stageVariables", cdk.validateObject)(properties.stageVariables)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.wrap('supplied properties not correct for "CfnStageProps"');
    }
    function cfnStagePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStagePropsValidator(properties).assertSuccess(), { ApiId: cdk.stringToCloudFormation(properties.apiId), StageName: cdk.stringToCloudFormation(properties.stageName), AccessLogSettings: cfnStageAccessLogSettingsPropertyToCloudFormation(properties.accessLogSettings), AccessPolicyId: cdk.stringToCloudFormation(properties.accessPolicyId), AutoDeploy: cdk.booleanToCloudFormation(properties.autoDeploy), ClientCertificateId: cdk.stringToCloudFormation(properties.clientCertificateId), DefaultRouteSettings: cfnStageRouteSettingsPropertyToCloudFormation(properties.defaultRouteSettings), DeploymentId: cdk.stringToCloudFormation(properties.deploymentId), Description: cdk.stringToCloudFormation(properties.description), RouteSettings: cdk.objectToCloudFormation(properties.routeSettings), StageVariables: cdk.objectToCloudFormation(properties.stageVariables), Tags: cdk.objectToCloudFormation(properties.tags) }) : properties;
    }
    function CfnStagePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiId", "ApiId", cfn_parse.FromCloudFormation.getString(properties.ApiId)), ret.addPropertyResult("stageName", "StageName", cfn_parse.FromCloudFormation.getString(properties.StageName)), ret.addPropertyResult("accessLogSettings", "AccessLogSettings", properties.AccessLogSettings != null ? CfnStageAccessLogSettingsPropertyFromCloudFormation(properties.AccessLogSettings) : void 0), ret.addPropertyResult("accessPolicyId", "AccessPolicyId", properties.AccessPolicyId != null ? cfn_parse.FromCloudFormation.getString(properties.AccessPolicyId) : void 0), ret.addPropertyResult("autoDeploy", "AutoDeploy", properties.AutoDeploy != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AutoDeploy) : void 0), ret.addPropertyResult("clientCertificateId", "ClientCertificateId", properties.ClientCertificateId != null ? cfn_parse.FromCloudFormation.getString(properties.ClientCertificateId) : void 0), ret.addPropertyResult("defaultRouteSettings", "DefaultRouteSettings", properties.DefaultRouteSettings != null ? CfnStageRouteSettingsPropertyFromCloudFormation(properties.DefaultRouteSettings) : void 0), ret.addPropertyResult("deploymentId", "DeploymentId", properties.DeploymentId != null ? cfn_parse.FromCloudFormation.getString(properties.DeploymentId) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("routeSettings", "RouteSettings", properties.RouteSettings != null ? cfn_parse.FromCloudFormation.getAny(properties.RouteSettings) : void 0), ret.addPropertyResult("stageVariables", "StageVariables", properties.StageVariables != null ? cfn_parse.FromCloudFormation.getAny(properties.StageVariables) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnStage = class _CfnStage extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnStagePropsFromCloudFormation(resourceProperties), ret = new _CfnStage(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnStage.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigatewayv2_CfnStageProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnStage), error;
        }
        cdk.requireProperty(props, "apiId", this), cdk.requireProperty(props, "stageName", this), this.apiId = props.apiId, this.stageName = props.stageName, this.accessLogSettings = props.accessLogSettings, this.accessPolicyId = props.accessPolicyId, this.autoDeploy = props.autoDeploy, this.clientCertificateId = props.clientCertificateId, this.defaultRouteSettings = props.defaultRouteSettings, this.deploymentId = props.deploymentId, this.description = props.description, this.routeSettings = props.routeSettings, this.stageVariables = props.stageVariables, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::ApiGatewayV2::Stage", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStage.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiId: this.apiId, stageName: this.stageName, accessLogSettings: this.accessLogSettings, accessPolicyId: this.accessPolicyId, autoDeploy: this.autoDeploy, clientCertificateId: this.clientCertificateId, defaultRouteSettings: this.defaultRouteSettings, deploymentId: this.deploymentId, description: this.description, routeSettings: this.routeSettings, stageVariables: this.stageVariables, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnStagePropsToCloudFormation(props);
      }
    };
    _m = JSII_RTTI_SYMBOL_1, CfnStage[_m] = { fqn: "aws-cdk-lib.aws_apigatewayv2.CfnStage", version: "2.80.0" }, CfnStage.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGatewayV2::Stage", exports2.CfnStage = CfnStage;
    function CfnStage_AccessLogSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationArn", cdk.validateString)(properties.destinationArn)), errors.collect(cdk.propertyValidator("format", cdk.validateString)(properties.format)), errors.wrap('supplied properties not correct for "AccessLogSettingsProperty"');
    }
    function cfnStageAccessLogSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStage_AccessLogSettingsPropertyValidator(properties).assertSuccess(), { DestinationArn: cdk.stringToCloudFormation(properties.destinationArn), Format: cdk.stringToCloudFormation(properties.format) }) : properties;
    }
    function CfnStageAccessLogSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationArn", "DestinationArn", properties.DestinationArn != null ? cfn_parse.FromCloudFormation.getString(properties.DestinationArn) : void 0), ret.addPropertyResult("format", "Format", properties.Format != null ? cfn_parse.FromCloudFormation.getString(properties.Format) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStage_RouteSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataTraceEnabled", cdk.validateBoolean)(properties.dataTraceEnabled)), errors.collect(cdk.propertyValidator("detailedMetricsEnabled", cdk.validateBoolean)(properties.detailedMetricsEnabled)), errors.collect(cdk.propertyValidator("loggingLevel", cdk.validateString)(properties.loggingLevel)), errors.collect(cdk.propertyValidator("throttlingBurstLimit", cdk.validateNumber)(properties.throttlingBurstLimit)), errors.collect(cdk.propertyValidator("throttlingRateLimit", cdk.validateNumber)(properties.throttlingRateLimit)), errors.wrap('supplied properties not correct for "RouteSettingsProperty"');
    }
    function cfnStageRouteSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStage_RouteSettingsPropertyValidator(properties).assertSuccess(), { DataTraceEnabled: cdk.booleanToCloudFormation(properties.dataTraceEnabled), DetailedMetricsEnabled: cdk.booleanToCloudFormation(properties.detailedMetricsEnabled), LoggingLevel: cdk.stringToCloudFormation(properties.loggingLevel), ThrottlingBurstLimit: cdk.numberToCloudFormation(properties.throttlingBurstLimit), ThrottlingRateLimit: cdk.numberToCloudFormation(properties.throttlingRateLimit) }) : properties;
    }
    function CfnStageRouteSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataTraceEnabled", "DataTraceEnabled", properties.DataTraceEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DataTraceEnabled) : void 0), ret.addPropertyResult("detailedMetricsEnabled", "DetailedMetricsEnabled", properties.DetailedMetricsEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DetailedMetricsEnabled) : void 0), ret.addPropertyResult("loggingLevel", "LoggingLevel", properties.LoggingLevel != null ? cfn_parse.FromCloudFormation.getString(properties.LoggingLevel) : void 0), ret.addPropertyResult("throttlingBurstLimit", "ThrottlingBurstLimit", properties.ThrottlingBurstLimit != null ? cfn_parse.FromCloudFormation.getNumber(properties.ThrottlingBurstLimit) : void 0), ret.addPropertyResult("throttlingRateLimit", "ThrottlingRateLimit", properties.ThrottlingRateLimit != null ? cfn_parse.FromCloudFormation.getNumber(properties.ThrottlingRateLimit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVpcLinkPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.requiredValidator)(properties.subnetIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.wrap('supplied properties not correct for "CfnVpcLinkProps"');
    }
    function cfnVpcLinkPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVpcLinkPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds), SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnVpcLinkPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("subnetIds", "SubnetIds", cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds)), ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVpcLink = class _CfnVpcLink extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVpcLinkPropsFromCloudFormation(resourceProperties), ret = new _CfnVpcLink(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVpcLink.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigatewayv2_CfnVpcLinkProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVpcLink), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "subnetIds", this), this.attrVpcLinkId = cdk.Token.asString(this.getAtt("VpcLinkId", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.subnetIds = props.subnetIds, this.securityGroupIds = props.securityGroupIds, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::ApiGatewayV2::VpcLink", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVpcLink.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, subnetIds: this.subnetIds, securityGroupIds: this.securityGroupIds, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnVpcLinkPropsToCloudFormation(props);
      }
    };
    _o = JSII_RTTI_SYMBOL_1, CfnVpcLink[_o] = { fqn: "aws-cdk-lib.aws_apigatewayv2.CfnVpcLink", version: "2.80.0" }, CfnVpcLink.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGatewayV2::VpcLink", exports2.CfnVpcLink = CfnVpcLink;
  }
});

// node_modules/aws-cdk-lib/aws-apigatewayv2/lib/index.js
var require_lib38 = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigatewayv2/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_apigatewayv2_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-apigatewayv2/index.js
var require_aws_apigatewayv2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigatewayv2/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib38(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/domain-name.js
var require_domain_name = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/domain-name.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DomainName = exports2.SecurityPolicy = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var apigateway_generated_1 = require_apigateway_generated();
    var base_path_mapping_1 = require_base_path_mapping();
    var restapi_1 = require_restapi();
    var apigwv2 = require_aws_apigatewayv2();
    var core_1 = require_core2();
    var SecurityPolicy;
    (function(SecurityPolicy2) {
      SecurityPolicy2.TLS_1_0 = "TLS_1_0", SecurityPolicy2.TLS_1_2 = "TLS_1_2";
    })(SecurityPolicy = exports2.SecurityPolicy || (exports2.SecurityPolicy = {}));
    var DomainName = class _DomainName extends core_1.Resource {
      static fromDomainNameAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_DomainNameAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromDomainNameAttributes), error;
        }
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.domainName = attrs.domainName, this.domainNameAliasDomainName = attrs.domainNameAliasTarget, this.domainNameAliasHostedZoneId = attrs.domainNameAliasHostedZoneId;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id), this.basePaths = /* @__PURE__ */ new Set();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_DomainNameProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _DomainName), error;
        }
        this.endpointType = props.endpointType || restapi_1.EndpointType.REGIONAL;
        const edge = this.endpointType === restapi_1.EndpointType.EDGE;
        if (this.securityPolicy = props.securityPolicy, !core_1.Token.isUnresolved(props.domainName) && /[A-Z]/.test(props.domainName))
          throw new Error(`Domain name does not support uppercase letters. Got: ${props.domainName}`);
        const mtlsConfig = this.configureMTLS(props.mtls), resource = new apigateway_generated_1.CfnDomainName(this, "Resource", { domainName: props.domainName, certificateArn: edge ? props.certificate.certificateArn : void 0, regionalCertificateArn: edge ? void 0 : props.certificate.certificateArn, endpointConfiguration: { types: [this.endpointType] }, mutualTlsAuthentication: mtlsConfig, securityPolicy: props.securityPolicy });
        this.domainName = resource.ref, this.domainNameAliasDomainName = edge ? resource.attrDistributionDomainName : resource.attrRegionalDomainName, this.domainNameAliasHostedZoneId = edge ? resource.attrDistributionHostedZoneId : resource.attrRegionalHostedZoneId;
        const multiLevel = this.validateBasePath(props.basePath);
        props.mapping && !multiLevel ? this.addBasePathMapping(props.mapping, { basePath: props.basePath }) : props.mapping && multiLevel && this.addApiMapping(props.mapping.deploymentStage, { basePath: props.basePath });
      }
      validateBasePath(path) {
        if (this.isMultiLevel(path)) {
          if (this.endpointType === restapi_1.EndpointType.EDGE)
            throw new Error("multi-level basePath is only supported when endpointType is EndpointType.REGIONAL");
          if (this.securityPolicy && this.securityPolicy !== SecurityPolicy.TLS_1_2)
            throw new Error("securityPolicy must be set to TLS_1_2 if multi-level basePath is provided");
          return true;
        }
        return false;
      }
      isMultiLevel(path) {
        return (path?.split("/").filter((x) => !!x) ?? []).length >= 2;
      }
      addBasePathMapping(targetApi, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_IRestApi(targetApi), jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_BasePathMappingOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addBasePathMapping), error;
        }
        if (this.basePaths.has(options.basePath))
          throw new Error(`DomainName ${this.node.id} already has a mapping for path ${options.basePath}`);
        if (this.isMultiLevel(options.basePath))
          throw new Error('BasePathMapping does not support multi-level paths. Use "addApiMapping instead.');
        this.basePaths.add(options.basePath);
        const id = `Map:${options.basePath || "/"}=>${core_1.Names.nodeUniqueId(targetApi.node)}`;
        return new base_path_mapping_1.BasePathMapping(this, id, { domainName: this, restApi: targetApi, ...options });
      }
      addApiMapping(targetStage, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_IStage(targetStage), jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_ApiMappingOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addApiMapping), error;
        }
        if (this.basePaths.has(options.basePath))
          throw new Error(`DomainName ${this.node.id} already has a mapping for path ${options.basePath}`);
        this.validateBasePath(options.basePath), this.basePaths.add(options.basePath);
        const id = `Map:${options.basePath ?? "none"}=>${core_1.Names.nodeUniqueId(targetStage.node)}`;
        new apigwv2.CfnApiMapping(this, id, { apiId: targetStage.restApi.restApiId, stage: targetStage.stageName, domainName: this.domainName, apiMappingKey: options.basePath });
      }
      configureMTLS(mtlsConfig) {
        if (mtlsConfig)
          return { truststoreUri: mtlsConfig.bucket.s3UrlForObject(mtlsConfig.key), truststoreVersion: mtlsConfig.version };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, DomainName[_a] = { fqn: "aws-cdk-lib.aws_apigateway.DomainName", version: "2.80.0" }, exports2.DomainName = DomainName;
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/gateway-response.js
var require_gateway_response = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/gateway-response.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ResponseType = exports2.GatewayResponse = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var apigateway_generated_1 = require_apigateway_generated();
    var core_1 = require_core2();
    var GatewayResponse = class _GatewayResponse extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_GatewayResponseProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _GatewayResponse), error;
        }
        const gatewayResponseProps = { restApiId: props.restApi.restApiId, responseType: props.type.responseType, responseParameters: this.buildResponseParameters(props.responseHeaders), responseTemplates: props.templates, statusCode: props.statusCode }, resource = new apigateway_generated_1.CfnGatewayResponse(this, "Resource", gatewayResponseProps), deployment = props.restApi.latestDeployment;
        deployment && (deployment.node.addDependency(resource), deployment.addToLogicalId({ gatewayResponse: { ...gatewayResponseProps } })), this.node.defaultChild = resource;
      }
      buildResponseParameters(responseHeaders) {
        if (!responseHeaders)
          return;
        const responseParameters = {};
        for (const [header, value] of Object.entries(responseHeaders))
          responseParameters[`gatewayresponse.header.${header}`] = value;
        return responseParameters;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, GatewayResponse[_a] = { fqn: "aws-cdk-lib.aws_apigateway.GatewayResponse", version: "2.80.0" }, exports2.GatewayResponse = GatewayResponse;
    var ResponseType = class _ResponseType {
      static of(type) {
        return new _ResponseType(type.toUpperCase());
      }
      constructor(type) {
        this.responseType = type;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, ResponseType[_b] = { fqn: "aws-cdk-lib.aws_apigateway.ResponseType", version: "2.80.0" }, ResponseType.ACCESS_DENIED = new ResponseType("ACCESS_DENIED"), ResponseType.API_CONFIGURATION_ERROR = new ResponseType("API_CONFIGURATION_ERROR"), ResponseType.AUTHORIZER_FAILURE = new ResponseType("AUTHORIZER_FAILURE"), ResponseType.AUTHORIZER_CONFIGURATION_ERROR = new ResponseType("AUTHORIZER_CONFIGURATION_ERROR"), ResponseType.BAD_REQUEST_PARAMETERS = new ResponseType("BAD_REQUEST_PARAMETERS"), ResponseType.BAD_REQUEST_BODY = new ResponseType("BAD_REQUEST_BODY"), ResponseType.DEFAULT_4XX = new ResponseType("DEFAULT_4XX"), ResponseType.DEFAULT_5XX = new ResponseType("DEFAULT_5XX"), ResponseType.EXPIRED_TOKEN = new ResponseType("EXPIRED_TOKEN"), ResponseType.INVALID_SIGNATURE = new ResponseType("INVALID_SIGNATURE"), ResponseType.INTEGRATION_FAILURE = new ResponseType("INTEGRATION_FAILURE"), ResponseType.INTEGRATION_TIMEOUT = new ResponseType("INTEGRATION_TIMEOUT"), ResponseType.INVALID_API_KEY = new ResponseType("INVALID_API_KEY"), ResponseType.MISSING_AUTHENTICATION_TOKEN = new ResponseType("MISSING_AUTHENTICATION_TOKEN"), ResponseType.QUOTA_EXCEEDED = new ResponseType("QUOTA_EXCEEDED"), ResponseType.REQUEST_TOO_LARGE = new ResponseType("REQUEST_TOO_LARGE"), ResponseType.RESOURCE_NOT_FOUND = new ResponseType("RESOURCE_NOT_FOUND"), ResponseType.THROTTLED = new ResponseType("THROTTLED"), ResponseType.UNAUTHORIZED = new ResponseType("UNAUTHORIZED"), ResponseType.UNSUPPORTED_MEDIA_TYPE = new ResponseType("UNSUPPORTED_MEDIA_TYPE"), ResponseType.WAF_FILTERED = new ResponseType("WAF_FILTERED"), exports2.ResponseType = ResponseType;
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/model.js
var require_model = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/model.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Model = exports2.ErrorModel = exports2.EmptyModel = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var apigateway_generated_1 = require_apigateway_generated();
    var restapi_1 = require_restapi();
    var util = require_util13();
    var core_1 = require_core2();
    var EmptyModel = class {
      constructor() {
        this.modelId = "Empty";
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EmptyModel[_a] = { fqn: "aws-cdk-lib.aws_apigateway.EmptyModel", version: "2.80.0" }, exports2.EmptyModel = EmptyModel;
    var ErrorModel = class {
      constructor() {
        this.modelId = "Error";
      }
    };
    _b = JSII_RTTI_SYMBOL_1, ErrorModel[_b] = { fqn: "aws-cdk-lib.aws_apigateway.ErrorModel", version: "2.80.0" }, exports2.ErrorModel = ErrorModel;
    var Model = class _Model extends core_1.Resource {
      static fromModelName(scope, id, modelName) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.modelId = modelName;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.modelName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_ModelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Model), error;
        }
        const modelProps = { name: this.physicalName, restApiId: props.restApi.restApiId, contentType: props.contentType ?? "application/json", description: props.description, schema: util.JsonSchemaMapper.toCfnJsonSchema(props.schema) }, resource = new apigateway_generated_1.CfnModel(this, "Resource", modelProps);
        this.modelId = this.getResourceNameAttribute(resource.ref);
        const deployment = props.restApi instanceof restapi_1.RestApi ? props.restApi.latestDeployment : void 0;
        deployment && (deployment.node.addDependency(resource), deployment.addToLogicalId({ model: modelProps }));
      }
    };
    _c = JSII_RTTI_SYMBOL_1, Model[_c] = { fqn: "aws-cdk-lib.aws_apigateway.Model", version: "2.80.0" }, Model.ERROR_MODEL = new ErrorModel(), Model.EMPTY_MODEL = new EmptyModel(), exports2.Model = Model;
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/requestvalidator.js
var require_requestvalidator = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/requestvalidator.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.RequestValidator = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var apigateway_generated_1 = require_apigateway_generated();
    var restapi_1 = require_restapi();
    var core_1 = require_core2();
    var RequestValidator = class _RequestValidator extends core_1.Resource {
      static fromRequestValidatorId(scope, id, requestValidatorId) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.requestValidatorId = requestValidatorId;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.requestValidatorName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_RequestValidatorProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _RequestValidator), error;
        }
        const validatorProps = { name: this.physicalName, restApiId: props.restApi.restApiId, validateRequestBody: props.validateRequestBody, validateRequestParameters: props.validateRequestParameters }, resource = new apigateway_generated_1.CfnRequestValidator(this, "Resource", validatorProps);
        this.requestValidatorId = resource.ref;
        const deployment = props.restApi instanceof restapi_1.RestApi ? props.restApi.latestDeployment : void 0;
        deployment && (deployment.node.addDependency(resource), deployment.addToLogicalId({ validator: validatorProps }));
      }
    };
    _a = JSII_RTTI_SYMBOL_1, RequestValidator[_a] = { fqn: "aws-cdk-lib.aws_apigateway.RequestValidator", version: "2.80.0" }, exports2.RequestValidator = RequestValidator;
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/cors.js
var require_cors = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/cors.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Cors = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var util_1 = require_util13();
    var Cors = class {
      constructor() {
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Cors[_a] = { fqn: "aws-cdk-lib.aws_apigateway.Cors", version: "2.80.0" }, Cors.ALL_METHODS = util_1.ALL_METHODS, Cors.ALL_ORIGINS = ["*"], Cors.DEFAULT_HEADERS = ["Content-Type", "X-Amz-Date", "Authorization", "X-Api-Key", "X-Amz-Security-Token", "X-Amz-User-Agent"], exports2.Cors = Cors;
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/vpc-link.js
var require_vpc_link = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/vpc-link.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.VpcLink = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var apigateway_generated_1 = require_apigateway_generated();
    var core_1 = require_core2();
    var VpcLink = class _VpcLink extends core_1.Resource {
      static fromVpcLinkId(scope, id, vpcLinkId) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.vpcLinkId = vpcLinkId;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.vpcLinkName || core_1.Lazy.string({ produce: () => core_1.Names.nodeUniqueId(this.node) }) }), this._targets = new Array();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_VpcLinkProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _VpcLink), error;
        }
        const cfnResource = new apigateway_generated_1.CfnVpcLink(this, "Resource", { name: this.physicalName, description: props.description, targetArns: core_1.Lazy.list({ produce: () => this.renderTargets() }) });
        this.vpcLinkId = cfnResource.ref, props.targets && this.addTargets(...props.targets), this.node.addValidation({ validate: () => this.validateVpcLink() });
      }
      addTargets(...targets) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_INetworkLoadBalancer(targets);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addTargets), error;
        }
        this._targets.push(...targets);
      }
      get _targetDnsNames() {
        return this._targets.map((t) => t.loadBalancerDnsName);
      }
      validateVpcLink() {
        return this._targets.length === 0 ? ["No targets added to vpc link"] : [];
      }
      renderTargets() {
        return this._targets.map((nlb) => nlb.loadBalancerArn);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, VpcLink[_a] = { fqn: "aws-cdk-lib.aws_apigateway.VpcLink", version: "2.80.0" }, exports2.VpcLink = VpcLink;
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/integration.js
var require_integration = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/integration.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ConnectionType = exports2.PassthroughBehavior = exports2.IntegrationType = exports2.ContentHandling = exports2.Integration = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var vpc_link_1 = require_vpc_link();
    var core_1 = require_core2();
    var Integration = class _Integration {
      constructor(props) {
        this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_IntegrationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Integration), error;
        }
        const options = this.props.options || {};
        if (options.credentialsPassthrough !== void 0 && options.credentialsRole !== void 0)
          throw new Error("'credentialsPassthrough' and 'credentialsRole' are mutually exclusive");
        if (options.connectionType === ConnectionType.VPC_LINK && options.vpcLink === void 0)
          throw new Error("'connectionType' of VPC_LINK requires 'vpcLink' prop to be set");
        if (options.connectionType === ConnectionType.INTERNET && options.vpcLink !== void 0)
          throw new Error("cannot set 'vpcLink' where 'connectionType' is INTERNET");
        if (options.timeout && !options.timeout.isUnresolved() && (options.timeout.toMilliseconds() < 50 || options.timeout.toMilliseconds() > 29e3))
          throw new Error("Integration timeout must be between 50 milliseconds and 29 seconds.");
      }
      bind(_method) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_Method(_method);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        let uri = this.props.uri;
        const options = this.props.options;
        return options?.connectionType === ConnectionType.VPC_LINK && uri === void 0 && (uri = core_1.Lazy.string({ produce: () => {
          const vpcLink = options.vpcLink;
          if (vpcLink instanceof vpc_link_1.VpcLink) {
            const targets = vpcLink._targetDnsNames;
            if (targets.length > 1)
              throw new Error("'uri' is required when there are more than one NLBs in the VPC Link");
            return `http://${targets[0]}`;
          } else
            throw new Error("'uri' is required when the 'connectionType' is VPC_LINK");
        } })), { options: { ...options, connectionType: options?.vpcLink ? ConnectionType.VPC_LINK : options?.connectionType }, type: this.props.type, uri, integrationHttpMethod: this.props.integrationHttpMethod };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Integration[_a] = { fqn: "aws-cdk-lib.aws_apigateway.Integration", version: "2.80.0" }, exports2.Integration = Integration;
    var ContentHandling;
    (function(ContentHandling2) {
      ContentHandling2.CONVERT_TO_BINARY = "CONVERT_TO_BINARY", ContentHandling2.CONVERT_TO_TEXT = "CONVERT_TO_TEXT";
    })(ContentHandling = exports2.ContentHandling || (exports2.ContentHandling = {}));
    var IntegrationType;
    (function(IntegrationType2) {
      IntegrationType2.AWS = "AWS", IntegrationType2.AWS_PROXY = "AWS_PROXY", IntegrationType2.HTTP = "HTTP", IntegrationType2.HTTP_PROXY = "HTTP_PROXY", IntegrationType2.MOCK = "MOCK";
    })(IntegrationType = exports2.IntegrationType || (exports2.IntegrationType = {}));
    var PassthroughBehavior;
    (function(PassthroughBehavior2) {
      PassthroughBehavior2.WHEN_NO_MATCH = "WHEN_NO_MATCH", PassthroughBehavior2.NEVER = "NEVER", PassthroughBehavior2.WHEN_NO_TEMPLATES = "WHEN_NO_TEMPLATES";
    })(PassthroughBehavior = exports2.PassthroughBehavior || (exports2.PassthroughBehavior = {}));
    var ConnectionType;
    (function(ConnectionType2) {
      ConnectionType2.INTERNET = "INTERNET", ConnectionType2.VPC_LINK = "VPC_LINK";
    })(ConnectionType = exports2.ConnectionType || (exports2.ConnectionType = {}));
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/integrations/aws.js
var require_aws2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/integrations/aws.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AwsIntegration = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var core_1 = require_core2();
    var integration_1 = require_integration();
    var util_1 = require_util13();
    var AwsIntegration = class _AwsIntegration extends integration_1.Integration {
      constructor(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_AwsIntegrationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AwsIntegration), error;
        }
        const backend = props.subdomain ? `${props.subdomain}.${props.service}` : props.service, type = props.proxy ? integration_1.IntegrationType.AWS_PROXY : integration_1.IntegrationType.AWS, { apiType, apiValue } = (0, util_1.parseAwsApiCall)(props.path, props.action, props.actionParameters);
        super({ type, integrationHttpMethod: props.integrationHttpMethod || "POST", uri: cdk.Lazy.string({ produce: () => {
          if (!this.scope)
            throw new Error("AwsIntegration must be used in API");
          return cdk.Stack.of(this.scope).formatArn({ service: "apigateway", account: backend, resource: apiType, arnFormat: core_1.ArnFormat.SLASH_RESOURCE_NAME, resourceName: apiValue, region: props.region });
        } }), options: props.options });
      }
      bind(method) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_Method(method);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        const bindResult = super.bind(method);
        return this.scope = method, bindResult;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AwsIntegration[_a] = { fqn: "aws-cdk-lib.aws_apigateway.AwsIntegration", version: "2.80.0" }, exports2.AwsIntegration = AwsIntegration;
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/integrations/lambda.js
var require_lambda3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/integrations/lambda.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LambdaIntegration = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var aws_1 = require_aws2();
    var iam = require_aws_iam();
    var lambda2 = require_aws_lambda();
    var core_1 = require_core2();
    var LambdaIntegration = class _LambdaIntegration extends aws_1.AwsIntegration {
      constructor(handler2, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_IFunction(handler2), jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_LambdaIntegrationOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _LambdaIntegration), error;
        }
        const proxy = options.proxy ?? true;
        super({ proxy, service: "lambda", path: `2015-03-31/functions/${handler2.functionArn}/invocations`, options }), this.handler = handler2, this.enableTest = options.allowTestInvoke ?? true;
      }
      bind(method) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_Method(method);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        const bindResult = super.bind(method), principal = new iam.ServicePrincipal("apigateway.amazonaws.com"), desc = `${core_1.Names.nodeUniqueId(method.api.node)}.${method.httpMethod}.${method.resource.path.replace(/\//g, ".")}`;
        this.handler.addPermission(`ApiPermission.${desc}`, { principal, scope: method, sourceArn: core_1.Lazy.string({ produce: () => method.methodArn }) }), this.enableTest && this.handler.addPermission(`ApiPermission.Test.${desc}`, { principal, scope: method, sourceArn: method.testMethodArn });
        let functionName;
        this.handler instanceof lambda2.Function ? functionName = this.handler.node.defaultChild.functionName : functionName = this.handler.functionName;
        let deploymentToken;
        return core_1.Token.isUnresolved(functionName) || (deploymentToken = JSON.stringify({ functionName })), { ...bindResult, deploymentToken };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LambdaIntegration[_a] = { fqn: "aws-cdk-lib.aws_apigateway.LambdaIntegration", version: "2.80.0" }, exports2.LambdaIntegration = LambdaIntegration;
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/integrations/http.js
var require_http2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/integrations/http.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.HttpIntegration = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var integration_1 = require_integration();
    var HttpIntegration = class _HttpIntegration extends integration_1.Integration {
      constructor(url, props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_HttpIntegrationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _HttpIntegration), error;
        }
        const proxy = props.proxy ?? true, method = props.httpMethod || "GET";
        super({ type: proxy ? integration_1.IntegrationType.HTTP_PROXY : integration_1.IntegrationType.HTTP, integrationHttpMethod: method, uri: url, options: props.options });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, HttpIntegration[_a] = { fqn: "aws-cdk-lib.aws_apigateway.HttpIntegration", version: "2.80.0" }, exports2.HttpIntegration = HttpIntegration;
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/integrations/mock.js
var require_mock = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/integrations/mock.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.MockIntegration = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var integration_1 = require_integration();
    var MockIntegration = class _MockIntegration extends integration_1.Integration {
      constructor(options) {
        super({ type: integration_1.IntegrationType.MOCK, options });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_IntegrationOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _MockIntegration), error;
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, MockIntegration[_a] = { fqn: "aws-cdk-lib.aws_apigateway.MockIntegration", version: "2.80.0" }, exports2.MockIntegration = MockIntegration;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions/lib/private/intrinstics.js
var require_intrinstics = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions/lib/private/intrinstics.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.IntrinsicParser = void 0;
    var IntrinsicParser = class {
      constructor(expression) {
        this.expression = expression, this.i = 0;
      }
      parseTopLevelIntrinsic() {
        this.ws();
        let ret;
        return this.char() === "$" ? ret = this.parsePath() : isAlphaNum(this.char()) ? ret = this.parseFnCall() : this.raiseError("expected '$' or a function call"), this.ws(), this.eof || this.raiseError("unexpected trailing characters"), ret;
      }
      parseIntrinsic() {
        if (this.ws(), this.char() === "$")
          return this.parsePath();
        if (isAlphaNum(this.char()))
          return this.parseFnCall();
        if (this.char() === "'")
          return this.parseStringLiteral();
        this.raiseError("expected $, function or single-quoted string");
      }
      parsePath() {
        const pathString = new Array();
        this.char() !== "$" && this.raiseError("expected '$'"), pathString.push(this.consume());
        let done = false;
        for (; !done && !this.eof; )
          switch (this.char()) {
            case ".":
            case "$":
              pathString.push(this.consume());
              break;
            case "'":
              const { quoted } = this.consumeQuotedString();
              pathString.push(quoted);
              break;
            case "[":
              pathString.push(this.consumeBracketedExpression("]"));
              break;
            default:
              if (isAlphaNum(this.char())) {
                pathString.push(this.consume());
                break;
              }
              done = true;
          }
        return { type: "path", path: pathString.join("") };
      }
      parseFnCall() {
        const name = new Array();
        for (; this.char() !== "("; )
          name.push(this.consume());
        this.next(), this.ws();
        const args = [];
        for (; this.char() !== ")"; )
          if (args.push(this.parseIntrinsic()), this.ws(), this.char() === ",") {
            this.next();
            continue;
          } else {
            if (this.char() === ")")
              continue;
            this.raiseError("expected , or )");
          }
        return this.next(), { type: "fncall", arguments: args, functionName: name.join("") };
      }
      parseStringLiteral() {
        const { unquoted } = this.consumeQuotedString();
        return { type: "string-literal", literal: unquoted };
      }
      consumeBracketedExpression(closingBrace) {
        const ret = new Array();
        for (ret.push(this.consume()); this.char() !== closingBrace; )
          this.char() === "[" ? ret.push(this.consumeBracketedExpression("]")) : this.char() === "{" ? ret.push(this.consumeBracketedExpression("}")) : ret.push(this.consume());
        return ret.push(this.consume()), ret.join("");
      }
      consumeQuotedString() {
        const quoted = new Array(), unquoted = new Array();
        for (quoted.push(this.consume()); this.char() !== "'"; )
          this.char() === "\\" && quoted.push(this.consume()), quoted.push(this.char()), unquoted.push(this.char()), this.next();
        return quoted.push(this.consume()), { quoted: quoted.join(""), unquoted: unquoted.join("") };
      }
      ws() {
        for (; !this.eof && [" ", "	", `
`].includes(this.char()); )
          this.next();
      }
      get eof() {
        return this.i >= this.expression.length;
      }
      char() {
        return this.eof && this.raiseError("unexpected end of string"), this.expression[this.i];
      }
      next() {
        this.i++;
      }
      consume() {
        const ret = this.char();
        return this.next(), ret;
      }
      raiseError(message) {
        throw new Error(`Invalid JSONPath expression: ${message} at index ${this.i} in ${JSON.stringify(this.expression)}`);
      }
    };
    exports2.IntrinsicParser = IntrinsicParser;
    function isAlphaNum(x) {
      return x.match(/^[a-zA-Z0-9]$/);
    }
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions/lib/private/json-path.js
var require_json_path = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions/lib/private/json-path.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.renderInExpression = exports2.jsonPathFromAny = exports2.jsonPathString = exports2.recurseObject = exports2.findReferencedPaths = exports2.renderObject = exports2.JsonPathToken = void 0;
    var intrinstics_1 = require_intrinstics();
    var core_1 = require_core2();
    var JSON_PATH_TOKEN_SYMBOL = Symbol.for("@aws-cdk/aws-stepfunctions.JsonPathToken");
    var JsonPathToken = class {
      static isJsonPathToken(x) {
        return x[JSON_PATH_TOKEN_SYMBOL] === true;
      }
      constructor(path) {
        this.path = path, this.creationStack = (0, core_1.captureStackTrace)(), this.displayHint = path.replace(/^[^a-zA-Z]+/, ""), Object.defineProperty(this, JSON_PATH_TOKEN_SYMBOL, { value: true });
      }
      resolve(_ctx) {
        return this.path;
      }
      toString() {
        return core_1.Token.asString(this, { displayHint: this.displayHint });
      }
      toJSON() {
        return `<path:${this.path}>`;
      }
    };
    exports2.JsonPathToken = JsonPathToken;
    function renderObject(obj) {
      return recurseObject(obj, { handleString: renderString, handleList: renderStringList, handleNumber: renderNumber, handleBoolean: renderBoolean, handleResolvable: renderResolvable });
    }
    exports2.renderObject = renderObject;
    function findReferencedPaths(obj) {
      const found = /* @__PURE__ */ new Set();
      return recurseObject(obj, { handleString(_key, x) {
        for (const p of findPathsInIntrinsicFunctions(jsonPathString(x)))
          found.add(p);
        return {};
      }, handleList(_key, x) {
        for (const p of findPathsInIntrinsicFunctions(jsonPathStringList(x)))
          found.add(p);
        return {};
      }, handleNumber(_key, x) {
        for (const p of findPathsInIntrinsicFunctions(jsonPathNumber(x)))
          found.add(p);
        return {};
      }, handleBoolean(_key, _x) {
        return {};
      }, handleResolvable(_key, x) {
        for (const p of findPathsInIntrinsicFunctions(jsonPathFromAny(x)))
          found.add(p);
        return {};
      } }), found;
    }
    exports2.findReferencedPaths = findReferencedPaths;
    function findPathsInIntrinsicFunctions(expression) {
      if (!expression)
        return [];
      const ret = new Array();
      try {
        const parsed = new intrinstics_1.IntrinsicParser(expression).parseTopLevelIntrinsic();
        return recurse(parsed), ret;
      } catch {
        return [expression];
      }
      function recurse(p) {
        switch (p.type) {
          case "path":
            ret.push(p.path);
            break;
          case "fncall":
            for (const arg of p.arguments)
              recurse(arg);
        }
      }
    }
    function recurseObject(obj, handlers, visited = []) {
      if (typeof obj != "object" || obj === null)
        return obj;
      if (visited.includes(obj))
        return {};
      visited.push(obj);
      const ret = {};
      for (const [key, value] of Object.entries(obj))
        typeof value == "string" ? Object.assign(ret, handlers.handleString(key, value)) : typeof value == "number" ? Object.assign(ret, handlers.handleNumber(key, value)) : Array.isArray(value) ? Object.assign(ret, recurseArray(key, value, handlers, visited)) : typeof value == "boolean" ? Object.assign(ret, handlers.handleBoolean(key, value)) : value == null || typeof value == "object" && (core_1.Tokenization.isResolvable(value) ? Object.assign(ret, handlers.handleResolvable(key, value)) : ret[key] = recurseObject(value, handlers, visited));
      return visited.pop(), ret;
    }
    exports2.recurseObject = recurseObject;
    function recurseArray(key, arr, handlers, visited = []) {
      return isStringArray(arr) && jsonPathStringList(arr) !== void 0 ? handlers.handleList(key, arr) : { [key]: arr.map((value) => {
        if (typeof value == "string" && jsonPathString(value) !== void 0 || typeof value == "number" && jsonPathNumber(value) !== void 0 || isStringArray(value) && jsonPathStringList(value) !== void 0)
          throw new Error("Cannot use JsonPath fields in an array, they must be used in objects");
        return typeof value == "object" && value !== null ? recurseObject(value, handlers, visited) : value;
      }) };
    }
    function isStringArray(x) {
      return Array.isArray(x) && x.every((el) => typeof el == "string");
    }
    function renderString(key, value) {
      const path = jsonPathString(value);
      return path !== void 0 ? { [key + ".$"]: path } : { [key]: value };
    }
    function renderResolvable(key, value) {
      const path = jsonPathFromAny(value);
      return path !== void 0 ? { [key + ".$"]: path } : { [key]: value };
    }
    function renderStringList(key, value) {
      const path = jsonPathStringList(value);
      return path !== void 0 ? { [key + ".$"]: path } : { [key]: value };
    }
    function renderNumber(key, value) {
      const path = jsonPathNumber(value);
      return path !== void 0 ? { [key + ".$"]: path } : { [key]: value };
    }
    function renderBoolean(key, value) {
      return { [key]: value };
    }
    function jsonPathString(x) {
      const fragments = core_1.Tokenization.reverseString(x), jsonPathTokens = fragments.tokens.filter(JsonPathToken.isJsonPathToken);
      if (jsonPathTokens.length > 0 && fragments.length > 1)
        throw new Error(`Field references must be the entire string, cannot concatenate them (found '${x}')`);
      if (jsonPathTokens.length > 0)
        return jsonPathTokens[0].path;
    }
    exports2.jsonPathString = jsonPathString;
    function jsonPathFromAny(x) {
      if (x)
        return typeof x == "string" ? jsonPathString(x) : pathFromToken(core_1.Tokenization.reverse(x));
    }
    exports2.jsonPathFromAny = jsonPathFromAny;
    function jsonPathStringList(x) {
      return pathFromToken(core_1.Tokenization.reverseList(x));
    }
    function jsonPathNumber(x) {
      return pathFromToken(core_1.Tokenization.reverseNumber(x));
    }
    function pathFromToken(token) {
      return token && (JsonPathToken.isJsonPathToken(token) ? token.path : void 0);
    }
    function renderInExpression(x) {
      const path = jsonPathFromAny(x);
      if (path)
        return path;
      if (typeof x == "number")
        return x.toString(10);
      if (typeof x == "string")
        return singleQuotestring(x);
      throw new Error("Unxexpected value.");
    }
    exports2.renderInExpression = renderInExpression;
    function singleQuotestring(x) {
      const ret = new Array();
      ret.push("'");
      for (const c of x)
        c === "'" ? ret.push("\\'") : c === "\\" ? ret.push("\\\\") : c === `
` ? ret.push("\\n") : ret.push(c);
      return ret.push("'"), ret.join("");
    }
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions/lib/fields.js
var require_fields = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions/lib/fields.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FieldUtils = exports2.Context = exports2.Data = exports2.JsonPath = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var json_path_1 = require_json_path();
    var core_1 = require_core2();
    var JsonPath = class {
      static stringAt(path) {
        return validateJsonPath(path), new json_path_1.JsonPathToken(path).toString();
      }
      static listAt(path) {
        return validateDataPath(path), core_1.Token.asList(new json_path_1.JsonPathToken(path));
      }
      static numberAt(path) {
        return validateJsonPath(path), core_1.Token.asNumber(new json_path_1.JsonPathToken(path));
      }
      static objectAt(path) {
        return validateJsonPath(path), new json_path_1.JsonPathToken(path);
      }
      static get entirePayload() {
        return new json_path_1.JsonPathToken("$").toString();
      }
      static isEncodedJsonPath(value) {
        return !!(0, json_path_1.jsonPathString)(value);
      }
      static get taskToken() {
        return new json_path_1.JsonPathToken("$$.Task.Token").toString();
      }
      static get entireContext() {
        return new json_path_1.JsonPathToken("$$").toString();
      }
      static array(...values) {
        return new json_path_1.JsonPathToken(`States.Array(${values.map(json_path_1.renderInExpression).join(", ")})`).toString();
      }
      static arrayPartition(array, chunkSize) {
        return new json_path_1.JsonPathToken(`States.ArrayPartition(${[array, chunkSize].map(json_path_1.renderInExpression).join(", ")})`).toString();
      }
      static arrayContains(array, value) {
        return new json_path_1.JsonPathToken(`States.ArrayContains(${[array, value].map(json_path_1.renderInExpression).join(", ")})`).toString();
      }
      static arrayRange(start, end, step) {
        return new json_path_1.JsonPathToken(`States.ArrayRange(${[start, end, step].map(json_path_1.renderInExpression).join(", ")})`).toString();
      }
      static arrayGetItem(array, index) {
        return new json_path_1.JsonPathToken(`States.ArrayGetItem(${[array, index].map(json_path_1.renderInExpression).join(", ")})`).toString();
      }
      static arrayLength(array) {
        return new json_path_1.JsonPathToken(`States.ArrayLength(${(0, json_path_1.renderInExpression)(array)})`).toString();
      }
      static arrayUnique(array) {
        return new json_path_1.JsonPathToken(`States.ArrayUnique(${(0, json_path_1.renderInExpression)(array)})`).toString();
      }
      static base64Encode(input) {
        return new json_path_1.JsonPathToken(`States.Base64Encode(${(0, json_path_1.renderInExpression)(input)})`).toString();
      }
      static base64Decode(base64) {
        return new json_path_1.JsonPathToken(`States.Base64Decode(${(0, json_path_1.renderInExpression)(base64)})`).toString();
      }
      static hash(data, algorithm) {
        return new json_path_1.JsonPathToken(`States.Hash(${[data, algorithm].map(json_path_1.renderInExpression).join(", ")})`).toString();
      }
      static jsonMerge(value1, value2) {
        return new json_path_1.JsonPathToken(`States.JsonMerge(${[value1, value2].map(json_path_1.renderInExpression).join(", ")}, false)`).toString();
      }
      static mathRandom(start, end) {
        return new json_path_1.JsonPathToken(`States.MathRandom(${[start, end].map(json_path_1.renderInExpression).join(", ")})`).toString();
      }
      static mathAdd(num1, num2) {
        return new json_path_1.JsonPathToken(`States.MathAdd(${[num1, num2].map(json_path_1.renderInExpression).join(", ")})`).toString();
      }
      static stringSplit(inputString, splitter) {
        return new json_path_1.JsonPathToken(`States.StringSplit(${[inputString, splitter].map(json_path_1.renderInExpression).join(", ")})`).toString();
      }
      static uuid() {
        return new json_path_1.JsonPathToken("States.UUID()").toString();
      }
      static format(formatString, ...values) {
        const allArgs = [formatString, ...values];
        return new json_path_1.JsonPathToken(`States.Format(${allArgs.map(json_path_1.renderInExpression).join(", ")})`).toString();
      }
      static stringToJson(jsonString) {
        return new json_path_1.JsonPathToken(`States.StringToJson(${(0, json_path_1.renderInExpression)(jsonString)})`);
      }
      static jsonToString(value) {
        const path = (0, json_path_1.jsonPathFromAny)(value);
        if (!path)
          throw new Error("Argument to JsonPath.jsonToString() must be a JsonPath object");
        return new json_path_1.JsonPathToken(`States.JsonToString(${path})`).toString();
      }
      constructor() {
      }
    };
    _a = JSII_RTTI_SYMBOL_1, JsonPath[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions.JsonPath", version: "2.80.0" }, JsonPath.DISCARD = core_1.Token.asString(core_1.JsonNull.INSTANCE, { displayHint: "DISCARD (JSON `null`)" }), exports2.JsonPath = JsonPath;
    var Data = class {
      static stringAt(path) {
        return validateDataPath(path), new json_path_1.JsonPathToken(path).toString();
      }
      static listAt(path) {
        return validateDataPath(path), core_1.Token.asList(new json_path_1.JsonPathToken(path));
      }
      static numberAt(path) {
        return validateDataPath(path), core_1.Token.asNumber(new json_path_1.JsonPathToken(path));
      }
      static get entirePayload() {
        return new json_path_1.JsonPathToken("$").toString();
      }
      static isJsonPathString(value) {
        return !!(0, json_path_1.jsonPathString)(value);
      }
      constructor() {
      }
    };
    _b = JSII_RTTI_SYMBOL_1, Data[_b] = { fqn: "aws-cdk-lib.aws_stepfunctions.Data", version: "2.80.0" }, exports2.Data = Data;
    var Context = class {
      static stringAt(path) {
        return validateContextPath(path), new json_path_1.JsonPathToken(path).toString();
      }
      static numberAt(path) {
        return validateContextPath(path), core_1.Token.asNumber(new json_path_1.JsonPathToken(path));
      }
      static get taskToken() {
        return new json_path_1.JsonPathToken("$$.Task.Token").toString();
      }
      static get entireContext() {
        return new json_path_1.JsonPathToken("$$").toString();
      }
      constructor() {
      }
    };
    _c = JSII_RTTI_SYMBOL_1, Context[_c] = { fqn: "aws-cdk-lib.aws_stepfunctions.Context", version: "2.80.0" }, exports2.Context = Context;
    var FieldUtils = class {
      static renderObject(obj) {
        return (0, json_path_1.renderObject)(obj);
      }
      static findReferencedPaths(obj) {
        return Array.from((0, json_path_1.findReferencedPaths)(obj)).sort();
      }
      static containsTaskToken(obj) {
        const paths = (0, json_path_1.findReferencedPaths)(obj);
        return paths.has("$$.Task.Token") || paths.has("$$.Task") || paths.has("$$");
      }
      constructor() {
      }
    };
    _d = JSII_RTTI_SYMBOL_1, FieldUtils[_d] = { fqn: "aws-cdk-lib.aws_stepfunctions.FieldUtils", version: "2.80.0" }, exports2.FieldUtils = FieldUtils;
    function validateJsonPath(path) {
      const intrinsicFunctionFullNames = ["Array", "ArrayPartition", "ArrayContains", "ArrayRange", "ArrayGetItem", "ArrayLength", "ArrayUnique", "Base64Encode", "Base64Decode", "Hash", "JsonMerge", "StringToJson", "JsonToString", "MathRandom", "MathAdd", "StringSplit", "UUID", "Format"].map((fn) => `States.${fn}`);
      if (path !== "$" && !path.startsWith("$.") && path !== "$$" && !path.startsWith("$$.") && !path.startsWith("$[") && intrinsicFunctionFullNames.every((fn) => !path.startsWith(fn))) {
        const lastItem = intrinsicFunctionFullNames.pop(), intrinsicFunctionsStr = intrinsicFunctionFullNames.join(", ") + ", or " + lastItem;
        throw new Error(`JSON path values must be exactly '$', '$$', start with '$.', start with '$$.', start with '$[', or start with an intrinsic function: ${intrinsicFunctionsStr}. Received: ${path}`);
      }
    }
    function validateDataPath(path) {
      if (path !== "$" && !path.startsWith("$[") && !path.startsWith("$."))
        throw new Error("Data JSON path values must either be exactly equal to '$', start with '$[' or start with '$.'");
    }
    function validateContextPath(path) {
      if (path !== "$$" && !path.startsWith("$$."))
        throw new Error("Context JSON path values must either be exactly equal to '$$' or start with '$$.'");
    }
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions/lib/stepfunctions-canned-metrics.generated.js
var require_stepfunctions_canned_metrics_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions/lib/stepfunctions-canned-metrics.generated.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.StatesMetrics = void 0;
    var StatesMetrics = class {
      static executionTimeAverage(dimensions) {
        return { namespace: "AWS/States", metricName: "ExecutionTime", dimensionsMap: dimensions, statistic: "Average" };
      }
      static executionsFailedSum(dimensions) {
        return { namespace: "AWS/States", metricName: "ExecutionsFailed", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static executionsSucceededSum(dimensions) {
        return { namespace: "AWS/States", metricName: "ExecutionsSucceeded", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static executionsThrottledSum(dimensions) {
        return { namespace: "AWS/States", metricName: "ExecutionsThrottled", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static executionsAbortedSum(dimensions) {
        return { namespace: "AWS/States", metricName: "ExecutionsAborted", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static executionsTimedOutSum(dimensions) {
        return { namespace: "AWS/States", metricName: "ExecutionsTimedOut", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static activityTimeAverage(dimensions) {
        return { namespace: "AWS/States", metricName: "ActivityTime", dimensionsMap: dimensions, statistic: "Average" };
      }
      static activitiesSucceededSum(dimensions) {
        return { namespace: "AWS/States", metricName: "ActivitiesSucceeded", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static activitiesFailedSum(dimensions) {
        return { namespace: "AWS/States", metricName: "ActivitiesFailed", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static activitiesHeartbeatTimedOutSum(dimensions) {
        return { namespace: "AWS/States", metricName: "ActivitiesHeartbeatTimedOut", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static activitiesScheduledSum(dimensions) {
        return { namespace: "AWS/States", metricName: "ActivitiesScheduled", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static activitiesStartedSum(dimensions) {
        return { namespace: "AWS/States", metricName: "ActivitiesStarted", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static activitiesTimedOutSum(dimensions) {
        return { namespace: "AWS/States", metricName: "ActivitiesTimedOut", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static activityRunTimeAverage(dimensions) {
        return { namespace: "AWS/States", metricName: "ActivityRunTime", dimensionsMap: dimensions, statistic: "Average" };
      }
      static activityScheduleTimeAverage(dimensions) {
        return { namespace: "AWS/States", metricName: "ActivityScheduleTime", dimensionsMap: dimensions, statistic: "Average" };
      }
    };
    exports2.StatesMetrics = StatesMetrics;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions/lib/stepfunctions.generated.js
var require_stepfunctions_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions/lib/stepfunctions.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnStateMachine = exports2.CfnActivity = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnActivityPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(CfnActivity_TagsEntryPropertyValidator))(properties.tags)), errors.wrap('supplied properties not correct for "CfnActivityProps"');
    }
    function cfnActivityPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnActivityPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cfnActivityTagsEntryPropertyToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnActivityPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(CfnActivityTagsEntryPropertyFromCloudFormation)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnActivity = class _CfnActivity extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnActivityPropsFromCloudFormation(resourceProperties), ret = new _CfnActivity(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnActivity.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_CfnActivityProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnActivity), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::StepFunctions::Activity", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnActivity.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnActivityPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnActivity[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions.CfnActivity", version: "2.80.0" }, CfnActivity.CFN_RESOURCE_TYPE_NAME = "AWS::StepFunctions::Activity", exports2.CfnActivity = CfnActivity;
    function CfnActivity_TagsEntryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TagsEntryProperty"');
    }
    function cfnActivityTagsEntryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnActivity_TagsEntryPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnActivityTagsEntryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStateMachinePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("definition", cdk.validateObject)(properties.definition)), errors.collect(cdk.propertyValidator("definitionS3Location", CfnStateMachine_S3LocationPropertyValidator)(properties.definitionS3Location)), errors.collect(cdk.propertyValidator("definitionString", cdk.validateString)(properties.definitionString)), errors.collect(cdk.propertyValidator("definitionSubstitutions", cdk.hashValidator(cdk.validateString))(properties.definitionSubstitutions)), errors.collect(cdk.propertyValidator("loggingConfiguration", CfnStateMachine_LoggingConfigurationPropertyValidator)(properties.loggingConfiguration)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("stateMachineName", cdk.validateString)(properties.stateMachineName)), errors.collect(cdk.propertyValidator("stateMachineType", cdk.validateString)(properties.stateMachineType)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(CfnStateMachine_TagsEntryPropertyValidator))(properties.tags)), errors.collect(cdk.propertyValidator("tracingConfiguration", CfnStateMachine_TracingConfigurationPropertyValidator)(properties.tracingConfiguration)), errors.wrap('supplied properties not correct for "CfnStateMachineProps"');
    }
    function cfnStateMachinePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStateMachinePropsValidator(properties).assertSuccess(), { RoleArn: cdk.stringToCloudFormation(properties.roleArn), Definition: cdk.objectToCloudFormation(properties.definition), DefinitionS3Location: cfnStateMachineS3LocationPropertyToCloudFormation(properties.definitionS3Location), DefinitionString: cdk.stringToCloudFormation(properties.definitionString), DefinitionSubstitutions: cdk.hashMapper(cdk.stringToCloudFormation)(properties.definitionSubstitutions), LoggingConfiguration: cfnStateMachineLoggingConfigurationPropertyToCloudFormation(properties.loggingConfiguration), StateMachineName: cdk.stringToCloudFormation(properties.stateMachineName), StateMachineType: cdk.stringToCloudFormation(properties.stateMachineType), Tags: cdk.listMapper(cfnStateMachineTagsEntryPropertyToCloudFormation)(properties.tags), TracingConfiguration: cfnStateMachineTracingConfigurationPropertyToCloudFormation(properties.tracingConfiguration) }) : properties;
    }
    function CfnStateMachinePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("definition", "Definition", properties.Definition != null ? cfn_parse.FromCloudFormation.getAny(properties.Definition) : void 0), ret.addPropertyResult("definitionS3Location", "DefinitionS3Location", properties.DefinitionS3Location != null ? CfnStateMachineS3LocationPropertyFromCloudFormation(properties.DefinitionS3Location) : void 0), ret.addPropertyResult("definitionString", "DefinitionString", properties.DefinitionString != null ? cfn_parse.FromCloudFormation.getString(properties.DefinitionString) : void 0), ret.addPropertyResult("definitionSubstitutions", "DefinitionSubstitutions", properties.DefinitionSubstitutions != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.DefinitionSubstitutions) : void 0), ret.addPropertyResult("loggingConfiguration", "LoggingConfiguration", properties.LoggingConfiguration != null ? CfnStateMachineLoggingConfigurationPropertyFromCloudFormation(properties.LoggingConfiguration) : void 0), ret.addPropertyResult("stateMachineName", "StateMachineName", properties.StateMachineName != null ? cfn_parse.FromCloudFormation.getString(properties.StateMachineName) : void 0), ret.addPropertyResult("stateMachineType", "StateMachineType", properties.StateMachineType != null ? cfn_parse.FromCloudFormation.getString(properties.StateMachineType) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(CfnStateMachineTagsEntryPropertyFromCloudFormation)(properties.Tags) : void 0), ret.addPropertyResult("tracingConfiguration", "TracingConfiguration", properties.TracingConfiguration != null ? CfnStateMachineTracingConfigurationPropertyFromCloudFormation(properties.TracingConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnStateMachine = class _CfnStateMachine extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnStateMachinePropsFromCloudFormation(resourceProperties), ret = new _CfnStateMachine(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnStateMachine.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_CfnStateMachineProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnStateMachine), error;
        }
        cdk.requireProperty(props, "roleArn", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.attrStateMachineRevisionId = cdk.Token.asString(this.getAtt("StateMachineRevisionId", cdk.ResolutionTypeHint.STRING)), this.roleArn = props.roleArn, this.definition = props.definition, this.definitionS3Location = props.definitionS3Location, this.definitionString = props.definitionString, this.definitionSubstitutions = props.definitionSubstitutions, this.loggingConfiguration = props.loggingConfiguration, this.stateMachineName = props.stateMachineName, this.stateMachineType = props.stateMachineType, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::StepFunctions::StateMachine", props.tags, { tagPropertyName: "tags" }), this.tracingConfiguration = props.tracingConfiguration;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStateMachine.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { roleArn: this.roleArn, definition: this.definition, definitionS3Location: this.definitionS3Location, definitionString: this.definitionString, definitionSubstitutions: this.definitionSubstitutions, loggingConfiguration: this.loggingConfiguration, stateMachineName: this.stateMachineName, stateMachineType: this.stateMachineType, tags: this.tags.renderTags(), tracingConfiguration: this.tracingConfiguration };
      }
      renderProperties(props) {
        return cfnStateMachinePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnStateMachine[_b] = { fqn: "aws-cdk-lib.aws_stepfunctions.CfnStateMachine", version: "2.80.0" }, CfnStateMachine.CFN_RESOURCE_TYPE_NAME = "AWS::StepFunctions::StateMachine", exports2.CfnStateMachine = CfnStateMachine;
    function CfnStateMachine_CloudWatchLogsLogGroupPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logGroupArn", cdk.validateString)(properties.logGroupArn)), errors.wrap('supplied properties not correct for "CloudWatchLogsLogGroupProperty"');
    }
    function cfnStateMachineCloudWatchLogsLogGroupPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStateMachine_CloudWatchLogsLogGroupPropertyValidator(properties).assertSuccess(), { LogGroupArn: cdk.stringToCloudFormation(properties.logGroupArn) }) : properties;
    }
    function CfnStateMachineCloudWatchLogsLogGroupPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logGroupArn", "LogGroupArn", properties.LogGroupArn != null ? cfn_parse.FromCloudFormation.getString(properties.LogGroupArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStateMachine_LogDestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchLogsLogGroup", CfnStateMachine_CloudWatchLogsLogGroupPropertyValidator)(properties.cloudWatchLogsLogGroup)), errors.wrap('supplied properties not correct for "LogDestinationProperty"');
    }
    function cfnStateMachineLogDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStateMachine_LogDestinationPropertyValidator(properties).assertSuccess(), { CloudWatchLogsLogGroup: cfnStateMachineCloudWatchLogsLogGroupPropertyToCloudFormation(properties.cloudWatchLogsLogGroup) }) : properties;
    }
    function CfnStateMachineLogDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchLogsLogGroup", "CloudWatchLogsLogGroup", properties.CloudWatchLogsLogGroup != null ? CfnStateMachineCloudWatchLogsLogGroupPropertyFromCloudFormation(properties.CloudWatchLogsLogGroup) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStateMachine_LoggingConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinations", cdk.listValidator(CfnStateMachine_LogDestinationPropertyValidator))(properties.destinations)), errors.collect(cdk.propertyValidator("includeExecutionData", cdk.validateBoolean)(properties.includeExecutionData)), errors.collect(cdk.propertyValidator("level", cdk.validateString)(properties.level)), errors.wrap('supplied properties not correct for "LoggingConfigurationProperty"');
    }
    function cfnStateMachineLoggingConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStateMachine_LoggingConfigurationPropertyValidator(properties).assertSuccess(), { Destinations: cdk.listMapper(cfnStateMachineLogDestinationPropertyToCloudFormation)(properties.destinations), IncludeExecutionData: cdk.booleanToCloudFormation(properties.includeExecutionData), Level: cdk.stringToCloudFormation(properties.level) }) : properties;
    }
    function CfnStateMachineLoggingConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinations", "Destinations", properties.Destinations != null ? cfn_parse.FromCloudFormation.getArray(CfnStateMachineLogDestinationPropertyFromCloudFormation)(properties.Destinations) : void 0), ret.addPropertyResult("includeExecutionData", "IncludeExecutionData", properties.IncludeExecutionData != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeExecutionData) : void 0), ret.addPropertyResult("level", "Level", properties.Level != null ? cfn_parse.FromCloudFormation.getString(properties.Level) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStateMachine_S3LocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.requiredValidator)(properties.bucket)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "S3LocationProperty"');
    }
    function cfnStateMachineS3LocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStateMachine_S3LocationPropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), Key: cdk.stringToCloudFormation(properties.key), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnStateMachineS3LocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", cfn_parse.FromCloudFormation.getString(properties.Bucket)), ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getString(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStateMachine_TagsEntryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TagsEntryProperty"');
    }
    function cfnStateMachineTagsEntryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStateMachine_TagsEntryPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnStateMachineTagsEntryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStateMachine_TracingConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "TracingConfigurationProperty"');
    }
    function cfnStateMachineTracingConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStateMachine_TracingConfigurationPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnStateMachineTracingConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions/lib/activity.js
var require_activity = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions/lib/activity.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Activity = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var stepfunctions_canned_metrics_generated_1 = require_stepfunctions_canned_metrics_generated();
    var stepfunctions_generated_1 = require_stepfunctions_generated();
    var cloudwatch = require_aws_cloudwatch();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var Activity = class _Activity extends core_1.Resource {
      static fromActivityArn(scope, id, activityArn) {
        class Imported extends core_1.Resource {
          get activityArn() {
            return activityArn;
          }
          get activityName() {
            return core_1.Stack.of(this).splitArn(activityArn, core_1.ArnFormat.COLON_RESOURCE_NAME).resourceName || "";
          }
        }
        return new Imported(scope, id);
      }
      static fromActivityName(scope, id, activityName) {
        return _Activity.fromActivityArn(scope, id, core_1.Stack.of(scope).formatArn({ service: "states", resource: "activity", resourceName: activityName, arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME }));
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.activityName || core_1.Lazy.string({ produce: () => this.generateName() }) });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_ActivityProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Activity), error;
        }
        const resource = new stepfunctions_generated_1.CfnActivity(this, "Resource", { name: this.physicalName });
        this.activityArn = this.getResourceArnAttribute(resource.ref, { service: "states", resource: "activity", resourceName: this.physicalName, arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME }), this.activityName = this.getResourceNameAttribute(resource.attrName);
      }
      grant(identity, ...actions) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(identity);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grant), error;
        }
        return iam.Grant.addToPrincipal({ grantee: identity, actions, resourceArns: [this.activityArn] });
      }
      metric(metricName, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metric), error;
        }
        return new cloudwatch.Metric({ namespace: "AWS/States", metricName, dimensions: { ActivityArn: this.activityArn }, statistic: "sum", ...props }).attachTo(this);
      }
      metricRunTime(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricRunTime), error;
        }
        return this.cannedMetric(stepfunctions_canned_metrics_generated_1.StatesMetrics.activityRunTimeAverage, props);
      }
      metricScheduleTime(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricScheduleTime), error;
        }
        return this.cannedMetric(stepfunctions_canned_metrics_generated_1.StatesMetrics.activityScheduleTimeAverage, props);
      }
      metricTime(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricTime), error;
        }
        return this.cannedMetric(stepfunctions_canned_metrics_generated_1.StatesMetrics.activityTimeAverage, props);
      }
      metricScheduled(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricScheduled), error;
        }
        return this.cannedMetric(stepfunctions_canned_metrics_generated_1.StatesMetrics.activitiesScheduledSum, props);
      }
      metricTimedOut(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricTimedOut), error;
        }
        return this.cannedMetric(stepfunctions_canned_metrics_generated_1.StatesMetrics.activitiesTimedOutSum, props);
      }
      metricStarted(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricStarted), error;
        }
        return this.cannedMetric(stepfunctions_canned_metrics_generated_1.StatesMetrics.activitiesStartedSum, props);
      }
      metricSucceeded(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricSucceeded), error;
        }
        return this.cannedMetric(stepfunctions_canned_metrics_generated_1.StatesMetrics.activitiesSucceededSum, props);
      }
      metricFailed(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricFailed), error;
        }
        return this.cannedMetric(stepfunctions_canned_metrics_generated_1.StatesMetrics.activitiesFailedSum, props);
      }
      metricHeartbeatTimedOut(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricHeartbeatTimedOut), error;
        }
        return this.cannedMetric(stepfunctions_canned_metrics_generated_1.StatesMetrics.activitiesHeartbeatTimedOutSum, props);
      }
      generateName() {
        const name = core_1.Names.uniqueId(this);
        return name.length > 80 ? name.substring(0, 40) + name.substring(name.length - 40) : name;
      }
      cannedMetric(fn, props) {
        return new cloudwatch.Metric({ ...fn({ ActivityArn: this.activityArn }), ...props }).attachTo(this);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Activity[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions.Activity", version: "2.80.0" }, exports2.Activity = Activity;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions/lib/input.js
var require_input2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions/lib/input.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.InputType = exports2.TaskInput = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var fields_1 = require_fields();
    var TaskInput = class _TaskInput {
      static fromText(text) {
        return new _TaskInput(InputType.TEXT, text);
      }
      static fromObject(obj) {
        return new _TaskInput(InputType.OBJECT, obj);
      }
      static fromJsonPathAt(path) {
        return new _TaskInput(InputType.TEXT, fields_1.JsonPath.stringAt(path));
      }
      static fromDataAt(path) {
        return new _TaskInput(InputType.TEXT, fields_1.JsonPath.stringAt(path));
      }
      static fromContextAt(path) {
        return new _TaskInput(InputType.TEXT, fields_1.JsonPath.stringAt(path));
      }
      constructor(type, value) {
        this.type = type, this.value = value;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, TaskInput[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions.TaskInput", version: "2.80.0" }, exports2.TaskInput = TaskInput;
    var InputType;
    (function(InputType2) {
      InputType2[InputType2.TEXT = 0] = "TEXT", InputType2[InputType2.OBJECT = 1] = "OBJECT";
    })(InputType = exports2.InputType || (exports2.InputType = {}));
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions/lib/types.js
var require_types7 = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions/lib/types.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DISCARD = exports2.Errors = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var Errors = class {
    };
    _a = JSII_RTTI_SYMBOL_1, Errors[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions.Errors", version: "2.80.0" }, Errors.ALL = "States.ALL", Errors.HEARTBEAT_TIMEOUT = "States.HeartbeatTimeout", Errors.TIMEOUT = "States.Timeout", Errors.TASKS_FAILED = "States.TaskFailed", Errors.PERMISSIONS = "States.Permissions", Errors.RESULT_PATH_MATCH_FAILURE = "States.ResultPathMatchFailure", Errors.PARAMETER_PATH_FAILURE = "States.ParameterPathFailure", Errors.BRANCH_FAILED = "States.BranchFailed", Errors.NO_CHOICE_MATCHED = "States.NoChoiceMatched", exports2.Errors = Errors, exports2.DISCARD = "DISCARD";
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions/lib/condition.js
var require_condition = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions/lib/condition.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Condition = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var Condition = class {
      static isPresent(variable) {
        return new VariableComparison(variable, ComparisonOperator.IsPresent, true);
      }
      static isNotPresent(variable) {
        return new VariableComparison(variable, ComparisonOperator.IsPresent, false);
      }
      static isString(variable) {
        return new VariableComparison(variable, ComparisonOperator.IsString, true);
      }
      static isNotString(variable) {
        return new VariableComparison(variable, ComparisonOperator.IsString, false);
      }
      static isNumeric(variable) {
        return new VariableComparison(variable, ComparisonOperator.IsNumeric, true);
      }
      static isNotNumeric(variable) {
        return new VariableComparison(variable, ComparisonOperator.IsNumeric, false);
      }
      static isBoolean(variable) {
        return new VariableComparison(variable, ComparisonOperator.IsBoolean, true);
      }
      static isNotBoolean(variable) {
        return new VariableComparison(variable, ComparisonOperator.IsBoolean, false);
      }
      static isTimestamp(variable) {
        return new VariableComparison(variable, ComparisonOperator.IsTimestamp, true);
      }
      static isNotTimestamp(variable) {
        return new VariableComparison(variable, ComparisonOperator.IsTimestamp, false);
      }
      static isNotNull(variable) {
        return new VariableComparison(variable, ComparisonOperator.IsNull, false);
      }
      static isNull(variable) {
        return new VariableComparison(variable, ComparisonOperator.IsNull, true);
      }
      static booleanEquals(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.BooleanEquals, value);
      }
      static booleanEqualsJsonPath(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.BooleanEqualsPath, value);
      }
      static stringEqualsJsonPath(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.StringEqualsPath, value);
      }
      static stringEquals(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.StringEquals, value);
      }
      static stringLessThan(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.StringLessThan, value);
      }
      static stringLessThanJsonPath(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.StringLessThanPath, value);
      }
      static stringLessThanEquals(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.StringLessThanEquals, value);
      }
      static stringLessThanEqualsJsonPath(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.StringLessThanEqualsPath, value);
      }
      static stringGreaterThan(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.StringGreaterThan, value);
      }
      static stringGreaterThanJsonPath(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.StringGreaterThanPath, value);
      }
      static stringGreaterThanEqualsJsonPath(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.StringGreaterThanEqualsPath, value);
      }
      static stringGreaterThanEquals(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.StringGreaterThanEquals, value);
      }
      static numberEquals(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.NumericEquals, value);
      }
      static numberEqualsJsonPath(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.NumericEqualsPath, value);
      }
      static numberLessThan(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.NumericLessThan, value);
      }
      static numberLessThanJsonPath(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.NumericLessThanPath, value);
      }
      static numberLessThanEquals(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.NumericLessThanEquals, value);
      }
      static numberLessThanEqualsJsonPath(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.NumericLessThanEqualsPath, value);
      }
      static numberGreaterThan(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.NumericGreaterThan, value);
      }
      static numberGreaterThanJsonPath(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.NumericGreaterThanPath, value);
      }
      static numberGreaterThanEquals(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.NumericGreaterThanEquals, value);
      }
      static numberGreaterThanEqualsJsonPath(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.NumericGreaterThanEqualsPath, value);
      }
      static timestampEquals(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.TimestampEquals, value);
      }
      static timestampEqualsJsonPath(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.TimestampEqualsPath, value);
      }
      static timestampLessThan(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.TimestampLessThan, value);
      }
      static timestampLessThanJsonPath(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.TimestampLessThanPath, value);
      }
      static timestampLessThanEquals(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.TimestampLessThanEquals, value);
      }
      static timestampLessThanEqualsJsonPath(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.TimestampLessThanEqualsPath, value);
      }
      static timestampGreaterThan(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.TimestampGreaterThan, value);
      }
      static timestampGreaterThanJsonPath(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.TimestampGreaterThanPath, value);
      }
      static timestampGreaterThanEquals(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.TimestampGreaterThanEquals, value);
      }
      static timestampGreaterThanEqualsJsonPath(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.TimestampGreaterThanEqualsPath, value);
      }
      static stringMatches(variable, value) {
        return new VariableComparison(variable, ComparisonOperator.StringMatches, value);
      }
      static and(...conditions) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_Condition(conditions);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.and), error;
        }
        return new CompoundCondition(CompoundOperator.And, ...conditions);
      }
      static or(...conditions) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_Condition(conditions);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.or), error;
        }
        return new CompoundCondition(CompoundOperator.Or, ...conditions);
      }
      static not(condition) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_Condition(condition);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.not), error;
        }
        return new NotCondition(condition);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Condition[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions.Condition", version: "2.80.0" }, exports2.Condition = Condition;
    var ComparisonOperator;
    (function(ComparisonOperator2) {
      ComparisonOperator2[ComparisonOperator2.StringEquals = 0] = "StringEquals", ComparisonOperator2[ComparisonOperator2.StringEqualsPath = 1] = "StringEqualsPath", ComparisonOperator2[ComparisonOperator2.StringLessThan = 2] = "StringLessThan", ComparisonOperator2[ComparisonOperator2.StringLessThanPath = 3] = "StringLessThanPath", ComparisonOperator2[ComparisonOperator2.StringGreaterThan = 4] = "StringGreaterThan", ComparisonOperator2[ComparisonOperator2.StringGreaterThanPath = 5] = "StringGreaterThanPath", ComparisonOperator2[ComparisonOperator2.StringLessThanEquals = 6] = "StringLessThanEquals", ComparisonOperator2[ComparisonOperator2.StringLessThanEqualsPath = 7] = "StringLessThanEqualsPath", ComparisonOperator2[ComparisonOperator2.StringGreaterThanEquals = 8] = "StringGreaterThanEquals", ComparisonOperator2[ComparisonOperator2.StringGreaterThanEqualsPath = 9] = "StringGreaterThanEqualsPath", ComparisonOperator2[ComparisonOperator2.NumericEquals = 10] = "NumericEquals", ComparisonOperator2[ComparisonOperator2.NumericEqualsPath = 11] = "NumericEqualsPath", ComparisonOperator2[ComparisonOperator2.NumericLessThan = 12] = "NumericLessThan", ComparisonOperator2[ComparisonOperator2.NumericLessThanPath = 13] = "NumericLessThanPath", ComparisonOperator2[ComparisonOperator2.NumericGreaterThan = 14] = "NumericGreaterThan", ComparisonOperator2[ComparisonOperator2.NumericGreaterThanPath = 15] = "NumericGreaterThanPath", ComparisonOperator2[ComparisonOperator2.NumericLessThanEquals = 16] = "NumericLessThanEquals", ComparisonOperator2[ComparisonOperator2.NumericLessThanEqualsPath = 17] = "NumericLessThanEqualsPath", ComparisonOperator2[ComparisonOperator2.NumericGreaterThanEquals = 18] = "NumericGreaterThanEquals", ComparisonOperator2[ComparisonOperator2.NumericGreaterThanEqualsPath = 19] = "NumericGreaterThanEqualsPath", ComparisonOperator2[ComparisonOperator2.BooleanEquals = 20] = "BooleanEquals", ComparisonOperator2[ComparisonOperator2.BooleanEqualsPath = 21] = "BooleanEqualsPath", ComparisonOperator2[ComparisonOperator2.TimestampEquals = 22] = "TimestampEquals", ComparisonOperator2[ComparisonOperator2.TimestampEqualsPath = 23] = "TimestampEqualsPath", ComparisonOperator2[ComparisonOperator2.TimestampLessThan = 24] = "TimestampLessThan", ComparisonOperator2[ComparisonOperator2.TimestampLessThanPath = 25] = "TimestampLessThanPath", ComparisonOperator2[ComparisonOperator2.TimestampGreaterThan = 26] = "TimestampGreaterThan", ComparisonOperator2[ComparisonOperator2.TimestampGreaterThanPath = 27] = "TimestampGreaterThanPath", ComparisonOperator2[ComparisonOperator2.TimestampLessThanEquals = 28] = "TimestampLessThanEquals", ComparisonOperator2[ComparisonOperator2.TimestampLessThanEqualsPath = 29] = "TimestampLessThanEqualsPath", ComparisonOperator2[ComparisonOperator2.TimestampGreaterThanEquals = 30] = "TimestampGreaterThanEquals", ComparisonOperator2[ComparisonOperator2.TimestampGreaterThanEqualsPath = 31] = "TimestampGreaterThanEqualsPath", ComparisonOperator2[ComparisonOperator2.IsNull = 32] = "IsNull", ComparisonOperator2[ComparisonOperator2.IsBoolean = 33] = "IsBoolean", ComparisonOperator2[ComparisonOperator2.IsNumeric = 34] = "IsNumeric", ComparisonOperator2[ComparisonOperator2.IsString = 35] = "IsString", ComparisonOperator2[ComparisonOperator2.IsTimestamp = 36] = "IsTimestamp", ComparisonOperator2[ComparisonOperator2.IsPresent = 37] = "IsPresent", ComparisonOperator2[ComparisonOperator2.StringMatches = 38] = "StringMatches";
    })(ComparisonOperator || (ComparisonOperator = {}));
    var CompoundOperator;
    (function(CompoundOperator2) {
      CompoundOperator2[CompoundOperator2.And = 0] = "And", CompoundOperator2[CompoundOperator2.Or = 1] = "Or";
    })(CompoundOperator || (CompoundOperator = {}));
    var VariableComparison = class extends Condition {
      constructor(variable, comparisonOperator, value) {
        if (super(), this.variable = variable, this.comparisonOperator = comparisonOperator, this.value = value, !/^\$|(\$[.[])/.test(variable))
          throw new Error(`Variable reference must be '$', start with '$.', or start with '$[', got '${variable}'`);
      }
      renderCondition() {
        return { Variable: this.variable, [ComparisonOperator[this.comparisonOperator]]: this.value };
      }
    };
    var CompoundCondition = class extends Condition {
      constructor(operator, ...conditions) {
        if (super(), this.operator = operator, this.conditions = conditions, conditions.length === 0)
          throw new Error("Must supply at least one inner condition for a logical combination");
      }
      renderCondition() {
        return { [CompoundOperator[this.operator]]: this.conditions.map((c) => c.renderCondition()) };
      }
    };
    var NotCondition = class extends Condition {
      constructor(comparisonOperation) {
        super(), this.comparisonOperation = comparisonOperation;
      }
      renderCondition() {
        return { Not: this.comparisonOperation.renderCondition() };
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions/lib/state-graph.js
var require_state_graph = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions/lib/state-graph.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.StateGraph = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var StateGraph = class _StateGraph {
      constructor(startState, graphDescription) {
        this.startState = startState, this.graphDescription = graphDescription, this.policyStatements = new Array(), this.allStates = /* @__PURE__ */ new Set(), this.allContainedStates = /* @__PURE__ */ new Map();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_State(startState);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _StateGraph), error;
        }
        this.allStates.add(startState), startState.bindToGraph(this);
      }
      registerState(state) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_State(state);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.registerState), error;
        }
        this.registerContainedState(state.stateId, this), this.allStates.add(state);
      }
      registerPolicyStatement(statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.registerPolicyStatement), error;
        }
        this.superGraph ? this.superGraph.registerPolicyStatement(statement) : this.policyStatements.push(statement);
      }
      registerSuperGraph(graph) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_StateGraph(graph);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.registerSuperGraph), error;
        }
        if (this.superGraph !== graph) {
          if (this.superGraph)
            throw new Error("Every StateGraph can only be registered into one other StateGraph");
          this.superGraph = graph, this.pushContainedStatesUp(graph), this.pushPolicyStatementsUp(graph);
        }
      }
      toGraphJson() {
        const states = {};
        for (const state of this.allStates)
          states[state.stateId] = state.toStateJson();
        return { StartAt: this.startState.stateId, States: states, TimeoutSeconds: this.timeout && this.timeout.toSeconds() };
      }
      toString() {
        const someNodes = Array.from(this.allStates).slice(0, 3).map((x) => x.stateId);
        return this.allStates.size > 3 && someNodes.push("..."), `${this.graphDescription} (${someNodes.join(", ")})`;
      }
      registerContainedState(stateId, graph) {
        if (this.superGraph)
          this.superGraph.registerContainedState(stateId, graph);
        else {
          const existingGraph = this.allContainedStates.get(stateId);
          if (existingGraph)
            throw new Error(`State with name '${stateId}' occurs in both ${graph} and ${existingGraph}. All states must have unique names.`);
          this.allContainedStates.set(stateId, graph);
        }
      }
      pushContainedStatesUp(superGraph) {
        for (const [stateId, graph] of this.allContainedStates)
          superGraph.registerContainedState(stateId, graph);
      }
      pushPolicyStatementsUp(superGraph) {
        for (const policyStatement of this.policyStatements)
          superGraph.registerPolicyStatement(policyStatement);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, StateGraph[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions.StateGraph", version: "2.80.0" }, exports2.StateGraph = StateGraph;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions/lib/state-machine.js
var require_state_machine2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions/lib/state-machine.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.StateMachine = exports2.LogLevel = exports2.StateMachineType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var state_graph_1 = require_state_graph();
    var stepfunctions_canned_metrics_generated_1 = require_stepfunctions_canned_metrics_generated();
    var stepfunctions_generated_1 = require_stepfunctions_generated();
    var cloudwatch = require_aws_cloudwatch();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var StateMachineType;
    (function(StateMachineType2) {
      StateMachineType2.EXPRESS = "EXPRESS", StateMachineType2.STANDARD = "STANDARD";
    })(StateMachineType = exports2.StateMachineType || (exports2.StateMachineType = {}));
    var LogLevel;
    (function(LogLevel2) {
      LogLevel2.OFF = "OFF", LogLevel2.ALL = "ALL", LogLevel2.ERROR = "ERROR", LogLevel2.FATAL = "FATAL";
    })(LogLevel = exports2.LogLevel || (exports2.LogLevel = {}));
    var StateMachineBase = class _StateMachineBase extends core_1.Resource {
      static fromStateMachineArn(scope, id, stateMachineArn) {
        class Import extends _StateMachineBase {
          constructor() {
            super(...arguments), this.stateMachineArn = stateMachineArn, this.grantPrincipal = new iam.UnknownPrincipal({ resource: this });
          }
        }
        return new Import(scope, id, { environmentFromArn: stateMachineArn });
      }
      static fromStateMachineName(scope, id, stateMachineName) {
        const stateMachineArn = core_1.Stack.of(scope).formatArn({ service: "states", resource: "stateMachine", arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME, resourceName: stateMachineName });
        return this.fromStateMachineArn(scope, id, stateMachineArn);
      }
      grantStartExecution(identity) {
        return iam.Grant.addToPrincipal({ grantee: identity, actions: ["states:StartExecution"], resourceArns: [this.stateMachineArn] });
      }
      grantStartSyncExecution(identity) {
        return iam.Grant.addToPrincipal({ grantee: identity, actions: ["states:StartSyncExecution"], resourceArns: [this.stateMachineArn] });
      }
      grantRead(identity) {
        return iam.Grant.addToPrincipal({ grantee: identity, actions: ["states:ListExecutions", "states:ListStateMachines"], resourceArns: [this.stateMachineArn] }), iam.Grant.addToPrincipal({ grantee: identity, actions: ["states:DescribeExecution", "states:DescribeStateMachineForExecution", "states:GetExecutionHistory"], resourceArns: [`${this.executionArn()}:*`] }), iam.Grant.addToPrincipal({ grantee: identity, actions: ["states:ListActivities", "states:DescribeStateMachine", "states:DescribeActivity"], resourceArns: ["*"] });
      }
      grantTaskResponse(identity) {
        return iam.Grant.addToPrincipal({ grantee: identity, actions: ["states:SendTaskSuccess", "states:SendTaskFailure", "states:SendTaskHeartbeat"], resourceArns: [this.stateMachineArn] });
      }
      grantExecution(identity, ...actions) {
        return iam.Grant.addToPrincipal({ grantee: identity, actions, resourceArns: [`${this.executionArn()}:*`] });
      }
      grant(identity, ...actions) {
        return iam.Grant.addToPrincipal({ grantee: identity, actions, resourceArns: [this.stateMachineArn] });
      }
      metric(metricName, props) {
        return new cloudwatch.Metric({ namespace: "AWS/States", metricName, dimensionsMap: { StateMachineArn: this.stateMachineArn }, statistic: "sum", ...props }).attachTo(this);
      }
      metricFailed(props) {
        return this.cannedMetric(stepfunctions_canned_metrics_generated_1.StatesMetrics.executionsFailedSum, props);
      }
      metricThrottled(props) {
        return this.metric("ExecutionThrottled", props);
      }
      metricAborted(props) {
        return this.cannedMetric(stepfunctions_canned_metrics_generated_1.StatesMetrics.executionsAbortedSum, props);
      }
      metricSucceeded(props) {
        return this.cannedMetric(stepfunctions_canned_metrics_generated_1.StatesMetrics.executionsSucceededSum, props);
      }
      metricTimedOut(props) {
        return this.cannedMetric(stepfunctions_canned_metrics_generated_1.StatesMetrics.executionsTimedOutSum, props);
      }
      metricStarted(props) {
        return this.metric("ExecutionsStarted", props);
      }
      metricTime(props) {
        return this.cannedMetric(stepfunctions_canned_metrics_generated_1.StatesMetrics.executionTimeAverage, props);
      }
      executionArn() {
        return core_1.Stack.of(this).formatArn({ resource: "execution", service: "states", resourceName: core_1.Arn.split(this.stateMachineArn, core_1.ArnFormat.COLON_RESOURCE_NAME).resourceName, arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME });
      }
      cannedMetric(fn, props) {
        return new cloudwatch.Metric({ ...fn({ StateMachineArn: this.stateMachineArn }), ...props }).attachTo(this);
      }
    };
    var StateMachine = class _StateMachine extends StateMachineBase {
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.stateMachineName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_StateMachineProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _StateMachine), error;
        }
        props.stateMachineName !== void 0 && this.validateStateMachineName(props.stateMachineName), this.role = props.role || new iam.Role(this, "Role", { assumedBy: new iam.ServicePrincipal("states.amazonaws.com") });
        const graph = new state_graph_1.StateGraph(props.definition.startState, `State Machine ${id} definition`);
        graph.timeout = props.timeout, this.stateMachineType = props.stateMachineType ?? StateMachineType.STANDARD;
        const resource = new stepfunctions_generated_1.CfnStateMachine(this, "Resource", { stateMachineName: this.physicalName, stateMachineType: props.stateMachineType ?? void 0, roleArn: this.role.roleArn, definitionString: core_1.Stack.of(this).toJsonString(graph.toGraphJson()), loggingConfiguration: props.logs ? this.buildLoggingConfiguration(props.logs) : void 0, tracingConfiguration: props.tracingEnabled ? this.buildTracingConfiguration() : void 0 });
        resource.applyRemovalPolicy(props.removalPolicy, { default: core_1.RemovalPolicy.DESTROY }), resource.node.addDependency(this.role);
        for (const statement of graph.policyStatements)
          this.addToRolePolicy(statement);
        this.stateMachineName = this.getResourceNameAttribute(resource.attrName), this.stateMachineArn = this.getResourceArnAttribute(resource.ref, { service: "states", resource: "stateMachine", resourceName: this.physicalName, arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME });
      }
      get grantPrincipal() {
        return this.role.grantPrincipal;
      }
      addToRolePolicy(statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToRolePolicy), error;
        }
        this.role.addToPrincipalPolicy(statement);
      }
      validateStateMachineName(stateMachineName) {
        if (!core_1.Token.isUnresolved(stateMachineName)) {
          if (stateMachineName.length < 1 || stateMachineName.length > 80)
            throw new Error(`State Machine name must be between 1 and 80 characters. Received: ${stateMachineName}`);
          if (!stateMachineName.match(/^[a-z0-9\+\!\@\.\(\)\-\=\_\']+$/i))
            throw new Error(`State Machine name must match "^[a-z0-9+!@.()-=_']+$/i". Received: ${stateMachineName}`);
        }
      }
      buildLoggingConfiguration(logOptions) {
        return this.addToRolePolicy(new iam.PolicyStatement({ effect: iam.Effect.ALLOW, actions: ["logs:CreateLogDelivery", "logs:GetLogDelivery", "logs:UpdateLogDelivery", "logs:DeleteLogDelivery", "logs:ListLogDeliveries", "logs:PutResourcePolicy", "logs:DescribeResourcePolicies", "logs:DescribeLogGroups"], resources: ["*"] })), { destinations: [{ cloudWatchLogsLogGroup: { logGroupArn: logOptions.destination.logGroupArn } }], includeExecutionData: logOptions.includeExecutionData, level: logOptions.level || "ERROR" };
      }
      buildTracingConfiguration() {
        return this.addToRolePolicy(new iam.PolicyStatement({ actions: ["xray:PutTraceSegments", "xray:PutTelemetryRecords", "xray:GetSamplingRules", "xray:GetSamplingTargets"], resources: ["*"] })), { enabled: true };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, StateMachine[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions.StateMachine", version: "2.80.0" }, exports2.StateMachine = StateMachine;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions/lib/states/private/state-type.js
var require_state_type = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions/lib/states/private/state-type.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.StateType = void 0;
    var StateType;
    (function(StateType2) {
      StateType2.PASS = "Pass", StateType2.TASK = "Task", StateType2.CHOICE = "Choice", StateType2.WAIT = "Wait", StateType2.SUCCEED = "Succeed", StateType2.FAIL = "Fail", StateType2.PARALLEL = "Parallel", StateType2.MAP = "Map";
    })(StateType = exports2.StateType || (exports2.StateType = {}));
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions/lib/states/state.js
var require_state = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions/lib/states/state.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.renderJsonPath = exports2.renderList = exports2.State = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var core_1 = require_core2();
    var fields_1 = require_fields();
    var types_1 = require_types7();
    var State = class _State extends constructs_1.Construct {
      static prefixStates(root, prefix) {
        const queue = [root];
        for (; queue.length > 0; ) {
          const el = queue.splice(0, 1)[0];
          isPrefixable(el) && el.addPrefix(prefix), queue.push(...constructs_1.Node.of(el).children);
        }
      }
      static findReachableStates(start, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_State(start), jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_FindStateOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.findReachableStates), error;
        }
        const visited = /* @__PURE__ */ new Set(), ret = /* @__PURE__ */ new Set(), queue = [start];
        for (; queue.length > 0; ) {
          const state = queue.splice(0, 1)[0];
          if (visited.has(state))
            continue;
          visited.add(state);
          const outgoing = state.outgoingTransitions(options);
          queue.push(...outgoing), ret.add(state);
        }
        return Array.from(ret);
      }
      static findReachableEndStates(start, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_State(start), jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_FindStateOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.findReachableEndStates), error;
        }
        const visited = /* @__PURE__ */ new Set(), ret = /* @__PURE__ */ new Set(), queue = [start];
        for (; queue.length > 0; ) {
          const state = queue.splice(0, 1)[0];
          if (visited.has(state))
            continue;
          visited.add(state);
          const outgoing = state.outgoingTransitions(options);
          outgoing.length > 0 ? queue.push(...outgoing) : ret.add(state);
        }
        return Array.from(ret);
      }
      static filterNextables(states) {
        return states.filter(isNextable);
      }
      constructor(scope, id, props) {
        super(scope, id), this.branches = [], this.retries = [], this.catches = [], this.choices = [], this.prefixes = [], this.incomingStates = [];
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_StateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _State), error;
        }
        this.startState = this, this.comment = props.comment, this.inputPath = props.inputPath, this.parameters = props.parameters, this.outputPath = props.outputPath, this.resultPath = props.resultPath, this.resultSelector = props.resultSelector, this.node.addValidation({ validate: () => this.validateState() });
      }
      validateState() {
        return [];
      }
      get id() {
        return this.node.id;
      }
      get stateId() {
        return this.prefixes.concat(this.id).join("");
      }
      addPrefix(x) {
        x !== "" && this.prefixes.splice(0, 0, x);
      }
      bindToGraph(graph) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_StateGraph(graph);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bindToGraph), error;
        }
        if (this.containingGraph !== graph) {
          if (this.containingGraph)
            throw new Error(`Trying to use state '${this.stateId}' in ${graph}, but is already in ${this.containingGraph}. Every state can only be used in one graph.`);
          this.containingGraph = graph, this.whenBoundToGraph(graph);
          for (const incoming of this.incomingStates)
            incoming.bindToGraph(graph);
          for (const outgoing of this.outgoingTransitions({ includeErrorHandlers: true }))
            outgoing.bindToGraph(graph);
          for (const branch of this.branches)
            branch.registerSuperGraph(this.containingGraph);
          this.iteration && this.iteration.registerSuperGraph(this.containingGraph);
        }
      }
      _addRetry(props = {}) {
        validateErrors(props.errors), this.retries.push({ ...props, errors: props.errors ?? [types_1.Errors.ALL] });
      }
      _addCatch(handler2, props = {}) {
        validateErrors(props.errors), this.catches.push({ next: handler2, props: { errors: props.errors ?? [types_1.Errors.ALL], resultPath: props.resultPath } }), handler2.addIncoming(this), this.containingGraph && handler2.bindToGraph(this.containingGraph);
      }
      makeNext(next) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_State(next);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.makeNext), error;
        }
        if (this._next)
          throw new Error(`State '${this.id}' already has a next state`);
        this._next = next, next.addIncoming(this), this.containingGraph && next.bindToGraph(this.containingGraph);
      }
      addChoice(condition, next) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_Condition(condition), jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_State(next);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addChoice), error;
        }
        this.choices.push({ condition, next }), next.startState.addIncoming(this), this.containingGraph && next.startState.bindToGraph(this.containingGraph);
      }
      addBranch(branch) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_StateGraph(branch);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addBranch), error;
        }
        this.branches.push(branch), this.containingGraph && branch.registerSuperGraph(this.containingGraph);
      }
      addIterator(iteration) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_StateGraph(iteration);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addIterator), error;
        }
        this.iteration = iteration, this.containingGraph && iteration.registerSuperGraph(this.containingGraph);
      }
      makeDefault(def) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_State(def);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.makeDefault), error;
        }
        if (this.defaultChoice)
          throw new Error(`Choice '${this.id}' already has a default next state`);
        this.defaultChoice = def;
      }
      renderNextEnd() {
        return this._next ? { Next: this._next.stateId } : { End: true };
      }
      renderChoices() {
        return { Choices: renderList(this.choices, renderChoice), Default: this.defaultChoice?.stateId };
      }
      renderInputOutput() {
        return { InputPath: renderJsonPath(this.inputPath), Parameters: this.parameters, OutputPath: renderJsonPath(this.outputPath) };
      }
      renderBranches() {
        return { Branches: this.branches.map((b) => b.toGraphJson()) };
      }
      renderIterator() {
        if (!this.iteration)
          throw new Error("Iterator must not be undefined !");
        return { Iterator: this.iteration.toGraphJson() };
      }
      renderRetryCatch() {
        return { Retry: renderList(this.retries, renderRetry, (a, b) => compareErrors(a.errors, b.errors)), Catch: renderList(this.catches, renderCatch, (a, b) => compareErrors(a.props.errors, b.props.errors)) };
      }
      renderResultSelector() {
        return fields_1.FieldUtils.renderObject({ ResultSelector: this.resultSelector });
      }
      whenBoundToGraph(graph) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_StateGraph(graph);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.whenBoundToGraph), error;
        }
        graph.registerState(this);
      }
      addIncoming(source) {
        this.incomingStates.push(source);
      }
      outgoingTransitions(options) {
        const ret = new Array();
        this._next && ret.push(this._next), this.defaultChoice && ret.push(this.defaultChoice);
        for (const c of this.choices)
          ret.push(c.next);
        if (options.includeErrorHandlers)
          for (const c of this.catches)
            ret.push(c.next);
        return ret;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, State[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions.State", version: "2.80.0" }, exports2.State = State;
    function renderChoice(c) {
      return { ...c.condition.renderCondition(), Next: c.next.stateId };
    }
    function renderRetry(retry) {
      return { ErrorEquals: retry.errors, IntervalSeconds: retry.interval && retry.interval.toSeconds(), MaxAttempts: retry.maxAttempts, BackoffRate: retry.backoffRate };
    }
    function renderCatch(c) {
      return { ErrorEquals: c.props.errors, ResultPath: renderJsonPath(c.props.resultPath), Next: c.next.stateId };
    }
    function compareErrors(a, b) {
      return a?.includes(types_1.Errors.ALL) ? 1 : b?.includes(types_1.Errors.ALL) ? -1 : 0;
    }
    function validateErrors(errors) {
      if (errors?.includes(types_1.Errors.ALL) && errors.length > 1)
        throw new Error(`${types_1.Errors.ALL} must appear alone in an error list`);
    }
    function renderList(xs, mapFn, sortFn) {
      if (xs.length === 0)
        return;
      let list = xs;
      return sortFn && (list = xs.sort(sortFn)), list.map(mapFn);
    }
    exports2.renderList = renderList;
    function renderJsonPath(jsonPath) {
      if (jsonPath !== void 0) {
        if (!core_1.Token.isUnresolved(jsonPath) && !jsonPath.startsWith("$"))
          throw new Error(`Expected JSON path to start with '$', got: ${jsonPath}`);
        return jsonPath;
      }
    }
    exports2.renderJsonPath = renderJsonPath;
    function isPrefixable(x) {
      return typeof x == "object" && x.addPrefix;
    }
    function isNextable(x) {
      return typeof x == "object" && x.next;
    }
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions/lib/states/parallel.js
var require_parallel = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions/lib/states/parallel.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Parallel = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var state_type_1 = require_state_type();
    var state_1 = require_state();
    var chain_1 = require_chain();
    var state_graph_1 = require_state_graph();
    var Parallel = class _Parallel extends state_1.State {
      constructor(scope, id, props = {}) {
        super(scope, id, props), this._branches = [];
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_ParallelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Parallel), error;
        }
        this.endStates = [this];
      }
      addRetry(props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_RetryProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addRetry), error;
        }
        return super._addRetry(props), this;
      }
      addCatch(handler2, props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_IChainable(handler2), jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_CatchProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addCatch), error;
        }
        return super._addCatch(handler2.startState, props), this;
      }
      next(next) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_IChainable(next);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.next), error;
        }
        return super.makeNext(next.startState), chain_1.Chain.sequence(this, next);
      }
      branch(...branches) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_IChainable(branches);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.branch), error;
        }
        return this._branches.push(...branches), this;
      }
      bindToGraph(graph) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_StateGraph(graph);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bindToGraph), error;
        }
        for (const branch of this._branches) {
          const name = `Parallel '${this.stateId}' branch ${this.branches.length + 1}`;
          super.addBranch(new state_graph_1.StateGraph(branch.startState, name));
        }
        return this._branches.splice(0, this._branches.length), super.bindToGraph(graph);
      }
      toStateJson() {
        return { Type: state_type_1.StateType.PARALLEL, Comment: this.comment, ResultPath: (0, state_1.renderJsonPath)(this.resultPath), ...this.renderNextEnd(), ...this.renderInputOutput(), ...this.renderRetryCatch(), ...this.renderBranches(), ...this.renderResultSelector() };
      }
      validateState() {
        return this.branches.length === 0 ? ["Parallel must have at least one branch"] : [];
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Parallel[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions.Parallel", version: "2.80.0" }, exports2.Parallel = Parallel;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions/lib/chain.js
var require_chain = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions/lib/chain.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Chain = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var parallel_1 = require_parallel();
    var Chain = class _Chain {
      static start(state) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_IChainable(state);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.start), error;
        }
        return new _Chain(state.startState, state.endStates, state);
      }
      static sequence(start, next) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_IChainable(start), jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_IChainable(next);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.sequence), error;
        }
        return new _Chain(start.startState, next.endStates, next);
      }
      static custom(startState, endStates, lastAdded) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_State(startState), jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_IChainable(lastAdded);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.custom), error;
        }
        return new _Chain(startState, endStates, lastAdded);
      }
      constructor(startState, endStates, lastAdded) {
        this.lastAdded = lastAdded, this.id = lastAdded.id, this.startState = startState, this.endStates = endStates;
      }
      next(next) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_IChainable(next);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.next), error;
        }
        if (this.endStates.length === 0)
          throw new Error(`Cannot add to chain: last state in chain (${this.lastAdded.id}) does not allow it`);
        for (const endState of this.endStates)
          endState.next(next);
        return new _Chain(this.startState, next.endStates, next);
      }
      toSingleState(id, props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_ParallelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.toSingleState), error;
        }
        return new parallel_1.Parallel(this.startState, id, props).branch(this);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Chain[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions.Chain", version: "2.80.0" }, exports2.Chain = Chain;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions/lib/state-machine-fragment.js
var require_state_machine_fragment = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions/lib/state-machine-fragment.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.StateMachineFragment = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var chain_1 = require_chain();
    var parallel_1 = require_parallel();
    var state_1 = require_state();
    var StateMachineFragment = class extends constructs_1.Construct {
      get id() {
        return this.node.id;
      }
      prefixStates(prefix) {
        return state_1.State.prefixStates(this, prefix || `${this.id}: `), this;
      }
      toSingleState(options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_SingleStateOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.toSingleState), error;
        }
        const stateId = options.stateId || this.id;
        return this.prefixStates(options.prefixStates || `${stateId}: `), new parallel_1.Parallel(this, stateId, options).branch(this);
      }
      next(next) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_IChainable(next);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.next), error;
        }
        return chain_1.Chain.start(this).next(next);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, StateMachineFragment[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions.StateMachineFragment", version: "2.80.0" }, exports2.StateMachineFragment = StateMachineFragment;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions/lib/state-transition-metrics.js
var require_state_transition_metrics = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions/lib/state-transition-metrics.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.StateTransitionMetric = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cloudwatch = require_aws_cloudwatch();
    var StateTransitionMetric = class _StateTransitionMetric {
      static metric(metricName, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metric), error;
        }
        return new cloudwatch.Metric({ namespace: "AWS/States", metricName, dimensionsMap: { ServiceMetric: "StateTransition" }, ...props });
      }
      static metricProvisionedBucketSize(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricProvisionedBucketSize), error;
        }
        return _StateTransitionMetric.metric("ProvisionedBucketSize", props);
      }
      static metricProvisionedRefillRate(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricProvisionedRefillRate), error;
        }
        return _StateTransitionMetric.metric("ProvisionedRefillRate", props);
      }
      static metricConsumedCapacity(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricConsumedCapacity), error;
        }
        return _StateTransitionMetric.metric("ConsumedCapacity", props);
      }
      static metricThrottledEvents(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricThrottledEvents), error;
        }
        return _StateTransitionMetric.metric("ThrottledEvents", { statistic: "sum", ...props });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, StateTransitionMetric[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions.StateTransitionMetric", version: "2.80.0" }, exports2.StateTransitionMetric = StateTransitionMetric;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions/lib/step-functions-task.js
var require_step_functions_task = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions/lib/step-functions-task.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ServiceIntegrationPattern = void 0;
    var ServiceIntegrationPattern;
    (function(ServiceIntegrationPattern2) {
      ServiceIntegrationPattern2.FIRE_AND_FORGET = "FIRE_AND_FORGET", ServiceIntegrationPattern2.SYNC = "SYNC", ServiceIntegrationPattern2.WAIT_FOR_TASK_TOKEN = "WAIT_FOR_TASK_TOKEN";
    })(ServiceIntegrationPattern = exports2.ServiceIntegrationPattern || (exports2.ServiceIntegrationPattern = {}));
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions/lib/states/choice.js
var require_choice = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions/lib/states/choice.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Choice = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var state_type_1 = require_state_type();
    var state_1 = require_state();
    var chain_1 = require_chain();
    var Choice = class _Choice extends state_1.State {
      constructor(scope, id, props = {}) {
        super(scope, id, props), this.endStates = [];
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_ChoiceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Choice), error;
        }
      }
      when(condition, next) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_Condition(condition), jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_IChainable(next);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.when), error;
        }
        return super.addChoice(condition, next.startState), this;
      }
      otherwise(def) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_IChainable(def);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.otherwise), error;
        }
        return super.makeDefault(def.startState), this;
      }
      afterwards(options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_AfterwardsOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.afterwards), error;
        }
        const endStates = state_1.State.filterNextables(state_1.State.findReachableEndStates(this, { includeErrorHandlers: options.includeErrorHandlers }));
        if (options.includeOtherwise && this.defaultChoice)
          throw new Error(`'includeOtherwise' set but Choice state ${this.stateId} already has an 'otherwise' transition`);
        return options.includeOtherwise && endStates.push(new DefaultAsNext(this)), chain_1.Chain.custom(this, endStates, this);
      }
      toStateJson() {
        return { Type: state_type_1.StateType.CHOICE, Comment: this.comment, ...this.renderInputOutput(), ...this.renderChoices() };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Choice[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions.Choice", version: "2.80.0" }, exports2.Choice = Choice;
    var DefaultAsNext = class {
      constructor(choice) {
        this.choice = choice;
      }
      next(state) {
        return this.choice.otherwise(state), chain_1.Chain.sequence(this.choice, state);
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions/lib/states/fail.js
var require_fail = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions/lib/states/fail.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Fail = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var state_type_1 = require_state_type();
    var state_1 = require_state();
    var Fail = class _Fail extends state_1.State {
      constructor(scope, id, props = {}) {
        super(scope, id, props), this.endStates = [];
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_FailProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Fail), error;
        }
        this.error = props.error, this.cause = props.cause;
      }
      toStateJson() {
        return { Type: state_type_1.StateType.FAIL, Comment: this.comment, Error: this.error, Cause: this.cause };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Fail[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions.Fail", version: "2.80.0" }, exports2.Fail = Fail;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions/lib/states/pass.js
var require_pass = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions/lib/states/pass.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Pass = exports2.Result = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var state_type_1 = require_state_type();
    var state_1 = require_state();
    var chain_1 = require_chain();
    var fields_1 = require_fields();
    var Result = class _Result {
      static fromString(value) {
        return new _Result(value);
      }
      static fromNumber(value) {
        return new _Result(value);
      }
      static fromBoolean(value) {
        return new _Result(value);
      }
      static fromObject(value) {
        return new _Result(value);
      }
      static fromArray(value) {
        return new _Result(value);
      }
      constructor(value) {
        this.value = value;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Result[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions.Result", version: "2.80.0" }, exports2.Result = Result;
    var Pass = class _Pass extends state_1.State {
      constructor(scope, id, props = {}) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_PassProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Pass), error;
        }
        this.result = props.result, this.endStates = [this];
      }
      next(next) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_IChainable(next);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.next), error;
        }
        return super.makeNext(next.startState), chain_1.Chain.sequence(this, next);
      }
      toStateJson() {
        return { Type: state_type_1.StateType.PASS, Comment: this.comment, Result: this.result?.value, ResultPath: (0, state_1.renderJsonPath)(this.resultPath), ...this.renderInputOutput(), ...this.renderParameters(), ...this.renderNextEnd() };
      }
      renderParameters() {
        return fields_1.FieldUtils.renderObject({ Parameters: this.parameters });
      }
    };
    _b = JSII_RTTI_SYMBOL_1, Pass[_b] = { fqn: "aws-cdk-lib.aws_stepfunctions.Pass", version: "2.80.0" }, exports2.Pass = Pass;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions/lib/states/succeed.js
var require_succeed = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions/lib/states/succeed.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Succeed = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var state_type_1 = require_state_type();
    var state_1 = require_state();
    var Succeed = class _Succeed extends state_1.State {
      constructor(scope, id, props = {}) {
        super(scope, id, props), this.endStates = [];
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_SucceedProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Succeed), error;
        }
      }
      toStateJson() {
        return { Type: state_type_1.StateType.SUCCEED, Comment: this.comment, ...this.renderInputOutput() };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Succeed[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions.Succeed", version: "2.80.0" }, exports2.Succeed = Succeed;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions/lib/util.js
var require_util14 = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions/lib/util.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.noEmptyObject = void 0;
    function noEmptyObject(o) {
      if (Object.keys(o).length !== 0)
        return o;
    }
    exports2.noEmptyObject = noEmptyObject;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions/lib/states/task.js
var require_task = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions/lib/states/task.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Task = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var state_type_1 = require_state_type();
    var state_1 = require_state();
    var cloudwatch = require_aws_cloudwatch();
    var chain_1 = require_chain();
    var fields_1 = require_fields();
    var util_1 = require_util14();
    var Task = class extends state_1.State {
      constructor(scope, id, props) {
        super(scope, id, props), this.timeout = props.timeout;
        const taskProps = props.task.bind(this);
        this.taskProps = { ...taskProps, parameters: (0, util_1.noEmptyObject)({ ...taskProps.parameters || {}, ...props.parameters || {} }) }, this.endStates = [this];
      }
      addRetry(props = {}) {
        return super._addRetry(props), this;
      }
      addCatch(handler2, props = {}) {
        return super._addCatch(handler2.startState, props), this;
      }
      next(next) {
        return super.makeNext(next.startState), chain_1.Chain.sequence(this, next);
      }
      toStateJson() {
        return { ...this.renderNextEnd(), ...this.renderRetryCatch(), ...this.renderInputOutput(), Type: state_type_1.StateType.TASK, Comment: this.comment, Resource: this.taskProps.resourceArn, Parameters: this.taskProps.parameters && fields_1.FieldUtils.renderObject(this.taskProps.parameters), ResultPath: (0, state_1.renderJsonPath)(this.resultPath), TimeoutSeconds: this.timeout && this.timeout.toSeconds(), HeartbeatSeconds: this.taskProps.heartbeat && this.taskProps.heartbeat.toSeconds() };
      }
      metric(metricName, props) {
        return new cloudwatch.Metric({ namespace: "AWS/States", metricName, dimensions: this.taskProps.metricDimensions, statistic: "sum", ...props }).attachTo(this);
      }
      metricRunTime(props) {
        return this.taskMetric(this.taskProps.metricPrefixSingular, "RunTime", { statistic: "avg", ...props });
      }
      metricScheduleTime(props) {
        return this.taskMetric(this.taskProps.metricPrefixSingular, "ScheduleTime", { statistic: "avg", ...props });
      }
      metricTime(props) {
        return this.taskMetric(this.taskProps.metricPrefixSingular, "Time", { statistic: "avg", ...props });
      }
      metricScheduled(props) {
        return this.taskMetric(this.taskProps.metricPrefixPlural, "Scheduled", props);
      }
      metricTimedOut(props) {
        return this.taskMetric(this.taskProps.metricPrefixPlural, "TimedOut", props);
      }
      metricStarted(props) {
        return this.taskMetric(this.taskProps.metricPrefixPlural, "Started", props);
      }
      metricSucceeded(props) {
        return this.taskMetric(this.taskProps.metricPrefixPlural, "Succeeded", props);
      }
      metricFailed(props) {
        return this.taskMetric(this.taskProps.metricPrefixPlural, "Failed", props);
      }
      metricHeartbeatTimedOut(props) {
        return this.taskMetric(this.taskProps.metricPrefixPlural, "HeartbeatTimedOut", props);
      }
      whenBoundToGraph(graph) {
        super.whenBoundToGraph(graph);
        for (const policyStatement of this.taskProps.policyStatements || [])
          graph.registerPolicyStatement(policyStatement);
      }
      taskMetric(prefix, suffix, props) {
        if (prefix === void 0)
          throw new Error("This Task Resource does not expose metrics");
        return this.metric(prefix + suffix, props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Task[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions.Task", version: "2.80.0" }, exports2.Task = Task;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions/lib/states/wait.js
var require_wait = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions/lib/states/wait.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Wait = exports2.WaitTime = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var state_type_1 = require_state_type();
    var state_1 = require_state();
    var chain_1 = require_chain();
    var WaitTime = class _WaitTime {
      static duration(duration) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Duration(duration);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.duration), error;
        }
        return new _WaitTime({ Seconds: duration.toSeconds() });
      }
      static timestamp(timestamp) {
        return new _WaitTime({ Timestamp: timestamp });
      }
      static secondsPath(path) {
        return new _WaitTime({ SecondsPath: path });
      }
      static timestampPath(path) {
        return new _WaitTime({ TimestampPath: path });
      }
      constructor(json) {
        this.json = json;
      }
      get _json() {
        return this.json;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, WaitTime[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions.WaitTime", version: "2.80.0" }, exports2.WaitTime = WaitTime;
    var Wait = class _Wait extends state_1.State {
      constructor(scope, id, props) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_WaitProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Wait), error;
        }
        this.time = props.time, this.endStates = [this];
      }
      next(next) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_IChainable(next);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.next), error;
        }
        return super.makeNext(next.startState), chain_1.Chain.sequence(this, next);
      }
      toStateJson() {
        return { Type: state_type_1.StateType.WAIT, Comment: this.comment, ...this.time._json, ...this.renderNextEnd() };
      }
    };
    _b = JSII_RTTI_SYMBOL_1, Wait[_b] = { fqn: "aws-cdk-lib.aws_stepfunctions.Wait", version: "2.80.0" }, exports2.Wait = Wait;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions/lib/states/map.js
var require_map = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions/lib/states/map.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Map = exports2.isPositiveInteger = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var state_type_1 = require_state_type();
    var state_1 = require_state();
    var core_1 = require_core2();
    var chain_1 = require_chain();
    var fields_1 = require_fields();
    var state_graph_1 = require_state_graph();
    var isPositiveInteger = (value) => {
      const isFloat = Math.floor(value) !== value, isNotPositiveInteger = value < 0 || value > Number.MAX_SAFE_INTEGER;
      return !isFloat && !isNotPositiveInteger;
    };
    exports2.isPositiveInteger = isPositiveInteger;
    var Map2 = class _Map extends state_1.State {
      constructor(scope, id, props = {}) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_MapProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Map), error;
        }
        this.endStates = [this], this.maxConcurrency = props.maxConcurrency, this.itemsPath = props.itemsPath;
      }
      addRetry(props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_RetryProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addRetry), error;
        }
        return super._addRetry(props), this;
      }
      addCatch(handler2, props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_IChainable(handler2), jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_CatchProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addCatch), error;
        }
        return super._addCatch(handler2.startState, props), this;
      }
      next(next) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_IChainable(next);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.next), error;
        }
        return super.makeNext(next.startState), chain_1.Chain.sequence(this, next);
      }
      iterator(iterator) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_IChainable(iterator);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.iterator), error;
        }
        const name = `Map ${this.stateId} Iterator`;
        return super.addIterator(new state_graph_1.StateGraph(iterator.startState, name)), this;
      }
      toStateJson() {
        return { Type: state_type_1.StateType.MAP, Comment: this.comment, ResultPath: (0, state_1.renderJsonPath)(this.resultPath), ...this.renderNextEnd(), ...this.renderInputOutput(), ...this.renderParameters(), ...this.renderResultSelector(), ...this.renderRetryCatch(), ...this.renderIterator(), ...this.renderItemsPath(), MaxConcurrency: this.maxConcurrency };
      }
      validateState() {
        const errors = [];
        return this.iteration === void 0 && errors.push("Map state must have a non-empty iterator"), this.maxConcurrency !== void 0 && !core_1.Token.isUnresolved(this.maxConcurrency) && !(0, exports2.isPositiveInteger)(this.maxConcurrency) && errors.push("maxConcurrency has to be a positive integer"), errors;
      }
      renderItemsPath() {
        return { ItemsPath: (0, state_1.renderJsonPath)(this.itemsPath) };
      }
      renderParameters() {
        return fields_1.FieldUtils.renderObject({ Parameters: this.parameters });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Map2[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions.Map", version: "2.80.0" }, exports2.Map = Map2;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions/lib/states/custom-state.js
var require_custom_state = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions/lib/states/custom-state.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CustomState = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var state_1 = require_state();
    var __1 = require_lib39();
    var CustomState = class _CustomState extends state_1.State {
      constructor(scope, id, props) {
        super(scope, id, {});
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_CustomStateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CustomState), error;
        }
        this.endStates = [this], this.stateJson = props.stateJson;
      }
      next(next) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_IChainable(next);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.next), error;
        }
        return super.makeNext(next.startState), __1.Chain.sequence(this, next);
      }
      toStateJson() {
        return { ...this.renderNextEnd(), ...this.stateJson };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CustomState[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions.CustomState", version: "2.80.0" }, exports2.CustomState = CustomState;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions/lib/states/task-base.js
var require_task_base = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions/lib/states/task-base.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Timeout = exports2.IntegrationPattern = exports2.TaskStateBase = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var state_1 = require_state();
    var cloudwatch = require_aws_cloudwatch();
    var iam = require_aws_iam();
    var chain_1 = require_chain();
    var fields_1 = require_fields();
    var TaskStateBase = class _TaskStateBase extends state_1.State {
      constructor(scope, id, props) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_TaskStateBaseProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _TaskStateBase), error;
        }
        this.endStates = [this], this.timeout = props.timeout, this.taskTimeout = props.taskTimeout, this.heartbeat = props.heartbeat, this.heartbeatTimeout = props.heartbeatTimeout, this.credentials = props.credentials;
      }
      addRetry(props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_RetryProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addRetry), error;
        }
        return super._addRetry(props), this;
      }
      addCatch(handler2, props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_IChainable(handler2), jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_CatchProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addCatch), error;
        }
        return super._addCatch(handler2.startState, props), this;
      }
      next(next) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_IChainable(next);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.next), error;
        }
        return super.makeNext(next.startState), chain_1.Chain.sequence(this, next);
      }
      toStateJson() {
        return { ...this.renderNextEnd(), ...this.renderRetryCatch(), ...this.renderTaskBase(), ...this._renderTask() };
      }
      metric(metricName, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metric), error;
        }
        return new cloudwatch.Metric({ namespace: "AWS/States", metricName, dimensionsMap: this.taskMetrics?.metricDimensions, statistic: "sum", ...props }).attachTo(this);
      }
      metricRunTime(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricRunTime), error;
        }
        return this.taskMetric(this.taskMetrics?.metricPrefixSingular, "RunTime", { statistic: "avg", ...props });
      }
      metricScheduleTime(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricScheduleTime), error;
        }
        return this.taskMetric(this.taskMetrics?.metricPrefixSingular, "ScheduleTime", { statistic: "avg", ...props });
      }
      metricTime(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricTime), error;
        }
        return this.taskMetric(this.taskMetrics?.metricPrefixSingular, "Time", { statistic: "avg", ...props });
      }
      metricScheduled(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricScheduled), error;
        }
        return this.taskMetric(this.taskMetrics?.metricPrefixPlural, "Scheduled", props);
      }
      metricTimedOut(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricTimedOut), error;
        }
        return this.taskMetric(this.taskMetrics?.metricPrefixPlural, "TimedOut", props);
      }
      metricStarted(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricStarted), error;
        }
        return this.taskMetric(this.taskMetrics?.metricPrefixPlural, "Started", props);
      }
      metricSucceeded(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricSucceeded), error;
        }
        return this.taskMetric(this.taskMetrics?.metricPrefixPlural, "Succeeded", props);
      }
      metricFailed(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricFailed), error;
        }
        return this.taskMetric(this.taskMetrics?.metricPrefixPlural, "Failed", props);
      }
      metricHeartbeatTimedOut(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricHeartbeatTimedOut), error;
        }
        return this.taskMetric(this.taskMetrics?.metricPrefixPlural, "HeartbeatTimedOut", props);
      }
      whenBoundToGraph(graph) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_StateGraph(graph);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.whenBoundToGraph), error;
        }
        super.whenBoundToGraph(graph);
        for (const policyStatement of this.taskPolicies || [])
          graph.registerPolicyStatement(policyStatement);
        this.credentials && graph.registerPolicyStatement(new iam.PolicyStatement({ effect: iam.Effect.ALLOW, actions: ["sts:AssumeRole"], resources: [this.credentials.role.resource] }));
      }
      taskMetric(prefix, suffix, props) {
        if (prefix === void 0)
          throw new Error("Task does not expose metrics. Use the 'metric()' function to add metrics.");
        return this.metric(prefix + suffix, props);
      }
      renderCredentials() {
        return this.credentials ? fields_1.FieldUtils.renderObject({ Credentials: { RoleArn: this.credentials.role.roleArn } }) : void 0;
      }
      renderTaskBase() {
        return { Type: "Task", Comment: this.comment, TimeoutSeconds: this.timeout?.toSeconds() ?? this.taskTimeout?.seconds, TimeoutSecondsPath: this.taskTimeout?.path, HeartbeatSeconds: this.heartbeat?.toSeconds() ?? this.heartbeatTimeout?.seconds, HeartbeatSecondsPath: this.heartbeatTimeout?.path, InputPath: (0, state_1.renderJsonPath)(this.inputPath), OutputPath: (0, state_1.renderJsonPath)(this.outputPath), ResultPath: (0, state_1.renderJsonPath)(this.resultPath), ...this.renderResultSelector(), ...this.renderCredentials() };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, TaskStateBase[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions.TaskStateBase", version: "2.80.0" }, exports2.TaskStateBase = TaskStateBase;
    var IntegrationPattern;
    (function(IntegrationPattern2) {
      IntegrationPattern2.REQUEST_RESPONSE = "REQUEST_RESPONSE", IntegrationPattern2.RUN_JOB = "RUN_JOB", IntegrationPattern2.WAIT_FOR_TASK_TOKEN = "WAIT_FOR_TASK_TOKEN";
    })(IntegrationPattern = exports2.IntegrationPattern || (exports2.IntegrationPattern = {}));
    var Timeout = class {
      static duration(duration) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Duration(duration);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.duration), error;
        }
        return { seconds: duration.toSeconds() };
      }
      static at(path) {
        return { path };
      }
    };
    _b = JSII_RTTI_SYMBOL_1, Timeout[_b] = { fqn: "aws-cdk-lib.aws_stepfunctions.Timeout", version: "2.80.0" }, exports2.Timeout = Timeout;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions/lib/task-credentials.js
var require_task_credentials = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions/lib/task-credentials.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.TaskRole = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var fields_1 = require_fields();
    var TaskRole = class {
      static fromRoleArnJsonPath(expression) {
        return new JsonExpressionTaskRole(expression);
      }
      static fromRole(role) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IRole(role);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromRole), error;
        }
        return new IamRoleTaskRole(role);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, TaskRole[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions.TaskRole", version: "2.80.0" }, exports2.TaskRole = TaskRole;
    var JsonExpressionTaskRole = class extends TaskRole {
      constructor(expression) {
        super(), this.roleArn = fields_1.JsonPath.stringAt(expression), this.resource = "*";
      }
    };
    var IamRoleTaskRole = class extends TaskRole {
      constructor(role) {
        super(), this.roleArn = role.roleArn, this.resource = role.roleArn;
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions/lib/index.js
var require_lib39 = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_fields(), exports2), __exportStar(require_activity(), exports2), __exportStar(require_input2(), exports2), __exportStar(require_types7(), exports2), __exportStar(require_condition(), exports2), __exportStar(require_state_machine2(), exports2), __exportStar(require_state_machine_fragment(), exports2), __exportStar(require_state_transition_metrics(), exports2), __exportStar(require_chain(), exports2), __exportStar(require_state_graph(), exports2), __exportStar(require_step_functions_task(), exports2), __exportStar(require_choice(), exports2), __exportStar(require_fail(), exports2), __exportStar(require_parallel(), exports2), __exportStar(require_pass(), exports2), __exportStar(require_state(), exports2), __exportStar(require_succeed(), exports2), __exportStar(require_task(), exports2), __exportStar(require_wait(), exports2), __exportStar(require_map(), exports2), __exportStar(require_custom_state(), exports2), __exportStar(require_task_base(), exports2), __exportStar(require_task_credentials(), exports2), __exportStar(require_stepfunctions_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions/index.js
var require_aws_stepfunctions = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib39(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/integrations/stepfunctions.js
var require_stepfunctions2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/integrations/stepfunctions.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.StepFunctionsIntegration = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var fs = require("fs");
    var path = require("path");
    var aws_1 = require_aws2();
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var core_1 = require_core2();
    var integration_1 = require_integration();
    var model_1 = require_model();
    var StepFunctionsIntegration = class {
      static startExecution(stateMachine, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_IStateMachine(stateMachine), jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_StepFunctionsExecutionIntegrationOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.startExecution), error;
        }
        return new StepFunctionsExecutionIntegration(stateMachine, options);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, StepFunctionsIntegration[_a] = { fqn: "aws-cdk-lib.aws_apigateway.StepFunctionsIntegration", version: "2.80.0" }, exports2.StepFunctionsIntegration = StepFunctionsIntegration;
    var StepFunctionsExecutionIntegration = class extends aws_1.AwsIntegration {
      constructor(stateMachine, options = {}) {
        super({ service: "states", action: "StartSyncExecution", options: { credentialsRole: options.credentialsRole, integrationResponses: integrationResponse(), passthroughBehavior: integration_1.PassthroughBehavior.NEVER, requestTemplates: requestTemplates(stateMachine, options), ...options } }), this.stateMachine = stateMachine;
      }
      bind(method) {
        const bindResult = super.bind(method), credentialsRole = bindResult.options?.credentialsRole ?? new iam.Role(method, "StartSyncExecutionRole", { assumedBy: new iam.ServicePrincipal("apigateway.amazonaws.com") });
        this.stateMachine.grantStartSyncExecution(credentialsRole);
        let stateMachineName;
        if (this.stateMachine instanceof sfn.StateMachine) {
          if (this.stateMachine.stateMachineType !== sfn.StateMachineType.EXPRESS)
            throw new Error('State Machine must be of type "EXPRESS". Please use StateMachineType.EXPRESS as the stateMachineType');
          stateMachineName = this.stateMachine.node.defaultChild.stateMachineName;
        } else
          stateMachineName = `StateMachine-${this.stateMachine.stack.node.addr}`;
        let deploymentToken;
        stateMachineName !== void 0 && !core_1.Token.isUnresolved(stateMachineName) && (deploymentToken = JSON.stringify({ stateMachineName }));
        for (const methodResponse of METHOD_RESPONSES)
          method.addMethodResponse(methodResponse);
        return { ...bindResult, options: { ...bindResult.options, credentialsRole }, deploymentToken };
      }
    };
    function integrationResponse() {
      const errorResponse = [{ selectionPattern: "4\\d{2}", statusCode: "400", responseTemplates: { "application/json": `{
            "error": "Bad request!"
          }` } }, { selectionPattern: "5\\d{2}", statusCode: "500", responseTemplates: { "application/json": `"error": $input.path('$.error')` } }];
      return [{ statusCode: "200", responseTemplates: { "application/json": ["#set($inputRoot = $input.path('$'))", `#if($input.path('$.status').toString().equals("FAILED"))`, "#set($context.responseOverride.status = 500)", "{", `"error": "$input.path('$.error')",`, `"cause": "$input.path('$.cause')"`, "}", "#else", "$input.path('$.output')", "#end"].join(`
`) } }, ...errorResponse];
    }
    function requestTemplates(stateMachine, options) {
      return { "application/json": templateString(stateMachine, options) };
    }
    function templateString(stateMachine, options) {
      let templateStr, requestContextStr = "";
      const includeHeader = options.headers ?? false, includeQueryString = options.querystring ?? true, includePath = options.path ?? true, includeAuthorizer = options.authorizer ?? false;
      return options.requestContext && Object.keys(options.requestContext).length > 0 && (requestContextStr = requestContext(options.requestContext)), templateStr = fs.readFileSync(path.join(__dirname, "stepfunctions.vtl"), { encoding: "utf-8" }), templateStr = templateStr.replace("%STATEMACHINE%", stateMachine.stateMachineArn), templateStr = templateStr.replace("%INCLUDE_HEADERS%", String(includeHeader)), templateStr = templateStr.replace("%INCLUDE_QUERYSTRING%", String(includeQueryString)), templateStr = templateStr.replace("%INCLUDE_PATH%", String(includePath)), templateStr = templateStr.replace("%INCLUDE_AUTHORIZER%", String(includeAuthorizer)), templateStr = templateStr.replace("%REQUESTCONTEXT%", requestContextStr), templateStr;
    }
    function requestContext(requestContextObj) {
      const context = { accountId: requestContextObj?.accountId ? "$context.identity.accountId" : void 0, apiId: requestContextObj?.apiId ? "$context.apiId" : void 0, apiKey: requestContextObj?.apiKey ? "$context.identity.apiKey" : void 0, authorizerPrincipalId: requestContextObj?.authorizerPrincipalId ? "$context.authorizer.principalId" : void 0, caller: requestContextObj?.caller ? "$context.identity.caller" : void 0, cognitoAuthenticationProvider: requestContextObj?.cognitoAuthenticationProvider ? "$context.identity.cognitoAuthenticationProvider" : void 0, cognitoAuthenticationType: requestContextObj?.cognitoAuthenticationType ? "$context.identity.cognitoAuthenticationType" : void 0, cognitoIdentityId: requestContextObj?.cognitoIdentityId ? "$context.identity.cognitoIdentityId" : void 0, cognitoIdentityPoolId: requestContextObj?.cognitoIdentityPoolId ? "$context.identity.cognitoIdentityPoolId" : void 0, httpMethod: requestContextObj?.httpMethod ? "$context.httpMethod" : void 0, stage: requestContextObj?.stage ? "$context.stage" : void 0, sourceIp: requestContextObj?.sourceIp ? "$context.identity.sourceIp" : void 0, user: requestContextObj?.user ? "$context.identity.user" : void 0, userAgent: requestContextObj?.userAgent ? "$context.identity.userAgent" : void 0, userArn: requestContextObj?.userArn ? "$context.identity.userArn" : void 0, requestId: requestContextObj?.requestId ? "$context.requestId" : void 0, resourceId: requestContextObj?.resourceId ? "$context.resourceId" : void 0, resourcePath: requestContextObj?.resourcePath ? "$context.resourcePath" : void 0 }, contextAsString = JSON.stringify(context), doublequotes = '"', replaceWith = "@@";
      return contextAsString.split(doublequotes).join(replaceWith);
    }
    var METHOD_RESPONSES = [{ statusCode: "200", responseModels: { "application/json": model_1.Model.EMPTY_MODEL } }, { statusCode: "400", responseModels: { "application/json": model_1.Model.ERROR_MODEL } }, { statusCode: "500", responseModels: { "application/json": model_1.Model.ERROR_MODEL } }];
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/integrations/request-context.js
var require_request_context = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/integrations/request-context.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/integrations/index.js
var require_integrations = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/integrations/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_aws2(), exports2), __exportStar(require_lambda3(), exports2), __exportStar(require_http2(), exports2), __exportStar(require_mock(), exports2), __exportStar(require_stepfunctions2(), exports2), __exportStar(require_request_context(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/authorizer.js
var require_authorizer = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/authorizer.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Authorizer = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var method_1 = require_method();
    var core_1 = require_core2();
    var AUTHORIZER_SYMBOL = Symbol.for("@aws-cdk/aws-apigateway.Authorizer");
    var Authorizer = class _Authorizer extends core_1.Resource {
      static isAuthorizer(x) {
        return x !== null && typeof x == "object" && AUTHORIZER_SYMBOL in x;
      }
      constructor(scope, id, props) {
        super(scope, id, props), this.authorizationType = method_1.AuthorizationType.CUSTOM;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ResourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Authorizer), error;
        }
        Object.defineProperty(this, AUTHORIZER_SYMBOL, { value: true });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Authorizer[_a] = { fqn: "aws-cdk-lib.aws_apigateway.Authorizer", version: "2.80.0" }, exports2.Authorizer = Authorizer;
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/method.js
var require_method = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/method.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AuthorizationType = exports2.Method = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var apigateway_canned_metrics_generated_1 = require_apigateway_canned_metrics_generated();
    var apigateway_generated_1 = require_apigateway_generated();
    var authorizer_1 = require_authorizer();
    var mock_1 = require_mock();
    var restapi_1 = require_restapi();
    var util_1 = require_util13();
    var cloudwatch = require_aws_cloudwatch();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var cx_api_1 = require_cx_api();
    var Method = class _Method extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_MethodProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Method), error;
        }
        this.resource = props.resource, this.api = props.resource.api, this.httpMethod = props.httpMethod.toUpperCase(), (0, util_1.validateHttpMethod)(this.httpMethod);
        const options = props.options || {}, defaultMethodOptions = props.resource.defaultMethodOptions || {}, authorizer = options.authorizer || defaultMethodOptions.authorizer, authorizerId = authorizer?.authorizerId ? authorizer.authorizerId : void 0, authorizationTypeOption = options.authorizationType || defaultMethodOptions.authorizationType, authorizationType = authorizer?.authorizationType || authorizationTypeOption || AuthorizationType.NONE;
        if (authorizer?.authorizationType && authorizationTypeOption && authorizer?.authorizationType !== authorizationTypeOption)
          throw new Error(`${this.resource}/${this.httpMethod} - Authorization type is set to ${authorizationTypeOption} which is different from what is required by the authorizer [${authorizer.authorizationType}]`);
        authorizer_1.Authorizer.isAuthorizer(authorizer) && authorizer._attachToApi(this.api), this.methodResponses = options.methodResponses ?? [];
        const bindResult = (props.integration ?? this.resource.defaultIntegration ?? new mock_1.MockIntegration()).bind(this), methodProps = { resourceId: props.resource.resourceId, restApiId: this.api.restApiId, httpMethod: this.httpMethod, operationName: options.operationName || defaultMethodOptions.operationName, apiKeyRequired: options.apiKeyRequired || defaultMethodOptions.apiKeyRequired, authorizationType, authorizerId, requestParameters: options.requestParameters || defaultMethodOptions.requestParameters, integration: this.renderIntegration(bindResult), methodResponses: core_1.Lazy.any({ produce: () => this.renderMethodResponses(this.methodResponses) }, { omitEmptyArray: true }), requestModels: this.renderRequestModels(options.requestModels), requestValidatorId: this.requestValidatorId(options), authorizationScopes: options.authorizationScopes ?? defaultMethodOptions.authorizationScopes }, resource = new apigateway_generated_1.CfnMethod(this, "Resource", methodProps);
        this.methodId = resource.ref, restapi_1.RestApiBase._isRestApiBase(props.resource.api) && props.resource.api._attachMethod(this);
        const deployment = props.resource.api.latestDeployment;
        deployment && (deployment.node.addDependency(resource), deployment.addToLogicalId({ method: { ...methodProps, integrationToken: bindResult?.deploymentToken } }));
      }
      get restApi() {
        return this.resource.restApi;
      }
      get methodArn() {
        const stage = this.api.deploymentStage?.stageName;
        return this.api.arnForExecuteApi(this.httpMethod, pathForArn(this.resource.path), stage);
      }
      get testMethodArn() {
        return this.api.arnForExecuteApi(this.httpMethod, pathForArn(this.resource.path), "test-invoke-stage");
      }
      addMethodResponse(methodResponse) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_MethodResponse(methodResponse);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addMethodResponse), error;
        }
        this.methodResponses.push(methodResponse);
      }
      renderIntegration(bindResult) {
        const options = bindResult.options ?? {};
        let credentials;
        return options.credentialsRole ? credentials = options.credentialsRole.roleArn : options.credentialsPassthrough && (credentials = core_1.Stack.of(this).formatArn({ service: "iam", region: "", account: "*", resource: "user", arnFormat: core_1.ArnFormat.SLASH_RESOURCE_NAME, resourceName: "*" })), { type: bindResult.type, uri: bindResult.uri, cacheKeyParameters: options.cacheKeyParameters, cacheNamespace: options.cacheNamespace, contentHandling: options.contentHandling, integrationHttpMethod: bindResult.integrationHttpMethod, requestParameters: options.requestParameters, requestTemplates: options.requestTemplates, passthroughBehavior: options.passthroughBehavior, integrationResponses: options.integrationResponses, connectionType: options.connectionType, connectionId: options.vpcLink ? options.vpcLink.vpcLinkId : void 0, credentials, timeoutInMillis: options.timeout?.toMilliseconds() };
      }
      renderMethodResponses(methodResponses) {
        if (methodResponses)
          return methodResponses.map((mr) => {
            let responseModels;
            if (mr.responseModels) {
              responseModels = {};
              for (const contentType in mr.responseModels)
                mr.responseModels.hasOwnProperty(contentType) && (responseModels[contentType] = mr.responseModels[contentType].modelId);
            }
            return { statusCode: mr.statusCode, responseParameters: mr.responseParameters, responseModels };
          });
      }
      renderRequestModels(requestModels) {
        if (!requestModels)
          return;
        const models = {};
        for (const contentType in requestModels)
          requestModels.hasOwnProperty(contentType) && (models[contentType] = requestModels[contentType].modelId);
        return models;
      }
      requestValidatorId(options) {
        if (options.requestValidator && options.requestValidatorOptions)
          throw new Error("Only one of 'requestValidator' or 'requestValidatorOptions' must be specified.");
        if (options.requestValidatorOptions) {
          const id = core_1.FeatureFlags.of(this).isEnabled(cx_api_1.APIGATEWAY_REQUEST_VALIDATOR_UNIQUE_ID) ? `${core_1.Names.uniqueResourceName(new constructs_1.Construct(this, "Validator"), {})}` : "validator";
          return this.api.addRequestValidator(id, options.requestValidatorOptions).requestValidatorId;
        }
        return options.requestValidator?.requestValidatorId;
      }
      metric(metricName, stage, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_IStage(stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metric), error;
        }
        return new cloudwatch.Metric({ namespace: "AWS/ApiGateway", metricName, dimensionsMap: { ApiName: this.api.restApiName, Method: this.httpMethod, Resource: this.resource.path, Stage: stage.stageName }, ...props }).attachTo(this);
      }
      metricClientError(stage, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_IStage(stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricClientError), error;
        }
        return this.cannedMetric(apigateway_canned_metrics_generated_1.ApiGatewayMetrics._4XxErrorSum, stage, props);
      }
      metricServerError(stage, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_IStage(stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricServerError), error;
        }
        return this.cannedMetric(apigateway_canned_metrics_generated_1.ApiGatewayMetrics._5XxErrorSum, stage, props);
      }
      metricCacheHitCount(stage, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_IStage(stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricCacheHitCount), error;
        }
        return this.cannedMetric(apigateway_canned_metrics_generated_1.ApiGatewayMetrics.cacheHitCountSum, stage, props);
      }
      metricCacheMissCount(stage, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_IStage(stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricCacheMissCount), error;
        }
        return this.cannedMetric(apigateway_canned_metrics_generated_1.ApiGatewayMetrics.cacheMissCountSum, stage, props);
      }
      metricCount(stage, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_IStage(stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricCount), error;
        }
        return this.cannedMetric(apigateway_canned_metrics_generated_1.ApiGatewayMetrics.countSum, stage, { statistic: "SampleCount", ...props });
      }
      metricIntegrationLatency(stage, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_IStage(stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricIntegrationLatency), error;
        }
        return this.cannedMetric(apigateway_canned_metrics_generated_1.ApiGatewayMetrics.integrationLatencyAverage, stage, props);
      }
      metricLatency(stage, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_IStage(stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricLatency), error;
        }
        return this.cannedMetric(apigateway_canned_metrics_generated_1.ApiGatewayMetrics.latencyAverage, stage, props);
      }
      grantExecute(grantee) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(grantee);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantExecute), error;
        }
        return iam.Grant.addToPrincipal({ grantee, actions: ["execute-api:Invoke"], resourceArns: [this.methodArn] });
      }
      cannedMetric(fn, stage, props) {
        return new cloudwatch.Metric({ ...fn({ ApiName: this.api.restApiName, Method: this.httpMethod, Resource: this.resource.path, Stage: stage.stageName }), ...props }).attachTo(this);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Method[_a] = { fqn: "aws-cdk-lib.aws_apigateway.Method", version: "2.80.0" }, exports2.Method = Method;
    var AuthorizationType;
    (function(AuthorizationType2) {
      AuthorizationType2.NONE = "NONE", AuthorizationType2.IAM = "AWS_IAM", AuthorizationType2.CUSTOM = "CUSTOM", AuthorizationType2.COGNITO = "COGNITO_USER_POOLS";
    })(AuthorizationType = exports2.AuthorizationType || (exports2.AuthorizationType = {}));
    function pathForArn(path) {
      return path.replace(/\{[^\}]*\}/g, "*");
    }
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/resource.js
var require_resource2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/resource.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ProxyResource = exports2.Resource = exports2.ResourceBase = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var apigateway_generated_1 = require_apigateway_generated();
    var cors_1 = require_cors();
    var integrations_1 = require_integrations();
    var method_1 = require_method();
    var core_1 = require_core2();
    var ResourceBase = class extends core_1.Resource {
      constructor(scope, id) {
        super(scope, id), this.children = {};
      }
      addResource(pathPart, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_ResourceOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addResource), error;
        }
        return new Resource(this, pathPart, { parent: this, pathPart, ...options });
      }
      addMethod(httpMethod, integration, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_Integration(integration), jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_MethodOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addMethod), error;
        }
        return new method_1.Method(this, httpMethod, { resource: this, httpMethod, integration, options });
      }
      addProxy(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_ProxyResourceOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addProxy), error;
        }
        return new ProxyResource(this, "{proxy+}", { parent: this, ...options });
      }
      addCorsPreflight(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_CorsOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addCorsPreflight), error;
        }
        const headers = {}, allowHeaders = options.allowHeaders || cors_1.Cors.DEFAULT_HEADERS;
        if (headers["Access-Control-Allow-Headers"] = `'${allowHeaders.join(",")}'`, options.allowOrigins.length === 0)
          throw new Error("allowOrigins must contain at least one origin");
        if (options.allowOrigins.includes("*") && options.allowOrigins.length > 1)
          throw new Error(`Invalid "allowOrigins" - cannot mix "*" with specific origins: ${options.allowOrigins.join(",")}`);
        const initialOrigin = options.allowOrigins[0];
        headers["Access-Control-Allow-Origin"] = `'${initialOrigin}'`, initialOrigin !== "*" && (headers.Vary = "'Origin'");
        let allowMethods = options.allowMethods || cors_1.Cors.ALL_METHODS;
        if (allowMethods.includes("ANY")) {
          if (allowMethods.length > 1)
            throw new Error(`ANY cannot be used with any other method. Received: ${allowMethods.join(",")}`);
          allowMethods = cors_1.Cors.ALL_METHODS;
        }
        headers["Access-Control-Allow-Methods"] = `'${allowMethods.join(",")}'`, options.allowCredentials && (headers["Access-Control-Allow-Credentials"] = "'true'");
        let maxAgeSeconds;
        if (options.maxAge && options.disableCache)
          throw new Error('The options "maxAge" and "disableCache" are mutually exclusive');
        options.maxAge && (maxAgeSeconds = options.maxAge.toSeconds()), options.disableCache && (maxAgeSeconds = -1), maxAgeSeconds && (headers["Access-Control-Max-Age"] = `'${maxAgeSeconds}'`), options.exposeHeaders && (headers["Access-Control-Expose-Headers"] = `'${options.exposeHeaders.join(",")}'`);
        const statusCode = options.statusCode ?? 204, integrationResponseParams = {}, methodResponseParams = {};
        for (const [name, value] of Object.entries(headers)) {
          const key = `method.response.header.${name}`;
          integrationResponseParams[key] = value, methodResponseParams[key] = true;
        }
        return this.addMethod("OPTIONS", new integrations_1.MockIntegration({ requestTemplates: { "application/json": "{ statusCode: 200 }" }, integrationResponses: [{ statusCode: `${statusCode}`, responseParameters: integrationResponseParams, responseTemplates: renderResponseTemplate() }] }), { authorizer: { authorizerId: "", authorizationType: method_1.AuthorizationType.NONE }, apiKeyRequired: false, authorizationType: method_1.AuthorizationType.NONE, methodResponses: [{ statusCode: `${statusCode}`, responseParameters: methodResponseParams }] });
        function renderResponseTemplate() {
          const origins = options.allowOrigins.slice(1);
          if (origins.length === 0)
            return;
          const template = new Array();
          template.push('#set($origin = $input.params().header.get("Origin"))'), template.push('#if($origin == "") #set($origin = $input.params().header.get("origin")) #end');
          const condition = origins.map((o) => `$origin.matches("${o}")`).join(" || ");
          return template.push(`#if(${condition})`), template.push("  #set($context.responseOverride.header.Access-Control-Allow-Origin = $origin)"), template.push("#end"), { "application/json": template.join(`
`) };
        }
      }
      getResource(pathPart) {
        return this.children[pathPart];
      }
      _trackChild(pathPart, resource) {
        this.children[pathPart] = resource;
      }
      resourceForPath(path) {
        if (!path)
          return this;
        if (path.startsWith("/")) {
          if (this.path !== "/")
            throw new Error(`Path may start with "/" only for the resource, but we are at: ${this.path}`);
          return this.resourceForPath(path.slice(1));
        }
        const parts = path.split("/"), next = parts.shift();
        if (!next || next === "")
          throw new Error("resourceForPath cannot be called with an empty path");
        let resource = this.getResource(next);
        return resource || (resource = this.addResource(next)), resource.resourceForPath(parts.join("/"));
      }
      get url() {
        return this.restApi.urlForPath(this.path);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ResourceBase[_a] = { fqn: "aws-cdk-lib.aws_apigateway.ResourceBase", version: "2.80.0" }, exports2.ResourceBase = ResourceBase;
    var Resource = class _Resource extends ResourceBase {
      static fromResourceAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_ResourceAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromResourceAttributes), error;
        }
        class Import extends ResourceBase {
          constructor() {
            super(...arguments), this.api = attrs.restApi, this.resourceId = attrs.resourceId, this.path = attrs.path, this.defaultIntegration = void 0, this.defaultMethodOptions = void 0, this.defaultCorsPreflightOptions = void 0;
          }
          get parentResource() {
            throw new Error("parentResource is not configured for imported resource.");
          }
          get restApi() {
            throw new Error("restApi is not configured for imported resource.");
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_ResourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Resource), error;
        }
        validateResourcePathPart(props.pathPart), this.parentResource = props.parent, props.parent instanceof ResourceBase && props.parent._trackChild(props.pathPart, this);
        const resourceProps = { restApiId: props.parent.api.restApiId, parentId: props.parent.resourceId, pathPart: props.pathPart }, resource = new apigateway_generated_1.CfnResource(this, "Resource", resourceProps);
        this.resourceId = resource.ref, this.api = props.parent.api, this.path = props.parent.path, this.path.endsWith("/") || (this.path += "/"), this.path += props.pathPart;
        const deployment = props.parent.api.latestDeployment;
        deployment && (deployment.node.addDependency(resource), deployment.addToLogicalId({ resource: resourceProps })), this.defaultIntegration = props.defaultIntegration || props.parent.defaultIntegration, this.defaultMethodOptions = { ...props.parent.defaultMethodOptions, ...props.defaultMethodOptions }, this.defaultCorsPreflightOptions = props.defaultCorsPreflightOptions || props.parent.defaultCorsPreflightOptions, this.defaultCorsPreflightOptions && this.addCorsPreflight(this.defaultCorsPreflightOptions);
      }
      get restApi() {
        if (!this.parentResource)
          throw new Error("parentResource was unexpectedly not defined");
        return this.parentResource.restApi;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, Resource[_b] = { fqn: "aws-cdk-lib.aws_apigateway.Resource", version: "2.80.0" }, exports2.Resource = Resource;
    var ProxyResource = class _ProxyResource extends Resource {
      constructor(scope, id, props) {
        super(scope, id, { parent: props.parent, pathPart: "{proxy+}", defaultIntegration: props.defaultIntegration, defaultMethodOptions: props.defaultMethodOptions });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_ProxyResourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ProxyResource), error;
        }
        (props.anyMethod ?? true) && (this.anyMethod = this.addMethod("ANY"));
      }
      addMethod(httpMethod, integration, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_Integration(integration), jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_MethodOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addMethod), error;
        }
        return this.parentResource && this.parentResource.path === "/" && (this.parentResource.node.tryFindChild(httpMethod) instanceof method_1.Method || this.parentResource.addMethod(httpMethod, integration, options)), super.addMethod(httpMethod, integration, options);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, ProxyResource[_c] = { fqn: "aws-cdk-lib.aws_apigateway.ProxyResource", version: "2.80.0" }, exports2.ProxyResource = ProxyResource;
    function validateResourcePathPart(part) {
      if (part.startsWith("{") && part.endsWith("}") && (part = part.slice(1, -1), part.endsWith("+") && (part = part.slice(0, -1))), !/^[a-zA-Z0-9:\.\_\-]+$/.test(part))
        throw new Error(`Resource's path part only allow [a-zA-Z0-9:._-], an optional trailing '+'
      and curly braces at the beginning and the end: ${part}`);
    }
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/access-log.js
var require_access_log = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/access-log.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AccessLogFormat = exports2.AccessLogField = exports2.LogGroupLogDestination = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var LogGroupLogDestination = class _LogGroupLogDestination {
      constructor(logGroup) {
        this.logGroup = logGroup;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_logs_ILogGroup(logGroup);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _LogGroupLogDestination), error;
        }
      }
      bind(_stage) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_IStage(_stage);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { destinationArn: this.logGroup.logGroupArn };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LogGroupLogDestination[_a] = { fqn: "aws-cdk-lib.aws_apigateway.LogGroupLogDestination", version: "2.80.0" }, exports2.LogGroupLogDestination = LogGroupLogDestination;
    var AccessLogField = class {
      static contextAccountId() {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_apigateway.AccessLogField#contextAccountId", "Use `contextCallerAccountId` or `contextOwnerAccountId` instead");
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.contextAccountId), error;
        }
        return "$context.identity.accountId";
      }
      static contextCallerAccountId() {
        return "$context.identity.accountId";
      }
      static contextOwnerAccountId() {
        return "$context.accountId";
      }
      static contextApiId() {
        return "$context.apiId";
      }
      static contextAuthorizerClaims(property) {
        return `$context.authorizer.claims.${property}`;
      }
      static contextAuthorizerPrincipalId() {
        return "$context.authorizer.principalId";
      }
      static contextAuthorizer(property) {
        return `$context.authorizer.${property}`;
      }
      static contextAwsEndpointRequestId() {
        return "$context.awsEndpointRequestId";
      }
      static contextDomainName() {
        return "$context.domainName";
      }
      static contextDomainPrefix() {
        return "$context.domainPrefix";
      }
      static contextErrorMessage() {
        return "$context.error.message";
      }
      static contextErrorMessageString() {
        return "$context.error.messageString";
      }
      static contextErrorResponseType() {
        return "$context.error.responseType";
      }
      static contextErrorValidationErrorString() {
        return "$context.error.validationErrorString";
      }
      static contextExtendedRequestId() {
        return "$context.extendedRequestId";
      }
      static contextHttpMethod() {
        return "$context.httpMethod";
      }
      static contextIdentityAccountId() {
        return "$context.identity.accountId";
      }
      static contextIdentityApiKey() {
        return "$context.identity.apiKey";
      }
      static contextIdentityApiKeyId() {
        return "$context.identity.apiKeyId";
      }
      static contextIdentityCaller() {
        return "$context.identity.caller";
      }
      static contextIdentityCognitoAuthenticationProvider() {
        return "$context.identity.cognitoAuthenticationProvider";
      }
      static contextIdentityCognitoAuthenticationType() {
        return "$context.identity.cognitoAuthenticationType";
      }
      static contextIdentityCognitoIdentityId() {
        return "$context.identity.cognitoIdentityId";
      }
      static contextIdentityCognitoIdentityPoolId() {
        return "$context.identity.cognitoIdentityPoolId";
      }
      static contextIdentityPrincipalOrgId() {
        return "$context.identity.principalOrgId";
      }
      static contextIdentitySourceIp() {
        return "$context.identity.sourceIp";
      }
      static contextIdentityClientCertPem() {
        return "$context.identity.clientCert.clientCertPem";
      }
      static contextIdentityClientCertSubjectDN() {
        return "$context.identity.clientCert.subjectDN";
      }
      static contextIdentityClientCertIssunerDN() {
        return "$context.identity.clientCert.issuerDN";
      }
      static contextIdentityClientCertSerialNumber() {
        return "$context.identity.clientCert.serialNumber";
      }
      static contextIdentityClientCertValidityNotBefore() {
        return "$context.identity.clientCert.validity.notBefore";
      }
      static contextIdentityClientCertValidityNotAfter() {
        return "$context.identity.clientCert.validity.notAfter";
      }
      static contextIdentityUser() {
        return "$context.identity.user";
      }
      static contextIdentityUserAgent() {
        return "$context.identity.userAgent";
      }
      static contextIdentityUserArn() {
        return "$context.identity.userArn";
      }
      static contextPath() {
        return "$context.path";
      }
      static contextProtocol() {
        return "$context.protocol";
      }
      static contextRequestId() {
        return "$context.requestId";
      }
      static contextRequestOverrideHeader(headerName) {
        return `$context.requestOverride.header.${headerName}`;
      }
      static contextRequestOverridePath(pathName) {
        return `$context.requestOverride.path.${pathName}`;
      }
      static contextRequestOverrideQuerystring(querystringName) {
        return `$context.requestOverride.querystring.${querystringName}`;
      }
      static contextResponseOverrideHeader(headerName) {
        return `$context.responseOverride.header.${headerName}`;
      }
      static contextResponseOverrideStatus() {
        return "$context.responseOverride.status";
      }
      static contextRequestTime() {
        return "$context.requestTime";
      }
      static contextRequestTimeEpoch() {
        return "$context.requestTimeEpoch";
      }
      static contextResourceId() {
        return "$context.resourceId";
      }
      static contextResourcePath() {
        return "$context.resourcePath";
      }
      static contextStage() {
        return "$context.stage";
      }
      static contextWafResponseCode() {
        return "$context.wafResponseCode";
      }
      static contextWebaclArn() {
        return "$context.webaclArn";
      }
      static contextXrayTraceId() {
        return "$context.xrayTraceId";
      }
      static contextAuthorizerIntegrationLatency() {
        return "$context.authorizer.integrationLatency";
      }
      static contextIntegrationLatency() {
        return "$context.integrationLatency";
      }
      static contextIntegrationStatus() {
        return "$context.integrationStatus";
      }
      static contextResponseLatency() {
        return "$context.responseLatency";
      }
      static contextResponseLength() {
        return "$context.responseLength";
      }
      static contextStatus() {
        return "$context.status";
      }
      static contextAuthorizeError() {
        return "$context.authorize.error";
      }
      static contextAuthorizeLatency() {
        return "$context.authorize.latency";
      }
      static contextAuthorizeStatus() {
        return "$context.authorize.status";
      }
      static contextAuthorizerError() {
        return "$context.authorizer.error";
      }
      static contextAuthorizerIntegrationStatus() {
        return "$context.authorizer.integrationStatus";
      }
      static contextAuthorizerLatency() {
        return "$context.authorizer.latency";
      }
      static contextAuthorizerRequestId() {
        return "$context.authorizer.requestId";
      }
      static contextAuthorizerStatus() {
        return "$context.authorizer.status";
      }
      static contextAuthenticateError() {
        return "$context.authenticate.error";
      }
      static contextAuthenticateLatency() {
        return "$context.authenticate.latency";
      }
      static contextAuthenticateStatus() {
        return "$context.authenticate.status";
      }
      static contextCustomDomainBasePathMatched() {
        return "$context.customDomain.basePathMatched";
      }
      static contextIntegrationErrorMessage() {
        return "$context.integrationErrorMessage";
      }
      static contextWafError() {
        return "$context.waf.error";
      }
      static contextWafLatency() {
        return "$context.waf.latency";
      }
      static contextWafStatus() {
        return "$context.waf.status";
      }
    };
    _b = JSII_RTTI_SYMBOL_1, AccessLogField[_b] = { fqn: "aws-cdk-lib.aws_apigateway.AccessLogField", version: "2.80.0" }, exports2.AccessLogField = AccessLogField;
    var AccessLogFormat = class _AccessLogFormat {
      static custom(format) {
        return new _AccessLogFormat(format);
      }
      static clf() {
        const requester = [AccessLogField.contextIdentitySourceIp(), AccessLogField.contextIdentityCaller(), AccessLogField.contextIdentityUser()].join(" "), requestTime = AccessLogField.contextRequestTime(), request = [AccessLogField.contextHttpMethod(), AccessLogField.contextResourcePath(), AccessLogField.contextProtocol()].join(" "), status = [AccessLogField.contextStatus(), AccessLogField.contextResponseLength(), AccessLogField.contextRequestId()].join(" ");
        return new _AccessLogFormat(`${requester} [${requestTime}] "${request}" ${status}`);
      }
      static jsonWithStandardFields(fields = { ip: true, user: true, caller: true, requestTime: true, httpMethod: true, resourcePath: true, status: true, protocol: true, responseLength: true }) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_JsonWithStandardFieldProps(fields);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.jsonWithStandardFields), error;
        }
        return this.custom(JSON.stringify({ requestId: AccessLogField.contextRequestId(), ip: fields.ip ? AccessLogField.contextIdentitySourceIp() : void 0, user: fields.user ? AccessLogField.contextIdentityUser() : void 0, caller: fields.caller ? AccessLogField.contextIdentityCaller() : void 0, requestTime: fields.requestTime ? AccessLogField.contextRequestTime() : void 0, httpMethod: fields.httpMethod ? AccessLogField.contextHttpMethod() : void 0, resourcePath: fields.resourcePath ? AccessLogField.contextResourcePath() : void 0, status: fields.status ? AccessLogField.contextStatus() : void 0, protocol: fields.protocol ? AccessLogField.contextProtocol() : void 0, responseLength: fields.responseLength ? AccessLogField.contextResponseLength() : void 0 }));
      }
      constructor(format) {
        this.format = format;
      }
      toString() {
        return this.format;
      }
    };
    _c = JSII_RTTI_SYMBOL_1, AccessLogFormat[_c] = { fqn: "aws-cdk-lib.aws_apigateway.AccessLogFormat", version: "2.80.0" }, exports2.AccessLogFormat = AccessLogFormat;
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/stage.js
var require_stage2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/stage.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Stage = exports2.StageBase = exports2.MethodLoggingLevel = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var access_log_1 = require_access_log();
    var api_key_1 = require_api_key();
    var apigateway_canned_metrics_generated_1 = require_apigateway_canned_metrics_generated();
    var apigateway_generated_1 = require_apigateway_generated();
    var restapi_1 = require_restapi();
    var util_1 = require_util13();
    var cloudwatch = require_aws_cloudwatch();
    var core_1 = require_core2();
    var MethodLoggingLevel;
    (function(MethodLoggingLevel2) {
      MethodLoggingLevel2.OFF = "OFF", MethodLoggingLevel2.ERROR = "ERROR", MethodLoggingLevel2.INFO = "INFO";
    })(MethodLoggingLevel = exports2.MethodLoggingLevel || (exports2.MethodLoggingLevel = {}));
    var StageBase = class extends core_1.Resource {
      addApiKey(id, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_ApiKeyOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addApiKey), error;
        }
        return new api_key_1.ApiKey(this, id, { stages: [this], ...options });
      }
      urlForPath(path = "/") {
        if (!path.startsWith("/"))
          throw new Error(`Path must begin with "/": ${path}`);
        return `https://${this.restApi.restApiId}.execute-api.${core_1.Stack.of(this).region}.${core_1.Stack.of(this).urlSuffix}/${this.stageName}${path}`;
      }
      get stageArn() {
        return core_1.Stack.of(this).formatArn({ arnFormat: core_1.ArnFormat.SLASH_RESOURCE_SLASH_RESOURCE_NAME, service: "apigateway", account: "", resource: "restapis", resourceName: `${this.restApi.restApiId}/stages/${this.stageName}` });
      }
      metric(metricName, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metric), error;
        }
        return new cloudwatch.Metric({ namespace: "AWS/ApiGateway", metricName, dimensionsMap: { ApiName: this.restApi.restApiName, Stage: this.stageName }, ...props }).attachTo(this);
      }
      metricClientError(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricClientError), error;
        }
        return this.cannedMetric(apigateway_canned_metrics_generated_1.ApiGatewayMetrics._4XxErrorSum, props);
      }
      metricServerError(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricServerError), error;
        }
        return this.cannedMetric(apigateway_canned_metrics_generated_1.ApiGatewayMetrics._5XxErrorSum, props);
      }
      metricCacheHitCount(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricCacheHitCount), error;
        }
        return this.cannedMetric(apigateway_canned_metrics_generated_1.ApiGatewayMetrics.cacheHitCountSum, props);
      }
      metricCacheMissCount(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricCacheMissCount), error;
        }
        return this.cannedMetric(apigateway_canned_metrics_generated_1.ApiGatewayMetrics.cacheMissCountSum, props);
      }
      metricCount(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricCount), error;
        }
        return this.cannedMetric(apigateway_canned_metrics_generated_1.ApiGatewayMetrics.countSum, { statistic: "SampleCount", ...props });
      }
      metricIntegrationLatency(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricIntegrationLatency), error;
        }
        return this.cannedMetric(apigateway_canned_metrics_generated_1.ApiGatewayMetrics.integrationLatencyAverage, props);
      }
      metricLatency(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricLatency), error;
        }
        return this.cannedMetric(apigateway_canned_metrics_generated_1.ApiGatewayMetrics.latencyAverage, props);
      }
      cannedMetric(fn, props) {
        return new cloudwatch.Metric({ ...fn({ ApiName: this.restApi.restApiName, Stage: this.stageName }), ...props }).attachTo(this);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, StageBase[_a] = { fqn: "aws-cdk-lib.aws_apigateway.StageBase", version: "2.80.0" }, exports2.StageBase = StageBase;
    var Stage = class _Stage extends StageBase {
      static fromStageAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_StageAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromStageAttributes), error;
        }
        class Import extends StageBase {
          constructor() {
            super(...arguments), this.stageName = attrs.stageName, this.restApi = attrs.restApi;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_StageProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Stage), error;
        }
        this.enableCacheCluster = props.cacheClusterEnabled;
        const methodSettings = this.renderMethodSettings(props);
        let accessLogSetting;
        const accessLogDestination = props.accessLogDestination, accessLogFormat = props.accessLogFormat;
        if (!accessLogDestination && !accessLogFormat)
          accessLogSetting = void 0;
        else {
          if (accessLogFormat !== void 0 && !core_1.Token.isUnresolved(accessLogFormat.toString()) && !/.*\$context.(requestId|extendedRequestId)\b.*/.test(accessLogFormat.toString()))
            throw new Error("Access log must include either `AccessLogFormat.contextRequestId()` or `AccessLogFormat.contextExtendedRequestId()`");
          if (accessLogFormat !== void 0 && accessLogDestination === void 0)
            throw new Error("Access log format is specified without a destination");
          accessLogSetting = { destinationArn: accessLogDestination?.bind(this).destinationArn, format: accessLogFormat?.toString() ? accessLogFormat?.toString() : access_log_1.AccessLogFormat.clf().toString() };
        }
        if (props.cacheClusterSize !== void 0) {
          if (this.enableCacheCluster === void 0)
            this.enableCacheCluster = true;
          else if (this.enableCacheCluster === false)
            throw new Error(`Cannot set "cacheClusterSize" to ${props.cacheClusterSize} and "cacheClusterEnabled" to "false"`);
        }
        const cacheClusterSize = this.enableCacheCluster ? props.cacheClusterSize || "0.5" : void 0, resource = new apigateway_generated_1.CfnStage(this, "Resource", { stageName: props.stageName || "prod", accessLogSetting, cacheClusterEnabled: this.enableCacheCluster, cacheClusterSize, clientCertificateId: props.clientCertificateId, deploymentId: props.deployment.deploymentId, restApiId: props.deployment.api.restApiId, description: props.description, documentationVersion: props.documentationVersion, variables: props.variables, tracingEnabled: props.tracingEnabled, methodSettings });
        this.stageName = resource.ref, this.restApi = props.deployment.api, restapi_1.RestApiBase._isRestApiBase(this.restApi) && this.restApi._attachStage(this);
      }
      renderMethodSettings(props) {
        const settings = new Array(), self2 = this, commonMethodOptions = { metricsEnabled: props.metricsEnabled, loggingLevel: props.loggingLevel, dataTraceEnabled: props.dataTraceEnabled, throttlingBurstLimit: props.throttlingBurstLimit, throttlingRateLimit: props.throttlingRateLimit, cachingEnabled: props.cachingEnabled, cacheTtl: props.cacheTtl, cacheDataEncrypted: props.cacheDataEncrypted };
        if (Object.keys(commonMethodOptions).map((v) => commonMethodOptions[v]).filter((x) => x !== void 0).length > 0 && settings.push(renderEntry("/*/*", commonMethodOptions)), props.methodOptions)
          for (const path of Object.keys(props.methodOptions))
            settings.push(renderEntry(path, props.methodOptions[path]));
        return settings.length === 0 ? void 0 : settings;
        function renderEntry(path, options) {
          if (options.cachingEnabled) {
            if (self2.enableCacheCluster === void 0)
              self2.enableCacheCluster = true;
            else if (self2.enableCacheCluster === false)
              throw new Error(`Cannot enable caching for method ${path} since cache cluster is disabled on stage`);
          }
          const { httpMethod, resourcePath } = (0, util_1.parseMethodOptionsPath)(path);
          return { httpMethod, resourcePath, cacheDataEncrypted: options.cacheDataEncrypted, cacheTtlInSeconds: options.cacheTtl && options.cacheTtl.toSeconds(), cachingEnabled: options.cachingEnabled, dataTraceEnabled: options.dataTraceEnabled ?? false, loggingLevel: options.loggingLevel, metricsEnabled: options.metricsEnabled, throttlingBurstLimit: options.throttlingBurstLimit, throttlingRateLimit: options.throttlingRateLimit };
        }
      }
    };
    _b = JSII_RTTI_SYMBOL_1, Stage[_b] = { fqn: "aws-cdk-lib.aws_apigateway.Stage", version: "2.80.0" }, exports2.Stage = Stage;
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/restapi.js
var require_restapi = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/restapi.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EndpointType = exports2.ApiKeySourceType = exports2.RestApi = exports2.SpecRestApi = exports2.RestApiBase = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var api_key_1 = require_api_key();
    var apigateway_canned_metrics_generated_1 = require_apigateway_canned_metrics_generated();
    var apigateway_generated_1 = require_apigateway_generated();
    var deployment_1 = require_deployment();
    var domain_name_1 = require_domain_name();
    var gateway_response_1 = require_gateway_response();
    var model_1 = require_model();
    var requestvalidator_1 = require_requestvalidator();
    var resource_1 = require_resource2();
    var stage_1 = require_stage2();
    var usage_plan_1 = require_usage_plan();
    var cloudwatch = require_aws_cloudwatch();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var cx_api_1 = require_cx_api();
    var RESTAPI_SYMBOL = Symbol.for("@aws-cdk/aws-apigateway.RestApiBase");
    var RestApiBase = class _RestApiBase extends core_1.Resource {
      static _isRestApiBase(x) {
        return x !== null && typeof x == "object" && RESTAPI_SYMBOL in x;
      }
      get latestDeployment() {
        return this._latestDeployment;
      }
      get domainName() {
        return this._domainName;
      }
      constructor(scope, id, props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_RestApiBaseProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _RestApiBase), error;
        }
        const restApiName = props.restApiName ?? id;
        super(scope, id, { physicalName: restApiName }), this.restApiName = restApiName, Object.defineProperty(this, RESTAPI_SYMBOL, { value: true });
      }
      urlForPath(path = "/") {
        if (!this.deploymentStage)
          throw new Error('Cannot determine deployment stage for API from "deploymentStage". Use "deploy" or explicitly set "deploymentStage"');
        return this.deploymentStage.urlForPath(path);
      }
      addDomainName(id, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_DomainNameOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addDomainName), error;
        }
        const domainName = new domain_name_1.DomainName(this, id, { ...options, mapping: this });
        return this._domainName || (this._domainName = domainName), domainName;
      }
      addUsagePlan(id, props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_UsagePlanProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addUsagePlan), error;
        }
        return new usage_plan_1.UsagePlan(this, id, props);
      }
      arnForExecuteApi(method = "*", path = "/*", stage = "*") {
        if (!core_1.Token.isUnresolved(path) && !path.startsWith("/"))
          throw new Error(`"path" must begin with a "/": '${path}'`);
        return method.toUpperCase() === "ANY" && (method = "*"), core_1.Stack.of(this).formatArn({ service: "execute-api", resource: this.restApiId, arnFormat: core_1.ArnFormat.SLASH_RESOURCE_NAME, resourceName: `${stage}/${method}${path}` });
      }
      addGatewayResponse(id, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_GatewayResponseOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addGatewayResponse), error;
        }
        return new gateway_response_1.GatewayResponse(this, id, { restApi: this, ...options });
      }
      addApiKey(id, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_ApiKeyOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addApiKey), error;
        }
        return new api_key_1.ApiKey(this, id, { stages: [this.deploymentStage], ...options });
      }
      metric(metricName, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metric), error;
        }
        return new cloudwatch.Metric({ namespace: "AWS/ApiGateway", metricName, dimensionsMap: { ApiName: this.restApiName }, ...props }).attachTo(this);
      }
      metricClientError(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricClientError), error;
        }
        return this.cannedMetric(apigateway_canned_metrics_generated_1.ApiGatewayMetrics._4XxErrorSum, props);
      }
      metricServerError(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricServerError), error;
        }
        return this.cannedMetric(apigateway_canned_metrics_generated_1.ApiGatewayMetrics._5XxErrorSum, props);
      }
      metricCacheHitCount(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricCacheHitCount), error;
        }
        return this.cannedMetric(apigateway_canned_metrics_generated_1.ApiGatewayMetrics.cacheHitCountSum, props);
      }
      metricCacheMissCount(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricCacheMissCount), error;
        }
        return this.cannedMetric(apigateway_canned_metrics_generated_1.ApiGatewayMetrics.cacheMissCountSum, props);
      }
      metricCount(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricCount), error;
        }
        return this.cannedMetric(apigateway_canned_metrics_generated_1.ApiGatewayMetrics.countSum, { statistic: "SampleCount", ...props });
      }
      metricIntegrationLatency(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricIntegrationLatency), error;
        }
        return this.cannedMetric(apigateway_canned_metrics_generated_1.ApiGatewayMetrics.integrationLatencyAverage, props);
      }
      metricLatency(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricLatency), error;
        }
        return this.cannedMetric(apigateway_canned_metrics_generated_1.ApiGatewayMetrics.latencyAverage, props);
      }
      _attachMethod(method) {
      }
      _attachDeployment(deployment) {
      }
      _attachStage(stage) {
        this.cloudWatchAccount && stage.node.addDependency(this.cloudWatchAccount);
      }
      _configureCloudWatchRole(apiResource) {
        const role = new iam.Role(this, "CloudWatchRole", { assumedBy: new iam.ServicePrincipal("apigateway.amazonaws.com"), managedPolicies: [iam.ManagedPolicy.fromAwsManagedPolicyName("service-role/AmazonAPIGatewayPushToCloudWatchLogs")] });
        role.applyRemovalPolicy(core_1.RemovalPolicy.RETAIN), this.cloudWatchAccount = new apigateway_generated_1.CfnAccount(this, "Account", { cloudWatchRoleArn: role.roleArn }), this.cloudWatchAccount.applyRemovalPolicy(core_1.RemovalPolicy.RETAIN), this.cloudWatchAccount.node.addDependency(apiResource);
      }
      configureCloudWatchRole(apiResource) {
        this._configureCloudWatchRole(apiResource);
      }
      configureDeployment(props) {
        this._configureDeployment(props);
      }
      _configureDeployment(props) {
        if (props.deploy ?? true) {
          this._latestDeployment = new deployment_1.Deployment(this, "Deployment", { description: props.description ? props.description : "Automatically created by the RestApi construct", api: this, retainDeployments: props.retainDeployments });
          const stageName = props.deployOptions && props.deployOptions.stageName || "prod";
          this.deploymentStage = new stage_1.Stage(this, `DeploymentStage.${stageName}`, { deployment: this._latestDeployment, ...props.deployOptions }), new core_1.CfnOutput(this, "Endpoint", { exportName: props.endpointExportName, value: this.urlForPath() });
        } else if (props.deployOptions)
          throw new Error("Cannot set 'deployOptions' if 'deploy' is disabled");
      }
      _configureEndpoints(props) {
        if (props.endpointTypes && props.endpointConfiguration)
          throw new Error("Only one of the RestApi props, endpointTypes or endpointConfiguration, is allowed");
        if (props.endpointConfiguration)
          return { types: props.endpointConfiguration.types, vpcEndpointIds: props.endpointConfiguration?.vpcEndpoints?.map((vpcEndpoint) => vpcEndpoint.vpcEndpointId) };
        if (props.endpointTypes)
          return { types: props.endpointTypes };
      }
      cannedMetric(fn, props) {
        return new cloudwatch.Metric({ ...fn({ ApiName: this.restApiName }), ...props }).attachTo(this);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, RestApiBase[_a] = { fqn: "aws-cdk-lib.aws_apigateway.RestApiBase", version: "2.80.0" }, exports2.RestApiBase = RestApiBase;
    var SpecRestApi = class _SpecRestApi extends RestApiBase {
      constructor(scope, id, props) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_SpecRestApiProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SpecRestApi), error;
        }
        const apiDefConfig = props.apiDefinition.bind(this), resource = new apigateway_generated_1.CfnRestApi(this, "Resource", { name: this.restApiName, policy: props.policy, failOnWarnings: props.failOnWarnings, minimumCompressionSize: props.minCompressionSize?.toBytes(), body: apiDefConfig.inlineDefinition ?? void 0, bodyS3Location: apiDefConfig.inlineDefinition ? void 0 : apiDefConfig.s3Location, endpointConfiguration: this._configureEndpoints(props), parameters: props.parameters, disableExecuteApiEndpoint: props.disableExecuteApiEndpoint });
        props.apiDefinition.bindAfterCreate(this, this), this.node.defaultChild = resource, this.restApiId = resource.ref, this.restApiRootResourceId = resource.attrRootResourceId, this.root = new RootResource(this, {}, this.restApiRootResourceId);
        const cloudWatchRoleDefault = !core_1.FeatureFlags.of(this).isEnabled(cx_api_1.APIGATEWAY_DISABLE_CLOUDWATCH_ROLE);
        (props.cloudWatchRole ?? cloudWatchRoleDefault) && this._configureCloudWatchRole(resource), this._configureDeployment(props), props.domainName && this.addDomainName("CustomDomain", props.domainName);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, SpecRestApi[_b] = { fqn: "aws-cdk-lib.aws_apigateway.SpecRestApi", version: "2.80.0" }, exports2.SpecRestApi = SpecRestApi;
    var RestApi = class _RestApi extends RestApiBase {
      static fromRestApiId(scope, id, restApiId) {
        class Import extends RestApiBase {
          constructor() {
            super(...arguments), this.restApiId = restApiId;
          }
          get root() {
            throw new Error("root is not configured when imported using `fromRestApiId()`. Use `fromRestApiAttributes()` API instead.");
          }
          get restApiRootResourceId() {
            throw new Error("restApiRootResourceId is not configured when imported using `fromRestApiId()`. Use `fromRestApiAttributes()` API instead.");
          }
        }
        return new Import(scope, id);
      }
      static fromRestApiAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_RestApiAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromRestApiAttributes), error;
        }
        class Import extends RestApiBase {
          constructor() {
            super(...arguments), this.restApiId = attrs.restApiId, this.restApiName = attrs.restApiName ?? id, this.restApiRootResourceId = attrs.rootResourceId, this.root = new RootResource(this, {}, this.restApiRootResourceId);
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props = {}) {
        super(scope, id, props), this.methods = new Array(), this.deployments = new Array();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_RestApiProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _RestApi), error;
        }
        if (props.minCompressionSize !== void 0 && props.minimumCompressionSize !== void 0)
          throw new Error("both properties minCompressionSize and minimumCompressionSize cannot be set at once.");
        const resource = new apigateway_generated_1.CfnRestApi(this, "Resource", { name: this.physicalName, description: props.description, policy: props.policy, failOnWarnings: props.failOnWarnings, minimumCompressionSize: props.minCompressionSize?.toBytes() ?? props.minimumCompressionSize, binaryMediaTypes: props.binaryMediaTypes, endpointConfiguration: this._configureEndpoints(props), apiKeySourceType: props.apiKeySourceType, cloneFrom: props.cloneFrom?.restApiId, parameters: props.parameters, disableExecuteApiEndpoint: props.disableExecuteApiEndpoint });
        this.node.defaultChild = resource, this.restApiId = resource.ref;
        const cloudWatchRoleDefault = !core_1.FeatureFlags.of(this).isEnabled(cx_api_1.APIGATEWAY_DISABLE_CLOUDWATCH_ROLE);
        (props.cloudWatchRole ?? cloudWatchRoleDefault) && this._configureCloudWatchRole(resource), this._configureDeployment(props), props.domainName && this.addDomainName("CustomDomain", props.domainName), this.root = new RootResource(this, props, resource.attrRootResourceId), this.restApiRootResourceId = resource.attrRootResourceId, this.node.addValidation({ validate: () => this.validateRestApi() });
      }
      get url() {
        return this.urlForPath();
      }
      addModel(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_ModelOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addModel), error;
        }
        return new model_1.Model(this, id, { ...props, restApi: this });
      }
      addRequestValidator(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_RequestValidatorOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addRequestValidator), error;
        }
        return new requestvalidator_1.RequestValidator(this, id, { ...props, restApi: this });
      }
      _attachMethod(method) {
        this.methods.push(method);
        for (const dep of this.deployments)
          dep._addMethodDependency(method);
      }
      _attachDeployment(deployment) {
        this.deployments.push(deployment);
        for (const method of this.methods)
          deployment._addMethodDependency(method);
      }
      validateRestApi() {
        return this.methods.length === 0 ? ["The REST API doesn't contain any methods"] : [];
      }
    };
    _c = JSII_RTTI_SYMBOL_1, RestApi[_c] = { fqn: "aws-cdk-lib.aws_apigateway.RestApi", version: "2.80.0" }, exports2.RestApi = RestApi;
    var ApiKeySourceType;
    (function(ApiKeySourceType2) {
      ApiKeySourceType2.HEADER = "HEADER", ApiKeySourceType2.AUTHORIZER = "AUTHORIZER";
    })(ApiKeySourceType = exports2.ApiKeySourceType || (exports2.ApiKeySourceType = {}));
    var EndpointType;
    (function(EndpointType2) {
      EndpointType2.EDGE = "EDGE", EndpointType2.REGIONAL = "REGIONAL", EndpointType2.PRIVATE = "PRIVATE";
    })(EndpointType = exports2.EndpointType || (exports2.EndpointType = {}));
    var RootResource = class extends resource_1.ResourceBase {
      constructor(api, props, resourceId) {
        super(api, "Default"), this.parentResource = void 0, this.defaultIntegration = props.defaultIntegration, this.defaultMethodOptions = props.defaultMethodOptions, this.defaultCorsPreflightOptions = props.defaultCorsPreflightOptions, this.api = api, this.resourceId = resourceId, this.path = "/", api instanceof RestApi && (this._restApi = api), this.defaultCorsPreflightOptions && this.addCorsPreflight(this.defaultCorsPreflightOptions);
      }
      get restApi() {
        if (!this._restApi)
          throw new Error("RestApi is not available on Resource not connected to an instance of RestApi. Use `api` instead");
        return this._restApi;
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/lambda-api.js
var require_lambda_api = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/lambda-api.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LambdaRestApi = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var integrations_1 = require_integrations();
    var restapi_1 = require_restapi();
    var LambdaRestApi = class _LambdaRestApi extends restapi_1.RestApi {
      constructor(scope, id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_LambdaRestApiProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _LambdaRestApi), error;
        }
        if (props.options?.defaultIntegration || props.defaultIntegration)
          throw new Error('Cannot specify "defaultIntegration" since Lambda integration is automatically defined');
        super(scope, id, { defaultIntegration: new integrations_1.LambdaIntegration(props.handler, props.integrationOptions), ...props.options, ...props }), props.proxy !== false && (this.root.addProxy(), this.root.addResource = addResourceThrows, this.root.addMethod = addMethodThrows, this.root.addProxy = addProxyThrows), this.node.addValidation({ validate() {
          for (const value of Object.values(props.deployOptions?.variables ?? {})) {
            const regexp = /[A-Za-z0-9-._~:/?#&=,]+/;
            if (value.match(regexp) === null)
              return ["Stage variable value " + value + " does not match the regex."];
          }
          return [];
        } });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LambdaRestApi[_a] = { fqn: "aws-cdk-lib.aws_apigateway.LambdaRestApi", version: "2.80.0" }, exports2.LambdaRestApi = LambdaRestApi;
    function addResourceThrows() {
      throw new Error("Cannot call 'addResource' on a proxying LambdaRestApi; set 'proxy' to false");
    }
    function addMethodThrows() {
      throw new Error("Cannot call 'addMethod' on a proxying LambdaRestApi; set 'proxy' to false");
    }
    function addProxyThrows() {
      throw new Error("Cannot call 'addProxy' on a proxying LambdaRestApi; set 'proxy' to false");
    }
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/methodresponse.js
var require_methodresponse = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/methodresponse.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/authorizers/lambda.js
var require_lambda4 = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/authorizers/lambda.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.RequestAuthorizer = exports2.TokenAuthorizer = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var lambda2 = require_aws_lambda();
    var core_1 = require_core2();
    var cx_api_1 = require_cx_api();
    var apigateway_generated_1 = require_apigateway_generated();
    var authorizer_1 = require_authorizer();
    var LambdaAuthorizer = class extends authorizer_1.Authorizer {
      constructor(scope, id, props) {
        if (super(scope, id), this.handler = props.handler, this.role = props.assumeRole, props.resultsCacheTtl && props.resultsCacheTtl?.toSeconds() > 3600)
          throw new Error("Lambda authorizer property 'resultsCacheTtl' must not be greater than 3600 seconds (1 hour)");
      }
      _attachToApi(restApi) {
        if (this.restApiId && this.restApiId !== restApi.restApiId)
          throw new Error("Cannot attach authorizer to two different rest APIs");
        this.restApiId = restApi.restApiId;
        const deployment = restApi.latestDeployment, addToLogicalId = core_1.FeatureFlags.of(this).isEnabled(cx_api_1.APIGATEWAY_AUTHORIZER_CHANGE_DEPLOYMENT_LOGICAL_ID);
        if (deployment && addToLogicalId) {
          let functionName;
          this.handler instanceof lambda2.Function ? functionName = this.handler.node.defaultChild.functionName : functionName = this.handler.functionName, deployment.node.addDependency(this), deployment.addToLogicalId({ authorizer: this.authorizerProps, authorizerToken: functionName });
        }
      }
      setupPermissions() {
        this.role ? iam.Role.isRole(this.role) && this.addLambdaInvokePermission(this.role) : this.addDefaultPermisionRole();
      }
      addDefaultPermisionRole() {
        this.handler.addPermission(`${core_1.Names.uniqueId(this)}:Permissions`, { principal: new iam.ServicePrincipal("apigateway.amazonaws.com"), sourceArn: this.authorizerArn });
      }
      addLambdaInvokePermission(role) {
        role.attachInlinePolicy(new iam.Policy(this, "authorizerInvokePolicy", { statements: [new iam.PolicyStatement({ resources: this.handler.resourceArnsForGrantInvoke, actions: ["lambda:InvokeFunction"] })] }));
      }
      lazyRestApiId() {
        return core_1.Lazy.string({ produce: () => {
          if (!this.restApiId)
            throw new Error(`Authorizer (${this.node.path}) must be attached to a RestApi`);
          return this.restApiId;
        } });
      }
    };
    var TokenAuthorizer = class _TokenAuthorizer extends LambdaAuthorizer {
      constructor(scope, id, props) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_TokenAuthorizerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _TokenAuthorizer), error;
        }
        const restApiId = this.lazyRestApiId(), authorizerProps = { name: props.authorizerName ?? core_1.Names.uniqueId(this), restApiId, type: "TOKEN", authorizerUri: lambdaAuthorizerArn(props.handler), authorizerCredentials: props.assumeRole?.roleArn, authorizerResultTtlInSeconds: props.resultsCacheTtl?.toSeconds(), identitySource: props.identitySource || "method.request.header.Authorization", identityValidationExpression: props.validationRegex };
        this.authorizerProps = authorizerProps;
        const resource = new apigateway_generated_1.CfnAuthorizer(this, "Resource", authorizerProps);
        this.authorizerId = resource.ref, this.authorizerArn = core_1.Stack.of(this).formatArn({ service: "execute-api", resource: restApiId, resourceName: `authorizers/${this.authorizerId}` }), this.setupPermissions();
      }
    };
    _a = JSII_RTTI_SYMBOL_1, TokenAuthorizer[_a] = { fqn: "aws-cdk-lib.aws_apigateway.TokenAuthorizer", version: "2.80.0" }, exports2.TokenAuthorizer = TokenAuthorizer;
    var RequestAuthorizer = class _RequestAuthorizer extends LambdaAuthorizer {
      constructor(scope, id, props) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_RequestAuthorizerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _RequestAuthorizer), error;
        }
        if ((props.resultsCacheTtl === void 0 || props.resultsCacheTtl.toSeconds() !== 0) && props.identitySources.length === 0)
          throw new Error("At least one Identity Source is required for a REQUEST-based Lambda authorizer if caching is enabled.");
        const restApiId = this.lazyRestApiId(), authorizerProps = { name: props.authorizerName ?? core_1.Names.uniqueId(this), restApiId, type: "REQUEST", authorizerUri: lambdaAuthorizerArn(props.handler), authorizerCredentials: props.assumeRole?.roleArn, authorizerResultTtlInSeconds: props.resultsCacheTtl?.toSeconds(), identitySource: props.identitySources.map((is) => is.toString()).join(",") };
        this.authorizerProps = authorizerProps;
        const resource = new apigateway_generated_1.CfnAuthorizer(this, "Resource", authorizerProps);
        this.authorizerId = resource.ref, this.authorizerArn = core_1.Stack.of(this).formatArn({ service: "execute-api", resource: restApiId, resourceName: `authorizers/${this.authorizerId}` }), this.setupPermissions();
      }
    };
    _b = JSII_RTTI_SYMBOL_1, RequestAuthorizer[_b] = { fqn: "aws-cdk-lib.aws_apigateway.RequestAuthorizer", version: "2.80.0" }, exports2.RequestAuthorizer = RequestAuthorizer;
    function lambdaAuthorizerArn(handler2) {
      const { region, partition } = core_1.Arn.split(handler2.functionArn, core_1.ArnFormat.COLON_RESOURCE_NAME);
      return `arn:${partition}:apigateway:${region}:lambda:path/2015-03-31/functions/${handler2.functionArn}/invocations`;
    }
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/authorizers/identity-source.js
var require_identity_source = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/authorizers/identity-source.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.IdentitySource = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var IdentitySource = class _IdentitySource {
      static header(headerName) {
        return _IdentitySource.toString(headerName, "method.request.header");
      }
      static queryString(queryString) {
        return _IdentitySource.toString(queryString, "method.request.querystring");
      }
      static stageVariable(stageVariable) {
        return _IdentitySource.toString(stageVariable, "stageVariables");
      }
      static context(context) {
        return _IdentitySource.toString(context, "context");
      }
      static toString(source, type) {
        if (!source.trim())
          throw new Error("IdentitySources must be a non-empty string.");
        return `${type}.${source}`;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, IdentitySource[_a] = { fqn: "aws-cdk-lib.aws_apigateway.IdentitySource", version: "2.80.0" }, exports2.IdentitySource = IdentitySource;
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/authorizers/cognito.js
var require_cognito = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/authorizers/cognito.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CognitoUserPoolsAuthorizer = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core_1 = require_core2();
    var cx_api_1 = require_cx_api();
    var apigateway_generated_1 = require_apigateway_generated();
    var authorizer_1 = require_authorizer();
    var method_1 = require_method();
    var CognitoUserPoolsAuthorizer = class _CognitoUserPoolsAuthorizer extends authorizer_1.Authorizer {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_CognitoUserPoolsAuthorizerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CognitoUserPoolsAuthorizer), error;
        }
        const restApiId = this.lazyRestApiId(), authorizerProps = { name: props.authorizerName ?? core_1.Names.uniqueId(this), restApiId, type: "COGNITO_USER_POOLS", providerArns: props.cognitoUserPools.map((userPool) => userPool.userPoolArn), authorizerResultTtlInSeconds: props.resultsCacheTtl?.toSeconds(), identitySource: props.identitySource || "method.request.header.Authorization" };
        this.authorizerProps = authorizerProps;
        const resource = new apigateway_generated_1.CfnAuthorizer(this, "Resource", authorizerProps);
        this.authorizerId = resource.ref, this.authorizerArn = core_1.Stack.of(this).formatArn({ service: "execute-api", resource: restApiId, resourceName: `authorizers/${this.authorizerId}` }), this.authorizationType = method_1.AuthorizationType.COGNITO;
      }
      _attachToApi(restApi) {
        if (this.restApiId && this.restApiId !== restApi.restApiId)
          throw new Error("Cannot attach authorizer to two different rest APIs");
        this.restApiId = restApi.restApiId;
        const addToLogicalId = core_1.FeatureFlags.of(this).isEnabled(cx_api_1.APIGATEWAY_AUTHORIZER_CHANGE_DEPLOYMENT_LOGICAL_ID), deployment = restApi.latestDeployment;
        deployment && addToLogicalId && (deployment.node.addDependency(this), deployment.addToLogicalId({ authorizer: this.authorizerProps }));
      }
      lazyRestApiId() {
        return core_1.Lazy.string({ produce: () => {
          if (!this.restApiId)
            throw new Error(`Authorizer (${this.node.path}) must be attached to a RestApi`);
          return this.restApiId;
        } });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CognitoUserPoolsAuthorizer[_a] = { fqn: "aws-cdk-lib.aws_apigateway.CognitoUserPoolsAuthorizer", version: "2.80.0" }, exports2.CognitoUserPoolsAuthorizer = CognitoUserPoolsAuthorizer;
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/authorizers/index.js
var require_authorizers = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/authorizers/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lambda4(), exports2), __exportStar(require_identity_source(), exports2), __exportStar(require_cognito(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/api-definition.js
var require_api_definition = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/api-definition.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AssetApiDefinition = exports2.InlineApiDefinition = exports2.S3ApiDefinition = exports2.ApiDefinition = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var s3_assets = require_aws_s3_assets();
    var cxapi = require_cx_api();
    var ApiDefinition = class {
      static fromBucket(bucket, key, objectVersion) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_IBucket(bucket);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromBucket), error;
        }
        return new S3ApiDefinition(bucket, key, objectVersion);
      }
      static fromInline(definition) {
        return new InlineApiDefinition(definition);
      }
      static fromAsset(file, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_assets_AssetOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromAsset), error;
        }
        return new AssetApiDefinition(file, options);
      }
      bindAfterCreate(_scope, _restApi) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_IRestApi(_restApi);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bindAfterCreate), error;
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ApiDefinition[_a] = { fqn: "aws-cdk-lib.aws_apigateway.ApiDefinition", version: "2.80.0" }, exports2.ApiDefinition = ApiDefinition;
    var S3ApiDefinition = class _S3ApiDefinition extends ApiDefinition {
      constructor(bucket, key, objectVersion) {
        super(), this.key = key, this.objectVersion = objectVersion;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_IBucket(bucket);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _S3ApiDefinition), error;
        }
        if (!bucket.bucketName)
          throw new Error("bucketName is undefined for the provided bucket");
        this.bucketName = bucket.bucketName;
      }
      bind(_scope) {
        return { s3Location: { bucket: this.bucketName, key: this.key, version: this.objectVersion } };
      }
    };
    _b = JSII_RTTI_SYMBOL_1, S3ApiDefinition[_b] = { fqn: "aws-cdk-lib.aws_apigateway.S3ApiDefinition", version: "2.80.0" }, exports2.S3ApiDefinition = S3ApiDefinition;
    var InlineApiDefinition = class extends ApiDefinition {
      constructor(definition) {
        if (super(), this.definition = definition, typeof definition != "object")
          throw new Error("definition should be of type object");
        if (Object.keys(definition).length === 0)
          throw new Error("JSON definition cannot be empty");
      }
      bind(_scope) {
        return { inlineDefinition: this.definition };
      }
    };
    _c = JSII_RTTI_SYMBOL_1, InlineApiDefinition[_c] = { fqn: "aws-cdk-lib.aws_apigateway.InlineApiDefinition", version: "2.80.0" }, exports2.InlineApiDefinition = InlineApiDefinition;
    var AssetApiDefinition = class _AssetApiDefinition extends ApiDefinition {
      constructor(path, options = {}) {
        super(), this.path = path, this.options = options;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_assets_AssetOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AssetApiDefinition), error;
        }
      }
      bind(scope) {
        if (this.asset === void 0 && (this.asset = new s3_assets.Asset(scope, "APIDefinition", { path: this.path, ...this.options })), this.asset.isZipArchive)
          throw new Error(`Asset cannot be a .zip file or a directory (${this.path})`);
        return { s3Location: { bucket: this.asset.s3BucketName, key: this.asset.s3ObjectKey } };
      }
      bindAfterCreate(scope, restApi) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_IRestApi(restApi);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bindAfterCreate), error;
        }
        if (!scope.node.tryGetContext(cxapi.ASSET_RESOURCE_METADATA_ENABLED_CONTEXT))
          return;
        if (!this.asset)
          throw new Error("bindToResource() must be called after bind()");
        const child = constructs_1.Node.of(restApi).defaultChild;
        child.addMetadata(cxapi.ASSET_RESOURCE_METADATA_PATH_KEY, this.asset.assetPath), child.addMetadata(cxapi.ASSET_RESOURCE_METADATA_PROPERTY_KEY, "BodyS3Location");
      }
    };
    _d = JSII_RTTI_SYMBOL_1, AssetApiDefinition[_d] = { fqn: "aws-cdk-lib.aws_apigateway.AssetApiDefinition", version: "2.80.0" }, exports2.AssetApiDefinition = AssetApiDefinition;
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/stepfunctions-api.js
var require_stepfunctions_api = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/stepfunctions-api.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.StepFunctionsRestApi = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var _1 = require_lib40();
    var stepfunctions_1 = require_stepfunctions2();
    var sfn = require_aws_stepfunctions();
    var StepFunctionsRestApi = class _StepFunctionsRestApi extends _1.RestApi {
      constructor(scope, id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_StepFunctionsRestApiProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _StepFunctionsRestApi), error;
        }
        if (props.defaultIntegration)
          throw new Error('Cannot specify "defaultIntegration" since Step Functions integration is automatically defined');
        if (props.stateMachine.node.defaultChild.stateMachineType !== sfn.StateMachineType.EXPRESS)
          throw new Error('State Machine must be of type "EXPRESS". Please use StateMachineType.EXPRESS as the stateMachineType');
        const stepfunctionsIntegration = stepfunctions_1.StepFunctionsIntegration.startExecution(props.stateMachine, { credentialsRole: props.role, requestContext: props.requestContext, path: props.path ?? true, querystring: props.querystring ?? true, headers: props.headers, authorizer: props.authorizer });
        super(scope, id, props), this.root.addMethod("ANY", stepfunctionsIntegration);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, StepFunctionsRestApi[_a] = { fqn: "aws-cdk-lib.aws_apigateway.StepFunctionsRestApi", version: "2.80.0" }, exports2.StepFunctionsRestApi = StepFunctionsRestApi;
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/apigatewayv2.js
var require_apigatewayv22 = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/apigatewayv2.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    var _l;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnStageV2 = exports2.CfnRouteResponseV2 = exports2.CfnRouteV2 = exports2.CfnModelV2 = exports2.CfnIntegrationResponseV2 = exports2.CfnIntegrationV2 = exports2.CfnDomainNameV2 = exports2.CfnDeploymentV2 = exports2.CfnAuthorizerV2 = exports2.CfnApiMappingV2 = exports2.CfnApiV2 = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    function CfnApiV2PropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return errors.collect(cdk.propertyValidator("apiKeySelectionExpression", cdk.validateString)(properties.apiKeySelectionExpression)), errors.collect(cdk.propertyValidator("basePath", cdk.validateString)(properties.basePath)), errors.collect(cdk.propertyValidator("body", cdk.validateObject)(properties.body)), errors.collect(cdk.propertyValidator("bodyS3Location", CfnApiV2_BodyS3LocationPropertyValidator)(properties.bodyS3Location)), errors.collect(cdk.propertyValidator("corsConfiguration", CfnApiV2_CorsPropertyValidator)(properties.corsConfiguration)), errors.collect(cdk.propertyValidator("credentialsArn", cdk.validateString)(properties.credentialsArn)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("disableSchemaValidation", cdk.validateBoolean)(properties.disableSchemaValidation)), errors.collect(cdk.propertyValidator("failOnWarnings", cdk.validateBoolean)(properties.failOnWarnings)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("protocolType", cdk.validateString)(properties.protocolType)), errors.collect(cdk.propertyValidator("routeKey", cdk.validateString)(properties.routeKey)), errors.collect(cdk.propertyValidator("routeSelectionExpression", cdk.validateString)(properties.routeSelectionExpression)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.collect(cdk.propertyValidator("target", cdk.validateString)(properties.target)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "CfnApiV2Props"');
    }
    function cfnApiV2PropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApiV2PropsValidator(properties).assertSuccess(), { ApiKeySelectionExpression: cdk.stringToCloudFormation(properties.apiKeySelectionExpression), BasePath: cdk.stringToCloudFormation(properties.basePath), Body: cdk.objectToCloudFormation(properties.body), BodyS3Location: cfnApiV2BodyS3LocationPropertyToCloudFormation(properties.bodyS3Location), CorsConfiguration: cfnApiV2CorsPropertyToCloudFormation(properties.corsConfiguration), CredentialsArn: cdk.stringToCloudFormation(properties.credentialsArn), Description: cdk.stringToCloudFormation(properties.description), DisableSchemaValidation: cdk.booleanToCloudFormation(properties.disableSchemaValidation), FailOnWarnings: cdk.booleanToCloudFormation(properties.failOnWarnings), Name: cdk.stringToCloudFormation(properties.name), ProtocolType: cdk.stringToCloudFormation(properties.protocolType), RouteKey: cdk.stringToCloudFormation(properties.routeKey), RouteSelectionExpression: cdk.stringToCloudFormation(properties.routeSelectionExpression), Tags: cdk.objectToCloudFormation(properties.tags), Target: cdk.stringToCloudFormation(properties.target), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    var CfnApiV2 = class _CfnApiV2 extends cdk.CfnResource {
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnApiV2.CFN_RESOURCE_TYPE_NAME, properties: props }), this.apiKeySelectionExpression = props.apiKeySelectionExpression, this.basePath = props.basePath, this.body = props.body, this.bodyS3Location = props.bodyS3Location, this.corsConfiguration = props.corsConfiguration, this.credentialsArn = props.credentialsArn, this.description = props.description, this.disableSchemaValidation = props.disableSchemaValidation, this.failOnWarnings = props.failOnWarnings, this.name = props.name, this.protocolType = props.protocolType, this.routeKey = props.routeKey, this.routeSelectionExpression = props.routeSelectionExpression, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::ApiGatewayV2::Api", props.tags, { tagPropertyName: "tags" }), this.target = props.target, this.version = props.version;
      }
      inspect(inspector) {
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApiV2.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiKeySelectionExpression: this.apiKeySelectionExpression, basePath: this.basePath, body: this.body, bodyS3Location: this.bodyS3Location, corsConfiguration: this.corsConfiguration, credentialsArn: this.credentialsArn, description: this.description, disableSchemaValidation: this.disableSchemaValidation, failOnWarnings: this.failOnWarnings, name: this.name, protocolType: this.protocolType, routeKey: this.routeKey, routeSelectionExpression: this.routeSelectionExpression, tags: this.tags.renderTags(), target: this.target, version: this.version };
      }
      renderProperties(props) {
        return cfnApiV2PropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnApiV2[_a] = { fqn: "aws-cdk-lib.aws_apigateway.CfnApiV2", version: "2.80.0" }, CfnApiV2.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGatewayV2::Api", exports2.CfnApiV2 = CfnApiV2;
    function CfnApiV2_BodyS3LocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("etag", cdk.validateString)(properties.etag)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "BodyS3LocationProperty"');
    }
    function cfnApiV2BodyS3LocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApiV2_BodyS3LocationPropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), Etag: cdk.stringToCloudFormation(properties.etag), Key: cdk.stringToCloudFormation(properties.key), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnApiV2_CorsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return errors.collect(cdk.propertyValidator("allowCredentials", cdk.validateBoolean)(properties.allowCredentials)), errors.collect(cdk.propertyValidator("allowHeaders", cdk.listValidator(cdk.validateString))(properties.allowHeaders)), errors.collect(cdk.propertyValidator("allowMethods", cdk.listValidator(cdk.validateString))(properties.allowMethods)), errors.collect(cdk.propertyValidator("allowOrigins", cdk.listValidator(cdk.validateString))(properties.allowOrigins)), errors.collect(cdk.propertyValidator("exposeHeaders", cdk.listValidator(cdk.validateString))(properties.exposeHeaders)), errors.collect(cdk.propertyValidator("maxAge", cdk.validateNumber)(properties.maxAge)), errors.wrap('supplied properties not correct for "CorsProperty"');
    }
    function cfnApiV2CorsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApiV2_CorsPropertyValidator(properties).assertSuccess(), { AllowCredentials: cdk.booleanToCloudFormation(properties.allowCredentials), AllowHeaders: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowHeaders), AllowMethods: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowMethods), AllowOrigins: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowOrigins), ExposeHeaders: cdk.listMapper(cdk.stringToCloudFormation)(properties.exposeHeaders), MaxAge: cdk.numberToCloudFormation(properties.maxAge) }) : properties;
    }
    function CfnApiMappingV2PropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return errors.collect(cdk.propertyValidator("apiId", cdk.requiredValidator)(properties.apiId)), errors.collect(cdk.propertyValidator("apiId", cdk.validateString)(properties.apiId)), errors.collect(cdk.propertyValidator("apiMappingKey", cdk.validateString)(properties.apiMappingKey)), errors.collect(cdk.propertyValidator("domainName", cdk.requiredValidator)(properties.domainName)), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.collect(cdk.propertyValidator("stage", cdk.requiredValidator)(properties.stage)), errors.collect(cdk.propertyValidator("stage", cdk.validateString)(properties.stage)), errors.wrap('supplied properties not correct for "CfnApiMappingV2Props"');
    }
    function cfnApiMappingV2PropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApiMappingV2PropsValidator(properties).assertSuccess(), { ApiId: cdk.stringToCloudFormation(properties.apiId), DomainName: cdk.stringToCloudFormation(properties.domainName), Stage: cdk.stringToCloudFormation(properties.stage), ApiMappingKey: cdk.stringToCloudFormation(properties.apiMappingKey) }) : properties;
    }
    var CfnApiMappingV2 = class _CfnApiMappingV2 extends cdk.CfnResource {
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApiMappingV2.CFN_RESOURCE_TYPE_NAME, properties: props }), cdk.requireProperty(props, "apiId", this), cdk.requireProperty(props, "domainName", this), cdk.requireProperty(props, "stage", this), this.apiId = props.apiId, this.domainName = props.domainName, this.stage = props.stage, this.apiMappingKey = props.apiMappingKey;
      }
      inspect(inspector) {
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApiMappingV2.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiId: this.apiId, domainName: this.domainName, stage: this.stage, apiMappingKey: this.apiMappingKey };
      }
      renderProperties(props) {
        return cfnApiMappingV2PropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnApiMappingV2[_b] = { fqn: "aws-cdk-lib.aws_apigateway.CfnApiMappingV2", version: "2.80.0" }, CfnApiMappingV2.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGatewayV2::ApiMapping", exports2.CfnApiMappingV2 = CfnApiMappingV2;
    function CfnAuthorizerV2PropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return errors.collect(cdk.propertyValidator("apiId", cdk.requiredValidator)(properties.apiId)), errors.collect(cdk.propertyValidator("apiId", cdk.validateString)(properties.apiId)), errors.collect(cdk.propertyValidator("authorizerCredentialsArn", cdk.validateString)(properties.authorizerCredentialsArn)), errors.collect(cdk.propertyValidator("authorizerResultTtlInSeconds", cdk.validateNumber)(properties.authorizerResultTtlInSeconds)), errors.collect(cdk.propertyValidator("authorizerType", cdk.requiredValidator)(properties.authorizerType)), errors.collect(cdk.propertyValidator("authorizerType", cdk.validateString)(properties.authorizerType)), errors.collect(cdk.propertyValidator("authorizerUri", cdk.validateString)(properties.authorizerUri)), errors.collect(cdk.propertyValidator("identitySource", cdk.requiredValidator)(properties.identitySource)), errors.collect(cdk.propertyValidator("identitySource", cdk.listValidator(cdk.validateString))(properties.identitySource)), errors.collect(cdk.propertyValidator("identityValidationExpression", cdk.validateString)(properties.identityValidationExpression)), errors.collect(cdk.propertyValidator("jwtConfiguration", CfnAuthorizerV2_JWTConfigurationPropertyValidator)(properties.jwtConfiguration)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "CfnAuthorizerV2Props"');
    }
    function cfnAuthorizerV2PropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAuthorizerV2PropsValidator(properties).assertSuccess(), { ApiId: cdk.stringToCloudFormation(properties.apiId), AuthorizerType: cdk.stringToCloudFormation(properties.authorizerType), IdentitySource: cdk.listMapper(cdk.stringToCloudFormation)(properties.identitySource), Name: cdk.stringToCloudFormation(properties.name), AuthorizerCredentialsArn: cdk.stringToCloudFormation(properties.authorizerCredentialsArn), AuthorizerResultTtlInSeconds: cdk.numberToCloudFormation(properties.authorizerResultTtlInSeconds), AuthorizerUri: cdk.stringToCloudFormation(properties.authorizerUri), IdentityValidationExpression: cdk.stringToCloudFormation(properties.identityValidationExpression), JwtConfiguration: cfnAuthorizerV2JWTConfigurationPropertyToCloudFormation(properties.jwtConfiguration) }) : properties;
    }
    var CfnAuthorizerV2 = class _CfnAuthorizerV2 extends cdk.CfnResource {
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAuthorizerV2.CFN_RESOURCE_TYPE_NAME, properties: props }), cdk.requireProperty(props, "apiId", this), cdk.requireProperty(props, "authorizerType", this), cdk.requireProperty(props, "identitySource", this), cdk.requireProperty(props, "name", this), this.apiId = props.apiId, this.authorizerType = props.authorizerType, this.identitySource = props.identitySource, this.name = props.name, this.authorizerCredentialsArn = props.authorizerCredentialsArn, this.authorizerResultTtlInSeconds = props.authorizerResultTtlInSeconds, this.authorizerUri = props.authorizerUri, this.identityValidationExpression = props.identityValidationExpression, this.jwtConfiguration = props.jwtConfiguration;
      }
      inspect(inspector) {
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAuthorizerV2.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiId: this.apiId, authorizerType: this.authorizerType, identitySource: this.identitySource, name: this.name, authorizerCredentialsArn: this.authorizerCredentialsArn, authorizerResultTtlInSeconds: this.authorizerResultTtlInSeconds, authorizerUri: this.authorizerUri, identityValidationExpression: this.identityValidationExpression, jwtConfiguration: this.jwtConfiguration };
      }
      renderProperties(props) {
        return cfnAuthorizerV2PropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnAuthorizerV2[_c] = { fqn: "aws-cdk-lib.aws_apigateway.CfnAuthorizerV2", version: "2.80.0" }, CfnAuthorizerV2.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGatewayV2::Authorizer", exports2.CfnAuthorizerV2 = CfnAuthorizerV2;
    function CfnAuthorizerV2_JWTConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return errors.collect(cdk.propertyValidator("audience", cdk.listValidator(cdk.validateString))(properties.audience)), errors.collect(cdk.propertyValidator("issuer", cdk.validateString)(properties.issuer)), errors.wrap('supplied properties not correct for "JWTConfigurationProperty"');
    }
    function cfnAuthorizerV2JWTConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAuthorizerV2_JWTConfigurationPropertyValidator(properties).assertSuccess(), { Audience: cdk.listMapper(cdk.stringToCloudFormation)(properties.audience), Issuer: cdk.stringToCloudFormation(properties.issuer) }) : properties;
    }
    function CfnDeploymentV2PropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return errors.collect(cdk.propertyValidator("apiId", cdk.requiredValidator)(properties.apiId)), errors.collect(cdk.propertyValidator("apiId", cdk.validateString)(properties.apiId)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("stageName", cdk.validateString)(properties.stageName)), errors.wrap('supplied properties not correct for "CfnDeploymentV2Props"');
    }
    function cfnDeploymentV2PropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentV2PropsValidator(properties).assertSuccess(), { ApiId: cdk.stringToCloudFormation(properties.apiId), Description: cdk.stringToCloudFormation(properties.description), StageName: cdk.stringToCloudFormation(properties.stageName) }) : properties;
    }
    var CfnDeploymentV2 = class _CfnDeploymentV2 extends cdk.CfnResource {
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDeploymentV2.CFN_RESOURCE_TYPE_NAME, properties: props }), cdk.requireProperty(props, "apiId", this), this.apiId = props.apiId, this.description = props.description, this.stageName = props.stageName;
      }
      inspect(inspector) {
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDeploymentV2.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiId: this.apiId, description: this.description, stageName: this.stageName };
      }
      renderProperties(props) {
        return cfnDeploymentV2PropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnDeploymentV2[_d] = { fqn: "aws-cdk-lib.aws_apigateway.CfnDeploymentV2", version: "2.80.0" }, CfnDeploymentV2.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGatewayV2::Deployment", exports2.CfnDeploymentV2 = CfnDeploymentV2;
    function CfnDomainNameV2PropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return errors.collect(cdk.propertyValidator("domainName", cdk.requiredValidator)(properties.domainName)), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.collect(cdk.propertyValidator("domainNameConfigurations", cdk.listValidator(CfnDomainNameV2_DomainNameConfigurationPropertyValidator))(properties.domainNameConfigurations)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.wrap('supplied properties not correct for "CfnDomainNameV2Props"');
    }
    function cfnDomainNameV2PropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomainNameV2PropsValidator(properties).assertSuccess(), { DomainName: cdk.stringToCloudFormation(properties.domainName), DomainNameConfigurations: cdk.listMapper(cfnDomainNameV2DomainNameConfigurationPropertyToCloudFormation)(properties.domainNameConfigurations), Tags: cdk.objectToCloudFormation(properties.tags) }) : properties;
    }
    var CfnDomainNameV2 = class _CfnDomainNameV2 extends cdk.CfnResource {
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDomainNameV2.CFN_RESOURCE_TYPE_NAME, properties: props }), cdk.requireProperty(props, "domainName", this), this.attrRegionalDomainName = cdk.Token.asString(this.getAtt("RegionalDomainName")), this.attrRegionalHostedZoneId = cdk.Token.asString(this.getAtt("RegionalHostedZoneId")), this.domainName = props.domainName, this.domainNameConfigurations = props.domainNameConfigurations, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::ApiGatewayV2::DomainName", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDomainNameV2.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { domainName: this.domainName, domainNameConfigurations: this.domainNameConfigurations, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDomainNameV2PropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnDomainNameV2[_e] = { fqn: "aws-cdk-lib.aws_apigateway.CfnDomainNameV2", version: "2.80.0" }, CfnDomainNameV2.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGatewayV2::DomainName", exports2.CfnDomainNameV2 = CfnDomainNameV2;
    function CfnDomainNameV2_DomainNameConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return errors.collect(cdk.propertyValidator("certificateArn", cdk.validateString)(properties.certificateArn)), errors.collect(cdk.propertyValidator("certificateName", cdk.validateString)(properties.certificateName)), errors.collect(cdk.propertyValidator("endpointType", cdk.validateString)(properties.endpointType)), errors.wrap('supplied properties not correct for "DomainNameConfigurationProperty"');
    }
    function cfnDomainNameV2DomainNameConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomainNameV2_DomainNameConfigurationPropertyValidator(properties).assertSuccess(), { CertificateArn: cdk.stringToCloudFormation(properties.certificateArn), CertificateName: cdk.stringToCloudFormation(properties.certificateName), EndpointType: cdk.stringToCloudFormation(properties.endpointType) }) : properties;
    }
    function CfnIntegrationV2PropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return errors.collect(cdk.propertyValidator("apiId", cdk.requiredValidator)(properties.apiId)), errors.collect(cdk.propertyValidator("apiId", cdk.validateString)(properties.apiId)), errors.collect(cdk.propertyValidator("connectionType", cdk.validateString)(properties.connectionType)), errors.collect(cdk.propertyValidator("contentHandlingStrategy", cdk.validateString)(properties.contentHandlingStrategy)), errors.collect(cdk.propertyValidator("credentialsArn", cdk.validateString)(properties.credentialsArn)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("integrationMethod", cdk.validateString)(properties.integrationMethod)), errors.collect(cdk.propertyValidator("integrationType", cdk.requiredValidator)(properties.integrationType)), errors.collect(cdk.propertyValidator("integrationType", cdk.validateString)(properties.integrationType)), errors.collect(cdk.propertyValidator("integrationUri", cdk.validateString)(properties.integrationUri)), errors.collect(cdk.propertyValidator("passthroughBehavior", cdk.validateString)(properties.passthroughBehavior)), errors.collect(cdk.propertyValidator("payloadFormatVersion", cdk.validateString)(properties.payloadFormatVersion)), errors.collect(cdk.propertyValidator("requestParameters", cdk.validateObject)(properties.requestParameters)), errors.collect(cdk.propertyValidator("requestTemplates", cdk.validateObject)(properties.requestTemplates)), errors.collect(cdk.propertyValidator("templateSelectionExpression", cdk.validateString)(properties.templateSelectionExpression)), errors.collect(cdk.propertyValidator("timeoutInMillis", cdk.validateNumber)(properties.timeoutInMillis)), errors.wrap('supplied properties not correct for "CfnIntegrationV2Props"');
    }
    function cfnIntegrationV2PropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIntegrationV2PropsValidator(properties).assertSuccess(), { ApiId: cdk.stringToCloudFormation(properties.apiId), IntegrationType: cdk.stringToCloudFormation(properties.integrationType), ConnectionType: cdk.stringToCloudFormation(properties.connectionType), ContentHandlingStrategy: cdk.stringToCloudFormation(properties.contentHandlingStrategy), CredentialsArn: cdk.stringToCloudFormation(properties.credentialsArn), Description: cdk.stringToCloudFormation(properties.description), IntegrationMethod: cdk.stringToCloudFormation(properties.integrationMethod), IntegrationUri: cdk.stringToCloudFormation(properties.integrationUri), PassthroughBehavior: cdk.stringToCloudFormation(properties.passthroughBehavior), PayloadFormatVersion: cdk.stringToCloudFormation(properties.payloadFormatVersion), RequestParameters: cdk.objectToCloudFormation(properties.requestParameters), RequestTemplates: cdk.objectToCloudFormation(properties.requestTemplates), TemplateSelectionExpression: cdk.stringToCloudFormation(properties.templateSelectionExpression), TimeoutInMillis: cdk.numberToCloudFormation(properties.timeoutInMillis) }) : properties;
    }
    var CfnIntegrationV2 = class _CfnIntegrationV2 extends cdk.CfnResource {
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnIntegrationV2.CFN_RESOURCE_TYPE_NAME, properties: props }), cdk.requireProperty(props, "apiId", this), cdk.requireProperty(props, "integrationType", this), this.apiId = props.apiId, this.integrationType = props.integrationType, this.connectionType = props.connectionType, this.contentHandlingStrategy = props.contentHandlingStrategy, this.credentialsArn = props.credentialsArn, this.description = props.description, this.integrationMethod = props.integrationMethod, this.integrationUri = props.integrationUri, this.passthroughBehavior = props.passthroughBehavior, this.payloadFormatVersion = props.payloadFormatVersion, this.requestParameters = props.requestParameters, this.requestTemplates = props.requestTemplates, this.templateSelectionExpression = props.templateSelectionExpression, this.timeoutInMillis = props.timeoutInMillis;
      }
      inspect(inspector) {
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnIntegrationV2.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiId: this.apiId, integrationType: this.integrationType, connectionType: this.connectionType, contentHandlingStrategy: this.contentHandlingStrategy, credentialsArn: this.credentialsArn, description: this.description, integrationMethod: this.integrationMethod, integrationUri: this.integrationUri, passthroughBehavior: this.passthroughBehavior, payloadFormatVersion: this.payloadFormatVersion, requestParameters: this.requestParameters, requestTemplates: this.requestTemplates, templateSelectionExpression: this.templateSelectionExpression, timeoutInMillis: this.timeoutInMillis };
      }
      renderProperties(props) {
        return cfnIntegrationV2PropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnIntegrationV2[_f] = { fqn: "aws-cdk-lib.aws_apigateway.CfnIntegrationV2", version: "2.80.0" }, CfnIntegrationV2.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGatewayV2::Integration", exports2.CfnIntegrationV2 = CfnIntegrationV2;
    function CfnIntegrationResponseV2PropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return errors.collect(cdk.propertyValidator("apiId", cdk.requiredValidator)(properties.apiId)), errors.collect(cdk.propertyValidator("apiId", cdk.validateString)(properties.apiId)), errors.collect(cdk.propertyValidator("contentHandlingStrategy", cdk.validateString)(properties.contentHandlingStrategy)), errors.collect(cdk.propertyValidator("integrationId", cdk.requiredValidator)(properties.integrationId)), errors.collect(cdk.propertyValidator("integrationId", cdk.validateString)(properties.integrationId)), errors.collect(cdk.propertyValidator("integrationResponseKey", cdk.requiredValidator)(properties.integrationResponseKey)), errors.collect(cdk.propertyValidator("integrationResponseKey", cdk.validateString)(properties.integrationResponseKey)), errors.collect(cdk.propertyValidator("responseParameters", cdk.validateObject)(properties.responseParameters)), errors.collect(cdk.propertyValidator("responseTemplates", cdk.validateObject)(properties.responseTemplates)), errors.collect(cdk.propertyValidator("templateSelectionExpression", cdk.validateString)(properties.templateSelectionExpression)), errors.wrap('supplied properties not correct for "CfnIntegrationResponseV2Props"');
    }
    function cfnIntegrationResponseV2PropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIntegrationResponseV2PropsValidator(properties).assertSuccess(), { ApiId: cdk.stringToCloudFormation(properties.apiId), IntegrationId: cdk.stringToCloudFormation(properties.integrationId), IntegrationResponseKey: cdk.stringToCloudFormation(properties.integrationResponseKey), ContentHandlingStrategy: cdk.stringToCloudFormation(properties.contentHandlingStrategy), ResponseParameters: cdk.objectToCloudFormation(properties.responseParameters), ResponseTemplates: cdk.objectToCloudFormation(properties.responseTemplates), TemplateSelectionExpression: cdk.stringToCloudFormation(properties.templateSelectionExpression) }) : properties;
    }
    var CfnIntegrationResponseV2 = class _CfnIntegrationResponseV2 extends cdk.CfnResource {
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnIntegrationResponseV2.CFN_RESOURCE_TYPE_NAME, properties: props }), cdk.requireProperty(props, "apiId", this), cdk.requireProperty(props, "integrationId", this), cdk.requireProperty(props, "integrationResponseKey", this), this.apiId = props.apiId, this.integrationId = props.integrationId, this.integrationResponseKey = props.integrationResponseKey, this.contentHandlingStrategy = props.contentHandlingStrategy, this.responseParameters = props.responseParameters, this.responseTemplates = props.responseTemplates, this.templateSelectionExpression = props.templateSelectionExpression;
      }
      inspect(inspector) {
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnIntegrationResponseV2.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiId: this.apiId, integrationId: this.integrationId, integrationResponseKey: this.integrationResponseKey, contentHandlingStrategy: this.contentHandlingStrategy, responseParameters: this.responseParameters, responseTemplates: this.responseTemplates, templateSelectionExpression: this.templateSelectionExpression };
      }
      renderProperties(props) {
        return cfnIntegrationResponseV2PropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnIntegrationResponseV2[_g] = { fqn: "aws-cdk-lib.aws_apigateway.CfnIntegrationResponseV2", version: "2.80.0" }, CfnIntegrationResponseV2.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGatewayV2::IntegrationResponse", exports2.CfnIntegrationResponseV2 = CfnIntegrationResponseV2;
    function CfnModelV2PropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return errors.collect(cdk.propertyValidator("apiId", cdk.requiredValidator)(properties.apiId)), errors.collect(cdk.propertyValidator("apiId", cdk.validateString)(properties.apiId)), errors.collect(cdk.propertyValidator("contentType", cdk.validateString)(properties.contentType)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("schema", cdk.requiredValidator)(properties.schema)), errors.collect(cdk.propertyValidator("schema", cdk.validateObject)(properties.schema)), errors.wrap('supplied properties not correct for "CfnModelV2Props"');
    }
    function cfnModelV2PropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelV2PropsValidator(properties).assertSuccess(), { ApiId: cdk.stringToCloudFormation(properties.apiId), Name: cdk.stringToCloudFormation(properties.name), Schema: cdk.objectToCloudFormation(properties.schema), ContentType: cdk.stringToCloudFormation(properties.contentType), Description: cdk.stringToCloudFormation(properties.description) }) : properties;
    }
    var CfnModelV2 = class _CfnModelV2 extends cdk.CfnResource {
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnModelV2.CFN_RESOURCE_TYPE_NAME, properties: props }), cdk.requireProperty(props, "apiId", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "schema", this), this.apiId = props.apiId, this.name = props.name, this.schema = props.schema, this.contentType = props.contentType, this.description = props.description;
      }
      inspect(inspector) {
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnModelV2.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiId: this.apiId, name: this.name, schema: this.schema, contentType: this.contentType, description: this.description };
      }
      renderProperties(props) {
        return cfnModelV2PropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnModelV2[_h] = { fqn: "aws-cdk-lib.aws_apigateway.CfnModelV2", version: "2.80.0" }, CfnModelV2.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGatewayV2::Model", exports2.CfnModelV2 = CfnModelV2;
    function CfnRouteV2PropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return errors.collect(cdk.propertyValidator("apiId", cdk.requiredValidator)(properties.apiId)), errors.collect(cdk.propertyValidator("apiId", cdk.validateString)(properties.apiId)), errors.collect(cdk.propertyValidator("apiKeyRequired", cdk.validateBoolean)(properties.apiKeyRequired)), errors.collect(cdk.propertyValidator("authorizationScopes", cdk.listValidator(cdk.validateString))(properties.authorizationScopes)), errors.collect(cdk.propertyValidator("authorizationType", cdk.validateString)(properties.authorizationType)), errors.collect(cdk.propertyValidator("authorizerId", cdk.validateString)(properties.authorizerId)), errors.collect(cdk.propertyValidator("modelSelectionExpression", cdk.validateString)(properties.modelSelectionExpression)), errors.collect(cdk.propertyValidator("operationName", cdk.validateString)(properties.operationName)), errors.collect(cdk.propertyValidator("requestModels", cdk.validateObject)(properties.requestModels)), errors.collect(cdk.propertyValidator("requestParameters", cdk.validateObject)(properties.requestParameters)), errors.collect(cdk.propertyValidator("routeKey", cdk.requiredValidator)(properties.routeKey)), errors.collect(cdk.propertyValidator("routeKey", cdk.validateString)(properties.routeKey)), errors.collect(cdk.propertyValidator("routeResponseSelectionExpression", cdk.validateString)(properties.routeResponseSelectionExpression)), errors.collect(cdk.propertyValidator("target", cdk.validateString)(properties.target)), errors.wrap('supplied properties not correct for "CfnRouteV2Props"');
    }
    function cfnRouteV2PropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRouteV2PropsValidator(properties).assertSuccess(), { ApiId: cdk.stringToCloudFormation(properties.apiId), RouteKey: cdk.stringToCloudFormation(properties.routeKey), ApiKeyRequired: cdk.booleanToCloudFormation(properties.apiKeyRequired), AuthorizationScopes: cdk.listMapper(cdk.stringToCloudFormation)(properties.authorizationScopes), AuthorizationType: cdk.stringToCloudFormation(properties.authorizationType), AuthorizerId: cdk.stringToCloudFormation(properties.authorizerId), ModelSelectionExpression: cdk.stringToCloudFormation(properties.modelSelectionExpression), OperationName: cdk.stringToCloudFormation(properties.operationName), RequestModels: cdk.objectToCloudFormation(properties.requestModels), RequestParameters: cdk.objectToCloudFormation(properties.requestParameters), RouteResponseSelectionExpression: cdk.stringToCloudFormation(properties.routeResponseSelectionExpression), Target: cdk.stringToCloudFormation(properties.target) }) : properties;
    }
    var CfnRouteV2 = class _CfnRouteV2 extends cdk.CfnResource {
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRouteV2.CFN_RESOURCE_TYPE_NAME, properties: props }), cdk.requireProperty(props, "apiId", this), cdk.requireProperty(props, "routeKey", this), this.apiId = props.apiId, this.routeKey = props.routeKey, this.apiKeyRequired = props.apiKeyRequired, this.authorizationScopes = props.authorizationScopes, this.authorizationType = props.authorizationType, this.authorizerId = props.authorizerId, this.modelSelectionExpression = props.modelSelectionExpression, this.operationName = props.operationName, this.requestModels = props.requestModels, this.requestParameters = props.requestParameters, this.routeResponseSelectionExpression = props.routeResponseSelectionExpression, this.target = props.target;
      }
      inspect(inspector) {
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRouteV2.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiId: this.apiId, routeKey: this.routeKey, apiKeyRequired: this.apiKeyRequired, authorizationScopes: this.authorizationScopes, authorizationType: this.authorizationType, authorizerId: this.authorizerId, modelSelectionExpression: this.modelSelectionExpression, operationName: this.operationName, requestModels: this.requestModels, requestParameters: this.requestParameters, routeResponseSelectionExpression: this.routeResponseSelectionExpression, target: this.target };
      }
      renderProperties(props) {
        return cfnRouteV2PropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnRouteV2[_j] = { fqn: "aws-cdk-lib.aws_apigateway.CfnRouteV2", version: "2.80.0" }, CfnRouteV2.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGatewayV2::Route", exports2.CfnRouteV2 = CfnRouteV2;
    function CfnRouteResponseV2PropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return errors.collect(cdk.propertyValidator("apiId", cdk.requiredValidator)(properties.apiId)), errors.collect(cdk.propertyValidator("apiId", cdk.validateString)(properties.apiId)), errors.collect(cdk.propertyValidator("modelSelectionExpression", cdk.validateString)(properties.modelSelectionExpression)), errors.collect(cdk.propertyValidator("responseModels", cdk.validateObject)(properties.responseModels)), errors.collect(cdk.propertyValidator("responseParameters", cdk.validateObject)(properties.responseParameters)), errors.collect(cdk.propertyValidator("routeId", cdk.requiredValidator)(properties.routeId)), errors.collect(cdk.propertyValidator("routeId", cdk.validateString)(properties.routeId)), errors.collect(cdk.propertyValidator("routeResponseKey", cdk.requiredValidator)(properties.routeResponseKey)), errors.collect(cdk.propertyValidator("routeResponseKey", cdk.validateString)(properties.routeResponseKey)), errors.wrap('supplied properties not correct for "CfnRouteResponseV2Props"');
    }
    function cfnRouteResponseV2PropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRouteResponseV2PropsValidator(properties).assertSuccess(), { ApiId: cdk.stringToCloudFormation(properties.apiId), RouteId: cdk.stringToCloudFormation(properties.routeId), RouteResponseKey: cdk.stringToCloudFormation(properties.routeResponseKey), ModelSelectionExpression: cdk.stringToCloudFormation(properties.modelSelectionExpression), ResponseModels: cdk.objectToCloudFormation(properties.responseModels), ResponseParameters: cdk.objectToCloudFormation(properties.responseParameters) }) : properties;
    }
    var CfnRouteResponseV2 = class _CfnRouteResponseV2 extends cdk.CfnResource {
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRouteResponseV2.CFN_RESOURCE_TYPE_NAME, properties: props }), cdk.requireProperty(props, "apiId", this), cdk.requireProperty(props, "routeId", this), cdk.requireProperty(props, "routeResponseKey", this), this.apiId = props.apiId, this.routeId = props.routeId, this.routeResponseKey = props.routeResponseKey, this.modelSelectionExpression = props.modelSelectionExpression, this.responseModels = props.responseModels, this.responseParameters = props.responseParameters;
      }
      inspect(inspector) {
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRouteResponseV2.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiId: this.apiId, routeId: this.routeId, routeResponseKey: this.routeResponseKey, modelSelectionExpression: this.modelSelectionExpression, responseModels: this.responseModels, responseParameters: this.responseParameters };
      }
      renderProperties(props) {
        return cfnRouteResponseV2PropsToCloudFormation(props);
      }
    };
    _k = JSII_RTTI_SYMBOL_1, CfnRouteResponseV2[_k] = { fqn: "aws-cdk-lib.aws_apigateway.CfnRouteResponseV2", version: "2.80.0" }, CfnRouteResponseV2.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGatewayV2::RouteResponse", exports2.CfnRouteResponseV2 = CfnRouteResponseV2;
    function CfnStageV2PropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return errors.collect(cdk.propertyValidator("accessLogSettings", CfnStageV2_AccessLogSettingsPropertyValidator)(properties.accessLogSettings)), errors.collect(cdk.propertyValidator("apiId", cdk.requiredValidator)(properties.apiId)), errors.collect(cdk.propertyValidator("apiId", cdk.validateString)(properties.apiId)), errors.collect(cdk.propertyValidator("autoDeploy", cdk.validateBoolean)(properties.autoDeploy)), errors.collect(cdk.propertyValidator("clientCertificateId", cdk.validateString)(properties.clientCertificateId)), errors.collect(cdk.propertyValidator("defaultRouteSettings", CfnStageV2_RouteSettingsPropertyValidator)(properties.defaultRouteSettings)), errors.collect(cdk.propertyValidator("deploymentId", cdk.validateString)(properties.deploymentId)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("routeSettings", cdk.validateObject)(properties.routeSettings)), errors.collect(cdk.propertyValidator("stageName", cdk.requiredValidator)(properties.stageName)), errors.collect(cdk.propertyValidator("stageName", cdk.validateString)(properties.stageName)), errors.collect(cdk.propertyValidator("stageVariables", cdk.validateObject)(properties.stageVariables)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.wrap('supplied properties not correct for "CfnStageV2Props"');
    }
    function cfnStageV2PropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStageV2PropsValidator(properties).assertSuccess(), { ApiId: cdk.stringToCloudFormation(properties.apiId), StageName: cdk.stringToCloudFormation(properties.stageName), AccessLogSettings: cfnStageV2AccessLogSettingsPropertyToCloudFormation(properties.accessLogSettings), AutoDeploy: cdk.booleanToCloudFormation(properties.autoDeploy), ClientCertificateId: cdk.stringToCloudFormation(properties.clientCertificateId), DefaultRouteSettings: cfnStageV2RouteSettingsPropertyToCloudFormation(properties.defaultRouteSettings), DeploymentId: cdk.stringToCloudFormation(properties.deploymentId), Description: cdk.stringToCloudFormation(properties.description), RouteSettings: cdk.objectToCloudFormation(properties.routeSettings), StageVariables: cdk.objectToCloudFormation(properties.stageVariables), Tags: cdk.objectToCloudFormation(properties.tags) }) : properties;
    }
    var CfnStageV2 = class _CfnStageV2 extends cdk.CfnResource {
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnStageV2.CFN_RESOURCE_TYPE_NAME, properties: props }), cdk.requireProperty(props, "apiId", this), cdk.requireProperty(props, "stageName", this), this.apiId = props.apiId, this.stageName = props.stageName, this.accessLogSettings = props.accessLogSettings, this.autoDeploy = props.autoDeploy, this.clientCertificateId = props.clientCertificateId, this.defaultRouteSettings = props.defaultRouteSettings, this.deploymentId = props.deploymentId, this.description = props.description, this.routeSettings = props.routeSettings, this.stageVariables = props.stageVariables, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::ApiGatewayV2::Stage", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStageV2.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiId: this.apiId, stageName: this.stageName, accessLogSettings: this.accessLogSettings, autoDeploy: this.autoDeploy, clientCertificateId: this.clientCertificateId, defaultRouteSettings: this.defaultRouteSettings, deploymentId: this.deploymentId, description: this.description, routeSettings: this.routeSettings, stageVariables: this.stageVariables, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnStageV2PropsToCloudFormation(props);
      }
    };
    _l = JSII_RTTI_SYMBOL_1, CfnStageV2[_l] = { fqn: "aws-cdk-lib.aws_apigateway.CfnStageV2", version: "2.80.0" }, CfnStageV2.CFN_RESOURCE_TYPE_NAME = "AWS::ApiGatewayV2::Stage", exports2.CfnStageV2 = CfnStageV2;
    function CfnStageV2_AccessLogSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return errors.collect(cdk.propertyValidator("destinationArn", cdk.validateString)(properties.destinationArn)), errors.collect(cdk.propertyValidator("format", cdk.validateString)(properties.format)), errors.wrap('supplied properties not correct for "AccessLogSettingsProperty"');
    }
    function cfnStageV2AccessLogSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStageV2_AccessLogSettingsPropertyValidator(properties).assertSuccess(), { DestinationArn: cdk.stringToCloudFormation(properties.destinationArn), Format: cdk.stringToCloudFormation(properties.format) }) : properties;
    }
    function CfnStageV2_RouteSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return errors.collect(cdk.propertyValidator("dataTraceEnabled", cdk.validateBoolean)(properties.dataTraceEnabled)), errors.collect(cdk.propertyValidator("detailedMetricsEnabled", cdk.validateBoolean)(properties.detailedMetricsEnabled)), errors.collect(cdk.propertyValidator("loggingLevel", cdk.validateString)(properties.loggingLevel)), errors.collect(cdk.propertyValidator("throttlingBurstLimit", cdk.validateNumber)(properties.throttlingBurstLimit)), errors.collect(cdk.propertyValidator("throttlingRateLimit", cdk.validateNumber)(properties.throttlingRateLimit)), errors.wrap('supplied properties not correct for "RouteSettingsProperty"');
    }
    function cfnStageV2RouteSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStageV2_RouteSettingsPropertyValidator(properties).assertSuccess(), { DataTraceEnabled: cdk.booleanToCloudFormation(properties.dataTraceEnabled), DetailedMetricsEnabled: cdk.booleanToCloudFormation(properties.detailedMetricsEnabled), LoggingLevel: cdk.stringToCloudFormation(properties.loggingLevel), ThrottlingBurstLimit: cdk.numberToCloudFormation(properties.throttlingBurstLimit), ThrottlingRateLimit: cdk.numberToCloudFormation(properties.throttlingRateLimit) }) : properties;
    }
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/lib/index.js
var require_lib40 = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_restapi(), exports2), __exportStar(require_resource2(), exports2), __exportStar(require_method(), exports2), __exportStar(require_integration(), exports2), __exportStar(require_deployment(), exports2), __exportStar(require_stage2(), exports2), __exportStar(require_integrations(), exports2), __exportStar(require_lambda_api(), exports2), __exportStar(require_api_key(), exports2), __exportStar(require_usage_plan(), exports2), __exportStar(require_vpc_link(), exports2), __exportStar(require_methodresponse(), exports2), __exportStar(require_model(), exports2), __exportStar(require_requestvalidator(), exports2), __exportStar(require_authorizer(), exports2), __exportStar(require_json_schema(), exports2), __exportStar(require_domain_name(), exports2), __exportStar(require_base_path_mapping(), exports2), __exportStar(require_cors(), exports2), __exportStar(require_authorizers(), exports2), __exportStar(require_access_log(), exports2), __exportStar(require_api_definition(), exports2), __exportStar(require_gateway_response(), exports2), __exportStar(require_stepfunctions_api(), exports2), __exportStar(require_apigateway_generated(), exports2), __exportStar(require_apigatewayv22(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-apigateway/index.js
var require_aws_apigateway = __commonJS({
  "node_modules/aws-cdk-lib/aws-apigateway/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib40(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-appconfig/lib/appconfig.generated.js
var require_appconfig_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-appconfig/lib/appconfig.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnHostedConfigurationVersion = exports2.CfnExtensionAssociation = exports2.CfnExtension = exports2.CfnEnvironment = exports2.CfnDeploymentStrategy = exports2.CfnDeployment = exports2.CfnConfigurationProfile = exports2.CfnApplication = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnApplicationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(CfnApplication_TagsPropertyValidator))(properties.tags)), errors.wrap('supplied properties not correct for "CfnApplicationProps"');
    }
    function cfnApplicationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cfnApplicationTagsPropertyToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnApplicationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(CfnApplicationTagsPropertyFromCloudFormation)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApplication = class _CfnApplication extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApplicationPropsFromCloudFormation(resourceProperties), ret = new _CfnApplication(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApplication.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appconfig_CfnApplicationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApplication), error;
        }
        cdk.requireProperty(props, "name", this), this.name = props.name, this.description = props.description, this.tags = props.tags;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApplication.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, description: this.description, tags: this.tags };
      }
      renderProperties(props) {
        return cfnApplicationPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnApplication[_a] = { fqn: "aws-cdk-lib.aws_appconfig.CfnApplication", version: "2.80.0" }, CfnApplication.CFN_RESOURCE_TYPE_NAME = "AWS::AppConfig::Application", exports2.CfnApplication = CfnApplication;
    function CfnApplication_TagsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TagsProperty"');
    }
    function cfnApplicationTagsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_TagsPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnApplicationTagsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigurationProfilePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationId", cdk.requiredValidator)(properties.applicationId)), errors.collect(cdk.propertyValidator("applicationId", cdk.validateString)(properties.applicationId)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("locationUri", cdk.requiredValidator)(properties.locationUri)), errors.collect(cdk.propertyValidator("locationUri", cdk.validateString)(properties.locationUri)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("retrievalRoleArn", cdk.validateString)(properties.retrievalRoleArn)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(CfnConfigurationProfile_TagsPropertyValidator))(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("validators", cdk.listValidator(CfnConfigurationProfile_ValidatorsPropertyValidator))(properties.validators)), errors.wrap('supplied properties not correct for "CfnConfigurationProfileProps"');
    }
    function cfnConfigurationProfilePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationProfilePropsValidator(properties).assertSuccess(), { ApplicationId: cdk.stringToCloudFormation(properties.applicationId), LocationUri: cdk.stringToCloudFormation(properties.locationUri), Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), RetrievalRoleArn: cdk.stringToCloudFormation(properties.retrievalRoleArn), Tags: cdk.listMapper(cfnConfigurationProfileTagsPropertyToCloudFormation)(properties.tags), Type: cdk.stringToCloudFormation(properties.type), Validators: cdk.listMapper(cfnConfigurationProfileValidatorsPropertyToCloudFormation)(properties.validators) }) : properties;
    }
    function CfnConfigurationProfilePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationId", "ApplicationId", cfn_parse.FromCloudFormation.getString(properties.ApplicationId)), ret.addPropertyResult("locationUri", "LocationUri", cfn_parse.FromCloudFormation.getString(properties.LocationUri)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("retrievalRoleArn", "RetrievalRoleArn", properties.RetrievalRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RetrievalRoleArn) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(CfnConfigurationProfileTagsPropertyFromCloudFormation)(properties.Tags) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addPropertyResult("validators", "Validators", properties.Validators != null ? cfn_parse.FromCloudFormation.getArray(CfnConfigurationProfileValidatorsPropertyFromCloudFormation)(properties.Validators) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnConfigurationProfile = class _CfnConfigurationProfile extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnConfigurationProfilePropsFromCloudFormation(resourceProperties), ret = new _CfnConfigurationProfile(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnConfigurationProfile.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appconfig_CfnConfigurationProfileProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnConfigurationProfile), error;
        }
        cdk.requireProperty(props, "applicationId", this), cdk.requireProperty(props, "locationUri", this), cdk.requireProperty(props, "name", this), this.applicationId = props.applicationId, this.locationUri = props.locationUri, this.name = props.name, this.description = props.description, this.retrievalRoleArn = props.retrievalRoleArn, this.tags = props.tags, this.type = props.type, this.validators = props.validators;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnConfigurationProfile.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationId: this.applicationId, locationUri: this.locationUri, name: this.name, description: this.description, retrievalRoleArn: this.retrievalRoleArn, tags: this.tags, type: this.type, validators: this.validators };
      }
      renderProperties(props) {
        return cfnConfigurationProfilePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnConfigurationProfile[_b] = { fqn: "aws-cdk-lib.aws_appconfig.CfnConfigurationProfile", version: "2.80.0" }, CfnConfigurationProfile.CFN_RESOURCE_TYPE_NAME = "AWS::AppConfig::ConfigurationProfile", exports2.CfnConfigurationProfile = CfnConfigurationProfile;
    function CfnConfigurationProfile_TagsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TagsProperty"');
    }
    function cfnConfigurationProfileTagsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationProfile_TagsPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnConfigurationProfileTagsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigurationProfile_ValidatorsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("content", cdk.validateString)(properties.content)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "ValidatorsProperty"');
    }
    function cfnConfigurationProfileValidatorsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationProfile_ValidatorsPropertyValidator(properties).assertSuccess(), { Content: cdk.stringToCloudFormation(properties.content), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnConfigurationProfileValidatorsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("content", "Content", properties.Content != null ? cfn_parse.FromCloudFormation.getString(properties.Content) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationId", cdk.requiredValidator)(properties.applicationId)), errors.collect(cdk.propertyValidator("applicationId", cdk.validateString)(properties.applicationId)), errors.collect(cdk.propertyValidator("configurationProfileId", cdk.requiredValidator)(properties.configurationProfileId)), errors.collect(cdk.propertyValidator("configurationProfileId", cdk.validateString)(properties.configurationProfileId)), errors.collect(cdk.propertyValidator("configurationVersion", cdk.requiredValidator)(properties.configurationVersion)), errors.collect(cdk.propertyValidator("configurationVersion", cdk.validateString)(properties.configurationVersion)), errors.collect(cdk.propertyValidator("deploymentStrategyId", cdk.requiredValidator)(properties.deploymentStrategyId)), errors.collect(cdk.propertyValidator("deploymentStrategyId", cdk.validateString)(properties.deploymentStrategyId)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("environmentId", cdk.requiredValidator)(properties.environmentId)), errors.collect(cdk.propertyValidator("environmentId", cdk.validateString)(properties.environmentId)), errors.collect(cdk.propertyValidator("kmsKeyIdentifier", cdk.validateString)(properties.kmsKeyIdentifier)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(CfnDeployment_TagsPropertyValidator))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDeploymentProps"');
    }
    function cfnDeploymentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentPropsValidator(properties).assertSuccess(), { ApplicationId: cdk.stringToCloudFormation(properties.applicationId), ConfigurationProfileId: cdk.stringToCloudFormation(properties.configurationProfileId), ConfigurationVersion: cdk.stringToCloudFormation(properties.configurationVersion), DeploymentStrategyId: cdk.stringToCloudFormation(properties.deploymentStrategyId), EnvironmentId: cdk.stringToCloudFormation(properties.environmentId), Description: cdk.stringToCloudFormation(properties.description), KmsKeyIdentifier: cdk.stringToCloudFormation(properties.kmsKeyIdentifier), Tags: cdk.listMapper(cfnDeploymentTagsPropertyToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDeploymentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationId", "ApplicationId", cfn_parse.FromCloudFormation.getString(properties.ApplicationId)), ret.addPropertyResult("configurationProfileId", "ConfigurationProfileId", cfn_parse.FromCloudFormation.getString(properties.ConfigurationProfileId)), ret.addPropertyResult("configurationVersion", "ConfigurationVersion", cfn_parse.FromCloudFormation.getString(properties.ConfigurationVersion)), ret.addPropertyResult("deploymentStrategyId", "DeploymentStrategyId", cfn_parse.FromCloudFormation.getString(properties.DeploymentStrategyId)), ret.addPropertyResult("environmentId", "EnvironmentId", cfn_parse.FromCloudFormation.getString(properties.EnvironmentId)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("kmsKeyIdentifier", "KmsKeyIdentifier", properties.KmsKeyIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyIdentifier) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(CfnDeploymentTagsPropertyFromCloudFormation)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDeployment = class _CfnDeployment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDeploymentPropsFromCloudFormation(resourceProperties), ret = new _CfnDeployment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDeployment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appconfig_CfnDeploymentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDeployment), error;
        }
        cdk.requireProperty(props, "applicationId", this), cdk.requireProperty(props, "configurationProfileId", this), cdk.requireProperty(props, "configurationVersion", this), cdk.requireProperty(props, "deploymentStrategyId", this), cdk.requireProperty(props, "environmentId", this), this.applicationId = props.applicationId, this.configurationProfileId = props.configurationProfileId, this.configurationVersion = props.configurationVersion, this.deploymentStrategyId = props.deploymentStrategyId, this.environmentId = props.environmentId, this.description = props.description, this.kmsKeyIdentifier = props.kmsKeyIdentifier, this.tags = props.tags;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDeployment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationId: this.applicationId, configurationProfileId: this.configurationProfileId, configurationVersion: this.configurationVersion, deploymentStrategyId: this.deploymentStrategyId, environmentId: this.environmentId, description: this.description, kmsKeyIdentifier: this.kmsKeyIdentifier, tags: this.tags };
      }
      renderProperties(props) {
        return cfnDeploymentPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnDeployment[_c] = { fqn: "aws-cdk-lib.aws_appconfig.CfnDeployment", version: "2.80.0" }, CfnDeployment.CFN_RESOURCE_TYPE_NAME = "AWS::AppConfig::Deployment", exports2.CfnDeployment = CfnDeployment;
    function CfnDeployment_TagsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TagsProperty"');
    }
    function cfnDeploymentTagsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeployment_TagsPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnDeploymentTagsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentStrategyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deploymentDurationInMinutes", cdk.requiredValidator)(properties.deploymentDurationInMinutes)), errors.collect(cdk.propertyValidator("deploymentDurationInMinutes", cdk.validateNumber)(properties.deploymentDurationInMinutes)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("finalBakeTimeInMinutes", cdk.validateNumber)(properties.finalBakeTimeInMinutes)), errors.collect(cdk.propertyValidator("growthFactor", cdk.requiredValidator)(properties.growthFactor)), errors.collect(cdk.propertyValidator("growthFactor", cdk.validateNumber)(properties.growthFactor)), errors.collect(cdk.propertyValidator("growthType", cdk.validateString)(properties.growthType)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("replicateTo", cdk.requiredValidator)(properties.replicateTo)), errors.collect(cdk.propertyValidator("replicateTo", cdk.validateString)(properties.replicateTo)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(CfnDeploymentStrategy_TagsPropertyValidator))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDeploymentStrategyProps"');
    }
    function cfnDeploymentStrategyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentStrategyPropsValidator(properties).assertSuccess(), { DeploymentDurationInMinutes: cdk.numberToCloudFormation(properties.deploymentDurationInMinutes), GrowthFactor: cdk.numberToCloudFormation(properties.growthFactor), Name: cdk.stringToCloudFormation(properties.name), ReplicateTo: cdk.stringToCloudFormation(properties.replicateTo), Description: cdk.stringToCloudFormation(properties.description), FinalBakeTimeInMinutes: cdk.numberToCloudFormation(properties.finalBakeTimeInMinutes), GrowthType: cdk.stringToCloudFormation(properties.growthType), Tags: cdk.listMapper(cfnDeploymentStrategyTagsPropertyToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDeploymentStrategyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deploymentDurationInMinutes", "DeploymentDurationInMinutes", cfn_parse.FromCloudFormation.getNumber(properties.DeploymentDurationInMinutes)), ret.addPropertyResult("growthFactor", "GrowthFactor", cfn_parse.FromCloudFormation.getNumber(properties.GrowthFactor)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("replicateTo", "ReplicateTo", cfn_parse.FromCloudFormation.getString(properties.ReplicateTo)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("finalBakeTimeInMinutes", "FinalBakeTimeInMinutes", properties.FinalBakeTimeInMinutes != null ? cfn_parse.FromCloudFormation.getNumber(properties.FinalBakeTimeInMinutes) : void 0), ret.addPropertyResult("growthType", "GrowthType", properties.GrowthType != null ? cfn_parse.FromCloudFormation.getString(properties.GrowthType) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(CfnDeploymentStrategyTagsPropertyFromCloudFormation)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDeploymentStrategy = class _CfnDeploymentStrategy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDeploymentStrategyPropsFromCloudFormation(resourceProperties), ret = new _CfnDeploymentStrategy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDeploymentStrategy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appconfig_CfnDeploymentStrategyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDeploymentStrategy), error;
        }
        cdk.requireProperty(props, "deploymentDurationInMinutes", this), cdk.requireProperty(props, "growthFactor", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "replicateTo", this), this.deploymentDurationInMinutes = props.deploymentDurationInMinutes, this.growthFactor = props.growthFactor, this.name = props.name, this.replicateTo = props.replicateTo, this.description = props.description, this.finalBakeTimeInMinutes = props.finalBakeTimeInMinutes, this.growthType = props.growthType, this.tags = props.tags;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDeploymentStrategy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { deploymentDurationInMinutes: this.deploymentDurationInMinutes, growthFactor: this.growthFactor, name: this.name, replicateTo: this.replicateTo, description: this.description, finalBakeTimeInMinutes: this.finalBakeTimeInMinutes, growthType: this.growthType, tags: this.tags };
      }
      renderProperties(props) {
        return cfnDeploymentStrategyPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnDeploymentStrategy[_d] = { fqn: "aws-cdk-lib.aws_appconfig.CfnDeploymentStrategy", version: "2.80.0" }, CfnDeploymentStrategy.CFN_RESOURCE_TYPE_NAME = "AWS::AppConfig::DeploymentStrategy", exports2.CfnDeploymentStrategy = CfnDeploymentStrategy;
    function CfnDeploymentStrategy_TagsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TagsProperty"');
    }
    function cfnDeploymentStrategyTagsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentStrategy_TagsPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnDeploymentStrategyTagsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEnvironmentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationId", cdk.requiredValidator)(properties.applicationId)), errors.collect(cdk.propertyValidator("applicationId", cdk.validateString)(properties.applicationId)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("monitors", cdk.listValidator(CfnEnvironment_MonitorsPropertyValidator))(properties.monitors)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(CfnEnvironment_TagsPropertyValidator))(properties.tags)), errors.wrap('supplied properties not correct for "CfnEnvironmentProps"');
    }
    function cfnEnvironmentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEnvironmentPropsValidator(properties).assertSuccess(), { ApplicationId: cdk.stringToCloudFormation(properties.applicationId), Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), Monitors: cdk.listMapper(cfnEnvironmentMonitorsPropertyToCloudFormation)(properties.monitors), Tags: cdk.listMapper(cfnEnvironmentTagsPropertyToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnEnvironmentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationId", "ApplicationId", cfn_parse.FromCloudFormation.getString(properties.ApplicationId)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("monitors", "Monitors", properties.Monitors != null ? cfn_parse.FromCloudFormation.getArray(CfnEnvironmentMonitorsPropertyFromCloudFormation)(properties.Monitors) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(CfnEnvironmentTagsPropertyFromCloudFormation)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEnvironment = class _CfnEnvironment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEnvironmentPropsFromCloudFormation(resourceProperties), ret = new _CfnEnvironment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEnvironment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appconfig_CfnEnvironmentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEnvironment), error;
        }
        cdk.requireProperty(props, "applicationId", this), cdk.requireProperty(props, "name", this), this.applicationId = props.applicationId, this.name = props.name, this.description = props.description, this.monitors = props.monitors, this.tags = props.tags;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEnvironment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationId: this.applicationId, name: this.name, description: this.description, monitors: this.monitors, tags: this.tags };
      }
      renderProperties(props) {
        return cfnEnvironmentPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnEnvironment[_e] = { fqn: "aws-cdk-lib.aws_appconfig.CfnEnvironment", version: "2.80.0" }, CfnEnvironment.CFN_RESOURCE_TYPE_NAME = "AWS::AppConfig::Environment", exports2.CfnEnvironment = CfnEnvironment;
    function CfnEnvironment_MonitorsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alarmArn", cdk.validateString)(properties.alarmArn)), errors.collect(cdk.propertyValidator("alarmRoleArn", cdk.validateString)(properties.alarmRoleArn)), errors.wrap('supplied properties not correct for "MonitorsProperty"');
    }
    function cfnEnvironmentMonitorsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEnvironment_MonitorsPropertyValidator(properties).assertSuccess(), { AlarmArn: cdk.stringToCloudFormation(properties.alarmArn), AlarmRoleArn: cdk.stringToCloudFormation(properties.alarmRoleArn) }) : properties;
    }
    function CfnEnvironmentMonitorsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alarmArn", "AlarmArn", properties.AlarmArn != null ? cfn_parse.FromCloudFormation.getString(properties.AlarmArn) : void 0), ret.addPropertyResult("alarmRoleArn", "AlarmRoleArn", properties.AlarmRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.AlarmRoleArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEnvironment_TagsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TagsProperty"');
    }
    function cfnEnvironmentTagsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEnvironment_TagsPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnEnvironmentTagsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnExtensionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.requiredValidator)(properties.actions)), errors.collect(cdk.propertyValidator("actions", cdk.validateObject)(properties.actions)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("latestVersionNumber", cdk.validateNumber)(properties.latestVersionNumber)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("parameters", cdk.hashValidator(CfnExtension_ParameterPropertyValidator))(properties.parameters)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnExtensionProps"');
    }
    function cfnExtensionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnExtensionPropsValidator(properties).assertSuccess(), { Actions: cdk.objectToCloudFormation(properties.actions), Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), LatestVersionNumber: cdk.numberToCloudFormation(properties.latestVersionNumber), Parameters: cdk.hashMapper(cfnExtensionParameterPropertyToCloudFormation)(properties.parameters), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnExtensionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", cfn_parse.FromCloudFormation.getAny(properties.Actions)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("latestVersionNumber", "LatestVersionNumber", properties.LatestVersionNumber != null ? cfn_parse.FromCloudFormation.getNumber(properties.LatestVersionNumber) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getMap(CfnExtensionParameterPropertyFromCloudFormation)(properties.Parameters) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnExtension = class _CfnExtension extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnExtensionPropsFromCloudFormation(resourceProperties), ret = new _CfnExtension(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnExtension.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appconfig_CfnExtensionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnExtension), error;
        }
        cdk.requireProperty(props, "actions", this), cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrVersionNumber = cdk.Token.asNumber(this.getAtt("VersionNumber", cdk.ResolutionTypeHint.NUMBER)), this.actions = props.actions, this.name = props.name, this.description = props.description, this.latestVersionNumber = props.latestVersionNumber, this.parameters = props.parameters, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::AppConfig::Extension", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnExtension.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { actions: this.actions, name: this.name, description: this.description, latestVersionNumber: this.latestVersionNumber, parameters: this.parameters, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnExtensionPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnExtension[_f] = { fqn: "aws-cdk-lib.aws_appconfig.CfnExtension", version: "2.80.0" }, CfnExtension.CFN_RESOURCE_TYPE_NAME = "AWS::AppConfig::Extension", exports2.CfnExtension = CfnExtension;
    function CfnExtension_ParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("required", cdk.requiredValidator)(properties.required)), errors.collect(cdk.propertyValidator("required", cdk.validateBoolean)(properties.required)), errors.wrap('supplied properties not correct for "ParameterProperty"');
    }
    function cfnExtensionParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnExtension_ParameterPropertyValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), Required: cdk.booleanToCloudFormation(properties.required) }) : properties;
    }
    function CfnExtensionParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("required", "Required", cfn_parse.FromCloudFormation.getBoolean(properties.Required)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnExtensionAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("extensionIdentifier", cdk.validateString)(properties.extensionIdentifier)), errors.collect(cdk.propertyValidator("extensionVersionNumber", cdk.validateNumber)(properties.extensionVersionNumber)), errors.collect(cdk.propertyValidator("parameters", cdk.hashValidator(cdk.validateString))(properties.parameters)), errors.collect(cdk.propertyValidator("resourceIdentifier", cdk.validateString)(properties.resourceIdentifier)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnExtensionAssociationProps"');
    }
    function cfnExtensionAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnExtensionAssociationPropsValidator(properties).assertSuccess(), { ExtensionIdentifier: cdk.stringToCloudFormation(properties.extensionIdentifier), ExtensionVersionNumber: cdk.numberToCloudFormation(properties.extensionVersionNumber), Parameters: cdk.hashMapper(cdk.stringToCloudFormation)(properties.parameters), ResourceIdentifier: cdk.stringToCloudFormation(properties.resourceIdentifier), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnExtensionAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("extensionIdentifier", "ExtensionIdentifier", properties.ExtensionIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.ExtensionIdentifier) : void 0), ret.addPropertyResult("extensionVersionNumber", "ExtensionVersionNumber", properties.ExtensionVersionNumber != null ? cfn_parse.FromCloudFormation.getNumber(properties.ExtensionVersionNumber) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Parameters) : void 0), ret.addPropertyResult("resourceIdentifier", "ResourceIdentifier", properties.ResourceIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceIdentifier) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnExtensionAssociation = class _CfnExtensionAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnExtensionAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnExtensionAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnExtensionAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appconfig_CfnExtensionAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnExtensionAssociation), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrExtensionArn = cdk.Token.asString(this.getAtt("ExtensionArn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrResourceArn = cdk.Token.asString(this.getAtt("ResourceArn", cdk.ResolutionTypeHint.STRING)), this.extensionIdentifier = props.extensionIdentifier, this.extensionVersionNumber = props.extensionVersionNumber, this.parameters = props.parameters, this.resourceIdentifier = props.resourceIdentifier, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::AppConfig::ExtensionAssociation", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnExtensionAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { extensionIdentifier: this.extensionIdentifier, extensionVersionNumber: this.extensionVersionNumber, parameters: this.parameters, resourceIdentifier: this.resourceIdentifier, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnExtensionAssociationPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnExtensionAssociation[_g] = { fqn: "aws-cdk-lib.aws_appconfig.CfnExtensionAssociation", version: "2.80.0" }, CfnExtensionAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::AppConfig::ExtensionAssociation", exports2.CfnExtensionAssociation = CfnExtensionAssociation;
    function CfnHostedConfigurationVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationId", cdk.requiredValidator)(properties.applicationId)), errors.collect(cdk.propertyValidator("applicationId", cdk.validateString)(properties.applicationId)), errors.collect(cdk.propertyValidator("configurationProfileId", cdk.requiredValidator)(properties.configurationProfileId)), errors.collect(cdk.propertyValidator("configurationProfileId", cdk.validateString)(properties.configurationProfileId)), errors.collect(cdk.propertyValidator("content", cdk.requiredValidator)(properties.content)), errors.collect(cdk.propertyValidator("content", cdk.validateString)(properties.content)), errors.collect(cdk.propertyValidator("contentType", cdk.requiredValidator)(properties.contentType)), errors.collect(cdk.propertyValidator("contentType", cdk.validateString)(properties.contentType)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("latestVersionNumber", cdk.validateNumber)(properties.latestVersionNumber)), errors.collect(cdk.propertyValidator("versionLabel", cdk.validateString)(properties.versionLabel)), errors.wrap('supplied properties not correct for "CfnHostedConfigurationVersionProps"');
    }
    function cfnHostedConfigurationVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHostedConfigurationVersionPropsValidator(properties).assertSuccess(), { ApplicationId: cdk.stringToCloudFormation(properties.applicationId), ConfigurationProfileId: cdk.stringToCloudFormation(properties.configurationProfileId), Content: cdk.stringToCloudFormation(properties.content), ContentType: cdk.stringToCloudFormation(properties.contentType), Description: cdk.stringToCloudFormation(properties.description), LatestVersionNumber: cdk.numberToCloudFormation(properties.latestVersionNumber), VersionLabel: cdk.stringToCloudFormation(properties.versionLabel) }) : properties;
    }
    function CfnHostedConfigurationVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationId", "ApplicationId", cfn_parse.FromCloudFormation.getString(properties.ApplicationId)), ret.addPropertyResult("configurationProfileId", "ConfigurationProfileId", cfn_parse.FromCloudFormation.getString(properties.ConfigurationProfileId)), ret.addPropertyResult("content", "Content", cfn_parse.FromCloudFormation.getString(properties.Content)), ret.addPropertyResult("contentType", "ContentType", cfn_parse.FromCloudFormation.getString(properties.ContentType)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("latestVersionNumber", "LatestVersionNumber", properties.LatestVersionNumber != null ? cfn_parse.FromCloudFormation.getNumber(properties.LatestVersionNumber) : void 0), ret.addPropertyResult("versionLabel", "VersionLabel", properties.VersionLabel != null ? cfn_parse.FromCloudFormation.getString(properties.VersionLabel) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnHostedConfigurationVersion = class _CfnHostedConfigurationVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnHostedConfigurationVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnHostedConfigurationVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnHostedConfigurationVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appconfig_CfnHostedConfigurationVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnHostedConfigurationVersion), error;
        }
        cdk.requireProperty(props, "applicationId", this), cdk.requireProperty(props, "configurationProfileId", this), cdk.requireProperty(props, "content", this), cdk.requireProperty(props, "contentType", this), this.applicationId = props.applicationId, this.configurationProfileId = props.configurationProfileId, this.content = props.content, this.contentType = props.contentType, this.description = props.description, this.latestVersionNumber = props.latestVersionNumber, this.versionLabel = props.versionLabel;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnHostedConfigurationVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationId: this.applicationId, configurationProfileId: this.configurationProfileId, content: this.content, contentType: this.contentType, description: this.description, latestVersionNumber: this.latestVersionNumber, versionLabel: this.versionLabel };
      }
      renderProperties(props) {
        return cfnHostedConfigurationVersionPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnHostedConfigurationVersion[_h] = { fqn: "aws-cdk-lib.aws_appconfig.CfnHostedConfigurationVersion", version: "2.80.0" }, CfnHostedConfigurationVersion.CFN_RESOURCE_TYPE_NAME = "AWS::AppConfig::HostedConfigurationVersion", exports2.CfnHostedConfigurationVersion = CfnHostedConfigurationVersion;
  }
});

// node_modules/aws-cdk-lib/aws-appconfig/lib/index.js
var require_lib41 = __commonJS({
  "node_modules/aws-cdk-lib/aws-appconfig/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_appconfig_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-appconfig/index.js
var require_aws_appconfig = __commonJS({
  "node_modules/aws-cdk-lib/aws-appconfig/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib41(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-appflow/lib/appflow.generated.js
var require_appflow_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-appflow/lib/appflow.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnFlow = exports2.CfnConnectorProfile = exports2.CfnConnector = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnConnectorPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectorLabel", cdk.validateString)(properties.connectorLabel)), errors.collect(cdk.propertyValidator("connectorProvisioningConfig", cdk.requiredValidator)(properties.connectorProvisioningConfig)), errors.collect(cdk.propertyValidator("connectorProvisioningConfig", CfnConnector_ConnectorProvisioningConfigPropertyValidator)(properties.connectorProvisioningConfig)), errors.collect(cdk.propertyValidator("connectorProvisioningType", cdk.requiredValidator)(properties.connectorProvisioningType)), errors.collect(cdk.propertyValidator("connectorProvisioningType", cdk.validateString)(properties.connectorProvisioningType)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.wrap('supplied properties not correct for "CfnConnectorProps"');
    }
    function cfnConnectorPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorPropsValidator(properties).assertSuccess(), { ConnectorProvisioningConfig: cfnConnectorConnectorProvisioningConfigPropertyToCloudFormation(properties.connectorProvisioningConfig), ConnectorProvisioningType: cdk.stringToCloudFormation(properties.connectorProvisioningType), ConnectorLabel: cdk.stringToCloudFormation(properties.connectorLabel), Description: cdk.stringToCloudFormation(properties.description) }) : properties;
    }
    function CfnConnectorPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectorProvisioningConfig", "ConnectorProvisioningConfig", CfnConnectorConnectorProvisioningConfigPropertyFromCloudFormation(properties.ConnectorProvisioningConfig)), ret.addPropertyResult("connectorProvisioningType", "ConnectorProvisioningType", cfn_parse.FromCloudFormation.getString(properties.ConnectorProvisioningType)), ret.addPropertyResult("connectorLabel", "ConnectorLabel", properties.ConnectorLabel != null ? cfn_parse.FromCloudFormation.getString(properties.ConnectorLabel) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnConnector = class _CfnConnector extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnConnectorPropsFromCloudFormation(resourceProperties), ret = new _CfnConnector(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnConnector.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appflow_CfnConnectorProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnConnector), error;
        }
        cdk.requireProperty(props, "connectorProvisioningConfig", this), cdk.requireProperty(props, "connectorProvisioningType", this), this.attrConnectorArn = cdk.Token.asString(this.getAtt("ConnectorArn", cdk.ResolutionTypeHint.STRING)), this.connectorProvisioningConfig = props.connectorProvisioningConfig, this.connectorProvisioningType = props.connectorProvisioningType, this.connectorLabel = props.connectorLabel, this.description = props.description;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnConnector.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { connectorProvisioningConfig: this.connectorProvisioningConfig, connectorProvisioningType: this.connectorProvisioningType, connectorLabel: this.connectorLabel, description: this.description };
      }
      renderProperties(props) {
        return cfnConnectorPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnConnector[_a] = { fqn: "aws-cdk-lib.aws_appflow.CfnConnector", version: "2.80.0" }, CfnConnector.CFN_RESOURCE_TYPE_NAME = "AWS::AppFlow::Connector", exports2.CfnConnector = CfnConnector;
    function CfnConnector_ConnectorProvisioningConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("lambda", CfnConnector_LambdaConnectorProvisioningConfigPropertyValidator)(properties.lambda)), errors.wrap('supplied properties not correct for "ConnectorProvisioningConfigProperty"');
    }
    function cfnConnectorConnectorProvisioningConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnector_ConnectorProvisioningConfigPropertyValidator(properties).assertSuccess(), { Lambda: cfnConnectorLambdaConnectorProvisioningConfigPropertyToCloudFormation(properties.lambda) }) : properties;
    }
    function CfnConnectorConnectorProvisioningConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("lambda", "Lambda", properties.Lambda != null ? CfnConnectorLambdaConnectorProvisioningConfigPropertyFromCloudFormation(properties.Lambda) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnector_LambdaConnectorProvisioningConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("lambdaArn", cdk.requiredValidator)(properties.lambdaArn)), errors.collect(cdk.propertyValidator("lambdaArn", cdk.validateString)(properties.lambdaArn)), errors.wrap('supplied properties not correct for "LambdaConnectorProvisioningConfigProperty"');
    }
    function cfnConnectorLambdaConnectorProvisioningConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnector_LambdaConnectorProvisioningConfigPropertyValidator(properties).assertSuccess(), { LambdaArn: cdk.stringToCloudFormation(properties.lambdaArn) }) : properties;
    }
    function CfnConnectorLambdaConnectorProvisioningConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("lambdaArn", "LambdaArn", cfn_parse.FromCloudFormation.getString(properties.LambdaArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfilePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectionMode", cdk.requiredValidator)(properties.connectionMode)), errors.collect(cdk.propertyValidator("connectionMode", cdk.validateString)(properties.connectionMode)), errors.collect(cdk.propertyValidator("connectorLabel", cdk.validateString)(properties.connectorLabel)), errors.collect(cdk.propertyValidator("connectorProfileConfig", CfnConnectorProfile_ConnectorProfileConfigPropertyValidator)(properties.connectorProfileConfig)), errors.collect(cdk.propertyValidator("connectorProfileName", cdk.requiredValidator)(properties.connectorProfileName)), errors.collect(cdk.propertyValidator("connectorProfileName", cdk.validateString)(properties.connectorProfileName)), errors.collect(cdk.propertyValidator("connectorType", cdk.requiredValidator)(properties.connectorType)), errors.collect(cdk.propertyValidator("connectorType", cdk.validateString)(properties.connectorType)), errors.collect(cdk.propertyValidator("kmsArn", cdk.validateString)(properties.kmsArn)), errors.wrap('supplied properties not correct for "CfnConnectorProfileProps"');
    }
    function cfnConnectorProfilePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfilePropsValidator(properties).assertSuccess(), { ConnectionMode: cdk.stringToCloudFormation(properties.connectionMode), ConnectorProfileName: cdk.stringToCloudFormation(properties.connectorProfileName), ConnectorType: cdk.stringToCloudFormation(properties.connectorType), ConnectorLabel: cdk.stringToCloudFormation(properties.connectorLabel), ConnectorProfileConfig: cfnConnectorProfileConnectorProfileConfigPropertyToCloudFormation(properties.connectorProfileConfig), KMSArn: cdk.stringToCloudFormation(properties.kmsArn) }) : properties;
    }
    function CfnConnectorProfilePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectionMode", "ConnectionMode", cfn_parse.FromCloudFormation.getString(properties.ConnectionMode)), ret.addPropertyResult("connectorProfileName", "ConnectorProfileName", cfn_parse.FromCloudFormation.getString(properties.ConnectorProfileName)), ret.addPropertyResult("connectorType", "ConnectorType", cfn_parse.FromCloudFormation.getString(properties.ConnectorType)), ret.addPropertyResult("connectorLabel", "ConnectorLabel", properties.ConnectorLabel != null ? cfn_parse.FromCloudFormation.getString(properties.ConnectorLabel) : void 0), ret.addPropertyResult("connectorProfileConfig", "ConnectorProfileConfig", properties.ConnectorProfileConfig != null ? CfnConnectorProfileConnectorProfileConfigPropertyFromCloudFormation(properties.ConnectorProfileConfig) : void 0), ret.addPropertyResult("kmsArn", "KMSArn", properties.KMSArn != null ? cfn_parse.FromCloudFormation.getString(properties.KMSArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnConnectorProfile = class _CfnConnectorProfile extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnConnectorProfilePropsFromCloudFormation(resourceProperties), ret = new _CfnConnectorProfile(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnConnectorProfile.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appflow_CfnConnectorProfileProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnConnectorProfile), error;
        }
        cdk.requireProperty(props, "connectionMode", this), cdk.requireProperty(props, "connectorProfileName", this), cdk.requireProperty(props, "connectorType", this), this.attrConnectorProfileArn = cdk.Token.asString(this.getAtt("ConnectorProfileArn", cdk.ResolutionTypeHint.STRING)), this.attrCredentialsArn = cdk.Token.asString(this.getAtt("CredentialsArn", cdk.ResolutionTypeHint.STRING)), this.connectionMode = props.connectionMode, this.connectorProfileName = props.connectorProfileName, this.connectorType = props.connectorType, this.connectorLabel = props.connectorLabel, this.connectorProfileConfig = props.connectorProfileConfig, this.kmsArn = props.kmsArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnConnectorProfile.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { connectionMode: this.connectionMode, connectorProfileName: this.connectorProfileName, connectorType: this.connectorType, connectorLabel: this.connectorLabel, connectorProfileConfig: this.connectorProfileConfig, kmsArn: this.kmsArn };
      }
      renderProperties(props) {
        return cfnConnectorProfilePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnConnectorProfile[_b] = { fqn: "aws-cdk-lib.aws_appflow.CfnConnectorProfile", version: "2.80.0" }, CfnConnectorProfile.CFN_RESOURCE_TYPE_NAME = "AWS::AppFlow::ConnectorProfile", exports2.CfnConnectorProfile = CfnConnectorProfile;
    function CfnConnectorProfile_AmplitudeConnectorProfileCredentialsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiKey", cdk.requiredValidator)(properties.apiKey)), errors.collect(cdk.propertyValidator("apiKey", cdk.validateString)(properties.apiKey)), errors.collect(cdk.propertyValidator("secretKey", cdk.requiredValidator)(properties.secretKey)), errors.collect(cdk.propertyValidator("secretKey", cdk.validateString)(properties.secretKey)), errors.wrap('supplied properties not correct for "AmplitudeConnectorProfileCredentialsProperty"');
    }
    function cfnConnectorProfileAmplitudeConnectorProfileCredentialsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_AmplitudeConnectorProfileCredentialsPropertyValidator(properties).assertSuccess(), { ApiKey: cdk.stringToCloudFormation(properties.apiKey), SecretKey: cdk.stringToCloudFormation(properties.secretKey) }) : properties;
    }
    function CfnConnectorProfileAmplitudeConnectorProfileCredentialsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiKey", "ApiKey", cfn_parse.FromCloudFormation.getString(properties.ApiKey)), ret.addPropertyResult("secretKey", "SecretKey", cfn_parse.FromCloudFormation.getString(properties.SecretKey)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_ApiKeyCredentialsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiKey", cdk.requiredValidator)(properties.apiKey)), errors.collect(cdk.propertyValidator("apiKey", cdk.validateString)(properties.apiKey)), errors.collect(cdk.propertyValidator("apiSecretKey", cdk.validateString)(properties.apiSecretKey)), errors.wrap('supplied properties not correct for "ApiKeyCredentialsProperty"');
    }
    function cfnConnectorProfileApiKeyCredentialsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_ApiKeyCredentialsPropertyValidator(properties).assertSuccess(), { ApiKey: cdk.stringToCloudFormation(properties.apiKey), ApiSecretKey: cdk.stringToCloudFormation(properties.apiSecretKey) }) : properties;
    }
    function CfnConnectorProfileApiKeyCredentialsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiKey", "ApiKey", cfn_parse.FromCloudFormation.getString(properties.ApiKey)), ret.addPropertyResult("apiSecretKey", "ApiSecretKey", properties.ApiSecretKey != null ? cfn_parse.FromCloudFormation.getString(properties.ApiSecretKey) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_BasicAuthCredentialsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("password", cdk.requiredValidator)(properties.password)), errors.collect(cdk.propertyValidator("password", cdk.validateString)(properties.password)), errors.collect(cdk.propertyValidator("username", cdk.requiredValidator)(properties.username)), errors.collect(cdk.propertyValidator("username", cdk.validateString)(properties.username)), errors.wrap('supplied properties not correct for "BasicAuthCredentialsProperty"');
    }
    function cfnConnectorProfileBasicAuthCredentialsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_BasicAuthCredentialsPropertyValidator(properties).assertSuccess(), { Password: cdk.stringToCloudFormation(properties.password), Username: cdk.stringToCloudFormation(properties.username) }) : properties;
    }
    function CfnConnectorProfileBasicAuthCredentialsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("password", "Password", cfn_parse.FromCloudFormation.getString(properties.Password)), ret.addPropertyResult("username", "Username", cfn_parse.FromCloudFormation.getString(properties.Username)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_ConnectorOAuthRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authCode", cdk.validateString)(properties.authCode)), errors.collect(cdk.propertyValidator("redirectUri", cdk.validateString)(properties.redirectUri)), errors.wrap('supplied properties not correct for "ConnectorOAuthRequestProperty"');
    }
    function cfnConnectorProfileConnectorOAuthRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_ConnectorOAuthRequestPropertyValidator(properties).assertSuccess(), { AuthCode: cdk.stringToCloudFormation(properties.authCode), RedirectUri: cdk.stringToCloudFormation(properties.redirectUri) }) : properties;
    }
    function CfnConnectorProfileConnectorOAuthRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authCode", "AuthCode", properties.AuthCode != null ? cfn_parse.FromCloudFormation.getString(properties.AuthCode) : void 0), ret.addPropertyResult("redirectUri", "RedirectUri", properties.RedirectUri != null ? cfn_parse.FromCloudFormation.getString(properties.RedirectUri) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_ConnectorProfileConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectorProfileCredentials", CfnConnectorProfile_ConnectorProfileCredentialsPropertyValidator)(properties.connectorProfileCredentials)), errors.collect(cdk.propertyValidator("connectorProfileProperties", CfnConnectorProfile_ConnectorProfilePropertiesPropertyValidator)(properties.connectorProfileProperties)), errors.wrap('supplied properties not correct for "ConnectorProfileConfigProperty"');
    }
    function cfnConnectorProfileConnectorProfileConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_ConnectorProfileConfigPropertyValidator(properties).assertSuccess(), { ConnectorProfileCredentials: cfnConnectorProfileConnectorProfileCredentialsPropertyToCloudFormation(properties.connectorProfileCredentials), ConnectorProfileProperties: cfnConnectorProfileConnectorProfilePropertiesPropertyToCloudFormation(properties.connectorProfileProperties) }) : properties;
    }
    function CfnConnectorProfileConnectorProfileConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectorProfileCredentials", "ConnectorProfileCredentials", properties.ConnectorProfileCredentials != null ? CfnConnectorProfileConnectorProfileCredentialsPropertyFromCloudFormation(properties.ConnectorProfileCredentials) : void 0), ret.addPropertyResult("connectorProfileProperties", "ConnectorProfileProperties", properties.ConnectorProfileProperties != null ? CfnConnectorProfileConnectorProfilePropertiesPropertyFromCloudFormation(properties.ConnectorProfileProperties) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_ConnectorProfileCredentialsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("amplitude", CfnConnectorProfile_AmplitudeConnectorProfileCredentialsPropertyValidator)(properties.amplitude)), errors.collect(cdk.propertyValidator("customConnector", CfnConnectorProfile_CustomConnectorProfileCredentialsPropertyValidator)(properties.customConnector)), errors.collect(cdk.propertyValidator("datadog", CfnConnectorProfile_DatadogConnectorProfileCredentialsPropertyValidator)(properties.datadog)), errors.collect(cdk.propertyValidator("dynatrace", CfnConnectorProfile_DynatraceConnectorProfileCredentialsPropertyValidator)(properties.dynatrace)), errors.collect(cdk.propertyValidator("googleAnalytics", CfnConnectorProfile_GoogleAnalyticsConnectorProfileCredentialsPropertyValidator)(properties.googleAnalytics)), errors.collect(cdk.propertyValidator("inforNexus", CfnConnectorProfile_InforNexusConnectorProfileCredentialsPropertyValidator)(properties.inforNexus)), errors.collect(cdk.propertyValidator("marketo", CfnConnectorProfile_MarketoConnectorProfileCredentialsPropertyValidator)(properties.marketo)), errors.collect(cdk.propertyValidator("pardot", CfnConnectorProfile_PardotConnectorProfileCredentialsPropertyValidator)(properties.pardot)), errors.collect(cdk.propertyValidator("redshift", CfnConnectorProfile_RedshiftConnectorProfileCredentialsPropertyValidator)(properties.redshift)), errors.collect(cdk.propertyValidator("sapoData", CfnConnectorProfile_SAPODataConnectorProfileCredentialsPropertyValidator)(properties.sapoData)), errors.collect(cdk.propertyValidator("salesforce", CfnConnectorProfile_SalesforceConnectorProfileCredentialsPropertyValidator)(properties.salesforce)), errors.collect(cdk.propertyValidator("serviceNow", CfnConnectorProfile_ServiceNowConnectorProfileCredentialsPropertyValidator)(properties.serviceNow)), errors.collect(cdk.propertyValidator("singular", CfnConnectorProfile_SingularConnectorProfileCredentialsPropertyValidator)(properties.singular)), errors.collect(cdk.propertyValidator("slack", CfnConnectorProfile_SlackConnectorProfileCredentialsPropertyValidator)(properties.slack)), errors.collect(cdk.propertyValidator("snowflake", CfnConnectorProfile_SnowflakeConnectorProfileCredentialsPropertyValidator)(properties.snowflake)), errors.collect(cdk.propertyValidator("trendmicro", CfnConnectorProfile_TrendmicroConnectorProfileCredentialsPropertyValidator)(properties.trendmicro)), errors.collect(cdk.propertyValidator("veeva", CfnConnectorProfile_VeevaConnectorProfileCredentialsPropertyValidator)(properties.veeva)), errors.collect(cdk.propertyValidator("zendesk", CfnConnectorProfile_ZendeskConnectorProfileCredentialsPropertyValidator)(properties.zendesk)), errors.wrap('supplied properties not correct for "ConnectorProfileCredentialsProperty"');
    }
    function cfnConnectorProfileConnectorProfileCredentialsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_ConnectorProfileCredentialsPropertyValidator(properties).assertSuccess(), { Amplitude: cfnConnectorProfileAmplitudeConnectorProfileCredentialsPropertyToCloudFormation(properties.amplitude), CustomConnector: cfnConnectorProfileCustomConnectorProfileCredentialsPropertyToCloudFormation(properties.customConnector), Datadog: cfnConnectorProfileDatadogConnectorProfileCredentialsPropertyToCloudFormation(properties.datadog), Dynatrace: cfnConnectorProfileDynatraceConnectorProfileCredentialsPropertyToCloudFormation(properties.dynatrace), GoogleAnalytics: cfnConnectorProfileGoogleAnalyticsConnectorProfileCredentialsPropertyToCloudFormation(properties.googleAnalytics), InforNexus: cfnConnectorProfileInforNexusConnectorProfileCredentialsPropertyToCloudFormation(properties.inforNexus), Marketo: cfnConnectorProfileMarketoConnectorProfileCredentialsPropertyToCloudFormation(properties.marketo), Pardot: cfnConnectorProfilePardotConnectorProfileCredentialsPropertyToCloudFormation(properties.pardot), Redshift: cfnConnectorProfileRedshiftConnectorProfileCredentialsPropertyToCloudFormation(properties.redshift), SAPOData: cfnConnectorProfileSAPODataConnectorProfileCredentialsPropertyToCloudFormation(properties.sapoData), Salesforce: cfnConnectorProfileSalesforceConnectorProfileCredentialsPropertyToCloudFormation(properties.salesforce), ServiceNow: cfnConnectorProfileServiceNowConnectorProfileCredentialsPropertyToCloudFormation(properties.serviceNow), Singular: cfnConnectorProfileSingularConnectorProfileCredentialsPropertyToCloudFormation(properties.singular), Slack: cfnConnectorProfileSlackConnectorProfileCredentialsPropertyToCloudFormation(properties.slack), Snowflake: cfnConnectorProfileSnowflakeConnectorProfileCredentialsPropertyToCloudFormation(properties.snowflake), Trendmicro: cfnConnectorProfileTrendmicroConnectorProfileCredentialsPropertyToCloudFormation(properties.trendmicro), Veeva: cfnConnectorProfileVeevaConnectorProfileCredentialsPropertyToCloudFormation(properties.veeva), Zendesk: cfnConnectorProfileZendeskConnectorProfileCredentialsPropertyToCloudFormation(properties.zendesk) }) : properties;
    }
    function CfnConnectorProfileConnectorProfileCredentialsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("amplitude", "Amplitude", properties.Amplitude != null ? CfnConnectorProfileAmplitudeConnectorProfileCredentialsPropertyFromCloudFormation(properties.Amplitude) : void 0), ret.addPropertyResult("customConnector", "CustomConnector", properties.CustomConnector != null ? CfnConnectorProfileCustomConnectorProfileCredentialsPropertyFromCloudFormation(properties.CustomConnector) : void 0), ret.addPropertyResult("datadog", "Datadog", properties.Datadog != null ? CfnConnectorProfileDatadogConnectorProfileCredentialsPropertyFromCloudFormation(properties.Datadog) : void 0), ret.addPropertyResult("dynatrace", "Dynatrace", properties.Dynatrace != null ? CfnConnectorProfileDynatraceConnectorProfileCredentialsPropertyFromCloudFormation(properties.Dynatrace) : void 0), ret.addPropertyResult("googleAnalytics", "GoogleAnalytics", properties.GoogleAnalytics != null ? CfnConnectorProfileGoogleAnalyticsConnectorProfileCredentialsPropertyFromCloudFormation(properties.GoogleAnalytics) : void 0), ret.addPropertyResult("inforNexus", "InforNexus", properties.InforNexus != null ? CfnConnectorProfileInforNexusConnectorProfileCredentialsPropertyFromCloudFormation(properties.InforNexus) : void 0), ret.addPropertyResult("marketo", "Marketo", properties.Marketo != null ? CfnConnectorProfileMarketoConnectorProfileCredentialsPropertyFromCloudFormation(properties.Marketo) : void 0), ret.addPropertyResult("pardot", "Pardot", properties.Pardot != null ? CfnConnectorProfilePardotConnectorProfileCredentialsPropertyFromCloudFormation(properties.Pardot) : void 0), ret.addPropertyResult("redshift", "Redshift", properties.Redshift != null ? CfnConnectorProfileRedshiftConnectorProfileCredentialsPropertyFromCloudFormation(properties.Redshift) : void 0), ret.addPropertyResult("sapoData", "SAPOData", properties.SAPOData != null ? CfnConnectorProfileSAPODataConnectorProfileCredentialsPropertyFromCloudFormation(properties.SAPOData) : void 0), ret.addPropertyResult("salesforce", "Salesforce", properties.Salesforce != null ? CfnConnectorProfileSalesforceConnectorProfileCredentialsPropertyFromCloudFormation(properties.Salesforce) : void 0), ret.addPropertyResult("serviceNow", "ServiceNow", properties.ServiceNow != null ? CfnConnectorProfileServiceNowConnectorProfileCredentialsPropertyFromCloudFormation(properties.ServiceNow) : void 0), ret.addPropertyResult("singular", "Singular", properties.Singular != null ? CfnConnectorProfileSingularConnectorProfileCredentialsPropertyFromCloudFormation(properties.Singular) : void 0), ret.addPropertyResult("slack", "Slack", properties.Slack != null ? CfnConnectorProfileSlackConnectorProfileCredentialsPropertyFromCloudFormation(properties.Slack) : void 0), ret.addPropertyResult("snowflake", "Snowflake", properties.Snowflake != null ? CfnConnectorProfileSnowflakeConnectorProfileCredentialsPropertyFromCloudFormation(properties.Snowflake) : void 0), ret.addPropertyResult("trendmicro", "Trendmicro", properties.Trendmicro != null ? CfnConnectorProfileTrendmicroConnectorProfileCredentialsPropertyFromCloudFormation(properties.Trendmicro) : void 0), ret.addPropertyResult("veeva", "Veeva", properties.Veeva != null ? CfnConnectorProfileVeevaConnectorProfileCredentialsPropertyFromCloudFormation(properties.Veeva) : void 0), ret.addPropertyResult("zendesk", "Zendesk", properties.Zendesk != null ? CfnConnectorProfileZendeskConnectorProfileCredentialsPropertyFromCloudFormation(properties.Zendesk) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_ConnectorProfilePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customConnector", CfnConnectorProfile_CustomConnectorProfilePropertiesPropertyValidator)(properties.customConnector)), errors.collect(cdk.propertyValidator("datadog", CfnConnectorProfile_DatadogConnectorProfilePropertiesPropertyValidator)(properties.datadog)), errors.collect(cdk.propertyValidator("dynatrace", CfnConnectorProfile_DynatraceConnectorProfilePropertiesPropertyValidator)(properties.dynatrace)), errors.collect(cdk.propertyValidator("inforNexus", CfnConnectorProfile_InforNexusConnectorProfilePropertiesPropertyValidator)(properties.inforNexus)), errors.collect(cdk.propertyValidator("marketo", CfnConnectorProfile_MarketoConnectorProfilePropertiesPropertyValidator)(properties.marketo)), errors.collect(cdk.propertyValidator("pardot", CfnConnectorProfile_PardotConnectorProfilePropertiesPropertyValidator)(properties.pardot)), errors.collect(cdk.propertyValidator("redshift", CfnConnectorProfile_RedshiftConnectorProfilePropertiesPropertyValidator)(properties.redshift)), errors.collect(cdk.propertyValidator("sapoData", CfnConnectorProfile_SAPODataConnectorProfilePropertiesPropertyValidator)(properties.sapoData)), errors.collect(cdk.propertyValidator("salesforce", CfnConnectorProfile_SalesforceConnectorProfilePropertiesPropertyValidator)(properties.salesforce)), errors.collect(cdk.propertyValidator("serviceNow", CfnConnectorProfile_ServiceNowConnectorProfilePropertiesPropertyValidator)(properties.serviceNow)), errors.collect(cdk.propertyValidator("slack", CfnConnectorProfile_SlackConnectorProfilePropertiesPropertyValidator)(properties.slack)), errors.collect(cdk.propertyValidator("snowflake", CfnConnectorProfile_SnowflakeConnectorProfilePropertiesPropertyValidator)(properties.snowflake)), errors.collect(cdk.propertyValidator("veeva", CfnConnectorProfile_VeevaConnectorProfilePropertiesPropertyValidator)(properties.veeva)), errors.collect(cdk.propertyValidator("zendesk", CfnConnectorProfile_ZendeskConnectorProfilePropertiesPropertyValidator)(properties.zendesk)), errors.wrap('supplied properties not correct for "ConnectorProfilePropertiesProperty"');
    }
    function cfnConnectorProfileConnectorProfilePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_ConnectorProfilePropertiesPropertyValidator(properties).assertSuccess(), { CustomConnector: cfnConnectorProfileCustomConnectorProfilePropertiesPropertyToCloudFormation(properties.customConnector), Datadog: cfnConnectorProfileDatadogConnectorProfilePropertiesPropertyToCloudFormation(properties.datadog), Dynatrace: cfnConnectorProfileDynatraceConnectorProfilePropertiesPropertyToCloudFormation(properties.dynatrace), InforNexus: cfnConnectorProfileInforNexusConnectorProfilePropertiesPropertyToCloudFormation(properties.inforNexus), Marketo: cfnConnectorProfileMarketoConnectorProfilePropertiesPropertyToCloudFormation(properties.marketo), Pardot: cfnConnectorProfilePardotConnectorProfilePropertiesPropertyToCloudFormation(properties.pardot), Redshift: cfnConnectorProfileRedshiftConnectorProfilePropertiesPropertyToCloudFormation(properties.redshift), SAPOData: cfnConnectorProfileSAPODataConnectorProfilePropertiesPropertyToCloudFormation(properties.sapoData), Salesforce: cfnConnectorProfileSalesforceConnectorProfilePropertiesPropertyToCloudFormation(properties.salesforce), ServiceNow: cfnConnectorProfileServiceNowConnectorProfilePropertiesPropertyToCloudFormation(properties.serviceNow), Slack: cfnConnectorProfileSlackConnectorProfilePropertiesPropertyToCloudFormation(properties.slack), Snowflake: cfnConnectorProfileSnowflakeConnectorProfilePropertiesPropertyToCloudFormation(properties.snowflake), Veeva: cfnConnectorProfileVeevaConnectorProfilePropertiesPropertyToCloudFormation(properties.veeva), Zendesk: cfnConnectorProfileZendeskConnectorProfilePropertiesPropertyToCloudFormation(properties.zendesk) }) : properties;
    }
    function CfnConnectorProfileConnectorProfilePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customConnector", "CustomConnector", properties.CustomConnector != null ? CfnConnectorProfileCustomConnectorProfilePropertiesPropertyFromCloudFormation(properties.CustomConnector) : void 0), ret.addPropertyResult("datadog", "Datadog", properties.Datadog != null ? CfnConnectorProfileDatadogConnectorProfilePropertiesPropertyFromCloudFormation(properties.Datadog) : void 0), ret.addPropertyResult("dynatrace", "Dynatrace", properties.Dynatrace != null ? CfnConnectorProfileDynatraceConnectorProfilePropertiesPropertyFromCloudFormation(properties.Dynatrace) : void 0), ret.addPropertyResult("inforNexus", "InforNexus", properties.InforNexus != null ? CfnConnectorProfileInforNexusConnectorProfilePropertiesPropertyFromCloudFormation(properties.InforNexus) : void 0), ret.addPropertyResult("marketo", "Marketo", properties.Marketo != null ? CfnConnectorProfileMarketoConnectorProfilePropertiesPropertyFromCloudFormation(properties.Marketo) : void 0), ret.addPropertyResult("pardot", "Pardot", properties.Pardot != null ? CfnConnectorProfilePardotConnectorProfilePropertiesPropertyFromCloudFormation(properties.Pardot) : void 0), ret.addPropertyResult("redshift", "Redshift", properties.Redshift != null ? CfnConnectorProfileRedshiftConnectorProfilePropertiesPropertyFromCloudFormation(properties.Redshift) : void 0), ret.addPropertyResult("sapoData", "SAPOData", properties.SAPOData != null ? CfnConnectorProfileSAPODataConnectorProfilePropertiesPropertyFromCloudFormation(properties.SAPOData) : void 0), ret.addPropertyResult("salesforce", "Salesforce", properties.Salesforce != null ? CfnConnectorProfileSalesforceConnectorProfilePropertiesPropertyFromCloudFormation(properties.Salesforce) : void 0), ret.addPropertyResult("serviceNow", "ServiceNow", properties.ServiceNow != null ? CfnConnectorProfileServiceNowConnectorProfilePropertiesPropertyFromCloudFormation(properties.ServiceNow) : void 0), ret.addPropertyResult("slack", "Slack", properties.Slack != null ? CfnConnectorProfileSlackConnectorProfilePropertiesPropertyFromCloudFormation(properties.Slack) : void 0), ret.addPropertyResult("snowflake", "Snowflake", properties.Snowflake != null ? CfnConnectorProfileSnowflakeConnectorProfilePropertiesPropertyFromCloudFormation(properties.Snowflake) : void 0), ret.addPropertyResult("veeva", "Veeva", properties.Veeva != null ? CfnConnectorProfileVeevaConnectorProfilePropertiesPropertyFromCloudFormation(properties.Veeva) : void 0), ret.addPropertyResult("zendesk", "Zendesk", properties.Zendesk != null ? CfnConnectorProfileZendeskConnectorProfilePropertiesPropertyFromCloudFormation(properties.Zendesk) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_CustomAuthCredentialsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("credentialsMap", cdk.hashValidator(cdk.validateString))(properties.credentialsMap)), errors.collect(cdk.propertyValidator("customAuthenticationType", cdk.requiredValidator)(properties.customAuthenticationType)), errors.collect(cdk.propertyValidator("customAuthenticationType", cdk.validateString)(properties.customAuthenticationType)), errors.wrap('supplied properties not correct for "CustomAuthCredentialsProperty"');
    }
    function cfnConnectorProfileCustomAuthCredentialsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_CustomAuthCredentialsPropertyValidator(properties).assertSuccess(), { CredentialsMap: cdk.hashMapper(cdk.stringToCloudFormation)(properties.credentialsMap), CustomAuthenticationType: cdk.stringToCloudFormation(properties.customAuthenticationType) }) : properties;
    }
    function CfnConnectorProfileCustomAuthCredentialsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("credentialsMap", "CredentialsMap", properties.CredentialsMap != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.CredentialsMap) : void 0), ret.addPropertyResult("customAuthenticationType", "CustomAuthenticationType", cfn_parse.FromCloudFormation.getString(properties.CustomAuthenticationType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_CustomConnectorProfileCredentialsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiKey", CfnConnectorProfile_ApiKeyCredentialsPropertyValidator)(properties.apiKey)), errors.collect(cdk.propertyValidator("authenticationType", cdk.requiredValidator)(properties.authenticationType)), errors.collect(cdk.propertyValidator("authenticationType", cdk.validateString)(properties.authenticationType)), errors.collect(cdk.propertyValidator("basic", CfnConnectorProfile_BasicAuthCredentialsPropertyValidator)(properties.basic)), errors.collect(cdk.propertyValidator("custom", CfnConnectorProfile_CustomAuthCredentialsPropertyValidator)(properties.custom)), errors.collect(cdk.propertyValidator("oauth2", CfnConnectorProfile_OAuth2CredentialsPropertyValidator)(properties.oauth2)), errors.wrap('supplied properties not correct for "CustomConnectorProfileCredentialsProperty"');
    }
    function cfnConnectorProfileCustomConnectorProfileCredentialsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_CustomConnectorProfileCredentialsPropertyValidator(properties).assertSuccess(), { ApiKey: cfnConnectorProfileApiKeyCredentialsPropertyToCloudFormation(properties.apiKey), AuthenticationType: cdk.stringToCloudFormation(properties.authenticationType), Basic: cfnConnectorProfileBasicAuthCredentialsPropertyToCloudFormation(properties.basic), Custom: cfnConnectorProfileCustomAuthCredentialsPropertyToCloudFormation(properties.custom), Oauth2: cfnConnectorProfileOAuth2CredentialsPropertyToCloudFormation(properties.oauth2) }) : properties;
    }
    function CfnConnectorProfileCustomConnectorProfileCredentialsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiKey", "ApiKey", properties.ApiKey != null ? CfnConnectorProfileApiKeyCredentialsPropertyFromCloudFormation(properties.ApiKey) : void 0), ret.addPropertyResult("authenticationType", "AuthenticationType", cfn_parse.FromCloudFormation.getString(properties.AuthenticationType)), ret.addPropertyResult("basic", "Basic", properties.Basic != null ? CfnConnectorProfileBasicAuthCredentialsPropertyFromCloudFormation(properties.Basic) : void 0), ret.addPropertyResult("custom", "Custom", properties.Custom != null ? CfnConnectorProfileCustomAuthCredentialsPropertyFromCloudFormation(properties.Custom) : void 0), ret.addPropertyResult("oauth2", "Oauth2", properties.Oauth2 != null ? CfnConnectorProfileOAuth2CredentialsPropertyFromCloudFormation(properties.Oauth2) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_CustomConnectorProfilePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("oAuth2Properties", CfnConnectorProfile_OAuth2PropertiesPropertyValidator)(properties.oAuth2Properties)), errors.collect(cdk.propertyValidator("profileProperties", cdk.hashValidator(cdk.validateString))(properties.profileProperties)), errors.wrap('supplied properties not correct for "CustomConnectorProfilePropertiesProperty"');
    }
    function cfnConnectorProfileCustomConnectorProfilePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_CustomConnectorProfilePropertiesPropertyValidator(properties).assertSuccess(), { OAuth2Properties: cfnConnectorProfileOAuth2PropertiesPropertyToCloudFormation(properties.oAuth2Properties), ProfileProperties: cdk.hashMapper(cdk.stringToCloudFormation)(properties.profileProperties) }) : properties;
    }
    function CfnConnectorProfileCustomConnectorProfilePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("oAuth2Properties", "OAuth2Properties", properties.OAuth2Properties != null ? CfnConnectorProfileOAuth2PropertiesPropertyFromCloudFormation(properties.OAuth2Properties) : void 0), ret.addPropertyResult("profileProperties", "ProfileProperties", properties.ProfileProperties != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.ProfileProperties) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_DatadogConnectorProfileCredentialsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiKey", cdk.requiredValidator)(properties.apiKey)), errors.collect(cdk.propertyValidator("apiKey", cdk.validateString)(properties.apiKey)), errors.collect(cdk.propertyValidator("applicationKey", cdk.requiredValidator)(properties.applicationKey)), errors.collect(cdk.propertyValidator("applicationKey", cdk.validateString)(properties.applicationKey)), errors.wrap('supplied properties not correct for "DatadogConnectorProfileCredentialsProperty"');
    }
    function cfnConnectorProfileDatadogConnectorProfileCredentialsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_DatadogConnectorProfileCredentialsPropertyValidator(properties).assertSuccess(), { ApiKey: cdk.stringToCloudFormation(properties.apiKey), ApplicationKey: cdk.stringToCloudFormation(properties.applicationKey) }) : properties;
    }
    function CfnConnectorProfileDatadogConnectorProfileCredentialsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiKey", "ApiKey", cfn_parse.FromCloudFormation.getString(properties.ApiKey)), ret.addPropertyResult("applicationKey", "ApplicationKey", cfn_parse.FromCloudFormation.getString(properties.ApplicationKey)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_DatadogConnectorProfilePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceUrl", cdk.requiredValidator)(properties.instanceUrl)), errors.collect(cdk.propertyValidator("instanceUrl", cdk.validateString)(properties.instanceUrl)), errors.wrap('supplied properties not correct for "DatadogConnectorProfilePropertiesProperty"');
    }
    function cfnConnectorProfileDatadogConnectorProfilePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_DatadogConnectorProfilePropertiesPropertyValidator(properties).assertSuccess(), { InstanceUrl: cdk.stringToCloudFormation(properties.instanceUrl) }) : properties;
    }
    function CfnConnectorProfileDatadogConnectorProfilePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceUrl", "InstanceUrl", cfn_parse.FromCloudFormation.getString(properties.InstanceUrl)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_DynatraceConnectorProfileCredentialsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiToken", cdk.requiredValidator)(properties.apiToken)), errors.collect(cdk.propertyValidator("apiToken", cdk.validateString)(properties.apiToken)), errors.wrap('supplied properties not correct for "DynatraceConnectorProfileCredentialsProperty"');
    }
    function cfnConnectorProfileDynatraceConnectorProfileCredentialsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_DynatraceConnectorProfileCredentialsPropertyValidator(properties).assertSuccess(), { ApiToken: cdk.stringToCloudFormation(properties.apiToken) }) : properties;
    }
    function CfnConnectorProfileDynatraceConnectorProfileCredentialsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiToken", "ApiToken", cfn_parse.FromCloudFormation.getString(properties.ApiToken)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_DynatraceConnectorProfilePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceUrl", cdk.requiredValidator)(properties.instanceUrl)), errors.collect(cdk.propertyValidator("instanceUrl", cdk.validateString)(properties.instanceUrl)), errors.wrap('supplied properties not correct for "DynatraceConnectorProfilePropertiesProperty"');
    }
    function cfnConnectorProfileDynatraceConnectorProfilePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_DynatraceConnectorProfilePropertiesPropertyValidator(properties).assertSuccess(), { InstanceUrl: cdk.stringToCloudFormation(properties.instanceUrl) }) : properties;
    }
    function CfnConnectorProfileDynatraceConnectorProfilePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceUrl", "InstanceUrl", cfn_parse.FromCloudFormation.getString(properties.InstanceUrl)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_GoogleAnalyticsConnectorProfileCredentialsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessToken", cdk.validateString)(properties.accessToken)), errors.collect(cdk.propertyValidator("clientId", cdk.requiredValidator)(properties.clientId)), errors.collect(cdk.propertyValidator("clientId", cdk.validateString)(properties.clientId)), errors.collect(cdk.propertyValidator("clientSecret", cdk.requiredValidator)(properties.clientSecret)), errors.collect(cdk.propertyValidator("clientSecret", cdk.validateString)(properties.clientSecret)), errors.collect(cdk.propertyValidator("connectorOAuthRequest", CfnConnectorProfile_ConnectorOAuthRequestPropertyValidator)(properties.connectorOAuthRequest)), errors.collect(cdk.propertyValidator("refreshToken", cdk.validateString)(properties.refreshToken)), errors.wrap('supplied properties not correct for "GoogleAnalyticsConnectorProfileCredentialsProperty"');
    }
    function cfnConnectorProfileGoogleAnalyticsConnectorProfileCredentialsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_GoogleAnalyticsConnectorProfileCredentialsPropertyValidator(properties).assertSuccess(), { AccessToken: cdk.stringToCloudFormation(properties.accessToken), ClientId: cdk.stringToCloudFormation(properties.clientId), ClientSecret: cdk.stringToCloudFormation(properties.clientSecret), ConnectorOAuthRequest: cfnConnectorProfileConnectorOAuthRequestPropertyToCloudFormation(properties.connectorOAuthRequest), RefreshToken: cdk.stringToCloudFormation(properties.refreshToken) }) : properties;
    }
    function CfnConnectorProfileGoogleAnalyticsConnectorProfileCredentialsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessToken", "AccessToken", properties.AccessToken != null ? cfn_parse.FromCloudFormation.getString(properties.AccessToken) : void 0), ret.addPropertyResult("clientId", "ClientId", cfn_parse.FromCloudFormation.getString(properties.ClientId)), ret.addPropertyResult("clientSecret", "ClientSecret", cfn_parse.FromCloudFormation.getString(properties.ClientSecret)), ret.addPropertyResult("connectorOAuthRequest", "ConnectorOAuthRequest", properties.ConnectorOAuthRequest != null ? CfnConnectorProfileConnectorOAuthRequestPropertyFromCloudFormation(properties.ConnectorOAuthRequest) : void 0), ret.addPropertyResult("refreshToken", "RefreshToken", properties.RefreshToken != null ? cfn_parse.FromCloudFormation.getString(properties.RefreshToken) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_InforNexusConnectorProfileCredentialsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessKeyId", cdk.requiredValidator)(properties.accessKeyId)), errors.collect(cdk.propertyValidator("accessKeyId", cdk.validateString)(properties.accessKeyId)), errors.collect(cdk.propertyValidator("datakey", cdk.requiredValidator)(properties.datakey)), errors.collect(cdk.propertyValidator("datakey", cdk.validateString)(properties.datakey)), errors.collect(cdk.propertyValidator("secretAccessKey", cdk.requiredValidator)(properties.secretAccessKey)), errors.collect(cdk.propertyValidator("secretAccessKey", cdk.validateString)(properties.secretAccessKey)), errors.collect(cdk.propertyValidator("userId", cdk.requiredValidator)(properties.userId)), errors.collect(cdk.propertyValidator("userId", cdk.validateString)(properties.userId)), errors.wrap('supplied properties not correct for "InforNexusConnectorProfileCredentialsProperty"');
    }
    function cfnConnectorProfileInforNexusConnectorProfileCredentialsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_InforNexusConnectorProfileCredentialsPropertyValidator(properties).assertSuccess(), { AccessKeyId: cdk.stringToCloudFormation(properties.accessKeyId), Datakey: cdk.stringToCloudFormation(properties.datakey), SecretAccessKey: cdk.stringToCloudFormation(properties.secretAccessKey), UserId: cdk.stringToCloudFormation(properties.userId) }) : properties;
    }
    function CfnConnectorProfileInforNexusConnectorProfileCredentialsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessKeyId", "AccessKeyId", cfn_parse.FromCloudFormation.getString(properties.AccessKeyId)), ret.addPropertyResult("datakey", "Datakey", cfn_parse.FromCloudFormation.getString(properties.Datakey)), ret.addPropertyResult("secretAccessKey", "SecretAccessKey", cfn_parse.FromCloudFormation.getString(properties.SecretAccessKey)), ret.addPropertyResult("userId", "UserId", cfn_parse.FromCloudFormation.getString(properties.UserId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_InforNexusConnectorProfilePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceUrl", cdk.requiredValidator)(properties.instanceUrl)), errors.collect(cdk.propertyValidator("instanceUrl", cdk.validateString)(properties.instanceUrl)), errors.wrap('supplied properties not correct for "InforNexusConnectorProfilePropertiesProperty"');
    }
    function cfnConnectorProfileInforNexusConnectorProfilePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_InforNexusConnectorProfilePropertiesPropertyValidator(properties).assertSuccess(), { InstanceUrl: cdk.stringToCloudFormation(properties.instanceUrl) }) : properties;
    }
    function CfnConnectorProfileInforNexusConnectorProfilePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceUrl", "InstanceUrl", cfn_parse.FromCloudFormation.getString(properties.InstanceUrl)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_MarketoConnectorProfileCredentialsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessToken", cdk.validateString)(properties.accessToken)), errors.collect(cdk.propertyValidator("clientId", cdk.requiredValidator)(properties.clientId)), errors.collect(cdk.propertyValidator("clientId", cdk.validateString)(properties.clientId)), errors.collect(cdk.propertyValidator("clientSecret", cdk.requiredValidator)(properties.clientSecret)), errors.collect(cdk.propertyValidator("clientSecret", cdk.validateString)(properties.clientSecret)), errors.collect(cdk.propertyValidator("connectorOAuthRequest", CfnConnectorProfile_ConnectorOAuthRequestPropertyValidator)(properties.connectorOAuthRequest)), errors.wrap('supplied properties not correct for "MarketoConnectorProfileCredentialsProperty"');
    }
    function cfnConnectorProfileMarketoConnectorProfileCredentialsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_MarketoConnectorProfileCredentialsPropertyValidator(properties).assertSuccess(), { AccessToken: cdk.stringToCloudFormation(properties.accessToken), ClientId: cdk.stringToCloudFormation(properties.clientId), ClientSecret: cdk.stringToCloudFormation(properties.clientSecret), ConnectorOAuthRequest: cfnConnectorProfileConnectorOAuthRequestPropertyToCloudFormation(properties.connectorOAuthRequest) }) : properties;
    }
    function CfnConnectorProfileMarketoConnectorProfileCredentialsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessToken", "AccessToken", properties.AccessToken != null ? cfn_parse.FromCloudFormation.getString(properties.AccessToken) : void 0), ret.addPropertyResult("clientId", "ClientId", cfn_parse.FromCloudFormation.getString(properties.ClientId)), ret.addPropertyResult("clientSecret", "ClientSecret", cfn_parse.FromCloudFormation.getString(properties.ClientSecret)), ret.addPropertyResult("connectorOAuthRequest", "ConnectorOAuthRequest", properties.ConnectorOAuthRequest != null ? CfnConnectorProfileConnectorOAuthRequestPropertyFromCloudFormation(properties.ConnectorOAuthRequest) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_MarketoConnectorProfilePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceUrl", cdk.requiredValidator)(properties.instanceUrl)), errors.collect(cdk.propertyValidator("instanceUrl", cdk.validateString)(properties.instanceUrl)), errors.wrap('supplied properties not correct for "MarketoConnectorProfilePropertiesProperty"');
    }
    function cfnConnectorProfileMarketoConnectorProfilePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_MarketoConnectorProfilePropertiesPropertyValidator(properties).assertSuccess(), { InstanceUrl: cdk.stringToCloudFormation(properties.instanceUrl) }) : properties;
    }
    function CfnConnectorProfileMarketoConnectorProfilePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceUrl", "InstanceUrl", cfn_parse.FromCloudFormation.getString(properties.InstanceUrl)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_OAuth2CredentialsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessToken", cdk.validateString)(properties.accessToken)), errors.collect(cdk.propertyValidator("clientId", cdk.validateString)(properties.clientId)), errors.collect(cdk.propertyValidator("clientSecret", cdk.validateString)(properties.clientSecret)), errors.collect(cdk.propertyValidator("oAuthRequest", CfnConnectorProfile_ConnectorOAuthRequestPropertyValidator)(properties.oAuthRequest)), errors.collect(cdk.propertyValidator("refreshToken", cdk.validateString)(properties.refreshToken)), errors.wrap('supplied properties not correct for "OAuth2CredentialsProperty"');
    }
    function cfnConnectorProfileOAuth2CredentialsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_OAuth2CredentialsPropertyValidator(properties).assertSuccess(), { AccessToken: cdk.stringToCloudFormation(properties.accessToken), ClientId: cdk.stringToCloudFormation(properties.clientId), ClientSecret: cdk.stringToCloudFormation(properties.clientSecret), OAuthRequest: cfnConnectorProfileConnectorOAuthRequestPropertyToCloudFormation(properties.oAuthRequest), RefreshToken: cdk.stringToCloudFormation(properties.refreshToken) }) : properties;
    }
    function CfnConnectorProfileOAuth2CredentialsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessToken", "AccessToken", properties.AccessToken != null ? cfn_parse.FromCloudFormation.getString(properties.AccessToken) : void 0), ret.addPropertyResult("clientId", "ClientId", properties.ClientId != null ? cfn_parse.FromCloudFormation.getString(properties.ClientId) : void 0), ret.addPropertyResult("clientSecret", "ClientSecret", properties.ClientSecret != null ? cfn_parse.FromCloudFormation.getString(properties.ClientSecret) : void 0), ret.addPropertyResult("oAuthRequest", "OAuthRequest", properties.OAuthRequest != null ? CfnConnectorProfileConnectorOAuthRequestPropertyFromCloudFormation(properties.OAuthRequest) : void 0), ret.addPropertyResult("refreshToken", "RefreshToken", properties.RefreshToken != null ? cfn_parse.FromCloudFormation.getString(properties.RefreshToken) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_OAuth2PropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("oAuth2GrantType", cdk.validateString)(properties.oAuth2GrantType)), errors.collect(cdk.propertyValidator("tokenUrl", cdk.validateString)(properties.tokenUrl)), errors.collect(cdk.propertyValidator("tokenUrlCustomProperties", cdk.hashValidator(cdk.validateString))(properties.tokenUrlCustomProperties)), errors.wrap('supplied properties not correct for "OAuth2PropertiesProperty"');
    }
    function cfnConnectorProfileOAuth2PropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_OAuth2PropertiesPropertyValidator(properties).assertSuccess(), { OAuth2GrantType: cdk.stringToCloudFormation(properties.oAuth2GrantType), TokenUrl: cdk.stringToCloudFormation(properties.tokenUrl), TokenUrlCustomProperties: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tokenUrlCustomProperties) }) : properties;
    }
    function CfnConnectorProfileOAuth2PropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("oAuth2GrantType", "OAuth2GrantType", properties.OAuth2GrantType != null ? cfn_parse.FromCloudFormation.getString(properties.OAuth2GrantType) : void 0), ret.addPropertyResult("tokenUrl", "TokenUrl", properties.TokenUrl != null ? cfn_parse.FromCloudFormation.getString(properties.TokenUrl) : void 0), ret.addPropertyResult("tokenUrlCustomProperties", "TokenUrlCustomProperties", properties.TokenUrlCustomProperties != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.TokenUrlCustomProperties) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_OAuthCredentialsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessToken", cdk.validateString)(properties.accessToken)), errors.collect(cdk.propertyValidator("clientId", cdk.validateString)(properties.clientId)), errors.collect(cdk.propertyValidator("clientSecret", cdk.validateString)(properties.clientSecret)), errors.collect(cdk.propertyValidator("connectorOAuthRequest", CfnConnectorProfile_ConnectorOAuthRequestPropertyValidator)(properties.connectorOAuthRequest)), errors.collect(cdk.propertyValidator("refreshToken", cdk.validateString)(properties.refreshToken)), errors.wrap('supplied properties not correct for "OAuthCredentialsProperty"');
    }
    function cfnConnectorProfileOAuthCredentialsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_OAuthCredentialsPropertyValidator(properties).assertSuccess(), { AccessToken: cdk.stringToCloudFormation(properties.accessToken), ClientId: cdk.stringToCloudFormation(properties.clientId), ClientSecret: cdk.stringToCloudFormation(properties.clientSecret), ConnectorOAuthRequest: cfnConnectorProfileConnectorOAuthRequestPropertyToCloudFormation(properties.connectorOAuthRequest), RefreshToken: cdk.stringToCloudFormation(properties.refreshToken) }) : properties;
    }
    function CfnConnectorProfileOAuthCredentialsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessToken", "AccessToken", properties.AccessToken != null ? cfn_parse.FromCloudFormation.getString(properties.AccessToken) : void 0), ret.addPropertyResult("clientId", "ClientId", properties.ClientId != null ? cfn_parse.FromCloudFormation.getString(properties.ClientId) : void 0), ret.addPropertyResult("clientSecret", "ClientSecret", properties.ClientSecret != null ? cfn_parse.FromCloudFormation.getString(properties.ClientSecret) : void 0), ret.addPropertyResult("connectorOAuthRequest", "ConnectorOAuthRequest", properties.ConnectorOAuthRequest != null ? CfnConnectorProfileConnectorOAuthRequestPropertyFromCloudFormation(properties.ConnectorOAuthRequest) : void 0), ret.addPropertyResult("refreshToken", "RefreshToken", properties.RefreshToken != null ? cfn_parse.FromCloudFormation.getString(properties.RefreshToken) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_OAuthPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authCodeUrl", cdk.validateString)(properties.authCodeUrl)), errors.collect(cdk.propertyValidator("oAuthScopes", cdk.listValidator(cdk.validateString))(properties.oAuthScopes)), errors.collect(cdk.propertyValidator("tokenUrl", cdk.validateString)(properties.tokenUrl)), errors.wrap('supplied properties not correct for "OAuthPropertiesProperty"');
    }
    function cfnConnectorProfileOAuthPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_OAuthPropertiesPropertyValidator(properties).assertSuccess(), { AuthCodeUrl: cdk.stringToCloudFormation(properties.authCodeUrl), OAuthScopes: cdk.listMapper(cdk.stringToCloudFormation)(properties.oAuthScopes), TokenUrl: cdk.stringToCloudFormation(properties.tokenUrl) }) : properties;
    }
    function CfnConnectorProfileOAuthPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authCodeUrl", "AuthCodeUrl", properties.AuthCodeUrl != null ? cfn_parse.FromCloudFormation.getString(properties.AuthCodeUrl) : void 0), ret.addPropertyResult("oAuthScopes", "OAuthScopes", properties.OAuthScopes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.OAuthScopes) : void 0), ret.addPropertyResult("tokenUrl", "TokenUrl", properties.TokenUrl != null ? cfn_parse.FromCloudFormation.getString(properties.TokenUrl) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_PardotConnectorProfileCredentialsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessToken", cdk.validateString)(properties.accessToken)), errors.collect(cdk.propertyValidator("clientCredentialsArn", cdk.validateString)(properties.clientCredentialsArn)), errors.collect(cdk.propertyValidator("connectorOAuthRequest", CfnConnectorProfile_ConnectorOAuthRequestPropertyValidator)(properties.connectorOAuthRequest)), errors.collect(cdk.propertyValidator("refreshToken", cdk.validateString)(properties.refreshToken)), errors.wrap('supplied properties not correct for "PardotConnectorProfileCredentialsProperty"');
    }
    function cfnConnectorProfilePardotConnectorProfileCredentialsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_PardotConnectorProfileCredentialsPropertyValidator(properties).assertSuccess(), { AccessToken: cdk.stringToCloudFormation(properties.accessToken), ClientCredentialsArn: cdk.stringToCloudFormation(properties.clientCredentialsArn), ConnectorOAuthRequest: cfnConnectorProfileConnectorOAuthRequestPropertyToCloudFormation(properties.connectorOAuthRequest), RefreshToken: cdk.stringToCloudFormation(properties.refreshToken) }) : properties;
    }
    function CfnConnectorProfilePardotConnectorProfileCredentialsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessToken", "AccessToken", properties.AccessToken != null ? cfn_parse.FromCloudFormation.getString(properties.AccessToken) : void 0), ret.addPropertyResult("clientCredentialsArn", "ClientCredentialsArn", properties.ClientCredentialsArn != null ? cfn_parse.FromCloudFormation.getString(properties.ClientCredentialsArn) : void 0), ret.addPropertyResult("connectorOAuthRequest", "ConnectorOAuthRequest", properties.ConnectorOAuthRequest != null ? CfnConnectorProfileConnectorOAuthRequestPropertyFromCloudFormation(properties.ConnectorOAuthRequest) : void 0), ret.addPropertyResult("refreshToken", "RefreshToken", properties.RefreshToken != null ? cfn_parse.FromCloudFormation.getString(properties.RefreshToken) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_PardotConnectorProfilePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("businessUnitId", cdk.requiredValidator)(properties.businessUnitId)), errors.collect(cdk.propertyValidator("businessUnitId", cdk.validateString)(properties.businessUnitId)), errors.collect(cdk.propertyValidator("instanceUrl", cdk.validateString)(properties.instanceUrl)), errors.collect(cdk.propertyValidator("isSandboxEnvironment", cdk.validateBoolean)(properties.isSandboxEnvironment)), errors.wrap('supplied properties not correct for "PardotConnectorProfilePropertiesProperty"');
    }
    function cfnConnectorProfilePardotConnectorProfilePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_PardotConnectorProfilePropertiesPropertyValidator(properties).assertSuccess(), { BusinessUnitId: cdk.stringToCloudFormation(properties.businessUnitId), InstanceUrl: cdk.stringToCloudFormation(properties.instanceUrl), IsSandboxEnvironment: cdk.booleanToCloudFormation(properties.isSandboxEnvironment) }) : properties;
    }
    function CfnConnectorProfilePardotConnectorProfilePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("businessUnitId", "BusinessUnitId", cfn_parse.FromCloudFormation.getString(properties.BusinessUnitId)), ret.addPropertyResult("instanceUrl", "InstanceUrl", properties.InstanceUrl != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceUrl) : void 0), ret.addPropertyResult("isSandboxEnvironment", "IsSandboxEnvironment", properties.IsSandboxEnvironment != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsSandboxEnvironment) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_RedshiftConnectorProfileCredentialsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("password", cdk.validateString)(properties.password)), errors.collect(cdk.propertyValidator("username", cdk.validateString)(properties.username)), errors.wrap('supplied properties not correct for "RedshiftConnectorProfileCredentialsProperty"');
    }
    function cfnConnectorProfileRedshiftConnectorProfileCredentialsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_RedshiftConnectorProfileCredentialsPropertyValidator(properties).assertSuccess(), { Password: cdk.stringToCloudFormation(properties.password), Username: cdk.stringToCloudFormation(properties.username) }) : properties;
    }
    function CfnConnectorProfileRedshiftConnectorProfileCredentialsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("password", "Password", properties.Password != null ? cfn_parse.FromCloudFormation.getString(properties.Password) : void 0), ret.addPropertyResult("username", "Username", properties.Username != null ? cfn_parse.FromCloudFormation.getString(properties.Username) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_RedshiftConnectorProfilePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketName", cdk.requiredValidator)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketPrefix", cdk.validateString)(properties.bucketPrefix)), errors.collect(cdk.propertyValidator("clusterIdentifier", cdk.validateString)(properties.clusterIdentifier)), errors.collect(cdk.propertyValidator("dataApiRoleArn", cdk.validateString)(properties.dataApiRoleArn)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("databaseUrl", cdk.validateString)(properties.databaseUrl)), errors.collect(cdk.propertyValidator("isRedshiftServerless", cdk.validateBoolean)(properties.isRedshiftServerless)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("workgroupName", cdk.validateString)(properties.workgroupName)), errors.wrap('supplied properties not correct for "RedshiftConnectorProfilePropertiesProperty"');
    }
    function cfnConnectorProfileRedshiftConnectorProfilePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_RedshiftConnectorProfilePropertiesPropertyValidator(properties).assertSuccess(), { BucketName: cdk.stringToCloudFormation(properties.bucketName), BucketPrefix: cdk.stringToCloudFormation(properties.bucketPrefix), ClusterIdentifier: cdk.stringToCloudFormation(properties.clusterIdentifier), DataApiRoleArn: cdk.stringToCloudFormation(properties.dataApiRoleArn), DatabaseName: cdk.stringToCloudFormation(properties.databaseName), DatabaseUrl: cdk.stringToCloudFormation(properties.databaseUrl), IsRedshiftServerless: cdk.booleanToCloudFormation(properties.isRedshiftServerless), RoleArn: cdk.stringToCloudFormation(properties.roleArn), WorkgroupName: cdk.stringToCloudFormation(properties.workgroupName) }) : properties;
    }
    function CfnConnectorProfileRedshiftConnectorProfilePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketName", "BucketName", cfn_parse.FromCloudFormation.getString(properties.BucketName)), ret.addPropertyResult("bucketPrefix", "BucketPrefix", properties.BucketPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.BucketPrefix) : void 0), ret.addPropertyResult("clusterIdentifier", "ClusterIdentifier", properties.ClusterIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.ClusterIdentifier) : void 0), ret.addPropertyResult("dataApiRoleArn", "DataApiRoleArn", properties.DataApiRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.DataApiRoleArn) : void 0), ret.addPropertyResult("databaseName", "DatabaseName", properties.DatabaseName != null ? cfn_parse.FromCloudFormation.getString(properties.DatabaseName) : void 0), ret.addPropertyResult("databaseUrl", "DatabaseUrl", properties.DatabaseUrl != null ? cfn_parse.FromCloudFormation.getString(properties.DatabaseUrl) : void 0), ret.addPropertyResult("isRedshiftServerless", "IsRedshiftServerless", properties.IsRedshiftServerless != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsRedshiftServerless) : void 0), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("workgroupName", "WorkgroupName", properties.WorkgroupName != null ? cfn_parse.FromCloudFormation.getString(properties.WorkgroupName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_SAPODataConnectorProfileCredentialsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("basicAuthCredentials", CfnConnectorProfile_BasicAuthCredentialsPropertyValidator)(properties.basicAuthCredentials)), errors.collect(cdk.propertyValidator("oAuthCredentials", CfnConnectorProfile_OAuthCredentialsPropertyValidator)(properties.oAuthCredentials)), errors.wrap('supplied properties not correct for "SAPODataConnectorProfileCredentialsProperty"');
    }
    function cfnConnectorProfileSAPODataConnectorProfileCredentialsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_SAPODataConnectorProfileCredentialsPropertyValidator(properties).assertSuccess(), { BasicAuthCredentials: cfnConnectorProfileBasicAuthCredentialsPropertyToCloudFormation(properties.basicAuthCredentials), OAuthCredentials: cfnConnectorProfileOAuthCredentialsPropertyToCloudFormation(properties.oAuthCredentials) }) : properties;
    }
    function CfnConnectorProfileSAPODataConnectorProfileCredentialsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("basicAuthCredentials", "BasicAuthCredentials", properties.BasicAuthCredentials != null ? CfnConnectorProfileBasicAuthCredentialsPropertyFromCloudFormation(properties.BasicAuthCredentials) : void 0), ret.addPropertyResult("oAuthCredentials", "OAuthCredentials", properties.OAuthCredentials != null ? CfnConnectorProfileOAuthCredentialsPropertyFromCloudFormation(properties.OAuthCredentials) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_SAPODataConnectorProfilePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationHostUrl", cdk.validateString)(properties.applicationHostUrl)), errors.collect(cdk.propertyValidator("applicationServicePath", cdk.validateString)(properties.applicationServicePath)), errors.collect(cdk.propertyValidator("clientNumber", cdk.validateString)(properties.clientNumber)), errors.collect(cdk.propertyValidator("logonLanguage", cdk.validateString)(properties.logonLanguage)), errors.collect(cdk.propertyValidator("oAuthProperties", CfnConnectorProfile_OAuthPropertiesPropertyValidator)(properties.oAuthProperties)), errors.collect(cdk.propertyValidator("portNumber", cdk.validateNumber)(properties.portNumber)), errors.collect(cdk.propertyValidator("privateLinkServiceName", cdk.validateString)(properties.privateLinkServiceName)), errors.wrap('supplied properties not correct for "SAPODataConnectorProfilePropertiesProperty"');
    }
    function cfnConnectorProfileSAPODataConnectorProfilePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_SAPODataConnectorProfilePropertiesPropertyValidator(properties).assertSuccess(), { ApplicationHostUrl: cdk.stringToCloudFormation(properties.applicationHostUrl), ApplicationServicePath: cdk.stringToCloudFormation(properties.applicationServicePath), ClientNumber: cdk.stringToCloudFormation(properties.clientNumber), LogonLanguage: cdk.stringToCloudFormation(properties.logonLanguage), OAuthProperties: cfnConnectorProfileOAuthPropertiesPropertyToCloudFormation(properties.oAuthProperties), PortNumber: cdk.numberToCloudFormation(properties.portNumber), PrivateLinkServiceName: cdk.stringToCloudFormation(properties.privateLinkServiceName) }) : properties;
    }
    function CfnConnectorProfileSAPODataConnectorProfilePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationHostUrl", "ApplicationHostUrl", properties.ApplicationHostUrl != null ? cfn_parse.FromCloudFormation.getString(properties.ApplicationHostUrl) : void 0), ret.addPropertyResult("applicationServicePath", "ApplicationServicePath", properties.ApplicationServicePath != null ? cfn_parse.FromCloudFormation.getString(properties.ApplicationServicePath) : void 0), ret.addPropertyResult("clientNumber", "ClientNumber", properties.ClientNumber != null ? cfn_parse.FromCloudFormation.getString(properties.ClientNumber) : void 0), ret.addPropertyResult("logonLanguage", "LogonLanguage", properties.LogonLanguage != null ? cfn_parse.FromCloudFormation.getString(properties.LogonLanguage) : void 0), ret.addPropertyResult("oAuthProperties", "OAuthProperties", properties.OAuthProperties != null ? CfnConnectorProfileOAuthPropertiesPropertyFromCloudFormation(properties.OAuthProperties) : void 0), ret.addPropertyResult("portNumber", "PortNumber", properties.PortNumber != null ? cfn_parse.FromCloudFormation.getNumber(properties.PortNumber) : void 0), ret.addPropertyResult("privateLinkServiceName", "PrivateLinkServiceName", properties.PrivateLinkServiceName != null ? cfn_parse.FromCloudFormation.getString(properties.PrivateLinkServiceName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_SalesforceConnectorProfileCredentialsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessToken", cdk.validateString)(properties.accessToken)), errors.collect(cdk.propertyValidator("clientCredentialsArn", cdk.validateString)(properties.clientCredentialsArn)), errors.collect(cdk.propertyValidator("connectorOAuthRequest", CfnConnectorProfile_ConnectorOAuthRequestPropertyValidator)(properties.connectorOAuthRequest)), errors.collect(cdk.propertyValidator("refreshToken", cdk.validateString)(properties.refreshToken)), errors.wrap('supplied properties not correct for "SalesforceConnectorProfileCredentialsProperty"');
    }
    function cfnConnectorProfileSalesforceConnectorProfileCredentialsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_SalesforceConnectorProfileCredentialsPropertyValidator(properties).assertSuccess(), { AccessToken: cdk.stringToCloudFormation(properties.accessToken), ClientCredentialsArn: cdk.stringToCloudFormation(properties.clientCredentialsArn), ConnectorOAuthRequest: cfnConnectorProfileConnectorOAuthRequestPropertyToCloudFormation(properties.connectorOAuthRequest), RefreshToken: cdk.stringToCloudFormation(properties.refreshToken) }) : properties;
    }
    function CfnConnectorProfileSalesforceConnectorProfileCredentialsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessToken", "AccessToken", properties.AccessToken != null ? cfn_parse.FromCloudFormation.getString(properties.AccessToken) : void 0), ret.addPropertyResult("clientCredentialsArn", "ClientCredentialsArn", properties.ClientCredentialsArn != null ? cfn_parse.FromCloudFormation.getString(properties.ClientCredentialsArn) : void 0), ret.addPropertyResult("connectorOAuthRequest", "ConnectorOAuthRequest", properties.ConnectorOAuthRequest != null ? CfnConnectorProfileConnectorOAuthRequestPropertyFromCloudFormation(properties.ConnectorOAuthRequest) : void 0), ret.addPropertyResult("refreshToken", "RefreshToken", properties.RefreshToken != null ? cfn_parse.FromCloudFormation.getString(properties.RefreshToken) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_SalesforceConnectorProfilePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceUrl", cdk.validateString)(properties.instanceUrl)), errors.collect(cdk.propertyValidator("isSandboxEnvironment", cdk.validateBoolean)(properties.isSandboxEnvironment)), errors.collect(cdk.propertyValidator("usePrivateLinkForMetadataAndAuthorization", cdk.validateBoolean)(properties.usePrivateLinkForMetadataAndAuthorization)), errors.wrap('supplied properties not correct for "SalesforceConnectorProfilePropertiesProperty"');
    }
    function cfnConnectorProfileSalesforceConnectorProfilePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_SalesforceConnectorProfilePropertiesPropertyValidator(properties).assertSuccess(), { InstanceUrl: cdk.stringToCloudFormation(properties.instanceUrl), isSandboxEnvironment: cdk.booleanToCloudFormation(properties.isSandboxEnvironment), usePrivateLinkForMetadataAndAuthorization: cdk.booleanToCloudFormation(properties.usePrivateLinkForMetadataAndAuthorization) }) : properties;
    }
    function CfnConnectorProfileSalesforceConnectorProfilePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceUrl", "InstanceUrl", properties.InstanceUrl != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceUrl) : void 0), ret.addPropertyResult("isSandboxEnvironment", "isSandboxEnvironment", properties.isSandboxEnvironment != null ? cfn_parse.FromCloudFormation.getBoolean(properties.isSandboxEnvironment) : void 0), ret.addPropertyResult("usePrivateLinkForMetadataAndAuthorization", "usePrivateLinkForMetadataAndAuthorization", properties.usePrivateLinkForMetadataAndAuthorization != null ? cfn_parse.FromCloudFormation.getBoolean(properties.usePrivateLinkForMetadataAndAuthorization) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_ServiceNowConnectorProfileCredentialsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("password", cdk.requiredValidator)(properties.password)), errors.collect(cdk.propertyValidator("password", cdk.validateString)(properties.password)), errors.collect(cdk.propertyValidator("username", cdk.requiredValidator)(properties.username)), errors.collect(cdk.propertyValidator("username", cdk.validateString)(properties.username)), errors.wrap('supplied properties not correct for "ServiceNowConnectorProfileCredentialsProperty"');
    }
    function cfnConnectorProfileServiceNowConnectorProfileCredentialsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_ServiceNowConnectorProfileCredentialsPropertyValidator(properties).assertSuccess(), { Password: cdk.stringToCloudFormation(properties.password), Username: cdk.stringToCloudFormation(properties.username) }) : properties;
    }
    function CfnConnectorProfileServiceNowConnectorProfileCredentialsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("password", "Password", cfn_parse.FromCloudFormation.getString(properties.Password)), ret.addPropertyResult("username", "Username", cfn_parse.FromCloudFormation.getString(properties.Username)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_ServiceNowConnectorProfilePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceUrl", cdk.requiredValidator)(properties.instanceUrl)), errors.collect(cdk.propertyValidator("instanceUrl", cdk.validateString)(properties.instanceUrl)), errors.wrap('supplied properties not correct for "ServiceNowConnectorProfilePropertiesProperty"');
    }
    function cfnConnectorProfileServiceNowConnectorProfilePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_ServiceNowConnectorProfilePropertiesPropertyValidator(properties).assertSuccess(), { InstanceUrl: cdk.stringToCloudFormation(properties.instanceUrl) }) : properties;
    }
    function CfnConnectorProfileServiceNowConnectorProfilePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceUrl", "InstanceUrl", cfn_parse.FromCloudFormation.getString(properties.InstanceUrl)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_SingularConnectorProfileCredentialsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiKey", cdk.requiredValidator)(properties.apiKey)), errors.collect(cdk.propertyValidator("apiKey", cdk.validateString)(properties.apiKey)), errors.wrap('supplied properties not correct for "SingularConnectorProfileCredentialsProperty"');
    }
    function cfnConnectorProfileSingularConnectorProfileCredentialsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_SingularConnectorProfileCredentialsPropertyValidator(properties).assertSuccess(), { ApiKey: cdk.stringToCloudFormation(properties.apiKey) }) : properties;
    }
    function CfnConnectorProfileSingularConnectorProfileCredentialsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiKey", "ApiKey", cfn_parse.FromCloudFormation.getString(properties.ApiKey)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_SlackConnectorProfileCredentialsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessToken", cdk.validateString)(properties.accessToken)), errors.collect(cdk.propertyValidator("clientId", cdk.requiredValidator)(properties.clientId)), errors.collect(cdk.propertyValidator("clientId", cdk.validateString)(properties.clientId)), errors.collect(cdk.propertyValidator("clientSecret", cdk.requiredValidator)(properties.clientSecret)), errors.collect(cdk.propertyValidator("clientSecret", cdk.validateString)(properties.clientSecret)), errors.collect(cdk.propertyValidator("connectorOAuthRequest", CfnConnectorProfile_ConnectorOAuthRequestPropertyValidator)(properties.connectorOAuthRequest)), errors.wrap('supplied properties not correct for "SlackConnectorProfileCredentialsProperty"');
    }
    function cfnConnectorProfileSlackConnectorProfileCredentialsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_SlackConnectorProfileCredentialsPropertyValidator(properties).assertSuccess(), { AccessToken: cdk.stringToCloudFormation(properties.accessToken), ClientId: cdk.stringToCloudFormation(properties.clientId), ClientSecret: cdk.stringToCloudFormation(properties.clientSecret), ConnectorOAuthRequest: cfnConnectorProfileConnectorOAuthRequestPropertyToCloudFormation(properties.connectorOAuthRequest) }) : properties;
    }
    function CfnConnectorProfileSlackConnectorProfileCredentialsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessToken", "AccessToken", properties.AccessToken != null ? cfn_parse.FromCloudFormation.getString(properties.AccessToken) : void 0), ret.addPropertyResult("clientId", "ClientId", cfn_parse.FromCloudFormation.getString(properties.ClientId)), ret.addPropertyResult("clientSecret", "ClientSecret", cfn_parse.FromCloudFormation.getString(properties.ClientSecret)), ret.addPropertyResult("connectorOAuthRequest", "ConnectorOAuthRequest", properties.ConnectorOAuthRequest != null ? CfnConnectorProfileConnectorOAuthRequestPropertyFromCloudFormation(properties.ConnectorOAuthRequest) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_SlackConnectorProfilePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceUrl", cdk.requiredValidator)(properties.instanceUrl)), errors.collect(cdk.propertyValidator("instanceUrl", cdk.validateString)(properties.instanceUrl)), errors.wrap('supplied properties not correct for "SlackConnectorProfilePropertiesProperty"');
    }
    function cfnConnectorProfileSlackConnectorProfilePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_SlackConnectorProfilePropertiesPropertyValidator(properties).assertSuccess(), { InstanceUrl: cdk.stringToCloudFormation(properties.instanceUrl) }) : properties;
    }
    function CfnConnectorProfileSlackConnectorProfilePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceUrl", "InstanceUrl", cfn_parse.FromCloudFormation.getString(properties.InstanceUrl)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_SnowflakeConnectorProfileCredentialsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("password", cdk.requiredValidator)(properties.password)), errors.collect(cdk.propertyValidator("password", cdk.validateString)(properties.password)), errors.collect(cdk.propertyValidator("username", cdk.requiredValidator)(properties.username)), errors.collect(cdk.propertyValidator("username", cdk.validateString)(properties.username)), errors.wrap('supplied properties not correct for "SnowflakeConnectorProfileCredentialsProperty"');
    }
    function cfnConnectorProfileSnowflakeConnectorProfileCredentialsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_SnowflakeConnectorProfileCredentialsPropertyValidator(properties).assertSuccess(), { Password: cdk.stringToCloudFormation(properties.password), Username: cdk.stringToCloudFormation(properties.username) }) : properties;
    }
    function CfnConnectorProfileSnowflakeConnectorProfileCredentialsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("password", "Password", cfn_parse.FromCloudFormation.getString(properties.Password)), ret.addPropertyResult("username", "Username", cfn_parse.FromCloudFormation.getString(properties.Username)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_SnowflakeConnectorProfilePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accountName", cdk.validateString)(properties.accountName)), errors.collect(cdk.propertyValidator("bucketName", cdk.requiredValidator)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketPrefix", cdk.validateString)(properties.bucketPrefix)), errors.collect(cdk.propertyValidator("privateLinkServiceName", cdk.validateString)(properties.privateLinkServiceName)), errors.collect(cdk.propertyValidator("region", cdk.validateString)(properties.region)), errors.collect(cdk.propertyValidator("stage", cdk.requiredValidator)(properties.stage)), errors.collect(cdk.propertyValidator("stage", cdk.validateString)(properties.stage)), errors.collect(cdk.propertyValidator("warehouse", cdk.requiredValidator)(properties.warehouse)), errors.collect(cdk.propertyValidator("warehouse", cdk.validateString)(properties.warehouse)), errors.wrap('supplied properties not correct for "SnowflakeConnectorProfilePropertiesProperty"');
    }
    function cfnConnectorProfileSnowflakeConnectorProfilePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_SnowflakeConnectorProfilePropertiesPropertyValidator(properties).assertSuccess(), { AccountName: cdk.stringToCloudFormation(properties.accountName), BucketName: cdk.stringToCloudFormation(properties.bucketName), BucketPrefix: cdk.stringToCloudFormation(properties.bucketPrefix), PrivateLinkServiceName: cdk.stringToCloudFormation(properties.privateLinkServiceName), Region: cdk.stringToCloudFormation(properties.region), Stage: cdk.stringToCloudFormation(properties.stage), Warehouse: cdk.stringToCloudFormation(properties.warehouse) }) : properties;
    }
    function CfnConnectorProfileSnowflakeConnectorProfilePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accountName", "AccountName", properties.AccountName != null ? cfn_parse.FromCloudFormation.getString(properties.AccountName) : void 0), ret.addPropertyResult("bucketName", "BucketName", cfn_parse.FromCloudFormation.getString(properties.BucketName)), ret.addPropertyResult("bucketPrefix", "BucketPrefix", properties.BucketPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.BucketPrefix) : void 0), ret.addPropertyResult("privateLinkServiceName", "PrivateLinkServiceName", properties.PrivateLinkServiceName != null ? cfn_parse.FromCloudFormation.getString(properties.PrivateLinkServiceName) : void 0), ret.addPropertyResult("region", "Region", properties.Region != null ? cfn_parse.FromCloudFormation.getString(properties.Region) : void 0), ret.addPropertyResult("stage", "Stage", cfn_parse.FromCloudFormation.getString(properties.Stage)), ret.addPropertyResult("warehouse", "Warehouse", cfn_parse.FromCloudFormation.getString(properties.Warehouse)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_TrendmicroConnectorProfileCredentialsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiSecretKey", cdk.requiredValidator)(properties.apiSecretKey)), errors.collect(cdk.propertyValidator("apiSecretKey", cdk.validateString)(properties.apiSecretKey)), errors.wrap('supplied properties not correct for "TrendmicroConnectorProfileCredentialsProperty"');
    }
    function cfnConnectorProfileTrendmicroConnectorProfileCredentialsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_TrendmicroConnectorProfileCredentialsPropertyValidator(properties).assertSuccess(), { ApiSecretKey: cdk.stringToCloudFormation(properties.apiSecretKey) }) : properties;
    }
    function CfnConnectorProfileTrendmicroConnectorProfileCredentialsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiSecretKey", "ApiSecretKey", cfn_parse.FromCloudFormation.getString(properties.ApiSecretKey)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_VeevaConnectorProfileCredentialsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("password", cdk.requiredValidator)(properties.password)), errors.collect(cdk.propertyValidator("password", cdk.validateString)(properties.password)), errors.collect(cdk.propertyValidator("username", cdk.requiredValidator)(properties.username)), errors.collect(cdk.propertyValidator("username", cdk.validateString)(properties.username)), errors.wrap('supplied properties not correct for "VeevaConnectorProfileCredentialsProperty"');
    }
    function cfnConnectorProfileVeevaConnectorProfileCredentialsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_VeevaConnectorProfileCredentialsPropertyValidator(properties).assertSuccess(), { Password: cdk.stringToCloudFormation(properties.password), Username: cdk.stringToCloudFormation(properties.username) }) : properties;
    }
    function CfnConnectorProfileVeevaConnectorProfileCredentialsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("password", "Password", cfn_parse.FromCloudFormation.getString(properties.Password)), ret.addPropertyResult("username", "Username", cfn_parse.FromCloudFormation.getString(properties.Username)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_VeevaConnectorProfilePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceUrl", cdk.requiredValidator)(properties.instanceUrl)), errors.collect(cdk.propertyValidator("instanceUrl", cdk.validateString)(properties.instanceUrl)), errors.wrap('supplied properties not correct for "VeevaConnectorProfilePropertiesProperty"');
    }
    function cfnConnectorProfileVeevaConnectorProfilePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_VeevaConnectorProfilePropertiesPropertyValidator(properties).assertSuccess(), { InstanceUrl: cdk.stringToCloudFormation(properties.instanceUrl) }) : properties;
    }
    function CfnConnectorProfileVeevaConnectorProfilePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceUrl", "InstanceUrl", cfn_parse.FromCloudFormation.getString(properties.InstanceUrl)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_ZendeskConnectorProfileCredentialsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessToken", cdk.validateString)(properties.accessToken)), errors.collect(cdk.propertyValidator("clientId", cdk.requiredValidator)(properties.clientId)), errors.collect(cdk.propertyValidator("clientId", cdk.validateString)(properties.clientId)), errors.collect(cdk.propertyValidator("clientSecret", cdk.requiredValidator)(properties.clientSecret)), errors.collect(cdk.propertyValidator("clientSecret", cdk.validateString)(properties.clientSecret)), errors.collect(cdk.propertyValidator("connectorOAuthRequest", CfnConnectorProfile_ConnectorOAuthRequestPropertyValidator)(properties.connectorOAuthRequest)), errors.wrap('supplied properties not correct for "ZendeskConnectorProfileCredentialsProperty"');
    }
    function cfnConnectorProfileZendeskConnectorProfileCredentialsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_ZendeskConnectorProfileCredentialsPropertyValidator(properties).assertSuccess(), { AccessToken: cdk.stringToCloudFormation(properties.accessToken), ClientId: cdk.stringToCloudFormation(properties.clientId), ClientSecret: cdk.stringToCloudFormation(properties.clientSecret), ConnectorOAuthRequest: cfnConnectorProfileConnectorOAuthRequestPropertyToCloudFormation(properties.connectorOAuthRequest) }) : properties;
    }
    function CfnConnectorProfileZendeskConnectorProfileCredentialsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessToken", "AccessToken", properties.AccessToken != null ? cfn_parse.FromCloudFormation.getString(properties.AccessToken) : void 0), ret.addPropertyResult("clientId", "ClientId", cfn_parse.FromCloudFormation.getString(properties.ClientId)), ret.addPropertyResult("clientSecret", "ClientSecret", cfn_parse.FromCloudFormation.getString(properties.ClientSecret)), ret.addPropertyResult("connectorOAuthRequest", "ConnectorOAuthRequest", properties.ConnectorOAuthRequest != null ? CfnConnectorProfileConnectorOAuthRequestPropertyFromCloudFormation(properties.ConnectorOAuthRequest) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorProfile_ZendeskConnectorProfilePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceUrl", cdk.requiredValidator)(properties.instanceUrl)), errors.collect(cdk.propertyValidator("instanceUrl", cdk.validateString)(properties.instanceUrl)), errors.wrap('supplied properties not correct for "ZendeskConnectorProfilePropertiesProperty"');
    }
    function cfnConnectorProfileZendeskConnectorProfilePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorProfile_ZendeskConnectorProfilePropertiesPropertyValidator(properties).assertSuccess(), { InstanceUrl: cdk.stringToCloudFormation(properties.instanceUrl) }) : properties;
    }
    function CfnConnectorProfileZendeskConnectorProfilePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceUrl", "InstanceUrl", cfn_parse.FromCloudFormation.getString(properties.InstanceUrl)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlowPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("destinationFlowConfigList", cdk.requiredValidator)(properties.destinationFlowConfigList)), errors.collect(cdk.propertyValidator("destinationFlowConfigList", cdk.listValidator(CfnFlow_DestinationFlowConfigPropertyValidator))(properties.destinationFlowConfigList)), errors.collect(cdk.propertyValidator("flowName", cdk.requiredValidator)(properties.flowName)), errors.collect(cdk.propertyValidator("flowName", cdk.validateString)(properties.flowName)), errors.collect(cdk.propertyValidator("kmsArn", cdk.validateString)(properties.kmsArn)), errors.collect(cdk.propertyValidator("metadataCatalogConfig", CfnFlow_MetadataCatalogConfigPropertyValidator)(properties.metadataCatalogConfig)), errors.collect(cdk.propertyValidator("sourceFlowConfig", cdk.requiredValidator)(properties.sourceFlowConfig)), errors.collect(cdk.propertyValidator("sourceFlowConfig", CfnFlow_SourceFlowConfigPropertyValidator)(properties.sourceFlowConfig)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("tasks", cdk.requiredValidator)(properties.tasks)), errors.collect(cdk.propertyValidator("tasks", cdk.listValidator(CfnFlow_TaskPropertyValidator))(properties.tasks)), errors.collect(cdk.propertyValidator("triggerConfig", cdk.requiredValidator)(properties.triggerConfig)), errors.collect(cdk.propertyValidator("triggerConfig", CfnFlow_TriggerConfigPropertyValidator)(properties.triggerConfig)), errors.wrap('supplied properties not correct for "CfnFlowProps"');
    }
    function cfnFlowPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlowPropsValidator(properties).assertSuccess(), { DestinationFlowConfigList: cdk.listMapper(cfnFlowDestinationFlowConfigPropertyToCloudFormation)(properties.destinationFlowConfigList), FlowName: cdk.stringToCloudFormation(properties.flowName), SourceFlowConfig: cfnFlowSourceFlowConfigPropertyToCloudFormation(properties.sourceFlowConfig), Tasks: cdk.listMapper(cfnFlowTaskPropertyToCloudFormation)(properties.tasks), TriggerConfig: cfnFlowTriggerConfigPropertyToCloudFormation(properties.triggerConfig), Description: cdk.stringToCloudFormation(properties.description), KMSArn: cdk.stringToCloudFormation(properties.kmsArn), MetadataCatalogConfig: cfnFlowMetadataCatalogConfigPropertyToCloudFormation(properties.metadataCatalogConfig), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnFlowPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationFlowConfigList", "DestinationFlowConfigList", cfn_parse.FromCloudFormation.getArray(CfnFlowDestinationFlowConfigPropertyFromCloudFormation)(properties.DestinationFlowConfigList)), ret.addPropertyResult("flowName", "FlowName", cfn_parse.FromCloudFormation.getString(properties.FlowName)), ret.addPropertyResult("sourceFlowConfig", "SourceFlowConfig", CfnFlowSourceFlowConfigPropertyFromCloudFormation(properties.SourceFlowConfig)), ret.addPropertyResult("tasks", "Tasks", cfn_parse.FromCloudFormation.getArray(CfnFlowTaskPropertyFromCloudFormation)(properties.Tasks)), ret.addPropertyResult("triggerConfig", "TriggerConfig", CfnFlowTriggerConfigPropertyFromCloudFormation(properties.TriggerConfig)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("kmsArn", "KMSArn", properties.KMSArn != null ? cfn_parse.FromCloudFormation.getString(properties.KMSArn) : void 0), ret.addPropertyResult("metadataCatalogConfig", "MetadataCatalogConfig", properties.MetadataCatalogConfig != null ? CfnFlowMetadataCatalogConfigPropertyFromCloudFormation(properties.MetadataCatalogConfig) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFlow = class _CfnFlow extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFlowPropsFromCloudFormation(resourceProperties), ret = new _CfnFlow(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFlow.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appflow_CfnFlowProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFlow), error;
        }
        cdk.requireProperty(props, "destinationFlowConfigList", this), cdk.requireProperty(props, "flowName", this), cdk.requireProperty(props, "sourceFlowConfig", this), cdk.requireProperty(props, "tasks", this), cdk.requireProperty(props, "triggerConfig", this), this.attrFlowArn = cdk.Token.asString(this.getAtt("FlowArn", cdk.ResolutionTypeHint.STRING)), this.destinationFlowConfigList = props.destinationFlowConfigList, this.flowName = props.flowName, this.sourceFlowConfig = props.sourceFlowConfig, this.tasks = props.tasks, this.triggerConfig = props.triggerConfig, this.description = props.description, this.kmsArn = props.kmsArn, this.metadataCatalogConfig = props.metadataCatalogConfig, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::AppFlow::Flow", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFlow.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { destinationFlowConfigList: this.destinationFlowConfigList, flowName: this.flowName, sourceFlowConfig: this.sourceFlowConfig, tasks: this.tasks, triggerConfig: this.triggerConfig, description: this.description, kmsArn: this.kmsArn, metadataCatalogConfig: this.metadataCatalogConfig, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnFlowPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnFlow[_c] = { fqn: "aws-cdk-lib.aws_appflow.CfnFlow", version: "2.80.0" }, CfnFlow.CFN_RESOURCE_TYPE_NAME = "AWS::AppFlow::Flow", exports2.CfnFlow = CfnFlow;
    function CfnFlow_AggregationConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationType", cdk.validateString)(properties.aggregationType)), errors.collect(cdk.propertyValidator("targetFileSize", cdk.validateNumber)(properties.targetFileSize)), errors.wrap('supplied properties not correct for "AggregationConfigProperty"');
    }
    function cfnFlowAggregationConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_AggregationConfigPropertyValidator(properties).assertSuccess(), { AggregationType: cdk.stringToCloudFormation(properties.aggregationType), TargetFileSize: cdk.numberToCloudFormation(properties.targetFileSize) }) : properties;
    }
    function CfnFlowAggregationConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationType", "AggregationType", properties.AggregationType != null ? cfn_parse.FromCloudFormation.getString(properties.AggregationType) : void 0), ret.addPropertyResult("targetFileSize", "TargetFileSize", properties.TargetFileSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.TargetFileSize) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_AmplitudeSourcePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("object", cdk.requiredValidator)(properties.object)), errors.collect(cdk.propertyValidator("object", cdk.validateString)(properties.object)), errors.wrap('supplied properties not correct for "AmplitudeSourcePropertiesProperty"');
    }
    function cfnFlowAmplitudeSourcePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_AmplitudeSourcePropertiesPropertyValidator(properties).assertSuccess(), { Object: cdk.stringToCloudFormation(properties.object) }) : properties;
    }
    function CfnFlowAmplitudeSourcePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("object", "Object", cfn_parse.FromCloudFormation.getString(properties.Object)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_ConnectorOperatorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("amplitude", cdk.validateString)(properties.amplitude)), errors.collect(cdk.propertyValidator("customConnector", cdk.validateString)(properties.customConnector)), errors.collect(cdk.propertyValidator("datadog", cdk.validateString)(properties.datadog)), errors.collect(cdk.propertyValidator("dynatrace", cdk.validateString)(properties.dynatrace)), errors.collect(cdk.propertyValidator("googleAnalytics", cdk.validateString)(properties.googleAnalytics)), errors.collect(cdk.propertyValidator("inforNexus", cdk.validateString)(properties.inforNexus)), errors.collect(cdk.propertyValidator("marketo", cdk.validateString)(properties.marketo)), errors.collect(cdk.propertyValidator("pardot", cdk.validateString)(properties.pardot)), errors.collect(cdk.propertyValidator("s3", cdk.validateString)(properties.s3)), errors.collect(cdk.propertyValidator("sapoData", cdk.validateString)(properties.sapoData)), errors.collect(cdk.propertyValidator("salesforce", cdk.validateString)(properties.salesforce)), errors.collect(cdk.propertyValidator("serviceNow", cdk.validateString)(properties.serviceNow)), errors.collect(cdk.propertyValidator("singular", cdk.validateString)(properties.singular)), errors.collect(cdk.propertyValidator("slack", cdk.validateString)(properties.slack)), errors.collect(cdk.propertyValidator("trendmicro", cdk.validateString)(properties.trendmicro)), errors.collect(cdk.propertyValidator("veeva", cdk.validateString)(properties.veeva)), errors.collect(cdk.propertyValidator("zendesk", cdk.validateString)(properties.zendesk)), errors.wrap('supplied properties not correct for "ConnectorOperatorProperty"');
    }
    function cfnFlowConnectorOperatorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_ConnectorOperatorPropertyValidator(properties).assertSuccess(), { Amplitude: cdk.stringToCloudFormation(properties.amplitude), CustomConnector: cdk.stringToCloudFormation(properties.customConnector), Datadog: cdk.stringToCloudFormation(properties.datadog), Dynatrace: cdk.stringToCloudFormation(properties.dynatrace), GoogleAnalytics: cdk.stringToCloudFormation(properties.googleAnalytics), InforNexus: cdk.stringToCloudFormation(properties.inforNexus), Marketo: cdk.stringToCloudFormation(properties.marketo), Pardot: cdk.stringToCloudFormation(properties.pardot), S3: cdk.stringToCloudFormation(properties.s3), SAPOData: cdk.stringToCloudFormation(properties.sapoData), Salesforce: cdk.stringToCloudFormation(properties.salesforce), ServiceNow: cdk.stringToCloudFormation(properties.serviceNow), Singular: cdk.stringToCloudFormation(properties.singular), Slack: cdk.stringToCloudFormation(properties.slack), Trendmicro: cdk.stringToCloudFormation(properties.trendmicro), Veeva: cdk.stringToCloudFormation(properties.veeva), Zendesk: cdk.stringToCloudFormation(properties.zendesk) }) : properties;
    }
    function CfnFlowConnectorOperatorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("amplitude", "Amplitude", properties.Amplitude != null ? cfn_parse.FromCloudFormation.getString(properties.Amplitude) : void 0), ret.addPropertyResult("customConnector", "CustomConnector", properties.CustomConnector != null ? cfn_parse.FromCloudFormation.getString(properties.CustomConnector) : void 0), ret.addPropertyResult("datadog", "Datadog", properties.Datadog != null ? cfn_parse.FromCloudFormation.getString(properties.Datadog) : void 0), ret.addPropertyResult("dynatrace", "Dynatrace", properties.Dynatrace != null ? cfn_parse.FromCloudFormation.getString(properties.Dynatrace) : void 0), ret.addPropertyResult("googleAnalytics", "GoogleAnalytics", properties.GoogleAnalytics != null ? cfn_parse.FromCloudFormation.getString(properties.GoogleAnalytics) : void 0), ret.addPropertyResult("inforNexus", "InforNexus", properties.InforNexus != null ? cfn_parse.FromCloudFormation.getString(properties.InforNexus) : void 0), ret.addPropertyResult("marketo", "Marketo", properties.Marketo != null ? cfn_parse.FromCloudFormation.getString(properties.Marketo) : void 0), ret.addPropertyResult("pardot", "Pardot", properties.Pardot != null ? cfn_parse.FromCloudFormation.getString(properties.Pardot) : void 0), ret.addPropertyResult("s3", "S3", properties.S3 != null ? cfn_parse.FromCloudFormation.getString(properties.S3) : void 0), ret.addPropertyResult("sapoData", "SAPOData", properties.SAPOData != null ? cfn_parse.FromCloudFormation.getString(properties.SAPOData) : void 0), ret.addPropertyResult("salesforce", "Salesforce", properties.Salesforce != null ? cfn_parse.FromCloudFormation.getString(properties.Salesforce) : void 0), ret.addPropertyResult("serviceNow", "ServiceNow", properties.ServiceNow != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceNow) : void 0), ret.addPropertyResult("singular", "Singular", properties.Singular != null ? cfn_parse.FromCloudFormation.getString(properties.Singular) : void 0), ret.addPropertyResult("slack", "Slack", properties.Slack != null ? cfn_parse.FromCloudFormation.getString(properties.Slack) : void 0), ret.addPropertyResult("trendmicro", "Trendmicro", properties.Trendmicro != null ? cfn_parse.FromCloudFormation.getString(properties.Trendmicro) : void 0), ret.addPropertyResult("veeva", "Veeva", properties.Veeva != null ? cfn_parse.FromCloudFormation.getString(properties.Veeva) : void 0), ret.addPropertyResult("zendesk", "Zendesk", properties.Zendesk != null ? cfn_parse.FromCloudFormation.getString(properties.Zendesk) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_CustomConnectorDestinationPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customProperties", cdk.hashValidator(cdk.validateString))(properties.customProperties)), errors.collect(cdk.propertyValidator("entityName", cdk.requiredValidator)(properties.entityName)), errors.collect(cdk.propertyValidator("entityName", cdk.validateString)(properties.entityName)), errors.collect(cdk.propertyValidator("errorHandlingConfig", CfnFlow_ErrorHandlingConfigPropertyValidator)(properties.errorHandlingConfig)), errors.collect(cdk.propertyValidator("idFieldNames", cdk.listValidator(cdk.validateString))(properties.idFieldNames)), errors.collect(cdk.propertyValidator("writeOperationType", cdk.validateString)(properties.writeOperationType)), errors.wrap('supplied properties not correct for "CustomConnectorDestinationPropertiesProperty"');
    }
    function cfnFlowCustomConnectorDestinationPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_CustomConnectorDestinationPropertiesPropertyValidator(properties).assertSuccess(), { CustomProperties: cdk.hashMapper(cdk.stringToCloudFormation)(properties.customProperties), EntityName: cdk.stringToCloudFormation(properties.entityName), ErrorHandlingConfig: cfnFlowErrorHandlingConfigPropertyToCloudFormation(properties.errorHandlingConfig), IdFieldNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.idFieldNames), WriteOperationType: cdk.stringToCloudFormation(properties.writeOperationType) }) : properties;
    }
    function CfnFlowCustomConnectorDestinationPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customProperties", "CustomProperties", properties.CustomProperties != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.CustomProperties) : void 0), ret.addPropertyResult("entityName", "EntityName", cfn_parse.FromCloudFormation.getString(properties.EntityName)), ret.addPropertyResult("errorHandlingConfig", "ErrorHandlingConfig", properties.ErrorHandlingConfig != null ? CfnFlowErrorHandlingConfigPropertyFromCloudFormation(properties.ErrorHandlingConfig) : void 0), ret.addPropertyResult("idFieldNames", "IdFieldNames", properties.IdFieldNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.IdFieldNames) : void 0), ret.addPropertyResult("writeOperationType", "WriteOperationType", properties.WriteOperationType != null ? cfn_parse.FromCloudFormation.getString(properties.WriteOperationType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_CustomConnectorSourcePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customProperties", cdk.hashValidator(cdk.validateString))(properties.customProperties)), errors.collect(cdk.propertyValidator("entityName", cdk.requiredValidator)(properties.entityName)), errors.collect(cdk.propertyValidator("entityName", cdk.validateString)(properties.entityName)), errors.wrap('supplied properties not correct for "CustomConnectorSourcePropertiesProperty"');
    }
    function cfnFlowCustomConnectorSourcePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_CustomConnectorSourcePropertiesPropertyValidator(properties).assertSuccess(), { CustomProperties: cdk.hashMapper(cdk.stringToCloudFormation)(properties.customProperties), EntityName: cdk.stringToCloudFormation(properties.entityName) }) : properties;
    }
    function CfnFlowCustomConnectorSourcePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customProperties", "CustomProperties", properties.CustomProperties != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.CustomProperties) : void 0), ret.addPropertyResult("entityName", "EntityName", cfn_parse.FromCloudFormation.getString(properties.EntityName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_DatadogSourcePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("object", cdk.requiredValidator)(properties.object)), errors.collect(cdk.propertyValidator("object", cdk.validateString)(properties.object)), errors.wrap('supplied properties not correct for "DatadogSourcePropertiesProperty"');
    }
    function cfnFlowDatadogSourcePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_DatadogSourcePropertiesPropertyValidator(properties).assertSuccess(), { Object: cdk.stringToCloudFormation(properties.object) }) : properties;
    }
    function CfnFlowDatadogSourcePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("object", "Object", cfn_parse.FromCloudFormation.getString(properties.Object)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_DestinationConnectorPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customConnector", CfnFlow_CustomConnectorDestinationPropertiesPropertyValidator)(properties.customConnector)), errors.collect(cdk.propertyValidator("eventBridge", CfnFlow_EventBridgeDestinationPropertiesPropertyValidator)(properties.eventBridge)), errors.collect(cdk.propertyValidator("lookoutMetrics", CfnFlow_LookoutMetricsDestinationPropertiesPropertyValidator)(properties.lookoutMetrics)), errors.collect(cdk.propertyValidator("marketo", CfnFlow_MarketoDestinationPropertiesPropertyValidator)(properties.marketo)), errors.collect(cdk.propertyValidator("redshift", CfnFlow_RedshiftDestinationPropertiesPropertyValidator)(properties.redshift)), errors.collect(cdk.propertyValidator("s3", CfnFlow_S3DestinationPropertiesPropertyValidator)(properties.s3)), errors.collect(cdk.propertyValidator("sapoData", CfnFlow_SAPODataDestinationPropertiesPropertyValidator)(properties.sapoData)), errors.collect(cdk.propertyValidator("salesforce", CfnFlow_SalesforceDestinationPropertiesPropertyValidator)(properties.salesforce)), errors.collect(cdk.propertyValidator("snowflake", CfnFlow_SnowflakeDestinationPropertiesPropertyValidator)(properties.snowflake)), errors.collect(cdk.propertyValidator("upsolver", CfnFlow_UpsolverDestinationPropertiesPropertyValidator)(properties.upsolver)), errors.collect(cdk.propertyValidator("zendesk", CfnFlow_ZendeskDestinationPropertiesPropertyValidator)(properties.zendesk)), errors.wrap('supplied properties not correct for "DestinationConnectorPropertiesProperty"');
    }
    function cfnFlowDestinationConnectorPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_DestinationConnectorPropertiesPropertyValidator(properties).assertSuccess(), { CustomConnector: cfnFlowCustomConnectorDestinationPropertiesPropertyToCloudFormation(properties.customConnector), EventBridge: cfnFlowEventBridgeDestinationPropertiesPropertyToCloudFormation(properties.eventBridge), LookoutMetrics: cfnFlowLookoutMetricsDestinationPropertiesPropertyToCloudFormation(properties.lookoutMetrics), Marketo: cfnFlowMarketoDestinationPropertiesPropertyToCloudFormation(properties.marketo), Redshift: cfnFlowRedshiftDestinationPropertiesPropertyToCloudFormation(properties.redshift), S3: cfnFlowS3DestinationPropertiesPropertyToCloudFormation(properties.s3), SAPOData: cfnFlowSAPODataDestinationPropertiesPropertyToCloudFormation(properties.sapoData), Salesforce: cfnFlowSalesforceDestinationPropertiesPropertyToCloudFormation(properties.salesforce), Snowflake: cfnFlowSnowflakeDestinationPropertiesPropertyToCloudFormation(properties.snowflake), Upsolver: cfnFlowUpsolverDestinationPropertiesPropertyToCloudFormation(properties.upsolver), Zendesk: cfnFlowZendeskDestinationPropertiesPropertyToCloudFormation(properties.zendesk) }) : properties;
    }
    function CfnFlowDestinationConnectorPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customConnector", "CustomConnector", properties.CustomConnector != null ? CfnFlowCustomConnectorDestinationPropertiesPropertyFromCloudFormation(properties.CustomConnector) : void 0), ret.addPropertyResult("eventBridge", "EventBridge", properties.EventBridge != null ? CfnFlowEventBridgeDestinationPropertiesPropertyFromCloudFormation(properties.EventBridge) : void 0), ret.addPropertyResult("lookoutMetrics", "LookoutMetrics", properties.LookoutMetrics != null ? CfnFlowLookoutMetricsDestinationPropertiesPropertyFromCloudFormation(properties.LookoutMetrics) : void 0), ret.addPropertyResult("marketo", "Marketo", properties.Marketo != null ? CfnFlowMarketoDestinationPropertiesPropertyFromCloudFormation(properties.Marketo) : void 0), ret.addPropertyResult("redshift", "Redshift", properties.Redshift != null ? CfnFlowRedshiftDestinationPropertiesPropertyFromCloudFormation(properties.Redshift) : void 0), ret.addPropertyResult("s3", "S3", properties.S3 != null ? CfnFlowS3DestinationPropertiesPropertyFromCloudFormation(properties.S3) : void 0), ret.addPropertyResult("sapoData", "SAPOData", properties.SAPOData != null ? CfnFlowSAPODataDestinationPropertiesPropertyFromCloudFormation(properties.SAPOData) : void 0), ret.addPropertyResult("salesforce", "Salesforce", properties.Salesforce != null ? CfnFlowSalesforceDestinationPropertiesPropertyFromCloudFormation(properties.Salesforce) : void 0), ret.addPropertyResult("snowflake", "Snowflake", properties.Snowflake != null ? CfnFlowSnowflakeDestinationPropertiesPropertyFromCloudFormation(properties.Snowflake) : void 0), ret.addPropertyResult("upsolver", "Upsolver", properties.Upsolver != null ? CfnFlowUpsolverDestinationPropertiesPropertyFromCloudFormation(properties.Upsolver) : void 0), ret.addPropertyResult("zendesk", "Zendesk", properties.Zendesk != null ? CfnFlowZendeskDestinationPropertiesPropertyFromCloudFormation(properties.Zendesk) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_DestinationFlowConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiVersion", cdk.validateString)(properties.apiVersion)), errors.collect(cdk.propertyValidator("connectorProfileName", cdk.validateString)(properties.connectorProfileName)), errors.collect(cdk.propertyValidator("connectorType", cdk.requiredValidator)(properties.connectorType)), errors.collect(cdk.propertyValidator("connectorType", cdk.validateString)(properties.connectorType)), errors.collect(cdk.propertyValidator("destinationConnectorProperties", cdk.requiredValidator)(properties.destinationConnectorProperties)), errors.collect(cdk.propertyValidator("destinationConnectorProperties", CfnFlow_DestinationConnectorPropertiesPropertyValidator)(properties.destinationConnectorProperties)), errors.wrap('supplied properties not correct for "DestinationFlowConfigProperty"');
    }
    function cfnFlowDestinationFlowConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_DestinationFlowConfigPropertyValidator(properties).assertSuccess(), { ApiVersion: cdk.stringToCloudFormation(properties.apiVersion), ConnectorProfileName: cdk.stringToCloudFormation(properties.connectorProfileName), ConnectorType: cdk.stringToCloudFormation(properties.connectorType), DestinationConnectorProperties: cfnFlowDestinationConnectorPropertiesPropertyToCloudFormation(properties.destinationConnectorProperties) }) : properties;
    }
    function CfnFlowDestinationFlowConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiVersion", "ApiVersion", properties.ApiVersion != null ? cfn_parse.FromCloudFormation.getString(properties.ApiVersion) : void 0), ret.addPropertyResult("connectorProfileName", "ConnectorProfileName", properties.ConnectorProfileName != null ? cfn_parse.FromCloudFormation.getString(properties.ConnectorProfileName) : void 0), ret.addPropertyResult("connectorType", "ConnectorType", cfn_parse.FromCloudFormation.getString(properties.ConnectorType)), ret.addPropertyResult("destinationConnectorProperties", "DestinationConnectorProperties", CfnFlowDestinationConnectorPropertiesPropertyFromCloudFormation(properties.DestinationConnectorProperties)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_DynatraceSourcePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("object", cdk.requiredValidator)(properties.object)), errors.collect(cdk.propertyValidator("object", cdk.validateString)(properties.object)), errors.wrap('supplied properties not correct for "DynatraceSourcePropertiesProperty"');
    }
    function cfnFlowDynatraceSourcePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_DynatraceSourcePropertiesPropertyValidator(properties).assertSuccess(), { Object: cdk.stringToCloudFormation(properties.object) }) : properties;
    }
    function CfnFlowDynatraceSourcePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("object", "Object", cfn_parse.FromCloudFormation.getString(properties.Object)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_ErrorHandlingConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketPrefix", cdk.validateString)(properties.bucketPrefix)), errors.collect(cdk.propertyValidator("failOnFirstError", cdk.validateBoolean)(properties.failOnFirstError)), errors.wrap('supplied properties not correct for "ErrorHandlingConfigProperty"');
    }
    function cfnFlowErrorHandlingConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_ErrorHandlingConfigPropertyValidator(properties).assertSuccess(), { BucketName: cdk.stringToCloudFormation(properties.bucketName), BucketPrefix: cdk.stringToCloudFormation(properties.bucketPrefix), FailOnFirstError: cdk.booleanToCloudFormation(properties.failOnFirstError) }) : properties;
    }
    function CfnFlowErrorHandlingConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketName", "BucketName", properties.BucketName != null ? cfn_parse.FromCloudFormation.getString(properties.BucketName) : void 0), ret.addPropertyResult("bucketPrefix", "BucketPrefix", properties.BucketPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.BucketPrefix) : void 0), ret.addPropertyResult("failOnFirstError", "FailOnFirstError", properties.FailOnFirstError != null ? cfn_parse.FromCloudFormation.getBoolean(properties.FailOnFirstError) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_EventBridgeDestinationPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("errorHandlingConfig", CfnFlow_ErrorHandlingConfigPropertyValidator)(properties.errorHandlingConfig)), errors.collect(cdk.propertyValidator("object", cdk.requiredValidator)(properties.object)), errors.collect(cdk.propertyValidator("object", cdk.validateString)(properties.object)), errors.wrap('supplied properties not correct for "EventBridgeDestinationPropertiesProperty"');
    }
    function cfnFlowEventBridgeDestinationPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_EventBridgeDestinationPropertiesPropertyValidator(properties).assertSuccess(), { ErrorHandlingConfig: cfnFlowErrorHandlingConfigPropertyToCloudFormation(properties.errorHandlingConfig), Object: cdk.stringToCloudFormation(properties.object) }) : properties;
    }
    function CfnFlowEventBridgeDestinationPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("errorHandlingConfig", "ErrorHandlingConfig", properties.ErrorHandlingConfig != null ? CfnFlowErrorHandlingConfigPropertyFromCloudFormation(properties.ErrorHandlingConfig) : void 0), ret.addPropertyResult("object", "Object", cfn_parse.FromCloudFormation.getString(properties.Object)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_GlueDataCatalogPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("databaseName", cdk.requiredValidator)(properties.databaseName)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("tablePrefix", cdk.requiredValidator)(properties.tablePrefix)), errors.collect(cdk.propertyValidator("tablePrefix", cdk.validateString)(properties.tablePrefix)), errors.wrap('supplied properties not correct for "GlueDataCatalogProperty"');
    }
    function cfnFlowGlueDataCatalogPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_GlueDataCatalogPropertyValidator(properties).assertSuccess(), { DatabaseName: cdk.stringToCloudFormation(properties.databaseName), RoleArn: cdk.stringToCloudFormation(properties.roleArn), TablePrefix: cdk.stringToCloudFormation(properties.tablePrefix) }) : properties;
    }
    function CfnFlowGlueDataCatalogPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("databaseName", "DatabaseName", cfn_parse.FromCloudFormation.getString(properties.DatabaseName)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("tablePrefix", "TablePrefix", cfn_parse.FromCloudFormation.getString(properties.TablePrefix)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_GoogleAnalyticsSourcePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("object", cdk.requiredValidator)(properties.object)), errors.collect(cdk.propertyValidator("object", cdk.validateString)(properties.object)), errors.wrap('supplied properties not correct for "GoogleAnalyticsSourcePropertiesProperty"');
    }
    function cfnFlowGoogleAnalyticsSourcePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_GoogleAnalyticsSourcePropertiesPropertyValidator(properties).assertSuccess(), { Object: cdk.stringToCloudFormation(properties.object) }) : properties;
    }
    function CfnFlowGoogleAnalyticsSourcePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("object", "Object", cfn_parse.FromCloudFormation.getString(properties.Object)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_IncrementalPullConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("datetimeTypeFieldName", cdk.validateString)(properties.datetimeTypeFieldName)), errors.wrap('supplied properties not correct for "IncrementalPullConfigProperty"');
    }
    function cfnFlowIncrementalPullConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_IncrementalPullConfigPropertyValidator(properties).assertSuccess(), { DatetimeTypeFieldName: cdk.stringToCloudFormation(properties.datetimeTypeFieldName) }) : properties;
    }
    function CfnFlowIncrementalPullConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("datetimeTypeFieldName", "DatetimeTypeFieldName", properties.DatetimeTypeFieldName != null ? cfn_parse.FromCloudFormation.getString(properties.DatetimeTypeFieldName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_InforNexusSourcePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("object", cdk.requiredValidator)(properties.object)), errors.collect(cdk.propertyValidator("object", cdk.validateString)(properties.object)), errors.wrap('supplied properties not correct for "InforNexusSourcePropertiesProperty"');
    }
    function cfnFlowInforNexusSourcePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_InforNexusSourcePropertiesPropertyValidator(properties).assertSuccess(), { Object: cdk.stringToCloudFormation(properties.object) }) : properties;
    }
    function CfnFlowInforNexusSourcePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("object", "Object", cfn_parse.FromCloudFormation.getString(properties.Object)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_LookoutMetricsDestinationPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("object", cdk.validateString)(properties.object)), errors.wrap('supplied properties not correct for "LookoutMetricsDestinationPropertiesProperty"');
    }
    function cfnFlowLookoutMetricsDestinationPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_LookoutMetricsDestinationPropertiesPropertyValidator(properties).assertSuccess(), { Object: cdk.stringToCloudFormation(properties.object) }) : properties;
    }
    function CfnFlowLookoutMetricsDestinationPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("object", "Object", properties.Object != null ? cfn_parse.FromCloudFormation.getString(properties.Object) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_MarketoDestinationPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("errorHandlingConfig", CfnFlow_ErrorHandlingConfigPropertyValidator)(properties.errorHandlingConfig)), errors.collect(cdk.propertyValidator("object", cdk.requiredValidator)(properties.object)), errors.collect(cdk.propertyValidator("object", cdk.validateString)(properties.object)), errors.wrap('supplied properties not correct for "MarketoDestinationPropertiesProperty"');
    }
    function cfnFlowMarketoDestinationPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_MarketoDestinationPropertiesPropertyValidator(properties).assertSuccess(), { ErrorHandlingConfig: cfnFlowErrorHandlingConfigPropertyToCloudFormation(properties.errorHandlingConfig), Object: cdk.stringToCloudFormation(properties.object) }) : properties;
    }
    function CfnFlowMarketoDestinationPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("errorHandlingConfig", "ErrorHandlingConfig", properties.ErrorHandlingConfig != null ? CfnFlowErrorHandlingConfigPropertyFromCloudFormation(properties.ErrorHandlingConfig) : void 0), ret.addPropertyResult("object", "Object", cfn_parse.FromCloudFormation.getString(properties.Object)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_MarketoSourcePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("object", cdk.requiredValidator)(properties.object)), errors.collect(cdk.propertyValidator("object", cdk.validateString)(properties.object)), errors.wrap('supplied properties not correct for "MarketoSourcePropertiesProperty"');
    }
    function cfnFlowMarketoSourcePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_MarketoSourcePropertiesPropertyValidator(properties).assertSuccess(), { Object: cdk.stringToCloudFormation(properties.object) }) : properties;
    }
    function CfnFlowMarketoSourcePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("object", "Object", cfn_parse.FromCloudFormation.getString(properties.Object)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_MetadataCatalogConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("glueDataCatalog", CfnFlow_GlueDataCatalogPropertyValidator)(properties.glueDataCatalog)), errors.wrap('supplied properties not correct for "MetadataCatalogConfigProperty"');
    }
    function cfnFlowMetadataCatalogConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_MetadataCatalogConfigPropertyValidator(properties).assertSuccess(), { GlueDataCatalog: cfnFlowGlueDataCatalogPropertyToCloudFormation(properties.glueDataCatalog) }) : properties;
    }
    function CfnFlowMetadataCatalogConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("glueDataCatalog", "GlueDataCatalog", properties.GlueDataCatalog != null ? CfnFlowGlueDataCatalogPropertyFromCloudFormation(properties.GlueDataCatalog) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_PardotSourcePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("object", cdk.requiredValidator)(properties.object)), errors.collect(cdk.propertyValidator("object", cdk.validateString)(properties.object)), errors.wrap('supplied properties not correct for "PardotSourcePropertiesProperty"');
    }
    function cfnFlowPardotSourcePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_PardotSourcePropertiesPropertyValidator(properties).assertSuccess(), { Object: cdk.stringToCloudFormation(properties.object) }) : properties;
    }
    function CfnFlowPardotSourcePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("object", "Object", cfn_parse.FromCloudFormation.getString(properties.Object)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_PrefixConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("pathPrefixHierarchy", cdk.listValidator(cdk.validateString))(properties.pathPrefixHierarchy)), errors.collect(cdk.propertyValidator("prefixFormat", cdk.validateString)(properties.prefixFormat)), errors.collect(cdk.propertyValidator("prefixType", cdk.validateString)(properties.prefixType)), errors.wrap('supplied properties not correct for "PrefixConfigProperty"');
    }
    function cfnFlowPrefixConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_PrefixConfigPropertyValidator(properties).assertSuccess(), { PathPrefixHierarchy: cdk.listMapper(cdk.stringToCloudFormation)(properties.pathPrefixHierarchy), PrefixFormat: cdk.stringToCloudFormation(properties.prefixFormat), PrefixType: cdk.stringToCloudFormation(properties.prefixType) }) : properties;
    }
    function CfnFlowPrefixConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("pathPrefixHierarchy", "PathPrefixHierarchy", properties.PathPrefixHierarchy != null ? cfn_parse.FromCloudFormation.getStringArray(properties.PathPrefixHierarchy) : void 0), ret.addPropertyResult("prefixFormat", "PrefixFormat", properties.PrefixFormat != null ? cfn_parse.FromCloudFormation.getString(properties.PrefixFormat) : void 0), ret.addPropertyResult("prefixType", "PrefixType", properties.PrefixType != null ? cfn_parse.FromCloudFormation.getString(properties.PrefixType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_RedshiftDestinationPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketPrefix", cdk.validateString)(properties.bucketPrefix)), errors.collect(cdk.propertyValidator("errorHandlingConfig", CfnFlow_ErrorHandlingConfigPropertyValidator)(properties.errorHandlingConfig)), errors.collect(cdk.propertyValidator("intermediateBucketName", cdk.requiredValidator)(properties.intermediateBucketName)), errors.collect(cdk.propertyValidator("intermediateBucketName", cdk.validateString)(properties.intermediateBucketName)), errors.collect(cdk.propertyValidator("object", cdk.requiredValidator)(properties.object)), errors.collect(cdk.propertyValidator("object", cdk.validateString)(properties.object)), errors.wrap('supplied properties not correct for "RedshiftDestinationPropertiesProperty"');
    }
    function cfnFlowRedshiftDestinationPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_RedshiftDestinationPropertiesPropertyValidator(properties).assertSuccess(), { BucketPrefix: cdk.stringToCloudFormation(properties.bucketPrefix), ErrorHandlingConfig: cfnFlowErrorHandlingConfigPropertyToCloudFormation(properties.errorHandlingConfig), IntermediateBucketName: cdk.stringToCloudFormation(properties.intermediateBucketName), Object: cdk.stringToCloudFormation(properties.object) }) : properties;
    }
    function CfnFlowRedshiftDestinationPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketPrefix", "BucketPrefix", properties.BucketPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.BucketPrefix) : void 0), ret.addPropertyResult("errorHandlingConfig", "ErrorHandlingConfig", properties.ErrorHandlingConfig != null ? CfnFlowErrorHandlingConfigPropertyFromCloudFormation(properties.ErrorHandlingConfig) : void 0), ret.addPropertyResult("intermediateBucketName", "IntermediateBucketName", cfn_parse.FromCloudFormation.getString(properties.IntermediateBucketName)), ret.addPropertyResult("object", "Object", cfn_parse.FromCloudFormation.getString(properties.Object)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_S3DestinationPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketName", cdk.requiredValidator)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketPrefix", cdk.validateString)(properties.bucketPrefix)), errors.collect(cdk.propertyValidator("s3OutputFormatConfig", CfnFlow_S3OutputFormatConfigPropertyValidator)(properties.s3OutputFormatConfig)), errors.wrap('supplied properties not correct for "S3DestinationPropertiesProperty"');
    }
    function cfnFlowS3DestinationPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_S3DestinationPropertiesPropertyValidator(properties).assertSuccess(), { BucketName: cdk.stringToCloudFormation(properties.bucketName), BucketPrefix: cdk.stringToCloudFormation(properties.bucketPrefix), S3OutputFormatConfig: cfnFlowS3OutputFormatConfigPropertyToCloudFormation(properties.s3OutputFormatConfig) }) : properties;
    }
    function CfnFlowS3DestinationPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketName", "BucketName", cfn_parse.FromCloudFormation.getString(properties.BucketName)), ret.addPropertyResult("bucketPrefix", "BucketPrefix", properties.BucketPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.BucketPrefix) : void 0), ret.addPropertyResult("s3OutputFormatConfig", "S3OutputFormatConfig", properties.S3OutputFormatConfig != null ? CfnFlowS3OutputFormatConfigPropertyFromCloudFormation(properties.S3OutputFormatConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_S3InputFormatConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3InputFileType", cdk.validateString)(properties.s3InputFileType)), errors.wrap('supplied properties not correct for "S3InputFormatConfigProperty"');
    }
    function cfnFlowS3InputFormatConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_S3InputFormatConfigPropertyValidator(properties).assertSuccess(), { S3InputFileType: cdk.stringToCloudFormation(properties.s3InputFileType) }) : properties;
    }
    function CfnFlowS3InputFormatConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3InputFileType", "S3InputFileType", properties.S3InputFileType != null ? cfn_parse.FromCloudFormation.getString(properties.S3InputFileType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_S3OutputFormatConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationConfig", CfnFlow_AggregationConfigPropertyValidator)(properties.aggregationConfig)), errors.collect(cdk.propertyValidator("fileType", cdk.validateString)(properties.fileType)), errors.collect(cdk.propertyValidator("prefixConfig", CfnFlow_PrefixConfigPropertyValidator)(properties.prefixConfig)), errors.collect(cdk.propertyValidator("preserveSourceDataTyping", cdk.validateBoolean)(properties.preserveSourceDataTyping)), errors.wrap('supplied properties not correct for "S3OutputFormatConfigProperty"');
    }
    function cfnFlowS3OutputFormatConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_S3OutputFormatConfigPropertyValidator(properties).assertSuccess(), { AggregationConfig: cfnFlowAggregationConfigPropertyToCloudFormation(properties.aggregationConfig), FileType: cdk.stringToCloudFormation(properties.fileType), PrefixConfig: cfnFlowPrefixConfigPropertyToCloudFormation(properties.prefixConfig), PreserveSourceDataTyping: cdk.booleanToCloudFormation(properties.preserveSourceDataTyping) }) : properties;
    }
    function CfnFlowS3OutputFormatConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationConfig", "AggregationConfig", properties.AggregationConfig != null ? CfnFlowAggregationConfigPropertyFromCloudFormation(properties.AggregationConfig) : void 0), ret.addPropertyResult("fileType", "FileType", properties.FileType != null ? cfn_parse.FromCloudFormation.getString(properties.FileType) : void 0), ret.addPropertyResult("prefixConfig", "PrefixConfig", properties.PrefixConfig != null ? CfnFlowPrefixConfigPropertyFromCloudFormation(properties.PrefixConfig) : void 0), ret.addPropertyResult("preserveSourceDataTyping", "PreserveSourceDataTyping", properties.PreserveSourceDataTyping != null ? cfn_parse.FromCloudFormation.getBoolean(properties.PreserveSourceDataTyping) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_S3SourcePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketName", cdk.requiredValidator)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketPrefix", cdk.requiredValidator)(properties.bucketPrefix)), errors.collect(cdk.propertyValidator("bucketPrefix", cdk.validateString)(properties.bucketPrefix)), errors.collect(cdk.propertyValidator("s3InputFormatConfig", CfnFlow_S3InputFormatConfigPropertyValidator)(properties.s3InputFormatConfig)), errors.wrap('supplied properties not correct for "S3SourcePropertiesProperty"');
    }
    function cfnFlowS3SourcePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_S3SourcePropertiesPropertyValidator(properties).assertSuccess(), { BucketName: cdk.stringToCloudFormation(properties.bucketName), BucketPrefix: cdk.stringToCloudFormation(properties.bucketPrefix), S3InputFormatConfig: cfnFlowS3InputFormatConfigPropertyToCloudFormation(properties.s3InputFormatConfig) }) : properties;
    }
    function CfnFlowS3SourcePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketName", "BucketName", cfn_parse.FromCloudFormation.getString(properties.BucketName)), ret.addPropertyResult("bucketPrefix", "BucketPrefix", cfn_parse.FromCloudFormation.getString(properties.BucketPrefix)), ret.addPropertyResult("s3InputFormatConfig", "S3InputFormatConfig", properties.S3InputFormatConfig != null ? CfnFlowS3InputFormatConfigPropertyFromCloudFormation(properties.S3InputFormatConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_SAPODataDestinationPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("errorHandlingConfig", CfnFlow_ErrorHandlingConfigPropertyValidator)(properties.errorHandlingConfig)), errors.collect(cdk.propertyValidator("idFieldNames", cdk.listValidator(cdk.validateString))(properties.idFieldNames)), errors.collect(cdk.propertyValidator("objectPath", cdk.requiredValidator)(properties.objectPath)), errors.collect(cdk.propertyValidator("objectPath", cdk.validateString)(properties.objectPath)), errors.collect(cdk.propertyValidator("successResponseHandlingConfig", CfnFlow_SuccessResponseHandlingConfigPropertyValidator)(properties.successResponseHandlingConfig)), errors.collect(cdk.propertyValidator("writeOperationType", cdk.validateString)(properties.writeOperationType)), errors.wrap('supplied properties not correct for "SAPODataDestinationPropertiesProperty"');
    }
    function cfnFlowSAPODataDestinationPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_SAPODataDestinationPropertiesPropertyValidator(properties).assertSuccess(), { ErrorHandlingConfig: cfnFlowErrorHandlingConfigPropertyToCloudFormation(properties.errorHandlingConfig), IdFieldNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.idFieldNames), ObjectPath: cdk.stringToCloudFormation(properties.objectPath), SuccessResponseHandlingConfig: cfnFlowSuccessResponseHandlingConfigPropertyToCloudFormation(properties.successResponseHandlingConfig), WriteOperationType: cdk.stringToCloudFormation(properties.writeOperationType) }) : properties;
    }
    function CfnFlowSAPODataDestinationPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("errorHandlingConfig", "ErrorHandlingConfig", properties.ErrorHandlingConfig != null ? CfnFlowErrorHandlingConfigPropertyFromCloudFormation(properties.ErrorHandlingConfig) : void 0), ret.addPropertyResult("idFieldNames", "IdFieldNames", properties.IdFieldNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.IdFieldNames) : void 0), ret.addPropertyResult("objectPath", "ObjectPath", cfn_parse.FromCloudFormation.getString(properties.ObjectPath)), ret.addPropertyResult("successResponseHandlingConfig", "SuccessResponseHandlingConfig", properties.SuccessResponseHandlingConfig != null ? CfnFlowSuccessResponseHandlingConfigPropertyFromCloudFormation(properties.SuccessResponseHandlingConfig) : void 0), ret.addPropertyResult("writeOperationType", "WriteOperationType", properties.WriteOperationType != null ? cfn_parse.FromCloudFormation.getString(properties.WriteOperationType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_SAPODataSourcePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("objectPath", cdk.requiredValidator)(properties.objectPath)), errors.collect(cdk.propertyValidator("objectPath", cdk.validateString)(properties.objectPath)), errors.wrap('supplied properties not correct for "SAPODataSourcePropertiesProperty"');
    }
    function cfnFlowSAPODataSourcePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_SAPODataSourcePropertiesPropertyValidator(properties).assertSuccess(), { ObjectPath: cdk.stringToCloudFormation(properties.objectPath) }) : properties;
    }
    function CfnFlowSAPODataSourcePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("objectPath", "ObjectPath", cfn_parse.FromCloudFormation.getString(properties.ObjectPath)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_SalesforceDestinationPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataTransferApi", cdk.validateString)(properties.dataTransferApi)), errors.collect(cdk.propertyValidator("errorHandlingConfig", CfnFlow_ErrorHandlingConfigPropertyValidator)(properties.errorHandlingConfig)), errors.collect(cdk.propertyValidator("idFieldNames", cdk.listValidator(cdk.validateString))(properties.idFieldNames)), errors.collect(cdk.propertyValidator("object", cdk.requiredValidator)(properties.object)), errors.collect(cdk.propertyValidator("object", cdk.validateString)(properties.object)), errors.collect(cdk.propertyValidator("writeOperationType", cdk.validateString)(properties.writeOperationType)), errors.wrap('supplied properties not correct for "SalesforceDestinationPropertiesProperty"');
    }
    function cfnFlowSalesforceDestinationPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_SalesforceDestinationPropertiesPropertyValidator(properties).assertSuccess(), { DataTransferApi: cdk.stringToCloudFormation(properties.dataTransferApi), ErrorHandlingConfig: cfnFlowErrorHandlingConfigPropertyToCloudFormation(properties.errorHandlingConfig), IdFieldNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.idFieldNames), Object: cdk.stringToCloudFormation(properties.object), WriteOperationType: cdk.stringToCloudFormation(properties.writeOperationType) }) : properties;
    }
    function CfnFlowSalesforceDestinationPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataTransferApi", "DataTransferApi", properties.DataTransferApi != null ? cfn_parse.FromCloudFormation.getString(properties.DataTransferApi) : void 0), ret.addPropertyResult("errorHandlingConfig", "ErrorHandlingConfig", properties.ErrorHandlingConfig != null ? CfnFlowErrorHandlingConfigPropertyFromCloudFormation(properties.ErrorHandlingConfig) : void 0), ret.addPropertyResult("idFieldNames", "IdFieldNames", properties.IdFieldNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.IdFieldNames) : void 0), ret.addPropertyResult("object", "Object", cfn_parse.FromCloudFormation.getString(properties.Object)), ret.addPropertyResult("writeOperationType", "WriteOperationType", properties.WriteOperationType != null ? cfn_parse.FromCloudFormation.getString(properties.WriteOperationType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_SalesforceSourcePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataTransferApi", cdk.validateString)(properties.dataTransferApi)), errors.collect(cdk.propertyValidator("enableDynamicFieldUpdate", cdk.validateBoolean)(properties.enableDynamicFieldUpdate)), errors.collect(cdk.propertyValidator("includeDeletedRecords", cdk.validateBoolean)(properties.includeDeletedRecords)), errors.collect(cdk.propertyValidator("object", cdk.requiredValidator)(properties.object)), errors.collect(cdk.propertyValidator("object", cdk.validateString)(properties.object)), errors.wrap('supplied properties not correct for "SalesforceSourcePropertiesProperty"');
    }
    function cfnFlowSalesforceSourcePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_SalesforceSourcePropertiesPropertyValidator(properties).assertSuccess(), { DataTransferApi: cdk.stringToCloudFormation(properties.dataTransferApi), EnableDynamicFieldUpdate: cdk.booleanToCloudFormation(properties.enableDynamicFieldUpdate), IncludeDeletedRecords: cdk.booleanToCloudFormation(properties.includeDeletedRecords), Object: cdk.stringToCloudFormation(properties.object) }) : properties;
    }
    function CfnFlowSalesforceSourcePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataTransferApi", "DataTransferApi", properties.DataTransferApi != null ? cfn_parse.FromCloudFormation.getString(properties.DataTransferApi) : void 0), ret.addPropertyResult("enableDynamicFieldUpdate", "EnableDynamicFieldUpdate", properties.EnableDynamicFieldUpdate != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableDynamicFieldUpdate) : void 0), ret.addPropertyResult("includeDeletedRecords", "IncludeDeletedRecords", properties.IncludeDeletedRecords != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeDeletedRecords) : void 0), ret.addPropertyResult("object", "Object", cfn_parse.FromCloudFormation.getString(properties.Object)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_ScheduledTriggerPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataPullMode", cdk.validateString)(properties.dataPullMode)), errors.collect(cdk.propertyValidator("firstExecutionFrom", cdk.validateNumber)(properties.firstExecutionFrom)), errors.collect(cdk.propertyValidator("flowErrorDeactivationThreshold", cdk.validateNumber)(properties.flowErrorDeactivationThreshold)), errors.collect(cdk.propertyValidator("scheduleEndTime", cdk.validateNumber)(properties.scheduleEndTime)), errors.collect(cdk.propertyValidator("scheduleExpression", cdk.requiredValidator)(properties.scheduleExpression)), errors.collect(cdk.propertyValidator("scheduleExpression", cdk.validateString)(properties.scheduleExpression)), errors.collect(cdk.propertyValidator("scheduleOffset", cdk.validateNumber)(properties.scheduleOffset)), errors.collect(cdk.propertyValidator("scheduleStartTime", cdk.validateNumber)(properties.scheduleStartTime)), errors.collect(cdk.propertyValidator("timeZone", cdk.validateString)(properties.timeZone)), errors.wrap('supplied properties not correct for "ScheduledTriggerPropertiesProperty"');
    }
    function cfnFlowScheduledTriggerPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_ScheduledTriggerPropertiesPropertyValidator(properties).assertSuccess(), { DataPullMode: cdk.stringToCloudFormation(properties.dataPullMode), FirstExecutionFrom: cdk.numberToCloudFormation(properties.firstExecutionFrom), FlowErrorDeactivationThreshold: cdk.numberToCloudFormation(properties.flowErrorDeactivationThreshold), ScheduleEndTime: cdk.numberToCloudFormation(properties.scheduleEndTime), ScheduleExpression: cdk.stringToCloudFormation(properties.scheduleExpression), ScheduleOffset: cdk.numberToCloudFormation(properties.scheduleOffset), ScheduleStartTime: cdk.numberToCloudFormation(properties.scheduleStartTime), TimeZone: cdk.stringToCloudFormation(properties.timeZone) }) : properties;
    }
    function CfnFlowScheduledTriggerPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataPullMode", "DataPullMode", properties.DataPullMode != null ? cfn_parse.FromCloudFormation.getString(properties.DataPullMode) : void 0), ret.addPropertyResult("firstExecutionFrom", "FirstExecutionFrom", properties.FirstExecutionFrom != null ? cfn_parse.FromCloudFormation.getNumber(properties.FirstExecutionFrom) : void 0), ret.addPropertyResult("flowErrorDeactivationThreshold", "FlowErrorDeactivationThreshold", properties.FlowErrorDeactivationThreshold != null ? cfn_parse.FromCloudFormation.getNumber(properties.FlowErrorDeactivationThreshold) : void 0), ret.addPropertyResult("scheduleEndTime", "ScheduleEndTime", properties.ScheduleEndTime != null ? cfn_parse.FromCloudFormation.getNumber(properties.ScheduleEndTime) : void 0), ret.addPropertyResult("scheduleExpression", "ScheduleExpression", cfn_parse.FromCloudFormation.getString(properties.ScheduleExpression)), ret.addPropertyResult("scheduleOffset", "ScheduleOffset", properties.ScheduleOffset != null ? cfn_parse.FromCloudFormation.getNumber(properties.ScheduleOffset) : void 0), ret.addPropertyResult("scheduleStartTime", "ScheduleStartTime", properties.ScheduleStartTime != null ? cfn_parse.FromCloudFormation.getNumber(properties.ScheduleStartTime) : void 0), ret.addPropertyResult("timeZone", "TimeZone", properties.TimeZone != null ? cfn_parse.FromCloudFormation.getString(properties.TimeZone) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_ServiceNowSourcePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("object", cdk.requiredValidator)(properties.object)), errors.collect(cdk.propertyValidator("object", cdk.validateString)(properties.object)), errors.wrap('supplied properties not correct for "ServiceNowSourcePropertiesProperty"');
    }
    function cfnFlowServiceNowSourcePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_ServiceNowSourcePropertiesPropertyValidator(properties).assertSuccess(), { Object: cdk.stringToCloudFormation(properties.object) }) : properties;
    }
    function CfnFlowServiceNowSourcePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("object", "Object", cfn_parse.FromCloudFormation.getString(properties.Object)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_SingularSourcePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("object", cdk.requiredValidator)(properties.object)), errors.collect(cdk.propertyValidator("object", cdk.validateString)(properties.object)), errors.wrap('supplied properties not correct for "SingularSourcePropertiesProperty"');
    }
    function cfnFlowSingularSourcePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_SingularSourcePropertiesPropertyValidator(properties).assertSuccess(), { Object: cdk.stringToCloudFormation(properties.object) }) : properties;
    }
    function CfnFlowSingularSourcePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("object", "Object", cfn_parse.FromCloudFormation.getString(properties.Object)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_SlackSourcePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("object", cdk.requiredValidator)(properties.object)), errors.collect(cdk.propertyValidator("object", cdk.validateString)(properties.object)), errors.wrap('supplied properties not correct for "SlackSourcePropertiesProperty"');
    }
    function cfnFlowSlackSourcePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_SlackSourcePropertiesPropertyValidator(properties).assertSuccess(), { Object: cdk.stringToCloudFormation(properties.object) }) : properties;
    }
    function CfnFlowSlackSourcePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("object", "Object", cfn_parse.FromCloudFormation.getString(properties.Object)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_SnowflakeDestinationPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketPrefix", cdk.validateString)(properties.bucketPrefix)), errors.collect(cdk.propertyValidator("errorHandlingConfig", CfnFlow_ErrorHandlingConfigPropertyValidator)(properties.errorHandlingConfig)), errors.collect(cdk.propertyValidator("intermediateBucketName", cdk.requiredValidator)(properties.intermediateBucketName)), errors.collect(cdk.propertyValidator("intermediateBucketName", cdk.validateString)(properties.intermediateBucketName)), errors.collect(cdk.propertyValidator("object", cdk.requiredValidator)(properties.object)), errors.collect(cdk.propertyValidator("object", cdk.validateString)(properties.object)), errors.wrap('supplied properties not correct for "SnowflakeDestinationPropertiesProperty"');
    }
    function cfnFlowSnowflakeDestinationPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_SnowflakeDestinationPropertiesPropertyValidator(properties).assertSuccess(), { BucketPrefix: cdk.stringToCloudFormation(properties.bucketPrefix), ErrorHandlingConfig: cfnFlowErrorHandlingConfigPropertyToCloudFormation(properties.errorHandlingConfig), IntermediateBucketName: cdk.stringToCloudFormation(properties.intermediateBucketName), Object: cdk.stringToCloudFormation(properties.object) }) : properties;
    }
    function CfnFlowSnowflakeDestinationPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketPrefix", "BucketPrefix", properties.BucketPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.BucketPrefix) : void 0), ret.addPropertyResult("errorHandlingConfig", "ErrorHandlingConfig", properties.ErrorHandlingConfig != null ? CfnFlowErrorHandlingConfigPropertyFromCloudFormation(properties.ErrorHandlingConfig) : void 0), ret.addPropertyResult("intermediateBucketName", "IntermediateBucketName", cfn_parse.FromCloudFormation.getString(properties.IntermediateBucketName)), ret.addPropertyResult("object", "Object", cfn_parse.FromCloudFormation.getString(properties.Object)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_SourceConnectorPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("amplitude", CfnFlow_AmplitudeSourcePropertiesPropertyValidator)(properties.amplitude)), errors.collect(cdk.propertyValidator("customConnector", CfnFlow_CustomConnectorSourcePropertiesPropertyValidator)(properties.customConnector)), errors.collect(cdk.propertyValidator("datadog", CfnFlow_DatadogSourcePropertiesPropertyValidator)(properties.datadog)), errors.collect(cdk.propertyValidator("dynatrace", CfnFlow_DynatraceSourcePropertiesPropertyValidator)(properties.dynatrace)), errors.collect(cdk.propertyValidator("googleAnalytics", CfnFlow_GoogleAnalyticsSourcePropertiesPropertyValidator)(properties.googleAnalytics)), errors.collect(cdk.propertyValidator("inforNexus", CfnFlow_InforNexusSourcePropertiesPropertyValidator)(properties.inforNexus)), errors.collect(cdk.propertyValidator("marketo", CfnFlow_MarketoSourcePropertiesPropertyValidator)(properties.marketo)), errors.collect(cdk.propertyValidator("pardot", CfnFlow_PardotSourcePropertiesPropertyValidator)(properties.pardot)), errors.collect(cdk.propertyValidator("s3", CfnFlow_S3SourcePropertiesPropertyValidator)(properties.s3)), errors.collect(cdk.propertyValidator("sapoData", CfnFlow_SAPODataSourcePropertiesPropertyValidator)(properties.sapoData)), errors.collect(cdk.propertyValidator("salesforce", CfnFlow_SalesforceSourcePropertiesPropertyValidator)(properties.salesforce)), errors.collect(cdk.propertyValidator("serviceNow", CfnFlow_ServiceNowSourcePropertiesPropertyValidator)(properties.serviceNow)), errors.collect(cdk.propertyValidator("singular", CfnFlow_SingularSourcePropertiesPropertyValidator)(properties.singular)), errors.collect(cdk.propertyValidator("slack", CfnFlow_SlackSourcePropertiesPropertyValidator)(properties.slack)), errors.collect(cdk.propertyValidator("trendmicro", CfnFlow_TrendmicroSourcePropertiesPropertyValidator)(properties.trendmicro)), errors.collect(cdk.propertyValidator("veeva", CfnFlow_VeevaSourcePropertiesPropertyValidator)(properties.veeva)), errors.collect(cdk.propertyValidator("zendesk", CfnFlow_ZendeskSourcePropertiesPropertyValidator)(properties.zendesk)), errors.wrap('supplied properties not correct for "SourceConnectorPropertiesProperty"');
    }
    function cfnFlowSourceConnectorPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_SourceConnectorPropertiesPropertyValidator(properties).assertSuccess(), { Amplitude: cfnFlowAmplitudeSourcePropertiesPropertyToCloudFormation(properties.amplitude), CustomConnector: cfnFlowCustomConnectorSourcePropertiesPropertyToCloudFormation(properties.customConnector), Datadog: cfnFlowDatadogSourcePropertiesPropertyToCloudFormation(properties.datadog), Dynatrace: cfnFlowDynatraceSourcePropertiesPropertyToCloudFormation(properties.dynatrace), GoogleAnalytics: cfnFlowGoogleAnalyticsSourcePropertiesPropertyToCloudFormation(properties.googleAnalytics), InforNexus: cfnFlowInforNexusSourcePropertiesPropertyToCloudFormation(properties.inforNexus), Marketo: cfnFlowMarketoSourcePropertiesPropertyToCloudFormation(properties.marketo), Pardot: cfnFlowPardotSourcePropertiesPropertyToCloudFormation(properties.pardot), S3: cfnFlowS3SourcePropertiesPropertyToCloudFormation(properties.s3), SAPOData: cfnFlowSAPODataSourcePropertiesPropertyToCloudFormation(properties.sapoData), Salesforce: cfnFlowSalesforceSourcePropertiesPropertyToCloudFormation(properties.salesforce), ServiceNow: cfnFlowServiceNowSourcePropertiesPropertyToCloudFormation(properties.serviceNow), Singular: cfnFlowSingularSourcePropertiesPropertyToCloudFormation(properties.singular), Slack: cfnFlowSlackSourcePropertiesPropertyToCloudFormation(properties.slack), Trendmicro: cfnFlowTrendmicroSourcePropertiesPropertyToCloudFormation(properties.trendmicro), Veeva: cfnFlowVeevaSourcePropertiesPropertyToCloudFormation(properties.veeva), Zendesk: cfnFlowZendeskSourcePropertiesPropertyToCloudFormation(properties.zendesk) }) : properties;
    }
    function CfnFlowSourceConnectorPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("amplitude", "Amplitude", properties.Amplitude != null ? CfnFlowAmplitudeSourcePropertiesPropertyFromCloudFormation(properties.Amplitude) : void 0), ret.addPropertyResult("customConnector", "CustomConnector", properties.CustomConnector != null ? CfnFlowCustomConnectorSourcePropertiesPropertyFromCloudFormation(properties.CustomConnector) : void 0), ret.addPropertyResult("datadog", "Datadog", properties.Datadog != null ? CfnFlowDatadogSourcePropertiesPropertyFromCloudFormation(properties.Datadog) : void 0), ret.addPropertyResult("dynatrace", "Dynatrace", properties.Dynatrace != null ? CfnFlowDynatraceSourcePropertiesPropertyFromCloudFormation(properties.Dynatrace) : void 0), ret.addPropertyResult("googleAnalytics", "GoogleAnalytics", properties.GoogleAnalytics != null ? CfnFlowGoogleAnalyticsSourcePropertiesPropertyFromCloudFormation(properties.GoogleAnalytics) : void 0), ret.addPropertyResult("inforNexus", "InforNexus", properties.InforNexus != null ? CfnFlowInforNexusSourcePropertiesPropertyFromCloudFormation(properties.InforNexus) : void 0), ret.addPropertyResult("marketo", "Marketo", properties.Marketo != null ? CfnFlowMarketoSourcePropertiesPropertyFromCloudFormation(properties.Marketo) : void 0), ret.addPropertyResult("pardot", "Pardot", properties.Pardot != null ? CfnFlowPardotSourcePropertiesPropertyFromCloudFormation(properties.Pardot) : void 0), ret.addPropertyResult("s3", "S3", properties.S3 != null ? CfnFlowS3SourcePropertiesPropertyFromCloudFormation(properties.S3) : void 0), ret.addPropertyResult("sapoData", "SAPOData", properties.SAPOData != null ? CfnFlowSAPODataSourcePropertiesPropertyFromCloudFormation(properties.SAPOData) : void 0), ret.addPropertyResult("salesforce", "Salesforce", properties.Salesforce != null ? CfnFlowSalesforceSourcePropertiesPropertyFromCloudFormation(properties.Salesforce) : void 0), ret.addPropertyResult("serviceNow", "ServiceNow", properties.ServiceNow != null ? CfnFlowServiceNowSourcePropertiesPropertyFromCloudFormation(properties.ServiceNow) : void 0), ret.addPropertyResult("singular", "Singular", properties.Singular != null ? CfnFlowSingularSourcePropertiesPropertyFromCloudFormation(properties.Singular) : void 0), ret.addPropertyResult("slack", "Slack", properties.Slack != null ? CfnFlowSlackSourcePropertiesPropertyFromCloudFormation(properties.Slack) : void 0), ret.addPropertyResult("trendmicro", "Trendmicro", properties.Trendmicro != null ? CfnFlowTrendmicroSourcePropertiesPropertyFromCloudFormation(properties.Trendmicro) : void 0), ret.addPropertyResult("veeva", "Veeva", properties.Veeva != null ? CfnFlowVeevaSourcePropertiesPropertyFromCloudFormation(properties.Veeva) : void 0), ret.addPropertyResult("zendesk", "Zendesk", properties.Zendesk != null ? CfnFlowZendeskSourcePropertiesPropertyFromCloudFormation(properties.Zendesk) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_SourceFlowConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiVersion", cdk.validateString)(properties.apiVersion)), errors.collect(cdk.propertyValidator("connectorProfileName", cdk.validateString)(properties.connectorProfileName)), errors.collect(cdk.propertyValidator("connectorType", cdk.requiredValidator)(properties.connectorType)), errors.collect(cdk.propertyValidator("connectorType", cdk.validateString)(properties.connectorType)), errors.collect(cdk.propertyValidator("incrementalPullConfig", CfnFlow_IncrementalPullConfigPropertyValidator)(properties.incrementalPullConfig)), errors.collect(cdk.propertyValidator("sourceConnectorProperties", cdk.requiredValidator)(properties.sourceConnectorProperties)), errors.collect(cdk.propertyValidator("sourceConnectorProperties", CfnFlow_SourceConnectorPropertiesPropertyValidator)(properties.sourceConnectorProperties)), errors.wrap('supplied properties not correct for "SourceFlowConfigProperty"');
    }
    function cfnFlowSourceFlowConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_SourceFlowConfigPropertyValidator(properties).assertSuccess(), { ApiVersion: cdk.stringToCloudFormation(properties.apiVersion), ConnectorProfileName: cdk.stringToCloudFormation(properties.connectorProfileName), ConnectorType: cdk.stringToCloudFormation(properties.connectorType), IncrementalPullConfig: cfnFlowIncrementalPullConfigPropertyToCloudFormation(properties.incrementalPullConfig), SourceConnectorProperties: cfnFlowSourceConnectorPropertiesPropertyToCloudFormation(properties.sourceConnectorProperties) }) : properties;
    }
    function CfnFlowSourceFlowConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiVersion", "ApiVersion", properties.ApiVersion != null ? cfn_parse.FromCloudFormation.getString(properties.ApiVersion) : void 0), ret.addPropertyResult("connectorProfileName", "ConnectorProfileName", properties.ConnectorProfileName != null ? cfn_parse.FromCloudFormation.getString(properties.ConnectorProfileName) : void 0), ret.addPropertyResult("connectorType", "ConnectorType", cfn_parse.FromCloudFormation.getString(properties.ConnectorType)), ret.addPropertyResult("incrementalPullConfig", "IncrementalPullConfig", properties.IncrementalPullConfig != null ? CfnFlowIncrementalPullConfigPropertyFromCloudFormation(properties.IncrementalPullConfig) : void 0), ret.addPropertyResult("sourceConnectorProperties", "SourceConnectorProperties", CfnFlowSourceConnectorPropertiesPropertyFromCloudFormation(properties.SourceConnectorProperties)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_SuccessResponseHandlingConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketPrefix", cdk.validateString)(properties.bucketPrefix)), errors.wrap('supplied properties not correct for "SuccessResponseHandlingConfigProperty"');
    }
    function cfnFlowSuccessResponseHandlingConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_SuccessResponseHandlingConfigPropertyValidator(properties).assertSuccess(), { BucketName: cdk.stringToCloudFormation(properties.bucketName), BucketPrefix: cdk.stringToCloudFormation(properties.bucketPrefix) }) : properties;
    }
    function CfnFlowSuccessResponseHandlingConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketName", "BucketName", properties.BucketName != null ? cfn_parse.FromCloudFormation.getString(properties.BucketName) : void 0), ret.addPropertyResult("bucketPrefix", "BucketPrefix", properties.BucketPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.BucketPrefix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_TaskPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectorOperator", CfnFlow_ConnectorOperatorPropertyValidator)(properties.connectorOperator)), errors.collect(cdk.propertyValidator("destinationField", cdk.validateString)(properties.destinationField)), errors.collect(cdk.propertyValidator("sourceFields", cdk.requiredValidator)(properties.sourceFields)), errors.collect(cdk.propertyValidator("sourceFields", cdk.listValidator(cdk.validateString))(properties.sourceFields)), errors.collect(cdk.propertyValidator("taskProperties", cdk.listValidator(CfnFlow_TaskPropertiesObjectPropertyValidator))(properties.taskProperties)), errors.collect(cdk.propertyValidator("taskType", cdk.requiredValidator)(properties.taskType)), errors.collect(cdk.propertyValidator("taskType", cdk.validateString)(properties.taskType)), errors.wrap('supplied properties not correct for "TaskProperty"');
    }
    function cfnFlowTaskPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_TaskPropertyValidator(properties).assertSuccess(), { ConnectorOperator: cfnFlowConnectorOperatorPropertyToCloudFormation(properties.connectorOperator), DestinationField: cdk.stringToCloudFormation(properties.destinationField), SourceFields: cdk.listMapper(cdk.stringToCloudFormation)(properties.sourceFields), TaskProperties: cdk.listMapper(cfnFlowTaskPropertiesObjectPropertyToCloudFormation)(properties.taskProperties), TaskType: cdk.stringToCloudFormation(properties.taskType) }) : properties;
    }
    function CfnFlowTaskPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectorOperator", "ConnectorOperator", properties.ConnectorOperator != null ? CfnFlowConnectorOperatorPropertyFromCloudFormation(properties.ConnectorOperator) : void 0), ret.addPropertyResult("destinationField", "DestinationField", properties.DestinationField != null ? cfn_parse.FromCloudFormation.getString(properties.DestinationField) : void 0), ret.addPropertyResult("sourceFields", "SourceFields", cfn_parse.FromCloudFormation.getStringArray(properties.SourceFields)), ret.addPropertyResult("taskProperties", "TaskProperties", properties.TaskProperties != null ? cfn_parse.FromCloudFormation.getArray(CfnFlowTaskPropertiesObjectPropertyFromCloudFormation)(properties.TaskProperties) : void 0), ret.addPropertyResult("taskType", "TaskType", cfn_parse.FromCloudFormation.getString(properties.TaskType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_TaskPropertiesObjectPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TaskPropertiesObjectProperty"');
    }
    function cfnFlowTaskPropertiesObjectPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_TaskPropertiesObjectPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnFlowTaskPropertiesObjectPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_TrendmicroSourcePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("object", cdk.requiredValidator)(properties.object)), errors.collect(cdk.propertyValidator("object", cdk.validateString)(properties.object)), errors.wrap('supplied properties not correct for "TrendmicroSourcePropertiesProperty"');
    }
    function cfnFlowTrendmicroSourcePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_TrendmicroSourcePropertiesPropertyValidator(properties).assertSuccess(), { Object: cdk.stringToCloudFormation(properties.object) }) : properties;
    }
    function CfnFlowTrendmicroSourcePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("object", "Object", cfn_parse.FromCloudFormation.getString(properties.Object)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_TriggerConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("activateFlowOnCreate", cdk.validateBoolean)(properties.activateFlowOnCreate)), errors.collect(cdk.propertyValidator("triggerProperties", CfnFlow_ScheduledTriggerPropertiesPropertyValidator)(properties.triggerProperties)), errors.collect(cdk.propertyValidator("triggerType", cdk.requiredValidator)(properties.triggerType)), errors.collect(cdk.propertyValidator("triggerType", cdk.validateString)(properties.triggerType)), errors.wrap('supplied properties not correct for "TriggerConfigProperty"');
    }
    function cfnFlowTriggerConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_TriggerConfigPropertyValidator(properties).assertSuccess(), { ActivateFlowOnCreate: cdk.booleanToCloudFormation(properties.activateFlowOnCreate), TriggerProperties: cfnFlowScheduledTriggerPropertiesPropertyToCloudFormation(properties.triggerProperties), TriggerType: cdk.stringToCloudFormation(properties.triggerType) }) : properties;
    }
    function CfnFlowTriggerConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("activateFlowOnCreate", "ActivateFlowOnCreate", properties.ActivateFlowOnCreate != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ActivateFlowOnCreate) : void 0), ret.addPropertyResult("triggerProperties", "TriggerProperties", properties.TriggerProperties != null ? CfnFlowScheduledTriggerPropertiesPropertyFromCloudFormation(properties.TriggerProperties) : void 0), ret.addPropertyResult("triggerType", "TriggerType", cfn_parse.FromCloudFormation.getString(properties.TriggerType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_UpsolverDestinationPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketName", cdk.requiredValidator)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketPrefix", cdk.validateString)(properties.bucketPrefix)), errors.collect(cdk.propertyValidator("s3OutputFormatConfig", cdk.requiredValidator)(properties.s3OutputFormatConfig)), errors.collect(cdk.propertyValidator("s3OutputFormatConfig", CfnFlow_UpsolverS3OutputFormatConfigPropertyValidator)(properties.s3OutputFormatConfig)), errors.wrap('supplied properties not correct for "UpsolverDestinationPropertiesProperty"');
    }
    function cfnFlowUpsolverDestinationPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_UpsolverDestinationPropertiesPropertyValidator(properties).assertSuccess(), { BucketName: cdk.stringToCloudFormation(properties.bucketName), BucketPrefix: cdk.stringToCloudFormation(properties.bucketPrefix), S3OutputFormatConfig: cfnFlowUpsolverS3OutputFormatConfigPropertyToCloudFormation(properties.s3OutputFormatConfig) }) : properties;
    }
    function CfnFlowUpsolverDestinationPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketName", "BucketName", cfn_parse.FromCloudFormation.getString(properties.BucketName)), ret.addPropertyResult("bucketPrefix", "BucketPrefix", properties.BucketPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.BucketPrefix) : void 0), ret.addPropertyResult("s3OutputFormatConfig", "S3OutputFormatConfig", CfnFlowUpsolverS3OutputFormatConfigPropertyFromCloudFormation(properties.S3OutputFormatConfig)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_UpsolverS3OutputFormatConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationConfig", CfnFlow_AggregationConfigPropertyValidator)(properties.aggregationConfig)), errors.collect(cdk.propertyValidator("fileType", cdk.validateString)(properties.fileType)), errors.collect(cdk.propertyValidator("prefixConfig", cdk.requiredValidator)(properties.prefixConfig)), errors.collect(cdk.propertyValidator("prefixConfig", CfnFlow_PrefixConfigPropertyValidator)(properties.prefixConfig)), errors.wrap('supplied properties not correct for "UpsolverS3OutputFormatConfigProperty"');
    }
    function cfnFlowUpsolverS3OutputFormatConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_UpsolverS3OutputFormatConfigPropertyValidator(properties).assertSuccess(), { AggregationConfig: cfnFlowAggregationConfigPropertyToCloudFormation(properties.aggregationConfig), FileType: cdk.stringToCloudFormation(properties.fileType), PrefixConfig: cfnFlowPrefixConfigPropertyToCloudFormation(properties.prefixConfig) }) : properties;
    }
    function CfnFlowUpsolverS3OutputFormatConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationConfig", "AggregationConfig", properties.AggregationConfig != null ? CfnFlowAggregationConfigPropertyFromCloudFormation(properties.AggregationConfig) : void 0), ret.addPropertyResult("fileType", "FileType", properties.FileType != null ? cfn_parse.FromCloudFormation.getString(properties.FileType) : void 0), ret.addPropertyResult("prefixConfig", "PrefixConfig", CfnFlowPrefixConfigPropertyFromCloudFormation(properties.PrefixConfig)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_VeevaSourcePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("documentType", cdk.validateString)(properties.documentType)), errors.collect(cdk.propertyValidator("includeAllVersions", cdk.validateBoolean)(properties.includeAllVersions)), errors.collect(cdk.propertyValidator("includeRenditions", cdk.validateBoolean)(properties.includeRenditions)), errors.collect(cdk.propertyValidator("includeSourceFiles", cdk.validateBoolean)(properties.includeSourceFiles)), errors.collect(cdk.propertyValidator("object", cdk.requiredValidator)(properties.object)), errors.collect(cdk.propertyValidator("object", cdk.validateString)(properties.object)), errors.wrap('supplied properties not correct for "VeevaSourcePropertiesProperty"');
    }
    function cfnFlowVeevaSourcePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_VeevaSourcePropertiesPropertyValidator(properties).assertSuccess(), { DocumentType: cdk.stringToCloudFormation(properties.documentType), IncludeAllVersions: cdk.booleanToCloudFormation(properties.includeAllVersions), IncludeRenditions: cdk.booleanToCloudFormation(properties.includeRenditions), IncludeSourceFiles: cdk.booleanToCloudFormation(properties.includeSourceFiles), Object: cdk.stringToCloudFormation(properties.object) }) : properties;
    }
    function CfnFlowVeevaSourcePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("documentType", "DocumentType", properties.DocumentType != null ? cfn_parse.FromCloudFormation.getString(properties.DocumentType) : void 0), ret.addPropertyResult("includeAllVersions", "IncludeAllVersions", properties.IncludeAllVersions != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeAllVersions) : void 0), ret.addPropertyResult("includeRenditions", "IncludeRenditions", properties.IncludeRenditions != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeRenditions) : void 0), ret.addPropertyResult("includeSourceFiles", "IncludeSourceFiles", properties.IncludeSourceFiles != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeSourceFiles) : void 0), ret.addPropertyResult("object", "Object", cfn_parse.FromCloudFormation.getString(properties.Object)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_ZendeskDestinationPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("errorHandlingConfig", CfnFlow_ErrorHandlingConfigPropertyValidator)(properties.errorHandlingConfig)), errors.collect(cdk.propertyValidator("idFieldNames", cdk.listValidator(cdk.validateString))(properties.idFieldNames)), errors.collect(cdk.propertyValidator("object", cdk.requiredValidator)(properties.object)), errors.collect(cdk.propertyValidator("object", cdk.validateString)(properties.object)), errors.collect(cdk.propertyValidator("writeOperationType", cdk.validateString)(properties.writeOperationType)), errors.wrap('supplied properties not correct for "ZendeskDestinationPropertiesProperty"');
    }
    function cfnFlowZendeskDestinationPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_ZendeskDestinationPropertiesPropertyValidator(properties).assertSuccess(), { ErrorHandlingConfig: cfnFlowErrorHandlingConfigPropertyToCloudFormation(properties.errorHandlingConfig), IdFieldNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.idFieldNames), Object: cdk.stringToCloudFormation(properties.object), WriteOperationType: cdk.stringToCloudFormation(properties.writeOperationType) }) : properties;
    }
    function CfnFlowZendeskDestinationPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("errorHandlingConfig", "ErrorHandlingConfig", properties.ErrorHandlingConfig != null ? CfnFlowErrorHandlingConfigPropertyFromCloudFormation(properties.ErrorHandlingConfig) : void 0), ret.addPropertyResult("idFieldNames", "IdFieldNames", properties.IdFieldNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.IdFieldNames) : void 0), ret.addPropertyResult("object", "Object", cfn_parse.FromCloudFormation.getString(properties.Object)), ret.addPropertyResult("writeOperationType", "WriteOperationType", properties.WriteOperationType != null ? cfn_parse.FromCloudFormation.getString(properties.WriteOperationType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_ZendeskSourcePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("object", cdk.requiredValidator)(properties.object)), errors.collect(cdk.propertyValidator("object", cdk.validateString)(properties.object)), errors.wrap('supplied properties not correct for "ZendeskSourcePropertiesProperty"');
    }
    function cfnFlowZendeskSourcePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_ZendeskSourcePropertiesPropertyValidator(properties).assertSuccess(), { Object: cdk.stringToCloudFormation(properties.object) }) : properties;
    }
    function CfnFlowZendeskSourcePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("object", "Object", cfn_parse.FromCloudFormation.getString(properties.Object)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-appflow/lib/index.js
var require_lib42 = __commonJS({
  "node_modules/aws-cdk-lib/aws-appflow/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_appflow_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-appflow/index.js
var require_aws_appflow = __commonJS({
  "node_modules/aws-cdk-lib/aws-appflow/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib42(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-appintegrations/lib/appintegrations.generated.js
var require_appintegrations_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-appintegrations/lib/appintegrations.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnEventIntegration = exports2.CfnDataIntegration = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnDataIntegrationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("fileConfiguration", CfnDataIntegration_FileConfigurationPropertyValidator)(properties.fileConfiguration)), errors.collect(cdk.propertyValidator("kmsKey", cdk.requiredValidator)(properties.kmsKey)), errors.collect(cdk.propertyValidator("kmsKey", cdk.validateString)(properties.kmsKey)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("objectConfiguration", cdk.validateObject)(properties.objectConfiguration)), errors.collect(cdk.propertyValidator("scheduleConfig", cdk.requiredValidator)(properties.scheduleConfig)), errors.collect(cdk.propertyValidator("scheduleConfig", CfnDataIntegration_ScheduleConfigPropertyValidator)(properties.scheduleConfig)), errors.collect(cdk.propertyValidator("sourceUri", cdk.requiredValidator)(properties.sourceUri)), errors.collect(cdk.propertyValidator("sourceUri", cdk.validateString)(properties.sourceUri)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDataIntegrationProps"');
    }
    function cfnDataIntegrationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataIntegrationPropsValidator(properties).assertSuccess(), { KmsKey: cdk.stringToCloudFormation(properties.kmsKey), Name: cdk.stringToCloudFormation(properties.name), ScheduleConfig: cfnDataIntegrationScheduleConfigPropertyToCloudFormation(properties.scheduleConfig), SourceURI: cdk.stringToCloudFormation(properties.sourceUri), Description: cdk.stringToCloudFormation(properties.description), FileConfiguration: cfnDataIntegrationFileConfigurationPropertyToCloudFormation(properties.fileConfiguration), ObjectConfiguration: cdk.objectToCloudFormation(properties.objectConfiguration), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDataIntegrationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsKey", "KmsKey", cfn_parse.FromCloudFormation.getString(properties.KmsKey)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("scheduleConfig", "ScheduleConfig", CfnDataIntegrationScheduleConfigPropertyFromCloudFormation(properties.ScheduleConfig)), ret.addPropertyResult("sourceUri", "SourceURI", cfn_parse.FromCloudFormation.getString(properties.SourceURI)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("fileConfiguration", "FileConfiguration", properties.FileConfiguration != null ? CfnDataIntegrationFileConfigurationPropertyFromCloudFormation(properties.FileConfiguration) : void 0), ret.addPropertyResult("objectConfiguration", "ObjectConfiguration", properties.ObjectConfiguration != null ? cfn_parse.FromCloudFormation.getAny(properties.ObjectConfiguration) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDataIntegration = class _CfnDataIntegration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDataIntegrationPropsFromCloudFormation(resourceProperties), ret = new _CfnDataIntegration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDataIntegration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appintegrations_CfnDataIntegrationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDataIntegration), error;
        }
        cdk.requireProperty(props, "kmsKey", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "scheduleConfig", this), cdk.requireProperty(props, "sourceUri", this), this.attrDataIntegrationArn = cdk.Token.asString(this.getAtt("DataIntegrationArn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.kmsKey = props.kmsKey, this.name = props.name, this.scheduleConfig = props.scheduleConfig, this.sourceUri = props.sourceUri, this.description = props.description, this.fileConfiguration = props.fileConfiguration, this.objectConfiguration = props.objectConfiguration, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::AppIntegrations::DataIntegration", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDataIntegration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { kmsKey: this.kmsKey, name: this.name, scheduleConfig: this.scheduleConfig, sourceUri: this.sourceUri, description: this.description, fileConfiguration: this.fileConfiguration, objectConfiguration: this.objectConfiguration, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDataIntegrationPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnDataIntegration[_a] = { fqn: "aws-cdk-lib.aws_appintegrations.CfnDataIntegration", version: "2.80.0" }, CfnDataIntegration.CFN_RESOURCE_TYPE_NAME = "AWS::AppIntegrations::DataIntegration", exports2.CfnDataIntegration = CfnDataIntegration;
    function CfnDataIntegration_FileConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("filters", cdk.validateObject)(properties.filters)), errors.collect(cdk.propertyValidator("folders", cdk.requiredValidator)(properties.folders)), errors.collect(cdk.propertyValidator("folders", cdk.listValidator(cdk.validateString))(properties.folders)), errors.wrap('supplied properties not correct for "FileConfigurationProperty"');
    }
    function cfnDataIntegrationFileConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataIntegration_FileConfigurationPropertyValidator(properties).assertSuccess(), { Filters: cdk.objectToCloudFormation(properties.filters), Folders: cdk.listMapper(cdk.stringToCloudFormation)(properties.folders) }) : properties;
    }
    function CfnDataIntegrationFileConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("filters", "Filters", properties.Filters != null ? cfn_parse.FromCloudFormation.getAny(properties.Filters) : void 0), ret.addPropertyResult("folders", "Folders", cfn_parse.FromCloudFormation.getStringArray(properties.Folders)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataIntegration_ScheduleConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("firstExecutionFrom", cdk.validateString)(properties.firstExecutionFrom)), errors.collect(cdk.propertyValidator("object", cdk.validateString)(properties.object)), errors.collect(cdk.propertyValidator("scheduleExpression", cdk.requiredValidator)(properties.scheduleExpression)), errors.collect(cdk.propertyValidator("scheduleExpression", cdk.validateString)(properties.scheduleExpression)), errors.wrap('supplied properties not correct for "ScheduleConfigProperty"');
    }
    function cfnDataIntegrationScheduleConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataIntegration_ScheduleConfigPropertyValidator(properties).assertSuccess(), { FirstExecutionFrom: cdk.stringToCloudFormation(properties.firstExecutionFrom), Object: cdk.stringToCloudFormation(properties.object), ScheduleExpression: cdk.stringToCloudFormation(properties.scheduleExpression) }) : properties;
    }
    function CfnDataIntegrationScheduleConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("firstExecutionFrom", "FirstExecutionFrom", properties.FirstExecutionFrom != null ? cfn_parse.FromCloudFormation.getString(properties.FirstExecutionFrom) : void 0), ret.addPropertyResult("object", "Object", properties.Object != null ? cfn_parse.FromCloudFormation.getString(properties.Object) : void 0), ret.addPropertyResult("scheduleExpression", "ScheduleExpression", cfn_parse.FromCloudFormation.getString(properties.ScheduleExpression)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEventIntegrationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("eventBridgeBus", cdk.requiredValidator)(properties.eventBridgeBus)), errors.collect(cdk.propertyValidator("eventBridgeBus", cdk.validateString)(properties.eventBridgeBus)), errors.collect(cdk.propertyValidator("eventFilter", cdk.requiredValidator)(properties.eventFilter)), errors.collect(cdk.propertyValidator("eventFilter", CfnEventIntegration_EventFilterPropertyValidator)(properties.eventFilter)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnEventIntegrationProps"');
    }
    function cfnEventIntegrationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventIntegrationPropsValidator(properties).assertSuccess(), { EventBridgeBus: cdk.stringToCloudFormation(properties.eventBridgeBus), EventFilter: cfnEventIntegrationEventFilterPropertyToCloudFormation(properties.eventFilter), Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnEventIntegrationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("eventBridgeBus", "EventBridgeBus", cfn_parse.FromCloudFormation.getString(properties.EventBridgeBus)), ret.addPropertyResult("eventFilter", "EventFilter", CfnEventIntegrationEventFilterPropertyFromCloudFormation(properties.EventFilter)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEventIntegration = class _CfnEventIntegration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEventIntegrationPropsFromCloudFormation(resourceProperties), ret = new _CfnEventIntegration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEventIntegration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appintegrations_CfnEventIntegrationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEventIntegration), error;
        }
        cdk.requireProperty(props, "eventBridgeBus", this), cdk.requireProperty(props, "eventFilter", this), cdk.requireProperty(props, "name", this), this.attrEventIntegrationArn = cdk.Token.asString(this.getAtt("EventIntegrationArn", cdk.ResolutionTypeHint.STRING)), this.eventBridgeBus = props.eventBridgeBus, this.eventFilter = props.eventFilter, this.name = props.name, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::AppIntegrations::EventIntegration", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEventIntegration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { eventBridgeBus: this.eventBridgeBus, eventFilter: this.eventFilter, name: this.name, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnEventIntegrationPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnEventIntegration[_b] = { fqn: "aws-cdk-lib.aws_appintegrations.CfnEventIntegration", version: "2.80.0" }, CfnEventIntegration.CFN_RESOURCE_TYPE_NAME = "AWS::AppIntegrations::EventIntegration", exports2.CfnEventIntegration = CfnEventIntegration;
    function CfnEventIntegration_EventFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("source", cdk.requiredValidator)(properties.source)), errors.collect(cdk.propertyValidator("source", cdk.validateString)(properties.source)), errors.wrap('supplied properties not correct for "EventFilterProperty"');
    }
    function cfnEventIntegrationEventFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventIntegration_EventFilterPropertyValidator(properties).assertSuccess(), { Source: cdk.stringToCloudFormation(properties.source) }) : properties;
    }
    function CfnEventIntegrationEventFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("source", "Source", cfn_parse.FromCloudFormation.getString(properties.Source)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-appintegrations/lib/index.js
var require_lib43 = __commonJS({
  "node_modules/aws-cdk-lib/aws-appintegrations/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_appintegrations_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-appintegrations/index.js
var require_aws_appintegrations = __commonJS({
  "node_modules/aws-cdk-lib/aws-appintegrations/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib43(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-applicationinsights/lib/applicationinsights.generated.js
var require_applicationinsights_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-applicationinsights/lib/applicationinsights.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnApplication = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnApplicationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoConfigurationEnabled", cdk.validateBoolean)(properties.autoConfigurationEnabled)), errors.collect(cdk.propertyValidator("cweMonitorEnabled", cdk.validateBoolean)(properties.cweMonitorEnabled)), errors.collect(cdk.propertyValidator("componentMonitoringSettings", cdk.listValidator(CfnApplication_ComponentMonitoringSettingPropertyValidator))(properties.componentMonitoringSettings)), errors.collect(cdk.propertyValidator("customComponents", cdk.listValidator(CfnApplication_CustomComponentPropertyValidator))(properties.customComponents)), errors.collect(cdk.propertyValidator("groupingType", cdk.validateString)(properties.groupingType)), errors.collect(cdk.propertyValidator("logPatternSets", cdk.listValidator(CfnApplication_LogPatternSetPropertyValidator))(properties.logPatternSets)), errors.collect(cdk.propertyValidator("opsCenterEnabled", cdk.validateBoolean)(properties.opsCenterEnabled)), errors.collect(cdk.propertyValidator("opsItemSnsTopicArn", cdk.validateString)(properties.opsItemSnsTopicArn)), errors.collect(cdk.propertyValidator("resourceGroupName", cdk.requiredValidator)(properties.resourceGroupName)), errors.collect(cdk.propertyValidator("resourceGroupName", cdk.validateString)(properties.resourceGroupName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnApplicationProps"');
    }
    function cfnApplicationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationPropsValidator(properties).assertSuccess(), { ResourceGroupName: cdk.stringToCloudFormation(properties.resourceGroupName), AutoConfigurationEnabled: cdk.booleanToCloudFormation(properties.autoConfigurationEnabled), ComponentMonitoringSettings: cdk.listMapper(cfnApplicationComponentMonitoringSettingPropertyToCloudFormation)(properties.componentMonitoringSettings), CustomComponents: cdk.listMapper(cfnApplicationCustomComponentPropertyToCloudFormation)(properties.customComponents), CWEMonitorEnabled: cdk.booleanToCloudFormation(properties.cweMonitorEnabled), GroupingType: cdk.stringToCloudFormation(properties.groupingType), LogPatternSets: cdk.listMapper(cfnApplicationLogPatternSetPropertyToCloudFormation)(properties.logPatternSets), OpsCenterEnabled: cdk.booleanToCloudFormation(properties.opsCenterEnabled), OpsItemSNSTopicArn: cdk.stringToCloudFormation(properties.opsItemSnsTopicArn), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnApplicationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceGroupName", "ResourceGroupName", cfn_parse.FromCloudFormation.getString(properties.ResourceGroupName)), ret.addPropertyResult("autoConfigurationEnabled", "AutoConfigurationEnabled", properties.AutoConfigurationEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AutoConfigurationEnabled) : void 0), ret.addPropertyResult("componentMonitoringSettings", "ComponentMonitoringSettings", properties.ComponentMonitoringSettings != null ? cfn_parse.FromCloudFormation.getArray(CfnApplicationComponentMonitoringSettingPropertyFromCloudFormation)(properties.ComponentMonitoringSettings) : void 0), ret.addPropertyResult("customComponents", "CustomComponents", properties.CustomComponents != null ? cfn_parse.FromCloudFormation.getArray(CfnApplicationCustomComponentPropertyFromCloudFormation)(properties.CustomComponents) : void 0), ret.addPropertyResult("cweMonitorEnabled", "CWEMonitorEnabled", properties.CWEMonitorEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CWEMonitorEnabled) : void 0), ret.addPropertyResult("groupingType", "GroupingType", properties.GroupingType != null ? cfn_parse.FromCloudFormation.getString(properties.GroupingType) : void 0), ret.addPropertyResult("logPatternSets", "LogPatternSets", properties.LogPatternSets != null ? cfn_parse.FromCloudFormation.getArray(CfnApplicationLogPatternSetPropertyFromCloudFormation)(properties.LogPatternSets) : void 0), ret.addPropertyResult("opsCenterEnabled", "OpsCenterEnabled", properties.OpsCenterEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.OpsCenterEnabled) : void 0), ret.addPropertyResult("opsItemSnsTopicArn", "OpsItemSNSTopicArn", properties.OpsItemSNSTopicArn != null ? cfn_parse.FromCloudFormation.getString(properties.OpsItemSNSTopicArn) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApplication = class _CfnApplication extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApplicationPropsFromCloudFormation(resourceProperties), ret = new _CfnApplication(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApplication.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_applicationinsights_CfnApplicationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApplication), error;
        }
        cdk.requireProperty(props, "resourceGroupName", this), this.attrApplicationArn = cdk.Token.asString(this.getAtt("ApplicationARN", cdk.ResolutionTypeHint.STRING)), this.resourceGroupName = props.resourceGroupName, this.autoConfigurationEnabled = props.autoConfigurationEnabled, this.componentMonitoringSettings = props.componentMonitoringSettings, this.customComponents = props.customComponents, this.cweMonitorEnabled = props.cweMonitorEnabled, this.groupingType = props.groupingType, this.logPatternSets = props.logPatternSets, this.opsCenterEnabled = props.opsCenterEnabled, this.opsItemSnsTopicArn = props.opsItemSnsTopicArn, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ApplicationInsights::Application", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApplication.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { resourceGroupName: this.resourceGroupName, autoConfigurationEnabled: this.autoConfigurationEnabled, componentMonitoringSettings: this.componentMonitoringSettings, customComponents: this.customComponents, cweMonitorEnabled: this.cweMonitorEnabled, groupingType: this.groupingType, logPatternSets: this.logPatternSets, opsCenterEnabled: this.opsCenterEnabled, opsItemSnsTopicArn: this.opsItemSnsTopicArn, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnApplicationPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnApplication[_a] = { fqn: "aws-cdk-lib.aws_applicationinsights.CfnApplication", version: "2.80.0" }, CfnApplication.CFN_RESOURCE_TYPE_NAME = "AWS::ApplicationInsights::Application", exports2.CfnApplication = CfnApplication;
    function CfnApplication_AlarmPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alarmName", cdk.requiredValidator)(properties.alarmName)), errors.collect(cdk.propertyValidator("alarmName", cdk.validateString)(properties.alarmName)), errors.collect(cdk.propertyValidator("severity", cdk.validateString)(properties.severity)), errors.wrap('supplied properties not correct for "AlarmProperty"');
    }
    function cfnApplicationAlarmPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_AlarmPropertyValidator(properties).assertSuccess(), { AlarmName: cdk.stringToCloudFormation(properties.alarmName), Severity: cdk.stringToCloudFormation(properties.severity) }) : properties;
    }
    function CfnApplicationAlarmPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alarmName", "AlarmName", cfn_parse.FromCloudFormation.getString(properties.AlarmName)), ret.addPropertyResult("severity", "Severity", properties.Severity != null ? cfn_parse.FromCloudFormation.getString(properties.Severity) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_AlarmMetricPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alarmMetricName", cdk.requiredValidator)(properties.alarmMetricName)), errors.collect(cdk.propertyValidator("alarmMetricName", cdk.validateString)(properties.alarmMetricName)), errors.wrap('supplied properties not correct for "AlarmMetricProperty"');
    }
    function cfnApplicationAlarmMetricPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_AlarmMetricPropertyValidator(properties).assertSuccess(), { AlarmMetricName: cdk.stringToCloudFormation(properties.alarmMetricName) }) : properties;
    }
    function CfnApplicationAlarmMetricPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alarmMetricName", "AlarmMetricName", cfn_parse.FromCloudFormation.getString(properties.AlarmMetricName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_ComponentConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configurationDetails", CfnApplication_ConfigurationDetailsPropertyValidator)(properties.configurationDetails)), errors.collect(cdk.propertyValidator("subComponentTypeConfigurations", cdk.listValidator(CfnApplication_SubComponentTypeConfigurationPropertyValidator))(properties.subComponentTypeConfigurations)), errors.wrap('supplied properties not correct for "ComponentConfigurationProperty"');
    }
    function cfnApplicationComponentConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_ComponentConfigurationPropertyValidator(properties).assertSuccess(), { ConfigurationDetails: cfnApplicationConfigurationDetailsPropertyToCloudFormation(properties.configurationDetails), SubComponentTypeConfigurations: cdk.listMapper(cfnApplicationSubComponentTypeConfigurationPropertyToCloudFormation)(properties.subComponentTypeConfigurations) }) : properties;
    }
    function CfnApplicationComponentConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configurationDetails", "ConfigurationDetails", properties.ConfigurationDetails != null ? CfnApplicationConfigurationDetailsPropertyFromCloudFormation(properties.ConfigurationDetails) : void 0), ret.addPropertyResult("subComponentTypeConfigurations", "SubComponentTypeConfigurations", properties.SubComponentTypeConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnApplicationSubComponentTypeConfigurationPropertyFromCloudFormation)(properties.SubComponentTypeConfigurations) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_ComponentMonitoringSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("componentArn", cdk.validateString)(properties.componentArn)), errors.collect(cdk.propertyValidator("componentConfigurationMode", cdk.requiredValidator)(properties.componentConfigurationMode)), errors.collect(cdk.propertyValidator("componentConfigurationMode", cdk.validateString)(properties.componentConfigurationMode)), errors.collect(cdk.propertyValidator("componentName", cdk.validateString)(properties.componentName)), errors.collect(cdk.propertyValidator("customComponentConfiguration", CfnApplication_ComponentConfigurationPropertyValidator)(properties.customComponentConfiguration)), errors.collect(cdk.propertyValidator("defaultOverwriteComponentConfiguration", CfnApplication_ComponentConfigurationPropertyValidator)(properties.defaultOverwriteComponentConfiguration)), errors.collect(cdk.propertyValidator("tier", cdk.requiredValidator)(properties.tier)), errors.collect(cdk.propertyValidator("tier", cdk.validateString)(properties.tier)), errors.wrap('supplied properties not correct for "ComponentMonitoringSettingProperty"');
    }
    function cfnApplicationComponentMonitoringSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_ComponentMonitoringSettingPropertyValidator(properties).assertSuccess(), { ComponentARN: cdk.stringToCloudFormation(properties.componentArn), ComponentConfigurationMode: cdk.stringToCloudFormation(properties.componentConfigurationMode), ComponentName: cdk.stringToCloudFormation(properties.componentName), CustomComponentConfiguration: cfnApplicationComponentConfigurationPropertyToCloudFormation(properties.customComponentConfiguration), DefaultOverwriteComponentConfiguration: cfnApplicationComponentConfigurationPropertyToCloudFormation(properties.defaultOverwriteComponentConfiguration), Tier: cdk.stringToCloudFormation(properties.tier) }) : properties;
    }
    function CfnApplicationComponentMonitoringSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("componentArn", "ComponentARN", properties.ComponentARN != null ? cfn_parse.FromCloudFormation.getString(properties.ComponentARN) : void 0), ret.addPropertyResult("componentConfigurationMode", "ComponentConfigurationMode", cfn_parse.FromCloudFormation.getString(properties.ComponentConfigurationMode)), ret.addPropertyResult("componentName", "ComponentName", properties.ComponentName != null ? cfn_parse.FromCloudFormation.getString(properties.ComponentName) : void 0), ret.addPropertyResult("customComponentConfiguration", "CustomComponentConfiguration", properties.CustomComponentConfiguration != null ? CfnApplicationComponentConfigurationPropertyFromCloudFormation(properties.CustomComponentConfiguration) : void 0), ret.addPropertyResult("defaultOverwriteComponentConfiguration", "DefaultOverwriteComponentConfiguration", properties.DefaultOverwriteComponentConfiguration != null ? CfnApplicationComponentConfigurationPropertyFromCloudFormation(properties.DefaultOverwriteComponentConfiguration) : void 0), ret.addPropertyResult("tier", "Tier", cfn_parse.FromCloudFormation.getString(properties.Tier)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_ConfigurationDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alarmMetrics", cdk.listValidator(CfnApplication_AlarmMetricPropertyValidator))(properties.alarmMetrics)), errors.collect(cdk.propertyValidator("alarms", cdk.listValidator(CfnApplication_AlarmPropertyValidator))(properties.alarms)), errors.collect(cdk.propertyValidator("haClusterPrometheusExporter", CfnApplication_HAClusterPrometheusExporterPropertyValidator)(properties.haClusterPrometheusExporter)), errors.collect(cdk.propertyValidator("hanaPrometheusExporter", CfnApplication_HANAPrometheusExporterPropertyValidator)(properties.hanaPrometheusExporter)), errors.collect(cdk.propertyValidator("jmxPrometheusExporter", CfnApplication_JMXPrometheusExporterPropertyValidator)(properties.jmxPrometheusExporter)), errors.collect(cdk.propertyValidator("logs", cdk.listValidator(CfnApplication_LogPropertyValidator))(properties.logs)), errors.collect(cdk.propertyValidator("windowsEvents", cdk.listValidator(CfnApplication_WindowsEventPropertyValidator))(properties.windowsEvents)), errors.wrap('supplied properties not correct for "ConfigurationDetailsProperty"');
    }
    function cfnApplicationConfigurationDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_ConfigurationDetailsPropertyValidator(properties).assertSuccess(), { AlarmMetrics: cdk.listMapper(cfnApplicationAlarmMetricPropertyToCloudFormation)(properties.alarmMetrics), Alarms: cdk.listMapper(cfnApplicationAlarmPropertyToCloudFormation)(properties.alarms), HAClusterPrometheusExporter: cfnApplicationHAClusterPrometheusExporterPropertyToCloudFormation(properties.haClusterPrometheusExporter), HANAPrometheusExporter: cfnApplicationHANAPrometheusExporterPropertyToCloudFormation(properties.hanaPrometheusExporter), JMXPrometheusExporter: cfnApplicationJMXPrometheusExporterPropertyToCloudFormation(properties.jmxPrometheusExporter), Logs: cdk.listMapper(cfnApplicationLogPropertyToCloudFormation)(properties.logs), WindowsEvents: cdk.listMapper(cfnApplicationWindowsEventPropertyToCloudFormation)(properties.windowsEvents) }) : properties;
    }
    function CfnApplicationConfigurationDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alarmMetrics", "AlarmMetrics", properties.AlarmMetrics != null ? cfn_parse.FromCloudFormation.getArray(CfnApplicationAlarmMetricPropertyFromCloudFormation)(properties.AlarmMetrics) : void 0), ret.addPropertyResult("alarms", "Alarms", properties.Alarms != null ? cfn_parse.FromCloudFormation.getArray(CfnApplicationAlarmPropertyFromCloudFormation)(properties.Alarms) : void 0), ret.addPropertyResult("haClusterPrometheusExporter", "HAClusterPrometheusExporter", properties.HAClusterPrometheusExporter != null ? CfnApplicationHAClusterPrometheusExporterPropertyFromCloudFormation(properties.HAClusterPrometheusExporter) : void 0), ret.addPropertyResult("hanaPrometheusExporter", "HANAPrometheusExporter", properties.HANAPrometheusExporter != null ? CfnApplicationHANAPrometheusExporterPropertyFromCloudFormation(properties.HANAPrometheusExporter) : void 0), ret.addPropertyResult("jmxPrometheusExporter", "JMXPrometheusExporter", properties.JMXPrometheusExporter != null ? CfnApplicationJMXPrometheusExporterPropertyFromCloudFormation(properties.JMXPrometheusExporter) : void 0), ret.addPropertyResult("logs", "Logs", properties.Logs != null ? cfn_parse.FromCloudFormation.getArray(CfnApplicationLogPropertyFromCloudFormation)(properties.Logs) : void 0), ret.addPropertyResult("windowsEvents", "WindowsEvents", properties.WindowsEvents != null ? cfn_parse.FromCloudFormation.getArray(CfnApplicationWindowsEventPropertyFromCloudFormation)(properties.WindowsEvents) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_CustomComponentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("componentName", cdk.requiredValidator)(properties.componentName)), errors.collect(cdk.propertyValidator("componentName", cdk.validateString)(properties.componentName)), errors.collect(cdk.propertyValidator("resourceList", cdk.requiredValidator)(properties.resourceList)), errors.collect(cdk.propertyValidator("resourceList", cdk.listValidator(cdk.validateString))(properties.resourceList)), errors.wrap('supplied properties not correct for "CustomComponentProperty"');
    }
    function cfnApplicationCustomComponentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_CustomComponentPropertyValidator(properties).assertSuccess(), { ComponentName: cdk.stringToCloudFormation(properties.componentName), ResourceList: cdk.listMapper(cdk.stringToCloudFormation)(properties.resourceList) }) : properties;
    }
    function CfnApplicationCustomComponentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("componentName", "ComponentName", cfn_parse.FromCloudFormation.getString(properties.ComponentName)), ret.addPropertyResult("resourceList", "ResourceList", cfn_parse.FromCloudFormation.getStringArray(properties.ResourceList)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_HAClusterPrometheusExporterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("prometheusPort", cdk.validateString)(properties.prometheusPort)), errors.wrap('supplied properties not correct for "HAClusterPrometheusExporterProperty"');
    }
    function cfnApplicationHAClusterPrometheusExporterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_HAClusterPrometheusExporterPropertyValidator(properties).assertSuccess(), { PrometheusPort: cdk.stringToCloudFormation(properties.prometheusPort) }) : properties;
    }
    function CfnApplicationHAClusterPrometheusExporterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("prometheusPort", "PrometheusPort", properties.PrometheusPort != null ? cfn_parse.FromCloudFormation.getString(properties.PrometheusPort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_HANAPrometheusExporterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("agreeToInstallHanadbClient", cdk.requiredValidator)(properties.agreeToInstallHanadbClient)), errors.collect(cdk.propertyValidator("agreeToInstallHanadbClient", cdk.validateBoolean)(properties.agreeToInstallHanadbClient)), errors.collect(cdk.propertyValidator("hanaPort", cdk.requiredValidator)(properties.hanaPort)), errors.collect(cdk.propertyValidator("hanaPort", cdk.validateString)(properties.hanaPort)), errors.collect(cdk.propertyValidator("hanasid", cdk.requiredValidator)(properties.hanasid)), errors.collect(cdk.propertyValidator("hanasid", cdk.validateString)(properties.hanasid)), errors.collect(cdk.propertyValidator("hanaSecretName", cdk.requiredValidator)(properties.hanaSecretName)), errors.collect(cdk.propertyValidator("hanaSecretName", cdk.validateString)(properties.hanaSecretName)), errors.collect(cdk.propertyValidator("prometheusPort", cdk.validateString)(properties.prometheusPort)), errors.wrap('supplied properties not correct for "HANAPrometheusExporterProperty"');
    }
    function cfnApplicationHANAPrometheusExporterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_HANAPrometheusExporterPropertyValidator(properties).assertSuccess(), { AgreeToInstallHANADBClient: cdk.booleanToCloudFormation(properties.agreeToInstallHanadbClient), HANAPort: cdk.stringToCloudFormation(properties.hanaPort), HANASID: cdk.stringToCloudFormation(properties.hanasid), HANASecretName: cdk.stringToCloudFormation(properties.hanaSecretName), PrometheusPort: cdk.stringToCloudFormation(properties.prometheusPort) }) : properties;
    }
    function CfnApplicationHANAPrometheusExporterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("agreeToInstallHanadbClient", "AgreeToInstallHANADBClient", cfn_parse.FromCloudFormation.getBoolean(properties.AgreeToInstallHANADBClient)), ret.addPropertyResult("hanaPort", "HANAPort", cfn_parse.FromCloudFormation.getString(properties.HANAPort)), ret.addPropertyResult("hanasid", "HANASID", cfn_parse.FromCloudFormation.getString(properties.HANASID)), ret.addPropertyResult("hanaSecretName", "HANASecretName", cfn_parse.FromCloudFormation.getString(properties.HANASecretName)), ret.addPropertyResult("prometheusPort", "PrometheusPort", properties.PrometheusPort != null ? cfn_parse.FromCloudFormation.getString(properties.PrometheusPort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_JMXPrometheusExporterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("hostPort", cdk.validateString)(properties.hostPort)), errors.collect(cdk.propertyValidator("jmxurl", cdk.validateString)(properties.jmxurl)), errors.collect(cdk.propertyValidator("prometheusPort", cdk.validateString)(properties.prometheusPort)), errors.wrap('supplied properties not correct for "JMXPrometheusExporterProperty"');
    }
    function cfnApplicationJMXPrometheusExporterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_JMXPrometheusExporterPropertyValidator(properties).assertSuccess(), { HostPort: cdk.stringToCloudFormation(properties.hostPort), JMXURL: cdk.stringToCloudFormation(properties.jmxurl), PrometheusPort: cdk.stringToCloudFormation(properties.prometheusPort) }) : properties;
    }
    function CfnApplicationJMXPrometheusExporterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("hostPort", "HostPort", properties.HostPort != null ? cfn_parse.FromCloudFormation.getString(properties.HostPort) : void 0), ret.addPropertyResult("jmxurl", "JMXURL", properties.JMXURL != null ? cfn_parse.FromCloudFormation.getString(properties.JMXURL) : void 0), ret.addPropertyResult("prometheusPort", "PrometheusPort", properties.PrometheusPort != null ? cfn_parse.FromCloudFormation.getString(properties.PrometheusPort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_LogPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("encoding", cdk.validateString)(properties.encoding)), errors.collect(cdk.propertyValidator("logGroupName", cdk.validateString)(properties.logGroupName)), errors.collect(cdk.propertyValidator("logPath", cdk.validateString)(properties.logPath)), errors.collect(cdk.propertyValidator("logType", cdk.requiredValidator)(properties.logType)), errors.collect(cdk.propertyValidator("logType", cdk.validateString)(properties.logType)), errors.collect(cdk.propertyValidator("patternSet", cdk.validateString)(properties.patternSet)), errors.wrap('supplied properties not correct for "LogProperty"');
    }
    function cfnApplicationLogPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_LogPropertyValidator(properties).assertSuccess(), { Encoding: cdk.stringToCloudFormation(properties.encoding), LogGroupName: cdk.stringToCloudFormation(properties.logGroupName), LogPath: cdk.stringToCloudFormation(properties.logPath), LogType: cdk.stringToCloudFormation(properties.logType), PatternSet: cdk.stringToCloudFormation(properties.patternSet) }) : properties;
    }
    function CfnApplicationLogPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("encoding", "Encoding", properties.Encoding != null ? cfn_parse.FromCloudFormation.getString(properties.Encoding) : void 0), ret.addPropertyResult("logGroupName", "LogGroupName", properties.LogGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.LogGroupName) : void 0), ret.addPropertyResult("logPath", "LogPath", properties.LogPath != null ? cfn_parse.FromCloudFormation.getString(properties.LogPath) : void 0), ret.addPropertyResult("logType", "LogType", cfn_parse.FromCloudFormation.getString(properties.LogType)), ret.addPropertyResult("patternSet", "PatternSet", properties.PatternSet != null ? cfn_parse.FromCloudFormation.getString(properties.PatternSet) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_LogPatternPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("pattern", cdk.requiredValidator)(properties.pattern)), errors.collect(cdk.propertyValidator("pattern", cdk.validateString)(properties.pattern)), errors.collect(cdk.propertyValidator("patternName", cdk.requiredValidator)(properties.patternName)), errors.collect(cdk.propertyValidator("patternName", cdk.validateString)(properties.patternName)), errors.collect(cdk.propertyValidator("rank", cdk.requiredValidator)(properties.rank)), errors.collect(cdk.propertyValidator("rank", cdk.validateNumber)(properties.rank)), errors.wrap('supplied properties not correct for "LogPatternProperty"');
    }
    function cfnApplicationLogPatternPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_LogPatternPropertyValidator(properties).assertSuccess(), { Pattern: cdk.stringToCloudFormation(properties.pattern), PatternName: cdk.stringToCloudFormation(properties.patternName), Rank: cdk.numberToCloudFormation(properties.rank) }) : properties;
    }
    function CfnApplicationLogPatternPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("pattern", "Pattern", cfn_parse.FromCloudFormation.getString(properties.Pattern)), ret.addPropertyResult("patternName", "PatternName", cfn_parse.FromCloudFormation.getString(properties.PatternName)), ret.addPropertyResult("rank", "Rank", cfn_parse.FromCloudFormation.getNumber(properties.Rank)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_LogPatternSetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logPatterns", cdk.requiredValidator)(properties.logPatterns)), errors.collect(cdk.propertyValidator("logPatterns", cdk.listValidator(CfnApplication_LogPatternPropertyValidator))(properties.logPatterns)), errors.collect(cdk.propertyValidator("patternSetName", cdk.requiredValidator)(properties.patternSetName)), errors.collect(cdk.propertyValidator("patternSetName", cdk.validateString)(properties.patternSetName)), errors.wrap('supplied properties not correct for "LogPatternSetProperty"');
    }
    function cfnApplicationLogPatternSetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_LogPatternSetPropertyValidator(properties).assertSuccess(), { LogPatterns: cdk.listMapper(cfnApplicationLogPatternPropertyToCloudFormation)(properties.logPatterns), PatternSetName: cdk.stringToCloudFormation(properties.patternSetName) }) : properties;
    }
    function CfnApplicationLogPatternSetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logPatterns", "LogPatterns", cfn_parse.FromCloudFormation.getArray(CfnApplicationLogPatternPropertyFromCloudFormation)(properties.LogPatterns)), ret.addPropertyResult("patternSetName", "PatternSetName", cfn_parse.FromCloudFormation.getString(properties.PatternSetName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_SubComponentConfigurationDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alarmMetrics", cdk.listValidator(CfnApplication_AlarmMetricPropertyValidator))(properties.alarmMetrics)), errors.collect(cdk.propertyValidator("logs", cdk.listValidator(CfnApplication_LogPropertyValidator))(properties.logs)), errors.collect(cdk.propertyValidator("windowsEvents", cdk.listValidator(CfnApplication_WindowsEventPropertyValidator))(properties.windowsEvents)), errors.wrap('supplied properties not correct for "SubComponentConfigurationDetailsProperty"');
    }
    function cfnApplicationSubComponentConfigurationDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_SubComponentConfigurationDetailsPropertyValidator(properties).assertSuccess(), { AlarmMetrics: cdk.listMapper(cfnApplicationAlarmMetricPropertyToCloudFormation)(properties.alarmMetrics), Logs: cdk.listMapper(cfnApplicationLogPropertyToCloudFormation)(properties.logs), WindowsEvents: cdk.listMapper(cfnApplicationWindowsEventPropertyToCloudFormation)(properties.windowsEvents) }) : properties;
    }
    function CfnApplicationSubComponentConfigurationDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alarmMetrics", "AlarmMetrics", properties.AlarmMetrics != null ? cfn_parse.FromCloudFormation.getArray(CfnApplicationAlarmMetricPropertyFromCloudFormation)(properties.AlarmMetrics) : void 0), ret.addPropertyResult("logs", "Logs", properties.Logs != null ? cfn_parse.FromCloudFormation.getArray(CfnApplicationLogPropertyFromCloudFormation)(properties.Logs) : void 0), ret.addPropertyResult("windowsEvents", "WindowsEvents", properties.WindowsEvents != null ? cfn_parse.FromCloudFormation.getArray(CfnApplicationWindowsEventPropertyFromCloudFormation)(properties.WindowsEvents) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_SubComponentTypeConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("subComponentConfigurationDetails", cdk.requiredValidator)(properties.subComponentConfigurationDetails)), errors.collect(cdk.propertyValidator("subComponentConfigurationDetails", CfnApplication_SubComponentConfigurationDetailsPropertyValidator)(properties.subComponentConfigurationDetails)), errors.collect(cdk.propertyValidator("subComponentType", cdk.requiredValidator)(properties.subComponentType)), errors.collect(cdk.propertyValidator("subComponentType", cdk.validateString)(properties.subComponentType)), errors.wrap('supplied properties not correct for "SubComponentTypeConfigurationProperty"');
    }
    function cfnApplicationSubComponentTypeConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_SubComponentTypeConfigurationPropertyValidator(properties).assertSuccess(), { SubComponentConfigurationDetails: cfnApplicationSubComponentConfigurationDetailsPropertyToCloudFormation(properties.subComponentConfigurationDetails), SubComponentType: cdk.stringToCloudFormation(properties.subComponentType) }) : properties;
    }
    function CfnApplicationSubComponentTypeConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("subComponentConfigurationDetails", "SubComponentConfigurationDetails", CfnApplicationSubComponentConfigurationDetailsPropertyFromCloudFormation(properties.SubComponentConfigurationDetails)), ret.addPropertyResult("subComponentType", "SubComponentType", cfn_parse.FromCloudFormation.getString(properties.SubComponentType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_WindowsEventPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("eventLevels", cdk.requiredValidator)(properties.eventLevels)), errors.collect(cdk.propertyValidator("eventLevels", cdk.listValidator(cdk.validateString))(properties.eventLevels)), errors.collect(cdk.propertyValidator("eventName", cdk.requiredValidator)(properties.eventName)), errors.collect(cdk.propertyValidator("eventName", cdk.validateString)(properties.eventName)), errors.collect(cdk.propertyValidator("logGroupName", cdk.requiredValidator)(properties.logGroupName)), errors.collect(cdk.propertyValidator("logGroupName", cdk.validateString)(properties.logGroupName)), errors.collect(cdk.propertyValidator("patternSet", cdk.validateString)(properties.patternSet)), errors.wrap('supplied properties not correct for "WindowsEventProperty"');
    }
    function cfnApplicationWindowsEventPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_WindowsEventPropertyValidator(properties).assertSuccess(), { EventLevels: cdk.listMapper(cdk.stringToCloudFormation)(properties.eventLevels), EventName: cdk.stringToCloudFormation(properties.eventName), LogGroupName: cdk.stringToCloudFormation(properties.logGroupName), PatternSet: cdk.stringToCloudFormation(properties.patternSet) }) : properties;
    }
    function CfnApplicationWindowsEventPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("eventLevels", "EventLevels", cfn_parse.FromCloudFormation.getStringArray(properties.EventLevels)), ret.addPropertyResult("eventName", "EventName", cfn_parse.FromCloudFormation.getString(properties.EventName)), ret.addPropertyResult("logGroupName", "LogGroupName", cfn_parse.FromCloudFormation.getString(properties.LogGroupName)), ret.addPropertyResult("patternSet", "PatternSet", properties.PatternSet != null ? cfn_parse.FromCloudFormation.getString(properties.PatternSet) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-applicationinsights/lib/index.js
var require_lib44 = __commonJS({
  "node_modules/aws-cdk-lib/aws-applicationinsights/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_applicationinsights_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-applicationinsights/index.js
var require_aws_applicationinsights = __commonJS({
  "node_modules/aws-cdk-lib/aws-applicationinsights/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib44(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-appmesh/lib/appmesh.generated.js
var require_appmesh_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-appmesh/lib/appmesh.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnVirtualService = exports2.CfnVirtualRouter = exports2.CfnVirtualNode = exports2.CfnVirtualGateway = exports2.CfnRoute = exports2.CfnMesh = exports2.CfnGatewayRoute = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnGatewayRoutePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("gatewayRouteName", cdk.validateString)(properties.gatewayRouteName)), errors.collect(cdk.propertyValidator("meshName", cdk.requiredValidator)(properties.meshName)), errors.collect(cdk.propertyValidator("meshName", cdk.validateString)(properties.meshName)), errors.collect(cdk.propertyValidator("meshOwner", cdk.validateString)(properties.meshOwner)), errors.collect(cdk.propertyValidator("spec", cdk.requiredValidator)(properties.spec)), errors.collect(cdk.propertyValidator("spec", CfnGatewayRoute_GatewayRouteSpecPropertyValidator)(properties.spec)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("virtualGatewayName", cdk.requiredValidator)(properties.virtualGatewayName)), errors.collect(cdk.propertyValidator("virtualGatewayName", cdk.validateString)(properties.virtualGatewayName)), errors.wrap('supplied properties not correct for "CfnGatewayRouteProps"');
    }
    function cfnGatewayRoutePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGatewayRoutePropsValidator(properties).assertSuccess(), { MeshName: cdk.stringToCloudFormation(properties.meshName), Spec: cfnGatewayRouteGatewayRouteSpecPropertyToCloudFormation(properties.spec), VirtualGatewayName: cdk.stringToCloudFormation(properties.virtualGatewayName), GatewayRouteName: cdk.stringToCloudFormation(properties.gatewayRouteName), MeshOwner: cdk.stringToCloudFormation(properties.meshOwner), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnGatewayRoutePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("meshName", "MeshName", cfn_parse.FromCloudFormation.getString(properties.MeshName)), ret.addPropertyResult("spec", "Spec", CfnGatewayRouteGatewayRouteSpecPropertyFromCloudFormation(properties.Spec)), ret.addPropertyResult("virtualGatewayName", "VirtualGatewayName", cfn_parse.FromCloudFormation.getString(properties.VirtualGatewayName)), ret.addPropertyResult("gatewayRouteName", "GatewayRouteName", properties.GatewayRouteName != null ? cfn_parse.FromCloudFormation.getString(properties.GatewayRouteName) : void 0), ret.addPropertyResult("meshOwner", "MeshOwner", properties.MeshOwner != null ? cfn_parse.FromCloudFormation.getString(properties.MeshOwner) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnGatewayRoute = class _CfnGatewayRoute extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnGatewayRoutePropsFromCloudFormation(resourceProperties), ret = new _CfnGatewayRoute(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnGatewayRoute.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_CfnGatewayRouteProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnGatewayRoute), error;
        }
        cdk.requireProperty(props, "meshName", this), cdk.requireProperty(props, "spec", this), cdk.requireProperty(props, "virtualGatewayName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrGatewayRouteName = cdk.Token.asString(this.getAtt("GatewayRouteName", cdk.ResolutionTypeHint.STRING)), this.attrMeshName = cdk.Token.asString(this.getAtt("MeshName", cdk.ResolutionTypeHint.STRING)), this.attrMeshOwner = cdk.Token.asString(this.getAtt("MeshOwner", cdk.ResolutionTypeHint.STRING)), this.attrResourceOwner = cdk.Token.asString(this.getAtt("ResourceOwner", cdk.ResolutionTypeHint.STRING)), this.attrUid = cdk.Token.asString(this.getAtt("Uid", cdk.ResolutionTypeHint.STRING)), this.attrVirtualGatewayName = cdk.Token.asString(this.getAtt("VirtualGatewayName", cdk.ResolutionTypeHint.STRING)), this.meshName = props.meshName, this.spec = props.spec, this.virtualGatewayName = props.virtualGatewayName, this.gatewayRouteName = props.gatewayRouteName, this.meshOwner = props.meshOwner, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::AppMesh::GatewayRoute", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnGatewayRoute.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { meshName: this.meshName, spec: this.spec, virtualGatewayName: this.virtualGatewayName, gatewayRouteName: this.gatewayRouteName, meshOwner: this.meshOwner, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnGatewayRoutePropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnGatewayRoute[_a] = { fqn: "aws-cdk-lib.aws_appmesh.CfnGatewayRoute", version: "2.80.0" }, CfnGatewayRoute.CFN_RESOURCE_TYPE_NAME = "AWS::AppMesh::GatewayRoute", exports2.CfnGatewayRoute = CfnGatewayRoute;
    function CfnGatewayRoute_GatewayRouteHostnameMatchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("exact", cdk.validateString)(properties.exact)), errors.collect(cdk.propertyValidator("suffix", cdk.validateString)(properties.suffix)), errors.wrap('supplied properties not correct for "GatewayRouteHostnameMatchProperty"');
    }
    function cfnGatewayRouteGatewayRouteHostnameMatchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGatewayRoute_GatewayRouteHostnameMatchPropertyValidator(properties).assertSuccess(), { Exact: cdk.stringToCloudFormation(properties.exact), Suffix: cdk.stringToCloudFormation(properties.suffix) }) : properties;
    }
    function CfnGatewayRouteGatewayRouteHostnameMatchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("exact", "Exact", properties.Exact != null ? cfn_parse.FromCloudFormation.getString(properties.Exact) : void 0), ret.addPropertyResult("suffix", "Suffix", properties.Suffix != null ? cfn_parse.FromCloudFormation.getString(properties.Suffix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGatewayRoute_GatewayRouteHostnameRewritePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultTargetHostname", cdk.validateString)(properties.defaultTargetHostname)), errors.wrap('supplied properties not correct for "GatewayRouteHostnameRewriteProperty"');
    }
    function cfnGatewayRouteGatewayRouteHostnameRewritePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGatewayRoute_GatewayRouteHostnameRewritePropertyValidator(properties).assertSuccess(), { DefaultTargetHostname: cdk.stringToCloudFormation(properties.defaultTargetHostname) }) : properties;
    }
    function CfnGatewayRouteGatewayRouteHostnameRewritePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultTargetHostname", "DefaultTargetHostname", properties.DefaultTargetHostname != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultTargetHostname) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGatewayRoute_GatewayRouteMetadataMatchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("exact", cdk.validateString)(properties.exact)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.collect(cdk.propertyValidator("range", CfnGatewayRoute_GatewayRouteRangeMatchPropertyValidator)(properties.range)), errors.collect(cdk.propertyValidator("regex", cdk.validateString)(properties.regex)), errors.collect(cdk.propertyValidator("suffix", cdk.validateString)(properties.suffix)), errors.wrap('supplied properties not correct for "GatewayRouteMetadataMatchProperty"');
    }
    function cfnGatewayRouteGatewayRouteMetadataMatchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGatewayRoute_GatewayRouteMetadataMatchPropertyValidator(properties).assertSuccess(), { Exact: cdk.stringToCloudFormation(properties.exact), Prefix: cdk.stringToCloudFormation(properties.prefix), Range: cfnGatewayRouteGatewayRouteRangeMatchPropertyToCloudFormation(properties.range), Regex: cdk.stringToCloudFormation(properties.regex), Suffix: cdk.stringToCloudFormation(properties.suffix) }) : properties;
    }
    function CfnGatewayRouteGatewayRouteMetadataMatchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("exact", "Exact", properties.Exact != null ? cfn_parse.FromCloudFormation.getString(properties.Exact) : void 0), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addPropertyResult("range", "Range", properties.Range != null ? CfnGatewayRouteGatewayRouteRangeMatchPropertyFromCloudFormation(properties.Range) : void 0), ret.addPropertyResult("regex", "Regex", properties.Regex != null ? cfn_parse.FromCloudFormation.getString(properties.Regex) : void 0), ret.addPropertyResult("suffix", "Suffix", properties.Suffix != null ? cfn_parse.FromCloudFormation.getString(properties.Suffix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGatewayRoute_GatewayRouteRangeMatchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("end", cdk.requiredValidator)(properties.end)), errors.collect(cdk.propertyValidator("end", cdk.validateNumber)(properties.end)), errors.collect(cdk.propertyValidator("start", cdk.requiredValidator)(properties.start)), errors.collect(cdk.propertyValidator("start", cdk.validateNumber)(properties.start)), errors.wrap('supplied properties not correct for "GatewayRouteRangeMatchProperty"');
    }
    function cfnGatewayRouteGatewayRouteRangeMatchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGatewayRoute_GatewayRouteRangeMatchPropertyValidator(properties).assertSuccess(), { End: cdk.numberToCloudFormation(properties.end), Start: cdk.numberToCloudFormation(properties.start) }) : properties;
    }
    function CfnGatewayRouteGatewayRouteRangeMatchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("end", "End", cfn_parse.FromCloudFormation.getNumber(properties.End)), ret.addPropertyResult("start", "Start", cfn_parse.FromCloudFormation.getNumber(properties.Start)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGatewayRoute_GatewayRouteSpecPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("grpcRoute", CfnGatewayRoute_GrpcGatewayRoutePropertyValidator)(properties.grpcRoute)), errors.collect(cdk.propertyValidator("http2Route", CfnGatewayRoute_HttpGatewayRoutePropertyValidator)(properties.http2Route)), errors.collect(cdk.propertyValidator("httpRoute", CfnGatewayRoute_HttpGatewayRoutePropertyValidator)(properties.httpRoute)), errors.collect(cdk.propertyValidator("priority", cdk.validateNumber)(properties.priority)), errors.wrap('supplied properties not correct for "GatewayRouteSpecProperty"');
    }
    function cfnGatewayRouteGatewayRouteSpecPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGatewayRoute_GatewayRouteSpecPropertyValidator(properties).assertSuccess(), { GrpcRoute: cfnGatewayRouteGrpcGatewayRoutePropertyToCloudFormation(properties.grpcRoute), Http2Route: cfnGatewayRouteHttpGatewayRoutePropertyToCloudFormation(properties.http2Route), HttpRoute: cfnGatewayRouteHttpGatewayRoutePropertyToCloudFormation(properties.httpRoute), Priority: cdk.numberToCloudFormation(properties.priority) }) : properties;
    }
    function CfnGatewayRouteGatewayRouteSpecPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("grpcRoute", "GrpcRoute", properties.GrpcRoute != null ? CfnGatewayRouteGrpcGatewayRoutePropertyFromCloudFormation(properties.GrpcRoute) : void 0), ret.addPropertyResult("http2Route", "Http2Route", properties.Http2Route != null ? CfnGatewayRouteHttpGatewayRoutePropertyFromCloudFormation(properties.Http2Route) : void 0), ret.addPropertyResult("httpRoute", "HttpRoute", properties.HttpRoute != null ? CfnGatewayRouteHttpGatewayRoutePropertyFromCloudFormation(properties.HttpRoute) : void 0), ret.addPropertyResult("priority", "Priority", properties.Priority != null ? cfn_parse.FromCloudFormation.getNumber(properties.Priority) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGatewayRoute_GatewayRouteTargetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("virtualService", cdk.requiredValidator)(properties.virtualService)), errors.collect(cdk.propertyValidator("virtualService", CfnGatewayRoute_GatewayRouteVirtualServicePropertyValidator)(properties.virtualService)), errors.wrap('supplied properties not correct for "GatewayRouteTargetProperty"');
    }
    function cfnGatewayRouteGatewayRouteTargetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGatewayRoute_GatewayRouteTargetPropertyValidator(properties).assertSuccess(), { Port: cdk.numberToCloudFormation(properties.port), VirtualService: cfnGatewayRouteGatewayRouteVirtualServicePropertyToCloudFormation(properties.virtualService) }) : properties;
    }
    function CfnGatewayRouteGatewayRouteTargetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addPropertyResult("virtualService", "VirtualService", CfnGatewayRouteGatewayRouteVirtualServicePropertyFromCloudFormation(properties.VirtualService)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGatewayRoute_GatewayRouteVirtualServicePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("virtualServiceName", cdk.requiredValidator)(properties.virtualServiceName)), errors.collect(cdk.propertyValidator("virtualServiceName", cdk.validateString)(properties.virtualServiceName)), errors.wrap('supplied properties not correct for "GatewayRouteVirtualServiceProperty"');
    }
    function cfnGatewayRouteGatewayRouteVirtualServicePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGatewayRoute_GatewayRouteVirtualServicePropertyValidator(properties).assertSuccess(), { VirtualServiceName: cdk.stringToCloudFormation(properties.virtualServiceName) }) : properties;
    }
    function CfnGatewayRouteGatewayRouteVirtualServicePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("virtualServiceName", "VirtualServiceName", cfn_parse.FromCloudFormation.getString(properties.VirtualServiceName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGatewayRoute_GrpcGatewayRoutePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.requiredValidator)(properties.action)), errors.collect(cdk.propertyValidator("action", CfnGatewayRoute_GrpcGatewayRouteActionPropertyValidator)(properties.action)), errors.collect(cdk.propertyValidator("match", cdk.requiredValidator)(properties.match)), errors.collect(cdk.propertyValidator("match", CfnGatewayRoute_GrpcGatewayRouteMatchPropertyValidator)(properties.match)), errors.wrap('supplied properties not correct for "GrpcGatewayRouteProperty"');
    }
    function cfnGatewayRouteGrpcGatewayRoutePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGatewayRoute_GrpcGatewayRoutePropertyValidator(properties).assertSuccess(), { Action: cfnGatewayRouteGrpcGatewayRouteActionPropertyToCloudFormation(properties.action), Match: cfnGatewayRouteGrpcGatewayRouteMatchPropertyToCloudFormation(properties.match) }) : properties;
    }
    function CfnGatewayRouteGrpcGatewayRoutePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", CfnGatewayRouteGrpcGatewayRouteActionPropertyFromCloudFormation(properties.Action)), ret.addPropertyResult("match", "Match", CfnGatewayRouteGrpcGatewayRouteMatchPropertyFromCloudFormation(properties.Match)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGatewayRoute_GrpcGatewayRouteActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("rewrite", CfnGatewayRoute_GrpcGatewayRouteRewritePropertyValidator)(properties.rewrite)), errors.collect(cdk.propertyValidator("target", cdk.requiredValidator)(properties.target)), errors.collect(cdk.propertyValidator("target", CfnGatewayRoute_GatewayRouteTargetPropertyValidator)(properties.target)), errors.wrap('supplied properties not correct for "GrpcGatewayRouteActionProperty"');
    }
    function cfnGatewayRouteGrpcGatewayRouteActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGatewayRoute_GrpcGatewayRouteActionPropertyValidator(properties).assertSuccess(), { Rewrite: cfnGatewayRouteGrpcGatewayRouteRewritePropertyToCloudFormation(properties.rewrite), Target: cfnGatewayRouteGatewayRouteTargetPropertyToCloudFormation(properties.target) }) : properties;
    }
    function CfnGatewayRouteGrpcGatewayRouteActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("rewrite", "Rewrite", properties.Rewrite != null ? CfnGatewayRouteGrpcGatewayRouteRewritePropertyFromCloudFormation(properties.Rewrite) : void 0), ret.addPropertyResult("target", "Target", CfnGatewayRouteGatewayRouteTargetPropertyFromCloudFormation(properties.Target)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGatewayRoute_GrpcGatewayRouteMatchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("hostname", CfnGatewayRoute_GatewayRouteHostnameMatchPropertyValidator)(properties.hostname)), errors.collect(cdk.propertyValidator("metadata", cdk.listValidator(CfnGatewayRoute_GrpcGatewayRouteMetadataPropertyValidator))(properties.metadata)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("serviceName", cdk.validateString)(properties.serviceName)), errors.wrap('supplied properties not correct for "GrpcGatewayRouteMatchProperty"');
    }
    function cfnGatewayRouteGrpcGatewayRouteMatchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGatewayRoute_GrpcGatewayRouteMatchPropertyValidator(properties).assertSuccess(), { Hostname: cfnGatewayRouteGatewayRouteHostnameMatchPropertyToCloudFormation(properties.hostname), Metadata: cdk.listMapper(cfnGatewayRouteGrpcGatewayRouteMetadataPropertyToCloudFormation)(properties.metadata), Port: cdk.numberToCloudFormation(properties.port), ServiceName: cdk.stringToCloudFormation(properties.serviceName) }) : properties;
    }
    function CfnGatewayRouteGrpcGatewayRouteMatchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("hostname", "Hostname", properties.Hostname != null ? CfnGatewayRouteGatewayRouteHostnameMatchPropertyFromCloudFormation(properties.Hostname) : void 0), ret.addPropertyResult("metadata", "Metadata", properties.Metadata != null ? cfn_parse.FromCloudFormation.getArray(CfnGatewayRouteGrpcGatewayRouteMetadataPropertyFromCloudFormation)(properties.Metadata) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addPropertyResult("serviceName", "ServiceName", properties.ServiceName != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGatewayRoute_GrpcGatewayRouteMetadataPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("invert", cdk.validateBoolean)(properties.invert)), errors.collect(cdk.propertyValidator("match", CfnGatewayRoute_GatewayRouteMetadataMatchPropertyValidator)(properties.match)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "GrpcGatewayRouteMetadataProperty"');
    }
    function cfnGatewayRouteGrpcGatewayRouteMetadataPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGatewayRoute_GrpcGatewayRouteMetadataPropertyValidator(properties).assertSuccess(), { Invert: cdk.booleanToCloudFormation(properties.invert), Match: cfnGatewayRouteGatewayRouteMetadataMatchPropertyToCloudFormation(properties.match), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnGatewayRouteGrpcGatewayRouteMetadataPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("invert", "Invert", properties.Invert != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Invert) : void 0), ret.addPropertyResult("match", "Match", properties.Match != null ? CfnGatewayRouteGatewayRouteMetadataMatchPropertyFromCloudFormation(properties.Match) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGatewayRoute_GrpcGatewayRouteRewritePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("hostname", CfnGatewayRoute_GatewayRouteHostnameRewritePropertyValidator)(properties.hostname)), errors.wrap('supplied properties not correct for "GrpcGatewayRouteRewriteProperty"');
    }
    function cfnGatewayRouteGrpcGatewayRouteRewritePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGatewayRoute_GrpcGatewayRouteRewritePropertyValidator(properties).assertSuccess(), { Hostname: cfnGatewayRouteGatewayRouteHostnameRewritePropertyToCloudFormation(properties.hostname) }) : properties;
    }
    function CfnGatewayRouteGrpcGatewayRouteRewritePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("hostname", "Hostname", properties.Hostname != null ? CfnGatewayRouteGatewayRouteHostnameRewritePropertyFromCloudFormation(properties.Hostname) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGatewayRoute_HttpGatewayRoutePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.requiredValidator)(properties.action)), errors.collect(cdk.propertyValidator("action", CfnGatewayRoute_HttpGatewayRouteActionPropertyValidator)(properties.action)), errors.collect(cdk.propertyValidator("match", cdk.requiredValidator)(properties.match)), errors.collect(cdk.propertyValidator("match", CfnGatewayRoute_HttpGatewayRouteMatchPropertyValidator)(properties.match)), errors.wrap('supplied properties not correct for "HttpGatewayRouteProperty"');
    }
    function cfnGatewayRouteHttpGatewayRoutePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGatewayRoute_HttpGatewayRoutePropertyValidator(properties).assertSuccess(), { Action: cfnGatewayRouteHttpGatewayRouteActionPropertyToCloudFormation(properties.action), Match: cfnGatewayRouteHttpGatewayRouteMatchPropertyToCloudFormation(properties.match) }) : properties;
    }
    function CfnGatewayRouteHttpGatewayRoutePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", CfnGatewayRouteHttpGatewayRouteActionPropertyFromCloudFormation(properties.Action)), ret.addPropertyResult("match", "Match", CfnGatewayRouteHttpGatewayRouteMatchPropertyFromCloudFormation(properties.Match)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGatewayRoute_HttpGatewayRouteActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("rewrite", CfnGatewayRoute_HttpGatewayRouteRewritePropertyValidator)(properties.rewrite)), errors.collect(cdk.propertyValidator("target", cdk.requiredValidator)(properties.target)), errors.collect(cdk.propertyValidator("target", CfnGatewayRoute_GatewayRouteTargetPropertyValidator)(properties.target)), errors.wrap('supplied properties not correct for "HttpGatewayRouteActionProperty"');
    }
    function cfnGatewayRouteHttpGatewayRouteActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGatewayRoute_HttpGatewayRouteActionPropertyValidator(properties).assertSuccess(), { Rewrite: cfnGatewayRouteHttpGatewayRouteRewritePropertyToCloudFormation(properties.rewrite), Target: cfnGatewayRouteGatewayRouteTargetPropertyToCloudFormation(properties.target) }) : properties;
    }
    function CfnGatewayRouteHttpGatewayRouteActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("rewrite", "Rewrite", properties.Rewrite != null ? CfnGatewayRouteHttpGatewayRouteRewritePropertyFromCloudFormation(properties.Rewrite) : void 0), ret.addPropertyResult("target", "Target", CfnGatewayRouteGatewayRouteTargetPropertyFromCloudFormation(properties.Target)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGatewayRoute_HttpGatewayRouteHeaderPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("invert", cdk.validateBoolean)(properties.invert)), errors.collect(cdk.propertyValidator("match", CfnGatewayRoute_HttpGatewayRouteHeaderMatchPropertyValidator)(properties.match)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "HttpGatewayRouteHeaderProperty"');
    }
    function cfnGatewayRouteHttpGatewayRouteHeaderPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGatewayRoute_HttpGatewayRouteHeaderPropertyValidator(properties).assertSuccess(), { Invert: cdk.booleanToCloudFormation(properties.invert), Match: cfnGatewayRouteHttpGatewayRouteHeaderMatchPropertyToCloudFormation(properties.match), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnGatewayRouteHttpGatewayRouteHeaderPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("invert", "Invert", properties.Invert != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Invert) : void 0), ret.addPropertyResult("match", "Match", properties.Match != null ? CfnGatewayRouteHttpGatewayRouteHeaderMatchPropertyFromCloudFormation(properties.Match) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGatewayRoute_HttpGatewayRouteHeaderMatchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("exact", cdk.validateString)(properties.exact)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.collect(cdk.propertyValidator("range", CfnGatewayRoute_GatewayRouteRangeMatchPropertyValidator)(properties.range)), errors.collect(cdk.propertyValidator("regex", cdk.validateString)(properties.regex)), errors.collect(cdk.propertyValidator("suffix", cdk.validateString)(properties.suffix)), errors.wrap('supplied properties not correct for "HttpGatewayRouteHeaderMatchProperty"');
    }
    function cfnGatewayRouteHttpGatewayRouteHeaderMatchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGatewayRoute_HttpGatewayRouteHeaderMatchPropertyValidator(properties).assertSuccess(), { Exact: cdk.stringToCloudFormation(properties.exact), Prefix: cdk.stringToCloudFormation(properties.prefix), Range: cfnGatewayRouteGatewayRouteRangeMatchPropertyToCloudFormation(properties.range), Regex: cdk.stringToCloudFormation(properties.regex), Suffix: cdk.stringToCloudFormation(properties.suffix) }) : properties;
    }
    function CfnGatewayRouteHttpGatewayRouteHeaderMatchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("exact", "Exact", properties.Exact != null ? cfn_parse.FromCloudFormation.getString(properties.Exact) : void 0), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addPropertyResult("range", "Range", properties.Range != null ? CfnGatewayRouteGatewayRouteRangeMatchPropertyFromCloudFormation(properties.Range) : void 0), ret.addPropertyResult("regex", "Regex", properties.Regex != null ? cfn_parse.FromCloudFormation.getString(properties.Regex) : void 0), ret.addPropertyResult("suffix", "Suffix", properties.Suffix != null ? cfn_parse.FromCloudFormation.getString(properties.Suffix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGatewayRoute_HttpGatewayRouteMatchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("headers", cdk.listValidator(CfnGatewayRoute_HttpGatewayRouteHeaderPropertyValidator))(properties.headers)), errors.collect(cdk.propertyValidator("hostname", CfnGatewayRoute_GatewayRouteHostnameMatchPropertyValidator)(properties.hostname)), errors.collect(cdk.propertyValidator("method", cdk.validateString)(properties.method)), errors.collect(cdk.propertyValidator("path", CfnGatewayRoute_HttpPathMatchPropertyValidator)(properties.path)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.collect(cdk.propertyValidator("queryParameters", cdk.listValidator(CfnGatewayRoute_QueryParameterPropertyValidator))(properties.queryParameters)), errors.wrap('supplied properties not correct for "HttpGatewayRouteMatchProperty"');
    }
    function cfnGatewayRouteHttpGatewayRouteMatchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGatewayRoute_HttpGatewayRouteMatchPropertyValidator(properties).assertSuccess(), { Headers: cdk.listMapper(cfnGatewayRouteHttpGatewayRouteHeaderPropertyToCloudFormation)(properties.headers), Hostname: cfnGatewayRouteGatewayRouteHostnameMatchPropertyToCloudFormation(properties.hostname), Method: cdk.stringToCloudFormation(properties.method), Path: cfnGatewayRouteHttpPathMatchPropertyToCloudFormation(properties.path), Port: cdk.numberToCloudFormation(properties.port), Prefix: cdk.stringToCloudFormation(properties.prefix), QueryParameters: cdk.listMapper(cfnGatewayRouteQueryParameterPropertyToCloudFormation)(properties.queryParameters) }) : properties;
    }
    function CfnGatewayRouteHttpGatewayRouteMatchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("headers", "Headers", properties.Headers != null ? cfn_parse.FromCloudFormation.getArray(CfnGatewayRouteHttpGatewayRouteHeaderPropertyFromCloudFormation)(properties.Headers) : void 0), ret.addPropertyResult("hostname", "Hostname", properties.Hostname != null ? CfnGatewayRouteGatewayRouteHostnameMatchPropertyFromCloudFormation(properties.Hostname) : void 0), ret.addPropertyResult("method", "Method", properties.Method != null ? cfn_parse.FromCloudFormation.getString(properties.Method) : void 0), ret.addPropertyResult("path", "Path", properties.Path != null ? CfnGatewayRouteHttpPathMatchPropertyFromCloudFormation(properties.Path) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addPropertyResult("queryParameters", "QueryParameters", properties.QueryParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnGatewayRouteQueryParameterPropertyFromCloudFormation)(properties.QueryParameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGatewayRoute_HttpGatewayRoutePathRewritePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("exact", cdk.validateString)(properties.exact)), errors.wrap('supplied properties not correct for "HttpGatewayRoutePathRewriteProperty"');
    }
    function cfnGatewayRouteHttpGatewayRoutePathRewritePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGatewayRoute_HttpGatewayRoutePathRewritePropertyValidator(properties).assertSuccess(), { Exact: cdk.stringToCloudFormation(properties.exact) }) : properties;
    }
    function CfnGatewayRouteHttpGatewayRoutePathRewritePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("exact", "Exact", properties.Exact != null ? cfn_parse.FromCloudFormation.getString(properties.Exact) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGatewayRoute_HttpGatewayRoutePrefixRewritePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultPrefix", cdk.validateString)(properties.defaultPrefix)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "HttpGatewayRoutePrefixRewriteProperty"');
    }
    function cfnGatewayRouteHttpGatewayRoutePrefixRewritePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGatewayRoute_HttpGatewayRoutePrefixRewritePropertyValidator(properties).assertSuccess(), { DefaultPrefix: cdk.stringToCloudFormation(properties.defaultPrefix), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnGatewayRouteHttpGatewayRoutePrefixRewritePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultPrefix", "DefaultPrefix", properties.DefaultPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultPrefix) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGatewayRoute_HttpGatewayRouteRewritePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("hostname", CfnGatewayRoute_GatewayRouteHostnameRewritePropertyValidator)(properties.hostname)), errors.collect(cdk.propertyValidator("path", CfnGatewayRoute_HttpGatewayRoutePathRewritePropertyValidator)(properties.path)), errors.collect(cdk.propertyValidator("prefix", CfnGatewayRoute_HttpGatewayRoutePrefixRewritePropertyValidator)(properties.prefix)), errors.wrap('supplied properties not correct for "HttpGatewayRouteRewriteProperty"');
    }
    function cfnGatewayRouteHttpGatewayRouteRewritePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGatewayRoute_HttpGatewayRouteRewritePropertyValidator(properties).assertSuccess(), { Hostname: cfnGatewayRouteGatewayRouteHostnameRewritePropertyToCloudFormation(properties.hostname), Path: cfnGatewayRouteHttpGatewayRoutePathRewritePropertyToCloudFormation(properties.path), Prefix: cfnGatewayRouteHttpGatewayRoutePrefixRewritePropertyToCloudFormation(properties.prefix) }) : properties;
    }
    function CfnGatewayRouteHttpGatewayRouteRewritePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("hostname", "Hostname", properties.Hostname != null ? CfnGatewayRouteGatewayRouteHostnameRewritePropertyFromCloudFormation(properties.Hostname) : void 0), ret.addPropertyResult("path", "Path", properties.Path != null ? CfnGatewayRouteHttpGatewayRoutePathRewritePropertyFromCloudFormation(properties.Path) : void 0), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? CfnGatewayRouteHttpGatewayRoutePrefixRewritePropertyFromCloudFormation(properties.Prefix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGatewayRoute_HttpPathMatchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("exact", cdk.validateString)(properties.exact)), errors.collect(cdk.propertyValidator("regex", cdk.validateString)(properties.regex)), errors.wrap('supplied properties not correct for "HttpPathMatchProperty"');
    }
    function cfnGatewayRouteHttpPathMatchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGatewayRoute_HttpPathMatchPropertyValidator(properties).assertSuccess(), { Exact: cdk.stringToCloudFormation(properties.exact), Regex: cdk.stringToCloudFormation(properties.regex) }) : properties;
    }
    function CfnGatewayRouteHttpPathMatchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("exact", "Exact", properties.Exact != null ? cfn_parse.FromCloudFormation.getString(properties.Exact) : void 0), ret.addPropertyResult("regex", "Regex", properties.Regex != null ? cfn_parse.FromCloudFormation.getString(properties.Regex) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGatewayRoute_HttpQueryParameterMatchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("exact", cdk.validateString)(properties.exact)), errors.wrap('supplied properties not correct for "HttpQueryParameterMatchProperty"');
    }
    function cfnGatewayRouteHttpQueryParameterMatchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGatewayRoute_HttpQueryParameterMatchPropertyValidator(properties).assertSuccess(), { Exact: cdk.stringToCloudFormation(properties.exact) }) : properties;
    }
    function CfnGatewayRouteHttpQueryParameterMatchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("exact", "Exact", properties.Exact != null ? cfn_parse.FromCloudFormation.getString(properties.Exact) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGatewayRoute_QueryParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("match", CfnGatewayRoute_HttpQueryParameterMatchPropertyValidator)(properties.match)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "QueryParameterProperty"');
    }
    function cfnGatewayRouteQueryParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGatewayRoute_QueryParameterPropertyValidator(properties).assertSuccess(), { Match: cfnGatewayRouteHttpQueryParameterMatchPropertyToCloudFormation(properties.match), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnGatewayRouteQueryParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("match", "Match", properties.Match != null ? CfnGatewayRouteHttpQueryParameterMatchPropertyFromCloudFormation(properties.Match) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMeshPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("meshName", cdk.validateString)(properties.meshName)), errors.collect(cdk.propertyValidator("spec", CfnMesh_MeshSpecPropertyValidator)(properties.spec)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnMeshProps"');
    }
    function cfnMeshPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMeshPropsValidator(properties).assertSuccess(), { MeshName: cdk.stringToCloudFormation(properties.meshName), Spec: cfnMeshMeshSpecPropertyToCloudFormation(properties.spec), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnMeshPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("meshName", "MeshName", properties.MeshName != null ? cfn_parse.FromCloudFormation.getString(properties.MeshName) : void 0), ret.addPropertyResult("spec", "Spec", properties.Spec != null ? CfnMeshMeshSpecPropertyFromCloudFormation(properties.Spec) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnMesh = class _CfnMesh extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnMeshPropsFromCloudFormation(resourceProperties), ret = new _CfnMesh(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnMesh.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_CfnMeshProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnMesh), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrMeshName = cdk.Token.asString(this.getAtt("MeshName", cdk.ResolutionTypeHint.STRING)), this.attrMeshOwner = cdk.Token.asString(this.getAtt("MeshOwner", cdk.ResolutionTypeHint.STRING)), this.attrResourceOwner = cdk.Token.asString(this.getAtt("ResourceOwner", cdk.ResolutionTypeHint.STRING)), this.attrUid = cdk.Token.asString(this.getAtt("Uid", cdk.ResolutionTypeHint.STRING)), this.meshName = props.meshName, this.spec = props.spec, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::AppMesh::Mesh", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnMesh.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { meshName: this.meshName, spec: this.spec, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnMeshPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnMesh[_b] = { fqn: "aws-cdk-lib.aws_appmesh.CfnMesh", version: "2.80.0" }, CfnMesh.CFN_RESOURCE_TYPE_NAME = "AWS::AppMesh::Mesh", exports2.CfnMesh = CfnMesh;
    function CfnMesh_EgressFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "EgressFilterProperty"');
    }
    function cfnMeshEgressFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMesh_EgressFilterPropertyValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnMeshEgressFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMesh_MeshServiceDiscoveryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ipPreference", cdk.validateString)(properties.ipPreference)), errors.wrap('supplied properties not correct for "MeshServiceDiscoveryProperty"');
    }
    function cfnMeshMeshServiceDiscoveryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMesh_MeshServiceDiscoveryPropertyValidator(properties).assertSuccess(), { IpPreference: cdk.stringToCloudFormation(properties.ipPreference) }) : properties;
    }
    function CfnMeshMeshServiceDiscoveryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ipPreference", "IpPreference", properties.IpPreference != null ? cfn_parse.FromCloudFormation.getString(properties.IpPreference) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMesh_MeshSpecPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("egressFilter", CfnMesh_EgressFilterPropertyValidator)(properties.egressFilter)), errors.collect(cdk.propertyValidator("serviceDiscovery", CfnMesh_MeshServiceDiscoveryPropertyValidator)(properties.serviceDiscovery)), errors.wrap('supplied properties not correct for "MeshSpecProperty"');
    }
    function cfnMeshMeshSpecPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMesh_MeshSpecPropertyValidator(properties).assertSuccess(), { EgressFilter: cfnMeshEgressFilterPropertyToCloudFormation(properties.egressFilter), ServiceDiscovery: cfnMeshMeshServiceDiscoveryPropertyToCloudFormation(properties.serviceDiscovery) }) : properties;
    }
    function CfnMeshMeshSpecPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("egressFilter", "EgressFilter", properties.EgressFilter != null ? CfnMeshEgressFilterPropertyFromCloudFormation(properties.EgressFilter) : void 0), ret.addPropertyResult("serviceDiscovery", "ServiceDiscovery", properties.ServiceDiscovery != null ? CfnMeshMeshServiceDiscoveryPropertyFromCloudFormation(properties.ServiceDiscovery) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRoutePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("meshName", cdk.requiredValidator)(properties.meshName)), errors.collect(cdk.propertyValidator("meshName", cdk.validateString)(properties.meshName)), errors.collect(cdk.propertyValidator("meshOwner", cdk.validateString)(properties.meshOwner)), errors.collect(cdk.propertyValidator("routeName", cdk.validateString)(properties.routeName)), errors.collect(cdk.propertyValidator("spec", cdk.requiredValidator)(properties.spec)), errors.collect(cdk.propertyValidator("spec", CfnRoute_RouteSpecPropertyValidator)(properties.spec)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("virtualRouterName", cdk.requiredValidator)(properties.virtualRouterName)), errors.collect(cdk.propertyValidator("virtualRouterName", cdk.validateString)(properties.virtualRouterName)), errors.wrap('supplied properties not correct for "CfnRouteProps"');
    }
    function cfnRoutePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoutePropsValidator(properties).assertSuccess(), { MeshName: cdk.stringToCloudFormation(properties.meshName), Spec: cfnRouteRouteSpecPropertyToCloudFormation(properties.spec), VirtualRouterName: cdk.stringToCloudFormation(properties.virtualRouterName), MeshOwner: cdk.stringToCloudFormation(properties.meshOwner), RouteName: cdk.stringToCloudFormation(properties.routeName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnRoutePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("meshName", "MeshName", cfn_parse.FromCloudFormation.getString(properties.MeshName)), ret.addPropertyResult("spec", "Spec", CfnRouteRouteSpecPropertyFromCloudFormation(properties.Spec)), ret.addPropertyResult("virtualRouterName", "VirtualRouterName", cfn_parse.FromCloudFormation.getString(properties.VirtualRouterName)), ret.addPropertyResult("meshOwner", "MeshOwner", properties.MeshOwner != null ? cfn_parse.FromCloudFormation.getString(properties.MeshOwner) : void 0), ret.addPropertyResult("routeName", "RouteName", properties.RouteName != null ? cfn_parse.FromCloudFormation.getString(properties.RouteName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRoute = class _CfnRoute extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRoutePropsFromCloudFormation(resourceProperties), ret = new _CfnRoute(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRoute.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_CfnRouteProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRoute), error;
        }
        cdk.requireProperty(props, "meshName", this), cdk.requireProperty(props, "spec", this), cdk.requireProperty(props, "virtualRouterName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrMeshName = cdk.Token.asString(this.getAtt("MeshName", cdk.ResolutionTypeHint.STRING)), this.attrMeshOwner = cdk.Token.asString(this.getAtt("MeshOwner", cdk.ResolutionTypeHint.STRING)), this.attrResourceOwner = cdk.Token.asString(this.getAtt("ResourceOwner", cdk.ResolutionTypeHint.STRING)), this.attrRouteName = cdk.Token.asString(this.getAtt("RouteName", cdk.ResolutionTypeHint.STRING)), this.attrUid = cdk.Token.asString(this.getAtt("Uid", cdk.ResolutionTypeHint.STRING)), this.attrVirtualRouterName = cdk.Token.asString(this.getAtt("VirtualRouterName", cdk.ResolutionTypeHint.STRING)), this.meshName = props.meshName, this.spec = props.spec, this.virtualRouterName = props.virtualRouterName, this.meshOwner = props.meshOwner, this.routeName = props.routeName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::AppMesh::Route", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRoute.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { meshName: this.meshName, spec: this.spec, virtualRouterName: this.virtualRouterName, meshOwner: this.meshOwner, routeName: this.routeName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnRoutePropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnRoute[_c] = { fqn: "aws-cdk-lib.aws_appmesh.CfnRoute", version: "2.80.0" }, CfnRoute.CFN_RESOURCE_TYPE_NAME = "AWS::AppMesh::Route", exports2.CfnRoute = CfnRoute;
    function CfnRoute_DurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("unit", cdk.requiredValidator)(properties.unit)), errors.collect(cdk.propertyValidator("unit", cdk.validateString)(properties.unit)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "DurationProperty"');
    }
    function cfnRouteDurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoute_DurationPropertyValidator(properties).assertSuccess(), { Unit: cdk.stringToCloudFormation(properties.unit), Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnRouteDurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("unit", "Unit", cfn_parse.FromCloudFormation.getString(properties.Unit)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getNumber(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRoute_GrpcRetryPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("grpcRetryEvents", cdk.listValidator(cdk.validateString))(properties.grpcRetryEvents)), errors.collect(cdk.propertyValidator("httpRetryEvents", cdk.listValidator(cdk.validateString))(properties.httpRetryEvents)), errors.collect(cdk.propertyValidator("maxRetries", cdk.requiredValidator)(properties.maxRetries)), errors.collect(cdk.propertyValidator("maxRetries", cdk.validateNumber)(properties.maxRetries)), errors.collect(cdk.propertyValidator("perRetryTimeout", cdk.requiredValidator)(properties.perRetryTimeout)), errors.collect(cdk.propertyValidator("perRetryTimeout", CfnRoute_DurationPropertyValidator)(properties.perRetryTimeout)), errors.collect(cdk.propertyValidator("tcpRetryEvents", cdk.listValidator(cdk.validateString))(properties.tcpRetryEvents)), errors.wrap('supplied properties not correct for "GrpcRetryPolicyProperty"');
    }
    function cfnRouteGrpcRetryPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoute_GrpcRetryPolicyPropertyValidator(properties).assertSuccess(), { GrpcRetryEvents: cdk.listMapper(cdk.stringToCloudFormation)(properties.grpcRetryEvents), HttpRetryEvents: cdk.listMapper(cdk.stringToCloudFormation)(properties.httpRetryEvents), MaxRetries: cdk.numberToCloudFormation(properties.maxRetries), PerRetryTimeout: cfnRouteDurationPropertyToCloudFormation(properties.perRetryTimeout), TcpRetryEvents: cdk.listMapper(cdk.stringToCloudFormation)(properties.tcpRetryEvents) }) : properties;
    }
    function CfnRouteGrpcRetryPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("grpcRetryEvents", "GrpcRetryEvents", properties.GrpcRetryEvents != null ? cfn_parse.FromCloudFormation.getStringArray(properties.GrpcRetryEvents) : void 0), ret.addPropertyResult("httpRetryEvents", "HttpRetryEvents", properties.HttpRetryEvents != null ? cfn_parse.FromCloudFormation.getStringArray(properties.HttpRetryEvents) : void 0), ret.addPropertyResult("maxRetries", "MaxRetries", cfn_parse.FromCloudFormation.getNumber(properties.MaxRetries)), ret.addPropertyResult("perRetryTimeout", "PerRetryTimeout", CfnRouteDurationPropertyFromCloudFormation(properties.PerRetryTimeout)), ret.addPropertyResult("tcpRetryEvents", "TcpRetryEvents", properties.TcpRetryEvents != null ? cfn_parse.FromCloudFormation.getStringArray(properties.TcpRetryEvents) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRoute_GrpcRoutePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.requiredValidator)(properties.action)), errors.collect(cdk.propertyValidator("action", CfnRoute_GrpcRouteActionPropertyValidator)(properties.action)), errors.collect(cdk.propertyValidator("match", cdk.requiredValidator)(properties.match)), errors.collect(cdk.propertyValidator("match", CfnRoute_GrpcRouteMatchPropertyValidator)(properties.match)), errors.collect(cdk.propertyValidator("retryPolicy", CfnRoute_GrpcRetryPolicyPropertyValidator)(properties.retryPolicy)), errors.collect(cdk.propertyValidator("timeout", CfnRoute_GrpcTimeoutPropertyValidator)(properties.timeout)), errors.wrap('supplied properties not correct for "GrpcRouteProperty"');
    }
    function cfnRouteGrpcRoutePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoute_GrpcRoutePropertyValidator(properties).assertSuccess(), { Action: cfnRouteGrpcRouteActionPropertyToCloudFormation(properties.action), Match: cfnRouteGrpcRouteMatchPropertyToCloudFormation(properties.match), RetryPolicy: cfnRouteGrpcRetryPolicyPropertyToCloudFormation(properties.retryPolicy), Timeout: cfnRouteGrpcTimeoutPropertyToCloudFormation(properties.timeout) }) : properties;
    }
    function CfnRouteGrpcRoutePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", CfnRouteGrpcRouteActionPropertyFromCloudFormation(properties.Action)), ret.addPropertyResult("match", "Match", CfnRouteGrpcRouteMatchPropertyFromCloudFormation(properties.Match)), ret.addPropertyResult("retryPolicy", "RetryPolicy", properties.RetryPolicy != null ? CfnRouteGrpcRetryPolicyPropertyFromCloudFormation(properties.RetryPolicy) : void 0), ret.addPropertyResult("timeout", "Timeout", properties.Timeout != null ? CfnRouteGrpcTimeoutPropertyFromCloudFormation(properties.Timeout) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRoute_GrpcRouteActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("weightedTargets", cdk.requiredValidator)(properties.weightedTargets)), errors.collect(cdk.propertyValidator("weightedTargets", cdk.listValidator(CfnRoute_WeightedTargetPropertyValidator))(properties.weightedTargets)), errors.wrap('supplied properties not correct for "GrpcRouteActionProperty"');
    }
    function cfnRouteGrpcRouteActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoute_GrpcRouteActionPropertyValidator(properties).assertSuccess(), { WeightedTargets: cdk.listMapper(cfnRouteWeightedTargetPropertyToCloudFormation)(properties.weightedTargets) }) : properties;
    }
    function CfnRouteGrpcRouteActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("weightedTargets", "WeightedTargets", cfn_parse.FromCloudFormation.getArray(CfnRouteWeightedTargetPropertyFromCloudFormation)(properties.WeightedTargets)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRoute_GrpcRouteMatchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("metadata", cdk.listValidator(CfnRoute_GrpcRouteMetadataPropertyValidator))(properties.metadata)), errors.collect(cdk.propertyValidator("methodName", cdk.validateString)(properties.methodName)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("serviceName", cdk.validateString)(properties.serviceName)), errors.wrap('supplied properties not correct for "GrpcRouteMatchProperty"');
    }
    function cfnRouteGrpcRouteMatchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoute_GrpcRouteMatchPropertyValidator(properties).assertSuccess(), { Metadata: cdk.listMapper(cfnRouteGrpcRouteMetadataPropertyToCloudFormation)(properties.metadata), MethodName: cdk.stringToCloudFormation(properties.methodName), Port: cdk.numberToCloudFormation(properties.port), ServiceName: cdk.stringToCloudFormation(properties.serviceName) }) : properties;
    }
    function CfnRouteGrpcRouteMatchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("metadata", "Metadata", properties.Metadata != null ? cfn_parse.FromCloudFormation.getArray(CfnRouteGrpcRouteMetadataPropertyFromCloudFormation)(properties.Metadata) : void 0), ret.addPropertyResult("methodName", "MethodName", properties.MethodName != null ? cfn_parse.FromCloudFormation.getString(properties.MethodName) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addPropertyResult("serviceName", "ServiceName", properties.ServiceName != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRoute_GrpcRouteMetadataPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("invert", cdk.validateBoolean)(properties.invert)), errors.collect(cdk.propertyValidator("match", CfnRoute_GrpcRouteMetadataMatchMethodPropertyValidator)(properties.match)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "GrpcRouteMetadataProperty"');
    }
    function cfnRouteGrpcRouteMetadataPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoute_GrpcRouteMetadataPropertyValidator(properties).assertSuccess(), { Invert: cdk.booleanToCloudFormation(properties.invert), Match: cfnRouteGrpcRouteMetadataMatchMethodPropertyToCloudFormation(properties.match), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnRouteGrpcRouteMetadataPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("invert", "Invert", properties.Invert != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Invert) : void 0), ret.addPropertyResult("match", "Match", properties.Match != null ? CfnRouteGrpcRouteMetadataMatchMethodPropertyFromCloudFormation(properties.Match) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRoute_GrpcRouteMetadataMatchMethodPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("exact", cdk.validateString)(properties.exact)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.collect(cdk.propertyValidator("range", CfnRoute_MatchRangePropertyValidator)(properties.range)), errors.collect(cdk.propertyValidator("regex", cdk.validateString)(properties.regex)), errors.collect(cdk.propertyValidator("suffix", cdk.validateString)(properties.suffix)), errors.wrap('supplied properties not correct for "GrpcRouteMetadataMatchMethodProperty"');
    }
    function cfnRouteGrpcRouteMetadataMatchMethodPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoute_GrpcRouteMetadataMatchMethodPropertyValidator(properties).assertSuccess(), { Exact: cdk.stringToCloudFormation(properties.exact), Prefix: cdk.stringToCloudFormation(properties.prefix), Range: cfnRouteMatchRangePropertyToCloudFormation(properties.range), Regex: cdk.stringToCloudFormation(properties.regex), Suffix: cdk.stringToCloudFormation(properties.suffix) }) : properties;
    }
    function CfnRouteGrpcRouteMetadataMatchMethodPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("exact", "Exact", properties.Exact != null ? cfn_parse.FromCloudFormation.getString(properties.Exact) : void 0), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addPropertyResult("range", "Range", properties.Range != null ? CfnRouteMatchRangePropertyFromCloudFormation(properties.Range) : void 0), ret.addPropertyResult("regex", "Regex", properties.Regex != null ? cfn_parse.FromCloudFormation.getString(properties.Regex) : void 0), ret.addPropertyResult("suffix", "Suffix", properties.Suffix != null ? cfn_parse.FromCloudFormation.getString(properties.Suffix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRoute_GrpcTimeoutPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("idle", CfnRoute_DurationPropertyValidator)(properties.idle)), errors.collect(cdk.propertyValidator("perRequest", CfnRoute_DurationPropertyValidator)(properties.perRequest)), errors.wrap('supplied properties not correct for "GrpcTimeoutProperty"');
    }
    function cfnRouteGrpcTimeoutPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoute_GrpcTimeoutPropertyValidator(properties).assertSuccess(), { Idle: cfnRouteDurationPropertyToCloudFormation(properties.idle), PerRequest: cfnRouteDurationPropertyToCloudFormation(properties.perRequest) }) : properties;
    }
    function CfnRouteGrpcTimeoutPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("idle", "Idle", properties.Idle != null ? CfnRouteDurationPropertyFromCloudFormation(properties.Idle) : void 0), ret.addPropertyResult("perRequest", "PerRequest", properties.PerRequest != null ? CfnRouteDurationPropertyFromCloudFormation(properties.PerRequest) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRoute_HeaderMatchMethodPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("exact", cdk.validateString)(properties.exact)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.collect(cdk.propertyValidator("range", CfnRoute_MatchRangePropertyValidator)(properties.range)), errors.collect(cdk.propertyValidator("regex", cdk.validateString)(properties.regex)), errors.collect(cdk.propertyValidator("suffix", cdk.validateString)(properties.suffix)), errors.wrap('supplied properties not correct for "HeaderMatchMethodProperty"');
    }
    function cfnRouteHeaderMatchMethodPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoute_HeaderMatchMethodPropertyValidator(properties).assertSuccess(), { Exact: cdk.stringToCloudFormation(properties.exact), Prefix: cdk.stringToCloudFormation(properties.prefix), Range: cfnRouteMatchRangePropertyToCloudFormation(properties.range), Regex: cdk.stringToCloudFormation(properties.regex), Suffix: cdk.stringToCloudFormation(properties.suffix) }) : properties;
    }
    function CfnRouteHeaderMatchMethodPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("exact", "Exact", properties.Exact != null ? cfn_parse.FromCloudFormation.getString(properties.Exact) : void 0), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addPropertyResult("range", "Range", properties.Range != null ? CfnRouteMatchRangePropertyFromCloudFormation(properties.Range) : void 0), ret.addPropertyResult("regex", "Regex", properties.Regex != null ? cfn_parse.FromCloudFormation.getString(properties.Regex) : void 0), ret.addPropertyResult("suffix", "Suffix", properties.Suffix != null ? cfn_parse.FromCloudFormation.getString(properties.Suffix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRoute_HttpPathMatchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("exact", cdk.validateString)(properties.exact)), errors.collect(cdk.propertyValidator("regex", cdk.validateString)(properties.regex)), errors.wrap('supplied properties not correct for "HttpPathMatchProperty"');
    }
    function cfnRouteHttpPathMatchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoute_HttpPathMatchPropertyValidator(properties).assertSuccess(), { Exact: cdk.stringToCloudFormation(properties.exact), Regex: cdk.stringToCloudFormation(properties.regex) }) : properties;
    }
    function CfnRouteHttpPathMatchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("exact", "Exact", properties.Exact != null ? cfn_parse.FromCloudFormation.getString(properties.Exact) : void 0), ret.addPropertyResult("regex", "Regex", properties.Regex != null ? cfn_parse.FromCloudFormation.getString(properties.Regex) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRoute_HttpQueryParameterMatchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("exact", cdk.validateString)(properties.exact)), errors.wrap('supplied properties not correct for "HttpQueryParameterMatchProperty"');
    }
    function cfnRouteHttpQueryParameterMatchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoute_HttpQueryParameterMatchPropertyValidator(properties).assertSuccess(), { Exact: cdk.stringToCloudFormation(properties.exact) }) : properties;
    }
    function CfnRouteHttpQueryParameterMatchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("exact", "Exact", properties.Exact != null ? cfn_parse.FromCloudFormation.getString(properties.Exact) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRoute_HttpRetryPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("httpRetryEvents", cdk.listValidator(cdk.validateString))(properties.httpRetryEvents)), errors.collect(cdk.propertyValidator("maxRetries", cdk.requiredValidator)(properties.maxRetries)), errors.collect(cdk.propertyValidator("maxRetries", cdk.validateNumber)(properties.maxRetries)), errors.collect(cdk.propertyValidator("perRetryTimeout", cdk.requiredValidator)(properties.perRetryTimeout)), errors.collect(cdk.propertyValidator("perRetryTimeout", CfnRoute_DurationPropertyValidator)(properties.perRetryTimeout)), errors.collect(cdk.propertyValidator("tcpRetryEvents", cdk.listValidator(cdk.validateString))(properties.tcpRetryEvents)), errors.wrap('supplied properties not correct for "HttpRetryPolicyProperty"');
    }
    function cfnRouteHttpRetryPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoute_HttpRetryPolicyPropertyValidator(properties).assertSuccess(), { HttpRetryEvents: cdk.listMapper(cdk.stringToCloudFormation)(properties.httpRetryEvents), MaxRetries: cdk.numberToCloudFormation(properties.maxRetries), PerRetryTimeout: cfnRouteDurationPropertyToCloudFormation(properties.perRetryTimeout), TcpRetryEvents: cdk.listMapper(cdk.stringToCloudFormation)(properties.tcpRetryEvents) }) : properties;
    }
    function CfnRouteHttpRetryPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("httpRetryEvents", "HttpRetryEvents", properties.HttpRetryEvents != null ? cfn_parse.FromCloudFormation.getStringArray(properties.HttpRetryEvents) : void 0), ret.addPropertyResult("maxRetries", "MaxRetries", cfn_parse.FromCloudFormation.getNumber(properties.MaxRetries)), ret.addPropertyResult("perRetryTimeout", "PerRetryTimeout", CfnRouteDurationPropertyFromCloudFormation(properties.PerRetryTimeout)), ret.addPropertyResult("tcpRetryEvents", "TcpRetryEvents", properties.TcpRetryEvents != null ? cfn_parse.FromCloudFormation.getStringArray(properties.TcpRetryEvents) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRoute_HttpRoutePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.requiredValidator)(properties.action)), errors.collect(cdk.propertyValidator("action", CfnRoute_HttpRouteActionPropertyValidator)(properties.action)), errors.collect(cdk.propertyValidator("match", cdk.requiredValidator)(properties.match)), errors.collect(cdk.propertyValidator("match", CfnRoute_HttpRouteMatchPropertyValidator)(properties.match)), errors.collect(cdk.propertyValidator("retryPolicy", CfnRoute_HttpRetryPolicyPropertyValidator)(properties.retryPolicy)), errors.collect(cdk.propertyValidator("timeout", CfnRoute_HttpTimeoutPropertyValidator)(properties.timeout)), errors.wrap('supplied properties not correct for "HttpRouteProperty"');
    }
    function cfnRouteHttpRoutePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoute_HttpRoutePropertyValidator(properties).assertSuccess(), { Action: cfnRouteHttpRouteActionPropertyToCloudFormation(properties.action), Match: cfnRouteHttpRouteMatchPropertyToCloudFormation(properties.match), RetryPolicy: cfnRouteHttpRetryPolicyPropertyToCloudFormation(properties.retryPolicy), Timeout: cfnRouteHttpTimeoutPropertyToCloudFormation(properties.timeout) }) : properties;
    }
    function CfnRouteHttpRoutePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", CfnRouteHttpRouteActionPropertyFromCloudFormation(properties.Action)), ret.addPropertyResult("match", "Match", CfnRouteHttpRouteMatchPropertyFromCloudFormation(properties.Match)), ret.addPropertyResult("retryPolicy", "RetryPolicy", properties.RetryPolicy != null ? CfnRouteHttpRetryPolicyPropertyFromCloudFormation(properties.RetryPolicy) : void 0), ret.addPropertyResult("timeout", "Timeout", properties.Timeout != null ? CfnRouteHttpTimeoutPropertyFromCloudFormation(properties.Timeout) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRoute_HttpRouteActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("weightedTargets", cdk.requiredValidator)(properties.weightedTargets)), errors.collect(cdk.propertyValidator("weightedTargets", cdk.listValidator(CfnRoute_WeightedTargetPropertyValidator))(properties.weightedTargets)), errors.wrap('supplied properties not correct for "HttpRouteActionProperty"');
    }
    function cfnRouteHttpRouteActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoute_HttpRouteActionPropertyValidator(properties).assertSuccess(), { WeightedTargets: cdk.listMapper(cfnRouteWeightedTargetPropertyToCloudFormation)(properties.weightedTargets) }) : properties;
    }
    function CfnRouteHttpRouteActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("weightedTargets", "WeightedTargets", cfn_parse.FromCloudFormation.getArray(CfnRouteWeightedTargetPropertyFromCloudFormation)(properties.WeightedTargets)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRoute_HttpRouteHeaderPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("invert", cdk.validateBoolean)(properties.invert)), errors.collect(cdk.propertyValidator("match", CfnRoute_HeaderMatchMethodPropertyValidator)(properties.match)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "HttpRouteHeaderProperty"');
    }
    function cfnRouteHttpRouteHeaderPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoute_HttpRouteHeaderPropertyValidator(properties).assertSuccess(), { Invert: cdk.booleanToCloudFormation(properties.invert), Match: cfnRouteHeaderMatchMethodPropertyToCloudFormation(properties.match), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnRouteHttpRouteHeaderPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("invert", "Invert", properties.Invert != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Invert) : void 0), ret.addPropertyResult("match", "Match", properties.Match != null ? CfnRouteHeaderMatchMethodPropertyFromCloudFormation(properties.Match) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRoute_HttpRouteMatchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("headers", cdk.listValidator(CfnRoute_HttpRouteHeaderPropertyValidator))(properties.headers)), errors.collect(cdk.propertyValidator("method", cdk.validateString)(properties.method)), errors.collect(cdk.propertyValidator("path", CfnRoute_HttpPathMatchPropertyValidator)(properties.path)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.collect(cdk.propertyValidator("queryParameters", cdk.listValidator(CfnRoute_QueryParameterPropertyValidator))(properties.queryParameters)), errors.collect(cdk.propertyValidator("scheme", cdk.validateString)(properties.scheme)), errors.wrap('supplied properties not correct for "HttpRouteMatchProperty"');
    }
    function cfnRouteHttpRouteMatchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoute_HttpRouteMatchPropertyValidator(properties).assertSuccess(), { Headers: cdk.listMapper(cfnRouteHttpRouteHeaderPropertyToCloudFormation)(properties.headers), Method: cdk.stringToCloudFormation(properties.method), Path: cfnRouteHttpPathMatchPropertyToCloudFormation(properties.path), Port: cdk.numberToCloudFormation(properties.port), Prefix: cdk.stringToCloudFormation(properties.prefix), QueryParameters: cdk.listMapper(cfnRouteQueryParameterPropertyToCloudFormation)(properties.queryParameters), Scheme: cdk.stringToCloudFormation(properties.scheme) }) : properties;
    }
    function CfnRouteHttpRouteMatchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("headers", "Headers", properties.Headers != null ? cfn_parse.FromCloudFormation.getArray(CfnRouteHttpRouteHeaderPropertyFromCloudFormation)(properties.Headers) : void 0), ret.addPropertyResult("method", "Method", properties.Method != null ? cfn_parse.FromCloudFormation.getString(properties.Method) : void 0), ret.addPropertyResult("path", "Path", properties.Path != null ? CfnRouteHttpPathMatchPropertyFromCloudFormation(properties.Path) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addPropertyResult("queryParameters", "QueryParameters", properties.QueryParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnRouteQueryParameterPropertyFromCloudFormation)(properties.QueryParameters) : void 0), ret.addPropertyResult("scheme", "Scheme", properties.Scheme != null ? cfn_parse.FromCloudFormation.getString(properties.Scheme) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRoute_HttpTimeoutPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("idle", CfnRoute_DurationPropertyValidator)(properties.idle)), errors.collect(cdk.propertyValidator("perRequest", CfnRoute_DurationPropertyValidator)(properties.perRequest)), errors.wrap('supplied properties not correct for "HttpTimeoutProperty"');
    }
    function cfnRouteHttpTimeoutPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoute_HttpTimeoutPropertyValidator(properties).assertSuccess(), { Idle: cfnRouteDurationPropertyToCloudFormation(properties.idle), PerRequest: cfnRouteDurationPropertyToCloudFormation(properties.perRequest) }) : properties;
    }
    function CfnRouteHttpTimeoutPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("idle", "Idle", properties.Idle != null ? CfnRouteDurationPropertyFromCloudFormation(properties.Idle) : void 0), ret.addPropertyResult("perRequest", "PerRequest", properties.PerRequest != null ? CfnRouteDurationPropertyFromCloudFormation(properties.PerRequest) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRoute_MatchRangePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("end", cdk.requiredValidator)(properties.end)), errors.collect(cdk.propertyValidator("end", cdk.validateNumber)(properties.end)), errors.collect(cdk.propertyValidator("start", cdk.requiredValidator)(properties.start)), errors.collect(cdk.propertyValidator("start", cdk.validateNumber)(properties.start)), errors.wrap('supplied properties not correct for "MatchRangeProperty"');
    }
    function cfnRouteMatchRangePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoute_MatchRangePropertyValidator(properties).assertSuccess(), { End: cdk.numberToCloudFormation(properties.end), Start: cdk.numberToCloudFormation(properties.start) }) : properties;
    }
    function CfnRouteMatchRangePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("end", "End", cfn_parse.FromCloudFormation.getNumber(properties.End)), ret.addPropertyResult("start", "Start", cfn_parse.FromCloudFormation.getNumber(properties.Start)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRoute_QueryParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("match", CfnRoute_HttpQueryParameterMatchPropertyValidator)(properties.match)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "QueryParameterProperty"');
    }
    function cfnRouteQueryParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoute_QueryParameterPropertyValidator(properties).assertSuccess(), { Match: cfnRouteHttpQueryParameterMatchPropertyToCloudFormation(properties.match), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnRouteQueryParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("match", "Match", properties.Match != null ? CfnRouteHttpQueryParameterMatchPropertyFromCloudFormation(properties.Match) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRoute_RouteSpecPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("grpcRoute", CfnRoute_GrpcRoutePropertyValidator)(properties.grpcRoute)), errors.collect(cdk.propertyValidator("http2Route", CfnRoute_HttpRoutePropertyValidator)(properties.http2Route)), errors.collect(cdk.propertyValidator("httpRoute", CfnRoute_HttpRoutePropertyValidator)(properties.httpRoute)), errors.collect(cdk.propertyValidator("priority", cdk.validateNumber)(properties.priority)), errors.collect(cdk.propertyValidator("tcpRoute", CfnRoute_TcpRoutePropertyValidator)(properties.tcpRoute)), errors.wrap('supplied properties not correct for "RouteSpecProperty"');
    }
    function cfnRouteRouteSpecPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoute_RouteSpecPropertyValidator(properties).assertSuccess(), { GrpcRoute: cfnRouteGrpcRoutePropertyToCloudFormation(properties.grpcRoute), Http2Route: cfnRouteHttpRoutePropertyToCloudFormation(properties.http2Route), HttpRoute: cfnRouteHttpRoutePropertyToCloudFormation(properties.httpRoute), Priority: cdk.numberToCloudFormation(properties.priority), TcpRoute: cfnRouteTcpRoutePropertyToCloudFormation(properties.tcpRoute) }) : properties;
    }
    function CfnRouteRouteSpecPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("grpcRoute", "GrpcRoute", properties.GrpcRoute != null ? CfnRouteGrpcRoutePropertyFromCloudFormation(properties.GrpcRoute) : void 0), ret.addPropertyResult("http2Route", "Http2Route", properties.Http2Route != null ? CfnRouteHttpRoutePropertyFromCloudFormation(properties.Http2Route) : void 0), ret.addPropertyResult("httpRoute", "HttpRoute", properties.HttpRoute != null ? CfnRouteHttpRoutePropertyFromCloudFormation(properties.HttpRoute) : void 0), ret.addPropertyResult("priority", "Priority", properties.Priority != null ? cfn_parse.FromCloudFormation.getNumber(properties.Priority) : void 0), ret.addPropertyResult("tcpRoute", "TcpRoute", properties.TcpRoute != null ? CfnRouteTcpRoutePropertyFromCloudFormation(properties.TcpRoute) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRoute_TcpRoutePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.requiredValidator)(properties.action)), errors.collect(cdk.propertyValidator("action", CfnRoute_TcpRouteActionPropertyValidator)(properties.action)), errors.collect(cdk.propertyValidator("match", CfnRoute_TcpRouteMatchPropertyValidator)(properties.match)), errors.collect(cdk.propertyValidator("timeout", CfnRoute_TcpTimeoutPropertyValidator)(properties.timeout)), errors.wrap('supplied properties not correct for "TcpRouteProperty"');
    }
    function cfnRouteTcpRoutePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoute_TcpRoutePropertyValidator(properties).assertSuccess(), { Action: cfnRouteTcpRouteActionPropertyToCloudFormation(properties.action), Match: cfnRouteTcpRouteMatchPropertyToCloudFormation(properties.match), Timeout: cfnRouteTcpTimeoutPropertyToCloudFormation(properties.timeout) }) : properties;
    }
    function CfnRouteTcpRoutePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", CfnRouteTcpRouteActionPropertyFromCloudFormation(properties.Action)), ret.addPropertyResult("match", "Match", properties.Match != null ? CfnRouteTcpRouteMatchPropertyFromCloudFormation(properties.Match) : void 0), ret.addPropertyResult("timeout", "Timeout", properties.Timeout != null ? CfnRouteTcpTimeoutPropertyFromCloudFormation(properties.Timeout) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRoute_TcpRouteActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("weightedTargets", cdk.requiredValidator)(properties.weightedTargets)), errors.collect(cdk.propertyValidator("weightedTargets", cdk.listValidator(CfnRoute_WeightedTargetPropertyValidator))(properties.weightedTargets)), errors.wrap('supplied properties not correct for "TcpRouteActionProperty"');
    }
    function cfnRouteTcpRouteActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoute_TcpRouteActionPropertyValidator(properties).assertSuccess(), { WeightedTargets: cdk.listMapper(cfnRouteWeightedTargetPropertyToCloudFormation)(properties.weightedTargets) }) : properties;
    }
    function CfnRouteTcpRouteActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("weightedTargets", "WeightedTargets", cfn_parse.FromCloudFormation.getArray(CfnRouteWeightedTargetPropertyFromCloudFormation)(properties.WeightedTargets)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRoute_TcpRouteMatchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.wrap('supplied properties not correct for "TcpRouteMatchProperty"');
    }
    function cfnRouteTcpRouteMatchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoute_TcpRouteMatchPropertyValidator(properties).assertSuccess(), { Port: cdk.numberToCloudFormation(properties.port) }) : properties;
    }
    function CfnRouteTcpRouteMatchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRoute_TcpTimeoutPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("idle", CfnRoute_DurationPropertyValidator)(properties.idle)), errors.wrap('supplied properties not correct for "TcpTimeoutProperty"');
    }
    function cfnRouteTcpTimeoutPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoute_TcpTimeoutPropertyValidator(properties).assertSuccess(), { Idle: cfnRouteDurationPropertyToCloudFormation(properties.idle) }) : properties;
    }
    function CfnRouteTcpTimeoutPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("idle", "Idle", properties.Idle != null ? CfnRouteDurationPropertyFromCloudFormation(properties.Idle) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRoute_WeightedTargetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("virtualNode", cdk.requiredValidator)(properties.virtualNode)), errors.collect(cdk.propertyValidator("virtualNode", cdk.validateString)(properties.virtualNode)), errors.collect(cdk.propertyValidator("weight", cdk.requiredValidator)(properties.weight)), errors.collect(cdk.propertyValidator("weight", cdk.validateNumber)(properties.weight)), errors.wrap('supplied properties not correct for "WeightedTargetProperty"');
    }
    function cfnRouteWeightedTargetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoute_WeightedTargetPropertyValidator(properties).assertSuccess(), { Port: cdk.numberToCloudFormation(properties.port), VirtualNode: cdk.stringToCloudFormation(properties.virtualNode), Weight: cdk.numberToCloudFormation(properties.weight) }) : properties;
    }
    function CfnRouteWeightedTargetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addPropertyResult("virtualNode", "VirtualNode", cfn_parse.FromCloudFormation.getString(properties.VirtualNode)), ret.addPropertyResult("weight", "Weight", cfn_parse.FromCloudFormation.getNumber(properties.Weight)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualGatewayPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("meshName", cdk.requiredValidator)(properties.meshName)), errors.collect(cdk.propertyValidator("meshName", cdk.validateString)(properties.meshName)), errors.collect(cdk.propertyValidator("meshOwner", cdk.validateString)(properties.meshOwner)), errors.collect(cdk.propertyValidator("spec", cdk.requiredValidator)(properties.spec)), errors.collect(cdk.propertyValidator("spec", CfnVirtualGateway_VirtualGatewaySpecPropertyValidator)(properties.spec)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("virtualGatewayName", cdk.validateString)(properties.virtualGatewayName)), errors.wrap('supplied properties not correct for "CfnVirtualGatewayProps"');
    }
    function cfnVirtualGatewayPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGatewayPropsValidator(properties).assertSuccess(), { MeshName: cdk.stringToCloudFormation(properties.meshName), Spec: cfnVirtualGatewayVirtualGatewaySpecPropertyToCloudFormation(properties.spec), MeshOwner: cdk.stringToCloudFormation(properties.meshOwner), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VirtualGatewayName: cdk.stringToCloudFormation(properties.virtualGatewayName) }) : properties;
    }
    function CfnVirtualGatewayPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("meshName", "MeshName", cfn_parse.FromCloudFormation.getString(properties.MeshName)), ret.addPropertyResult("spec", "Spec", CfnVirtualGatewayVirtualGatewaySpecPropertyFromCloudFormation(properties.Spec)), ret.addPropertyResult("meshOwner", "MeshOwner", properties.MeshOwner != null ? cfn_parse.FromCloudFormation.getString(properties.MeshOwner) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("virtualGatewayName", "VirtualGatewayName", properties.VirtualGatewayName != null ? cfn_parse.FromCloudFormation.getString(properties.VirtualGatewayName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVirtualGateway = class _CfnVirtualGateway extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVirtualGatewayPropsFromCloudFormation(resourceProperties), ret = new _CfnVirtualGateway(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVirtualGateway.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_CfnVirtualGatewayProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVirtualGateway), error;
        }
        cdk.requireProperty(props, "meshName", this), cdk.requireProperty(props, "spec", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrMeshName = cdk.Token.asString(this.getAtt("MeshName", cdk.ResolutionTypeHint.STRING)), this.attrMeshOwner = cdk.Token.asString(this.getAtt("MeshOwner", cdk.ResolutionTypeHint.STRING)), this.attrResourceOwner = cdk.Token.asString(this.getAtt("ResourceOwner", cdk.ResolutionTypeHint.STRING)), this.attrUid = cdk.Token.asString(this.getAtt("Uid", cdk.ResolutionTypeHint.STRING)), this.attrVirtualGatewayName = cdk.Token.asString(this.getAtt("VirtualGatewayName", cdk.ResolutionTypeHint.STRING)), this.meshName = props.meshName, this.spec = props.spec, this.meshOwner = props.meshOwner, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::AppMesh::VirtualGateway", props.tags, { tagPropertyName: "tags" }), this.virtualGatewayName = props.virtualGatewayName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVirtualGateway.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { meshName: this.meshName, spec: this.spec, meshOwner: this.meshOwner, tags: this.tags.renderTags(), virtualGatewayName: this.virtualGatewayName };
      }
      renderProperties(props) {
        return cfnVirtualGatewayPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnVirtualGateway[_d] = { fqn: "aws-cdk-lib.aws_appmesh.CfnVirtualGateway", version: "2.80.0" }, CfnVirtualGateway.CFN_RESOURCE_TYPE_NAME = "AWS::AppMesh::VirtualGateway", exports2.CfnVirtualGateway = CfnVirtualGateway;
    function CfnVirtualGateway_JsonFormatRefPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "JsonFormatRefProperty"');
    }
    function cfnVirtualGatewayJsonFormatRefPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGateway_JsonFormatRefPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnVirtualGatewayJsonFormatRefPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualGateway_LoggingFormatPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("json", cdk.listValidator(CfnVirtualGateway_JsonFormatRefPropertyValidator))(properties.json)), errors.collect(cdk.propertyValidator("text", cdk.validateString)(properties.text)), errors.wrap('supplied properties not correct for "LoggingFormatProperty"');
    }
    function cfnVirtualGatewayLoggingFormatPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGateway_LoggingFormatPropertyValidator(properties).assertSuccess(), { Json: cdk.listMapper(cfnVirtualGatewayJsonFormatRefPropertyToCloudFormation)(properties.json), Text: cdk.stringToCloudFormation(properties.text) }) : properties;
    }
    function CfnVirtualGatewayLoggingFormatPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("json", "Json", properties.Json != null ? cfn_parse.FromCloudFormation.getArray(CfnVirtualGatewayJsonFormatRefPropertyFromCloudFormation)(properties.Json) : void 0), ret.addPropertyResult("text", "Text", properties.Text != null ? cfn_parse.FromCloudFormation.getString(properties.Text) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualGateway_SubjectAlternativeNameMatchersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("exact", cdk.listValidator(cdk.validateString))(properties.exact)), errors.wrap('supplied properties not correct for "SubjectAlternativeNameMatchersProperty"');
    }
    function cfnVirtualGatewaySubjectAlternativeNameMatchersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGateway_SubjectAlternativeNameMatchersPropertyValidator(properties).assertSuccess(), { Exact: cdk.listMapper(cdk.stringToCloudFormation)(properties.exact) }) : properties;
    }
    function CfnVirtualGatewaySubjectAlternativeNameMatchersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("exact", "Exact", properties.Exact != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Exact) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualGateway_SubjectAlternativeNamesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("match", cdk.requiredValidator)(properties.match)), errors.collect(cdk.propertyValidator("match", CfnVirtualGateway_SubjectAlternativeNameMatchersPropertyValidator)(properties.match)), errors.wrap('supplied properties not correct for "SubjectAlternativeNamesProperty"');
    }
    function cfnVirtualGatewaySubjectAlternativeNamesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGateway_SubjectAlternativeNamesPropertyValidator(properties).assertSuccess(), { Match: cfnVirtualGatewaySubjectAlternativeNameMatchersPropertyToCloudFormation(properties.match) }) : properties;
    }
    function CfnVirtualGatewaySubjectAlternativeNamesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("match", "Match", CfnVirtualGatewaySubjectAlternativeNameMatchersPropertyFromCloudFormation(properties.Match)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualGateway_VirtualGatewayAccessLogPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("file", CfnVirtualGateway_VirtualGatewayFileAccessLogPropertyValidator)(properties.file)), errors.wrap('supplied properties not correct for "VirtualGatewayAccessLogProperty"');
    }
    function cfnVirtualGatewayVirtualGatewayAccessLogPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGateway_VirtualGatewayAccessLogPropertyValidator(properties).assertSuccess(), { File: cfnVirtualGatewayVirtualGatewayFileAccessLogPropertyToCloudFormation(properties.file) }) : properties;
    }
    function CfnVirtualGatewayVirtualGatewayAccessLogPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("file", "File", properties.File != null ? CfnVirtualGatewayVirtualGatewayFileAccessLogPropertyFromCloudFormation(properties.File) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualGateway_VirtualGatewayBackendDefaultsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clientPolicy", CfnVirtualGateway_VirtualGatewayClientPolicyPropertyValidator)(properties.clientPolicy)), errors.wrap('supplied properties not correct for "VirtualGatewayBackendDefaultsProperty"');
    }
    function cfnVirtualGatewayVirtualGatewayBackendDefaultsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGateway_VirtualGatewayBackendDefaultsPropertyValidator(properties).assertSuccess(), { ClientPolicy: cfnVirtualGatewayVirtualGatewayClientPolicyPropertyToCloudFormation(properties.clientPolicy) }) : properties;
    }
    function CfnVirtualGatewayVirtualGatewayBackendDefaultsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clientPolicy", "ClientPolicy", properties.ClientPolicy != null ? CfnVirtualGatewayVirtualGatewayClientPolicyPropertyFromCloudFormation(properties.ClientPolicy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualGateway_VirtualGatewayClientPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("tls", CfnVirtualGateway_VirtualGatewayClientPolicyTlsPropertyValidator)(properties.tls)), errors.wrap('supplied properties not correct for "VirtualGatewayClientPolicyProperty"');
    }
    function cfnVirtualGatewayVirtualGatewayClientPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGateway_VirtualGatewayClientPolicyPropertyValidator(properties).assertSuccess(), { TLS: cfnVirtualGatewayVirtualGatewayClientPolicyTlsPropertyToCloudFormation(properties.tls) }) : properties;
    }
    function CfnVirtualGatewayVirtualGatewayClientPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("tls", "TLS", properties.TLS != null ? CfnVirtualGatewayVirtualGatewayClientPolicyTlsPropertyFromCloudFormation(properties.TLS) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualGateway_VirtualGatewayClientPolicyTlsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificate", CfnVirtualGateway_VirtualGatewayClientTlsCertificatePropertyValidator)(properties.certificate)), errors.collect(cdk.propertyValidator("enforce", cdk.validateBoolean)(properties.enforce)), errors.collect(cdk.propertyValidator("ports", cdk.listValidator(cdk.validateNumber))(properties.ports)), errors.collect(cdk.propertyValidator("validation", cdk.requiredValidator)(properties.validation)), errors.collect(cdk.propertyValidator("validation", CfnVirtualGateway_VirtualGatewayTlsValidationContextPropertyValidator)(properties.validation)), errors.wrap('supplied properties not correct for "VirtualGatewayClientPolicyTlsProperty"');
    }
    function cfnVirtualGatewayVirtualGatewayClientPolicyTlsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGateway_VirtualGatewayClientPolicyTlsPropertyValidator(properties).assertSuccess(), { Certificate: cfnVirtualGatewayVirtualGatewayClientTlsCertificatePropertyToCloudFormation(properties.certificate), Enforce: cdk.booleanToCloudFormation(properties.enforce), Ports: cdk.listMapper(cdk.numberToCloudFormation)(properties.ports), Validation: cfnVirtualGatewayVirtualGatewayTlsValidationContextPropertyToCloudFormation(properties.validation) }) : properties;
    }
    function CfnVirtualGatewayVirtualGatewayClientPolicyTlsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificate", "Certificate", properties.Certificate != null ? CfnVirtualGatewayVirtualGatewayClientTlsCertificatePropertyFromCloudFormation(properties.Certificate) : void 0), ret.addPropertyResult("enforce", "Enforce", properties.Enforce != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enforce) : void 0), ret.addPropertyResult("ports", "Ports", properties.Ports != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getNumber)(properties.Ports) : void 0), ret.addPropertyResult("validation", "Validation", CfnVirtualGatewayVirtualGatewayTlsValidationContextPropertyFromCloudFormation(properties.Validation)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualGateway_VirtualGatewayClientTlsCertificatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("file", CfnVirtualGateway_VirtualGatewayListenerTlsFileCertificatePropertyValidator)(properties.file)), errors.collect(cdk.propertyValidator("sds", CfnVirtualGateway_VirtualGatewayListenerTlsSdsCertificatePropertyValidator)(properties.sds)), errors.wrap('supplied properties not correct for "VirtualGatewayClientTlsCertificateProperty"');
    }
    function cfnVirtualGatewayVirtualGatewayClientTlsCertificatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGateway_VirtualGatewayClientTlsCertificatePropertyValidator(properties).assertSuccess(), { File: cfnVirtualGatewayVirtualGatewayListenerTlsFileCertificatePropertyToCloudFormation(properties.file), SDS: cfnVirtualGatewayVirtualGatewayListenerTlsSdsCertificatePropertyToCloudFormation(properties.sds) }) : properties;
    }
    function CfnVirtualGatewayVirtualGatewayClientTlsCertificatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("file", "File", properties.File != null ? CfnVirtualGatewayVirtualGatewayListenerTlsFileCertificatePropertyFromCloudFormation(properties.File) : void 0), ret.addPropertyResult("sds", "SDS", properties.SDS != null ? CfnVirtualGatewayVirtualGatewayListenerTlsSdsCertificatePropertyFromCloudFormation(properties.SDS) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualGateway_VirtualGatewayConnectionPoolPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("grpc", CfnVirtualGateway_VirtualGatewayGrpcConnectionPoolPropertyValidator)(properties.grpc)), errors.collect(cdk.propertyValidator("http", CfnVirtualGateway_VirtualGatewayHttpConnectionPoolPropertyValidator)(properties.http)), errors.collect(cdk.propertyValidator("http2", CfnVirtualGateway_VirtualGatewayHttp2ConnectionPoolPropertyValidator)(properties.http2)), errors.wrap('supplied properties not correct for "VirtualGatewayConnectionPoolProperty"');
    }
    function cfnVirtualGatewayVirtualGatewayConnectionPoolPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGateway_VirtualGatewayConnectionPoolPropertyValidator(properties).assertSuccess(), { GRPC: cfnVirtualGatewayVirtualGatewayGrpcConnectionPoolPropertyToCloudFormation(properties.grpc), HTTP: cfnVirtualGatewayVirtualGatewayHttpConnectionPoolPropertyToCloudFormation(properties.http), HTTP2: cfnVirtualGatewayVirtualGatewayHttp2ConnectionPoolPropertyToCloudFormation(properties.http2) }) : properties;
    }
    function CfnVirtualGatewayVirtualGatewayConnectionPoolPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("grpc", "GRPC", properties.GRPC != null ? CfnVirtualGatewayVirtualGatewayGrpcConnectionPoolPropertyFromCloudFormation(properties.GRPC) : void 0), ret.addPropertyResult("http", "HTTP", properties.HTTP != null ? CfnVirtualGatewayVirtualGatewayHttpConnectionPoolPropertyFromCloudFormation(properties.HTTP) : void 0), ret.addPropertyResult("http2", "HTTP2", properties.HTTP2 != null ? CfnVirtualGatewayVirtualGatewayHttp2ConnectionPoolPropertyFromCloudFormation(properties.HTTP2) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualGateway_VirtualGatewayFileAccessLogPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("format", CfnVirtualGateway_LoggingFormatPropertyValidator)(properties.format)), errors.collect(cdk.propertyValidator("path", cdk.requiredValidator)(properties.path)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.wrap('supplied properties not correct for "VirtualGatewayFileAccessLogProperty"');
    }
    function cfnVirtualGatewayVirtualGatewayFileAccessLogPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGateway_VirtualGatewayFileAccessLogPropertyValidator(properties).assertSuccess(), { Format: cfnVirtualGatewayLoggingFormatPropertyToCloudFormation(properties.format), Path: cdk.stringToCloudFormation(properties.path) }) : properties;
    }
    function CfnVirtualGatewayVirtualGatewayFileAccessLogPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("format", "Format", properties.Format != null ? CfnVirtualGatewayLoggingFormatPropertyFromCloudFormation(properties.Format) : void 0), ret.addPropertyResult("path", "Path", cfn_parse.FromCloudFormation.getString(properties.Path)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualGateway_VirtualGatewayGrpcConnectionPoolPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxRequests", cdk.requiredValidator)(properties.maxRequests)), errors.collect(cdk.propertyValidator("maxRequests", cdk.validateNumber)(properties.maxRequests)), errors.wrap('supplied properties not correct for "VirtualGatewayGrpcConnectionPoolProperty"');
    }
    function cfnVirtualGatewayVirtualGatewayGrpcConnectionPoolPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGateway_VirtualGatewayGrpcConnectionPoolPropertyValidator(properties).assertSuccess(), { MaxRequests: cdk.numberToCloudFormation(properties.maxRequests) }) : properties;
    }
    function CfnVirtualGatewayVirtualGatewayGrpcConnectionPoolPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxRequests", "MaxRequests", cfn_parse.FromCloudFormation.getNumber(properties.MaxRequests)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualGateway_VirtualGatewayHealthCheckPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("healthyThreshold", cdk.requiredValidator)(properties.healthyThreshold)), errors.collect(cdk.propertyValidator("healthyThreshold", cdk.validateNumber)(properties.healthyThreshold)), errors.collect(cdk.propertyValidator("intervalMillis", cdk.requiredValidator)(properties.intervalMillis)), errors.collect(cdk.propertyValidator("intervalMillis", cdk.validateNumber)(properties.intervalMillis)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("protocol", cdk.requiredValidator)(properties.protocol)), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.collect(cdk.propertyValidator("timeoutMillis", cdk.requiredValidator)(properties.timeoutMillis)), errors.collect(cdk.propertyValidator("timeoutMillis", cdk.validateNumber)(properties.timeoutMillis)), errors.collect(cdk.propertyValidator("unhealthyThreshold", cdk.requiredValidator)(properties.unhealthyThreshold)), errors.collect(cdk.propertyValidator("unhealthyThreshold", cdk.validateNumber)(properties.unhealthyThreshold)), errors.wrap('supplied properties not correct for "VirtualGatewayHealthCheckPolicyProperty"');
    }
    function cfnVirtualGatewayVirtualGatewayHealthCheckPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGateway_VirtualGatewayHealthCheckPolicyPropertyValidator(properties).assertSuccess(), { HealthyThreshold: cdk.numberToCloudFormation(properties.healthyThreshold), IntervalMillis: cdk.numberToCloudFormation(properties.intervalMillis), Path: cdk.stringToCloudFormation(properties.path), Port: cdk.numberToCloudFormation(properties.port), Protocol: cdk.stringToCloudFormation(properties.protocol), TimeoutMillis: cdk.numberToCloudFormation(properties.timeoutMillis), UnhealthyThreshold: cdk.numberToCloudFormation(properties.unhealthyThreshold) }) : properties;
    }
    function CfnVirtualGatewayVirtualGatewayHealthCheckPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("healthyThreshold", "HealthyThreshold", cfn_parse.FromCloudFormation.getNumber(properties.HealthyThreshold)), ret.addPropertyResult("intervalMillis", "IntervalMillis", cfn_parse.FromCloudFormation.getNumber(properties.IntervalMillis)), ret.addPropertyResult("path", "Path", properties.Path != null ? cfn_parse.FromCloudFormation.getString(properties.Path) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addPropertyResult("protocol", "Protocol", cfn_parse.FromCloudFormation.getString(properties.Protocol)), ret.addPropertyResult("timeoutMillis", "TimeoutMillis", cfn_parse.FromCloudFormation.getNumber(properties.TimeoutMillis)), ret.addPropertyResult("unhealthyThreshold", "UnhealthyThreshold", cfn_parse.FromCloudFormation.getNumber(properties.UnhealthyThreshold)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualGateway_VirtualGatewayHttp2ConnectionPoolPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxRequests", cdk.requiredValidator)(properties.maxRequests)), errors.collect(cdk.propertyValidator("maxRequests", cdk.validateNumber)(properties.maxRequests)), errors.wrap('supplied properties not correct for "VirtualGatewayHttp2ConnectionPoolProperty"');
    }
    function cfnVirtualGatewayVirtualGatewayHttp2ConnectionPoolPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGateway_VirtualGatewayHttp2ConnectionPoolPropertyValidator(properties).assertSuccess(), { MaxRequests: cdk.numberToCloudFormation(properties.maxRequests) }) : properties;
    }
    function CfnVirtualGatewayVirtualGatewayHttp2ConnectionPoolPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxRequests", "MaxRequests", cfn_parse.FromCloudFormation.getNumber(properties.MaxRequests)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualGateway_VirtualGatewayHttpConnectionPoolPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxConnections", cdk.requiredValidator)(properties.maxConnections)), errors.collect(cdk.propertyValidator("maxConnections", cdk.validateNumber)(properties.maxConnections)), errors.collect(cdk.propertyValidator("maxPendingRequests", cdk.validateNumber)(properties.maxPendingRequests)), errors.wrap('supplied properties not correct for "VirtualGatewayHttpConnectionPoolProperty"');
    }
    function cfnVirtualGatewayVirtualGatewayHttpConnectionPoolPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGateway_VirtualGatewayHttpConnectionPoolPropertyValidator(properties).assertSuccess(), { MaxConnections: cdk.numberToCloudFormation(properties.maxConnections), MaxPendingRequests: cdk.numberToCloudFormation(properties.maxPendingRequests) }) : properties;
    }
    function CfnVirtualGatewayVirtualGatewayHttpConnectionPoolPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxConnections", "MaxConnections", cfn_parse.FromCloudFormation.getNumber(properties.MaxConnections)), ret.addPropertyResult("maxPendingRequests", "MaxPendingRequests", properties.MaxPendingRequests != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxPendingRequests) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualGateway_VirtualGatewayListenerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectionPool", CfnVirtualGateway_VirtualGatewayConnectionPoolPropertyValidator)(properties.connectionPool)), errors.collect(cdk.propertyValidator("healthCheck", CfnVirtualGateway_VirtualGatewayHealthCheckPolicyPropertyValidator)(properties.healthCheck)), errors.collect(cdk.propertyValidator("portMapping", cdk.requiredValidator)(properties.portMapping)), errors.collect(cdk.propertyValidator("portMapping", CfnVirtualGateway_VirtualGatewayPortMappingPropertyValidator)(properties.portMapping)), errors.collect(cdk.propertyValidator("tls", CfnVirtualGateway_VirtualGatewayListenerTlsPropertyValidator)(properties.tls)), errors.wrap('supplied properties not correct for "VirtualGatewayListenerProperty"');
    }
    function cfnVirtualGatewayVirtualGatewayListenerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGateway_VirtualGatewayListenerPropertyValidator(properties).assertSuccess(), { ConnectionPool: cfnVirtualGatewayVirtualGatewayConnectionPoolPropertyToCloudFormation(properties.connectionPool), HealthCheck: cfnVirtualGatewayVirtualGatewayHealthCheckPolicyPropertyToCloudFormation(properties.healthCheck), PortMapping: cfnVirtualGatewayVirtualGatewayPortMappingPropertyToCloudFormation(properties.portMapping), TLS: cfnVirtualGatewayVirtualGatewayListenerTlsPropertyToCloudFormation(properties.tls) }) : properties;
    }
    function CfnVirtualGatewayVirtualGatewayListenerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectionPool", "ConnectionPool", properties.ConnectionPool != null ? CfnVirtualGatewayVirtualGatewayConnectionPoolPropertyFromCloudFormation(properties.ConnectionPool) : void 0), ret.addPropertyResult("healthCheck", "HealthCheck", properties.HealthCheck != null ? CfnVirtualGatewayVirtualGatewayHealthCheckPolicyPropertyFromCloudFormation(properties.HealthCheck) : void 0), ret.addPropertyResult("portMapping", "PortMapping", CfnVirtualGatewayVirtualGatewayPortMappingPropertyFromCloudFormation(properties.PortMapping)), ret.addPropertyResult("tls", "TLS", properties.TLS != null ? CfnVirtualGatewayVirtualGatewayListenerTlsPropertyFromCloudFormation(properties.TLS) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualGateway_VirtualGatewayListenerTlsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificate", cdk.requiredValidator)(properties.certificate)), errors.collect(cdk.propertyValidator("certificate", CfnVirtualGateway_VirtualGatewayListenerTlsCertificatePropertyValidator)(properties.certificate)), errors.collect(cdk.propertyValidator("mode", cdk.requiredValidator)(properties.mode)), errors.collect(cdk.propertyValidator("mode", cdk.validateString)(properties.mode)), errors.collect(cdk.propertyValidator("validation", CfnVirtualGateway_VirtualGatewayListenerTlsValidationContextPropertyValidator)(properties.validation)), errors.wrap('supplied properties not correct for "VirtualGatewayListenerTlsProperty"');
    }
    function cfnVirtualGatewayVirtualGatewayListenerTlsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGateway_VirtualGatewayListenerTlsPropertyValidator(properties).assertSuccess(), { Certificate: cfnVirtualGatewayVirtualGatewayListenerTlsCertificatePropertyToCloudFormation(properties.certificate), Mode: cdk.stringToCloudFormation(properties.mode), Validation: cfnVirtualGatewayVirtualGatewayListenerTlsValidationContextPropertyToCloudFormation(properties.validation) }) : properties;
    }
    function CfnVirtualGatewayVirtualGatewayListenerTlsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificate", "Certificate", CfnVirtualGatewayVirtualGatewayListenerTlsCertificatePropertyFromCloudFormation(properties.Certificate)), ret.addPropertyResult("mode", "Mode", cfn_parse.FromCloudFormation.getString(properties.Mode)), ret.addPropertyResult("validation", "Validation", properties.Validation != null ? CfnVirtualGatewayVirtualGatewayListenerTlsValidationContextPropertyFromCloudFormation(properties.Validation) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualGateway_VirtualGatewayListenerTlsAcmCertificatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateArn", cdk.requiredValidator)(properties.certificateArn)), errors.collect(cdk.propertyValidator("certificateArn", cdk.validateString)(properties.certificateArn)), errors.wrap('supplied properties not correct for "VirtualGatewayListenerTlsAcmCertificateProperty"');
    }
    function cfnVirtualGatewayVirtualGatewayListenerTlsAcmCertificatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGateway_VirtualGatewayListenerTlsAcmCertificatePropertyValidator(properties).assertSuccess(), { CertificateArn: cdk.stringToCloudFormation(properties.certificateArn) }) : properties;
    }
    function CfnVirtualGatewayVirtualGatewayListenerTlsAcmCertificatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificateArn", "CertificateArn", cfn_parse.FromCloudFormation.getString(properties.CertificateArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualGateway_VirtualGatewayListenerTlsCertificatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acm", CfnVirtualGateway_VirtualGatewayListenerTlsAcmCertificatePropertyValidator)(properties.acm)), errors.collect(cdk.propertyValidator("file", CfnVirtualGateway_VirtualGatewayListenerTlsFileCertificatePropertyValidator)(properties.file)), errors.collect(cdk.propertyValidator("sds", CfnVirtualGateway_VirtualGatewayListenerTlsSdsCertificatePropertyValidator)(properties.sds)), errors.wrap('supplied properties not correct for "VirtualGatewayListenerTlsCertificateProperty"');
    }
    function cfnVirtualGatewayVirtualGatewayListenerTlsCertificatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGateway_VirtualGatewayListenerTlsCertificatePropertyValidator(properties).assertSuccess(), { ACM: cfnVirtualGatewayVirtualGatewayListenerTlsAcmCertificatePropertyToCloudFormation(properties.acm), File: cfnVirtualGatewayVirtualGatewayListenerTlsFileCertificatePropertyToCloudFormation(properties.file), SDS: cfnVirtualGatewayVirtualGatewayListenerTlsSdsCertificatePropertyToCloudFormation(properties.sds) }) : properties;
    }
    function CfnVirtualGatewayVirtualGatewayListenerTlsCertificatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("acm", "ACM", properties.ACM != null ? CfnVirtualGatewayVirtualGatewayListenerTlsAcmCertificatePropertyFromCloudFormation(properties.ACM) : void 0), ret.addPropertyResult("file", "File", properties.File != null ? CfnVirtualGatewayVirtualGatewayListenerTlsFileCertificatePropertyFromCloudFormation(properties.File) : void 0), ret.addPropertyResult("sds", "SDS", properties.SDS != null ? CfnVirtualGatewayVirtualGatewayListenerTlsSdsCertificatePropertyFromCloudFormation(properties.SDS) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualGateway_VirtualGatewayListenerTlsFileCertificatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateChain", cdk.requiredValidator)(properties.certificateChain)), errors.collect(cdk.propertyValidator("certificateChain", cdk.validateString)(properties.certificateChain)), errors.collect(cdk.propertyValidator("privateKey", cdk.requiredValidator)(properties.privateKey)), errors.collect(cdk.propertyValidator("privateKey", cdk.validateString)(properties.privateKey)), errors.wrap('supplied properties not correct for "VirtualGatewayListenerTlsFileCertificateProperty"');
    }
    function cfnVirtualGatewayVirtualGatewayListenerTlsFileCertificatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGateway_VirtualGatewayListenerTlsFileCertificatePropertyValidator(properties).assertSuccess(), { CertificateChain: cdk.stringToCloudFormation(properties.certificateChain), PrivateKey: cdk.stringToCloudFormation(properties.privateKey) }) : properties;
    }
    function CfnVirtualGatewayVirtualGatewayListenerTlsFileCertificatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificateChain", "CertificateChain", cfn_parse.FromCloudFormation.getString(properties.CertificateChain)), ret.addPropertyResult("privateKey", "PrivateKey", cfn_parse.FromCloudFormation.getString(properties.PrivateKey)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualGateway_VirtualGatewayListenerTlsSdsCertificatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("secretName", cdk.requiredValidator)(properties.secretName)), errors.collect(cdk.propertyValidator("secretName", cdk.validateString)(properties.secretName)), errors.wrap('supplied properties not correct for "VirtualGatewayListenerTlsSdsCertificateProperty"');
    }
    function cfnVirtualGatewayVirtualGatewayListenerTlsSdsCertificatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGateway_VirtualGatewayListenerTlsSdsCertificatePropertyValidator(properties).assertSuccess(), { SecretName: cdk.stringToCloudFormation(properties.secretName) }) : properties;
    }
    function CfnVirtualGatewayVirtualGatewayListenerTlsSdsCertificatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("secretName", "SecretName", cfn_parse.FromCloudFormation.getString(properties.SecretName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualGateway_VirtualGatewayListenerTlsValidationContextPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("subjectAlternativeNames", CfnVirtualGateway_SubjectAlternativeNamesPropertyValidator)(properties.subjectAlternativeNames)), errors.collect(cdk.propertyValidator("trust", cdk.requiredValidator)(properties.trust)), errors.collect(cdk.propertyValidator("trust", CfnVirtualGateway_VirtualGatewayListenerTlsValidationContextTrustPropertyValidator)(properties.trust)), errors.wrap('supplied properties not correct for "VirtualGatewayListenerTlsValidationContextProperty"');
    }
    function cfnVirtualGatewayVirtualGatewayListenerTlsValidationContextPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGateway_VirtualGatewayListenerTlsValidationContextPropertyValidator(properties).assertSuccess(), { SubjectAlternativeNames: cfnVirtualGatewaySubjectAlternativeNamesPropertyToCloudFormation(properties.subjectAlternativeNames), Trust: cfnVirtualGatewayVirtualGatewayListenerTlsValidationContextTrustPropertyToCloudFormation(properties.trust) }) : properties;
    }
    function CfnVirtualGatewayVirtualGatewayListenerTlsValidationContextPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("subjectAlternativeNames", "SubjectAlternativeNames", properties.SubjectAlternativeNames != null ? CfnVirtualGatewaySubjectAlternativeNamesPropertyFromCloudFormation(properties.SubjectAlternativeNames) : void 0), ret.addPropertyResult("trust", "Trust", CfnVirtualGatewayVirtualGatewayListenerTlsValidationContextTrustPropertyFromCloudFormation(properties.Trust)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualGateway_VirtualGatewayListenerTlsValidationContextTrustPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("file", CfnVirtualGateway_VirtualGatewayTlsValidationContextFileTrustPropertyValidator)(properties.file)), errors.collect(cdk.propertyValidator("sds", CfnVirtualGateway_VirtualGatewayTlsValidationContextSdsTrustPropertyValidator)(properties.sds)), errors.wrap('supplied properties not correct for "VirtualGatewayListenerTlsValidationContextTrustProperty"');
    }
    function cfnVirtualGatewayVirtualGatewayListenerTlsValidationContextTrustPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGateway_VirtualGatewayListenerTlsValidationContextTrustPropertyValidator(properties).assertSuccess(), { File: cfnVirtualGatewayVirtualGatewayTlsValidationContextFileTrustPropertyToCloudFormation(properties.file), SDS: cfnVirtualGatewayVirtualGatewayTlsValidationContextSdsTrustPropertyToCloudFormation(properties.sds) }) : properties;
    }
    function CfnVirtualGatewayVirtualGatewayListenerTlsValidationContextTrustPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("file", "File", properties.File != null ? CfnVirtualGatewayVirtualGatewayTlsValidationContextFileTrustPropertyFromCloudFormation(properties.File) : void 0), ret.addPropertyResult("sds", "SDS", properties.SDS != null ? CfnVirtualGatewayVirtualGatewayTlsValidationContextSdsTrustPropertyFromCloudFormation(properties.SDS) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualGateway_VirtualGatewayLoggingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessLog", CfnVirtualGateway_VirtualGatewayAccessLogPropertyValidator)(properties.accessLog)), errors.wrap('supplied properties not correct for "VirtualGatewayLoggingProperty"');
    }
    function cfnVirtualGatewayVirtualGatewayLoggingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGateway_VirtualGatewayLoggingPropertyValidator(properties).assertSuccess(), { AccessLog: cfnVirtualGatewayVirtualGatewayAccessLogPropertyToCloudFormation(properties.accessLog) }) : properties;
    }
    function CfnVirtualGatewayVirtualGatewayLoggingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessLog", "AccessLog", properties.AccessLog != null ? CfnVirtualGatewayVirtualGatewayAccessLogPropertyFromCloudFormation(properties.AccessLog) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualGateway_VirtualGatewayPortMappingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("port", cdk.requiredValidator)(properties.port)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("protocol", cdk.requiredValidator)(properties.protocol)), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.wrap('supplied properties not correct for "VirtualGatewayPortMappingProperty"');
    }
    function cfnVirtualGatewayVirtualGatewayPortMappingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGateway_VirtualGatewayPortMappingPropertyValidator(properties).assertSuccess(), { Port: cdk.numberToCloudFormation(properties.port), Protocol: cdk.stringToCloudFormation(properties.protocol) }) : properties;
    }
    function CfnVirtualGatewayVirtualGatewayPortMappingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("port", "Port", cfn_parse.FromCloudFormation.getNumber(properties.Port)), ret.addPropertyResult("protocol", "Protocol", cfn_parse.FromCloudFormation.getString(properties.Protocol)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualGateway_VirtualGatewaySpecPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("backendDefaults", CfnVirtualGateway_VirtualGatewayBackendDefaultsPropertyValidator)(properties.backendDefaults)), errors.collect(cdk.propertyValidator("listeners", cdk.requiredValidator)(properties.listeners)), errors.collect(cdk.propertyValidator("listeners", cdk.listValidator(CfnVirtualGateway_VirtualGatewayListenerPropertyValidator))(properties.listeners)), errors.collect(cdk.propertyValidator("logging", CfnVirtualGateway_VirtualGatewayLoggingPropertyValidator)(properties.logging)), errors.wrap('supplied properties not correct for "VirtualGatewaySpecProperty"');
    }
    function cfnVirtualGatewayVirtualGatewaySpecPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGateway_VirtualGatewaySpecPropertyValidator(properties).assertSuccess(), { BackendDefaults: cfnVirtualGatewayVirtualGatewayBackendDefaultsPropertyToCloudFormation(properties.backendDefaults), Listeners: cdk.listMapper(cfnVirtualGatewayVirtualGatewayListenerPropertyToCloudFormation)(properties.listeners), Logging: cfnVirtualGatewayVirtualGatewayLoggingPropertyToCloudFormation(properties.logging) }) : properties;
    }
    function CfnVirtualGatewayVirtualGatewaySpecPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("backendDefaults", "BackendDefaults", properties.BackendDefaults != null ? CfnVirtualGatewayVirtualGatewayBackendDefaultsPropertyFromCloudFormation(properties.BackendDefaults) : void 0), ret.addPropertyResult("listeners", "Listeners", cfn_parse.FromCloudFormation.getArray(CfnVirtualGatewayVirtualGatewayListenerPropertyFromCloudFormation)(properties.Listeners)), ret.addPropertyResult("logging", "Logging", properties.Logging != null ? CfnVirtualGatewayVirtualGatewayLoggingPropertyFromCloudFormation(properties.Logging) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualGateway_VirtualGatewayTlsValidationContextPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("subjectAlternativeNames", CfnVirtualGateway_SubjectAlternativeNamesPropertyValidator)(properties.subjectAlternativeNames)), errors.collect(cdk.propertyValidator("trust", cdk.requiredValidator)(properties.trust)), errors.collect(cdk.propertyValidator("trust", CfnVirtualGateway_VirtualGatewayTlsValidationContextTrustPropertyValidator)(properties.trust)), errors.wrap('supplied properties not correct for "VirtualGatewayTlsValidationContextProperty"');
    }
    function cfnVirtualGatewayVirtualGatewayTlsValidationContextPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGateway_VirtualGatewayTlsValidationContextPropertyValidator(properties).assertSuccess(), { SubjectAlternativeNames: cfnVirtualGatewaySubjectAlternativeNamesPropertyToCloudFormation(properties.subjectAlternativeNames), Trust: cfnVirtualGatewayVirtualGatewayTlsValidationContextTrustPropertyToCloudFormation(properties.trust) }) : properties;
    }
    function CfnVirtualGatewayVirtualGatewayTlsValidationContextPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("subjectAlternativeNames", "SubjectAlternativeNames", properties.SubjectAlternativeNames != null ? CfnVirtualGatewaySubjectAlternativeNamesPropertyFromCloudFormation(properties.SubjectAlternativeNames) : void 0), ret.addPropertyResult("trust", "Trust", CfnVirtualGatewayVirtualGatewayTlsValidationContextTrustPropertyFromCloudFormation(properties.Trust)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualGateway_VirtualGatewayTlsValidationContextAcmTrustPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateAuthorityArns", cdk.requiredValidator)(properties.certificateAuthorityArns)), errors.collect(cdk.propertyValidator("certificateAuthorityArns", cdk.listValidator(cdk.validateString))(properties.certificateAuthorityArns)), errors.wrap('supplied properties not correct for "VirtualGatewayTlsValidationContextAcmTrustProperty"');
    }
    function cfnVirtualGatewayVirtualGatewayTlsValidationContextAcmTrustPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGateway_VirtualGatewayTlsValidationContextAcmTrustPropertyValidator(properties).assertSuccess(), { CertificateAuthorityArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.certificateAuthorityArns) }) : properties;
    }
    function CfnVirtualGatewayVirtualGatewayTlsValidationContextAcmTrustPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificateAuthorityArns", "CertificateAuthorityArns", cfn_parse.FromCloudFormation.getStringArray(properties.CertificateAuthorityArns)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualGateway_VirtualGatewayTlsValidationContextFileTrustPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateChain", cdk.requiredValidator)(properties.certificateChain)), errors.collect(cdk.propertyValidator("certificateChain", cdk.validateString)(properties.certificateChain)), errors.wrap('supplied properties not correct for "VirtualGatewayTlsValidationContextFileTrustProperty"');
    }
    function cfnVirtualGatewayVirtualGatewayTlsValidationContextFileTrustPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGateway_VirtualGatewayTlsValidationContextFileTrustPropertyValidator(properties).assertSuccess(), { CertificateChain: cdk.stringToCloudFormation(properties.certificateChain) }) : properties;
    }
    function CfnVirtualGatewayVirtualGatewayTlsValidationContextFileTrustPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificateChain", "CertificateChain", cfn_parse.FromCloudFormation.getString(properties.CertificateChain)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualGateway_VirtualGatewayTlsValidationContextSdsTrustPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("secretName", cdk.requiredValidator)(properties.secretName)), errors.collect(cdk.propertyValidator("secretName", cdk.validateString)(properties.secretName)), errors.wrap('supplied properties not correct for "VirtualGatewayTlsValidationContextSdsTrustProperty"');
    }
    function cfnVirtualGatewayVirtualGatewayTlsValidationContextSdsTrustPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGateway_VirtualGatewayTlsValidationContextSdsTrustPropertyValidator(properties).assertSuccess(), { SecretName: cdk.stringToCloudFormation(properties.secretName) }) : properties;
    }
    function CfnVirtualGatewayVirtualGatewayTlsValidationContextSdsTrustPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("secretName", "SecretName", cfn_parse.FromCloudFormation.getString(properties.SecretName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualGateway_VirtualGatewayTlsValidationContextTrustPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acm", CfnVirtualGateway_VirtualGatewayTlsValidationContextAcmTrustPropertyValidator)(properties.acm)), errors.collect(cdk.propertyValidator("file", CfnVirtualGateway_VirtualGatewayTlsValidationContextFileTrustPropertyValidator)(properties.file)), errors.collect(cdk.propertyValidator("sds", CfnVirtualGateway_VirtualGatewayTlsValidationContextSdsTrustPropertyValidator)(properties.sds)), errors.wrap('supplied properties not correct for "VirtualGatewayTlsValidationContextTrustProperty"');
    }
    function cfnVirtualGatewayVirtualGatewayTlsValidationContextTrustPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualGateway_VirtualGatewayTlsValidationContextTrustPropertyValidator(properties).assertSuccess(), { ACM: cfnVirtualGatewayVirtualGatewayTlsValidationContextAcmTrustPropertyToCloudFormation(properties.acm), File: cfnVirtualGatewayVirtualGatewayTlsValidationContextFileTrustPropertyToCloudFormation(properties.file), SDS: cfnVirtualGatewayVirtualGatewayTlsValidationContextSdsTrustPropertyToCloudFormation(properties.sds) }) : properties;
    }
    function CfnVirtualGatewayVirtualGatewayTlsValidationContextTrustPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("acm", "ACM", properties.ACM != null ? CfnVirtualGatewayVirtualGatewayTlsValidationContextAcmTrustPropertyFromCloudFormation(properties.ACM) : void 0), ret.addPropertyResult("file", "File", properties.File != null ? CfnVirtualGatewayVirtualGatewayTlsValidationContextFileTrustPropertyFromCloudFormation(properties.File) : void 0), ret.addPropertyResult("sds", "SDS", properties.SDS != null ? CfnVirtualGatewayVirtualGatewayTlsValidationContextSdsTrustPropertyFromCloudFormation(properties.SDS) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNodePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("meshName", cdk.requiredValidator)(properties.meshName)), errors.collect(cdk.propertyValidator("meshName", cdk.validateString)(properties.meshName)), errors.collect(cdk.propertyValidator("meshOwner", cdk.validateString)(properties.meshOwner)), errors.collect(cdk.propertyValidator("spec", cdk.requiredValidator)(properties.spec)), errors.collect(cdk.propertyValidator("spec", CfnVirtualNode_VirtualNodeSpecPropertyValidator)(properties.spec)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("virtualNodeName", cdk.validateString)(properties.virtualNodeName)), errors.wrap('supplied properties not correct for "CfnVirtualNodeProps"');
    }
    function cfnVirtualNodePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNodePropsValidator(properties).assertSuccess(), { MeshName: cdk.stringToCloudFormation(properties.meshName), Spec: cfnVirtualNodeVirtualNodeSpecPropertyToCloudFormation(properties.spec), MeshOwner: cdk.stringToCloudFormation(properties.meshOwner), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VirtualNodeName: cdk.stringToCloudFormation(properties.virtualNodeName) }) : properties;
    }
    function CfnVirtualNodePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("meshName", "MeshName", cfn_parse.FromCloudFormation.getString(properties.MeshName)), ret.addPropertyResult("spec", "Spec", CfnVirtualNodeVirtualNodeSpecPropertyFromCloudFormation(properties.Spec)), ret.addPropertyResult("meshOwner", "MeshOwner", properties.MeshOwner != null ? cfn_parse.FromCloudFormation.getString(properties.MeshOwner) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("virtualNodeName", "VirtualNodeName", properties.VirtualNodeName != null ? cfn_parse.FromCloudFormation.getString(properties.VirtualNodeName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVirtualNode = class _CfnVirtualNode extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVirtualNodePropsFromCloudFormation(resourceProperties), ret = new _CfnVirtualNode(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVirtualNode.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_CfnVirtualNodeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVirtualNode), error;
        }
        cdk.requireProperty(props, "meshName", this), cdk.requireProperty(props, "spec", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrMeshName = cdk.Token.asString(this.getAtt("MeshName", cdk.ResolutionTypeHint.STRING)), this.attrMeshOwner = cdk.Token.asString(this.getAtt("MeshOwner", cdk.ResolutionTypeHint.STRING)), this.attrResourceOwner = cdk.Token.asString(this.getAtt("ResourceOwner", cdk.ResolutionTypeHint.STRING)), this.attrUid = cdk.Token.asString(this.getAtt("Uid", cdk.ResolutionTypeHint.STRING)), this.attrVirtualNodeName = cdk.Token.asString(this.getAtt("VirtualNodeName", cdk.ResolutionTypeHint.STRING)), this.meshName = props.meshName, this.spec = props.spec, this.meshOwner = props.meshOwner, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::AppMesh::VirtualNode", props.tags, { tagPropertyName: "tags" }), this.virtualNodeName = props.virtualNodeName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVirtualNode.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { meshName: this.meshName, spec: this.spec, meshOwner: this.meshOwner, tags: this.tags.renderTags(), virtualNodeName: this.virtualNodeName };
      }
      renderProperties(props) {
        return cfnVirtualNodePropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnVirtualNode[_e] = { fqn: "aws-cdk-lib.aws_appmesh.CfnVirtualNode", version: "2.80.0" }, CfnVirtualNode.CFN_RESOURCE_TYPE_NAME = "AWS::AppMesh::VirtualNode", exports2.CfnVirtualNode = CfnVirtualNode;
    function CfnVirtualNode_AccessLogPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("file", CfnVirtualNode_FileAccessLogPropertyValidator)(properties.file)), errors.wrap('supplied properties not correct for "AccessLogProperty"');
    }
    function cfnVirtualNodeAccessLogPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_AccessLogPropertyValidator(properties).assertSuccess(), { File: cfnVirtualNodeFileAccessLogPropertyToCloudFormation(properties.file) }) : properties;
    }
    function CfnVirtualNodeAccessLogPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("file", "File", properties.File != null ? CfnVirtualNodeFileAccessLogPropertyFromCloudFormation(properties.File) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_AwsCloudMapInstanceAttributePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "AwsCloudMapInstanceAttributeProperty"');
    }
    function cfnVirtualNodeAwsCloudMapInstanceAttributePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_AwsCloudMapInstanceAttributePropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnVirtualNodeAwsCloudMapInstanceAttributePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_AwsCloudMapServiceDiscoveryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributes", cdk.listValidator(CfnVirtualNode_AwsCloudMapInstanceAttributePropertyValidator))(properties.attributes)), errors.collect(cdk.propertyValidator("ipPreference", cdk.validateString)(properties.ipPreference)), errors.collect(cdk.propertyValidator("namespaceName", cdk.requiredValidator)(properties.namespaceName)), errors.collect(cdk.propertyValidator("namespaceName", cdk.validateString)(properties.namespaceName)), errors.collect(cdk.propertyValidator("serviceName", cdk.requiredValidator)(properties.serviceName)), errors.collect(cdk.propertyValidator("serviceName", cdk.validateString)(properties.serviceName)), errors.wrap('supplied properties not correct for "AwsCloudMapServiceDiscoveryProperty"');
    }
    function cfnVirtualNodeAwsCloudMapServiceDiscoveryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_AwsCloudMapServiceDiscoveryPropertyValidator(properties).assertSuccess(), { Attributes: cdk.listMapper(cfnVirtualNodeAwsCloudMapInstanceAttributePropertyToCloudFormation)(properties.attributes), IpPreference: cdk.stringToCloudFormation(properties.ipPreference), NamespaceName: cdk.stringToCloudFormation(properties.namespaceName), ServiceName: cdk.stringToCloudFormation(properties.serviceName) }) : properties;
    }
    function CfnVirtualNodeAwsCloudMapServiceDiscoveryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attributes", "Attributes", properties.Attributes != null ? cfn_parse.FromCloudFormation.getArray(CfnVirtualNodeAwsCloudMapInstanceAttributePropertyFromCloudFormation)(properties.Attributes) : void 0), ret.addPropertyResult("ipPreference", "IpPreference", properties.IpPreference != null ? cfn_parse.FromCloudFormation.getString(properties.IpPreference) : void 0), ret.addPropertyResult("namespaceName", "NamespaceName", cfn_parse.FromCloudFormation.getString(properties.NamespaceName)), ret.addPropertyResult("serviceName", "ServiceName", cfn_parse.FromCloudFormation.getString(properties.ServiceName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_BackendPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("virtualService", CfnVirtualNode_VirtualServiceBackendPropertyValidator)(properties.virtualService)), errors.wrap('supplied properties not correct for "BackendProperty"');
    }
    function cfnVirtualNodeBackendPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_BackendPropertyValidator(properties).assertSuccess(), { VirtualService: cfnVirtualNodeVirtualServiceBackendPropertyToCloudFormation(properties.virtualService) }) : properties;
    }
    function CfnVirtualNodeBackendPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("virtualService", "VirtualService", properties.VirtualService != null ? CfnVirtualNodeVirtualServiceBackendPropertyFromCloudFormation(properties.VirtualService) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_BackendDefaultsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clientPolicy", CfnVirtualNode_ClientPolicyPropertyValidator)(properties.clientPolicy)), errors.wrap('supplied properties not correct for "BackendDefaultsProperty"');
    }
    function cfnVirtualNodeBackendDefaultsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_BackendDefaultsPropertyValidator(properties).assertSuccess(), { ClientPolicy: cfnVirtualNodeClientPolicyPropertyToCloudFormation(properties.clientPolicy) }) : properties;
    }
    function CfnVirtualNodeBackendDefaultsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clientPolicy", "ClientPolicy", properties.ClientPolicy != null ? CfnVirtualNodeClientPolicyPropertyFromCloudFormation(properties.ClientPolicy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_ClientPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("tls", CfnVirtualNode_ClientPolicyTlsPropertyValidator)(properties.tls)), errors.wrap('supplied properties not correct for "ClientPolicyProperty"');
    }
    function cfnVirtualNodeClientPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_ClientPolicyPropertyValidator(properties).assertSuccess(), { TLS: cfnVirtualNodeClientPolicyTlsPropertyToCloudFormation(properties.tls) }) : properties;
    }
    function CfnVirtualNodeClientPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("tls", "TLS", properties.TLS != null ? CfnVirtualNodeClientPolicyTlsPropertyFromCloudFormation(properties.TLS) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_ClientPolicyTlsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificate", CfnVirtualNode_ClientTlsCertificatePropertyValidator)(properties.certificate)), errors.collect(cdk.propertyValidator("enforce", cdk.validateBoolean)(properties.enforce)), errors.collect(cdk.propertyValidator("ports", cdk.listValidator(cdk.validateNumber))(properties.ports)), errors.collect(cdk.propertyValidator("validation", cdk.requiredValidator)(properties.validation)), errors.collect(cdk.propertyValidator("validation", CfnVirtualNode_TlsValidationContextPropertyValidator)(properties.validation)), errors.wrap('supplied properties not correct for "ClientPolicyTlsProperty"');
    }
    function cfnVirtualNodeClientPolicyTlsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_ClientPolicyTlsPropertyValidator(properties).assertSuccess(), { Certificate: cfnVirtualNodeClientTlsCertificatePropertyToCloudFormation(properties.certificate), Enforce: cdk.booleanToCloudFormation(properties.enforce), Ports: cdk.listMapper(cdk.numberToCloudFormation)(properties.ports), Validation: cfnVirtualNodeTlsValidationContextPropertyToCloudFormation(properties.validation) }) : properties;
    }
    function CfnVirtualNodeClientPolicyTlsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificate", "Certificate", properties.Certificate != null ? CfnVirtualNodeClientTlsCertificatePropertyFromCloudFormation(properties.Certificate) : void 0), ret.addPropertyResult("enforce", "Enforce", properties.Enforce != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enforce) : void 0), ret.addPropertyResult("ports", "Ports", properties.Ports != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getNumber)(properties.Ports) : void 0), ret.addPropertyResult("validation", "Validation", CfnVirtualNodeTlsValidationContextPropertyFromCloudFormation(properties.Validation)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_ClientTlsCertificatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("file", CfnVirtualNode_ListenerTlsFileCertificatePropertyValidator)(properties.file)), errors.collect(cdk.propertyValidator("sds", CfnVirtualNode_ListenerTlsSdsCertificatePropertyValidator)(properties.sds)), errors.wrap('supplied properties not correct for "ClientTlsCertificateProperty"');
    }
    function cfnVirtualNodeClientTlsCertificatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_ClientTlsCertificatePropertyValidator(properties).assertSuccess(), { File: cfnVirtualNodeListenerTlsFileCertificatePropertyToCloudFormation(properties.file), SDS: cfnVirtualNodeListenerTlsSdsCertificatePropertyToCloudFormation(properties.sds) }) : properties;
    }
    function CfnVirtualNodeClientTlsCertificatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("file", "File", properties.File != null ? CfnVirtualNodeListenerTlsFileCertificatePropertyFromCloudFormation(properties.File) : void 0), ret.addPropertyResult("sds", "SDS", properties.SDS != null ? CfnVirtualNodeListenerTlsSdsCertificatePropertyFromCloudFormation(properties.SDS) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_DnsServiceDiscoveryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("hostname", cdk.requiredValidator)(properties.hostname)), errors.collect(cdk.propertyValidator("hostname", cdk.validateString)(properties.hostname)), errors.collect(cdk.propertyValidator("ipPreference", cdk.validateString)(properties.ipPreference)), errors.collect(cdk.propertyValidator("responseType", cdk.validateString)(properties.responseType)), errors.wrap('supplied properties not correct for "DnsServiceDiscoveryProperty"');
    }
    function cfnVirtualNodeDnsServiceDiscoveryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_DnsServiceDiscoveryPropertyValidator(properties).assertSuccess(), { Hostname: cdk.stringToCloudFormation(properties.hostname), IpPreference: cdk.stringToCloudFormation(properties.ipPreference), ResponseType: cdk.stringToCloudFormation(properties.responseType) }) : properties;
    }
    function CfnVirtualNodeDnsServiceDiscoveryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("hostname", "Hostname", cfn_parse.FromCloudFormation.getString(properties.Hostname)), ret.addPropertyResult("ipPreference", "IpPreference", properties.IpPreference != null ? cfn_parse.FromCloudFormation.getString(properties.IpPreference) : void 0), ret.addPropertyResult("responseType", "ResponseType", properties.ResponseType != null ? cfn_parse.FromCloudFormation.getString(properties.ResponseType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_DurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("unit", cdk.requiredValidator)(properties.unit)), errors.collect(cdk.propertyValidator("unit", cdk.validateString)(properties.unit)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "DurationProperty"');
    }
    function cfnVirtualNodeDurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_DurationPropertyValidator(properties).assertSuccess(), { Unit: cdk.stringToCloudFormation(properties.unit), Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnVirtualNodeDurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("unit", "Unit", cfn_parse.FromCloudFormation.getString(properties.Unit)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getNumber(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_FileAccessLogPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("format", CfnVirtualNode_LoggingFormatPropertyValidator)(properties.format)), errors.collect(cdk.propertyValidator("path", cdk.requiredValidator)(properties.path)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.wrap('supplied properties not correct for "FileAccessLogProperty"');
    }
    function cfnVirtualNodeFileAccessLogPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_FileAccessLogPropertyValidator(properties).assertSuccess(), { Format: cfnVirtualNodeLoggingFormatPropertyToCloudFormation(properties.format), Path: cdk.stringToCloudFormation(properties.path) }) : properties;
    }
    function CfnVirtualNodeFileAccessLogPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("format", "Format", properties.Format != null ? CfnVirtualNodeLoggingFormatPropertyFromCloudFormation(properties.Format) : void 0), ret.addPropertyResult("path", "Path", cfn_parse.FromCloudFormation.getString(properties.Path)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_GrpcTimeoutPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("idle", CfnVirtualNode_DurationPropertyValidator)(properties.idle)), errors.collect(cdk.propertyValidator("perRequest", CfnVirtualNode_DurationPropertyValidator)(properties.perRequest)), errors.wrap('supplied properties not correct for "GrpcTimeoutProperty"');
    }
    function cfnVirtualNodeGrpcTimeoutPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_GrpcTimeoutPropertyValidator(properties).assertSuccess(), { Idle: cfnVirtualNodeDurationPropertyToCloudFormation(properties.idle), PerRequest: cfnVirtualNodeDurationPropertyToCloudFormation(properties.perRequest) }) : properties;
    }
    function CfnVirtualNodeGrpcTimeoutPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("idle", "Idle", properties.Idle != null ? CfnVirtualNodeDurationPropertyFromCloudFormation(properties.Idle) : void 0), ret.addPropertyResult("perRequest", "PerRequest", properties.PerRequest != null ? CfnVirtualNodeDurationPropertyFromCloudFormation(properties.PerRequest) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_HealthCheckPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("healthyThreshold", cdk.requiredValidator)(properties.healthyThreshold)), errors.collect(cdk.propertyValidator("healthyThreshold", cdk.validateNumber)(properties.healthyThreshold)), errors.collect(cdk.propertyValidator("intervalMillis", cdk.requiredValidator)(properties.intervalMillis)), errors.collect(cdk.propertyValidator("intervalMillis", cdk.validateNumber)(properties.intervalMillis)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("protocol", cdk.requiredValidator)(properties.protocol)), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.collect(cdk.propertyValidator("timeoutMillis", cdk.requiredValidator)(properties.timeoutMillis)), errors.collect(cdk.propertyValidator("timeoutMillis", cdk.validateNumber)(properties.timeoutMillis)), errors.collect(cdk.propertyValidator("unhealthyThreshold", cdk.requiredValidator)(properties.unhealthyThreshold)), errors.collect(cdk.propertyValidator("unhealthyThreshold", cdk.validateNumber)(properties.unhealthyThreshold)), errors.wrap('supplied properties not correct for "HealthCheckProperty"');
    }
    function cfnVirtualNodeHealthCheckPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_HealthCheckPropertyValidator(properties).assertSuccess(), { HealthyThreshold: cdk.numberToCloudFormation(properties.healthyThreshold), IntervalMillis: cdk.numberToCloudFormation(properties.intervalMillis), Path: cdk.stringToCloudFormation(properties.path), Port: cdk.numberToCloudFormation(properties.port), Protocol: cdk.stringToCloudFormation(properties.protocol), TimeoutMillis: cdk.numberToCloudFormation(properties.timeoutMillis), UnhealthyThreshold: cdk.numberToCloudFormation(properties.unhealthyThreshold) }) : properties;
    }
    function CfnVirtualNodeHealthCheckPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("healthyThreshold", "HealthyThreshold", cfn_parse.FromCloudFormation.getNumber(properties.HealthyThreshold)), ret.addPropertyResult("intervalMillis", "IntervalMillis", cfn_parse.FromCloudFormation.getNumber(properties.IntervalMillis)), ret.addPropertyResult("path", "Path", properties.Path != null ? cfn_parse.FromCloudFormation.getString(properties.Path) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addPropertyResult("protocol", "Protocol", cfn_parse.FromCloudFormation.getString(properties.Protocol)), ret.addPropertyResult("timeoutMillis", "TimeoutMillis", cfn_parse.FromCloudFormation.getNumber(properties.TimeoutMillis)), ret.addPropertyResult("unhealthyThreshold", "UnhealthyThreshold", cfn_parse.FromCloudFormation.getNumber(properties.UnhealthyThreshold)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_HttpTimeoutPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("idle", CfnVirtualNode_DurationPropertyValidator)(properties.idle)), errors.collect(cdk.propertyValidator("perRequest", CfnVirtualNode_DurationPropertyValidator)(properties.perRequest)), errors.wrap('supplied properties not correct for "HttpTimeoutProperty"');
    }
    function cfnVirtualNodeHttpTimeoutPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_HttpTimeoutPropertyValidator(properties).assertSuccess(), { Idle: cfnVirtualNodeDurationPropertyToCloudFormation(properties.idle), PerRequest: cfnVirtualNodeDurationPropertyToCloudFormation(properties.perRequest) }) : properties;
    }
    function CfnVirtualNodeHttpTimeoutPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("idle", "Idle", properties.Idle != null ? CfnVirtualNodeDurationPropertyFromCloudFormation(properties.Idle) : void 0), ret.addPropertyResult("perRequest", "PerRequest", properties.PerRequest != null ? CfnVirtualNodeDurationPropertyFromCloudFormation(properties.PerRequest) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_JsonFormatRefPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "JsonFormatRefProperty"');
    }
    function cfnVirtualNodeJsonFormatRefPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_JsonFormatRefPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnVirtualNodeJsonFormatRefPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_ListenerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectionPool", CfnVirtualNode_VirtualNodeConnectionPoolPropertyValidator)(properties.connectionPool)), errors.collect(cdk.propertyValidator("healthCheck", CfnVirtualNode_HealthCheckPropertyValidator)(properties.healthCheck)), errors.collect(cdk.propertyValidator("outlierDetection", CfnVirtualNode_OutlierDetectionPropertyValidator)(properties.outlierDetection)), errors.collect(cdk.propertyValidator("portMapping", cdk.requiredValidator)(properties.portMapping)), errors.collect(cdk.propertyValidator("portMapping", CfnVirtualNode_PortMappingPropertyValidator)(properties.portMapping)), errors.collect(cdk.propertyValidator("tls", CfnVirtualNode_ListenerTlsPropertyValidator)(properties.tls)), errors.collect(cdk.propertyValidator("timeout", CfnVirtualNode_ListenerTimeoutPropertyValidator)(properties.timeout)), errors.wrap('supplied properties not correct for "ListenerProperty"');
    }
    function cfnVirtualNodeListenerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_ListenerPropertyValidator(properties).assertSuccess(), { ConnectionPool: cfnVirtualNodeVirtualNodeConnectionPoolPropertyToCloudFormation(properties.connectionPool), HealthCheck: cfnVirtualNodeHealthCheckPropertyToCloudFormation(properties.healthCheck), OutlierDetection: cfnVirtualNodeOutlierDetectionPropertyToCloudFormation(properties.outlierDetection), PortMapping: cfnVirtualNodePortMappingPropertyToCloudFormation(properties.portMapping), TLS: cfnVirtualNodeListenerTlsPropertyToCloudFormation(properties.tls), Timeout: cfnVirtualNodeListenerTimeoutPropertyToCloudFormation(properties.timeout) }) : properties;
    }
    function CfnVirtualNodeListenerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectionPool", "ConnectionPool", properties.ConnectionPool != null ? CfnVirtualNodeVirtualNodeConnectionPoolPropertyFromCloudFormation(properties.ConnectionPool) : void 0), ret.addPropertyResult("healthCheck", "HealthCheck", properties.HealthCheck != null ? CfnVirtualNodeHealthCheckPropertyFromCloudFormation(properties.HealthCheck) : void 0), ret.addPropertyResult("outlierDetection", "OutlierDetection", properties.OutlierDetection != null ? CfnVirtualNodeOutlierDetectionPropertyFromCloudFormation(properties.OutlierDetection) : void 0), ret.addPropertyResult("portMapping", "PortMapping", CfnVirtualNodePortMappingPropertyFromCloudFormation(properties.PortMapping)), ret.addPropertyResult("tls", "TLS", properties.TLS != null ? CfnVirtualNodeListenerTlsPropertyFromCloudFormation(properties.TLS) : void 0), ret.addPropertyResult("timeout", "Timeout", properties.Timeout != null ? CfnVirtualNodeListenerTimeoutPropertyFromCloudFormation(properties.Timeout) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_ListenerTimeoutPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("grpc", CfnVirtualNode_GrpcTimeoutPropertyValidator)(properties.grpc)), errors.collect(cdk.propertyValidator("http", CfnVirtualNode_HttpTimeoutPropertyValidator)(properties.http)), errors.collect(cdk.propertyValidator("http2", CfnVirtualNode_HttpTimeoutPropertyValidator)(properties.http2)), errors.collect(cdk.propertyValidator("tcp", CfnVirtualNode_TcpTimeoutPropertyValidator)(properties.tcp)), errors.wrap('supplied properties not correct for "ListenerTimeoutProperty"');
    }
    function cfnVirtualNodeListenerTimeoutPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_ListenerTimeoutPropertyValidator(properties).assertSuccess(), { GRPC: cfnVirtualNodeGrpcTimeoutPropertyToCloudFormation(properties.grpc), HTTP: cfnVirtualNodeHttpTimeoutPropertyToCloudFormation(properties.http), HTTP2: cfnVirtualNodeHttpTimeoutPropertyToCloudFormation(properties.http2), TCP: cfnVirtualNodeTcpTimeoutPropertyToCloudFormation(properties.tcp) }) : properties;
    }
    function CfnVirtualNodeListenerTimeoutPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("grpc", "GRPC", properties.GRPC != null ? CfnVirtualNodeGrpcTimeoutPropertyFromCloudFormation(properties.GRPC) : void 0), ret.addPropertyResult("http", "HTTP", properties.HTTP != null ? CfnVirtualNodeHttpTimeoutPropertyFromCloudFormation(properties.HTTP) : void 0), ret.addPropertyResult("http2", "HTTP2", properties.HTTP2 != null ? CfnVirtualNodeHttpTimeoutPropertyFromCloudFormation(properties.HTTP2) : void 0), ret.addPropertyResult("tcp", "TCP", properties.TCP != null ? CfnVirtualNodeTcpTimeoutPropertyFromCloudFormation(properties.TCP) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_ListenerTlsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificate", cdk.requiredValidator)(properties.certificate)), errors.collect(cdk.propertyValidator("certificate", CfnVirtualNode_ListenerTlsCertificatePropertyValidator)(properties.certificate)), errors.collect(cdk.propertyValidator("mode", cdk.requiredValidator)(properties.mode)), errors.collect(cdk.propertyValidator("mode", cdk.validateString)(properties.mode)), errors.collect(cdk.propertyValidator("validation", CfnVirtualNode_ListenerTlsValidationContextPropertyValidator)(properties.validation)), errors.wrap('supplied properties not correct for "ListenerTlsProperty"');
    }
    function cfnVirtualNodeListenerTlsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_ListenerTlsPropertyValidator(properties).assertSuccess(), { Certificate: cfnVirtualNodeListenerTlsCertificatePropertyToCloudFormation(properties.certificate), Mode: cdk.stringToCloudFormation(properties.mode), Validation: cfnVirtualNodeListenerTlsValidationContextPropertyToCloudFormation(properties.validation) }) : properties;
    }
    function CfnVirtualNodeListenerTlsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificate", "Certificate", CfnVirtualNodeListenerTlsCertificatePropertyFromCloudFormation(properties.Certificate)), ret.addPropertyResult("mode", "Mode", cfn_parse.FromCloudFormation.getString(properties.Mode)), ret.addPropertyResult("validation", "Validation", properties.Validation != null ? CfnVirtualNodeListenerTlsValidationContextPropertyFromCloudFormation(properties.Validation) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_ListenerTlsAcmCertificatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateArn", cdk.requiredValidator)(properties.certificateArn)), errors.collect(cdk.propertyValidator("certificateArn", cdk.validateString)(properties.certificateArn)), errors.wrap('supplied properties not correct for "ListenerTlsAcmCertificateProperty"');
    }
    function cfnVirtualNodeListenerTlsAcmCertificatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_ListenerTlsAcmCertificatePropertyValidator(properties).assertSuccess(), { CertificateArn: cdk.stringToCloudFormation(properties.certificateArn) }) : properties;
    }
    function CfnVirtualNodeListenerTlsAcmCertificatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificateArn", "CertificateArn", cfn_parse.FromCloudFormation.getString(properties.CertificateArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_ListenerTlsCertificatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acm", CfnVirtualNode_ListenerTlsAcmCertificatePropertyValidator)(properties.acm)), errors.collect(cdk.propertyValidator("file", CfnVirtualNode_ListenerTlsFileCertificatePropertyValidator)(properties.file)), errors.collect(cdk.propertyValidator("sds", CfnVirtualNode_ListenerTlsSdsCertificatePropertyValidator)(properties.sds)), errors.wrap('supplied properties not correct for "ListenerTlsCertificateProperty"');
    }
    function cfnVirtualNodeListenerTlsCertificatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_ListenerTlsCertificatePropertyValidator(properties).assertSuccess(), { ACM: cfnVirtualNodeListenerTlsAcmCertificatePropertyToCloudFormation(properties.acm), File: cfnVirtualNodeListenerTlsFileCertificatePropertyToCloudFormation(properties.file), SDS: cfnVirtualNodeListenerTlsSdsCertificatePropertyToCloudFormation(properties.sds) }) : properties;
    }
    function CfnVirtualNodeListenerTlsCertificatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("acm", "ACM", properties.ACM != null ? CfnVirtualNodeListenerTlsAcmCertificatePropertyFromCloudFormation(properties.ACM) : void 0), ret.addPropertyResult("file", "File", properties.File != null ? CfnVirtualNodeListenerTlsFileCertificatePropertyFromCloudFormation(properties.File) : void 0), ret.addPropertyResult("sds", "SDS", properties.SDS != null ? CfnVirtualNodeListenerTlsSdsCertificatePropertyFromCloudFormation(properties.SDS) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_ListenerTlsFileCertificatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateChain", cdk.requiredValidator)(properties.certificateChain)), errors.collect(cdk.propertyValidator("certificateChain", cdk.validateString)(properties.certificateChain)), errors.collect(cdk.propertyValidator("privateKey", cdk.requiredValidator)(properties.privateKey)), errors.collect(cdk.propertyValidator("privateKey", cdk.validateString)(properties.privateKey)), errors.wrap('supplied properties not correct for "ListenerTlsFileCertificateProperty"');
    }
    function cfnVirtualNodeListenerTlsFileCertificatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_ListenerTlsFileCertificatePropertyValidator(properties).assertSuccess(), { CertificateChain: cdk.stringToCloudFormation(properties.certificateChain), PrivateKey: cdk.stringToCloudFormation(properties.privateKey) }) : properties;
    }
    function CfnVirtualNodeListenerTlsFileCertificatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificateChain", "CertificateChain", cfn_parse.FromCloudFormation.getString(properties.CertificateChain)), ret.addPropertyResult("privateKey", "PrivateKey", cfn_parse.FromCloudFormation.getString(properties.PrivateKey)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_ListenerTlsSdsCertificatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("secretName", cdk.requiredValidator)(properties.secretName)), errors.collect(cdk.propertyValidator("secretName", cdk.validateString)(properties.secretName)), errors.wrap('supplied properties not correct for "ListenerTlsSdsCertificateProperty"');
    }
    function cfnVirtualNodeListenerTlsSdsCertificatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_ListenerTlsSdsCertificatePropertyValidator(properties).assertSuccess(), { SecretName: cdk.stringToCloudFormation(properties.secretName) }) : properties;
    }
    function CfnVirtualNodeListenerTlsSdsCertificatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("secretName", "SecretName", cfn_parse.FromCloudFormation.getString(properties.SecretName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_ListenerTlsValidationContextPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("subjectAlternativeNames", CfnVirtualNode_SubjectAlternativeNamesPropertyValidator)(properties.subjectAlternativeNames)), errors.collect(cdk.propertyValidator("trust", cdk.requiredValidator)(properties.trust)), errors.collect(cdk.propertyValidator("trust", CfnVirtualNode_ListenerTlsValidationContextTrustPropertyValidator)(properties.trust)), errors.wrap('supplied properties not correct for "ListenerTlsValidationContextProperty"');
    }
    function cfnVirtualNodeListenerTlsValidationContextPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_ListenerTlsValidationContextPropertyValidator(properties).assertSuccess(), { SubjectAlternativeNames: cfnVirtualNodeSubjectAlternativeNamesPropertyToCloudFormation(properties.subjectAlternativeNames), Trust: cfnVirtualNodeListenerTlsValidationContextTrustPropertyToCloudFormation(properties.trust) }) : properties;
    }
    function CfnVirtualNodeListenerTlsValidationContextPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("subjectAlternativeNames", "SubjectAlternativeNames", properties.SubjectAlternativeNames != null ? CfnVirtualNodeSubjectAlternativeNamesPropertyFromCloudFormation(properties.SubjectAlternativeNames) : void 0), ret.addPropertyResult("trust", "Trust", CfnVirtualNodeListenerTlsValidationContextTrustPropertyFromCloudFormation(properties.Trust)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_ListenerTlsValidationContextTrustPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("file", CfnVirtualNode_TlsValidationContextFileTrustPropertyValidator)(properties.file)), errors.collect(cdk.propertyValidator("sds", CfnVirtualNode_TlsValidationContextSdsTrustPropertyValidator)(properties.sds)), errors.wrap('supplied properties not correct for "ListenerTlsValidationContextTrustProperty"');
    }
    function cfnVirtualNodeListenerTlsValidationContextTrustPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_ListenerTlsValidationContextTrustPropertyValidator(properties).assertSuccess(), { File: cfnVirtualNodeTlsValidationContextFileTrustPropertyToCloudFormation(properties.file), SDS: cfnVirtualNodeTlsValidationContextSdsTrustPropertyToCloudFormation(properties.sds) }) : properties;
    }
    function CfnVirtualNodeListenerTlsValidationContextTrustPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("file", "File", properties.File != null ? CfnVirtualNodeTlsValidationContextFileTrustPropertyFromCloudFormation(properties.File) : void 0), ret.addPropertyResult("sds", "SDS", properties.SDS != null ? CfnVirtualNodeTlsValidationContextSdsTrustPropertyFromCloudFormation(properties.SDS) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_LoggingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessLog", CfnVirtualNode_AccessLogPropertyValidator)(properties.accessLog)), errors.wrap('supplied properties not correct for "LoggingProperty"');
    }
    function cfnVirtualNodeLoggingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_LoggingPropertyValidator(properties).assertSuccess(), { AccessLog: cfnVirtualNodeAccessLogPropertyToCloudFormation(properties.accessLog) }) : properties;
    }
    function CfnVirtualNodeLoggingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessLog", "AccessLog", properties.AccessLog != null ? CfnVirtualNodeAccessLogPropertyFromCloudFormation(properties.AccessLog) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_LoggingFormatPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("json", cdk.listValidator(CfnVirtualNode_JsonFormatRefPropertyValidator))(properties.json)), errors.collect(cdk.propertyValidator("text", cdk.validateString)(properties.text)), errors.wrap('supplied properties not correct for "LoggingFormatProperty"');
    }
    function cfnVirtualNodeLoggingFormatPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_LoggingFormatPropertyValidator(properties).assertSuccess(), { Json: cdk.listMapper(cfnVirtualNodeJsonFormatRefPropertyToCloudFormation)(properties.json), Text: cdk.stringToCloudFormation(properties.text) }) : properties;
    }
    function CfnVirtualNodeLoggingFormatPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("json", "Json", properties.Json != null ? cfn_parse.FromCloudFormation.getArray(CfnVirtualNodeJsonFormatRefPropertyFromCloudFormation)(properties.Json) : void 0), ret.addPropertyResult("text", "Text", properties.Text != null ? cfn_parse.FromCloudFormation.getString(properties.Text) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_OutlierDetectionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("baseEjectionDuration", cdk.requiredValidator)(properties.baseEjectionDuration)), errors.collect(cdk.propertyValidator("baseEjectionDuration", CfnVirtualNode_DurationPropertyValidator)(properties.baseEjectionDuration)), errors.collect(cdk.propertyValidator("interval", cdk.requiredValidator)(properties.interval)), errors.collect(cdk.propertyValidator("interval", CfnVirtualNode_DurationPropertyValidator)(properties.interval)), errors.collect(cdk.propertyValidator("maxEjectionPercent", cdk.requiredValidator)(properties.maxEjectionPercent)), errors.collect(cdk.propertyValidator("maxEjectionPercent", cdk.validateNumber)(properties.maxEjectionPercent)), errors.collect(cdk.propertyValidator("maxServerErrors", cdk.requiredValidator)(properties.maxServerErrors)), errors.collect(cdk.propertyValidator("maxServerErrors", cdk.validateNumber)(properties.maxServerErrors)), errors.wrap('supplied properties not correct for "OutlierDetectionProperty"');
    }
    function cfnVirtualNodeOutlierDetectionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_OutlierDetectionPropertyValidator(properties).assertSuccess(), { BaseEjectionDuration: cfnVirtualNodeDurationPropertyToCloudFormation(properties.baseEjectionDuration), Interval: cfnVirtualNodeDurationPropertyToCloudFormation(properties.interval), MaxEjectionPercent: cdk.numberToCloudFormation(properties.maxEjectionPercent), MaxServerErrors: cdk.numberToCloudFormation(properties.maxServerErrors) }) : properties;
    }
    function CfnVirtualNodeOutlierDetectionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("baseEjectionDuration", "BaseEjectionDuration", CfnVirtualNodeDurationPropertyFromCloudFormation(properties.BaseEjectionDuration)), ret.addPropertyResult("interval", "Interval", CfnVirtualNodeDurationPropertyFromCloudFormation(properties.Interval)), ret.addPropertyResult("maxEjectionPercent", "MaxEjectionPercent", cfn_parse.FromCloudFormation.getNumber(properties.MaxEjectionPercent)), ret.addPropertyResult("maxServerErrors", "MaxServerErrors", cfn_parse.FromCloudFormation.getNumber(properties.MaxServerErrors)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_PortMappingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("port", cdk.requiredValidator)(properties.port)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("protocol", cdk.requiredValidator)(properties.protocol)), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.wrap('supplied properties not correct for "PortMappingProperty"');
    }
    function cfnVirtualNodePortMappingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_PortMappingPropertyValidator(properties).assertSuccess(), { Port: cdk.numberToCloudFormation(properties.port), Protocol: cdk.stringToCloudFormation(properties.protocol) }) : properties;
    }
    function CfnVirtualNodePortMappingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("port", "Port", cfn_parse.FromCloudFormation.getNumber(properties.Port)), ret.addPropertyResult("protocol", "Protocol", cfn_parse.FromCloudFormation.getString(properties.Protocol)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_ServiceDiscoveryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("awsCloudMap", CfnVirtualNode_AwsCloudMapServiceDiscoveryPropertyValidator)(properties.awsCloudMap)), errors.collect(cdk.propertyValidator("dns", CfnVirtualNode_DnsServiceDiscoveryPropertyValidator)(properties.dns)), errors.wrap('supplied properties not correct for "ServiceDiscoveryProperty"');
    }
    function cfnVirtualNodeServiceDiscoveryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_ServiceDiscoveryPropertyValidator(properties).assertSuccess(), { AWSCloudMap: cfnVirtualNodeAwsCloudMapServiceDiscoveryPropertyToCloudFormation(properties.awsCloudMap), DNS: cfnVirtualNodeDnsServiceDiscoveryPropertyToCloudFormation(properties.dns) }) : properties;
    }
    function CfnVirtualNodeServiceDiscoveryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("awsCloudMap", "AWSCloudMap", properties.AWSCloudMap != null ? CfnVirtualNodeAwsCloudMapServiceDiscoveryPropertyFromCloudFormation(properties.AWSCloudMap) : void 0), ret.addPropertyResult("dns", "DNS", properties.DNS != null ? CfnVirtualNodeDnsServiceDiscoveryPropertyFromCloudFormation(properties.DNS) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_SubjectAlternativeNameMatchersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("exact", cdk.listValidator(cdk.validateString))(properties.exact)), errors.wrap('supplied properties not correct for "SubjectAlternativeNameMatchersProperty"');
    }
    function cfnVirtualNodeSubjectAlternativeNameMatchersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_SubjectAlternativeNameMatchersPropertyValidator(properties).assertSuccess(), { Exact: cdk.listMapper(cdk.stringToCloudFormation)(properties.exact) }) : properties;
    }
    function CfnVirtualNodeSubjectAlternativeNameMatchersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("exact", "Exact", properties.Exact != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Exact) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_SubjectAlternativeNamesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("match", cdk.requiredValidator)(properties.match)), errors.collect(cdk.propertyValidator("match", CfnVirtualNode_SubjectAlternativeNameMatchersPropertyValidator)(properties.match)), errors.wrap('supplied properties not correct for "SubjectAlternativeNamesProperty"');
    }
    function cfnVirtualNodeSubjectAlternativeNamesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_SubjectAlternativeNamesPropertyValidator(properties).assertSuccess(), { Match: cfnVirtualNodeSubjectAlternativeNameMatchersPropertyToCloudFormation(properties.match) }) : properties;
    }
    function CfnVirtualNodeSubjectAlternativeNamesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("match", "Match", CfnVirtualNodeSubjectAlternativeNameMatchersPropertyFromCloudFormation(properties.Match)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_TcpTimeoutPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("idle", CfnVirtualNode_DurationPropertyValidator)(properties.idle)), errors.wrap('supplied properties not correct for "TcpTimeoutProperty"');
    }
    function cfnVirtualNodeTcpTimeoutPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_TcpTimeoutPropertyValidator(properties).assertSuccess(), { Idle: cfnVirtualNodeDurationPropertyToCloudFormation(properties.idle) }) : properties;
    }
    function CfnVirtualNodeTcpTimeoutPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("idle", "Idle", properties.Idle != null ? CfnVirtualNodeDurationPropertyFromCloudFormation(properties.Idle) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_TlsValidationContextPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("subjectAlternativeNames", CfnVirtualNode_SubjectAlternativeNamesPropertyValidator)(properties.subjectAlternativeNames)), errors.collect(cdk.propertyValidator("trust", cdk.requiredValidator)(properties.trust)), errors.collect(cdk.propertyValidator("trust", CfnVirtualNode_TlsValidationContextTrustPropertyValidator)(properties.trust)), errors.wrap('supplied properties not correct for "TlsValidationContextProperty"');
    }
    function cfnVirtualNodeTlsValidationContextPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_TlsValidationContextPropertyValidator(properties).assertSuccess(), { SubjectAlternativeNames: cfnVirtualNodeSubjectAlternativeNamesPropertyToCloudFormation(properties.subjectAlternativeNames), Trust: cfnVirtualNodeTlsValidationContextTrustPropertyToCloudFormation(properties.trust) }) : properties;
    }
    function CfnVirtualNodeTlsValidationContextPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("subjectAlternativeNames", "SubjectAlternativeNames", properties.SubjectAlternativeNames != null ? CfnVirtualNodeSubjectAlternativeNamesPropertyFromCloudFormation(properties.SubjectAlternativeNames) : void 0), ret.addPropertyResult("trust", "Trust", CfnVirtualNodeTlsValidationContextTrustPropertyFromCloudFormation(properties.Trust)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_TlsValidationContextAcmTrustPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateAuthorityArns", cdk.requiredValidator)(properties.certificateAuthorityArns)), errors.collect(cdk.propertyValidator("certificateAuthorityArns", cdk.listValidator(cdk.validateString))(properties.certificateAuthorityArns)), errors.wrap('supplied properties not correct for "TlsValidationContextAcmTrustProperty"');
    }
    function cfnVirtualNodeTlsValidationContextAcmTrustPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_TlsValidationContextAcmTrustPropertyValidator(properties).assertSuccess(), { CertificateAuthorityArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.certificateAuthorityArns) }) : properties;
    }
    function CfnVirtualNodeTlsValidationContextAcmTrustPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificateAuthorityArns", "CertificateAuthorityArns", cfn_parse.FromCloudFormation.getStringArray(properties.CertificateAuthorityArns)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_TlsValidationContextFileTrustPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateChain", cdk.requiredValidator)(properties.certificateChain)), errors.collect(cdk.propertyValidator("certificateChain", cdk.validateString)(properties.certificateChain)), errors.wrap('supplied properties not correct for "TlsValidationContextFileTrustProperty"');
    }
    function cfnVirtualNodeTlsValidationContextFileTrustPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_TlsValidationContextFileTrustPropertyValidator(properties).assertSuccess(), { CertificateChain: cdk.stringToCloudFormation(properties.certificateChain) }) : properties;
    }
    function CfnVirtualNodeTlsValidationContextFileTrustPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificateChain", "CertificateChain", cfn_parse.FromCloudFormation.getString(properties.CertificateChain)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_TlsValidationContextSdsTrustPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("secretName", cdk.requiredValidator)(properties.secretName)), errors.collect(cdk.propertyValidator("secretName", cdk.validateString)(properties.secretName)), errors.wrap('supplied properties not correct for "TlsValidationContextSdsTrustProperty"');
    }
    function cfnVirtualNodeTlsValidationContextSdsTrustPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_TlsValidationContextSdsTrustPropertyValidator(properties).assertSuccess(), { SecretName: cdk.stringToCloudFormation(properties.secretName) }) : properties;
    }
    function CfnVirtualNodeTlsValidationContextSdsTrustPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("secretName", "SecretName", cfn_parse.FromCloudFormation.getString(properties.SecretName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_TlsValidationContextTrustPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acm", CfnVirtualNode_TlsValidationContextAcmTrustPropertyValidator)(properties.acm)), errors.collect(cdk.propertyValidator("file", CfnVirtualNode_TlsValidationContextFileTrustPropertyValidator)(properties.file)), errors.collect(cdk.propertyValidator("sds", CfnVirtualNode_TlsValidationContextSdsTrustPropertyValidator)(properties.sds)), errors.wrap('supplied properties not correct for "TlsValidationContextTrustProperty"');
    }
    function cfnVirtualNodeTlsValidationContextTrustPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_TlsValidationContextTrustPropertyValidator(properties).assertSuccess(), { ACM: cfnVirtualNodeTlsValidationContextAcmTrustPropertyToCloudFormation(properties.acm), File: cfnVirtualNodeTlsValidationContextFileTrustPropertyToCloudFormation(properties.file), SDS: cfnVirtualNodeTlsValidationContextSdsTrustPropertyToCloudFormation(properties.sds) }) : properties;
    }
    function CfnVirtualNodeTlsValidationContextTrustPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("acm", "ACM", properties.ACM != null ? CfnVirtualNodeTlsValidationContextAcmTrustPropertyFromCloudFormation(properties.ACM) : void 0), ret.addPropertyResult("file", "File", properties.File != null ? CfnVirtualNodeTlsValidationContextFileTrustPropertyFromCloudFormation(properties.File) : void 0), ret.addPropertyResult("sds", "SDS", properties.SDS != null ? CfnVirtualNodeTlsValidationContextSdsTrustPropertyFromCloudFormation(properties.SDS) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_VirtualNodeConnectionPoolPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("grpc", CfnVirtualNode_VirtualNodeGrpcConnectionPoolPropertyValidator)(properties.grpc)), errors.collect(cdk.propertyValidator("http", CfnVirtualNode_VirtualNodeHttpConnectionPoolPropertyValidator)(properties.http)), errors.collect(cdk.propertyValidator("http2", CfnVirtualNode_VirtualNodeHttp2ConnectionPoolPropertyValidator)(properties.http2)), errors.collect(cdk.propertyValidator("tcp", CfnVirtualNode_VirtualNodeTcpConnectionPoolPropertyValidator)(properties.tcp)), errors.wrap('supplied properties not correct for "VirtualNodeConnectionPoolProperty"');
    }
    function cfnVirtualNodeVirtualNodeConnectionPoolPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_VirtualNodeConnectionPoolPropertyValidator(properties).assertSuccess(), { GRPC: cfnVirtualNodeVirtualNodeGrpcConnectionPoolPropertyToCloudFormation(properties.grpc), HTTP: cfnVirtualNodeVirtualNodeHttpConnectionPoolPropertyToCloudFormation(properties.http), HTTP2: cfnVirtualNodeVirtualNodeHttp2ConnectionPoolPropertyToCloudFormation(properties.http2), TCP: cfnVirtualNodeVirtualNodeTcpConnectionPoolPropertyToCloudFormation(properties.tcp) }) : properties;
    }
    function CfnVirtualNodeVirtualNodeConnectionPoolPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("grpc", "GRPC", properties.GRPC != null ? CfnVirtualNodeVirtualNodeGrpcConnectionPoolPropertyFromCloudFormation(properties.GRPC) : void 0), ret.addPropertyResult("http", "HTTP", properties.HTTP != null ? CfnVirtualNodeVirtualNodeHttpConnectionPoolPropertyFromCloudFormation(properties.HTTP) : void 0), ret.addPropertyResult("http2", "HTTP2", properties.HTTP2 != null ? CfnVirtualNodeVirtualNodeHttp2ConnectionPoolPropertyFromCloudFormation(properties.HTTP2) : void 0), ret.addPropertyResult("tcp", "TCP", properties.TCP != null ? CfnVirtualNodeVirtualNodeTcpConnectionPoolPropertyFromCloudFormation(properties.TCP) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_VirtualNodeGrpcConnectionPoolPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxRequests", cdk.requiredValidator)(properties.maxRequests)), errors.collect(cdk.propertyValidator("maxRequests", cdk.validateNumber)(properties.maxRequests)), errors.wrap('supplied properties not correct for "VirtualNodeGrpcConnectionPoolProperty"');
    }
    function cfnVirtualNodeVirtualNodeGrpcConnectionPoolPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_VirtualNodeGrpcConnectionPoolPropertyValidator(properties).assertSuccess(), { MaxRequests: cdk.numberToCloudFormation(properties.maxRequests) }) : properties;
    }
    function CfnVirtualNodeVirtualNodeGrpcConnectionPoolPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxRequests", "MaxRequests", cfn_parse.FromCloudFormation.getNumber(properties.MaxRequests)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_VirtualNodeHttp2ConnectionPoolPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxRequests", cdk.requiredValidator)(properties.maxRequests)), errors.collect(cdk.propertyValidator("maxRequests", cdk.validateNumber)(properties.maxRequests)), errors.wrap('supplied properties not correct for "VirtualNodeHttp2ConnectionPoolProperty"');
    }
    function cfnVirtualNodeVirtualNodeHttp2ConnectionPoolPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_VirtualNodeHttp2ConnectionPoolPropertyValidator(properties).assertSuccess(), { MaxRequests: cdk.numberToCloudFormation(properties.maxRequests) }) : properties;
    }
    function CfnVirtualNodeVirtualNodeHttp2ConnectionPoolPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxRequests", "MaxRequests", cfn_parse.FromCloudFormation.getNumber(properties.MaxRequests)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_VirtualNodeHttpConnectionPoolPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxConnections", cdk.requiredValidator)(properties.maxConnections)), errors.collect(cdk.propertyValidator("maxConnections", cdk.validateNumber)(properties.maxConnections)), errors.collect(cdk.propertyValidator("maxPendingRequests", cdk.validateNumber)(properties.maxPendingRequests)), errors.wrap('supplied properties not correct for "VirtualNodeHttpConnectionPoolProperty"');
    }
    function cfnVirtualNodeVirtualNodeHttpConnectionPoolPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_VirtualNodeHttpConnectionPoolPropertyValidator(properties).assertSuccess(), { MaxConnections: cdk.numberToCloudFormation(properties.maxConnections), MaxPendingRequests: cdk.numberToCloudFormation(properties.maxPendingRequests) }) : properties;
    }
    function CfnVirtualNodeVirtualNodeHttpConnectionPoolPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxConnections", "MaxConnections", cfn_parse.FromCloudFormation.getNumber(properties.MaxConnections)), ret.addPropertyResult("maxPendingRequests", "MaxPendingRequests", properties.MaxPendingRequests != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxPendingRequests) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_VirtualNodeSpecPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("backendDefaults", CfnVirtualNode_BackendDefaultsPropertyValidator)(properties.backendDefaults)), errors.collect(cdk.propertyValidator("backends", cdk.listValidator(CfnVirtualNode_BackendPropertyValidator))(properties.backends)), errors.collect(cdk.propertyValidator("listeners", cdk.listValidator(CfnVirtualNode_ListenerPropertyValidator))(properties.listeners)), errors.collect(cdk.propertyValidator("logging", CfnVirtualNode_LoggingPropertyValidator)(properties.logging)), errors.collect(cdk.propertyValidator("serviceDiscovery", CfnVirtualNode_ServiceDiscoveryPropertyValidator)(properties.serviceDiscovery)), errors.wrap('supplied properties not correct for "VirtualNodeSpecProperty"');
    }
    function cfnVirtualNodeVirtualNodeSpecPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_VirtualNodeSpecPropertyValidator(properties).assertSuccess(), { BackendDefaults: cfnVirtualNodeBackendDefaultsPropertyToCloudFormation(properties.backendDefaults), Backends: cdk.listMapper(cfnVirtualNodeBackendPropertyToCloudFormation)(properties.backends), Listeners: cdk.listMapper(cfnVirtualNodeListenerPropertyToCloudFormation)(properties.listeners), Logging: cfnVirtualNodeLoggingPropertyToCloudFormation(properties.logging), ServiceDiscovery: cfnVirtualNodeServiceDiscoveryPropertyToCloudFormation(properties.serviceDiscovery) }) : properties;
    }
    function CfnVirtualNodeVirtualNodeSpecPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("backendDefaults", "BackendDefaults", properties.BackendDefaults != null ? CfnVirtualNodeBackendDefaultsPropertyFromCloudFormation(properties.BackendDefaults) : void 0), ret.addPropertyResult("backends", "Backends", properties.Backends != null ? cfn_parse.FromCloudFormation.getArray(CfnVirtualNodeBackendPropertyFromCloudFormation)(properties.Backends) : void 0), ret.addPropertyResult("listeners", "Listeners", properties.Listeners != null ? cfn_parse.FromCloudFormation.getArray(CfnVirtualNodeListenerPropertyFromCloudFormation)(properties.Listeners) : void 0), ret.addPropertyResult("logging", "Logging", properties.Logging != null ? CfnVirtualNodeLoggingPropertyFromCloudFormation(properties.Logging) : void 0), ret.addPropertyResult("serviceDiscovery", "ServiceDiscovery", properties.ServiceDiscovery != null ? CfnVirtualNodeServiceDiscoveryPropertyFromCloudFormation(properties.ServiceDiscovery) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_VirtualNodeTcpConnectionPoolPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxConnections", cdk.requiredValidator)(properties.maxConnections)), errors.collect(cdk.propertyValidator("maxConnections", cdk.validateNumber)(properties.maxConnections)), errors.wrap('supplied properties not correct for "VirtualNodeTcpConnectionPoolProperty"');
    }
    function cfnVirtualNodeVirtualNodeTcpConnectionPoolPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_VirtualNodeTcpConnectionPoolPropertyValidator(properties).assertSuccess(), { MaxConnections: cdk.numberToCloudFormation(properties.maxConnections) }) : properties;
    }
    function CfnVirtualNodeVirtualNodeTcpConnectionPoolPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxConnections", "MaxConnections", cfn_parse.FromCloudFormation.getNumber(properties.MaxConnections)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualNode_VirtualServiceBackendPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clientPolicy", CfnVirtualNode_ClientPolicyPropertyValidator)(properties.clientPolicy)), errors.collect(cdk.propertyValidator("virtualServiceName", cdk.requiredValidator)(properties.virtualServiceName)), errors.collect(cdk.propertyValidator("virtualServiceName", cdk.validateString)(properties.virtualServiceName)), errors.wrap('supplied properties not correct for "VirtualServiceBackendProperty"');
    }
    function cfnVirtualNodeVirtualServiceBackendPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualNode_VirtualServiceBackendPropertyValidator(properties).assertSuccess(), { ClientPolicy: cfnVirtualNodeClientPolicyPropertyToCloudFormation(properties.clientPolicy), VirtualServiceName: cdk.stringToCloudFormation(properties.virtualServiceName) }) : properties;
    }
    function CfnVirtualNodeVirtualServiceBackendPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clientPolicy", "ClientPolicy", properties.ClientPolicy != null ? CfnVirtualNodeClientPolicyPropertyFromCloudFormation(properties.ClientPolicy) : void 0), ret.addPropertyResult("virtualServiceName", "VirtualServiceName", cfn_parse.FromCloudFormation.getString(properties.VirtualServiceName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualRouterPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("meshName", cdk.requiredValidator)(properties.meshName)), errors.collect(cdk.propertyValidator("meshName", cdk.validateString)(properties.meshName)), errors.collect(cdk.propertyValidator("meshOwner", cdk.validateString)(properties.meshOwner)), errors.collect(cdk.propertyValidator("spec", cdk.requiredValidator)(properties.spec)), errors.collect(cdk.propertyValidator("spec", CfnVirtualRouter_VirtualRouterSpecPropertyValidator)(properties.spec)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("virtualRouterName", cdk.validateString)(properties.virtualRouterName)), errors.wrap('supplied properties not correct for "CfnVirtualRouterProps"');
    }
    function cfnVirtualRouterPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualRouterPropsValidator(properties).assertSuccess(), { MeshName: cdk.stringToCloudFormation(properties.meshName), Spec: cfnVirtualRouterVirtualRouterSpecPropertyToCloudFormation(properties.spec), MeshOwner: cdk.stringToCloudFormation(properties.meshOwner), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VirtualRouterName: cdk.stringToCloudFormation(properties.virtualRouterName) }) : properties;
    }
    function CfnVirtualRouterPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("meshName", "MeshName", cfn_parse.FromCloudFormation.getString(properties.MeshName)), ret.addPropertyResult("spec", "Spec", CfnVirtualRouterVirtualRouterSpecPropertyFromCloudFormation(properties.Spec)), ret.addPropertyResult("meshOwner", "MeshOwner", properties.MeshOwner != null ? cfn_parse.FromCloudFormation.getString(properties.MeshOwner) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("virtualRouterName", "VirtualRouterName", properties.VirtualRouterName != null ? cfn_parse.FromCloudFormation.getString(properties.VirtualRouterName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVirtualRouter = class _CfnVirtualRouter extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVirtualRouterPropsFromCloudFormation(resourceProperties), ret = new _CfnVirtualRouter(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVirtualRouter.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_CfnVirtualRouterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVirtualRouter), error;
        }
        cdk.requireProperty(props, "meshName", this), cdk.requireProperty(props, "spec", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrMeshName = cdk.Token.asString(this.getAtt("MeshName", cdk.ResolutionTypeHint.STRING)), this.attrMeshOwner = cdk.Token.asString(this.getAtt("MeshOwner", cdk.ResolutionTypeHint.STRING)), this.attrResourceOwner = cdk.Token.asString(this.getAtt("ResourceOwner", cdk.ResolutionTypeHint.STRING)), this.attrUid = cdk.Token.asString(this.getAtt("Uid", cdk.ResolutionTypeHint.STRING)), this.attrVirtualRouterName = cdk.Token.asString(this.getAtt("VirtualRouterName", cdk.ResolutionTypeHint.STRING)), this.meshName = props.meshName, this.spec = props.spec, this.meshOwner = props.meshOwner, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::AppMesh::VirtualRouter", props.tags, { tagPropertyName: "tags" }), this.virtualRouterName = props.virtualRouterName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVirtualRouter.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { meshName: this.meshName, spec: this.spec, meshOwner: this.meshOwner, tags: this.tags.renderTags(), virtualRouterName: this.virtualRouterName };
      }
      renderProperties(props) {
        return cfnVirtualRouterPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnVirtualRouter[_f] = { fqn: "aws-cdk-lib.aws_appmesh.CfnVirtualRouter", version: "2.80.0" }, CfnVirtualRouter.CFN_RESOURCE_TYPE_NAME = "AWS::AppMesh::VirtualRouter", exports2.CfnVirtualRouter = CfnVirtualRouter;
    function CfnVirtualRouter_PortMappingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("port", cdk.requiredValidator)(properties.port)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("protocol", cdk.requiredValidator)(properties.protocol)), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.wrap('supplied properties not correct for "PortMappingProperty"');
    }
    function cfnVirtualRouterPortMappingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualRouter_PortMappingPropertyValidator(properties).assertSuccess(), { Port: cdk.numberToCloudFormation(properties.port), Protocol: cdk.stringToCloudFormation(properties.protocol) }) : properties;
    }
    function CfnVirtualRouterPortMappingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("port", "Port", cfn_parse.FromCloudFormation.getNumber(properties.Port)), ret.addPropertyResult("protocol", "Protocol", cfn_parse.FromCloudFormation.getString(properties.Protocol)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualRouter_VirtualRouterListenerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("portMapping", cdk.requiredValidator)(properties.portMapping)), errors.collect(cdk.propertyValidator("portMapping", CfnVirtualRouter_PortMappingPropertyValidator)(properties.portMapping)), errors.wrap('supplied properties not correct for "VirtualRouterListenerProperty"');
    }
    function cfnVirtualRouterVirtualRouterListenerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualRouter_VirtualRouterListenerPropertyValidator(properties).assertSuccess(), { PortMapping: cfnVirtualRouterPortMappingPropertyToCloudFormation(properties.portMapping) }) : properties;
    }
    function CfnVirtualRouterVirtualRouterListenerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("portMapping", "PortMapping", CfnVirtualRouterPortMappingPropertyFromCloudFormation(properties.PortMapping)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualRouter_VirtualRouterSpecPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("listeners", cdk.requiredValidator)(properties.listeners)), errors.collect(cdk.propertyValidator("listeners", cdk.listValidator(CfnVirtualRouter_VirtualRouterListenerPropertyValidator))(properties.listeners)), errors.wrap('supplied properties not correct for "VirtualRouterSpecProperty"');
    }
    function cfnVirtualRouterVirtualRouterSpecPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualRouter_VirtualRouterSpecPropertyValidator(properties).assertSuccess(), { Listeners: cdk.listMapper(cfnVirtualRouterVirtualRouterListenerPropertyToCloudFormation)(properties.listeners) }) : properties;
    }
    function CfnVirtualRouterVirtualRouterSpecPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("listeners", "Listeners", cfn_parse.FromCloudFormation.getArray(CfnVirtualRouterVirtualRouterListenerPropertyFromCloudFormation)(properties.Listeners)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualServicePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("meshName", cdk.requiredValidator)(properties.meshName)), errors.collect(cdk.propertyValidator("meshName", cdk.validateString)(properties.meshName)), errors.collect(cdk.propertyValidator("meshOwner", cdk.validateString)(properties.meshOwner)), errors.collect(cdk.propertyValidator("spec", cdk.requiredValidator)(properties.spec)), errors.collect(cdk.propertyValidator("spec", CfnVirtualService_VirtualServiceSpecPropertyValidator)(properties.spec)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("virtualServiceName", cdk.requiredValidator)(properties.virtualServiceName)), errors.collect(cdk.propertyValidator("virtualServiceName", cdk.validateString)(properties.virtualServiceName)), errors.wrap('supplied properties not correct for "CfnVirtualServiceProps"');
    }
    function cfnVirtualServicePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualServicePropsValidator(properties).assertSuccess(), { MeshName: cdk.stringToCloudFormation(properties.meshName), Spec: cfnVirtualServiceVirtualServiceSpecPropertyToCloudFormation(properties.spec), VirtualServiceName: cdk.stringToCloudFormation(properties.virtualServiceName), MeshOwner: cdk.stringToCloudFormation(properties.meshOwner), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnVirtualServicePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("meshName", "MeshName", cfn_parse.FromCloudFormation.getString(properties.MeshName)), ret.addPropertyResult("spec", "Spec", CfnVirtualServiceVirtualServiceSpecPropertyFromCloudFormation(properties.Spec)), ret.addPropertyResult("virtualServiceName", "VirtualServiceName", cfn_parse.FromCloudFormation.getString(properties.VirtualServiceName)), ret.addPropertyResult("meshOwner", "MeshOwner", properties.MeshOwner != null ? cfn_parse.FromCloudFormation.getString(properties.MeshOwner) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVirtualService = class _CfnVirtualService extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVirtualServicePropsFromCloudFormation(resourceProperties), ret = new _CfnVirtualService(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVirtualService.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_CfnVirtualServiceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVirtualService), error;
        }
        cdk.requireProperty(props, "meshName", this), cdk.requireProperty(props, "spec", this), cdk.requireProperty(props, "virtualServiceName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrMeshName = cdk.Token.asString(this.getAtt("MeshName", cdk.ResolutionTypeHint.STRING)), this.attrMeshOwner = cdk.Token.asString(this.getAtt("MeshOwner", cdk.ResolutionTypeHint.STRING)), this.attrResourceOwner = cdk.Token.asString(this.getAtt("ResourceOwner", cdk.ResolutionTypeHint.STRING)), this.attrUid = cdk.Token.asString(this.getAtt("Uid", cdk.ResolutionTypeHint.STRING)), this.attrVirtualServiceName = cdk.Token.asString(this.getAtt("VirtualServiceName", cdk.ResolutionTypeHint.STRING)), this.meshName = props.meshName, this.spec = props.spec, this.virtualServiceName = props.virtualServiceName, this.meshOwner = props.meshOwner, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::AppMesh::VirtualService", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVirtualService.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { meshName: this.meshName, spec: this.spec, virtualServiceName: this.virtualServiceName, meshOwner: this.meshOwner, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnVirtualServicePropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnVirtualService[_g] = { fqn: "aws-cdk-lib.aws_appmesh.CfnVirtualService", version: "2.80.0" }, CfnVirtualService.CFN_RESOURCE_TYPE_NAME = "AWS::AppMesh::VirtualService", exports2.CfnVirtualService = CfnVirtualService;
    function CfnVirtualService_VirtualNodeServiceProviderPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("virtualNodeName", cdk.requiredValidator)(properties.virtualNodeName)), errors.collect(cdk.propertyValidator("virtualNodeName", cdk.validateString)(properties.virtualNodeName)), errors.wrap('supplied properties not correct for "VirtualNodeServiceProviderProperty"');
    }
    function cfnVirtualServiceVirtualNodeServiceProviderPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualService_VirtualNodeServiceProviderPropertyValidator(properties).assertSuccess(), { VirtualNodeName: cdk.stringToCloudFormation(properties.virtualNodeName) }) : properties;
    }
    function CfnVirtualServiceVirtualNodeServiceProviderPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("virtualNodeName", "VirtualNodeName", cfn_parse.FromCloudFormation.getString(properties.VirtualNodeName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualService_VirtualRouterServiceProviderPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("virtualRouterName", cdk.requiredValidator)(properties.virtualRouterName)), errors.collect(cdk.propertyValidator("virtualRouterName", cdk.validateString)(properties.virtualRouterName)), errors.wrap('supplied properties not correct for "VirtualRouterServiceProviderProperty"');
    }
    function cfnVirtualServiceVirtualRouterServiceProviderPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualService_VirtualRouterServiceProviderPropertyValidator(properties).assertSuccess(), { VirtualRouterName: cdk.stringToCloudFormation(properties.virtualRouterName) }) : properties;
    }
    function CfnVirtualServiceVirtualRouterServiceProviderPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("virtualRouterName", "VirtualRouterName", cfn_parse.FromCloudFormation.getString(properties.VirtualRouterName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualService_VirtualServiceProviderPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("virtualNode", CfnVirtualService_VirtualNodeServiceProviderPropertyValidator)(properties.virtualNode)), errors.collect(cdk.propertyValidator("virtualRouter", CfnVirtualService_VirtualRouterServiceProviderPropertyValidator)(properties.virtualRouter)), errors.wrap('supplied properties not correct for "VirtualServiceProviderProperty"');
    }
    function cfnVirtualServiceVirtualServiceProviderPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualService_VirtualServiceProviderPropertyValidator(properties).assertSuccess(), { VirtualNode: cfnVirtualServiceVirtualNodeServiceProviderPropertyToCloudFormation(properties.virtualNode), VirtualRouter: cfnVirtualServiceVirtualRouterServiceProviderPropertyToCloudFormation(properties.virtualRouter) }) : properties;
    }
    function CfnVirtualServiceVirtualServiceProviderPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("virtualNode", "VirtualNode", properties.VirtualNode != null ? CfnVirtualServiceVirtualNodeServiceProviderPropertyFromCloudFormation(properties.VirtualNode) : void 0), ret.addPropertyResult("virtualRouter", "VirtualRouter", properties.VirtualRouter != null ? CfnVirtualServiceVirtualRouterServiceProviderPropertyFromCloudFormation(properties.VirtualRouter) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualService_VirtualServiceSpecPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("provider", CfnVirtualService_VirtualServiceProviderPropertyValidator)(properties.provider)), errors.wrap('supplied properties not correct for "VirtualServiceSpecProperty"');
    }
    function cfnVirtualServiceVirtualServiceSpecPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualService_VirtualServiceSpecPropertyValidator(properties).assertSuccess(), { Provider: cfnVirtualServiceVirtualServiceProviderPropertyToCloudFormation(properties.provider) }) : properties;
    }
    function CfnVirtualServiceVirtualServiceSpecPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("provider", "Provider", properties.Provider != null ? CfnVirtualServiceVirtualServiceProviderPropertyFromCloudFormation(properties.Provider) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-appmesh/lib/private/utils.js
var require_utils9 = __commonJS({
  "node_modules/aws-cdk-lib/aws-appmesh/lib/private/utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.validateGrpcGatewayRouteMatch = exports2.validateGrpcRouteMatch = exports2.validateGrpcMatchArrayLength = exports2.validateHttpMatchArrayLength = exports2.renderMeshOwner = exports2.renderListenerTlsOptions = exports2.renderTlsClientPolicy = void 0;
    var core_1 = require_core2();
    function renderTlsClientPolicy(scope, tlsClientPolicy) {
      const certificate = tlsClientPolicy?.mutualTlsCertificate?.bind(scope).tlsCertificate, sans = tlsClientPolicy?.validation.subjectAlternativeNames;
      return tlsClientPolicy ? { certificate, ports: tlsClientPolicy.ports, enforce: tlsClientPolicy.enforce, validation: { subjectAlternativeNames: sans ? { match: sans.bind(scope).subjectAlternativeNamesMatch } : void 0, trust: tlsClientPolicy.validation.trust.bind(scope).tlsValidationTrust } } : void 0;
    }
    exports2.renderTlsClientPolicy = renderTlsClientPolicy;
    function renderListenerTlsOptions(scope, listenerTls) {
      const tlsValidation = listenerTls?.mutualTlsValidation;
      return listenerTls ? { certificate: listenerTls.certificate.bind(scope).tlsCertificate, mode: listenerTls.mode, validation: tlsValidation ? { subjectAlternativeNames: tlsValidation.subjectAlternativeNames ? { match: tlsValidation.subjectAlternativeNames.bind(scope).subjectAlternativeNamesMatch } : void 0, trust: tlsValidation.trust.bind(scope).tlsValidationTrust } : void 0 } : void 0;
    }
    exports2.renderListenerTlsOptions = renderListenerTlsOptions;
    function renderMeshOwner(resourceAccount, meshAccount) {
      const comparison = core_1.Token.compareStrings(resourceAccount, meshAccount);
      return comparison === core_1.TokenComparison.DIFFERENT || comparison === core_1.TokenComparison.ONE_UNRESOLVED ? meshAccount : void 0;
    }
    exports2.renderMeshOwner = renderMeshOwner;
    function validateHttpMatchArrayLength(headers, queryParameters) {
      if (headers && (headers.length < 1 || headers.length > 10))
        throw new Error(`Number of headers provided for matching must be between 1 and 10, got: ${headers.length}`);
      if (queryParameters && (queryParameters.length < 1 || queryParameters.length > 10))
        throw new Error(`Number of query parameters provided for matching must be between 1 and 10, got: ${queryParameters.length}`);
    }
    exports2.validateHttpMatchArrayLength = validateHttpMatchArrayLength;
    function validateGrpcMatchArrayLength(metadata) {
      if (metadata && (metadata.length < 1 || metadata.length > 10))
        throw new Error(`Number of metadata provided for matching must be between 1 and 10, got: ${metadata.length}`);
    }
    exports2.validateGrpcMatchArrayLength = validateGrpcMatchArrayLength;
    function validateGrpcRouteMatch(match) {
      if (match.serviceName === void 0 && match.metadata === void 0 && match.methodName === void 0)
        throw new Error("At least one gRPC route match property must be provided");
    }
    exports2.validateGrpcRouteMatch = validateGrpcRouteMatch;
    function validateGrpcGatewayRouteMatch(match) {
      if (match.serviceName === void 0 && match.metadata === void 0 && match.hostname === void 0)
        throw new Error("At least one gRPC gateway route match property beside rewriteRequestHostname must be provided");
    }
    exports2.validateGrpcGatewayRouteMatch = validateGrpcGatewayRouteMatch;
  }
});

// node_modules/aws-cdk-lib/aws-appmesh/lib/gateway-route.js
var require_gateway_route = __commonJS({
  "node_modules/aws-cdk-lib/aws-appmesh/lib/gateway-route.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.GatewayRoute = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var appmesh_generated_1 = require_appmesh_generated();
    var utils_1 = require_utils9();
    var virtual_gateway_1 = require_virtual_gateway();
    var cdk = require_core2();
    var GatewayRoute = class _GatewayRoute extends cdk.Resource {
      static fromGatewayRouteArn(scope, id, gatewayRouteArn) {
        return new class extends cdk.Resource {
          constructor() {
            super(...arguments), this.gatewayRouteArn = gatewayRouteArn, this.gatewayRouteName = cdk.Fn.select(4, cdk.Fn.split("/", cdk.Stack.of(scope).splitArn(gatewayRouteArn, cdk.ArnFormat.SLASH_RESOURCE_NAME).resourceName)), this.virtualGateway = virtual_gateway_1.VirtualGateway.fromVirtualGatewayArn(this, "virtualGateway", gatewayRouteArn);
          }
        }(scope, id);
      }
      static fromGatewayRouteAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_GatewayRouteAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromGatewayRouteAttributes), error;
        }
        return new class extends cdk.Resource {
          constructor() {
            super(...arguments), this.gatewayRouteName = attrs.gatewayRouteName, this.gatewayRouteArn = cdk.Stack.of(scope).formatArn({ service: "appmesh", resource: `mesh/${attrs.virtualGateway.mesh.meshName}/virtualGateway/${attrs.virtualGateway.virtualGatewayName}/gatewayRoute`, resourceName: this.gatewayRouteName }), this.virtualGateway = attrs.virtualGateway;
          }
        }(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.gatewayRouteName || cdk.Lazy.string({ produce: () => cdk.Names.uniqueId(this) }) });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_GatewayRouteProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _GatewayRoute), error;
        }
        this.virtualGateway = props.virtualGateway;
        const routeSpecConfig = props.routeSpec.bind(this), gatewayRoute = new appmesh_generated_1.CfnGatewayRoute(this, "Resource", { gatewayRouteName: this.physicalName, meshName: props.virtualGateway.mesh.meshName, meshOwner: (0, utils_1.renderMeshOwner)(this.env.account, this.virtualGateway.mesh.env.account), spec: { httpRoute: routeSpecConfig.httpSpecConfig, http2Route: routeSpecConfig.http2SpecConfig, grpcRoute: routeSpecConfig.grpcSpecConfig, priority: routeSpecConfig.priority }, virtualGatewayName: this.virtualGateway.virtualGatewayName });
        this.gatewayRouteName = this.getResourceNameAttribute(gatewayRoute.attrGatewayRouteName), this.gatewayRouteArn = this.getResourceArnAttribute(gatewayRoute.ref, { service: "appmesh", resource: `mesh/${props.virtualGateway.mesh.meshName}/virtualRouter/${this.virtualGateway.virtualGatewayName}/gatewayRoute`, resourceName: this.physicalName }), this.node.addValidation({ validate() {
          if (cdk.Resource.isOwnedResource(props.virtualGateway)) {
            const listeners = props.virtualGateway.node.defaultChild.spec.listeners;
            if (Array.isArray(listeners) && listeners.length > 1)
              return ["Gateway route must define a match port if the parent Virtual Gateway has multiple listeners."];
          }
          return [];
        } });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, GatewayRoute[_a] = { fqn: "aws-cdk-lib.aws_appmesh.GatewayRoute", version: "2.80.0" }, exports2.GatewayRoute = GatewayRoute;
  }
});

// node_modules/aws-cdk-lib/aws-appmesh/lib/shared-interfaces.js
var require_shared_interfaces = __commonJS({
  "node_modules/aws-cdk-lib/aws-appmesh/lib/shared-interfaces.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Backend = exports2.LoggingFormat = exports2.AccessLog = exports2.Protocol = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var utils_1 = require_utils9();
    var cdk = require_core2();
    var Protocol;
    (function(Protocol2) {
      Protocol2.HTTP = "http", Protocol2.TCP = "tcp", Protocol2.HTTP2 = "http2", Protocol2.GRPC = "grpc";
    })(Protocol = exports2.Protocol || (exports2.Protocol = {}));
    var AccessLog = class {
      static fromFilePath(filePath, loggingFormat) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_LoggingFormat(loggingFormat);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromFilePath), error;
        }
        return new FileAccessLog(filePath, loggingFormat);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AccessLog[_a] = { fqn: "aws-cdk-lib.aws_appmesh.AccessLog", version: "2.80.0" }, exports2.AccessLog = AccessLog;
    var FileAccessLog = class extends AccessLog {
      constructor(filePath, loggingFormat) {
        super(), this.filePath = filePath, this.virtualGatewayLoggingFormat = loggingFormat?.bind().formatConfig, this.virtualNodeLoggingFormat = loggingFormat?.bind().formatConfig;
      }
      bind(_scope) {
        return { virtualNodeAccessLog: { file: { path: this.filePath, format: this.virtualNodeLoggingFormat } }, virtualGatewayAccessLog: { file: { path: this.filePath, format: this.virtualGatewayLoggingFormat } } };
      }
    };
    var LoggingFormat = class {
      static fromText(text) {
        return new TextLoggingFormat(text);
      }
      static fromJson(jsonLoggingFormat) {
        if (Object.keys(jsonLoggingFormat).length == 0)
          throw new Error("Json key pairs cannot be empty.");
        return new JsonLoggingFormat(jsonLoggingFormat);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, LoggingFormat[_b] = { fqn: "aws-cdk-lib.aws_appmesh.LoggingFormat", version: "2.80.0" }, exports2.LoggingFormat = LoggingFormat;
    var JsonLoggingFormat = class extends LoggingFormat {
      constructor(json) {
        super(), this.json = Object.entries(json).map(([key, value]) => ({ key, value }));
      }
      bind() {
        return { formatConfig: { json: this.json } };
      }
    };
    var TextLoggingFormat = class extends LoggingFormat {
      constructor(text) {
        super(), this.text = text;
      }
      bind() {
        return { formatConfig: { text: this.text } };
      }
    };
    var Backend = class {
      static virtualService(virtualService, props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_IVirtualService(virtualService), jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_VirtualServiceBackendOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.virtualService), error;
        }
        return new VirtualServiceBackend(virtualService, props.tlsClientPolicy);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, Backend[_c] = { fqn: "aws-cdk-lib.aws_appmesh.Backend", version: "2.80.0" }, exports2.Backend = Backend;
    var VirtualServiceBackend = class extends Backend {
      constructor(virtualService, tlsClientPolicy) {
        super(), this.virtualService = virtualService, this.tlsClientPolicy = tlsClientPolicy;
      }
      bind(scope) {
        return { virtualServiceBackend: { virtualService: { virtualServiceName: cdk.Token.isUnresolved(this.virtualService.virtualServiceName) ? this.virtualService.physicalName : this.virtualService.virtualServiceName, clientPolicy: this.tlsClientPolicy ? { tls: (0, utils_1.renderTlsClientPolicy)(scope, this.tlsClientPolicy) } : void 0 } } };
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-appmesh/lib/virtual-gateway-listener.js
var require_virtual_gateway_listener = __commonJS({
  "node_modules/aws-cdk-lib/aws-appmesh/lib/virtual-gateway-listener.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.VirtualGatewayListener = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var utils_1 = require_utils9();
    var shared_interfaces_1 = require_shared_interfaces();
    var VirtualGatewayListener = class {
      static http(options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_HttpGatewayListenerOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.http), error;
        }
        return new VirtualGatewayListenerImpl(shared_interfaces_1.Protocol.HTTP, options.healthCheck, options.port, options.tls, options.connectionPool);
      }
      static http2(options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_Http2GatewayListenerOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.http2), error;
        }
        return new VirtualGatewayListenerImpl(shared_interfaces_1.Protocol.HTTP2, options.healthCheck, options.port, options.tls, options.connectionPool);
      }
      static grpc(options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_GrpcGatewayListenerOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grpc), error;
        }
        return new VirtualGatewayListenerImpl(shared_interfaces_1.Protocol.GRPC, options.healthCheck, options.port, options.tls, options.connectionPool);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, VirtualGatewayListener[_a] = { fqn: "aws-cdk-lib.aws_appmesh.VirtualGatewayListener", version: "2.80.0" }, exports2.VirtualGatewayListener = VirtualGatewayListener;
    var VirtualGatewayListenerImpl = class extends VirtualGatewayListener {
      constructor(protocol, healthCheck, port = 8080, listenerTls, connectionPool) {
        super(), this.protocol = protocol, this.healthCheck = healthCheck, this.port = port, this.listenerTls = listenerTls, this.connectionPool = connectionPool;
      }
      bind(scope) {
        return { listener: { portMapping: { port: this.port, protocol: this.protocol }, healthCheck: this.healthCheck?.bind(scope, { defaultPort: this.port }).virtualGatewayHealthCheck, tls: (0, utils_1.renderListenerTlsOptions)(scope, this.listenerTls), connectionPool: this.connectionPool ? renderConnectionPool(this.connectionPool, this.protocol) : void 0 } };
      }
    };
    function renderConnectionPool(connectionPool, listenerProtocol) {
      return { [listenerProtocol]: { maxRequests: connectionPool?.maxRequests !== void 0 ? connectionPool.maxRequests : void 0, maxConnections: connectionPool?.maxConnections !== void 0 ? connectionPool.maxConnections : void 0, maxPendingRequests: connectionPool?.maxPendingRequests !== void 0 ? connectionPool.maxPendingRequests : void 0 } };
    }
  }
});

// node_modules/aws-cdk-lib/aws-appmesh/lib/virtual-gateway.js
var require_virtual_gateway = __commonJS({
  "node_modules/aws-cdk-lib/aws-appmesh/lib/virtual-gateway.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.VirtualGateway = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var appmesh_generated_1 = require_appmesh_generated();
    var gateway_route_1 = require_gateway_route();
    var mesh_1 = require_mesh();
    var utils_1 = require_utils9();
    var virtual_gateway_listener_1 = require_virtual_gateway_listener();
    var iam = require_aws_iam();
    var cdk = require_core2();
    var VirtualGatewayBase = class extends cdk.Resource {
      addGatewayRoute(id, props) {
        return new gateway_route_1.GatewayRoute(this, id, { ...props, virtualGateway: this });
      }
      grantStreamAggregatedResources(identity) {
        return iam.Grant.addToPrincipal({ grantee: identity, actions: ["appmesh:StreamAggregatedResources"], resourceArns: [this.virtualGatewayArn] });
      }
    };
    var VirtualGateway = class _VirtualGateway extends VirtualGatewayBase {
      static fromVirtualGatewayArn(scope, id, virtualGatewayArn) {
        return new class extends VirtualGatewayBase {
          constructor() {
            super(...arguments), this.parsedArn = cdk.Fn.split("/", cdk.Stack.of(scope).splitArn(virtualGatewayArn, cdk.ArnFormat.SLASH_RESOURCE_NAME).resourceName), this.mesh = mesh_1.Mesh.fromMeshName(this, "Mesh", cdk.Fn.select(0, this.parsedArn)), this.virtualGatewayArn = virtualGatewayArn, this.virtualGatewayName = cdk.Fn.select(2, this.parsedArn);
          }
        }(scope, id);
      }
      static fromVirtualGatewayAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_VirtualGatewayAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromVirtualGatewayAttributes), error;
        }
        return new class extends VirtualGatewayBase {
          constructor() {
            super(...arguments), this.mesh = attrs.mesh, this.virtualGatewayName = attrs.virtualGatewayName, this.virtualGatewayArn = cdk.Stack.of(this).formatArn({ service: "appmesh", resource: `mesh/${attrs.mesh.meshName}/virtualGateway`, resourceName: this.virtualGatewayName });
          }
        }(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.virtualGatewayName || cdk.Lazy.string({ produce: () => cdk.Names.uniqueId(this) }) }), this.listeners = new Array();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_VirtualGatewayProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _VirtualGateway), error;
        }
        this.mesh = props.mesh, props.listeners ? props.listeners.forEach((listener) => this.listeners.push(listener.bind(this))) : this.listeners.push(virtual_gateway_listener_1.VirtualGatewayListener.http().bind(this));
        const accessLogging = props.accessLog?.bind(this), node = new appmesh_generated_1.CfnVirtualGateway(this, "Resource", { virtualGatewayName: this.physicalName, meshName: this.mesh.meshName, meshOwner: (0, utils_1.renderMeshOwner)(this.env.account, this.mesh.env.account), spec: { listeners: this.listeners.map((listener) => listener.listener), backendDefaults: props.backendDefaults !== void 0 ? { clientPolicy: { tls: (0, utils_1.renderTlsClientPolicy)(this, props.backendDefaults?.tlsClientPolicy) } } : void 0, logging: accessLogging !== void 0 ? { accessLog: accessLogging.virtualGatewayAccessLog } : void 0 } });
        this.virtualGatewayName = this.getResourceNameAttribute(node.attrVirtualGatewayName), this.virtualGatewayArn = this.getResourceArnAttribute(node.ref, { service: "appmesh", resource: `mesh/${props.mesh.meshName}/virtualGateway`, resourceName: this.physicalName });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, VirtualGateway[_a] = { fqn: "aws-cdk-lib.aws_appmesh.VirtualGateway", version: "2.80.0" }, exports2.VirtualGateway = VirtualGateway;
  }
});

// node_modules/aws-cdk-lib/aws-appmesh/lib/virtual-node.js
var require_virtual_node = __commonJS({
  "node_modules/aws-cdk-lib/aws-appmesh/lib/virtual-node.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.VirtualNode = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var appmesh_generated_1 = require_appmesh_generated();
    var mesh_1 = require_mesh();
    var utils_1 = require_utils9();
    var iam = require_aws_iam();
    var cdk = require_core2();
    var VirtualNodeBase = class extends cdk.Resource {
      grantStreamAggregatedResources(identity) {
        return iam.Grant.addToPrincipal({ grantee: identity, actions: ["appmesh:StreamAggregatedResources"], resourceArns: [this.virtualNodeArn] });
      }
    };
    var VirtualNode = class _VirtualNode extends VirtualNodeBase {
      static fromVirtualNodeArn(scope, id, virtualNodeArn) {
        return new class extends VirtualNodeBase {
          constructor() {
            super(...arguments), this.virtualNodeArn = virtualNodeArn, this.parsedArn = cdk.Fn.split("/", cdk.Stack.of(scope).splitArn(virtualNodeArn, cdk.ArnFormat.SLASH_RESOURCE_NAME).resourceName), this.mesh = mesh_1.Mesh.fromMeshName(this, "Mesh", cdk.Fn.select(0, this.parsedArn)), this.virtualNodeName = cdk.Fn.select(2, this.parsedArn);
          }
        }(scope, id);
      }
      static fromVirtualNodeAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_VirtualNodeAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromVirtualNodeAttributes), error;
        }
        return new class extends VirtualNodeBase {
          constructor() {
            super(...arguments), this.mesh = attrs.mesh, this.virtualNodeName = attrs.virtualNodeName, this.virtualNodeArn = cdk.Stack.of(this).formatArn({ service: "appmesh", resource: `mesh/${attrs.mesh.meshName}/virtualNode`, resourceName: this.virtualNodeName });
          }
        }(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.virtualNodeName || cdk.Lazy.string({ produce: () => cdk.Names.uniqueId(this) }) }), this.backends = new Array(), this.listeners = new Array();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_VirtualNodeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _VirtualNode), error;
        }
        this.mesh = props.mesh, this.serviceDiscoveryConfig = props.serviceDiscovery?.bind(this), props.backends?.forEach((backend) => this.addBackend(backend)), props.listeners?.forEach((listener) => this.addListener(listener));
        const accessLogging = props.accessLog?.bind(this), node = new appmesh_generated_1.CfnVirtualNode(this, "Resource", { virtualNodeName: this.physicalName, meshName: this.mesh.meshName, meshOwner: (0, utils_1.renderMeshOwner)(this.env.account, this.mesh.env.account), spec: { backends: cdk.Lazy.any({ produce: () => this.backends }, { omitEmptyArray: true }), listeners: cdk.Lazy.any({ produce: () => this.listeners.map((listener) => listener.listener) }, { omitEmptyArray: true }), backendDefaults: props.backendDefaults !== void 0 ? { clientPolicy: { tls: (0, utils_1.renderTlsClientPolicy)(this, props.backendDefaults?.tlsClientPolicy) } } : void 0, serviceDiscovery: renderServiceDiscovery(this.serviceDiscoveryConfig), logging: accessLogging !== void 0 ? { accessLog: accessLogging.virtualNodeAccessLog } : void 0 } });
        this.virtualNodeName = this.getResourceNameAttribute(node.attrVirtualNodeName), this.virtualNodeArn = this.getResourceArnAttribute(node.ref, { service: "appmesh", resource: `mesh/${props.mesh.meshName}/virtualNode`, resourceName: this.physicalName });
      }
      addListener(listener) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_VirtualNodeListener(listener);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addListener), error;
        }
        if (!this.serviceDiscoveryConfig)
          throw new Error("Service discovery information is required for a VirtualNode with a listener.");
        this.listeners.push(listener.bind(this));
      }
      addBackend(backend) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_Backend(backend);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addBackend), error;
        }
        this.backends.push(backend.bind(this).virtualServiceBackend);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, VirtualNode[_a] = { fqn: "aws-cdk-lib.aws_appmesh.VirtualNode", version: "2.80.0" }, exports2.VirtualNode = VirtualNode;
    function renderServiceDiscovery(config) {
      return config ? { dns: config?.dns, awsCloudMap: config?.cloudmap } : void 0;
    }
  }
});

// node_modules/aws-cdk-lib/aws-appmesh/lib/route.js
var require_route2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-appmesh/lib/route.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Route = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var appmesh_generated_1 = require_appmesh_generated();
    var utils_1 = require_utils9();
    var virtual_router_1 = require_virtual_router();
    var cdk = require_core2();
    var Route = class _Route extends cdk.Resource {
      static fromRouteArn(scope, id, routeArn) {
        return new class extends cdk.Resource {
          constructor() {
            super(...arguments), this.routeArn = routeArn, this.virtualRouter = virtual_router_1.VirtualRouter.fromVirtualRouterArn(this, "VirtualRouter", routeArn), this.routeName = cdk.Fn.select(4, cdk.Fn.split("/", cdk.Stack.of(scope).splitArn(routeArn, cdk.ArnFormat.SLASH_RESOURCE_NAME).resourceName));
          }
        }(scope, id);
      }
      static fromRouteAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_RouteAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromRouteAttributes), error;
        }
        return new class extends cdk.Resource {
          constructor() {
            super(...arguments), this.routeName = attrs.routeName, this.virtualRouter = attrs.virtualRouter, this.routeArn = cdk.Stack.of(this).formatArn({ service: "appmesh", resource: `mesh/${attrs.virtualRouter.mesh.meshName}/virtualRouter/${attrs.virtualRouter.virtualRouterName}/route`, resourceName: this.routeName });
          }
        }(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.routeName || cdk.Lazy.string({ produce: () => cdk.Names.uniqueId(this) }) });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_RouteProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Route), error;
        }
        this.virtualRouter = props.virtualRouter;
        const spec = props.routeSpec.bind(this), route = new appmesh_generated_1.CfnRoute(this, "Resource", { routeName: this.physicalName, meshName: this.virtualRouter.mesh.meshName, meshOwner: (0, utils_1.renderMeshOwner)(this.env.account, this.virtualRouter.mesh.env.account), virtualRouterName: this.virtualRouter.virtualRouterName, spec: { tcpRoute: spec.tcpRouteSpec, httpRoute: spec.httpRouteSpec, http2Route: spec.http2RouteSpec, grpcRoute: spec.grpcRouteSpec, priority: spec.priority } });
        this.routeName = this.getResourceNameAttribute(route.attrRouteName), this.routeArn = this.getResourceArnAttribute(route.ref, { service: "appmesh", resource: `mesh/${props.mesh.meshName}/virtualRouter/${props.virtualRouter.virtualRouterName}/route`, resourceName: this.physicalName });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Route[_a] = { fqn: "aws-cdk-lib.aws_appmesh.Route", version: "2.80.0" }, exports2.Route = Route;
  }
});

// node_modules/aws-cdk-lib/aws-appmesh/lib/virtual-router-listener.js
var require_virtual_router_listener = __commonJS({
  "node_modules/aws-cdk-lib/aws-appmesh/lib/virtual-router-listener.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.VirtualRouterListener = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var shared_interfaces_1 = require_shared_interfaces();
    var VirtualRouterListener = class {
      static http(port) {
        return new VirtualRouterListenerImpl(shared_interfaces_1.Protocol.HTTP, port);
      }
      static http2(port) {
        return new VirtualRouterListenerImpl(shared_interfaces_1.Protocol.HTTP2, port);
      }
      static grpc(port) {
        return new VirtualRouterListenerImpl(shared_interfaces_1.Protocol.GRPC, port);
      }
      static tcp(port) {
        return new VirtualRouterListenerImpl(shared_interfaces_1.Protocol.TCP, port);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, VirtualRouterListener[_a] = { fqn: "aws-cdk-lib.aws_appmesh.VirtualRouterListener", version: "2.80.0" }, exports2.VirtualRouterListener = VirtualRouterListener;
    var VirtualRouterListenerImpl = class extends VirtualRouterListener {
      constructor(protocol, port) {
        super(), this.protocol = protocol, this.port = port ?? 8080;
      }
      bind(_scope) {
        return { listener: { portMapping: { port: this.port, protocol: this.protocol } } };
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-appmesh/lib/virtual-router.js
var require_virtual_router = __commonJS({
  "node_modules/aws-cdk-lib/aws-appmesh/lib/virtual-router.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.VirtualRouter = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var appmesh_generated_1 = require_appmesh_generated();
    var mesh_1 = require_mesh();
    var utils_1 = require_utils9();
    var route_1 = require_route2();
    var virtual_router_listener_1 = require_virtual_router_listener();
    var cdk = require_core2();
    var VirtualRouterBase = class extends cdk.Resource {
      addRoute(id, props) {
        return new route_1.Route(this, id, { ...props, routeName: id, mesh: this.mesh, virtualRouter: this });
      }
    };
    var VirtualRouter = class _VirtualRouter extends VirtualRouterBase {
      static fromVirtualRouterArn(scope, id, virtualRouterArn) {
        return new class extends VirtualRouterBase {
          constructor() {
            super(...arguments), this.virtualRouterArn = virtualRouterArn, this.parsedArn = cdk.Fn.split("/", cdk.Stack.of(scope).splitArn(virtualRouterArn, cdk.ArnFormat.SLASH_RESOURCE_NAME).resourceName), this.virtualRouterName = cdk.Fn.select(2, this.parsedArn), this.mesh = mesh_1.Mesh.fromMeshName(this, "Mesh", cdk.Fn.select(0, this.parsedArn));
          }
        }(scope, id);
      }
      static fromVirtualRouterAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_VirtualRouterAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromVirtualRouterAttributes), error;
        }
        return new class extends VirtualRouterBase {
          constructor() {
            super(...arguments), this.virtualRouterName = attrs.virtualRouterName, this.mesh = attrs.mesh, this.virtualRouterArn = cdk.Stack.of(this).formatArn({ service: "appmesh", resource: `mesh/${attrs.mesh.meshName}/virtualRouter`, resourceName: this.virtualRouterName });
          }
        }(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.virtualRouterName || cdk.Lazy.string({ produce: () => cdk.Names.uniqueId(this) }) }), this.listeners = new Array();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_VirtualRouterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _VirtualRouter), error;
        }
        this.mesh = props.mesh, props.listeners && props.listeners.length ? props.listeners.forEach((listener) => this.addListener(listener)) : this.addListener(virtual_router_listener_1.VirtualRouterListener.http());
        const router = new appmesh_generated_1.CfnVirtualRouter(this, "Resource", { virtualRouterName: this.physicalName, meshName: this.mesh.meshName, meshOwner: (0, utils_1.renderMeshOwner)(this.env.account, this.mesh.env.account), spec: { listeners: this.listeners } });
        this.virtualRouterName = this.getResourceNameAttribute(router.attrVirtualRouterName), this.virtualRouterArn = this.getResourceArnAttribute(router.ref, { service: "appmesh", resource: `mesh/${props.mesh.meshName}/virtualRouter`, resourceName: this.physicalName });
      }
      addListener(listener) {
        this.listeners.push(listener.bind(this).listener);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, VirtualRouter[_a] = { fqn: "aws-cdk-lib.aws_appmesh.VirtualRouter", version: "2.80.0" }, exports2.VirtualRouter = VirtualRouter;
  }
});

// node_modules/aws-cdk-lib/aws-appmesh/lib/mesh.js
var require_mesh = __commonJS({
  "node_modules/aws-cdk-lib/aws-appmesh/lib/mesh.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Mesh = exports2.MeshFilterType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var appmesh_generated_1 = require_appmesh_generated();
    var virtual_gateway_1 = require_virtual_gateway();
    var virtual_node_1 = require_virtual_node();
    var virtual_router_1 = require_virtual_router();
    var cdk = require_core2();
    var MeshFilterType;
    (function(MeshFilterType2) {
      MeshFilterType2.ALLOW_ALL = "ALLOW_ALL", MeshFilterType2.DROP_ALL = "DROP_ALL";
    })(MeshFilterType = exports2.MeshFilterType || (exports2.MeshFilterType = {}));
    var MeshBase = class extends cdk.Resource {
      addVirtualRouter(id, props = {}) {
        return new virtual_router_1.VirtualRouter(this, id, { ...props, mesh: this });
      }
      addVirtualNode(id, props = {}) {
        return new virtual_node_1.VirtualNode(this, id, { ...props, mesh: this });
      }
      addVirtualGateway(id, props) {
        return new virtual_gateway_1.VirtualGateway(this, id, { ...props, mesh: this });
      }
    };
    var Mesh = class _Mesh extends MeshBase {
      static fromMeshArn(scope, id, meshArn) {
        const parts = cdk.Stack.of(scope).splitArn(meshArn, cdk.ArnFormat.SLASH_RESOURCE_NAME);
        class Import extends MeshBase {
          constructor() {
            super(...arguments), this.meshName = parts.resourceName || "", this.meshArn = meshArn;
          }
        }
        return new Import(scope, id, { environmentFromArn: meshArn });
      }
      static fromMeshName(scope, id, meshName) {
        const arn = cdk.Stack.of(scope).formatArn({ service: "appmesh", resource: "mesh", resourceName: meshName });
        class Import extends MeshBase {
          constructor() {
            super(...arguments), this.meshName = meshName, this.meshArn = arn;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.meshName || cdk.Lazy.string({ produce: () => cdk.Names.uniqueId(this) }) });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_MeshProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Mesh), error;
        }
        const mesh = new appmesh_generated_1.CfnMesh(this, "Resource", { meshName: this.physicalName, spec: { egressFilter: props.egressFilter ? { type: props.egressFilter } : void 0, serviceDiscovery: props.serviceDiscovery } });
        this.meshName = this.getResourceNameAttribute(mesh.attrMeshName), this.meshArn = this.getResourceArnAttribute(mesh.ref, { service: "appmesh", resource: "mesh", resourceName: this.physicalName });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Mesh[_a] = { fqn: "aws-cdk-lib.aws_appmesh.Mesh", version: "2.80.0" }, exports2.Mesh = Mesh;
  }
});

// node_modules/aws-cdk-lib/aws-appmesh/lib/service-discovery.js
var require_service_discovery = __commonJS({
  "node_modules/aws-cdk-lib/aws-appmesh/lib/service-discovery.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ServiceDiscovery = exports2.DnsResponseType = exports2.IpPreference = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var IpPreference;
    (function(IpPreference2) {
      IpPreference2.IPV4_ONLY = "IPv4_ONLY", IpPreference2.IPV4_PREFERRED = "IPv4_PREFERRED", IpPreference2.IPV6_ONLY = "IPv6_ONLY", IpPreference2.IPV6_PREFERRED = "IPv6_PREFERRED";
    })(IpPreference = exports2.IpPreference || (exports2.IpPreference = {}));
    var DnsResponseType;
    (function(DnsResponseType2) {
      DnsResponseType2.LOAD_BALANCER = "LOADBALANCER", DnsResponseType2.ENDPOINTS = "ENDPOINTS";
    })(DnsResponseType = exports2.DnsResponseType || (exports2.DnsResponseType = {}));
    var ServiceDiscovery = class {
      static dns(hostname, responseType, ipPreference) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_DnsResponseType(responseType), jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_IpPreference(ipPreference);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.dns), error;
        }
        return new DnsServiceDiscovery(hostname, responseType, ipPreference);
      }
      static cloudMap(service, instanceAttributes, ipPreference) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicediscovery_IService(service), jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_IpPreference(ipPreference);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.cloudMap), error;
        }
        return new CloudMapServiceDiscovery(service, instanceAttributes, ipPreference);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ServiceDiscovery[_a] = { fqn: "aws-cdk-lib.aws_appmesh.ServiceDiscovery", version: "2.80.0" }, exports2.ServiceDiscovery = ServiceDiscovery;
    var DnsServiceDiscovery = class extends ServiceDiscovery {
      constructor(hostname, responseType, ipPreference) {
        super(), this.hostname = hostname, this.responseType = responseType, this.ipPreference = ipPreference;
      }
      bind(_scope) {
        return { dns: { hostname: this.hostname, responseType: this.responseType, ipPreference: this.ipPreference } };
      }
    };
    var CloudMapServiceDiscovery = class extends ServiceDiscovery {
      constructor(service, instanceAttributes, ipPreference) {
        super(), this.service = service, this.instanceAttributes = instanceAttributes, this.ipPreference = ipPreference;
      }
      bind(_scope) {
        return { cloudmap: { namespaceName: this.service.namespace.namespaceName, serviceName: this.service.serviceName, attributes: renderAttributes(this.instanceAttributes), ipPreference: this.ipPreference } };
      }
    };
    function renderAttributes(attrs) {
      if (attrs !== void 0)
        return Object.entries(attrs).map(([key, value]) => ({ key, value }));
    }
  }
});

// node_modules/aws-cdk-lib/aws-appmesh/lib/http-route-path-match.js
var require_http_route_path_match = __commonJS({
  "node_modules/aws-cdk-lib/aws-appmesh/lib/http-route-path-match.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.HttpGatewayRoutePathMatch = exports2.HttpRoutePathMatch = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var HttpRoutePathMatch = class {
      static exactly(path) {
        return new HttpRouteWholePathMatch({ exact: path });
      }
      static regex(regex) {
        return new HttpRouteWholePathMatch({ regex });
      }
      static startsWith(prefix) {
        return new HttpRoutePrefixPathMatch(prefix);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, HttpRoutePathMatch[_a] = { fqn: "aws-cdk-lib.aws_appmesh.HttpRoutePathMatch", version: "2.80.0" }, exports2.HttpRoutePathMatch = HttpRoutePathMatch;
    var HttpRoutePrefixPathMatch = class extends HttpRoutePathMatch {
      constructor(prefix) {
        if (super(), this.prefix = prefix, prefix && prefix[0] !== "/")
          throw new Error(`Prefix Path for the match must start with '/', got: ${prefix}`);
      }
      bind(_scope) {
        return { prefixPathMatch: this.prefix };
      }
    };
    var HttpRouteWholePathMatch = class extends HttpRoutePathMatch {
      constructor(match) {
        if (super(), this.match = match, match.exact && match.exact[0] !== "/")
          throw new Error(`Exact Path for the match must start with '/', got: ${match.exact}`);
      }
      bind(_scope) {
        return { wholePathMatch: this.match };
      }
    };
    var HttpGatewayRoutePathMatch = class {
      static startsWith(prefix, rewriteTo) {
        return new HttpGatewayRoutePrefixPathMatch(prefix, rewriteTo);
      }
      static exactly(path, rewriteTo) {
        return new HttpGatewayRouteWholePathMatch({ exact: path }, rewriteTo);
      }
      static regex(regex, rewriteTo) {
        return new HttpGatewayRouteWholePathMatch({ regex }, rewriteTo);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, HttpGatewayRoutePathMatch[_b] = { fqn: "aws-cdk-lib.aws_appmesh.HttpGatewayRoutePathMatch", version: "2.80.0" }, exports2.HttpGatewayRoutePathMatch = HttpGatewayRoutePathMatch;
    var HttpGatewayRoutePrefixPathMatch = class extends HttpGatewayRoutePathMatch {
      constructor(prefixPathMatch, rewriteTo) {
        if (super(), this.prefixPathMatch = prefixPathMatch, this.rewriteTo = rewriteTo, prefixPathMatch[0] !== "/")
          throw new Error(`Prefix path for the match must start with '/', got: ${prefixPathMatch}`);
        if (rewriteTo) {
          if (prefixPathMatch[prefixPathMatch.length - 1] !== "/")
            throw new Error(`When prefix path for the rewrite is specified, prefix path for the match must end with '/', got: ${prefixPathMatch}`);
          if (rewriteTo[0] !== "/" || rewriteTo[rewriteTo.length - 1] !== "/")
            throw new Error(`Prefix path for the rewrite must start and end with '/', got: ${rewriteTo}`);
        }
      }
      bind(_scope) {
        return { prefixPathMatch: this.prefixPathMatch, prefixPathRewrite: this.rewriteTo === void 0 ? void 0 : { defaultPrefix: this.rewriteTo === "" ? "DISABLED" : void 0, value: this.rewriteTo === "" ? void 0 : this.rewriteTo } };
      }
    };
    var HttpGatewayRouteWholePathMatch = class extends HttpGatewayRoutePathMatch {
      constructor(wholePathMatch, exactPathRewrite) {
        if (super(), this.wholePathMatch = wholePathMatch, this.exactPathRewrite = exactPathRewrite, wholePathMatch.exact && wholePathMatch.exact[0] !== "/")
          throw new Error(`Exact Path for the match must start with '/', got: ${wholePathMatch.exact}`);
        if (exactPathRewrite === "")
          throw new Error("Exact Path for the rewrite cannot be empty. Unlike startsWith() method, no automatic rewrite on whole path match");
        if (exactPathRewrite && exactPathRewrite[0] !== "/")
          throw new Error(`Exact Path for the rewrite must start with '/', got: ${exactPathRewrite}`);
      }
      bind(_scope) {
        return { wholePathMatch: this.wholePathMatch, wholePathRewrite: this.exactPathRewrite === void 0 ? void 0 : { exact: this.exactPathRewrite } };
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-appmesh/lib/route-spec.js
var require_route_spec = __commonJS({
  "node_modules/aws-cdk-lib/aws-appmesh/lib/route-spec.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.RouteSpec = exports2.GrpcRetryEvent = exports2.TcpRetryEvent = exports2.HttpRetryEvent = exports2.HttpRouteProtocol = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var http_route_path_match_1 = require_http_route_path_match();
    var utils_1 = require_utils9();
    var shared_interfaces_1 = require_shared_interfaces();
    var HttpRouteProtocol;
    (function(HttpRouteProtocol2) {
      HttpRouteProtocol2.HTTP = "http", HttpRouteProtocol2.HTTPS = "https";
    })(HttpRouteProtocol = exports2.HttpRouteProtocol || (exports2.HttpRouteProtocol = {}));
    var HttpRetryEvent;
    (function(HttpRetryEvent2) {
      HttpRetryEvent2.SERVER_ERROR = "server-error", HttpRetryEvent2.GATEWAY_ERROR = "gateway-error", HttpRetryEvent2.CLIENT_ERROR = "client-error", HttpRetryEvent2.STREAM_ERROR = "stream-error";
    })(HttpRetryEvent = exports2.HttpRetryEvent || (exports2.HttpRetryEvent = {}));
    var TcpRetryEvent;
    (function(TcpRetryEvent2) {
      TcpRetryEvent2.CONNECTION_ERROR = "connection-error";
    })(TcpRetryEvent = exports2.TcpRetryEvent || (exports2.TcpRetryEvent = {}));
    var GrpcRetryEvent;
    (function(GrpcRetryEvent2) {
      GrpcRetryEvent2.CANCELLED = "cancelled", GrpcRetryEvent2.DEADLINE_EXCEEDED = "deadline-exceeded", GrpcRetryEvent2.INTERNAL_ERROR = "internal", GrpcRetryEvent2.RESOURCE_EXHAUSTED = "resource-exhausted", GrpcRetryEvent2.UNAVAILABLE = "unavailable";
    })(GrpcRetryEvent = exports2.GrpcRetryEvent || (exports2.GrpcRetryEvent = {}));
    var RouteSpec = class {
      static http(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_HttpRouteSpecOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.http), error;
        }
        return new HttpRouteSpec(options, shared_interfaces_1.Protocol.HTTP);
      }
      static http2(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_HttpRouteSpecOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.http2), error;
        }
        return new HttpRouteSpec(options, shared_interfaces_1.Protocol.HTTP2);
      }
      static tcp(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_TcpRouteSpecOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.tcp), error;
        }
        return new TcpRouteSpec(options);
      }
      static grpc(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_GrpcRouteSpecOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grpc), error;
        }
        return new GrpcRouteSpec(options);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, RouteSpec[_a] = { fqn: "aws-cdk-lib.aws_appmesh.RouteSpec", version: "2.80.0" }, exports2.RouteSpec = RouteSpec;
    var HttpRouteSpec = class extends RouteSpec {
      constructor(props, protocol) {
        if (super(), this.protocol = protocol, this.match = props.match, this.weightedTargets = props.weightedTargets, this.timeout = props.timeout, this.priority = props.priority, props.retryPolicy) {
          const httpRetryEvents = props.retryPolicy.httpRetryEvents ?? [], tcpRetryEvents = props.retryPolicy.tcpRetryEvents ?? [];
          if (httpRetryEvents.length + tcpRetryEvents.length === 0)
            throw new Error("You must specify one value for at least one of `httpRetryEvents` or `tcpRetryEvents`");
          this.retryPolicy = { ...props.retryPolicy, httpRetryEvents: httpRetryEvents.length > 0 ? httpRetryEvents : void 0, tcpRetryEvents: tcpRetryEvents.length > 0 ? tcpRetryEvents : void 0 };
        }
      }
      bind(scope) {
        const pathMatchConfig = (this.match?.path ?? http_route_path_match_1.HttpRoutePathMatch.startsWith("/")).bind(scope), headers = this.match?.headers, queryParameters = this.match?.queryParameters;
        (0, utils_1.validateHttpMatchArrayLength)(headers, queryParameters);
        const httpConfig = { action: { weightedTargets: renderWeightedTargets(this.weightedTargets) }, match: { prefix: pathMatchConfig.prefixPathMatch, path: pathMatchConfig.wholePathMatch, headers: headers?.map((header) => header.bind(scope).headerMatch), method: this.match?.method, scheme: this.match?.protocol, queryParameters: queryParameters?.map((queryParameter) => queryParameter.bind(scope).queryParameterMatch) }, timeout: renderTimeout(this.timeout), retryPolicy: this.retryPolicy ? renderHttpRetryPolicy(this.retryPolicy) : void 0 };
        return { priority: this.priority, httpRouteSpec: this.protocol === shared_interfaces_1.Protocol.HTTP ? httpConfig : void 0, http2RouteSpec: this.protocol === shared_interfaces_1.Protocol.HTTP2 ? httpConfig : void 0 };
      }
    };
    var TcpRouteSpec = class extends RouteSpec {
      constructor(props) {
        super(), this.weightedTargets = props.weightedTargets, this.timeout = props.timeout, this.priority = props.priority;
      }
      bind(_scope) {
        return { priority: this.priority, tcpRouteSpec: { action: { weightedTargets: renderWeightedTargets(this.weightedTargets) }, timeout: renderTimeout(this.timeout) } };
      }
    };
    var GrpcRouteSpec = class extends RouteSpec {
      constructor(props) {
        if (super(), this.weightedTargets = props.weightedTargets, this.match = props.match, this.timeout = props.timeout, this.priority = props.priority, props.retryPolicy) {
          const grpcRetryEvents = props.retryPolicy.grpcRetryEvents ?? [], httpRetryEvents = props.retryPolicy.httpRetryEvents ?? [], tcpRetryEvents = props.retryPolicy.tcpRetryEvents ?? [];
          if (grpcRetryEvents.length + httpRetryEvents.length + tcpRetryEvents.length === 0)
            throw new Error("You must specify one value for at least one of `grpcRetryEvents`, `httpRetryEvents` or `tcpRetryEvents`");
          this.retryPolicy = { ...props.retryPolicy, grpcRetryEvents: grpcRetryEvents.length > 0 ? grpcRetryEvents : void 0, httpRetryEvents: httpRetryEvents.length > 0 ? httpRetryEvents : void 0, tcpRetryEvents: tcpRetryEvents.length > 0 ? tcpRetryEvents : void 0 };
        }
      }
      bind(scope) {
        const serviceName = this.match.serviceName, methodName = this.match.methodName, metadata = this.match.metadata;
        if ((0, utils_1.validateGrpcRouteMatch)(this.match), (0, utils_1.validateGrpcMatchArrayLength)(metadata), methodName && !serviceName)
          throw new Error("If you specify a method name, you must also specify a service name");
        return { priority: this.priority, grpcRouteSpec: { action: { weightedTargets: renderWeightedTargets(this.weightedTargets) }, match: { serviceName, methodName, metadata: metadata?.map((singleMetadata) => singleMetadata.bind(scope).headerMatch) }, timeout: renderTimeout(this.timeout), retryPolicy: this.retryPolicy ? renderGrpcRetryPolicy(this.retryPolicy) : void 0 } };
      }
    };
    function renderWeightedTargets(weightedTargets) {
      const renderedTargets = [];
      for (const t of weightedTargets)
        renderedTargets.push({ virtualNode: t.virtualNode.virtualNodeName, weight: t.weight == null ? 1 : t.weight });
      return renderedTargets;
    }
    function renderTimeout(timeout) {
      return timeout ? { idle: timeout?.idle !== void 0 ? { unit: "ms", value: timeout?.idle.toMilliseconds() } : void 0, perRequest: timeout?.perRequest !== void 0 ? { unit: "ms", value: timeout?.perRequest.toMilliseconds() } : void 0 } : void 0;
    }
    function renderHttpRetryPolicy(retryPolicy) {
      return { maxRetries: retryPolicy.retryAttempts, perRetryTimeout: { unit: "ms", value: retryPolicy.retryTimeout.toMilliseconds() }, httpRetryEvents: retryPolicy.httpRetryEvents, tcpRetryEvents: retryPolicy.tcpRetryEvents };
    }
    function renderGrpcRetryPolicy(retryPolicy) {
      return { ...renderHttpRetryPolicy(retryPolicy), grpcRetryEvents: retryPolicy.grpcRetryEvents };
    }
  }
});

// node_modules/aws-cdk-lib/aws-appmesh/lib/tls-certificate.js
var require_tls_certificate = __commonJS({
  "node_modules/aws-cdk-lib/aws-appmesh/lib/tls-certificate.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.MutualTlsCertificate = exports2.TlsCertificate = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var TlsCertificate = class {
      static file(certificateChainPath, privateKeyPath) {
        return new FileTlsCertificate(certificateChainPath, privateKeyPath);
      }
      static acm(certificate) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_certificatemanager_ICertificate(certificate);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.acm), error;
        }
        return new AcmTlsCertificate(certificate);
      }
      static sds(secretName) {
        return new SdsTlsCertificate(secretName);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, TlsCertificate[_a] = { fqn: "aws-cdk-lib.aws_appmesh.TlsCertificate", version: "2.80.0" }, exports2.TlsCertificate = TlsCertificate;
    var MutualTlsCertificate = class extends TlsCertificate {
      constructor() {
        super(...arguments), this.differentiator = false;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, MutualTlsCertificate[_b] = { fqn: "aws-cdk-lib.aws_appmesh.MutualTlsCertificate", version: "2.80.0" }, exports2.MutualTlsCertificate = MutualTlsCertificate;
    var AcmTlsCertificate = class extends TlsCertificate {
      constructor(certificate) {
        super(), this.acmCertificate = certificate;
      }
      bind(_scope) {
        return { tlsCertificate: { acm: { certificateArn: this.acmCertificate.certificateArn } } };
      }
    };
    var FileTlsCertificate = class extends MutualTlsCertificate {
      constructor(certificateChainPath, privateKeyPath) {
        super(), this.certificateChain = certificateChainPath, this.privateKey = privateKeyPath;
      }
      bind(_scope) {
        return { tlsCertificate: { file: { certificateChain: this.certificateChain, privateKey: this.privateKey } } };
      }
    };
    var SdsTlsCertificate = class extends MutualTlsCertificate {
      constructor(secretName) {
        super(), this.secretName = secretName;
      }
      bind(_scope) {
        return { tlsCertificate: { sds: { secretName: this.secretName } } };
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-appmesh/lib/virtual-service.js
var require_virtual_service = __commonJS({
  "node_modules/aws-cdk-lib/aws-appmesh/lib/virtual-service.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.VirtualServiceProvider = exports2.VirtualService = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var appmesh_generated_1 = require_appmesh_generated();
    var mesh_1 = require_mesh();
    var utils_1 = require_utils9();
    var cdk = require_core2();
    var VirtualService = class _VirtualService extends cdk.Resource {
      static fromVirtualServiceArn(scope, id, virtualServiceArn) {
        return new class extends cdk.Resource {
          constructor() {
            super(...arguments), this.virtualServiceArn = virtualServiceArn, this.parsedArn = cdk.Fn.split("/", cdk.Stack.of(scope).splitArn(virtualServiceArn, cdk.ArnFormat.SLASH_RESOURCE_NAME).resourceName), this.virtualServiceName = cdk.Fn.select(2, this.parsedArn), this.mesh = mesh_1.Mesh.fromMeshName(this, "Mesh", cdk.Fn.select(0, this.parsedArn));
          }
        }(scope, id);
      }
      static fromVirtualServiceAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_VirtualServiceAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromVirtualServiceAttributes), error;
        }
        return new class extends cdk.Resource {
          constructor() {
            super(...arguments), this.virtualServiceName = attrs.virtualServiceName, this.mesh = attrs.mesh, this.virtualServiceArn = cdk.Stack.of(this).formatArn({ service: "appmesh", resource: `mesh/${attrs.mesh.meshName}/virtualService`, resourceName: this.virtualServiceName });
          }
        }(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.virtualServiceName || cdk.Lazy.string({ produce: () => cdk.Names.uniqueId(this) }) });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_VirtualServiceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _VirtualService), error;
        }
        const providerConfig = props.virtualServiceProvider.bind(this);
        this.mesh = providerConfig.mesh;
        const svc = new appmesh_generated_1.CfnVirtualService(this, "Resource", { meshName: this.mesh.meshName, meshOwner: (0, utils_1.renderMeshOwner)(this.env.account, this.mesh.env.account), virtualServiceName: this.physicalName, spec: { provider: providerConfig.virtualNodeProvider || providerConfig.virtualRouterProvider ? { virtualNode: providerConfig.virtualNodeProvider, virtualRouter: providerConfig.virtualRouterProvider } : void 0 } });
        this.virtualServiceName = this.getResourceNameAttribute(svc.attrVirtualServiceName), this.virtualServiceArn = this.getResourceArnAttribute(svc.ref, { service: "appmesh", resource: `mesh/${this.mesh.meshName}/virtualService`, resourceName: this.physicalName });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, VirtualService[_a] = { fqn: "aws-cdk-lib.aws_appmesh.VirtualService", version: "2.80.0" }, exports2.VirtualService = VirtualService;
    var VirtualServiceProvider = class {
      static virtualNode(virtualNode) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_IVirtualNode(virtualNode);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.virtualNode), error;
        }
        return new VirtualServiceProviderImpl(virtualNode, void 0);
      }
      static virtualRouter(virtualRouter) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_IVirtualRouter(virtualRouter);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.virtualRouter), error;
        }
        return new VirtualServiceProviderImpl(void 0, virtualRouter);
      }
      static none(mesh) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_IMesh(mesh);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.none), error;
        }
        return new VirtualServiceProviderImpl(void 0, void 0, mesh);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, VirtualServiceProvider[_b] = { fqn: "aws-cdk-lib.aws_appmesh.VirtualServiceProvider", version: "2.80.0" }, exports2.VirtualServiceProvider = VirtualServiceProvider;
    var VirtualServiceProviderImpl = class extends VirtualServiceProvider {
      constructor(virtualNode, virtualRouter, mesh) {
        super(), this.virtualNode = virtualNode, this.virtualRouter = virtualRouter;
        const providedMesh = this.virtualNode?.mesh ?? this.virtualRouter?.mesh ?? mesh;
        this.mesh = providedMesh;
      }
      bind(_construct) {
        return { mesh: this.mesh, virtualNodeProvider: this.virtualNode ? { virtualNodeName: this.virtualNode.virtualNodeName } : void 0, virtualRouterProvider: this.virtualRouter ? { virtualRouterName: this.virtualRouter.virtualRouterName } : void 0 };
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-appmesh/lib/virtual-node-listener.js
var require_virtual_node_listener = __commonJS({
  "node_modules/aws-cdk-lib/aws-appmesh/lib/virtual-node-listener.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.VirtualNodeListener = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var utils_1 = require_utils9();
    var shared_interfaces_1 = require_shared_interfaces();
    var VirtualNodeListener = class {
      static http(props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_HttpVirtualNodeListenerOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.http), error;
        }
        return new VirtualNodeListenerImpl(shared_interfaces_1.Protocol.HTTP, props.healthCheck, props.timeout, props.port, props.tls, props.outlierDetection, props.connectionPool);
      }
      static http2(props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_Http2VirtualNodeListenerOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.http2), error;
        }
        return new VirtualNodeListenerImpl(shared_interfaces_1.Protocol.HTTP2, props.healthCheck, props.timeout, props.port, props.tls, props.outlierDetection, props.connectionPool);
      }
      static grpc(props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_GrpcVirtualNodeListenerOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grpc), error;
        }
        return new VirtualNodeListenerImpl(shared_interfaces_1.Protocol.GRPC, props.healthCheck, props.timeout, props.port, props.tls, props.outlierDetection, props.connectionPool);
      }
      static tcp(props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_TcpVirtualNodeListenerOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.tcp), error;
        }
        return new VirtualNodeListenerImpl(shared_interfaces_1.Protocol.TCP, props.healthCheck, props.timeout, props.port, props.tls, props.outlierDetection, props.connectionPool);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, VirtualNodeListener[_a] = { fqn: "aws-cdk-lib.aws_appmesh.VirtualNodeListener", version: "2.80.0" }, exports2.VirtualNodeListener = VirtualNodeListener;
    var VirtualNodeListenerImpl = class extends VirtualNodeListener {
      constructor(protocol, healthCheck, timeout, port = 8080, tls, outlierDetection, connectionPool) {
        super(), this.protocol = protocol, this.healthCheck = healthCheck, this.timeout = timeout, this.port = port, this.tls = tls, this.outlierDetection = outlierDetection, this.connectionPool = connectionPool;
      }
      bind(scope) {
        return { listener: { portMapping: { port: this.port, protocol: this.protocol }, healthCheck: this.healthCheck?.bind(scope, { defaultPort: this.port }).virtualNodeHealthCheck, timeout: this.timeout ? this.renderTimeout(this.timeout) : void 0, tls: (0, utils_1.renderListenerTlsOptions)(scope, this.tls), outlierDetection: this.outlierDetection ? this.renderOutlierDetection(this.outlierDetection) : void 0, connectionPool: this.connectionPool ? this.renderConnectionPool(this.connectionPool) : void 0 } };
      }
      renderTimeout(timeout) {
        return { [this.protocol]: { idle: timeout?.idle !== void 0 ? { unit: "ms", value: timeout?.idle.toMilliseconds() } : void 0, perRequest: timeout?.perRequest !== void 0 ? { unit: "ms", value: timeout?.perRequest.toMilliseconds() } : void 0 } };
      }
      renderOutlierDetection(outlierDetection) {
        return { baseEjectionDuration: { unit: "ms", value: outlierDetection.baseEjectionDuration.toMilliseconds() }, interval: { unit: "ms", value: outlierDetection.interval.toMilliseconds() }, maxEjectionPercent: outlierDetection.maxEjectionPercent, maxServerErrors: outlierDetection.maxServerErrors };
      }
      renderConnectionPool(connectionPool) {
        return { [this.protocol]: { maxRequests: connectionPool?.maxRequests !== void 0 ? connectionPool.maxRequests : void 0, maxConnections: connectionPool?.maxConnections !== void 0 ? connectionPool.maxConnections : void 0, maxPendingRequests: connectionPool?.maxPendingRequests !== void 0 ? connectionPool.maxPendingRequests : void 0 } };
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-appmesh/lib/gateway-route-spec.js
var require_gateway_route_spec = __commonJS({
  "node_modules/aws-cdk-lib/aws-appmesh/lib/gateway-route-spec.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.GatewayRouteSpec = exports2.GatewayRouteHostnameMatch = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var http_route_path_match_1 = require_http_route_path_match();
    var utils_1 = require_utils9();
    var shared_interfaces_1 = require_shared_interfaces();
    var GatewayRouteHostnameMatch = class {
      static exactly(name) {
        return new GatewayRouteHostnameMatchImpl({ exact: name });
      }
      static endsWith(suffix) {
        return new GatewayRouteHostnameMatchImpl({ suffix });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, GatewayRouteHostnameMatch[_a] = { fqn: "aws-cdk-lib.aws_appmesh.GatewayRouteHostnameMatch", version: "2.80.0" }, exports2.GatewayRouteHostnameMatch = GatewayRouteHostnameMatch;
    var GatewayRouteHostnameMatchImpl = class extends GatewayRouteHostnameMatch {
      constructor(matchProperty) {
        super(), this.matchProperty = matchProperty;
      }
      bind(_scope) {
        return { hostnameMatch: this.matchProperty };
      }
    };
    var GatewayRouteSpec = class {
      static http(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_HttpGatewayRouteSpecOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.http), error;
        }
        return new HttpGatewayRouteSpec(options, shared_interfaces_1.Protocol.HTTP);
      }
      static http2(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_HttpGatewayRouteSpecOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.http2), error;
        }
        return new HttpGatewayRouteSpec(options, shared_interfaces_1.Protocol.HTTP2);
      }
      static grpc(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_GrpcGatewayRouteSpecOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grpc), error;
        }
        return new GrpcGatewayRouteSpec(options);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, GatewayRouteSpec[_b] = { fqn: "aws-cdk-lib.aws_appmesh.GatewayRouteSpec", version: "2.80.0" }, exports2.GatewayRouteSpec = GatewayRouteSpec;
    var HttpGatewayRouteSpec = class extends GatewayRouteSpec {
      constructor(options, protocol) {
        super(), this.routeTarget = options.routeTarget, this.routeType = protocol, this.match = options.match, this.priority = options.priority;
      }
      bind(scope) {
        const pathMatchConfig = (this.match?.path ?? http_route_path_match_1.HttpGatewayRoutePathMatch.startsWith("/")).bind(scope), rewriteRequestHostname = this.match?.rewriteRequestHostname, prefixPathRewrite = pathMatchConfig.prefixPathRewrite, wholePathRewrite = pathMatchConfig.wholePathRewrite, httpConfig = { match: { prefix: pathMatchConfig.prefixPathMatch, path: pathMatchConfig.wholePathMatch, hostname: this.match?.hostname?.bind(scope).hostnameMatch, method: this.match?.method, headers: this.match?.headers?.map((header) => header.bind(scope).headerMatch), queryParameters: this.match?.queryParameters?.map((queryParameter) => queryParameter.bind(scope).queryParameterMatch), port: this.match?.port }, action: { target: { virtualService: { virtualServiceName: this.routeTarget.virtualServiceName } }, rewrite: rewriteRequestHostname !== void 0 || prefixPathRewrite || wholePathRewrite ? { hostname: rewriteRequestHostname === void 0 ? void 0 : { defaultTargetHostname: rewriteRequestHostname ? "ENABLED" : "DISABLED" }, prefix: prefixPathRewrite, path: wholePathRewrite } : void 0 } };
        return { priority: this.priority, httpSpecConfig: this.routeType === shared_interfaces_1.Protocol.HTTP ? httpConfig : void 0, http2SpecConfig: this.routeType === shared_interfaces_1.Protocol.HTTP2 ? httpConfig : void 0 };
      }
    };
    var GrpcGatewayRouteSpec = class extends GatewayRouteSpec {
      constructor(options) {
        super(), this.match = options.match, this.routeTarget = options.routeTarget, this.priority = options.priority;
      }
      bind(scope) {
        const metadataMatch = this.match.metadata;
        return (0, utils_1.validateGrpcGatewayRouteMatch)(this.match), (0, utils_1.validateGrpcMatchArrayLength)(metadataMatch), { grpcSpecConfig: { match: { serviceName: this.match.serviceName, hostname: this.match.hostname?.bind(scope).hostnameMatch, metadata: metadataMatch?.map((metadata) => metadata.bind(scope).headerMatch) }, action: { target: { virtualService: { virtualServiceName: this.routeTarget.virtualServiceName } }, rewrite: this.match.rewriteRequestHostname === void 0 ? void 0 : { hostname: { defaultTargetHostname: this.match.rewriteRequestHostname ? "ENABLED" : "DISABLED" } } } }, priority: this.priority };
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-appmesh/lib/health-checks.js
var require_health_checks = __commonJS({
  "node_modules/aws-cdk-lib/aws-appmesh/lib/health-checks.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.HealthCheck = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var shared_interfaces_1 = require_shared_interfaces();
    var cdk = require_core2();
    var HealthCheck = class {
      static http(options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_HttpHealthCheckOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.http), error;
        }
        return new HealthCheckImpl(shared_interfaces_1.Protocol.HTTP, options.healthyThreshold, options.unhealthyThreshold, options.interval, options.timeout, options.path);
      }
      static http2(options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_HttpHealthCheckOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.http2), error;
        }
        return new HealthCheckImpl(shared_interfaces_1.Protocol.HTTP2, options.healthyThreshold, options.unhealthyThreshold, options.interval, options.timeout, options.path);
      }
      static grpc(options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_GrpcHealthCheckOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grpc), error;
        }
        return new HealthCheckImpl(shared_interfaces_1.Protocol.GRPC, options.healthyThreshold, options.unhealthyThreshold, options.interval, options.timeout);
      }
      static tcp(options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appmesh_TcpHealthCheckOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.tcp), error;
        }
        return new HealthCheckImpl(shared_interfaces_1.Protocol.TCP, options.healthyThreshold, options.unhealthyThreshold, options.interval, options.timeout);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, HealthCheck[_a] = { fqn: "aws-cdk-lib.aws_appmesh.HealthCheck", version: "2.80.0" }, exports2.HealthCheck = HealthCheck;
    var HealthCheckImpl = class extends HealthCheck {
      constructor(protocol, healthyThreshold = 2, unhealthyThreshold = 2, interval = cdk.Duration.seconds(5), timeout = cdk.Duration.seconds(2), path) {
        if (super(), this.protocol = protocol, this.healthyThreshold = healthyThreshold, this.unhealthyThreshold = unhealthyThreshold, this.interval = interval, this.timeout = timeout, this.path = path, healthyThreshold < 2 || healthyThreshold > 10)
          throw new Error("healthyThreshold must be between 2 and 10");
        if (unhealthyThreshold < 2 || unhealthyThreshold > 10)
          throw new Error("unhealthyThreshold must be between 2 and 10");
        if (interval.toMilliseconds() < 5e3 || interval.toMilliseconds() > 3e5)
          throw new Error("interval must be between 5 seconds and 300 seconds");
        if (timeout.toMilliseconds() < 2e3 || timeout.toMilliseconds() > 6e4)
          throw new Error("timeout must be between 2 seconds and 60 seconds");
        path === void 0 && (protocol === shared_interfaces_1.Protocol.HTTP || protocol === shared_interfaces_1.Protocol.HTTP2) && (this.path = "/");
      }
      bind(_scope, options) {
        return { virtualNodeHealthCheck: { protocol: this.protocol, healthyThreshold: this.healthyThreshold, unhealthyThreshold: this.unhealthyThreshold, intervalMillis: this.interval.toMilliseconds(), timeoutMillis: this.timeout.toMilliseconds(), path: this.path, port: options.defaultPort }, virtualGatewayHealthCheck: { protocol: this.protocol, healthyThreshold: this.healthyThreshold, unhealthyThreshold: this.unhealthyThreshold, intervalMillis: this.interval.toMilliseconds(), timeoutMillis: this.timeout.toMilliseconds(), path: this.path, port: options.defaultPort } };
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-appmesh/lib/listener-tls-options.js
var require_listener_tls_options = __commonJS({
  "node_modules/aws-cdk-lib/aws-appmesh/lib/listener-tls-options.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.TlsMode = void 0;
    var TlsMode;
    (function(TlsMode2) {
      TlsMode2.STRICT = "STRICT", TlsMode2.PERMISSIVE = "PERMISSIVE", TlsMode2.DISABLED = "DISABLED";
    })(TlsMode = exports2.TlsMode || (exports2.TlsMode = {}));
  }
});

// node_modules/aws-cdk-lib/aws-appmesh/lib/tls-validation.js
var require_tls_validation = __commonJS({
  "node_modules/aws-cdk-lib/aws-appmesh/lib/tls-validation.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SubjectAlternativeNames = exports2.MutualTlsValidationTrust = exports2.TlsValidationTrust = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var TlsValidationTrust = class {
      static file(certificateChain) {
        return new TlsValidationFileTrust(certificateChain);
      }
      static acm(certificateAuthorities) {
        return new TlsValidationAcmTrust(certificateAuthorities);
      }
      static sds(secretName) {
        return new TlsValidationSdsTrust(secretName);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, TlsValidationTrust[_a] = { fqn: "aws-cdk-lib.aws_appmesh.TlsValidationTrust", version: "2.80.0" }, exports2.TlsValidationTrust = TlsValidationTrust;
    var MutualTlsValidationTrust = class extends TlsValidationTrust {
      constructor() {
        super(...arguments), this.differentiator = false;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, MutualTlsValidationTrust[_b] = { fqn: "aws-cdk-lib.aws_appmesh.MutualTlsValidationTrust", version: "2.80.0" }, exports2.MutualTlsValidationTrust = MutualTlsValidationTrust;
    var TlsValidationAcmTrust = class extends TlsValidationTrust {
      constructor(certificateAuthorities) {
        super(), this.certificateAuthorities = certificateAuthorities;
      }
      bind(_scope) {
        if (this.certificateAuthorities.length === 0)
          throw new Error("you must provide at least one Certificate Authority when creating an ACM Trust ClientPolicy");
        return { tlsValidationTrust: { acm: { certificateAuthorityArns: this.certificateAuthorities.map((certificateArn) => certificateArn.certificateAuthorityArn) } } };
      }
    };
    var TlsValidationFileTrust = class extends MutualTlsValidationTrust {
      constructor(certificateChain) {
        super(), this.certificateChain = certificateChain;
      }
      bind(_scope) {
        return { tlsValidationTrust: { file: { certificateChain: this.certificateChain } } };
      }
    };
    var TlsValidationSdsTrust = class extends MutualTlsValidationTrust {
      constructor(secretName) {
        super(), this.secretName = secretName;
      }
      bind(_scope) {
        return { tlsValidationTrust: { sds: { secretName: this.secretName } } };
      }
    };
    var SubjectAlternativeNames = class {
      static matchingExactly(...names) {
        return new SubjectAlternativeNamesImpl({ exact: names });
      }
    };
    _c = JSII_RTTI_SYMBOL_1, SubjectAlternativeNames[_c] = { fqn: "aws-cdk-lib.aws_appmesh.SubjectAlternativeNames", version: "2.80.0" }, exports2.SubjectAlternativeNames = SubjectAlternativeNames;
    var SubjectAlternativeNamesImpl = class extends SubjectAlternativeNames {
      constructor(matchProperty) {
        super(), this.matchProperty = matchProperty;
      }
      bind(_scope) {
        return { subjectAlternativeNamesMatch: this.matchProperty };
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-appmesh/lib/tls-client-policy.js
var require_tls_client_policy = __commonJS({
  "node_modules/aws-cdk-lib/aws-appmesh/lib/tls-client-policy.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-appmesh/lib/http-route-method.js
var require_http_route_method = __commonJS({
  "node_modules/aws-cdk-lib/aws-appmesh/lib/http-route-method.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.HttpRouteMethod = void 0;
    var HttpRouteMethod;
    (function(HttpRouteMethod2) {
      HttpRouteMethod2.GET = "GET", HttpRouteMethod2.HEAD = "HEAD", HttpRouteMethod2.POST = "POST", HttpRouteMethod2.PUT = "PUT", HttpRouteMethod2.DELETE = "DELETE", HttpRouteMethod2.CONNECT = "CONNECT", HttpRouteMethod2.OPTIONS = "OPTIONS", HttpRouteMethod2.TRACE = "TRACE", HttpRouteMethod2.PATCH = "PATCH";
    })(HttpRouteMethod = exports2.HttpRouteMethod || (exports2.HttpRouteMethod = {}));
  }
});

// node_modules/aws-cdk-lib/aws-appmesh/lib/header-match.js
var require_header_match = __commonJS({
  "node_modules/aws-cdk-lib/aws-appmesh/lib/header-match.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.HeaderMatch = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var HeaderMatch = class {
      static valueIs(headerName, headerValue) {
        return new HeaderMatchImpl(headerName, false, { exact: headerValue });
      }
      static valueIsNot(headerName, headerValue) {
        return new HeaderMatchImpl(headerName, true, { exact: headerValue });
      }
      static valueStartsWith(headerName, prefix) {
        return new HeaderMatchImpl(headerName, false, { prefix });
      }
      static valueDoesNotStartWith(headerName, prefix) {
        return new HeaderMatchImpl(headerName, true, { prefix });
      }
      static valueEndsWith(headerName, suffix) {
        return new HeaderMatchImpl(headerName, false, { suffix });
      }
      static valueDoesNotEndWith(headerName, suffix) {
        return new HeaderMatchImpl(headerName, true, { suffix });
      }
      static valueMatchesRegex(headerName, regex) {
        return new HeaderMatchImpl(headerName, false, { regex });
      }
      static valueDoesNotMatchRegex(headerName, regex) {
        return new HeaderMatchImpl(headerName, true, { regex });
      }
      static valuesIsInRange(headerName, start, end) {
        return new HeaderMatchImpl(headerName, false, { range: { start, end } });
      }
      static valuesIsNotInRange(headerName, start, end) {
        return new HeaderMatchImpl(headerName, true, { range: { start, end } });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, HeaderMatch[_a] = { fqn: "aws-cdk-lib.aws_appmesh.HeaderMatch", version: "2.80.0" }, exports2.HeaderMatch = HeaderMatch;
    var HeaderMatchImpl = class extends HeaderMatch {
      constructor(headerName, invert, matchProperty) {
        super(), this.headerName = headerName, this.invert = invert, this.matchProperty = matchProperty;
      }
      bind(_scope) {
        return { headerMatch: { name: this.headerName, invert: this.invert, match: this.matchProperty } };
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-appmesh/lib/query-parameter-match.js
var require_query_parameter_match = __commonJS({
  "node_modules/aws-cdk-lib/aws-appmesh/lib/query-parameter-match.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.QueryParameterMatch = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var QueryParameterMatch = class {
      static valueIs(queryParameterName, queryParameterValue) {
        return new QueryParameterMatchImpl(queryParameterName, { exact: queryParameterValue });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, QueryParameterMatch[_a] = { fqn: "aws-cdk-lib.aws_appmesh.QueryParameterMatch", version: "2.80.0" }, exports2.QueryParameterMatch = QueryParameterMatch;
    var QueryParameterMatchImpl = class extends QueryParameterMatch {
      constructor(queryParameterName, matchProperty) {
        super(), this.queryParameterName = queryParameterName, this.matchProperty = matchProperty;
      }
      bind(_scope) {
        return { queryParameterMatch: { match: this.matchProperty, name: this.queryParameterName } };
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-appmesh/lib/index.js
var require_lib45 = __commonJS({
  "node_modules/aws-cdk-lib/aws-appmesh/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_appmesh_generated(), exports2), __exportStar(require_mesh(), exports2), __exportStar(require_route2(), exports2), __exportStar(require_service_discovery(), exports2), __exportStar(require_route_spec(), exports2), __exportStar(require_shared_interfaces(), exports2), __exportStar(require_tls_certificate(), exports2), __exportStar(require_virtual_node(), exports2), __exportStar(require_virtual_router(), exports2), __exportStar(require_virtual_router_listener(), exports2), __exportStar(require_virtual_service(), exports2), __exportStar(require_virtual_node_listener(), exports2), __exportStar(require_virtual_gateway(), exports2), __exportStar(require_virtual_gateway_listener(), exports2), __exportStar(require_gateway_route(), exports2), __exportStar(require_gateway_route_spec(), exports2), __exportStar(require_health_checks(), exports2), __exportStar(require_listener_tls_options(), exports2), __exportStar(require_tls_validation(), exports2), __exportStar(require_tls_client_policy(), exports2), __exportStar(require_http_route_method(), exports2), __exportStar(require_header_match(), exports2), __exportStar(require_query_parameter_match(), exports2), __exportStar(require_http_route_path_match(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-appmesh/index.js
var require_aws_appmesh = __commonJS({
  "node_modules/aws-cdk-lib/aws-appmesh/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib45(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-apprunner/lib/apprunner.generated.js
var require_apprunner_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-apprunner/lib/apprunner.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnVpcIngressConnection = exports2.CfnVpcConnector = exports2.CfnService = exports2.CfnObservabilityConfiguration = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnObservabilityConfigurationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("observabilityConfigurationName", cdk.validateString)(properties.observabilityConfigurationName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("traceConfiguration", CfnObservabilityConfiguration_TraceConfigurationPropertyValidator)(properties.traceConfiguration)), errors.wrap('supplied properties not correct for "CfnObservabilityConfigurationProps"');
    }
    function cfnObservabilityConfigurationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnObservabilityConfigurationPropsValidator(properties).assertSuccess(), { ObservabilityConfigurationName: cdk.stringToCloudFormation(properties.observabilityConfigurationName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TraceConfiguration: cfnObservabilityConfigurationTraceConfigurationPropertyToCloudFormation(properties.traceConfiguration) }) : properties;
    }
    function CfnObservabilityConfigurationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("observabilityConfigurationName", "ObservabilityConfigurationName", properties.ObservabilityConfigurationName != null ? cfn_parse.FromCloudFormation.getString(properties.ObservabilityConfigurationName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("traceConfiguration", "TraceConfiguration", properties.TraceConfiguration != null ? CfnObservabilityConfigurationTraceConfigurationPropertyFromCloudFormation(properties.TraceConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnObservabilityConfiguration = class _CfnObservabilityConfiguration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnObservabilityConfigurationPropsFromCloudFormation(resourceProperties), ret = new _CfnObservabilityConfiguration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnObservabilityConfiguration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apprunner_CfnObservabilityConfigurationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnObservabilityConfiguration), error;
        }
        this.attrLatest = this.getAtt("Latest", cdk.ResolutionTypeHint.STRING), this.attrObservabilityConfigurationArn = cdk.Token.asString(this.getAtt("ObservabilityConfigurationArn", cdk.ResolutionTypeHint.STRING)), this.attrObservabilityConfigurationRevision = cdk.Token.asNumber(this.getAtt("ObservabilityConfigurationRevision", cdk.ResolutionTypeHint.NUMBER)), this.observabilityConfigurationName = props.observabilityConfigurationName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::AppRunner::ObservabilityConfiguration", props.tags, { tagPropertyName: "tags" }), this.traceConfiguration = props.traceConfiguration;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnObservabilityConfiguration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { observabilityConfigurationName: this.observabilityConfigurationName, tags: this.tags.renderTags(), traceConfiguration: this.traceConfiguration };
      }
      renderProperties(props) {
        return cfnObservabilityConfigurationPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnObservabilityConfiguration[_a] = { fqn: "aws-cdk-lib.aws_apprunner.CfnObservabilityConfiguration", version: "2.80.0" }, CfnObservabilityConfiguration.CFN_RESOURCE_TYPE_NAME = "AWS::AppRunner::ObservabilityConfiguration", exports2.CfnObservabilityConfiguration = CfnObservabilityConfiguration;
    function CfnObservabilityConfiguration_TraceConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("vendor", cdk.requiredValidator)(properties.vendor)), errors.collect(cdk.propertyValidator("vendor", cdk.validateString)(properties.vendor)), errors.wrap('supplied properties not correct for "TraceConfigurationProperty"');
    }
    function cfnObservabilityConfigurationTraceConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnObservabilityConfiguration_TraceConfigurationPropertyValidator(properties).assertSuccess(), { Vendor: cdk.stringToCloudFormation(properties.vendor) }) : properties;
    }
    function CfnObservabilityConfigurationTraceConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("vendor", "Vendor", cfn_parse.FromCloudFormation.getString(properties.Vendor)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnServicePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoScalingConfigurationArn", cdk.validateString)(properties.autoScalingConfigurationArn)), errors.collect(cdk.propertyValidator("encryptionConfiguration", CfnService_EncryptionConfigurationPropertyValidator)(properties.encryptionConfiguration)), errors.collect(cdk.propertyValidator("healthCheckConfiguration", CfnService_HealthCheckConfigurationPropertyValidator)(properties.healthCheckConfiguration)), errors.collect(cdk.propertyValidator("instanceConfiguration", CfnService_InstanceConfigurationPropertyValidator)(properties.instanceConfiguration)), errors.collect(cdk.propertyValidator("networkConfiguration", CfnService_NetworkConfigurationPropertyValidator)(properties.networkConfiguration)), errors.collect(cdk.propertyValidator("observabilityConfiguration", CfnService_ServiceObservabilityConfigurationPropertyValidator)(properties.observabilityConfiguration)), errors.collect(cdk.propertyValidator("serviceName", cdk.validateString)(properties.serviceName)), errors.collect(cdk.propertyValidator("sourceConfiguration", cdk.requiredValidator)(properties.sourceConfiguration)), errors.collect(cdk.propertyValidator("sourceConfiguration", CfnService_SourceConfigurationPropertyValidator)(properties.sourceConfiguration)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnServiceProps"');
    }
    function cfnServicePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnServicePropsValidator(properties).assertSuccess(), { SourceConfiguration: cfnServiceSourceConfigurationPropertyToCloudFormation(properties.sourceConfiguration), AutoScalingConfigurationArn: cdk.stringToCloudFormation(properties.autoScalingConfigurationArn), EncryptionConfiguration: cfnServiceEncryptionConfigurationPropertyToCloudFormation(properties.encryptionConfiguration), HealthCheckConfiguration: cfnServiceHealthCheckConfigurationPropertyToCloudFormation(properties.healthCheckConfiguration), InstanceConfiguration: cfnServiceInstanceConfigurationPropertyToCloudFormation(properties.instanceConfiguration), NetworkConfiguration: cfnServiceNetworkConfigurationPropertyToCloudFormation(properties.networkConfiguration), ObservabilityConfiguration: cfnServiceServiceObservabilityConfigurationPropertyToCloudFormation(properties.observabilityConfiguration), ServiceName: cdk.stringToCloudFormation(properties.serviceName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnServicePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sourceConfiguration", "SourceConfiguration", CfnServiceSourceConfigurationPropertyFromCloudFormation(properties.SourceConfiguration)), ret.addPropertyResult("autoScalingConfigurationArn", "AutoScalingConfigurationArn", properties.AutoScalingConfigurationArn != null ? cfn_parse.FromCloudFormation.getString(properties.AutoScalingConfigurationArn) : void 0), ret.addPropertyResult("encryptionConfiguration", "EncryptionConfiguration", properties.EncryptionConfiguration != null ? CfnServiceEncryptionConfigurationPropertyFromCloudFormation(properties.EncryptionConfiguration) : void 0), ret.addPropertyResult("healthCheckConfiguration", "HealthCheckConfiguration", properties.HealthCheckConfiguration != null ? CfnServiceHealthCheckConfigurationPropertyFromCloudFormation(properties.HealthCheckConfiguration) : void 0), ret.addPropertyResult("instanceConfiguration", "InstanceConfiguration", properties.InstanceConfiguration != null ? CfnServiceInstanceConfigurationPropertyFromCloudFormation(properties.InstanceConfiguration) : void 0), ret.addPropertyResult("networkConfiguration", "NetworkConfiguration", properties.NetworkConfiguration != null ? CfnServiceNetworkConfigurationPropertyFromCloudFormation(properties.NetworkConfiguration) : void 0), ret.addPropertyResult("observabilityConfiguration", "ObservabilityConfiguration", properties.ObservabilityConfiguration != null ? CfnServiceServiceObservabilityConfigurationPropertyFromCloudFormation(properties.ObservabilityConfiguration) : void 0), ret.addPropertyResult("serviceName", "ServiceName", properties.ServiceName != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnService = class _CfnService extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnServicePropsFromCloudFormation(resourceProperties), ret = new _CfnService(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnService.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apprunner_CfnServiceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnService), error;
        }
        cdk.requireProperty(props, "sourceConfiguration", this), this.attrServiceArn = cdk.Token.asString(this.getAtt("ServiceArn", cdk.ResolutionTypeHint.STRING)), this.attrServiceId = cdk.Token.asString(this.getAtt("ServiceId", cdk.ResolutionTypeHint.STRING)), this.attrServiceUrl = cdk.Token.asString(this.getAtt("ServiceUrl", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.sourceConfiguration = props.sourceConfiguration, this.autoScalingConfigurationArn = props.autoScalingConfigurationArn, this.encryptionConfiguration = props.encryptionConfiguration, this.healthCheckConfiguration = props.healthCheckConfiguration, this.instanceConfiguration = props.instanceConfiguration, this.networkConfiguration = props.networkConfiguration, this.observabilityConfiguration = props.observabilityConfiguration, this.serviceName = props.serviceName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::AppRunner::Service", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnService.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { sourceConfiguration: this.sourceConfiguration, autoScalingConfigurationArn: this.autoScalingConfigurationArn, encryptionConfiguration: this.encryptionConfiguration, healthCheckConfiguration: this.healthCheckConfiguration, instanceConfiguration: this.instanceConfiguration, networkConfiguration: this.networkConfiguration, observabilityConfiguration: this.observabilityConfiguration, serviceName: this.serviceName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnServicePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnService[_b] = { fqn: "aws-cdk-lib.aws_apprunner.CfnService", version: "2.80.0" }, CfnService.CFN_RESOURCE_TYPE_NAME = "AWS::AppRunner::Service", exports2.CfnService = CfnService;
    function CfnService_AuthenticationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessRoleArn", cdk.validateString)(properties.accessRoleArn)), errors.collect(cdk.propertyValidator("connectionArn", cdk.validateString)(properties.connectionArn)), errors.wrap('supplied properties not correct for "AuthenticationConfigurationProperty"');
    }
    function cfnServiceAuthenticationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_AuthenticationConfigurationPropertyValidator(properties).assertSuccess(), { AccessRoleArn: cdk.stringToCloudFormation(properties.accessRoleArn), ConnectionArn: cdk.stringToCloudFormation(properties.connectionArn) }) : properties;
    }
    function CfnServiceAuthenticationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessRoleArn", "AccessRoleArn", properties.AccessRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.AccessRoleArn) : void 0), ret.addPropertyResult("connectionArn", "ConnectionArn", properties.ConnectionArn != null ? cfn_parse.FromCloudFormation.getString(properties.ConnectionArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_CodeConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("codeConfigurationValues", CfnService_CodeConfigurationValuesPropertyValidator)(properties.codeConfigurationValues)), errors.collect(cdk.propertyValidator("configurationSource", cdk.requiredValidator)(properties.configurationSource)), errors.collect(cdk.propertyValidator("configurationSource", cdk.validateString)(properties.configurationSource)), errors.wrap('supplied properties not correct for "CodeConfigurationProperty"');
    }
    function cfnServiceCodeConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_CodeConfigurationPropertyValidator(properties).assertSuccess(), { CodeConfigurationValues: cfnServiceCodeConfigurationValuesPropertyToCloudFormation(properties.codeConfigurationValues), ConfigurationSource: cdk.stringToCloudFormation(properties.configurationSource) }) : properties;
    }
    function CfnServiceCodeConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("codeConfigurationValues", "CodeConfigurationValues", properties.CodeConfigurationValues != null ? CfnServiceCodeConfigurationValuesPropertyFromCloudFormation(properties.CodeConfigurationValues) : void 0), ret.addPropertyResult("configurationSource", "ConfigurationSource", cfn_parse.FromCloudFormation.getString(properties.ConfigurationSource)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_CodeConfigurationValuesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("buildCommand", cdk.validateString)(properties.buildCommand)), errors.collect(cdk.propertyValidator("port", cdk.validateString)(properties.port)), errors.collect(cdk.propertyValidator("runtime", cdk.requiredValidator)(properties.runtime)), errors.collect(cdk.propertyValidator("runtime", cdk.validateString)(properties.runtime)), errors.collect(cdk.propertyValidator("runtimeEnvironmentSecrets", cdk.listValidator(CfnService_KeyValuePairPropertyValidator))(properties.runtimeEnvironmentSecrets)), errors.collect(cdk.propertyValidator("runtimeEnvironmentVariables", cdk.listValidator(CfnService_KeyValuePairPropertyValidator))(properties.runtimeEnvironmentVariables)), errors.collect(cdk.propertyValidator("startCommand", cdk.validateString)(properties.startCommand)), errors.wrap('supplied properties not correct for "CodeConfigurationValuesProperty"');
    }
    function cfnServiceCodeConfigurationValuesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_CodeConfigurationValuesPropertyValidator(properties).assertSuccess(), { BuildCommand: cdk.stringToCloudFormation(properties.buildCommand), Port: cdk.stringToCloudFormation(properties.port), Runtime: cdk.stringToCloudFormation(properties.runtime), RuntimeEnvironmentSecrets: cdk.listMapper(cfnServiceKeyValuePairPropertyToCloudFormation)(properties.runtimeEnvironmentSecrets), RuntimeEnvironmentVariables: cdk.listMapper(cfnServiceKeyValuePairPropertyToCloudFormation)(properties.runtimeEnvironmentVariables), StartCommand: cdk.stringToCloudFormation(properties.startCommand) }) : properties;
    }
    function CfnServiceCodeConfigurationValuesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("buildCommand", "BuildCommand", properties.BuildCommand != null ? cfn_parse.FromCloudFormation.getString(properties.BuildCommand) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getString(properties.Port) : void 0), ret.addPropertyResult("runtime", "Runtime", cfn_parse.FromCloudFormation.getString(properties.Runtime)), ret.addPropertyResult("runtimeEnvironmentSecrets", "RuntimeEnvironmentSecrets", properties.RuntimeEnvironmentSecrets != null ? cfn_parse.FromCloudFormation.getArray(CfnServiceKeyValuePairPropertyFromCloudFormation)(properties.RuntimeEnvironmentSecrets) : void 0), ret.addPropertyResult("runtimeEnvironmentVariables", "RuntimeEnvironmentVariables", properties.RuntimeEnvironmentVariables != null ? cfn_parse.FromCloudFormation.getArray(CfnServiceKeyValuePairPropertyFromCloudFormation)(properties.RuntimeEnvironmentVariables) : void 0), ret.addPropertyResult("startCommand", "StartCommand", properties.StartCommand != null ? cfn_parse.FromCloudFormation.getString(properties.StartCommand) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_CodeRepositoryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("codeConfiguration", CfnService_CodeConfigurationPropertyValidator)(properties.codeConfiguration)), errors.collect(cdk.propertyValidator("repositoryUrl", cdk.requiredValidator)(properties.repositoryUrl)), errors.collect(cdk.propertyValidator("repositoryUrl", cdk.validateString)(properties.repositoryUrl)), errors.collect(cdk.propertyValidator("sourceCodeVersion", cdk.requiredValidator)(properties.sourceCodeVersion)), errors.collect(cdk.propertyValidator("sourceCodeVersion", CfnService_SourceCodeVersionPropertyValidator)(properties.sourceCodeVersion)), errors.wrap('supplied properties not correct for "CodeRepositoryProperty"');
    }
    function cfnServiceCodeRepositoryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_CodeRepositoryPropertyValidator(properties).assertSuccess(), { CodeConfiguration: cfnServiceCodeConfigurationPropertyToCloudFormation(properties.codeConfiguration), RepositoryUrl: cdk.stringToCloudFormation(properties.repositoryUrl), SourceCodeVersion: cfnServiceSourceCodeVersionPropertyToCloudFormation(properties.sourceCodeVersion) }) : properties;
    }
    function CfnServiceCodeRepositoryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("codeConfiguration", "CodeConfiguration", properties.CodeConfiguration != null ? CfnServiceCodeConfigurationPropertyFromCloudFormation(properties.CodeConfiguration) : void 0), ret.addPropertyResult("repositoryUrl", "RepositoryUrl", cfn_parse.FromCloudFormation.getString(properties.RepositoryUrl)), ret.addPropertyResult("sourceCodeVersion", "SourceCodeVersion", CfnServiceSourceCodeVersionPropertyFromCloudFormation(properties.SourceCodeVersion)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_EgressConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("egressType", cdk.requiredValidator)(properties.egressType)), errors.collect(cdk.propertyValidator("egressType", cdk.validateString)(properties.egressType)), errors.collect(cdk.propertyValidator("vpcConnectorArn", cdk.validateString)(properties.vpcConnectorArn)), errors.wrap('supplied properties not correct for "EgressConfigurationProperty"');
    }
    function cfnServiceEgressConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_EgressConfigurationPropertyValidator(properties).assertSuccess(), { EgressType: cdk.stringToCloudFormation(properties.egressType), VpcConnectorArn: cdk.stringToCloudFormation(properties.vpcConnectorArn) }) : properties;
    }
    function CfnServiceEgressConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("egressType", "EgressType", cfn_parse.FromCloudFormation.getString(properties.EgressType)), ret.addPropertyResult("vpcConnectorArn", "VpcConnectorArn", properties.VpcConnectorArn != null ? cfn_parse.FromCloudFormation.getString(properties.VpcConnectorArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_EncryptionConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kmsKey", cdk.requiredValidator)(properties.kmsKey)), errors.collect(cdk.propertyValidator("kmsKey", cdk.validateString)(properties.kmsKey)), errors.wrap('supplied properties not correct for "EncryptionConfigurationProperty"');
    }
    function cfnServiceEncryptionConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_EncryptionConfigurationPropertyValidator(properties).assertSuccess(), { KmsKey: cdk.stringToCloudFormation(properties.kmsKey) }) : properties;
    }
    function CfnServiceEncryptionConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsKey", "KmsKey", cfn_parse.FromCloudFormation.getString(properties.KmsKey)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_HealthCheckConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("healthyThreshold", cdk.validateNumber)(properties.healthyThreshold)), errors.collect(cdk.propertyValidator("interval", cdk.validateNumber)(properties.interval)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.collect(cdk.propertyValidator("timeout", cdk.validateNumber)(properties.timeout)), errors.collect(cdk.propertyValidator("unhealthyThreshold", cdk.validateNumber)(properties.unhealthyThreshold)), errors.wrap('supplied properties not correct for "HealthCheckConfigurationProperty"');
    }
    function cfnServiceHealthCheckConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_HealthCheckConfigurationPropertyValidator(properties).assertSuccess(), { HealthyThreshold: cdk.numberToCloudFormation(properties.healthyThreshold), Interval: cdk.numberToCloudFormation(properties.interval), Path: cdk.stringToCloudFormation(properties.path), Protocol: cdk.stringToCloudFormation(properties.protocol), Timeout: cdk.numberToCloudFormation(properties.timeout), UnhealthyThreshold: cdk.numberToCloudFormation(properties.unhealthyThreshold) }) : properties;
    }
    function CfnServiceHealthCheckConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("healthyThreshold", "HealthyThreshold", properties.HealthyThreshold != null ? cfn_parse.FromCloudFormation.getNumber(properties.HealthyThreshold) : void 0), ret.addPropertyResult("interval", "Interval", properties.Interval != null ? cfn_parse.FromCloudFormation.getNumber(properties.Interval) : void 0), ret.addPropertyResult("path", "Path", properties.Path != null ? cfn_parse.FromCloudFormation.getString(properties.Path) : void 0), ret.addPropertyResult("protocol", "Protocol", properties.Protocol != null ? cfn_parse.FromCloudFormation.getString(properties.Protocol) : void 0), ret.addPropertyResult("timeout", "Timeout", properties.Timeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.Timeout) : void 0), ret.addPropertyResult("unhealthyThreshold", "UnhealthyThreshold", properties.UnhealthyThreshold != null ? cfn_parse.FromCloudFormation.getNumber(properties.UnhealthyThreshold) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_ImageConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("port", cdk.validateString)(properties.port)), errors.collect(cdk.propertyValidator("runtimeEnvironmentSecrets", cdk.listValidator(CfnService_KeyValuePairPropertyValidator))(properties.runtimeEnvironmentSecrets)), errors.collect(cdk.propertyValidator("runtimeEnvironmentVariables", cdk.listValidator(CfnService_KeyValuePairPropertyValidator))(properties.runtimeEnvironmentVariables)), errors.collect(cdk.propertyValidator("startCommand", cdk.validateString)(properties.startCommand)), errors.wrap('supplied properties not correct for "ImageConfigurationProperty"');
    }
    function cfnServiceImageConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_ImageConfigurationPropertyValidator(properties).assertSuccess(), { Port: cdk.stringToCloudFormation(properties.port), RuntimeEnvironmentSecrets: cdk.listMapper(cfnServiceKeyValuePairPropertyToCloudFormation)(properties.runtimeEnvironmentSecrets), RuntimeEnvironmentVariables: cdk.listMapper(cfnServiceKeyValuePairPropertyToCloudFormation)(properties.runtimeEnvironmentVariables), StartCommand: cdk.stringToCloudFormation(properties.startCommand) }) : properties;
    }
    function CfnServiceImageConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getString(properties.Port) : void 0), ret.addPropertyResult("runtimeEnvironmentSecrets", "RuntimeEnvironmentSecrets", properties.RuntimeEnvironmentSecrets != null ? cfn_parse.FromCloudFormation.getArray(CfnServiceKeyValuePairPropertyFromCloudFormation)(properties.RuntimeEnvironmentSecrets) : void 0), ret.addPropertyResult("runtimeEnvironmentVariables", "RuntimeEnvironmentVariables", properties.RuntimeEnvironmentVariables != null ? cfn_parse.FromCloudFormation.getArray(CfnServiceKeyValuePairPropertyFromCloudFormation)(properties.RuntimeEnvironmentVariables) : void 0), ret.addPropertyResult("startCommand", "StartCommand", properties.StartCommand != null ? cfn_parse.FromCloudFormation.getString(properties.StartCommand) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_ImageRepositoryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("imageConfiguration", CfnService_ImageConfigurationPropertyValidator)(properties.imageConfiguration)), errors.collect(cdk.propertyValidator("imageIdentifier", cdk.requiredValidator)(properties.imageIdentifier)), errors.collect(cdk.propertyValidator("imageIdentifier", cdk.validateString)(properties.imageIdentifier)), errors.collect(cdk.propertyValidator("imageRepositoryType", cdk.requiredValidator)(properties.imageRepositoryType)), errors.collect(cdk.propertyValidator("imageRepositoryType", cdk.validateString)(properties.imageRepositoryType)), errors.wrap('supplied properties not correct for "ImageRepositoryProperty"');
    }
    function cfnServiceImageRepositoryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_ImageRepositoryPropertyValidator(properties).assertSuccess(), { ImageConfiguration: cfnServiceImageConfigurationPropertyToCloudFormation(properties.imageConfiguration), ImageIdentifier: cdk.stringToCloudFormation(properties.imageIdentifier), ImageRepositoryType: cdk.stringToCloudFormation(properties.imageRepositoryType) }) : properties;
    }
    function CfnServiceImageRepositoryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("imageConfiguration", "ImageConfiguration", properties.ImageConfiguration != null ? CfnServiceImageConfigurationPropertyFromCloudFormation(properties.ImageConfiguration) : void 0), ret.addPropertyResult("imageIdentifier", "ImageIdentifier", cfn_parse.FromCloudFormation.getString(properties.ImageIdentifier)), ret.addPropertyResult("imageRepositoryType", "ImageRepositoryType", cfn_parse.FromCloudFormation.getString(properties.ImageRepositoryType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_IngressConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("isPubliclyAccessible", cdk.requiredValidator)(properties.isPubliclyAccessible)), errors.collect(cdk.propertyValidator("isPubliclyAccessible", cdk.validateBoolean)(properties.isPubliclyAccessible)), errors.wrap('supplied properties not correct for "IngressConfigurationProperty"');
    }
    function cfnServiceIngressConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_IngressConfigurationPropertyValidator(properties).assertSuccess(), { IsPubliclyAccessible: cdk.booleanToCloudFormation(properties.isPubliclyAccessible) }) : properties;
    }
    function CfnServiceIngressConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("isPubliclyAccessible", "IsPubliclyAccessible", cfn_parse.FromCloudFormation.getBoolean(properties.IsPubliclyAccessible)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_InstanceConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cpu", cdk.validateString)(properties.cpu)), errors.collect(cdk.propertyValidator("instanceRoleArn", cdk.validateString)(properties.instanceRoleArn)), errors.collect(cdk.propertyValidator("memory", cdk.validateString)(properties.memory)), errors.wrap('supplied properties not correct for "InstanceConfigurationProperty"');
    }
    function cfnServiceInstanceConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_InstanceConfigurationPropertyValidator(properties).assertSuccess(), { Cpu: cdk.stringToCloudFormation(properties.cpu), InstanceRoleArn: cdk.stringToCloudFormation(properties.instanceRoleArn), Memory: cdk.stringToCloudFormation(properties.memory) }) : properties;
    }
    function CfnServiceInstanceConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cpu", "Cpu", properties.Cpu != null ? cfn_parse.FromCloudFormation.getString(properties.Cpu) : void 0), ret.addPropertyResult("instanceRoleArn", "InstanceRoleArn", properties.InstanceRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceRoleArn) : void 0), ret.addPropertyResult("memory", "Memory", properties.Memory != null ? cfn_parse.FromCloudFormation.getString(properties.Memory) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_KeyValuePairPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "KeyValuePairProperty"');
    }
    function cfnServiceKeyValuePairPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_KeyValuePairPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnServiceKeyValuePairPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_NetworkConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("egressConfiguration", CfnService_EgressConfigurationPropertyValidator)(properties.egressConfiguration)), errors.collect(cdk.propertyValidator("ingressConfiguration", CfnService_IngressConfigurationPropertyValidator)(properties.ingressConfiguration)), errors.wrap('supplied properties not correct for "NetworkConfigurationProperty"');
    }
    function cfnServiceNetworkConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_NetworkConfigurationPropertyValidator(properties).assertSuccess(), { EgressConfiguration: cfnServiceEgressConfigurationPropertyToCloudFormation(properties.egressConfiguration), IngressConfiguration: cfnServiceIngressConfigurationPropertyToCloudFormation(properties.ingressConfiguration) }) : properties;
    }
    function CfnServiceNetworkConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("egressConfiguration", "EgressConfiguration", properties.EgressConfiguration != null ? CfnServiceEgressConfigurationPropertyFromCloudFormation(properties.EgressConfiguration) : void 0), ret.addPropertyResult("ingressConfiguration", "IngressConfiguration", properties.IngressConfiguration != null ? CfnServiceIngressConfigurationPropertyFromCloudFormation(properties.IngressConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_ServiceObservabilityConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("observabilityConfigurationArn", cdk.validateString)(properties.observabilityConfigurationArn)), errors.collect(cdk.propertyValidator("observabilityEnabled", cdk.requiredValidator)(properties.observabilityEnabled)), errors.collect(cdk.propertyValidator("observabilityEnabled", cdk.validateBoolean)(properties.observabilityEnabled)), errors.wrap('supplied properties not correct for "ServiceObservabilityConfigurationProperty"');
    }
    function cfnServiceServiceObservabilityConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_ServiceObservabilityConfigurationPropertyValidator(properties).assertSuccess(), { ObservabilityConfigurationArn: cdk.stringToCloudFormation(properties.observabilityConfigurationArn), ObservabilityEnabled: cdk.booleanToCloudFormation(properties.observabilityEnabled) }) : properties;
    }
    function CfnServiceServiceObservabilityConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("observabilityConfigurationArn", "ObservabilityConfigurationArn", properties.ObservabilityConfigurationArn != null ? cfn_parse.FromCloudFormation.getString(properties.ObservabilityConfigurationArn) : void 0), ret.addPropertyResult("observabilityEnabled", "ObservabilityEnabled", cfn_parse.FromCloudFormation.getBoolean(properties.ObservabilityEnabled)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_SourceCodeVersionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "SourceCodeVersionProperty"');
    }
    function cfnServiceSourceCodeVersionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_SourceCodeVersionPropertyValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnServiceSourceCodeVersionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_SourceConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authenticationConfiguration", CfnService_AuthenticationConfigurationPropertyValidator)(properties.authenticationConfiguration)), errors.collect(cdk.propertyValidator("autoDeploymentsEnabled", cdk.validateBoolean)(properties.autoDeploymentsEnabled)), errors.collect(cdk.propertyValidator("codeRepository", CfnService_CodeRepositoryPropertyValidator)(properties.codeRepository)), errors.collect(cdk.propertyValidator("imageRepository", CfnService_ImageRepositoryPropertyValidator)(properties.imageRepository)), errors.wrap('supplied properties not correct for "SourceConfigurationProperty"');
    }
    function cfnServiceSourceConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_SourceConfigurationPropertyValidator(properties).assertSuccess(), { AuthenticationConfiguration: cfnServiceAuthenticationConfigurationPropertyToCloudFormation(properties.authenticationConfiguration), AutoDeploymentsEnabled: cdk.booleanToCloudFormation(properties.autoDeploymentsEnabled), CodeRepository: cfnServiceCodeRepositoryPropertyToCloudFormation(properties.codeRepository), ImageRepository: cfnServiceImageRepositoryPropertyToCloudFormation(properties.imageRepository) }) : properties;
    }
    function CfnServiceSourceConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authenticationConfiguration", "AuthenticationConfiguration", properties.AuthenticationConfiguration != null ? CfnServiceAuthenticationConfigurationPropertyFromCloudFormation(properties.AuthenticationConfiguration) : void 0), ret.addPropertyResult("autoDeploymentsEnabled", "AutoDeploymentsEnabled", properties.AutoDeploymentsEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AutoDeploymentsEnabled) : void 0), ret.addPropertyResult("codeRepository", "CodeRepository", properties.CodeRepository != null ? CfnServiceCodeRepositoryPropertyFromCloudFormation(properties.CodeRepository) : void 0), ret.addPropertyResult("imageRepository", "ImageRepository", properties.ImageRepository != null ? CfnServiceImageRepositoryPropertyFromCloudFormation(properties.ImageRepository) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVpcConnectorPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroups", cdk.listValidator(cdk.validateString))(properties.securityGroups)), errors.collect(cdk.propertyValidator("subnets", cdk.requiredValidator)(properties.subnets)), errors.collect(cdk.propertyValidator("subnets", cdk.listValidator(cdk.validateString))(properties.subnets)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpcConnectorName", cdk.validateString)(properties.vpcConnectorName)), errors.wrap('supplied properties not correct for "CfnVpcConnectorProps"');
    }
    function cfnVpcConnectorPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVpcConnectorPropsValidator(properties).assertSuccess(), { Subnets: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnets), SecurityGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroups), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VpcConnectorName: cdk.stringToCloudFormation(properties.vpcConnectorName) }) : properties;
    }
    function CfnVpcConnectorPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("subnets", "Subnets", cfn_parse.FromCloudFormation.getStringArray(properties.Subnets)), ret.addPropertyResult("securityGroups", "SecurityGroups", properties.SecurityGroups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroups) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("vpcConnectorName", "VpcConnectorName", properties.VpcConnectorName != null ? cfn_parse.FromCloudFormation.getString(properties.VpcConnectorName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVpcConnector = class _CfnVpcConnector extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVpcConnectorPropsFromCloudFormation(resourceProperties), ret = new _CfnVpcConnector(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVpcConnector.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apprunner_CfnVpcConnectorProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVpcConnector), error;
        }
        cdk.requireProperty(props, "subnets", this), this.attrVpcConnectorArn = cdk.Token.asString(this.getAtt("VpcConnectorArn", cdk.ResolutionTypeHint.STRING)), this.attrVpcConnectorRevision = cdk.Token.asNumber(this.getAtt("VpcConnectorRevision", cdk.ResolutionTypeHint.NUMBER)), this.subnets = props.subnets, this.securityGroups = props.securityGroups, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::AppRunner::VpcConnector", props.tags, { tagPropertyName: "tags" }), this.vpcConnectorName = props.vpcConnectorName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVpcConnector.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { subnets: this.subnets, securityGroups: this.securityGroups, tags: this.tags.renderTags(), vpcConnectorName: this.vpcConnectorName };
      }
      renderProperties(props) {
        return cfnVpcConnectorPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnVpcConnector[_c] = { fqn: "aws-cdk-lib.aws_apprunner.CfnVpcConnector", version: "2.80.0" }, CfnVpcConnector.CFN_RESOURCE_TYPE_NAME = "AWS::AppRunner::VpcConnector", exports2.CfnVpcConnector = CfnVpcConnector;
    function CfnVpcIngressConnectionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ingressVpcConfiguration", cdk.requiredValidator)(properties.ingressVpcConfiguration)), errors.collect(cdk.propertyValidator("ingressVpcConfiguration", CfnVpcIngressConnection_IngressVpcConfigurationPropertyValidator)(properties.ingressVpcConfiguration)), errors.collect(cdk.propertyValidator("serviceArn", cdk.requiredValidator)(properties.serviceArn)), errors.collect(cdk.propertyValidator("serviceArn", cdk.validateString)(properties.serviceArn)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpcIngressConnectionName", cdk.validateString)(properties.vpcIngressConnectionName)), errors.wrap('supplied properties not correct for "CfnVpcIngressConnectionProps"');
    }
    function cfnVpcIngressConnectionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVpcIngressConnectionPropsValidator(properties).assertSuccess(), { IngressVpcConfiguration: cfnVpcIngressConnectionIngressVpcConfigurationPropertyToCloudFormation(properties.ingressVpcConfiguration), ServiceArn: cdk.stringToCloudFormation(properties.serviceArn), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VpcIngressConnectionName: cdk.stringToCloudFormation(properties.vpcIngressConnectionName) }) : properties;
    }
    function CfnVpcIngressConnectionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ingressVpcConfiguration", "IngressVpcConfiguration", CfnVpcIngressConnectionIngressVpcConfigurationPropertyFromCloudFormation(properties.IngressVpcConfiguration)), ret.addPropertyResult("serviceArn", "ServiceArn", cfn_parse.FromCloudFormation.getString(properties.ServiceArn)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("vpcIngressConnectionName", "VpcIngressConnectionName", properties.VpcIngressConnectionName != null ? cfn_parse.FromCloudFormation.getString(properties.VpcIngressConnectionName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVpcIngressConnection = class _CfnVpcIngressConnection extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVpcIngressConnectionPropsFromCloudFormation(resourceProperties), ret = new _CfnVpcIngressConnection(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVpcIngressConnection.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apprunner_CfnVpcIngressConnectionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVpcIngressConnection), error;
        }
        cdk.requireProperty(props, "ingressVpcConfiguration", this), cdk.requireProperty(props, "serviceArn", this), this.attrDomainName = cdk.Token.asString(this.getAtt("DomainName", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.attrVpcIngressConnectionArn = cdk.Token.asString(this.getAtt("VpcIngressConnectionArn", cdk.ResolutionTypeHint.STRING)), this.ingressVpcConfiguration = props.ingressVpcConfiguration, this.serviceArn = props.serviceArn, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::AppRunner::VpcIngressConnection", props.tags, { tagPropertyName: "tags" }), this.vpcIngressConnectionName = props.vpcIngressConnectionName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVpcIngressConnection.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { ingressVpcConfiguration: this.ingressVpcConfiguration, serviceArn: this.serviceArn, tags: this.tags.renderTags(), vpcIngressConnectionName: this.vpcIngressConnectionName };
      }
      renderProperties(props) {
        return cfnVpcIngressConnectionPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnVpcIngressConnection[_d] = { fqn: "aws-cdk-lib.aws_apprunner.CfnVpcIngressConnection", version: "2.80.0" }, CfnVpcIngressConnection.CFN_RESOURCE_TYPE_NAME = "AWS::AppRunner::VpcIngressConnection", exports2.CfnVpcIngressConnection = CfnVpcIngressConnection;
    function CfnVpcIngressConnection_IngressVpcConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("vpcEndpointId", cdk.requiredValidator)(properties.vpcEndpointId)), errors.collect(cdk.propertyValidator("vpcEndpointId", cdk.validateString)(properties.vpcEndpointId)), errors.collect(cdk.propertyValidator("vpcId", cdk.requiredValidator)(properties.vpcId)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "IngressVpcConfigurationProperty"');
    }
    function cfnVpcIngressConnectionIngressVpcConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVpcIngressConnection_IngressVpcConfigurationPropertyValidator(properties).assertSuccess(), { VpcEndpointId: cdk.stringToCloudFormation(properties.vpcEndpointId), VpcId: cdk.stringToCloudFormation(properties.vpcId) }) : properties;
    }
    function CfnVpcIngressConnectionIngressVpcConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("vpcEndpointId", "VpcEndpointId", cfn_parse.FromCloudFormation.getString(properties.VpcEndpointId)), ret.addPropertyResult("vpcId", "VpcId", cfn_parse.FromCloudFormation.getString(properties.VpcId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-apprunner/lib/index.js
var require_lib46 = __commonJS({
  "node_modules/aws-cdk-lib/aws-apprunner/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_apprunner_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-apprunner/index.js
var require_aws_apprunner = __commonJS({
  "node_modules/aws-cdk-lib/aws-apprunner/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib46(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-appstream/lib/appstream.generated.js
var require_appstream_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-appstream/lib/appstream.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    var _l;
    var _m;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnUser = exports2.CfnStackUserAssociation = exports2.CfnStackFleetAssociation = exports2.CfnStack = exports2.CfnImageBuilder = exports2.CfnFleet = exports2.CfnEntitlement = exports2.CfnDirectoryConfig = exports2.CfnApplicationFleetAssociation = exports2.CfnApplicationEntitlementAssociation = exports2.CfnApplication = exports2.CfnAppBlock = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAppBlockPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("displayName", cdk.validateString)(properties.displayName)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("setupScriptDetails", cdk.requiredValidator)(properties.setupScriptDetails)), errors.collect(cdk.propertyValidator("setupScriptDetails", CfnAppBlock_ScriptDetailsPropertyValidator)(properties.setupScriptDetails)), errors.collect(cdk.propertyValidator("sourceS3Location", cdk.requiredValidator)(properties.sourceS3Location)), errors.collect(cdk.propertyValidator("sourceS3Location", CfnAppBlock_S3LocationPropertyValidator)(properties.sourceS3Location)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnAppBlockProps"');
    }
    function cfnAppBlockPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAppBlockPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), SetupScriptDetails: cfnAppBlockScriptDetailsPropertyToCloudFormation(properties.setupScriptDetails), SourceS3Location: cfnAppBlockS3LocationPropertyToCloudFormation(properties.sourceS3Location), Description: cdk.stringToCloudFormation(properties.description), DisplayName: cdk.stringToCloudFormation(properties.displayName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnAppBlockPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("setupScriptDetails", "SetupScriptDetails", CfnAppBlockScriptDetailsPropertyFromCloudFormation(properties.SetupScriptDetails)), ret.addPropertyResult("sourceS3Location", "SourceS3Location", CfnAppBlockS3LocationPropertyFromCloudFormation(properties.SourceS3Location)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("displayName", "DisplayName", properties.DisplayName != null ? cfn_parse.FromCloudFormation.getString(properties.DisplayName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAppBlock = class _CfnAppBlock extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAppBlockPropsFromCloudFormation(resourceProperties), ret = new _CfnAppBlock(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAppBlock.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appstream_CfnAppBlockProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAppBlock), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "setupScriptDetails", this), cdk.requireProperty(props, "sourceS3Location", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreatedTime = cdk.Token.asString(this.getAtt("CreatedTime", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.setupScriptDetails = props.setupScriptDetails, this.sourceS3Location = props.sourceS3Location, this.description = props.description, this.displayName = props.displayName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::AppStream::AppBlock", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAppBlock.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, setupScriptDetails: this.setupScriptDetails, sourceS3Location: this.sourceS3Location, description: this.description, displayName: this.displayName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnAppBlockPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAppBlock[_a] = { fqn: "aws-cdk-lib.aws_appstream.CfnAppBlock", version: "2.80.0" }, CfnAppBlock.CFN_RESOURCE_TYPE_NAME = "AWS::AppStream::AppBlock", exports2.CfnAppBlock = CfnAppBlock;
    function CfnAppBlock_S3LocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3Bucket", cdk.requiredValidator)(properties.s3Bucket)), errors.collect(cdk.propertyValidator("s3Bucket", cdk.validateString)(properties.s3Bucket)), errors.collect(cdk.propertyValidator("s3Key", cdk.requiredValidator)(properties.s3Key)), errors.collect(cdk.propertyValidator("s3Key", cdk.validateString)(properties.s3Key)), errors.wrap('supplied properties not correct for "S3LocationProperty"');
    }
    function cfnAppBlockS3LocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAppBlock_S3LocationPropertyValidator(properties).assertSuccess(), { S3Bucket: cdk.stringToCloudFormation(properties.s3Bucket), S3Key: cdk.stringToCloudFormation(properties.s3Key) }) : properties;
    }
    function CfnAppBlockS3LocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Bucket", "S3Bucket", cfn_parse.FromCloudFormation.getString(properties.S3Bucket)), ret.addPropertyResult("s3Key", "S3Key", cfn_parse.FromCloudFormation.getString(properties.S3Key)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAppBlock_ScriptDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("executableParameters", cdk.validateString)(properties.executableParameters)), errors.collect(cdk.propertyValidator("executablePath", cdk.requiredValidator)(properties.executablePath)), errors.collect(cdk.propertyValidator("executablePath", cdk.validateString)(properties.executablePath)), errors.collect(cdk.propertyValidator("scriptS3Location", cdk.requiredValidator)(properties.scriptS3Location)), errors.collect(cdk.propertyValidator("scriptS3Location", CfnAppBlock_S3LocationPropertyValidator)(properties.scriptS3Location)), errors.collect(cdk.propertyValidator("timeoutInSeconds", cdk.requiredValidator)(properties.timeoutInSeconds)), errors.collect(cdk.propertyValidator("timeoutInSeconds", cdk.validateNumber)(properties.timeoutInSeconds)), errors.wrap('supplied properties not correct for "ScriptDetailsProperty"');
    }
    function cfnAppBlockScriptDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAppBlock_ScriptDetailsPropertyValidator(properties).assertSuccess(), { ExecutableParameters: cdk.stringToCloudFormation(properties.executableParameters), ExecutablePath: cdk.stringToCloudFormation(properties.executablePath), ScriptS3Location: cfnAppBlockS3LocationPropertyToCloudFormation(properties.scriptS3Location), TimeoutInSeconds: cdk.numberToCloudFormation(properties.timeoutInSeconds) }) : properties;
    }
    function CfnAppBlockScriptDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("executableParameters", "ExecutableParameters", properties.ExecutableParameters != null ? cfn_parse.FromCloudFormation.getString(properties.ExecutableParameters) : void 0), ret.addPropertyResult("executablePath", "ExecutablePath", cfn_parse.FromCloudFormation.getString(properties.ExecutablePath)), ret.addPropertyResult("scriptS3Location", "ScriptS3Location", CfnAppBlockS3LocationPropertyFromCloudFormation(properties.ScriptS3Location)), ret.addPropertyResult("timeoutInSeconds", "TimeoutInSeconds", cfn_parse.FromCloudFormation.getNumber(properties.TimeoutInSeconds)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("appBlockArn", cdk.requiredValidator)(properties.appBlockArn)), errors.collect(cdk.propertyValidator("appBlockArn", cdk.validateString)(properties.appBlockArn)), errors.collect(cdk.propertyValidator("attributesToDelete", cdk.listValidator(cdk.validateString))(properties.attributesToDelete)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("displayName", cdk.validateString)(properties.displayName)), errors.collect(cdk.propertyValidator("iconS3Location", cdk.requiredValidator)(properties.iconS3Location)), errors.collect(cdk.propertyValidator("iconS3Location", CfnApplication_S3LocationPropertyValidator)(properties.iconS3Location)), errors.collect(cdk.propertyValidator("instanceFamilies", cdk.requiredValidator)(properties.instanceFamilies)), errors.collect(cdk.propertyValidator("instanceFamilies", cdk.listValidator(cdk.validateString))(properties.instanceFamilies)), errors.collect(cdk.propertyValidator("launchParameters", cdk.validateString)(properties.launchParameters)), errors.collect(cdk.propertyValidator("launchPath", cdk.requiredValidator)(properties.launchPath)), errors.collect(cdk.propertyValidator("launchPath", cdk.validateString)(properties.launchPath)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("platforms", cdk.requiredValidator)(properties.platforms)), errors.collect(cdk.propertyValidator("platforms", cdk.listValidator(cdk.validateString))(properties.platforms)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("workingDirectory", cdk.validateString)(properties.workingDirectory)), errors.wrap('supplied properties not correct for "CfnApplicationProps"');
    }
    function cfnApplicationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationPropsValidator(properties).assertSuccess(), { AppBlockArn: cdk.stringToCloudFormation(properties.appBlockArn), IconS3Location: cfnApplicationS3LocationPropertyToCloudFormation(properties.iconS3Location), InstanceFamilies: cdk.listMapper(cdk.stringToCloudFormation)(properties.instanceFamilies), LaunchPath: cdk.stringToCloudFormation(properties.launchPath), Name: cdk.stringToCloudFormation(properties.name), Platforms: cdk.listMapper(cdk.stringToCloudFormation)(properties.platforms), AttributesToDelete: cdk.listMapper(cdk.stringToCloudFormation)(properties.attributesToDelete), Description: cdk.stringToCloudFormation(properties.description), DisplayName: cdk.stringToCloudFormation(properties.displayName), LaunchParameters: cdk.stringToCloudFormation(properties.launchParameters), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), WorkingDirectory: cdk.stringToCloudFormation(properties.workingDirectory) }) : properties;
    }
    function CfnApplicationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("appBlockArn", "AppBlockArn", cfn_parse.FromCloudFormation.getString(properties.AppBlockArn)), ret.addPropertyResult("iconS3Location", "IconS3Location", CfnApplicationS3LocationPropertyFromCloudFormation(properties.IconS3Location)), ret.addPropertyResult("instanceFamilies", "InstanceFamilies", cfn_parse.FromCloudFormation.getStringArray(properties.InstanceFamilies)), ret.addPropertyResult("launchPath", "LaunchPath", cfn_parse.FromCloudFormation.getString(properties.LaunchPath)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("platforms", "Platforms", cfn_parse.FromCloudFormation.getStringArray(properties.Platforms)), ret.addPropertyResult("attributesToDelete", "AttributesToDelete", properties.AttributesToDelete != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AttributesToDelete) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("displayName", "DisplayName", properties.DisplayName != null ? cfn_parse.FromCloudFormation.getString(properties.DisplayName) : void 0), ret.addPropertyResult("launchParameters", "LaunchParameters", properties.LaunchParameters != null ? cfn_parse.FromCloudFormation.getString(properties.LaunchParameters) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("workingDirectory", "WorkingDirectory", properties.WorkingDirectory != null ? cfn_parse.FromCloudFormation.getString(properties.WorkingDirectory) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApplication = class _CfnApplication extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApplicationPropsFromCloudFormation(resourceProperties), ret = new _CfnApplication(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApplication.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appstream_CfnApplicationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApplication), error;
        }
        cdk.requireProperty(props, "appBlockArn", this), cdk.requireProperty(props, "iconS3Location", this), cdk.requireProperty(props, "instanceFamilies", this), cdk.requireProperty(props, "launchPath", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "platforms", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreatedTime = cdk.Token.asString(this.getAtt("CreatedTime", cdk.ResolutionTypeHint.STRING)), this.appBlockArn = props.appBlockArn, this.iconS3Location = props.iconS3Location, this.instanceFamilies = props.instanceFamilies, this.launchPath = props.launchPath, this.name = props.name, this.platforms = props.platforms, this.attributesToDelete = props.attributesToDelete, this.description = props.description, this.displayName = props.displayName, this.launchParameters = props.launchParameters, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::AppStream::Application", props.tags, { tagPropertyName: "tags" }), this.workingDirectory = props.workingDirectory;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApplication.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { appBlockArn: this.appBlockArn, iconS3Location: this.iconS3Location, instanceFamilies: this.instanceFamilies, launchPath: this.launchPath, name: this.name, platforms: this.platforms, attributesToDelete: this.attributesToDelete, description: this.description, displayName: this.displayName, launchParameters: this.launchParameters, tags: this.tags.renderTags(), workingDirectory: this.workingDirectory };
      }
      renderProperties(props) {
        return cfnApplicationPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnApplication[_b] = { fqn: "aws-cdk-lib.aws_appstream.CfnApplication", version: "2.80.0" }, CfnApplication.CFN_RESOURCE_TYPE_NAME = "AWS::AppStream::Application", exports2.CfnApplication = CfnApplication;
    function CfnApplication_S3LocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3Bucket", cdk.requiredValidator)(properties.s3Bucket)), errors.collect(cdk.propertyValidator("s3Bucket", cdk.validateString)(properties.s3Bucket)), errors.collect(cdk.propertyValidator("s3Key", cdk.requiredValidator)(properties.s3Key)), errors.collect(cdk.propertyValidator("s3Key", cdk.validateString)(properties.s3Key)), errors.wrap('supplied properties not correct for "S3LocationProperty"');
    }
    function cfnApplicationS3LocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_S3LocationPropertyValidator(properties).assertSuccess(), { S3Bucket: cdk.stringToCloudFormation(properties.s3Bucket), S3Key: cdk.stringToCloudFormation(properties.s3Key) }) : properties;
    }
    function CfnApplicationS3LocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Bucket", "S3Bucket", cfn_parse.FromCloudFormation.getString(properties.S3Bucket)), ret.addPropertyResult("s3Key", "S3Key", cfn_parse.FromCloudFormation.getString(properties.S3Key)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationEntitlementAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationIdentifier", cdk.requiredValidator)(properties.applicationIdentifier)), errors.collect(cdk.propertyValidator("applicationIdentifier", cdk.validateString)(properties.applicationIdentifier)), errors.collect(cdk.propertyValidator("entitlementName", cdk.requiredValidator)(properties.entitlementName)), errors.collect(cdk.propertyValidator("entitlementName", cdk.validateString)(properties.entitlementName)), errors.collect(cdk.propertyValidator("stackName", cdk.requiredValidator)(properties.stackName)), errors.collect(cdk.propertyValidator("stackName", cdk.validateString)(properties.stackName)), errors.wrap('supplied properties not correct for "CfnApplicationEntitlementAssociationProps"');
    }
    function cfnApplicationEntitlementAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationEntitlementAssociationPropsValidator(properties).assertSuccess(), { ApplicationIdentifier: cdk.stringToCloudFormation(properties.applicationIdentifier), EntitlementName: cdk.stringToCloudFormation(properties.entitlementName), StackName: cdk.stringToCloudFormation(properties.stackName) }) : properties;
    }
    function CfnApplicationEntitlementAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationIdentifier", "ApplicationIdentifier", cfn_parse.FromCloudFormation.getString(properties.ApplicationIdentifier)), ret.addPropertyResult("entitlementName", "EntitlementName", cfn_parse.FromCloudFormation.getString(properties.EntitlementName)), ret.addPropertyResult("stackName", "StackName", cfn_parse.FromCloudFormation.getString(properties.StackName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApplicationEntitlementAssociation = class _CfnApplicationEntitlementAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApplicationEntitlementAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnApplicationEntitlementAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApplicationEntitlementAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appstream_CfnApplicationEntitlementAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApplicationEntitlementAssociation), error;
        }
        cdk.requireProperty(props, "applicationIdentifier", this), cdk.requireProperty(props, "entitlementName", this), cdk.requireProperty(props, "stackName", this), this.applicationIdentifier = props.applicationIdentifier, this.entitlementName = props.entitlementName, this.stackName = props.stackName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApplicationEntitlementAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationIdentifier: this.applicationIdentifier, entitlementName: this.entitlementName, stackName: this.stackName };
      }
      renderProperties(props) {
        return cfnApplicationEntitlementAssociationPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnApplicationEntitlementAssociation[_c] = { fqn: "aws-cdk-lib.aws_appstream.CfnApplicationEntitlementAssociation", version: "2.80.0" }, CfnApplicationEntitlementAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::AppStream::ApplicationEntitlementAssociation", exports2.CfnApplicationEntitlementAssociation = CfnApplicationEntitlementAssociation;
    function CfnApplicationFleetAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationArn", cdk.requiredValidator)(properties.applicationArn)), errors.collect(cdk.propertyValidator("applicationArn", cdk.validateString)(properties.applicationArn)), errors.collect(cdk.propertyValidator("fleetName", cdk.requiredValidator)(properties.fleetName)), errors.collect(cdk.propertyValidator("fleetName", cdk.validateString)(properties.fleetName)), errors.wrap('supplied properties not correct for "CfnApplicationFleetAssociationProps"');
    }
    function cfnApplicationFleetAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationFleetAssociationPropsValidator(properties).assertSuccess(), { ApplicationArn: cdk.stringToCloudFormation(properties.applicationArn), FleetName: cdk.stringToCloudFormation(properties.fleetName) }) : properties;
    }
    function CfnApplicationFleetAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationArn", "ApplicationArn", cfn_parse.FromCloudFormation.getString(properties.ApplicationArn)), ret.addPropertyResult("fleetName", "FleetName", cfn_parse.FromCloudFormation.getString(properties.FleetName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApplicationFleetAssociation = class _CfnApplicationFleetAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApplicationFleetAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnApplicationFleetAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApplicationFleetAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appstream_CfnApplicationFleetAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApplicationFleetAssociation), error;
        }
        cdk.requireProperty(props, "applicationArn", this), cdk.requireProperty(props, "fleetName", this), this.applicationArn = props.applicationArn, this.fleetName = props.fleetName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApplicationFleetAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationArn: this.applicationArn, fleetName: this.fleetName };
      }
      renderProperties(props) {
        return cfnApplicationFleetAssociationPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnApplicationFleetAssociation[_d] = { fqn: "aws-cdk-lib.aws_appstream.CfnApplicationFleetAssociation", version: "2.80.0" }, CfnApplicationFleetAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::AppStream::ApplicationFleetAssociation", exports2.CfnApplicationFleetAssociation = CfnApplicationFleetAssociation;
    function CfnDirectoryConfigPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateBasedAuthProperties", CfnDirectoryConfig_CertificateBasedAuthPropertiesPropertyValidator)(properties.certificateBasedAuthProperties)), errors.collect(cdk.propertyValidator("directoryName", cdk.requiredValidator)(properties.directoryName)), errors.collect(cdk.propertyValidator("directoryName", cdk.validateString)(properties.directoryName)), errors.collect(cdk.propertyValidator("organizationalUnitDistinguishedNames", cdk.requiredValidator)(properties.organizationalUnitDistinguishedNames)), errors.collect(cdk.propertyValidator("organizationalUnitDistinguishedNames", cdk.listValidator(cdk.validateString))(properties.organizationalUnitDistinguishedNames)), errors.collect(cdk.propertyValidator("serviceAccountCredentials", cdk.requiredValidator)(properties.serviceAccountCredentials)), errors.collect(cdk.propertyValidator("serviceAccountCredentials", CfnDirectoryConfig_ServiceAccountCredentialsPropertyValidator)(properties.serviceAccountCredentials)), errors.wrap('supplied properties not correct for "CfnDirectoryConfigProps"');
    }
    function cfnDirectoryConfigPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDirectoryConfigPropsValidator(properties).assertSuccess(), { DirectoryName: cdk.stringToCloudFormation(properties.directoryName), OrganizationalUnitDistinguishedNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.organizationalUnitDistinguishedNames), ServiceAccountCredentials: cfnDirectoryConfigServiceAccountCredentialsPropertyToCloudFormation(properties.serviceAccountCredentials), CertificateBasedAuthProperties: cfnDirectoryConfigCertificateBasedAuthPropertiesPropertyToCloudFormation(properties.certificateBasedAuthProperties) }) : properties;
    }
    function CfnDirectoryConfigPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("directoryName", "DirectoryName", cfn_parse.FromCloudFormation.getString(properties.DirectoryName)), ret.addPropertyResult("organizationalUnitDistinguishedNames", "OrganizationalUnitDistinguishedNames", cfn_parse.FromCloudFormation.getStringArray(properties.OrganizationalUnitDistinguishedNames)), ret.addPropertyResult("serviceAccountCredentials", "ServiceAccountCredentials", CfnDirectoryConfigServiceAccountCredentialsPropertyFromCloudFormation(properties.ServiceAccountCredentials)), ret.addPropertyResult("certificateBasedAuthProperties", "CertificateBasedAuthProperties", properties.CertificateBasedAuthProperties != null ? CfnDirectoryConfigCertificateBasedAuthPropertiesPropertyFromCloudFormation(properties.CertificateBasedAuthProperties) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDirectoryConfig = class _CfnDirectoryConfig extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDirectoryConfigPropsFromCloudFormation(resourceProperties), ret = new _CfnDirectoryConfig(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDirectoryConfig.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appstream_CfnDirectoryConfigProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDirectoryConfig), error;
        }
        cdk.requireProperty(props, "directoryName", this), cdk.requireProperty(props, "organizationalUnitDistinguishedNames", this), cdk.requireProperty(props, "serviceAccountCredentials", this), this.directoryName = props.directoryName, this.organizationalUnitDistinguishedNames = props.organizationalUnitDistinguishedNames, this.serviceAccountCredentials = props.serviceAccountCredentials, this.certificateBasedAuthProperties = props.certificateBasedAuthProperties;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDirectoryConfig.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { directoryName: this.directoryName, organizationalUnitDistinguishedNames: this.organizationalUnitDistinguishedNames, serviceAccountCredentials: this.serviceAccountCredentials, certificateBasedAuthProperties: this.certificateBasedAuthProperties };
      }
      renderProperties(props) {
        return cfnDirectoryConfigPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnDirectoryConfig[_e] = { fqn: "aws-cdk-lib.aws_appstream.CfnDirectoryConfig", version: "2.80.0" }, CfnDirectoryConfig.CFN_RESOURCE_TYPE_NAME = "AWS::AppStream::DirectoryConfig", exports2.CfnDirectoryConfig = CfnDirectoryConfig;
    function CfnDirectoryConfig_CertificateBasedAuthPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateAuthorityArn", cdk.validateString)(properties.certificateAuthorityArn)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "CertificateBasedAuthPropertiesProperty"');
    }
    function cfnDirectoryConfigCertificateBasedAuthPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDirectoryConfig_CertificateBasedAuthPropertiesPropertyValidator(properties).assertSuccess(), { CertificateAuthorityArn: cdk.stringToCloudFormation(properties.certificateAuthorityArn), Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnDirectoryConfigCertificateBasedAuthPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificateAuthorityArn", "CertificateAuthorityArn", properties.CertificateAuthorityArn != null ? cfn_parse.FromCloudFormation.getString(properties.CertificateAuthorityArn) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDirectoryConfig_ServiceAccountCredentialsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accountName", cdk.requiredValidator)(properties.accountName)), errors.collect(cdk.propertyValidator("accountName", cdk.validateString)(properties.accountName)), errors.collect(cdk.propertyValidator("accountPassword", cdk.requiredValidator)(properties.accountPassword)), errors.collect(cdk.propertyValidator("accountPassword", cdk.validateString)(properties.accountPassword)), errors.wrap('supplied properties not correct for "ServiceAccountCredentialsProperty"');
    }
    function cfnDirectoryConfigServiceAccountCredentialsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDirectoryConfig_ServiceAccountCredentialsPropertyValidator(properties).assertSuccess(), { AccountName: cdk.stringToCloudFormation(properties.accountName), AccountPassword: cdk.stringToCloudFormation(properties.accountPassword) }) : properties;
    }
    function CfnDirectoryConfigServiceAccountCredentialsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accountName", "AccountName", cfn_parse.FromCloudFormation.getString(properties.AccountName)), ret.addPropertyResult("accountPassword", "AccountPassword", cfn_parse.FromCloudFormation.getString(properties.AccountPassword)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEntitlementPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("appVisibility", cdk.requiredValidator)(properties.appVisibility)), errors.collect(cdk.propertyValidator("appVisibility", cdk.validateString)(properties.appVisibility)), errors.collect(cdk.propertyValidator("attributes", cdk.requiredValidator)(properties.attributes)), errors.collect(cdk.propertyValidator("attributes", cdk.listValidator(CfnEntitlement_AttributePropertyValidator))(properties.attributes)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("stackName", cdk.requiredValidator)(properties.stackName)), errors.collect(cdk.propertyValidator("stackName", cdk.validateString)(properties.stackName)), errors.wrap('supplied properties not correct for "CfnEntitlementProps"');
    }
    function cfnEntitlementPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEntitlementPropsValidator(properties).assertSuccess(), { AppVisibility: cdk.stringToCloudFormation(properties.appVisibility), Attributes: cdk.listMapper(cfnEntitlementAttributePropertyToCloudFormation)(properties.attributes), Name: cdk.stringToCloudFormation(properties.name), StackName: cdk.stringToCloudFormation(properties.stackName), Description: cdk.stringToCloudFormation(properties.description) }) : properties;
    }
    function CfnEntitlementPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("appVisibility", "AppVisibility", cfn_parse.FromCloudFormation.getString(properties.AppVisibility)), ret.addPropertyResult("attributes", "Attributes", cfn_parse.FromCloudFormation.getArray(CfnEntitlementAttributePropertyFromCloudFormation)(properties.Attributes)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("stackName", "StackName", cfn_parse.FromCloudFormation.getString(properties.StackName)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEntitlement = class _CfnEntitlement extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEntitlementPropsFromCloudFormation(resourceProperties), ret = new _CfnEntitlement(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEntitlement.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appstream_CfnEntitlementProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEntitlement), error;
        }
        cdk.requireProperty(props, "appVisibility", this), cdk.requireProperty(props, "attributes", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "stackName", this), this.attrCreatedTime = cdk.Token.asString(this.getAtt("CreatedTime", cdk.ResolutionTypeHint.STRING)), this.attrLastModifiedTime = cdk.Token.asString(this.getAtt("LastModifiedTime", cdk.ResolutionTypeHint.STRING)), this.appVisibility = props.appVisibility, this.attributes = props.attributes, this.name = props.name, this.stackName = props.stackName, this.description = props.description;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEntitlement.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { appVisibility: this.appVisibility, attributes: this.attributes, name: this.name, stackName: this.stackName, description: this.description };
      }
      renderProperties(props) {
        return cfnEntitlementPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnEntitlement[_f] = { fqn: "aws-cdk-lib.aws_appstream.CfnEntitlement", version: "2.80.0" }, CfnEntitlement.CFN_RESOURCE_TYPE_NAME = "AWS::AppStream::Entitlement", exports2.CfnEntitlement = CfnEntitlement;
    function CfnEntitlement_AttributePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "AttributeProperty"');
    }
    function cfnEntitlementAttributePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEntitlement_AttributePropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnEntitlementAttributePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFleetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computeCapacity", CfnFleet_ComputeCapacityPropertyValidator)(properties.computeCapacity)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("disconnectTimeoutInSeconds", cdk.validateNumber)(properties.disconnectTimeoutInSeconds)), errors.collect(cdk.propertyValidator("displayName", cdk.validateString)(properties.displayName)), errors.collect(cdk.propertyValidator("domainJoinInfo", CfnFleet_DomainJoinInfoPropertyValidator)(properties.domainJoinInfo)), errors.collect(cdk.propertyValidator("enableDefaultInternetAccess", cdk.validateBoolean)(properties.enableDefaultInternetAccess)), errors.collect(cdk.propertyValidator("fleetType", cdk.validateString)(properties.fleetType)), errors.collect(cdk.propertyValidator("iamRoleArn", cdk.validateString)(properties.iamRoleArn)), errors.collect(cdk.propertyValidator("idleDisconnectTimeoutInSeconds", cdk.validateNumber)(properties.idleDisconnectTimeoutInSeconds)), errors.collect(cdk.propertyValidator("imageArn", cdk.validateString)(properties.imageArn)), errors.collect(cdk.propertyValidator("imageName", cdk.validateString)(properties.imageName)), errors.collect(cdk.propertyValidator("instanceType", cdk.requiredValidator)(properties.instanceType)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("maxConcurrentSessions", cdk.validateNumber)(properties.maxConcurrentSessions)), errors.collect(cdk.propertyValidator("maxUserDurationInSeconds", cdk.validateNumber)(properties.maxUserDurationInSeconds)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("platform", cdk.validateString)(properties.platform)), errors.collect(cdk.propertyValidator("sessionScriptS3Location", CfnFleet_S3LocationPropertyValidator)(properties.sessionScriptS3Location)), errors.collect(cdk.propertyValidator("streamView", cdk.validateString)(properties.streamView)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("usbDeviceFilterStrings", cdk.listValidator(cdk.validateString))(properties.usbDeviceFilterStrings)), errors.collect(cdk.propertyValidator("vpcConfig", CfnFleet_VpcConfigPropertyValidator)(properties.vpcConfig)), errors.wrap('supplied properties not correct for "CfnFleetProps"');
    }
    function cfnFleetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFleetPropsValidator(properties).assertSuccess(), { InstanceType: cdk.stringToCloudFormation(properties.instanceType), Name: cdk.stringToCloudFormation(properties.name), ComputeCapacity: cfnFleetComputeCapacityPropertyToCloudFormation(properties.computeCapacity), Description: cdk.stringToCloudFormation(properties.description), DisconnectTimeoutInSeconds: cdk.numberToCloudFormation(properties.disconnectTimeoutInSeconds), DisplayName: cdk.stringToCloudFormation(properties.displayName), DomainJoinInfo: cfnFleetDomainJoinInfoPropertyToCloudFormation(properties.domainJoinInfo), EnableDefaultInternetAccess: cdk.booleanToCloudFormation(properties.enableDefaultInternetAccess), FleetType: cdk.stringToCloudFormation(properties.fleetType), IamRoleArn: cdk.stringToCloudFormation(properties.iamRoleArn), IdleDisconnectTimeoutInSeconds: cdk.numberToCloudFormation(properties.idleDisconnectTimeoutInSeconds), ImageArn: cdk.stringToCloudFormation(properties.imageArn), ImageName: cdk.stringToCloudFormation(properties.imageName), MaxConcurrentSessions: cdk.numberToCloudFormation(properties.maxConcurrentSessions), MaxUserDurationInSeconds: cdk.numberToCloudFormation(properties.maxUserDurationInSeconds), Platform: cdk.stringToCloudFormation(properties.platform), SessionScriptS3Location: cfnFleetS3LocationPropertyToCloudFormation(properties.sessionScriptS3Location), StreamView: cdk.stringToCloudFormation(properties.streamView), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), UsbDeviceFilterStrings: cdk.listMapper(cdk.stringToCloudFormation)(properties.usbDeviceFilterStrings), VpcConfig: cfnFleetVpcConfigPropertyToCloudFormation(properties.vpcConfig) }) : properties;
    }
    function CfnFleetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceType", "InstanceType", cfn_parse.FromCloudFormation.getString(properties.InstanceType)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("computeCapacity", "ComputeCapacity", properties.ComputeCapacity != null ? CfnFleetComputeCapacityPropertyFromCloudFormation(properties.ComputeCapacity) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("disconnectTimeoutInSeconds", "DisconnectTimeoutInSeconds", properties.DisconnectTimeoutInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.DisconnectTimeoutInSeconds) : void 0), ret.addPropertyResult("displayName", "DisplayName", properties.DisplayName != null ? cfn_parse.FromCloudFormation.getString(properties.DisplayName) : void 0), ret.addPropertyResult("domainJoinInfo", "DomainJoinInfo", properties.DomainJoinInfo != null ? CfnFleetDomainJoinInfoPropertyFromCloudFormation(properties.DomainJoinInfo) : void 0), ret.addPropertyResult("enableDefaultInternetAccess", "EnableDefaultInternetAccess", properties.EnableDefaultInternetAccess != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableDefaultInternetAccess) : void 0), ret.addPropertyResult("fleetType", "FleetType", properties.FleetType != null ? cfn_parse.FromCloudFormation.getString(properties.FleetType) : void 0), ret.addPropertyResult("iamRoleArn", "IamRoleArn", properties.IamRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.IamRoleArn) : void 0), ret.addPropertyResult("idleDisconnectTimeoutInSeconds", "IdleDisconnectTimeoutInSeconds", properties.IdleDisconnectTimeoutInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.IdleDisconnectTimeoutInSeconds) : void 0), ret.addPropertyResult("imageArn", "ImageArn", properties.ImageArn != null ? cfn_parse.FromCloudFormation.getString(properties.ImageArn) : void 0), ret.addPropertyResult("imageName", "ImageName", properties.ImageName != null ? cfn_parse.FromCloudFormation.getString(properties.ImageName) : void 0), ret.addPropertyResult("maxConcurrentSessions", "MaxConcurrentSessions", properties.MaxConcurrentSessions != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxConcurrentSessions) : void 0), ret.addPropertyResult("maxUserDurationInSeconds", "MaxUserDurationInSeconds", properties.MaxUserDurationInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxUserDurationInSeconds) : void 0), ret.addPropertyResult("platform", "Platform", properties.Platform != null ? cfn_parse.FromCloudFormation.getString(properties.Platform) : void 0), ret.addPropertyResult("sessionScriptS3Location", "SessionScriptS3Location", properties.SessionScriptS3Location != null ? CfnFleetS3LocationPropertyFromCloudFormation(properties.SessionScriptS3Location) : void 0), ret.addPropertyResult("streamView", "StreamView", properties.StreamView != null ? cfn_parse.FromCloudFormation.getString(properties.StreamView) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("usbDeviceFilterStrings", "UsbDeviceFilterStrings", properties.UsbDeviceFilterStrings != null ? cfn_parse.FromCloudFormation.getStringArray(properties.UsbDeviceFilterStrings) : void 0), ret.addPropertyResult("vpcConfig", "VpcConfig", properties.VpcConfig != null ? CfnFleetVpcConfigPropertyFromCloudFormation(properties.VpcConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFleet = class _CfnFleet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFleetPropsFromCloudFormation(resourceProperties), ret = new _CfnFleet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFleet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appstream_CfnFleetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFleet), error;
        }
        cdk.requireProperty(props, "instanceType", this), cdk.requireProperty(props, "name", this), this.instanceType = props.instanceType, this.name = props.name, this.computeCapacity = props.computeCapacity, this.description = props.description, this.disconnectTimeoutInSeconds = props.disconnectTimeoutInSeconds, this.displayName = props.displayName, this.domainJoinInfo = props.domainJoinInfo, this.enableDefaultInternetAccess = props.enableDefaultInternetAccess, this.fleetType = props.fleetType, this.iamRoleArn = props.iamRoleArn, this.idleDisconnectTimeoutInSeconds = props.idleDisconnectTimeoutInSeconds, this.imageArn = props.imageArn, this.imageName = props.imageName, this.maxConcurrentSessions = props.maxConcurrentSessions, this.maxUserDurationInSeconds = props.maxUserDurationInSeconds, this.platform = props.platform, this.sessionScriptS3Location = props.sessionScriptS3Location, this.streamView = props.streamView, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::AppStream::Fleet", props.tags, { tagPropertyName: "tags" }), this.usbDeviceFilterStrings = props.usbDeviceFilterStrings, this.vpcConfig = props.vpcConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFleet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { instanceType: this.instanceType, name: this.name, computeCapacity: this.computeCapacity, description: this.description, disconnectTimeoutInSeconds: this.disconnectTimeoutInSeconds, displayName: this.displayName, domainJoinInfo: this.domainJoinInfo, enableDefaultInternetAccess: this.enableDefaultInternetAccess, fleetType: this.fleetType, iamRoleArn: this.iamRoleArn, idleDisconnectTimeoutInSeconds: this.idleDisconnectTimeoutInSeconds, imageArn: this.imageArn, imageName: this.imageName, maxConcurrentSessions: this.maxConcurrentSessions, maxUserDurationInSeconds: this.maxUserDurationInSeconds, platform: this.platform, sessionScriptS3Location: this.sessionScriptS3Location, streamView: this.streamView, tags: this.tags.renderTags(), usbDeviceFilterStrings: this.usbDeviceFilterStrings, vpcConfig: this.vpcConfig };
      }
      renderProperties(props) {
        return cfnFleetPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnFleet[_g] = { fqn: "aws-cdk-lib.aws_appstream.CfnFleet", version: "2.80.0" }, CfnFleet.CFN_RESOURCE_TYPE_NAME = "AWS::AppStream::Fleet", exports2.CfnFleet = CfnFleet;
    function CfnFleet_ComputeCapacityPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("desiredInstances", cdk.requiredValidator)(properties.desiredInstances)), errors.collect(cdk.propertyValidator("desiredInstances", cdk.validateNumber)(properties.desiredInstances)), errors.wrap('supplied properties not correct for "ComputeCapacityProperty"');
    }
    function cfnFleetComputeCapacityPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFleet_ComputeCapacityPropertyValidator(properties).assertSuccess(), { DesiredInstances: cdk.numberToCloudFormation(properties.desiredInstances) }) : properties;
    }
    function CfnFleetComputeCapacityPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("desiredInstances", "DesiredInstances", cfn_parse.FromCloudFormation.getNumber(properties.DesiredInstances)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFleet_DomainJoinInfoPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("directoryName", cdk.validateString)(properties.directoryName)), errors.collect(cdk.propertyValidator("organizationalUnitDistinguishedName", cdk.validateString)(properties.organizationalUnitDistinguishedName)), errors.wrap('supplied properties not correct for "DomainJoinInfoProperty"');
    }
    function cfnFleetDomainJoinInfoPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFleet_DomainJoinInfoPropertyValidator(properties).assertSuccess(), { DirectoryName: cdk.stringToCloudFormation(properties.directoryName), OrganizationalUnitDistinguishedName: cdk.stringToCloudFormation(properties.organizationalUnitDistinguishedName) }) : properties;
    }
    function CfnFleetDomainJoinInfoPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("directoryName", "DirectoryName", properties.DirectoryName != null ? cfn_parse.FromCloudFormation.getString(properties.DirectoryName) : void 0), ret.addPropertyResult("organizationalUnitDistinguishedName", "OrganizationalUnitDistinguishedName", properties.OrganizationalUnitDistinguishedName != null ? cfn_parse.FromCloudFormation.getString(properties.OrganizationalUnitDistinguishedName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFleet_S3LocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3Bucket", cdk.requiredValidator)(properties.s3Bucket)), errors.collect(cdk.propertyValidator("s3Bucket", cdk.validateString)(properties.s3Bucket)), errors.collect(cdk.propertyValidator("s3Key", cdk.requiredValidator)(properties.s3Key)), errors.collect(cdk.propertyValidator("s3Key", cdk.validateString)(properties.s3Key)), errors.wrap('supplied properties not correct for "S3LocationProperty"');
    }
    function cfnFleetS3LocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFleet_S3LocationPropertyValidator(properties).assertSuccess(), { S3Bucket: cdk.stringToCloudFormation(properties.s3Bucket), S3Key: cdk.stringToCloudFormation(properties.s3Key) }) : properties;
    }
    function CfnFleetS3LocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Bucket", "S3Bucket", cfn_parse.FromCloudFormation.getString(properties.S3Bucket)), ret.addPropertyResult("s3Key", "S3Key", cfn_parse.FromCloudFormation.getString(properties.S3Key)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFleet_VpcConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.wrap('supplied properties not correct for "VpcConfigProperty"');
    }
    function cfnFleetVpcConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFleet_VpcConfigPropertyValidator(properties).assertSuccess(), { SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds) }) : properties;
    }
    function CfnFleetVpcConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("subnetIds", "SubnetIds", properties.SubnetIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnImageBuilderPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessEndpoints", cdk.listValidator(CfnImageBuilder_AccessEndpointPropertyValidator))(properties.accessEndpoints)), errors.collect(cdk.propertyValidator("appstreamAgentVersion", cdk.validateString)(properties.appstreamAgentVersion)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("displayName", cdk.validateString)(properties.displayName)), errors.collect(cdk.propertyValidator("domainJoinInfo", CfnImageBuilder_DomainJoinInfoPropertyValidator)(properties.domainJoinInfo)), errors.collect(cdk.propertyValidator("enableDefaultInternetAccess", cdk.validateBoolean)(properties.enableDefaultInternetAccess)), errors.collect(cdk.propertyValidator("iamRoleArn", cdk.validateString)(properties.iamRoleArn)), errors.collect(cdk.propertyValidator("imageArn", cdk.validateString)(properties.imageArn)), errors.collect(cdk.propertyValidator("imageName", cdk.validateString)(properties.imageName)), errors.collect(cdk.propertyValidator("instanceType", cdk.requiredValidator)(properties.instanceType)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpcConfig", CfnImageBuilder_VpcConfigPropertyValidator)(properties.vpcConfig)), errors.wrap('supplied properties not correct for "CfnImageBuilderProps"');
    }
    function cfnImageBuilderPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnImageBuilderPropsValidator(properties).assertSuccess(), { InstanceType: cdk.stringToCloudFormation(properties.instanceType), Name: cdk.stringToCloudFormation(properties.name), AccessEndpoints: cdk.listMapper(cfnImageBuilderAccessEndpointPropertyToCloudFormation)(properties.accessEndpoints), AppstreamAgentVersion: cdk.stringToCloudFormation(properties.appstreamAgentVersion), Description: cdk.stringToCloudFormation(properties.description), DisplayName: cdk.stringToCloudFormation(properties.displayName), DomainJoinInfo: cfnImageBuilderDomainJoinInfoPropertyToCloudFormation(properties.domainJoinInfo), EnableDefaultInternetAccess: cdk.booleanToCloudFormation(properties.enableDefaultInternetAccess), IamRoleArn: cdk.stringToCloudFormation(properties.iamRoleArn), ImageArn: cdk.stringToCloudFormation(properties.imageArn), ImageName: cdk.stringToCloudFormation(properties.imageName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VpcConfig: cfnImageBuilderVpcConfigPropertyToCloudFormation(properties.vpcConfig) }) : properties;
    }
    function CfnImageBuilderPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceType", "InstanceType", cfn_parse.FromCloudFormation.getString(properties.InstanceType)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("accessEndpoints", "AccessEndpoints", properties.AccessEndpoints != null ? cfn_parse.FromCloudFormation.getArray(CfnImageBuilderAccessEndpointPropertyFromCloudFormation)(properties.AccessEndpoints) : void 0), ret.addPropertyResult("appstreamAgentVersion", "AppstreamAgentVersion", properties.AppstreamAgentVersion != null ? cfn_parse.FromCloudFormation.getString(properties.AppstreamAgentVersion) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("displayName", "DisplayName", properties.DisplayName != null ? cfn_parse.FromCloudFormation.getString(properties.DisplayName) : void 0), ret.addPropertyResult("domainJoinInfo", "DomainJoinInfo", properties.DomainJoinInfo != null ? CfnImageBuilderDomainJoinInfoPropertyFromCloudFormation(properties.DomainJoinInfo) : void 0), ret.addPropertyResult("enableDefaultInternetAccess", "EnableDefaultInternetAccess", properties.EnableDefaultInternetAccess != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableDefaultInternetAccess) : void 0), ret.addPropertyResult("iamRoleArn", "IamRoleArn", properties.IamRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.IamRoleArn) : void 0), ret.addPropertyResult("imageArn", "ImageArn", properties.ImageArn != null ? cfn_parse.FromCloudFormation.getString(properties.ImageArn) : void 0), ret.addPropertyResult("imageName", "ImageName", properties.ImageName != null ? cfn_parse.FromCloudFormation.getString(properties.ImageName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("vpcConfig", "VpcConfig", properties.VpcConfig != null ? CfnImageBuilderVpcConfigPropertyFromCloudFormation(properties.VpcConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnImageBuilder = class _CfnImageBuilder extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnImageBuilderPropsFromCloudFormation(resourceProperties), ret = new _CfnImageBuilder(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnImageBuilder.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appstream_CfnImageBuilderProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnImageBuilder), error;
        }
        cdk.requireProperty(props, "instanceType", this), cdk.requireProperty(props, "name", this), this.attrStreamingUrl = cdk.Token.asString(this.getAtt("StreamingUrl", cdk.ResolutionTypeHint.STRING)), this.instanceType = props.instanceType, this.name = props.name, this.accessEndpoints = props.accessEndpoints, this.appstreamAgentVersion = props.appstreamAgentVersion, this.description = props.description, this.displayName = props.displayName, this.domainJoinInfo = props.domainJoinInfo, this.enableDefaultInternetAccess = props.enableDefaultInternetAccess, this.iamRoleArn = props.iamRoleArn, this.imageArn = props.imageArn, this.imageName = props.imageName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::AppStream::ImageBuilder", props.tags, { tagPropertyName: "tags" }), this.vpcConfig = props.vpcConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnImageBuilder.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { instanceType: this.instanceType, name: this.name, accessEndpoints: this.accessEndpoints, appstreamAgentVersion: this.appstreamAgentVersion, description: this.description, displayName: this.displayName, domainJoinInfo: this.domainJoinInfo, enableDefaultInternetAccess: this.enableDefaultInternetAccess, iamRoleArn: this.iamRoleArn, imageArn: this.imageArn, imageName: this.imageName, tags: this.tags.renderTags(), vpcConfig: this.vpcConfig };
      }
      renderProperties(props) {
        return cfnImageBuilderPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnImageBuilder[_h] = { fqn: "aws-cdk-lib.aws_appstream.CfnImageBuilder", version: "2.80.0" }, CfnImageBuilder.CFN_RESOURCE_TYPE_NAME = "AWS::AppStream::ImageBuilder", exports2.CfnImageBuilder = CfnImageBuilder;
    function CfnImageBuilder_AccessEndpointPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endpointType", cdk.requiredValidator)(properties.endpointType)), errors.collect(cdk.propertyValidator("endpointType", cdk.validateString)(properties.endpointType)), errors.collect(cdk.propertyValidator("vpceId", cdk.requiredValidator)(properties.vpceId)), errors.collect(cdk.propertyValidator("vpceId", cdk.validateString)(properties.vpceId)), errors.wrap('supplied properties not correct for "AccessEndpointProperty"');
    }
    function cfnImageBuilderAccessEndpointPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnImageBuilder_AccessEndpointPropertyValidator(properties).assertSuccess(), { EndpointType: cdk.stringToCloudFormation(properties.endpointType), VpceId: cdk.stringToCloudFormation(properties.vpceId) }) : properties;
    }
    function CfnImageBuilderAccessEndpointPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endpointType", "EndpointType", cfn_parse.FromCloudFormation.getString(properties.EndpointType)), ret.addPropertyResult("vpceId", "VpceId", cfn_parse.FromCloudFormation.getString(properties.VpceId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnImageBuilder_DomainJoinInfoPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("directoryName", cdk.validateString)(properties.directoryName)), errors.collect(cdk.propertyValidator("organizationalUnitDistinguishedName", cdk.validateString)(properties.organizationalUnitDistinguishedName)), errors.wrap('supplied properties not correct for "DomainJoinInfoProperty"');
    }
    function cfnImageBuilderDomainJoinInfoPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnImageBuilder_DomainJoinInfoPropertyValidator(properties).assertSuccess(), { DirectoryName: cdk.stringToCloudFormation(properties.directoryName), OrganizationalUnitDistinguishedName: cdk.stringToCloudFormation(properties.organizationalUnitDistinguishedName) }) : properties;
    }
    function CfnImageBuilderDomainJoinInfoPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("directoryName", "DirectoryName", properties.DirectoryName != null ? cfn_parse.FromCloudFormation.getString(properties.DirectoryName) : void 0), ret.addPropertyResult("organizationalUnitDistinguishedName", "OrganizationalUnitDistinguishedName", properties.OrganizationalUnitDistinguishedName != null ? cfn_parse.FromCloudFormation.getString(properties.OrganizationalUnitDistinguishedName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnImageBuilder_VpcConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.wrap('supplied properties not correct for "VpcConfigProperty"');
    }
    function cfnImageBuilderVpcConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnImageBuilder_VpcConfigPropertyValidator(properties).assertSuccess(), { SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds) }) : properties;
    }
    function CfnImageBuilderVpcConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("subnetIds", "SubnetIds", properties.SubnetIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStackPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessEndpoints", cdk.listValidator(CfnStack_AccessEndpointPropertyValidator))(properties.accessEndpoints)), errors.collect(cdk.propertyValidator("applicationSettings", CfnStack_ApplicationSettingsPropertyValidator)(properties.applicationSettings)), errors.collect(cdk.propertyValidator("attributesToDelete", cdk.listValidator(cdk.validateString))(properties.attributesToDelete)), errors.collect(cdk.propertyValidator("deleteStorageConnectors", cdk.validateBoolean)(properties.deleteStorageConnectors)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("displayName", cdk.validateString)(properties.displayName)), errors.collect(cdk.propertyValidator("embedHostDomains", cdk.listValidator(cdk.validateString))(properties.embedHostDomains)), errors.collect(cdk.propertyValidator("feedbackUrl", cdk.validateString)(properties.feedbackUrl)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("redirectUrl", cdk.validateString)(properties.redirectUrl)), errors.collect(cdk.propertyValidator("storageConnectors", cdk.listValidator(CfnStack_StorageConnectorPropertyValidator))(properties.storageConnectors)), errors.collect(cdk.propertyValidator("streamingExperienceSettings", CfnStack_StreamingExperienceSettingsPropertyValidator)(properties.streamingExperienceSettings)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("userSettings", cdk.listValidator(CfnStack_UserSettingPropertyValidator))(properties.userSettings)), errors.wrap('supplied properties not correct for "CfnStackProps"');
    }
    function cfnStackPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStackPropsValidator(properties).assertSuccess(), { AccessEndpoints: cdk.listMapper(cfnStackAccessEndpointPropertyToCloudFormation)(properties.accessEndpoints), ApplicationSettings: cfnStackApplicationSettingsPropertyToCloudFormation(properties.applicationSettings), AttributesToDelete: cdk.listMapper(cdk.stringToCloudFormation)(properties.attributesToDelete), DeleteStorageConnectors: cdk.booleanToCloudFormation(properties.deleteStorageConnectors), Description: cdk.stringToCloudFormation(properties.description), DisplayName: cdk.stringToCloudFormation(properties.displayName), EmbedHostDomains: cdk.listMapper(cdk.stringToCloudFormation)(properties.embedHostDomains), FeedbackURL: cdk.stringToCloudFormation(properties.feedbackUrl), Name: cdk.stringToCloudFormation(properties.name), RedirectURL: cdk.stringToCloudFormation(properties.redirectUrl), StorageConnectors: cdk.listMapper(cfnStackStorageConnectorPropertyToCloudFormation)(properties.storageConnectors), StreamingExperienceSettings: cfnStackStreamingExperienceSettingsPropertyToCloudFormation(properties.streamingExperienceSettings), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), UserSettings: cdk.listMapper(cfnStackUserSettingPropertyToCloudFormation)(properties.userSettings) }) : properties;
    }
    function CfnStackPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessEndpoints", "AccessEndpoints", properties.AccessEndpoints != null ? cfn_parse.FromCloudFormation.getArray(CfnStackAccessEndpointPropertyFromCloudFormation)(properties.AccessEndpoints) : void 0), ret.addPropertyResult("applicationSettings", "ApplicationSettings", properties.ApplicationSettings != null ? CfnStackApplicationSettingsPropertyFromCloudFormation(properties.ApplicationSettings) : void 0), ret.addPropertyResult("attributesToDelete", "AttributesToDelete", properties.AttributesToDelete != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AttributesToDelete) : void 0), ret.addPropertyResult("deleteStorageConnectors", "DeleteStorageConnectors", properties.DeleteStorageConnectors != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeleteStorageConnectors) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("displayName", "DisplayName", properties.DisplayName != null ? cfn_parse.FromCloudFormation.getString(properties.DisplayName) : void 0), ret.addPropertyResult("embedHostDomains", "EmbedHostDomains", properties.EmbedHostDomains != null ? cfn_parse.FromCloudFormation.getStringArray(properties.EmbedHostDomains) : void 0), ret.addPropertyResult("feedbackUrl", "FeedbackURL", properties.FeedbackURL != null ? cfn_parse.FromCloudFormation.getString(properties.FeedbackURL) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("redirectUrl", "RedirectURL", properties.RedirectURL != null ? cfn_parse.FromCloudFormation.getString(properties.RedirectURL) : void 0), ret.addPropertyResult("storageConnectors", "StorageConnectors", properties.StorageConnectors != null ? cfn_parse.FromCloudFormation.getArray(CfnStackStorageConnectorPropertyFromCloudFormation)(properties.StorageConnectors) : void 0), ret.addPropertyResult("streamingExperienceSettings", "StreamingExperienceSettings", properties.StreamingExperienceSettings != null ? CfnStackStreamingExperienceSettingsPropertyFromCloudFormation(properties.StreamingExperienceSettings) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("userSettings", "UserSettings", properties.UserSettings != null ? cfn_parse.FromCloudFormation.getArray(CfnStackUserSettingPropertyFromCloudFormation)(properties.UserSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnStack = class _CfnStack extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnStackPropsFromCloudFormation(resourceProperties), ret = new _CfnStack(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnStack.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appstream_CfnStackProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnStack), error;
        }
        this.accessEndpoints = props.accessEndpoints, this.applicationSettings = props.applicationSettings, this.attributesToDelete = props.attributesToDelete, this.deleteStorageConnectors = props.deleteStorageConnectors, this.description = props.description, this.displayName = props.displayName, this.embedHostDomains = props.embedHostDomains, this.feedbackUrl = props.feedbackUrl, this.name = props.name, this.redirectUrl = props.redirectUrl, this.storageConnectors = props.storageConnectors, this.streamingExperienceSettings = props.streamingExperienceSettings, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::AppStream::Stack", props.tags, { tagPropertyName: "tags" }), this.userSettings = props.userSettings;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStack.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { accessEndpoints: this.accessEndpoints, applicationSettings: this.applicationSettings, attributesToDelete: this.attributesToDelete, deleteStorageConnectors: this.deleteStorageConnectors, description: this.description, displayName: this.displayName, embedHostDomains: this.embedHostDomains, feedbackUrl: this.feedbackUrl, name: this.name, redirectUrl: this.redirectUrl, storageConnectors: this.storageConnectors, streamingExperienceSettings: this.streamingExperienceSettings, tags: this.tags.renderTags(), userSettings: this.userSettings };
      }
      renderProperties(props) {
        return cfnStackPropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnStack[_j] = { fqn: "aws-cdk-lib.aws_appstream.CfnStack", version: "2.80.0" }, CfnStack.CFN_RESOURCE_TYPE_NAME = "AWS::AppStream::Stack", exports2.CfnStack = CfnStack;
    function CfnStack_AccessEndpointPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endpointType", cdk.requiredValidator)(properties.endpointType)), errors.collect(cdk.propertyValidator("endpointType", cdk.validateString)(properties.endpointType)), errors.collect(cdk.propertyValidator("vpceId", cdk.requiredValidator)(properties.vpceId)), errors.collect(cdk.propertyValidator("vpceId", cdk.validateString)(properties.vpceId)), errors.wrap('supplied properties not correct for "AccessEndpointProperty"');
    }
    function cfnStackAccessEndpointPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStack_AccessEndpointPropertyValidator(properties).assertSuccess(), { EndpointType: cdk.stringToCloudFormation(properties.endpointType), VpceId: cdk.stringToCloudFormation(properties.vpceId) }) : properties;
    }
    function CfnStackAccessEndpointPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endpointType", "EndpointType", cfn_parse.FromCloudFormation.getString(properties.EndpointType)), ret.addPropertyResult("vpceId", "VpceId", cfn_parse.FromCloudFormation.getString(properties.VpceId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStack_ApplicationSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("settingsGroup", cdk.validateString)(properties.settingsGroup)), errors.wrap('supplied properties not correct for "ApplicationSettingsProperty"');
    }
    function cfnStackApplicationSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStack_ApplicationSettingsPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled), SettingsGroup: cdk.stringToCloudFormation(properties.settingsGroup) }) : properties;
    }
    function CfnStackApplicationSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addPropertyResult("settingsGroup", "SettingsGroup", properties.SettingsGroup != null ? cfn_parse.FromCloudFormation.getString(properties.SettingsGroup) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStack_StorageConnectorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectorType", cdk.requiredValidator)(properties.connectorType)), errors.collect(cdk.propertyValidator("connectorType", cdk.validateString)(properties.connectorType)), errors.collect(cdk.propertyValidator("domains", cdk.listValidator(cdk.validateString))(properties.domains)), errors.collect(cdk.propertyValidator("resourceIdentifier", cdk.validateString)(properties.resourceIdentifier)), errors.wrap('supplied properties not correct for "StorageConnectorProperty"');
    }
    function cfnStackStorageConnectorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStack_StorageConnectorPropertyValidator(properties).assertSuccess(), { ConnectorType: cdk.stringToCloudFormation(properties.connectorType), Domains: cdk.listMapper(cdk.stringToCloudFormation)(properties.domains), ResourceIdentifier: cdk.stringToCloudFormation(properties.resourceIdentifier) }) : properties;
    }
    function CfnStackStorageConnectorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectorType", "ConnectorType", cfn_parse.FromCloudFormation.getString(properties.ConnectorType)), ret.addPropertyResult("domains", "Domains", properties.Domains != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Domains) : void 0), ret.addPropertyResult("resourceIdentifier", "ResourceIdentifier", properties.ResourceIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceIdentifier) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStack_StreamingExperienceSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("preferredProtocol", cdk.validateString)(properties.preferredProtocol)), errors.wrap('supplied properties not correct for "StreamingExperienceSettingsProperty"');
    }
    function cfnStackStreamingExperienceSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStack_StreamingExperienceSettingsPropertyValidator(properties).assertSuccess(), { PreferredProtocol: cdk.stringToCloudFormation(properties.preferredProtocol) }) : properties;
    }
    function CfnStackStreamingExperienceSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("preferredProtocol", "PreferredProtocol", properties.PreferredProtocol != null ? cfn_parse.FromCloudFormation.getString(properties.PreferredProtocol) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStack_UserSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.requiredValidator)(properties.action)), errors.collect(cdk.propertyValidator("action", cdk.validateString)(properties.action)), errors.collect(cdk.propertyValidator("permission", cdk.requiredValidator)(properties.permission)), errors.collect(cdk.propertyValidator("permission", cdk.validateString)(properties.permission)), errors.wrap('supplied properties not correct for "UserSettingProperty"');
    }
    function cfnStackUserSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStack_UserSettingPropertyValidator(properties).assertSuccess(), { Action: cdk.stringToCloudFormation(properties.action), Permission: cdk.stringToCloudFormation(properties.permission) }) : properties;
    }
    function CfnStackUserSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", cfn_parse.FromCloudFormation.getString(properties.Action)), ret.addPropertyResult("permission", "Permission", cfn_parse.FromCloudFormation.getString(properties.Permission)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStackFleetAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fleetName", cdk.requiredValidator)(properties.fleetName)), errors.collect(cdk.propertyValidator("fleetName", cdk.validateString)(properties.fleetName)), errors.collect(cdk.propertyValidator("stackName", cdk.requiredValidator)(properties.stackName)), errors.collect(cdk.propertyValidator("stackName", cdk.validateString)(properties.stackName)), errors.wrap('supplied properties not correct for "CfnStackFleetAssociationProps"');
    }
    function cfnStackFleetAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStackFleetAssociationPropsValidator(properties).assertSuccess(), { FleetName: cdk.stringToCloudFormation(properties.fleetName), StackName: cdk.stringToCloudFormation(properties.stackName) }) : properties;
    }
    function CfnStackFleetAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fleetName", "FleetName", cfn_parse.FromCloudFormation.getString(properties.FleetName)), ret.addPropertyResult("stackName", "StackName", cfn_parse.FromCloudFormation.getString(properties.StackName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnStackFleetAssociation = class _CfnStackFleetAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnStackFleetAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnStackFleetAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnStackFleetAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appstream_CfnStackFleetAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnStackFleetAssociation), error;
        }
        cdk.requireProperty(props, "fleetName", this), cdk.requireProperty(props, "stackName", this), this.fleetName = props.fleetName, this.stackName = props.stackName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStackFleetAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { fleetName: this.fleetName, stackName: this.stackName };
      }
      renderProperties(props) {
        return cfnStackFleetAssociationPropsToCloudFormation(props);
      }
    };
    _k = JSII_RTTI_SYMBOL_1, CfnStackFleetAssociation[_k] = { fqn: "aws-cdk-lib.aws_appstream.CfnStackFleetAssociation", version: "2.80.0" }, CfnStackFleetAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::AppStream::StackFleetAssociation", exports2.CfnStackFleetAssociation = CfnStackFleetAssociation;
    function CfnStackUserAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authenticationType", cdk.requiredValidator)(properties.authenticationType)), errors.collect(cdk.propertyValidator("authenticationType", cdk.validateString)(properties.authenticationType)), errors.collect(cdk.propertyValidator("sendEmailNotification", cdk.validateBoolean)(properties.sendEmailNotification)), errors.collect(cdk.propertyValidator("stackName", cdk.requiredValidator)(properties.stackName)), errors.collect(cdk.propertyValidator("stackName", cdk.validateString)(properties.stackName)), errors.collect(cdk.propertyValidator("userName", cdk.requiredValidator)(properties.userName)), errors.collect(cdk.propertyValidator("userName", cdk.validateString)(properties.userName)), errors.wrap('supplied properties not correct for "CfnStackUserAssociationProps"');
    }
    function cfnStackUserAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStackUserAssociationPropsValidator(properties).assertSuccess(), { AuthenticationType: cdk.stringToCloudFormation(properties.authenticationType), StackName: cdk.stringToCloudFormation(properties.stackName), UserName: cdk.stringToCloudFormation(properties.userName), SendEmailNotification: cdk.booleanToCloudFormation(properties.sendEmailNotification) }) : properties;
    }
    function CfnStackUserAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authenticationType", "AuthenticationType", cfn_parse.FromCloudFormation.getString(properties.AuthenticationType)), ret.addPropertyResult("stackName", "StackName", cfn_parse.FromCloudFormation.getString(properties.StackName)), ret.addPropertyResult("userName", "UserName", cfn_parse.FromCloudFormation.getString(properties.UserName)), ret.addPropertyResult("sendEmailNotification", "SendEmailNotification", properties.SendEmailNotification != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SendEmailNotification) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnStackUserAssociation = class _CfnStackUserAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnStackUserAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnStackUserAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnStackUserAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appstream_CfnStackUserAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnStackUserAssociation), error;
        }
        cdk.requireProperty(props, "authenticationType", this), cdk.requireProperty(props, "stackName", this), cdk.requireProperty(props, "userName", this), this.authenticationType = props.authenticationType, this.stackName = props.stackName, this.userName = props.userName, this.sendEmailNotification = props.sendEmailNotification;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStackUserAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { authenticationType: this.authenticationType, stackName: this.stackName, userName: this.userName, sendEmailNotification: this.sendEmailNotification };
      }
      renderProperties(props) {
        return cfnStackUserAssociationPropsToCloudFormation(props);
      }
    };
    _l = JSII_RTTI_SYMBOL_1, CfnStackUserAssociation[_l] = { fqn: "aws-cdk-lib.aws_appstream.CfnStackUserAssociation", version: "2.80.0" }, CfnStackUserAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::AppStream::StackUserAssociation", exports2.CfnStackUserAssociation = CfnStackUserAssociation;
    function CfnUserPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authenticationType", cdk.requiredValidator)(properties.authenticationType)), errors.collect(cdk.propertyValidator("authenticationType", cdk.validateString)(properties.authenticationType)), errors.collect(cdk.propertyValidator("firstName", cdk.validateString)(properties.firstName)), errors.collect(cdk.propertyValidator("lastName", cdk.validateString)(properties.lastName)), errors.collect(cdk.propertyValidator("messageAction", cdk.validateString)(properties.messageAction)), errors.collect(cdk.propertyValidator("userName", cdk.requiredValidator)(properties.userName)), errors.collect(cdk.propertyValidator("userName", cdk.validateString)(properties.userName)), errors.wrap('supplied properties not correct for "CfnUserProps"');
    }
    function cfnUserPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPropsValidator(properties).assertSuccess(), { AuthenticationType: cdk.stringToCloudFormation(properties.authenticationType), UserName: cdk.stringToCloudFormation(properties.userName), FirstName: cdk.stringToCloudFormation(properties.firstName), LastName: cdk.stringToCloudFormation(properties.lastName), MessageAction: cdk.stringToCloudFormation(properties.messageAction) }) : properties;
    }
    function CfnUserPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authenticationType", "AuthenticationType", cfn_parse.FromCloudFormation.getString(properties.AuthenticationType)), ret.addPropertyResult("userName", "UserName", cfn_parse.FromCloudFormation.getString(properties.UserName)), ret.addPropertyResult("firstName", "FirstName", properties.FirstName != null ? cfn_parse.FromCloudFormation.getString(properties.FirstName) : void 0), ret.addPropertyResult("lastName", "LastName", properties.LastName != null ? cfn_parse.FromCloudFormation.getString(properties.LastName) : void 0), ret.addPropertyResult("messageAction", "MessageAction", properties.MessageAction != null ? cfn_parse.FromCloudFormation.getString(properties.MessageAction) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnUser = class _CfnUser extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnUserPropsFromCloudFormation(resourceProperties), ret = new _CfnUser(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnUser.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appstream_CfnUserProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnUser), error;
        }
        cdk.requireProperty(props, "authenticationType", this), cdk.requireProperty(props, "userName", this), this.authenticationType = props.authenticationType, this.userName = props.userName, this.firstName = props.firstName, this.lastName = props.lastName, this.messageAction = props.messageAction;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnUser.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { authenticationType: this.authenticationType, userName: this.userName, firstName: this.firstName, lastName: this.lastName, messageAction: this.messageAction };
      }
      renderProperties(props) {
        return cfnUserPropsToCloudFormation(props);
      }
    };
    _m = JSII_RTTI_SYMBOL_1, CfnUser[_m] = { fqn: "aws-cdk-lib.aws_appstream.CfnUser", version: "2.80.0" }, CfnUser.CFN_RESOURCE_TYPE_NAME = "AWS::AppStream::User", exports2.CfnUser = CfnUser;
  }
});

// node_modules/aws-cdk-lib/aws-appstream/lib/index.js
var require_lib47 = __commonJS({
  "node_modules/aws-cdk-lib/aws-appstream/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_appstream_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-appstream/index.js
var require_aws_appstream = __commonJS({
  "node_modules/aws-cdk-lib/aws-appstream/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib47(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-appsync/lib/appsync.generated.js
var require_appsync_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-appsync/lib/appsync.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnResolver = exports2.CfnGraphQLSchema = exports2.CfnGraphQLApi = exports2.CfnFunctionConfiguration = exports2.CfnDomainNameApiAssociation = exports2.CfnDomainName = exports2.CfnDataSource = exports2.CfnApiKey = exports2.CfnApiCache = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnApiCachePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiCachingBehavior", cdk.requiredValidator)(properties.apiCachingBehavior)), errors.collect(cdk.propertyValidator("apiCachingBehavior", cdk.validateString)(properties.apiCachingBehavior)), errors.collect(cdk.propertyValidator("apiId", cdk.requiredValidator)(properties.apiId)), errors.collect(cdk.propertyValidator("apiId", cdk.validateString)(properties.apiId)), errors.collect(cdk.propertyValidator("atRestEncryptionEnabled", cdk.validateBoolean)(properties.atRestEncryptionEnabled)), errors.collect(cdk.propertyValidator("transitEncryptionEnabled", cdk.validateBoolean)(properties.transitEncryptionEnabled)), errors.collect(cdk.propertyValidator("ttl", cdk.requiredValidator)(properties.ttl)), errors.collect(cdk.propertyValidator("ttl", cdk.validateNumber)(properties.ttl)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnApiCacheProps"');
    }
    function cfnApiCachePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApiCachePropsValidator(properties).assertSuccess(), { ApiCachingBehavior: cdk.stringToCloudFormation(properties.apiCachingBehavior), ApiId: cdk.stringToCloudFormation(properties.apiId), Ttl: cdk.numberToCloudFormation(properties.ttl), Type: cdk.stringToCloudFormation(properties.type), AtRestEncryptionEnabled: cdk.booleanToCloudFormation(properties.atRestEncryptionEnabled), TransitEncryptionEnabled: cdk.booleanToCloudFormation(properties.transitEncryptionEnabled) }) : properties;
    }
    function CfnApiCachePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiCachingBehavior", "ApiCachingBehavior", cfn_parse.FromCloudFormation.getString(properties.ApiCachingBehavior)), ret.addPropertyResult("apiId", "ApiId", cfn_parse.FromCloudFormation.getString(properties.ApiId)), ret.addPropertyResult("ttl", "Ttl", cfn_parse.FromCloudFormation.getNumber(properties.Ttl)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("atRestEncryptionEnabled", "AtRestEncryptionEnabled", properties.AtRestEncryptionEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AtRestEncryptionEnabled) : void 0), ret.addPropertyResult("transitEncryptionEnabled", "TransitEncryptionEnabled", properties.TransitEncryptionEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.TransitEncryptionEnabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApiCache = class _CfnApiCache extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApiCachePropsFromCloudFormation(resourceProperties), ret = new _CfnApiCache(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApiCache.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_CfnApiCacheProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApiCache), error;
        }
        cdk.requireProperty(props, "apiCachingBehavior", this), cdk.requireProperty(props, "apiId", this), cdk.requireProperty(props, "ttl", this), cdk.requireProperty(props, "type", this), this.apiCachingBehavior = props.apiCachingBehavior, this.apiId = props.apiId, this.ttl = props.ttl, this.type = props.type, this.atRestEncryptionEnabled = props.atRestEncryptionEnabled, this.transitEncryptionEnabled = props.transitEncryptionEnabled;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApiCache.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiCachingBehavior: this.apiCachingBehavior, apiId: this.apiId, ttl: this.ttl, type: this.type, atRestEncryptionEnabled: this.atRestEncryptionEnabled, transitEncryptionEnabled: this.transitEncryptionEnabled };
      }
      renderProperties(props) {
        return cfnApiCachePropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnApiCache[_a] = { fqn: "aws-cdk-lib.aws_appsync.CfnApiCache", version: "2.80.0" }, CfnApiCache.CFN_RESOURCE_TYPE_NAME = "AWS::AppSync::ApiCache", exports2.CfnApiCache = CfnApiCache;
    function CfnApiKeyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiId", cdk.requiredValidator)(properties.apiId)), errors.collect(cdk.propertyValidator("apiId", cdk.validateString)(properties.apiId)), errors.collect(cdk.propertyValidator("apiKeyId", cdk.validateString)(properties.apiKeyId)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("expires", cdk.validateNumber)(properties.expires)), errors.wrap('supplied properties not correct for "CfnApiKeyProps"');
    }
    function cfnApiKeyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApiKeyPropsValidator(properties).assertSuccess(), { ApiId: cdk.stringToCloudFormation(properties.apiId), ApiKeyId: cdk.stringToCloudFormation(properties.apiKeyId), Description: cdk.stringToCloudFormation(properties.description), Expires: cdk.numberToCloudFormation(properties.expires) }) : properties;
    }
    function CfnApiKeyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiId", "ApiId", cfn_parse.FromCloudFormation.getString(properties.ApiId)), ret.addPropertyResult("apiKeyId", "ApiKeyId", properties.ApiKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.ApiKeyId) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("expires", "Expires", properties.Expires != null ? cfn_parse.FromCloudFormation.getNumber(properties.Expires) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApiKey = class _CfnApiKey extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApiKeyPropsFromCloudFormation(resourceProperties), ret = new _CfnApiKey(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApiKey.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_CfnApiKeyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApiKey), error;
        }
        cdk.requireProperty(props, "apiId", this), this.attrApiKey = cdk.Token.asString(this.getAtt("ApiKey", cdk.ResolutionTypeHint.STRING)), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.apiId = props.apiId, this.apiKeyId = props.apiKeyId, this.description = props.description, this.expires = props.expires;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApiKey.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiId: this.apiId, apiKeyId: this.apiKeyId, description: this.description, expires: this.expires };
      }
      renderProperties(props) {
        return cfnApiKeyPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnApiKey[_b] = { fqn: "aws-cdk-lib.aws_appsync.CfnApiKey", version: "2.80.0" }, CfnApiKey.CFN_RESOURCE_TYPE_NAME = "AWS::AppSync::ApiKey", exports2.CfnApiKey = CfnApiKey;
    function CfnDataSourcePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiId", cdk.requiredValidator)(properties.apiId)), errors.collect(cdk.propertyValidator("apiId", cdk.validateString)(properties.apiId)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("dynamoDbConfig", CfnDataSource_DynamoDBConfigPropertyValidator)(properties.dynamoDbConfig)), errors.collect(cdk.propertyValidator("elasticsearchConfig", CfnDataSource_ElasticsearchConfigPropertyValidator)(properties.elasticsearchConfig)), errors.collect(cdk.propertyValidator("eventBridgeConfig", CfnDataSource_EventBridgeConfigPropertyValidator)(properties.eventBridgeConfig)), errors.collect(cdk.propertyValidator("httpConfig", CfnDataSource_HttpConfigPropertyValidator)(properties.httpConfig)), errors.collect(cdk.propertyValidator("lambdaConfig", CfnDataSource_LambdaConfigPropertyValidator)(properties.lambdaConfig)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("openSearchServiceConfig", CfnDataSource_OpenSearchServiceConfigPropertyValidator)(properties.openSearchServiceConfig)), errors.collect(cdk.propertyValidator("relationalDatabaseConfig", CfnDataSource_RelationalDatabaseConfigPropertyValidator)(properties.relationalDatabaseConfig)), errors.collect(cdk.propertyValidator("serviceRoleArn", cdk.validateString)(properties.serviceRoleArn)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnDataSourceProps"');
    }
    function cfnDataSourcePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSourcePropsValidator(properties).assertSuccess(), { ApiId: cdk.stringToCloudFormation(properties.apiId), Name: cdk.stringToCloudFormation(properties.name), Type: cdk.stringToCloudFormation(properties.type), Description: cdk.stringToCloudFormation(properties.description), DynamoDBConfig: cfnDataSourceDynamoDBConfigPropertyToCloudFormation(properties.dynamoDbConfig), ElasticsearchConfig: cfnDataSourceElasticsearchConfigPropertyToCloudFormation(properties.elasticsearchConfig), EventBridgeConfig: cfnDataSourceEventBridgeConfigPropertyToCloudFormation(properties.eventBridgeConfig), HttpConfig: cfnDataSourceHttpConfigPropertyToCloudFormation(properties.httpConfig), LambdaConfig: cfnDataSourceLambdaConfigPropertyToCloudFormation(properties.lambdaConfig), OpenSearchServiceConfig: cfnDataSourceOpenSearchServiceConfigPropertyToCloudFormation(properties.openSearchServiceConfig), RelationalDatabaseConfig: cfnDataSourceRelationalDatabaseConfigPropertyToCloudFormation(properties.relationalDatabaseConfig), ServiceRoleArn: cdk.stringToCloudFormation(properties.serviceRoleArn) }) : properties;
    }
    function CfnDataSourcePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiId", "ApiId", cfn_parse.FromCloudFormation.getString(properties.ApiId)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("dynamoDbConfig", "DynamoDBConfig", properties.DynamoDBConfig != null ? CfnDataSourceDynamoDBConfigPropertyFromCloudFormation(properties.DynamoDBConfig) : void 0), ret.addPropertyResult("elasticsearchConfig", "ElasticsearchConfig", properties.ElasticsearchConfig != null ? CfnDataSourceElasticsearchConfigPropertyFromCloudFormation(properties.ElasticsearchConfig) : void 0), ret.addPropertyResult("eventBridgeConfig", "EventBridgeConfig", properties.EventBridgeConfig != null ? CfnDataSourceEventBridgeConfigPropertyFromCloudFormation(properties.EventBridgeConfig) : void 0), ret.addPropertyResult("httpConfig", "HttpConfig", properties.HttpConfig != null ? CfnDataSourceHttpConfigPropertyFromCloudFormation(properties.HttpConfig) : void 0), ret.addPropertyResult("lambdaConfig", "LambdaConfig", properties.LambdaConfig != null ? CfnDataSourceLambdaConfigPropertyFromCloudFormation(properties.LambdaConfig) : void 0), ret.addPropertyResult("openSearchServiceConfig", "OpenSearchServiceConfig", properties.OpenSearchServiceConfig != null ? CfnDataSourceOpenSearchServiceConfigPropertyFromCloudFormation(properties.OpenSearchServiceConfig) : void 0), ret.addPropertyResult("relationalDatabaseConfig", "RelationalDatabaseConfig", properties.RelationalDatabaseConfig != null ? CfnDataSourceRelationalDatabaseConfigPropertyFromCloudFormation(properties.RelationalDatabaseConfig) : void 0), ret.addPropertyResult("serviceRoleArn", "ServiceRoleArn", properties.ServiceRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceRoleArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDataSource = class _CfnDataSource extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDataSourcePropsFromCloudFormation(resourceProperties), ret = new _CfnDataSource(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDataSource.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_CfnDataSourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDataSource), error;
        }
        cdk.requireProperty(props, "apiId", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "type", this), this.attrDataSourceArn = cdk.Token.asString(this.getAtt("DataSourceArn", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.apiId = props.apiId, this.name = props.name, this.type = props.type, this.description = props.description, this.dynamoDbConfig = props.dynamoDbConfig, this.elasticsearchConfig = props.elasticsearchConfig, this.eventBridgeConfig = props.eventBridgeConfig, this.httpConfig = props.httpConfig, this.lambdaConfig = props.lambdaConfig, this.openSearchServiceConfig = props.openSearchServiceConfig, this.relationalDatabaseConfig = props.relationalDatabaseConfig, this.serviceRoleArn = props.serviceRoleArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDataSource.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiId: this.apiId, name: this.name, type: this.type, description: this.description, dynamoDbConfig: this.dynamoDbConfig, elasticsearchConfig: this.elasticsearchConfig, eventBridgeConfig: this.eventBridgeConfig, httpConfig: this.httpConfig, lambdaConfig: this.lambdaConfig, openSearchServiceConfig: this.openSearchServiceConfig, relationalDatabaseConfig: this.relationalDatabaseConfig, serviceRoleArn: this.serviceRoleArn };
      }
      renderProperties(props) {
        return cfnDataSourcePropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnDataSource[_c] = { fqn: "aws-cdk-lib.aws_appsync.CfnDataSource", version: "2.80.0" }, CfnDataSource.CFN_RESOURCE_TYPE_NAME = "AWS::AppSync::DataSource", exports2.CfnDataSource = CfnDataSource;
    function CfnDataSource_AuthorizationConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authorizationType", cdk.requiredValidator)(properties.authorizationType)), errors.collect(cdk.propertyValidator("authorizationType", cdk.validateString)(properties.authorizationType)), errors.collect(cdk.propertyValidator("awsIamConfig", CfnDataSource_AwsIamConfigPropertyValidator)(properties.awsIamConfig)), errors.wrap('supplied properties not correct for "AuthorizationConfigProperty"');
    }
    function cfnDataSourceAuthorizationConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_AuthorizationConfigPropertyValidator(properties).assertSuccess(), { AuthorizationType: cdk.stringToCloudFormation(properties.authorizationType), AwsIamConfig: cfnDataSourceAwsIamConfigPropertyToCloudFormation(properties.awsIamConfig) }) : properties;
    }
    function CfnDataSourceAuthorizationConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authorizationType", "AuthorizationType", cfn_parse.FromCloudFormation.getString(properties.AuthorizationType)), ret.addPropertyResult("awsIamConfig", "AwsIamConfig", properties.AwsIamConfig != null ? CfnDataSourceAwsIamConfigPropertyFromCloudFormation(properties.AwsIamConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_AwsIamConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("signingRegion", cdk.validateString)(properties.signingRegion)), errors.collect(cdk.propertyValidator("signingServiceName", cdk.validateString)(properties.signingServiceName)), errors.wrap('supplied properties not correct for "AwsIamConfigProperty"');
    }
    function cfnDataSourceAwsIamConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_AwsIamConfigPropertyValidator(properties).assertSuccess(), { SigningRegion: cdk.stringToCloudFormation(properties.signingRegion), SigningServiceName: cdk.stringToCloudFormation(properties.signingServiceName) }) : properties;
    }
    function CfnDataSourceAwsIamConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("signingRegion", "SigningRegion", properties.SigningRegion != null ? cfn_parse.FromCloudFormation.getString(properties.SigningRegion) : void 0), ret.addPropertyResult("signingServiceName", "SigningServiceName", properties.SigningServiceName != null ? cfn_parse.FromCloudFormation.getString(properties.SigningServiceName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_DeltaSyncConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("baseTableTtl", cdk.requiredValidator)(properties.baseTableTtl)), errors.collect(cdk.propertyValidator("baseTableTtl", cdk.validateString)(properties.baseTableTtl)), errors.collect(cdk.propertyValidator("deltaSyncTableName", cdk.requiredValidator)(properties.deltaSyncTableName)), errors.collect(cdk.propertyValidator("deltaSyncTableName", cdk.validateString)(properties.deltaSyncTableName)), errors.collect(cdk.propertyValidator("deltaSyncTableTtl", cdk.requiredValidator)(properties.deltaSyncTableTtl)), errors.collect(cdk.propertyValidator("deltaSyncTableTtl", cdk.validateString)(properties.deltaSyncTableTtl)), errors.wrap('supplied properties not correct for "DeltaSyncConfigProperty"');
    }
    function cfnDataSourceDeltaSyncConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_DeltaSyncConfigPropertyValidator(properties).assertSuccess(), { BaseTableTTL: cdk.stringToCloudFormation(properties.baseTableTtl), DeltaSyncTableName: cdk.stringToCloudFormation(properties.deltaSyncTableName), DeltaSyncTableTTL: cdk.stringToCloudFormation(properties.deltaSyncTableTtl) }) : properties;
    }
    function CfnDataSourceDeltaSyncConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("baseTableTtl", "BaseTableTTL", cfn_parse.FromCloudFormation.getString(properties.BaseTableTTL)), ret.addPropertyResult("deltaSyncTableName", "DeltaSyncTableName", cfn_parse.FromCloudFormation.getString(properties.DeltaSyncTableName)), ret.addPropertyResult("deltaSyncTableTtl", "DeltaSyncTableTTL", cfn_parse.FromCloudFormation.getString(properties.DeltaSyncTableTTL)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_DynamoDBConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("awsRegion", cdk.requiredValidator)(properties.awsRegion)), errors.collect(cdk.propertyValidator("awsRegion", cdk.validateString)(properties.awsRegion)), errors.collect(cdk.propertyValidator("deltaSyncConfig", CfnDataSource_DeltaSyncConfigPropertyValidator)(properties.deltaSyncConfig)), errors.collect(cdk.propertyValidator("tableName", cdk.requiredValidator)(properties.tableName)), errors.collect(cdk.propertyValidator("tableName", cdk.validateString)(properties.tableName)), errors.collect(cdk.propertyValidator("useCallerCredentials", cdk.validateBoolean)(properties.useCallerCredentials)), errors.collect(cdk.propertyValidator("versioned", cdk.validateBoolean)(properties.versioned)), errors.wrap('supplied properties not correct for "DynamoDBConfigProperty"');
    }
    function cfnDataSourceDynamoDBConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_DynamoDBConfigPropertyValidator(properties).assertSuccess(), { AwsRegion: cdk.stringToCloudFormation(properties.awsRegion), DeltaSyncConfig: cfnDataSourceDeltaSyncConfigPropertyToCloudFormation(properties.deltaSyncConfig), TableName: cdk.stringToCloudFormation(properties.tableName), UseCallerCredentials: cdk.booleanToCloudFormation(properties.useCallerCredentials), Versioned: cdk.booleanToCloudFormation(properties.versioned) }) : properties;
    }
    function CfnDataSourceDynamoDBConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("awsRegion", "AwsRegion", cfn_parse.FromCloudFormation.getString(properties.AwsRegion)), ret.addPropertyResult("deltaSyncConfig", "DeltaSyncConfig", properties.DeltaSyncConfig != null ? CfnDataSourceDeltaSyncConfigPropertyFromCloudFormation(properties.DeltaSyncConfig) : void 0), ret.addPropertyResult("tableName", "TableName", cfn_parse.FromCloudFormation.getString(properties.TableName)), ret.addPropertyResult("useCallerCredentials", "UseCallerCredentials", properties.UseCallerCredentials != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseCallerCredentials) : void 0), ret.addPropertyResult("versioned", "Versioned", properties.Versioned != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Versioned) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_ElasticsearchConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("awsRegion", cdk.requiredValidator)(properties.awsRegion)), errors.collect(cdk.propertyValidator("awsRegion", cdk.validateString)(properties.awsRegion)), errors.collect(cdk.propertyValidator("endpoint", cdk.requiredValidator)(properties.endpoint)), errors.collect(cdk.propertyValidator("endpoint", cdk.validateString)(properties.endpoint)), errors.wrap('supplied properties not correct for "ElasticsearchConfigProperty"');
    }
    function cfnDataSourceElasticsearchConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_ElasticsearchConfigPropertyValidator(properties).assertSuccess(), { AwsRegion: cdk.stringToCloudFormation(properties.awsRegion), Endpoint: cdk.stringToCloudFormation(properties.endpoint) }) : properties;
    }
    function CfnDataSourceElasticsearchConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("awsRegion", "AwsRegion", cfn_parse.FromCloudFormation.getString(properties.AwsRegion)), ret.addPropertyResult("endpoint", "Endpoint", cfn_parse.FromCloudFormation.getString(properties.Endpoint)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_EventBridgeConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("eventBusArn", cdk.requiredValidator)(properties.eventBusArn)), errors.collect(cdk.propertyValidator("eventBusArn", cdk.validateString)(properties.eventBusArn)), errors.wrap('supplied properties not correct for "EventBridgeConfigProperty"');
    }
    function cfnDataSourceEventBridgeConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_EventBridgeConfigPropertyValidator(properties).assertSuccess(), { EventBusArn: cdk.stringToCloudFormation(properties.eventBusArn) }) : properties;
    }
    function CfnDataSourceEventBridgeConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("eventBusArn", "EventBusArn", cfn_parse.FromCloudFormation.getString(properties.EventBusArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_HttpConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authorizationConfig", CfnDataSource_AuthorizationConfigPropertyValidator)(properties.authorizationConfig)), errors.collect(cdk.propertyValidator("endpoint", cdk.requiredValidator)(properties.endpoint)), errors.collect(cdk.propertyValidator("endpoint", cdk.validateString)(properties.endpoint)), errors.wrap('supplied properties not correct for "HttpConfigProperty"');
    }
    function cfnDataSourceHttpConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_HttpConfigPropertyValidator(properties).assertSuccess(), { AuthorizationConfig: cfnDataSourceAuthorizationConfigPropertyToCloudFormation(properties.authorizationConfig), Endpoint: cdk.stringToCloudFormation(properties.endpoint) }) : properties;
    }
    function CfnDataSourceHttpConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authorizationConfig", "AuthorizationConfig", properties.AuthorizationConfig != null ? CfnDataSourceAuthorizationConfigPropertyFromCloudFormation(properties.AuthorizationConfig) : void 0), ret.addPropertyResult("endpoint", "Endpoint", cfn_parse.FromCloudFormation.getString(properties.Endpoint)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_LambdaConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("lambdaFunctionArn", cdk.requiredValidator)(properties.lambdaFunctionArn)), errors.collect(cdk.propertyValidator("lambdaFunctionArn", cdk.validateString)(properties.lambdaFunctionArn)), errors.wrap('supplied properties not correct for "LambdaConfigProperty"');
    }
    function cfnDataSourceLambdaConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_LambdaConfigPropertyValidator(properties).assertSuccess(), { LambdaFunctionArn: cdk.stringToCloudFormation(properties.lambdaFunctionArn) }) : properties;
    }
    function CfnDataSourceLambdaConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("lambdaFunctionArn", "LambdaFunctionArn", cfn_parse.FromCloudFormation.getString(properties.LambdaFunctionArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_OpenSearchServiceConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("awsRegion", cdk.requiredValidator)(properties.awsRegion)), errors.collect(cdk.propertyValidator("awsRegion", cdk.validateString)(properties.awsRegion)), errors.collect(cdk.propertyValidator("endpoint", cdk.requiredValidator)(properties.endpoint)), errors.collect(cdk.propertyValidator("endpoint", cdk.validateString)(properties.endpoint)), errors.wrap('supplied properties not correct for "OpenSearchServiceConfigProperty"');
    }
    function cfnDataSourceOpenSearchServiceConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_OpenSearchServiceConfigPropertyValidator(properties).assertSuccess(), { AwsRegion: cdk.stringToCloudFormation(properties.awsRegion), Endpoint: cdk.stringToCloudFormation(properties.endpoint) }) : properties;
    }
    function CfnDataSourceOpenSearchServiceConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("awsRegion", "AwsRegion", cfn_parse.FromCloudFormation.getString(properties.AwsRegion)), ret.addPropertyResult("endpoint", "Endpoint", cfn_parse.FromCloudFormation.getString(properties.Endpoint)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_RdsHttpEndpointConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("awsRegion", cdk.requiredValidator)(properties.awsRegion)), errors.collect(cdk.propertyValidator("awsRegion", cdk.validateString)(properties.awsRegion)), errors.collect(cdk.propertyValidator("awsSecretStoreArn", cdk.requiredValidator)(properties.awsSecretStoreArn)), errors.collect(cdk.propertyValidator("awsSecretStoreArn", cdk.validateString)(properties.awsSecretStoreArn)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("dbClusterIdentifier", cdk.requiredValidator)(properties.dbClusterIdentifier)), errors.collect(cdk.propertyValidator("dbClusterIdentifier", cdk.validateString)(properties.dbClusterIdentifier)), errors.collect(cdk.propertyValidator("schema", cdk.validateString)(properties.schema)), errors.wrap('supplied properties not correct for "RdsHttpEndpointConfigProperty"');
    }
    function cfnDataSourceRdsHttpEndpointConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_RdsHttpEndpointConfigPropertyValidator(properties).assertSuccess(), { AwsRegion: cdk.stringToCloudFormation(properties.awsRegion), AwsSecretStoreArn: cdk.stringToCloudFormation(properties.awsSecretStoreArn), DatabaseName: cdk.stringToCloudFormation(properties.databaseName), DbClusterIdentifier: cdk.stringToCloudFormation(properties.dbClusterIdentifier), Schema: cdk.stringToCloudFormation(properties.schema) }) : properties;
    }
    function CfnDataSourceRdsHttpEndpointConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("awsRegion", "AwsRegion", cfn_parse.FromCloudFormation.getString(properties.AwsRegion)), ret.addPropertyResult("awsSecretStoreArn", "AwsSecretStoreArn", cfn_parse.FromCloudFormation.getString(properties.AwsSecretStoreArn)), ret.addPropertyResult("databaseName", "DatabaseName", properties.DatabaseName != null ? cfn_parse.FromCloudFormation.getString(properties.DatabaseName) : void 0), ret.addPropertyResult("dbClusterIdentifier", "DbClusterIdentifier", cfn_parse.FromCloudFormation.getString(properties.DbClusterIdentifier)), ret.addPropertyResult("schema", "Schema", properties.Schema != null ? cfn_parse.FromCloudFormation.getString(properties.Schema) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_RelationalDatabaseConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("rdsHttpEndpointConfig", CfnDataSource_RdsHttpEndpointConfigPropertyValidator)(properties.rdsHttpEndpointConfig)), errors.collect(cdk.propertyValidator("relationalDatabaseSourceType", cdk.requiredValidator)(properties.relationalDatabaseSourceType)), errors.collect(cdk.propertyValidator("relationalDatabaseSourceType", cdk.validateString)(properties.relationalDatabaseSourceType)), errors.wrap('supplied properties not correct for "RelationalDatabaseConfigProperty"');
    }
    function cfnDataSourceRelationalDatabaseConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_RelationalDatabaseConfigPropertyValidator(properties).assertSuccess(), { RdsHttpEndpointConfig: cfnDataSourceRdsHttpEndpointConfigPropertyToCloudFormation(properties.rdsHttpEndpointConfig), RelationalDatabaseSourceType: cdk.stringToCloudFormation(properties.relationalDatabaseSourceType) }) : properties;
    }
    function CfnDataSourceRelationalDatabaseConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("rdsHttpEndpointConfig", "RdsHttpEndpointConfig", properties.RdsHttpEndpointConfig != null ? CfnDataSourceRdsHttpEndpointConfigPropertyFromCloudFormation(properties.RdsHttpEndpointConfig) : void 0), ret.addPropertyResult("relationalDatabaseSourceType", "RelationalDatabaseSourceType", cfn_parse.FromCloudFormation.getString(properties.RelationalDatabaseSourceType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomainNamePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateArn", cdk.requiredValidator)(properties.certificateArn)), errors.collect(cdk.propertyValidator("certificateArn", cdk.validateString)(properties.certificateArn)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("domainName", cdk.requiredValidator)(properties.domainName)), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.wrap('supplied properties not correct for "CfnDomainNameProps"');
    }
    function cfnDomainNamePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomainNamePropsValidator(properties).assertSuccess(), { CertificateArn: cdk.stringToCloudFormation(properties.certificateArn), DomainName: cdk.stringToCloudFormation(properties.domainName), Description: cdk.stringToCloudFormation(properties.description) }) : properties;
    }
    function CfnDomainNamePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificateArn", "CertificateArn", cfn_parse.FromCloudFormation.getString(properties.CertificateArn)), ret.addPropertyResult("domainName", "DomainName", cfn_parse.FromCloudFormation.getString(properties.DomainName)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDomainName = class _CfnDomainName extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDomainNamePropsFromCloudFormation(resourceProperties), ret = new _CfnDomainName(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDomainName.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_CfnDomainNameProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDomainName), error;
        }
        cdk.requireProperty(props, "certificateArn", this), cdk.requireProperty(props, "domainName", this), this.attrAppSyncDomainName = cdk.Token.asString(this.getAtt("AppSyncDomainName", cdk.ResolutionTypeHint.STRING)), this.attrDomainName = cdk.Token.asString(this.getAtt("DomainName", cdk.ResolutionTypeHint.STRING)), this.attrHostedZoneId = cdk.Token.asString(this.getAtt("HostedZoneId", cdk.ResolutionTypeHint.STRING)), this.certificateArn = props.certificateArn, this.domainName = props.domainName, this.description = props.description;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDomainName.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { certificateArn: this.certificateArn, domainName: this.domainName, description: this.description };
      }
      renderProperties(props) {
        return cfnDomainNamePropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnDomainName[_d] = { fqn: "aws-cdk-lib.aws_appsync.CfnDomainName", version: "2.80.0" }, CfnDomainName.CFN_RESOURCE_TYPE_NAME = "AWS::AppSync::DomainName", exports2.CfnDomainName = CfnDomainName;
    function CfnDomainNameApiAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiId", cdk.requiredValidator)(properties.apiId)), errors.collect(cdk.propertyValidator("apiId", cdk.validateString)(properties.apiId)), errors.collect(cdk.propertyValidator("domainName", cdk.requiredValidator)(properties.domainName)), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.wrap('supplied properties not correct for "CfnDomainNameApiAssociationProps"');
    }
    function cfnDomainNameApiAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomainNameApiAssociationPropsValidator(properties).assertSuccess(), { ApiId: cdk.stringToCloudFormation(properties.apiId), DomainName: cdk.stringToCloudFormation(properties.domainName) }) : properties;
    }
    function CfnDomainNameApiAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiId", "ApiId", cfn_parse.FromCloudFormation.getString(properties.ApiId)), ret.addPropertyResult("domainName", "DomainName", cfn_parse.FromCloudFormation.getString(properties.DomainName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDomainNameApiAssociation = class _CfnDomainNameApiAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDomainNameApiAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnDomainNameApiAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDomainNameApiAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_CfnDomainNameApiAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDomainNameApiAssociation), error;
        }
        cdk.requireProperty(props, "apiId", this), cdk.requireProperty(props, "domainName", this), this.attrApiAssociationIdentifier = cdk.Token.asString(this.getAtt("ApiAssociationIdentifier", cdk.ResolutionTypeHint.STRING)), this.apiId = props.apiId, this.domainName = props.domainName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDomainNameApiAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiId: this.apiId, domainName: this.domainName };
      }
      renderProperties(props) {
        return cfnDomainNameApiAssociationPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnDomainNameApiAssociation[_e] = { fqn: "aws-cdk-lib.aws_appsync.CfnDomainNameApiAssociation", version: "2.80.0" }, CfnDomainNameApiAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::AppSync::DomainNameApiAssociation", exports2.CfnDomainNameApiAssociation = CfnDomainNameApiAssociation;
    function CfnFunctionConfigurationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiId", cdk.requiredValidator)(properties.apiId)), errors.collect(cdk.propertyValidator("apiId", cdk.validateString)(properties.apiId)), errors.collect(cdk.propertyValidator("code", cdk.validateString)(properties.code)), errors.collect(cdk.propertyValidator("codeS3Location", cdk.validateString)(properties.codeS3Location)), errors.collect(cdk.propertyValidator("dataSourceName", cdk.requiredValidator)(properties.dataSourceName)), errors.collect(cdk.propertyValidator("dataSourceName", cdk.validateString)(properties.dataSourceName)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("functionVersion", cdk.validateString)(properties.functionVersion)), errors.collect(cdk.propertyValidator("maxBatchSize", cdk.validateNumber)(properties.maxBatchSize)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("requestMappingTemplate", cdk.validateString)(properties.requestMappingTemplate)), errors.collect(cdk.propertyValidator("requestMappingTemplateS3Location", cdk.validateString)(properties.requestMappingTemplateS3Location)), errors.collect(cdk.propertyValidator("responseMappingTemplate", cdk.validateString)(properties.responseMappingTemplate)), errors.collect(cdk.propertyValidator("responseMappingTemplateS3Location", cdk.validateString)(properties.responseMappingTemplateS3Location)), errors.collect(cdk.propertyValidator("runtime", CfnFunctionConfiguration_AppSyncRuntimePropertyValidator)(properties.runtime)), errors.collect(cdk.propertyValidator("syncConfig", CfnFunctionConfiguration_SyncConfigPropertyValidator)(properties.syncConfig)), errors.wrap('supplied properties not correct for "CfnFunctionConfigurationProps"');
    }
    function cfnFunctionConfigurationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunctionConfigurationPropsValidator(properties).assertSuccess(), { ApiId: cdk.stringToCloudFormation(properties.apiId), DataSourceName: cdk.stringToCloudFormation(properties.dataSourceName), Name: cdk.stringToCloudFormation(properties.name), Code: cdk.stringToCloudFormation(properties.code), CodeS3Location: cdk.stringToCloudFormation(properties.codeS3Location), Description: cdk.stringToCloudFormation(properties.description), FunctionVersion: cdk.stringToCloudFormation(properties.functionVersion), MaxBatchSize: cdk.numberToCloudFormation(properties.maxBatchSize), RequestMappingTemplate: cdk.stringToCloudFormation(properties.requestMappingTemplate), RequestMappingTemplateS3Location: cdk.stringToCloudFormation(properties.requestMappingTemplateS3Location), ResponseMappingTemplate: cdk.stringToCloudFormation(properties.responseMappingTemplate), ResponseMappingTemplateS3Location: cdk.stringToCloudFormation(properties.responseMappingTemplateS3Location), Runtime: cfnFunctionConfigurationAppSyncRuntimePropertyToCloudFormation(properties.runtime), SyncConfig: cfnFunctionConfigurationSyncConfigPropertyToCloudFormation(properties.syncConfig) }) : properties;
    }
    function CfnFunctionConfigurationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiId", "ApiId", cfn_parse.FromCloudFormation.getString(properties.ApiId)), ret.addPropertyResult("dataSourceName", "DataSourceName", cfn_parse.FromCloudFormation.getString(properties.DataSourceName)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("code", "Code", properties.Code != null ? cfn_parse.FromCloudFormation.getString(properties.Code) : void 0), ret.addPropertyResult("codeS3Location", "CodeS3Location", properties.CodeS3Location != null ? cfn_parse.FromCloudFormation.getString(properties.CodeS3Location) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("functionVersion", "FunctionVersion", properties.FunctionVersion != null ? cfn_parse.FromCloudFormation.getString(properties.FunctionVersion) : void 0), ret.addPropertyResult("maxBatchSize", "MaxBatchSize", properties.MaxBatchSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxBatchSize) : void 0), ret.addPropertyResult("requestMappingTemplate", "RequestMappingTemplate", properties.RequestMappingTemplate != null ? cfn_parse.FromCloudFormation.getString(properties.RequestMappingTemplate) : void 0), ret.addPropertyResult("requestMappingTemplateS3Location", "RequestMappingTemplateS3Location", properties.RequestMappingTemplateS3Location != null ? cfn_parse.FromCloudFormation.getString(properties.RequestMappingTemplateS3Location) : void 0), ret.addPropertyResult("responseMappingTemplate", "ResponseMappingTemplate", properties.ResponseMappingTemplate != null ? cfn_parse.FromCloudFormation.getString(properties.ResponseMappingTemplate) : void 0), ret.addPropertyResult("responseMappingTemplateS3Location", "ResponseMappingTemplateS3Location", properties.ResponseMappingTemplateS3Location != null ? cfn_parse.FromCloudFormation.getString(properties.ResponseMappingTemplateS3Location) : void 0), ret.addPropertyResult("runtime", "Runtime", properties.Runtime != null ? CfnFunctionConfigurationAppSyncRuntimePropertyFromCloudFormation(properties.Runtime) : void 0), ret.addPropertyResult("syncConfig", "SyncConfig", properties.SyncConfig != null ? CfnFunctionConfigurationSyncConfigPropertyFromCloudFormation(properties.SyncConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFunctionConfiguration = class _CfnFunctionConfiguration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFunctionConfigurationPropsFromCloudFormation(resourceProperties), ret = new _CfnFunctionConfiguration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFunctionConfiguration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_CfnFunctionConfigurationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFunctionConfiguration), error;
        }
        cdk.requireProperty(props, "apiId", this), cdk.requireProperty(props, "dataSourceName", this), cdk.requireProperty(props, "name", this), this.attrDataSourceName = cdk.Token.asString(this.getAtt("DataSourceName", cdk.ResolutionTypeHint.STRING)), this.attrFunctionArn = cdk.Token.asString(this.getAtt("FunctionArn", cdk.ResolutionTypeHint.STRING)), this.attrFunctionId = cdk.Token.asString(this.getAtt("FunctionId", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.apiId = props.apiId, this.dataSourceName = props.dataSourceName, this.name = props.name, this.code = props.code, this.codeS3Location = props.codeS3Location, this.description = props.description, this.functionVersion = props.functionVersion, this.maxBatchSize = props.maxBatchSize, this.requestMappingTemplate = props.requestMappingTemplate, this.requestMappingTemplateS3Location = props.requestMappingTemplateS3Location, this.responseMappingTemplate = props.responseMappingTemplate, this.responseMappingTemplateS3Location = props.responseMappingTemplateS3Location, this.runtime = props.runtime, this.syncConfig = props.syncConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFunctionConfiguration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiId: this.apiId, dataSourceName: this.dataSourceName, name: this.name, code: this.code, codeS3Location: this.codeS3Location, description: this.description, functionVersion: this.functionVersion, maxBatchSize: this.maxBatchSize, requestMappingTemplate: this.requestMappingTemplate, requestMappingTemplateS3Location: this.requestMappingTemplateS3Location, responseMappingTemplate: this.responseMappingTemplate, responseMappingTemplateS3Location: this.responseMappingTemplateS3Location, runtime: this.runtime, syncConfig: this.syncConfig };
      }
      renderProperties(props) {
        return cfnFunctionConfigurationPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnFunctionConfiguration[_f] = { fqn: "aws-cdk-lib.aws_appsync.CfnFunctionConfiguration", version: "2.80.0" }, CfnFunctionConfiguration.CFN_RESOURCE_TYPE_NAME = "AWS::AppSync::FunctionConfiguration", exports2.CfnFunctionConfiguration = CfnFunctionConfiguration;
    function CfnFunctionConfiguration_AppSyncRuntimePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("runtimeVersion", cdk.requiredValidator)(properties.runtimeVersion)), errors.collect(cdk.propertyValidator("runtimeVersion", cdk.validateString)(properties.runtimeVersion)), errors.wrap('supplied properties not correct for "AppSyncRuntimeProperty"');
    }
    function cfnFunctionConfigurationAppSyncRuntimePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunctionConfiguration_AppSyncRuntimePropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), RuntimeVersion: cdk.stringToCloudFormation(properties.runtimeVersion) }) : properties;
    }
    function CfnFunctionConfigurationAppSyncRuntimePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("runtimeVersion", "RuntimeVersion", cfn_parse.FromCloudFormation.getString(properties.RuntimeVersion)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunctionConfiguration_LambdaConflictHandlerConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("lambdaConflictHandlerArn", cdk.validateString)(properties.lambdaConflictHandlerArn)), errors.wrap('supplied properties not correct for "LambdaConflictHandlerConfigProperty"');
    }
    function cfnFunctionConfigurationLambdaConflictHandlerConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunctionConfiguration_LambdaConflictHandlerConfigPropertyValidator(properties).assertSuccess(), { LambdaConflictHandlerArn: cdk.stringToCloudFormation(properties.lambdaConflictHandlerArn) }) : properties;
    }
    function CfnFunctionConfigurationLambdaConflictHandlerConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("lambdaConflictHandlerArn", "LambdaConflictHandlerArn", properties.LambdaConflictHandlerArn != null ? cfn_parse.FromCloudFormation.getString(properties.LambdaConflictHandlerArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunctionConfiguration_SyncConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("conflictDetection", cdk.requiredValidator)(properties.conflictDetection)), errors.collect(cdk.propertyValidator("conflictDetection", cdk.validateString)(properties.conflictDetection)), errors.collect(cdk.propertyValidator("conflictHandler", cdk.validateString)(properties.conflictHandler)), errors.collect(cdk.propertyValidator("lambdaConflictHandlerConfig", CfnFunctionConfiguration_LambdaConflictHandlerConfigPropertyValidator)(properties.lambdaConflictHandlerConfig)), errors.wrap('supplied properties not correct for "SyncConfigProperty"');
    }
    function cfnFunctionConfigurationSyncConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunctionConfiguration_SyncConfigPropertyValidator(properties).assertSuccess(), { ConflictDetection: cdk.stringToCloudFormation(properties.conflictDetection), ConflictHandler: cdk.stringToCloudFormation(properties.conflictHandler), LambdaConflictHandlerConfig: cfnFunctionConfigurationLambdaConflictHandlerConfigPropertyToCloudFormation(properties.lambdaConflictHandlerConfig) }) : properties;
    }
    function CfnFunctionConfigurationSyncConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("conflictDetection", "ConflictDetection", cfn_parse.FromCloudFormation.getString(properties.ConflictDetection)), ret.addPropertyResult("conflictHandler", "ConflictHandler", properties.ConflictHandler != null ? cfn_parse.FromCloudFormation.getString(properties.ConflictHandler) : void 0), ret.addPropertyResult("lambdaConflictHandlerConfig", "LambdaConflictHandlerConfig", properties.LambdaConflictHandlerConfig != null ? CfnFunctionConfigurationLambdaConflictHandlerConfigPropertyFromCloudFormation(properties.LambdaConflictHandlerConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGraphQLApiPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("additionalAuthenticationProviders", cdk.listValidator(CfnGraphQLApi_AdditionalAuthenticationProviderPropertyValidator))(properties.additionalAuthenticationProviders)), errors.collect(cdk.propertyValidator("authenticationType", cdk.requiredValidator)(properties.authenticationType)), errors.collect(cdk.propertyValidator("authenticationType", cdk.validateString)(properties.authenticationType)), errors.collect(cdk.propertyValidator("lambdaAuthorizerConfig", CfnGraphQLApi_LambdaAuthorizerConfigPropertyValidator)(properties.lambdaAuthorizerConfig)), errors.collect(cdk.propertyValidator("logConfig", CfnGraphQLApi_LogConfigPropertyValidator)(properties.logConfig)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("openIdConnectConfig", CfnGraphQLApi_OpenIDConnectConfigPropertyValidator)(properties.openIdConnectConfig)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("userPoolConfig", CfnGraphQLApi_UserPoolConfigPropertyValidator)(properties.userPoolConfig)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.collect(cdk.propertyValidator("xrayEnabled", cdk.validateBoolean)(properties.xrayEnabled)), errors.wrap('supplied properties not correct for "CfnGraphQLApiProps"');
    }
    function cfnGraphQLApiPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGraphQLApiPropsValidator(properties).assertSuccess(), { AuthenticationType: cdk.stringToCloudFormation(properties.authenticationType), Name: cdk.stringToCloudFormation(properties.name), AdditionalAuthenticationProviders: cdk.listMapper(cfnGraphQLApiAdditionalAuthenticationProviderPropertyToCloudFormation)(properties.additionalAuthenticationProviders), LambdaAuthorizerConfig: cfnGraphQLApiLambdaAuthorizerConfigPropertyToCloudFormation(properties.lambdaAuthorizerConfig), LogConfig: cfnGraphQLApiLogConfigPropertyToCloudFormation(properties.logConfig), OpenIDConnectConfig: cfnGraphQLApiOpenIDConnectConfigPropertyToCloudFormation(properties.openIdConnectConfig), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), UserPoolConfig: cfnGraphQLApiUserPoolConfigPropertyToCloudFormation(properties.userPoolConfig), Visibility: cdk.stringToCloudFormation(properties.visibility), XrayEnabled: cdk.booleanToCloudFormation(properties.xrayEnabled) }) : properties;
    }
    function CfnGraphQLApiPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authenticationType", "AuthenticationType", cfn_parse.FromCloudFormation.getString(properties.AuthenticationType)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("additionalAuthenticationProviders", "AdditionalAuthenticationProviders", properties.AdditionalAuthenticationProviders != null ? cfn_parse.FromCloudFormation.getArray(CfnGraphQLApiAdditionalAuthenticationProviderPropertyFromCloudFormation)(properties.AdditionalAuthenticationProviders) : void 0), ret.addPropertyResult("lambdaAuthorizerConfig", "LambdaAuthorizerConfig", properties.LambdaAuthorizerConfig != null ? CfnGraphQLApiLambdaAuthorizerConfigPropertyFromCloudFormation(properties.LambdaAuthorizerConfig) : void 0), ret.addPropertyResult("logConfig", "LogConfig", properties.LogConfig != null ? CfnGraphQLApiLogConfigPropertyFromCloudFormation(properties.LogConfig) : void 0), ret.addPropertyResult("openIdConnectConfig", "OpenIDConnectConfig", properties.OpenIDConnectConfig != null ? CfnGraphQLApiOpenIDConnectConfigPropertyFromCloudFormation(properties.OpenIDConnectConfig) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("userPoolConfig", "UserPoolConfig", properties.UserPoolConfig != null ? CfnGraphQLApiUserPoolConfigPropertyFromCloudFormation(properties.UserPoolConfig) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addPropertyResult("xrayEnabled", "XrayEnabled", properties.XrayEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.XrayEnabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnGraphQLApi = class _CfnGraphQLApi extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnGraphQLApiPropsFromCloudFormation(resourceProperties), ret = new _CfnGraphQLApi(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnGraphQLApi.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_CfnGraphQLApiProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnGraphQLApi), error;
        }
        cdk.requireProperty(props, "authenticationType", this), cdk.requireProperty(props, "name", this), this.attrApiId = cdk.Token.asString(this.getAtt("ApiId", cdk.ResolutionTypeHint.STRING)), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrGraphQlDns = cdk.Token.asString(this.getAtt("GraphQLDns", cdk.ResolutionTypeHint.STRING)), this.attrGraphQlUrl = cdk.Token.asString(this.getAtt("GraphQLUrl", cdk.ResolutionTypeHint.STRING)), this.attrRealtimeDns = cdk.Token.asString(this.getAtt("RealtimeDns", cdk.ResolutionTypeHint.STRING)), this.attrRealtimeUrl = cdk.Token.asString(this.getAtt("RealtimeUrl", cdk.ResolutionTypeHint.STRING)), this.authenticationType = props.authenticationType, this.name = props.name, this.additionalAuthenticationProviders = props.additionalAuthenticationProviders, this.lambdaAuthorizerConfig = props.lambdaAuthorizerConfig, this.logConfig = props.logConfig, this.openIdConnectConfig = props.openIdConnectConfig, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::AppSync::GraphQLApi", props.tags, { tagPropertyName: "tags" }), this.userPoolConfig = props.userPoolConfig, this.visibility = props.visibility, this.xrayEnabled = props.xrayEnabled;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnGraphQLApi.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { authenticationType: this.authenticationType, name: this.name, additionalAuthenticationProviders: this.additionalAuthenticationProviders, lambdaAuthorizerConfig: this.lambdaAuthorizerConfig, logConfig: this.logConfig, openIdConnectConfig: this.openIdConnectConfig, tags: this.tags.renderTags(), userPoolConfig: this.userPoolConfig, visibility: this.visibility, xrayEnabled: this.xrayEnabled };
      }
      renderProperties(props) {
        return cfnGraphQLApiPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnGraphQLApi[_g] = { fqn: "aws-cdk-lib.aws_appsync.CfnGraphQLApi", version: "2.80.0" }, CfnGraphQLApi.CFN_RESOURCE_TYPE_NAME = "AWS::AppSync::GraphQLApi", exports2.CfnGraphQLApi = CfnGraphQLApi;
    function CfnGraphQLApi_AdditionalAuthenticationProviderPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authenticationType", cdk.requiredValidator)(properties.authenticationType)), errors.collect(cdk.propertyValidator("authenticationType", cdk.validateString)(properties.authenticationType)), errors.collect(cdk.propertyValidator("lambdaAuthorizerConfig", CfnGraphQLApi_LambdaAuthorizerConfigPropertyValidator)(properties.lambdaAuthorizerConfig)), errors.collect(cdk.propertyValidator("openIdConnectConfig", CfnGraphQLApi_OpenIDConnectConfigPropertyValidator)(properties.openIdConnectConfig)), errors.collect(cdk.propertyValidator("userPoolConfig", CfnGraphQLApi_CognitoUserPoolConfigPropertyValidator)(properties.userPoolConfig)), errors.wrap('supplied properties not correct for "AdditionalAuthenticationProviderProperty"');
    }
    function cfnGraphQLApiAdditionalAuthenticationProviderPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGraphQLApi_AdditionalAuthenticationProviderPropertyValidator(properties).assertSuccess(), { AuthenticationType: cdk.stringToCloudFormation(properties.authenticationType), LambdaAuthorizerConfig: cfnGraphQLApiLambdaAuthorizerConfigPropertyToCloudFormation(properties.lambdaAuthorizerConfig), OpenIDConnectConfig: cfnGraphQLApiOpenIDConnectConfigPropertyToCloudFormation(properties.openIdConnectConfig), UserPoolConfig: cfnGraphQLApiCognitoUserPoolConfigPropertyToCloudFormation(properties.userPoolConfig) }) : properties;
    }
    function CfnGraphQLApiAdditionalAuthenticationProviderPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authenticationType", "AuthenticationType", cfn_parse.FromCloudFormation.getString(properties.AuthenticationType)), ret.addPropertyResult("lambdaAuthorizerConfig", "LambdaAuthorizerConfig", properties.LambdaAuthorizerConfig != null ? CfnGraphQLApiLambdaAuthorizerConfigPropertyFromCloudFormation(properties.LambdaAuthorizerConfig) : void 0), ret.addPropertyResult("openIdConnectConfig", "OpenIDConnectConfig", properties.OpenIDConnectConfig != null ? CfnGraphQLApiOpenIDConnectConfigPropertyFromCloudFormation(properties.OpenIDConnectConfig) : void 0), ret.addPropertyResult("userPoolConfig", "UserPoolConfig", properties.UserPoolConfig != null ? CfnGraphQLApiCognitoUserPoolConfigPropertyFromCloudFormation(properties.UserPoolConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGraphQLApi_CognitoUserPoolConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("appIdClientRegex", cdk.validateString)(properties.appIdClientRegex)), errors.collect(cdk.propertyValidator("awsRegion", cdk.validateString)(properties.awsRegion)), errors.collect(cdk.propertyValidator("userPoolId", cdk.validateString)(properties.userPoolId)), errors.wrap('supplied properties not correct for "CognitoUserPoolConfigProperty"');
    }
    function cfnGraphQLApiCognitoUserPoolConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGraphQLApi_CognitoUserPoolConfigPropertyValidator(properties).assertSuccess(), { AppIdClientRegex: cdk.stringToCloudFormation(properties.appIdClientRegex), AwsRegion: cdk.stringToCloudFormation(properties.awsRegion), UserPoolId: cdk.stringToCloudFormation(properties.userPoolId) }) : properties;
    }
    function CfnGraphQLApiCognitoUserPoolConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("appIdClientRegex", "AppIdClientRegex", properties.AppIdClientRegex != null ? cfn_parse.FromCloudFormation.getString(properties.AppIdClientRegex) : void 0), ret.addPropertyResult("awsRegion", "AwsRegion", properties.AwsRegion != null ? cfn_parse.FromCloudFormation.getString(properties.AwsRegion) : void 0), ret.addPropertyResult("userPoolId", "UserPoolId", properties.UserPoolId != null ? cfn_parse.FromCloudFormation.getString(properties.UserPoolId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGraphQLApi_LambdaAuthorizerConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authorizerResultTtlInSeconds", cdk.validateNumber)(properties.authorizerResultTtlInSeconds)), errors.collect(cdk.propertyValidator("authorizerUri", cdk.validateString)(properties.authorizerUri)), errors.collect(cdk.propertyValidator("identityValidationExpression", cdk.validateString)(properties.identityValidationExpression)), errors.wrap('supplied properties not correct for "LambdaAuthorizerConfigProperty"');
    }
    function cfnGraphQLApiLambdaAuthorizerConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGraphQLApi_LambdaAuthorizerConfigPropertyValidator(properties).assertSuccess(), { AuthorizerResultTtlInSeconds: cdk.numberToCloudFormation(properties.authorizerResultTtlInSeconds), AuthorizerUri: cdk.stringToCloudFormation(properties.authorizerUri), IdentityValidationExpression: cdk.stringToCloudFormation(properties.identityValidationExpression) }) : properties;
    }
    function CfnGraphQLApiLambdaAuthorizerConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authorizerResultTtlInSeconds", "AuthorizerResultTtlInSeconds", properties.AuthorizerResultTtlInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.AuthorizerResultTtlInSeconds) : void 0), ret.addPropertyResult("authorizerUri", "AuthorizerUri", properties.AuthorizerUri != null ? cfn_parse.FromCloudFormation.getString(properties.AuthorizerUri) : void 0), ret.addPropertyResult("identityValidationExpression", "IdentityValidationExpression", properties.IdentityValidationExpression != null ? cfn_parse.FromCloudFormation.getString(properties.IdentityValidationExpression) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGraphQLApi_LogConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchLogsRoleArn", cdk.validateString)(properties.cloudWatchLogsRoleArn)), errors.collect(cdk.propertyValidator("excludeVerboseContent", cdk.validateBoolean)(properties.excludeVerboseContent)), errors.collect(cdk.propertyValidator("fieldLogLevel", cdk.validateString)(properties.fieldLogLevel)), errors.wrap('supplied properties not correct for "LogConfigProperty"');
    }
    function cfnGraphQLApiLogConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGraphQLApi_LogConfigPropertyValidator(properties).assertSuccess(), { CloudWatchLogsRoleArn: cdk.stringToCloudFormation(properties.cloudWatchLogsRoleArn), ExcludeVerboseContent: cdk.booleanToCloudFormation(properties.excludeVerboseContent), FieldLogLevel: cdk.stringToCloudFormation(properties.fieldLogLevel) }) : properties;
    }
    function CfnGraphQLApiLogConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchLogsRoleArn", "CloudWatchLogsRoleArn", properties.CloudWatchLogsRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.CloudWatchLogsRoleArn) : void 0), ret.addPropertyResult("excludeVerboseContent", "ExcludeVerboseContent", properties.ExcludeVerboseContent != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ExcludeVerboseContent) : void 0), ret.addPropertyResult("fieldLogLevel", "FieldLogLevel", properties.FieldLogLevel != null ? cfn_parse.FromCloudFormation.getString(properties.FieldLogLevel) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGraphQLApi_OpenIDConnectConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authTtl", cdk.validateNumber)(properties.authTtl)), errors.collect(cdk.propertyValidator("clientId", cdk.validateString)(properties.clientId)), errors.collect(cdk.propertyValidator("iatTtl", cdk.validateNumber)(properties.iatTtl)), errors.collect(cdk.propertyValidator("issuer", cdk.validateString)(properties.issuer)), errors.wrap('supplied properties not correct for "OpenIDConnectConfigProperty"');
    }
    function cfnGraphQLApiOpenIDConnectConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGraphQLApi_OpenIDConnectConfigPropertyValidator(properties).assertSuccess(), { AuthTTL: cdk.numberToCloudFormation(properties.authTtl), ClientId: cdk.stringToCloudFormation(properties.clientId), IatTTL: cdk.numberToCloudFormation(properties.iatTtl), Issuer: cdk.stringToCloudFormation(properties.issuer) }) : properties;
    }
    function CfnGraphQLApiOpenIDConnectConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authTtl", "AuthTTL", properties.AuthTTL != null ? cfn_parse.FromCloudFormation.getNumber(properties.AuthTTL) : void 0), ret.addPropertyResult("clientId", "ClientId", properties.ClientId != null ? cfn_parse.FromCloudFormation.getString(properties.ClientId) : void 0), ret.addPropertyResult("iatTtl", "IatTTL", properties.IatTTL != null ? cfn_parse.FromCloudFormation.getNumber(properties.IatTTL) : void 0), ret.addPropertyResult("issuer", "Issuer", properties.Issuer != null ? cfn_parse.FromCloudFormation.getString(properties.Issuer) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGraphQLApi_UserPoolConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("appIdClientRegex", cdk.validateString)(properties.appIdClientRegex)), errors.collect(cdk.propertyValidator("awsRegion", cdk.validateString)(properties.awsRegion)), errors.collect(cdk.propertyValidator("defaultAction", cdk.validateString)(properties.defaultAction)), errors.collect(cdk.propertyValidator("userPoolId", cdk.validateString)(properties.userPoolId)), errors.wrap('supplied properties not correct for "UserPoolConfigProperty"');
    }
    function cfnGraphQLApiUserPoolConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGraphQLApi_UserPoolConfigPropertyValidator(properties).assertSuccess(), { AppIdClientRegex: cdk.stringToCloudFormation(properties.appIdClientRegex), AwsRegion: cdk.stringToCloudFormation(properties.awsRegion), DefaultAction: cdk.stringToCloudFormation(properties.defaultAction), UserPoolId: cdk.stringToCloudFormation(properties.userPoolId) }) : properties;
    }
    function CfnGraphQLApiUserPoolConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("appIdClientRegex", "AppIdClientRegex", properties.AppIdClientRegex != null ? cfn_parse.FromCloudFormation.getString(properties.AppIdClientRegex) : void 0), ret.addPropertyResult("awsRegion", "AwsRegion", properties.AwsRegion != null ? cfn_parse.FromCloudFormation.getString(properties.AwsRegion) : void 0), ret.addPropertyResult("defaultAction", "DefaultAction", properties.DefaultAction != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultAction) : void 0), ret.addPropertyResult("userPoolId", "UserPoolId", properties.UserPoolId != null ? cfn_parse.FromCloudFormation.getString(properties.UserPoolId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGraphQLSchemaPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiId", cdk.requiredValidator)(properties.apiId)), errors.collect(cdk.propertyValidator("apiId", cdk.validateString)(properties.apiId)), errors.collect(cdk.propertyValidator("definition", cdk.validateString)(properties.definition)), errors.collect(cdk.propertyValidator("definitionS3Location", cdk.validateString)(properties.definitionS3Location)), errors.wrap('supplied properties not correct for "CfnGraphQLSchemaProps"');
    }
    function cfnGraphQLSchemaPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGraphQLSchemaPropsValidator(properties).assertSuccess(), { ApiId: cdk.stringToCloudFormation(properties.apiId), Definition: cdk.stringToCloudFormation(properties.definition), DefinitionS3Location: cdk.stringToCloudFormation(properties.definitionS3Location) }) : properties;
    }
    function CfnGraphQLSchemaPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiId", "ApiId", cfn_parse.FromCloudFormation.getString(properties.ApiId)), ret.addPropertyResult("definition", "Definition", properties.Definition != null ? cfn_parse.FromCloudFormation.getString(properties.Definition) : void 0), ret.addPropertyResult("definitionS3Location", "DefinitionS3Location", properties.DefinitionS3Location != null ? cfn_parse.FromCloudFormation.getString(properties.DefinitionS3Location) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnGraphQLSchema = class _CfnGraphQLSchema extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnGraphQLSchemaPropsFromCloudFormation(resourceProperties), ret = new _CfnGraphQLSchema(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnGraphQLSchema.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_CfnGraphQLSchemaProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnGraphQLSchema), error;
        }
        cdk.requireProperty(props, "apiId", this), this.apiId = props.apiId, this.definition = props.definition, this.definitionS3Location = props.definitionS3Location;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnGraphQLSchema.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiId: this.apiId, definition: this.definition, definitionS3Location: this.definitionS3Location };
      }
      renderProperties(props) {
        return cfnGraphQLSchemaPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnGraphQLSchema[_h] = { fqn: "aws-cdk-lib.aws_appsync.CfnGraphQLSchema", version: "2.80.0" }, CfnGraphQLSchema.CFN_RESOURCE_TYPE_NAME = "AWS::AppSync::GraphQLSchema", exports2.CfnGraphQLSchema = CfnGraphQLSchema;
    function CfnResolverPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiId", cdk.requiredValidator)(properties.apiId)), errors.collect(cdk.propertyValidator("apiId", cdk.validateString)(properties.apiId)), errors.collect(cdk.propertyValidator("cachingConfig", CfnResolver_CachingConfigPropertyValidator)(properties.cachingConfig)), errors.collect(cdk.propertyValidator("code", cdk.validateString)(properties.code)), errors.collect(cdk.propertyValidator("codeS3Location", cdk.validateString)(properties.codeS3Location)), errors.collect(cdk.propertyValidator("dataSourceName", cdk.validateString)(properties.dataSourceName)), errors.collect(cdk.propertyValidator("fieldName", cdk.requiredValidator)(properties.fieldName)), errors.collect(cdk.propertyValidator("fieldName", cdk.validateString)(properties.fieldName)), errors.collect(cdk.propertyValidator("kind", cdk.validateString)(properties.kind)), errors.collect(cdk.propertyValidator("maxBatchSize", cdk.validateNumber)(properties.maxBatchSize)), errors.collect(cdk.propertyValidator("pipelineConfig", CfnResolver_PipelineConfigPropertyValidator)(properties.pipelineConfig)), errors.collect(cdk.propertyValidator("requestMappingTemplate", cdk.validateString)(properties.requestMappingTemplate)), errors.collect(cdk.propertyValidator("requestMappingTemplateS3Location", cdk.validateString)(properties.requestMappingTemplateS3Location)), errors.collect(cdk.propertyValidator("responseMappingTemplate", cdk.validateString)(properties.responseMappingTemplate)), errors.collect(cdk.propertyValidator("responseMappingTemplateS3Location", cdk.validateString)(properties.responseMappingTemplateS3Location)), errors.collect(cdk.propertyValidator("runtime", CfnResolver_AppSyncRuntimePropertyValidator)(properties.runtime)), errors.collect(cdk.propertyValidator("syncConfig", CfnResolver_SyncConfigPropertyValidator)(properties.syncConfig)), errors.collect(cdk.propertyValidator("typeName", cdk.requiredValidator)(properties.typeName)), errors.collect(cdk.propertyValidator("typeName", cdk.validateString)(properties.typeName)), errors.wrap('supplied properties not correct for "CfnResolverProps"');
    }
    function cfnResolverPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResolverPropsValidator(properties).assertSuccess(), { ApiId: cdk.stringToCloudFormation(properties.apiId), FieldName: cdk.stringToCloudFormation(properties.fieldName), TypeName: cdk.stringToCloudFormation(properties.typeName), CachingConfig: cfnResolverCachingConfigPropertyToCloudFormation(properties.cachingConfig), Code: cdk.stringToCloudFormation(properties.code), CodeS3Location: cdk.stringToCloudFormation(properties.codeS3Location), DataSourceName: cdk.stringToCloudFormation(properties.dataSourceName), Kind: cdk.stringToCloudFormation(properties.kind), MaxBatchSize: cdk.numberToCloudFormation(properties.maxBatchSize), PipelineConfig: cfnResolverPipelineConfigPropertyToCloudFormation(properties.pipelineConfig), RequestMappingTemplate: cdk.stringToCloudFormation(properties.requestMappingTemplate), RequestMappingTemplateS3Location: cdk.stringToCloudFormation(properties.requestMappingTemplateS3Location), ResponseMappingTemplate: cdk.stringToCloudFormation(properties.responseMappingTemplate), ResponseMappingTemplateS3Location: cdk.stringToCloudFormation(properties.responseMappingTemplateS3Location), Runtime: cfnResolverAppSyncRuntimePropertyToCloudFormation(properties.runtime), SyncConfig: cfnResolverSyncConfigPropertyToCloudFormation(properties.syncConfig) }) : properties;
    }
    function CfnResolverPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiId", "ApiId", cfn_parse.FromCloudFormation.getString(properties.ApiId)), ret.addPropertyResult("fieldName", "FieldName", cfn_parse.FromCloudFormation.getString(properties.FieldName)), ret.addPropertyResult("typeName", "TypeName", cfn_parse.FromCloudFormation.getString(properties.TypeName)), ret.addPropertyResult("cachingConfig", "CachingConfig", properties.CachingConfig != null ? CfnResolverCachingConfigPropertyFromCloudFormation(properties.CachingConfig) : void 0), ret.addPropertyResult("code", "Code", properties.Code != null ? cfn_parse.FromCloudFormation.getString(properties.Code) : void 0), ret.addPropertyResult("codeS3Location", "CodeS3Location", properties.CodeS3Location != null ? cfn_parse.FromCloudFormation.getString(properties.CodeS3Location) : void 0), ret.addPropertyResult("dataSourceName", "DataSourceName", properties.DataSourceName != null ? cfn_parse.FromCloudFormation.getString(properties.DataSourceName) : void 0), ret.addPropertyResult("kind", "Kind", properties.Kind != null ? cfn_parse.FromCloudFormation.getString(properties.Kind) : void 0), ret.addPropertyResult("maxBatchSize", "MaxBatchSize", properties.MaxBatchSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxBatchSize) : void 0), ret.addPropertyResult("pipelineConfig", "PipelineConfig", properties.PipelineConfig != null ? CfnResolverPipelineConfigPropertyFromCloudFormation(properties.PipelineConfig) : void 0), ret.addPropertyResult("requestMappingTemplate", "RequestMappingTemplate", properties.RequestMappingTemplate != null ? cfn_parse.FromCloudFormation.getString(properties.RequestMappingTemplate) : void 0), ret.addPropertyResult("requestMappingTemplateS3Location", "RequestMappingTemplateS3Location", properties.RequestMappingTemplateS3Location != null ? cfn_parse.FromCloudFormation.getString(properties.RequestMappingTemplateS3Location) : void 0), ret.addPropertyResult("responseMappingTemplate", "ResponseMappingTemplate", properties.ResponseMappingTemplate != null ? cfn_parse.FromCloudFormation.getString(properties.ResponseMappingTemplate) : void 0), ret.addPropertyResult("responseMappingTemplateS3Location", "ResponseMappingTemplateS3Location", properties.ResponseMappingTemplateS3Location != null ? cfn_parse.FromCloudFormation.getString(properties.ResponseMappingTemplateS3Location) : void 0), ret.addPropertyResult("runtime", "Runtime", properties.Runtime != null ? CfnResolverAppSyncRuntimePropertyFromCloudFormation(properties.Runtime) : void 0), ret.addPropertyResult("syncConfig", "SyncConfig", properties.SyncConfig != null ? CfnResolverSyncConfigPropertyFromCloudFormation(properties.SyncConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResolver = class _CfnResolver extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResolverPropsFromCloudFormation(resourceProperties), ret = new _CfnResolver(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnResolver.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_CfnResolverProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResolver), error;
        }
        cdk.requireProperty(props, "apiId", this), cdk.requireProperty(props, "fieldName", this), cdk.requireProperty(props, "typeName", this), this.attrFieldName = cdk.Token.asString(this.getAtt("FieldName", cdk.ResolutionTypeHint.STRING)), this.attrResolverArn = cdk.Token.asString(this.getAtt("ResolverArn", cdk.ResolutionTypeHint.STRING)), this.attrTypeName = cdk.Token.asString(this.getAtt("TypeName", cdk.ResolutionTypeHint.STRING)), this.apiId = props.apiId, this.fieldName = props.fieldName, this.typeName = props.typeName, this.cachingConfig = props.cachingConfig, this.code = props.code, this.codeS3Location = props.codeS3Location, this.dataSourceName = props.dataSourceName, this.kind = props.kind, this.maxBatchSize = props.maxBatchSize, this.pipelineConfig = props.pipelineConfig, this.requestMappingTemplate = props.requestMappingTemplate, this.requestMappingTemplateS3Location = props.requestMappingTemplateS3Location, this.responseMappingTemplate = props.responseMappingTemplate, this.responseMappingTemplateS3Location = props.responseMappingTemplateS3Location, this.runtime = props.runtime, this.syncConfig = props.syncConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResolver.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiId: this.apiId, fieldName: this.fieldName, typeName: this.typeName, cachingConfig: this.cachingConfig, code: this.code, codeS3Location: this.codeS3Location, dataSourceName: this.dataSourceName, kind: this.kind, maxBatchSize: this.maxBatchSize, pipelineConfig: this.pipelineConfig, requestMappingTemplate: this.requestMappingTemplate, requestMappingTemplateS3Location: this.requestMappingTemplateS3Location, responseMappingTemplate: this.responseMappingTemplate, responseMappingTemplateS3Location: this.responseMappingTemplateS3Location, runtime: this.runtime, syncConfig: this.syncConfig };
      }
      renderProperties(props) {
        return cfnResolverPropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnResolver[_j] = { fqn: "aws-cdk-lib.aws_appsync.CfnResolver", version: "2.80.0" }, CfnResolver.CFN_RESOURCE_TYPE_NAME = "AWS::AppSync::Resolver", exports2.CfnResolver = CfnResolver;
    function CfnResolver_AppSyncRuntimePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("runtimeVersion", cdk.requiredValidator)(properties.runtimeVersion)), errors.collect(cdk.propertyValidator("runtimeVersion", cdk.validateString)(properties.runtimeVersion)), errors.wrap('supplied properties not correct for "AppSyncRuntimeProperty"');
    }
    function cfnResolverAppSyncRuntimePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResolver_AppSyncRuntimePropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), RuntimeVersion: cdk.stringToCloudFormation(properties.runtimeVersion) }) : properties;
    }
    function CfnResolverAppSyncRuntimePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("runtimeVersion", "RuntimeVersion", cfn_parse.FromCloudFormation.getString(properties.RuntimeVersion)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResolver_CachingConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cachingKeys", cdk.listValidator(cdk.validateString))(properties.cachingKeys)), errors.collect(cdk.propertyValidator("ttl", cdk.requiredValidator)(properties.ttl)), errors.collect(cdk.propertyValidator("ttl", cdk.validateNumber)(properties.ttl)), errors.wrap('supplied properties not correct for "CachingConfigProperty"');
    }
    function cfnResolverCachingConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResolver_CachingConfigPropertyValidator(properties).assertSuccess(), { CachingKeys: cdk.listMapper(cdk.stringToCloudFormation)(properties.cachingKeys), Ttl: cdk.numberToCloudFormation(properties.ttl) }) : properties;
    }
    function CfnResolverCachingConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cachingKeys", "CachingKeys", properties.CachingKeys != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CachingKeys) : void 0), ret.addPropertyResult("ttl", "Ttl", cfn_parse.FromCloudFormation.getNumber(properties.Ttl)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResolver_LambdaConflictHandlerConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("lambdaConflictHandlerArn", cdk.validateString)(properties.lambdaConflictHandlerArn)), errors.wrap('supplied properties not correct for "LambdaConflictHandlerConfigProperty"');
    }
    function cfnResolverLambdaConflictHandlerConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResolver_LambdaConflictHandlerConfigPropertyValidator(properties).assertSuccess(), { LambdaConflictHandlerArn: cdk.stringToCloudFormation(properties.lambdaConflictHandlerArn) }) : properties;
    }
    function CfnResolverLambdaConflictHandlerConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("lambdaConflictHandlerArn", "LambdaConflictHandlerArn", properties.LambdaConflictHandlerArn != null ? cfn_parse.FromCloudFormation.getString(properties.LambdaConflictHandlerArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResolver_PipelineConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("functions", cdk.listValidator(cdk.validateString))(properties.functions)), errors.wrap('supplied properties not correct for "PipelineConfigProperty"');
    }
    function cfnResolverPipelineConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResolver_PipelineConfigPropertyValidator(properties).assertSuccess(), { Functions: cdk.listMapper(cdk.stringToCloudFormation)(properties.functions) }) : properties;
    }
    function CfnResolverPipelineConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("functions", "Functions", properties.Functions != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Functions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResolver_SyncConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("conflictDetection", cdk.requiredValidator)(properties.conflictDetection)), errors.collect(cdk.propertyValidator("conflictDetection", cdk.validateString)(properties.conflictDetection)), errors.collect(cdk.propertyValidator("conflictHandler", cdk.validateString)(properties.conflictHandler)), errors.collect(cdk.propertyValidator("lambdaConflictHandlerConfig", CfnResolver_LambdaConflictHandlerConfigPropertyValidator)(properties.lambdaConflictHandlerConfig)), errors.wrap('supplied properties not correct for "SyncConfigProperty"');
    }
    function cfnResolverSyncConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResolver_SyncConfigPropertyValidator(properties).assertSuccess(), { ConflictDetection: cdk.stringToCloudFormation(properties.conflictDetection), ConflictHandler: cdk.stringToCloudFormation(properties.conflictHandler), LambdaConflictHandlerConfig: cfnResolverLambdaConflictHandlerConfigPropertyToCloudFormation(properties.lambdaConflictHandlerConfig) }) : properties;
    }
    function CfnResolverSyncConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("conflictDetection", "ConflictDetection", cfn_parse.FromCloudFormation.getString(properties.ConflictDetection)), ret.addPropertyResult("conflictHandler", "ConflictHandler", properties.ConflictHandler != null ? cfn_parse.FromCloudFormation.getString(properties.ConflictHandler) : void 0), ret.addPropertyResult("lambdaConflictHandlerConfig", "LambdaConflictHandlerConfig", properties.LambdaConflictHandlerConfig != null ? CfnResolverLambdaConflictHandlerConfigPropertyFromCloudFormation(properties.LambdaConflictHandlerConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-appsync/lib/appsync-function.js
var require_appsync_function = __commonJS({
  "node_modules/aws-cdk-lib/aws-appsync/lib/appsync-function.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AppsyncFunction = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var appsync_generated_1 = require_appsync_generated();
    var core_1 = require_core2();
    var AppsyncFunction = class _AppsyncFunction extends core_1.Resource {
      static fromAppsyncFunctionAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_AppsyncFunctionAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromAppsyncFunctionAttributes), error;
        }
        class Import extends core_1.Resource {
          constructor(s, i) {
            super(s, i), this.functionId = core_1.Lazy.stringValue({ produce: () => core_1.Fn.select(3, core_1.Fn.split("/", attrs.functionArn)) }), this.functionArn = attrs.functionArn;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_AppsyncFunctionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AppsyncFunction), error;
        }
        if (props.runtime && !props.code)
          throw new Error("Code is required when specifying a runtime");
        if (props.code && (props.requestMappingTemplate || props.responseMappingTemplate))
          throw new Error("Mapping templates cannot be used alongside code");
        const code = props.code?.bind(this);
        this.function = new appsync_generated_1.CfnFunctionConfiguration(this, "Resource", { name: props.name, description: props.description, apiId: props.api.apiId, dataSourceName: props.dataSource.name, runtime: props.runtime?.toProperties(), codeS3Location: code?.s3Location, code: code?.inlineCode, functionVersion: "2018-05-29", requestMappingTemplate: props.requestMappingTemplate?.renderTemplate(), responseMappingTemplate: props.responseMappingTemplate?.renderTemplate() }), this.functionName = this.function.attrName, this.functionArn = this.function.attrFunctionArn, this.functionId = this.function.attrFunctionId, this.dataSource = props.dataSource, this.function.addDependency(this.dataSource.ds), props.api.addSchemaDependency(this.function);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AppsyncFunction[_a] = { fqn: "aws-cdk-lib.aws_appsync.AppsyncFunction", version: "2.80.0" }, exports2.AppsyncFunction = AppsyncFunction;
  }
});

// node_modules/aws-cdk-lib/aws-appsync/lib/caching-config.js
var require_caching_config = __commonJS({
  "node_modules/aws-cdk-lib/aws-appsync/lib/caching-config.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-appsync/lib/caching-key.js
var require_caching_key = __commonJS({
  "node_modules/aws-cdk-lib/aws-appsync/lib/caching-key.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.BASE_CACHING_KEYS = exports2.CONTEXT_IDENTITY_CACHING_KEY = exports2.CONTEXT_SOURCE_CACHING_KEY = exports2.CONTEXT_ARGUMENTS_CACHING_KEY = void 0, exports2.CONTEXT_ARGUMENTS_CACHING_KEY = "$context.arguments", exports2.CONTEXT_SOURCE_CACHING_KEY = "$context.source", exports2.CONTEXT_IDENTITY_CACHING_KEY = "$context.identity", exports2.BASE_CACHING_KEYS = [exports2.CONTEXT_ARGUMENTS_CACHING_KEY, exports2.CONTEXT_SOURCE_CACHING_KEY, exports2.CONTEXT_IDENTITY_CACHING_KEY];
  }
});

// node_modules/aws-cdk-lib/aws-appsync/lib/private.js
var require_private = __commonJS({
  "node_modules/aws-cdk-lib/aws-appsync/lib/private.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Between = exports2.BinaryCondition = exports2.BeginsWith = exports2.BaseKeyCondition = void 0;
    var BaseKeyCondition = class _BaseKeyCondition {
      and(cond) {
        return new class extends _BaseKeyCondition {
          constructor(left, right) {
            super(), this.left = left, this.right = right;
          }
          renderCondition() {
            return `${this.left.renderCondition()} AND ${this.right.renderCondition()}`;
          }
          keyNames() {
            return concatAndDedup(this.left.keyNames(), this.right.keyNames());
          }
          args() {
            return concatAndDedup(this.left.args(), this.right.args());
          }
        }(this, cond);
      }
      renderExpressionNames() {
        return this.keyNames().map((keyName) => `"#${keyName}" : "${keyName}"`).join(", ");
      }
      renderExpressionValues() {
        return this.args().map((arg) => `":${arg}" : $util.dynamodb.toDynamoDBJson($ctx.args.${arg})`).join(", ");
      }
    };
    exports2.BaseKeyCondition = BaseKeyCondition;
    var BeginsWith = class extends BaseKeyCondition {
      constructor(keyName, arg) {
        super(), this.keyName = keyName, this.arg = arg;
      }
      renderCondition() {
        return `begins_with(#${this.keyName}, :${this.arg})`;
      }
      keyNames() {
        return [this.keyName];
      }
      args() {
        return [this.arg];
      }
    };
    exports2.BeginsWith = BeginsWith;
    var BinaryCondition = class extends BaseKeyCondition {
      constructor(keyName, op, arg) {
        super(), this.keyName = keyName, this.op = op, this.arg = arg;
      }
      renderCondition() {
        return `#${this.keyName} ${this.op} :${this.arg}`;
      }
      keyNames() {
        return [this.keyName];
      }
      args() {
        return [this.arg];
      }
    };
    exports2.BinaryCondition = BinaryCondition;
    var Between = class extends BaseKeyCondition {
      constructor(keyName, arg1, arg2) {
        super(), this.keyName = keyName, this.arg1 = arg1, this.arg2 = arg2;
      }
      renderCondition() {
        return `#${this.keyName} BETWEEN :${this.arg1} AND :${this.arg2}`;
      }
      keyNames() {
        return [this.keyName];
      }
      args() {
        return [this.arg1, this.arg2];
      }
    };
    exports2.Between = Between;
    function concatAndDedup(left, right) {
      return left.concat(right).filter((elem, index, self2) => index === self2.indexOf(elem));
    }
  }
});

// node_modules/aws-cdk-lib/aws-appsync/lib/key.js
var require_key3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-appsync/lib/key.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Values = exports2.AttributeValuesStep = exports2.AttributeValues = exports2.PartitionKey = exports2.PrimaryKey = exports2.SortKeyStep = exports2.PartitionKeyStep = exports2.Assign = exports2.KeyCondition = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var private_1 = require_private();
    var KeyCondition = class _KeyCondition {
      static eq(keyName, arg) {
        return new _KeyCondition(new private_1.BinaryCondition(keyName, "=", arg));
      }
      static lt(keyName, arg) {
        return new _KeyCondition(new private_1.BinaryCondition(keyName, "<", arg));
      }
      static le(keyName, arg) {
        return new _KeyCondition(new private_1.BinaryCondition(keyName, "<=", arg));
      }
      static gt(keyName, arg) {
        return new _KeyCondition(new private_1.BinaryCondition(keyName, ">", arg));
      }
      static ge(keyName, arg) {
        return new _KeyCondition(new private_1.BinaryCondition(keyName, ">=", arg));
      }
      static beginsWith(keyName, arg) {
        return new _KeyCondition(new private_1.BeginsWith(keyName, arg));
      }
      static between(keyName, arg1, arg2) {
        return new _KeyCondition(new private_1.Between(keyName, arg1, arg2));
      }
      constructor(cond) {
        this.cond = cond;
      }
      and(keyCond) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_KeyCondition(keyCond);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.and), error;
        }
        return new _KeyCondition(this.cond.and(keyCond.cond));
      }
      renderTemplate() {
        return `"query" : {
              "expression" : "${this.cond.renderCondition()}",
              "expressionNames" : {
                ${this.cond.renderExpressionNames()}
              },
              "expressionValues" : {
                ${this.cond.renderExpressionValues()}
              }
            }`;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, KeyCondition[_a] = { fqn: "aws-cdk-lib.aws_appsync.KeyCondition", version: "2.80.0" }, exports2.KeyCondition = KeyCondition;
    var Assign = class {
      constructor(attr, arg) {
        this.attr = attr, this.arg = arg;
      }
      renderAsAssignment() {
        return `"${this.attr}" : $util.dynamodb.toDynamoDBJson(${this.arg})`;
      }
      putInMap(map) {
        return `$util.qr($${map}.put("${this.attr}", ${this.arg}))`;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, Assign[_b] = { fqn: "aws-cdk-lib.aws_appsync.Assign", version: "2.80.0" }, exports2.Assign = Assign;
    var PartitionKeyStep = class {
      constructor(key) {
        this.key = key;
      }
      is(val) {
        return new PartitionKey(new Assign(this.key, `$ctx.args.${val}`));
      }
      auto() {
        return new PartitionKey(new Assign(this.key, "$util.autoId()"));
      }
    };
    _c = JSII_RTTI_SYMBOL_1, PartitionKeyStep[_c] = { fqn: "aws-cdk-lib.aws_appsync.PartitionKeyStep", version: "2.80.0" }, exports2.PartitionKeyStep = PartitionKeyStep;
    var SortKeyStep = class _SortKeyStep {
      constructor(pkey, skey) {
        this.pkey = pkey, this.skey = skey;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_Assign(pkey);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SortKeyStep), error;
        }
      }
      is(val) {
        return new PrimaryKey(this.pkey, new Assign(this.skey, `$ctx.args.${val}`));
      }
      auto() {
        return new PrimaryKey(this.pkey, new Assign(this.skey, "$util.autoId()"));
      }
    };
    _d = JSII_RTTI_SYMBOL_1, SortKeyStep[_d] = { fqn: "aws-cdk-lib.aws_appsync.SortKeyStep", version: "2.80.0" }, exports2.SortKeyStep = SortKeyStep;
    var PrimaryKey = class _PrimaryKey {
      static partition(key) {
        return new PartitionKeyStep(key);
      }
      constructor(pkey, skey) {
        this.pkey = pkey, this.skey = skey;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_Assign(pkey), jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_Assign(skey);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _PrimaryKey), error;
        }
      }
      renderTemplate() {
        const assignments = [this.pkey.renderAsAssignment()];
        return this.skey && assignments.push(this.skey.renderAsAssignment()), `"key" : {
      ${assignments.join(",")}
    }`;
      }
    };
    _e = JSII_RTTI_SYMBOL_1, PrimaryKey[_e] = { fqn: "aws-cdk-lib.aws_appsync.PrimaryKey", version: "2.80.0" }, exports2.PrimaryKey = PrimaryKey;
    var PartitionKey = class _PartitionKey extends PrimaryKey {
      constructor(pkey) {
        super(pkey);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_Assign(pkey);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _PartitionKey), error;
        }
      }
      sort(key) {
        return new SortKeyStep(this.pkey, key);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, PartitionKey[_f] = { fqn: "aws-cdk-lib.aws_appsync.PartitionKey", version: "2.80.0" }, exports2.PartitionKey = PartitionKey;
    var AttributeValues = class {
      constructor(container, assignments = []) {
        this.container = container, this.assignments = assignments;
      }
      attribute(attr) {
        return new AttributeValuesStep(attr, this.container, this.assignments);
      }
      renderVariables() {
        return `#set($input = ${this.container})
      ${this.assignments.map((a) => a.putInMap("input")).join(`
`)}`;
      }
      renderTemplate() {
        return '"attributeValues": $util.dynamodb.toMapValuesJson($input)';
      }
    };
    _g = JSII_RTTI_SYMBOL_1, AttributeValues[_g] = { fqn: "aws-cdk-lib.aws_appsync.AttributeValues", version: "2.80.0" }, exports2.AttributeValues = AttributeValues;
    var AttributeValuesStep = class {
      constructor(attr, container, assignments) {
        this.attr = attr, this.container = container, this.assignments = assignments;
      }
      is(val) {
        return this.assignments.push(new Assign(this.attr, val)), new AttributeValues(this.container, this.assignments);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, AttributeValuesStep[_h] = { fqn: "aws-cdk-lib.aws_appsync.AttributeValuesStep", version: "2.80.0" }, exports2.AttributeValuesStep = AttributeValuesStep;
    var Values = class {
      static projecting(arg) {
        return new AttributeValues("$ctx.args" + (arg ? `.${arg}` : ""));
      }
      static attribute(attr) {
        return new AttributeValues("{}").attribute(attr);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, Values[_j] = { fqn: "aws-cdk-lib.aws_appsync.Values", version: "2.80.0" }, exports2.Values = Values;
  }
});

// node_modules/aws-cdk-lib/aws-appsync/lib/resolver.js
var require_resolver = __commonJS({
  "node_modules/aws-cdk-lib/aws-appsync/lib/resolver.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Resolver = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var appsync_generated_1 = require_appsync_generated();
    var caching_key_1 = require_caching_key();
    var core_1 = require_core2();
    var Resolver = class _Resolver extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_ResolverProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Resolver), error;
        }
        const pipelineConfig = props.pipelineConfig && props.pipelineConfig.length ? { functions: props.pipelineConfig.map((func) => func.functionId) } : void 0;
        if (props.runtime && !props.code)
          throw new Error("Code is required when specifying a runtime");
        if (props.code && (props.requestMappingTemplate || props.responseMappingTemplate))
          throw new Error("Mapping templates cannot be used alongside code");
        if (pipelineConfig && props.dataSource)
          throw new Error(`Pipeline Resolver cannot have data source. Received: ${props.dataSource.name}`);
        if (props.cachingConfig?.ttl && (props.cachingConfig.ttl.toSeconds() < 1 || props.cachingConfig.ttl.toSeconds() > 3600))
          throw new Error(`Caching config TTL must be between 1 and 3600 seconds. Received: ${props.cachingConfig.ttl.toSeconds()}`);
        if (props.cachingConfig?.cachingKeys && props.cachingConfig.cachingKeys.find((cachingKey) => !core_1.Token.isUnresolved(cachingKey) && !caching_key_1.BASE_CACHING_KEYS.find((baseCachingKey) => cachingKey.startsWith(baseCachingKey))))
          throw new Error(`Caching config keys must begin with $context.arguments, $context.source or $context.identity. Received: ${props.cachingConfig.cachingKeys}`);
        const code = props.code?.bind(this);
        this.resolver = new appsync_generated_1.CfnResolver(this, "Resource", { apiId: props.api.apiId, typeName: props.typeName, fieldName: props.fieldName, dataSourceName: props.dataSource ? props.dataSource.name : void 0, kind: pipelineConfig ? "PIPELINE" : "UNIT", runtime: props.runtime?.toProperties(), codeS3Location: code?.s3Location, code: code?.inlineCode, pipelineConfig, requestMappingTemplate: props.requestMappingTemplate ? props.requestMappingTemplate.renderTemplate() : void 0, responseMappingTemplate: props.responseMappingTemplate ? props.responseMappingTemplate.renderTemplate() : void 0, cachingConfig: this.createCachingConfig(props.cachingConfig), maxBatchSize: props.maxBatchSize }), props.api.addSchemaDependency(this.resolver), props.dataSource && this.resolver.addDependency(props.dataSource.ds), this.arn = this.resolver.attrResolverArn;
      }
      createCachingConfig(config) {
        return config ? { cachingKeys: config.cachingKeys, ttl: config.ttl?.toSeconds() } : void 0;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Resolver[_a] = { fqn: "aws-cdk-lib.aws_appsync.Resolver", version: "2.80.0" }, exports2.Resolver = Resolver;
  }
});

// node_modules/aws-cdk-lib/aws-appsync/lib/data-source.js
var require_data_source = __commonJS({
  "node_modules/aws-cdk-lib/aws-appsync/lib/data-source.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.OpenSearchDataSource = exports2.ElasticsearchDataSource = exports2.RdsDataSource = exports2.LambdaDataSource = exports2.EventBridgeDataSource = exports2.HttpDataSource = exports2.DynamoDbDataSource = exports2.NoneDataSource = exports2.BackedDataSource = exports2.BaseDataSource = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var appsync_function_1 = require_appsync_function();
    var appsync_generated_1 = require_appsync_generated();
    var resolver_1 = require_resolver();
    var aws_iam_1 = require_aws_iam();
    var core_1 = require_core2();
    var BaseDataSource = class _BaseDataSource extends constructs_1.Construct {
      constructor(scope, id, props, extended) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_BackedDataSourceProps(props), jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_ExtendedDataSourceProps(extended);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _BaseDataSource), error;
        }
        extended.type !== "NONE" && (this.serviceRole = props.serviceRole || new aws_iam_1.Role(this, "ServiceRole", { assumedBy: new aws_iam_1.ServicePrincipal("appsync.amazonaws.com") }));
        const name = props.name ?? id, supportedName = core_1.Token.isUnresolved(name) ? name : name.replace(/[\W]+/g, "");
        this.ds = new appsync_generated_1.CfnDataSource(this, "Resource", { apiId: props.api.apiId, name: supportedName, description: props.description, serviceRoleArn: this.serviceRole?.roleArn, ...extended }), this.name = supportedName, this.api = props.api;
      }
      createResolver(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_BaseResolverProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.createResolver), error;
        }
        return new resolver_1.Resolver(this.api, id, { api: this.api, dataSource: this, ...props });
      }
      createFunction(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_BaseAppsyncFunctionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.createFunction), error;
        }
        return new appsync_function_1.AppsyncFunction(this.api, id, { api: this.api, dataSource: this, ...props });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, BaseDataSource[_a] = { fqn: "aws-cdk-lib.aws_appsync.BaseDataSource", version: "2.80.0" }, exports2.BaseDataSource = BaseDataSource;
    var BackedDataSource = class _BackedDataSource extends BaseDataSource {
      constructor(scope, id, props, extended) {
        super(scope, id, props, extended);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_BackedDataSourceProps(props), jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_ExtendedDataSourceProps(extended);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _BackedDataSource), error;
        }
        this.grantPrincipal = this.serviceRole;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, BackedDataSource[_b] = { fqn: "aws-cdk-lib.aws_appsync.BackedDataSource", version: "2.80.0" }, exports2.BackedDataSource = BackedDataSource;
    var NoneDataSource = class _NoneDataSource extends BaseDataSource {
      constructor(scope, id, props) {
        super(scope, id, props, { type: "NONE" });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_NoneDataSourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _NoneDataSource), error;
        }
      }
    };
    _c = JSII_RTTI_SYMBOL_1, NoneDataSource[_c] = { fqn: "aws-cdk-lib.aws_appsync.NoneDataSource", version: "2.80.0" }, exports2.NoneDataSource = NoneDataSource;
    var DynamoDbDataSource = class _DynamoDbDataSource extends BackedDataSource {
      constructor(scope, id, props) {
        super(scope, id, props, { type: "AMAZON_DYNAMODB", dynamoDbConfig: { tableName: props.table.tableName, awsRegion: props.table.env.region, useCallerCredentials: props.useCallerCredentials } });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_DynamoDbDataSourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _DynamoDbDataSource), error;
        }
        props.readOnlyAccess ? props.table.grantReadData(this) : props.table.grantReadWriteData(this);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, DynamoDbDataSource[_d] = { fqn: "aws-cdk-lib.aws_appsync.DynamoDbDataSource", version: "2.80.0" }, exports2.DynamoDbDataSource = DynamoDbDataSource;
    var HttpDataSource = class _HttpDataSource extends BackedDataSource {
      constructor(scope, id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_HttpDataSourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _HttpDataSource), error;
        }
        const authorizationConfig = props.authorizationConfig ? { authorizationType: "AWS_IAM", awsIamConfig: props.authorizationConfig } : void 0;
        super(scope, id, props, { type: "HTTP", httpConfig: { endpoint: props.endpoint, authorizationConfig } });
      }
    };
    _e = JSII_RTTI_SYMBOL_1, HttpDataSource[_e] = { fqn: "aws-cdk-lib.aws_appsync.HttpDataSource", version: "2.80.0" }, exports2.HttpDataSource = HttpDataSource;
    var EventBridgeDataSource = class _EventBridgeDataSource extends BackedDataSource {
      constructor(scope, id, props) {
        super(scope, id, props, { type: "AMAZON_EVENTBRIDGE", eventBridgeConfig: { eventBusArn: props.eventBus.eventBusArn } });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_EventBridgeDataSourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EventBridgeDataSource), error;
        }
        props.eventBus.grantPutEventsTo(this);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, EventBridgeDataSource[_f] = { fqn: "aws-cdk-lib.aws_appsync.EventBridgeDataSource", version: "2.80.0" }, exports2.EventBridgeDataSource = EventBridgeDataSource;
    var LambdaDataSource = class _LambdaDataSource extends BackedDataSource {
      constructor(scope, id, props) {
        super(scope, id, props, { type: "AWS_LAMBDA", lambdaConfig: { lambdaFunctionArn: props.lambdaFunction.functionArn } });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_LambdaDataSourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _LambdaDataSource), error;
        }
        props.lambdaFunction.grantInvoke(this);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, LambdaDataSource[_g] = { fqn: "aws-cdk-lib.aws_appsync.LambdaDataSource", version: "2.80.0" }, exports2.LambdaDataSource = LambdaDataSource;
    var RdsDataSource = class _RdsDataSource extends BackedDataSource {
      constructor(scope, id, props) {
        super(scope, id, props, { type: "RELATIONAL_DATABASE", relationalDatabaseConfig: { rdsHttpEndpointConfig: { awsRegion: props.serverlessCluster.env.region, dbClusterIdentifier: core_1.Lazy.string({ produce: () => core_1.Stack.of(this).formatArn({ service: "rds", resource: `cluster:${props.serverlessCluster.clusterIdentifier}` }) }), awsSecretStoreArn: props.secretStore.secretArn, databaseName: props.databaseName }, relationalDatabaseSourceType: "RDS_HTTP_ENDPOINT" } });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_RdsDataSourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _RdsDataSource), error;
        }
        const clusterArn = core_1.Stack.of(this).formatArn({ service: "rds", resource: `cluster:${props.serverlessCluster.clusterIdentifier}` });
        props.secretStore.grantRead(this), props.serverlessCluster.grantDataApiAccess(this), aws_iam_1.Grant.addToPrincipal({ grantee: this, actions: ["rds-data:DeleteItems", "rds-data:ExecuteSql", "rds-data:GetItems", "rds-data:InsertItems", "rds-data:UpdateItems"], resourceArns: [clusterArn, `${clusterArn}:*`], scope: this });
      }
    };
    _h = JSII_RTTI_SYMBOL_1, RdsDataSource[_h] = { fqn: "aws-cdk-lib.aws_appsync.RdsDataSource", version: "2.80.0" }, exports2.RdsDataSource = RdsDataSource;
    var ElasticsearchDataSource = class _ElasticsearchDataSource extends BackedDataSource {
      constructor(scope, id, props) {
        super(scope, id, props, { type: "AMAZON_ELASTICSEARCH", elasticsearchConfig: { awsRegion: props.domain.env.region, endpoint: `https://${props.domain.domainEndpoint}` } });
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_appsync.ElasticsearchDataSource", "- use `OpenSearchDataSource`"), jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_ElasticsearchDataSourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ElasticsearchDataSource), error;
        }
        props.domain.grantReadWrite(this);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, ElasticsearchDataSource[_j] = { fqn: "aws-cdk-lib.aws_appsync.ElasticsearchDataSource", version: "2.80.0" }, exports2.ElasticsearchDataSource = ElasticsearchDataSource;
    var OpenSearchDataSource = class _OpenSearchDataSource extends BackedDataSource {
      constructor(scope, id, props) {
        super(scope, id, props, { type: "AMAZON_OPENSEARCH_SERVICE", openSearchServiceConfig: { awsRegion: props.domain.env.region, endpoint: `https://${props.domain.domainEndpoint}` } });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_OpenSearchDataSourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _OpenSearchDataSource), error;
        }
        props.domain.grantReadWrite(this);
      }
    };
    _k = JSII_RTTI_SYMBOL_1, OpenSearchDataSource[_k] = { fqn: "aws-cdk-lib.aws_appsync.OpenSearchDataSource", version: "2.80.0" }, exports2.OpenSearchDataSource = OpenSearchDataSource;
  }
});

// node_modules/aws-cdk-lib/aws-appsync/lib/mapping-template.js
var require_mapping_template = __commonJS({
  "node_modules/aws-cdk-lib/aws-appsync/lib/mapping-template.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.MappingTemplate = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var fs_1 = require("fs");
    var MappingTemplate = class {
      static fromString(template) {
        return new StringMappingTemplate(template);
      }
      static fromFile(fileName) {
        return new StringMappingTemplate((0, fs_1.readFileSync)(fileName).toString("utf-8"));
      }
      static dynamoDbResultList() {
        return this.fromString("$util.toJson($ctx.result.items)");
      }
      static dynamoDbResultItem() {
        return this.fromString("$util.toJson($ctx.result)");
      }
      static dynamoDbScanTable(consistentRead = false) {
        return this.fromString(`{"version" : "2017-02-28", "operation" : "Scan", "consistentRead": ${consistentRead}}`);
      }
      static dynamoDbQuery(cond, indexName, consistentRead = false) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_KeyCondition(cond);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.dynamoDbQuery), error;
        }
        return this.fromString(`{"version" : "2017-02-28", "operation" : "Query",  "consistentRead": ${consistentRead}, ${indexName ? `"index" : "${indexName}", ` : ""}${cond.renderTemplate()}}`);
      }
      static dynamoDbGetItem(keyName, idArg, consistentRead = false) {
        return this.fromString(`{"version": "2017-02-28", "operation": "GetItem", "consistentRead": ${consistentRead}, "key": {"${keyName}": $util.dynamodb.toDynamoDBJson($ctx.args.${idArg})}}`);
      }
      static dynamoDbDeleteItem(keyName, idArg) {
        return this.fromString(`{"version": "2017-02-28", "operation": "DeleteItem", "key": {"${keyName}": $util.dynamodb.toDynamoDBJson($ctx.args.${idArg})}}`);
      }
      static dynamoDbPutItem(key, values) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_PrimaryKey(key), jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_AttributeValues(values);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.dynamoDbPutItem), error;
        }
        return this.fromString(`
      ${values.renderVariables()}
      {
        "version": "2017-02-28",
        "operation": "PutItem",
        ${key.renderTemplate()},
        ${values.renderTemplate()}
      }`);
      }
      static lambdaRequest(payload2 = "$util.toJson($ctx)", operation = "Invoke") {
        return this.fromString(`{"version": "2017-02-28", "operation": "${operation}", "payload": ${payload2}}`);
      }
      static lambdaResult() {
        return this.fromString("$util.toJson($ctx.result)");
      }
    };
    _a = JSII_RTTI_SYMBOL_1, MappingTemplate[_a] = { fqn: "aws-cdk-lib.aws_appsync.MappingTemplate", version: "2.80.0" }, exports2.MappingTemplate = MappingTemplate;
    var StringMappingTemplate = class extends MappingTemplate {
      constructor(template) {
        super(), this.template = template;
      }
      renderTemplate() {
        return this.template;
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-appsync/lib/schema.js
var require_schema4 = __commonJS({
  "node_modules/aws-cdk-lib/aws-appsync/lib/schema.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SchemaFile = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var fs_1 = require("fs");
    var SchemaFile = class _SchemaFile {
      static fromAsset(filePath) {
        return new _SchemaFile({ filePath });
      }
      constructor(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_SchemaProps(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SchemaFile), error;
        }
        this.definition = (0, fs_1.readFileSync)(options.filePath).toString("utf-8");
      }
      bind(api, _options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_IGraphqlApi(api), jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_SchemaBindOptions(_options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { apiId: api.apiId, definition: this.definition };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SchemaFile[_a] = { fqn: "aws-cdk-lib.aws_appsync.SchemaFile", version: "2.80.0" }, exports2.SchemaFile = SchemaFile;
  }
});

// node_modules/aws-cdk-lib/aws-appsync/lib/graphqlapi-base.js
var require_graphqlapi_base = __commonJS({
  "node_modules/aws-cdk-lib/aws-appsync/lib/graphqlapi-base.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.GraphqlApiBase = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var data_source_1 = require_data_source();
    var resolver_1 = require_resolver();
    var core_1 = require_core2();
    var GraphqlApiBase = class extends core_1.Resource {
      addNoneDataSource(id, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_DataSourceOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addNoneDataSource), error;
        }
        return new data_source_1.NoneDataSource(this, id, { api: this, name: options?.name, description: options?.description });
      }
      addDynamoDbDataSource(id, table, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_dynamodb_ITable(table), jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_DataSourceOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addDynamoDbDataSource), error;
        }
        return new data_source_1.DynamoDbDataSource(this, id, { api: this, table, name: options?.name, description: options?.description });
      }
      addHttpDataSource(id, endpoint, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_HttpDataSourceOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addHttpDataSource), error;
        }
        return new data_source_1.HttpDataSource(this, id, { api: this, endpoint, name: options?.name, description: options?.description, authorizationConfig: options?.authorizationConfig });
      }
      addLambdaDataSource(id, lambdaFunction, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_IFunction(lambdaFunction), jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_DataSourceOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addLambdaDataSource), error;
        }
        return new data_source_1.LambdaDataSource(this, id, { api: this, lambdaFunction, name: options?.name, description: options?.description });
      }
      addRdsDataSource(id, serverlessCluster, secretStore, databaseName, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_IServerlessCluster(serverlessCluster), jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_ISecret(secretStore), jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_DataSourceOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addRdsDataSource), error;
        }
        return new data_source_1.RdsDataSource(this, id, { api: this, name: options?.name, description: options?.description, serverlessCluster, secretStore, databaseName });
      }
      addElasticsearchDataSource(id, domain, options) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_appsync.GraphqlApiBase#addElasticsearchDataSource", "- use `addOpenSearchDataSource`"), jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticsearch_IDomain(domain), jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_DataSourceOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addElasticsearchDataSource), error;
        }
        return new data_source_1.ElasticsearchDataSource(this, id, { api: this, name: options?.name, description: options?.description, domain });
      }
      addEventBridgeDataSource(id, eventBus, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_IEventBus(eventBus), jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_DataSourceOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addEventBridgeDataSource), error;
        }
        return new data_source_1.EventBridgeDataSource(this, id, { api: this, eventBus, name: options?.name, description: options?.description });
      }
      addOpenSearchDataSource(id, domain, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_opensearchservice_IDomain(domain), jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_DataSourceOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addOpenSearchDataSource), error;
        }
        return new data_source_1.OpenSearchDataSource(this, id, { api: this, name: options?.name, description: options?.description, domain });
      }
      createResolver(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_ExtendedResolverProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.createResolver), error;
        }
        return new resolver_1.Resolver(this, id, { api: this, ...props });
      }
      addSchemaDependency(construct) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnResource(construct);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addSchemaDependency), error;
        }
        return false;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, GraphqlApiBase[_a] = { fqn: "aws-cdk-lib.aws_appsync.GraphqlApiBase", version: "2.80.0" }, exports2.GraphqlApiBase = GraphqlApiBase;
  }
});

// node_modules/aws-cdk-lib/aws-appsync/lib/graphqlapi.js
var require_graphqlapi = __commonJS({
  "node_modules/aws-cdk-lib/aws-appsync/lib/graphqlapi.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.GraphqlApi = exports2.IamResource = exports2.Visibility = exports2.FieldLogLevel = exports2.UserPoolDefaultAction = exports2.AuthorizationType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var appsync_generated_1 = require_appsync_generated();
    var graphqlapi_base_1 = require_graphqlapi_base();
    var aws_iam_1 = require_aws_iam();
    var aws_logs_1 = require_aws_logs();
    var core_1 = require_core2();
    var AuthorizationType;
    (function(AuthorizationType2) {
      AuthorizationType2.API_KEY = "API_KEY", AuthorizationType2.IAM = "AWS_IAM", AuthorizationType2.USER_POOL = "AMAZON_COGNITO_USER_POOLS", AuthorizationType2.OIDC = "OPENID_CONNECT", AuthorizationType2.LAMBDA = "AWS_LAMBDA";
    })(AuthorizationType = exports2.AuthorizationType || (exports2.AuthorizationType = {}));
    var UserPoolDefaultAction;
    (function(UserPoolDefaultAction2) {
      UserPoolDefaultAction2.ALLOW = "ALLOW", UserPoolDefaultAction2.DENY = "DENY";
    })(UserPoolDefaultAction = exports2.UserPoolDefaultAction || (exports2.UserPoolDefaultAction = {}));
    var FieldLogLevel;
    (function(FieldLogLevel2) {
      FieldLogLevel2.NONE = "NONE", FieldLogLevel2.ERROR = "ERROR", FieldLogLevel2.ALL = "ALL";
    })(FieldLogLevel = exports2.FieldLogLevel || (exports2.FieldLogLevel = {}));
    var Visibility;
    (function(Visibility2) {
      Visibility2.GLOBAL = "GLOBAL", Visibility2.PRIVATE = "PRIVATE";
    })(Visibility = exports2.Visibility || (exports2.Visibility = {}));
    var IamResource = class _IamResource {
      static custom(...arns) {
        if (arns.length === 0)
          throw new Error("At least 1 custom ARN must be provided.");
        return new _IamResource(arns);
      }
      static ofType(type, ...fields) {
        const arns = fields.length ? fields.map((field) => `types/${type}/fields/${field}`) : [`types/${type}/*`];
        return new _IamResource(arns);
      }
      static all() {
        return new _IamResource(["*"]);
      }
      constructor(arns) {
        this.arns = arns;
      }
      resourceArns(api) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_GraphqlApi(api);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.resourceArns), error;
        }
        return this.arns.map((arn) => core_1.Stack.of(api).formatArn({ service: "appsync", resource: `apis/${api.apiId}`, arnFormat: core_1.ArnFormat.SLASH_RESOURCE_NAME, resourceName: `${arn}` }));
      }
    };
    _a = JSII_RTTI_SYMBOL_1, IamResource[_a] = { fqn: "aws-cdk-lib.aws_appsync.IamResource", version: "2.80.0" }, exports2.IamResource = IamResource;
    var GraphqlApi = class _GraphqlApi extends graphqlapi_base_1.GraphqlApiBase {
      static fromGraphqlApiAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_GraphqlApiAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromGraphqlApiAttributes), error;
        }
        const arn = attrs.graphqlApiArn ?? core_1.Stack.of(scope).formatArn({ service: "appsync", resource: `apis/${attrs.graphqlApiId}` });
        class Import extends graphqlapi_base_1.GraphqlApiBase {
          constructor(s, i) {
            super(s, i), this.apiId = attrs.graphqlApiId, this.arn = arn;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_GraphqlApiProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _GraphqlApi), error;
        }
        const defaultMode = props.authorizationConfig?.defaultAuthorization ?? { authorizationType: AuthorizationType.API_KEY }, additionalModes = props.authorizationConfig?.additionalAuthorizationModes ?? [], modes = [defaultMode, ...additionalModes];
        if (this.modes = modes.map((mode) => mode.authorizationType), this.validateAuthorizationProps(modes), this.api = new appsync_generated_1.CfnGraphQLApi(this, "Resource", { name: props.name, authenticationType: defaultMode.authorizationType, logConfig: this.setupLogConfig(props.logConfig), openIdConnectConfig: this.setupOpenIdConnectConfig(defaultMode.openIdConnectConfig), userPoolConfig: this.setupUserPoolConfig(defaultMode.userPoolConfig), lambdaAuthorizerConfig: this.setupLambdaAuthorizerConfig(defaultMode.lambdaAuthorizerConfig), additionalAuthenticationProviders: this.setupAdditionalAuthorizationModes(additionalModes), xrayEnabled: props.xrayEnabled, visibility: props.visibility }), this.apiId = this.api.attrApiId, this.arn = this.api.attrArn, this.graphqlUrl = this.api.attrGraphQlUrl, this.name = this.api.name, this.schema = props.schema, this.schemaResource = new appsync_generated_1.CfnGraphQLSchema(this, "Schema", this.schema.bind(this)), props.domainName && (this.domainNameResource = new appsync_generated_1.CfnDomainName(this, "DomainName", { domainName: props.domainName.domainName, certificateArn: props.domainName.certificate.certificateArn, description: `domain for ${this.name} at ${this.graphqlUrl}` }), new appsync_generated_1.CfnDomainNameApiAssociation(this, "DomainAssociation", { domainName: props.domainName.domainName, apiId: this.apiId }).addDependency(this.domainNameResource)), modes.some((mode) => mode.authorizationType === AuthorizationType.API_KEY)) {
          const config = modes.find((mode) => mode.authorizationType === AuthorizationType.API_KEY && mode.apiKeyConfig)?.apiKeyConfig;
          this.apiKeyResource = this.createAPIKey(config), this.apiKeyResource.addDependency(this.schemaResource), this.apiKey = this.apiKeyResource.attrApiKey;
        }
        modes.some((mode) => mode.authorizationType === AuthorizationType.LAMBDA) && modes.find((mode) => mode.authorizationType === AuthorizationType.LAMBDA && mode.lambdaAuthorizerConfig)?.lambdaAuthorizerConfig?.handler.addPermission(`${id}-appsync`, { principal: new aws_iam_1.ServicePrincipal("appsync.amazonaws.com"), action: "lambda:InvokeFunction" });
        const logGroupName = `/aws/appsync/apis/${this.apiId}`;
        this.logGroup = aws_logs_1.LogGroup.fromLogGroupName(this, "LogGroup", logGroupName), props.logConfig?.retention && new aws_logs_1.LogRetention(this, "LogRetention", { logGroupName: this.logGroup.logGroupName, retention: props.logConfig.retention });
      }
      grant(grantee, resources, ...actions) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(grantee), jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_IamResource(resources);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grant), error;
        }
        return aws_iam_1.Grant.addToPrincipal({ grantee, actions, resourceArns: resources.resourceArns(this), scope: this });
      }
      grantMutation(grantee, ...fields) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(grantee);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantMutation), error;
        }
        return this.grant(grantee, IamResource.ofType("Mutation", ...fields), "appsync:GraphQL");
      }
      grantQuery(grantee, ...fields) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(grantee);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantQuery), error;
        }
        return this.grant(grantee, IamResource.ofType("Query", ...fields), "appsync:GraphQL");
      }
      grantSubscription(grantee, ...fields) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(grantee);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantSubscription), error;
        }
        return this.grant(grantee, IamResource.ofType("Subscription", ...fields), "appsync:GraphQL");
      }
      validateAuthorizationProps(modes) {
        if (modes.filter((mode) => mode.authorizationType === AuthorizationType.LAMBDA).length > 1)
          throw new Error("You can only have a single AWS Lambda function configured to authorize your API.");
        if (modes.map((mode) => {
          if (mode.authorizationType === AuthorizationType.OIDC && !mode.openIdConnectConfig)
            throw new Error("Missing OIDC Configuration");
          if (mode.authorizationType === AuthorizationType.USER_POOL && !mode.userPoolConfig)
            throw new Error("Missing User Pool Configuration");
          if (mode.authorizationType === AuthorizationType.LAMBDA && !mode.lambdaAuthorizerConfig)
            throw new Error("Missing Lambda Configuration");
        }), modes.filter((mode) => mode.authorizationType === AuthorizationType.API_KEY).length > 1)
          throw new Error("You can't duplicate API_KEY configuration. See https://docs.aws.amazon.com/appsync/latest/devguide/security.html");
        if (modes.filter((mode) => mode.authorizationType === AuthorizationType.IAM).length > 1)
          throw new Error("You can't duplicate IAM configuration. See https://docs.aws.amazon.com/appsync/latest/devguide/security.html");
      }
      addSchemaDependency(construct) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnResource(construct);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addSchemaDependency), error;
        }
        return construct.addDependency(this.schemaResource), true;
      }
      setupLogConfig(config) {
        if (!config)
          return;
        const logsRoleArn = config.role?.roleArn ?? new aws_iam_1.Role(this, "ApiLogsRole", { assumedBy: new aws_iam_1.ServicePrincipal("appsync.amazonaws.com"), managedPolicies: [aws_iam_1.ManagedPolicy.fromAwsManagedPolicyName("service-role/AWSAppSyncPushToCloudWatchLogs")] }).roleArn, fieldLogLevel = config.fieldLogLevel ?? FieldLogLevel.NONE;
        return { cloudWatchLogsRoleArn: logsRoleArn, excludeVerboseContent: config.excludeVerboseContent, fieldLogLevel };
      }
      setupOpenIdConnectConfig(config) {
        if (config)
          return { authTtl: config.tokenExpiryFromAuth, clientId: config.clientId, iatTtl: config.tokenExpiryFromIssue, issuer: config.oidcProvider };
      }
      setupUserPoolConfig(config) {
        if (config)
          return { userPoolId: config.userPool.userPoolId, awsRegion: config.userPool.env.region, appIdClientRegex: config.appIdClientRegex, defaultAction: config.defaultAction || UserPoolDefaultAction.ALLOW };
      }
      setupLambdaAuthorizerConfig(config) {
        if (config)
          return { authorizerResultTtlInSeconds: config.resultsCacheTtl?.toSeconds(), authorizerUri: config.handler.functionArn, identityValidationExpression: config.validationRegex };
      }
      setupAdditionalAuthorizationModes(modes) {
        if (!(!modes || modes.length === 0))
          return modes.reduce((acc, mode) => [...acc, { authenticationType: mode.authorizationType, userPoolConfig: this.setupUserPoolConfig(mode.userPoolConfig), openIdConnectConfig: this.setupOpenIdConnectConfig(mode.openIdConnectConfig), lambdaAuthorizerConfig: this.setupLambdaAuthorizerConfig(mode.lambdaAuthorizerConfig) }], []);
      }
      createAPIKey(config) {
        if (config?.expires?.isBefore(core_1.Duration.days(1)) || config?.expires?.isAfter(core_1.Duration.days(365)))
          throw Error("API key expiration must be between 1 and 365 days.");
        const expires = config?.expires ? config?.expires.toEpoch() : void 0;
        return new appsync_generated_1.CfnApiKey(this, `${config?.name || "Default"}ApiKey`, { expires, description: config?.description, apiId: this.apiId });
      }
      get appSyncDomainName() {
        if (!this.domainNameResource)
          throw new Error("Cannot retrieve the appSyncDomainName without a domainName configuration");
        return this.domainNameResource.attrAppSyncDomainName;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, GraphqlApi[_b] = { fqn: "aws-cdk-lib.aws_appsync.GraphqlApi", version: "2.80.0" }, exports2.GraphqlApi = GraphqlApi;
  }
});

// node_modules/aws-cdk-lib/aws-appsync/lib/code.js
var require_code2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-appsync/lib/code.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.InlineCode = exports2.AssetCode = exports2.Code = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var s3_assets = require_aws_s3_assets();
    var cdk = require_core2();
    var Code2 = class {
      static fromAsset(path, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_assets_AssetOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromAsset), error;
        }
        return new AssetCode(path, options);
      }
      static fromInline(code) {
        return new InlineCode(code);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Code2[_a] = { fqn: "aws-cdk-lib.aws_appsync.Code", version: "2.80.0" }, exports2.Code = Code2;
    var AssetCode = class _AssetCode extends Code2 {
      constructor(path, options = {}) {
        super(), this.path = path, this.options = options;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_assets_AssetOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AssetCode), error;
        }
      }
      bind(scope) {
        if (!this.asset)
          this.asset = new s3_assets.Asset(scope, "Code", { path: this.path, ...this.options });
        else if (cdk.Stack.of(this.asset) !== cdk.Stack.of(scope))
          throw new Error(`Asset is already associated with another stack '${cdk.Stack.of(this.asset).stackName}'. Create a new Code instance for every stack.`);
        return { s3Location: this.asset.s3ObjectUrl };
      }
    };
    _b = JSII_RTTI_SYMBOL_1, AssetCode[_b] = { fqn: "aws-cdk-lib.aws_appsync.AssetCode", version: "2.80.0" }, exports2.AssetCode = AssetCode;
    var InlineCode = class extends Code2 {
      constructor(code) {
        if (super(), this.code = code, code.length === 0)
          throw new Error("AppSync Inline code cannot be empty");
      }
      bind(_scope) {
        return { inlineCode: this.code };
      }
    };
    _c = JSII_RTTI_SYMBOL_1, InlineCode[_c] = { fqn: "aws-cdk-lib.aws_appsync.InlineCode", version: "2.80.0" }, exports2.InlineCode = InlineCode;
  }
});

// node_modules/aws-cdk-lib/aws-appsync/lib/runtime.js
var require_runtime4 = __commonJS({
  "node_modules/aws-cdk-lib/aws-appsync/lib/runtime.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FunctionRuntime = exports2.FunctionRuntimeFamily = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var FunctionRuntimeFamily;
    (function(FunctionRuntimeFamily2) {
      FunctionRuntimeFamily2.JS = "APPSYNC_JS";
    })(FunctionRuntimeFamily = exports2.FunctionRuntimeFamily || (exports2.FunctionRuntimeFamily = {}));
    var FunctionRuntime = class _FunctionRuntime {
      constructor(family, version) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_appsync_FunctionRuntimeFamily(family);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _FunctionRuntime), error;
        }
        this.name = family, this.version = version;
      }
      toProperties() {
        return { name: this.name, runtimeVersion: this.version };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, FunctionRuntime[_a] = { fqn: "aws-cdk-lib.aws_appsync.FunctionRuntime", version: "2.80.0" }, FunctionRuntime.JS_1_0_0 = new FunctionRuntime(FunctionRuntimeFamily.JS, "1.0.0"), exports2.FunctionRuntime = FunctionRuntime;
  }
});

// node_modules/aws-cdk-lib/aws-appsync/lib/index.js
var require_lib48 = __commonJS({
  "node_modules/aws-cdk-lib/aws-appsync/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_appsync_function(), exports2), __exportStar(require_appsync_generated(), exports2), __exportStar(require_caching_config(), exports2), __exportStar(require_caching_key(), exports2), __exportStar(require_key3(), exports2), __exportStar(require_data_source(), exports2), __exportStar(require_mapping_template(), exports2), __exportStar(require_resolver(), exports2), __exportStar(require_schema4(), exports2), __exportStar(require_graphqlapi(), exports2), __exportStar(require_graphqlapi_base(), exports2), __exportStar(require_code2(), exports2), __exportStar(require_runtime4(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-appsync/index.js
var require_aws_appsync = __commonJS({
  "node_modules/aws-cdk-lib/aws-appsync/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib48(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-aps/lib/aps.generated.js
var require_aps_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-aps/lib/aps.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnWorkspace = exports2.CfnRuleGroupsNamespace = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnRuleGroupsNamespacePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("data", cdk.requiredValidator)(properties.data)), errors.collect(cdk.propertyValidator("data", cdk.validateString)(properties.data)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("workspace", cdk.requiredValidator)(properties.workspace)), errors.collect(cdk.propertyValidator("workspace", cdk.validateString)(properties.workspace)), errors.wrap('supplied properties not correct for "CfnRuleGroupsNamespaceProps"');
    }
    function cfnRuleGroupsNamespacePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroupsNamespacePropsValidator(properties).assertSuccess(), { Data: cdk.stringToCloudFormation(properties.data), Name: cdk.stringToCloudFormation(properties.name), Workspace: cdk.stringToCloudFormation(properties.workspace), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnRuleGroupsNamespacePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("data", "Data", cfn_parse.FromCloudFormation.getString(properties.Data)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("workspace", "Workspace", cfn_parse.FromCloudFormation.getString(properties.Workspace)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRuleGroupsNamespace = class _CfnRuleGroupsNamespace extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRuleGroupsNamespacePropsFromCloudFormation(resourceProperties), ret = new _CfnRuleGroupsNamespace(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRuleGroupsNamespace.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_aps_CfnRuleGroupsNamespaceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRuleGroupsNamespace), error;
        }
        cdk.requireProperty(props, "data", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "workspace", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.data = props.data, this.name = props.name, this.workspace = props.workspace, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::APS::RuleGroupsNamespace", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRuleGroupsNamespace.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { data: this.data, name: this.name, workspace: this.workspace, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnRuleGroupsNamespacePropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnRuleGroupsNamespace[_a] = { fqn: "aws-cdk-lib.aws_aps.CfnRuleGroupsNamespace", version: "2.80.0" }, CfnRuleGroupsNamespace.CFN_RESOURCE_TYPE_NAME = "AWS::APS::RuleGroupsNamespace", exports2.CfnRuleGroupsNamespace = CfnRuleGroupsNamespace;
    function CfnWorkspacePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alertManagerDefinition", cdk.validateString)(properties.alertManagerDefinition)), errors.collect(cdk.propertyValidator("alias", cdk.validateString)(properties.alias)), errors.collect(cdk.propertyValidator("loggingConfiguration", CfnWorkspace_LoggingConfigurationPropertyValidator)(properties.loggingConfiguration)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnWorkspaceProps"');
    }
    function cfnWorkspacePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkspacePropsValidator(properties).assertSuccess(), { AlertManagerDefinition: cdk.stringToCloudFormation(properties.alertManagerDefinition), Alias: cdk.stringToCloudFormation(properties.alias), LoggingConfiguration: cfnWorkspaceLoggingConfigurationPropertyToCloudFormation(properties.loggingConfiguration), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnWorkspacePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alertManagerDefinition", "AlertManagerDefinition", properties.AlertManagerDefinition != null ? cfn_parse.FromCloudFormation.getString(properties.AlertManagerDefinition) : void 0), ret.addPropertyResult("alias", "Alias", properties.Alias != null ? cfn_parse.FromCloudFormation.getString(properties.Alias) : void 0), ret.addPropertyResult("loggingConfiguration", "LoggingConfiguration", properties.LoggingConfiguration != null ? CfnWorkspaceLoggingConfigurationPropertyFromCloudFormation(properties.LoggingConfiguration) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnWorkspace = class _CfnWorkspace extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnWorkspacePropsFromCloudFormation(resourceProperties), ret = new _CfnWorkspace(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnWorkspace.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_aps_CfnWorkspaceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnWorkspace), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrPrometheusEndpoint = cdk.Token.asString(this.getAtt("PrometheusEndpoint", cdk.ResolutionTypeHint.STRING)), this.attrWorkspaceId = cdk.Token.asString(this.getAtt("WorkspaceId", cdk.ResolutionTypeHint.STRING)), this.alertManagerDefinition = props.alertManagerDefinition, this.alias = props.alias, this.loggingConfiguration = props.loggingConfiguration, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::APS::Workspace", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnWorkspace.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { alertManagerDefinition: this.alertManagerDefinition, alias: this.alias, loggingConfiguration: this.loggingConfiguration, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnWorkspacePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnWorkspace[_b] = { fqn: "aws-cdk-lib.aws_aps.CfnWorkspace", version: "2.80.0" }, CfnWorkspace.CFN_RESOURCE_TYPE_NAME = "AWS::APS::Workspace", exports2.CfnWorkspace = CfnWorkspace;
    function CfnWorkspace_LoggingConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logGroupArn", cdk.validateString)(properties.logGroupArn)), errors.wrap('supplied properties not correct for "LoggingConfigurationProperty"');
    }
    function cfnWorkspaceLoggingConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkspace_LoggingConfigurationPropertyValidator(properties).assertSuccess(), { LogGroupArn: cdk.stringToCloudFormation(properties.logGroupArn) }) : properties;
    }
    function CfnWorkspaceLoggingConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logGroupArn", "LogGroupArn", properties.LogGroupArn != null ? cfn_parse.FromCloudFormation.getString(properties.LogGroupArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-aps/lib/index.js
var require_lib49 = __commonJS({
  "node_modules/aws-cdk-lib/aws-aps/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_aps_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-aps/index.js
var require_aws_aps = __commonJS({
  "node_modules/aws-cdk-lib/aws-aps/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib49(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-athena/lib/athena.generated.js
var require_athena_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-athena/lib/athena.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnWorkGroup = exports2.CfnPreparedStatement = exports2.CfnNamedQuery = exports2.CfnDataCatalog = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnDataCatalogPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("parameters", cdk.hashValidator(cdk.validateString))(properties.parameters)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnDataCatalogProps"');
    }
    function cfnDataCatalogPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataCatalogPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Type: cdk.stringToCloudFormation(properties.type), Description: cdk.stringToCloudFormation(properties.description), Parameters: cdk.hashMapper(cdk.stringToCloudFormation)(properties.parameters), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDataCatalogPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Parameters) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDataCatalog = class _CfnDataCatalog extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDataCatalogPropsFromCloudFormation(resourceProperties), ret = new _CfnDataCatalog(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDataCatalog.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_athena_CfnDataCatalogProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDataCatalog), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "type", this), this.name = props.name, this.type = props.type, this.description = props.description, this.parameters = props.parameters, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Athena::DataCatalog", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDataCatalog.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, type: this.type, description: this.description, parameters: this.parameters, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDataCatalogPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnDataCatalog[_a] = { fqn: "aws-cdk-lib.aws_athena.CfnDataCatalog", version: "2.80.0" }, CfnDataCatalog.CFN_RESOURCE_TYPE_NAME = "AWS::Athena::DataCatalog", exports2.CfnDataCatalog = CfnDataCatalog;
    function CfnNamedQueryPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("database", cdk.requiredValidator)(properties.database)), errors.collect(cdk.propertyValidator("database", cdk.validateString)(properties.database)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("queryString", cdk.requiredValidator)(properties.queryString)), errors.collect(cdk.propertyValidator("queryString", cdk.validateString)(properties.queryString)), errors.collect(cdk.propertyValidator("workGroup", cdk.validateString)(properties.workGroup)), errors.wrap('supplied properties not correct for "CfnNamedQueryProps"');
    }
    function cfnNamedQueryPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNamedQueryPropsValidator(properties).assertSuccess(), { Database: cdk.stringToCloudFormation(properties.database), QueryString: cdk.stringToCloudFormation(properties.queryString), Description: cdk.stringToCloudFormation(properties.description), Name: cdk.stringToCloudFormation(properties.name), WorkGroup: cdk.stringToCloudFormation(properties.workGroup) }) : properties;
    }
    function CfnNamedQueryPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("database", "Database", cfn_parse.FromCloudFormation.getString(properties.Database)), ret.addPropertyResult("queryString", "QueryString", cfn_parse.FromCloudFormation.getString(properties.QueryString)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("workGroup", "WorkGroup", properties.WorkGroup != null ? cfn_parse.FromCloudFormation.getString(properties.WorkGroup) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnNamedQuery = class _CfnNamedQuery extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnNamedQueryPropsFromCloudFormation(resourceProperties), ret = new _CfnNamedQuery(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnNamedQuery.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_athena_CfnNamedQueryProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnNamedQuery), error;
        }
        cdk.requireProperty(props, "database", this), cdk.requireProperty(props, "queryString", this), this.attrNamedQueryId = cdk.Token.asString(this.getAtt("NamedQueryId", cdk.ResolutionTypeHint.STRING)), this.database = props.database, this.queryString = props.queryString, this.description = props.description, this.name = props.name, this.workGroup = props.workGroup;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnNamedQuery.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { database: this.database, queryString: this.queryString, description: this.description, name: this.name, workGroup: this.workGroup };
      }
      renderProperties(props) {
        return cfnNamedQueryPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnNamedQuery[_b] = { fqn: "aws-cdk-lib.aws_athena.CfnNamedQuery", version: "2.80.0" }, CfnNamedQuery.CFN_RESOURCE_TYPE_NAME = "AWS::Athena::NamedQuery", exports2.CfnNamedQuery = CfnNamedQuery;
    function CfnPreparedStatementPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("queryStatement", cdk.requiredValidator)(properties.queryStatement)), errors.collect(cdk.propertyValidator("queryStatement", cdk.validateString)(properties.queryStatement)), errors.collect(cdk.propertyValidator("statementName", cdk.requiredValidator)(properties.statementName)), errors.collect(cdk.propertyValidator("statementName", cdk.validateString)(properties.statementName)), errors.collect(cdk.propertyValidator("workGroup", cdk.requiredValidator)(properties.workGroup)), errors.collect(cdk.propertyValidator("workGroup", cdk.validateString)(properties.workGroup)), errors.wrap('supplied properties not correct for "CfnPreparedStatementProps"');
    }
    function cfnPreparedStatementPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPreparedStatementPropsValidator(properties).assertSuccess(), { QueryStatement: cdk.stringToCloudFormation(properties.queryStatement), StatementName: cdk.stringToCloudFormation(properties.statementName), WorkGroup: cdk.stringToCloudFormation(properties.workGroup), Description: cdk.stringToCloudFormation(properties.description) }) : properties;
    }
    function CfnPreparedStatementPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("queryStatement", "QueryStatement", cfn_parse.FromCloudFormation.getString(properties.QueryStatement)), ret.addPropertyResult("statementName", "StatementName", cfn_parse.FromCloudFormation.getString(properties.StatementName)), ret.addPropertyResult("workGroup", "WorkGroup", cfn_parse.FromCloudFormation.getString(properties.WorkGroup)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPreparedStatement = class _CfnPreparedStatement extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPreparedStatementPropsFromCloudFormation(resourceProperties), ret = new _CfnPreparedStatement(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPreparedStatement.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_athena_CfnPreparedStatementProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPreparedStatement), error;
        }
        cdk.requireProperty(props, "queryStatement", this), cdk.requireProperty(props, "statementName", this), cdk.requireProperty(props, "workGroup", this), this.queryStatement = props.queryStatement, this.statementName = props.statementName, this.workGroup = props.workGroup, this.description = props.description;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPreparedStatement.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { queryStatement: this.queryStatement, statementName: this.statementName, workGroup: this.workGroup, description: this.description };
      }
      renderProperties(props) {
        return cfnPreparedStatementPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnPreparedStatement[_c] = { fqn: "aws-cdk-lib.aws_athena.CfnPreparedStatement", version: "2.80.0" }, CfnPreparedStatement.CFN_RESOURCE_TYPE_NAME = "AWS::Athena::PreparedStatement", exports2.CfnPreparedStatement = CfnPreparedStatement;
    function CfnWorkGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("recursiveDeleteOption", cdk.validateBoolean)(properties.recursiveDeleteOption)), errors.collect(cdk.propertyValidator("state", cdk.validateString)(properties.state)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("workGroupConfiguration", CfnWorkGroup_WorkGroupConfigurationPropertyValidator)(properties.workGroupConfiguration)), errors.wrap('supplied properties not correct for "CfnWorkGroupProps"');
    }
    function cfnWorkGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkGroupPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), RecursiveDeleteOption: cdk.booleanToCloudFormation(properties.recursiveDeleteOption), State: cdk.stringToCloudFormation(properties.state), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), WorkGroupConfiguration: cfnWorkGroupWorkGroupConfigurationPropertyToCloudFormation(properties.workGroupConfiguration) }) : properties;
    }
    function CfnWorkGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("recursiveDeleteOption", "RecursiveDeleteOption", properties.RecursiveDeleteOption != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RecursiveDeleteOption) : void 0), ret.addPropertyResult("state", "State", properties.State != null ? cfn_parse.FromCloudFormation.getString(properties.State) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("workGroupConfiguration", "WorkGroupConfiguration", properties.WorkGroupConfiguration != null ? CfnWorkGroupWorkGroupConfigurationPropertyFromCloudFormation(properties.WorkGroupConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnWorkGroup = class _CfnWorkGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnWorkGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnWorkGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnWorkGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_athena_CfnWorkGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnWorkGroup), error;
        }
        cdk.requireProperty(props, "name", this), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrWorkGroupConfigurationEngineVersionEffectiveEngineVersion = cdk.Token.asString(this.getAtt("WorkGroupConfiguration.EngineVersion.EffectiveEngineVersion", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.description = props.description, this.recursiveDeleteOption = props.recursiveDeleteOption, this.state = props.state, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Athena::WorkGroup", props.tags, { tagPropertyName: "tags" }), this.workGroupConfiguration = props.workGroupConfiguration;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnWorkGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, description: this.description, recursiveDeleteOption: this.recursiveDeleteOption, state: this.state, tags: this.tags.renderTags(), workGroupConfiguration: this.workGroupConfiguration };
      }
      renderProperties(props) {
        return cfnWorkGroupPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnWorkGroup[_d] = { fqn: "aws-cdk-lib.aws_athena.CfnWorkGroup", version: "2.80.0" }, CfnWorkGroup.CFN_RESOURCE_TYPE_NAME = "AWS::Athena::WorkGroup", exports2.CfnWorkGroup = CfnWorkGroup;
    function CfnWorkGroup_AclConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3AclOption", cdk.requiredValidator)(properties.s3AclOption)), errors.collect(cdk.propertyValidator("s3AclOption", cdk.validateString)(properties.s3AclOption)), errors.wrap('supplied properties not correct for "AclConfigurationProperty"');
    }
    function cfnWorkGroupAclConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkGroup_AclConfigurationPropertyValidator(properties).assertSuccess(), { S3AclOption: cdk.stringToCloudFormation(properties.s3AclOption) }) : properties;
    }
    function CfnWorkGroupAclConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3AclOption", "S3AclOption", cfn_parse.FromCloudFormation.getString(properties.S3AclOption)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWorkGroup_CustomerContentEncryptionConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kmsKey", cdk.requiredValidator)(properties.kmsKey)), errors.collect(cdk.propertyValidator("kmsKey", cdk.validateString)(properties.kmsKey)), errors.wrap('supplied properties not correct for "CustomerContentEncryptionConfigurationProperty"');
    }
    function cfnWorkGroupCustomerContentEncryptionConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkGroup_CustomerContentEncryptionConfigurationPropertyValidator(properties).assertSuccess(), { KmsKey: cdk.stringToCloudFormation(properties.kmsKey) }) : properties;
    }
    function CfnWorkGroupCustomerContentEncryptionConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsKey", "KmsKey", cfn_parse.FromCloudFormation.getString(properties.KmsKey)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWorkGroup_EncryptionConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("encryptionOption", cdk.requiredValidator)(properties.encryptionOption)), errors.collect(cdk.propertyValidator("encryptionOption", cdk.validateString)(properties.encryptionOption)), errors.collect(cdk.propertyValidator("kmsKey", cdk.validateString)(properties.kmsKey)), errors.wrap('supplied properties not correct for "EncryptionConfigurationProperty"');
    }
    function cfnWorkGroupEncryptionConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkGroup_EncryptionConfigurationPropertyValidator(properties).assertSuccess(), { EncryptionOption: cdk.stringToCloudFormation(properties.encryptionOption), KmsKey: cdk.stringToCloudFormation(properties.kmsKey) }) : properties;
    }
    function CfnWorkGroupEncryptionConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("encryptionOption", "EncryptionOption", cfn_parse.FromCloudFormation.getString(properties.EncryptionOption)), ret.addPropertyResult("kmsKey", "KmsKey", properties.KmsKey != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKey) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWorkGroup_EngineVersionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("effectiveEngineVersion", cdk.validateString)(properties.effectiveEngineVersion)), errors.collect(cdk.propertyValidator("selectedEngineVersion", cdk.validateString)(properties.selectedEngineVersion)), errors.wrap('supplied properties not correct for "EngineVersionProperty"');
    }
    function cfnWorkGroupEngineVersionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkGroup_EngineVersionPropertyValidator(properties).assertSuccess(), { EffectiveEngineVersion: cdk.stringToCloudFormation(properties.effectiveEngineVersion), SelectedEngineVersion: cdk.stringToCloudFormation(properties.selectedEngineVersion) }) : properties;
    }
    function CfnWorkGroupEngineVersionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("effectiveEngineVersion", "EffectiveEngineVersion", properties.EffectiveEngineVersion != null ? cfn_parse.FromCloudFormation.getString(properties.EffectiveEngineVersion) : void 0), ret.addPropertyResult("selectedEngineVersion", "SelectedEngineVersion", properties.SelectedEngineVersion != null ? cfn_parse.FromCloudFormation.getString(properties.SelectedEngineVersion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWorkGroup_ResultConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aclConfiguration", CfnWorkGroup_AclConfigurationPropertyValidator)(properties.aclConfiguration)), errors.collect(cdk.propertyValidator("encryptionConfiguration", CfnWorkGroup_EncryptionConfigurationPropertyValidator)(properties.encryptionConfiguration)), errors.collect(cdk.propertyValidator("expectedBucketOwner", cdk.validateString)(properties.expectedBucketOwner)), errors.collect(cdk.propertyValidator("outputLocation", cdk.validateString)(properties.outputLocation)), errors.wrap('supplied properties not correct for "ResultConfigurationProperty"');
    }
    function cfnWorkGroupResultConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkGroup_ResultConfigurationPropertyValidator(properties).assertSuccess(), { AclConfiguration: cfnWorkGroupAclConfigurationPropertyToCloudFormation(properties.aclConfiguration), EncryptionConfiguration: cfnWorkGroupEncryptionConfigurationPropertyToCloudFormation(properties.encryptionConfiguration), ExpectedBucketOwner: cdk.stringToCloudFormation(properties.expectedBucketOwner), OutputLocation: cdk.stringToCloudFormation(properties.outputLocation) }) : properties;
    }
    function CfnWorkGroupResultConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aclConfiguration", "AclConfiguration", properties.AclConfiguration != null ? CfnWorkGroupAclConfigurationPropertyFromCloudFormation(properties.AclConfiguration) : void 0), ret.addPropertyResult("encryptionConfiguration", "EncryptionConfiguration", properties.EncryptionConfiguration != null ? CfnWorkGroupEncryptionConfigurationPropertyFromCloudFormation(properties.EncryptionConfiguration) : void 0), ret.addPropertyResult("expectedBucketOwner", "ExpectedBucketOwner", properties.ExpectedBucketOwner != null ? cfn_parse.FromCloudFormation.getString(properties.ExpectedBucketOwner) : void 0), ret.addPropertyResult("outputLocation", "OutputLocation", properties.OutputLocation != null ? cfn_parse.FromCloudFormation.getString(properties.OutputLocation) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWorkGroup_WorkGroupConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("additionalConfiguration", cdk.validateString)(properties.additionalConfiguration)), errors.collect(cdk.propertyValidator("bytesScannedCutoffPerQuery", cdk.validateNumber)(properties.bytesScannedCutoffPerQuery)), errors.collect(cdk.propertyValidator("customerContentEncryptionConfiguration", CfnWorkGroup_CustomerContentEncryptionConfigurationPropertyValidator)(properties.customerContentEncryptionConfiguration)), errors.collect(cdk.propertyValidator("enforceWorkGroupConfiguration", cdk.validateBoolean)(properties.enforceWorkGroupConfiguration)), errors.collect(cdk.propertyValidator("engineVersion", CfnWorkGroup_EngineVersionPropertyValidator)(properties.engineVersion)), errors.collect(cdk.propertyValidator("executionRole", cdk.validateString)(properties.executionRole)), errors.collect(cdk.propertyValidator("publishCloudWatchMetricsEnabled", cdk.validateBoolean)(properties.publishCloudWatchMetricsEnabled)), errors.collect(cdk.propertyValidator("requesterPaysEnabled", cdk.validateBoolean)(properties.requesterPaysEnabled)), errors.collect(cdk.propertyValidator("resultConfiguration", CfnWorkGroup_ResultConfigurationPropertyValidator)(properties.resultConfiguration)), errors.wrap('supplied properties not correct for "WorkGroupConfigurationProperty"');
    }
    function cfnWorkGroupWorkGroupConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkGroup_WorkGroupConfigurationPropertyValidator(properties).assertSuccess(), { AdditionalConfiguration: cdk.stringToCloudFormation(properties.additionalConfiguration), BytesScannedCutoffPerQuery: cdk.numberToCloudFormation(properties.bytesScannedCutoffPerQuery), CustomerContentEncryptionConfiguration: cfnWorkGroupCustomerContentEncryptionConfigurationPropertyToCloudFormation(properties.customerContentEncryptionConfiguration), EnforceWorkGroupConfiguration: cdk.booleanToCloudFormation(properties.enforceWorkGroupConfiguration), EngineVersion: cfnWorkGroupEngineVersionPropertyToCloudFormation(properties.engineVersion), ExecutionRole: cdk.stringToCloudFormation(properties.executionRole), PublishCloudWatchMetricsEnabled: cdk.booleanToCloudFormation(properties.publishCloudWatchMetricsEnabled), RequesterPaysEnabled: cdk.booleanToCloudFormation(properties.requesterPaysEnabled), ResultConfiguration: cfnWorkGroupResultConfigurationPropertyToCloudFormation(properties.resultConfiguration) }) : properties;
    }
    function CfnWorkGroupWorkGroupConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("additionalConfiguration", "AdditionalConfiguration", properties.AdditionalConfiguration != null ? cfn_parse.FromCloudFormation.getString(properties.AdditionalConfiguration) : void 0), ret.addPropertyResult("bytesScannedCutoffPerQuery", "BytesScannedCutoffPerQuery", properties.BytesScannedCutoffPerQuery != null ? cfn_parse.FromCloudFormation.getNumber(properties.BytesScannedCutoffPerQuery) : void 0), ret.addPropertyResult("customerContentEncryptionConfiguration", "CustomerContentEncryptionConfiguration", properties.CustomerContentEncryptionConfiguration != null ? CfnWorkGroupCustomerContentEncryptionConfigurationPropertyFromCloudFormation(properties.CustomerContentEncryptionConfiguration) : void 0), ret.addPropertyResult("enforceWorkGroupConfiguration", "EnforceWorkGroupConfiguration", properties.EnforceWorkGroupConfiguration != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnforceWorkGroupConfiguration) : void 0), ret.addPropertyResult("engineVersion", "EngineVersion", properties.EngineVersion != null ? CfnWorkGroupEngineVersionPropertyFromCloudFormation(properties.EngineVersion) : void 0), ret.addPropertyResult("executionRole", "ExecutionRole", properties.ExecutionRole != null ? cfn_parse.FromCloudFormation.getString(properties.ExecutionRole) : void 0), ret.addPropertyResult("publishCloudWatchMetricsEnabled", "PublishCloudWatchMetricsEnabled", properties.PublishCloudWatchMetricsEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.PublishCloudWatchMetricsEnabled) : void 0), ret.addPropertyResult("requesterPaysEnabled", "RequesterPaysEnabled", properties.RequesterPaysEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RequesterPaysEnabled) : void 0), ret.addPropertyResult("resultConfiguration", "ResultConfiguration", properties.ResultConfiguration != null ? CfnWorkGroupResultConfigurationPropertyFromCloudFormation(properties.ResultConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-athena/lib/index.js
var require_lib50 = __commonJS({
  "node_modules/aws-cdk-lib/aws-athena/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_athena_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-athena/index.js
var require_aws_athena = __commonJS({
  "node_modules/aws-cdk-lib/aws-athena/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib50(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-auditmanager/lib/auditmanager.generated.js
var require_auditmanager_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-auditmanager/lib/auditmanager.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnAssessment = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAssessmentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("assessmentReportsDestination", CfnAssessment_AssessmentReportsDestinationPropertyValidator)(properties.assessmentReportsDestination)), errors.collect(cdk.propertyValidator("awsAccount", CfnAssessment_AWSAccountPropertyValidator)(properties.awsAccount)), errors.collect(cdk.propertyValidator("delegations", cdk.listValidator(CfnAssessment_DelegationPropertyValidator))(properties.delegations)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("frameworkId", cdk.validateString)(properties.frameworkId)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("roles", cdk.listValidator(CfnAssessment_RolePropertyValidator))(properties.roles)), errors.collect(cdk.propertyValidator("scope", CfnAssessment_ScopePropertyValidator)(properties.scope)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnAssessmentProps"');
    }
    function cfnAssessmentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssessmentPropsValidator(properties).assertSuccess(), { AssessmentReportsDestination: cfnAssessmentAssessmentReportsDestinationPropertyToCloudFormation(properties.assessmentReportsDestination), AwsAccount: cfnAssessmentAWSAccountPropertyToCloudFormation(properties.awsAccount), Delegations: cdk.listMapper(cfnAssessmentDelegationPropertyToCloudFormation)(properties.delegations), Description: cdk.stringToCloudFormation(properties.description), FrameworkId: cdk.stringToCloudFormation(properties.frameworkId), Name: cdk.stringToCloudFormation(properties.name), Roles: cdk.listMapper(cfnAssessmentRolePropertyToCloudFormation)(properties.roles), Scope: cfnAssessmentScopePropertyToCloudFormation(properties.scope), Status: cdk.stringToCloudFormation(properties.status), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnAssessmentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("assessmentReportsDestination", "AssessmentReportsDestination", properties.AssessmentReportsDestination != null ? CfnAssessmentAssessmentReportsDestinationPropertyFromCloudFormation(properties.AssessmentReportsDestination) : void 0), ret.addPropertyResult("awsAccount", "AwsAccount", properties.AwsAccount != null ? CfnAssessmentAWSAccountPropertyFromCloudFormation(properties.AwsAccount) : void 0), ret.addPropertyResult("delegations", "Delegations", properties.Delegations != null ? cfn_parse.FromCloudFormation.getArray(CfnAssessmentDelegationPropertyFromCloudFormation)(properties.Delegations) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("frameworkId", "FrameworkId", properties.FrameworkId != null ? cfn_parse.FromCloudFormation.getString(properties.FrameworkId) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("roles", "Roles", properties.Roles != null ? cfn_parse.FromCloudFormation.getArray(CfnAssessmentRolePropertyFromCloudFormation)(properties.Roles) : void 0), ret.addPropertyResult("scope", "Scope", properties.Scope != null ? CfnAssessmentScopePropertyFromCloudFormation(properties.Scope) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAssessment = class _CfnAssessment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAssessmentPropsFromCloudFormation(resourceProperties), ret = new _CfnAssessment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnAssessment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_auditmanager_CfnAssessmentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAssessment), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrAssessmentId = cdk.Token.asString(this.getAtt("AssessmentId", cdk.ResolutionTypeHint.STRING)), this.attrCreationTime = this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING), this.assessmentReportsDestination = props.assessmentReportsDestination, this.awsAccount = props.awsAccount, this.delegations = props.delegations, this.description = props.description, this.frameworkId = props.frameworkId, this.name = props.name, this.roles = props.roles, this.scope = props.scope, this.status = props.status, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::AuditManager::Assessment", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAssessment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { assessmentReportsDestination: this.assessmentReportsDestination, awsAccount: this.awsAccount, delegations: this.delegations, description: this.description, frameworkId: this.frameworkId, name: this.name, roles: this.roles, scope: this.scope, status: this.status, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnAssessmentPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAssessment[_a] = { fqn: "aws-cdk-lib.aws_auditmanager.CfnAssessment", version: "2.80.0" }, CfnAssessment.CFN_RESOURCE_TYPE_NAME = "AWS::AuditManager::Assessment", exports2.CfnAssessment = CfnAssessment;
    function CfnAssessment_AWSAccountPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("emailAddress", cdk.validateString)(properties.emailAddress)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "AWSAccountProperty"');
    }
    function cfnAssessmentAWSAccountPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssessment_AWSAccountPropertyValidator(properties).assertSuccess(), { EmailAddress: cdk.stringToCloudFormation(properties.emailAddress), Id: cdk.stringToCloudFormation(properties.id), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnAssessmentAWSAccountPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("emailAddress", "EmailAddress", properties.EmailAddress != null ? cfn_parse.FromCloudFormation.getString(properties.EmailAddress) : void 0), ret.addPropertyResult("id", "Id", properties.Id != null ? cfn_parse.FromCloudFormation.getString(properties.Id) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAssessment_AWSServicePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("serviceName", cdk.validateString)(properties.serviceName)), errors.wrap('supplied properties not correct for "AWSServiceProperty"');
    }
    function cfnAssessmentAWSServicePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssessment_AWSServicePropertyValidator(properties).assertSuccess(), { ServiceName: cdk.stringToCloudFormation(properties.serviceName) }) : properties;
    }
    function CfnAssessmentAWSServicePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("serviceName", "ServiceName", properties.ServiceName != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAssessment_AssessmentReportsDestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destination", cdk.validateString)(properties.destination)), errors.collect(cdk.propertyValidator("destinationType", cdk.validateString)(properties.destinationType)), errors.wrap('supplied properties not correct for "AssessmentReportsDestinationProperty"');
    }
    function cfnAssessmentAssessmentReportsDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssessment_AssessmentReportsDestinationPropertyValidator(properties).assertSuccess(), { Destination: cdk.stringToCloudFormation(properties.destination), DestinationType: cdk.stringToCloudFormation(properties.destinationType) }) : properties;
    }
    function CfnAssessmentAssessmentReportsDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destination", "Destination", properties.Destination != null ? cfn_parse.FromCloudFormation.getString(properties.Destination) : void 0), ret.addPropertyResult("destinationType", "DestinationType", properties.DestinationType != null ? cfn_parse.FromCloudFormation.getString(properties.DestinationType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAssessment_DelegationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("assessmentId", cdk.validateString)(properties.assessmentId)), errors.collect(cdk.propertyValidator("assessmentName", cdk.validateString)(properties.assessmentName)), errors.collect(cdk.propertyValidator("comment", cdk.validateString)(properties.comment)), errors.collect(cdk.propertyValidator("controlSetId", cdk.validateString)(properties.controlSetId)), errors.collect(cdk.propertyValidator("createdBy", cdk.validateString)(properties.createdBy)), errors.collect(cdk.propertyValidator("creationTime", cdk.validateNumber)(properties.creationTime)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("lastUpdated", cdk.validateNumber)(properties.lastUpdated)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleType", cdk.validateString)(properties.roleType)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "DelegationProperty"');
    }
    function cfnAssessmentDelegationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssessment_DelegationPropertyValidator(properties).assertSuccess(), { AssessmentId: cdk.stringToCloudFormation(properties.assessmentId), AssessmentName: cdk.stringToCloudFormation(properties.assessmentName), Comment: cdk.stringToCloudFormation(properties.comment), ControlSetId: cdk.stringToCloudFormation(properties.controlSetId), CreatedBy: cdk.stringToCloudFormation(properties.createdBy), CreationTime: cdk.numberToCloudFormation(properties.creationTime), Id: cdk.stringToCloudFormation(properties.id), LastUpdated: cdk.numberToCloudFormation(properties.lastUpdated), RoleArn: cdk.stringToCloudFormation(properties.roleArn), RoleType: cdk.stringToCloudFormation(properties.roleType), Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnAssessmentDelegationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("assessmentId", "AssessmentId", properties.AssessmentId != null ? cfn_parse.FromCloudFormation.getString(properties.AssessmentId) : void 0), ret.addPropertyResult("assessmentName", "AssessmentName", properties.AssessmentName != null ? cfn_parse.FromCloudFormation.getString(properties.AssessmentName) : void 0), ret.addPropertyResult("comment", "Comment", properties.Comment != null ? cfn_parse.FromCloudFormation.getString(properties.Comment) : void 0), ret.addPropertyResult("controlSetId", "ControlSetId", properties.ControlSetId != null ? cfn_parse.FromCloudFormation.getString(properties.ControlSetId) : void 0), ret.addPropertyResult("createdBy", "CreatedBy", properties.CreatedBy != null ? cfn_parse.FromCloudFormation.getString(properties.CreatedBy) : void 0), ret.addPropertyResult("creationTime", "CreationTime", properties.CreationTime != null ? cfn_parse.FromCloudFormation.getNumber(properties.CreationTime) : void 0), ret.addPropertyResult("id", "Id", properties.Id != null ? cfn_parse.FromCloudFormation.getString(properties.Id) : void 0), ret.addPropertyResult("lastUpdated", "LastUpdated", properties.LastUpdated != null ? cfn_parse.FromCloudFormation.getNumber(properties.LastUpdated) : void 0), ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addPropertyResult("roleType", "RoleType", properties.RoleType != null ? cfn_parse.FromCloudFormation.getString(properties.RoleType) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAssessment_RolePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleType", cdk.validateString)(properties.roleType)), errors.wrap('supplied properties not correct for "RoleProperty"');
    }
    function cfnAssessmentRolePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssessment_RolePropertyValidator(properties).assertSuccess(), { RoleArn: cdk.stringToCloudFormation(properties.roleArn), RoleType: cdk.stringToCloudFormation(properties.roleType) }) : properties;
    }
    function CfnAssessmentRolePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addPropertyResult("roleType", "RoleType", properties.RoleType != null ? cfn_parse.FromCloudFormation.getString(properties.RoleType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAssessment_ScopePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("awsAccounts", cdk.listValidator(CfnAssessment_AWSAccountPropertyValidator))(properties.awsAccounts)), errors.collect(cdk.propertyValidator("awsServices", cdk.listValidator(CfnAssessment_AWSServicePropertyValidator))(properties.awsServices)), errors.wrap('supplied properties not correct for "ScopeProperty"');
    }
    function cfnAssessmentScopePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssessment_ScopePropertyValidator(properties).assertSuccess(), { AwsAccounts: cdk.listMapper(cfnAssessmentAWSAccountPropertyToCloudFormation)(properties.awsAccounts), AwsServices: cdk.listMapper(cfnAssessmentAWSServicePropertyToCloudFormation)(properties.awsServices) }) : properties;
    }
    function CfnAssessmentScopePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("awsAccounts", "AwsAccounts", properties.AwsAccounts != null ? cfn_parse.FromCloudFormation.getArray(CfnAssessmentAWSAccountPropertyFromCloudFormation)(properties.AwsAccounts) : void 0), ret.addPropertyResult("awsServices", "AwsServices", properties.AwsServices != null ? cfn_parse.FromCloudFormation.getArray(CfnAssessmentAWSServicePropertyFromCloudFormation)(properties.AwsServices) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-auditmanager/lib/index.js
var require_lib51 = __commonJS({
  "node_modules/aws-cdk-lib/aws-auditmanager/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_auditmanager_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-auditmanager/index.js
var require_aws_auditmanager = __commonJS({
  "node_modules/aws-cdk-lib/aws-auditmanager/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib51(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-autoscaling/lib/autoscaling.generated.js
var require_autoscaling_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-autoscaling/lib/autoscaling.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnWarmPool = exports2.CfnScheduledAction = exports2.CfnScalingPolicy = exports2.CfnLifecycleHook = exports2.CfnLaunchConfiguration = exports2.CfnAutoScalingGroup = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAutoScalingGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoScalingGroupName", cdk.validateString)(properties.autoScalingGroupName)), errors.collect(cdk.propertyValidator("availabilityZones", cdk.listValidator(cdk.validateString))(properties.availabilityZones)), errors.collect(cdk.propertyValidator("capacityRebalance", cdk.validateBoolean)(properties.capacityRebalance)), errors.collect(cdk.propertyValidator("context", cdk.validateString)(properties.context)), errors.collect(cdk.propertyValidator("cooldown", cdk.validateString)(properties.cooldown)), errors.collect(cdk.propertyValidator("defaultInstanceWarmup", cdk.validateNumber)(properties.defaultInstanceWarmup)), errors.collect(cdk.propertyValidator("desiredCapacity", cdk.validateString)(properties.desiredCapacity)), errors.collect(cdk.propertyValidator("desiredCapacityType", cdk.validateString)(properties.desiredCapacityType)), errors.collect(cdk.propertyValidator("healthCheckGracePeriod", cdk.validateNumber)(properties.healthCheckGracePeriod)), errors.collect(cdk.propertyValidator("healthCheckType", cdk.validateString)(properties.healthCheckType)), errors.collect(cdk.propertyValidator("instanceId", cdk.validateString)(properties.instanceId)), errors.collect(cdk.propertyValidator("launchConfigurationName", cdk.validateString)(properties.launchConfigurationName)), errors.collect(cdk.propertyValidator("launchTemplate", CfnAutoScalingGroup_LaunchTemplateSpecificationPropertyValidator)(properties.launchTemplate)), errors.collect(cdk.propertyValidator("lifecycleHookSpecificationList", cdk.listValidator(CfnAutoScalingGroup_LifecycleHookSpecificationPropertyValidator))(properties.lifecycleHookSpecificationList)), errors.collect(cdk.propertyValidator("loadBalancerNames", cdk.listValidator(cdk.validateString))(properties.loadBalancerNames)), errors.collect(cdk.propertyValidator("maxInstanceLifetime", cdk.validateNumber)(properties.maxInstanceLifetime)), errors.collect(cdk.propertyValidator("maxSize", cdk.requiredValidator)(properties.maxSize)), errors.collect(cdk.propertyValidator("maxSize", cdk.validateString)(properties.maxSize)), errors.collect(cdk.propertyValidator("metricsCollection", cdk.listValidator(CfnAutoScalingGroup_MetricsCollectionPropertyValidator))(properties.metricsCollection)), errors.collect(cdk.propertyValidator("minSize", cdk.requiredValidator)(properties.minSize)), errors.collect(cdk.propertyValidator("minSize", cdk.validateString)(properties.minSize)), errors.collect(cdk.propertyValidator("mixedInstancesPolicy", CfnAutoScalingGroup_MixedInstancesPolicyPropertyValidator)(properties.mixedInstancesPolicy)), errors.collect(cdk.propertyValidator("newInstancesProtectedFromScaleIn", cdk.validateBoolean)(properties.newInstancesProtectedFromScaleIn)), errors.collect(cdk.propertyValidator("notificationConfigurations", cdk.listValidator(CfnAutoScalingGroup_NotificationConfigurationPropertyValidator))(properties.notificationConfigurations)), errors.collect(cdk.propertyValidator("placementGroup", cdk.validateString)(properties.placementGroup)), errors.collect(cdk.propertyValidator("serviceLinkedRoleArn", cdk.validateString)(properties.serviceLinkedRoleArn)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(CfnAutoScalingGroup_TagPropertyPropertyValidator))(properties.tags)), errors.collect(cdk.propertyValidator("targetGroupArns", cdk.listValidator(cdk.validateString))(properties.targetGroupArns)), errors.collect(cdk.propertyValidator("terminationPolicies", cdk.listValidator(cdk.validateString))(properties.terminationPolicies)), errors.collect(cdk.propertyValidator("vpcZoneIdentifier", cdk.listValidator(cdk.validateString))(properties.vpcZoneIdentifier)), errors.wrap('supplied properties not correct for "CfnAutoScalingGroupProps"');
    }
    function cfnAutoScalingGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAutoScalingGroupPropsValidator(properties).assertSuccess(), { MaxSize: cdk.stringToCloudFormation(properties.maxSize), MinSize: cdk.stringToCloudFormation(properties.minSize), AutoScalingGroupName: cdk.stringToCloudFormation(properties.autoScalingGroupName), AvailabilityZones: cdk.listMapper(cdk.stringToCloudFormation)(properties.availabilityZones), CapacityRebalance: cdk.booleanToCloudFormation(properties.capacityRebalance), Context: cdk.stringToCloudFormation(properties.context), Cooldown: cdk.stringToCloudFormation(properties.cooldown), DefaultInstanceWarmup: cdk.numberToCloudFormation(properties.defaultInstanceWarmup), DesiredCapacity: cdk.stringToCloudFormation(properties.desiredCapacity), DesiredCapacityType: cdk.stringToCloudFormation(properties.desiredCapacityType), HealthCheckGracePeriod: cdk.numberToCloudFormation(properties.healthCheckGracePeriod), HealthCheckType: cdk.stringToCloudFormation(properties.healthCheckType), InstanceId: cdk.stringToCloudFormation(properties.instanceId), LaunchConfigurationName: cdk.stringToCloudFormation(properties.launchConfigurationName), LaunchTemplate: cfnAutoScalingGroupLaunchTemplateSpecificationPropertyToCloudFormation(properties.launchTemplate), LifecycleHookSpecificationList: cdk.listMapper(cfnAutoScalingGroupLifecycleHookSpecificationPropertyToCloudFormation)(properties.lifecycleHookSpecificationList), LoadBalancerNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.loadBalancerNames), MaxInstanceLifetime: cdk.numberToCloudFormation(properties.maxInstanceLifetime), MetricsCollection: cdk.listMapper(cfnAutoScalingGroupMetricsCollectionPropertyToCloudFormation)(properties.metricsCollection), MixedInstancesPolicy: cfnAutoScalingGroupMixedInstancesPolicyPropertyToCloudFormation(properties.mixedInstancesPolicy), NewInstancesProtectedFromScaleIn: cdk.booleanToCloudFormation(properties.newInstancesProtectedFromScaleIn), NotificationConfigurations: cdk.listMapper(cfnAutoScalingGroupNotificationConfigurationPropertyToCloudFormation)(properties.notificationConfigurations), PlacementGroup: cdk.stringToCloudFormation(properties.placementGroup), ServiceLinkedRoleARN: cdk.stringToCloudFormation(properties.serviceLinkedRoleArn), Tags: cdk.listMapper(cfnAutoScalingGroupTagPropertyPropertyToCloudFormation)(properties.tags), TargetGroupARNs: cdk.listMapper(cdk.stringToCloudFormation)(properties.targetGroupArns), TerminationPolicies: cdk.listMapper(cdk.stringToCloudFormation)(properties.terminationPolicies), VPCZoneIdentifier: cdk.listMapper(cdk.stringToCloudFormation)(properties.vpcZoneIdentifier) }) : properties;
    }
    function CfnAutoScalingGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxSize", "MaxSize", cfn_parse.FromCloudFormation.getString(properties.MaxSize)), ret.addPropertyResult("minSize", "MinSize", cfn_parse.FromCloudFormation.getString(properties.MinSize)), ret.addPropertyResult("autoScalingGroupName", "AutoScalingGroupName", properties.AutoScalingGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.AutoScalingGroupName) : void 0), ret.addPropertyResult("availabilityZones", "AvailabilityZones", properties.AvailabilityZones != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AvailabilityZones) : void 0), ret.addPropertyResult("capacityRebalance", "CapacityRebalance", properties.CapacityRebalance != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CapacityRebalance) : void 0), ret.addPropertyResult("context", "Context", properties.Context != null ? cfn_parse.FromCloudFormation.getString(properties.Context) : void 0), ret.addPropertyResult("cooldown", "Cooldown", properties.Cooldown != null ? cfn_parse.FromCloudFormation.getString(properties.Cooldown) : void 0), ret.addPropertyResult("defaultInstanceWarmup", "DefaultInstanceWarmup", properties.DefaultInstanceWarmup != null ? cfn_parse.FromCloudFormation.getNumber(properties.DefaultInstanceWarmup) : void 0), ret.addPropertyResult("desiredCapacity", "DesiredCapacity", properties.DesiredCapacity != null ? cfn_parse.FromCloudFormation.getString(properties.DesiredCapacity) : void 0), ret.addPropertyResult("desiredCapacityType", "DesiredCapacityType", properties.DesiredCapacityType != null ? cfn_parse.FromCloudFormation.getString(properties.DesiredCapacityType) : void 0), ret.addPropertyResult("healthCheckGracePeriod", "HealthCheckGracePeriod", properties.HealthCheckGracePeriod != null ? cfn_parse.FromCloudFormation.getNumber(properties.HealthCheckGracePeriod) : void 0), ret.addPropertyResult("healthCheckType", "HealthCheckType", properties.HealthCheckType != null ? cfn_parse.FromCloudFormation.getString(properties.HealthCheckType) : void 0), ret.addPropertyResult("instanceId", "InstanceId", properties.InstanceId != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceId) : void 0), ret.addPropertyResult("launchConfigurationName", "LaunchConfigurationName", properties.LaunchConfigurationName != null ? cfn_parse.FromCloudFormation.getString(properties.LaunchConfigurationName) : void 0), ret.addPropertyResult("launchTemplate", "LaunchTemplate", properties.LaunchTemplate != null ? CfnAutoScalingGroupLaunchTemplateSpecificationPropertyFromCloudFormation(properties.LaunchTemplate) : void 0), ret.addPropertyResult("lifecycleHookSpecificationList", "LifecycleHookSpecificationList", properties.LifecycleHookSpecificationList != null ? cfn_parse.FromCloudFormation.getArray(CfnAutoScalingGroupLifecycleHookSpecificationPropertyFromCloudFormation)(properties.LifecycleHookSpecificationList) : void 0), ret.addPropertyResult("loadBalancerNames", "LoadBalancerNames", properties.LoadBalancerNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.LoadBalancerNames) : void 0), ret.addPropertyResult("maxInstanceLifetime", "MaxInstanceLifetime", properties.MaxInstanceLifetime != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxInstanceLifetime) : void 0), ret.addPropertyResult("metricsCollection", "MetricsCollection", properties.MetricsCollection != null ? cfn_parse.FromCloudFormation.getArray(CfnAutoScalingGroupMetricsCollectionPropertyFromCloudFormation)(properties.MetricsCollection) : void 0), ret.addPropertyResult("mixedInstancesPolicy", "MixedInstancesPolicy", properties.MixedInstancesPolicy != null ? CfnAutoScalingGroupMixedInstancesPolicyPropertyFromCloudFormation(properties.MixedInstancesPolicy) : void 0), ret.addPropertyResult("newInstancesProtectedFromScaleIn", "NewInstancesProtectedFromScaleIn", properties.NewInstancesProtectedFromScaleIn != null ? cfn_parse.FromCloudFormation.getBoolean(properties.NewInstancesProtectedFromScaleIn) : void 0), ret.addPropertyResult("notificationConfigurations", "NotificationConfigurations", properties.NotificationConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnAutoScalingGroupNotificationConfigurationPropertyFromCloudFormation)(properties.NotificationConfigurations) : void 0), ret.addPropertyResult("placementGroup", "PlacementGroup", properties.PlacementGroup != null ? cfn_parse.FromCloudFormation.getString(properties.PlacementGroup) : void 0), ret.addPropertyResult("serviceLinkedRoleArn", "ServiceLinkedRoleARN", properties.ServiceLinkedRoleARN != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceLinkedRoleARN) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(CfnAutoScalingGroupTagPropertyPropertyFromCloudFormation)(properties.Tags) : void 0), ret.addPropertyResult("targetGroupArns", "TargetGroupARNs", properties.TargetGroupARNs != null ? cfn_parse.FromCloudFormation.getStringArray(properties.TargetGroupARNs) : void 0), ret.addPropertyResult("terminationPolicies", "TerminationPolicies", properties.TerminationPolicies != null ? cfn_parse.FromCloudFormation.getStringArray(properties.TerminationPolicies) : void 0), ret.addPropertyResult("vpcZoneIdentifier", "VPCZoneIdentifier", properties.VPCZoneIdentifier != null ? cfn_parse.FromCloudFormation.getStringArray(properties.VPCZoneIdentifier) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAutoScalingGroup = class _CfnAutoScalingGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAutoScalingGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnAutoScalingGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAutoScalingGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_CfnAutoScalingGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAutoScalingGroup), error;
        }
        cdk.requireProperty(props, "maxSize", this), cdk.requireProperty(props, "minSize", this), this.maxSize = props.maxSize, this.minSize = props.minSize, this.autoScalingGroupName = props.autoScalingGroupName, this.availabilityZones = props.availabilityZones, this.capacityRebalance = props.capacityRebalance, this.context = props.context, this.cooldown = props.cooldown, this.defaultInstanceWarmup = props.defaultInstanceWarmup, this.desiredCapacity = props.desiredCapacity, this.desiredCapacityType = props.desiredCapacityType, this.healthCheckGracePeriod = props.healthCheckGracePeriod, this.healthCheckType = props.healthCheckType, this.instanceId = props.instanceId, this.launchConfigurationName = props.launchConfigurationName, this.launchTemplate = props.launchTemplate, this.lifecycleHookSpecificationList = props.lifecycleHookSpecificationList, this.loadBalancerNames = props.loadBalancerNames, this.maxInstanceLifetime = props.maxInstanceLifetime, this.metricsCollection = props.metricsCollection, this.mixedInstancesPolicy = props.mixedInstancesPolicy, this.newInstancesProtectedFromScaleIn = props.newInstancesProtectedFromScaleIn, this.notificationConfigurations = props.notificationConfigurations, this.placementGroup = props.placementGroup, this.serviceLinkedRoleArn = props.serviceLinkedRoleArn, this.tags = new cdk.TagManager(cdk.TagType.AUTOSCALING_GROUP, "AWS::AutoScaling::AutoScalingGroup", props.tags, { tagPropertyName: "tags" }), this.targetGroupArns = props.targetGroupArns, this.terminationPolicies = props.terminationPolicies, this.vpcZoneIdentifier = props.vpcZoneIdentifier;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAutoScalingGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { maxSize: this.maxSize, minSize: this.minSize, autoScalingGroupName: this.autoScalingGroupName, availabilityZones: this.availabilityZones, capacityRebalance: this.capacityRebalance, context: this.context, cooldown: this.cooldown, defaultInstanceWarmup: this.defaultInstanceWarmup, desiredCapacity: this.desiredCapacity, desiredCapacityType: this.desiredCapacityType, healthCheckGracePeriod: this.healthCheckGracePeriod, healthCheckType: this.healthCheckType, instanceId: this.instanceId, launchConfigurationName: this.launchConfigurationName, launchTemplate: this.launchTemplate, lifecycleHookSpecificationList: this.lifecycleHookSpecificationList, loadBalancerNames: this.loadBalancerNames, maxInstanceLifetime: this.maxInstanceLifetime, metricsCollection: this.metricsCollection, mixedInstancesPolicy: this.mixedInstancesPolicy, newInstancesProtectedFromScaleIn: this.newInstancesProtectedFromScaleIn, notificationConfigurations: this.notificationConfigurations, placementGroup: this.placementGroup, serviceLinkedRoleArn: this.serviceLinkedRoleArn, tags: this.tags.renderTags(), targetGroupArns: this.targetGroupArns, terminationPolicies: this.terminationPolicies, vpcZoneIdentifier: this.vpcZoneIdentifier };
      }
      renderProperties(props) {
        return cfnAutoScalingGroupPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAutoScalingGroup[_a] = { fqn: "aws-cdk-lib.aws_autoscaling.CfnAutoScalingGroup", version: "2.80.0" }, CfnAutoScalingGroup.CFN_RESOURCE_TYPE_NAME = "AWS::AutoScaling::AutoScalingGroup", exports2.CfnAutoScalingGroup = CfnAutoScalingGroup;
    function CfnAutoScalingGroup_AcceleratorCountRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "AcceleratorCountRequestProperty"');
    }
    function cfnAutoScalingGroupAcceleratorCountRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAutoScalingGroup_AcceleratorCountRequestPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnAutoScalingGroupAcceleratorCountRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAutoScalingGroup_AcceleratorTotalMemoryMiBRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "AcceleratorTotalMemoryMiBRequestProperty"');
    }
    function cfnAutoScalingGroupAcceleratorTotalMemoryMiBRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAutoScalingGroup_AcceleratorTotalMemoryMiBRequestPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnAutoScalingGroupAcceleratorTotalMemoryMiBRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAutoScalingGroup_BaselineEbsBandwidthMbpsRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "BaselineEbsBandwidthMbpsRequestProperty"');
    }
    function cfnAutoScalingGroupBaselineEbsBandwidthMbpsRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAutoScalingGroup_BaselineEbsBandwidthMbpsRequestPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnAutoScalingGroupBaselineEbsBandwidthMbpsRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAutoScalingGroup_InstanceRequirementsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acceleratorCount", CfnAutoScalingGroup_AcceleratorCountRequestPropertyValidator)(properties.acceleratorCount)), errors.collect(cdk.propertyValidator("acceleratorManufacturers", cdk.listValidator(cdk.validateString))(properties.acceleratorManufacturers)), errors.collect(cdk.propertyValidator("acceleratorNames", cdk.listValidator(cdk.validateString))(properties.acceleratorNames)), errors.collect(cdk.propertyValidator("acceleratorTotalMemoryMiB", CfnAutoScalingGroup_AcceleratorTotalMemoryMiBRequestPropertyValidator)(properties.acceleratorTotalMemoryMiB)), errors.collect(cdk.propertyValidator("acceleratorTypes", cdk.listValidator(cdk.validateString))(properties.acceleratorTypes)), errors.collect(cdk.propertyValidator("allowedInstanceTypes", cdk.listValidator(cdk.validateString))(properties.allowedInstanceTypes)), errors.collect(cdk.propertyValidator("bareMetal", cdk.validateString)(properties.bareMetal)), errors.collect(cdk.propertyValidator("baselineEbsBandwidthMbps", CfnAutoScalingGroup_BaselineEbsBandwidthMbpsRequestPropertyValidator)(properties.baselineEbsBandwidthMbps)), errors.collect(cdk.propertyValidator("burstablePerformance", cdk.validateString)(properties.burstablePerformance)), errors.collect(cdk.propertyValidator("cpuManufacturers", cdk.listValidator(cdk.validateString))(properties.cpuManufacturers)), errors.collect(cdk.propertyValidator("excludedInstanceTypes", cdk.listValidator(cdk.validateString))(properties.excludedInstanceTypes)), errors.collect(cdk.propertyValidator("instanceGenerations", cdk.listValidator(cdk.validateString))(properties.instanceGenerations)), errors.collect(cdk.propertyValidator("localStorage", cdk.validateString)(properties.localStorage)), errors.collect(cdk.propertyValidator("localStorageTypes", cdk.listValidator(cdk.validateString))(properties.localStorageTypes)), errors.collect(cdk.propertyValidator("memoryGiBPerVCpu", CfnAutoScalingGroup_MemoryGiBPerVCpuRequestPropertyValidator)(properties.memoryGiBPerVCpu)), errors.collect(cdk.propertyValidator("memoryMiB", CfnAutoScalingGroup_MemoryMiBRequestPropertyValidator)(properties.memoryMiB)), errors.collect(cdk.propertyValidator("networkBandwidthGbps", CfnAutoScalingGroup_NetworkBandwidthGbpsRequestPropertyValidator)(properties.networkBandwidthGbps)), errors.collect(cdk.propertyValidator("networkInterfaceCount", CfnAutoScalingGroup_NetworkInterfaceCountRequestPropertyValidator)(properties.networkInterfaceCount)), errors.collect(cdk.propertyValidator("onDemandMaxPricePercentageOverLowestPrice", cdk.validateNumber)(properties.onDemandMaxPricePercentageOverLowestPrice)), errors.collect(cdk.propertyValidator("requireHibernateSupport", cdk.validateBoolean)(properties.requireHibernateSupport)), errors.collect(cdk.propertyValidator("spotMaxPricePercentageOverLowestPrice", cdk.validateNumber)(properties.spotMaxPricePercentageOverLowestPrice)), errors.collect(cdk.propertyValidator("totalLocalStorageGb", CfnAutoScalingGroup_TotalLocalStorageGBRequestPropertyValidator)(properties.totalLocalStorageGb)), errors.collect(cdk.propertyValidator("vCpuCount", CfnAutoScalingGroup_VCpuCountRequestPropertyValidator)(properties.vCpuCount)), errors.wrap('supplied properties not correct for "InstanceRequirementsProperty"');
    }
    function cfnAutoScalingGroupInstanceRequirementsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAutoScalingGroup_InstanceRequirementsPropertyValidator(properties).assertSuccess(), { AcceleratorCount: cfnAutoScalingGroupAcceleratorCountRequestPropertyToCloudFormation(properties.acceleratorCount), AcceleratorManufacturers: cdk.listMapper(cdk.stringToCloudFormation)(properties.acceleratorManufacturers), AcceleratorNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.acceleratorNames), AcceleratorTotalMemoryMiB: cfnAutoScalingGroupAcceleratorTotalMemoryMiBRequestPropertyToCloudFormation(properties.acceleratorTotalMemoryMiB), AcceleratorTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.acceleratorTypes), AllowedInstanceTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowedInstanceTypes), BareMetal: cdk.stringToCloudFormation(properties.bareMetal), BaselineEbsBandwidthMbps: cfnAutoScalingGroupBaselineEbsBandwidthMbpsRequestPropertyToCloudFormation(properties.baselineEbsBandwidthMbps), BurstablePerformance: cdk.stringToCloudFormation(properties.burstablePerformance), CpuManufacturers: cdk.listMapper(cdk.stringToCloudFormation)(properties.cpuManufacturers), ExcludedInstanceTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.excludedInstanceTypes), InstanceGenerations: cdk.listMapper(cdk.stringToCloudFormation)(properties.instanceGenerations), LocalStorage: cdk.stringToCloudFormation(properties.localStorage), LocalStorageTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.localStorageTypes), MemoryGiBPerVCpu: cfnAutoScalingGroupMemoryGiBPerVCpuRequestPropertyToCloudFormation(properties.memoryGiBPerVCpu), MemoryMiB: cfnAutoScalingGroupMemoryMiBRequestPropertyToCloudFormation(properties.memoryMiB), NetworkBandwidthGbps: cfnAutoScalingGroupNetworkBandwidthGbpsRequestPropertyToCloudFormation(properties.networkBandwidthGbps), NetworkInterfaceCount: cfnAutoScalingGroupNetworkInterfaceCountRequestPropertyToCloudFormation(properties.networkInterfaceCount), OnDemandMaxPricePercentageOverLowestPrice: cdk.numberToCloudFormation(properties.onDemandMaxPricePercentageOverLowestPrice), RequireHibernateSupport: cdk.booleanToCloudFormation(properties.requireHibernateSupport), SpotMaxPricePercentageOverLowestPrice: cdk.numberToCloudFormation(properties.spotMaxPricePercentageOverLowestPrice), TotalLocalStorageGB: cfnAutoScalingGroupTotalLocalStorageGBRequestPropertyToCloudFormation(properties.totalLocalStorageGb), VCpuCount: cfnAutoScalingGroupVCpuCountRequestPropertyToCloudFormation(properties.vCpuCount) }) : properties;
    }
    function CfnAutoScalingGroupInstanceRequirementsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("acceleratorCount", "AcceleratorCount", properties.AcceleratorCount != null ? CfnAutoScalingGroupAcceleratorCountRequestPropertyFromCloudFormation(properties.AcceleratorCount) : void 0), ret.addPropertyResult("acceleratorManufacturers", "AcceleratorManufacturers", properties.AcceleratorManufacturers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AcceleratorManufacturers) : void 0), ret.addPropertyResult("acceleratorNames", "AcceleratorNames", properties.AcceleratorNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AcceleratorNames) : void 0), ret.addPropertyResult("acceleratorTotalMemoryMiB", "AcceleratorTotalMemoryMiB", properties.AcceleratorTotalMemoryMiB != null ? CfnAutoScalingGroupAcceleratorTotalMemoryMiBRequestPropertyFromCloudFormation(properties.AcceleratorTotalMemoryMiB) : void 0), ret.addPropertyResult("acceleratorTypes", "AcceleratorTypes", properties.AcceleratorTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AcceleratorTypes) : void 0), ret.addPropertyResult("allowedInstanceTypes", "AllowedInstanceTypes", properties.AllowedInstanceTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AllowedInstanceTypes) : void 0), ret.addPropertyResult("bareMetal", "BareMetal", properties.BareMetal != null ? cfn_parse.FromCloudFormation.getString(properties.BareMetal) : void 0), ret.addPropertyResult("baselineEbsBandwidthMbps", "BaselineEbsBandwidthMbps", properties.BaselineEbsBandwidthMbps != null ? CfnAutoScalingGroupBaselineEbsBandwidthMbpsRequestPropertyFromCloudFormation(properties.BaselineEbsBandwidthMbps) : void 0), ret.addPropertyResult("burstablePerformance", "BurstablePerformance", properties.BurstablePerformance != null ? cfn_parse.FromCloudFormation.getString(properties.BurstablePerformance) : void 0), ret.addPropertyResult("cpuManufacturers", "CpuManufacturers", properties.CpuManufacturers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CpuManufacturers) : void 0), ret.addPropertyResult("excludedInstanceTypes", "ExcludedInstanceTypes", properties.ExcludedInstanceTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExcludedInstanceTypes) : void 0), ret.addPropertyResult("instanceGenerations", "InstanceGenerations", properties.InstanceGenerations != null ? cfn_parse.FromCloudFormation.getStringArray(properties.InstanceGenerations) : void 0), ret.addPropertyResult("localStorage", "LocalStorage", properties.LocalStorage != null ? cfn_parse.FromCloudFormation.getString(properties.LocalStorage) : void 0), ret.addPropertyResult("localStorageTypes", "LocalStorageTypes", properties.LocalStorageTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.LocalStorageTypes) : void 0), ret.addPropertyResult("memoryGiBPerVCpu", "MemoryGiBPerVCpu", properties.MemoryGiBPerVCpu != null ? CfnAutoScalingGroupMemoryGiBPerVCpuRequestPropertyFromCloudFormation(properties.MemoryGiBPerVCpu) : void 0), ret.addPropertyResult("memoryMiB", "MemoryMiB", properties.MemoryMiB != null ? CfnAutoScalingGroupMemoryMiBRequestPropertyFromCloudFormation(properties.MemoryMiB) : void 0), ret.addPropertyResult("networkBandwidthGbps", "NetworkBandwidthGbps", properties.NetworkBandwidthGbps != null ? CfnAutoScalingGroupNetworkBandwidthGbpsRequestPropertyFromCloudFormation(properties.NetworkBandwidthGbps) : void 0), ret.addPropertyResult("networkInterfaceCount", "NetworkInterfaceCount", properties.NetworkInterfaceCount != null ? CfnAutoScalingGroupNetworkInterfaceCountRequestPropertyFromCloudFormation(properties.NetworkInterfaceCount) : void 0), ret.addPropertyResult("onDemandMaxPricePercentageOverLowestPrice", "OnDemandMaxPricePercentageOverLowestPrice", properties.OnDemandMaxPricePercentageOverLowestPrice != null ? cfn_parse.FromCloudFormation.getNumber(properties.OnDemandMaxPricePercentageOverLowestPrice) : void 0), ret.addPropertyResult("requireHibernateSupport", "RequireHibernateSupport", properties.RequireHibernateSupport != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RequireHibernateSupport) : void 0), ret.addPropertyResult("spotMaxPricePercentageOverLowestPrice", "SpotMaxPricePercentageOverLowestPrice", properties.SpotMaxPricePercentageOverLowestPrice != null ? cfn_parse.FromCloudFormation.getNumber(properties.SpotMaxPricePercentageOverLowestPrice) : void 0), ret.addPropertyResult("totalLocalStorageGb", "TotalLocalStorageGB", properties.TotalLocalStorageGB != null ? CfnAutoScalingGroupTotalLocalStorageGBRequestPropertyFromCloudFormation(properties.TotalLocalStorageGB) : void 0), ret.addPropertyResult("vCpuCount", "VCpuCount", properties.VCpuCount != null ? CfnAutoScalingGroupVCpuCountRequestPropertyFromCloudFormation(properties.VCpuCount) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAutoScalingGroup_InstancesDistributionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("onDemandAllocationStrategy", cdk.validateString)(properties.onDemandAllocationStrategy)), errors.collect(cdk.propertyValidator("onDemandBaseCapacity", cdk.validateNumber)(properties.onDemandBaseCapacity)), errors.collect(cdk.propertyValidator("onDemandPercentageAboveBaseCapacity", cdk.validateNumber)(properties.onDemandPercentageAboveBaseCapacity)), errors.collect(cdk.propertyValidator("spotAllocationStrategy", cdk.validateString)(properties.spotAllocationStrategy)), errors.collect(cdk.propertyValidator("spotInstancePools", cdk.validateNumber)(properties.spotInstancePools)), errors.collect(cdk.propertyValidator("spotMaxPrice", cdk.validateString)(properties.spotMaxPrice)), errors.wrap('supplied properties not correct for "InstancesDistributionProperty"');
    }
    function cfnAutoScalingGroupInstancesDistributionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAutoScalingGroup_InstancesDistributionPropertyValidator(properties).assertSuccess(), { OnDemandAllocationStrategy: cdk.stringToCloudFormation(properties.onDemandAllocationStrategy), OnDemandBaseCapacity: cdk.numberToCloudFormation(properties.onDemandBaseCapacity), OnDemandPercentageAboveBaseCapacity: cdk.numberToCloudFormation(properties.onDemandPercentageAboveBaseCapacity), SpotAllocationStrategy: cdk.stringToCloudFormation(properties.spotAllocationStrategy), SpotInstancePools: cdk.numberToCloudFormation(properties.spotInstancePools), SpotMaxPrice: cdk.stringToCloudFormation(properties.spotMaxPrice) }) : properties;
    }
    function CfnAutoScalingGroupInstancesDistributionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("onDemandAllocationStrategy", "OnDemandAllocationStrategy", properties.OnDemandAllocationStrategy != null ? cfn_parse.FromCloudFormation.getString(properties.OnDemandAllocationStrategy) : void 0), ret.addPropertyResult("onDemandBaseCapacity", "OnDemandBaseCapacity", properties.OnDemandBaseCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.OnDemandBaseCapacity) : void 0), ret.addPropertyResult("onDemandPercentageAboveBaseCapacity", "OnDemandPercentageAboveBaseCapacity", properties.OnDemandPercentageAboveBaseCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.OnDemandPercentageAboveBaseCapacity) : void 0), ret.addPropertyResult("spotAllocationStrategy", "SpotAllocationStrategy", properties.SpotAllocationStrategy != null ? cfn_parse.FromCloudFormation.getString(properties.SpotAllocationStrategy) : void 0), ret.addPropertyResult("spotInstancePools", "SpotInstancePools", properties.SpotInstancePools != null ? cfn_parse.FromCloudFormation.getNumber(properties.SpotInstancePools) : void 0), ret.addPropertyResult("spotMaxPrice", "SpotMaxPrice", properties.SpotMaxPrice != null ? cfn_parse.FromCloudFormation.getString(properties.SpotMaxPrice) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAutoScalingGroup_LaunchTemplatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("launchTemplateSpecification", cdk.requiredValidator)(properties.launchTemplateSpecification)), errors.collect(cdk.propertyValidator("launchTemplateSpecification", CfnAutoScalingGroup_LaunchTemplateSpecificationPropertyValidator)(properties.launchTemplateSpecification)), errors.collect(cdk.propertyValidator("overrides", cdk.listValidator(CfnAutoScalingGroup_LaunchTemplateOverridesPropertyValidator))(properties.overrides)), errors.wrap('supplied properties not correct for "LaunchTemplateProperty"');
    }
    function cfnAutoScalingGroupLaunchTemplatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAutoScalingGroup_LaunchTemplatePropertyValidator(properties).assertSuccess(), { LaunchTemplateSpecification: cfnAutoScalingGroupLaunchTemplateSpecificationPropertyToCloudFormation(properties.launchTemplateSpecification), Overrides: cdk.listMapper(cfnAutoScalingGroupLaunchTemplateOverridesPropertyToCloudFormation)(properties.overrides) }) : properties;
    }
    function CfnAutoScalingGroupLaunchTemplatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("launchTemplateSpecification", "LaunchTemplateSpecification", CfnAutoScalingGroupLaunchTemplateSpecificationPropertyFromCloudFormation(properties.LaunchTemplateSpecification)), ret.addPropertyResult("overrides", "Overrides", properties.Overrides != null ? cfn_parse.FromCloudFormation.getArray(CfnAutoScalingGroupLaunchTemplateOverridesPropertyFromCloudFormation)(properties.Overrides) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAutoScalingGroup_LaunchTemplateOverridesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceRequirements", CfnAutoScalingGroup_InstanceRequirementsPropertyValidator)(properties.instanceRequirements)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("launchTemplateSpecification", CfnAutoScalingGroup_LaunchTemplateSpecificationPropertyValidator)(properties.launchTemplateSpecification)), errors.collect(cdk.propertyValidator("weightedCapacity", cdk.validateString)(properties.weightedCapacity)), errors.wrap('supplied properties not correct for "LaunchTemplateOverridesProperty"');
    }
    function cfnAutoScalingGroupLaunchTemplateOverridesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAutoScalingGroup_LaunchTemplateOverridesPropertyValidator(properties).assertSuccess(), { InstanceRequirements: cfnAutoScalingGroupInstanceRequirementsPropertyToCloudFormation(properties.instanceRequirements), InstanceType: cdk.stringToCloudFormation(properties.instanceType), LaunchTemplateSpecification: cfnAutoScalingGroupLaunchTemplateSpecificationPropertyToCloudFormation(properties.launchTemplateSpecification), WeightedCapacity: cdk.stringToCloudFormation(properties.weightedCapacity) }) : properties;
    }
    function CfnAutoScalingGroupLaunchTemplateOverridesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceRequirements", "InstanceRequirements", properties.InstanceRequirements != null ? CfnAutoScalingGroupInstanceRequirementsPropertyFromCloudFormation(properties.InstanceRequirements) : void 0), ret.addPropertyResult("instanceType", "InstanceType", properties.InstanceType != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceType) : void 0), ret.addPropertyResult("launchTemplateSpecification", "LaunchTemplateSpecification", properties.LaunchTemplateSpecification != null ? CfnAutoScalingGroupLaunchTemplateSpecificationPropertyFromCloudFormation(properties.LaunchTemplateSpecification) : void 0), ret.addPropertyResult("weightedCapacity", "WeightedCapacity", properties.WeightedCapacity != null ? cfn_parse.FromCloudFormation.getString(properties.WeightedCapacity) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAutoScalingGroup_LaunchTemplateSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("launchTemplateId", cdk.validateString)(properties.launchTemplateId)), errors.collect(cdk.propertyValidator("launchTemplateName", cdk.validateString)(properties.launchTemplateName)), errors.collect(cdk.propertyValidator("version", cdk.requiredValidator)(properties.version)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "LaunchTemplateSpecificationProperty"');
    }
    function cfnAutoScalingGroupLaunchTemplateSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAutoScalingGroup_LaunchTemplateSpecificationPropertyValidator(properties).assertSuccess(), { LaunchTemplateId: cdk.stringToCloudFormation(properties.launchTemplateId), LaunchTemplateName: cdk.stringToCloudFormation(properties.launchTemplateName), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnAutoScalingGroupLaunchTemplateSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("launchTemplateId", "LaunchTemplateId", properties.LaunchTemplateId != null ? cfn_parse.FromCloudFormation.getString(properties.LaunchTemplateId) : void 0), ret.addPropertyResult("launchTemplateName", "LaunchTemplateName", properties.LaunchTemplateName != null ? cfn_parse.FromCloudFormation.getString(properties.LaunchTemplateName) : void 0), ret.addPropertyResult("version", "Version", cfn_parse.FromCloudFormation.getString(properties.Version)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAutoScalingGroup_LifecycleHookSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultResult", cdk.validateString)(properties.defaultResult)), errors.collect(cdk.propertyValidator("heartbeatTimeout", cdk.validateNumber)(properties.heartbeatTimeout)), errors.collect(cdk.propertyValidator("lifecycleHookName", cdk.requiredValidator)(properties.lifecycleHookName)), errors.collect(cdk.propertyValidator("lifecycleHookName", cdk.validateString)(properties.lifecycleHookName)), errors.collect(cdk.propertyValidator("lifecycleTransition", cdk.requiredValidator)(properties.lifecycleTransition)), errors.collect(cdk.propertyValidator("lifecycleTransition", cdk.validateString)(properties.lifecycleTransition)), errors.collect(cdk.propertyValidator("notificationMetadata", cdk.validateString)(properties.notificationMetadata)), errors.collect(cdk.propertyValidator("notificationTargetArn", cdk.validateString)(properties.notificationTargetArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "LifecycleHookSpecificationProperty"');
    }
    function cfnAutoScalingGroupLifecycleHookSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAutoScalingGroup_LifecycleHookSpecificationPropertyValidator(properties).assertSuccess(), { DefaultResult: cdk.stringToCloudFormation(properties.defaultResult), HeartbeatTimeout: cdk.numberToCloudFormation(properties.heartbeatTimeout), LifecycleHookName: cdk.stringToCloudFormation(properties.lifecycleHookName), LifecycleTransition: cdk.stringToCloudFormation(properties.lifecycleTransition), NotificationMetadata: cdk.stringToCloudFormation(properties.notificationMetadata), NotificationTargetARN: cdk.stringToCloudFormation(properties.notificationTargetArn), RoleARN: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnAutoScalingGroupLifecycleHookSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultResult", "DefaultResult", properties.DefaultResult != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultResult) : void 0), ret.addPropertyResult("heartbeatTimeout", "HeartbeatTimeout", properties.HeartbeatTimeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.HeartbeatTimeout) : void 0), ret.addPropertyResult("lifecycleHookName", "LifecycleHookName", cfn_parse.FromCloudFormation.getString(properties.LifecycleHookName)), ret.addPropertyResult("lifecycleTransition", "LifecycleTransition", cfn_parse.FromCloudFormation.getString(properties.LifecycleTransition)), ret.addPropertyResult("notificationMetadata", "NotificationMetadata", properties.NotificationMetadata != null ? cfn_parse.FromCloudFormation.getString(properties.NotificationMetadata) : void 0), ret.addPropertyResult("notificationTargetArn", "NotificationTargetARN", properties.NotificationTargetARN != null ? cfn_parse.FromCloudFormation.getString(properties.NotificationTargetARN) : void 0), ret.addPropertyResult("roleArn", "RoleARN", properties.RoleARN != null ? cfn_parse.FromCloudFormation.getString(properties.RoleARN) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAutoScalingGroup_MemoryGiBPerVCpuRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "MemoryGiBPerVCpuRequestProperty"');
    }
    function cfnAutoScalingGroupMemoryGiBPerVCpuRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAutoScalingGroup_MemoryGiBPerVCpuRequestPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnAutoScalingGroupMemoryGiBPerVCpuRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAutoScalingGroup_MemoryMiBRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "MemoryMiBRequestProperty"');
    }
    function cfnAutoScalingGroupMemoryMiBRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAutoScalingGroup_MemoryMiBRequestPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnAutoScalingGroupMemoryMiBRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAutoScalingGroup_MetricsCollectionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("granularity", cdk.requiredValidator)(properties.granularity)), errors.collect(cdk.propertyValidator("granularity", cdk.validateString)(properties.granularity)), errors.collect(cdk.propertyValidator("metrics", cdk.listValidator(cdk.validateString))(properties.metrics)), errors.wrap('supplied properties not correct for "MetricsCollectionProperty"');
    }
    function cfnAutoScalingGroupMetricsCollectionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAutoScalingGroup_MetricsCollectionPropertyValidator(properties).assertSuccess(), { Granularity: cdk.stringToCloudFormation(properties.granularity), Metrics: cdk.listMapper(cdk.stringToCloudFormation)(properties.metrics) }) : properties;
    }
    function CfnAutoScalingGroupMetricsCollectionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("granularity", "Granularity", cfn_parse.FromCloudFormation.getString(properties.Granularity)), ret.addPropertyResult("metrics", "Metrics", properties.Metrics != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Metrics) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAutoScalingGroup_MixedInstancesPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instancesDistribution", CfnAutoScalingGroup_InstancesDistributionPropertyValidator)(properties.instancesDistribution)), errors.collect(cdk.propertyValidator("launchTemplate", cdk.requiredValidator)(properties.launchTemplate)), errors.collect(cdk.propertyValidator("launchTemplate", CfnAutoScalingGroup_LaunchTemplatePropertyValidator)(properties.launchTemplate)), errors.wrap('supplied properties not correct for "MixedInstancesPolicyProperty"');
    }
    function cfnAutoScalingGroupMixedInstancesPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAutoScalingGroup_MixedInstancesPolicyPropertyValidator(properties).assertSuccess(), { InstancesDistribution: cfnAutoScalingGroupInstancesDistributionPropertyToCloudFormation(properties.instancesDistribution), LaunchTemplate: cfnAutoScalingGroupLaunchTemplatePropertyToCloudFormation(properties.launchTemplate) }) : properties;
    }
    function CfnAutoScalingGroupMixedInstancesPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instancesDistribution", "InstancesDistribution", properties.InstancesDistribution != null ? CfnAutoScalingGroupInstancesDistributionPropertyFromCloudFormation(properties.InstancesDistribution) : void 0), ret.addPropertyResult("launchTemplate", "LaunchTemplate", CfnAutoScalingGroupLaunchTemplatePropertyFromCloudFormation(properties.LaunchTemplate)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAutoScalingGroup_NetworkBandwidthGbpsRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "NetworkBandwidthGbpsRequestProperty"');
    }
    function cfnAutoScalingGroupNetworkBandwidthGbpsRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAutoScalingGroup_NetworkBandwidthGbpsRequestPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnAutoScalingGroupNetworkBandwidthGbpsRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAutoScalingGroup_NetworkInterfaceCountRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "NetworkInterfaceCountRequestProperty"');
    }
    function cfnAutoScalingGroupNetworkInterfaceCountRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAutoScalingGroup_NetworkInterfaceCountRequestPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnAutoScalingGroupNetworkInterfaceCountRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAutoScalingGroup_NotificationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("notificationTypes", cdk.listValidator(cdk.validateString))(properties.notificationTypes)), errors.collect(cdk.propertyValidator("topicArn", cdk.requiredValidator)(properties.topicArn)), errors.collect(cdk.propertyValidator("topicArn", cdk.validateString)(properties.topicArn)), errors.wrap('supplied properties not correct for "NotificationConfigurationProperty"');
    }
    function cfnAutoScalingGroupNotificationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAutoScalingGroup_NotificationConfigurationPropertyValidator(properties).assertSuccess(), { NotificationTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.notificationTypes), TopicARN: cdk.stringToCloudFormation(properties.topicArn) }) : properties;
    }
    function CfnAutoScalingGroupNotificationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("notificationTypes", "NotificationTypes", properties.NotificationTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.NotificationTypes) : void 0), ret.addPropertyResult("topicArn", "TopicARN", cfn_parse.FromCloudFormation.getString(properties.TopicARN)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAutoScalingGroup_TagPropertyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("propagateAtLaunch", cdk.requiredValidator)(properties.propagateAtLaunch)), errors.collect(cdk.propertyValidator("propagateAtLaunch", cdk.validateBoolean)(properties.propagateAtLaunch)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TagPropertyProperty"');
    }
    function cfnAutoScalingGroupTagPropertyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAutoScalingGroup_TagPropertyPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), PropagateAtLaunch: cdk.booleanToCloudFormation(properties.propagateAtLaunch), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnAutoScalingGroupTagPropertyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("propagateAtLaunch", "PropagateAtLaunch", cfn_parse.FromCloudFormation.getBoolean(properties.PropagateAtLaunch)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAutoScalingGroup_TotalLocalStorageGBRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "TotalLocalStorageGBRequestProperty"');
    }
    function cfnAutoScalingGroupTotalLocalStorageGBRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAutoScalingGroup_TotalLocalStorageGBRequestPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnAutoScalingGroupTotalLocalStorageGBRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAutoScalingGroup_VCpuCountRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "VCpuCountRequestProperty"');
    }
    function cfnAutoScalingGroupVCpuCountRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAutoScalingGroup_VCpuCountRequestPropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnAutoScalingGroupVCpuCountRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchConfigurationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("associatePublicIpAddress", cdk.validateBoolean)(properties.associatePublicIpAddress)), errors.collect(cdk.propertyValidator("blockDeviceMappings", cdk.listValidator(CfnLaunchConfiguration_BlockDeviceMappingPropertyValidator))(properties.blockDeviceMappings)), errors.collect(cdk.propertyValidator("classicLinkVpcId", cdk.validateString)(properties.classicLinkVpcId)), errors.collect(cdk.propertyValidator("classicLinkVpcSecurityGroups", cdk.listValidator(cdk.validateString))(properties.classicLinkVpcSecurityGroups)), errors.collect(cdk.propertyValidator("ebsOptimized", cdk.validateBoolean)(properties.ebsOptimized)), errors.collect(cdk.propertyValidator("iamInstanceProfile", cdk.validateString)(properties.iamInstanceProfile)), errors.collect(cdk.propertyValidator("imageId", cdk.requiredValidator)(properties.imageId)), errors.collect(cdk.propertyValidator("imageId", cdk.validateString)(properties.imageId)), errors.collect(cdk.propertyValidator("instanceId", cdk.validateString)(properties.instanceId)), errors.collect(cdk.propertyValidator("instanceMonitoring", cdk.validateBoolean)(properties.instanceMonitoring)), errors.collect(cdk.propertyValidator("instanceType", cdk.requiredValidator)(properties.instanceType)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("kernelId", cdk.validateString)(properties.kernelId)), errors.collect(cdk.propertyValidator("keyName", cdk.validateString)(properties.keyName)), errors.collect(cdk.propertyValidator("launchConfigurationName", cdk.validateString)(properties.launchConfigurationName)), errors.collect(cdk.propertyValidator("metadataOptions", CfnLaunchConfiguration_MetadataOptionsPropertyValidator)(properties.metadataOptions)), errors.collect(cdk.propertyValidator("placementTenancy", cdk.validateString)(properties.placementTenancy)), errors.collect(cdk.propertyValidator("ramDiskId", cdk.validateString)(properties.ramDiskId)), errors.collect(cdk.propertyValidator("securityGroups", cdk.listValidator(cdk.validateString))(properties.securityGroups)), errors.collect(cdk.propertyValidator("spotPrice", cdk.validateString)(properties.spotPrice)), errors.collect(cdk.propertyValidator("userData", cdk.validateString)(properties.userData)), errors.wrap('supplied properties not correct for "CfnLaunchConfigurationProps"');
    }
    function cfnLaunchConfigurationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchConfigurationPropsValidator(properties).assertSuccess(), { ImageId: cdk.stringToCloudFormation(properties.imageId), InstanceType: cdk.stringToCloudFormation(properties.instanceType), AssociatePublicIpAddress: cdk.booleanToCloudFormation(properties.associatePublicIpAddress), BlockDeviceMappings: cdk.listMapper(cfnLaunchConfigurationBlockDeviceMappingPropertyToCloudFormation)(properties.blockDeviceMappings), ClassicLinkVPCId: cdk.stringToCloudFormation(properties.classicLinkVpcId), ClassicLinkVPCSecurityGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.classicLinkVpcSecurityGroups), EbsOptimized: cdk.booleanToCloudFormation(properties.ebsOptimized), IamInstanceProfile: cdk.stringToCloudFormation(properties.iamInstanceProfile), InstanceId: cdk.stringToCloudFormation(properties.instanceId), InstanceMonitoring: cdk.booleanToCloudFormation(properties.instanceMonitoring), KernelId: cdk.stringToCloudFormation(properties.kernelId), KeyName: cdk.stringToCloudFormation(properties.keyName), LaunchConfigurationName: cdk.stringToCloudFormation(properties.launchConfigurationName), MetadataOptions: cfnLaunchConfigurationMetadataOptionsPropertyToCloudFormation(properties.metadataOptions), PlacementTenancy: cdk.stringToCloudFormation(properties.placementTenancy), RamDiskId: cdk.stringToCloudFormation(properties.ramDiskId), SecurityGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroups), SpotPrice: cdk.stringToCloudFormation(properties.spotPrice), UserData: cdk.stringToCloudFormation(properties.userData) }) : properties;
    }
    function CfnLaunchConfigurationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("imageId", "ImageId", cfn_parse.FromCloudFormation.getString(properties.ImageId)), ret.addPropertyResult("instanceType", "InstanceType", cfn_parse.FromCloudFormation.getString(properties.InstanceType)), ret.addPropertyResult("associatePublicIpAddress", "AssociatePublicIpAddress", properties.AssociatePublicIpAddress != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AssociatePublicIpAddress) : void 0), ret.addPropertyResult("blockDeviceMappings", "BlockDeviceMappings", properties.BlockDeviceMappings != null ? cfn_parse.FromCloudFormation.getArray(CfnLaunchConfigurationBlockDeviceMappingPropertyFromCloudFormation)(properties.BlockDeviceMappings) : void 0), ret.addPropertyResult("classicLinkVpcId", "ClassicLinkVPCId", properties.ClassicLinkVPCId != null ? cfn_parse.FromCloudFormation.getString(properties.ClassicLinkVPCId) : void 0), ret.addPropertyResult("classicLinkVpcSecurityGroups", "ClassicLinkVPCSecurityGroups", properties.ClassicLinkVPCSecurityGroups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ClassicLinkVPCSecurityGroups) : void 0), ret.addPropertyResult("ebsOptimized", "EbsOptimized", properties.EbsOptimized != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EbsOptimized) : void 0), ret.addPropertyResult("iamInstanceProfile", "IamInstanceProfile", properties.IamInstanceProfile != null ? cfn_parse.FromCloudFormation.getString(properties.IamInstanceProfile) : void 0), ret.addPropertyResult("instanceId", "InstanceId", properties.InstanceId != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceId) : void 0), ret.addPropertyResult("instanceMonitoring", "InstanceMonitoring", properties.InstanceMonitoring != null ? cfn_parse.FromCloudFormation.getBoolean(properties.InstanceMonitoring) : void 0), ret.addPropertyResult("kernelId", "KernelId", properties.KernelId != null ? cfn_parse.FromCloudFormation.getString(properties.KernelId) : void 0), ret.addPropertyResult("keyName", "KeyName", properties.KeyName != null ? cfn_parse.FromCloudFormation.getString(properties.KeyName) : void 0), ret.addPropertyResult("launchConfigurationName", "LaunchConfigurationName", properties.LaunchConfigurationName != null ? cfn_parse.FromCloudFormation.getString(properties.LaunchConfigurationName) : void 0), ret.addPropertyResult("metadataOptions", "MetadataOptions", properties.MetadataOptions != null ? CfnLaunchConfigurationMetadataOptionsPropertyFromCloudFormation(properties.MetadataOptions) : void 0), ret.addPropertyResult("placementTenancy", "PlacementTenancy", properties.PlacementTenancy != null ? cfn_parse.FromCloudFormation.getString(properties.PlacementTenancy) : void 0), ret.addPropertyResult("ramDiskId", "RamDiskId", properties.RamDiskId != null ? cfn_parse.FromCloudFormation.getString(properties.RamDiskId) : void 0), ret.addPropertyResult("securityGroups", "SecurityGroups", properties.SecurityGroups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroups) : void 0), ret.addPropertyResult("spotPrice", "SpotPrice", properties.SpotPrice != null ? cfn_parse.FromCloudFormation.getString(properties.SpotPrice) : void 0), ret.addPropertyResult("userData", "UserData", properties.UserData != null ? cfn_parse.FromCloudFormation.getString(properties.UserData) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLaunchConfiguration = class _CfnLaunchConfiguration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLaunchConfigurationPropsFromCloudFormation(resourceProperties), ret = new _CfnLaunchConfiguration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLaunchConfiguration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_CfnLaunchConfigurationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLaunchConfiguration), error;
        }
        cdk.requireProperty(props, "imageId", this), cdk.requireProperty(props, "instanceType", this), this.imageId = props.imageId, this.instanceType = props.instanceType, this.associatePublicIpAddress = props.associatePublicIpAddress, this.blockDeviceMappings = props.blockDeviceMappings, this.classicLinkVpcId = props.classicLinkVpcId, this.classicLinkVpcSecurityGroups = props.classicLinkVpcSecurityGroups, this.ebsOptimized = props.ebsOptimized, this.iamInstanceProfile = props.iamInstanceProfile, this.instanceId = props.instanceId, this.instanceMonitoring = props.instanceMonitoring, this.kernelId = props.kernelId, this.keyName = props.keyName, this.launchConfigurationName = props.launchConfigurationName, this.metadataOptions = props.metadataOptions, this.placementTenancy = props.placementTenancy, this.ramDiskId = props.ramDiskId, this.securityGroups = props.securityGroups, this.spotPrice = props.spotPrice, this.userData = props.userData;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLaunchConfiguration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { imageId: this.imageId, instanceType: this.instanceType, associatePublicIpAddress: this.associatePublicIpAddress, blockDeviceMappings: this.blockDeviceMappings, classicLinkVpcId: this.classicLinkVpcId, classicLinkVpcSecurityGroups: this.classicLinkVpcSecurityGroups, ebsOptimized: this.ebsOptimized, iamInstanceProfile: this.iamInstanceProfile, instanceId: this.instanceId, instanceMonitoring: this.instanceMonitoring, kernelId: this.kernelId, keyName: this.keyName, launchConfigurationName: this.launchConfigurationName, metadataOptions: this.metadataOptions, placementTenancy: this.placementTenancy, ramDiskId: this.ramDiskId, securityGroups: this.securityGroups, spotPrice: this.spotPrice, userData: this.userData };
      }
      renderProperties(props) {
        return cfnLaunchConfigurationPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnLaunchConfiguration[_b] = { fqn: "aws-cdk-lib.aws_autoscaling.CfnLaunchConfiguration", version: "2.80.0" }, CfnLaunchConfiguration.CFN_RESOURCE_TYPE_NAME = "AWS::AutoScaling::LaunchConfiguration", exports2.CfnLaunchConfiguration = CfnLaunchConfiguration;
    function CfnLaunchConfiguration_BlockDevicePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deleteOnTermination", cdk.validateBoolean)(properties.deleteOnTermination)), errors.collect(cdk.propertyValidator("encrypted", cdk.validateBoolean)(properties.encrypted)), errors.collect(cdk.propertyValidator("iops", cdk.validateNumber)(properties.iops)), errors.collect(cdk.propertyValidator("snapshotId", cdk.validateString)(properties.snapshotId)), errors.collect(cdk.propertyValidator("throughput", cdk.validateNumber)(properties.throughput)), errors.collect(cdk.propertyValidator("volumeSize", cdk.validateNumber)(properties.volumeSize)), errors.collect(cdk.propertyValidator("volumeType", cdk.validateString)(properties.volumeType)), errors.wrap('supplied properties not correct for "BlockDeviceProperty"');
    }
    function cfnLaunchConfigurationBlockDevicePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchConfiguration_BlockDevicePropertyValidator(properties).assertSuccess(), { DeleteOnTermination: cdk.booleanToCloudFormation(properties.deleteOnTermination), Encrypted: cdk.booleanToCloudFormation(properties.encrypted), Iops: cdk.numberToCloudFormation(properties.iops), SnapshotId: cdk.stringToCloudFormation(properties.snapshotId), Throughput: cdk.numberToCloudFormation(properties.throughput), VolumeSize: cdk.numberToCloudFormation(properties.volumeSize), VolumeType: cdk.stringToCloudFormation(properties.volumeType) }) : properties;
    }
    function CfnLaunchConfigurationBlockDevicePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deleteOnTermination", "DeleteOnTermination", properties.DeleteOnTermination != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeleteOnTermination) : void 0), ret.addPropertyResult("encrypted", "Encrypted", properties.Encrypted != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Encrypted) : void 0), ret.addPropertyResult("iops", "Iops", properties.Iops != null ? cfn_parse.FromCloudFormation.getNumber(properties.Iops) : void 0), ret.addPropertyResult("snapshotId", "SnapshotId", properties.SnapshotId != null ? cfn_parse.FromCloudFormation.getString(properties.SnapshotId) : void 0), ret.addPropertyResult("throughput", "Throughput", properties.Throughput != null ? cfn_parse.FromCloudFormation.getNumber(properties.Throughput) : void 0), ret.addPropertyResult("volumeSize", "VolumeSize", properties.VolumeSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.VolumeSize) : void 0), ret.addPropertyResult("volumeType", "VolumeType", properties.VolumeType != null ? cfn_parse.FromCloudFormation.getString(properties.VolumeType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchConfiguration_BlockDeviceMappingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deviceName", cdk.requiredValidator)(properties.deviceName)), errors.collect(cdk.propertyValidator("deviceName", cdk.validateString)(properties.deviceName)), errors.collect(cdk.propertyValidator("ebs", CfnLaunchConfiguration_BlockDevicePropertyValidator)(properties.ebs)), errors.collect(cdk.propertyValidator("noDevice", cdk.validateBoolean)(properties.noDevice)), errors.collect(cdk.propertyValidator("virtualName", cdk.validateString)(properties.virtualName)), errors.wrap('supplied properties not correct for "BlockDeviceMappingProperty"');
    }
    function cfnLaunchConfigurationBlockDeviceMappingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchConfiguration_BlockDeviceMappingPropertyValidator(properties).assertSuccess(), { DeviceName: cdk.stringToCloudFormation(properties.deviceName), Ebs: cfnLaunchConfigurationBlockDevicePropertyToCloudFormation(properties.ebs), NoDevice: cdk.booleanToCloudFormation(properties.noDevice), VirtualName: cdk.stringToCloudFormation(properties.virtualName) }) : properties;
    }
    function CfnLaunchConfigurationBlockDeviceMappingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deviceName", "DeviceName", cfn_parse.FromCloudFormation.getString(properties.DeviceName)), ret.addPropertyResult("ebs", "Ebs", properties.Ebs != null ? CfnLaunchConfigurationBlockDevicePropertyFromCloudFormation(properties.Ebs) : void 0), ret.addPropertyResult("noDevice", "NoDevice", properties.NoDevice != null ? cfn_parse.FromCloudFormation.getBoolean(properties.NoDevice) : void 0), ret.addPropertyResult("virtualName", "VirtualName", properties.VirtualName != null ? cfn_parse.FromCloudFormation.getString(properties.VirtualName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchConfiguration_MetadataOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("httpEndpoint", cdk.validateString)(properties.httpEndpoint)), errors.collect(cdk.propertyValidator("httpPutResponseHopLimit", cdk.validateNumber)(properties.httpPutResponseHopLimit)), errors.collect(cdk.propertyValidator("httpTokens", cdk.validateString)(properties.httpTokens)), errors.wrap('supplied properties not correct for "MetadataOptionsProperty"');
    }
    function cfnLaunchConfigurationMetadataOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchConfiguration_MetadataOptionsPropertyValidator(properties).assertSuccess(), { HttpEndpoint: cdk.stringToCloudFormation(properties.httpEndpoint), HttpPutResponseHopLimit: cdk.numberToCloudFormation(properties.httpPutResponseHopLimit), HttpTokens: cdk.stringToCloudFormation(properties.httpTokens) }) : properties;
    }
    function CfnLaunchConfigurationMetadataOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("httpEndpoint", "HttpEndpoint", properties.HttpEndpoint != null ? cfn_parse.FromCloudFormation.getString(properties.HttpEndpoint) : void 0), ret.addPropertyResult("httpPutResponseHopLimit", "HttpPutResponseHopLimit", properties.HttpPutResponseHopLimit != null ? cfn_parse.FromCloudFormation.getNumber(properties.HttpPutResponseHopLimit) : void 0), ret.addPropertyResult("httpTokens", "HttpTokens", properties.HttpTokens != null ? cfn_parse.FromCloudFormation.getString(properties.HttpTokens) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLifecycleHookPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoScalingGroupName", cdk.requiredValidator)(properties.autoScalingGroupName)), errors.collect(cdk.propertyValidator("autoScalingGroupName", cdk.validateString)(properties.autoScalingGroupName)), errors.collect(cdk.propertyValidator("defaultResult", cdk.validateString)(properties.defaultResult)), errors.collect(cdk.propertyValidator("heartbeatTimeout", cdk.validateNumber)(properties.heartbeatTimeout)), errors.collect(cdk.propertyValidator("lifecycleHookName", cdk.validateString)(properties.lifecycleHookName)), errors.collect(cdk.propertyValidator("lifecycleTransition", cdk.requiredValidator)(properties.lifecycleTransition)), errors.collect(cdk.propertyValidator("lifecycleTransition", cdk.validateString)(properties.lifecycleTransition)), errors.collect(cdk.propertyValidator("notificationMetadata", cdk.validateString)(properties.notificationMetadata)), errors.collect(cdk.propertyValidator("notificationTargetArn", cdk.validateString)(properties.notificationTargetArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "CfnLifecycleHookProps"');
    }
    function cfnLifecycleHookPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLifecycleHookPropsValidator(properties).assertSuccess(), { AutoScalingGroupName: cdk.stringToCloudFormation(properties.autoScalingGroupName), LifecycleTransition: cdk.stringToCloudFormation(properties.lifecycleTransition), DefaultResult: cdk.stringToCloudFormation(properties.defaultResult), HeartbeatTimeout: cdk.numberToCloudFormation(properties.heartbeatTimeout), LifecycleHookName: cdk.stringToCloudFormation(properties.lifecycleHookName), NotificationMetadata: cdk.stringToCloudFormation(properties.notificationMetadata), NotificationTargetARN: cdk.stringToCloudFormation(properties.notificationTargetArn), RoleARN: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnLifecycleHookPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("autoScalingGroupName", "AutoScalingGroupName", cfn_parse.FromCloudFormation.getString(properties.AutoScalingGroupName)), ret.addPropertyResult("lifecycleTransition", "LifecycleTransition", cfn_parse.FromCloudFormation.getString(properties.LifecycleTransition)), ret.addPropertyResult("defaultResult", "DefaultResult", properties.DefaultResult != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultResult) : void 0), ret.addPropertyResult("heartbeatTimeout", "HeartbeatTimeout", properties.HeartbeatTimeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.HeartbeatTimeout) : void 0), ret.addPropertyResult("lifecycleHookName", "LifecycleHookName", properties.LifecycleHookName != null ? cfn_parse.FromCloudFormation.getString(properties.LifecycleHookName) : void 0), ret.addPropertyResult("notificationMetadata", "NotificationMetadata", properties.NotificationMetadata != null ? cfn_parse.FromCloudFormation.getString(properties.NotificationMetadata) : void 0), ret.addPropertyResult("notificationTargetArn", "NotificationTargetARN", properties.NotificationTargetARN != null ? cfn_parse.FromCloudFormation.getString(properties.NotificationTargetARN) : void 0), ret.addPropertyResult("roleArn", "RoleARN", properties.RoleARN != null ? cfn_parse.FromCloudFormation.getString(properties.RoleARN) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLifecycleHook = class _CfnLifecycleHook extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLifecycleHookPropsFromCloudFormation(resourceProperties), ret = new _CfnLifecycleHook(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLifecycleHook.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_CfnLifecycleHookProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLifecycleHook), error;
        }
        cdk.requireProperty(props, "autoScalingGroupName", this), cdk.requireProperty(props, "lifecycleTransition", this), this.autoScalingGroupName = props.autoScalingGroupName, this.lifecycleTransition = props.lifecycleTransition, this.defaultResult = props.defaultResult, this.heartbeatTimeout = props.heartbeatTimeout, this.lifecycleHookName = props.lifecycleHookName, this.notificationMetadata = props.notificationMetadata, this.notificationTargetArn = props.notificationTargetArn, this.roleArn = props.roleArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLifecycleHook.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { autoScalingGroupName: this.autoScalingGroupName, lifecycleTransition: this.lifecycleTransition, defaultResult: this.defaultResult, heartbeatTimeout: this.heartbeatTimeout, lifecycleHookName: this.lifecycleHookName, notificationMetadata: this.notificationMetadata, notificationTargetArn: this.notificationTargetArn, roleArn: this.roleArn };
      }
      renderProperties(props) {
        return cfnLifecycleHookPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnLifecycleHook[_c] = { fqn: "aws-cdk-lib.aws_autoscaling.CfnLifecycleHook", version: "2.80.0" }, CfnLifecycleHook.CFN_RESOURCE_TYPE_NAME = "AWS::AutoScaling::LifecycleHook", exports2.CfnLifecycleHook = CfnLifecycleHook;
    function CfnScalingPolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("adjustmentType", cdk.validateString)(properties.adjustmentType)), errors.collect(cdk.propertyValidator("autoScalingGroupName", cdk.requiredValidator)(properties.autoScalingGroupName)), errors.collect(cdk.propertyValidator("autoScalingGroupName", cdk.validateString)(properties.autoScalingGroupName)), errors.collect(cdk.propertyValidator("cooldown", cdk.validateString)(properties.cooldown)), errors.collect(cdk.propertyValidator("estimatedInstanceWarmup", cdk.validateNumber)(properties.estimatedInstanceWarmup)), errors.collect(cdk.propertyValidator("metricAggregationType", cdk.validateString)(properties.metricAggregationType)), errors.collect(cdk.propertyValidator("minAdjustmentMagnitude", cdk.validateNumber)(properties.minAdjustmentMagnitude)), errors.collect(cdk.propertyValidator("policyType", cdk.validateString)(properties.policyType)), errors.collect(cdk.propertyValidator("predictiveScalingConfiguration", CfnScalingPolicy_PredictiveScalingConfigurationPropertyValidator)(properties.predictiveScalingConfiguration)), errors.collect(cdk.propertyValidator("scalingAdjustment", cdk.validateNumber)(properties.scalingAdjustment)), errors.collect(cdk.propertyValidator("stepAdjustments", cdk.listValidator(CfnScalingPolicy_StepAdjustmentPropertyValidator))(properties.stepAdjustments)), errors.collect(cdk.propertyValidator("targetTrackingConfiguration", CfnScalingPolicy_TargetTrackingConfigurationPropertyValidator)(properties.targetTrackingConfiguration)), errors.wrap('supplied properties not correct for "CfnScalingPolicyProps"');
    }
    function cfnScalingPolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPolicyPropsValidator(properties).assertSuccess(), { AutoScalingGroupName: cdk.stringToCloudFormation(properties.autoScalingGroupName), AdjustmentType: cdk.stringToCloudFormation(properties.adjustmentType), Cooldown: cdk.stringToCloudFormation(properties.cooldown), EstimatedInstanceWarmup: cdk.numberToCloudFormation(properties.estimatedInstanceWarmup), MetricAggregationType: cdk.stringToCloudFormation(properties.metricAggregationType), MinAdjustmentMagnitude: cdk.numberToCloudFormation(properties.minAdjustmentMagnitude), PolicyType: cdk.stringToCloudFormation(properties.policyType), PredictiveScalingConfiguration: cfnScalingPolicyPredictiveScalingConfigurationPropertyToCloudFormation(properties.predictiveScalingConfiguration), ScalingAdjustment: cdk.numberToCloudFormation(properties.scalingAdjustment), StepAdjustments: cdk.listMapper(cfnScalingPolicyStepAdjustmentPropertyToCloudFormation)(properties.stepAdjustments), TargetTrackingConfiguration: cfnScalingPolicyTargetTrackingConfigurationPropertyToCloudFormation(properties.targetTrackingConfiguration) }) : properties;
    }
    function CfnScalingPolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("autoScalingGroupName", "AutoScalingGroupName", cfn_parse.FromCloudFormation.getString(properties.AutoScalingGroupName)), ret.addPropertyResult("adjustmentType", "AdjustmentType", properties.AdjustmentType != null ? cfn_parse.FromCloudFormation.getString(properties.AdjustmentType) : void 0), ret.addPropertyResult("cooldown", "Cooldown", properties.Cooldown != null ? cfn_parse.FromCloudFormation.getString(properties.Cooldown) : void 0), ret.addPropertyResult("estimatedInstanceWarmup", "EstimatedInstanceWarmup", properties.EstimatedInstanceWarmup != null ? cfn_parse.FromCloudFormation.getNumber(properties.EstimatedInstanceWarmup) : void 0), ret.addPropertyResult("metricAggregationType", "MetricAggregationType", properties.MetricAggregationType != null ? cfn_parse.FromCloudFormation.getString(properties.MetricAggregationType) : void 0), ret.addPropertyResult("minAdjustmentMagnitude", "MinAdjustmentMagnitude", properties.MinAdjustmentMagnitude != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinAdjustmentMagnitude) : void 0), ret.addPropertyResult("policyType", "PolicyType", properties.PolicyType != null ? cfn_parse.FromCloudFormation.getString(properties.PolicyType) : void 0), ret.addPropertyResult("predictiveScalingConfiguration", "PredictiveScalingConfiguration", properties.PredictiveScalingConfiguration != null ? CfnScalingPolicyPredictiveScalingConfigurationPropertyFromCloudFormation(properties.PredictiveScalingConfiguration) : void 0), ret.addPropertyResult("scalingAdjustment", "ScalingAdjustment", properties.ScalingAdjustment != null ? cfn_parse.FromCloudFormation.getNumber(properties.ScalingAdjustment) : void 0), ret.addPropertyResult("stepAdjustments", "StepAdjustments", properties.StepAdjustments != null ? cfn_parse.FromCloudFormation.getArray(CfnScalingPolicyStepAdjustmentPropertyFromCloudFormation)(properties.StepAdjustments) : void 0), ret.addPropertyResult("targetTrackingConfiguration", "TargetTrackingConfiguration", properties.TargetTrackingConfiguration != null ? CfnScalingPolicyTargetTrackingConfigurationPropertyFromCloudFormation(properties.TargetTrackingConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnScalingPolicy = class _CfnScalingPolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnScalingPolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnScalingPolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnScalingPolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_CfnScalingPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnScalingPolicy), error;
        }
        cdk.requireProperty(props, "autoScalingGroupName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrPolicyName = cdk.Token.asString(this.getAtt("PolicyName", cdk.ResolutionTypeHint.STRING)), this.autoScalingGroupName = props.autoScalingGroupName, this.adjustmentType = props.adjustmentType, this.cooldown = props.cooldown, this.estimatedInstanceWarmup = props.estimatedInstanceWarmup, this.metricAggregationType = props.metricAggregationType, this.minAdjustmentMagnitude = props.minAdjustmentMagnitude, this.policyType = props.policyType, this.predictiveScalingConfiguration = props.predictiveScalingConfiguration, this.scalingAdjustment = props.scalingAdjustment, this.stepAdjustments = props.stepAdjustments, this.targetTrackingConfiguration = props.targetTrackingConfiguration;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnScalingPolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { autoScalingGroupName: this.autoScalingGroupName, adjustmentType: this.adjustmentType, cooldown: this.cooldown, estimatedInstanceWarmup: this.estimatedInstanceWarmup, metricAggregationType: this.metricAggregationType, minAdjustmentMagnitude: this.minAdjustmentMagnitude, policyType: this.policyType, predictiveScalingConfiguration: this.predictiveScalingConfiguration, scalingAdjustment: this.scalingAdjustment, stepAdjustments: this.stepAdjustments, targetTrackingConfiguration: this.targetTrackingConfiguration };
      }
      renderProperties(props) {
        return cfnScalingPolicyPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnScalingPolicy[_d] = { fqn: "aws-cdk-lib.aws_autoscaling.CfnScalingPolicy", version: "2.80.0" }, CfnScalingPolicy.CFN_RESOURCE_TYPE_NAME = "AWS::AutoScaling::ScalingPolicy", exports2.CfnScalingPolicy = CfnScalingPolicy;
    function CfnScalingPolicy_CustomizedMetricSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dimensions", cdk.listValidator(CfnScalingPolicy_MetricDimensionPropertyValidator))(properties.dimensions)), errors.collect(cdk.propertyValidator("metricName", cdk.requiredValidator)(properties.metricName)), errors.collect(cdk.propertyValidator("metricName", cdk.validateString)(properties.metricName)), errors.collect(cdk.propertyValidator("namespace", cdk.requiredValidator)(properties.namespace)), errors.collect(cdk.propertyValidator("namespace", cdk.validateString)(properties.namespace)), errors.collect(cdk.propertyValidator("statistic", cdk.requiredValidator)(properties.statistic)), errors.collect(cdk.propertyValidator("statistic", cdk.validateString)(properties.statistic)), errors.collect(cdk.propertyValidator("unit", cdk.validateString)(properties.unit)), errors.wrap('supplied properties not correct for "CustomizedMetricSpecificationProperty"');
    }
    function cfnScalingPolicyCustomizedMetricSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPolicy_CustomizedMetricSpecificationPropertyValidator(properties).assertSuccess(), { Dimensions: cdk.listMapper(cfnScalingPolicyMetricDimensionPropertyToCloudFormation)(properties.dimensions), MetricName: cdk.stringToCloudFormation(properties.metricName), Namespace: cdk.stringToCloudFormation(properties.namespace), Statistic: cdk.stringToCloudFormation(properties.statistic), Unit: cdk.stringToCloudFormation(properties.unit) }) : properties;
    }
    function CfnScalingPolicyCustomizedMetricSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dimensions", "Dimensions", properties.Dimensions != null ? cfn_parse.FromCloudFormation.getArray(CfnScalingPolicyMetricDimensionPropertyFromCloudFormation)(properties.Dimensions) : void 0), ret.addPropertyResult("metricName", "MetricName", cfn_parse.FromCloudFormation.getString(properties.MetricName)), ret.addPropertyResult("namespace", "Namespace", cfn_parse.FromCloudFormation.getString(properties.Namespace)), ret.addPropertyResult("statistic", "Statistic", cfn_parse.FromCloudFormation.getString(properties.Statistic)), ret.addPropertyResult("unit", "Unit", properties.Unit != null ? cfn_parse.FromCloudFormation.getString(properties.Unit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScalingPolicy_MetricPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dimensions", cdk.listValidator(CfnScalingPolicy_MetricDimensionPropertyValidator))(properties.dimensions)), errors.collect(cdk.propertyValidator("metricName", cdk.requiredValidator)(properties.metricName)), errors.collect(cdk.propertyValidator("metricName", cdk.validateString)(properties.metricName)), errors.collect(cdk.propertyValidator("namespace", cdk.requiredValidator)(properties.namespace)), errors.collect(cdk.propertyValidator("namespace", cdk.validateString)(properties.namespace)), errors.wrap('supplied properties not correct for "MetricProperty"');
    }
    function cfnScalingPolicyMetricPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPolicy_MetricPropertyValidator(properties).assertSuccess(), { Dimensions: cdk.listMapper(cfnScalingPolicyMetricDimensionPropertyToCloudFormation)(properties.dimensions), MetricName: cdk.stringToCloudFormation(properties.metricName), Namespace: cdk.stringToCloudFormation(properties.namespace) }) : properties;
    }
    function CfnScalingPolicyMetricPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dimensions", "Dimensions", properties.Dimensions != null ? cfn_parse.FromCloudFormation.getArray(CfnScalingPolicyMetricDimensionPropertyFromCloudFormation)(properties.Dimensions) : void 0), ret.addPropertyResult("metricName", "MetricName", cfn_parse.FromCloudFormation.getString(properties.MetricName)), ret.addPropertyResult("namespace", "Namespace", cfn_parse.FromCloudFormation.getString(properties.Namespace)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScalingPolicy_MetricDataQueryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("label", cdk.validateString)(properties.label)), errors.collect(cdk.propertyValidator("metricStat", CfnScalingPolicy_MetricStatPropertyValidator)(properties.metricStat)), errors.collect(cdk.propertyValidator("returnData", cdk.validateBoolean)(properties.returnData)), errors.wrap('supplied properties not correct for "MetricDataQueryProperty"');
    }
    function cfnScalingPolicyMetricDataQueryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPolicy_MetricDataQueryPropertyValidator(properties).assertSuccess(), { Expression: cdk.stringToCloudFormation(properties.expression), Id: cdk.stringToCloudFormation(properties.id), Label: cdk.stringToCloudFormation(properties.label), MetricStat: cfnScalingPolicyMetricStatPropertyToCloudFormation(properties.metricStat), ReturnData: cdk.booleanToCloudFormation(properties.returnData) }) : properties;
    }
    function CfnScalingPolicyMetricDataQueryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("expression", "Expression", properties.Expression != null ? cfn_parse.FromCloudFormation.getString(properties.Expression) : void 0), ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("label", "Label", properties.Label != null ? cfn_parse.FromCloudFormation.getString(properties.Label) : void 0), ret.addPropertyResult("metricStat", "MetricStat", properties.MetricStat != null ? CfnScalingPolicyMetricStatPropertyFromCloudFormation(properties.MetricStat) : void 0), ret.addPropertyResult("returnData", "ReturnData", properties.ReturnData != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ReturnData) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScalingPolicy_MetricDimensionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "MetricDimensionProperty"');
    }
    function cfnScalingPolicyMetricDimensionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPolicy_MetricDimensionPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnScalingPolicyMetricDimensionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScalingPolicy_MetricStatPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("metric", cdk.requiredValidator)(properties.metric)), errors.collect(cdk.propertyValidator("metric", CfnScalingPolicy_MetricPropertyValidator)(properties.metric)), errors.collect(cdk.propertyValidator("stat", cdk.requiredValidator)(properties.stat)), errors.collect(cdk.propertyValidator("stat", cdk.validateString)(properties.stat)), errors.collect(cdk.propertyValidator("unit", cdk.validateString)(properties.unit)), errors.wrap('supplied properties not correct for "MetricStatProperty"');
    }
    function cfnScalingPolicyMetricStatPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPolicy_MetricStatPropertyValidator(properties).assertSuccess(), { Metric: cfnScalingPolicyMetricPropertyToCloudFormation(properties.metric), Stat: cdk.stringToCloudFormation(properties.stat), Unit: cdk.stringToCloudFormation(properties.unit) }) : properties;
    }
    function CfnScalingPolicyMetricStatPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("metric", "Metric", CfnScalingPolicyMetricPropertyFromCloudFormation(properties.Metric)), ret.addPropertyResult("stat", "Stat", cfn_parse.FromCloudFormation.getString(properties.Stat)), ret.addPropertyResult("unit", "Unit", properties.Unit != null ? cfn_parse.FromCloudFormation.getString(properties.Unit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScalingPolicy_PredefinedMetricSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("predefinedMetricType", cdk.requiredValidator)(properties.predefinedMetricType)), errors.collect(cdk.propertyValidator("predefinedMetricType", cdk.validateString)(properties.predefinedMetricType)), errors.collect(cdk.propertyValidator("resourceLabel", cdk.validateString)(properties.resourceLabel)), errors.wrap('supplied properties not correct for "PredefinedMetricSpecificationProperty"');
    }
    function cfnScalingPolicyPredefinedMetricSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPolicy_PredefinedMetricSpecificationPropertyValidator(properties).assertSuccess(), { PredefinedMetricType: cdk.stringToCloudFormation(properties.predefinedMetricType), ResourceLabel: cdk.stringToCloudFormation(properties.resourceLabel) }) : properties;
    }
    function CfnScalingPolicyPredefinedMetricSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("predefinedMetricType", "PredefinedMetricType", cfn_parse.FromCloudFormation.getString(properties.PredefinedMetricType)), ret.addPropertyResult("resourceLabel", "ResourceLabel", properties.ResourceLabel != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceLabel) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScalingPolicy_PredictiveScalingConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxCapacityBreachBehavior", cdk.validateString)(properties.maxCapacityBreachBehavior)), errors.collect(cdk.propertyValidator("maxCapacityBuffer", cdk.validateNumber)(properties.maxCapacityBuffer)), errors.collect(cdk.propertyValidator("metricSpecifications", cdk.requiredValidator)(properties.metricSpecifications)), errors.collect(cdk.propertyValidator("metricSpecifications", cdk.listValidator(CfnScalingPolicy_PredictiveScalingMetricSpecificationPropertyValidator))(properties.metricSpecifications)), errors.collect(cdk.propertyValidator("mode", cdk.validateString)(properties.mode)), errors.collect(cdk.propertyValidator("schedulingBufferTime", cdk.validateNumber)(properties.schedulingBufferTime)), errors.wrap('supplied properties not correct for "PredictiveScalingConfigurationProperty"');
    }
    function cfnScalingPolicyPredictiveScalingConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPolicy_PredictiveScalingConfigurationPropertyValidator(properties).assertSuccess(), { MaxCapacityBreachBehavior: cdk.stringToCloudFormation(properties.maxCapacityBreachBehavior), MaxCapacityBuffer: cdk.numberToCloudFormation(properties.maxCapacityBuffer), MetricSpecifications: cdk.listMapper(cfnScalingPolicyPredictiveScalingMetricSpecificationPropertyToCloudFormation)(properties.metricSpecifications), Mode: cdk.stringToCloudFormation(properties.mode), SchedulingBufferTime: cdk.numberToCloudFormation(properties.schedulingBufferTime) }) : properties;
    }
    function CfnScalingPolicyPredictiveScalingConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxCapacityBreachBehavior", "MaxCapacityBreachBehavior", properties.MaxCapacityBreachBehavior != null ? cfn_parse.FromCloudFormation.getString(properties.MaxCapacityBreachBehavior) : void 0), ret.addPropertyResult("maxCapacityBuffer", "MaxCapacityBuffer", properties.MaxCapacityBuffer != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxCapacityBuffer) : void 0), ret.addPropertyResult("metricSpecifications", "MetricSpecifications", cfn_parse.FromCloudFormation.getArray(CfnScalingPolicyPredictiveScalingMetricSpecificationPropertyFromCloudFormation)(properties.MetricSpecifications)), ret.addPropertyResult("mode", "Mode", properties.Mode != null ? cfn_parse.FromCloudFormation.getString(properties.Mode) : void 0), ret.addPropertyResult("schedulingBufferTime", "SchedulingBufferTime", properties.SchedulingBufferTime != null ? cfn_parse.FromCloudFormation.getNumber(properties.SchedulingBufferTime) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScalingPolicy_PredictiveScalingCustomizedCapacityMetricPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("metricDataQueries", cdk.requiredValidator)(properties.metricDataQueries)), errors.collect(cdk.propertyValidator("metricDataQueries", cdk.listValidator(CfnScalingPolicy_MetricDataQueryPropertyValidator))(properties.metricDataQueries)), errors.wrap('supplied properties not correct for "PredictiveScalingCustomizedCapacityMetricProperty"');
    }
    function cfnScalingPolicyPredictiveScalingCustomizedCapacityMetricPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPolicy_PredictiveScalingCustomizedCapacityMetricPropertyValidator(properties).assertSuccess(), { MetricDataQueries: cdk.listMapper(cfnScalingPolicyMetricDataQueryPropertyToCloudFormation)(properties.metricDataQueries) }) : properties;
    }
    function CfnScalingPolicyPredictiveScalingCustomizedCapacityMetricPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("metricDataQueries", "MetricDataQueries", cfn_parse.FromCloudFormation.getArray(CfnScalingPolicyMetricDataQueryPropertyFromCloudFormation)(properties.MetricDataQueries)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScalingPolicy_PredictiveScalingCustomizedLoadMetricPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("metricDataQueries", cdk.requiredValidator)(properties.metricDataQueries)), errors.collect(cdk.propertyValidator("metricDataQueries", cdk.listValidator(CfnScalingPolicy_MetricDataQueryPropertyValidator))(properties.metricDataQueries)), errors.wrap('supplied properties not correct for "PredictiveScalingCustomizedLoadMetricProperty"');
    }
    function cfnScalingPolicyPredictiveScalingCustomizedLoadMetricPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPolicy_PredictiveScalingCustomizedLoadMetricPropertyValidator(properties).assertSuccess(), { MetricDataQueries: cdk.listMapper(cfnScalingPolicyMetricDataQueryPropertyToCloudFormation)(properties.metricDataQueries) }) : properties;
    }
    function CfnScalingPolicyPredictiveScalingCustomizedLoadMetricPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("metricDataQueries", "MetricDataQueries", cfn_parse.FromCloudFormation.getArray(CfnScalingPolicyMetricDataQueryPropertyFromCloudFormation)(properties.MetricDataQueries)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScalingPolicy_PredictiveScalingCustomizedScalingMetricPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("metricDataQueries", cdk.requiredValidator)(properties.metricDataQueries)), errors.collect(cdk.propertyValidator("metricDataQueries", cdk.listValidator(CfnScalingPolicy_MetricDataQueryPropertyValidator))(properties.metricDataQueries)), errors.wrap('supplied properties not correct for "PredictiveScalingCustomizedScalingMetricProperty"');
    }
    function cfnScalingPolicyPredictiveScalingCustomizedScalingMetricPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPolicy_PredictiveScalingCustomizedScalingMetricPropertyValidator(properties).assertSuccess(), { MetricDataQueries: cdk.listMapper(cfnScalingPolicyMetricDataQueryPropertyToCloudFormation)(properties.metricDataQueries) }) : properties;
    }
    function CfnScalingPolicyPredictiveScalingCustomizedScalingMetricPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("metricDataQueries", "MetricDataQueries", cfn_parse.FromCloudFormation.getArray(CfnScalingPolicyMetricDataQueryPropertyFromCloudFormation)(properties.MetricDataQueries)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScalingPolicy_PredictiveScalingMetricSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customizedCapacityMetricSpecification", CfnScalingPolicy_PredictiveScalingCustomizedCapacityMetricPropertyValidator)(properties.customizedCapacityMetricSpecification)), errors.collect(cdk.propertyValidator("customizedLoadMetricSpecification", CfnScalingPolicy_PredictiveScalingCustomizedLoadMetricPropertyValidator)(properties.customizedLoadMetricSpecification)), errors.collect(cdk.propertyValidator("customizedScalingMetricSpecification", CfnScalingPolicy_PredictiveScalingCustomizedScalingMetricPropertyValidator)(properties.customizedScalingMetricSpecification)), errors.collect(cdk.propertyValidator("predefinedLoadMetricSpecification", CfnScalingPolicy_PredictiveScalingPredefinedLoadMetricPropertyValidator)(properties.predefinedLoadMetricSpecification)), errors.collect(cdk.propertyValidator("predefinedMetricPairSpecification", CfnScalingPolicy_PredictiveScalingPredefinedMetricPairPropertyValidator)(properties.predefinedMetricPairSpecification)), errors.collect(cdk.propertyValidator("predefinedScalingMetricSpecification", CfnScalingPolicy_PredictiveScalingPredefinedScalingMetricPropertyValidator)(properties.predefinedScalingMetricSpecification)), errors.collect(cdk.propertyValidator("targetValue", cdk.requiredValidator)(properties.targetValue)), errors.collect(cdk.propertyValidator("targetValue", cdk.validateNumber)(properties.targetValue)), errors.wrap('supplied properties not correct for "PredictiveScalingMetricSpecificationProperty"');
    }
    function cfnScalingPolicyPredictiveScalingMetricSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPolicy_PredictiveScalingMetricSpecificationPropertyValidator(properties).assertSuccess(), { CustomizedCapacityMetricSpecification: cfnScalingPolicyPredictiveScalingCustomizedCapacityMetricPropertyToCloudFormation(properties.customizedCapacityMetricSpecification), CustomizedLoadMetricSpecification: cfnScalingPolicyPredictiveScalingCustomizedLoadMetricPropertyToCloudFormation(properties.customizedLoadMetricSpecification), CustomizedScalingMetricSpecification: cfnScalingPolicyPredictiveScalingCustomizedScalingMetricPropertyToCloudFormation(properties.customizedScalingMetricSpecification), PredefinedLoadMetricSpecification: cfnScalingPolicyPredictiveScalingPredefinedLoadMetricPropertyToCloudFormation(properties.predefinedLoadMetricSpecification), PredefinedMetricPairSpecification: cfnScalingPolicyPredictiveScalingPredefinedMetricPairPropertyToCloudFormation(properties.predefinedMetricPairSpecification), PredefinedScalingMetricSpecification: cfnScalingPolicyPredictiveScalingPredefinedScalingMetricPropertyToCloudFormation(properties.predefinedScalingMetricSpecification), TargetValue: cdk.numberToCloudFormation(properties.targetValue) }) : properties;
    }
    function CfnScalingPolicyPredictiveScalingMetricSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customizedCapacityMetricSpecification", "CustomizedCapacityMetricSpecification", properties.CustomizedCapacityMetricSpecification != null ? CfnScalingPolicyPredictiveScalingCustomizedCapacityMetricPropertyFromCloudFormation(properties.CustomizedCapacityMetricSpecification) : void 0), ret.addPropertyResult("customizedLoadMetricSpecification", "CustomizedLoadMetricSpecification", properties.CustomizedLoadMetricSpecification != null ? CfnScalingPolicyPredictiveScalingCustomizedLoadMetricPropertyFromCloudFormation(properties.CustomizedLoadMetricSpecification) : void 0), ret.addPropertyResult("customizedScalingMetricSpecification", "CustomizedScalingMetricSpecification", properties.CustomizedScalingMetricSpecification != null ? CfnScalingPolicyPredictiveScalingCustomizedScalingMetricPropertyFromCloudFormation(properties.CustomizedScalingMetricSpecification) : void 0), ret.addPropertyResult("predefinedLoadMetricSpecification", "PredefinedLoadMetricSpecification", properties.PredefinedLoadMetricSpecification != null ? CfnScalingPolicyPredictiveScalingPredefinedLoadMetricPropertyFromCloudFormation(properties.PredefinedLoadMetricSpecification) : void 0), ret.addPropertyResult("predefinedMetricPairSpecification", "PredefinedMetricPairSpecification", properties.PredefinedMetricPairSpecification != null ? CfnScalingPolicyPredictiveScalingPredefinedMetricPairPropertyFromCloudFormation(properties.PredefinedMetricPairSpecification) : void 0), ret.addPropertyResult("predefinedScalingMetricSpecification", "PredefinedScalingMetricSpecification", properties.PredefinedScalingMetricSpecification != null ? CfnScalingPolicyPredictiveScalingPredefinedScalingMetricPropertyFromCloudFormation(properties.PredefinedScalingMetricSpecification) : void 0), ret.addPropertyResult("targetValue", "TargetValue", cfn_parse.FromCloudFormation.getNumber(properties.TargetValue)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScalingPolicy_PredictiveScalingPredefinedLoadMetricPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("predefinedMetricType", cdk.requiredValidator)(properties.predefinedMetricType)), errors.collect(cdk.propertyValidator("predefinedMetricType", cdk.validateString)(properties.predefinedMetricType)), errors.collect(cdk.propertyValidator("resourceLabel", cdk.validateString)(properties.resourceLabel)), errors.wrap('supplied properties not correct for "PredictiveScalingPredefinedLoadMetricProperty"');
    }
    function cfnScalingPolicyPredictiveScalingPredefinedLoadMetricPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPolicy_PredictiveScalingPredefinedLoadMetricPropertyValidator(properties).assertSuccess(), { PredefinedMetricType: cdk.stringToCloudFormation(properties.predefinedMetricType), ResourceLabel: cdk.stringToCloudFormation(properties.resourceLabel) }) : properties;
    }
    function CfnScalingPolicyPredictiveScalingPredefinedLoadMetricPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("predefinedMetricType", "PredefinedMetricType", cfn_parse.FromCloudFormation.getString(properties.PredefinedMetricType)), ret.addPropertyResult("resourceLabel", "ResourceLabel", properties.ResourceLabel != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceLabel) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScalingPolicy_PredictiveScalingPredefinedMetricPairPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("predefinedMetricType", cdk.requiredValidator)(properties.predefinedMetricType)), errors.collect(cdk.propertyValidator("predefinedMetricType", cdk.validateString)(properties.predefinedMetricType)), errors.collect(cdk.propertyValidator("resourceLabel", cdk.validateString)(properties.resourceLabel)), errors.wrap('supplied properties not correct for "PredictiveScalingPredefinedMetricPairProperty"');
    }
    function cfnScalingPolicyPredictiveScalingPredefinedMetricPairPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPolicy_PredictiveScalingPredefinedMetricPairPropertyValidator(properties).assertSuccess(), { PredefinedMetricType: cdk.stringToCloudFormation(properties.predefinedMetricType), ResourceLabel: cdk.stringToCloudFormation(properties.resourceLabel) }) : properties;
    }
    function CfnScalingPolicyPredictiveScalingPredefinedMetricPairPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("predefinedMetricType", "PredefinedMetricType", cfn_parse.FromCloudFormation.getString(properties.PredefinedMetricType)), ret.addPropertyResult("resourceLabel", "ResourceLabel", properties.ResourceLabel != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceLabel) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScalingPolicy_PredictiveScalingPredefinedScalingMetricPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("predefinedMetricType", cdk.requiredValidator)(properties.predefinedMetricType)), errors.collect(cdk.propertyValidator("predefinedMetricType", cdk.validateString)(properties.predefinedMetricType)), errors.collect(cdk.propertyValidator("resourceLabel", cdk.validateString)(properties.resourceLabel)), errors.wrap('supplied properties not correct for "PredictiveScalingPredefinedScalingMetricProperty"');
    }
    function cfnScalingPolicyPredictiveScalingPredefinedScalingMetricPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPolicy_PredictiveScalingPredefinedScalingMetricPropertyValidator(properties).assertSuccess(), { PredefinedMetricType: cdk.stringToCloudFormation(properties.predefinedMetricType), ResourceLabel: cdk.stringToCloudFormation(properties.resourceLabel) }) : properties;
    }
    function CfnScalingPolicyPredictiveScalingPredefinedScalingMetricPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("predefinedMetricType", "PredefinedMetricType", cfn_parse.FromCloudFormation.getString(properties.PredefinedMetricType)), ret.addPropertyResult("resourceLabel", "ResourceLabel", properties.ResourceLabel != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceLabel) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScalingPolicy_StepAdjustmentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("metricIntervalLowerBound", cdk.validateNumber)(properties.metricIntervalLowerBound)), errors.collect(cdk.propertyValidator("metricIntervalUpperBound", cdk.validateNumber)(properties.metricIntervalUpperBound)), errors.collect(cdk.propertyValidator("scalingAdjustment", cdk.requiredValidator)(properties.scalingAdjustment)), errors.collect(cdk.propertyValidator("scalingAdjustment", cdk.validateNumber)(properties.scalingAdjustment)), errors.wrap('supplied properties not correct for "StepAdjustmentProperty"');
    }
    function cfnScalingPolicyStepAdjustmentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPolicy_StepAdjustmentPropertyValidator(properties).assertSuccess(), { MetricIntervalLowerBound: cdk.numberToCloudFormation(properties.metricIntervalLowerBound), MetricIntervalUpperBound: cdk.numberToCloudFormation(properties.metricIntervalUpperBound), ScalingAdjustment: cdk.numberToCloudFormation(properties.scalingAdjustment) }) : properties;
    }
    function CfnScalingPolicyStepAdjustmentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("metricIntervalLowerBound", "MetricIntervalLowerBound", properties.MetricIntervalLowerBound != null ? cfn_parse.FromCloudFormation.getNumber(properties.MetricIntervalLowerBound) : void 0), ret.addPropertyResult("metricIntervalUpperBound", "MetricIntervalUpperBound", properties.MetricIntervalUpperBound != null ? cfn_parse.FromCloudFormation.getNumber(properties.MetricIntervalUpperBound) : void 0), ret.addPropertyResult("scalingAdjustment", "ScalingAdjustment", cfn_parse.FromCloudFormation.getNumber(properties.ScalingAdjustment)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScalingPolicy_TargetTrackingConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customizedMetricSpecification", CfnScalingPolicy_CustomizedMetricSpecificationPropertyValidator)(properties.customizedMetricSpecification)), errors.collect(cdk.propertyValidator("disableScaleIn", cdk.validateBoolean)(properties.disableScaleIn)), errors.collect(cdk.propertyValidator("predefinedMetricSpecification", CfnScalingPolicy_PredefinedMetricSpecificationPropertyValidator)(properties.predefinedMetricSpecification)), errors.collect(cdk.propertyValidator("targetValue", cdk.requiredValidator)(properties.targetValue)), errors.collect(cdk.propertyValidator("targetValue", cdk.validateNumber)(properties.targetValue)), errors.wrap('supplied properties not correct for "TargetTrackingConfigurationProperty"');
    }
    function cfnScalingPolicyTargetTrackingConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPolicy_TargetTrackingConfigurationPropertyValidator(properties).assertSuccess(), { CustomizedMetricSpecification: cfnScalingPolicyCustomizedMetricSpecificationPropertyToCloudFormation(properties.customizedMetricSpecification), DisableScaleIn: cdk.booleanToCloudFormation(properties.disableScaleIn), PredefinedMetricSpecification: cfnScalingPolicyPredefinedMetricSpecificationPropertyToCloudFormation(properties.predefinedMetricSpecification), TargetValue: cdk.numberToCloudFormation(properties.targetValue) }) : properties;
    }
    function CfnScalingPolicyTargetTrackingConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customizedMetricSpecification", "CustomizedMetricSpecification", properties.CustomizedMetricSpecification != null ? CfnScalingPolicyCustomizedMetricSpecificationPropertyFromCloudFormation(properties.CustomizedMetricSpecification) : void 0), ret.addPropertyResult("disableScaleIn", "DisableScaleIn", properties.DisableScaleIn != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DisableScaleIn) : void 0), ret.addPropertyResult("predefinedMetricSpecification", "PredefinedMetricSpecification", properties.PredefinedMetricSpecification != null ? CfnScalingPolicyPredefinedMetricSpecificationPropertyFromCloudFormation(properties.PredefinedMetricSpecification) : void 0), ret.addPropertyResult("targetValue", "TargetValue", cfn_parse.FromCloudFormation.getNumber(properties.TargetValue)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScheduledActionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoScalingGroupName", cdk.requiredValidator)(properties.autoScalingGroupName)), errors.collect(cdk.propertyValidator("autoScalingGroupName", cdk.validateString)(properties.autoScalingGroupName)), errors.collect(cdk.propertyValidator("desiredCapacity", cdk.validateNumber)(properties.desiredCapacity)), errors.collect(cdk.propertyValidator("endTime", cdk.validateString)(properties.endTime)), errors.collect(cdk.propertyValidator("maxSize", cdk.validateNumber)(properties.maxSize)), errors.collect(cdk.propertyValidator("minSize", cdk.validateNumber)(properties.minSize)), errors.collect(cdk.propertyValidator("recurrence", cdk.validateString)(properties.recurrence)), errors.collect(cdk.propertyValidator("startTime", cdk.validateString)(properties.startTime)), errors.collect(cdk.propertyValidator("timeZone", cdk.validateString)(properties.timeZone)), errors.wrap('supplied properties not correct for "CfnScheduledActionProps"');
    }
    function cfnScheduledActionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScheduledActionPropsValidator(properties).assertSuccess(), { AutoScalingGroupName: cdk.stringToCloudFormation(properties.autoScalingGroupName), DesiredCapacity: cdk.numberToCloudFormation(properties.desiredCapacity), EndTime: cdk.stringToCloudFormation(properties.endTime), MaxSize: cdk.numberToCloudFormation(properties.maxSize), MinSize: cdk.numberToCloudFormation(properties.minSize), Recurrence: cdk.stringToCloudFormation(properties.recurrence), StartTime: cdk.stringToCloudFormation(properties.startTime), TimeZone: cdk.stringToCloudFormation(properties.timeZone) }) : properties;
    }
    function CfnScheduledActionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("autoScalingGroupName", "AutoScalingGroupName", cfn_parse.FromCloudFormation.getString(properties.AutoScalingGroupName)), ret.addPropertyResult("desiredCapacity", "DesiredCapacity", properties.DesiredCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.DesiredCapacity) : void 0), ret.addPropertyResult("endTime", "EndTime", properties.EndTime != null ? cfn_parse.FromCloudFormation.getString(properties.EndTime) : void 0), ret.addPropertyResult("maxSize", "MaxSize", properties.MaxSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxSize) : void 0), ret.addPropertyResult("minSize", "MinSize", properties.MinSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinSize) : void 0), ret.addPropertyResult("recurrence", "Recurrence", properties.Recurrence != null ? cfn_parse.FromCloudFormation.getString(properties.Recurrence) : void 0), ret.addPropertyResult("startTime", "StartTime", properties.StartTime != null ? cfn_parse.FromCloudFormation.getString(properties.StartTime) : void 0), ret.addPropertyResult("timeZone", "TimeZone", properties.TimeZone != null ? cfn_parse.FromCloudFormation.getString(properties.TimeZone) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnScheduledAction = class _CfnScheduledAction extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnScheduledActionPropsFromCloudFormation(resourceProperties), ret = new _CfnScheduledAction(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnScheduledAction.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_CfnScheduledActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnScheduledAction), error;
        }
        cdk.requireProperty(props, "autoScalingGroupName", this), this.attrScheduledActionName = cdk.Token.asString(this.getAtt("ScheduledActionName", cdk.ResolutionTypeHint.STRING)), this.autoScalingGroupName = props.autoScalingGroupName, this.desiredCapacity = props.desiredCapacity, this.endTime = props.endTime, this.maxSize = props.maxSize, this.minSize = props.minSize, this.recurrence = props.recurrence, this.startTime = props.startTime, this.timeZone = props.timeZone;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnScheduledAction.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { autoScalingGroupName: this.autoScalingGroupName, desiredCapacity: this.desiredCapacity, endTime: this.endTime, maxSize: this.maxSize, minSize: this.minSize, recurrence: this.recurrence, startTime: this.startTime, timeZone: this.timeZone };
      }
      renderProperties(props) {
        return cfnScheduledActionPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnScheduledAction[_e] = { fqn: "aws-cdk-lib.aws_autoscaling.CfnScheduledAction", version: "2.80.0" }, CfnScheduledAction.CFN_RESOURCE_TYPE_NAME = "AWS::AutoScaling::ScheduledAction", exports2.CfnScheduledAction = CfnScheduledAction;
    function CfnWarmPoolPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoScalingGroupName", cdk.requiredValidator)(properties.autoScalingGroupName)), errors.collect(cdk.propertyValidator("autoScalingGroupName", cdk.validateString)(properties.autoScalingGroupName)), errors.collect(cdk.propertyValidator("instanceReusePolicy", CfnWarmPool_InstanceReusePolicyPropertyValidator)(properties.instanceReusePolicy)), errors.collect(cdk.propertyValidator("maxGroupPreparedCapacity", cdk.validateNumber)(properties.maxGroupPreparedCapacity)), errors.collect(cdk.propertyValidator("minSize", cdk.validateNumber)(properties.minSize)), errors.collect(cdk.propertyValidator("poolState", cdk.validateString)(properties.poolState)), errors.wrap('supplied properties not correct for "CfnWarmPoolProps"');
    }
    function cfnWarmPoolPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWarmPoolPropsValidator(properties).assertSuccess(), { AutoScalingGroupName: cdk.stringToCloudFormation(properties.autoScalingGroupName), InstanceReusePolicy: cfnWarmPoolInstanceReusePolicyPropertyToCloudFormation(properties.instanceReusePolicy), MaxGroupPreparedCapacity: cdk.numberToCloudFormation(properties.maxGroupPreparedCapacity), MinSize: cdk.numberToCloudFormation(properties.minSize), PoolState: cdk.stringToCloudFormation(properties.poolState) }) : properties;
    }
    function CfnWarmPoolPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("autoScalingGroupName", "AutoScalingGroupName", cfn_parse.FromCloudFormation.getString(properties.AutoScalingGroupName)), ret.addPropertyResult("instanceReusePolicy", "InstanceReusePolicy", properties.InstanceReusePolicy != null ? CfnWarmPoolInstanceReusePolicyPropertyFromCloudFormation(properties.InstanceReusePolicy) : void 0), ret.addPropertyResult("maxGroupPreparedCapacity", "MaxGroupPreparedCapacity", properties.MaxGroupPreparedCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxGroupPreparedCapacity) : void 0), ret.addPropertyResult("minSize", "MinSize", properties.MinSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinSize) : void 0), ret.addPropertyResult("poolState", "PoolState", properties.PoolState != null ? cfn_parse.FromCloudFormation.getString(properties.PoolState) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnWarmPool = class _CfnWarmPool extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnWarmPoolPropsFromCloudFormation(resourceProperties), ret = new _CfnWarmPool(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnWarmPool.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_CfnWarmPoolProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnWarmPool), error;
        }
        cdk.requireProperty(props, "autoScalingGroupName", this), this.autoScalingGroupName = props.autoScalingGroupName, this.instanceReusePolicy = props.instanceReusePolicy, this.maxGroupPreparedCapacity = props.maxGroupPreparedCapacity, this.minSize = props.minSize, this.poolState = props.poolState;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnWarmPool.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { autoScalingGroupName: this.autoScalingGroupName, instanceReusePolicy: this.instanceReusePolicy, maxGroupPreparedCapacity: this.maxGroupPreparedCapacity, minSize: this.minSize, poolState: this.poolState };
      }
      renderProperties(props) {
        return cfnWarmPoolPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnWarmPool[_f] = { fqn: "aws-cdk-lib.aws_autoscaling.CfnWarmPool", version: "2.80.0" }, CfnWarmPool.CFN_RESOURCE_TYPE_NAME = "AWS::AutoScaling::WarmPool", exports2.CfnWarmPool = CfnWarmPool;
    function CfnWarmPool_InstanceReusePolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("reuseOnScaleIn", cdk.validateBoolean)(properties.reuseOnScaleIn)), errors.wrap('supplied properties not correct for "InstanceReusePolicyProperty"');
    }
    function cfnWarmPoolInstanceReusePolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWarmPool_InstanceReusePolicyPropertyValidator(properties).assertSuccess(), { ReuseOnScaleIn: cdk.booleanToCloudFormation(properties.reuseOnScaleIn) }) : properties;
    }
    function CfnWarmPoolInstanceReusePolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("reuseOnScaleIn", "ReuseOnScaleIn", properties.ReuseOnScaleIn != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ReuseOnScaleIn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-autoscaling/lib/lifecycle-hook.js
var require_lifecycle_hook = __commonJS({
  "node_modules/aws-cdk-lib/aws-autoscaling/lib/lifecycle-hook.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LifecycleTransition = exports2.DefaultResult = exports2.LifecycleHook = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var autoscaling_generated_1 = require_autoscaling_generated();
    var core_1 = require_core2();
    var LifecycleHook = class _LifecycleHook extends core_1.Resource {
      get role() {
        if (!this._role)
          throw new Error("'role' is undefined. Please specify a 'role' or specify a 'notificationTarget' to have a role provided for you.");
        return this._role;
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.lifecycleHookName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_LifecycleHookProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _LifecycleHook), error;
        }
        const targetProps = props.notificationTarget ? props.notificationTarget.bind(this, { lifecycleHook: this, role: props.role }) : void 0;
        if (props.role) {
          if (this._role = props.role, !props.notificationTarget)
            throw new Error("'notificationTarget' parameter required when 'role' parameter is specified");
        } else
          this._role = targetProps ? targetProps.createdRole : void 0;
        const l1NotificationTargetArn = targetProps ? targetProps.notificationTargetArn : void 0, l1RoleArn = this._role ? this.role.roleArn : void 0, resource = new autoscaling_generated_1.CfnLifecycleHook(this, "Resource", { autoScalingGroupName: props.autoScalingGroup.autoScalingGroupName, defaultResult: props.defaultResult, heartbeatTimeout: props.heartbeatTimeout && props.heartbeatTimeout.toSeconds(), lifecycleHookName: this.physicalName, lifecycleTransition: props.lifecycleTransition, notificationMetadata: props.notificationMetadata, notificationTargetArn: l1NotificationTargetArn, roleArn: l1RoleArn });
        this._role && resource.node.addDependency(this.role), this.lifecycleHookName = resource.ref;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LifecycleHook[_a] = { fqn: "aws-cdk-lib.aws_autoscaling.LifecycleHook", version: "2.80.0" }, exports2.LifecycleHook = LifecycleHook;
    var DefaultResult;
    (function(DefaultResult2) {
      DefaultResult2.CONTINUE = "CONTINUE", DefaultResult2.ABANDON = "ABANDON";
    })(DefaultResult = exports2.DefaultResult || (exports2.DefaultResult = {}));
    var LifecycleTransition;
    (function(LifecycleTransition2) {
      LifecycleTransition2.INSTANCE_LAUNCHING = "autoscaling:EC2_INSTANCE_LAUNCHING", LifecycleTransition2.INSTANCE_TERMINATING = "autoscaling:EC2_INSTANCE_TERMINATING";
    })(LifecycleTransition = exports2.LifecycleTransition || (exports2.LifecycleTransition = {}));
  }
});

// node_modules/aws-cdk-lib/aws-autoscaling/lib/scheduled-action.js
var require_scheduled_action = __commonJS({
  "node_modules/aws-cdk-lib/aws-autoscaling/lib/scheduled-action.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ScheduledAction = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var autoscaling_generated_1 = require_autoscaling_generated();
    var core_1 = require_core2();
    var ScheduledAction = class _ScheduledAction extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_ScheduledActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ScheduledAction), error;
        }
        if (props.minCapacity === void 0 && props.maxCapacity === void 0 && props.desiredCapacity === void 0)
          throw new Error("At least one of minCapacity, maxCapacity, or desiredCapacity is required");
        props.schedule._bind(this);
        const resource = new autoscaling_generated_1.CfnScheduledAction(this, "Resource", { autoScalingGroupName: props.autoScalingGroup.autoScalingGroupName, startTime: formatISO(props.startTime), endTime: formatISO(props.endTime), minSize: props.minCapacity, maxSize: props.maxCapacity, desiredCapacity: props.desiredCapacity, recurrence: props.schedule.expressionString, timeZone: props.timeZone });
        this.scheduledActionName = resource.attrScheduledActionName;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ScheduledAction[_a] = { fqn: "aws-cdk-lib.aws_autoscaling.ScheduledAction", version: "2.80.0" }, exports2.ScheduledAction = ScheduledAction;
    function formatISO(date) {
      if (!date)
        return;
      return date.getUTCFullYear() + "-" + pad(date.getUTCMonth() + 1) + "-" + pad(date.getUTCDate()) + "T" + pad(date.getUTCHours()) + ":" + pad(date.getUTCMinutes()) + ":" + pad(date.getUTCSeconds()) + "Z";
      function pad(num) {
        return num < 10 ? "0" + num : num;
      }
    }
  }
});

// node_modules/aws-cdk-lib/aws-autoscaling/lib/step-scaling-action.js
var require_step_scaling_action2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-autoscaling/lib/step-scaling-action.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.MetricAggregationType = exports2.AdjustmentType = exports2.StepScalingAction = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var autoscaling_generated_1 = require_autoscaling_generated();
    var core_1 = require_core2();
    var StepScalingAction = class _StepScalingAction extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id), this.adjustments = new Array();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_StepScalingActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _StepScalingAction), error;
        }
        const resource = new autoscaling_generated_1.CfnScalingPolicy(this, "Resource", { policyType: "StepScaling", autoScalingGroupName: props.autoScalingGroup.autoScalingGroupName, cooldown: props.cooldown && props.cooldown.toSeconds().toString(), estimatedInstanceWarmup: props.estimatedInstanceWarmup && props.estimatedInstanceWarmup.toSeconds(), adjustmentType: props.adjustmentType, minAdjustmentMagnitude: props.minAdjustmentMagnitude, metricAggregationType: props.metricAggregationType, stepAdjustments: core_1.Lazy.any({ produce: () => this.adjustments }) });
        this.scalingPolicyArn = resource.ref;
      }
      addAdjustment(adjustment) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_AdjustmentTier(adjustment);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addAdjustment), error;
        }
        if (adjustment.lowerBound === void 0 && adjustment.upperBound === void 0)
          throw new Error("At least one of lowerBound or upperBound is required");
        this.adjustments.push({ metricIntervalLowerBound: adjustment.lowerBound, metricIntervalUpperBound: adjustment.upperBound, scalingAdjustment: adjustment.adjustment });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, StepScalingAction[_a] = { fqn: "aws-cdk-lib.aws_autoscaling.StepScalingAction", version: "2.80.0" }, exports2.StepScalingAction = StepScalingAction;
    var AdjustmentType;
    (function(AdjustmentType2) {
      AdjustmentType2.CHANGE_IN_CAPACITY = "ChangeInCapacity", AdjustmentType2.PERCENT_CHANGE_IN_CAPACITY = "PercentChangeInCapacity", AdjustmentType2.EXACT_CAPACITY = "ExactCapacity";
    })(AdjustmentType = exports2.AdjustmentType || (exports2.AdjustmentType = {}));
    var MetricAggregationType;
    (function(MetricAggregationType2) {
      MetricAggregationType2.AVERAGE = "Average", MetricAggregationType2.MINIMUM = "Minimum", MetricAggregationType2.MAXIMUM = "Maximum";
    })(MetricAggregationType = exports2.MetricAggregationType || (exports2.MetricAggregationType = {}));
  }
});

// node_modules/aws-cdk-lib/aws-autoscaling/lib/step-scaling-policy.js
var require_step_scaling_policy2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-autoscaling/lib/step-scaling-policy.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.StepScalingPolicy = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var step_scaling_action_1 = require_step_scaling_action2();
    var aws_autoscaling_common_1 = require_aws_autoscaling_common();
    var cloudwatch = require_aws_cloudwatch();
    var StepScalingPolicy = class _StepScalingPolicy extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_StepScalingPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _StepScalingPolicy), error;
        }
        if (props.scalingSteps.length < 2)
          throw new Error("You must supply at least 2 intervals for autoscaling");
        const changesAreAbsolute = (props.adjustmentType || step_scaling_action_1.AdjustmentType.CHANGE_IN_CAPACITY) === step_scaling_action_1.AdjustmentType.EXACT_CAPACITY, intervals = (0, aws_autoscaling_common_1.normalizeIntervals)(props.scalingSteps, changesAreAbsolute), alarms = (0, aws_autoscaling_common_1.findAlarmThresholds)(intervals);
        if (alarms.lowerAlarmIntervalIndex !== void 0) {
          const threshold = intervals[alarms.lowerAlarmIntervalIndex].upper;
          this.lowerAction = new step_scaling_action_1.StepScalingAction(this, "LowerPolicy", { adjustmentType: props.adjustmentType, cooldown: props.cooldown, estimatedInstanceWarmup: props.estimatedInstanceWarmup, metricAggregationType: props.metricAggregationType ?? aggregationTypeFromMetric(props.metric), minAdjustmentMagnitude: props.minAdjustmentMagnitude, autoScalingGroup: props.autoScalingGroup });
          for (let i = alarms.lowerAlarmIntervalIndex; i >= 0; i--)
            this.lowerAction.addAdjustment({ adjustment: intervals[i].change, lowerBound: i !== 0 ? intervals[i].lower - threshold : void 0, upperBound: intervals[i].upper - threshold });
          this.lowerAlarm = new cloudwatch.Alarm(this, "LowerAlarm", { metric: props.metric, alarmDescription: "Lower threshold scaling alarm", comparisonOperator: cloudwatch.ComparisonOperator.LESS_THAN_OR_EQUAL_TO_THRESHOLD, evaluationPeriods: props.evaluationPeriods ?? 1, threshold }), this.lowerAlarm.addAlarmAction(new StepScalingAlarmAction(this.lowerAction));
        }
        if (alarms.upperAlarmIntervalIndex !== void 0) {
          const threshold = intervals[alarms.upperAlarmIntervalIndex].lower;
          this.upperAction = new step_scaling_action_1.StepScalingAction(this, "UpperPolicy", { adjustmentType: props.adjustmentType, cooldown: props.cooldown, estimatedInstanceWarmup: props.estimatedInstanceWarmup, metricAggregationType: props.metricAggregationType ?? aggregationTypeFromMetric(props.metric), minAdjustmentMagnitude: props.minAdjustmentMagnitude, autoScalingGroup: props.autoScalingGroup });
          for (let i = alarms.upperAlarmIntervalIndex; i < intervals.length; i++)
            this.upperAction.addAdjustment({ adjustment: intervals[i].change, lowerBound: intervals[i].lower - threshold, upperBound: i !== intervals.length - 1 ? intervals[i].upper - threshold : void 0 });
          this.upperAlarm = new cloudwatch.Alarm(this, "UpperAlarm", { metric: props.metric, alarmDescription: "Upper threshold scaling alarm", comparisonOperator: cloudwatch.ComparisonOperator.GREATER_THAN_OR_EQUAL_TO_THRESHOLD, evaluationPeriods: props.evaluationPeriods ?? 1, threshold }), this.upperAlarm.addAlarmAction(new StepScalingAlarmAction(this.upperAction));
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, StepScalingPolicy[_a] = { fqn: "aws-cdk-lib.aws_autoscaling.StepScalingPolicy", version: "2.80.0" }, exports2.StepScalingPolicy = StepScalingPolicy;
    function aggregationTypeFromMetric(metric) {
      const statistic = metric.toMetricConfig().metricStat?.statistic;
      if (statistic !== void 0)
        switch (statistic) {
          case "Average":
            return step_scaling_action_1.MetricAggregationType.AVERAGE;
          case "Minimum":
            return step_scaling_action_1.MetricAggregationType.MINIMUM;
          case "Maximum":
            return step_scaling_action_1.MetricAggregationType.MAXIMUM;
          default:
            return step_scaling_action_1.MetricAggregationType.AVERAGE;
        }
    }
    var StepScalingAlarmAction = class {
      constructor(stepScalingAction) {
        this.stepScalingAction = stepScalingAction;
      }
      bind(_scope, _alarm) {
        return { alarmActionArn: this.stepScalingAction.scalingPolicyArn };
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-autoscaling/lib/target-tracking-scaling-policy.js
var require_target_tracking_scaling_policy2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-autoscaling/lib/target-tracking-scaling-policy.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PredefinedMetric = exports2.TargetTrackingScalingPolicy = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var autoscaling_generated_1 = require_autoscaling_generated();
    var TargetTrackingScalingPolicy = class _TargetTrackingScalingPolicy extends constructs_1.Construct {
      constructor(scope, id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_TargetTrackingScalingPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _TargetTrackingScalingPolicy), error;
        }
        if (props.customMetric === void 0 == (props.predefinedMetric === void 0))
          throw new Error("Exactly one of 'customMetric' or 'predefinedMetric' must be specified.");
        if (props.predefinedMetric === PredefinedMetric.ALB_REQUEST_COUNT_PER_TARGET && !props.resourceLabel)
          throw new Error("When tracking the ALBRequestCountPerTarget metric, the ALB identifier must be supplied in resourceLabel");
        if (props.customMetric && !props.customMetric.toMetricConfig().metricStat)
          throw new Error("Only direct metrics are supported for Target Tracking. Use Step Scaling or supply a Metric object.");
        super(scope, id), this.resource = new autoscaling_generated_1.CfnScalingPolicy(this, "Resource", { policyType: "TargetTrackingScaling", autoScalingGroupName: props.autoScalingGroup.autoScalingGroupName, cooldown: props.cooldown && props.cooldown.toSeconds().toString(), estimatedInstanceWarmup: props.estimatedInstanceWarmup && props.estimatedInstanceWarmup.toSeconds(), targetTrackingConfiguration: { customizedMetricSpecification: renderCustomMetric(props.customMetric), disableScaleIn: props.disableScaleIn, predefinedMetricSpecification: props.predefinedMetric !== void 0 ? { predefinedMetricType: props.predefinedMetric, resourceLabel: props.resourceLabel } : void 0, targetValue: props.targetValue } }), this.scalingPolicyArn = this.resource.ref;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, TargetTrackingScalingPolicy[_a] = { fqn: "aws-cdk-lib.aws_autoscaling.TargetTrackingScalingPolicy", version: "2.80.0" }, exports2.TargetTrackingScalingPolicy = TargetTrackingScalingPolicy;
    function renderCustomMetric(metric) {
      if (!metric)
        return;
      const c = metric.toMetricConfig().metricStat;
      return { dimensions: c.dimensions, metricName: c.metricName, namespace: c.namespace, statistic: c.statistic, unit: c.unitFilter };
    }
    var PredefinedMetric;
    (function(PredefinedMetric2) {
      PredefinedMetric2.ASG_AVERAGE_CPU_UTILIZATION = "ASGAverageCPUUtilization", PredefinedMetric2.ASG_AVERAGE_NETWORK_IN = "ASGAverageNetworkIn", PredefinedMetric2.ASG_AVERAGE_NETWORK_OUT = "ASGAverageNetworkOut", PredefinedMetric2.ALB_REQUEST_COUNT_PER_TARGET = "ALBRequestCountPerTarget";
    })(PredefinedMetric = exports2.PredefinedMetric || (exports2.PredefinedMetric = {}));
  }
});

// node_modules/aws-cdk-lib/aws-autoscaling/lib/volume.js
var require_volume2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-autoscaling/lib/volume.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EbsDeviceVolumeType = exports2.BlockDeviceVolume = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var BlockDeviceVolume = class _BlockDeviceVolume {
      static ebs(volumeSize, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_EbsDeviceOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.ebs), error;
        }
        return new this({ ...options, volumeSize });
      }
      static ebsFromSnapshot(snapshotId, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_EbsDeviceSnapshotOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.ebsFromSnapshot), error;
        }
        return new this({ ...options, snapshotId });
      }
      static ephemeral(volumeIndex) {
        if (volumeIndex < 0)
          throw new Error(`volumeIndex must be a number starting from 0, got "${volumeIndex}"`);
        return new this(void 0, `ephemeral${volumeIndex}`);
      }
      static noDevice() {
        return this._NO_DEVICE;
      }
      constructor(ebsDevice, virtualName) {
        this.ebsDevice = ebsDevice, this.virtualName = virtualName;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_EbsDeviceProps(ebsDevice);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _BlockDeviceVolume), error;
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, BlockDeviceVolume[_a] = { fqn: "aws-cdk-lib.aws_autoscaling.BlockDeviceVolume", version: "2.80.0" }, BlockDeviceVolume._NO_DEVICE = new BlockDeviceVolume(), exports2.BlockDeviceVolume = BlockDeviceVolume;
    var EbsDeviceVolumeType;
    (function(EbsDeviceVolumeType2) {
      EbsDeviceVolumeType2.STANDARD = "standard", EbsDeviceVolumeType2.IO1 = "io1", EbsDeviceVolumeType2.GP2 = "gp2", EbsDeviceVolumeType2.GP3 = "gp3", EbsDeviceVolumeType2.ST1 = "st1", EbsDeviceVolumeType2.SC1 = "sc1";
    })(EbsDeviceVolumeType = exports2.EbsDeviceVolumeType || (exports2.EbsDeviceVolumeType = {}));
  }
});

// node_modules/aws-cdk-lib/aws-autoscaling/lib/warm-pool.js
var require_warm_pool = __commonJS({
  "node_modules/aws-cdk-lib/aws-autoscaling/lib/warm-pool.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PoolState = exports2.WarmPool = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var autoscaling_generated_1 = require_autoscaling_generated();
    var core_1 = require_core2();
    var WarmPool = class _WarmPool extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id, { physicalName: core_1.Lazy.string({ produce: () => core_1.Names.uniqueId(this) }) });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_WarmPoolProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _WarmPool), error;
        }
        if (props.maxGroupPreparedCapacity && props.maxGroupPreparedCapacity < -1)
          throw new Error("'maxGroupPreparedCapacity' parameter should be greater than or equal to -1");
        if (props.minSize && props.minSize < 0)
          throw new Error("'minSize' parameter should be greater than or equal to 0");
        new autoscaling_generated_1.CfnWarmPool(this, "Resource", { autoScalingGroupName: props.autoScalingGroup.autoScalingGroupName, instanceReusePolicy: props.reuseOnScaleIn !== void 0 ? { reuseOnScaleIn: props.reuseOnScaleIn } : void 0, maxGroupPreparedCapacity: props.maxGroupPreparedCapacity, minSize: props.minSize, poolState: props.poolState });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, WarmPool[_a] = { fqn: "aws-cdk-lib.aws_autoscaling.WarmPool", version: "2.80.0" }, exports2.WarmPool = WarmPool;
    var PoolState;
    (function(PoolState2) {
      PoolState2.HIBERNATED = "Hibernated", PoolState2.RUNNING = "Running", PoolState2.STOPPED = "Stopped";
    })(PoolState = exports2.PoolState || (exports2.PoolState = {}));
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/elasticloadbalancingv2.generated.js
var require_elasticloadbalancingv2_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/elasticloadbalancingv2.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnTargetGroup = exports2.CfnLoadBalancer = exports2.CfnListenerRule = exports2.CfnListenerCertificate = exports2.CfnListener = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnListenerPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alpnPolicy", cdk.listValidator(cdk.validateString))(properties.alpnPolicy)), errors.collect(cdk.propertyValidator("certificates", cdk.listValidator(CfnListener_CertificatePropertyValidator))(properties.certificates)), errors.collect(cdk.propertyValidator("defaultActions", cdk.requiredValidator)(properties.defaultActions)), errors.collect(cdk.propertyValidator("defaultActions", cdk.listValidator(CfnListener_ActionPropertyValidator))(properties.defaultActions)), errors.collect(cdk.propertyValidator("loadBalancerArn", cdk.requiredValidator)(properties.loadBalancerArn)), errors.collect(cdk.propertyValidator("loadBalancerArn", cdk.validateString)(properties.loadBalancerArn)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.collect(cdk.propertyValidator("sslPolicy", cdk.validateString)(properties.sslPolicy)), errors.wrap('supplied properties not correct for "CfnListenerProps"');
    }
    function cfnListenerPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListenerPropsValidator(properties).assertSuccess(), { DefaultActions: cdk.listMapper(cfnListenerActionPropertyToCloudFormation)(properties.defaultActions), LoadBalancerArn: cdk.stringToCloudFormation(properties.loadBalancerArn), AlpnPolicy: cdk.listMapper(cdk.stringToCloudFormation)(properties.alpnPolicy), Certificates: cdk.listMapper(cfnListenerCertificatePropertyToCloudFormation)(properties.certificates), Port: cdk.numberToCloudFormation(properties.port), Protocol: cdk.stringToCloudFormation(properties.protocol), SslPolicy: cdk.stringToCloudFormation(properties.sslPolicy) }) : properties;
    }
    function CfnListenerPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultActions", "DefaultActions", cfn_parse.FromCloudFormation.getArray(CfnListenerActionPropertyFromCloudFormation)(properties.DefaultActions)), ret.addPropertyResult("loadBalancerArn", "LoadBalancerArn", cfn_parse.FromCloudFormation.getString(properties.LoadBalancerArn)), ret.addPropertyResult("alpnPolicy", "AlpnPolicy", properties.AlpnPolicy != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AlpnPolicy) : void 0), ret.addPropertyResult("certificates", "Certificates", properties.Certificates != null ? cfn_parse.FromCloudFormation.getArray(CfnListenerCertificatePropertyFromCloudFormation)(properties.Certificates) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addPropertyResult("protocol", "Protocol", properties.Protocol != null ? cfn_parse.FromCloudFormation.getString(properties.Protocol) : void 0), ret.addPropertyResult("sslPolicy", "SslPolicy", properties.SslPolicy != null ? cfn_parse.FromCloudFormation.getString(properties.SslPolicy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnListener = class _CfnListener extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnListenerPropsFromCloudFormation(resourceProperties), ret = new _CfnListener(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnListener.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnListener), error;
        }
        cdk.requireProperty(props, "defaultActions", this), cdk.requireProperty(props, "loadBalancerArn", this), this.attrListenerArn = cdk.Token.asString(this.getAtt("ListenerArn", cdk.ResolutionTypeHint.STRING)), this.defaultActions = props.defaultActions, this.loadBalancerArn = props.loadBalancerArn, this.alpnPolicy = props.alpnPolicy, this.certificates = props.certificates, this.port = props.port, this.protocol = props.protocol, this.sslPolicy = props.sslPolicy;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnListener.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { defaultActions: this.defaultActions, loadBalancerArn: this.loadBalancerArn, alpnPolicy: this.alpnPolicy, certificates: this.certificates, port: this.port, protocol: this.protocol, sslPolicy: this.sslPolicy };
      }
      renderProperties(props) {
        return cfnListenerPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnListener[_a] = { fqn: "aws-cdk-lib.aws_elasticloadbalancingv2.CfnListener", version: "2.80.0" }, CfnListener.CFN_RESOURCE_TYPE_NAME = "AWS::ElasticLoadBalancingV2::Listener", exports2.CfnListener = CfnListener;
    function CfnListener_ActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authenticateCognitoConfig", CfnListener_AuthenticateCognitoConfigPropertyValidator)(properties.authenticateCognitoConfig)), errors.collect(cdk.propertyValidator("authenticateOidcConfig", CfnListener_AuthenticateOidcConfigPropertyValidator)(properties.authenticateOidcConfig)), errors.collect(cdk.propertyValidator("fixedResponseConfig", CfnListener_FixedResponseConfigPropertyValidator)(properties.fixedResponseConfig)), errors.collect(cdk.propertyValidator("forwardConfig", CfnListener_ForwardConfigPropertyValidator)(properties.forwardConfig)), errors.collect(cdk.propertyValidator("order", cdk.validateNumber)(properties.order)), errors.collect(cdk.propertyValidator("redirectConfig", CfnListener_RedirectConfigPropertyValidator)(properties.redirectConfig)), errors.collect(cdk.propertyValidator("targetGroupArn", cdk.validateString)(properties.targetGroupArn)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "ActionProperty"');
    }
    function cfnListenerActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListener_ActionPropertyValidator(properties).assertSuccess(), { AuthenticateCognitoConfig: cfnListenerAuthenticateCognitoConfigPropertyToCloudFormation(properties.authenticateCognitoConfig), AuthenticateOidcConfig: cfnListenerAuthenticateOidcConfigPropertyToCloudFormation(properties.authenticateOidcConfig), FixedResponseConfig: cfnListenerFixedResponseConfigPropertyToCloudFormation(properties.fixedResponseConfig), ForwardConfig: cfnListenerForwardConfigPropertyToCloudFormation(properties.forwardConfig), Order: cdk.numberToCloudFormation(properties.order), RedirectConfig: cfnListenerRedirectConfigPropertyToCloudFormation(properties.redirectConfig), TargetGroupArn: cdk.stringToCloudFormation(properties.targetGroupArn), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnListenerActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authenticateCognitoConfig", "AuthenticateCognitoConfig", properties.AuthenticateCognitoConfig != null ? CfnListenerAuthenticateCognitoConfigPropertyFromCloudFormation(properties.AuthenticateCognitoConfig) : void 0), ret.addPropertyResult("authenticateOidcConfig", "AuthenticateOidcConfig", properties.AuthenticateOidcConfig != null ? CfnListenerAuthenticateOidcConfigPropertyFromCloudFormation(properties.AuthenticateOidcConfig) : void 0), ret.addPropertyResult("fixedResponseConfig", "FixedResponseConfig", properties.FixedResponseConfig != null ? CfnListenerFixedResponseConfigPropertyFromCloudFormation(properties.FixedResponseConfig) : void 0), ret.addPropertyResult("forwardConfig", "ForwardConfig", properties.ForwardConfig != null ? CfnListenerForwardConfigPropertyFromCloudFormation(properties.ForwardConfig) : void 0), ret.addPropertyResult("order", "Order", properties.Order != null ? cfn_parse.FromCloudFormation.getNumber(properties.Order) : void 0), ret.addPropertyResult("redirectConfig", "RedirectConfig", properties.RedirectConfig != null ? CfnListenerRedirectConfigPropertyFromCloudFormation(properties.RedirectConfig) : void 0), ret.addPropertyResult("targetGroupArn", "TargetGroupArn", properties.TargetGroupArn != null ? cfn_parse.FromCloudFormation.getString(properties.TargetGroupArn) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnListener_AuthenticateCognitoConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authenticationRequestExtraParams", cdk.hashValidator(cdk.validateString))(properties.authenticationRequestExtraParams)), errors.collect(cdk.propertyValidator("onUnauthenticatedRequest", cdk.validateString)(properties.onUnauthenticatedRequest)), errors.collect(cdk.propertyValidator("scope", cdk.validateString)(properties.scope)), errors.collect(cdk.propertyValidator("sessionCookieName", cdk.validateString)(properties.sessionCookieName)), errors.collect(cdk.propertyValidator("sessionTimeout", cdk.validateString)(properties.sessionTimeout)), errors.collect(cdk.propertyValidator("userPoolArn", cdk.requiredValidator)(properties.userPoolArn)), errors.collect(cdk.propertyValidator("userPoolArn", cdk.validateString)(properties.userPoolArn)), errors.collect(cdk.propertyValidator("userPoolClientId", cdk.requiredValidator)(properties.userPoolClientId)), errors.collect(cdk.propertyValidator("userPoolClientId", cdk.validateString)(properties.userPoolClientId)), errors.collect(cdk.propertyValidator("userPoolDomain", cdk.requiredValidator)(properties.userPoolDomain)), errors.collect(cdk.propertyValidator("userPoolDomain", cdk.validateString)(properties.userPoolDomain)), errors.wrap('supplied properties not correct for "AuthenticateCognitoConfigProperty"');
    }
    function cfnListenerAuthenticateCognitoConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListener_AuthenticateCognitoConfigPropertyValidator(properties).assertSuccess(), { AuthenticationRequestExtraParams: cdk.hashMapper(cdk.stringToCloudFormation)(properties.authenticationRequestExtraParams), OnUnauthenticatedRequest: cdk.stringToCloudFormation(properties.onUnauthenticatedRequest), Scope: cdk.stringToCloudFormation(properties.scope), SessionCookieName: cdk.stringToCloudFormation(properties.sessionCookieName), SessionTimeout: cdk.stringToCloudFormation(properties.sessionTimeout), UserPoolArn: cdk.stringToCloudFormation(properties.userPoolArn), UserPoolClientId: cdk.stringToCloudFormation(properties.userPoolClientId), UserPoolDomain: cdk.stringToCloudFormation(properties.userPoolDomain) }) : properties;
    }
    function CfnListenerAuthenticateCognitoConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authenticationRequestExtraParams", "AuthenticationRequestExtraParams", properties.AuthenticationRequestExtraParams != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.AuthenticationRequestExtraParams) : void 0), ret.addPropertyResult("onUnauthenticatedRequest", "OnUnauthenticatedRequest", properties.OnUnauthenticatedRequest != null ? cfn_parse.FromCloudFormation.getString(properties.OnUnauthenticatedRequest) : void 0), ret.addPropertyResult("scope", "Scope", properties.Scope != null ? cfn_parse.FromCloudFormation.getString(properties.Scope) : void 0), ret.addPropertyResult("sessionCookieName", "SessionCookieName", properties.SessionCookieName != null ? cfn_parse.FromCloudFormation.getString(properties.SessionCookieName) : void 0), ret.addPropertyResult("sessionTimeout", "SessionTimeout", properties.SessionTimeout != null ? cfn_parse.FromCloudFormation.getString(properties.SessionTimeout) : void 0), ret.addPropertyResult("userPoolArn", "UserPoolArn", cfn_parse.FromCloudFormation.getString(properties.UserPoolArn)), ret.addPropertyResult("userPoolClientId", "UserPoolClientId", cfn_parse.FromCloudFormation.getString(properties.UserPoolClientId)), ret.addPropertyResult("userPoolDomain", "UserPoolDomain", cfn_parse.FromCloudFormation.getString(properties.UserPoolDomain)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnListener_AuthenticateOidcConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authenticationRequestExtraParams", cdk.hashValidator(cdk.validateString))(properties.authenticationRequestExtraParams)), errors.collect(cdk.propertyValidator("authorizationEndpoint", cdk.requiredValidator)(properties.authorizationEndpoint)), errors.collect(cdk.propertyValidator("authorizationEndpoint", cdk.validateString)(properties.authorizationEndpoint)), errors.collect(cdk.propertyValidator("clientId", cdk.requiredValidator)(properties.clientId)), errors.collect(cdk.propertyValidator("clientId", cdk.validateString)(properties.clientId)), errors.collect(cdk.propertyValidator("clientSecret", cdk.validateString)(properties.clientSecret)), errors.collect(cdk.propertyValidator("issuer", cdk.requiredValidator)(properties.issuer)), errors.collect(cdk.propertyValidator("issuer", cdk.validateString)(properties.issuer)), errors.collect(cdk.propertyValidator("onUnauthenticatedRequest", cdk.validateString)(properties.onUnauthenticatedRequest)), errors.collect(cdk.propertyValidator("scope", cdk.validateString)(properties.scope)), errors.collect(cdk.propertyValidator("sessionCookieName", cdk.validateString)(properties.sessionCookieName)), errors.collect(cdk.propertyValidator("sessionTimeout", cdk.validateString)(properties.sessionTimeout)), errors.collect(cdk.propertyValidator("tokenEndpoint", cdk.requiredValidator)(properties.tokenEndpoint)), errors.collect(cdk.propertyValidator("tokenEndpoint", cdk.validateString)(properties.tokenEndpoint)), errors.collect(cdk.propertyValidator("useExistingClientSecret", cdk.validateBoolean)(properties.useExistingClientSecret)), errors.collect(cdk.propertyValidator("userInfoEndpoint", cdk.requiredValidator)(properties.userInfoEndpoint)), errors.collect(cdk.propertyValidator("userInfoEndpoint", cdk.validateString)(properties.userInfoEndpoint)), errors.wrap('supplied properties not correct for "AuthenticateOidcConfigProperty"');
    }
    function cfnListenerAuthenticateOidcConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListener_AuthenticateOidcConfigPropertyValidator(properties).assertSuccess(), { AuthenticationRequestExtraParams: cdk.hashMapper(cdk.stringToCloudFormation)(properties.authenticationRequestExtraParams), AuthorizationEndpoint: cdk.stringToCloudFormation(properties.authorizationEndpoint), ClientId: cdk.stringToCloudFormation(properties.clientId), ClientSecret: cdk.stringToCloudFormation(properties.clientSecret), Issuer: cdk.stringToCloudFormation(properties.issuer), OnUnauthenticatedRequest: cdk.stringToCloudFormation(properties.onUnauthenticatedRequest), Scope: cdk.stringToCloudFormation(properties.scope), SessionCookieName: cdk.stringToCloudFormation(properties.sessionCookieName), SessionTimeout: cdk.stringToCloudFormation(properties.sessionTimeout), TokenEndpoint: cdk.stringToCloudFormation(properties.tokenEndpoint), UseExistingClientSecret: cdk.booleanToCloudFormation(properties.useExistingClientSecret), UserInfoEndpoint: cdk.stringToCloudFormation(properties.userInfoEndpoint) }) : properties;
    }
    function CfnListenerAuthenticateOidcConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authenticationRequestExtraParams", "AuthenticationRequestExtraParams", properties.AuthenticationRequestExtraParams != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.AuthenticationRequestExtraParams) : void 0), ret.addPropertyResult("authorizationEndpoint", "AuthorizationEndpoint", cfn_parse.FromCloudFormation.getString(properties.AuthorizationEndpoint)), ret.addPropertyResult("clientId", "ClientId", cfn_parse.FromCloudFormation.getString(properties.ClientId)), ret.addPropertyResult("clientSecret", "ClientSecret", properties.ClientSecret != null ? cfn_parse.FromCloudFormation.getString(properties.ClientSecret) : void 0), ret.addPropertyResult("issuer", "Issuer", cfn_parse.FromCloudFormation.getString(properties.Issuer)), ret.addPropertyResult("onUnauthenticatedRequest", "OnUnauthenticatedRequest", properties.OnUnauthenticatedRequest != null ? cfn_parse.FromCloudFormation.getString(properties.OnUnauthenticatedRequest) : void 0), ret.addPropertyResult("scope", "Scope", properties.Scope != null ? cfn_parse.FromCloudFormation.getString(properties.Scope) : void 0), ret.addPropertyResult("sessionCookieName", "SessionCookieName", properties.SessionCookieName != null ? cfn_parse.FromCloudFormation.getString(properties.SessionCookieName) : void 0), ret.addPropertyResult("sessionTimeout", "SessionTimeout", properties.SessionTimeout != null ? cfn_parse.FromCloudFormation.getString(properties.SessionTimeout) : void 0), ret.addPropertyResult("tokenEndpoint", "TokenEndpoint", cfn_parse.FromCloudFormation.getString(properties.TokenEndpoint)), ret.addPropertyResult("useExistingClientSecret", "UseExistingClientSecret", properties.UseExistingClientSecret != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseExistingClientSecret) : void 0), ret.addPropertyResult("userInfoEndpoint", "UserInfoEndpoint", cfn_parse.FromCloudFormation.getString(properties.UserInfoEndpoint)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnListener_CertificatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateArn", cdk.validateString)(properties.certificateArn)), errors.wrap('supplied properties not correct for "CertificateProperty"');
    }
    function cfnListenerCertificatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListener_CertificatePropertyValidator(properties).assertSuccess(), { CertificateArn: cdk.stringToCloudFormation(properties.certificateArn) }) : properties;
    }
    function CfnListenerCertificatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificateArn", "CertificateArn", properties.CertificateArn != null ? cfn_parse.FromCloudFormation.getString(properties.CertificateArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnListener_FixedResponseConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contentType", cdk.validateString)(properties.contentType)), errors.collect(cdk.propertyValidator("messageBody", cdk.validateString)(properties.messageBody)), errors.collect(cdk.propertyValidator("statusCode", cdk.requiredValidator)(properties.statusCode)), errors.collect(cdk.propertyValidator("statusCode", cdk.validateString)(properties.statusCode)), errors.wrap('supplied properties not correct for "FixedResponseConfigProperty"');
    }
    function cfnListenerFixedResponseConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListener_FixedResponseConfigPropertyValidator(properties).assertSuccess(), { ContentType: cdk.stringToCloudFormation(properties.contentType), MessageBody: cdk.stringToCloudFormation(properties.messageBody), StatusCode: cdk.stringToCloudFormation(properties.statusCode) }) : properties;
    }
    function CfnListenerFixedResponseConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contentType", "ContentType", properties.ContentType != null ? cfn_parse.FromCloudFormation.getString(properties.ContentType) : void 0), ret.addPropertyResult("messageBody", "MessageBody", properties.MessageBody != null ? cfn_parse.FromCloudFormation.getString(properties.MessageBody) : void 0), ret.addPropertyResult("statusCode", "StatusCode", cfn_parse.FromCloudFormation.getString(properties.StatusCode)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnListener_ForwardConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("targetGroupStickinessConfig", CfnListener_TargetGroupStickinessConfigPropertyValidator)(properties.targetGroupStickinessConfig)), errors.collect(cdk.propertyValidator("targetGroups", cdk.listValidator(CfnListener_TargetGroupTuplePropertyValidator))(properties.targetGroups)), errors.wrap('supplied properties not correct for "ForwardConfigProperty"');
    }
    function cfnListenerForwardConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListener_ForwardConfigPropertyValidator(properties).assertSuccess(), { TargetGroupStickinessConfig: cfnListenerTargetGroupStickinessConfigPropertyToCloudFormation(properties.targetGroupStickinessConfig), TargetGroups: cdk.listMapper(cfnListenerTargetGroupTuplePropertyToCloudFormation)(properties.targetGroups) }) : properties;
    }
    function CfnListenerForwardConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("targetGroupStickinessConfig", "TargetGroupStickinessConfig", properties.TargetGroupStickinessConfig != null ? CfnListenerTargetGroupStickinessConfigPropertyFromCloudFormation(properties.TargetGroupStickinessConfig) : void 0), ret.addPropertyResult("targetGroups", "TargetGroups", properties.TargetGroups != null ? cfn_parse.FromCloudFormation.getArray(CfnListenerTargetGroupTuplePropertyFromCloudFormation)(properties.TargetGroups) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnListener_RedirectConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("host", cdk.validateString)(properties.host)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.collect(cdk.propertyValidator("port", cdk.validateString)(properties.port)), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.collect(cdk.propertyValidator("query", cdk.validateString)(properties.query)), errors.collect(cdk.propertyValidator("statusCode", cdk.requiredValidator)(properties.statusCode)), errors.collect(cdk.propertyValidator("statusCode", cdk.validateString)(properties.statusCode)), errors.wrap('supplied properties not correct for "RedirectConfigProperty"');
    }
    function cfnListenerRedirectConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListener_RedirectConfigPropertyValidator(properties).assertSuccess(), { Host: cdk.stringToCloudFormation(properties.host), Path: cdk.stringToCloudFormation(properties.path), Port: cdk.stringToCloudFormation(properties.port), Protocol: cdk.stringToCloudFormation(properties.protocol), Query: cdk.stringToCloudFormation(properties.query), StatusCode: cdk.stringToCloudFormation(properties.statusCode) }) : properties;
    }
    function CfnListenerRedirectConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("host", "Host", properties.Host != null ? cfn_parse.FromCloudFormation.getString(properties.Host) : void 0), ret.addPropertyResult("path", "Path", properties.Path != null ? cfn_parse.FromCloudFormation.getString(properties.Path) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getString(properties.Port) : void 0), ret.addPropertyResult("protocol", "Protocol", properties.Protocol != null ? cfn_parse.FromCloudFormation.getString(properties.Protocol) : void 0), ret.addPropertyResult("query", "Query", properties.Query != null ? cfn_parse.FromCloudFormation.getString(properties.Query) : void 0), ret.addPropertyResult("statusCode", "StatusCode", cfn_parse.FromCloudFormation.getString(properties.StatusCode)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnListener_TargetGroupStickinessConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("durationSeconds", cdk.validateNumber)(properties.durationSeconds)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "TargetGroupStickinessConfigProperty"');
    }
    function cfnListenerTargetGroupStickinessConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListener_TargetGroupStickinessConfigPropertyValidator(properties).assertSuccess(), { DurationSeconds: cdk.numberToCloudFormation(properties.durationSeconds), Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnListenerTargetGroupStickinessConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("durationSeconds", "DurationSeconds", properties.DurationSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.DurationSeconds) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnListener_TargetGroupTuplePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("targetGroupArn", cdk.validateString)(properties.targetGroupArn)), errors.collect(cdk.propertyValidator("weight", cdk.validateNumber)(properties.weight)), errors.wrap('supplied properties not correct for "TargetGroupTupleProperty"');
    }
    function cfnListenerTargetGroupTuplePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListener_TargetGroupTuplePropertyValidator(properties).assertSuccess(), { TargetGroupArn: cdk.stringToCloudFormation(properties.targetGroupArn), Weight: cdk.numberToCloudFormation(properties.weight) }) : properties;
    }
    function CfnListenerTargetGroupTuplePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("targetGroupArn", "TargetGroupArn", properties.TargetGroupArn != null ? cfn_parse.FromCloudFormation.getString(properties.TargetGroupArn) : void 0), ret.addPropertyResult("weight", "Weight", properties.Weight != null ? cfn_parse.FromCloudFormation.getNumber(properties.Weight) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnListenerCertificatePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificates", cdk.requiredValidator)(properties.certificates)), errors.collect(cdk.propertyValidator("certificates", cdk.listValidator(CfnListenerCertificate_CertificatePropertyValidator))(properties.certificates)), errors.collect(cdk.propertyValidator("listenerArn", cdk.requiredValidator)(properties.listenerArn)), errors.collect(cdk.propertyValidator("listenerArn", cdk.validateString)(properties.listenerArn)), errors.wrap('supplied properties not correct for "CfnListenerCertificateProps"');
    }
    function cfnListenerCertificatePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListenerCertificatePropsValidator(properties).assertSuccess(), { Certificates: cdk.listMapper(cfnListenerCertificateCertificatePropertyToCloudFormation)(properties.certificates), ListenerArn: cdk.stringToCloudFormation(properties.listenerArn) }) : properties;
    }
    function CfnListenerCertificatePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificates", "Certificates", cfn_parse.FromCloudFormation.getArray(CfnListenerCertificateCertificatePropertyFromCloudFormation)(properties.Certificates)), ret.addPropertyResult("listenerArn", "ListenerArn", cfn_parse.FromCloudFormation.getString(properties.ListenerArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnListenerCertificate = class _CfnListenerCertificate extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnListenerCertificatePropsFromCloudFormation(resourceProperties), ret = new _CfnListenerCertificate(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnListenerCertificate.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerCertificateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnListenerCertificate), error;
        }
        cdk.requireProperty(props, "certificates", this), cdk.requireProperty(props, "listenerArn", this), this.certificates = props.certificates, this.listenerArn = props.listenerArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnListenerCertificate.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { certificates: this.certificates, listenerArn: this.listenerArn };
      }
      renderProperties(props) {
        return cfnListenerCertificatePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnListenerCertificate[_b] = { fqn: "aws-cdk-lib.aws_elasticloadbalancingv2.CfnListenerCertificate", version: "2.80.0" }, CfnListenerCertificate.CFN_RESOURCE_TYPE_NAME = "AWS::ElasticLoadBalancingV2::ListenerCertificate", exports2.CfnListenerCertificate = CfnListenerCertificate;
    function CfnListenerCertificate_CertificatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateArn", cdk.validateString)(properties.certificateArn)), errors.wrap('supplied properties not correct for "CertificateProperty"');
    }
    function cfnListenerCertificateCertificatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListenerCertificate_CertificatePropertyValidator(properties).assertSuccess(), { CertificateArn: cdk.stringToCloudFormation(properties.certificateArn) }) : properties;
    }
    function CfnListenerCertificateCertificatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificateArn", "CertificateArn", properties.CertificateArn != null ? cfn_parse.FromCloudFormation.getString(properties.CertificateArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnListenerRulePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.requiredValidator)(properties.actions)), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnListenerRule_ActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("conditions", cdk.requiredValidator)(properties.conditions)), errors.collect(cdk.propertyValidator("conditions", cdk.listValidator(CfnListenerRule_RuleConditionPropertyValidator))(properties.conditions)), errors.collect(cdk.propertyValidator("listenerArn", cdk.validateString)(properties.listenerArn)), errors.collect(cdk.propertyValidator("priority", cdk.requiredValidator)(properties.priority)), errors.collect(cdk.propertyValidator("priority", cdk.validateNumber)(properties.priority)), errors.wrap('supplied properties not correct for "CfnListenerRuleProps"');
    }
    function cfnListenerRulePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListenerRulePropsValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnListenerRuleActionPropertyToCloudFormation)(properties.actions), Conditions: cdk.listMapper(cfnListenerRuleRuleConditionPropertyToCloudFormation)(properties.conditions), Priority: cdk.numberToCloudFormation(properties.priority), ListenerArn: cdk.stringToCloudFormation(properties.listenerArn) }) : properties;
    }
    function CfnListenerRulePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", cfn_parse.FromCloudFormation.getArray(CfnListenerRuleActionPropertyFromCloudFormation)(properties.Actions)), ret.addPropertyResult("conditions", "Conditions", cfn_parse.FromCloudFormation.getArray(CfnListenerRuleRuleConditionPropertyFromCloudFormation)(properties.Conditions)), ret.addPropertyResult("priority", "Priority", cfn_parse.FromCloudFormation.getNumber(properties.Priority)), ret.addPropertyResult("listenerArn", "ListenerArn", properties.ListenerArn != null ? cfn_parse.FromCloudFormation.getString(properties.ListenerArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnListenerRule = class _CfnListenerRule extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnListenerRulePropsFromCloudFormation(resourceProperties), ret = new _CfnListenerRule(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnListenerRule.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRuleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnListenerRule), error;
        }
        cdk.requireProperty(props, "actions", this), cdk.requireProperty(props, "conditions", this), cdk.requireProperty(props, "priority", this), this.attrIsDefault = this.getAtt("IsDefault", cdk.ResolutionTypeHint.STRING), this.attrRuleArn = cdk.Token.asString(this.getAtt("RuleArn", cdk.ResolutionTypeHint.STRING)), this.actions = props.actions, this.conditions = props.conditions, this.priority = props.priority, this.listenerArn = props.listenerArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnListenerRule.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { actions: this.actions, conditions: this.conditions, priority: this.priority, listenerArn: this.listenerArn };
      }
      renderProperties(props) {
        return cfnListenerRulePropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnListenerRule[_c] = { fqn: "aws-cdk-lib.aws_elasticloadbalancingv2.CfnListenerRule", version: "2.80.0" }, CfnListenerRule.CFN_RESOURCE_TYPE_NAME = "AWS::ElasticLoadBalancingV2::ListenerRule", exports2.CfnListenerRule = CfnListenerRule;
    function CfnListenerRule_ActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authenticateCognitoConfig", CfnListenerRule_AuthenticateCognitoConfigPropertyValidator)(properties.authenticateCognitoConfig)), errors.collect(cdk.propertyValidator("authenticateOidcConfig", CfnListenerRule_AuthenticateOidcConfigPropertyValidator)(properties.authenticateOidcConfig)), errors.collect(cdk.propertyValidator("fixedResponseConfig", CfnListenerRule_FixedResponseConfigPropertyValidator)(properties.fixedResponseConfig)), errors.collect(cdk.propertyValidator("forwardConfig", CfnListenerRule_ForwardConfigPropertyValidator)(properties.forwardConfig)), errors.collect(cdk.propertyValidator("order", cdk.validateNumber)(properties.order)), errors.collect(cdk.propertyValidator("redirectConfig", CfnListenerRule_RedirectConfigPropertyValidator)(properties.redirectConfig)), errors.collect(cdk.propertyValidator("targetGroupArn", cdk.validateString)(properties.targetGroupArn)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "ActionProperty"');
    }
    function cfnListenerRuleActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListenerRule_ActionPropertyValidator(properties).assertSuccess(), { AuthenticateCognitoConfig: cfnListenerRuleAuthenticateCognitoConfigPropertyToCloudFormation(properties.authenticateCognitoConfig), AuthenticateOidcConfig: cfnListenerRuleAuthenticateOidcConfigPropertyToCloudFormation(properties.authenticateOidcConfig), FixedResponseConfig: cfnListenerRuleFixedResponseConfigPropertyToCloudFormation(properties.fixedResponseConfig), ForwardConfig: cfnListenerRuleForwardConfigPropertyToCloudFormation(properties.forwardConfig), Order: cdk.numberToCloudFormation(properties.order), RedirectConfig: cfnListenerRuleRedirectConfigPropertyToCloudFormation(properties.redirectConfig), TargetGroupArn: cdk.stringToCloudFormation(properties.targetGroupArn), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnListenerRuleActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authenticateCognitoConfig", "AuthenticateCognitoConfig", properties.AuthenticateCognitoConfig != null ? CfnListenerRuleAuthenticateCognitoConfigPropertyFromCloudFormation(properties.AuthenticateCognitoConfig) : void 0), ret.addPropertyResult("authenticateOidcConfig", "AuthenticateOidcConfig", properties.AuthenticateOidcConfig != null ? CfnListenerRuleAuthenticateOidcConfigPropertyFromCloudFormation(properties.AuthenticateOidcConfig) : void 0), ret.addPropertyResult("fixedResponseConfig", "FixedResponseConfig", properties.FixedResponseConfig != null ? CfnListenerRuleFixedResponseConfigPropertyFromCloudFormation(properties.FixedResponseConfig) : void 0), ret.addPropertyResult("forwardConfig", "ForwardConfig", properties.ForwardConfig != null ? CfnListenerRuleForwardConfigPropertyFromCloudFormation(properties.ForwardConfig) : void 0), ret.addPropertyResult("order", "Order", properties.Order != null ? cfn_parse.FromCloudFormation.getNumber(properties.Order) : void 0), ret.addPropertyResult("redirectConfig", "RedirectConfig", properties.RedirectConfig != null ? CfnListenerRuleRedirectConfigPropertyFromCloudFormation(properties.RedirectConfig) : void 0), ret.addPropertyResult("targetGroupArn", "TargetGroupArn", properties.TargetGroupArn != null ? cfn_parse.FromCloudFormation.getString(properties.TargetGroupArn) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnListenerRule_AuthenticateCognitoConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authenticationRequestExtraParams", cdk.hashValidator(cdk.validateString))(properties.authenticationRequestExtraParams)), errors.collect(cdk.propertyValidator("onUnauthenticatedRequest", cdk.validateString)(properties.onUnauthenticatedRequest)), errors.collect(cdk.propertyValidator("scope", cdk.validateString)(properties.scope)), errors.collect(cdk.propertyValidator("sessionCookieName", cdk.validateString)(properties.sessionCookieName)), errors.collect(cdk.propertyValidator("sessionTimeout", cdk.validateNumber)(properties.sessionTimeout)), errors.collect(cdk.propertyValidator("userPoolArn", cdk.requiredValidator)(properties.userPoolArn)), errors.collect(cdk.propertyValidator("userPoolArn", cdk.validateString)(properties.userPoolArn)), errors.collect(cdk.propertyValidator("userPoolClientId", cdk.requiredValidator)(properties.userPoolClientId)), errors.collect(cdk.propertyValidator("userPoolClientId", cdk.validateString)(properties.userPoolClientId)), errors.collect(cdk.propertyValidator("userPoolDomain", cdk.requiredValidator)(properties.userPoolDomain)), errors.collect(cdk.propertyValidator("userPoolDomain", cdk.validateString)(properties.userPoolDomain)), errors.wrap('supplied properties not correct for "AuthenticateCognitoConfigProperty"');
    }
    function cfnListenerRuleAuthenticateCognitoConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListenerRule_AuthenticateCognitoConfigPropertyValidator(properties).assertSuccess(), { AuthenticationRequestExtraParams: cdk.hashMapper(cdk.stringToCloudFormation)(properties.authenticationRequestExtraParams), OnUnauthenticatedRequest: cdk.stringToCloudFormation(properties.onUnauthenticatedRequest), Scope: cdk.stringToCloudFormation(properties.scope), SessionCookieName: cdk.stringToCloudFormation(properties.sessionCookieName), SessionTimeout: cdk.numberToCloudFormation(properties.sessionTimeout), UserPoolArn: cdk.stringToCloudFormation(properties.userPoolArn), UserPoolClientId: cdk.stringToCloudFormation(properties.userPoolClientId), UserPoolDomain: cdk.stringToCloudFormation(properties.userPoolDomain) }) : properties;
    }
    function CfnListenerRuleAuthenticateCognitoConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authenticationRequestExtraParams", "AuthenticationRequestExtraParams", properties.AuthenticationRequestExtraParams != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.AuthenticationRequestExtraParams) : void 0), ret.addPropertyResult("onUnauthenticatedRequest", "OnUnauthenticatedRequest", properties.OnUnauthenticatedRequest != null ? cfn_parse.FromCloudFormation.getString(properties.OnUnauthenticatedRequest) : void 0), ret.addPropertyResult("scope", "Scope", properties.Scope != null ? cfn_parse.FromCloudFormation.getString(properties.Scope) : void 0), ret.addPropertyResult("sessionCookieName", "SessionCookieName", properties.SessionCookieName != null ? cfn_parse.FromCloudFormation.getString(properties.SessionCookieName) : void 0), ret.addPropertyResult("sessionTimeout", "SessionTimeout", properties.SessionTimeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.SessionTimeout) : void 0), ret.addPropertyResult("userPoolArn", "UserPoolArn", cfn_parse.FromCloudFormation.getString(properties.UserPoolArn)), ret.addPropertyResult("userPoolClientId", "UserPoolClientId", cfn_parse.FromCloudFormation.getString(properties.UserPoolClientId)), ret.addPropertyResult("userPoolDomain", "UserPoolDomain", cfn_parse.FromCloudFormation.getString(properties.UserPoolDomain)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnListenerRule_AuthenticateOidcConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authenticationRequestExtraParams", cdk.hashValidator(cdk.validateString))(properties.authenticationRequestExtraParams)), errors.collect(cdk.propertyValidator("authorizationEndpoint", cdk.requiredValidator)(properties.authorizationEndpoint)), errors.collect(cdk.propertyValidator("authorizationEndpoint", cdk.validateString)(properties.authorizationEndpoint)), errors.collect(cdk.propertyValidator("clientId", cdk.requiredValidator)(properties.clientId)), errors.collect(cdk.propertyValidator("clientId", cdk.validateString)(properties.clientId)), errors.collect(cdk.propertyValidator("clientSecret", cdk.validateString)(properties.clientSecret)), errors.collect(cdk.propertyValidator("issuer", cdk.requiredValidator)(properties.issuer)), errors.collect(cdk.propertyValidator("issuer", cdk.validateString)(properties.issuer)), errors.collect(cdk.propertyValidator("onUnauthenticatedRequest", cdk.validateString)(properties.onUnauthenticatedRequest)), errors.collect(cdk.propertyValidator("scope", cdk.validateString)(properties.scope)), errors.collect(cdk.propertyValidator("sessionCookieName", cdk.validateString)(properties.sessionCookieName)), errors.collect(cdk.propertyValidator("sessionTimeout", cdk.validateNumber)(properties.sessionTimeout)), errors.collect(cdk.propertyValidator("tokenEndpoint", cdk.requiredValidator)(properties.tokenEndpoint)), errors.collect(cdk.propertyValidator("tokenEndpoint", cdk.validateString)(properties.tokenEndpoint)), errors.collect(cdk.propertyValidator("useExistingClientSecret", cdk.validateBoolean)(properties.useExistingClientSecret)), errors.collect(cdk.propertyValidator("userInfoEndpoint", cdk.requiredValidator)(properties.userInfoEndpoint)), errors.collect(cdk.propertyValidator("userInfoEndpoint", cdk.validateString)(properties.userInfoEndpoint)), errors.wrap('supplied properties not correct for "AuthenticateOidcConfigProperty"');
    }
    function cfnListenerRuleAuthenticateOidcConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListenerRule_AuthenticateOidcConfigPropertyValidator(properties).assertSuccess(), { AuthenticationRequestExtraParams: cdk.hashMapper(cdk.stringToCloudFormation)(properties.authenticationRequestExtraParams), AuthorizationEndpoint: cdk.stringToCloudFormation(properties.authorizationEndpoint), ClientId: cdk.stringToCloudFormation(properties.clientId), ClientSecret: cdk.stringToCloudFormation(properties.clientSecret), Issuer: cdk.stringToCloudFormation(properties.issuer), OnUnauthenticatedRequest: cdk.stringToCloudFormation(properties.onUnauthenticatedRequest), Scope: cdk.stringToCloudFormation(properties.scope), SessionCookieName: cdk.stringToCloudFormation(properties.sessionCookieName), SessionTimeout: cdk.numberToCloudFormation(properties.sessionTimeout), TokenEndpoint: cdk.stringToCloudFormation(properties.tokenEndpoint), UseExistingClientSecret: cdk.booleanToCloudFormation(properties.useExistingClientSecret), UserInfoEndpoint: cdk.stringToCloudFormation(properties.userInfoEndpoint) }) : properties;
    }
    function CfnListenerRuleAuthenticateOidcConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authenticationRequestExtraParams", "AuthenticationRequestExtraParams", properties.AuthenticationRequestExtraParams != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.AuthenticationRequestExtraParams) : void 0), ret.addPropertyResult("authorizationEndpoint", "AuthorizationEndpoint", cfn_parse.FromCloudFormation.getString(properties.AuthorizationEndpoint)), ret.addPropertyResult("clientId", "ClientId", cfn_parse.FromCloudFormation.getString(properties.ClientId)), ret.addPropertyResult("clientSecret", "ClientSecret", properties.ClientSecret != null ? cfn_parse.FromCloudFormation.getString(properties.ClientSecret) : void 0), ret.addPropertyResult("issuer", "Issuer", cfn_parse.FromCloudFormation.getString(properties.Issuer)), ret.addPropertyResult("onUnauthenticatedRequest", "OnUnauthenticatedRequest", properties.OnUnauthenticatedRequest != null ? cfn_parse.FromCloudFormation.getString(properties.OnUnauthenticatedRequest) : void 0), ret.addPropertyResult("scope", "Scope", properties.Scope != null ? cfn_parse.FromCloudFormation.getString(properties.Scope) : void 0), ret.addPropertyResult("sessionCookieName", "SessionCookieName", properties.SessionCookieName != null ? cfn_parse.FromCloudFormation.getString(properties.SessionCookieName) : void 0), ret.addPropertyResult("sessionTimeout", "SessionTimeout", properties.SessionTimeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.SessionTimeout) : void 0), ret.addPropertyResult("tokenEndpoint", "TokenEndpoint", cfn_parse.FromCloudFormation.getString(properties.TokenEndpoint)), ret.addPropertyResult("useExistingClientSecret", "UseExistingClientSecret", properties.UseExistingClientSecret != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseExistingClientSecret) : void 0), ret.addPropertyResult("userInfoEndpoint", "UserInfoEndpoint", cfn_parse.FromCloudFormation.getString(properties.UserInfoEndpoint)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnListenerRule_FixedResponseConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contentType", cdk.validateString)(properties.contentType)), errors.collect(cdk.propertyValidator("messageBody", cdk.validateString)(properties.messageBody)), errors.collect(cdk.propertyValidator("statusCode", cdk.requiredValidator)(properties.statusCode)), errors.collect(cdk.propertyValidator("statusCode", cdk.validateString)(properties.statusCode)), errors.wrap('supplied properties not correct for "FixedResponseConfigProperty"');
    }
    function cfnListenerRuleFixedResponseConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListenerRule_FixedResponseConfigPropertyValidator(properties).assertSuccess(), { ContentType: cdk.stringToCloudFormation(properties.contentType), MessageBody: cdk.stringToCloudFormation(properties.messageBody), StatusCode: cdk.stringToCloudFormation(properties.statusCode) }) : properties;
    }
    function CfnListenerRuleFixedResponseConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contentType", "ContentType", properties.ContentType != null ? cfn_parse.FromCloudFormation.getString(properties.ContentType) : void 0), ret.addPropertyResult("messageBody", "MessageBody", properties.MessageBody != null ? cfn_parse.FromCloudFormation.getString(properties.MessageBody) : void 0), ret.addPropertyResult("statusCode", "StatusCode", cfn_parse.FromCloudFormation.getString(properties.StatusCode)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnListenerRule_ForwardConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("targetGroupStickinessConfig", CfnListenerRule_TargetGroupStickinessConfigPropertyValidator)(properties.targetGroupStickinessConfig)), errors.collect(cdk.propertyValidator("targetGroups", cdk.listValidator(CfnListenerRule_TargetGroupTuplePropertyValidator))(properties.targetGroups)), errors.wrap('supplied properties not correct for "ForwardConfigProperty"');
    }
    function cfnListenerRuleForwardConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListenerRule_ForwardConfigPropertyValidator(properties).assertSuccess(), { TargetGroupStickinessConfig: cfnListenerRuleTargetGroupStickinessConfigPropertyToCloudFormation(properties.targetGroupStickinessConfig), TargetGroups: cdk.listMapper(cfnListenerRuleTargetGroupTuplePropertyToCloudFormation)(properties.targetGroups) }) : properties;
    }
    function CfnListenerRuleForwardConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("targetGroupStickinessConfig", "TargetGroupStickinessConfig", properties.TargetGroupStickinessConfig != null ? CfnListenerRuleTargetGroupStickinessConfigPropertyFromCloudFormation(properties.TargetGroupStickinessConfig) : void 0), ret.addPropertyResult("targetGroups", "TargetGroups", properties.TargetGroups != null ? cfn_parse.FromCloudFormation.getArray(CfnListenerRuleTargetGroupTuplePropertyFromCloudFormation)(properties.TargetGroups) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnListenerRule_HostHeaderConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "HostHeaderConfigProperty"');
    }
    function cfnListenerRuleHostHeaderConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListenerRule_HostHeaderConfigPropertyValidator(properties).assertSuccess(), { Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnListenerRuleHostHeaderConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnListenerRule_HttpHeaderConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("httpHeaderName", cdk.validateString)(properties.httpHeaderName)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "HttpHeaderConfigProperty"');
    }
    function cfnListenerRuleHttpHeaderConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListenerRule_HttpHeaderConfigPropertyValidator(properties).assertSuccess(), { HttpHeaderName: cdk.stringToCloudFormation(properties.httpHeaderName), Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnListenerRuleHttpHeaderConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("httpHeaderName", "HttpHeaderName", properties.HttpHeaderName != null ? cfn_parse.FromCloudFormation.getString(properties.HttpHeaderName) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnListenerRule_HttpRequestMethodConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "HttpRequestMethodConfigProperty"');
    }
    function cfnListenerRuleHttpRequestMethodConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListenerRule_HttpRequestMethodConfigPropertyValidator(properties).assertSuccess(), { Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnListenerRuleHttpRequestMethodConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnListenerRule_PathPatternConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "PathPatternConfigProperty"');
    }
    function cfnListenerRulePathPatternConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListenerRule_PathPatternConfigPropertyValidator(properties).assertSuccess(), { Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnListenerRulePathPatternConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnListenerRule_QueryStringConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnListenerRule_QueryStringKeyValuePropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "QueryStringConfigProperty"');
    }
    function cfnListenerRuleQueryStringConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListenerRule_QueryStringConfigPropertyValidator(properties).assertSuccess(), { Values: cdk.listMapper(cfnListenerRuleQueryStringKeyValuePropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnListenerRuleQueryStringConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnListenerRuleQueryStringKeyValuePropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnListenerRule_QueryStringKeyValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "QueryStringKeyValueProperty"');
    }
    function cfnListenerRuleQueryStringKeyValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListenerRule_QueryStringKeyValuePropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnListenerRuleQueryStringKeyValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnListenerRule_RedirectConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("host", cdk.validateString)(properties.host)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.collect(cdk.propertyValidator("port", cdk.validateString)(properties.port)), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.collect(cdk.propertyValidator("query", cdk.validateString)(properties.query)), errors.collect(cdk.propertyValidator("statusCode", cdk.requiredValidator)(properties.statusCode)), errors.collect(cdk.propertyValidator("statusCode", cdk.validateString)(properties.statusCode)), errors.wrap('supplied properties not correct for "RedirectConfigProperty"');
    }
    function cfnListenerRuleRedirectConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListenerRule_RedirectConfigPropertyValidator(properties).assertSuccess(), { Host: cdk.stringToCloudFormation(properties.host), Path: cdk.stringToCloudFormation(properties.path), Port: cdk.stringToCloudFormation(properties.port), Protocol: cdk.stringToCloudFormation(properties.protocol), Query: cdk.stringToCloudFormation(properties.query), StatusCode: cdk.stringToCloudFormation(properties.statusCode) }) : properties;
    }
    function CfnListenerRuleRedirectConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("host", "Host", properties.Host != null ? cfn_parse.FromCloudFormation.getString(properties.Host) : void 0), ret.addPropertyResult("path", "Path", properties.Path != null ? cfn_parse.FromCloudFormation.getString(properties.Path) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getString(properties.Port) : void 0), ret.addPropertyResult("protocol", "Protocol", properties.Protocol != null ? cfn_parse.FromCloudFormation.getString(properties.Protocol) : void 0), ret.addPropertyResult("query", "Query", properties.Query != null ? cfn_parse.FromCloudFormation.getString(properties.Query) : void 0), ret.addPropertyResult("statusCode", "StatusCode", cfn_parse.FromCloudFormation.getString(properties.StatusCode)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnListenerRule_RuleConditionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("field", cdk.validateString)(properties.field)), errors.collect(cdk.propertyValidator("hostHeaderConfig", CfnListenerRule_HostHeaderConfigPropertyValidator)(properties.hostHeaderConfig)), errors.collect(cdk.propertyValidator("httpHeaderConfig", CfnListenerRule_HttpHeaderConfigPropertyValidator)(properties.httpHeaderConfig)), errors.collect(cdk.propertyValidator("httpRequestMethodConfig", CfnListenerRule_HttpRequestMethodConfigPropertyValidator)(properties.httpRequestMethodConfig)), errors.collect(cdk.propertyValidator("pathPatternConfig", CfnListenerRule_PathPatternConfigPropertyValidator)(properties.pathPatternConfig)), errors.collect(cdk.propertyValidator("queryStringConfig", CfnListenerRule_QueryStringConfigPropertyValidator)(properties.queryStringConfig)), errors.collect(cdk.propertyValidator("sourceIpConfig", CfnListenerRule_SourceIpConfigPropertyValidator)(properties.sourceIpConfig)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "RuleConditionProperty"');
    }
    function cfnListenerRuleRuleConditionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListenerRule_RuleConditionPropertyValidator(properties).assertSuccess(), { Field: cdk.stringToCloudFormation(properties.field), HostHeaderConfig: cfnListenerRuleHostHeaderConfigPropertyToCloudFormation(properties.hostHeaderConfig), HttpHeaderConfig: cfnListenerRuleHttpHeaderConfigPropertyToCloudFormation(properties.httpHeaderConfig), HttpRequestMethodConfig: cfnListenerRuleHttpRequestMethodConfigPropertyToCloudFormation(properties.httpRequestMethodConfig), PathPatternConfig: cfnListenerRulePathPatternConfigPropertyToCloudFormation(properties.pathPatternConfig), QueryStringConfig: cfnListenerRuleQueryStringConfigPropertyToCloudFormation(properties.queryStringConfig), SourceIpConfig: cfnListenerRuleSourceIpConfigPropertyToCloudFormation(properties.sourceIpConfig), Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnListenerRuleRuleConditionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("field", "Field", properties.Field != null ? cfn_parse.FromCloudFormation.getString(properties.Field) : void 0), ret.addPropertyResult("hostHeaderConfig", "HostHeaderConfig", properties.HostHeaderConfig != null ? CfnListenerRuleHostHeaderConfigPropertyFromCloudFormation(properties.HostHeaderConfig) : void 0), ret.addPropertyResult("httpHeaderConfig", "HttpHeaderConfig", properties.HttpHeaderConfig != null ? CfnListenerRuleHttpHeaderConfigPropertyFromCloudFormation(properties.HttpHeaderConfig) : void 0), ret.addPropertyResult("httpRequestMethodConfig", "HttpRequestMethodConfig", properties.HttpRequestMethodConfig != null ? CfnListenerRuleHttpRequestMethodConfigPropertyFromCloudFormation(properties.HttpRequestMethodConfig) : void 0), ret.addPropertyResult("pathPatternConfig", "PathPatternConfig", properties.PathPatternConfig != null ? CfnListenerRulePathPatternConfigPropertyFromCloudFormation(properties.PathPatternConfig) : void 0), ret.addPropertyResult("queryStringConfig", "QueryStringConfig", properties.QueryStringConfig != null ? CfnListenerRuleQueryStringConfigPropertyFromCloudFormation(properties.QueryStringConfig) : void 0), ret.addPropertyResult("sourceIpConfig", "SourceIpConfig", properties.SourceIpConfig != null ? CfnListenerRuleSourceIpConfigPropertyFromCloudFormation(properties.SourceIpConfig) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnListenerRule_SourceIpConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "SourceIpConfigProperty"');
    }
    function cfnListenerRuleSourceIpConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListenerRule_SourceIpConfigPropertyValidator(properties).assertSuccess(), { Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnListenerRuleSourceIpConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnListenerRule_TargetGroupStickinessConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("durationSeconds", cdk.validateNumber)(properties.durationSeconds)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "TargetGroupStickinessConfigProperty"');
    }
    function cfnListenerRuleTargetGroupStickinessConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListenerRule_TargetGroupStickinessConfigPropertyValidator(properties).assertSuccess(), { DurationSeconds: cdk.numberToCloudFormation(properties.durationSeconds), Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnListenerRuleTargetGroupStickinessConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("durationSeconds", "DurationSeconds", properties.DurationSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.DurationSeconds) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnListenerRule_TargetGroupTuplePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("targetGroupArn", cdk.validateString)(properties.targetGroupArn)), errors.collect(cdk.propertyValidator("weight", cdk.validateNumber)(properties.weight)), errors.wrap('supplied properties not correct for "TargetGroupTupleProperty"');
    }
    function cfnListenerRuleTargetGroupTuplePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListenerRule_TargetGroupTuplePropertyValidator(properties).assertSuccess(), { TargetGroupArn: cdk.stringToCloudFormation(properties.targetGroupArn), Weight: cdk.numberToCloudFormation(properties.weight) }) : properties;
    }
    function CfnListenerRuleTargetGroupTuplePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("targetGroupArn", "TargetGroupArn", properties.TargetGroupArn != null ? cfn_parse.FromCloudFormation.getString(properties.TargetGroupArn) : void 0), ret.addPropertyResult("weight", "Weight", properties.Weight != null ? cfn_parse.FromCloudFormation.getNumber(properties.Weight) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLoadBalancerPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ipAddressType", cdk.validateString)(properties.ipAddressType)), errors.collect(cdk.propertyValidator("loadBalancerAttributes", cdk.listValidator(CfnLoadBalancer_LoadBalancerAttributePropertyValidator))(properties.loadBalancerAttributes)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("scheme", cdk.validateString)(properties.scheme)), errors.collect(cdk.propertyValidator("securityGroups", cdk.listValidator(cdk.validateString))(properties.securityGroups)), errors.collect(cdk.propertyValidator("subnetMappings", cdk.listValidator(CfnLoadBalancer_SubnetMappingPropertyValidator))(properties.subnetMappings)), errors.collect(cdk.propertyValidator("subnets", cdk.listValidator(cdk.validateString))(properties.subnets)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnLoadBalancerProps"');
    }
    function cfnLoadBalancerPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLoadBalancerPropsValidator(properties).assertSuccess(), { IpAddressType: cdk.stringToCloudFormation(properties.ipAddressType), LoadBalancerAttributes: cdk.listMapper(cfnLoadBalancerLoadBalancerAttributePropertyToCloudFormation)(properties.loadBalancerAttributes), Name: cdk.stringToCloudFormation(properties.name), Scheme: cdk.stringToCloudFormation(properties.scheme), SecurityGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroups), SubnetMappings: cdk.listMapper(cfnLoadBalancerSubnetMappingPropertyToCloudFormation)(properties.subnetMappings), Subnets: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnets), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnLoadBalancerPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ipAddressType", "IpAddressType", properties.IpAddressType != null ? cfn_parse.FromCloudFormation.getString(properties.IpAddressType) : void 0), ret.addPropertyResult("loadBalancerAttributes", "LoadBalancerAttributes", properties.LoadBalancerAttributes != null ? cfn_parse.FromCloudFormation.getArray(CfnLoadBalancerLoadBalancerAttributePropertyFromCloudFormation)(properties.LoadBalancerAttributes) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("scheme", "Scheme", properties.Scheme != null ? cfn_parse.FromCloudFormation.getString(properties.Scheme) : void 0), ret.addPropertyResult("securityGroups", "SecurityGroups", properties.SecurityGroups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroups) : void 0), ret.addPropertyResult("subnetMappings", "SubnetMappings", properties.SubnetMappings != null ? cfn_parse.FromCloudFormation.getArray(CfnLoadBalancerSubnetMappingPropertyFromCloudFormation)(properties.SubnetMappings) : void 0), ret.addPropertyResult("subnets", "Subnets", properties.Subnets != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Subnets) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLoadBalancer = class _CfnLoadBalancer extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLoadBalancerPropsFromCloudFormation(resourceProperties), ret = new _CfnLoadBalancer(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnLoadBalancer.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_CfnLoadBalancerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLoadBalancer), error;
        }
        this.attrCanonicalHostedZoneId = cdk.Token.asString(this.getAtt("CanonicalHostedZoneID", cdk.ResolutionTypeHint.STRING)), this.attrDnsName = cdk.Token.asString(this.getAtt("DNSName", cdk.ResolutionTypeHint.STRING)), this.attrLoadBalancerFullName = cdk.Token.asString(this.getAtt("LoadBalancerFullName", cdk.ResolutionTypeHint.STRING)), this.attrLoadBalancerName = cdk.Token.asString(this.getAtt("LoadBalancerName", cdk.ResolutionTypeHint.STRING)), this.attrSecurityGroups = cdk.Token.asList(this.getAtt("SecurityGroups", cdk.ResolutionTypeHint.STRING_LIST)), this.ipAddressType = props.ipAddressType, this.loadBalancerAttributes = props.loadBalancerAttributes, this.name = props.name, this.scheme = props.scheme, this.securityGroups = props.securityGroups, this.subnetMappings = props.subnetMappings, this.subnets = props.subnets, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ElasticLoadBalancingV2::LoadBalancer", props.tags, { tagPropertyName: "tags" }), this.type = props.type;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLoadBalancer.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { ipAddressType: this.ipAddressType, loadBalancerAttributes: this.loadBalancerAttributes, name: this.name, scheme: this.scheme, securityGroups: this.securityGroups, subnetMappings: this.subnetMappings, subnets: this.subnets, tags: this.tags.renderTags(), type: this.type };
      }
      renderProperties(props) {
        return cfnLoadBalancerPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnLoadBalancer[_d] = { fqn: "aws-cdk-lib.aws_elasticloadbalancingv2.CfnLoadBalancer", version: "2.80.0" }, CfnLoadBalancer.CFN_RESOURCE_TYPE_NAME = "AWS::ElasticLoadBalancingV2::LoadBalancer", exports2.CfnLoadBalancer = CfnLoadBalancer;
    function CfnLoadBalancer_LoadBalancerAttributePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "LoadBalancerAttributeProperty"');
    }
    function cfnLoadBalancerLoadBalancerAttributePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLoadBalancer_LoadBalancerAttributePropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnLoadBalancerLoadBalancerAttributePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLoadBalancer_SubnetMappingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allocationId", cdk.validateString)(properties.allocationId)), errors.collect(cdk.propertyValidator("iPv6Address", cdk.validateString)(properties.iPv6Address)), errors.collect(cdk.propertyValidator("privateIPv4Address", cdk.validateString)(properties.privateIPv4Address)), errors.collect(cdk.propertyValidator("subnetId", cdk.requiredValidator)(properties.subnetId)), errors.collect(cdk.propertyValidator("subnetId", cdk.validateString)(properties.subnetId)), errors.wrap('supplied properties not correct for "SubnetMappingProperty"');
    }
    function cfnLoadBalancerSubnetMappingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLoadBalancer_SubnetMappingPropertyValidator(properties).assertSuccess(), { AllocationId: cdk.stringToCloudFormation(properties.allocationId), IPv6Address: cdk.stringToCloudFormation(properties.iPv6Address), PrivateIPv4Address: cdk.stringToCloudFormation(properties.privateIPv4Address), SubnetId: cdk.stringToCloudFormation(properties.subnetId) }) : properties;
    }
    function CfnLoadBalancerSubnetMappingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allocationId", "AllocationId", properties.AllocationId != null ? cfn_parse.FromCloudFormation.getString(properties.AllocationId) : void 0), ret.addPropertyResult("iPv6Address", "IPv6Address", properties.IPv6Address != null ? cfn_parse.FromCloudFormation.getString(properties.IPv6Address) : void 0), ret.addPropertyResult("privateIPv4Address", "PrivateIPv4Address", properties.PrivateIPv4Address != null ? cfn_parse.FromCloudFormation.getString(properties.PrivateIPv4Address) : void 0), ret.addPropertyResult("subnetId", "SubnetId", cfn_parse.FromCloudFormation.getString(properties.SubnetId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTargetGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("healthCheckEnabled", cdk.validateBoolean)(properties.healthCheckEnabled)), errors.collect(cdk.propertyValidator("healthCheckIntervalSeconds", cdk.validateNumber)(properties.healthCheckIntervalSeconds)), errors.collect(cdk.propertyValidator("healthCheckPath", cdk.validateString)(properties.healthCheckPath)), errors.collect(cdk.propertyValidator("healthCheckPort", cdk.validateString)(properties.healthCheckPort)), errors.collect(cdk.propertyValidator("healthCheckProtocol", cdk.validateString)(properties.healthCheckProtocol)), errors.collect(cdk.propertyValidator("healthCheckTimeoutSeconds", cdk.validateNumber)(properties.healthCheckTimeoutSeconds)), errors.collect(cdk.propertyValidator("healthyThresholdCount", cdk.validateNumber)(properties.healthyThresholdCount)), errors.collect(cdk.propertyValidator("ipAddressType", cdk.validateString)(properties.ipAddressType)), errors.collect(cdk.propertyValidator("matcher", CfnTargetGroup_MatcherPropertyValidator)(properties.matcher)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.collect(cdk.propertyValidator("protocolVersion", cdk.validateString)(properties.protocolVersion)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("targetGroupAttributes", cdk.listValidator(CfnTargetGroup_TargetGroupAttributePropertyValidator))(properties.targetGroupAttributes)), errors.collect(cdk.propertyValidator("targetType", cdk.validateString)(properties.targetType)), errors.collect(cdk.propertyValidator("targets", cdk.listValidator(CfnTargetGroup_TargetDescriptionPropertyValidator))(properties.targets)), errors.collect(cdk.propertyValidator("unhealthyThresholdCount", cdk.validateNumber)(properties.unhealthyThresholdCount)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "CfnTargetGroupProps"');
    }
    function cfnTargetGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTargetGroupPropsValidator(properties).assertSuccess(), { HealthCheckEnabled: cdk.booleanToCloudFormation(properties.healthCheckEnabled), HealthCheckIntervalSeconds: cdk.numberToCloudFormation(properties.healthCheckIntervalSeconds), HealthCheckPath: cdk.stringToCloudFormation(properties.healthCheckPath), HealthCheckPort: cdk.stringToCloudFormation(properties.healthCheckPort), HealthCheckProtocol: cdk.stringToCloudFormation(properties.healthCheckProtocol), HealthCheckTimeoutSeconds: cdk.numberToCloudFormation(properties.healthCheckTimeoutSeconds), HealthyThresholdCount: cdk.numberToCloudFormation(properties.healthyThresholdCount), IpAddressType: cdk.stringToCloudFormation(properties.ipAddressType), Matcher: cfnTargetGroupMatcherPropertyToCloudFormation(properties.matcher), Name: cdk.stringToCloudFormation(properties.name), Port: cdk.numberToCloudFormation(properties.port), Protocol: cdk.stringToCloudFormation(properties.protocol), ProtocolVersion: cdk.stringToCloudFormation(properties.protocolVersion), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TargetGroupAttributes: cdk.listMapper(cfnTargetGroupTargetGroupAttributePropertyToCloudFormation)(properties.targetGroupAttributes), Targets: cdk.listMapper(cfnTargetGroupTargetDescriptionPropertyToCloudFormation)(properties.targets), TargetType: cdk.stringToCloudFormation(properties.targetType), UnhealthyThresholdCount: cdk.numberToCloudFormation(properties.unhealthyThresholdCount), VpcId: cdk.stringToCloudFormation(properties.vpcId) }) : properties;
    }
    function CfnTargetGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("healthCheckEnabled", "HealthCheckEnabled", properties.HealthCheckEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.HealthCheckEnabled) : void 0), ret.addPropertyResult("healthCheckIntervalSeconds", "HealthCheckIntervalSeconds", properties.HealthCheckIntervalSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.HealthCheckIntervalSeconds) : void 0), ret.addPropertyResult("healthCheckPath", "HealthCheckPath", properties.HealthCheckPath != null ? cfn_parse.FromCloudFormation.getString(properties.HealthCheckPath) : void 0), ret.addPropertyResult("healthCheckPort", "HealthCheckPort", properties.HealthCheckPort != null ? cfn_parse.FromCloudFormation.getString(properties.HealthCheckPort) : void 0), ret.addPropertyResult("healthCheckProtocol", "HealthCheckProtocol", properties.HealthCheckProtocol != null ? cfn_parse.FromCloudFormation.getString(properties.HealthCheckProtocol) : void 0), ret.addPropertyResult("healthCheckTimeoutSeconds", "HealthCheckTimeoutSeconds", properties.HealthCheckTimeoutSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.HealthCheckTimeoutSeconds) : void 0), ret.addPropertyResult("healthyThresholdCount", "HealthyThresholdCount", properties.HealthyThresholdCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.HealthyThresholdCount) : void 0), ret.addPropertyResult("ipAddressType", "IpAddressType", properties.IpAddressType != null ? cfn_parse.FromCloudFormation.getString(properties.IpAddressType) : void 0), ret.addPropertyResult("matcher", "Matcher", properties.Matcher != null ? CfnTargetGroupMatcherPropertyFromCloudFormation(properties.Matcher) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addPropertyResult("protocol", "Protocol", properties.Protocol != null ? cfn_parse.FromCloudFormation.getString(properties.Protocol) : void 0), ret.addPropertyResult("protocolVersion", "ProtocolVersion", properties.ProtocolVersion != null ? cfn_parse.FromCloudFormation.getString(properties.ProtocolVersion) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("targetGroupAttributes", "TargetGroupAttributes", properties.TargetGroupAttributes != null ? cfn_parse.FromCloudFormation.getArray(CfnTargetGroupTargetGroupAttributePropertyFromCloudFormation)(properties.TargetGroupAttributes) : void 0), ret.addPropertyResult("targets", "Targets", properties.Targets != null ? cfn_parse.FromCloudFormation.getArray(CfnTargetGroupTargetDescriptionPropertyFromCloudFormation)(properties.Targets) : void 0), ret.addPropertyResult("targetType", "TargetType", properties.TargetType != null ? cfn_parse.FromCloudFormation.getString(properties.TargetType) : void 0), ret.addPropertyResult("unhealthyThresholdCount", "UnhealthyThresholdCount", properties.UnhealthyThresholdCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.UnhealthyThresholdCount) : void 0), ret.addPropertyResult("vpcId", "VpcId", properties.VpcId != null ? cfn_parse.FromCloudFormation.getString(properties.VpcId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTargetGroup = class _CfnTargetGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTargetGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnTargetGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnTargetGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_CfnTargetGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTargetGroup), error;
        }
        this.attrLoadBalancerArns = cdk.Token.asList(this.getAtt("LoadBalancerArns", cdk.ResolutionTypeHint.STRING_LIST)), this.attrTargetGroupArn = cdk.Token.asString(this.getAtt("TargetGroupArn", cdk.ResolutionTypeHint.STRING)), this.attrTargetGroupFullName = cdk.Token.asString(this.getAtt("TargetGroupFullName", cdk.ResolutionTypeHint.STRING)), this.attrTargetGroupName = cdk.Token.asString(this.getAtt("TargetGroupName", cdk.ResolutionTypeHint.STRING)), this.healthCheckEnabled = props.healthCheckEnabled, this.healthCheckIntervalSeconds = props.healthCheckIntervalSeconds, this.healthCheckPath = props.healthCheckPath, this.healthCheckPort = props.healthCheckPort, this.healthCheckProtocol = props.healthCheckProtocol, this.healthCheckTimeoutSeconds = props.healthCheckTimeoutSeconds, this.healthyThresholdCount = props.healthyThresholdCount, this.ipAddressType = props.ipAddressType, this.matcher = props.matcher, this.name = props.name, this.port = props.port, this.protocol = props.protocol, this.protocolVersion = props.protocolVersion, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ElasticLoadBalancingV2::TargetGroup", props.tags, { tagPropertyName: "tags" }), this.targetGroupAttributes = props.targetGroupAttributes, this.targets = props.targets, this.targetType = props.targetType, this.unhealthyThresholdCount = props.unhealthyThresholdCount, this.vpcId = props.vpcId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTargetGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { healthCheckEnabled: this.healthCheckEnabled, healthCheckIntervalSeconds: this.healthCheckIntervalSeconds, healthCheckPath: this.healthCheckPath, healthCheckPort: this.healthCheckPort, healthCheckProtocol: this.healthCheckProtocol, healthCheckTimeoutSeconds: this.healthCheckTimeoutSeconds, healthyThresholdCount: this.healthyThresholdCount, ipAddressType: this.ipAddressType, matcher: this.matcher, name: this.name, port: this.port, protocol: this.protocol, protocolVersion: this.protocolVersion, tags: this.tags.renderTags(), targetGroupAttributes: this.targetGroupAttributes, targets: this.targets, targetType: this.targetType, unhealthyThresholdCount: this.unhealthyThresholdCount, vpcId: this.vpcId };
      }
      renderProperties(props) {
        return cfnTargetGroupPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnTargetGroup[_e] = { fqn: "aws-cdk-lib.aws_elasticloadbalancingv2.CfnTargetGroup", version: "2.80.0" }, CfnTargetGroup.CFN_RESOURCE_TYPE_NAME = "AWS::ElasticLoadBalancingV2::TargetGroup", exports2.CfnTargetGroup = CfnTargetGroup;
    function CfnTargetGroup_MatcherPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("grpcCode", cdk.validateString)(properties.grpcCode)), errors.collect(cdk.propertyValidator("httpCode", cdk.validateString)(properties.httpCode)), errors.wrap('supplied properties not correct for "MatcherProperty"');
    }
    function cfnTargetGroupMatcherPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTargetGroup_MatcherPropertyValidator(properties).assertSuccess(), { GrpcCode: cdk.stringToCloudFormation(properties.grpcCode), HttpCode: cdk.stringToCloudFormation(properties.httpCode) }) : properties;
    }
    function CfnTargetGroupMatcherPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("grpcCode", "GrpcCode", properties.GrpcCode != null ? cfn_parse.FromCloudFormation.getString(properties.GrpcCode) : void 0), ret.addPropertyResult("httpCode", "HttpCode", properties.HttpCode != null ? cfn_parse.FromCloudFormation.getString(properties.HttpCode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTargetGroup_TargetDescriptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availabilityZone", cdk.validateString)(properties.availabilityZone)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.wrap('supplied properties not correct for "TargetDescriptionProperty"');
    }
    function cfnTargetGroupTargetDescriptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTargetGroup_TargetDescriptionPropertyValidator(properties).assertSuccess(), { AvailabilityZone: cdk.stringToCloudFormation(properties.availabilityZone), Id: cdk.stringToCloudFormation(properties.id), Port: cdk.numberToCloudFormation(properties.port) }) : properties;
    }
    function CfnTargetGroupTargetDescriptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("availabilityZone", "AvailabilityZone", properties.AvailabilityZone != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityZone) : void 0), ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTargetGroup_TargetGroupAttributePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TargetGroupAttributeProperty"');
    }
    function cfnTargetGroupTargetGroupAttributePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTargetGroup_TargetGroupAttributePropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnTargetGroupTargetGroupAttributePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/alb/application-listener-action.js
var require_application_listener_action = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/alb/application-listener-action.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.UnauthenticatedAction = exports2.ListenerAction = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var aws_ec2_1 = require_aws_ec2();
    var core_1 = require_core2();
    var ListenerAction = class _ListenerAction {
      static authenticateOidc(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_AuthenticateOidcOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.authenticateOidc), error;
        }
        return new AuthenticateOidcAction(options);
      }
      static forward(targetGroups, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_ForwardOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.forward), error;
        }
        if (targetGroups.length === 0)
          throw new Error("Need at least one targetGroup in a ListenerAction.forward()");
        return targetGroups.length === 1 && options.stickinessDuration === void 0 ? new TargetGroupListenerAction(targetGroups, { type: "forward", targetGroupArn: targetGroups[0].targetGroupArn }) : _ListenerAction.weightedForward(targetGroups.map((g) => ({ targetGroup: g, weight: 1 })), options);
      }
      static weightedForward(targetGroups, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_ForwardOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.weightedForward), error;
        }
        if (targetGroups.length === 0)
          throw new Error("Need at least one targetGroup in a ListenerAction.weightedForward()");
        return new TargetGroupListenerAction(targetGroups.map((g) => g.targetGroup), { type: "forward", forwardConfig: { targetGroups: targetGroups.map((g) => ({ targetGroupArn: g.targetGroup.targetGroupArn, weight: g.weight })), targetGroupStickinessConfig: options.stickinessDuration ? { durationSeconds: options.stickinessDuration.toSeconds(), enabled: true } : void 0 } });
      }
      static fixedResponse(statusCode, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_FixedResponseOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fixedResponse), error;
        }
        return new _ListenerAction({ type: "fixed-response", fixedResponseConfig: { statusCode: core_1.Tokenization.stringifyNumber(statusCode), contentType: options.contentType, messageBody: options.messageBody } });
      }
      static redirect(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_RedirectOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.redirect), error;
        }
        if ([options.host, options.path, options.port, options.protocol, options.query].findIndex((x) => x !== void 0) === -1)
          throw new Error("To prevent redirect loops, set at least one of 'protocol', 'host', 'port', 'path', or 'query'.");
        return new _ListenerAction({ type: "redirect", redirectConfig: { statusCode: options.permanent ? "HTTP_301" : "HTTP_302", host: options.host, path: options.path, port: options.port, protocol: options.protocol, query: options.query } });
      }
      constructor(defaultActionJson, next) {
        this.defaultActionJson = defaultActionJson, this.next = next;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_CfnListener_ActionProperty(defaultActionJson), jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_ListenerAction(next);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ListenerAction), error;
        }
      }
      renderRuleActions() {
        const actionJson = this._actionJson ?? this.defaultActionJson;
        return this._renumber([actionJson, ...this.next?.renderRuleActions() ?? []]);
      }
      renderActions() {
        return this._renumber([this.defaultActionJson, ...this.next?.renderActions() ?? []]);
      }
      bind(scope, listener, associatingConstruct) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_IApplicationListener(listener);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        this.next?.bind(scope, listener, associatingConstruct);
      }
      _renumber(actions) {
        return actions.length < 2 ? actions : actions.map((action, i) => ({ ...action, order: i + 1 }));
      }
      renumber(actions) {
        return this._renumber(actions);
      }
      addRuleAction(actionJson) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_CfnListenerRule_ActionProperty(actionJson);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addRuleAction), error;
        }
        if (this._actionJson)
          throw new Error("rule action is already set");
        this._actionJson = actionJson;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ListenerAction[_a] = { fqn: "aws-cdk-lib.aws_elasticloadbalancingv2.ListenerAction", version: "2.80.0" }, exports2.ListenerAction = ListenerAction;
    var UnauthenticatedAction;
    (function(UnauthenticatedAction2) {
      UnauthenticatedAction2.DENY = "deny", UnauthenticatedAction2.ALLOW = "allow", UnauthenticatedAction2.AUTHENTICATE = "authenticate";
    })(UnauthenticatedAction = exports2.UnauthenticatedAction || (exports2.UnauthenticatedAction = {}));
    var TargetGroupListenerAction = class extends ListenerAction {
      constructor(targetGroups, defaultActionJson) {
        super(defaultActionJson), this.targetGroups = targetGroups;
      }
      bind(_scope, listener, associatingConstruct) {
        for (const tg of this.targetGroups)
          tg.registerListener(listener, associatingConstruct);
      }
    };
    var AuthenticateOidcAction = class extends ListenerAction {
      constructor(options) {
        const defaultActionConfig = { authorizationEndpoint: options.authorizationEndpoint, clientId: options.clientId, clientSecret: options.clientSecret.unsafeUnwrap(), issuer: options.issuer, tokenEndpoint: options.tokenEndpoint, userInfoEndpoint: options.userInfoEndpoint, authenticationRequestExtraParams: options.authenticationRequestExtraParams, onUnauthenticatedRequest: options.onUnauthenticatedRequest, scope: options.scope, sessionCookieName: options.sessionCookieName, sessionTimeout: options.sessionTimeout?.toSeconds().toString() };
        super({ type: "authenticate-oidc", authenticateOidcConfig: defaultActionConfig }, options.next), this.allowHttpsOutbound = options.allowHttpsOutbound ?? true, this.addRuleAction({ type: "authenticate-oidc", authenticateOidcConfig: { ...defaultActionConfig, sessionTimeout: options.sessionTimeout?.toSeconds() } });
      }
      bind(scope, listener, associatingConstruct) {
        super.bind(scope, listener, associatingConstruct), this.allowHttpsOutbound && listener.connections.allowToAnyIpv4(aws_ec2_1.Port.tcp(443), "Allow to IdP endpoint");
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/alb/application-listener-certificate.js
var require_application_listener_certificate = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/alb/application-listener-certificate.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ApplicationListenerCertificate = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var elasticloadbalancingv2_generated_1 = require_elasticloadbalancingv2_generated();
    var ApplicationListenerCertificate = class _ApplicationListenerCertificate extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationListenerCertificateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ApplicationListenerCertificate), error;
        }
        if (!props.certificateArns && !props.certificates)
          throw new Error("At least one of 'certificateArns' or 'certificates' is required");
        const certificates = [...(props.certificates || []).map((c) => ({ certificateArn: c.certificateArn })), ...(props.certificateArns || []).map((certificateArn) => ({ certificateArn }))];
        new elasticloadbalancingv2_generated_1.CfnListenerCertificate(this, "Resource", { listenerArn: props.listener.listenerArn, certificates });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ApplicationListenerCertificate[_a] = { fqn: "aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationListenerCertificate", version: "2.80.0" }, exports2.ApplicationListenerCertificate = ApplicationListenerCertificate;
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/alb/application-listener-rule.js
var require_application_listener_rule = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/alb/application-listener-rule.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ApplicationListenerRule = exports2.ContentType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var application_listener_action_1 = require_application_listener_action();
    var cdk = require_core2();
    var elasticloadbalancingv2_generated_1 = require_elasticloadbalancingv2_generated();
    var ContentType;
    (function(ContentType2) {
      ContentType2.TEXT_PLAIN = "text/plain", ContentType2.TEXT_CSS = "text/css", ContentType2.TEXT_HTML = "text/html", ContentType2.APPLICATION_JAVASCRIPT = "application/javascript", ContentType2.APPLICATION_JSON = "application/json";
    })(ContentType = exports2.ContentType || (exports2.ContentType = {}));
    var ApplicationListenerRule = class _ApplicationListenerRule extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id), this.legacyConditions = {};
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationListenerRuleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ApplicationListenerRule), error;
        }
        this.conditions = props.conditions || [];
        const hasPathPatterns = props.pathPatterns || props.pathPattern;
        if (this.conditions.length === 0 && !props.hostHeader && !hasPathPatterns)
          throw new Error("At least one of 'conditions', 'hostHeader', 'pathPattern' or 'pathPatterns' is required when defining a load balancing rule.");
        const providedActions = ["action", "targetGroups", "fixedResponse", "redirectResponse"].filter((action) => props[action] !== void 0);
        if (providedActions.length > 1)
          throw new Error(`'${providedActions}' specified together, specify only one`);
        if (!cdk.Token.isUnresolved(props.priority) && props.priority <= 0)
          throw new Error("Priority must have value greater than or equal to 1");
        this.listener = props.listener;
        const resource = new elasticloadbalancingv2_generated_1.CfnListenerRule(this, "Resource", { listenerArn: props.listener.listenerArn, priority: props.priority, conditions: cdk.Lazy.any({ produce: () => this.renderConditions() }), actions: cdk.Lazy.any({ produce: () => this.action ? this.action.renderRuleActions() : [] }) });
        if (props.hostHeader && this.setCondition("host-header", [props.hostHeader]), hasPathPatterns) {
          if (props.pathPattern && props.pathPatterns)
            throw new Error("Both `pathPatterns` and `pathPattern` are specified, specify only one");
          const pathPattern = props.pathPattern ? [props.pathPattern] : props.pathPatterns;
          this.setCondition("path-pattern", pathPattern);
        }
        props.action && this.configureAction(props.action), props.targetGroups && this.configureAction(application_listener_action_1.ListenerAction.forward(props.targetGroups)), props.fixedResponse ? this.addFixedResponse(props.fixedResponse) : props.redirectResponse && this.addRedirectResponse(props.redirectResponse), this.listenerRuleArn = resource.ref, this.node.addValidation({ validate: () => this.validateListenerRule() });
      }
      setCondition(field, values) {
        if (values === void 0) {
          delete this.legacyConditions[field];
          return;
        }
        this.legacyConditions[field] = values;
      }
      addCondition(condition) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_ListenerCondition(condition);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addCondition), error;
        }
        this.conditions.push(condition);
      }
      configureAction(action) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_ListenerAction(action);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.configureAction), error;
        }
        this.action && cdk.Annotations.of(this).addWarning("An Action already existed on this ListenerRule and was replaced. Configure exactly one default Action."), action.bind(this, this.listener, this), this.action = action;
      }
      addTargetGroup(targetGroup) {
        this.configureAction(application_listener_action_1.ListenerAction.forward([targetGroup]));
      }
      addFixedResponse(fixedResponse) {
        validateFixedResponse(fixedResponse), this.configureAction(application_listener_action_1.ListenerAction.fixedResponse(cdk.Token.asNumber(fixedResponse.statusCode), { contentType: fixedResponse.contentType, messageBody: fixedResponse.messageBody }));
      }
      addRedirectResponse(redirectResponse) {
        validateRedirectResponse(redirectResponse), this.configureAction(application_listener_action_1.ListenerAction.redirect({ host: redirectResponse.host, path: redirectResponse.path, permanent: redirectResponse.statusCode === "HTTP_301", port: redirectResponse.port, protocol: redirectResponse.protocol, query: redirectResponse.query }));
      }
      validateListenerRule() {
        return this.action === void 0 ? ["Listener rule needs at least one action"] : Object.keys(this.legacyConditions).length === 0 && this.conditions.length === 0 ? ["Listener rule needs at least one condition"] : [];
      }
      renderConditions() {
        const legacyConditions = Object.entries(this.legacyConditions).map(([field, values]) => ({ field, values })), conditions = this.conditions.map((condition) => condition.renderRawCondition());
        return [...legacyConditions, ...conditions];
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ApplicationListenerRule[_a] = { fqn: "aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationListenerRule", version: "2.80.0" }, exports2.ApplicationListenerRule = ApplicationListenerRule;
    function validateFixedResponse(fixedResponse) {
      if (fixedResponse.statusCode && !/^(2|4|5)\d\d$/.test(fixedResponse.statusCode))
        throw new Error("`statusCode` must be 2XX, 4XX or 5XX.");
      if (fixedResponse.messageBody && fixedResponse.messageBody.length > 1024)
        throw new Error("`messageBody` cannot have more than 1024 characters.");
    }
    function validateRedirectResponse(redirectResponse) {
      if (redirectResponse.protocol && !/^(HTTPS?|#\{protocol\})$/i.test(redirectResponse.protocol))
        throw new Error("`protocol` must be HTTP, HTTPS, or #{protocol}.");
      if (!redirectResponse.statusCode || !/^HTTP_30[12]$/.test(redirectResponse.statusCode))
        throw new Error("`statusCode` must be HTTP_301 or HTTP_302.");
    }
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/elasticloadbalancingv2-canned-metrics.generated.js
var require_elasticloadbalancingv2_canned_metrics_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/elasticloadbalancingv2-canned-metrics.generated.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.NetworkELBMetrics = exports2.GatewayELBMetrics = exports2.ApplicationELBMetrics = void 0;
    var ApplicationELBMetrics = class {
      static activeConnectionCountSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "ActiveConnectionCount", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static clientTlsNegotiationErrorCountSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "ClientTLSNegotiationErrorCount", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static consumedLcUsAverage(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "ConsumedLCUs", dimensionsMap: dimensions, statistic: "Average" };
      }
      static desyncMitigationModeNonCompliantRequestCountSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "DesyncMitigationMode_NonCompliant_Request_Count", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static elbAuthErrorSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "ELBAuthError", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static elbAuthFailureSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "ELBAuthFailure", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static elbAuthLatencySum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "ELBAuthLatency", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static elbAuthRefreshTokenSuccessSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "ELBAuthRefreshTokenSuccess", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static elbAuthSuccessSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "ELBAuthSuccess", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static elbAuthUserClaimsSizeExceededSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "ELBAuthUserClaimsSizeExceeded", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static grpcRequestCountSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "GrpcRequestCount", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static httpFixedResponseCountSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "HTTP_Fixed_Response_Count", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static httpRedirectCountSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "HTTP_Redirect_Count", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static httpRedirectUrlLimitExceededCountSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "HTTP_Redirect_Url_Limit_Exceeded_Count", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static httpCodeElb3XxCountSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "HTTPCode_ELB_3XX_Count", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static httpCodeElb4XxCountSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "HTTPCode_ELB_4XX_Count", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static httpCodeElb5XxCountSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "HTTPCode_ELB_5XX_Count", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static httpCodeElb500CountSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "HTTPCode_ELB_500_Count", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static httpCodeElb502CountSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "HTTPCode_ELB_502_Count", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static httpCodeElb503CountSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "HTTPCode_ELB_503_Count", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static httpCodeElb504CountSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "HTTPCode_ELB_504_Count", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static httpCodeTarget2XxCountSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "HTTPCode_Target_2XX_Count", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static httpCodeTarget3XxCountSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "HTTPCode_Target_3XX_Count", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static httpCodeTarget4XxCountSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "HTTPCode_Target_4XX_Count", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static httpCodeTarget5XxCountSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "HTTPCode_Target_5XX_Count", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static iPv6ProcessedBytesSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "IPv6ProcessedBytes", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static iPv6RequestCountSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "IPv6RequestCount", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static newConnectionCountSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "NewConnectionCount", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static nonStickyRequestCountSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "NonStickyRequestCount", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static processedBytesSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "ProcessedBytes", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static rejectedConnectionCountSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "RejectedConnectionCount", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static requestCountSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "RequestCount", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static ruleEvaluationsSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "RuleEvaluations", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static targetConnectionErrorCountSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "TargetConnectionErrorCount", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static targetResponseTimeAverage(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "TargetResponseTime", dimensionsMap: dimensions, statistic: "Average" };
      }
      static targetTlsNegotiationErrorCountSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "TargetTLSNegotiationErrorCount", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static lambdaTargetProcessedBytesSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "LambdaTargetProcessedBytes", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static requestCountPerTargetSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "RequestCountPerTarget", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static lambdaInternalErrorSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "LambdaInternalError", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static lambdaUserErrorSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "LambdaUserError", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static droppedInvalidHeaderRequestCountSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "DroppedInvalidHeaderRequestCount", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static forwardedInvalidHeaderRequestCountSum(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "ForwardedInvalidHeaderRequestCount", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static healthyHostCountAverage(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "HealthyHostCount", dimensionsMap: dimensions, statistic: "Average" };
      }
      static unHealthyHostCountAverage(dimensions) {
        return { namespace: "AWS/ApplicationELB", metricName: "UnHealthyHostCount", dimensionsMap: dimensions, statistic: "Average" };
      }
    };
    exports2.ApplicationELBMetrics = ApplicationELBMetrics;
    var GatewayELBMetrics = class {
      static healthyHostCountAverage(dimensions) {
        return { namespace: "AWS/GatewayELB", metricName: "HealthyHostCount", dimensionsMap: dimensions, statistic: "Average" };
      }
      static unHealthyHostCountAverage(dimensions) {
        return { namespace: "AWS/GatewayELB", metricName: "UnHealthyHostCount", dimensionsMap: dimensions, statistic: "Average" };
      }
      static activeFlowCountSum(dimensions) {
        return { namespace: "AWS/GatewayELB", metricName: "ActiveFlowCount", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static consumedLcUsAverage(dimensions) {
        return { namespace: "AWS/GatewayELB", metricName: "ConsumedLCUs", dimensionsMap: dimensions, statistic: "Average" };
      }
      static newFlowCountSum(dimensions) {
        return { namespace: "AWS/GatewayELB", metricName: "NewFlowCount", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static processedBytesSum(dimensions) {
        return { namespace: "AWS/GatewayELB", metricName: "ProcessedBytes", dimensionsMap: dimensions, statistic: "Sum" };
      }
    };
    exports2.GatewayELBMetrics = GatewayELBMetrics;
    var NetworkELBMetrics = class {
      static activeFlowCountAverage(dimensions) {
        return { namespace: "AWS/NetworkELB", metricName: "ActiveFlowCount", dimensionsMap: dimensions, statistic: "Average" };
      }
      static activeFlowCountTcpAverage(dimensions) {
        return { namespace: "AWS/NetworkELB", metricName: "ActiveFlowCount_TCP", dimensionsMap: dimensions, statistic: "Average" };
      }
      static activeFlowCountTlsAverage(dimensions) {
        return { namespace: "AWS/NetworkELB", metricName: "ActiveFlowCount_TLS", dimensionsMap: dimensions, statistic: "Average" };
      }
      static activeFlowCountUdpAverage(dimensions) {
        return { namespace: "AWS/NetworkELB", metricName: "ActiveFlowCount_UDP", dimensionsMap: dimensions, statistic: "Average" };
      }
      static clientTlsNegotiationErrorCountSum(dimensions) {
        return { namespace: "AWS/NetworkELB", metricName: "ClientTLSNegotiationErrorCount", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static consumedLcUsAverage(dimensions) {
        return { namespace: "AWS/NetworkELB", metricName: "ConsumedLCUs", dimensionsMap: dimensions, statistic: "Average" };
      }
      static consumedLcUsTcpAverage(dimensions) {
        return { namespace: "AWS/NetworkELB", metricName: "ConsumedLCUs_TCP", dimensionsMap: dimensions, statistic: "Average" };
      }
      static consumedLcUsTlsAverage(dimensions) {
        return { namespace: "AWS/NetworkELB", metricName: "ConsumedLCUs_TLS", dimensionsMap: dimensions, statistic: "Average" };
      }
      static consumedLcUsUdpAverage(dimensions) {
        return { namespace: "AWS/NetworkELB", metricName: "ConsumedLCUs_UDP", dimensionsMap: dimensions, statistic: "Average" };
      }
      static newFlowCountSum(dimensions) {
        return { namespace: "AWS/NetworkELB", metricName: "NewFlowCount", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static newFlowCountTcpSum(dimensions) {
        return { namespace: "AWS/NetworkELB", metricName: "NewFlowCount_TCP", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static newFlowCountTlsSum(dimensions) {
        return { namespace: "AWS/NetworkELB", metricName: "NewFlowCount_TLS", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static newFlowCountUdpSum(dimensions) {
        return { namespace: "AWS/NetworkELB", metricName: "NewFlowCount_UDP", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static processedBytesSum(dimensions) {
        return { namespace: "AWS/NetworkELB", metricName: "ProcessedBytes", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static processedBytesTcpSum(dimensions) {
        return { namespace: "AWS/NetworkELB", metricName: "ProcessedBytes_TCP", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static processedBytesTlsSum(dimensions) {
        return { namespace: "AWS/NetworkELB", metricName: "ProcessedBytes_TLS", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static processedBytesUdpSum(dimensions) {
        return { namespace: "AWS/NetworkELB", metricName: "ProcessedBytes_UDP", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static targetTlsNegotiationErrorCountSum(dimensions) {
        return { namespace: "AWS/NetworkELB", metricName: "TargetTLSNegotiationErrorCount", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static tcpClientResetCountSum(dimensions) {
        return { namespace: "AWS/NetworkELB", metricName: "TCP_Client_Reset_Count", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static tcpElbResetCountSum(dimensions) {
        return { namespace: "AWS/NetworkELB", metricName: "TCP_ELB_Reset_Count", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static tcpTargetResetCountSum(dimensions) {
        return { namespace: "AWS/NetworkELB", metricName: "TCP_Target_Reset_Count", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static healthyHostCountMinimum(dimensions) {
        return { namespace: "AWS/NetworkELB", metricName: "HealthyHostCount", dimensionsMap: dimensions, statistic: "Minimum" };
      }
      static unHealthyHostCountMaximum(dimensions) {
        return { namespace: "AWS/NetworkELB", metricName: "UnHealthyHostCount", dimensionsMap: dimensions, statistic: "Maximum" };
      }
    };
    exports2.NetworkELBMetrics = NetworkELBMetrics;
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/shared/enums.js
var require_enums = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/shared/enums.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DesyncMitigationMode = exports2.TargetGroupLoadBalancingAlgorithmType = exports2.AlpnPolicy = exports2.TargetType = exports2.SslPolicy = exports2.ApplicationProtocolVersion = exports2.ApplicationProtocol = exports2.Protocol = exports2.IpAddressType = void 0;
    var IpAddressType;
    (function(IpAddressType2) {
      IpAddressType2.IPV4 = "ipv4", IpAddressType2.DUAL_STACK = "dualstack";
    })(IpAddressType = exports2.IpAddressType || (exports2.IpAddressType = {}));
    var Protocol;
    (function(Protocol2) {
      Protocol2.HTTP = "HTTP", Protocol2.HTTPS = "HTTPS", Protocol2.TCP = "TCP", Protocol2.TLS = "TLS", Protocol2.UDP = "UDP", Protocol2.TCP_UDP = "TCP_UDP";
    })(Protocol = exports2.Protocol || (exports2.Protocol = {}));
    var ApplicationProtocol;
    (function(ApplicationProtocol2) {
      ApplicationProtocol2.HTTP = "HTTP", ApplicationProtocol2.HTTPS = "HTTPS";
    })(ApplicationProtocol = exports2.ApplicationProtocol || (exports2.ApplicationProtocol = {}));
    var ApplicationProtocolVersion;
    (function(ApplicationProtocolVersion2) {
      ApplicationProtocolVersion2.GRPC = "GRPC", ApplicationProtocolVersion2.HTTP1 = "HTTP1", ApplicationProtocolVersion2.HTTP2 = "HTTP2";
    })(ApplicationProtocolVersion = exports2.ApplicationProtocolVersion || (exports2.ApplicationProtocolVersion = {}));
    var SslPolicy;
    (function(SslPolicy2) {
      SslPolicy2.RECOMMENDED_TLS = "ELBSecurityPolicy-TLS13-1-2-2021-06", SslPolicy2.RECOMMENDED = "ELBSecurityPolicy-2016-08", SslPolicy2.TLS13_RES = "ELBSecurityPolicy-TLS13-1-2-Res-2021-06", SslPolicy2.TLS13_EXT1 = "ELBSecurityPolicy-TLS13-1-2-Ext1-2021-06", SslPolicy2.TLS13_EXT2 = "ELBSecurityPolicy-TLS13-1-2-Ext2-2021-06", SslPolicy2.TLS13_10 = "ELBSecurityPolicy-TLS13-1-0-2021-06", SslPolicy2.TLS13_11 = "ELBSecurityPolicy-TLS13-1-1-2021-06", SslPolicy2.TLS13_13 = "ELBSecurityPolicy-TLS13-1-3-2021-06", SslPolicy2.FORWARD_SECRECY_TLS12_RES_GCM = "ELBSecurityPolicy-FS-1-2-Res-2020-10", SslPolicy2.FORWARD_SECRECY_TLS12_RES = "ELBSecurityPolicy-FS-1-2-Res-2019-08", SslPolicy2.FORWARD_SECRECY_TLS12 = "ELBSecurityPolicy-FS-1-2-2019-08", SslPolicy2.FORWARD_SECRECY_TLS11 = "ELBSecurityPolicy-FS-1-1-2019-08", SslPolicy2.FORWARD_SECRECY = "ELBSecurityPolicy-FS-2018-06", SslPolicy2.TLS12 = "ELBSecurityPolicy-TLS-1-2-2017-01", SslPolicy2.TLS12_EXT = "ELBSecurityPolicy-TLS-1-2-Ext-2018-06", SslPolicy2.TLS11 = "ELBSecurityPolicy-TLS-1-1-2017-01", SslPolicy2.LEGACY = "ELBSecurityPolicy-TLS-1-0-2015-04";
    })(SslPolicy = exports2.SslPolicy || (exports2.SslPolicy = {}));
    var TargetType;
    (function(TargetType2) {
      TargetType2.INSTANCE = "instance", TargetType2.IP = "ip", TargetType2.LAMBDA = "lambda", TargetType2.ALB = "alb";
    })(TargetType = exports2.TargetType || (exports2.TargetType = {}));
    var AlpnPolicy;
    (function(AlpnPolicy2) {
      AlpnPolicy2.HTTP1_ONLY = "HTTP1Only", AlpnPolicy2.HTTP2_ONLY = "HTTP2Only", AlpnPolicy2.HTTP2_OPTIONAL = "HTTP2Optional", AlpnPolicy2.HTTP2_PREFERRED = "HTTP2Preferred", AlpnPolicy2.NONE = "None";
    })(AlpnPolicy = exports2.AlpnPolicy || (exports2.AlpnPolicy = {}));
    var TargetGroupLoadBalancingAlgorithmType;
    (function(TargetGroupLoadBalancingAlgorithmType2) {
      TargetGroupLoadBalancingAlgorithmType2.ROUND_ROBIN = "round_robin", TargetGroupLoadBalancingAlgorithmType2.LEAST_OUTSTANDING_REQUESTS = "least_outstanding_requests";
    })(TargetGroupLoadBalancingAlgorithmType = exports2.TargetGroupLoadBalancingAlgorithmType || (exports2.TargetGroupLoadBalancingAlgorithmType = {}));
    var DesyncMitigationMode;
    (function(DesyncMitigationMode2) {
      DesyncMitigationMode2.MONITOR = "monitor", DesyncMitigationMode2.DEFENSIVE = "defensive", DesyncMitigationMode2.STRICTEST = "strictest";
    })(DesyncMitigationMode = exports2.DesyncMitigationMode || (exports2.DesyncMitigationMode = {}));
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/shared/util.js
var require_util15 = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/shared/util.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.parseTargetGroupFullName = exports2.parseLoadBalancerFullName = exports2.mapTagMapToCxschema = exports2.validateNetworkProtocol = exports2.ifUndefined = exports2.determineProtocolAndPort = exports2.defaultProtocolForPort = exports2.defaultPortForProtocol = exports2.renderAttributes = void 0;
    var enums_1 = require_enums();
    var core_1 = require_core2();
    function renderAttributes(attributes) {
      const ret = [];
      for (const [key, value] of Object.entries(attributes))
        value !== void 0 && ret.push({ key, value });
      return ret;
    }
    exports2.renderAttributes = renderAttributes;
    function defaultPortForProtocol(proto) {
      switch (proto) {
        case enums_1.ApplicationProtocol.HTTP:
          return 80;
        case enums_1.ApplicationProtocol.HTTPS:
          return 443;
        default:
          throw new Error(`Unrecognized protocol: ${proto}`);
      }
    }
    exports2.defaultPortForProtocol = defaultPortForProtocol;
    function defaultProtocolForPort(port) {
      switch (port) {
        case 80:
        case 8e3:
        case 8008:
        case 8080:
          return enums_1.ApplicationProtocol.HTTP;
        case 443:
        case 8443:
          return enums_1.ApplicationProtocol.HTTPS;
        default:
          throw new Error(`Don't know default protocol for port: ${port}; please supply a protocol`);
      }
    }
    exports2.defaultProtocolForPort = defaultProtocolForPort;
    function determineProtocolAndPort(protocol, port) {
      return protocol === void 0 && port === void 0 ? [void 0, void 0] : (protocol === void 0 && (protocol = defaultProtocolForPort(port)), port === void 0 && (port = defaultPortForProtocol(protocol)), [protocol, port]);
    }
    exports2.determineProtocolAndPort = determineProtocolAndPort;
    function ifUndefined(x, def) {
      return x ?? def;
    }
    exports2.ifUndefined = ifUndefined;
    function validateNetworkProtocol(protocol) {
      const NLB_PROTOCOLS = [enums_1.Protocol.TCP, enums_1.Protocol.TLS, enums_1.Protocol.UDP, enums_1.Protocol.TCP_UDP];
      if (NLB_PROTOCOLS.indexOf(protocol) === -1)
        throw new Error(`The protocol must be one of ${NLB_PROTOCOLS.join(", ")}. Found ${protocol}`);
    }
    exports2.validateNetworkProtocol = validateNetworkProtocol;
    function mapTagMapToCxschema(tagMap) {
      return Object.entries(tagMap).map(([key, value]) => ({ key, value }));
    }
    exports2.mapTagMapToCxschema = mapTagMapToCxschema;
    function parseLoadBalancerFullName(arn) {
      if (core_1.Token.isUnresolved(arn)) {
        const arnParts = core_1.Fn.split("/", arn);
        return `${core_1.Fn.select(1, arnParts)}/${core_1.Fn.select(2, arnParts)}/${core_1.Fn.select(3, arnParts)}`;
      } else {
        const resourceName = core_1.Arn.split(arn, core_1.ArnFormat.SLASH_RESOURCE_NAME).resourceName;
        if (!resourceName)
          throw new Error(`Provided ARN does not belong to a load balancer: ${arn}`);
        return resourceName;
      }
    }
    exports2.parseLoadBalancerFullName = parseLoadBalancerFullName;
    function parseTargetGroupFullName(arn) {
      const resource = core_1.Arn.split(arn, core_1.ArnFormat.NO_RESOURCE_NAME).resource;
      if (!resource)
        throw new Error(`Provided ARN does not belong to a target group: ${arn}`);
      return resource;
    }
    exports2.parseTargetGroupFullName = parseTargetGroupFullName;
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/shared/base-target-group.js
var require_base_target_group = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/shared/base-target-group.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.loadBalancerNameFromListenerArn = exports2.TargetGroupBase = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var enums_1 = require_enums();
    var util_1 = require_util15();
    var cdk = require_core2();
    var elasticloadbalancingv2_generated_1 = require_elasticloadbalancingv2_generated();
    var TargetGroupBase = class _TargetGroupBase extends constructs_1.Construct {
      constructor(scope, id, baseProps, additionalProps) {
        super(scope, id), this.loadBalancerAttachedDependencies = new constructs_1.DependencyGroup(), this.attributes = {}, this.targetsJson = new Array();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_BaseTargetGroupProps(baseProps);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _TargetGroupBase), error;
        }
        baseProps.deregistrationDelay !== void 0 && this.setAttribute("deregistration_delay.timeout_seconds", baseProps.deregistrationDelay.toSeconds().toString()), this.healthCheck = baseProps.healthCheck || {}, this.vpc = baseProps.vpc, this.targetType = baseProps.targetType, this.resource = new elasticloadbalancingv2_generated_1.CfnTargetGroup(this, "Resource", { name: baseProps.targetGroupName, targetGroupAttributes: cdk.Lazy.any({ produce: () => (0, util_1.renderAttributes)(this.attributes) }, { omitEmptyArray: true }), targetType: cdk.Lazy.string({ produce: () => this.targetType }), targets: cdk.Lazy.any({ produce: () => this.targetsJson }, { omitEmptyArray: true }), vpcId: cdk.Lazy.string({ produce: () => this.vpc && this.targetType !== enums_1.TargetType.LAMBDA ? this.vpc.vpcId : void 0 }), healthCheckEnabled: cdk.Lazy.any({ produce: () => this.healthCheck?.enabled }), healthCheckIntervalSeconds: cdk.Lazy.number({ produce: () => this.healthCheck?.interval?.toSeconds() }), healthCheckPath: cdk.Lazy.string({ produce: () => this.healthCheck?.path }), healthCheckPort: cdk.Lazy.string({ produce: () => this.healthCheck?.port }), healthCheckProtocol: cdk.Lazy.string({ produce: () => this.healthCheck?.protocol }), healthCheckTimeoutSeconds: cdk.Lazy.number({ produce: () => this.healthCheck?.timeout?.toSeconds() }), healthyThresholdCount: cdk.Lazy.number({ produce: () => this.healthCheck?.healthyThresholdCount }), unhealthyThresholdCount: cdk.Lazy.number({ produce: () => this.healthCheck?.unhealthyThresholdCount }), matcher: cdk.Lazy.any({ produce: () => this.healthCheck?.healthyHttpCodes !== void 0 || this.healthCheck?.healthyGrpcCodes !== void 0 ? { grpcCode: this.healthCheck.healthyGrpcCodes, httpCode: this.healthCheck.healthyHttpCodes } : void 0 }), ...additionalProps }), this.targetGroupLoadBalancerArns = this.resource.attrLoadBalancerArns, this.targetGroupArn = this.resource.ref, this.targetGroupFullName = this.resource.attrTargetGroupFullName, this.loadBalancerArns = this.resource.attrLoadBalancerArns.toString(), this.targetGroupName = this.resource.attrTargetGroupName, this.defaultPort = additionalProps.port, this.node.addValidation({ validate: () => this.validateTargetGroup() });
      }
      get loadBalancerAttached() {
        return this.loadBalancerAttachedDependencies;
      }
      configureHealthCheck(healthCheck) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_HealthCheck(healthCheck);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.configureHealthCheck), error;
        }
        this.healthCheck = healthCheck;
      }
      setAttribute(key, value) {
        this.attributes[key] = value;
      }
      addLoadBalancerTarget(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_LoadBalancerTargetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addLoadBalancerTarget), error;
        }
        if (this.targetType !== void 0 && this.targetType !== props.targetType)
          throw new Error(`Already have a of type '${this.targetType}', adding '${props.targetType}'; make all targets the same type.`);
        if (this.targetType = props.targetType, this.targetType === enums_1.TargetType.LAMBDA && this.targetsJson.length >= 1)
          throw new Error("TargetGroup can only contain one LAMBDA target. Create a new TargetGroup.");
        props.targetJson && this.targetsJson.push(props.targetJson);
      }
      validateTargetGroup() {
        const ret = new Array();
        this.targetType === void 0 && this.targetsJson.length === 0 && cdk.Annotations.of(this).addWarning("When creating an empty TargetGroup, you should specify a 'targetType' (this warning may become an error in the future)."), this.targetType !== enums_1.TargetType.LAMBDA && this.vpc === void 0 && ret.push("'vpc' is required for a non-Lambda TargetGroup");
        const targetGroupName = this.resource.name;
        return !cdk.Token.isUnresolved(targetGroupName) && targetGroupName !== void 0 && (targetGroupName.length > 32 && ret.push(`Target group name: "${targetGroupName}" can have a maximum of 32 characters.`), (targetGroupName.startsWith("-") || targetGroupName.endsWith("-")) && ret.push(`Target group name: "${targetGroupName}" must not begin or end with a hyphen.`), /^[0-9a-z-]+$/i.test(targetGroupName) || ret.push(`Target group name: "${targetGroupName}" must contain only alphanumeric characters or hyphens.`)), ret;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, TargetGroupBase[_a] = { fqn: "aws-cdk-lib.aws_elasticloadbalancingv2.TargetGroupBase", version: "2.80.0" }, exports2.TargetGroupBase = TargetGroupBase;
    function loadBalancerNameFromListenerArn(listenerArn) {
      const arnParts = cdk.Fn.split("/", listenerArn);
      return `${cdk.Fn.select(1, arnParts)}/${cdk.Fn.select(2, arnParts)}/${cdk.Fn.select(3, arnParts)}`;
    }
    exports2.loadBalancerNameFromListenerArn = loadBalancerNameFromListenerArn;
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/shared/imported.js
var require_imported = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/shared/imported.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ImportedTargetGroupBase = void 0;
    var constructs_1 = require_lib2();
    var cdk = require_core2();
    var ImportedTargetGroupBase = class extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id), this.loadBalancerAttached = new constructs_1.DependencyGroup(), this.targetGroupArn = props.targetGroupArn, this.targetGroupName = cdk.Stack.of(scope).splitArn(props.targetGroupArn, cdk.ArnFormat.SLASH_RESOURCE_NAME).resourceName.split("/")[0], this.loadBalancerArns = props.loadBalancerArns || cdk.Aws.NO_VALUE;
      }
    };
    exports2.ImportedTargetGroupBase = ImportedTargetGroupBase;
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/alb/application-target-group.js
var require_application_target_group = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/alb/application-target-group.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ApplicationTargetGroup = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cloudwatch = require_aws_cloudwatch();
    var ec2 = require_aws_ec2();
    var core_1 = require_core2();
    var elasticloadbalancingv2_canned_metrics_generated_1 = require_elasticloadbalancingv2_canned_metrics_generated();
    var base_target_group_1 = require_base_target_group();
    var enums_1 = require_enums();
    var imported_1 = require_imported();
    var util_1 = require_util15();
    var ApplicationTargetGroupMetrics = class {
      constructor(scope, targetGroupFullName, loadBalancerFullName) {
        this.scope = scope, this.targetGroupFullName = targetGroupFullName, this.loadBalancerFullName = loadBalancerFullName;
      }
      custom(metricName, props) {
        return new cloudwatch.Metric({ namespace: "AWS/ApplicationELB", metricName, dimensionsMap: { TargetGroup: this.targetGroupFullName, LoadBalancer: this.loadBalancerFullName }, ...props }).attachTo(this.scope);
      }
      ipv6RequestCount(props) {
        return this.cannedMetric(elasticloadbalancingv2_canned_metrics_generated_1.ApplicationELBMetrics.iPv6RequestCountSum, props);
      }
      requestCount(props) {
        return this.cannedMetric(elasticloadbalancingv2_canned_metrics_generated_1.ApplicationELBMetrics.requestCountSum, props);
      }
      healthyHostCount(props) {
        return this.custom("HealthyHostCount", { statistic: "Average", ...props });
      }
      unhealthyHostCount(props) {
        return this.custom("UnHealthyHostCount", { statistic: "Average", ...props });
      }
      httpCodeTarget(code, props) {
        return this.custom(code, { statistic: "Sum", ...props });
      }
      requestCountPerTarget(props) {
        return this.custom("RequestCountPerTarget", { statistic: "Sum", ...props });
      }
      targetConnectionErrorCount(props) {
        return this.custom("TargetConnectionErrorCount", { statistic: "Sum", ...props });
      }
      targetResponseTime(props) {
        return this.custom("TargetResponseTime", { statistic: "Average", ...props });
      }
      targetTLSNegotiationErrorCount(props) {
        return this.custom("TargetTLSNegotiationErrorCount", { statistic: "Sum", ...props });
      }
      cannedMetric(fn, props) {
        return new cloudwatch.Metric({ ...fn({ LoadBalancer: this.loadBalancerFullName, TargetGroup: this.targetGroupFullName }), ...props }).attachTo(this.scope);
      }
    };
    var ApplicationTargetGroup = class _ApplicationTargetGroup extends base_target_group_1.TargetGroupBase {
      static fromTargetGroupAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_TargetGroupAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromTargetGroupAttributes), error;
        }
        return new ImportedApplicationTargetGroup(scope, id, attrs);
      }
      static import(scope, id, props) {
        return _ApplicationTargetGroup.fromTargetGroupAttributes(scope, id, props);
      }
      constructor(scope, id, props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationTargetGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ApplicationTargetGroup), error;
        }
        const [protocol, port] = (0, util_1.determineProtocolAndPort)(props.protocol, props.port), { protocolVersion } = props;
        if (super(scope, id, { ...props }, { protocol, protocolVersion, port }), this.protocol = protocol, this.port = port, this.node.addValidation({ validate: () => this.targetType === enums_1.TargetType.LAMBDA && (this.port || this.protocol) ? ["port/protocol should not be specified for Lambda targets"] : [] }), this.connectableMembers = [], this.listeners = [], props) {
          if (props.slowStart !== void 0) {
            if (props.slowStart.toSeconds() < 30 || props.slowStart.toSeconds() > 900)
              throw new Error("Slow start duration value must be between 30 and 900 seconds.");
            this.setAttribute("slow_start.duration_seconds", props.slowStart.toSeconds().toString());
          }
          props.stickinessCookieDuration ? this.enableCookieStickiness(props.stickinessCookieDuration, props.stickinessCookieName) : this.setAttribute("stickiness.enabled", "false"), props.loadBalancingAlgorithmType && this.setAttribute("load_balancing.algorithm.type", props.loadBalancingAlgorithmType), this.addTarget(...props.targets || []);
        }
      }
      get metrics() {
        return this._metrics || (this._metrics = new ApplicationTargetGroupMetrics(this, this.targetGroupFullName, this.firstLoadBalancerFullName)), this._metrics;
      }
      addTarget(...targets) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_IApplicationLoadBalancerTarget(targets);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addTarget), error;
        }
        for (const target of targets) {
          const result = target.attachToApplicationTargetGroup(this);
          this.addLoadBalancerTarget(result);
        }
        this.targetType === enums_1.TargetType.LAMBDA && this.setAttribute("stickiness.enabled", void 0);
      }
      enableCookieStickiness(duration, cookieName) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Duration(duration);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.enableCookieStickiness), error;
        }
        if (duration.toSeconds() < 1 || duration.toSeconds() > 604800)
          throw new Error("Stickiness cookie duration value must be between 1 second and 7 days (604800 seconds).");
        if (cookieName !== void 0) {
          if (!core_1.Token.isUnresolved(cookieName) && (cookieName.startsWith("AWSALB") || cookieName.startsWith("AWSALBAPP") || cookieName.startsWith("AWSALBTG")))
            throw new Error("App cookie names that start with the following prefixes are not allowed: AWSALB, AWSALBAPP, and AWSALBTG; they're reserved for use by the load balancer.");
          if (cookieName === "")
            throw new Error("App cookie name cannot be an empty string.");
        }
        this.setAttribute("stickiness.enabled", "true"), cookieName ? (this.setAttribute("stickiness.type", "app_cookie"), this.setAttribute("stickiness.app_cookie.cookie_name", cookieName), this.setAttribute("stickiness.app_cookie.duration_seconds", duration.toSeconds().toString())) : (this.setAttribute("stickiness.type", "lb_cookie"), this.setAttribute("stickiness.lb_cookie.duration_seconds", duration.toSeconds().toString()));
      }
      registerConnectable(connectable, portRange) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_IConnectable(connectable), jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_Port(portRange);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.registerConnectable), error;
        }
        portRange = portRange || ec2.Port.tcp(this.defaultPort), this.connectableMembers.push({ connectable, portRange });
        for (const listener of this.listeners)
          listener.registerConnectable(connectable, portRange);
      }
      registerListener(listener, associatingConstruct) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_IApplicationListener(listener);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.registerListener), error;
        }
        for (const member of this.connectableMembers)
          listener.registerConnectable(member.connectable, member.portRange);
        this.listeners.push(listener), this.loadBalancerAttachedDependencies.add(associatingConstruct ?? listener);
      }
      get firstLoadBalancerFullName() {
        if (this.listeners.length === 0)
          throw new Error("The TargetGroup needs to be attached to a LoadBalancer before you can call this method");
        return (0, base_target_group_1.loadBalancerNameFromListenerArn)(this.listeners[0].listenerArn);
      }
      metric(metricName, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metric), error;
        }
        return this.metrics.custom(metricName, props);
      }
      metricIpv6RequestCount(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationTargetGroup#metricIpv6RequestCount", "Use ``ApplicationTargetGroup.metrics.ipv6RequestCount`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricIpv6RequestCount), error;
        }
        return this.metrics.ipv6RequestCount(props);
      }
      metricRequestCount(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationTargetGroup#metricRequestCount", "Use ``ApplicationTargetGroup.metrics.requestCount`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricRequestCount), error;
        }
        return this.metrics.requestCount(props);
      }
      metricHealthyHostCount(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationTargetGroup#metricHealthyHostCount", "Use ``ApplicationTargetGroup.metrics.healthyHostCount`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricHealthyHostCount), error;
        }
        return this.metrics.healthyHostCount(props);
      }
      metricUnhealthyHostCount(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationTargetGroup#metricUnhealthyHostCount", "Use ``ApplicationTargetGroup.metrics.unhealthyHostCount`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricUnhealthyHostCount), error;
        }
        return this.metrics.unhealthyHostCount(props);
      }
      metricHttpCodeTarget(code, props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationTargetGroup#metricHttpCodeTarget", "Use ``ApplicationTargetGroup.metrics.httpCodeTarget`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_HttpCodeTarget(code), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricHttpCodeTarget), error;
        }
        return this.metrics.httpCodeTarget(code, props);
      }
      metricRequestCountPerTarget(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationTargetGroup#metricRequestCountPerTarget", "Use ``ApplicationTargetGroup.metrics.ipv6RequestCount`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricRequestCountPerTarget), error;
        }
        return this.metrics.requestCountPerTarget(props);
      }
      metricTargetConnectionErrorCount(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationTargetGroup#metricTargetConnectionErrorCount", "Use ``ApplicationTargetGroup.metrics.targetConnectionErrorCount`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricTargetConnectionErrorCount), error;
        }
        return this.metrics.targetConnectionErrorCount(props);
      }
      metricTargetResponseTime(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationTargetGroup#metricTargetResponseTime", "Use ``ApplicationTargetGroup.metrics.targetResponseTime`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricTargetResponseTime), error;
        }
        return this.metrics.targetResponseTime(props);
      }
      metricTargetTLSNegotiationErrorCount(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationTargetGroup#metricTargetTLSNegotiationErrorCount", "Use ``ApplicationTargetGroup.metrics.tlsNegotiationErrorCount`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricTargetTLSNegotiationErrorCount), error;
        }
        return this.metrics.targetTLSNegotiationErrorCount(props);
      }
      validateTargetGroup() {
        const ret = super.validateTargetGroup();
        return this.targetType !== void 0 && this.targetType !== enums_1.TargetType.LAMBDA && (this.protocol === void 0 || this.port === void 0) && ret.push("At least one of 'port' or 'protocol' is required for a non-Lambda TargetGroup"), this.healthCheck && (this.healthCheck.interval && this.healthCheck.timeout && this.healthCheck.interval.toMilliseconds() <= this.healthCheck.timeout.toMilliseconds() && ret.push(`Healthcheck interval ${this.healthCheck.interval.toHumanString()} must be greater than the timeout ${this.healthCheck.timeout.toHumanString()}`), this.healthCheck.protocol && (ALB_HEALTH_CHECK_PROTOCOLS.includes(this.healthCheck.protocol) || ret.push([`Health check protocol '${this.healthCheck.protocol}' is not supported. `, `Must be one of [${ALB_HEALTH_CHECK_PROTOCOLS.join(", ")}]`].join("")))), ret;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ApplicationTargetGroup[_a] = { fqn: "aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationTargetGroup", version: "2.80.0" }, exports2.ApplicationTargetGroup = ApplicationTargetGroup;
    var ImportedApplicationTargetGroup = class extends imported_1.ImportedTargetGroupBase {
      constructor(scope, id, props) {
        if (super(scope, id, props), this.loadBalancerArns != core_1.Aws.NO_VALUE) {
          const targetGroupFullName = (0, util_1.parseTargetGroupFullName)(this.targetGroupArn), firstLoadBalancerFullName = (0, util_1.parseLoadBalancerFullName)(this.loadBalancerArns);
          this._metrics = new ApplicationTargetGroupMetrics(this, targetGroupFullName, firstLoadBalancerFullName);
        }
      }
      registerListener(_listener, _associatingConstruct) {
        core_1.Annotations.of(this).addWarning("Cannot register listener on imported target group -- security groups might need to be updated manually");
      }
      registerConnectable(_connectable, _portRange) {
        core_1.Annotations.of(this).addWarning("Cannot register connectable on imported target group -- security groups might need to be updated manually");
      }
      addTarget(...targets) {
        for (const target of targets)
          if (target.attachToApplicationTargetGroup(this).targetJson !== void 0)
            throw new Error("Cannot add a non-self registering target to an imported TargetGroup. Create a new TargetGroup instead.");
      }
      get metrics() {
        if (!this._metrics)
          throw new Error("The imported ApplicationTargetGroup needs the associated ApplicationBalancer to be able to provide metrics. Please specify the ARN value when importing it.");
        return this._metrics;
      }
    };
    var ALB_HEALTH_CHECK_PROTOCOLS = [enums_1.Protocol.HTTP, enums_1.Protocol.HTTPS];
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/shared/base-listener.js
var require_base_listener = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/shared/base-listener.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.BaseListener = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var util_1 = require_util15();
    var cxschema = require_cloud_assembly_schema2();
    var core_1 = require_core2();
    var elasticloadbalancingv2_generated_1 = require_elasticloadbalancingv2_generated();
    var BaseListener = class extends core_1.Resource {
      static _queryContextProvider(scope, options) {
        if (core_1.Token.isUnresolved(options.userOptions.loadBalancerArn) || Object.values(options.userOptions.loadBalancerTags ?? {}).some(core_1.Token.isUnresolved) || core_1.Token.isUnresolved(options.userOptions.listenerPort))
          throw new Error("All arguments to look up a load balancer listener must be concrete (no Tokens)");
        let cxschemaTags;
        return options.userOptions.loadBalancerTags && (cxschemaTags = (0, util_1.mapTagMapToCxschema)(options.userOptions.loadBalancerTags)), core_1.ContextProvider.getValue(scope, { provider: cxschema.ContextProvider.LOAD_BALANCER_LISTENER_PROVIDER, props: { listenerArn: options.listenerArn, listenerPort: options.userOptions.listenerPort, listenerProtocol: options.listenerProtocol, loadBalancerArn: options.userOptions.loadBalancerArn, loadBalancerTags: cxschemaTags, loadBalancerType: options.loadBalancerType }, dummyValue: { listenerArn: `arn:aws:elasticloadbalancing:us-west-2:123456789012:listener/${options.loadBalancerType}/my-load-balancer/50dc6c495c0c9188/f2f7dc8efc522ab2`, listenerPort: 80, securityGroupIds: ["sg-123456789012"] } }).value;
      }
      constructor(scope, id, additionalProps) {
        super(scope, id);
        const resource = new elasticloadbalancingv2_generated_1.CfnListener(this, "Resource", { ...additionalProps, defaultActions: core_1.Lazy.any({ produce: () => this.defaultAction?.renderActions() ?? [] }) });
        this.listenerArn = resource.ref, this.node.addValidation({ validate: () => this.validateListener() });
      }
      validateListener() {
        return this.defaultAction ? [] : ["Listener needs at least one default action or target group (call addTargetGroups or addAction)"];
      }
      _setDefaultAction(action) {
        this.defaultAction && core_1.Annotations.of(this).addWarning("A default Action already existed on this Listener and was replaced. Configure exactly one default Action."), this.defaultAction = action;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, BaseListener[_a] = { fqn: "aws-cdk-lib.aws_elasticloadbalancingv2.BaseListener", version: "2.80.0" }, exports2.BaseListener = BaseListener;
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/shared/listener-certificate.js
var require_listener_certificate = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/shared/listener-certificate.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ListenerCertificate = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var ListenerCertificate = class _ListenerCertificate {
      static fromCertificateManager(acmCertificate) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_certificatemanager_ICertificate(acmCertificate);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromCertificateManager), error;
        }
        return new _ListenerCertificate(acmCertificate.certificateArn);
      }
      static fromArn(certificateArn) {
        return new _ListenerCertificate(certificateArn);
      }
      constructor(certificateArn) {
        this.certificateArn = certificateArn;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ListenerCertificate[_a] = { fqn: "aws-cdk-lib.aws_elasticloadbalancingv2.ListenerCertificate", version: "2.80.0" }, exports2.ListenerCertificate = ListenerCertificate;
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/alb/application-listener.js
var require_application_listener = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/alb/application-listener.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ApplicationListener = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var application_listener_action_1 = require_application_listener_action();
    var application_listener_certificate_1 = require_application_listener_certificate();
    var application_listener_rule_1 = require_application_listener_rule();
    var application_target_group_1 = require_application_target_group();
    var ec2 = require_aws_ec2();
    var cxschema = require_cloud_assembly_schema2();
    var core_1 = require_core2();
    var base_listener_1 = require_base_listener();
    var enums_1 = require_enums();
    var listener_certificate_1 = require_listener_certificate();
    var util_1 = require_util15();
    var ApplicationListener = class _ApplicationListener extends base_listener_1.BaseListener {
      static fromLookup(scope, id, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationListenerLookupOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromLookup), error;
        }
        if (core_1.Token.isUnresolved(options.listenerArn))
          throw new Error("All arguments to look up a load balancer listener must be concrete (no Tokens)");
        let listenerProtocol;
        switch (options.listenerProtocol) {
          case enums_1.ApplicationProtocol.HTTP:
            listenerProtocol = cxschema.LoadBalancerListenerProtocol.HTTP;
            break;
          case enums_1.ApplicationProtocol.HTTPS:
            listenerProtocol = cxschema.LoadBalancerListenerProtocol.HTTPS;
            break;
        }
        const props = base_listener_1.BaseListener._queryContextProvider(scope, { userOptions: options, loadBalancerType: cxschema.LoadBalancerType.APPLICATION, listenerArn: options.listenerArn, listenerProtocol });
        return new LookedUpApplicationListener(scope, id, props);
      }
      static fromApplicationListenerAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationListenerAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromApplicationListenerAttributes), error;
        }
        return new ImportedApplicationListener(scope, id, attrs);
      }
      constructor(scope, id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationListenerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ApplicationListener), error;
        }
        const [protocol, port] = (0, util_1.determineProtocolAndPort)(props.protocol, props.port);
        if (protocol === void 0 || port === void 0)
          throw new Error("At least one of 'port' or 'protocol' is required");
        if (super(scope, id, { loadBalancerArn: props.loadBalancer.loadBalancerArn, certificates: core_1.Lazy.any({ produce: () => this.certificateArns.map((certificateArn) => ({ certificateArn })) }, { omitEmptyArray: true }), protocol, port, sslPolicy: props.sslPolicy }), this.loadBalancer = props.loadBalancer, this.protocol = protocol, this.certificateArns = [], props.certificateArns && props.certificateArns.length > 0 && this.addCertificateArns("ListenerCertificate", props.certificateArns), props.certificates && props.certificates.length > 0 && this.addCertificates("DefaultCertificates", props.certificates), this.connections = new ec2.Connections({ securityGroups: props.loadBalancer.connections.securityGroups, defaultPort: ec2.Port.tcp(port) }), props.defaultAction && props.defaultTargetGroups)
          throw new Error("Specify at most one of 'defaultAction' and 'defaultTargetGroups'");
        props.defaultAction && this.setDefaultAction(props.defaultAction), props.defaultTargetGroups && this.setDefaultAction(application_listener_action_1.ListenerAction.forward(props.defaultTargetGroups)), props.open !== false && (this.connections.allowDefaultPortFrom(ec2.Peer.anyIpv4(), `Allow from anyone on port ${port}`), this.loadBalancer.ipAddressType === enums_1.IpAddressType.DUAL_STACK && this.connections.allowDefaultPortFrom(ec2.Peer.anyIpv6(), `Allow from anyone on port ${port}`));
      }
      addCertificateArns(id, arns) {
        this.addCertificates(id, arns.map(listener_certificate_1.ListenerCertificate.fromArn));
      }
      addCertificates(id, certificates) {
        const additionalCerts = [...certificates];
        if (this.certificateArns.length === 0 && additionalCerts.length > 0) {
          const first = additionalCerts.splice(0, 1)[0];
          this.certificateArns.push(first.certificateArn);
        }
        for (let i = 0; i < additionalCerts.length; i++)
          new application_listener_certificate_1.ApplicationListenerCertificate(this, `${id}${i + 1}`, { listener: this, certificates: [additionalCerts[i]] });
      }
      addAction(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_AddApplicationActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addAction), error;
        }
        checkAddRuleProps(props), props.priority !== void 0 ? new application_listener_rule_1.ApplicationListenerRule(this, id + "Rule", { listener: this, priority: props.priority, ...props }) : this.setDefaultAction(props.action);
      }
      addTargetGroups(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_AddApplicationTargetGroupsProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addTargetGroups), error;
        }
        checkAddRuleProps(props), props.priority !== void 0 ? new application_listener_rule_1.ApplicationListenerRule(this, id + "Rule", { listener: this, priority: props.priority, ...props }) : this.setDefaultAction(application_listener_action_1.ListenerAction.forward(props.targetGroups));
      }
      addTargets(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_AddApplicationTargetsProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addTargets), error;
        }
        if (!this.loadBalancer.vpc)
          throw new Error("Can only call addTargets() when using a constructed Load Balancer or an imported Load Balancer with specified vpc; construct a new TargetGroup and use addTargetGroup");
        const group = new application_target_group_1.ApplicationTargetGroup(this, id + "Group", { vpc: this.loadBalancer.vpc, ...props });
        return this.addTargetGroups(id, { targetGroups: [group], ...props }), group;
      }
      addFixedResponse(id, props) {
        checkAddRuleProps(props);
        const fixedResponse = { statusCode: props.statusCode, contentType: props.contentType, messageBody: props.messageBody };
        if (fixedResponse.statusCode && !/^(2|4|5)\d\d$/.test(fixedResponse.statusCode))
          throw new Error("`statusCode` must be 2XX, 4XX or 5XX.");
        if (fixedResponse.messageBody && fixedResponse.messageBody.length > 1024)
          throw new Error("`messageBody` cannot have more than 1024 characters.");
        props.priority ? new application_listener_rule_1.ApplicationListenerRule(this, id + "Rule", { listener: this, priority: props.priority, fixedResponse, ...props }) : this.setDefaultAction(application_listener_action_1.ListenerAction.fixedResponse(core_1.Token.asNumber(props.statusCode), { contentType: props.contentType, messageBody: props.messageBody }));
      }
      addRedirectResponse(id, props) {
        checkAddRuleProps(props);
        const redirectResponse = { host: props.host, path: props.path, port: props.port, protocol: props.protocol, query: props.query, statusCode: props.statusCode };
        if (redirectResponse.protocol && !/^(HTTPS?|#\{protocol\})$/i.test(redirectResponse.protocol))
          throw new Error("`protocol` must be HTTP, HTTPS, or #{protocol}.");
        if (!redirectResponse.statusCode || !/^HTTP_30[12]$/.test(redirectResponse.statusCode))
          throw new Error("`statusCode` must be HTTP_301 or HTTP_302.");
        props.priority ? new application_listener_rule_1.ApplicationListenerRule(this, id + "Rule", { listener: this, priority: props.priority, redirectResponse, ...props }) : this.setDefaultAction(application_listener_action_1.ListenerAction.redirect({ host: props.host, path: props.path, port: props.port, protocol: props.protocol, query: props.query, permanent: props.statusCode === "HTTP_301" }));
      }
      registerConnectable(connectable, portRange) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_IConnectable(connectable), jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_Port(portRange);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.registerConnectable), error;
        }
        connectable.connections.allowFrom(this.loadBalancer, portRange, "Load balancer to target");
      }
      validateListener() {
        const errors = super.validateListener();
        return this.protocol === enums_1.ApplicationProtocol.HTTPS && this.certificateArns.length === 0 && errors.push("HTTPS Listener needs at least one certificate (call addCertificates)"), errors;
      }
      setDefaultAction(action) {
        action.bind(this, this), this._setDefaultAction(action);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ApplicationListener[_a] = { fqn: "aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationListener", version: "2.80.0" }, exports2.ApplicationListener = ApplicationListener;
    var ExternalApplicationListener = class extends core_1.Resource {
      constructor(scope, id) {
        super(scope, id);
      }
      registerConnectable(connectable, portRange) {
        this.connections.allowTo(connectable, portRange, "Load balancer to target");
      }
      addCertificateArns(id, arns) {
        this.addCertificates(id, arns.map(listener_certificate_1.ListenerCertificate.fromArn));
      }
      addCertificates(id, certificates) {
        new application_listener_certificate_1.ApplicationListenerCertificate(this, id, { listener: this, certificates });
      }
      addTargetGroups(id, props) {
        if (checkAddRuleProps(props), props.priority !== void 0)
          new application_listener_rule_1.ApplicationListenerRule(this, id, { listener: this, priority: props.priority, ...props });
        else
          throw new Error("Cannot add default Target Groups to imported ApplicationListener");
      }
      addTargets(_id, _props) {
        throw new Error("Can only call addTargets() when using a constructed ApplicationListener; construct a new TargetGroup and use addTargetGroup.");
      }
      addAction(id, props) {
        if (checkAddRuleProps(props), props.priority !== void 0)
          new application_listener_rule_1.ApplicationListenerRule(this, id + "Rule", { listener: this, priority: props.priority, ...props });
        else
          throw new Error("priority must be set for actions added to an imported listener");
      }
    };
    var ImportedApplicationListener = class extends ExternalApplicationListener {
      constructor(scope, id, props) {
        super(scope, id), this.listenerArn = props.listenerArn;
        const defaultPort = props.defaultPort !== void 0 ? ec2.Port.tcp(props.defaultPort) : void 0;
        this.connections = new ec2.Connections({ securityGroups: [props.securityGroup], defaultPort });
      }
    };
    var LookedUpApplicationListener = class extends ExternalApplicationListener {
      constructor(scope, id, props) {
        super(scope, id), this.listenerArn = props.listenerArn, this.connections = new ec2.Connections({ defaultPort: ec2.Port.tcp(props.listenerPort) });
        for (const securityGroupId of props.securityGroupIds) {
          const securityGroup = ec2.SecurityGroup.fromLookupById(this, `SecurityGroup-${securityGroupId}`, securityGroupId);
          this.connections.addSecurityGroup(securityGroup);
        }
      }
    };
    function checkAddRuleProps(props) {
      const hasAnyConditions = (props.conditions?.length || 0) !== 0 || props.hostHeader !== void 0 || props.pathPattern !== void 0 || props.pathPatterns !== void 0, hasPriority = props.priority !== void 0;
      if (hasAnyConditions !== hasPriority)
        throw new Error("Setting 'conditions', 'pathPattern' or 'hostHeader' also requires 'priority', and vice versa");
    }
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/shared/base-load-balancer.js
var require_base_load_balancer = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/shared/base-load-balancer.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.BaseLoadBalancer = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var util_1 = require_util15();
    var ec2 = require_aws_ec2();
    var iam = require_aws_iam();
    var aws_iam_1 = require_aws_iam();
    var cxschema = require_cloud_assembly_schema2();
    var core_1 = require_core2();
    var cxapi = require_cx_api();
    var region_info_1 = require_region_info2();
    var elasticloadbalancingv2_generated_1 = require_elasticloadbalancingv2_generated();
    var BaseLoadBalancer = class _BaseLoadBalancer extends core_1.Resource {
      static _queryContextProvider(scope, options) {
        if (core_1.Token.isUnresolved(options.userOptions.loadBalancerArn) || Object.values(options.userOptions.loadBalancerTags ?? {}).some(core_1.Token.isUnresolved))
          throw new Error("All arguments to look up a load balancer must be concrete (no Tokens)");
        let cxschemaTags;
        return options.userOptions.loadBalancerTags && (cxschemaTags = (0, util_1.mapTagMapToCxschema)(options.userOptions.loadBalancerTags)), core_1.ContextProvider.getValue(scope, { provider: cxschema.ContextProvider.LOAD_BALANCER_PROVIDER, props: { loadBalancerArn: options.userOptions.loadBalancerArn, loadBalancerTags: cxschemaTags, loadBalancerType: options.loadBalancerType }, dummyValue: { ipAddressType: cxapi.LoadBalancerIpAddressType.DUAL_STACK, loadBalancerArn: `arn:aws:elasticloadbalancing:us-west-2:123456789012:loadbalancer/${options.loadBalancerType}/my-load-balancer/50dc6c495c0c9188`, loadBalancerCanonicalHostedZoneId: "Z3DZXE0EXAMPLE", loadBalancerDnsName: "my-load-balancer-1234567890.us-west-2.elb.amazonaws.com", securityGroupIds: ["sg-1234"], vpcId: "vpc-12345" } }).value;
      }
      constructor(scope, id, baseProps, additionalProps) {
        super(scope, id, { physicalName: baseProps.loadBalancerName }), this.attributes = {};
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_BaseLoadBalancerProps(baseProps);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _BaseLoadBalancer), error;
        }
        const internetFacing = (0, util_1.ifUndefined)(baseProps.internetFacing, false), vpcSubnets = (0, util_1.ifUndefined)(baseProps.vpcSubnets, internetFacing ? { subnetType: ec2.SubnetType.PUBLIC } : {}), { subnetIds, internetConnectivityEstablished } = baseProps.vpc.selectSubnets(vpcSubnets);
        this.vpc = baseProps.vpc;
        const resource = new elasticloadbalancingv2_generated_1.CfnLoadBalancer(this, "Resource", { name: this.physicalName, subnets: subnetIds, scheme: internetFacing ? "internet-facing" : "internal", loadBalancerAttributes: core_1.Lazy.any({ produce: () => (0, util_1.renderAttributes)(this.attributes) }, { omitEmptyArray: true }), ...additionalProps });
        internetFacing && resource.node.addDependency(internetConnectivityEstablished), this.setAttribute("deletion_protection.enabled", baseProps.deletionProtection ? "true" : "false"), this.loadBalancerCanonicalHostedZoneId = resource.attrCanonicalHostedZoneId, this.loadBalancerDnsName = resource.attrDnsName, this.loadBalancerFullName = resource.attrLoadBalancerFullName, this.loadBalancerName = resource.attrLoadBalancerName, this.loadBalancerArn = resource.ref, this.loadBalancerSecurityGroups = resource.attrSecurityGroups, this.node.addValidation({ validate: this.validateLoadBalancer.bind(this) });
      }
      logAccessLogs(bucket, prefix) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_IBucket(bucket);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.logAccessLogs), error;
        }
        prefix = prefix || "", this.setAttribute("access_logs.s3.enabled", "true"), this.setAttribute("access_logs.s3.bucket", bucket.bucketName.toString()), this.setAttribute("access_logs.s3.prefix", prefix);
        const logsDeliveryServicePrincipal = new aws_iam_1.ServicePrincipal("delivery.logs.amazonaws.com");
        bucket.addToResourcePolicy(new aws_iam_1.PolicyStatement({ actions: ["s3:PutObject"], principals: [this.resourcePolicyPrincipal()], resources: [bucket.arnForObjects(`${prefix ? prefix + "/" : ""}AWSLogs/${core_1.Stack.of(this).account}/*`)] })), bucket.addToResourcePolicy(new aws_iam_1.PolicyStatement({ actions: ["s3:PutObject"], principals: [logsDeliveryServicePrincipal], resources: [bucket.arnForObjects(`${prefix ? prefix + "/" : ""}AWSLogs/${this.env.account}/*`)], conditions: { StringEquals: { "s3:x-amz-acl": "bucket-owner-full-control" } } })), bucket.addToResourcePolicy(new aws_iam_1.PolicyStatement({ actions: ["s3:GetBucketAcl"], principals: [logsDeliveryServicePrincipal], resources: [bucket.bucketArn] })), this.node.addDependency(bucket);
      }
      setAttribute(key, value) {
        this.attributes[key] = value;
      }
      removeAttribute(key) {
        this.setAttribute(key, void 0);
      }
      resourcePolicyPrincipal() {
        const region = core_1.Stack.of(this).region;
        if (core_1.Token.isUnresolved(region))
          throw new Error("Region is required to enable ELBv2 access logging");
        const account = region_info_1.RegionInfo.get(region).elbv2Account;
        return account ? new iam.AccountPrincipal(account) : new iam.ServicePrincipal("logdelivery.elasticloadbalancing.amazonaws.com");
      }
      validateLoadBalancer() {
        const ret = new Array(), loadBalancerName = this.physicalName;
        return !core_1.Token.isUnresolved(loadBalancerName) && loadBalancerName !== void 0 && (loadBalancerName.length > 32 && ret.push(`Load balancer name: "${loadBalancerName}" can have a maximum of 32 characters.`), loadBalancerName.startsWith("internal-") && ret.push(`Load balancer name: "${loadBalancerName}" must not begin with "internal-".`), (loadBalancerName.startsWith("-") || loadBalancerName.endsWith("-")) && ret.push(`Load balancer name: "${loadBalancerName}" must not begin or end with a hyphen.`), /^[0-9a-z-]+$/i.test(loadBalancerName) || ret.push(`Load balancer name: "${loadBalancerName}" must contain only alphanumeric characters or hyphens.`)), ret;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, BaseLoadBalancer[_a] = { fqn: "aws-cdk-lib.aws_elasticloadbalancingv2.BaseLoadBalancer", version: "2.80.0" }, exports2.BaseLoadBalancer = BaseLoadBalancer;
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/alb/application-load-balancer.js
var require_application_load_balancer = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/alb/application-load-balancer.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.HttpCodeTarget = exports2.HttpCodeElb = exports2.ApplicationLoadBalancer = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var application_listener_1 = require_application_listener();
    var application_listener_action_1 = require_application_listener_action();
    var cloudwatch = require_aws_cloudwatch();
    var ec2 = require_aws_ec2();
    var cxschema = require_cloud_assembly_schema2();
    var core_1 = require_core2();
    var cxapi = require_cx_api();
    var elasticloadbalancingv2_canned_metrics_generated_1 = require_elasticloadbalancingv2_canned_metrics_generated();
    var base_load_balancer_1 = require_base_load_balancer();
    var enums_1 = require_enums();
    var util_1 = require_util15();
    var ApplicationLoadBalancer = class _ApplicationLoadBalancer extends base_load_balancer_1.BaseLoadBalancer {
      static fromLookup(scope, id, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationLoadBalancerLookupOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromLookup), error;
        }
        const props = base_load_balancer_1.BaseLoadBalancer._queryContextProvider(scope, { userOptions: options, loadBalancerType: cxschema.LoadBalancerType.APPLICATION });
        return new LookedUpApplicationLoadBalancer(scope, id, props);
      }
      static fromApplicationLoadBalancerAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationLoadBalancerAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromApplicationLoadBalancerAttributes), error;
        }
        return new ImportedApplicationLoadBalancer(scope, id, attrs);
      }
      constructor(scope, id, props) {
        super(scope, id, props, { type: "application", securityGroups: core_1.Lazy.list({ produce: () => this.connections.securityGroups.map((sg) => sg.securityGroupId) }), ipAddressType: props.ipAddressType });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationLoadBalancerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ApplicationLoadBalancer), error;
        }
        this.ipAddressType = props.ipAddressType ?? enums_1.IpAddressType.IPV4;
        const securityGroups = [props.securityGroup || new ec2.SecurityGroup(this, "SecurityGroup", { vpc: props.vpc, description: `Automatically created Security Group for ELB ${core_1.Names.uniqueId(this)}`, allowAllOutbound: false })];
        this.connections = new ec2.Connections({ securityGroups }), this.listeners = [], this.metrics = new ApplicationLoadBalancerMetrics(this, this.loadBalancerFullName), props.http2Enabled === false && this.setAttribute("routing.http2.enabled", "false"), props.idleTimeout !== void 0 && this.setAttribute("idle_timeout.timeout_seconds", props.idleTimeout.toSeconds().toString()), props.dropInvalidHeaderFields && this.setAttribute("routing.http.drop_invalid_header_fields.enabled", "true"), props.desyncMitigationMode !== void 0 && this.setAttribute("routing.http.desync_mitigation_mode", props.desyncMitigationMode);
      }
      addListener(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_BaseApplicationListenerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addListener), error;
        }
        const listener = new application_listener_1.ApplicationListener(this, id, { loadBalancer: this, ...props });
        return this.listeners.push(listener), listener;
      }
      addRedirect(props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationLoadBalancerRedirectConfig(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addRedirect), error;
        }
        const sourcePort = props.sourcePort ?? 80, targetPort = (props.targetPort ?? 443).toString();
        return this.addListener(`Redirect${sourcePort}To${targetPort}`, { protocol: props.sourceProtocol ?? enums_1.ApplicationProtocol.HTTP, port: sourcePort, open: props.open ?? true, defaultAction: application_listener_action_1.ListenerAction.redirect({ port: targetPort, protocol: props.targetProtocol ?? enums_1.ApplicationProtocol.HTTPS, permanent: true }) });
      }
      addSecurityGroup(securityGroup) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_ISecurityGroup(securityGroup);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addSecurityGroup), error;
        }
        this.connections.addSecurityGroup(securityGroup);
      }
      metric(metricName, props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationLoadBalancer#metric", "Use ``ApplicationLoadBalancer.metrics.custom`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metric), error;
        }
        return this.metrics.custom(metricName, props);
      }
      metricActiveConnectionCount(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationLoadBalancer#metricActiveConnectionCount", "Use ``ApplicationLoadBalancer.metrics.activeConnectionCount`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricActiveConnectionCount), error;
        }
        return this.metrics.activeConnectionCount(props);
      }
      metricClientTlsNegotiationErrorCount(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationLoadBalancer#metricClientTlsNegotiationErrorCount", "Use ``ApplicationLoadBalancer.metrics.clientTlsNegotiationErrorCount`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricClientTlsNegotiationErrorCount), error;
        }
        return this.metrics.clientTlsNegotiationErrorCount(props);
      }
      metricConsumedLCUs(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationLoadBalancer#metricConsumedLCUs", "Use ``ApplicationLoadBalancer.metrics.consumedLCUs`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricConsumedLCUs), error;
        }
        return this.metrics.consumedLCUs(props);
      }
      metricHttpFixedResponseCount(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationLoadBalancer#metricHttpFixedResponseCount", "Use ``ApplicationLoadBalancer.metrics.httpFixedResponseCount`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricHttpFixedResponseCount), error;
        }
        return this.metrics.httpFixedResponseCount(props);
      }
      metricHttpRedirectCount(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationLoadBalancer#metricHttpRedirectCount", "Use ``ApplicationLoadBalancer.metrics.httpRedirectCount`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricHttpRedirectCount), error;
        }
        return this.metrics.httpRedirectCount(props);
      }
      metricHttpRedirectUrlLimitExceededCount(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationLoadBalancer#metricHttpRedirectUrlLimitExceededCount", "Use ``ApplicationLoadBalancer.metrics.httpRedirectUrlLimitExceededCount`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricHttpRedirectUrlLimitExceededCount), error;
        }
        return this.metrics.httpRedirectUrlLimitExceededCount(props);
      }
      metricHttpCodeElb(code, props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationLoadBalancer#metricHttpCodeElb", "Use ``ApplicationLoadBalancer.metrics.httpCodeElb`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_HttpCodeElb(code), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricHttpCodeElb), error;
        }
        return this.metrics.httpCodeElb(code, props);
      }
      metricHttpCodeTarget(code, props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationLoadBalancer#metricHttpCodeTarget", "Use ``ApplicationLoadBalancer.metrics.httpCodeTarget`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_HttpCodeTarget(code), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricHttpCodeTarget), error;
        }
        return this.metrics.httpCodeTarget(code, props);
      }
      metricIpv6ProcessedBytes(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationLoadBalancer#metricIpv6ProcessedBytes", "Use ``ApplicationLoadBalancer.metrics.ipv6ProcessedBytes`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricIpv6ProcessedBytes), error;
        }
        return this.metrics.ipv6ProcessedBytes(props);
      }
      metricIpv6RequestCount(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationLoadBalancer#metricIpv6RequestCount", "Use ``ApplicationLoadBalancer.metrics.ipv6RequestCount`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricIpv6RequestCount), error;
        }
        return this.metrics.ipv6RequestCount(props);
      }
      metricNewConnectionCount(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationLoadBalancer#metricNewConnectionCount", "Use ``ApplicationLoadBalancer.metrics.newConnectionCount`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricNewConnectionCount), error;
        }
        return this.metrics.newConnectionCount(props);
      }
      metricProcessedBytes(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationLoadBalancer#metricProcessedBytes", "Use ``ApplicationLoadBalancer.metrics.processedBytes`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricProcessedBytes), error;
        }
        return this.metrics.processedBytes(props);
      }
      metricRejectedConnectionCount(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationLoadBalancer#metricRejectedConnectionCount", "Use ``ApplicationLoadBalancer.metrics.rejectedConnectionCount`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricRejectedConnectionCount), error;
        }
        return this.metrics.rejectedConnectionCount(props);
      }
      metricRequestCount(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationLoadBalancer#metricRequestCount", "Use ``ApplicationLoadBalancer.metrics.requestCount`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricRequestCount), error;
        }
        return this.metrics.requestCount(props);
      }
      metricRuleEvaluations(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationLoadBalancer#metricRuleEvaluations", "Use ``ApplicationLoadBalancer.metrics.ruleEvaluations`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricRuleEvaluations), error;
        }
        return this.metrics.ruleEvaluations(props);
      }
      metricTargetConnectionErrorCount(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationLoadBalancer#metricTargetConnectionErrorCount", "Use ``ApplicationLoadBalancer.metrics.targetConnectionErrorCount`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricTargetConnectionErrorCount), error;
        }
        return this.metrics.targetConnectionErrorCount(props);
      }
      metricTargetResponseTime(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationLoadBalancer#metricTargetResponseTime", "Use ``ApplicationLoadBalancer.metrics.targetResponseTime`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricTargetResponseTime), error;
        }
        return this.metrics.targetResponseTime(props);
      }
      metricTargetTLSNegotiationErrorCount(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationLoadBalancer#metricTargetTLSNegotiationErrorCount", "Use ``ApplicationLoadBalancer.metrics.targetTLSNegotiationErrorCount`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricTargetTLSNegotiationErrorCount), error;
        }
        return this.metrics.targetTLSNegotiationErrorCount(props);
      }
      metricElbAuthError(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationLoadBalancer#metricElbAuthError", "Use ``ApplicationLoadBalancer.metrics.elbAuthError`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricElbAuthError), error;
        }
        return this.metrics.elbAuthError(props);
      }
      metricElbAuthFailure(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationLoadBalancer#metricElbAuthFailure", "Use ``ApplicationLoadBalancer.metrics.elbAuthFailure`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricElbAuthFailure), error;
        }
        return this.metrics.elbAuthFailure(props);
      }
      metricElbAuthLatency(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationLoadBalancer#metricElbAuthLatency", "Use ``ApplicationLoadBalancer.metrics.elbAuthLatency`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricElbAuthLatency), error;
        }
        return this.metrics.elbAuthLatency(props);
      }
      metricElbAuthSuccess(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationLoadBalancer#metricElbAuthSuccess", "Use ``ApplicationLoadBalancer.metrics.elbAuthSuccess`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricElbAuthSuccess), error;
        }
        return this.metrics.elbAuthSuccess(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ApplicationLoadBalancer[_a] = { fqn: "aws-cdk-lib.aws_elasticloadbalancingv2.ApplicationLoadBalancer", version: "2.80.0" }, exports2.ApplicationLoadBalancer = ApplicationLoadBalancer;
    var ApplicationLoadBalancerMetrics = class {
      constructor(scope, loadBalancerFullName) {
        this.scope = scope, this.loadBalancerFullName = loadBalancerFullName;
      }
      custom(metricName, props) {
        return new cloudwatch.Metric({ namespace: "AWS/ApplicationELB", metricName, dimensionsMap: { LoadBalancer: this.loadBalancerFullName }, ...props });
      }
      activeConnectionCount(props) {
        return this.cannedMetric(elasticloadbalancingv2_canned_metrics_generated_1.ApplicationELBMetrics.activeConnectionCountSum, props);
      }
      clientTlsNegotiationErrorCount(props) {
        return this.cannedMetric(elasticloadbalancingv2_canned_metrics_generated_1.ApplicationELBMetrics.clientTlsNegotiationErrorCountSum, props);
      }
      consumedLCUs(props) {
        return this.cannedMetric(elasticloadbalancingv2_canned_metrics_generated_1.ApplicationELBMetrics.consumedLcUsAverage, { statistic: "sum", ...props });
      }
      httpFixedResponseCount(props) {
        return this.cannedMetric(elasticloadbalancingv2_canned_metrics_generated_1.ApplicationELBMetrics.httpFixedResponseCountSum, props);
      }
      httpRedirectCount(props) {
        return this.cannedMetric(elasticloadbalancingv2_canned_metrics_generated_1.ApplicationELBMetrics.httpRedirectCountSum, props);
      }
      httpRedirectUrlLimitExceededCount(props) {
        return this.cannedMetric(elasticloadbalancingv2_canned_metrics_generated_1.ApplicationELBMetrics.httpRedirectUrlLimitExceededCountSum, props);
      }
      httpCodeElb(code, props) {
        return this.custom(code, { statistic: "Sum", ...props });
      }
      httpCodeTarget(code, props) {
        return this.custom(code, { statistic: "Sum", ...props });
      }
      ipv6ProcessedBytes(props) {
        return this.cannedMetric(elasticloadbalancingv2_canned_metrics_generated_1.ApplicationELBMetrics.iPv6ProcessedBytesSum, props);
      }
      ipv6RequestCount(props) {
        return this.cannedMetric(elasticloadbalancingv2_canned_metrics_generated_1.ApplicationELBMetrics.iPv6RequestCountSum, props);
      }
      newConnectionCount(props) {
        return this.cannedMetric(elasticloadbalancingv2_canned_metrics_generated_1.ApplicationELBMetrics.newConnectionCountSum, props);
      }
      processedBytes(props) {
        return this.cannedMetric(elasticloadbalancingv2_canned_metrics_generated_1.ApplicationELBMetrics.processedBytesSum, props);
      }
      rejectedConnectionCount(props) {
        return this.cannedMetric(elasticloadbalancingv2_canned_metrics_generated_1.ApplicationELBMetrics.rejectedConnectionCountSum, props);
      }
      requestCount(props) {
        return this.cannedMetric(elasticloadbalancingv2_canned_metrics_generated_1.ApplicationELBMetrics.requestCountSum, props);
      }
      ruleEvaluations(props) {
        return this.cannedMetric(elasticloadbalancingv2_canned_metrics_generated_1.ApplicationELBMetrics.ruleEvaluationsSum, props);
      }
      targetConnectionErrorCount(props) {
        return this.custom("TargetConnectionErrorCount", { statistic: "Sum", ...props });
      }
      targetResponseTime(props) {
        return this.custom("TargetResponseTime", { statistic: "Average", ...props });
      }
      targetTLSNegotiationErrorCount(props) {
        return this.custom("TargetTLSNegotiationErrorCount", { statistic: "Sum", ...props });
      }
      elbAuthError(props) {
        return this.custom("ELBAuthError", { statistic: "Sum", ...props });
      }
      elbAuthFailure(props) {
        return this.custom("ELBAuthFailure", { statistic: "Sum", ...props });
      }
      elbAuthLatency(props) {
        return this.custom("ELBAuthLatency", { statistic: "Average", ...props });
      }
      elbAuthSuccess(props) {
        return this.custom("ELBAuthSuccess", { statistic: "Sum", ...props });
      }
      cannedMetric(fn, props) {
        return new cloudwatch.Metric({ ...fn({ LoadBalancer: this.loadBalancerFullName }), ...props }).attachTo(this.scope);
      }
    };
    var HttpCodeElb;
    (function(HttpCodeElb2) {
      HttpCodeElb2.ELB_3XX_COUNT = "HTTPCode_ELB_3XX_Count", HttpCodeElb2.ELB_4XX_COUNT = "HTTPCode_ELB_4XX_Count", HttpCodeElb2.ELB_5XX_COUNT = "HTTPCode_ELB_5XX_Count";
    })(HttpCodeElb = exports2.HttpCodeElb || (exports2.HttpCodeElb = {}));
    var HttpCodeTarget;
    (function(HttpCodeTarget2) {
      HttpCodeTarget2.TARGET_2XX_COUNT = "HTTPCode_Target_2XX_Count", HttpCodeTarget2.TARGET_3XX_COUNT = "HTTPCode_Target_3XX_Count", HttpCodeTarget2.TARGET_4XX_COUNT = "HTTPCode_Target_4XX_Count", HttpCodeTarget2.TARGET_5XX_COUNT = "HTTPCode_Target_5XX_Count";
    })(HttpCodeTarget = exports2.HttpCodeTarget || (exports2.HttpCodeTarget = {}));
    var ImportedApplicationLoadBalancer = class extends core_1.Resource {
      get listeners() {
        throw Error(".listeners can only be accessed if the class was constructed as an owned, not imported, load balancer");
      }
      constructor(scope, id, props) {
        super(scope, id, { environmentFromArn: props.loadBalancerArn }), this.props = props, this.vpc = props.vpc, this.loadBalancerArn = props.loadBalancerArn, this.connections = new ec2.Connections({ securityGroups: [ec2.SecurityGroup.fromSecurityGroupId(this, "SecurityGroup", props.securityGroupId, { allowAllOutbound: props.securityGroupAllowsAllOutbound })] }), this.metrics = new ApplicationLoadBalancerMetrics(this, (0, util_1.parseLoadBalancerFullName)(props.loadBalancerArn));
      }
      addListener(id, props) {
        return new application_listener_1.ApplicationListener(this, id, { loadBalancer: this, ...props });
      }
      get loadBalancerCanonicalHostedZoneId() {
        if (this.props.loadBalancerCanonicalHostedZoneId)
          return this.props.loadBalancerCanonicalHostedZoneId;
        throw new Error(`'loadBalancerCanonicalHostedZoneId' was not provided when constructing Application Load Balancer ${this.node.path} from attributes`);
      }
      get loadBalancerDnsName() {
        if (this.props.loadBalancerDnsName)
          return this.props.loadBalancerDnsName;
        throw new Error(`'loadBalancerDnsName' was not provided when constructing Application Load Balancer ${this.node.path} from attributes`);
      }
    };
    var LookedUpApplicationLoadBalancer = class extends core_1.Resource {
      get listeners() {
        throw Error(".listeners can only be accessed if the class was constructed as an owned, not looked up, load balancer");
      }
      constructor(scope, id, props) {
        super(scope, id, { environmentFromArn: props.loadBalancerArn }), this.loadBalancerArn = props.loadBalancerArn, this.loadBalancerCanonicalHostedZoneId = props.loadBalancerCanonicalHostedZoneId, this.loadBalancerDnsName = props.loadBalancerDnsName, props.ipAddressType === cxapi.LoadBalancerIpAddressType.IPV4 ? this.ipAddressType = enums_1.IpAddressType.IPV4 : props.ipAddressType === cxapi.LoadBalancerIpAddressType.DUAL_STACK && (this.ipAddressType = enums_1.IpAddressType.DUAL_STACK), this.vpc = ec2.Vpc.fromLookup(this, "Vpc", { vpcId: props.vpcId }), this.connections = new ec2.Connections();
        for (const securityGroupId of props.securityGroupIds) {
          const securityGroup = ec2.SecurityGroup.fromLookupById(this, `SecurityGroup-${securityGroupId}`, securityGroupId);
          this.connections.addSecurityGroup(securityGroup);
        }
        this.metrics = new ApplicationLoadBalancerMetrics(this, (0, util_1.parseLoadBalancerFullName)(this.loadBalancerArn));
      }
      addListener(id, props) {
        return new application_listener_1.ApplicationListener(this, id, { ...props, loadBalancer: this });
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/alb/conditions.js
var require_conditions2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/alb/conditions.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ListenerCondition = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var ListenerCondition = class {
      static hostHeaders(values) {
        return new HostHeaderListenerCondition(values);
      }
      static httpHeader(name, values) {
        return new HttpHeaderListenerCondition(name, values);
      }
      static httpRequestMethods(values) {
        return new HttpRequestMethodListenerCondition(values);
      }
      static pathPatterns(values) {
        return new PathPatternListenerCondition(values);
      }
      static queryStrings(values) {
        return new QueryStringListenerCondition(values);
      }
      static sourceIps(values) {
        return new SourceIpListenerCondition(values);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ListenerCondition[_a] = { fqn: "aws-cdk-lib.aws_elasticloadbalancingv2.ListenerCondition", version: "2.80.0" }, exports2.ListenerCondition = ListenerCondition;
    var HostHeaderListenerCondition = class extends ListenerCondition {
      constructor(values) {
        super(), this.values = values;
      }
      renderRawCondition() {
        return { field: "host-header", hostHeaderConfig: { values: this.values } };
      }
    };
    var HttpHeaderListenerCondition = class extends ListenerCondition {
      constructor(name, values) {
        super(), this.name = name, this.values = values;
      }
      renderRawCondition() {
        return { field: "http-header", httpHeaderConfig: { httpHeaderName: this.name, values: this.values } };
      }
    };
    var HttpRequestMethodListenerCondition = class extends ListenerCondition {
      constructor(values) {
        super(), this.values = values;
      }
      renderRawCondition() {
        return { field: "http-request-method", httpRequestMethodConfig: { values: this.values } };
      }
    };
    var PathPatternListenerCondition = class extends ListenerCondition {
      constructor(values) {
        if (super(), this.values = values, values && values.length > 5)
          throw new Error("A rule can only have '5' condition values");
      }
      renderRawCondition() {
        return { field: "path-pattern", pathPatternConfig: { values: this.values } };
      }
    };
    var QueryStringListenerCondition = class extends ListenerCondition {
      constructor(values) {
        super(), this.values = values;
      }
      renderRawCondition() {
        return { field: "query-string", queryStringConfig: { values: this.values } };
      }
    };
    var SourceIpListenerCondition = class extends ListenerCondition {
      constructor(values) {
        super(), this.values = values;
      }
      renderRawCondition() {
        return { field: "source-ip", sourceIpConfig: { values: this.values } };
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/nlb/network-listener-action.js
var require_network_listener_action = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/nlb/network-listener-action.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.NetworkListenerAction = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var NetworkListenerAction = class _NetworkListenerAction {
      static forward(targetGroups, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_NetworkForwardOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.forward), error;
        }
        if (targetGroups.length === 0)
          throw new Error("Need at least one targetGroup in a NetworkListenerAction.forward()");
        return targetGroups.length === 1 && options.stickinessDuration === void 0 ? new TargetGroupListenerAction(targetGroups, { type: "forward", targetGroupArn: targetGroups[0].targetGroupArn }) : new TargetGroupListenerAction(targetGroups, { type: "forward", forwardConfig: { targetGroups: targetGroups.map((g) => ({ targetGroupArn: g.targetGroupArn })), targetGroupStickinessConfig: options.stickinessDuration ? { durationSeconds: options.stickinessDuration.toSeconds(), enabled: true } : void 0 } });
      }
      static weightedForward(targetGroups, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_NetworkForwardOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.weightedForward), error;
        }
        if (targetGroups.length === 0)
          throw new Error("Need at least one targetGroup in a NetworkListenerAction.weightedForward()");
        return new TargetGroupListenerAction(targetGroups.map((g) => g.targetGroup), { type: "forward", forwardConfig: { targetGroups: targetGroups.map((g) => ({ targetGroupArn: g.targetGroup.targetGroupArn, weight: g.weight })), targetGroupStickinessConfig: options.stickinessDuration ? { durationSeconds: options.stickinessDuration.toSeconds(), enabled: true } : void 0 } });
      }
      constructor(defaultActionJson, next) {
        this.defaultActionJson = defaultActionJson, this.next = next;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_CfnListener_ActionProperty(defaultActionJson), jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_NetworkListenerAction(next);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _NetworkListenerAction), error;
        }
      }
      renderRuleActions() {
        const actionJson = this._actionJson ?? this.defaultActionJson;
        return this._renumber([actionJson, ...this.next?.renderRuleActions() ?? []]);
      }
      renderActions() {
        return this._renumber([this.defaultActionJson, ...this.next?.renderActions() ?? []]);
      }
      bind(scope, listener) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_INetworkListener(listener);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        Array.isArray(scope), Array.isArray(listener);
      }
      _renumber(actions) {
        return actions.length < 2 ? actions : actions.map((action, i) => ({ ...action, order: i + 1 }));
      }
      renumber(actions) {
        return this._renumber(actions);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, NetworkListenerAction[_a] = { fqn: "aws-cdk-lib.aws_elasticloadbalancingv2.NetworkListenerAction", version: "2.80.0" }, exports2.NetworkListenerAction = NetworkListenerAction;
    var TargetGroupListenerAction = class extends NetworkListenerAction {
      constructor(targetGroups, defaultActionJson) {
        super(defaultActionJson), this.targetGroups = targetGroups;
      }
      bind(_scope, listener) {
        for (const tg of this.targetGroups)
          tg.registerListener(listener);
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/nlb/network-listener-certificate.js
var require_network_listener_certificate = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/nlb/network-listener-certificate.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.NetworkListenerCertificate = void 0;
    var constructs_1 = require_lib2();
    var elasticloadbalancingv2_generated_1 = require_elasticloadbalancingv2_generated();
    var NetworkListenerCertificate = class extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id);
        const certificates = [...(props.certificates || []).map((c) => ({ certificateArn: c.certificateArn }))];
        new elasticloadbalancingv2_generated_1.CfnListenerCertificate(this, "Resource", { listenerArn: props.listener.listenerArn, certificates });
      }
    };
    exports2.NetworkListenerCertificate = NetworkListenerCertificate;
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/nlb/network-target-group.js
var require_network_target_group = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/nlb/network-target-group.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.NetworkTargetGroup = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cloudwatch = require_aws_cloudwatch();
    var cdk = require_core2();
    var base_target_group_1 = require_base_target_group();
    var enums_1 = require_enums();
    var imported_1 = require_imported();
    var util_1 = require_util15();
    var NetworkTargetGroupMetrics = class {
      constructor(scope, targetGroupFullName, loadBalancerFullName) {
        this.scope = scope, this.targetGroupFullName = targetGroupFullName, this.loadBalancerFullName = loadBalancerFullName;
      }
      custom(metricName, props) {
        return new cloudwatch.Metric({ namespace: "AWS/NetworkELB", metricName, dimensionsMap: { LoadBalancer: this.loadBalancerFullName, TargetGroup: this.targetGroupFullName }, ...props }).attachTo(this.scope);
      }
      healthyHostCount(props) {
        return this.custom("HealthyHostCount", { statistic: "Average", ...props });
      }
      unHealthyHostCount(props) {
        return this.custom("UnHealthyHostCount", { statistic: "Average", ...props });
      }
    };
    var NetworkTargetGroup = class _NetworkTargetGroup extends base_target_group_1.TargetGroupBase {
      static fromTargetGroupAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_TargetGroupAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromTargetGroupAttributes), error;
        }
        return new ImportedNetworkTargetGroup(scope, id, attrs);
      }
      static import(scope, id, props) {
        return _NetworkTargetGroup.fromTargetGroupAttributes(scope, id, props);
      }
      constructor(scope, id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_NetworkTargetGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _NetworkTargetGroup), error;
        }
        const proto = props.protocol || enums_1.Protocol.TCP;
        (0, util_1.validateNetworkProtocol)(proto), super(scope, id, props, { protocol: proto, port: props.port }), this.listeners = [], props.proxyProtocolV2 != null && this.setAttribute("proxy_protocol_v2.enabled", props.proxyProtocolV2 ? "true" : "false"), props.preserveClientIp !== void 0 && this.setAttribute("preserve_client_ip.enabled", props.preserveClientIp ? "true" : "false"), props.connectionTermination !== void 0 && this.setAttribute("deregistration_delay.connection_termination.enabled", props.connectionTermination ? "true" : "false"), this.addTarget(...props.targets || []);
      }
      get metrics() {
        return this._metrics || (this._metrics = new NetworkTargetGroupMetrics(this, this.targetGroupFullName, this.firstLoadBalancerFullName)), this._metrics;
      }
      addTarget(...targets) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_INetworkLoadBalancerTarget(targets);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addTarget), error;
        }
        for (const target of targets) {
          const result = target.attachToNetworkTargetGroup(this);
          this.addLoadBalancerTarget(result);
        }
      }
      registerListener(listener) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_INetworkListener(listener);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.registerListener), error;
        }
        this.loadBalancerAttachedDependencies.add(listener), this.listeners.push(listener);
      }
      metricHealthyHostCount(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.NetworkTargetGroup#metricHealthyHostCount", "Use ``NetworkTargetGroup.metrics.healthyHostCount`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricHealthyHostCount), error;
        }
        return this.metrics.healthyHostCount(props);
      }
      metricUnHealthyHostCount(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.NetworkTargetGroup#metricUnHealthyHostCount", "Use ``NetworkTargetGroup.metrics.healthyHostCount`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricUnHealthyHostCount), error;
        }
        return this.metrics.unHealthyHostCount(props);
      }
      get firstLoadBalancerFullName() {
        if (this.listeners.length === 0)
          throw new Error("The TargetGroup needs to be attached to a LoadBalancer before you can call this method");
        return (0, base_target_group_1.loadBalancerNameFromListenerArn)(this.listeners[0].listenerArn);
      }
      validateTargetGroup() {
        const ret = super.validateTargetGroup(), healthCheck = this.healthCheck || {}, lowHealthCheckInterval = 5, highHealthCheckInterval = 300;
        if (healthCheck.interval) {
          const seconds = healthCheck.interval.toSeconds();
          !cdk.Token.isUnresolved(seconds) && (seconds < lowHealthCheckInterval || seconds > highHealthCheckInterval) && ret.push(`Health check interval '${seconds}' not supported. Must be between ${lowHealthCheckInterval} and ${highHealthCheckInterval}.`);
        }
        if (healthCheck.healthyThresholdCount) {
          const thresholdCount = healthCheck.healthyThresholdCount;
          (thresholdCount < 2 || thresholdCount > 10) && ret.push(`Healthy Threshold Count '${thresholdCount}' not supported. Must be a number between 2 and 10.`);
        }
        if (healthCheck.unhealthyThresholdCount) {
          const thresholdCount = healthCheck.unhealthyThresholdCount;
          (thresholdCount < 2 || thresholdCount > 10) && ret.push(`Unhealthy Threshold Count '${thresholdCount}' not supported. Must be a number between 2 and 10.`);
        }
        return healthCheck.healthyThresholdCount && healthCheck.unhealthyThresholdCount && healthCheck.healthyThresholdCount !== healthCheck.unhealthyThresholdCount && ret.push([`Healthy and Unhealthy Threshold Counts must be the same: ${healthCheck.healthyThresholdCount}`, `is not equal to ${healthCheck.unhealthyThresholdCount}.`].join(" ")), healthCheck.protocol && (NLB_HEALTH_CHECK_PROTOCOLS.includes(healthCheck.protocol) || ret.push(`Health check protocol '${healthCheck.protocol}' is not supported. Must be one of [${NLB_HEALTH_CHECK_PROTOCOLS.join(", ")}]`), healthCheck.path && !NLB_PATH_HEALTH_CHECK_PROTOCOLS.includes(healthCheck.protocol) && ret.push([`'${healthCheck.protocol}' health checks do not support the path property.`, `Must be one of [${NLB_PATH_HEALTH_CHECK_PROTOCOLS.join(", ")}]`].join(" ")), healthCheck.timeout && healthCheck.timeout.toSeconds() !== NLB_HEALTH_CHECK_TIMEOUTS[healthCheck.protocol] && ret.push(["Custom health check timeouts are not supported for Network Load Balancer health checks.", `Expected ${NLB_HEALTH_CHECK_TIMEOUTS[healthCheck.protocol]} seconds for ${healthCheck.protocol}, got ${healthCheck.timeout.toSeconds()}`].join(" "))), ret;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, NetworkTargetGroup[_a] = { fqn: "aws-cdk-lib.aws_elasticloadbalancingv2.NetworkTargetGroup", version: "2.80.0" }, exports2.NetworkTargetGroup = NetworkTargetGroup;
    var ImportedNetworkTargetGroup = class extends imported_1.ImportedTargetGroupBase {
      constructor(scope, id, props) {
        if (super(scope, id, props), this.loadBalancerArns != cdk.Aws.NO_VALUE) {
          const targetGroupFullName = (0, util_1.parseTargetGroupFullName)(this.targetGroupArn), firstLoadBalancerFullName = (0, util_1.parseLoadBalancerFullName)(this.loadBalancerArns);
          this._metrics = new NetworkTargetGroupMetrics(this, targetGroupFullName, firstLoadBalancerFullName);
        }
      }
      get metrics() {
        if (!this._metrics)
          throw new Error("The imported NetworkTargetGroup needs the associated NetworkLoadBalancer to be able to provide metrics. Please specify the ARN value when importing it.");
        return this._metrics;
      }
      registerListener(_listener) {
      }
      addTarget(...targets) {
        for (const target of targets)
          if (target.attachToNetworkTargetGroup(this).targetJson !== void 0)
            throw new Error("Cannot add a non-self registering target to an imported TargetGroup. Create a new TargetGroup instead.");
      }
    };
    var NLB_HEALTH_CHECK_PROTOCOLS = [enums_1.Protocol.HTTP, enums_1.Protocol.HTTPS, enums_1.Protocol.TCP];
    var NLB_PATH_HEALTH_CHECK_PROTOCOLS = [enums_1.Protocol.HTTP, enums_1.Protocol.HTTPS];
    var NLB_HEALTH_CHECK_TIMEOUTS = { [enums_1.Protocol.HTTP]: 6, [enums_1.Protocol.HTTPS]: 10, [enums_1.Protocol.TCP]: 10 };
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/nlb/network-listener.js
var require_network_listener = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/nlb/network-listener.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.NetworkListener = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var network_listener_action_1 = require_network_listener_action();
    var network_listener_certificate_1 = require_network_listener_certificate();
    var network_target_group_1 = require_network_target_group();
    var cxschema = require_cloud_assembly_schema2();
    var core_1 = require_core2();
    var base_listener_1 = require_base_listener();
    var enums_1 = require_enums();
    var util_1 = require_util15();
    var NetworkListener = class _NetworkListener extends base_listener_1.BaseListener {
      static fromLookup(scope, id, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_NetworkListenerLookupOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromLookup), error;
        }
        let listenerProtocol;
        if (options.listenerProtocol)
          switch ((0, util_1.validateNetworkProtocol)(options.listenerProtocol), options.listenerProtocol) {
            case enums_1.Protocol.TCP:
              listenerProtocol = cxschema.LoadBalancerListenerProtocol.TCP;
              break;
            case enums_1.Protocol.UDP:
              listenerProtocol = cxschema.LoadBalancerListenerProtocol.UDP;
              break;
            case enums_1.Protocol.TCP_UDP:
              listenerProtocol = cxschema.LoadBalancerListenerProtocol.TCP_UDP;
              break;
            case enums_1.Protocol.TLS:
              listenerProtocol = cxschema.LoadBalancerListenerProtocol.TLS;
              break;
          }
        const props = base_listener_1.BaseListener._queryContextProvider(scope, { userOptions: options, listenerProtocol, loadBalancerType: cxschema.LoadBalancerType.NETWORK });
        class LookedUp extends core_1.Resource {
          constructor() {
            super(...arguments), this.listenerArn = props.listenerArn;
          }
        }
        return new LookedUp(scope, id);
      }
      static fromNetworkListenerArn(scope, id, networkListenerArn) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.listenerArn = networkListenerArn;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_NetworkListenerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _NetworkListener), error;
        }
        const certs = props.certificates || [], proto = props.protocol || (certs.length > 0 ? enums_1.Protocol.TLS : enums_1.Protocol.TCP);
        if ((0, util_1.validateNetworkProtocol)(proto), proto === enums_1.Protocol.TLS && certs.filter((v) => v != null).length === 0)
          throw new Error("When the protocol is set to TLS, you must specify certificates");
        if (proto !== enums_1.Protocol.TLS && certs.length > 0)
          throw new Error("Protocol must be TLS when certificates have been specified");
        if (proto !== enums_1.Protocol.TLS && props.alpnPolicy)
          throw new Error("Protocol must be TLS when alpnPolicy have been specified");
        if (super(scope, id, { loadBalancerArn: props.loadBalancer.loadBalancerArn, protocol: proto, port: props.port, sslPolicy: props.sslPolicy, certificates: core_1.Lazy.any({ produce: () => this.certificateArns.map((certificateArn) => ({ certificateArn })) }, { omitEmptyArray: true }), alpnPolicy: props.alpnPolicy ? [props.alpnPolicy] : void 0 }), this.certificateArns = [], this.loadBalancer = props.loadBalancer, this.protocol = proto, certs.length > 0 && this.addCertificates("DefaultCertificates", certs), props.defaultAction && props.defaultTargetGroups)
          throw new Error("Specify at most one of 'defaultAction' and 'defaultTargetGroups'");
        props.defaultAction && this.setDefaultAction(props.defaultAction), props.defaultTargetGroups && this.setDefaultAction(network_listener_action_1.NetworkListenerAction.forward(props.defaultTargetGroups));
      }
      addCertificates(id, certificates) {
        const additionalCerts = [...certificates];
        if (this.certificateArns.length === 0 && additionalCerts.length > 0) {
          const first = additionalCerts.splice(0, 1)[0];
          this.certificateArns.push(first.certificateArn);
        }
        for (let i = 0; i < additionalCerts.length; i++)
          new network_listener_certificate_1.NetworkListenerCertificate(this, `${id}${i + 1}`, { listener: this, certificates: [additionalCerts[i]] });
      }
      addTargetGroups(_id, ...targetGroups) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_INetworkTargetGroup(targetGroups);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addTargetGroups), error;
        }
        this.setDefaultAction(network_listener_action_1.NetworkListenerAction.forward(targetGroups));
      }
      addAction(_id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_AddNetworkActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addAction), error;
        }
        this.setDefaultAction(props.action);
      }
      addTargets(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_AddNetworkTargetsProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addTargets), error;
        }
        if (!this.loadBalancer.vpc)
          throw new Error("Can only call addTargets() when using a constructed Load Balancer or imported Load Balancer with specified VPC; construct a new TargetGroup and use addTargetGroup");
        const group = new network_target_group_1.NetworkTargetGroup(this, id + "Group", { deregistrationDelay: props.deregistrationDelay, healthCheck: props.healthCheck, port: props.port, protocol: props.protocol ?? this.protocol, proxyProtocolV2: props.proxyProtocolV2, preserveClientIp: props.preserveClientIp, targetGroupName: props.targetGroupName, targets: props.targets, vpc: this.loadBalancer.vpc });
        return this.addTargetGroups(id, group), group;
      }
      setDefaultAction(action) {
        action.bind(this, this), this._setDefaultAction(action);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, NetworkListener[_a] = { fqn: "aws-cdk-lib.aws_elasticloadbalancingv2.NetworkListener", version: "2.80.0" }, exports2.NetworkListener = NetworkListener;
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/nlb/network-load-balancer.js
var require_network_load_balancer = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/nlb/network-load-balancer.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.NetworkLoadBalancer = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var network_listener_1 = require_network_listener();
    var cloudwatch = require_aws_cloudwatch();
    var ec2 = require_aws_ec2();
    var cxschema = require_cloud_assembly_schema2();
    var core_1 = require_core2();
    var elasticloadbalancingv2_canned_metrics_generated_1 = require_elasticloadbalancingv2_canned_metrics_generated();
    var base_load_balancer_1 = require_base_load_balancer();
    var util_1 = require_util15();
    var NetworkLoadBalancerMetrics = class {
      constructor(scope, loadBalancerFullName) {
        this.scope = scope, this.loadBalancerFullName = loadBalancerFullName;
      }
      custom(metricName, props) {
        return new cloudwatch.Metric({ namespace: "AWS/NetworkELB", metricName, dimensionsMap: { LoadBalancer: this.loadBalancerFullName }, ...props }).attachTo(this.scope);
      }
      activeFlowCount(props) {
        return this.cannedMetric(elasticloadbalancingv2_canned_metrics_generated_1.NetworkELBMetrics.activeFlowCountAverage, props);
      }
      consumedLCUs(props) {
        return this.cannedMetric(elasticloadbalancingv2_canned_metrics_generated_1.NetworkELBMetrics.consumedLcUsAverage, { statistic: "Sum", ...props });
      }
      newFlowCount(props) {
        return this.cannedMetric(elasticloadbalancingv2_canned_metrics_generated_1.NetworkELBMetrics.newFlowCountSum, props);
      }
      processedBytes(props) {
        return this.cannedMetric(elasticloadbalancingv2_canned_metrics_generated_1.NetworkELBMetrics.processedBytesSum, props);
      }
      tcpClientResetCount(props) {
        return this.cannedMetric(elasticloadbalancingv2_canned_metrics_generated_1.NetworkELBMetrics.tcpClientResetCountSum, props);
      }
      tcpElbResetCount(props) {
        return this.cannedMetric(elasticloadbalancingv2_canned_metrics_generated_1.NetworkELBMetrics.tcpElbResetCountSum, props);
      }
      tcpTargetResetCount(props) {
        return this.cannedMetric(elasticloadbalancingv2_canned_metrics_generated_1.NetworkELBMetrics.tcpTargetResetCountSum, props);
      }
      cannedMetric(fn, props) {
        return new cloudwatch.Metric({ ...fn({ LoadBalancer: this.loadBalancerFullName }), ...props }).attachTo(this.scope);
      }
    };
    var NetworkLoadBalancer = class _NetworkLoadBalancer extends base_load_balancer_1.BaseLoadBalancer {
      static fromLookup(scope, id, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_NetworkLoadBalancerLookupOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromLookup), error;
        }
        const props = base_load_balancer_1.BaseLoadBalancer._queryContextProvider(scope, { userOptions: options, loadBalancerType: cxschema.LoadBalancerType.NETWORK });
        return new LookedUpNetworkLoadBalancer(scope, id, props);
      }
      static fromNetworkLoadBalancerAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_NetworkLoadBalancerAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromNetworkLoadBalancerAttributes), error;
        }
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.loadBalancerArn = attrs.loadBalancerArn, this.vpc = attrs.vpc, this.metrics = new NetworkLoadBalancerMetrics(this, (0, util_1.parseLoadBalancerFullName)(attrs.loadBalancerArn));
          }
          addListener(lid, props) {
            return new network_listener_1.NetworkListener(this, lid, { loadBalancer: this, ...props });
          }
          get loadBalancerCanonicalHostedZoneId() {
            if (attrs.loadBalancerCanonicalHostedZoneId)
              return attrs.loadBalancerCanonicalHostedZoneId;
            throw new Error(`'loadBalancerCanonicalHostedZoneId' was not provided when constructing Network Load Balancer ${this.node.path} from attributes`);
          }
          get loadBalancerDnsName() {
            if (attrs.loadBalancerDnsName)
              return attrs.loadBalancerDnsName;
            throw new Error(`'loadBalancerDnsName' was not provided when constructing Network Load Balancer ${this.node.path} from attributes`);
          }
        }
        return new Import(scope, id, { environmentFromArn: attrs.loadBalancerArn });
      }
      constructor(scope, id, props) {
        super(scope, id, props, { type: "network" });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_NetworkLoadBalancerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _NetworkLoadBalancer), error;
        }
        this.metrics = new NetworkLoadBalancerMetrics(this, this.loadBalancerFullName), props.crossZoneEnabled && this.setAttribute("load_balancing.cross_zone.enabled", "true");
      }
      addListener(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_BaseNetworkListenerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addListener), error;
        }
        return new network_listener_1.NetworkListener(this, id, { loadBalancer: this, ...props });
      }
      metric(metricName, props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.NetworkLoadBalancer#metric", "Use ``NetworkLoadBalancer.metrics.custom`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metric), error;
        }
        return new cloudwatch.Metric({ namespace: "AWS/NetworkELB", metricName, dimensions: { LoadBalancer: this.loadBalancerFullName }, ...props }).attachTo(this);
      }
      metricActiveFlowCount(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.NetworkLoadBalancer#metricActiveFlowCount", "Use ``NetworkLoadBalancer.metrics.activeFlowCount`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricActiveFlowCount), error;
        }
        return this.metrics.activeFlowCount(props);
      }
      metricConsumedLCUs(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.NetworkLoadBalancer#metricConsumedLCUs", "Use ``NetworkLoadBalancer.metrics.activeFlowCount`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricConsumedLCUs), error;
        }
        return this.metrics.consumedLCUs(props);
      }
      metricHealthyHostCount(props) {
        return this.metric("HealthyHostCount", { statistic: "Average", ...props });
      }
      metricUnHealthyHostCount(props) {
        return this.metric("UnHealthyHostCount", { statistic: "Average", ...props });
      }
      metricNewFlowCount(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.NetworkLoadBalancer#metricNewFlowCount", "Use ``NetworkLoadBalancer.metrics.newFlowCount`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricNewFlowCount), error;
        }
        return this.metrics.newFlowCount(props);
      }
      metricProcessedBytes(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.NetworkLoadBalancer#metricProcessedBytes", "Use ``NetworkLoadBalancer.metrics.processedBytes`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricProcessedBytes), error;
        }
        return this.metrics.processedBytes(props);
      }
      metricTcpClientResetCount(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.NetworkLoadBalancer#metricTcpClientResetCount", "Use ``NetworkLoadBalancer.metrics.tcpClientResetCount`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricTcpClientResetCount), error;
        }
        return this.metrics.tcpClientResetCount(props);
      }
      metricTcpElbResetCount(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.NetworkLoadBalancer#metricTcpElbResetCount", "Use ``NetworkLoadBalancer.metrics.tcpElbResetCount`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricTcpElbResetCount), error;
        }
        return this.metrics.tcpElbResetCount(props);
      }
      metricTcpTargetResetCount(props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_elasticloadbalancingv2.NetworkLoadBalancer#metricTcpTargetResetCount", "Use ``NetworkLoadBalancer.metrics.tcpTargetResetCount`` instead"), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricTcpTargetResetCount), error;
        }
        return this.metrics.tcpTargetResetCount(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, NetworkLoadBalancer[_a] = { fqn: "aws-cdk-lib.aws_elasticloadbalancingv2.NetworkLoadBalancer", version: "2.80.0" }, exports2.NetworkLoadBalancer = NetworkLoadBalancer;
    var LookedUpNetworkLoadBalancer = class extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id, { environmentFromArn: props.loadBalancerArn }), this.loadBalancerArn = props.loadBalancerArn, this.loadBalancerCanonicalHostedZoneId = props.loadBalancerCanonicalHostedZoneId, this.loadBalancerDnsName = props.loadBalancerDnsName, this.metrics = new NetworkLoadBalancerMetrics(this, (0, util_1.parseLoadBalancerFullName)(props.loadBalancerArn)), this.vpc = ec2.Vpc.fromLookup(this, "Vpc", { vpcId: props.vpcId });
      }
      addListener(lid, props) {
        return new network_listener_1.NetworkListener(this, lid, { loadBalancer: this, ...props });
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/shared/load-balancer-targets.js
var require_load_balancer_targets = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/shared/load-balancer-targets.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.IpTarget = exports2.InstanceTarget = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var enums_1 = require_enums();
    var InstanceTarget = class {
      constructor(instanceId, port) {
        this.instanceId = instanceId, this.port = port;
      }
      attachToApplicationTargetGroup(targetGroup) {
        return this.attach(targetGroup);
      }
      attachToNetworkTargetGroup(targetGroup) {
        return this.attach(targetGroup);
      }
      attach(_targetGroup) {
        return { targetType: enums_1.TargetType.INSTANCE, targetJson: { id: this.instanceId, port: this.port } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, InstanceTarget[_a] = { fqn: "aws-cdk-lib.aws_elasticloadbalancingv2.InstanceTarget", version: "2.80.0" }, exports2.InstanceTarget = InstanceTarget;
    var IpTarget = class {
      constructor(ipAddress, port, availabilityZone) {
        this.ipAddress = ipAddress, this.port = port, this.availabilityZone = availabilityZone;
      }
      attachToApplicationTargetGroup(targetGroup) {
        return this.attach(targetGroup);
      }
      attachToNetworkTargetGroup(targetGroup) {
        return this.attach(targetGroup);
      }
      attach(_targetGroup) {
        return { targetType: enums_1.TargetType.IP, targetJson: { id: this.ipAddress, port: this.port, availabilityZone: this.availabilityZone } };
      }
    };
    _b = JSII_RTTI_SYMBOL_1, IpTarget[_b] = { fqn: "aws-cdk-lib.aws_elasticloadbalancingv2.IpTarget", version: "2.80.0" }, exports2.IpTarget = IpTarget;
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/shared/listener-action.js
var require_listener_action = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/shared/listener-action.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/index.js
var require_lib52 = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_elasticloadbalancingv2_generated(), exports2), __exportStar(require_application_listener(), exports2), __exportStar(require_application_listener_certificate(), exports2), __exportStar(require_application_listener_rule(), exports2), __exportStar(require_application_load_balancer(), exports2), __exportStar(require_application_target_group(), exports2), __exportStar(require_application_listener_action(), exports2), __exportStar(require_conditions2(), exports2), __exportStar(require_network_listener(), exports2), __exportStar(require_network_load_balancer(), exports2), __exportStar(require_network_target_group(), exports2), __exportStar(require_network_listener_action(), exports2), __exportStar(require_base_listener(), exports2), __exportStar(require_base_load_balancer(), exports2), __exportStar(require_base_target_group(), exports2), __exportStar(require_enums(), exports2), __exportStar(require_load_balancer_targets(), exports2), __exportStar(require_listener_certificate(), exports2), __exportStar(require_listener_action(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/index.js
var require_aws_elasticloadbalancingv2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib52(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-autoscaling/lib/auto-scaling-group.js
var require_auto_scaling_group = __commonJS({
  "node_modules/aws-cdk-lib/aws-autoscaling/lib/auto-scaling-group.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.HealthCheck = exports2.ScalingProcess = exports2.ScalingEvents = exports2.ScalingEvent = exports2.UpdateType = exports2.AutoScalingGroup = exports2.GroupMetric = exports2.GroupMetrics = exports2.UpdatePolicy = exports2.Signals = exports2.SpotAllocationStrategy = exports2.OnDemandAllocationStrategy = exports2.Monitoring = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var aspects_1 = require_aspects2();
    var autoscaling_generated_1 = require_autoscaling_generated();
    var lifecycle_hook_1 = require_lifecycle_hook();
    var scheduled_action_1 = require_scheduled_action();
    var step_scaling_policy_1 = require_step_scaling_policy2();
    var target_tracking_scaling_policy_1 = require_target_tracking_scaling_policy2();
    var volume_1 = require_volume2();
    var warm_pool_1 = require_warm_pool();
    var ec2 = require_aws_ec2();
    var elbv2 = require_aws_elasticloadbalancingv2();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var NAME_TAG = "Name";
    var Monitoring;
    (function(Monitoring2) {
      Monitoring2[Monitoring2.BASIC = 0] = "BASIC", Monitoring2[Monitoring2.DETAILED = 1] = "DETAILED";
    })(Monitoring = exports2.Monitoring || (exports2.Monitoring = {}));
    var OnDemandAllocationStrategy;
    (function(OnDemandAllocationStrategy2) {
      OnDemandAllocationStrategy2.PRIORITIZED = "prioritized";
    })(OnDemandAllocationStrategy = exports2.OnDemandAllocationStrategy || (exports2.OnDemandAllocationStrategy = {}));
    var SpotAllocationStrategy;
    (function(SpotAllocationStrategy2) {
      SpotAllocationStrategy2.LOWEST_PRICE = "lowest-price", SpotAllocationStrategy2.CAPACITY_OPTIMIZED = "capacity-optimized", SpotAllocationStrategy2.CAPACITY_OPTIMIZED_PRIORITIZED = "capacity-optimized-prioritized", SpotAllocationStrategy2.PRICE_CAPACITY_OPTIMIZED = "price-capacity-optimized";
    })(SpotAllocationStrategy = exports2.SpotAllocationStrategy || (exports2.SpotAllocationStrategy = {}));
    var Signals = class _Signals {
      static waitForAll(options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_SignalsOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.waitForAll), error;
        }
        return validatePercentage(options.minSuccessPercentage), new class extends _Signals {
          renderCreationPolicy(renderOptions) {
            return this.doRender(options, renderOptions.desiredCapacity ?? renderOptions.minCapacity);
          }
        }();
      }
      static waitForMinCapacity(options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_SignalsOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.waitForMinCapacity), error;
        }
        return validatePercentage(options.minSuccessPercentage), new class extends _Signals {
          renderCreationPolicy(renderOptions) {
            return this.doRender(options, renderOptions.minCapacity);
          }
        }();
      }
      static waitForCount(count, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_SignalsOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.waitForCount), error;
        }
        return validatePercentage(options.minSuccessPercentage), new class extends _Signals {
          renderCreationPolicy() {
            return this.doRender(options, count);
          }
        }();
      }
      doRender(options, count) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_SignalsOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.doRender), error;
        }
        const minSuccessfulInstancesPercent = validatePercentage(options.minSuccessPercentage);
        return { ...options.minSuccessPercentage !== void 0 ? { autoScalingCreationPolicy: { minSuccessfulInstancesPercent } } : {}, resourceSignal: { count, timeout: options.timeout?.toIsoString() } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Signals[_a] = { fqn: "aws-cdk-lib.aws_autoscaling.Signals", version: "2.80.0" }, exports2.Signals = Signals;
    var UpdatePolicy = class _UpdatePolicy {
      static replacingUpdate() {
        return new class extends _UpdatePolicy {
          _renderUpdatePolicy() {
            return { autoScalingReplacingUpdate: { willReplace: true } };
          }
        }();
      }
      static rollingUpdate(options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_RollingUpdateOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.rollingUpdate), error;
        }
        const minSuccessPercentage = validatePercentage(options.minSuccessPercentage);
        return new class extends _UpdatePolicy {
          _renderUpdatePolicy(renderOptions) {
            return { autoScalingRollingUpdate: { maxBatchSize: options.maxBatchSize, minInstancesInService: options.minInstancesInService, suspendProcesses: options.suspendProcesses ?? DEFAULT_SUSPEND_PROCESSES, minSuccessfulInstancesPercent: minSuccessPercentage ?? renderOptions.creationPolicy?.autoScalingCreationPolicy?.minSuccessfulInstancesPercent, waitOnResourceSignals: options.waitOnResourceSignals ?? renderOptions.creationPolicy?.resourceSignal !== void 0 ? true : void 0, pauseTime: options.pauseTime?.toIsoString() ?? renderOptions.creationPolicy?.resourceSignal?.timeout } };
          }
        }();
      }
    };
    _b = JSII_RTTI_SYMBOL_1, UpdatePolicy[_b] = { fqn: "aws-cdk-lib.aws_autoscaling.UpdatePolicy", version: "2.80.0" }, exports2.UpdatePolicy = UpdatePolicy;
    var GroupMetrics = class _GroupMetrics {
      static all() {
        return new _GroupMetrics();
      }
      constructor(...metrics) {
        this._metrics = /* @__PURE__ */ new Set();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_GroupMetric(metrics);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _GroupMetrics), error;
        }
        metrics?.forEach((metric) => this._metrics.add(metric));
      }
    };
    _c = JSII_RTTI_SYMBOL_1, GroupMetrics[_c] = { fqn: "aws-cdk-lib.aws_autoscaling.GroupMetrics", version: "2.80.0" }, exports2.GroupMetrics = GroupMetrics;
    var GroupMetric = class {
      constructor(name) {
        this.name = name;
      }
    };
    _d = JSII_RTTI_SYMBOL_1, GroupMetric[_d] = { fqn: "aws-cdk-lib.aws_autoscaling.GroupMetric", version: "2.80.0" }, GroupMetric.MIN_SIZE = new GroupMetric("GroupMinSize"), GroupMetric.MAX_SIZE = new GroupMetric("GroupMaxSize"), GroupMetric.DESIRED_CAPACITY = new GroupMetric("GroupDesiredCapacity"), GroupMetric.IN_SERVICE_INSTANCES = new GroupMetric("GroupInServiceInstances"), GroupMetric.PENDING_INSTANCES = new GroupMetric("GroupPendingInstances"), GroupMetric.STANDBY_INSTANCES = new GroupMetric("GroupStandbyInstances"), GroupMetric.TERMINATING_INSTANCES = new GroupMetric("GroupTerminatingInstances"), GroupMetric.TOTAL_INSTANCES = new GroupMetric("GroupTotalInstances"), exports2.GroupMetric = GroupMetric;
    var AutoScalingGroupBase = class extends core_1.Resource {
      constructor() {
        super(...arguments), this.grantPrincipal = new iam.UnknownPrincipal({ resource: this }), this.hasCalledScaleOnRequestCount = false;
      }
      addLifecycleHook(id, props) {
        return new lifecycle_hook_1.LifecycleHook(this, `LifecycleHook${id}`, { autoScalingGroup: this, ...props });
      }
      addWarmPool(options) {
        return new warm_pool_1.WarmPool(this, "WarmPool", { autoScalingGroup: this, ...options });
      }
      scaleOnSchedule(id, props) {
        return new scheduled_action_1.ScheduledAction(this, `ScheduledAction${id}`, { autoScalingGroup: this, ...props });
      }
      scaleOnCpuUtilization(id, props) {
        return new target_tracking_scaling_policy_1.TargetTrackingScalingPolicy(this, `ScalingPolicy${id}`, { autoScalingGroup: this, predefinedMetric: target_tracking_scaling_policy_1.PredefinedMetric.ASG_AVERAGE_CPU_UTILIZATION, targetValue: props.targetUtilizationPercent, ...props });
      }
      scaleOnIncomingBytes(id, props) {
        return new target_tracking_scaling_policy_1.TargetTrackingScalingPolicy(this, `ScalingPolicy${id}`, { autoScalingGroup: this, predefinedMetric: target_tracking_scaling_policy_1.PredefinedMetric.ASG_AVERAGE_NETWORK_IN, targetValue: props.targetBytesPerSecond, ...props });
      }
      scaleOnOutgoingBytes(id, props) {
        return new target_tracking_scaling_policy_1.TargetTrackingScalingPolicy(this, `ScalingPolicy${id}`, { autoScalingGroup: this, predefinedMetric: target_tracking_scaling_policy_1.PredefinedMetric.ASG_AVERAGE_NETWORK_OUT, targetValue: props.targetBytesPerSecond, ...props });
      }
      scaleOnRequestCount(id, props) {
        if (this.albTargetGroup === void 0)
          throw new Error("Attach the AutoScalingGroup to a non-imported Application Load Balancer before calling scaleOnRequestCount()");
        const resourceLabel = `${this.albTargetGroup.firstLoadBalancerFullName}/${this.albTargetGroup.targetGroupFullName}`;
        if (props.targetRequestsPerMinute === void 0 == (props.targetRequestsPerSecond === void 0))
          throw new Error("Specify exactly one of 'targetRequestsPerMinute' or 'targetRequestsPerSecond'");
        let rpm;
        if (props.targetRequestsPerSecond !== void 0) {
          if (core_1.Token.isUnresolved(props.targetRequestsPerSecond))
            throw new Error("'targetRequestsPerSecond' cannot be an unresolved value; use 'targetRequestsPerMinute' instead.");
          rpm = props.targetRequestsPerSecond * 60;
        } else
          rpm = props.targetRequestsPerMinute;
        const policy = new target_tracking_scaling_policy_1.TargetTrackingScalingPolicy(this, `ScalingPolicy${id}`, { autoScalingGroup: this, predefinedMetric: target_tracking_scaling_policy_1.PredefinedMetric.ALB_REQUEST_COUNT_PER_TARGET, targetValue: rpm, resourceLabel, ...props });
        return policy.node.addDependency(this.albTargetGroup.loadBalancerAttached), this.hasCalledScaleOnRequestCount = true, policy;
      }
      scaleToTrackMetric(id, props) {
        return new target_tracking_scaling_policy_1.TargetTrackingScalingPolicy(this, `ScalingPolicy${id}`, { autoScalingGroup: this, customMetric: props.metric, ...props });
      }
      scaleOnMetric(id, props) {
        return new step_scaling_policy_1.StepScalingPolicy(this, id, { ...props, autoScalingGroup: this });
      }
      addUserData(..._commands) {
      }
    };
    var AutoScalingGroup = class _AutoScalingGroup extends AutoScalingGroupBase {
      static fromAutoScalingGroupName(scope, id, autoScalingGroupName) {
        class Import extends AutoScalingGroupBase {
          constructor() {
            super(...arguments), this.autoScalingGroupName = autoScalingGroupName, this.autoScalingGroupArn = core_1.Stack.of(this).formatArn({ service: "autoscaling", resource: "autoScalingGroup:*:autoScalingGroupName", resourceName: this.autoScalingGroupName }), this.osType = ec2.OperatingSystemType.UNKNOWN;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.autoScalingGroupName }), this.loadBalancerNames = [], this.targetGroupArns = [], this.groupMetrics = [], this.notifications = [];
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_AutoScalingGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AutoScalingGroup), error;
        }
        if (this.newInstancesProtectedFromScaleIn = props.newInstancesProtectedFromScaleIn, props.initOptions && !props.init)
          throw new Error("Setting 'initOptions' requires that 'init' is also set");
        props.groupMetrics && this.groupMetrics.push(...props.groupMetrics);
        let launchConfig;
        if (props.launchTemplate || props.mixedInstancesPolicy) {
          this.verifyNoLaunchConfigPropIsGiven(props);
          const bareLaunchTemplate = props.launchTemplate, mixedInstancesPolicy = props.mixedInstancesPolicy;
          if (bareLaunchTemplate && mixedInstancesPolicy)
            throw new Error("Setting 'mixedInstancesPolicy' must not be set when 'launchTemplate' is set");
          if (bareLaunchTemplate && bareLaunchTemplate instanceof ec2.LaunchTemplate) {
            if (!bareLaunchTemplate.instanceType)
              throw new Error("Setting 'launchTemplate' requires its 'instanceType' to be set");
            if (!bareLaunchTemplate.imageId)
              throw new Error("Setting 'launchTemplate' requires its 'machineImage' to be set");
            this.launchTemplate = bareLaunchTemplate;
          }
          if (mixedInstancesPolicy && mixedInstancesPolicy.launchTemplate instanceof ec2.LaunchTemplate) {
            if (!mixedInstancesPolicy.launchTemplate.imageId)
              throw new Error("Setting 'mixedInstancesPolicy.launchTemplate' requires its 'machineImage' to be set");
            this.launchTemplate = mixedInstancesPolicy.launchTemplate;
          }
          this._role = this.launchTemplate?.role, this.grantPrincipal = this._role || new iam.UnknownPrincipal({ resource: this }), this.osType = this.launchTemplate?.osType ?? ec2.OperatingSystemType.UNKNOWN;
        } else {
          if (!props.machineImage)
            throw new Error("Setting 'machineImage' is required when 'launchTemplate' and 'mixedInstancesPolicy' is not set");
          if (!props.instanceType)
            throw new Error("Setting 'instanceType' is required when 'launchTemplate' and 'mixedInstancesPolicy' is not set");
          this.securityGroup = props.securityGroup || new ec2.SecurityGroup(this, "InstanceSecurityGroup", { vpc: props.vpc, allowAllOutbound: props.allowAllOutbound !== false }), this._connections = new ec2.Connections({ securityGroups: [this.securityGroup] }), this.securityGroups = [this.securityGroup], core_1.Tags.of(this).add(NAME_TAG, this.node.path), this._role = props.role || new iam.Role(this, "InstanceRole", { roleName: core_1.PhysicalName.GENERATE_IF_NEEDED, assumedBy: new iam.ServicePrincipal("ec2.amazonaws.com") }), this.grantPrincipal = this._role, props.ssmSessionPermissions && this.role.addManagedPolicy(iam.ManagedPolicy.fromAwsManagedPolicyName("AmazonSSMManagedInstanceCore"));
          const iamProfile = new iam.CfnInstanceProfile(this, "InstanceProfile", { roles: [this.role.roleName] }), imageConfig = props.machineImage.getImage(this);
          this._userData = props.userData ?? imageConfig.userData;
          const userDataToken = core_1.Lazy.string({ produce: () => core_1.Fn.base64(this.userData.render()) }), securityGroupsToken = core_1.Lazy.list({ produce: () => this.securityGroups.map((sg) => sg.securityGroupId) });
          launchConfig = new autoscaling_generated_1.CfnLaunchConfiguration(this, "LaunchConfig", { imageId: imageConfig.imageId, keyName: props.keyName, instanceType: props.instanceType.toString(), instanceMonitoring: props.instanceMonitoring !== void 0 ? props.instanceMonitoring === Monitoring.DETAILED : void 0, securityGroups: securityGroupsToken, iamInstanceProfile: iamProfile.ref, userData: userDataToken, associatePublicIpAddress: props.associatePublicIpAddress, spotPrice: props.spotPrice, blockDeviceMappings: props.blockDevices !== void 0 ? synthesizeBlockDeviceMappings(this, props.blockDevices) : void 0 }), launchConfig.node.addDependency(this.role), this.osType = imageConfig.osType;
        }
        const desiredCapacity = props.desiredCapacity, minCapacity = props.minCapacity ?? 1, maxCapacity = props.maxCapacity ?? desiredCapacity ?? Math.max(minCapacity, 1);
        if ((0, core_1.withResolved)(minCapacity, maxCapacity, (min, max) => {
          if (min > max)
            throw new Error(`minCapacity (${min}) should be <= maxCapacity (${max})`);
        }), (0, core_1.withResolved)(desiredCapacity, minCapacity, (desired, min) => {
          if (desired !== void 0 && desired < min)
            throw new Error(`Should have minCapacity (${min}) <= desiredCapacity (${desired})`);
        }), (0, core_1.withResolved)(desiredCapacity, maxCapacity, (desired, max) => {
          if (desired !== void 0 && max < desired)
            throw new Error(`Should have desiredCapacity (${desired}) <= maxCapacity (${max})`);
        }), desiredCapacity !== void 0 && core_1.Annotations.of(this).addWarning("desiredCapacity has been configured. Be aware this will reset the size of your AutoScalingGroup on every deployment. See https://github.com/aws/aws-cdk/issues/5215"), this.maxInstanceLifetime = props.maxInstanceLifetime, this.maxInstanceLifetime && !this.maxInstanceLifetime.isUnresolved() && this.maxInstanceLifetime.toSeconds() !== 0 && (this.maxInstanceLifetime.toSeconds() < 86400 || this.maxInstanceLifetime.toSeconds() > 31536e3))
          throw new Error("maxInstanceLifetime must be between 1 and 365 days (inclusive)");
        if (props.notificationsTopic && props.notifications)
          throw new Error("Cannot set 'notificationsTopic' and 'notifications', 'notificationsTopic' is deprecated use 'notifications' instead");
        props.notificationsTopic && (this.notifications = [{ topic: props.notificationsTopic }]), props.notifications && (this.notifications = props.notifications.map((nc) => ({ topic: nc.topic, scalingEvents: nc.scalingEvents ?? ScalingEvents.ALL })));
        const { subnetIds, hasPublic } = props.vpc.selectSubnets(props.vpcSubnets), asgProps = { autoScalingGroupName: this.physicalName, cooldown: props.cooldown?.toSeconds().toString(), minSize: core_1.Tokenization.stringifyNumber(minCapacity), maxSize: core_1.Tokenization.stringifyNumber(maxCapacity), desiredCapacity: desiredCapacity !== void 0 ? core_1.Tokenization.stringifyNumber(desiredCapacity) : void 0, loadBalancerNames: core_1.Lazy.list({ produce: () => this.loadBalancerNames }, { omitEmpty: true }), targetGroupArns: core_1.Lazy.list({ produce: () => this.targetGroupArns }, { omitEmpty: true }), notificationConfigurations: this.renderNotificationConfiguration(), metricsCollection: core_1.Lazy.any({ produce: () => this.renderMetricsCollection() }), vpcZoneIdentifier: subnetIds, healthCheckType: props.healthCheck && props.healthCheck.type, healthCheckGracePeriod: props.healthCheck && props.healthCheck.gracePeriod && props.healthCheck.gracePeriod.toSeconds(), maxInstanceLifetime: this.maxInstanceLifetime ? this.maxInstanceLifetime.toSeconds() : void 0, newInstancesProtectedFromScaleIn: core_1.Lazy.any({ produce: () => this.newInstancesProtectedFromScaleIn }), terminationPolicies: props.terminationPolicies, defaultInstanceWarmup: props.defaultInstanceWarmup?.toSeconds(), capacityRebalance: props.capacityRebalance, ...this.getLaunchSettings(launchConfig, props.launchTemplate, props.mixedInstancesPolicy) };
        if (!hasPublic && props.associatePublicIpAddress)
          throw new Error("To set 'associatePublicIpAddress: true' you must select Public subnets (vpcSubnets: { subnetType: SubnetType.PUBLIC })");
        this.autoScalingGroup = new autoscaling_generated_1.CfnAutoScalingGroup(this, "ASG", asgProps), this.autoScalingGroupName = this.getResourceNameAttribute(this.autoScalingGroup.ref), this.autoScalingGroupArn = core_1.Stack.of(this).formatArn({ service: "autoscaling", resource: "autoScalingGroup:*:autoScalingGroupName", resourceName: this.autoScalingGroupName }), this.node.defaultChild = this.autoScalingGroup, this.applyUpdatePolicies(props, { desiredCapacity, minCapacity }), props.init && this.applyCloudFormationInit(props.init, props.initOptions), this.spotPrice = props.spotPrice, props.requireImdsv2 && core_1.Aspects.of(this).add(new aspects_1.AutoScalingGroupRequireImdsv2Aspect()), this.node.addValidation({ validate: () => this.validateTargetGroup() });
      }
      addSecurityGroup(securityGroup) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_ISecurityGroup(securityGroup);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addSecurityGroup), error;
        }
        if (!this.securityGroups)
          throw new Error("You cannot add security groups when the Auto Scaling Group is created from a Launch Template.");
        this.securityGroups.push(securityGroup);
      }
      attachToClassicLB(loadBalancer) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancing_LoadBalancer(loadBalancer);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.attachToClassicLB), error;
        }
        this.loadBalancerNames.push(loadBalancer.loadBalancerName);
      }
      attachToApplicationTargetGroup(targetGroup) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_IApplicationTargetGroup(targetGroup);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.attachToApplicationTargetGroup), error;
        }
        return this.targetGroupArns.push(targetGroup.targetGroupArn), targetGroup instanceof elbv2.ApplicationTargetGroup && (this.albTargetGroup = targetGroup), targetGroup.registerConnectable(this), { targetType: elbv2.TargetType.INSTANCE };
      }
      attachToNetworkTargetGroup(targetGroup) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_INetworkTargetGroup(targetGroup);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.attachToNetworkTargetGroup), error;
        }
        return this.targetGroupArns.push(targetGroup.targetGroupArn), { targetType: elbv2.TargetType.INSTANCE };
      }
      addUserData(...commands) {
        this.userData.addCommands(...commands);
      }
      addToRolePolicy(statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToRolePolicy), error;
        }
        this.role.addToPrincipalPolicy(statement);
      }
      applyCloudFormationInit(init, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CloudFormationInit(init), jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_ApplyCloudFormationInitOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.applyCloudFormationInit), error;
        }
        if (!this.autoScalingGroup.cfnOptions.creationPolicy?.resourceSignal)
          throw new Error("When applying CloudFormationInit, you must also configure signals by supplying 'signals' at instantiation time.");
        init.attach(this.autoScalingGroup, { platform: this.osType, instanceRole: this.role, userData: this.userData, configSets: options.configSets, embedFingerprint: options.embedFingerprint, printLog: options.printLog, ignoreFailures: options.ignoreFailures, includeRole: options.includeRole, includeUrl: options.includeUrl });
      }
      protectNewInstancesFromScaleIn() {
        this.newInstancesProtectedFromScaleIn = true;
      }
      areNewInstancesProtectedFromScaleIn() {
        return this.newInstancesProtectedFromScaleIn === true;
      }
      get connections() {
        if (this._connections)
          return this._connections;
        if (this.launchTemplate)
          return this.launchTemplate.connections;
        throw new Error("AutoScalingGroup can only be used as IConnectable if it is not created from an imported Launch Template.");
      }
      get userData() {
        if (this._userData)
          return this._userData;
        if (this.launchTemplate?.userData)
          return this.launchTemplate.userData;
        throw new Error("The provided launch template does not expose its user data.");
      }
      get role() {
        if (this._role)
          return this._role;
        throw new Error("The provided launch template does not expose or does not define its role.");
      }
      verifyNoLaunchConfigPropIsGiven(props) {
        if (props.machineImage)
          throw new Error("Setting 'machineImage' must not be set when 'launchTemplate' or 'mixedInstancesPolicy' is set");
        if (props.instanceType)
          throw new Error("Setting 'instanceType' must not be set when 'launchTemplate' or 'mixedInstancesPolicy' is set");
        if (props.role)
          throw new Error("Setting 'role' must not be set when 'launchTemplate' or 'mixedInstancesPolicy' is set");
        if (props.userData)
          throw new Error("Setting 'userData' must not be set when 'launchTemplate' or 'mixedInstancesPolicy' is set");
        if (props.securityGroup)
          throw new Error("Setting 'securityGroup' must not be set when 'launchTemplate' or 'mixedInstancesPolicy' is set");
        if (props.keyName)
          throw new Error("Setting 'keyName' must not be set when 'launchTemplate' or 'mixedInstancesPolicy' is set");
        if (props.instanceMonitoring)
          throw new Error("Setting 'instanceMonitoring' must not be set when 'launchTemplate' or 'mixedInstancesPolicy' is set");
        if (props.associatePublicIpAddress !== void 0)
          throw new Error("Setting 'associatePublicIpAddress' must not be set when 'launchTemplate' or 'mixedInstancesPolicy' is set");
        if (props.spotPrice)
          throw new Error("Setting 'spotPrice' must not be set when 'launchTemplate' or 'mixedInstancesPolicy' is set");
        if (props.blockDevices)
          throw new Error("Setting 'blockDevices' must not be set when 'launchTemplate' or 'mixedInstancesPolicy' is set");
      }
      applyUpdatePolicies(props, signalOptions) {
        const oldProps = ["updateType", "rollingUpdateConfiguration", "resourceSignalCount", "resourceSignalTimeout", "replacingUpdateMinSuccessfulInstancesPercent"];
        for (const prop of oldProps)
          if ((props.signals || props.updatePolicy) && props[prop] !== void 0)
            throw new Error(`Cannot set 'signals'/'updatePolicy' and '${prop}' together. Prefer 'signals'/'updatePolicy'`);
        props = { ...props, updatePolicy: props.updatePolicy ?? (props.init ? UpdatePolicy.rollingUpdate() : void 0) }, props.signals || props.updatePolicy ? this.applyNewSignalUpdatePolicies(props, signalOptions) : this.applyLegacySignalUpdatePolicies(props), props.ignoreUnmodifiedSizeProperties !== false && (this.autoScalingGroup.cfnOptions.updatePolicy = { ...this.autoScalingGroup.cfnOptions.updatePolicy, autoScalingScheduledAction: { ignoreUnmodifiedGroupSizeProperties: true } }), props.signals && !props.init && this.addToRolePolicy(new iam.PolicyStatement({ actions: ["cloudformation:SignalResource"], resources: [core_1.Aws.STACK_ID] }));
      }
      applyNewSignalUpdatePolicies(props, signalOptions) {
        this.autoScalingGroup.cfnOptions.creationPolicy = props.signals?.renderCreationPolicy(signalOptions), this.autoScalingGroup.cfnOptions.updatePolicy = props.updatePolicy?._renderUpdatePolicy({ creationPolicy: this.autoScalingGroup.cfnOptions.creationPolicy });
      }
      applyLegacySignalUpdatePolicies(props) {
        props.updateType === UpdateType.REPLACING_UPDATE ? (this.autoScalingGroup.cfnOptions.updatePolicy = { ...this.autoScalingGroup.cfnOptions.updatePolicy, autoScalingReplacingUpdate: { willReplace: true } }, props.replacingUpdateMinSuccessfulInstancesPercent !== void 0 && (this.autoScalingGroup.cfnOptions.creationPolicy = { ...this.autoScalingGroup.cfnOptions.creationPolicy, autoScalingCreationPolicy: { minSuccessfulInstancesPercent: validatePercentage(props.replacingUpdateMinSuccessfulInstancesPercent) } })) : props.updateType === UpdateType.ROLLING_UPDATE && (this.autoScalingGroup.cfnOptions.updatePolicy = { ...this.autoScalingGroup.cfnOptions.updatePolicy, autoScalingRollingUpdate: renderRollingUpdateConfig(props.rollingUpdateConfiguration) }), (props.resourceSignalCount !== void 0 || props.resourceSignalTimeout !== void 0) && (this.autoScalingGroup.cfnOptions.creationPolicy = { ...this.autoScalingGroup.cfnOptions.creationPolicy, resourceSignal: { count: props.resourceSignalCount, timeout: props.resourceSignalTimeout && props.resourceSignalTimeout.toIsoString() } });
      }
      renderNotificationConfiguration() {
        if (this.notifications.length !== 0)
          return this.notifications.map((notification) => ({ topicArn: notification.topic.topicArn, notificationTypes: notification.scalingEvents ? notification.scalingEvents._types : ScalingEvents.ALL._types }));
      }
      renderMetricsCollection() {
        if (this.groupMetrics.length !== 0)
          return this.groupMetrics.map((group) => ({ granularity: "1Minute", metrics: group._metrics?.size !== 0 ? [...group._metrics].map((m) => m.name) : void 0 }));
      }
      getLaunchSettings(launchConfig, launchTemplate, mixedInstancesPolicy) {
        if (launchConfig)
          return { launchConfigurationName: launchConfig.ref };
        if (launchTemplate)
          return { launchTemplate: this.convertILaunchTemplateToSpecification(launchTemplate) };
        if (mixedInstancesPolicy) {
          let instancesDistribution;
          if (mixedInstancesPolicy.instancesDistribution) {
            const dist = mixedInstancesPolicy.instancesDistribution;
            instancesDistribution = { onDemandAllocationStrategy: dist.onDemandAllocationStrategy?.toString(), onDemandBaseCapacity: dist.onDemandBaseCapacity, onDemandPercentageAboveBaseCapacity: dist.onDemandPercentageAboveBaseCapacity, spotAllocationStrategy: dist.spotAllocationStrategy?.toString(), spotInstancePools: dist.spotInstancePools, spotMaxPrice: dist.spotMaxPrice };
          }
          return { mixedInstancesPolicy: { instancesDistribution, launchTemplate: { launchTemplateSpecification: this.convertILaunchTemplateToSpecification(mixedInstancesPolicy.launchTemplate), ...mixedInstancesPolicy.launchTemplateOverrides ? { overrides: mixedInstancesPolicy.launchTemplateOverrides.map((override) => {
            if (override.weightedCapacity && Math.floor(override.weightedCapacity) !== override.weightedCapacity)
              throw new Error("Weight must be an integer");
            return { instanceType: override.instanceType.toString(), launchTemplateSpecification: override.launchTemplate ? this.convertILaunchTemplateToSpecification(override.launchTemplate) : void 0, weightedCapacity: override.weightedCapacity?.toString() };
          }) } : {} } } };
        }
        throw new Error("Either launchConfig, launchTemplate or mixedInstancesPolicy needs to be specified.");
      }
      convertILaunchTemplateToSpecification(launchTemplate) {
        return launchTemplate.launchTemplateId ? { launchTemplateId: launchTemplate.launchTemplateId, version: launchTemplate.versionNumber } : { launchTemplateName: launchTemplate.launchTemplateName, version: launchTemplate.versionNumber };
      }
      validateTargetGroup() {
        const errors = new Array();
        return this.hasCalledScaleOnRequestCount && this.targetGroupArns.length > 1 && errors.push("Cannon use multiple target groups if `scaleOnRequestCount()` is being used."), errors;
      }
    };
    _e = JSII_RTTI_SYMBOL_1, AutoScalingGroup[_e] = { fqn: "aws-cdk-lib.aws_autoscaling.AutoScalingGroup", version: "2.80.0" }, exports2.AutoScalingGroup = AutoScalingGroup;
    var UpdateType;
    (function(UpdateType2) {
      UpdateType2.NONE = "None", UpdateType2.REPLACING_UPDATE = "Replace", UpdateType2.ROLLING_UPDATE = "RollingUpdate";
    })(UpdateType = exports2.UpdateType || (exports2.UpdateType = {}));
    var ScalingEvent;
    (function(ScalingEvent2) {
      ScalingEvent2.INSTANCE_LAUNCH = "autoscaling:EC2_INSTANCE_LAUNCH", ScalingEvent2.INSTANCE_TERMINATE = "autoscaling:EC2_INSTANCE_TERMINATE", ScalingEvent2.INSTANCE_TERMINATE_ERROR = "autoscaling:EC2_INSTANCE_TERMINATE_ERROR", ScalingEvent2.INSTANCE_LAUNCH_ERROR = "autoscaling:EC2_INSTANCE_LAUNCH_ERROR", ScalingEvent2.TEST_NOTIFICATION = "autoscaling:TEST_NOTIFICATION";
    })(ScalingEvent = exports2.ScalingEvent || (exports2.ScalingEvent = {}));
    var ScalingEvents = class _ScalingEvents {
      constructor(...types) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_ScalingEvent(types);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ScalingEvents), error;
        }
        this._types = types;
      }
    };
    _f = JSII_RTTI_SYMBOL_1, ScalingEvents[_f] = { fqn: "aws-cdk-lib.aws_autoscaling.ScalingEvents", version: "2.80.0" }, ScalingEvents.ERRORS = new ScalingEvents(ScalingEvent.INSTANCE_LAUNCH_ERROR, ScalingEvent.INSTANCE_TERMINATE_ERROR), ScalingEvents.ALL = new ScalingEvents(ScalingEvent.INSTANCE_LAUNCH, ScalingEvent.INSTANCE_LAUNCH_ERROR, ScalingEvent.INSTANCE_TERMINATE, ScalingEvent.INSTANCE_TERMINATE_ERROR), ScalingEvents.LAUNCH_EVENTS = new ScalingEvents(ScalingEvent.INSTANCE_LAUNCH, ScalingEvent.INSTANCE_LAUNCH_ERROR), ScalingEvents.TERMINATION_EVENTS = new ScalingEvents(ScalingEvent.INSTANCE_TERMINATE, ScalingEvent.INSTANCE_TERMINATE_ERROR), exports2.ScalingEvents = ScalingEvents;
    var ScalingProcess;
    (function(ScalingProcess2) {
      ScalingProcess2.LAUNCH = "Launch", ScalingProcess2.TERMINATE = "Terminate", ScalingProcess2.HEALTH_CHECK = "HealthCheck", ScalingProcess2.REPLACE_UNHEALTHY = "ReplaceUnhealthy", ScalingProcess2.AZ_REBALANCE = "AZRebalance", ScalingProcess2.ALARM_NOTIFICATION = "AlarmNotification", ScalingProcess2.SCHEDULED_ACTIONS = "ScheduledActions", ScalingProcess2.ADD_TO_LOAD_BALANCER = "AddToLoadBalancer";
    })(ScalingProcess = exports2.ScalingProcess || (exports2.ScalingProcess = {}));
    var DEFAULT_SUSPEND_PROCESSES = [ScalingProcess.HEALTH_CHECK, ScalingProcess.REPLACE_UNHEALTHY, ScalingProcess.AZ_REBALANCE, ScalingProcess.ALARM_NOTIFICATION, ScalingProcess.SCHEDULED_ACTIONS];
    var HealthCheck = class _HealthCheck {
      static ec2(options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_Ec2HealthCheckOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.ec2), error;
        }
        return new _HealthCheck(HealthCheckType.EC2, options.grace);
      }
      static elb(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_ElbHealthCheckOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.elb), error;
        }
        return new _HealthCheck(HealthCheckType.ELB, options.grace);
      }
      constructor(type, gracePeriod) {
        this.type = type, this.gracePeriod = gracePeriod;
      }
    };
    _g = JSII_RTTI_SYMBOL_1, HealthCheck[_g] = { fqn: "aws-cdk-lib.aws_autoscaling.HealthCheck", version: "2.80.0" }, exports2.HealthCheck = HealthCheck;
    var HealthCheckType;
    (function(HealthCheckType2) {
      HealthCheckType2.EC2 = "EC2", HealthCheckType2.ELB = "ELB";
    })(HealthCheckType || (HealthCheckType = {}));
    function renderRollingUpdateConfig(config = {}) {
      const waitOnResourceSignals = config.minSuccessfulInstancesPercent !== void 0, pauseTime = config.pauseTime || (waitOnResourceSignals ? core_1.Duration.minutes(5) : core_1.Duration.seconds(0));
      return { maxBatchSize: config.maxBatchSize, minInstancesInService: config.minInstancesInService, minSuccessfulInstancesPercent: validatePercentage(config.minSuccessfulInstancesPercent), waitOnResourceSignals, pauseTime: pauseTime && pauseTime.toIsoString(), suspendProcesses: config.suspendProcesses ?? DEFAULT_SUSPEND_PROCESSES };
    }
    function validatePercentage(x) {
      if (x === void 0 || 0 <= x && x <= 100)
        return x;
      throw new Error(`Expected: a percentage 0..100, got: ${x}`);
    }
    function synthesizeBlockDeviceMappings(construct, blockDevices) {
      return blockDevices.map(({ deviceName, volume, mappingEnabled }) => {
        const { virtualName, ebsDevice: ebs } = volume;
        if (volume === volume_1.BlockDeviceVolume._NO_DEVICE || mappingEnabled === false)
          return { deviceName, noDevice: true };
        if (ebs) {
          const { iops, volumeType, throughput } = ebs;
          if (throughput) {
            const throughputRange = { Min: 125, Max: 1e3 }, { Min, Max } = throughputRange;
            if (volumeType != volume_1.EbsDeviceVolumeType.GP3)
              throw new Error("throughput property requires volumeType: EbsDeviceVolumeType.GP3");
            if (throughput < Min || throughput > Max)
              throw new Error(`throughput property takes a minimum of ${Min} and a maximum of ${Max}`);
            const maximumThroughputRatio = 0.25;
            if (iops) {
              const iopsRatio = throughput / iops;
              if (iopsRatio > maximumThroughputRatio)
                throw new Error(`Throughput (MiBps) to iops ratio of ${iopsRatio} is too high; maximum is ${maximumThroughputRatio} MiBps per iops`);
            }
          }
          if (iops)
            volumeType !== volume_1.EbsDeviceVolumeType.IO1 && core_1.Annotations.of(construct).addWarning("iops will be ignored without volumeType: EbsDeviceVolumeType.IO1");
          else if (volumeType === volume_1.EbsDeviceVolumeType.IO1)
            throw new Error("iops property is required with volumeType: EbsDeviceVolumeType.IO1");
        }
        return { deviceName, ebs, virtualName };
      });
    }
  }
});

// node_modules/aws-cdk-lib/aws-autoscaling/lib/aspects/require-imdsv2-aspect.js
var require_require_imdsv2_aspect2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-autoscaling/lib/aspects/require-imdsv2-aspect.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AutoScalingGroupRequireImdsv2Aspect = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var auto_scaling_group_1 = require_auto_scaling_group();
    var AutoScalingGroupRequireImdsv2Aspect = class _AutoScalingGroupRequireImdsv2Aspect {
      constructor() {
      }
      visit(node) {
        if (!(node instanceof auto_scaling_group_1.AutoScalingGroup))
          return;
        const launchConfig = node.node.tryFindChild("LaunchConfig");
        if (cdk.isResolvableObject(launchConfig.metadataOptions)) {
          this.warn(node, "CfnLaunchConfiguration.MetadataOptions field is a CDK token.");
          return;
        }
        launchConfig.metadataOptions = { ...launchConfig.metadataOptions, httpTokens: "required" };
      }
      warn(node, message) {
        cdk.Annotations.of(node).addWarning(`${_AutoScalingGroupRequireImdsv2Aspect.name} failed on node ${node.node.id}: ${message}`);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AutoScalingGroupRequireImdsv2Aspect[_a] = { fqn: "aws-cdk-lib.aws_autoscaling.AutoScalingGroupRequireImdsv2Aspect", version: "2.80.0" }, exports2.AutoScalingGroupRequireImdsv2Aspect = AutoScalingGroupRequireImdsv2Aspect;
  }
});

// node_modules/aws-cdk-lib/aws-autoscaling/lib/aspects/index.js
var require_aspects2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-autoscaling/lib/aspects/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_require_imdsv2_aspect2(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-autoscaling/lib/schedule.js
var require_schedule3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-autoscaling/lib/schedule.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Schedule = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core_1 = require_core2();
    var Schedule = class _Schedule {
      static expression(expression) {
        return new LiteralSchedule(expression);
      }
      static cron(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_CronOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.cron), error;
        }
        if (options.weekDay !== void 0 && options.day !== void 0)
          throw new Error("Cannot supply both 'day' and 'weekDay', use at most one");
        const minute = fallback(options.minute, "*"), hour = fallback(options.hour, "*"), month = fallback(options.month, "*"), day = fallback(options.day, "*"), weekDay = fallback(options.weekDay, "*");
        return new class extends _Schedule {
          constructor() {
            super(...arguments), this.expressionString = `${minute} ${hour} ${day} ${month} ${weekDay}`;
          }
          _bind(scope) {
            return options.minute || core_1.Annotations.of(scope).addWarning("cron: If you don't pass 'minute', by default the event runs every minute. Pass 'minute: '*'' if that's what you intend, or 'minute: 0' to run once per hour instead."), new LiteralSchedule(this.expressionString);
          }
        }();
      }
      constructor() {
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Schedule[_a] = { fqn: "aws-cdk-lib.aws_autoscaling.Schedule", version: "2.80.0" }, exports2.Schedule = Schedule;
    var LiteralSchedule = class extends Schedule {
      constructor(expressionString) {
        super(), this.expressionString = expressionString;
      }
      _bind() {
      }
    };
    function fallback(x, def) {
      return x === void 0 ? def : x;
    }
  }
});

// node_modules/aws-cdk-lib/aws-autoscaling/lib/lifecycle-hook-target.js
var require_lifecycle_hook_target = __commonJS({
  "node_modules/aws-cdk-lib/aws-autoscaling/lib/lifecycle-hook-target.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-autoscaling/lib/termination-policy.js
var require_termination_policy = __commonJS({
  "node_modules/aws-cdk-lib/aws-autoscaling/lib/termination-policy.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.TerminationPolicy = void 0;
    var TerminationPolicy;
    (function(TerminationPolicy2) {
      TerminationPolicy2.ALLOCATION_STRATEGY = "AllocationStrategy", TerminationPolicy2.CLOSEST_TO_NEXT_INSTANCE_HOUR = "ClosestToNextInstanceHour", TerminationPolicy2.DEFAULT = "Default", TerminationPolicy2.NEWEST_INSTANCE = "NewestInstance", TerminationPolicy2.OLDEST_INSTANCE = "OldestInstance", TerminationPolicy2.OLDEST_LAUNCH_CONFIGURATION = "OldestLaunchConfiguration", TerminationPolicy2.OLDEST_LAUNCH_TEMPLATE = "OldestLaunchTemplate";
    })(TerminationPolicy = exports2.TerminationPolicy || (exports2.TerminationPolicy = {}));
  }
});

// node_modules/aws-cdk-lib/aws-autoscaling/lib/index.js
var require_lib53 = __commonJS({
  "node_modules/aws-cdk-lib/aws-autoscaling/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_aspects2(), exports2), __exportStar(require_auto_scaling_group(), exports2), __exportStar(require_schedule3(), exports2), __exportStar(require_lifecycle_hook(), exports2), __exportStar(require_lifecycle_hook_target(), exports2), __exportStar(require_scheduled_action(), exports2), __exportStar(require_step_scaling_action2(), exports2), __exportStar(require_step_scaling_policy2(), exports2), __exportStar(require_target_tracking_scaling_policy2(), exports2), __exportStar(require_termination_policy(), exports2), __exportStar(require_volume2(), exports2), __exportStar(require_warm_pool(), exports2), __exportStar(require_autoscaling_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-autoscaling/index.js
var require_aws_autoscaling = __commonJS({
  "node_modules/aws-cdk-lib/aws-autoscaling/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib53(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-autoscaling-hooktargets/lib/common.js
var require_common3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-autoscaling-hooktargets/lib/common.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.createRole = void 0;
    var iam = require_aws_iam();
    function createRole(scope, _role) {
      let role = _role;
      return role || (role = new iam.Role(scope, "Role", { assumedBy: new iam.ServicePrincipal("autoscaling.amazonaws.com") })), role;
    }
    exports2.createRole = createRole;
  }
});

// node_modules/aws-cdk-lib/aws-autoscaling-hooktargets/lib/queue-hook.js
var require_queue_hook = __commonJS({
  "node_modules/aws-cdk-lib/aws-autoscaling-hooktargets/lib/queue-hook.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.QueueHook = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var common_1 = require_common3();
    var QueueHook = class _QueueHook {
      constructor(queue) {
        this.queue = queue;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sqs_IQueue(queue);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _QueueHook), error;
        }
      }
      bind(_scope, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_BindHookTargetOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        const role = (0, common_1.createRole)(_scope, options.role);
        return this.queue.grantSendMessages(role), { notificationTargetArn: this.queue.queueArn, createdRole: role };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, QueueHook[_a] = { fqn: "aws-cdk-lib.aws_autoscaling_hooktargets.QueueHook", version: "2.80.0" }, exports2.QueueHook = QueueHook;
  }
});

// node_modules/aws-cdk-lib/aws-autoscaling-hooktargets/lib/topic-hook.js
var require_topic_hook = __commonJS({
  "node_modules/aws-cdk-lib/aws-autoscaling-hooktargets/lib/topic-hook.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.TopicHook = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var common_1 = require_common3();
    var TopicHook = class _TopicHook {
      constructor(topic) {
        this.topic = topic;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sns_ITopic(topic);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _TopicHook), error;
        }
      }
      bind(_scope, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_BindHookTargetOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        const role = (0, common_1.createRole)(_scope, options.role);
        return this.topic.grantPublish(role), { notificationTargetArn: this.topic.topicArn, createdRole: role };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, TopicHook[_a] = { fqn: "aws-cdk-lib.aws_autoscaling_hooktargets.TopicHook", version: "2.80.0" }, exports2.TopicHook = TopicHook;
  }
});

// node_modules/aws-cdk-lib/aws-sns/lib/sns.generated.js
var require_sns_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-sns/lib/sns.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnTopicPolicy = exports2.CfnTopic = exports2.CfnSubscription = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnSubscriptionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deliveryPolicy", cdk.validateObject)(properties.deliveryPolicy)), errors.collect(cdk.propertyValidator("endpoint", cdk.validateString)(properties.endpoint)), errors.collect(cdk.propertyValidator("filterPolicy", cdk.validateObject)(properties.filterPolicy)), errors.collect(cdk.propertyValidator("filterPolicyScope", cdk.validateString)(properties.filterPolicyScope)), errors.collect(cdk.propertyValidator("protocol", cdk.requiredValidator)(properties.protocol)), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.collect(cdk.propertyValidator("rawMessageDelivery", cdk.validateBoolean)(properties.rawMessageDelivery)), errors.collect(cdk.propertyValidator("redrivePolicy", cdk.validateObject)(properties.redrivePolicy)), errors.collect(cdk.propertyValidator("region", cdk.validateString)(properties.region)), errors.collect(cdk.propertyValidator("subscriptionRoleArn", cdk.validateString)(properties.subscriptionRoleArn)), errors.collect(cdk.propertyValidator("topicArn", cdk.requiredValidator)(properties.topicArn)), errors.collect(cdk.propertyValidator("topicArn", cdk.validateString)(properties.topicArn)), errors.wrap('supplied properties not correct for "CfnSubscriptionProps"');
    }
    function cfnSubscriptionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSubscriptionPropsValidator(properties).assertSuccess(), { Protocol: cdk.stringToCloudFormation(properties.protocol), TopicArn: cdk.stringToCloudFormation(properties.topicArn), DeliveryPolicy: cdk.objectToCloudFormation(properties.deliveryPolicy), Endpoint: cdk.stringToCloudFormation(properties.endpoint), FilterPolicy: cdk.objectToCloudFormation(properties.filterPolicy), FilterPolicyScope: cdk.stringToCloudFormation(properties.filterPolicyScope), RawMessageDelivery: cdk.booleanToCloudFormation(properties.rawMessageDelivery), RedrivePolicy: cdk.objectToCloudFormation(properties.redrivePolicy), Region: cdk.stringToCloudFormation(properties.region), SubscriptionRoleArn: cdk.stringToCloudFormation(properties.subscriptionRoleArn) }) : properties;
    }
    function CfnSubscriptionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("protocol", "Protocol", cfn_parse.FromCloudFormation.getString(properties.Protocol)), ret.addPropertyResult("topicArn", "TopicArn", cfn_parse.FromCloudFormation.getString(properties.TopicArn)), ret.addPropertyResult("deliveryPolicy", "DeliveryPolicy", properties.DeliveryPolicy != null ? cfn_parse.FromCloudFormation.getAny(properties.DeliveryPolicy) : void 0), ret.addPropertyResult("endpoint", "Endpoint", properties.Endpoint != null ? cfn_parse.FromCloudFormation.getString(properties.Endpoint) : void 0), ret.addPropertyResult("filterPolicy", "FilterPolicy", properties.FilterPolicy != null ? cfn_parse.FromCloudFormation.getAny(properties.FilterPolicy) : void 0), ret.addPropertyResult("filterPolicyScope", "FilterPolicyScope", properties.FilterPolicyScope != null ? cfn_parse.FromCloudFormation.getString(properties.FilterPolicyScope) : void 0), ret.addPropertyResult("rawMessageDelivery", "RawMessageDelivery", properties.RawMessageDelivery != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RawMessageDelivery) : void 0), ret.addPropertyResult("redrivePolicy", "RedrivePolicy", properties.RedrivePolicy != null ? cfn_parse.FromCloudFormation.getAny(properties.RedrivePolicy) : void 0), ret.addPropertyResult("region", "Region", properties.Region != null ? cfn_parse.FromCloudFormation.getString(properties.Region) : void 0), ret.addPropertyResult("subscriptionRoleArn", "SubscriptionRoleArn", properties.SubscriptionRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.SubscriptionRoleArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSubscription = class _CfnSubscription extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSubscriptionPropsFromCloudFormation(resourceProperties), ret = new _CfnSubscription(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSubscription.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sns_CfnSubscriptionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSubscription), error;
        }
        cdk.requireProperty(props, "protocol", this), cdk.requireProperty(props, "topicArn", this), this.protocol = props.protocol, this.topicArn = props.topicArn, this.deliveryPolicy = props.deliveryPolicy, this.endpoint = props.endpoint, this.filterPolicy = props.filterPolicy, this.filterPolicyScope = props.filterPolicyScope, this.rawMessageDelivery = props.rawMessageDelivery, this.redrivePolicy = props.redrivePolicy, this.region = props.region, this.subscriptionRoleArn = props.subscriptionRoleArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSubscription.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { protocol: this.protocol, topicArn: this.topicArn, deliveryPolicy: this.deliveryPolicy, endpoint: this.endpoint, filterPolicy: this.filterPolicy, filterPolicyScope: this.filterPolicyScope, rawMessageDelivery: this.rawMessageDelivery, redrivePolicy: this.redrivePolicy, region: this.region, subscriptionRoleArn: this.subscriptionRoleArn };
      }
      renderProperties(props) {
        return cfnSubscriptionPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnSubscription[_a] = { fqn: "aws-cdk-lib.aws_sns.CfnSubscription", version: "2.80.0" }, CfnSubscription.CFN_RESOURCE_TYPE_NAME = "AWS::SNS::Subscription", exports2.CfnSubscription = CfnSubscription;
    function CfnTopicPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contentBasedDeduplication", cdk.validateBoolean)(properties.contentBasedDeduplication)), errors.collect(cdk.propertyValidator("dataProtectionPolicy", cdk.validateObject)(properties.dataProtectionPolicy)), errors.collect(cdk.propertyValidator("displayName", cdk.validateString)(properties.displayName)), errors.collect(cdk.propertyValidator("fifoTopic", cdk.validateBoolean)(properties.fifoTopic)), errors.collect(cdk.propertyValidator("kmsMasterKeyId", cdk.validateString)(properties.kmsMasterKeyId)), errors.collect(cdk.propertyValidator("signatureVersion", cdk.validateString)(properties.signatureVersion)), errors.collect(cdk.propertyValidator("subscription", cdk.listValidator(CfnTopic_SubscriptionPropertyValidator))(properties.subscription)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("topicName", cdk.validateString)(properties.topicName)), errors.collect(cdk.propertyValidator("tracingConfig", cdk.validateString)(properties.tracingConfig)), errors.wrap('supplied properties not correct for "CfnTopicProps"');
    }
    function cfnTopicPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicPropsValidator(properties).assertSuccess(), { ContentBasedDeduplication: cdk.booleanToCloudFormation(properties.contentBasedDeduplication), DataProtectionPolicy: cdk.objectToCloudFormation(properties.dataProtectionPolicy), DisplayName: cdk.stringToCloudFormation(properties.displayName), FifoTopic: cdk.booleanToCloudFormation(properties.fifoTopic), KmsMasterKeyId: cdk.stringToCloudFormation(properties.kmsMasterKeyId), SignatureVersion: cdk.stringToCloudFormation(properties.signatureVersion), Subscription: cdk.listMapper(cfnTopicSubscriptionPropertyToCloudFormation)(properties.subscription), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TopicName: cdk.stringToCloudFormation(properties.topicName), TracingConfig: cdk.stringToCloudFormation(properties.tracingConfig) }) : properties;
    }
    function CfnTopicPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contentBasedDeduplication", "ContentBasedDeduplication", properties.ContentBasedDeduplication != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ContentBasedDeduplication) : void 0), ret.addPropertyResult("dataProtectionPolicy", "DataProtectionPolicy", properties.DataProtectionPolicy != null ? cfn_parse.FromCloudFormation.getAny(properties.DataProtectionPolicy) : void 0), ret.addPropertyResult("displayName", "DisplayName", properties.DisplayName != null ? cfn_parse.FromCloudFormation.getString(properties.DisplayName) : void 0), ret.addPropertyResult("fifoTopic", "FifoTopic", properties.FifoTopic != null ? cfn_parse.FromCloudFormation.getBoolean(properties.FifoTopic) : void 0), ret.addPropertyResult("kmsMasterKeyId", "KmsMasterKeyId", properties.KmsMasterKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsMasterKeyId) : void 0), ret.addPropertyResult("signatureVersion", "SignatureVersion", properties.SignatureVersion != null ? cfn_parse.FromCloudFormation.getString(properties.SignatureVersion) : void 0), ret.addPropertyResult("subscription", "Subscription", properties.Subscription != null ? cfn_parse.FromCloudFormation.getArray(CfnTopicSubscriptionPropertyFromCloudFormation)(properties.Subscription) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("topicName", "TopicName", properties.TopicName != null ? cfn_parse.FromCloudFormation.getString(properties.TopicName) : void 0), ret.addPropertyResult("tracingConfig", "TracingConfig", properties.TracingConfig != null ? cfn_parse.FromCloudFormation.getString(properties.TracingConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTopic = class _CfnTopic extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTopicPropsFromCloudFormation(resourceProperties), ret = new _CfnTopic(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnTopic.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sns_CfnTopicProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTopic), error;
        }
        this.attrTopicArn = cdk.Token.asString(this.getAtt("TopicArn", cdk.ResolutionTypeHint.STRING)), this.attrTopicName = cdk.Token.asString(this.getAtt("TopicName", cdk.ResolutionTypeHint.STRING)), this.contentBasedDeduplication = props.contentBasedDeduplication, this.dataProtectionPolicy = props.dataProtectionPolicy, this.displayName = props.displayName, this.fifoTopic = props.fifoTopic, this.kmsMasterKeyId = props.kmsMasterKeyId, this.signatureVersion = props.signatureVersion, this.subscription = props.subscription, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SNS::Topic", props.tags, { tagPropertyName: "tags" }), this.topicName = props.topicName, this.tracingConfig = props.tracingConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTopic.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { contentBasedDeduplication: this.contentBasedDeduplication, dataProtectionPolicy: this.dataProtectionPolicy, displayName: this.displayName, fifoTopic: this.fifoTopic, kmsMasterKeyId: this.kmsMasterKeyId, signatureVersion: this.signatureVersion, subscription: this.subscription, tags: this.tags.renderTags(), topicName: this.topicName, tracingConfig: this.tracingConfig };
      }
      renderProperties(props) {
        return cfnTopicPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnTopic[_b] = { fqn: "aws-cdk-lib.aws_sns.CfnTopic", version: "2.80.0" }, CfnTopic.CFN_RESOURCE_TYPE_NAME = "AWS::SNS::Topic", exports2.CfnTopic = CfnTopic;
    function CfnTopic_SubscriptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endpoint", cdk.requiredValidator)(properties.endpoint)), errors.collect(cdk.propertyValidator("endpoint", cdk.validateString)(properties.endpoint)), errors.collect(cdk.propertyValidator("protocol", cdk.requiredValidator)(properties.protocol)), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.wrap('supplied properties not correct for "SubscriptionProperty"');
    }
    function cfnTopicSubscriptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopic_SubscriptionPropertyValidator(properties).assertSuccess(), { Endpoint: cdk.stringToCloudFormation(properties.endpoint), Protocol: cdk.stringToCloudFormation(properties.protocol) }) : properties;
    }
    function CfnTopicSubscriptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endpoint", "Endpoint", cfn_parse.FromCloudFormation.getString(properties.Endpoint)), ret.addPropertyResult("protocol", "Protocol", cfn_parse.FromCloudFormation.getString(properties.Protocol)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicPolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("policyDocument", cdk.requiredValidator)(properties.policyDocument)), errors.collect(cdk.propertyValidator("policyDocument", cdk.validateObject)(properties.policyDocument)), errors.collect(cdk.propertyValidator("topics", cdk.requiredValidator)(properties.topics)), errors.collect(cdk.propertyValidator("topics", cdk.listValidator(cdk.validateString))(properties.topics)), errors.wrap('supplied properties not correct for "CfnTopicPolicyProps"');
    }
    function cfnTopicPolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicPolicyPropsValidator(properties).assertSuccess(), { PolicyDocument: cdk.objectToCloudFormation(properties.policyDocument), Topics: cdk.listMapper(cdk.stringToCloudFormation)(properties.topics) }) : properties;
    }
    function CfnTopicPolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("policyDocument", "PolicyDocument", cfn_parse.FromCloudFormation.getAny(properties.PolicyDocument)), ret.addPropertyResult("topics", "Topics", cfn_parse.FromCloudFormation.getStringArray(properties.Topics)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTopicPolicy = class _CfnTopicPolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTopicPolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnTopicPolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTopicPolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sns_CfnTopicPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTopicPolicy), error;
        }
        cdk.requireProperty(props, "policyDocument", this), cdk.requireProperty(props, "topics", this), this.policyDocument = props.policyDocument, this.topics = props.topics;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTopicPolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { policyDocument: this.policyDocument, topics: this.topics };
      }
      renderProperties(props) {
        return cfnTopicPolicyPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnTopicPolicy[_c] = { fqn: "aws-cdk-lib.aws_sns.CfnTopicPolicy", version: "2.80.0" }, CfnTopicPolicy.CFN_RESOURCE_TYPE_NAME = "AWS::SNS::TopicPolicy", exports2.CfnTopicPolicy = CfnTopicPolicy;
  }
});

// node_modules/aws-cdk-lib/aws-sns/lib/policy.js
var require_policy5 = __commonJS({
  "node_modules/aws-cdk-lib/aws-sns/lib/policy.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.TopicPolicy = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var sns_generated_1 = require_sns_generated();
    var aws_iam_1 = require_aws_iam();
    var core_1 = require_core2();
    var TopicPolicy = class _TopicPolicy extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id), this.document = new aws_iam_1.PolicyDocument({ assignSids: true });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sns_TopicPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _TopicPolicy), error;
        }
        this.document = props.policyDocument ?? this.document, new sns_generated_1.CfnTopicPolicy(this, "Resource", { policyDocument: this.document, topics: props.topics.map((t) => t.topicArn) });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, TopicPolicy[_a] = { fqn: "aws-cdk-lib.aws_sns.TopicPolicy", version: "2.80.0" }, exports2.TopicPolicy = TopicPolicy;
  }
});

// node_modules/aws-cdk-lib/aws-sns/lib/subscription.js
var require_subscription = __commonJS({
  "node_modules/aws-cdk-lib/aws-sns/lib/subscription.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Policy = exports2.Filter = exports2.FilterOrPolicy = exports2.FilterOrPolicyType = exports2.SubscriptionProtocol = exports2.Subscription = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var sns_generated_1 = require_sns_generated();
    var aws_iam_1 = require_aws_iam();
    var core_1 = require_core2();
    var Subscription = class _Subscription extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sns_SubscriptionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Subscription), error;
        }
        if (props.rawMessageDelivery && [SubscriptionProtocol.HTTP, SubscriptionProtocol.HTTPS, SubscriptionProtocol.SQS, SubscriptionProtocol.FIREHOSE].indexOf(props.protocol) < 0)
          throw new Error("Raw message delivery can only be enabled for HTTP, HTTPS, SQS, and Firehose subscriptions.");
        if (props.filterPolicy) {
          if (Object.keys(props.filterPolicy).length > 5)
            throw new Error("A filter policy can have a maximum of 5 attribute names.");
          this.filterPolicy = Object.entries(props.filterPolicy).reduce((acc, [k, v]) => ({ ...acc, [k]: v.conditions }), {});
          let total = 1;
          if (Object.values(this.filterPolicy).forEach((filter) => {
            total *= filter.length;
          }), total > 150)
            throw new Error(`The total combination of values (${total}) must not exceed 150.`);
        } else if (props.filterPolicyWithMessageBody) {
          if (Object.keys(props.filterPolicyWithMessageBody).length > 5)
            throw new Error("A filter policy can have a maximum of 5 attribute names.");
          this.filterPolicyWithMessageBody = props.filterPolicyWithMessageBody;
        }
        if (props.protocol === SubscriptionProtocol.FIREHOSE && !props.subscriptionRoleArn)
          throw new Error("Subscription role arn is required field for subscriptions with a firehose protocol.");
        const filterPolicy = this.filterPolicyWithMessageBody ? buildFilterPolicyWithMessageBody(this.filterPolicyWithMessageBody) : this.filterPolicy;
        this.deadLetterQueue = this.buildDeadLetterQueue(props), new sns_generated_1.CfnSubscription(this, "Resource", { endpoint: props.endpoint, protocol: props.protocol, topicArn: props.topic.topicArn, rawMessageDelivery: props.rawMessageDelivery, filterPolicy, filterPolicyScope: this.filterPolicyWithMessageBody ? "MessageBody" : void 0, region: props.region, redrivePolicy: this.buildDeadLetterConfig(this.deadLetterQueue), subscriptionRoleArn: props.subscriptionRoleArn });
      }
      buildDeadLetterQueue(props) {
        if (!props.deadLetterQueue)
          return;
        const deadLetterQueue = props.deadLetterQueue;
        return deadLetterQueue.addToResourcePolicy(new aws_iam_1.PolicyStatement({ resources: [deadLetterQueue.queueArn], actions: ["sqs:SendMessage"], principals: [new aws_iam_1.ServicePrincipal("sns.amazonaws.com")], conditions: { ArnEquals: { "aws:SourceArn": props.topic.topicArn } } })), deadLetterQueue;
      }
      buildDeadLetterConfig(deadLetterQueue) {
        if (deadLetterQueue)
          return { deadLetterTargetArn: deadLetterQueue.queueArn };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Subscription[_a] = { fqn: "aws-cdk-lib.aws_sns.Subscription", version: "2.80.0" }, exports2.Subscription = Subscription;
    var SubscriptionProtocol;
    (function(SubscriptionProtocol2) {
      SubscriptionProtocol2.HTTP = "http", SubscriptionProtocol2.HTTPS = "https", SubscriptionProtocol2.EMAIL = "email", SubscriptionProtocol2.EMAIL_JSON = "email-json", SubscriptionProtocol2.SMS = "sms", SubscriptionProtocol2.SQS = "sqs", SubscriptionProtocol2.APPLICATION = "application", SubscriptionProtocol2.LAMBDA = "lambda", SubscriptionProtocol2.FIREHOSE = "firehose";
    })(SubscriptionProtocol = exports2.SubscriptionProtocol || (exports2.SubscriptionProtocol = {}));
    function buildFilterPolicyWithMessageBody(inputObject, depth = 1, totalCombinationValues = [1]) {
      const result = {};
      for (const [key, filterOrPolicy] of Object.entries(inputObject))
        if (filterOrPolicy.isPolicy())
          result[key] = buildFilterPolicyWithMessageBody(filterOrPolicy.policyDoc, depth + 1, totalCombinationValues);
        else if (filterOrPolicy.isFilter()) {
          const filter = filterOrPolicy.filterDoc.conditions;
          result[key] = filter, totalCombinationValues[0] *= filter.length * depth;
        }
      if (totalCombinationValues[0] > 150)
        throw new Error(`The total combination of values (${totalCombinationValues}) must not exceed 150.`);
      return result;
    }
    var FilterOrPolicyType;
    (function(FilterOrPolicyType2) {
      FilterOrPolicyType2[FilterOrPolicyType2.FILTER = 0] = "FILTER", FilterOrPolicyType2[FilterOrPolicyType2.POLICY = 1] = "POLICY";
    })(FilterOrPolicyType = exports2.FilterOrPolicyType || (exports2.FilterOrPolicyType = {}));
    var FilterOrPolicy = class {
      static filter(filter) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sns_SubscriptionFilter(filter);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.filter), error;
        }
        return new Filter(filter);
      }
      static policy(policy) {
        return new Policy(policy);
      }
      isPolicy() {
        return this.type === FilterOrPolicyType.POLICY;
      }
      isFilter() {
        return this.type === FilterOrPolicyType.FILTER;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, FilterOrPolicy[_b] = { fqn: "aws-cdk-lib.aws_sns.FilterOrPolicy", version: "2.80.0" }, exports2.FilterOrPolicy = FilterOrPolicy;
    var Filter = class _Filter extends FilterOrPolicy {
      constructor(filterDoc) {
        super(), this.filterDoc = filterDoc, this.type = FilterOrPolicyType.FILTER;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sns_SubscriptionFilter(filterDoc);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Filter), error;
        }
      }
    };
    _c = JSII_RTTI_SYMBOL_1, Filter[_c] = { fqn: "aws-cdk-lib.aws_sns.Filter", version: "2.80.0" }, exports2.Filter = Filter;
    var Policy = class extends FilterOrPolicy {
      constructor(policyDoc) {
        super(), this.policyDoc = policyDoc, this.type = FilterOrPolicyType.POLICY;
      }
    };
    _d = JSII_RTTI_SYMBOL_1, Policy[_d] = { fqn: "aws-cdk-lib.aws_sns.Policy", version: "2.80.0" }, exports2.Policy = Policy;
  }
});

// node_modules/aws-cdk-lib/aws-sns/lib/topic-base.js
var require_topic_base = __commonJS({
  "node_modules/aws-cdk-lib/aws-sns/lib/topic-base.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.TopicBase = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var policy_1 = require_policy5();
    var subscription_1 = require_subscription();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var TopicBase = class _TopicBase extends core_1.Resource {
      constructor(scope, id, props = {}) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_ResourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _TopicBase), error;
        }
        this.node.addValidation({ validate: () => this.policy?.document.validateForResourcePolicy() ?? [] });
      }
      addSubscription(topicSubscription) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sns_ITopicSubscription(topicSubscription);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addSubscription), error;
        }
        const subscriptionConfig = topicSubscription.bind(this), scope = subscriptionConfig.subscriberScope || this;
        let id = subscriptionConfig.subscriberId;
        if (core_1.Token.isUnresolved(subscriptionConfig.subscriberId) && (id = this.nextTokenId(scope)), scope.node.tryFindChild(id))
          throw new Error(`A subscription with id "${id}" already exists under the scope ${scope.node.path}`);
        const subscription = new subscription_1.Subscription(scope, id, { topic: this, ...subscriptionConfig });
        return subscriptionConfig.subscriptionDependency && subscription.node.addDependency(subscriptionConfig.subscriptionDependency), subscription;
      }
      addToResourcePolicy(statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToResourcePolicy), error;
        }
        return !this.policy && this.autoCreatePolicy && (this.policy = new policy_1.TopicPolicy(this, "Policy", { topics: [this] })), this.policy ? (this.policy.document.addStatements(statement), { statementAdded: true, policyDependable: this.policy }) : { statementAdded: false };
      }
      grantPublish(grantee) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(grantee);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantPublish), error;
        }
        return iam.Grant.addToPrincipalOrResource({ grantee, actions: ["sns:Publish"], resourceArns: [this.topicArn], resource: this });
      }
      bindAsNotificationRuleTarget(_scope) {
        return this.grantPublish(new iam.ServicePrincipal("codestar-notifications.amazonaws.com")), { targetType: "SNS", targetAddress: this.topicArn };
      }
      nextTokenId(scope) {
        let nextSuffix = 1;
        const re = /TokenSubscription:([\d]*)/gm;
        for (const source of scope.node.findAll()) {
          const m = re.exec(source.node.id);
          if (m !== null) {
            const matchSuffix = parseInt(m[1], 10);
            matchSuffix >= nextSuffix && (nextSuffix = matchSuffix + 1);
          }
        }
        return `TokenSubscription:${nextSuffix}`;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, TopicBase[_a] = { fqn: "aws-cdk-lib.aws_sns.TopicBase", version: "2.80.0" }, exports2.TopicBase = TopicBase;
  }
});

// node_modules/aws-cdk-lib/aws-sns/lib/topic.js
var require_topic = __commonJS({
  "node_modules/aws-cdk-lib/aws-sns/lib/topic.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Topic = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var sns_generated_1 = require_sns_generated();
    var topic_base_1 = require_topic_base();
    var core_1 = require_core2();
    var Topic = class _Topic extends topic_base_1.TopicBase {
      static fromTopicArn(scope, id, topicArn) {
        class Import extends topic_base_1.TopicBase {
          constructor() {
            super(...arguments), this.topicArn = topicArn, this.topicName = core_1.Stack.of(scope).splitArn(topicArn, core_1.ArnFormat.NO_RESOURCE_NAME).resource, this.fifo = this.topicName.endsWith(".fifo"), this.autoCreatePolicy = false;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.topicName }), this.autoCreatePolicy = true;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sns_TopicProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Topic), error;
        }
        if (props.contentBasedDeduplication && !props.fifo)
          throw new Error("Content based deduplication can only be enabled for FIFO SNS topics.");
        let cfnTopicName;
        props.fifo && props.topicName && !props.topicName.endsWith(".fifo") ? cfnTopicName = this.physicalName + ".fifo" : props.fifo && !props.topicName ? cfnTopicName = `${core_1.Names.uniqueResourceName(this, { maxLength: 251, separator: "-" })}.fifo` : cfnTopicName = this.physicalName;
        const resource = new sns_generated_1.CfnTopic(this, "Resource", { displayName: props.displayName, topicName: cfnTopicName, kmsMasterKeyId: props.masterKey && props.masterKey.keyArn, contentBasedDeduplication: props.contentBasedDeduplication, fifoTopic: props.fifo });
        this.topicArn = this.getResourceArnAttribute(resource.ref, { service: "sns", resource: this.physicalName }), this.topicName = this.getResourceNameAttribute(resource.attrTopicName), this.fifo = props.fifo || false;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Topic[_a] = { fqn: "aws-cdk-lib.aws_sns.Topic", version: "2.80.0" }, exports2.Topic = Topic;
  }
});

// node_modules/aws-cdk-lib/aws-sns/lib/subscriber.js
var require_subscriber = __commonJS({
  "node_modules/aws-cdk-lib/aws-sns/lib/subscriber.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-sns/lib/subscription-filter.js
var require_subscription_filter2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-sns/lib/subscription-filter.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SubscriptionFilter = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var SubscriptionFilter = class _SubscriptionFilter {
      static stringFilter(stringConditions) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sns_StringConditions(stringConditions);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.stringFilter), error;
        }
        const conditions = new Array();
        if (stringConditions.whitelist && stringConditions.allowlist)
          throw new Error("`whitelist` is deprecated; please use `allowlist` instead");
        if (stringConditions.blacklist && stringConditions.denylist)
          throw new Error("`blacklist` is deprecated; please use `denylist` instead");
        const allowlist = stringConditions.allowlist ?? stringConditions.whitelist, denylist = stringConditions.denylist ?? stringConditions.blacklist;
        return allowlist && conditions.push(...allowlist), denylist && conditions.push({ "anything-but": denylist }), stringConditions.matchPrefixes && conditions.push(...stringConditions.matchPrefixes.map((p) => ({ prefix: p }))), new _SubscriptionFilter(conditions);
      }
      static numericFilter(numericConditions) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sns_NumericConditions(numericConditions);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.numericFilter), error;
        }
        const conditions = new Array();
        if (numericConditions.whitelist && numericConditions.allowlist)
          throw new Error("`whitelist` is deprecated; please use `allowlist` instead");
        const allowlist = numericConditions.allowlist ?? numericConditions.whitelist;
        return allowlist && conditions.push(...allowlist.map((v) => ({ numeric: ["=", v] }))), numericConditions.greaterThan !== void 0 && conditions.push({ numeric: [">", numericConditions.greaterThan] }), numericConditions.greaterThanOrEqualTo !== void 0 && conditions.push({ numeric: [">=", numericConditions.greaterThanOrEqualTo] }), numericConditions.lessThan !== void 0 && conditions.push({ numeric: ["<", numericConditions.lessThan] }), numericConditions.lessThanOrEqualTo !== void 0 && conditions.push({ numeric: ["<=", numericConditions.lessThanOrEqualTo] }), numericConditions.between && conditions.push({ numeric: [">=", numericConditions.between.start, "<=", numericConditions.between.stop] }), numericConditions.betweenStrict && conditions.push({ numeric: [">", numericConditions.betweenStrict.start, "<", numericConditions.betweenStrict.stop] }), new _SubscriptionFilter(conditions);
      }
      static existsFilter() {
        return new _SubscriptionFilter([{ exists: true }]);
      }
      constructor(conditions = []) {
        this.conditions = conditions;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SubscriptionFilter[_a] = { fqn: "aws-cdk-lib.aws_sns.SubscriptionFilter", version: "2.80.0" }, exports2.SubscriptionFilter = SubscriptionFilter;
  }
});

// node_modules/aws-cdk-lib/aws-sns/lib/sns-augmentations.generated.js
var require_sns_augmentations_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-sns/lib/sns-augmentations.generated.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var cloudwatch = require_aws_cloudwatch();
    var topic_base_1 = require_topic_base();
    topic_base_1.TopicBase.prototype.metric = function(metricName, props) {
      return new cloudwatch.Metric({ namespace: "AWS/SNS", metricName, dimensionsMap: { TopicName: this.topicName }, ...props }).attachTo(this);
    }, topic_base_1.TopicBase.prototype.metricPublishSize = function(props) {
      return this.metric("PublishSize", { statistic: "Average", ...props });
    }, topic_base_1.TopicBase.prototype.metricNumberOfMessagesPublished = function(props) {
      return this.metric("NumberOfMessagesPublished", { statistic: "Sum", ...props });
    }, topic_base_1.TopicBase.prototype.metricNumberOfNotificationsDelivered = function(props) {
      return this.metric("NumberOfNotificationsDelivered", { statistic: "Sum", ...props });
    }, topic_base_1.TopicBase.prototype.metricNumberOfNotificationsFailed = function(props) {
      return this.metric("NumberOfNotificationsFailed", { statistic: "Sum", ...props });
    }, topic_base_1.TopicBase.prototype.metricNumberOfNotificationsFilteredOut = function(props) {
      return this.metric("NumberOfNotificationsFilteredOut", { statistic: "Sum", ...props });
    }, topic_base_1.TopicBase.prototype.metricNumberOfNotificationsFilteredOutNoMessageAttributes = function(props) {
      return this.metric("NumberOfNotificationsFilteredOut-NoMessageAttributes", { statistic: "Sum", ...props });
    }, topic_base_1.TopicBase.prototype.metricNumberOfNotificationsFilteredOutInvalidAttributes = function(props) {
      return this.metric("NumberOfNotificationsFilteredOut-InvalidAttributes", { statistic: "Sum", ...props });
    }, topic_base_1.TopicBase.prototype.metricSMSMonthToDateSpentUSD = function(props) {
      return this.metric("SMSMonthToDateSpentUSD", { statistic: "Maximum", ...props });
    }, topic_base_1.TopicBase.prototype.metricSMSSuccessRate = function(props) {
      return this.metric("SMSSuccessRate", { statistic: "Sum", ...props });
    };
  }
});

// node_modules/aws-cdk-lib/aws-sns/lib/index.js
var require_lib54 = __commonJS({
  "node_modules/aws-cdk-lib/aws-sns/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_policy5(), exports2), __exportStar(require_topic(), exports2), __exportStar(require_topic_base(), exports2), __exportStar(require_subscription(), exports2), __exportStar(require_subscriber(), exports2), __exportStar(require_subscription_filter2(), exports2), __exportStar(require_sns_generated(), exports2), require_sns_augmentations_generated();
  }
});

// node_modules/aws-cdk-lib/aws-sns/index.js
var require_aws_sns = __commonJS({
  "node_modules/aws-cdk-lib/aws-sns/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib54(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-sns-subscriptions/lib/subscription.js
var require_subscription2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-sns-subscriptions/lib/subscription.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-sns-subscriptions/lib/email.js
var require_email = __commonJS({
  "node_modules/aws-cdk-lib/aws-sns-subscriptions/lib/email.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EmailSubscription = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var sns = require_aws_sns();
    var EmailSubscription = class _EmailSubscription {
      constructor(emailAddress, props = {}) {
        this.emailAddress = emailAddress, this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sns_subscriptions_EmailSubscriptionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EmailSubscription), error;
        }
      }
      bind(_topic) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sns_ITopic(_topic);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { subscriberId: this.emailAddress, endpoint: this.emailAddress, protocol: this.props.json ? sns.SubscriptionProtocol.EMAIL_JSON : sns.SubscriptionProtocol.EMAIL, filterPolicy: this.props.filterPolicy, filterPolicyWithMessageBody: this.props.filterPolicyWithMessageBody, deadLetterQueue: this.props.deadLetterQueue };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EmailSubscription[_a] = { fqn: "aws-cdk-lib.aws_sns_subscriptions.EmailSubscription", version: "2.80.0" }, exports2.EmailSubscription = EmailSubscription;
  }
});

// node_modules/aws-cdk-lib/aws-sns-subscriptions/lib/lambda.js
var require_lambda5 = __commonJS({
  "node_modules/aws-cdk-lib/aws-sns-subscriptions/lib/lambda.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LambdaSubscription = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var iam = require_aws_iam();
    var sns = require_aws_sns();
    var core_1 = require_core2();
    var LambdaSubscription = class _LambdaSubscription {
      constructor(fn, props = {}) {
        this.fn = fn, this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_IFunction(fn), jsiiDeprecationWarnings.aws_cdk_lib_aws_sns_subscriptions_LambdaSubscriptionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _LambdaSubscription), error;
        }
      }
      bind(topic) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sns_ITopic(topic);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        if (!(this.fn instanceof constructs_1.Construct))
          throw new Error("The supplied lambda Function object must be an instance of Construct");
        return this.fn.addPermission(`AllowInvoke:${core_1.Names.nodeUniqueId(topic.node)}`, { sourceArn: topic.topicArn, principal: new iam.ServicePrincipal("sns.amazonaws.com") }), topic instanceof sns.Topic && topic.stack !== this.fn.stack && this.fn.stack.addDependency(topic.stack), { subscriberScope: this.fn, subscriberId: topic.node.id, endpoint: this.fn.functionArn, protocol: sns.SubscriptionProtocol.LAMBDA, filterPolicy: this.props.filterPolicy, filterPolicyWithMessageBody: this.props.filterPolicyWithMessageBody, region: this.regionFromArn(topic), deadLetterQueue: this.props.deadLetterQueue };
      }
      regionFromArn(topic) {
        return topic instanceof sns.Topic ? topic.stack !== this.fn.stack && !core_1.Token.isUnresolved(topic.env.region) && topic.env.region !== this.fn.env.region ? topic.env.region : void 0 : core_1.Stack.of(topic).splitArn(topic.topicArn, core_1.ArnFormat.SLASH_RESOURCE_NAME).region;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LambdaSubscription[_a] = { fqn: "aws-cdk-lib.aws_sns_subscriptions.LambdaSubscription", version: "2.80.0" }, exports2.LambdaSubscription = LambdaSubscription;
  }
});

// node_modules/aws-cdk-lib/aws-sns-subscriptions/lib/sqs.js
var require_sqs3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-sns-subscriptions/lib/sqs.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SqsSubscription = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var iam = require_aws_iam();
    var sns = require_aws_sns();
    var core_1 = require_core2();
    var cxapi = require_cx_api();
    var SqsSubscription = class _SqsSubscription {
      constructor(queue, props = {}) {
        this.queue = queue, this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sqs_IQueue(queue), jsiiDeprecationWarnings.aws_cdk_lib_aws_sns_subscriptions_SqsSubscriptionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SqsSubscription), error;
        }
      }
      bind(topic) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sns_ITopic(topic);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        if (!(this.queue instanceof constructs_1.Construct))
          throw new Error("The supplied Queue object must be an instance of Construct");
        const snsServicePrincipal = new iam.ServicePrincipal("sns.amazonaws.com"), queuePolicyDependable = this.queue.addToResourcePolicy(new iam.PolicyStatement({ resources: [this.queue.queueArn], actions: ["sqs:SendMessage"], principals: [snsServicePrincipal], conditions: { ArnEquals: { "aws:SourceArn": topic.topicArn } } })).policyDependable;
        return this.queue.encryptionMasterKey && this.queue.encryptionMasterKey.addToResourcePolicy(new iam.PolicyStatement({ resources: ["*"], actions: ["kms:Decrypt", "kms:GenerateDataKey"], principals: [snsServicePrincipal], conditions: core_1.FeatureFlags.of(topic).isEnabled(cxapi.SNS_SUBSCRIPTIONS_SQS_DECRYPTION_POLICY) ? { ArnEquals: { "aws:SourceArn": topic.topicArn } } : void 0 })), topic instanceof sns.Topic && topic.stack !== this.queue.stack && this.queue.stack.addDependency(topic.stack), { subscriberScope: this.queue, subscriberId: core_1.Names.nodeUniqueId(topic.node), endpoint: this.queue.queueArn, protocol: sns.SubscriptionProtocol.SQS, rawMessageDelivery: this.props.rawMessageDelivery, filterPolicy: this.props.filterPolicy, filterPolicyWithMessageBody: this.props.filterPolicyWithMessageBody, region: this.regionFromArn(topic), deadLetterQueue: this.props.deadLetterQueue, subscriptionDependency: queuePolicyDependable };
      }
      regionFromArn(topic) {
        return topic instanceof sns.Topic ? topic.stack !== this.queue.stack && !core_1.Token.isUnresolved(topic.env.region) && topic.env.region !== this.queue.env.region ? topic.env.region : void 0 : core_1.Stack.of(topic).splitArn(topic.topicArn, core_1.ArnFormat.SLASH_RESOURCE_NAME).region;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SqsSubscription[_a] = { fqn: "aws-cdk-lib.aws_sns_subscriptions.SqsSubscription", version: "2.80.0" }, exports2.SqsSubscription = SqsSubscription;
  }
});

// node_modules/aws-cdk-lib/aws-sns-subscriptions/lib/url.js
var require_url = __commonJS({
  "node_modules/aws-cdk-lib/aws-sns-subscriptions/lib/url.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.UrlSubscription = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var sns = require_aws_sns();
    var core_1 = require_core2();
    var UrlSubscription = class _UrlSubscription {
      constructor(url, props = {}) {
        this.url = url, this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sns_subscriptions_UrlSubscriptionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _UrlSubscription), error;
        }
        if (this.unresolvedUrl = core_1.Token.isUnresolved(url), !this.unresolvedUrl && !url.startsWith("http://") && !url.startsWith("https://"))
          throw new Error("URL must start with either http:// or https://");
        if (this.unresolvedUrl && props.protocol === void 0)
          throw new Error("Must provide protocol if url is unresolved");
        this.unresolvedUrl ? this.protocol = props.protocol : this.protocol = this.url.startsWith("https:") ? sns.SubscriptionProtocol.HTTPS : sns.SubscriptionProtocol.HTTP;
      }
      bind(_topic) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sns_ITopic(_topic);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { subscriberId: this.url, endpoint: this.url, protocol: this.protocol, rawMessageDelivery: this.props.rawMessageDelivery, filterPolicy: this.props.filterPolicy, filterPolicyWithMessageBody: this.props.filterPolicyWithMessageBody, deadLetterQueue: this.props.deadLetterQueue };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, UrlSubscription[_a] = { fqn: "aws-cdk-lib.aws_sns_subscriptions.UrlSubscription", version: "2.80.0" }, exports2.UrlSubscription = UrlSubscription;
  }
});

// node_modules/aws-cdk-lib/aws-sns-subscriptions/lib/sms.js
var require_sms2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-sns-subscriptions/lib/sms.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SmsSubscription = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var sns = require_aws_sns();
    var SmsSubscription = class _SmsSubscription {
      constructor(phoneNumber, props = {}) {
        this.phoneNumber = phoneNumber, this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sns_subscriptions_SmsSubscriptionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SmsSubscription), error;
        }
      }
      bind(_topic) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sns_ITopic(_topic);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { subscriberId: this.phoneNumber, endpoint: this.phoneNumber, protocol: sns.SubscriptionProtocol.SMS, filterPolicy: this.props.filterPolicy, filterPolicyWithMessageBody: this.props.filterPolicyWithMessageBody };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SmsSubscription[_a] = { fqn: "aws-cdk-lib.aws_sns_subscriptions.SmsSubscription", version: "2.80.0" }, exports2.SmsSubscription = SmsSubscription;
  }
});

// node_modules/aws-cdk-lib/aws-sns-subscriptions/lib/index.js
var require_lib55 = __commonJS({
  "node_modules/aws-cdk-lib/aws-sns-subscriptions/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_subscription2(), exports2), __exportStar(require_email(), exports2), __exportStar(require_lambda5(), exports2), __exportStar(require_sqs3(), exports2), __exportStar(require_url(), exports2), __exportStar(require_sms2(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-sns-subscriptions/index.js
var require_aws_sns_subscriptions = __commonJS({
  "node_modules/aws-cdk-lib/aws-sns-subscriptions/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib55(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-autoscaling-hooktargets/lib/lambda-hook.js
var require_lambda_hook = __commonJS({
  "node_modules/aws-cdk-lib/aws-autoscaling-hooktargets/lib/lambda-hook.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FunctionHook = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var common_1 = require_common3();
    var topic_hook_1 = require_topic_hook();
    var sns = require_aws_sns();
    var subs = require_aws_sns_subscriptions();
    var FunctionHook = class _FunctionHook {
      constructor(fn, encryptionKey) {
        this.fn = fn, this.encryptionKey = encryptionKey;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_IFunction(fn), jsiiDeprecationWarnings.aws_cdk_lib_aws_kms_IKey(encryptionKey);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _FunctionHook), error;
        }
      }
      bind(_scope, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_BindHookTargetOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        const topic = new sns.Topic(_scope, "Topic", { masterKey: this.encryptionKey }), role = (0, common_1.createRole)(_scope, options.role);
        return this.encryptionKey?.grant(role, "kms:Decrypt", "kms:GenerateDataKey"), topic.addSubscription(new subs.LambdaSubscription(this.fn)), new topic_hook_1.TopicHook(topic).bind(_scope, { lifecycleHook: options.lifecycleHook, role });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, FunctionHook[_a] = { fqn: "aws-cdk-lib.aws_autoscaling_hooktargets.FunctionHook", version: "2.80.0" }, exports2.FunctionHook = FunctionHook;
  }
});

// node_modules/aws-cdk-lib/aws-autoscaling-hooktargets/lib/index.js
var require_lib56 = __commonJS({
  "node_modules/aws-cdk-lib/aws-autoscaling-hooktargets/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_common3(), exports2), __exportStar(require_queue_hook(), exports2), __exportStar(require_topic_hook(), exports2), __exportStar(require_lambda_hook(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-autoscaling-hooktargets/index.js
var require_aws_autoscaling_hooktargets = __commonJS({
  "node_modules/aws-cdk-lib/aws-autoscaling-hooktargets/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib56(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-autoscalingplans/lib/autoscalingplans.generated.js
var require_autoscalingplans_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-autoscalingplans/lib/autoscalingplans.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnScalingPlan = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnScalingPlanPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationSource", cdk.requiredValidator)(properties.applicationSource)), errors.collect(cdk.propertyValidator("applicationSource", CfnScalingPlan_ApplicationSourcePropertyValidator)(properties.applicationSource)), errors.collect(cdk.propertyValidator("scalingInstructions", cdk.requiredValidator)(properties.scalingInstructions)), errors.collect(cdk.propertyValidator("scalingInstructions", cdk.listValidator(CfnScalingPlan_ScalingInstructionPropertyValidator))(properties.scalingInstructions)), errors.wrap('supplied properties not correct for "CfnScalingPlanProps"');
    }
    function cfnScalingPlanPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPlanPropsValidator(properties).assertSuccess(), { ApplicationSource: cfnScalingPlanApplicationSourcePropertyToCloudFormation(properties.applicationSource), ScalingInstructions: cdk.listMapper(cfnScalingPlanScalingInstructionPropertyToCloudFormation)(properties.scalingInstructions) }) : properties;
    }
    function CfnScalingPlanPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationSource", "ApplicationSource", CfnScalingPlanApplicationSourcePropertyFromCloudFormation(properties.ApplicationSource)), ret.addPropertyResult("scalingInstructions", "ScalingInstructions", cfn_parse.FromCloudFormation.getArray(CfnScalingPlanScalingInstructionPropertyFromCloudFormation)(properties.ScalingInstructions)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnScalingPlan = class _CfnScalingPlan extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnScalingPlanPropsFromCloudFormation(resourceProperties), ret = new _CfnScalingPlan(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnScalingPlan.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscalingplans_CfnScalingPlanProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnScalingPlan), error;
        }
        cdk.requireProperty(props, "applicationSource", this), cdk.requireProperty(props, "scalingInstructions", this), this.attrScalingPlanName = cdk.Token.asString(this.getAtt("ScalingPlanName", cdk.ResolutionTypeHint.STRING)), this.attrScalingPlanVersion = cdk.Token.asString(this.getAtt("ScalingPlanVersion", cdk.ResolutionTypeHint.STRING)), this.applicationSource = props.applicationSource, this.scalingInstructions = props.scalingInstructions;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnScalingPlan.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationSource: this.applicationSource, scalingInstructions: this.scalingInstructions };
      }
      renderProperties(props) {
        return cfnScalingPlanPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnScalingPlan[_a] = { fqn: "aws-cdk-lib.aws_autoscalingplans.CfnScalingPlan", version: "2.80.0" }, CfnScalingPlan.CFN_RESOURCE_TYPE_NAME = "AWS::AutoScalingPlans::ScalingPlan", exports2.CfnScalingPlan = CfnScalingPlan;
    function CfnScalingPlan_ApplicationSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudFormationStackArn", cdk.validateString)(properties.cloudFormationStackArn)), errors.collect(cdk.propertyValidator("tagFilters", cdk.listValidator(CfnScalingPlan_TagFilterPropertyValidator))(properties.tagFilters)), errors.wrap('supplied properties not correct for "ApplicationSourceProperty"');
    }
    function cfnScalingPlanApplicationSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPlan_ApplicationSourcePropertyValidator(properties).assertSuccess(), { CloudFormationStackARN: cdk.stringToCloudFormation(properties.cloudFormationStackArn), TagFilters: cdk.listMapper(cfnScalingPlanTagFilterPropertyToCloudFormation)(properties.tagFilters) }) : properties;
    }
    function CfnScalingPlanApplicationSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudFormationStackArn", "CloudFormationStackARN", properties.CloudFormationStackARN != null ? cfn_parse.FromCloudFormation.getString(properties.CloudFormationStackARN) : void 0), ret.addPropertyResult("tagFilters", "TagFilters", properties.TagFilters != null ? cfn_parse.FromCloudFormation.getArray(CfnScalingPlanTagFilterPropertyFromCloudFormation)(properties.TagFilters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScalingPlan_CustomizedLoadMetricSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dimensions", cdk.listValidator(CfnScalingPlan_MetricDimensionPropertyValidator))(properties.dimensions)), errors.collect(cdk.propertyValidator("metricName", cdk.requiredValidator)(properties.metricName)), errors.collect(cdk.propertyValidator("metricName", cdk.validateString)(properties.metricName)), errors.collect(cdk.propertyValidator("namespace", cdk.requiredValidator)(properties.namespace)), errors.collect(cdk.propertyValidator("namespace", cdk.validateString)(properties.namespace)), errors.collect(cdk.propertyValidator("statistic", cdk.requiredValidator)(properties.statistic)), errors.collect(cdk.propertyValidator("statistic", cdk.validateString)(properties.statistic)), errors.collect(cdk.propertyValidator("unit", cdk.validateString)(properties.unit)), errors.wrap('supplied properties not correct for "CustomizedLoadMetricSpecificationProperty"');
    }
    function cfnScalingPlanCustomizedLoadMetricSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPlan_CustomizedLoadMetricSpecificationPropertyValidator(properties).assertSuccess(), { Dimensions: cdk.listMapper(cfnScalingPlanMetricDimensionPropertyToCloudFormation)(properties.dimensions), MetricName: cdk.stringToCloudFormation(properties.metricName), Namespace: cdk.stringToCloudFormation(properties.namespace), Statistic: cdk.stringToCloudFormation(properties.statistic), Unit: cdk.stringToCloudFormation(properties.unit) }) : properties;
    }
    function CfnScalingPlanCustomizedLoadMetricSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dimensions", "Dimensions", properties.Dimensions != null ? cfn_parse.FromCloudFormation.getArray(CfnScalingPlanMetricDimensionPropertyFromCloudFormation)(properties.Dimensions) : void 0), ret.addPropertyResult("metricName", "MetricName", cfn_parse.FromCloudFormation.getString(properties.MetricName)), ret.addPropertyResult("namespace", "Namespace", cfn_parse.FromCloudFormation.getString(properties.Namespace)), ret.addPropertyResult("statistic", "Statistic", cfn_parse.FromCloudFormation.getString(properties.Statistic)), ret.addPropertyResult("unit", "Unit", properties.Unit != null ? cfn_parse.FromCloudFormation.getString(properties.Unit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScalingPlan_CustomizedScalingMetricSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dimensions", cdk.listValidator(CfnScalingPlan_MetricDimensionPropertyValidator))(properties.dimensions)), errors.collect(cdk.propertyValidator("metricName", cdk.requiredValidator)(properties.metricName)), errors.collect(cdk.propertyValidator("metricName", cdk.validateString)(properties.metricName)), errors.collect(cdk.propertyValidator("namespace", cdk.requiredValidator)(properties.namespace)), errors.collect(cdk.propertyValidator("namespace", cdk.validateString)(properties.namespace)), errors.collect(cdk.propertyValidator("statistic", cdk.requiredValidator)(properties.statistic)), errors.collect(cdk.propertyValidator("statistic", cdk.validateString)(properties.statistic)), errors.collect(cdk.propertyValidator("unit", cdk.validateString)(properties.unit)), errors.wrap('supplied properties not correct for "CustomizedScalingMetricSpecificationProperty"');
    }
    function cfnScalingPlanCustomizedScalingMetricSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPlan_CustomizedScalingMetricSpecificationPropertyValidator(properties).assertSuccess(), { Dimensions: cdk.listMapper(cfnScalingPlanMetricDimensionPropertyToCloudFormation)(properties.dimensions), MetricName: cdk.stringToCloudFormation(properties.metricName), Namespace: cdk.stringToCloudFormation(properties.namespace), Statistic: cdk.stringToCloudFormation(properties.statistic), Unit: cdk.stringToCloudFormation(properties.unit) }) : properties;
    }
    function CfnScalingPlanCustomizedScalingMetricSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dimensions", "Dimensions", properties.Dimensions != null ? cfn_parse.FromCloudFormation.getArray(CfnScalingPlanMetricDimensionPropertyFromCloudFormation)(properties.Dimensions) : void 0), ret.addPropertyResult("metricName", "MetricName", cfn_parse.FromCloudFormation.getString(properties.MetricName)), ret.addPropertyResult("namespace", "Namespace", cfn_parse.FromCloudFormation.getString(properties.Namespace)), ret.addPropertyResult("statistic", "Statistic", cfn_parse.FromCloudFormation.getString(properties.Statistic)), ret.addPropertyResult("unit", "Unit", properties.Unit != null ? cfn_parse.FromCloudFormation.getString(properties.Unit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScalingPlan_MetricDimensionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "MetricDimensionProperty"');
    }
    function cfnScalingPlanMetricDimensionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPlan_MetricDimensionPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnScalingPlanMetricDimensionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScalingPlan_PredefinedLoadMetricSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("predefinedLoadMetricType", cdk.requiredValidator)(properties.predefinedLoadMetricType)), errors.collect(cdk.propertyValidator("predefinedLoadMetricType", cdk.validateString)(properties.predefinedLoadMetricType)), errors.collect(cdk.propertyValidator("resourceLabel", cdk.validateString)(properties.resourceLabel)), errors.wrap('supplied properties not correct for "PredefinedLoadMetricSpecificationProperty"');
    }
    function cfnScalingPlanPredefinedLoadMetricSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPlan_PredefinedLoadMetricSpecificationPropertyValidator(properties).assertSuccess(), { PredefinedLoadMetricType: cdk.stringToCloudFormation(properties.predefinedLoadMetricType), ResourceLabel: cdk.stringToCloudFormation(properties.resourceLabel) }) : properties;
    }
    function CfnScalingPlanPredefinedLoadMetricSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("predefinedLoadMetricType", "PredefinedLoadMetricType", cfn_parse.FromCloudFormation.getString(properties.PredefinedLoadMetricType)), ret.addPropertyResult("resourceLabel", "ResourceLabel", properties.ResourceLabel != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceLabel) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScalingPlan_PredefinedScalingMetricSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("predefinedScalingMetricType", cdk.requiredValidator)(properties.predefinedScalingMetricType)), errors.collect(cdk.propertyValidator("predefinedScalingMetricType", cdk.validateString)(properties.predefinedScalingMetricType)), errors.collect(cdk.propertyValidator("resourceLabel", cdk.validateString)(properties.resourceLabel)), errors.wrap('supplied properties not correct for "PredefinedScalingMetricSpecificationProperty"');
    }
    function cfnScalingPlanPredefinedScalingMetricSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPlan_PredefinedScalingMetricSpecificationPropertyValidator(properties).assertSuccess(), { PredefinedScalingMetricType: cdk.stringToCloudFormation(properties.predefinedScalingMetricType), ResourceLabel: cdk.stringToCloudFormation(properties.resourceLabel) }) : properties;
    }
    function CfnScalingPlanPredefinedScalingMetricSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("predefinedScalingMetricType", "PredefinedScalingMetricType", cfn_parse.FromCloudFormation.getString(properties.PredefinedScalingMetricType)), ret.addPropertyResult("resourceLabel", "ResourceLabel", properties.ResourceLabel != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceLabel) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScalingPlan_ScalingInstructionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customizedLoadMetricSpecification", CfnScalingPlan_CustomizedLoadMetricSpecificationPropertyValidator)(properties.customizedLoadMetricSpecification)), errors.collect(cdk.propertyValidator("disableDynamicScaling", cdk.validateBoolean)(properties.disableDynamicScaling)), errors.collect(cdk.propertyValidator("maxCapacity", cdk.requiredValidator)(properties.maxCapacity)), errors.collect(cdk.propertyValidator("maxCapacity", cdk.validateNumber)(properties.maxCapacity)), errors.collect(cdk.propertyValidator("minCapacity", cdk.requiredValidator)(properties.minCapacity)), errors.collect(cdk.propertyValidator("minCapacity", cdk.validateNumber)(properties.minCapacity)), errors.collect(cdk.propertyValidator("predefinedLoadMetricSpecification", CfnScalingPlan_PredefinedLoadMetricSpecificationPropertyValidator)(properties.predefinedLoadMetricSpecification)), errors.collect(cdk.propertyValidator("predictiveScalingMaxCapacityBehavior", cdk.validateString)(properties.predictiveScalingMaxCapacityBehavior)), errors.collect(cdk.propertyValidator("predictiveScalingMaxCapacityBuffer", cdk.validateNumber)(properties.predictiveScalingMaxCapacityBuffer)), errors.collect(cdk.propertyValidator("predictiveScalingMode", cdk.validateString)(properties.predictiveScalingMode)), errors.collect(cdk.propertyValidator("resourceId", cdk.requiredValidator)(properties.resourceId)), errors.collect(cdk.propertyValidator("resourceId", cdk.validateString)(properties.resourceId)), errors.collect(cdk.propertyValidator("scalableDimension", cdk.requiredValidator)(properties.scalableDimension)), errors.collect(cdk.propertyValidator("scalableDimension", cdk.validateString)(properties.scalableDimension)), errors.collect(cdk.propertyValidator("scalingPolicyUpdateBehavior", cdk.validateString)(properties.scalingPolicyUpdateBehavior)), errors.collect(cdk.propertyValidator("scheduledActionBufferTime", cdk.validateNumber)(properties.scheduledActionBufferTime)), errors.collect(cdk.propertyValidator("serviceNamespace", cdk.requiredValidator)(properties.serviceNamespace)), errors.collect(cdk.propertyValidator("serviceNamespace", cdk.validateString)(properties.serviceNamespace)), errors.collect(cdk.propertyValidator("targetTrackingConfigurations", cdk.requiredValidator)(properties.targetTrackingConfigurations)), errors.collect(cdk.propertyValidator("targetTrackingConfigurations", cdk.listValidator(CfnScalingPlan_TargetTrackingConfigurationPropertyValidator))(properties.targetTrackingConfigurations)), errors.wrap('supplied properties not correct for "ScalingInstructionProperty"');
    }
    function cfnScalingPlanScalingInstructionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPlan_ScalingInstructionPropertyValidator(properties).assertSuccess(), { CustomizedLoadMetricSpecification: cfnScalingPlanCustomizedLoadMetricSpecificationPropertyToCloudFormation(properties.customizedLoadMetricSpecification), DisableDynamicScaling: cdk.booleanToCloudFormation(properties.disableDynamicScaling), MaxCapacity: cdk.numberToCloudFormation(properties.maxCapacity), MinCapacity: cdk.numberToCloudFormation(properties.minCapacity), PredefinedLoadMetricSpecification: cfnScalingPlanPredefinedLoadMetricSpecificationPropertyToCloudFormation(properties.predefinedLoadMetricSpecification), PredictiveScalingMaxCapacityBehavior: cdk.stringToCloudFormation(properties.predictiveScalingMaxCapacityBehavior), PredictiveScalingMaxCapacityBuffer: cdk.numberToCloudFormation(properties.predictiveScalingMaxCapacityBuffer), PredictiveScalingMode: cdk.stringToCloudFormation(properties.predictiveScalingMode), ResourceId: cdk.stringToCloudFormation(properties.resourceId), ScalableDimension: cdk.stringToCloudFormation(properties.scalableDimension), ScalingPolicyUpdateBehavior: cdk.stringToCloudFormation(properties.scalingPolicyUpdateBehavior), ScheduledActionBufferTime: cdk.numberToCloudFormation(properties.scheduledActionBufferTime), ServiceNamespace: cdk.stringToCloudFormation(properties.serviceNamespace), TargetTrackingConfigurations: cdk.listMapper(cfnScalingPlanTargetTrackingConfigurationPropertyToCloudFormation)(properties.targetTrackingConfigurations) }) : properties;
    }
    function CfnScalingPlanScalingInstructionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customizedLoadMetricSpecification", "CustomizedLoadMetricSpecification", properties.CustomizedLoadMetricSpecification != null ? CfnScalingPlanCustomizedLoadMetricSpecificationPropertyFromCloudFormation(properties.CustomizedLoadMetricSpecification) : void 0), ret.addPropertyResult("disableDynamicScaling", "DisableDynamicScaling", properties.DisableDynamicScaling != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DisableDynamicScaling) : void 0), ret.addPropertyResult("maxCapacity", "MaxCapacity", cfn_parse.FromCloudFormation.getNumber(properties.MaxCapacity)), ret.addPropertyResult("minCapacity", "MinCapacity", cfn_parse.FromCloudFormation.getNumber(properties.MinCapacity)), ret.addPropertyResult("predefinedLoadMetricSpecification", "PredefinedLoadMetricSpecification", properties.PredefinedLoadMetricSpecification != null ? CfnScalingPlanPredefinedLoadMetricSpecificationPropertyFromCloudFormation(properties.PredefinedLoadMetricSpecification) : void 0), ret.addPropertyResult("predictiveScalingMaxCapacityBehavior", "PredictiveScalingMaxCapacityBehavior", properties.PredictiveScalingMaxCapacityBehavior != null ? cfn_parse.FromCloudFormation.getString(properties.PredictiveScalingMaxCapacityBehavior) : void 0), ret.addPropertyResult("predictiveScalingMaxCapacityBuffer", "PredictiveScalingMaxCapacityBuffer", properties.PredictiveScalingMaxCapacityBuffer != null ? cfn_parse.FromCloudFormation.getNumber(properties.PredictiveScalingMaxCapacityBuffer) : void 0), ret.addPropertyResult("predictiveScalingMode", "PredictiveScalingMode", properties.PredictiveScalingMode != null ? cfn_parse.FromCloudFormation.getString(properties.PredictiveScalingMode) : void 0), ret.addPropertyResult("resourceId", "ResourceId", cfn_parse.FromCloudFormation.getString(properties.ResourceId)), ret.addPropertyResult("scalableDimension", "ScalableDimension", cfn_parse.FromCloudFormation.getString(properties.ScalableDimension)), ret.addPropertyResult("scalingPolicyUpdateBehavior", "ScalingPolicyUpdateBehavior", properties.ScalingPolicyUpdateBehavior != null ? cfn_parse.FromCloudFormation.getString(properties.ScalingPolicyUpdateBehavior) : void 0), ret.addPropertyResult("scheduledActionBufferTime", "ScheduledActionBufferTime", properties.ScheduledActionBufferTime != null ? cfn_parse.FromCloudFormation.getNumber(properties.ScheduledActionBufferTime) : void 0), ret.addPropertyResult("serviceNamespace", "ServiceNamespace", cfn_parse.FromCloudFormation.getString(properties.ServiceNamespace)), ret.addPropertyResult("targetTrackingConfigurations", "TargetTrackingConfigurations", cfn_parse.FromCloudFormation.getArray(CfnScalingPlanTargetTrackingConfigurationPropertyFromCloudFormation)(properties.TargetTrackingConfigurations)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScalingPlan_TagFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "TagFilterProperty"');
    }
    function cfnScalingPlanTagFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPlan_TagFilterPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnScalingPlanTagFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScalingPlan_TargetTrackingConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customizedScalingMetricSpecification", CfnScalingPlan_CustomizedScalingMetricSpecificationPropertyValidator)(properties.customizedScalingMetricSpecification)), errors.collect(cdk.propertyValidator("disableScaleIn", cdk.validateBoolean)(properties.disableScaleIn)), errors.collect(cdk.propertyValidator("estimatedInstanceWarmup", cdk.validateNumber)(properties.estimatedInstanceWarmup)), errors.collect(cdk.propertyValidator("predefinedScalingMetricSpecification", CfnScalingPlan_PredefinedScalingMetricSpecificationPropertyValidator)(properties.predefinedScalingMetricSpecification)), errors.collect(cdk.propertyValidator("scaleInCooldown", cdk.validateNumber)(properties.scaleInCooldown)), errors.collect(cdk.propertyValidator("scaleOutCooldown", cdk.validateNumber)(properties.scaleOutCooldown)), errors.collect(cdk.propertyValidator("targetValue", cdk.requiredValidator)(properties.targetValue)), errors.collect(cdk.propertyValidator("targetValue", cdk.validateNumber)(properties.targetValue)), errors.wrap('supplied properties not correct for "TargetTrackingConfigurationProperty"');
    }
    function cfnScalingPlanTargetTrackingConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScalingPlan_TargetTrackingConfigurationPropertyValidator(properties).assertSuccess(), { CustomizedScalingMetricSpecification: cfnScalingPlanCustomizedScalingMetricSpecificationPropertyToCloudFormation(properties.customizedScalingMetricSpecification), DisableScaleIn: cdk.booleanToCloudFormation(properties.disableScaleIn), EstimatedInstanceWarmup: cdk.numberToCloudFormation(properties.estimatedInstanceWarmup), PredefinedScalingMetricSpecification: cfnScalingPlanPredefinedScalingMetricSpecificationPropertyToCloudFormation(properties.predefinedScalingMetricSpecification), ScaleInCooldown: cdk.numberToCloudFormation(properties.scaleInCooldown), ScaleOutCooldown: cdk.numberToCloudFormation(properties.scaleOutCooldown), TargetValue: cdk.numberToCloudFormation(properties.targetValue) }) : properties;
    }
    function CfnScalingPlanTargetTrackingConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customizedScalingMetricSpecification", "CustomizedScalingMetricSpecification", properties.CustomizedScalingMetricSpecification != null ? CfnScalingPlanCustomizedScalingMetricSpecificationPropertyFromCloudFormation(properties.CustomizedScalingMetricSpecification) : void 0), ret.addPropertyResult("disableScaleIn", "DisableScaleIn", properties.DisableScaleIn != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DisableScaleIn) : void 0), ret.addPropertyResult("estimatedInstanceWarmup", "EstimatedInstanceWarmup", properties.EstimatedInstanceWarmup != null ? cfn_parse.FromCloudFormation.getNumber(properties.EstimatedInstanceWarmup) : void 0), ret.addPropertyResult("predefinedScalingMetricSpecification", "PredefinedScalingMetricSpecification", properties.PredefinedScalingMetricSpecification != null ? CfnScalingPlanPredefinedScalingMetricSpecificationPropertyFromCloudFormation(properties.PredefinedScalingMetricSpecification) : void 0), ret.addPropertyResult("scaleInCooldown", "ScaleInCooldown", properties.ScaleInCooldown != null ? cfn_parse.FromCloudFormation.getNumber(properties.ScaleInCooldown) : void 0), ret.addPropertyResult("scaleOutCooldown", "ScaleOutCooldown", properties.ScaleOutCooldown != null ? cfn_parse.FromCloudFormation.getNumber(properties.ScaleOutCooldown) : void 0), ret.addPropertyResult("targetValue", "TargetValue", cfn_parse.FromCloudFormation.getNumber(properties.TargetValue)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-autoscalingplans/lib/index.js
var require_lib57 = __commonJS({
  "node_modules/aws-cdk-lib/aws-autoscalingplans/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_autoscalingplans_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-autoscalingplans/index.js
var require_aws_autoscalingplans = __commonJS({
  "node_modules/aws-cdk-lib/aws-autoscalingplans/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib57(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-backup/lib/backup.generated.js
var require_backup_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-backup/lib/backup.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnReportPlan = exports2.CfnFramework = exports2.CfnBackupVault = exports2.CfnBackupSelection = exports2.CfnBackupPlan = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnBackupPlanPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("backupPlan", cdk.requiredValidator)(properties.backupPlan)), errors.collect(cdk.propertyValidator("backupPlan", CfnBackupPlan_BackupPlanResourceTypePropertyValidator)(properties.backupPlan)), errors.collect(cdk.propertyValidator("backupPlanTags", cdk.hashValidator(cdk.validateString))(properties.backupPlanTags)), errors.wrap('supplied properties not correct for "CfnBackupPlanProps"');
    }
    function cfnBackupPlanPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBackupPlanPropsValidator(properties).assertSuccess(), { BackupPlan: cfnBackupPlanBackupPlanResourceTypePropertyToCloudFormation(properties.backupPlan), BackupPlanTags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.backupPlanTags) }) : properties;
    }
    function CfnBackupPlanPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("backupPlan", "BackupPlan", CfnBackupPlanBackupPlanResourceTypePropertyFromCloudFormation(properties.BackupPlan)), ret.addPropertyResult("backupPlanTags", "BackupPlanTags", properties.BackupPlanTags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.BackupPlanTags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnBackupPlan = class _CfnBackupPlan extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnBackupPlanPropsFromCloudFormation(resourceProperties), ret = new _CfnBackupPlan(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnBackupPlan.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_backup_CfnBackupPlanProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnBackupPlan), error;
        }
        cdk.requireProperty(props, "backupPlan", this), this.attrBackupPlanArn = cdk.Token.asString(this.getAtt("BackupPlanArn", cdk.ResolutionTypeHint.STRING)), this.attrBackupPlanId = cdk.Token.asString(this.getAtt("BackupPlanId", cdk.ResolutionTypeHint.STRING)), this.attrVersionId = cdk.Token.asString(this.getAtt("VersionId", cdk.ResolutionTypeHint.STRING)), this.backupPlan = props.backupPlan, this.backupPlanTags = props.backupPlanTags;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnBackupPlan.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { backupPlan: this.backupPlan, backupPlanTags: this.backupPlanTags };
      }
      renderProperties(props) {
        return cfnBackupPlanPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnBackupPlan[_a] = { fqn: "aws-cdk-lib.aws_backup.CfnBackupPlan", version: "2.80.0" }, CfnBackupPlan.CFN_RESOURCE_TYPE_NAME = "AWS::Backup::BackupPlan", exports2.CfnBackupPlan = CfnBackupPlan;
    function CfnBackupPlan_AdvancedBackupSettingResourceTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("backupOptions", cdk.requiredValidator)(properties.backupOptions)), errors.collect(cdk.propertyValidator("backupOptions", cdk.validateObject)(properties.backupOptions)), errors.collect(cdk.propertyValidator("resourceType", cdk.requiredValidator)(properties.resourceType)), errors.collect(cdk.propertyValidator("resourceType", cdk.validateString)(properties.resourceType)), errors.wrap('supplied properties not correct for "AdvancedBackupSettingResourceTypeProperty"');
    }
    function cfnBackupPlanAdvancedBackupSettingResourceTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBackupPlan_AdvancedBackupSettingResourceTypePropertyValidator(properties).assertSuccess(), { BackupOptions: cdk.objectToCloudFormation(properties.backupOptions), ResourceType: cdk.stringToCloudFormation(properties.resourceType) }) : properties;
    }
    function CfnBackupPlanAdvancedBackupSettingResourceTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("backupOptions", "BackupOptions", cfn_parse.FromCloudFormation.getAny(properties.BackupOptions)), ret.addPropertyResult("resourceType", "ResourceType", cfn_parse.FromCloudFormation.getString(properties.ResourceType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBackupPlan_BackupPlanResourceTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("advancedBackupSettings", cdk.listValidator(CfnBackupPlan_AdvancedBackupSettingResourceTypePropertyValidator))(properties.advancedBackupSettings)), errors.collect(cdk.propertyValidator("backupPlanName", cdk.requiredValidator)(properties.backupPlanName)), errors.collect(cdk.propertyValidator("backupPlanName", cdk.validateString)(properties.backupPlanName)), errors.collect(cdk.propertyValidator("backupPlanRule", cdk.requiredValidator)(properties.backupPlanRule)), errors.collect(cdk.propertyValidator("backupPlanRule", cdk.listValidator(CfnBackupPlan_BackupRuleResourceTypePropertyValidator))(properties.backupPlanRule)), errors.wrap('supplied properties not correct for "BackupPlanResourceTypeProperty"');
    }
    function cfnBackupPlanBackupPlanResourceTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBackupPlan_BackupPlanResourceTypePropertyValidator(properties).assertSuccess(), { AdvancedBackupSettings: cdk.listMapper(cfnBackupPlanAdvancedBackupSettingResourceTypePropertyToCloudFormation)(properties.advancedBackupSettings), BackupPlanName: cdk.stringToCloudFormation(properties.backupPlanName), BackupPlanRule: cdk.listMapper(cfnBackupPlanBackupRuleResourceTypePropertyToCloudFormation)(properties.backupPlanRule) }) : properties;
    }
    function CfnBackupPlanBackupPlanResourceTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("advancedBackupSettings", "AdvancedBackupSettings", properties.AdvancedBackupSettings != null ? cfn_parse.FromCloudFormation.getArray(CfnBackupPlanAdvancedBackupSettingResourceTypePropertyFromCloudFormation)(properties.AdvancedBackupSettings) : void 0), ret.addPropertyResult("backupPlanName", "BackupPlanName", cfn_parse.FromCloudFormation.getString(properties.BackupPlanName)), ret.addPropertyResult("backupPlanRule", "BackupPlanRule", cfn_parse.FromCloudFormation.getArray(CfnBackupPlanBackupRuleResourceTypePropertyFromCloudFormation)(properties.BackupPlanRule)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBackupPlan_BackupRuleResourceTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("completionWindowMinutes", cdk.validateNumber)(properties.completionWindowMinutes)), errors.collect(cdk.propertyValidator("copyActions", cdk.listValidator(CfnBackupPlan_CopyActionResourceTypePropertyValidator))(properties.copyActions)), errors.collect(cdk.propertyValidator("enableContinuousBackup", cdk.validateBoolean)(properties.enableContinuousBackup)), errors.collect(cdk.propertyValidator("lifecycle", CfnBackupPlan_LifecycleResourceTypePropertyValidator)(properties.lifecycle)), errors.collect(cdk.propertyValidator("recoveryPointTags", cdk.hashValidator(cdk.validateString))(properties.recoveryPointTags)), errors.collect(cdk.propertyValidator("ruleName", cdk.requiredValidator)(properties.ruleName)), errors.collect(cdk.propertyValidator("ruleName", cdk.validateString)(properties.ruleName)), errors.collect(cdk.propertyValidator("scheduleExpression", cdk.validateString)(properties.scheduleExpression)), errors.collect(cdk.propertyValidator("startWindowMinutes", cdk.validateNumber)(properties.startWindowMinutes)), errors.collect(cdk.propertyValidator("targetBackupVault", cdk.requiredValidator)(properties.targetBackupVault)), errors.collect(cdk.propertyValidator("targetBackupVault", cdk.validateString)(properties.targetBackupVault)), errors.wrap('supplied properties not correct for "BackupRuleResourceTypeProperty"');
    }
    function cfnBackupPlanBackupRuleResourceTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBackupPlan_BackupRuleResourceTypePropertyValidator(properties).assertSuccess(), { CompletionWindowMinutes: cdk.numberToCloudFormation(properties.completionWindowMinutes), CopyActions: cdk.listMapper(cfnBackupPlanCopyActionResourceTypePropertyToCloudFormation)(properties.copyActions), EnableContinuousBackup: cdk.booleanToCloudFormation(properties.enableContinuousBackup), Lifecycle: cfnBackupPlanLifecycleResourceTypePropertyToCloudFormation(properties.lifecycle), RecoveryPointTags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.recoveryPointTags), RuleName: cdk.stringToCloudFormation(properties.ruleName), ScheduleExpression: cdk.stringToCloudFormation(properties.scheduleExpression), StartWindowMinutes: cdk.numberToCloudFormation(properties.startWindowMinutes), TargetBackupVault: cdk.stringToCloudFormation(properties.targetBackupVault) }) : properties;
    }
    function CfnBackupPlanBackupRuleResourceTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("completionWindowMinutes", "CompletionWindowMinutes", properties.CompletionWindowMinutes != null ? cfn_parse.FromCloudFormation.getNumber(properties.CompletionWindowMinutes) : void 0), ret.addPropertyResult("copyActions", "CopyActions", properties.CopyActions != null ? cfn_parse.FromCloudFormation.getArray(CfnBackupPlanCopyActionResourceTypePropertyFromCloudFormation)(properties.CopyActions) : void 0), ret.addPropertyResult("enableContinuousBackup", "EnableContinuousBackup", properties.EnableContinuousBackup != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableContinuousBackup) : void 0), ret.addPropertyResult("lifecycle", "Lifecycle", properties.Lifecycle != null ? CfnBackupPlanLifecycleResourceTypePropertyFromCloudFormation(properties.Lifecycle) : void 0), ret.addPropertyResult("recoveryPointTags", "RecoveryPointTags", properties.RecoveryPointTags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.RecoveryPointTags) : void 0), ret.addPropertyResult("ruleName", "RuleName", cfn_parse.FromCloudFormation.getString(properties.RuleName)), ret.addPropertyResult("scheduleExpression", "ScheduleExpression", properties.ScheduleExpression != null ? cfn_parse.FromCloudFormation.getString(properties.ScheduleExpression) : void 0), ret.addPropertyResult("startWindowMinutes", "StartWindowMinutes", properties.StartWindowMinutes != null ? cfn_parse.FromCloudFormation.getNumber(properties.StartWindowMinutes) : void 0), ret.addPropertyResult("targetBackupVault", "TargetBackupVault", cfn_parse.FromCloudFormation.getString(properties.TargetBackupVault)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBackupPlan_CopyActionResourceTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationBackupVaultArn", cdk.requiredValidator)(properties.destinationBackupVaultArn)), errors.collect(cdk.propertyValidator("destinationBackupVaultArn", cdk.validateString)(properties.destinationBackupVaultArn)), errors.collect(cdk.propertyValidator("lifecycle", CfnBackupPlan_LifecycleResourceTypePropertyValidator)(properties.lifecycle)), errors.wrap('supplied properties not correct for "CopyActionResourceTypeProperty"');
    }
    function cfnBackupPlanCopyActionResourceTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBackupPlan_CopyActionResourceTypePropertyValidator(properties).assertSuccess(), { DestinationBackupVaultArn: cdk.stringToCloudFormation(properties.destinationBackupVaultArn), Lifecycle: cfnBackupPlanLifecycleResourceTypePropertyToCloudFormation(properties.lifecycle) }) : properties;
    }
    function CfnBackupPlanCopyActionResourceTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationBackupVaultArn", "DestinationBackupVaultArn", cfn_parse.FromCloudFormation.getString(properties.DestinationBackupVaultArn)), ret.addPropertyResult("lifecycle", "Lifecycle", properties.Lifecycle != null ? CfnBackupPlanLifecycleResourceTypePropertyFromCloudFormation(properties.Lifecycle) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBackupPlan_LifecycleResourceTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deleteAfterDays", cdk.validateNumber)(properties.deleteAfterDays)), errors.collect(cdk.propertyValidator("moveToColdStorageAfterDays", cdk.validateNumber)(properties.moveToColdStorageAfterDays)), errors.wrap('supplied properties not correct for "LifecycleResourceTypeProperty"');
    }
    function cfnBackupPlanLifecycleResourceTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBackupPlan_LifecycleResourceTypePropertyValidator(properties).assertSuccess(), { DeleteAfterDays: cdk.numberToCloudFormation(properties.deleteAfterDays), MoveToColdStorageAfterDays: cdk.numberToCloudFormation(properties.moveToColdStorageAfterDays) }) : properties;
    }
    function CfnBackupPlanLifecycleResourceTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deleteAfterDays", "DeleteAfterDays", properties.DeleteAfterDays != null ? cfn_parse.FromCloudFormation.getNumber(properties.DeleteAfterDays) : void 0), ret.addPropertyResult("moveToColdStorageAfterDays", "MoveToColdStorageAfterDays", properties.MoveToColdStorageAfterDays != null ? cfn_parse.FromCloudFormation.getNumber(properties.MoveToColdStorageAfterDays) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBackupSelectionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("backupPlanId", cdk.requiredValidator)(properties.backupPlanId)), errors.collect(cdk.propertyValidator("backupPlanId", cdk.validateString)(properties.backupPlanId)), errors.collect(cdk.propertyValidator("backupSelection", cdk.requiredValidator)(properties.backupSelection)), errors.collect(cdk.propertyValidator("backupSelection", CfnBackupSelection_BackupSelectionResourceTypePropertyValidator)(properties.backupSelection)), errors.wrap('supplied properties not correct for "CfnBackupSelectionProps"');
    }
    function cfnBackupSelectionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBackupSelectionPropsValidator(properties).assertSuccess(), { BackupPlanId: cdk.stringToCloudFormation(properties.backupPlanId), BackupSelection: cfnBackupSelectionBackupSelectionResourceTypePropertyToCloudFormation(properties.backupSelection) }) : properties;
    }
    function CfnBackupSelectionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("backupPlanId", "BackupPlanId", cfn_parse.FromCloudFormation.getString(properties.BackupPlanId)), ret.addPropertyResult("backupSelection", "BackupSelection", CfnBackupSelectionBackupSelectionResourceTypePropertyFromCloudFormation(properties.BackupSelection)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnBackupSelection = class _CfnBackupSelection extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnBackupSelectionPropsFromCloudFormation(resourceProperties), ret = new _CfnBackupSelection(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnBackupSelection.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_backup_CfnBackupSelectionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnBackupSelection), error;
        }
        cdk.requireProperty(props, "backupPlanId", this), cdk.requireProperty(props, "backupSelection", this), this.attrBackupPlanId = cdk.Token.asString(this.getAtt("BackupPlanId", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrSelectionId = cdk.Token.asString(this.getAtt("SelectionId", cdk.ResolutionTypeHint.STRING)), this.backupPlanId = props.backupPlanId, this.backupSelection = props.backupSelection;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnBackupSelection.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { backupPlanId: this.backupPlanId, backupSelection: this.backupSelection };
      }
      renderProperties(props) {
        return cfnBackupSelectionPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnBackupSelection[_b] = { fqn: "aws-cdk-lib.aws_backup.CfnBackupSelection", version: "2.80.0" }, CfnBackupSelection.CFN_RESOURCE_TYPE_NAME = "AWS::Backup::BackupSelection", exports2.CfnBackupSelection = CfnBackupSelection;
    function CfnBackupSelection_BackupSelectionResourceTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("conditions", cdk.validateObject)(properties.conditions)), errors.collect(cdk.propertyValidator("iamRoleArn", cdk.requiredValidator)(properties.iamRoleArn)), errors.collect(cdk.propertyValidator("iamRoleArn", cdk.validateString)(properties.iamRoleArn)), errors.collect(cdk.propertyValidator("listOfTags", cdk.listValidator(CfnBackupSelection_ConditionResourceTypePropertyValidator))(properties.listOfTags)), errors.collect(cdk.propertyValidator("notResources", cdk.listValidator(cdk.validateString))(properties.notResources)), errors.collect(cdk.propertyValidator("resources", cdk.listValidator(cdk.validateString))(properties.resources)), errors.collect(cdk.propertyValidator("selectionName", cdk.requiredValidator)(properties.selectionName)), errors.collect(cdk.propertyValidator("selectionName", cdk.validateString)(properties.selectionName)), errors.wrap('supplied properties not correct for "BackupSelectionResourceTypeProperty"');
    }
    function cfnBackupSelectionBackupSelectionResourceTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBackupSelection_BackupSelectionResourceTypePropertyValidator(properties).assertSuccess(), { Conditions: cdk.objectToCloudFormation(properties.conditions), IamRoleArn: cdk.stringToCloudFormation(properties.iamRoleArn), ListOfTags: cdk.listMapper(cfnBackupSelectionConditionResourceTypePropertyToCloudFormation)(properties.listOfTags), NotResources: cdk.listMapper(cdk.stringToCloudFormation)(properties.notResources), Resources: cdk.listMapper(cdk.stringToCloudFormation)(properties.resources), SelectionName: cdk.stringToCloudFormation(properties.selectionName) }) : properties;
    }
    function CfnBackupSelectionBackupSelectionResourceTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("conditions", "Conditions", properties.Conditions != null ? cfn_parse.FromCloudFormation.getAny(properties.Conditions) : void 0), ret.addPropertyResult("iamRoleArn", "IamRoleArn", cfn_parse.FromCloudFormation.getString(properties.IamRoleArn)), ret.addPropertyResult("listOfTags", "ListOfTags", properties.ListOfTags != null ? cfn_parse.FromCloudFormation.getArray(CfnBackupSelectionConditionResourceTypePropertyFromCloudFormation)(properties.ListOfTags) : void 0), ret.addPropertyResult("notResources", "NotResources", properties.NotResources != null ? cfn_parse.FromCloudFormation.getStringArray(properties.NotResources) : void 0), ret.addPropertyResult("resources", "Resources", properties.Resources != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Resources) : void 0), ret.addPropertyResult("selectionName", "SelectionName", cfn_parse.FromCloudFormation.getString(properties.SelectionName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBackupSelection_ConditionResourceTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("conditionKey", cdk.requiredValidator)(properties.conditionKey)), errors.collect(cdk.propertyValidator("conditionKey", cdk.validateString)(properties.conditionKey)), errors.collect(cdk.propertyValidator("conditionType", cdk.requiredValidator)(properties.conditionType)), errors.collect(cdk.propertyValidator("conditionType", cdk.validateString)(properties.conditionType)), errors.collect(cdk.propertyValidator("conditionValue", cdk.requiredValidator)(properties.conditionValue)), errors.collect(cdk.propertyValidator("conditionValue", cdk.validateString)(properties.conditionValue)), errors.wrap('supplied properties not correct for "ConditionResourceTypeProperty"');
    }
    function cfnBackupSelectionConditionResourceTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBackupSelection_ConditionResourceTypePropertyValidator(properties).assertSuccess(), { ConditionKey: cdk.stringToCloudFormation(properties.conditionKey), ConditionType: cdk.stringToCloudFormation(properties.conditionType), ConditionValue: cdk.stringToCloudFormation(properties.conditionValue) }) : properties;
    }
    function CfnBackupSelectionConditionResourceTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("conditionKey", "ConditionKey", cfn_parse.FromCloudFormation.getString(properties.ConditionKey)), ret.addPropertyResult("conditionType", "ConditionType", cfn_parse.FromCloudFormation.getString(properties.ConditionType)), ret.addPropertyResult("conditionValue", "ConditionValue", cfn_parse.FromCloudFormation.getString(properties.ConditionValue)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBackupVaultPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessPolicy", cdk.validateObject)(properties.accessPolicy)), errors.collect(cdk.propertyValidator("backupVaultName", cdk.requiredValidator)(properties.backupVaultName)), errors.collect(cdk.propertyValidator("backupVaultName", cdk.validateString)(properties.backupVaultName)), errors.collect(cdk.propertyValidator("backupVaultTags", cdk.hashValidator(cdk.validateString))(properties.backupVaultTags)), errors.collect(cdk.propertyValidator("encryptionKeyArn", cdk.validateString)(properties.encryptionKeyArn)), errors.collect(cdk.propertyValidator("lockConfiguration", CfnBackupVault_LockConfigurationTypePropertyValidator)(properties.lockConfiguration)), errors.collect(cdk.propertyValidator("notifications", CfnBackupVault_NotificationObjectTypePropertyValidator)(properties.notifications)), errors.wrap('supplied properties not correct for "CfnBackupVaultProps"');
    }
    function cfnBackupVaultPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBackupVaultPropsValidator(properties).assertSuccess(), { BackupVaultName: cdk.stringToCloudFormation(properties.backupVaultName), AccessPolicy: cdk.objectToCloudFormation(properties.accessPolicy), BackupVaultTags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.backupVaultTags), EncryptionKeyArn: cdk.stringToCloudFormation(properties.encryptionKeyArn), LockConfiguration: cfnBackupVaultLockConfigurationTypePropertyToCloudFormation(properties.lockConfiguration), Notifications: cfnBackupVaultNotificationObjectTypePropertyToCloudFormation(properties.notifications) }) : properties;
    }
    function CfnBackupVaultPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("backupVaultName", "BackupVaultName", cfn_parse.FromCloudFormation.getString(properties.BackupVaultName)), ret.addPropertyResult("accessPolicy", "AccessPolicy", properties.AccessPolicy != null ? cfn_parse.FromCloudFormation.getAny(properties.AccessPolicy) : void 0), ret.addPropertyResult("backupVaultTags", "BackupVaultTags", properties.BackupVaultTags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.BackupVaultTags) : void 0), ret.addPropertyResult("encryptionKeyArn", "EncryptionKeyArn", properties.EncryptionKeyArn != null ? cfn_parse.FromCloudFormation.getString(properties.EncryptionKeyArn) : void 0), ret.addPropertyResult("lockConfiguration", "LockConfiguration", properties.LockConfiguration != null ? CfnBackupVaultLockConfigurationTypePropertyFromCloudFormation(properties.LockConfiguration) : void 0), ret.addPropertyResult("notifications", "Notifications", properties.Notifications != null ? CfnBackupVaultNotificationObjectTypePropertyFromCloudFormation(properties.Notifications) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnBackupVault = class _CfnBackupVault extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnBackupVaultPropsFromCloudFormation(resourceProperties), ret = new _CfnBackupVault(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnBackupVault.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_backup_CfnBackupVaultProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnBackupVault), error;
        }
        cdk.requireProperty(props, "backupVaultName", this), this.attrBackupVaultArn = cdk.Token.asString(this.getAtt("BackupVaultArn", cdk.ResolutionTypeHint.STRING)), this.attrBackupVaultName = cdk.Token.asString(this.getAtt("BackupVaultName", cdk.ResolutionTypeHint.STRING)), this.backupVaultName = props.backupVaultName, this.accessPolicy = props.accessPolicy, this.backupVaultTags = props.backupVaultTags, this.encryptionKeyArn = props.encryptionKeyArn, this.lockConfiguration = props.lockConfiguration, this.notifications = props.notifications, this.node.scope && cdk.Resource.isResource(this.node.scope) && this.node.addValidation({ validate: () => this.cfnOptions.deletionPolicy === void 0 ? ["'AWS::Backup::BackupVault' is a stateful resource type, and you must specify a Removal Policy for it. Call 'resource.applyRemovalPolicy()'."] : [] });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnBackupVault.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { backupVaultName: this.backupVaultName, accessPolicy: this.accessPolicy, backupVaultTags: this.backupVaultTags, encryptionKeyArn: this.encryptionKeyArn, lockConfiguration: this.lockConfiguration, notifications: this.notifications };
      }
      renderProperties(props) {
        return cfnBackupVaultPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnBackupVault[_c] = { fqn: "aws-cdk-lib.aws_backup.CfnBackupVault", version: "2.80.0" }, CfnBackupVault.CFN_RESOURCE_TYPE_NAME = "AWS::Backup::BackupVault", exports2.CfnBackupVault = CfnBackupVault;
    function CfnBackupVault_LockConfigurationTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("changeableForDays", cdk.validateNumber)(properties.changeableForDays)), errors.collect(cdk.propertyValidator("maxRetentionDays", cdk.validateNumber)(properties.maxRetentionDays)), errors.collect(cdk.propertyValidator("minRetentionDays", cdk.requiredValidator)(properties.minRetentionDays)), errors.collect(cdk.propertyValidator("minRetentionDays", cdk.validateNumber)(properties.minRetentionDays)), errors.wrap('supplied properties not correct for "LockConfigurationTypeProperty"');
    }
    function cfnBackupVaultLockConfigurationTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBackupVault_LockConfigurationTypePropertyValidator(properties).assertSuccess(), { ChangeableForDays: cdk.numberToCloudFormation(properties.changeableForDays), MaxRetentionDays: cdk.numberToCloudFormation(properties.maxRetentionDays), MinRetentionDays: cdk.numberToCloudFormation(properties.minRetentionDays) }) : properties;
    }
    function CfnBackupVaultLockConfigurationTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("changeableForDays", "ChangeableForDays", properties.ChangeableForDays != null ? cfn_parse.FromCloudFormation.getNumber(properties.ChangeableForDays) : void 0), ret.addPropertyResult("maxRetentionDays", "MaxRetentionDays", properties.MaxRetentionDays != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxRetentionDays) : void 0), ret.addPropertyResult("minRetentionDays", "MinRetentionDays", cfn_parse.FromCloudFormation.getNumber(properties.MinRetentionDays)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBackupVault_NotificationObjectTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("backupVaultEvents", cdk.requiredValidator)(properties.backupVaultEvents)), errors.collect(cdk.propertyValidator("backupVaultEvents", cdk.listValidator(cdk.validateString))(properties.backupVaultEvents)), errors.collect(cdk.propertyValidator("snsTopicArn", cdk.requiredValidator)(properties.snsTopicArn)), errors.collect(cdk.propertyValidator("snsTopicArn", cdk.validateString)(properties.snsTopicArn)), errors.wrap('supplied properties not correct for "NotificationObjectTypeProperty"');
    }
    function cfnBackupVaultNotificationObjectTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBackupVault_NotificationObjectTypePropertyValidator(properties).assertSuccess(), { BackupVaultEvents: cdk.listMapper(cdk.stringToCloudFormation)(properties.backupVaultEvents), SNSTopicArn: cdk.stringToCloudFormation(properties.snsTopicArn) }) : properties;
    }
    function CfnBackupVaultNotificationObjectTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("backupVaultEvents", "BackupVaultEvents", cfn_parse.FromCloudFormation.getStringArray(properties.BackupVaultEvents)), ret.addPropertyResult("snsTopicArn", "SNSTopicArn", cfn_parse.FromCloudFormation.getString(properties.SNSTopicArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFrameworkPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("frameworkControls", cdk.requiredValidator)(properties.frameworkControls)), errors.collect(cdk.propertyValidator("frameworkControls", cdk.listValidator(CfnFramework_FrameworkControlPropertyValidator))(properties.frameworkControls)), errors.collect(cdk.propertyValidator("frameworkDescription", cdk.validateString)(properties.frameworkDescription)), errors.collect(cdk.propertyValidator("frameworkName", cdk.validateString)(properties.frameworkName)), errors.collect(cdk.propertyValidator("frameworkTags", cdk.listValidator(cdk.validateCfnTag))(properties.frameworkTags)), errors.wrap('supplied properties not correct for "CfnFrameworkProps"');
    }
    function cfnFrameworkPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFrameworkPropsValidator(properties).assertSuccess(), { FrameworkControls: cdk.listMapper(cfnFrameworkFrameworkControlPropertyToCloudFormation)(properties.frameworkControls), FrameworkDescription: cdk.stringToCloudFormation(properties.frameworkDescription), FrameworkName: cdk.stringToCloudFormation(properties.frameworkName), FrameworkTags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.frameworkTags) }) : properties;
    }
    function CfnFrameworkPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("frameworkControls", "FrameworkControls", cfn_parse.FromCloudFormation.getArray(CfnFrameworkFrameworkControlPropertyFromCloudFormation)(properties.FrameworkControls)), ret.addPropertyResult("frameworkDescription", "FrameworkDescription", properties.FrameworkDescription != null ? cfn_parse.FromCloudFormation.getString(properties.FrameworkDescription) : void 0), ret.addPropertyResult("frameworkName", "FrameworkName", properties.FrameworkName != null ? cfn_parse.FromCloudFormation.getString(properties.FrameworkName) : void 0), ret.addPropertyResult("frameworkTags", "FrameworkTags", properties.FrameworkTags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.FrameworkTags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFramework = class _CfnFramework extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFrameworkPropsFromCloudFormation(resourceProperties), ret = new _CfnFramework(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFramework.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_backup_CfnFrameworkProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFramework), error;
        }
        cdk.requireProperty(props, "frameworkControls", this), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrDeploymentStatus = cdk.Token.asString(this.getAtt("DeploymentStatus", cdk.ResolutionTypeHint.STRING)), this.attrFrameworkArn = cdk.Token.asString(this.getAtt("FrameworkArn", cdk.ResolutionTypeHint.STRING)), this.attrFrameworkStatus = cdk.Token.asString(this.getAtt("FrameworkStatus", cdk.ResolutionTypeHint.STRING)), this.frameworkControls = props.frameworkControls, this.frameworkDescription = props.frameworkDescription, this.frameworkName = props.frameworkName, this.frameworkTags = props.frameworkTags;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFramework.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { frameworkControls: this.frameworkControls, frameworkDescription: this.frameworkDescription, frameworkName: this.frameworkName, frameworkTags: this.frameworkTags };
      }
      renderProperties(props) {
        return cfnFrameworkPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnFramework[_d] = { fqn: "aws-cdk-lib.aws_backup.CfnFramework", version: "2.80.0" }, CfnFramework.CFN_RESOURCE_TYPE_NAME = "AWS::Backup::Framework", exports2.CfnFramework = CfnFramework;
    function CfnFramework_ControlInputParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("parameterName", cdk.requiredValidator)(properties.parameterName)), errors.collect(cdk.propertyValidator("parameterName", cdk.validateString)(properties.parameterName)), errors.collect(cdk.propertyValidator("parameterValue", cdk.requiredValidator)(properties.parameterValue)), errors.collect(cdk.propertyValidator("parameterValue", cdk.validateString)(properties.parameterValue)), errors.wrap('supplied properties not correct for "ControlInputParameterProperty"');
    }
    function cfnFrameworkControlInputParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFramework_ControlInputParameterPropertyValidator(properties).assertSuccess(), { ParameterName: cdk.stringToCloudFormation(properties.parameterName), ParameterValue: cdk.stringToCloudFormation(properties.parameterValue) }) : properties;
    }
    function CfnFrameworkControlInputParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("parameterName", "ParameterName", cfn_parse.FromCloudFormation.getString(properties.ParameterName)), ret.addPropertyResult("parameterValue", "ParameterValue", cfn_parse.FromCloudFormation.getString(properties.ParameterValue)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFramework_FrameworkControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("controlInputParameters", cdk.listValidator(CfnFramework_ControlInputParameterPropertyValidator))(properties.controlInputParameters)), errors.collect(cdk.propertyValidator("controlName", cdk.requiredValidator)(properties.controlName)), errors.collect(cdk.propertyValidator("controlName", cdk.validateString)(properties.controlName)), errors.collect(cdk.propertyValidator("controlScope", cdk.validateObject)(properties.controlScope)), errors.wrap('supplied properties not correct for "FrameworkControlProperty"');
    }
    function cfnFrameworkFrameworkControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFramework_FrameworkControlPropertyValidator(properties).assertSuccess(), { ControlInputParameters: cdk.listMapper(cfnFrameworkControlInputParameterPropertyToCloudFormation)(properties.controlInputParameters), ControlName: cdk.stringToCloudFormation(properties.controlName), ControlScope: cdk.objectToCloudFormation(properties.controlScope) }) : properties;
    }
    function CfnFrameworkFrameworkControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("controlInputParameters", "ControlInputParameters", properties.ControlInputParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnFrameworkControlInputParameterPropertyFromCloudFormation)(properties.ControlInputParameters) : void 0), ret.addPropertyResult("controlName", "ControlName", cfn_parse.FromCloudFormation.getString(properties.ControlName)), ret.addPropertyResult("controlScope", "ControlScope", properties.ControlScope != null ? cfn_parse.FromCloudFormation.getAny(properties.ControlScope) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnReportPlanPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("reportDeliveryChannel", cdk.requiredValidator)(properties.reportDeliveryChannel)), errors.collect(cdk.propertyValidator("reportDeliveryChannel", cdk.validateObject)(properties.reportDeliveryChannel)), errors.collect(cdk.propertyValidator("reportPlanDescription", cdk.validateString)(properties.reportPlanDescription)), errors.collect(cdk.propertyValidator("reportPlanName", cdk.validateString)(properties.reportPlanName)), errors.collect(cdk.propertyValidator("reportPlanTags", cdk.listValidator(cdk.validateCfnTag))(properties.reportPlanTags)), errors.collect(cdk.propertyValidator("reportSetting", cdk.requiredValidator)(properties.reportSetting)), errors.collect(cdk.propertyValidator("reportSetting", cdk.validateObject)(properties.reportSetting)), errors.wrap('supplied properties not correct for "CfnReportPlanProps"');
    }
    function cfnReportPlanPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReportPlanPropsValidator(properties).assertSuccess(), { ReportDeliveryChannel: cdk.objectToCloudFormation(properties.reportDeliveryChannel), ReportSetting: cdk.objectToCloudFormation(properties.reportSetting), ReportPlanDescription: cdk.stringToCloudFormation(properties.reportPlanDescription), ReportPlanName: cdk.stringToCloudFormation(properties.reportPlanName), ReportPlanTags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.reportPlanTags) }) : properties;
    }
    function CfnReportPlanPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("reportDeliveryChannel", "ReportDeliveryChannel", cfn_parse.FromCloudFormation.getAny(properties.ReportDeliveryChannel)), ret.addPropertyResult("reportSetting", "ReportSetting", cfn_parse.FromCloudFormation.getAny(properties.ReportSetting)), ret.addPropertyResult("reportPlanDescription", "ReportPlanDescription", properties.ReportPlanDescription != null ? cfn_parse.FromCloudFormation.getString(properties.ReportPlanDescription) : void 0), ret.addPropertyResult("reportPlanName", "ReportPlanName", properties.ReportPlanName != null ? cfn_parse.FromCloudFormation.getString(properties.ReportPlanName) : void 0), ret.addPropertyResult("reportPlanTags", "ReportPlanTags", properties.ReportPlanTags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.ReportPlanTags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnReportPlan = class _CfnReportPlan extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnReportPlanPropsFromCloudFormation(resourceProperties), ret = new _CfnReportPlan(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnReportPlan.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_backup_CfnReportPlanProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnReportPlan), error;
        }
        cdk.requireProperty(props, "reportDeliveryChannel", this), cdk.requireProperty(props, "reportSetting", this), this.attrReportPlanArn = cdk.Token.asString(this.getAtt("ReportPlanArn", cdk.ResolutionTypeHint.STRING)), this.reportDeliveryChannel = props.reportDeliveryChannel, this.reportSetting = props.reportSetting, this.reportPlanDescription = props.reportPlanDescription, this.reportPlanName = props.reportPlanName, this.reportPlanTags = props.reportPlanTags;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnReportPlan.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { reportDeliveryChannel: this.reportDeliveryChannel, reportSetting: this.reportSetting, reportPlanDescription: this.reportPlanDescription, reportPlanName: this.reportPlanName, reportPlanTags: this.reportPlanTags };
      }
      renderProperties(props) {
        return cfnReportPlanPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnReportPlan[_e] = { fqn: "aws-cdk-lib.aws_backup.CfnReportPlan", version: "2.80.0" }, CfnReportPlan.CFN_RESOURCE_TYPE_NAME = "AWS::Backup::ReportPlan", exports2.CfnReportPlan = CfnReportPlan;
  }
});

// node_modules/aws-cdk-lib/aws-backup/lib/vault.js
var require_vault = __commonJS({
  "node_modules/aws-cdk-lib/aws-backup/lib/vault.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.BackupVault = exports2.BackupVaultEvents = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var backup_generated_1 = require_backup_generated();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var BackupVaultEvents;
    (function(BackupVaultEvents2) {
      BackupVaultEvents2.BACKUP_JOB_STARTED = "BACKUP_JOB_STARTED", BackupVaultEvents2.BACKUP_JOB_COMPLETED = "BACKUP_JOB_COMPLETED", BackupVaultEvents2.BACKUP_JOB_SUCCESSFUL = "BACKUP_JOB_SUCCESSFUL", BackupVaultEvents2.BACKUP_JOB_FAILED = "BACKUP_JOB_FAILED", BackupVaultEvents2.BACKUP_JOB_EXPIRED = "BACKUP_JOB_EXPIRED", BackupVaultEvents2.RESTORE_JOB_STARTED = "RESTORE_JOB_STARTED", BackupVaultEvents2.RESTORE_JOB_COMPLETED = "RESTORE_JOB_COMPLETED", BackupVaultEvents2.RESTORE_JOB_SUCCESSFUL = "RESTORE_JOB_SUCCESSFUL", BackupVaultEvents2.RESTORE_JOB_FAILED = "RESTORE_JOB_FAILED", BackupVaultEvents2.COPY_JOB_STARTED = "COPY_JOB_STARTED", BackupVaultEvents2.COPY_JOB_SUCCESSFUL = "COPY_JOB_SUCCESSFUL", BackupVaultEvents2.COPY_JOB_FAILED = "COPY_JOB_FAILED", BackupVaultEvents2.RECOVERY_POINT_MODIFIED = "RECOVERY_POINT_MODIFIED", BackupVaultEvents2.BACKUP_PLAN_CREATED = "BACKUP_PLAN_CREATED", BackupVaultEvents2.BACKUP_PLAN_MODIFIED = "BACKUP_PLAN_MODIFIED", BackupVaultEvents2.S3_BACKUP_OBJECT_FAILED = "S3_BACKUP_OBJECT_FAILED", BackupVaultEvents2.S3_RESTORE_OBJECT_FAILED = "S3_RESTORE_OBJECT_FAILED";
    })(BackupVaultEvents = exports2.BackupVaultEvents || (exports2.BackupVaultEvents = {}));
    var BackupVaultBase = class extends core_1.Resource {
      grant(grantee, ...actions) {
        for (const action of actions)
          if (action.indexOf("*") >= 0)
            throw new Error("AWS Backup access policies don't support a wildcard in the Action key.");
        return iam.Grant.addToPrincipal({ grantee, actions, resourceArns: [this.backupVaultArn] });
      }
    };
    var BackupVault = class _BackupVault extends BackupVaultBase {
      static fromBackupVaultName(scope, id, backupVaultName) {
        const backupVaultArn = core_1.Stack.of(scope).formatArn({ service: "backup", resource: "backup-vault", resourceName: backupVaultName, arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME });
        return _BackupVault.fromBackupVaultArn(scope, id, backupVaultArn);
      }
      static fromBackupVaultArn(scope, id, backupVaultArn) {
        const parsedArn = core_1.Stack.of(scope).splitArn(backupVaultArn, core_1.ArnFormat.COLON_RESOURCE_NAME);
        if (parsedArn.arnFormat !== core_1.ArnFormat.COLON_RESOURCE_NAME)
          throw new Error(`Backup Vault Arn ${backupVaultArn} has the wrong format, expected ${core_1.ArnFormat.COLON_RESOURCE_NAME}.`);
        if (!parsedArn.resourceName)
          throw new Error(`Backup Vault Arn ${backupVaultArn} does not have a resource name.`);
        class Import extends BackupVaultBase {
          constructor() {
            super(...arguments), this.backupVaultName = parsedArn.resourceName, this.backupVaultArn = backupVaultArn;
          }
        }
        return new Import(scope, id, { account: parsedArn.account, region: parsedArn.region });
      }
      constructor(scope, id, props = {}) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_backup_BackupVaultProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _BackupVault), error;
        }
        if (props.backupVaultName && !/^[a-zA-Z0-9\-_]{2,50}$/.test(props.backupVaultName))
          throw new Error("Expected vault name to match pattern `^[a-zA-Z0-9-_]{2,50}$`");
        let notifications;
        props.notificationTopic && (notifications = { backupVaultEvents: props.notificationEvents || Object.values(BackupVaultEvents), snsTopicArn: props.notificationTopic.topicArn }, props.notificationTopic.grantPublish(new iam.ServicePrincipal("backup.amazonaws.com"))), this.accessPolicy = props.accessPolicy ?? new iam.PolicyDocument(), props.blockRecoveryPointDeletion && this.blockRecoveryPointDeletion();
        const vault = new backup_generated_1.CfnBackupVault(this, "Resource", { backupVaultName: props.backupVaultName || this.uniqueVaultName(), accessPolicy: core_1.Lazy.any({ produce: () => this.accessPolicy.toJSON() }), encryptionKeyArn: props.encryptionKey && props.encryptionKey.keyArn, notifications, lockConfiguration: renderLockConfiguration(props.lockConfiguration) });
        vault.applyRemovalPolicy(props.removalPolicy), this.backupVaultName = vault.attrBackupVaultName, this.backupVaultArn = vault.attrBackupVaultArn;
      }
      addToAccessPolicy(statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToAccessPolicy), error;
        }
        this.accessPolicy.addStatements(statement);
      }
      blockRecoveryPointDeletion() {
        this.addToAccessPolicy(new iam.PolicyStatement({ effect: iam.Effect.DENY, actions: ["backup:DeleteRecoveryPoint", "backup:UpdateRecoveryPointLifecycle"], principals: [new iam.AnyPrincipal()], resources: ["*"] }));
      }
      uniqueVaultName() {
        const id = core_1.Names.uniqueId(this);
        return id.substring(Math.max(id.length - 50, 0), id.length);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, BackupVault[_a] = { fqn: "aws-cdk-lib.aws_backup.BackupVault", version: "2.80.0" }, exports2.BackupVault = BackupVault;
    function renderLockConfiguration(config) {
      if (config) {
        if (config.changeableFor && config.changeableFor.toHours() < 72)
          throw new Error(`AWS Backup enforces a 72-hour cooling-off period before Vault Lock takes effect and becomes immutable, got ${config.changeableFor.toHours()} hours`);
        if (config.maxRetention) {
          if (config.maxRetention.toDays() > 36500)
            throw new Error(`The longest maximum retention period you can specify is 36500 days, got ${config.maxRetention.toDays()} days`);
          if (config.maxRetention.toDays() <= config.minRetention.toDays())
            throw new Error(`The maximum retention period (${config.maxRetention.toDays()} days) must be greater than the minimum retention period (${config.minRetention.toDays()} days)`);
        }
        if (config.minRetention.toHours() < 24)
          throw new Error(`The shortest minimum retention period you can specify is 1 day, got ${config.minRetention.toHours()} hours`);
        return { minRetentionDays: config.minRetention.toDays(), maxRetentionDays: config.maxRetention?.toDays(), changeableForDays: config.changeableFor?.toDays() };
      }
    }
  }
});

// node_modules/aws-cdk-lib/aws-backup/lib/rule.js
var require_rule3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-backup/lib/rule.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.BackupPlanRule = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var events = require_aws_events();
    var core_1 = require_core2();
    var BackupPlanRule = class _BackupPlanRule {
      static daily(backupVault) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_backup_IBackupVault(backupVault);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.daily), error;
        }
        return new _BackupPlanRule({ backupVault, ruleName: "Daily", scheduleExpression: events.Schedule.cron({ hour: "5", minute: "0" }), deleteAfter: core_1.Duration.days(35) });
      }
      static weekly(backupVault) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_backup_IBackupVault(backupVault);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.weekly), error;
        }
        return new _BackupPlanRule({ backupVault, ruleName: "Weekly", scheduleExpression: events.Schedule.cron({ hour: "5", minute: "0", weekDay: "SAT" }), deleteAfter: core_1.Duration.days(30 * 3) });
      }
      static monthly1Year(backupVault) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_backup_IBackupVault(backupVault);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.monthly1Year), error;
        }
        return new _BackupPlanRule({ backupVault, ruleName: "Monthly1Year", scheduleExpression: events.Schedule.cron({ day: "1", hour: "5", minute: "0" }), moveToColdStorageAfter: core_1.Duration.days(30), deleteAfter: core_1.Duration.days(365) });
      }
      static monthly5Year(backupVault) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_backup_IBackupVault(backupVault);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.monthly5Year), error;
        }
        return new _BackupPlanRule({ backupVault, ruleName: "Monthly5Year", scheduleExpression: events.Schedule.cron({ day: "1", hour: "5", minute: "0" }), moveToColdStorageAfter: core_1.Duration.days(30 * 3), deleteAfter: core_1.Duration.days(365 * 5) });
      }
      static monthly7Year(backupVault) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_backup_IBackupVault(backupVault);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.monthly7Year), error;
        }
        return new _BackupPlanRule({ backupVault, ruleName: "Monthly7Year", scheduleExpression: events.Schedule.cron({ day: "1", hour: "5", minute: "0" }), moveToColdStorageAfter: core_1.Duration.days(30 * 3), deleteAfter: core_1.Duration.days(365 * 7) });
      }
      constructor(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_backup_BackupPlanRuleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _BackupPlanRule), error;
        }
        if (props.deleteAfter && props.moveToColdStorageAfter && props.deleteAfter.toDays() < props.moveToColdStorageAfter.toDays())
          throw new Error("`deleteAfter` must be greater than `moveToColdStorageAfter`");
        if (props.scheduleExpression && !/^cron/.test(props.scheduleExpression.expressionString))
          throw new Error("`scheduleExpression` must be of type `cron`");
        const deleteAfter = props.enableContinuousBackup && !props.deleteAfter ? core_1.Duration.days(35) : props.deleteAfter;
        if (props.enableContinuousBackup && props.moveToColdStorageAfter)
          throw new Error("`moveToColdStorageAfter` must not be specified if `enableContinuousBackup` is enabled");
        if (props.enableContinuousBackup && props.deleteAfter && (props.deleteAfter?.toDays() < 1 || props.deleteAfter?.toDays() > 35))
          throw new Error(`'deleteAfter' must be between 1 and 35 days if 'enableContinuousBackup' is enabled, but got ${props.deleteAfter.toHumanString()}`);
        props.copyActions && props.copyActions.length > 0 && props.copyActions.forEach((copyAction) => {
          if (copyAction.deleteAfter && !core_1.Token.isUnresolved(copyAction.deleteAfter) && copyAction.moveToColdStorageAfter && !core_1.Token.isUnresolved(copyAction.moveToColdStorageAfter) && copyAction.deleteAfter.toDays() < copyAction.moveToColdStorageAfter.toDays() + 90)
            throw new Error(["'deleteAfter' must at least 90 days later than corresponding 'moveToColdStorageAfter'", `received 'deleteAfter: ${copyAction.deleteAfter.toDays()}' and 'moveToColdStorageAfter: ${copyAction.moveToColdStorageAfter.toDays()}'`].join(`
`));
        }), this.props = { ...props, deleteAfter };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, BackupPlanRule[_a] = { fqn: "aws-cdk-lib.aws_backup.BackupPlanRule", version: "2.80.0" }, exports2.BackupPlanRule = BackupPlanRule;
  }
});

// node_modules/aws-cdk-lib/aws-dynamodb/lib/dynamodb.generated.js
var require_dynamodb_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-dynamodb/lib/dynamodb.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnTable = exports2.CfnGlobalTable = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnGlobalTablePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributeDefinitions", cdk.requiredValidator)(properties.attributeDefinitions)), errors.collect(cdk.propertyValidator("attributeDefinitions", cdk.listValidator(CfnGlobalTable_AttributeDefinitionPropertyValidator))(properties.attributeDefinitions)), errors.collect(cdk.propertyValidator("billingMode", cdk.validateString)(properties.billingMode)), errors.collect(cdk.propertyValidator("globalSecondaryIndexes", cdk.listValidator(CfnGlobalTable_GlobalSecondaryIndexPropertyValidator))(properties.globalSecondaryIndexes)), errors.collect(cdk.propertyValidator("keySchema", cdk.requiredValidator)(properties.keySchema)), errors.collect(cdk.propertyValidator("keySchema", cdk.listValidator(CfnGlobalTable_KeySchemaPropertyValidator))(properties.keySchema)), errors.collect(cdk.propertyValidator("localSecondaryIndexes", cdk.listValidator(CfnGlobalTable_LocalSecondaryIndexPropertyValidator))(properties.localSecondaryIndexes)), errors.collect(cdk.propertyValidator("replicas", cdk.requiredValidator)(properties.replicas)), errors.collect(cdk.propertyValidator("replicas", cdk.listValidator(CfnGlobalTable_ReplicaSpecificationPropertyValidator))(properties.replicas)), errors.collect(cdk.propertyValidator("sseSpecification", CfnGlobalTable_SSESpecificationPropertyValidator)(properties.sseSpecification)), errors.collect(cdk.propertyValidator("streamSpecification", CfnGlobalTable_StreamSpecificationPropertyValidator)(properties.streamSpecification)), errors.collect(cdk.propertyValidator("tableName", cdk.validateString)(properties.tableName)), errors.collect(cdk.propertyValidator("timeToLiveSpecification", CfnGlobalTable_TimeToLiveSpecificationPropertyValidator)(properties.timeToLiveSpecification)), errors.collect(cdk.propertyValidator("writeProvisionedThroughputSettings", CfnGlobalTable_WriteProvisionedThroughputSettingsPropertyValidator)(properties.writeProvisionedThroughputSettings)), errors.wrap('supplied properties not correct for "CfnGlobalTableProps"');
    }
    function cfnGlobalTablePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGlobalTablePropsValidator(properties).assertSuccess(), { AttributeDefinitions: cdk.listMapper(cfnGlobalTableAttributeDefinitionPropertyToCloudFormation)(properties.attributeDefinitions), KeySchema: cdk.listMapper(cfnGlobalTableKeySchemaPropertyToCloudFormation)(properties.keySchema), Replicas: cdk.listMapper(cfnGlobalTableReplicaSpecificationPropertyToCloudFormation)(properties.replicas), BillingMode: cdk.stringToCloudFormation(properties.billingMode), GlobalSecondaryIndexes: cdk.listMapper(cfnGlobalTableGlobalSecondaryIndexPropertyToCloudFormation)(properties.globalSecondaryIndexes), LocalSecondaryIndexes: cdk.listMapper(cfnGlobalTableLocalSecondaryIndexPropertyToCloudFormation)(properties.localSecondaryIndexes), SSESpecification: cfnGlobalTableSSESpecificationPropertyToCloudFormation(properties.sseSpecification), StreamSpecification: cfnGlobalTableStreamSpecificationPropertyToCloudFormation(properties.streamSpecification), TableName: cdk.stringToCloudFormation(properties.tableName), TimeToLiveSpecification: cfnGlobalTableTimeToLiveSpecificationPropertyToCloudFormation(properties.timeToLiveSpecification), WriteProvisionedThroughputSettings: cfnGlobalTableWriteProvisionedThroughputSettingsPropertyToCloudFormation(properties.writeProvisionedThroughputSettings) }) : properties;
    }
    function CfnGlobalTablePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attributeDefinitions", "AttributeDefinitions", cfn_parse.FromCloudFormation.getArray(CfnGlobalTableAttributeDefinitionPropertyFromCloudFormation)(properties.AttributeDefinitions)), ret.addPropertyResult("keySchema", "KeySchema", cfn_parse.FromCloudFormation.getArray(CfnGlobalTableKeySchemaPropertyFromCloudFormation)(properties.KeySchema)), ret.addPropertyResult("replicas", "Replicas", cfn_parse.FromCloudFormation.getArray(CfnGlobalTableReplicaSpecificationPropertyFromCloudFormation)(properties.Replicas)), ret.addPropertyResult("billingMode", "BillingMode", properties.BillingMode != null ? cfn_parse.FromCloudFormation.getString(properties.BillingMode) : void 0), ret.addPropertyResult("globalSecondaryIndexes", "GlobalSecondaryIndexes", properties.GlobalSecondaryIndexes != null ? cfn_parse.FromCloudFormation.getArray(CfnGlobalTableGlobalSecondaryIndexPropertyFromCloudFormation)(properties.GlobalSecondaryIndexes) : void 0), ret.addPropertyResult("localSecondaryIndexes", "LocalSecondaryIndexes", properties.LocalSecondaryIndexes != null ? cfn_parse.FromCloudFormation.getArray(CfnGlobalTableLocalSecondaryIndexPropertyFromCloudFormation)(properties.LocalSecondaryIndexes) : void 0), ret.addPropertyResult("sseSpecification", "SSESpecification", properties.SSESpecification != null ? CfnGlobalTableSSESpecificationPropertyFromCloudFormation(properties.SSESpecification) : void 0), ret.addPropertyResult("streamSpecification", "StreamSpecification", properties.StreamSpecification != null ? CfnGlobalTableStreamSpecificationPropertyFromCloudFormation(properties.StreamSpecification) : void 0), ret.addPropertyResult("tableName", "TableName", properties.TableName != null ? cfn_parse.FromCloudFormation.getString(properties.TableName) : void 0), ret.addPropertyResult("timeToLiveSpecification", "TimeToLiveSpecification", properties.TimeToLiveSpecification != null ? CfnGlobalTableTimeToLiveSpecificationPropertyFromCloudFormation(properties.TimeToLiveSpecification) : void 0), ret.addPropertyResult("writeProvisionedThroughputSettings", "WriteProvisionedThroughputSettings", properties.WriteProvisionedThroughputSettings != null ? CfnGlobalTableWriteProvisionedThroughputSettingsPropertyFromCloudFormation(properties.WriteProvisionedThroughputSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnGlobalTable = class _CfnGlobalTable extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnGlobalTablePropsFromCloudFormation(resourceProperties), ret = new _CfnGlobalTable(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnGlobalTable.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_dynamodb_CfnGlobalTableProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnGlobalTable), error;
        }
        cdk.requireProperty(props, "attributeDefinitions", this), cdk.requireProperty(props, "keySchema", this), cdk.requireProperty(props, "replicas", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrStreamArn = cdk.Token.asString(this.getAtt("StreamArn", cdk.ResolutionTypeHint.STRING)), this.attrTableId = cdk.Token.asString(this.getAtt("TableId", cdk.ResolutionTypeHint.STRING)), this.attributeDefinitions = props.attributeDefinitions, this.keySchema = props.keySchema, this.replicas = props.replicas, this.billingMode = props.billingMode, this.globalSecondaryIndexes = props.globalSecondaryIndexes, this.localSecondaryIndexes = props.localSecondaryIndexes, this.sseSpecification = props.sseSpecification, this.streamSpecification = props.streamSpecification, this.tableName = props.tableName, this.timeToLiveSpecification = props.timeToLiveSpecification, this.writeProvisionedThroughputSettings = props.writeProvisionedThroughputSettings, this.node.scope && cdk.Resource.isResource(this.node.scope) && this.node.addValidation({ validate: () => this.cfnOptions.deletionPolicy === void 0 ? ["'AWS::DynamoDB::GlobalTable' is a stateful resource type, and you must specify a Removal Policy for it. Call 'resource.applyRemovalPolicy()'."] : [] });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnGlobalTable.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { attributeDefinitions: this.attributeDefinitions, keySchema: this.keySchema, replicas: this.replicas, billingMode: this.billingMode, globalSecondaryIndexes: this.globalSecondaryIndexes, localSecondaryIndexes: this.localSecondaryIndexes, sseSpecification: this.sseSpecification, streamSpecification: this.streamSpecification, tableName: this.tableName, timeToLiveSpecification: this.timeToLiveSpecification, writeProvisionedThroughputSettings: this.writeProvisionedThroughputSettings };
      }
      renderProperties(props) {
        return cfnGlobalTablePropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnGlobalTable[_a] = { fqn: "aws-cdk-lib.aws_dynamodb.CfnGlobalTable", version: "2.80.0" }, CfnGlobalTable.CFN_RESOURCE_TYPE_NAME = "AWS::DynamoDB::GlobalTable", exports2.CfnGlobalTable = CfnGlobalTable;
    function CfnGlobalTable_AttributeDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributeName", cdk.requiredValidator)(properties.attributeName)), errors.collect(cdk.propertyValidator("attributeName", cdk.validateString)(properties.attributeName)), errors.collect(cdk.propertyValidator("attributeType", cdk.requiredValidator)(properties.attributeType)), errors.collect(cdk.propertyValidator("attributeType", cdk.validateString)(properties.attributeType)), errors.wrap('supplied properties not correct for "AttributeDefinitionProperty"');
    }
    function cfnGlobalTableAttributeDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGlobalTable_AttributeDefinitionPropertyValidator(properties).assertSuccess(), { AttributeName: cdk.stringToCloudFormation(properties.attributeName), AttributeType: cdk.stringToCloudFormation(properties.attributeType) }) : properties;
    }
    function CfnGlobalTableAttributeDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attributeName", "AttributeName", cfn_parse.FromCloudFormation.getString(properties.AttributeName)), ret.addPropertyResult("attributeType", "AttributeType", cfn_parse.FromCloudFormation.getString(properties.AttributeType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGlobalTable_CapacityAutoScalingSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxCapacity", cdk.requiredValidator)(properties.maxCapacity)), errors.collect(cdk.propertyValidator("maxCapacity", cdk.validateNumber)(properties.maxCapacity)), errors.collect(cdk.propertyValidator("minCapacity", cdk.requiredValidator)(properties.minCapacity)), errors.collect(cdk.propertyValidator("minCapacity", cdk.validateNumber)(properties.minCapacity)), errors.collect(cdk.propertyValidator("seedCapacity", cdk.validateNumber)(properties.seedCapacity)), errors.collect(cdk.propertyValidator("targetTrackingScalingPolicyConfiguration", cdk.requiredValidator)(properties.targetTrackingScalingPolicyConfiguration)), errors.collect(cdk.propertyValidator("targetTrackingScalingPolicyConfiguration", CfnGlobalTable_TargetTrackingScalingPolicyConfigurationPropertyValidator)(properties.targetTrackingScalingPolicyConfiguration)), errors.wrap('supplied properties not correct for "CapacityAutoScalingSettingsProperty"');
    }
    function cfnGlobalTableCapacityAutoScalingSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGlobalTable_CapacityAutoScalingSettingsPropertyValidator(properties).assertSuccess(), { MaxCapacity: cdk.numberToCloudFormation(properties.maxCapacity), MinCapacity: cdk.numberToCloudFormation(properties.minCapacity), SeedCapacity: cdk.numberToCloudFormation(properties.seedCapacity), TargetTrackingScalingPolicyConfiguration: cfnGlobalTableTargetTrackingScalingPolicyConfigurationPropertyToCloudFormation(properties.targetTrackingScalingPolicyConfiguration) }) : properties;
    }
    function CfnGlobalTableCapacityAutoScalingSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxCapacity", "MaxCapacity", cfn_parse.FromCloudFormation.getNumber(properties.MaxCapacity)), ret.addPropertyResult("minCapacity", "MinCapacity", cfn_parse.FromCloudFormation.getNumber(properties.MinCapacity)), ret.addPropertyResult("seedCapacity", "SeedCapacity", properties.SeedCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.SeedCapacity) : void 0), ret.addPropertyResult("targetTrackingScalingPolicyConfiguration", "TargetTrackingScalingPolicyConfiguration", CfnGlobalTableTargetTrackingScalingPolicyConfigurationPropertyFromCloudFormation(properties.TargetTrackingScalingPolicyConfiguration)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGlobalTable_ContributorInsightsSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "ContributorInsightsSpecificationProperty"');
    }
    function cfnGlobalTableContributorInsightsSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGlobalTable_ContributorInsightsSpecificationPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnGlobalTableContributorInsightsSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGlobalTable_GlobalSecondaryIndexPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("indexName", cdk.requiredValidator)(properties.indexName)), errors.collect(cdk.propertyValidator("indexName", cdk.validateString)(properties.indexName)), errors.collect(cdk.propertyValidator("keySchema", cdk.requiredValidator)(properties.keySchema)), errors.collect(cdk.propertyValidator("keySchema", cdk.listValidator(CfnGlobalTable_KeySchemaPropertyValidator))(properties.keySchema)), errors.collect(cdk.propertyValidator("projection", cdk.requiredValidator)(properties.projection)), errors.collect(cdk.propertyValidator("projection", CfnGlobalTable_ProjectionPropertyValidator)(properties.projection)), errors.collect(cdk.propertyValidator("writeProvisionedThroughputSettings", CfnGlobalTable_WriteProvisionedThroughputSettingsPropertyValidator)(properties.writeProvisionedThroughputSettings)), errors.wrap('supplied properties not correct for "GlobalSecondaryIndexProperty"');
    }
    function cfnGlobalTableGlobalSecondaryIndexPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGlobalTable_GlobalSecondaryIndexPropertyValidator(properties).assertSuccess(), { IndexName: cdk.stringToCloudFormation(properties.indexName), KeySchema: cdk.listMapper(cfnGlobalTableKeySchemaPropertyToCloudFormation)(properties.keySchema), Projection: cfnGlobalTableProjectionPropertyToCloudFormation(properties.projection), WriteProvisionedThroughputSettings: cfnGlobalTableWriteProvisionedThroughputSettingsPropertyToCloudFormation(properties.writeProvisionedThroughputSettings) }) : properties;
    }
    function CfnGlobalTableGlobalSecondaryIndexPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("indexName", "IndexName", cfn_parse.FromCloudFormation.getString(properties.IndexName)), ret.addPropertyResult("keySchema", "KeySchema", cfn_parse.FromCloudFormation.getArray(CfnGlobalTableKeySchemaPropertyFromCloudFormation)(properties.KeySchema)), ret.addPropertyResult("projection", "Projection", CfnGlobalTableProjectionPropertyFromCloudFormation(properties.Projection)), ret.addPropertyResult("writeProvisionedThroughputSettings", "WriteProvisionedThroughputSettings", properties.WriteProvisionedThroughputSettings != null ? CfnGlobalTableWriteProvisionedThroughputSettingsPropertyFromCloudFormation(properties.WriteProvisionedThroughputSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGlobalTable_KeySchemaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributeName", cdk.requiredValidator)(properties.attributeName)), errors.collect(cdk.propertyValidator("attributeName", cdk.validateString)(properties.attributeName)), errors.collect(cdk.propertyValidator("keyType", cdk.requiredValidator)(properties.keyType)), errors.collect(cdk.propertyValidator("keyType", cdk.validateString)(properties.keyType)), errors.wrap('supplied properties not correct for "KeySchemaProperty"');
    }
    function cfnGlobalTableKeySchemaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGlobalTable_KeySchemaPropertyValidator(properties).assertSuccess(), { AttributeName: cdk.stringToCloudFormation(properties.attributeName), KeyType: cdk.stringToCloudFormation(properties.keyType) }) : properties;
    }
    function CfnGlobalTableKeySchemaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attributeName", "AttributeName", cfn_parse.FromCloudFormation.getString(properties.AttributeName)), ret.addPropertyResult("keyType", "KeyType", cfn_parse.FromCloudFormation.getString(properties.KeyType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGlobalTable_KinesisStreamSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("streamArn", cdk.requiredValidator)(properties.streamArn)), errors.collect(cdk.propertyValidator("streamArn", cdk.validateString)(properties.streamArn)), errors.wrap('supplied properties not correct for "KinesisStreamSpecificationProperty"');
    }
    function cfnGlobalTableKinesisStreamSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGlobalTable_KinesisStreamSpecificationPropertyValidator(properties).assertSuccess(), { StreamArn: cdk.stringToCloudFormation(properties.streamArn) }) : properties;
    }
    function CfnGlobalTableKinesisStreamSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("streamArn", "StreamArn", cfn_parse.FromCloudFormation.getString(properties.StreamArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGlobalTable_LocalSecondaryIndexPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("indexName", cdk.requiredValidator)(properties.indexName)), errors.collect(cdk.propertyValidator("indexName", cdk.validateString)(properties.indexName)), errors.collect(cdk.propertyValidator("keySchema", cdk.requiredValidator)(properties.keySchema)), errors.collect(cdk.propertyValidator("keySchema", cdk.listValidator(CfnGlobalTable_KeySchemaPropertyValidator))(properties.keySchema)), errors.collect(cdk.propertyValidator("projection", cdk.requiredValidator)(properties.projection)), errors.collect(cdk.propertyValidator("projection", CfnGlobalTable_ProjectionPropertyValidator)(properties.projection)), errors.wrap('supplied properties not correct for "LocalSecondaryIndexProperty"');
    }
    function cfnGlobalTableLocalSecondaryIndexPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGlobalTable_LocalSecondaryIndexPropertyValidator(properties).assertSuccess(), { IndexName: cdk.stringToCloudFormation(properties.indexName), KeySchema: cdk.listMapper(cfnGlobalTableKeySchemaPropertyToCloudFormation)(properties.keySchema), Projection: cfnGlobalTableProjectionPropertyToCloudFormation(properties.projection) }) : properties;
    }
    function CfnGlobalTableLocalSecondaryIndexPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("indexName", "IndexName", cfn_parse.FromCloudFormation.getString(properties.IndexName)), ret.addPropertyResult("keySchema", "KeySchema", cfn_parse.FromCloudFormation.getArray(CfnGlobalTableKeySchemaPropertyFromCloudFormation)(properties.KeySchema)), ret.addPropertyResult("projection", "Projection", CfnGlobalTableProjectionPropertyFromCloudFormation(properties.Projection)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGlobalTable_PointInTimeRecoverySpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("pointInTimeRecoveryEnabled", cdk.validateBoolean)(properties.pointInTimeRecoveryEnabled)), errors.wrap('supplied properties not correct for "PointInTimeRecoverySpecificationProperty"');
    }
    function cfnGlobalTablePointInTimeRecoverySpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGlobalTable_PointInTimeRecoverySpecificationPropertyValidator(properties).assertSuccess(), { PointInTimeRecoveryEnabled: cdk.booleanToCloudFormation(properties.pointInTimeRecoveryEnabled) }) : properties;
    }
    function CfnGlobalTablePointInTimeRecoverySpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("pointInTimeRecoveryEnabled", "PointInTimeRecoveryEnabled", properties.PointInTimeRecoveryEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.PointInTimeRecoveryEnabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGlobalTable_ProjectionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("nonKeyAttributes", cdk.listValidator(cdk.validateString))(properties.nonKeyAttributes)), errors.collect(cdk.propertyValidator("projectionType", cdk.validateString)(properties.projectionType)), errors.wrap('supplied properties not correct for "ProjectionProperty"');
    }
    function cfnGlobalTableProjectionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGlobalTable_ProjectionPropertyValidator(properties).assertSuccess(), { NonKeyAttributes: cdk.listMapper(cdk.stringToCloudFormation)(properties.nonKeyAttributes), ProjectionType: cdk.stringToCloudFormation(properties.projectionType) }) : properties;
    }
    function CfnGlobalTableProjectionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("nonKeyAttributes", "NonKeyAttributes", properties.NonKeyAttributes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.NonKeyAttributes) : void 0), ret.addPropertyResult("projectionType", "ProjectionType", properties.ProjectionType != null ? cfn_parse.FromCloudFormation.getString(properties.ProjectionType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGlobalTable_ReadProvisionedThroughputSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("readCapacityAutoScalingSettings", CfnGlobalTable_CapacityAutoScalingSettingsPropertyValidator)(properties.readCapacityAutoScalingSettings)), errors.collect(cdk.propertyValidator("readCapacityUnits", cdk.validateNumber)(properties.readCapacityUnits)), errors.wrap('supplied properties not correct for "ReadProvisionedThroughputSettingsProperty"');
    }
    function cfnGlobalTableReadProvisionedThroughputSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGlobalTable_ReadProvisionedThroughputSettingsPropertyValidator(properties).assertSuccess(), { ReadCapacityAutoScalingSettings: cfnGlobalTableCapacityAutoScalingSettingsPropertyToCloudFormation(properties.readCapacityAutoScalingSettings), ReadCapacityUnits: cdk.numberToCloudFormation(properties.readCapacityUnits) }) : properties;
    }
    function CfnGlobalTableReadProvisionedThroughputSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("readCapacityAutoScalingSettings", "ReadCapacityAutoScalingSettings", properties.ReadCapacityAutoScalingSettings != null ? CfnGlobalTableCapacityAutoScalingSettingsPropertyFromCloudFormation(properties.ReadCapacityAutoScalingSettings) : void 0), ret.addPropertyResult("readCapacityUnits", "ReadCapacityUnits", properties.ReadCapacityUnits != null ? cfn_parse.FromCloudFormation.getNumber(properties.ReadCapacityUnits) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGlobalTable_ReplicaGlobalSecondaryIndexSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contributorInsightsSpecification", CfnGlobalTable_ContributorInsightsSpecificationPropertyValidator)(properties.contributorInsightsSpecification)), errors.collect(cdk.propertyValidator("indexName", cdk.requiredValidator)(properties.indexName)), errors.collect(cdk.propertyValidator("indexName", cdk.validateString)(properties.indexName)), errors.collect(cdk.propertyValidator("readProvisionedThroughputSettings", CfnGlobalTable_ReadProvisionedThroughputSettingsPropertyValidator)(properties.readProvisionedThroughputSettings)), errors.wrap('supplied properties not correct for "ReplicaGlobalSecondaryIndexSpecificationProperty"');
    }
    function cfnGlobalTableReplicaGlobalSecondaryIndexSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGlobalTable_ReplicaGlobalSecondaryIndexSpecificationPropertyValidator(properties).assertSuccess(), { ContributorInsightsSpecification: cfnGlobalTableContributorInsightsSpecificationPropertyToCloudFormation(properties.contributorInsightsSpecification), IndexName: cdk.stringToCloudFormation(properties.indexName), ReadProvisionedThroughputSettings: cfnGlobalTableReadProvisionedThroughputSettingsPropertyToCloudFormation(properties.readProvisionedThroughputSettings) }) : properties;
    }
    function CfnGlobalTableReplicaGlobalSecondaryIndexSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contributorInsightsSpecification", "ContributorInsightsSpecification", properties.ContributorInsightsSpecification != null ? CfnGlobalTableContributorInsightsSpecificationPropertyFromCloudFormation(properties.ContributorInsightsSpecification) : void 0), ret.addPropertyResult("indexName", "IndexName", cfn_parse.FromCloudFormation.getString(properties.IndexName)), ret.addPropertyResult("readProvisionedThroughputSettings", "ReadProvisionedThroughputSettings", properties.ReadProvisionedThroughputSettings != null ? CfnGlobalTableReadProvisionedThroughputSettingsPropertyFromCloudFormation(properties.ReadProvisionedThroughputSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGlobalTable_ReplicaSSESpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kmsMasterKeyId", cdk.requiredValidator)(properties.kmsMasterKeyId)), errors.collect(cdk.propertyValidator("kmsMasterKeyId", cdk.validateString)(properties.kmsMasterKeyId)), errors.wrap('supplied properties not correct for "ReplicaSSESpecificationProperty"');
    }
    function cfnGlobalTableReplicaSSESpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGlobalTable_ReplicaSSESpecificationPropertyValidator(properties).assertSuccess(), { KMSMasterKeyId: cdk.stringToCloudFormation(properties.kmsMasterKeyId) }) : properties;
    }
    function CfnGlobalTableReplicaSSESpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsMasterKeyId", "KMSMasterKeyId", cfn_parse.FromCloudFormation.getString(properties.KMSMasterKeyId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGlobalTable_ReplicaSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contributorInsightsSpecification", CfnGlobalTable_ContributorInsightsSpecificationPropertyValidator)(properties.contributorInsightsSpecification)), errors.collect(cdk.propertyValidator("deletionProtectionEnabled", cdk.validateBoolean)(properties.deletionProtectionEnabled)), errors.collect(cdk.propertyValidator("globalSecondaryIndexes", cdk.listValidator(CfnGlobalTable_ReplicaGlobalSecondaryIndexSpecificationPropertyValidator))(properties.globalSecondaryIndexes)), errors.collect(cdk.propertyValidator("kinesisStreamSpecification", CfnGlobalTable_KinesisStreamSpecificationPropertyValidator)(properties.kinesisStreamSpecification)), errors.collect(cdk.propertyValidator("pointInTimeRecoverySpecification", CfnGlobalTable_PointInTimeRecoverySpecificationPropertyValidator)(properties.pointInTimeRecoverySpecification)), errors.collect(cdk.propertyValidator("readProvisionedThroughputSettings", CfnGlobalTable_ReadProvisionedThroughputSettingsPropertyValidator)(properties.readProvisionedThroughputSettings)), errors.collect(cdk.propertyValidator("region", cdk.requiredValidator)(properties.region)), errors.collect(cdk.propertyValidator("region", cdk.validateString)(properties.region)), errors.collect(cdk.propertyValidator("sseSpecification", CfnGlobalTable_ReplicaSSESpecificationPropertyValidator)(properties.sseSpecification)), errors.collect(cdk.propertyValidator("tableClass", cdk.validateString)(properties.tableClass)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "ReplicaSpecificationProperty"');
    }
    function cfnGlobalTableReplicaSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGlobalTable_ReplicaSpecificationPropertyValidator(properties).assertSuccess(), { ContributorInsightsSpecification: cfnGlobalTableContributorInsightsSpecificationPropertyToCloudFormation(properties.contributorInsightsSpecification), DeletionProtectionEnabled: cdk.booleanToCloudFormation(properties.deletionProtectionEnabled), GlobalSecondaryIndexes: cdk.listMapper(cfnGlobalTableReplicaGlobalSecondaryIndexSpecificationPropertyToCloudFormation)(properties.globalSecondaryIndexes), KinesisStreamSpecification: cfnGlobalTableKinesisStreamSpecificationPropertyToCloudFormation(properties.kinesisStreamSpecification), PointInTimeRecoverySpecification: cfnGlobalTablePointInTimeRecoverySpecificationPropertyToCloudFormation(properties.pointInTimeRecoverySpecification), ReadProvisionedThroughputSettings: cfnGlobalTableReadProvisionedThroughputSettingsPropertyToCloudFormation(properties.readProvisionedThroughputSettings), Region: cdk.stringToCloudFormation(properties.region), SSESpecification: cfnGlobalTableReplicaSSESpecificationPropertyToCloudFormation(properties.sseSpecification), TableClass: cdk.stringToCloudFormation(properties.tableClass), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnGlobalTableReplicaSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contributorInsightsSpecification", "ContributorInsightsSpecification", properties.ContributorInsightsSpecification != null ? CfnGlobalTableContributorInsightsSpecificationPropertyFromCloudFormation(properties.ContributorInsightsSpecification) : void 0), ret.addPropertyResult("deletionProtectionEnabled", "DeletionProtectionEnabled", properties.DeletionProtectionEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeletionProtectionEnabled) : void 0), ret.addPropertyResult("globalSecondaryIndexes", "GlobalSecondaryIndexes", properties.GlobalSecondaryIndexes != null ? cfn_parse.FromCloudFormation.getArray(CfnGlobalTableReplicaGlobalSecondaryIndexSpecificationPropertyFromCloudFormation)(properties.GlobalSecondaryIndexes) : void 0), ret.addPropertyResult("kinesisStreamSpecification", "KinesisStreamSpecification", properties.KinesisStreamSpecification != null ? CfnGlobalTableKinesisStreamSpecificationPropertyFromCloudFormation(properties.KinesisStreamSpecification) : void 0), ret.addPropertyResult("pointInTimeRecoverySpecification", "PointInTimeRecoverySpecification", properties.PointInTimeRecoverySpecification != null ? CfnGlobalTablePointInTimeRecoverySpecificationPropertyFromCloudFormation(properties.PointInTimeRecoverySpecification) : void 0), ret.addPropertyResult("readProvisionedThroughputSettings", "ReadProvisionedThroughputSettings", properties.ReadProvisionedThroughputSettings != null ? CfnGlobalTableReadProvisionedThroughputSettingsPropertyFromCloudFormation(properties.ReadProvisionedThroughputSettings) : void 0), ret.addPropertyResult("region", "Region", cfn_parse.FromCloudFormation.getString(properties.Region)), ret.addPropertyResult("sseSpecification", "SSESpecification", properties.SSESpecification != null ? CfnGlobalTableReplicaSSESpecificationPropertyFromCloudFormation(properties.SSESpecification) : void 0), ret.addPropertyResult("tableClass", "TableClass", properties.TableClass != null ? cfn_parse.FromCloudFormation.getString(properties.TableClass) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGlobalTable_SSESpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sseEnabled", cdk.requiredValidator)(properties.sseEnabled)), errors.collect(cdk.propertyValidator("sseEnabled", cdk.validateBoolean)(properties.sseEnabled)), errors.collect(cdk.propertyValidator("sseType", cdk.validateString)(properties.sseType)), errors.wrap('supplied properties not correct for "SSESpecificationProperty"');
    }
    function cfnGlobalTableSSESpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGlobalTable_SSESpecificationPropertyValidator(properties).assertSuccess(), { SSEEnabled: cdk.booleanToCloudFormation(properties.sseEnabled), SSEType: cdk.stringToCloudFormation(properties.sseType) }) : properties;
    }
    function CfnGlobalTableSSESpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sseEnabled", "SSEEnabled", cfn_parse.FromCloudFormation.getBoolean(properties.SSEEnabled)), ret.addPropertyResult("sseType", "SSEType", properties.SSEType != null ? cfn_parse.FromCloudFormation.getString(properties.SSEType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGlobalTable_StreamSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("streamViewType", cdk.requiredValidator)(properties.streamViewType)), errors.collect(cdk.propertyValidator("streamViewType", cdk.validateString)(properties.streamViewType)), errors.wrap('supplied properties not correct for "StreamSpecificationProperty"');
    }
    function cfnGlobalTableStreamSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGlobalTable_StreamSpecificationPropertyValidator(properties).assertSuccess(), { StreamViewType: cdk.stringToCloudFormation(properties.streamViewType) }) : properties;
    }
    function CfnGlobalTableStreamSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("streamViewType", "StreamViewType", cfn_parse.FromCloudFormation.getString(properties.StreamViewType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGlobalTable_TargetTrackingScalingPolicyConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("disableScaleIn", cdk.validateBoolean)(properties.disableScaleIn)), errors.collect(cdk.propertyValidator("scaleInCooldown", cdk.validateNumber)(properties.scaleInCooldown)), errors.collect(cdk.propertyValidator("scaleOutCooldown", cdk.validateNumber)(properties.scaleOutCooldown)), errors.collect(cdk.propertyValidator("targetValue", cdk.requiredValidator)(properties.targetValue)), errors.collect(cdk.propertyValidator("targetValue", cdk.validateNumber)(properties.targetValue)), errors.wrap('supplied properties not correct for "TargetTrackingScalingPolicyConfigurationProperty"');
    }
    function cfnGlobalTableTargetTrackingScalingPolicyConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGlobalTable_TargetTrackingScalingPolicyConfigurationPropertyValidator(properties).assertSuccess(), { DisableScaleIn: cdk.booleanToCloudFormation(properties.disableScaleIn), ScaleInCooldown: cdk.numberToCloudFormation(properties.scaleInCooldown), ScaleOutCooldown: cdk.numberToCloudFormation(properties.scaleOutCooldown), TargetValue: cdk.numberToCloudFormation(properties.targetValue) }) : properties;
    }
    function CfnGlobalTableTargetTrackingScalingPolicyConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("disableScaleIn", "DisableScaleIn", properties.DisableScaleIn != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DisableScaleIn) : void 0), ret.addPropertyResult("scaleInCooldown", "ScaleInCooldown", properties.ScaleInCooldown != null ? cfn_parse.FromCloudFormation.getNumber(properties.ScaleInCooldown) : void 0), ret.addPropertyResult("scaleOutCooldown", "ScaleOutCooldown", properties.ScaleOutCooldown != null ? cfn_parse.FromCloudFormation.getNumber(properties.ScaleOutCooldown) : void 0), ret.addPropertyResult("targetValue", "TargetValue", cfn_parse.FromCloudFormation.getNumber(properties.TargetValue)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGlobalTable_TimeToLiveSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributeName", cdk.validateString)(properties.attributeName)), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "TimeToLiveSpecificationProperty"');
    }
    function cfnGlobalTableTimeToLiveSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGlobalTable_TimeToLiveSpecificationPropertyValidator(properties).assertSuccess(), { AttributeName: cdk.stringToCloudFormation(properties.attributeName), Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnGlobalTableTimeToLiveSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attributeName", "AttributeName", properties.AttributeName != null ? cfn_parse.FromCloudFormation.getString(properties.AttributeName) : void 0), ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGlobalTable_WriteProvisionedThroughputSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("writeCapacityAutoScalingSettings", CfnGlobalTable_CapacityAutoScalingSettingsPropertyValidator)(properties.writeCapacityAutoScalingSettings)), errors.wrap('supplied properties not correct for "WriteProvisionedThroughputSettingsProperty"');
    }
    function cfnGlobalTableWriteProvisionedThroughputSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGlobalTable_WriteProvisionedThroughputSettingsPropertyValidator(properties).assertSuccess(), { WriteCapacityAutoScalingSettings: cfnGlobalTableCapacityAutoScalingSettingsPropertyToCloudFormation(properties.writeCapacityAutoScalingSettings) }) : properties;
    }
    function CfnGlobalTableWriteProvisionedThroughputSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("writeCapacityAutoScalingSettings", "WriteCapacityAutoScalingSettings", properties.WriteCapacityAutoScalingSettings != null ? CfnGlobalTableCapacityAutoScalingSettingsPropertyFromCloudFormation(properties.WriteCapacityAutoScalingSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTablePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributeDefinitions", cdk.listValidator(CfnTable_AttributeDefinitionPropertyValidator))(properties.attributeDefinitions)), errors.collect(cdk.propertyValidator("billingMode", cdk.validateString)(properties.billingMode)), errors.collect(cdk.propertyValidator("contributorInsightsSpecification", CfnTable_ContributorInsightsSpecificationPropertyValidator)(properties.contributorInsightsSpecification)), errors.collect(cdk.propertyValidator("deletionProtectionEnabled", cdk.validateBoolean)(properties.deletionProtectionEnabled)), errors.collect(cdk.propertyValidator("globalSecondaryIndexes", cdk.listValidator(CfnTable_GlobalSecondaryIndexPropertyValidator))(properties.globalSecondaryIndexes)), errors.collect(cdk.propertyValidator("importSourceSpecification", CfnTable_ImportSourceSpecificationPropertyValidator)(properties.importSourceSpecification)), errors.collect(cdk.propertyValidator("keySchema", cdk.requiredValidator)(properties.keySchema)), errors.collect(cdk.propertyValidator("keySchema", cdk.listValidator(CfnTable_KeySchemaPropertyValidator))(properties.keySchema)), errors.collect(cdk.propertyValidator("kinesisStreamSpecification", CfnTable_KinesisStreamSpecificationPropertyValidator)(properties.kinesisStreamSpecification)), errors.collect(cdk.propertyValidator("localSecondaryIndexes", cdk.listValidator(CfnTable_LocalSecondaryIndexPropertyValidator))(properties.localSecondaryIndexes)), errors.collect(cdk.propertyValidator("pointInTimeRecoverySpecification", CfnTable_PointInTimeRecoverySpecificationPropertyValidator)(properties.pointInTimeRecoverySpecification)), errors.collect(cdk.propertyValidator("provisionedThroughput", CfnTable_ProvisionedThroughputPropertyValidator)(properties.provisionedThroughput)), errors.collect(cdk.propertyValidator("sseSpecification", CfnTable_SSESpecificationPropertyValidator)(properties.sseSpecification)), errors.collect(cdk.propertyValidator("streamSpecification", CfnTable_StreamSpecificationPropertyValidator)(properties.streamSpecification)), errors.collect(cdk.propertyValidator("tableClass", cdk.validateString)(properties.tableClass)), errors.collect(cdk.propertyValidator("tableName", cdk.validateString)(properties.tableName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("timeToLiveSpecification", CfnTable_TimeToLiveSpecificationPropertyValidator)(properties.timeToLiveSpecification)), errors.wrap('supplied properties not correct for "CfnTableProps"');
    }
    function cfnTablePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTablePropsValidator(properties).assertSuccess(), { KeySchema: cdk.listMapper(cfnTableKeySchemaPropertyToCloudFormation)(properties.keySchema), AttributeDefinitions: cdk.listMapper(cfnTableAttributeDefinitionPropertyToCloudFormation)(properties.attributeDefinitions), BillingMode: cdk.stringToCloudFormation(properties.billingMode), ContributorInsightsSpecification: cfnTableContributorInsightsSpecificationPropertyToCloudFormation(properties.contributorInsightsSpecification), DeletionProtectionEnabled: cdk.booleanToCloudFormation(properties.deletionProtectionEnabled), GlobalSecondaryIndexes: cdk.listMapper(cfnTableGlobalSecondaryIndexPropertyToCloudFormation)(properties.globalSecondaryIndexes), ImportSourceSpecification: cfnTableImportSourceSpecificationPropertyToCloudFormation(properties.importSourceSpecification), KinesisStreamSpecification: cfnTableKinesisStreamSpecificationPropertyToCloudFormation(properties.kinesisStreamSpecification), LocalSecondaryIndexes: cdk.listMapper(cfnTableLocalSecondaryIndexPropertyToCloudFormation)(properties.localSecondaryIndexes), PointInTimeRecoverySpecification: cfnTablePointInTimeRecoverySpecificationPropertyToCloudFormation(properties.pointInTimeRecoverySpecification), ProvisionedThroughput: cfnTableProvisionedThroughputPropertyToCloudFormation(properties.provisionedThroughput), SSESpecification: cfnTableSSESpecificationPropertyToCloudFormation(properties.sseSpecification), StreamSpecification: cfnTableStreamSpecificationPropertyToCloudFormation(properties.streamSpecification), TableClass: cdk.stringToCloudFormation(properties.tableClass), TableName: cdk.stringToCloudFormation(properties.tableName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TimeToLiveSpecification: cfnTableTimeToLiveSpecificationPropertyToCloudFormation(properties.timeToLiveSpecification) }) : properties;
    }
    function CfnTablePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("keySchema", "KeySchema", cfn_parse.FromCloudFormation.getArray(CfnTableKeySchemaPropertyFromCloudFormation)(properties.KeySchema)), ret.addPropertyResult("attributeDefinitions", "AttributeDefinitions", properties.AttributeDefinitions != null ? cfn_parse.FromCloudFormation.getArray(CfnTableAttributeDefinitionPropertyFromCloudFormation)(properties.AttributeDefinitions) : void 0), ret.addPropertyResult("billingMode", "BillingMode", properties.BillingMode != null ? cfn_parse.FromCloudFormation.getString(properties.BillingMode) : void 0), ret.addPropertyResult("contributorInsightsSpecification", "ContributorInsightsSpecification", properties.ContributorInsightsSpecification != null ? CfnTableContributorInsightsSpecificationPropertyFromCloudFormation(properties.ContributorInsightsSpecification) : void 0), ret.addPropertyResult("deletionProtectionEnabled", "DeletionProtectionEnabled", properties.DeletionProtectionEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeletionProtectionEnabled) : void 0), ret.addPropertyResult("globalSecondaryIndexes", "GlobalSecondaryIndexes", properties.GlobalSecondaryIndexes != null ? cfn_parse.FromCloudFormation.getArray(CfnTableGlobalSecondaryIndexPropertyFromCloudFormation)(properties.GlobalSecondaryIndexes) : void 0), ret.addPropertyResult("importSourceSpecification", "ImportSourceSpecification", properties.ImportSourceSpecification != null ? CfnTableImportSourceSpecificationPropertyFromCloudFormation(properties.ImportSourceSpecification) : void 0), ret.addPropertyResult("kinesisStreamSpecification", "KinesisStreamSpecification", properties.KinesisStreamSpecification != null ? CfnTableKinesisStreamSpecificationPropertyFromCloudFormation(properties.KinesisStreamSpecification) : void 0), ret.addPropertyResult("localSecondaryIndexes", "LocalSecondaryIndexes", properties.LocalSecondaryIndexes != null ? cfn_parse.FromCloudFormation.getArray(CfnTableLocalSecondaryIndexPropertyFromCloudFormation)(properties.LocalSecondaryIndexes) : void 0), ret.addPropertyResult("pointInTimeRecoverySpecification", "PointInTimeRecoverySpecification", properties.PointInTimeRecoverySpecification != null ? CfnTablePointInTimeRecoverySpecificationPropertyFromCloudFormation(properties.PointInTimeRecoverySpecification) : void 0), ret.addPropertyResult("provisionedThroughput", "ProvisionedThroughput", properties.ProvisionedThroughput != null ? CfnTableProvisionedThroughputPropertyFromCloudFormation(properties.ProvisionedThroughput) : void 0), ret.addPropertyResult("sseSpecification", "SSESpecification", properties.SSESpecification != null ? CfnTableSSESpecificationPropertyFromCloudFormation(properties.SSESpecification) : void 0), ret.addPropertyResult("streamSpecification", "StreamSpecification", properties.StreamSpecification != null ? CfnTableStreamSpecificationPropertyFromCloudFormation(properties.StreamSpecification) : void 0), ret.addPropertyResult("tableClass", "TableClass", properties.TableClass != null ? cfn_parse.FromCloudFormation.getString(properties.TableClass) : void 0), ret.addPropertyResult("tableName", "TableName", properties.TableName != null ? cfn_parse.FromCloudFormation.getString(properties.TableName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("timeToLiveSpecification", "TimeToLiveSpecification", properties.TimeToLiveSpecification != null ? CfnTableTimeToLiveSpecificationPropertyFromCloudFormation(properties.TimeToLiveSpecification) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTable = class _CfnTable extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTablePropsFromCloudFormation(resourceProperties), ret = new _CfnTable(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTable.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_dynamodb_CfnTableProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTable), error;
        }
        cdk.requireProperty(props, "keySchema", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrStreamArn = cdk.Token.asString(this.getAtt("StreamArn", cdk.ResolutionTypeHint.STRING)), this.keySchema = props.keySchema, this.attributeDefinitions = props.attributeDefinitions, this.billingMode = props.billingMode, this.contributorInsightsSpecification = props.contributorInsightsSpecification, this.deletionProtectionEnabled = props.deletionProtectionEnabled, this.globalSecondaryIndexes = props.globalSecondaryIndexes, this.importSourceSpecification = props.importSourceSpecification, this.kinesisStreamSpecification = props.kinesisStreamSpecification, this.localSecondaryIndexes = props.localSecondaryIndexes, this.pointInTimeRecoverySpecification = props.pointInTimeRecoverySpecification, this.provisionedThroughput = props.provisionedThroughput, this.sseSpecification = props.sseSpecification, this.streamSpecification = props.streamSpecification, this.tableClass = props.tableClass, this.tableName = props.tableName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DynamoDB::Table", props.tags, { tagPropertyName: "tags" }), this.timeToLiveSpecification = props.timeToLiveSpecification, this.node.scope && cdk.Resource.isResource(this.node.scope) && this.node.addValidation({ validate: () => this.cfnOptions.deletionPolicy === void 0 ? ["'AWS::DynamoDB::Table' is a stateful resource type, and you must specify a Removal Policy for it. Call 'resource.applyRemovalPolicy()'."] : [] });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTable.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { keySchema: this.keySchema, attributeDefinitions: this.attributeDefinitions, billingMode: this.billingMode, contributorInsightsSpecification: this.contributorInsightsSpecification, deletionProtectionEnabled: this.deletionProtectionEnabled, globalSecondaryIndexes: this.globalSecondaryIndexes, importSourceSpecification: this.importSourceSpecification, kinesisStreamSpecification: this.kinesisStreamSpecification, localSecondaryIndexes: this.localSecondaryIndexes, pointInTimeRecoverySpecification: this.pointInTimeRecoverySpecification, provisionedThroughput: this.provisionedThroughput, sseSpecification: this.sseSpecification, streamSpecification: this.streamSpecification, tableClass: this.tableClass, tableName: this.tableName, tags: this.tags.renderTags(), timeToLiveSpecification: this.timeToLiveSpecification };
      }
      renderProperties(props) {
        return cfnTablePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnTable[_b] = { fqn: "aws-cdk-lib.aws_dynamodb.CfnTable", version: "2.80.0" }, CfnTable.CFN_RESOURCE_TYPE_NAME = "AWS::DynamoDB::Table", exports2.CfnTable = CfnTable;
    function CfnTable_AttributeDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributeName", cdk.requiredValidator)(properties.attributeName)), errors.collect(cdk.propertyValidator("attributeName", cdk.validateString)(properties.attributeName)), errors.collect(cdk.propertyValidator("attributeType", cdk.requiredValidator)(properties.attributeType)), errors.collect(cdk.propertyValidator("attributeType", cdk.validateString)(properties.attributeType)), errors.wrap('supplied properties not correct for "AttributeDefinitionProperty"');
    }
    function cfnTableAttributeDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTable_AttributeDefinitionPropertyValidator(properties).assertSuccess(), { AttributeName: cdk.stringToCloudFormation(properties.attributeName), AttributeType: cdk.stringToCloudFormation(properties.attributeType) }) : properties;
    }
    function CfnTableAttributeDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attributeName", "AttributeName", cfn_parse.FromCloudFormation.getString(properties.AttributeName)), ret.addPropertyResult("attributeType", "AttributeType", cfn_parse.FromCloudFormation.getString(properties.AttributeType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTable_ContributorInsightsSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "ContributorInsightsSpecificationProperty"');
    }
    function cfnTableContributorInsightsSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTable_ContributorInsightsSpecificationPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnTableContributorInsightsSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTable_CsvPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("delimiter", cdk.validateString)(properties.delimiter)), errors.collect(cdk.propertyValidator("headerList", cdk.listValidator(cdk.validateString))(properties.headerList)), errors.wrap('supplied properties not correct for "CsvProperty"');
    }
    function cfnTableCsvPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTable_CsvPropertyValidator(properties).assertSuccess(), { Delimiter: cdk.stringToCloudFormation(properties.delimiter), HeaderList: cdk.listMapper(cdk.stringToCloudFormation)(properties.headerList) }) : properties;
    }
    function CfnTableCsvPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("delimiter", "Delimiter", properties.Delimiter != null ? cfn_parse.FromCloudFormation.getString(properties.Delimiter) : void 0), ret.addPropertyResult("headerList", "HeaderList", properties.HeaderList != null ? cfn_parse.FromCloudFormation.getStringArray(properties.HeaderList) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTable_GlobalSecondaryIndexPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contributorInsightsSpecification", CfnTable_ContributorInsightsSpecificationPropertyValidator)(properties.contributorInsightsSpecification)), errors.collect(cdk.propertyValidator("indexName", cdk.requiredValidator)(properties.indexName)), errors.collect(cdk.propertyValidator("indexName", cdk.validateString)(properties.indexName)), errors.collect(cdk.propertyValidator("keySchema", cdk.requiredValidator)(properties.keySchema)), errors.collect(cdk.propertyValidator("keySchema", cdk.listValidator(CfnTable_KeySchemaPropertyValidator))(properties.keySchema)), errors.collect(cdk.propertyValidator("projection", cdk.requiredValidator)(properties.projection)), errors.collect(cdk.propertyValidator("projection", CfnTable_ProjectionPropertyValidator)(properties.projection)), errors.collect(cdk.propertyValidator("provisionedThroughput", CfnTable_ProvisionedThroughputPropertyValidator)(properties.provisionedThroughput)), errors.wrap('supplied properties not correct for "GlobalSecondaryIndexProperty"');
    }
    function cfnTableGlobalSecondaryIndexPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTable_GlobalSecondaryIndexPropertyValidator(properties).assertSuccess(), { ContributorInsightsSpecification: cfnTableContributorInsightsSpecificationPropertyToCloudFormation(properties.contributorInsightsSpecification), IndexName: cdk.stringToCloudFormation(properties.indexName), KeySchema: cdk.listMapper(cfnTableKeySchemaPropertyToCloudFormation)(properties.keySchema), Projection: cfnTableProjectionPropertyToCloudFormation(properties.projection), ProvisionedThroughput: cfnTableProvisionedThroughputPropertyToCloudFormation(properties.provisionedThroughput) }) : properties;
    }
    function CfnTableGlobalSecondaryIndexPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contributorInsightsSpecification", "ContributorInsightsSpecification", properties.ContributorInsightsSpecification != null ? CfnTableContributorInsightsSpecificationPropertyFromCloudFormation(properties.ContributorInsightsSpecification) : void 0), ret.addPropertyResult("indexName", "IndexName", cfn_parse.FromCloudFormation.getString(properties.IndexName)), ret.addPropertyResult("keySchema", "KeySchema", cfn_parse.FromCloudFormation.getArray(CfnTableKeySchemaPropertyFromCloudFormation)(properties.KeySchema)), ret.addPropertyResult("projection", "Projection", CfnTableProjectionPropertyFromCloudFormation(properties.Projection)), ret.addPropertyResult("provisionedThroughput", "ProvisionedThroughput", properties.ProvisionedThroughput != null ? CfnTableProvisionedThroughputPropertyFromCloudFormation(properties.ProvisionedThroughput) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTable_ImportSourceSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("inputCompressionType", cdk.validateString)(properties.inputCompressionType)), errors.collect(cdk.propertyValidator("inputFormat", cdk.requiredValidator)(properties.inputFormat)), errors.collect(cdk.propertyValidator("inputFormat", cdk.validateString)(properties.inputFormat)), errors.collect(cdk.propertyValidator("inputFormatOptions", CfnTable_InputFormatOptionsPropertyValidator)(properties.inputFormatOptions)), errors.collect(cdk.propertyValidator("s3BucketSource", cdk.requiredValidator)(properties.s3BucketSource)), errors.collect(cdk.propertyValidator("s3BucketSource", CfnTable_S3BucketSourcePropertyValidator)(properties.s3BucketSource)), errors.wrap('supplied properties not correct for "ImportSourceSpecificationProperty"');
    }
    function cfnTableImportSourceSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTable_ImportSourceSpecificationPropertyValidator(properties).assertSuccess(), { InputCompressionType: cdk.stringToCloudFormation(properties.inputCompressionType), InputFormat: cdk.stringToCloudFormation(properties.inputFormat), InputFormatOptions: cfnTableInputFormatOptionsPropertyToCloudFormation(properties.inputFormatOptions), S3BucketSource: cfnTableS3BucketSourcePropertyToCloudFormation(properties.s3BucketSource) }) : properties;
    }
    function CfnTableImportSourceSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("inputCompressionType", "InputCompressionType", properties.InputCompressionType != null ? cfn_parse.FromCloudFormation.getString(properties.InputCompressionType) : void 0), ret.addPropertyResult("inputFormat", "InputFormat", cfn_parse.FromCloudFormation.getString(properties.InputFormat)), ret.addPropertyResult("inputFormatOptions", "InputFormatOptions", properties.InputFormatOptions != null ? CfnTableInputFormatOptionsPropertyFromCloudFormation(properties.InputFormatOptions) : void 0), ret.addPropertyResult("s3BucketSource", "S3BucketSource", CfnTableS3BucketSourcePropertyFromCloudFormation(properties.S3BucketSource)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTable_InputFormatOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("csv", CfnTable_CsvPropertyValidator)(properties.csv)), errors.wrap('supplied properties not correct for "InputFormatOptionsProperty"');
    }
    function cfnTableInputFormatOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTable_InputFormatOptionsPropertyValidator(properties).assertSuccess(), { Csv: cfnTableCsvPropertyToCloudFormation(properties.csv) }) : properties;
    }
    function CfnTableInputFormatOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("csv", "Csv", properties.Csv != null ? CfnTableCsvPropertyFromCloudFormation(properties.Csv) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTable_KeySchemaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributeName", cdk.requiredValidator)(properties.attributeName)), errors.collect(cdk.propertyValidator("attributeName", cdk.validateString)(properties.attributeName)), errors.collect(cdk.propertyValidator("keyType", cdk.requiredValidator)(properties.keyType)), errors.collect(cdk.propertyValidator("keyType", cdk.validateString)(properties.keyType)), errors.wrap('supplied properties not correct for "KeySchemaProperty"');
    }
    function cfnTableKeySchemaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTable_KeySchemaPropertyValidator(properties).assertSuccess(), { AttributeName: cdk.stringToCloudFormation(properties.attributeName), KeyType: cdk.stringToCloudFormation(properties.keyType) }) : properties;
    }
    function CfnTableKeySchemaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attributeName", "AttributeName", cfn_parse.FromCloudFormation.getString(properties.AttributeName)), ret.addPropertyResult("keyType", "KeyType", cfn_parse.FromCloudFormation.getString(properties.KeyType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTable_KinesisStreamSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("streamArn", cdk.requiredValidator)(properties.streamArn)), errors.collect(cdk.propertyValidator("streamArn", cdk.validateString)(properties.streamArn)), errors.wrap('supplied properties not correct for "KinesisStreamSpecificationProperty"');
    }
    function cfnTableKinesisStreamSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTable_KinesisStreamSpecificationPropertyValidator(properties).assertSuccess(), { StreamArn: cdk.stringToCloudFormation(properties.streamArn) }) : properties;
    }
    function CfnTableKinesisStreamSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("streamArn", "StreamArn", cfn_parse.FromCloudFormation.getString(properties.StreamArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTable_LocalSecondaryIndexPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("indexName", cdk.requiredValidator)(properties.indexName)), errors.collect(cdk.propertyValidator("indexName", cdk.validateString)(properties.indexName)), errors.collect(cdk.propertyValidator("keySchema", cdk.requiredValidator)(properties.keySchema)), errors.collect(cdk.propertyValidator("keySchema", cdk.listValidator(CfnTable_KeySchemaPropertyValidator))(properties.keySchema)), errors.collect(cdk.propertyValidator("projection", cdk.requiredValidator)(properties.projection)), errors.collect(cdk.propertyValidator("projection", CfnTable_ProjectionPropertyValidator)(properties.projection)), errors.wrap('supplied properties not correct for "LocalSecondaryIndexProperty"');
    }
    function cfnTableLocalSecondaryIndexPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTable_LocalSecondaryIndexPropertyValidator(properties).assertSuccess(), { IndexName: cdk.stringToCloudFormation(properties.indexName), KeySchema: cdk.listMapper(cfnTableKeySchemaPropertyToCloudFormation)(properties.keySchema), Projection: cfnTableProjectionPropertyToCloudFormation(properties.projection) }) : properties;
    }
    function CfnTableLocalSecondaryIndexPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("indexName", "IndexName", cfn_parse.FromCloudFormation.getString(properties.IndexName)), ret.addPropertyResult("keySchema", "KeySchema", cfn_parse.FromCloudFormation.getArray(CfnTableKeySchemaPropertyFromCloudFormation)(properties.KeySchema)), ret.addPropertyResult("projection", "Projection", CfnTableProjectionPropertyFromCloudFormation(properties.Projection)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTable_PointInTimeRecoverySpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("pointInTimeRecoveryEnabled", cdk.validateBoolean)(properties.pointInTimeRecoveryEnabled)), errors.wrap('supplied properties not correct for "PointInTimeRecoverySpecificationProperty"');
    }
    function cfnTablePointInTimeRecoverySpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTable_PointInTimeRecoverySpecificationPropertyValidator(properties).assertSuccess(), { PointInTimeRecoveryEnabled: cdk.booleanToCloudFormation(properties.pointInTimeRecoveryEnabled) }) : properties;
    }
    function CfnTablePointInTimeRecoverySpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("pointInTimeRecoveryEnabled", "PointInTimeRecoveryEnabled", properties.PointInTimeRecoveryEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.PointInTimeRecoveryEnabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTable_ProjectionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("nonKeyAttributes", cdk.listValidator(cdk.validateString))(properties.nonKeyAttributes)), errors.collect(cdk.propertyValidator("projectionType", cdk.validateString)(properties.projectionType)), errors.wrap('supplied properties not correct for "ProjectionProperty"');
    }
    function cfnTableProjectionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTable_ProjectionPropertyValidator(properties).assertSuccess(), { NonKeyAttributes: cdk.listMapper(cdk.stringToCloudFormation)(properties.nonKeyAttributes), ProjectionType: cdk.stringToCloudFormation(properties.projectionType) }) : properties;
    }
    function CfnTableProjectionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("nonKeyAttributes", "NonKeyAttributes", properties.NonKeyAttributes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.NonKeyAttributes) : void 0), ret.addPropertyResult("projectionType", "ProjectionType", properties.ProjectionType != null ? cfn_parse.FromCloudFormation.getString(properties.ProjectionType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTable_ProvisionedThroughputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("readCapacityUnits", cdk.requiredValidator)(properties.readCapacityUnits)), errors.collect(cdk.propertyValidator("readCapacityUnits", cdk.validateNumber)(properties.readCapacityUnits)), errors.collect(cdk.propertyValidator("writeCapacityUnits", cdk.requiredValidator)(properties.writeCapacityUnits)), errors.collect(cdk.propertyValidator("writeCapacityUnits", cdk.validateNumber)(properties.writeCapacityUnits)), errors.wrap('supplied properties not correct for "ProvisionedThroughputProperty"');
    }
    function cfnTableProvisionedThroughputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTable_ProvisionedThroughputPropertyValidator(properties).assertSuccess(), { ReadCapacityUnits: cdk.numberToCloudFormation(properties.readCapacityUnits), WriteCapacityUnits: cdk.numberToCloudFormation(properties.writeCapacityUnits) }) : properties;
    }
    function CfnTableProvisionedThroughputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("readCapacityUnits", "ReadCapacityUnits", cfn_parse.FromCloudFormation.getNumber(properties.ReadCapacityUnits)), ret.addPropertyResult("writeCapacityUnits", "WriteCapacityUnits", cfn_parse.FromCloudFormation.getNumber(properties.WriteCapacityUnits)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTable_S3BucketSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3Bucket", cdk.requiredValidator)(properties.s3Bucket)), errors.collect(cdk.propertyValidator("s3Bucket", cdk.validateString)(properties.s3Bucket)), errors.collect(cdk.propertyValidator("s3BucketOwner", cdk.validateString)(properties.s3BucketOwner)), errors.collect(cdk.propertyValidator("s3KeyPrefix", cdk.validateString)(properties.s3KeyPrefix)), errors.wrap('supplied properties not correct for "S3BucketSourceProperty"');
    }
    function cfnTableS3BucketSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTable_S3BucketSourcePropertyValidator(properties).assertSuccess(), { S3Bucket: cdk.stringToCloudFormation(properties.s3Bucket), S3BucketOwner: cdk.stringToCloudFormation(properties.s3BucketOwner), S3KeyPrefix: cdk.stringToCloudFormation(properties.s3KeyPrefix) }) : properties;
    }
    function CfnTableS3BucketSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Bucket", "S3Bucket", cfn_parse.FromCloudFormation.getString(properties.S3Bucket)), ret.addPropertyResult("s3BucketOwner", "S3BucketOwner", properties.S3BucketOwner != null ? cfn_parse.FromCloudFormation.getString(properties.S3BucketOwner) : void 0), ret.addPropertyResult("s3KeyPrefix", "S3KeyPrefix", properties.S3KeyPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.S3KeyPrefix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTable_SSESpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kmsMasterKeyId", cdk.validateString)(properties.kmsMasterKeyId)), errors.collect(cdk.propertyValidator("sseEnabled", cdk.requiredValidator)(properties.sseEnabled)), errors.collect(cdk.propertyValidator("sseEnabled", cdk.validateBoolean)(properties.sseEnabled)), errors.collect(cdk.propertyValidator("sseType", cdk.validateString)(properties.sseType)), errors.wrap('supplied properties not correct for "SSESpecificationProperty"');
    }
    function cfnTableSSESpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTable_SSESpecificationPropertyValidator(properties).assertSuccess(), { KMSMasterKeyId: cdk.stringToCloudFormation(properties.kmsMasterKeyId), SSEEnabled: cdk.booleanToCloudFormation(properties.sseEnabled), SSEType: cdk.stringToCloudFormation(properties.sseType) }) : properties;
    }
    function CfnTableSSESpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsMasterKeyId", "KMSMasterKeyId", properties.KMSMasterKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KMSMasterKeyId) : void 0), ret.addPropertyResult("sseEnabled", "SSEEnabled", cfn_parse.FromCloudFormation.getBoolean(properties.SSEEnabled)), ret.addPropertyResult("sseType", "SSEType", properties.SSEType != null ? cfn_parse.FromCloudFormation.getString(properties.SSEType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTable_StreamSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("streamViewType", cdk.requiredValidator)(properties.streamViewType)), errors.collect(cdk.propertyValidator("streamViewType", cdk.validateString)(properties.streamViewType)), errors.wrap('supplied properties not correct for "StreamSpecificationProperty"');
    }
    function cfnTableStreamSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTable_StreamSpecificationPropertyValidator(properties).assertSuccess(), { StreamViewType: cdk.stringToCloudFormation(properties.streamViewType) }) : properties;
    }
    function CfnTableStreamSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("streamViewType", "StreamViewType", cfn_parse.FromCloudFormation.getString(properties.StreamViewType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTable_TimeToLiveSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributeName", cdk.requiredValidator)(properties.attributeName)), errors.collect(cdk.propertyValidator("attributeName", cdk.validateString)(properties.attributeName)), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "TimeToLiveSpecificationProperty"');
    }
    function cfnTableTimeToLiveSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTable_TimeToLiveSpecificationPropertyValidator(properties).assertSuccess(), { AttributeName: cdk.stringToCloudFormation(properties.attributeName), Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnTableTimeToLiveSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attributeName", "AttributeName", cfn_parse.FromCloudFormation.getString(properties.AttributeName)), ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-dynamodb/lib/dynamodb-canned-metrics.generated.js
var require_dynamodb_canned_metrics_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-dynamodb/lib/dynamodb-canned-metrics.generated.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DynamoDBMetrics = void 0;
    var DynamoDBMetrics = class {
      static conditionalCheckFailedRequestsSum(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "ConditionalCheckFailedRequests", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static consumedReadCapacityUnitsSum(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "ConsumedReadCapacityUnits", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static consumedWriteCapacityUnitsSum(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "ConsumedWriteCapacityUnits", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static provisionedReadCapacityUnitsAverage(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "ProvisionedReadCapacityUnits", dimensionsMap: dimensions, statistic: "Average" };
      }
      static provisionedWriteCapacityUnitsAverage(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "ProvisionedWriteCapacityUnits", dimensionsMap: dimensions, statistic: "Average" };
      }
      static readThrottleEventsSum(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "ReadThrottleEvents", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static timeToLiveDeletedItemCountSum(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "TimeToLiveDeletedItemCount", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static transactionConflictAverage(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "TransactionConflict", dimensionsMap: dimensions, statistic: "Average" };
      }
      static writeThrottleEventsSum(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "WriteThrottleEvents", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static successfulRequestLatencyAverage(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "SuccessfulRequestLatency", dimensionsMap: dimensions, statistic: "Average" };
      }
      static systemErrorsSum(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "SystemErrors", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static throttledRequestsSum(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "ThrottledRequests", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static returnedItemCountSum(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "ReturnedItemCount", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static onlineIndexConsumedWriteCapacitySum(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "OnlineIndexConsumedWriteCapacity", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static onlineIndexPercentageProgressAverage(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "OnlineIndexPercentageProgress", dimensionsMap: dimensions, statistic: "Average" };
      }
      static onlineIndexThrottleEventsSum(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "OnlineIndexThrottleEvents", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static ageOfOldestUnreplicatedRecordAverage(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "AgeOfOldestUnreplicatedRecord", dimensionsMap: dimensions, statistic: "Average" };
      }
      static consumedChangeDataCaptureUnitsAverage(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "ConsumedChangeDataCaptureUnits", dimensionsMap: dimensions, statistic: "Average" };
      }
      static throttledPutRecordCountAverage(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "ThrottledPutRecordCount", dimensionsMap: dimensions, statistic: "Average" };
      }
      static pendingReplicationCountAverage(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "PendingReplicationCount", dimensionsMap: dimensions, statistic: "Average" };
      }
      static replicationLatencyAverage(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "ReplicationLatency", dimensionsMap: dimensions, statistic: "Average" };
      }
      static returnedBytesAverage(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "ReturnedBytes", dimensionsMap: dimensions, statistic: "Average" };
      }
      static returnedRecordsCountAverage(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "ReturnedRecordsCount", dimensionsMap: dimensions, statistic: "Average" };
      }
      static accountMaxReadsMaximum(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "AccountMaxReads", dimensionsMap: dimensions, statistic: "Maximum" };
      }
      static accountMaxTableLevelReadsMaximum(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "AccountMaxTableLevelReads", dimensionsMap: dimensions, statistic: "Maximum" };
      }
      static accountMaxTableLevelWritesMaximum(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "AccountMaxTableLevelWrites", dimensionsMap: dimensions, statistic: "Maximum" };
      }
      static accountMaxWritesMaximum(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "AccountMaxWrites", dimensionsMap: dimensions, statistic: "Maximum" };
      }
      static accountProvisionedReadCapacityUtilizationAverage(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "AccountProvisionedReadCapacityUtilization", dimensionsMap: dimensions, statistic: "Average" };
      }
      static accountProvisionedWriteCapacityUtilizationAverage(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "AccountProvisionedWriteCapacityUtilization", dimensionsMap: dimensions, statistic: "Average" };
      }
      static maxProvisionedTableReadCapacityUtilizationAverage(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "MaxProvisionedTableReadCapacityUtilization", dimensionsMap: dimensions, statistic: "Average" };
      }
      static maxProvisionedTableWriteCapacityUtilizationAverage(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "MaxProvisionedTableWriteCapacityUtilization", dimensionsMap: dimensions, statistic: "Average" };
      }
      static userErrorsSum(dimensions) {
        return { namespace: "AWS/DynamoDB", metricName: "UserErrors", dimensionsMap: dimensions, statistic: "Sum" };
      }
    };
    exports2.DynamoDBMetrics = DynamoDBMetrics;
  }
});

// node_modules/aws-cdk-lib/aws-dynamodb/lib/perms.js
var require_perms4 = __commonJS({
  "node_modules/aws-cdk-lib/aws-dynamodb/lib/perms.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DESCRIBE_TABLE = exports2.READ_STREAM_DATA_ACTIONS = exports2.KEY_WRITE_ACTIONS = exports2.WRITE_DATA_ACTIONS = exports2.KEY_READ_ACTIONS = exports2.READ_DATA_ACTIONS = void 0, exports2.READ_DATA_ACTIONS = ["dynamodb:BatchGetItem", "dynamodb:GetRecords", "dynamodb:GetShardIterator", "dynamodb:Query", "dynamodb:GetItem", "dynamodb:Scan", "dynamodb:ConditionCheckItem"], exports2.KEY_READ_ACTIONS = ["kms:Decrypt", "kms:DescribeKey"], exports2.WRITE_DATA_ACTIONS = ["dynamodb:BatchWriteItem", "dynamodb:PutItem", "dynamodb:UpdateItem", "dynamodb:DeleteItem"], exports2.KEY_WRITE_ACTIONS = ["kms:Encrypt", "kms:ReEncrypt*", "kms:GenerateDataKey*"], exports2.READ_STREAM_DATA_ACTIONS = ["dynamodb:DescribeStream", "dynamodb:GetRecords", "dynamodb:GetShardIterator"], exports2.DESCRIBE_TABLE = "dynamodb:DescribeTable";
  }
});

// node_modules/aws-cdk-lib/aws-dynamodb/lib/replica-provider.js
var require_replica_provider = __commonJS({
  "node_modules/aws-cdk-lib/aws-dynamodb/lib/replica-provider.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ReplicaProvider = void 0;
    var path = require("path");
    var iam = require_aws_iam();
    var lambda2 = require_aws_lambda();
    var core_1 = require_core2();
    var cr = require_custom_resources();
    var ReplicaProvider = class _ReplicaProvider extends core_1.NestedStack {
      static getOrCreate(scope, props) {
        const stack = core_1.Stack.of(scope), uid = "@aws-cdk/aws-dynamodb.ReplicaProvider";
        return stack.node.tryFindChild(uid) ?? new _ReplicaProvider(stack, uid, props);
      }
      constructor(scope, id, props) {
        super(scope, id);
        const code = lambda2.Code.fromAsset(path.join(__dirname, "replica-handler"));
        this.onEventHandler = new lambda2.Function(this, "OnEventHandler", { code, runtime: lambda2.Runtime.NODEJS_14_X, handler: "index.onEventHandler", timeout: core_1.Duration.minutes(5) }), this.isCompleteHandler = new lambda2.Function(this, "IsCompleteHandler", { code, runtime: lambda2.Runtime.NODEJS_14_X, handler: "index.isCompleteHandler", timeout: core_1.Duration.seconds(30) }), this.onEventHandler.addToRolePolicy(new iam.PolicyStatement({ actions: ["iam:CreateServiceLinkedRole"], resources: [core_1.Stack.of(this).formatArn({ service: "iam", region: "", resource: "role", resourceName: "aws-service-role/replication.dynamodb.amazonaws.com/AWSServiceRoleForDynamoDBReplication" })] })), this.onEventHandler.addToRolePolicy(new iam.PolicyStatement({ actions: ["dynamodb:DescribeLimits"], resources: ["*"] }));
        let resources = [];
        props.regions.forEach((region) => {
          resources.push(`arn:${core_1.Aws.PARTITION}:dynamodb:${region}:${this.account}:table/${props.tableName}`);
        }), this.onEventHandler.addToRolePolicy(new iam.PolicyStatement({ actions: ["dynamodb:DeleteTable", "dynamodb:DeleteTableReplica"], resources })), this.provider = new cr.Provider(this, "Provider", { onEventHandler: this.onEventHandler, isCompleteHandler: this.isCompleteHandler, queryInterval: core_1.Duration.seconds(10), totalTimeout: props.timeout });
      }
    };
    exports2.ReplicaProvider = ReplicaProvider;
  }
});

// node_modules/aws-cdk-lib/aws-dynamodb/lib/scalable-table-attribute.js
var require_scalable_table_attribute = __commonJS({
  "node_modules/aws-cdk-lib/aws-dynamodb/lib/scalable-table-attribute.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ScalableTableAttribute = void 0;
    var appscaling = require_aws_applicationautoscaling();
    var ScalableTableAttribute = class extends appscaling.BaseScalableAttribute {
      constructor() {
        super(...arguments), this.scalingPolicyCreated = false;
      }
      scaleOnSchedule(id, action) {
        this.scalingPolicyCreated = true, super.doScaleOnSchedule(id, action);
      }
      scaleOnUtilization(props) {
        if (props.targetUtilizationPercent < 10 || props.targetUtilizationPercent > 90)
          throw new RangeError(`targetUtilizationPercent for DynamoDB scaling must be between 10 and 90 percent, got: ${props.targetUtilizationPercent}`);
        this.scalingPolicyCreated = true;
        const predefinedMetric = this.props.dimension.indexOf("ReadCapacity") === -1 ? appscaling.PredefinedMetric.DYNAMODB_WRITE_CAPACITY_UTILIZATION : appscaling.PredefinedMetric.DYNAMODB_READ_CAPACITY_UTILIZATION;
        super.doScaleToTrackMetric("Tracking", { policyName: props.policyName, disableScaleIn: props.disableScaleIn, scaleInCooldown: props.scaleInCooldown, scaleOutCooldown: props.scaleOutCooldown, targetValue: props.targetUtilizationPercent, predefinedMetric });
      }
      get _scalingPolicyCreated() {
        return this.scalingPolicyCreated;
      }
    };
    exports2.ScalableTableAttribute = ScalableTableAttribute;
  }
});

// node_modules/aws-cdk-lib/aws-dynamodb/lib/table.js
var require_table2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-dynamodb/lib/table.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.TableClass = exports2.StreamViewType = exports2.ProjectionType = exports2.BillingMode = exports2.AttributeType = exports2.Table = exports2.TableEncryption = exports2.Operation = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var dynamodb_canned_metrics_generated_1 = require_dynamodb_canned_metrics_generated();
    var dynamodb_generated_1 = require_dynamodb_generated();
    var perms = require_perms4();
    var replica_provider_1 = require_replica_provider();
    var scalable_table_attribute_1 = require_scalable_table_attribute();
    var appscaling = require_aws_applicationautoscaling();
    var cloudwatch = require_aws_cloudwatch();
    var iam = require_aws_iam();
    var kms = require_aws_kms();
    var core_1 = require_core2();
    var HASH_KEY_TYPE = "HASH";
    var RANGE_KEY_TYPE = "RANGE";
    var MAX_LOCAL_SECONDARY_INDEX_COUNT = 5;
    var Operation;
    (function(Operation2) {
      Operation2.GET_ITEM = "GetItem", Operation2.BATCH_GET_ITEM = "BatchGetItem", Operation2.SCAN = "Scan", Operation2.QUERY = "Query", Operation2.GET_RECORDS = "GetRecords", Operation2.PUT_ITEM = "PutItem", Operation2.DELETE_ITEM = "DeleteItem", Operation2.UPDATE_ITEM = "UpdateItem", Operation2.BATCH_WRITE_ITEM = "BatchWriteItem", Operation2.TRANSACT_WRITE_ITEMS = "TransactWriteItems", Operation2.TRANSACT_GET_ITEMS = "TransactGetItems", Operation2.EXECUTE_TRANSACTION = "ExecuteTransaction", Operation2.BATCH_EXECUTE_STATEMENT = "BatchExecuteStatement", Operation2.EXECUTE_STATEMENT = "ExecuteStatement";
    })(Operation = exports2.Operation || (exports2.Operation = {}));
    var TableEncryption;
    (function(TableEncryption2) {
      TableEncryption2.DEFAULT = "AWS_OWNED", TableEncryption2.CUSTOMER_MANAGED = "CUSTOMER_MANAGED", TableEncryption2.AWS_MANAGED = "AWS_MANAGED";
    })(TableEncryption = exports2.TableEncryption || (exports2.TableEncryption = {}));
    var TableBase = class extends core_1.Resource {
      constructor() {
        super(...arguments), this.regionalArns = new Array();
      }
      grant(grantee, ...actions) {
        return iam.Grant.addToPrincipal({ grantee, actions, resourceArns: [this.tableArn, core_1.Lazy.string({ produce: () => this.hasIndex ? `${this.tableArn}/index/*` : core_1.Aws.NO_VALUE }), ...this.regionalArns, ...this.regionalArns.map((arn) => core_1.Lazy.string({ produce: () => this.hasIndex ? `${arn}/index/*` : core_1.Aws.NO_VALUE }))], scope: this });
      }
      grantStream(grantee, ...actions) {
        if (!this.tableStreamArn)
          throw new Error(`DynamoDB Streams must be enabled on the table ${this.node.path}`);
        return iam.Grant.addToPrincipal({ grantee, actions, resourceArns: [this.tableStreamArn], scope: this });
      }
      grantReadData(grantee) {
        const tableActions = perms.READ_DATA_ACTIONS.concat(perms.DESCRIBE_TABLE);
        return this.combinedGrant(grantee, { keyActions: perms.KEY_READ_ACTIONS, tableActions });
      }
      grantTableListStreams(grantee) {
        if (!this.tableStreamArn)
          throw new Error(`DynamoDB Streams must be enabled on the table ${this.node.path}`);
        return iam.Grant.addToPrincipal({ grantee, actions: ["dynamodb:ListStreams"], resourceArns: ["*"] });
      }
      grantStreamRead(grantee) {
        return this.grantTableListStreams(grantee), this.combinedGrant(grantee, { keyActions: perms.KEY_READ_ACTIONS, streamActions: perms.READ_STREAM_DATA_ACTIONS });
      }
      grantWriteData(grantee) {
        const tableActions = perms.WRITE_DATA_ACTIONS.concat(perms.DESCRIBE_TABLE), keyActions = perms.KEY_READ_ACTIONS.concat(perms.KEY_WRITE_ACTIONS);
        return this.combinedGrant(grantee, { keyActions, tableActions });
      }
      grantReadWriteData(grantee) {
        const tableActions = perms.READ_DATA_ACTIONS.concat(perms.WRITE_DATA_ACTIONS).concat(perms.DESCRIBE_TABLE), keyActions = perms.KEY_READ_ACTIONS.concat(perms.KEY_WRITE_ACTIONS);
        return this.combinedGrant(grantee, { keyActions, tableActions });
      }
      grantFullAccess(grantee) {
        const keyActions = perms.KEY_READ_ACTIONS.concat(perms.KEY_WRITE_ACTIONS);
        return this.combinedGrant(grantee, { keyActions, tableActions: ["dynamodb:*"] });
      }
      metric(metricName, props) {
        return new cloudwatch.Metric({ namespace: "AWS/DynamoDB", metricName, dimensionsMap: { TableName: this.tableName }, ...props }).attachTo(this);
      }
      metricConsumedReadCapacityUnits(props) {
        return this.cannedMetric(dynamodb_canned_metrics_generated_1.DynamoDBMetrics.consumedReadCapacityUnitsSum, props);
      }
      metricConsumedWriteCapacityUnits(props) {
        return this.cannedMetric(dynamodb_canned_metrics_generated_1.DynamoDBMetrics.consumedWriteCapacityUnitsSum, props);
      }
      metricSystemErrors(props) {
        if (!props?.dimensions?.Operation && !props?.dimensionsMap?.Operation)
          throw new Error("'Operation' dimension must be passed for the 'SystemErrors' metric.");
        const dimensionsMap = { TableName: this.tableName, ...props?.dimensions ?? {}, ...props?.dimensionsMap ?? {} };
        return this.metric("SystemErrors", { statistic: "sum", ...props, dimensionsMap });
      }
      metricUserErrors(props) {
        if (props?.dimensions)
          throw new Error("'dimensions' is not supported for the 'UserErrors' metric");
        return this.metric("UserErrors", { statistic: "sum", ...props, dimensionsMap: {} });
      }
      metricConditionalCheckFailedRequests(props) {
        return this.metric("ConditionalCheckFailedRequests", { statistic: "sum", ...props });
      }
      metricThrottledRequests(props) {
        return this.metric("ThrottledRequests", { statistic: "sum", ...props });
      }
      metricSuccessfulRequestLatency(props) {
        if (!props?.dimensions?.Operation && !props?.dimensionsMap?.Operation)
          throw new Error("'Operation' dimension must be passed for the 'SuccessfulRequestLatency' metric.");
        const dimensionsMap = { TableName: this.tableName, Operation: props.dimensionsMap?.Operation ?? props.dimensions?.Operation };
        return new cloudwatch.Metric({ ...dynamodb_canned_metrics_generated_1.DynamoDBMetrics.successfulRequestLatencyAverage(dimensionsMap), ...props, dimensionsMap }).attachTo(this);
      }
      metricThrottledRequestsForOperation(operation, props) {
        return new cloudwatch.Metric({ ...dynamodb_canned_metrics_generated_1.DynamoDBMetrics.throttledRequestsSum({ Operation: operation, TableName: this.tableName }), ...props }).attachTo(this);
      }
      metricThrottledRequestsForOperations(props) {
        return this.sumMetricsForOperations("ThrottledRequests", "Sum of throttled requests across all operations", props);
      }
      metricSystemErrorsForOperations(props) {
        return this.sumMetricsForOperations("SystemErrors", "Sum of errors across all operations", props);
      }
      sumMetricsForOperations(metricName, expressionLabel, props) {
        if (props?.dimensions?.Operation)
          throw new Error("The Operation dimension is not supported. Use the 'operations' property.");
        const operations = props?.operations ?? Object.values(Operation), values = this.createMetricsForOperations(metricName, operations, { statistic: "sum", ...props });
        return new cloudwatch.MathExpression({ expression: `${Object.keys(values).join(" + ")}`, usingMetrics: { ...values }, color: props?.color, label: expressionLabel, period: props?.period });
      }
      createMetricsForOperations(metricName, operations, props, metricNameMapper) {
        const metrics = {}, mapper = metricNameMapper ?? ((op) => op.toLowerCase());
        if (props?.dimensions?.Operation)
          throw new Error("Invalid properties. Operation dimension is not supported when calculating operational metrics");
        for (const operation of operations) {
          const metric = this.metric(metricName, { ...props, dimensionsMap: { TableName: this.tableName, Operation: operation, ...props?.dimensions } }), operationMetricName = mapper(operation), firstChar = operationMetricName.charAt(0);
          if (firstChar === firstChar.toUpperCase())
            throw new Error(`Mapper generated an illegal operation metric name: ${operationMetricName}. Must start with a lowercase letter`);
          metrics[operationMetricName] = metric;
        }
        return metrics;
      }
      combinedGrant(grantee, opts) {
        if (this.encryptionKey && opts.keyActions && this.encryptionKey.grant(grantee, ...opts.keyActions), opts.tableActions) {
          const resources = [this.tableArn, core_1.Lazy.string({ produce: () => this.hasIndex ? `${this.tableArn}/index/*` : core_1.Aws.NO_VALUE }), ...this.regionalArns, ...this.regionalArns.map((arn) => core_1.Lazy.string({ produce: () => this.hasIndex ? `${arn}/index/*` : core_1.Aws.NO_VALUE }))];
          return iam.Grant.addToPrincipal({ grantee, actions: opts.tableActions, resourceArns: resources, scope: this });
        }
        if (opts.streamActions) {
          if (!this.tableStreamArn)
            throw new Error(`DynamoDB Streams must be enabled on the table ${this.node.path}`);
          const resources = [this.tableStreamArn];
          return iam.Grant.addToPrincipal({ grantee, actions: opts.streamActions, resourceArns: resources, scope: this });
        }
        throw new Error(`Unexpected 'action', ${opts.tableActions || opts.streamActions}`);
      }
      cannedMetric(fn, props) {
        return new cloudwatch.Metric({ ...fn({ TableName: this.tableName }), ...props }).attachTo(this);
      }
    };
    var Table = class _Table extends TableBase {
      static grantListStreams(grantee) {
        return iam.Grant.addToPrincipal({ grantee, actions: ["dynamodb:ListStreams"], resourceArns: ["*"] });
      }
      static fromTableName(scope, id, tableName) {
        return _Table.fromTableAttributes(scope, id, { tableName });
      }
      static fromTableArn(scope, id, tableArn) {
        return _Table.fromTableAttributes(scope, id, { tableArn });
      }
      static fromTableAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_dynamodb_TableAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromTableAttributes), error;
        }
        class Import extends TableBase {
          constructor(_tableArn, tableName, tableStreamArn) {
            super(scope, id), this.hasIndex = (attrs.grantIndexPermissions ?? false) || (attrs.globalIndexes ?? []).length > 0 || (attrs.localIndexes ?? []).length > 0, this.tableArn = _tableArn, this.tableName = tableName, this.tableStreamArn = tableStreamArn, this.encryptionKey = attrs.encryptionKey;
          }
        }
        let name, arn;
        const stack = core_1.Stack.of(scope);
        if (attrs.tableName) {
          if (attrs.tableArn)
            throw new Error("Only one of tableArn or tableName can be provided");
          name = attrs.tableName, arn = stack.formatArn({ service: "dynamodb", resource: "table", resourceName: attrs.tableName });
        } else {
          if (!attrs.tableArn)
            throw new Error("One of tableName or tableArn is required!");
          arn = attrs.tableArn;
          const maybeTableName = stack.splitArn(attrs.tableArn, core_1.ArnFormat.SLASH_RESOURCE_NAME).resourceName;
          if (!maybeTableName)
            throw new Error("ARN for DynamoDB table must be in the form: ...");
          name = maybeTableName;
        }
        return new Import(arn, name, attrs.tableStreamArn);
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.tableName }), this.keySchema = new Array(), this.attributeDefinitions = new Array(), this.globalSecondaryIndexes = new Array(), this.localSecondaryIndexes = new Array(), this.secondaryIndexSchemas = /* @__PURE__ */ new Map(), this.nonKeyAttributes = /* @__PURE__ */ new Set(), this.tableScaling = {}, this.indexScaling = /* @__PURE__ */ new Map(), this.globalReplicaCustomResources = new Array();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_dynamodb_TableProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Table), error;
        }
        const { sseSpecification, encryptionKey } = this.parseEncryption(props);
        let streamSpecification;
        if (props.replicationRegions) {
          if (props.stream && props.stream !== StreamViewType.NEW_AND_OLD_IMAGES)
            throw new Error("`stream` must be set to `NEW_AND_OLD_IMAGES` when specifying `replicationRegions`");
          streamSpecification = { streamViewType: StreamViewType.NEW_AND_OLD_IMAGES }, this.billingMode = props.billingMode ?? BillingMode.PAY_PER_REQUEST;
        } else
          this.billingMode = props.billingMode ?? BillingMode.PROVISIONED, props.stream && (streamSpecification = { streamViewType: props.stream });
        this.validateProvisioning(props), this.table = new dynamodb_generated_1.CfnTable(this, "Resource", { tableName: this.physicalName, keySchema: this.keySchema, attributeDefinitions: this.attributeDefinitions, globalSecondaryIndexes: core_1.Lazy.any({ produce: () => this.globalSecondaryIndexes }, { omitEmptyArray: true }), localSecondaryIndexes: core_1.Lazy.any({ produce: () => this.localSecondaryIndexes }, { omitEmptyArray: true }), pointInTimeRecoverySpecification: props.pointInTimeRecovery != null ? { pointInTimeRecoveryEnabled: props.pointInTimeRecovery } : void 0, billingMode: this.billingMode === BillingMode.PAY_PER_REQUEST ? this.billingMode : void 0, provisionedThroughput: this.billingMode === BillingMode.PAY_PER_REQUEST ? void 0 : { readCapacityUnits: props.readCapacity || 5, writeCapacityUnits: props.writeCapacity || 5 }, sseSpecification, streamSpecification, tableClass: props.tableClass, timeToLiveSpecification: props.timeToLiveAttribute ? { attributeName: props.timeToLiveAttribute, enabled: true } : void 0, contributorInsightsSpecification: props.contributorInsightsEnabled !== void 0 ? { enabled: props.contributorInsightsEnabled } : void 0, kinesisStreamSpecification: props.kinesisStream ? { streamArn: props.kinesisStream.streamArn } : void 0, deletionProtectionEnabled: props.deletionProtection }), this.table.applyRemovalPolicy(props.removalPolicy), this.encryptionKey = encryptionKey, this.tableArn = this.getResourceArnAttribute(this.table.attrArn, { service: "dynamodb", resource: "table", resourceName: this.physicalName }), this.tableName = this.getResourceNameAttribute(this.table.ref), props.tableName && this.node.addMetadata("aws:cdk:hasPhysicalName", this.tableName), this.tableStreamArn = streamSpecification ? this.table.attrStreamArn : void 0, this.scalingRole = this.makeScalingRole(), this.addKey(props.partitionKey, HASH_KEY_TYPE), this.tablePartitionKey = props.partitionKey, props.sortKey && (this.addKey(props.sortKey, RANGE_KEY_TYPE), this.tableSortKey = props.sortKey), props.replicationRegions && props.replicationRegions.length > 0 && this.createReplicaTables(props.replicationRegions, props.replicationTimeout, props.waitForReplicationToFinish), this.node.addValidation({ validate: () => this.validateTable() });
      }
      addGlobalSecondaryIndex(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_dynamodb_GlobalSecondaryIndexProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addGlobalSecondaryIndex), error;
        }
        this.validateProvisioning(props), this.validateIndexName(props.indexName);
        const gsiKeySchema = this.buildIndexKeySchema(props.partitionKey, props.sortKey), gsiProjection = this.buildIndexProjection(props);
        this.globalSecondaryIndexes.push({ indexName: props.indexName, keySchema: gsiKeySchema, projection: gsiProjection, provisionedThroughput: this.billingMode === BillingMode.PAY_PER_REQUEST ? void 0 : { readCapacityUnits: props.readCapacity || 5, writeCapacityUnits: props.writeCapacity || 5 } }), this.secondaryIndexSchemas.set(props.indexName, { partitionKey: props.partitionKey, sortKey: props.sortKey }), this.indexScaling.set(props.indexName, {});
      }
      addLocalSecondaryIndex(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_dynamodb_LocalSecondaryIndexProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addLocalSecondaryIndex), error;
        }
        if (this.localSecondaryIndexes.length >= MAX_LOCAL_SECONDARY_INDEX_COUNT)
          throw new RangeError(`a maximum number of local secondary index per table is ${MAX_LOCAL_SECONDARY_INDEX_COUNT}`);
        this.validateIndexName(props.indexName);
        const lsiKeySchema = this.buildIndexKeySchema(this.tablePartitionKey, props.sortKey), lsiProjection = this.buildIndexProjection(props);
        this.localSecondaryIndexes.push({ indexName: props.indexName, keySchema: lsiKeySchema, projection: lsiProjection }), this.secondaryIndexSchemas.set(props.indexName, { partitionKey: this.tablePartitionKey, sortKey: props.sortKey });
      }
      autoScaleReadCapacity(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_dynamodb_EnableScalingProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.autoScaleReadCapacity), error;
        }
        if (this.tableScaling.scalableReadAttribute)
          throw new Error("Read AutoScaling already enabled for this table");
        if (this.billingMode === BillingMode.PAY_PER_REQUEST)
          throw new Error("AutoScaling is not available for tables with PAY_PER_REQUEST billing mode");
        return this.tableScaling.scalableReadAttribute = new scalable_table_attribute_1.ScalableTableAttribute(this, "ReadScaling", { serviceNamespace: appscaling.ServiceNamespace.DYNAMODB, resourceId: `table/${this.tableName}`, dimension: "dynamodb:table:ReadCapacityUnits", role: this.scalingRole, ...props });
      }
      autoScaleWriteCapacity(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_dynamodb_EnableScalingProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.autoScaleWriteCapacity), error;
        }
        if (this.tableScaling.scalableWriteAttribute)
          throw new Error("Write AutoScaling already enabled for this table");
        if (this.billingMode === BillingMode.PAY_PER_REQUEST)
          throw new Error("AutoScaling is not available for tables with PAY_PER_REQUEST billing mode");
        this.tableScaling.scalableWriteAttribute = new scalable_table_attribute_1.ScalableTableAttribute(this, "WriteScaling", { serviceNamespace: appscaling.ServiceNamespace.DYNAMODB, resourceId: `table/${this.tableName}`, dimension: "dynamodb:table:WriteCapacityUnits", role: this.scalingRole, ...props });
        for (const globalReplicaCustomResource of this.globalReplicaCustomResources)
          globalReplicaCustomResource.node.addDependency(this.tableScaling.scalableWriteAttribute);
        return this.tableScaling.scalableWriteAttribute;
      }
      autoScaleGlobalSecondaryIndexReadCapacity(indexName, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_dynamodb_EnableScalingProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.autoScaleGlobalSecondaryIndexReadCapacity), error;
        }
        if (this.billingMode === BillingMode.PAY_PER_REQUEST)
          throw new Error("AutoScaling is not available for tables with PAY_PER_REQUEST billing mode");
        const attributePair = this.indexScaling.get(indexName);
        if (!attributePair)
          throw new Error(`No global secondary index with name ${indexName}`);
        if (attributePair.scalableReadAttribute)
          throw new Error("Read AutoScaling already enabled for this index");
        return attributePair.scalableReadAttribute = new scalable_table_attribute_1.ScalableTableAttribute(this, `${indexName}ReadScaling`, { serviceNamespace: appscaling.ServiceNamespace.DYNAMODB, resourceId: `table/${this.tableName}/index/${indexName}`, dimension: "dynamodb:index:ReadCapacityUnits", role: this.scalingRole, ...props });
      }
      autoScaleGlobalSecondaryIndexWriteCapacity(indexName, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_dynamodb_EnableScalingProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.autoScaleGlobalSecondaryIndexWriteCapacity), error;
        }
        if (this.billingMode === BillingMode.PAY_PER_REQUEST)
          throw new Error("AutoScaling is not available for tables with PAY_PER_REQUEST billing mode");
        const attributePair = this.indexScaling.get(indexName);
        if (!attributePair)
          throw new Error(`No global secondary index with name ${indexName}`);
        if (attributePair.scalableWriteAttribute)
          throw new Error("Write AutoScaling already enabled for this index");
        return attributePair.scalableWriteAttribute = new scalable_table_attribute_1.ScalableTableAttribute(this, `${indexName}WriteScaling`, { serviceNamespace: appscaling.ServiceNamespace.DYNAMODB, resourceId: `table/${this.tableName}/index/${indexName}`, dimension: "dynamodb:index:WriteCapacityUnits", role: this.scalingRole, ...props });
      }
      schema(indexName) {
        if (!indexName)
          return { partitionKey: this.tablePartitionKey, sortKey: this.tableSortKey };
        let schema = this.secondaryIndexSchemas.get(indexName);
        if (!schema)
          throw new Error(`Cannot find schema for index: ${indexName}. Use 'addGlobalSecondaryIndex' or 'addLocalSecondaryIndex' to add index`);
        return schema;
      }
      validateTable() {
        const errors = new Array();
        if (this.tablePartitionKey || errors.push("a partition key must be specified"), this.localSecondaryIndexes.length > 0 && !this.tableSortKey && errors.push("a sort key of the table must be specified to add local secondary indexes"), this.globalReplicaCustomResources.length > 0 && this.billingMode === BillingMode.PROVISIONED) {
          const writeAutoScaleAttribute = this.tableScaling.scalableWriteAttribute;
          writeAutoScaleAttribute ? writeAutoScaleAttribute._scalingPolicyCreated || errors.push("A global Table that uses PROVISIONED as the billing mode needs auto-scaled write capacity with a policy. Call one of the scaleOn*() methods of the object returned from autoScaleWriteCapacity()") : errors.push("A global Table that uses PROVISIONED as the billing mode needs auto-scaled write capacity. Use the autoScaleWriteCapacity() method to enable it.");
        }
        return errors;
      }
      validateProvisioning(props) {
        if (this.billingMode === BillingMode.PAY_PER_REQUEST && (props.readCapacity !== void 0 || props.writeCapacity !== void 0))
          throw new Error("you cannot provision read and write capacity for a table with PAY_PER_REQUEST billing mode");
      }
      validateIndexName(indexName) {
        if (this.secondaryIndexSchemas.has(indexName))
          throw new Error(`a duplicate index name, ${indexName}, is not allowed`);
      }
      validateNonKeyAttributes(nonKeyAttributes) {
        if (this.nonKeyAttributes.size + nonKeyAttributes.length > 100)
          throw new RangeError("a maximum number of nonKeyAttributes across all of secondary indexes is 100");
        nonKeyAttributes.forEach((att) => this.nonKeyAttributes.add(att));
      }
      buildIndexKeySchema(partitionKey, sortKey) {
        this.registerAttribute(partitionKey);
        const indexKeySchema = [{ attributeName: partitionKey.name, keyType: HASH_KEY_TYPE }];
        return sortKey && (this.registerAttribute(sortKey), indexKeySchema.push({ attributeName: sortKey.name, keyType: RANGE_KEY_TYPE })), indexKeySchema;
      }
      buildIndexProjection(props) {
        if (props.projectionType === ProjectionType.INCLUDE && !props.nonKeyAttributes)
          throw new Error(`non-key attributes should be specified when using ${ProjectionType.INCLUDE} projection type`);
        if (props.projectionType !== ProjectionType.INCLUDE && props.nonKeyAttributes)
          throw new Error(`non-key attributes should not be specified when not using ${ProjectionType.INCLUDE} projection type`);
        return props.nonKeyAttributes && this.validateNonKeyAttributes(props.nonKeyAttributes), { projectionType: props.projectionType ?? ProjectionType.ALL, nonKeyAttributes: props.nonKeyAttributes ?? void 0 };
      }
      findKey(keyType) {
        return this.keySchema.find((prop) => prop.keyType === keyType);
      }
      addKey(attribute, keyType) {
        const existingProp = this.findKey(keyType);
        if (existingProp)
          throw new Error(`Unable to set ${attribute.name} as a ${keyType} key, because ${existingProp.attributeName} is a ${keyType} key`);
        return this.registerAttribute(attribute), this.keySchema.push({ attributeName: attribute.name, keyType }), this;
      }
      registerAttribute(attribute) {
        const { name, type } = attribute, existingDef = this.attributeDefinitions.find((def) => def.attributeName === name);
        if (existingDef && existingDef.attributeType !== type)
          throw new Error(`Unable to specify ${name} as ${type} because it was already defined as ${existingDef.attributeType}`);
        existingDef || this.attributeDefinitions.push({ attributeName: name, attributeType: type });
      }
      makeScalingRole() {
        return iam.Role.fromRoleArn(this, "ScalingRole", core_1.Stack.of(this).formatArn({ service: "iam", region: "", resource: "role/aws-service-role/dynamodb.application-autoscaling.amazonaws.com", resourceName: "AWSServiceRoleForApplicationAutoScaling_DynamoDBTable" }));
      }
      createReplicaTables(regions, timeout, waitForReplicationToFinish) {
        const stack = core_1.Stack.of(this);
        if (!core_1.Token.isUnresolved(stack.region) && regions.includes(stack.region))
          throw new Error("`replicationRegions` cannot include the region where this stack is deployed.");
        const provider = replica_provider_1.ReplicaProvider.getOrCreate(this, { tableName: this.tableName, regions, timeout }), onEventHandlerPolicy = new SourceTableAttachedPolicy(this, provider.onEventHandler.role), isCompleteHandlerPolicy = new SourceTableAttachedPolicy(this, provider.isCompleteHandler.role);
        this.grant(onEventHandlerPolicy, "dynamodb:*"), this.grant(isCompleteHandlerPolicy, "dynamodb:DescribeTable");
        let previousRegion, previousRegionCondition;
        for (const region of new Set(regions)) {
          const currentRegion = new core_1.CustomResource(this, `Replica${region}`, { serviceToken: provider.provider.serviceToken, resourceType: "Custom::DynamoDBReplica", properties: { TableName: this.tableName, Region: region, SkipReplicationCompletedWait: waitForReplicationToFinish == null ? void 0 : (!waitForReplicationToFinish).toString() } });
          currentRegion.node.addDependency(onEventHandlerPolicy.policy, isCompleteHandlerPolicy.policy), this.globalReplicaCustomResources.push(currentRegion);
          let createReplica;
          if (core_1.Token.isUnresolved(stack.region)) {
            createReplica = new core_1.CfnCondition(this, `StackRegionNotEquals${region}`, { expression: core_1.Fn.conditionNot(core_1.Fn.conditionEquals(region, core_1.Aws.REGION)) });
            const cfnCustomResource = currentRegion.node.defaultChild;
            cfnCustomResource.cfnOptions.condition = createReplica;
          }
          if (this.regionalArns.push(stack.formatArn({ region, service: "dynamodb", resource: "table", resourceName: this.tableName })), previousRegion)
            if (previousRegionCondition) {
              const previousRegionCfnResource = previousRegion.node.defaultChild;
              currentRegion.node.defaultChild.addMetadata("DynamoDbReplicationDependency", core_1.Fn.conditionIf(previousRegionCondition.logicalId, previousRegionCfnResource.ref, core_1.Aws.NO_VALUE));
            } else
              currentRegion.node.addDependency(previousRegion);
          previousRegion = currentRegion, previousRegionCondition = createReplica;
        }
        onEventHandlerPolicy.grantPrincipal.addToPrincipalPolicy(new iam.PolicyStatement({ actions: ["dynamodb:*"], resources: this.regionalArns }));
      }
      get hasIndex() {
        return this.globalSecondaryIndexes.length + this.localSecondaryIndexes.length > 0;
      }
      parseEncryption(props) {
        let encryptionType = props.encryption;
        if (encryptionType != null && props.serverSideEncryption != null)
          throw new Error("Only one of encryption and serverSideEncryption can be specified, but both were provided");
        if (props.serverSideEncryption && props.encryptionKey)
          throw new Error("encryptionKey cannot be specified when serverSideEncryption is specified. Use encryption instead");
        if (encryptionType === void 0 && (encryptionType = props.encryptionKey != null ? TableEncryption.CUSTOMER_MANAGED : props.serverSideEncryption ? TableEncryption.AWS_MANAGED : void 0), encryptionType !== TableEncryption.CUSTOMER_MANAGED && props.encryptionKey)
          throw new Error("`encryptionKey cannot be specified unless encryption is set to TableEncryption.CUSTOMER_MANAGED (it was set to ${encryptionType})`");
        if (encryptionType === TableEncryption.CUSTOMER_MANAGED && props.replicationRegions)
          throw new Error("TableEncryption.CUSTOMER_MANAGED is not supported by DynamoDB Global Tables (where replicationRegions was set)");
        switch (encryptionType) {
          case TableEncryption.CUSTOMER_MANAGED:
            const encryptionKey = props.encryptionKey ?? new kms.Key(this, "Key", { description: `Customer-managed key auto-created for encrypting DynamoDB table at ${this.node.path}`, enableKeyRotation: true });
            return { sseSpecification: { sseEnabled: true, kmsMasterKeyId: encryptionKey.keyArn, sseType: "KMS" }, encryptionKey };
          case TableEncryption.AWS_MANAGED:
            return { sseSpecification: { sseEnabled: true } };
          case TableEncryption.DEFAULT:
            return { sseSpecification: { sseEnabled: false } };
          case void 0:
            return { sseSpecification: void 0 };
          default:
            throw new Error(`Unexpected 'encryptionType': ${encryptionType}`);
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Table[_a] = { fqn: "aws-cdk-lib.aws_dynamodb.Table", version: "2.80.0" }, exports2.Table = Table;
    var AttributeType;
    (function(AttributeType2) {
      AttributeType2.BINARY = "B", AttributeType2.NUMBER = "N", AttributeType2.STRING = "S";
    })(AttributeType = exports2.AttributeType || (exports2.AttributeType = {}));
    var BillingMode;
    (function(BillingMode2) {
      BillingMode2.PAY_PER_REQUEST = "PAY_PER_REQUEST", BillingMode2.PROVISIONED = "PROVISIONED";
    })(BillingMode = exports2.BillingMode || (exports2.BillingMode = {}));
    var ProjectionType;
    (function(ProjectionType2) {
      ProjectionType2.KEYS_ONLY = "KEYS_ONLY", ProjectionType2.INCLUDE = "INCLUDE", ProjectionType2.ALL = "ALL";
    })(ProjectionType = exports2.ProjectionType || (exports2.ProjectionType = {}));
    var StreamViewType;
    (function(StreamViewType2) {
      StreamViewType2.NEW_IMAGE = "NEW_IMAGE", StreamViewType2.OLD_IMAGE = "OLD_IMAGE", StreamViewType2.NEW_AND_OLD_IMAGES = "NEW_AND_OLD_IMAGES", StreamViewType2.KEYS_ONLY = "KEYS_ONLY";
    })(StreamViewType = exports2.StreamViewType || (exports2.StreamViewType = {}));
    var TableClass;
    (function(TableClass2) {
      TableClass2.STANDARD = "STANDARD", TableClass2.STANDARD_INFREQUENT_ACCESS = "STANDARD_INFREQUENT_ACCESS";
    })(TableClass = exports2.TableClass || (exports2.TableClass = {}));
    var SourceTableAttachedPolicy = class extends constructs_1.Construct {
      constructor(sourceTable, role) {
        super(sourceTable, `SourceTableAttachedManagedPolicy-${core_1.Names.nodeUniqueId(role.node)}`);
        const policy = new iam.ManagedPolicy(this, "Resource", { description: `DynamoDB replication managed policy for table ${sourceTable.tableName}`, roles: [role] });
        this.policy = policy, this.grantPrincipal = new SourceTableAttachedPrincipal(role, policy);
      }
    };
    var SourceTableAttachedPrincipal = class extends iam.PrincipalBase {
      constructor(role, policy) {
        super(), this.role = role, this.policy = policy;
      }
      get policyFragment() {
        return this.role.policyFragment;
      }
      addToPrincipalPolicy(statement) {
        return this.policy.addStatements(statement), { policyDependable: this.policy, statementAdded: true };
      }
      dedupeString() {
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-dynamodb/lib/scalable-attribute-api.js
var require_scalable_attribute_api2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-dynamodb/lib/scalable-attribute-api.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-dynamodb/lib/index.js
var require_lib58 = __commonJS({
  "node_modules/aws-cdk-lib/aws-dynamodb/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_dynamodb_generated(), exports2), __exportStar(require_table2(), exports2), __exportStar(require_scalable_attribute_api2(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-dynamodb/index.js
var require_aws_dynamodb = __commonJS({
  "node_modules/aws-cdk-lib/aws-dynamodb/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib58(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-efs/lib/efs.generated.js
var require_efs_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-efs/lib/efs.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnMountTarget = exports2.CfnFileSystem = exports2.CfnAccessPoint = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAccessPointPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessPointTags", cdk.listValidator(CfnAccessPoint_AccessPointTagPropertyValidator))(properties.accessPointTags)), errors.collect(cdk.propertyValidator("clientToken", cdk.validateString)(properties.clientToken)), errors.collect(cdk.propertyValidator("fileSystemId", cdk.requiredValidator)(properties.fileSystemId)), errors.collect(cdk.propertyValidator("fileSystemId", cdk.validateString)(properties.fileSystemId)), errors.collect(cdk.propertyValidator("posixUser", CfnAccessPoint_PosixUserPropertyValidator)(properties.posixUser)), errors.collect(cdk.propertyValidator("rootDirectory", CfnAccessPoint_RootDirectoryPropertyValidator)(properties.rootDirectory)), errors.wrap('supplied properties not correct for "CfnAccessPointProps"');
    }
    function cfnAccessPointPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccessPointPropsValidator(properties).assertSuccess(), { FileSystemId: cdk.stringToCloudFormation(properties.fileSystemId), AccessPointTags: cdk.listMapper(cfnAccessPointAccessPointTagPropertyToCloudFormation)(properties.accessPointTags), ClientToken: cdk.stringToCloudFormation(properties.clientToken), PosixUser: cfnAccessPointPosixUserPropertyToCloudFormation(properties.posixUser), RootDirectory: cfnAccessPointRootDirectoryPropertyToCloudFormation(properties.rootDirectory) }) : properties;
    }
    function CfnAccessPointPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fileSystemId", "FileSystemId", cfn_parse.FromCloudFormation.getString(properties.FileSystemId)), ret.addPropertyResult("accessPointTags", "AccessPointTags", properties.AccessPointTags != null ? cfn_parse.FromCloudFormation.getArray(CfnAccessPointAccessPointTagPropertyFromCloudFormation)(properties.AccessPointTags) : void 0), ret.addPropertyResult("clientToken", "ClientToken", properties.ClientToken != null ? cfn_parse.FromCloudFormation.getString(properties.ClientToken) : void 0), ret.addPropertyResult("posixUser", "PosixUser", properties.PosixUser != null ? CfnAccessPointPosixUserPropertyFromCloudFormation(properties.PosixUser) : void 0), ret.addPropertyResult("rootDirectory", "RootDirectory", properties.RootDirectory != null ? CfnAccessPointRootDirectoryPropertyFromCloudFormation(properties.RootDirectory) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAccessPoint = class _CfnAccessPoint extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAccessPointPropsFromCloudFormation(resourceProperties), ret = new _CfnAccessPoint(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAccessPoint.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_efs_CfnAccessPointProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAccessPoint), error;
        }
        cdk.requireProperty(props, "fileSystemId", this), this.attrAccessPointId = cdk.Token.asString(this.getAtt("AccessPointId", cdk.ResolutionTypeHint.STRING)), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.fileSystemId = props.fileSystemId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EFS::AccessPoint", props.accessPointTags, { tagPropertyName: "accessPointTags" }), this.clientToken = props.clientToken, this.posixUser = props.posixUser, this.rootDirectory = props.rootDirectory;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAccessPoint.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { fileSystemId: this.fileSystemId, accessPointTags: this.tags.renderTags(), clientToken: this.clientToken, posixUser: this.posixUser, rootDirectory: this.rootDirectory };
      }
      renderProperties(props) {
        return cfnAccessPointPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAccessPoint[_a] = { fqn: "aws-cdk-lib.aws_efs.CfnAccessPoint", version: "2.80.0" }, CfnAccessPoint.CFN_RESOURCE_TYPE_NAME = "AWS::EFS::AccessPoint", exports2.CfnAccessPoint = CfnAccessPoint;
    function CfnAccessPoint_AccessPointTagPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "AccessPointTagProperty"');
    }
    function cfnAccessPointAccessPointTagPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccessPoint_AccessPointTagPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnAccessPointAccessPointTagPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAccessPoint_CreationInfoPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ownerGid", cdk.requiredValidator)(properties.ownerGid)), errors.collect(cdk.propertyValidator("ownerGid", cdk.validateString)(properties.ownerGid)), errors.collect(cdk.propertyValidator("ownerUid", cdk.requiredValidator)(properties.ownerUid)), errors.collect(cdk.propertyValidator("ownerUid", cdk.validateString)(properties.ownerUid)), errors.collect(cdk.propertyValidator("permissions", cdk.requiredValidator)(properties.permissions)), errors.collect(cdk.propertyValidator("permissions", cdk.validateString)(properties.permissions)), errors.wrap('supplied properties not correct for "CreationInfoProperty"');
    }
    function cfnAccessPointCreationInfoPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccessPoint_CreationInfoPropertyValidator(properties).assertSuccess(), { OwnerGid: cdk.stringToCloudFormation(properties.ownerGid), OwnerUid: cdk.stringToCloudFormation(properties.ownerUid), Permissions: cdk.stringToCloudFormation(properties.permissions) }) : properties;
    }
    function CfnAccessPointCreationInfoPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ownerGid", "OwnerGid", cfn_parse.FromCloudFormation.getString(properties.OwnerGid)), ret.addPropertyResult("ownerUid", "OwnerUid", cfn_parse.FromCloudFormation.getString(properties.OwnerUid)), ret.addPropertyResult("permissions", "Permissions", cfn_parse.FromCloudFormation.getString(properties.Permissions)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAccessPoint_PosixUserPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("gid", cdk.requiredValidator)(properties.gid)), errors.collect(cdk.propertyValidator("gid", cdk.validateString)(properties.gid)), errors.collect(cdk.propertyValidator("secondaryGids", cdk.listValidator(cdk.validateString))(properties.secondaryGids)), errors.collect(cdk.propertyValidator("uid", cdk.requiredValidator)(properties.uid)), errors.collect(cdk.propertyValidator("uid", cdk.validateString)(properties.uid)), errors.wrap('supplied properties not correct for "PosixUserProperty"');
    }
    function cfnAccessPointPosixUserPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccessPoint_PosixUserPropertyValidator(properties).assertSuccess(), { Gid: cdk.stringToCloudFormation(properties.gid), SecondaryGids: cdk.listMapper(cdk.stringToCloudFormation)(properties.secondaryGids), Uid: cdk.stringToCloudFormation(properties.uid) }) : properties;
    }
    function CfnAccessPointPosixUserPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("gid", "Gid", cfn_parse.FromCloudFormation.getString(properties.Gid)), ret.addPropertyResult("secondaryGids", "SecondaryGids", properties.SecondaryGids != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecondaryGids) : void 0), ret.addPropertyResult("uid", "Uid", cfn_parse.FromCloudFormation.getString(properties.Uid)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAccessPoint_RootDirectoryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("creationInfo", CfnAccessPoint_CreationInfoPropertyValidator)(properties.creationInfo)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.wrap('supplied properties not correct for "RootDirectoryProperty"');
    }
    function cfnAccessPointRootDirectoryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccessPoint_RootDirectoryPropertyValidator(properties).assertSuccess(), { CreationInfo: cfnAccessPointCreationInfoPropertyToCloudFormation(properties.creationInfo), Path: cdk.stringToCloudFormation(properties.path) }) : properties;
    }
    function CfnAccessPointRootDirectoryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("creationInfo", "CreationInfo", properties.CreationInfo != null ? CfnAccessPointCreationInfoPropertyFromCloudFormation(properties.CreationInfo) : void 0), ret.addPropertyResult("path", "Path", properties.Path != null ? cfn_parse.FromCloudFormation.getString(properties.Path) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFileSystemPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availabilityZoneName", cdk.validateString)(properties.availabilityZoneName)), errors.collect(cdk.propertyValidator("backupPolicy", CfnFileSystem_BackupPolicyPropertyValidator)(properties.backupPolicy)), errors.collect(cdk.propertyValidator("bypassPolicyLockoutSafetyCheck", cdk.validateBoolean)(properties.bypassPolicyLockoutSafetyCheck)), errors.collect(cdk.propertyValidator("encrypted", cdk.validateBoolean)(properties.encrypted)), errors.collect(cdk.propertyValidator("fileSystemPolicy", cdk.validateObject)(properties.fileSystemPolicy)), errors.collect(cdk.propertyValidator("fileSystemTags", cdk.listValidator(CfnFileSystem_ElasticFileSystemTagPropertyValidator))(properties.fileSystemTags)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("lifecyclePolicies", cdk.listValidator(CfnFileSystem_LifecyclePolicyPropertyValidator))(properties.lifecyclePolicies)), errors.collect(cdk.propertyValidator("performanceMode", cdk.validateString)(properties.performanceMode)), errors.collect(cdk.propertyValidator("provisionedThroughputInMibps", cdk.validateNumber)(properties.provisionedThroughputInMibps)), errors.collect(cdk.propertyValidator("throughputMode", cdk.validateString)(properties.throughputMode)), errors.wrap('supplied properties not correct for "CfnFileSystemProps"');
    }
    function cfnFileSystemPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFileSystemPropsValidator(properties).assertSuccess(), { AvailabilityZoneName: cdk.stringToCloudFormation(properties.availabilityZoneName), BackupPolicy: cfnFileSystemBackupPolicyPropertyToCloudFormation(properties.backupPolicy), BypassPolicyLockoutSafetyCheck: cdk.booleanToCloudFormation(properties.bypassPolicyLockoutSafetyCheck), Encrypted: cdk.booleanToCloudFormation(properties.encrypted), FileSystemPolicy: cdk.objectToCloudFormation(properties.fileSystemPolicy), FileSystemTags: cdk.listMapper(cfnFileSystemElasticFileSystemTagPropertyToCloudFormation)(properties.fileSystemTags), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), LifecyclePolicies: cdk.listMapper(cfnFileSystemLifecyclePolicyPropertyToCloudFormation)(properties.lifecyclePolicies), PerformanceMode: cdk.stringToCloudFormation(properties.performanceMode), ProvisionedThroughputInMibps: cdk.numberToCloudFormation(properties.provisionedThroughputInMibps), ThroughputMode: cdk.stringToCloudFormation(properties.throughputMode) }) : properties;
    }
    function CfnFileSystemPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("availabilityZoneName", "AvailabilityZoneName", properties.AvailabilityZoneName != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityZoneName) : void 0), ret.addPropertyResult("backupPolicy", "BackupPolicy", properties.BackupPolicy != null ? CfnFileSystemBackupPolicyPropertyFromCloudFormation(properties.BackupPolicy) : void 0), ret.addPropertyResult("bypassPolicyLockoutSafetyCheck", "BypassPolicyLockoutSafetyCheck", properties.BypassPolicyLockoutSafetyCheck != null ? cfn_parse.FromCloudFormation.getBoolean(properties.BypassPolicyLockoutSafetyCheck) : void 0), ret.addPropertyResult("encrypted", "Encrypted", properties.Encrypted != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Encrypted) : void 0), ret.addPropertyResult("fileSystemPolicy", "FileSystemPolicy", properties.FileSystemPolicy != null ? cfn_parse.FromCloudFormation.getAny(properties.FileSystemPolicy) : void 0), ret.addPropertyResult("fileSystemTags", "FileSystemTags", properties.FileSystemTags != null ? cfn_parse.FromCloudFormation.getArray(CfnFileSystemElasticFileSystemTagPropertyFromCloudFormation)(properties.FileSystemTags) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("lifecyclePolicies", "LifecyclePolicies", properties.LifecyclePolicies != null ? cfn_parse.FromCloudFormation.getArray(CfnFileSystemLifecyclePolicyPropertyFromCloudFormation)(properties.LifecyclePolicies) : void 0), ret.addPropertyResult("performanceMode", "PerformanceMode", properties.PerformanceMode != null ? cfn_parse.FromCloudFormation.getString(properties.PerformanceMode) : void 0), ret.addPropertyResult("provisionedThroughputInMibps", "ProvisionedThroughputInMibps", properties.ProvisionedThroughputInMibps != null ? cfn_parse.FromCloudFormation.getNumber(properties.ProvisionedThroughputInMibps) : void 0), ret.addPropertyResult("throughputMode", "ThroughputMode", properties.ThroughputMode != null ? cfn_parse.FromCloudFormation.getString(properties.ThroughputMode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFileSystem = class _CfnFileSystem extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFileSystemPropsFromCloudFormation(resourceProperties), ret = new _CfnFileSystem(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnFileSystem.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_efs_CfnFileSystemProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFileSystem), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrFileSystemId = cdk.Token.asString(this.getAtt("FileSystemId", cdk.ResolutionTypeHint.STRING)), this.availabilityZoneName = props.availabilityZoneName, this.backupPolicy = props.backupPolicy, this.bypassPolicyLockoutSafetyCheck = props.bypassPolicyLockoutSafetyCheck, this.encrypted = props.encrypted, this.fileSystemPolicy = props.fileSystemPolicy, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EFS::FileSystem", props.fileSystemTags, { tagPropertyName: "fileSystemTags" }), this.kmsKeyId = props.kmsKeyId, this.lifecyclePolicies = props.lifecyclePolicies, this.performanceMode = props.performanceMode, this.provisionedThroughputInMibps = props.provisionedThroughputInMibps, this.throughputMode = props.throughputMode, this.node.scope && cdk.Resource.isResource(this.node.scope) && this.node.addValidation({ validate: () => this.cfnOptions.deletionPolicy === void 0 ? ["'AWS::EFS::FileSystem' is a stateful resource type, and you must specify a Removal Policy for it. Call 'resource.applyRemovalPolicy()'."] : [] });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFileSystem.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { availabilityZoneName: this.availabilityZoneName, backupPolicy: this.backupPolicy, bypassPolicyLockoutSafetyCheck: this.bypassPolicyLockoutSafetyCheck, encrypted: this.encrypted, fileSystemPolicy: this.fileSystemPolicy, fileSystemTags: this.tags.renderTags(), kmsKeyId: this.kmsKeyId, lifecyclePolicies: this.lifecyclePolicies, performanceMode: this.performanceMode, provisionedThroughputInMibps: this.provisionedThroughputInMibps, throughputMode: this.throughputMode };
      }
      renderProperties(props) {
        return cfnFileSystemPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnFileSystem[_b] = { fqn: "aws-cdk-lib.aws_efs.CfnFileSystem", version: "2.80.0" }, CfnFileSystem.CFN_RESOURCE_TYPE_NAME = "AWS::EFS::FileSystem", exports2.CfnFileSystem = CfnFileSystem;
    function CfnFileSystem_BackupPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("status", cdk.requiredValidator)(properties.status)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "BackupPolicyProperty"');
    }
    function cfnFileSystemBackupPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFileSystem_BackupPolicyPropertyValidator(properties).assertSuccess(), { Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnFileSystemBackupPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("status", "Status", cfn_parse.FromCloudFormation.getString(properties.Status)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFileSystem_ElasticFileSystemTagPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "ElasticFileSystemTagProperty"');
    }
    function cfnFileSystemElasticFileSystemTagPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFileSystem_ElasticFileSystemTagPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnFileSystemElasticFileSystemTagPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFileSystem_LifecyclePolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("transitionToIa", cdk.validateString)(properties.transitionToIa)), errors.collect(cdk.propertyValidator("transitionToPrimaryStorageClass", cdk.validateString)(properties.transitionToPrimaryStorageClass)), errors.wrap('supplied properties not correct for "LifecyclePolicyProperty"');
    }
    function cfnFileSystemLifecyclePolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFileSystem_LifecyclePolicyPropertyValidator(properties).assertSuccess(), { TransitionToIA: cdk.stringToCloudFormation(properties.transitionToIa), TransitionToPrimaryStorageClass: cdk.stringToCloudFormation(properties.transitionToPrimaryStorageClass) }) : properties;
    }
    function CfnFileSystemLifecyclePolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("transitionToIa", "TransitionToIA", properties.TransitionToIA != null ? cfn_parse.FromCloudFormation.getString(properties.TransitionToIA) : void 0), ret.addPropertyResult("transitionToPrimaryStorageClass", "TransitionToPrimaryStorageClass", properties.TransitionToPrimaryStorageClass != null ? cfn_parse.FromCloudFormation.getString(properties.TransitionToPrimaryStorageClass) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMountTargetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fileSystemId", cdk.requiredValidator)(properties.fileSystemId)), errors.collect(cdk.propertyValidator("fileSystemId", cdk.validateString)(properties.fileSystemId)), errors.collect(cdk.propertyValidator("ipAddress", cdk.validateString)(properties.ipAddress)), errors.collect(cdk.propertyValidator("securityGroups", cdk.requiredValidator)(properties.securityGroups)), errors.collect(cdk.propertyValidator("securityGroups", cdk.listValidator(cdk.validateString))(properties.securityGroups)), errors.collect(cdk.propertyValidator("subnetId", cdk.requiredValidator)(properties.subnetId)), errors.collect(cdk.propertyValidator("subnetId", cdk.validateString)(properties.subnetId)), errors.wrap('supplied properties not correct for "CfnMountTargetProps"');
    }
    function cfnMountTargetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMountTargetPropsValidator(properties).assertSuccess(), { FileSystemId: cdk.stringToCloudFormation(properties.fileSystemId), SecurityGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroups), SubnetId: cdk.stringToCloudFormation(properties.subnetId), IpAddress: cdk.stringToCloudFormation(properties.ipAddress) }) : properties;
    }
    function CfnMountTargetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fileSystemId", "FileSystemId", cfn_parse.FromCloudFormation.getString(properties.FileSystemId)), ret.addPropertyResult("securityGroups", "SecurityGroups", cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroups)), ret.addPropertyResult("subnetId", "SubnetId", cfn_parse.FromCloudFormation.getString(properties.SubnetId)), ret.addPropertyResult("ipAddress", "IpAddress", properties.IpAddress != null ? cfn_parse.FromCloudFormation.getString(properties.IpAddress) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnMountTarget = class _CfnMountTarget extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnMountTargetPropsFromCloudFormation(resourceProperties), ret = new _CfnMountTarget(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnMountTarget.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_efs_CfnMountTargetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnMountTarget), error;
        }
        cdk.requireProperty(props, "fileSystemId", this), cdk.requireProperty(props, "securityGroups", this), cdk.requireProperty(props, "subnetId", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrIpAddress = cdk.Token.asString(this.getAtt("IpAddress", cdk.ResolutionTypeHint.STRING)), this.fileSystemId = props.fileSystemId, this.securityGroups = props.securityGroups, this.subnetId = props.subnetId, this.ipAddress = props.ipAddress;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnMountTarget.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { fileSystemId: this.fileSystemId, securityGroups: this.securityGroups, subnetId: this.subnetId, ipAddress: this.ipAddress };
      }
      renderProperties(props) {
        return cfnMountTargetPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnMountTarget[_c] = { fqn: "aws-cdk-lib.aws_efs.CfnMountTarget", version: "2.80.0" }, CfnMountTarget.CFN_RESOURCE_TYPE_NAME = "AWS::EFS::MountTarget", exports2.CfnMountTarget = CfnMountTarget;
  }
});

// node_modules/aws-cdk-lib/aws-efs/lib/access-point.js
var require_access_point = __commonJS({
  "node_modules/aws-cdk-lib/aws-efs/lib/access-point.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AccessPoint = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var efs_generated_1 = require_efs_generated();
    var core_1 = require_core2();
    var AccessPointBase = class extends core_1.Resource {
    };
    var AccessPoint = class _AccessPoint extends AccessPointBase {
      static fromAccessPointAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_efs_AccessPointAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromAccessPointAttributes), error;
        }
        return new ImportedAccessPoint(scope, id, attrs);
      }
      static fromAccessPointId(scope, id, accessPointId) {
        return new ImportedAccessPoint(scope, id, { accessPointId });
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_efs_AccessPointProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AccessPoint), error;
        }
        const resource = new efs_generated_1.CfnAccessPoint(this, "Resource", { fileSystemId: props.fileSystem.fileSystemId, rootDirectory: { creationInfo: props.createAcl ? { ownerGid: props.createAcl.ownerGid, ownerUid: props.createAcl.ownerUid, permissions: props.createAcl.permissions } : void 0, path: props.path }, posixUser: props.posixUser ? { uid: props.posixUser.uid, gid: props.posixUser.gid, secondaryGids: props.posixUser.secondaryGids } : void 0 });
        core_1.Tags.of(this).add("Name", this.node.path), this.accessPointId = resource.ref, this.accessPointArn = core_1.Stack.of(scope).formatArn({ service: "elasticfilesystem", resource: "access-point", resourceName: this.accessPointId }), this.fileSystem = props.fileSystem;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AccessPoint[_a] = { fqn: "aws-cdk-lib.aws_efs.AccessPoint", version: "2.80.0" }, exports2.AccessPoint = AccessPoint;
    var ImportedAccessPoint = class extends AccessPointBase {
      constructor(scope, id, attrs) {
        if (super(scope, id), attrs.accessPointId) {
          if (attrs.accessPointArn)
            throw new Error("Only one of accessPointId or AccessPointArn can be provided!");
          this.accessPointId = attrs.accessPointId, this.accessPointArn = core_1.Stack.of(scope).formatArn({ service: "elasticfilesystem", resource: "access-point", resourceName: attrs.accessPointId });
        } else {
          if (!attrs.accessPointArn)
            throw new Error("One of accessPointId or AccessPointArn is required!");
          this.accessPointArn = attrs.accessPointArn;
          let maybeApId = core_1.Stack.of(scope).splitArn(attrs.accessPointArn, core_1.ArnFormat.SLASH_RESOURCE_NAME).resourceName;
          if (!maybeApId)
            throw new Error("ARN for AccessPoint must provide the resource name.");
          this.accessPointId = maybeApId;
        }
        this._fileSystem = attrs.fileSystem;
      }
      get fileSystem() {
        if (!this._fileSystem)
          throw new Error("fileSystem is only available if 'fromAccessPointAttributes()' is used and a fileSystem is passed in as an attribute.");
        return this._fileSystem;
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-efs/lib/efs-file-system.js
var require_efs_file_system = __commonJS({
  "node_modules/aws-cdk-lib/aws-efs/lib/efs-file-system.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FileSystem = exports2.ThroughputMode = exports2.PerformanceMode = exports2.OutOfInfrequentAccessPolicy = exports2.LifecyclePolicy = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var access_point_1 = require_access_point();
    var efs_generated_1 = require_efs_generated();
    var ec2 = require_aws_ec2();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var cxapi = require_cx_api();
    var LifecyclePolicy;
    (function(LifecyclePolicy2) {
      LifecyclePolicy2.AFTER_1_DAY = "AFTER_1_DAY", LifecyclePolicy2.AFTER_7_DAYS = "AFTER_7_DAYS", LifecyclePolicy2.AFTER_14_DAYS = "AFTER_14_DAYS", LifecyclePolicy2.AFTER_30_DAYS = "AFTER_30_DAYS", LifecyclePolicy2.AFTER_60_DAYS = "AFTER_60_DAYS", LifecyclePolicy2.AFTER_90_DAYS = "AFTER_90_DAYS";
    })(LifecyclePolicy = exports2.LifecyclePolicy || (exports2.LifecyclePolicy = {}));
    var OutOfInfrequentAccessPolicy;
    (function(OutOfInfrequentAccessPolicy2) {
      OutOfInfrequentAccessPolicy2.AFTER_1_ACCESS = "AFTER_1_ACCESS";
    })(OutOfInfrequentAccessPolicy = exports2.OutOfInfrequentAccessPolicy || (exports2.OutOfInfrequentAccessPolicy = {}));
    var PerformanceMode;
    (function(PerformanceMode2) {
      PerformanceMode2.GENERAL_PURPOSE = "generalPurpose", PerformanceMode2.MAX_IO = "maxIO";
    })(PerformanceMode = exports2.PerformanceMode || (exports2.PerformanceMode = {}));
    var ThroughputMode;
    (function(ThroughputMode2) {
      ThroughputMode2.BURSTING = "bursting", ThroughputMode2.PROVISIONED = "provisioned", ThroughputMode2.ELASTIC = "elastic";
    })(ThroughputMode = exports2.ThroughputMode || (exports2.ThroughputMode = {}));
    var FileSystemBase = class extends core_1.Resource {
      grant(grantee, ...actions) {
        return iam.Grant.addToPrincipal({ grantee, actions, resourceArns: [this.fileSystemArn] });
      }
      addToResourcePolicy(statement) {
        return this._resource ? (this._fileSystemPolicy = this._fileSystemPolicy ?? new iam.PolicyDocument({ statements: [] }), this._fileSystemPolicy.addStatements(statement), { statementAdded: true, policyDependable: this }) : { statementAdded: false };
      }
    };
    var FileSystem = class _FileSystem extends FileSystemBase {
      static fromFileSystemAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_efs_FileSystemAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromFileSystemAttributes), error;
        }
        return new ImportedFileSystem(scope, id, attrs);
      }
      constructor(scope, id, props) {
        super(scope, id), this._mountTargetsAvailable = new constructs_1.DependencyGroup();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_efs_FileSystemProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _FileSystem), error;
        }
        if (props.throughputMode === ThroughputMode.PROVISIONED && props.provisionedThroughputPerSecond === void 0)
          throw new Error("Property provisionedThroughputPerSecond is required when throughputMode is PROVISIONED");
        if (props.throughputMode === ThroughputMode.ELASTIC && props.performanceMode === PerformanceMode.MAX_IO)
          throw new Error("ThroughputMode ELASTIC is not supported for file systems with performanceMode MAX_IO");
        const encrypted = props.encrypted ?? (core_1.FeatureFlags.of(this).isEnabled(cxapi.EFS_DEFAULT_ENCRYPTION_AT_REST) ? true : void 0);
        let lifecyclePolicies = [];
        props.lifecyclePolicy && lifecyclePolicies.push({ transitionToIa: props.lifecyclePolicy }), props.outOfInfrequentAccessPolicy && lifecyclePolicies.push({ transitionToPrimaryStorageClass: props.outOfInfrequentAccessPolicy }), this._resource = new efs_generated_1.CfnFileSystem(this, "Resource", { encrypted, kmsKeyId: props.kmsKey?.keyArn, lifecyclePolicies: lifecyclePolicies.length > 0 ? lifecyclePolicies : void 0, performanceMode: props.performanceMode, throughputMode: props.throughputMode, provisionedThroughputInMibps: props.provisionedThroughputPerSecond?.toMebibytes(), backupPolicy: props.enableAutomaticBackups ? { status: "ENABLED" } : void 0, fileSystemPolicy: core_1.Lazy.any({ produce: () => this._fileSystemPolicy }) }), this._resource.applyRemovalPolicy(props.removalPolicy), this.fileSystemId = this._resource.ref, this.fileSystemArn = this._resource.attrArn, this._fileSystemPolicy = props.fileSystemPolicy, core_1.Tags.of(this).add("Name", props.fileSystemName || this.node.path);
        const securityGroup = props.securityGroup || new ec2.SecurityGroup(this, "EfsSecurityGroup", { vpc: props.vpc });
        this.connections = new ec2.Connections({ securityGroups: [securityGroup], defaultPort: ec2.Port.tcp(_FileSystem.DEFAULT_PORT) });
        const subnets = props.vpc.selectSubnets(props.vpcSubnets ?? { onePerAz: true });
        let mountTargetCount = 0;
        this.mountTargetsAvailable = [], subnets.subnetIds.forEach((subnetId) => {
          const mountTarget = new efs_generated_1.CfnMountTarget(this, "EfsMountTarget" + ++mountTargetCount, { fileSystemId: this.fileSystemId, securityGroups: Array.of(securityGroup.securityGroupId), subnetId });
          this._mountTargetsAvailable.add(mountTarget);
        }), this.mountTargetsAvailable = this._mountTargetsAvailable;
      }
      addAccessPoint(id, accessPointOptions = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_efs_AccessPointOptions(accessPointOptions);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addAccessPoint), error;
        }
        return new access_point_1.AccessPoint(this, id, { fileSystem: this, ...accessPointOptions });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, FileSystem[_a] = { fqn: "aws-cdk-lib.aws_efs.FileSystem", version: "2.80.0" }, FileSystem.DEFAULT_PORT = 2049, exports2.FileSystem = FileSystem;
    var ImportedFileSystem = class extends FileSystemBase {
      constructor(scope, id, attrs) {
        if (super(scope, id), !!attrs.fileSystemId == !!attrs.fileSystemArn)
          throw new Error("One of fileSystemId or fileSystemArn, but not both, must be provided.");
        this.fileSystemArn = attrs.fileSystemArn ?? core_1.Stack.of(scope).formatArn({ service: "elasticfilesystem", resource: "file-system", resourceName: attrs.fileSystemId });
        const parsedArn = core_1.Stack.of(scope).splitArn(this.fileSystemArn, core_1.ArnFormat.SLASH_RESOURCE_NAME);
        if (!parsedArn.resourceName)
          throw new Error(`Invalid FileSystem Arn ${this.fileSystemArn}`);
        this.fileSystemId = attrs.fileSystemId ?? parsedArn.resourceName, this.connections = new ec2.Connections({ securityGroups: [attrs.securityGroup], defaultPort: ec2.Port.tcp(FileSystem.DEFAULT_PORT) }), this.mountTargetsAvailable = new constructs_1.DependencyGroup();
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-efs/lib/index.js
var require_lib59 = __commonJS({
  "node_modules/aws-cdk-lib/aws-efs/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_access_point(), exports2), __exportStar(require_efs_file_system(), exports2), __exportStar(require_efs_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-efs/index.js
var require_aws_efs = __commonJS({
  "node_modules/aws-cdk-lib/aws-efs/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib59(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-rds/lib/engine.js
var require_engine = __commonJS({
  "node_modules/aws-cdk-lib/aws-rds/lib/engine.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-rds/lib/engine-version.js
var require_engine_version = __commonJS({
  "node_modules/aws-cdk-lib/aws-rds/lib/engine-version.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-rds/lib/props.js
var require_props = __commonJS({
  "node_modules/aws-cdk-lib/aws-rds/lib/props.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PerformanceInsightRetention = exports2.SnapshotCredentials = exports2.Credentials = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var Credentials = class {
      static fromGeneratedSecret(username, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_CredentialsBaseOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromGeneratedSecret), error;
        }
        return { ...options, username, usernameAsString: true };
      }
      static fromPassword(username, password) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_SecretValue(password);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromPassword), error;
        }
        return { username, password, usernameAsString: true };
      }
      static fromUsername(username, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_CredentialsFromUsernameOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromUsername), error;
        }
        return { ...options, username };
      }
      static fromSecret(secret, username) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_ISecret(secret);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromSecret), error;
        }
        return { username: username ?? secret.secretValueFromJson("username").unsafeUnwrap(), password: secret.secretValueFromJson("password"), encryptionKey: secret.encryptionKey, secret };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Credentials[_a] = { fqn: "aws-cdk-lib.aws_rds.Credentials", version: "2.80.0" }, exports2.Credentials = Credentials;
    var SnapshotCredentials = class {
      static fromGeneratedSecret(username, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_SnapshotCredentialsFromGeneratedPasswordOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromGeneratedSecret), error;
        }
        return { ...options, generatePassword: true, replaceOnPasswordCriteriaChanges: true, username };
      }
      static fromGeneratedPassword(username, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_SnapshotCredentialsFromGeneratedPasswordOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromGeneratedPassword), error;
        }
        return { ...options, generatePassword: true, username };
      }
      static fromPassword(password) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_SecretValue(password);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromPassword), error;
        }
        return { generatePassword: false, password };
      }
      static fromSecret(secret) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_ISecret(secret);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromSecret), error;
        }
        return { generatePassword: false, password: secret.secretValueFromJson("password"), secret };
      }
    };
    _b = JSII_RTTI_SYMBOL_1, SnapshotCredentials[_b] = { fqn: "aws-cdk-lib.aws_rds.SnapshotCredentials", version: "2.80.0" }, exports2.SnapshotCredentials = SnapshotCredentials;
    var PerformanceInsightRetention;
    (function(PerformanceInsightRetention2) {
      PerformanceInsightRetention2[PerformanceInsightRetention2.DEFAULT = 7] = "DEFAULT", PerformanceInsightRetention2[PerformanceInsightRetention2.MONTHS_1 = 31] = "MONTHS_1", PerformanceInsightRetention2[PerformanceInsightRetention2.MONTHS_2 = 62] = "MONTHS_2", PerformanceInsightRetention2[PerformanceInsightRetention2.MONTHS_3 = 93] = "MONTHS_3", PerformanceInsightRetention2[PerformanceInsightRetention2.MONTHS_4 = 124] = "MONTHS_4", PerformanceInsightRetention2[PerformanceInsightRetention2.MONTHS_5 = 155] = "MONTHS_5", PerformanceInsightRetention2[PerformanceInsightRetention2.MONTHS_6 = 186] = "MONTHS_6", PerformanceInsightRetention2[PerformanceInsightRetention2.MONTHS_7 = 217] = "MONTHS_7", PerformanceInsightRetention2[PerformanceInsightRetention2.MONTHS_8 = 248] = "MONTHS_8", PerformanceInsightRetention2[PerformanceInsightRetention2.MONTHS_9 = 279] = "MONTHS_9", PerformanceInsightRetention2[PerformanceInsightRetention2.MONTHS_10 = 310] = "MONTHS_10", PerformanceInsightRetention2[PerformanceInsightRetention2.MONTHS_11 = 341] = "MONTHS_11", PerformanceInsightRetention2[PerformanceInsightRetention2.MONTHS_12 = 372] = "MONTHS_12", PerformanceInsightRetention2[PerformanceInsightRetention2.MONTHS_13 = 403] = "MONTHS_13", PerformanceInsightRetention2[PerformanceInsightRetention2.MONTHS_14 = 434] = "MONTHS_14", PerformanceInsightRetention2[PerformanceInsightRetention2.MONTHS_15 = 465] = "MONTHS_15", PerformanceInsightRetention2[PerformanceInsightRetention2.MONTHS_16 = 496] = "MONTHS_16", PerformanceInsightRetention2[PerformanceInsightRetention2.MONTHS_17 = 527] = "MONTHS_17", PerformanceInsightRetention2[PerformanceInsightRetention2.MONTHS_18 = 558] = "MONTHS_18", PerformanceInsightRetention2[PerformanceInsightRetention2.MONTHS_19 = 589] = "MONTHS_19", PerformanceInsightRetention2[PerformanceInsightRetention2.MONTHS_20 = 620] = "MONTHS_20", PerformanceInsightRetention2[PerformanceInsightRetention2.MONTHS_21 = 651] = "MONTHS_21", PerformanceInsightRetention2[PerformanceInsightRetention2.MONTHS_22 = 682] = "MONTHS_22", PerformanceInsightRetention2[PerformanceInsightRetention2.MONTHS_23 = 713] = "MONTHS_23", PerformanceInsightRetention2[PerformanceInsightRetention2.LONG_TERM = 731] = "LONG_TERM";
    })(PerformanceInsightRetention = exports2.PerformanceInsightRetention || (exports2.PerformanceInsightRetention = {}));
  }
});

// node_modules/aws-cdk-lib/aws-rds/lib/private/util.js
var require_util16 = __commonJS({
  "node_modules/aws-cdk-lib/aws-rds/lib/private/util.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.applyDefaultRotationOptions = exports2.renderUnless = exports2.helperRemovalPolicy = exports2.renderCredentials = exports2.defaultDeletionProtection = exports2.engineDescription = exports2.setupS3ImportExport = exports2.DEFAULT_PASSWORD_EXCLUDE_CHARS = void 0;
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var database_secret_1 = require_database_secret();
    var props_1 = require_props();
    exports2.DEFAULT_PASSWORD_EXCLUDE_CHARS = " %+~`#$&*()|[]{}:;<>?!'/@\"\\";
    function setupS3ImportExport(scope, props, combineRoles) {
      let s3ImportRole = props.s3ImportRole, s3ExportRole = props.s3ExportRole;
      if (props.s3ImportBuckets && props.s3ImportBuckets.length > 0) {
        if (props.s3ImportRole)
          throw new Error("Only one of s3ImportRole or s3ImportBuckets must be specified, not both.");
        s3ImportRole = combineRoles && s3ExportRole ? s3ExportRole : new iam.Role(scope, "S3ImportRole", { assumedBy: new iam.ServicePrincipal("rds.amazonaws.com") });
        for (const bucket of props.s3ImportBuckets)
          bucket.grantRead(s3ImportRole);
      }
      if (props.s3ExportBuckets && props.s3ExportBuckets.length > 0) {
        if (props.s3ExportRole)
          throw new Error("Only one of s3ExportRole or s3ExportBuckets must be specified, not both.");
        s3ExportRole = combineRoles && s3ImportRole ? s3ImportRole : new iam.Role(scope, "S3ExportRole", { assumedBy: new iam.ServicePrincipal("rds.amazonaws.com") });
        for (const bucket of props.s3ExportBuckets)
          bucket.grantReadWrite(s3ExportRole);
      }
      return { s3ImportRole, s3ExportRole };
    }
    exports2.setupS3ImportExport = setupS3ImportExport;
    function engineDescription(engine) {
      return engine.engineType + (engine.engineVersion?.fullVersion ? `-${engine.engineVersion.fullVersion}` : "");
    }
    exports2.engineDescription = engineDescription;
    function defaultDeletionProtection(deletionProtection, removalPolicy) {
      return deletionProtection ?? (removalPolicy === core_1.RemovalPolicy.RETAIN ? true : void 0);
    }
    exports2.defaultDeletionProtection = defaultDeletionProtection;
    function renderCredentials(scope, engine, credentials) {
      let renderedCredentials = credentials ?? props_1.Credentials.fromUsername(engine.defaultUsername ?? "admin");
      return !renderedCredentials.secret && !renderedCredentials.password && (renderedCredentials = props_1.Credentials.fromSecret(new database_secret_1.DatabaseSecret(scope, "Secret", { username: renderedCredentials.username, secretName: renderedCredentials.secretName, encryptionKey: renderedCredentials.encryptionKey, excludeCharacters: renderedCredentials.excludeCharacters, replaceOnPasswordCriteriaChanges: credentials?.usernameAsString, replicaRegions: renderedCredentials.replicaRegions }), credentials?.usernameAsString ? renderedCredentials.username : void 0)), renderedCredentials;
    }
    exports2.renderCredentials = renderCredentials;
    function helperRemovalPolicy(basePolicy) {
      return basePolicy === core_1.RemovalPolicy.RETAIN ? core_1.RemovalPolicy.RETAIN : core_1.RemovalPolicy.DESTROY;
    }
    exports2.helperRemovalPolicy = helperRemovalPolicy;
    function renderUnless(value, suppressValue) {
      return value === suppressValue ? void 0 : value;
    }
    exports2.renderUnless = renderUnless;
    function applyDefaultRotationOptions(options, defaultvpcSubnets) {
      return { excludeCharacters: exports2.DEFAULT_PASSWORD_EXCLUDE_CHARS, vpcSubnets: defaultvpcSubnets, ...options };
    }
    exports2.applyDefaultRotationOptions = applyDefaultRotationOptions;
  }
});

// node_modules/aws-cdk-lib/aws-rds/lib/database-secret.js
var require_database_secret = __commonJS({
  "node_modules/aws-cdk-lib/aws-rds/lib/database-secret.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DatabaseSecret = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var util_1 = require_util16();
    var secretsmanager = require_aws_secretsmanager();
    var core_1 = require_core2();
    var helpers_internal_1 = require_helpers_internal();
    var DatabaseSecret = class _DatabaseSecret extends secretsmanager.Secret {
      constructor(scope, id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_DatabaseSecretProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _DatabaseSecret), error;
        }
        const excludeCharacters = props.excludeCharacters ?? util_1.DEFAULT_PASSWORD_EXCLUDE_CHARS;
        if (super(scope, id, { encryptionKey: props.encryptionKey, description: `Generated by the CDK for stack: ${core_1.Aws.STACK_NAME}`, secretName: props.secretName, generateSecretString: { passwordLength: 30, secretStringTemplate: JSON.stringify({ username: props.username, dbname: props.dbname, masterarn: props.masterSecret?.secretArn }), generateStringKey: "password", excludeCharacters }, replicaRegions: props.replicaRegions }), props.replaceOnPasswordCriteriaChanges) {
          const hash = (0, helpers_internal_1.md5hash)(JSON.stringify({ excludeCharacters })), logicalId = `${core_1.Names.uniqueId(this)}${hash}`;
          this.node.defaultChild.overrideLogicalId(logicalId.slice(-255));
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, DatabaseSecret[_a] = { fqn: "aws-cdk-lib.aws_rds.DatabaseSecret", version: "2.80.0" }, exports2.DatabaseSecret = DatabaseSecret;
  }
});

// node_modules/aws-cdk-lib/aws-rds/lib/endpoint.js
var require_endpoint = __commonJS({
  "node_modules/aws-cdk-lib/aws-rds/lib/endpoint.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Endpoint = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core_1 = require_core2();
    var Endpoint = class {
      constructor(address, port) {
        this.hostname = address, this.port = port;
        const portDesc = core_1.Token.isUnresolved(port) ? core_1.Token.asString(port) : port;
        this.socketAddress = `${address}:${portDesc}`;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Endpoint[_a] = { fqn: "aws-cdk-lib.aws_rds.Endpoint", version: "2.80.0" }, exports2.Endpoint = Endpoint;
  }
});

// node_modules/aws-cdk-lib/aws-rds/lib/rds.generated.js
var require_rds_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-rds/lib/rds.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    var _l;
    var _m;
    var _o;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnOptionGroup = exports2.CfnGlobalCluster = exports2.CfnEventSubscription = exports2.CfnDBSubnetGroup = exports2.CfnDBSecurityGroupIngress = exports2.CfnDBSecurityGroup = exports2.CfnDBProxyTargetGroup = exports2.CfnDBProxyEndpoint = exports2.CfnDBProxy = exports2.CfnDBParameterGroup = exports2.CfnDBInstance = exports2.CfnDBClusterParameterGroup = exports2.CfnDBCluster = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnDBClusterPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allocatedStorage", cdk.validateNumber)(properties.allocatedStorage)), errors.collect(cdk.propertyValidator("associatedRoles", cdk.listValidator(CfnDBCluster_DBClusterRolePropertyValidator))(properties.associatedRoles)), errors.collect(cdk.propertyValidator("autoMinorVersionUpgrade", cdk.validateBoolean)(properties.autoMinorVersionUpgrade)), errors.collect(cdk.propertyValidator("availabilityZones", cdk.listValidator(cdk.validateString))(properties.availabilityZones)), errors.collect(cdk.propertyValidator("backtrackWindow", cdk.validateNumber)(properties.backtrackWindow)), errors.collect(cdk.propertyValidator("backupRetentionPeriod", cdk.validateNumber)(properties.backupRetentionPeriod)), errors.collect(cdk.propertyValidator("copyTagsToSnapshot", cdk.validateBoolean)(properties.copyTagsToSnapshot)), errors.collect(cdk.propertyValidator("dbClusterIdentifier", cdk.validateString)(properties.dbClusterIdentifier)), errors.collect(cdk.propertyValidator("dbClusterInstanceClass", cdk.validateString)(properties.dbClusterInstanceClass)), errors.collect(cdk.propertyValidator("dbClusterParameterGroupName", cdk.validateString)(properties.dbClusterParameterGroupName)), errors.collect(cdk.propertyValidator("dbInstanceParameterGroupName", cdk.validateString)(properties.dbInstanceParameterGroupName)), errors.collect(cdk.propertyValidator("dbSubnetGroupName", cdk.validateString)(properties.dbSubnetGroupName)), errors.collect(cdk.propertyValidator("dbSystemId", cdk.validateString)(properties.dbSystemId)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("deletionProtection", cdk.validateBoolean)(properties.deletionProtection)), errors.collect(cdk.propertyValidator("domain", cdk.validateString)(properties.domain)), errors.collect(cdk.propertyValidator("domainIamRoleName", cdk.validateString)(properties.domainIamRoleName)), errors.collect(cdk.propertyValidator("enableCloudwatchLogsExports", cdk.listValidator(cdk.validateString))(properties.enableCloudwatchLogsExports)), errors.collect(cdk.propertyValidator("enableHttpEndpoint", cdk.validateBoolean)(properties.enableHttpEndpoint)), errors.collect(cdk.propertyValidator("enableIamDatabaseAuthentication", cdk.validateBoolean)(properties.enableIamDatabaseAuthentication)), errors.collect(cdk.propertyValidator("engine", cdk.validateString)(properties.engine)), errors.collect(cdk.propertyValidator("engineMode", cdk.validateString)(properties.engineMode)), errors.collect(cdk.propertyValidator("engineVersion", cdk.validateString)(properties.engineVersion)), errors.collect(cdk.propertyValidator("globalClusterIdentifier", cdk.validateString)(properties.globalClusterIdentifier)), errors.collect(cdk.propertyValidator("iops", cdk.validateNumber)(properties.iops)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("manageMasterUserPassword", cdk.validateBoolean)(properties.manageMasterUserPassword)), errors.collect(cdk.propertyValidator("masterUserPassword", cdk.validateString)(properties.masterUserPassword)), errors.collect(cdk.propertyValidator("masterUserSecret", CfnDBCluster_MasterUserSecretPropertyValidator)(properties.masterUserSecret)), errors.collect(cdk.propertyValidator("masterUsername", cdk.validateString)(properties.masterUsername)), errors.collect(cdk.propertyValidator("monitoringInterval", cdk.validateNumber)(properties.monitoringInterval)), errors.collect(cdk.propertyValidator("monitoringRoleArn", cdk.validateString)(properties.monitoringRoleArn)), errors.collect(cdk.propertyValidator("networkType", cdk.validateString)(properties.networkType)), errors.collect(cdk.propertyValidator("performanceInsightsEnabled", cdk.validateBoolean)(properties.performanceInsightsEnabled)), errors.collect(cdk.propertyValidator("performanceInsightsKmsKeyId", cdk.validateString)(properties.performanceInsightsKmsKeyId)), errors.collect(cdk.propertyValidator("performanceInsightsRetentionPeriod", cdk.validateNumber)(properties.performanceInsightsRetentionPeriod)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("preferredBackupWindow", cdk.validateString)(properties.preferredBackupWindow)), errors.collect(cdk.propertyValidator("preferredMaintenanceWindow", cdk.validateString)(properties.preferredMaintenanceWindow)), errors.collect(cdk.propertyValidator("publiclyAccessible", cdk.validateBoolean)(properties.publiclyAccessible)), errors.collect(cdk.propertyValidator("replicationSourceIdentifier", cdk.validateString)(properties.replicationSourceIdentifier)), errors.collect(cdk.propertyValidator("restoreToTime", cdk.validateString)(properties.restoreToTime)), errors.collect(cdk.propertyValidator("restoreType", cdk.validateString)(properties.restoreType)), errors.collect(cdk.propertyValidator("scalingConfiguration", CfnDBCluster_ScalingConfigurationPropertyValidator)(properties.scalingConfiguration)), errors.collect(cdk.propertyValidator("serverlessV2ScalingConfiguration", CfnDBCluster_ServerlessV2ScalingConfigurationPropertyValidator)(properties.serverlessV2ScalingConfiguration)), errors.collect(cdk.propertyValidator("snapshotIdentifier", cdk.validateString)(properties.snapshotIdentifier)), errors.collect(cdk.propertyValidator("sourceDbClusterIdentifier", cdk.validateString)(properties.sourceDbClusterIdentifier)), errors.collect(cdk.propertyValidator("sourceRegion", cdk.validateString)(properties.sourceRegion)), errors.collect(cdk.propertyValidator("storageEncrypted", cdk.validateBoolean)(properties.storageEncrypted)), errors.collect(cdk.propertyValidator("storageType", cdk.validateString)(properties.storageType)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("useLatestRestorableTime", cdk.validateBoolean)(properties.useLatestRestorableTime)), errors.collect(cdk.propertyValidator("vpcSecurityGroupIds", cdk.listValidator(cdk.validateString))(properties.vpcSecurityGroupIds)), errors.wrap('supplied properties not correct for "CfnDBClusterProps"');
    }
    function cfnDBClusterPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBClusterPropsValidator(properties).assertSuccess(), { AllocatedStorage: cdk.numberToCloudFormation(properties.allocatedStorage), AssociatedRoles: cdk.listMapper(cfnDBClusterDBClusterRolePropertyToCloudFormation)(properties.associatedRoles), AutoMinorVersionUpgrade: cdk.booleanToCloudFormation(properties.autoMinorVersionUpgrade), AvailabilityZones: cdk.listMapper(cdk.stringToCloudFormation)(properties.availabilityZones), BacktrackWindow: cdk.numberToCloudFormation(properties.backtrackWindow), BackupRetentionPeriod: cdk.numberToCloudFormation(properties.backupRetentionPeriod), CopyTagsToSnapshot: cdk.booleanToCloudFormation(properties.copyTagsToSnapshot), DatabaseName: cdk.stringToCloudFormation(properties.databaseName), DBClusterIdentifier: cdk.stringToCloudFormation(properties.dbClusterIdentifier), DBClusterInstanceClass: cdk.stringToCloudFormation(properties.dbClusterInstanceClass), DBClusterParameterGroupName: cdk.stringToCloudFormation(properties.dbClusterParameterGroupName), DBInstanceParameterGroupName: cdk.stringToCloudFormation(properties.dbInstanceParameterGroupName), DBSubnetGroupName: cdk.stringToCloudFormation(properties.dbSubnetGroupName), DBSystemId: cdk.stringToCloudFormation(properties.dbSystemId), DeletionProtection: cdk.booleanToCloudFormation(properties.deletionProtection), Domain: cdk.stringToCloudFormation(properties.domain), DomainIAMRoleName: cdk.stringToCloudFormation(properties.domainIamRoleName), EnableCloudwatchLogsExports: cdk.listMapper(cdk.stringToCloudFormation)(properties.enableCloudwatchLogsExports), EnableHttpEndpoint: cdk.booleanToCloudFormation(properties.enableHttpEndpoint), EnableIAMDatabaseAuthentication: cdk.booleanToCloudFormation(properties.enableIamDatabaseAuthentication), Engine: cdk.stringToCloudFormation(properties.engine), EngineMode: cdk.stringToCloudFormation(properties.engineMode), EngineVersion: cdk.stringToCloudFormation(properties.engineVersion), GlobalClusterIdentifier: cdk.stringToCloudFormation(properties.globalClusterIdentifier), Iops: cdk.numberToCloudFormation(properties.iops), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), ManageMasterUserPassword: cdk.booleanToCloudFormation(properties.manageMasterUserPassword), MasterUsername: cdk.stringToCloudFormation(properties.masterUsername), MasterUserPassword: cdk.stringToCloudFormation(properties.masterUserPassword), MasterUserSecret: cfnDBClusterMasterUserSecretPropertyToCloudFormation(properties.masterUserSecret), MonitoringInterval: cdk.numberToCloudFormation(properties.monitoringInterval), MonitoringRoleArn: cdk.stringToCloudFormation(properties.monitoringRoleArn), NetworkType: cdk.stringToCloudFormation(properties.networkType), PerformanceInsightsEnabled: cdk.booleanToCloudFormation(properties.performanceInsightsEnabled), PerformanceInsightsKmsKeyId: cdk.stringToCloudFormation(properties.performanceInsightsKmsKeyId), PerformanceInsightsRetentionPeriod: cdk.numberToCloudFormation(properties.performanceInsightsRetentionPeriod), Port: cdk.numberToCloudFormation(properties.port), PreferredBackupWindow: cdk.stringToCloudFormation(properties.preferredBackupWindow), PreferredMaintenanceWindow: cdk.stringToCloudFormation(properties.preferredMaintenanceWindow), PubliclyAccessible: cdk.booleanToCloudFormation(properties.publiclyAccessible), ReplicationSourceIdentifier: cdk.stringToCloudFormation(properties.replicationSourceIdentifier), RestoreToTime: cdk.stringToCloudFormation(properties.restoreToTime), RestoreType: cdk.stringToCloudFormation(properties.restoreType), ScalingConfiguration: cfnDBClusterScalingConfigurationPropertyToCloudFormation(properties.scalingConfiguration), ServerlessV2ScalingConfiguration: cfnDBClusterServerlessV2ScalingConfigurationPropertyToCloudFormation(properties.serverlessV2ScalingConfiguration), SnapshotIdentifier: cdk.stringToCloudFormation(properties.snapshotIdentifier), SourceDBClusterIdentifier: cdk.stringToCloudFormation(properties.sourceDbClusterIdentifier), SourceRegion: cdk.stringToCloudFormation(properties.sourceRegion), StorageEncrypted: cdk.booleanToCloudFormation(properties.storageEncrypted), StorageType: cdk.stringToCloudFormation(properties.storageType), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), UseLatestRestorableTime: cdk.booleanToCloudFormation(properties.useLatestRestorableTime), VpcSecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.vpcSecurityGroupIds) }) : properties;
    }
    function CfnDBClusterPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allocatedStorage", "AllocatedStorage", properties.AllocatedStorage != null ? cfn_parse.FromCloudFormation.getNumber(properties.AllocatedStorage) : void 0), ret.addPropertyResult("associatedRoles", "AssociatedRoles", properties.AssociatedRoles != null ? cfn_parse.FromCloudFormation.getArray(CfnDBClusterDBClusterRolePropertyFromCloudFormation)(properties.AssociatedRoles) : void 0), ret.addPropertyResult("autoMinorVersionUpgrade", "AutoMinorVersionUpgrade", properties.AutoMinorVersionUpgrade != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AutoMinorVersionUpgrade) : void 0), ret.addPropertyResult("availabilityZones", "AvailabilityZones", properties.AvailabilityZones != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AvailabilityZones) : void 0), ret.addPropertyResult("backtrackWindow", "BacktrackWindow", properties.BacktrackWindow != null ? cfn_parse.FromCloudFormation.getNumber(properties.BacktrackWindow) : void 0), ret.addPropertyResult("backupRetentionPeriod", "BackupRetentionPeriod", properties.BackupRetentionPeriod != null ? cfn_parse.FromCloudFormation.getNumber(properties.BackupRetentionPeriod) : void 0), ret.addPropertyResult("copyTagsToSnapshot", "CopyTagsToSnapshot", properties.CopyTagsToSnapshot != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CopyTagsToSnapshot) : void 0), ret.addPropertyResult("databaseName", "DatabaseName", properties.DatabaseName != null ? cfn_parse.FromCloudFormation.getString(properties.DatabaseName) : void 0), ret.addPropertyResult("dbClusterIdentifier", "DBClusterIdentifier", properties.DBClusterIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.DBClusterIdentifier) : void 0), ret.addPropertyResult("dbClusterInstanceClass", "DBClusterInstanceClass", properties.DBClusterInstanceClass != null ? cfn_parse.FromCloudFormation.getString(properties.DBClusterInstanceClass) : void 0), ret.addPropertyResult("dbClusterParameterGroupName", "DBClusterParameterGroupName", properties.DBClusterParameterGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.DBClusterParameterGroupName) : void 0), ret.addPropertyResult("dbInstanceParameterGroupName", "DBInstanceParameterGroupName", properties.DBInstanceParameterGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.DBInstanceParameterGroupName) : void 0), ret.addPropertyResult("dbSubnetGroupName", "DBSubnetGroupName", properties.DBSubnetGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.DBSubnetGroupName) : void 0), ret.addPropertyResult("dbSystemId", "DBSystemId", properties.DBSystemId != null ? cfn_parse.FromCloudFormation.getString(properties.DBSystemId) : void 0), ret.addPropertyResult("deletionProtection", "DeletionProtection", properties.DeletionProtection != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeletionProtection) : void 0), ret.addPropertyResult("domain", "Domain", properties.Domain != null ? cfn_parse.FromCloudFormation.getString(properties.Domain) : void 0), ret.addPropertyResult("domainIamRoleName", "DomainIAMRoleName", properties.DomainIAMRoleName != null ? cfn_parse.FromCloudFormation.getString(properties.DomainIAMRoleName) : void 0), ret.addPropertyResult("enableCloudwatchLogsExports", "EnableCloudwatchLogsExports", properties.EnableCloudwatchLogsExports != null ? cfn_parse.FromCloudFormation.getStringArray(properties.EnableCloudwatchLogsExports) : void 0), ret.addPropertyResult("enableHttpEndpoint", "EnableHttpEndpoint", properties.EnableHttpEndpoint != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableHttpEndpoint) : void 0), ret.addPropertyResult("enableIamDatabaseAuthentication", "EnableIAMDatabaseAuthentication", properties.EnableIAMDatabaseAuthentication != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableIAMDatabaseAuthentication) : void 0), ret.addPropertyResult("engine", "Engine", properties.Engine != null ? cfn_parse.FromCloudFormation.getString(properties.Engine) : void 0), ret.addPropertyResult("engineMode", "EngineMode", properties.EngineMode != null ? cfn_parse.FromCloudFormation.getString(properties.EngineMode) : void 0), ret.addPropertyResult("engineVersion", "EngineVersion", properties.EngineVersion != null ? cfn_parse.FromCloudFormation.getString(properties.EngineVersion) : void 0), ret.addPropertyResult("globalClusterIdentifier", "GlobalClusterIdentifier", properties.GlobalClusterIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.GlobalClusterIdentifier) : void 0), ret.addPropertyResult("iops", "Iops", properties.Iops != null ? cfn_parse.FromCloudFormation.getNumber(properties.Iops) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("manageMasterUserPassword", "ManageMasterUserPassword", properties.ManageMasterUserPassword != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ManageMasterUserPassword) : void 0), ret.addPropertyResult("masterUsername", "MasterUsername", properties.MasterUsername != null ? cfn_parse.FromCloudFormation.getString(properties.MasterUsername) : void 0), ret.addPropertyResult("masterUserPassword", "MasterUserPassword", properties.MasterUserPassword != null ? cfn_parse.FromCloudFormation.getString(properties.MasterUserPassword) : void 0), ret.addPropertyResult("masterUserSecret", "MasterUserSecret", properties.MasterUserSecret != null ? CfnDBClusterMasterUserSecretPropertyFromCloudFormation(properties.MasterUserSecret) : void 0), ret.addPropertyResult("monitoringInterval", "MonitoringInterval", properties.MonitoringInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.MonitoringInterval) : void 0), ret.addPropertyResult("monitoringRoleArn", "MonitoringRoleArn", properties.MonitoringRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.MonitoringRoleArn) : void 0), ret.addPropertyResult("networkType", "NetworkType", properties.NetworkType != null ? cfn_parse.FromCloudFormation.getString(properties.NetworkType) : void 0), ret.addPropertyResult("performanceInsightsEnabled", "PerformanceInsightsEnabled", properties.PerformanceInsightsEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.PerformanceInsightsEnabled) : void 0), ret.addPropertyResult("performanceInsightsKmsKeyId", "PerformanceInsightsKmsKeyId", properties.PerformanceInsightsKmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.PerformanceInsightsKmsKeyId) : void 0), ret.addPropertyResult("performanceInsightsRetentionPeriod", "PerformanceInsightsRetentionPeriod", properties.PerformanceInsightsRetentionPeriod != null ? cfn_parse.FromCloudFormation.getNumber(properties.PerformanceInsightsRetentionPeriod) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addPropertyResult("preferredBackupWindow", "PreferredBackupWindow", properties.PreferredBackupWindow != null ? cfn_parse.FromCloudFormation.getString(properties.PreferredBackupWindow) : void 0), ret.addPropertyResult("preferredMaintenanceWindow", "PreferredMaintenanceWindow", properties.PreferredMaintenanceWindow != null ? cfn_parse.FromCloudFormation.getString(properties.PreferredMaintenanceWindow) : void 0), ret.addPropertyResult("publiclyAccessible", "PubliclyAccessible", properties.PubliclyAccessible != null ? cfn_parse.FromCloudFormation.getBoolean(properties.PubliclyAccessible) : void 0), ret.addPropertyResult("replicationSourceIdentifier", "ReplicationSourceIdentifier", properties.ReplicationSourceIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.ReplicationSourceIdentifier) : void 0), ret.addPropertyResult("restoreToTime", "RestoreToTime", properties.RestoreToTime != null ? cfn_parse.FromCloudFormation.getString(properties.RestoreToTime) : void 0), ret.addPropertyResult("restoreType", "RestoreType", properties.RestoreType != null ? cfn_parse.FromCloudFormation.getString(properties.RestoreType) : void 0), ret.addPropertyResult("scalingConfiguration", "ScalingConfiguration", properties.ScalingConfiguration != null ? CfnDBClusterScalingConfigurationPropertyFromCloudFormation(properties.ScalingConfiguration) : void 0), ret.addPropertyResult("serverlessV2ScalingConfiguration", "ServerlessV2ScalingConfiguration", properties.ServerlessV2ScalingConfiguration != null ? CfnDBClusterServerlessV2ScalingConfigurationPropertyFromCloudFormation(properties.ServerlessV2ScalingConfiguration) : void 0), ret.addPropertyResult("snapshotIdentifier", "SnapshotIdentifier", properties.SnapshotIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.SnapshotIdentifier) : void 0), ret.addPropertyResult("sourceDbClusterIdentifier", "SourceDBClusterIdentifier", properties.SourceDBClusterIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.SourceDBClusterIdentifier) : void 0), ret.addPropertyResult("sourceRegion", "SourceRegion", properties.SourceRegion != null ? cfn_parse.FromCloudFormation.getString(properties.SourceRegion) : void 0), ret.addPropertyResult("storageEncrypted", "StorageEncrypted", properties.StorageEncrypted != null ? cfn_parse.FromCloudFormation.getBoolean(properties.StorageEncrypted) : void 0), ret.addPropertyResult("storageType", "StorageType", properties.StorageType != null ? cfn_parse.FromCloudFormation.getString(properties.StorageType) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("useLatestRestorableTime", "UseLatestRestorableTime", properties.UseLatestRestorableTime != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseLatestRestorableTime) : void 0), ret.addPropertyResult("vpcSecurityGroupIds", "VpcSecurityGroupIds", properties.VpcSecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.VpcSecurityGroupIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDBCluster = class _CfnDBCluster extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDBClusterPropsFromCloudFormation(resourceProperties), ret = new _CfnDBCluster(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnDBCluster.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_CfnDBClusterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDBCluster), error;
        }
        this.attrDbClusterArn = cdk.Token.asString(this.getAtt("DBClusterArn", cdk.ResolutionTypeHint.STRING)), this.attrDbClusterResourceId = cdk.Token.asString(this.getAtt("DBClusterResourceId", cdk.ResolutionTypeHint.STRING)), this.attrEndpointAddress = cdk.Token.asString(this.getAtt("Endpoint.Address", cdk.ResolutionTypeHint.STRING)), this.attrEndpointPort = cdk.Token.asString(this.getAtt("Endpoint.Port", cdk.ResolutionTypeHint.STRING)), this.attrMasterUserSecretSecretArn = cdk.Token.asString(this.getAtt("MasterUserSecret.SecretArn", cdk.ResolutionTypeHint.STRING)), this.attrReadEndpointAddress = cdk.Token.asString(this.getAtt("ReadEndpoint.Address", cdk.ResolutionTypeHint.STRING)), this.allocatedStorage = props.allocatedStorage, this.associatedRoles = props.associatedRoles, this.autoMinorVersionUpgrade = props.autoMinorVersionUpgrade, this.availabilityZones = props.availabilityZones, this.backtrackWindow = props.backtrackWindow, this.backupRetentionPeriod = props.backupRetentionPeriod, this.copyTagsToSnapshot = props.copyTagsToSnapshot, this.databaseName = props.databaseName, this.dbClusterIdentifier = props.dbClusterIdentifier, this.dbClusterInstanceClass = props.dbClusterInstanceClass, this.dbClusterParameterGroupName = props.dbClusterParameterGroupName, this.dbInstanceParameterGroupName = props.dbInstanceParameterGroupName, this.dbSubnetGroupName = props.dbSubnetGroupName, this.dbSystemId = props.dbSystemId, this.deletionProtection = props.deletionProtection, this.domain = props.domain, this.domainIamRoleName = props.domainIamRoleName, this.enableCloudwatchLogsExports = props.enableCloudwatchLogsExports, this.enableHttpEndpoint = props.enableHttpEndpoint, this.enableIamDatabaseAuthentication = props.enableIamDatabaseAuthentication, this.engine = props.engine, this.engineMode = props.engineMode, this.engineVersion = props.engineVersion, this.globalClusterIdentifier = props.globalClusterIdentifier, this.iops = props.iops, this.kmsKeyId = props.kmsKeyId, this.manageMasterUserPassword = props.manageMasterUserPassword, this.masterUsername = props.masterUsername, this.masterUserPassword = props.masterUserPassword, this.masterUserSecret = props.masterUserSecret, this.monitoringInterval = props.monitoringInterval, this.monitoringRoleArn = props.monitoringRoleArn, this.networkType = props.networkType, this.performanceInsightsEnabled = props.performanceInsightsEnabled, this.performanceInsightsKmsKeyId = props.performanceInsightsKmsKeyId, this.performanceInsightsRetentionPeriod = props.performanceInsightsRetentionPeriod, this.port = props.port, this.preferredBackupWindow = props.preferredBackupWindow, this.preferredMaintenanceWindow = props.preferredMaintenanceWindow, this.publiclyAccessible = props.publiclyAccessible, this.replicationSourceIdentifier = props.replicationSourceIdentifier, this.restoreToTime = props.restoreToTime, this.restoreType = props.restoreType, this.scalingConfiguration = props.scalingConfiguration, this.serverlessV2ScalingConfiguration = props.serverlessV2ScalingConfiguration, this.snapshotIdentifier = props.snapshotIdentifier, this.sourceDbClusterIdentifier = props.sourceDbClusterIdentifier, this.sourceRegion = props.sourceRegion, this.storageEncrypted = props.storageEncrypted, this.storageType = props.storageType, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::RDS::DBCluster", props.tags, { tagPropertyName: "tags" }), this.useLatestRestorableTime = props.useLatestRestorableTime, this.vpcSecurityGroupIds = props.vpcSecurityGroupIds, this.node.scope && cdk.Resource.isResource(this.node.scope) && this.node.addValidation({ validate: () => this.cfnOptions.deletionPolicy === void 0 ? ["'AWS::RDS::DBCluster' is a stateful resource type, and you must specify a Removal Policy for it. Call 'resource.applyRemovalPolicy()'."] : [] });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDBCluster.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { allocatedStorage: this.allocatedStorage, associatedRoles: this.associatedRoles, autoMinorVersionUpgrade: this.autoMinorVersionUpgrade, availabilityZones: this.availabilityZones, backtrackWindow: this.backtrackWindow, backupRetentionPeriod: this.backupRetentionPeriod, copyTagsToSnapshot: this.copyTagsToSnapshot, databaseName: this.databaseName, dbClusterIdentifier: this.dbClusterIdentifier, dbClusterInstanceClass: this.dbClusterInstanceClass, dbClusterParameterGroupName: this.dbClusterParameterGroupName, dbInstanceParameterGroupName: this.dbInstanceParameterGroupName, dbSubnetGroupName: this.dbSubnetGroupName, dbSystemId: this.dbSystemId, deletionProtection: this.deletionProtection, domain: this.domain, domainIamRoleName: this.domainIamRoleName, enableCloudwatchLogsExports: this.enableCloudwatchLogsExports, enableHttpEndpoint: this.enableHttpEndpoint, enableIamDatabaseAuthentication: this.enableIamDatabaseAuthentication, engine: this.engine, engineMode: this.engineMode, engineVersion: this.engineVersion, globalClusterIdentifier: this.globalClusterIdentifier, iops: this.iops, kmsKeyId: this.kmsKeyId, manageMasterUserPassword: this.manageMasterUserPassword, masterUsername: this.masterUsername, masterUserPassword: this.masterUserPassword, masterUserSecret: this.masterUserSecret, monitoringInterval: this.monitoringInterval, monitoringRoleArn: this.monitoringRoleArn, networkType: this.networkType, performanceInsightsEnabled: this.performanceInsightsEnabled, performanceInsightsKmsKeyId: this.performanceInsightsKmsKeyId, performanceInsightsRetentionPeriod: this.performanceInsightsRetentionPeriod, port: this.port, preferredBackupWindow: this.preferredBackupWindow, preferredMaintenanceWindow: this.preferredMaintenanceWindow, publiclyAccessible: this.publiclyAccessible, replicationSourceIdentifier: this.replicationSourceIdentifier, restoreToTime: this.restoreToTime, restoreType: this.restoreType, scalingConfiguration: this.scalingConfiguration, serverlessV2ScalingConfiguration: this.serverlessV2ScalingConfiguration, snapshotIdentifier: this.snapshotIdentifier, sourceDbClusterIdentifier: this.sourceDbClusterIdentifier, sourceRegion: this.sourceRegion, storageEncrypted: this.storageEncrypted, storageType: this.storageType, tags: this.tags.renderTags(), useLatestRestorableTime: this.useLatestRestorableTime, vpcSecurityGroupIds: this.vpcSecurityGroupIds };
      }
      renderProperties(props) {
        return cfnDBClusterPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnDBCluster[_a] = { fqn: "aws-cdk-lib.aws_rds.CfnDBCluster", version: "2.80.0" }, CfnDBCluster.CFN_RESOURCE_TYPE_NAME = "AWS::RDS::DBCluster", exports2.CfnDBCluster = CfnDBCluster;
    function CfnDBCluster_DBClusterRolePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("featureName", cdk.validateString)(properties.featureName)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "DBClusterRoleProperty"');
    }
    function cfnDBClusterDBClusterRolePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBCluster_DBClusterRolePropertyValidator(properties).assertSuccess(), { FeatureName: cdk.stringToCloudFormation(properties.featureName), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnDBClusterDBClusterRolePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("featureName", "FeatureName", properties.FeatureName != null ? cfn_parse.FromCloudFormation.getString(properties.FeatureName) : void 0), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDBCluster_MasterUserSecretPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("secretArn", cdk.validateString)(properties.secretArn)), errors.wrap('supplied properties not correct for "MasterUserSecretProperty"');
    }
    function cfnDBClusterMasterUserSecretPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBCluster_MasterUserSecretPropertyValidator(properties).assertSuccess(), { KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), SecretArn: cdk.stringToCloudFormation(properties.secretArn) }) : properties;
    }
    function CfnDBClusterMasterUserSecretPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("secretArn", "SecretArn", properties.SecretArn != null ? cfn_parse.FromCloudFormation.getString(properties.SecretArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDBCluster_ScalingConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoPause", cdk.validateBoolean)(properties.autoPause)), errors.collect(cdk.propertyValidator("maxCapacity", cdk.validateNumber)(properties.maxCapacity)), errors.collect(cdk.propertyValidator("minCapacity", cdk.validateNumber)(properties.minCapacity)), errors.collect(cdk.propertyValidator("secondsBeforeTimeout", cdk.validateNumber)(properties.secondsBeforeTimeout)), errors.collect(cdk.propertyValidator("secondsUntilAutoPause", cdk.validateNumber)(properties.secondsUntilAutoPause)), errors.collect(cdk.propertyValidator("timeoutAction", cdk.validateString)(properties.timeoutAction)), errors.wrap('supplied properties not correct for "ScalingConfigurationProperty"');
    }
    function cfnDBClusterScalingConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBCluster_ScalingConfigurationPropertyValidator(properties).assertSuccess(), { AutoPause: cdk.booleanToCloudFormation(properties.autoPause), MaxCapacity: cdk.numberToCloudFormation(properties.maxCapacity), MinCapacity: cdk.numberToCloudFormation(properties.minCapacity), SecondsBeforeTimeout: cdk.numberToCloudFormation(properties.secondsBeforeTimeout), SecondsUntilAutoPause: cdk.numberToCloudFormation(properties.secondsUntilAutoPause), TimeoutAction: cdk.stringToCloudFormation(properties.timeoutAction) }) : properties;
    }
    function CfnDBClusterScalingConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("autoPause", "AutoPause", properties.AutoPause != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AutoPause) : void 0), ret.addPropertyResult("maxCapacity", "MaxCapacity", properties.MaxCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxCapacity) : void 0), ret.addPropertyResult("minCapacity", "MinCapacity", properties.MinCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinCapacity) : void 0), ret.addPropertyResult("secondsBeforeTimeout", "SecondsBeforeTimeout", properties.SecondsBeforeTimeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.SecondsBeforeTimeout) : void 0), ret.addPropertyResult("secondsUntilAutoPause", "SecondsUntilAutoPause", properties.SecondsUntilAutoPause != null ? cfn_parse.FromCloudFormation.getNumber(properties.SecondsUntilAutoPause) : void 0), ret.addPropertyResult("timeoutAction", "TimeoutAction", properties.TimeoutAction != null ? cfn_parse.FromCloudFormation.getString(properties.TimeoutAction) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDBCluster_ServerlessV2ScalingConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxCapacity", cdk.validateNumber)(properties.maxCapacity)), errors.collect(cdk.propertyValidator("minCapacity", cdk.validateNumber)(properties.minCapacity)), errors.wrap('supplied properties not correct for "ServerlessV2ScalingConfigurationProperty"');
    }
    function cfnDBClusterServerlessV2ScalingConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBCluster_ServerlessV2ScalingConfigurationPropertyValidator(properties).assertSuccess(), { MaxCapacity: cdk.numberToCloudFormation(properties.maxCapacity), MinCapacity: cdk.numberToCloudFormation(properties.minCapacity) }) : properties;
    }
    function CfnDBClusterServerlessV2ScalingConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxCapacity", "MaxCapacity", properties.MaxCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxCapacity) : void 0), ret.addPropertyResult("minCapacity", "MinCapacity", properties.MinCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinCapacity) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDBClusterParameterGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dbClusterParameterGroupName", cdk.validateString)(properties.dbClusterParameterGroupName)), errors.collect(cdk.propertyValidator("description", cdk.requiredValidator)(properties.description)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("family", cdk.requiredValidator)(properties.family)), errors.collect(cdk.propertyValidator("family", cdk.validateString)(properties.family)), errors.collect(cdk.propertyValidator("parameters", cdk.requiredValidator)(properties.parameters)), errors.collect(cdk.propertyValidator("parameters", cdk.validateObject)(properties.parameters)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDBClusterParameterGroupProps"');
    }
    function cfnDBClusterParameterGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBClusterParameterGroupPropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), Family: cdk.stringToCloudFormation(properties.family), Parameters: cdk.objectToCloudFormation(properties.parameters), DBClusterParameterGroupName: cdk.stringToCloudFormation(properties.dbClusterParameterGroupName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDBClusterParameterGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", cfn_parse.FromCloudFormation.getString(properties.Description)), ret.addPropertyResult("family", "Family", cfn_parse.FromCloudFormation.getString(properties.Family)), ret.addPropertyResult("parameters", "Parameters", cfn_parse.FromCloudFormation.getAny(properties.Parameters)), ret.addPropertyResult("dbClusterParameterGroupName", "DBClusterParameterGroupName", properties.DBClusterParameterGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.DBClusterParameterGroupName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDBClusterParameterGroup = class _CfnDBClusterParameterGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDBClusterParameterGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnDBClusterParameterGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDBClusterParameterGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_CfnDBClusterParameterGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDBClusterParameterGroup), error;
        }
        cdk.requireProperty(props, "description", this), cdk.requireProperty(props, "family", this), cdk.requireProperty(props, "parameters", this), this.description = props.description, this.family = props.family, this.parameters = props.parameters, this.dbClusterParameterGroupName = props.dbClusterParameterGroupName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::RDS::DBClusterParameterGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDBClusterParameterGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, family: this.family, parameters: this.parameters, dbClusterParameterGroupName: this.dbClusterParameterGroupName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDBClusterParameterGroupPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnDBClusterParameterGroup[_b] = { fqn: "aws-cdk-lib.aws_rds.CfnDBClusterParameterGroup", version: "2.80.0" }, CfnDBClusterParameterGroup.CFN_RESOURCE_TYPE_NAME = "AWS::RDS::DBClusterParameterGroup", exports2.CfnDBClusterParameterGroup = CfnDBClusterParameterGroup;
    function CfnDBInstancePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allocatedStorage", cdk.validateString)(properties.allocatedStorage)), errors.collect(cdk.propertyValidator("allowMajorVersionUpgrade", cdk.validateBoolean)(properties.allowMajorVersionUpgrade)), errors.collect(cdk.propertyValidator("associatedRoles", cdk.listValidator(CfnDBInstance_DBInstanceRolePropertyValidator))(properties.associatedRoles)), errors.collect(cdk.propertyValidator("autoMinorVersionUpgrade", cdk.validateBoolean)(properties.autoMinorVersionUpgrade)), errors.collect(cdk.propertyValidator("availabilityZone", cdk.validateString)(properties.availabilityZone)), errors.collect(cdk.propertyValidator("backupRetentionPeriod", cdk.validateNumber)(properties.backupRetentionPeriod)), errors.collect(cdk.propertyValidator("caCertificateIdentifier", cdk.validateString)(properties.caCertificateIdentifier)), errors.collect(cdk.propertyValidator("certificateDetails", CfnDBInstance_CertificateDetailsPropertyValidator)(properties.certificateDetails)), errors.collect(cdk.propertyValidator("certificateRotationRestart", cdk.validateBoolean)(properties.certificateRotationRestart)), errors.collect(cdk.propertyValidator("characterSetName", cdk.validateString)(properties.characterSetName)), errors.collect(cdk.propertyValidator("copyTagsToSnapshot", cdk.validateBoolean)(properties.copyTagsToSnapshot)), errors.collect(cdk.propertyValidator("customIamInstanceProfile", cdk.validateString)(properties.customIamInstanceProfile)), errors.collect(cdk.propertyValidator("dbClusterIdentifier", cdk.validateString)(properties.dbClusterIdentifier)), errors.collect(cdk.propertyValidator("dbClusterSnapshotIdentifier", cdk.validateString)(properties.dbClusterSnapshotIdentifier)), errors.collect(cdk.propertyValidator("dbInstanceClass", cdk.validateString)(properties.dbInstanceClass)), errors.collect(cdk.propertyValidator("dbInstanceIdentifier", cdk.validateString)(properties.dbInstanceIdentifier)), errors.collect(cdk.propertyValidator("dbName", cdk.validateString)(properties.dbName)), errors.collect(cdk.propertyValidator("dbParameterGroupName", cdk.validateString)(properties.dbParameterGroupName)), errors.collect(cdk.propertyValidator("dbSecurityGroups", cdk.listValidator(cdk.validateString))(properties.dbSecurityGroups)), errors.collect(cdk.propertyValidator("dbSnapshotIdentifier", cdk.validateString)(properties.dbSnapshotIdentifier)), errors.collect(cdk.propertyValidator("dbSubnetGroupName", cdk.validateString)(properties.dbSubnetGroupName)), errors.collect(cdk.propertyValidator("deleteAutomatedBackups", cdk.validateBoolean)(properties.deleteAutomatedBackups)), errors.collect(cdk.propertyValidator("deletionProtection", cdk.validateBoolean)(properties.deletionProtection)), errors.collect(cdk.propertyValidator("domain", cdk.validateString)(properties.domain)), errors.collect(cdk.propertyValidator("domainIamRoleName", cdk.validateString)(properties.domainIamRoleName)), errors.collect(cdk.propertyValidator("enableCloudwatchLogsExports", cdk.listValidator(cdk.validateString))(properties.enableCloudwatchLogsExports)), errors.collect(cdk.propertyValidator("enableIamDatabaseAuthentication", cdk.validateBoolean)(properties.enableIamDatabaseAuthentication)), errors.collect(cdk.propertyValidator("enablePerformanceInsights", cdk.validateBoolean)(properties.enablePerformanceInsights)), errors.collect(cdk.propertyValidator("endpoint", CfnDBInstance_EndpointPropertyValidator)(properties.endpoint)), errors.collect(cdk.propertyValidator("engine", cdk.validateString)(properties.engine)), errors.collect(cdk.propertyValidator("engineVersion", cdk.validateString)(properties.engineVersion)), errors.collect(cdk.propertyValidator("iops", cdk.validateNumber)(properties.iops)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("licenseModel", cdk.validateString)(properties.licenseModel)), errors.collect(cdk.propertyValidator("manageMasterUserPassword", cdk.validateBoolean)(properties.manageMasterUserPassword)), errors.collect(cdk.propertyValidator("masterUserPassword", cdk.validateString)(properties.masterUserPassword)), errors.collect(cdk.propertyValidator("masterUserSecret", CfnDBInstance_MasterUserSecretPropertyValidator)(properties.masterUserSecret)), errors.collect(cdk.propertyValidator("masterUsername", cdk.validateString)(properties.masterUsername)), errors.collect(cdk.propertyValidator("maxAllocatedStorage", cdk.validateNumber)(properties.maxAllocatedStorage)), errors.collect(cdk.propertyValidator("monitoringInterval", cdk.validateNumber)(properties.monitoringInterval)), errors.collect(cdk.propertyValidator("monitoringRoleArn", cdk.validateString)(properties.monitoringRoleArn)), errors.collect(cdk.propertyValidator("multiAz", cdk.validateBoolean)(properties.multiAz)), errors.collect(cdk.propertyValidator("ncharCharacterSetName", cdk.validateString)(properties.ncharCharacterSetName)), errors.collect(cdk.propertyValidator("networkType", cdk.validateString)(properties.networkType)), errors.collect(cdk.propertyValidator("optionGroupName", cdk.validateString)(properties.optionGroupName)), errors.collect(cdk.propertyValidator("performanceInsightsKmsKeyId", cdk.validateString)(properties.performanceInsightsKmsKeyId)), errors.collect(cdk.propertyValidator("performanceInsightsRetentionPeriod", cdk.validateNumber)(properties.performanceInsightsRetentionPeriod)), errors.collect(cdk.propertyValidator("port", cdk.validateString)(properties.port)), errors.collect(cdk.propertyValidator("preferredBackupWindow", cdk.validateString)(properties.preferredBackupWindow)), errors.collect(cdk.propertyValidator("preferredMaintenanceWindow", cdk.validateString)(properties.preferredMaintenanceWindow)), errors.collect(cdk.propertyValidator("processorFeatures", cdk.listValidator(CfnDBInstance_ProcessorFeaturePropertyValidator))(properties.processorFeatures)), errors.collect(cdk.propertyValidator("promotionTier", cdk.validateNumber)(properties.promotionTier)), errors.collect(cdk.propertyValidator("publiclyAccessible", cdk.validateBoolean)(properties.publiclyAccessible)), errors.collect(cdk.propertyValidator("replicaMode", cdk.validateString)(properties.replicaMode)), errors.collect(cdk.propertyValidator("restoreTime", cdk.validateString)(properties.restoreTime)), errors.collect(cdk.propertyValidator("sourceDbClusterIdentifier", cdk.validateString)(properties.sourceDbClusterIdentifier)), errors.collect(cdk.propertyValidator("sourceDbInstanceAutomatedBackupsArn", cdk.validateString)(properties.sourceDbInstanceAutomatedBackupsArn)), errors.collect(cdk.propertyValidator("sourceDbInstanceIdentifier", cdk.validateString)(properties.sourceDbInstanceIdentifier)), errors.collect(cdk.propertyValidator("sourceDbiResourceId", cdk.validateString)(properties.sourceDbiResourceId)), errors.collect(cdk.propertyValidator("sourceRegion", cdk.validateString)(properties.sourceRegion)), errors.collect(cdk.propertyValidator("storageEncrypted", cdk.validateBoolean)(properties.storageEncrypted)), errors.collect(cdk.propertyValidator("storageThroughput", cdk.validateNumber)(properties.storageThroughput)), errors.collect(cdk.propertyValidator("storageType", cdk.validateString)(properties.storageType)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("timezone", cdk.validateString)(properties.timezone)), errors.collect(cdk.propertyValidator("useDefaultProcessorFeatures", cdk.validateBoolean)(properties.useDefaultProcessorFeatures)), errors.collect(cdk.propertyValidator("useLatestRestorableTime", cdk.validateBoolean)(properties.useLatestRestorableTime)), errors.collect(cdk.propertyValidator("vpcSecurityGroups", cdk.listValidator(cdk.validateString))(properties.vpcSecurityGroups)), errors.wrap('supplied properties not correct for "CfnDBInstanceProps"');
    }
    function cfnDBInstancePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBInstancePropsValidator(properties).assertSuccess(), { AllocatedStorage: cdk.stringToCloudFormation(properties.allocatedStorage), AllowMajorVersionUpgrade: cdk.booleanToCloudFormation(properties.allowMajorVersionUpgrade), AssociatedRoles: cdk.listMapper(cfnDBInstanceDBInstanceRolePropertyToCloudFormation)(properties.associatedRoles), AutoMinorVersionUpgrade: cdk.booleanToCloudFormation(properties.autoMinorVersionUpgrade), AvailabilityZone: cdk.stringToCloudFormation(properties.availabilityZone), BackupRetentionPeriod: cdk.numberToCloudFormation(properties.backupRetentionPeriod), CACertificateIdentifier: cdk.stringToCloudFormation(properties.caCertificateIdentifier), CertificateDetails: cfnDBInstanceCertificateDetailsPropertyToCloudFormation(properties.certificateDetails), CertificateRotationRestart: cdk.booleanToCloudFormation(properties.certificateRotationRestart), CharacterSetName: cdk.stringToCloudFormation(properties.characterSetName), CopyTagsToSnapshot: cdk.booleanToCloudFormation(properties.copyTagsToSnapshot), CustomIAMInstanceProfile: cdk.stringToCloudFormation(properties.customIamInstanceProfile), DBClusterIdentifier: cdk.stringToCloudFormation(properties.dbClusterIdentifier), DBClusterSnapshotIdentifier: cdk.stringToCloudFormation(properties.dbClusterSnapshotIdentifier), DBInstanceClass: cdk.stringToCloudFormation(properties.dbInstanceClass), DBInstanceIdentifier: cdk.stringToCloudFormation(properties.dbInstanceIdentifier), DBName: cdk.stringToCloudFormation(properties.dbName), DBParameterGroupName: cdk.stringToCloudFormation(properties.dbParameterGroupName), DBSecurityGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.dbSecurityGroups), DBSnapshotIdentifier: cdk.stringToCloudFormation(properties.dbSnapshotIdentifier), DBSubnetGroupName: cdk.stringToCloudFormation(properties.dbSubnetGroupName), DeleteAutomatedBackups: cdk.booleanToCloudFormation(properties.deleteAutomatedBackups), DeletionProtection: cdk.booleanToCloudFormation(properties.deletionProtection), Domain: cdk.stringToCloudFormation(properties.domain), DomainIAMRoleName: cdk.stringToCloudFormation(properties.domainIamRoleName), EnableCloudwatchLogsExports: cdk.listMapper(cdk.stringToCloudFormation)(properties.enableCloudwatchLogsExports), EnableIAMDatabaseAuthentication: cdk.booleanToCloudFormation(properties.enableIamDatabaseAuthentication), EnablePerformanceInsights: cdk.booleanToCloudFormation(properties.enablePerformanceInsights), Endpoint: cfnDBInstanceEndpointPropertyToCloudFormation(properties.endpoint), Engine: cdk.stringToCloudFormation(properties.engine), EngineVersion: cdk.stringToCloudFormation(properties.engineVersion), Iops: cdk.numberToCloudFormation(properties.iops), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), LicenseModel: cdk.stringToCloudFormation(properties.licenseModel), ManageMasterUserPassword: cdk.booleanToCloudFormation(properties.manageMasterUserPassword), MasterUsername: cdk.stringToCloudFormation(properties.masterUsername), MasterUserPassword: cdk.stringToCloudFormation(properties.masterUserPassword), MasterUserSecret: cfnDBInstanceMasterUserSecretPropertyToCloudFormation(properties.masterUserSecret), MaxAllocatedStorage: cdk.numberToCloudFormation(properties.maxAllocatedStorage), MonitoringInterval: cdk.numberToCloudFormation(properties.monitoringInterval), MonitoringRoleArn: cdk.stringToCloudFormation(properties.monitoringRoleArn), MultiAZ: cdk.booleanToCloudFormation(properties.multiAz), NcharCharacterSetName: cdk.stringToCloudFormation(properties.ncharCharacterSetName), NetworkType: cdk.stringToCloudFormation(properties.networkType), OptionGroupName: cdk.stringToCloudFormation(properties.optionGroupName), PerformanceInsightsKMSKeyId: cdk.stringToCloudFormation(properties.performanceInsightsKmsKeyId), PerformanceInsightsRetentionPeriod: cdk.numberToCloudFormation(properties.performanceInsightsRetentionPeriod), Port: cdk.stringToCloudFormation(properties.port), PreferredBackupWindow: cdk.stringToCloudFormation(properties.preferredBackupWindow), PreferredMaintenanceWindow: cdk.stringToCloudFormation(properties.preferredMaintenanceWindow), ProcessorFeatures: cdk.listMapper(cfnDBInstanceProcessorFeaturePropertyToCloudFormation)(properties.processorFeatures), PromotionTier: cdk.numberToCloudFormation(properties.promotionTier), PubliclyAccessible: cdk.booleanToCloudFormation(properties.publiclyAccessible), ReplicaMode: cdk.stringToCloudFormation(properties.replicaMode), RestoreTime: cdk.stringToCloudFormation(properties.restoreTime), SourceDBClusterIdentifier: cdk.stringToCloudFormation(properties.sourceDbClusterIdentifier), SourceDBInstanceAutomatedBackupsArn: cdk.stringToCloudFormation(properties.sourceDbInstanceAutomatedBackupsArn), SourceDBInstanceIdentifier: cdk.stringToCloudFormation(properties.sourceDbInstanceIdentifier), SourceDbiResourceId: cdk.stringToCloudFormation(properties.sourceDbiResourceId), SourceRegion: cdk.stringToCloudFormation(properties.sourceRegion), StorageEncrypted: cdk.booleanToCloudFormation(properties.storageEncrypted), StorageThroughput: cdk.numberToCloudFormation(properties.storageThroughput), StorageType: cdk.stringToCloudFormation(properties.storageType), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), Timezone: cdk.stringToCloudFormation(properties.timezone), UseDefaultProcessorFeatures: cdk.booleanToCloudFormation(properties.useDefaultProcessorFeatures), UseLatestRestorableTime: cdk.booleanToCloudFormation(properties.useLatestRestorableTime), VPCSecurityGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.vpcSecurityGroups) }) : properties;
    }
    function CfnDBInstancePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allocatedStorage", "AllocatedStorage", properties.AllocatedStorage != null ? cfn_parse.FromCloudFormation.getString(properties.AllocatedStorage) : void 0), ret.addPropertyResult("allowMajorVersionUpgrade", "AllowMajorVersionUpgrade", properties.AllowMajorVersionUpgrade != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllowMajorVersionUpgrade) : void 0), ret.addPropertyResult("associatedRoles", "AssociatedRoles", properties.AssociatedRoles != null ? cfn_parse.FromCloudFormation.getArray(CfnDBInstanceDBInstanceRolePropertyFromCloudFormation)(properties.AssociatedRoles) : void 0), ret.addPropertyResult("autoMinorVersionUpgrade", "AutoMinorVersionUpgrade", properties.AutoMinorVersionUpgrade != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AutoMinorVersionUpgrade) : void 0), ret.addPropertyResult("availabilityZone", "AvailabilityZone", properties.AvailabilityZone != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityZone) : void 0), ret.addPropertyResult("backupRetentionPeriod", "BackupRetentionPeriod", properties.BackupRetentionPeriod != null ? cfn_parse.FromCloudFormation.getNumber(properties.BackupRetentionPeriod) : void 0), ret.addPropertyResult("caCertificateIdentifier", "CACertificateIdentifier", properties.CACertificateIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.CACertificateIdentifier) : void 0), ret.addPropertyResult("certificateDetails", "CertificateDetails", properties.CertificateDetails != null ? CfnDBInstanceCertificateDetailsPropertyFromCloudFormation(properties.CertificateDetails) : void 0), ret.addPropertyResult("certificateRotationRestart", "CertificateRotationRestart", properties.CertificateRotationRestart != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CertificateRotationRestart) : void 0), ret.addPropertyResult("characterSetName", "CharacterSetName", properties.CharacterSetName != null ? cfn_parse.FromCloudFormation.getString(properties.CharacterSetName) : void 0), ret.addPropertyResult("copyTagsToSnapshot", "CopyTagsToSnapshot", properties.CopyTagsToSnapshot != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CopyTagsToSnapshot) : void 0), ret.addPropertyResult("customIamInstanceProfile", "CustomIAMInstanceProfile", properties.CustomIAMInstanceProfile != null ? cfn_parse.FromCloudFormation.getString(properties.CustomIAMInstanceProfile) : void 0), ret.addPropertyResult("dbClusterIdentifier", "DBClusterIdentifier", properties.DBClusterIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.DBClusterIdentifier) : void 0), ret.addPropertyResult("dbClusterSnapshotIdentifier", "DBClusterSnapshotIdentifier", properties.DBClusterSnapshotIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.DBClusterSnapshotIdentifier) : void 0), ret.addPropertyResult("dbInstanceClass", "DBInstanceClass", properties.DBInstanceClass != null ? cfn_parse.FromCloudFormation.getString(properties.DBInstanceClass) : void 0), ret.addPropertyResult("dbInstanceIdentifier", "DBInstanceIdentifier", properties.DBInstanceIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.DBInstanceIdentifier) : void 0), ret.addPropertyResult("dbName", "DBName", properties.DBName != null ? cfn_parse.FromCloudFormation.getString(properties.DBName) : void 0), ret.addPropertyResult("dbParameterGroupName", "DBParameterGroupName", properties.DBParameterGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.DBParameterGroupName) : void 0), ret.addPropertyResult("dbSecurityGroups", "DBSecurityGroups", properties.DBSecurityGroups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.DBSecurityGroups) : void 0), ret.addPropertyResult("dbSnapshotIdentifier", "DBSnapshotIdentifier", properties.DBSnapshotIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.DBSnapshotIdentifier) : void 0), ret.addPropertyResult("dbSubnetGroupName", "DBSubnetGroupName", properties.DBSubnetGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.DBSubnetGroupName) : void 0), ret.addPropertyResult("deleteAutomatedBackups", "DeleteAutomatedBackups", properties.DeleteAutomatedBackups != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeleteAutomatedBackups) : void 0), ret.addPropertyResult("deletionProtection", "DeletionProtection", properties.DeletionProtection != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeletionProtection) : void 0), ret.addPropertyResult("domain", "Domain", properties.Domain != null ? cfn_parse.FromCloudFormation.getString(properties.Domain) : void 0), ret.addPropertyResult("domainIamRoleName", "DomainIAMRoleName", properties.DomainIAMRoleName != null ? cfn_parse.FromCloudFormation.getString(properties.DomainIAMRoleName) : void 0), ret.addPropertyResult("enableCloudwatchLogsExports", "EnableCloudwatchLogsExports", properties.EnableCloudwatchLogsExports != null ? cfn_parse.FromCloudFormation.getStringArray(properties.EnableCloudwatchLogsExports) : void 0), ret.addPropertyResult("enableIamDatabaseAuthentication", "EnableIAMDatabaseAuthentication", properties.EnableIAMDatabaseAuthentication != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableIAMDatabaseAuthentication) : void 0), ret.addPropertyResult("enablePerformanceInsights", "EnablePerformanceInsights", properties.EnablePerformanceInsights != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnablePerformanceInsights) : void 0), ret.addPropertyResult("endpoint", "Endpoint", properties.Endpoint != null ? CfnDBInstanceEndpointPropertyFromCloudFormation(properties.Endpoint) : void 0), ret.addPropertyResult("engine", "Engine", properties.Engine != null ? cfn_parse.FromCloudFormation.getString(properties.Engine) : void 0), ret.addPropertyResult("engineVersion", "EngineVersion", properties.EngineVersion != null ? cfn_parse.FromCloudFormation.getString(properties.EngineVersion) : void 0), ret.addPropertyResult("iops", "Iops", properties.Iops != null ? cfn_parse.FromCloudFormation.getNumber(properties.Iops) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("licenseModel", "LicenseModel", properties.LicenseModel != null ? cfn_parse.FromCloudFormation.getString(properties.LicenseModel) : void 0), ret.addPropertyResult("manageMasterUserPassword", "ManageMasterUserPassword", properties.ManageMasterUserPassword != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ManageMasterUserPassword) : void 0), ret.addPropertyResult("masterUsername", "MasterUsername", properties.MasterUsername != null ? cfn_parse.FromCloudFormation.getString(properties.MasterUsername) : void 0), ret.addPropertyResult("masterUserPassword", "MasterUserPassword", properties.MasterUserPassword != null ? cfn_parse.FromCloudFormation.getString(properties.MasterUserPassword) : void 0), ret.addPropertyResult("masterUserSecret", "MasterUserSecret", properties.MasterUserSecret != null ? CfnDBInstanceMasterUserSecretPropertyFromCloudFormation(properties.MasterUserSecret) : void 0), ret.addPropertyResult("maxAllocatedStorage", "MaxAllocatedStorage", properties.MaxAllocatedStorage != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxAllocatedStorage) : void 0), ret.addPropertyResult("monitoringInterval", "MonitoringInterval", properties.MonitoringInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.MonitoringInterval) : void 0), ret.addPropertyResult("monitoringRoleArn", "MonitoringRoleArn", properties.MonitoringRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.MonitoringRoleArn) : void 0), ret.addPropertyResult("multiAz", "MultiAZ", properties.MultiAZ != null ? cfn_parse.FromCloudFormation.getBoolean(properties.MultiAZ) : void 0), ret.addPropertyResult("ncharCharacterSetName", "NcharCharacterSetName", properties.NcharCharacterSetName != null ? cfn_parse.FromCloudFormation.getString(properties.NcharCharacterSetName) : void 0), ret.addPropertyResult("networkType", "NetworkType", properties.NetworkType != null ? cfn_parse.FromCloudFormation.getString(properties.NetworkType) : void 0), ret.addPropertyResult("optionGroupName", "OptionGroupName", properties.OptionGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.OptionGroupName) : void 0), ret.addPropertyResult("performanceInsightsKmsKeyId", "PerformanceInsightsKMSKeyId", properties.PerformanceInsightsKMSKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.PerformanceInsightsKMSKeyId) : void 0), ret.addPropertyResult("performanceInsightsRetentionPeriod", "PerformanceInsightsRetentionPeriod", properties.PerformanceInsightsRetentionPeriod != null ? cfn_parse.FromCloudFormation.getNumber(properties.PerformanceInsightsRetentionPeriod) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getString(properties.Port) : void 0), ret.addPropertyResult("preferredBackupWindow", "PreferredBackupWindow", properties.PreferredBackupWindow != null ? cfn_parse.FromCloudFormation.getString(properties.PreferredBackupWindow) : void 0), ret.addPropertyResult("preferredMaintenanceWindow", "PreferredMaintenanceWindow", properties.PreferredMaintenanceWindow != null ? cfn_parse.FromCloudFormation.getString(properties.PreferredMaintenanceWindow) : void 0), ret.addPropertyResult("processorFeatures", "ProcessorFeatures", properties.ProcessorFeatures != null ? cfn_parse.FromCloudFormation.getArray(CfnDBInstanceProcessorFeaturePropertyFromCloudFormation)(properties.ProcessorFeatures) : void 0), ret.addPropertyResult("promotionTier", "PromotionTier", properties.PromotionTier != null ? cfn_parse.FromCloudFormation.getNumber(properties.PromotionTier) : void 0), ret.addPropertyResult("publiclyAccessible", "PubliclyAccessible", properties.PubliclyAccessible != null ? cfn_parse.FromCloudFormation.getBoolean(properties.PubliclyAccessible) : void 0), ret.addPropertyResult("replicaMode", "ReplicaMode", properties.ReplicaMode != null ? cfn_parse.FromCloudFormation.getString(properties.ReplicaMode) : void 0), ret.addPropertyResult("restoreTime", "RestoreTime", properties.RestoreTime != null ? cfn_parse.FromCloudFormation.getString(properties.RestoreTime) : void 0), ret.addPropertyResult("sourceDbClusterIdentifier", "SourceDBClusterIdentifier", properties.SourceDBClusterIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.SourceDBClusterIdentifier) : void 0), ret.addPropertyResult("sourceDbInstanceAutomatedBackupsArn", "SourceDBInstanceAutomatedBackupsArn", properties.SourceDBInstanceAutomatedBackupsArn != null ? cfn_parse.FromCloudFormation.getString(properties.SourceDBInstanceAutomatedBackupsArn) : void 0), ret.addPropertyResult("sourceDbInstanceIdentifier", "SourceDBInstanceIdentifier", properties.SourceDBInstanceIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.SourceDBInstanceIdentifier) : void 0), ret.addPropertyResult("sourceDbiResourceId", "SourceDbiResourceId", properties.SourceDbiResourceId != null ? cfn_parse.FromCloudFormation.getString(properties.SourceDbiResourceId) : void 0), ret.addPropertyResult("sourceRegion", "SourceRegion", properties.SourceRegion != null ? cfn_parse.FromCloudFormation.getString(properties.SourceRegion) : void 0), ret.addPropertyResult("storageEncrypted", "StorageEncrypted", properties.StorageEncrypted != null ? cfn_parse.FromCloudFormation.getBoolean(properties.StorageEncrypted) : void 0), ret.addPropertyResult("storageThroughput", "StorageThroughput", properties.StorageThroughput != null ? cfn_parse.FromCloudFormation.getNumber(properties.StorageThroughput) : void 0), ret.addPropertyResult("storageType", "StorageType", properties.StorageType != null ? cfn_parse.FromCloudFormation.getString(properties.StorageType) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("timezone", "Timezone", properties.Timezone != null ? cfn_parse.FromCloudFormation.getString(properties.Timezone) : void 0), ret.addPropertyResult("useDefaultProcessorFeatures", "UseDefaultProcessorFeatures", properties.UseDefaultProcessorFeatures != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseDefaultProcessorFeatures) : void 0), ret.addPropertyResult("useLatestRestorableTime", "UseLatestRestorableTime", properties.UseLatestRestorableTime != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseLatestRestorableTime) : void 0), ret.addPropertyResult("vpcSecurityGroups", "VPCSecurityGroups", properties.VPCSecurityGroups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.VPCSecurityGroups) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDBInstance = class _CfnDBInstance extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDBInstancePropsFromCloudFormation(resourceProperties), ret = new _CfnDBInstance(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnDBInstance.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_CfnDBInstanceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDBInstance), error;
        }
        this.attrCertificateDetailsCaIdentifier = cdk.Token.asString(this.getAtt("CertificateDetails.CAIdentifier", cdk.ResolutionTypeHint.STRING)), this.attrCertificateDetailsValidTill = cdk.Token.asString(this.getAtt("CertificateDetails.ValidTill", cdk.ResolutionTypeHint.STRING)), this.attrDbInstanceArn = cdk.Token.asString(this.getAtt("DBInstanceArn", cdk.ResolutionTypeHint.STRING)), this.attrDbSystemId = cdk.Token.asString(this.getAtt("DBSystemId", cdk.ResolutionTypeHint.STRING)), this.attrDbiResourceId = cdk.Token.asString(this.getAtt("DbiResourceId", cdk.ResolutionTypeHint.STRING)), this.attrEndpointAddress = cdk.Token.asString(this.getAtt("Endpoint.Address", cdk.ResolutionTypeHint.STRING)), this.attrEndpointHostedZoneId = cdk.Token.asString(this.getAtt("Endpoint.HostedZoneId", cdk.ResolutionTypeHint.STRING)), this.attrEndpointPort = cdk.Token.asString(this.getAtt("Endpoint.Port", cdk.ResolutionTypeHint.STRING)), this.attrMasterUserSecretSecretArn = cdk.Token.asString(this.getAtt("MasterUserSecret.SecretArn", cdk.ResolutionTypeHint.STRING)), this.allocatedStorage = props.allocatedStorage, this.allowMajorVersionUpgrade = props.allowMajorVersionUpgrade, this.associatedRoles = props.associatedRoles, this.autoMinorVersionUpgrade = props.autoMinorVersionUpgrade, this.availabilityZone = props.availabilityZone, this.backupRetentionPeriod = props.backupRetentionPeriod, this.caCertificateIdentifier = props.caCertificateIdentifier, this.certificateDetails = props.certificateDetails, this.certificateRotationRestart = props.certificateRotationRestart, this.characterSetName = props.characterSetName, this.copyTagsToSnapshot = props.copyTagsToSnapshot, this.customIamInstanceProfile = props.customIamInstanceProfile, this.dbClusterIdentifier = props.dbClusterIdentifier, this.dbClusterSnapshotIdentifier = props.dbClusterSnapshotIdentifier, this.dbInstanceClass = props.dbInstanceClass, this.dbInstanceIdentifier = props.dbInstanceIdentifier, this.dbName = props.dbName, this.dbParameterGroupName = props.dbParameterGroupName, this.dbSecurityGroups = props.dbSecurityGroups, this.dbSnapshotIdentifier = props.dbSnapshotIdentifier, this.dbSubnetGroupName = props.dbSubnetGroupName, this.deleteAutomatedBackups = props.deleteAutomatedBackups, this.deletionProtection = props.deletionProtection, this.domain = props.domain, this.domainIamRoleName = props.domainIamRoleName, this.enableCloudwatchLogsExports = props.enableCloudwatchLogsExports, this.enableIamDatabaseAuthentication = props.enableIamDatabaseAuthentication, this.enablePerformanceInsights = props.enablePerformanceInsights, this.endpoint = props.endpoint, this.engine = props.engine, this.engineVersion = props.engineVersion, this.iops = props.iops, this.kmsKeyId = props.kmsKeyId, this.licenseModel = props.licenseModel, this.manageMasterUserPassword = props.manageMasterUserPassword, this.masterUsername = props.masterUsername, this.masterUserPassword = props.masterUserPassword, this.masterUserSecret = props.masterUserSecret, this.maxAllocatedStorage = props.maxAllocatedStorage, this.monitoringInterval = props.monitoringInterval, this.monitoringRoleArn = props.monitoringRoleArn, this.multiAz = props.multiAz, this.ncharCharacterSetName = props.ncharCharacterSetName, this.networkType = props.networkType, this.optionGroupName = props.optionGroupName, this.performanceInsightsKmsKeyId = props.performanceInsightsKmsKeyId, this.performanceInsightsRetentionPeriod = props.performanceInsightsRetentionPeriod, this.port = props.port, this.preferredBackupWindow = props.preferredBackupWindow, this.preferredMaintenanceWindow = props.preferredMaintenanceWindow, this.processorFeatures = props.processorFeatures, this.promotionTier = props.promotionTier, this.publiclyAccessible = props.publiclyAccessible, this.replicaMode = props.replicaMode, this.restoreTime = props.restoreTime, this.sourceDbClusterIdentifier = props.sourceDbClusterIdentifier, this.sourceDbInstanceAutomatedBackupsArn = props.sourceDbInstanceAutomatedBackupsArn, this.sourceDbInstanceIdentifier = props.sourceDbInstanceIdentifier, this.sourceDbiResourceId = props.sourceDbiResourceId, this.sourceRegion = props.sourceRegion, this.storageEncrypted = props.storageEncrypted, this.storageThroughput = props.storageThroughput, this.storageType = props.storageType, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::RDS::DBInstance", props.tags, { tagPropertyName: "tags" }), this.timezone = props.timezone, this.useDefaultProcessorFeatures = props.useDefaultProcessorFeatures, this.useLatestRestorableTime = props.useLatestRestorableTime, this.vpcSecurityGroups = props.vpcSecurityGroups, this.node.scope && cdk.Resource.isResource(this.node.scope) && this.node.addValidation({ validate: () => this.cfnOptions.deletionPolicy === void 0 ? ["'AWS::RDS::DBInstance' is a stateful resource type, and you must specify a Removal Policy for it. Call 'resource.applyRemovalPolicy()'."] : [] });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDBInstance.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { allocatedStorage: this.allocatedStorage, allowMajorVersionUpgrade: this.allowMajorVersionUpgrade, associatedRoles: this.associatedRoles, autoMinorVersionUpgrade: this.autoMinorVersionUpgrade, availabilityZone: this.availabilityZone, backupRetentionPeriod: this.backupRetentionPeriod, caCertificateIdentifier: this.caCertificateIdentifier, certificateDetails: this.certificateDetails, certificateRotationRestart: this.certificateRotationRestart, characterSetName: this.characterSetName, copyTagsToSnapshot: this.copyTagsToSnapshot, customIamInstanceProfile: this.customIamInstanceProfile, dbClusterIdentifier: this.dbClusterIdentifier, dbClusterSnapshotIdentifier: this.dbClusterSnapshotIdentifier, dbInstanceClass: this.dbInstanceClass, dbInstanceIdentifier: this.dbInstanceIdentifier, dbName: this.dbName, dbParameterGroupName: this.dbParameterGroupName, dbSecurityGroups: this.dbSecurityGroups, dbSnapshotIdentifier: this.dbSnapshotIdentifier, dbSubnetGroupName: this.dbSubnetGroupName, deleteAutomatedBackups: this.deleteAutomatedBackups, deletionProtection: this.deletionProtection, domain: this.domain, domainIamRoleName: this.domainIamRoleName, enableCloudwatchLogsExports: this.enableCloudwatchLogsExports, enableIamDatabaseAuthentication: this.enableIamDatabaseAuthentication, enablePerformanceInsights: this.enablePerformanceInsights, endpoint: this.endpoint, engine: this.engine, engineVersion: this.engineVersion, iops: this.iops, kmsKeyId: this.kmsKeyId, licenseModel: this.licenseModel, manageMasterUserPassword: this.manageMasterUserPassword, masterUsername: this.masterUsername, masterUserPassword: this.masterUserPassword, masterUserSecret: this.masterUserSecret, maxAllocatedStorage: this.maxAllocatedStorage, monitoringInterval: this.monitoringInterval, monitoringRoleArn: this.monitoringRoleArn, multiAz: this.multiAz, ncharCharacterSetName: this.ncharCharacterSetName, networkType: this.networkType, optionGroupName: this.optionGroupName, performanceInsightsKmsKeyId: this.performanceInsightsKmsKeyId, performanceInsightsRetentionPeriod: this.performanceInsightsRetentionPeriod, port: this.port, preferredBackupWindow: this.preferredBackupWindow, preferredMaintenanceWindow: this.preferredMaintenanceWindow, processorFeatures: this.processorFeatures, promotionTier: this.promotionTier, publiclyAccessible: this.publiclyAccessible, replicaMode: this.replicaMode, restoreTime: this.restoreTime, sourceDbClusterIdentifier: this.sourceDbClusterIdentifier, sourceDbInstanceAutomatedBackupsArn: this.sourceDbInstanceAutomatedBackupsArn, sourceDbInstanceIdentifier: this.sourceDbInstanceIdentifier, sourceDbiResourceId: this.sourceDbiResourceId, sourceRegion: this.sourceRegion, storageEncrypted: this.storageEncrypted, storageThroughput: this.storageThroughput, storageType: this.storageType, tags: this.tags.renderTags(), timezone: this.timezone, useDefaultProcessorFeatures: this.useDefaultProcessorFeatures, useLatestRestorableTime: this.useLatestRestorableTime, vpcSecurityGroups: this.vpcSecurityGroups };
      }
      renderProperties(props) {
        return cfnDBInstancePropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnDBInstance[_c] = { fqn: "aws-cdk-lib.aws_rds.CfnDBInstance", version: "2.80.0" }, CfnDBInstance.CFN_RESOURCE_TYPE_NAME = "AWS::RDS::DBInstance", exports2.CfnDBInstance = CfnDBInstance;
    function CfnDBInstance_CertificateDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("caIdentifier", cdk.validateString)(properties.caIdentifier)), errors.collect(cdk.propertyValidator("validTill", cdk.validateString)(properties.validTill)), errors.wrap('supplied properties not correct for "CertificateDetailsProperty"');
    }
    function cfnDBInstanceCertificateDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBInstance_CertificateDetailsPropertyValidator(properties).assertSuccess(), { CAIdentifier: cdk.stringToCloudFormation(properties.caIdentifier), ValidTill: cdk.stringToCloudFormation(properties.validTill) }) : properties;
    }
    function CfnDBInstanceCertificateDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("caIdentifier", "CAIdentifier", properties.CAIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.CAIdentifier) : void 0), ret.addPropertyResult("validTill", "ValidTill", properties.ValidTill != null ? cfn_parse.FromCloudFormation.getString(properties.ValidTill) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDBInstance_DBInstanceRolePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("featureName", cdk.requiredValidator)(properties.featureName)), errors.collect(cdk.propertyValidator("featureName", cdk.validateString)(properties.featureName)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "DBInstanceRoleProperty"');
    }
    function cfnDBInstanceDBInstanceRolePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBInstance_DBInstanceRolePropertyValidator(properties).assertSuccess(), { FeatureName: cdk.stringToCloudFormation(properties.featureName), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnDBInstanceDBInstanceRolePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("featureName", "FeatureName", cfn_parse.FromCloudFormation.getString(properties.FeatureName)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDBInstance_EndpointPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("address", cdk.validateString)(properties.address)), errors.collect(cdk.propertyValidator("hostedZoneId", cdk.validateString)(properties.hostedZoneId)), errors.collect(cdk.propertyValidator("port", cdk.validateString)(properties.port)), errors.wrap('supplied properties not correct for "EndpointProperty"');
    }
    function cfnDBInstanceEndpointPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBInstance_EndpointPropertyValidator(properties).assertSuccess(), { Address: cdk.stringToCloudFormation(properties.address), HostedZoneId: cdk.stringToCloudFormation(properties.hostedZoneId), Port: cdk.stringToCloudFormation(properties.port) }) : properties;
    }
    function CfnDBInstanceEndpointPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("address", "Address", properties.Address != null ? cfn_parse.FromCloudFormation.getString(properties.Address) : void 0), ret.addPropertyResult("hostedZoneId", "HostedZoneId", properties.HostedZoneId != null ? cfn_parse.FromCloudFormation.getString(properties.HostedZoneId) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getString(properties.Port) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDBInstance_MasterUserSecretPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("secretArn", cdk.validateString)(properties.secretArn)), errors.wrap('supplied properties not correct for "MasterUserSecretProperty"');
    }
    function cfnDBInstanceMasterUserSecretPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBInstance_MasterUserSecretPropertyValidator(properties).assertSuccess(), { KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), SecretArn: cdk.stringToCloudFormation(properties.secretArn) }) : properties;
    }
    function CfnDBInstanceMasterUserSecretPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("secretArn", "SecretArn", properties.SecretArn != null ? cfn_parse.FromCloudFormation.getString(properties.SecretArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDBInstance_ProcessorFeaturePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "ProcessorFeatureProperty"');
    }
    function cfnDBInstanceProcessorFeaturePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBInstance_ProcessorFeaturePropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnDBInstanceProcessorFeaturePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDBParameterGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dbParameterGroupName", cdk.validateString)(properties.dbParameterGroupName)), errors.collect(cdk.propertyValidator("description", cdk.requiredValidator)(properties.description)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("family", cdk.requiredValidator)(properties.family)), errors.collect(cdk.propertyValidator("family", cdk.validateString)(properties.family)), errors.collect(cdk.propertyValidator("parameters", cdk.validateObject)(properties.parameters)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDBParameterGroupProps"');
    }
    function cfnDBParameterGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBParameterGroupPropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), Family: cdk.stringToCloudFormation(properties.family), DBParameterGroupName: cdk.stringToCloudFormation(properties.dbParameterGroupName), Parameters: cdk.objectToCloudFormation(properties.parameters), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDBParameterGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", cfn_parse.FromCloudFormation.getString(properties.Description)), ret.addPropertyResult("family", "Family", cfn_parse.FromCloudFormation.getString(properties.Family)), ret.addPropertyResult("dbParameterGroupName", "DBParameterGroupName", properties.DBParameterGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.DBParameterGroupName) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getAny(properties.Parameters) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDBParameterGroup = class _CfnDBParameterGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDBParameterGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnDBParameterGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDBParameterGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_CfnDBParameterGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDBParameterGroup), error;
        }
        cdk.requireProperty(props, "description", this), cdk.requireProperty(props, "family", this), this.attrDbParameterGroupName = cdk.Token.asString(this.getAtt("DBParameterGroupName", cdk.ResolutionTypeHint.STRING)), this.description = props.description, this.family = props.family, this.dbParameterGroupName = props.dbParameterGroupName, this.parameters = props.parameters, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::RDS::DBParameterGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDBParameterGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, family: this.family, dbParameterGroupName: this.dbParameterGroupName, parameters: this.parameters, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDBParameterGroupPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnDBParameterGroup[_d] = { fqn: "aws-cdk-lib.aws_rds.CfnDBParameterGroup", version: "2.80.0" }, CfnDBParameterGroup.CFN_RESOURCE_TYPE_NAME = "AWS::RDS::DBParameterGroup", exports2.CfnDBParameterGroup = CfnDBParameterGroup;
    function CfnDBProxyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("auth", cdk.requiredValidator)(properties.auth)), errors.collect(cdk.propertyValidator("auth", cdk.listValidator(CfnDBProxy_AuthFormatPropertyValidator))(properties.auth)), errors.collect(cdk.propertyValidator("dbProxyName", cdk.requiredValidator)(properties.dbProxyName)), errors.collect(cdk.propertyValidator("dbProxyName", cdk.validateString)(properties.dbProxyName)), errors.collect(cdk.propertyValidator("debugLogging", cdk.validateBoolean)(properties.debugLogging)), errors.collect(cdk.propertyValidator("engineFamily", cdk.requiredValidator)(properties.engineFamily)), errors.collect(cdk.propertyValidator("engineFamily", cdk.validateString)(properties.engineFamily)), errors.collect(cdk.propertyValidator("idleClientTimeout", cdk.validateNumber)(properties.idleClientTimeout)), errors.collect(cdk.propertyValidator("requireTls", cdk.validateBoolean)(properties.requireTls)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(CfnDBProxy_TagFormatPropertyValidator))(properties.tags)), errors.collect(cdk.propertyValidator("vpcSecurityGroupIds", cdk.listValidator(cdk.validateString))(properties.vpcSecurityGroupIds)), errors.collect(cdk.propertyValidator("vpcSubnetIds", cdk.requiredValidator)(properties.vpcSubnetIds)), errors.collect(cdk.propertyValidator("vpcSubnetIds", cdk.listValidator(cdk.validateString))(properties.vpcSubnetIds)), errors.wrap('supplied properties not correct for "CfnDBProxyProps"');
    }
    function cfnDBProxyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBProxyPropsValidator(properties).assertSuccess(), { Auth: cdk.listMapper(cfnDBProxyAuthFormatPropertyToCloudFormation)(properties.auth), DBProxyName: cdk.stringToCloudFormation(properties.dbProxyName), EngineFamily: cdk.stringToCloudFormation(properties.engineFamily), RoleArn: cdk.stringToCloudFormation(properties.roleArn), VpcSubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.vpcSubnetIds), DebugLogging: cdk.booleanToCloudFormation(properties.debugLogging), IdleClientTimeout: cdk.numberToCloudFormation(properties.idleClientTimeout), RequireTLS: cdk.booleanToCloudFormation(properties.requireTls), Tags: cdk.listMapper(cfnDBProxyTagFormatPropertyToCloudFormation)(properties.tags), VpcSecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.vpcSecurityGroupIds) }) : properties;
    }
    function CfnDBProxyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("auth", "Auth", cfn_parse.FromCloudFormation.getArray(CfnDBProxyAuthFormatPropertyFromCloudFormation)(properties.Auth)), ret.addPropertyResult("dbProxyName", "DBProxyName", cfn_parse.FromCloudFormation.getString(properties.DBProxyName)), ret.addPropertyResult("engineFamily", "EngineFamily", cfn_parse.FromCloudFormation.getString(properties.EngineFamily)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("vpcSubnetIds", "VpcSubnetIds", cfn_parse.FromCloudFormation.getStringArray(properties.VpcSubnetIds)), ret.addPropertyResult("debugLogging", "DebugLogging", properties.DebugLogging != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DebugLogging) : void 0), ret.addPropertyResult("idleClientTimeout", "IdleClientTimeout", properties.IdleClientTimeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.IdleClientTimeout) : void 0), ret.addPropertyResult("requireTls", "RequireTLS", properties.RequireTLS != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RequireTLS) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(CfnDBProxyTagFormatPropertyFromCloudFormation)(properties.Tags) : void 0), ret.addPropertyResult("vpcSecurityGroupIds", "VpcSecurityGroupIds", properties.VpcSecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.VpcSecurityGroupIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDBProxy = class _CfnDBProxy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDBProxyPropsFromCloudFormation(resourceProperties), ret = new _CfnDBProxy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDBProxy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_CfnDBProxyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDBProxy), error;
        }
        cdk.requireProperty(props, "auth", this), cdk.requireProperty(props, "dbProxyName", this), cdk.requireProperty(props, "engineFamily", this), cdk.requireProperty(props, "roleArn", this), cdk.requireProperty(props, "vpcSubnetIds", this), this.attrDbProxyArn = cdk.Token.asString(this.getAtt("DBProxyArn", cdk.ResolutionTypeHint.STRING)), this.attrEndpoint = cdk.Token.asString(this.getAtt("Endpoint", cdk.ResolutionTypeHint.STRING)), this.attrVpcId = cdk.Token.asString(this.getAtt("VpcId", cdk.ResolutionTypeHint.STRING)), this.auth = props.auth, this.dbProxyName = props.dbProxyName, this.engineFamily = props.engineFamily, this.roleArn = props.roleArn, this.vpcSubnetIds = props.vpcSubnetIds, this.debugLogging = props.debugLogging, this.idleClientTimeout = props.idleClientTimeout, this.requireTls = props.requireTls, this.tags = props.tags, this.vpcSecurityGroupIds = props.vpcSecurityGroupIds;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDBProxy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { auth: this.auth, dbProxyName: this.dbProxyName, engineFamily: this.engineFamily, roleArn: this.roleArn, vpcSubnetIds: this.vpcSubnetIds, debugLogging: this.debugLogging, idleClientTimeout: this.idleClientTimeout, requireTls: this.requireTls, tags: this.tags, vpcSecurityGroupIds: this.vpcSecurityGroupIds };
      }
      renderProperties(props) {
        return cfnDBProxyPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnDBProxy[_e] = { fqn: "aws-cdk-lib.aws_rds.CfnDBProxy", version: "2.80.0" }, CfnDBProxy.CFN_RESOURCE_TYPE_NAME = "AWS::RDS::DBProxy", exports2.CfnDBProxy = CfnDBProxy;
    function CfnDBProxy_AuthFormatPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authScheme", cdk.validateString)(properties.authScheme)), errors.collect(cdk.propertyValidator("clientPasswordAuthType", cdk.validateString)(properties.clientPasswordAuthType)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("iamAuth", cdk.validateString)(properties.iamAuth)), errors.collect(cdk.propertyValidator("secretArn", cdk.validateString)(properties.secretArn)), errors.wrap('supplied properties not correct for "AuthFormatProperty"');
    }
    function cfnDBProxyAuthFormatPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBProxy_AuthFormatPropertyValidator(properties).assertSuccess(), { AuthScheme: cdk.stringToCloudFormation(properties.authScheme), ClientPasswordAuthType: cdk.stringToCloudFormation(properties.clientPasswordAuthType), Description: cdk.stringToCloudFormation(properties.description), IAMAuth: cdk.stringToCloudFormation(properties.iamAuth), SecretArn: cdk.stringToCloudFormation(properties.secretArn) }) : properties;
    }
    function CfnDBProxyAuthFormatPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authScheme", "AuthScheme", properties.AuthScheme != null ? cfn_parse.FromCloudFormation.getString(properties.AuthScheme) : void 0), ret.addPropertyResult("clientPasswordAuthType", "ClientPasswordAuthType", properties.ClientPasswordAuthType != null ? cfn_parse.FromCloudFormation.getString(properties.ClientPasswordAuthType) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("iamAuth", "IAMAuth", properties.IAMAuth != null ? cfn_parse.FromCloudFormation.getString(properties.IAMAuth) : void 0), ret.addPropertyResult("secretArn", "SecretArn", properties.SecretArn != null ? cfn_parse.FromCloudFormation.getString(properties.SecretArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDBProxy_TagFormatPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TagFormatProperty"');
    }
    function cfnDBProxyTagFormatPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBProxy_TagFormatPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnDBProxyTagFormatPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDBProxyEndpointPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dbProxyEndpointName", cdk.requiredValidator)(properties.dbProxyEndpointName)), errors.collect(cdk.propertyValidator("dbProxyEndpointName", cdk.validateString)(properties.dbProxyEndpointName)), errors.collect(cdk.propertyValidator("dbProxyName", cdk.requiredValidator)(properties.dbProxyName)), errors.collect(cdk.propertyValidator("dbProxyName", cdk.validateString)(properties.dbProxyName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(CfnDBProxyEndpoint_TagFormatPropertyValidator))(properties.tags)), errors.collect(cdk.propertyValidator("targetRole", cdk.validateString)(properties.targetRole)), errors.collect(cdk.propertyValidator("vpcSecurityGroupIds", cdk.listValidator(cdk.validateString))(properties.vpcSecurityGroupIds)), errors.collect(cdk.propertyValidator("vpcSubnetIds", cdk.requiredValidator)(properties.vpcSubnetIds)), errors.collect(cdk.propertyValidator("vpcSubnetIds", cdk.listValidator(cdk.validateString))(properties.vpcSubnetIds)), errors.wrap('supplied properties not correct for "CfnDBProxyEndpointProps"');
    }
    function cfnDBProxyEndpointPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBProxyEndpointPropsValidator(properties).assertSuccess(), { DBProxyEndpointName: cdk.stringToCloudFormation(properties.dbProxyEndpointName), DBProxyName: cdk.stringToCloudFormation(properties.dbProxyName), VpcSubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.vpcSubnetIds), Tags: cdk.listMapper(cfnDBProxyEndpointTagFormatPropertyToCloudFormation)(properties.tags), TargetRole: cdk.stringToCloudFormation(properties.targetRole), VpcSecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.vpcSecurityGroupIds) }) : properties;
    }
    function CfnDBProxyEndpointPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dbProxyEndpointName", "DBProxyEndpointName", cfn_parse.FromCloudFormation.getString(properties.DBProxyEndpointName)), ret.addPropertyResult("dbProxyName", "DBProxyName", cfn_parse.FromCloudFormation.getString(properties.DBProxyName)), ret.addPropertyResult("vpcSubnetIds", "VpcSubnetIds", cfn_parse.FromCloudFormation.getStringArray(properties.VpcSubnetIds)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(CfnDBProxyEndpointTagFormatPropertyFromCloudFormation)(properties.Tags) : void 0), ret.addPropertyResult("targetRole", "TargetRole", properties.TargetRole != null ? cfn_parse.FromCloudFormation.getString(properties.TargetRole) : void 0), ret.addPropertyResult("vpcSecurityGroupIds", "VpcSecurityGroupIds", properties.VpcSecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.VpcSecurityGroupIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDBProxyEndpoint = class _CfnDBProxyEndpoint extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDBProxyEndpointPropsFromCloudFormation(resourceProperties), ret = new _CfnDBProxyEndpoint(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDBProxyEndpoint.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_CfnDBProxyEndpointProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDBProxyEndpoint), error;
        }
        cdk.requireProperty(props, "dbProxyEndpointName", this), cdk.requireProperty(props, "dbProxyName", this), cdk.requireProperty(props, "vpcSubnetIds", this), this.attrDbProxyEndpointArn = cdk.Token.asString(this.getAtt("DBProxyEndpointArn", cdk.ResolutionTypeHint.STRING)), this.attrEndpoint = cdk.Token.asString(this.getAtt("Endpoint", cdk.ResolutionTypeHint.STRING)), this.attrIsDefault = this.getAtt("IsDefault", cdk.ResolutionTypeHint.STRING), this.attrVpcId = cdk.Token.asString(this.getAtt("VpcId", cdk.ResolutionTypeHint.STRING)), this.dbProxyEndpointName = props.dbProxyEndpointName, this.dbProxyName = props.dbProxyName, this.vpcSubnetIds = props.vpcSubnetIds, this.tags = props.tags, this.targetRole = props.targetRole, this.vpcSecurityGroupIds = props.vpcSecurityGroupIds;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDBProxyEndpoint.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { dbProxyEndpointName: this.dbProxyEndpointName, dbProxyName: this.dbProxyName, vpcSubnetIds: this.vpcSubnetIds, tags: this.tags, targetRole: this.targetRole, vpcSecurityGroupIds: this.vpcSecurityGroupIds };
      }
      renderProperties(props) {
        return cfnDBProxyEndpointPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnDBProxyEndpoint[_f] = { fqn: "aws-cdk-lib.aws_rds.CfnDBProxyEndpoint", version: "2.80.0" }, CfnDBProxyEndpoint.CFN_RESOURCE_TYPE_NAME = "AWS::RDS::DBProxyEndpoint", exports2.CfnDBProxyEndpoint = CfnDBProxyEndpoint;
    function CfnDBProxyEndpoint_TagFormatPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TagFormatProperty"');
    }
    function cfnDBProxyEndpointTagFormatPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBProxyEndpoint_TagFormatPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnDBProxyEndpointTagFormatPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDBProxyTargetGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectionPoolConfigurationInfo", CfnDBProxyTargetGroup_ConnectionPoolConfigurationInfoFormatPropertyValidator)(properties.connectionPoolConfigurationInfo)), errors.collect(cdk.propertyValidator("dbClusterIdentifiers", cdk.listValidator(cdk.validateString))(properties.dbClusterIdentifiers)), errors.collect(cdk.propertyValidator("dbInstanceIdentifiers", cdk.listValidator(cdk.validateString))(properties.dbInstanceIdentifiers)), errors.collect(cdk.propertyValidator("dbProxyName", cdk.requiredValidator)(properties.dbProxyName)), errors.collect(cdk.propertyValidator("dbProxyName", cdk.validateString)(properties.dbProxyName)), errors.collect(cdk.propertyValidator("targetGroupName", cdk.requiredValidator)(properties.targetGroupName)), errors.collect(cdk.propertyValidator("targetGroupName", cdk.validateString)(properties.targetGroupName)), errors.wrap('supplied properties not correct for "CfnDBProxyTargetGroupProps"');
    }
    function cfnDBProxyTargetGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBProxyTargetGroupPropsValidator(properties).assertSuccess(), { DBProxyName: cdk.stringToCloudFormation(properties.dbProxyName), TargetGroupName: cdk.stringToCloudFormation(properties.targetGroupName), ConnectionPoolConfigurationInfo: cfnDBProxyTargetGroupConnectionPoolConfigurationInfoFormatPropertyToCloudFormation(properties.connectionPoolConfigurationInfo), DBClusterIdentifiers: cdk.listMapper(cdk.stringToCloudFormation)(properties.dbClusterIdentifiers), DBInstanceIdentifiers: cdk.listMapper(cdk.stringToCloudFormation)(properties.dbInstanceIdentifiers) }) : properties;
    }
    function CfnDBProxyTargetGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dbProxyName", "DBProxyName", cfn_parse.FromCloudFormation.getString(properties.DBProxyName)), ret.addPropertyResult("targetGroupName", "TargetGroupName", cfn_parse.FromCloudFormation.getString(properties.TargetGroupName)), ret.addPropertyResult("connectionPoolConfigurationInfo", "ConnectionPoolConfigurationInfo", properties.ConnectionPoolConfigurationInfo != null ? CfnDBProxyTargetGroupConnectionPoolConfigurationInfoFormatPropertyFromCloudFormation(properties.ConnectionPoolConfigurationInfo) : void 0), ret.addPropertyResult("dbClusterIdentifiers", "DBClusterIdentifiers", properties.DBClusterIdentifiers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.DBClusterIdentifiers) : void 0), ret.addPropertyResult("dbInstanceIdentifiers", "DBInstanceIdentifiers", properties.DBInstanceIdentifiers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.DBInstanceIdentifiers) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDBProxyTargetGroup = class _CfnDBProxyTargetGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDBProxyTargetGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnDBProxyTargetGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDBProxyTargetGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_CfnDBProxyTargetGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDBProxyTargetGroup), error;
        }
        cdk.requireProperty(props, "dbProxyName", this), cdk.requireProperty(props, "targetGroupName", this), this.attrTargetGroupArn = cdk.Token.asString(this.getAtt("TargetGroupArn", cdk.ResolutionTypeHint.STRING)), this.dbProxyName = props.dbProxyName, this.targetGroupName = props.targetGroupName, this.connectionPoolConfigurationInfo = props.connectionPoolConfigurationInfo, this.dbClusterIdentifiers = props.dbClusterIdentifiers, this.dbInstanceIdentifiers = props.dbInstanceIdentifiers;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDBProxyTargetGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { dbProxyName: this.dbProxyName, targetGroupName: this.targetGroupName, connectionPoolConfigurationInfo: this.connectionPoolConfigurationInfo, dbClusterIdentifiers: this.dbClusterIdentifiers, dbInstanceIdentifiers: this.dbInstanceIdentifiers };
      }
      renderProperties(props) {
        return cfnDBProxyTargetGroupPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnDBProxyTargetGroup[_g] = { fqn: "aws-cdk-lib.aws_rds.CfnDBProxyTargetGroup", version: "2.80.0" }, CfnDBProxyTargetGroup.CFN_RESOURCE_TYPE_NAME = "AWS::RDS::DBProxyTargetGroup", exports2.CfnDBProxyTargetGroup = CfnDBProxyTargetGroup;
    function CfnDBProxyTargetGroup_ConnectionPoolConfigurationInfoFormatPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectionBorrowTimeout", cdk.validateNumber)(properties.connectionBorrowTimeout)), errors.collect(cdk.propertyValidator("initQuery", cdk.validateString)(properties.initQuery)), errors.collect(cdk.propertyValidator("maxConnectionsPercent", cdk.validateNumber)(properties.maxConnectionsPercent)), errors.collect(cdk.propertyValidator("maxIdleConnectionsPercent", cdk.validateNumber)(properties.maxIdleConnectionsPercent)), errors.collect(cdk.propertyValidator("sessionPinningFilters", cdk.listValidator(cdk.validateString))(properties.sessionPinningFilters)), errors.wrap('supplied properties not correct for "ConnectionPoolConfigurationInfoFormatProperty"');
    }
    function cfnDBProxyTargetGroupConnectionPoolConfigurationInfoFormatPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBProxyTargetGroup_ConnectionPoolConfigurationInfoFormatPropertyValidator(properties).assertSuccess(), { ConnectionBorrowTimeout: cdk.numberToCloudFormation(properties.connectionBorrowTimeout), InitQuery: cdk.stringToCloudFormation(properties.initQuery), MaxConnectionsPercent: cdk.numberToCloudFormation(properties.maxConnectionsPercent), MaxIdleConnectionsPercent: cdk.numberToCloudFormation(properties.maxIdleConnectionsPercent), SessionPinningFilters: cdk.listMapper(cdk.stringToCloudFormation)(properties.sessionPinningFilters) }) : properties;
    }
    function CfnDBProxyTargetGroupConnectionPoolConfigurationInfoFormatPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectionBorrowTimeout", "ConnectionBorrowTimeout", properties.ConnectionBorrowTimeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.ConnectionBorrowTimeout) : void 0), ret.addPropertyResult("initQuery", "InitQuery", properties.InitQuery != null ? cfn_parse.FromCloudFormation.getString(properties.InitQuery) : void 0), ret.addPropertyResult("maxConnectionsPercent", "MaxConnectionsPercent", properties.MaxConnectionsPercent != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxConnectionsPercent) : void 0), ret.addPropertyResult("maxIdleConnectionsPercent", "MaxIdleConnectionsPercent", properties.MaxIdleConnectionsPercent != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxIdleConnectionsPercent) : void 0), ret.addPropertyResult("sessionPinningFilters", "SessionPinningFilters", properties.SessionPinningFilters != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SessionPinningFilters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDBSecurityGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dbSecurityGroupIngress", cdk.requiredValidator)(properties.dbSecurityGroupIngress)), errors.collect(cdk.propertyValidator("dbSecurityGroupIngress", cdk.listValidator(CfnDBSecurityGroup_IngressPropertyValidator))(properties.dbSecurityGroupIngress)), errors.collect(cdk.propertyValidator("ec2VpcId", cdk.validateString)(properties.ec2VpcId)), errors.collect(cdk.propertyValidator("groupDescription", cdk.requiredValidator)(properties.groupDescription)), errors.collect(cdk.propertyValidator("groupDescription", cdk.validateString)(properties.groupDescription)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDBSecurityGroupProps"');
    }
    function cfnDBSecurityGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBSecurityGroupPropsValidator(properties).assertSuccess(), { DBSecurityGroupIngress: cdk.listMapper(cfnDBSecurityGroupIngressPropertyToCloudFormation)(properties.dbSecurityGroupIngress), GroupDescription: cdk.stringToCloudFormation(properties.groupDescription), EC2VpcId: cdk.stringToCloudFormation(properties.ec2VpcId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDBSecurityGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dbSecurityGroupIngress", "DBSecurityGroupIngress", cfn_parse.FromCloudFormation.getArray(CfnDBSecurityGroupIngressPropertyFromCloudFormation)(properties.DBSecurityGroupIngress)), ret.addPropertyResult("groupDescription", "GroupDescription", cfn_parse.FromCloudFormation.getString(properties.GroupDescription)), ret.addPropertyResult("ec2VpcId", "EC2VpcId", properties.EC2VpcId != null ? cfn_parse.FromCloudFormation.getString(properties.EC2VpcId) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDBSecurityGroup = class _CfnDBSecurityGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDBSecurityGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnDBSecurityGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDBSecurityGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_CfnDBSecurityGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDBSecurityGroup), error;
        }
        cdk.requireProperty(props, "dbSecurityGroupIngress", this), cdk.requireProperty(props, "groupDescription", this), this.dbSecurityGroupIngress = props.dbSecurityGroupIngress, this.groupDescription = props.groupDescription, this.ec2VpcId = props.ec2VpcId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::RDS::DBSecurityGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDBSecurityGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { dbSecurityGroupIngress: this.dbSecurityGroupIngress, groupDescription: this.groupDescription, ec2VpcId: this.ec2VpcId, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDBSecurityGroupPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnDBSecurityGroup[_h] = { fqn: "aws-cdk-lib.aws_rds.CfnDBSecurityGroup", version: "2.80.0" }, CfnDBSecurityGroup.CFN_RESOURCE_TYPE_NAME = "AWS::RDS::DBSecurityGroup", exports2.CfnDBSecurityGroup = CfnDBSecurityGroup;
    function CfnDBSecurityGroup_IngressPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cidrip", cdk.validateString)(properties.cidrip)), errors.collect(cdk.propertyValidator("ec2SecurityGroupId", cdk.validateString)(properties.ec2SecurityGroupId)), errors.collect(cdk.propertyValidator("ec2SecurityGroupName", cdk.validateString)(properties.ec2SecurityGroupName)), errors.collect(cdk.propertyValidator("ec2SecurityGroupOwnerId", cdk.validateString)(properties.ec2SecurityGroupOwnerId)), errors.wrap('supplied properties not correct for "IngressProperty"');
    }
    function cfnDBSecurityGroupIngressPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBSecurityGroup_IngressPropertyValidator(properties).assertSuccess(), { CIDRIP: cdk.stringToCloudFormation(properties.cidrip), EC2SecurityGroupId: cdk.stringToCloudFormation(properties.ec2SecurityGroupId), EC2SecurityGroupName: cdk.stringToCloudFormation(properties.ec2SecurityGroupName), EC2SecurityGroupOwnerId: cdk.stringToCloudFormation(properties.ec2SecurityGroupOwnerId) }) : properties;
    }
    function CfnDBSecurityGroupIngressPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cidrip", "CIDRIP", properties.CIDRIP != null ? cfn_parse.FromCloudFormation.getString(properties.CIDRIP) : void 0), ret.addPropertyResult("ec2SecurityGroupId", "EC2SecurityGroupId", properties.EC2SecurityGroupId != null ? cfn_parse.FromCloudFormation.getString(properties.EC2SecurityGroupId) : void 0), ret.addPropertyResult("ec2SecurityGroupName", "EC2SecurityGroupName", properties.EC2SecurityGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.EC2SecurityGroupName) : void 0), ret.addPropertyResult("ec2SecurityGroupOwnerId", "EC2SecurityGroupOwnerId", properties.EC2SecurityGroupOwnerId != null ? cfn_parse.FromCloudFormation.getString(properties.EC2SecurityGroupOwnerId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDBSecurityGroupIngressPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cidrip", cdk.validateString)(properties.cidrip)), errors.collect(cdk.propertyValidator("dbSecurityGroupName", cdk.requiredValidator)(properties.dbSecurityGroupName)), errors.collect(cdk.propertyValidator("dbSecurityGroupName", cdk.validateString)(properties.dbSecurityGroupName)), errors.collect(cdk.propertyValidator("ec2SecurityGroupId", cdk.validateString)(properties.ec2SecurityGroupId)), errors.collect(cdk.propertyValidator("ec2SecurityGroupName", cdk.validateString)(properties.ec2SecurityGroupName)), errors.collect(cdk.propertyValidator("ec2SecurityGroupOwnerId", cdk.validateString)(properties.ec2SecurityGroupOwnerId)), errors.wrap('supplied properties not correct for "CfnDBSecurityGroupIngressProps"');
    }
    function cfnDBSecurityGroupIngressPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBSecurityGroupIngressPropsValidator(properties).assertSuccess(), { DBSecurityGroupName: cdk.stringToCloudFormation(properties.dbSecurityGroupName), CIDRIP: cdk.stringToCloudFormation(properties.cidrip), EC2SecurityGroupId: cdk.stringToCloudFormation(properties.ec2SecurityGroupId), EC2SecurityGroupName: cdk.stringToCloudFormation(properties.ec2SecurityGroupName), EC2SecurityGroupOwnerId: cdk.stringToCloudFormation(properties.ec2SecurityGroupOwnerId) }) : properties;
    }
    function CfnDBSecurityGroupIngressPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dbSecurityGroupName", "DBSecurityGroupName", cfn_parse.FromCloudFormation.getString(properties.DBSecurityGroupName)), ret.addPropertyResult("cidrip", "CIDRIP", properties.CIDRIP != null ? cfn_parse.FromCloudFormation.getString(properties.CIDRIP) : void 0), ret.addPropertyResult("ec2SecurityGroupId", "EC2SecurityGroupId", properties.EC2SecurityGroupId != null ? cfn_parse.FromCloudFormation.getString(properties.EC2SecurityGroupId) : void 0), ret.addPropertyResult("ec2SecurityGroupName", "EC2SecurityGroupName", properties.EC2SecurityGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.EC2SecurityGroupName) : void 0), ret.addPropertyResult("ec2SecurityGroupOwnerId", "EC2SecurityGroupOwnerId", properties.EC2SecurityGroupOwnerId != null ? cfn_parse.FromCloudFormation.getString(properties.EC2SecurityGroupOwnerId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDBSecurityGroupIngress = class _CfnDBSecurityGroupIngress extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDBSecurityGroupIngressPropsFromCloudFormation(resourceProperties), ret = new _CfnDBSecurityGroupIngress(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDBSecurityGroupIngress.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_CfnDBSecurityGroupIngressProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDBSecurityGroupIngress), error;
        }
        cdk.requireProperty(props, "dbSecurityGroupName", this), this.dbSecurityGroupName = props.dbSecurityGroupName, this.cidrip = props.cidrip, this.ec2SecurityGroupId = props.ec2SecurityGroupId, this.ec2SecurityGroupName = props.ec2SecurityGroupName, this.ec2SecurityGroupOwnerId = props.ec2SecurityGroupOwnerId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDBSecurityGroupIngress.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { dbSecurityGroupName: this.dbSecurityGroupName, cidrip: this.cidrip, ec2SecurityGroupId: this.ec2SecurityGroupId, ec2SecurityGroupName: this.ec2SecurityGroupName, ec2SecurityGroupOwnerId: this.ec2SecurityGroupOwnerId };
      }
      renderProperties(props) {
        return cfnDBSecurityGroupIngressPropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnDBSecurityGroupIngress[_j] = { fqn: "aws-cdk-lib.aws_rds.CfnDBSecurityGroupIngress", version: "2.80.0" }, CfnDBSecurityGroupIngress.CFN_RESOURCE_TYPE_NAME = "AWS::RDS::DBSecurityGroupIngress", exports2.CfnDBSecurityGroupIngress = CfnDBSecurityGroupIngress;
    function CfnDBSubnetGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dbSubnetGroupDescription", cdk.requiredValidator)(properties.dbSubnetGroupDescription)), errors.collect(cdk.propertyValidator("dbSubnetGroupDescription", cdk.validateString)(properties.dbSubnetGroupDescription)), errors.collect(cdk.propertyValidator("dbSubnetGroupName", cdk.validateString)(properties.dbSubnetGroupName)), errors.collect(cdk.propertyValidator("subnetIds", cdk.requiredValidator)(properties.subnetIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDBSubnetGroupProps"');
    }
    function cfnDBSubnetGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBSubnetGroupPropsValidator(properties).assertSuccess(), { DBSubnetGroupDescription: cdk.stringToCloudFormation(properties.dbSubnetGroupDescription), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds), DBSubnetGroupName: cdk.stringToCloudFormation(properties.dbSubnetGroupName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDBSubnetGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dbSubnetGroupDescription", "DBSubnetGroupDescription", cfn_parse.FromCloudFormation.getString(properties.DBSubnetGroupDescription)), ret.addPropertyResult("subnetIds", "SubnetIds", cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds)), ret.addPropertyResult("dbSubnetGroupName", "DBSubnetGroupName", properties.DBSubnetGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.DBSubnetGroupName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDBSubnetGroup = class _CfnDBSubnetGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDBSubnetGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnDBSubnetGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDBSubnetGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_CfnDBSubnetGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDBSubnetGroup), error;
        }
        cdk.requireProperty(props, "dbSubnetGroupDescription", this), cdk.requireProperty(props, "subnetIds", this), this.dbSubnetGroupDescription = props.dbSubnetGroupDescription, this.subnetIds = props.subnetIds, this.dbSubnetGroupName = props.dbSubnetGroupName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::RDS::DBSubnetGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDBSubnetGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { dbSubnetGroupDescription: this.dbSubnetGroupDescription, subnetIds: this.subnetIds, dbSubnetGroupName: this.dbSubnetGroupName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDBSubnetGroupPropsToCloudFormation(props);
      }
    };
    _k = JSII_RTTI_SYMBOL_1, CfnDBSubnetGroup[_k] = { fqn: "aws-cdk-lib.aws_rds.CfnDBSubnetGroup", version: "2.80.0" }, CfnDBSubnetGroup.CFN_RESOURCE_TYPE_NAME = "AWS::RDS::DBSubnetGroup", exports2.CfnDBSubnetGroup = CfnDBSubnetGroup;
    function CfnEventSubscriptionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("eventCategories", cdk.listValidator(cdk.validateString))(properties.eventCategories)), errors.collect(cdk.propertyValidator("snsTopicArn", cdk.requiredValidator)(properties.snsTopicArn)), errors.collect(cdk.propertyValidator("snsTopicArn", cdk.validateString)(properties.snsTopicArn)), errors.collect(cdk.propertyValidator("sourceIds", cdk.listValidator(cdk.validateString))(properties.sourceIds)), errors.collect(cdk.propertyValidator("sourceType", cdk.validateString)(properties.sourceType)), errors.collect(cdk.propertyValidator("subscriptionName", cdk.validateString)(properties.subscriptionName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnEventSubscriptionProps"');
    }
    function cfnEventSubscriptionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventSubscriptionPropsValidator(properties).assertSuccess(), { SnsTopicArn: cdk.stringToCloudFormation(properties.snsTopicArn), Enabled: cdk.booleanToCloudFormation(properties.enabled), EventCategories: cdk.listMapper(cdk.stringToCloudFormation)(properties.eventCategories), SourceIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.sourceIds), SourceType: cdk.stringToCloudFormation(properties.sourceType), SubscriptionName: cdk.stringToCloudFormation(properties.subscriptionName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnEventSubscriptionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("snsTopicArn", "SnsTopicArn", cfn_parse.FromCloudFormation.getString(properties.SnsTopicArn)), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("eventCategories", "EventCategories", properties.EventCategories != null ? cfn_parse.FromCloudFormation.getStringArray(properties.EventCategories) : void 0), ret.addPropertyResult("sourceIds", "SourceIds", properties.SourceIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SourceIds) : void 0), ret.addPropertyResult("sourceType", "SourceType", properties.SourceType != null ? cfn_parse.FromCloudFormation.getString(properties.SourceType) : void 0), ret.addPropertyResult("subscriptionName", "SubscriptionName", properties.SubscriptionName != null ? cfn_parse.FromCloudFormation.getString(properties.SubscriptionName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEventSubscription = class _CfnEventSubscription extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEventSubscriptionPropsFromCloudFormation(resourceProperties), ret = new _CfnEventSubscription(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEventSubscription.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_CfnEventSubscriptionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEventSubscription), error;
        }
        cdk.requireProperty(props, "snsTopicArn", this), this.snsTopicArn = props.snsTopicArn, this.enabled = props.enabled, this.eventCategories = props.eventCategories, this.sourceIds = props.sourceIds, this.sourceType = props.sourceType, this.subscriptionName = props.subscriptionName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::RDS::EventSubscription", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEventSubscription.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { snsTopicArn: this.snsTopicArn, enabled: this.enabled, eventCategories: this.eventCategories, sourceIds: this.sourceIds, sourceType: this.sourceType, subscriptionName: this.subscriptionName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnEventSubscriptionPropsToCloudFormation(props);
      }
    };
    _l = JSII_RTTI_SYMBOL_1, CfnEventSubscription[_l] = { fqn: "aws-cdk-lib.aws_rds.CfnEventSubscription", version: "2.80.0" }, CfnEventSubscription.CFN_RESOURCE_TYPE_NAME = "AWS::RDS::EventSubscription", exports2.CfnEventSubscription = CfnEventSubscription;
    function CfnGlobalClusterPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deletionProtection", cdk.validateBoolean)(properties.deletionProtection)), errors.collect(cdk.propertyValidator("engine", cdk.validateString)(properties.engine)), errors.collect(cdk.propertyValidator("engineVersion", cdk.validateString)(properties.engineVersion)), errors.collect(cdk.propertyValidator("globalClusterIdentifier", cdk.validateString)(properties.globalClusterIdentifier)), errors.collect(cdk.propertyValidator("sourceDbClusterIdentifier", cdk.validateString)(properties.sourceDbClusterIdentifier)), errors.collect(cdk.propertyValidator("storageEncrypted", cdk.validateBoolean)(properties.storageEncrypted)), errors.wrap('supplied properties not correct for "CfnGlobalClusterProps"');
    }
    function cfnGlobalClusterPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGlobalClusterPropsValidator(properties).assertSuccess(), { DeletionProtection: cdk.booleanToCloudFormation(properties.deletionProtection), Engine: cdk.stringToCloudFormation(properties.engine), EngineVersion: cdk.stringToCloudFormation(properties.engineVersion), GlobalClusterIdentifier: cdk.stringToCloudFormation(properties.globalClusterIdentifier), SourceDBClusterIdentifier: cdk.stringToCloudFormation(properties.sourceDbClusterIdentifier), StorageEncrypted: cdk.booleanToCloudFormation(properties.storageEncrypted) }) : properties;
    }
    function CfnGlobalClusterPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deletionProtection", "DeletionProtection", properties.DeletionProtection != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeletionProtection) : void 0), ret.addPropertyResult("engine", "Engine", properties.Engine != null ? cfn_parse.FromCloudFormation.getString(properties.Engine) : void 0), ret.addPropertyResult("engineVersion", "EngineVersion", properties.EngineVersion != null ? cfn_parse.FromCloudFormation.getString(properties.EngineVersion) : void 0), ret.addPropertyResult("globalClusterIdentifier", "GlobalClusterIdentifier", properties.GlobalClusterIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.GlobalClusterIdentifier) : void 0), ret.addPropertyResult("sourceDbClusterIdentifier", "SourceDBClusterIdentifier", properties.SourceDBClusterIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.SourceDBClusterIdentifier) : void 0), ret.addPropertyResult("storageEncrypted", "StorageEncrypted", properties.StorageEncrypted != null ? cfn_parse.FromCloudFormation.getBoolean(properties.StorageEncrypted) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnGlobalCluster = class _CfnGlobalCluster extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnGlobalClusterPropsFromCloudFormation(resourceProperties), ret = new _CfnGlobalCluster(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnGlobalCluster.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_CfnGlobalClusterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnGlobalCluster), error;
        }
        this.deletionProtection = props.deletionProtection, this.engine = props.engine, this.engineVersion = props.engineVersion, this.globalClusterIdentifier = props.globalClusterIdentifier, this.sourceDbClusterIdentifier = props.sourceDbClusterIdentifier, this.storageEncrypted = props.storageEncrypted;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnGlobalCluster.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { deletionProtection: this.deletionProtection, engine: this.engine, engineVersion: this.engineVersion, globalClusterIdentifier: this.globalClusterIdentifier, sourceDbClusterIdentifier: this.sourceDbClusterIdentifier, storageEncrypted: this.storageEncrypted };
      }
      renderProperties(props) {
        return cfnGlobalClusterPropsToCloudFormation(props);
      }
    };
    _m = JSII_RTTI_SYMBOL_1, CfnGlobalCluster[_m] = { fqn: "aws-cdk-lib.aws_rds.CfnGlobalCluster", version: "2.80.0" }, CfnGlobalCluster.CFN_RESOURCE_TYPE_NAME = "AWS::RDS::GlobalCluster", exports2.CfnGlobalCluster = CfnGlobalCluster;
    function CfnOptionGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("engineName", cdk.requiredValidator)(properties.engineName)), errors.collect(cdk.propertyValidator("engineName", cdk.validateString)(properties.engineName)), errors.collect(cdk.propertyValidator("majorEngineVersion", cdk.requiredValidator)(properties.majorEngineVersion)), errors.collect(cdk.propertyValidator("majorEngineVersion", cdk.validateString)(properties.majorEngineVersion)), errors.collect(cdk.propertyValidator("optionConfigurations", cdk.listValidator(CfnOptionGroup_OptionConfigurationPropertyValidator))(properties.optionConfigurations)), errors.collect(cdk.propertyValidator("optionGroupDescription", cdk.requiredValidator)(properties.optionGroupDescription)), errors.collect(cdk.propertyValidator("optionGroupDescription", cdk.validateString)(properties.optionGroupDescription)), errors.collect(cdk.propertyValidator("optionGroupName", cdk.validateString)(properties.optionGroupName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnOptionGroupProps"');
    }
    function cfnOptionGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOptionGroupPropsValidator(properties).assertSuccess(), { EngineName: cdk.stringToCloudFormation(properties.engineName), MajorEngineVersion: cdk.stringToCloudFormation(properties.majorEngineVersion), OptionGroupDescription: cdk.stringToCloudFormation(properties.optionGroupDescription), OptionConfigurations: cdk.listMapper(cfnOptionGroupOptionConfigurationPropertyToCloudFormation)(properties.optionConfigurations), OptionGroupName: cdk.stringToCloudFormation(properties.optionGroupName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnOptionGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("engineName", "EngineName", cfn_parse.FromCloudFormation.getString(properties.EngineName)), ret.addPropertyResult("majorEngineVersion", "MajorEngineVersion", cfn_parse.FromCloudFormation.getString(properties.MajorEngineVersion)), ret.addPropertyResult("optionGroupDescription", "OptionGroupDescription", cfn_parse.FromCloudFormation.getString(properties.OptionGroupDescription)), ret.addPropertyResult("optionConfigurations", "OptionConfigurations", properties.OptionConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnOptionGroupOptionConfigurationPropertyFromCloudFormation)(properties.OptionConfigurations) : void 0), ret.addPropertyResult("optionGroupName", "OptionGroupName", properties.OptionGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.OptionGroupName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnOptionGroup = class _CfnOptionGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnOptionGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnOptionGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnOptionGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_CfnOptionGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnOptionGroup), error;
        }
        cdk.requireProperty(props, "engineName", this), cdk.requireProperty(props, "majorEngineVersion", this), cdk.requireProperty(props, "optionGroupDescription", this), this.engineName = props.engineName, this.majorEngineVersion = props.majorEngineVersion, this.optionGroupDescription = props.optionGroupDescription, this.optionConfigurations = props.optionConfigurations, this.optionGroupName = props.optionGroupName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::RDS::OptionGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnOptionGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { engineName: this.engineName, majorEngineVersion: this.majorEngineVersion, optionGroupDescription: this.optionGroupDescription, optionConfigurations: this.optionConfigurations, optionGroupName: this.optionGroupName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnOptionGroupPropsToCloudFormation(props);
      }
    };
    _o = JSII_RTTI_SYMBOL_1, CfnOptionGroup[_o] = { fqn: "aws-cdk-lib.aws_rds.CfnOptionGroup", version: "2.80.0" }, CfnOptionGroup.CFN_RESOURCE_TYPE_NAME = "AWS::RDS::OptionGroup", exports2.CfnOptionGroup = CfnOptionGroup;
    function CfnOptionGroup_OptionConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dbSecurityGroupMemberships", cdk.listValidator(cdk.validateString))(properties.dbSecurityGroupMemberships)), errors.collect(cdk.propertyValidator("optionName", cdk.requiredValidator)(properties.optionName)), errors.collect(cdk.propertyValidator("optionName", cdk.validateString)(properties.optionName)), errors.collect(cdk.propertyValidator("optionSettings", cdk.listValidator(CfnOptionGroup_OptionSettingPropertyValidator))(properties.optionSettings)), errors.collect(cdk.propertyValidator("optionVersion", cdk.validateString)(properties.optionVersion)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("vpcSecurityGroupMemberships", cdk.listValidator(cdk.validateString))(properties.vpcSecurityGroupMemberships)), errors.wrap('supplied properties not correct for "OptionConfigurationProperty"');
    }
    function cfnOptionGroupOptionConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOptionGroup_OptionConfigurationPropertyValidator(properties).assertSuccess(), { DBSecurityGroupMemberships: cdk.listMapper(cdk.stringToCloudFormation)(properties.dbSecurityGroupMemberships), OptionName: cdk.stringToCloudFormation(properties.optionName), OptionSettings: cdk.listMapper(cfnOptionGroupOptionSettingPropertyToCloudFormation)(properties.optionSettings), OptionVersion: cdk.stringToCloudFormation(properties.optionVersion), Port: cdk.numberToCloudFormation(properties.port), VpcSecurityGroupMemberships: cdk.listMapper(cdk.stringToCloudFormation)(properties.vpcSecurityGroupMemberships) }) : properties;
    }
    function CfnOptionGroupOptionConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dbSecurityGroupMemberships", "DBSecurityGroupMemberships", properties.DBSecurityGroupMemberships != null ? cfn_parse.FromCloudFormation.getStringArray(properties.DBSecurityGroupMemberships) : void 0), ret.addPropertyResult("optionName", "OptionName", cfn_parse.FromCloudFormation.getString(properties.OptionName)), ret.addPropertyResult("optionSettings", "OptionSettings", properties.OptionSettings != null ? cfn_parse.FromCloudFormation.getArray(CfnOptionGroupOptionSettingPropertyFromCloudFormation)(properties.OptionSettings) : void 0), ret.addPropertyResult("optionVersion", "OptionVersion", properties.OptionVersion != null ? cfn_parse.FromCloudFormation.getString(properties.OptionVersion) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addPropertyResult("vpcSecurityGroupMemberships", "VpcSecurityGroupMemberships", properties.VpcSecurityGroupMemberships != null ? cfn_parse.FromCloudFormation.getStringArray(properties.VpcSecurityGroupMemberships) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnOptionGroup_OptionSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "OptionSettingProperty"');
    }
    function cfnOptionGroupOptionSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOptionGroup_OptionSettingPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnOptionGroupOptionSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-rds/lib/parameter-group.js
var require_parameter_group = __commonJS({
  "node_modules/aws-cdk-lib/aws-rds/lib/parameter-group.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ParameterGroup = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var rds_generated_1 = require_rds_generated();
    var core_1 = require_core2();
    var ParameterGroup = class _ParameterGroup extends core_1.Resource {
      static fromParameterGroupName(scope, id, parameterGroupName) {
        class Import extends core_1.Resource {
          bindToCluster(_options) {
            return { parameterGroupName };
          }
          bindToInstance(_options) {
            return { parameterGroupName };
          }
          addParameter(_key, _value) {
            return false;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_ParameterGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ParameterGroup), error;
        }
        const family = props.engine.parameterGroupFamily;
        if (!family)
          throw new Error("ParameterGroup cannot be used with an engine that doesn't specify a version");
        this.family = family, this.description = props.description, this.parameters = props.parameters ?? {};
      }
      bindToCluster(_options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_ParameterGroupClusterBindOptions(_options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bindToCluster), error;
        }
        if (!this.clusterCfnGroup) {
          const id = this.instanceCfnGroup ? "ClusterParameterGroup" : "Resource";
          this.clusterCfnGroup = new rds_generated_1.CfnDBClusterParameterGroup(this, id, { description: this.description || `Cluster parameter group for ${this.family}`, family: this.family, parameters: core_1.Lazy.any({ produce: () => this.parameters }) });
        }
        return { parameterGroupName: this.clusterCfnGroup.ref };
      }
      bindToInstance(_options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_ParameterGroupInstanceBindOptions(_options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bindToInstance), error;
        }
        if (!this.instanceCfnGroup) {
          const id = this.clusterCfnGroup ? "InstanceParameterGroup" : "Resource";
          this.instanceCfnGroup = new rds_generated_1.CfnDBParameterGroup(this, id, { description: this.description || `Parameter group for ${this.family}`, family: this.family, parameters: core_1.Lazy.any({ produce: () => this.parameters }) });
        }
        return { parameterGroupName: this.instanceCfnGroup.ref };
      }
      addParameter(key, value) {
        return this.parameters[key] = value, true;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ParameterGroup[_a] = { fqn: "aws-cdk-lib.aws_rds.ParameterGroup", version: "2.80.0" }, exports2.ParameterGroup = ParameterGroup;
  }
});

// node_modules/aws-cdk-lib/aws-rds/lib/proxy.js
var require_proxy = __commonJS({
  "node_modules/aws-cdk-lib/aws-rds/lib/proxy.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DatabaseProxy = exports2.ProxyTarget = exports2.SessionPinningFilter = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var util_1 = require_util16();
    var rds_generated_1 = require_rds_generated();
    var ec2 = require_aws_ec2();
    var iam = require_aws_iam();
    var secretsmanager = require_aws_secretsmanager();
    var cdk = require_core2();
    var cxapi = require_cx_api();
    var SessionPinningFilter = class _SessionPinningFilter {
      static of(filterName) {
        return new _SessionPinningFilter(filterName);
      }
      constructor(filterName) {
        this.filterName = filterName;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SessionPinningFilter[_a] = { fqn: "aws-cdk-lib.aws_rds.SessionPinningFilter", version: "2.80.0" }, SessionPinningFilter.EXCLUDE_VARIABLE_SETS = new SessionPinningFilter("EXCLUDE_VARIABLE_SETS"), exports2.SessionPinningFilter = SessionPinningFilter;
    var ProxyTarget = class _ProxyTarget {
      static fromInstance(instance) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_IDatabaseInstance(instance);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromInstance), error;
        }
        return new _ProxyTarget(instance, void 0);
      }
      static fromCluster(cluster) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_IDatabaseCluster(cluster);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromCluster), error;
        }
        return new _ProxyTarget(void 0, cluster);
      }
      constructor(dbInstance, dbCluster) {
        this.dbInstance = dbInstance, this.dbCluster = dbCluster;
      }
      bind(proxy) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_DatabaseProxy(proxy);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        const engine = this.dbInstance?.engine ?? this.dbCluster?.engine;
        if (!engine) {
          const errorResource = this.dbCluster ?? this.dbInstance;
          throw new Error(`Could not determine engine for proxy target '${errorResource?.node.path}'. Please provide it explicitly when importing the resource`);
        }
        const engineFamily = engine.engineFamily;
        if (!engineFamily)
          throw new Error(`Engine '${(0, util_1.engineDescription)(engine)}' does not support proxies`);
        return this.dbCluster?.connections.allowDefaultPortFrom(proxy, "Allow connections to the database Cluster from the Proxy"), this.dbInstance?.connections.allowDefaultPortFrom(proxy, "Allow connections to the database Instance from the Proxy"), { engineFamily, dbClusters: this.dbCluster ? [this.dbCluster] : void 0, dbInstances: this.dbInstance ? [this.dbInstance] : void 0 };
      }
    };
    _b = JSII_RTTI_SYMBOL_1, ProxyTarget[_b] = { fqn: "aws-cdk-lib.aws_rds.ProxyTarget", version: "2.80.0" }, exports2.ProxyTarget = ProxyTarget;
    var DatabaseProxyBase = class extends cdk.Resource {
      grantConnect(grantee, dbUser) {
        if (!dbUser)
          throw new Error("For imported Database Proxies, the dbUser is required in grantConnect()");
        const scopeStack = cdk.Stack.of(this), proxyGeneratedId = scopeStack.splitArn(this.dbProxyArn, cdk.ArnFormat.COLON_RESOURCE_NAME).resourceName, userArn = scopeStack.formatArn({ service: "rds-db", resource: "dbuser", resourceName: `${proxyGeneratedId}/${dbUser}`, arnFormat: cdk.ArnFormat.COLON_RESOURCE_NAME });
        return iam.Grant.addToPrincipal({ grantee, actions: ["rds-db:connect"], resourceArns: [userArn] });
      }
    };
    var DatabaseProxy = class _DatabaseProxy extends DatabaseProxyBase {
      static fromDatabaseProxyAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_DatabaseProxyAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromDatabaseProxyAttributes), error;
        }
        class Import extends DatabaseProxyBase {
          constructor() {
            super(...arguments), this.dbProxyName = attrs.dbProxyName, this.dbProxyArn = attrs.dbProxyArn, this.endpoint = attrs.endpoint;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_DatabaseProxyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _DatabaseProxy), error;
        }
        const physicalName = props.dbProxyName || (cdk.FeatureFlags.of(this).isEnabled(cxapi.DATABASE_PROXY_UNIQUE_RESOURCE_NAME) ? cdk.Names.uniqueResourceName(this, { maxLength: 60 }) : id), role = props.role || new iam.Role(this, "IAMRole", { assumedBy: new iam.ServicePrincipal("rds.amazonaws.com") });
        for (const secret of props.secrets)
          secret.grantRead(role);
        const securityGroups = props.securityGroups ?? [new ec2.SecurityGroup(this, "ProxySecurityGroup", { description: "SecurityGroup for Database Proxy", vpc: props.vpc })];
        this.connections = new ec2.Connections({ securityGroups });
        const bindResult = props.proxyTarget.bind(this);
        if (props.secrets.length < 1)
          throw new Error("One or more secrets are required.");
        this.secrets = props.secrets, this.resource = new rds_generated_1.CfnDBProxy(this, "Resource", { auth: props.secrets.map((_) => ({ authScheme: "SECRETS", iamAuth: props.iamAuth ? "REQUIRED" : "DISABLED", secretArn: _.secretArn })), dbProxyName: physicalName, debugLogging: props.debugLogging, engineFamily: bindResult.engineFamily, idleClientTimeout: props.idleClientTimeout?.toSeconds(), requireTls: props.requireTLS ?? true, roleArn: role.roleArn, vpcSecurityGroupIds: cdk.Lazy.list({ produce: () => this.connections.securityGroups.map((_) => _.securityGroupId) }), vpcSubnetIds: props.vpc.selectSubnets(props.vpcSubnets).subnetIds }), this.dbProxyName = this.resource.ref, this.dbProxyArn = this.resource.attrDbProxyArn, this.endpoint = this.resource.attrEndpoint;
        let dbInstanceIdentifiers;
        bindResult.dbInstances && (dbInstanceIdentifiers = [bindResult.dbInstances[0].instanceIdentifier]);
        let dbClusterIdentifiers;
        if (bindResult.dbClusters && (dbClusterIdentifiers = bindResult.dbClusters.map((c) => c.clusterIdentifier)), dbInstanceIdentifiers && dbClusterIdentifiers)
          throw new Error("Cannot specify both dbInstanceIdentifiers and dbClusterIdentifiers");
        const proxyTargetGroup = new rds_generated_1.CfnDBProxyTargetGroup(this, "ProxyTargetGroup", { targetGroupName: "default", dbProxyName: this.dbProxyName, dbInstanceIdentifiers, dbClusterIdentifiers, connectionPoolConfigurationInfo: toConnectionPoolConfigurationInfo(props) });
        bindResult.dbClusters?.forEach((c) => proxyTargetGroup.node.addDependency(c));
      }
      asSecretAttachmentTarget() {
        return { targetId: this.dbProxyName, targetType: secretsmanager.AttachmentTargetType.RDS_DB_PROXY };
      }
      grantConnect(grantee, dbUser) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(grantee);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantConnect), error;
        }
        if (!dbUser) {
          if (this.secrets.length > 1)
            throw new Error("When the Proxy contains multiple Secrets, you must pass a dbUser explicitly to grantConnect()");
          dbUser = this.secrets[0].secretValueFromJson("username").unsafeUnwrap();
        }
        return super.grantConnect(grantee, dbUser);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, DatabaseProxy[_c] = { fqn: "aws-cdk-lib.aws_rds.DatabaseProxy", version: "2.80.0" }, exports2.DatabaseProxy = DatabaseProxy;
    function toConnectionPoolConfigurationInfo(props) {
      return { connectionBorrowTimeout: props.borrowTimeout?.toSeconds(), initQuery: props.initQuery, maxConnectionsPercent: props.maxConnectionsPercent, maxIdleConnectionsPercent: props.maxIdleConnectionsPercent, sessionPinningFilters: props.sessionPinningFilters?.map((_) => _.filterName) };
    }
  }
});

// node_modules/aws-cdk-lib/aws-rds/lib/subnet-group.js
var require_subnet_group = __commonJS({
  "node_modules/aws-cdk-lib/aws-rds/lib/subnet-group.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SubnetGroup = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var rds_generated_1 = require_rds_generated();
    var ec2 = require_aws_ec2();
    var core_1 = require_core2();
    var SubnetGroup = class _SubnetGroup extends core_1.Resource {
      static fromSubnetGroupName(scope, id, subnetGroupName) {
        return new class extends core_1.Resource {
          constructor() {
            super(...arguments), this.subnetGroupName = subnetGroupName;
          }
        }(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_SubnetGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SubnetGroup), error;
        }
        const { subnetIds } = props.vpc.selectSubnets(props.vpcSubnets ?? { subnetType: ec2.SubnetType.PRIVATE_WITH_EGRESS }), subnetGroup = new rds_generated_1.CfnDBSubnetGroup(this, "Default", { dbSubnetGroupDescription: props.description, dbSubnetGroupName: core_1.Token.isUnresolved(props.subnetGroupName) ? props.subnetGroupName : props.subnetGroupName?.toLowerCase(), subnetIds });
        props.removalPolicy && subnetGroup.applyRemovalPolicy(props.removalPolicy), this.subnetGroupName = subnetGroup.ref;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SubnetGroup[_a] = { fqn: "aws-cdk-lib.aws_rds.SubnetGroup", version: "2.80.0" }, exports2.SubnetGroup = SubnetGroup;
  }
});

// node_modules/aws-cdk-lib/aws-rds/lib/cluster.js
var require_cluster = __commonJS({
  "node_modules/aws-cdk-lib/aws-rds/lib/cluster.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DatabaseClusterFromSnapshot = exports2.DatabaseCluster = exports2.DatabaseClusterBase = exports2.InstanceUpdateBehaviour = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var database_secret_1 = require_database_secret();
    var endpoint_1 = require_endpoint();
    var parameter_group_1 = require_parameter_group();
    var util_1 = require_util16();
    var props_1 = require_props();
    var proxy_1 = require_proxy();
    var rds_generated_1 = require_rds_generated();
    var subnet_group_1 = require_subnet_group();
    var ec2 = require_aws_ec2();
    var aws_iam_1 = require_aws_iam();
    var logs = require_aws_logs();
    var secretsmanager = require_aws_secretsmanager();
    var core_1 = require_core2();
    var cxapi = require_cx_api();
    var InstanceUpdateBehaviour;
    (function(InstanceUpdateBehaviour2) {
      InstanceUpdateBehaviour2.BULK = "BULK", InstanceUpdateBehaviour2.ROLLING = "ROLLING";
    })(InstanceUpdateBehaviour = exports2.InstanceUpdateBehaviour || (exports2.InstanceUpdateBehaviour = {}));
    var DatabaseClusterBase = class extends core_1.Resource {
      addProxy(id, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_DatabaseProxyOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addProxy), error;
        }
        return new proxy_1.DatabaseProxy(this, id, { proxyTarget: proxy_1.ProxyTarget.fromCluster(this), ...options });
      }
      asSecretAttachmentTarget() {
        return { targetId: this.clusterIdentifier, targetType: secretsmanager.AttachmentTargetType.RDS_DB_CLUSTER };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, DatabaseClusterBase[_a] = { fqn: "aws-cdk-lib.aws_rds.DatabaseClusterBase", version: "2.80.0" }, exports2.DatabaseClusterBase = DatabaseClusterBase;
    var DatabaseClusterNew = class extends DatabaseClusterBase {
      constructor(scope, id, props) {
        super(scope, id), this.vpc = props.instanceProps.vpc, this.vpcSubnets = props.instanceProps.vpcSubnets, this.singleUserRotationApplication = props.engine.singleUserRotationApplication, this.multiUserRotationApplication = props.engine.multiUserRotationApplication;
        const { subnetIds } = props.instanceProps.vpc.selectSubnets(props.instanceProps.vpcSubnets);
        subnetIds.length < 2 && core_1.Annotations.of(this).addError(`Cluster requires at least 2 subnets, got ${subnetIds.length}`), this.subnetGroup = props.subnetGroup ?? new subnet_group_1.SubnetGroup(this, "Subnets", { description: `Subnets for ${id} database`, vpc: props.instanceProps.vpc, vpcSubnets: props.instanceProps.vpcSubnets, removalPolicy: (0, util_1.renderUnless)((0, util_1.helperRemovalPolicy)(props.removalPolicy), core_1.RemovalPolicy.DESTROY) }), this.securityGroups = props.instanceProps.securityGroups ?? [new ec2.SecurityGroup(this, "SecurityGroup", { description: "RDS security group", vpc: props.instanceProps.vpc })];
        const combineRoles = props.engine.combineImportAndExportRoles ?? false;
        let { s3ImportRole, s3ExportRole } = (0, util_1.setupS3ImportExport)(this, props, combineRoles);
        if (props.parameterGroup && props.parameters)
          throw new Error("You cannot specify both parameterGroup and parameters");
        const parameterGroup = props.parameterGroup ?? (props.parameters ? new parameter_group_1.ParameterGroup(this, "ParameterGroup", { engine: props.engine, parameters: props.parameters }) : void 0), clusterEngineBindConfig = props.engine.bindToCluster(this, { s3ImportRole, s3ExportRole, parameterGroup }), clusterAssociatedRoles = [];
        s3ImportRole && clusterAssociatedRoles.push({ roleArn: s3ImportRole.roleArn, featureName: clusterEngineBindConfig.features?.s3Import }), s3ExportRole && (s3ExportRole !== s3ImportRole || clusterEngineBindConfig.features?.s3Import !== clusterEngineBindConfig.features?.s3Export) && clusterAssociatedRoles.push({ roleArn: s3ExportRole.roleArn, featureName: clusterEngineBindConfig.features?.s3Export });
        const clusterParameterGroupConfig = (props.parameterGroup ?? clusterEngineBindConfig.parameterGroup)?.bindToCluster({});
        this.engine = props.engine;
        const clusterIdentifier = core_1.FeatureFlags.of(this).isEnabled(cxapi.RDS_LOWERCASE_DB_IDENTIFIER) && !core_1.Token.isUnresolved(props.clusterIdentifier) ? props.clusterIdentifier?.toLowerCase() : props.clusterIdentifier;
        this.newCfnProps = { engine: props.engine.engineType, engineVersion: props.engine.engineVersion?.fullVersion, dbClusterIdentifier: clusterIdentifier, dbSubnetGroupName: this.subnetGroup.subnetGroupName, vpcSecurityGroupIds: this.securityGroups.map((sg) => sg.securityGroupId), port: props.port ?? clusterEngineBindConfig.port, dbClusterParameterGroupName: clusterParameterGroupConfig?.parameterGroupName, associatedRoles: clusterAssociatedRoles.length > 0 ? clusterAssociatedRoles : void 0, deletionProtection: (0, util_1.defaultDeletionProtection)(props.deletionProtection, props.removalPolicy), enableIamDatabaseAuthentication: props.iamAuthentication, networkType: props.networkType, backtrackWindow: props.backtrackWindow?.toSeconds(), backupRetentionPeriod: props.backup?.retention?.toDays(), preferredBackupWindow: props.backup?.preferredWindow, preferredMaintenanceWindow: props.preferredMaintenanceWindow, databaseName: props.defaultDatabaseName, enableCloudwatchLogsExports: props.cloudwatchLogsExports, kmsKeyId: props.storageEncryptionKey?.keyArn, storageEncrypted: props.storageEncryptionKey ? true : props.storageEncrypted, copyTagsToSnapshot: props.copyTagsToSnapshot ?? true };
      }
      addRotationSingleUser(options = {}) {
        if (!this.secret)
          throw new Error("Cannot add a single user rotation for a cluster without a secret.");
        const id = "RotationSingleUser";
        if (this.node.tryFindChild(id))
          throw new Error("A single user rotation was already added to this cluster.");
        return new secretsmanager.SecretRotation(this, id, { ...(0, util_1.applyDefaultRotationOptions)(options, this.vpcSubnets), secret: this.secret, application: this.singleUserRotationApplication, vpc: this.vpc, target: this });
      }
      addRotationMultiUser(id, options) {
        if (!this.secret)
          throw new Error("Cannot add a multi user rotation for a cluster without a secret.");
        return new secretsmanager.SecretRotation(this, id, { ...(0, util_1.applyDefaultRotationOptions)(options, this.vpcSubnets), secret: options.secret, masterSecret: this.secret, application: this.multiUserRotationApplication, vpc: this.vpc, target: this });
      }
    };
    var ImportedDatabaseCluster = class extends DatabaseClusterBase {
      constructor(scope, id, attrs) {
        super(scope, id), this.clusterIdentifier = attrs.clusterIdentifier, this._clusterResourceIdentifier = attrs.clusterResourceIdentifier;
        const defaultPort = attrs.port ? ec2.Port.tcp(attrs.port) : void 0;
        this.connections = new ec2.Connections({ securityGroups: attrs.securityGroups, defaultPort }), this.engine = attrs.engine, this._clusterEndpoint = attrs.clusterEndpointAddress && attrs.port ? new endpoint_1.Endpoint(attrs.clusterEndpointAddress, attrs.port) : void 0, this._clusterReadEndpoint = attrs.readerEndpointAddress && attrs.port ? new endpoint_1.Endpoint(attrs.readerEndpointAddress, attrs.port) : void 0, this._instanceIdentifiers = attrs.instanceIdentifiers, this._instanceEndpoints = attrs.instanceEndpointAddresses && attrs.port ? attrs.instanceEndpointAddresses.map((addr) => new endpoint_1.Endpoint(addr, attrs.port)) : void 0;
      }
      get clusterResourceIdentifier() {
        if (!this._clusterResourceIdentifier)
          throw new Error("Cannot access `clusterResourceIdentifier` of an imported cluster without a clusterResourceIdentifier");
        return this._clusterResourceIdentifier;
      }
      get clusterEndpoint() {
        if (!this._clusterEndpoint)
          throw new Error("Cannot access `clusterEndpoint` of an imported cluster without an endpoint address and port");
        return this._clusterEndpoint;
      }
      get clusterReadEndpoint() {
        if (!this._clusterReadEndpoint)
          throw new Error("Cannot access `clusterReadEndpoint` of an imported cluster without a readerEndpointAddress and port");
        return this._clusterReadEndpoint;
      }
      get instanceIdentifiers() {
        if (!this._instanceIdentifiers)
          throw new Error("Cannot access `instanceIdentifiers` of an imported cluster without provided instanceIdentifiers");
        return this._instanceIdentifiers;
      }
      get instanceEndpoints() {
        if (!this._instanceEndpoints)
          throw new Error("Cannot access `instanceEndpoints` of an imported cluster without instanceEndpointAddresses and port");
        return this._instanceEndpoints;
      }
    };
    var DatabaseCluster = class _DatabaseCluster extends DatabaseClusterNew {
      static fromDatabaseClusterAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_DatabaseClusterAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromDatabaseClusterAttributes), error;
        }
        return new ImportedDatabaseCluster(scope, id, attrs);
      }
      constructor(scope, id, props) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_DatabaseClusterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _DatabaseCluster), error;
        }
        const credentials = (0, util_1.renderCredentials)(this, props.engine, props.credentials), secret = credentials.secret, cluster = new rds_generated_1.CfnDBCluster(this, "Resource", { ...this.newCfnProps, masterUsername: credentials.username, masterUserPassword: credentials.password?.unsafeUnwrap() });
        this.clusterIdentifier = cluster.ref, this.clusterResourceIdentifier = cluster.attrDbClusterResourceId, secret && (this.secret = secret.attach(this));
        const portAttribute = core_1.Token.asNumber(cluster.attrEndpointPort);
        this.clusterEndpoint = new endpoint_1.Endpoint(cluster.attrEndpointAddress, portAttribute), this.clusterReadEndpoint = new endpoint_1.Endpoint(cluster.attrReadEndpointAddress, portAttribute), this.connections = new ec2.Connections({ securityGroups: this.securityGroups, defaultPort: ec2.Port.tcp(this.clusterEndpoint.port) }), cluster.applyRemovalPolicy(props.removalPolicy ?? core_1.RemovalPolicy.SNAPSHOT), setLogRetention(this, props);
        const createdInstances = createInstances(this, props, this.subnetGroup);
        this.instanceIdentifiers = createdInstances.instanceIdentifiers, this.instanceEndpoints = createdInstances.instanceEndpoints;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, DatabaseCluster[_b] = { fqn: "aws-cdk-lib.aws_rds.DatabaseCluster", version: "2.80.0" }, exports2.DatabaseCluster = DatabaseCluster;
    var DatabaseClusterFromSnapshot = class _DatabaseClusterFromSnapshot extends DatabaseClusterNew {
      constructor(scope, id, props) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_DatabaseClusterFromSnapshotProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _DatabaseClusterFromSnapshot), error;
        }
        props.credentials && !props.credentials.password && !props.credentials.secret && core_1.Annotations.of(this).addWarning("Use `snapshotCredentials` to modify password of a cluster created from a snapshot."), !props.credentials && !props.snapshotCredentials && core_1.Annotations.of(this).addWarning("Generated credentials will not be applied to cluster. Use `snapshotCredentials` instead. `addRotationSingleUser()` and `addRotationMultiUser()` cannot be used on this cluster.");
        const deprecatedCredentials = (0, util_1.renderCredentials)(this, props.engine, props.credentials);
        let credentials = props.snapshotCredentials, secret = credentials?.secret;
        if (!secret && credentials?.generatePassword) {
          if (!credentials.username)
            throw new Error("`snapshotCredentials` `username` must be specified when `generatePassword` is set to true");
          secret = new database_secret_1.DatabaseSecret(this, "SnapshotSecret", { username: credentials.username, encryptionKey: credentials.encryptionKey, excludeCharacters: credentials.excludeCharacters, replaceOnPasswordCriteriaChanges: credentials.replaceOnPasswordCriteriaChanges, replicaRegions: credentials.replicaRegions });
        }
        const cluster = new rds_generated_1.CfnDBCluster(this, "Resource", { ...this.newCfnProps, snapshotIdentifier: props.snapshotIdentifier, masterUserPassword: secret?.secretValueFromJson("password")?.unsafeUnwrap() ?? credentials?.password?.unsafeUnwrap() });
        if (this.clusterIdentifier = cluster.ref, this.clusterResourceIdentifier = cluster.attrDbClusterResourceId, secret && (this.secret = secret.attach(this)), deprecatedCredentials.secret) {
          const deprecatedSecret = deprecatedCredentials.secret.attach(this);
          this.secret || (this.secret = deprecatedSecret);
        }
        const portAttribute = core_1.Token.asNumber(cluster.attrEndpointPort);
        this.clusterEndpoint = new endpoint_1.Endpoint(cluster.attrEndpointAddress, portAttribute), this.clusterReadEndpoint = new endpoint_1.Endpoint(cluster.attrReadEndpointAddress, portAttribute), this.connections = new ec2.Connections({ securityGroups: this.securityGroups, defaultPort: ec2.Port.tcp(this.clusterEndpoint.port) }), cluster.applyRemovalPolicy(props.removalPolicy ?? core_1.RemovalPolicy.SNAPSHOT), setLogRetention(this, props);
        const createdInstances = createInstances(this, props, this.subnetGroup);
        this.instanceIdentifiers = createdInstances.instanceIdentifiers, this.instanceEndpoints = createdInstances.instanceEndpoints;
      }
    };
    _c = JSII_RTTI_SYMBOL_1, DatabaseClusterFromSnapshot[_c] = { fqn: "aws-cdk-lib.aws_rds.DatabaseClusterFromSnapshot", version: "2.80.0" }, exports2.DatabaseClusterFromSnapshot = DatabaseClusterFromSnapshot;
    function setLogRetention(cluster, props) {
      if (props.cloudwatchLogsExports) {
        const unsupportedLogTypes = props.cloudwatchLogsExports.filter((logType) => !props.engine.supportedLogTypes.includes(logType));
        if (unsupportedLogTypes.length > 0)
          throw new Error(`Unsupported logs for the current engine type: ${unsupportedLogTypes.join(",")}`);
        if (props.cloudwatchLogsRetention)
          for (const log of props.cloudwatchLogsExports)
            new logs.LogRetention(cluster, `LogRetention${log}`, { logGroupName: `/aws/rds/cluster/${cluster.clusterIdentifier}/${log}`, retention: props.cloudwatchLogsRetention, role: props.cloudwatchLogsRetentionRole });
      }
    }
    function createInstances(cluster, props, subnetGroup) {
      const instanceCount = props.instances != null ? props.instances : 2, instanceUpdateBehaviour = props.instanceUpdateBehaviour ?? InstanceUpdateBehaviour.BULK;
      if (core_1.Token.isUnresolved(instanceCount))
        throw new Error("The number of instances an RDS Cluster consists of cannot be provided as a deploy-time only value!");
      if (instanceCount < 1)
        throw new Error("At least one instance is required");
      const instanceIdentifiers = [], instanceEndpoints = [], portAttribute = cluster.clusterEndpoint.port, instanceProps = props.instanceProps, internetConnected = instanceProps.vpc.selectSubnets(instanceProps.vpcSubnets).internetConnectivityEstablished;
      let monitoringRole;
      props.monitoringInterval && props.monitoringInterval.toSeconds() && (monitoringRole = props.monitoringRole || new aws_iam_1.Role(cluster, "MonitoringRole", { assumedBy: new aws_iam_1.ServicePrincipal("monitoring.rds.amazonaws.com"), managedPolicies: [aws_iam_1.ManagedPolicy.fromAwsManagedPolicyName("service-role/AmazonRDSEnhancedMonitoringRole")] }));
      const enablePerformanceInsights = instanceProps.enablePerformanceInsights || instanceProps.performanceInsightRetention !== void 0 || instanceProps.performanceInsightEncryptionKey !== void 0;
      if (enablePerformanceInsights && instanceProps.enablePerformanceInsights === false)
        throw new Error("`enablePerformanceInsights` disabled, but `performanceInsightRetention` or `performanceInsightEncryptionKey` was set");
      const instanceType = instanceProps.instanceType ?? ec2.InstanceType.of(ec2.InstanceClass.T3, ec2.InstanceSize.MEDIUM);
      if (instanceProps.parameterGroup && instanceProps.parameters)
        throw new Error("You cannot specify both parameterGroup and parameters");
      const instanceParameterGroupConfig = (instanceProps.parameterGroup ?? (instanceProps.parameters ? new parameter_group_1.ParameterGroup(cluster, "InstanceParameterGroup", { engine: props.engine, parameters: instanceProps.parameters }) : void 0))?.bindToInstance({}), instances = [];
      for (let i = 0; i < instanceCount; i++) {
        const instanceIndex = i + 1, instanceIdentifier = props.instanceIdentifierBase != null ? `${props.instanceIdentifierBase}${instanceIndex}` : props.clusterIdentifier != null ? `${props.clusterIdentifier}instance${instanceIndex}` : void 0, instance = new rds_generated_1.CfnDBInstance(cluster, `Instance${instanceIndex}`, { engine: props.engine.engineType, dbClusterIdentifier: cluster.clusterIdentifier, dbInstanceIdentifier: instanceIdentifier, dbInstanceClass: databaseInstanceType(instanceType), publiclyAccessible: instanceProps.publiclyAccessible ?? (instanceProps.vpcSubnets && instanceProps.vpcSubnets.subnetType === ec2.SubnetType.PUBLIC), enablePerformanceInsights: enablePerformanceInsights || instanceProps.enablePerformanceInsights, performanceInsightsKmsKeyId: instanceProps.performanceInsightEncryptionKey?.keyArn, performanceInsightsRetentionPeriod: enablePerformanceInsights ? instanceProps.performanceInsightRetention || props_1.PerformanceInsightRetention.DEFAULT : void 0, dbSubnetGroupName: subnetGroup.subnetGroupName, dbParameterGroupName: instanceParameterGroupConfig?.parameterGroupName, monitoringInterval: props.monitoringInterval && props.monitoringInterval.toSeconds(), monitoringRoleArn: monitoringRole && monitoringRole.roleArn, autoMinorVersionUpgrade: props.instanceProps.autoMinorVersionUpgrade, allowMajorVersionUpgrade: props.instanceProps.allowMajorVersionUpgrade, deleteAutomatedBackups: props.instanceProps.deleteAutomatedBackups });
        instance.applyRemovalPolicy((0, util_1.helperRemovalPolicy)(props.removalPolicy)), instance.node.addDependency(internetConnected), instanceIdentifiers.push(instance.ref), instanceEndpoints.push(new endpoint_1.Endpoint(instance.attrEndpointAddress, portAttribute)), instances.push(instance);
      }
      if (instanceUpdateBehaviour === InstanceUpdateBehaviour.ROLLING)
        for (let i = 1; i < instanceCount; i++)
          instances[i].node.addDependency(instances[i - 1]);
      return { instanceEndpoints, instanceIdentifiers };
    }
    function databaseInstanceType(instanceType) {
      return "db." + instanceType.toString();
    }
  }
});

// node_modules/aws-cdk-lib/aws-rds/lib/cluster-ref.js
var require_cluster_ref = __commonJS({
  "node_modules/aws-cdk-lib/aws-rds/lib/cluster-ref.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-rds/lib/cluster-engine.js
var require_cluster_engine = __commonJS({
  "node_modules/aws-cdk-lib/aws-rds/lib/cluster-engine.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DatabaseClusterEngine = exports2.AuroraPostgresEngineVersion = exports2.AuroraMysqlEngineVersion = exports2.AuroraEngineVersion = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var parameter_group_1 = require_parameter_group();
    var secretsmanager = require_aws_secretsmanager();
    var ClusterEngineBase = class {
      constructor(props) {
        this.engineType = props.engineType, this.features = props.features, this.singleUserRotationApplication = props.singleUserRotationApplication, this.multiUserRotationApplication = props.multiUserRotationApplication, this.defaultPort = props.defaultPort, this.engineVersion = props.engineVersion, this.parameterGroupFamily = this.engineVersion ? `${this.engineType}${this.engineVersion.majorVersion}` : void 0;
      }
      bindToCluster(scope, options) {
        return { parameterGroup: options.parameterGroup ?? this.defaultParameterGroup(scope), port: this.defaultPort, features: this.features };
      }
    };
    var MySqlClusterEngineBase = class extends ClusterEngineBase {
      constructor(props) {
        super({ ...props, singleUserRotationApplication: secretsmanager.SecretRotationApplication.MYSQL_ROTATION_SINGLE_USER, multiUserRotationApplication: secretsmanager.SecretRotationApplication.MYSQL_ROTATION_MULTI_USER, engineVersion: props.engineVersion ? props.engineVersion : { majorVersion: props.defaultMajorVersion } }), this.engineFamily = "MYSQL", this.supportedLogTypes = ["error", "general", "slowquery", "audit"], this.combineImportAndExportRoles = props.combineImportAndExportRoles;
      }
      bindToCluster(scope, options) {
        const config = super.bindToCluster(scope, options), parameterGroup = options.parameterGroup ?? (options.s3ImportRole || options.s3ExportRole ? new parameter_group_1.ParameterGroup(scope, "ClusterParameterGroup", { engine: this }) : config.parameterGroup);
        if (options.s3ImportRole) {
          const s3ImportParam = this.combineImportAndExportRoles ? "aws_default_s3_role" : "aurora_load_from_s3_role";
          parameterGroup?.addParameter(s3ImportParam, options.s3ImportRole.roleArn);
        }
        if (options.s3ExportRole) {
          const s3ExportParam = this.combineImportAndExportRoles ? "aws_default_s3_role" : "aurora_select_into_s3_role";
          parameterGroup?.addParameter(s3ExportParam, options.s3ExportRole.roleArn);
        }
        return { ...config, parameterGroup };
      }
    };
    var AuroraEngineVersion = class _AuroraEngineVersion {
      static of(auroraFullVersion, auroraMajorVersion) {
        return new _AuroraEngineVersion(auroraFullVersion, auroraMajorVersion);
      }
      static builtIn_5_6(minorVersion, addStandardPrefix = true) {
        return new _AuroraEngineVersion(`5.6.${addStandardPrefix ? "mysql_aurora." : ""}${minorVersion}`);
      }
      constructor(auroraFullVersion, auroraMajorVersion = "5.6") {
        this.auroraFullVersion = auroraFullVersion, this.auroraMajorVersion = auroraMajorVersion;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AuroraEngineVersion[_a] = { fqn: "aws-cdk-lib.aws_rds.AuroraEngineVersion", version: "2.80.0" }, AuroraEngineVersion.VER_10A = AuroraEngineVersion.builtIn_5_6("10a", false), AuroraEngineVersion.VER_1_17_9 = AuroraEngineVersion.builtIn_5_6("1.17.9"), AuroraEngineVersion.VER_1_19_0 = AuroraEngineVersion.builtIn_5_6("1.19.0"), AuroraEngineVersion.VER_1_19_1 = AuroraEngineVersion.builtIn_5_6("1.19.1"), AuroraEngineVersion.VER_1_19_2 = AuroraEngineVersion.builtIn_5_6("1.19.2"), AuroraEngineVersion.VER_1_19_5 = AuroraEngineVersion.builtIn_5_6("1.19.5"), AuroraEngineVersion.VER_1_19_6 = AuroraEngineVersion.builtIn_5_6("1.19.6"), AuroraEngineVersion.VER_1_20_0 = AuroraEngineVersion.builtIn_5_6("1.20.0"), AuroraEngineVersion.VER_1_20_1 = AuroraEngineVersion.builtIn_5_6("1.20.1"), AuroraEngineVersion.VER_1_21_0 = AuroraEngineVersion.builtIn_5_6("1.21.0"), AuroraEngineVersion.VER_1_22_0 = AuroraEngineVersion.builtIn_5_6("1.22.0"), AuroraEngineVersion.VER_1_22_1 = AuroraEngineVersion.builtIn_5_6("1.22.1"), AuroraEngineVersion.VER_1_22_1_3 = AuroraEngineVersion.builtIn_5_6("1.22.1.3"), AuroraEngineVersion.VER_1_22_2 = AuroraEngineVersion.builtIn_5_6("1.22.2"), AuroraEngineVersion.VER_1_22_3 = AuroraEngineVersion.builtIn_5_6("1.22.3"), AuroraEngineVersion.VER_1_22_4 = AuroraEngineVersion.builtIn_5_6("1.22.4"), AuroraEngineVersion.VER_1_22_5 = AuroraEngineVersion.builtIn_5_6("1.22.5"), AuroraEngineVersion.VER_1_23_0 = AuroraEngineVersion.builtIn_5_6("1.23.0"), AuroraEngineVersion.VER_1_23_1 = AuroraEngineVersion.builtIn_5_6("1.23.1"), AuroraEngineVersion.VER_1_23_2 = AuroraEngineVersion.builtIn_5_6("1.23.2"), AuroraEngineVersion.VER_1_23_3 = AuroraEngineVersion.builtIn_5_6("1.23.3"), AuroraEngineVersion.VER_1_23_4 = AuroraEngineVersion.builtIn_5_6("1.23.4"), exports2.AuroraEngineVersion = AuroraEngineVersion;
    var AuroraClusterEngine = class extends MySqlClusterEngineBase {
      constructor(version) {
        super({ engineType: "aurora", engineVersion: version ? { fullVersion: version.auroraFullVersion, majorVersion: version.auroraMajorVersion } : void 0, defaultMajorVersion: "5.6" });
      }
      defaultParameterGroup(_scope) {
      }
    };
    var AuroraMysqlEngineVersion = class _AuroraMysqlEngineVersion {
      static of(auroraMysqlFullVersion, auroraMysqlMajorVersion) {
        return new _AuroraMysqlEngineVersion(auroraMysqlFullVersion, auroraMysqlMajorVersion);
      }
      static builtIn_5_7(minorVersion, addStandardPrefix = true) {
        return new _AuroraMysqlEngineVersion(`5.7.${addStandardPrefix ? "mysql_aurora." : ""}${minorVersion}`);
      }
      static builtIn_8_0(minorVersion) {
        return new _AuroraMysqlEngineVersion(`8.0.mysql_aurora.${minorVersion}`, "8.0", true);
      }
      constructor(auroraMysqlFullVersion, auroraMysqlMajorVersion = "5.7", combineImportAndExportRoles) {
        this.auroraMysqlFullVersion = auroraMysqlFullVersion, this.auroraMysqlMajorVersion = auroraMysqlMajorVersion, this._combineImportAndExportRoles = combineImportAndExportRoles;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, AuroraMysqlEngineVersion[_b] = { fqn: "aws-cdk-lib.aws_rds.AuroraMysqlEngineVersion", version: "2.80.0" }, AuroraMysqlEngineVersion.VER_5_7_12 = AuroraMysqlEngineVersion.builtIn_5_7("12", false), AuroraMysqlEngineVersion.VER_2_03_2 = AuroraMysqlEngineVersion.builtIn_5_7("2.03.2"), AuroraMysqlEngineVersion.VER_2_03_3 = AuroraMysqlEngineVersion.builtIn_5_7("2.03.3"), AuroraMysqlEngineVersion.VER_2_03_4 = AuroraMysqlEngineVersion.builtIn_5_7("2.03.4"), AuroraMysqlEngineVersion.VER_2_04_0 = AuroraMysqlEngineVersion.builtIn_5_7("2.04.0"), AuroraMysqlEngineVersion.VER_2_04_1 = AuroraMysqlEngineVersion.builtIn_5_7("2.04.1"), AuroraMysqlEngineVersion.VER_2_04_2 = AuroraMysqlEngineVersion.builtIn_5_7("2.04.2"), AuroraMysqlEngineVersion.VER_2_04_3 = AuroraMysqlEngineVersion.builtIn_5_7("2.04.3"), AuroraMysqlEngineVersion.VER_2_04_4 = AuroraMysqlEngineVersion.builtIn_5_7("2.04.4"), AuroraMysqlEngineVersion.VER_2_04_5 = AuroraMysqlEngineVersion.builtIn_5_7("2.04.5"), AuroraMysqlEngineVersion.VER_2_04_6 = AuroraMysqlEngineVersion.builtIn_5_7("2.04.6"), AuroraMysqlEngineVersion.VER_2_04_7 = AuroraMysqlEngineVersion.builtIn_5_7("2.04.7"), AuroraMysqlEngineVersion.VER_2_04_8 = AuroraMysqlEngineVersion.builtIn_5_7("2.04.8"), AuroraMysqlEngineVersion.VER_2_05_0 = AuroraMysqlEngineVersion.builtIn_5_7("2.05.0"), AuroraMysqlEngineVersion.VER_2_06_0 = AuroraMysqlEngineVersion.builtIn_5_7("2.06.0"), AuroraMysqlEngineVersion.VER_2_07_0 = AuroraMysqlEngineVersion.builtIn_5_7("2.07.0"), AuroraMysqlEngineVersion.VER_2_07_1 = AuroraMysqlEngineVersion.builtIn_5_7("2.07.1"), AuroraMysqlEngineVersion.VER_2_07_2 = AuroraMysqlEngineVersion.builtIn_5_7("2.07.2"), AuroraMysqlEngineVersion.VER_2_07_3 = AuroraMysqlEngineVersion.builtIn_5_7("2.07.3"), AuroraMysqlEngineVersion.VER_2_07_4 = AuroraMysqlEngineVersion.builtIn_5_7("2.07.4"), AuroraMysqlEngineVersion.VER_2_07_5 = AuroraMysqlEngineVersion.builtIn_5_7("2.07.5"), AuroraMysqlEngineVersion.VER_2_07_6 = AuroraMysqlEngineVersion.builtIn_5_7("2.07.6"), AuroraMysqlEngineVersion.VER_2_07_7 = AuroraMysqlEngineVersion.builtIn_5_7("2.07.7"), AuroraMysqlEngineVersion.VER_2_07_8 = AuroraMysqlEngineVersion.builtIn_5_7("2.07.8"), AuroraMysqlEngineVersion.VER_2_08_0 = AuroraMysqlEngineVersion.builtIn_5_7("2.08.0"), AuroraMysqlEngineVersion.VER_2_08_1 = AuroraMysqlEngineVersion.builtIn_5_7("2.08.1"), AuroraMysqlEngineVersion.VER_2_08_2 = AuroraMysqlEngineVersion.builtIn_5_7("2.08.2"), AuroraMysqlEngineVersion.VER_2_08_3 = AuroraMysqlEngineVersion.builtIn_5_7("2.08.3"), AuroraMysqlEngineVersion.VER_2_08_4 = AuroraMysqlEngineVersion.builtIn_5_7("2.08.4"), AuroraMysqlEngineVersion.VER_2_09_0 = AuroraMysqlEngineVersion.builtIn_5_7("2.09.0"), AuroraMysqlEngineVersion.VER_2_09_1 = AuroraMysqlEngineVersion.builtIn_5_7("2.09.1"), AuroraMysqlEngineVersion.VER_2_09_2 = AuroraMysqlEngineVersion.builtIn_5_7("2.09.2"), AuroraMysqlEngineVersion.VER_2_09_3 = AuroraMysqlEngineVersion.builtIn_5_7("2.09.3"), AuroraMysqlEngineVersion.VER_2_10_0 = AuroraMysqlEngineVersion.builtIn_5_7("2.10.0"), AuroraMysqlEngineVersion.VER_2_10_1 = AuroraMysqlEngineVersion.builtIn_5_7("2.10.1"), AuroraMysqlEngineVersion.VER_2_10_2 = AuroraMysqlEngineVersion.builtIn_5_7("2.10.2"), AuroraMysqlEngineVersion.VER_2_10_3 = AuroraMysqlEngineVersion.builtIn_5_7("2.10.3"), AuroraMysqlEngineVersion.VER_2_11_0 = AuroraMysqlEngineVersion.builtIn_5_7("2.11.0"), AuroraMysqlEngineVersion.VER_2_11_1 = AuroraMysqlEngineVersion.builtIn_5_7("2.11.1"), AuroraMysqlEngineVersion.VER_2_11_2 = AuroraMysqlEngineVersion.builtIn_5_7("2.11.2"), AuroraMysqlEngineVersion.VER_3_01_0 = AuroraMysqlEngineVersion.builtIn_8_0("3.01.0"), AuroraMysqlEngineVersion.VER_3_01_1 = AuroraMysqlEngineVersion.builtIn_8_0("3.01.1"), AuroraMysqlEngineVersion.VER_3_02_0 = AuroraMysqlEngineVersion.builtIn_8_0("3.02.0"), AuroraMysqlEngineVersion.VER_3_02_1 = AuroraMysqlEngineVersion.builtIn_8_0("3.02.1"), AuroraMysqlEngineVersion.VER_3_02_2 = AuroraMysqlEngineVersion.builtIn_8_0("3.02.2"), AuroraMysqlEngineVersion.VER_3_03_0 = AuroraMysqlEngineVersion.builtIn_8_0("3.03.0"), exports2.AuroraMysqlEngineVersion = AuroraMysqlEngineVersion;
    var AuroraMysqlClusterEngine = class extends MySqlClusterEngineBase {
      constructor(version) {
        super({ engineType: "aurora-mysql", engineVersion: version ? { fullVersion: version.auroraMysqlFullVersion, majorVersion: version.auroraMysqlMajorVersion } : void 0, defaultMajorVersion: "5.7", combineImportAndExportRoles: version?._combineImportAndExportRoles });
      }
      defaultParameterGroup(scope) {
        return parameter_group_1.ParameterGroup.fromParameterGroupName(scope, "AuroraMySqlDatabaseClusterEngineDefaultParameterGroup", `default.${this.parameterGroupFamily}`);
      }
    };
    var AuroraPostgresEngineVersion = class _AuroraPostgresEngineVersion {
      static of(auroraPostgresFullVersion, auroraPostgresMajorVersion, auroraPostgresFeatures) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_AuroraPostgresEngineFeatures(auroraPostgresFeatures);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.of), error;
        }
        return new _AuroraPostgresEngineVersion(auroraPostgresFullVersion, auroraPostgresMajorVersion, auroraPostgresFeatures);
      }
      constructor(auroraPostgresFullVersion, auroraPostgresMajorVersion, auroraPostgresFeatures) {
        this.auroraPostgresFullVersion = auroraPostgresFullVersion, this.auroraPostgresMajorVersion = auroraPostgresMajorVersion, this._features = { s3Import: auroraPostgresFeatures?.s3Import ? "s3Import" : void 0, s3Export: auroraPostgresFeatures?.s3Export ? "s3Export" : void 0 };
      }
    };
    _c = JSII_RTTI_SYMBOL_1, AuroraPostgresEngineVersion[_c] = { fqn: "aws-cdk-lib.aws_rds.AuroraPostgresEngineVersion", version: "2.80.0" }, AuroraPostgresEngineVersion.VER_9_6_8 = AuroraPostgresEngineVersion.of("9.6.8", "9.6"), AuroraPostgresEngineVersion.VER_9_6_9 = AuroraPostgresEngineVersion.of("9.6.9", "9.6"), AuroraPostgresEngineVersion.VER_9_6_11 = AuroraPostgresEngineVersion.of("9.6.11", "9.6"), AuroraPostgresEngineVersion.VER_9_6_12 = AuroraPostgresEngineVersion.of("9.6.12", "9.6"), AuroraPostgresEngineVersion.VER_9_6_16 = AuroraPostgresEngineVersion.of("9.6.16", "9.6"), AuroraPostgresEngineVersion.VER_9_6_17 = AuroraPostgresEngineVersion.of("9.6.17", "9.6"), AuroraPostgresEngineVersion.VER_9_6_18 = AuroraPostgresEngineVersion.of("9.6.18", "9.6"), AuroraPostgresEngineVersion.VER_9_6_19 = AuroraPostgresEngineVersion.of("9.6.19", "9.6"), AuroraPostgresEngineVersion.VER_10_4 = AuroraPostgresEngineVersion.of("10.4", "10"), AuroraPostgresEngineVersion.VER_10_5 = AuroraPostgresEngineVersion.of("10.5", "10"), AuroraPostgresEngineVersion.VER_10_6 = AuroraPostgresEngineVersion.of("10.6", "10"), AuroraPostgresEngineVersion.VER_10_7 = AuroraPostgresEngineVersion.of("10.7", "10", { s3Import: true }), AuroraPostgresEngineVersion.VER_10_11 = AuroraPostgresEngineVersion.of("10.11", "10", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_10_12 = AuroraPostgresEngineVersion.of("10.12", "10", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_10_13 = AuroraPostgresEngineVersion.of("10.13", "10", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_10_14 = AuroraPostgresEngineVersion.of("10.14", "10", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_10_16 = AuroraPostgresEngineVersion.of("10.16", "10", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_10_17 = AuroraPostgresEngineVersion.of("10.17", "10", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_10_18 = AuroraPostgresEngineVersion.of("10.18", "10", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_10_19 = AuroraPostgresEngineVersion.of("10.19", "10", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_10_20 = AuroraPostgresEngineVersion.of("10.20", "10", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_10_21 = AuroraPostgresEngineVersion.of("10.21", "10", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_11_4 = AuroraPostgresEngineVersion.of("11.4", "11", { s3Import: true }), AuroraPostgresEngineVersion.VER_11_6 = AuroraPostgresEngineVersion.of("11.6", "11", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_11_7 = AuroraPostgresEngineVersion.of("11.7", "11", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_11_8 = AuroraPostgresEngineVersion.of("11.8", "11", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_11_9 = AuroraPostgresEngineVersion.of("11.9", "11", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_11_11 = AuroraPostgresEngineVersion.of("11.11", "11", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_11_12 = AuroraPostgresEngineVersion.of("11.12", "11", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_11_13 = AuroraPostgresEngineVersion.of("11.13", "11", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_11_14 = AuroraPostgresEngineVersion.of("11.14", "11", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_11_15 = AuroraPostgresEngineVersion.of("11.15", "11", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_11_16 = AuroraPostgresEngineVersion.of("11.16", "11", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_11_17 = AuroraPostgresEngineVersion.of("11.17", "11", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_11_18 = AuroraPostgresEngineVersion.of("11.18", "11", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_11_19 = AuroraPostgresEngineVersion.of("11.19", "11", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_12_4 = AuroraPostgresEngineVersion.of("12.4", "12", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_12_6 = AuroraPostgresEngineVersion.of("12.6", "12", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_12_7 = AuroraPostgresEngineVersion.of("12.7", "12", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_12_8 = AuroraPostgresEngineVersion.of("12.8", "12", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_12_9 = AuroraPostgresEngineVersion.of("12.9", "12", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_12_10 = AuroraPostgresEngineVersion.of("12.10", "12", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_12_11 = AuroraPostgresEngineVersion.of("12.11", "12", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_12_12 = AuroraPostgresEngineVersion.of("12.12", "12", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_12_13 = AuroraPostgresEngineVersion.of("12.13", "12", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_12_14 = AuroraPostgresEngineVersion.of("12.14", "12", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_13_3 = AuroraPostgresEngineVersion.of("13.3", "13", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_13_4 = AuroraPostgresEngineVersion.of("13.4", "13", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_13_5 = AuroraPostgresEngineVersion.of("13.5", "13", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_13_6 = AuroraPostgresEngineVersion.of("13.6", "13", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_13_7 = AuroraPostgresEngineVersion.of("13.7", "13", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_13_8 = AuroraPostgresEngineVersion.of("13.8", "13", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_13_9 = AuroraPostgresEngineVersion.of("13.9", "13", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_13_10 = AuroraPostgresEngineVersion.of("13.10", "13", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_14_3 = AuroraPostgresEngineVersion.of("14.3", "14", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_14_4 = AuroraPostgresEngineVersion.of("14.4", "14", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_14_5 = AuroraPostgresEngineVersion.of("14.5", "14", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_14_6 = AuroraPostgresEngineVersion.of("14.6", "14", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_14_7 = AuroraPostgresEngineVersion.of("14.7", "14", { s3Import: true, s3Export: true }), AuroraPostgresEngineVersion.VER_15_2 = AuroraPostgresEngineVersion.of("15.2", "15", { s3Import: true, s3Export: true }), exports2.AuroraPostgresEngineVersion = AuroraPostgresEngineVersion;
    var AuroraPostgresClusterEngine = class _AuroraPostgresClusterEngine extends ClusterEngineBase {
      constructor(version) {
        super({ engineType: "aurora-postgresql", singleUserRotationApplication: secretsmanager.SecretRotationApplication.POSTGRES_ROTATION_SINGLE_USER, multiUserRotationApplication: secretsmanager.SecretRotationApplication.POSTGRES_ROTATION_MULTI_USER, defaultPort: 5432, engineVersion: version ? { fullVersion: version.auroraPostgresFullVersion, majorVersion: version.auroraPostgresMajorVersion } : void 0, features: version ? { s3Import: version._features.s3Import ? _AuroraPostgresClusterEngine.S3_IMPORT_FEATURE_NAME : void 0, s3Export: version._features.s3Export ? _AuroraPostgresClusterEngine.S3_EXPORT_FEATURE_NAME : void 0 } : { s3Import: _AuroraPostgresClusterEngine.S3_IMPORT_FEATURE_NAME, s3Export: _AuroraPostgresClusterEngine.S3_EXPORT_FEATURE_NAME } }), this.engineFamily = "POSTGRESQL", this.defaultUsername = "postgres", this.supportedLogTypes = ["postgresql"];
      }
      bindToCluster(scope, options) {
        const config = super.bindToCluster(scope, options);
        if (this.engineVersion?.fullVersion) {
          if (options.s3ImportRole && !config.features?.s3Import)
            throw new Error(`s3Import is not supported for Postgres version: ${this.engineVersion.fullVersion}. Use a version that supports the s3Import feature.`);
          if (options.s3ExportRole && !config.features?.s3Export)
            throw new Error(`s3Export is not supported for Postgres version: ${this.engineVersion.fullVersion}. Use a version that supports the s3Export feature.`);
        }
        return config;
      }
      defaultParameterGroup(scope) {
        if (!this.parameterGroupFamily)
          throw new Error("Could not create a new ParameterGroup for an unversioned aurora-postgresql cluster engine. Please either use a versioned engine, or pass an explicit ParameterGroup when creating the cluster");
        return parameter_group_1.ParameterGroup.fromParameterGroupName(scope, "AuroraPostgreSqlDatabaseClusterEngineDefaultParameterGroup", `default.${this.parameterGroupFamily}`);
      }
    };
    AuroraPostgresClusterEngine.S3_IMPORT_FEATURE_NAME = "s3Import", AuroraPostgresClusterEngine.S3_EXPORT_FEATURE_NAME = "s3Export";
    var DatabaseClusterEngine = class {
      static aurora(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_AuroraClusterEngineProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.aurora), error;
        }
        return new AuroraClusterEngine(props.version);
      }
      static auroraMysql(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_AuroraMysqlClusterEngineProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.auroraMysql), error;
        }
        return new AuroraMysqlClusterEngine(props.version);
      }
      static auroraPostgres(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_AuroraPostgresClusterEngineProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.auroraPostgres), error;
        }
        return new AuroraPostgresClusterEngine(props.version);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, DatabaseClusterEngine[_d] = { fqn: "aws-cdk-lib.aws_rds.DatabaseClusterEngine", version: "2.80.0" }, DatabaseClusterEngine.AURORA = new AuroraClusterEngine(), DatabaseClusterEngine.AURORA_MYSQL = new AuroraMysqlClusterEngine(), DatabaseClusterEngine.AURORA_POSTGRESQL = new AuroraPostgresClusterEngine(), exports2.DatabaseClusterEngine = DatabaseClusterEngine;
  }
});

// node_modules/aws-cdk-lib/aws-rds/lib/option-group.js
var require_option_group = __commonJS({
  "node_modules/aws-cdk-lib/aws-rds/lib/option-group.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.OptionGroup = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var rds_generated_1 = require_rds_generated();
    var ec2 = require_aws_ec2();
    var core_1 = require_core2();
    var OptionGroup = class _OptionGroup extends core_1.Resource {
      static fromOptionGroupName(scope, id, optionGroupName) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.optionGroupName = optionGroupName;
          }
          addConfiguration(_) {
            return false;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id), this.optionConnections = {}, this.configurations = [];
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_OptionGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _OptionGroup), error;
        }
        const majorEngineVersion = props.engine.engineVersion?.majorVersion;
        if (!majorEngineVersion)
          throw new Error("OptionGroup cannot be used with an engine that doesn't specify a version");
        props.configurations.forEach((config) => this.addConfiguration(config));
        const optionGroup = new rds_generated_1.CfnOptionGroup(this, "Resource", { engineName: props.engine.engineType, majorEngineVersion, optionGroupDescription: props.description || `Option group for ${props.engine.engineType} ${majorEngineVersion}`, optionConfigurations: core_1.Lazy.any({ produce: () => this.renderConfigurations(this.configurations) }) });
        this.optionGroupName = optionGroup.ref;
      }
      addConfiguration(configuration) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_OptionConfiguration(configuration);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addConfiguration), error;
        }
        if (this.configurations.push(configuration), configuration.port) {
          if (!configuration.vpc)
            throw new Error("`port` and `vpc` must be specified together.");
          const securityGroups = configuration.securityGroups && configuration.securityGroups.length > 0 ? configuration.securityGroups : [new ec2.SecurityGroup(this, `SecurityGroup${configuration.name}`, { description: `Security group for ${configuration.name} option`, vpc: configuration.vpc })];
          this.optionConnections[configuration.name] = new ec2.Connections({ securityGroups, defaultPort: ec2.Port.tcp(configuration.port) });
        }
        return true;
      }
      renderConfigurations(configurations) {
        const configs = [];
        for (const config of configurations) {
          const securityGroups = config.vpc ? this.optionConnections[config.name].securityGroups.map((sg) => sg.securityGroupId) : void 0;
          configs.push({ optionName: config.name, optionSettings: config.settings && Object.entries(config.settings).map(([name, value]) => ({ name, value })), optionVersion: config.version, port: config.port, vpcSecurityGroupMemberships: securityGroups });
        }
        return configs;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, OptionGroup[_a] = { fqn: "aws-cdk-lib.aws_rds.OptionGroup", version: "2.80.0" }, exports2.OptionGroup = OptionGroup;
  }
});

// node_modules/aws-cdk-lib/aws-rds/lib/instance-engine.js
var require_instance_engine = __commonJS({
  "node_modules/aws-cdk-lib/aws-rds/lib/instance-engine.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DatabaseInstanceEngine = exports2.SqlServerEngineVersion = exports2.OracleEngineVersion = exports2.OracleLegacyEngineVersion = exports2.PostgresEngineVersion = exports2.MysqlEngineVersion = exports2.MariaDbEngineVersion = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var option_group_1 = require_option_group();
    var secretsmanager = require_aws_secretsmanager();
    var InstanceEngineBase = class {
      constructor(props) {
        this.engineType = props.engineType, this.features = props.features, this.singleUserRotationApplication = props.singleUserRotationApplication, this.multiUserRotationApplication = props.multiUserRotationApplication, this.engineVersion = props.version, this.parameterGroupFamily = props.parameterGroupFamily ?? (this.engineVersion ? `${this.engineType}${this.engineVersion.majorVersion}` : void 0), this.engineFamily = props.engineFamily;
      }
      bindToInstance(_scope, options) {
        if (options.timezone && !this.supportsTimezone)
          throw new Error(`timezone property can not be configured for ${this.engineType}`);
        return { features: this.features, optionGroup: options.optionGroup };
      }
      get supportsTimezone() {
        return false;
      }
    };
    var MariaDbEngineVersion = class _MariaDbEngineVersion {
      static of(mariaDbFullVersion, mariaDbMajorVersion) {
        return new _MariaDbEngineVersion(mariaDbFullVersion, mariaDbMajorVersion);
      }
      constructor(mariaDbFullVersion, mariaDbMajorVersion) {
        this.mariaDbFullVersion = mariaDbFullVersion, this.mariaDbMajorVersion = mariaDbMajorVersion;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, MariaDbEngineVersion[_a] = { fqn: "aws-cdk-lib.aws_rds.MariaDbEngineVersion", version: "2.80.0" }, MariaDbEngineVersion.VER_10_0 = MariaDbEngineVersion.of("10.0", "10.0"), MariaDbEngineVersion.VER_10_0_17 = MariaDbEngineVersion.of("10.0.17", "10.0"), MariaDbEngineVersion.VER_10_0_24 = MariaDbEngineVersion.of("10.0.24", "10.0"), MariaDbEngineVersion.VER_10_0_28 = MariaDbEngineVersion.of("10.0.28", "10.0"), MariaDbEngineVersion.VER_10_0_31 = MariaDbEngineVersion.of("10.0.31", "10.0"), MariaDbEngineVersion.VER_10_0_32 = MariaDbEngineVersion.of("10.0.32", "10.0"), MariaDbEngineVersion.VER_10_0_34 = MariaDbEngineVersion.of("10.0.34", "10.0"), MariaDbEngineVersion.VER_10_0_35 = MariaDbEngineVersion.of("10.0.35", "10.0"), MariaDbEngineVersion.VER_10_1 = MariaDbEngineVersion.of("10.1", "10.1"), MariaDbEngineVersion.VER_10_1_14 = MariaDbEngineVersion.of("10.1.14", "10.1"), MariaDbEngineVersion.VER_10_1_19 = MariaDbEngineVersion.of("10.1.19", "10.1"), MariaDbEngineVersion.VER_10_1_23 = MariaDbEngineVersion.of("10.1.23", "10.1"), MariaDbEngineVersion.VER_10_1_26 = MariaDbEngineVersion.of("10.1.26", "10.1"), MariaDbEngineVersion.VER_10_1_31 = MariaDbEngineVersion.of("10.1.31", "10.1"), MariaDbEngineVersion.VER_10_1_34 = MariaDbEngineVersion.of("10.1.34", "10.1"), MariaDbEngineVersion.VER_10_2 = MariaDbEngineVersion.of("10.2", "10.2"), MariaDbEngineVersion.VER_10_2_11 = MariaDbEngineVersion.of("10.2.11", "10.2"), MariaDbEngineVersion.VER_10_2_12 = MariaDbEngineVersion.of("10.2.12", "10.2"), MariaDbEngineVersion.VER_10_2_15 = MariaDbEngineVersion.of("10.2.15", "10.2"), MariaDbEngineVersion.VER_10_2_21 = MariaDbEngineVersion.of("10.2.21", "10.2"), MariaDbEngineVersion.VER_10_2_32 = MariaDbEngineVersion.of("10.2.32", "10.2"), MariaDbEngineVersion.VER_10_2_37 = MariaDbEngineVersion.of("10.2.37", "10.2"), MariaDbEngineVersion.VER_10_2_39 = MariaDbEngineVersion.of("10.2.39", "10.2"), MariaDbEngineVersion.VER_10_2_40 = MariaDbEngineVersion.of("10.2.40", "10.2"), MariaDbEngineVersion.VER_10_2_41 = MariaDbEngineVersion.of("10.2.41", "10.2"), MariaDbEngineVersion.VER_10_3 = MariaDbEngineVersion.of("10.3", "10.3"), MariaDbEngineVersion.VER_10_3_8 = MariaDbEngineVersion.of("10.3.8", "10.3"), MariaDbEngineVersion.VER_10_3_13 = MariaDbEngineVersion.of("10.3.13", "10.3"), MariaDbEngineVersion.VER_10_3_20 = MariaDbEngineVersion.of("10.3.20", "10.3"), MariaDbEngineVersion.VER_10_3_23 = MariaDbEngineVersion.of("10.3.23", "10.3"), MariaDbEngineVersion.VER_10_3_28 = MariaDbEngineVersion.of("10.3.28", "10.3"), MariaDbEngineVersion.VER_10_3_31 = MariaDbEngineVersion.of("10.3.31", "10.3"), MariaDbEngineVersion.VER_10_3_32 = MariaDbEngineVersion.of("10.3.32", "10.3"), MariaDbEngineVersion.VER_10_3_34 = MariaDbEngineVersion.of("10.3.34", "10.3"), MariaDbEngineVersion.VER_10_3_35 = MariaDbEngineVersion.of("10.3.35", "10.3"), MariaDbEngineVersion.VER_10_3_36 = MariaDbEngineVersion.of("10.3.36", "10.3"), MariaDbEngineVersion.VER_10_3_37 = MariaDbEngineVersion.of("10.3.37", "10.3"), MariaDbEngineVersion.VER_10_3_38 = MariaDbEngineVersion.of("10.3.38", "10.3"), MariaDbEngineVersion.VER_10_4 = MariaDbEngineVersion.of("10.4", "10.4"), MariaDbEngineVersion.VER_10_4_8 = MariaDbEngineVersion.of("10.4.8", "10.4"), MariaDbEngineVersion.VER_10_4_13 = MariaDbEngineVersion.of("10.4.13", "10.4"), MariaDbEngineVersion.VER_10_4_18 = MariaDbEngineVersion.of("10.4.18", "10.4"), MariaDbEngineVersion.VER_10_4_21 = MariaDbEngineVersion.of("10.4.21", "10.4"), MariaDbEngineVersion.VER_10_4_22 = MariaDbEngineVersion.of("10.4.22", "10.4"), MariaDbEngineVersion.VER_10_4_24 = MariaDbEngineVersion.of("10.4.24", "10.4"), MariaDbEngineVersion.VER_10_4_25 = MariaDbEngineVersion.of("10.4.25", "10.4"), MariaDbEngineVersion.VER_10_4_26 = MariaDbEngineVersion.of("10.4.26", "10.4"), MariaDbEngineVersion.VER_10_4_27 = MariaDbEngineVersion.of("10.4.27", "10.4"), MariaDbEngineVersion.VER_10_4_28 = MariaDbEngineVersion.of("10.4.28", "10.4"), MariaDbEngineVersion.VER_10_5 = MariaDbEngineVersion.of("10.5", "10.5"), MariaDbEngineVersion.VER_10_5_8 = MariaDbEngineVersion.of("10.5.8", "10.5"), MariaDbEngineVersion.VER_10_5_9 = MariaDbEngineVersion.of("10.5.9", "10.5"), MariaDbEngineVersion.VER_10_5_12 = MariaDbEngineVersion.of("10.5.12", "10.5"), MariaDbEngineVersion.VER_10_5_13 = MariaDbEngineVersion.of("10.5.13", "10.5"), MariaDbEngineVersion.VER_10_5_15 = MariaDbEngineVersion.of("10.5.15", "10.5"), MariaDbEngineVersion.VER_10_5_16 = MariaDbEngineVersion.of("10.5.16", "10.5"), MariaDbEngineVersion.VER_10_5_17 = MariaDbEngineVersion.of("10.5.17", "10.5"), MariaDbEngineVersion.VER_10_5_18 = MariaDbEngineVersion.of("10.5.18", "10.5"), MariaDbEngineVersion.VER_10_5_19 = MariaDbEngineVersion.of("10.5.19", "10.5"), MariaDbEngineVersion.VER_10_6 = MariaDbEngineVersion.of("10.6", "10.6"), MariaDbEngineVersion.VER_10_6_5 = MariaDbEngineVersion.of("10.6.5", "10.6"), MariaDbEngineVersion.VER_10_6_7 = MariaDbEngineVersion.of("10.6.7", "10.6"), MariaDbEngineVersion.VER_10_6_8 = MariaDbEngineVersion.of("10.6.8", "10.6"), MariaDbEngineVersion.VER_10_6_10 = MariaDbEngineVersion.of("10.6.10", "10.6"), MariaDbEngineVersion.VER_10_6_11 = MariaDbEngineVersion.of("10.6.11", "10.6"), MariaDbEngineVersion.VER_10_6_12 = MariaDbEngineVersion.of("10.6.12", "10.6"), exports2.MariaDbEngineVersion = MariaDbEngineVersion;
    var MariaDbInstanceEngine = class extends InstanceEngineBase {
      constructor(version) {
        super({ engineType: "mariadb", singleUserRotationApplication: secretsmanager.SecretRotationApplication.MARIADB_ROTATION_SINGLE_USER, multiUserRotationApplication: secretsmanager.SecretRotationApplication.MARIADB_ROTATION_MULTI_USER, version: version ? { fullVersion: version.mariaDbFullVersion, majorVersion: version.mariaDbMajorVersion } : void 0 }), this.supportsReadReplicaBackups = true;
      }
      bindToInstance(scope, options) {
        if (options.domain)
          throw new Error(`domain property cannot be configured for ${this.engineType}`);
        return super.bindToInstance(scope, options);
      }
    };
    var MysqlEngineVersion = class _MysqlEngineVersion {
      static of(mysqlFullVersion, mysqlMajorVersion) {
        return new _MysqlEngineVersion(mysqlFullVersion, mysqlMajorVersion);
      }
      constructor(mysqlFullVersion, mysqlMajorVersion) {
        this.mysqlFullVersion = mysqlFullVersion, this.mysqlMajorVersion = mysqlMajorVersion;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, MysqlEngineVersion[_b] = { fqn: "aws-cdk-lib.aws_rds.MysqlEngineVersion", version: "2.80.0" }, MysqlEngineVersion.VER_5_5 = MysqlEngineVersion.of("5.5", "5.5"), MysqlEngineVersion.VER_5_5_46 = MysqlEngineVersion.of("5.5.46", "5.5"), MysqlEngineVersion.VER_5_5_53 = MysqlEngineVersion.of("5.5.53", "5.5"), MysqlEngineVersion.VER_5_5_57 = MysqlEngineVersion.of("5.5.57", "5.5"), MysqlEngineVersion.VER_5_5_59 = MysqlEngineVersion.of("5.5.59", "5.5"), MysqlEngineVersion.VER_5_5_61 = MysqlEngineVersion.of("5.5.61", "5.5"), MysqlEngineVersion.VER_5_6 = MysqlEngineVersion.of("5.6", "5.6"), MysqlEngineVersion.VER_5_6_34 = MysqlEngineVersion.of("5.6.34", "5.6"), MysqlEngineVersion.VER_5_6_35 = MysqlEngineVersion.of("5.6.35", "5.6"), MysqlEngineVersion.VER_5_6_37 = MysqlEngineVersion.of("5.6.37", "5.6"), MysqlEngineVersion.VER_5_6_39 = MysqlEngineVersion.of("5.6.39", "5.6"), MysqlEngineVersion.VER_5_6_40 = MysqlEngineVersion.of("5.6.40", "5.6"), MysqlEngineVersion.VER_5_6_41 = MysqlEngineVersion.of("5.6.41", "5.6"), MysqlEngineVersion.VER_5_6_43 = MysqlEngineVersion.of("5.6.43", "5.6"), MysqlEngineVersion.VER_5_6_44 = MysqlEngineVersion.of("5.6.44", "5.6"), MysqlEngineVersion.VER_5_6_46 = MysqlEngineVersion.of("5.6.46", "5.6"), MysqlEngineVersion.VER_5_6_48 = MysqlEngineVersion.of("5.6.48", "5.6"), MysqlEngineVersion.VER_5_6_49 = MysqlEngineVersion.of("5.6.49", "5.6"), MysqlEngineVersion.VER_5_6_51 = MysqlEngineVersion.of("5.6.51", "5.6"), MysqlEngineVersion.VER_5_7 = MysqlEngineVersion.of("5.7", "5.7"), MysqlEngineVersion.VER_5_7_16 = MysqlEngineVersion.of("5.7.16", "5.7"), MysqlEngineVersion.VER_5_7_17 = MysqlEngineVersion.of("5.7.17", "5.7"), MysqlEngineVersion.VER_5_7_19 = MysqlEngineVersion.of("5.7.19", "5.7"), MysqlEngineVersion.VER_5_7_21 = MysqlEngineVersion.of("5.7.21", "5.7"), MysqlEngineVersion.VER_5_7_22 = MysqlEngineVersion.of("5.7.22", "5.7"), MysqlEngineVersion.VER_5_7_23 = MysqlEngineVersion.of("5.7.23", "5.7"), MysqlEngineVersion.VER_5_7_24 = MysqlEngineVersion.of("5.7.24", "5.7"), MysqlEngineVersion.VER_5_7_25 = MysqlEngineVersion.of("5.7.25", "5.7"), MysqlEngineVersion.VER_5_7_26 = MysqlEngineVersion.of("5.7.26", "5.7"), MysqlEngineVersion.VER_5_7_28 = MysqlEngineVersion.of("5.7.28", "5.7"), MysqlEngineVersion.VER_5_7_30 = MysqlEngineVersion.of("5.7.30", "5.7"), MysqlEngineVersion.VER_5_7_31 = MysqlEngineVersion.of("5.7.31", "5.7"), MysqlEngineVersion.VER_5_7_33 = MysqlEngineVersion.of("5.7.33", "5.7"), MysqlEngineVersion.VER_5_7_34 = MysqlEngineVersion.of("5.7.34", "5.7"), MysqlEngineVersion.VER_5_7_35 = MysqlEngineVersion.of("5.7.35", "5.7"), MysqlEngineVersion.VER_5_7_36 = MysqlEngineVersion.of("5.7.36", "5.7"), MysqlEngineVersion.VER_5_7_37 = MysqlEngineVersion.of("5.7.37", "5.7"), MysqlEngineVersion.VER_5_7_38 = MysqlEngineVersion.of("5.7.38", "5.7"), MysqlEngineVersion.VER_5_7_39 = MysqlEngineVersion.of("5.7.39", "5.7"), MysqlEngineVersion.VER_5_7_40 = MysqlEngineVersion.of("5.7.40", "5.7"), MysqlEngineVersion.VER_5_7_41 = MysqlEngineVersion.of("5.7.41", "5.7"), MysqlEngineVersion.VER_8_0 = MysqlEngineVersion.of("8.0", "8.0"), MysqlEngineVersion.VER_8_0_11 = MysqlEngineVersion.of("8.0.11", "8.0"), MysqlEngineVersion.VER_8_0_13 = MysqlEngineVersion.of("8.0.13", "8.0"), MysqlEngineVersion.VER_8_0_15 = MysqlEngineVersion.of("8.0.15", "8.0"), MysqlEngineVersion.VER_8_0_16 = MysqlEngineVersion.of("8.0.16", "8.0"), MysqlEngineVersion.VER_8_0_17 = MysqlEngineVersion.of("8.0.17", "8.0"), MysqlEngineVersion.VER_8_0_19 = MysqlEngineVersion.of("8.0.19", "8.0"), MysqlEngineVersion.VER_8_0_20 = MysqlEngineVersion.of("8.0.20", "8.0"), MysqlEngineVersion.VER_8_0_21 = MysqlEngineVersion.of("8.0.21", "8.0"), MysqlEngineVersion.VER_8_0_23 = MysqlEngineVersion.of("8.0.23", "8.0"), MysqlEngineVersion.VER_8_0_25 = MysqlEngineVersion.of("8.0.25", "8.0"), MysqlEngineVersion.VER_8_0_26 = MysqlEngineVersion.of("8.0.26", "8.0"), MysqlEngineVersion.VER_8_0_27 = MysqlEngineVersion.of("8.0.27", "8.0"), MysqlEngineVersion.VER_8_0_28 = MysqlEngineVersion.of("8.0.28", "8.0"), MysqlEngineVersion.VER_8_0_30 = MysqlEngineVersion.of("8.0.30", "8.0"), MysqlEngineVersion.VER_8_0_31 = MysqlEngineVersion.of("8.0.31", "8.0"), MysqlEngineVersion.VER_8_0_32 = MysqlEngineVersion.of("8.0.32", "8.0"), exports2.MysqlEngineVersion = MysqlEngineVersion;
    var MySqlInstanceEngine = class extends InstanceEngineBase {
      constructor(version) {
        super({ engineType: "mysql", singleUserRotationApplication: secretsmanager.SecretRotationApplication.MYSQL_ROTATION_SINGLE_USER, multiUserRotationApplication: secretsmanager.SecretRotationApplication.MYSQL_ROTATION_MULTI_USER, version: version ? { fullVersion: version.mysqlFullVersion, majorVersion: version.mysqlMajorVersion } : void 0, engineFamily: "MYSQL" }), this.supportsReadReplicaBackups = true;
      }
    };
    var PostgresEngineVersion = class _PostgresEngineVersion {
      static of(postgresFullVersion, postgresMajorVersion, postgresFeatures) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_PostgresEngineFeatures(postgresFeatures);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.of), error;
        }
        return new _PostgresEngineVersion(postgresFullVersion, postgresMajorVersion, postgresFeatures);
      }
      constructor(postgresFullVersion, postgresMajorVersion, postgresFeatures) {
        this.postgresFullVersion = postgresFullVersion, this.postgresMajorVersion = postgresMajorVersion, this._features = { s3Import: postgresFeatures?.s3Import ? "s3Import" : void 0, s3Export: postgresFeatures?.s3Export ? "s3Export" : void 0 };
      }
    };
    _c = JSII_RTTI_SYMBOL_1, PostgresEngineVersion[_c] = { fqn: "aws-cdk-lib.aws_rds.PostgresEngineVersion", version: "2.80.0" }, PostgresEngineVersion.VER_9_5 = PostgresEngineVersion.of("9.5", "9.5"), PostgresEngineVersion.VER_9_5_2 = PostgresEngineVersion.of("9.5.2", "9.5"), PostgresEngineVersion.VER_9_5_4 = PostgresEngineVersion.of("9.5.4", "9.5"), PostgresEngineVersion.VER_9_5_6 = PostgresEngineVersion.of("9.5.6", "9.5"), PostgresEngineVersion.VER_9_5_7 = PostgresEngineVersion.of("9.5.7", "9.5"), PostgresEngineVersion.VER_9_5_9 = PostgresEngineVersion.of("9.5.9", "9.5"), PostgresEngineVersion.VER_9_5_10 = PostgresEngineVersion.of("9.5.10", "9.5"), PostgresEngineVersion.VER_9_5_12 = PostgresEngineVersion.of("9.5.12", "9.5"), PostgresEngineVersion.VER_9_5_13 = PostgresEngineVersion.of("9.5.13", "9.5"), PostgresEngineVersion.VER_9_5_14 = PostgresEngineVersion.of("9.5.14", "9.5"), PostgresEngineVersion.VER_9_5_15 = PostgresEngineVersion.of("9.5.15", "9.5"), PostgresEngineVersion.VER_9_5_16 = PostgresEngineVersion.of("9.5.16", "9.5"), PostgresEngineVersion.VER_9_5_18 = PostgresEngineVersion.of("9.5.18", "9.5"), PostgresEngineVersion.VER_9_5_19 = PostgresEngineVersion.of("9.5.19", "9.5"), PostgresEngineVersion.VER_9_5_20 = PostgresEngineVersion.of("9.5.20", "9.5"), PostgresEngineVersion.VER_9_5_21 = PostgresEngineVersion.of("9.5.21", "9.5"), PostgresEngineVersion.VER_9_5_22 = PostgresEngineVersion.of("9.5.22", "9.5"), PostgresEngineVersion.VER_9_5_23 = PostgresEngineVersion.of("9.5.23", "9.5"), PostgresEngineVersion.VER_9_5_24 = PostgresEngineVersion.of("9.5.24", "9.5"), PostgresEngineVersion.VER_9_5_25 = PostgresEngineVersion.of("9.5.25", "9.5"), PostgresEngineVersion.VER_9_6 = PostgresEngineVersion.of("9.6", "9.6"), PostgresEngineVersion.VER_9_6_1 = PostgresEngineVersion.of("9.6.1", "9.6"), PostgresEngineVersion.VER_9_6_2 = PostgresEngineVersion.of("9.6.2", "9.6"), PostgresEngineVersion.VER_9_6_3 = PostgresEngineVersion.of("9.6.3", "9.6"), PostgresEngineVersion.VER_9_6_5 = PostgresEngineVersion.of("9.6.5", "9.6"), PostgresEngineVersion.VER_9_6_6 = PostgresEngineVersion.of("9.6.6", "9.6"), PostgresEngineVersion.VER_9_6_8 = PostgresEngineVersion.of("9.6.8", "9.6"), PostgresEngineVersion.VER_9_6_9 = PostgresEngineVersion.of("9.6.9", "9.6"), PostgresEngineVersion.VER_9_6_10 = PostgresEngineVersion.of("9.6.10", "9.6"), PostgresEngineVersion.VER_9_6_11 = PostgresEngineVersion.of("9.6.11", "9.6"), PostgresEngineVersion.VER_9_6_12 = PostgresEngineVersion.of("9.6.12", "9.6"), PostgresEngineVersion.VER_9_6_14 = PostgresEngineVersion.of("9.6.14", "9.6"), PostgresEngineVersion.VER_9_6_15 = PostgresEngineVersion.of("9.6.15", "9.6"), PostgresEngineVersion.VER_9_6_16 = PostgresEngineVersion.of("9.6.16", "9.6"), PostgresEngineVersion.VER_9_6_17 = PostgresEngineVersion.of("9.6.17", "9.6"), PostgresEngineVersion.VER_9_6_18 = PostgresEngineVersion.of("9.6.18", "9.6"), PostgresEngineVersion.VER_9_6_19 = PostgresEngineVersion.of("9.6.19", "9.6"), PostgresEngineVersion.VER_9_6_20 = PostgresEngineVersion.of("9.6.20", "9.6"), PostgresEngineVersion.VER_9_6_21 = PostgresEngineVersion.of("9.6.21", "9.6"), PostgresEngineVersion.VER_9_6_22 = PostgresEngineVersion.of("9.6.22", "9.6"), PostgresEngineVersion.VER_9_6_23 = PostgresEngineVersion.of("9.6.23", "9.6"), PostgresEngineVersion.VER_9_6_24 = PostgresEngineVersion.of("9.6.24", "9.6"), PostgresEngineVersion.VER_10 = PostgresEngineVersion.of("10", "10"), PostgresEngineVersion.VER_10_1 = PostgresEngineVersion.of("10.1", "10"), PostgresEngineVersion.VER_10_3 = PostgresEngineVersion.of("10.3", "10"), PostgresEngineVersion.VER_10_4 = PostgresEngineVersion.of("10.4", "10"), PostgresEngineVersion.VER_10_5 = PostgresEngineVersion.of("10.5", "10"), PostgresEngineVersion.VER_10_6 = PostgresEngineVersion.of("10.6", "10"), PostgresEngineVersion.VER_10_7 = PostgresEngineVersion.of("10.7", "10", { s3Import: true }), PostgresEngineVersion.VER_10_9 = PostgresEngineVersion.of("10.9", "10", { s3Import: true }), PostgresEngineVersion.VER_10_10 = PostgresEngineVersion.of("10.10", "10", { s3Import: true }), PostgresEngineVersion.VER_10_11 = PostgresEngineVersion.of("10.11", "10", { s3Import: true }), PostgresEngineVersion.VER_10_12 = PostgresEngineVersion.of("10.12", "10", { s3Import: true }), PostgresEngineVersion.VER_10_13 = PostgresEngineVersion.of("10.13", "10", { s3Import: true }), PostgresEngineVersion.VER_10_14 = PostgresEngineVersion.of("10.14", "10", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_10_15 = PostgresEngineVersion.of("10.15", "10", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_10_16 = PostgresEngineVersion.of("10.16", "10", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_10_17 = PostgresEngineVersion.of("10.17", "10", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_10_18 = PostgresEngineVersion.of("10.18", "10", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_10_19 = PostgresEngineVersion.of("10.19", "10", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_10_20 = PostgresEngineVersion.of("10.20", "10", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_10_21 = PostgresEngineVersion.of("10.21", "10", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_10_22 = PostgresEngineVersion.of("10.22", "10", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_10_23 = PostgresEngineVersion.of("10.23", "10", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_11 = PostgresEngineVersion.of("11", "11", { s3Import: true }), PostgresEngineVersion.VER_11_1 = PostgresEngineVersion.of("11.1", "11", { s3Import: true }), PostgresEngineVersion.VER_11_2 = PostgresEngineVersion.of("11.2", "11", { s3Import: true }), PostgresEngineVersion.VER_11_4 = PostgresEngineVersion.of("11.4", "11", { s3Import: true }), PostgresEngineVersion.VER_11_5 = PostgresEngineVersion.of("11.5", "11", { s3Import: true }), PostgresEngineVersion.VER_11_6 = PostgresEngineVersion.of("11.6", "11", { s3Import: true }), PostgresEngineVersion.VER_11_7 = PostgresEngineVersion.of("11.7", "11", { s3Import: true }), PostgresEngineVersion.VER_11_8 = PostgresEngineVersion.of("11.8", "11", { s3Import: true }), PostgresEngineVersion.VER_11_9 = PostgresEngineVersion.of("11.9", "11", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_11_10 = PostgresEngineVersion.of("11.10", "11", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_11_11 = PostgresEngineVersion.of("11.11", "11", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_11_12 = PostgresEngineVersion.of("11.12", "11", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_11_13 = PostgresEngineVersion.of("11.13", "11", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_11_14 = PostgresEngineVersion.of("11.14", "11", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_11_15 = PostgresEngineVersion.of("11.15", "11", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_11_16 = PostgresEngineVersion.of("11.16", "11", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_11_17 = PostgresEngineVersion.of("11.17", "11", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_11_18 = PostgresEngineVersion.of("11.18", "11", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_11_19 = PostgresEngineVersion.of("11.19", "11", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_12 = PostgresEngineVersion.of("12", "12", { s3Import: true }), PostgresEngineVersion.VER_12_2 = PostgresEngineVersion.of("12.2", "12", { s3Import: true }), PostgresEngineVersion.VER_12_3 = PostgresEngineVersion.of("12.3", "12", { s3Import: true }), PostgresEngineVersion.VER_12_4 = PostgresEngineVersion.of("12.4", "12", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_12_5 = PostgresEngineVersion.of("12.5", "12", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_12_6 = PostgresEngineVersion.of("12.6", "12", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_12_7 = PostgresEngineVersion.of("12.7", "12", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_12_8 = PostgresEngineVersion.of("12.8", "12", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_12_9 = PostgresEngineVersion.of("12.9", "12", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_12_10 = PostgresEngineVersion.of("12.10", "12", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_12_11 = PostgresEngineVersion.of("12.11", "12", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_12_12 = PostgresEngineVersion.of("12.12", "12", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_12_13 = PostgresEngineVersion.of("12.13", "12", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_12_14 = PostgresEngineVersion.of("12.14", "12", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_13 = PostgresEngineVersion.of("13", "13", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_13_1 = PostgresEngineVersion.of("13.1", "13", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_13_2 = PostgresEngineVersion.of("13.2", "13", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_13_3 = PostgresEngineVersion.of("13.3", "13", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_13_4 = PostgresEngineVersion.of("13.4", "13", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_13_5 = PostgresEngineVersion.of("13.5", "13", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_13_6 = PostgresEngineVersion.of("13.6", "13", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_13_7 = PostgresEngineVersion.of("13.7", "13", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_13_8 = PostgresEngineVersion.of("13.8", "13", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_13_9 = PostgresEngineVersion.of("13.9", "13", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_13_10 = PostgresEngineVersion.of("13.10", "13", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_14 = PostgresEngineVersion.of("14", "14", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_14_1 = PostgresEngineVersion.of("14.1", "14", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_14_2 = PostgresEngineVersion.of("14.2", "14", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_14_3 = PostgresEngineVersion.of("14.3", "14", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_14_4 = PostgresEngineVersion.of("14.4", "14", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_14_5 = PostgresEngineVersion.of("14.5", "14", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_14_6 = PostgresEngineVersion.of("14.6", "14", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_14_7 = PostgresEngineVersion.of("14.7", "14", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_15 = PostgresEngineVersion.of("15", "15", { s3Import: true, s3Export: true }), PostgresEngineVersion.VER_15_2 = PostgresEngineVersion.of("15.2", "15", { s3Import: true, s3Export: true }), exports2.PostgresEngineVersion = PostgresEngineVersion;
    var PostgresInstanceEngine = class extends InstanceEngineBase {
      constructor(version) {
        super({ engineType: "postgres", singleUserRotationApplication: secretsmanager.SecretRotationApplication.POSTGRES_ROTATION_SINGLE_USER, multiUserRotationApplication: secretsmanager.SecretRotationApplication.POSTGRES_ROTATION_MULTI_USER, version: version ? { fullVersion: version.postgresFullVersion, majorVersion: version.postgresMajorVersion } : void 0, features: version ? version?._features : { s3Import: "s3Import" }, engineFamily: "POSTGRESQL" }), this.defaultUsername = "postgres";
      }
    };
    var OracleLegacyEngineVersion = class _OracleLegacyEngineVersion {
      static of(oracleLegacyFullVersion, oracleLegacyMajorVersion) {
        return new _OracleLegacyEngineVersion(oracleLegacyFullVersion, oracleLegacyMajorVersion);
      }
      constructor(oracleLegacyFullVersion, oracleLegacyMajorVersion) {
        this.oracleLegacyFullVersion = oracleLegacyFullVersion, this.oracleLegacyMajorVersion = oracleLegacyMajorVersion;
      }
    };
    _d = JSII_RTTI_SYMBOL_1, OracleLegacyEngineVersion[_d] = { fqn: "aws-cdk-lib.aws_rds.OracleLegacyEngineVersion", version: "2.80.0" }, OracleLegacyEngineVersion.VER_11_2 = OracleLegacyEngineVersion.of("11.2", "11.2"), OracleLegacyEngineVersion.VER_11_2_0_2_V2 = OracleLegacyEngineVersion.of("11.2.0.2.v2", "11.2"), OracleLegacyEngineVersion.VER_11_2_0_4_V1 = OracleLegacyEngineVersion.of("11.2.0.4.v1", "11.2"), OracleLegacyEngineVersion.VER_11_2_0_4_V3 = OracleLegacyEngineVersion.of("11.2.0.4.v3", "11.2"), OracleLegacyEngineVersion.VER_11_2_0_4_V4 = OracleLegacyEngineVersion.of("11.2.0.4.v4", "11.2"), OracleLegacyEngineVersion.VER_11_2_0_4_V5 = OracleLegacyEngineVersion.of("11.2.0.4.v5", "11.2"), OracleLegacyEngineVersion.VER_11_2_0_4_V6 = OracleLegacyEngineVersion.of("11.2.0.4.v6", "11.2"), OracleLegacyEngineVersion.VER_11_2_0_4_V7 = OracleLegacyEngineVersion.of("11.2.0.4.v7", "11.2"), OracleLegacyEngineVersion.VER_11_2_0_4_V8 = OracleLegacyEngineVersion.of("11.2.0.4.v8", "11.2"), OracleLegacyEngineVersion.VER_11_2_0_4_V9 = OracleLegacyEngineVersion.of("11.2.0.4.v9", "11.2"), OracleLegacyEngineVersion.VER_11_2_0_4_V10 = OracleLegacyEngineVersion.of("11.2.0.4.v10", "11.2"), OracleLegacyEngineVersion.VER_11_2_0_4_V11 = OracleLegacyEngineVersion.of("11.2.0.4.v11", "11.2"), OracleLegacyEngineVersion.VER_11_2_0_4_V12 = OracleLegacyEngineVersion.of("11.2.0.4.v12", "11.2"), OracleLegacyEngineVersion.VER_11_2_0_4_V13 = OracleLegacyEngineVersion.of("11.2.0.4.v13", "11.2"), OracleLegacyEngineVersion.VER_11_2_0_4_V14 = OracleLegacyEngineVersion.of("11.2.0.4.v14", "11.2"), OracleLegacyEngineVersion.VER_11_2_0_4_V15 = OracleLegacyEngineVersion.of("11.2.0.4.v15", "11.2"), OracleLegacyEngineVersion.VER_11_2_0_4_V16 = OracleLegacyEngineVersion.of("11.2.0.4.v16", "11.2"), OracleLegacyEngineVersion.VER_11_2_0_4_V17 = OracleLegacyEngineVersion.of("11.2.0.4.v17", "11.2"), OracleLegacyEngineVersion.VER_11_2_0_4_V18 = OracleLegacyEngineVersion.of("11.2.0.4.v18", "11.2"), OracleLegacyEngineVersion.VER_11_2_0_4_V19 = OracleLegacyEngineVersion.of("11.2.0.4.v19", "11.2"), OracleLegacyEngineVersion.VER_11_2_0_4_V20 = OracleLegacyEngineVersion.of("11.2.0.4.v20", "11.2"), OracleLegacyEngineVersion.VER_11_2_0_4_V21 = OracleLegacyEngineVersion.of("11.2.0.4.v21", "11.2"), OracleLegacyEngineVersion.VER_11_2_0_4_V22 = OracleLegacyEngineVersion.of("11.2.0.4.v22", "11.2"), OracleLegacyEngineVersion.VER_11_2_0_4_V23 = OracleLegacyEngineVersion.of("11.2.0.4.v23", "11.2"), OracleLegacyEngineVersion.VER_11_2_0_4_V24 = OracleLegacyEngineVersion.of("11.2.0.4.v24", "11.2"), OracleLegacyEngineVersion.VER_11_2_0_4_V25 = OracleLegacyEngineVersion.of("11.2.0.4.v25", "11.2"), exports2.OracleLegacyEngineVersion = OracleLegacyEngineVersion;
    var OracleEngineVersion = class _OracleEngineVersion {
      static of(oracleFullVersion, oracleMajorVersion) {
        return new _OracleEngineVersion(oracleFullVersion, oracleMajorVersion);
      }
      constructor(oracleFullVersion, oracleMajorVersion) {
        this.oracleFullVersion = oracleFullVersion, this.oracleMajorVersion = oracleMajorVersion;
      }
    };
    _e = JSII_RTTI_SYMBOL_1, OracleEngineVersion[_e] = { fqn: "aws-cdk-lib.aws_rds.OracleEngineVersion", version: "2.80.0" }, OracleEngineVersion.VER_12_1 = OracleEngineVersion.of("12.1", "12.1"), OracleEngineVersion.VER_12_1_0_2_V1 = OracleEngineVersion.of("12.1.0.2.v1", "12.1"), OracleEngineVersion.VER_12_1_0_2_V2 = OracleEngineVersion.of("12.1.0.2.v2", "12.1"), OracleEngineVersion.VER_12_1_0_2_V3 = OracleEngineVersion.of("12.1.0.2.v3", "12.1"), OracleEngineVersion.VER_12_1_0_2_V4 = OracleEngineVersion.of("12.1.0.2.v4", "12.1"), OracleEngineVersion.VER_12_1_0_2_V5 = OracleEngineVersion.of("12.1.0.2.v5", "12.1"), OracleEngineVersion.VER_12_1_0_2_V6 = OracleEngineVersion.of("12.1.0.2.v6", "12.1"), OracleEngineVersion.VER_12_1_0_2_V7 = OracleEngineVersion.of("12.1.0.2.v7", "12.1"), OracleEngineVersion.VER_12_1_0_2_V8 = OracleEngineVersion.of("12.1.0.2.v8", "12.1"), OracleEngineVersion.VER_12_1_0_2_V9 = OracleEngineVersion.of("12.1.0.2.v9", "12.1"), OracleEngineVersion.VER_12_1_0_2_V10 = OracleEngineVersion.of("12.1.0.2.v10", "12.1"), OracleEngineVersion.VER_12_1_0_2_V11 = OracleEngineVersion.of("12.1.0.2.v11", "12.1"), OracleEngineVersion.VER_12_1_0_2_V12 = OracleEngineVersion.of("12.1.0.2.v12", "12.1"), OracleEngineVersion.VER_12_1_0_2_V13 = OracleEngineVersion.of("12.1.0.2.v13", "12.1"), OracleEngineVersion.VER_12_1_0_2_V14 = OracleEngineVersion.of("12.1.0.2.v14", "12.1"), OracleEngineVersion.VER_12_1_0_2_V15 = OracleEngineVersion.of("12.1.0.2.v15", "12.1"), OracleEngineVersion.VER_12_1_0_2_V16 = OracleEngineVersion.of("12.1.0.2.v16", "12.1"), OracleEngineVersion.VER_12_1_0_2_V17 = OracleEngineVersion.of("12.1.0.2.v17", "12.1"), OracleEngineVersion.VER_12_1_0_2_V18 = OracleEngineVersion.of("12.1.0.2.v18", "12.1"), OracleEngineVersion.VER_12_1_0_2_V19 = OracleEngineVersion.of("12.1.0.2.v19", "12.1"), OracleEngineVersion.VER_12_1_0_2_V20 = OracleEngineVersion.of("12.1.0.2.v20", "12.1"), OracleEngineVersion.VER_12_1_0_2_V21 = OracleEngineVersion.of("12.1.0.2.v21", "12.1"), OracleEngineVersion.VER_12_1_0_2_V22 = OracleEngineVersion.of("12.1.0.2.v22", "12.1"), OracleEngineVersion.VER_12_1_0_2_V23 = OracleEngineVersion.of("12.1.0.2.v23", "12.1"), OracleEngineVersion.VER_12_1_0_2_V24 = OracleEngineVersion.of("12.1.0.2.v24", "12.1"), OracleEngineVersion.VER_12_1_0_2_V25 = OracleEngineVersion.of("12.1.0.2.v25", "12.1"), OracleEngineVersion.VER_12_1_0_2_V26 = OracleEngineVersion.of("12.1.0.2.v26", "12.1"), OracleEngineVersion.VER_12_1_0_2_V27 = OracleEngineVersion.of("12.1.0.2.v27", "12.1"), OracleEngineVersion.VER_12_1_0_2_V28 = OracleEngineVersion.of("12.1.0.2.v28", "12.1"), OracleEngineVersion.VER_12_1_0_2_V29 = OracleEngineVersion.of("12.1.0.2.v29", "12.1"), OracleEngineVersion.VER_12_2 = OracleEngineVersion.of("12.2", "12.2"), OracleEngineVersion.VER_12_2_0_1_2018_10_R1 = OracleEngineVersion.of("12.2.0.1.ru-2018-10.rur-2018-10.r1", "12.2"), OracleEngineVersion.VER_12_2_0_1_2019_01_R1 = OracleEngineVersion.of("12.2.0.1.ru-2019-01.rur-2019-01.r1", "12.2"), OracleEngineVersion.VER_12_2_0_1_2019_04_R1 = OracleEngineVersion.of("12.2.0.1.ru-2019-04.rur-2019-04.r1", "12.2"), OracleEngineVersion.VER_12_2_0_1_2019_07_R1 = OracleEngineVersion.of("12.2.0.1.ru-2019-07.rur-2019-07.r1", "12.2"), OracleEngineVersion.VER_12_2_0_1_2019_10_R1 = OracleEngineVersion.of("12.2.0.1.ru-2019-10.rur-2019-10.r1", "12.2"), OracleEngineVersion.VER_12_2_0_1_2020_01_R1 = OracleEngineVersion.of("12.2.0.1.ru-2020-01.rur-2020-01.r1", "12.2"), OracleEngineVersion.VER_12_2_0_1_2020_04_R1 = OracleEngineVersion.of("12.2.0.1.ru-2020-04.rur-2020-04.r1", "12.2"), OracleEngineVersion.VER_12_2_0_1_2020_07_R1 = OracleEngineVersion.of("12.2.0.1.ru-2020-07.rur-2020-07.r1", "12.2"), OracleEngineVersion.VER_12_2_0_1_2020_10_R1 = OracleEngineVersion.of("12.2.0.1.ru-2020-10.rur-2020-10.r1", "12.2"), OracleEngineVersion.VER_12_2_0_1_2021_01_R1 = OracleEngineVersion.of("12.2.0.1.ru-2021-01.rur-2021-01.r1", "12.2"), OracleEngineVersion.VER_12_2_0_1_2021_04_R1 = OracleEngineVersion.of("12.2.0.1.ru-2021-04.rur-2021-04.r1", "12.2"), OracleEngineVersion.VER_12_2_0_1_2021_07_R1 = OracleEngineVersion.of("12.2.0.1.ru-2021-07.rur-2021-07.r1", "12.2"), OracleEngineVersion.VER_12_2_0_1_2021_10_R1 = OracleEngineVersion.of("12.2.0.1.ru-2021-10.rur-2021-10.r1", "12.2"), OracleEngineVersion.VER_12_2_0_1_2022_01_R1 = OracleEngineVersion.of("12.2.0.1.ru-2022-01.rur-2022-01.r1", "12.2"), OracleEngineVersion.VER_18 = OracleEngineVersion.of("18", "18"), OracleEngineVersion.VER_18_0_0_0_2019_07_R1 = OracleEngineVersion.of("18.0.0.0.ru-2019-07.rur-2019-07.r1", "18"), OracleEngineVersion.VER_18_0_0_0_2019_10_R1 = OracleEngineVersion.of("18.0.0.0.ru-2019-10.rur-2019-10.r1", "18"), OracleEngineVersion.VER_18_0_0_0_2020_01_R1 = OracleEngineVersion.of("18.0.0.0.ru-2020-01.rur-2020-01.r1", "18"), OracleEngineVersion.VER_18_0_0_0_2020_04_R1 = OracleEngineVersion.of("18.0.0.0.ru-2020-04.rur-2020-04.r1", "18"), OracleEngineVersion.VER_18_0_0_0_2020_07_R1 = OracleEngineVersion.of("18.0.0.0.ru-2020-07.rur-2020-07.r1", "18"), OracleEngineVersion.VER_18_0_0_0_2020_10_R1 = OracleEngineVersion.of("18.0.0.0.ru-2020-10.rur-2020-10.r1", "18"), OracleEngineVersion.VER_18_0_0_0_2021_01_R1 = OracleEngineVersion.of("18.0.0.0.ru-2021-01.rur-2021-01.r1", "18"), OracleEngineVersion.VER_18_0_0_0_2021_04_R1 = OracleEngineVersion.of("18.0.0.0.ru-2021-04.rur-2021-04.r1", "18"), OracleEngineVersion.VER_19 = OracleEngineVersion.of("19", "19"), OracleEngineVersion.VER_19_0_0_0_2019_07_R1 = OracleEngineVersion.of("19.0.0.0.ru-2019-07.rur-2019-07.r1", "19"), OracleEngineVersion.VER_19_0_0_0_2019_10_R1 = OracleEngineVersion.of("19.0.0.0.ru-2019-10.rur-2019-10.r1", "19"), OracleEngineVersion.VER_19_0_0_0_2020_01_R1 = OracleEngineVersion.of("19.0.0.0.ru-2020-01.rur-2020-01.r1", "19"), OracleEngineVersion.VER_19_0_0_0_2020_04_R1 = OracleEngineVersion.of("19.0.0.0.ru-2020-04.rur-2020-04.r1", "19"), OracleEngineVersion.VER_19_0_0_0_2020_07_R1 = OracleEngineVersion.of("19.0.0.0.ru-2020-07.rur-2020-07.r1", "19"), OracleEngineVersion.VER_19_0_0_0_2020_10_R1 = OracleEngineVersion.of("19.0.0.0.ru-2020-10.rur-2020-10.r1", "19"), OracleEngineVersion.VER_19_0_0_0_2021_01_R1 = OracleEngineVersion.of("19.0.0.0.ru-2021-01.rur-2021-01.r1", "19"), OracleEngineVersion.VER_19_0_0_0_2021_01_R2 = OracleEngineVersion.of("19.0.0.0.ru-2021-01.rur-2021-01.r2", "19"), OracleEngineVersion.VER_19_0_0_0_2021_04_R1 = OracleEngineVersion.of("19.0.0.0.ru-2021-04.rur-2021-04.r1", "19"), OracleEngineVersion.VER_19_0_0_0_2021_07_R1 = OracleEngineVersion.of("19.0.0.0.ru-2021-07.rur-2021-07.r1", "19"), OracleEngineVersion.VER_19_0_0_0_2021_10_R1 = OracleEngineVersion.of("19.0.0.0.ru-2021-10.rur-2021-10.r1", "19"), OracleEngineVersion.VER_19_0_0_0_2022_01_R1 = OracleEngineVersion.of("19.0.0.0.ru-2022-01.rur-2022-01.r1", "19"), OracleEngineVersion.VER_19_0_0_0_2022_04_R1 = OracleEngineVersion.of("19.0.0.0.ru-2022-04.rur-2022-04.r1", "19"), OracleEngineVersion.VER_19_0_0_0_2022_07_R1 = OracleEngineVersion.of("19.0.0.0.ru-2022-07.rur-2022-07.r1", "19"), OracleEngineVersion.VER_19_0_0_0_2022_10_R1 = OracleEngineVersion.of("19.0.0.0.ru-2022-10.rur-2022-10.r1", "19"), OracleEngineVersion.VER_19_0_0_0_2023_01_R1 = OracleEngineVersion.of("19.0.0.0.ru-2023-01.rur-2023-01.r1", "19"), OracleEngineVersion.VER_21 = OracleEngineVersion.of("21", "21"), OracleEngineVersion.VER_21_0_0_0_2022_01_R1 = OracleEngineVersion.of("21.0.0.0.ru-2022-01.rur-2022-01.r1", "21"), OracleEngineVersion.VER_21_0_0_0_2022_04_R1 = OracleEngineVersion.of("21.0.0.0.ru-2022-04.rur-2022-04.r1", "21"), OracleEngineVersion.VER_21_0_0_0_2022_07_R1 = OracleEngineVersion.of("21.0.0.0.ru-2022-07.rur-2022-07.r1", "21"), OracleEngineVersion.VER_21_0_0_0_2022_10_R1 = OracleEngineVersion.of("21.0.0.0.ru-2022-10.rur-2022-10.r1", "21"), OracleEngineVersion.VER_21_0_0_0_2023_01_R1 = OracleEngineVersion.of("21.0.0.0.ru-2023-01.rur-2023-01.r1", "21"), exports2.OracleEngineVersion = OracleEngineVersion;
    var OracleInstanceEngineBase = class extends InstanceEngineBase {
      constructor(props) {
        super({ ...props, singleUserRotationApplication: secretsmanager.SecretRotationApplication.ORACLE_ROTATION_SINGLE_USER, multiUserRotationApplication: secretsmanager.SecretRotationApplication.ORACLE_ROTATION_MULTI_USER, parameterGroupFamily: props.version ? `${props.engineType}-${props.version.majorVersion}` : void 0, features: { s3Import: "S3_INTEGRATION", s3Export: "S3_INTEGRATION" } });
      }
      bindToInstance(scope, options) {
        const config = super.bindToInstance(scope, options);
        let optionGroup = options.optionGroup;
        return (options.s3ImportRole || options.s3ExportRole) && (optionGroup || (optionGroup = new option_group_1.OptionGroup(scope, "InstanceOptionGroup", { engine: this, configurations: [] })), optionGroup.addConfiguration({ name: "S3_INTEGRATION", version: "1.0" })), { ...config, optionGroup };
      }
    };
    var OracleSeInstanceEngine = class extends OracleInstanceEngineBase {
      constructor(version) {
        super({ engineType: "oracle-se", version: version ? { fullVersion: version.oracleLegacyFullVersion, majorVersion: version.oracleLegacyMajorVersion } : { majorVersion: "11.2" } });
      }
    };
    var OracleSe1InstanceEngine = class extends OracleInstanceEngineBase {
      constructor(version) {
        super({ engineType: "oracle-se1", version: version ? { fullVersion: version.oracleLegacyFullVersion, majorVersion: version.oracleLegacyMajorVersion } : { majorVersion: "11.2" } });
      }
    };
    var OracleSe2InstanceEngine = class extends OracleInstanceEngineBase {
      constructor(version) {
        super({ engineType: "oracle-se2", version: version ? { fullVersion: version.oracleFullVersion, majorVersion: version.oracleMajorVersion } : void 0 });
      }
    };
    var OracleSe2CdbInstanceEngine = class extends OracleInstanceEngineBase {
      constructor(version) {
        super({ engineType: "oracle-se2-cdb", version: version ? { fullVersion: version.oracleFullVersion, majorVersion: version.oracleMajorVersion } : void 0 });
      }
    };
    var OracleEeInstanceEngine = class extends OracleInstanceEngineBase {
      constructor(version) {
        super({ engineType: "oracle-ee", version: version ? { fullVersion: version.oracleFullVersion, majorVersion: version.oracleMajorVersion } : void 0 });
      }
    };
    var OracleEeCdbInstanceEngine = class extends OracleInstanceEngineBase {
      constructor(version) {
        super({ engineType: "oracle-ee-cdb", version: version ? { fullVersion: version.oracleFullVersion, majorVersion: version.oracleMajorVersion } : void 0 });
      }
    };
    var SqlServerEngineVersion = class _SqlServerEngineVersion {
      static of(sqlServerFullVersion, sqlServerMajorVersion) {
        return new _SqlServerEngineVersion(sqlServerFullVersion, sqlServerMajorVersion);
      }
      constructor(sqlServerFullVersion, sqlServerMajorVersion) {
        this.sqlServerFullVersion = sqlServerFullVersion, this.sqlServerMajorVersion = sqlServerMajorVersion;
      }
    };
    _f = JSII_RTTI_SYMBOL_1, SqlServerEngineVersion[_f] = { fqn: "aws-cdk-lib.aws_rds.SqlServerEngineVersion", version: "2.80.0" }, SqlServerEngineVersion.VER_11 = SqlServerEngineVersion.of("11.00", "11.00"), SqlServerEngineVersion.VER_11_00_5058_0_V1 = SqlServerEngineVersion.of("11.00.5058.0.v1", "11.00"), SqlServerEngineVersion.VER_11_00_6020_0_V1 = SqlServerEngineVersion.of("11.00.6020.0.v1", "11.00"), SqlServerEngineVersion.VER_11_00_6594_0_V1 = SqlServerEngineVersion.of("11.00.6594.0.v1", "11.00"), SqlServerEngineVersion.VER_11_00_7462_6_V1 = SqlServerEngineVersion.of("11.00.7462.6.v1", "11.00"), SqlServerEngineVersion.VER_11_00_7493_4_V1 = SqlServerEngineVersion.of("11.00.7493.4.v1", "11.00"), SqlServerEngineVersion.VER_12 = SqlServerEngineVersion.of("12.00", "12.00"), SqlServerEngineVersion.VER_12_00_5000_0_V1 = SqlServerEngineVersion.of("12.00.5000.0.v1", "12.00"), SqlServerEngineVersion.VER_12_00_5546_0_V1 = SqlServerEngineVersion.of("12.00.5546.0.v1", "12.00"), SqlServerEngineVersion.VER_12_00_5571_0_V1 = SqlServerEngineVersion.of("12.00.5571.0.v1", "12.00"), SqlServerEngineVersion.VER_12_00_6293_0_V1 = SqlServerEngineVersion.of("12.00.6293.0.v1", "12.00"), SqlServerEngineVersion.VER_12_00_6329_1_V1 = SqlServerEngineVersion.of("12.00.6329.1.v1", "12.00"), SqlServerEngineVersion.VER_12_00_6433_1_V1 = SqlServerEngineVersion.of("12.00.6433.1.v1", "12.00"), SqlServerEngineVersion.VER_12_00_6439_10_V1 = SqlServerEngineVersion.of("12.00.6439.10.v1", "12.00"), SqlServerEngineVersion.VER_13 = SqlServerEngineVersion.of("13.00", "13.00"), SqlServerEngineVersion.VER_13_00_2164_0_V1 = SqlServerEngineVersion.of("13.00.2164.0.v1", "13.00"), SqlServerEngineVersion.VER_13_00_4422_0_V1 = SqlServerEngineVersion.of("13.00.4422.0.v1", "13.00"), SqlServerEngineVersion.VER_13_00_4451_0_V1 = SqlServerEngineVersion.of("13.00.4451.0.v1", "13.00"), SqlServerEngineVersion.VER_13_00_4466_4_V1 = SqlServerEngineVersion.of("13.00.4466.4.v1", "13.00"), SqlServerEngineVersion.VER_13_00_4522_0_V1 = SqlServerEngineVersion.of("13.00.4522.0.v1", "13.00"), SqlServerEngineVersion.VER_13_00_5216_0_V1 = SqlServerEngineVersion.of("13.00.5216.0.v1", "13.00"), SqlServerEngineVersion.VER_13_00_5292_0_V1 = SqlServerEngineVersion.of("13.00.5292.0.v1", "13.00"), SqlServerEngineVersion.VER_13_00_5366_0_V1 = SqlServerEngineVersion.of("13.00.5366.0.v1", "13.00"), SqlServerEngineVersion.VER_13_00_5426_0_V1 = SqlServerEngineVersion.of("13.00.5426.0.v1", "13.00"), SqlServerEngineVersion.VER_13_00_5598_27_V1 = SqlServerEngineVersion.of("13.00.5598.27.v1", "13.00"), SqlServerEngineVersion.VER_13_00_5820_21_V1 = SqlServerEngineVersion.of("13.00.5820.21.v1", "13.00"), SqlServerEngineVersion.VER_13_00_5850_14_V1 = SqlServerEngineVersion.of("13.00.5850.14.v1", "13.00"), SqlServerEngineVersion.VER_13_00_5882_1_V1 = SqlServerEngineVersion.of("13.00.5882.1.v1", "13.00"), SqlServerEngineVersion.VER_13_00_6300_2_V1 = SqlServerEngineVersion.of("13.00.6300.2.v1", "13.00"), SqlServerEngineVersion.VER_13_00_6419_1_V1 = SqlServerEngineVersion.of("13.00.6419.1.v1", "13.00"), SqlServerEngineVersion.VER_14 = SqlServerEngineVersion.of("14.00", "14.00"), SqlServerEngineVersion.VER_14_00_1000_169_V1 = SqlServerEngineVersion.of("14.00.1000.169.v1", "14.00"), SqlServerEngineVersion.VER_14_00_3015_40_V1 = SqlServerEngineVersion.of("14.00.3015.40.v1", "14.00"), SqlServerEngineVersion.VER_14_00_3035_2_V1 = SqlServerEngineVersion.of("14.00.3035.2.v1", "14.00"), SqlServerEngineVersion.VER_14_00_3049_1_V1 = SqlServerEngineVersion.of("14.00.3049.1.v1", "14.00"), SqlServerEngineVersion.VER_14_00_3192_2_V1 = SqlServerEngineVersion.of("14.00.3192.2.v1", "14.00"), SqlServerEngineVersion.VER_14_00_3223_3_V1 = SqlServerEngineVersion.of("14.00.3223.3.v1", "14.00"), SqlServerEngineVersion.VER_14_00_3281_6_V1 = SqlServerEngineVersion.of("14.00.3281.6.v1", "14.00"), SqlServerEngineVersion.VER_14_00_3294_2_V1 = SqlServerEngineVersion.of("14.00.3294.2.v1", "14.00"), SqlServerEngineVersion.VER_14_00_3356_20_V1 = SqlServerEngineVersion.of("14.00.3356.20.v1", "14.00"), SqlServerEngineVersion.VER_14_00_3381_3_V1 = SqlServerEngineVersion.of("14.00.3381.3.v1", "14.00"), SqlServerEngineVersion.VER_14_00_3401_7_V1 = SqlServerEngineVersion.of("14.00.3401.7.v1", "14.00"), SqlServerEngineVersion.VER_14_00_3421_10_V1 = SqlServerEngineVersion.of("14.00.3421.10.v1", "14.00"), SqlServerEngineVersion.VER_14_00_3451_2_V1 = SqlServerEngineVersion.of("14.00.3451.2.v1", "14.00"), SqlServerEngineVersion.VER_15 = SqlServerEngineVersion.of("15.00", "15.00"), SqlServerEngineVersion.VER_15_00_4043_16_V1 = SqlServerEngineVersion.of("15.00.4043.16.v1", "15.00"), SqlServerEngineVersion.VER_15_00_4043_23_V1 = SqlServerEngineVersion.of("15.00.4043.23.v1", "15.00"), SqlServerEngineVersion.VER_15_00_4073_23_V1 = SqlServerEngineVersion.of("15.00.4073.23.v1", "15.00"), SqlServerEngineVersion.VER_15_00_4153_1_V1 = SqlServerEngineVersion.of("15.00.4153.1.v1", "15.00"), SqlServerEngineVersion.VER_15_00_4198_2_V1 = SqlServerEngineVersion.of("15.00.4198.2.v1", "15.00"), SqlServerEngineVersion.VER_15_00_4236_7_V1 = SqlServerEngineVersion.of("15.00.4236.7.v1", "15.00"), exports2.SqlServerEngineVersion = SqlServerEngineVersion;
    var SqlServerInstanceEngineBase = class extends InstanceEngineBase {
      constructor(props) {
        super({ ...props, singleUserRotationApplication: secretsmanager.SecretRotationApplication.SQLSERVER_ROTATION_SINGLE_USER, multiUserRotationApplication: secretsmanager.SecretRotationApplication.SQLSERVER_ROTATION_MULTI_USER, version: props.version ? { fullVersion: props.version.sqlServerFullVersion, majorVersion: props.version.sqlServerMajorVersion } : void 0, parameterGroupFamily: props.version ? `${props.engineType}-${props.version.sqlServerMajorVersion.endsWith(".00") ? props.version.sqlServerMajorVersion.slice(0, -1) : props.version.sqlServerMajorVersion}` : void 0, features: { s3Import: "S3_INTEGRATION", s3Export: "S3_INTEGRATION" }, engineFamily: "SQLSERVER" });
      }
      bindToInstance(scope, options) {
        const config = super.bindToInstance(scope, options);
        let optionGroup = options.optionGroup;
        const s3Role = options.s3ImportRole ?? options.s3ExportRole;
        if (s3Role) {
          if (options.s3ImportRole && options.s3ExportRole && options.s3ImportRole !== options.s3ExportRole)
            throw new Error("S3 import and export roles must be the same for SQL Server engines");
          optionGroup || (optionGroup = new option_group_1.OptionGroup(scope, "InstanceOptionGroup", { engine: this, configurations: [] })), optionGroup.addConfiguration({ name: "SQLSERVER_BACKUP_RESTORE", settings: { IAM_ROLE_ARN: s3Role.roleArn } });
        }
        return { ...config, optionGroup };
      }
      get supportsTimezone() {
        return true;
      }
    };
    var SqlServerSeInstanceEngine = class extends SqlServerInstanceEngineBase {
      constructor(version) {
        super({ engineType: "sqlserver-se", version });
      }
    };
    var SqlServerExInstanceEngine = class extends SqlServerInstanceEngineBase {
      constructor(version) {
        super({ engineType: "sqlserver-ex", version });
      }
    };
    var SqlServerWebInstanceEngine = class extends SqlServerInstanceEngineBase {
      constructor(version) {
        super({ engineType: "sqlserver-web", version });
      }
    };
    var SqlServerEeInstanceEngine = class extends SqlServerInstanceEngineBase {
      constructor(version) {
        super({ engineType: "sqlserver-ee", version });
      }
    };
    var DatabaseInstanceEngine = class {
      static mariaDb(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_MariaDbInstanceEngineProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.mariaDb), error;
        }
        return new MariaDbInstanceEngine(props.version);
      }
      static mysql(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_MySqlInstanceEngineProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.mysql), error;
        }
        return new MySqlInstanceEngine(props.version);
      }
      static postgres(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_PostgresInstanceEngineProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.postgres), error;
        }
        return new PostgresInstanceEngine(props.version);
      }
      static oracleSe(props) {
        return new OracleSeInstanceEngine(props.version);
      }
      static oracleSe1(props) {
        return new OracleSe1InstanceEngine(props.version);
      }
      static oracleSe2(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_OracleSe2InstanceEngineProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.oracleSe2), error;
        }
        return new OracleSe2InstanceEngine(props.version);
      }
      static oracleSe2Cdb(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_OracleSe2CdbInstanceEngineProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.oracleSe2Cdb), error;
        }
        return new OracleSe2CdbInstanceEngine(props.version);
      }
      static oracleEe(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_OracleEeInstanceEngineProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.oracleEe), error;
        }
        return new OracleEeInstanceEngine(props.version);
      }
      static oracleEeCdb(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_OracleEeCdbInstanceEngineProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.oracleEeCdb), error;
        }
        return new OracleEeCdbInstanceEngine(props.version);
      }
      static sqlServerSe(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_SqlServerSeInstanceEngineProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.sqlServerSe), error;
        }
        return new SqlServerSeInstanceEngine(props.version);
      }
      static sqlServerEx(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_SqlServerExInstanceEngineProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.sqlServerEx), error;
        }
        return new SqlServerExInstanceEngine(props.version);
      }
      static sqlServerWeb(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_SqlServerWebInstanceEngineProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.sqlServerWeb), error;
        }
        return new SqlServerWebInstanceEngine(props.version);
      }
      static sqlServerEe(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_SqlServerEeInstanceEngineProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.sqlServerEe), error;
        }
        return new SqlServerEeInstanceEngine(props.version);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, DatabaseInstanceEngine[_g] = { fqn: "aws-cdk-lib.aws_rds.DatabaseInstanceEngine", version: "2.80.0" }, DatabaseInstanceEngine.MARIADB = new MariaDbInstanceEngine(), DatabaseInstanceEngine.MYSQL = new MySqlInstanceEngine(), DatabaseInstanceEngine.ORACLE_EE = new OracleEeInstanceEngine(), DatabaseInstanceEngine.ORACLE_EE_CDB = new OracleEeCdbInstanceEngine(), DatabaseInstanceEngine.ORACLE_SE2 = new OracleSe2InstanceEngine(), DatabaseInstanceEngine.ORACLE_SE2_CDB = new OracleSe2CdbInstanceEngine(), DatabaseInstanceEngine.ORACLE_SE1 = new OracleSe1InstanceEngine(), DatabaseInstanceEngine.ORACLE_SE = new OracleSeInstanceEngine(), DatabaseInstanceEngine.POSTGRES = new PostgresInstanceEngine(), DatabaseInstanceEngine.SQL_SERVER_EE = new SqlServerEeInstanceEngine(), DatabaseInstanceEngine.SQL_SERVER_SE = new SqlServerSeInstanceEngine(), DatabaseInstanceEngine.SQL_SERVER_EX = new SqlServerExInstanceEngine(), DatabaseInstanceEngine.SQL_SERVER_WEB = new SqlServerWebInstanceEngine(), exports2.DatabaseInstanceEngine = DatabaseInstanceEngine;
  }
});

// node_modules/aws-cdk-lib/aws-rds/lib/instance.js
var require_instance2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-rds/lib/instance.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DatabaseInstanceReadReplica = exports2.DatabaseInstanceFromSnapshot = exports2.DatabaseInstance = exports2.NetworkType = exports2.StorageType = exports2.LicenseModel = exports2.DatabaseInstanceBase = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var database_secret_1 = require_database_secret();
    var endpoint_1 = require_endpoint();
    var parameter_group_1 = require_parameter_group();
    var util_1 = require_util16();
    var props_1 = require_props();
    var proxy_1 = require_proxy();
    var rds_generated_1 = require_rds_generated();
    var subnet_group_1 = require_subnet_group();
    var ec2 = require_aws_ec2();
    var events = require_aws_events();
    var iam = require_aws_iam();
    var logs = require_aws_logs();
    var secretsmanager = require_aws_secretsmanager();
    var core_1 = require_core2();
    var cxapi = require_cx_api();
    var DatabaseInstanceBase = class _DatabaseInstanceBase extends core_1.Resource {
      static fromDatabaseInstanceAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_DatabaseInstanceAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromDatabaseInstanceAttributes), error;
        }
        class Import extends _DatabaseInstanceBase {
          constructor() {
            super(...arguments), this.defaultPort = ec2.Port.tcp(attrs.port), this.connections = new ec2.Connections({ securityGroups: attrs.securityGroups, defaultPort: this.defaultPort }), this.instanceIdentifier = attrs.instanceIdentifier, this.dbInstanceEndpointAddress = attrs.instanceEndpointAddress, this.dbInstanceEndpointPort = core_1.Tokenization.stringifyNumber(attrs.port), this.instanceEndpoint = new endpoint_1.Endpoint(attrs.instanceEndpointAddress, attrs.port), this.engine = attrs.engine, this.enableIamAuthentication = true, this.instanceResourceId = attrs.instanceResourceId;
          }
        }
        return new Import(scope, id);
      }
      addProxy(id, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_DatabaseProxyOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addProxy), error;
        }
        return new proxy_1.DatabaseProxy(this, id, { proxyTarget: proxy_1.ProxyTarget.fromInstance(this), ...options });
      }
      grantConnect(grantee, dbUser) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(grantee);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantConnect), error;
        }
        if (this.enableIamAuthentication === false)
          throw new Error("Cannot grant connect when IAM authentication is disabled");
        if (!this.instanceResourceId)
          throw new Error("For imported Database Instances, instanceResourceId is required to grantConnect()");
        if (!dbUser)
          throw new Error("For imported Database Instances, the dbUser is required to grantConnect()");
        return this.enableIamAuthentication = true, iam.Grant.addToPrincipal({ grantee, actions: ["rds-db:connect"], resourceArns: [core_1.Stack.of(this).formatArn({ arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME, service: "rds-db", resource: "dbuser", resourceName: [this.instanceResourceId, dbUser].join("/") })] });
      }
      onEvent(id, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_OnEventOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.onEvent), error;
        }
        const rule = new events.Rule(this, id, options);
        return rule.addEventPattern({ source: ["aws.rds"], resources: [this.instanceArn] }), rule.addTarget(options.target), rule;
      }
      get instanceArn() {
        const commonAnComponents = { service: "rds", resource: "db", arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME }, localArn = core_1.Stack.of(this).formatArn({ ...commonAnComponents, resourceName: this.instanceIdentifier });
        return this.getResourceArnAttribute(localArn, { ...commonAnComponents, resourceName: this.physicalName });
      }
      asSecretAttachmentTarget() {
        return { targetId: this.instanceIdentifier, targetType: secretsmanager.AttachmentTargetType.RDS_DB_INSTANCE };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, DatabaseInstanceBase[_a] = { fqn: "aws-cdk-lib.aws_rds.DatabaseInstanceBase", version: "2.80.0" }, exports2.DatabaseInstanceBase = DatabaseInstanceBase;
    var LicenseModel;
    (function(LicenseModel2) {
      LicenseModel2.LICENSE_INCLUDED = "license-included", LicenseModel2.BRING_YOUR_OWN_LICENSE = "bring-your-own-license", LicenseModel2.GENERAL_PUBLIC_LICENSE = "general-public-license";
    })(LicenseModel = exports2.LicenseModel || (exports2.LicenseModel = {}));
    var StorageType;
    (function(StorageType2) {
      StorageType2.STANDARD = "standard", StorageType2.GP2 = "gp2", StorageType2.GP3 = "gp3", StorageType2.IO1 = "io1";
    })(StorageType = exports2.StorageType || (exports2.StorageType = {}));
    var NetworkType;
    (function(NetworkType2) {
      NetworkType2.IPV4 = "IPV4", NetworkType2.DUAL = "DUAL";
    })(NetworkType = exports2.NetworkType || (exports2.NetworkType = {}));
    var DatabaseInstanceNew = class extends DatabaseInstanceBase {
      constructor(scope, id, props) {
        const instancePhysicalName = core_1.Token.isUnresolved(props.instanceIdentifier) ? props.instanceIdentifier : props.instanceIdentifier?.toLowerCase();
        if (super(scope, id, { physicalName: instancePhysicalName }), this.vpc = props.vpc, props.vpcSubnets && props.vpcPlacement)
          throw new Error("Only one of `vpcSubnets` or `vpcPlacement` can be specified");
        if (this.vpcPlacement = props.vpcSubnets ?? props.vpcPlacement, props.multiAz === true && props.availabilityZone)
          throw new Error("Requesting a specific availability zone is not valid for Multi-AZ instances");
        const subnetGroup = props.subnetGroup ?? new subnet_group_1.SubnetGroup(this, "SubnetGroup", { description: `Subnet group for ${this.node.id} database`, vpc: this.vpc, vpcSubnets: this.vpcPlacement, removalPolicy: (0, util_1.renderUnless)((0, util_1.helperRemovalPolicy)(props.removalPolicy), core_1.RemovalPolicy.DESTROY) }), securityGroups = props.securityGroups || [new ec2.SecurityGroup(this, "SecurityGroup", { description: `Security group for ${this.node.id} database`, vpc: props.vpc })];
        this.connections = new ec2.Connections({ securityGroups, defaultPort: ec2.Port.tcp(core_1.Lazy.number({ produce: () => this.instanceEndpoint.port })) });
        let monitoringRole;
        props.monitoringInterval && props.monitoringInterval.toSeconds() && (monitoringRole = props.monitoringRole || new iam.Role(this, "MonitoringRole", { assumedBy: new iam.ServicePrincipal("monitoring.rds.amazonaws.com"), managedPolicies: [iam.ManagedPolicy.fromAwsManagedPolicyName("service-role/AmazonRDSEnhancedMonitoringRole")] }));
        const storageType = props.storageType ?? StorageType.GP2, iops = defaultIops(storageType, props.iops);
        if (props.storageThroughput && storageType !== StorageType.GP3)
          throw new Error(`The storage throughput can only be specified with GP3 storage type. Got ${storageType}.`);
        if (storageType === StorageType.GP3 && props.storageThroughput && iops && !core_1.Token.isUnresolved(props.storageThroughput) && !core_1.Token.isUnresolved(iops) && props.storageThroughput / iops > 0.25)
          throw new Error(`The maximum ratio of storage throughput to IOPS is 0.25. Got ${props.storageThroughput / iops}.`);
        this.cloudwatchLogsExports = props.cloudwatchLogsExports, this.cloudwatchLogsRetention = props.cloudwatchLogsRetention, this.cloudwatchLogsRetentionRole = props.cloudwatchLogsRetentionRole, this.enableIamAuthentication = props.iamAuthentication;
        const enablePerformanceInsights = props.enablePerformanceInsights || props.performanceInsightRetention !== void 0 || props.performanceInsightEncryptionKey !== void 0;
        if (enablePerformanceInsights && props.enablePerformanceInsights === false)
          throw new Error("`enablePerformanceInsights` disabled, but `performanceInsightRetention` or `performanceInsightEncryptionKey` was set");
        props.domain && (this.domainId = props.domain, this.domainRole = props.domainRole || new iam.Role(this, "RDSDirectoryServiceRole", { assumedBy: new iam.ServicePrincipal("rds.amazonaws.com"), managedPolicies: [iam.ManagedPolicy.fromAwsManagedPolicyName("service-role/AmazonRDSDirectoryServiceAccess")] }));
        const maybeLowercasedInstanceId = core_1.FeatureFlags.of(this).isEnabled(cxapi.RDS_LOWERCASE_DB_IDENTIFIER) && !core_1.Token.isUnresolved(props.instanceIdentifier) ? props.instanceIdentifier?.toLowerCase() : props.instanceIdentifier, instanceParameterGroupConfig = props.parameterGroup?.bindToInstance({});
        this.newCfnProps = { autoMinorVersionUpgrade: props.autoMinorVersionUpgrade, availabilityZone: props.multiAz ? void 0 : props.availabilityZone, backupRetentionPeriod: props.backupRetention?.toDays(), copyTagsToSnapshot: props.copyTagsToSnapshot ?? true, dbInstanceClass: core_1.Lazy.string({ produce: () => `db.${this.instanceType}` }), dbInstanceIdentifier: core_1.Token.isUnresolved(props.instanceIdentifier) ? this.physicalName : maybeLowercasedInstanceId, dbSubnetGroupName: subnetGroup.subnetGroupName, deleteAutomatedBackups: props.deleteAutomatedBackups, deletionProtection: (0, util_1.defaultDeletionProtection)(props.deletionProtection, props.removalPolicy), enableCloudwatchLogsExports: this.cloudwatchLogsExports, enableIamDatabaseAuthentication: core_1.Lazy.any({ produce: () => this.enableIamAuthentication }), enablePerformanceInsights: enablePerformanceInsights || props.enablePerformanceInsights, iops, monitoringInterval: props.monitoringInterval?.toSeconds(), monitoringRoleArn: monitoringRole?.roleArn, multiAz: props.multiAz, dbParameterGroupName: instanceParameterGroupConfig?.parameterGroupName, optionGroupName: props.optionGroup?.optionGroupName, performanceInsightsKmsKeyId: props.performanceInsightEncryptionKey?.keyArn, performanceInsightsRetentionPeriod: enablePerformanceInsights ? props.performanceInsightRetention || props_1.PerformanceInsightRetention.DEFAULT : void 0, port: props.port !== void 0 ? core_1.Tokenization.stringifyNumber(props.port) : void 0, preferredBackupWindow: props.preferredBackupWindow, preferredMaintenanceWindow: props.preferredMaintenanceWindow, processorFeatures: props.processorFeatures && renderProcessorFeatures(props.processorFeatures), publiclyAccessible: props.publiclyAccessible ?? (this.vpcPlacement && this.vpcPlacement.subnetType === ec2.SubnetType.PUBLIC), storageType, storageThroughput: props.storageThroughput, vpcSecurityGroups: securityGroups.map((s) => s.securityGroupId), maxAllocatedStorage: props.maxAllocatedStorage, domain: this.domainId, domainIamRoleName: this.domainRole?.roleName, networkType: props.networkType };
      }
      setLogRetention() {
        if (this.cloudwatchLogsExports && this.cloudwatchLogsRetention)
          for (const log of this.cloudwatchLogsExports)
            new logs.LogRetention(this, `LogRetention${log}`, { logGroupName: `/aws/rds/instance/${this.instanceIdentifier}/${log}`, retention: this.cloudwatchLogsRetention, role: this.cloudwatchLogsRetentionRole });
      }
    };
    var DatabaseInstanceSource = class extends DatabaseInstanceNew {
      constructor(scope, id, props) {
        super(scope, id, props), this.singleUserRotationApplication = props.engine.singleUserRotationApplication, this.multiUserRotationApplication = props.engine.multiUserRotationApplication, this.engine = props.engine;
        const engineType = props.engine.engineType, combineRoles = engineType.startsWith("oracle-") || engineType.startsWith("sqlserver-");
        let { s3ImportRole, s3ExportRole } = (0, util_1.setupS3ImportExport)(this, props, combineRoles);
        const engineConfig = props.engine.bindToInstance(this, { ...props, s3ImportRole, s3ExportRole }), instanceAssociatedRoles = [], engineFeatures = engineConfig.features;
        if (s3ImportRole) {
          if (!engineFeatures?.s3Import)
            throw new Error(`Engine '${(0, util_1.engineDescription)(props.engine)}' does not support S3 import`);
          instanceAssociatedRoles.push({ roleArn: s3ImportRole.roleArn, featureName: engineFeatures?.s3Import });
        }
        if (s3ExportRole) {
          if (!engineFeatures?.s3Export)
            throw new Error(`Engine '${(0, util_1.engineDescription)(props.engine)}' does not support S3 export`);
          engineFeatures.s3Import !== engineFeatures?.s3Export && instanceAssociatedRoles.push({ roleArn: s3ExportRole.roleArn, featureName: engineFeatures?.s3Export });
        }
        if (this.instanceType = props.instanceType ?? ec2.InstanceType.of(ec2.InstanceClass.M5, ec2.InstanceSize.LARGE), props.parameterGroup && props.parameters)
          throw new Error("You cannot specify both parameterGroup and parameters");
        const dbParameterGroupName = props.parameters ? new parameter_group_1.ParameterGroup(this, "ParameterGroup", { engine: props.engine, parameters: props.parameters }).bindToInstance({}).parameterGroupName : this.newCfnProps.dbParameterGroupName;
        this.sourceCfnProps = { ...this.newCfnProps, associatedRoles: instanceAssociatedRoles.length > 0 ? instanceAssociatedRoles : void 0, optionGroupName: engineConfig.optionGroup?.optionGroupName, allocatedStorage: props.allocatedStorage?.toString() ?? "100", allowMajorVersionUpgrade: props.allowMajorVersionUpgrade, dbName: props.databaseName, engine: engineType, engineVersion: props.engine.engineVersion?.fullVersion, licenseModel: props.licenseModel, timezone: props.timezone, dbParameterGroupName };
      }
      addRotationSingleUser(options = {}) {
        if (!this.secret)
          throw new Error("Cannot add single user rotation for an instance without secret.");
        const id = "RotationSingleUser";
        if (this.node.tryFindChild(id))
          throw new Error("A single user rotation was already added to this instance.");
        return new secretsmanager.SecretRotation(this, id, { ...(0, util_1.applyDefaultRotationOptions)(options, this.vpcPlacement), secret: this.secret, application: this.singleUserRotationApplication, vpc: this.vpc, target: this });
      }
      addRotationMultiUser(id, options) {
        if (!this.secret)
          throw new Error("Cannot add multi user rotation for an instance without secret.");
        return new secretsmanager.SecretRotation(this, id, { ...(0, util_1.applyDefaultRotationOptions)(options, this.vpcPlacement), secret: options.secret, masterSecret: this.secret, application: this.multiUserRotationApplication, vpc: this.vpc, target: this });
      }
      grantConnect(grantee, dbUser) {
        if (!dbUser) {
          if (!this.secret)
            throw new Error("A secret or dbUser is required to grantConnect()");
          dbUser = this.secret.secretValueFromJson("username").toString();
        }
        return super.grantConnect(grantee, dbUser);
      }
    };
    var DatabaseInstance = class _DatabaseInstance extends DatabaseInstanceSource {
      constructor(scope, id, props) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_DatabaseInstanceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _DatabaseInstance), error;
        }
        const credentials = (0, util_1.renderCredentials)(this, props.engine, props.credentials), secret = credentials.secret, instance = new rds_generated_1.CfnDBInstance(this, "Resource", { ...this.sourceCfnProps, characterSetName: props.characterSetName, kmsKeyId: props.storageEncryptionKey && props.storageEncryptionKey.keyArn, masterUsername: credentials.username, masterUserPassword: credentials.password?.unsafeUnwrap(), storageEncrypted: props.storageEncryptionKey ? true : props.storageEncrypted });
        this.instanceIdentifier = this.getResourceNameAttribute(instance.ref), this.dbInstanceEndpointAddress = instance.attrEndpointAddress, this.dbInstanceEndpointPort = instance.attrEndpointPort, this.instanceResourceId = instance.attrDbiResourceId;
        const portAttribute = core_1.Token.asNumber(instance.attrEndpointPort);
        this.instanceEndpoint = new endpoint_1.Endpoint(instance.attrEndpointAddress, portAttribute), instance.applyRemovalPolicy(props.removalPolicy ?? core_1.RemovalPolicy.SNAPSHOT), secret && (this.secret = secret.attach(this)), this.setLogRetention();
      }
    };
    _b = JSII_RTTI_SYMBOL_1, DatabaseInstance[_b] = { fqn: "aws-cdk-lib.aws_rds.DatabaseInstance", version: "2.80.0" }, exports2.DatabaseInstance = DatabaseInstance;
    var DatabaseInstanceFromSnapshot = class _DatabaseInstanceFromSnapshot extends DatabaseInstanceSource {
      constructor(scope, id, props) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_DatabaseInstanceFromSnapshotProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _DatabaseInstanceFromSnapshot), error;
        }
        let credentials = props.credentials, secret = credentials?.secret;
        if (!secret && credentials?.generatePassword) {
          if (!credentials.username)
            throw new Error("`credentials` `username` must be specified when `generatePassword` is set to true");
          secret = new database_secret_1.DatabaseSecret(this, "Secret", { username: credentials.username, encryptionKey: credentials.encryptionKey, excludeCharacters: credentials.excludeCharacters, replaceOnPasswordCriteriaChanges: credentials.replaceOnPasswordCriteriaChanges, replicaRegions: credentials.replicaRegions });
        }
        const instance = new rds_generated_1.CfnDBInstance(this, "Resource", { ...this.sourceCfnProps, dbSnapshotIdentifier: props.snapshotIdentifier, masterUserPassword: secret?.secretValueFromJson("password")?.unsafeUnwrap() ?? credentials?.password?.unsafeUnwrap() });
        this.instanceIdentifier = instance.ref, this.dbInstanceEndpointAddress = instance.attrEndpointAddress, this.dbInstanceEndpointPort = instance.attrEndpointPort, this.instanceResourceId = instance.attrDbiResourceId;
        const portAttribute = core_1.Token.asNumber(instance.attrEndpointPort);
        this.instanceEndpoint = new endpoint_1.Endpoint(instance.attrEndpointAddress, portAttribute), instance.applyRemovalPolicy(props.removalPolicy ?? core_1.RemovalPolicy.SNAPSHOT), secret && (this.secret = secret.attach(this)), this.setLogRetention();
      }
    };
    _c = JSII_RTTI_SYMBOL_1, DatabaseInstanceFromSnapshot[_c] = { fqn: "aws-cdk-lib.aws_rds.DatabaseInstanceFromSnapshot", version: "2.80.0" }, exports2.DatabaseInstanceFromSnapshot = DatabaseInstanceFromSnapshot;
    var DatabaseInstanceReadReplica = class _DatabaseInstanceReadReplica extends DatabaseInstanceNew {
      constructor(scope, id, props) {
        super(scope, id, props), this.engine = void 0;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_DatabaseInstanceReadReplicaProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _DatabaseInstanceReadReplica), error;
        }
        if (props.sourceDatabaseInstance.engine && !props.sourceDatabaseInstance.engine.supportsReadReplicaBackups && props.backupRetention)
          throw new Error(`Cannot set 'backupRetention', as engine '${(0, util_1.engineDescription)(props.sourceDatabaseInstance.engine)}' does not support automatic backups for read replicas`);
        const shouldPassEngine = props.domain != null, instance = new rds_generated_1.CfnDBInstance(this, "Resource", { ...this.newCfnProps, sourceDbInstanceIdentifier: props.sourceDatabaseInstance.instanceArn, kmsKeyId: props.storageEncryptionKey?.keyArn, storageEncrypted: props.storageEncryptionKey ? true : props.storageEncrypted, engine: shouldPassEngine ? props.sourceDatabaseInstance.engine?.engineType : void 0 });
        this.instanceType = props.instanceType, this.instanceIdentifier = instance.ref, this.dbInstanceEndpointAddress = instance.attrEndpointAddress, this.dbInstanceEndpointPort = instance.attrEndpointPort, this.instanceResourceId = instance.attrDbInstanceArn;
        const portAttribute = core_1.Token.asNumber(instance.attrEndpointPort);
        this.instanceEndpoint = new endpoint_1.Endpoint(instance.attrEndpointAddress, portAttribute), instance.applyRemovalPolicy(props.removalPolicy ?? core_1.RemovalPolicy.SNAPSHOT), this.setLogRetention();
      }
    };
    _d = JSII_RTTI_SYMBOL_1, DatabaseInstanceReadReplica[_d] = { fqn: "aws-cdk-lib.aws_rds.DatabaseInstanceReadReplica", version: "2.80.0" }, exports2.DatabaseInstanceReadReplica = DatabaseInstanceReadReplica;
    function renderProcessorFeatures(features) {
      const featuresList = Object.entries(features).map(([name, value]) => ({ name, value: value.toString() }));
      return featuresList.length === 0 ? void 0 : featuresList;
    }
    function defaultIops(storageType, iops) {
      switch (storageType) {
        case StorageType.STANDARD:
        case StorageType.GP2:
          return;
        case StorageType.GP3:
          return iops;
        case StorageType.IO1:
          return iops ?? 1e3;
      }
    }
  }
});

// node_modules/aws-cdk-lib/aws-rds/lib/perms.js
var require_perms5 = __commonJS({
  "node_modules/aws-cdk-lib/aws-rds/lib/perms.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DATA_API_ACTIONS = void 0, exports2.DATA_API_ACTIONS = ["rds-data:BatchExecuteStatement", "rds-data:BeginTransaction", "rds-data:CommitTransaction", "rds-data:ExecuteStatement", "rds-data:RollbackTransaction"];
  }
});

// node_modules/aws-cdk-lib/aws-rds/lib/serverless-cluster.js
var require_serverless_cluster = __commonJS({
  "node_modules/aws-cdk-lib/aws-rds/lib/serverless-cluster.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ServerlessClusterFromSnapshot = exports2.ServerlessCluster = exports2.AuroraCapacityUnit = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var database_secret_1 = require_database_secret();
    var endpoint_1 = require_endpoint();
    var perms_1 = require_perms5();
    var util_1 = require_util16();
    var rds_generated_1 = require_rds_generated();
    var subnet_group_1 = require_subnet_group();
    var ec2 = require_aws_ec2();
    var iam = require_aws_iam();
    var secretsmanager = require_aws_secretsmanager();
    var core_1 = require_core2();
    var cxapi = require_cx_api();
    var AuroraCapacityUnit;
    (function(AuroraCapacityUnit2) {
      AuroraCapacityUnit2[AuroraCapacityUnit2.ACU_1 = 1] = "ACU_1", AuroraCapacityUnit2[AuroraCapacityUnit2.ACU_2 = 2] = "ACU_2", AuroraCapacityUnit2[AuroraCapacityUnit2.ACU_4 = 4] = "ACU_4", AuroraCapacityUnit2[AuroraCapacityUnit2.ACU_8 = 8] = "ACU_8", AuroraCapacityUnit2[AuroraCapacityUnit2.ACU_16 = 16] = "ACU_16", AuroraCapacityUnit2[AuroraCapacityUnit2.ACU_32 = 32] = "ACU_32", AuroraCapacityUnit2[AuroraCapacityUnit2.ACU_64 = 64] = "ACU_64", AuroraCapacityUnit2[AuroraCapacityUnit2.ACU_128 = 128] = "ACU_128", AuroraCapacityUnit2[AuroraCapacityUnit2.ACU_192 = 192] = "ACU_192", AuroraCapacityUnit2[AuroraCapacityUnit2.ACU_256 = 256] = "ACU_256", AuroraCapacityUnit2[AuroraCapacityUnit2.ACU_384 = 384] = "ACU_384";
    })(AuroraCapacityUnit = exports2.AuroraCapacityUnit || (exports2.AuroraCapacityUnit = {}));
    var ServerlessClusterBase = class extends core_1.Resource {
      get clusterArn() {
        return core_1.Stack.of(this).formatArn({ service: "rds", resource: "cluster", arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME, resourceName: this.clusterIdentifier });
      }
      grantDataApiAccess(grantee) {
        if (this.enableDataApi === false)
          throw new Error("Cannot grant Data API access when the Data API is disabled");
        this.enableDataApi = true;
        const ret = iam.Grant.addToPrincipal({ grantee, actions: perms_1.DATA_API_ACTIONS, resourceArns: ["*"], scope: this });
        return this.secret?.grantRead(grantee), ret;
      }
      asSecretAttachmentTarget() {
        return { targetId: this.clusterIdentifier, targetType: secretsmanager.AttachmentTargetType.RDS_DB_CLUSTER };
      }
    };
    var ServerlessClusterNew = class extends ServerlessClusterBase {
      constructor(scope, id, props) {
        if (super(scope, id), props.vpc === void 0) {
          if (props.vpcSubnets !== void 0)
            throw new Error("A VPC is required to use vpcSubnets in ServerlessCluster. Please add a VPC or remove vpcSubnets");
          if (props.subnetGroup !== void 0)
            throw new Error("A VPC is required to use subnetGroup in ServerlessCluster. Please add a VPC or remove subnetGroup");
          if (props.securityGroups !== void 0)
            throw new Error("A VPC is required to use securityGroups in ServerlessCluster. Please add a VPC or remove securityGroups");
        }
        let subnetGroup = props.subnetGroup;
        if (this.securityGroups = props.securityGroups ?? [], props.vpc !== void 0) {
          const { subnetIds } = props.vpc.selectSubnets(props.vpcSubnets);
          subnetIds.length < 2 && core_1.Annotations.of(this).addError(`Cluster requires at least 2 subnets, got ${subnetIds.length}`), subnetGroup = props.subnetGroup ?? new subnet_group_1.SubnetGroup(this, "Subnets", { description: `Subnets for ${id} database`, vpc: props.vpc, vpcSubnets: props.vpcSubnets, removalPolicy: props.removalPolicy === core_1.RemovalPolicy.RETAIN ? props.removalPolicy : void 0 }), this.securityGroups = props.securityGroups ?? [new ec2.SecurityGroup(this, "SecurityGroup", { description: "RDS security group", vpc: props.vpc })];
        }
        if (props.backupRetention) {
          const backupRetentionDays = props.backupRetention.toDays();
          if (backupRetentionDays < 1 || backupRetentionDays > 35)
            throw new Error(`backup retention period must be between 1 and 35 days. received: ${backupRetentionDays}`);
        }
        const clusterEngineBindConfig = props.engine.bindToCluster(this, { parameterGroup: props.parameterGroup }), clusterParameterGroupConfig = (props.parameterGroup ?? clusterEngineBindConfig.parameterGroup)?.bindToCluster({}), clusterIdentifier = core_1.FeatureFlags.of(this).isEnabled(cxapi.RDS_LOWERCASE_DB_IDENTIFIER) ? props.clusterIdentifier?.toLowerCase() : props.clusterIdentifier;
        this.newCfnProps = { backupRetentionPeriod: props.backupRetention?.toDays(), databaseName: props.defaultDatabaseName, dbClusterIdentifier: clusterIdentifier, dbClusterParameterGroupName: clusterParameterGroupConfig?.parameterGroupName, dbSubnetGroupName: subnetGroup?.subnetGroupName, deletionProtection: (0, util_1.defaultDeletionProtection)(props.deletionProtection, props.removalPolicy), engine: props.engine.engineType, engineVersion: props.engine.engineVersion?.fullVersion, engineMode: "serverless", enableHttpEndpoint: core_1.Lazy.any({ produce: () => this.enableDataApi }), scalingConfiguration: props.scaling ? this.renderScalingConfiguration(props.scaling) : void 0, storageEncrypted: true, vpcSecurityGroupIds: this.securityGroups.map((sg) => sg.securityGroupId), copyTagsToSnapshot: props.copyTagsToSnapshot ?? true }, this.connections = new ec2.Connections({ securityGroups: this.securityGroups, defaultPort: ec2.Port.tcp(core_1.Lazy.number({ produce: () => this.clusterEndpoint.port })) });
      }
      renderScalingConfiguration(options) {
        const minCapacity = options.minCapacity, maxCapacity = options.maxCapacity;
        if (minCapacity && maxCapacity && minCapacity > maxCapacity)
          throw new Error("maximum capacity must be greater than or equal to minimum capacity.");
        const secondsToAutoPause = options.autoPause?.toSeconds();
        if (secondsToAutoPause && (secondsToAutoPause < 300 || secondsToAutoPause > 86400))
          throw new Error("auto pause time must be between 5 minutes and 1 day.");
        return { autoPause: secondsToAutoPause !== 0, minCapacity: options.minCapacity, maxCapacity: options.maxCapacity, secondsUntilAutoPause: secondsToAutoPause === 0 ? void 0 : secondsToAutoPause };
      }
    };
    var ServerlessCluster = class _ServerlessCluster extends ServerlessClusterNew {
      static fromServerlessClusterAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_ServerlessClusterAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromServerlessClusterAttributes), error;
        }
        return new ImportedServerlessCluster(scope, id, attrs);
      }
      constructor(scope, id, props) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_ServerlessClusterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ServerlessCluster), error;
        }
        this.vpc = props.vpc, this.vpcSubnets = props.vpcSubnets, this.singleUserRotationApplication = props.engine.singleUserRotationApplication, this.multiUserRotationApplication = props.engine.multiUserRotationApplication, this.enableDataApi = props.enableDataApi;
        const credentials = (0, util_1.renderCredentials)(this, props.engine, props.credentials), secret = credentials.secret, cluster = new rds_generated_1.CfnDBCluster(this, "Resource", { ...this.newCfnProps, masterUsername: credentials.username, masterUserPassword: credentials.password?.unsafeUnwrap(), kmsKeyId: props.storageEncryptionKey?.keyArn });
        this.clusterIdentifier = cluster.ref;
        const portAttribute = core_1.Token.asNumber(cluster.attrEndpointPort);
        this.clusterEndpoint = new endpoint_1.Endpoint(cluster.attrEndpointAddress, portAttribute), this.clusterReadEndpoint = new endpoint_1.Endpoint(cluster.attrReadEndpointAddress, portAttribute), cluster.applyRemovalPolicy(props.removalPolicy ?? core_1.RemovalPolicy.SNAPSHOT), secret && (this.secret = secret.attach(this));
      }
      addRotationSingleUser(options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_RotationSingleUserOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addRotationSingleUser), error;
        }
        if (!this.secret)
          throw new Error("Cannot add single user rotation for a cluster without secret.");
        if (this.vpc === void 0)
          throw new Error("Cannot add single user rotation for a cluster without VPC.");
        const id = "RotationSingleUser";
        if (this.node.tryFindChild(id))
          throw new Error("A single user rotation was already added to this cluster.");
        return new secretsmanager.SecretRotation(this, id, { ...(0, util_1.applyDefaultRotationOptions)(options, this.vpcSubnets), secret: this.secret, application: this.singleUserRotationApplication, vpc: this.vpc, target: this });
      }
      addRotationMultiUser(id, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_RotationMultiUserOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addRotationMultiUser), error;
        }
        if (!this.secret)
          throw new Error("Cannot add multi user rotation for a cluster without secret.");
        if (this.vpc === void 0)
          throw new Error("Cannot add multi user rotation for a cluster without VPC.");
        return new secretsmanager.SecretRotation(this, id, { ...(0, util_1.applyDefaultRotationOptions)(options, this.vpcSubnets), secret: options.secret, masterSecret: this.secret, application: this.multiUserRotationApplication, vpc: this.vpc, target: this });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ServerlessCluster[_a] = { fqn: "aws-cdk-lib.aws_rds.ServerlessCluster", version: "2.80.0" }, exports2.ServerlessCluster = ServerlessCluster;
    var ImportedServerlessCluster = class extends ServerlessClusterBase {
      constructor(scope, id, attrs) {
        super(scope, id), this.enableDataApi = true, this.clusterIdentifier = attrs.clusterIdentifier;
        const defaultPort = attrs.port ? ec2.Port.tcp(attrs.port) : void 0;
        this.connections = new ec2.Connections({ securityGroups: attrs.securityGroups, defaultPort }), this.secret = attrs.secret, this._clusterEndpoint = attrs.clusterEndpointAddress && attrs.port ? new endpoint_1.Endpoint(attrs.clusterEndpointAddress, attrs.port) : void 0, this._clusterReadEndpoint = attrs.readerEndpointAddress && attrs.port ? new endpoint_1.Endpoint(attrs.readerEndpointAddress, attrs.port) : void 0;
      }
      get clusterEndpoint() {
        if (!this._clusterEndpoint)
          throw new Error("Cannot access `clusterEndpoint` of an imported cluster without an endpoint address and port");
        return this._clusterEndpoint;
      }
      get clusterReadEndpoint() {
        if (!this._clusterReadEndpoint)
          throw new Error("Cannot access `clusterReadEndpoint` of an imported cluster without a readerEndpointAddress and port");
        return this._clusterReadEndpoint;
      }
    };
    var ServerlessClusterFromSnapshot = class _ServerlessClusterFromSnapshot extends ServerlessClusterNew {
      constructor(scope, id, props) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_ServerlessClusterFromSnapshotProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ServerlessClusterFromSnapshot), error;
        }
        this.enableDataApi = props.enableDataApi;
        let credentials = props.credentials, secret = credentials?.secret;
        if (!secret && credentials?.generatePassword) {
          if (!credentials.username)
            throw new Error("`credentials` `username` must be specified when `generatePassword` is set to true");
          secret = new database_secret_1.DatabaseSecret(this, "Secret", { username: credentials.username, encryptionKey: credentials.encryptionKey, excludeCharacters: credentials.excludeCharacters, replaceOnPasswordCriteriaChanges: credentials.replaceOnPasswordCriteriaChanges, replicaRegions: credentials.replicaRegions });
        }
        const cluster = new rds_generated_1.CfnDBCluster(this, "Resource", { ...this.newCfnProps, snapshotIdentifier: props.snapshotIdentifier, masterUserPassword: secret?.secretValueFromJson("password")?.unsafeUnwrap() ?? credentials?.password?.unsafeUnwrap() });
        this.clusterIdentifier = cluster.ref;
        const portAttribute = core_1.Token.asNumber(cluster.attrEndpointPort);
        this.clusterEndpoint = new endpoint_1.Endpoint(cluster.attrEndpointAddress, portAttribute), this.clusterReadEndpoint = new endpoint_1.Endpoint(cluster.attrReadEndpointAddress, portAttribute), cluster.applyRemovalPolicy(props.removalPolicy ?? core_1.RemovalPolicy.SNAPSHOT), secret && (this.secret = secret.attach(this));
      }
    };
    _b = JSII_RTTI_SYMBOL_1, ServerlessClusterFromSnapshot[_b] = { fqn: "aws-cdk-lib.aws_rds.ServerlessClusterFromSnapshot", version: "2.80.0" }, exports2.ServerlessClusterFromSnapshot = ServerlessClusterFromSnapshot;
  }
});

// node_modules/aws-cdk-lib/aws-rds/lib/rds-augmentations.generated.js
var require_rds_augmentations_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-rds/lib/rds-augmentations.generated.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var cloudwatch = require_aws_cloudwatch();
    var cluster_1 = require_cluster();
    cluster_1.DatabaseClusterBase.prototype.metric = function(metricName, props) {
      return new cloudwatch.Metric({ namespace: "AWS/RDS", metricName, dimensionsMap: { DBClusterIdentifier: this.clusterIdentifier }, ...props }).attachTo(this);
    }, cluster_1.DatabaseClusterBase.prototype.metricCPUUtilization = function(props) {
      return this.metric("CPUUtilization", { statistic: "Average", ...props });
    }, cluster_1.DatabaseClusterBase.prototype.metricDatabaseConnections = function(props) {
      return this.metric("DatabaseConnections", { statistic: "Average", ...props });
    }, cluster_1.DatabaseClusterBase.prototype.metricDeadlocks = function(props) {
      return this.metric("Deadlocks", { statistic: "Average", ...props });
    }, cluster_1.DatabaseClusterBase.prototype.metricEngineUptime = function(props) {
      return this.metric("EngineUptime", { statistic: "Average", ...props });
    }, cluster_1.DatabaseClusterBase.prototype.metricFreeableMemory = function(props) {
      return this.metric("FreeableMemory", { statistic: "Average", ...props });
    }, cluster_1.DatabaseClusterBase.prototype.metricFreeLocalStorage = function(props) {
      return this.metric("FreeLocalStorage", { statistic: "Average", ...props });
    }, cluster_1.DatabaseClusterBase.prototype.metricNetworkReceiveThroughput = function(props) {
      return this.metric("NetworkReceiveThroughput", { statistic: "Average", ...props });
    }, cluster_1.DatabaseClusterBase.prototype.metricNetworkThroughput = function(props) {
      return this.metric("NetworkThroughput", { statistic: "Average", ...props });
    }, cluster_1.DatabaseClusterBase.prototype.metricNetworkTransmitThroughput = function(props) {
      return this.metric("NetworkTransmitThroughput", { statistic: "Average", ...props });
    }, cluster_1.DatabaseClusterBase.prototype.metricSnapshotStorageUsed = function(props) {
      return this.metric("SnapshotStorageUsed", { statistic: "Average", ...props });
    }, cluster_1.DatabaseClusterBase.prototype.metricTotalBackupStorageBilled = function(props) {
      return this.metric("TotalBackupStorageBilled", { statistic: "Average", ...props });
    }, cluster_1.DatabaseClusterBase.prototype.metricVolumeBytesUsed = function(props) {
      return this.metric("VolumeBytesUsed", { statistic: "Average", ...props });
    }, cluster_1.DatabaseClusterBase.prototype.metricVolumeReadIOPs = function(props) {
      return this.metric("VolumeReadIOPs", { statistic: "Average", ...props });
    }, cluster_1.DatabaseClusterBase.prototype.metricVolumeWriteIOPs = function(props) {
      return this.metric("VolumeWriteIOPs", { statistic: "Average", ...props });
    };
    var instance_1 = require_instance2();
    instance_1.DatabaseInstanceBase.prototype.metric = function(metricName, props) {
      return new cloudwatch.Metric({ namespace: "AWS/RDS", metricName, dimensionsMap: { DBInstanceIdentifier: this.instanceIdentifier }, ...props }).attachTo(this);
    }, instance_1.DatabaseInstanceBase.prototype.metricCPUUtilization = function(props) {
      return this.metric("CPUUtilization", { statistic: "Average", ...props });
    }, instance_1.DatabaseInstanceBase.prototype.metricDatabaseConnections = function(props) {
      return this.metric("DatabaseConnections", { statistic: "Average", ...props });
    }, instance_1.DatabaseInstanceBase.prototype.metricFreeStorageSpace = function(props) {
      return this.metric("FreeStorageSpace", { statistic: "Average", ...props });
    }, instance_1.DatabaseInstanceBase.prototype.metricFreeableMemory = function(props) {
      return this.metric("FreeableMemory", { statistic: "Average", ...props });
    }, instance_1.DatabaseInstanceBase.prototype.metricWriteIOPS = function(props) {
      return this.metric("WriteIOPS", { statistic: "Average", ...props });
    }, instance_1.DatabaseInstanceBase.prototype.metricReadIOPS = function(props) {
      return this.metric("ReadIOPS", { statistic: "Average", ...props });
    };
  }
});

// node_modules/aws-cdk-lib/aws-rds/lib/index.js
var require_lib60 = __commonJS({
  "node_modules/aws-cdk-lib/aws-rds/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_engine(), exports2), __exportStar(require_engine_version(), exports2), __exportStar(require_cluster(), exports2), __exportStar(require_cluster_ref(), exports2), __exportStar(require_cluster_engine(), exports2), __exportStar(require_instance_engine(), exports2), __exportStar(require_props(), exports2), __exportStar(require_parameter_group(), exports2), __exportStar(require_database_secret(), exports2), __exportStar(require_endpoint(), exports2), __exportStar(require_option_group(), exports2), __exportStar(require_instance2(), exports2), __exportStar(require_proxy(), exports2), __exportStar(require_serverless_cluster(), exports2), __exportStar(require_subnet_group(), exports2), __exportStar(require_rds_generated(), exports2), require_rds_augmentations_generated();
  }
});

// node_modules/aws-cdk-lib/aws-rds/index.js
var require_aws_rds = __commonJS({
  "node_modules/aws-cdk-lib/aws-rds/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib60(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-backup/lib/backupable-resources-collector.js
var require_backupable_resources_collector = __commonJS({
  "node_modules/aws-cdk-lib/aws-backup/lib/backupable-resources-collector.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.BackupableResourcesCollector = void 0;
    var dynamodb = require_aws_dynamodb();
    var ec2 = require_aws_ec2();
    var efs = require_aws_efs();
    var rds = require_aws_rds();
    var core_1 = require_core2();
    var BackupableResourcesCollector = class {
      constructor() {
        this.resources = [];
      }
      visit(node) {
        node instanceof efs.CfnFileSystem && this.resources.push(core_1.Stack.of(node).formatArn({ service: "elasticfilesystem", resource: "file-system", resourceName: node.ref })), node instanceof dynamodb.CfnTable && this.resources.push(core_1.Stack.of(node).formatArn({ service: "dynamodb", resource: "table", resourceName: node.ref })), node instanceof ec2.CfnInstance && this.resources.push(core_1.Stack.of(node).formatArn({ service: "ec2", resource: "instance", resourceName: node.ref })), node instanceof ec2.CfnVolume && this.resources.push(core_1.Stack.of(node).formatArn({ service: "ec2", resource: "volume", resourceName: node.ref })), node instanceof rds.CfnDBInstance && (node.dbClusterIdentifier || this.resources.push(core_1.Stack.of(node).formatArn({ service: "rds", resource: "db", arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME, resourceName: node.ref }))), node instanceof rds.CfnDBCluster && this.resources.push(core_1.Stack.of(node).formatArn({ service: "rds", resource: "cluster", arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME, resourceName: node.ref }));
      }
    };
    exports2.BackupableResourcesCollector = BackupableResourcesCollector;
  }
});

// node_modules/aws-cdk-lib/aws-backup/lib/resource.js
var require_resource3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-backup/lib/resource.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.BackupResource = exports2.TagOperation = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core_1 = require_core2();
    var TagOperation;
    (function(TagOperation2) {
      TagOperation2.STRING_EQUALS = "STRINGEQUALS", TagOperation2.DUMMY = "dummy";
    })(TagOperation = exports2.TagOperation || (exports2.TagOperation = {}));
    var BackupResource = class _BackupResource {
      static fromConstruct(construct) {
        return new _BackupResource(void 0, void 0, construct);
      }
      static fromDynamoDbTable(table) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_dynamodb_ITable(table);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromDynamoDbTable), error;
        }
        return _BackupResource.fromArn(table.tableArn);
      }
      static fromEc2Instance(instance) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_IInstance(instance);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromEc2Instance), error;
        }
        return _BackupResource.fromArn(core_1.Stack.of(instance).formatArn({ service: "ec2", resource: "instance", resourceName: instance.instanceId }));
      }
      static fromEfsFileSystem(fileSystem) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_efs_IFileSystem(fileSystem);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromEfsFileSystem), error;
        }
        return _BackupResource.fromArn(core_1.Stack.of(fileSystem).formatArn({ service: "elasticfilesystem", resource: "file-system", resourceName: fileSystem.fileSystemId }));
      }
      static fromRdsDatabaseInstance(instance) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_IDatabaseInstance(instance);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromRdsDatabaseInstance), error;
        }
        return _BackupResource.fromArn(instance.instanceArn);
      }
      static fromRdsDatabaseCluster(cluster) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_IDatabaseCluster(cluster);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromRdsDatabaseCluster), error;
        }
        const stack = core_1.Stack.of(cluster);
        return _BackupResource.fromArn(`arn:${stack.partition}:rds:${stack.region}:${stack.account}:cluster:${cluster.clusterIdentifier}`);
      }
      static fromRdsServerlessCluster(cluster) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rds_IServerlessCluster(cluster);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromRdsServerlessCluster), error;
        }
        return _BackupResource.fromArn(cluster.clusterArn);
      }
      static fromArn(arn) {
        return new _BackupResource(arn);
      }
      static fromTag(key, value, operation) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_backup_TagOperation(operation);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromTag), error;
        }
        return new _BackupResource(void 0, { key, value, operation });
      }
      constructor(resource, tagCondition, construct) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_backup_TagCondition(tagCondition);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _BackupResource), error;
        }
        this.resource = resource, this.tagCondition = tagCondition, this.construct = construct;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, BackupResource[_a] = { fqn: "aws-cdk-lib.aws_backup.BackupResource", version: "2.80.0" }, exports2.BackupResource = BackupResource;
  }
});

// node_modules/aws-cdk-lib/aws-backup/lib/selection.js
var require_selection = __commonJS({
  "node_modules/aws-cdk-lib/aws-backup/lib/selection.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.BackupSelection = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var backup_generated_1 = require_backup_generated();
    var backupable_resources_collector_1 = require_backupable_resources_collector();
    var resource_1 = require_resource3();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var BackupSelection = class _BackupSelection extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id), this.listOfTags = [], this.resources = [], this.backupableResourcesCollector = new backupable_resources_collector_1.BackupableResourcesCollector();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_backup_BackupSelectionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _BackupSelection), error;
        }
        const role = props.role || new iam.Role(this, "Role", { assumedBy: new iam.ServicePrincipal("backup.amazonaws.com") });
        role.addManagedPolicy(iam.ManagedPolicy.fromAwsManagedPolicyName("service-role/AWSBackupServiceRolePolicyForBackup")), props.allowRestores && role.addManagedPolicy(iam.ManagedPolicy.fromAwsManagedPolicyName("service-role/AWSBackupServiceRolePolicyForRestores")), this.grantPrincipal = role;
        const selection = new backup_generated_1.CfnBackupSelection(this, "Resource", { backupPlanId: props.backupPlan.backupPlanId, backupSelection: { iamRoleArn: role.roleArn, selectionName: props.backupSelectionName || this.node.id, listOfTags: core_1.Lazy.any({ produce: () => this.listOfTags }, { omitEmptyArray: true }), resources: core_1.Lazy.list({ produce: () => [...this.resources, ...this.backupableResourcesCollector.resources] }, { omitEmpty: true }) } });
        this.backupPlanId = selection.attrBackupPlanId, this.selectionId = selection.attrSelectionId;
        for (const resource of props.resources)
          this.addResource(resource);
      }
      addResource(resource) {
        resource.tagCondition && this.listOfTags.push({ conditionKey: resource.tagCondition.key, conditionType: resource.tagCondition.operation || resource_1.TagOperation.STRING_EQUALS, conditionValue: resource.tagCondition.value }), resource.resource && this.resources.push(resource.resource), resource.construct && core_1.Aspects.of(resource.construct).add(this.backupableResourcesCollector);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, BackupSelection[_a] = { fqn: "aws-cdk-lib.aws_backup.BackupSelection", version: "2.80.0" }, exports2.BackupSelection = BackupSelection;
  }
});

// node_modules/aws-cdk-lib/aws-backup/lib/plan.js
var require_plan = __commonJS({
  "node_modules/aws-cdk-lib/aws-backup/lib/plan.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.BackupPlan = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var backup_generated_1 = require_backup_generated();
    var rule_1 = require_rule3();
    var selection_1 = require_selection();
    var vault_1 = require_vault();
    var core_1 = require_core2();
    var BackupPlan = class _BackupPlan extends core_1.Resource {
      static fromBackupPlanId(scope, id, backupPlanId) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.backupPlanId = backupPlanId;
          }
        }
        return new Import(scope, id);
      }
      static daily35DayRetention(scope, id, backupVault) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_backup_IBackupVault(backupVault);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.daily35DayRetention), error;
        }
        const plan = new _BackupPlan(scope, id, { backupVault });
        return plan.addRule(rule_1.BackupPlanRule.daily()), plan;
      }
      static dailyMonthly1YearRetention(scope, id, backupVault) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_backup_IBackupVault(backupVault);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.dailyMonthly1YearRetention), error;
        }
        const plan = new _BackupPlan(scope, id, { backupVault });
        return plan.addRule(rule_1.BackupPlanRule.daily()), plan.addRule(rule_1.BackupPlanRule.monthly1Year()), plan;
      }
      static dailyWeeklyMonthly5YearRetention(scope, id, backupVault) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_backup_IBackupVault(backupVault);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.dailyWeeklyMonthly5YearRetention), error;
        }
        const plan = new _BackupPlan(scope, id, { backupVault });
        return plan.addRule(rule_1.BackupPlanRule.daily()), plan.addRule(rule_1.BackupPlanRule.weekly()), plan.addRule(rule_1.BackupPlanRule.monthly5Year()), plan;
      }
      static dailyWeeklyMonthly7YearRetention(scope, id, backupVault) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_backup_IBackupVault(backupVault);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.dailyWeeklyMonthly7YearRetention), error;
        }
        const plan = new _BackupPlan(scope, id, { backupVault });
        return plan.addRule(rule_1.BackupPlanRule.daily()), plan.addRule(rule_1.BackupPlanRule.weekly()), plan.addRule(rule_1.BackupPlanRule.monthly7Year()), plan;
      }
      constructor(scope, id, props = {}) {
        super(scope, id), this.rules = [];
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_backup_BackupPlanProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _BackupPlan), error;
        }
        const plan = new backup_generated_1.CfnBackupPlan(this, "Resource", { backupPlan: { advancedBackupSettings: this.advancedBackupSettings(props), backupPlanName: props.backupPlanName || id, backupPlanRule: core_1.Lazy.any({ produce: () => this.rules }, { omitEmptyArray: true }) } });
        this.backupPlanId = plan.attrBackupPlanId, this.backupPlanArn = plan.attrBackupPlanArn, this.versionId = plan.attrVersionId, this._backupVault = props.backupVault;
        for (const rule of props.backupPlanRules || [])
          this.addRule(rule);
        this.node.addValidation({ validate: () => this.validatePlan() });
      }
      advancedBackupSettings(props) {
        if (props.windowsVss)
          return [{ backupOptions: { WindowsVSS: "enabled" }, resourceType: "EC2" }];
      }
      addRule(rule) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_backup_BackupPlanRule(rule);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addRule), error;
        }
        let vault;
        rule.props.backupVault ? vault = rule.props.backupVault : this._backupVault ? vault = this._backupVault : (this._backupVault = new vault_1.BackupVault(this, "Vault"), vault = this._backupVault), this.rules.push({ completionWindowMinutes: rule.props.completionWindow?.toMinutes(), lifecycle: (rule.props.deleteAfter || rule.props.moveToColdStorageAfter) && { deleteAfterDays: rule.props.deleteAfter?.toDays(), moveToColdStorageAfterDays: rule.props.moveToColdStorageAfter?.toDays() }, ruleName: rule.props.ruleName ?? `${this.node.id}Rule${this.rules.length}`, scheduleExpression: rule.props.scheduleExpression?.expressionString, startWindowMinutes: rule.props.startWindow?.toMinutes(), enableContinuousBackup: rule.props.enableContinuousBackup, targetBackupVault: vault.backupVaultName, copyActions: rule.props.copyActions?.map(this.planCopyActions) });
      }
      planCopyActions(props) {
        return { destinationBackupVaultArn: props.destinationBackupVault.backupVaultArn, lifecycle: (props.deleteAfter || props.moveToColdStorageAfter) && { deleteAfterDays: props.deleteAfter?.toDays(), moveToColdStorageAfterDays: props.moveToColdStorageAfter?.toDays() } };
      }
      get backupVault() {
        if (!this._backupVault)
          throw new Error("No backup vault!");
        return this._backupVault;
      }
      addSelection(id, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_backup_BackupSelectionOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addSelection), error;
        }
        return new selection_1.BackupSelection(this, id, { backupPlan: this, ...options });
      }
      validatePlan() {
        return this.rules.length === 0 ? ["A backup plan must have at least 1 rule."] : [];
      }
    };
    _a = JSII_RTTI_SYMBOL_1, BackupPlan[_a] = { fqn: "aws-cdk-lib.aws_backup.BackupPlan", version: "2.80.0" }, exports2.BackupPlan = BackupPlan;
  }
});

// node_modules/aws-cdk-lib/aws-backup/lib/index.js
var require_lib61 = __commonJS({
  "node_modules/aws-cdk-lib/aws-backup/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_vault(), exports2), __exportStar(require_plan(), exports2), __exportStar(require_rule3(), exports2), __exportStar(require_selection(), exports2), __exportStar(require_resource3(), exports2), __exportStar(require_backup_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-backup/index.js
var require_aws_backup = __commonJS({
  "node_modules/aws-cdk-lib/aws-backup/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib61(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-backupgateway/lib/backupgateway.generated.js
var require_backupgateway_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-backupgateway/lib/backupgateway.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnHypervisor = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnHypervisorPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("host", cdk.validateString)(properties.host)), errors.collect(cdk.propertyValidator("kmsKeyArn", cdk.validateString)(properties.kmsKeyArn)), errors.collect(cdk.propertyValidator("logGroupArn", cdk.validateString)(properties.logGroupArn)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("password", cdk.validateString)(properties.password)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("username", cdk.validateString)(properties.username)), errors.wrap('supplied properties not correct for "CfnHypervisorProps"');
    }
    function cfnHypervisorPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHypervisorPropsValidator(properties).assertSuccess(), { Host: cdk.stringToCloudFormation(properties.host), KmsKeyArn: cdk.stringToCloudFormation(properties.kmsKeyArn), LogGroupArn: cdk.stringToCloudFormation(properties.logGroupArn), Name: cdk.stringToCloudFormation(properties.name), Password: cdk.stringToCloudFormation(properties.password), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), Username: cdk.stringToCloudFormation(properties.username) }) : properties;
    }
    function CfnHypervisorPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("host", "Host", properties.Host != null ? cfn_parse.FromCloudFormation.getString(properties.Host) : void 0), ret.addPropertyResult("kmsKeyArn", "KmsKeyArn", properties.KmsKeyArn != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyArn) : void 0), ret.addPropertyResult("logGroupArn", "LogGroupArn", properties.LogGroupArn != null ? cfn_parse.FromCloudFormation.getString(properties.LogGroupArn) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("password", "Password", properties.Password != null ? cfn_parse.FromCloudFormation.getString(properties.Password) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("username", "Username", properties.Username != null ? cfn_parse.FromCloudFormation.getString(properties.Username) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnHypervisor = class _CfnHypervisor extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnHypervisorPropsFromCloudFormation(resourceProperties), ret = new _CfnHypervisor(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnHypervisor.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_backupgateway_CfnHypervisorProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnHypervisor), error;
        }
        this.attrHypervisorArn = cdk.Token.asString(this.getAtt("HypervisorArn", cdk.ResolutionTypeHint.STRING)), this.host = props.host, this.kmsKeyArn = props.kmsKeyArn, this.logGroupArn = props.logGroupArn, this.name = props.name, this.password = props.password, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::BackupGateway::Hypervisor", props.tags, { tagPropertyName: "tags" }), this.username = props.username;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnHypervisor.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { host: this.host, kmsKeyArn: this.kmsKeyArn, logGroupArn: this.logGroupArn, name: this.name, password: this.password, tags: this.tags.renderTags(), username: this.username };
      }
      renderProperties(props) {
        return cfnHypervisorPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnHypervisor[_a] = { fqn: "aws-cdk-lib.aws_backupgateway.CfnHypervisor", version: "2.80.0" }, CfnHypervisor.CFN_RESOURCE_TYPE_NAME = "AWS::BackupGateway::Hypervisor", exports2.CfnHypervisor = CfnHypervisor;
  }
});

// node_modules/aws-cdk-lib/aws-backupgateway/lib/index.js
var require_lib62 = __commonJS({
  "node_modules/aws-cdk-lib/aws-backupgateway/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_backupgateway_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-backupgateway/index.js
var require_aws_backupgateway = __commonJS({
  "node_modules/aws-cdk-lib/aws-backupgateway/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib62(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-batch/lib/batch.generated.js
var require_batch_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-batch/lib/batch.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnSchedulingPolicy = exports2.CfnJobQueue = exports2.CfnJobDefinition = exports2.CfnComputeEnvironment = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnComputeEnvironmentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computeEnvironmentName", cdk.validateString)(properties.computeEnvironmentName)), errors.collect(cdk.propertyValidator("computeResources", CfnComputeEnvironment_ComputeResourcesPropertyValidator)(properties.computeResources)), errors.collect(cdk.propertyValidator("eksConfiguration", CfnComputeEnvironment_EksConfigurationPropertyValidator)(properties.eksConfiguration)), errors.collect(cdk.propertyValidator("replaceComputeEnvironment", cdk.validateBoolean)(properties.replaceComputeEnvironment)), errors.collect(cdk.propertyValidator("serviceRole", cdk.validateString)(properties.serviceRole)), errors.collect(cdk.propertyValidator("state", cdk.validateString)(properties.state)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("unmanagedvCpus", cdk.validateNumber)(properties.unmanagedvCpus)), errors.collect(cdk.propertyValidator("updatePolicy", CfnComputeEnvironment_UpdatePolicyPropertyValidator)(properties.updatePolicy)), errors.wrap('supplied properties not correct for "CfnComputeEnvironmentProps"');
    }
    function cfnComputeEnvironmentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComputeEnvironmentPropsValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type), ComputeEnvironmentName: cdk.stringToCloudFormation(properties.computeEnvironmentName), ComputeResources: cfnComputeEnvironmentComputeResourcesPropertyToCloudFormation(properties.computeResources), EksConfiguration: cfnComputeEnvironmentEksConfigurationPropertyToCloudFormation(properties.eksConfiguration), ReplaceComputeEnvironment: cdk.booleanToCloudFormation(properties.replaceComputeEnvironment), ServiceRole: cdk.stringToCloudFormation(properties.serviceRole), State: cdk.stringToCloudFormation(properties.state), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags), UnmanagedvCpus: cdk.numberToCloudFormation(properties.unmanagedvCpus), UpdatePolicy: cfnComputeEnvironmentUpdatePolicyPropertyToCloudFormation(properties.updatePolicy) }) : properties;
    }
    function CfnComputeEnvironmentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("computeEnvironmentName", "ComputeEnvironmentName", properties.ComputeEnvironmentName != null ? cfn_parse.FromCloudFormation.getString(properties.ComputeEnvironmentName) : void 0), ret.addPropertyResult("computeResources", "ComputeResources", properties.ComputeResources != null ? CfnComputeEnvironmentComputeResourcesPropertyFromCloudFormation(properties.ComputeResources) : void 0), ret.addPropertyResult("eksConfiguration", "EksConfiguration", properties.EksConfiguration != null ? CfnComputeEnvironmentEksConfigurationPropertyFromCloudFormation(properties.EksConfiguration) : void 0), ret.addPropertyResult("replaceComputeEnvironment", "ReplaceComputeEnvironment", properties.ReplaceComputeEnvironment != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ReplaceComputeEnvironment) : void 0), ret.addPropertyResult("serviceRole", "ServiceRole", properties.ServiceRole != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceRole) : void 0), ret.addPropertyResult("state", "State", properties.State != null ? cfn_parse.FromCloudFormation.getString(properties.State) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addPropertyResult("unmanagedvCpus", "UnmanagedvCpus", properties.UnmanagedvCpus != null ? cfn_parse.FromCloudFormation.getNumber(properties.UnmanagedvCpus) : void 0), ret.addPropertyResult("updatePolicy", "UpdatePolicy", properties.UpdatePolicy != null ? CfnComputeEnvironmentUpdatePolicyPropertyFromCloudFormation(properties.UpdatePolicy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnComputeEnvironment = class _CfnComputeEnvironment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnComputeEnvironmentPropsFromCloudFormation(resourceProperties), ret = new _CfnComputeEnvironment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnComputeEnvironment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_batch_CfnComputeEnvironmentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnComputeEnvironment), error;
        }
        cdk.requireProperty(props, "type", this), this.attrComputeEnvironmentArn = cdk.Token.asString(this.getAtt("ComputeEnvironmentArn", cdk.ResolutionTypeHint.STRING)), this.type = props.type, this.computeEnvironmentName = props.computeEnvironmentName, this.computeResources = props.computeResources, this.eksConfiguration = props.eksConfiguration, this.replaceComputeEnvironment = props.replaceComputeEnvironment, this.serviceRole = props.serviceRole, this.state = props.state, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Batch::ComputeEnvironment", props.tags, { tagPropertyName: "tags" }), this.unmanagedvCpus = props.unmanagedvCpus, this.updatePolicy = props.updatePolicy;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnComputeEnvironment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { type: this.type, computeEnvironmentName: this.computeEnvironmentName, computeResources: this.computeResources, eksConfiguration: this.eksConfiguration, replaceComputeEnvironment: this.replaceComputeEnvironment, serviceRole: this.serviceRole, state: this.state, tags: this.tags.renderTags(), unmanagedvCpus: this.unmanagedvCpus, updatePolicy: this.updatePolicy };
      }
      renderProperties(props) {
        return cfnComputeEnvironmentPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnComputeEnvironment[_a] = { fqn: "aws-cdk-lib.aws_batch.CfnComputeEnvironment", version: "2.80.0" }, CfnComputeEnvironment.CFN_RESOURCE_TYPE_NAME = "AWS::Batch::ComputeEnvironment", exports2.CfnComputeEnvironment = CfnComputeEnvironment;
    function CfnComputeEnvironment_ComputeResourcesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allocationStrategy", cdk.validateString)(properties.allocationStrategy)), errors.collect(cdk.propertyValidator("bidPercentage", cdk.validateNumber)(properties.bidPercentage)), errors.collect(cdk.propertyValidator("desiredvCpus", cdk.validateNumber)(properties.desiredvCpus)), errors.collect(cdk.propertyValidator("ec2Configuration", cdk.listValidator(CfnComputeEnvironment_Ec2ConfigurationObjectPropertyValidator))(properties.ec2Configuration)), errors.collect(cdk.propertyValidator("ec2KeyPair", cdk.validateString)(properties.ec2KeyPair)), errors.collect(cdk.propertyValidator("imageId", cdk.validateString)(properties.imageId)), errors.collect(cdk.propertyValidator("instanceRole", cdk.validateString)(properties.instanceRole)), errors.collect(cdk.propertyValidator("instanceTypes", cdk.listValidator(cdk.validateString))(properties.instanceTypes)), errors.collect(cdk.propertyValidator("launchTemplate", CfnComputeEnvironment_LaunchTemplateSpecificationPropertyValidator)(properties.launchTemplate)), errors.collect(cdk.propertyValidator("maxvCpus", cdk.requiredValidator)(properties.maxvCpus)), errors.collect(cdk.propertyValidator("maxvCpus", cdk.validateNumber)(properties.maxvCpus)), errors.collect(cdk.propertyValidator("minvCpus", cdk.validateNumber)(properties.minvCpus)), errors.collect(cdk.propertyValidator("placementGroup", cdk.validateString)(properties.placementGroup)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("spotIamFleetRole", cdk.validateString)(properties.spotIamFleetRole)), errors.collect(cdk.propertyValidator("subnets", cdk.requiredValidator)(properties.subnets)), errors.collect(cdk.propertyValidator("subnets", cdk.listValidator(cdk.validateString))(properties.subnets)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("updateToLatestImageVersion", cdk.validateBoolean)(properties.updateToLatestImageVersion)), errors.wrap('supplied properties not correct for "ComputeResourcesProperty"');
    }
    function cfnComputeEnvironmentComputeResourcesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComputeEnvironment_ComputeResourcesPropertyValidator(properties).assertSuccess(), { AllocationStrategy: cdk.stringToCloudFormation(properties.allocationStrategy), BidPercentage: cdk.numberToCloudFormation(properties.bidPercentage), DesiredvCpus: cdk.numberToCloudFormation(properties.desiredvCpus), Ec2Configuration: cdk.listMapper(cfnComputeEnvironmentEc2ConfigurationObjectPropertyToCloudFormation)(properties.ec2Configuration), Ec2KeyPair: cdk.stringToCloudFormation(properties.ec2KeyPair), ImageId: cdk.stringToCloudFormation(properties.imageId), InstanceRole: cdk.stringToCloudFormation(properties.instanceRole), InstanceTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.instanceTypes), LaunchTemplate: cfnComputeEnvironmentLaunchTemplateSpecificationPropertyToCloudFormation(properties.launchTemplate), MaxvCpus: cdk.numberToCloudFormation(properties.maxvCpus), MinvCpus: cdk.numberToCloudFormation(properties.minvCpus), PlacementGroup: cdk.stringToCloudFormation(properties.placementGroup), SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SpotIamFleetRole: cdk.stringToCloudFormation(properties.spotIamFleetRole), Subnets: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnets), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags), Type: cdk.stringToCloudFormation(properties.type), UpdateToLatestImageVersion: cdk.booleanToCloudFormation(properties.updateToLatestImageVersion) }) : properties;
    }
    function CfnComputeEnvironmentComputeResourcesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allocationStrategy", "AllocationStrategy", properties.AllocationStrategy != null ? cfn_parse.FromCloudFormation.getString(properties.AllocationStrategy) : void 0), ret.addPropertyResult("bidPercentage", "BidPercentage", properties.BidPercentage != null ? cfn_parse.FromCloudFormation.getNumber(properties.BidPercentage) : void 0), ret.addPropertyResult("desiredvCpus", "DesiredvCpus", properties.DesiredvCpus != null ? cfn_parse.FromCloudFormation.getNumber(properties.DesiredvCpus) : void 0), ret.addPropertyResult("ec2Configuration", "Ec2Configuration", properties.Ec2Configuration != null ? cfn_parse.FromCloudFormation.getArray(CfnComputeEnvironmentEc2ConfigurationObjectPropertyFromCloudFormation)(properties.Ec2Configuration) : void 0), ret.addPropertyResult("ec2KeyPair", "Ec2KeyPair", properties.Ec2KeyPair != null ? cfn_parse.FromCloudFormation.getString(properties.Ec2KeyPair) : void 0), ret.addPropertyResult("imageId", "ImageId", properties.ImageId != null ? cfn_parse.FromCloudFormation.getString(properties.ImageId) : void 0), ret.addPropertyResult("instanceRole", "InstanceRole", properties.InstanceRole != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceRole) : void 0), ret.addPropertyResult("instanceTypes", "InstanceTypes", properties.InstanceTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.InstanceTypes) : void 0), ret.addPropertyResult("launchTemplate", "LaunchTemplate", properties.LaunchTemplate != null ? CfnComputeEnvironmentLaunchTemplateSpecificationPropertyFromCloudFormation(properties.LaunchTemplate) : void 0), ret.addPropertyResult("maxvCpus", "MaxvCpus", cfn_parse.FromCloudFormation.getNumber(properties.MaxvCpus)), ret.addPropertyResult("minvCpus", "MinvCpus", properties.MinvCpus != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinvCpus) : void 0), ret.addPropertyResult("placementGroup", "PlacementGroup", properties.PlacementGroup != null ? cfn_parse.FromCloudFormation.getString(properties.PlacementGroup) : void 0), ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("spotIamFleetRole", "SpotIamFleetRole", properties.SpotIamFleetRole != null ? cfn_parse.FromCloudFormation.getString(properties.SpotIamFleetRole) : void 0), ret.addPropertyResult("subnets", "Subnets", cfn_parse.FromCloudFormation.getStringArray(properties.Subnets)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("updateToLatestImageVersion", "UpdateToLatestImageVersion", properties.UpdateToLatestImageVersion != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UpdateToLatestImageVersion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComputeEnvironment_Ec2ConfigurationObjectPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("imageIdOverride", cdk.validateString)(properties.imageIdOverride)), errors.collect(cdk.propertyValidator("imageKubernetesVersion", cdk.validateString)(properties.imageKubernetesVersion)), errors.collect(cdk.propertyValidator("imageType", cdk.requiredValidator)(properties.imageType)), errors.collect(cdk.propertyValidator("imageType", cdk.validateString)(properties.imageType)), errors.wrap('supplied properties not correct for "Ec2ConfigurationObjectProperty"');
    }
    function cfnComputeEnvironmentEc2ConfigurationObjectPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComputeEnvironment_Ec2ConfigurationObjectPropertyValidator(properties).assertSuccess(), { ImageIdOverride: cdk.stringToCloudFormation(properties.imageIdOverride), ImageKubernetesVersion: cdk.stringToCloudFormation(properties.imageKubernetesVersion), ImageType: cdk.stringToCloudFormation(properties.imageType) }) : properties;
    }
    function CfnComputeEnvironmentEc2ConfigurationObjectPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("imageIdOverride", "ImageIdOverride", properties.ImageIdOverride != null ? cfn_parse.FromCloudFormation.getString(properties.ImageIdOverride) : void 0), ret.addPropertyResult("imageKubernetesVersion", "ImageKubernetesVersion", properties.ImageKubernetesVersion != null ? cfn_parse.FromCloudFormation.getString(properties.ImageKubernetesVersion) : void 0), ret.addPropertyResult("imageType", "ImageType", cfn_parse.FromCloudFormation.getString(properties.ImageType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComputeEnvironment_EksConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("eksClusterArn", cdk.requiredValidator)(properties.eksClusterArn)), errors.collect(cdk.propertyValidator("eksClusterArn", cdk.validateString)(properties.eksClusterArn)), errors.collect(cdk.propertyValidator("kubernetesNamespace", cdk.requiredValidator)(properties.kubernetesNamespace)), errors.collect(cdk.propertyValidator("kubernetesNamespace", cdk.validateString)(properties.kubernetesNamespace)), errors.wrap('supplied properties not correct for "EksConfigurationProperty"');
    }
    function cfnComputeEnvironmentEksConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComputeEnvironment_EksConfigurationPropertyValidator(properties).assertSuccess(), { EksClusterArn: cdk.stringToCloudFormation(properties.eksClusterArn), KubernetesNamespace: cdk.stringToCloudFormation(properties.kubernetesNamespace) }) : properties;
    }
    function CfnComputeEnvironmentEksConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("eksClusterArn", "EksClusterArn", cfn_parse.FromCloudFormation.getString(properties.EksClusterArn)), ret.addPropertyResult("kubernetesNamespace", "KubernetesNamespace", cfn_parse.FromCloudFormation.getString(properties.KubernetesNamespace)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComputeEnvironment_LaunchTemplateSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("launchTemplateId", cdk.validateString)(properties.launchTemplateId)), errors.collect(cdk.propertyValidator("launchTemplateName", cdk.validateString)(properties.launchTemplateName)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "LaunchTemplateSpecificationProperty"');
    }
    function cfnComputeEnvironmentLaunchTemplateSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComputeEnvironment_LaunchTemplateSpecificationPropertyValidator(properties).assertSuccess(), { LaunchTemplateId: cdk.stringToCloudFormation(properties.launchTemplateId), LaunchTemplateName: cdk.stringToCloudFormation(properties.launchTemplateName), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnComputeEnvironmentLaunchTemplateSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("launchTemplateId", "LaunchTemplateId", properties.LaunchTemplateId != null ? cfn_parse.FromCloudFormation.getString(properties.LaunchTemplateId) : void 0), ret.addPropertyResult("launchTemplateName", "LaunchTemplateName", properties.LaunchTemplateName != null ? cfn_parse.FromCloudFormation.getString(properties.LaunchTemplateName) : void 0), ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getString(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComputeEnvironment_UpdatePolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("jobExecutionTimeoutMinutes", cdk.validateNumber)(properties.jobExecutionTimeoutMinutes)), errors.collect(cdk.propertyValidator("terminateJobsOnUpdate", cdk.validateBoolean)(properties.terminateJobsOnUpdate)), errors.wrap('supplied properties not correct for "UpdatePolicyProperty"');
    }
    function cfnComputeEnvironmentUpdatePolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComputeEnvironment_UpdatePolicyPropertyValidator(properties).assertSuccess(), { JobExecutionTimeoutMinutes: cdk.numberToCloudFormation(properties.jobExecutionTimeoutMinutes), TerminateJobsOnUpdate: cdk.booleanToCloudFormation(properties.terminateJobsOnUpdate) }) : properties;
    }
    function CfnComputeEnvironmentUpdatePolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("jobExecutionTimeoutMinutes", "JobExecutionTimeoutMinutes", properties.JobExecutionTimeoutMinutes != null ? cfn_parse.FromCloudFormation.getNumber(properties.JobExecutionTimeoutMinutes) : void 0), ret.addPropertyResult("terminateJobsOnUpdate", "TerminateJobsOnUpdate", properties.TerminateJobsOnUpdate != null ? cfn_parse.FromCloudFormation.getBoolean(properties.TerminateJobsOnUpdate) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinitionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containerProperties", CfnJobDefinition_ContainerPropertiesPropertyValidator)(properties.containerProperties)), errors.collect(cdk.propertyValidator("eksProperties", CfnJobDefinition_EksPropertiesPropertyValidator)(properties.eksProperties)), errors.collect(cdk.propertyValidator("jobDefinitionName", cdk.validateString)(properties.jobDefinitionName)), errors.collect(cdk.propertyValidator("nodeProperties", CfnJobDefinition_NodePropertiesPropertyValidator)(properties.nodeProperties)), errors.collect(cdk.propertyValidator("parameters", cdk.validateObject)(properties.parameters)), errors.collect(cdk.propertyValidator("platformCapabilities", cdk.listValidator(cdk.validateString))(properties.platformCapabilities)), errors.collect(cdk.propertyValidator("propagateTags", cdk.validateBoolean)(properties.propagateTags)), errors.collect(cdk.propertyValidator("retryStrategy", CfnJobDefinition_RetryStrategyPropertyValidator)(properties.retryStrategy)), errors.collect(cdk.propertyValidator("schedulingPriority", cdk.validateNumber)(properties.schedulingPriority)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.collect(cdk.propertyValidator("timeout", CfnJobDefinition_TimeoutPropertyValidator)(properties.timeout)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnJobDefinitionProps"');
    }
    function cfnJobDefinitionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinitionPropsValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type), ContainerProperties: cfnJobDefinitionContainerPropertiesPropertyToCloudFormation(properties.containerProperties), EksProperties: cfnJobDefinitionEksPropertiesPropertyToCloudFormation(properties.eksProperties), JobDefinitionName: cdk.stringToCloudFormation(properties.jobDefinitionName), NodeProperties: cfnJobDefinitionNodePropertiesPropertyToCloudFormation(properties.nodeProperties), Parameters: cdk.objectToCloudFormation(properties.parameters), PlatformCapabilities: cdk.listMapper(cdk.stringToCloudFormation)(properties.platformCapabilities), PropagateTags: cdk.booleanToCloudFormation(properties.propagateTags), RetryStrategy: cfnJobDefinitionRetryStrategyPropertyToCloudFormation(properties.retryStrategy), SchedulingPriority: cdk.numberToCloudFormation(properties.schedulingPriority), Tags: cdk.objectToCloudFormation(properties.tags), Timeout: cfnJobDefinitionTimeoutPropertyToCloudFormation(properties.timeout) }) : properties;
    }
    function CfnJobDefinitionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("containerProperties", "ContainerProperties", properties.ContainerProperties != null ? CfnJobDefinitionContainerPropertiesPropertyFromCloudFormation(properties.ContainerProperties) : void 0), ret.addPropertyResult("eksProperties", "EksProperties", properties.EksProperties != null ? CfnJobDefinitionEksPropertiesPropertyFromCloudFormation(properties.EksProperties) : void 0), ret.addPropertyResult("jobDefinitionName", "JobDefinitionName", properties.JobDefinitionName != null ? cfn_parse.FromCloudFormation.getString(properties.JobDefinitionName) : void 0), ret.addPropertyResult("nodeProperties", "NodeProperties", properties.NodeProperties != null ? CfnJobDefinitionNodePropertiesPropertyFromCloudFormation(properties.NodeProperties) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getAny(properties.Parameters) : void 0), ret.addPropertyResult("platformCapabilities", "PlatformCapabilities", properties.PlatformCapabilities != null ? cfn_parse.FromCloudFormation.getStringArray(properties.PlatformCapabilities) : void 0), ret.addPropertyResult("propagateTags", "PropagateTags", properties.PropagateTags != null ? cfn_parse.FromCloudFormation.getBoolean(properties.PropagateTags) : void 0), ret.addPropertyResult("retryStrategy", "RetryStrategy", properties.RetryStrategy != null ? CfnJobDefinitionRetryStrategyPropertyFromCloudFormation(properties.RetryStrategy) : void 0), ret.addPropertyResult("schedulingPriority", "SchedulingPriority", properties.SchedulingPriority != null ? cfn_parse.FromCloudFormation.getNumber(properties.SchedulingPriority) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addPropertyResult("timeout", "Timeout", properties.Timeout != null ? CfnJobDefinitionTimeoutPropertyFromCloudFormation(properties.Timeout) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnJobDefinition = class _CfnJobDefinition extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnJobDefinitionPropsFromCloudFormation(resourceProperties), ret = new _CfnJobDefinition(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnJobDefinition.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_batch_CfnJobDefinitionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnJobDefinition), error;
        }
        cdk.requireProperty(props, "type", this), this.type = props.type, this.containerProperties = props.containerProperties, this.eksProperties = props.eksProperties, this.jobDefinitionName = props.jobDefinitionName, this.nodeProperties = props.nodeProperties, this.parameters = props.parameters, this.platformCapabilities = props.platformCapabilities, this.propagateTags = props.propagateTags, this.retryStrategy = props.retryStrategy, this.schedulingPriority = props.schedulingPriority, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Batch::JobDefinition", props.tags, { tagPropertyName: "tags" }), this.timeout = props.timeout;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnJobDefinition.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { type: this.type, containerProperties: this.containerProperties, eksProperties: this.eksProperties, jobDefinitionName: this.jobDefinitionName, nodeProperties: this.nodeProperties, parameters: this.parameters, platformCapabilities: this.platformCapabilities, propagateTags: this.propagateTags, retryStrategy: this.retryStrategy, schedulingPriority: this.schedulingPriority, tags: this.tags.renderTags(), timeout: this.timeout };
      }
      renderProperties(props) {
        return cfnJobDefinitionPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnJobDefinition[_b] = { fqn: "aws-cdk-lib.aws_batch.CfnJobDefinition", version: "2.80.0" }, CfnJobDefinition.CFN_RESOURCE_TYPE_NAME = "AWS::Batch::JobDefinition", exports2.CfnJobDefinition = CfnJobDefinition;
    function CfnJobDefinition_AuthorizationConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessPointId", cdk.validateString)(properties.accessPointId)), errors.collect(cdk.propertyValidator("iam", cdk.validateString)(properties.iam)), errors.wrap('supplied properties not correct for "AuthorizationConfigProperty"');
    }
    function cfnJobDefinitionAuthorizationConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_AuthorizationConfigPropertyValidator(properties).assertSuccess(), { AccessPointId: cdk.stringToCloudFormation(properties.accessPointId), Iam: cdk.stringToCloudFormation(properties.iam) }) : properties;
    }
    function CfnJobDefinitionAuthorizationConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessPointId", "AccessPointId", properties.AccessPointId != null ? cfn_parse.FromCloudFormation.getString(properties.AccessPointId) : void 0), ret.addPropertyResult("iam", "Iam", properties.Iam != null ? cfn_parse.FromCloudFormation.getString(properties.Iam) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_ContainerPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("command", cdk.listValidator(cdk.validateString))(properties.command)), errors.collect(cdk.propertyValidator("environment", cdk.listValidator(CfnJobDefinition_EnvironmentPropertyValidator))(properties.environment)), errors.collect(cdk.propertyValidator("ephemeralStorage", CfnJobDefinition_EphemeralStoragePropertyValidator)(properties.ephemeralStorage)), errors.collect(cdk.propertyValidator("executionRoleArn", cdk.validateString)(properties.executionRoleArn)), errors.collect(cdk.propertyValidator("fargatePlatformConfiguration", CfnJobDefinition_FargatePlatformConfigurationPropertyValidator)(properties.fargatePlatformConfiguration)), errors.collect(cdk.propertyValidator("image", cdk.requiredValidator)(properties.image)), errors.collect(cdk.propertyValidator("image", cdk.validateString)(properties.image)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("jobRoleArn", cdk.validateString)(properties.jobRoleArn)), errors.collect(cdk.propertyValidator("linuxParameters", CfnJobDefinition_LinuxParametersPropertyValidator)(properties.linuxParameters)), errors.collect(cdk.propertyValidator("logConfiguration", CfnJobDefinition_LogConfigurationPropertyValidator)(properties.logConfiguration)), errors.collect(cdk.propertyValidator("memory", cdk.validateNumber)(properties.memory)), errors.collect(cdk.propertyValidator("mountPoints", cdk.listValidator(CfnJobDefinition_MountPointsPropertyValidator))(properties.mountPoints)), errors.collect(cdk.propertyValidator("networkConfiguration", CfnJobDefinition_NetworkConfigurationPropertyValidator)(properties.networkConfiguration)), errors.collect(cdk.propertyValidator("privileged", cdk.validateBoolean)(properties.privileged)), errors.collect(cdk.propertyValidator("readonlyRootFilesystem", cdk.validateBoolean)(properties.readonlyRootFilesystem)), errors.collect(cdk.propertyValidator("resourceRequirements", cdk.listValidator(CfnJobDefinition_ResourceRequirementPropertyValidator))(properties.resourceRequirements)), errors.collect(cdk.propertyValidator("secrets", cdk.listValidator(CfnJobDefinition_SecretPropertyValidator))(properties.secrets)), errors.collect(cdk.propertyValidator("ulimits", cdk.listValidator(CfnJobDefinition_UlimitPropertyValidator))(properties.ulimits)), errors.collect(cdk.propertyValidator("user", cdk.validateString)(properties.user)), errors.collect(cdk.propertyValidator("vcpus", cdk.validateNumber)(properties.vcpus)), errors.collect(cdk.propertyValidator("volumes", cdk.listValidator(CfnJobDefinition_VolumesPropertyValidator))(properties.volumes)), errors.wrap('supplied properties not correct for "ContainerPropertiesProperty"');
    }
    function cfnJobDefinitionContainerPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_ContainerPropertiesPropertyValidator(properties).assertSuccess(), { Command: cdk.listMapper(cdk.stringToCloudFormation)(properties.command), Environment: cdk.listMapper(cfnJobDefinitionEnvironmentPropertyToCloudFormation)(properties.environment), EphemeralStorage: cfnJobDefinitionEphemeralStoragePropertyToCloudFormation(properties.ephemeralStorage), ExecutionRoleArn: cdk.stringToCloudFormation(properties.executionRoleArn), FargatePlatformConfiguration: cfnJobDefinitionFargatePlatformConfigurationPropertyToCloudFormation(properties.fargatePlatformConfiguration), Image: cdk.stringToCloudFormation(properties.image), InstanceType: cdk.stringToCloudFormation(properties.instanceType), JobRoleArn: cdk.stringToCloudFormation(properties.jobRoleArn), LinuxParameters: cfnJobDefinitionLinuxParametersPropertyToCloudFormation(properties.linuxParameters), LogConfiguration: cfnJobDefinitionLogConfigurationPropertyToCloudFormation(properties.logConfiguration), Memory: cdk.numberToCloudFormation(properties.memory), MountPoints: cdk.listMapper(cfnJobDefinitionMountPointsPropertyToCloudFormation)(properties.mountPoints), NetworkConfiguration: cfnJobDefinitionNetworkConfigurationPropertyToCloudFormation(properties.networkConfiguration), Privileged: cdk.booleanToCloudFormation(properties.privileged), ReadonlyRootFilesystem: cdk.booleanToCloudFormation(properties.readonlyRootFilesystem), ResourceRequirements: cdk.listMapper(cfnJobDefinitionResourceRequirementPropertyToCloudFormation)(properties.resourceRequirements), Secrets: cdk.listMapper(cfnJobDefinitionSecretPropertyToCloudFormation)(properties.secrets), Ulimits: cdk.listMapper(cfnJobDefinitionUlimitPropertyToCloudFormation)(properties.ulimits), User: cdk.stringToCloudFormation(properties.user), Vcpus: cdk.numberToCloudFormation(properties.vcpus), Volumes: cdk.listMapper(cfnJobDefinitionVolumesPropertyToCloudFormation)(properties.volumes) }) : properties;
    }
    function CfnJobDefinitionContainerPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("command", "Command", properties.Command != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Command) : void 0), ret.addPropertyResult("environment", "Environment", properties.Environment != null ? cfn_parse.FromCloudFormation.getArray(CfnJobDefinitionEnvironmentPropertyFromCloudFormation)(properties.Environment) : void 0), ret.addPropertyResult("ephemeralStorage", "EphemeralStorage", properties.EphemeralStorage != null ? CfnJobDefinitionEphemeralStoragePropertyFromCloudFormation(properties.EphemeralStorage) : void 0), ret.addPropertyResult("executionRoleArn", "ExecutionRoleArn", properties.ExecutionRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.ExecutionRoleArn) : void 0), ret.addPropertyResult("fargatePlatformConfiguration", "FargatePlatformConfiguration", properties.FargatePlatformConfiguration != null ? CfnJobDefinitionFargatePlatformConfigurationPropertyFromCloudFormation(properties.FargatePlatformConfiguration) : void 0), ret.addPropertyResult("image", "Image", cfn_parse.FromCloudFormation.getString(properties.Image)), ret.addPropertyResult("instanceType", "InstanceType", properties.InstanceType != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceType) : void 0), ret.addPropertyResult("jobRoleArn", "JobRoleArn", properties.JobRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.JobRoleArn) : void 0), ret.addPropertyResult("linuxParameters", "LinuxParameters", properties.LinuxParameters != null ? CfnJobDefinitionLinuxParametersPropertyFromCloudFormation(properties.LinuxParameters) : void 0), ret.addPropertyResult("logConfiguration", "LogConfiguration", properties.LogConfiguration != null ? CfnJobDefinitionLogConfigurationPropertyFromCloudFormation(properties.LogConfiguration) : void 0), ret.addPropertyResult("memory", "Memory", properties.Memory != null ? cfn_parse.FromCloudFormation.getNumber(properties.Memory) : void 0), ret.addPropertyResult("mountPoints", "MountPoints", properties.MountPoints != null ? cfn_parse.FromCloudFormation.getArray(CfnJobDefinitionMountPointsPropertyFromCloudFormation)(properties.MountPoints) : void 0), ret.addPropertyResult("networkConfiguration", "NetworkConfiguration", properties.NetworkConfiguration != null ? CfnJobDefinitionNetworkConfigurationPropertyFromCloudFormation(properties.NetworkConfiguration) : void 0), ret.addPropertyResult("privileged", "Privileged", properties.Privileged != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Privileged) : void 0), ret.addPropertyResult("readonlyRootFilesystem", "ReadonlyRootFilesystem", properties.ReadonlyRootFilesystem != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ReadonlyRootFilesystem) : void 0), ret.addPropertyResult("resourceRequirements", "ResourceRequirements", properties.ResourceRequirements != null ? cfn_parse.FromCloudFormation.getArray(CfnJobDefinitionResourceRequirementPropertyFromCloudFormation)(properties.ResourceRequirements) : void 0), ret.addPropertyResult("secrets", "Secrets", properties.Secrets != null ? cfn_parse.FromCloudFormation.getArray(CfnJobDefinitionSecretPropertyFromCloudFormation)(properties.Secrets) : void 0), ret.addPropertyResult("ulimits", "Ulimits", properties.Ulimits != null ? cfn_parse.FromCloudFormation.getArray(CfnJobDefinitionUlimitPropertyFromCloudFormation)(properties.Ulimits) : void 0), ret.addPropertyResult("user", "User", properties.User != null ? cfn_parse.FromCloudFormation.getString(properties.User) : void 0), ret.addPropertyResult("vcpus", "Vcpus", properties.Vcpus != null ? cfn_parse.FromCloudFormation.getNumber(properties.Vcpus) : void 0), ret.addPropertyResult("volumes", "Volumes", properties.Volumes != null ? cfn_parse.FromCloudFormation.getArray(CfnJobDefinitionVolumesPropertyFromCloudFormation)(properties.Volumes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_DevicePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containerPath", cdk.validateString)(properties.containerPath)), errors.collect(cdk.propertyValidator("hostPath", cdk.validateString)(properties.hostPath)), errors.collect(cdk.propertyValidator("permissions", cdk.listValidator(cdk.validateString))(properties.permissions)), errors.wrap('supplied properties not correct for "DeviceProperty"');
    }
    function cfnJobDefinitionDevicePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_DevicePropertyValidator(properties).assertSuccess(), { ContainerPath: cdk.stringToCloudFormation(properties.containerPath), HostPath: cdk.stringToCloudFormation(properties.hostPath), Permissions: cdk.listMapper(cdk.stringToCloudFormation)(properties.permissions) }) : properties;
    }
    function CfnJobDefinitionDevicePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containerPath", "ContainerPath", properties.ContainerPath != null ? cfn_parse.FromCloudFormation.getString(properties.ContainerPath) : void 0), ret.addPropertyResult("hostPath", "HostPath", properties.HostPath != null ? cfn_parse.FromCloudFormation.getString(properties.HostPath) : void 0), ret.addPropertyResult("permissions", "Permissions", properties.Permissions != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Permissions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_EfsVolumeConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authorizationConfig", CfnJobDefinition_AuthorizationConfigPropertyValidator)(properties.authorizationConfig)), errors.collect(cdk.propertyValidator("fileSystemId", cdk.requiredValidator)(properties.fileSystemId)), errors.collect(cdk.propertyValidator("fileSystemId", cdk.validateString)(properties.fileSystemId)), errors.collect(cdk.propertyValidator("rootDirectory", cdk.validateString)(properties.rootDirectory)), errors.collect(cdk.propertyValidator("transitEncryption", cdk.validateString)(properties.transitEncryption)), errors.collect(cdk.propertyValidator("transitEncryptionPort", cdk.validateNumber)(properties.transitEncryptionPort)), errors.wrap('supplied properties not correct for "EfsVolumeConfigurationProperty"');
    }
    function cfnJobDefinitionEfsVolumeConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_EfsVolumeConfigurationPropertyValidator(properties).assertSuccess(), { AuthorizationConfig: cfnJobDefinitionAuthorizationConfigPropertyToCloudFormation(properties.authorizationConfig), FileSystemId: cdk.stringToCloudFormation(properties.fileSystemId), RootDirectory: cdk.stringToCloudFormation(properties.rootDirectory), TransitEncryption: cdk.stringToCloudFormation(properties.transitEncryption), TransitEncryptionPort: cdk.numberToCloudFormation(properties.transitEncryptionPort) }) : properties;
    }
    function CfnJobDefinitionEfsVolumeConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authorizationConfig", "AuthorizationConfig", properties.AuthorizationConfig != null ? CfnJobDefinitionAuthorizationConfigPropertyFromCloudFormation(properties.AuthorizationConfig) : void 0), ret.addPropertyResult("fileSystemId", "FileSystemId", cfn_parse.FromCloudFormation.getString(properties.FileSystemId)), ret.addPropertyResult("rootDirectory", "RootDirectory", properties.RootDirectory != null ? cfn_parse.FromCloudFormation.getString(properties.RootDirectory) : void 0), ret.addPropertyResult("transitEncryption", "TransitEncryption", properties.TransitEncryption != null ? cfn_parse.FromCloudFormation.getString(properties.TransitEncryption) : void 0), ret.addPropertyResult("transitEncryptionPort", "TransitEncryptionPort", properties.TransitEncryptionPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.TransitEncryptionPort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_EksContainerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("args", cdk.listValidator(cdk.validateString))(properties.args)), errors.collect(cdk.propertyValidator("command", cdk.listValidator(cdk.validateString))(properties.command)), errors.collect(cdk.propertyValidator("env", cdk.listValidator(CfnJobDefinition_EksContainerEnvironmentVariablePropertyValidator))(properties.env)), errors.collect(cdk.propertyValidator("image", cdk.requiredValidator)(properties.image)), errors.collect(cdk.propertyValidator("image", cdk.validateString)(properties.image)), errors.collect(cdk.propertyValidator("imagePullPolicy", cdk.validateString)(properties.imagePullPolicy)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("resources", CfnJobDefinition_ResourcesPropertyValidator)(properties.resources)), errors.collect(cdk.propertyValidator("securityContext", CfnJobDefinition_SecurityContextPropertyValidator)(properties.securityContext)), errors.collect(cdk.propertyValidator("volumeMounts", cdk.listValidator(CfnJobDefinition_EksContainerVolumeMountPropertyValidator))(properties.volumeMounts)), errors.wrap('supplied properties not correct for "EksContainerProperty"');
    }
    function cfnJobDefinitionEksContainerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_EksContainerPropertyValidator(properties).assertSuccess(), { Args: cdk.listMapper(cdk.stringToCloudFormation)(properties.args), Command: cdk.listMapper(cdk.stringToCloudFormation)(properties.command), Env: cdk.listMapper(cfnJobDefinitionEksContainerEnvironmentVariablePropertyToCloudFormation)(properties.env), Image: cdk.stringToCloudFormation(properties.image), ImagePullPolicy: cdk.stringToCloudFormation(properties.imagePullPolicy), Name: cdk.stringToCloudFormation(properties.name), Resources: cfnJobDefinitionResourcesPropertyToCloudFormation(properties.resources), SecurityContext: cfnJobDefinitionSecurityContextPropertyToCloudFormation(properties.securityContext), VolumeMounts: cdk.listMapper(cfnJobDefinitionEksContainerVolumeMountPropertyToCloudFormation)(properties.volumeMounts) }) : properties;
    }
    function CfnJobDefinitionEksContainerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("args", "Args", properties.Args != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Args) : void 0), ret.addPropertyResult("command", "Command", properties.Command != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Command) : void 0), ret.addPropertyResult("env", "Env", properties.Env != null ? cfn_parse.FromCloudFormation.getArray(CfnJobDefinitionEksContainerEnvironmentVariablePropertyFromCloudFormation)(properties.Env) : void 0), ret.addPropertyResult("image", "Image", cfn_parse.FromCloudFormation.getString(properties.Image)), ret.addPropertyResult("imagePullPolicy", "ImagePullPolicy", properties.ImagePullPolicy != null ? cfn_parse.FromCloudFormation.getString(properties.ImagePullPolicy) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("resources", "Resources", properties.Resources != null ? CfnJobDefinitionResourcesPropertyFromCloudFormation(properties.Resources) : void 0), ret.addPropertyResult("securityContext", "SecurityContext", properties.SecurityContext != null ? CfnJobDefinitionSecurityContextPropertyFromCloudFormation(properties.SecurityContext) : void 0), ret.addPropertyResult("volumeMounts", "VolumeMounts", properties.VolumeMounts != null ? cfn_parse.FromCloudFormation.getArray(CfnJobDefinitionEksContainerVolumeMountPropertyFromCloudFormation)(properties.VolumeMounts) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_EksContainerEnvironmentVariablePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "EksContainerEnvironmentVariableProperty"');
    }
    function cfnJobDefinitionEksContainerEnvironmentVariablePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_EksContainerEnvironmentVariablePropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnJobDefinitionEksContainerEnvironmentVariablePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_EksContainerVolumeMountPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mountPath", cdk.validateString)(properties.mountPath)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("readOnly", cdk.validateBoolean)(properties.readOnly)), errors.wrap('supplied properties not correct for "EksContainerVolumeMountProperty"');
    }
    function cfnJobDefinitionEksContainerVolumeMountPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_EksContainerVolumeMountPropertyValidator(properties).assertSuccess(), { MountPath: cdk.stringToCloudFormation(properties.mountPath), Name: cdk.stringToCloudFormation(properties.name), ReadOnly: cdk.booleanToCloudFormation(properties.readOnly) }) : properties;
    }
    function CfnJobDefinitionEksContainerVolumeMountPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mountPath", "MountPath", properties.MountPath != null ? cfn_parse.FromCloudFormation.getString(properties.MountPath) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("readOnly", "ReadOnly", properties.ReadOnly != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ReadOnly) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_EksPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("podProperties", CfnJobDefinition_PodPropertiesPropertyValidator)(properties.podProperties)), errors.wrap('supplied properties not correct for "EksPropertiesProperty"');
    }
    function cfnJobDefinitionEksPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_EksPropertiesPropertyValidator(properties).assertSuccess(), { PodProperties: cfnJobDefinitionPodPropertiesPropertyToCloudFormation(properties.podProperties) }) : properties;
    }
    function CfnJobDefinitionEksPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("podProperties", "PodProperties", properties.PodProperties != null ? CfnJobDefinitionPodPropertiesPropertyFromCloudFormation(properties.PodProperties) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_EksSecretPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("optional", cdk.validateBoolean)(properties.optional)), errors.collect(cdk.propertyValidator("secretName", cdk.requiredValidator)(properties.secretName)), errors.collect(cdk.propertyValidator("secretName", cdk.validateString)(properties.secretName)), errors.wrap('supplied properties not correct for "EksSecretProperty"');
    }
    function cfnJobDefinitionEksSecretPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_EksSecretPropertyValidator(properties).assertSuccess(), { Optional: cdk.booleanToCloudFormation(properties.optional), SecretName: cdk.stringToCloudFormation(properties.secretName) }) : properties;
    }
    function CfnJobDefinitionEksSecretPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("optional", "Optional", properties.Optional != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Optional) : void 0), ret.addPropertyResult("secretName", "SecretName", cfn_parse.FromCloudFormation.getString(properties.SecretName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_EksVolumePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("emptyDir", CfnJobDefinition_EmptyDirPropertyValidator)(properties.emptyDir)), errors.collect(cdk.propertyValidator("hostPath", CfnJobDefinition_HostPathPropertyValidator)(properties.hostPath)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("secret", CfnJobDefinition_EksSecretPropertyValidator)(properties.secret)), errors.wrap('supplied properties not correct for "EksVolumeProperty"');
    }
    function cfnJobDefinitionEksVolumePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_EksVolumePropertyValidator(properties).assertSuccess(), { EmptyDir: cfnJobDefinitionEmptyDirPropertyToCloudFormation(properties.emptyDir), HostPath: cfnJobDefinitionHostPathPropertyToCloudFormation(properties.hostPath), Name: cdk.stringToCloudFormation(properties.name), Secret: cfnJobDefinitionEksSecretPropertyToCloudFormation(properties.secret) }) : properties;
    }
    function CfnJobDefinitionEksVolumePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("emptyDir", "EmptyDir", properties.EmptyDir != null ? CfnJobDefinitionEmptyDirPropertyFromCloudFormation(properties.EmptyDir) : void 0), ret.addPropertyResult("hostPath", "HostPath", properties.HostPath != null ? CfnJobDefinitionHostPathPropertyFromCloudFormation(properties.HostPath) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("secret", "Secret", properties.Secret != null ? CfnJobDefinitionEksSecretPropertyFromCloudFormation(properties.Secret) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_EmptyDirPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("medium", cdk.validateString)(properties.medium)), errors.collect(cdk.propertyValidator("sizeLimit", cdk.validateString)(properties.sizeLimit)), errors.wrap('supplied properties not correct for "EmptyDirProperty"');
    }
    function cfnJobDefinitionEmptyDirPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_EmptyDirPropertyValidator(properties).assertSuccess(), { Medium: cdk.stringToCloudFormation(properties.medium), SizeLimit: cdk.stringToCloudFormation(properties.sizeLimit) }) : properties;
    }
    function CfnJobDefinitionEmptyDirPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("medium", "Medium", properties.Medium != null ? cfn_parse.FromCloudFormation.getString(properties.Medium) : void 0), ret.addPropertyResult("sizeLimit", "SizeLimit", properties.SizeLimit != null ? cfn_parse.FromCloudFormation.getString(properties.SizeLimit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_EnvironmentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "EnvironmentProperty"');
    }
    function cfnJobDefinitionEnvironmentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_EnvironmentPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnJobDefinitionEnvironmentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_EphemeralStoragePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sizeInGiB", cdk.requiredValidator)(properties.sizeInGiB)), errors.collect(cdk.propertyValidator("sizeInGiB", cdk.validateNumber)(properties.sizeInGiB)), errors.wrap('supplied properties not correct for "EphemeralStorageProperty"');
    }
    function cfnJobDefinitionEphemeralStoragePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_EphemeralStoragePropertyValidator(properties).assertSuccess(), { SizeInGiB: cdk.numberToCloudFormation(properties.sizeInGiB) }) : properties;
    }
    function CfnJobDefinitionEphemeralStoragePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sizeInGiB", "SizeInGiB", cfn_parse.FromCloudFormation.getNumber(properties.SizeInGiB)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_EvaluateOnExitPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.requiredValidator)(properties.action)), errors.collect(cdk.propertyValidator("action", cdk.validateString)(properties.action)), errors.collect(cdk.propertyValidator("onExitCode", cdk.validateString)(properties.onExitCode)), errors.collect(cdk.propertyValidator("onReason", cdk.validateString)(properties.onReason)), errors.collect(cdk.propertyValidator("onStatusReason", cdk.validateString)(properties.onStatusReason)), errors.wrap('supplied properties not correct for "EvaluateOnExitProperty"');
    }
    function cfnJobDefinitionEvaluateOnExitPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_EvaluateOnExitPropertyValidator(properties).assertSuccess(), { Action: cdk.stringToCloudFormation(properties.action), OnExitCode: cdk.stringToCloudFormation(properties.onExitCode), OnReason: cdk.stringToCloudFormation(properties.onReason), OnStatusReason: cdk.stringToCloudFormation(properties.onStatusReason) }) : properties;
    }
    function CfnJobDefinitionEvaluateOnExitPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", cfn_parse.FromCloudFormation.getString(properties.Action)), ret.addPropertyResult("onExitCode", "OnExitCode", properties.OnExitCode != null ? cfn_parse.FromCloudFormation.getString(properties.OnExitCode) : void 0), ret.addPropertyResult("onReason", "OnReason", properties.OnReason != null ? cfn_parse.FromCloudFormation.getString(properties.OnReason) : void 0), ret.addPropertyResult("onStatusReason", "OnStatusReason", properties.OnStatusReason != null ? cfn_parse.FromCloudFormation.getString(properties.OnStatusReason) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_FargatePlatformConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("platformVersion", cdk.validateString)(properties.platformVersion)), errors.wrap('supplied properties not correct for "FargatePlatformConfigurationProperty"');
    }
    function cfnJobDefinitionFargatePlatformConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_FargatePlatformConfigurationPropertyValidator(properties).assertSuccess(), { PlatformVersion: cdk.stringToCloudFormation(properties.platformVersion) }) : properties;
    }
    function CfnJobDefinitionFargatePlatformConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("platformVersion", "PlatformVersion", properties.PlatformVersion != null ? cfn_parse.FromCloudFormation.getString(properties.PlatformVersion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_HostPathPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.wrap('supplied properties not correct for "HostPathProperty"');
    }
    function cfnJobDefinitionHostPathPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_HostPathPropertyValidator(properties).assertSuccess(), { Path: cdk.stringToCloudFormation(properties.path) }) : properties;
    }
    function CfnJobDefinitionHostPathPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("path", "Path", properties.Path != null ? cfn_parse.FromCloudFormation.getString(properties.Path) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_LinuxParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("devices", cdk.listValidator(CfnJobDefinition_DevicePropertyValidator))(properties.devices)), errors.collect(cdk.propertyValidator("initProcessEnabled", cdk.validateBoolean)(properties.initProcessEnabled)), errors.collect(cdk.propertyValidator("maxSwap", cdk.validateNumber)(properties.maxSwap)), errors.collect(cdk.propertyValidator("sharedMemorySize", cdk.validateNumber)(properties.sharedMemorySize)), errors.collect(cdk.propertyValidator("swappiness", cdk.validateNumber)(properties.swappiness)), errors.collect(cdk.propertyValidator("tmpfs", cdk.listValidator(CfnJobDefinition_TmpfsPropertyValidator))(properties.tmpfs)), errors.wrap('supplied properties not correct for "LinuxParametersProperty"');
    }
    function cfnJobDefinitionLinuxParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_LinuxParametersPropertyValidator(properties).assertSuccess(), { Devices: cdk.listMapper(cfnJobDefinitionDevicePropertyToCloudFormation)(properties.devices), InitProcessEnabled: cdk.booleanToCloudFormation(properties.initProcessEnabled), MaxSwap: cdk.numberToCloudFormation(properties.maxSwap), SharedMemorySize: cdk.numberToCloudFormation(properties.sharedMemorySize), Swappiness: cdk.numberToCloudFormation(properties.swappiness), Tmpfs: cdk.listMapper(cfnJobDefinitionTmpfsPropertyToCloudFormation)(properties.tmpfs) }) : properties;
    }
    function CfnJobDefinitionLinuxParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("devices", "Devices", properties.Devices != null ? cfn_parse.FromCloudFormation.getArray(CfnJobDefinitionDevicePropertyFromCloudFormation)(properties.Devices) : void 0), ret.addPropertyResult("initProcessEnabled", "InitProcessEnabled", properties.InitProcessEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.InitProcessEnabled) : void 0), ret.addPropertyResult("maxSwap", "MaxSwap", properties.MaxSwap != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxSwap) : void 0), ret.addPropertyResult("sharedMemorySize", "SharedMemorySize", properties.SharedMemorySize != null ? cfn_parse.FromCloudFormation.getNumber(properties.SharedMemorySize) : void 0), ret.addPropertyResult("swappiness", "Swappiness", properties.Swappiness != null ? cfn_parse.FromCloudFormation.getNumber(properties.Swappiness) : void 0), ret.addPropertyResult("tmpfs", "Tmpfs", properties.Tmpfs != null ? cfn_parse.FromCloudFormation.getArray(CfnJobDefinitionTmpfsPropertyFromCloudFormation)(properties.Tmpfs) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_LogConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logDriver", cdk.requiredValidator)(properties.logDriver)), errors.collect(cdk.propertyValidator("logDriver", cdk.validateString)(properties.logDriver)), errors.collect(cdk.propertyValidator("options", cdk.validateObject)(properties.options)), errors.collect(cdk.propertyValidator("secretOptions", cdk.listValidator(CfnJobDefinition_SecretPropertyValidator))(properties.secretOptions)), errors.wrap('supplied properties not correct for "LogConfigurationProperty"');
    }
    function cfnJobDefinitionLogConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_LogConfigurationPropertyValidator(properties).assertSuccess(), { LogDriver: cdk.stringToCloudFormation(properties.logDriver), Options: cdk.objectToCloudFormation(properties.options), SecretOptions: cdk.listMapper(cfnJobDefinitionSecretPropertyToCloudFormation)(properties.secretOptions) }) : properties;
    }
    function CfnJobDefinitionLogConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logDriver", "LogDriver", cfn_parse.FromCloudFormation.getString(properties.LogDriver)), ret.addPropertyResult("options", "Options", properties.Options != null ? cfn_parse.FromCloudFormation.getAny(properties.Options) : void 0), ret.addPropertyResult("secretOptions", "SecretOptions", properties.SecretOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnJobDefinitionSecretPropertyFromCloudFormation)(properties.SecretOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_MetadataPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("labels", cdk.validateObject)(properties.labels)), errors.wrap('supplied properties not correct for "MetadataProperty"');
    }
    function cfnJobDefinitionMetadataPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_MetadataPropertyValidator(properties).assertSuccess(), { Labels: cdk.objectToCloudFormation(properties.labels) }) : properties;
    }
    function CfnJobDefinitionMetadataPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("labels", "Labels", properties.Labels != null ? cfn_parse.FromCloudFormation.getAny(properties.Labels) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_MountPointsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containerPath", cdk.validateString)(properties.containerPath)), errors.collect(cdk.propertyValidator("readOnly", cdk.validateBoolean)(properties.readOnly)), errors.collect(cdk.propertyValidator("sourceVolume", cdk.validateString)(properties.sourceVolume)), errors.wrap('supplied properties not correct for "MountPointsProperty"');
    }
    function cfnJobDefinitionMountPointsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_MountPointsPropertyValidator(properties).assertSuccess(), { ContainerPath: cdk.stringToCloudFormation(properties.containerPath), ReadOnly: cdk.booleanToCloudFormation(properties.readOnly), SourceVolume: cdk.stringToCloudFormation(properties.sourceVolume) }) : properties;
    }
    function CfnJobDefinitionMountPointsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containerPath", "ContainerPath", properties.ContainerPath != null ? cfn_parse.FromCloudFormation.getString(properties.ContainerPath) : void 0), ret.addPropertyResult("readOnly", "ReadOnly", properties.ReadOnly != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ReadOnly) : void 0), ret.addPropertyResult("sourceVolume", "SourceVolume", properties.SourceVolume != null ? cfn_parse.FromCloudFormation.getString(properties.SourceVolume) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_NetworkConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("assignPublicIp", cdk.validateString)(properties.assignPublicIp)), errors.wrap('supplied properties not correct for "NetworkConfigurationProperty"');
    }
    function cfnJobDefinitionNetworkConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_NetworkConfigurationPropertyValidator(properties).assertSuccess(), { AssignPublicIp: cdk.stringToCloudFormation(properties.assignPublicIp) }) : properties;
    }
    function CfnJobDefinitionNetworkConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("assignPublicIp", "AssignPublicIp", properties.AssignPublicIp != null ? cfn_parse.FromCloudFormation.getString(properties.AssignPublicIp) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_NodePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mainNode", cdk.requiredValidator)(properties.mainNode)), errors.collect(cdk.propertyValidator("mainNode", cdk.validateNumber)(properties.mainNode)), errors.collect(cdk.propertyValidator("nodeRangeProperties", cdk.requiredValidator)(properties.nodeRangeProperties)), errors.collect(cdk.propertyValidator("nodeRangeProperties", cdk.listValidator(CfnJobDefinition_NodeRangePropertyPropertyValidator))(properties.nodeRangeProperties)), errors.collect(cdk.propertyValidator("numNodes", cdk.requiredValidator)(properties.numNodes)), errors.collect(cdk.propertyValidator("numNodes", cdk.validateNumber)(properties.numNodes)), errors.wrap('supplied properties not correct for "NodePropertiesProperty"');
    }
    function cfnJobDefinitionNodePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_NodePropertiesPropertyValidator(properties).assertSuccess(), { MainNode: cdk.numberToCloudFormation(properties.mainNode), NodeRangeProperties: cdk.listMapper(cfnJobDefinitionNodeRangePropertyPropertyToCloudFormation)(properties.nodeRangeProperties), NumNodes: cdk.numberToCloudFormation(properties.numNodes) }) : properties;
    }
    function CfnJobDefinitionNodePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mainNode", "MainNode", cfn_parse.FromCloudFormation.getNumber(properties.MainNode)), ret.addPropertyResult("nodeRangeProperties", "NodeRangeProperties", cfn_parse.FromCloudFormation.getArray(CfnJobDefinitionNodeRangePropertyPropertyFromCloudFormation)(properties.NodeRangeProperties)), ret.addPropertyResult("numNodes", "NumNodes", cfn_parse.FromCloudFormation.getNumber(properties.NumNodes)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_NodeRangePropertyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("container", CfnJobDefinition_ContainerPropertiesPropertyValidator)(properties.container)), errors.collect(cdk.propertyValidator("targetNodes", cdk.requiredValidator)(properties.targetNodes)), errors.collect(cdk.propertyValidator("targetNodes", cdk.validateString)(properties.targetNodes)), errors.wrap('supplied properties not correct for "NodeRangePropertyProperty"');
    }
    function cfnJobDefinitionNodeRangePropertyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_NodeRangePropertyPropertyValidator(properties).assertSuccess(), { Container: cfnJobDefinitionContainerPropertiesPropertyToCloudFormation(properties.container), TargetNodes: cdk.stringToCloudFormation(properties.targetNodes) }) : properties;
    }
    function CfnJobDefinitionNodeRangePropertyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("container", "Container", properties.Container != null ? CfnJobDefinitionContainerPropertiesPropertyFromCloudFormation(properties.Container) : void 0), ret.addPropertyResult("targetNodes", "TargetNodes", cfn_parse.FromCloudFormation.getString(properties.TargetNodes)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_PodPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containers", cdk.listValidator(CfnJobDefinition_EksContainerPropertyValidator))(properties.containers)), errors.collect(cdk.propertyValidator("dnsPolicy", cdk.validateString)(properties.dnsPolicy)), errors.collect(cdk.propertyValidator("hostNetwork", cdk.validateBoolean)(properties.hostNetwork)), errors.collect(cdk.propertyValidator("metadata", CfnJobDefinition_MetadataPropertyValidator)(properties.metadata)), errors.collect(cdk.propertyValidator("serviceAccountName", cdk.validateString)(properties.serviceAccountName)), errors.collect(cdk.propertyValidator("volumes", cdk.listValidator(CfnJobDefinition_EksVolumePropertyValidator))(properties.volumes)), errors.wrap('supplied properties not correct for "PodPropertiesProperty"');
    }
    function cfnJobDefinitionPodPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_PodPropertiesPropertyValidator(properties).assertSuccess(), { Containers: cdk.listMapper(cfnJobDefinitionEksContainerPropertyToCloudFormation)(properties.containers), DnsPolicy: cdk.stringToCloudFormation(properties.dnsPolicy), HostNetwork: cdk.booleanToCloudFormation(properties.hostNetwork), Metadata: cfnJobDefinitionMetadataPropertyToCloudFormation(properties.metadata), ServiceAccountName: cdk.stringToCloudFormation(properties.serviceAccountName), Volumes: cdk.listMapper(cfnJobDefinitionEksVolumePropertyToCloudFormation)(properties.volumes) }) : properties;
    }
    function CfnJobDefinitionPodPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containers", "Containers", properties.Containers != null ? cfn_parse.FromCloudFormation.getArray(CfnJobDefinitionEksContainerPropertyFromCloudFormation)(properties.Containers) : void 0), ret.addPropertyResult("dnsPolicy", "DnsPolicy", properties.DnsPolicy != null ? cfn_parse.FromCloudFormation.getString(properties.DnsPolicy) : void 0), ret.addPropertyResult("hostNetwork", "HostNetwork", properties.HostNetwork != null ? cfn_parse.FromCloudFormation.getBoolean(properties.HostNetwork) : void 0), ret.addPropertyResult("metadata", "Metadata", properties.Metadata != null ? CfnJobDefinitionMetadataPropertyFromCloudFormation(properties.Metadata) : void 0), ret.addPropertyResult("serviceAccountName", "ServiceAccountName", properties.ServiceAccountName != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceAccountName) : void 0), ret.addPropertyResult("volumes", "Volumes", properties.Volumes != null ? cfn_parse.FromCloudFormation.getArray(CfnJobDefinitionEksVolumePropertyFromCloudFormation)(properties.Volumes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_ResourceRequirementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "ResourceRequirementProperty"');
    }
    function cfnJobDefinitionResourceRequirementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_ResourceRequirementPropertyValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnJobDefinitionResourceRequirementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_ResourcesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("limits", cdk.validateObject)(properties.limits)), errors.collect(cdk.propertyValidator("requests", cdk.validateObject)(properties.requests)), errors.wrap('supplied properties not correct for "ResourcesProperty"');
    }
    function cfnJobDefinitionResourcesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_ResourcesPropertyValidator(properties).assertSuccess(), { Limits: cdk.objectToCloudFormation(properties.limits), Requests: cdk.objectToCloudFormation(properties.requests) }) : properties;
    }
    function CfnJobDefinitionResourcesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("limits", "Limits", properties.Limits != null ? cfn_parse.FromCloudFormation.getAny(properties.Limits) : void 0), ret.addPropertyResult("requests", "Requests", properties.Requests != null ? cfn_parse.FromCloudFormation.getAny(properties.Requests) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_RetryStrategyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attempts", cdk.validateNumber)(properties.attempts)), errors.collect(cdk.propertyValidator("evaluateOnExit", cdk.listValidator(CfnJobDefinition_EvaluateOnExitPropertyValidator))(properties.evaluateOnExit)), errors.wrap('supplied properties not correct for "RetryStrategyProperty"');
    }
    function cfnJobDefinitionRetryStrategyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_RetryStrategyPropertyValidator(properties).assertSuccess(), { Attempts: cdk.numberToCloudFormation(properties.attempts), EvaluateOnExit: cdk.listMapper(cfnJobDefinitionEvaluateOnExitPropertyToCloudFormation)(properties.evaluateOnExit) }) : properties;
    }
    function CfnJobDefinitionRetryStrategyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attempts", "Attempts", properties.Attempts != null ? cfn_parse.FromCloudFormation.getNumber(properties.Attempts) : void 0), ret.addPropertyResult("evaluateOnExit", "EvaluateOnExit", properties.EvaluateOnExit != null ? cfn_parse.FromCloudFormation.getArray(CfnJobDefinitionEvaluateOnExitPropertyFromCloudFormation)(properties.EvaluateOnExit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_SecretPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("valueFrom", cdk.requiredValidator)(properties.valueFrom)), errors.collect(cdk.propertyValidator("valueFrom", cdk.validateString)(properties.valueFrom)), errors.wrap('supplied properties not correct for "SecretProperty"');
    }
    function cfnJobDefinitionSecretPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_SecretPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), ValueFrom: cdk.stringToCloudFormation(properties.valueFrom) }) : properties;
    }
    function CfnJobDefinitionSecretPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("valueFrom", "ValueFrom", cfn_parse.FromCloudFormation.getString(properties.ValueFrom)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_SecurityContextPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("privileged", cdk.validateBoolean)(properties.privileged)), errors.collect(cdk.propertyValidator("readOnlyRootFilesystem", cdk.validateBoolean)(properties.readOnlyRootFilesystem)), errors.collect(cdk.propertyValidator("runAsGroup", cdk.validateNumber)(properties.runAsGroup)), errors.collect(cdk.propertyValidator("runAsNonRoot", cdk.validateBoolean)(properties.runAsNonRoot)), errors.collect(cdk.propertyValidator("runAsUser", cdk.validateNumber)(properties.runAsUser)), errors.wrap('supplied properties not correct for "SecurityContextProperty"');
    }
    function cfnJobDefinitionSecurityContextPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_SecurityContextPropertyValidator(properties).assertSuccess(), { Privileged: cdk.booleanToCloudFormation(properties.privileged), ReadOnlyRootFilesystem: cdk.booleanToCloudFormation(properties.readOnlyRootFilesystem), RunAsGroup: cdk.numberToCloudFormation(properties.runAsGroup), RunAsNonRoot: cdk.booleanToCloudFormation(properties.runAsNonRoot), RunAsUser: cdk.numberToCloudFormation(properties.runAsUser) }) : properties;
    }
    function CfnJobDefinitionSecurityContextPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("privileged", "Privileged", properties.Privileged != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Privileged) : void 0), ret.addPropertyResult("readOnlyRootFilesystem", "ReadOnlyRootFilesystem", properties.ReadOnlyRootFilesystem != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ReadOnlyRootFilesystem) : void 0), ret.addPropertyResult("runAsGroup", "RunAsGroup", properties.RunAsGroup != null ? cfn_parse.FromCloudFormation.getNumber(properties.RunAsGroup) : void 0), ret.addPropertyResult("runAsNonRoot", "RunAsNonRoot", properties.RunAsNonRoot != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RunAsNonRoot) : void 0), ret.addPropertyResult("runAsUser", "RunAsUser", properties.RunAsUser != null ? cfn_parse.FromCloudFormation.getNumber(properties.RunAsUser) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_TimeoutPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attemptDurationSeconds", cdk.validateNumber)(properties.attemptDurationSeconds)), errors.wrap('supplied properties not correct for "TimeoutProperty"');
    }
    function cfnJobDefinitionTimeoutPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_TimeoutPropertyValidator(properties).assertSuccess(), { AttemptDurationSeconds: cdk.numberToCloudFormation(properties.attemptDurationSeconds) }) : properties;
    }
    function CfnJobDefinitionTimeoutPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attemptDurationSeconds", "AttemptDurationSeconds", properties.AttemptDurationSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.AttemptDurationSeconds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_TmpfsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containerPath", cdk.requiredValidator)(properties.containerPath)), errors.collect(cdk.propertyValidator("containerPath", cdk.validateString)(properties.containerPath)), errors.collect(cdk.propertyValidator("mountOptions", cdk.listValidator(cdk.validateString))(properties.mountOptions)), errors.collect(cdk.propertyValidator("size", cdk.requiredValidator)(properties.size)), errors.collect(cdk.propertyValidator("size", cdk.validateNumber)(properties.size)), errors.wrap('supplied properties not correct for "TmpfsProperty"');
    }
    function cfnJobDefinitionTmpfsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_TmpfsPropertyValidator(properties).assertSuccess(), { ContainerPath: cdk.stringToCloudFormation(properties.containerPath), MountOptions: cdk.listMapper(cdk.stringToCloudFormation)(properties.mountOptions), Size: cdk.numberToCloudFormation(properties.size) }) : properties;
    }
    function CfnJobDefinitionTmpfsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containerPath", "ContainerPath", cfn_parse.FromCloudFormation.getString(properties.ContainerPath)), ret.addPropertyResult("mountOptions", "MountOptions", properties.MountOptions != null ? cfn_parse.FromCloudFormation.getStringArray(properties.MountOptions) : void 0), ret.addPropertyResult("size", "Size", cfn_parse.FromCloudFormation.getNumber(properties.Size)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_UlimitPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("hardLimit", cdk.requiredValidator)(properties.hardLimit)), errors.collect(cdk.propertyValidator("hardLimit", cdk.validateNumber)(properties.hardLimit)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("softLimit", cdk.requiredValidator)(properties.softLimit)), errors.collect(cdk.propertyValidator("softLimit", cdk.validateNumber)(properties.softLimit)), errors.wrap('supplied properties not correct for "UlimitProperty"');
    }
    function cfnJobDefinitionUlimitPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_UlimitPropertyValidator(properties).assertSuccess(), { HardLimit: cdk.numberToCloudFormation(properties.hardLimit), Name: cdk.stringToCloudFormation(properties.name), SoftLimit: cdk.numberToCloudFormation(properties.softLimit) }) : properties;
    }
    function CfnJobDefinitionUlimitPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("hardLimit", "HardLimit", cfn_parse.FromCloudFormation.getNumber(properties.HardLimit)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("softLimit", "SoftLimit", cfn_parse.FromCloudFormation.getNumber(properties.SoftLimit)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_VolumesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("efsVolumeConfiguration", CfnJobDefinition_EfsVolumeConfigurationPropertyValidator)(properties.efsVolumeConfiguration)), errors.collect(cdk.propertyValidator("host", CfnJobDefinition_VolumesHostPropertyValidator)(properties.host)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "VolumesProperty"');
    }
    function cfnJobDefinitionVolumesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_VolumesPropertyValidator(properties).assertSuccess(), { EfsVolumeConfiguration: cfnJobDefinitionEfsVolumeConfigurationPropertyToCloudFormation(properties.efsVolumeConfiguration), Host: cfnJobDefinitionVolumesHostPropertyToCloudFormation(properties.host), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnJobDefinitionVolumesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("efsVolumeConfiguration", "EfsVolumeConfiguration", properties.EfsVolumeConfiguration != null ? CfnJobDefinitionEfsVolumeConfigurationPropertyFromCloudFormation(properties.EfsVolumeConfiguration) : void 0), ret.addPropertyResult("host", "Host", properties.Host != null ? CfnJobDefinitionVolumesHostPropertyFromCloudFormation(properties.Host) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobDefinition_VolumesHostPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sourcePath", cdk.validateString)(properties.sourcePath)), errors.wrap('supplied properties not correct for "VolumesHostProperty"');
    }
    function cfnJobDefinitionVolumesHostPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobDefinition_VolumesHostPropertyValidator(properties).assertSuccess(), { SourcePath: cdk.stringToCloudFormation(properties.sourcePath) }) : properties;
    }
    function CfnJobDefinitionVolumesHostPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sourcePath", "SourcePath", properties.SourcePath != null ? cfn_parse.FromCloudFormation.getString(properties.SourcePath) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobQueuePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computeEnvironmentOrder", cdk.requiredValidator)(properties.computeEnvironmentOrder)), errors.collect(cdk.propertyValidator("computeEnvironmentOrder", cdk.listValidator(CfnJobQueue_ComputeEnvironmentOrderPropertyValidator))(properties.computeEnvironmentOrder)), errors.collect(cdk.propertyValidator("jobQueueName", cdk.validateString)(properties.jobQueueName)), errors.collect(cdk.propertyValidator("priority", cdk.requiredValidator)(properties.priority)), errors.collect(cdk.propertyValidator("priority", cdk.validateNumber)(properties.priority)), errors.collect(cdk.propertyValidator("schedulingPolicyArn", cdk.validateString)(properties.schedulingPolicyArn)), errors.collect(cdk.propertyValidator("state", cdk.validateString)(properties.state)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.wrap('supplied properties not correct for "CfnJobQueueProps"');
    }
    function cfnJobQueuePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobQueuePropsValidator(properties).assertSuccess(), { ComputeEnvironmentOrder: cdk.listMapper(cfnJobQueueComputeEnvironmentOrderPropertyToCloudFormation)(properties.computeEnvironmentOrder), Priority: cdk.numberToCloudFormation(properties.priority), JobQueueName: cdk.stringToCloudFormation(properties.jobQueueName), SchedulingPolicyArn: cdk.stringToCloudFormation(properties.schedulingPolicyArn), State: cdk.stringToCloudFormation(properties.state), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnJobQueuePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computeEnvironmentOrder", "ComputeEnvironmentOrder", cfn_parse.FromCloudFormation.getArray(CfnJobQueueComputeEnvironmentOrderPropertyFromCloudFormation)(properties.ComputeEnvironmentOrder)), ret.addPropertyResult("priority", "Priority", cfn_parse.FromCloudFormation.getNumber(properties.Priority)), ret.addPropertyResult("jobQueueName", "JobQueueName", properties.JobQueueName != null ? cfn_parse.FromCloudFormation.getString(properties.JobQueueName) : void 0), ret.addPropertyResult("schedulingPolicyArn", "SchedulingPolicyArn", properties.SchedulingPolicyArn != null ? cfn_parse.FromCloudFormation.getString(properties.SchedulingPolicyArn) : void 0), ret.addPropertyResult("state", "State", properties.State != null ? cfn_parse.FromCloudFormation.getString(properties.State) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnJobQueue = class _CfnJobQueue extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnJobQueuePropsFromCloudFormation(resourceProperties), ret = new _CfnJobQueue(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnJobQueue.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_batch_CfnJobQueueProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnJobQueue), error;
        }
        cdk.requireProperty(props, "computeEnvironmentOrder", this), cdk.requireProperty(props, "priority", this), this.attrJobQueueArn = cdk.Token.asString(this.getAtt("JobQueueArn", cdk.ResolutionTypeHint.STRING)), this.computeEnvironmentOrder = props.computeEnvironmentOrder, this.priority = props.priority, this.jobQueueName = props.jobQueueName, this.schedulingPolicyArn = props.schedulingPolicyArn, this.state = props.state, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Batch::JobQueue", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnJobQueue.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { computeEnvironmentOrder: this.computeEnvironmentOrder, priority: this.priority, jobQueueName: this.jobQueueName, schedulingPolicyArn: this.schedulingPolicyArn, state: this.state, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnJobQueuePropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnJobQueue[_c] = { fqn: "aws-cdk-lib.aws_batch.CfnJobQueue", version: "2.80.0" }, CfnJobQueue.CFN_RESOURCE_TYPE_NAME = "AWS::Batch::JobQueue", exports2.CfnJobQueue = CfnJobQueue;
    function CfnJobQueue_ComputeEnvironmentOrderPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computeEnvironment", cdk.requiredValidator)(properties.computeEnvironment)), errors.collect(cdk.propertyValidator("computeEnvironment", cdk.validateString)(properties.computeEnvironment)), errors.collect(cdk.propertyValidator("order", cdk.requiredValidator)(properties.order)), errors.collect(cdk.propertyValidator("order", cdk.validateNumber)(properties.order)), errors.wrap('supplied properties not correct for "ComputeEnvironmentOrderProperty"');
    }
    function cfnJobQueueComputeEnvironmentOrderPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobQueue_ComputeEnvironmentOrderPropertyValidator(properties).assertSuccess(), { ComputeEnvironment: cdk.stringToCloudFormation(properties.computeEnvironment), Order: cdk.numberToCloudFormation(properties.order) }) : properties;
    }
    function CfnJobQueueComputeEnvironmentOrderPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computeEnvironment", "ComputeEnvironment", cfn_parse.FromCloudFormation.getString(properties.ComputeEnvironment)), ret.addPropertyResult("order", "Order", cfn_parse.FromCloudFormation.getNumber(properties.Order)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSchedulingPolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fairsharePolicy", CfnSchedulingPolicy_FairsharePolicyPropertyValidator)(properties.fairsharePolicy)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.wrap('supplied properties not correct for "CfnSchedulingPolicyProps"');
    }
    function cfnSchedulingPolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSchedulingPolicyPropsValidator(properties).assertSuccess(), { FairsharePolicy: cfnSchedulingPolicyFairsharePolicyPropertyToCloudFormation(properties.fairsharePolicy), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnSchedulingPolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fairsharePolicy", "FairsharePolicy", properties.FairsharePolicy != null ? CfnSchedulingPolicyFairsharePolicyPropertyFromCloudFormation(properties.FairsharePolicy) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSchedulingPolicy = class _CfnSchedulingPolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSchedulingPolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnSchedulingPolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnSchedulingPolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_batch_CfnSchedulingPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSchedulingPolicy), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.fairsharePolicy = props.fairsharePolicy, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Batch::SchedulingPolicy", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSchedulingPolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { fairsharePolicy: this.fairsharePolicy, name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnSchedulingPolicyPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnSchedulingPolicy[_d] = { fqn: "aws-cdk-lib.aws_batch.CfnSchedulingPolicy", version: "2.80.0" }, CfnSchedulingPolicy.CFN_RESOURCE_TYPE_NAME = "AWS::Batch::SchedulingPolicy", exports2.CfnSchedulingPolicy = CfnSchedulingPolicy;
    function CfnSchedulingPolicy_FairsharePolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computeReservation", cdk.validateNumber)(properties.computeReservation)), errors.collect(cdk.propertyValidator("shareDecaySeconds", cdk.validateNumber)(properties.shareDecaySeconds)), errors.collect(cdk.propertyValidator("shareDistribution", cdk.listValidator(CfnSchedulingPolicy_ShareAttributesPropertyValidator))(properties.shareDistribution)), errors.wrap('supplied properties not correct for "FairsharePolicyProperty"');
    }
    function cfnSchedulingPolicyFairsharePolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSchedulingPolicy_FairsharePolicyPropertyValidator(properties).assertSuccess(), { ComputeReservation: cdk.numberToCloudFormation(properties.computeReservation), ShareDecaySeconds: cdk.numberToCloudFormation(properties.shareDecaySeconds), ShareDistribution: cdk.listMapper(cfnSchedulingPolicyShareAttributesPropertyToCloudFormation)(properties.shareDistribution) }) : properties;
    }
    function CfnSchedulingPolicyFairsharePolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computeReservation", "ComputeReservation", properties.ComputeReservation != null ? cfn_parse.FromCloudFormation.getNumber(properties.ComputeReservation) : void 0), ret.addPropertyResult("shareDecaySeconds", "ShareDecaySeconds", properties.ShareDecaySeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.ShareDecaySeconds) : void 0), ret.addPropertyResult("shareDistribution", "ShareDistribution", properties.ShareDistribution != null ? cfn_parse.FromCloudFormation.getArray(CfnSchedulingPolicyShareAttributesPropertyFromCloudFormation)(properties.ShareDistribution) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSchedulingPolicy_ShareAttributesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("shareIdentifier", cdk.validateString)(properties.shareIdentifier)), errors.collect(cdk.propertyValidator("weightFactor", cdk.validateNumber)(properties.weightFactor)), errors.wrap('supplied properties not correct for "ShareAttributesProperty"');
    }
    function cfnSchedulingPolicyShareAttributesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSchedulingPolicy_ShareAttributesPropertyValidator(properties).assertSuccess(), { ShareIdentifier: cdk.stringToCloudFormation(properties.shareIdentifier), WeightFactor: cdk.numberToCloudFormation(properties.weightFactor) }) : properties;
    }
    function CfnSchedulingPolicyShareAttributesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("shareIdentifier", "ShareIdentifier", properties.ShareIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.ShareIdentifier) : void 0), ret.addPropertyResult("weightFactor", "WeightFactor", properties.WeightFactor != null ? cfn_parse.FromCloudFormation.getNumber(properties.WeightFactor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-batch/lib/index.js
var require_lib63 = __commonJS({
  "node_modules/aws-cdk-lib/aws-batch/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_batch_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-batch/index.js
var require_aws_batch = __commonJS({
  "node_modules/aws-cdk-lib/aws-batch/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib63(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-billingconductor/lib/billingconductor.generated.js
var require_billingconductor_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-billingconductor/lib/billingconductor.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnPricingRule = exports2.CfnPricingPlan = exports2.CfnCustomLineItem = exports2.CfnBillingGroup = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnBillingGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accountGrouping", cdk.requiredValidator)(properties.accountGrouping)), errors.collect(cdk.propertyValidator("accountGrouping", CfnBillingGroup_AccountGroupingPropertyValidator)(properties.accountGrouping)), errors.collect(cdk.propertyValidator("computationPreference", cdk.requiredValidator)(properties.computationPreference)), errors.collect(cdk.propertyValidator("computationPreference", CfnBillingGroup_ComputationPreferencePropertyValidator)(properties.computationPreference)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("primaryAccountId", cdk.requiredValidator)(properties.primaryAccountId)), errors.collect(cdk.propertyValidator("primaryAccountId", cdk.validateString)(properties.primaryAccountId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnBillingGroupProps"');
    }
    function cfnBillingGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBillingGroupPropsValidator(properties).assertSuccess(), { AccountGrouping: cfnBillingGroupAccountGroupingPropertyToCloudFormation(properties.accountGrouping), ComputationPreference: cfnBillingGroupComputationPreferencePropertyToCloudFormation(properties.computationPreference), Name: cdk.stringToCloudFormation(properties.name), PrimaryAccountId: cdk.stringToCloudFormation(properties.primaryAccountId), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnBillingGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accountGrouping", "AccountGrouping", CfnBillingGroupAccountGroupingPropertyFromCloudFormation(properties.AccountGrouping)), ret.addPropertyResult("computationPreference", "ComputationPreference", CfnBillingGroupComputationPreferencePropertyFromCloudFormation(properties.ComputationPreference)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("primaryAccountId", "PrimaryAccountId", cfn_parse.FromCloudFormation.getString(properties.PrimaryAccountId)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnBillingGroup = class _CfnBillingGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnBillingGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnBillingGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnBillingGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_billingconductor_CfnBillingGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnBillingGroup), error;
        }
        cdk.requireProperty(props, "accountGrouping", this), cdk.requireProperty(props, "computationPreference", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "primaryAccountId", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreationTime = cdk.Token.asNumber(this.getAtt("CreationTime", cdk.ResolutionTypeHint.NUMBER)), this.attrLastModifiedTime = cdk.Token.asNumber(this.getAtt("LastModifiedTime", cdk.ResolutionTypeHint.NUMBER)), this.attrSize = cdk.Token.asNumber(this.getAtt("Size", cdk.ResolutionTypeHint.NUMBER)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.attrStatusReason = cdk.Token.asString(this.getAtt("StatusReason", cdk.ResolutionTypeHint.STRING)), this.accountGrouping = props.accountGrouping, this.computationPreference = props.computationPreference, this.name = props.name, this.primaryAccountId = props.primaryAccountId, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::BillingConductor::BillingGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnBillingGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { accountGrouping: this.accountGrouping, computationPreference: this.computationPreference, name: this.name, primaryAccountId: this.primaryAccountId, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnBillingGroupPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnBillingGroup[_a] = { fqn: "aws-cdk-lib.aws_billingconductor.CfnBillingGroup", version: "2.80.0" }, CfnBillingGroup.CFN_RESOURCE_TYPE_NAME = "AWS::BillingConductor::BillingGroup", exports2.CfnBillingGroup = CfnBillingGroup;
    function CfnBillingGroup_AccountGroupingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("linkedAccountIds", cdk.requiredValidator)(properties.linkedAccountIds)), errors.collect(cdk.propertyValidator("linkedAccountIds", cdk.listValidator(cdk.validateString))(properties.linkedAccountIds)), errors.wrap('supplied properties not correct for "AccountGroupingProperty"');
    }
    function cfnBillingGroupAccountGroupingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBillingGroup_AccountGroupingPropertyValidator(properties).assertSuccess(), { LinkedAccountIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.linkedAccountIds) }) : properties;
    }
    function CfnBillingGroupAccountGroupingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("linkedAccountIds", "LinkedAccountIds", cfn_parse.FromCloudFormation.getStringArray(properties.LinkedAccountIds)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBillingGroup_ComputationPreferencePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("pricingPlanArn", cdk.requiredValidator)(properties.pricingPlanArn)), errors.collect(cdk.propertyValidator("pricingPlanArn", cdk.validateString)(properties.pricingPlanArn)), errors.wrap('supplied properties not correct for "ComputationPreferenceProperty"');
    }
    function cfnBillingGroupComputationPreferencePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBillingGroup_ComputationPreferencePropertyValidator(properties).assertSuccess(), { PricingPlanArn: cdk.stringToCloudFormation(properties.pricingPlanArn) }) : properties;
    }
    function CfnBillingGroupComputationPreferencePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("pricingPlanArn", "PricingPlanArn", cfn_parse.FromCloudFormation.getString(properties.PricingPlanArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCustomLineItemPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("billingGroupArn", cdk.requiredValidator)(properties.billingGroupArn)), errors.collect(cdk.propertyValidator("billingGroupArn", cdk.validateString)(properties.billingGroupArn)), errors.collect(cdk.propertyValidator("billingPeriodRange", CfnCustomLineItem_BillingPeriodRangePropertyValidator)(properties.billingPeriodRange)), errors.collect(cdk.propertyValidator("customLineItemChargeDetails", CfnCustomLineItem_CustomLineItemChargeDetailsPropertyValidator)(properties.customLineItemChargeDetails)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnCustomLineItemProps"');
    }
    function cfnCustomLineItemPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCustomLineItemPropsValidator(properties).assertSuccess(), { BillingGroupArn: cdk.stringToCloudFormation(properties.billingGroupArn), Name: cdk.stringToCloudFormation(properties.name), BillingPeriodRange: cfnCustomLineItemBillingPeriodRangePropertyToCloudFormation(properties.billingPeriodRange), CustomLineItemChargeDetails: cfnCustomLineItemCustomLineItemChargeDetailsPropertyToCloudFormation(properties.customLineItemChargeDetails), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnCustomLineItemPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("billingGroupArn", "BillingGroupArn", cfn_parse.FromCloudFormation.getString(properties.BillingGroupArn)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("billingPeriodRange", "BillingPeriodRange", properties.BillingPeriodRange != null ? CfnCustomLineItemBillingPeriodRangePropertyFromCloudFormation(properties.BillingPeriodRange) : void 0), ret.addPropertyResult("customLineItemChargeDetails", "CustomLineItemChargeDetails", properties.CustomLineItemChargeDetails != null ? CfnCustomLineItemCustomLineItemChargeDetailsPropertyFromCloudFormation(properties.CustomLineItemChargeDetails) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCustomLineItem = class _CfnCustomLineItem extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCustomLineItemPropsFromCloudFormation(resourceProperties), ret = new _CfnCustomLineItem(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCustomLineItem.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_billingconductor_CfnCustomLineItemProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCustomLineItem), error;
        }
        cdk.requireProperty(props, "billingGroupArn", this), cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrAssociationSize = cdk.Token.asNumber(this.getAtt("AssociationSize", cdk.ResolutionTypeHint.NUMBER)), this.attrCreationTime = cdk.Token.asNumber(this.getAtt("CreationTime", cdk.ResolutionTypeHint.NUMBER)), this.attrCurrencyCode = cdk.Token.asString(this.getAtt("CurrencyCode", cdk.ResolutionTypeHint.STRING)), this.attrLastModifiedTime = cdk.Token.asNumber(this.getAtt("LastModifiedTime", cdk.ResolutionTypeHint.NUMBER)), this.attrProductCode = cdk.Token.asString(this.getAtt("ProductCode", cdk.ResolutionTypeHint.STRING)), this.billingGroupArn = props.billingGroupArn, this.name = props.name, this.billingPeriodRange = props.billingPeriodRange, this.customLineItemChargeDetails = props.customLineItemChargeDetails, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::BillingConductor::CustomLineItem", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCustomLineItem.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { billingGroupArn: this.billingGroupArn, name: this.name, billingPeriodRange: this.billingPeriodRange, customLineItemChargeDetails: this.customLineItemChargeDetails, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnCustomLineItemPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnCustomLineItem[_b] = { fqn: "aws-cdk-lib.aws_billingconductor.CfnCustomLineItem", version: "2.80.0" }, CfnCustomLineItem.CFN_RESOURCE_TYPE_NAME = "AWS::BillingConductor::CustomLineItem", exports2.CfnCustomLineItem = CfnCustomLineItem;
    function CfnCustomLineItem_BillingPeriodRangePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("exclusiveEndBillingPeriod", cdk.validateString)(properties.exclusiveEndBillingPeriod)), errors.collect(cdk.propertyValidator("inclusiveStartBillingPeriod", cdk.validateString)(properties.inclusiveStartBillingPeriod)), errors.wrap('supplied properties not correct for "BillingPeriodRangeProperty"');
    }
    function cfnCustomLineItemBillingPeriodRangePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCustomLineItem_BillingPeriodRangePropertyValidator(properties).assertSuccess(), { ExclusiveEndBillingPeriod: cdk.stringToCloudFormation(properties.exclusiveEndBillingPeriod), InclusiveStartBillingPeriod: cdk.stringToCloudFormation(properties.inclusiveStartBillingPeriod) }) : properties;
    }
    function CfnCustomLineItemBillingPeriodRangePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("exclusiveEndBillingPeriod", "ExclusiveEndBillingPeriod", properties.ExclusiveEndBillingPeriod != null ? cfn_parse.FromCloudFormation.getString(properties.ExclusiveEndBillingPeriod) : void 0), ret.addPropertyResult("inclusiveStartBillingPeriod", "InclusiveStartBillingPeriod", properties.InclusiveStartBillingPeriod != null ? cfn_parse.FromCloudFormation.getString(properties.InclusiveStartBillingPeriod) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCustomLineItem_CustomLineItemChargeDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("flat", CfnCustomLineItem_CustomLineItemFlatChargeDetailsPropertyValidator)(properties.flat)), errors.collect(cdk.propertyValidator("percentage", CfnCustomLineItem_CustomLineItemPercentageChargeDetailsPropertyValidator)(properties.percentage)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CustomLineItemChargeDetailsProperty"');
    }
    function cfnCustomLineItemCustomLineItemChargeDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCustomLineItem_CustomLineItemChargeDetailsPropertyValidator(properties).assertSuccess(), { Flat: cfnCustomLineItemCustomLineItemFlatChargeDetailsPropertyToCloudFormation(properties.flat), Percentage: cfnCustomLineItemCustomLineItemPercentageChargeDetailsPropertyToCloudFormation(properties.percentage), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnCustomLineItemCustomLineItemChargeDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("flat", "Flat", properties.Flat != null ? CfnCustomLineItemCustomLineItemFlatChargeDetailsPropertyFromCloudFormation(properties.Flat) : void 0), ret.addPropertyResult("percentage", "Percentage", properties.Percentage != null ? CfnCustomLineItemCustomLineItemPercentageChargeDetailsPropertyFromCloudFormation(properties.Percentage) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCustomLineItem_CustomLineItemFlatChargeDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("chargeValue", cdk.requiredValidator)(properties.chargeValue)), errors.collect(cdk.propertyValidator("chargeValue", cdk.validateNumber)(properties.chargeValue)), errors.wrap('supplied properties not correct for "CustomLineItemFlatChargeDetailsProperty"');
    }
    function cfnCustomLineItemCustomLineItemFlatChargeDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCustomLineItem_CustomLineItemFlatChargeDetailsPropertyValidator(properties).assertSuccess(), { ChargeValue: cdk.numberToCloudFormation(properties.chargeValue) }) : properties;
    }
    function CfnCustomLineItemCustomLineItemFlatChargeDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("chargeValue", "ChargeValue", cfn_parse.FromCloudFormation.getNumber(properties.ChargeValue)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCustomLineItem_CustomLineItemPercentageChargeDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("childAssociatedResources", cdk.listValidator(cdk.validateString))(properties.childAssociatedResources)), errors.collect(cdk.propertyValidator("percentageValue", cdk.requiredValidator)(properties.percentageValue)), errors.collect(cdk.propertyValidator("percentageValue", cdk.validateNumber)(properties.percentageValue)), errors.wrap('supplied properties not correct for "CustomLineItemPercentageChargeDetailsProperty"');
    }
    function cfnCustomLineItemCustomLineItemPercentageChargeDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCustomLineItem_CustomLineItemPercentageChargeDetailsPropertyValidator(properties).assertSuccess(), { ChildAssociatedResources: cdk.listMapper(cdk.stringToCloudFormation)(properties.childAssociatedResources), PercentageValue: cdk.numberToCloudFormation(properties.percentageValue) }) : properties;
    }
    function CfnCustomLineItemCustomLineItemPercentageChargeDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("childAssociatedResources", "ChildAssociatedResources", properties.ChildAssociatedResources != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ChildAssociatedResources) : void 0), ret.addPropertyResult("percentageValue", "PercentageValue", cfn_parse.FromCloudFormation.getNumber(properties.PercentageValue)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPricingPlanPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("pricingRuleArns", cdk.listValidator(cdk.validateString))(properties.pricingRuleArns)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnPricingPlanProps"');
    }
    function cfnPricingPlanPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPricingPlanPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), PricingRuleArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.pricingRuleArns), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnPricingPlanPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("pricingRuleArns", "PricingRuleArns", properties.PricingRuleArns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.PricingRuleArns) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPricingPlan = class _CfnPricingPlan extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPricingPlanPropsFromCloudFormation(resourceProperties), ret = new _CfnPricingPlan(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPricingPlan.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_billingconductor_CfnPricingPlanProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPricingPlan), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreationTime = cdk.Token.asNumber(this.getAtt("CreationTime", cdk.ResolutionTypeHint.NUMBER)), this.attrLastModifiedTime = cdk.Token.asNumber(this.getAtt("LastModifiedTime", cdk.ResolutionTypeHint.NUMBER)), this.attrSize = cdk.Token.asNumber(this.getAtt("Size", cdk.ResolutionTypeHint.NUMBER)), this.name = props.name, this.description = props.description, this.pricingRuleArns = props.pricingRuleArns, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::BillingConductor::PricingPlan", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPricingPlan.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, description: this.description, pricingRuleArns: this.pricingRuleArns, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnPricingPlanPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnPricingPlan[_c] = { fqn: "aws-cdk-lib.aws_billingconductor.CfnPricingPlan", version: "2.80.0" }, CfnPricingPlan.CFN_RESOURCE_TYPE_NAME = "AWS::BillingConductor::PricingPlan", exports2.CfnPricingPlan = CfnPricingPlan;
    function CfnPricingRulePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("billingEntity", cdk.validateString)(properties.billingEntity)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("modifierPercentage", cdk.validateNumber)(properties.modifierPercentage)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("operation", cdk.validateString)(properties.operation)), errors.collect(cdk.propertyValidator("scope", cdk.requiredValidator)(properties.scope)), errors.collect(cdk.propertyValidator("scope", cdk.validateString)(properties.scope)), errors.collect(cdk.propertyValidator("service", cdk.validateString)(properties.service)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("tiering", CfnPricingRule_TieringPropertyValidator)(properties.tiering)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("usageType", cdk.validateString)(properties.usageType)), errors.wrap('supplied properties not correct for "CfnPricingRuleProps"');
    }
    function cfnPricingRulePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPricingRulePropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Scope: cdk.stringToCloudFormation(properties.scope), Type: cdk.stringToCloudFormation(properties.type), BillingEntity: cdk.stringToCloudFormation(properties.billingEntity), Description: cdk.stringToCloudFormation(properties.description), ModifierPercentage: cdk.numberToCloudFormation(properties.modifierPercentage), Operation: cdk.stringToCloudFormation(properties.operation), Service: cdk.stringToCloudFormation(properties.service), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), Tiering: cfnPricingRuleTieringPropertyToCloudFormation(properties.tiering), UsageType: cdk.stringToCloudFormation(properties.usageType) }) : properties;
    }
    function CfnPricingRulePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("scope", "Scope", cfn_parse.FromCloudFormation.getString(properties.Scope)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("billingEntity", "BillingEntity", properties.BillingEntity != null ? cfn_parse.FromCloudFormation.getString(properties.BillingEntity) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("modifierPercentage", "ModifierPercentage", properties.ModifierPercentage != null ? cfn_parse.FromCloudFormation.getNumber(properties.ModifierPercentage) : void 0), ret.addPropertyResult("operation", "Operation", properties.Operation != null ? cfn_parse.FromCloudFormation.getString(properties.Operation) : void 0), ret.addPropertyResult("service", "Service", properties.Service != null ? cfn_parse.FromCloudFormation.getString(properties.Service) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("tiering", "Tiering", properties.Tiering != null ? CfnPricingRuleTieringPropertyFromCloudFormation(properties.Tiering) : void 0), ret.addPropertyResult("usageType", "UsageType", properties.UsageType != null ? cfn_parse.FromCloudFormation.getString(properties.UsageType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPricingRule = class _CfnPricingRule extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPricingRulePropsFromCloudFormation(resourceProperties), ret = new _CfnPricingRule(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPricingRule.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_billingconductor_CfnPricingRuleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPricingRule), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "scope", this), cdk.requireProperty(props, "type", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrAssociatedPricingPlanCount = cdk.Token.asNumber(this.getAtt("AssociatedPricingPlanCount", cdk.ResolutionTypeHint.NUMBER)), this.attrCreationTime = cdk.Token.asNumber(this.getAtt("CreationTime", cdk.ResolutionTypeHint.NUMBER)), this.attrLastModifiedTime = cdk.Token.asNumber(this.getAtt("LastModifiedTime", cdk.ResolutionTypeHint.NUMBER)), this.name = props.name, this.scope = props.scope, this.type = props.type, this.billingEntity = props.billingEntity, this.description = props.description, this.modifierPercentage = props.modifierPercentage, this.operation = props.operation, this.service = props.service, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::BillingConductor::PricingRule", props.tags, { tagPropertyName: "tags" }), this.tiering = props.tiering, this.usageType = props.usageType;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPricingRule.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, scope: this.scope, type: this.type, billingEntity: this.billingEntity, description: this.description, modifierPercentage: this.modifierPercentage, operation: this.operation, service: this.service, tags: this.tags.renderTags(), tiering: this.tiering, usageType: this.usageType };
      }
      renderProperties(props) {
        return cfnPricingRulePropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnPricingRule[_d] = { fqn: "aws-cdk-lib.aws_billingconductor.CfnPricingRule", version: "2.80.0" }, CfnPricingRule.CFN_RESOURCE_TYPE_NAME = "AWS::BillingConductor::PricingRule", exports2.CfnPricingRule = CfnPricingRule;
    function CfnPricingRule_FreeTierPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("activated", cdk.requiredValidator)(properties.activated)), errors.collect(cdk.propertyValidator("activated", cdk.validateBoolean)(properties.activated)), errors.wrap('supplied properties not correct for "FreeTierProperty"');
    }
    function cfnPricingRuleFreeTierPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPricingRule_FreeTierPropertyValidator(properties).assertSuccess(), { Activated: cdk.booleanToCloudFormation(properties.activated) }) : properties;
    }
    function CfnPricingRuleFreeTierPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("activated", "Activated", cfn_parse.FromCloudFormation.getBoolean(properties.Activated)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPricingRule_TieringPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("freeTier", CfnPricingRule_FreeTierPropertyValidator)(properties.freeTier)), errors.wrap('supplied properties not correct for "TieringProperty"');
    }
    function cfnPricingRuleTieringPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPricingRule_TieringPropertyValidator(properties).assertSuccess(), { FreeTier: cfnPricingRuleFreeTierPropertyToCloudFormation(properties.freeTier) }) : properties;
    }
    function CfnPricingRuleTieringPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("freeTier", "FreeTier", properties.FreeTier != null ? CfnPricingRuleFreeTierPropertyFromCloudFormation(properties.FreeTier) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-billingconductor/lib/index.js
var require_lib64 = __commonJS({
  "node_modules/aws-cdk-lib/aws-billingconductor/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_billingconductor_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-billingconductor/index.js
var require_aws_billingconductor = __commonJS({
  "node_modules/aws-cdk-lib/aws-billingconductor/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib64(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-budgets/lib/budgets.generated.js
var require_budgets_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-budgets/lib/budgets.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnBudgetsAction = exports2.CfnBudget = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnBudgetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("budget", cdk.requiredValidator)(properties.budget)), errors.collect(cdk.propertyValidator("budget", CfnBudget_BudgetDataPropertyValidator)(properties.budget)), errors.collect(cdk.propertyValidator("notificationsWithSubscribers", cdk.listValidator(CfnBudget_NotificationWithSubscribersPropertyValidator))(properties.notificationsWithSubscribers)), errors.wrap('supplied properties not correct for "CfnBudgetProps"');
    }
    function cfnBudgetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBudgetPropsValidator(properties).assertSuccess(), { Budget: cfnBudgetBudgetDataPropertyToCloudFormation(properties.budget), NotificationsWithSubscribers: cdk.listMapper(cfnBudgetNotificationWithSubscribersPropertyToCloudFormation)(properties.notificationsWithSubscribers) }) : properties;
    }
    function CfnBudgetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("budget", "Budget", CfnBudgetBudgetDataPropertyFromCloudFormation(properties.Budget)), ret.addPropertyResult("notificationsWithSubscribers", "NotificationsWithSubscribers", properties.NotificationsWithSubscribers != null ? cfn_parse.FromCloudFormation.getArray(CfnBudgetNotificationWithSubscribersPropertyFromCloudFormation)(properties.NotificationsWithSubscribers) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnBudget = class _CfnBudget extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnBudgetPropsFromCloudFormation(resourceProperties), ret = new _CfnBudget(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnBudget.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_budgets_CfnBudgetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnBudget), error;
        }
        cdk.requireProperty(props, "budget", this), this.budget = props.budget, this.notificationsWithSubscribers = props.notificationsWithSubscribers;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnBudget.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { budget: this.budget, notificationsWithSubscribers: this.notificationsWithSubscribers };
      }
      renderProperties(props) {
        return cfnBudgetPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnBudget[_a] = { fqn: "aws-cdk-lib.aws_budgets.CfnBudget", version: "2.80.0" }, CfnBudget.CFN_RESOURCE_TYPE_NAME = "AWS::Budgets::Budget", exports2.CfnBudget = CfnBudget;
    function CfnBudget_AutoAdjustDataPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoAdjustType", cdk.requiredValidator)(properties.autoAdjustType)), errors.collect(cdk.propertyValidator("autoAdjustType", cdk.validateString)(properties.autoAdjustType)), errors.collect(cdk.propertyValidator("historicalOptions", CfnBudget_HistoricalOptionsPropertyValidator)(properties.historicalOptions)), errors.wrap('supplied properties not correct for "AutoAdjustDataProperty"');
    }
    function cfnBudgetAutoAdjustDataPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBudget_AutoAdjustDataPropertyValidator(properties).assertSuccess(), { AutoAdjustType: cdk.stringToCloudFormation(properties.autoAdjustType), HistoricalOptions: cfnBudgetHistoricalOptionsPropertyToCloudFormation(properties.historicalOptions) }) : properties;
    }
    function CfnBudgetAutoAdjustDataPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("autoAdjustType", "AutoAdjustType", cfn_parse.FromCloudFormation.getString(properties.AutoAdjustType)), ret.addPropertyResult("historicalOptions", "HistoricalOptions", properties.HistoricalOptions != null ? CfnBudgetHistoricalOptionsPropertyFromCloudFormation(properties.HistoricalOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBudget_BudgetDataPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoAdjustData", CfnBudget_AutoAdjustDataPropertyValidator)(properties.autoAdjustData)), errors.collect(cdk.propertyValidator("budgetLimit", CfnBudget_SpendPropertyValidator)(properties.budgetLimit)), errors.collect(cdk.propertyValidator("budgetName", cdk.validateString)(properties.budgetName)), errors.collect(cdk.propertyValidator("budgetType", cdk.requiredValidator)(properties.budgetType)), errors.collect(cdk.propertyValidator("budgetType", cdk.validateString)(properties.budgetType)), errors.collect(cdk.propertyValidator("costFilters", cdk.validateObject)(properties.costFilters)), errors.collect(cdk.propertyValidator("costTypes", CfnBudget_CostTypesPropertyValidator)(properties.costTypes)), errors.collect(cdk.propertyValidator("plannedBudgetLimits", cdk.validateObject)(properties.plannedBudgetLimits)), errors.collect(cdk.propertyValidator("timePeriod", CfnBudget_TimePeriodPropertyValidator)(properties.timePeriod)), errors.collect(cdk.propertyValidator("timeUnit", cdk.requiredValidator)(properties.timeUnit)), errors.collect(cdk.propertyValidator("timeUnit", cdk.validateString)(properties.timeUnit)), errors.wrap('supplied properties not correct for "BudgetDataProperty"');
    }
    function cfnBudgetBudgetDataPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBudget_BudgetDataPropertyValidator(properties).assertSuccess(), { AutoAdjustData: cfnBudgetAutoAdjustDataPropertyToCloudFormation(properties.autoAdjustData), BudgetLimit: cfnBudgetSpendPropertyToCloudFormation(properties.budgetLimit), BudgetName: cdk.stringToCloudFormation(properties.budgetName), BudgetType: cdk.stringToCloudFormation(properties.budgetType), CostFilters: cdk.objectToCloudFormation(properties.costFilters), CostTypes: cfnBudgetCostTypesPropertyToCloudFormation(properties.costTypes), PlannedBudgetLimits: cdk.objectToCloudFormation(properties.plannedBudgetLimits), TimePeriod: cfnBudgetTimePeriodPropertyToCloudFormation(properties.timePeriod), TimeUnit: cdk.stringToCloudFormation(properties.timeUnit) }) : properties;
    }
    function CfnBudgetBudgetDataPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("autoAdjustData", "AutoAdjustData", properties.AutoAdjustData != null ? CfnBudgetAutoAdjustDataPropertyFromCloudFormation(properties.AutoAdjustData) : void 0), ret.addPropertyResult("budgetLimit", "BudgetLimit", properties.BudgetLimit != null ? CfnBudgetSpendPropertyFromCloudFormation(properties.BudgetLimit) : void 0), ret.addPropertyResult("budgetName", "BudgetName", properties.BudgetName != null ? cfn_parse.FromCloudFormation.getString(properties.BudgetName) : void 0), ret.addPropertyResult("budgetType", "BudgetType", cfn_parse.FromCloudFormation.getString(properties.BudgetType)), ret.addPropertyResult("costFilters", "CostFilters", properties.CostFilters != null ? cfn_parse.FromCloudFormation.getAny(properties.CostFilters) : void 0), ret.addPropertyResult("costTypes", "CostTypes", properties.CostTypes != null ? CfnBudgetCostTypesPropertyFromCloudFormation(properties.CostTypes) : void 0), ret.addPropertyResult("plannedBudgetLimits", "PlannedBudgetLimits", properties.PlannedBudgetLimits != null ? cfn_parse.FromCloudFormation.getAny(properties.PlannedBudgetLimits) : void 0), ret.addPropertyResult("timePeriod", "TimePeriod", properties.TimePeriod != null ? CfnBudgetTimePeriodPropertyFromCloudFormation(properties.TimePeriod) : void 0), ret.addPropertyResult("timeUnit", "TimeUnit", cfn_parse.FromCloudFormation.getString(properties.TimeUnit)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBudget_CostTypesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("includeCredit", cdk.validateBoolean)(properties.includeCredit)), errors.collect(cdk.propertyValidator("includeDiscount", cdk.validateBoolean)(properties.includeDiscount)), errors.collect(cdk.propertyValidator("includeOtherSubscription", cdk.validateBoolean)(properties.includeOtherSubscription)), errors.collect(cdk.propertyValidator("includeRecurring", cdk.validateBoolean)(properties.includeRecurring)), errors.collect(cdk.propertyValidator("includeRefund", cdk.validateBoolean)(properties.includeRefund)), errors.collect(cdk.propertyValidator("includeSubscription", cdk.validateBoolean)(properties.includeSubscription)), errors.collect(cdk.propertyValidator("includeSupport", cdk.validateBoolean)(properties.includeSupport)), errors.collect(cdk.propertyValidator("includeTax", cdk.validateBoolean)(properties.includeTax)), errors.collect(cdk.propertyValidator("includeUpfront", cdk.validateBoolean)(properties.includeUpfront)), errors.collect(cdk.propertyValidator("useAmortized", cdk.validateBoolean)(properties.useAmortized)), errors.collect(cdk.propertyValidator("useBlended", cdk.validateBoolean)(properties.useBlended)), errors.wrap('supplied properties not correct for "CostTypesProperty"');
    }
    function cfnBudgetCostTypesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBudget_CostTypesPropertyValidator(properties).assertSuccess(), { IncludeCredit: cdk.booleanToCloudFormation(properties.includeCredit), IncludeDiscount: cdk.booleanToCloudFormation(properties.includeDiscount), IncludeOtherSubscription: cdk.booleanToCloudFormation(properties.includeOtherSubscription), IncludeRecurring: cdk.booleanToCloudFormation(properties.includeRecurring), IncludeRefund: cdk.booleanToCloudFormation(properties.includeRefund), IncludeSubscription: cdk.booleanToCloudFormation(properties.includeSubscription), IncludeSupport: cdk.booleanToCloudFormation(properties.includeSupport), IncludeTax: cdk.booleanToCloudFormation(properties.includeTax), IncludeUpfront: cdk.booleanToCloudFormation(properties.includeUpfront), UseAmortized: cdk.booleanToCloudFormation(properties.useAmortized), UseBlended: cdk.booleanToCloudFormation(properties.useBlended) }) : properties;
    }
    function CfnBudgetCostTypesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("includeCredit", "IncludeCredit", properties.IncludeCredit != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeCredit) : void 0), ret.addPropertyResult("includeDiscount", "IncludeDiscount", properties.IncludeDiscount != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeDiscount) : void 0), ret.addPropertyResult("includeOtherSubscription", "IncludeOtherSubscription", properties.IncludeOtherSubscription != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeOtherSubscription) : void 0), ret.addPropertyResult("includeRecurring", "IncludeRecurring", properties.IncludeRecurring != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeRecurring) : void 0), ret.addPropertyResult("includeRefund", "IncludeRefund", properties.IncludeRefund != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeRefund) : void 0), ret.addPropertyResult("includeSubscription", "IncludeSubscription", properties.IncludeSubscription != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeSubscription) : void 0), ret.addPropertyResult("includeSupport", "IncludeSupport", properties.IncludeSupport != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeSupport) : void 0), ret.addPropertyResult("includeTax", "IncludeTax", properties.IncludeTax != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeTax) : void 0), ret.addPropertyResult("includeUpfront", "IncludeUpfront", properties.IncludeUpfront != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeUpfront) : void 0), ret.addPropertyResult("useAmortized", "UseAmortized", properties.UseAmortized != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseAmortized) : void 0), ret.addPropertyResult("useBlended", "UseBlended", properties.UseBlended != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseBlended) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBudget_HistoricalOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("budgetAdjustmentPeriod", cdk.requiredValidator)(properties.budgetAdjustmentPeriod)), errors.collect(cdk.propertyValidator("budgetAdjustmentPeriod", cdk.validateNumber)(properties.budgetAdjustmentPeriod)), errors.wrap('supplied properties not correct for "HistoricalOptionsProperty"');
    }
    function cfnBudgetHistoricalOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBudget_HistoricalOptionsPropertyValidator(properties).assertSuccess(), { BudgetAdjustmentPeriod: cdk.numberToCloudFormation(properties.budgetAdjustmentPeriod) }) : properties;
    }
    function CfnBudgetHistoricalOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("budgetAdjustmentPeriod", "BudgetAdjustmentPeriod", cfn_parse.FromCloudFormation.getNumber(properties.BudgetAdjustmentPeriod)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBudget_NotificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("comparisonOperator", cdk.requiredValidator)(properties.comparisonOperator)), errors.collect(cdk.propertyValidator("comparisonOperator", cdk.validateString)(properties.comparisonOperator)), errors.collect(cdk.propertyValidator("notificationType", cdk.requiredValidator)(properties.notificationType)), errors.collect(cdk.propertyValidator("notificationType", cdk.validateString)(properties.notificationType)), errors.collect(cdk.propertyValidator("threshold", cdk.requiredValidator)(properties.threshold)), errors.collect(cdk.propertyValidator("threshold", cdk.validateNumber)(properties.threshold)), errors.collect(cdk.propertyValidator("thresholdType", cdk.validateString)(properties.thresholdType)), errors.wrap('supplied properties not correct for "NotificationProperty"');
    }
    function cfnBudgetNotificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBudget_NotificationPropertyValidator(properties).assertSuccess(), { ComparisonOperator: cdk.stringToCloudFormation(properties.comparisonOperator), NotificationType: cdk.stringToCloudFormation(properties.notificationType), Threshold: cdk.numberToCloudFormation(properties.threshold), ThresholdType: cdk.stringToCloudFormation(properties.thresholdType) }) : properties;
    }
    function CfnBudgetNotificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("comparisonOperator", "ComparisonOperator", cfn_parse.FromCloudFormation.getString(properties.ComparisonOperator)), ret.addPropertyResult("notificationType", "NotificationType", cfn_parse.FromCloudFormation.getString(properties.NotificationType)), ret.addPropertyResult("threshold", "Threshold", cfn_parse.FromCloudFormation.getNumber(properties.Threshold)), ret.addPropertyResult("thresholdType", "ThresholdType", properties.ThresholdType != null ? cfn_parse.FromCloudFormation.getString(properties.ThresholdType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBudget_NotificationWithSubscribersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("notification", cdk.requiredValidator)(properties.notification)), errors.collect(cdk.propertyValidator("notification", CfnBudget_NotificationPropertyValidator)(properties.notification)), errors.collect(cdk.propertyValidator("subscribers", cdk.requiredValidator)(properties.subscribers)), errors.collect(cdk.propertyValidator("subscribers", cdk.listValidator(CfnBudget_SubscriberPropertyValidator))(properties.subscribers)), errors.wrap('supplied properties not correct for "NotificationWithSubscribersProperty"');
    }
    function cfnBudgetNotificationWithSubscribersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBudget_NotificationWithSubscribersPropertyValidator(properties).assertSuccess(), { Notification: cfnBudgetNotificationPropertyToCloudFormation(properties.notification), Subscribers: cdk.listMapper(cfnBudgetSubscriberPropertyToCloudFormation)(properties.subscribers) }) : properties;
    }
    function CfnBudgetNotificationWithSubscribersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("notification", "Notification", CfnBudgetNotificationPropertyFromCloudFormation(properties.Notification)), ret.addPropertyResult("subscribers", "Subscribers", cfn_parse.FromCloudFormation.getArray(CfnBudgetSubscriberPropertyFromCloudFormation)(properties.Subscribers)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBudget_SpendPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("amount", cdk.requiredValidator)(properties.amount)), errors.collect(cdk.propertyValidator("amount", cdk.validateNumber)(properties.amount)), errors.collect(cdk.propertyValidator("unit", cdk.requiredValidator)(properties.unit)), errors.collect(cdk.propertyValidator("unit", cdk.validateString)(properties.unit)), errors.wrap('supplied properties not correct for "SpendProperty"');
    }
    function cfnBudgetSpendPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBudget_SpendPropertyValidator(properties).assertSuccess(), { Amount: cdk.numberToCloudFormation(properties.amount), Unit: cdk.stringToCloudFormation(properties.unit) }) : properties;
    }
    function CfnBudgetSpendPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("amount", "Amount", cfn_parse.FromCloudFormation.getNumber(properties.Amount)), ret.addPropertyResult("unit", "Unit", cfn_parse.FromCloudFormation.getString(properties.Unit)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBudget_SubscriberPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("address", cdk.requiredValidator)(properties.address)), errors.collect(cdk.propertyValidator("address", cdk.validateString)(properties.address)), errors.collect(cdk.propertyValidator("subscriptionType", cdk.requiredValidator)(properties.subscriptionType)), errors.collect(cdk.propertyValidator("subscriptionType", cdk.validateString)(properties.subscriptionType)), errors.wrap('supplied properties not correct for "SubscriberProperty"');
    }
    function cfnBudgetSubscriberPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBudget_SubscriberPropertyValidator(properties).assertSuccess(), { Address: cdk.stringToCloudFormation(properties.address), SubscriptionType: cdk.stringToCloudFormation(properties.subscriptionType) }) : properties;
    }
    function CfnBudgetSubscriberPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("address", "Address", cfn_parse.FromCloudFormation.getString(properties.Address)), ret.addPropertyResult("subscriptionType", "SubscriptionType", cfn_parse.FromCloudFormation.getString(properties.SubscriptionType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBudget_TimePeriodPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("end", cdk.validateString)(properties.end)), errors.collect(cdk.propertyValidator("start", cdk.validateString)(properties.start)), errors.wrap('supplied properties not correct for "TimePeriodProperty"');
    }
    function cfnBudgetTimePeriodPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBudget_TimePeriodPropertyValidator(properties).assertSuccess(), { End: cdk.stringToCloudFormation(properties.end), Start: cdk.stringToCloudFormation(properties.start) }) : properties;
    }
    function CfnBudgetTimePeriodPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("end", "End", properties.End != null ? cfn_parse.FromCloudFormation.getString(properties.End) : void 0), ret.addPropertyResult("start", "Start", properties.Start != null ? cfn_parse.FromCloudFormation.getString(properties.Start) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBudgetsActionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actionThreshold", cdk.requiredValidator)(properties.actionThreshold)), errors.collect(cdk.propertyValidator("actionThreshold", CfnBudgetsAction_ActionThresholdPropertyValidator)(properties.actionThreshold)), errors.collect(cdk.propertyValidator("actionType", cdk.requiredValidator)(properties.actionType)), errors.collect(cdk.propertyValidator("actionType", cdk.validateString)(properties.actionType)), errors.collect(cdk.propertyValidator("approvalModel", cdk.validateString)(properties.approvalModel)), errors.collect(cdk.propertyValidator("budgetName", cdk.requiredValidator)(properties.budgetName)), errors.collect(cdk.propertyValidator("budgetName", cdk.validateString)(properties.budgetName)), errors.collect(cdk.propertyValidator("definition", cdk.requiredValidator)(properties.definition)), errors.collect(cdk.propertyValidator("definition", CfnBudgetsAction_DefinitionPropertyValidator)(properties.definition)), errors.collect(cdk.propertyValidator("executionRoleArn", cdk.requiredValidator)(properties.executionRoleArn)), errors.collect(cdk.propertyValidator("executionRoleArn", cdk.validateString)(properties.executionRoleArn)), errors.collect(cdk.propertyValidator("notificationType", cdk.requiredValidator)(properties.notificationType)), errors.collect(cdk.propertyValidator("notificationType", cdk.validateString)(properties.notificationType)), errors.collect(cdk.propertyValidator("subscribers", cdk.requiredValidator)(properties.subscribers)), errors.collect(cdk.propertyValidator("subscribers", cdk.listValidator(CfnBudgetsAction_SubscriberPropertyValidator))(properties.subscribers)), errors.wrap('supplied properties not correct for "CfnBudgetsActionProps"');
    }
    function cfnBudgetsActionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBudgetsActionPropsValidator(properties).assertSuccess(), { ActionThreshold: cfnBudgetsActionActionThresholdPropertyToCloudFormation(properties.actionThreshold), ActionType: cdk.stringToCloudFormation(properties.actionType), BudgetName: cdk.stringToCloudFormation(properties.budgetName), Definition: cfnBudgetsActionDefinitionPropertyToCloudFormation(properties.definition), ExecutionRoleArn: cdk.stringToCloudFormation(properties.executionRoleArn), NotificationType: cdk.stringToCloudFormation(properties.notificationType), Subscribers: cdk.listMapper(cfnBudgetsActionSubscriberPropertyToCloudFormation)(properties.subscribers), ApprovalModel: cdk.stringToCloudFormation(properties.approvalModel) }) : properties;
    }
    function CfnBudgetsActionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actionThreshold", "ActionThreshold", CfnBudgetsActionActionThresholdPropertyFromCloudFormation(properties.ActionThreshold)), ret.addPropertyResult("actionType", "ActionType", cfn_parse.FromCloudFormation.getString(properties.ActionType)), ret.addPropertyResult("budgetName", "BudgetName", cfn_parse.FromCloudFormation.getString(properties.BudgetName)), ret.addPropertyResult("definition", "Definition", CfnBudgetsActionDefinitionPropertyFromCloudFormation(properties.Definition)), ret.addPropertyResult("executionRoleArn", "ExecutionRoleArn", cfn_parse.FromCloudFormation.getString(properties.ExecutionRoleArn)), ret.addPropertyResult("notificationType", "NotificationType", cfn_parse.FromCloudFormation.getString(properties.NotificationType)), ret.addPropertyResult("subscribers", "Subscribers", cfn_parse.FromCloudFormation.getArray(CfnBudgetsActionSubscriberPropertyFromCloudFormation)(properties.Subscribers)), ret.addPropertyResult("approvalModel", "ApprovalModel", properties.ApprovalModel != null ? cfn_parse.FromCloudFormation.getString(properties.ApprovalModel) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnBudgetsAction = class _CfnBudgetsAction extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnBudgetsActionPropsFromCloudFormation(resourceProperties), ret = new _CfnBudgetsAction(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnBudgetsAction.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_budgets_CfnBudgetsActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnBudgetsAction), error;
        }
        cdk.requireProperty(props, "actionThreshold", this), cdk.requireProperty(props, "actionType", this), cdk.requireProperty(props, "budgetName", this), cdk.requireProperty(props, "definition", this), cdk.requireProperty(props, "executionRoleArn", this), cdk.requireProperty(props, "notificationType", this), cdk.requireProperty(props, "subscribers", this), this.attrActionId = cdk.Token.asString(this.getAtt("ActionId", cdk.ResolutionTypeHint.STRING)), this.actionThreshold = props.actionThreshold, this.actionType = props.actionType, this.budgetName = props.budgetName, this.definition = props.definition, this.executionRoleArn = props.executionRoleArn, this.notificationType = props.notificationType, this.subscribers = props.subscribers, this.approvalModel = props.approvalModel;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnBudgetsAction.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { actionThreshold: this.actionThreshold, actionType: this.actionType, budgetName: this.budgetName, definition: this.definition, executionRoleArn: this.executionRoleArn, notificationType: this.notificationType, subscribers: this.subscribers, approvalModel: this.approvalModel };
      }
      renderProperties(props) {
        return cfnBudgetsActionPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnBudgetsAction[_b] = { fqn: "aws-cdk-lib.aws_budgets.CfnBudgetsAction", version: "2.80.0" }, CfnBudgetsAction.CFN_RESOURCE_TYPE_NAME = "AWS::Budgets::BudgetsAction", exports2.CfnBudgetsAction = CfnBudgetsAction;
    function CfnBudgetsAction_ActionThresholdPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "ActionThresholdProperty"');
    }
    function cfnBudgetsActionActionThresholdPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBudgetsAction_ActionThresholdPropertyValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type), Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnBudgetsActionActionThresholdPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getNumber(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBudgetsAction_DefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("iamActionDefinition", CfnBudgetsAction_IamActionDefinitionPropertyValidator)(properties.iamActionDefinition)), errors.collect(cdk.propertyValidator("scpActionDefinition", CfnBudgetsAction_ScpActionDefinitionPropertyValidator)(properties.scpActionDefinition)), errors.collect(cdk.propertyValidator("ssmActionDefinition", CfnBudgetsAction_SsmActionDefinitionPropertyValidator)(properties.ssmActionDefinition)), errors.wrap('supplied properties not correct for "DefinitionProperty"');
    }
    function cfnBudgetsActionDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBudgetsAction_DefinitionPropertyValidator(properties).assertSuccess(), { IamActionDefinition: cfnBudgetsActionIamActionDefinitionPropertyToCloudFormation(properties.iamActionDefinition), ScpActionDefinition: cfnBudgetsActionScpActionDefinitionPropertyToCloudFormation(properties.scpActionDefinition), SsmActionDefinition: cfnBudgetsActionSsmActionDefinitionPropertyToCloudFormation(properties.ssmActionDefinition) }) : properties;
    }
    function CfnBudgetsActionDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("iamActionDefinition", "IamActionDefinition", properties.IamActionDefinition != null ? CfnBudgetsActionIamActionDefinitionPropertyFromCloudFormation(properties.IamActionDefinition) : void 0), ret.addPropertyResult("scpActionDefinition", "ScpActionDefinition", properties.ScpActionDefinition != null ? CfnBudgetsActionScpActionDefinitionPropertyFromCloudFormation(properties.ScpActionDefinition) : void 0), ret.addPropertyResult("ssmActionDefinition", "SsmActionDefinition", properties.SsmActionDefinition != null ? CfnBudgetsActionSsmActionDefinitionPropertyFromCloudFormation(properties.SsmActionDefinition) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBudgetsAction_IamActionDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groups", cdk.listValidator(cdk.validateString))(properties.groups)), errors.collect(cdk.propertyValidator("policyArn", cdk.requiredValidator)(properties.policyArn)), errors.collect(cdk.propertyValidator("policyArn", cdk.validateString)(properties.policyArn)), errors.collect(cdk.propertyValidator("roles", cdk.listValidator(cdk.validateString))(properties.roles)), errors.collect(cdk.propertyValidator("users", cdk.listValidator(cdk.validateString))(properties.users)), errors.wrap('supplied properties not correct for "IamActionDefinitionProperty"');
    }
    function cfnBudgetsActionIamActionDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBudgetsAction_IamActionDefinitionPropertyValidator(properties).assertSuccess(), { Groups: cdk.listMapper(cdk.stringToCloudFormation)(properties.groups), PolicyArn: cdk.stringToCloudFormation(properties.policyArn), Roles: cdk.listMapper(cdk.stringToCloudFormation)(properties.roles), Users: cdk.listMapper(cdk.stringToCloudFormation)(properties.users) }) : properties;
    }
    function CfnBudgetsActionIamActionDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groups", "Groups", properties.Groups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Groups) : void 0), ret.addPropertyResult("policyArn", "PolicyArn", cfn_parse.FromCloudFormation.getString(properties.PolicyArn)), ret.addPropertyResult("roles", "Roles", properties.Roles != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Roles) : void 0), ret.addPropertyResult("users", "Users", properties.Users != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Users) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBudgetsAction_ScpActionDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("policyId", cdk.requiredValidator)(properties.policyId)), errors.collect(cdk.propertyValidator("policyId", cdk.validateString)(properties.policyId)), errors.collect(cdk.propertyValidator("targetIds", cdk.requiredValidator)(properties.targetIds)), errors.collect(cdk.propertyValidator("targetIds", cdk.listValidator(cdk.validateString))(properties.targetIds)), errors.wrap('supplied properties not correct for "ScpActionDefinitionProperty"');
    }
    function cfnBudgetsActionScpActionDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBudgetsAction_ScpActionDefinitionPropertyValidator(properties).assertSuccess(), { PolicyId: cdk.stringToCloudFormation(properties.policyId), TargetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.targetIds) }) : properties;
    }
    function CfnBudgetsActionScpActionDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("policyId", "PolicyId", cfn_parse.FromCloudFormation.getString(properties.PolicyId)), ret.addPropertyResult("targetIds", "TargetIds", cfn_parse.FromCloudFormation.getStringArray(properties.TargetIds)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBudgetsAction_SsmActionDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceIds", cdk.requiredValidator)(properties.instanceIds)), errors.collect(cdk.propertyValidator("instanceIds", cdk.listValidator(cdk.validateString))(properties.instanceIds)), errors.collect(cdk.propertyValidator("region", cdk.requiredValidator)(properties.region)), errors.collect(cdk.propertyValidator("region", cdk.validateString)(properties.region)), errors.collect(cdk.propertyValidator("subtype", cdk.requiredValidator)(properties.subtype)), errors.collect(cdk.propertyValidator("subtype", cdk.validateString)(properties.subtype)), errors.wrap('supplied properties not correct for "SsmActionDefinitionProperty"');
    }
    function cfnBudgetsActionSsmActionDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBudgetsAction_SsmActionDefinitionPropertyValidator(properties).assertSuccess(), { InstanceIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.instanceIds), Region: cdk.stringToCloudFormation(properties.region), Subtype: cdk.stringToCloudFormation(properties.subtype) }) : properties;
    }
    function CfnBudgetsActionSsmActionDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceIds", "InstanceIds", cfn_parse.FromCloudFormation.getStringArray(properties.InstanceIds)), ret.addPropertyResult("region", "Region", cfn_parse.FromCloudFormation.getString(properties.Region)), ret.addPropertyResult("subtype", "Subtype", cfn_parse.FromCloudFormation.getString(properties.Subtype)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBudgetsAction_SubscriberPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("address", cdk.requiredValidator)(properties.address)), errors.collect(cdk.propertyValidator("address", cdk.validateString)(properties.address)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "SubscriberProperty"');
    }
    function cfnBudgetsActionSubscriberPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBudgetsAction_SubscriberPropertyValidator(properties).assertSuccess(), { Address: cdk.stringToCloudFormation(properties.address), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnBudgetsActionSubscriberPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("address", "Address", cfn_parse.FromCloudFormation.getString(properties.Address)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-budgets/lib/index.js
var require_lib65 = __commonJS({
  "node_modules/aws-cdk-lib/aws-budgets/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_budgets_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-budgets/index.js
var require_aws_budgets = __commonJS({
  "node_modules/aws-cdk-lib/aws-budgets/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib65(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-cassandra/lib/cassandra.generated.js
var require_cassandra_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-cassandra/lib/cassandra.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnTable = exports2.CfnKeyspace = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnKeyspacePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("keyspaceName", cdk.validateString)(properties.keyspaceName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnKeyspaceProps"');
    }
    function cfnKeyspacePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnKeyspacePropsValidator(properties).assertSuccess(), { KeyspaceName: cdk.stringToCloudFormation(properties.keyspaceName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnKeyspacePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("keyspaceName", "KeyspaceName", properties.KeyspaceName != null ? cfn_parse.FromCloudFormation.getString(properties.KeyspaceName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnKeyspace = class _CfnKeyspace extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnKeyspacePropsFromCloudFormation(resourceProperties), ret = new _CfnKeyspace(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnKeyspace.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cassandra_CfnKeyspaceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnKeyspace), error;
        }
        this.keyspaceName = props.keyspaceName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Cassandra::Keyspace", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnKeyspace.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { keyspaceName: this.keyspaceName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnKeyspacePropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnKeyspace[_a] = { fqn: "aws-cdk-lib.aws_cassandra.CfnKeyspace", version: "2.80.0" }, CfnKeyspace.CFN_RESOURCE_TYPE_NAME = "AWS::Cassandra::Keyspace", exports2.CfnKeyspace = CfnKeyspace;
    function CfnTablePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("billingMode", CfnTable_BillingModePropertyValidator)(properties.billingMode)), errors.collect(cdk.propertyValidator("clientSideTimestampsEnabled", cdk.validateBoolean)(properties.clientSideTimestampsEnabled)), errors.collect(cdk.propertyValidator("clusteringKeyColumns", cdk.listValidator(CfnTable_ClusteringKeyColumnPropertyValidator))(properties.clusteringKeyColumns)), errors.collect(cdk.propertyValidator("defaultTimeToLive", cdk.validateNumber)(properties.defaultTimeToLive)), errors.collect(cdk.propertyValidator("encryptionSpecification", CfnTable_EncryptionSpecificationPropertyValidator)(properties.encryptionSpecification)), errors.collect(cdk.propertyValidator("keyspaceName", cdk.requiredValidator)(properties.keyspaceName)), errors.collect(cdk.propertyValidator("keyspaceName", cdk.validateString)(properties.keyspaceName)), errors.collect(cdk.propertyValidator("partitionKeyColumns", cdk.requiredValidator)(properties.partitionKeyColumns)), errors.collect(cdk.propertyValidator("partitionKeyColumns", cdk.listValidator(CfnTable_ColumnPropertyValidator))(properties.partitionKeyColumns)), errors.collect(cdk.propertyValidator("pointInTimeRecoveryEnabled", cdk.validateBoolean)(properties.pointInTimeRecoveryEnabled)), errors.collect(cdk.propertyValidator("regularColumns", cdk.listValidator(CfnTable_ColumnPropertyValidator))(properties.regularColumns)), errors.collect(cdk.propertyValidator("tableName", cdk.validateString)(properties.tableName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnTableProps"');
    }
    function cfnTablePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTablePropsValidator(properties).assertSuccess(), { KeyspaceName: cdk.stringToCloudFormation(properties.keyspaceName), PartitionKeyColumns: cdk.listMapper(cfnTableColumnPropertyToCloudFormation)(properties.partitionKeyColumns), BillingMode: cfnTableBillingModePropertyToCloudFormation(properties.billingMode), ClientSideTimestampsEnabled: cdk.booleanToCloudFormation(properties.clientSideTimestampsEnabled), ClusteringKeyColumns: cdk.listMapper(cfnTableClusteringKeyColumnPropertyToCloudFormation)(properties.clusteringKeyColumns), DefaultTimeToLive: cdk.numberToCloudFormation(properties.defaultTimeToLive), EncryptionSpecification: cfnTableEncryptionSpecificationPropertyToCloudFormation(properties.encryptionSpecification), PointInTimeRecoveryEnabled: cdk.booleanToCloudFormation(properties.pointInTimeRecoveryEnabled), RegularColumns: cdk.listMapper(cfnTableColumnPropertyToCloudFormation)(properties.regularColumns), TableName: cdk.stringToCloudFormation(properties.tableName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnTablePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("keyspaceName", "KeyspaceName", cfn_parse.FromCloudFormation.getString(properties.KeyspaceName)), ret.addPropertyResult("partitionKeyColumns", "PartitionKeyColumns", cfn_parse.FromCloudFormation.getArray(CfnTableColumnPropertyFromCloudFormation)(properties.PartitionKeyColumns)), ret.addPropertyResult("billingMode", "BillingMode", properties.BillingMode != null ? CfnTableBillingModePropertyFromCloudFormation(properties.BillingMode) : void 0), ret.addPropertyResult("clientSideTimestampsEnabled", "ClientSideTimestampsEnabled", properties.ClientSideTimestampsEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ClientSideTimestampsEnabled) : void 0), ret.addPropertyResult("clusteringKeyColumns", "ClusteringKeyColumns", properties.ClusteringKeyColumns != null ? cfn_parse.FromCloudFormation.getArray(CfnTableClusteringKeyColumnPropertyFromCloudFormation)(properties.ClusteringKeyColumns) : void 0), ret.addPropertyResult("defaultTimeToLive", "DefaultTimeToLive", properties.DefaultTimeToLive != null ? cfn_parse.FromCloudFormation.getNumber(properties.DefaultTimeToLive) : void 0), ret.addPropertyResult("encryptionSpecification", "EncryptionSpecification", properties.EncryptionSpecification != null ? CfnTableEncryptionSpecificationPropertyFromCloudFormation(properties.EncryptionSpecification) : void 0), ret.addPropertyResult("pointInTimeRecoveryEnabled", "PointInTimeRecoveryEnabled", properties.PointInTimeRecoveryEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.PointInTimeRecoveryEnabled) : void 0), ret.addPropertyResult("regularColumns", "RegularColumns", properties.RegularColumns != null ? cfn_parse.FromCloudFormation.getArray(CfnTableColumnPropertyFromCloudFormation)(properties.RegularColumns) : void 0), ret.addPropertyResult("tableName", "TableName", properties.TableName != null ? cfn_parse.FromCloudFormation.getString(properties.TableName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTable = class _CfnTable extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTablePropsFromCloudFormation(resourceProperties), ret = new _CfnTable(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTable.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cassandra_CfnTableProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTable), error;
        }
        cdk.requireProperty(props, "keyspaceName", this), cdk.requireProperty(props, "partitionKeyColumns", this), this.keyspaceName = props.keyspaceName, this.partitionKeyColumns = props.partitionKeyColumns, this.billingMode = props.billingMode, this.clientSideTimestampsEnabled = props.clientSideTimestampsEnabled, this.clusteringKeyColumns = props.clusteringKeyColumns, this.defaultTimeToLive = props.defaultTimeToLive, this.encryptionSpecification = props.encryptionSpecification, this.pointInTimeRecoveryEnabled = props.pointInTimeRecoveryEnabled, this.regularColumns = props.regularColumns, this.tableName = props.tableName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Cassandra::Table", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTable.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { keyspaceName: this.keyspaceName, partitionKeyColumns: this.partitionKeyColumns, billingMode: this.billingMode, clientSideTimestampsEnabled: this.clientSideTimestampsEnabled, clusteringKeyColumns: this.clusteringKeyColumns, defaultTimeToLive: this.defaultTimeToLive, encryptionSpecification: this.encryptionSpecification, pointInTimeRecoveryEnabled: this.pointInTimeRecoveryEnabled, regularColumns: this.regularColumns, tableName: this.tableName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnTablePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnTable[_b] = { fqn: "aws-cdk-lib.aws_cassandra.CfnTable", version: "2.80.0" }, CfnTable.CFN_RESOURCE_TYPE_NAME = "AWS::Cassandra::Table", exports2.CfnTable = CfnTable;
    function CfnTable_BillingModePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mode", cdk.requiredValidator)(properties.mode)), errors.collect(cdk.propertyValidator("mode", cdk.validateString)(properties.mode)), errors.collect(cdk.propertyValidator("provisionedThroughput", CfnTable_ProvisionedThroughputPropertyValidator)(properties.provisionedThroughput)), errors.wrap('supplied properties not correct for "BillingModeProperty"');
    }
    function cfnTableBillingModePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTable_BillingModePropertyValidator(properties).assertSuccess(), { Mode: cdk.stringToCloudFormation(properties.mode), ProvisionedThroughput: cfnTableProvisionedThroughputPropertyToCloudFormation(properties.provisionedThroughput) }) : properties;
    }
    function CfnTableBillingModePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mode", "Mode", cfn_parse.FromCloudFormation.getString(properties.Mode)), ret.addPropertyResult("provisionedThroughput", "ProvisionedThroughput", properties.ProvisionedThroughput != null ? CfnTableProvisionedThroughputPropertyFromCloudFormation(properties.ProvisionedThroughput) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTable_ClusteringKeyColumnPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnTable_ColumnPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("orderBy", cdk.validateString)(properties.orderBy)), errors.wrap('supplied properties not correct for "ClusteringKeyColumnProperty"');
    }
    function cfnTableClusteringKeyColumnPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTable_ClusteringKeyColumnPropertyValidator(properties).assertSuccess(), { Column: cfnTableColumnPropertyToCloudFormation(properties.column), OrderBy: cdk.stringToCloudFormation(properties.orderBy) }) : properties;
    }
    function CfnTableClusteringKeyColumnPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", CfnTableColumnPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("orderBy", "OrderBy", properties.OrderBy != null ? cfn_parse.FromCloudFormation.getString(properties.OrderBy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTable_ColumnPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnName", cdk.requiredValidator)(properties.columnName)), errors.collect(cdk.propertyValidator("columnName", cdk.validateString)(properties.columnName)), errors.collect(cdk.propertyValidator("columnType", cdk.requiredValidator)(properties.columnType)), errors.collect(cdk.propertyValidator("columnType", cdk.validateString)(properties.columnType)), errors.wrap('supplied properties not correct for "ColumnProperty"');
    }
    function cfnTableColumnPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTable_ColumnPropertyValidator(properties).assertSuccess(), { ColumnName: cdk.stringToCloudFormation(properties.columnName), ColumnType: cdk.stringToCloudFormation(properties.columnType) }) : properties;
    }
    function CfnTableColumnPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columnName", "ColumnName", cfn_parse.FromCloudFormation.getString(properties.ColumnName)), ret.addPropertyResult("columnType", "ColumnType", cfn_parse.FromCloudFormation.getString(properties.ColumnType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTable_EncryptionSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("encryptionType", cdk.requiredValidator)(properties.encryptionType)), errors.collect(cdk.propertyValidator("encryptionType", cdk.validateString)(properties.encryptionType)), errors.collect(cdk.propertyValidator("kmsKeyIdentifier", cdk.validateString)(properties.kmsKeyIdentifier)), errors.wrap('supplied properties not correct for "EncryptionSpecificationProperty"');
    }
    function cfnTableEncryptionSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTable_EncryptionSpecificationPropertyValidator(properties).assertSuccess(), { EncryptionType: cdk.stringToCloudFormation(properties.encryptionType), KmsKeyIdentifier: cdk.stringToCloudFormation(properties.kmsKeyIdentifier) }) : properties;
    }
    function CfnTableEncryptionSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("encryptionType", "EncryptionType", cfn_parse.FromCloudFormation.getString(properties.EncryptionType)), ret.addPropertyResult("kmsKeyIdentifier", "KmsKeyIdentifier", properties.KmsKeyIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyIdentifier) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTable_ProvisionedThroughputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("readCapacityUnits", cdk.requiredValidator)(properties.readCapacityUnits)), errors.collect(cdk.propertyValidator("readCapacityUnits", cdk.validateNumber)(properties.readCapacityUnits)), errors.collect(cdk.propertyValidator("writeCapacityUnits", cdk.requiredValidator)(properties.writeCapacityUnits)), errors.collect(cdk.propertyValidator("writeCapacityUnits", cdk.validateNumber)(properties.writeCapacityUnits)), errors.wrap('supplied properties not correct for "ProvisionedThroughputProperty"');
    }
    function cfnTableProvisionedThroughputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTable_ProvisionedThroughputPropertyValidator(properties).assertSuccess(), { ReadCapacityUnits: cdk.numberToCloudFormation(properties.readCapacityUnits), WriteCapacityUnits: cdk.numberToCloudFormation(properties.writeCapacityUnits) }) : properties;
    }
    function CfnTableProvisionedThroughputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("readCapacityUnits", "ReadCapacityUnits", cfn_parse.FromCloudFormation.getNumber(properties.ReadCapacityUnits)), ret.addPropertyResult("writeCapacityUnits", "WriteCapacityUnits", cfn_parse.FromCloudFormation.getNumber(properties.WriteCapacityUnits)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-cassandra/lib/index.js
var require_lib66 = __commonJS({
  "node_modules/aws-cdk-lib/aws-cassandra/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_cassandra_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-cassandra/index.js
var require_aws_cassandra = __commonJS({
  "node_modules/aws-cdk-lib/aws-cassandra/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib66(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-ce/lib/ce.generated.js
var require_ce_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-ce/lib/ce.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnCostCategory = exports2.CfnAnomalySubscription = exports2.CfnAnomalyMonitor = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAnomalyMonitorPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("monitorDimension", cdk.validateString)(properties.monitorDimension)), errors.collect(cdk.propertyValidator("monitorName", cdk.requiredValidator)(properties.monitorName)), errors.collect(cdk.propertyValidator("monitorName", cdk.validateString)(properties.monitorName)), errors.collect(cdk.propertyValidator("monitorSpecification", cdk.validateString)(properties.monitorSpecification)), errors.collect(cdk.propertyValidator("monitorType", cdk.requiredValidator)(properties.monitorType)), errors.collect(cdk.propertyValidator("monitorType", cdk.validateString)(properties.monitorType)), errors.collect(cdk.propertyValidator("resourceTags", cdk.listValidator(CfnAnomalyMonitor_ResourceTagPropertyValidator))(properties.resourceTags)), errors.wrap('supplied properties not correct for "CfnAnomalyMonitorProps"');
    }
    function cfnAnomalyMonitorPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnomalyMonitorPropsValidator(properties).assertSuccess(), { MonitorName: cdk.stringToCloudFormation(properties.monitorName), MonitorType: cdk.stringToCloudFormation(properties.monitorType), MonitorDimension: cdk.stringToCloudFormation(properties.monitorDimension), MonitorSpecification: cdk.stringToCloudFormation(properties.monitorSpecification), ResourceTags: cdk.listMapper(cfnAnomalyMonitorResourceTagPropertyToCloudFormation)(properties.resourceTags) }) : properties;
    }
    function CfnAnomalyMonitorPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("monitorName", "MonitorName", cfn_parse.FromCloudFormation.getString(properties.MonitorName)), ret.addPropertyResult("monitorType", "MonitorType", cfn_parse.FromCloudFormation.getString(properties.MonitorType)), ret.addPropertyResult("monitorDimension", "MonitorDimension", properties.MonitorDimension != null ? cfn_parse.FromCloudFormation.getString(properties.MonitorDimension) : void 0), ret.addPropertyResult("monitorSpecification", "MonitorSpecification", properties.MonitorSpecification != null ? cfn_parse.FromCloudFormation.getString(properties.MonitorSpecification) : void 0), ret.addPropertyResult("resourceTags", "ResourceTags", properties.ResourceTags != null ? cfn_parse.FromCloudFormation.getArray(CfnAnomalyMonitorResourceTagPropertyFromCloudFormation)(properties.ResourceTags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAnomalyMonitor = class _CfnAnomalyMonitor extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAnomalyMonitorPropsFromCloudFormation(resourceProperties), ret = new _CfnAnomalyMonitor(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAnomalyMonitor.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ce_CfnAnomalyMonitorProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAnomalyMonitor), error;
        }
        cdk.requireProperty(props, "monitorName", this), cdk.requireProperty(props, "monitorType", this), this.attrCreationDate = cdk.Token.asString(this.getAtt("CreationDate", cdk.ResolutionTypeHint.STRING)), this.attrDimensionalValueCount = cdk.Token.asNumber(this.getAtt("DimensionalValueCount", cdk.ResolutionTypeHint.NUMBER)), this.attrLastEvaluatedDate = cdk.Token.asString(this.getAtt("LastEvaluatedDate", cdk.ResolutionTypeHint.STRING)), this.attrLastUpdatedDate = cdk.Token.asString(this.getAtt("LastUpdatedDate", cdk.ResolutionTypeHint.STRING)), this.attrMonitorArn = cdk.Token.asString(this.getAtt("MonitorArn", cdk.ResolutionTypeHint.STRING)), this.monitorName = props.monitorName, this.monitorType = props.monitorType, this.monitorDimension = props.monitorDimension, this.monitorSpecification = props.monitorSpecification, this.resourceTags = props.resourceTags;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAnomalyMonitor.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { monitorName: this.monitorName, monitorType: this.monitorType, monitorDimension: this.monitorDimension, monitorSpecification: this.monitorSpecification, resourceTags: this.resourceTags };
      }
      renderProperties(props) {
        return cfnAnomalyMonitorPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAnomalyMonitor[_a] = { fqn: "aws-cdk-lib.aws_ce.CfnAnomalyMonitor", version: "2.80.0" }, CfnAnomalyMonitor.CFN_RESOURCE_TYPE_NAME = "AWS::CE::AnomalyMonitor", exports2.CfnAnomalyMonitor = CfnAnomalyMonitor;
    function CfnAnomalyMonitor_ResourceTagPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "ResourceTagProperty"');
    }
    function cfnAnomalyMonitorResourceTagPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnomalyMonitor_ResourceTagPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnAnomalyMonitorResourceTagPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnomalySubscriptionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("frequency", cdk.requiredValidator)(properties.frequency)), errors.collect(cdk.propertyValidator("frequency", cdk.validateString)(properties.frequency)), errors.collect(cdk.propertyValidator("monitorArnList", cdk.requiredValidator)(properties.monitorArnList)), errors.collect(cdk.propertyValidator("monitorArnList", cdk.listValidator(cdk.validateString))(properties.monitorArnList)), errors.collect(cdk.propertyValidator("resourceTags", cdk.listValidator(CfnAnomalySubscription_ResourceTagPropertyValidator))(properties.resourceTags)), errors.collect(cdk.propertyValidator("subscribers", cdk.requiredValidator)(properties.subscribers)), errors.collect(cdk.propertyValidator("subscribers", cdk.listValidator(CfnAnomalySubscription_SubscriberPropertyValidator))(properties.subscribers)), errors.collect(cdk.propertyValidator("subscriptionName", cdk.requiredValidator)(properties.subscriptionName)), errors.collect(cdk.propertyValidator("subscriptionName", cdk.validateString)(properties.subscriptionName)), errors.collect(cdk.propertyValidator("threshold", cdk.validateNumber)(properties.threshold)), errors.collect(cdk.propertyValidator("thresholdExpression", cdk.validateString)(properties.thresholdExpression)), errors.wrap('supplied properties not correct for "CfnAnomalySubscriptionProps"');
    }
    function cfnAnomalySubscriptionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnomalySubscriptionPropsValidator(properties).assertSuccess(), { Frequency: cdk.stringToCloudFormation(properties.frequency), MonitorArnList: cdk.listMapper(cdk.stringToCloudFormation)(properties.monitorArnList), Subscribers: cdk.listMapper(cfnAnomalySubscriptionSubscriberPropertyToCloudFormation)(properties.subscribers), SubscriptionName: cdk.stringToCloudFormation(properties.subscriptionName), ResourceTags: cdk.listMapper(cfnAnomalySubscriptionResourceTagPropertyToCloudFormation)(properties.resourceTags), Threshold: cdk.numberToCloudFormation(properties.threshold), ThresholdExpression: cdk.stringToCloudFormation(properties.thresholdExpression) }) : properties;
    }
    function CfnAnomalySubscriptionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("frequency", "Frequency", cfn_parse.FromCloudFormation.getString(properties.Frequency)), ret.addPropertyResult("monitorArnList", "MonitorArnList", cfn_parse.FromCloudFormation.getStringArray(properties.MonitorArnList)), ret.addPropertyResult("subscribers", "Subscribers", cfn_parse.FromCloudFormation.getArray(CfnAnomalySubscriptionSubscriberPropertyFromCloudFormation)(properties.Subscribers)), ret.addPropertyResult("subscriptionName", "SubscriptionName", cfn_parse.FromCloudFormation.getString(properties.SubscriptionName)), ret.addPropertyResult("resourceTags", "ResourceTags", properties.ResourceTags != null ? cfn_parse.FromCloudFormation.getArray(CfnAnomalySubscriptionResourceTagPropertyFromCloudFormation)(properties.ResourceTags) : void 0), ret.addPropertyResult("threshold", "Threshold", properties.Threshold != null ? cfn_parse.FromCloudFormation.getNumber(properties.Threshold) : void 0), ret.addPropertyResult("thresholdExpression", "ThresholdExpression", properties.ThresholdExpression != null ? cfn_parse.FromCloudFormation.getString(properties.ThresholdExpression) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAnomalySubscription = class _CfnAnomalySubscription extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAnomalySubscriptionPropsFromCloudFormation(resourceProperties), ret = new _CfnAnomalySubscription(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAnomalySubscription.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ce_CfnAnomalySubscriptionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAnomalySubscription), error;
        }
        cdk.requireProperty(props, "frequency", this), cdk.requireProperty(props, "monitorArnList", this), cdk.requireProperty(props, "subscribers", this), cdk.requireProperty(props, "subscriptionName", this), this.attrAccountId = cdk.Token.asString(this.getAtt("AccountId", cdk.ResolutionTypeHint.STRING)), this.attrSubscriptionArn = cdk.Token.asString(this.getAtt("SubscriptionArn", cdk.ResolutionTypeHint.STRING)), this.frequency = props.frequency, this.monitorArnList = props.monitorArnList, this.subscribers = props.subscribers, this.subscriptionName = props.subscriptionName, this.resourceTags = props.resourceTags, this.threshold = props.threshold, this.thresholdExpression = props.thresholdExpression;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAnomalySubscription.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { frequency: this.frequency, monitorArnList: this.monitorArnList, subscribers: this.subscribers, subscriptionName: this.subscriptionName, resourceTags: this.resourceTags, threshold: this.threshold, thresholdExpression: this.thresholdExpression };
      }
      renderProperties(props) {
        return cfnAnomalySubscriptionPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnAnomalySubscription[_b] = { fqn: "aws-cdk-lib.aws_ce.CfnAnomalySubscription", version: "2.80.0" }, CfnAnomalySubscription.CFN_RESOURCE_TYPE_NAME = "AWS::CE::AnomalySubscription", exports2.CfnAnomalySubscription = CfnAnomalySubscription;
    function CfnAnomalySubscription_ResourceTagPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "ResourceTagProperty"');
    }
    function cfnAnomalySubscriptionResourceTagPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnomalySubscription_ResourceTagPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnAnomalySubscriptionResourceTagPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnomalySubscription_SubscriberPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("address", cdk.requiredValidator)(properties.address)), errors.collect(cdk.propertyValidator("address", cdk.validateString)(properties.address)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "SubscriberProperty"');
    }
    function cfnAnomalySubscriptionSubscriberPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnomalySubscription_SubscriberPropertyValidator(properties).assertSuccess(), { Address: cdk.stringToCloudFormation(properties.address), Status: cdk.stringToCloudFormation(properties.status), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnAnomalySubscriptionSubscriberPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("address", "Address", cfn_parse.FromCloudFormation.getString(properties.Address)), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCostCategoryPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultValue", cdk.validateString)(properties.defaultValue)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("ruleVersion", cdk.requiredValidator)(properties.ruleVersion)), errors.collect(cdk.propertyValidator("ruleVersion", cdk.validateString)(properties.ruleVersion)), errors.collect(cdk.propertyValidator("rules", cdk.requiredValidator)(properties.rules)), errors.collect(cdk.propertyValidator("rules", cdk.validateString)(properties.rules)), errors.collect(cdk.propertyValidator("splitChargeRules", cdk.validateString)(properties.splitChargeRules)), errors.wrap('supplied properties not correct for "CfnCostCategoryProps"');
    }
    function cfnCostCategoryPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCostCategoryPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Rules: cdk.stringToCloudFormation(properties.rules), RuleVersion: cdk.stringToCloudFormation(properties.ruleVersion), DefaultValue: cdk.stringToCloudFormation(properties.defaultValue), SplitChargeRules: cdk.stringToCloudFormation(properties.splitChargeRules) }) : properties;
    }
    function CfnCostCategoryPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("rules", "Rules", cfn_parse.FromCloudFormation.getString(properties.Rules)), ret.addPropertyResult("ruleVersion", "RuleVersion", cfn_parse.FromCloudFormation.getString(properties.RuleVersion)), ret.addPropertyResult("defaultValue", "DefaultValue", properties.DefaultValue != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultValue) : void 0), ret.addPropertyResult("splitChargeRules", "SplitChargeRules", properties.SplitChargeRules != null ? cfn_parse.FromCloudFormation.getString(properties.SplitChargeRules) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCostCategory = class _CfnCostCategory extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCostCategoryPropsFromCloudFormation(resourceProperties), ret = new _CfnCostCategory(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCostCategory.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ce_CfnCostCategoryProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCostCategory), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "ruleVersion", this), cdk.requireProperty(props, "rules", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrEffectiveStart = cdk.Token.asString(this.getAtt("EffectiveStart", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.rules = props.rules, this.ruleVersion = props.ruleVersion, this.defaultValue = props.defaultValue, this.splitChargeRules = props.splitChargeRules;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCostCategory.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, rules: this.rules, ruleVersion: this.ruleVersion, defaultValue: this.defaultValue, splitChargeRules: this.splitChargeRules };
      }
      renderProperties(props) {
        return cfnCostCategoryPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnCostCategory[_c] = { fqn: "aws-cdk-lib.aws_ce.CfnCostCategory", version: "2.80.0" }, CfnCostCategory.CFN_RESOURCE_TYPE_NAME = "AWS::CE::CostCategory", exports2.CfnCostCategory = CfnCostCategory;
  }
});

// node_modules/aws-cdk-lib/aws-ce/lib/index.js
var require_lib67 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ce/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_ce_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-ce/index.js
var require_aws_ce = __commonJS({
  "node_modules/aws-cdk-lib/aws-ce/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib67(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-chatbot/lib/chatbot.generated.js
var require_chatbot_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-chatbot/lib/chatbot.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnSlackChannelConfiguration = exports2.CfnMicrosoftTeamsChannelConfiguration = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnMicrosoftTeamsChannelConfigurationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configurationName", cdk.requiredValidator)(properties.configurationName)), errors.collect(cdk.propertyValidator("configurationName", cdk.validateString)(properties.configurationName)), errors.collect(cdk.propertyValidator("guardrailPolicies", cdk.listValidator(cdk.validateString))(properties.guardrailPolicies)), errors.collect(cdk.propertyValidator("iamRoleArn", cdk.requiredValidator)(properties.iamRoleArn)), errors.collect(cdk.propertyValidator("iamRoleArn", cdk.validateString)(properties.iamRoleArn)), errors.collect(cdk.propertyValidator("loggingLevel", cdk.validateString)(properties.loggingLevel)), errors.collect(cdk.propertyValidator("snsTopicArns", cdk.listValidator(cdk.validateString))(properties.snsTopicArns)), errors.collect(cdk.propertyValidator("teamId", cdk.requiredValidator)(properties.teamId)), errors.collect(cdk.propertyValidator("teamId", cdk.validateString)(properties.teamId)), errors.collect(cdk.propertyValidator("teamsChannelId", cdk.requiredValidator)(properties.teamsChannelId)), errors.collect(cdk.propertyValidator("teamsChannelId", cdk.validateString)(properties.teamsChannelId)), errors.collect(cdk.propertyValidator("teamsTenantId", cdk.requiredValidator)(properties.teamsTenantId)), errors.collect(cdk.propertyValidator("teamsTenantId", cdk.validateString)(properties.teamsTenantId)), errors.collect(cdk.propertyValidator("userRoleRequired", cdk.validateBoolean)(properties.userRoleRequired)), errors.wrap('supplied properties not correct for "CfnMicrosoftTeamsChannelConfigurationProps"');
    }
    function cfnMicrosoftTeamsChannelConfigurationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMicrosoftTeamsChannelConfigurationPropsValidator(properties).assertSuccess(), { ConfigurationName: cdk.stringToCloudFormation(properties.configurationName), IamRoleArn: cdk.stringToCloudFormation(properties.iamRoleArn), TeamId: cdk.stringToCloudFormation(properties.teamId), TeamsChannelId: cdk.stringToCloudFormation(properties.teamsChannelId), TeamsTenantId: cdk.stringToCloudFormation(properties.teamsTenantId), GuardrailPolicies: cdk.listMapper(cdk.stringToCloudFormation)(properties.guardrailPolicies), LoggingLevel: cdk.stringToCloudFormation(properties.loggingLevel), SnsTopicArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.snsTopicArns), UserRoleRequired: cdk.booleanToCloudFormation(properties.userRoleRequired) }) : properties;
    }
    function CfnMicrosoftTeamsChannelConfigurationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configurationName", "ConfigurationName", cfn_parse.FromCloudFormation.getString(properties.ConfigurationName)), ret.addPropertyResult("iamRoleArn", "IamRoleArn", cfn_parse.FromCloudFormation.getString(properties.IamRoleArn)), ret.addPropertyResult("teamId", "TeamId", cfn_parse.FromCloudFormation.getString(properties.TeamId)), ret.addPropertyResult("teamsChannelId", "TeamsChannelId", cfn_parse.FromCloudFormation.getString(properties.TeamsChannelId)), ret.addPropertyResult("teamsTenantId", "TeamsTenantId", cfn_parse.FromCloudFormation.getString(properties.TeamsTenantId)), ret.addPropertyResult("guardrailPolicies", "GuardrailPolicies", properties.GuardrailPolicies != null ? cfn_parse.FromCloudFormation.getStringArray(properties.GuardrailPolicies) : void 0), ret.addPropertyResult("loggingLevel", "LoggingLevel", properties.LoggingLevel != null ? cfn_parse.FromCloudFormation.getString(properties.LoggingLevel) : void 0), ret.addPropertyResult("snsTopicArns", "SnsTopicArns", properties.SnsTopicArns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SnsTopicArns) : void 0), ret.addPropertyResult("userRoleRequired", "UserRoleRequired", properties.UserRoleRequired != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UserRoleRequired) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnMicrosoftTeamsChannelConfiguration = class _CfnMicrosoftTeamsChannelConfiguration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnMicrosoftTeamsChannelConfigurationPropsFromCloudFormation(resourceProperties), ret = new _CfnMicrosoftTeamsChannelConfiguration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnMicrosoftTeamsChannelConfiguration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_chatbot_CfnMicrosoftTeamsChannelConfigurationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnMicrosoftTeamsChannelConfiguration), error;
        }
        cdk.requireProperty(props, "configurationName", this), cdk.requireProperty(props, "iamRoleArn", this), cdk.requireProperty(props, "teamId", this), cdk.requireProperty(props, "teamsChannelId", this), cdk.requireProperty(props, "teamsTenantId", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.configurationName = props.configurationName, this.iamRoleArn = props.iamRoleArn, this.teamId = props.teamId, this.teamsChannelId = props.teamsChannelId, this.teamsTenantId = props.teamsTenantId, this.guardrailPolicies = props.guardrailPolicies, this.loggingLevel = props.loggingLevel, this.snsTopicArns = props.snsTopicArns, this.userRoleRequired = props.userRoleRequired;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnMicrosoftTeamsChannelConfiguration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { configurationName: this.configurationName, iamRoleArn: this.iamRoleArn, teamId: this.teamId, teamsChannelId: this.teamsChannelId, teamsTenantId: this.teamsTenantId, guardrailPolicies: this.guardrailPolicies, loggingLevel: this.loggingLevel, snsTopicArns: this.snsTopicArns, userRoleRequired: this.userRoleRequired };
      }
      renderProperties(props) {
        return cfnMicrosoftTeamsChannelConfigurationPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnMicrosoftTeamsChannelConfiguration[_a] = { fqn: "aws-cdk-lib.aws_chatbot.CfnMicrosoftTeamsChannelConfiguration", version: "2.80.0" }, CfnMicrosoftTeamsChannelConfiguration.CFN_RESOURCE_TYPE_NAME = "AWS::Chatbot::MicrosoftTeamsChannelConfiguration", exports2.CfnMicrosoftTeamsChannelConfiguration = CfnMicrosoftTeamsChannelConfiguration;
    function CfnSlackChannelConfigurationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configurationName", cdk.requiredValidator)(properties.configurationName)), errors.collect(cdk.propertyValidator("configurationName", cdk.validateString)(properties.configurationName)), errors.collect(cdk.propertyValidator("guardrailPolicies", cdk.listValidator(cdk.validateString))(properties.guardrailPolicies)), errors.collect(cdk.propertyValidator("iamRoleArn", cdk.requiredValidator)(properties.iamRoleArn)), errors.collect(cdk.propertyValidator("iamRoleArn", cdk.validateString)(properties.iamRoleArn)), errors.collect(cdk.propertyValidator("loggingLevel", cdk.validateString)(properties.loggingLevel)), errors.collect(cdk.propertyValidator("slackChannelId", cdk.requiredValidator)(properties.slackChannelId)), errors.collect(cdk.propertyValidator("slackChannelId", cdk.validateString)(properties.slackChannelId)), errors.collect(cdk.propertyValidator("slackWorkspaceId", cdk.requiredValidator)(properties.slackWorkspaceId)), errors.collect(cdk.propertyValidator("slackWorkspaceId", cdk.validateString)(properties.slackWorkspaceId)), errors.collect(cdk.propertyValidator("snsTopicArns", cdk.listValidator(cdk.validateString))(properties.snsTopicArns)), errors.collect(cdk.propertyValidator("userRoleRequired", cdk.validateBoolean)(properties.userRoleRequired)), errors.wrap('supplied properties not correct for "CfnSlackChannelConfigurationProps"');
    }
    function cfnSlackChannelConfigurationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSlackChannelConfigurationPropsValidator(properties).assertSuccess(), { ConfigurationName: cdk.stringToCloudFormation(properties.configurationName), IamRoleArn: cdk.stringToCloudFormation(properties.iamRoleArn), SlackChannelId: cdk.stringToCloudFormation(properties.slackChannelId), SlackWorkspaceId: cdk.stringToCloudFormation(properties.slackWorkspaceId), GuardrailPolicies: cdk.listMapper(cdk.stringToCloudFormation)(properties.guardrailPolicies), LoggingLevel: cdk.stringToCloudFormation(properties.loggingLevel), SnsTopicArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.snsTopicArns), UserRoleRequired: cdk.booleanToCloudFormation(properties.userRoleRequired) }) : properties;
    }
    function CfnSlackChannelConfigurationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configurationName", "ConfigurationName", cfn_parse.FromCloudFormation.getString(properties.ConfigurationName)), ret.addPropertyResult("iamRoleArn", "IamRoleArn", cfn_parse.FromCloudFormation.getString(properties.IamRoleArn)), ret.addPropertyResult("slackChannelId", "SlackChannelId", cfn_parse.FromCloudFormation.getString(properties.SlackChannelId)), ret.addPropertyResult("slackWorkspaceId", "SlackWorkspaceId", cfn_parse.FromCloudFormation.getString(properties.SlackWorkspaceId)), ret.addPropertyResult("guardrailPolicies", "GuardrailPolicies", properties.GuardrailPolicies != null ? cfn_parse.FromCloudFormation.getStringArray(properties.GuardrailPolicies) : void 0), ret.addPropertyResult("loggingLevel", "LoggingLevel", properties.LoggingLevel != null ? cfn_parse.FromCloudFormation.getString(properties.LoggingLevel) : void 0), ret.addPropertyResult("snsTopicArns", "SnsTopicArns", properties.SnsTopicArns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SnsTopicArns) : void 0), ret.addPropertyResult("userRoleRequired", "UserRoleRequired", properties.UserRoleRequired != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UserRoleRequired) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSlackChannelConfiguration = class _CfnSlackChannelConfiguration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSlackChannelConfigurationPropsFromCloudFormation(resourceProperties), ret = new _CfnSlackChannelConfiguration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSlackChannelConfiguration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_chatbot_CfnSlackChannelConfigurationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSlackChannelConfiguration), error;
        }
        cdk.requireProperty(props, "configurationName", this), cdk.requireProperty(props, "iamRoleArn", this), cdk.requireProperty(props, "slackChannelId", this), cdk.requireProperty(props, "slackWorkspaceId", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.configurationName = props.configurationName, this.iamRoleArn = props.iamRoleArn, this.slackChannelId = props.slackChannelId, this.slackWorkspaceId = props.slackWorkspaceId, this.guardrailPolicies = props.guardrailPolicies, this.loggingLevel = props.loggingLevel, this.snsTopicArns = props.snsTopicArns, this.userRoleRequired = props.userRoleRequired;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSlackChannelConfiguration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { configurationName: this.configurationName, iamRoleArn: this.iamRoleArn, slackChannelId: this.slackChannelId, slackWorkspaceId: this.slackWorkspaceId, guardrailPolicies: this.guardrailPolicies, loggingLevel: this.loggingLevel, snsTopicArns: this.snsTopicArns, userRoleRequired: this.userRoleRequired };
      }
      renderProperties(props) {
        return cfnSlackChannelConfigurationPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnSlackChannelConfiguration[_b] = { fqn: "aws-cdk-lib.aws_chatbot.CfnSlackChannelConfiguration", version: "2.80.0" }, CfnSlackChannelConfiguration.CFN_RESOURCE_TYPE_NAME = "AWS::Chatbot::SlackChannelConfiguration", exports2.CfnSlackChannelConfiguration = CfnSlackChannelConfiguration;
  }
});

// node_modules/aws-cdk-lib/aws-chatbot/lib/slack-channel-configuration.js
var require_slack_channel_configuration = __commonJS({
  "node_modules/aws-cdk-lib/aws-chatbot/lib/slack-channel-configuration.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SlackChannelConfiguration = exports2.LoggingLevel = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var chatbot_generated_1 = require_chatbot_generated();
    var cloudwatch = require_aws_cloudwatch();
    var iam = require_aws_iam();
    var logs = require_aws_logs();
    var cdk = require_core2();
    var LoggingLevel;
    (function(LoggingLevel2) {
      LoggingLevel2.ERROR = "ERROR", LoggingLevel2.INFO = "INFO", LoggingLevel2.NONE = "NONE";
    })(LoggingLevel = exports2.LoggingLevel || (exports2.LoggingLevel = {}));
    var SlackChannelConfigurationBase = class extends cdk.Resource {
      addToRolePolicy(statement) {
        this.role && this.role.addToPrincipalPolicy(statement);
      }
      metric(metricName, props) {
        return new cloudwatch.Metric({ namespace: "AWS/Chatbot", region: "us-east-1", dimensionsMap: { ConfigurationName: this.slackChannelConfigurationName }, metricName, ...props });
      }
      bindAsNotificationRuleTarget(_scope) {
        return { targetType: "AWSChatbotSlack", targetAddress: this.slackChannelConfigurationArn };
      }
    };
    var SlackChannelConfiguration = class _SlackChannelConfiguration extends SlackChannelConfigurationBase {
      static fromSlackChannelConfigurationArn(scope, id, slackChannelConfigurationArn) {
        const re = /^slack-channel\//, resourceName = cdk.Arn.extractResourceName(slackChannelConfigurationArn, "chat-configuration");
        if (!cdk.Token.isUnresolved(slackChannelConfigurationArn) && !re.test(resourceName))
          throw new Error("The ARN of a Slack integration must be in the form: arn:<partition>:chatbot:<region>:<account>:chat-configuration/slack-channel/<slackChannelName>");
        class Import extends SlackChannelConfigurationBase {
          constructor(s, i) {
            super(s, i), this.slackChannelConfigurationArn = slackChannelConfigurationArn, this.role = void 0, this.grantPrincipal = new iam.UnknownPrincipal({ resource: this }), cdk.Token.isUnresolved(slackChannelConfigurationArn) ? this.slackChannelConfigurationName = cdk.Fn.select(1, cdk.Fn.split("slack-channel/", resourceName)) : this.slackChannelConfigurationName = resourceName.substring(14);
          }
        }
        return new Import(scope, id);
      }
      static metricAll(metricName, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricAll), error;
        }
        return new cloudwatch.Metric({ namespace: "AWS/Chatbot", region: "us-east-1", metricName, ...props });
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.slackChannelConfigurationName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_chatbot_SlackChannelConfigurationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SlackChannelConfiguration), error;
        }
        this.role = props.role || new iam.Role(this, "ConfigurationRole", { assumedBy: new iam.ServicePrincipal("chatbot.amazonaws.com") }), this.grantPrincipal = this.role, this.notificationTopics = props.notificationTopics ?? [];
        const configuration = new chatbot_generated_1.CfnSlackChannelConfiguration(this, "Resource", { configurationName: props.slackChannelConfigurationName, iamRoleArn: this.role.roleArn, slackWorkspaceId: props.slackWorkspaceId, slackChannelId: props.slackChannelId, snsTopicArns: cdk.Lazy.list({ produce: () => this.notificationTopics.map((topic) => topic.topicArn) }, { omitEmpty: true }), loggingLevel: props.loggingLevel?.toString(), guardrailPolicies: cdk.Lazy.list({ produce: () => props.guardrailPolicies?.map((policy) => policy.managedPolicyArn) }, { omitEmpty: true }) });
        props.logRetention && new logs.LogRetention(this, "LogRetention", { logGroupName: `/aws/chatbot/${props.slackChannelConfigurationName}`, retention: props.logRetention, role: props.logRetentionRole, logGroupRegion: "us-east-1", logRetentionRetryOptions: props.logRetentionRetryOptions }), this.slackChannelConfigurationArn = configuration.ref, this.slackChannelConfigurationName = props.slackChannelConfigurationName;
      }
      addNotificationTopic(notificationTopic) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sns_ITopic(notificationTopic);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addNotificationTopic), error;
        }
        this.notificationTopics.push(notificationTopic);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SlackChannelConfiguration[_a] = { fqn: "aws-cdk-lib.aws_chatbot.SlackChannelConfiguration", version: "2.80.0" }, exports2.SlackChannelConfiguration = SlackChannelConfiguration;
  }
});

// node_modules/aws-cdk-lib/aws-chatbot/lib/index.js
var require_lib68 = __commonJS({
  "node_modules/aws-cdk-lib/aws-chatbot/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_chatbot_generated(), exports2), __exportStar(require_slack_channel_configuration(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-chatbot/index.js
var require_aws_chatbot = __commonJS({
  "node_modules/aws-cdk-lib/aws-chatbot/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib68(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-cloud9/lib/cloud9.generated.js
var require_cloud9_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloud9/lib/cloud9.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnEnvironmentEC2 = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnEnvironmentEC2PropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("automaticStopTimeMinutes", cdk.validateNumber)(properties.automaticStopTimeMinutes)), errors.collect(cdk.propertyValidator("connectionType", cdk.validateString)(properties.connectionType)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("imageId", cdk.validateString)(properties.imageId)), errors.collect(cdk.propertyValidator("instanceType", cdk.requiredValidator)(properties.instanceType)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("ownerArn", cdk.validateString)(properties.ownerArn)), errors.collect(cdk.propertyValidator("repositories", cdk.listValidator(CfnEnvironmentEC2_RepositoryPropertyValidator))(properties.repositories)), errors.collect(cdk.propertyValidator("subnetId", cdk.validateString)(properties.subnetId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnEnvironmentEC2Props"');
    }
    function cfnEnvironmentEC2PropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEnvironmentEC2PropsValidator(properties).assertSuccess(), { InstanceType: cdk.stringToCloudFormation(properties.instanceType), AutomaticStopTimeMinutes: cdk.numberToCloudFormation(properties.automaticStopTimeMinutes), ConnectionType: cdk.stringToCloudFormation(properties.connectionType), Description: cdk.stringToCloudFormation(properties.description), ImageId: cdk.stringToCloudFormation(properties.imageId), Name: cdk.stringToCloudFormation(properties.name), OwnerArn: cdk.stringToCloudFormation(properties.ownerArn), Repositories: cdk.listMapper(cfnEnvironmentEC2RepositoryPropertyToCloudFormation)(properties.repositories), SubnetId: cdk.stringToCloudFormation(properties.subnetId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnEnvironmentEC2PropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceType", "InstanceType", cfn_parse.FromCloudFormation.getString(properties.InstanceType)), ret.addPropertyResult("automaticStopTimeMinutes", "AutomaticStopTimeMinutes", properties.AutomaticStopTimeMinutes != null ? cfn_parse.FromCloudFormation.getNumber(properties.AutomaticStopTimeMinutes) : void 0), ret.addPropertyResult("connectionType", "ConnectionType", properties.ConnectionType != null ? cfn_parse.FromCloudFormation.getString(properties.ConnectionType) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("imageId", "ImageId", properties.ImageId != null ? cfn_parse.FromCloudFormation.getString(properties.ImageId) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("ownerArn", "OwnerArn", properties.OwnerArn != null ? cfn_parse.FromCloudFormation.getString(properties.OwnerArn) : void 0), ret.addPropertyResult("repositories", "Repositories", properties.Repositories != null ? cfn_parse.FromCloudFormation.getArray(CfnEnvironmentEC2RepositoryPropertyFromCloudFormation)(properties.Repositories) : void 0), ret.addPropertyResult("subnetId", "SubnetId", properties.SubnetId != null ? cfn_parse.FromCloudFormation.getString(properties.SubnetId) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEnvironmentEC2 = class _CfnEnvironmentEC2 extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEnvironmentEC2PropsFromCloudFormation(resourceProperties), ret = new _CfnEnvironmentEC2(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEnvironmentEC2.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloud9_CfnEnvironmentEC2Props(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEnvironmentEC2), error;
        }
        cdk.requireProperty(props, "instanceType", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.instanceType = props.instanceType, this.automaticStopTimeMinutes = props.automaticStopTimeMinutes, this.connectionType = props.connectionType, this.description = props.description, this.imageId = props.imageId, this.name = props.name, this.ownerArn = props.ownerArn, this.repositories = props.repositories, this.subnetId = props.subnetId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Cloud9::EnvironmentEC2", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEnvironmentEC2.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { instanceType: this.instanceType, automaticStopTimeMinutes: this.automaticStopTimeMinutes, connectionType: this.connectionType, description: this.description, imageId: this.imageId, name: this.name, ownerArn: this.ownerArn, repositories: this.repositories, subnetId: this.subnetId, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnEnvironmentEC2PropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnEnvironmentEC2[_a] = { fqn: "aws-cdk-lib.aws_cloud9.CfnEnvironmentEC2", version: "2.80.0" }, CfnEnvironmentEC2.CFN_RESOURCE_TYPE_NAME = "AWS::Cloud9::EnvironmentEC2", exports2.CfnEnvironmentEC2 = CfnEnvironmentEC2;
    function CfnEnvironmentEC2_RepositoryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("pathComponent", cdk.requiredValidator)(properties.pathComponent)), errors.collect(cdk.propertyValidator("pathComponent", cdk.validateString)(properties.pathComponent)), errors.collect(cdk.propertyValidator("repositoryUrl", cdk.requiredValidator)(properties.repositoryUrl)), errors.collect(cdk.propertyValidator("repositoryUrl", cdk.validateString)(properties.repositoryUrl)), errors.wrap('supplied properties not correct for "RepositoryProperty"');
    }
    function cfnEnvironmentEC2RepositoryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEnvironmentEC2_RepositoryPropertyValidator(properties).assertSuccess(), { PathComponent: cdk.stringToCloudFormation(properties.pathComponent), RepositoryUrl: cdk.stringToCloudFormation(properties.repositoryUrl) }) : properties;
    }
    function CfnEnvironmentEC2RepositoryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("pathComponent", "PathComponent", cfn_parse.FromCloudFormation.getString(properties.PathComponent)), ret.addPropertyResult("repositoryUrl", "RepositoryUrl", cfn_parse.FromCloudFormation.getString(properties.RepositoryUrl)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-cloud9/lib/index.js
var require_lib69 = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloud9/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_cloud9_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-cloud9/index.js
var require_aws_cloud9 = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloud9/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib69(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-cloudformation/lib/cloud-formation-capabilities.js
var require_cloud_formation_capabilities = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudformation/lib/cloud-formation-capabilities.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CloudFormationCapabilities = void 0;
    var CloudFormationCapabilities;
    (function(CloudFormationCapabilities2) {
      CloudFormationCapabilities2.NONE = "", CloudFormationCapabilities2.ANONYMOUS_IAM = "CAPABILITY_IAM", CloudFormationCapabilities2.NAMED_IAM = "CAPABILITY_NAMED_IAM", CloudFormationCapabilities2.AUTO_EXPAND = "CAPABILITY_AUTO_EXPAND";
    })(CloudFormationCapabilities = exports2.CloudFormationCapabilities || (exports2.CloudFormationCapabilities = {}));
  }
});

// node_modules/aws-cdk-lib/aws-cloudformation/lib/custom-resource.js
var require_custom_resource2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudformation/lib/custom-resource.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CustomResource = exports2.CustomResourceProvider = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core = require_core2();
    var CustomResourceProvider = class _CustomResourceProvider {
      static fromLambda(handler2) {
        return new _CustomResourceProvider(handler2.functionArn);
      }
      static fromTopic(topic) {
        return new _CustomResourceProvider(topic.topicArn);
      }
      static lambda(handler2) {
        return this.fromLambda(handler2);
      }
      static topic(topic) {
        return this.fromTopic(topic);
      }
      constructor(serviceToken) {
        this.serviceToken = serviceToken;
      }
      bind(_scope) {
        return { serviceToken: this.serviceToken };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CustomResourceProvider[_a] = { fqn: "aws-cdk-lib.aws_cloudformation.CustomResourceProvider", version: "2.80.0" }, exports2.CustomResourceProvider = CustomResourceProvider;
    var CustomResource2 = class extends core.CustomResource {
      constructor(scope, id, props) {
        super(scope, id, { pascalCaseProperties: true, properties: props.properties, removalPolicy: props.removalPolicy, resourceType: props.resourceType, serviceToken: core.Lazy.string({ produce: () => props.provider.bind(this).serviceToken }) });
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CustomResource2[_b] = { fqn: "aws-cdk-lib.aws_cloudformation.CustomResource", version: "2.80.0" }, exports2.CustomResource = CustomResource2;
  }
});

// node_modules/aws-cdk-lib/aws-cloudformation/lib/nested-stack.js
var require_nested_stack2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudformation/lib/nested-stack.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.NestedStack = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core = require_core2();
    var NestedStack = class extends core.NestedStack {
      constructor(scope, id, props = {}) {
        super(scope, id, { parameters: props.parameters, timeout: props.timeout, notificationArns: props.notifications?.map((n) => n.topicArn) });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, NestedStack[_a] = { fqn: "aws-cdk-lib.aws_cloudformation.NestedStack", version: "2.80.0" }, exports2.NestedStack = NestedStack;
  }
});

// node_modules/aws-cdk-lib/aws-cloudformation/lib/cloudformation.generated.js
var require_cloudformation_generated2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudformation/lib/cloudformation.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    var _l;
    var _m;
    var _o;
    var _p;
    var _q;
    var _r;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnWaitConditionHandle = exports2.CfnWaitCondition = exports2.CfnTypeActivation = exports2.CfnStackSet = exports2.CfnStack = exports2.CfnResourceVersion = exports2.CfnResourceDefaultVersion = exports2.CfnPublisher = exports2.CfnPublicTypeVersion = exports2.CfnModuleVersion = exports2.CfnModuleDefaultVersion = exports2.CfnMacro = exports2.CfnHookVersion = exports2.CfnHookTypeConfig = exports2.CfnHookDefaultVersion = exports2.CfnCustomResource = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnCustomResourcePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("serviceToken", cdk.requiredValidator)(properties.serviceToken)), errors.collect(cdk.propertyValidator("serviceToken", cdk.validateString)(properties.serviceToken)), errors.wrap('supplied properties not correct for "CfnCustomResourceProps"');
    }
    function cfnCustomResourcePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCustomResourcePropsValidator(properties).assertSuccess(), { ServiceToken: cdk.stringToCloudFormation(properties.serviceToken) }) : properties;
    }
    function CfnCustomResourcePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("serviceToken", "ServiceToken", cfn_parse.FromCloudFormation.getString(properties.ServiceToken)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCustomResource = class _CfnCustomResource extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCustomResourcePropsFromCloudFormation(resourceProperties), ret = new _CfnCustomResource(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCustomResource.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudformation_CfnCustomResourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCustomResource), error;
        }
        cdk.requireProperty(props, "serviceToken", this), this.serviceToken = props.serviceToken;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCustomResource.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { serviceToken: this.serviceToken };
      }
      renderProperties(props) {
        return cfnCustomResourcePropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnCustomResource[_a] = { fqn: "aws-cdk-lib.aws_cloudformation.CfnCustomResource", version: "2.80.0" }, CfnCustomResource.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::CustomResource", exports2.CfnCustomResource = CfnCustomResource;
    function CfnHookDefaultVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("typeName", cdk.validateString)(properties.typeName)), errors.collect(cdk.propertyValidator("typeVersionArn", cdk.validateString)(properties.typeVersionArn)), errors.collect(cdk.propertyValidator("versionId", cdk.validateString)(properties.versionId)), errors.wrap('supplied properties not correct for "CfnHookDefaultVersionProps"');
    }
    function cfnHookDefaultVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHookDefaultVersionPropsValidator(properties).assertSuccess(), { TypeName: cdk.stringToCloudFormation(properties.typeName), TypeVersionArn: cdk.stringToCloudFormation(properties.typeVersionArn), VersionId: cdk.stringToCloudFormation(properties.versionId) }) : properties;
    }
    function CfnHookDefaultVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("typeName", "TypeName", properties.TypeName != null ? cfn_parse.FromCloudFormation.getString(properties.TypeName) : void 0), ret.addPropertyResult("typeVersionArn", "TypeVersionArn", properties.TypeVersionArn != null ? cfn_parse.FromCloudFormation.getString(properties.TypeVersionArn) : void 0), ret.addPropertyResult("versionId", "VersionId", properties.VersionId != null ? cfn_parse.FromCloudFormation.getString(properties.VersionId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnHookDefaultVersion = class _CfnHookDefaultVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnHookDefaultVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnHookDefaultVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnHookDefaultVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudformation_CfnHookDefaultVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnHookDefaultVersion), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.typeName = props.typeName, this.typeVersionArn = props.typeVersionArn, this.versionId = props.versionId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnHookDefaultVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { typeName: this.typeName, typeVersionArn: this.typeVersionArn, versionId: this.versionId };
      }
      renderProperties(props) {
        return cfnHookDefaultVersionPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnHookDefaultVersion[_b] = { fqn: "aws-cdk-lib.aws_cloudformation.CfnHookDefaultVersion", version: "2.80.0" }, CfnHookDefaultVersion.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::HookDefaultVersion", exports2.CfnHookDefaultVersion = CfnHookDefaultVersion;
    function CfnHookTypeConfigPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configuration", cdk.requiredValidator)(properties.configuration)), errors.collect(cdk.propertyValidator("configuration", cdk.validateString)(properties.configuration)), errors.collect(cdk.propertyValidator("configurationAlias", cdk.validateString)(properties.configurationAlias)), errors.collect(cdk.propertyValidator("typeArn", cdk.validateString)(properties.typeArn)), errors.collect(cdk.propertyValidator("typeName", cdk.validateString)(properties.typeName)), errors.wrap('supplied properties not correct for "CfnHookTypeConfigProps"');
    }
    function cfnHookTypeConfigPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHookTypeConfigPropsValidator(properties).assertSuccess(), { Configuration: cdk.stringToCloudFormation(properties.configuration), ConfigurationAlias: cdk.stringToCloudFormation(properties.configurationAlias), TypeArn: cdk.stringToCloudFormation(properties.typeArn), TypeName: cdk.stringToCloudFormation(properties.typeName) }) : properties;
    }
    function CfnHookTypeConfigPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configuration", "Configuration", cfn_parse.FromCloudFormation.getString(properties.Configuration)), ret.addPropertyResult("configurationAlias", "ConfigurationAlias", properties.ConfigurationAlias != null ? cfn_parse.FromCloudFormation.getString(properties.ConfigurationAlias) : void 0), ret.addPropertyResult("typeArn", "TypeArn", properties.TypeArn != null ? cfn_parse.FromCloudFormation.getString(properties.TypeArn) : void 0), ret.addPropertyResult("typeName", "TypeName", properties.TypeName != null ? cfn_parse.FromCloudFormation.getString(properties.TypeName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnHookTypeConfig = class _CfnHookTypeConfig extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnHookTypeConfigPropsFromCloudFormation(resourceProperties), ret = new _CfnHookTypeConfig(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnHookTypeConfig.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudformation_CfnHookTypeConfigProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnHookTypeConfig), error;
        }
        cdk.requireProperty(props, "configuration", this), this.attrConfigurationArn = cdk.Token.asString(this.getAtt("ConfigurationArn", cdk.ResolutionTypeHint.STRING)), this.configuration = props.configuration, this.configurationAlias = props.configurationAlias, this.typeArn = props.typeArn, this.typeName = props.typeName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnHookTypeConfig.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { configuration: this.configuration, configurationAlias: this.configurationAlias, typeArn: this.typeArn, typeName: this.typeName };
      }
      renderProperties(props) {
        return cfnHookTypeConfigPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnHookTypeConfig[_c] = { fqn: "aws-cdk-lib.aws_cloudformation.CfnHookTypeConfig", version: "2.80.0" }, CfnHookTypeConfig.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::HookTypeConfig", exports2.CfnHookTypeConfig = CfnHookTypeConfig;
    function CfnHookVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("executionRoleArn", cdk.validateString)(properties.executionRoleArn)), errors.collect(cdk.propertyValidator("loggingConfig", CfnHookVersion_LoggingConfigPropertyValidator)(properties.loggingConfig)), errors.collect(cdk.propertyValidator("schemaHandlerPackage", cdk.requiredValidator)(properties.schemaHandlerPackage)), errors.collect(cdk.propertyValidator("schemaHandlerPackage", cdk.validateString)(properties.schemaHandlerPackage)), errors.collect(cdk.propertyValidator("typeName", cdk.requiredValidator)(properties.typeName)), errors.collect(cdk.propertyValidator("typeName", cdk.validateString)(properties.typeName)), errors.wrap('supplied properties not correct for "CfnHookVersionProps"');
    }
    function cfnHookVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHookVersionPropsValidator(properties).assertSuccess(), { SchemaHandlerPackage: cdk.stringToCloudFormation(properties.schemaHandlerPackage), TypeName: cdk.stringToCloudFormation(properties.typeName), ExecutionRoleArn: cdk.stringToCloudFormation(properties.executionRoleArn), LoggingConfig: cfnHookVersionLoggingConfigPropertyToCloudFormation(properties.loggingConfig) }) : properties;
    }
    function CfnHookVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("schemaHandlerPackage", "SchemaHandlerPackage", cfn_parse.FromCloudFormation.getString(properties.SchemaHandlerPackage)), ret.addPropertyResult("typeName", "TypeName", cfn_parse.FromCloudFormation.getString(properties.TypeName)), ret.addPropertyResult("executionRoleArn", "ExecutionRoleArn", properties.ExecutionRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.ExecutionRoleArn) : void 0), ret.addPropertyResult("loggingConfig", "LoggingConfig", properties.LoggingConfig != null ? CfnHookVersionLoggingConfigPropertyFromCloudFormation(properties.LoggingConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnHookVersion = class _CfnHookVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnHookVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnHookVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnHookVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudformation_CfnHookVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnHookVersion), error;
        }
        cdk.requireProperty(props, "schemaHandlerPackage", this), cdk.requireProperty(props, "typeName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrIsDefaultVersion = this.getAtt("IsDefaultVersion", cdk.ResolutionTypeHint.STRING), this.attrTypeArn = cdk.Token.asString(this.getAtt("TypeArn", cdk.ResolutionTypeHint.STRING)), this.attrVersionId = cdk.Token.asString(this.getAtt("VersionId", cdk.ResolutionTypeHint.STRING)), this.attrVisibility = cdk.Token.asString(this.getAtt("Visibility", cdk.ResolutionTypeHint.STRING)), this.schemaHandlerPackage = props.schemaHandlerPackage, this.typeName = props.typeName, this.executionRoleArn = props.executionRoleArn, this.loggingConfig = props.loggingConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnHookVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { schemaHandlerPackage: this.schemaHandlerPackage, typeName: this.typeName, executionRoleArn: this.executionRoleArn, loggingConfig: this.loggingConfig };
      }
      renderProperties(props) {
        return cfnHookVersionPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnHookVersion[_d] = { fqn: "aws-cdk-lib.aws_cloudformation.CfnHookVersion", version: "2.80.0" }, CfnHookVersion.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::HookVersion", exports2.CfnHookVersion = CfnHookVersion;
    function CfnHookVersion_LoggingConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logGroupName", cdk.validateString)(properties.logGroupName)), errors.collect(cdk.propertyValidator("logRoleArn", cdk.validateString)(properties.logRoleArn)), errors.wrap('supplied properties not correct for "LoggingConfigProperty"');
    }
    function cfnHookVersionLoggingConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHookVersion_LoggingConfigPropertyValidator(properties).assertSuccess(), { LogGroupName: cdk.stringToCloudFormation(properties.logGroupName), LogRoleArn: cdk.stringToCloudFormation(properties.logRoleArn) }) : properties;
    }
    function CfnHookVersionLoggingConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logGroupName", "LogGroupName", properties.LogGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.LogGroupName) : void 0), ret.addPropertyResult("logRoleArn", "LogRoleArn", properties.LogRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.LogRoleArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMacroPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("functionName", cdk.requiredValidator)(properties.functionName)), errors.collect(cdk.propertyValidator("functionName", cdk.validateString)(properties.functionName)), errors.collect(cdk.propertyValidator("logGroupName", cdk.validateString)(properties.logGroupName)), errors.collect(cdk.propertyValidator("logRoleArn", cdk.validateString)(properties.logRoleArn)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "CfnMacroProps"');
    }
    function cfnMacroPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMacroPropsValidator(properties).assertSuccess(), { FunctionName: cdk.stringToCloudFormation(properties.functionName), Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), LogGroupName: cdk.stringToCloudFormation(properties.logGroupName), LogRoleARN: cdk.stringToCloudFormation(properties.logRoleArn) }) : properties;
    }
    function CfnMacroPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("functionName", "FunctionName", cfn_parse.FromCloudFormation.getString(properties.FunctionName)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("logGroupName", "LogGroupName", properties.LogGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.LogGroupName) : void 0), ret.addPropertyResult("logRoleArn", "LogRoleARN", properties.LogRoleARN != null ? cfn_parse.FromCloudFormation.getString(properties.LogRoleARN) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnMacro = class _CfnMacro extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnMacroPropsFromCloudFormation(resourceProperties), ret = new _CfnMacro(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnMacro.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudformation_CfnMacroProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnMacro), error;
        }
        cdk.requireProperty(props, "functionName", this), cdk.requireProperty(props, "name", this), this.functionName = props.functionName, this.name = props.name, this.description = props.description, this.logGroupName = props.logGroupName, this.logRoleArn = props.logRoleArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnMacro.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { functionName: this.functionName, name: this.name, description: this.description, logGroupName: this.logGroupName, logRoleArn: this.logRoleArn };
      }
      renderProperties(props) {
        return cfnMacroPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnMacro[_e] = { fqn: "aws-cdk-lib.aws_cloudformation.CfnMacro", version: "2.80.0" }, CfnMacro.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::Macro", exports2.CfnMacro = CfnMacro;
    function CfnModuleDefaultVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("moduleName", cdk.validateString)(properties.moduleName)), errors.collect(cdk.propertyValidator("versionId", cdk.validateString)(properties.versionId)), errors.wrap('supplied properties not correct for "CfnModuleDefaultVersionProps"');
    }
    function cfnModuleDefaultVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModuleDefaultVersionPropsValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn), ModuleName: cdk.stringToCloudFormation(properties.moduleName), VersionId: cdk.stringToCloudFormation(properties.versionId) }) : properties;
    }
    function CfnModuleDefaultVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", properties.Arn != null ? cfn_parse.FromCloudFormation.getString(properties.Arn) : void 0), ret.addPropertyResult("moduleName", "ModuleName", properties.ModuleName != null ? cfn_parse.FromCloudFormation.getString(properties.ModuleName) : void 0), ret.addPropertyResult("versionId", "VersionId", properties.VersionId != null ? cfn_parse.FromCloudFormation.getString(properties.VersionId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnModuleDefaultVersion = class _CfnModuleDefaultVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnModuleDefaultVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnModuleDefaultVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnModuleDefaultVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudformation_CfnModuleDefaultVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnModuleDefaultVersion), error;
        }
        this.arn = props.arn, this.moduleName = props.moduleName, this.versionId = props.versionId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnModuleDefaultVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { arn: this.arn, moduleName: this.moduleName, versionId: this.versionId };
      }
      renderProperties(props) {
        return cfnModuleDefaultVersionPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnModuleDefaultVersion[_f] = { fqn: "aws-cdk-lib.aws_cloudformation.CfnModuleDefaultVersion", version: "2.80.0" }, CfnModuleDefaultVersion.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::ModuleDefaultVersion", exports2.CfnModuleDefaultVersion = CfnModuleDefaultVersion;
    function CfnModuleVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("moduleName", cdk.requiredValidator)(properties.moduleName)), errors.collect(cdk.propertyValidator("moduleName", cdk.validateString)(properties.moduleName)), errors.collect(cdk.propertyValidator("modulePackage", cdk.requiredValidator)(properties.modulePackage)), errors.collect(cdk.propertyValidator("modulePackage", cdk.validateString)(properties.modulePackage)), errors.wrap('supplied properties not correct for "CfnModuleVersionProps"');
    }
    function cfnModuleVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModuleVersionPropsValidator(properties).assertSuccess(), { ModuleName: cdk.stringToCloudFormation(properties.moduleName), ModulePackage: cdk.stringToCloudFormation(properties.modulePackage) }) : properties;
    }
    function CfnModuleVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("moduleName", "ModuleName", cfn_parse.FromCloudFormation.getString(properties.ModuleName)), ret.addPropertyResult("modulePackage", "ModulePackage", cfn_parse.FromCloudFormation.getString(properties.ModulePackage)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnModuleVersion = class _CfnModuleVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnModuleVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnModuleVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnModuleVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudformation_CfnModuleVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnModuleVersion), error;
        }
        cdk.requireProperty(props, "moduleName", this), cdk.requireProperty(props, "modulePackage", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrDescription = cdk.Token.asString(this.getAtt("Description", cdk.ResolutionTypeHint.STRING)), this.attrDocumentationUrl = cdk.Token.asString(this.getAtt("DocumentationUrl", cdk.ResolutionTypeHint.STRING)), this.attrIsDefaultVersion = this.getAtt("IsDefaultVersion", cdk.ResolutionTypeHint.STRING), this.attrSchema = cdk.Token.asString(this.getAtt("Schema", cdk.ResolutionTypeHint.STRING)), this.attrTimeCreated = cdk.Token.asString(this.getAtt("TimeCreated", cdk.ResolutionTypeHint.STRING)), this.attrVersionId = cdk.Token.asString(this.getAtt("VersionId", cdk.ResolutionTypeHint.STRING)), this.attrVisibility = cdk.Token.asString(this.getAtt("Visibility", cdk.ResolutionTypeHint.STRING)), this.moduleName = props.moduleName, this.modulePackage = props.modulePackage;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnModuleVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { moduleName: this.moduleName, modulePackage: this.modulePackage };
      }
      renderProperties(props) {
        return cfnModuleVersionPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnModuleVersion[_g] = { fqn: "aws-cdk-lib.aws_cloudformation.CfnModuleVersion", version: "2.80.0" }, CfnModuleVersion.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::ModuleVersion", exports2.CfnModuleVersion = CfnModuleVersion;
    function CfnPublicTypeVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("logDeliveryBucket", cdk.validateString)(properties.logDeliveryBucket)), errors.collect(cdk.propertyValidator("publicVersionNumber", cdk.validateString)(properties.publicVersionNumber)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("typeName", cdk.validateString)(properties.typeName)), errors.wrap('supplied properties not correct for "CfnPublicTypeVersionProps"');
    }
    function cfnPublicTypeVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPublicTypeVersionPropsValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn), LogDeliveryBucket: cdk.stringToCloudFormation(properties.logDeliveryBucket), PublicVersionNumber: cdk.stringToCloudFormation(properties.publicVersionNumber), Type: cdk.stringToCloudFormation(properties.type), TypeName: cdk.stringToCloudFormation(properties.typeName) }) : properties;
    }
    function CfnPublicTypeVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", properties.Arn != null ? cfn_parse.FromCloudFormation.getString(properties.Arn) : void 0), ret.addPropertyResult("logDeliveryBucket", "LogDeliveryBucket", properties.LogDeliveryBucket != null ? cfn_parse.FromCloudFormation.getString(properties.LogDeliveryBucket) : void 0), ret.addPropertyResult("publicVersionNumber", "PublicVersionNumber", properties.PublicVersionNumber != null ? cfn_parse.FromCloudFormation.getString(properties.PublicVersionNumber) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addPropertyResult("typeName", "TypeName", properties.TypeName != null ? cfn_parse.FromCloudFormation.getString(properties.TypeName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPublicTypeVersion = class _CfnPublicTypeVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPublicTypeVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnPublicTypeVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnPublicTypeVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudformation_CfnPublicTypeVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPublicTypeVersion), error;
        }
        this.attrPublicTypeArn = cdk.Token.asString(this.getAtt("PublicTypeArn", cdk.ResolutionTypeHint.STRING)), this.attrPublisherId = cdk.Token.asString(this.getAtt("PublisherId", cdk.ResolutionTypeHint.STRING)), this.attrTypeVersionArn = cdk.Token.asString(this.getAtt("TypeVersionArn", cdk.ResolutionTypeHint.STRING)), this.arn = props.arn, this.logDeliveryBucket = props.logDeliveryBucket, this.publicVersionNumber = props.publicVersionNumber, this.type = props.type, this.typeName = props.typeName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPublicTypeVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { arn: this.arn, logDeliveryBucket: this.logDeliveryBucket, publicVersionNumber: this.publicVersionNumber, type: this.type, typeName: this.typeName };
      }
      renderProperties(props) {
        return cfnPublicTypeVersionPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnPublicTypeVersion[_h] = { fqn: "aws-cdk-lib.aws_cloudformation.CfnPublicTypeVersion", version: "2.80.0" }, CfnPublicTypeVersion.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::PublicTypeVersion", exports2.CfnPublicTypeVersion = CfnPublicTypeVersion;
    function CfnPublisherPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acceptTermsAndConditions", cdk.requiredValidator)(properties.acceptTermsAndConditions)), errors.collect(cdk.propertyValidator("acceptTermsAndConditions", cdk.validateBoolean)(properties.acceptTermsAndConditions)), errors.collect(cdk.propertyValidator("connectionArn", cdk.validateString)(properties.connectionArn)), errors.wrap('supplied properties not correct for "CfnPublisherProps"');
    }
    function cfnPublisherPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPublisherPropsValidator(properties).assertSuccess(), { AcceptTermsAndConditions: cdk.booleanToCloudFormation(properties.acceptTermsAndConditions), ConnectionArn: cdk.stringToCloudFormation(properties.connectionArn) }) : properties;
    }
    function CfnPublisherPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("acceptTermsAndConditions", "AcceptTermsAndConditions", cfn_parse.FromCloudFormation.getBoolean(properties.AcceptTermsAndConditions)), ret.addPropertyResult("connectionArn", "ConnectionArn", properties.ConnectionArn != null ? cfn_parse.FromCloudFormation.getString(properties.ConnectionArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPublisher = class _CfnPublisher extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPublisherPropsFromCloudFormation(resourceProperties), ret = new _CfnPublisher(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPublisher.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudformation_CfnPublisherProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPublisher), error;
        }
        cdk.requireProperty(props, "acceptTermsAndConditions", this), this.attrIdentityProvider = cdk.Token.asString(this.getAtt("IdentityProvider", cdk.ResolutionTypeHint.STRING)), this.attrPublisherId = cdk.Token.asString(this.getAtt("PublisherId", cdk.ResolutionTypeHint.STRING)), this.attrPublisherProfile = cdk.Token.asString(this.getAtt("PublisherProfile", cdk.ResolutionTypeHint.STRING)), this.attrPublisherStatus = cdk.Token.asString(this.getAtt("PublisherStatus", cdk.ResolutionTypeHint.STRING)), this.acceptTermsAndConditions = props.acceptTermsAndConditions, this.connectionArn = props.connectionArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPublisher.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { acceptTermsAndConditions: this.acceptTermsAndConditions, connectionArn: this.connectionArn };
      }
      renderProperties(props) {
        return cfnPublisherPropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnPublisher[_j] = { fqn: "aws-cdk-lib.aws_cloudformation.CfnPublisher", version: "2.80.0" }, CfnPublisher.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::Publisher", exports2.CfnPublisher = CfnPublisher;
    function CfnResourceDefaultVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("typeName", cdk.validateString)(properties.typeName)), errors.collect(cdk.propertyValidator("typeVersionArn", cdk.validateString)(properties.typeVersionArn)), errors.collect(cdk.propertyValidator("versionId", cdk.validateString)(properties.versionId)), errors.wrap('supplied properties not correct for "CfnResourceDefaultVersionProps"');
    }
    function cfnResourceDefaultVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceDefaultVersionPropsValidator(properties).assertSuccess(), { TypeName: cdk.stringToCloudFormation(properties.typeName), TypeVersionArn: cdk.stringToCloudFormation(properties.typeVersionArn), VersionId: cdk.stringToCloudFormation(properties.versionId) }) : properties;
    }
    function CfnResourceDefaultVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("typeName", "TypeName", properties.TypeName != null ? cfn_parse.FromCloudFormation.getString(properties.TypeName) : void 0), ret.addPropertyResult("typeVersionArn", "TypeVersionArn", properties.TypeVersionArn != null ? cfn_parse.FromCloudFormation.getString(properties.TypeVersionArn) : void 0), ret.addPropertyResult("versionId", "VersionId", properties.VersionId != null ? cfn_parse.FromCloudFormation.getString(properties.VersionId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResourceDefaultVersion = class _CfnResourceDefaultVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResourceDefaultVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnResourceDefaultVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnResourceDefaultVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudformation_CfnResourceDefaultVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResourceDefaultVersion), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.typeName = props.typeName, this.typeVersionArn = props.typeVersionArn, this.versionId = props.versionId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResourceDefaultVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { typeName: this.typeName, typeVersionArn: this.typeVersionArn, versionId: this.versionId };
      }
      renderProperties(props) {
        return cfnResourceDefaultVersionPropsToCloudFormation(props);
      }
    };
    _k = JSII_RTTI_SYMBOL_1, CfnResourceDefaultVersion[_k] = { fqn: "aws-cdk-lib.aws_cloudformation.CfnResourceDefaultVersion", version: "2.80.0" }, CfnResourceDefaultVersion.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::ResourceDefaultVersion", exports2.CfnResourceDefaultVersion = CfnResourceDefaultVersion;
    function CfnResourceVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("executionRoleArn", cdk.validateString)(properties.executionRoleArn)), errors.collect(cdk.propertyValidator("loggingConfig", CfnResourceVersion_LoggingConfigPropertyValidator)(properties.loggingConfig)), errors.collect(cdk.propertyValidator("schemaHandlerPackage", cdk.requiredValidator)(properties.schemaHandlerPackage)), errors.collect(cdk.propertyValidator("schemaHandlerPackage", cdk.validateString)(properties.schemaHandlerPackage)), errors.collect(cdk.propertyValidator("typeName", cdk.requiredValidator)(properties.typeName)), errors.collect(cdk.propertyValidator("typeName", cdk.validateString)(properties.typeName)), errors.wrap('supplied properties not correct for "CfnResourceVersionProps"');
    }
    function cfnResourceVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceVersionPropsValidator(properties).assertSuccess(), { SchemaHandlerPackage: cdk.stringToCloudFormation(properties.schemaHandlerPackage), TypeName: cdk.stringToCloudFormation(properties.typeName), ExecutionRoleArn: cdk.stringToCloudFormation(properties.executionRoleArn), LoggingConfig: cfnResourceVersionLoggingConfigPropertyToCloudFormation(properties.loggingConfig) }) : properties;
    }
    function CfnResourceVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("schemaHandlerPackage", "SchemaHandlerPackage", cfn_parse.FromCloudFormation.getString(properties.SchemaHandlerPackage)), ret.addPropertyResult("typeName", "TypeName", cfn_parse.FromCloudFormation.getString(properties.TypeName)), ret.addPropertyResult("executionRoleArn", "ExecutionRoleArn", properties.ExecutionRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.ExecutionRoleArn) : void 0), ret.addPropertyResult("loggingConfig", "LoggingConfig", properties.LoggingConfig != null ? CfnResourceVersionLoggingConfigPropertyFromCloudFormation(properties.LoggingConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResourceVersion = class _CfnResourceVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResourceVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnResourceVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnResourceVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudformation_CfnResourceVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResourceVersion), error;
        }
        cdk.requireProperty(props, "schemaHandlerPackage", this), cdk.requireProperty(props, "typeName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrIsDefaultVersion = this.getAtt("IsDefaultVersion", cdk.ResolutionTypeHint.STRING), this.attrProvisioningType = cdk.Token.asString(this.getAtt("ProvisioningType", cdk.ResolutionTypeHint.STRING)), this.attrTypeArn = cdk.Token.asString(this.getAtt("TypeArn", cdk.ResolutionTypeHint.STRING)), this.attrVersionId = cdk.Token.asString(this.getAtt("VersionId", cdk.ResolutionTypeHint.STRING)), this.attrVisibility = cdk.Token.asString(this.getAtt("Visibility", cdk.ResolutionTypeHint.STRING)), this.schemaHandlerPackage = props.schemaHandlerPackage, this.typeName = props.typeName, this.executionRoleArn = props.executionRoleArn, this.loggingConfig = props.loggingConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResourceVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { schemaHandlerPackage: this.schemaHandlerPackage, typeName: this.typeName, executionRoleArn: this.executionRoleArn, loggingConfig: this.loggingConfig };
      }
      renderProperties(props) {
        return cfnResourceVersionPropsToCloudFormation(props);
      }
    };
    _l = JSII_RTTI_SYMBOL_1, CfnResourceVersion[_l] = { fqn: "aws-cdk-lib.aws_cloudformation.CfnResourceVersion", version: "2.80.0" }, CfnResourceVersion.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::ResourceVersion", exports2.CfnResourceVersion = CfnResourceVersion;
    function CfnResourceVersion_LoggingConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logGroupName", cdk.validateString)(properties.logGroupName)), errors.collect(cdk.propertyValidator("logRoleArn", cdk.validateString)(properties.logRoleArn)), errors.wrap('supplied properties not correct for "LoggingConfigProperty"');
    }
    function cfnResourceVersionLoggingConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceVersion_LoggingConfigPropertyValidator(properties).assertSuccess(), { LogGroupName: cdk.stringToCloudFormation(properties.logGroupName), LogRoleArn: cdk.stringToCloudFormation(properties.logRoleArn) }) : properties;
    }
    function CfnResourceVersionLoggingConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logGroupName", "LogGroupName", properties.LogGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.LogGroupName) : void 0), ret.addPropertyResult("logRoleArn", "LogRoleArn", properties.LogRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.LogRoleArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStackPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("notificationArns", cdk.listValidator(cdk.validateString))(properties.notificationArns)), errors.collect(cdk.propertyValidator("parameters", cdk.hashValidator(cdk.validateString))(properties.parameters)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("templateUrl", cdk.requiredValidator)(properties.templateUrl)), errors.collect(cdk.propertyValidator("templateUrl", cdk.validateString)(properties.templateUrl)), errors.collect(cdk.propertyValidator("timeoutInMinutes", cdk.validateNumber)(properties.timeoutInMinutes)), errors.wrap('supplied properties not correct for "CfnStackProps"');
    }
    function cfnStackPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStackPropsValidator(properties).assertSuccess(), { TemplateURL: cdk.stringToCloudFormation(properties.templateUrl), NotificationARNs: cdk.listMapper(cdk.stringToCloudFormation)(properties.notificationArns), Parameters: cdk.hashMapper(cdk.stringToCloudFormation)(properties.parameters), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TimeoutInMinutes: cdk.numberToCloudFormation(properties.timeoutInMinutes) }) : properties;
    }
    function CfnStackPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("templateUrl", "TemplateURL", cfn_parse.FromCloudFormation.getString(properties.TemplateURL)), ret.addPropertyResult("notificationArns", "NotificationARNs", properties.NotificationARNs != null ? cfn_parse.FromCloudFormation.getStringArray(properties.NotificationARNs) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Parameters) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("timeoutInMinutes", "TimeoutInMinutes", properties.TimeoutInMinutes != null ? cfn_parse.FromCloudFormation.getNumber(properties.TimeoutInMinutes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnStack = class _CfnStack extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnStackPropsFromCloudFormation(resourceProperties), ret = new _CfnStack(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnStack.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudformation_CfnStackProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnStack), error;
        }
        cdk.requireProperty(props, "templateUrl", this), this.templateUrl = props.templateUrl, this.notificationArns = props.notificationArns, this.parameters = props.parameters, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::CloudFormation::Stack", props.tags, { tagPropertyName: "tags" }), this.timeoutInMinutes = props.timeoutInMinutes, this.node.scope && cdk.Resource.isResource(this.node.scope) && this.node.addValidation({ validate: () => this.cfnOptions.deletionPolicy === void 0 ? ["'AWS::CloudFormation::Stack' is a stateful resource type, and you must specify a Removal Policy for it. Call 'resource.applyRemovalPolicy()'."] : [] });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStack.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { templateUrl: this.templateUrl, notificationArns: this.notificationArns, parameters: this.parameters, tags: this.tags.renderTags(), timeoutInMinutes: this.timeoutInMinutes };
      }
      renderProperties(props) {
        return cfnStackPropsToCloudFormation(props);
      }
    };
    _m = JSII_RTTI_SYMBOL_1, CfnStack[_m] = { fqn: "aws-cdk-lib.aws_cloudformation.CfnStack", version: "2.80.0" }, CfnStack.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::Stack", exports2.CfnStack = CfnStack;
    function CfnStackSetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("administrationRoleArn", cdk.validateString)(properties.administrationRoleArn)), errors.collect(cdk.propertyValidator("autoDeployment", CfnStackSet_AutoDeploymentPropertyValidator)(properties.autoDeployment)), errors.collect(cdk.propertyValidator("callAs", cdk.validateString)(properties.callAs)), errors.collect(cdk.propertyValidator("capabilities", cdk.listValidator(cdk.validateString))(properties.capabilities)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("executionRoleName", cdk.validateString)(properties.executionRoleName)), errors.collect(cdk.propertyValidator("managedExecution", cdk.validateObject)(properties.managedExecution)), errors.collect(cdk.propertyValidator("operationPreferences", CfnStackSet_OperationPreferencesPropertyValidator)(properties.operationPreferences)), errors.collect(cdk.propertyValidator("parameters", cdk.listValidator(CfnStackSet_ParameterPropertyValidator))(properties.parameters)), errors.collect(cdk.propertyValidator("permissionModel", cdk.requiredValidator)(properties.permissionModel)), errors.collect(cdk.propertyValidator("permissionModel", cdk.validateString)(properties.permissionModel)), errors.collect(cdk.propertyValidator("stackInstancesGroup", cdk.listValidator(CfnStackSet_StackInstancesPropertyValidator))(properties.stackInstancesGroup)), errors.collect(cdk.propertyValidator("stackSetName", cdk.requiredValidator)(properties.stackSetName)), errors.collect(cdk.propertyValidator("stackSetName", cdk.validateString)(properties.stackSetName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("templateBody", cdk.validateString)(properties.templateBody)), errors.collect(cdk.propertyValidator("templateUrl", cdk.validateString)(properties.templateUrl)), errors.wrap('supplied properties not correct for "CfnStackSetProps"');
    }
    function cfnStackSetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStackSetPropsValidator(properties).assertSuccess(), { PermissionModel: cdk.stringToCloudFormation(properties.permissionModel), StackSetName: cdk.stringToCloudFormation(properties.stackSetName), AdministrationRoleARN: cdk.stringToCloudFormation(properties.administrationRoleArn), AutoDeployment: cfnStackSetAutoDeploymentPropertyToCloudFormation(properties.autoDeployment), CallAs: cdk.stringToCloudFormation(properties.callAs), Capabilities: cdk.listMapper(cdk.stringToCloudFormation)(properties.capabilities), Description: cdk.stringToCloudFormation(properties.description), ExecutionRoleName: cdk.stringToCloudFormation(properties.executionRoleName), ManagedExecution: cdk.objectToCloudFormation(properties.managedExecution), OperationPreferences: cfnStackSetOperationPreferencesPropertyToCloudFormation(properties.operationPreferences), Parameters: cdk.listMapper(cfnStackSetParameterPropertyToCloudFormation)(properties.parameters), StackInstancesGroup: cdk.listMapper(cfnStackSetStackInstancesPropertyToCloudFormation)(properties.stackInstancesGroup), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TemplateBody: cdk.stringToCloudFormation(properties.templateBody), TemplateURL: cdk.stringToCloudFormation(properties.templateUrl) }) : properties;
    }
    function CfnStackSetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("permissionModel", "PermissionModel", cfn_parse.FromCloudFormation.getString(properties.PermissionModel)), ret.addPropertyResult("stackSetName", "StackSetName", cfn_parse.FromCloudFormation.getString(properties.StackSetName)), ret.addPropertyResult("administrationRoleArn", "AdministrationRoleARN", properties.AdministrationRoleARN != null ? cfn_parse.FromCloudFormation.getString(properties.AdministrationRoleARN) : void 0), ret.addPropertyResult("autoDeployment", "AutoDeployment", properties.AutoDeployment != null ? CfnStackSetAutoDeploymentPropertyFromCloudFormation(properties.AutoDeployment) : void 0), ret.addPropertyResult("callAs", "CallAs", properties.CallAs != null ? cfn_parse.FromCloudFormation.getString(properties.CallAs) : void 0), ret.addPropertyResult("capabilities", "Capabilities", properties.Capabilities != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Capabilities) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("executionRoleName", "ExecutionRoleName", properties.ExecutionRoleName != null ? cfn_parse.FromCloudFormation.getString(properties.ExecutionRoleName) : void 0), ret.addPropertyResult("managedExecution", "ManagedExecution", properties.ManagedExecution != null ? cfn_parse.FromCloudFormation.getAny(properties.ManagedExecution) : void 0), ret.addPropertyResult("operationPreferences", "OperationPreferences", properties.OperationPreferences != null ? CfnStackSetOperationPreferencesPropertyFromCloudFormation(properties.OperationPreferences) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getArray(CfnStackSetParameterPropertyFromCloudFormation)(properties.Parameters) : void 0), ret.addPropertyResult("stackInstancesGroup", "StackInstancesGroup", properties.StackInstancesGroup != null ? cfn_parse.FromCloudFormation.getArray(CfnStackSetStackInstancesPropertyFromCloudFormation)(properties.StackInstancesGroup) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("templateBody", "TemplateBody", properties.TemplateBody != null ? cfn_parse.FromCloudFormation.getString(properties.TemplateBody) : void 0), ret.addPropertyResult("templateUrl", "TemplateURL", properties.TemplateURL != null ? cfn_parse.FromCloudFormation.getString(properties.TemplateURL) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnStackSet = class _CfnStackSet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnStackSetPropsFromCloudFormation(resourceProperties), ret = new _CfnStackSet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnStackSet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudformation_CfnStackSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnStackSet), error;
        }
        cdk.requireProperty(props, "permissionModel", this), cdk.requireProperty(props, "stackSetName", this), this.attrStackSetId = cdk.Token.asString(this.getAtt("StackSetId", cdk.ResolutionTypeHint.STRING)), this.permissionModel = props.permissionModel, this.stackSetName = props.stackSetName, this.administrationRoleArn = props.administrationRoleArn, this.autoDeployment = props.autoDeployment, this.callAs = props.callAs, this.capabilities = props.capabilities, this.description = props.description, this.executionRoleName = props.executionRoleName, this.managedExecution = props.managedExecution, this.operationPreferences = props.operationPreferences, this.parameters = props.parameters, this.stackInstancesGroup = props.stackInstancesGroup, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::CloudFormation::StackSet", props.tags, { tagPropertyName: "tags" }), this.templateBody = props.templateBody, this.templateUrl = props.templateUrl;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStackSet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { permissionModel: this.permissionModel, stackSetName: this.stackSetName, administrationRoleArn: this.administrationRoleArn, autoDeployment: this.autoDeployment, callAs: this.callAs, capabilities: this.capabilities, description: this.description, executionRoleName: this.executionRoleName, managedExecution: this.managedExecution, operationPreferences: this.operationPreferences, parameters: this.parameters, stackInstancesGroup: this.stackInstancesGroup, tags: this.tags.renderTags(), templateBody: this.templateBody, templateUrl: this.templateUrl };
      }
      renderProperties(props) {
        return cfnStackSetPropsToCloudFormation(props);
      }
    };
    _o = JSII_RTTI_SYMBOL_1, CfnStackSet[_o] = { fqn: "aws-cdk-lib.aws_cloudformation.CfnStackSet", version: "2.80.0" }, CfnStackSet.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::StackSet", exports2.CfnStackSet = CfnStackSet;
    function CfnStackSet_AutoDeploymentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("retainStacksOnAccountRemoval", cdk.validateBoolean)(properties.retainStacksOnAccountRemoval)), errors.wrap('supplied properties not correct for "AutoDeploymentProperty"');
    }
    function cfnStackSetAutoDeploymentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStackSet_AutoDeploymentPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled), RetainStacksOnAccountRemoval: cdk.booleanToCloudFormation(properties.retainStacksOnAccountRemoval) }) : properties;
    }
    function CfnStackSetAutoDeploymentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("retainStacksOnAccountRemoval", "RetainStacksOnAccountRemoval", properties.RetainStacksOnAccountRemoval != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RetainStacksOnAccountRemoval) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStackSet_DeploymentTargetsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accountFilterType", cdk.validateString)(properties.accountFilterType)), errors.collect(cdk.propertyValidator("accounts", cdk.listValidator(cdk.validateString))(properties.accounts)), errors.collect(cdk.propertyValidator("organizationalUnitIds", cdk.listValidator(cdk.validateString))(properties.organizationalUnitIds)), errors.wrap('supplied properties not correct for "DeploymentTargetsProperty"');
    }
    function cfnStackSetDeploymentTargetsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStackSet_DeploymentTargetsPropertyValidator(properties).assertSuccess(), { AccountFilterType: cdk.stringToCloudFormation(properties.accountFilterType), Accounts: cdk.listMapper(cdk.stringToCloudFormation)(properties.accounts), OrganizationalUnitIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.organizationalUnitIds) }) : properties;
    }
    function CfnStackSetDeploymentTargetsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accountFilterType", "AccountFilterType", properties.AccountFilterType != null ? cfn_parse.FromCloudFormation.getString(properties.AccountFilterType) : void 0), ret.addPropertyResult("accounts", "Accounts", properties.Accounts != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Accounts) : void 0), ret.addPropertyResult("organizationalUnitIds", "OrganizationalUnitIds", properties.OrganizationalUnitIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.OrganizationalUnitIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStackSet_OperationPreferencesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("failureToleranceCount", cdk.validateNumber)(properties.failureToleranceCount)), errors.collect(cdk.propertyValidator("failureTolerancePercentage", cdk.validateNumber)(properties.failureTolerancePercentage)), errors.collect(cdk.propertyValidator("maxConcurrentCount", cdk.validateNumber)(properties.maxConcurrentCount)), errors.collect(cdk.propertyValidator("maxConcurrentPercentage", cdk.validateNumber)(properties.maxConcurrentPercentage)), errors.collect(cdk.propertyValidator("regionConcurrencyType", cdk.validateString)(properties.regionConcurrencyType)), errors.collect(cdk.propertyValidator("regionOrder", cdk.listValidator(cdk.validateString))(properties.regionOrder)), errors.wrap('supplied properties not correct for "OperationPreferencesProperty"');
    }
    function cfnStackSetOperationPreferencesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStackSet_OperationPreferencesPropertyValidator(properties).assertSuccess(), { FailureToleranceCount: cdk.numberToCloudFormation(properties.failureToleranceCount), FailureTolerancePercentage: cdk.numberToCloudFormation(properties.failureTolerancePercentage), MaxConcurrentCount: cdk.numberToCloudFormation(properties.maxConcurrentCount), MaxConcurrentPercentage: cdk.numberToCloudFormation(properties.maxConcurrentPercentage), RegionConcurrencyType: cdk.stringToCloudFormation(properties.regionConcurrencyType), RegionOrder: cdk.listMapper(cdk.stringToCloudFormation)(properties.regionOrder) }) : properties;
    }
    function CfnStackSetOperationPreferencesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("failureToleranceCount", "FailureToleranceCount", properties.FailureToleranceCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.FailureToleranceCount) : void 0), ret.addPropertyResult("failureTolerancePercentage", "FailureTolerancePercentage", properties.FailureTolerancePercentage != null ? cfn_parse.FromCloudFormation.getNumber(properties.FailureTolerancePercentage) : void 0), ret.addPropertyResult("maxConcurrentCount", "MaxConcurrentCount", properties.MaxConcurrentCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxConcurrentCount) : void 0), ret.addPropertyResult("maxConcurrentPercentage", "MaxConcurrentPercentage", properties.MaxConcurrentPercentage != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxConcurrentPercentage) : void 0), ret.addPropertyResult("regionConcurrencyType", "RegionConcurrencyType", properties.RegionConcurrencyType != null ? cfn_parse.FromCloudFormation.getString(properties.RegionConcurrencyType) : void 0), ret.addPropertyResult("regionOrder", "RegionOrder", properties.RegionOrder != null ? cfn_parse.FromCloudFormation.getStringArray(properties.RegionOrder) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStackSet_ParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("parameterKey", cdk.requiredValidator)(properties.parameterKey)), errors.collect(cdk.propertyValidator("parameterKey", cdk.validateString)(properties.parameterKey)), errors.collect(cdk.propertyValidator("parameterValue", cdk.requiredValidator)(properties.parameterValue)), errors.collect(cdk.propertyValidator("parameterValue", cdk.validateString)(properties.parameterValue)), errors.wrap('supplied properties not correct for "ParameterProperty"');
    }
    function cfnStackSetParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStackSet_ParameterPropertyValidator(properties).assertSuccess(), { ParameterKey: cdk.stringToCloudFormation(properties.parameterKey), ParameterValue: cdk.stringToCloudFormation(properties.parameterValue) }) : properties;
    }
    function CfnStackSetParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("parameterKey", "ParameterKey", cfn_parse.FromCloudFormation.getString(properties.ParameterKey)), ret.addPropertyResult("parameterValue", "ParameterValue", cfn_parse.FromCloudFormation.getString(properties.ParameterValue)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStackSet_StackInstancesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deploymentTargets", cdk.requiredValidator)(properties.deploymentTargets)), errors.collect(cdk.propertyValidator("deploymentTargets", CfnStackSet_DeploymentTargetsPropertyValidator)(properties.deploymentTargets)), errors.collect(cdk.propertyValidator("parameterOverrides", cdk.listValidator(CfnStackSet_ParameterPropertyValidator))(properties.parameterOverrides)), errors.collect(cdk.propertyValidator("regions", cdk.requiredValidator)(properties.regions)), errors.collect(cdk.propertyValidator("regions", cdk.listValidator(cdk.validateString))(properties.regions)), errors.wrap('supplied properties not correct for "StackInstancesProperty"');
    }
    function cfnStackSetStackInstancesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStackSet_StackInstancesPropertyValidator(properties).assertSuccess(), { DeploymentTargets: cfnStackSetDeploymentTargetsPropertyToCloudFormation(properties.deploymentTargets), ParameterOverrides: cdk.listMapper(cfnStackSetParameterPropertyToCloudFormation)(properties.parameterOverrides), Regions: cdk.listMapper(cdk.stringToCloudFormation)(properties.regions) }) : properties;
    }
    function CfnStackSetStackInstancesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deploymentTargets", "DeploymentTargets", CfnStackSetDeploymentTargetsPropertyFromCloudFormation(properties.DeploymentTargets)), ret.addPropertyResult("parameterOverrides", "ParameterOverrides", properties.ParameterOverrides != null ? cfn_parse.FromCloudFormation.getArray(CfnStackSetParameterPropertyFromCloudFormation)(properties.ParameterOverrides) : void 0), ret.addPropertyResult("regions", "Regions", cfn_parse.FromCloudFormation.getStringArray(properties.Regions)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTypeActivationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoUpdate", cdk.validateBoolean)(properties.autoUpdate)), errors.collect(cdk.propertyValidator("executionRoleArn", cdk.validateString)(properties.executionRoleArn)), errors.collect(cdk.propertyValidator("loggingConfig", CfnTypeActivation_LoggingConfigPropertyValidator)(properties.loggingConfig)), errors.collect(cdk.propertyValidator("majorVersion", cdk.validateString)(properties.majorVersion)), errors.collect(cdk.propertyValidator("publicTypeArn", cdk.validateString)(properties.publicTypeArn)), errors.collect(cdk.propertyValidator("publisherId", cdk.validateString)(properties.publisherId)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("typeName", cdk.validateString)(properties.typeName)), errors.collect(cdk.propertyValidator("typeNameAlias", cdk.validateString)(properties.typeNameAlias)), errors.collect(cdk.propertyValidator("versionBump", cdk.validateString)(properties.versionBump)), errors.wrap('supplied properties not correct for "CfnTypeActivationProps"');
    }
    function cfnTypeActivationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTypeActivationPropsValidator(properties).assertSuccess(), { AutoUpdate: cdk.booleanToCloudFormation(properties.autoUpdate), ExecutionRoleArn: cdk.stringToCloudFormation(properties.executionRoleArn), LoggingConfig: cfnTypeActivationLoggingConfigPropertyToCloudFormation(properties.loggingConfig), MajorVersion: cdk.stringToCloudFormation(properties.majorVersion), PublicTypeArn: cdk.stringToCloudFormation(properties.publicTypeArn), PublisherId: cdk.stringToCloudFormation(properties.publisherId), Type: cdk.stringToCloudFormation(properties.type), TypeName: cdk.stringToCloudFormation(properties.typeName), TypeNameAlias: cdk.stringToCloudFormation(properties.typeNameAlias), VersionBump: cdk.stringToCloudFormation(properties.versionBump) }) : properties;
    }
    function CfnTypeActivationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("autoUpdate", "AutoUpdate", properties.AutoUpdate != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AutoUpdate) : void 0), ret.addPropertyResult("executionRoleArn", "ExecutionRoleArn", properties.ExecutionRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.ExecutionRoleArn) : void 0), ret.addPropertyResult("loggingConfig", "LoggingConfig", properties.LoggingConfig != null ? CfnTypeActivationLoggingConfigPropertyFromCloudFormation(properties.LoggingConfig) : void 0), ret.addPropertyResult("majorVersion", "MajorVersion", properties.MajorVersion != null ? cfn_parse.FromCloudFormation.getString(properties.MajorVersion) : void 0), ret.addPropertyResult("publicTypeArn", "PublicTypeArn", properties.PublicTypeArn != null ? cfn_parse.FromCloudFormation.getString(properties.PublicTypeArn) : void 0), ret.addPropertyResult("publisherId", "PublisherId", properties.PublisherId != null ? cfn_parse.FromCloudFormation.getString(properties.PublisherId) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addPropertyResult("typeName", "TypeName", properties.TypeName != null ? cfn_parse.FromCloudFormation.getString(properties.TypeName) : void 0), ret.addPropertyResult("typeNameAlias", "TypeNameAlias", properties.TypeNameAlias != null ? cfn_parse.FromCloudFormation.getString(properties.TypeNameAlias) : void 0), ret.addPropertyResult("versionBump", "VersionBump", properties.VersionBump != null ? cfn_parse.FromCloudFormation.getString(properties.VersionBump) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTypeActivation = class _CfnTypeActivation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTypeActivationPropsFromCloudFormation(resourceProperties), ret = new _CfnTypeActivation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnTypeActivation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudformation_CfnTypeActivationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTypeActivation), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.autoUpdate = props.autoUpdate, this.executionRoleArn = props.executionRoleArn, this.loggingConfig = props.loggingConfig, this.majorVersion = props.majorVersion, this.publicTypeArn = props.publicTypeArn, this.publisherId = props.publisherId, this.type = props.type, this.typeName = props.typeName, this.typeNameAlias = props.typeNameAlias, this.versionBump = props.versionBump;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTypeActivation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { autoUpdate: this.autoUpdate, executionRoleArn: this.executionRoleArn, loggingConfig: this.loggingConfig, majorVersion: this.majorVersion, publicTypeArn: this.publicTypeArn, publisherId: this.publisherId, type: this.type, typeName: this.typeName, typeNameAlias: this.typeNameAlias, versionBump: this.versionBump };
      }
      renderProperties(props) {
        return cfnTypeActivationPropsToCloudFormation(props);
      }
    };
    _p = JSII_RTTI_SYMBOL_1, CfnTypeActivation[_p] = { fqn: "aws-cdk-lib.aws_cloudformation.CfnTypeActivation", version: "2.80.0" }, CfnTypeActivation.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::TypeActivation", exports2.CfnTypeActivation = CfnTypeActivation;
    function CfnTypeActivation_LoggingConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logGroupName", cdk.validateString)(properties.logGroupName)), errors.collect(cdk.propertyValidator("logRoleArn", cdk.validateString)(properties.logRoleArn)), errors.wrap('supplied properties not correct for "LoggingConfigProperty"');
    }
    function cfnTypeActivationLoggingConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTypeActivation_LoggingConfigPropertyValidator(properties).assertSuccess(), { LogGroupName: cdk.stringToCloudFormation(properties.logGroupName), LogRoleArn: cdk.stringToCloudFormation(properties.logRoleArn) }) : properties;
    }
    function CfnTypeActivationLoggingConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logGroupName", "LogGroupName", properties.LogGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.LogGroupName) : void 0), ret.addPropertyResult("logRoleArn", "LogRoleArn", properties.LogRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.LogRoleArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWaitConditionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("count", cdk.validateNumber)(properties.count)), errors.collect(cdk.propertyValidator("handle", cdk.validateString)(properties.handle)), errors.collect(cdk.propertyValidator("timeout", cdk.validateString)(properties.timeout)), errors.wrap('supplied properties not correct for "CfnWaitConditionProps"');
    }
    function cfnWaitConditionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWaitConditionPropsValidator(properties).assertSuccess(), { Count: cdk.numberToCloudFormation(properties.count), Handle: cdk.stringToCloudFormation(properties.handle), Timeout: cdk.stringToCloudFormation(properties.timeout) }) : properties;
    }
    function CfnWaitConditionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("count", "Count", properties.Count != null ? cfn_parse.FromCloudFormation.getNumber(properties.Count) : void 0), ret.addPropertyResult("handle", "Handle", properties.Handle != null ? cfn_parse.FromCloudFormation.getString(properties.Handle) : void 0), ret.addPropertyResult("timeout", "Timeout", properties.Timeout != null ? cfn_parse.FromCloudFormation.getString(properties.Timeout) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnWaitCondition = class _CfnWaitCondition extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnWaitConditionPropsFromCloudFormation(resourceProperties), ret = new _CfnWaitCondition(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnWaitCondition.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudformation_CfnWaitConditionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnWaitCondition), error;
        }
        this.attrData = this.getAtt("Data", cdk.ResolutionTypeHint.STRING), this.count = props.count, this.handle = props.handle, this.timeout = props.timeout;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnWaitCondition.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { count: this.count, handle: this.handle, timeout: this.timeout };
      }
      renderProperties(props) {
        return cfnWaitConditionPropsToCloudFormation(props);
      }
    };
    _q = JSII_RTTI_SYMBOL_1, CfnWaitCondition[_q] = { fqn: "aws-cdk-lib.aws_cloudformation.CfnWaitCondition", version: "2.80.0" }, CfnWaitCondition.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::WaitCondition", exports2.CfnWaitCondition = CfnWaitCondition;
    var CfnWaitConditionHandle = class _CfnWaitConditionHandle extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const ret = new _CfnWaitConditionHandle(scope, id);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id) {
        super(scope, id, { type: _CfnWaitConditionHandle.CFN_RESOURCE_TYPE_NAME });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnWaitConditionHandle.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
    };
    _r = JSII_RTTI_SYMBOL_1, CfnWaitConditionHandle[_r] = { fqn: "aws-cdk-lib.aws_cloudformation.CfnWaitConditionHandle", version: "2.80.0" }, CfnWaitConditionHandle.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFormation::WaitConditionHandle", exports2.CfnWaitConditionHandle = CfnWaitConditionHandle;
  }
});

// node_modules/aws-cdk-lib/aws-cloudformation/lib/index.js
var require_lib70 = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudformation/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_cloud_formation_capabilities(), exports2), __exportStar(require_custom_resource2(), exports2), __exportStar(require_nested_stack2(), exports2), __exportStar(require_cloudformation_generated2(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-cloudformation/index.js
var require_aws_cloudformation = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudformation/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib70(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-cloudfront/lib/cloudfront.generated.js
var require_cloudfront_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudfront/lib/cloudfront.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    var _l;
    var _m;
    var _o;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnStreamingDistribution = exports2.CfnResponseHeadersPolicy = exports2.CfnRealtimeLogConfig = exports2.CfnPublicKey = exports2.CfnOriginRequestPolicy = exports2.CfnOriginAccessControl = exports2.CfnMonitoringSubscription = exports2.CfnKeyGroup = exports2.CfnFunction = exports2.CfnDistribution = exports2.CfnContinuousDeploymentPolicy = exports2.CfnCloudFrontOriginAccessIdentity = exports2.CfnCachePolicy = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnCachePolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cachePolicyConfig", cdk.requiredValidator)(properties.cachePolicyConfig)), errors.collect(cdk.propertyValidator("cachePolicyConfig", CfnCachePolicy_CachePolicyConfigPropertyValidator)(properties.cachePolicyConfig)), errors.wrap('supplied properties not correct for "CfnCachePolicyProps"');
    }
    function cfnCachePolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCachePolicyPropsValidator(properties).assertSuccess(), { CachePolicyConfig: cfnCachePolicyCachePolicyConfigPropertyToCloudFormation(properties.cachePolicyConfig) }) : properties;
    }
    function CfnCachePolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cachePolicyConfig", "CachePolicyConfig", CfnCachePolicyCachePolicyConfigPropertyFromCloudFormation(properties.CachePolicyConfig)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCachePolicy = class _CfnCachePolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCachePolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnCachePolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCachePolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_CfnCachePolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCachePolicy), error;
        }
        cdk.requireProperty(props, "cachePolicyConfig", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrLastModifiedTime = cdk.Token.asString(this.getAtt("LastModifiedTime", cdk.ResolutionTypeHint.STRING)), this.cachePolicyConfig = props.cachePolicyConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCachePolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { cachePolicyConfig: this.cachePolicyConfig };
      }
      renderProperties(props) {
        return cfnCachePolicyPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnCachePolicy[_a] = { fqn: "aws-cdk-lib.aws_cloudfront.CfnCachePolicy", version: "2.80.0" }, CfnCachePolicy.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFront::CachePolicy", exports2.CfnCachePolicy = CfnCachePolicy;
    function CfnCachePolicy_CachePolicyConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("comment", cdk.validateString)(properties.comment)), errors.collect(cdk.propertyValidator("defaultTtl", cdk.requiredValidator)(properties.defaultTtl)), errors.collect(cdk.propertyValidator("defaultTtl", cdk.validateNumber)(properties.defaultTtl)), errors.collect(cdk.propertyValidator("maxTtl", cdk.requiredValidator)(properties.maxTtl)), errors.collect(cdk.propertyValidator("maxTtl", cdk.validateNumber)(properties.maxTtl)), errors.collect(cdk.propertyValidator("minTtl", cdk.requiredValidator)(properties.minTtl)), errors.collect(cdk.propertyValidator("minTtl", cdk.validateNumber)(properties.minTtl)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("parametersInCacheKeyAndForwardedToOrigin", cdk.requiredValidator)(properties.parametersInCacheKeyAndForwardedToOrigin)), errors.collect(cdk.propertyValidator("parametersInCacheKeyAndForwardedToOrigin", CfnCachePolicy_ParametersInCacheKeyAndForwardedToOriginPropertyValidator)(properties.parametersInCacheKeyAndForwardedToOrigin)), errors.wrap('supplied properties not correct for "CachePolicyConfigProperty"');
    }
    function cfnCachePolicyCachePolicyConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCachePolicy_CachePolicyConfigPropertyValidator(properties).assertSuccess(), { Comment: cdk.stringToCloudFormation(properties.comment), DefaultTTL: cdk.numberToCloudFormation(properties.defaultTtl), MaxTTL: cdk.numberToCloudFormation(properties.maxTtl), MinTTL: cdk.numberToCloudFormation(properties.minTtl), Name: cdk.stringToCloudFormation(properties.name), ParametersInCacheKeyAndForwardedToOrigin: cfnCachePolicyParametersInCacheKeyAndForwardedToOriginPropertyToCloudFormation(properties.parametersInCacheKeyAndForwardedToOrigin) }) : properties;
    }
    function CfnCachePolicyCachePolicyConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("comment", "Comment", properties.Comment != null ? cfn_parse.FromCloudFormation.getString(properties.Comment) : void 0), ret.addPropertyResult("defaultTtl", "DefaultTTL", cfn_parse.FromCloudFormation.getNumber(properties.DefaultTTL)), ret.addPropertyResult("maxTtl", "MaxTTL", cfn_parse.FromCloudFormation.getNumber(properties.MaxTTL)), ret.addPropertyResult("minTtl", "MinTTL", cfn_parse.FromCloudFormation.getNumber(properties.MinTTL)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("parametersInCacheKeyAndForwardedToOrigin", "ParametersInCacheKeyAndForwardedToOrigin", CfnCachePolicyParametersInCacheKeyAndForwardedToOriginPropertyFromCloudFormation(properties.ParametersInCacheKeyAndForwardedToOrigin)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCachePolicy_CookiesConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cookieBehavior", cdk.requiredValidator)(properties.cookieBehavior)), errors.collect(cdk.propertyValidator("cookieBehavior", cdk.validateString)(properties.cookieBehavior)), errors.collect(cdk.propertyValidator("cookies", cdk.listValidator(cdk.validateString))(properties.cookies)), errors.wrap('supplied properties not correct for "CookiesConfigProperty"');
    }
    function cfnCachePolicyCookiesConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCachePolicy_CookiesConfigPropertyValidator(properties).assertSuccess(), { CookieBehavior: cdk.stringToCloudFormation(properties.cookieBehavior), Cookies: cdk.listMapper(cdk.stringToCloudFormation)(properties.cookies) }) : properties;
    }
    function CfnCachePolicyCookiesConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cookieBehavior", "CookieBehavior", cfn_parse.FromCloudFormation.getString(properties.CookieBehavior)), ret.addPropertyResult("cookies", "Cookies", properties.Cookies != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Cookies) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCachePolicy_HeadersConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("headerBehavior", cdk.requiredValidator)(properties.headerBehavior)), errors.collect(cdk.propertyValidator("headerBehavior", cdk.validateString)(properties.headerBehavior)), errors.collect(cdk.propertyValidator("headers", cdk.listValidator(cdk.validateString))(properties.headers)), errors.wrap('supplied properties not correct for "HeadersConfigProperty"');
    }
    function cfnCachePolicyHeadersConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCachePolicy_HeadersConfigPropertyValidator(properties).assertSuccess(), { HeaderBehavior: cdk.stringToCloudFormation(properties.headerBehavior), Headers: cdk.listMapper(cdk.stringToCloudFormation)(properties.headers) }) : properties;
    }
    function CfnCachePolicyHeadersConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("headerBehavior", "HeaderBehavior", cfn_parse.FromCloudFormation.getString(properties.HeaderBehavior)), ret.addPropertyResult("headers", "Headers", properties.Headers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Headers) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCachePolicy_ParametersInCacheKeyAndForwardedToOriginPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cookiesConfig", cdk.requiredValidator)(properties.cookiesConfig)), errors.collect(cdk.propertyValidator("cookiesConfig", CfnCachePolicy_CookiesConfigPropertyValidator)(properties.cookiesConfig)), errors.collect(cdk.propertyValidator("enableAcceptEncodingBrotli", cdk.validateBoolean)(properties.enableAcceptEncodingBrotli)), errors.collect(cdk.propertyValidator("enableAcceptEncodingGzip", cdk.requiredValidator)(properties.enableAcceptEncodingGzip)), errors.collect(cdk.propertyValidator("enableAcceptEncodingGzip", cdk.validateBoolean)(properties.enableAcceptEncodingGzip)), errors.collect(cdk.propertyValidator("headersConfig", cdk.requiredValidator)(properties.headersConfig)), errors.collect(cdk.propertyValidator("headersConfig", CfnCachePolicy_HeadersConfigPropertyValidator)(properties.headersConfig)), errors.collect(cdk.propertyValidator("queryStringsConfig", cdk.requiredValidator)(properties.queryStringsConfig)), errors.collect(cdk.propertyValidator("queryStringsConfig", CfnCachePolicy_QueryStringsConfigPropertyValidator)(properties.queryStringsConfig)), errors.wrap('supplied properties not correct for "ParametersInCacheKeyAndForwardedToOriginProperty"');
    }
    function cfnCachePolicyParametersInCacheKeyAndForwardedToOriginPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCachePolicy_ParametersInCacheKeyAndForwardedToOriginPropertyValidator(properties).assertSuccess(), { CookiesConfig: cfnCachePolicyCookiesConfigPropertyToCloudFormation(properties.cookiesConfig), EnableAcceptEncodingBrotli: cdk.booleanToCloudFormation(properties.enableAcceptEncodingBrotli), EnableAcceptEncodingGzip: cdk.booleanToCloudFormation(properties.enableAcceptEncodingGzip), HeadersConfig: cfnCachePolicyHeadersConfigPropertyToCloudFormation(properties.headersConfig), QueryStringsConfig: cfnCachePolicyQueryStringsConfigPropertyToCloudFormation(properties.queryStringsConfig) }) : properties;
    }
    function CfnCachePolicyParametersInCacheKeyAndForwardedToOriginPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cookiesConfig", "CookiesConfig", CfnCachePolicyCookiesConfigPropertyFromCloudFormation(properties.CookiesConfig)), ret.addPropertyResult("enableAcceptEncodingBrotli", "EnableAcceptEncodingBrotli", properties.EnableAcceptEncodingBrotli != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableAcceptEncodingBrotli) : void 0), ret.addPropertyResult("enableAcceptEncodingGzip", "EnableAcceptEncodingGzip", cfn_parse.FromCloudFormation.getBoolean(properties.EnableAcceptEncodingGzip)), ret.addPropertyResult("headersConfig", "HeadersConfig", CfnCachePolicyHeadersConfigPropertyFromCloudFormation(properties.HeadersConfig)), ret.addPropertyResult("queryStringsConfig", "QueryStringsConfig", CfnCachePolicyQueryStringsConfigPropertyFromCloudFormation(properties.QueryStringsConfig)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCachePolicy_QueryStringsConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("queryStringBehavior", cdk.requiredValidator)(properties.queryStringBehavior)), errors.collect(cdk.propertyValidator("queryStringBehavior", cdk.validateString)(properties.queryStringBehavior)), errors.collect(cdk.propertyValidator("queryStrings", cdk.listValidator(cdk.validateString))(properties.queryStrings)), errors.wrap('supplied properties not correct for "QueryStringsConfigProperty"');
    }
    function cfnCachePolicyQueryStringsConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCachePolicy_QueryStringsConfigPropertyValidator(properties).assertSuccess(), { QueryStringBehavior: cdk.stringToCloudFormation(properties.queryStringBehavior), QueryStrings: cdk.listMapper(cdk.stringToCloudFormation)(properties.queryStrings) }) : properties;
    }
    function CfnCachePolicyQueryStringsConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("queryStringBehavior", "QueryStringBehavior", cfn_parse.FromCloudFormation.getString(properties.QueryStringBehavior)), ret.addPropertyResult("queryStrings", "QueryStrings", properties.QueryStrings != null ? cfn_parse.FromCloudFormation.getStringArray(properties.QueryStrings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCloudFrontOriginAccessIdentityPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudFrontOriginAccessIdentityConfig", cdk.requiredValidator)(properties.cloudFrontOriginAccessIdentityConfig)), errors.collect(cdk.propertyValidator("cloudFrontOriginAccessIdentityConfig", CfnCloudFrontOriginAccessIdentity_CloudFrontOriginAccessIdentityConfigPropertyValidator)(properties.cloudFrontOriginAccessIdentityConfig)), errors.wrap('supplied properties not correct for "CfnCloudFrontOriginAccessIdentityProps"');
    }
    function cfnCloudFrontOriginAccessIdentityPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCloudFrontOriginAccessIdentityPropsValidator(properties).assertSuccess(), { CloudFrontOriginAccessIdentityConfig: cfnCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigPropertyToCloudFormation(properties.cloudFrontOriginAccessIdentityConfig) }) : properties;
    }
    function CfnCloudFrontOriginAccessIdentityPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudFrontOriginAccessIdentityConfig", "CloudFrontOriginAccessIdentityConfig", CfnCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigPropertyFromCloudFormation(properties.CloudFrontOriginAccessIdentityConfig)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCloudFrontOriginAccessIdentity = class _CfnCloudFrontOriginAccessIdentity extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCloudFrontOriginAccessIdentityPropsFromCloudFormation(resourceProperties), ret = new _CfnCloudFrontOriginAccessIdentity(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCloudFrontOriginAccessIdentity.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_CfnCloudFrontOriginAccessIdentityProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCloudFrontOriginAccessIdentity), error;
        }
        cdk.requireProperty(props, "cloudFrontOriginAccessIdentityConfig", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrS3CanonicalUserId = cdk.Token.asString(this.getAtt("S3CanonicalUserId", cdk.ResolutionTypeHint.STRING)), this.cloudFrontOriginAccessIdentityConfig = props.cloudFrontOriginAccessIdentityConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCloudFrontOriginAccessIdentity.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { cloudFrontOriginAccessIdentityConfig: this.cloudFrontOriginAccessIdentityConfig };
      }
      renderProperties(props) {
        return cfnCloudFrontOriginAccessIdentityPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnCloudFrontOriginAccessIdentity[_b] = { fqn: "aws-cdk-lib.aws_cloudfront.CfnCloudFrontOriginAccessIdentity", version: "2.80.0" }, CfnCloudFrontOriginAccessIdentity.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFront::CloudFrontOriginAccessIdentity", exports2.CfnCloudFrontOriginAccessIdentity = CfnCloudFrontOriginAccessIdentity;
    function CfnCloudFrontOriginAccessIdentity_CloudFrontOriginAccessIdentityConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("comment", cdk.requiredValidator)(properties.comment)), errors.collect(cdk.propertyValidator("comment", cdk.validateString)(properties.comment)), errors.wrap('supplied properties not correct for "CloudFrontOriginAccessIdentityConfigProperty"');
    }
    function cfnCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCloudFrontOriginAccessIdentity_CloudFrontOriginAccessIdentityConfigPropertyValidator(properties).assertSuccess(), { Comment: cdk.stringToCloudFormation(properties.comment) }) : properties;
    }
    function CfnCloudFrontOriginAccessIdentityCloudFrontOriginAccessIdentityConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("comment", "Comment", cfn_parse.FromCloudFormation.getString(properties.Comment)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnContinuousDeploymentPolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("continuousDeploymentPolicyConfig", cdk.requiredValidator)(properties.continuousDeploymentPolicyConfig)), errors.collect(cdk.propertyValidator("continuousDeploymentPolicyConfig", CfnContinuousDeploymentPolicy_ContinuousDeploymentPolicyConfigPropertyValidator)(properties.continuousDeploymentPolicyConfig)), errors.wrap('supplied properties not correct for "CfnContinuousDeploymentPolicyProps"');
    }
    function cfnContinuousDeploymentPolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContinuousDeploymentPolicyPropsValidator(properties).assertSuccess(), { ContinuousDeploymentPolicyConfig: cfnContinuousDeploymentPolicyContinuousDeploymentPolicyConfigPropertyToCloudFormation(properties.continuousDeploymentPolicyConfig) }) : properties;
    }
    function CfnContinuousDeploymentPolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("continuousDeploymentPolicyConfig", "ContinuousDeploymentPolicyConfig", CfnContinuousDeploymentPolicyContinuousDeploymentPolicyConfigPropertyFromCloudFormation(properties.ContinuousDeploymentPolicyConfig)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnContinuousDeploymentPolicy = class _CfnContinuousDeploymentPolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnContinuousDeploymentPolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnContinuousDeploymentPolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnContinuousDeploymentPolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_CfnContinuousDeploymentPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnContinuousDeploymentPolicy), error;
        }
        cdk.requireProperty(props, "continuousDeploymentPolicyConfig", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrLastModifiedTime = cdk.Token.asString(this.getAtt("LastModifiedTime", cdk.ResolutionTypeHint.STRING)), this.continuousDeploymentPolicyConfig = props.continuousDeploymentPolicyConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnContinuousDeploymentPolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { continuousDeploymentPolicyConfig: this.continuousDeploymentPolicyConfig };
      }
      renderProperties(props) {
        return cfnContinuousDeploymentPolicyPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnContinuousDeploymentPolicy[_c] = { fqn: "aws-cdk-lib.aws_cloudfront.CfnContinuousDeploymentPolicy", version: "2.80.0" }, CfnContinuousDeploymentPolicy.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFront::ContinuousDeploymentPolicy", exports2.CfnContinuousDeploymentPolicy = CfnContinuousDeploymentPolicy;
    function CfnContinuousDeploymentPolicy_ContinuousDeploymentPolicyConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("stagingDistributionDnsNames", cdk.requiredValidator)(properties.stagingDistributionDnsNames)), errors.collect(cdk.propertyValidator("stagingDistributionDnsNames", cdk.listValidator(cdk.validateString))(properties.stagingDistributionDnsNames)), errors.collect(cdk.propertyValidator("trafficConfig", CfnContinuousDeploymentPolicy_TrafficConfigPropertyValidator)(properties.trafficConfig)), errors.wrap('supplied properties not correct for "ContinuousDeploymentPolicyConfigProperty"');
    }
    function cfnContinuousDeploymentPolicyContinuousDeploymentPolicyConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContinuousDeploymentPolicy_ContinuousDeploymentPolicyConfigPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled), StagingDistributionDnsNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.stagingDistributionDnsNames), TrafficConfig: cfnContinuousDeploymentPolicyTrafficConfigPropertyToCloudFormation(properties.trafficConfig) }) : properties;
    }
    function CfnContinuousDeploymentPolicyContinuousDeploymentPolicyConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addPropertyResult("stagingDistributionDnsNames", "StagingDistributionDnsNames", cfn_parse.FromCloudFormation.getStringArray(properties.StagingDistributionDnsNames)), ret.addPropertyResult("trafficConfig", "TrafficConfig", properties.TrafficConfig != null ? CfnContinuousDeploymentPolicyTrafficConfigPropertyFromCloudFormation(properties.TrafficConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnContinuousDeploymentPolicy_SessionStickinessConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("idleTtl", cdk.requiredValidator)(properties.idleTtl)), errors.collect(cdk.propertyValidator("idleTtl", cdk.validateNumber)(properties.idleTtl)), errors.collect(cdk.propertyValidator("maximumTtl", cdk.requiredValidator)(properties.maximumTtl)), errors.collect(cdk.propertyValidator("maximumTtl", cdk.validateNumber)(properties.maximumTtl)), errors.wrap('supplied properties not correct for "SessionStickinessConfigProperty"');
    }
    function cfnContinuousDeploymentPolicySessionStickinessConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContinuousDeploymentPolicy_SessionStickinessConfigPropertyValidator(properties).assertSuccess(), { IdleTTL: cdk.numberToCloudFormation(properties.idleTtl), MaximumTTL: cdk.numberToCloudFormation(properties.maximumTtl) }) : properties;
    }
    function CfnContinuousDeploymentPolicySessionStickinessConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("idleTtl", "IdleTTL", cfn_parse.FromCloudFormation.getNumber(properties.IdleTTL)), ret.addPropertyResult("maximumTtl", "MaximumTTL", cfn_parse.FromCloudFormation.getNumber(properties.MaximumTTL)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnContinuousDeploymentPolicy_SingleHeaderConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("header", cdk.requiredValidator)(properties.header)), errors.collect(cdk.propertyValidator("header", cdk.validateString)(properties.header)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "SingleHeaderConfigProperty"');
    }
    function cfnContinuousDeploymentPolicySingleHeaderConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContinuousDeploymentPolicy_SingleHeaderConfigPropertyValidator(properties).assertSuccess(), { Header: cdk.stringToCloudFormation(properties.header), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnContinuousDeploymentPolicySingleHeaderConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("header", "Header", cfn_parse.FromCloudFormation.getString(properties.Header)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnContinuousDeploymentPolicy_SingleWeightConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sessionStickinessConfig", CfnContinuousDeploymentPolicy_SessionStickinessConfigPropertyValidator)(properties.sessionStickinessConfig)), errors.collect(cdk.propertyValidator("weight", cdk.requiredValidator)(properties.weight)), errors.collect(cdk.propertyValidator("weight", cdk.validateNumber)(properties.weight)), errors.wrap('supplied properties not correct for "SingleWeightConfigProperty"');
    }
    function cfnContinuousDeploymentPolicySingleWeightConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContinuousDeploymentPolicy_SingleWeightConfigPropertyValidator(properties).assertSuccess(), { SessionStickinessConfig: cfnContinuousDeploymentPolicySessionStickinessConfigPropertyToCloudFormation(properties.sessionStickinessConfig), Weight: cdk.numberToCloudFormation(properties.weight) }) : properties;
    }
    function CfnContinuousDeploymentPolicySingleWeightConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sessionStickinessConfig", "SessionStickinessConfig", properties.SessionStickinessConfig != null ? CfnContinuousDeploymentPolicySessionStickinessConfigPropertyFromCloudFormation(properties.SessionStickinessConfig) : void 0), ret.addPropertyResult("weight", "Weight", cfn_parse.FromCloudFormation.getNumber(properties.Weight)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnContinuousDeploymentPolicy_TrafficConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("singleHeaderConfig", CfnContinuousDeploymentPolicy_SingleHeaderConfigPropertyValidator)(properties.singleHeaderConfig)), errors.collect(cdk.propertyValidator("singleWeightConfig", CfnContinuousDeploymentPolicy_SingleWeightConfigPropertyValidator)(properties.singleWeightConfig)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "TrafficConfigProperty"');
    }
    function cfnContinuousDeploymentPolicyTrafficConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContinuousDeploymentPolicy_TrafficConfigPropertyValidator(properties).assertSuccess(), { SingleHeaderConfig: cfnContinuousDeploymentPolicySingleHeaderConfigPropertyToCloudFormation(properties.singleHeaderConfig), SingleWeightConfig: cfnContinuousDeploymentPolicySingleWeightConfigPropertyToCloudFormation(properties.singleWeightConfig), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnContinuousDeploymentPolicyTrafficConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("singleHeaderConfig", "SingleHeaderConfig", properties.SingleHeaderConfig != null ? CfnContinuousDeploymentPolicySingleHeaderConfigPropertyFromCloudFormation(properties.SingleHeaderConfig) : void 0), ret.addPropertyResult("singleWeightConfig", "SingleWeightConfig", properties.SingleWeightConfig != null ? CfnContinuousDeploymentPolicySingleWeightConfigPropertyFromCloudFormation(properties.SingleWeightConfig) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistributionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("distributionConfig", cdk.requiredValidator)(properties.distributionConfig)), errors.collect(cdk.propertyValidator("distributionConfig", CfnDistribution_DistributionConfigPropertyValidator)(properties.distributionConfig)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDistributionProps"');
    }
    function cfnDistributionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistributionPropsValidator(properties).assertSuccess(), { DistributionConfig: cfnDistributionDistributionConfigPropertyToCloudFormation(properties.distributionConfig), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDistributionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("distributionConfig", "DistributionConfig", CfnDistributionDistributionConfigPropertyFromCloudFormation(properties.DistributionConfig)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDistribution = class _CfnDistribution extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDistributionPropsFromCloudFormation(resourceProperties), ret = new _CfnDistribution(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDistribution.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_CfnDistributionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDistribution), error;
        }
        cdk.requireProperty(props, "distributionConfig", this), this.attrDomainName = cdk.Token.asString(this.getAtt("DomainName", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.distributionConfig = props.distributionConfig, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::CloudFront::Distribution", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDistribution.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { distributionConfig: this.distributionConfig, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDistributionPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnDistribution[_d] = { fqn: "aws-cdk-lib.aws_cloudfront.CfnDistribution", version: "2.80.0" }, CfnDistribution.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFront::Distribution", exports2.CfnDistribution = CfnDistribution;
    function CfnDistribution_CacheBehaviorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowedMethods", cdk.listValidator(cdk.validateString))(properties.allowedMethods)), errors.collect(cdk.propertyValidator("cachePolicyId", cdk.validateString)(properties.cachePolicyId)), errors.collect(cdk.propertyValidator("cachedMethods", cdk.listValidator(cdk.validateString))(properties.cachedMethods)), errors.collect(cdk.propertyValidator("compress", cdk.validateBoolean)(properties.compress)), errors.collect(cdk.propertyValidator("defaultTtl", cdk.validateNumber)(properties.defaultTtl)), errors.collect(cdk.propertyValidator("fieldLevelEncryptionId", cdk.validateString)(properties.fieldLevelEncryptionId)), errors.collect(cdk.propertyValidator("forwardedValues", CfnDistribution_ForwardedValuesPropertyValidator)(properties.forwardedValues)), errors.collect(cdk.propertyValidator("functionAssociations", cdk.listValidator(CfnDistribution_FunctionAssociationPropertyValidator))(properties.functionAssociations)), errors.collect(cdk.propertyValidator("lambdaFunctionAssociations", cdk.listValidator(CfnDistribution_LambdaFunctionAssociationPropertyValidator))(properties.lambdaFunctionAssociations)), errors.collect(cdk.propertyValidator("maxTtl", cdk.validateNumber)(properties.maxTtl)), errors.collect(cdk.propertyValidator("minTtl", cdk.validateNumber)(properties.minTtl)), errors.collect(cdk.propertyValidator("originRequestPolicyId", cdk.validateString)(properties.originRequestPolicyId)), errors.collect(cdk.propertyValidator("pathPattern", cdk.requiredValidator)(properties.pathPattern)), errors.collect(cdk.propertyValidator("pathPattern", cdk.validateString)(properties.pathPattern)), errors.collect(cdk.propertyValidator("realtimeLogConfigArn", cdk.validateString)(properties.realtimeLogConfigArn)), errors.collect(cdk.propertyValidator("responseHeadersPolicyId", cdk.validateString)(properties.responseHeadersPolicyId)), errors.collect(cdk.propertyValidator("smoothStreaming", cdk.validateBoolean)(properties.smoothStreaming)), errors.collect(cdk.propertyValidator("targetOriginId", cdk.requiredValidator)(properties.targetOriginId)), errors.collect(cdk.propertyValidator("targetOriginId", cdk.validateString)(properties.targetOriginId)), errors.collect(cdk.propertyValidator("trustedKeyGroups", cdk.listValidator(cdk.validateString))(properties.trustedKeyGroups)), errors.collect(cdk.propertyValidator("trustedSigners", cdk.listValidator(cdk.validateString))(properties.trustedSigners)), errors.collect(cdk.propertyValidator("viewerProtocolPolicy", cdk.requiredValidator)(properties.viewerProtocolPolicy)), errors.collect(cdk.propertyValidator("viewerProtocolPolicy", cdk.validateString)(properties.viewerProtocolPolicy)), errors.wrap('supplied properties not correct for "CacheBehaviorProperty"');
    }
    function cfnDistributionCacheBehaviorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_CacheBehaviorPropertyValidator(properties).assertSuccess(), { AllowedMethods: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowedMethods), CachePolicyId: cdk.stringToCloudFormation(properties.cachePolicyId), CachedMethods: cdk.listMapper(cdk.stringToCloudFormation)(properties.cachedMethods), Compress: cdk.booleanToCloudFormation(properties.compress), DefaultTTL: cdk.numberToCloudFormation(properties.defaultTtl), FieldLevelEncryptionId: cdk.stringToCloudFormation(properties.fieldLevelEncryptionId), ForwardedValues: cfnDistributionForwardedValuesPropertyToCloudFormation(properties.forwardedValues), FunctionAssociations: cdk.listMapper(cfnDistributionFunctionAssociationPropertyToCloudFormation)(properties.functionAssociations), LambdaFunctionAssociations: cdk.listMapper(cfnDistributionLambdaFunctionAssociationPropertyToCloudFormation)(properties.lambdaFunctionAssociations), MaxTTL: cdk.numberToCloudFormation(properties.maxTtl), MinTTL: cdk.numberToCloudFormation(properties.minTtl), OriginRequestPolicyId: cdk.stringToCloudFormation(properties.originRequestPolicyId), PathPattern: cdk.stringToCloudFormation(properties.pathPattern), RealtimeLogConfigArn: cdk.stringToCloudFormation(properties.realtimeLogConfigArn), ResponseHeadersPolicyId: cdk.stringToCloudFormation(properties.responseHeadersPolicyId), SmoothStreaming: cdk.booleanToCloudFormation(properties.smoothStreaming), TargetOriginId: cdk.stringToCloudFormation(properties.targetOriginId), TrustedKeyGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.trustedKeyGroups), TrustedSigners: cdk.listMapper(cdk.stringToCloudFormation)(properties.trustedSigners), ViewerProtocolPolicy: cdk.stringToCloudFormation(properties.viewerProtocolPolicy) }) : properties;
    }
    function CfnDistributionCacheBehaviorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowedMethods", "AllowedMethods", properties.AllowedMethods != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AllowedMethods) : void 0), ret.addPropertyResult("cachePolicyId", "CachePolicyId", properties.CachePolicyId != null ? cfn_parse.FromCloudFormation.getString(properties.CachePolicyId) : void 0), ret.addPropertyResult("cachedMethods", "CachedMethods", properties.CachedMethods != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CachedMethods) : void 0), ret.addPropertyResult("compress", "Compress", properties.Compress != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Compress) : void 0), ret.addPropertyResult("defaultTtl", "DefaultTTL", properties.DefaultTTL != null ? cfn_parse.FromCloudFormation.getNumber(properties.DefaultTTL) : void 0), ret.addPropertyResult("fieldLevelEncryptionId", "FieldLevelEncryptionId", properties.FieldLevelEncryptionId != null ? cfn_parse.FromCloudFormation.getString(properties.FieldLevelEncryptionId) : void 0), ret.addPropertyResult("forwardedValues", "ForwardedValues", properties.ForwardedValues != null ? CfnDistributionForwardedValuesPropertyFromCloudFormation(properties.ForwardedValues) : void 0), ret.addPropertyResult("functionAssociations", "FunctionAssociations", properties.FunctionAssociations != null ? cfn_parse.FromCloudFormation.getArray(CfnDistributionFunctionAssociationPropertyFromCloudFormation)(properties.FunctionAssociations) : void 0), ret.addPropertyResult("lambdaFunctionAssociations", "LambdaFunctionAssociations", properties.LambdaFunctionAssociations != null ? cfn_parse.FromCloudFormation.getArray(CfnDistributionLambdaFunctionAssociationPropertyFromCloudFormation)(properties.LambdaFunctionAssociations) : void 0), ret.addPropertyResult("maxTtl", "MaxTTL", properties.MaxTTL != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxTTL) : void 0), ret.addPropertyResult("minTtl", "MinTTL", properties.MinTTL != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinTTL) : void 0), ret.addPropertyResult("originRequestPolicyId", "OriginRequestPolicyId", properties.OriginRequestPolicyId != null ? cfn_parse.FromCloudFormation.getString(properties.OriginRequestPolicyId) : void 0), ret.addPropertyResult("pathPattern", "PathPattern", cfn_parse.FromCloudFormation.getString(properties.PathPattern)), ret.addPropertyResult("realtimeLogConfigArn", "RealtimeLogConfigArn", properties.RealtimeLogConfigArn != null ? cfn_parse.FromCloudFormation.getString(properties.RealtimeLogConfigArn) : void 0), ret.addPropertyResult("responseHeadersPolicyId", "ResponseHeadersPolicyId", properties.ResponseHeadersPolicyId != null ? cfn_parse.FromCloudFormation.getString(properties.ResponseHeadersPolicyId) : void 0), ret.addPropertyResult("smoothStreaming", "SmoothStreaming", properties.SmoothStreaming != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SmoothStreaming) : void 0), ret.addPropertyResult("targetOriginId", "TargetOriginId", cfn_parse.FromCloudFormation.getString(properties.TargetOriginId)), ret.addPropertyResult("trustedKeyGroups", "TrustedKeyGroups", properties.TrustedKeyGroups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.TrustedKeyGroups) : void 0), ret.addPropertyResult("trustedSigners", "TrustedSigners", properties.TrustedSigners != null ? cfn_parse.FromCloudFormation.getStringArray(properties.TrustedSigners) : void 0), ret.addPropertyResult("viewerProtocolPolicy", "ViewerProtocolPolicy", cfn_parse.FromCloudFormation.getString(properties.ViewerProtocolPolicy)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistribution_CookiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("forward", cdk.requiredValidator)(properties.forward)), errors.collect(cdk.propertyValidator("forward", cdk.validateString)(properties.forward)), errors.collect(cdk.propertyValidator("whitelistedNames", cdk.listValidator(cdk.validateString))(properties.whitelistedNames)), errors.wrap('supplied properties not correct for "CookiesProperty"');
    }
    function cfnDistributionCookiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_CookiesPropertyValidator(properties).assertSuccess(), { Forward: cdk.stringToCloudFormation(properties.forward), WhitelistedNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.whitelistedNames) }) : properties;
    }
    function CfnDistributionCookiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("forward", "Forward", cfn_parse.FromCloudFormation.getString(properties.Forward)), ret.addPropertyResult("whitelistedNames", "WhitelistedNames", properties.WhitelistedNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.WhitelistedNames) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistribution_CustomErrorResponsePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("errorCachingMinTtl", cdk.validateNumber)(properties.errorCachingMinTtl)), errors.collect(cdk.propertyValidator("errorCode", cdk.requiredValidator)(properties.errorCode)), errors.collect(cdk.propertyValidator("errorCode", cdk.validateNumber)(properties.errorCode)), errors.collect(cdk.propertyValidator("responseCode", cdk.validateNumber)(properties.responseCode)), errors.collect(cdk.propertyValidator("responsePagePath", cdk.validateString)(properties.responsePagePath)), errors.wrap('supplied properties not correct for "CustomErrorResponseProperty"');
    }
    function cfnDistributionCustomErrorResponsePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_CustomErrorResponsePropertyValidator(properties).assertSuccess(), { ErrorCachingMinTTL: cdk.numberToCloudFormation(properties.errorCachingMinTtl), ErrorCode: cdk.numberToCloudFormation(properties.errorCode), ResponseCode: cdk.numberToCloudFormation(properties.responseCode), ResponsePagePath: cdk.stringToCloudFormation(properties.responsePagePath) }) : properties;
    }
    function CfnDistributionCustomErrorResponsePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("errorCachingMinTtl", "ErrorCachingMinTTL", properties.ErrorCachingMinTTL != null ? cfn_parse.FromCloudFormation.getNumber(properties.ErrorCachingMinTTL) : void 0), ret.addPropertyResult("errorCode", "ErrorCode", cfn_parse.FromCloudFormation.getNumber(properties.ErrorCode)), ret.addPropertyResult("responseCode", "ResponseCode", properties.ResponseCode != null ? cfn_parse.FromCloudFormation.getNumber(properties.ResponseCode) : void 0), ret.addPropertyResult("responsePagePath", "ResponsePagePath", properties.ResponsePagePath != null ? cfn_parse.FromCloudFormation.getString(properties.ResponsePagePath) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistribution_CustomOriginConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("httpPort", cdk.validateNumber)(properties.httpPort)), errors.collect(cdk.propertyValidator("httpsPort", cdk.validateNumber)(properties.httpsPort)), errors.collect(cdk.propertyValidator("originKeepaliveTimeout", cdk.validateNumber)(properties.originKeepaliveTimeout)), errors.collect(cdk.propertyValidator("originProtocolPolicy", cdk.requiredValidator)(properties.originProtocolPolicy)), errors.collect(cdk.propertyValidator("originProtocolPolicy", cdk.validateString)(properties.originProtocolPolicy)), errors.collect(cdk.propertyValidator("originReadTimeout", cdk.validateNumber)(properties.originReadTimeout)), errors.collect(cdk.propertyValidator("originSslProtocols", cdk.listValidator(cdk.validateString))(properties.originSslProtocols)), errors.wrap('supplied properties not correct for "CustomOriginConfigProperty"');
    }
    function cfnDistributionCustomOriginConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_CustomOriginConfigPropertyValidator(properties).assertSuccess(), { HTTPPort: cdk.numberToCloudFormation(properties.httpPort), HTTPSPort: cdk.numberToCloudFormation(properties.httpsPort), OriginKeepaliveTimeout: cdk.numberToCloudFormation(properties.originKeepaliveTimeout), OriginProtocolPolicy: cdk.stringToCloudFormation(properties.originProtocolPolicy), OriginReadTimeout: cdk.numberToCloudFormation(properties.originReadTimeout), OriginSSLProtocols: cdk.listMapper(cdk.stringToCloudFormation)(properties.originSslProtocols) }) : properties;
    }
    function CfnDistributionCustomOriginConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("httpPort", "HTTPPort", properties.HTTPPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.HTTPPort) : void 0), ret.addPropertyResult("httpsPort", "HTTPSPort", properties.HTTPSPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.HTTPSPort) : void 0), ret.addPropertyResult("originKeepaliveTimeout", "OriginKeepaliveTimeout", properties.OriginKeepaliveTimeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.OriginKeepaliveTimeout) : void 0), ret.addPropertyResult("originProtocolPolicy", "OriginProtocolPolicy", cfn_parse.FromCloudFormation.getString(properties.OriginProtocolPolicy)), ret.addPropertyResult("originReadTimeout", "OriginReadTimeout", properties.OriginReadTimeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.OriginReadTimeout) : void 0), ret.addPropertyResult("originSslProtocols", "OriginSSLProtocols", properties.OriginSSLProtocols != null ? cfn_parse.FromCloudFormation.getStringArray(properties.OriginSSLProtocols) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistribution_DefaultCacheBehaviorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowedMethods", cdk.listValidator(cdk.validateString))(properties.allowedMethods)), errors.collect(cdk.propertyValidator("cachePolicyId", cdk.validateString)(properties.cachePolicyId)), errors.collect(cdk.propertyValidator("cachedMethods", cdk.listValidator(cdk.validateString))(properties.cachedMethods)), errors.collect(cdk.propertyValidator("compress", cdk.validateBoolean)(properties.compress)), errors.collect(cdk.propertyValidator("defaultTtl", cdk.validateNumber)(properties.defaultTtl)), errors.collect(cdk.propertyValidator("fieldLevelEncryptionId", cdk.validateString)(properties.fieldLevelEncryptionId)), errors.collect(cdk.propertyValidator("forwardedValues", CfnDistribution_ForwardedValuesPropertyValidator)(properties.forwardedValues)), errors.collect(cdk.propertyValidator("functionAssociations", cdk.listValidator(CfnDistribution_FunctionAssociationPropertyValidator))(properties.functionAssociations)), errors.collect(cdk.propertyValidator("lambdaFunctionAssociations", cdk.listValidator(CfnDistribution_LambdaFunctionAssociationPropertyValidator))(properties.lambdaFunctionAssociations)), errors.collect(cdk.propertyValidator("maxTtl", cdk.validateNumber)(properties.maxTtl)), errors.collect(cdk.propertyValidator("minTtl", cdk.validateNumber)(properties.minTtl)), errors.collect(cdk.propertyValidator("originRequestPolicyId", cdk.validateString)(properties.originRequestPolicyId)), errors.collect(cdk.propertyValidator("realtimeLogConfigArn", cdk.validateString)(properties.realtimeLogConfigArn)), errors.collect(cdk.propertyValidator("responseHeadersPolicyId", cdk.validateString)(properties.responseHeadersPolicyId)), errors.collect(cdk.propertyValidator("smoothStreaming", cdk.validateBoolean)(properties.smoothStreaming)), errors.collect(cdk.propertyValidator("targetOriginId", cdk.requiredValidator)(properties.targetOriginId)), errors.collect(cdk.propertyValidator("targetOriginId", cdk.validateString)(properties.targetOriginId)), errors.collect(cdk.propertyValidator("trustedKeyGroups", cdk.listValidator(cdk.validateString))(properties.trustedKeyGroups)), errors.collect(cdk.propertyValidator("trustedSigners", cdk.listValidator(cdk.validateString))(properties.trustedSigners)), errors.collect(cdk.propertyValidator("viewerProtocolPolicy", cdk.requiredValidator)(properties.viewerProtocolPolicy)), errors.collect(cdk.propertyValidator("viewerProtocolPolicy", cdk.validateString)(properties.viewerProtocolPolicy)), errors.wrap('supplied properties not correct for "DefaultCacheBehaviorProperty"');
    }
    function cfnDistributionDefaultCacheBehaviorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_DefaultCacheBehaviorPropertyValidator(properties).assertSuccess(), { AllowedMethods: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowedMethods), CachePolicyId: cdk.stringToCloudFormation(properties.cachePolicyId), CachedMethods: cdk.listMapper(cdk.stringToCloudFormation)(properties.cachedMethods), Compress: cdk.booleanToCloudFormation(properties.compress), DefaultTTL: cdk.numberToCloudFormation(properties.defaultTtl), FieldLevelEncryptionId: cdk.stringToCloudFormation(properties.fieldLevelEncryptionId), ForwardedValues: cfnDistributionForwardedValuesPropertyToCloudFormation(properties.forwardedValues), FunctionAssociations: cdk.listMapper(cfnDistributionFunctionAssociationPropertyToCloudFormation)(properties.functionAssociations), LambdaFunctionAssociations: cdk.listMapper(cfnDistributionLambdaFunctionAssociationPropertyToCloudFormation)(properties.lambdaFunctionAssociations), MaxTTL: cdk.numberToCloudFormation(properties.maxTtl), MinTTL: cdk.numberToCloudFormation(properties.minTtl), OriginRequestPolicyId: cdk.stringToCloudFormation(properties.originRequestPolicyId), RealtimeLogConfigArn: cdk.stringToCloudFormation(properties.realtimeLogConfigArn), ResponseHeadersPolicyId: cdk.stringToCloudFormation(properties.responseHeadersPolicyId), SmoothStreaming: cdk.booleanToCloudFormation(properties.smoothStreaming), TargetOriginId: cdk.stringToCloudFormation(properties.targetOriginId), TrustedKeyGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.trustedKeyGroups), TrustedSigners: cdk.listMapper(cdk.stringToCloudFormation)(properties.trustedSigners), ViewerProtocolPolicy: cdk.stringToCloudFormation(properties.viewerProtocolPolicy) }) : properties;
    }
    function CfnDistributionDefaultCacheBehaviorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowedMethods", "AllowedMethods", properties.AllowedMethods != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AllowedMethods) : void 0), ret.addPropertyResult("cachePolicyId", "CachePolicyId", properties.CachePolicyId != null ? cfn_parse.FromCloudFormation.getString(properties.CachePolicyId) : void 0), ret.addPropertyResult("cachedMethods", "CachedMethods", properties.CachedMethods != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CachedMethods) : void 0), ret.addPropertyResult("compress", "Compress", properties.Compress != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Compress) : void 0), ret.addPropertyResult("defaultTtl", "DefaultTTL", properties.DefaultTTL != null ? cfn_parse.FromCloudFormation.getNumber(properties.DefaultTTL) : void 0), ret.addPropertyResult("fieldLevelEncryptionId", "FieldLevelEncryptionId", properties.FieldLevelEncryptionId != null ? cfn_parse.FromCloudFormation.getString(properties.FieldLevelEncryptionId) : void 0), ret.addPropertyResult("forwardedValues", "ForwardedValues", properties.ForwardedValues != null ? CfnDistributionForwardedValuesPropertyFromCloudFormation(properties.ForwardedValues) : void 0), ret.addPropertyResult("functionAssociations", "FunctionAssociations", properties.FunctionAssociations != null ? cfn_parse.FromCloudFormation.getArray(CfnDistributionFunctionAssociationPropertyFromCloudFormation)(properties.FunctionAssociations) : void 0), ret.addPropertyResult("lambdaFunctionAssociations", "LambdaFunctionAssociations", properties.LambdaFunctionAssociations != null ? cfn_parse.FromCloudFormation.getArray(CfnDistributionLambdaFunctionAssociationPropertyFromCloudFormation)(properties.LambdaFunctionAssociations) : void 0), ret.addPropertyResult("maxTtl", "MaxTTL", properties.MaxTTL != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxTTL) : void 0), ret.addPropertyResult("minTtl", "MinTTL", properties.MinTTL != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinTTL) : void 0), ret.addPropertyResult("originRequestPolicyId", "OriginRequestPolicyId", properties.OriginRequestPolicyId != null ? cfn_parse.FromCloudFormation.getString(properties.OriginRequestPolicyId) : void 0), ret.addPropertyResult("realtimeLogConfigArn", "RealtimeLogConfigArn", properties.RealtimeLogConfigArn != null ? cfn_parse.FromCloudFormation.getString(properties.RealtimeLogConfigArn) : void 0), ret.addPropertyResult("responseHeadersPolicyId", "ResponseHeadersPolicyId", properties.ResponseHeadersPolicyId != null ? cfn_parse.FromCloudFormation.getString(properties.ResponseHeadersPolicyId) : void 0), ret.addPropertyResult("smoothStreaming", "SmoothStreaming", properties.SmoothStreaming != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SmoothStreaming) : void 0), ret.addPropertyResult("targetOriginId", "TargetOriginId", cfn_parse.FromCloudFormation.getString(properties.TargetOriginId)), ret.addPropertyResult("trustedKeyGroups", "TrustedKeyGroups", properties.TrustedKeyGroups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.TrustedKeyGroups) : void 0), ret.addPropertyResult("trustedSigners", "TrustedSigners", properties.TrustedSigners != null ? cfn_parse.FromCloudFormation.getStringArray(properties.TrustedSigners) : void 0), ret.addPropertyResult("viewerProtocolPolicy", "ViewerProtocolPolicy", cfn_parse.FromCloudFormation.getString(properties.ViewerProtocolPolicy)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistribution_DistributionConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aliases", cdk.listValidator(cdk.validateString))(properties.aliases)), errors.collect(cdk.propertyValidator("cnamEs", cdk.listValidator(cdk.validateString))(properties.cnamEs)), errors.collect(cdk.propertyValidator("cacheBehaviors", cdk.listValidator(CfnDistribution_CacheBehaviorPropertyValidator))(properties.cacheBehaviors)), errors.collect(cdk.propertyValidator("comment", cdk.validateString)(properties.comment)), errors.collect(cdk.propertyValidator("continuousDeploymentPolicyId", cdk.validateString)(properties.continuousDeploymentPolicyId)), errors.collect(cdk.propertyValidator("customErrorResponses", cdk.listValidator(CfnDistribution_CustomErrorResponsePropertyValidator))(properties.customErrorResponses)), errors.collect(cdk.propertyValidator("customOrigin", CfnDistribution_LegacyCustomOriginPropertyValidator)(properties.customOrigin)), errors.collect(cdk.propertyValidator("defaultCacheBehavior", cdk.requiredValidator)(properties.defaultCacheBehavior)), errors.collect(cdk.propertyValidator("defaultCacheBehavior", CfnDistribution_DefaultCacheBehaviorPropertyValidator)(properties.defaultCacheBehavior)), errors.collect(cdk.propertyValidator("defaultRootObject", cdk.validateString)(properties.defaultRootObject)), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("httpVersion", cdk.validateString)(properties.httpVersion)), errors.collect(cdk.propertyValidator("ipv6Enabled", cdk.validateBoolean)(properties.ipv6Enabled)), errors.collect(cdk.propertyValidator("logging", CfnDistribution_LoggingPropertyValidator)(properties.logging)), errors.collect(cdk.propertyValidator("originGroups", CfnDistribution_OriginGroupsPropertyValidator)(properties.originGroups)), errors.collect(cdk.propertyValidator("origins", cdk.listValidator(CfnDistribution_OriginPropertyValidator))(properties.origins)), errors.collect(cdk.propertyValidator("priceClass", cdk.validateString)(properties.priceClass)), errors.collect(cdk.propertyValidator("restrictions", CfnDistribution_RestrictionsPropertyValidator)(properties.restrictions)), errors.collect(cdk.propertyValidator("s3Origin", CfnDistribution_LegacyS3OriginPropertyValidator)(properties.s3Origin)), errors.collect(cdk.propertyValidator("staging", cdk.validateBoolean)(properties.staging)), errors.collect(cdk.propertyValidator("viewerCertificate", CfnDistribution_ViewerCertificatePropertyValidator)(properties.viewerCertificate)), errors.collect(cdk.propertyValidator("webAclId", cdk.validateString)(properties.webAclId)), errors.wrap('supplied properties not correct for "DistributionConfigProperty"');
    }
    function cfnDistributionDistributionConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_DistributionConfigPropertyValidator(properties).assertSuccess(), { Aliases: cdk.listMapper(cdk.stringToCloudFormation)(properties.aliases), CNAMEs: cdk.listMapper(cdk.stringToCloudFormation)(properties.cnamEs), CacheBehaviors: cdk.listMapper(cfnDistributionCacheBehaviorPropertyToCloudFormation)(properties.cacheBehaviors), Comment: cdk.stringToCloudFormation(properties.comment), ContinuousDeploymentPolicyId: cdk.stringToCloudFormation(properties.continuousDeploymentPolicyId), CustomErrorResponses: cdk.listMapper(cfnDistributionCustomErrorResponsePropertyToCloudFormation)(properties.customErrorResponses), CustomOrigin: cfnDistributionLegacyCustomOriginPropertyToCloudFormation(properties.customOrigin), DefaultCacheBehavior: cfnDistributionDefaultCacheBehaviorPropertyToCloudFormation(properties.defaultCacheBehavior), DefaultRootObject: cdk.stringToCloudFormation(properties.defaultRootObject), Enabled: cdk.booleanToCloudFormation(properties.enabled), HttpVersion: cdk.stringToCloudFormation(properties.httpVersion), IPV6Enabled: cdk.booleanToCloudFormation(properties.ipv6Enabled), Logging: cfnDistributionLoggingPropertyToCloudFormation(properties.logging), OriginGroups: cfnDistributionOriginGroupsPropertyToCloudFormation(properties.originGroups), Origins: cdk.listMapper(cfnDistributionOriginPropertyToCloudFormation)(properties.origins), PriceClass: cdk.stringToCloudFormation(properties.priceClass), Restrictions: cfnDistributionRestrictionsPropertyToCloudFormation(properties.restrictions), S3Origin: cfnDistributionLegacyS3OriginPropertyToCloudFormation(properties.s3Origin), Staging: cdk.booleanToCloudFormation(properties.staging), ViewerCertificate: cfnDistributionViewerCertificatePropertyToCloudFormation(properties.viewerCertificate), WebACLId: cdk.stringToCloudFormation(properties.webAclId) }) : properties;
    }
    function CfnDistributionDistributionConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aliases", "Aliases", properties.Aliases != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Aliases) : void 0), ret.addPropertyResult("cnamEs", "CNAMEs", properties.CNAMEs != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CNAMEs) : void 0), ret.addPropertyResult("cacheBehaviors", "CacheBehaviors", properties.CacheBehaviors != null ? cfn_parse.FromCloudFormation.getArray(CfnDistributionCacheBehaviorPropertyFromCloudFormation)(properties.CacheBehaviors) : void 0), ret.addPropertyResult("comment", "Comment", properties.Comment != null ? cfn_parse.FromCloudFormation.getString(properties.Comment) : void 0), ret.addPropertyResult("continuousDeploymentPolicyId", "ContinuousDeploymentPolicyId", properties.ContinuousDeploymentPolicyId != null ? cfn_parse.FromCloudFormation.getString(properties.ContinuousDeploymentPolicyId) : void 0), ret.addPropertyResult("customErrorResponses", "CustomErrorResponses", properties.CustomErrorResponses != null ? cfn_parse.FromCloudFormation.getArray(CfnDistributionCustomErrorResponsePropertyFromCloudFormation)(properties.CustomErrorResponses) : void 0), ret.addPropertyResult("customOrigin", "CustomOrigin", properties.CustomOrigin != null ? CfnDistributionLegacyCustomOriginPropertyFromCloudFormation(properties.CustomOrigin) : void 0), ret.addPropertyResult("defaultCacheBehavior", "DefaultCacheBehavior", CfnDistributionDefaultCacheBehaviorPropertyFromCloudFormation(properties.DefaultCacheBehavior)), ret.addPropertyResult("defaultRootObject", "DefaultRootObject", properties.DefaultRootObject != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultRootObject) : void 0), ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addPropertyResult("httpVersion", "HttpVersion", properties.HttpVersion != null ? cfn_parse.FromCloudFormation.getString(properties.HttpVersion) : void 0), ret.addPropertyResult("ipv6Enabled", "IPV6Enabled", properties.IPV6Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IPV6Enabled) : void 0), ret.addPropertyResult("logging", "Logging", properties.Logging != null ? CfnDistributionLoggingPropertyFromCloudFormation(properties.Logging) : void 0), ret.addPropertyResult("originGroups", "OriginGroups", properties.OriginGroups != null ? CfnDistributionOriginGroupsPropertyFromCloudFormation(properties.OriginGroups) : void 0), ret.addPropertyResult("origins", "Origins", properties.Origins != null ? cfn_parse.FromCloudFormation.getArray(CfnDistributionOriginPropertyFromCloudFormation)(properties.Origins) : void 0), ret.addPropertyResult("priceClass", "PriceClass", properties.PriceClass != null ? cfn_parse.FromCloudFormation.getString(properties.PriceClass) : void 0), ret.addPropertyResult("restrictions", "Restrictions", properties.Restrictions != null ? CfnDistributionRestrictionsPropertyFromCloudFormation(properties.Restrictions) : void 0), ret.addPropertyResult("s3Origin", "S3Origin", properties.S3Origin != null ? CfnDistributionLegacyS3OriginPropertyFromCloudFormation(properties.S3Origin) : void 0), ret.addPropertyResult("staging", "Staging", properties.Staging != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Staging) : void 0), ret.addPropertyResult("viewerCertificate", "ViewerCertificate", properties.ViewerCertificate != null ? CfnDistributionViewerCertificatePropertyFromCloudFormation(properties.ViewerCertificate) : void 0), ret.addPropertyResult("webAclId", "WebACLId", properties.WebACLId != null ? cfn_parse.FromCloudFormation.getString(properties.WebACLId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistribution_ForwardedValuesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cookies", CfnDistribution_CookiesPropertyValidator)(properties.cookies)), errors.collect(cdk.propertyValidator("headers", cdk.listValidator(cdk.validateString))(properties.headers)), errors.collect(cdk.propertyValidator("queryString", cdk.requiredValidator)(properties.queryString)), errors.collect(cdk.propertyValidator("queryString", cdk.validateBoolean)(properties.queryString)), errors.collect(cdk.propertyValidator("queryStringCacheKeys", cdk.listValidator(cdk.validateString))(properties.queryStringCacheKeys)), errors.wrap('supplied properties not correct for "ForwardedValuesProperty"');
    }
    function cfnDistributionForwardedValuesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_ForwardedValuesPropertyValidator(properties).assertSuccess(), { Cookies: cfnDistributionCookiesPropertyToCloudFormation(properties.cookies), Headers: cdk.listMapper(cdk.stringToCloudFormation)(properties.headers), QueryString: cdk.booleanToCloudFormation(properties.queryString), QueryStringCacheKeys: cdk.listMapper(cdk.stringToCloudFormation)(properties.queryStringCacheKeys) }) : properties;
    }
    function CfnDistributionForwardedValuesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cookies", "Cookies", properties.Cookies != null ? CfnDistributionCookiesPropertyFromCloudFormation(properties.Cookies) : void 0), ret.addPropertyResult("headers", "Headers", properties.Headers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Headers) : void 0), ret.addPropertyResult("queryString", "QueryString", cfn_parse.FromCloudFormation.getBoolean(properties.QueryString)), ret.addPropertyResult("queryStringCacheKeys", "QueryStringCacheKeys", properties.QueryStringCacheKeys != null ? cfn_parse.FromCloudFormation.getStringArray(properties.QueryStringCacheKeys) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistribution_FunctionAssociationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("eventType", cdk.validateString)(properties.eventType)), errors.collect(cdk.propertyValidator("functionArn", cdk.validateString)(properties.functionArn)), errors.wrap('supplied properties not correct for "FunctionAssociationProperty"');
    }
    function cfnDistributionFunctionAssociationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_FunctionAssociationPropertyValidator(properties).assertSuccess(), { EventType: cdk.stringToCloudFormation(properties.eventType), FunctionARN: cdk.stringToCloudFormation(properties.functionArn) }) : properties;
    }
    function CfnDistributionFunctionAssociationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("eventType", "EventType", properties.EventType != null ? cfn_parse.FromCloudFormation.getString(properties.EventType) : void 0), ret.addPropertyResult("functionArn", "FunctionARN", properties.FunctionARN != null ? cfn_parse.FromCloudFormation.getString(properties.FunctionARN) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistribution_GeoRestrictionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("locations", cdk.listValidator(cdk.validateString))(properties.locations)), errors.collect(cdk.propertyValidator("restrictionType", cdk.requiredValidator)(properties.restrictionType)), errors.collect(cdk.propertyValidator("restrictionType", cdk.validateString)(properties.restrictionType)), errors.wrap('supplied properties not correct for "GeoRestrictionProperty"');
    }
    function cfnDistributionGeoRestrictionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_GeoRestrictionPropertyValidator(properties).assertSuccess(), { Locations: cdk.listMapper(cdk.stringToCloudFormation)(properties.locations), RestrictionType: cdk.stringToCloudFormation(properties.restrictionType) }) : properties;
    }
    function CfnDistributionGeoRestrictionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("locations", "Locations", properties.Locations != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Locations) : void 0), ret.addPropertyResult("restrictionType", "RestrictionType", cfn_parse.FromCloudFormation.getString(properties.RestrictionType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistribution_LambdaFunctionAssociationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("eventType", cdk.validateString)(properties.eventType)), errors.collect(cdk.propertyValidator("includeBody", cdk.validateBoolean)(properties.includeBody)), errors.collect(cdk.propertyValidator("lambdaFunctionArn", cdk.validateString)(properties.lambdaFunctionArn)), errors.wrap('supplied properties not correct for "LambdaFunctionAssociationProperty"');
    }
    function cfnDistributionLambdaFunctionAssociationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_LambdaFunctionAssociationPropertyValidator(properties).assertSuccess(), { EventType: cdk.stringToCloudFormation(properties.eventType), IncludeBody: cdk.booleanToCloudFormation(properties.includeBody), LambdaFunctionARN: cdk.stringToCloudFormation(properties.lambdaFunctionArn) }) : properties;
    }
    function CfnDistributionLambdaFunctionAssociationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("eventType", "EventType", properties.EventType != null ? cfn_parse.FromCloudFormation.getString(properties.EventType) : void 0), ret.addPropertyResult("includeBody", "IncludeBody", properties.IncludeBody != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeBody) : void 0), ret.addPropertyResult("lambdaFunctionArn", "LambdaFunctionARN", properties.LambdaFunctionARN != null ? cfn_parse.FromCloudFormation.getString(properties.LambdaFunctionARN) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistribution_LegacyCustomOriginPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dnsName", cdk.requiredValidator)(properties.dnsName)), errors.collect(cdk.propertyValidator("dnsName", cdk.validateString)(properties.dnsName)), errors.collect(cdk.propertyValidator("httpPort", cdk.validateNumber)(properties.httpPort)), errors.collect(cdk.propertyValidator("httpsPort", cdk.validateNumber)(properties.httpsPort)), errors.collect(cdk.propertyValidator("originProtocolPolicy", cdk.requiredValidator)(properties.originProtocolPolicy)), errors.collect(cdk.propertyValidator("originProtocolPolicy", cdk.validateString)(properties.originProtocolPolicy)), errors.collect(cdk.propertyValidator("originSslProtocols", cdk.requiredValidator)(properties.originSslProtocols)), errors.collect(cdk.propertyValidator("originSslProtocols", cdk.listValidator(cdk.validateString))(properties.originSslProtocols)), errors.wrap('supplied properties not correct for "LegacyCustomOriginProperty"');
    }
    function cfnDistributionLegacyCustomOriginPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_LegacyCustomOriginPropertyValidator(properties).assertSuccess(), { DNSName: cdk.stringToCloudFormation(properties.dnsName), HTTPPort: cdk.numberToCloudFormation(properties.httpPort), HTTPSPort: cdk.numberToCloudFormation(properties.httpsPort), OriginProtocolPolicy: cdk.stringToCloudFormation(properties.originProtocolPolicy), OriginSSLProtocols: cdk.listMapper(cdk.stringToCloudFormation)(properties.originSslProtocols) }) : properties;
    }
    function CfnDistributionLegacyCustomOriginPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dnsName", "DNSName", cfn_parse.FromCloudFormation.getString(properties.DNSName)), ret.addPropertyResult("httpPort", "HTTPPort", properties.HTTPPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.HTTPPort) : void 0), ret.addPropertyResult("httpsPort", "HTTPSPort", properties.HTTPSPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.HTTPSPort) : void 0), ret.addPropertyResult("originProtocolPolicy", "OriginProtocolPolicy", cfn_parse.FromCloudFormation.getString(properties.OriginProtocolPolicy)), ret.addPropertyResult("originSslProtocols", "OriginSSLProtocols", cfn_parse.FromCloudFormation.getStringArray(properties.OriginSSLProtocols)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistribution_LegacyS3OriginPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dnsName", cdk.requiredValidator)(properties.dnsName)), errors.collect(cdk.propertyValidator("dnsName", cdk.validateString)(properties.dnsName)), errors.collect(cdk.propertyValidator("originAccessIdentity", cdk.validateString)(properties.originAccessIdentity)), errors.wrap('supplied properties not correct for "LegacyS3OriginProperty"');
    }
    function cfnDistributionLegacyS3OriginPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_LegacyS3OriginPropertyValidator(properties).assertSuccess(), { DNSName: cdk.stringToCloudFormation(properties.dnsName), OriginAccessIdentity: cdk.stringToCloudFormation(properties.originAccessIdentity) }) : properties;
    }
    function CfnDistributionLegacyS3OriginPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dnsName", "DNSName", cfn_parse.FromCloudFormation.getString(properties.DNSName)), ret.addPropertyResult("originAccessIdentity", "OriginAccessIdentity", properties.OriginAccessIdentity != null ? cfn_parse.FromCloudFormation.getString(properties.OriginAccessIdentity) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistribution_LoggingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.requiredValidator)(properties.bucket)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("includeCookies", cdk.validateBoolean)(properties.includeCookies)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.wrap('supplied properties not correct for "LoggingProperty"');
    }
    function cfnDistributionLoggingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_LoggingPropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), IncludeCookies: cdk.booleanToCloudFormation(properties.includeCookies), Prefix: cdk.stringToCloudFormation(properties.prefix) }) : properties;
    }
    function CfnDistributionLoggingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", cfn_parse.FromCloudFormation.getString(properties.Bucket)), ret.addPropertyResult("includeCookies", "IncludeCookies", properties.IncludeCookies != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeCookies) : void 0), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistribution_OriginPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectionAttempts", cdk.validateNumber)(properties.connectionAttempts)), errors.collect(cdk.propertyValidator("connectionTimeout", cdk.validateNumber)(properties.connectionTimeout)), errors.collect(cdk.propertyValidator("customOriginConfig", CfnDistribution_CustomOriginConfigPropertyValidator)(properties.customOriginConfig)), errors.collect(cdk.propertyValidator("domainName", cdk.requiredValidator)(properties.domainName)), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("originAccessControlId", cdk.validateString)(properties.originAccessControlId)), errors.collect(cdk.propertyValidator("originCustomHeaders", cdk.listValidator(CfnDistribution_OriginCustomHeaderPropertyValidator))(properties.originCustomHeaders)), errors.collect(cdk.propertyValidator("originPath", cdk.validateString)(properties.originPath)), errors.collect(cdk.propertyValidator("originShield", CfnDistribution_OriginShieldPropertyValidator)(properties.originShield)), errors.collect(cdk.propertyValidator("s3OriginConfig", CfnDistribution_S3OriginConfigPropertyValidator)(properties.s3OriginConfig)), errors.wrap('supplied properties not correct for "OriginProperty"');
    }
    function cfnDistributionOriginPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_OriginPropertyValidator(properties).assertSuccess(), { ConnectionAttempts: cdk.numberToCloudFormation(properties.connectionAttempts), ConnectionTimeout: cdk.numberToCloudFormation(properties.connectionTimeout), CustomOriginConfig: cfnDistributionCustomOriginConfigPropertyToCloudFormation(properties.customOriginConfig), DomainName: cdk.stringToCloudFormation(properties.domainName), Id: cdk.stringToCloudFormation(properties.id), OriginAccessControlId: cdk.stringToCloudFormation(properties.originAccessControlId), OriginCustomHeaders: cdk.listMapper(cfnDistributionOriginCustomHeaderPropertyToCloudFormation)(properties.originCustomHeaders), OriginPath: cdk.stringToCloudFormation(properties.originPath), OriginShield: cfnDistributionOriginShieldPropertyToCloudFormation(properties.originShield), S3OriginConfig: cfnDistributionS3OriginConfigPropertyToCloudFormation(properties.s3OriginConfig) }) : properties;
    }
    function CfnDistributionOriginPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectionAttempts", "ConnectionAttempts", properties.ConnectionAttempts != null ? cfn_parse.FromCloudFormation.getNumber(properties.ConnectionAttempts) : void 0), ret.addPropertyResult("connectionTimeout", "ConnectionTimeout", properties.ConnectionTimeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.ConnectionTimeout) : void 0), ret.addPropertyResult("customOriginConfig", "CustomOriginConfig", properties.CustomOriginConfig != null ? CfnDistributionCustomOriginConfigPropertyFromCloudFormation(properties.CustomOriginConfig) : void 0), ret.addPropertyResult("domainName", "DomainName", cfn_parse.FromCloudFormation.getString(properties.DomainName)), ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("originAccessControlId", "OriginAccessControlId", properties.OriginAccessControlId != null ? cfn_parse.FromCloudFormation.getString(properties.OriginAccessControlId) : void 0), ret.addPropertyResult("originCustomHeaders", "OriginCustomHeaders", properties.OriginCustomHeaders != null ? cfn_parse.FromCloudFormation.getArray(CfnDistributionOriginCustomHeaderPropertyFromCloudFormation)(properties.OriginCustomHeaders) : void 0), ret.addPropertyResult("originPath", "OriginPath", properties.OriginPath != null ? cfn_parse.FromCloudFormation.getString(properties.OriginPath) : void 0), ret.addPropertyResult("originShield", "OriginShield", properties.OriginShield != null ? CfnDistributionOriginShieldPropertyFromCloudFormation(properties.OriginShield) : void 0), ret.addPropertyResult("s3OriginConfig", "S3OriginConfig", properties.S3OriginConfig != null ? CfnDistributionS3OriginConfigPropertyFromCloudFormation(properties.S3OriginConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistribution_OriginCustomHeaderPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("headerName", cdk.requiredValidator)(properties.headerName)), errors.collect(cdk.propertyValidator("headerName", cdk.validateString)(properties.headerName)), errors.collect(cdk.propertyValidator("headerValue", cdk.requiredValidator)(properties.headerValue)), errors.collect(cdk.propertyValidator("headerValue", cdk.validateString)(properties.headerValue)), errors.wrap('supplied properties not correct for "OriginCustomHeaderProperty"');
    }
    function cfnDistributionOriginCustomHeaderPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_OriginCustomHeaderPropertyValidator(properties).assertSuccess(), { HeaderName: cdk.stringToCloudFormation(properties.headerName), HeaderValue: cdk.stringToCloudFormation(properties.headerValue) }) : properties;
    }
    function CfnDistributionOriginCustomHeaderPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("headerName", "HeaderName", cfn_parse.FromCloudFormation.getString(properties.HeaderName)), ret.addPropertyResult("headerValue", "HeaderValue", cfn_parse.FromCloudFormation.getString(properties.HeaderValue)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistribution_OriginGroupPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("failoverCriteria", cdk.requiredValidator)(properties.failoverCriteria)), errors.collect(cdk.propertyValidator("failoverCriteria", CfnDistribution_OriginGroupFailoverCriteriaPropertyValidator)(properties.failoverCriteria)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("members", cdk.requiredValidator)(properties.members)), errors.collect(cdk.propertyValidator("members", CfnDistribution_OriginGroupMembersPropertyValidator)(properties.members)), errors.wrap('supplied properties not correct for "OriginGroupProperty"');
    }
    function cfnDistributionOriginGroupPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_OriginGroupPropertyValidator(properties).assertSuccess(), { FailoverCriteria: cfnDistributionOriginGroupFailoverCriteriaPropertyToCloudFormation(properties.failoverCriteria), Id: cdk.stringToCloudFormation(properties.id), Members: cfnDistributionOriginGroupMembersPropertyToCloudFormation(properties.members) }) : properties;
    }
    function CfnDistributionOriginGroupPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("failoverCriteria", "FailoverCriteria", CfnDistributionOriginGroupFailoverCriteriaPropertyFromCloudFormation(properties.FailoverCriteria)), ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("members", "Members", CfnDistributionOriginGroupMembersPropertyFromCloudFormation(properties.Members)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistribution_OriginGroupFailoverCriteriaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("statusCodes", cdk.requiredValidator)(properties.statusCodes)), errors.collect(cdk.propertyValidator("statusCodes", CfnDistribution_StatusCodesPropertyValidator)(properties.statusCodes)), errors.wrap('supplied properties not correct for "OriginGroupFailoverCriteriaProperty"');
    }
    function cfnDistributionOriginGroupFailoverCriteriaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_OriginGroupFailoverCriteriaPropertyValidator(properties).assertSuccess(), { StatusCodes: cfnDistributionStatusCodesPropertyToCloudFormation(properties.statusCodes) }) : properties;
    }
    function CfnDistributionOriginGroupFailoverCriteriaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("statusCodes", "StatusCodes", CfnDistributionStatusCodesPropertyFromCloudFormation(properties.StatusCodes)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistribution_OriginGroupMemberPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("originId", cdk.requiredValidator)(properties.originId)), errors.collect(cdk.propertyValidator("originId", cdk.validateString)(properties.originId)), errors.wrap('supplied properties not correct for "OriginGroupMemberProperty"');
    }
    function cfnDistributionOriginGroupMemberPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_OriginGroupMemberPropertyValidator(properties).assertSuccess(), { OriginId: cdk.stringToCloudFormation(properties.originId) }) : properties;
    }
    function CfnDistributionOriginGroupMemberPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("originId", "OriginId", cfn_parse.FromCloudFormation.getString(properties.OriginId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistribution_OriginGroupMembersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("items", cdk.requiredValidator)(properties.items)), errors.collect(cdk.propertyValidator("items", cdk.listValidator(CfnDistribution_OriginGroupMemberPropertyValidator))(properties.items)), errors.collect(cdk.propertyValidator("quantity", cdk.requiredValidator)(properties.quantity)), errors.collect(cdk.propertyValidator("quantity", cdk.validateNumber)(properties.quantity)), errors.wrap('supplied properties not correct for "OriginGroupMembersProperty"');
    }
    function cfnDistributionOriginGroupMembersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_OriginGroupMembersPropertyValidator(properties).assertSuccess(), { Items: cdk.listMapper(cfnDistributionOriginGroupMemberPropertyToCloudFormation)(properties.items), Quantity: cdk.numberToCloudFormation(properties.quantity) }) : properties;
    }
    function CfnDistributionOriginGroupMembersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("items", "Items", cfn_parse.FromCloudFormation.getArray(CfnDistributionOriginGroupMemberPropertyFromCloudFormation)(properties.Items)), ret.addPropertyResult("quantity", "Quantity", cfn_parse.FromCloudFormation.getNumber(properties.Quantity)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistribution_OriginGroupsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("items", cdk.listValidator(CfnDistribution_OriginGroupPropertyValidator))(properties.items)), errors.collect(cdk.propertyValidator("quantity", cdk.requiredValidator)(properties.quantity)), errors.collect(cdk.propertyValidator("quantity", cdk.validateNumber)(properties.quantity)), errors.wrap('supplied properties not correct for "OriginGroupsProperty"');
    }
    function cfnDistributionOriginGroupsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_OriginGroupsPropertyValidator(properties).assertSuccess(), { Items: cdk.listMapper(cfnDistributionOriginGroupPropertyToCloudFormation)(properties.items), Quantity: cdk.numberToCloudFormation(properties.quantity) }) : properties;
    }
    function CfnDistributionOriginGroupsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("items", "Items", properties.Items != null ? cfn_parse.FromCloudFormation.getArray(CfnDistributionOriginGroupPropertyFromCloudFormation)(properties.Items) : void 0), ret.addPropertyResult("quantity", "Quantity", cfn_parse.FromCloudFormation.getNumber(properties.Quantity)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistribution_OriginShieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("originShieldRegion", cdk.validateString)(properties.originShieldRegion)), errors.wrap('supplied properties not correct for "OriginShieldProperty"');
    }
    function cfnDistributionOriginShieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_OriginShieldPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled), OriginShieldRegion: cdk.stringToCloudFormation(properties.originShieldRegion) }) : properties;
    }
    function CfnDistributionOriginShieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("originShieldRegion", "OriginShieldRegion", properties.OriginShieldRegion != null ? cfn_parse.FromCloudFormation.getString(properties.OriginShieldRegion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistribution_RestrictionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("geoRestriction", cdk.requiredValidator)(properties.geoRestriction)), errors.collect(cdk.propertyValidator("geoRestriction", CfnDistribution_GeoRestrictionPropertyValidator)(properties.geoRestriction)), errors.wrap('supplied properties not correct for "RestrictionsProperty"');
    }
    function cfnDistributionRestrictionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_RestrictionsPropertyValidator(properties).assertSuccess(), { GeoRestriction: cfnDistributionGeoRestrictionPropertyToCloudFormation(properties.geoRestriction) }) : properties;
    }
    function CfnDistributionRestrictionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("geoRestriction", "GeoRestriction", CfnDistributionGeoRestrictionPropertyFromCloudFormation(properties.GeoRestriction)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistribution_S3OriginConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("originAccessIdentity", cdk.validateString)(properties.originAccessIdentity)), errors.wrap('supplied properties not correct for "S3OriginConfigProperty"');
    }
    function cfnDistributionS3OriginConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_S3OriginConfigPropertyValidator(properties).assertSuccess(), { OriginAccessIdentity: cdk.stringToCloudFormation(properties.originAccessIdentity) }) : properties;
    }
    function CfnDistributionS3OriginConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("originAccessIdentity", "OriginAccessIdentity", properties.OriginAccessIdentity != null ? cfn_parse.FromCloudFormation.getString(properties.OriginAccessIdentity) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistribution_StatusCodesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("items", cdk.requiredValidator)(properties.items)), errors.collect(cdk.propertyValidator("items", cdk.listValidator(cdk.validateNumber))(properties.items)), errors.collect(cdk.propertyValidator("quantity", cdk.requiredValidator)(properties.quantity)), errors.collect(cdk.propertyValidator("quantity", cdk.validateNumber)(properties.quantity)), errors.wrap('supplied properties not correct for "StatusCodesProperty"');
    }
    function cfnDistributionStatusCodesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_StatusCodesPropertyValidator(properties).assertSuccess(), { Items: cdk.listMapper(cdk.numberToCloudFormation)(properties.items), Quantity: cdk.numberToCloudFormation(properties.quantity) }) : properties;
    }
    function CfnDistributionStatusCodesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("items", "Items", cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getNumber)(properties.Items)), ret.addPropertyResult("quantity", "Quantity", cfn_parse.FromCloudFormation.getNumber(properties.Quantity)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistribution_ViewerCertificatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acmCertificateArn", cdk.validateString)(properties.acmCertificateArn)), errors.collect(cdk.propertyValidator("cloudFrontDefaultCertificate", cdk.validateBoolean)(properties.cloudFrontDefaultCertificate)), errors.collect(cdk.propertyValidator("iamCertificateId", cdk.validateString)(properties.iamCertificateId)), errors.collect(cdk.propertyValidator("minimumProtocolVersion", cdk.validateString)(properties.minimumProtocolVersion)), errors.collect(cdk.propertyValidator("sslSupportMethod", cdk.validateString)(properties.sslSupportMethod)), errors.wrap('supplied properties not correct for "ViewerCertificateProperty"');
    }
    function cfnDistributionViewerCertificatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_ViewerCertificatePropertyValidator(properties).assertSuccess(), { AcmCertificateArn: cdk.stringToCloudFormation(properties.acmCertificateArn), CloudFrontDefaultCertificate: cdk.booleanToCloudFormation(properties.cloudFrontDefaultCertificate), IamCertificateId: cdk.stringToCloudFormation(properties.iamCertificateId), MinimumProtocolVersion: cdk.stringToCloudFormation(properties.minimumProtocolVersion), SslSupportMethod: cdk.stringToCloudFormation(properties.sslSupportMethod) }) : properties;
    }
    function CfnDistributionViewerCertificatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("acmCertificateArn", "AcmCertificateArn", properties.AcmCertificateArn != null ? cfn_parse.FromCloudFormation.getString(properties.AcmCertificateArn) : void 0), ret.addPropertyResult("cloudFrontDefaultCertificate", "CloudFrontDefaultCertificate", properties.CloudFrontDefaultCertificate != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CloudFrontDefaultCertificate) : void 0), ret.addPropertyResult("iamCertificateId", "IamCertificateId", properties.IamCertificateId != null ? cfn_parse.FromCloudFormation.getString(properties.IamCertificateId) : void 0), ret.addPropertyResult("minimumProtocolVersion", "MinimumProtocolVersion", properties.MinimumProtocolVersion != null ? cfn_parse.FromCloudFormation.getString(properties.MinimumProtocolVersion) : void 0), ret.addPropertyResult("sslSupportMethod", "SslSupportMethod", properties.SslSupportMethod != null ? cfn_parse.FromCloudFormation.getString(properties.SslSupportMethod) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunctionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoPublish", cdk.validateBoolean)(properties.autoPublish)), errors.collect(cdk.propertyValidator("functionCode", cdk.requiredValidator)(properties.functionCode)), errors.collect(cdk.propertyValidator("functionCode", cdk.validateString)(properties.functionCode)), errors.collect(cdk.propertyValidator("functionConfig", cdk.requiredValidator)(properties.functionConfig)), errors.collect(cdk.propertyValidator("functionConfig", CfnFunction_FunctionConfigPropertyValidator)(properties.functionConfig)), errors.collect(cdk.propertyValidator("functionMetadata", CfnFunction_FunctionMetadataPropertyValidator)(properties.functionMetadata)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "CfnFunctionProps"');
    }
    function cfnFunctionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunctionPropsValidator(properties).assertSuccess(), { FunctionCode: cdk.stringToCloudFormation(properties.functionCode), FunctionConfig: cfnFunctionFunctionConfigPropertyToCloudFormation(properties.functionConfig), Name: cdk.stringToCloudFormation(properties.name), AutoPublish: cdk.booleanToCloudFormation(properties.autoPublish), FunctionMetadata: cfnFunctionFunctionMetadataPropertyToCloudFormation(properties.functionMetadata) }) : properties;
    }
    function CfnFunctionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("functionCode", "FunctionCode", cfn_parse.FromCloudFormation.getString(properties.FunctionCode)), ret.addPropertyResult("functionConfig", "FunctionConfig", CfnFunctionFunctionConfigPropertyFromCloudFormation(properties.FunctionConfig)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("autoPublish", "AutoPublish", properties.AutoPublish != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AutoPublish) : void 0), ret.addPropertyResult("functionMetadata", "FunctionMetadata", properties.FunctionMetadata != null ? CfnFunctionFunctionMetadataPropertyFromCloudFormation(properties.FunctionMetadata) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFunction = class _CfnFunction extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFunctionPropsFromCloudFormation(resourceProperties), ret = new _CfnFunction(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFunction.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_CfnFunctionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFunction), error;
        }
        cdk.requireProperty(props, "functionCode", this), cdk.requireProperty(props, "functionConfig", this), cdk.requireProperty(props, "name", this), this.attrFunctionArn = cdk.Token.asString(this.getAtt("FunctionARN", cdk.ResolutionTypeHint.STRING)), this.attrFunctionMetadataFunctionArn = cdk.Token.asString(this.getAtt("FunctionMetadata.FunctionARN", cdk.ResolutionTypeHint.STRING)), this.attrStage = cdk.Token.asString(this.getAtt("Stage", cdk.ResolutionTypeHint.STRING)), this.functionCode = props.functionCode, this.functionConfig = props.functionConfig, this.name = props.name, this.autoPublish = props.autoPublish, this.functionMetadata = props.functionMetadata;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFunction.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { functionCode: this.functionCode, functionConfig: this.functionConfig, name: this.name, autoPublish: this.autoPublish, functionMetadata: this.functionMetadata };
      }
      renderProperties(props) {
        return cfnFunctionPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnFunction[_e] = { fqn: "aws-cdk-lib.aws_cloudfront.CfnFunction", version: "2.80.0" }, CfnFunction.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFront::Function", exports2.CfnFunction = CfnFunction;
    function CfnFunction_FunctionConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("comment", cdk.requiredValidator)(properties.comment)), errors.collect(cdk.propertyValidator("comment", cdk.validateString)(properties.comment)), errors.collect(cdk.propertyValidator("runtime", cdk.requiredValidator)(properties.runtime)), errors.collect(cdk.propertyValidator("runtime", cdk.validateString)(properties.runtime)), errors.wrap('supplied properties not correct for "FunctionConfigProperty"');
    }
    function cfnFunctionFunctionConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_FunctionConfigPropertyValidator(properties).assertSuccess(), { Comment: cdk.stringToCloudFormation(properties.comment), Runtime: cdk.stringToCloudFormation(properties.runtime) }) : properties;
    }
    function CfnFunctionFunctionConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("comment", "Comment", cfn_parse.FromCloudFormation.getString(properties.Comment)), ret.addPropertyResult("runtime", "Runtime", cfn_parse.FromCloudFormation.getString(properties.Runtime)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunction_FunctionMetadataPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("functionArn", cdk.validateString)(properties.functionArn)), errors.wrap('supplied properties not correct for "FunctionMetadataProperty"');
    }
    function cfnFunctionFunctionMetadataPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunction_FunctionMetadataPropertyValidator(properties).assertSuccess(), { FunctionARN: cdk.stringToCloudFormation(properties.functionArn) }) : properties;
    }
    function CfnFunctionFunctionMetadataPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("functionArn", "FunctionARN", properties.FunctionARN != null ? cfn_parse.FromCloudFormation.getString(properties.FunctionARN) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnKeyGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("keyGroupConfig", cdk.requiredValidator)(properties.keyGroupConfig)), errors.collect(cdk.propertyValidator("keyGroupConfig", CfnKeyGroup_KeyGroupConfigPropertyValidator)(properties.keyGroupConfig)), errors.wrap('supplied properties not correct for "CfnKeyGroupProps"');
    }
    function cfnKeyGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnKeyGroupPropsValidator(properties).assertSuccess(), { KeyGroupConfig: cfnKeyGroupKeyGroupConfigPropertyToCloudFormation(properties.keyGroupConfig) }) : properties;
    }
    function CfnKeyGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("keyGroupConfig", "KeyGroupConfig", CfnKeyGroupKeyGroupConfigPropertyFromCloudFormation(properties.KeyGroupConfig)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnKeyGroup = class _CfnKeyGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnKeyGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnKeyGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnKeyGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_CfnKeyGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnKeyGroup), error;
        }
        cdk.requireProperty(props, "keyGroupConfig", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrLastModifiedTime = cdk.Token.asString(this.getAtt("LastModifiedTime", cdk.ResolutionTypeHint.STRING)), this.keyGroupConfig = props.keyGroupConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnKeyGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { keyGroupConfig: this.keyGroupConfig };
      }
      renderProperties(props) {
        return cfnKeyGroupPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnKeyGroup[_f] = { fqn: "aws-cdk-lib.aws_cloudfront.CfnKeyGroup", version: "2.80.0" }, CfnKeyGroup.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFront::KeyGroup", exports2.CfnKeyGroup = CfnKeyGroup;
    function CfnKeyGroup_KeyGroupConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("comment", cdk.validateString)(properties.comment)), errors.collect(cdk.propertyValidator("items", cdk.requiredValidator)(properties.items)), errors.collect(cdk.propertyValidator("items", cdk.listValidator(cdk.validateString))(properties.items)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "KeyGroupConfigProperty"');
    }
    function cfnKeyGroupKeyGroupConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnKeyGroup_KeyGroupConfigPropertyValidator(properties).assertSuccess(), { Comment: cdk.stringToCloudFormation(properties.comment), Items: cdk.listMapper(cdk.stringToCloudFormation)(properties.items), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnKeyGroupKeyGroupConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("comment", "Comment", properties.Comment != null ? cfn_parse.FromCloudFormation.getString(properties.Comment) : void 0), ret.addPropertyResult("items", "Items", cfn_parse.FromCloudFormation.getStringArray(properties.Items)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMonitoringSubscriptionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("distributionId", cdk.requiredValidator)(properties.distributionId)), errors.collect(cdk.propertyValidator("distributionId", cdk.validateString)(properties.distributionId)), errors.collect(cdk.propertyValidator("monitoringSubscription", cdk.requiredValidator)(properties.monitoringSubscription)), errors.collect(cdk.propertyValidator("monitoringSubscription", CfnMonitoringSubscription_MonitoringSubscriptionPropertyValidator)(properties.monitoringSubscription)), errors.wrap('supplied properties not correct for "CfnMonitoringSubscriptionProps"');
    }
    function cfnMonitoringSubscriptionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMonitoringSubscriptionPropsValidator(properties).assertSuccess(), { DistributionId: cdk.stringToCloudFormation(properties.distributionId), MonitoringSubscription: cfnMonitoringSubscriptionMonitoringSubscriptionPropertyToCloudFormation(properties.monitoringSubscription) }) : properties;
    }
    function CfnMonitoringSubscriptionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("distributionId", "DistributionId", cfn_parse.FromCloudFormation.getString(properties.DistributionId)), ret.addPropertyResult("monitoringSubscription", "MonitoringSubscription", CfnMonitoringSubscriptionMonitoringSubscriptionPropertyFromCloudFormation(properties.MonitoringSubscription)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnMonitoringSubscription = class _CfnMonitoringSubscription extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnMonitoringSubscriptionPropsFromCloudFormation(resourceProperties), ret = new _CfnMonitoringSubscription(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnMonitoringSubscription.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_CfnMonitoringSubscriptionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnMonitoringSubscription), error;
        }
        cdk.requireProperty(props, "distributionId", this), cdk.requireProperty(props, "monitoringSubscription", this), this.distributionId = props.distributionId, this.monitoringSubscription = props.monitoringSubscription;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnMonitoringSubscription.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { distributionId: this.distributionId, monitoringSubscription: this.monitoringSubscription };
      }
      renderProperties(props) {
        return cfnMonitoringSubscriptionPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnMonitoringSubscription[_g] = { fqn: "aws-cdk-lib.aws_cloudfront.CfnMonitoringSubscription", version: "2.80.0" }, CfnMonitoringSubscription.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFront::MonitoringSubscription", exports2.CfnMonitoringSubscription = CfnMonitoringSubscription;
    function CfnMonitoringSubscription_MonitoringSubscriptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("realtimeMetricsSubscriptionConfig", CfnMonitoringSubscription_RealtimeMetricsSubscriptionConfigPropertyValidator)(properties.realtimeMetricsSubscriptionConfig)), errors.wrap('supplied properties not correct for "MonitoringSubscriptionProperty"');
    }
    function cfnMonitoringSubscriptionMonitoringSubscriptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMonitoringSubscription_MonitoringSubscriptionPropertyValidator(properties).assertSuccess(), { RealtimeMetricsSubscriptionConfig: cfnMonitoringSubscriptionRealtimeMetricsSubscriptionConfigPropertyToCloudFormation(properties.realtimeMetricsSubscriptionConfig) }) : properties;
    }
    function CfnMonitoringSubscriptionMonitoringSubscriptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("realtimeMetricsSubscriptionConfig", "RealtimeMetricsSubscriptionConfig", properties.RealtimeMetricsSubscriptionConfig != null ? CfnMonitoringSubscriptionRealtimeMetricsSubscriptionConfigPropertyFromCloudFormation(properties.RealtimeMetricsSubscriptionConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMonitoringSubscription_RealtimeMetricsSubscriptionConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("realtimeMetricsSubscriptionStatus", cdk.requiredValidator)(properties.realtimeMetricsSubscriptionStatus)), errors.collect(cdk.propertyValidator("realtimeMetricsSubscriptionStatus", cdk.validateString)(properties.realtimeMetricsSubscriptionStatus)), errors.wrap('supplied properties not correct for "RealtimeMetricsSubscriptionConfigProperty"');
    }
    function cfnMonitoringSubscriptionRealtimeMetricsSubscriptionConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMonitoringSubscription_RealtimeMetricsSubscriptionConfigPropertyValidator(properties).assertSuccess(), { RealtimeMetricsSubscriptionStatus: cdk.stringToCloudFormation(properties.realtimeMetricsSubscriptionStatus) }) : properties;
    }
    function CfnMonitoringSubscriptionRealtimeMetricsSubscriptionConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("realtimeMetricsSubscriptionStatus", "RealtimeMetricsSubscriptionStatus", cfn_parse.FromCloudFormation.getString(properties.RealtimeMetricsSubscriptionStatus)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnOriginAccessControlPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("originAccessControlConfig", cdk.requiredValidator)(properties.originAccessControlConfig)), errors.collect(cdk.propertyValidator("originAccessControlConfig", CfnOriginAccessControl_OriginAccessControlConfigPropertyValidator)(properties.originAccessControlConfig)), errors.wrap('supplied properties not correct for "CfnOriginAccessControlProps"');
    }
    function cfnOriginAccessControlPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOriginAccessControlPropsValidator(properties).assertSuccess(), { OriginAccessControlConfig: cfnOriginAccessControlOriginAccessControlConfigPropertyToCloudFormation(properties.originAccessControlConfig) }) : properties;
    }
    function CfnOriginAccessControlPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("originAccessControlConfig", "OriginAccessControlConfig", CfnOriginAccessControlOriginAccessControlConfigPropertyFromCloudFormation(properties.OriginAccessControlConfig)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnOriginAccessControl = class _CfnOriginAccessControl extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnOriginAccessControlPropsFromCloudFormation(resourceProperties), ret = new _CfnOriginAccessControl(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnOriginAccessControl.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_CfnOriginAccessControlProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnOriginAccessControl), error;
        }
        cdk.requireProperty(props, "originAccessControlConfig", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.originAccessControlConfig = props.originAccessControlConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnOriginAccessControl.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { originAccessControlConfig: this.originAccessControlConfig };
      }
      renderProperties(props) {
        return cfnOriginAccessControlPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnOriginAccessControl[_h] = { fqn: "aws-cdk-lib.aws_cloudfront.CfnOriginAccessControl", version: "2.80.0" }, CfnOriginAccessControl.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFront::OriginAccessControl", exports2.CfnOriginAccessControl = CfnOriginAccessControl;
    function CfnOriginAccessControl_OriginAccessControlConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("originAccessControlOriginType", cdk.requiredValidator)(properties.originAccessControlOriginType)), errors.collect(cdk.propertyValidator("originAccessControlOriginType", cdk.validateString)(properties.originAccessControlOriginType)), errors.collect(cdk.propertyValidator("signingBehavior", cdk.requiredValidator)(properties.signingBehavior)), errors.collect(cdk.propertyValidator("signingBehavior", cdk.validateString)(properties.signingBehavior)), errors.collect(cdk.propertyValidator("signingProtocol", cdk.requiredValidator)(properties.signingProtocol)), errors.collect(cdk.propertyValidator("signingProtocol", cdk.validateString)(properties.signingProtocol)), errors.wrap('supplied properties not correct for "OriginAccessControlConfigProperty"');
    }
    function cfnOriginAccessControlOriginAccessControlConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOriginAccessControl_OriginAccessControlConfigPropertyValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), Name: cdk.stringToCloudFormation(properties.name), OriginAccessControlOriginType: cdk.stringToCloudFormation(properties.originAccessControlOriginType), SigningBehavior: cdk.stringToCloudFormation(properties.signingBehavior), SigningProtocol: cdk.stringToCloudFormation(properties.signingProtocol) }) : properties;
    }
    function CfnOriginAccessControlOriginAccessControlConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("originAccessControlOriginType", "OriginAccessControlOriginType", cfn_parse.FromCloudFormation.getString(properties.OriginAccessControlOriginType)), ret.addPropertyResult("signingBehavior", "SigningBehavior", cfn_parse.FromCloudFormation.getString(properties.SigningBehavior)), ret.addPropertyResult("signingProtocol", "SigningProtocol", cfn_parse.FromCloudFormation.getString(properties.SigningProtocol)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnOriginRequestPolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("originRequestPolicyConfig", cdk.requiredValidator)(properties.originRequestPolicyConfig)), errors.collect(cdk.propertyValidator("originRequestPolicyConfig", CfnOriginRequestPolicy_OriginRequestPolicyConfigPropertyValidator)(properties.originRequestPolicyConfig)), errors.wrap('supplied properties not correct for "CfnOriginRequestPolicyProps"');
    }
    function cfnOriginRequestPolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOriginRequestPolicyPropsValidator(properties).assertSuccess(), { OriginRequestPolicyConfig: cfnOriginRequestPolicyOriginRequestPolicyConfigPropertyToCloudFormation(properties.originRequestPolicyConfig) }) : properties;
    }
    function CfnOriginRequestPolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("originRequestPolicyConfig", "OriginRequestPolicyConfig", CfnOriginRequestPolicyOriginRequestPolicyConfigPropertyFromCloudFormation(properties.OriginRequestPolicyConfig)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnOriginRequestPolicy = class _CfnOriginRequestPolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnOriginRequestPolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnOriginRequestPolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnOriginRequestPolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_CfnOriginRequestPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnOriginRequestPolicy), error;
        }
        cdk.requireProperty(props, "originRequestPolicyConfig", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrLastModifiedTime = cdk.Token.asString(this.getAtt("LastModifiedTime", cdk.ResolutionTypeHint.STRING)), this.originRequestPolicyConfig = props.originRequestPolicyConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnOriginRequestPolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { originRequestPolicyConfig: this.originRequestPolicyConfig };
      }
      renderProperties(props) {
        return cfnOriginRequestPolicyPropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnOriginRequestPolicy[_j] = { fqn: "aws-cdk-lib.aws_cloudfront.CfnOriginRequestPolicy", version: "2.80.0" }, CfnOriginRequestPolicy.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFront::OriginRequestPolicy", exports2.CfnOriginRequestPolicy = CfnOriginRequestPolicy;
    function CfnOriginRequestPolicy_CookiesConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cookieBehavior", cdk.requiredValidator)(properties.cookieBehavior)), errors.collect(cdk.propertyValidator("cookieBehavior", cdk.validateString)(properties.cookieBehavior)), errors.collect(cdk.propertyValidator("cookies", cdk.listValidator(cdk.validateString))(properties.cookies)), errors.wrap('supplied properties not correct for "CookiesConfigProperty"');
    }
    function cfnOriginRequestPolicyCookiesConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOriginRequestPolicy_CookiesConfigPropertyValidator(properties).assertSuccess(), { CookieBehavior: cdk.stringToCloudFormation(properties.cookieBehavior), Cookies: cdk.listMapper(cdk.stringToCloudFormation)(properties.cookies) }) : properties;
    }
    function CfnOriginRequestPolicyCookiesConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cookieBehavior", "CookieBehavior", cfn_parse.FromCloudFormation.getString(properties.CookieBehavior)), ret.addPropertyResult("cookies", "Cookies", properties.Cookies != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Cookies) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnOriginRequestPolicy_HeadersConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("headerBehavior", cdk.requiredValidator)(properties.headerBehavior)), errors.collect(cdk.propertyValidator("headerBehavior", cdk.validateString)(properties.headerBehavior)), errors.collect(cdk.propertyValidator("headers", cdk.listValidator(cdk.validateString))(properties.headers)), errors.wrap('supplied properties not correct for "HeadersConfigProperty"');
    }
    function cfnOriginRequestPolicyHeadersConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOriginRequestPolicy_HeadersConfigPropertyValidator(properties).assertSuccess(), { HeaderBehavior: cdk.stringToCloudFormation(properties.headerBehavior), Headers: cdk.listMapper(cdk.stringToCloudFormation)(properties.headers) }) : properties;
    }
    function CfnOriginRequestPolicyHeadersConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("headerBehavior", "HeaderBehavior", cfn_parse.FromCloudFormation.getString(properties.HeaderBehavior)), ret.addPropertyResult("headers", "Headers", properties.Headers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Headers) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnOriginRequestPolicy_OriginRequestPolicyConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("comment", cdk.validateString)(properties.comment)), errors.collect(cdk.propertyValidator("cookiesConfig", cdk.requiredValidator)(properties.cookiesConfig)), errors.collect(cdk.propertyValidator("cookiesConfig", CfnOriginRequestPolicy_CookiesConfigPropertyValidator)(properties.cookiesConfig)), errors.collect(cdk.propertyValidator("headersConfig", cdk.requiredValidator)(properties.headersConfig)), errors.collect(cdk.propertyValidator("headersConfig", CfnOriginRequestPolicy_HeadersConfigPropertyValidator)(properties.headersConfig)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("queryStringsConfig", cdk.requiredValidator)(properties.queryStringsConfig)), errors.collect(cdk.propertyValidator("queryStringsConfig", CfnOriginRequestPolicy_QueryStringsConfigPropertyValidator)(properties.queryStringsConfig)), errors.wrap('supplied properties not correct for "OriginRequestPolicyConfigProperty"');
    }
    function cfnOriginRequestPolicyOriginRequestPolicyConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOriginRequestPolicy_OriginRequestPolicyConfigPropertyValidator(properties).assertSuccess(), { Comment: cdk.stringToCloudFormation(properties.comment), CookiesConfig: cfnOriginRequestPolicyCookiesConfigPropertyToCloudFormation(properties.cookiesConfig), HeadersConfig: cfnOriginRequestPolicyHeadersConfigPropertyToCloudFormation(properties.headersConfig), Name: cdk.stringToCloudFormation(properties.name), QueryStringsConfig: cfnOriginRequestPolicyQueryStringsConfigPropertyToCloudFormation(properties.queryStringsConfig) }) : properties;
    }
    function CfnOriginRequestPolicyOriginRequestPolicyConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("comment", "Comment", properties.Comment != null ? cfn_parse.FromCloudFormation.getString(properties.Comment) : void 0), ret.addPropertyResult("cookiesConfig", "CookiesConfig", CfnOriginRequestPolicyCookiesConfigPropertyFromCloudFormation(properties.CookiesConfig)), ret.addPropertyResult("headersConfig", "HeadersConfig", CfnOriginRequestPolicyHeadersConfigPropertyFromCloudFormation(properties.HeadersConfig)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("queryStringsConfig", "QueryStringsConfig", CfnOriginRequestPolicyQueryStringsConfigPropertyFromCloudFormation(properties.QueryStringsConfig)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnOriginRequestPolicy_QueryStringsConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("queryStringBehavior", cdk.requiredValidator)(properties.queryStringBehavior)), errors.collect(cdk.propertyValidator("queryStringBehavior", cdk.validateString)(properties.queryStringBehavior)), errors.collect(cdk.propertyValidator("queryStrings", cdk.listValidator(cdk.validateString))(properties.queryStrings)), errors.wrap('supplied properties not correct for "QueryStringsConfigProperty"');
    }
    function cfnOriginRequestPolicyQueryStringsConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOriginRequestPolicy_QueryStringsConfigPropertyValidator(properties).assertSuccess(), { QueryStringBehavior: cdk.stringToCloudFormation(properties.queryStringBehavior), QueryStrings: cdk.listMapper(cdk.stringToCloudFormation)(properties.queryStrings) }) : properties;
    }
    function CfnOriginRequestPolicyQueryStringsConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("queryStringBehavior", "QueryStringBehavior", cfn_parse.FromCloudFormation.getString(properties.QueryStringBehavior)), ret.addPropertyResult("queryStrings", "QueryStrings", properties.QueryStrings != null ? cfn_parse.FromCloudFormation.getStringArray(properties.QueryStrings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPublicKeyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("publicKeyConfig", cdk.requiredValidator)(properties.publicKeyConfig)), errors.collect(cdk.propertyValidator("publicKeyConfig", CfnPublicKey_PublicKeyConfigPropertyValidator)(properties.publicKeyConfig)), errors.wrap('supplied properties not correct for "CfnPublicKeyProps"');
    }
    function cfnPublicKeyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPublicKeyPropsValidator(properties).assertSuccess(), { PublicKeyConfig: cfnPublicKeyPublicKeyConfigPropertyToCloudFormation(properties.publicKeyConfig) }) : properties;
    }
    function CfnPublicKeyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("publicKeyConfig", "PublicKeyConfig", CfnPublicKeyPublicKeyConfigPropertyFromCloudFormation(properties.PublicKeyConfig)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPublicKey = class _CfnPublicKey extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPublicKeyPropsFromCloudFormation(resourceProperties), ret = new _CfnPublicKey(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPublicKey.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_CfnPublicKeyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPublicKey), error;
        }
        cdk.requireProperty(props, "publicKeyConfig", this), this.attrCreatedTime = cdk.Token.asString(this.getAtt("CreatedTime", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.publicKeyConfig = props.publicKeyConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPublicKey.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { publicKeyConfig: this.publicKeyConfig };
      }
      renderProperties(props) {
        return cfnPublicKeyPropsToCloudFormation(props);
      }
    };
    _k = JSII_RTTI_SYMBOL_1, CfnPublicKey[_k] = { fqn: "aws-cdk-lib.aws_cloudfront.CfnPublicKey", version: "2.80.0" }, CfnPublicKey.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFront::PublicKey", exports2.CfnPublicKey = CfnPublicKey;
    function CfnPublicKey_PublicKeyConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("callerReference", cdk.requiredValidator)(properties.callerReference)), errors.collect(cdk.propertyValidator("callerReference", cdk.validateString)(properties.callerReference)), errors.collect(cdk.propertyValidator("comment", cdk.validateString)(properties.comment)), errors.collect(cdk.propertyValidator("encodedKey", cdk.requiredValidator)(properties.encodedKey)), errors.collect(cdk.propertyValidator("encodedKey", cdk.validateString)(properties.encodedKey)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "PublicKeyConfigProperty"');
    }
    function cfnPublicKeyPublicKeyConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPublicKey_PublicKeyConfigPropertyValidator(properties).assertSuccess(), { CallerReference: cdk.stringToCloudFormation(properties.callerReference), Comment: cdk.stringToCloudFormation(properties.comment), EncodedKey: cdk.stringToCloudFormation(properties.encodedKey), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnPublicKeyPublicKeyConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("callerReference", "CallerReference", cfn_parse.FromCloudFormation.getString(properties.CallerReference)), ret.addPropertyResult("comment", "Comment", properties.Comment != null ? cfn_parse.FromCloudFormation.getString(properties.Comment) : void 0), ret.addPropertyResult("encodedKey", "EncodedKey", cfn_parse.FromCloudFormation.getString(properties.EncodedKey)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRealtimeLogConfigPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endPoints", cdk.requiredValidator)(properties.endPoints)), errors.collect(cdk.propertyValidator("endPoints", cdk.listValidator(CfnRealtimeLogConfig_EndPointPropertyValidator))(properties.endPoints)), errors.collect(cdk.propertyValidator("fields", cdk.requiredValidator)(properties.fields)), errors.collect(cdk.propertyValidator("fields", cdk.listValidator(cdk.validateString))(properties.fields)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("samplingRate", cdk.requiredValidator)(properties.samplingRate)), errors.collect(cdk.propertyValidator("samplingRate", cdk.validateNumber)(properties.samplingRate)), errors.wrap('supplied properties not correct for "CfnRealtimeLogConfigProps"');
    }
    function cfnRealtimeLogConfigPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRealtimeLogConfigPropsValidator(properties).assertSuccess(), { EndPoints: cdk.listMapper(cfnRealtimeLogConfigEndPointPropertyToCloudFormation)(properties.endPoints), Fields: cdk.listMapper(cdk.stringToCloudFormation)(properties.fields), Name: cdk.stringToCloudFormation(properties.name), SamplingRate: cdk.numberToCloudFormation(properties.samplingRate) }) : properties;
    }
    function CfnRealtimeLogConfigPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endPoints", "EndPoints", cfn_parse.FromCloudFormation.getArray(CfnRealtimeLogConfigEndPointPropertyFromCloudFormation)(properties.EndPoints)), ret.addPropertyResult("fields", "Fields", cfn_parse.FromCloudFormation.getStringArray(properties.Fields)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("samplingRate", "SamplingRate", cfn_parse.FromCloudFormation.getNumber(properties.SamplingRate)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRealtimeLogConfig = class _CfnRealtimeLogConfig extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRealtimeLogConfigPropsFromCloudFormation(resourceProperties), ret = new _CfnRealtimeLogConfig(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRealtimeLogConfig.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_CfnRealtimeLogConfigProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRealtimeLogConfig), error;
        }
        cdk.requireProperty(props, "endPoints", this), cdk.requireProperty(props, "fields", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "samplingRate", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.endPoints = props.endPoints, this.fields = props.fields, this.name = props.name, this.samplingRate = props.samplingRate;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRealtimeLogConfig.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { endPoints: this.endPoints, fields: this.fields, name: this.name, samplingRate: this.samplingRate };
      }
      renderProperties(props) {
        return cfnRealtimeLogConfigPropsToCloudFormation(props);
      }
    };
    _l = JSII_RTTI_SYMBOL_1, CfnRealtimeLogConfig[_l] = { fqn: "aws-cdk-lib.aws_cloudfront.CfnRealtimeLogConfig", version: "2.80.0" }, CfnRealtimeLogConfig.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFront::RealtimeLogConfig", exports2.CfnRealtimeLogConfig = CfnRealtimeLogConfig;
    function CfnRealtimeLogConfig_EndPointPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kinesisStreamConfig", cdk.requiredValidator)(properties.kinesisStreamConfig)), errors.collect(cdk.propertyValidator("kinesisStreamConfig", CfnRealtimeLogConfig_KinesisStreamConfigPropertyValidator)(properties.kinesisStreamConfig)), errors.collect(cdk.propertyValidator("streamType", cdk.requiredValidator)(properties.streamType)), errors.collect(cdk.propertyValidator("streamType", cdk.validateString)(properties.streamType)), errors.wrap('supplied properties not correct for "EndPointProperty"');
    }
    function cfnRealtimeLogConfigEndPointPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRealtimeLogConfig_EndPointPropertyValidator(properties).assertSuccess(), { KinesisStreamConfig: cfnRealtimeLogConfigKinesisStreamConfigPropertyToCloudFormation(properties.kinesisStreamConfig), StreamType: cdk.stringToCloudFormation(properties.streamType) }) : properties;
    }
    function CfnRealtimeLogConfigEndPointPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kinesisStreamConfig", "KinesisStreamConfig", CfnRealtimeLogConfigKinesisStreamConfigPropertyFromCloudFormation(properties.KinesisStreamConfig)), ret.addPropertyResult("streamType", "StreamType", cfn_parse.FromCloudFormation.getString(properties.StreamType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRealtimeLogConfig_KinesisStreamConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("streamArn", cdk.requiredValidator)(properties.streamArn)), errors.collect(cdk.propertyValidator("streamArn", cdk.validateString)(properties.streamArn)), errors.wrap('supplied properties not correct for "KinesisStreamConfigProperty"');
    }
    function cfnRealtimeLogConfigKinesisStreamConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRealtimeLogConfig_KinesisStreamConfigPropertyValidator(properties).assertSuccess(), { RoleArn: cdk.stringToCloudFormation(properties.roleArn), StreamArn: cdk.stringToCloudFormation(properties.streamArn) }) : properties;
    }
    function CfnRealtimeLogConfigKinesisStreamConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("streamArn", "StreamArn", cfn_parse.FromCloudFormation.getString(properties.StreamArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResponseHeadersPolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("responseHeadersPolicyConfig", cdk.requiredValidator)(properties.responseHeadersPolicyConfig)), errors.collect(cdk.propertyValidator("responseHeadersPolicyConfig", CfnResponseHeadersPolicy_ResponseHeadersPolicyConfigPropertyValidator)(properties.responseHeadersPolicyConfig)), errors.wrap('supplied properties not correct for "CfnResponseHeadersPolicyProps"');
    }
    function cfnResponseHeadersPolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResponseHeadersPolicyPropsValidator(properties).assertSuccess(), { ResponseHeadersPolicyConfig: cfnResponseHeadersPolicyResponseHeadersPolicyConfigPropertyToCloudFormation(properties.responseHeadersPolicyConfig) }) : properties;
    }
    function CfnResponseHeadersPolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("responseHeadersPolicyConfig", "ResponseHeadersPolicyConfig", CfnResponseHeadersPolicyResponseHeadersPolicyConfigPropertyFromCloudFormation(properties.ResponseHeadersPolicyConfig)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResponseHeadersPolicy = class _CfnResponseHeadersPolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResponseHeadersPolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnResponseHeadersPolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnResponseHeadersPolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_CfnResponseHeadersPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResponseHeadersPolicy), error;
        }
        cdk.requireProperty(props, "responseHeadersPolicyConfig", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrLastModifiedTime = cdk.Token.asString(this.getAtt("LastModifiedTime", cdk.ResolutionTypeHint.STRING)), this.responseHeadersPolicyConfig = props.responseHeadersPolicyConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResponseHeadersPolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { responseHeadersPolicyConfig: this.responseHeadersPolicyConfig };
      }
      renderProperties(props) {
        return cfnResponseHeadersPolicyPropsToCloudFormation(props);
      }
    };
    _m = JSII_RTTI_SYMBOL_1, CfnResponseHeadersPolicy[_m] = { fqn: "aws-cdk-lib.aws_cloudfront.CfnResponseHeadersPolicy", version: "2.80.0" }, CfnResponseHeadersPolicy.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFront::ResponseHeadersPolicy", exports2.CfnResponseHeadersPolicy = CfnResponseHeadersPolicy;
    function CfnResponseHeadersPolicy_AccessControlAllowHeadersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("items", cdk.requiredValidator)(properties.items)), errors.collect(cdk.propertyValidator("items", cdk.listValidator(cdk.validateString))(properties.items)), errors.wrap('supplied properties not correct for "AccessControlAllowHeadersProperty"');
    }
    function cfnResponseHeadersPolicyAccessControlAllowHeadersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResponseHeadersPolicy_AccessControlAllowHeadersPropertyValidator(properties).assertSuccess(), { Items: cdk.listMapper(cdk.stringToCloudFormation)(properties.items) }) : properties;
    }
    function CfnResponseHeadersPolicyAccessControlAllowHeadersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("items", "Items", cfn_parse.FromCloudFormation.getStringArray(properties.Items)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResponseHeadersPolicy_AccessControlAllowMethodsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("items", cdk.requiredValidator)(properties.items)), errors.collect(cdk.propertyValidator("items", cdk.listValidator(cdk.validateString))(properties.items)), errors.wrap('supplied properties not correct for "AccessControlAllowMethodsProperty"');
    }
    function cfnResponseHeadersPolicyAccessControlAllowMethodsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResponseHeadersPolicy_AccessControlAllowMethodsPropertyValidator(properties).assertSuccess(), { Items: cdk.listMapper(cdk.stringToCloudFormation)(properties.items) }) : properties;
    }
    function CfnResponseHeadersPolicyAccessControlAllowMethodsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("items", "Items", cfn_parse.FromCloudFormation.getStringArray(properties.Items)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResponseHeadersPolicy_AccessControlAllowOriginsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("items", cdk.requiredValidator)(properties.items)), errors.collect(cdk.propertyValidator("items", cdk.listValidator(cdk.validateString))(properties.items)), errors.wrap('supplied properties not correct for "AccessControlAllowOriginsProperty"');
    }
    function cfnResponseHeadersPolicyAccessControlAllowOriginsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResponseHeadersPolicy_AccessControlAllowOriginsPropertyValidator(properties).assertSuccess(), { Items: cdk.listMapper(cdk.stringToCloudFormation)(properties.items) }) : properties;
    }
    function CfnResponseHeadersPolicyAccessControlAllowOriginsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("items", "Items", cfn_parse.FromCloudFormation.getStringArray(properties.Items)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResponseHeadersPolicy_AccessControlExposeHeadersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("items", cdk.requiredValidator)(properties.items)), errors.collect(cdk.propertyValidator("items", cdk.listValidator(cdk.validateString))(properties.items)), errors.wrap('supplied properties not correct for "AccessControlExposeHeadersProperty"');
    }
    function cfnResponseHeadersPolicyAccessControlExposeHeadersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResponseHeadersPolicy_AccessControlExposeHeadersPropertyValidator(properties).assertSuccess(), { Items: cdk.listMapper(cdk.stringToCloudFormation)(properties.items) }) : properties;
    }
    function CfnResponseHeadersPolicyAccessControlExposeHeadersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("items", "Items", cfn_parse.FromCloudFormation.getStringArray(properties.Items)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResponseHeadersPolicy_ContentSecurityPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contentSecurityPolicy", cdk.requiredValidator)(properties.contentSecurityPolicy)), errors.collect(cdk.propertyValidator("contentSecurityPolicy", cdk.validateString)(properties.contentSecurityPolicy)), errors.collect(cdk.propertyValidator("override", cdk.requiredValidator)(properties.override)), errors.collect(cdk.propertyValidator("override", cdk.validateBoolean)(properties.override)), errors.wrap('supplied properties not correct for "ContentSecurityPolicyProperty"');
    }
    function cfnResponseHeadersPolicyContentSecurityPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResponseHeadersPolicy_ContentSecurityPolicyPropertyValidator(properties).assertSuccess(), { ContentSecurityPolicy: cdk.stringToCloudFormation(properties.contentSecurityPolicy), Override: cdk.booleanToCloudFormation(properties.override) }) : properties;
    }
    function CfnResponseHeadersPolicyContentSecurityPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contentSecurityPolicy", "ContentSecurityPolicy", cfn_parse.FromCloudFormation.getString(properties.ContentSecurityPolicy)), ret.addPropertyResult("override", "Override", cfn_parse.FromCloudFormation.getBoolean(properties.Override)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResponseHeadersPolicy_ContentTypeOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("override", cdk.requiredValidator)(properties.override)), errors.collect(cdk.propertyValidator("override", cdk.validateBoolean)(properties.override)), errors.wrap('supplied properties not correct for "ContentTypeOptionsProperty"');
    }
    function cfnResponseHeadersPolicyContentTypeOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResponseHeadersPolicy_ContentTypeOptionsPropertyValidator(properties).assertSuccess(), { Override: cdk.booleanToCloudFormation(properties.override) }) : properties;
    }
    function CfnResponseHeadersPolicyContentTypeOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("override", "Override", cfn_parse.FromCloudFormation.getBoolean(properties.Override)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResponseHeadersPolicy_CorsConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessControlAllowCredentials", cdk.requiredValidator)(properties.accessControlAllowCredentials)), errors.collect(cdk.propertyValidator("accessControlAllowCredentials", cdk.validateBoolean)(properties.accessControlAllowCredentials)), errors.collect(cdk.propertyValidator("accessControlAllowHeaders", cdk.requiredValidator)(properties.accessControlAllowHeaders)), errors.collect(cdk.propertyValidator("accessControlAllowHeaders", CfnResponseHeadersPolicy_AccessControlAllowHeadersPropertyValidator)(properties.accessControlAllowHeaders)), errors.collect(cdk.propertyValidator("accessControlAllowMethods", cdk.requiredValidator)(properties.accessControlAllowMethods)), errors.collect(cdk.propertyValidator("accessControlAllowMethods", CfnResponseHeadersPolicy_AccessControlAllowMethodsPropertyValidator)(properties.accessControlAllowMethods)), errors.collect(cdk.propertyValidator("accessControlAllowOrigins", cdk.requiredValidator)(properties.accessControlAllowOrigins)), errors.collect(cdk.propertyValidator("accessControlAllowOrigins", CfnResponseHeadersPolicy_AccessControlAllowOriginsPropertyValidator)(properties.accessControlAllowOrigins)), errors.collect(cdk.propertyValidator("accessControlExposeHeaders", CfnResponseHeadersPolicy_AccessControlExposeHeadersPropertyValidator)(properties.accessControlExposeHeaders)), errors.collect(cdk.propertyValidator("accessControlMaxAgeSec", cdk.validateNumber)(properties.accessControlMaxAgeSec)), errors.collect(cdk.propertyValidator("originOverride", cdk.requiredValidator)(properties.originOverride)), errors.collect(cdk.propertyValidator("originOverride", cdk.validateBoolean)(properties.originOverride)), errors.wrap('supplied properties not correct for "CorsConfigProperty"');
    }
    function cfnResponseHeadersPolicyCorsConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResponseHeadersPolicy_CorsConfigPropertyValidator(properties).assertSuccess(), { AccessControlAllowCredentials: cdk.booleanToCloudFormation(properties.accessControlAllowCredentials), AccessControlAllowHeaders: cfnResponseHeadersPolicyAccessControlAllowHeadersPropertyToCloudFormation(properties.accessControlAllowHeaders), AccessControlAllowMethods: cfnResponseHeadersPolicyAccessControlAllowMethodsPropertyToCloudFormation(properties.accessControlAllowMethods), AccessControlAllowOrigins: cfnResponseHeadersPolicyAccessControlAllowOriginsPropertyToCloudFormation(properties.accessControlAllowOrigins), AccessControlExposeHeaders: cfnResponseHeadersPolicyAccessControlExposeHeadersPropertyToCloudFormation(properties.accessControlExposeHeaders), AccessControlMaxAgeSec: cdk.numberToCloudFormation(properties.accessControlMaxAgeSec), OriginOverride: cdk.booleanToCloudFormation(properties.originOverride) }) : properties;
    }
    function CfnResponseHeadersPolicyCorsConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessControlAllowCredentials", "AccessControlAllowCredentials", cfn_parse.FromCloudFormation.getBoolean(properties.AccessControlAllowCredentials)), ret.addPropertyResult("accessControlAllowHeaders", "AccessControlAllowHeaders", CfnResponseHeadersPolicyAccessControlAllowHeadersPropertyFromCloudFormation(properties.AccessControlAllowHeaders)), ret.addPropertyResult("accessControlAllowMethods", "AccessControlAllowMethods", CfnResponseHeadersPolicyAccessControlAllowMethodsPropertyFromCloudFormation(properties.AccessControlAllowMethods)), ret.addPropertyResult("accessControlAllowOrigins", "AccessControlAllowOrigins", CfnResponseHeadersPolicyAccessControlAllowOriginsPropertyFromCloudFormation(properties.AccessControlAllowOrigins)), ret.addPropertyResult("accessControlExposeHeaders", "AccessControlExposeHeaders", properties.AccessControlExposeHeaders != null ? CfnResponseHeadersPolicyAccessControlExposeHeadersPropertyFromCloudFormation(properties.AccessControlExposeHeaders) : void 0), ret.addPropertyResult("accessControlMaxAgeSec", "AccessControlMaxAgeSec", properties.AccessControlMaxAgeSec != null ? cfn_parse.FromCloudFormation.getNumber(properties.AccessControlMaxAgeSec) : void 0), ret.addPropertyResult("originOverride", "OriginOverride", cfn_parse.FromCloudFormation.getBoolean(properties.OriginOverride)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResponseHeadersPolicy_CustomHeaderPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("header", cdk.requiredValidator)(properties.header)), errors.collect(cdk.propertyValidator("header", cdk.validateString)(properties.header)), errors.collect(cdk.propertyValidator("override", cdk.requiredValidator)(properties.override)), errors.collect(cdk.propertyValidator("override", cdk.validateBoolean)(properties.override)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "CustomHeaderProperty"');
    }
    function cfnResponseHeadersPolicyCustomHeaderPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResponseHeadersPolicy_CustomHeaderPropertyValidator(properties).assertSuccess(), { Header: cdk.stringToCloudFormation(properties.header), Override: cdk.booleanToCloudFormation(properties.override), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnResponseHeadersPolicyCustomHeaderPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("header", "Header", cfn_parse.FromCloudFormation.getString(properties.Header)), ret.addPropertyResult("override", "Override", cfn_parse.FromCloudFormation.getBoolean(properties.Override)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResponseHeadersPolicy_CustomHeadersConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("items", cdk.requiredValidator)(properties.items)), errors.collect(cdk.propertyValidator("items", cdk.listValidator(CfnResponseHeadersPolicy_CustomHeaderPropertyValidator))(properties.items)), errors.wrap('supplied properties not correct for "CustomHeadersConfigProperty"');
    }
    function cfnResponseHeadersPolicyCustomHeadersConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResponseHeadersPolicy_CustomHeadersConfigPropertyValidator(properties).assertSuccess(), { Items: cdk.listMapper(cfnResponseHeadersPolicyCustomHeaderPropertyToCloudFormation)(properties.items) }) : properties;
    }
    function CfnResponseHeadersPolicyCustomHeadersConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("items", "Items", cfn_parse.FromCloudFormation.getArray(CfnResponseHeadersPolicyCustomHeaderPropertyFromCloudFormation)(properties.Items)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResponseHeadersPolicy_FrameOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("frameOption", cdk.requiredValidator)(properties.frameOption)), errors.collect(cdk.propertyValidator("frameOption", cdk.validateString)(properties.frameOption)), errors.collect(cdk.propertyValidator("override", cdk.requiredValidator)(properties.override)), errors.collect(cdk.propertyValidator("override", cdk.validateBoolean)(properties.override)), errors.wrap('supplied properties not correct for "FrameOptionsProperty"');
    }
    function cfnResponseHeadersPolicyFrameOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResponseHeadersPolicy_FrameOptionsPropertyValidator(properties).assertSuccess(), { FrameOption: cdk.stringToCloudFormation(properties.frameOption), Override: cdk.booleanToCloudFormation(properties.override) }) : properties;
    }
    function CfnResponseHeadersPolicyFrameOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("frameOption", "FrameOption", cfn_parse.FromCloudFormation.getString(properties.FrameOption)), ret.addPropertyResult("override", "Override", cfn_parse.FromCloudFormation.getBoolean(properties.Override)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResponseHeadersPolicy_ReferrerPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("override", cdk.requiredValidator)(properties.override)), errors.collect(cdk.propertyValidator("override", cdk.validateBoolean)(properties.override)), errors.collect(cdk.propertyValidator("referrerPolicy", cdk.requiredValidator)(properties.referrerPolicy)), errors.collect(cdk.propertyValidator("referrerPolicy", cdk.validateString)(properties.referrerPolicy)), errors.wrap('supplied properties not correct for "ReferrerPolicyProperty"');
    }
    function cfnResponseHeadersPolicyReferrerPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResponseHeadersPolicy_ReferrerPolicyPropertyValidator(properties).assertSuccess(), { Override: cdk.booleanToCloudFormation(properties.override), ReferrerPolicy: cdk.stringToCloudFormation(properties.referrerPolicy) }) : properties;
    }
    function CfnResponseHeadersPolicyReferrerPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("override", "Override", cfn_parse.FromCloudFormation.getBoolean(properties.Override)), ret.addPropertyResult("referrerPolicy", "ReferrerPolicy", cfn_parse.FromCloudFormation.getString(properties.ReferrerPolicy)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResponseHeadersPolicy_RemoveHeaderPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("header", cdk.requiredValidator)(properties.header)), errors.collect(cdk.propertyValidator("header", cdk.validateString)(properties.header)), errors.wrap('supplied properties not correct for "RemoveHeaderProperty"');
    }
    function cfnResponseHeadersPolicyRemoveHeaderPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResponseHeadersPolicy_RemoveHeaderPropertyValidator(properties).assertSuccess(), { Header: cdk.stringToCloudFormation(properties.header) }) : properties;
    }
    function CfnResponseHeadersPolicyRemoveHeaderPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("header", "Header", cfn_parse.FromCloudFormation.getString(properties.Header)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResponseHeadersPolicy_RemoveHeadersConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("items", cdk.requiredValidator)(properties.items)), errors.collect(cdk.propertyValidator("items", cdk.listValidator(CfnResponseHeadersPolicy_RemoveHeaderPropertyValidator))(properties.items)), errors.wrap('supplied properties not correct for "RemoveHeadersConfigProperty"');
    }
    function cfnResponseHeadersPolicyRemoveHeadersConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResponseHeadersPolicy_RemoveHeadersConfigPropertyValidator(properties).assertSuccess(), { Items: cdk.listMapper(cfnResponseHeadersPolicyRemoveHeaderPropertyToCloudFormation)(properties.items) }) : properties;
    }
    function CfnResponseHeadersPolicyRemoveHeadersConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("items", "Items", cfn_parse.FromCloudFormation.getArray(CfnResponseHeadersPolicyRemoveHeaderPropertyFromCloudFormation)(properties.Items)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResponseHeadersPolicy_ResponseHeadersPolicyConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("comment", cdk.validateString)(properties.comment)), errors.collect(cdk.propertyValidator("corsConfig", CfnResponseHeadersPolicy_CorsConfigPropertyValidator)(properties.corsConfig)), errors.collect(cdk.propertyValidator("customHeadersConfig", CfnResponseHeadersPolicy_CustomHeadersConfigPropertyValidator)(properties.customHeadersConfig)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("removeHeadersConfig", CfnResponseHeadersPolicy_RemoveHeadersConfigPropertyValidator)(properties.removeHeadersConfig)), errors.collect(cdk.propertyValidator("securityHeadersConfig", CfnResponseHeadersPolicy_SecurityHeadersConfigPropertyValidator)(properties.securityHeadersConfig)), errors.collect(cdk.propertyValidator("serverTimingHeadersConfig", CfnResponseHeadersPolicy_ServerTimingHeadersConfigPropertyValidator)(properties.serverTimingHeadersConfig)), errors.wrap('supplied properties not correct for "ResponseHeadersPolicyConfigProperty"');
    }
    function cfnResponseHeadersPolicyResponseHeadersPolicyConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResponseHeadersPolicy_ResponseHeadersPolicyConfigPropertyValidator(properties).assertSuccess(), { Comment: cdk.stringToCloudFormation(properties.comment), CorsConfig: cfnResponseHeadersPolicyCorsConfigPropertyToCloudFormation(properties.corsConfig), CustomHeadersConfig: cfnResponseHeadersPolicyCustomHeadersConfigPropertyToCloudFormation(properties.customHeadersConfig), Name: cdk.stringToCloudFormation(properties.name), RemoveHeadersConfig: cfnResponseHeadersPolicyRemoveHeadersConfigPropertyToCloudFormation(properties.removeHeadersConfig), SecurityHeadersConfig: cfnResponseHeadersPolicySecurityHeadersConfigPropertyToCloudFormation(properties.securityHeadersConfig), ServerTimingHeadersConfig: cfnResponseHeadersPolicyServerTimingHeadersConfigPropertyToCloudFormation(properties.serverTimingHeadersConfig) }) : properties;
    }
    function CfnResponseHeadersPolicyResponseHeadersPolicyConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("comment", "Comment", properties.Comment != null ? cfn_parse.FromCloudFormation.getString(properties.Comment) : void 0), ret.addPropertyResult("corsConfig", "CorsConfig", properties.CorsConfig != null ? CfnResponseHeadersPolicyCorsConfigPropertyFromCloudFormation(properties.CorsConfig) : void 0), ret.addPropertyResult("customHeadersConfig", "CustomHeadersConfig", properties.CustomHeadersConfig != null ? CfnResponseHeadersPolicyCustomHeadersConfigPropertyFromCloudFormation(properties.CustomHeadersConfig) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("removeHeadersConfig", "RemoveHeadersConfig", properties.RemoveHeadersConfig != null ? CfnResponseHeadersPolicyRemoveHeadersConfigPropertyFromCloudFormation(properties.RemoveHeadersConfig) : void 0), ret.addPropertyResult("securityHeadersConfig", "SecurityHeadersConfig", properties.SecurityHeadersConfig != null ? CfnResponseHeadersPolicySecurityHeadersConfigPropertyFromCloudFormation(properties.SecurityHeadersConfig) : void 0), ret.addPropertyResult("serverTimingHeadersConfig", "ServerTimingHeadersConfig", properties.ServerTimingHeadersConfig != null ? CfnResponseHeadersPolicyServerTimingHeadersConfigPropertyFromCloudFormation(properties.ServerTimingHeadersConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResponseHeadersPolicy_SecurityHeadersConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contentSecurityPolicy", CfnResponseHeadersPolicy_ContentSecurityPolicyPropertyValidator)(properties.contentSecurityPolicy)), errors.collect(cdk.propertyValidator("contentTypeOptions", CfnResponseHeadersPolicy_ContentTypeOptionsPropertyValidator)(properties.contentTypeOptions)), errors.collect(cdk.propertyValidator("frameOptions", CfnResponseHeadersPolicy_FrameOptionsPropertyValidator)(properties.frameOptions)), errors.collect(cdk.propertyValidator("referrerPolicy", CfnResponseHeadersPolicy_ReferrerPolicyPropertyValidator)(properties.referrerPolicy)), errors.collect(cdk.propertyValidator("strictTransportSecurity", CfnResponseHeadersPolicy_StrictTransportSecurityPropertyValidator)(properties.strictTransportSecurity)), errors.collect(cdk.propertyValidator("xssProtection", CfnResponseHeadersPolicy_XSSProtectionPropertyValidator)(properties.xssProtection)), errors.wrap('supplied properties not correct for "SecurityHeadersConfigProperty"');
    }
    function cfnResponseHeadersPolicySecurityHeadersConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResponseHeadersPolicy_SecurityHeadersConfigPropertyValidator(properties).assertSuccess(), { ContentSecurityPolicy: cfnResponseHeadersPolicyContentSecurityPolicyPropertyToCloudFormation(properties.contentSecurityPolicy), ContentTypeOptions: cfnResponseHeadersPolicyContentTypeOptionsPropertyToCloudFormation(properties.contentTypeOptions), FrameOptions: cfnResponseHeadersPolicyFrameOptionsPropertyToCloudFormation(properties.frameOptions), ReferrerPolicy: cfnResponseHeadersPolicyReferrerPolicyPropertyToCloudFormation(properties.referrerPolicy), StrictTransportSecurity: cfnResponseHeadersPolicyStrictTransportSecurityPropertyToCloudFormation(properties.strictTransportSecurity), XSSProtection: cfnResponseHeadersPolicyXSSProtectionPropertyToCloudFormation(properties.xssProtection) }) : properties;
    }
    function CfnResponseHeadersPolicySecurityHeadersConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contentSecurityPolicy", "ContentSecurityPolicy", properties.ContentSecurityPolicy != null ? CfnResponseHeadersPolicyContentSecurityPolicyPropertyFromCloudFormation(properties.ContentSecurityPolicy) : void 0), ret.addPropertyResult("contentTypeOptions", "ContentTypeOptions", properties.ContentTypeOptions != null ? CfnResponseHeadersPolicyContentTypeOptionsPropertyFromCloudFormation(properties.ContentTypeOptions) : void 0), ret.addPropertyResult("frameOptions", "FrameOptions", properties.FrameOptions != null ? CfnResponseHeadersPolicyFrameOptionsPropertyFromCloudFormation(properties.FrameOptions) : void 0), ret.addPropertyResult("referrerPolicy", "ReferrerPolicy", properties.ReferrerPolicy != null ? CfnResponseHeadersPolicyReferrerPolicyPropertyFromCloudFormation(properties.ReferrerPolicy) : void 0), ret.addPropertyResult("strictTransportSecurity", "StrictTransportSecurity", properties.StrictTransportSecurity != null ? CfnResponseHeadersPolicyStrictTransportSecurityPropertyFromCloudFormation(properties.StrictTransportSecurity) : void 0), ret.addPropertyResult("xssProtection", "XSSProtection", properties.XSSProtection != null ? CfnResponseHeadersPolicyXSSProtectionPropertyFromCloudFormation(properties.XSSProtection) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResponseHeadersPolicy_ServerTimingHeadersConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("samplingRate", cdk.validateNumber)(properties.samplingRate)), errors.wrap('supplied properties not correct for "ServerTimingHeadersConfigProperty"');
    }
    function cfnResponseHeadersPolicyServerTimingHeadersConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResponseHeadersPolicy_ServerTimingHeadersConfigPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled), SamplingRate: cdk.numberToCloudFormation(properties.samplingRate) }) : properties;
    }
    function CfnResponseHeadersPolicyServerTimingHeadersConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addPropertyResult("samplingRate", "SamplingRate", properties.SamplingRate != null ? cfn_parse.FromCloudFormation.getNumber(properties.SamplingRate) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResponseHeadersPolicy_StrictTransportSecurityPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessControlMaxAgeSec", cdk.requiredValidator)(properties.accessControlMaxAgeSec)), errors.collect(cdk.propertyValidator("accessControlMaxAgeSec", cdk.validateNumber)(properties.accessControlMaxAgeSec)), errors.collect(cdk.propertyValidator("includeSubdomains", cdk.validateBoolean)(properties.includeSubdomains)), errors.collect(cdk.propertyValidator("override", cdk.requiredValidator)(properties.override)), errors.collect(cdk.propertyValidator("override", cdk.validateBoolean)(properties.override)), errors.collect(cdk.propertyValidator("preload", cdk.validateBoolean)(properties.preload)), errors.wrap('supplied properties not correct for "StrictTransportSecurityProperty"');
    }
    function cfnResponseHeadersPolicyStrictTransportSecurityPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResponseHeadersPolicy_StrictTransportSecurityPropertyValidator(properties).assertSuccess(), { AccessControlMaxAgeSec: cdk.numberToCloudFormation(properties.accessControlMaxAgeSec), IncludeSubdomains: cdk.booleanToCloudFormation(properties.includeSubdomains), Override: cdk.booleanToCloudFormation(properties.override), Preload: cdk.booleanToCloudFormation(properties.preload) }) : properties;
    }
    function CfnResponseHeadersPolicyStrictTransportSecurityPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessControlMaxAgeSec", "AccessControlMaxAgeSec", cfn_parse.FromCloudFormation.getNumber(properties.AccessControlMaxAgeSec)), ret.addPropertyResult("includeSubdomains", "IncludeSubdomains", properties.IncludeSubdomains != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeSubdomains) : void 0), ret.addPropertyResult("override", "Override", cfn_parse.FromCloudFormation.getBoolean(properties.Override)), ret.addPropertyResult("preload", "Preload", properties.Preload != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Preload) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResponseHeadersPolicy_XSSProtectionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("modeBlock", cdk.validateBoolean)(properties.modeBlock)), errors.collect(cdk.propertyValidator("override", cdk.requiredValidator)(properties.override)), errors.collect(cdk.propertyValidator("override", cdk.validateBoolean)(properties.override)), errors.collect(cdk.propertyValidator("protection", cdk.requiredValidator)(properties.protection)), errors.collect(cdk.propertyValidator("protection", cdk.validateBoolean)(properties.protection)), errors.collect(cdk.propertyValidator("reportUri", cdk.validateString)(properties.reportUri)), errors.wrap('supplied properties not correct for "XSSProtectionProperty"');
    }
    function cfnResponseHeadersPolicyXSSProtectionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResponseHeadersPolicy_XSSProtectionPropertyValidator(properties).assertSuccess(), { ModeBlock: cdk.booleanToCloudFormation(properties.modeBlock), Override: cdk.booleanToCloudFormation(properties.override), Protection: cdk.booleanToCloudFormation(properties.protection), ReportUri: cdk.stringToCloudFormation(properties.reportUri) }) : properties;
    }
    function CfnResponseHeadersPolicyXSSProtectionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("modeBlock", "ModeBlock", properties.ModeBlock != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ModeBlock) : void 0), ret.addPropertyResult("override", "Override", cfn_parse.FromCloudFormation.getBoolean(properties.Override)), ret.addPropertyResult("protection", "Protection", cfn_parse.FromCloudFormation.getBoolean(properties.Protection)), ret.addPropertyResult("reportUri", "ReportUri", properties.ReportUri != null ? cfn_parse.FromCloudFormation.getString(properties.ReportUri) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStreamingDistributionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("streamingDistributionConfig", cdk.requiredValidator)(properties.streamingDistributionConfig)), errors.collect(cdk.propertyValidator("streamingDistributionConfig", CfnStreamingDistribution_StreamingDistributionConfigPropertyValidator)(properties.streamingDistributionConfig)), errors.collect(cdk.propertyValidator("tags", cdk.requiredValidator)(properties.tags)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnStreamingDistributionProps"');
    }
    function cfnStreamingDistributionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStreamingDistributionPropsValidator(properties).assertSuccess(), { StreamingDistributionConfig: cfnStreamingDistributionStreamingDistributionConfigPropertyToCloudFormation(properties.streamingDistributionConfig), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnStreamingDistributionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("streamingDistributionConfig", "StreamingDistributionConfig", CfnStreamingDistributionStreamingDistributionConfigPropertyFromCloudFormation(properties.StreamingDistributionConfig)), ret.addPropertyResult("tags", "Tags", cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnStreamingDistribution = class _CfnStreamingDistribution extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnStreamingDistributionPropsFromCloudFormation(resourceProperties), ret = new _CfnStreamingDistribution(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnStreamingDistribution.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_CfnStreamingDistributionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnStreamingDistribution), error;
        }
        cdk.requireProperty(props, "streamingDistributionConfig", this), cdk.requireProperty(props, "tags", this), this.attrDomainName = cdk.Token.asString(this.getAtt("DomainName", cdk.ResolutionTypeHint.STRING)), this.streamingDistributionConfig = props.streamingDistributionConfig, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::CloudFront::StreamingDistribution", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStreamingDistribution.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { streamingDistributionConfig: this.streamingDistributionConfig, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnStreamingDistributionPropsToCloudFormation(props);
      }
    };
    _o = JSII_RTTI_SYMBOL_1, CfnStreamingDistribution[_o] = { fqn: "aws-cdk-lib.aws_cloudfront.CfnStreamingDistribution", version: "2.80.0" }, CfnStreamingDistribution.CFN_RESOURCE_TYPE_NAME = "AWS::CloudFront::StreamingDistribution", exports2.CfnStreamingDistribution = CfnStreamingDistribution;
    function CfnStreamingDistribution_LoggingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.requiredValidator)(properties.bucket)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("prefix", cdk.requiredValidator)(properties.prefix)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.wrap('supplied properties not correct for "LoggingProperty"');
    }
    function cfnStreamingDistributionLoggingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStreamingDistribution_LoggingPropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), Enabled: cdk.booleanToCloudFormation(properties.enabled), Prefix: cdk.stringToCloudFormation(properties.prefix) }) : properties;
    }
    function CfnStreamingDistributionLoggingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", cfn_parse.FromCloudFormation.getString(properties.Bucket)), ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addPropertyResult("prefix", "Prefix", cfn_parse.FromCloudFormation.getString(properties.Prefix)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStreamingDistribution_S3OriginPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("domainName", cdk.requiredValidator)(properties.domainName)), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.collect(cdk.propertyValidator("originAccessIdentity", cdk.requiredValidator)(properties.originAccessIdentity)), errors.collect(cdk.propertyValidator("originAccessIdentity", cdk.validateString)(properties.originAccessIdentity)), errors.wrap('supplied properties not correct for "S3OriginProperty"');
    }
    function cfnStreamingDistributionS3OriginPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStreamingDistribution_S3OriginPropertyValidator(properties).assertSuccess(), { DomainName: cdk.stringToCloudFormation(properties.domainName), OriginAccessIdentity: cdk.stringToCloudFormation(properties.originAccessIdentity) }) : properties;
    }
    function CfnStreamingDistributionS3OriginPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("domainName", "DomainName", cfn_parse.FromCloudFormation.getString(properties.DomainName)), ret.addPropertyResult("originAccessIdentity", "OriginAccessIdentity", cfn_parse.FromCloudFormation.getString(properties.OriginAccessIdentity)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStreamingDistribution_StreamingDistributionConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aliases", cdk.listValidator(cdk.validateString))(properties.aliases)), errors.collect(cdk.propertyValidator("comment", cdk.requiredValidator)(properties.comment)), errors.collect(cdk.propertyValidator("comment", cdk.validateString)(properties.comment)), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("logging", CfnStreamingDistribution_LoggingPropertyValidator)(properties.logging)), errors.collect(cdk.propertyValidator("priceClass", cdk.validateString)(properties.priceClass)), errors.collect(cdk.propertyValidator("s3Origin", cdk.requiredValidator)(properties.s3Origin)), errors.collect(cdk.propertyValidator("s3Origin", CfnStreamingDistribution_S3OriginPropertyValidator)(properties.s3Origin)), errors.collect(cdk.propertyValidator("trustedSigners", cdk.requiredValidator)(properties.trustedSigners)), errors.collect(cdk.propertyValidator("trustedSigners", CfnStreamingDistribution_TrustedSignersPropertyValidator)(properties.trustedSigners)), errors.wrap('supplied properties not correct for "StreamingDistributionConfigProperty"');
    }
    function cfnStreamingDistributionStreamingDistributionConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStreamingDistribution_StreamingDistributionConfigPropertyValidator(properties).assertSuccess(), { Aliases: cdk.listMapper(cdk.stringToCloudFormation)(properties.aliases), Comment: cdk.stringToCloudFormation(properties.comment), Enabled: cdk.booleanToCloudFormation(properties.enabled), Logging: cfnStreamingDistributionLoggingPropertyToCloudFormation(properties.logging), PriceClass: cdk.stringToCloudFormation(properties.priceClass), S3Origin: cfnStreamingDistributionS3OriginPropertyToCloudFormation(properties.s3Origin), TrustedSigners: cfnStreamingDistributionTrustedSignersPropertyToCloudFormation(properties.trustedSigners) }) : properties;
    }
    function CfnStreamingDistributionStreamingDistributionConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aliases", "Aliases", properties.Aliases != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Aliases) : void 0), ret.addPropertyResult("comment", "Comment", cfn_parse.FromCloudFormation.getString(properties.Comment)), ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addPropertyResult("logging", "Logging", properties.Logging != null ? CfnStreamingDistributionLoggingPropertyFromCloudFormation(properties.Logging) : void 0), ret.addPropertyResult("priceClass", "PriceClass", properties.PriceClass != null ? cfn_parse.FromCloudFormation.getString(properties.PriceClass) : void 0), ret.addPropertyResult("s3Origin", "S3Origin", CfnStreamingDistributionS3OriginPropertyFromCloudFormation(properties.S3Origin)), ret.addPropertyResult("trustedSigners", "TrustedSigners", CfnStreamingDistributionTrustedSignersPropertyFromCloudFormation(properties.TrustedSigners)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStreamingDistribution_TrustedSignersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("awsAccountNumbers", cdk.listValidator(cdk.validateString))(properties.awsAccountNumbers)), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "TrustedSignersProperty"');
    }
    function cfnStreamingDistributionTrustedSignersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStreamingDistribution_TrustedSignersPropertyValidator(properties).assertSuccess(), { AwsAccountNumbers: cdk.listMapper(cdk.stringToCloudFormation)(properties.awsAccountNumbers), Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnStreamingDistributionTrustedSignersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("awsAccountNumbers", "AwsAccountNumbers", properties.AwsAccountNumbers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AwsAccountNumbers) : void 0), ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-cloudfront/lib/cache-policy.js
var require_cache_policy = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudfront/lib/cache-policy.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CacheQueryStringBehavior = exports2.CacheHeaderBehavior = exports2.CacheCookieBehavior = exports2.CachePolicy = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cloudfront_generated_1 = require_cloudfront_generated();
    var core_1 = require_core2();
    var CachePolicy = class _CachePolicy extends core_1.Resource {
      static fromCachePolicyId(scope, id, cachePolicyId) {
        return new class extends core_1.Resource {
          constructor() {
            super(...arguments), this.cachePolicyId = cachePolicyId;
          }
        }(scope, id);
      }
      static fromManagedCachePolicy(managedCachePolicyId) {
        return new class {
          constructor() {
            this.cachePolicyId = managedCachePolicyId;
          }
        }();
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.cachePolicyName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_CachePolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CachePolicy), error;
        }
        const cachePolicyName = props.cachePolicyName ?? `${core_1.Names.uniqueId(this).slice(0, 110)}-${core_1.Stack.of(this).region}`;
        if (!core_1.Token.isUnresolved(cachePolicyName) && !cachePolicyName.match(/^[\w-]+$/i))
          throw new Error(`'cachePolicyName' can only include '-', '_', and alphanumeric characters, got: '${cachePolicyName}'`);
        if (cachePolicyName.length > 128)
          throw new Error(`'cachePolicyName' cannot be longer than 128 characters, got: '${cachePolicyName.length}'`);
        const minTtl = (props.minTtl ?? core_1.Duration.seconds(0)).toSeconds(), defaultTtl = Math.max((props.defaultTtl ?? core_1.Duration.days(1)).toSeconds(), minTtl), maxTtl = Math.max((props.maxTtl ?? core_1.Duration.days(365)).toSeconds(), defaultTtl), resource = new cloudfront_generated_1.CfnCachePolicy(this, "Resource", { cachePolicyConfig: { name: cachePolicyName, comment: props.comment, minTtl, maxTtl, defaultTtl, parametersInCacheKeyAndForwardedToOrigin: this.renderCacheKey(props) } });
        this.cachePolicyId = resource.ref;
      }
      renderCacheKey(props) {
        const cookies = props.cookieBehavior ?? CacheCookieBehavior.none(), headers = props.headerBehavior ?? CacheHeaderBehavior.none(), queryStrings = props.queryStringBehavior ?? CacheQueryStringBehavior.none();
        return { cookiesConfig: { cookieBehavior: cookies.behavior, cookies: cookies.cookies }, headersConfig: { headerBehavior: headers.behavior, headers: headers.headers }, enableAcceptEncodingGzip: props.enableAcceptEncodingGzip ?? false, enableAcceptEncodingBrotli: props.enableAcceptEncodingBrotli ?? false, queryStringsConfig: { queryStringBehavior: queryStrings.behavior, queryStrings: queryStrings.queryStrings } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CachePolicy[_a] = { fqn: "aws-cdk-lib.aws_cloudfront.CachePolicy", version: "2.80.0" }, CachePolicy.AMPLIFY = CachePolicy.fromManagedCachePolicy("2e54312d-136d-493c-8eb9-b001f22f67d2"), CachePolicy.CACHING_OPTIMIZED = CachePolicy.fromManagedCachePolicy("658327ea-f89d-4fab-a63d-7e88639e58f6"), CachePolicy.CACHING_OPTIMIZED_FOR_UNCOMPRESSED_OBJECTS = CachePolicy.fromManagedCachePolicy("b2884449-e4de-46a7-ac36-70bc7f1ddd6d"), CachePolicy.CACHING_DISABLED = CachePolicy.fromManagedCachePolicy("4135ea2d-6df8-44a3-9df3-4b5a84be39ad"), CachePolicy.ELEMENTAL_MEDIA_PACKAGE = CachePolicy.fromManagedCachePolicy("08627262-05a9-4f76-9ded-b50ca2e3a84f"), exports2.CachePolicy = CachePolicy;
    var CacheCookieBehavior = class _CacheCookieBehavior {
      static none() {
        return new _CacheCookieBehavior("none");
      }
      static all() {
        return new _CacheCookieBehavior("all");
      }
      static allowList(...cookies) {
        if (cookies.length === 0)
          throw new Error("At least one cookie to allow must be provided");
        return new _CacheCookieBehavior("whitelist", cookies);
      }
      static denyList(...cookies) {
        if (cookies.length === 0)
          throw new Error("At least one cookie to deny must be provided");
        return new _CacheCookieBehavior("allExcept", cookies);
      }
      constructor(behavior, cookies) {
        this.behavior = behavior, this.cookies = cookies;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CacheCookieBehavior[_b] = { fqn: "aws-cdk-lib.aws_cloudfront.CacheCookieBehavior", version: "2.80.0" }, exports2.CacheCookieBehavior = CacheCookieBehavior;
    var CacheHeaderBehavior = class _CacheHeaderBehavior {
      static none() {
        return new _CacheHeaderBehavior("none");
      }
      static allowList(...headers) {
        if (headers.length === 0)
          throw new Error("At least one header to allow must be provided");
        return new _CacheHeaderBehavior("whitelist", headers);
      }
      constructor(behavior, headers) {
        this.behavior = behavior, this.headers = headers;
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CacheHeaderBehavior[_c] = { fqn: "aws-cdk-lib.aws_cloudfront.CacheHeaderBehavior", version: "2.80.0" }, exports2.CacheHeaderBehavior = CacheHeaderBehavior;
    var CacheQueryStringBehavior = class _CacheQueryStringBehavior {
      static none() {
        return new _CacheQueryStringBehavior("none");
      }
      static all() {
        return new _CacheQueryStringBehavior("all");
      }
      static allowList(...queryStrings) {
        if (queryStrings.length === 0)
          throw new Error("At least one query string to allow must be provided");
        return new _CacheQueryStringBehavior("whitelist", queryStrings);
      }
      static denyList(...queryStrings) {
        if (queryStrings.length === 0)
          throw new Error("At least one query string to deny must be provided");
        return new _CacheQueryStringBehavior("allExcept", queryStrings);
      }
      constructor(behavior, queryStrings) {
        this.behavior = behavior, this.queryStrings = queryStrings;
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CacheQueryStringBehavior[_d] = { fqn: "aws-cdk-lib.aws_cloudfront.CacheQueryStringBehavior", version: "2.80.0" }, exports2.CacheQueryStringBehavior = CacheQueryStringBehavior;
  }
});

// node_modules/aws-cdk-lib/aws-cloudfront/lib/private/cache-behavior.js
var require_cache_behavior = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudfront/lib/private/cache-behavior.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CacheBehavior = void 0;
    var iam = require_aws_iam();
    var cache_policy_1 = require_cache_policy();
    var distribution_1 = require_distribution();
    var CacheBehavior = class {
      constructor(originId, props) {
        this.props = props, this.originId = originId, this.validateEdgeLambdas(props.edgeLambdas), this.grantEdgeLambdaFunctionExecutionRole(props.edgeLambdas);
      }
      _renderBehavior() {
        return { pathPattern: this.props.pathPattern, targetOriginId: this.originId, allowedMethods: this.props.allowedMethods?.methods, cachedMethods: this.props.cachedMethods?.methods, cachePolicyId: (this.props.cachePolicy ?? cache_policy_1.CachePolicy.CACHING_OPTIMIZED).cachePolicyId, compress: this.props.compress ?? true, originRequestPolicyId: this.props.originRequestPolicy?.originRequestPolicyId, responseHeadersPolicyId: this.props.responseHeadersPolicy?.responseHeadersPolicyId, smoothStreaming: this.props.smoothStreaming, viewerProtocolPolicy: this.props.viewerProtocolPolicy ?? distribution_1.ViewerProtocolPolicy.ALLOW_ALL, functionAssociations: this.props.functionAssociations?.map((association) => ({ functionArn: association.function.functionArn, eventType: association.eventType.toString() })), lambdaFunctionAssociations: this.props.edgeLambdas?.map((edgeLambda) => ({ lambdaFunctionArn: edgeLambda.functionVersion.edgeArn, eventType: edgeLambda.eventType.toString(), includeBody: edgeLambda.includeBody })), trustedKeyGroups: this.props.trustedKeyGroups?.map((keyGroup) => keyGroup.keyGroupId) };
      }
      validateEdgeLambdas(edgeLambdas) {
        const includeBodyEventTypes = [distribution_1.LambdaEdgeEventType.ORIGIN_REQUEST, distribution_1.LambdaEdgeEventType.VIEWER_REQUEST];
        if (edgeLambdas && edgeLambdas.some((lambda2) => lambda2.includeBody && !includeBodyEventTypes.includes(lambda2.eventType)))
          throw new Error("'includeBody' can only be true for ORIGIN_REQUEST or VIEWER_REQUEST event types.");
      }
      grantEdgeLambdaFunctionExecutionRole(edgeLambdas) {
        !edgeLambdas || edgeLambdas.length === 0 || edgeLambdas.forEach((edgeLambda) => {
          const role = edgeLambda.functionVersion.role;
          role && iam.Role.isRole(role) && role.assumeRolePolicy && role.assumeRolePolicy.addStatements(new iam.PolicyStatement({ actions: ["sts:AssumeRole"], principals: [new iam.ServicePrincipal("edgelambda.amazonaws.com")] }));
        });
      }
    };
    exports2.CacheBehavior = CacheBehavior;
  }
});

// node_modules/aws-cdk-lib/aws-cloudfront/lib/private/utils.js
var require_utils10 = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudfront/lib/private/utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.formatDistributionArn = void 0;
    var core_1 = require_core2();
    function formatDistributionArn(dist) {
      return core_1.Stack.of(dist).formatArn({ service: "cloudfront", region: "", resource: "distribution", resourceName: dist.distributionId });
    }
    exports2.formatDistributionArn = formatDistributionArn;
  }
});

// node_modules/aws-cdk-lib/aws-cloudfront/lib/distribution.js
var require_distribution = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudfront/lib/distribution.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LambdaEdgeEventType = exports2.CachedMethods = exports2.AllowedMethods = exports2.SecurityPolicyProtocol = exports2.SSLMethod = exports2.OriginProtocolPolicy = exports2.ViewerProtocolPolicy = exports2.PriceClass = exports2.HttpVersion = exports2.Distribution = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var cloudfront_generated_1 = require_cloudfront_generated();
    var cache_behavior_1 = require_cache_behavior();
    var utils_1 = require_utils10();
    var iam = require_aws_iam();
    var s3 = require_aws_s3();
    var core_1 = require_core2();
    var cx_api_1 = require_cx_api();
    var Distribution = class _Distribution extends core_1.Resource {
      static fromDistributionAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_DistributionAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromDistributionAttributes), error;
        }
        return new class extends core_1.Resource {
          constructor() {
            super(scope, id), this.domainName = attrs.domainName, this.distributionDomainName = attrs.domainName, this.distributionId = attrs.distributionId;
          }
          grant(grantee, ...actions) {
            return iam.Grant.addToPrincipal({ grantee, actions, resourceArns: [(0, utils_1.formatDistributionArn)(this)] });
          }
          grantCreateInvalidation(grantee) {
            return this.grant(grantee, "cloudfront:CreateInvalidation");
          }
        }();
      }
      constructor(scope, id, props) {
        super(scope, id), this.additionalBehaviors = [], this.boundOrigins = [], this.originGroups = [];
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_DistributionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Distribution), error;
        }
        if (props.certificate) {
          const certificateRegion = core_1.Stack.of(this).splitArn(props.certificate.certificateArn, core_1.ArnFormat.SLASH_RESOURCE_NAME).region;
          if (!core_1.Token.isUnresolved(certificateRegion) && certificateRegion !== "us-east-1")
            throw new Error(`Distribution certificates must be in the us-east-1 region and the certificate you provided is in ${certificateRegion}.`);
          if ((props.domainNames ?? []).length === 0)
            throw new Error("Must specify at least one domain name to use a certificate with a distribution");
        }
        const originId = this.addOrigin(props.defaultBehavior.origin);
        this.defaultBehavior = new cache_behavior_1.CacheBehavior(originId, { pathPattern: "*", ...props.defaultBehavior }), props.additionalBehaviors && Object.entries(props.additionalBehaviors).forEach(([pathPattern, behaviorOptions]) => {
          this.addBehavior(pathPattern, behaviorOptions.origin, behaviorOptions);
        }), this.certificate = props.certificate, this.errorResponses = props.errorResponses ?? [];
        const trimmedComment = props.comment && props.comment.length > 128 ? `${props.comment.slice(0, 128 - 3)}...` : props.comment, distribution = new cloudfront_generated_1.CfnDistribution(this, "Resource", { distributionConfig: { enabled: props.enabled ?? true, origins: core_1.Lazy.any({ produce: () => this.renderOrigins() }), originGroups: core_1.Lazy.any({ produce: () => this.renderOriginGroups() }), defaultCacheBehavior: this.defaultBehavior._renderBehavior(), aliases: props.domainNames, cacheBehaviors: core_1.Lazy.any({ produce: () => this.renderCacheBehaviors() }), comment: trimmedComment, customErrorResponses: this.renderErrorResponses(), defaultRootObject: props.defaultRootObject, httpVersion: props.httpVersion ?? HttpVersion.HTTP2, ipv6Enabled: props.enableIpv6 ?? true, logging: this.renderLogging(props), priceClass: props.priceClass ?? void 0, restrictions: this.renderRestrictions(props.geoRestriction), viewerCertificate: this.certificate ? this.renderViewerCertificate(this.certificate, props.minimumProtocolVersion, props.sslSupportMethod) : void 0, webAclId: props.webAclId } });
        this.domainName = distribution.attrDomainName, this.distributionDomainName = distribution.attrDomainName, this.distributionId = distribution.ref;
      }
      addBehavior(pathPattern, origin, behaviorOptions = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_IOrigin(origin), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_AddBehaviorOptions(behaviorOptions);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addBehavior), error;
        }
        if (pathPattern === "*")
          throw new Error("Only the default behavior can have a path pattern of '*'");
        const originId = this.addOrigin(origin);
        this.additionalBehaviors.push(new cache_behavior_1.CacheBehavior(originId, { pathPattern, ...behaviorOptions }));
      }
      grant(identity, ...actions) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(identity);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grant), error;
        }
        return iam.Grant.addToPrincipal({ grantee: identity, actions, resourceArns: [(0, utils_1.formatDistributionArn)(this)] });
      }
      grantCreateInvalidation(identity) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(identity);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantCreateInvalidation), error;
        }
        return this.grant(identity, "cloudfront:CreateInvalidation");
      }
      addOrigin(origin, isFailoverOrigin = false) {
        const existingOrigin = this.boundOrigins.find((boundOrigin) => boundOrigin.origin === origin);
        if (existingOrigin)
          return existingOrigin.originGroupId ?? existingOrigin.originId;
        {
          const originIndex = this.boundOrigins.length + 1, scope = new constructs_1.Construct(this, `Origin${originIndex}`), generatedId = core_1.Names.uniqueId(scope).slice(-128), originBindConfig = origin.bind(scope, { originId: generatedId }), originId = originBindConfig.originProperty?.id ?? generatedId, duplicateId = this.boundOrigins.find((boundOrigin) => boundOrigin.originProperty?.id === originBindConfig.originProperty?.id);
          if (duplicateId)
            throw new Error(`Origin with id ${duplicateId.originProperty?.id} already exists. OriginIds must be unique within a distribution`);
          if (!originBindConfig.failoverConfig)
            this.boundOrigins.push({ origin, originId, ...originBindConfig });
          else {
            if (isFailoverOrigin)
              throw new Error("An Origin cannot use an Origin with its own failover configuration as its fallback origin!");
            const groupIndex = this.originGroups.length + 1, originGroupId = core_1.Names.uniqueId(new constructs_1.Construct(this, `OriginGroup${groupIndex}`)).slice(-128);
            this.boundOrigins.push({ origin, originId, originGroupId, ...originBindConfig });
            const failoverOriginId = this.addOrigin(originBindConfig.failoverConfig.failoverOrigin, true);
            return this.addOriginGroup(originGroupId, originBindConfig.failoverConfig.statusCodes, originId, failoverOriginId), originGroupId;
          }
          return originBindConfig.originProperty?.id ?? originId;
        }
      }
      addOriginGroup(originGroupId, statusCodes, originId, failoverOriginId) {
        if (statusCodes = statusCodes ?? [500, 502, 503, 504], statusCodes.length === 0)
          throw new Error("fallbackStatusCodes cannot be empty");
        this.originGroups.push({ failoverCriteria: { statusCodes: { items: statusCodes, quantity: statusCodes.length } }, id: originGroupId, members: { items: [{ originId }, { originId: failoverOriginId }], quantity: 2 } });
      }
      renderOrigins() {
        const renderedOrigins = [];
        return this.boundOrigins.forEach((boundOrigin) => {
          boundOrigin.originProperty && renderedOrigins.push(boundOrigin.originProperty);
        }), renderedOrigins;
      }
      renderOriginGroups() {
        return this.originGroups.length === 0 ? void 0 : { items: this.originGroups, quantity: this.originGroups.length };
      }
      renderCacheBehaviors() {
        if (this.additionalBehaviors.length !== 0)
          return this.additionalBehaviors.map((behavior) => behavior._renderBehavior());
      }
      renderErrorResponses() {
        if (this.errorResponses.length !== 0)
          return this.errorResponses.map((errorConfig) => {
            if (!errorConfig.responseHttpStatus && !errorConfig.ttl && !errorConfig.responsePagePath)
              throw new Error("A custom error response without either a 'responseHttpStatus', 'ttl' or 'responsePagePath' is not valid.");
            return { errorCachingMinTtl: errorConfig.ttl?.toSeconds(), errorCode: errorConfig.httpStatus, responseCode: errorConfig.responsePagePath ? errorConfig.responseHttpStatus ?? errorConfig.httpStatus : errorConfig.responseHttpStatus, responsePagePath: errorConfig.responsePagePath };
          });
      }
      renderLogging(props) {
        if (!props.enableLogging && !props.logBucket)
          return;
        if (props.enableLogging === false && props.logBucket)
          throw new Error("Explicitly disabled logging but provided a logging bucket.");
        return { bucket: (props.logBucket ?? new s3.Bucket(this, "LoggingBucket", { encryption: s3.BucketEncryption.S3_MANAGED, objectOwnership: s3.ObjectOwnership.OBJECT_WRITER })).bucketRegionalDomainName, includeCookies: props.logIncludesCookies, prefix: props.logFilePrefix };
      }
      renderRestrictions(geoRestriction) {
        return geoRestriction ? { geoRestriction: { restrictionType: geoRestriction.restrictionType, locations: geoRestriction.locations } } : void 0;
      }
      renderViewerCertificate(certificate, minimumProtocolVersionProp, sslSupportMethodProp) {
        const defaultVersion = core_1.FeatureFlags.of(this).isEnabled(cx_api_1.CLOUDFRONT_DEFAULT_SECURITY_POLICY_TLS_V1_2_2021) ? SecurityPolicyProtocol.TLS_V1_2_2021 : SecurityPolicyProtocol.TLS_V1_2_2019, minimumProtocolVersion = minimumProtocolVersionProp ?? defaultVersion, sslSupportMethod = sslSupportMethodProp ?? SSLMethod.SNI;
        return { acmCertificateArn: certificate.certificateArn, minimumProtocolVersion, sslSupportMethod };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Distribution[_a] = { fqn: "aws-cdk-lib.aws_cloudfront.Distribution", version: "2.80.0" }, exports2.Distribution = Distribution;
    var HttpVersion;
    (function(HttpVersion2) {
      HttpVersion2.HTTP1_1 = "http1.1", HttpVersion2.HTTP2 = "http2", HttpVersion2.HTTP2_AND_3 = "http2and3", HttpVersion2.HTTP3 = "http3";
    })(HttpVersion = exports2.HttpVersion || (exports2.HttpVersion = {}));
    var PriceClass;
    (function(PriceClass2) {
      PriceClass2.PRICE_CLASS_100 = "PriceClass_100", PriceClass2.PRICE_CLASS_200 = "PriceClass_200", PriceClass2.PRICE_CLASS_ALL = "PriceClass_All";
    })(PriceClass = exports2.PriceClass || (exports2.PriceClass = {}));
    var ViewerProtocolPolicy;
    (function(ViewerProtocolPolicy2) {
      ViewerProtocolPolicy2.HTTPS_ONLY = "https-only", ViewerProtocolPolicy2.REDIRECT_TO_HTTPS = "redirect-to-https", ViewerProtocolPolicy2.ALLOW_ALL = "allow-all";
    })(ViewerProtocolPolicy = exports2.ViewerProtocolPolicy || (exports2.ViewerProtocolPolicy = {}));
    var OriginProtocolPolicy;
    (function(OriginProtocolPolicy2) {
      OriginProtocolPolicy2.HTTP_ONLY = "http-only", OriginProtocolPolicy2.MATCH_VIEWER = "match-viewer", OriginProtocolPolicy2.HTTPS_ONLY = "https-only";
    })(OriginProtocolPolicy = exports2.OriginProtocolPolicy || (exports2.OriginProtocolPolicy = {}));
    var SSLMethod;
    (function(SSLMethod2) {
      SSLMethod2.SNI = "sni-only", SSLMethod2.VIP = "vip";
    })(SSLMethod = exports2.SSLMethod || (exports2.SSLMethod = {}));
    var SecurityPolicyProtocol;
    (function(SecurityPolicyProtocol2) {
      SecurityPolicyProtocol2.SSL_V3 = "SSLv3", SecurityPolicyProtocol2.TLS_V1 = "TLSv1", SecurityPolicyProtocol2.TLS_V1_2016 = "TLSv1_2016", SecurityPolicyProtocol2.TLS_V1_1_2016 = "TLSv1.1_2016", SecurityPolicyProtocol2.TLS_V1_2_2018 = "TLSv1.2_2018", SecurityPolicyProtocol2.TLS_V1_2_2019 = "TLSv1.2_2019", SecurityPolicyProtocol2.TLS_V1_2_2021 = "TLSv1.2_2021";
    })(SecurityPolicyProtocol = exports2.SecurityPolicyProtocol || (exports2.SecurityPolicyProtocol = {}));
    var AllowedMethods = class {
      constructor(methods) {
        this.methods = methods;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, AllowedMethods[_b] = { fqn: "aws-cdk-lib.aws_cloudfront.AllowedMethods", version: "2.80.0" }, AllowedMethods.ALLOW_GET_HEAD = new AllowedMethods(["GET", "HEAD"]), AllowedMethods.ALLOW_GET_HEAD_OPTIONS = new AllowedMethods(["GET", "HEAD", "OPTIONS"]), AllowedMethods.ALLOW_ALL = new AllowedMethods(["GET", "HEAD", "OPTIONS", "PUT", "PATCH", "POST", "DELETE"]), exports2.AllowedMethods = AllowedMethods;
    var CachedMethods = class {
      constructor(methods) {
        this.methods = methods;
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CachedMethods[_c] = { fqn: "aws-cdk-lib.aws_cloudfront.CachedMethods", version: "2.80.0" }, CachedMethods.CACHE_GET_HEAD = new CachedMethods(["GET", "HEAD"]), CachedMethods.CACHE_GET_HEAD_OPTIONS = new CachedMethods(["GET", "HEAD", "OPTIONS"]), exports2.CachedMethods = CachedMethods;
    var LambdaEdgeEventType;
    (function(LambdaEdgeEventType2) {
      LambdaEdgeEventType2.ORIGIN_REQUEST = "origin-request", LambdaEdgeEventType2.ORIGIN_RESPONSE = "origin-response", LambdaEdgeEventType2.VIEWER_REQUEST = "viewer-request", LambdaEdgeEventType2.VIEWER_RESPONSE = "viewer-response";
    })(LambdaEdgeEventType = exports2.LambdaEdgeEventType || (exports2.LambdaEdgeEventType = {}));
  }
});

// node_modules/aws-cdk-lib/aws-cloudfront/lib/function.js
var require_function2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudfront/lib/function.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FunctionEventType = exports2.Function = exports2.FunctionCode = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var fs = require("fs");
    var cloudfront_generated_1 = require_cloudfront_generated();
    var core_1 = require_core2();
    var FunctionCode = class {
      static fromInline(code) {
        return new InlineCode(code);
      }
      static fromFile(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_FileCodeOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromFile), error;
        }
        return new FileCode(options);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, FunctionCode[_a] = { fqn: "aws-cdk-lib.aws_cloudfront.FunctionCode", version: "2.80.0" }, exports2.FunctionCode = FunctionCode;
    var InlineCode = class extends FunctionCode {
      constructor(code) {
        super(), this.code = code;
      }
      render() {
        return this.code;
      }
    };
    var FileCode = class extends FunctionCode {
      constructor(options) {
        super(), this.options = options;
      }
      render() {
        return fs.readFileSync(this.options.filePath, { encoding: "utf-8" });
      }
    };
    var Function3 = class _Function extends core_1.Resource {
      static fromFunctionAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_FunctionAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromFunctionAttributes), error;
        }
        return new class extends core_1.Resource {
          constructor() {
            super(...arguments), this.functionName = attrs.functionName, this.functionArn = attrs.functionArn;
          }
        }(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_FunctionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Function), error;
        }
        this.functionName = props.functionName ?? this.generateName();
        const resource = new cloudfront_generated_1.CfnFunction(this, "Resource", { autoPublish: true, functionCode: props.code.render(), functionConfig: { comment: props.comment ?? this.functionName, runtime: "cloudfront-js-1.0" }, name: this.functionName });
        this.functionArn = resource.attrFunctionArn, this.functionStage = resource.attrStage;
      }
      generateName() {
        const name = core_1.Stack.of(this).region + core_1.Names.uniqueId(this);
        return name.length > 64 ? name.substring(0, 32) + name.substring(name.length - 32) : name;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, Function3[_b] = { fqn: "aws-cdk-lib.aws_cloudfront.Function", version: "2.80.0" }, exports2.Function = Function3;
    var FunctionEventType;
    (function(FunctionEventType2) {
      FunctionEventType2.VIEWER_REQUEST = "viewer-request", FunctionEventType2.VIEWER_RESPONSE = "viewer-response";
    })(FunctionEventType = exports2.FunctionEventType || (exports2.FunctionEventType = {}));
  }
});

// node_modules/aws-cdk-lib/aws-cloudfront/lib/geo-restriction.js
var require_geo_restriction = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudfront/lib/geo-restriction.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.GeoRestriction = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var GeoRestriction = class _GeoRestriction {
      static allowlist(...locations) {
        return new _GeoRestriction("whitelist", _GeoRestriction.validateLocations(locations));
      }
      static denylist(...locations) {
        return new _GeoRestriction("blacklist", _GeoRestriction.validateLocations(locations));
      }
      static whitelist(...locations) {
        return _GeoRestriction.allowlist(...locations);
      }
      static blacklist(...locations) {
        return _GeoRestriction.denylist(...locations);
      }
      static validateLocations(locations) {
        if (locations.length === 0)
          throw new Error("Should provide at least 1 location");
        return locations.forEach((location) => {
          if (!_GeoRestriction.LOCATION_REGEX.test(location))
            throw new Error(`Invalid location format for location: ${location}, location should be two-letter and uppercase country ISO 3166-1-alpha-2 code`);
        }), locations;
      }
      constructor(restrictionType, locations) {
        this.restrictionType = restrictionType, this.locations = locations;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, GeoRestriction[_a] = { fqn: "aws-cdk-lib.aws_cloudfront.GeoRestriction", version: "2.80.0" }, GeoRestriction.LOCATION_REGEX = /^[A-Z]{2}$/, exports2.GeoRestriction = GeoRestriction;
  }
});

// node_modules/aws-cdk-lib/aws-cloudfront/lib/key-group.js
var require_key_group = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudfront/lib/key-group.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.KeyGroup = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cloudfront_generated_1 = require_cloudfront_generated();
    var core_1 = require_core2();
    var KeyGroup = class _KeyGroup extends core_1.Resource {
      static fromKeyGroupId(scope, id, keyGroupId) {
        return new class extends core_1.Resource {
          constructor() {
            super(...arguments), this.keyGroupId = keyGroupId;
          }
        }(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_KeyGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _KeyGroup), error;
        }
        const resource = new cloudfront_generated_1.CfnKeyGroup(this, "Resource", { keyGroupConfig: { name: props.keyGroupName ?? this.generateName(), comment: props.comment, items: props.items.map((key) => key.publicKeyId) } });
        this.keyGroupId = resource.ref;
      }
      generateName() {
        const name = core_1.Names.uniqueId(this);
        return name.length > 80 ? name.substring(0, 40) + name.substring(name.length - 40) : name;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, KeyGroup[_a] = { fqn: "aws-cdk-lib.aws_cloudfront.KeyGroup", version: "2.80.0" }, exports2.KeyGroup = KeyGroup;
  }
});

// node_modules/aws-cdk-lib/aws-cloudfront/lib/origin.js
var require_origin = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudfront/lib/origin.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.OriginBase = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core_1 = require_core2();
    var OriginBase = class _OriginBase {
      constructor(domainName, props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_OriginProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _OriginBase), error;
        }
        validateIntInRangeOrUndefined("connectionTimeout", 1, 10, props.connectionTimeout?.toSeconds()), validateIntInRangeOrUndefined("connectionAttempts", 1, 3, props.connectionAttempts, false), validateCustomHeaders(props.customHeaders), this.domainName = domainName, this.originPath = this.validateOriginPath(props.originPath), this.connectionTimeout = props.connectionTimeout, this.connectionAttempts = props.connectionAttempts, this.customHeaders = props.customHeaders, this.originShieldRegion = props.originShieldRegion, this.originId = props.originId, this.originShieldEnabled = props.originShieldEnabled ?? true;
      }
      bind(_scope, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_OriginBindOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        const s3OriginConfig = this.renderS3OriginConfig(), customOriginConfig = this.renderCustomOriginConfig();
        if (!s3OriginConfig && !customOriginConfig)
          throw new Error("Subclass must override and provide either s3OriginConfig or customOriginConfig");
        return { originProperty: { domainName: this.domainName, id: this.originId ?? options.originId, originPath: this.originPath, connectionAttempts: this.connectionAttempts, connectionTimeout: this.connectionTimeout?.toSeconds(), originCustomHeaders: this.renderCustomHeaders(), s3OriginConfig, customOriginConfig, originShield: this.renderOriginShield(this.originShieldEnabled, this.originShieldRegion) } };
      }
      renderS3OriginConfig() {
      }
      renderCustomOriginConfig() {
      }
      renderCustomHeaders() {
        if (!(!this.customHeaders || Object.entries(this.customHeaders).length === 0))
          return Object.entries(this.customHeaders).map(([headerName, headerValue]) => ({ headerName, headerValue }));
      }
      validateOriginPath(originPath) {
        if (core_1.Token.isUnresolved(originPath))
          return originPath;
        if (originPath === void 0)
          return;
        let path = originPath;
        return path.startsWith("/") || (path = "/" + path), path.endsWith("/") && (path = path.slice(0, -1)), path;
      }
      renderOriginShield(originShieldEnabled, originShieldRegion) {
        return originShieldEnabled ? originShieldRegion ? { enabled: true, originShieldRegion } : void 0 : { enabled: false };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, OriginBase[_a] = { fqn: "aws-cdk-lib.aws_cloudfront.OriginBase", version: "2.80.0" }, exports2.OriginBase = OriginBase;
    function validateIntInRangeOrUndefined(name, min, max, value, isDuration = true) {
      if (value !== void 0 && (!Number.isInteger(value) || value < min || value > max)) {
        const seconds = isDuration ? " seconds" : "";
        throw new Error(`${name}: Must be an int between ${min} and ${max}${seconds} (inclusive); received ${value}.`);
      }
    }
    function validateCustomHeaders(customHeaders) {
      if (!customHeaders || Object.entries(customHeaders).length === 0)
        return;
      const customHeaderKeys = Object.keys(customHeaders), prohibitedHeaderKeys = ["Cache-Control", "Connection", "Content-Length", "Cookie", "Host", "If-Match", "If-Modified-Since", "If-None-Match", "If-Range", "If-Unmodified-Since", "Max-Forwards", "Pragma", "Proxy-Authorization", "Proxy-Connection", "Range", "Request-Range", "TE", "Trailer", "Transfer-Encoding", "Upgrade", "Via", "X-Real-Ip"], prohibitedHeaderKeyPrefixes = ["X-Amz-", "X-Edge-"], prohibitedHeadersKeysMatches = customHeaderKeys.filter((customKey) => prohibitedHeaderKeys.map((prohibitedKey) => prohibitedKey.toLowerCase()).includes(customKey.toLowerCase())), prohibitedHeaderPrefixMatches = customHeaderKeys.filter((customKey) => prohibitedHeaderKeyPrefixes.some((prohibitedKeyPrefix) => customKey.toLowerCase().startsWith(prohibitedKeyPrefix.toLowerCase())));
      if (prohibitedHeadersKeysMatches.length !== 0)
        throw new Error(`The following headers cannot be configured as custom origin headers: ${prohibitedHeadersKeysMatches.join(", ")}`);
      if (prohibitedHeaderPrefixMatches.length !== 0)
        throw new Error(`The following headers cannot be used as prefixes for custom origin headers: ${prohibitedHeaderPrefixMatches.join(", ")}`);
    }
  }
});

// node_modules/aws-cdk-lib/aws-cloudfront/lib/origin-access-identity.js
var require_origin_access_identity = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudfront/lib/origin-access-identity.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.OriginAccessIdentity = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cloudfront_generated_1 = require_cloudfront_generated();
    var iam = require_aws_iam();
    var cdk = require_core2();
    var OriginAccessIdentityBase = class extends cdk.Resource {
      arn() {
        return cdk.Stack.of(this).formatArn({ service: "iam", region: "", account: "cloudfront", resource: "user", resourceName: `CloudFront Origin Access Identity ${this.originAccessIdentityId}` });
      }
    };
    var OriginAccessIdentity = class _OriginAccessIdentity extends OriginAccessIdentityBase {
      static fromOriginAccessIdentityName(scope, id, originAccessIdentityName) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_cloudfront.OriginAccessIdentity#fromOriginAccessIdentityName", "use `fromOriginAccessIdentityId`");
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromOriginAccessIdentityName), error;
        }
        return _OriginAccessIdentity.fromOriginAccessIdentityId(scope, id, originAccessIdentityName);
      }
      static fromOriginAccessIdentityId(scope, id, originAccessIdentityId) {
        class Import extends OriginAccessIdentityBase {
          constructor(s, i) {
            super(s, i, { physicalName: originAccessIdentityId }), this.originAccessIdentityId = originAccessIdentityId, this.originAccessIdentityName = originAccessIdentityId, this.grantPrincipal = new iam.ArnPrincipal(this.arn());
          }
        }
        return new Import(scope, id);
      }
      get originAccessIdentityName() {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_cloudfront.OriginAccessIdentity#originAccessIdentityName", "use originAccessIdentityId instead");
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, jsiiDeprecationWarnings.getPropertyDescriptor(this, "originAccessIdentityName").get), error;
        }
        return this.originAccessIdentityId;
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_OriginAccessIdentityProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _OriginAccessIdentity), error;
        }
        const comment = (props?.comment ?? "Allows CloudFront to reach the bucket").slice(0, 128);
        this.resource = new cloudfront_generated_1.CfnCloudFrontOriginAccessIdentity(this, "Resource", { cloudFrontOriginAccessIdentityConfig: { comment } }), this.originAccessIdentityId = this.getResourceNameAttribute(this.resource.ref), this.cloudFrontOriginAccessIdentityS3CanonicalUserId = this.resource.attrS3CanonicalUserId, this.grantPrincipal = new iam.CanonicalUserPrincipal(this.cloudFrontOriginAccessIdentityS3CanonicalUserId);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, OriginAccessIdentity[_a] = { fqn: "aws-cdk-lib.aws_cloudfront.OriginAccessIdentity", version: "2.80.0" }, exports2.OriginAccessIdentity = OriginAccessIdentity;
  }
});

// node_modules/aws-cdk-lib/aws-cloudfront/lib/origin-request-policy.js
var require_origin_request_policy = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudfront/lib/origin-request-policy.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.OriginRequestQueryStringBehavior = exports2.OriginRequestHeaderBehavior = exports2.OriginRequestCookieBehavior = exports2.OriginRequestPolicy = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cloudfront_generated_1 = require_cloudfront_generated();
    var core_1 = require_core2();
    var OriginRequestPolicy = class _OriginRequestPolicy extends core_1.Resource {
      static fromOriginRequestPolicyId(scope, id, originRequestPolicyId) {
        return new class extends core_1.Resource {
          constructor() {
            super(...arguments), this.originRequestPolicyId = originRequestPolicyId;
          }
        }(scope, id);
      }
      static fromManagedOriginRequestPolicy(managedOriginRequestPolicyId) {
        return new class {
          constructor() {
            this.originRequestPolicyId = managedOriginRequestPolicyId;
          }
        }();
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.originRequestPolicyName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_OriginRequestPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _OriginRequestPolicy), error;
        }
        const originRequestPolicyName = props.originRequestPolicyName ?? core_1.Names.uniqueId(this);
        if (!core_1.Token.isUnresolved(originRequestPolicyName) && !originRequestPolicyName.match(/^[\w-]+$/i))
          throw new Error(`'originRequestPolicyName' can only include '-', '_', and alphanumeric characters, got: '${props.originRequestPolicyName}'`);
        const cookies = props.cookieBehavior ?? OriginRequestCookieBehavior.none(), headers = props.headerBehavior ?? OriginRequestHeaderBehavior.none(), queryStrings = props.queryStringBehavior ?? OriginRequestQueryStringBehavior.none(), resource = new cloudfront_generated_1.CfnOriginRequestPolicy(this, "Resource", { originRequestPolicyConfig: { name: originRequestPolicyName, comment: props.comment, cookiesConfig: { cookieBehavior: cookies.behavior, cookies: cookies.cookies }, headersConfig: { headerBehavior: headers.behavior, headers: headers.headers }, queryStringsConfig: { queryStringBehavior: queryStrings.behavior, queryStrings: queryStrings.queryStrings } } });
        this.originRequestPolicyId = resource.ref;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, OriginRequestPolicy[_a] = { fqn: "aws-cdk-lib.aws_cloudfront.OriginRequestPolicy", version: "2.80.0" }, OriginRequestPolicy.USER_AGENT_REFERER_HEADERS = OriginRequestPolicy.fromManagedOriginRequestPolicy("acba4595-bd28-49b8-b9fe-13317c0390fa"), OriginRequestPolicy.CORS_CUSTOM_ORIGIN = OriginRequestPolicy.fromManagedOriginRequestPolicy("59781a5b-3903-41f3-afcb-af62929ccde1"), OriginRequestPolicy.CORS_S3_ORIGIN = OriginRequestPolicy.fromManagedOriginRequestPolicy("88a5eaf4-2fd4-4709-b370-b4c650ea3fcf"), OriginRequestPolicy.ALL_VIEWER = OriginRequestPolicy.fromManagedOriginRequestPolicy("216adef6-5c7f-47e4-b989-5492eafa07d3"), OriginRequestPolicy.ELEMENTAL_MEDIA_TAILOR = OriginRequestPolicy.fromManagedOriginRequestPolicy("775133bc-15f2-49f9-abea-afb2e0bf67d2"), OriginRequestPolicy.ALL_VIEWER_AND_CLOUDFRONT_2022 = OriginRequestPolicy.fromManagedOriginRequestPolicy("33f36d7e-f396-46d9-90e0-52428a34d9dc"), OriginRequestPolicy.ALL_VIEWER_EXCEPT_HOST_HEADER = OriginRequestPolicy.fromManagedOriginRequestPolicy("b689b0a8-53d0-40ab-baf2-68738e2966ac"), exports2.OriginRequestPolicy = OriginRequestPolicy;
    var OriginRequestCookieBehavior = class _OriginRequestCookieBehavior {
      static none() {
        return new _OriginRequestCookieBehavior("none");
      }
      static all() {
        return new _OriginRequestCookieBehavior("all");
      }
      static allowList(...cookies) {
        if (cookies.length === 0)
          throw new Error("At least one cookie to allow must be provided");
        return new _OriginRequestCookieBehavior("whitelist", cookies);
      }
      constructor(behavior, cookies) {
        this.behavior = behavior, this.cookies = cookies;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, OriginRequestCookieBehavior[_b] = { fqn: "aws-cdk-lib.aws_cloudfront.OriginRequestCookieBehavior", version: "2.80.0" }, exports2.OriginRequestCookieBehavior = OriginRequestCookieBehavior;
    var OriginRequestHeaderBehavior = class _OriginRequestHeaderBehavior {
      static none() {
        return new _OriginRequestHeaderBehavior("none");
      }
      static all(...cloudfrontHeaders) {
        if (cloudfrontHeaders.length > 0) {
          if (!cloudfrontHeaders.every((header) => header.startsWith("CloudFront-")))
            throw new Error("additional CloudFront headers passed to `OriginRequestHeaderBehavior.all()` must begin with 'CloudFront-'");
          return new _OriginRequestHeaderBehavior("allViewerAndWhitelistCloudFront", cloudfrontHeaders);
        } else
          return new _OriginRequestHeaderBehavior("allViewer");
      }
      static allowList(...headers) {
        if (headers.length === 0)
          throw new Error("At least one header to allow must be provided");
        if (headers.map((header) => header.toLowerCase()).some((header) => ["authorization", "accept-encoding"].includes(header)))
          throw new Error("you cannot pass `Authorization` or `Accept-Encoding` as header values; use a CachePolicy to forward these headers instead");
        return new _OriginRequestHeaderBehavior("whitelist", headers);
      }
      constructor(behavior, headers) {
        this.behavior = behavior, this.headers = headers;
      }
    };
    _c = JSII_RTTI_SYMBOL_1, OriginRequestHeaderBehavior[_c] = { fqn: "aws-cdk-lib.aws_cloudfront.OriginRequestHeaderBehavior", version: "2.80.0" }, exports2.OriginRequestHeaderBehavior = OriginRequestHeaderBehavior;
    var OriginRequestQueryStringBehavior = class _OriginRequestQueryStringBehavior {
      static none() {
        return new _OriginRequestQueryStringBehavior("none");
      }
      static all() {
        return new _OriginRequestQueryStringBehavior("all");
      }
      static allowList(...queryStrings) {
        if (queryStrings.length === 0)
          throw new Error("At least one query string to allow must be provided");
        return new _OriginRequestQueryStringBehavior("whitelist", queryStrings);
      }
      constructor(behavior, queryStrings) {
        this.behavior = behavior, this.queryStrings = queryStrings;
      }
    };
    _d = JSII_RTTI_SYMBOL_1, OriginRequestQueryStringBehavior[_d] = { fqn: "aws-cdk-lib.aws_cloudfront.OriginRequestQueryStringBehavior", version: "2.80.0" }, exports2.OriginRequestQueryStringBehavior = OriginRequestQueryStringBehavior;
  }
});

// node_modules/aws-cdk-lib/aws-cloudfront/lib/public-key.js
var require_public_key = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudfront/lib/public-key.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PublicKey = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cloudfront_generated_1 = require_cloudfront_generated();
    var core_1 = require_core2();
    var PublicKey = class _PublicKey extends core_1.Resource {
      static fromPublicKeyId(scope, id, publicKeyId) {
        return new class extends core_1.Resource {
          constructor() {
            super(...arguments), this.publicKeyId = publicKeyId;
          }
        }(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_PublicKeyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _PublicKey), error;
        }
        if (!core_1.Token.isUnresolved(props.encodedKey) && !/^-----BEGIN PUBLIC KEY-----/.test(props.encodedKey))
          throw new Error(`Public key must be in PEM format (with the BEGIN/END PUBLIC KEY lines); got ${props.encodedKey}`);
        const resource = new cloudfront_generated_1.CfnPublicKey(this, "Resource", { publicKeyConfig: { name: props.publicKeyName ?? this.generateName(), callerReference: this.node.addr, encodedKey: props.encodedKey, comment: props.comment } });
        this.publicKeyId = resource.ref;
      }
      generateName() {
        const name = core_1.Names.uniqueId(this);
        return name.length > 80 ? name.substring(0, 40) + name.substring(name.length - 40) : name;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, PublicKey[_a] = { fqn: "aws-cdk-lib.aws_cloudfront.PublicKey", version: "2.80.0" }, exports2.PublicKey = PublicKey;
  }
});

// node_modules/aws-cdk-lib/aws-cloudfront/lib/response-headers-policy.js
var require_response_headers_policy = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudfront/lib/response-headers-policy.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.HeadersReferrerPolicy = exports2.HeadersFrameOption = exports2.ResponseHeadersPolicy = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cloudfront_generated_1 = require_cloudfront_generated();
    var core_1 = require_core2();
    var ResponseHeadersPolicy = class _ResponseHeadersPolicy extends core_1.Resource {
      static fromResponseHeadersPolicyId(scope, id, responseHeadersPolicyId) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.responseHeadersPolicyId = responseHeadersPolicyId;
          }
        }
        return new Import(scope, id);
      }
      static fromManagedResponseHeadersPolicy(managedResponseHeadersPolicyId) {
        return new class {
          constructor() {
            this.responseHeadersPolicyId = managedResponseHeadersPolicyId;
          }
        }();
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.responseHeadersPolicyName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_ResponseHeadersPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ResponseHeadersPolicy), error;
        }
        const responseHeadersPolicyName = props.responseHeadersPolicyName ?? core_1.Names.uniqueResourceName(this, { maxLength: 128 }), resource = new cloudfront_generated_1.CfnResponseHeadersPolicy(this, "Resource", { responseHeadersPolicyConfig: { name: responseHeadersPolicyName, comment: props.comment, corsConfig: props.corsBehavior ? this._renderCorsConfig(props.corsBehavior) : void 0, customHeadersConfig: props.customHeadersBehavior ? this._renderCustomHeadersConfig(props.customHeadersBehavior) : void 0, securityHeadersConfig: props.securityHeadersBehavior ? this._renderSecurityHeadersConfig(props.securityHeadersBehavior) : void 0, removeHeadersConfig: props.removeHeaders ? this._renderRemoveHeadersConfig(props.removeHeaders) : void 0, serverTimingHeadersConfig: props.serverTimingSamplingRate ? this._renderServerTimingHeadersConfig(props.serverTimingSamplingRate) : void 0 } });
        this.responseHeadersPolicyId = resource.ref;
      }
      _renderCorsConfig(behavior) {
        return { accessControlAllowCredentials: behavior.accessControlAllowCredentials, accessControlAllowHeaders: { items: behavior.accessControlAllowHeaders }, accessControlAllowMethods: { items: behavior.accessControlAllowMethods }, accessControlAllowOrigins: { items: behavior.accessControlAllowOrigins }, accessControlExposeHeaders: behavior.accessControlExposeHeaders ? { items: behavior.accessControlExposeHeaders } : void 0, accessControlMaxAgeSec: behavior.accessControlMaxAge ? behavior.accessControlMaxAge.toSeconds() : void 0, originOverride: behavior.originOverride };
      }
      _renderCustomHeadersConfig(behavior) {
        return { items: behavior.customHeaders };
      }
      _renderSecurityHeadersConfig(behavior) {
        return { contentSecurityPolicy: behavior.contentSecurityPolicy, contentTypeOptions: behavior.contentTypeOptions, frameOptions: behavior.frameOptions, referrerPolicy: behavior.referrerPolicy, strictTransportSecurity: behavior.strictTransportSecurity ? { ...behavior.strictTransportSecurity, accessControlMaxAgeSec: behavior.strictTransportSecurity.accessControlMaxAge.toSeconds() } : void 0, xssProtection: behavior.xssProtection };
      }
      _renderRemoveHeadersConfig(headers) {
        const readonlyHeaders = ["content-encoding", "content-length", "transfer-encoding", "warning", "via"];
        return { items: headers.map((header) => {
          if (!core_1.Token.isUnresolved(header) && readonlyHeaders.includes(header.toLowerCase()))
            throw new Error(`Cannot remove read-only header ${header}`);
          return { header };
        }) };
      }
      _renderServerTimingHeadersConfig(samplingRate) {
        if (!core_1.Token.isUnresolved(samplingRate)) {
          if (samplingRate < 0 || samplingRate > 100)
            throw new Error(`Sampling rate must be between 0 and 100 (inclusive), received ${samplingRate}`);
          if (!hasMaxDecimalPlaces(samplingRate, 4))
            throw new Error(`Sampling rate can have up to four decimal places, received ${samplingRate}`);
        }
        return { enabled: true, samplingRate };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ResponseHeadersPolicy[_a] = { fqn: "aws-cdk-lib.aws_cloudfront.ResponseHeadersPolicy", version: "2.80.0" }, ResponseHeadersPolicy.CORS_ALLOW_ALL_ORIGINS = ResponseHeadersPolicy.fromManagedResponseHeadersPolicy("60669652-455b-4ae9-85a4-c4c02393f86c"), ResponseHeadersPolicy.CORS_ALLOW_ALL_ORIGINS_WITH_PREFLIGHT = ResponseHeadersPolicy.fromManagedResponseHeadersPolicy("5cc3b908-e619-4b99-88e5-2cf7f45965bd"), ResponseHeadersPolicy.SECURITY_HEADERS = ResponseHeadersPolicy.fromManagedResponseHeadersPolicy("67f7725c-6f97-4210-82d7-5512b31e9d03"), ResponseHeadersPolicy.CORS_ALLOW_ALL_ORIGINS_AND_SECURITY_HEADERS = ResponseHeadersPolicy.fromManagedResponseHeadersPolicy("e61eb60c-9c35-4d20-a928-2b84e02af89c"), ResponseHeadersPolicy.CORS_ALLOW_ALL_ORIGINS_WITH_PREFLIGHT_AND_SECURITY_HEADERS = ResponseHeadersPolicy.fromManagedResponseHeadersPolicy("eaab4381-ed33-4a86-88ca-d9558dc6cd63"), exports2.ResponseHeadersPolicy = ResponseHeadersPolicy;
    var HeadersFrameOption;
    (function(HeadersFrameOption2) {
      HeadersFrameOption2.DENY = "DENY", HeadersFrameOption2.SAMEORIGIN = "SAMEORIGIN";
    })(HeadersFrameOption = exports2.HeadersFrameOption || (exports2.HeadersFrameOption = {}));
    var HeadersReferrerPolicy;
    (function(HeadersReferrerPolicy2) {
      HeadersReferrerPolicy2.NO_REFERRER = "no-referrer", HeadersReferrerPolicy2.NO_REFERRER_WHEN_DOWNGRADE = "no-referrer-when-downgrade", HeadersReferrerPolicy2.ORIGIN = "origin", HeadersReferrerPolicy2.ORIGIN_WHEN_CROSS_ORIGIN = "origin-when-cross-origin", HeadersReferrerPolicy2.SAME_ORIGIN = "same-origin", HeadersReferrerPolicy2.STRICT_ORIGIN = "strict-origin", HeadersReferrerPolicy2.STRICT_ORIGIN_WHEN_CROSS_ORIGIN = "strict-origin-when-cross-origin", HeadersReferrerPolicy2.UNSAFE_URL = "unsafe-url";
    })(HeadersReferrerPolicy = exports2.HeadersReferrerPolicy || (exports2.HeadersReferrerPolicy = {}));
    function hasMaxDecimalPlaces(num, decimals) {
      const parts = num.toString().split(".");
      return parts.length === 1 || parts[1].length <= decimals;
    }
  }
});

// node_modules/aws-cdk-lib/aws-cloudfront/lib/web-distribution.js
var require_web_distribution = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudfront/lib/web-distribution.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CloudFrontWebDistribution = exports2.ViewerCertificate = exports2.CloudFrontAllowedCachedMethods = exports2.CloudFrontAllowedMethods = exports2.OriginSslPolicy = exports2.FailoverStatusCode = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cloudfront_generated_1 = require_cloudfront_generated();
    var distribution_1 = require_distribution();
    var utils_1 = require_utils10();
    var certificatemanager = require_aws_certificatemanager();
    var iam = require_aws_iam();
    var s3 = require_aws_s3();
    var cdk = require_core2();
    var FailoverStatusCode;
    (function(FailoverStatusCode2) {
      FailoverStatusCode2[FailoverStatusCode2.FORBIDDEN = 403] = "FORBIDDEN", FailoverStatusCode2[FailoverStatusCode2.NOT_FOUND = 404] = "NOT_FOUND", FailoverStatusCode2[FailoverStatusCode2.INTERNAL_SERVER_ERROR = 500] = "INTERNAL_SERVER_ERROR", FailoverStatusCode2[FailoverStatusCode2.BAD_GATEWAY = 502] = "BAD_GATEWAY", FailoverStatusCode2[FailoverStatusCode2.SERVICE_UNAVAILABLE = 503] = "SERVICE_UNAVAILABLE", FailoverStatusCode2[FailoverStatusCode2.GATEWAY_TIMEOUT = 504] = "GATEWAY_TIMEOUT";
    })(FailoverStatusCode = exports2.FailoverStatusCode || (exports2.FailoverStatusCode = {}));
    var OriginSslPolicy;
    (function(OriginSslPolicy2) {
      OriginSslPolicy2.SSL_V3 = "SSLv3", OriginSslPolicy2.TLS_V1 = "TLSv1", OriginSslPolicy2.TLS_V1_1 = "TLSv1.1", OriginSslPolicy2.TLS_V1_2 = "TLSv1.2";
    })(OriginSslPolicy = exports2.OriginSslPolicy || (exports2.OriginSslPolicy = {}));
    var CloudFrontAllowedMethods;
    (function(CloudFrontAllowedMethods2) {
      CloudFrontAllowedMethods2.GET_HEAD = "GH", CloudFrontAllowedMethods2.GET_HEAD_OPTIONS = "GHO", CloudFrontAllowedMethods2.ALL = "ALL";
    })(CloudFrontAllowedMethods = exports2.CloudFrontAllowedMethods || (exports2.CloudFrontAllowedMethods = {}));
    var CloudFrontAllowedCachedMethods;
    (function(CloudFrontAllowedCachedMethods2) {
      CloudFrontAllowedCachedMethods2.GET_HEAD = "GH", CloudFrontAllowedCachedMethods2.GET_HEAD_OPTIONS = "GHO";
    })(CloudFrontAllowedCachedMethods = exports2.CloudFrontAllowedCachedMethods || (exports2.CloudFrontAllowedCachedMethods = {}));
    var ViewerCertificate = class _ViewerCertificate {
      static fromAcmCertificate(certificate, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_certificatemanager_ICertificate(certificate), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_ViewerCertificateOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromAcmCertificate), error;
        }
        const { sslMethod: sslSupportMethod = distribution_1.SSLMethod.SNI, securityPolicy: minimumProtocolVersion, aliases } = options;
        return new _ViewerCertificate({ acmCertificateArn: certificate.certificateArn, sslSupportMethod, minimumProtocolVersion }, aliases);
      }
      static fromIamCertificate(iamCertificateId, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_ViewerCertificateOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromIamCertificate), error;
        }
        const { sslMethod: sslSupportMethod = distribution_1.SSLMethod.SNI, securityPolicy: minimumProtocolVersion, aliases } = options;
        return new _ViewerCertificate({ iamCertificateId, sslSupportMethod, minimumProtocolVersion }, aliases);
      }
      static fromCloudFrontDefaultCertificate(...aliases) {
        return new _ViewerCertificate({ cloudFrontDefaultCertificate: true }, aliases);
      }
      constructor(props, aliases = []) {
        this.props = props, this.aliases = aliases;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ViewerCertificate[_a] = { fqn: "aws-cdk-lib.aws_cloudfront.ViewerCertificate", version: "2.80.0" }, exports2.ViewerCertificate = ViewerCertificate;
    var CloudFrontWebDistribution = class _CloudFrontWebDistribution extends cdk.Resource {
      static fromDistributionAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_CloudFrontWebDistributionAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromDistributionAttributes), error;
        }
        return new class extends cdk.Resource {
          constructor() {
            super(scope, id), this.domainName = attrs.domainName, this.distributionDomainName = attrs.domainName, this.distributionId = attrs.distributionId;
          }
          grant(grantee, ...actions) {
            return iam.Grant.addToPrincipal({ grantee, actions, resourceArns: [(0, utils_1.formatDistributionArn)(this)] });
          }
          grantCreateInvalidation(identity) {
            return this.grant(identity, "cloudfront:CreateInvalidation");
          }
        }();
      }
      constructor(scope, id, props) {
        super(scope, id), this.METHOD_LOOKUP_MAP = { GH: ["GET", "HEAD"], GHO: ["GET", "HEAD", "OPTIONS"], ALL: ["DELETE", "GET", "HEAD", "OPTIONS", "PATCH", "POST", "PUT"] }, this.VALID_SSL_PROTOCOLS = { [distribution_1.SSLMethod.SNI]: [distribution_1.SecurityPolicyProtocol.TLS_V1, distribution_1.SecurityPolicyProtocol.TLS_V1_1_2016, distribution_1.SecurityPolicyProtocol.TLS_V1_2016, distribution_1.SecurityPolicyProtocol.TLS_V1_2_2018, distribution_1.SecurityPolicyProtocol.TLS_V1_2_2019, distribution_1.SecurityPolicyProtocol.TLS_V1_2_2021], [distribution_1.SSLMethod.VIP]: [distribution_1.SecurityPolicyProtocol.SSL_V3, distribution_1.SecurityPolicyProtocol.TLS_V1] };
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_CloudFrontWebDistributionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CloudFrontWebDistribution), error;
        }
        const trimmedComment = props.comment && props.comment.length > 128 ? `${props.comment.slice(0, 128 - 3)}...` : props.comment, behaviors = [], origins = [], originGroups = [];
        let originIndex = 1;
        for (const originConfig of props.originConfigs) {
          let originId = `origin${originIndex}`;
          const originProperty = this.toOriginProperty(originConfig, originId);
          if (originConfig.failoverCustomOriginSource || originConfig.failoverS3OriginSource) {
            const originSecondaryId = `originSecondary${originIndex}`, originSecondaryProperty = this.toOriginProperty({ s3OriginSource: originConfig.failoverS3OriginSource, customOriginSource: originConfig.failoverCustomOriginSource, originPath: originConfig.originPath, originHeaders: originConfig.originHeaders, originShieldRegion: originConfig.originShieldRegion }, originSecondaryId), originGroupsId = `OriginGroup${originIndex}`, failoverCodes = originConfig.failoverCriteriaStatusCodes ?? [500, 502, 503, 504];
            originGroups.push({ id: originGroupsId, members: { items: [{ originId }, { originId: originSecondaryId }], quantity: 2 }, failoverCriteria: { statusCodes: { items: failoverCodes, quantity: failoverCodes.length } } }), originId = originGroupsId, origins.push(originSecondaryProperty);
          }
          for (const behavior of originConfig.behaviors)
            behaviors.push({ ...behavior, targetOriginId: originId });
          origins.push(originProperty), originIndex++;
        }
        origins.forEach((origin) => {
          if (!origin.s3OriginConfig && !origin.customOriginConfig)
            throw new Error(`Origin ${origin.domainName} is missing either S3OriginConfig or CustomOriginConfig. At least 1 must be specified.`);
        });
        const originGroupsDistConfig = originGroups.length > 0 ? { items: originGroups, quantity: originGroups.length } : void 0, defaultBehaviors = behaviors.filter((behavior) => behavior.isDefaultBehavior);
        if (defaultBehaviors.length !== 1)
          throw new Error("There can only be one default behavior across all sources. [ One default behavior per distribution ].");
        const otherBehaviors = [];
        for (const behavior of behaviors.filter((b) => !b.isDefaultBehavior)) {
          if (!behavior.pathPattern)
            throw new Error("pathPattern is required for all non-default behaviors");
          otherBehaviors.push(this.toBehavior(behavior, props.viewerProtocolPolicy));
        }
        let distributionConfig = { comment: trimmedComment, enabled: props.enabled ?? true, defaultRootObject: props.defaultRootObject ?? "index.html", httpVersion: props.httpVersion || distribution_1.HttpVersion.HTTP2, priceClass: props.priceClass || distribution_1.PriceClass.PRICE_CLASS_100, ipv6Enabled: props.enableIpV6 ?? true, customErrorResponses: props.errorConfigurations, webAclId: props.webACLId, origins, originGroups: originGroupsDistConfig, defaultCacheBehavior: this.toBehavior(defaultBehaviors[0], props.viewerProtocolPolicy), cacheBehaviors: otherBehaviors.length > 0 ? otherBehaviors : void 0 };
        if (props.aliasConfiguration && props.viewerCertificate)
          throw new Error(["You cannot set both aliasConfiguration and viewerCertificate properties.", "Please only use viewerCertificate, as aliasConfiguration is deprecated."].join(" "));
        let _viewerCertificate = props.viewerCertificate;
        if (props.aliasConfiguration) {
          const { acmCertRef, securityPolicy, sslMethod, names: aliases } = props.aliasConfiguration;
          _viewerCertificate = ViewerCertificate.fromAcmCertificate(certificatemanager.Certificate.fromCertificateArn(this, "AliasConfigurationCert", acmCertRef), { securityPolicy, sslMethod, aliases });
        }
        if (_viewerCertificate) {
          const { props: viewerCertificate, aliases } = _viewerCertificate;
          Object.assign(distributionConfig, { aliases, viewerCertificate });
          const { minimumProtocolVersion, sslSupportMethod } = viewerCertificate;
          if (minimumProtocolVersion != null && sslSupportMethod != null) {
            const validProtocols = this.VALID_SSL_PROTOCOLS[sslSupportMethod];
            if (validProtocols.indexOf(minimumProtocolVersion.toString()) === -1)
              throw new Error(`${minimumProtocolVersion} is not compabtible with sslMethod ${sslSupportMethod}.
	Valid Protocols are: ${validProtocols.join(", ")}`);
          }
        } else
          distributionConfig = { ...distributionConfig, viewerCertificate: { cloudFrontDefaultCertificate: true } };
        props.loggingConfig && (this.loggingBucket = props.loggingConfig.bucket || new s3.Bucket(this, "LoggingBucket", { encryption: s3.BucketEncryption.S3_MANAGED }), distributionConfig = { ...distributionConfig, logging: { bucket: this.loggingBucket.bucketRegionalDomainName, includeCookies: props.loggingConfig.includeCookies || false, prefix: props.loggingConfig.prefix } }), props.geoRestriction && (distributionConfig = { ...distributionConfig, restrictions: { geoRestriction: { restrictionType: props.geoRestriction.restrictionType, locations: props.geoRestriction.locations } } });
        const distribution = new cloudfront_generated_1.CfnDistribution(this, "CFDistribution", { distributionConfig });
        this.node.defaultChild = distribution, this.domainName = distribution.attrDomainName, this.distributionDomainName = distribution.attrDomainName, this.distributionId = distribution.ref;
      }
      grant(identity, ...actions) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(identity);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grant), error;
        }
        return iam.Grant.addToPrincipal({ grantee: identity, actions, resourceArns: [(0, utils_1.formatDistributionArn)(this)] });
      }
      grantCreateInvalidation(identity) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(identity);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantCreateInvalidation), error;
        }
        return this.grant(identity, "cloudfront:CreateInvalidation");
      }
      toBehavior(input, protoPolicy) {
        let toReturn = { allowedMethods: this.METHOD_LOOKUP_MAP[input.allowedMethods || CloudFrontAllowedMethods.GET_HEAD], cachedMethods: this.METHOD_LOOKUP_MAP[input.cachedMethods || CloudFrontAllowedCachedMethods.GET_HEAD], compress: input.compress !== false, defaultTtl: input.defaultTtl && input.defaultTtl.toSeconds(), forwardedValues: input.forwardedValues || { queryString: false, cookies: { forward: "none" } }, maxTtl: input.maxTtl && input.maxTtl.toSeconds(), minTtl: input.minTtl && input.minTtl.toSeconds(), trustedKeyGroups: input.trustedKeyGroups?.map((key) => key.keyGroupId), trustedSigners: input.trustedSigners, targetOriginId: input.targetOriginId, viewerProtocolPolicy: input.viewerProtocolPolicy || protoPolicy || distribution_1.ViewerProtocolPolicy.REDIRECT_TO_HTTPS };
        if (input.isDefaultBehavior || (toReturn = Object.assign(toReturn, { pathPattern: input.pathPattern })), input.functionAssociations && (toReturn = Object.assign(toReturn, { functionAssociations: input.functionAssociations.map((association) => ({ functionArn: association.function.functionArn, eventType: association.eventType.toString() })) })), input.lambdaFunctionAssociations) {
          const includeBodyEventTypes = [distribution_1.LambdaEdgeEventType.ORIGIN_REQUEST, distribution_1.LambdaEdgeEventType.VIEWER_REQUEST];
          if (input.lambdaFunctionAssociations.some((fna) => fna.includeBody && !includeBodyEventTypes.includes(fna.eventType)))
            throw new Error("'includeBody' can only be true for ORIGIN_REQUEST or VIEWER_REQUEST event types.");
          toReturn = Object.assign(toReturn, { lambdaFunctionAssociations: input.lambdaFunctionAssociations.map((fna) => ({ eventType: fna.eventType, lambdaFunctionArn: fna.lambdaFunction && fna.lambdaFunction.edgeArn, includeBody: fna.includeBody })) });
          for (const a of input.lambdaFunctionAssociations)
            a.lambdaFunction.role && iam.Role.isRole(a.lambdaFunction.role) && a.lambdaFunction.role.assumeRolePolicy && a.lambdaFunction.role.assumeRolePolicy.addStatements(new iam.PolicyStatement({ actions: ["sts:AssumeRole"], principals: [new iam.ServicePrincipal("edgelambda.amazonaws.com")] }));
        }
        return toReturn;
      }
      toOriginProperty(originConfig, originId) {
        if (!originConfig.s3OriginSource && !originConfig.customOriginSource)
          throw new Error("There must be at least one origin source - either an s3OriginSource, a customOriginSource");
        if (originConfig.customOriginSource && originConfig.s3OriginSource)
          throw new Error("There cannot be both an s3OriginSource and a customOriginSource in the same SourceConfiguration.");
        if ([originConfig.originHeaders, originConfig.s3OriginSource?.originHeaders, originConfig.customOriginSource?.originHeaders].filter((x) => x).length > 1)
          throw new Error("Only one originHeaders field allowed across origin and failover origins");
        if ([originConfig.originPath, originConfig.s3OriginSource?.originPath, originConfig.customOriginSource?.originPath].filter((x) => x).length > 1)
          throw new Error("Only one originPath field allowed across origin and failover origins");
        if ([originConfig.originShieldRegion, originConfig.s3OriginSource?.originShieldRegion, originConfig.customOriginSource?.originShieldRegion].filter((x) => x).length > 1)
          throw new Error("Only one originShieldRegion field allowed across origin and failover origins");
        const headers = originConfig.originHeaders ?? originConfig.s3OriginSource?.originHeaders ?? originConfig.customOriginSource?.originHeaders, originHeaders = [];
        headers && Object.keys(headers).forEach((key) => {
          const oHeader = { headerName: key, headerValue: headers[key] };
          originHeaders.push(oHeader);
        });
        let s3OriginConfig;
        originConfig.s3OriginSource && (originConfig.s3OriginSource.originAccessIdentity ? (originConfig.s3OriginSource.s3BucketSource.addToResourcePolicy(new iam.PolicyStatement({ resources: [originConfig.s3OriginSource.s3BucketSource.arnForObjects("*")], actions: ["s3:GetObject"], principals: [originConfig.s3OriginSource.originAccessIdentity.grantPrincipal] })), s3OriginConfig = { originAccessIdentity: `origin-access-identity/cloudfront/${originConfig.s3OriginSource.originAccessIdentity.originAccessIdentityId}` }) : s3OriginConfig = {});
        const connectionAttempts = originConfig.connectionAttempts ?? 3;
        if (connectionAttempts < 1 || 3 < connectionAttempts || !Number.isInteger(connectionAttempts))
          throw new Error("connectionAttempts: You can specify 1, 2, or 3 as the number of attempts.");
        const connectionTimeout = (originConfig.connectionTimeout || cdk.Duration.seconds(10)).toSeconds();
        if (connectionTimeout < 1 || 10 < connectionTimeout || !Number.isInteger(connectionTimeout))
          throw new Error("connectionTimeout: You can specify a number of seconds between 1 and 10 (inclusive).");
        return { id: originId, domainName: originConfig.s3OriginSource ? originConfig.s3OriginSource.s3BucketSource.bucketRegionalDomainName : originConfig.customOriginSource.domainName, originPath: originConfig.originPath ?? originConfig.customOriginSource?.originPath ?? originConfig.s3OriginSource?.originPath, originCustomHeaders: originHeaders.length > 0 ? originHeaders : void 0, s3OriginConfig, originShield: this.toOriginShieldProperty(originConfig), customOriginConfig: originConfig.customOriginSource ? { httpPort: originConfig.customOriginSource.httpPort || 80, httpsPort: originConfig.customOriginSource.httpsPort || 443, originKeepaliveTimeout: originConfig.customOriginSource.originKeepaliveTimeout && originConfig.customOriginSource.originKeepaliveTimeout.toSeconds() || 5, originReadTimeout: originConfig.customOriginSource.originReadTimeout && originConfig.customOriginSource.originReadTimeout.toSeconds() || 30, originProtocolPolicy: originConfig.customOriginSource.originProtocolPolicy || distribution_1.OriginProtocolPolicy.HTTPS_ONLY, originSslProtocols: originConfig.customOriginSource.allowedOriginSSLVersions || [OriginSslPolicy.TLS_V1_2] } : void 0, connectionAttempts, connectionTimeout };
      }
      toOriginShieldProperty(originConfig) {
        const originShieldRegion = originConfig.originShieldRegion ?? originConfig.customOriginSource?.originShieldRegion ?? originConfig.s3OriginSource?.originShieldRegion;
        return originShieldRegion ? { enabled: true, originShieldRegion } : void 0;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CloudFrontWebDistribution[_b] = { fqn: "aws-cdk-lib.aws_cloudfront.CloudFrontWebDistribution", version: "2.80.0" }, exports2.CloudFrontWebDistribution = CloudFrontWebDistribution;
  }
});

// node_modules/aws-cdk-lib/aws-cloudfront/lib/experimental/edge-function.js
var require_edge_function = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudfront/lib/experimental/edge-function.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EdgeFunction = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var path = require("path");
    var iam = require_aws_iam();
    var lambda2 = require_aws_lambda();
    var ssm = require_aws_ssm();
    var core_1 = require_core2();
    var EdgeFunction = class _EdgeFunction extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id), this.isBoundToVpc = false;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_experimental_EdgeFunctionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EdgeFunction), error;
        }
        const regionIsUsEast1 = !core_1.Token.isUnresolved(this.env.region) && this.env.region === "us-east-1", { edgeFunction, edgeArn } = regionIsUsEast1 ? this.createInRegionFunction(props) : this.createCrossRegionFunction(id, props);
        this.edgeArn = edgeArn, this.functionArn = edgeArn, this._edgeFunction = edgeFunction, this.functionName = this._edgeFunction.functionName, this.grantPrincipal = this._edgeFunction.role, this.permissionsNode = this._edgeFunction.permissionsNode, this.version = lambda2.extractQualifierFromArn(this.functionArn), this.architecture = this._edgeFunction.architecture, this.resourceArnsForGrantInvoke = this._edgeFunction.resourceArnsForGrantInvoke, this.node.defaultChild = this._edgeFunction;
      }
      get lambda() {
        return this._edgeFunction;
      }
      get currentVersion() {
        return this;
      }
      addAlias(aliasName, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_AliasOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addAlias), error;
        }
        return new lambda2.Alias(this._edgeFunction, `Alias${aliasName}`, { aliasName, version: this._edgeFunction.currentVersion, ...options });
      }
      get connections() {
        throw new Error("Lambda@Edge does not support connections");
      }
      get latestVersion() {
        throw new Error("$LATEST function version cannot be used for Lambda@Edge");
      }
      addEventSourceMapping(id, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_EventSourceMappingOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addEventSourceMapping), error;
        }
        return this.lambda.addEventSourceMapping(id, options);
      }
      addPermission(id, permission) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_Permission(permission);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addPermission), error;
        }
        return this.lambda.addPermission(id, permission);
      }
      addToRolePolicy(statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToRolePolicy), error;
        }
        return this.lambda.addToRolePolicy(statement);
      }
      grantInvoke(identity) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(identity);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantInvoke), error;
        }
        return this.lambda.grantInvoke(identity);
      }
      grantInvokeUrl(identity) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(identity);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantInvokeUrl), error;
        }
        return this.lambda.grantInvokeUrl(identity);
      }
      metric(metricName, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metric), error;
        }
        return this.lambda.metric(metricName, { ...props, region: _EdgeFunction.EDGE_REGION });
      }
      metricDuration(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricDuration), error;
        }
        return this.lambda.metricDuration({ ...props, region: _EdgeFunction.EDGE_REGION });
      }
      metricErrors(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricErrors), error;
        }
        return this.lambda.metricErrors({ ...props, region: _EdgeFunction.EDGE_REGION });
      }
      metricInvocations(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricInvocations), error;
        }
        return this.lambda.metricInvocations({ ...props, region: _EdgeFunction.EDGE_REGION });
      }
      metricThrottles(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricThrottles), error;
        }
        return this.lambda.metricThrottles({ ...props, region: _EdgeFunction.EDGE_REGION });
      }
      addEventSource(source) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_IEventSource(source);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addEventSource), error;
        }
        return this.lambda.addEventSource(source);
      }
      configureAsyncInvoke(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_EventInvokeConfigOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.configureAsyncInvoke), error;
        }
        return this.lambda.configureAsyncInvoke(options);
      }
      addFunctionUrl(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_FunctionUrlOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addFunctionUrl), error;
        }
        return this.lambda.addFunctionUrl(options);
      }
      createInRegionFunction(props) {
        const edgeFunction = new lambda2.Function(this, "Fn", props);
        return addEdgeLambdaToRoleTrustStatement(edgeFunction.role), { edgeFunction, edgeArn: edgeFunction.currentVersion.edgeArn };
      }
      createCrossRegionFunction(id, props) {
        const parameterNamePrefix = "cdk/EdgeFunctionArn";
        if (core_1.Token.isUnresolved(this.env.region))
          throw new Error("stacks which use EdgeFunctions must have an explicitly set region");
        const sanitizedPath = this.node.path.replace(/[^\/\w.-]/g, "_"), parameterName = `/${parameterNamePrefix}/${this.env.region}/${sanitizedPath}`, functionStack = this.edgeStack(props.stackId), edgeFunction = new lambda2.Function(functionStack, id, props);
        addEdgeLambdaToRoleTrustStatement(edgeFunction.role);
        const version = edgeFunction.currentVersion;
        new ssm.StringParameter(edgeFunction, "Parameter", { parameterName, stringValue: version.edgeArn });
        const edgeArn = this.createCrossRegionArnReader(parameterNamePrefix, parameterName, version);
        return { edgeFunction, edgeArn };
      }
      createCrossRegionArnReader(parameterNamePrefix, parameterName, version) {
        const parameterArnPrefix = this.stack.formatArn({ service: "ssm", region: _EdgeFunction.EDGE_REGION, resource: "parameter", resourceName: parameterNamePrefix + "/*" }), resourceType = "Custom::CrossRegionStringParameterReader", serviceToken = core_1.CustomResourceProvider.getOrCreate(this, resourceType, { codeDirectory: path.join(__dirname, "edge-function"), runtime: (0, core_1.builtInCustomResourceProviderNodeRuntime)(this), policyStatements: [{ Effect: "Allow", Resource: parameterArnPrefix, Action: ["ssm:GetParameter"] }] });
        return new core_1.CustomResource(this, "ArnReader", { resourceType, serviceToken, properties: { Region: _EdgeFunction.EDGE_REGION, ParameterName: parameterName, RefreshToken: core_1.Lazy.uncachedString({ produce: () => {
          const cfn = version.node.defaultChild;
          return this.stack.resolve(cfn.logicalId);
        } }) } }).getAttString("FunctionArn");
      }
      edgeStack(stackId) {
        const stage = core_1.Stage.of(this);
        if (!stage)
          throw new Error("stacks which use EdgeFunctions must be part of a CDK app or stage");
        const edgeStackId = stackId ?? `edge-lambda-stack-${this.stack.node.addr}`;
        let edgeStack = stage.node.tryFindChild(edgeStackId);
        return edgeStack || (edgeStack = new core_1.Stack(stage, edgeStackId, { env: { region: _EdgeFunction.EDGE_REGION, account: core_1.Stack.of(this).account } })), this.stack.addDependency(edgeStack), edgeStack;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EdgeFunction[_a] = { fqn: "aws-cdk-lib.aws_cloudfront.experimental.EdgeFunction", version: "2.80.0" }, EdgeFunction.EDGE_REGION = "us-east-1", exports2.EdgeFunction = EdgeFunction;
    function addEdgeLambdaToRoleTrustStatement(role) {
      if (iam.Role.isRole(role) && role.assumeRolePolicy) {
        const statement = new iam.PolicyStatement(), edgeLambdaServicePrincipal = new iam.ServicePrincipal("edgelambda.amazonaws.com");
        statement.addPrincipals(edgeLambdaServicePrincipal), statement.addActions(edgeLambdaServicePrincipal.assumeRoleAction), role.assumeRolePolicy.addStatements(statement);
      }
    }
  }
});

// node_modules/aws-cdk-lib/aws-cloudfront/lib/experimental/index.js
var require_experimental = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudfront/lib/experimental/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_edge_function(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-cloudfront/lib/index.js
var require_lib71 = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudfront/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.experimental = void 0, __exportStar(require_cache_policy(), exports2), __exportStar(require_distribution(), exports2), __exportStar(require_function2(), exports2), __exportStar(require_geo_restriction(), exports2), __exportStar(require_key_group(), exports2), __exportStar(require_origin(), exports2), __exportStar(require_origin_access_identity(), exports2), __exportStar(require_origin_request_policy(), exports2), __exportStar(require_public_key(), exports2), __exportStar(require_response_headers_policy(), exports2), __exportStar(require_web_distribution(), exports2), exports2.experimental = require_experimental(), __exportStar(require_cloudfront_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-cloudfront/index.js
var require_aws_cloudfront = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudfront/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib71(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-cloudfront-origins/lib/private/utils.js
var require_utils11 = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudfront-origins/lib/private/utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.validateSecondsInRangeOrUndefined = void 0;
    function validateSecondsInRangeOrUndefined(name, min, max, duration) {
      if (duration === void 0)
        return;
      const value = duration.toSeconds();
      if (!Number.isInteger(value) || value < min || value > max)
        throw new Error(`${name}: Must be an int between ${min} and ${max} seconds (inclusive); received ${value}.`);
    }
    exports2.validateSecondsInRangeOrUndefined = validateSecondsInRangeOrUndefined;
  }
});

// node_modules/aws-cdk-lib/aws-cloudfront-origins/lib/http-origin.js
var require_http_origin = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudfront-origins/lib/http-origin.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.HttpOrigin = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var utils_1 = require_utils11();
    var cloudfront = require_aws_cloudfront();
    var HttpOrigin = class _HttpOrigin extends cloudfront.OriginBase {
      constructor(domainName, props = {}) {
        super(domainName, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_origins_HttpOriginProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _HttpOrigin), error;
        }
        (0, utils_1.validateSecondsInRangeOrUndefined)("readTimeout", 1, 180, props.readTimeout), (0, utils_1.validateSecondsInRangeOrUndefined)("keepaliveTimeout", 1, 180, props.keepaliveTimeout);
      }
      renderCustomOriginConfig() {
        return { originSslProtocols: this.props.originSslProtocols ?? [cloudfront.OriginSslPolicy.TLS_V1_2], originProtocolPolicy: this.props.protocolPolicy ?? cloudfront.OriginProtocolPolicy.HTTPS_ONLY, httpPort: this.props.httpPort, httpsPort: this.props.httpsPort, originReadTimeout: this.props.readTimeout?.toSeconds(), originKeepaliveTimeout: this.props.keepaliveTimeout?.toSeconds() };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, HttpOrigin[_a] = { fqn: "aws-cdk-lib.aws_cloudfront_origins.HttpOrigin", version: "2.80.0" }, exports2.HttpOrigin = HttpOrigin;
  }
});

// node_modules/aws-cdk-lib/aws-cloudfront-origins/lib/load-balancer-origin.js
var require_load_balancer_origin = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudfront-origins/lib/load-balancer-origin.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LoadBalancerV2Origin = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var http_origin_1 = require_http_origin();
    var LoadBalancerV2Origin = class _LoadBalancerV2Origin extends http_origin_1.HttpOrigin {
      constructor(loadBalancer, props = {}) {
        super(loadBalancer.loadBalancerDnsName, { ...props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_ILoadBalancerV2(loadBalancer), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_origins_LoadBalancerV2OriginProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _LoadBalancerV2Origin), error;
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LoadBalancerV2Origin[_a] = { fqn: "aws-cdk-lib.aws_cloudfront_origins.LoadBalancerV2Origin", version: "2.80.0" }, exports2.LoadBalancerV2Origin = LoadBalancerV2Origin;
  }
});

// node_modules/aws-cdk-lib/aws-cloudfront-origins/lib/s3-origin.js
var require_s3_origin = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudfront-origins/lib/s3-origin.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.S3Origin = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var http_origin_1 = require_http_origin();
    var cloudfront = require_aws_cloudfront();
    var iam = require_aws_iam();
    var cdk = require_core2();
    var S3Origin = class _S3Origin {
      constructor(bucket, props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_IBucket(bucket), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_origins_S3OriginProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _S3Origin), error;
        }
        this.origin = bucket.isWebsite ? new http_origin_1.HttpOrigin(bucket.bucketWebsiteDomainName, { protocolPolicy: cloudfront.OriginProtocolPolicy.HTTP_ONLY, ...props }) : new S3BucketOrigin(bucket, props);
      }
      bind(scope, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_OriginBindOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return this.origin.bind(scope, options);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, S3Origin[_a] = { fqn: "aws-cdk-lib.aws_cloudfront_origins.S3Origin", version: "2.80.0" }, exports2.S3Origin = S3Origin;
    var S3BucketOrigin = class extends cloudfront.OriginBase {
      constructor(bucket, { originAccessIdentity, ...props }) {
        super(bucket.bucketRegionalDomainName, props), this.bucket = bucket, originAccessIdentity && (this.originAccessIdentity = originAccessIdentity);
      }
      bind(scope, options) {
        if (!this.originAccessIdentity) {
          const bucketStack = cdk.Stack.of(this.bucket), bucketInDifferentStack = bucketStack !== cdk.Stack.of(scope), oaiScope = bucketInDifferentStack ? bucketStack : scope, oaiId = bucketInDifferentStack ? `${cdk.Names.uniqueId(scope)}S3Origin` : "S3Origin";
          this.originAccessIdentity = new cloudfront.OriginAccessIdentity(oaiScope, oaiId, { comment: `Identity for ${options.originId}` });
        }
        return this.bucket.addToResourcePolicy(new iam.PolicyStatement({ resources: [this.bucket.arnForObjects("*")], actions: ["s3:GetObject"], principals: [this.originAccessIdentity.grantPrincipal] })), super.bind(scope, options);
      }
      renderS3OriginConfig() {
        return { originAccessIdentity: `origin-access-identity/cloudfront/${this.originAccessIdentity.originAccessIdentityId}` };
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-cloudfront-origins/lib/origin-group.js
var require_origin_group = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudfront-origins/lib/origin-group.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.OriginGroup = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var OriginGroup = class _OriginGroup {
      constructor(props) {
        this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_origins_OriginGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _OriginGroup), error;
        }
      }
      bind(scope, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_OriginBindOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        const primaryOriginConfig = this.props.primaryOrigin.bind(scope, options);
        if (primaryOriginConfig.failoverConfig)
          throw new Error("An OriginGroup cannot use an Origin with its own failover configuration as its primary origin!");
        return { originProperty: primaryOriginConfig.originProperty, failoverConfig: { failoverOrigin: this.props.fallbackOrigin, statusCodes: this.props.fallbackStatusCodes } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, OriginGroup[_a] = { fqn: "aws-cdk-lib.aws_cloudfront_origins.OriginGroup", version: "2.80.0" }, exports2.OriginGroup = OriginGroup;
  }
});

// node_modules/aws-cdk-lib/aws-cloudfront-origins/lib/rest-api-origin.js
var require_rest_api_origin = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudfront-origins/lib/rest-api-origin.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.RestApiOrigin = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var utils_1 = require_utils11();
    var cloudfront = require_aws_cloudfront();
    var cdk = require_core2();
    var RestApiOrigin = class _RestApiOrigin extends cloudfront.OriginBase {
      constructor(restApi, props = {}) {
        super(cdk.Fn.select(2, cdk.Fn.split("/", restApi.url)), { originPath: props.originPath ?? `/${cdk.Fn.select(3, cdk.Fn.split("/", restApi.url))}`, ...props }), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_RestApi(restApi), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_origins_RestApiOriginProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _RestApiOrigin), error;
        }
        (0, utils_1.validateSecondsInRangeOrUndefined)("readTimeout", 1, 180, props.readTimeout), (0, utils_1.validateSecondsInRangeOrUndefined)("keepaliveTimeout", 1, 180, props.keepaliveTimeout);
      }
      renderCustomOriginConfig() {
        return { originSslProtocols: [cloudfront.OriginSslPolicy.TLS_V1_2], originProtocolPolicy: cloudfront.OriginProtocolPolicy.HTTPS_ONLY, originReadTimeout: this.props.readTimeout?.toSeconds(), originKeepaliveTimeout: this.props.keepaliveTimeout?.toSeconds() };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, RestApiOrigin[_a] = { fqn: "aws-cdk-lib.aws_cloudfront_origins.RestApiOrigin", version: "2.80.0" }, exports2.RestApiOrigin = RestApiOrigin;
  }
});

// node_modules/aws-cdk-lib/aws-cloudfront-origins/lib/index.js
var require_lib72 = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudfront-origins/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_http_origin(), exports2), __exportStar(require_load_balancer_origin(), exports2), __exportStar(require_s3_origin(), exports2), __exportStar(require_origin_group(), exports2), __exportStar(require_rest_api_origin(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-cloudfront-origins/index.js
var require_aws_cloudfront_origins = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudfront-origins/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib72(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-cloudtrail/lib/cloudtrail.generated.js
var require_cloudtrail_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudtrail/lib/cloudtrail.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnTrail = exports2.CfnResourcePolicy = exports2.CfnEventDataStore = exports2.CfnChannel = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnChannelPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinations", cdk.listValidator(CfnChannel_DestinationPropertyValidator))(properties.destinations)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("source", cdk.validateString)(properties.source)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnChannelProps"');
    }
    function cfnChannelPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannelPropsValidator(properties).assertSuccess(), { Destinations: cdk.listMapper(cfnChannelDestinationPropertyToCloudFormation)(properties.destinations), Name: cdk.stringToCloudFormation(properties.name), Source: cdk.stringToCloudFormation(properties.source), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnChannelPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinations", "Destinations", properties.Destinations != null ? cfn_parse.FromCloudFormation.getArray(CfnChannelDestinationPropertyFromCloudFormation)(properties.Destinations) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("source", "Source", properties.Source != null ? cfn_parse.FromCloudFormation.getString(properties.Source) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnChannel = class _CfnChannel extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnChannelPropsFromCloudFormation(resourceProperties), ret = new _CfnChannel(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnChannel.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudtrail_CfnChannelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnChannel), error;
        }
        this.attrChannelArn = cdk.Token.asString(this.getAtt("ChannelArn", cdk.ResolutionTypeHint.STRING)), this.destinations = props.destinations, this.name = props.name, this.source = props.source, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::CloudTrail::Channel", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnChannel.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { destinations: this.destinations, name: this.name, source: this.source, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnChannelPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnChannel[_a] = { fqn: "aws-cdk-lib.aws_cloudtrail.CfnChannel", version: "2.80.0" }, CfnChannel.CFN_RESOURCE_TYPE_NAME = "AWS::CloudTrail::Channel", exports2.CfnChannel = CfnChannel;
    function CfnChannel_DestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("location", cdk.requiredValidator)(properties.location)), errors.collect(cdk.propertyValidator("location", cdk.validateString)(properties.location)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "DestinationProperty"');
    }
    function cfnChannelDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_DestinationPropertyValidator(properties).assertSuccess(), { Location: cdk.stringToCloudFormation(properties.location), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnChannelDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("location", "Location", cfn_parse.FromCloudFormation.getString(properties.Location)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEventDataStorePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("advancedEventSelectors", cdk.listValidator(CfnEventDataStore_AdvancedEventSelectorPropertyValidator))(properties.advancedEventSelectors)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("multiRegionEnabled", cdk.validateBoolean)(properties.multiRegionEnabled)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("organizationEnabled", cdk.validateBoolean)(properties.organizationEnabled)), errors.collect(cdk.propertyValidator("retentionPeriod", cdk.validateNumber)(properties.retentionPeriod)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("terminationProtectionEnabled", cdk.validateBoolean)(properties.terminationProtectionEnabled)), errors.wrap('supplied properties not correct for "CfnEventDataStoreProps"');
    }
    function cfnEventDataStorePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventDataStorePropsValidator(properties).assertSuccess(), { AdvancedEventSelectors: cdk.listMapper(cfnEventDataStoreAdvancedEventSelectorPropertyToCloudFormation)(properties.advancedEventSelectors), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), MultiRegionEnabled: cdk.booleanToCloudFormation(properties.multiRegionEnabled), Name: cdk.stringToCloudFormation(properties.name), OrganizationEnabled: cdk.booleanToCloudFormation(properties.organizationEnabled), RetentionPeriod: cdk.numberToCloudFormation(properties.retentionPeriod), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TerminationProtectionEnabled: cdk.booleanToCloudFormation(properties.terminationProtectionEnabled) }) : properties;
    }
    function CfnEventDataStorePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("advancedEventSelectors", "AdvancedEventSelectors", properties.AdvancedEventSelectors != null ? cfn_parse.FromCloudFormation.getArray(CfnEventDataStoreAdvancedEventSelectorPropertyFromCloudFormation)(properties.AdvancedEventSelectors) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("multiRegionEnabled", "MultiRegionEnabled", properties.MultiRegionEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.MultiRegionEnabled) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("organizationEnabled", "OrganizationEnabled", properties.OrganizationEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.OrganizationEnabled) : void 0), ret.addPropertyResult("retentionPeriod", "RetentionPeriod", properties.RetentionPeriod != null ? cfn_parse.FromCloudFormation.getNumber(properties.RetentionPeriod) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("terminationProtectionEnabled", "TerminationProtectionEnabled", properties.TerminationProtectionEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.TerminationProtectionEnabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEventDataStore = class _CfnEventDataStore extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEventDataStorePropsFromCloudFormation(resourceProperties), ret = new _CfnEventDataStore(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnEventDataStore.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudtrail_CfnEventDataStoreProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEventDataStore), error;
        }
        this.attrCreatedTimestamp = cdk.Token.asString(this.getAtt("CreatedTimestamp", cdk.ResolutionTypeHint.STRING)), this.attrEventDataStoreArn = cdk.Token.asString(this.getAtt("EventDataStoreArn", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.attrUpdatedTimestamp = cdk.Token.asString(this.getAtt("UpdatedTimestamp", cdk.ResolutionTypeHint.STRING)), this.advancedEventSelectors = props.advancedEventSelectors, this.kmsKeyId = props.kmsKeyId, this.multiRegionEnabled = props.multiRegionEnabled, this.name = props.name, this.organizationEnabled = props.organizationEnabled, this.retentionPeriod = props.retentionPeriod, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::CloudTrail::EventDataStore", props.tags, { tagPropertyName: "tags" }), this.terminationProtectionEnabled = props.terminationProtectionEnabled;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEventDataStore.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { advancedEventSelectors: this.advancedEventSelectors, kmsKeyId: this.kmsKeyId, multiRegionEnabled: this.multiRegionEnabled, name: this.name, organizationEnabled: this.organizationEnabled, retentionPeriod: this.retentionPeriod, tags: this.tags.renderTags(), terminationProtectionEnabled: this.terminationProtectionEnabled };
      }
      renderProperties(props) {
        return cfnEventDataStorePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnEventDataStore[_b] = { fqn: "aws-cdk-lib.aws_cloudtrail.CfnEventDataStore", version: "2.80.0" }, CfnEventDataStore.CFN_RESOURCE_TYPE_NAME = "AWS::CloudTrail::EventDataStore", exports2.CfnEventDataStore = CfnEventDataStore;
    function CfnEventDataStore_AdvancedEventSelectorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldSelectors", cdk.requiredValidator)(properties.fieldSelectors)), errors.collect(cdk.propertyValidator("fieldSelectors", cdk.listValidator(CfnEventDataStore_AdvancedFieldSelectorPropertyValidator))(properties.fieldSelectors)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "AdvancedEventSelectorProperty"');
    }
    function cfnEventDataStoreAdvancedEventSelectorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventDataStore_AdvancedEventSelectorPropertyValidator(properties).assertSuccess(), { FieldSelectors: cdk.listMapper(cfnEventDataStoreAdvancedFieldSelectorPropertyToCloudFormation)(properties.fieldSelectors), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnEventDataStoreAdvancedEventSelectorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldSelectors", "FieldSelectors", cfn_parse.FromCloudFormation.getArray(CfnEventDataStoreAdvancedFieldSelectorPropertyFromCloudFormation)(properties.FieldSelectors)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEventDataStore_AdvancedFieldSelectorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endsWith", cdk.listValidator(cdk.validateString))(properties.endsWith)), errors.collect(cdk.propertyValidator("equalTo", cdk.listValidator(cdk.validateString))(properties.equalTo)), errors.collect(cdk.propertyValidator("field", cdk.requiredValidator)(properties.field)), errors.collect(cdk.propertyValidator("field", cdk.validateString)(properties.field)), errors.collect(cdk.propertyValidator("notEndsWith", cdk.listValidator(cdk.validateString))(properties.notEndsWith)), errors.collect(cdk.propertyValidator("notEquals", cdk.listValidator(cdk.validateString))(properties.notEquals)), errors.collect(cdk.propertyValidator("notStartsWith", cdk.listValidator(cdk.validateString))(properties.notStartsWith)), errors.collect(cdk.propertyValidator("startsWith", cdk.listValidator(cdk.validateString))(properties.startsWith)), errors.wrap('supplied properties not correct for "AdvancedFieldSelectorProperty"');
    }
    function cfnEventDataStoreAdvancedFieldSelectorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventDataStore_AdvancedFieldSelectorPropertyValidator(properties).assertSuccess(), { EndsWith: cdk.listMapper(cdk.stringToCloudFormation)(properties.endsWith), Equals: cdk.listMapper(cdk.stringToCloudFormation)(properties.equalTo), Field: cdk.stringToCloudFormation(properties.field), NotEndsWith: cdk.listMapper(cdk.stringToCloudFormation)(properties.notEndsWith), NotEquals: cdk.listMapper(cdk.stringToCloudFormation)(properties.notEquals), NotStartsWith: cdk.listMapper(cdk.stringToCloudFormation)(properties.notStartsWith), StartsWith: cdk.listMapper(cdk.stringToCloudFormation)(properties.startsWith) }) : properties;
    }
    function CfnEventDataStoreAdvancedFieldSelectorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endsWith", "EndsWith", properties.EndsWith != null ? cfn_parse.FromCloudFormation.getStringArray(properties.EndsWith) : void 0), ret.addPropertyResult("equalTo", "Equals", properties.Equals != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Equals) : void 0), ret.addPropertyResult("field", "Field", cfn_parse.FromCloudFormation.getString(properties.Field)), ret.addPropertyResult("notEndsWith", "NotEndsWith", properties.NotEndsWith != null ? cfn_parse.FromCloudFormation.getStringArray(properties.NotEndsWith) : void 0), ret.addPropertyResult("notEquals", "NotEquals", properties.NotEquals != null ? cfn_parse.FromCloudFormation.getStringArray(properties.NotEquals) : void 0), ret.addPropertyResult("notStartsWith", "NotStartsWith", properties.NotStartsWith != null ? cfn_parse.FromCloudFormation.getStringArray(properties.NotStartsWith) : void 0), ret.addPropertyResult("startsWith", "StartsWith", properties.StartsWith != null ? cfn_parse.FromCloudFormation.getStringArray(properties.StartsWith) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourcePolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceArn", cdk.requiredValidator)(properties.resourceArn)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.collect(cdk.propertyValidator("resourcePolicy", cdk.requiredValidator)(properties.resourcePolicy)), errors.collect(cdk.propertyValidator("resourcePolicy", cdk.validateObject)(properties.resourcePolicy)), errors.wrap('supplied properties not correct for "CfnResourcePolicyProps"');
    }
    function cfnResourcePolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourcePolicyPropsValidator(properties).assertSuccess(), { ResourceArn: cdk.stringToCloudFormation(properties.resourceArn), ResourcePolicy: cdk.objectToCloudFormation(properties.resourcePolicy) }) : properties;
    }
    function CfnResourcePolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceArn", "ResourceArn", cfn_parse.FromCloudFormation.getString(properties.ResourceArn)), ret.addPropertyResult("resourcePolicy", "ResourcePolicy", cfn_parse.FromCloudFormation.getAny(properties.ResourcePolicy)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResourcePolicy = class _CfnResourcePolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResourcePolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnResourcePolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnResourcePolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudtrail_CfnResourcePolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResourcePolicy), error;
        }
        cdk.requireProperty(props, "resourceArn", this), cdk.requireProperty(props, "resourcePolicy", this), this.resourceArn = props.resourceArn, this.resourcePolicy = props.resourcePolicy;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResourcePolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { resourceArn: this.resourceArn, resourcePolicy: this.resourcePolicy };
      }
      renderProperties(props) {
        return cfnResourcePolicyPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnResourcePolicy[_c] = { fqn: "aws-cdk-lib.aws_cloudtrail.CfnResourcePolicy", version: "2.80.0" }, CfnResourcePolicy.CFN_RESOURCE_TYPE_NAME = "AWS::CloudTrail::ResourcePolicy", exports2.CfnResourcePolicy = CfnResourcePolicy;
    function CfnTrailPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchLogsLogGroupArn", cdk.validateString)(properties.cloudWatchLogsLogGroupArn)), errors.collect(cdk.propertyValidator("cloudWatchLogsRoleArn", cdk.validateString)(properties.cloudWatchLogsRoleArn)), errors.collect(cdk.propertyValidator("enableLogFileValidation", cdk.validateBoolean)(properties.enableLogFileValidation)), errors.collect(cdk.propertyValidator("eventSelectors", cdk.listValidator(CfnTrail_EventSelectorPropertyValidator))(properties.eventSelectors)), errors.collect(cdk.propertyValidator("includeGlobalServiceEvents", cdk.validateBoolean)(properties.includeGlobalServiceEvents)), errors.collect(cdk.propertyValidator("insightSelectors", cdk.listValidator(CfnTrail_InsightSelectorPropertyValidator))(properties.insightSelectors)), errors.collect(cdk.propertyValidator("isLogging", cdk.requiredValidator)(properties.isLogging)), errors.collect(cdk.propertyValidator("isLogging", cdk.validateBoolean)(properties.isLogging)), errors.collect(cdk.propertyValidator("isMultiRegionTrail", cdk.validateBoolean)(properties.isMultiRegionTrail)), errors.collect(cdk.propertyValidator("isOrganizationTrail", cdk.validateBoolean)(properties.isOrganizationTrail)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("s3BucketName", cdk.requiredValidator)(properties.s3BucketName)), errors.collect(cdk.propertyValidator("s3BucketName", cdk.validateString)(properties.s3BucketName)), errors.collect(cdk.propertyValidator("s3KeyPrefix", cdk.validateString)(properties.s3KeyPrefix)), errors.collect(cdk.propertyValidator("snsTopicName", cdk.validateString)(properties.snsTopicName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("trailName", cdk.validateString)(properties.trailName)), errors.wrap('supplied properties not correct for "CfnTrailProps"');
    }
    function cfnTrailPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTrailPropsValidator(properties).assertSuccess(), { IsLogging: cdk.booleanToCloudFormation(properties.isLogging), S3BucketName: cdk.stringToCloudFormation(properties.s3BucketName), CloudWatchLogsLogGroupArn: cdk.stringToCloudFormation(properties.cloudWatchLogsLogGroupArn), CloudWatchLogsRoleArn: cdk.stringToCloudFormation(properties.cloudWatchLogsRoleArn), EnableLogFileValidation: cdk.booleanToCloudFormation(properties.enableLogFileValidation), EventSelectors: cdk.listMapper(cfnTrailEventSelectorPropertyToCloudFormation)(properties.eventSelectors), IncludeGlobalServiceEvents: cdk.booleanToCloudFormation(properties.includeGlobalServiceEvents), InsightSelectors: cdk.listMapper(cfnTrailInsightSelectorPropertyToCloudFormation)(properties.insightSelectors), IsMultiRegionTrail: cdk.booleanToCloudFormation(properties.isMultiRegionTrail), IsOrganizationTrail: cdk.booleanToCloudFormation(properties.isOrganizationTrail), KMSKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), S3KeyPrefix: cdk.stringToCloudFormation(properties.s3KeyPrefix), SnsTopicName: cdk.stringToCloudFormation(properties.snsTopicName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TrailName: cdk.stringToCloudFormation(properties.trailName) }) : properties;
    }
    function CfnTrailPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("isLogging", "IsLogging", cfn_parse.FromCloudFormation.getBoolean(properties.IsLogging)), ret.addPropertyResult("s3BucketName", "S3BucketName", cfn_parse.FromCloudFormation.getString(properties.S3BucketName)), ret.addPropertyResult("cloudWatchLogsLogGroupArn", "CloudWatchLogsLogGroupArn", properties.CloudWatchLogsLogGroupArn != null ? cfn_parse.FromCloudFormation.getString(properties.CloudWatchLogsLogGroupArn) : void 0), ret.addPropertyResult("cloudWatchLogsRoleArn", "CloudWatchLogsRoleArn", properties.CloudWatchLogsRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.CloudWatchLogsRoleArn) : void 0), ret.addPropertyResult("enableLogFileValidation", "EnableLogFileValidation", properties.EnableLogFileValidation != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableLogFileValidation) : void 0), ret.addPropertyResult("eventSelectors", "EventSelectors", properties.EventSelectors != null ? cfn_parse.FromCloudFormation.getArray(CfnTrailEventSelectorPropertyFromCloudFormation)(properties.EventSelectors) : void 0), ret.addPropertyResult("includeGlobalServiceEvents", "IncludeGlobalServiceEvents", properties.IncludeGlobalServiceEvents != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeGlobalServiceEvents) : void 0), ret.addPropertyResult("insightSelectors", "InsightSelectors", properties.InsightSelectors != null ? cfn_parse.FromCloudFormation.getArray(CfnTrailInsightSelectorPropertyFromCloudFormation)(properties.InsightSelectors) : void 0), ret.addPropertyResult("isMultiRegionTrail", "IsMultiRegionTrail", properties.IsMultiRegionTrail != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsMultiRegionTrail) : void 0), ret.addPropertyResult("isOrganizationTrail", "IsOrganizationTrail", properties.IsOrganizationTrail != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsOrganizationTrail) : void 0), ret.addPropertyResult("kmsKeyId", "KMSKeyId", properties.KMSKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KMSKeyId) : void 0), ret.addPropertyResult("s3KeyPrefix", "S3KeyPrefix", properties.S3KeyPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.S3KeyPrefix) : void 0), ret.addPropertyResult("snsTopicName", "SnsTopicName", properties.SnsTopicName != null ? cfn_parse.FromCloudFormation.getString(properties.SnsTopicName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("trailName", "TrailName", properties.TrailName != null ? cfn_parse.FromCloudFormation.getString(properties.TrailName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTrail = class _CfnTrail extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTrailPropsFromCloudFormation(resourceProperties), ret = new _CfnTrail(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTrail.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudtrail_CfnTrailProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTrail), error;
        }
        cdk.requireProperty(props, "isLogging", this), cdk.requireProperty(props, "s3BucketName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrSnsTopicArn = cdk.Token.asString(this.getAtt("SnsTopicArn", cdk.ResolutionTypeHint.STRING)), this.isLogging = props.isLogging, this.s3BucketName = props.s3BucketName, this.cloudWatchLogsLogGroupArn = props.cloudWatchLogsLogGroupArn, this.cloudWatchLogsRoleArn = props.cloudWatchLogsRoleArn, this.enableLogFileValidation = props.enableLogFileValidation, this.eventSelectors = props.eventSelectors, this.includeGlobalServiceEvents = props.includeGlobalServiceEvents, this.insightSelectors = props.insightSelectors, this.isMultiRegionTrail = props.isMultiRegionTrail, this.isOrganizationTrail = props.isOrganizationTrail, this.kmsKeyId = props.kmsKeyId, this.s3KeyPrefix = props.s3KeyPrefix, this.snsTopicName = props.snsTopicName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::CloudTrail::Trail", props.tags, { tagPropertyName: "tags" }), this.trailName = props.trailName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTrail.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { isLogging: this.isLogging, s3BucketName: this.s3BucketName, cloudWatchLogsLogGroupArn: this.cloudWatchLogsLogGroupArn, cloudWatchLogsRoleArn: this.cloudWatchLogsRoleArn, enableLogFileValidation: this.enableLogFileValidation, eventSelectors: this.eventSelectors, includeGlobalServiceEvents: this.includeGlobalServiceEvents, insightSelectors: this.insightSelectors, isMultiRegionTrail: this.isMultiRegionTrail, isOrganizationTrail: this.isOrganizationTrail, kmsKeyId: this.kmsKeyId, s3KeyPrefix: this.s3KeyPrefix, snsTopicName: this.snsTopicName, tags: this.tags.renderTags(), trailName: this.trailName };
      }
      renderProperties(props) {
        return cfnTrailPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnTrail[_d] = { fqn: "aws-cdk-lib.aws_cloudtrail.CfnTrail", version: "2.80.0" }, CfnTrail.CFN_RESOURCE_TYPE_NAME = "AWS::CloudTrail::Trail", exports2.CfnTrail = CfnTrail;
    function CfnTrail_DataResourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "DataResourceProperty"');
    }
    function cfnTrailDataResourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTrail_DataResourcePropertyValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type), Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnTrailDataResourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTrail_EventSelectorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataResources", cdk.listValidator(CfnTrail_DataResourcePropertyValidator))(properties.dataResources)), errors.collect(cdk.propertyValidator("excludeManagementEventSources", cdk.listValidator(cdk.validateString))(properties.excludeManagementEventSources)), errors.collect(cdk.propertyValidator("includeManagementEvents", cdk.validateBoolean)(properties.includeManagementEvents)), errors.collect(cdk.propertyValidator("readWriteType", cdk.validateString)(properties.readWriteType)), errors.wrap('supplied properties not correct for "EventSelectorProperty"');
    }
    function cfnTrailEventSelectorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTrail_EventSelectorPropertyValidator(properties).assertSuccess(), { DataResources: cdk.listMapper(cfnTrailDataResourcePropertyToCloudFormation)(properties.dataResources), ExcludeManagementEventSources: cdk.listMapper(cdk.stringToCloudFormation)(properties.excludeManagementEventSources), IncludeManagementEvents: cdk.booleanToCloudFormation(properties.includeManagementEvents), ReadWriteType: cdk.stringToCloudFormation(properties.readWriteType) }) : properties;
    }
    function CfnTrailEventSelectorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataResources", "DataResources", properties.DataResources != null ? cfn_parse.FromCloudFormation.getArray(CfnTrailDataResourcePropertyFromCloudFormation)(properties.DataResources) : void 0), ret.addPropertyResult("excludeManagementEventSources", "ExcludeManagementEventSources", properties.ExcludeManagementEventSources != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExcludeManagementEventSources) : void 0), ret.addPropertyResult("includeManagementEvents", "IncludeManagementEvents", properties.IncludeManagementEvents != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeManagementEvents) : void 0), ret.addPropertyResult("readWriteType", "ReadWriteType", properties.ReadWriteType != null ? cfn_parse.FromCloudFormation.getString(properties.ReadWriteType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTrail_InsightSelectorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("insightType", cdk.validateString)(properties.insightType)), errors.wrap('supplied properties not correct for "InsightSelectorProperty"');
    }
    function cfnTrailInsightSelectorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTrail_InsightSelectorPropertyValidator(properties).assertSuccess(), { InsightType: cdk.stringToCloudFormation(properties.insightType) }) : properties;
    }
    function CfnTrailInsightSelectorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("insightType", "InsightType", properties.InsightType != null ? cfn_parse.FromCloudFormation.getString(properties.InsightType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-cloudtrail/lib/cloudtrail.js
var require_cloudtrail2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudtrail/lib/cloudtrail.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DataResourceType = exports2.ManagementEventSources = exports2.Trail = exports2.InsightType = exports2.ReadWriteType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cloudtrail_generated_1 = require_cloudtrail_generated();
    var events = require_aws_events();
    var iam = require_aws_iam();
    var logs = require_aws_logs();
    var s3 = require_aws_s3();
    var core_1 = require_core2();
    var ReadWriteType;
    (function(ReadWriteType2) {
      ReadWriteType2.READ_ONLY = "ReadOnly", ReadWriteType2.WRITE_ONLY = "WriteOnly", ReadWriteType2.ALL = "All", ReadWriteType2.NONE = "None";
    })(ReadWriteType = exports2.ReadWriteType || (exports2.ReadWriteType = {}));
    var InsightType = class {
      constructor(value) {
        this.value = value;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, InsightType[_a] = { fqn: "aws-cdk-lib.aws_cloudtrail.InsightType", version: "2.80.0" }, InsightType.API_CALL_RATE = new InsightType("ApiCallRateInsight"), InsightType.API_ERROR_RATE = new InsightType("ApiErrorRateInsight"), exports2.InsightType = InsightType;
    var Trail = class _Trail extends core_1.Resource {
      static onEvent(scope, id, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_OnEventOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.onEvent), error;
        }
        const rule = new events.Rule(scope, id, options);
        return rule.addTarget(options.target), rule.addEventPattern({ detailType: ["AWS API Call via CloudTrail"] }), rule;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.trailName }), this.eventSelectors = [];
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudtrail_TrailProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Trail), error;
        }
        const cloudTrailPrincipal = new iam.ServicePrincipal("cloudtrail.amazonaws.com");
        this.s3bucket = props.bucket || new s3.Bucket(this, "S3", { enforceSSL: true }), this.s3bucket.addToResourcePolicy(new iam.PolicyStatement({ resources: [this.s3bucket.bucketArn], actions: ["s3:GetBucketAcl"], principals: [cloudTrailPrincipal] })), this.s3bucket.addToResourcePolicy(new iam.PolicyStatement({ resources: [this.s3bucket.arnForObjects(`${props.s3KeyPrefix ? `${props.s3KeyPrefix}/` : ""}AWSLogs/${core_1.Stack.of(this).account}/*`)], actions: ["s3:PutObject"], principals: [cloudTrailPrincipal], conditions: { StringEquals: { "s3:x-amz-acl": "bucket-owner-full-control" } } })), this.topic = props.snsTopic, this.topic && this.topic.grantPublish(cloudTrailPrincipal);
        let logsRole;
        if (props.sendToCloudWatchLogs && (props.cloudWatchLogGroup ? this.logGroup = props.cloudWatchLogGroup : this.logGroup = new logs.LogGroup(this, "LogGroup", { retention: props.cloudWatchLogsRetention ?? logs.RetentionDays.ONE_YEAR }), logsRole = new iam.Role(this, "LogsRole", { assumedBy: cloudTrailPrincipal }), logsRole.addToPrincipalPolicy(new iam.PolicyStatement({ actions: ["logs:PutLogEvents", "logs:CreateLogStream"], resources: [this.logGroup.logGroupArn] }))), this.managementEvents = props.managementEvents, this.managementEvents && this.managementEvents !== ReadWriteType.NONE && this.eventSelectors.push({ includeManagementEvents: true, readWriteType: props.managementEvents }), this.node.addValidation({ validate: () => this.validateEventSelectors() }), props.kmsKey && props.encryptionKey)
          throw new Error("Both kmsKey and encryptionKey must not be specified. Use only encryptionKey");
        props.insightTypes && (this.insightTypeValues = props.insightTypes.map(function(t) {
          return { insightType: t.value };
        }));
        const trail = new cloudtrail_generated_1.CfnTrail(this, "Resource", { isLogging: true, enableLogFileValidation: props.enableFileValidation == null ? true : props.enableFileValidation, isMultiRegionTrail: props.isMultiRegionTrail == null ? true : props.isMultiRegionTrail, includeGlobalServiceEvents: props.includeGlobalServiceEvents == null ? true : props.includeGlobalServiceEvents, trailName: this.physicalName, kmsKeyId: props.encryptionKey?.keyArn ?? props.kmsKey?.keyArn, s3BucketName: this.s3bucket.bucketName, s3KeyPrefix: props.s3KeyPrefix, cloudWatchLogsLogGroupArn: this.logGroup?.logGroupArn, cloudWatchLogsRoleArn: logsRole?.roleArn, snsTopicName: this.topic?.topicName, eventSelectors: this.eventSelectors, isOrganizationTrail: props.isOrganizationTrail, insightSelectors: this.insightTypeValues });
        this.trailArn = this.getResourceArnAttribute(trail.attrArn, { service: "cloudtrail", resource: "trail", resourceName: this.physicalName }), this.trailSnsTopicArn = trail.attrSnsTopicArn, this.s3bucket.policy && trail.node.addDependency(this.s3bucket.policy), logsRole !== void 0 && trail.node.addDependency(logsRole);
      }
      addEventSelector(dataResourceType, dataResourceValues, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudtrail_DataResourceType(dataResourceType), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudtrail_AddEventSelectorOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addEventSelector), error;
        }
        if (dataResourceValues.length > 250)
          throw new Error("A maximum of 250 data elements can be in one event selector");
        if (this.eventSelectors.length > 5)
          throw new Error("A maximum of 5 event selectors are supported per trail.");
        let includeAllManagementEvents;
        this.managementEvents === ReadWriteType.NONE && (includeAllManagementEvents = false), this.eventSelectors.push({ dataResources: [{ type: dataResourceType, values: dataResourceValues }], includeManagementEvents: options.includeManagementEvents ?? includeAllManagementEvents, excludeManagementEventSources: options.excludeManagementEventSources, readWriteType: options.readWriteType });
      }
      addLambdaEventSelector(handlers, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudtrail_AddEventSelectorOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addLambdaEventSelector), error;
        }
        if (handlers.length === 0)
          return;
        const dataResourceValues = handlers.map((h) => h.functionArn);
        return this.addEventSelector(DataResourceType.LAMBDA_FUNCTION, dataResourceValues, options);
      }
      logAllLambdaDataEvents(options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudtrail_AddEventSelectorOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.logAllLambdaDataEvents), error;
        }
        return this.addEventSelector(DataResourceType.LAMBDA_FUNCTION, [`arn:${this.stack.partition}:lambda`], options);
      }
      addS3EventSelector(s3Selector, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudtrail_AddEventSelectorOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addS3EventSelector), error;
        }
        if (s3Selector.length === 0)
          return;
        const dataResourceValues = s3Selector.map((sel) => `${sel.bucket.bucketArn}/${sel.objectPrefix ?? ""}`);
        return this.addEventSelector(DataResourceType.S3_OBJECT, dataResourceValues, options);
      }
      logAllS3DataEvents(options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudtrail_AddEventSelectorOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.logAllS3DataEvents), error;
        }
        return this.addEventSelector(DataResourceType.S3_OBJECT, [`arn:${this.stack.partition}:s3:::`], options);
      }
      onCloudTrailEvent(id, options = {}) {
        return _Trail.onEvent(this, id, options);
      }
      validateEventSelectors() {
        const errors = [];
        return this.managementEvents === ReadWriteType.NONE && this.eventSelectors.length === 0 && errors.push("At least one event selector must be added when management event recording is set to None"), errors;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, Trail[_b] = { fqn: "aws-cdk-lib.aws_cloudtrail.Trail", version: "2.80.0" }, exports2.Trail = Trail;
    var ManagementEventSources;
    (function(ManagementEventSources2) {
      ManagementEventSources2.KMS = "kms.amazonaws.com", ManagementEventSources2.RDS_DATA_API = "rdsdata.amazonaws.com";
    })(ManagementEventSources = exports2.ManagementEventSources || (exports2.ManagementEventSources = {}));
    var DataResourceType;
    (function(DataResourceType2) {
      DataResourceType2.LAMBDA_FUNCTION = "AWS::Lambda::Function", DataResourceType2.S3_OBJECT = "AWS::S3::Object";
    })(DataResourceType = exports2.DataResourceType || (exports2.DataResourceType = {}));
  }
});

// node_modules/aws-cdk-lib/aws-cloudtrail/lib/index.js
var require_lib73 = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudtrail/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_cloudtrail2(), exports2), __exportStar(require_cloudtrail_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-cloudtrail/index.js
var require_aws_cloudtrail = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudtrail/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib73(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-cloudwatch-actions/lib/appscaling.js
var require_appscaling = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudwatch-actions/lib/appscaling.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ApplicationScalingAction = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var ApplicationScalingAction = class _ApplicationScalingAction {
      constructor(stepScalingAction) {
        this.stepScalingAction = stepScalingAction;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_applicationautoscaling_StepScalingAction(stepScalingAction);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ApplicationScalingAction), error;
        }
      }
      bind(_scope, _alarm) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_IAlarm(_alarm);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { alarmActionArn: this.stepScalingAction.scalingPolicyArn };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ApplicationScalingAction[_a] = { fqn: "aws-cdk-lib.aws_cloudwatch_actions.ApplicationScalingAction", version: "2.80.0" }, exports2.ApplicationScalingAction = ApplicationScalingAction;
  }
});

// node_modules/aws-cdk-lib/aws-cloudwatch-actions/lib/autoscaling.js
var require_autoscaling2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudwatch-actions/lib/autoscaling.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AutoScalingAction = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var AutoScalingAction = class _AutoScalingAction {
      constructor(stepScalingAction) {
        this.stepScalingAction = stepScalingAction;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_StepScalingAction(stepScalingAction);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AutoScalingAction), error;
        }
      }
      bind(_scope, _alarm) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_IAlarm(_alarm);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { alarmActionArn: this.stepScalingAction.scalingPolicyArn };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AutoScalingAction[_a] = { fqn: "aws-cdk-lib.aws_cloudwatch_actions.AutoScalingAction", version: "2.80.0" }, exports2.AutoScalingAction = AutoScalingAction;
  }
});

// node_modules/aws-cdk-lib/aws-cloudwatch-actions/lib/sns.js
var require_sns2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudwatch-actions/lib/sns.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SnsAction = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var SnsAction = class _SnsAction {
      constructor(topic) {
        this.topic = topic;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sns_ITopic(topic);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SnsAction), error;
        }
      }
      bind(_scope, _alarm) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_IAlarm(_alarm);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { alarmActionArn: this.topic.topicArn };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SnsAction[_a] = { fqn: "aws-cdk-lib.aws_cloudwatch_actions.SnsAction", version: "2.80.0" }, exports2.SnsAction = SnsAction;
  }
});

// node_modules/aws-cdk-lib/aws-cloudwatch-actions/lib/ec2.js
var require_ec23 = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudwatch-actions/lib/ec2.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Ec2Action = exports2.Ec2InstanceAction = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core_1 = require_core2();
    var Ec2InstanceAction;
    (function(Ec2InstanceAction2) {
      Ec2InstanceAction2.STOP = "stop", Ec2InstanceAction2.TERMINATE = "terminate", Ec2InstanceAction2.RECOVER = "recover", Ec2InstanceAction2.REBOOT = "reboot";
    })(Ec2InstanceAction = exports2.Ec2InstanceAction || (exports2.Ec2InstanceAction = {}));
    var Ec2Action = class _Ec2Action {
      constructor(instanceAction) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_actions_Ec2InstanceAction(instanceAction);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Ec2Action), error;
        }
        this.ec2Action = instanceAction;
      }
      bind(_scope, _alarm) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_IAlarm(_alarm);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { alarmActionArn: `arn:${core_1.Stack.of(_scope).partition}:automate:${core_1.Stack.of(_scope).region}:ec2:${this.ec2Action}` };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Ec2Action[_a] = { fqn: "aws-cdk-lib.aws_cloudwatch_actions.Ec2Action", version: "2.80.0" }, exports2.Ec2Action = Ec2Action;
  }
});

// node_modules/aws-cdk-lib/aws-cloudwatch-actions/lib/ssm.js
var require_ssm2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudwatch-actions/lib/ssm.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SsmIncidentAction = exports2.SsmAction = exports2.OpsItemCategory = exports2.OpsItemSeverity = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core_1 = require_core2();
    var OpsItemSeverity;
    (function(OpsItemSeverity2) {
      OpsItemSeverity2.CRITICAL = "1", OpsItemSeverity2.HIGH = "2", OpsItemSeverity2.MEDIUM = "3", OpsItemSeverity2.LOW = "4";
    })(OpsItemSeverity = exports2.OpsItemSeverity || (exports2.OpsItemSeverity = {}));
    var OpsItemCategory;
    (function(OpsItemCategory2) {
      OpsItemCategory2.AVAILABILITY = "Availability", OpsItemCategory2.COST = "Cost", OpsItemCategory2.PERFORMANCE = "Performance", OpsItemCategory2.RECOVERY = "Recovery", OpsItemCategory2.SECURITY = "Security";
    })(OpsItemCategory = exports2.OpsItemCategory || (exports2.OpsItemCategory = {}));
    var SsmAction = class _SsmAction {
      constructor(severity, category) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_actions_OpsItemSeverity(severity), jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_actions_OpsItemCategory(category);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SsmAction), error;
        }
        this.severity = severity, this.category = category;
      }
      bind(_scope, _alarm) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_IAlarm(_alarm);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return this.category === void 0 ? { alarmActionArn: `arn:${core_1.Stack.of(_scope).partition}:ssm:${core_1.Stack.of(_scope).region}:${core_1.Stack.of(_scope).account}:opsitem:${this.severity}` } : { alarmActionArn: `arn:${core_1.Stack.of(_scope).partition}:ssm:${core_1.Stack.of(_scope).region}:${core_1.Stack.of(_scope).account}:opsitem:${this.severity}#CATEGORY=${this.category}` };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SsmAction[_a] = { fqn: "aws-cdk-lib.aws_cloudwatch_actions.SsmAction", version: "2.80.0" }, exports2.SsmAction = SsmAction;
    var SsmIncidentAction = class {
      constructor(responsePlanName) {
        this.responsePlanName = responsePlanName;
      }
      bind(_scope, _alarm) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_IAlarm(_alarm);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { alarmActionArn: `arn:${core_1.Stack.of(_scope).partition}:ssm-incidents::${core_1.Stack.of(_scope).account}:response-plan/${this.responsePlanName}` };
      }
    };
    _b = JSII_RTTI_SYMBOL_1, SsmIncidentAction[_b] = { fqn: "aws-cdk-lib.aws_cloudwatch_actions.SsmIncidentAction", version: "2.80.0" }, exports2.SsmIncidentAction = SsmIncidentAction;
  }
});

// node_modules/aws-cdk-lib/aws-cloudwatch-actions/lib/index.js
var require_lib74 = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudwatch-actions/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_appscaling(), exports2), __exportStar(require_autoscaling2(), exports2), __exportStar(require_sns2(), exports2), __exportStar(require_ec23(), exports2), __exportStar(require_ssm2(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-cloudwatch-actions/index.js
var require_aws_cloudwatch_actions = __commonJS({
  "node_modules/aws-cdk-lib/aws-cloudwatch-actions/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib74(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-codeartifact/lib/codeartifact.generated.js
var require_codeartifact_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-codeartifact/lib/codeartifact.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnRepository = exports2.CfnDomain = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnDomainPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("domainName", cdk.requiredValidator)(properties.domainName)), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.collect(cdk.propertyValidator("encryptionKey", cdk.validateString)(properties.encryptionKey)), errors.collect(cdk.propertyValidator("permissionsPolicyDocument", cdk.validateObject)(properties.permissionsPolicyDocument)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDomainProps"');
    }
    function cfnDomainPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomainPropsValidator(properties).assertSuccess(), { DomainName: cdk.stringToCloudFormation(properties.domainName), EncryptionKey: cdk.stringToCloudFormation(properties.encryptionKey), PermissionsPolicyDocument: cdk.objectToCloudFormation(properties.permissionsPolicyDocument), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDomainPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("domainName", "DomainName", cfn_parse.FromCloudFormation.getString(properties.DomainName)), ret.addPropertyResult("encryptionKey", "EncryptionKey", properties.EncryptionKey != null ? cfn_parse.FromCloudFormation.getString(properties.EncryptionKey) : void 0), ret.addPropertyResult("permissionsPolicyDocument", "PermissionsPolicyDocument", properties.PermissionsPolicyDocument != null ? cfn_parse.FromCloudFormation.getAny(properties.PermissionsPolicyDocument) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDomain = class _CfnDomain extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDomainPropsFromCloudFormation(resourceProperties), ret = new _CfnDomain(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDomain.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codeartifact_CfnDomainProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDomain), error;
        }
        cdk.requireProperty(props, "domainName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrEncryptionKey = cdk.Token.asString(this.getAtt("EncryptionKey", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.attrOwner = cdk.Token.asString(this.getAtt("Owner", cdk.ResolutionTypeHint.STRING)), this.domainName = props.domainName, this.encryptionKey = props.encryptionKey, this.permissionsPolicyDocument = props.permissionsPolicyDocument, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::CodeArtifact::Domain", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDomain.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { domainName: this.domainName, encryptionKey: this.encryptionKey, permissionsPolicyDocument: this.permissionsPolicyDocument, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDomainPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnDomain[_a] = { fqn: "aws-cdk-lib.aws_codeartifact.CfnDomain", version: "2.80.0" }, CfnDomain.CFN_RESOURCE_TYPE_NAME = "AWS::CodeArtifact::Domain", exports2.CfnDomain = CfnDomain;
    function CfnRepositoryPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("domainName", cdk.requiredValidator)(properties.domainName)), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.collect(cdk.propertyValidator("domainOwner", cdk.validateString)(properties.domainOwner)), errors.collect(cdk.propertyValidator("externalConnections", cdk.listValidator(cdk.validateString))(properties.externalConnections)), errors.collect(cdk.propertyValidator("permissionsPolicyDocument", cdk.validateObject)(properties.permissionsPolicyDocument)), errors.collect(cdk.propertyValidator("repositoryName", cdk.requiredValidator)(properties.repositoryName)), errors.collect(cdk.propertyValidator("repositoryName", cdk.validateString)(properties.repositoryName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("upstreams", cdk.listValidator(cdk.validateString))(properties.upstreams)), errors.wrap('supplied properties not correct for "CfnRepositoryProps"');
    }
    function cfnRepositoryPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRepositoryPropsValidator(properties).assertSuccess(), { DomainName: cdk.stringToCloudFormation(properties.domainName), RepositoryName: cdk.stringToCloudFormation(properties.repositoryName), Description: cdk.stringToCloudFormation(properties.description), DomainOwner: cdk.stringToCloudFormation(properties.domainOwner), ExternalConnections: cdk.listMapper(cdk.stringToCloudFormation)(properties.externalConnections), PermissionsPolicyDocument: cdk.objectToCloudFormation(properties.permissionsPolicyDocument), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), Upstreams: cdk.listMapper(cdk.stringToCloudFormation)(properties.upstreams) }) : properties;
    }
    function CfnRepositoryPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("domainName", "DomainName", cfn_parse.FromCloudFormation.getString(properties.DomainName)), ret.addPropertyResult("repositoryName", "RepositoryName", cfn_parse.FromCloudFormation.getString(properties.RepositoryName)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("domainOwner", "DomainOwner", properties.DomainOwner != null ? cfn_parse.FromCloudFormation.getString(properties.DomainOwner) : void 0), ret.addPropertyResult("externalConnections", "ExternalConnections", properties.ExternalConnections != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExternalConnections) : void 0), ret.addPropertyResult("permissionsPolicyDocument", "PermissionsPolicyDocument", properties.PermissionsPolicyDocument != null ? cfn_parse.FromCloudFormation.getAny(properties.PermissionsPolicyDocument) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("upstreams", "Upstreams", properties.Upstreams != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Upstreams) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRepository = class _CfnRepository extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRepositoryPropsFromCloudFormation(resourceProperties), ret = new _CfnRepository(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRepository.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codeartifact_CfnRepositoryProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRepository), error;
        }
        cdk.requireProperty(props, "domainName", this), cdk.requireProperty(props, "repositoryName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrDomainName = cdk.Token.asString(this.getAtt("DomainName", cdk.ResolutionTypeHint.STRING)), this.attrDomainOwner = cdk.Token.asString(this.getAtt("DomainOwner", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.domainName = props.domainName, this.repositoryName = props.repositoryName, this.description = props.description, this.domainOwner = props.domainOwner, this.externalConnections = props.externalConnections, this.permissionsPolicyDocument = props.permissionsPolicyDocument, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::CodeArtifact::Repository", props.tags, { tagPropertyName: "tags" }), this.upstreams = props.upstreams;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRepository.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { domainName: this.domainName, repositoryName: this.repositoryName, description: this.description, domainOwner: this.domainOwner, externalConnections: this.externalConnections, permissionsPolicyDocument: this.permissionsPolicyDocument, tags: this.tags.renderTags(), upstreams: this.upstreams };
      }
      renderProperties(props) {
        return cfnRepositoryPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnRepository[_b] = { fqn: "aws-cdk-lib.aws_codeartifact.CfnRepository", version: "2.80.0" }, CfnRepository.CFN_RESOURCE_TYPE_NAME = "AWS::CodeArtifact::Repository", exports2.CfnRepository = CfnRepository;
  }
});

// node_modules/aws-cdk-lib/aws-codeartifact/lib/index.js
var require_lib75 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codeartifact/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_codeartifact_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-codeartifact/index.js
var require_aws_codeartifact = __commonJS({
  "node_modules/aws-cdk-lib/aws-codeartifact/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib75(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-codebuild/lib/events.js
var require_events = __commonJS({
  "node_modules/aws-cdk-lib/aws-codebuild/lib/events.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PhaseChangeEvent = exports2.StateChangeEvent = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var events = require_aws_events();
    var StateChangeEvent = class {
      static get buildStatus() {
        return events.EventField.fromPath("$.detail.build-status");
      }
      static get projectName() {
        return events.EventField.fromPath("$.detail.project-name");
      }
      static get buildId() {
        return events.EventField.fromPath("$.detail.build-id");
      }
      static get currentPhase() {
        return events.EventField.fromPath("$.detail.current-phase");
      }
      constructor() {
      }
    };
    _a = JSII_RTTI_SYMBOL_1, StateChangeEvent[_a] = { fqn: "aws-cdk-lib.aws_codebuild.StateChangeEvent", version: "2.80.0" }, exports2.StateChangeEvent = StateChangeEvent;
    var PhaseChangeEvent = class {
      static get projectName() {
        return events.EventField.fromPath("$.detail.project-name");
      }
      static get buildId() {
        return events.EventField.fromPath("$.detail.build-id");
      }
      static get completedPhase() {
        return events.EventField.fromPath("$.detail.completed-phase");
      }
      static get completedPhaseStatus() {
        return events.EventField.fromPath("$.detail.completed-phase-status");
      }
      static get completedPhaseDurationSeconds() {
        return events.EventField.fromPath("$.detail.completed-phase-duration-seconds");
      }
      static get buildComplete() {
        return events.EventField.fromPath("$.detail.build-complete");
      }
      constructor() {
      }
    };
    _b = JSII_RTTI_SYMBOL_1, PhaseChangeEvent[_b] = { fqn: "aws-cdk-lib.aws_codebuild.PhaseChangeEvent", version: "2.80.0" }, exports2.PhaseChangeEvent = PhaseChangeEvent;
  }
});

// node_modules/aws-cdk-lib/aws-codebuild/lib/artifacts.js
var require_artifacts = __commonJS({
  "node_modules/aws-cdk-lib/aws-codebuild/lib/artifacts.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Artifacts = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var Artifacts = class _Artifacts {
      static s3(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_S3ArtifactsProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.s3), error;
        }
        return new S3Artifacts(props);
      }
      constructor(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_ArtifactsProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Artifacts), error;
        }
        this.identifier = props.identifier;
      }
      bind(_scope, _project) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_IProject(_project);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { artifactsProperty: { artifactIdentifier: this.identifier, type: this.type } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Artifacts[_a] = { fqn: "aws-cdk-lib.aws_codebuild.Artifacts", version: "2.80.0" }, exports2.Artifacts = Artifacts;
    var S3Artifacts = class extends Artifacts {
      constructor(props) {
        super(props), this.props = props, this.type = "S3";
      }
      bind(_scope, project) {
        return this.props.bucket.grantReadWrite(project), { artifactsProperty: { ...super.bind(_scope, project).artifactsProperty, location: this.props.bucket.bucketName, path: this.props.path, namespaceType: this.props.includeBuildId === false ? "NONE" : "BUILD_ID", name: this.props.name == null ? void 0 : this.props.name, packaging: this.props.packageZip === false ? "NONE" : "ZIP", encryptionDisabled: this.props.encryption === false ? true : void 0, overrideArtifactName: this.props.name == null ? true : void 0 } };
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-codebuild/lib/codepipeline-artifacts.js
var require_codepipeline_artifacts = __commonJS({
  "node_modules/aws-cdk-lib/aws-codebuild/lib/codepipeline-artifacts.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CodePipelineArtifacts = void 0;
    var artifacts_1 = require_artifacts();
    var CodePipelineArtifacts = class extends artifacts_1.Artifacts {
      constructor() {
        super({}), this.type = "CODEPIPELINE";
      }
    };
    exports2.CodePipelineArtifacts = CodePipelineArtifacts;
  }
});

// node_modules/aws-cdk-lib/aws-codebuild/lib/source-types.js
var require_source_types = __commonJS({
  "node_modules/aws-cdk-lib/aws-codebuild/lib/source-types.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.BITBUCKET_SOURCE_TYPE = exports2.GITHUB_ENTERPRISE_SOURCE_TYPE = exports2.GITHUB_SOURCE_TYPE = exports2.CODECOMMIT_SOURCE_TYPE = exports2.S3_SOURCE_TYPE = exports2.CODEPIPELINE_SOURCE_ARTIFACTS_TYPE = exports2.NO_SOURCE_TYPE = void 0, exports2.NO_SOURCE_TYPE = "NO_SOURCE", exports2.CODEPIPELINE_SOURCE_ARTIFACTS_TYPE = "CODEPIPELINE", exports2.S3_SOURCE_TYPE = "S3", exports2.CODECOMMIT_SOURCE_TYPE = "CODECOMMIT", exports2.GITHUB_SOURCE_TYPE = "GITHUB", exports2.GITHUB_ENTERPRISE_SOURCE_TYPE = "GITHUB_ENTERPRISE", exports2.BITBUCKET_SOURCE_TYPE = "BITBUCKET";
  }
});

// node_modules/aws-cdk-lib/aws-codebuild/lib/source.js
var require_source = __commonJS({
  "node_modules/aws-cdk-lib/aws-codebuild/lib/source.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FilterGroup = exports2.EventAction = exports2.Source = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var source_types_1 = require_source_types();
    var iam = require_aws_iam();
    var Source = class _Source {
      static s3(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_S3SourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.s3), error;
        }
        return new S3Source(props);
      }
      static codeCommit(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_CodeCommitSourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.codeCommit), error;
        }
        return new CodeCommitSource(props);
      }
      static gitHub(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_GitHubSourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.gitHub), error;
        }
        return new GitHubSource(props);
      }
      static gitHubEnterprise(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_GitHubEnterpriseSourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.gitHubEnterprise), error;
        }
        return new GitHubEnterpriseSource(props);
      }
      static bitBucket(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_BitBucketSourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bitBucket), error;
        }
        return new BitBucketSource(props);
      }
      constructor(props) {
        this.badgeSupported = false;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_SourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Source), error;
        }
        this.identifier = props.identifier;
      }
      bind(_scope, _project) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_IProject(_project);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { sourceProperty: { sourceIdentifier: this.identifier, type: this.type } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Source[_a] = { fqn: "aws-cdk-lib.aws_codebuild.Source", version: "2.80.0" }, exports2.Source = Source;
    var GitSource = class extends Source {
      constructor(props) {
        super(props), this.cloneDepth = props.cloneDepth, this.branchOrRef = props.branchOrRef, this.fetchSubmodules = props.fetchSubmodules;
      }
      bind(_scope, _project) {
        const superConfig = super.bind(_scope, _project);
        return { sourceVersion: this.branchOrRef, sourceProperty: { ...superConfig.sourceProperty, gitCloneDepth: this.cloneDepth, gitSubmodulesConfig: this.fetchSubmodules ? { fetchSubmodules: this.fetchSubmodules } : void 0 } };
      }
    };
    var EventAction;
    (function(EventAction2) {
      EventAction2.PUSH = "PUSH", EventAction2.PULL_REQUEST_CREATED = "PULL_REQUEST_CREATED", EventAction2.PULL_REQUEST_UPDATED = "PULL_REQUEST_UPDATED", EventAction2.PULL_REQUEST_MERGED = "PULL_REQUEST_MERGED", EventAction2.PULL_REQUEST_REOPENED = "PULL_REQUEST_REOPENED";
    })(EventAction = exports2.EventAction || (exports2.EventAction = {}));
    var WebhookFilterTypes;
    (function(WebhookFilterTypes2) {
      WebhookFilterTypes2.FILE_PATH = "FILE_PATH", WebhookFilterTypes2.COMMIT_MESSAGE = "COMMIT_MESSAGE", WebhookFilterTypes2.HEAD_REF = "HEAD_REF", WebhookFilterTypes2.ACTOR_ACCOUNT_ID = "ACTOR_ACCOUNT_ID", WebhookFilterTypes2.BASE_REF = "BASE_REF";
    })(WebhookFilterTypes || (WebhookFilterTypes = {}));
    var FilterGroup = class _FilterGroup {
      static inEventOf(...actions) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_EventAction(actions);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inEventOf), error;
        }
        return new _FilterGroup(new Set(actions), []);
      }
      constructor(actions, filters) {
        if (actions.size === 0)
          throw new Error("A filter group must contain at least one event action");
        this.actions = actions, this.filters = filters;
      }
      andBranchIs(branchName) {
        return this.addHeadBranchFilter(branchName, true);
      }
      andBranchIsNot(branchName) {
        return this.addHeadBranchFilter(branchName, false);
      }
      andCommitMessageIs(commitMessage) {
        return this.addCommitMessageFilter(commitMessage, true);
      }
      andCommitMessageIsNot(commitMessage) {
        return this.addCommitMessageFilter(commitMessage, false);
      }
      andTagIs(tagName) {
        return this.addHeadTagFilter(tagName, true);
      }
      andTagIsNot(tagName) {
        return this.addHeadTagFilter(tagName, false);
      }
      andHeadRefIs(pattern) {
        return this.addHeadRefFilter(pattern, true);
      }
      andHeadRefIsNot(pattern) {
        return this.addHeadRefFilter(pattern, false);
      }
      andActorAccountIs(pattern) {
        return this.addActorAccountId(pattern, true);
      }
      andActorAccountIsNot(pattern) {
        return this.addActorAccountId(pattern, false);
      }
      andBaseBranchIs(branchName) {
        return this.addBaseBranchFilter(branchName, true);
      }
      andBaseBranchIsNot(branchName) {
        return this.addBaseBranchFilter(branchName, false);
      }
      andBaseRefIs(pattern) {
        return this.addBaseRefFilter(pattern, true);
      }
      andBaseRefIsNot(pattern) {
        return this.addBaseRefFilter(pattern, false);
      }
      andFilePathIs(pattern) {
        return this.addFilePathFilter(pattern, true);
      }
      andFilePathIsNot(pattern) {
        return this.addFilePathFilter(pattern, false);
      }
      get _actions() {
        return set2Array(this.actions);
      }
      get _filters() {
        return this.filters.slice();
      }
      _toJson() {
        return [{ type: "EVENT", pattern: set2Array(this.actions).join(", ") }].concat(this.filters);
      }
      addCommitMessageFilter(commitMessage, include) {
        return this.addFilter(WebhookFilterTypes.COMMIT_MESSAGE, commitMessage, include);
      }
      addHeadBranchFilter(branchName, include) {
        return this.addHeadRefFilter(`refs/heads/${branchName}`, include);
      }
      addHeadTagFilter(tagName, include) {
        return this.addHeadRefFilter(`refs/tags/${tagName}`, include);
      }
      addHeadRefFilter(refName, include) {
        return this.addFilter(WebhookFilterTypes.HEAD_REF, refName, include);
      }
      addActorAccountId(accountId, include) {
        return this.addFilter(WebhookFilterTypes.ACTOR_ACCOUNT_ID, accountId, include);
      }
      addBaseBranchFilter(branchName, include) {
        return this.addBaseRefFilter(`refs/heads/${branchName}`, include);
      }
      addBaseRefFilter(refName, include) {
        if (this.actions.has(EventAction.PUSH))
          throw new Error("A base reference condition cannot be added if a Group contains a PUSH event action");
        return this.addFilter(WebhookFilterTypes.BASE_REF, refName, include);
      }
      addFilePathFilter(pattern, include) {
        return this.addFilter(WebhookFilterTypes.FILE_PATH, pattern, include);
      }
      addFilter(type, pattern, include) {
        return new _FilterGroup(this.actions, this.filters.concat([{ type, pattern, excludeMatchedPattern: include ? void 0 : true }]));
      }
    };
    _b = JSII_RTTI_SYMBOL_1, FilterGroup[_b] = { fqn: "aws-cdk-lib.aws_codebuild.FilterGroup", version: "2.80.0" }, exports2.FilterGroup = FilterGroup;
    var ThirdPartyGitSource = class extends GitSource {
      constructor(props) {
        super(props), this.badgeSupported = true, this.webhook = props.webhook, this.reportBuildStatus = props.reportBuildStatus ?? true, this.webhookFilters = props.webhookFilters || [], this.webhookTriggersBatchBuild = props.webhookTriggersBatchBuild, this.buildStatusUrl = props.buildStatusUrl;
      }
      bind(_scope, project) {
        const anyFilterGroupsProvided = this.webhookFilters.length > 0, webhook = this.webhook ?? (anyFilterGroupsProvided ? true : void 0);
        if (!webhook && anyFilterGroupsProvided)
          throw new Error("`webhookFilters` cannot be used when `webhook` is `false`");
        if (!webhook && this.webhookTriggersBatchBuild)
          throw new Error("`webhookTriggersBatchBuild` cannot be used when `webhook` is `false`");
        const superConfig = super.bind(_scope, project);
        return this.webhookTriggersBatchBuild && project.enableBatchBuilds(), { sourceProperty: { ...superConfig.sourceProperty, reportBuildStatus: this.reportBuildStatus }, sourceVersion: superConfig.sourceVersion, buildTriggers: webhook === void 0 ? void 0 : { webhook, buildType: this.webhookTriggersBatchBuild ? "BUILD_BATCH" : void 0, filterGroups: anyFilterGroupsProvided ? this.webhookFilters.map((fg) => fg._toJson()) : void 0 } };
      }
    };
    var CodeCommitSource = class extends GitSource {
      constructor(props) {
        super(props), this.badgeSupported = true, this.type = source_types_1.CODECOMMIT_SOURCE_TYPE, this.repo = props.repository;
      }
      bind(_scope, project) {
        project.addToRolePolicy(new iam.PolicyStatement({ actions: ["codecommit:GitPull"], resources: [this.repo.repositoryArn] }));
        const superConfig = super.bind(_scope, project);
        return { sourceProperty: { ...superConfig.sourceProperty, location: this.repo.repositoryCloneUrlHttp }, sourceVersion: superConfig.sourceVersion };
      }
    };
    var S3Source = class extends Source {
      constructor(props) {
        super(props), this.type = source_types_1.S3_SOURCE_TYPE, this.bucket = props.bucket, this.path = props.path, this.version = props.version;
      }
      bind(_scope, project) {
        return this.bucket.grantRead(project, this.path), { sourceProperty: { ...super.bind(_scope, project).sourceProperty, location: `${this.bucket.bucketName}/${this.path}` }, sourceVersion: this.version };
      }
    };
    var CommonGithubSource = class extends ThirdPartyGitSource {
      constructor(props) {
        super(props), this.buildStatusContext = props.buildStatusContext;
      }
      bind(scope, project) {
        const superConfig = super.bind(scope, project);
        return { sourceProperty: { ...superConfig.sourceProperty, buildStatusConfig: this.buildStatusContext !== void 0 || this.buildStatusUrl !== void 0 ? { context: this.buildStatusContext, targetUrl: this.buildStatusUrl } : void 0 }, sourceVersion: superConfig.sourceVersion, buildTriggers: superConfig.buildTriggers };
      }
    };
    var GitHubSource = class extends CommonGithubSource {
      constructor(props) {
        super(props), this.type = source_types_1.GITHUB_SOURCE_TYPE, this.httpsCloneUrl = `https://github.com/${props.owner}/${props.repo}.git`;
      }
      bind(_scope, project) {
        const superConfig = super.bind(_scope, project);
        return { sourceProperty: { ...superConfig.sourceProperty, location: this.httpsCloneUrl }, sourceVersion: superConfig.sourceVersion, buildTriggers: superConfig.buildTriggers };
      }
    };
    var GitHubEnterpriseSource = class extends CommonGithubSource {
      constructor(props) {
        super(props), this.type = source_types_1.GITHUB_ENTERPRISE_SOURCE_TYPE, this.httpsCloneUrl = props.httpsCloneUrl, this.ignoreSslErrors = props.ignoreSslErrors;
      }
      bind(_scope, _project) {
        if (this.hasCommitMessageFilterAndPrEvent())
          throw new Error("COMMIT_MESSAGE filters cannot be used with GitHub Enterprise Server pull request events");
        if (this.hasFilePathFilterAndPrEvent())
          throw new Error("FILE_PATH filters cannot be used with GitHub Enterprise Server pull request events");
        const superConfig = super.bind(_scope, _project);
        return { sourceProperty: { ...superConfig.sourceProperty, location: this.httpsCloneUrl, insecureSsl: this.ignoreSslErrors }, sourceVersion: superConfig.sourceVersion, buildTriggers: superConfig.buildTriggers };
      }
      hasCommitMessageFilterAndPrEvent() {
        return this.webhookFilters.some((fg) => fg._filters.some((fp) => fp.type === WebhookFilterTypes.COMMIT_MESSAGE) && this.hasPrEvent(fg._actions));
      }
      hasFilePathFilterAndPrEvent() {
        return this.webhookFilters.some((fg) => fg._filters.some((fp) => fp.type === WebhookFilterTypes.FILE_PATH) && this.hasPrEvent(fg._actions));
      }
      hasPrEvent(actions) {
        return actions.includes(EventAction.PULL_REQUEST_CREATED || EventAction.PULL_REQUEST_MERGED || EventAction.PULL_REQUEST_REOPENED || EventAction.PULL_REQUEST_UPDATED);
      }
    };
    var BitBucketSource = class extends ThirdPartyGitSource {
      constructor(props) {
        super(props), this.type = source_types_1.BITBUCKET_SOURCE_TYPE, this.httpsCloneUrl = `https://bitbucket.org/${props.owner}/${props.repo}.git`, this.buildStatusName = props.buildStatusName;
      }
      bind(_scope, _project) {
        if (this.anyWebhookFilterContainsPrReopenedEventAction())
          throw new Error("BitBucket sources do not support the PULL_REQUEST_REOPENED webhook event action");
        const superConfig = super.bind(_scope, _project);
        return { sourceProperty: { ...superConfig.sourceProperty, location: this.httpsCloneUrl, buildStatusConfig: this.buildStatusName !== void 0 || this.buildStatusUrl !== void 0 ? { context: this.buildStatusName, targetUrl: this.buildStatusUrl } : void 0 }, sourceVersion: superConfig.sourceVersion, buildTriggers: superConfig.buildTriggers };
      }
      anyWebhookFilterContainsPrReopenedEventAction() {
        return this.webhookFilters.findIndex((fg) => fg._actions.findIndex((a) => a === EventAction.PULL_REQUEST_REOPENED) !== -1) !== -1;
      }
    };
    function set2Array(set) {
      const ret = [];
      return set.forEach((el) => ret.push(el)), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-codebuild/lib/codepipeline-source.js
var require_codepipeline_source = __commonJS({
  "node_modules/aws-cdk-lib/aws-codebuild/lib/codepipeline-source.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CodePipelineSource = void 0;
    var source_1 = require_source();
    var source_types_1 = require_source_types();
    var CodePipelineSource = class extends source_1.Source {
      constructor() {
        super({}), this.type = source_types_1.CODEPIPELINE_SOURCE_ARTIFACTS_TYPE;
      }
    };
    exports2.CodePipelineSource = CodePipelineSource;
  }
});

// node_modules/aws-cdk-lib/aws-codebuild/lib/private/yaml-cfn.js
var require_yaml_cfn2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codebuild/lib/private/yaml-cfn.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.serialize = void 0;
    var yaml = require_yaml();
    var yaml_types = require_types3();
    function serialize(obj) {
      const oldFold = yaml_types.strOptions.fold.lineWidth;
      try {
        return yaml_types.strOptions.fold.lineWidth = 0, yaml.stringify(obj, { schema: "yaml-1.1" });
      } finally {
        yaml_types.strOptions.fold.lineWidth = oldFold;
      }
    }
    exports2.serialize = serialize;
  }
});

// node_modules/aws-cdk-lib/aws-codebuild/lib/build-spec.js
var require_build_spec = __commonJS({
  "node_modules/aws-cdk-lib/aws-codebuild/lib/build-spec.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.mergeBuildSpecs = exports2.BuildSpec = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var yaml_cfn = require_yaml_cfn2();
    var s3_assets = require_aws_s3_assets();
    var core_1 = require_core2();
    var BuildSpec = class {
      static fromObject(value) {
        return new ObjectBuildSpec(value);
      }
      static fromObjectToYaml(value) {
        return new YamlBuildSpec(value);
      }
      static fromSourceFilename(filename) {
        return new FilenameBuildSpec(filename);
      }
      static fromAsset(path) {
        return new AssetBuildSpec(path);
      }
      constructor() {
      }
    };
    _a = JSII_RTTI_SYMBOL_1, BuildSpec[_a] = { fqn: "aws-cdk-lib.aws_codebuild.BuildSpec", version: "2.80.0" }, exports2.BuildSpec = BuildSpec;
    var AssetBuildSpec = class extends BuildSpec {
      constructor(path, options = {}) {
        super(), this.path = path, this.options = options, this.isImmediate = true;
      }
      toBuildSpec(scope) {
        if (!scope)
          throw new Error("`AssetBuildSpec` requires a `scope` argument");
        if (!this.asset)
          this.asset = new s3_assets.Asset(scope, "Code", { path: this.path, ...this.options });
        else if (core_1.Stack.of(this.asset) !== core_1.Stack.of(scope))
          throw new Error(`Asset is already associated with another stack '${core_1.Stack.of(this.asset).stackName}'. Create a new BuildSpec instance for every stack.`);
        return this.asset.grantRead(scope), this.asset.bucket.arnForObjects(this.asset.s3ObjectKey);
      }
      toString() {
        return `<buildspec file: ${this.path}>`;
      }
    };
    var FilenameBuildSpec = class extends BuildSpec {
      constructor(filename) {
        super(), this.filename = filename, this.isImmediate = false;
      }
      toBuildSpec() {
        return this.filename;
      }
      toString() {
        return `<buildspec file: ${this.filename}>`;
      }
    };
    var ObjectBuildSpec = class extends BuildSpec {
      constructor(spec) {
        super(), this.spec = spec, this.isImmediate = true;
      }
      toBuildSpec() {
        return core_1.Lazy.uncachedString({ produce: (ctx) => core_1.Stack.of(ctx.scope).toJsonString(this.spec, 2) });
      }
    };
    var YamlBuildSpec = class extends BuildSpec {
      constructor(spec) {
        super(), this.spec = spec, this.isImmediate = true;
      }
      toBuildSpec() {
        return yaml_cfn.serialize(this.spec);
      }
    };
    function mergeBuildSpecs(lhs, rhs) {
      if (!(lhs instanceof ObjectBuildSpec) || !(rhs instanceof ObjectBuildSpec))
        throw new Error("Can only merge buildspecs created using BuildSpec.fromObject()");
      if (lhs.spec.version === "0.1")
        throw new Error('Cannot extend buildspec at version "0.1". Set the version to "0.2" or higher instead.');
      if (lhs.spec.artifacts && rhs.spec.artifacts)
        throw new Error("Only one build spec is allowed to specify artifacts.");
      const lhsSpec = JSON.parse(JSON.stringify(lhs.spec)), rhsSpec = JSON.parse(JSON.stringify(rhs.spec));
      normalizeSpec(lhsSpec), normalizeSpec(rhsSpec);
      const merged = mergeDeep(lhsSpec, rhsSpec);
      return lhsSpec.reports && rhsSpec.reports && (merged.reports = { ...lhsSpec.reports, ...rhsSpec.reports }), new ObjectBuildSpec(merged);
    }
    exports2.mergeBuildSpecs = mergeBuildSpecs;
    function normalizeSpec(spec) {
      spec.env && typeof spec.env["exported-variables"] == "string" && (spec.env["exported-variables"] = [spec.env["exported-variables"]]);
      for (const key in spec.phases)
        Object.prototype.hasOwnProperty.call(spec.phases, key) && normalizeSpecPhase(spec.phases[key]);
      if (spec.reports) {
        for (const key in spec.reports)
          if (Object.prototype.hasOwnProperty.call(spec.reports, key)) {
            const report = spec.reports[key];
            typeof report.files == "string" && (report.files = [report.files]);
          }
      }
      if (spec.artifacts) {
        typeof spec.artifacts.files == "string" && (spec.artifacts.files = [spec.artifacts.files]);
        for (const key in spec.artifacts["secondary-artifacts"])
          if (Object.prototype.hasOwnProperty.call(spec.artifacts["secondary-artifacts"], key)) {
            const secArtifact = spec.artifacts["secondary-artifacts"][key];
            typeof secArtifact.files == "string" && (secArtifact.files = [secArtifact.files]);
          }
      }
      spec.cache && typeof spec.cache.paths == "string" && (spec.cache.paths = [spec.cache.paths]);
    }
    function normalizeSpecPhase(phase) {
      phase.commands && typeof phase.commands == "string" && (phase.commands = [phase.commands]), phase.finally && typeof phase.finally == "string" && (phase.finally = [phase.finally]);
    }
    function mergeDeep(lhs, rhs) {
      if (Array.isArray(lhs) && Array.isArray(rhs))
        return [...lhs, ...rhs];
      if (Array.isArray(lhs) || Array.isArray(rhs))
        return rhs;
      const isObject = (obj) => obj && typeof obj == "object";
      if (isObject(lhs) && isObject(rhs)) {
        const ret = { ...lhs };
        for (const k of Object.keys(rhs))
          ret[k] = k in lhs ? mergeDeep(lhs[k], rhs[k]) : rhs[k];
        return ret;
      }
      return rhs;
    }
  }
});

// node_modules/aws-cdk-lib/aws-codebuild/lib/cache.js
var require_cache2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codebuild/lib/cache.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Cache = exports2.LocalCacheMode = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core_1 = require_core2();
    var LocalCacheMode;
    (function(LocalCacheMode2) {
      LocalCacheMode2.SOURCE = "LOCAL_SOURCE_CACHE", LocalCacheMode2.DOCKER_LAYER = "LOCAL_DOCKER_LAYER_CACHE", LocalCacheMode2.CUSTOM = "LOCAL_CUSTOM_CACHE";
    })(LocalCacheMode = exports2.LocalCacheMode || (exports2.LocalCacheMode = {}));
    var Cache = class {
      static none() {
        return { _toCloudFormation() {
          return { type: "NO_CACHE" };
        }, _bind() {
        } };
      }
      static local(...modes) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_LocalCacheMode(modes);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.local), error;
        }
        return { _toCloudFormation: () => ({ type: "LOCAL", modes }), _bind: () => {
        } };
      }
      static bucket(bucket, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_IBucket(bucket), jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_BucketCacheOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bucket), error;
        }
        return { _toCloudFormation: () => ({ type: "S3", location: core_1.Fn.join("/", [bucket.bucketName, options && options.prefix || core_1.Aws.NO_VALUE]) }), _bind: (project) => {
          bucket.grantReadWrite(project);
        } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Cache[_a] = { fqn: "aws-cdk-lib.aws_codebuild.Cache", version: "2.80.0" }, exports2.Cache = Cache;
  }
});

// node_modules/aws-cdk-lib/aws-codebuild/lib/codebuild-canned-metrics.generated.js
var require_codebuild_canned_metrics_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-codebuild/lib/codebuild-canned-metrics.generated.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CodeBuildMetrics = void 0;
    var CodeBuildMetrics = class {
      static succeededBuildsSum(dimensions) {
        return { namespace: "AWS/CodeBuild", metricName: "SucceededBuilds", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static failedBuildsSum(dimensions) {
        return { namespace: "AWS/CodeBuild", metricName: "FailedBuilds", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static buildsSum(dimensions) {
        return { namespace: "AWS/CodeBuild", metricName: "Builds", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static durationAverage(dimensions) {
        return { namespace: "AWS/CodeBuild", metricName: "Duration", dimensionsMap: dimensions, statistic: "Average" };
      }
    };
    exports2.CodeBuildMetrics = CodeBuildMetrics;
  }
});

// node_modules/aws-cdk-lib/aws-codebuild/lib/codebuild.generated.js
var require_codebuild_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-codebuild/lib/codebuild.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnSourceCredential = exports2.CfnReportGroup = exports2.CfnProject = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnProjectPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("artifacts", cdk.requiredValidator)(properties.artifacts)), errors.collect(cdk.propertyValidator("artifacts", CfnProject_ArtifactsPropertyValidator)(properties.artifacts)), errors.collect(cdk.propertyValidator("badgeEnabled", cdk.validateBoolean)(properties.badgeEnabled)), errors.collect(cdk.propertyValidator("buildBatchConfig", CfnProject_ProjectBuildBatchConfigPropertyValidator)(properties.buildBatchConfig)), errors.collect(cdk.propertyValidator("cache", CfnProject_ProjectCachePropertyValidator)(properties.cache)), errors.collect(cdk.propertyValidator("concurrentBuildLimit", cdk.validateNumber)(properties.concurrentBuildLimit)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("encryptionKey", cdk.validateString)(properties.encryptionKey)), errors.collect(cdk.propertyValidator("environment", cdk.requiredValidator)(properties.environment)), errors.collect(cdk.propertyValidator("environment", CfnProject_EnvironmentPropertyValidator)(properties.environment)), errors.collect(cdk.propertyValidator("fileSystemLocations", cdk.listValidator(CfnProject_ProjectFileSystemLocationPropertyValidator))(properties.fileSystemLocations)), errors.collect(cdk.propertyValidator("logsConfig", CfnProject_LogsConfigPropertyValidator)(properties.logsConfig)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("queuedTimeoutInMinutes", cdk.validateNumber)(properties.queuedTimeoutInMinutes)), errors.collect(cdk.propertyValidator("resourceAccessRole", cdk.validateString)(properties.resourceAccessRole)), errors.collect(cdk.propertyValidator("secondaryArtifacts", cdk.listValidator(CfnProject_ArtifactsPropertyValidator))(properties.secondaryArtifacts)), errors.collect(cdk.propertyValidator("secondarySourceVersions", cdk.listValidator(CfnProject_ProjectSourceVersionPropertyValidator))(properties.secondarySourceVersions)), errors.collect(cdk.propertyValidator("secondarySources", cdk.listValidator(CfnProject_SourcePropertyValidator))(properties.secondarySources)), errors.collect(cdk.propertyValidator("serviceRole", cdk.requiredValidator)(properties.serviceRole)), errors.collect(cdk.propertyValidator("serviceRole", cdk.validateString)(properties.serviceRole)), errors.collect(cdk.propertyValidator("source", cdk.requiredValidator)(properties.source)), errors.collect(cdk.propertyValidator("source", CfnProject_SourcePropertyValidator)(properties.source)), errors.collect(cdk.propertyValidator("sourceVersion", cdk.validateString)(properties.sourceVersion)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("timeoutInMinutes", cdk.validateNumber)(properties.timeoutInMinutes)), errors.collect(cdk.propertyValidator("triggers", CfnProject_ProjectTriggersPropertyValidator)(properties.triggers)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.collect(cdk.propertyValidator("vpcConfig", CfnProject_VpcConfigPropertyValidator)(properties.vpcConfig)), errors.wrap('supplied properties not correct for "CfnProjectProps"');
    }
    function cfnProjectPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProjectPropsValidator(properties).assertSuccess(), { Artifacts: cfnProjectArtifactsPropertyToCloudFormation(properties.artifacts), Environment: cfnProjectEnvironmentPropertyToCloudFormation(properties.environment), ServiceRole: cdk.stringToCloudFormation(properties.serviceRole), Source: cfnProjectSourcePropertyToCloudFormation(properties.source), BadgeEnabled: cdk.booleanToCloudFormation(properties.badgeEnabled), BuildBatchConfig: cfnProjectProjectBuildBatchConfigPropertyToCloudFormation(properties.buildBatchConfig), Cache: cfnProjectProjectCachePropertyToCloudFormation(properties.cache), ConcurrentBuildLimit: cdk.numberToCloudFormation(properties.concurrentBuildLimit), Description: cdk.stringToCloudFormation(properties.description), EncryptionKey: cdk.stringToCloudFormation(properties.encryptionKey), FileSystemLocations: cdk.listMapper(cfnProjectProjectFileSystemLocationPropertyToCloudFormation)(properties.fileSystemLocations), LogsConfig: cfnProjectLogsConfigPropertyToCloudFormation(properties.logsConfig), Name: cdk.stringToCloudFormation(properties.name), QueuedTimeoutInMinutes: cdk.numberToCloudFormation(properties.queuedTimeoutInMinutes), ResourceAccessRole: cdk.stringToCloudFormation(properties.resourceAccessRole), SecondaryArtifacts: cdk.listMapper(cfnProjectArtifactsPropertyToCloudFormation)(properties.secondaryArtifacts), SecondarySources: cdk.listMapper(cfnProjectSourcePropertyToCloudFormation)(properties.secondarySources), SecondarySourceVersions: cdk.listMapper(cfnProjectProjectSourceVersionPropertyToCloudFormation)(properties.secondarySourceVersions), SourceVersion: cdk.stringToCloudFormation(properties.sourceVersion), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TimeoutInMinutes: cdk.numberToCloudFormation(properties.timeoutInMinutes), Triggers: cfnProjectProjectTriggersPropertyToCloudFormation(properties.triggers), Visibility: cdk.stringToCloudFormation(properties.visibility), VpcConfig: cfnProjectVpcConfigPropertyToCloudFormation(properties.vpcConfig) }) : properties;
    }
    function CfnProjectPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("artifacts", "Artifacts", CfnProjectArtifactsPropertyFromCloudFormation(properties.Artifacts)), ret.addPropertyResult("environment", "Environment", CfnProjectEnvironmentPropertyFromCloudFormation(properties.Environment)), ret.addPropertyResult("serviceRole", "ServiceRole", cfn_parse.FromCloudFormation.getString(properties.ServiceRole)), ret.addPropertyResult("source", "Source", CfnProjectSourcePropertyFromCloudFormation(properties.Source)), ret.addPropertyResult("badgeEnabled", "BadgeEnabled", properties.BadgeEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.BadgeEnabled) : void 0), ret.addPropertyResult("buildBatchConfig", "BuildBatchConfig", properties.BuildBatchConfig != null ? CfnProjectProjectBuildBatchConfigPropertyFromCloudFormation(properties.BuildBatchConfig) : void 0), ret.addPropertyResult("cache", "Cache", properties.Cache != null ? CfnProjectProjectCachePropertyFromCloudFormation(properties.Cache) : void 0), ret.addPropertyResult("concurrentBuildLimit", "ConcurrentBuildLimit", properties.ConcurrentBuildLimit != null ? cfn_parse.FromCloudFormation.getNumber(properties.ConcurrentBuildLimit) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("encryptionKey", "EncryptionKey", properties.EncryptionKey != null ? cfn_parse.FromCloudFormation.getString(properties.EncryptionKey) : void 0), ret.addPropertyResult("fileSystemLocations", "FileSystemLocations", properties.FileSystemLocations != null ? cfn_parse.FromCloudFormation.getArray(CfnProjectProjectFileSystemLocationPropertyFromCloudFormation)(properties.FileSystemLocations) : void 0), ret.addPropertyResult("logsConfig", "LogsConfig", properties.LogsConfig != null ? CfnProjectLogsConfigPropertyFromCloudFormation(properties.LogsConfig) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("queuedTimeoutInMinutes", "QueuedTimeoutInMinutes", properties.QueuedTimeoutInMinutes != null ? cfn_parse.FromCloudFormation.getNumber(properties.QueuedTimeoutInMinutes) : void 0), ret.addPropertyResult("resourceAccessRole", "ResourceAccessRole", properties.ResourceAccessRole != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceAccessRole) : void 0), ret.addPropertyResult("secondaryArtifacts", "SecondaryArtifacts", properties.SecondaryArtifacts != null ? cfn_parse.FromCloudFormation.getArray(CfnProjectArtifactsPropertyFromCloudFormation)(properties.SecondaryArtifacts) : void 0), ret.addPropertyResult("secondarySources", "SecondarySources", properties.SecondarySources != null ? cfn_parse.FromCloudFormation.getArray(CfnProjectSourcePropertyFromCloudFormation)(properties.SecondarySources) : void 0), ret.addPropertyResult("secondarySourceVersions", "SecondarySourceVersions", properties.SecondarySourceVersions != null ? cfn_parse.FromCloudFormation.getArray(CfnProjectProjectSourceVersionPropertyFromCloudFormation)(properties.SecondarySourceVersions) : void 0), ret.addPropertyResult("sourceVersion", "SourceVersion", properties.SourceVersion != null ? cfn_parse.FromCloudFormation.getString(properties.SourceVersion) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("timeoutInMinutes", "TimeoutInMinutes", properties.TimeoutInMinutes != null ? cfn_parse.FromCloudFormation.getNumber(properties.TimeoutInMinutes) : void 0), ret.addPropertyResult("triggers", "Triggers", properties.Triggers != null ? CfnProjectProjectTriggersPropertyFromCloudFormation(properties.Triggers) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addPropertyResult("vpcConfig", "VpcConfig", properties.VpcConfig != null ? CfnProjectVpcConfigPropertyFromCloudFormation(properties.VpcConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnProject = class _CfnProject extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnProjectPropsFromCloudFormation(resourceProperties), ret = new _CfnProject(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnProject.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_CfnProjectProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnProject), error;
        }
        cdk.requireProperty(props, "artifacts", this), cdk.requireProperty(props, "environment", this), cdk.requireProperty(props, "serviceRole", this), cdk.requireProperty(props, "source", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.artifacts = props.artifacts, this.environment = props.environment, this.serviceRole = props.serviceRole, this.source = props.source, this.badgeEnabled = props.badgeEnabled, this.buildBatchConfig = props.buildBatchConfig, this.cache = props.cache, this.concurrentBuildLimit = props.concurrentBuildLimit, this.description = props.description, this.encryptionKey = props.encryptionKey, this.fileSystemLocations = props.fileSystemLocations, this.logsConfig = props.logsConfig, this.name = props.name, this.queuedTimeoutInMinutes = props.queuedTimeoutInMinutes, this.resourceAccessRole = props.resourceAccessRole, this.secondaryArtifacts = props.secondaryArtifacts, this.secondarySources = props.secondarySources, this.secondarySourceVersions = props.secondarySourceVersions, this.sourceVersion = props.sourceVersion, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::CodeBuild::Project", props.tags, { tagPropertyName: "tags" }), this.timeoutInMinutes = props.timeoutInMinutes, this.triggers = props.triggers, this.visibility = props.visibility, this.vpcConfig = props.vpcConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnProject.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { artifacts: this.artifacts, environment: this.environment, serviceRole: this.serviceRole, source: this.source, badgeEnabled: this.badgeEnabled, buildBatchConfig: this.buildBatchConfig, cache: this.cache, concurrentBuildLimit: this.concurrentBuildLimit, description: this.description, encryptionKey: this.encryptionKey, fileSystemLocations: this.fileSystemLocations, logsConfig: this.logsConfig, name: this.name, queuedTimeoutInMinutes: this.queuedTimeoutInMinutes, resourceAccessRole: this.resourceAccessRole, secondaryArtifacts: this.secondaryArtifacts, secondarySources: this.secondarySources, secondarySourceVersions: this.secondarySourceVersions, sourceVersion: this.sourceVersion, tags: this.tags.renderTags(), timeoutInMinutes: this.timeoutInMinutes, triggers: this.triggers, visibility: this.visibility, vpcConfig: this.vpcConfig };
      }
      renderProperties(props) {
        return cfnProjectPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnProject[_a] = { fqn: "aws-cdk-lib.aws_codebuild.CfnProject", version: "2.80.0" }, CfnProject.CFN_RESOURCE_TYPE_NAME = "AWS::CodeBuild::Project", exports2.CfnProject = CfnProject;
    function CfnProject_ArtifactsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("artifactIdentifier", cdk.validateString)(properties.artifactIdentifier)), errors.collect(cdk.propertyValidator("encryptionDisabled", cdk.validateBoolean)(properties.encryptionDisabled)), errors.collect(cdk.propertyValidator("location", cdk.validateString)(properties.location)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("namespaceType", cdk.validateString)(properties.namespaceType)), errors.collect(cdk.propertyValidator("overrideArtifactName", cdk.validateBoolean)(properties.overrideArtifactName)), errors.collect(cdk.propertyValidator("packaging", cdk.validateString)(properties.packaging)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "ArtifactsProperty"');
    }
    function cfnProjectArtifactsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProject_ArtifactsPropertyValidator(properties).assertSuccess(), { ArtifactIdentifier: cdk.stringToCloudFormation(properties.artifactIdentifier), EncryptionDisabled: cdk.booleanToCloudFormation(properties.encryptionDisabled), Location: cdk.stringToCloudFormation(properties.location), Name: cdk.stringToCloudFormation(properties.name), NamespaceType: cdk.stringToCloudFormation(properties.namespaceType), OverrideArtifactName: cdk.booleanToCloudFormation(properties.overrideArtifactName), Packaging: cdk.stringToCloudFormation(properties.packaging), Path: cdk.stringToCloudFormation(properties.path), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnProjectArtifactsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("artifactIdentifier", "ArtifactIdentifier", properties.ArtifactIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.ArtifactIdentifier) : void 0), ret.addPropertyResult("encryptionDisabled", "EncryptionDisabled", properties.EncryptionDisabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EncryptionDisabled) : void 0), ret.addPropertyResult("location", "Location", properties.Location != null ? cfn_parse.FromCloudFormation.getString(properties.Location) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("namespaceType", "NamespaceType", properties.NamespaceType != null ? cfn_parse.FromCloudFormation.getString(properties.NamespaceType) : void 0), ret.addPropertyResult("overrideArtifactName", "OverrideArtifactName", properties.OverrideArtifactName != null ? cfn_parse.FromCloudFormation.getBoolean(properties.OverrideArtifactName) : void 0), ret.addPropertyResult("packaging", "Packaging", properties.Packaging != null ? cfn_parse.FromCloudFormation.getString(properties.Packaging) : void 0), ret.addPropertyResult("path", "Path", properties.Path != null ? cfn_parse.FromCloudFormation.getString(properties.Path) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnProject_BatchRestrictionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computeTypesAllowed", cdk.listValidator(cdk.validateString))(properties.computeTypesAllowed)), errors.collect(cdk.propertyValidator("maximumBuildsAllowed", cdk.validateNumber)(properties.maximumBuildsAllowed)), errors.wrap('supplied properties not correct for "BatchRestrictionsProperty"');
    }
    function cfnProjectBatchRestrictionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProject_BatchRestrictionsPropertyValidator(properties).assertSuccess(), { ComputeTypesAllowed: cdk.listMapper(cdk.stringToCloudFormation)(properties.computeTypesAllowed), MaximumBuildsAllowed: cdk.numberToCloudFormation(properties.maximumBuildsAllowed) }) : properties;
    }
    function CfnProjectBatchRestrictionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computeTypesAllowed", "ComputeTypesAllowed", properties.ComputeTypesAllowed != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ComputeTypesAllowed) : void 0), ret.addPropertyResult("maximumBuildsAllowed", "MaximumBuildsAllowed", properties.MaximumBuildsAllowed != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumBuildsAllowed) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnProject_BuildStatusConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("context", cdk.validateString)(properties.context)), errors.collect(cdk.propertyValidator("targetUrl", cdk.validateString)(properties.targetUrl)), errors.wrap('supplied properties not correct for "BuildStatusConfigProperty"');
    }
    function cfnProjectBuildStatusConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProject_BuildStatusConfigPropertyValidator(properties).assertSuccess(), { Context: cdk.stringToCloudFormation(properties.context), TargetUrl: cdk.stringToCloudFormation(properties.targetUrl) }) : properties;
    }
    function CfnProjectBuildStatusConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("context", "Context", properties.Context != null ? cfn_parse.FromCloudFormation.getString(properties.Context) : void 0), ret.addPropertyResult("targetUrl", "TargetUrl", properties.TargetUrl != null ? cfn_parse.FromCloudFormation.getString(properties.TargetUrl) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnProject_CloudWatchLogsConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groupName", cdk.validateString)(properties.groupName)), errors.collect(cdk.propertyValidator("status", cdk.requiredValidator)(properties.status)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.collect(cdk.propertyValidator("streamName", cdk.validateString)(properties.streamName)), errors.wrap('supplied properties not correct for "CloudWatchLogsConfigProperty"');
    }
    function cfnProjectCloudWatchLogsConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProject_CloudWatchLogsConfigPropertyValidator(properties).assertSuccess(), { GroupName: cdk.stringToCloudFormation(properties.groupName), Status: cdk.stringToCloudFormation(properties.status), StreamName: cdk.stringToCloudFormation(properties.streamName) }) : properties;
    }
    function CfnProjectCloudWatchLogsConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupName", "GroupName", properties.GroupName != null ? cfn_parse.FromCloudFormation.getString(properties.GroupName) : void 0), ret.addPropertyResult("status", "Status", cfn_parse.FromCloudFormation.getString(properties.Status)), ret.addPropertyResult("streamName", "StreamName", properties.StreamName != null ? cfn_parse.FromCloudFormation.getString(properties.StreamName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnProject_EnvironmentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificate", cdk.validateString)(properties.certificate)), errors.collect(cdk.propertyValidator("computeType", cdk.requiredValidator)(properties.computeType)), errors.collect(cdk.propertyValidator("computeType", cdk.validateString)(properties.computeType)), errors.collect(cdk.propertyValidator("environmentVariables", cdk.listValidator(CfnProject_EnvironmentVariablePropertyValidator))(properties.environmentVariables)), errors.collect(cdk.propertyValidator("image", cdk.requiredValidator)(properties.image)), errors.collect(cdk.propertyValidator("image", cdk.validateString)(properties.image)), errors.collect(cdk.propertyValidator("imagePullCredentialsType", cdk.validateString)(properties.imagePullCredentialsType)), errors.collect(cdk.propertyValidator("privilegedMode", cdk.validateBoolean)(properties.privilegedMode)), errors.collect(cdk.propertyValidator("registryCredential", CfnProject_RegistryCredentialPropertyValidator)(properties.registryCredential)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "EnvironmentProperty"');
    }
    function cfnProjectEnvironmentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProject_EnvironmentPropertyValidator(properties).assertSuccess(), { Certificate: cdk.stringToCloudFormation(properties.certificate), ComputeType: cdk.stringToCloudFormation(properties.computeType), EnvironmentVariables: cdk.listMapper(cfnProjectEnvironmentVariablePropertyToCloudFormation)(properties.environmentVariables), Image: cdk.stringToCloudFormation(properties.image), ImagePullCredentialsType: cdk.stringToCloudFormation(properties.imagePullCredentialsType), PrivilegedMode: cdk.booleanToCloudFormation(properties.privilegedMode), RegistryCredential: cfnProjectRegistryCredentialPropertyToCloudFormation(properties.registryCredential), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnProjectEnvironmentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificate", "Certificate", properties.Certificate != null ? cfn_parse.FromCloudFormation.getString(properties.Certificate) : void 0), ret.addPropertyResult("computeType", "ComputeType", cfn_parse.FromCloudFormation.getString(properties.ComputeType)), ret.addPropertyResult("environmentVariables", "EnvironmentVariables", properties.EnvironmentVariables != null ? cfn_parse.FromCloudFormation.getArray(CfnProjectEnvironmentVariablePropertyFromCloudFormation)(properties.EnvironmentVariables) : void 0), ret.addPropertyResult("image", "Image", cfn_parse.FromCloudFormation.getString(properties.Image)), ret.addPropertyResult("imagePullCredentialsType", "ImagePullCredentialsType", properties.ImagePullCredentialsType != null ? cfn_parse.FromCloudFormation.getString(properties.ImagePullCredentialsType) : void 0), ret.addPropertyResult("privilegedMode", "PrivilegedMode", properties.PrivilegedMode != null ? cfn_parse.FromCloudFormation.getBoolean(properties.PrivilegedMode) : void 0), ret.addPropertyResult("registryCredential", "RegistryCredential", properties.RegistryCredential != null ? CfnProjectRegistryCredentialPropertyFromCloudFormation(properties.RegistryCredential) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnProject_EnvironmentVariablePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "EnvironmentVariableProperty"');
    }
    function cfnProjectEnvironmentVariablePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProject_EnvironmentVariablePropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Type: cdk.stringToCloudFormation(properties.type), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnProjectEnvironmentVariablePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnProject_GitSubmodulesConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fetchSubmodules", cdk.requiredValidator)(properties.fetchSubmodules)), errors.collect(cdk.propertyValidator("fetchSubmodules", cdk.validateBoolean)(properties.fetchSubmodules)), errors.wrap('supplied properties not correct for "GitSubmodulesConfigProperty"');
    }
    function cfnProjectGitSubmodulesConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProject_GitSubmodulesConfigPropertyValidator(properties).assertSuccess(), { FetchSubmodules: cdk.booleanToCloudFormation(properties.fetchSubmodules) }) : properties;
    }
    function CfnProjectGitSubmodulesConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fetchSubmodules", "FetchSubmodules", cfn_parse.FromCloudFormation.getBoolean(properties.FetchSubmodules)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnProject_LogsConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchLogs", CfnProject_CloudWatchLogsConfigPropertyValidator)(properties.cloudWatchLogs)), errors.collect(cdk.propertyValidator("s3Logs", CfnProject_S3LogsConfigPropertyValidator)(properties.s3Logs)), errors.wrap('supplied properties not correct for "LogsConfigProperty"');
    }
    function cfnProjectLogsConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProject_LogsConfigPropertyValidator(properties).assertSuccess(), { CloudWatchLogs: cfnProjectCloudWatchLogsConfigPropertyToCloudFormation(properties.cloudWatchLogs), S3Logs: cfnProjectS3LogsConfigPropertyToCloudFormation(properties.s3Logs) }) : properties;
    }
    function CfnProjectLogsConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchLogs", "CloudWatchLogs", properties.CloudWatchLogs != null ? CfnProjectCloudWatchLogsConfigPropertyFromCloudFormation(properties.CloudWatchLogs) : void 0), ret.addPropertyResult("s3Logs", "S3Logs", properties.S3Logs != null ? CfnProjectS3LogsConfigPropertyFromCloudFormation(properties.S3Logs) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnProject_ProjectBuildBatchConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("batchReportMode", cdk.validateString)(properties.batchReportMode)), errors.collect(cdk.propertyValidator("combineArtifacts", cdk.validateBoolean)(properties.combineArtifacts)), errors.collect(cdk.propertyValidator("restrictions", CfnProject_BatchRestrictionsPropertyValidator)(properties.restrictions)), errors.collect(cdk.propertyValidator("serviceRole", cdk.validateString)(properties.serviceRole)), errors.collect(cdk.propertyValidator("timeoutInMins", cdk.validateNumber)(properties.timeoutInMins)), errors.wrap('supplied properties not correct for "ProjectBuildBatchConfigProperty"');
    }
    function cfnProjectProjectBuildBatchConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProject_ProjectBuildBatchConfigPropertyValidator(properties).assertSuccess(), { BatchReportMode: cdk.stringToCloudFormation(properties.batchReportMode), CombineArtifacts: cdk.booleanToCloudFormation(properties.combineArtifacts), Restrictions: cfnProjectBatchRestrictionsPropertyToCloudFormation(properties.restrictions), ServiceRole: cdk.stringToCloudFormation(properties.serviceRole), TimeoutInMins: cdk.numberToCloudFormation(properties.timeoutInMins) }) : properties;
    }
    function CfnProjectProjectBuildBatchConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("batchReportMode", "BatchReportMode", properties.BatchReportMode != null ? cfn_parse.FromCloudFormation.getString(properties.BatchReportMode) : void 0), ret.addPropertyResult("combineArtifacts", "CombineArtifacts", properties.CombineArtifacts != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CombineArtifacts) : void 0), ret.addPropertyResult("restrictions", "Restrictions", properties.Restrictions != null ? CfnProjectBatchRestrictionsPropertyFromCloudFormation(properties.Restrictions) : void 0), ret.addPropertyResult("serviceRole", "ServiceRole", properties.ServiceRole != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceRole) : void 0), ret.addPropertyResult("timeoutInMins", "TimeoutInMins", properties.TimeoutInMins != null ? cfn_parse.FromCloudFormation.getNumber(properties.TimeoutInMins) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnProject_ProjectCachePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("location", cdk.validateString)(properties.location)), errors.collect(cdk.propertyValidator("modes", cdk.listValidator(cdk.validateString))(properties.modes)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "ProjectCacheProperty"');
    }
    function cfnProjectProjectCachePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProject_ProjectCachePropertyValidator(properties).assertSuccess(), { Location: cdk.stringToCloudFormation(properties.location), Modes: cdk.listMapper(cdk.stringToCloudFormation)(properties.modes), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnProjectProjectCachePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("location", "Location", properties.Location != null ? cfn_parse.FromCloudFormation.getString(properties.Location) : void 0), ret.addPropertyResult("modes", "Modes", properties.Modes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Modes) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnProject_ProjectFileSystemLocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("identifier", cdk.requiredValidator)(properties.identifier)), errors.collect(cdk.propertyValidator("identifier", cdk.validateString)(properties.identifier)), errors.collect(cdk.propertyValidator("location", cdk.requiredValidator)(properties.location)), errors.collect(cdk.propertyValidator("location", cdk.validateString)(properties.location)), errors.collect(cdk.propertyValidator("mountOptions", cdk.validateString)(properties.mountOptions)), errors.collect(cdk.propertyValidator("mountPoint", cdk.requiredValidator)(properties.mountPoint)), errors.collect(cdk.propertyValidator("mountPoint", cdk.validateString)(properties.mountPoint)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "ProjectFileSystemLocationProperty"');
    }
    function cfnProjectProjectFileSystemLocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProject_ProjectFileSystemLocationPropertyValidator(properties).assertSuccess(), { Identifier: cdk.stringToCloudFormation(properties.identifier), Location: cdk.stringToCloudFormation(properties.location), MountOptions: cdk.stringToCloudFormation(properties.mountOptions), MountPoint: cdk.stringToCloudFormation(properties.mountPoint), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnProjectProjectFileSystemLocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("identifier", "Identifier", cfn_parse.FromCloudFormation.getString(properties.Identifier)), ret.addPropertyResult("location", "Location", cfn_parse.FromCloudFormation.getString(properties.Location)), ret.addPropertyResult("mountOptions", "MountOptions", properties.MountOptions != null ? cfn_parse.FromCloudFormation.getString(properties.MountOptions) : void 0), ret.addPropertyResult("mountPoint", "MountPoint", cfn_parse.FromCloudFormation.getString(properties.MountPoint)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnProject_ProjectSourceVersionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sourceIdentifier", cdk.requiredValidator)(properties.sourceIdentifier)), errors.collect(cdk.propertyValidator("sourceIdentifier", cdk.validateString)(properties.sourceIdentifier)), errors.collect(cdk.propertyValidator("sourceVersion", cdk.validateString)(properties.sourceVersion)), errors.wrap('supplied properties not correct for "ProjectSourceVersionProperty"');
    }
    function cfnProjectProjectSourceVersionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProject_ProjectSourceVersionPropertyValidator(properties).assertSuccess(), { SourceIdentifier: cdk.stringToCloudFormation(properties.sourceIdentifier), SourceVersion: cdk.stringToCloudFormation(properties.sourceVersion) }) : properties;
    }
    function CfnProjectProjectSourceVersionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sourceIdentifier", "SourceIdentifier", cfn_parse.FromCloudFormation.getString(properties.SourceIdentifier)), ret.addPropertyResult("sourceVersion", "SourceVersion", properties.SourceVersion != null ? cfn_parse.FromCloudFormation.getString(properties.SourceVersion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnProject_ProjectTriggersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("buildType", cdk.validateString)(properties.buildType)), errors.collect(cdk.propertyValidator("filterGroups", cdk.listValidator(cdk.listValidator(CfnProject_WebhookFilterPropertyValidator)))(properties.filterGroups)), errors.collect(cdk.propertyValidator("webhook", cdk.validateBoolean)(properties.webhook)), errors.wrap('supplied properties not correct for "ProjectTriggersProperty"');
    }
    function cfnProjectProjectTriggersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProject_ProjectTriggersPropertyValidator(properties).assertSuccess(), { BuildType: cdk.stringToCloudFormation(properties.buildType), FilterGroups: cdk.listMapper(cdk.listMapper(cfnProjectWebhookFilterPropertyToCloudFormation))(properties.filterGroups), Webhook: cdk.booleanToCloudFormation(properties.webhook) }) : properties;
    }
    function CfnProjectProjectTriggersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("buildType", "BuildType", properties.BuildType != null ? cfn_parse.FromCloudFormation.getString(properties.BuildType) : void 0), ret.addPropertyResult("filterGroups", "FilterGroups", properties.FilterGroups != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getArray(CfnProjectWebhookFilterPropertyFromCloudFormation))(properties.FilterGroups) : void 0), ret.addPropertyResult("webhook", "Webhook", properties.Webhook != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Webhook) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnProject_RegistryCredentialPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("credential", cdk.requiredValidator)(properties.credential)), errors.collect(cdk.propertyValidator("credential", cdk.validateString)(properties.credential)), errors.collect(cdk.propertyValidator("credentialProvider", cdk.requiredValidator)(properties.credentialProvider)), errors.collect(cdk.propertyValidator("credentialProvider", cdk.validateString)(properties.credentialProvider)), errors.wrap('supplied properties not correct for "RegistryCredentialProperty"');
    }
    function cfnProjectRegistryCredentialPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProject_RegistryCredentialPropertyValidator(properties).assertSuccess(), { Credential: cdk.stringToCloudFormation(properties.credential), CredentialProvider: cdk.stringToCloudFormation(properties.credentialProvider) }) : properties;
    }
    function CfnProjectRegistryCredentialPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("credential", "Credential", cfn_parse.FromCloudFormation.getString(properties.Credential)), ret.addPropertyResult("credentialProvider", "CredentialProvider", cfn_parse.FromCloudFormation.getString(properties.CredentialProvider)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnProject_S3LogsConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("encryptionDisabled", cdk.validateBoolean)(properties.encryptionDisabled)), errors.collect(cdk.propertyValidator("location", cdk.validateString)(properties.location)), errors.collect(cdk.propertyValidator("status", cdk.requiredValidator)(properties.status)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "S3LogsConfigProperty"');
    }
    function cfnProjectS3LogsConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProject_S3LogsConfigPropertyValidator(properties).assertSuccess(), { EncryptionDisabled: cdk.booleanToCloudFormation(properties.encryptionDisabled), Location: cdk.stringToCloudFormation(properties.location), Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnProjectS3LogsConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("encryptionDisabled", "EncryptionDisabled", properties.EncryptionDisabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EncryptionDisabled) : void 0), ret.addPropertyResult("location", "Location", properties.Location != null ? cfn_parse.FromCloudFormation.getString(properties.Location) : void 0), ret.addPropertyResult("status", "Status", cfn_parse.FromCloudFormation.getString(properties.Status)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnProject_SourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("auth", CfnProject_SourceAuthPropertyValidator)(properties.auth)), errors.collect(cdk.propertyValidator("buildSpec", cdk.validateString)(properties.buildSpec)), errors.collect(cdk.propertyValidator("buildStatusConfig", CfnProject_BuildStatusConfigPropertyValidator)(properties.buildStatusConfig)), errors.collect(cdk.propertyValidator("gitCloneDepth", cdk.validateNumber)(properties.gitCloneDepth)), errors.collect(cdk.propertyValidator("gitSubmodulesConfig", CfnProject_GitSubmodulesConfigPropertyValidator)(properties.gitSubmodulesConfig)), errors.collect(cdk.propertyValidator("insecureSsl", cdk.validateBoolean)(properties.insecureSsl)), errors.collect(cdk.propertyValidator("location", cdk.validateString)(properties.location)), errors.collect(cdk.propertyValidator("reportBuildStatus", cdk.validateBoolean)(properties.reportBuildStatus)), errors.collect(cdk.propertyValidator("sourceIdentifier", cdk.validateString)(properties.sourceIdentifier)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "SourceProperty"');
    }
    function cfnProjectSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProject_SourcePropertyValidator(properties).assertSuccess(), { Auth: cfnProjectSourceAuthPropertyToCloudFormation(properties.auth), BuildSpec: cdk.stringToCloudFormation(properties.buildSpec), BuildStatusConfig: cfnProjectBuildStatusConfigPropertyToCloudFormation(properties.buildStatusConfig), GitCloneDepth: cdk.numberToCloudFormation(properties.gitCloneDepth), GitSubmodulesConfig: cfnProjectGitSubmodulesConfigPropertyToCloudFormation(properties.gitSubmodulesConfig), InsecureSsl: cdk.booleanToCloudFormation(properties.insecureSsl), Location: cdk.stringToCloudFormation(properties.location), ReportBuildStatus: cdk.booleanToCloudFormation(properties.reportBuildStatus), SourceIdentifier: cdk.stringToCloudFormation(properties.sourceIdentifier), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnProjectSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("auth", "Auth", properties.Auth != null ? CfnProjectSourceAuthPropertyFromCloudFormation(properties.Auth) : void 0), ret.addPropertyResult("buildSpec", "BuildSpec", properties.BuildSpec != null ? cfn_parse.FromCloudFormation.getString(properties.BuildSpec) : void 0), ret.addPropertyResult("buildStatusConfig", "BuildStatusConfig", properties.BuildStatusConfig != null ? CfnProjectBuildStatusConfigPropertyFromCloudFormation(properties.BuildStatusConfig) : void 0), ret.addPropertyResult("gitCloneDepth", "GitCloneDepth", properties.GitCloneDepth != null ? cfn_parse.FromCloudFormation.getNumber(properties.GitCloneDepth) : void 0), ret.addPropertyResult("gitSubmodulesConfig", "GitSubmodulesConfig", properties.GitSubmodulesConfig != null ? CfnProjectGitSubmodulesConfigPropertyFromCloudFormation(properties.GitSubmodulesConfig) : void 0), ret.addPropertyResult("insecureSsl", "InsecureSsl", properties.InsecureSsl != null ? cfn_parse.FromCloudFormation.getBoolean(properties.InsecureSsl) : void 0), ret.addPropertyResult("location", "Location", properties.Location != null ? cfn_parse.FromCloudFormation.getString(properties.Location) : void 0), ret.addPropertyResult("reportBuildStatus", "ReportBuildStatus", properties.ReportBuildStatus != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ReportBuildStatus) : void 0), ret.addPropertyResult("sourceIdentifier", "SourceIdentifier", properties.SourceIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.SourceIdentifier) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnProject_SourceAuthPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resource", cdk.validateString)(properties.resource)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "SourceAuthProperty"');
    }
    function cfnProjectSourceAuthPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProject_SourceAuthPropertyValidator(properties).assertSuccess(), { Resource: cdk.stringToCloudFormation(properties.resource), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnProjectSourceAuthPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resource", "Resource", properties.Resource != null ? cfn_parse.FromCloudFormation.getString(properties.Resource) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnProject_VpcConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnets", cdk.listValidator(cdk.validateString))(properties.subnets)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "VpcConfigProperty"');
    }
    function cfnProjectVpcConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProject_VpcConfigPropertyValidator(properties).assertSuccess(), { SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), Subnets: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnets), VpcId: cdk.stringToCloudFormation(properties.vpcId) }) : properties;
    }
    function CfnProjectVpcConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("subnets", "Subnets", properties.Subnets != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Subnets) : void 0), ret.addPropertyResult("vpcId", "VpcId", properties.VpcId != null ? cfn_parse.FromCloudFormation.getString(properties.VpcId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnProject_WebhookFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("excludeMatchedPattern", cdk.validateBoolean)(properties.excludeMatchedPattern)), errors.collect(cdk.propertyValidator("pattern", cdk.requiredValidator)(properties.pattern)), errors.collect(cdk.propertyValidator("pattern", cdk.validateString)(properties.pattern)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "WebhookFilterProperty"');
    }
    function cfnProjectWebhookFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProject_WebhookFilterPropertyValidator(properties).assertSuccess(), { ExcludeMatchedPattern: cdk.booleanToCloudFormation(properties.excludeMatchedPattern), Pattern: cdk.stringToCloudFormation(properties.pattern), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnProjectWebhookFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("excludeMatchedPattern", "ExcludeMatchedPattern", properties.ExcludeMatchedPattern != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ExcludeMatchedPattern) : void 0), ret.addPropertyResult("pattern", "Pattern", cfn_parse.FromCloudFormation.getString(properties.Pattern)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnReportGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deleteReports", cdk.validateBoolean)(properties.deleteReports)), errors.collect(cdk.propertyValidator("exportConfig", cdk.requiredValidator)(properties.exportConfig)), errors.collect(cdk.propertyValidator("exportConfig", CfnReportGroup_ReportExportConfigPropertyValidator)(properties.exportConfig)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnReportGroupProps"');
    }
    function cfnReportGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReportGroupPropsValidator(properties).assertSuccess(), { ExportConfig: cfnReportGroupReportExportConfigPropertyToCloudFormation(properties.exportConfig), Type: cdk.stringToCloudFormation(properties.type), DeleteReports: cdk.booleanToCloudFormation(properties.deleteReports), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnReportGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("exportConfig", "ExportConfig", CfnReportGroupReportExportConfigPropertyFromCloudFormation(properties.ExportConfig)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("deleteReports", "DeleteReports", properties.DeleteReports != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeleteReports) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnReportGroup = class _CfnReportGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnReportGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnReportGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnReportGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_CfnReportGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnReportGroup), error;
        }
        cdk.requireProperty(props, "exportConfig", this), cdk.requireProperty(props, "type", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.exportConfig = props.exportConfig, this.type = props.type, this.deleteReports = props.deleteReports, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::CodeBuild::ReportGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnReportGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { exportConfig: this.exportConfig, type: this.type, deleteReports: this.deleteReports, name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnReportGroupPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnReportGroup[_b] = { fqn: "aws-cdk-lib.aws_codebuild.CfnReportGroup", version: "2.80.0" }, CfnReportGroup.CFN_RESOURCE_TYPE_NAME = "AWS::CodeBuild::ReportGroup", exports2.CfnReportGroup = CfnReportGroup;
    function CfnReportGroup_ReportExportConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("exportConfigType", cdk.requiredValidator)(properties.exportConfigType)), errors.collect(cdk.propertyValidator("exportConfigType", cdk.validateString)(properties.exportConfigType)), errors.collect(cdk.propertyValidator("s3Destination", CfnReportGroup_S3ReportExportConfigPropertyValidator)(properties.s3Destination)), errors.wrap('supplied properties not correct for "ReportExportConfigProperty"');
    }
    function cfnReportGroupReportExportConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReportGroup_ReportExportConfigPropertyValidator(properties).assertSuccess(), { ExportConfigType: cdk.stringToCloudFormation(properties.exportConfigType), S3Destination: cfnReportGroupS3ReportExportConfigPropertyToCloudFormation(properties.s3Destination) }) : properties;
    }
    function CfnReportGroupReportExportConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("exportConfigType", "ExportConfigType", cfn_parse.FromCloudFormation.getString(properties.ExportConfigType)), ret.addPropertyResult("s3Destination", "S3Destination", properties.S3Destination != null ? CfnReportGroupS3ReportExportConfigPropertyFromCloudFormation(properties.S3Destination) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnReportGroup_S3ReportExportConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.requiredValidator)(properties.bucket)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("bucketOwner", cdk.validateString)(properties.bucketOwner)), errors.collect(cdk.propertyValidator("encryptionDisabled", cdk.validateBoolean)(properties.encryptionDisabled)), errors.collect(cdk.propertyValidator("encryptionKey", cdk.validateString)(properties.encryptionKey)), errors.collect(cdk.propertyValidator("packaging", cdk.validateString)(properties.packaging)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.wrap('supplied properties not correct for "S3ReportExportConfigProperty"');
    }
    function cfnReportGroupS3ReportExportConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReportGroup_S3ReportExportConfigPropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), BucketOwner: cdk.stringToCloudFormation(properties.bucketOwner), EncryptionDisabled: cdk.booleanToCloudFormation(properties.encryptionDisabled), EncryptionKey: cdk.stringToCloudFormation(properties.encryptionKey), Packaging: cdk.stringToCloudFormation(properties.packaging), Path: cdk.stringToCloudFormation(properties.path) }) : properties;
    }
    function CfnReportGroupS3ReportExportConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", cfn_parse.FromCloudFormation.getString(properties.Bucket)), ret.addPropertyResult("bucketOwner", "BucketOwner", properties.BucketOwner != null ? cfn_parse.FromCloudFormation.getString(properties.BucketOwner) : void 0), ret.addPropertyResult("encryptionDisabled", "EncryptionDisabled", properties.EncryptionDisabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EncryptionDisabled) : void 0), ret.addPropertyResult("encryptionKey", "EncryptionKey", properties.EncryptionKey != null ? cfn_parse.FromCloudFormation.getString(properties.EncryptionKey) : void 0), ret.addPropertyResult("packaging", "Packaging", properties.Packaging != null ? cfn_parse.FromCloudFormation.getString(properties.Packaging) : void 0), ret.addPropertyResult("path", "Path", properties.Path != null ? cfn_parse.FromCloudFormation.getString(properties.Path) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSourceCredentialPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authType", cdk.requiredValidator)(properties.authType)), errors.collect(cdk.propertyValidator("authType", cdk.validateString)(properties.authType)), errors.collect(cdk.propertyValidator("serverType", cdk.requiredValidator)(properties.serverType)), errors.collect(cdk.propertyValidator("serverType", cdk.validateString)(properties.serverType)), errors.collect(cdk.propertyValidator("token", cdk.requiredValidator)(properties.token)), errors.collect(cdk.propertyValidator("token", cdk.validateString)(properties.token)), errors.collect(cdk.propertyValidator("username", cdk.validateString)(properties.username)), errors.wrap('supplied properties not correct for "CfnSourceCredentialProps"');
    }
    function cfnSourceCredentialPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSourceCredentialPropsValidator(properties).assertSuccess(), { AuthType: cdk.stringToCloudFormation(properties.authType), ServerType: cdk.stringToCloudFormation(properties.serverType), Token: cdk.stringToCloudFormation(properties.token), Username: cdk.stringToCloudFormation(properties.username) }) : properties;
    }
    function CfnSourceCredentialPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authType", "AuthType", cfn_parse.FromCloudFormation.getString(properties.AuthType)), ret.addPropertyResult("serverType", "ServerType", cfn_parse.FromCloudFormation.getString(properties.ServerType)), ret.addPropertyResult("token", "Token", cfn_parse.FromCloudFormation.getString(properties.Token)), ret.addPropertyResult("username", "Username", properties.Username != null ? cfn_parse.FromCloudFormation.getString(properties.Username) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSourceCredential = class _CfnSourceCredential extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSourceCredentialPropsFromCloudFormation(resourceProperties), ret = new _CfnSourceCredential(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSourceCredential.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_CfnSourceCredentialProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSourceCredential), error;
        }
        cdk.requireProperty(props, "authType", this), cdk.requireProperty(props, "serverType", this), cdk.requireProperty(props, "token", this), this.authType = props.authType, this.serverType = props.serverType, this.token = props.token, this.username = props.username;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSourceCredential.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { authType: this.authType, serverType: this.serverType, token: this.token, username: this.username };
      }
      renderProperties(props) {
        return cfnSourceCredentialPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnSourceCredential[_c] = { fqn: "aws-cdk-lib.aws_codebuild.CfnSourceCredential", version: "2.80.0" }, CfnSourceCredential.CFN_RESOURCE_TYPE_NAME = "AWS::CodeBuild::SourceCredential", exports2.CfnSourceCredential = CfnSourceCredential;
  }
});

// node_modules/aws-cdk-lib/aws-codebuild/lib/no-artifacts.js
var require_no_artifacts = __commonJS({
  "node_modules/aws-cdk-lib/aws-codebuild/lib/no-artifacts.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.NoArtifacts = void 0;
    var artifacts_1 = require_artifacts();
    var NoArtifacts = class extends artifacts_1.Artifacts {
      constructor() {
        super({}), this.type = "NO_ARTIFACTS";
      }
    };
    exports2.NoArtifacts = NoArtifacts;
  }
});

// node_modules/aws-cdk-lib/aws-codebuild/lib/no-source.js
var require_no_source = __commonJS({
  "node_modules/aws-cdk-lib/aws-codebuild/lib/no-source.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.NoSource = void 0;
    var source_1 = require_source();
    var source_types_1 = require_source_types();
    var NoSource = class extends source_1.Source {
      constructor() {
        super({}), this.type = source_types_1.NO_SOURCE_TYPE;
      }
    };
    exports2.NoSource = NoSource;
  }
});

// node_modules/aws-cdk-lib/aws-codebuild/lib/private/run-script-linux-build-spec.js
var require_run_script_linux_build_spec = __commonJS({
  "node_modules/aws-cdk-lib/aws-codebuild/lib/private/run-script-linux-build-spec.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.runScriptLinuxBuildSpec = exports2.S3_KEY_ENV = exports2.S3_BUCKET_ENV = void 0;
    var build_spec_1 = require_build_spec();
    exports2.S3_BUCKET_ENV = "SCRIPT_S3_BUCKET", exports2.S3_KEY_ENV = "SCRIPT_S3_KEY";
    function runScriptLinuxBuildSpec(entrypoint) {
      return build_spec_1.BuildSpec.fromObject({ version: "0.2", phases: { pre_build: { commands: [`echo "Downloading scripts from s3://\${${exports2.S3_BUCKET_ENV}}/\${${exports2.S3_KEY_ENV}}"`, `aws s3 cp s3://\${${exports2.S3_BUCKET_ENV}}/\${${exports2.S3_KEY_ENV}} /tmp`, "mkdir -p /tmp/scriptdir", `unzip /tmp/$(basename $${exports2.S3_KEY_ENV}) -d /tmp/scriptdir`] }, build: { commands: ["export SCRIPT_DIR=/tmp/scriptdir", `echo "Running ${entrypoint}"`, `chmod +x /tmp/scriptdir/${entrypoint}`, `/tmp/scriptdir/${entrypoint}`] } } });
    }
    exports2.runScriptLinuxBuildSpec = runScriptLinuxBuildSpec;
  }
});

// node_modules/aws-cdk-lib/aws-codebuild/lib/report-group-utils.js
var require_report_group_utils = __commonJS({
  "node_modules/aws-cdk-lib/aws-codebuild/lib/report-group-utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.reportGroupArnComponents = exports2.renderReportGroupArn = void 0;
    var cdk = require_core2();
    function renderReportGroupArn(scope, reportGroupName) {
      return cdk.Stack.of(scope).formatArn(reportGroupArnComponents(reportGroupName));
    }
    exports2.renderReportGroupArn = renderReportGroupArn;
    function reportGroupArnComponents(reportGroupName) {
      return { service: "codebuild", resource: "report-group", resourceName: reportGroupName };
    }
    exports2.reportGroupArnComponents = reportGroupArnComponents;
  }
});

// node_modules/aws-cdk-lib/aws-codestarnotifications/lib/codestarnotifications.generated.js
var require_codestarnotifications_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-codestarnotifications/lib/codestarnotifications.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnNotificationRule = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnNotificationRulePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("createdBy", cdk.validateString)(properties.createdBy)), errors.collect(cdk.propertyValidator("detailType", cdk.requiredValidator)(properties.detailType)), errors.collect(cdk.propertyValidator("detailType", cdk.validateString)(properties.detailType)), errors.collect(cdk.propertyValidator("eventTypeId", cdk.validateString)(properties.eventTypeId)), errors.collect(cdk.propertyValidator("eventTypeIds", cdk.requiredValidator)(properties.eventTypeIds)), errors.collect(cdk.propertyValidator("eventTypeIds", cdk.listValidator(cdk.validateString))(properties.eventTypeIds)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("resource", cdk.requiredValidator)(properties.resource)), errors.collect(cdk.propertyValidator("resource", cdk.validateString)(properties.resource)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.collect(cdk.propertyValidator("targetAddress", cdk.validateString)(properties.targetAddress)), errors.collect(cdk.propertyValidator("targets", cdk.requiredValidator)(properties.targets)), errors.collect(cdk.propertyValidator("targets", cdk.listValidator(CfnNotificationRule_TargetPropertyValidator))(properties.targets)), errors.wrap('supplied properties not correct for "CfnNotificationRuleProps"');
    }
    function cfnNotificationRulePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNotificationRulePropsValidator(properties).assertSuccess(), { DetailType: cdk.stringToCloudFormation(properties.detailType), EventTypeIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.eventTypeIds), Name: cdk.stringToCloudFormation(properties.name), Resource: cdk.stringToCloudFormation(properties.resource), Targets: cdk.listMapper(cfnNotificationRuleTargetPropertyToCloudFormation)(properties.targets), CreatedBy: cdk.stringToCloudFormation(properties.createdBy), EventTypeId: cdk.stringToCloudFormation(properties.eventTypeId), Status: cdk.stringToCloudFormation(properties.status), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags), TargetAddress: cdk.stringToCloudFormation(properties.targetAddress) }) : properties;
    }
    function CfnNotificationRulePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("detailType", "DetailType", cfn_parse.FromCloudFormation.getString(properties.DetailType)), ret.addPropertyResult("eventTypeIds", "EventTypeIds", cfn_parse.FromCloudFormation.getStringArray(properties.EventTypeIds)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("resource", "Resource", cfn_parse.FromCloudFormation.getString(properties.Resource)), ret.addPropertyResult("targets", "Targets", cfn_parse.FromCloudFormation.getArray(CfnNotificationRuleTargetPropertyFromCloudFormation)(properties.Targets)), ret.addPropertyResult("createdBy", "CreatedBy", properties.CreatedBy != null ? cfn_parse.FromCloudFormation.getString(properties.CreatedBy) : void 0), ret.addPropertyResult("eventTypeId", "EventTypeId", properties.EventTypeId != null ? cfn_parse.FromCloudFormation.getString(properties.EventTypeId) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addPropertyResult("targetAddress", "TargetAddress", properties.TargetAddress != null ? cfn_parse.FromCloudFormation.getString(properties.TargetAddress) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnNotificationRule = class _CfnNotificationRule extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnNotificationRulePropsFromCloudFormation(resourceProperties), ret = new _CfnNotificationRule(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnNotificationRule.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codestarnotifications_CfnNotificationRuleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnNotificationRule), error;
        }
        cdk.requireProperty(props, "detailType", this), cdk.requireProperty(props, "eventTypeIds", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "resource", this), cdk.requireProperty(props, "targets", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.detailType = props.detailType, this.eventTypeIds = props.eventTypeIds, this.name = props.name, this.resource = props.resource, this.targets = props.targets, this.createdBy = props.createdBy, this.eventTypeId = props.eventTypeId, this.status = props.status, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::CodeStarNotifications::NotificationRule", props.tags, { tagPropertyName: "tags" }), this.targetAddress = props.targetAddress;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnNotificationRule.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { detailType: this.detailType, eventTypeIds: this.eventTypeIds, name: this.name, resource: this.resource, targets: this.targets, createdBy: this.createdBy, eventTypeId: this.eventTypeId, status: this.status, tags: this.tags.renderTags(), targetAddress: this.targetAddress };
      }
      renderProperties(props) {
        return cfnNotificationRulePropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnNotificationRule[_a] = { fqn: "aws-cdk-lib.aws_codestarnotifications.CfnNotificationRule", version: "2.80.0" }, CfnNotificationRule.CFN_RESOURCE_TYPE_NAME = "AWS::CodeStarNotifications::NotificationRule", exports2.CfnNotificationRule = CfnNotificationRule;
    function CfnNotificationRule_TargetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("targetAddress", cdk.requiredValidator)(properties.targetAddress)), errors.collect(cdk.propertyValidator("targetAddress", cdk.validateString)(properties.targetAddress)), errors.collect(cdk.propertyValidator("targetType", cdk.requiredValidator)(properties.targetType)), errors.collect(cdk.propertyValidator("targetType", cdk.validateString)(properties.targetType)), errors.wrap('supplied properties not correct for "TargetProperty"');
    }
    function cfnNotificationRuleTargetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNotificationRule_TargetPropertyValidator(properties).assertSuccess(), { TargetAddress: cdk.stringToCloudFormation(properties.targetAddress), TargetType: cdk.stringToCloudFormation(properties.targetType) }) : properties;
    }
    function CfnNotificationRuleTargetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("targetAddress", "TargetAddress", cfn_parse.FromCloudFormation.getString(properties.TargetAddress)), ret.addPropertyResult("targetType", "TargetType", cfn_parse.FromCloudFormation.getString(properties.TargetType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-codestarnotifications/lib/notification-rule.js
var require_notification_rule = __commonJS({
  "node_modules/aws-cdk-lib/aws-codestarnotifications/lib/notification-rule.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.NotificationRule = exports2.DetailType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var codestarnotifications_generated_1 = require_codestarnotifications_generated();
    var core_1 = require_core2();
    var DetailType;
    (function(DetailType2) {
      DetailType2.BASIC = "BASIC", DetailType2.FULL = "FULL";
    })(DetailType = exports2.DetailType || (exports2.DetailType = {}));
    var NotificationRule = class _NotificationRule extends core_1.Resource {
      static fromNotificationRuleArn(scope, id, notificationRuleArn) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.notificationRuleArn = notificationRuleArn;
          }
          addTarget(_target) {
            return false;
          }
        }
        return new Import(scope, id, { environmentFromArn: notificationRuleArn });
      }
      constructor(scope, id, props) {
        super(scope, id), this.targets = [], this.events = [];
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codestarnotifications_NotificationRuleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _NotificationRule), error;
        }
        const source = props.source.bindAsNotificationRuleSource(this);
        this.addEvents(props.events);
        const resource = new codestarnotifications_generated_1.CfnNotificationRule(this, "Resource", { name: props.notificationRuleName || core_1.Names.uniqueId(this).slice(-64), detailType: props.detailType || DetailType.FULL, targets: this.targets, eventTypeIds: this.events, resource: source.sourceArn, status: props.enabled !== void 0 ? props.enabled ? "ENABLED" : "DISABLED" : void 0 });
        this.notificationRuleArn = resource.ref, props.targets?.forEach((target) => {
          this.addTarget(target);
        });
      }
      addTarget(target) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codestarnotifications_INotificationRuleTarget(target);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addTarget), error;
        }
        return this.targets.push(target.bindAsNotificationRuleTarget(this)), true;
      }
      addEvents(events) {
        events.forEach((event) => {
          this.events.includes(event) || this.events.push(event);
        });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, NotificationRule[_a] = { fqn: "aws-cdk-lib.aws_codestarnotifications.NotificationRule", version: "2.80.0" }, exports2.NotificationRule = NotificationRule;
  }
});

// node_modules/aws-cdk-lib/aws-codestarnotifications/lib/notification-rule-source.js
var require_notification_rule_source = __commonJS({
  "node_modules/aws-cdk-lib/aws-codestarnotifications/lib/notification-rule-source.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-codestarnotifications/lib/notification-rule-target.js
var require_notification_rule_target = __commonJS({
  "node_modules/aws-cdk-lib/aws-codestarnotifications/lib/notification-rule-target.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-codestarnotifications/lib/index.js
var require_lib76 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codestarnotifications/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_codestarnotifications_generated(), exports2), __exportStar(require_notification_rule(), exports2), __exportStar(require_notification_rule_source(), exports2), __exportStar(require_notification_rule_target(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-codestarnotifications/index.js
var require_aws_codestarnotifications = __commonJS({
  "node_modules/aws-cdk-lib/aws-codestarnotifications/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib76(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-codebuild/lib/linux-arm-build-image.js
var require_linux_arm_build_image = __commonJS({
  "node_modules/aws-cdk-lib/aws-codebuild/lib/linux-arm-build-image.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LinuxArmBuildImage = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var run_script_linux_build_spec_1 = require_run_script_linux_build_spec();
    var project_1 = require_project();
    var LinuxArmBuildImage = class _LinuxArmBuildImage {
      static fromEcrRepository(repository, tagOrDigest = "latest") {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecr_IRepository(repository);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromEcrRepository), error;
        }
        return new _LinuxArmBuildImage({ imageId: repository.repositoryUriForTagOrDigest(tagOrDigest), imagePullPrincipalType: project_1.ImagePullPrincipalType.SERVICE_ROLE, repository });
      }
      static fromCodeBuildImageId(id) {
        return new _LinuxArmBuildImage({ imageId: id, imagePullPrincipalType: project_1.ImagePullPrincipalType.CODEBUILD });
      }
      constructor(props) {
        this.type = "ARM_CONTAINER", this.defaultComputeType = project_1.ComputeType.LARGE, this.imageId = props.imageId, this.imagePullPrincipalType = props.imagePullPrincipalType, this.secretsManagerCredentials = props.secretsManagerCredentials, this.repository = props.repository;
      }
      validate(buildEnvironment) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_BuildEnvironment(buildEnvironment);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.validate), error;
        }
        const ret = [];
        return buildEnvironment.computeType && buildEnvironment.computeType !== project_1.ComputeType.SMALL && buildEnvironment.computeType !== project_1.ComputeType.LARGE && ret.push(`ARM images only support ComputeTypes '${project_1.ComputeType.SMALL}' and '${project_1.ComputeType.LARGE}' - '${buildEnvironment.computeType}' was given`), ret;
      }
      runScriptBuildspec(entrypoint) {
        return (0, run_script_linux_build_spec_1.runScriptLinuxBuildSpec)(entrypoint);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LinuxArmBuildImage[_a] = { fqn: "aws-cdk-lib.aws_codebuild.LinuxArmBuildImage", version: "2.80.0" }, LinuxArmBuildImage.AMAZON_LINUX_2_STANDARD_1_0 = LinuxArmBuildImage.fromCodeBuildImageId("aws/codebuild/amazonlinux2-aarch64-standard:1.0"), LinuxArmBuildImage.AMAZON_LINUX_2_STANDARD_2_0 = LinuxArmBuildImage.fromCodeBuildImageId("aws/codebuild/amazonlinux2-aarch64-standard:2.0"), LinuxArmBuildImage.AMAZON_LINUX_2_STANDARD_3_0 = LinuxArmBuildImage.fromCodeBuildImageId("aws/codebuild/amazonlinux2-aarch64-standard:3.0"), exports2.LinuxArmBuildImage = LinuxArmBuildImage;
  }
});

// node_modules/aws-cdk-lib/aws-codebuild/lib/project.js
var require_project = __commonJS({
  "node_modules/aws-cdk-lib/aws-codebuild/lib/project.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ProjectNotificationEvents = exports2.BuildEnvironmentVariableType = exports2.WindowsBuildImage = exports2.WindowsImageType = exports2.LinuxBuildImage = exports2.ImagePullPrincipalType = exports2.ComputeType = exports2.Project = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var build_spec_1 = require_build_spec();
    var cache_1 = require_cache2();
    var codebuild_canned_metrics_generated_1 = require_codebuild_canned_metrics_generated();
    var codebuild_generated_1 = require_codebuild_generated();
    var codepipeline_artifacts_1 = require_codepipeline_artifacts();
    var no_artifacts_1 = require_no_artifacts();
    var no_source_1 = require_no_source();
    var run_script_linux_build_spec_1 = require_run_script_linux_build_spec();
    var report_group_utils_1 = require_report_group_utils();
    var source_types_1 = require_source_types();
    var cloudwatch = require_aws_cloudwatch();
    var notifications = require_aws_codestarnotifications();
    var ec2 = require_aws_ec2();
    var aws_ecr_assets_1 = require_aws_ecr_assets();
    var events = require_aws_events();
    var iam = require_aws_iam();
    var kms = require_aws_kms();
    var core_1 = require_core2();
    var VPC_POLICY_SYM = Symbol.for("@aws-cdk/aws-codebuild.roleVpcPolicy");
    var ProjectBase = class extends core_1.Resource {
      get connections() {
        if (!this._connections)
          throw new Error('Only VPC-associated Projects have security groups to manage. Supply the "vpc" parameter when creating the Project');
        return this._connections;
      }
      enableBatchBuilds() {
      }
      addToRolePolicy(statement) {
        this.role && this.role.addToPrincipalPolicy(statement);
      }
      onEvent(id, options = {}) {
        const rule = new events.Rule(this, id, options);
        return rule.addTarget(options.target), rule.addEventPattern({ source: ["aws.codebuild"], detail: { "project-name": [this.projectName] } }), rule;
      }
      onStateChange(id, options = {}) {
        const rule = this.onEvent(id, options);
        return rule.addEventPattern({ detailType: ["CodeBuild Build State Change"] }), rule;
      }
      onPhaseChange(id, options = {}) {
        const rule = this.onEvent(id, options);
        return rule.addEventPattern({ detailType: ["CodeBuild Build Phase Change"] }), rule;
      }
      onBuildStarted(id, options = {}) {
        const rule = this.onStateChange(id, options);
        return rule.addEventPattern({ detail: { "build-status": ["IN_PROGRESS"] } }), rule;
      }
      onBuildFailed(id, options = {}) {
        const rule = this.onStateChange(id, options);
        return rule.addEventPattern({ detail: { "build-status": ["FAILED"] } }), rule;
      }
      onBuildSucceeded(id, options = {}) {
        const rule = this.onStateChange(id, options);
        return rule.addEventPattern({ detail: { "build-status": ["SUCCEEDED"] } }), rule;
      }
      metric(metricName, props) {
        return new cloudwatch.Metric({ namespace: "AWS/CodeBuild", metricName, dimensionsMap: { ProjectName: this.projectName }, ...props }).attachTo(this);
      }
      metricBuilds(props) {
        return this.cannedMetric(codebuild_canned_metrics_generated_1.CodeBuildMetrics.buildsSum, props);
      }
      metricDuration(props) {
        return this.cannedMetric(codebuild_canned_metrics_generated_1.CodeBuildMetrics.durationAverage, props);
      }
      metricSucceededBuilds(props) {
        return this.cannedMetric(codebuild_canned_metrics_generated_1.CodeBuildMetrics.succeededBuildsSum, props);
      }
      metricFailedBuilds(props) {
        return this.cannedMetric(codebuild_canned_metrics_generated_1.CodeBuildMetrics.failedBuildsSum, props);
      }
      notifyOn(id, target, options) {
        return new notifications.NotificationRule(this, id, { ...options, source: this, targets: [target] });
      }
      notifyOnBuildSucceeded(id, target, options) {
        return this.notifyOn(id, target, { ...options, events: [ProjectNotificationEvents.BUILD_SUCCEEDED] });
      }
      notifyOnBuildFailed(id, target, options) {
        return this.notifyOn(id, target, { ...options, events: [ProjectNotificationEvents.BUILD_FAILED] });
      }
      bindAsNotificationRuleSource(_scope) {
        return { sourceArn: this.projectArn };
      }
      cannedMetric(fn, props) {
        return new cloudwatch.Metric({ ...fn({ ProjectName: this.projectName }), ...props }).attachTo(this);
      }
    };
    var Project = class _Project extends ProjectBase {
      static fromProjectArn(scope, id, projectArn) {
        const parsedArn = core_1.Stack.of(scope).splitArn(projectArn, core_1.ArnFormat.SLASH_RESOURCE_NAME);
        class Import extends ProjectBase {
          constructor(s, i) {
            super(s, i, { account: parsedArn.account, region: parsedArn.region }), this.projectArn = projectArn, this.projectName = parsedArn.resourceName, this.role = void 0, this.grantPrincipal = new iam.UnknownPrincipal({ resource: this });
          }
        }
        return new Import(scope, id);
      }
      static fromProjectName(scope, id, projectName) {
        class Import extends ProjectBase {
          constructor(s, i) {
            super(s, i), this.role = void 0, this.projectArn = core_1.Stack.of(this).formatArn({ service: "codebuild", resource: "project", resourceName: projectName }), this.grantPrincipal = new iam.UnknownPrincipal({ resource: this }), this.projectName = projectName;
          }
        }
        return new Import(scope, id);
      }
      static serializeEnvVariables(environmentVariables, validateNoPlainTextSecrets = false, principal) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(principal);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.serializeEnvVariables), error;
        }
        const ret = new Array(), ssmIamResources = new Array(), secretsManagerIamResources = /* @__PURE__ */ new Set(), kmsIamResources = /* @__PURE__ */ new Set();
        for (const [name, envVariable] of Object.entries(environmentVariables)) {
          const envVariableValue = envVariable.value?.toString(), cfnEnvVariable = { name, type: envVariable.type || BuildEnvironmentVariableType.PLAINTEXT, value: envVariableValue };
          if (ret.push(cfnEnvVariable), validateNoPlainTextSecrets && cfnEnvVariable.type === BuildEnvironmentVariableType.PLAINTEXT) {
            const fragments = core_1.Tokenization.reverseString(cfnEnvVariable.value);
            for (const token of fragments.tokens)
              if (token instanceof core_1.SecretValue)
                throw new Error(`Plaintext environment variable '${name}' contains a secret value! This means the value of this variable will be visible in plain text in the AWS Console. Please consider using CodeBuild's SecretsManager environment variables feature instead. If you'd like to continue with having this secret in the plaintext environment variables, please set the checkSecretsInPlainTextEnvVariables property to false`);
          }
          if (principal) {
            const stack = core_1.Stack.of(principal);
            if (envVariable.type === BuildEnvironmentVariableType.PARAMETER_STORE && ssmIamResources.push(stack.formatArn({ service: "ssm", resource: "parameter", resourceName: envVariableValue.startsWith("/") ? envVariableValue.slice(1) : envVariableValue })), envVariable.type === BuildEnvironmentVariableType.SECRETS_MANAGER)
              if (envVariableValue.startsWith("arn:")) {
                const parsedArn = stack.splitArn(envVariableValue, core_1.ArnFormat.COLON_RESOURCE_NAME);
                if (!parsedArn.resourceName)
                  throw new Error("SecretManager ARN is missing the name of the secret: " + envVariableValue);
                const secretName = parsedArn.resourceName.split(":")[0];
                secretsManagerIamResources.add(stack.formatArn({ service: "secretsmanager", resource: "secret", resourceName: `${secretName}*`, arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME, partition: parsedArn.partition, account: parsedArn.account, region: parsedArn.region })), parsedArn.account && core_1.Token.compareStrings(parsedArn.account, stack.account) === core_1.TokenComparison.DIFFERENT && kmsIamResources.add(stack.formatArn({ service: "kms", resource: "key", resourceName: "*", arnFormat: core_1.ArnFormat.SLASH_RESOURCE_NAME, partition: parsedArn.partition, account: parsedArn.account, region: parsedArn.region }));
              } else if (core_1.Token.isUnresolved(envVariableValue)) {
                let secretArn = envVariableValue.split(":")[0];
                const fragments = core_1.Tokenization.reverseString(envVariableValue);
                if (fragments.tokens.length === 1) {
                  const resolvable = fragments.tokens[0];
                  if (core_1.Reference.isReference(resolvable)) {
                    const resourceStack = core_1.Stack.of(resolvable.target);
                    core_1.Token.compareStrings(stack.account, resourceStack.account) === core_1.TokenComparison.DIFFERENT && (kmsIamResources.add(stack.formatArn({ service: "kms", resource: "key", resourceName: "*", arnFormat: core_1.ArnFormat.SLASH_RESOURCE_NAME, partition: resourceStack.partition, account: resourceStack.account, region: resourceStack.region })), secretArn = `${secretArn}-??????`);
                  }
                }
                secretsManagerIamResources.add(secretArn);
              } else {
                const secretName = envVariableValue.split(":")[0];
                secretsManagerIamResources.add(stack.formatArn({ service: "secretsmanager", resource: "secret", resourceName: `${secretName}-??????`, arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME }));
              }
          }
        }
        return ssmIamResources.length !== 0 && principal?.grantPrincipal.addToPrincipalPolicy(new iam.PolicyStatement({ actions: ["ssm:GetParameters"], resources: ssmIamResources })), secretsManagerIamResources.size !== 0 && principal?.grantPrincipal.addToPrincipalPolicy(new iam.PolicyStatement({ actions: ["secretsmanager:GetSecretValue"], resources: Array.from(secretsManagerIamResources) })), kmsIamResources.size !== 0 && principal?.grantPrincipal.addToPrincipalPolicy(new iam.PolicyStatement({ actions: ["kms:Decrypt"], resources: Array.from(kmsIamResources) })), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.projectName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_ProjectProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Project), error;
        }
        this.role = props.role || new iam.Role(this, "Role", { roleName: core_1.PhysicalName.GENERATE_IF_NEEDED, assumedBy: new iam.ServicePrincipal("codebuild.amazonaws.com") }), this.grantPrincipal = this.role, this.buildImage = props.environment && props.environment.buildImage || LinuxBuildImage.STANDARD_1_0, this.source = props.source || new no_source_1.NoSource();
        const sourceConfig = this.source.bind(this, this);
        if (props.badge && !this.source.badgeSupported)
          throw new Error(`Badge is not supported for source type ${this.source.type}`);
        const artifacts = props.artifacts ? props.artifacts : this.source.type === source_types_1.CODEPIPELINE_SOURCE_ARTIFACTS_TYPE ? new codepipeline_artifacts_1.CodePipelineArtifacts() : new no_artifacts_1.NoArtifacts(), artifactsConfig = artifacts.bind(this, this), cache = props.cache || cache_1.Cache.none();
        cache._bind(this);
        const environmentVariables = props.environmentVariables || {}, buildSpec = props.buildSpec;
        if (this.source.type === source_types_1.NO_SOURCE_TYPE && (buildSpec === void 0 || !buildSpec.isImmediate))
          throw new Error("If the Project's source is NoSource, you need to provide a concrete buildSpec");
        this._secondarySources = [], this._secondarySourceVersions = [], this._fileSystemLocations = [];
        for (const secondarySource of props.secondarySources || [])
          this.addSecondarySource(secondarySource);
        this._secondaryArtifacts = [];
        for (const secondaryArtifact of props.secondaryArtifacts || [])
          this.addSecondaryArtifact(secondaryArtifact);
        this.validateCodePipelineSettings(artifacts);
        for (const fileSystemLocation of props.fileSystemLocations || [])
          this.addFileSystemLocation(fileSystemLocation);
        const resource = new codebuild_generated_1.CfnProject(this, "Resource", { description: props.description, source: { ...sourceConfig.sourceProperty, buildSpec: buildSpec && buildSpec.toBuildSpec(this) }, artifacts: artifactsConfig.artifactsProperty, serviceRole: this.role.roleArn, environment: this.renderEnvironment(props, environmentVariables), fileSystemLocations: core_1.Lazy.any({ produce: () => this.renderFileSystemLocations() }), encryptionKey: core_1.Lazy.string({ produce: () => this._encryptionKey ? this._encryptionKey.keyArn : "alias/aws/s3" }), badgeEnabled: props.badge, cache: cache._toCloudFormation(), name: this.physicalName, timeoutInMinutes: props.timeout && props.timeout.toMinutes(), queuedTimeoutInMinutes: props.queuedTimeout && props.queuedTimeout.toMinutes(), concurrentBuildLimit: props.concurrentBuildLimit, secondarySources: core_1.Lazy.any({ produce: () => this.renderSecondarySources() }), secondarySourceVersions: core_1.Lazy.any({ produce: () => this.renderSecondarySourceVersions() }), secondaryArtifacts: core_1.Lazy.any({ produce: () => this.renderSecondaryArtifacts() }), triggers: sourceConfig.buildTriggers, sourceVersion: sourceConfig.sourceVersion, vpcConfig: this.configureVpc(props), logsConfig: this.renderLoggingConfiguration(props.logging), buildBatchConfig: core_1.Lazy.any({ produce: () => this._batchServiceRole ? { serviceRole: this._batchServiceRole.roleArn } : void 0 }) });
        this.addVpcRequiredPermissions(props, resource), this.projectArn = this.getResourceArnAttribute(resource.attrArn, { service: "codebuild", resource: "project", resourceName: this.physicalName }), this.projectName = this.getResourceNameAttribute(resource.ref), this.addToRolePolicy(this.createLoggingPermission()), props.grantReportGroupPermissions !== false && this.addToRolePolicy(new iam.PolicyStatement({ actions: ["codebuild:CreateReportGroup", "codebuild:CreateReport", "codebuild:UpdateReport", "codebuild:BatchPutTestCases", "codebuild:BatchPutCodeCoverages"], resources: [(0, report_group_utils_1.renderReportGroupArn)(this, `${this.projectName}-*`)] })), props.ssmSessionPermissions && this.addToRolePolicy(new iam.PolicyStatement({ actions: ["ssmmessages:CreateControlChannel", "ssmmessages:CreateDataChannel", "ssmmessages:OpenControlChannel", "ssmmessages:OpenDataChannel", "logs:DescribeLogGroups", "logs:CreateLogStream", "logs:PutLogEvents", "s3:GetEncryptionConfiguration", "s3:PutObject"], resources: ["*"] })), props.encryptionKey && (this.encryptionKey = props.encryptionKey), isBindableBuildImage(this.buildImage) && this.buildImage.bind(this, this, {}), this.node.addValidation({ validate: () => this.validateProject() });
      }
      enableBatchBuilds() {
        return this._batchServiceRole || (this._batchServiceRole = new iam.Role(this, "BatchServiceRole", { assumedBy: new iam.ServicePrincipal("codebuild.amazonaws.com") }), this._batchServiceRole.addToPrincipalPolicy(new iam.PolicyStatement({ resources: [core_1.Lazy.string({ produce: () => this.projectArn })], actions: ["codebuild:StartBuild", "codebuild:StopBuild", "codebuild:RetryBuild"] }))), { role: this._batchServiceRole };
      }
      addSecondarySource(secondarySource) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_ISource(secondarySource);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addSecondarySource), error;
        }
        if (!secondarySource.identifier)
          throw new Error("The identifier attribute is mandatory for secondary sources");
        const secondarySourceConfig = secondarySource.bind(this, this);
        this._secondarySources.push(secondarySourceConfig.sourceProperty), secondarySourceConfig.sourceVersion && this._secondarySourceVersions.push({ sourceIdentifier: secondarySource.identifier, sourceVersion: secondarySourceConfig.sourceVersion });
      }
      addFileSystemLocation(fileSystemLocation) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_IFileSystemLocation(fileSystemLocation);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addFileSystemLocation), error;
        }
        const fileSystemConfig = fileSystemLocation.bind(this, this);
        this._fileSystemLocations.push(fileSystemConfig.location);
      }
      addSecondaryArtifact(secondaryArtifact) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_IArtifacts(secondaryArtifact);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addSecondaryArtifact), error;
        }
        if (!secondaryArtifact.identifier)
          throw new Error("The identifier attribute is mandatory for secondary artifacts");
        this._secondaryArtifacts.push(secondaryArtifact.bind(this, this).artifactsProperty);
      }
      bindToCodePipeline(_scope, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_BindToCodePipelineOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bindToCodePipeline), error;
        }
        if (options.artifactBucket.encryptionKey && !this._encryptionKey) {
          const keyStack = core_1.Stack.of(options.artifactBucket.encryptionKey), projectStack = core_1.Stack.of(this);
          options.artifactBucket.encryptionKey instanceof kms.Key && (keyStack.account !== projectStack.account || keyStack.region !== projectStack.region) || (this.encryptionKey = options.artifactBucket.encryptionKey);
        }
      }
      validateProject() {
        const ret = new Array();
        return this.source.type === source_types_1.CODEPIPELINE_SOURCE_ARTIFACTS_TYPE && (this._secondarySources.length > 0 && ret.push("A Project with a CodePipeline Source cannot have secondary sources. Use the CodeBuild Pipeline Actions' `extraInputs` property instead"), this._secondaryArtifacts.length > 0 && ret.push("A Project with a CodePipeline Source cannot have secondary artifacts. Use the CodeBuild Pipeline Actions' `outputs` property instead")), ret;
      }
      set encryptionKey(encryptionKey) {
        this._encryptionKey = encryptionKey, encryptionKey.grantEncryptDecrypt(this);
      }
      createLoggingPermission() {
        const logGroupArn = core_1.Stack.of(this).formatArn({ service: "logs", resource: "log-group", arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME, resourceName: `/aws/codebuild/${this.projectName}` }), logGroupStarArn = `${logGroupArn}:*`;
        return new iam.PolicyStatement({ resources: [logGroupArn, logGroupStarArn], actions: ["logs:CreateLogGroup", "logs:CreateLogStream", "logs:PutLogEvents"] });
      }
      renderEnvironment(props, projectVars = {}) {
        const env = props.environment ?? {}, vars = {}, containerVars = env.environmentVariables || {};
        for (const name of Object.keys(containerVars))
          vars[name] = containerVars[name];
        for (const name of Object.keys(projectVars))
          vars[name] = projectVars[name];
        const hasEnvironmentVars = Object.keys(vars).length > 0, errors = this.buildImage.validate(env);
        if (errors.length > 0)
          throw new Error("Invalid CodeBuild environment: " + errors.join(`
`));
        const imagePullPrincipalType = this.buildImage.imagePullPrincipalType === ImagePullPrincipalType.CODEBUILD ? ImagePullPrincipalType.CODEBUILD : ImagePullPrincipalType.SERVICE_ROLE;
        if (this.buildImage.repository)
          if (imagePullPrincipalType === ImagePullPrincipalType.SERVICE_ROLE)
            this.buildImage.repository.grantPull(this);
          else {
            const statement = new iam.PolicyStatement({ principals: [new iam.ServicePrincipal("codebuild.amazonaws.com")], actions: ["ecr:GetDownloadUrlForLayer", "ecr:BatchGetImage", "ecr:BatchCheckLayerAvailability"] });
            statement.sid = "CodeBuild", this.buildImage.repository.addToResourcePolicy(statement);
          }
        imagePullPrincipalType === ImagePullPrincipalType.SERVICE_ROLE && this.buildImage.secretsManagerCredentials?.grantRead(this);
        const secret = this.buildImage.secretsManagerCredentials;
        return { type: this.buildImage.type, image: this.buildImage.imageId, imagePullCredentialsType: imagePullPrincipalType, registryCredential: secret ? { credentialProvider: "SECRETS_MANAGER", credential: secret.secretFullArn ?? secret.secretName } : void 0, certificate: env.certificate?.bucket.arnForObjects(env.certificate.objectKey), privilegedMode: env.privileged || false, computeType: env.computeType || this.buildImage.defaultComputeType, environmentVariables: hasEnvironmentVars ? _Project.serializeEnvVariables(vars, props.checkSecretsInPlainTextEnvVariables ?? true, this) : void 0 };
      }
      renderFileSystemLocations() {
        return this._fileSystemLocations.length === 0 ? void 0 : this._fileSystemLocations;
      }
      renderSecondarySources() {
        return this._secondarySources.length === 0 ? void 0 : this._secondarySources;
      }
      renderSecondarySourceVersions() {
        return this._secondarySourceVersions.length === 0 ? void 0 : this._secondarySourceVersions;
      }
      renderSecondaryArtifacts() {
        return this._secondaryArtifacts.length === 0 ? void 0 : this._secondaryArtifacts;
      }
      configureVpc(props) {
        if ((props.securityGroups || props.allowAllOutbound !== void 0) && !props.vpc)
          throw new Error("Cannot configure 'securityGroup' or 'allowAllOutbound' without configuring a VPC");
        if (!props.vpc)
          return;
        if (props.securityGroups && props.securityGroups.length > 0 && props.allowAllOutbound !== void 0)
          throw new Error("Configure 'allowAllOutbound' directly on the supplied SecurityGroup.");
        let securityGroups;
        return props.securityGroups && props.securityGroups.length > 0 ? securityGroups = props.securityGroups : securityGroups = [new ec2.SecurityGroup(this, "SecurityGroup", { vpc: props.vpc, description: "Automatic generated security group for CodeBuild " + core_1.Names.uniqueId(this), allowAllOutbound: props.allowAllOutbound })], this._connections = new ec2.Connections({ securityGroups }), { vpcId: props.vpc.vpcId, subnets: props.vpc.selectSubnets(props.subnetSelection).subnetIds, securityGroupIds: this.connections.securityGroups.map((s) => s.securityGroupId) };
      }
      renderLoggingConfiguration(props) {
        if (props === void 0)
          return;
        let s3Config, cloudwatchConfig;
        if (props.s3) {
          const s3Logs = props.s3;
          s3Config = { status: s3Logs.enabled ?? true ? "ENABLED" : "DISABLED", location: `${s3Logs.bucket.bucketName}` + (s3Logs.prefix ? `/${s3Logs.prefix}` : ""), encryptionDisabled: s3Logs.encrypted }, s3Logs.bucket?.grantWrite(this);
        }
        if (props.cloudWatch) {
          const cloudWatchLogs = props.cloudWatch, status = cloudWatchLogs.enabled ?? true ? "ENABLED" : "DISABLED";
          if (status === "ENABLED" && !cloudWatchLogs.logGroup)
            throw new Error("Specifying a LogGroup is required if CloudWatch logging for CodeBuild is enabled");
          cloudWatchLogs.logGroup?.grantWrite(this), cloudwatchConfig = { status, groupName: cloudWatchLogs.logGroup?.logGroupName, streamName: cloudWatchLogs.prefix };
        }
        return { s3Logs: s3Config, cloudWatchLogs: cloudwatchConfig };
      }
      addVpcRequiredPermissions(props, project) {
        if (!props.vpc || !this.role)
          return;
        this.role.addToPrincipalPolicy(new iam.PolicyStatement({ resources: [`arn:${core_1.Aws.PARTITION}:ec2:${core_1.Aws.REGION}:${core_1.Aws.ACCOUNT_ID}:network-interface/*`], actions: ["ec2:CreateNetworkInterfacePermission"], conditions: { StringEquals: { "ec2:Subnet": props.vpc.selectSubnets(props.subnetSelection).subnetIds.map((si) => `arn:${core_1.Aws.PARTITION}:ec2:${core_1.Aws.REGION}:${core_1.Aws.ACCOUNT_ID}:subnet/${si}`), "ec2:AuthorizedService": "codebuild.amazonaws.com" } } }));
        let policy = this.role[VPC_POLICY_SYM];
        policy || (policy = new iam.Policy(this, "PolicyDocument", { statements: [new iam.PolicyStatement({ resources: ["*"], actions: ["ec2:CreateNetworkInterface", "ec2:DescribeNetworkInterfaces", "ec2:DeleteNetworkInterface", "ec2:DescribeSubnets", "ec2:DescribeSecurityGroups", "ec2:DescribeDhcpOptions", "ec2:DescribeVpcs"] })] }), this.role.attachInlinePolicy(policy), this.role[VPC_POLICY_SYM] = policy), project.node.addDependency(policy);
      }
      validateCodePipelineSettings(artifacts) {
        const sourceType = this.source.type, artifactsType = artifacts.type;
        if ((sourceType === source_types_1.CODEPIPELINE_SOURCE_ARTIFACTS_TYPE || artifactsType === source_types_1.CODEPIPELINE_SOURCE_ARTIFACTS_TYPE) && sourceType !== artifactsType)
          throw new Error("Both source and artifacts must be set to CodePipeline");
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Project[_a] = { fqn: "aws-cdk-lib.aws_codebuild.Project", version: "2.80.0" }, exports2.Project = Project;
    var ComputeType;
    (function(ComputeType2) {
      ComputeType2.SMALL = "BUILD_GENERAL1_SMALL", ComputeType2.MEDIUM = "BUILD_GENERAL1_MEDIUM", ComputeType2.LARGE = "BUILD_GENERAL1_LARGE", ComputeType2.X2_LARGE = "BUILD_GENERAL1_2XLARGE";
    })(ComputeType = exports2.ComputeType || (exports2.ComputeType = {}));
    var ImagePullPrincipalType;
    (function(ImagePullPrincipalType2) {
      ImagePullPrincipalType2.CODEBUILD = "CODEBUILD", ImagePullPrincipalType2.SERVICE_ROLE = "SERVICE_ROLE";
    })(ImagePullPrincipalType = exports2.ImagePullPrincipalType || (exports2.ImagePullPrincipalType = {}));
    var linux_arm_build_image_1 = require_linux_arm_build_image();
    var LinuxBuildImage = class _LinuxBuildImage {
      static fromDockerRegistry(name, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_DockerImageOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromDockerRegistry), error;
        }
        return new _LinuxBuildImage({ ...options, imageId: name, imagePullPrincipalType: ImagePullPrincipalType.SERVICE_ROLE });
      }
      static fromEcrRepository(repository, tagOrDigest = "latest") {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecr_IRepository(repository);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromEcrRepository), error;
        }
        return new _LinuxBuildImage({ imageId: repository.repositoryUriForTagOrDigest(tagOrDigest), imagePullPrincipalType: ImagePullPrincipalType.SERVICE_ROLE, repository });
      }
      static fromAsset(scope, id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecr_assets_DockerImageAssetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromAsset), error;
        }
        const asset = new aws_ecr_assets_1.DockerImageAsset(scope, id, props);
        return new _LinuxBuildImage({ imageId: asset.imageUri, imagePullPrincipalType: ImagePullPrincipalType.SERVICE_ROLE, repository: asset.repository });
      }
      static fromCodeBuildImageId(id) {
        return _LinuxBuildImage.codeBuildImage(id);
      }
      static codeBuildImage(name) {
        return new _LinuxBuildImage({ imageId: name, imagePullPrincipalType: ImagePullPrincipalType.CODEBUILD });
      }
      constructor(props) {
        this.type = "LINUX_CONTAINER", this.defaultComputeType = ComputeType.SMALL, this.imageId = props.imageId, this.imagePullPrincipalType = props.imagePullPrincipalType, this.secretsManagerCredentials = props.secretsManagerCredentials, this.repository = props.repository;
      }
      validate(_env) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_BuildEnvironment(_env);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.validate), error;
        }
        return [];
      }
      runScriptBuildspec(entrypoint) {
        return (0, run_script_linux_build_spec_1.runScriptLinuxBuildSpec)(entrypoint);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, LinuxBuildImage[_b] = { fqn: "aws-cdk-lib.aws_codebuild.LinuxBuildImage", version: "2.80.0" }, LinuxBuildImage.STANDARD_1_0 = LinuxBuildImage.codeBuildImage("aws/codebuild/standard:1.0"), LinuxBuildImage.STANDARD_2_0 = LinuxBuildImage.codeBuildImage("aws/codebuild/standard:2.0"), LinuxBuildImage.STANDARD_3_0 = LinuxBuildImage.codeBuildImage("aws/codebuild/standard:3.0"), LinuxBuildImage.STANDARD_4_0 = LinuxBuildImage.codeBuildImage("aws/codebuild/standard:4.0"), LinuxBuildImage.STANDARD_5_0 = LinuxBuildImage.codeBuildImage("aws/codebuild/standard:5.0"), LinuxBuildImage.STANDARD_6_0 = LinuxBuildImage.codeBuildImage("aws/codebuild/standard:6.0"), LinuxBuildImage.STANDARD_7_0 = LinuxBuildImage.codeBuildImage("aws/codebuild/standard:7.0"), LinuxBuildImage.AMAZON_LINUX_2 = LinuxBuildImage.codeBuildImage("aws/codebuild/amazonlinux2-x86_64-standard:1.0"), LinuxBuildImage.AMAZON_LINUX_2_2 = LinuxBuildImage.codeBuildImage("aws/codebuild/amazonlinux2-x86_64-standard:2.0"), LinuxBuildImage.AMAZON_LINUX_2_3 = LinuxBuildImage.codeBuildImage("aws/codebuild/amazonlinux2-x86_64-standard:3.0"), LinuxBuildImage.AMAZON_LINUX_2_4 = LinuxBuildImage.codeBuildImage("aws/codebuild/amazonlinux2-x86_64-standard:4.0"), LinuxBuildImage.AMAZON_LINUX_2_ARM = linux_arm_build_image_1.LinuxArmBuildImage.AMAZON_LINUX_2_STANDARD_1_0, LinuxBuildImage.AMAZON_LINUX_2_ARM_2 = linux_arm_build_image_1.LinuxArmBuildImage.AMAZON_LINUX_2_STANDARD_2_0, LinuxBuildImage.AMAZON_LINUX_2_ARM_3 = linux_arm_build_image_1.LinuxArmBuildImage.AMAZON_LINUX_2_STANDARD_3_0, LinuxBuildImage.UBUNTU_14_04_BASE = LinuxBuildImage.codeBuildImage("aws/codebuild/ubuntu-base:14.04"), LinuxBuildImage.UBUNTU_14_04_ANDROID_JAVA8_24_4_1 = LinuxBuildImage.codeBuildImage("aws/codebuild/android-java-8:24.4.1"), LinuxBuildImage.UBUNTU_14_04_ANDROID_JAVA8_26_1_1 = LinuxBuildImage.codeBuildImage("aws/codebuild/android-java-8:26.1.1"), LinuxBuildImage.UBUNTU_14_04_DOCKER_17_09_0 = LinuxBuildImage.codeBuildImage("aws/codebuild/docker:17.09.0"), LinuxBuildImage.UBUNTU_14_04_DOCKER_18_09_0 = LinuxBuildImage.codeBuildImage("aws/codebuild/docker:18.09.0"), LinuxBuildImage.UBUNTU_14_04_GOLANG_1_10 = LinuxBuildImage.codeBuildImage("aws/codebuild/golang:1.10"), LinuxBuildImage.UBUNTU_14_04_GOLANG_1_11 = LinuxBuildImage.codeBuildImage("aws/codebuild/golang:1.11"), LinuxBuildImage.UBUNTU_14_04_OPEN_JDK_8 = LinuxBuildImage.codeBuildImage("aws/codebuild/java:openjdk-8"), LinuxBuildImage.UBUNTU_14_04_OPEN_JDK_9 = LinuxBuildImage.codeBuildImage("aws/codebuild/java:openjdk-9"), LinuxBuildImage.UBUNTU_14_04_OPEN_JDK_11 = LinuxBuildImage.codeBuildImage("aws/codebuild/java:openjdk-11"), LinuxBuildImage.UBUNTU_14_04_NODEJS_10_14_1 = LinuxBuildImage.codeBuildImage("aws/codebuild/nodejs:10.14.1"), LinuxBuildImage.UBUNTU_14_04_NODEJS_10_1_0 = LinuxBuildImage.codeBuildImage("aws/codebuild/nodejs:10.1.0"), LinuxBuildImage.UBUNTU_14_04_NODEJS_8_11_0 = LinuxBuildImage.codeBuildImage("aws/codebuild/nodejs:8.11.0"), LinuxBuildImage.UBUNTU_14_04_NODEJS_6_3_1 = LinuxBuildImage.codeBuildImage("aws/codebuild/nodejs:6.3.1"), LinuxBuildImage.UBUNTU_14_04_PHP_5_6 = LinuxBuildImage.codeBuildImage("aws/codebuild/php:5.6"), LinuxBuildImage.UBUNTU_14_04_PHP_7_0 = LinuxBuildImage.codeBuildImage("aws/codebuild/php:7.0"), LinuxBuildImage.UBUNTU_14_04_PHP_7_1 = LinuxBuildImage.codeBuildImage("aws/codebuild/php:7.1"), LinuxBuildImage.UBUNTU_14_04_PYTHON_3_7_1 = LinuxBuildImage.codeBuildImage("aws/codebuild/python:3.7.1"), LinuxBuildImage.UBUNTU_14_04_PYTHON_3_6_5 = LinuxBuildImage.codeBuildImage("aws/codebuild/python:3.6.5"), LinuxBuildImage.UBUNTU_14_04_PYTHON_3_5_2 = LinuxBuildImage.codeBuildImage("aws/codebuild/python:3.5.2"), LinuxBuildImage.UBUNTU_14_04_PYTHON_3_4_5 = LinuxBuildImage.codeBuildImage("aws/codebuild/python:3.4.5"), LinuxBuildImage.UBUNTU_14_04_PYTHON_3_3_6 = LinuxBuildImage.codeBuildImage("aws/codebuild/python:3.3.6"), LinuxBuildImage.UBUNTU_14_04_PYTHON_2_7_12 = LinuxBuildImage.codeBuildImage("aws/codebuild/python:2.7.12"), LinuxBuildImage.UBUNTU_14_04_RUBY_2_5_3 = LinuxBuildImage.codeBuildImage("aws/codebuild/ruby:2.5.3"), LinuxBuildImage.UBUNTU_14_04_RUBY_2_5_1 = LinuxBuildImage.codeBuildImage("aws/codebuild/ruby:2.5.1"), LinuxBuildImage.UBUNTU_14_04_RUBY_2_3_1 = LinuxBuildImage.codeBuildImage("aws/codebuild/ruby:2.3.1"), LinuxBuildImage.UBUNTU_14_04_RUBY_2_2_5 = LinuxBuildImage.codeBuildImage("aws/codebuild/ruby:2.2.5"), LinuxBuildImage.UBUNTU_14_04_DOTNET_CORE_1_1 = LinuxBuildImage.codeBuildImage("aws/codebuild/dot-net:core-1"), LinuxBuildImage.UBUNTU_14_04_DOTNET_CORE_2_0 = LinuxBuildImage.codeBuildImage("aws/codebuild/dot-net:core-2.0"), LinuxBuildImage.UBUNTU_14_04_DOTNET_CORE_2_1 = LinuxBuildImage.codeBuildImage("aws/codebuild/dot-net:core-2.1"), exports2.LinuxBuildImage = LinuxBuildImage;
    var WindowsImageType;
    (function(WindowsImageType2) {
      WindowsImageType2.STANDARD = "WINDOWS_CONTAINER", WindowsImageType2.SERVER_2019 = "WINDOWS_SERVER_2019_CONTAINER";
    })(WindowsImageType = exports2.WindowsImageType || (exports2.WindowsImageType = {}));
    var WindowsBuildImage = class _WindowsBuildImage {
      static fromDockerRegistry(name, options = {}, imageType = WindowsImageType.STANDARD) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_DockerImageOptions(options), jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_WindowsImageType(imageType);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromDockerRegistry), error;
        }
        return new _WindowsBuildImage({ ...options, imageId: name, imagePullPrincipalType: ImagePullPrincipalType.SERVICE_ROLE, imageType });
      }
      static fromEcrRepository(repository, tagOrDigest = "latest", imageType = WindowsImageType.STANDARD) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecr_IRepository(repository), jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_WindowsImageType(imageType);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromEcrRepository), error;
        }
        return new _WindowsBuildImage({ imageId: repository.repositoryUriForTagOrDigest(tagOrDigest), imagePullPrincipalType: ImagePullPrincipalType.SERVICE_ROLE, imageType, repository });
      }
      static fromAsset(scope, id, props, imageType = WindowsImageType.STANDARD) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecr_assets_DockerImageAssetProps(props), jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_WindowsImageType(imageType);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromAsset), error;
        }
        const asset = new aws_ecr_assets_1.DockerImageAsset(scope, id, props);
        return new _WindowsBuildImage({ imageId: asset.imageUri, imagePullPrincipalType: ImagePullPrincipalType.SERVICE_ROLE, imageType, repository: asset.repository });
      }
      constructor(props) {
        this.defaultComputeType = ComputeType.MEDIUM, this.type = (props.imageType ?? WindowsImageType.STANDARD).toString(), this.imageId = props.imageId, this.imagePullPrincipalType = props.imagePullPrincipalType, this.secretsManagerCredentials = props.secretsManagerCredentials, this.repository = props.repository;
      }
      validate(buildEnvironment) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_BuildEnvironment(buildEnvironment);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.validate), error;
        }
        const ret = [];
        return buildEnvironment.computeType === ComputeType.SMALL && ret.push("Windows images do not support the Small ComputeType"), ret;
      }
      runScriptBuildspec(entrypoint) {
        return build_spec_1.BuildSpec.fromObject({ version: "0.2", phases: { pre_build: { commands: [] }, build: { commands: ["Set-Variable -Name TEMPDIR -Value (New-TemporaryFile).DirectoryName", `aws s3 cp s3://$env:${run_script_linux_build_spec_1.S3_BUCKET_ENV}/$env:${run_script_linux_build_spec_1.S3_KEY_ENV} $TEMPDIR\\scripts.zip`, "New-Item -ItemType Directory -Path $TEMPDIR\\scriptdir", "Expand-Archive -Path $TEMPDIR/scripts.zip -DestinationPath $TEMPDIR\\scriptdir", '$env:SCRIPT_DIR = "$TEMPDIR\\scriptdir"', `& $TEMPDIR\\scriptdir\\${entrypoint}`] } } });
      }
    };
    _c = JSII_RTTI_SYMBOL_1, WindowsBuildImage[_c] = { fqn: "aws-cdk-lib.aws_codebuild.WindowsBuildImage", version: "2.80.0" }, WindowsBuildImage.WIN_SERVER_CORE_2016_BASE = new WindowsBuildImage({ imageId: "aws/codebuild/windows-base:1.0", imagePullPrincipalType: ImagePullPrincipalType.CODEBUILD }), WindowsBuildImage.WINDOWS_BASE_2_0 = new WindowsBuildImage({ imageId: "aws/codebuild/windows-base:2.0", imagePullPrincipalType: ImagePullPrincipalType.CODEBUILD }), WindowsBuildImage.WIN_SERVER_CORE_2019_BASE = new WindowsBuildImage({ imageId: "aws/codebuild/windows-base:2019-1.0", imagePullPrincipalType: ImagePullPrincipalType.CODEBUILD, imageType: WindowsImageType.SERVER_2019 }), WindowsBuildImage.WIN_SERVER_CORE_2019_BASE_2_0 = new WindowsBuildImage({ imageId: "aws/codebuild/windows-base:2019-2.0", imagePullPrincipalType: ImagePullPrincipalType.CODEBUILD, imageType: WindowsImageType.SERVER_2019 }), exports2.WindowsBuildImage = WindowsBuildImage;
    var BuildEnvironmentVariableType;
    (function(BuildEnvironmentVariableType2) {
      BuildEnvironmentVariableType2.PLAINTEXT = "PLAINTEXT", BuildEnvironmentVariableType2.PARAMETER_STORE = "PARAMETER_STORE", BuildEnvironmentVariableType2.SECRETS_MANAGER = "SECRETS_MANAGER";
    })(BuildEnvironmentVariableType = exports2.BuildEnvironmentVariableType || (exports2.BuildEnvironmentVariableType = {}));
    var ProjectNotificationEvents;
    (function(ProjectNotificationEvents2) {
      ProjectNotificationEvents2.BUILD_FAILED = "codebuild-project-build-state-failed", ProjectNotificationEvents2.BUILD_SUCCEEDED = "codebuild-project-build-state-succeeded", ProjectNotificationEvents2.BUILD_IN_PROGRESS = "codebuild-project-build-state-in-progress", ProjectNotificationEvents2.BUILD_STOPPED = "codebuild-project-build-state-stopped", ProjectNotificationEvents2.BUILD_PHASE_FAILED = "codebuild-project-build-phase-failure", ProjectNotificationEvents2.BUILD_PHASE_SUCCEEDED = "codebuild-project-build-phase-success";
    })(ProjectNotificationEvents = exports2.ProjectNotificationEvents || (exports2.ProjectNotificationEvents = {}));
    function isBindableBuildImage(x) {
      return typeof x == "object" && !!x && !!x.bind;
    }
  }
});

// node_modules/aws-cdk-lib/aws-codebuild/lib/pipeline-project.js
var require_pipeline_project = __commonJS({
  "node_modules/aws-cdk-lib/aws-codebuild/lib/pipeline-project.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PipelineProject = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var codepipeline_artifacts_1 = require_codepipeline_artifacts();
    var codepipeline_source_1 = require_codepipeline_source();
    var project_1 = require_project();
    var PipelineProject = class _PipelineProject extends project_1.Project {
      constructor(scope, id, props) {
        super(scope, id, { source: new codepipeline_source_1.CodePipelineSource(), artifacts: new codepipeline_artifacts_1.CodePipelineArtifacts(), ...props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_PipelineProjectProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _PipelineProject), error;
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, PipelineProject[_a] = { fqn: "aws-cdk-lib.aws_codebuild.PipelineProject", version: "2.80.0" }, exports2.PipelineProject = PipelineProject;
  }
});

// node_modules/aws-cdk-lib/aws-codebuild/lib/project-logs.js
var require_project_logs = __commonJS({
  "node_modules/aws-cdk-lib/aws-codebuild/lib/project-logs.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-codebuild/lib/report-group.js
var require_report_group = __commonJS({
  "node_modules/aws-cdk-lib/aws-codebuild/lib/report-group.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ReportGroup = exports2.ReportGroupType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var codebuild_generated_1 = require_codebuild_generated();
    var report_group_utils_1 = require_report_group_utils();
    var iam = require_aws_iam();
    var cdk = require_core2();
    var ReportGroupBase = class extends cdk.Resource {
      grantWrite(identity) {
        const typeAction = this.type === ReportGroupType.CODE_COVERAGE ? "codebuild:BatchPutCodeCoverages" : "codebuild:BatchPutTestCases", ret = iam.Grant.addToPrincipal({ grantee: identity, actions: ["codebuild:CreateReport", "codebuild:UpdateReport", typeAction], resourceArns: [this.reportGroupArn] });
        return this.exportBucket && this.exportBucket.grantWrite(identity), ret;
      }
    };
    var ReportGroupType;
    (function(ReportGroupType2) {
      ReportGroupType2.TEST = "TEST", ReportGroupType2.CODE_COVERAGE = "CODE_COVERAGE";
    })(ReportGroupType = exports2.ReportGroupType || (exports2.ReportGroupType = {}));
    var ReportGroup = class _ReportGroup extends ReportGroupBase {
      static fromReportGroupName(scope, id, reportGroupName) {
        class Import extends ReportGroupBase {
          constructor() {
            super(...arguments), this.reportGroupName = reportGroupName, this.reportGroupArn = (0, report_group_utils_1.renderReportGroupArn)(scope, reportGroupName), this.exportBucket = void 0, this.type = void 0;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.reportGroupName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_ReportGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ReportGroup), error;
        }
        this.type = props.type ? props.type : ReportGroupType.TEST;
        const resource = new codebuild_generated_1.CfnReportGroup(this, "Resource", { type: this.type, exportConfig: { exportConfigType: props.exportBucket ? "S3" : "NO_EXPORT", s3Destination: props.exportBucket ? { bucket: props.exportBucket.bucketName, encryptionDisabled: props.exportBucket.encryptionKey ? false : void 0, encryptionKey: props.exportBucket.encryptionKey?.keyArn, packaging: props.zipExport ? "ZIP" : void 0 } : void 0 }, name: props.reportGroupName });
        resource.applyRemovalPolicy(props.removalPolicy, { default: cdk.RemovalPolicy.RETAIN }), this.reportGroupArn = this.getResourceArnAttribute(resource.attrArn, (0, report_group_utils_1.reportGroupArnComponents)(this.physicalName)), this.reportGroupName = this.getResourceNameAttribute(cdk.Fn.select(1, cdk.Fn.split("/", resource.ref))), this.exportBucket = props.exportBucket;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ReportGroup[_a] = { fqn: "aws-cdk-lib.aws_codebuild.ReportGroup", version: "2.80.0" }, exports2.ReportGroup = ReportGroup;
  }
});

// node_modules/aws-cdk-lib/aws-codebuild/lib/source-credentials.js
var require_source_credentials = __commonJS({
  "node_modules/aws-cdk-lib/aws-codebuild/lib/source-credentials.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.BitBucketSourceCredentials = exports2.GitHubEnterpriseSourceCredentials = exports2.GitHubSourceCredentials = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var codebuild_generated_1 = require_codebuild_generated();
    var core_1 = require_core2();
    var GitHubSourceCredentials = class _GitHubSourceCredentials extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_GitHubSourceCredentialsProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _GitHubSourceCredentials), error;
        }
        new codebuild_generated_1.CfnSourceCredential(this, "Resource", { serverType: "GITHUB", authType: "PERSONAL_ACCESS_TOKEN", token: props.accessToken.unsafeUnwrap() });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, GitHubSourceCredentials[_a] = { fqn: "aws-cdk-lib.aws_codebuild.GitHubSourceCredentials", version: "2.80.0" }, exports2.GitHubSourceCredentials = GitHubSourceCredentials;
    var GitHubEnterpriseSourceCredentials = class _GitHubEnterpriseSourceCredentials extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_GitHubEnterpriseSourceCredentialsProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _GitHubEnterpriseSourceCredentials), error;
        }
        new codebuild_generated_1.CfnSourceCredential(this, "Resource", { serverType: "GITHUB_ENTERPRISE", authType: "PERSONAL_ACCESS_TOKEN", token: props.accessToken.unsafeUnwrap() });
      }
    };
    _b = JSII_RTTI_SYMBOL_1, GitHubEnterpriseSourceCredentials[_b] = { fqn: "aws-cdk-lib.aws_codebuild.GitHubEnterpriseSourceCredentials", version: "2.80.0" }, exports2.GitHubEnterpriseSourceCredentials = GitHubEnterpriseSourceCredentials;
    var BitBucketSourceCredentials = class _BitBucketSourceCredentials extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_BitBucketSourceCredentialsProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _BitBucketSourceCredentials), error;
        }
        new codebuild_generated_1.CfnSourceCredential(this, "Resource", { serverType: "BITBUCKET", authType: "BASIC_AUTH", username: props.username.unsafeUnwrap(), token: props.password.unsafeUnwrap() });
      }
    };
    _c = JSII_RTTI_SYMBOL_1, BitBucketSourceCredentials[_c] = { fqn: "aws-cdk-lib.aws_codebuild.BitBucketSourceCredentials", version: "2.80.0" }, exports2.BitBucketSourceCredentials = BitBucketSourceCredentials;
  }
});

// node_modules/aws-cdk-lib/aws-codebuild/lib/file-location.js
var require_file_location = __commonJS({
  "node_modules/aws-cdk-lib/aws-codebuild/lib/file-location.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FileSystemLocation = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var FileSystemLocation = class {
      static efs(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_EfsFileSystemLocationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.efs), error;
        }
        return new EfsFileSystemLocation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, FileSystemLocation[_a] = { fqn: "aws-cdk-lib.aws_codebuild.FileSystemLocation", version: "2.80.0" }, exports2.FileSystemLocation = FileSystemLocation;
    var EfsFileSystemLocation = class {
      constructor(props) {
        this.props = props;
      }
      bind(_scope, _project) {
        return { location: { identifier: this.props.identifier, location: this.props.location, mountOptions: this.props.mountOptions, mountPoint: this.props.mountPoint, type: "EFS" } };
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-codebuild/lib/linux-gpu-build-image.js
var require_linux_gpu_build_image = __commonJS({
  "node_modules/aws-cdk-lib/aws-codebuild/lib/linux-gpu-build-image.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LinuxGpuBuildImage = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var run_script_linux_build_spec_1 = require_run_script_linux_build_spec();
    var project_1 = require_project();
    var ecr = require_aws_ecr();
    var core = require_core2();
    var region_info_1 = require_region_info2();
    var LinuxGpuBuildImage = class _LinuxGpuBuildImage {
      static awsDeepLearningContainersImage(repositoryName, tag, account) {
        return new _LinuxGpuBuildImage(repositoryName, tag, account);
      }
      static fromEcrRepository(repository, tag = "latest") {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecr_IRepository(repository);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromEcrRepository), error;
        }
        return new _LinuxGpuBuildImage(repository.repositoryName, tag, repository.env.account);
      }
      constructor(repositoryName, tag, account) {
        this.repositoryName = repositoryName, this.account = account, this.type = "LINUX_GPU_CONTAINER", this.defaultComputeType = project_1.ComputeType.LARGE, this.imagePullPrincipalType = project_1.ImagePullPrincipalType.SERVICE_ROLE;
        const imageAccount = account ?? core.Lazy.string({ produce: () => {
          if (this._imageAccount === void 0)
            throw new Error("Make sure this 'LinuxGpuBuildImage' is used in a CodeBuild Project construct");
          return this._imageAccount;
        } });
        this.imageId = `${imageAccount}.dkr.ecr.${core.Aws.REGION}.${core.Aws.URL_SUFFIX}/${repositoryName}:${tag}`;
      }
      bind(scope, project, _options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_IProject(project), jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_BuildImageBindOptions(_options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        const account = this.account ?? core.Stack.of(scope).regionalFact(region_info_1.FactName.DLC_REPOSITORY_ACCOUNT);
        return ecr.Repository.fromRepositoryAttributes(scope, "AwsDlcRepositoryCodeBuild", { repositoryName: this.repositoryName, repositoryArn: ecr.Repository.arnForLocalRepository(this.repositoryName, scope, account) }).grantPull(project), this._imageAccount = account, {};
      }
      validate(buildEnvironment) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_BuildEnvironment(buildEnvironment);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.validate), error;
        }
        const ret = [];
        return buildEnvironment.computeType && buildEnvironment.computeType !== project_1.ComputeType.LARGE && ret.push(`GPU images only support ComputeType '${project_1.ComputeType.LARGE}' - '${buildEnvironment.computeType}' was given`), ret;
      }
      runScriptBuildspec(entrypoint) {
        return (0, run_script_linux_build_spec_1.runScriptLinuxBuildSpec)(entrypoint);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LinuxGpuBuildImage[_a] = { fqn: "aws-cdk-lib.aws_codebuild.LinuxGpuBuildImage", version: "2.80.0" }, LinuxGpuBuildImage.DLC_TENSORFLOW_1_14_0 = LinuxGpuBuildImage.awsDeepLearningContainersImage("tensorflow-training", "1.14.0-gpu-py36-cu100-ubuntu16.04"), LinuxGpuBuildImage.DLC_TENSORFLOW_1_15_0 = LinuxGpuBuildImage.awsDeepLearningContainersImage("tensorflow-training", "1.15.0-gpu-py36-cu100-ubuntu18.04"), LinuxGpuBuildImage.DLC_TENSORFLOW_1_15_2_TRAINING = LinuxGpuBuildImage.awsDeepLearningContainersImage("tensorflow-training", "1.15.2-gpu-py37-cu100-ubuntu18.04"), LinuxGpuBuildImage.DLC_TENSORFLOW_1_15_2_INFERENCE = LinuxGpuBuildImage.awsDeepLearningContainersImage("tensorflow-inference", "1.15.2-gpu-py36-cu100-ubuntu18.04"), LinuxGpuBuildImage.DLC_TENSORFLOW_2_0_0 = LinuxGpuBuildImage.awsDeepLearningContainersImage("tensorflow-training", "2.0.0-gpu-py36-cu100-ubuntu18.04"), LinuxGpuBuildImage.DLC_TENSORFLOW_2_0_1 = LinuxGpuBuildImage.awsDeepLearningContainersImage("tensorflow-training", "2.0.1-gpu-py36-cu100-ubuntu18.04"), LinuxGpuBuildImage.DLC_TENSORFLOW_2_1_0_TRAINING = LinuxGpuBuildImage.awsDeepLearningContainersImage("tensorflow-training", "2.1.0-gpu-py36-cu101-ubuntu18.04"), LinuxGpuBuildImage.DLC_TENSORFLOW_2_1_0_INFERENCE = LinuxGpuBuildImage.awsDeepLearningContainersImage("tensorflow-inference", "2.1.0-gpu-py36-cu101-ubuntu18.04"), LinuxGpuBuildImage.DLC_TENSORFLOW_2_2_0_TRAINING = LinuxGpuBuildImage.awsDeepLearningContainersImage("tensorflow-training", "2.2.0-gpu-py37-cu101-ubuntu18.04"), LinuxGpuBuildImage.DLC_PYTORCH_1_2_0 = LinuxGpuBuildImage.awsDeepLearningContainersImage("pytorch-training", "1.2.0-gpu-py36-cu100-ubuntu16.04"), LinuxGpuBuildImage.DLC_PYTORCH_1_3_1 = LinuxGpuBuildImage.awsDeepLearningContainersImage("pytorch-training", "1.3.1-gpu-py36-cu101-ubuntu16.04"), LinuxGpuBuildImage.DLC_PYTORCH_1_4_0_TRAINING = LinuxGpuBuildImage.awsDeepLearningContainersImage("pytorch-training", "1.4.0-gpu-py36-cu101-ubuntu16.04"), LinuxGpuBuildImage.DLC_PYTORCH_1_4_0_INFERENCE = LinuxGpuBuildImage.awsDeepLearningContainersImage("pytorch-inference", "1.4.0-gpu-py36-cu101-ubuntu16.04"), LinuxGpuBuildImage.DLC_PYTORCH_1_5_0_TRAINING = LinuxGpuBuildImage.awsDeepLearningContainersImage("pytorch-training", "1.5.0-gpu-py36-cu101-ubuntu16.04"), LinuxGpuBuildImage.DLC_PYTORCH_1_5_0_INFERENCE = LinuxGpuBuildImage.awsDeepLearningContainersImage("pytorch-inference", "1.5.0-gpu-py36-cu101-ubuntu16.04"), LinuxGpuBuildImage.DLC_MXNET_1_4_1 = LinuxGpuBuildImage.awsDeepLearningContainersImage("mxnet-training", "1.4.1-gpu-py36-cu100-ubuntu16.04"), LinuxGpuBuildImage.DLC_MXNET_1_6_0 = LinuxGpuBuildImage.awsDeepLearningContainersImage("mxnet-training", "1.6.0-gpu-py36-cu101-ubuntu16.04"), exports2.LinuxGpuBuildImage = LinuxGpuBuildImage;
  }
});

// node_modules/aws-cdk-lib/aws-codebuild/lib/untrusted-code-boundary-policy.js
var require_untrusted_code_boundary_policy = __commonJS({
  "node_modules/aws-cdk-lib/aws-codebuild/lib/untrusted-code-boundary-policy.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.UntrustedCodeBoundaryPolicy = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var UntrustedCodeBoundaryPolicy = class _UntrustedCodeBoundaryPolicy extends iam.ManagedPolicy {
      constructor(scope, id, props = {}) {
        super(scope, id, { managedPolicyName: props.managedPolicyName, description: "Permissions Boundary Policy for CodeBuild Projects running untrusted code", statements: [new iam.PolicyStatement({ actions: ["logs:CreateLogGroup", "logs:CreateLogStream", "logs:PutLogEvents", "codebuild:CreateReportGroup", "codebuild:CreateReport", "codebuild:UpdateReport", "codebuild:BatchPutTestCases", "codebuild:BatchPutCodeCoverages", "codebuild:StartBuild", "codebuild:StopBuild", "codebuild:RetryBuild", "ecr:GetDownloadUrlForLayer", "ecr:BatchGetImage", "ecr:BatchCheckLayerAvailability", "ec2:CreateNetworkInterfacePermission", "ec2:CreateNetworkInterface", "ec2:DescribeNetworkInterfaces", "ec2:DeleteNetworkInterface", "ec2:DescribeSubnets", "ec2:DescribeSecurityGroups", "ec2:DescribeDhcpOptions", "ec2:DescribeVpcs"], resources: ["*"] }), ...props.additionalStatements ?? []] });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_UntrustedCodeBoundaryPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _UntrustedCodeBoundaryPolicy), error;
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, UntrustedCodeBoundaryPolicy[_a] = { fqn: "aws-cdk-lib.aws_codebuild.UntrustedCodeBoundaryPolicy", version: "2.80.0" }, exports2.UntrustedCodeBoundaryPolicy = UntrustedCodeBoundaryPolicy;
  }
});

// node_modules/aws-cdk-lib/aws-codebuild/lib/index.js
var require_lib77 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codebuild/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_events(), exports2), __exportStar(require_pipeline_project(), exports2), __exportStar(require_project(), exports2), __exportStar(require_project_logs(), exports2), __exportStar(require_report_group(), exports2), __exportStar(require_source(), exports2), __exportStar(require_source_credentials(), exports2), __exportStar(require_artifacts(), exports2), __exportStar(require_cache2(), exports2), __exportStar(require_build_spec(), exports2), __exportStar(require_file_location(), exports2), __exportStar(require_linux_gpu_build_image(), exports2), __exportStar(require_untrusted_code_boundary_policy(), exports2), __exportStar(require_linux_arm_build_image(), exports2), __exportStar(require_codebuild_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-codebuild/index.js
var require_aws_codebuild = __commonJS({
  "node_modules/aws-cdk-lib/aws-codebuild/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib77(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-codecommit/lib/events.js
var require_events2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codecommit/lib/events.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ReferenceEvent = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var events = require_aws_events();
    var ReferenceEvent = class {
      static get eventType() {
        return events.EventField.fromPath("$.detail.event");
      }
      static get repositoryName() {
        return events.EventField.fromPath("$.detail.repositoryName");
      }
      static get repositoryId() {
        return events.EventField.fromPath("$.detail.repositoryId");
      }
      static get referenceType() {
        return events.EventField.fromPath("$.detail.referenceType");
      }
      static get referenceName() {
        return events.EventField.fromPath("$.detail.referenceName");
      }
      static get referenceFullName() {
        return events.EventField.fromPath("$.detail.referenceFullName");
      }
      static get commitId() {
        return events.EventField.fromPath("$.detail.commitId");
      }
      constructor() {
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ReferenceEvent[_a] = { fqn: "aws-cdk-lib.aws_codecommit.ReferenceEvent", version: "2.80.0" }, exports2.ReferenceEvent = ReferenceEvent;
  }
});

// node_modules/aws-cdk-lib/aws-codecommit/lib/codecommit.generated.js
var require_codecommit_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-codecommit/lib/codecommit.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnRepository = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnRepositoryPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("code", CfnRepository_CodePropertyValidator)(properties.code)), errors.collect(cdk.propertyValidator("repositoryDescription", cdk.validateString)(properties.repositoryDescription)), errors.collect(cdk.propertyValidator("repositoryName", cdk.requiredValidator)(properties.repositoryName)), errors.collect(cdk.propertyValidator("repositoryName", cdk.validateString)(properties.repositoryName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("triggers", cdk.listValidator(CfnRepository_RepositoryTriggerPropertyValidator))(properties.triggers)), errors.wrap('supplied properties not correct for "CfnRepositoryProps"');
    }
    function cfnRepositoryPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRepositoryPropsValidator(properties).assertSuccess(), { RepositoryName: cdk.stringToCloudFormation(properties.repositoryName), Code: cfnRepositoryCodePropertyToCloudFormation(properties.code), RepositoryDescription: cdk.stringToCloudFormation(properties.repositoryDescription), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), Triggers: cdk.listMapper(cfnRepositoryRepositoryTriggerPropertyToCloudFormation)(properties.triggers) }) : properties;
    }
    function CfnRepositoryPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("repositoryName", "RepositoryName", cfn_parse.FromCloudFormation.getString(properties.RepositoryName)), ret.addPropertyResult("code", "Code", properties.Code != null ? CfnRepositoryCodePropertyFromCloudFormation(properties.Code) : void 0), ret.addPropertyResult("repositoryDescription", "RepositoryDescription", properties.RepositoryDescription != null ? cfn_parse.FromCloudFormation.getString(properties.RepositoryDescription) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("triggers", "Triggers", properties.Triggers != null ? cfn_parse.FromCloudFormation.getArray(CfnRepositoryRepositoryTriggerPropertyFromCloudFormation)(properties.Triggers) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRepository = class _CfnRepository extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRepositoryPropsFromCloudFormation(resourceProperties), ret = new _CfnRepository(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRepository.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codecommit_CfnRepositoryProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRepository), error;
        }
        cdk.requireProperty(props, "repositoryName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCloneUrlHttp = cdk.Token.asString(this.getAtt("CloneUrlHttp", cdk.ResolutionTypeHint.STRING)), this.attrCloneUrlSsh = cdk.Token.asString(this.getAtt("CloneUrlSsh", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.repositoryName = props.repositoryName, this.code = props.code, this.repositoryDescription = props.repositoryDescription, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::CodeCommit::Repository", props.tags, { tagPropertyName: "tags" }), this.triggers = props.triggers;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRepository.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { repositoryName: this.repositoryName, code: this.code, repositoryDescription: this.repositoryDescription, tags: this.tags.renderTags(), triggers: this.triggers };
      }
      renderProperties(props) {
        return cfnRepositoryPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnRepository[_a] = { fqn: "aws-cdk-lib.aws_codecommit.CfnRepository", version: "2.80.0" }, CfnRepository.CFN_RESOURCE_TYPE_NAME = "AWS::CodeCommit::Repository", exports2.CfnRepository = CfnRepository;
    function CfnRepository_CodePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("branchName", cdk.validateString)(properties.branchName)), errors.collect(cdk.propertyValidator("s3", cdk.requiredValidator)(properties.s3)), errors.collect(cdk.propertyValidator("s3", CfnRepository_S3PropertyValidator)(properties.s3)), errors.wrap('supplied properties not correct for "CodeProperty"');
    }
    function cfnRepositoryCodePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRepository_CodePropertyValidator(properties).assertSuccess(), { BranchName: cdk.stringToCloudFormation(properties.branchName), S3: cfnRepositoryS3PropertyToCloudFormation(properties.s3) }) : properties;
    }
    function CfnRepositoryCodePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("branchName", "BranchName", properties.BranchName != null ? cfn_parse.FromCloudFormation.getString(properties.BranchName) : void 0), ret.addPropertyResult("s3", "S3", CfnRepositoryS3PropertyFromCloudFormation(properties.S3)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRepository_RepositoryTriggerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("branches", cdk.listValidator(cdk.validateString))(properties.branches)), errors.collect(cdk.propertyValidator("customData", cdk.validateString)(properties.customData)), errors.collect(cdk.propertyValidator("destinationArn", cdk.requiredValidator)(properties.destinationArn)), errors.collect(cdk.propertyValidator("destinationArn", cdk.validateString)(properties.destinationArn)), errors.collect(cdk.propertyValidator("events", cdk.requiredValidator)(properties.events)), errors.collect(cdk.propertyValidator("events", cdk.listValidator(cdk.validateString))(properties.events)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "RepositoryTriggerProperty"');
    }
    function cfnRepositoryRepositoryTriggerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRepository_RepositoryTriggerPropertyValidator(properties).assertSuccess(), { Branches: cdk.listMapper(cdk.stringToCloudFormation)(properties.branches), CustomData: cdk.stringToCloudFormation(properties.customData), DestinationArn: cdk.stringToCloudFormation(properties.destinationArn), Events: cdk.listMapper(cdk.stringToCloudFormation)(properties.events), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnRepositoryRepositoryTriggerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("branches", "Branches", properties.Branches != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Branches) : void 0), ret.addPropertyResult("customData", "CustomData", properties.CustomData != null ? cfn_parse.FromCloudFormation.getString(properties.CustomData) : void 0), ret.addPropertyResult("destinationArn", "DestinationArn", cfn_parse.FromCloudFormation.getString(properties.DestinationArn)), ret.addPropertyResult("events", "Events", cfn_parse.FromCloudFormation.getStringArray(properties.Events)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRepository_S3PropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.requiredValidator)(properties.bucket)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("objectVersion", cdk.validateString)(properties.objectVersion)), errors.wrap('supplied properties not correct for "S3Property"');
    }
    function cfnRepositoryS3PropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRepository_S3PropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), Key: cdk.stringToCloudFormation(properties.key), ObjectVersion: cdk.stringToCloudFormation(properties.objectVersion) }) : properties;
    }
    function CfnRepositoryS3PropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", cfn_parse.FromCloudFormation.getString(properties.Bucket)), ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("objectVersion", "ObjectVersion", properties.ObjectVersion != null ? cfn_parse.FromCloudFormation.getString(properties.ObjectVersion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-codecommit/lib/repository.js
var require_repository2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codecommit/lib/repository.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.RepositoryNotificationEvents = exports2.RepositoryEventTrigger = exports2.Repository = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var codecommit_generated_1 = require_codecommit_generated();
    var notifications = require_aws_codestarnotifications();
    var events = require_aws_events();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var RepositoryBase = class extends core_1.Resource {
      onEvent(id, options = {}) {
        const rule = new events.Rule(this, id, options);
        return rule.addEventPattern({ source: ["aws.codecommit"], resources: [this.repositoryArn] }), rule.addTarget(options.target), rule;
      }
      onStateChange(id, options = {}) {
        const rule = this.onEvent(id, options);
        return rule.addEventPattern({ detailType: ["CodeCommit Repository State Change"] }), rule;
      }
      onReferenceCreated(id, options = {}) {
        const rule = this.onStateChange(id, options);
        return rule.addEventPattern({ detail: { event: ["referenceCreated"] } }), rule;
      }
      onReferenceUpdated(id, options = {}) {
        const rule = this.onStateChange(id, options);
        return rule.addEventPattern({ detail: { event: ["referenceCreated", "referenceUpdated"] } }), rule;
      }
      onReferenceDeleted(id, options = {}) {
        const rule = this.onStateChange(id, options);
        return rule.addEventPattern({ detail: { event: ["referenceDeleted"] } }), rule;
      }
      onPullRequestStateChange(id, options = {}) {
        const rule = this.onEvent(id, options);
        return rule.addEventPattern({ detailType: ["CodeCommit Pull Request State Change"] }), rule;
      }
      onCommentOnPullRequest(id, options = {}) {
        const rule = this.onEvent(id, options);
        return rule.addEventPattern({ detailType: ["CodeCommit Comment on Pull Request"] }), rule;
      }
      onCommentOnCommit(id, options = {}) {
        const rule = this.onEvent(id, options);
        return rule.addEventPattern({ detailType: ["CodeCommit Comment on Commit"] }), rule;
      }
      onCommit(id, options = {}) {
        const rule = this.onReferenceUpdated(id, options);
        return options.branches && rule.addEventPattern({ detail: { referenceName: options.branches } }), rule;
      }
      grant(grantee, ...actions) {
        return iam.Grant.addToPrincipal({ grantee, actions, resourceArns: [this.repositoryArn] });
      }
      grantPull(grantee) {
        return this.grant(grantee, "codecommit:GitPull");
      }
      grantPullPush(grantee) {
        return this.grantPull(grantee), this.grant(grantee, "codecommit:GitPush");
      }
      grantRead(grantee) {
        return this.grantPull(grantee), this.grant(grantee, "codecommit:EvaluatePullRequestApprovalRules", "codecommit:Get*", "codecommit:Describe*");
      }
      notifyOn(id, target, options) {
        return new notifications.NotificationRule(this, id, { ...options, source: this, targets: [target] });
      }
      notifyOnPullRequestComment(id, target, options) {
        return this.notifyOn(id, target, { ...options, events: [RepositoryNotificationEvents.PULL_REQUEST_COMMENT] });
      }
      notifyOnApprovalStatusChanged(id, target, options) {
        return this.notifyOn(id, target, { ...options, events: [RepositoryNotificationEvents.APPROVAL_STATUS_CHANGED] });
      }
      notifyOnApprovalRuleOverridden(id, target, options) {
        return this.notifyOn(id, target, { ...options, events: [RepositoryNotificationEvents.APPROVAL_RULE_OVERRIDDEN] });
      }
      notifyOnPullRequestCreated(id, target, options) {
        return this.notifyOn(id, target, { ...options, events: [RepositoryNotificationEvents.PULL_REQUEST_CREATED] });
      }
      notifiyOnPullRequestMerged(id, target, options) {
        return this.notifyOnPullRequestMerged(id, target, options);
      }
      notifyOnPullRequestMerged(id, target, options) {
        return this.notifyOn(id, target, { ...options, events: [RepositoryNotificationEvents.PULL_REQUEST_MERGED] });
      }
      notifyOnBranchOrTagCreated(id, target, options) {
        return this.notifyOn(id, target, { ...options, events: [RepositoryNotificationEvents.BRANCH_OR_TAG_CREATED] });
      }
      notifyOnBranchOrTagDeleted(id, target, options) {
        return this.notifyOn(id, target, { ...options, events: [RepositoryNotificationEvents.BRANCH_OR_TAG_DELETED] });
      }
      bindAsNotificationRuleSource(_scope) {
        return { sourceArn: this.repositoryArn };
      }
    };
    var Repository = class _Repository extends RepositoryBase {
      static fromRepositoryArn(scope, id, repositoryArn) {
        const stack = core_1.Stack.of(scope), arn = stack.splitArn(repositoryArn, core_1.ArnFormat.NO_RESOURCE_NAME), repositoryName = arn.resource, region = arn.region;
        class Import extends RepositoryBase {
          constructor() {
            super(...arguments), this.repositoryArn = repositoryArn, this.repositoryName = repositoryName, this.repositoryCloneUrlHttp = makeCloneUrl(stack, repositoryName, "https", region), this.repositoryCloneUrlSsh = makeCloneUrl(stack, repositoryName, "ssh", region), this.repositoryCloneUrlGrc = makeCloneUrl(stack, repositoryName, "grc", region);
          }
        }
        return new Import(scope, id, { account: arn.account, region });
      }
      static fromRepositoryName(scope, id, repositoryName) {
        const stack = core_1.Stack.of(scope);
        class Import extends RepositoryBase {
          constructor() {
            super(...arguments), this.repositoryName = repositoryName, this.repositoryArn = core_1.Stack.of(scope).formatArn({ service: "codecommit", resource: repositoryName }), this.repositoryCloneUrlHttp = makeCloneUrl(stack, repositoryName, "https"), this.repositoryCloneUrlSsh = makeCloneUrl(stack, repositoryName, "ssh"), this.repositoryCloneUrlGrc = makeCloneUrl(stack, repositoryName, "grc");
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.repositoryName }), this.triggers = new Array();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codecommit_RepositoryProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Repository), error;
        }
        const repository = new codecommit_generated_1.CfnRepository(this, "Resource", { repositoryName: props.repositoryName, repositoryDescription: props.description, triggers: core_1.Lazy.any({ produce: () => this.triggers }, { omitEmptyArray: true }), code: props.code?.bind(this)?.code });
        this.repositoryName = this.getResourceNameAttribute(repository.attrName), this.repositoryArn = this.getResourceArnAttribute(repository.attrArn, { service: "codecommit", resource: this.physicalName }), this.repositoryCloneUrlHttp = repository.attrCloneUrlHttp, this.repositoryCloneUrlSsh = repository.attrCloneUrlSsh, this.repositoryCloneUrlGrc = makeCloneUrl(core_1.Stack.of(this), this.repositoryName, "grc");
      }
      notify(arn, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codecommit_RepositoryTriggerOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.notify), error;
        }
        let evt = options && options.events;
        evt && evt.length > 1 && evt.indexOf(RepositoryEventTrigger.ALL) > -1 && (evt = [RepositoryEventTrigger.ALL]);
        const customData = options && options.customData, branches = options && options.branches;
        let name = options && options.name;
        if (name || (name = this.node.path + "/" + arn), this.triggers.find((prop) => prop.name === name))
          throw new Error(`Unable to set repository trigger named ${name} because trigger names must be unique`);
        return this.triggers.push({ destinationArn: arn, name, customData, branches, events: evt || [RepositoryEventTrigger.ALL] }), this;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Repository[_a] = { fqn: "aws-cdk-lib.aws_codecommit.Repository", version: "2.80.0" }, exports2.Repository = Repository;
    var RepositoryEventTrigger;
    (function(RepositoryEventTrigger2) {
      RepositoryEventTrigger2.ALL = "all", RepositoryEventTrigger2.UPDATE_REF = "updateReference", RepositoryEventTrigger2.CREATE_REF = "createReference", RepositoryEventTrigger2.DELETE_REF = "deleteReference";
    })(RepositoryEventTrigger = exports2.RepositoryEventTrigger || (exports2.RepositoryEventTrigger = {}));
    function makeCloneUrl(stack, repositoryName, protocol, region) {
      switch (protocol) {
        case "https":
        case "ssh":
          return `${protocol}://git-codecommit.${region ?? stack.region}.${stack.urlSuffix}/v1/repos/${repositoryName}`;
        case "grc":
          return `codecommit::${region ?? stack.region}://${repositoryName}`;
      }
    }
    var RepositoryNotificationEvents;
    (function(RepositoryNotificationEvents2) {
      RepositoryNotificationEvents2.COMMIT_COMMENT = "codecommit-repository-comments-on-commits", RepositoryNotificationEvents2.PULL_REQUEST_COMMENT = "codecommit-repository-comments-on-pull-requests", RepositoryNotificationEvents2.APPROVAL_STATUS_CHANGED = "codecommit-repository-approvals-status-changed", RepositoryNotificationEvents2.APPROVAL_RULE_OVERRIDDEN = "codecommit-repository-approvals-rule-override", RepositoryNotificationEvents2.PULL_REQUEST_CREATED = "codecommit-repository-pull-request-created", RepositoryNotificationEvents2.PULL_REQUEST_SOURCE_UPDATED = "codecommit-repository-pull-request-source-updated", RepositoryNotificationEvents2.PULL_REQUEST_STATUS_CHANGED = "codecommit-repository-pull-request-status-changed", RepositoryNotificationEvents2.PULL_REQUEST_MERGED = "codecommit-repository-pull-request-merged", RepositoryNotificationEvents2.BRANCH_OR_TAG_CREATED = "codecommit-repository-branches-and-tags-created", RepositoryNotificationEvents2.BRANCH_OR_TAG_DELETED = "codecommit-repository-branches-and-tags-deleted", RepositoryNotificationEvents2.BRANCH_OR_TAG_UPDATED = "codecommit-repository-branches-and-tags-updated";
    })(RepositoryNotificationEvents = exports2.RepositoryNotificationEvents || (exports2.RepositoryNotificationEvents = {}));
  }
});

// node_modules/aws-cdk-lib/aws-codecommit/lib/code.js
var require_code3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codecommit/lib/code.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Code = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var fs = require("fs");
    var path = require("path");
    var assets = require_aws_s3_assets();
    var Code2 = class {
      static fromDirectory(directoryPath, branch) {
        const resolvedPath = path.resolve(directoryPath), statResult = fs.statSync(resolvedPath);
        if (!statResult || !statResult.isDirectory())
          throw new Error(`'${directoryPath}' needs to be a path to a directory (resolved to: '${resolvedPath}')`);
        return new PathResolvedCode(resolvedPath, branch);
      }
      static fromZipFile(filePath, branch) {
        const resolvedPath = path.resolve(filePath), statResult = fs.statSync(resolvedPath);
        if (!statResult || !statResult.isFile())
          throw new Error(`'${filePath}' needs to be a path to a ZIP file (resolved to: '${resolvedPath}')`);
        return new PathResolvedCode(resolvedPath, branch);
      }
      static fromAsset(asset, branch) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_assets_Asset(asset);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromAsset), error;
        }
        return new AssetCode(asset, branch);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Code2[_a] = { fqn: "aws-cdk-lib.aws_codecommit.Code", version: "2.80.0" }, exports2.Code = Code2;
    var PathResolvedCode = class extends Code2 {
      constructor(resolvedPath, branch) {
        super(), this.resolvedPath = resolvedPath, this.branch = branch;
      }
      bind(scope) {
        const asset = new assets.Asset(scope, "PathResolvedCodeAsset", { path: this.resolvedPath });
        return new AssetCode(asset, this.branch).bind(scope);
      }
    };
    var AssetCode = class extends Code2 {
      constructor(asset, branch) {
        super(), this.asset = asset, this.branch = branch;
      }
      bind(_scope) {
        if (!this.asset.isZipArchive)
          throw new Error("Asset must be a .zip file or a directory (resolved to: " + this.asset.assetPath + " )");
        return { code: { branchName: this.branch, s3: { bucket: this.asset.s3BucketName, key: this.asset.s3ObjectKey } } };
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-codecommit/lib/index.js
var require_lib78 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codecommit/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_events2(), exports2), __exportStar(require_repository2(), exports2), __exportStar(require_code3(), exports2), __exportStar(require_codecommit_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-codecommit/index.js
var require_aws_codecommit = __commonJS({
  "node_modules/aws-cdk-lib/aws-codecommit/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib78(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-codedeploy/lib/codedeploy.generated.js
var require_codedeploy_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-codedeploy/lib/codedeploy.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnDeploymentGroup = exports2.CfnDeploymentConfig = exports2.CfnApplication = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnApplicationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationName", cdk.validateString)(properties.applicationName)), errors.collect(cdk.propertyValidator("computePlatform", cdk.validateString)(properties.computePlatform)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnApplicationProps"');
    }
    function cfnApplicationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationPropsValidator(properties).assertSuccess(), { ApplicationName: cdk.stringToCloudFormation(properties.applicationName), ComputePlatform: cdk.stringToCloudFormation(properties.computePlatform), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnApplicationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationName", "ApplicationName", properties.ApplicationName != null ? cfn_parse.FromCloudFormation.getString(properties.ApplicationName) : void 0), ret.addPropertyResult("computePlatform", "ComputePlatform", properties.ComputePlatform != null ? cfn_parse.FromCloudFormation.getString(properties.ComputePlatform) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApplication = class _CfnApplication extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApplicationPropsFromCloudFormation(resourceProperties), ret = new _CfnApplication(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnApplication.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codedeploy_CfnApplicationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApplication), error;
        }
        this.applicationName = props.applicationName, this.computePlatform = props.computePlatform, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::CodeDeploy::Application", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApplication.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationName: this.applicationName, computePlatform: this.computePlatform, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnApplicationPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnApplication[_a] = { fqn: "aws-cdk-lib.aws_codedeploy.CfnApplication", version: "2.80.0" }, CfnApplication.CFN_RESOURCE_TYPE_NAME = "AWS::CodeDeploy::Application", exports2.CfnApplication = CfnApplication;
    function CfnDeploymentConfigPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computePlatform", cdk.validateString)(properties.computePlatform)), errors.collect(cdk.propertyValidator("deploymentConfigName", cdk.validateString)(properties.deploymentConfigName)), errors.collect(cdk.propertyValidator("minimumHealthyHosts", CfnDeploymentConfig_MinimumHealthyHostsPropertyValidator)(properties.minimumHealthyHosts)), errors.collect(cdk.propertyValidator("trafficRoutingConfig", CfnDeploymentConfig_TrafficRoutingConfigPropertyValidator)(properties.trafficRoutingConfig)), errors.wrap('supplied properties not correct for "CfnDeploymentConfigProps"');
    }
    function cfnDeploymentConfigPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentConfigPropsValidator(properties).assertSuccess(), { ComputePlatform: cdk.stringToCloudFormation(properties.computePlatform), DeploymentConfigName: cdk.stringToCloudFormation(properties.deploymentConfigName), MinimumHealthyHosts: cfnDeploymentConfigMinimumHealthyHostsPropertyToCloudFormation(properties.minimumHealthyHosts), TrafficRoutingConfig: cfnDeploymentConfigTrafficRoutingConfigPropertyToCloudFormation(properties.trafficRoutingConfig) }) : properties;
    }
    function CfnDeploymentConfigPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computePlatform", "ComputePlatform", properties.ComputePlatform != null ? cfn_parse.FromCloudFormation.getString(properties.ComputePlatform) : void 0), ret.addPropertyResult("deploymentConfigName", "DeploymentConfigName", properties.DeploymentConfigName != null ? cfn_parse.FromCloudFormation.getString(properties.DeploymentConfigName) : void 0), ret.addPropertyResult("minimumHealthyHosts", "MinimumHealthyHosts", properties.MinimumHealthyHosts != null ? CfnDeploymentConfigMinimumHealthyHostsPropertyFromCloudFormation(properties.MinimumHealthyHosts) : void 0), ret.addPropertyResult("trafficRoutingConfig", "TrafficRoutingConfig", properties.TrafficRoutingConfig != null ? CfnDeploymentConfigTrafficRoutingConfigPropertyFromCloudFormation(properties.TrafficRoutingConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDeploymentConfig = class _CfnDeploymentConfig extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDeploymentConfigPropsFromCloudFormation(resourceProperties), ret = new _CfnDeploymentConfig(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnDeploymentConfig.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codedeploy_CfnDeploymentConfigProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDeploymentConfig), error;
        }
        this.computePlatform = props.computePlatform, this.deploymentConfigName = props.deploymentConfigName, this.minimumHealthyHosts = props.minimumHealthyHosts, this.trafficRoutingConfig = props.trafficRoutingConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDeploymentConfig.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { computePlatform: this.computePlatform, deploymentConfigName: this.deploymentConfigName, minimumHealthyHosts: this.minimumHealthyHosts, trafficRoutingConfig: this.trafficRoutingConfig };
      }
      renderProperties(props) {
        return cfnDeploymentConfigPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnDeploymentConfig[_b] = { fqn: "aws-cdk-lib.aws_codedeploy.CfnDeploymentConfig", version: "2.80.0" }, CfnDeploymentConfig.CFN_RESOURCE_TYPE_NAME = "AWS::CodeDeploy::DeploymentConfig", exports2.CfnDeploymentConfig = CfnDeploymentConfig;
    function CfnDeploymentConfig_MinimumHealthyHostsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "MinimumHealthyHostsProperty"');
    }
    function cfnDeploymentConfigMinimumHealthyHostsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentConfig_MinimumHealthyHostsPropertyValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type), Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnDeploymentConfigMinimumHealthyHostsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getNumber(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentConfig_TimeBasedCanaryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("canaryInterval", cdk.requiredValidator)(properties.canaryInterval)), errors.collect(cdk.propertyValidator("canaryInterval", cdk.validateNumber)(properties.canaryInterval)), errors.collect(cdk.propertyValidator("canaryPercentage", cdk.requiredValidator)(properties.canaryPercentage)), errors.collect(cdk.propertyValidator("canaryPercentage", cdk.validateNumber)(properties.canaryPercentage)), errors.wrap('supplied properties not correct for "TimeBasedCanaryProperty"');
    }
    function cfnDeploymentConfigTimeBasedCanaryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentConfig_TimeBasedCanaryPropertyValidator(properties).assertSuccess(), { CanaryInterval: cdk.numberToCloudFormation(properties.canaryInterval), CanaryPercentage: cdk.numberToCloudFormation(properties.canaryPercentage) }) : properties;
    }
    function CfnDeploymentConfigTimeBasedCanaryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("canaryInterval", "CanaryInterval", cfn_parse.FromCloudFormation.getNumber(properties.CanaryInterval)), ret.addPropertyResult("canaryPercentage", "CanaryPercentage", cfn_parse.FromCloudFormation.getNumber(properties.CanaryPercentage)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentConfig_TimeBasedLinearPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("linearInterval", cdk.requiredValidator)(properties.linearInterval)), errors.collect(cdk.propertyValidator("linearInterval", cdk.validateNumber)(properties.linearInterval)), errors.collect(cdk.propertyValidator("linearPercentage", cdk.requiredValidator)(properties.linearPercentage)), errors.collect(cdk.propertyValidator("linearPercentage", cdk.validateNumber)(properties.linearPercentage)), errors.wrap('supplied properties not correct for "TimeBasedLinearProperty"');
    }
    function cfnDeploymentConfigTimeBasedLinearPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentConfig_TimeBasedLinearPropertyValidator(properties).assertSuccess(), { LinearInterval: cdk.numberToCloudFormation(properties.linearInterval), LinearPercentage: cdk.numberToCloudFormation(properties.linearPercentage) }) : properties;
    }
    function CfnDeploymentConfigTimeBasedLinearPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("linearInterval", "LinearInterval", cfn_parse.FromCloudFormation.getNumber(properties.LinearInterval)), ret.addPropertyResult("linearPercentage", "LinearPercentage", cfn_parse.FromCloudFormation.getNumber(properties.LinearPercentage)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentConfig_TrafficRoutingConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("timeBasedCanary", CfnDeploymentConfig_TimeBasedCanaryPropertyValidator)(properties.timeBasedCanary)), errors.collect(cdk.propertyValidator("timeBasedLinear", CfnDeploymentConfig_TimeBasedLinearPropertyValidator)(properties.timeBasedLinear)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "TrafficRoutingConfigProperty"');
    }
    function cfnDeploymentConfigTrafficRoutingConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentConfig_TrafficRoutingConfigPropertyValidator(properties).assertSuccess(), { TimeBasedCanary: cfnDeploymentConfigTimeBasedCanaryPropertyToCloudFormation(properties.timeBasedCanary), TimeBasedLinear: cfnDeploymentConfigTimeBasedLinearPropertyToCloudFormation(properties.timeBasedLinear), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnDeploymentConfigTrafficRoutingConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("timeBasedCanary", "TimeBasedCanary", properties.TimeBasedCanary != null ? CfnDeploymentConfigTimeBasedCanaryPropertyFromCloudFormation(properties.TimeBasedCanary) : void 0), ret.addPropertyResult("timeBasedLinear", "TimeBasedLinear", properties.TimeBasedLinear != null ? CfnDeploymentConfigTimeBasedLinearPropertyFromCloudFormation(properties.TimeBasedLinear) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alarmConfiguration", CfnDeploymentGroup_AlarmConfigurationPropertyValidator)(properties.alarmConfiguration)), errors.collect(cdk.propertyValidator("applicationName", cdk.requiredValidator)(properties.applicationName)), errors.collect(cdk.propertyValidator("applicationName", cdk.validateString)(properties.applicationName)), errors.collect(cdk.propertyValidator("autoRollbackConfiguration", CfnDeploymentGroup_AutoRollbackConfigurationPropertyValidator)(properties.autoRollbackConfiguration)), errors.collect(cdk.propertyValidator("autoScalingGroups", cdk.listValidator(cdk.validateString))(properties.autoScalingGroups)), errors.collect(cdk.propertyValidator("blueGreenDeploymentConfiguration", CfnDeploymentGroup_BlueGreenDeploymentConfigurationPropertyValidator)(properties.blueGreenDeploymentConfiguration)), errors.collect(cdk.propertyValidator("deployment", CfnDeploymentGroup_DeploymentPropertyValidator)(properties.deployment)), errors.collect(cdk.propertyValidator("deploymentConfigName", cdk.validateString)(properties.deploymentConfigName)), errors.collect(cdk.propertyValidator("deploymentGroupName", cdk.validateString)(properties.deploymentGroupName)), errors.collect(cdk.propertyValidator("deploymentStyle", CfnDeploymentGroup_DeploymentStylePropertyValidator)(properties.deploymentStyle)), errors.collect(cdk.propertyValidator("ecsServices", cdk.listValidator(CfnDeploymentGroup_ECSServicePropertyValidator))(properties.ecsServices)), errors.collect(cdk.propertyValidator("ec2TagFilters", cdk.listValidator(CfnDeploymentGroup_EC2TagFilterPropertyValidator))(properties.ec2TagFilters)), errors.collect(cdk.propertyValidator("ec2TagSet", CfnDeploymentGroup_EC2TagSetPropertyValidator)(properties.ec2TagSet)), errors.collect(cdk.propertyValidator("loadBalancerInfo", CfnDeploymentGroup_LoadBalancerInfoPropertyValidator)(properties.loadBalancerInfo)), errors.collect(cdk.propertyValidator("onPremisesInstanceTagFilters", cdk.listValidator(CfnDeploymentGroup_TagFilterPropertyValidator))(properties.onPremisesInstanceTagFilters)), errors.collect(cdk.propertyValidator("onPremisesTagSet", CfnDeploymentGroup_OnPremisesTagSetPropertyValidator)(properties.onPremisesTagSet)), errors.collect(cdk.propertyValidator("outdatedInstancesStrategy", cdk.validateString)(properties.outdatedInstancesStrategy)), errors.collect(cdk.propertyValidator("serviceRoleArn", cdk.requiredValidator)(properties.serviceRoleArn)), errors.collect(cdk.propertyValidator("serviceRoleArn", cdk.validateString)(properties.serviceRoleArn)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("triggerConfigurations", cdk.listValidator(CfnDeploymentGroup_TriggerConfigPropertyValidator))(properties.triggerConfigurations)), errors.wrap('supplied properties not correct for "CfnDeploymentGroupProps"');
    }
    function cfnDeploymentGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentGroupPropsValidator(properties).assertSuccess(), { ApplicationName: cdk.stringToCloudFormation(properties.applicationName), ServiceRoleArn: cdk.stringToCloudFormation(properties.serviceRoleArn), AlarmConfiguration: cfnDeploymentGroupAlarmConfigurationPropertyToCloudFormation(properties.alarmConfiguration), AutoRollbackConfiguration: cfnDeploymentGroupAutoRollbackConfigurationPropertyToCloudFormation(properties.autoRollbackConfiguration), AutoScalingGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.autoScalingGroups), BlueGreenDeploymentConfiguration: cfnDeploymentGroupBlueGreenDeploymentConfigurationPropertyToCloudFormation(properties.blueGreenDeploymentConfiguration), Deployment: cfnDeploymentGroupDeploymentPropertyToCloudFormation(properties.deployment), DeploymentConfigName: cdk.stringToCloudFormation(properties.deploymentConfigName), DeploymentGroupName: cdk.stringToCloudFormation(properties.deploymentGroupName), DeploymentStyle: cfnDeploymentGroupDeploymentStylePropertyToCloudFormation(properties.deploymentStyle), Ec2TagFilters: cdk.listMapper(cfnDeploymentGroupEC2TagFilterPropertyToCloudFormation)(properties.ec2TagFilters), Ec2TagSet: cfnDeploymentGroupEC2TagSetPropertyToCloudFormation(properties.ec2TagSet), ECSServices: cdk.listMapper(cfnDeploymentGroupECSServicePropertyToCloudFormation)(properties.ecsServices), LoadBalancerInfo: cfnDeploymentGroupLoadBalancerInfoPropertyToCloudFormation(properties.loadBalancerInfo), OnPremisesInstanceTagFilters: cdk.listMapper(cfnDeploymentGroupTagFilterPropertyToCloudFormation)(properties.onPremisesInstanceTagFilters), OnPremisesTagSet: cfnDeploymentGroupOnPremisesTagSetPropertyToCloudFormation(properties.onPremisesTagSet), OutdatedInstancesStrategy: cdk.stringToCloudFormation(properties.outdatedInstancesStrategy), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TriggerConfigurations: cdk.listMapper(cfnDeploymentGroupTriggerConfigPropertyToCloudFormation)(properties.triggerConfigurations) }) : properties;
    }
    function CfnDeploymentGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationName", "ApplicationName", cfn_parse.FromCloudFormation.getString(properties.ApplicationName)), ret.addPropertyResult("serviceRoleArn", "ServiceRoleArn", cfn_parse.FromCloudFormation.getString(properties.ServiceRoleArn)), ret.addPropertyResult("alarmConfiguration", "AlarmConfiguration", properties.AlarmConfiguration != null ? CfnDeploymentGroupAlarmConfigurationPropertyFromCloudFormation(properties.AlarmConfiguration) : void 0), ret.addPropertyResult("autoRollbackConfiguration", "AutoRollbackConfiguration", properties.AutoRollbackConfiguration != null ? CfnDeploymentGroupAutoRollbackConfigurationPropertyFromCloudFormation(properties.AutoRollbackConfiguration) : void 0), ret.addPropertyResult("autoScalingGroups", "AutoScalingGroups", properties.AutoScalingGroups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AutoScalingGroups) : void 0), ret.addPropertyResult("blueGreenDeploymentConfiguration", "BlueGreenDeploymentConfiguration", properties.BlueGreenDeploymentConfiguration != null ? CfnDeploymentGroupBlueGreenDeploymentConfigurationPropertyFromCloudFormation(properties.BlueGreenDeploymentConfiguration) : void 0), ret.addPropertyResult("deployment", "Deployment", properties.Deployment != null ? CfnDeploymentGroupDeploymentPropertyFromCloudFormation(properties.Deployment) : void 0), ret.addPropertyResult("deploymentConfigName", "DeploymentConfigName", properties.DeploymentConfigName != null ? cfn_parse.FromCloudFormation.getString(properties.DeploymentConfigName) : void 0), ret.addPropertyResult("deploymentGroupName", "DeploymentGroupName", properties.DeploymentGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.DeploymentGroupName) : void 0), ret.addPropertyResult("deploymentStyle", "DeploymentStyle", properties.DeploymentStyle != null ? CfnDeploymentGroupDeploymentStylePropertyFromCloudFormation(properties.DeploymentStyle) : void 0), ret.addPropertyResult("ec2TagFilters", "Ec2TagFilters", properties.Ec2TagFilters != null ? cfn_parse.FromCloudFormation.getArray(CfnDeploymentGroupEC2TagFilterPropertyFromCloudFormation)(properties.Ec2TagFilters) : void 0), ret.addPropertyResult("ec2TagSet", "Ec2TagSet", properties.Ec2TagSet != null ? CfnDeploymentGroupEC2TagSetPropertyFromCloudFormation(properties.Ec2TagSet) : void 0), ret.addPropertyResult("ecsServices", "ECSServices", properties.ECSServices != null ? cfn_parse.FromCloudFormation.getArray(CfnDeploymentGroupECSServicePropertyFromCloudFormation)(properties.ECSServices) : void 0), ret.addPropertyResult("loadBalancerInfo", "LoadBalancerInfo", properties.LoadBalancerInfo != null ? CfnDeploymentGroupLoadBalancerInfoPropertyFromCloudFormation(properties.LoadBalancerInfo) : void 0), ret.addPropertyResult("onPremisesInstanceTagFilters", "OnPremisesInstanceTagFilters", properties.OnPremisesInstanceTagFilters != null ? cfn_parse.FromCloudFormation.getArray(CfnDeploymentGroupTagFilterPropertyFromCloudFormation)(properties.OnPremisesInstanceTagFilters) : void 0), ret.addPropertyResult("onPremisesTagSet", "OnPremisesTagSet", properties.OnPremisesTagSet != null ? CfnDeploymentGroupOnPremisesTagSetPropertyFromCloudFormation(properties.OnPremisesTagSet) : void 0), ret.addPropertyResult("outdatedInstancesStrategy", "OutdatedInstancesStrategy", properties.OutdatedInstancesStrategy != null ? cfn_parse.FromCloudFormation.getString(properties.OutdatedInstancesStrategy) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("triggerConfigurations", "TriggerConfigurations", properties.TriggerConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnDeploymentGroupTriggerConfigPropertyFromCloudFormation)(properties.TriggerConfigurations) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDeploymentGroup = class _CfnDeploymentGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDeploymentGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnDeploymentGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDeploymentGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codedeploy_CfnDeploymentGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDeploymentGroup), error;
        }
        cdk.requireProperty(props, "applicationName", this), cdk.requireProperty(props, "serviceRoleArn", this), this.applicationName = props.applicationName, this.serviceRoleArn = props.serviceRoleArn, this.alarmConfiguration = props.alarmConfiguration, this.autoRollbackConfiguration = props.autoRollbackConfiguration, this.autoScalingGroups = props.autoScalingGroups, this.blueGreenDeploymentConfiguration = props.blueGreenDeploymentConfiguration, this.deployment = props.deployment, this.deploymentConfigName = props.deploymentConfigName, this.deploymentGroupName = props.deploymentGroupName, this.deploymentStyle = props.deploymentStyle, this.ec2TagFilters = props.ec2TagFilters, this.ec2TagSet = props.ec2TagSet, this.ecsServices = props.ecsServices, this.loadBalancerInfo = props.loadBalancerInfo, this.onPremisesInstanceTagFilters = props.onPremisesInstanceTagFilters, this.onPremisesTagSet = props.onPremisesTagSet, this.outdatedInstancesStrategy = props.outdatedInstancesStrategy, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::CodeDeploy::DeploymentGroup", props.tags, { tagPropertyName: "tags" }), this.triggerConfigurations = props.triggerConfigurations;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDeploymentGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationName: this.applicationName, serviceRoleArn: this.serviceRoleArn, alarmConfiguration: this.alarmConfiguration, autoRollbackConfiguration: this.autoRollbackConfiguration, autoScalingGroups: this.autoScalingGroups, blueGreenDeploymentConfiguration: this.blueGreenDeploymentConfiguration, deployment: this.deployment, deploymentConfigName: this.deploymentConfigName, deploymentGroupName: this.deploymentGroupName, deploymentStyle: this.deploymentStyle, ec2TagFilters: this.ec2TagFilters, ec2TagSet: this.ec2TagSet, ecsServices: this.ecsServices, loadBalancerInfo: this.loadBalancerInfo, onPremisesInstanceTagFilters: this.onPremisesInstanceTagFilters, onPremisesTagSet: this.onPremisesTagSet, outdatedInstancesStrategy: this.outdatedInstancesStrategy, tags: this.tags.renderTags(), triggerConfigurations: this.triggerConfigurations };
      }
      renderProperties(props) {
        return cfnDeploymentGroupPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnDeploymentGroup[_c] = { fqn: "aws-cdk-lib.aws_codedeploy.CfnDeploymentGroup", version: "2.80.0" }, CfnDeploymentGroup.CFN_RESOURCE_TYPE_NAME = "AWS::CodeDeploy::DeploymentGroup", exports2.CfnDeploymentGroup = CfnDeploymentGroup;
    function CfnDeploymentGroup_AlarmPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "AlarmProperty"');
    }
    function cfnDeploymentGroupAlarmPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentGroup_AlarmPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnDeploymentGroupAlarmPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentGroup_AlarmConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alarms", cdk.listValidator(CfnDeploymentGroup_AlarmPropertyValidator))(properties.alarms)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("ignorePollAlarmFailure", cdk.validateBoolean)(properties.ignorePollAlarmFailure)), errors.wrap('supplied properties not correct for "AlarmConfigurationProperty"');
    }
    function cfnDeploymentGroupAlarmConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentGroup_AlarmConfigurationPropertyValidator(properties).assertSuccess(), { Alarms: cdk.listMapper(cfnDeploymentGroupAlarmPropertyToCloudFormation)(properties.alarms), Enabled: cdk.booleanToCloudFormation(properties.enabled), IgnorePollAlarmFailure: cdk.booleanToCloudFormation(properties.ignorePollAlarmFailure) }) : properties;
    }
    function CfnDeploymentGroupAlarmConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alarms", "Alarms", properties.Alarms != null ? cfn_parse.FromCloudFormation.getArray(CfnDeploymentGroupAlarmPropertyFromCloudFormation)(properties.Alarms) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("ignorePollAlarmFailure", "IgnorePollAlarmFailure", properties.IgnorePollAlarmFailure != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IgnorePollAlarmFailure) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentGroup_AutoRollbackConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("events", cdk.listValidator(cdk.validateString))(properties.events)), errors.wrap('supplied properties not correct for "AutoRollbackConfigurationProperty"');
    }
    function cfnDeploymentGroupAutoRollbackConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentGroup_AutoRollbackConfigurationPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled), Events: cdk.listMapper(cdk.stringToCloudFormation)(properties.events) }) : properties;
    }
    function CfnDeploymentGroupAutoRollbackConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("events", "Events", properties.Events != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Events) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentGroup_BlueGreenDeploymentConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deploymentReadyOption", CfnDeploymentGroup_DeploymentReadyOptionPropertyValidator)(properties.deploymentReadyOption)), errors.collect(cdk.propertyValidator("greenFleetProvisioningOption", CfnDeploymentGroup_GreenFleetProvisioningOptionPropertyValidator)(properties.greenFleetProvisioningOption)), errors.collect(cdk.propertyValidator("terminateBlueInstancesOnDeploymentSuccess", CfnDeploymentGroup_BlueInstanceTerminationOptionPropertyValidator)(properties.terminateBlueInstancesOnDeploymentSuccess)), errors.wrap('supplied properties not correct for "BlueGreenDeploymentConfigurationProperty"');
    }
    function cfnDeploymentGroupBlueGreenDeploymentConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentGroup_BlueGreenDeploymentConfigurationPropertyValidator(properties).assertSuccess(), { DeploymentReadyOption: cfnDeploymentGroupDeploymentReadyOptionPropertyToCloudFormation(properties.deploymentReadyOption), GreenFleetProvisioningOption: cfnDeploymentGroupGreenFleetProvisioningOptionPropertyToCloudFormation(properties.greenFleetProvisioningOption), TerminateBlueInstancesOnDeploymentSuccess: cfnDeploymentGroupBlueInstanceTerminationOptionPropertyToCloudFormation(properties.terminateBlueInstancesOnDeploymentSuccess) }) : properties;
    }
    function CfnDeploymentGroupBlueGreenDeploymentConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deploymentReadyOption", "DeploymentReadyOption", properties.DeploymentReadyOption != null ? CfnDeploymentGroupDeploymentReadyOptionPropertyFromCloudFormation(properties.DeploymentReadyOption) : void 0), ret.addPropertyResult("greenFleetProvisioningOption", "GreenFleetProvisioningOption", properties.GreenFleetProvisioningOption != null ? CfnDeploymentGroupGreenFleetProvisioningOptionPropertyFromCloudFormation(properties.GreenFleetProvisioningOption) : void 0), ret.addPropertyResult("terminateBlueInstancesOnDeploymentSuccess", "TerminateBlueInstancesOnDeploymentSuccess", properties.TerminateBlueInstancesOnDeploymentSuccess != null ? CfnDeploymentGroupBlueInstanceTerminationOptionPropertyFromCloudFormation(properties.TerminateBlueInstancesOnDeploymentSuccess) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentGroup_BlueInstanceTerminationOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.validateString)(properties.action)), errors.collect(cdk.propertyValidator("terminationWaitTimeInMinutes", cdk.validateNumber)(properties.terminationWaitTimeInMinutes)), errors.wrap('supplied properties not correct for "BlueInstanceTerminationOptionProperty"');
    }
    function cfnDeploymentGroupBlueInstanceTerminationOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentGroup_BlueInstanceTerminationOptionPropertyValidator(properties).assertSuccess(), { Action: cdk.stringToCloudFormation(properties.action), TerminationWaitTimeInMinutes: cdk.numberToCloudFormation(properties.terminationWaitTimeInMinutes) }) : properties;
    }
    function CfnDeploymentGroupBlueInstanceTerminationOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", properties.Action != null ? cfn_parse.FromCloudFormation.getString(properties.Action) : void 0), ret.addPropertyResult("terminationWaitTimeInMinutes", "TerminationWaitTimeInMinutes", properties.TerminationWaitTimeInMinutes != null ? cfn_parse.FromCloudFormation.getNumber(properties.TerminationWaitTimeInMinutes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentGroup_DeploymentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("ignoreApplicationStopFailures", cdk.validateBoolean)(properties.ignoreApplicationStopFailures)), errors.collect(cdk.propertyValidator("revision", cdk.requiredValidator)(properties.revision)), errors.collect(cdk.propertyValidator("revision", CfnDeploymentGroup_RevisionLocationPropertyValidator)(properties.revision)), errors.wrap('supplied properties not correct for "DeploymentProperty"');
    }
    function cfnDeploymentGroupDeploymentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentGroup_DeploymentPropertyValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), IgnoreApplicationStopFailures: cdk.booleanToCloudFormation(properties.ignoreApplicationStopFailures), Revision: cfnDeploymentGroupRevisionLocationPropertyToCloudFormation(properties.revision) }) : properties;
    }
    function CfnDeploymentGroupDeploymentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("ignoreApplicationStopFailures", "IgnoreApplicationStopFailures", properties.IgnoreApplicationStopFailures != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IgnoreApplicationStopFailures) : void 0), ret.addPropertyResult("revision", "Revision", CfnDeploymentGroupRevisionLocationPropertyFromCloudFormation(properties.Revision)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentGroup_DeploymentReadyOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actionOnTimeout", cdk.validateString)(properties.actionOnTimeout)), errors.collect(cdk.propertyValidator("waitTimeInMinutes", cdk.validateNumber)(properties.waitTimeInMinutes)), errors.wrap('supplied properties not correct for "DeploymentReadyOptionProperty"');
    }
    function cfnDeploymentGroupDeploymentReadyOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentGroup_DeploymentReadyOptionPropertyValidator(properties).assertSuccess(), { ActionOnTimeout: cdk.stringToCloudFormation(properties.actionOnTimeout), WaitTimeInMinutes: cdk.numberToCloudFormation(properties.waitTimeInMinutes) }) : properties;
    }
    function CfnDeploymentGroupDeploymentReadyOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actionOnTimeout", "ActionOnTimeout", properties.ActionOnTimeout != null ? cfn_parse.FromCloudFormation.getString(properties.ActionOnTimeout) : void 0), ret.addPropertyResult("waitTimeInMinutes", "WaitTimeInMinutes", properties.WaitTimeInMinutes != null ? cfn_parse.FromCloudFormation.getNumber(properties.WaitTimeInMinutes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentGroup_DeploymentStylePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deploymentOption", cdk.validateString)(properties.deploymentOption)), errors.collect(cdk.propertyValidator("deploymentType", cdk.validateString)(properties.deploymentType)), errors.wrap('supplied properties not correct for "DeploymentStyleProperty"');
    }
    function cfnDeploymentGroupDeploymentStylePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentGroup_DeploymentStylePropertyValidator(properties).assertSuccess(), { DeploymentOption: cdk.stringToCloudFormation(properties.deploymentOption), DeploymentType: cdk.stringToCloudFormation(properties.deploymentType) }) : properties;
    }
    function CfnDeploymentGroupDeploymentStylePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deploymentOption", "DeploymentOption", properties.DeploymentOption != null ? cfn_parse.FromCloudFormation.getString(properties.DeploymentOption) : void 0), ret.addPropertyResult("deploymentType", "DeploymentType", properties.DeploymentType != null ? cfn_parse.FromCloudFormation.getString(properties.DeploymentType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentGroup_EC2TagFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "EC2TagFilterProperty"');
    }
    function cfnDeploymentGroupEC2TagFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentGroup_EC2TagFilterPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Type: cdk.stringToCloudFormation(properties.type), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnDeploymentGroupEC2TagFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentGroup_EC2TagSetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ec2TagSetList", cdk.listValidator(CfnDeploymentGroup_EC2TagSetListObjectPropertyValidator))(properties.ec2TagSetList)), errors.wrap('supplied properties not correct for "EC2TagSetProperty"');
    }
    function cfnDeploymentGroupEC2TagSetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentGroup_EC2TagSetPropertyValidator(properties).assertSuccess(), { Ec2TagSetList: cdk.listMapper(cfnDeploymentGroupEC2TagSetListObjectPropertyToCloudFormation)(properties.ec2TagSetList) }) : properties;
    }
    function CfnDeploymentGroupEC2TagSetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ec2TagSetList", "Ec2TagSetList", properties.Ec2TagSetList != null ? cfn_parse.FromCloudFormation.getArray(CfnDeploymentGroupEC2TagSetListObjectPropertyFromCloudFormation)(properties.Ec2TagSetList) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentGroup_EC2TagSetListObjectPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ec2TagGroup", cdk.listValidator(CfnDeploymentGroup_EC2TagFilterPropertyValidator))(properties.ec2TagGroup)), errors.wrap('supplied properties not correct for "EC2TagSetListObjectProperty"');
    }
    function cfnDeploymentGroupEC2TagSetListObjectPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentGroup_EC2TagSetListObjectPropertyValidator(properties).assertSuccess(), { Ec2TagGroup: cdk.listMapper(cfnDeploymentGroupEC2TagFilterPropertyToCloudFormation)(properties.ec2TagGroup) }) : properties;
    }
    function CfnDeploymentGroupEC2TagSetListObjectPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ec2TagGroup", "Ec2TagGroup", properties.Ec2TagGroup != null ? cfn_parse.FromCloudFormation.getArray(CfnDeploymentGroupEC2TagFilterPropertyFromCloudFormation)(properties.Ec2TagGroup) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentGroup_ECSServicePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clusterName", cdk.requiredValidator)(properties.clusterName)), errors.collect(cdk.propertyValidator("clusterName", cdk.validateString)(properties.clusterName)), errors.collect(cdk.propertyValidator("serviceName", cdk.requiredValidator)(properties.serviceName)), errors.collect(cdk.propertyValidator("serviceName", cdk.validateString)(properties.serviceName)), errors.wrap('supplied properties not correct for "ECSServiceProperty"');
    }
    function cfnDeploymentGroupECSServicePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentGroup_ECSServicePropertyValidator(properties).assertSuccess(), { ClusterName: cdk.stringToCloudFormation(properties.clusterName), ServiceName: cdk.stringToCloudFormation(properties.serviceName) }) : properties;
    }
    function CfnDeploymentGroupECSServicePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clusterName", "ClusterName", cfn_parse.FromCloudFormation.getString(properties.ClusterName)), ret.addPropertyResult("serviceName", "ServiceName", cfn_parse.FromCloudFormation.getString(properties.ServiceName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentGroup_ELBInfoPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "ELBInfoProperty"');
    }
    function cfnDeploymentGroupELBInfoPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentGroup_ELBInfoPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnDeploymentGroupELBInfoPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentGroup_GitHubLocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("commitId", cdk.requiredValidator)(properties.commitId)), errors.collect(cdk.propertyValidator("commitId", cdk.validateString)(properties.commitId)), errors.collect(cdk.propertyValidator("repository", cdk.requiredValidator)(properties.repository)), errors.collect(cdk.propertyValidator("repository", cdk.validateString)(properties.repository)), errors.wrap('supplied properties not correct for "GitHubLocationProperty"');
    }
    function cfnDeploymentGroupGitHubLocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentGroup_GitHubLocationPropertyValidator(properties).assertSuccess(), { CommitId: cdk.stringToCloudFormation(properties.commitId), Repository: cdk.stringToCloudFormation(properties.repository) }) : properties;
    }
    function CfnDeploymentGroupGitHubLocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("commitId", "CommitId", cfn_parse.FromCloudFormation.getString(properties.CommitId)), ret.addPropertyResult("repository", "Repository", cfn_parse.FromCloudFormation.getString(properties.Repository)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentGroup_GreenFleetProvisioningOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.validateString)(properties.action)), errors.wrap('supplied properties not correct for "GreenFleetProvisioningOptionProperty"');
    }
    function cfnDeploymentGroupGreenFleetProvisioningOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentGroup_GreenFleetProvisioningOptionPropertyValidator(properties).assertSuccess(), { Action: cdk.stringToCloudFormation(properties.action) }) : properties;
    }
    function CfnDeploymentGroupGreenFleetProvisioningOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", properties.Action != null ? cfn_parse.FromCloudFormation.getString(properties.Action) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentGroup_LoadBalancerInfoPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("elbInfoList", cdk.listValidator(CfnDeploymentGroup_ELBInfoPropertyValidator))(properties.elbInfoList)), errors.collect(cdk.propertyValidator("targetGroupInfoList", cdk.listValidator(CfnDeploymentGroup_TargetGroupInfoPropertyValidator))(properties.targetGroupInfoList)), errors.collect(cdk.propertyValidator("targetGroupPairInfoList", cdk.listValidator(CfnDeploymentGroup_TargetGroupPairInfoPropertyValidator))(properties.targetGroupPairInfoList)), errors.wrap('supplied properties not correct for "LoadBalancerInfoProperty"');
    }
    function cfnDeploymentGroupLoadBalancerInfoPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentGroup_LoadBalancerInfoPropertyValidator(properties).assertSuccess(), { ElbInfoList: cdk.listMapper(cfnDeploymentGroupELBInfoPropertyToCloudFormation)(properties.elbInfoList), TargetGroupInfoList: cdk.listMapper(cfnDeploymentGroupTargetGroupInfoPropertyToCloudFormation)(properties.targetGroupInfoList), TargetGroupPairInfoList: cdk.listMapper(cfnDeploymentGroupTargetGroupPairInfoPropertyToCloudFormation)(properties.targetGroupPairInfoList) }) : properties;
    }
    function CfnDeploymentGroupLoadBalancerInfoPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("elbInfoList", "ElbInfoList", properties.ElbInfoList != null ? cfn_parse.FromCloudFormation.getArray(CfnDeploymentGroupELBInfoPropertyFromCloudFormation)(properties.ElbInfoList) : void 0), ret.addPropertyResult("targetGroupInfoList", "TargetGroupInfoList", properties.TargetGroupInfoList != null ? cfn_parse.FromCloudFormation.getArray(CfnDeploymentGroupTargetGroupInfoPropertyFromCloudFormation)(properties.TargetGroupInfoList) : void 0), ret.addPropertyResult("targetGroupPairInfoList", "TargetGroupPairInfoList", properties.TargetGroupPairInfoList != null ? cfn_parse.FromCloudFormation.getArray(CfnDeploymentGroupTargetGroupPairInfoPropertyFromCloudFormation)(properties.TargetGroupPairInfoList) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentGroup_OnPremisesTagSetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("onPremisesTagSetList", cdk.listValidator(CfnDeploymentGroup_OnPremisesTagSetListObjectPropertyValidator))(properties.onPremisesTagSetList)), errors.wrap('supplied properties not correct for "OnPremisesTagSetProperty"');
    }
    function cfnDeploymentGroupOnPremisesTagSetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentGroup_OnPremisesTagSetPropertyValidator(properties).assertSuccess(), { OnPremisesTagSetList: cdk.listMapper(cfnDeploymentGroupOnPremisesTagSetListObjectPropertyToCloudFormation)(properties.onPremisesTagSetList) }) : properties;
    }
    function CfnDeploymentGroupOnPremisesTagSetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("onPremisesTagSetList", "OnPremisesTagSetList", properties.OnPremisesTagSetList != null ? cfn_parse.FromCloudFormation.getArray(CfnDeploymentGroupOnPremisesTagSetListObjectPropertyFromCloudFormation)(properties.OnPremisesTagSetList) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentGroup_OnPremisesTagSetListObjectPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("onPremisesTagGroup", cdk.listValidator(CfnDeploymentGroup_TagFilterPropertyValidator))(properties.onPremisesTagGroup)), errors.wrap('supplied properties not correct for "OnPremisesTagSetListObjectProperty"');
    }
    function cfnDeploymentGroupOnPremisesTagSetListObjectPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentGroup_OnPremisesTagSetListObjectPropertyValidator(properties).assertSuccess(), { OnPremisesTagGroup: cdk.listMapper(cfnDeploymentGroupTagFilterPropertyToCloudFormation)(properties.onPremisesTagGroup) }) : properties;
    }
    function CfnDeploymentGroupOnPremisesTagSetListObjectPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("onPremisesTagGroup", "OnPremisesTagGroup", properties.OnPremisesTagGroup != null ? cfn_parse.FromCloudFormation.getArray(CfnDeploymentGroupTagFilterPropertyFromCloudFormation)(properties.OnPremisesTagGroup) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentGroup_RevisionLocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("gitHubLocation", CfnDeploymentGroup_GitHubLocationPropertyValidator)(properties.gitHubLocation)), errors.collect(cdk.propertyValidator("revisionType", cdk.validateString)(properties.revisionType)), errors.collect(cdk.propertyValidator("s3Location", CfnDeploymentGroup_S3LocationPropertyValidator)(properties.s3Location)), errors.wrap('supplied properties not correct for "RevisionLocationProperty"');
    }
    function cfnDeploymentGroupRevisionLocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentGroup_RevisionLocationPropertyValidator(properties).assertSuccess(), { GitHubLocation: cfnDeploymentGroupGitHubLocationPropertyToCloudFormation(properties.gitHubLocation), RevisionType: cdk.stringToCloudFormation(properties.revisionType), S3Location: cfnDeploymentGroupS3LocationPropertyToCloudFormation(properties.s3Location) }) : properties;
    }
    function CfnDeploymentGroupRevisionLocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("gitHubLocation", "GitHubLocation", properties.GitHubLocation != null ? CfnDeploymentGroupGitHubLocationPropertyFromCloudFormation(properties.GitHubLocation) : void 0), ret.addPropertyResult("revisionType", "RevisionType", properties.RevisionType != null ? cfn_parse.FromCloudFormation.getString(properties.RevisionType) : void 0), ret.addPropertyResult("s3Location", "S3Location", properties.S3Location != null ? CfnDeploymentGroupS3LocationPropertyFromCloudFormation(properties.S3Location) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentGroup_S3LocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.requiredValidator)(properties.bucket)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("bundleType", cdk.validateString)(properties.bundleType)), errors.collect(cdk.propertyValidator("eTag", cdk.validateString)(properties.eTag)), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "S3LocationProperty"');
    }
    function cfnDeploymentGroupS3LocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentGroup_S3LocationPropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), BundleType: cdk.stringToCloudFormation(properties.bundleType), ETag: cdk.stringToCloudFormation(properties.eTag), Key: cdk.stringToCloudFormation(properties.key), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnDeploymentGroupS3LocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", cfn_parse.FromCloudFormation.getString(properties.Bucket)), ret.addPropertyResult("bundleType", "BundleType", properties.BundleType != null ? cfn_parse.FromCloudFormation.getString(properties.BundleType) : void 0), ret.addPropertyResult("eTag", "ETag", properties.ETag != null ? cfn_parse.FromCloudFormation.getString(properties.ETag) : void 0), ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getString(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentGroup_TagFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TagFilterProperty"');
    }
    function cfnDeploymentGroupTagFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentGroup_TagFilterPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Type: cdk.stringToCloudFormation(properties.type), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnDeploymentGroupTagFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentGroup_TargetGroupInfoPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "TargetGroupInfoProperty"');
    }
    function cfnDeploymentGroupTargetGroupInfoPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentGroup_TargetGroupInfoPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnDeploymentGroupTargetGroupInfoPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentGroup_TargetGroupPairInfoPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("prodTrafficRoute", CfnDeploymentGroup_TrafficRoutePropertyValidator)(properties.prodTrafficRoute)), errors.collect(cdk.propertyValidator("targetGroups", cdk.listValidator(CfnDeploymentGroup_TargetGroupInfoPropertyValidator))(properties.targetGroups)), errors.collect(cdk.propertyValidator("testTrafficRoute", CfnDeploymentGroup_TrafficRoutePropertyValidator)(properties.testTrafficRoute)), errors.wrap('supplied properties not correct for "TargetGroupPairInfoProperty"');
    }
    function cfnDeploymentGroupTargetGroupPairInfoPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentGroup_TargetGroupPairInfoPropertyValidator(properties).assertSuccess(), { ProdTrafficRoute: cfnDeploymentGroupTrafficRoutePropertyToCloudFormation(properties.prodTrafficRoute), TargetGroups: cdk.listMapper(cfnDeploymentGroupTargetGroupInfoPropertyToCloudFormation)(properties.targetGroups), TestTrafficRoute: cfnDeploymentGroupTrafficRoutePropertyToCloudFormation(properties.testTrafficRoute) }) : properties;
    }
    function CfnDeploymentGroupTargetGroupPairInfoPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("prodTrafficRoute", "ProdTrafficRoute", properties.ProdTrafficRoute != null ? CfnDeploymentGroupTrafficRoutePropertyFromCloudFormation(properties.ProdTrafficRoute) : void 0), ret.addPropertyResult("targetGroups", "TargetGroups", properties.TargetGroups != null ? cfn_parse.FromCloudFormation.getArray(CfnDeploymentGroupTargetGroupInfoPropertyFromCloudFormation)(properties.TargetGroups) : void 0), ret.addPropertyResult("testTrafficRoute", "TestTrafficRoute", properties.TestTrafficRoute != null ? CfnDeploymentGroupTrafficRoutePropertyFromCloudFormation(properties.TestTrafficRoute) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentGroup_TrafficRoutePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("listenerArns", cdk.listValidator(cdk.validateString))(properties.listenerArns)), errors.wrap('supplied properties not correct for "TrafficRouteProperty"');
    }
    function cfnDeploymentGroupTrafficRoutePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentGroup_TrafficRoutePropertyValidator(properties).assertSuccess(), { ListenerArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.listenerArns) }) : properties;
    }
    function CfnDeploymentGroupTrafficRoutePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("listenerArns", "ListenerArns", properties.ListenerArns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ListenerArns) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentGroup_TriggerConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("triggerEvents", cdk.listValidator(cdk.validateString))(properties.triggerEvents)), errors.collect(cdk.propertyValidator("triggerName", cdk.validateString)(properties.triggerName)), errors.collect(cdk.propertyValidator("triggerTargetArn", cdk.validateString)(properties.triggerTargetArn)), errors.wrap('supplied properties not correct for "TriggerConfigProperty"');
    }
    function cfnDeploymentGroupTriggerConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentGroup_TriggerConfigPropertyValidator(properties).assertSuccess(), { TriggerEvents: cdk.listMapper(cdk.stringToCloudFormation)(properties.triggerEvents), TriggerName: cdk.stringToCloudFormation(properties.triggerName), TriggerTargetArn: cdk.stringToCloudFormation(properties.triggerTargetArn) }) : properties;
    }
    function CfnDeploymentGroupTriggerConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("triggerEvents", "TriggerEvents", properties.TriggerEvents != null ? cfn_parse.FromCloudFormation.getStringArray(properties.TriggerEvents) : void 0), ret.addPropertyResult("triggerName", "TriggerName", properties.TriggerName != null ? cfn_parse.FromCloudFormation.getString(properties.TriggerName) : void 0), ret.addPropertyResult("triggerTargetArn", "TriggerTargetArn", properties.TriggerTargetArn != null ? cfn_parse.FromCloudFormation.getString(properties.TriggerTargetArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-codedeploy/lib/base-deployment-config.js
var require_base_deployment_config = __commonJS({
  "node_modules/aws-cdk-lib/aws-codedeploy/lib/base-deployment-config.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.BaseDeploymentConfig = exports2.ComputePlatform = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var codedeploy_generated_1 = require_codedeploy_generated();
    var utils_1 = require_utils8();
    var core_1 = require_core2();
    var ComputePlatform;
    (function(ComputePlatform2) {
      ComputePlatform2.SERVER = "Server", ComputePlatform2.LAMBDA = "Lambda", ComputePlatform2.ECS = "ECS";
    })(ComputePlatform = exports2.ComputePlatform || (exports2.ComputePlatform = {}));
    var BaseDeploymentConfig = class _BaseDeploymentConfig extends core_1.Resource {
      static fromDeploymentConfigName(scope, id, deploymentConfigName) {
        const arn = core_1.Stack.of(scope).formatArn({ service: "codedeploy", resource: "deploymentconfig", resourceName: deploymentConfigName, arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME });
        return { deploymentConfigName, deploymentConfigArn: arn };
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props?.deploymentConfigName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codedeploy_BaseDeploymentConfigProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _BaseDeploymentConfig), error;
        }
        if (props?.trafficRouting && (props?.computePlatform === void 0 || props?.computePlatform === ComputePlatform.SERVER))
          throw new Error("Traffic routing config must not be specified for a Server-base deployment configuration");
        if (props?.minimumHealthyHosts && props?.computePlatform && props?.computePlatform !== ComputePlatform.SERVER)
          throw new Error("Minimum healthy hosts config must only be specified for a Server-base deployment configuration");
        const resource = new codedeploy_generated_1.CfnDeploymentConfig(this, "Resource", { deploymentConfigName: this.physicalName, computePlatform: props?.computePlatform, trafficRoutingConfig: props?.trafficRouting?.bind(this), minimumHealthyHosts: props?.minimumHealthyHosts?._json });
        this.deploymentConfigName = this.getResourceNameAttribute(resource.ref), this.deploymentConfigArn = this.getResourceArnAttribute((0, utils_1.arnForDeploymentConfig)(resource.ref), { service: "codedeploy", resource: "deploymentconfig", resourceName: this.physicalName, arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME }), this.node.addValidation({ validate: () => (0, utils_1.validateName)("Deployment config", this.physicalName) });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, BaseDeploymentConfig[_a] = { fqn: "aws-cdk-lib.aws_codedeploy.BaseDeploymentConfig", version: "2.80.0" }, exports2.BaseDeploymentConfig = BaseDeploymentConfig;
  }
});

// node_modules/aws-cdk-lib/aws-codedeploy/lib/host-health-config.js
var require_host_health_config = __commonJS({
  "node_modules/aws-cdk-lib/aws-codedeploy/lib/host-health-config.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.MinimumHealthyHosts = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var MinimumHealthyHosts = class _MinimumHealthyHosts {
      static count(value) {
        return new _MinimumHealthyHosts({ type: "HOST_COUNT", value });
      }
      static percentage(value) {
        return new _MinimumHealthyHosts({ type: "FLEET_PERCENT", value });
      }
      constructor(json) {
        this.json = json;
      }
      get _json() {
        return this.json;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, MinimumHealthyHosts[_a] = { fqn: "aws-cdk-lib.aws_codedeploy.MinimumHealthyHosts", version: "2.80.0" }, exports2.MinimumHealthyHosts = MinimumHealthyHosts;
  }
});

// node_modules/aws-cdk-lib/aws-codedeploy/lib/rollback-config.js
var require_rollback_config = __commonJS({
  "node_modules/aws-cdk-lib/aws-codedeploy/lib/rollback-config.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-codedeploy/lib/traffic-routing-config.js
var require_traffic_routing_config = __commonJS({
  "node_modules/aws-cdk-lib/aws-codedeploy/lib/traffic-routing-config.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.TimeBasedLinearTrafficRouting = exports2.TimeBasedCanaryTrafficRouting = exports2.AllAtOnceTrafficRouting = exports2.TrafficRouting = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var TrafficRouting = class {
      static allAtOnce() {
        return new AllAtOnceTrafficRouting();
      }
      static timeBasedCanary(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codedeploy_TimeBasedCanaryTrafficRoutingProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.timeBasedCanary), error;
        }
        return new TimeBasedCanaryTrafficRouting(props);
      }
      static timeBasedLinear(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codedeploy_TimeBasedLinearTrafficRoutingProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.timeBasedLinear), error;
        }
        return new TimeBasedLinearTrafficRouting(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, TrafficRouting[_a] = { fqn: "aws-cdk-lib.aws_codedeploy.TrafficRouting", version: "2.80.0" }, exports2.TrafficRouting = TrafficRouting;
    var AllAtOnceTrafficRouting = class extends TrafficRouting {
      constructor() {
        super();
      }
      bind(_scope) {
        return { type: "AllAtOnce" };
      }
    };
    _b = JSII_RTTI_SYMBOL_1, AllAtOnceTrafficRouting[_b] = { fqn: "aws-cdk-lib.aws_codedeploy.AllAtOnceTrafficRouting", version: "2.80.0" }, exports2.AllAtOnceTrafficRouting = AllAtOnceTrafficRouting;
    var TimeBasedCanaryTrafficRouting = class _TimeBasedCanaryTrafficRouting extends TrafficRouting {
      constructor(props) {
        super();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codedeploy_TimeBasedCanaryTrafficRoutingProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _TimeBasedCanaryTrafficRouting), error;
        }
        this.interval = props.interval, this.percentage = props.percentage;
      }
      bind(_scope) {
        return { type: "TimeBasedCanary", timeBasedCanary: { canaryInterval: this.interval.toMinutes(), canaryPercentage: this.percentage } };
      }
    };
    _c = JSII_RTTI_SYMBOL_1, TimeBasedCanaryTrafficRouting[_c] = { fqn: "aws-cdk-lib.aws_codedeploy.TimeBasedCanaryTrafficRouting", version: "2.80.0" }, exports2.TimeBasedCanaryTrafficRouting = TimeBasedCanaryTrafficRouting;
    var TimeBasedLinearTrafficRouting = class _TimeBasedLinearTrafficRouting extends TrafficRouting {
      constructor(props) {
        super();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codedeploy_TimeBasedLinearTrafficRoutingProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _TimeBasedLinearTrafficRouting), error;
        }
        this.interval = props.interval, this.percentage = props.percentage;
      }
      bind(_scope) {
        return { type: "TimeBasedLinear", timeBasedLinear: { linearInterval: this.interval.toMinutes(), linearPercentage: this.percentage } };
      }
    };
    _d = JSII_RTTI_SYMBOL_1, TimeBasedLinearTrafficRouting[_d] = { fqn: "aws-cdk-lib.aws_codedeploy.TimeBasedLinearTrafficRouting", version: "2.80.0" }, exports2.TimeBasedLinearTrafficRouting = TimeBasedLinearTrafficRouting;
  }
});

// node_modules/aws-cdk-lib/aws-codedeploy/lib/ecs/application.js
var require_application = __commonJS({
  "node_modules/aws-cdk-lib/aws-codedeploy/lib/ecs/application.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EcsApplication = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core_1 = require_core2();
    var codedeploy_generated_1 = require_codedeploy_generated();
    var utils_1 = require_utils8();
    var EcsApplication = class _EcsApplication extends core_1.Resource {
      static fromEcsApplicationName(scope, id, ecsApplicationName) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.applicationArn = (0, utils_1.arnForApplication)(core_1.Stack.of(scope), ecsApplicationName), this.applicationName = ecsApplicationName;
          }
        }
        return new Import(scope, id);
      }
      static fromEcsApplicationArn(scope, id, ecsApplicationArn) {
        return new class extends core_1.Resource {
          constructor() {
            super(...arguments), this.applicationArn = ecsApplicationArn, this.applicationName = core_1.Arn.split(ecsApplicationArn, core_1.ArnFormat.COLON_RESOURCE_NAME).resourceName ?? "<invalid arn>";
          }
        }(scope, id, { environmentFromArn: ecsApplicationArn });
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.applicationName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codedeploy_EcsApplicationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EcsApplication), error;
        }
        const resource = new codedeploy_generated_1.CfnApplication(this, "Resource", { applicationName: this.physicalName, computePlatform: "ECS" });
        this.applicationName = this.getResourceNameAttribute(resource.ref), this.applicationArn = this.getResourceArnAttribute((0, utils_1.arnForApplication)(core_1.Stack.of(scope), resource.ref), { service: "codedeploy", resource: "application", resourceName: this.physicalName, arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME }), this.node.addValidation({ validate: () => (0, utils_1.validateName)("Application", this.physicalName) });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EcsApplication[_a] = { fqn: "aws-cdk-lib.aws_codedeploy.EcsApplication", version: "2.80.0" }, exports2.EcsApplication = EcsApplication;
  }
});

// node_modules/aws-cdk-lib/aws-codedeploy/lib/ecs/deployment-config.js
var require_deployment_config = __commonJS({
  "node_modules/aws-cdk-lib/aws-codedeploy/lib/ecs/deployment-config.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EcsDeploymentConfig = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var base_deployment_config_1 = require_base_deployment_config();
    var utils_1 = require_utils8();
    var traffic_routing_config_1 = require_traffic_routing_config();
    var EcsDeploymentConfig = class _EcsDeploymentConfig extends base_deployment_config_1.BaseDeploymentConfig {
      static fromEcsDeploymentConfigName(scope, id, ecsDeploymentConfigName) {
        return this.fromDeploymentConfigName(scope, id, ecsDeploymentConfigName);
      }
      static deploymentConfig(name) {
        return (0, utils_1.deploymentConfig)(name);
      }
      constructor(scope, id, props) {
        super(scope, id, { ...props, computePlatform: base_deployment_config_1.ComputePlatform.ECS, trafficRouting: props?.trafficRouting ?? traffic_routing_config_1.TrafficRouting.allAtOnce() });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codedeploy_EcsDeploymentConfigProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EcsDeploymentConfig), error;
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EcsDeploymentConfig[_a] = { fqn: "aws-cdk-lib.aws_codedeploy.EcsDeploymentConfig", version: "2.80.0" }, EcsDeploymentConfig.ALL_AT_ONCE = EcsDeploymentConfig.deploymentConfig("CodeDeployDefault.ECSAllAtOnce"), EcsDeploymentConfig.LINEAR_10PERCENT_EVERY_1MINUTES = EcsDeploymentConfig.deploymentConfig("CodeDeployDefault.ECSLinear10PercentEvery1Minutes"), EcsDeploymentConfig.LINEAR_10PERCENT_EVERY_3MINUTES = EcsDeploymentConfig.deploymentConfig("CodeDeployDefault.ECSLinear10PercentEvery3Minutes"), EcsDeploymentConfig.CANARY_10PERCENT_5MINUTES = EcsDeploymentConfig.deploymentConfig("CodeDeployDefault.ECSCanary10Percent5Minutes"), EcsDeploymentConfig.CANARY_10PERCENT_15MINUTES = EcsDeploymentConfig.deploymentConfig("CodeDeployDefault.ECSCanary10Percent15Minutes"), exports2.EcsDeploymentConfig = EcsDeploymentConfig;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/base/scalable-task-count.js
var require_scalable_task_count = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/base/scalable-task-count.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ScalableTaskCount = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var appscaling = require_aws_applicationautoscaling();
    var ScalableTaskCount = class _ScalableTaskCount extends appscaling.BaseScalableAttribute {
      constructor(scope, id, props) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_ScalableTaskCountProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ScalableTaskCount), error;
        }
      }
      scaleOnSchedule(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_applicationautoscaling_ScalingSchedule(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.scaleOnSchedule), error;
        }
        return super.doScaleOnSchedule(id, props);
      }
      scaleOnMetric(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_applicationautoscaling_BasicStepScalingPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.scaleOnMetric), error;
        }
        return super.doScaleOnMetric(id, props);
      }
      scaleOnCpuUtilization(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_CpuUtilizationScalingProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.scaleOnCpuUtilization), error;
        }
        return super.doScaleToTrackMetric(id, { predefinedMetric: appscaling.PredefinedMetric.ECS_SERVICE_AVERAGE_CPU_UTILIZATION, policyName: props.policyName, disableScaleIn: props.disableScaleIn, targetValue: props.targetUtilizationPercent, scaleInCooldown: props.scaleInCooldown, scaleOutCooldown: props.scaleOutCooldown });
      }
      scaleOnMemoryUtilization(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_MemoryUtilizationScalingProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.scaleOnMemoryUtilization), error;
        }
        return super.doScaleToTrackMetric(id, { predefinedMetric: appscaling.PredefinedMetric.ECS_SERVICE_AVERAGE_MEMORY_UTILIZATION, targetValue: props.targetUtilizationPercent, policyName: props.policyName, disableScaleIn: props.disableScaleIn, scaleInCooldown: props.scaleInCooldown, scaleOutCooldown: props.scaleOutCooldown });
      }
      scaleOnRequestCount(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_RequestCountScalingProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.scaleOnRequestCount), error;
        }
        const resourceLabel = props.targetGroup.firstLoadBalancerFullName + "/" + props.targetGroup.targetGroupFullName;
        return super.doScaleToTrackMetric(id, { predefinedMetric: appscaling.PredefinedMetric.ALB_REQUEST_COUNT_PER_TARGET, resourceLabel, targetValue: props.requestsPerTarget, policyName: props.policyName, disableScaleIn: props.disableScaleIn, scaleInCooldown: props.scaleInCooldown, scaleOutCooldown: props.scaleOutCooldown });
      }
      scaleToTrackCustomMetric(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_TrackCustomMetricProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.scaleToTrackCustomMetric), error;
        }
        return super.doScaleToTrackMetric(id, { customMetric: props.metric, targetValue: props.targetValue, policyName: props.policyName, disableScaleIn: props.disableScaleIn, scaleInCooldown: props.scaleInCooldown, scaleOutCooldown: props.scaleOutCooldown });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ScalableTaskCount[_a] = { fqn: "aws-cdk-lib.aws_ecs.ScalableTaskCount", version: "2.80.0" }, exports2.ScalableTaskCount = ScalableTaskCount;
  }
});

// node_modules/aws-cdk-lib/aws-servicediscovery/lib/instance.js
var require_instance3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicediscovery/lib/instance.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.InstanceBase = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core_1 = require_core2();
    var InstanceBase = class extends core_1.Resource {
      uniqueInstanceId() {
        const id = core_1.Names.uniqueId(this);
        return id.substring(Math.max(id.length - 64, 0), id.length);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, InstanceBase[_a] = { fqn: "aws-cdk-lib.aws_servicediscovery.InstanceBase", version: "2.80.0" }, exports2.InstanceBase = InstanceBase;
  }
});

// node_modules/aws-cdk-lib/aws-servicediscovery/lib/namespace.js
var require_namespace = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicediscovery/lib/namespace.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.NamespaceType = void 0;
    var NamespaceType;
    (function(NamespaceType2) {
      NamespaceType2.HTTP = "HTTP", NamespaceType2.DNS_PRIVATE = "DNS_PRIVATE", NamespaceType2.DNS_PUBLIC = "DNS_PUBLIC";
    })(NamespaceType = exports2.NamespaceType || (exports2.NamespaceType = {}));
  }
});

// node_modules/aws-cdk-lib/aws-servicediscovery/lib/servicediscovery.generated.js
var require_servicediscovery_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicediscovery/lib/servicediscovery.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnService = exports2.CfnPublicDnsNamespace = exports2.CfnPrivateDnsNamespace = exports2.CfnInstance = exports2.CfnHttpNamespace = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnHttpNamespacePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnHttpNamespaceProps"');
    }
    function cfnHttpNamespacePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHttpNamespacePropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnHttpNamespacePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnHttpNamespace = class _CfnHttpNamespace extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnHttpNamespacePropsFromCloudFormation(resourceProperties), ret = new _CfnHttpNamespace(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnHttpNamespace.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicediscovery_CfnHttpNamespaceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnHttpNamespace), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ServiceDiscovery::HttpNamespace", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnHttpNamespace.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnHttpNamespacePropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnHttpNamespace[_a] = { fqn: "aws-cdk-lib.aws_servicediscovery.CfnHttpNamespace", version: "2.80.0" }, CfnHttpNamespace.CFN_RESOURCE_TYPE_NAME = "AWS::ServiceDiscovery::HttpNamespace", exports2.CfnHttpNamespace = CfnHttpNamespace;
    function CfnInstancePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceAttributes", cdk.requiredValidator)(properties.instanceAttributes)), errors.collect(cdk.propertyValidator("instanceAttributes", cdk.validateObject)(properties.instanceAttributes)), errors.collect(cdk.propertyValidator("instanceId", cdk.validateString)(properties.instanceId)), errors.collect(cdk.propertyValidator("serviceId", cdk.requiredValidator)(properties.serviceId)), errors.collect(cdk.propertyValidator("serviceId", cdk.validateString)(properties.serviceId)), errors.wrap('supplied properties not correct for "CfnInstanceProps"');
    }
    function cfnInstancePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstancePropsValidator(properties).assertSuccess(), { InstanceAttributes: cdk.objectToCloudFormation(properties.instanceAttributes), ServiceId: cdk.stringToCloudFormation(properties.serviceId), InstanceId: cdk.stringToCloudFormation(properties.instanceId) }) : properties;
    }
    function CfnInstancePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceAttributes", "InstanceAttributes", cfn_parse.FromCloudFormation.getAny(properties.InstanceAttributes)), ret.addPropertyResult("serviceId", "ServiceId", cfn_parse.FromCloudFormation.getString(properties.ServiceId)), ret.addPropertyResult("instanceId", "InstanceId", properties.InstanceId != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnInstance = class _CfnInstance extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnInstancePropsFromCloudFormation(resourceProperties), ret = new _CfnInstance(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnInstance.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicediscovery_CfnInstanceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnInstance), error;
        }
        cdk.requireProperty(props, "instanceAttributes", this), cdk.requireProperty(props, "serviceId", this), this.instanceAttributes = props.instanceAttributes, this.serviceId = props.serviceId, this.instanceId = props.instanceId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnInstance.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { instanceAttributes: this.instanceAttributes, serviceId: this.serviceId, instanceId: this.instanceId };
      }
      renderProperties(props) {
        return cfnInstancePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnInstance[_b] = { fqn: "aws-cdk-lib.aws_servicediscovery.CfnInstance", version: "2.80.0" }, CfnInstance.CFN_RESOURCE_TYPE_NAME = "AWS::ServiceDiscovery::Instance", exports2.CfnInstance = CfnInstance;
    function CfnPrivateDnsNamespacePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("properties", CfnPrivateDnsNamespace_PropertiesPropertyValidator)(properties.properties)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpc", cdk.requiredValidator)(properties.vpc)), errors.collect(cdk.propertyValidator("vpc", cdk.validateString)(properties.vpc)), errors.wrap('supplied properties not correct for "CfnPrivateDnsNamespaceProps"');
    }
    function cfnPrivateDnsNamespacePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPrivateDnsNamespacePropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Vpc: cdk.stringToCloudFormation(properties.vpc), Description: cdk.stringToCloudFormation(properties.description), Properties: cfnPrivateDnsNamespacePropertiesPropertyToCloudFormation(properties.properties), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnPrivateDnsNamespacePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("vpc", "Vpc", cfn_parse.FromCloudFormation.getString(properties.Vpc)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("properties", "Properties", properties.Properties != null ? CfnPrivateDnsNamespacePropertiesPropertyFromCloudFormation(properties.Properties) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPrivateDnsNamespace = class _CfnPrivateDnsNamespace extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPrivateDnsNamespacePropsFromCloudFormation(resourceProperties), ret = new _CfnPrivateDnsNamespace(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPrivateDnsNamespace.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicediscovery_CfnPrivateDnsNamespaceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPrivateDnsNamespace), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "vpc", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrHostedZoneId = cdk.Token.asString(this.getAtt("HostedZoneId", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.vpc = props.vpc, this.description = props.description, this.properties = props.properties, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ServiceDiscovery::PrivateDnsNamespace", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPrivateDnsNamespace.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, vpc: this.vpc, description: this.description, properties: this.properties, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnPrivateDnsNamespacePropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnPrivateDnsNamespace[_c] = { fqn: "aws-cdk-lib.aws_servicediscovery.CfnPrivateDnsNamespace", version: "2.80.0" }, CfnPrivateDnsNamespace.CFN_RESOURCE_TYPE_NAME = "AWS::ServiceDiscovery::PrivateDnsNamespace", exports2.CfnPrivateDnsNamespace = CfnPrivateDnsNamespace;
    function CfnPrivateDnsNamespace_PrivateDnsPropertiesMutablePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("soa", CfnPrivateDnsNamespace_SOAPropertyValidator)(properties.soa)), errors.wrap('supplied properties not correct for "PrivateDnsPropertiesMutableProperty"');
    }
    function cfnPrivateDnsNamespacePrivateDnsPropertiesMutablePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPrivateDnsNamespace_PrivateDnsPropertiesMutablePropertyValidator(properties).assertSuccess(), { SOA: cfnPrivateDnsNamespaceSOAPropertyToCloudFormation(properties.soa) }) : properties;
    }
    function CfnPrivateDnsNamespacePrivateDnsPropertiesMutablePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("soa", "SOA", properties.SOA != null ? CfnPrivateDnsNamespaceSOAPropertyFromCloudFormation(properties.SOA) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPrivateDnsNamespace_PropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dnsProperties", CfnPrivateDnsNamespace_PrivateDnsPropertiesMutablePropertyValidator)(properties.dnsProperties)), errors.wrap('supplied properties not correct for "PropertiesProperty"');
    }
    function cfnPrivateDnsNamespacePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPrivateDnsNamespace_PropertiesPropertyValidator(properties).assertSuccess(), { DnsProperties: cfnPrivateDnsNamespacePrivateDnsPropertiesMutablePropertyToCloudFormation(properties.dnsProperties) }) : properties;
    }
    function CfnPrivateDnsNamespacePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dnsProperties", "DnsProperties", properties.DnsProperties != null ? CfnPrivateDnsNamespacePrivateDnsPropertiesMutablePropertyFromCloudFormation(properties.DnsProperties) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPrivateDnsNamespace_SOAPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ttl", cdk.validateNumber)(properties.ttl)), errors.wrap('supplied properties not correct for "SOAProperty"');
    }
    function cfnPrivateDnsNamespaceSOAPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPrivateDnsNamespace_SOAPropertyValidator(properties).assertSuccess(), { TTL: cdk.numberToCloudFormation(properties.ttl) }) : properties;
    }
    function CfnPrivateDnsNamespaceSOAPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ttl", "TTL", properties.TTL != null ? cfn_parse.FromCloudFormation.getNumber(properties.TTL) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPublicDnsNamespacePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("properties", CfnPublicDnsNamespace_PropertiesPropertyValidator)(properties.properties)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnPublicDnsNamespaceProps"');
    }
    function cfnPublicDnsNamespacePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPublicDnsNamespacePropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), Properties: cfnPublicDnsNamespacePropertiesPropertyToCloudFormation(properties.properties), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnPublicDnsNamespacePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("properties", "Properties", properties.Properties != null ? CfnPublicDnsNamespacePropertiesPropertyFromCloudFormation(properties.Properties) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPublicDnsNamespace = class _CfnPublicDnsNamespace extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPublicDnsNamespacePropsFromCloudFormation(resourceProperties), ret = new _CfnPublicDnsNamespace(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPublicDnsNamespace.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicediscovery_CfnPublicDnsNamespaceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPublicDnsNamespace), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrHostedZoneId = cdk.Token.asString(this.getAtt("HostedZoneId", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.description = props.description, this.properties = props.properties, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ServiceDiscovery::PublicDnsNamespace", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPublicDnsNamespace.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, description: this.description, properties: this.properties, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnPublicDnsNamespacePropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnPublicDnsNamespace[_d] = { fqn: "aws-cdk-lib.aws_servicediscovery.CfnPublicDnsNamespace", version: "2.80.0" }, CfnPublicDnsNamespace.CFN_RESOURCE_TYPE_NAME = "AWS::ServiceDiscovery::PublicDnsNamespace", exports2.CfnPublicDnsNamespace = CfnPublicDnsNamespace;
    function CfnPublicDnsNamespace_PropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dnsProperties", CfnPublicDnsNamespace_PublicDnsPropertiesMutablePropertyValidator)(properties.dnsProperties)), errors.wrap('supplied properties not correct for "PropertiesProperty"');
    }
    function cfnPublicDnsNamespacePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPublicDnsNamespace_PropertiesPropertyValidator(properties).assertSuccess(), { DnsProperties: cfnPublicDnsNamespacePublicDnsPropertiesMutablePropertyToCloudFormation(properties.dnsProperties) }) : properties;
    }
    function CfnPublicDnsNamespacePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dnsProperties", "DnsProperties", properties.DnsProperties != null ? CfnPublicDnsNamespacePublicDnsPropertiesMutablePropertyFromCloudFormation(properties.DnsProperties) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPublicDnsNamespace_PublicDnsPropertiesMutablePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("soa", CfnPublicDnsNamespace_SOAPropertyValidator)(properties.soa)), errors.wrap('supplied properties not correct for "PublicDnsPropertiesMutableProperty"');
    }
    function cfnPublicDnsNamespacePublicDnsPropertiesMutablePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPublicDnsNamespace_PublicDnsPropertiesMutablePropertyValidator(properties).assertSuccess(), { SOA: cfnPublicDnsNamespaceSOAPropertyToCloudFormation(properties.soa) }) : properties;
    }
    function CfnPublicDnsNamespacePublicDnsPropertiesMutablePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("soa", "SOA", properties.SOA != null ? CfnPublicDnsNamespaceSOAPropertyFromCloudFormation(properties.SOA) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPublicDnsNamespace_SOAPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ttl", cdk.validateNumber)(properties.ttl)), errors.wrap('supplied properties not correct for "SOAProperty"');
    }
    function cfnPublicDnsNamespaceSOAPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPublicDnsNamespace_SOAPropertyValidator(properties).assertSuccess(), { TTL: cdk.numberToCloudFormation(properties.ttl) }) : properties;
    }
    function CfnPublicDnsNamespaceSOAPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ttl", "TTL", properties.TTL != null ? cfn_parse.FromCloudFormation.getNumber(properties.TTL) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnServicePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("dnsConfig", CfnService_DnsConfigPropertyValidator)(properties.dnsConfig)), errors.collect(cdk.propertyValidator("healthCheckConfig", CfnService_HealthCheckConfigPropertyValidator)(properties.healthCheckConfig)), errors.collect(cdk.propertyValidator("healthCheckCustomConfig", CfnService_HealthCheckCustomConfigPropertyValidator)(properties.healthCheckCustomConfig)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("namespaceId", cdk.validateString)(properties.namespaceId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnServiceProps"');
    }
    function cfnServicePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnServicePropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), DnsConfig: cfnServiceDnsConfigPropertyToCloudFormation(properties.dnsConfig), HealthCheckConfig: cfnServiceHealthCheckConfigPropertyToCloudFormation(properties.healthCheckConfig), HealthCheckCustomConfig: cfnServiceHealthCheckCustomConfigPropertyToCloudFormation(properties.healthCheckCustomConfig), Name: cdk.stringToCloudFormation(properties.name), NamespaceId: cdk.stringToCloudFormation(properties.namespaceId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnServicePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("dnsConfig", "DnsConfig", properties.DnsConfig != null ? CfnServiceDnsConfigPropertyFromCloudFormation(properties.DnsConfig) : void 0), ret.addPropertyResult("healthCheckConfig", "HealthCheckConfig", properties.HealthCheckConfig != null ? CfnServiceHealthCheckConfigPropertyFromCloudFormation(properties.HealthCheckConfig) : void 0), ret.addPropertyResult("healthCheckCustomConfig", "HealthCheckCustomConfig", properties.HealthCheckCustomConfig != null ? CfnServiceHealthCheckCustomConfigPropertyFromCloudFormation(properties.HealthCheckCustomConfig) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("namespaceId", "NamespaceId", properties.NamespaceId != null ? cfn_parse.FromCloudFormation.getString(properties.NamespaceId) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnService = class _CfnService extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnServicePropsFromCloudFormation(resourceProperties), ret = new _CfnService(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnService.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicediscovery_CfnServiceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnService), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.description = props.description, this.dnsConfig = props.dnsConfig, this.healthCheckConfig = props.healthCheckConfig, this.healthCheckCustomConfig = props.healthCheckCustomConfig, this.name = props.name, this.namespaceId = props.namespaceId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ServiceDiscovery::Service", props.tags, { tagPropertyName: "tags" }), this.type = props.type;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnService.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, dnsConfig: this.dnsConfig, healthCheckConfig: this.healthCheckConfig, healthCheckCustomConfig: this.healthCheckCustomConfig, name: this.name, namespaceId: this.namespaceId, tags: this.tags.renderTags(), type: this.type };
      }
      renderProperties(props) {
        return cfnServicePropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnService[_e] = { fqn: "aws-cdk-lib.aws_servicediscovery.CfnService", version: "2.80.0" }, CfnService.CFN_RESOURCE_TYPE_NAME = "AWS::ServiceDiscovery::Service", exports2.CfnService = CfnService;
    function CfnService_DnsConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dnsRecords", cdk.requiredValidator)(properties.dnsRecords)), errors.collect(cdk.propertyValidator("dnsRecords", cdk.listValidator(CfnService_DnsRecordPropertyValidator))(properties.dnsRecords)), errors.collect(cdk.propertyValidator("namespaceId", cdk.validateString)(properties.namespaceId)), errors.collect(cdk.propertyValidator("routingPolicy", cdk.validateString)(properties.routingPolicy)), errors.wrap('supplied properties not correct for "DnsConfigProperty"');
    }
    function cfnServiceDnsConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_DnsConfigPropertyValidator(properties).assertSuccess(), { DnsRecords: cdk.listMapper(cfnServiceDnsRecordPropertyToCloudFormation)(properties.dnsRecords), NamespaceId: cdk.stringToCloudFormation(properties.namespaceId), RoutingPolicy: cdk.stringToCloudFormation(properties.routingPolicy) }) : properties;
    }
    function CfnServiceDnsConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dnsRecords", "DnsRecords", cfn_parse.FromCloudFormation.getArray(CfnServiceDnsRecordPropertyFromCloudFormation)(properties.DnsRecords)), ret.addPropertyResult("namespaceId", "NamespaceId", properties.NamespaceId != null ? cfn_parse.FromCloudFormation.getString(properties.NamespaceId) : void 0), ret.addPropertyResult("routingPolicy", "RoutingPolicy", properties.RoutingPolicy != null ? cfn_parse.FromCloudFormation.getString(properties.RoutingPolicy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_DnsRecordPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ttl", cdk.requiredValidator)(properties.ttl)), errors.collect(cdk.propertyValidator("ttl", cdk.validateNumber)(properties.ttl)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "DnsRecordProperty"');
    }
    function cfnServiceDnsRecordPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_DnsRecordPropertyValidator(properties).assertSuccess(), { TTL: cdk.numberToCloudFormation(properties.ttl), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnServiceDnsRecordPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ttl", "TTL", cfn_parse.FromCloudFormation.getNumber(properties.TTL)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_HealthCheckConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("failureThreshold", cdk.validateNumber)(properties.failureThreshold)), errors.collect(cdk.propertyValidator("resourcePath", cdk.validateString)(properties.resourcePath)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "HealthCheckConfigProperty"');
    }
    function cfnServiceHealthCheckConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_HealthCheckConfigPropertyValidator(properties).assertSuccess(), { FailureThreshold: cdk.numberToCloudFormation(properties.failureThreshold), ResourcePath: cdk.stringToCloudFormation(properties.resourcePath), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnServiceHealthCheckConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("failureThreshold", "FailureThreshold", properties.FailureThreshold != null ? cfn_parse.FromCloudFormation.getNumber(properties.FailureThreshold) : void 0), ret.addPropertyResult("resourcePath", "ResourcePath", properties.ResourcePath != null ? cfn_parse.FromCloudFormation.getString(properties.ResourcePath) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_HealthCheckCustomConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("failureThreshold", cdk.validateNumber)(properties.failureThreshold)), errors.wrap('supplied properties not correct for "HealthCheckCustomConfigProperty"');
    }
    function cfnServiceHealthCheckCustomConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_HealthCheckCustomConfigPropertyValidator(properties).assertSuccess(), { FailureThreshold: cdk.numberToCloudFormation(properties.failureThreshold) }) : properties;
    }
    function CfnServiceHealthCheckCustomConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("failureThreshold", "FailureThreshold", properties.FailureThreshold != null ? cfn_parse.FromCloudFormation.getNumber(properties.FailureThreshold) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-servicediscovery/lib/cname-instance.js
var require_cname_instance = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicediscovery/lib/cname-instance.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CnameInstance = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var instance_1 = require_instance3();
    var namespace_1 = require_namespace();
    var service_1 = require_service2();
    var servicediscovery_generated_1 = require_servicediscovery_generated();
    var CnameInstance = class _CnameInstance extends instance_1.InstanceBase {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicediscovery_CnameInstanceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CnameInstance), error;
        }
        if (props.service.namespace.type === namespace_1.NamespaceType.HTTP)
          throw new Error("Namespace associated with Service must be a DNS Namespace.");
        if (props.service.dnsRecordType !== service_1.DnsRecordType.CNAME)
          throw new Error("A `CnameIntance` can only be used with a service using a `CNAME` record.");
        const resource = new servicediscovery_generated_1.CfnInstance(this, "Resource", { instanceId: props.instanceId || this.uniqueInstanceId(), serviceId: props.service.serviceId, instanceAttributes: { AWS_INSTANCE_CNAME: props.instanceCname, ...props.customAttributes } });
        this.service = props.service, this.instanceId = resource.ref, this.cname = props.instanceCname;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CnameInstance[_a] = { fqn: "aws-cdk-lib.aws_servicediscovery.CnameInstance", version: "2.80.0" }, exports2.CnameInstance = CnameInstance;
  }
});

// node_modules/aws-cdk-lib/aws-servicediscovery/lib/ip-instance.js
var require_ip_instance = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicediscovery/lib/ip-instance.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.IpInstance = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var instance_1 = require_instance3();
    var service_1 = require_service2();
    var servicediscovery_generated_1 = require_servicediscovery_generated();
    var IpInstance = class _IpInstance extends instance_1.InstanceBase {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicediscovery_IpInstanceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _IpInstance), error;
        }
        const dnsRecordType = props.service.dnsRecordType;
        if (dnsRecordType === service_1.DnsRecordType.CNAME)
          throw new Error("Service must support `A`, `AAAA` or `SRV` records to register this instance type.");
        if (dnsRecordType === service_1.DnsRecordType.SRV) {
          if (!props.port)
            throw new Error("A `port` must be specified for a service using a `SRV` record.");
          if (!props.ipv4 && !props.ipv6)
            throw new Error("At least `ipv4` or `ipv6` must be specified for a service using a `SRV` record.");
        }
        if (!props.ipv4 && (dnsRecordType === service_1.DnsRecordType.A || dnsRecordType === service_1.DnsRecordType.A_AAAA))
          throw new Error("An `ipv4` must be specified for a service using a `A` record.");
        if (!props.ipv6 && (dnsRecordType === service_1.DnsRecordType.AAAA || dnsRecordType === service_1.DnsRecordType.A_AAAA))
          throw new Error("An `ipv6` must be specified for a service using a `AAAA` record.");
        const port = props.port || 80, resource = new servicediscovery_generated_1.CfnInstance(this, "Resource", { instanceAttributes: { AWS_INSTANCE_IPV4: props.ipv4, AWS_INSTANCE_IPV6: props.ipv6, AWS_INSTANCE_PORT: port.toString(), ...props.customAttributes }, instanceId: props.instanceId || this.uniqueInstanceId(), serviceId: props.service.serviceId });
        this.service = props.service, this.instanceId = resource.ref, this.ipv4 = props.ipv4 || "", this.ipv6 = props.ipv6 || "", this.port = port;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, IpInstance[_a] = { fqn: "aws-cdk-lib.aws_servicediscovery.IpInstance", version: "2.80.0" }, exports2.IpInstance = IpInstance;
  }
});

// node_modules/aws-cdk-lib/aws-servicediscovery/lib/private/utils.js
var require_utils12 = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicediscovery/lib/private/utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.defaultDiscoveryType = void 0;
    var namespace_1 = require_namespace();
    var service_1 = require_service2();
    function defaultDiscoveryType(namespace) {
      return namespace.type == namespace_1.NamespaceType.HTTP ? service_1.DiscoveryType.API : service_1.DiscoveryType.DNS_AND_API;
    }
    exports2.defaultDiscoveryType = defaultDiscoveryType;
  }
});

// node_modules/aws-cdk-lib/aws-servicediscovery/lib/non-ip-instance.js
var require_non_ip_instance = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicediscovery/lib/non-ip-instance.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.NonIpInstance = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var instance_1 = require_instance3();
    var utils_1 = require_utils12();
    var service_1 = require_service2();
    var servicediscovery_generated_1 = require_servicediscovery_generated();
    var NonIpInstance = class _NonIpInstance extends instance_1.InstanceBase {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicediscovery_NonIpInstanceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _NonIpInstance), error;
        }
        if ((props.service.discoveryType || (0, utils_1.defaultDiscoveryType)(props.service.namespace)) !== service_1.DiscoveryType.API)
          throw new Error("This type of instance can only be registered for HTTP namespaces.");
        if (props.customAttributes === void 0 || Object.keys(props.customAttributes).length === 0)
          throw new Error("You must specify at least one custom attribute for this instance type.");
        const resource = new servicediscovery_generated_1.CfnInstance(this, "Resource", { instanceId: props.instanceId || this.uniqueInstanceId(), serviceId: props.service.serviceId, instanceAttributes: { ...props.customAttributes } });
        this.service = props.service, this.instanceId = resource.ref;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, NonIpInstance[_a] = { fqn: "aws-cdk-lib.aws_servicediscovery.NonIpInstance", version: "2.80.0" }, exports2.NonIpInstance = NonIpInstance;
  }
});

// node_modules/aws-cdk-lib/aws-servicediscovery/lib/service.js
var require_service2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicediscovery/lib/service.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.HealthCheckType = exports2.RoutingPolicy = exports2.DnsRecordType = exports2.DiscoveryType = exports2.Service = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var alias_target_instance_1 = require_alias_target_instance();
    var cname_instance_1 = require_cname_instance();
    var ip_instance_1 = require_ip_instance();
    var namespace_1 = require_namespace();
    var non_ip_instance_1 = require_non_ip_instance();
    var utils_1 = require_utils12();
    var servicediscovery_generated_1 = require_servicediscovery_generated();
    var core_1 = require_core2();
    var ServiceBase = class extends core_1.Resource {
    };
    var Service = class _Service extends ServiceBase {
      static fromServiceAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicediscovery_ServiceAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromServiceAttributes), error;
        }
        class Import extends ServiceBase {
          constructor() {
            super(...arguments), this.namespace = attrs.namespace, this.serviceId = attrs.serviceId, this.serviceArn = attrs.serviceArn, this.dnsRecordType = attrs.dnsRecordType, this.routingPolicy = attrs.routingPolicy, this.serviceName = attrs.serviceName, this.discoveryType = attrs.discoveryType || (0, utils_1.defaultDiscoveryType)(attrs.namespace);
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicediscovery_ServiceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Service), error;
        }
        const namespaceType = props.namespace.type, discoveryType = props.discoveryType || (0, utils_1.defaultDiscoveryType)(props.namespace);
        if (namespaceType == namespace_1.NamespaceType.HTTP && discoveryType == DiscoveryType.DNS_AND_API)
          throw new Error("Cannot specify `discoveryType` of DNS_AND_API when using an HTTP namespace.");
        if (discoveryType === DiscoveryType.API && (props.routingPolicy || props.dnsRecordType))
          throw new Error("Cannot specify `routingPolicy` or `dnsRecord` when using an HTTP namespace.");
        if (props.healthCheck && props.customHealthCheck)
          throw new Error("Cannot specify both `healthCheckConfig` and `healthCheckCustomConfig`.");
        if (namespaceType === namespace_1.NamespaceType.DNS_PRIVATE && props.healthCheck)
          throw new Error("Cannot specify `healthCheckConfig` for a Private DNS namespace.");
        if (props.routingPolicy === RoutingPolicy.MULTIVALUE && props.dnsRecordType === DnsRecordType.CNAME)
          throw new Error("Cannot use `CNAME` record when routing policy is `Multivalue`.");
        if (props.routingPolicy === RoutingPolicy.MULTIVALUE && props.loadBalancer)
          throw new Error("Cannot register loadbalancers when routing policy is `Multivalue`.");
        if (props.healthCheck && props.healthCheck.type === HealthCheckType.TCP && props.healthCheck.resourcePath)
          throw new Error("Cannot specify `resourcePath` when using a `TCP` health check.");
        const routingPolicy = props.dnsRecordType === DnsRecordType.CNAME || props.loadBalancer ? RoutingPolicy.WEIGHTED : RoutingPolicy.MULTIVALUE, dnsRecordType = props.dnsRecordType || DnsRecordType.A;
        if (props.loadBalancer && !(dnsRecordType === DnsRecordType.A || dnsRecordType === DnsRecordType.AAAA || dnsRecordType === DnsRecordType.A_AAAA))
          throw new Error("Must support `A` or `AAAA` records to register loadbalancers.");
        const dnsConfig = discoveryType === DiscoveryType.API ? void 0 : { dnsRecords: renderDnsRecords(dnsRecordType, props.dnsTtl), namespaceId: props.namespace.namespaceId, routingPolicy }, healthCheckConfigDefaults = { type: HealthCheckType.HTTP, failureThreshold: 1, resourcePath: props.healthCheck && props.healthCheck.type !== HealthCheckType.TCP ? "/" : void 0 }, healthCheckConfig = props.healthCheck && { ...healthCheckConfigDefaults, ...props.healthCheck }, healthCheckCustomConfig = props.customHealthCheck, service = new servicediscovery_generated_1.CfnService(this, "Resource", { name: props.name, description: props.description, dnsConfig, healthCheckConfig, healthCheckCustomConfig, namespaceId: props.namespace.namespaceId, type: props.discoveryType == DiscoveryType.API ? "HTTP" : void 0 });
        this.serviceName = service.attrName, this.serviceArn = service.attrArn, this.serviceId = service.attrId, this.namespace = props.namespace, this.dnsRecordType = dnsRecordType, this.routingPolicy = routingPolicy, this.discoveryType = discoveryType;
      }
      registerLoadBalancer(id, loadBalancer, customAttributes) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_ILoadBalancerV2(loadBalancer);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.registerLoadBalancer), error;
        }
        return new alias_target_instance_1.AliasTargetInstance(this, id, { service: this, dnsName: loadBalancer.loadBalancerDnsName, customAttributes });
      }
      registerNonIpInstance(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicediscovery_NonIpInstanceBaseProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.registerNonIpInstance), error;
        }
        return new non_ip_instance_1.NonIpInstance(this, id, { service: this, ...props });
      }
      registerIpInstance(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicediscovery_IpInstanceBaseProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.registerIpInstance), error;
        }
        return new ip_instance_1.IpInstance(this, id, { service: this, ...props });
      }
      registerCnameInstance(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicediscovery_CnameInstanceBaseProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.registerCnameInstance), error;
        }
        return new cname_instance_1.CnameInstance(this, id, { service: this, ...props });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Service[_a] = { fqn: "aws-cdk-lib.aws_servicediscovery.Service", version: "2.80.0" }, exports2.Service = Service;
    function renderDnsRecords(dnsRecordType, dnsTtl = core_1.Duration.minutes(1)) {
      const ttl = dnsTtl.toSeconds();
      return dnsRecordType === DnsRecordType.A_AAAA ? [{ type: DnsRecordType.A, ttl }, { type: DnsRecordType.AAAA, ttl }] : [{ type: dnsRecordType, ttl }];
    }
    var DiscoveryType;
    (function(DiscoveryType2) {
      DiscoveryType2.API = "API", DiscoveryType2.DNS_AND_API = "DNS_AND_API";
    })(DiscoveryType = exports2.DiscoveryType || (exports2.DiscoveryType = {}));
    var DnsRecordType;
    (function(DnsRecordType2) {
      DnsRecordType2.A = "A", DnsRecordType2.AAAA = "AAAA", DnsRecordType2.A_AAAA = "A, AAAA", DnsRecordType2.SRV = "SRV", DnsRecordType2.CNAME = "CNAME";
    })(DnsRecordType = exports2.DnsRecordType || (exports2.DnsRecordType = {}));
    var RoutingPolicy;
    (function(RoutingPolicy2) {
      RoutingPolicy2.WEIGHTED = "WEIGHTED", RoutingPolicy2.MULTIVALUE = "MULTIVALUE";
    })(RoutingPolicy = exports2.RoutingPolicy || (exports2.RoutingPolicy = {}));
    var HealthCheckType;
    (function(HealthCheckType2) {
      HealthCheckType2.HTTP = "HTTP", HealthCheckType2.HTTPS = "HTTPS", HealthCheckType2.TCP = "TCP";
    })(HealthCheckType = exports2.HealthCheckType || (exports2.HealthCheckType = {}));
  }
});

// node_modules/aws-cdk-lib/aws-servicediscovery/lib/alias-target-instance.js
var require_alias_target_instance = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicediscovery/lib/alias-target-instance.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AliasTargetInstance = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var instance_1 = require_instance3();
    var namespace_1 = require_namespace();
    var service_1 = require_service2();
    var servicediscovery_generated_1 = require_servicediscovery_generated();
    var core_1 = require_core2();
    var AliasTargetInstance = class _AliasTargetInstance extends instance_1.InstanceBase {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicediscovery_AliasTargetInstanceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AliasTargetInstance), error;
        }
        if (props.service.namespace.type === namespace_1.NamespaceType.HTTP)
          throw new Error("Namespace associated with Service must be a DNS Namespace.");
        const dnsRecordType = props.service.dnsRecordType;
        if (dnsRecordType !== service_1.DnsRecordType.A && dnsRecordType !== service_1.DnsRecordType.AAAA && dnsRecordType !== service_1.DnsRecordType.A_AAAA)
          throw new Error("Service must use `A` or `AAAA` records to register an AliasRecordTarget.");
        if (props.service.routingPolicy !== service_1.RoutingPolicy.WEIGHTED)
          throw new Error("Service must use `WEIGHTED` routing policy.");
        const resource = new servicediscovery_generated_1.CfnInstance(this, "Resource", { instanceAttributes: { AWS_ALIAS_DNS_NAME: props.dnsName, ...props.customAttributes }, instanceId: props.instanceId || core_1.Names.uniqueId(this), serviceId: props.service.serviceId });
        this.service = props.service, this.instanceId = resource.ref, this.dnsName = props.dnsName;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AliasTargetInstance[_a] = { fqn: "aws-cdk-lib.aws_servicediscovery.AliasTargetInstance", version: "2.80.0" }, exports2.AliasTargetInstance = AliasTargetInstance;
  }
});

// node_modules/aws-cdk-lib/aws-servicediscovery/lib/http-namespace.js
var require_http_namespace = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicediscovery/lib/http-namespace.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.HttpNamespace = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var namespace_1 = require_namespace();
    var service_1 = require_service2();
    var servicediscovery_generated_1 = require_servicediscovery_generated();
    var core_1 = require_core2();
    var HttpNamespace = class _HttpNamespace extends core_1.Resource {
      static fromHttpNamespaceAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicediscovery_HttpNamespaceAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromHttpNamespaceAttributes), error;
        }
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.namespaceName = attrs.namespaceName, this.namespaceId = attrs.namespaceId, this.namespaceArn = attrs.namespaceArn, this.type = namespace_1.NamespaceType.HTTP;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicediscovery_HttpNamespaceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _HttpNamespace), error;
        }
        const ns = new servicediscovery_generated_1.CfnHttpNamespace(this, "Resource", { name: props.name, description: props.description });
        this.namespaceName = props.name, this.namespaceId = ns.attrId, this.namespaceArn = ns.attrArn, this.type = namespace_1.NamespaceType.HTTP;
      }
      get httpNamespaceArn() {
        return this.namespaceArn;
      }
      get httpNamespaceName() {
        return this.namespaceName;
      }
      get httpNamespaceId() {
        return this.namespaceId;
      }
      createService(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicediscovery_BaseServiceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.createService), error;
        }
        return new service_1.Service(this, id, { namespace: this, ...props });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, HttpNamespace[_a] = { fqn: "aws-cdk-lib.aws_servicediscovery.HttpNamespace", version: "2.80.0" }, exports2.HttpNamespace = HttpNamespace;
  }
});

// node_modules/aws-cdk-lib/aws-servicediscovery/lib/private-dns-namespace.js
var require_private_dns_namespace = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicediscovery/lib/private-dns-namespace.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PrivateDnsNamespace = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var namespace_1 = require_namespace();
    var service_1 = require_service2();
    var servicediscovery_generated_1 = require_servicediscovery_generated();
    var core_1 = require_core2();
    var PrivateDnsNamespace = class _PrivateDnsNamespace extends core_1.Resource {
      static fromPrivateDnsNamespaceAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicediscovery_PrivateDnsNamespaceAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromPrivateDnsNamespaceAttributes), error;
        }
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.namespaceName = attrs.namespaceName, this.namespaceId = attrs.namespaceId, this.namespaceArn = attrs.namespaceArn, this.type = namespace_1.NamespaceType.DNS_PRIVATE;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicediscovery_PrivateDnsNamespaceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _PrivateDnsNamespace), error;
        }
        if (props.vpc === void 0)
          throw new Error("VPC must be specified for PrivateDNSNamespaces");
        const ns = new servicediscovery_generated_1.CfnPrivateDnsNamespace(this, "Resource", { name: props.name, description: props.description, vpc: props.vpc.vpcId });
        this.namespaceName = props.name, this.namespaceId = ns.attrId, this.namespaceArn = ns.attrArn, this.namespaceHostedZoneId = ns.attrHostedZoneId, this.type = namespace_1.NamespaceType.DNS_PRIVATE;
      }
      get privateDnsNamespaceArn() {
        return this.namespaceArn;
      }
      get privateDnsNamespaceName() {
        return this.namespaceName;
      }
      get privateDnsNamespaceId() {
        return this.namespaceId;
      }
      createService(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicediscovery_DnsServiceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.createService), error;
        }
        return new service_1.Service(this, id, { namespace: this, ...props });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, PrivateDnsNamespace[_a] = { fqn: "aws-cdk-lib.aws_servicediscovery.PrivateDnsNamespace", version: "2.80.0" }, exports2.PrivateDnsNamespace = PrivateDnsNamespace;
  }
});

// node_modules/aws-cdk-lib/aws-servicediscovery/lib/public-dns-namespace.js
var require_public_dns_namespace = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicediscovery/lib/public-dns-namespace.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PublicDnsNamespace = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var namespace_1 = require_namespace();
    var service_1 = require_service2();
    var servicediscovery_generated_1 = require_servicediscovery_generated();
    var core_1 = require_core2();
    var PublicDnsNamespace = class _PublicDnsNamespace extends core_1.Resource {
      static fromPublicDnsNamespaceAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicediscovery_PublicDnsNamespaceAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromPublicDnsNamespaceAttributes), error;
        }
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.namespaceName = attrs.namespaceName, this.namespaceId = attrs.namespaceId, this.namespaceArn = attrs.namespaceArn, this.type = namespace_1.NamespaceType.DNS_PUBLIC;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicediscovery_PublicDnsNamespaceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _PublicDnsNamespace), error;
        }
        const ns = new servicediscovery_generated_1.CfnPublicDnsNamespace(this, "Resource", { name: props.name, description: props.description });
        this.namespaceName = props.name, this.namespaceId = ns.attrId, this.namespaceArn = ns.attrArn, this.namespaceHostedZoneId = ns.attrHostedZoneId, this.type = namespace_1.NamespaceType.DNS_PUBLIC;
      }
      get publicDnsNamespaceArn() {
        return this.namespaceArn;
      }
      get publicDnsNamespaceName() {
        return this.namespaceName;
      }
      get publicDnsNamespaceId() {
        return this.namespaceId;
      }
      createService(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicediscovery_DnsServiceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.createService), error;
        }
        return new service_1.Service(this, id, { namespace: this, ...props });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, PublicDnsNamespace[_a] = { fqn: "aws-cdk-lib.aws_servicediscovery.PublicDnsNamespace", version: "2.80.0" }, exports2.PublicDnsNamespace = PublicDnsNamespace;
  }
});

// node_modules/aws-cdk-lib/aws-servicediscovery/lib/index.js
var require_lib79 = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicediscovery/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_instance3(), exports2), __exportStar(require_alias_target_instance(), exports2), __exportStar(require_cname_instance(), exports2), __exportStar(require_ip_instance(), exports2), __exportStar(require_non_ip_instance(), exports2), __exportStar(require_namespace(), exports2), __exportStar(require_http_namespace(), exports2), __exportStar(require_private_dns_namespace(), exports2), __exportStar(require_public_dns_namespace(), exports2), __exportStar(require_service2(), exports2), __exportStar(require_servicediscovery_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-servicediscovery/index.js
var require_aws_servicediscovery = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicediscovery/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib79(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/base/_imported-task-definition.js
var require_imported_task_definition = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/base/_imported-task-definition.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ImportedTaskDefinition = void 0;
    var task_definition_1 = require_task_definition();
    var core_1 = require_core2();
    var ImportedTaskDefinition = class extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id), this.executionRole = void 0, this.compatibility = props.compatibility ?? task_definition_1.Compatibility.EC2_AND_FARGATE, this.taskDefinitionArn = props.taskDefinitionArn, this.executionRole = props.executionRole, this._taskRole = props.taskRole, this._networkMode = props.networkMode;
      }
      get networkMode() {
        if (this._networkMode == null)
          throw new Error("This operation requires the networkMode in ImportedTaskDefinition to be defined. Add the 'networkMode' in ImportedTaskDefinitionProps to instantiate ImportedTaskDefinition");
        return this._networkMode;
      }
      get taskRole() {
        if (this._taskRole == null)
          throw new Error("This operation requires the taskRole in ImportedTaskDefinition to be defined. Add the 'taskRole' in ImportedTaskDefinitionProps to instantiate ImportedTaskDefinition");
        return this._taskRole;
      }
      get isEc2Compatible() {
        return (0, task_definition_1.isEc2Compatible)(this.compatibility);
      }
      get isFargateCompatible() {
        return (0, task_definition_1.isFargateCompatible)(this.compatibility);
      }
      get isExternalCompatible() {
        return (0, task_definition_1.isExternalCompatible)(this.compatibility);
      }
    };
    exports2.ImportedTaskDefinition = ImportedTaskDefinition;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/container-definition.js
var require_container_definition = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/container-definition.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AppProtocol = exports2.Protocol = exports2.ServiceConnect = exports2.PortMap = exports2.ContainerDependencyCondition = exports2.UlimitName = exports2.ContainerDefinition = exports2.Secret = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var task_definition_1 = require_task_definition();
    var cdk = require_core2();
    var Secret = class {
      static fromSsmParameter(parameter) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ssm_IParameter(parameter);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromSsmParameter), error;
        }
        return { arn: parameter.parameterArn, grantRead: (grantee) => parameter.grantRead(grantee) };
      }
      static fromSecretsManager(secret, field) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_ISecret(secret);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromSecretsManager), error;
        }
        return { arn: field ? `${secret.secretArn}:${field}::` : secret.secretArn, hasField: !!field, grantRead: (grantee) => secret.grantRead(grantee) };
      }
      static fromSecretsManagerVersion(secret, versionInfo, field) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_ISecret(secret), jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_SecretVersionInfo(versionInfo);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromSecretsManagerVersion), error;
        }
        return { arn: `${secret.secretArn}:${field ?? ""}:${versionInfo.versionStage ?? ""}:${versionInfo.versionId ?? ""}`, hasField: !!field, grantRead: (grantee) => secret.grantRead(grantee) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Secret[_a] = { fqn: "aws-cdk-lib.aws_ecs.Secret", version: "2.80.0" }, exports2.Secret = Secret;
    var ContainerDefinition = class _ContainerDefinition extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id), this.props = props, this.mountPoints = new Array(), this.portMappings = new Array(), this.volumesFrom = new Array(), this.ulimits = new Array(), this.containerDependencies = new Array(), this.inferenceAcceleratorResources = [], this.links = new Array(), this.secrets = [];
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_ContainerDefinitionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ContainerDefinition), error;
        }
        if (props.memoryLimitMiB !== void 0 && props.memoryReservationMiB !== void 0 && props.memoryLimitMiB < props.memoryReservationMiB)
          throw new Error("MemoryLimitMiB should not be less than MemoryReservationMiB.");
        if (this.essential = props.essential ?? true, this.taskDefinition = props.taskDefinition, this.memoryLimitSpecified = props.memoryLimitMiB !== void 0 || props.memoryReservationMiB !== void 0, this.linuxParameters = props.linuxParameters, this.containerName = props.containerName ?? this.node.id, this.imageConfig = props.image.bind(this, this), this.imageName = this.imageConfig.imageName, this._namedPorts = /* @__PURE__ */ new Map(), props.logging && (this.logDriverConfig = props.logging.bind(this, this)), props.secrets)
          for (const [name, secret] of Object.entries(props.secrets))
            this.addSecret(name, secret);
        if (props.environment ? this.environment = { ...props.environment } : this.environment = {}, props.environmentFiles) {
          this.environmentFiles = [];
          for (const environmentFile of props.environmentFiles)
            this.environmentFiles.push(environmentFile.bind(this));
        }
        props.cpu && (this.cpu = props.cpu), props.taskDefinition._linkContainer(this), props.portMappings && this.addPortMappings(...props.portMappings), props.inferenceAcceleratorResources && this.addInferenceAcceleratorResource(...props.inferenceAcceleratorResources), this.pseudoTerminal = props.pseudoTerminal, props.ulimits && this.addUlimits(...props.ulimits);
      }
      addLink(container, alias) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_ContainerDefinition(container);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addLink), error;
        }
        if (this.taskDefinition.networkMode !== task_definition_1.NetworkMode.BRIDGE)
          throw new Error("You must use network mode Bridge to add container links.");
        alias !== void 0 ? this.links.push(`${container.containerName}:${alias}`) : this.links.push(`${container.containerName}`);
      }
      addMountPoints(...mountPoints) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_MountPoint(mountPoints);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addMountPoints), error;
        }
        this.mountPoints.push(...mountPoints);
      }
      addScratch(scratch) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_ScratchSpace(scratch);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addScratch), error;
        }
        const mountPoint = { containerPath: scratch.containerPath, readOnly: scratch.readOnly, sourceVolume: scratch.name }, volume = { host: { sourcePath: scratch.sourcePath }, name: scratch.name };
        this.taskDefinition.addVolume(volume), this.addMountPoints(mountPoint);
      }
      addPortMappings(...portMappings) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_PortMapping(portMappings);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addPortMappings), error;
        }
        this.portMappings.push(...portMappings.map((pm) => {
          new PortMap(this.taskDefinition.networkMode, pm).validate();
          const serviceConnect = new ServiceConnect(this.taskDefinition.networkMode, pm);
          return serviceConnect.isServiceConnect() && (serviceConnect.validate(), this.setNamedPort(pm)), this.addHostPortIfNeeded(pm);
        }));
      }
      addEnvironment(name, value) {
        this.environment[name] = value;
      }
      addSecret(name, secret) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_Secret(secret);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addSecret), error;
        }
        secret.grantRead(this.taskDefinition.obtainExecutionRole()), this.secrets.push({ name, valueFrom: secret.arn });
      }
      addInferenceAcceleratorResource(...inferenceAcceleratorResources) {
        this.inferenceAcceleratorResources.push(...inferenceAcceleratorResources.map((resource) => {
          for (const inferenceAccelerator of this.taskDefinition.inferenceAccelerators)
            if (resource === inferenceAccelerator.deviceName)
              return resource;
          throw new Error(`Resource value ${resource} in container definition doesn't match any inference accelerator device name in the task definition.`);
        }));
      }
      addUlimits(...ulimits) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_Ulimit(ulimits);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addUlimits), error;
        }
        this.ulimits.push(...ulimits);
      }
      addContainerDependencies(...containerDependencies) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_ContainerDependency(containerDependencies);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addContainerDependencies), error;
        }
        this.containerDependencies.push(...containerDependencies);
      }
      addVolumesFrom(...volumesFrom) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_VolumeFrom(volumesFrom);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addVolumesFrom), error;
        }
        this.volumesFrom.push(...volumesFrom);
      }
      addToExecutionPolicy(statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToExecutionPolicy), error;
        }
        this.taskDefinition.addToExecutionRolePolicy(statement);
      }
      findPortMapping(containerPort, protocol) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_Protocol(protocol);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.findPortMapping), error;
        }
        for (const portMapping of this.portMappings) {
          const p = portMapping.protocol || Protocol.TCP;
          if (portMapping.containerPort === containerPort && p === protocol)
            return portMapping;
        }
      }
      findPortMappingByName(name) {
        return this._namedPorts.get(name);
      }
      setNamedPort(pm) {
        if (pm.name) {
          if (this._namedPorts.has(pm.name))
            throw new Error(`Port mapping name '${pm.name}' already exists on this container`);
          this._namedPorts.set(pm.name, pm);
        }
      }
      addHostPortIfNeeded(pm) {
        const newPM = { ...pm };
        return this.taskDefinition.networkMode !== task_definition_1.NetworkMode.BRIDGE || pm.hostPort !== void 0 || (newPM.hostPort = 0), newPM;
      }
      get referencesSecretJsonField() {
        for (const secret of this.secrets)
          if (secret.valueFrom.endsWith("::"))
            return true;
        return false;
      }
      get ingressPort() {
        if (this.portMappings.length === 0)
          throw new Error(`Container ${this.containerName} hasn't defined any ports. Call addPortMappings().`);
        const defaultPortMapping = this.portMappings[0];
        return defaultPortMapping.hostPort !== void 0 && defaultPortMapping.hostPort !== 0 ? defaultPortMapping.hostPort : this.taskDefinition.networkMode === task_definition_1.NetworkMode.BRIDGE ? 0 : defaultPortMapping.containerPort;
      }
      get containerPort() {
        if (this.portMappings.length === 0)
          throw new Error(`Container ${this.containerName} hasn't defined any ports. Call addPortMappings().`);
        return this.portMappings[0].containerPort;
      }
      renderContainerDefinition(_taskDefinition) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_TaskDefinition(_taskDefinition);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.renderContainerDefinition), error;
        }
        return { command: this.props.command, cpu: this.props.cpu, disableNetworking: this.props.disableNetworking, dependsOn: cdk.Lazy.any({ produce: () => this.containerDependencies.map(renderContainerDependency) }, { omitEmptyArray: true }), dnsSearchDomains: this.props.dnsSearchDomains, dnsServers: this.props.dnsServers, dockerLabels: this.props.dockerLabels, dockerSecurityOptions: this.props.dockerSecurityOptions, entryPoint: this.props.entryPoint, essential: this.essential, hostname: this.props.hostname, image: this.imageConfig.imageName, memory: this.props.memoryLimitMiB, memoryReservation: this.props.memoryReservationMiB, mountPoints: cdk.Lazy.any({ produce: () => this.mountPoints.map(renderMountPoint) }, { omitEmptyArray: true }), name: this.containerName, portMappings: cdk.Lazy.any({ produce: () => this.portMappings.map(renderPortMapping) }, { omitEmptyArray: true }), privileged: this.props.privileged, pseudoTerminal: this.props.pseudoTerminal, readonlyRootFilesystem: this.props.readonlyRootFilesystem, repositoryCredentials: this.imageConfig.repositoryCredentials, startTimeout: this.props.startTimeout && this.props.startTimeout.toSeconds(), stopTimeout: this.props.stopTimeout && this.props.stopTimeout.toSeconds(), ulimits: cdk.Lazy.any({ produce: () => this.ulimits.map(renderUlimit) }, { omitEmptyArray: true }), user: this.props.user, volumesFrom: cdk.Lazy.any({ produce: () => this.volumesFrom.map(renderVolumeFrom) }, { omitEmptyArray: true }), workingDirectory: this.props.workingDirectory, logConfiguration: this.logDriverConfig, environment: this.environment && Object.keys(this.environment).length ? renderKV(this.environment, "name", "value") : void 0, environmentFiles: this.environmentFiles && renderEnvironmentFiles(cdk.Stack.of(this).partition, this.environmentFiles), secrets: this.secrets.length ? this.secrets : void 0, extraHosts: this.props.extraHosts && renderKV(this.props.extraHosts, "hostname", "ipAddress"), healthCheck: this.props.healthCheck && renderHealthCheck(this.props.healthCheck), links: cdk.Lazy.list({ produce: () => this.links }, { omitEmpty: true }), linuxParameters: this.linuxParameters && this.linuxParameters.renderLinuxParameters(), resourceRequirements: !this.props.gpuCount && this.inferenceAcceleratorResources.length == 0 ? void 0 : renderResourceRequirements(this.props.gpuCount, this.inferenceAcceleratorResources), systemControls: this.props.systemControls && renderSystemControls(this.props.systemControls) };
      }
    };
    _b = JSII_RTTI_SYMBOL_1, ContainerDefinition[_b] = { fqn: "aws-cdk-lib.aws_ecs.ContainerDefinition", version: "2.80.0" }, exports2.ContainerDefinition = ContainerDefinition;
    function renderKV(env, keyName, valueName) {
      const ret = [];
      for (const [key, value] of Object.entries(env))
        ret.push({ [keyName]: key, [valueName]: value });
      return ret;
    }
    function renderEnvironmentFiles(partition, environmentFiles) {
      const ret = [];
      for (const environmentFile of environmentFiles) {
        const s3Location = environmentFile.s3Location;
        if (!s3Location)
          throw Error("Environment file must specify an S3 location");
        ret.push({ type: environmentFile.fileType, value: `arn:${partition}:s3:::${s3Location.bucketName}/${s3Location.objectKey}` });
      }
      return ret;
    }
    function renderHealthCheck(hc) {
      if (hc.interval?.toSeconds() !== void 0 && (5 > hc.interval?.toSeconds() || hc.interval?.toSeconds() > 300))
        throw new Error("Interval must be between 5 seconds and 300 seconds.");
      if (hc.timeout?.toSeconds() !== void 0 && (2 > hc.timeout?.toSeconds() || hc.timeout?.toSeconds() > 120))
        throw new Error("Timeout must be between 2 seconds and 120 seconds.");
      if (hc.interval?.toSeconds() !== void 0 && hc.timeout?.toSeconds() !== void 0 && hc.interval?.toSeconds() < hc.timeout?.toSeconds())
        throw new Error("Health check interval should be longer than timeout.");
      return { command: getHealthCheckCommand(hc), interval: hc.interval?.toSeconds() ?? 30, retries: hc.retries ?? 3, startPeriod: hc.startPeriod?.toSeconds(), timeout: hc.timeout?.toSeconds() ?? 5 };
    }
    function getHealthCheckCommand(hc) {
      const cmd = hc.command, hcCommand = new Array();
      if (cmd.length === 0)
        throw new Error("At least one argument must be supplied for health check command.");
      return cmd.length === 1 ? (hcCommand.push("CMD-SHELL", cmd[0]), hcCommand) : (cmd[0] !== "CMD" && cmd[0] !== "CMD-SHELL" && hcCommand.push("CMD"), hcCommand.concat(cmd));
    }
    function renderResourceRequirements(gpuCount = 0, inferenceAcceleratorResources = []) {
      const ret = [];
      for (const resource of inferenceAcceleratorResources)
        ret.push({ type: "InferenceAccelerator", value: resource });
      return gpuCount > 0 && ret.push({ type: "GPU", value: gpuCount.toString() }), ret;
    }
    var UlimitName;
    (function(UlimitName2) {
      UlimitName2.CORE = "core", UlimitName2.CPU = "cpu", UlimitName2.DATA = "data", UlimitName2.FSIZE = "fsize", UlimitName2.LOCKS = "locks", UlimitName2.MEMLOCK = "memlock", UlimitName2.MSGQUEUE = "msgqueue", UlimitName2.NICE = "nice", UlimitName2.NOFILE = "nofile", UlimitName2.NPROC = "nproc", UlimitName2.RSS = "rss", UlimitName2.RTPRIO = "rtprio", UlimitName2.RTTIME = "rttime", UlimitName2.SIGPENDING = "sigpending", UlimitName2.STACK = "stack";
    })(UlimitName = exports2.UlimitName || (exports2.UlimitName = {}));
    function renderUlimit(ulimit) {
      return { name: ulimit.name, softLimit: ulimit.softLimit, hardLimit: ulimit.hardLimit };
    }
    var ContainerDependencyCondition;
    (function(ContainerDependencyCondition2) {
      ContainerDependencyCondition2.START = "START", ContainerDependencyCondition2.COMPLETE = "COMPLETE", ContainerDependencyCondition2.SUCCESS = "SUCCESS", ContainerDependencyCondition2.HEALTHY = "HEALTHY";
    })(ContainerDependencyCondition = exports2.ContainerDependencyCondition || (exports2.ContainerDependencyCondition = {}));
    function renderContainerDependency(containerDependency) {
      return { containerName: containerDependency.container.containerName, condition: containerDependency.condition || ContainerDependencyCondition.HEALTHY };
    }
    var PortMap = class _PortMap {
      constructor(networkmode, pm) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_NetworkMode(networkmode), jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_PortMapping(pm);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _PortMap), error;
        }
        this.networkmode = networkmode, this.portmapping = pm;
      }
      validate() {
        if (!this.isvalidPortName())
          throw new Error("Port mapping name cannot be an empty string.");
        if (!this.isValidPorts()) {
          const pm = this.portmapping;
          throw new Error(`Host port (${pm.hostPort}) must be left out or equal to container port ${pm.containerPort} for network mode ${this.networkmode}`);
        }
      }
      isvalidPortName() {
        return this.portmapping.name !== "";
      }
      isValidPorts() {
        const isAwsVpcMode = this.networkmode == task_definition_1.NetworkMode.AWS_VPC, isHostMode = this.networkmode == task_definition_1.NetworkMode.HOST;
        if (!isAwsVpcMode && !isHostMode)
          return true;
        const hostPort = this.portmapping.hostPort;
        return !(this.portmapping.containerPort !== hostPort && hostPort !== void 0);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, PortMap[_c] = { fqn: "aws-cdk-lib.aws_ecs.PortMap", version: "2.80.0" }, exports2.PortMap = PortMap;
    var ServiceConnect = class _ServiceConnect {
      constructor(networkmode, pm) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_NetworkMode(networkmode), jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_PortMapping(pm);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ServiceConnect), error;
        }
        this.portmapping = pm, this.networkmode = networkmode;
      }
      isServiceConnect() {
        const hasPortname = this.portmapping.name, hasAppProtcol = this.portmapping.appProtocol;
        return !!(hasPortname || hasAppProtcol);
      }
      validate() {
        if (!this.isValidNetworkmode())
          throw new Error(`Service connect related port mapping fields 'name' and 'appProtocol' are not supported for network mode ${this.networkmode}`);
        if (!this.isValidPortName())
          throw new Error("Service connect-related port mapping field 'appProtocol' cannot be set without 'name'");
      }
      isValidNetworkmode() {
        const isAwsVpcMode = this.networkmode == task_definition_1.NetworkMode.AWS_VPC, isBridgeMode = this.networkmode == task_definition_1.NetworkMode.BRIDGE;
        return !!(isAwsVpcMode || isBridgeMode);
      }
      isValidPortName() {
        return !!this.portmapping.name;
      }
    };
    _d = JSII_RTTI_SYMBOL_1, ServiceConnect[_d] = { fqn: "aws-cdk-lib.aws_ecs.ServiceConnect", version: "2.80.0" }, exports2.ServiceConnect = ServiceConnect;
    var Protocol;
    (function(Protocol2) {
      Protocol2.TCP = "tcp", Protocol2.UDP = "udp";
    })(Protocol = exports2.Protocol || (exports2.Protocol = {}));
    var AppProtocol = class {
      constructor(value) {
        this.value = value;
      }
    };
    _e = JSII_RTTI_SYMBOL_1, AppProtocol[_e] = { fqn: "aws-cdk-lib.aws_ecs.AppProtocol", version: "2.80.0" }, AppProtocol.http = new AppProtocol("http"), AppProtocol.http2 = new AppProtocol("http2"), AppProtocol.grpc = new AppProtocol("grpc"), exports2.AppProtocol = AppProtocol;
    function renderPortMapping(pm) {
      return { containerPort: pm.containerPort, hostPort: pm.hostPort, protocol: pm.protocol || Protocol.TCP, appProtocol: pm.appProtocol?.value, name: pm.name ? pm.name : void 0 };
    }
    function renderMountPoint(mp) {
      return { containerPath: mp.containerPath, readOnly: mp.readOnly, sourceVolume: mp.sourceVolume };
    }
    function renderVolumeFrom(vf) {
      return { sourceContainer: vf.sourceContainer, readOnly: vf.readOnly };
    }
    function renderSystemControls(systemControls) {
      return systemControls.map((sc) => ({ namespace: sc.namespace, value: sc.value }));
    }
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/ecs.generated.js
var require_ecs_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/ecs.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnTaskSet = exports2.CfnTaskDefinition = exports2.CfnService = exports2.CfnPrimaryTaskSet = exports2.CfnClusterCapacityProviderAssociations = exports2.CfnCluster = exports2.CfnCapacityProvider = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnCapacityProviderPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoScalingGroupProvider", cdk.requiredValidator)(properties.autoScalingGroupProvider)), errors.collect(cdk.propertyValidator("autoScalingGroupProvider", CfnCapacityProvider_AutoScalingGroupProviderPropertyValidator)(properties.autoScalingGroupProvider)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnCapacityProviderProps"');
    }
    function cfnCapacityProviderPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCapacityProviderPropsValidator(properties).assertSuccess(), { AutoScalingGroupProvider: cfnCapacityProviderAutoScalingGroupProviderPropertyToCloudFormation(properties.autoScalingGroupProvider), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnCapacityProviderPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("autoScalingGroupProvider", "AutoScalingGroupProvider", CfnCapacityProviderAutoScalingGroupProviderPropertyFromCloudFormation(properties.AutoScalingGroupProvider)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCapacityProvider = class _CfnCapacityProvider extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCapacityProviderPropsFromCloudFormation(resourceProperties), ret = new _CfnCapacityProvider(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCapacityProvider.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_CfnCapacityProviderProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCapacityProvider), error;
        }
        cdk.requireProperty(props, "autoScalingGroupProvider", this), this.autoScalingGroupProvider = props.autoScalingGroupProvider, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ECS::CapacityProvider", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCapacityProvider.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { autoScalingGroupProvider: this.autoScalingGroupProvider, name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnCapacityProviderPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnCapacityProvider[_a] = { fqn: "aws-cdk-lib.aws_ecs.CfnCapacityProvider", version: "2.80.0" }, CfnCapacityProvider.CFN_RESOURCE_TYPE_NAME = "AWS::ECS::CapacityProvider", exports2.CfnCapacityProvider = CfnCapacityProvider;
    function CfnCapacityProvider_AutoScalingGroupProviderPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoScalingGroupArn", cdk.requiredValidator)(properties.autoScalingGroupArn)), errors.collect(cdk.propertyValidator("autoScalingGroupArn", cdk.validateString)(properties.autoScalingGroupArn)), errors.collect(cdk.propertyValidator("managedScaling", CfnCapacityProvider_ManagedScalingPropertyValidator)(properties.managedScaling)), errors.collect(cdk.propertyValidator("managedTerminationProtection", cdk.validateString)(properties.managedTerminationProtection)), errors.wrap('supplied properties not correct for "AutoScalingGroupProviderProperty"');
    }
    function cfnCapacityProviderAutoScalingGroupProviderPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCapacityProvider_AutoScalingGroupProviderPropertyValidator(properties).assertSuccess(), { AutoScalingGroupArn: cdk.stringToCloudFormation(properties.autoScalingGroupArn), ManagedScaling: cfnCapacityProviderManagedScalingPropertyToCloudFormation(properties.managedScaling), ManagedTerminationProtection: cdk.stringToCloudFormation(properties.managedTerminationProtection) }) : properties;
    }
    function CfnCapacityProviderAutoScalingGroupProviderPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("autoScalingGroupArn", "AutoScalingGroupArn", cfn_parse.FromCloudFormation.getString(properties.AutoScalingGroupArn)), ret.addPropertyResult("managedScaling", "ManagedScaling", properties.ManagedScaling != null ? CfnCapacityProviderManagedScalingPropertyFromCloudFormation(properties.ManagedScaling) : void 0), ret.addPropertyResult("managedTerminationProtection", "ManagedTerminationProtection", properties.ManagedTerminationProtection != null ? cfn_parse.FromCloudFormation.getString(properties.ManagedTerminationProtection) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCapacityProvider_ManagedScalingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceWarmupPeriod", cdk.validateNumber)(properties.instanceWarmupPeriod)), errors.collect(cdk.propertyValidator("maximumScalingStepSize", cdk.validateNumber)(properties.maximumScalingStepSize)), errors.collect(cdk.propertyValidator("minimumScalingStepSize", cdk.validateNumber)(properties.minimumScalingStepSize)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.collect(cdk.propertyValidator("targetCapacity", cdk.validateNumber)(properties.targetCapacity)), errors.wrap('supplied properties not correct for "ManagedScalingProperty"');
    }
    function cfnCapacityProviderManagedScalingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCapacityProvider_ManagedScalingPropertyValidator(properties).assertSuccess(), { InstanceWarmupPeriod: cdk.numberToCloudFormation(properties.instanceWarmupPeriod), MaximumScalingStepSize: cdk.numberToCloudFormation(properties.maximumScalingStepSize), MinimumScalingStepSize: cdk.numberToCloudFormation(properties.minimumScalingStepSize), Status: cdk.stringToCloudFormation(properties.status), TargetCapacity: cdk.numberToCloudFormation(properties.targetCapacity) }) : properties;
    }
    function CfnCapacityProviderManagedScalingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceWarmupPeriod", "InstanceWarmupPeriod", properties.InstanceWarmupPeriod != null ? cfn_parse.FromCloudFormation.getNumber(properties.InstanceWarmupPeriod) : void 0), ret.addPropertyResult("maximumScalingStepSize", "MaximumScalingStepSize", properties.MaximumScalingStepSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumScalingStepSize) : void 0), ret.addPropertyResult("minimumScalingStepSize", "MinimumScalingStepSize", properties.MinimumScalingStepSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinimumScalingStepSize) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addPropertyResult("targetCapacity", "TargetCapacity", properties.TargetCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.TargetCapacity) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnClusterPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("capacityProviders", cdk.listValidator(cdk.validateString))(properties.capacityProviders)), errors.collect(cdk.propertyValidator("clusterName", cdk.validateString)(properties.clusterName)), errors.collect(cdk.propertyValidator("clusterSettings", cdk.listValidator(CfnCluster_ClusterSettingsPropertyValidator))(properties.clusterSettings)), errors.collect(cdk.propertyValidator("configuration", CfnCluster_ClusterConfigurationPropertyValidator)(properties.configuration)), errors.collect(cdk.propertyValidator("defaultCapacityProviderStrategy", cdk.listValidator(CfnCluster_CapacityProviderStrategyItemPropertyValidator))(properties.defaultCapacityProviderStrategy)), errors.collect(cdk.propertyValidator("serviceConnectDefaults", CfnCluster_ServiceConnectDefaultsPropertyValidator)(properties.serviceConnectDefaults)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnClusterProps"');
    }
    function cfnClusterPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClusterPropsValidator(properties).assertSuccess(), { CapacityProviders: cdk.listMapper(cdk.stringToCloudFormation)(properties.capacityProviders), ClusterName: cdk.stringToCloudFormation(properties.clusterName), ClusterSettings: cdk.listMapper(cfnClusterClusterSettingsPropertyToCloudFormation)(properties.clusterSettings), Configuration: cfnClusterClusterConfigurationPropertyToCloudFormation(properties.configuration), DefaultCapacityProviderStrategy: cdk.listMapper(cfnClusterCapacityProviderStrategyItemPropertyToCloudFormation)(properties.defaultCapacityProviderStrategy), ServiceConnectDefaults: cfnClusterServiceConnectDefaultsPropertyToCloudFormation(properties.serviceConnectDefaults), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnClusterPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("capacityProviders", "CapacityProviders", properties.CapacityProviders != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CapacityProviders) : void 0), ret.addPropertyResult("clusterName", "ClusterName", properties.ClusterName != null ? cfn_parse.FromCloudFormation.getString(properties.ClusterName) : void 0), ret.addPropertyResult("clusterSettings", "ClusterSettings", properties.ClusterSettings != null ? cfn_parse.FromCloudFormation.getArray(CfnClusterClusterSettingsPropertyFromCloudFormation)(properties.ClusterSettings) : void 0), ret.addPropertyResult("configuration", "Configuration", properties.Configuration != null ? CfnClusterClusterConfigurationPropertyFromCloudFormation(properties.Configuration) : void 0), ret.addPropertyResult("defaultCapacityProviderStrategy", "DefaultCapacityProviderStrategy", properties.DefaultCapacityProviderStrategy != null ? cfn_parse.FromCloudFormation.getArray(CfnClusterCapacityProviderStrategyItemPropertyFromCloudFormation)(properties.DefaultCapacityProviderStrategy) : void 0), ret.addPropertyResult("serviceConnectDefaults", "ServiceConnectDefaults", properties.ServiceConnectDefaults != null ? CfnClusterServiceConnectDefaultsPropertyFromCloudFormation(properties.ServiceConnectDefaults) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCluster = class _CfnCluster extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnClusterPropsFromCloudFormation(resourceProperties), ret = new _CfnCluster(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnCluster.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_CfnClusterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCluster), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.capacityProviders = props.capacityProviders, this.clusterName = props.clusterName, this.clusterSettings = props.clusterSettings, this.configuration = props.configuration, this.defaultCapacityProviderStrategy = props.defaultCapacityProviderStrategy, this.serviceConnectDefaults = props.serviceConnectDefaults, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ECS::Cluster", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCluster.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { capacityProviders: this.capacityProviders, clusterName: this.clusterName, clusterSettings: this.clusterSettings, configuration: this.configuration, defaultCapacityProviderStrategy: this.defaultCapacityProviderStrategy, serviceConnectDefaults: this.serviceConnectDefaults, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnClusterPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnCluster[_b] = { fqn: "aws-cdk-lib.aws_ecs.CfnCluster", version: "2.80.0" }, CfnCluster.CFN_RESOURCE_TYPE_NAME = "AWS::ECS::Cluster", exports2.CfnCluster = CfnCluster;
    function CfnCluster_CapacityProviderStrategyItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("base", cdk.validateNumber)(properties.base)), errors.collect(cdk.propertyValidator("capacityProvider", cdk.validateString)(properties.capacityProvider)), errors.collect(cdk.propertyValidator("weight", cdk.validateNumber)(properties.weight)), errors.wrap('supplied properties not correct for "CapacityProviderStrategyItemProperty"');
    }
    function cfnClusterCapacityProviderStrategyItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_CapacityProviderStrategyItemPropertyValidator(properties).assertSuccess(), { Base: cdk.numberToCloudFormation(properties.base), CapacityProvider: cdk.stringToCloudFormation(properties.capacityProvider), Weight: cdk.numberToCloudFormation(properties.weight) }) : properties;
    }
    function CfnClusterCapacityProviderStrategyItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("base", "Base", properties.Base != null ? cfn_parse.FromCloudFormation.getNumber(properties.Base) : void 0), ret.addPropertyResult("capacityProvider", "CapacityProvider", properties.CapacityProvider != null ? cfn_parse.FromCloudFormation.getString(properties.CapacityProvider) : void 0), ret.addPropertyResult("weight", "Weight", properties.Weight != null ? cfn_parse.FromCloudFormation.getNumber(properties.Weight) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_ClusterConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("executeCommandConfiguration", CfnCluster_ExecuteCommandConfigurationPropertyValidator)(properties.executeCommandConfiguration)), errors.wrap('supplied properties not correct for "ClusterConfigurationProperty"');
    }
    function cfnClusterClusterConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_ClusterConfigurationPropertyValidator(properties).assertSuccess(), { ExecuteCommandConfiguration: cfnClusterExecuteCommandConfigurationPropertyToCloudFormation(properties.executeCommandConfiguration) }) : properties;
    }
    function CfnClusterClusterConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("executeCommandConfiguration", "ExecuteCommandConfiguration", properties.ExecuteCommandConfiguration != null ? CfnClusterExecuteCommandConfigurationPropertyFromCloudFormation(properties.ExecuteCommandConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_ClusterSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "ClusterSettingsProperty"');
    }
    function cfnClusterClusterSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_ClusterSettingsPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnClusterClusterSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_ExecuteCommandConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("logConfiguration", CfnCluster_ExecuteCommandLogConfigurationPropertyValidator)(properties.logConfiguration)), errors.collect(cdk.propertyValidator("logging", cdk.validateString)(properties.logging)), errors.wrap('supplied properties not correct for "ExecuteCommandConfigurationProperty"');
    }
    function cfnClusterExecuteCommandConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_ExecuteCommandConfigurationPropertyValidator(properties).assertSuccess(), { KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), LogConfiguration: cfnClusterExecuteCommandLogConfigurationPropertyToCloudFormation(properties.logConfiguration), Logging: cdk.stringToCloudFormation(properties.logging) }) : properties;
    }
    function CfnClusterExecuteCommandConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("logConfiguration", "LogConfiguration", properties.LogConfiguration != null ? CfnClusterExecuteCommandLogConfigurationPropertyFromCloudFormation(properties.LogConfiguration) : void 0), ret.addPropertyResult("logging", "Logging", properties.Logging != null ? cfn_parse.FromCloudFormation.getString(properties.Logging) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_ExecuteCommandLogConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchEncryptionEnabled", cdk.validateBoolean)(properties.cloudWatchEncryptionEnabled)), errors.collect(cdk.propertyValidator("cloudWatchLogGroupName", cdk.validateString)(properties.cloudWatchLogGroupName)), errors.collect(cdk.propertyValidator("s3BucketName", cdk.validateString)(properties.s3BucketName)), errors.collect(cdk.propertyValidator("s3EncryptionEnabled", cdk.validateBoolean)(properties.s3EncryptionEnabled)), errors.collect(cdk.propertyValidator("s3KeyPrefix", cdk.validateString)(properties.s3KeyPrefix)), errors.wrap('supplied properties not correct for "ExecuteCommandLogConfigurationProperty"');
    }
    function cfnClusterExecuteCommandLogConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_ExecuteCommandLogConfigurationPropertyValidator(properties).assertSuccess(), { CloudWatchEncryptionEnabled: cdk.booleanToCloudFormation(properties.cloudWatchEncryptionEnabled), CloudWatchLogGroupName: cdk.stringToCloudFormation(properties.cloudWatchLogGroupName), S3BucketName: cdk.stringToCloudFormation(properties.s3BucketName), S3EncryptionEnabled: cdk.booleanToCloudFormation(properties.s3EncryptionEnabled), S3KeyPrefix: cdk.stringToCloudFormation(properties.s3KeyPrefix) }) : properties;
    }
    function CfnClusterExecuteCommandLogConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchEncryptionEnabled", "CloudWatchEncryptionEnabled", properties.CloudWatchEncryptionEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CloudWatchEncryptionEnabled) : void 0), ret.addPropertyResult("cloudWatchLogGroupName", "CloudWatchLogGroupName", properties.CloudWatchLogGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.CloudWatchLogGroupName) : void 0), ret.addPropertyResult("s3BucketName", "S3BucketName", properties.S3BucketName != null ? cfn_parse.FromCloudFormation.getString(properties.S3BucketName) : void 0), ret.addPropertyResult("s3EncryptionEnabled", "S3EncryptionEnabled", properties.S3EncryptionEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.S3EncryptionEnabled) : void 0), ret.addPropertyResult("s3KeyPrefix", "S3KeyPrefix", properties.S3KeyPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.S3KeyPrefix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_ServiceConnectDefaultsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("namespace", cdk.validateString)(properties.namespace)), errors.wrap('supplied properties not correct for "ServiceConnectDefaultsProperty"');
    }
    function cfnClusterServiceConnectDefaultsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_ServiceConnectDefaultsPropertyValidator(properties).assertSuccess(), { Namespace: cdk.stringToCloudFormation(properties.namespace) }) : properties;
    }
    function CfnClusterServiceConnectDefaultsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("namespace", "Namespace", properties.Namespace != null ? cfn_parse.FromCloudFormation.getString(properties.Namespace) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnClusterCapacityProviderAssociationsPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("capacityProviders", cdk.requiredValidator)(properties.capacityProviders)), errors.collect(cdk.propertyValidator("capacityProviders", cdk.listValidator(cdk.validateString))(properties.capacityProviders)), errors.collect(cdk.propertyValidator("cluster", cdk.requiredValidator)(properties.cluster)), errors.collect(cdk.propertyValidator("cluster", cdk.validateString)(properties.cluster)), errors.collect(cdk.propertyValidator("defaultCapacityProviderStrategy", cdk.requiredValidator)(properties.defaultCapacityProviderStrategy)), errors.collect(cdk.propertyValidator("defaultCapacityProviderStrategy", cdk.listValidator(CfnClusterCapacityProviderAssociations_CapacityProviderStrategyPropertyValidator))(properties.defaultCapacityProviderStrategy)), errors.wrap('supplied properties not correct for "CfnClusterCapacityProviderAssociationsProps"');
    }
    function cfnClusterCapacityProviderAssociationsPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClusterCapacityProviderAssociationsPropsValidator(properties).assertSuccess(), { CapacityProviders: cdk.listMapper(cdk.stringToCloudFormation)(properties.capacityProviders), Cluster: cdk.stringToCloudFormation(properties.cluster), DefaultCapacityProviderStrategy: cdk.listMapper(cfnClusterCapacityProviderAssociationsCapacityProviderStrategyPropertyToCloudFormation)(properties.defaultCapacityProviderStrategy) }) : properties;
    }
    function CfnClusterCapacityProviderAssociationsPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("capacityProviders", "CapacityProviders", cfn_parse.FromCloudFormation.getStringArray(properties.CapacityProviders)), ret.addPropertyResult("cluster", "Cluster", cfn_parse.FromCloudFormation.getString(properties.Cluster)), ret.addPropertyResult("defaultCapacityProviderStrategy", "DefaultCapacityProviderStrategy", cfn_parse.FromCloudFormation.getArray(CfnClusterCapacityProviderAssociationsCapacityProviderStrategyPropertyFromCloudFormation)(properties.DefaultCapacityProviderStrategy)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnClusterCapacityProviderAssociations = class _CfnClusterCapacityProviderAssociations extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnClusterCapacityProviderAssociationsPropsFromCloudFormation(resourceProperties), ret = new _CfnClusterCapacityProviderAssociations(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnClusterCapacityProviderAssociations.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_CfnClusterCapacityProviderAssociationsProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnClusterCapacityProviderAssociations), error;
        }
        cdk.requireProperty(props, "capacityProviders", this), cdk.requireProperty(props, "cluster", this), cdk.requireProperty(props, "defaultCapacityProviderStrategy", this), this.capacityProviders = props.capacityProviders, this.cluster = props.cluster, this.defaultCapacityProviderStrategy = props.defaultCapacityProviderStrategy;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnClusterCapacityProviderAssociations.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { capacityProviders: this.capacityProviders, cluster: this.cluster, defaultCapacityProviderStrategy: this.defaultCapacityProviderStrategy };
      }
      renderProperties(props) {
        return cfnClusterCapacityProviderAssociationsPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnClusterCapacityProviderAssociations[_c] = { fqn: "aws-cdk-lib.aws_ecs.CfnClusterCapacityProviderAssociations", version: "2.80.0" }, CfnClusterCapacityProviderAssociations.CFN_RESOURCE_TYPE_NAME = "AWS::ECS::ClusterCapacityProviderAssociations", exports2.CfnClusterCapacityProviderAssociations = CfnClusterCapacityProviderAssociations;
    function CfnClusterCapacityProviderAssociations_CapacityProviderStrategyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("base", cdk.validateNumber)(properties.base)), errors.collect(cdk.propertyValidator("capacityProvider", cdk.requiredValidator)(properties.capacityProvider)), errors.collect(cdk.propertyValidator("capacityProvider", cdk.validateString)(properties.capacityProvider)), errors.collect(cdk.propertyValidator("weight", cdk.validateNumber)(properties.weight)), errors.wrap('supplied properties not correct for "CapacityProviderStrategyProperty"');
    }
    function cfnClusterCapacityProviderAssociationsCapacityProviderStrategyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClusterCapacityProviderAssociations_CapacityProviderStrategyPropertyValidator(properties).assertSuccess(), { Base: cdk.numberToCloudFormation(properties.base), CapacityProvider: cdk.stringToCloudFormation(properties.capacityProvider), Weight: cdk.numberToCloudFormation(properties.weight) }) : properties;
    }
    function CfnClusterCapacityProviderAssociationsCapacityProviderStrategyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("base", "Base", properties.Base != null ? cfn_parse.FromCloudFormation.getNumber(properties.Base) : void 0), ret.addPropertyResult("capacityProvider", "CapacityProvider", cfn_parse.FromCloudFormation.getString(properties.CapacityProvider)), ret.addPropertyResult("weight", "Weight", properties.Weight != null ? cfn_parse.FromCloudFormation.getNumber(properties.Weight) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPrimaryTaskSetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cluster", cdk.requiredValidator)(properties.cluster)), errors.collect(cdk.propertyValidator("cluster", cdk.validateString)(properties.cluster)), errors.collect(cdk.propertyValidator("service", cdk.requiredValidator)(properties.service)), errors.collect(cdk.propertyValidator("service", cdk.validateString)(properties.service)), errors.collect(cdk.propertyValidator("taskSetId", cdk.requiredValidator)(properties.taskSetId)), errors.collect(cdk.propertyValidator("taskSetId", cdk.validateString)(properties.taskSetId)), errors.wrap('supplied properties not correct for "CfnPrimaryTaskSetProps"');
    }
    function cfnPrimaryTaskSetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPrimaryTaskSetPropsValidator(properties).assertSuccess(), { Cluster: cdk.stringToCloudFormation(properties.cluster), Service: cdk.stringToCloudFormation(properties.service), TaskSetId: cdk.stringToCloudFormation(properties.taskSetId) }) : properties;
    }
    function CfnPrimaryTaskSetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cluster", "Cluster", cfn_parse.FromCloudFormation.getString(properties.Cluster)), ret.addPropertyResult("service", "Service", cfn_parse.FromCloudFormation.getString(properties.Service)), ret.addPropertyResult("taskSetId", "TaskSetId", cfn_parse.FromCloudFormation.getString(properties.TaskSetId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPrimaryTaskSet = class _CfnPrimaryTaskSet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPrimaryTaskSetPropsFromCloudFormation(resourceProperties), ret = new _CfnPrimaryTaskSet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPrimaryTaskSet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_CfnPrimaryTaskSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPrimaryTaskSet), error;
        }
        cdk.requireProperty(props, "cluster", this), cdk.requireProperty(props, "service", this), cdk.requireProperty(props, "taskSetId", this), this.cluster = props.cluster, this.service = props.service, this.taskSetId = props.taskSetId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPrimaryTaskSet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { cluster: this.cluster, service: this.service, taskSetId: this.taskSetId };
      }
      renderProperties(props) {
        return cfnPrimaryTaskSetPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnPrimaryTaskSet[_d] = { fqn: "aws-cdk-lib.aws_ecs.CfnPrimaryTaskSet", version: "2.80.0" }, CfnPrimaryTaskSet.CFN_RESOURCE_TYPE_NAME = "AWS::ECS::PrimaryTaskSet", exports2.CfnPrimaryTaskSet = CfnPrimaryTaskSet;
    function CfnServicePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("capacityProviderStrategy", cdk.listValidator(CfnService_CapacityProviderStrategyItemPropertyValidator))(properties.capacityProviderStrategy)), errors.collect(cdk.propertyValidator("cluster", cdk.validateString)(properties.cluster)), errors.collect(cdk.propertyValidator("deploymentConfiguration", CfnService_DeploymentConfigurationPropertyValidator)(properties.deploymentConfiguration)), errors.collect(cdk.propertyValidator("deploymentController", CfnService_DeploymentControllerPropertyValidator)(properties.deploymentController)), errors.collect(cdk.propertyValidator("desiredCount", cdk.validateNumber)(properties.desiredCount)), errors.collect(cdk.propertyValidator("enableEcsManagedTags", cdk.validateBoolean)(properties.enableEcsManagedTags)), errors.collect(cdk.propertyValidator("enableExecuteCommand", cdk.validateBoolean)(properties.enableExecuteCommand)), errors.collect(cdk.propertyValidator("healthCheckGracePeriodSeconds", cdk.validateNumber)(properties.healthCheckGracePeriodSeconds)), errors.collect(cdk.propertyValidator("launchType", cdk.validateString)(properties.launchType)), errors.collect(cdk.propertyValidator("loadBalancers", cdk.listValidator(CfnService_LoadBalancerPropertyValidator))(properties.loadBalancers)), errors.collect(cdk.propertyValidator("networkConfiguration", CfnService_NetworkConfigurationPropertyValidator)(properties.networkConfiguration)), errors.collect(cdk.propertyValidator("placementConstraints", cdk.listValidator(CfnService_PlacementConstraintPropertyValidator))(properties.placementConstraints)), errors.collect(cdk.propertyValidator("placementStrategies", cdk.listValidator(CfnService_PlacementStrategyPropertyValidator))(properties.placementStrategies)), errors.collect(cdk.propertyValidator("platformVersion", cdk.validateString)(properties.platformVersion)), errors.collect(cdk.propertyValidator("propagateTags", cdk.validateString)(properties.propagateTags)), errors.collect(cdk.propertyValidator("role", cdk.validateString)(properties.role)), errors.collect(cdk.propertyValidator("schedulingStrategy", cdk.validateString)(properties.schedulingStrategy)), errors.collect(cdk.propertyValidator("serviceConnectConfiguration", CfnService_ServiceConnectConfigurationPropertyValidator)(properties.serviceConnectConfiguration)), errors.collect(cdk.propertyValidator("serviceName", cdk.validateString)(properties.serviceName)), errors.collect(cdk.propertyValidator("serviceRegistries", cdk.listValidator(CfnService_ServiceRegistryPropertyValidator))(properties.serviceRegistries)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("taskDefinition", cdk.validateString)(properties.taskDefinition)), errors.wrap('supplied properties not correct for "CfnServiceProps"');
    }
    function cfnServicePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnServicePropsValidator(properties).assertSuccess(), { CapacityProviderStrategy: cdk.listMapper(cfnServiceCapacityProviderStrategyItemPropertyToCloudFormation)(properties.capacityProviderStrategy), Cluster: cdk.stringToCloudFormation(properties.cluster), DeploymentConfiguration: cfnServiceDeploymentConfigurationPropertyToCloudFormation(properties.deploymentConfiguration), DeploymentController: cfnServiceDeploymentControllerPropertyToCloudFormation(properties.deploymentController), DesiredCount: cdk.numberToCloudFormation(properties.desiredCount), EnableECSManagedTags: cdk.booleanToCloudFormation(properties.enableEcsManagedTags), EnableExecuteCommand: cdk.booleanToCloudFormation(properties.enableExecuteCommand), HealthCheckGracePeriodSeconds: cdk.numberToCloudFormation(properties.healthCheckGracePeriodSeconds), LaunchType: cdk.stringToCloudFormation(properties.launchType), LoadBalancers: cdk.listMapper(cfnServiceLoadBalancerPropertyToCloudFormation)(properties.loadBalancers), NetworkConfiguration: cfnServiceNetworkConfigurationPropertyToCloudFormation(properties.networkConfiguration), PlacementConstraints: cdk.listMapper(cfnServicePlacementConstraintPropertyToCloudFormation)(properties.placementConstraints), PlacementStrategies: cdk.listMapper(cfnServicePlacementStrategyPropertyToCloudFormation)(properties.placementStrategies), PlatformVersion: cdk.stringToCloudFormation(properties.platformVersion), PropagateTags: cdk.stringToCloudFormation(properties.propagateTags), Role: cdk.stringToCloudFormation(properties.role), SchedulingStrategy: cdk.stringToCloudFormation(properties.schedulingStrategy), ServiceConnectConfiguration: cfnServiceServiceConnectConfigurationPropertyToCloudFormation(properties.serviceConnectConfiguration), ServiceName: cdk.stringToCloudFormation(properties.serviceName), ServiceRegistries: cdk.listMapper(cfnServiceServiceRegistryPropertyToCloudFormation)(properties.serviceRegistries), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TaskDefinition: cdk.stringToCloudFormation(properties.taskDefinition) }) : properties;
    }
    function CfnServicePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("capacityProviderStrategy", "CapacityProviderStrategy", properties.CapacityProviderStrategy != null ? cfn_parse.FromCloudFormation.getArray(CfnServiceCapacityProviderStrategyItemPropertyFromCloudFormation)(properties.CapacityProviderStrategy) : void 0), ret.addPropertyResult("cluster", "Cluster", properties.Cluster != null ? cfn_parse.FromCloudFormation.getString(properties.Cluster) : void 0), ret.addPropertyResult("deploymentConfiguration", "DeploymentConfiguration", properties.DeploymentConfiguration != null ? CfnServiceDeploymentConfigurationPropertyFromCloudFormation(properties.DeploymentConfiguration) : void 0), ret.addPropertyResult("deploymentController", "DeploymentController", properties.DeploymentController != null ? CfnServiceDeploymentControllerPropertyFromCloudFormation(properties.DeploymentController) : void 0), ret.addPropertyResult("desiredCount", "DesiredCount", properties.DesiredCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.DesiredCount) : void 0), ret.addPropertyResult("enableEcsManagedTags", "EnableECSManagedTags", properties.EnableECSManagedTags != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableECSManagedTags) : void 0), ret.addPropertyResult("enableExecuteCommand", "EnableExecuteCommand", properties.EnableExecuteCommand != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableExecuteCommand) : void 0), ret.addPropertyResult("healthCheckGracePeriodSeconds", "HealthCheckGracePeriodSeconds", properties.HealthCheckGracePeriodSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.HealthCheckGracePeriodSeconds) : void 0), ret.addPropertyResult("launchType", "LaunchType", properties.LaunchType != null ? cfn_parse.FromCloudFormation.getString(properties.LaunchType) : void 0), ret.addPropertyResult("loadBalancers", "LoadBalancers", properties.LoadBalancers != null ? cfn_parse.FromCloudFormation.getArray(CfnServiceLoadBalancerPropertyFromCloudFormation)(properties.LoadBalancers) : void 0), ret.addPropertyResult("networkConfiguration", "NetworkConfiguration", properties.NetworkConfiguration != null ? CfnServiceNetworkConfigurationPropertyFromCloudFormation(properties.NetworkConfiguration) : void 0), ret.addPropertyResult("placementConstraints", "PlacementConstraints", properties.PlacementConstraints != null ? cfn_parse.FromCloudFormation.getArray(CfnServicePlacementConstraintPropertyFromCloudFormation)(properties.PlacementConstraints) : void 0), ret.addPropertyResult("placementStrategies", "PlacementStrategies", properties.PlacementStrategies != null ? cfn_parse.FromCloudFormation.getArray(CfnServicePlacementStrategyPropertyFromCloudFormation)(properties.PlacementStrategies) : void 0), ret.addPropertyResult("platformVersion", "PlatformVersion", properties.PlatformVersion != null ? cfn_parse.FromCloudFormation.getString(properties.PlatformVersion) : void 0), ret.addPropertyResult("propagateTags", "PropagateTags", properties.PropagateTags != null ? cfn_parse.FromCloudFormation.getString(properties.PropagateTags) : void 0), ret.addPropertyResult("role", "Role", properties.Role != null ? cfn_parse.FromCloudFormation.getString(properties.Role) : void 0), ret.addPropertyResult("schedulingStrategy", "SchedulingStrategy", properties.SchedulingStrategy != null ? cfn_parse.FromCloudFormation.getString(properties.SchedulingStrategy) : void 0), ret.addPropertyResult("serviceConnectConfiguration", "ServiceConnectConfiguration", properties.ServiceConnectConfiguration != null ? CfnServiceServiceConnectConfigurationPropertyFromCloudFormation(properties.ServiceConnectConfiguration) : void 0), ret.addPropertyResult("serviceName", "ServiceName", properties.ServiceName != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceName) : void 0), ret.addPropertyResult("serviceRegistries", "ServiceRegistries", properties.ServiceRegistries != null ? cfn_parse.FromCloudFormation.getArray(CfnServiceServiceRegistryPropertyFromCloudFormation)(properties.ServiceRegistries) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("taskDefinition", "TaskDefinition", properties.TaskDefinition != null ? cfn_parse.FromCloudFormation.getString(properties.TaskDefinition) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnService = class _CfnService extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnServicePropsFromCloudFormation(resourceProperties), ret = new _CfnService(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnService.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_CfnServiceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnService), error;
        }
        this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.attrServiceArn = cdk.Token.asString(this.getAtt("ServiceArn", cdk.ResolutionTypeHint.STRING)), this.capacityProviderStrategy = props.capacityProviderStrategy, this.cluster = props.cluster, this.deploymentConfiguration = props.deploymentConfiguration, this.deploymentController = props.deploymentController, this.desiredCount = props.desiredCount, this.enableEcsManagedTags = props.enableEcsManagedTags, this.enableExecuteCommand = props.enableExecuteCommand, this.healthCheckGracePeriodSeconds = props.healthCheckGracePeriodSeconds, this.launchType = props.launchType, this.loadBalancers = props.loadBalancers, this.networkConfiguration = props.networkConfiguration, this.placementConstraints = props.placementConstraints, this.placementStrategies = props.placementStrategies, this.platformVersion = props.platformVersion, this.propagateTags = props.propagateTags, this.role = props.role, this.schedulingStrategy = props.schedulingStrategy, this.serviceConnectConfiguration = props.serviceConnectConfiguration, this.serviceName = props.serviceName, this.serviceRegistries = props.serviceRegistries, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ECS::Service", props.tags, { tagPropertyName: "tags" }), this.taskDefinition = props.taskDefinition;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnService.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { capacityProviderStrategy: this.capacityProviderStrategy, cluster: this.cluster, deploymentConfiguration: this.deploymentConfiguration, deploymentController: this.deploymentController, desiredCount: this.desiredCount, enableEcsManagedTags: this.enableEcsManagedTags, enableExecuteCommand: this.enableExecuteCommand, healthCheckGracePeriodSeconds: this.healthCheckGracePeriodSeconds, launchType: this.launchType, loadBalancers: this.loadBalancers, networkConfiguration: this.networkConfiguration, placementConstraints: this.placementConstraints, placementStrategies: this.placementStrategies, platformVersion: this.platformVersion, propagateTags: this.propagateTags, role: this.role, schedulingStrategy: this.schedulingStrategy, serviceConnectConfiguration: this.serviceConnectConfiguration, serviceName: this.serviceName, serviceRegistries: this.serviceRegistries, tags: this.tags.renderTags(), taskDefinition: this.taskDefinition };
      }
      renderProperties(props) {
        return cfnServicePropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnService[_e] = { fqn: "aws-cdk-lib.aws_ecs.CfnService", version: "2.80.0" }, CfnService.CFN_RESOURCE_TYPE_NAME = "AWS::ECS::Service", exports2.CfnService = CfnService;
    function CfnService_AwsVpcConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("assignPublicIp", cdk.validateString)(properties.assignPublicIp)), errors.collect(cdk.propertyValidator("securityGroups", cdk.listValidator(cdk.validateString))(properties.securityGroups)), errors.collect(cdk.propertyValidator("subnets", cdk.requiredValidator)(properties.subnets)), errors.collect(cdk.propertyValidator("subnets", cdk.listValidator(cdk.validateString))(properties.subnets)), errors.wrap('supplied properties not correct for "AwsVpcConfigurationProperty"');
    }
    function cfnServiceAwsVpcConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_AwsVpcConfigurationPropertyValidator(properties).assertSuccess(), { AssignPublicIp: cdk.stringToCloudFormation(properties.assignPublicIp), SecurityGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroups), Subnets: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnets) }) : properties;
    }
    function CfnServiceAwsVpcConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("assignPublicIp", "AssignPublicIp", properties.AssignPublicIp != null ? cfn_parse.FromCloudFormation.getString(properties.AssignPublicIp) : void 0), ret.addPropertyResult("securityGroups", "SecurityGroups", properties.SecurityGroups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroups) : void 0), ret.addPropertyResult("subnets", "Subnets", cfn_parse.FromCloudFormation.getStringArray(properties.Subnets)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_CapacityProviderStrategyItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("base", cdk.validateNumber)(properties.base)), errors.collect(cdk.propertyValidator("capacityProvider", cdk.validateString)(properties.capacityProvider)), errors.collect(cdk.propertyValidator("weight", cdk.validateNumber)(properties.weight)), errors.wrap('supplied properties not correct for "CapacityProviderStrategyItemProperty"');
    }
    function cfnServiceCapacityProviderStrategyItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_CapacityProviderStrategyItemPropertyValidator(properties).assertSuccess(), { Base: cdk.numberToCloudFormation(properties.base), CapacityProvider: cdk.stringToCloudFormation(properties.capacityProvider), Weight: cdk.numberToCloudFormation(properties.weight) }) : properties;
    }
    function CfnServiceCapacityProviderStrategyItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("base", "Base", properties.Base != null ? cfn_parse.FromCloudFormation.getNumber(properties.Base) : void 0), ret.addPropertyResult("capacityProvider", "CapacityProvider", properties.CapacityProvider != null ? cfn_parse.FromCloudFormation.getString(properties.CapacityProvider) : void 0), ret.addPropertyResult("weight", "Weight", properties.Weight != null ? cfn_parse.FromCloudFormation.getNumber(properties.Weight) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_DeploymentAlarmsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alarmNames", cdk.requiredValidator)(properties.alarmNames)), errors.collect(cdk.propertyValidator("alarmNames", cdk.listValidator(cdk.validateString))(properties.alarmNames)), errors.collect(cdk.propertyValidator("enable", cdk.requiredValidator)(properties.enable)), errors.collect(cdk.propertyValidator("enable", cdk.validateBoolean)(properties.enable)), errors.collect(cdk.propertyValidator("rollback", cdk.requiredValidator)(properties.rollback)), errors.collect(cdk.propertyValidator("rollback", cdk.validateBoolean)(properties.rollback)), errors.wrap('supplied properties not correct for "DeploymentAlarmsProperty"');
    }
    function cfnServiceDeploymentAlarmsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_DeploymentAlarmsPropertyValidator(properties).assertSuccess(), { AlarmNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.alarmNames), Enable: cdk.booleanToCloudFormation(properties.enable), Rollback: cdk.booleanToCloudFormation(properties.rollback) }) : properties;
    }
    function CfnServiceDeploymentAlarmsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alarmNames", "AlarmNames", cfn_parse.FromCloudFormation.getStringArray(properties.AlarmNames)), ret.addPropertyResult("enable", "Enable", cfn_parse.FromCloudFormation.getBoolean(properties.Enable)), ret.addPropertyResult("rollback", "Rollback", cfn_parse.FromCloudFormation.getBoolean(properties.Rollback)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_DeploymentCircuitBreakerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enable", cdk.requiredValidator)(properties.enable)), errors.collect(cdk.propertyValidator("enable", cdk.validateBoolean)(properties.enable)), errors.collect(cdk.propertyValidator("rollback", cdk.requiredValidator)(properties.rollback)), errors.collect(cdk.propertyValidator("rollback", cdk.validateBoolean)(properties.rollback)), errors.wrap('supplied properties not correct for "DeploymentCircuitBreakerProperty"');
    }
    function cfnServiceDeploymentCircuitBreakerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_DeploymentCircuitBreakerPropertyValidator(properties).assertSuccess(), { Enable: cdk.booleanToCloudFormation(properties.enable), Rollback: cdk.booleanToCloudFormation(properties.rollback) }) : properties;
    }
    function CfnServiceDeploymentCircuitBreakerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enable", "Enable", cfn_parse.FromCloudFormation.getBoolean(properties.Enable)), ret.addPropertyResult("rollback", "Rollback", cfn_parse.FromCloudFormation.getBoolean(properties.Rollback)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_DeploymentConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alarms", CfnService_DeploymentAlarmsPropertyValidator)(properties.alarms)), errors.collect(cdk.propertyValidator("deploymentCircuitBreaker", CfnService_DeploymentCircuitBreakerPropertyValidator)(properties.deploymentCircuitBreaker)), errors.collect(cdk.propertyValidator("maximumPercent", cdk.validateNumber)(properties.maximumPercent)), errors.collect(cdk.propertyValidator("minimumHealthyPercent", cdk.validateNumber)(properties.minimumHealthyPercent)), errors.wrap('supplied properties not correct for "DeploymentConfigurationProperty"');
    }
    function cfnServiceDeploymentConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_DeploymentConfigurationPropertyValidator(properties).assertSuccess(), { Alarms: cfnServiceDeploymentAlarmsPropertyToCloudFormation(properties.alarms), DeploymentCircuitBreaker: cfnServiceDeploymentCircuitBreakerPropertyToCloudFormation(properties.deploymentCircuitBreaker), MaximumPercent: cdk.numberToCloudFormation(properties.maximumPercent), MinimumHealthyPercent: cdk.numberToCloudFormation(properties.minimumHealthyPercent) }) : properties;
    }
    function CfnServiceDeploymentConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alarms", "Alarms", properties.Alarms != null ? CfnServiceDeploymentAlarmsPropertyFromCloudFormation(properties.Alarms) : void 0), ret.addPropertyResult("deploymentCircuitBreaker", "DeploymentCircuitBreaker", properties.DeploymentCircuitBreaker != null ? CfnServiceDeploymentCircuitBreakerPropertyFromCloudFormation(properties.DeploymentCircuitBreaker) : void 0), ret.addPropertyResult("maximumPercent", "MaximumPercent", properties.MaximumPercent != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumPercent) : void 0), ret.addPropertyResult("minimumHealthyPercent", "MinimumHealthyPercent", properties.MinimumHealthyPercent != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinimumHealthyPercent) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_DeploymentControllerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "DeploymentControllerProperty"');
    }
    function cfnServiceDeploymentControllerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_DeploymentControllerPropertyValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnServiceDeploymentControllerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_LoadBalancerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containerName", cdk.validateString)(properties.containerName)), errors.collect(cdk.propertyValidator("containerPort", cdk.requiredValidator)(properties.containerPort)), errors.collect(cdk.propertyValidator("containerPort", cdk.validateNumber)(properties.containerPort)), errors.collect(cdk.propertyValidator("loadBalancerName", cdk.validateString)(properties.loadBalancerName)), errors.collect(cdk.propertyValidator("targetGroupArn", cdk.validateString)(properties.targetGroupArn)), errors.wrap('supplied properties not correct for "LoadBalancerProperty"');
    }
    function cfnServiceLoadBalancerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_LoadBalancerPropertyValidator(properties).assertSuccess(), { ContainerName: cdk.stringToCloudFormation(properties.containerName), ContainerPort: cdk.numberToCloudFormation(properties.containerPort), LoadBalancerName: cdk.stringToCloudFormation(properties.loadBalancerName), TargetGroupArn: cdk.stringToCloudFormation(properties.targetGroupArn) }) : properties;
    }
    function CfnServiceLoadBalancerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containerName", "ContainerName", properties.ContainerName != null ? cfn_parse.FromCloudFormation.getString(properties.ContainerName) : void 0), ret.addPropertyResult("containerPort", "ContainerPort", cfn_parse.FromCloudFormation.getNumber(properties.ContainerPort)), ret.addPropertyResult("loadBalancerName", "LoadBalancerName", properties.LoadBalancerName != null ? cfn_parse.FromCloudFormation.getString(properties.LoadBalancerName) : void 0), ret.addPropertyResult("targetGroupArn", "TargetGroupArn", properties.TargetGroupArn != null ? cfn_parse.FromCloudFormation.getString(properties.TargetGroupArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_LogConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logDriver", cdk.validateString)(properties.logDriver)), errors.collect(cdk.propertyValidator("options", cdk.hashValidator(cdk.validateString))(properties.options)), errors.collect(cdk.propertyValidator("secretOptions", cdk.listValidator(CfnService_SecretPropertyValidator))(properties.secretOptions)), errors.wrap('supplied properties not correct for "LogConfigurationProperty"');
    }
    function cfnServiceLogConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_LogConfigurationPropertyValidator(properties).assertSuccess(), { LogDriver: cdk.stringToCloudFormation(properties.logDriver), Options: cdk.hashMapper(cdk.stringToCloudFormation)(properties.options), SecretOptions: cdk.listMapper(cfnServiceSecretPropertyToCloudFormation)(properties.secretOptions) }) : properties;
    }
    function CfnServiceLogConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logDriver", "LogDriver", properties.LogDriver != null ? cfn_parse.FromCloudFormation.getString(properties.LogDriver) : void 0), ret.addPropertyResult("options", "Options", properties.Options != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Options) : void 0), ret.addPropertyResult("secretOptions", "SecretOptions", properties.SecretOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnServiceSecretPropertyFromCloudFormation)(properties.SecretOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_NetworkConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("awsvpcConfiguration", CfnService_AwsVpcConfigurationPropertyValidator)(properties.awsvpcConfiguration)), errors.wrap('supplied properties not correct for "NetworkConfigurationProperty"');
    }
    function cfnServiceNetworkConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_NetworkConfigurationPropertyValidator(properties).assertSuccess(), { AwsvpcConfiguration: cfnServiceAwsVpcConfigurationPropertyToCloudFormation(properties.awsvpcConfiguration) }) : properties;
    }
    function CfnServiceNetworkConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("awsvpcConfiguration", "AwsvpcConfiguration", properties.AwsvpcConfiguration != null ? CfnServiceAwsVpcConfigurationPropertyFromCloudFormation(properties.AwsvpcConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_PlacementConstraintPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "PlacementConstraintProperty"');
    }
    function cfnServicePlacementConstraintPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_PlacementConstraintPropertyValidator(properties).assertSuccess(), { Expression: cdk.stringToCloudFormation(properties.expression), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnServicePlacementConstraintPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("expression", "Expression", properties.Expression != null ? cfn_parse.FromCloudFormation.getString(properties.Expression) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_PlacementStrategyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("field", cdk.validateString)(properties.field)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "PlacementStrategyProperty"');
    }
    function cfnServicePlacementStrategyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_PlacementStrategyPropertyValidator(properties).assertSuccess(), { Field: cdk.stringToCloudFormation(properties.field), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnServicePlacementStrategyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("field", "Field", properties.Field != null ? cfn_parse.FromCloudFormation.getString(properties.Field) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_SecretPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("valueFrom", cdk.requiredValidator)(properties.valueFrom)), errors.collect(cdk.propertyValidator("valueFrom", cdk.validateString)(properties.valueFrom)), errors.wrap('supplied properties not correct for "SecretProperty"');
    }
    function cfnServiceSecretPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_SecretPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), ValueFrom: cdk.stringToCloudFormation(properties.valueFrom) }) : properties;
    }
    function CfnServiceSecretPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("valueFrom", "ValueFrom", cfn_parse.FromCloudFormation.getString(properties.ValueFrom)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_ServiceConnectClientAliasPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dnsName", cdk.validateString)(properties.dnsName)), errors.collect(cdk.propertyValidator("port", cdk.requiredValidator)(properties.port)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.wrap('supplied properties not correct for "ServiceConnectClientAliasProperty"');
    }
    function cfnServiceServiceConnectClientAliasPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_ServiceConnectClientAliasPropertyValidator(properties).assertSuccess(), { DnsName: cdk.stringToCloudFormation(properties.dnsName), Port: cdk.numberToCloudFormation(properties.port) }) : properties;
    }
    function CfnServiceServiceConnectClientAliasPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dnsName", "DnsName", properties.DnsName != null ? cfn_parse.FromCloudFormation.getString(properties.DnsName) : void 0), ret.addPropertyResult("port", "Port", cfn_parse.FromCloudFormation.getNumber(properties.Port)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_ServiceConnectConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("logConfiguration", CfnService_LogConfigurationPropertyValidator)(properties.logConfiguration)), errors.collect(cdk.propertyValidator("namespace", cdk.validateString)(properties.namespace)), errors.collect(cdk.propertyValidator("services", cdk.listValidator(CfnService_ServiceConnectServicePropertyValidator))(properties.services)), errors.wrap('supplied properties not correct for "ServiceConnectConfigurationProperty"');
    }
    function cfnServiceServiceConnectConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_ServiceConnectConfigurationPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled), LogConfiguration: cfnServiceLogConfigurationPropertyToCloudFormation(properties.logConfiguration), Namespace: cdk.stringToCloudFormation(properties.namespace), Services: cdk.listMapper(cfnServiceServiceConnectServicePropertyToCloudFormation)(properties.services) }) : properties;
    }
    function CfnServiceServiceConnectConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addPropertyResult("logConfiguration", "LogConfiguration", properties.LogConfiguration != null ? CfnServiceLogConfigurationPropertyFromCloudFormation(properties.LogConfiguration) : void 0), ret.addPropertyResult("namespace", "Namespace", properties.Namespace != null ? cfn_parse.FromCloudFormation.getString(properties.Namespace) : void 0), ret.addPropertyResult("services", "Services", properties.Services != null ? cfn_parse.FromCloudFormation.getArray(CfnServiceServiceConnectServicePropertyFromCloudFormation)(properties.Services) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_ServiceConnectServicePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clientAliases", cdk.listValidator(CfnService_ServiceConnectClientAliasPropertyValidator))(properties.clientAliases)), errors.collect(cdk.propertyValidator("discoveryName", cdk.validateString)(properties.discoveryName)), errors.collect(cdk.propertyValidator("ingressPortOverride", cdk.validateNumber)(properties.ingressPortOverride)), errors.collect(cdk.propertyValidator("portName", cdk.requiredValidator)(properties.portName)), errors.collect(cdk.propertyValidator("portName", cdk.validateString)(properties.portName)), errors.wrap('supplied properties not correct for "ServiceConnectServiceProperty"');
    }
    function cfnServiceServiceConnectServicePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_ServiceConnectServicePropertyValidator(properties).assertSuccess(), { ClientAliases: cdk.listMapper(cfnServiceServiceConnectClientAliasPropertyToCloudFormation)(properties.clientAliases), DiscoveryName: cdk.stringToCloudFormation(properties.discoveryName), IngressPortOverride: cdk.numberToCloudFormation(properties.ingressPortOverride), PortName: cdk.stringToCloudFormation(properties.portName) }) : properties;
    }
    function CfnServiceServiceConnectServicePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clientAliases", "ClientAliases", properties.ClientAliases != null ? cfn_parse.FromCloudFormation.getArray(CfnServiceServiceConnectClientAliasPropertyFromCloudFormation)(properties.ClientAliases) : void 0), ret.addPropertyResult("discoveryName", "DiscoveryName", properties.DiscoveryName != null ? cfn_parse.FromCloudFormation.getString(properties.DiscoveryName) : void 0), ret.addPropertyResult("ingressPortOverride", "IngressPortOverride", properties.IngressPortOverride != null ? cfn_parse.FromCloudFormation.getNumber(properties.IngressPortOverride) : void 0), ret.addPropertyResult("portName", "PortName", cfn_parse.FromCloudFormation.getString(properties.PortName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_ServiceRegistryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containerName", cdk.validateString)(properties.containerName)), errors.collect(cdk.propertyValidator("containerPort", cdk.validateNumber)(properties.containerPort)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("registryArn", cdk.validateString)(properties.registryArn)), errors.wrap('supplied properties not correct for "ServiceRegistryProperty"');
    }
    function cfnServiceServiceRegistryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_ServiceRegistryPropertyValidator(properties).assertSuccess(), { ContainerName: cdk.stringToCloudFormation(properties.containerName), ContainerPort: cdk.numberToCloudFormation(properties.containerPort), Port: cdk.numberToCloudFormation(properties.port), RegistryArn: cdk.stringToCloudFormation(properties.registryArn) }) : properties;
    }
    function CfnServiceServiceRegistryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containerName", "ContainerName", properties.ContainerName != null ? cfn_parse.FromCloudFormation.getString(properties.ContainerName) : void 0), ret.addPropertyResult("containerPort", "ContainerPort", properties.ContainerPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.ContainerPort) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addPropertyResult("registryArn", "RegistryArn", properties.RegistryArn != null ? cfn_parse.FromCloudFormation.getString(properties.RegistryArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinitionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containerDefinitions", cdk.listValidator(CfnTaskDefinition_ContainerDefinitionPropertyValidator))(properties.containerDefinitions)), errors.collect(cdk.propertyValidator("cpu", cdk.validateString)(properties.cpu)), errors.collect(cdk.propertyValidator("ephemeralStorage", CfnTaskDefinition_EphemeralStoragePropertyValidator)(properties.ephemeralStorage)), errors.collect(cdk.propertyValidator("executionRoleArn", cdk.validateString)(properties.executionRoleArn)), errors.collect(cdk.propertyValidator("family", cdk.validateString)(properties.family)), errors.collect(cdk.propertyValidator("inferenceAccelerators", cdk.listValidator(CfnTaskDefinition_InferenceAcceleratorPropertyValidator))(properties.inferenceAccelerators)), errors.collect(cdk.propertyValidator("ipcMode", cdk.validateString)(properties.ipcMode)), errors.collect(cdk.propertyValidator("memory", cdk.validateString)(properties.memory)), errors.collect(cdk.propertyValidator("networkMode", cdk.validateString)(properties.networkMode)), errors.collect(cdk.propertyValidator("pidMode", cdk.validateString)(properties.pidMode)), errors.collect(cdk.propertyValidator("placementConstraints", cdk.listValidator(CfnTaskDefinition_TaskDefinitionPlacementConstraintPropertyValidator))(properties.placementConstraints)), errors.collect(cdk.propertyValidator("proxyConfiguration", CfnTaskDefinition_ProxyConfigurationPropertyValidator)(properties.proxyConfiguration)), errors.collect(cdk.propertyValidator("requiresCompatibilities", cdk.listValidator(cdk.validateString))(properties.requiresCompatibilities)), errors.collect(cdk.propertyValidator("runtimePlatform", CfnTaskDefinition_RuntimePlatformPropertyValidator)(properties.runtimePlatform)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("taskRoleArn", cdk.validateString)(properties.taskRoleArn)), errors.collect(cdk.propertyValidator("volumes", cdk.listValidator(CfnTaskDefinition_VolumePropertyValidator))(properties.volumes)), errors.wrap('supplied properties not correct for "CfnTaskDefinitionProps"');
    }
    function cfnTaskDefinitionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinitionPropsValidator(properties).assertSuccess(), { ContainerDefinitions: cdk.listMapper(cfnTaskDefinitionContainerDefinitionPropertyToCloudFormation)(properties.containerDefinitions), Cpu: cdk.stringToCloudFormation(properties.cpu), EphemeralStorage: cfnTaskDefinitionEphemeralStoragePropertyToCloudFormation(properties.ephemeralStorage), ExecutionRoleArn: cdk.stringToCloudFormation(properties.executionRoleArn), Family: cdk.stringToCloudFormation(properties.family), InferenceAccelerators: cdk.listMapper(cfnTaskDefinitionInferenceAcceleratorPropertyToCloudFormation)(properties.inferenceAccelerators), IpcMode: cdk.stringToCloudFormation(properties.ipcMode), Memory: cdk.stringToCloudFormation(properties.memory), NetworkMode: cdk.stringToCloudFormation(properties.networkMode), PidMode: cdk.stringToCloudFormation(properties.pidMode), PlacementConstraints: cdk.listMapper(cfnTaskDefinitionTaskDefinitionPlacementConstraintPropertyToCloudFormation)(properties.placementConstraints), ProxyConfiguration: cfnTaskDefinitionProxyConfigurationPropertyToCloudFormation(properties.proxyConfiguration), RequiresCompatibilities: cdk.listMapper(cdk.stringToCloudFormation)(properties.requiresCompatibilities), RuntimePlatform: cfnTaskDefinitionRuntimePlatformPropertyToCloudFormation(properties.runtimePlatform), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TaskRoleArn: cdk.stringToCloudFormation(properties.taskRoleArn), Volumes: cdk.listMapper(cfnTaskDefinitionVolumePropertyToCloudFormation)(properties.volumes) }) : properties;
    }
    function CfnTaskDefinitionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containerDefinitions", "ContainerDefinitions", properties.ContainerDefinitions != null ? cfn_parse.FromCloudFormation.getArray(CfnTaskDefinitionContainerDefinitionPropertyFromCloudFormation)(properties.ContainerDefinitions) : void 0), ret.addPropertyResult("cpu", "Cpu", properties.Cpu != null ? cfn_parse.FromCloudFormation.getString(properties.Cpu) : void 0), ret.addPropertyResult("ephemeralStorage", "EphemeralStorage", properties.EphemeralStorage != null ? CfnTaskDefinitionEphemeralStoragePropertyFromCloudFormation(properties.EphemeralStorage) : void 0), ret.addPropertyResult("executionRoleArn", "ExecutionRoleArn", properties.ExecutionRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.ExecutionRoleArn) : void 0), ret.addPropertyResult("family", "Family", properties.Family != null ? cfn_parse.FromCloudFormation.getString(properties.Family) : void 0), ret.addPropertyResult("inferenceAccelerators", "InferenceAccelerators", properties.InferenceAccelerators != null ? cfn_parse.FromCloudFormation.getArray(CfnTaskDefinitionInferenceAcceleratorPropertyFromCloudFormation)(properties.InferenceAccelerators) : void 0), ret.addPropertyResult("ipcMode", "IpcMode", properties.IpcMode != null ? cfn_parse.FromCloudFormation.getString(properties.IpcMode) : void 0), ret.addPropertyResult("memory", "Memory", properties.Memory != null ? cfn_parse.FromCloudFormation.getString(properties.Memory) : void 0), ret.addPropertyResult("networkMode", "NetworkMode", properties.NetworkMode != null ? cfn_parse.FromCloudFormation.getString(properties.NetworkMode) : void 0), ret.addPropertyResult("pidMode", "PidMode", properties.PidMode != null ? cfn_parse.FromCloudFormation.getString(properties.PidMode) : void 0), ret.addPropertyResult("placementConstraints", "PlacementConstraints", properties.PlacementConstraints != null ? cfn_parse.FromCloudFormation.getArray(CfnTaskDefinitionTaskDefinitionPlacementConstraintPropertyFromCloudFormation)(properties.PlacementConstraints) : void 0), ret.addPropertyResult("proxyConfiguration", "ProxyConfiguration", properties.ProxyConfiguration != null ? CfnTaskDefinitionProxyConfigurationPropertyFromCloudFormation(properties.ProxyConfiguration) : void 0), ret.addPropertyResult("requiresCompatibilities", "RequiresCompatibilities", properties.RequiresCompatibilities != null ? cfn_parse.FromCloudFormation.getStringArray(properties.RequiresCompatibilities) : void 0), ret.addPropertyResult("runtimePlatform", "RuntimePlatform", properties.RuntimePlatform != null ? CfnTaskDefinitionRuntimePlatformPropertyFromCloudFormation(properties.RuntimePlatform) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("taskRoleArn", "TaskRoleArn", properties.TaskRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.TaskRoleArn) : void 0), ret.addPropertyResult("volumes", "Volumes", properties.Volumes != null ? cfn_parse.FromCloudFormation.getArray(CfnTaskDefinitionVolumePropertyFromCloudFormation)(properties.Volumes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTaskDefinition = class _CfnTaskDefinition extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTaskDefinitionPropsFromCloudFormation(resourceProperties), ret = new _CfnTaskDefinition(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnTaskDefinition.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_CfnTaskDefinitionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTaskDefinition), error;
        }
        this.attrTaskDefinitionArn = cdk.Token.asString(this.getAtt("TaskDefinitionArn", cdk.ResolutionTypeHint.STRING)), this.containerDefinitions = props.containerDefinitions, this.cpu = props.cpu, this.ephemeralStorage = props.ephemeralStorage, this.executionRoleArn = props.executionRoleArn, this.family = props.family, this.inferenceAccelerators = props.inferenceAccelerators, this.ipcMode = props.ipcMode, this.memory = props.memory, this.networkMode = props.networkMode, this.pidMode = props.pidMode, this.placementConstraints = props.placementConstraints, this.proxyConfiguration = props.proxyConfiguration, this.requiresCompatibilities = props.requiresCompatibilities, this.runtimePlatform = props.runtimePlatform, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ECS::TaskDefinition", props.tags, { tagPropertyName: "tags" }), this.taskRoleArn = props.taskRoleArn, this.volumes = props.volumes;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTaskDefinition.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { containerDefinitions: this.containerDefinitions, cpu: this.cpu, ephemeralStorage: this.ephemeralStorage, executionRoleArn: this.executionRoleArn, family: this.family, inferenceAccelerators: this.inferenceAccelerators, ipcMode: this.ipcMode, memory: this.memory, networkMode: this.networkMode, pidMode: this.pidMode, placementConstraints: this.placementConstraints, proxyConfiguration: this.proxyConfiguration, requiresCompatibilities: this.requiresCompatibilities, runtimePlatform: this.runtimePlatform, tags: this.tags.renderTags(), taskRoleArn: this.taskRoleArn, volumes: this.volumes };
      }
      renderProperties(props) {
        return cfnTaskDefinitionPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnTaskDefinition[_f] = { fqn: "aws-cdk-lib.aws_ecs.CfnTaskDefinition", version: "2.80.0" }, CfnTaskDefinition.CFN_RESOURCE_TYPE_NAME = "AWS::ECS::TaskDefinition", exports2.CfnTaskDefinition = CfnTaskDefinition;
    function CfnTaskDefinition_AuthorizationConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessPointId", cdk.validateString)(properties.accessPointId)), errors.collect(cdk.propertyValidator("iam", cdk.validateString)(properties.iam)), errors.wrap('supplied properties not correct for "AuthorizationConfigProperty"');
    }
    function cfnTaskDefinitionAuthorizationConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_AuthorizationConfigPropertyValidator(properties).assertSuccess(), { AccessPointId: cdk.stringToCloudFormation(properties.accessPointId), IAM: cdk.stringToCloudFormation(properties.iam) }) : properties;
    }
    function CfnTaskDefinitionAuthorizationConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessPointId", "AccessPointId", properties.AccessPointId != null ? cfn_parse.FromCloudFormation.getString(properties.AccessPointId) : void 0), ret.addPropertyResult("iam", "IAM", properties.IAM != null ? cfn_parse.FromCloudFormation.getString(properties.IAM) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_ContainerDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("command", cdk.listValidator(cdk.validateString))(properties.command)), errors.collect(cdk.propertyValidator("cpu", cdk.validateNumber)(properties.cpu)), errors.collect(cdk.propertyValidator("dependsOn", cdk.listValidator(CfnTaskDefinition_ContainerDependencyPropertyValidator))(properties.dependsOn)), errors.collect(cdk.propertyValidator("disableNetworking", cdk.validateBoolean)(properties.disableNetworking)), errors.collect(cdk.propertyValidator("dnsSearchDomains", cdk.listValidator(cdk.validateString))(properties.dnsSearchDomains)), errors.collect(cdk.propertyValidator("dnsServers", cdk.listValidator(cdk.validateString))(properties.dnsServers)), errors.collect(cdk.propertyValidator("dockerLabels", cdk.hashValidator(cdk.validateString))(properties.dockerLabels)), errors.collect(cdk.propertyValidator("dockerSecurityOptions", cdk.listValidator(cdk.validateString))(properties.dockerSecurityOptions)), errors.collect(cdk.propertyValidator("entryPoint", cdk.listValidator(cdk.validateString))(properties.entryPoint)), errors.collect(cdk.propertyValidator("environment", cdk.listValidator(CfnTaskDefinition_KeyValuePairPropertyValidator))(properties.environment)), errors.collect(cdk.propertyValidator("environmentFiles", cdk.listValidator(CfnTaskDefinition_EnvironmentFilePropertyValidator))(properties.environmentFiles)), errors.collect(cdk.propertyValidator("essential", cdk.validateBoolean)(properties.essential)), errors.collect(cdk.propertyValidator("extraHosts", cdk.listValidator(CfnTaskDefinition_HostEntryPropertyValidator))(properties.extraHosts)), errors.collect(cdk.propertyValidator("firelensConfiguration", CfnTaskDefinition_FirelensConfigurationPropertyValidator)(properties.firelensConfiguration)), errors.collect(cdk.propertyValidator("healthCheck", CfnTaskDefinition_HealthCheckPropertyValidator)(properties.healthCheck)), errors.collect(cdk.propertyValidator("hostname", cdk.validateString)(properties.hostname)), errors.collect(cdk.propertyValidator("image", cdk.requiredValidator)(properties.image)), errors.collect(cdk.propertyValidator("image", cdk.validateString)(properties.image)), errors.collect(cdk.propertyValidator("interactive", cdk.validateBoolean)(properties.interactive)), errors.collect(cdk.propertyValidator("links", cdk.listValidator(cdk.validateString))(properties.links)), errors.collect(cdk.propertyValidator("linuxParameters", CfnTaskDefinition_LinuxParametersPropertyValidator)(properties.linuxParameters)), errors.collect(cdk.propertyValidator("logConfiguration", CfnTaskDefinition_LogConfigurationPropertyValidator)(properties.logConfiguration)), errors.collect(cdk.propertyValidator("memory", cdk.validateNumber)(properties.memory)), errors.collect(cdk.propertyValidator("memoryReservation", cdk.validateNumber)(properties.memoryReservation)), errors.collect(cdk.propertyValidator("mountPoints", cdk.listValidator(CfnTaskDefinition_MountPointPropertyValidator))(properties.mountPoints)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("portMappings", cdk.listValidator(CfnTaskDefinition_PortMappingPropertyValidator))(properties.portMappings)), errors.collect(cdk.propertyValidator("privileged", cdk.validateBoolean)(properties.privileged)), errors.collect(cdk.propertyValidator("pseudoTerminal", cdk.validateBoolean)(properties.pseudoTerminal)), errors.collect(cdk.propertyValidator("readonlyRootFilesystem", cdk.validateBoolean)(properties.readonlyRootFilesystem)), errors.collect(cdk.propertyValidator("repositoryCredentials", CfnTaskDefinition_RepositoryCredentialsPropertyValidator)(properties.repositoryCredentials)), errors.collect(cdk.propertyValidator("resourceRequirements", cdk.listValidator(CfnTaskDefinition_ResourceRequirementPropertyValidator))(properties.resourceRequirements)), errors.collect(cdk.propertyValidator("secrets", cdk.listValidator(CfnTaskDefinition_SecretPropertyValidator))(properties.secrets)), errors.collect(cdk.propertyValidator("startTimeout", cdk.validateNumber)(properties.startTimeout)), errors.collect(cdk.propertyValidator("stopTimeout", cdk.validateNumber)(properties.stopTimeout)), errors.collect(cdk.propertyValidator("systemControls", cdk.listValidator(CfnTaskDefinition_SystemControlPropertyValidator))(properties.systemControls)), errors.collect(cdk.propertyValidator("ulimits", cdk.listValidator(CfnTaskDefinition_UlimitPropertyValidator))(properties.ulimits)), errors.collect(cdk.propertyValidator("user", cdk.validateString)(properties.user)), errors.collect(cdk.propertyValidator("volumesFrom", cdk.listValidator(CfnTaskDefinition_VolumeFromPropertyValidator))(properties.volumesFrom)), errors.collect(cdk.propertyValidator("workingDirectory", cdk.validateString)(properties.workingDirectory)), errors.wrap('supplied properties not correct for "ContainerDefinitionProperty"');
    }
    function cfnTaskDefinitionContainerDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_ContainerDefinitionPropertyValidator(properties).assertSuccess(), { Command: cdk.listMapper(cdk.stringToCloudFormation)(properties.command), Cpu: cdk.numberToCloudFormation(properties.cpu), DependsOn: cdk.listMapper(cfnTaskDefinitionContainerDependencyPropertyToCloudFormation)(properties.dependsOn), DisableNetworking: cdk.booleanToCloudFormation(properties.disableNetworking), DnsSearchDomains: cdk.listMapper(cdk.stringToCloudFormation)(properties.dnsSearchDomains), DnsServers: cdk.listMapper(cdk.stringToCloudFormation)(properties.dnsServers), DockerLabels: cdk.hashMapper(cdk.stringToCloudFormation)(properties.dockerLabels), DockerSecurityOptions: cdk.listMapper(cdk.stringToCloudFormation)(properties.dockerSecurityOptions), EntryPoint: cdk.listMapper(cdk.stringToCloudFormation)(properties.entryPoint), Environment: cdk.listMapper(cfnTaskDefinitionKeyValuePairPropertyToCloudFormation)(properties.environment), EnvironmentFiles: cdk.listMapper(cfnTaskDefinitionEnvironmentFilePropertyToCloudFormation)(properties.environmentFiles), Essential: cdk.booleanToCloudFormation(properties.essential), ExtraHosts: cdk.listMapper(cfnTaskDefinitionHostEntryPropertyToCloudFormation)(properties.extraHosts), FirelensConfiguration: cfnTaskDefinitionFirelensConfigurationPropertyToCloudFormation(properties.firelensConfiguration), HealthCheck: cfnTaskDefinitionHealthCheckPropertyToCloudFormation(properties.healthCheck), Hostname: cdk.stringToCloudFormation(properties.hostname), Image: cdk.stringToCloudFormation(properties.image), Interactive: cdk.booleanToCloudFormation(properties.interactive), Links: cdk.listMapper(cdk.stringToCloudFormation)(properties.links), LinuxParameters: cfnTaskDefinitionLinuxParametersPropertyToCloudFormation(properties.linuxParameters), LogConfiguration: cfnTaskDefinitionLogConfigurationPropertyToCloudFormation(properties.logConfiguration), Memory: cdk.numberToCloudFormation(properties.memory), MemoryReservation: cdk.numberToCloudFormation(properties.memoryReservation), MountPoints: cdk.listMapper(cfnTaskDefinitionMountPointPropertyToCloudFormation)(properties.mountPoints), Name: cdk.stringToCloudFormation(properties.name), PortMappings: cdk.listMapper(cfnTaskDefinitionPortMappingPropertyToCloudFormation)(properties.portMappings), Privileged: cdk.booleanToCloudFormation(properties.privileged), PseudoTerminal: cdk.booleanToCloudFormation(properties.pseudoTerminal), ReadonlyRootFilesystem: cdk.booleanToCloudFormation(properties.readonlyRootFilesystem), RepositoryCredentials: cfnTaskDefinitionRepositoryCredentialsPropertyToCloudFormation(properties.repositoryCredentials), ResourceRequirements: cdk.listMapper(cfnTaskDefinitionResourceRequirementPropertyToCloudFormation)(properties.resourceRequirements), Secrets: cdk.listMapper(cfnTaskDefinitionSecretPropertyToCloudFormation)(properties.secrets), StartTimeout: cdk.numberToCloudFormation(properties.startTimeout), StopTimeout: cdk.numberToCloudFormation(properties.stopTimeout), SystemControls: cdk.listMapper(cfnTaskDefinitionSystemControlPropertyToCloudFormation)(properties.systemControls), Ulimits: cdk.listMapper(cfnTaskDefinitionUlimitPropertyToCloudFormation)(properties.ulimits), User: cdk.stringToCloudFormation(properties.user), VolumesFrom: cdk.listMapper(cfnTaskDefinitionVolumeFromPropertyToCloudFormation)(properties.volumesFrom), WorkingDirectory: cdk.stringToCloudFormation(properties.workingDirectory) }) : properties;
    }
    function CfnTaskDefinitionContainerDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("command", "Command", properties.Command != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Command) : void 0), ret.addPropertyResult("cpu", "Cpu", properties.Cpu != null ? cfn_parse.FromCloudFormation.getNumber(properties.Cpu) : void 0), ret.addPropertyResult("dependsOn", "DependsOn", properties.DependsOn != null ? cfn_parse.FromCloudFormation.getArray(CfnTaskDefinitionContainerDependencyPropertyFromCloudFormation)(properties.DependsOn) : void 0), ret.addPropertyResult("disableNetworking", "DisableNetworking", properties.DisableNetworking != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DisableNetworking) : void 0), ret.addPropertyResult("dnsSearchDomains", "DnsSearchDomains", properties.DnsSearchDomains != null ? cfn_parse.FromCloudFormation.getStringArray(properties.DnsSearchDomains) : void 0), ret.addPropertyResult("dnsServers", "DnsServers", properties.DnsServers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.DnsServers) : void 0), ret.addPropertyResult("dockerLabels", "DockerLabels", properties.DockerLabels != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.DockerLabels) : void 0), ret.addPropertyResult("dockerSecurityOptions", "DockerSecurityOptions", properties.DockerSecurityOptions != null ? cfn_parse.FromCloudFormation.getStringArray(properties.DockerSecurityOptions) : void 0), ret.addPropertyResult("entryPoint", "EntryPoint", properties.EntryPoint != null ? cfn_parse.FromCloudFormation.getStringArray(properties.EntryPoint) : void 0), ret.addPropertyResult("environment", "Environment", properties.Environment != null ? cfn_parse.FromCloudFormation.getArray(CfnTaskDefinitionKeyValuePairPropertyFromCloudFormation)(properties.Environment) : void 0), ret.addPropertyResult("environmentFiles", "EnvironmentFiles", properties.EnvironmentFiles != null ? cfn_parse.FromCloudFormation.getArray(CfnTaskDefinitionEnvironmentFilePropertyFromCloudFormation)(properties.EnvironmentFiles) : void 0), ret.addPropertyResult("essential", "Essential", properties.Essential != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Essential) : void 0), ret.addPropertyResult("extraHosts", "ExtraHosts", properties.ExtraHosts != null ? cfn_parse.FromCloudFormation.getArray(CfnTaskDefinitionHostEntryPropertyFromCloudFormation)(properties.ExtraHosts) : void 0), ret.addPropertyResult("firelensConfiguration", "FirelensConfiguration", properties.FirelensConfiguration != null ? CfnTaskDefinitionFirelensConfigurationPropertyFromCloudFormation(properties.FirelensConfiguration) : void 0), ret.addPropertyResult("healthCheck", "HealthCheck", properties.HealthCheck != null ? CfnTaskDefinitionHealthCheckPropertyFromCloudFormation(properties.HealthCheck) : void 0), ret.addPropertyResult("hostname", "Hostname", properties.Hostname != null ? cfn_parse.FromCloudFormation.getString(properties.Hostname) : void 0), ret.addPropertyResult("image", "Image", cfn_parse.FromCloudFormation.getString(properties.Image)), ret.addPropertyResult("interactive", "Interactive", properties.Interactive != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Interactive) : void 0), ret.addPropertyResult("links", "Links", properties.Links != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Links) : void 0), ret.addPropertyResult("linuxParameters", "LinuxParameters", properties.LinuxParameters != null ? CfnTaskDefinitionLinuxParametersPropertyFromCloudFormation(properties.LinuxParameters) : void 0), ret.addPropertyResult("logConfiguration", "LogConfiguration", properties.LogConfiguration != null ? CfnTaskDefinitionLogConfigurationPropertyFromCloudFormation(properties.LogConfiguration) : void 0), ret.addPropertyResult("memory", "Memory", properties.Memory != null ? cfn_parse.FromCloudFormation.getNumber(properties.Memory) : void 0), ret.addPropertyResult("memoryReservation", "MemoryReservation", properties.MemoryReservation != null ? cfn_parse.FromCloudFormation.getNumber(properties.MemoryReservation) : void 0), ret.addPropertyResult("mountPoints", "MountPoints", properties.MountPoints != null ? cfn_parse.FromCloudFormation.getArray(CfnTaskDefinitionMountPointPropertyFromCloudFormation)(properties.MountPoints) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("portMappings", "PortMappings", properties.PortMappings != null ? cfn_parse.FromCloudFormation.getArray(CfnTaskDefinitionPortMappingPropertyFromCloudFormation)(properties.PortMappings) : void 0), ret.addPropertyResult("privileged", "Privileged", properties.Privileged != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Privileged) : void 0), ret.addPropertyResult("pseudoTerminal", "PseudoTerminal", properties.PseudoTerminal != null ? cfn_parse.FromCloudFormation.getBoolean(properties.PseudoTerminal) : void 0), ret.addPropertyResult("readonlyRootFilesystem", "ReadonlyRootFilesystem", properties.ReadonlyRootFilesystem != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ReadonlyRootFilesystem) : void 0), ret.addPropertyResult("repositoryCredentials", "RepositoryCredentials", properties.RepositoryCredentials != null ? CfnTaskDefinitionRepositoryCredentialsPropertyFromCloudFormation(properties.RepositoryCredentials) : void 0), ret.addPropertyResult("resourceRequirements", "ResourceRequirements", properties.ResourceRequirements != null ? cfn_parse.FromCloudFormation.getArray(CfnTaskDefinitionResourceRequirementPropertyFromCloudFormation)(properties.ResourceRequirements) : void 0), ret.addPropertyResult("secrets", "Secrets", properties.Secrets != null ? cfn_parse.FromCloudFormation.getArray(CfnTaskDefinitionSecretPropertyFromCloudFormation)(properties.Secrets) : void 0), ret.addPropertyResult("startTimeout", "StartTimeout", properties.StartTimeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.StartTimeout) : void 0), ret.addPropertyResult("stopTimeout", "StopTimeout", properties.StopTimeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.StopTimeout) : void 0), ret.addPropertyResult("systemControls", "SystemControls", properties.SystemControls != null ? cfn_parse.FromCloudFormation.getArray(CfnTaskDefinitionSystemControlPropertyFromCloudFormation)(properties.SystemControls) : void 0), ret.addPropertyResult("ulimits", "Ulimits", properties.Ulimits != null ? cfn_parse.FromCloudFormation.getArray(CfnTaskDefinitionUlimitPropertyFromCloudFormation)(properties.Ulimits) : void 0), ret.addPropertyResult("user", "User", properties.User != null ? cfn_parse.FromCloudFormation.getString(properties.User) : void 0), ret.addPropertyResult("volumesFrom", "VolumesFrom", properties.VolumesFrom != null ? cfn_parse.FromCloudFormation.getArray(CfnTaskDefinitionVolumeFromPropertyFromCloudFormation)(properties.VolumesFrom) : void 0), ret.addPropertyResult("workingDirectory", "WorkingDirectory", properties.WorkingDirectory != null ? cfn_parse.FromCloudFormation.getString(properties.WorkingDirectory) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_ContainerDependencyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("condition", cdk.validateString)(properties.condition)), errors.collect(cdk.propertyValidator("containerName", cdk.validateString)(properties.containerName)), errors.wrap('supplied properties not correct for "ContainerDependencyProperty"');
    }
    function cfnTaskDefinitionContainerDependencyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_ContainerDependencyPropertyValidator(properties).assertSuccess(), { Condition: cdk.stringToCloudFormation(properties.condition), ContainerName: cdk.stringToCloudFormation(properties.containerName) }) : properties;
    }
    function CfnTaskDefinitionContainerDependencyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("condition", "Condition", properties.Condition != null ? cfn_parse.FromCloudFormation.getString(properties.Condition) : void 0), ret.addPropertyResult("containerName", "ContainerName", properties.ContainerName != null ? cfn_parse.FromCloudFormation.getString(properties.ContainerName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_DevicePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containerPath", cdk.validateString)(properties.containerPath)), errors.collect(cdk.propertyValidator("hostPath", cdk.validateString)(properties.hostPath)), errors.collect(cdk.propertyValidator("permissions", cdk.listValidator(cdk.validateString))(properties.permissions)), errors.wrap('supplied properties not correct for "DeviceProperty"');
    }
    function cfnTaskDefinitionDevicePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_DevicePropertyValidator(properties).assertSuccess(), { ContainerPath: cdk.stringToCloudFormation(properties.containerPath), HostPath: cdk.stringToCloudFormation(properties.hostPath), Permissions: cdk.listMapper(cdk.stringToCloudFormation)(properties.permissions) }) : properties;
    }
    function CfnTaskDefinitionDevicePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containerPath", "ContainerPath", properties.ContainerPath != null ? cfn_parse.FromCloudFormation.getString(properties.ContainerPath) : void 0), ret.addPropertyResult("hostPath", "HostPath", properties.HostPath != null ? cfn_parse.FromCloudFormation.getString(properties.HostPath) : void 0), ret.addPropertyResult("permissions", "Permissions", properties.Permissions != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Permissions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_DockerVolumeConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoprovision", cdk.validateBoolean)(properties.autoprovision)), errors.collect(cdk.propertyValidator("driver", cdk.validateString)(properties.driver)), errors.collect(cdk.propertyValidator("driverOpts", cdk.hashValidator(cdk.validateString))(properties.driverOpts)), errors.collect(cdk.propertyValidator("labels", cdk.hashValidator(cdk.validateString))(properties.labels)), errors.collect(cdk.propertyValidator("scope", cdk.validateString)(properties.scope)), errors.wrap('supplied properties not correct for "DockerVolumeConfigurationProperty"');
    }
    function cfnTaskDefinitionDockerVolumeConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_DockerVolumeConfigurationPropertyValidator(properties).assertSuccess(), { Autoprovision: cdk.booleanToCloudFormation(properties.autoprovision), Driver: cdk.stringToCloudFormation(properties.driver), DriverOpts: cdk.hashMapper(cdk.stringToCloudFormation)(properties.driverOpts), Labels: cdk.hashMapper(cdk.stringToCloudFormation)(properties.labels), Scope: cdk.stringToCloudFormation(properties.scope) }) : properties;
    }
    function CfnTaskDefinitionDockerVolumeConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("autoprovision", "Autoprovision", properties.Autoprovision != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Autoprovision) : void 0), ret.addPropertyResult("driver", "Driver", properties.Driver != null ? cfn_parse.FromCloudFormation.getString(properties.Driver) : void 0), ret.addPropertyResult("driverOpts", "DriverOpts", properties.DriverOpts != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.DriverOpts) : void 0), ret.addPropertyResult("labels", "Labels", properties.Labels != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Labels) : void 0), ret.addPropertyResult("scope", "Scope", properties.Scope != null ? cfn_parse.FromCloudFormation.getString(properties.Scope) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_EFSVolumeConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authorizationConfig", CfnTaskDefinition_AuthorizationConfigPropertyValidator)(properties.authorizationConfig)), errors.collect(cdk.propertyValidator("filesystemId", cdk.requiredValidator)(properties.filesystemId)), errors.collect(cdk.propertyValidator("filesystemId", cdk.validateString)(properties.filesystemId)), errors.collect(cdk.propertyValidator("rootDirectory", cdk.validateString)(properties.rootDirectory)), errors.collect(cdk.propertyValidator("transitEncryption", cdk.validateString)(properties.transitEncryption)), errors.collect(cdk.propertyValidator("transitEncryptionPort", cdk.validateNumber)(properties.transitEncryptionPort)), errors.wrap('supplied properties not correct for "EFSVolumeConfigurationProperty"');
    }
    function cfnTaskDefinitionEFSVolumeConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_EFSVolumeConfigurationPropertyValidator(properties).assertSuccess(), { AuthorizationConfig: cfnTaskDefinitionAuthorizationConfigPropertyToCloudFormation(properties.authorizationConfig), FilesystemId: cdk.stringToCloudFormation(properties.filesystemId), RootDirectory: cdk.stringToCloudFormation(properties.rootDirectory), TransitEncryption: cdk.stringToCloudFormation(properties.transitEncryption), TransitEncryptionPort: cdk.numberToCloudFormation(properties.transitEncryptionPort) }) : properties;
    }
    function CfnTaskDefinitionEFSVolumeConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authorizationConfig", "AuthorizationConfig", properties.AuthorizationConfig != null ? CfnTaskDefinitionAuthorizationConfigPropertyFromCloudFormation(properties.AuthorizationConfig) : void 0), ret.addPropertyResult("filesystemId", "FilesystemId", cfn_parse.FromCloudFormation.getString(properties.FilesystemId)), ret.addPropertyResult("rootDirectory", "RootDirectory", properties.RootDirectory != null ? cfn_parse.FromCloudFormation.getString(properties.RootDirectory) : void 0), ret.addPropertyResult("transitEncryption", "TransitEncryption", properties.TransitEncryption != null ? cfn_parse.FromCloudFormation.getString(properties.TransitEncryption) : void 0), ret.addPropertyResult("transitEncryptionPort", "TransitEncryptionPort", properties.TransitEncryptionPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.TransitEncryptionPort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_EnvironmentFilePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "EnvironmentFileProperty"');
    }
    function cfnTaskDefinitionEnvironmentFilePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_EnvironmentFilePropertyValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnTaskDefinitionEnvironmentFilePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_EphemeralStoragePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sizeInGiB", cdk.validateNumber)(properties.sizeInGiB)), errors.wrap('supplied properties not correct for "EphemeralStorageProperty"');
    }
    function cfnTaskDefinitionEphemeralStoragePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_EphemeralStoragePropertyValidator(properties).assertSuccess(), { SizeInGiB: cdk.numberToCloudFormation(properties.sizeInGiB) }) : properties;
    }
    function CfnTaskDefinitionEphemeralStoragePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sizeInGiB", "SizeInGiB", properties.SizeInGiB != null ? cfn_parse.FromCloudFormation.getNumber(properties.SizeInGiB) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_FirelensConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("options", cdk.hashValidator(cdk.validateString))(properties.options)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "FirelensConfigurationProperty"');
    }
    function cfnTaskDefinitionFirelensConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_FirelensConfigurationPropertyValidator(properties).assertSuccess(), { Options: cdk.hashMapper(cdk.stringToCloudFormation)(properties.options), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnTaskDefinitionFirelensConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("options", "Options", properties.Options != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Options) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_HealthCheckPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("command", cdk.listValidator(cdk.validateString))(properties.command)), errors.collect(cdk.propertyValidator("interval", cdk.validateNumber)(properties.interval)), errors.collect(cdk.propertyValidator("retries", cdk.validateNumber)(properties.retries)), errors.collect(cdk.propertyValidator("startPeriod", cdk.validateNumber)(properties.startPeriod)), errors.collect(cdk.propertyValidator("timeout", cdk.validateNumber)(properties.timeout)), errors.wrap('supplied properties not correct for "HealthCheckProperty"');
    }
    function cfnTaskDefinitionHealthCheckPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_HealthCheckPropertyValidator(properties).assertSuccess(), { Command: cdk.listMapper(cdk.stringToCloudFormation)(properties.command), Interval: cdk.numberToCloudFormation(properties.interval), Retries: cdk.numberToCloudFormation(properties.retries), StartPeriod: cdk.numberToCloudFormation(properties.startPeriod), Timeout: cdk.numberToCloudFormation(properties.timeout) }) : properties;
    }
    function CfnTaskDefinitionHealthCheckPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("command", "Command", properties.Command != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Command) : void 0), ret.addPropertyResult("interval", "Interval", properties.Interval != null ? cfn_parse.FromCloudFormation.getNumber(properties.Interval) : void 0), ret.addPropertyResult("retries", "Retries", properties.Retries != null ? cfn_parse.FromCloudFormation.getNumber(properties.Retries) : void 0), ret.addPropertyResult("startPeriod", "StartPeriod", properties.StartPeriod != null ? cfn_parse.FromCloudFormation.getNumber(properties.StartPeriod) : void 0), ret.addPropertyResult("timeout", "Timeout", properties.Timeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.Timeout) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_HostEntryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("hostname", cdk.validateString)(properties.hostname)), errors.collect(cdk.propertyValidator("ipAddress", cdk.validateString)(properties.ipAddress)), errors.wrap('supplied properties not correct for "HostEntryProperty"');
    }
    function cfnTaskDefinitionHostEntryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_HostEntryPropertyValidator(properties).assertSuccess(), { Hostname: cdk.stringToCloudFormation(properties.hostname), IpAddress: cdk.stringToCloudFormation(properties.ipAddress) }) : properties;
    }
    function CfnTaskDefinitionHostEntryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("hostname", "Hostname", properties.Hostname != null ? cfn_parse.FromCloudFormation.getString(properties.Hostname) : void 0), ret.addPropertyResult("ipAddress", "IpAddress", properties.IpAddress != null ? cfn_parse.FromCloudFormation.getString(properties.IpAddress) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_HostVolumePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sourcePath", cdk.validateString)(properties.sourcePath)), errors.wrap('supplied properties not correct for "HostVolumePropertiesProperty"');
    }
    function cfnTaskDefinitionHostVolumePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_HostVolumePropertiesPropertyValidator(properties).assertSuccess(), { SourcePath: cdk.stringToCloudFormation(properties.sourcePath) }) : properties;
    }
    function CfnTaskDefinitionHostVolumePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sourcePath", "SourcePath", properties.SourcePath != null ? cfn_parse.FromCloudFormation.getString(properties.SourcePath) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_InferenceAcceleratorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deviceName", cdk.validateString)(properties.deviceName)), errors.collect(cdk.propertyValidator("deviceType", cdk.validateString)(properties.deviceType)), errors.wrap('supplied properties not correct for "InferenceAcceleratorProperty"');
    }
    function cfnTaskDefinitionInferenceAcceleratorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_InferenceAcceleratorPropertyValidator(properties).assertSuccess(), { DeviceName: cdk.stringToCloudFormation(properties.deviceName), DeviceType: cdk.stringToCloudFormation(properties.deviceType) }) : properties;
    }
    function CfnTaskDefinitionInferenceAcceleratorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deviceName", "DeviceName", properties.DeviceName != null ? cfn_parse.FromCloudFormation.getString(properties.DeviceName) : void 0), ret.addPropertyResult("deviceType", "DeviceType", properties.DeviceType != null ? cfn_parse.FromCloudFormation.getString(properties.DeviceType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_KernelCapabilitiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("add", cdk.listValidator(cdk.validateString))(properties.add)), errors.collect(cdk.propertyValidator("drop", cdk.listValidator(cdk.validateString))(properties.drop)), errors.wrap('supplied properties not correct for "KernelCapabilitiesProperty"');
    }
    function cfnTaskDefinitionKernelCapabilitiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_KernelCapabilitiesPropertyValidator(properties).assertSuccess(), { Add: cdk.listMapper(cdk.stringToCloudFormation)(properties.add), Drop: cdk.listMapper(cdk.stringToCloudFormation)(properties.drop) }) : properties;
    }
    function CfnTaskDefinitionKernelCapabilitiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("add", "Add", properties.Add != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Add) : void 0), ret.addPropertyResult("drop", "Drop", properties.Drop != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Drop) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_KeyValuePairPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "KeyValuePairProperty"');
    }
    function cfnTaskDefinitionKeyValuePairPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_KeyValuePairPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnTaskDefinitionKeyValuePairPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_LinuxParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("capabilities", CfnTaskDefinition_KernelCapabilitiesPropertyValidator)(properties.capabilities)), errors.collect(cdk.propertyValidator("devices", cdk.listValidator(CfnTaskDefinition_DevicePropertyValidator))(properties.devices)), errors.collect(cdk.propertyValidator("initProcessEnabled", cdk.validateBoolean)(properties.initProcessEnabled)), errors.collect(cdk.propertyValidator("maxSwap", cdk.validateNumber)(properties.maxSwap)), errors.collect(cdk.propertyValidator("sharedMemorySize", cdk.validateNumber)(properties.sharedMemorySize)), errors.collect(cdk.propertyValidator("swappiness", cdk.validateNumber)(properties.swappiness)), errors.collect(cdk.propertyValidator("tmpfs", cdk.listValidator(CfnTaskDefinition_TmpfsPropertyValidator))(properties.tmpfs)), errors.wrap('supplied properties not correct for "LinuxParametersProperty"');
    }
    function cfnTaskDefinitionLinuxParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_LinuxParametersPropertyValidator(properties).assertSuccess(), { Capabilities: cfnTaskDefinitionKernelCapabilitiesPropertyToCloudFormation(properties.capabilities), Devices: cdk.listMapper(cfnTaskDefinitionDevicePropertyToCloudFormation)(properties.devices), InitProcessEnabled: cdk.booleanToCloudFormation(properties.initProcessEnabled), MaxSwap: cdk.numberToCloudFormation(properties.maxSwap), SharedMemorySize: cdk.numberToCloudFormation(properties.sharedMemorySize), Swappiness: cdk.numberToCloudFormation(properties.swappiness), Tmpfs: cdk.listMapper(cfnTaskDefinitionTmpfsPropertyToCloudFormation)(properties.tmpfs) }) : properties;
    }
    function CfnTaskDefinitionLinuxParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("capabilities", "Capabilities", properties.Capabilities != null ? CfnTaskDefinitionKernelCapabilitiesPropertyFromCloudFormation(properties.Capabilities) : void 0), ret.addPropertyResult("devices", "Devices", properties.Devices != null ? cfn_parse.FromCloudFormation.getArray(CfnTaskDefinitionDevicePropertyFromCloudFormation)(properties.Devices) : void 0), ret.addPropertyResult("initProcessEnabled", "InitProcessEnabled", properties.InitProcessEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.InitProcessEnabled) : void 0), ret.addPropertyResult("maxSwap", "MaxSwap", properties.MaxSwap != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxSwap) : void 0), ret.addPropertyResult("sharedMemorySize", "SharedMemorySize", properties.SharedMemorySize != null ? cfn_parse.FromCloudFormation.getNumber(properties.SharedMemorySize) : void 0), ret.addPropertyResult("swappiness", "Swappiness", properties.Swappiness != null ? cfn_parse.FromCloudFormation.getNumber(properties.Swappiness) : void 0), ret.addPropertyResult("tmpfs", "Tmpfs", properties.Tmpfs != null ? cfn_parse.FromCloudFormation.getArray(CfnTaskDefinitionTmpfsPropertyFromCloudFormation)(properties.Tmpfs) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_LogConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logDriver", cdk.requiredValidator)(properties.logDriver)), errors.collect(cdk.propertyValidator("logDriver", cdk.validateString)(properties.logDriver)), errors.collect(cdk.propertyValidator("options", cdk.hashValidator(cdk.validateString))(properties.options)), errors.collect(cdk.propertyValidator("secretOptions", cdk.listValidator(CfnTaskDefinition_SecretPropertyValidator))(properties.secretOptions)), errors.wrap('supplied properties not correct for "LogConfigurationProperty"');
    }
    function cfnTaskDefinitionLogConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_LogConfigurationPropertyValidator(properties).assertSuccess(), { LogDriver: cdk.stringToCloudFormation(properties.logDriver), Options: cdk.hashMapper(cdk.stringToCloudFormation)(properties.options), SecretOptions: cdk.listMapper(cfnTaskDefinitionSecretPropertyToCloudFormation)(properties.secretOptions) }) : properties;
    }
    function CfnTaskDefinitionLogConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logDriver", "LogDriver", cfn_parse.FromCloudFormation.getString(properties.LogDriver)), ret.addPropertyResult("options", "Options", properties.Options != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Options) : void 0), ret.addPropertyResult("secretOptions", "SecretOptions", properties.SecretOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnTaskDefinitionSecretPropertyFromCloudFormation)(properties.SecretOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_MountPointPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containerPath", cdk.validateString)(properties.containerPath)), errors.collect(cdk.propertyValidator("readOnly", cdk.validateBoolean)(properties.readOnly)), errors.collect(cdk.propertyValidator("sourceVolume", cdk.validateString)(properties.sourceVolume)), errors.wrap('supplied properties not correct for "MountPointProperty"');
    }
    function cfnTaskDefinitionMountPointPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_MountPointPropertyValidator(properties).assertSuccess(), { ContainerPath: cdk.stringToCloudFormation(properties.containerPath), ReadOnly: cdk.booleanToCloudFormation(properties.readOnly), SourceVolume: cdk.stringToCloudFormation(properties.sourceVolume) }) : properties;
    }
    function CfnTaskDefinitionMountPointPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containerPath", "ContainerPath", properties.ContainerPath != null ? cfn_parse.FromCloudFormation.getString(properties.ContainerPath) : void 0), ret.addPropertyResult("readOnly", "ReadOnly", properties.ReadOnly != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ReadOnly) : void 0), ret.addPropertyResult("sourceVolume", "SourceVolume", properties.SourceVolume != null ? cfn_parse.FromCloudFormation.getString(properties.SourceVolume) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_PortMappingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("appProtocol", cdk.validateString)(properties.appProtocol)), errors.collect(cdk.propertyValidator("containerPort", cdk.validateNumber)(properties.containerPort)), errors.collect(cdk.propertyValidator("containerPortRange", cdk.validateString)(properties.containerPortRange)), errors.collect(cdk.propertyValidator("hostPort", cdk.validateNumber)(properties.hostPort)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.wrap('supplied properties not correct for "PortMappingProperty"');
    }
    function cfnTaskDefinitionPortMappingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_PortMappingPropertyValidator(properties).assertSuccess(), { AppProtocol: cdk.stringToCloudFormation(properties.appProtocol), ContainerPort: cdk.numberToCloudFormation(properties.containerPort), ContainerPortRange: cdk.stringToCloudFormation(properties.containerPortRange), HostPort: cdk.numberToCloudFormation(properties.hostPort), Name: cdk.stringToCloudFormation(properties.name), Protocol: cdk.stringToCloudFormation(properties.protocol) }) : properties;
    }
    function CfnTaskDefinitionPortMappingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("appProtocol", "AppProtocol", properties.AppProtocol != null ? cfn_parse.FromCloudFormation.getString(properties.AppProtocol) : void 0), ret.addPropertyResult("containerPort", "ContainerPort", properties.ContainerPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.ContainerPort) : void 0), ret.addPropertyResult("containerPortRange", "ContainerPortRange", properties.ContainerPortRange != null ? cfn_parse.FromCloudFormation.getString(properties.ContainerPortRange) : void 0), ret.addPropertyResult("hostPort", "HostPort", properties.HostPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.HostPort) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("protocol", "Protocol", properties.Protocol != null ? cfn_parse.FromCloudFormation.getString(properties.Protocol) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_ProxyConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containerName", cdk.requiredValidator)(properties.containerName)), errors.collect(cdk.propertyValidator("containerName", cdk.validateString)(properties.containerName)), errors.collect(cdk.propertyValidator("proxyConfigurationProperties", cdk.listValidator(CfnTaskDefinition_KeyValuePairPropertyValidator))(properties.proxyConfigurationProperties)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "ProxyConfigurationProperty"');
    }
    function cfnTaskDefinitionProxyConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_ProxyConfigurationPropertyValidator(properties).assertSuccess(), { ContainerName: cdk.stringToCloudFormation(properties.containerName), ProxyConfigurationProperties: cdk.listMapper(cfnTaskDefinitionKeyValuePairPropertyToCloudFormation)(properties.proxyConfigurationProperties), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnTaskDefinitionProxyConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containerName", "ContainerName", cfn_parse.FromCloudFormation.getString(properties.ContainerName)), ret.addPropertyResult("proxyConfigurationProperties", "ProxyConfigurationProperties", properties.ProxyConfigurationProperties != null ? cfn_parse.FromCloudFormation.getArray(CfnTaskDefinitionKeyValuePairPropertyFromCloudFormation)(properties.ProxyConfigurationProperties) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_RepositoryCredentialsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("credentialsParameter", cdk.validateString)(properties.credentialsParameter)), errors.wrap('supplied properties not correct for "RepositoryCredentialsProperty"');
    }
    function cfnTaskDefinitionRepositoryCredentialsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_RepositoryCredentialsPropertyValidator(properties).assertSuccess(), { CredentialsParameter: cdk.stringToCloudFormation(properties.credentialsParameter) }) : properties;
    }
    function CfnTaskDefinitionRepositoryCredentialsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("credentialsParameter", "CredentialsParameter", properties.CredentialsParameter != null ? cfn_parse.FromCloudFormation.getString(properties.CredentialsParameter) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_ResourceRequirementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "ResourceRequirementProperty"');
    }
    function cfnTaskDefinitionResourceRequirementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_ResourceRequirementPropertyValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnTaskDefinitionResourceRequirementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_RuntimePlatformPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cpuArchitecture", cdk.validateString)(properties.cpuArchitecture)), errors.collect(cdk.propertyValidator("operatingSystemFamily", cdk.validateString)(properties.operatingSystemFamily)), errors.wrap('supplied properties not correct for "RuntimePlatformProperty"');
    }
    function cfnTaskDefinitionRuntimePlatformPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_RuntimePlatformPropertyValidator(properties).assertSuccess(), { CpuArchitecture: cdk.stringToCloudFormation(properties.cpuArchitecture), OperatingSystemFamily: cdk.stringToCloudFormation(properties.operatingSystemFamily) }) : properties;
    }
    function CfnTaskDefinitionRuntimePlatformPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cpuArchitecture", "CpuArchitecture", properties.CpuArchitecture != null ? cfn_parse.FromCloudFormation.getString(properties.CpuArchitecture) : void 0), ret.addPropertyResult("operatingSystemFamily", "OperatingSystemFamily", properties.OperatingSystemFamily != null ? cfn_parse.FromCloudFormation.getString(properties.OperatingSystemFamily) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_SecretPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("valueFrom", cdk.requiredValidator)(properties.valueFrom)), errors.collect(cdk.propertyValidator("valueFrom", cdk.validateString)(properties.valueFrom)), errors.wrap('supplied properties not correct for "SecretProperty"');
    }
    function cfnTaskDefinitionSecretPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_SecretPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), ValueFrom: cdk.stringToCloudFormation(properties.valueFrom) }) : properties;
    }
    function CfnTaskDefinitionSecretPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("valueFrom", "ValueFrom", cfn_parse.FromCloudFormation.getString(properties.ValueFrom)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_SystemControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("namespace", cdk.validateString)(properties.namespace)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "SystemControlProperty"');
    }
    function cfnTaskDefinitionSystemControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_SystemControlPropertyValidator(properties).assertSuccess(), { Namespace: cdk.stringToCloudFormation(properties.namespace), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnTaskDefinitionSystemControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("namespace", "Namespace", properties.Namespace != null ? cfn_parse.FromCloudFormation.getString(properties.Namespace) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_TaskDefinitionPlacementConstraintPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "TaskDefinitionPlacementConstraintProperty"');
    }
    function cfnTaskDefinitionTaskDefinitionPlacementConstraintPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_TaskDefinitionPlacementConstraintPropertyValidator(properties).assertSuccess(), { Expression: cdk.stringToCloudFormation(properties.expression), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnTaskDefinitionTaskDefinitionPlacementConstraintPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("expression", "Expression", properties.Expression != null ? cfn_parse.FromCloudFormation.getString(properties.Expression) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_TmpfsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containerPath", cdk.validateString)(properties.containerPath)), errors.collect(cdk.propertyValidator("mountOptions", cdk.listValidator(cdk.validateString))(properties.mountOptions)), errors.collect(cdk.propertyValidator("size", cdk.requiredValidator)(properties.size)), errors.collect(cdk.propertyValidator("size", cdk.validateNumber)(properties.size)), errors.wrap('supplied properties not correct for "TmpfsProperty"');
    }
    function cfnTaskDefinitionTmpfsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_TmpfsPropertyValidator(properties).assertSuccess(), { ContainerPath: cdk.stringToCloudFormation(properties.containerPath), MountOptions: cdk.listMapper(cdk.stringToCloudFormation)(properties.mountOptions), Size: cdk.numberToCloudFormation(properties.size) }) : properties;
    }
    function CfnTaskDefinitionTmpfsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containerPath", "ContainerPath", properties.ContainerPath != null ? cfn_parse.FromCloudFormation.getString(properties.ContainerPath) : void 0), ret.addPropertyResult("mountOptions", "MountOptions", properties.MountOptions != null ? cfn_parse.FromCloudFormation.getStringArray(properties.MountOptions) : void 0), ret.addPropertyResult("size", "Size", cfn_parse.FromCloudFormation.getNumber(properties.Size)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_UlimitPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("hardLimit", cdk.requiredValidator)(properties.hardLimit)), errors.collect(cdk.propertyValidator("hardLimit", cdk.validateNumber)(properties.hardLimit)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("softLimit", cdk.requiredValidator)(properties.softLimit)), errors.collect(cdk.propertyValidator("softLimit", cdk.validateNumber)(properties.softLimit)), errors.wrap('supplied properties not correct for "UlimitProperty"');
    }
    function cfnTaskDefinitionUlimitPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_UlimitPropertyValidator(properties).assertSuccess(), { HardLimit: cdk.numberToCloudFormation(properties.hardLimit), Name: cdk.stringToCloudFormation(properties.name), SoftLimit: cdk.numberToCloudFormation(properties.softLimit) }) : properties;
    }
    function CfnTaskDefinitionUlimitPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("hardLimit", "HardLimit", cfn_parse.FromCloudFormation.getNumber(properties.HardLimit)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("softLimit", "SoftLimit", cfn_parse.FromCloudFormation.getNumber(properties.SoftLimit)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_VolumePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dockerVolumeConfiguration", CfnTaskDefinition_DockerVolumeConfigurationPropertyValidator)(properties.dockerVolumeConfiguration)), errors.collect(cdk.propertyValidator("efsVolumeConfiguration", CfnTaskDefinition_EFSVolumeConfigurationPropertyValidator)(properties.efsVolumeConfiguration)), errors.collect(cdk.propertyValidator("host", CfnTaskDefinition_HostVolumePropertiesPropertyValidator)(properties.host)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "VolumeProperty"');
    }
    function cfnTaskDefinitionVolumePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_VolumePropertyValidator(properties).assertSuccess(), { DockerVolumeConfiguration: cfnTaskDefinitionDockerVolumeConfigurationPropertyToCloudFormation(properties.dockerVolumeConfiguration), EFSVolumeConfiguration: cfnTaskDefinitionEFSVolumeConfigurationPropertyToCloudFormation(properties.efsVolumeConfiguration), Host: cfnTaskDefinitionHostVolumePropertiesPropertyToCloudFormation(properties.host), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnTaskDefinitionVolumePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dockerVolumeConfiguration", "DockerVolumeConfiguration", properties.DockerVolumeConfiguration != null ? CfnTaskDefinitionDockerVolumeConfigurationPropertyFromCloudFormation(properties.DockerVolumeConfiguration) : void 0), ret.addPropertyResult("efsVolumeConfiguration", "EFSVolumeConfiguration", properties.EFSVolumeConfiguration != null ? CfnTaskDefinitionEFSVolumeConfigurationPropertyFromCloudFormation(properties.EFSVolumeConfiguration) : void 0), ret.addPropertyResult("host", "Host", properties.Host != null ? CfnTaskDefinitionHostVolumePropertiesPropertyFromCloudFormation(properties.Host) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_VolumeFromPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("readOnly", cdk.validateBoolean)(properties.readOnly)), errors.collect(cdk.propertyValidator("sourceContainer", cdk.validateString)(properties.sourceContainer)), errors.wrap('supplied properties not correct for "VolumeFromProperty"');
    }
    function cfnTaskDefinitionVolumeFromPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_VolumeFromPropertyValidator(properties).assertSuccess(), { ReadOnly: cdk.booleanToCloudFormation(properties.readOnly), SourceContainer: cdk.stringToCloudFormation(properties.sourceContainer) }) : properties;
    }
    function CfnTaskDefinitionVolumeFromPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("readOnly", "ReadOnly", properties.ReadOnly != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ReadOnly) : void 0), ret.addPropertyResult("sourceContainer", "SourceContainer", properties.SourceContainer != null ? cfn_parse.FromCloudFormation.getString(properties.SourceContainer) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskSetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cluster", cdk.requiredValidator)(properties.cluster)), errors.collect(cdk.propertyValidator("cluster", cdk.validateString)(properties.cluster)), errors.collect(cdk.propertyValidator("externalId", cdk.validateString)(properties.externalId)), errors.collect(cdk.propertyValidator("launchType", cdk.validateString)(properties.launchType)), errors.collect(cdk.propertyValidator("loadBalancers", cdk.listValidator(CfnTaskSet_LoadBalancerPropertyValidator))(properties.loadBalancers)), errors.collect(cdk.propertyValidator("networkConfiguration", CfnTaskSet_NetworkConfigurationPropertyValidator)(properties.networkConfiguration)), errors.collect(cdk.propertyValidator("platformVersion", cdk.validateString)(properties.platformVersion)), errors.collect(cdk.propertyValidator("scale", CfnTaskSet_ScalePropertyValidator)(properties.scale)), errors.collect(cdk.propertyValidator("service", cdk.requiredValidator)(properties.service)), errors.collect(cdk.propertyValidator("service", cdk.validateString)(properties.service)), errors.collect(cdk.propertyValidator("serviceRegistries", cdk.listValidator(CfnTaskSet_ServiceRegistryPropertyValidator))(properties.serviceRegistries)), errors.collect(cdk.propertyValidator("taskDefinition", cdk.requiredValidator)(properties.taskDefinition)), errors.collect(cdk.propertyValidator("taskDefinition", cdk.validateString)(properties.taskDefinition)), errors.wrap('supplied properties not correct for "CfnTaskSetProps"');
    }
    function cfnTaskSetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskSetPropsValidator(properties).assertSuccess(), { Cluster: cdk.stringToCloudFormation(properties.cluster), Service: cdk.stringToCloudFormation(properties.service), TaskDefinition: cdk.stringToCloudFormation(properties.taskDefinition), ExternalId: cdk.stringToCloudFormation(properties.externalId), LaunchType: cdk.stringToCloudFormation(properties.launchType), LoadBalancers: cdk.listMapper(cfnTaskSetLoadBalancerPropertyToCloudFormation)(properties.loadBalancers), NetworkConfiguration: cfnTaskSetNetworkConfigurationPropertyToCloudFormation(properties.networkConfiguration), PlatformVersion: cdk.stringToCloudFormation(properties.platformVersion), Scale: cfnTaskSetScalePropertyToCloudFormation(properties.scale), ServiceRegistries: cdk.listMapper(cfnTaskSetServiceRegistryPropertyToCloudFormation)(properties.serviceRegistries) }) : properties;
    }
    function CfnTaskSetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cluster", "Cluster", cfn_parse.FromCloudFormation.getString(properties.Cluster)), ret.addPropertyResult("service", "Service", cfn_parse.FromCloudFormation.getString(properties.Service)), ret.addPropertyResult("taskDefinition", "TaskDefinition", cfn_parse.FromCloudFormation.getString(properties.TaskDefinition)), ret.addPropertyResult("externalId", "ExternalId", properties.ExternalId != null ? cfn_parse.FromCloudFormation.getString(properties.ExternalId) : void 0), ret.addPropertyResult("launchType", "LaunchType", properties.LaunchType != null ? cfn_parse.FromCloudFormation.getString(properties.LaunchType) : void 0), ret.addPropertyResult("loadBalancers", "LoadBalancers", properties.LoadBalancers != null ? cfn_parse.FromCloudFormation.getArray(CfnTaskSetLoadBalancerPropertyFromCloudFormation)(properties.LoadBalancers) : void 0), ret.addPropertyResult("networkConfiguration", "NetworkConfiguration", properties.NetworkConfiguration != null ? CfnTaskSetNetworkConfigurationPropertyFromCloudFormation(properties.NetworkConfiguration) : void 0), ret.addPropertyResult("platformVersion", "PlatformVersion", properties.PlatformVersion != null ? cfn_parse.FromCloudFormation.getString(properties.PlatformVersion) : void 0), ret.addPropertyResult("scale", "Scale", properties.Scale != null ? CfnTaskSetScalePropertyFromCloudFormation(properties.Scale) : void 0), ret.addPropertyResult("serviceRegistries", "ServiceRegistries", properties.ServiceRegistries != null ? cfn_parse.FromCloudFormation.getArray(CfnTaskSetServiceRegistryPropertyFromCloudFormation)(properties.ServiceRegistries) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTaskSet = class _CfnTaskSet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTaskSetPropsFromCloudFormation(resourceProperties), ret = new _CfnTaskSet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTaskSet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_CfnTaskSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTaskSet), error;
        }
        cdk.requireProperty(props, "cluster", this), cdk.requireProperty(props, "service", this), cdk.requireProperty(props, "taskDefinition", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.cluster = props.cluster, this.service = props.service, this.taskDefinition = props.taskDefinition, this.externalId = props.externalId, this.launchType = props.launchType, this.loadBalancers = props.loadBalancers, this.networkConfiguration = props.networkConfiguration, this.platformVersion = props.platformVersion, this.scale = props.scale, this.serviceRegistries = props.serviceRegistries;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTaskSet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { cluster: this.cluster, service: this.service, taskDefinition: this.taskDefinition, externalId: this.externalId, launchType: this.launchType, loadBalancers: this.loadBalancers, networkConfiguration: this.networkConfiguration, platformVersion: this.platformVersion, scale: this.scale, serviceRegistries: this.serviceRegistries };
      }
      renderProperties(props) {
        return cfnTaskSetPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnTaskSet[_g] = { fqn: "aws-cdk-lib.aws_ecs.CfnTaskSet", version: "2.80.0" }, CfnTaskSet.CFN_RESOURCE_TYPE_NAME = "AWS::ECS::TaskSet", exports2.CfnTaskSet = CfnTaskSet;
    function CfnTaskSet_AwsVpcConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("assignPublicIp", cdk.validateString)(properties.assignPublicIp)), errors.collect(cdk.propertyValidator("securityGroups", cdk.listValidator(cdk.validateString))(properties.securityGroups)), errors.collect(cdk.propertyValidator("subnets", cdk.requiredValidator)(properties.subnets)), errors.collect(cdk.propertyValidator("subnets", cdk.listValidator(cdk.validateString))(properties.subnets)), errors.wrap('supplied properties not correct for "AwsVpcConfigurationProperty"');
    }
    function cfnTaskSetAwsVpcConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskSet_AwsVpcConfigurationPropertyValidator(properties).assertSuccess(), { AssignPublicIp: cdk.stringToCloudFormation(properties.assignPublicIp), SecurityGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroups), Subnets: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnets) }) : properties;
    }
    function CfnTaskSetAwsVpcConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("assignPublicIp", "AssignPublicIp", properties.AssignPublicIp != null ? cfn_parse.FromCloudFormation.getString(properties.AssignPublicIp) : void 0), ret.addPropertyResult("securityGroups", "SecurityGroups", properties.SecurityGroups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroups) : void 0), ret.addPropertyResult("subnets", "Subnets", cfn_parse.FromCloudFormation.getStringArray(properties.Subnets)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskSet_LoadBalancerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containerName", cdk.validateString)(properties.containerName)), errors.collect(cdk.propertyValidator("containerPort", cdk.validateNumber)(properties.containerPort)), errors.collect(cdk.propertyValidator("loadBalancerName", cdk.validateString)(properties.loadBalancerName)), errors.collect(cdk.propertyValidator("targetGroupArn", cdk.validateString)(properties.targetGroupArn)), errors.wrap('supplied properties not correct for "LoadBalancerProperty"');
    }
    function cfnTaskSetLoadBalancerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskSet_LoadBalancerPropertyValidator(properties).assertSuccess(), { ContainerName: cdk.stringToCloudFormation(properties.containerName), ContainerPort: cdk.numberToCloudFormation(properties.containerPort), LoadBalancerName: cdk.stringToCloudFormation(properties.loadBalancerName), TargetGroupArn: cdk.stringToCloudFormation(properties.targetGroupArn) }) : properties;
    }
    function CfnTaskSetLoadBalancerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containerName", "ContainerName", properties.ContainerName != null ? cfn_parse.FromCloudFormation.getString(properties.ContainerName) : void 0), ret.addPropertyResult("containerPort", "ContainerPort", properties.ContainerPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.ContainerPort) : void 0), ret.addPropertyResult("loadBalancerName", "LoadBalancerName", properties.LoadBalancerName != null ? cfn_parse.FromCloudFormation.getString(properties.LoadBalancerName) : void 0), ret.addPropertyResult("targetGroupArn", "TargetGroupArn", properties.TargetGroupArn != null ? cfn_parse.FromCloudFormation.getString(properties.TargetGroupArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskSet_NetworkConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("awsVpcConfiguration", CfnTaskSet_AwsVpcConfigurationPropertyValidator)(properties.awsVpcConfiguration)), errors.wrap('supplied properties not correct for "NetworkConfigurationProperty"');
    }
    function cfnTaskSetNetworkConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskSet_NetworkConfigurationPropertyValidator(properties).assertSuccess(), { AwsVpcConfiguration: cfnTaskSetAwsVpcConfigurationPropertyToCloudFormation(properties.awsVpcConfiguration) }) : properties;
    }
    function CfnTaskSetNetworkConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("awsVpcConfiguration", "AwsVpcConfiguration", properties.AwsVpcConfiguration != null ? CfnTaskSetAwsVpcConfigurationPropertyFromCloudFormation(properties.AwsVpcConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskSet_ScalePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("unit", cdk.validateString)(properties.unit)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "ScaleProperty"');
    }
    function cfnTaskSetScalePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskSet_ScalePropertyValidator(properties).assertSuccess(), { Unit: cdk.stringToCloudFormation(properties.unit), Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnTaskSetScalePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("unit", "Unit", properties.Unit != null ? cfn_parse.FromCloudFormation.getString(properties.Unit) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getNumber(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskSet_ServiceRegistryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containerName", cdk.validateString)(properties.containerName)), errors.collect(cdk.propertyValidator("containerPort", cdk.validateNumber)(properties.containerPort)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("registryArn", cdk.validateString)(properties.registryArn)), errors.wrap('supplied properties not correct for "ServiceRegistryProperty"');
    }
    function cfnTaskSetServiceRegistryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskSet_ServiceRegistryPropertyValidator(properties).assertSuccess(), { ContainerName: cdk.stringToCloudFormation(properties.containerName), ContainerPort: cdk.numberToCloudFormation(properties.containerPort), Port: cdk.numberToCloudFormation(properties.port), RegistryArn: cdk.stringToCloudFormation(properties.registryArn) }) : properties;
    }
    function CfnTaskSetServiceRegistryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containerName", "ContainerName", properties.ContainerName != null ? cfn_parse.FromCloudFormation.getString(properties.ContainerName) : void 0), ret.addPropertyResult("containerPort", "ContainerPort", properties.ContainerPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.ContainerPort) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addPropertyResult("registryArn", "RegistryArn", properties.RegistryArn != null ? cfn_parse.FromCloudFormation.getString(properties.RegistryArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/images/asset-image.js
var require_asset_image = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/images/asset-image.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AssetImage = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var aws_ecr_assets_1 = require_aws_ecr_assets();
    var container_image_1 = require_container_image();
    var AssetImage = class _AssetImage extends container_image_1.ContainerImage {
      constructor(directory, props = {}) {
        super(), this.directory = directory, this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_AssetImageProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AssetImage), error;
        }
      }
      bind(scope, containerDefinition) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_ContainerDefinition(containerDefinition);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        const asset = new aws_ecr_assets_1.DockerImageAsset(scope, "AssetImage", { directory: this.directory, ...this.props });
        return asset.repository.grantPull(containerDefinition.taskDefinition.obtainExecutionRole()), { imageName: asset.imageUri };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AssetImage[_a] = { fqn: "aws-cdk-lib.aws_ecs.AssetImage", version: "2.80.0" }, exports2.AssetImage = AssetImage;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/images/ecr.js
var require_ecr2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/images/ecr.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EcrImage = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var container_image_1 = require_container_image();
    var EcrImage = class _EcrImage extends container_image_1.ContainerImage {
      constructor(repository, tagOrDigest) {
        super(), this.repository = repository, this.tagOrDigest = tagOrDigest;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecr_IRepository(repository);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EcrImage), error;
        }
        this.imageName = this.repository.repositoryUriForTagOrDigest(this.tagOrDigest);
      }
      bind(_scope, containerDefinition) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_ContainerDefinition(containerDefinition);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return this.repository.grantPull(containerDefinition.taskDefinition.obtainExecutionRole()), { imageName: this.imageName };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EcrImage[_a] = { fqn: "aws-cdk-lib.aws_ecs.EcrImage", version: "2.80.0" }, exports2.EcrImage = EcrImage;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/images/repository.js
var require_repository3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/images/repository.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.RepositoryImage = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core_1 = require_core2();
    var container_image_1 = require_container_image();
    var ECR_IMAGE_REGEX = /(^[a-zA-Z0-9][a-zA-Z0-9-_]*).dkr.ecr.([a-zA-Z0-9][a-zA-Z0-9-_]*).amazonaws.com(.cn)?\/.*/;
    var RepositoryImage = class _RepositoryImage extends container_image_1.ContainerImage {
      constructor(imageName, props = {}) {
        super(), this.imageName = imageName, this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_RepositoryImageProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _RepositoryImage), error;
        }
      }
      bind(scope, containerDefinition) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_ContainerDefinition(containerDefinition);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return !core_1.Token.isUnresolved(this.imageName) && ECR_IMAGE_REGEX.test(this.imageName) && core_1.Annotations.of(scope).addWarning("Proper policies need to be attached before pulling from ECR repository, or use 'fromEcrRepository'."), this.props.credentials && this.props.credentials.grantRead(containerDefinition.taskDefinition.obtainExecutionRole()), { imageName: this.imageName, repositoryCredentials: this.props.credentials && { credentialsParameter: this.props.credentials.secretArn } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, RepositoryImage[_a] = { fqn: "aws-cdk-lib.aws_ecs.RepositoryImage", version: "2.80.0" }, exports2.RepositoryImage = RepositoryImage;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/container-image.js
var require_container_image = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/container-image.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ContainerImage = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var aws_ecr_assets_1 = require_aws_ecr_assets();
    var ContainerImage = class {
      static fromRegistry(name, props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_RepositoryImageProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromRegistry), error;
        }
        return new repository_1.RepositoryImage(name, props);
      }
      static fromEcrRepository(repository, tag = "latest") {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecr_IRepository(repository);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromEcrRepository), error;
        }
        return new ecr_1.EcrImage(repository, tag);
      }
      static fromAsset(directory, props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_AssetImageProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromAsset), error;
        }
        return new asset_image_1.AssetImage(directory, props);
      }
      static fromDockerImageAsset(asset) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecr_assets_DockerImageAsset(asset);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromDockerImageAsset), error;
        }
        return { bind(_scope, containerDefinition) {
          return asset.repository.grantPull(containerDefinition.taskDefinition.obtainExecutionRole()), { imageName: asset.imageUri };
        } };
      }
      static fromTarball(tarballFile) {
        return { bind(scope, containerDefinition) {
          const asset = new aws_ecr_assets_1.TarballImageAsset(scope, "Tarball", { tarballFile });
          return asset.repository.grantPull(containerDefinition.taskDefinition.obtainExecutionRole()), { imageName: asset.imageUri };
        } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ContainerImage[_a] = { fqn: "aws-cdk-lib.aws_ecs.ContainerImage", version: "2.80.0" }, exports2.ContainerImage = ContainerImage;
    var asset_image_1 = require_asset_image();
    var ecr_1 = require_ecr2();
    var repository_1 = require_repository3();
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/firelens-log-router.js
var require_firelens_log_router = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/firelens-log-router.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FirelensLogRouter = exports2.obtainDefaultFluentBitECRImage = exports2.FirelensConfigFileType = exports2.FirelensLogRouterType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var container_definition_1 = require_container_definition();
    var container_image_1 = require_container_image();
    var iam = require_aws_iam();
    var ssm = require_aws_ssm();
    var cdk = require_core2();
    var FirelensLogRouterType;
    (function(FirelensLogRouterType2) {
      FirelensLogRouterType2.FLUENTBIT = "fluentbit", FirelensLogRouterType2.FLUENTD = "fluentd";
    })(FirelensLogRouterType = exports2.FirelensLogRouterType || (exports2.FirelensLogRouterType = {}));
    var FirelensConfigFileType;
    (function(FirelensConfigFileType2) {
      FirelensConfigFileType2.S3 = "s3", FirelensConfigFileType2.FILE = "file";
    })(FirelensConfigFileType = exports2.FirelensConfigFileType || (exports2.FirelensConfigFileType = {}));
    function renderFirelensConfig(firelensConfig) {
      return firelensConfig.options ? firelensConfig.options.configFileValue === void 0 ? { type: firelensConfig.type, options: { "enable-ecs-log-metadata": firelensConfig.options.enableECSLogMetadata ? "true" : "false" } } : { type: firelensConfig.type, options: { "enable-ecs-log-metadata": firelensConfig.options.enableECSLogMetadata ? "true" : "false", "config-file-type": firelensConfig.options.configFileType, "config-file-value": firelensConfig.options.configFileValue } } : { type: firelensConfig.type };
    }
    var fluentBitImageSSMPath = "/aws/service/aws-for-fluent-bit";
    function obtainDefaultFluentBitECRImage(task, logDriverConfig, imageTag) {
      task.addToExecutionRolePolicy(new iam.PolicyStatement({ actions: ["ecr:GetAuthorizationToken", "ecr:BatchCheckLayerAvailability", "ecr:GetDownloadUrlForLayer", "ecr:BatchGetImage"], resources: ["*"] }));
      const logName = logDriverConfig && logDriverConfig.logDriver === "awsfirelens" && logDriverConfig.options && logDriverConfig.options.Name;
      logName === "cloudwatch" ? task.addToTaskRolePolicy(new iam.PolicyStatement({ actions: ["logs:CreateLogGroup", "logs:CreateLogStream", "logs:DescribeLogStreams", "logs:PutLogEvents"], resources: ["*"] })) : logName === "firehose" ? task.addToTaskRolePolicy(new iam.PolicyStatement({ actions: ["firehose:PutRecordBatch"], resources: ["*"] })) : logName === "kinesis" && task.addToTaskRolePolicy(new iam.PolicyStatement({ actions: ["kinesis:PutRecords"], resources: ["*"] }));
      const fluentBitImage = `${fluentBitImageSSMPath}/${imageTag || "latest"}`;
      return container_image_1.ContainerImage.fromRegistry(ssm.StringParameter.valueForStringParameter(task, fluentBitImage));
    }
    exports2.obtainDefaultFluentBitECRImage = obtainDefaultFluentBitECRImage;
    var FirelensLogRouter = class _FirelensLogRouter extends container_definition_1.ContainerDefinition {
      constructor(scope, id, props) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_FirelensLogRouterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _FirelensLogRouter), error;
        }
        const options = props.firelensConfig.options;
        if (options) {
          if (options.configFileValue && options.configFileType === void 0 || options.configFileValue === void 0 && options.configFileType)
            throw new Error("configFileValue and configFileType must be set together to define a custom config source");
          const hasConfig = options.configFileValue !== void 0, enableECSLogMetadata = options.enableECSLogMetadata || options.enableECSLogMetadata === void 0, configFileType = (options.configFileType === void 0 || options.configFileType === FirelensConfigFileType.S3) && (cdk.Token.isUnresolved(options.configFileValue) || /arn:aws[a-zA-Z-]*:s3:::.+/.test(options.configFileValue || "")) ? FirelensConfigFileType.S3 : FirelensConfigFileType.FILE;
          this.firelensConfig = { type: props.firelensConfig.type, options: { enableECSLogMetadata, ...hasConfig ? { configFileType, configFileValue: options.configFileValue } : {} } }, hasConfig && configFileType === FirelensConfigFileType.S3 && (props.taskDefinition.addToExecutionRolePolicy(new iam.PolicyStatement({ actions: ["s3:GetObject"], resources: [options.configFileValue ?? ""] })), props.taskDefinition.addToExecutionRolePolicy(new iam.PolicyStatement({ actions: ["s3:GetBucketLocation"], resources: [(options.configFileValue ?? "").split("/")[0]] })));
        } else
          this.firelensConfig = props.firelensConfig;
      }
      renderContainerDefinition(_taskDefinition) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_TaskDefinition(_taskDefinition);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.renderContainerDefinition), error;
        }
        return { ...super.renderContainerDefinition(), firelensConfiguration: this.firelensConfig && renderFirelensConfig(this.firelensConfig) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, FirelensLogRouter[_a] = { fqn: "aws-cdk-lib.aws_ecs.FirelensLogRouter", version: "2.80.0" }, exports2.FirelensLogRouter = FirelensLogRouter;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/log-drivers/log-driver.js
var require_log_driver = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/log-drivers/log-driver.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LogDriver = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var aws_log_driver_1 = require_aws_log_driver();
    var LogDriver = class {
      static awsLogs(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_AwsLogDriverProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.awsLogs), error;
        }
        return new aws_log_driver_1.AwsLogDriver(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LogDriver[_a] = { fqn: "aws-cdk-lib.aws_ecs.LogDriver", version: "2.80.0" }, exports2.LogDriver = LogDriver;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/log-drivers/utils.js
var require_utils13 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/log-drivers/utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.renderLogDriverSecretOptions = exports2.joinWithCommas = exports2.renderCommonLogDriverOptions = exports2.stringifyOptions = exports2.ensureInRange = exports2.ensurePositiveInteger = exports2.removeEmpty = void 0;
    var core_1 = require_core2();
    function removeEmpty(x) {
      for (const key of Object.keys(x))
        x[key] === void 0 && delete x[key];
      return x;
    }
    exports2.removeEmpty = removeEmpty;
    function ensurePositiveInteger(val) {
      if (!core_1.Token.isUnresolved(val) && Number.isInteger(val) && val < 0)
        throw new Error(`\`${val}\` must be a positive integer.`);
    }
    exports2.ensurePositiveInteger = ensurePositiveInteger;
    function ensureInRange(val, start, end) {
      if (!core_1.Token.isUnresolved(val) && !(val >= start && val <= end))
        throw new Error(`\`${val}\` must be within range ${start}:${end}`);
    }
    exports2.ensureInRange = ensureInRange;
    function stringifyOptions(options) {
      const _options = {}, filteredOptions = removeEmpty(options);
      for (const [key, value] of Object.entries(filteredOptions))
        _options[key] = core_1.SecretValue.isSecretValue(value) ? value.unsafeUnwrap() : `${value}`;
      return _options;
    }
    exports2.stringifyOptions = stringifyOptions;
    function renderCommonLogDriverOptions(opts) {
      return { tag: opts.tag, labels: joinWithCommas(opts.labels), env: joinWithCommas(opts.env), "env-regex": opts.envRegex };
    }
    exports2.renderCommonLogDriverOptions = renderCommonLogDriverOptions;
    function joinWithCommas(xs) {
      return xs && xs.join(",");
    }
    exports2.joinWithCommas = joinWithCommas;
    function renderLogDriverSecretOptions(secretValue, taskDefinition) {
      const secrets = [];
      for (const [name, secret] of Object.entries(secretValue))
        secret.grantRead(taskDefinition.obtainExecutionRole()), secrets.push({ name, valueFrom: secret.arn });
      return secrets;
    }
    exports2.renderLogDriverSecretOptions = renderLogDriverSecretOptions;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/log-drivers/aws-log-driver.js
var require_aws_log_driver = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/log-drivers/aws-log-driver.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AwsLogDriver = exports2.AwsLogDriverMode = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var log_driver_1 = require_log_driver();
    var utils_1 = require_utils13();
    var logs = require_aws_logs();
    var AwsLogDriverMode;
    (function(AwsLogDriverMode2) {
      AwsLogDriverMode2.BLOCKING = "blocking", AwsLogDriverMode2.NON_BLOCKING = "non-blocking";
    })(AwsLogDriverMode = exports2.AwsLogDriverMode || (exports2.AwsLogDriverMode = {}));
    var AwsLogDriver = class _AwsLogDriver extends log_driver_1.LogDriver {
      constructor(props) {
        super(), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_AwsLogDriverProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AwsLogDriver), error;
        }
        if (props.logGroup && props.logRetention)
          throw new Error("Cannot specify both `logGroup` and `logRetentionDays`.");
      }
      bind(scope, containerDefinition) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_ContainerDefinition(containerDefinition);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return this.logGroup = this.props.logGroup || new logs.LogGroup(scope, "LogGroup", { retention: this.props.logRetention || 1 / 0 }), this.logGroup.grantWrite(containerDefinition.taskDefinition.obtainExecutionRole()), { logDriver: "awslogs", options: (0, utils_1.removeEmpty)({ "awslogs-group": this.logGroup.logGroupName, "awslogs-stream-prefix": this.props.streamPrefix, "awslogs-region": this.logGroup.env.region, "awslogs-datetime-format": this.props.datetimeFormat, "awslogs-multiline-pattern": this.props.multilinePattern, mode: this.props.mode }) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AwsLogDriver[_a] = { fqn: "aws-cdk-lib.aws_ecs.AwsLogDriver", version: "2.80.0" }, exports2.AwsLogDriver = AwsLogDriver;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/base/task-definition.js
var require_task_definition = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/base/task-definition.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.isExternalCompatible = exports2.isFargateCompatible = exports2.isEc2Compatible = exports2.Compatibility = exports2.Scope = exports2.PidMode = exports2.IpcMode = exports2.NetworkMode = exports2.TaskDefinition = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var _imported_task_definition_1 = require_imported_task_definition();
    var ec2 = require_aws_ec2();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var container_definition_1 = require_container_definition();
    var ecs_generated_1 = require_ecs_generated();
    var firelens_log_router_1 = require_firelens_log_router();
    var aws_log_driver_1 = require_aws_log_driver();
    var TaskDefinitionBase = class extends core_1.Resource {
      get isEc2Compatible() {
        return isEc2Compatible(this.compatibility);
      }
      get isFargateCompatible() {
        return isFargateCompatible(this.compatibility);
      }
      get isExternalCompatible() {
        return isExternalCompatible(this.compatibility);
      }
    };
    var TaskDefinition = class _TaskDefinition extends TaskDefinitionBase {
      static fromTaskDefinitionArn(scope, id, taskDefinitionArn) {
        return new _imported_task_definition_1.ImportedTaskDefinition(scope, id, { taskDefinitionArn });
      }
      static fromTaskDefinitionAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_TaskDefinitionAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromTaskDefinitionAttributes), error;
        }
        return new _imported_task_definition_1.ImportedTaskDefinition(scope, id, { taskDefinitionArn: attrs.taskDefinitionArn, compatibility: attrs.compatibility, networkMode: attrs.networkMode, taskRole: attrs.taskRole, executionRole: attrs.executionRole });
      }
      constructor(scope, id, props) {
        super(scope, id), this.containers = new Array(), this.volumes = [], this.placementConstraints = new Array(), this._inferenceAccelerators = [];
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_TaskDefinitionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _TaskDefinition), error;
        }
        if (this.family = props.family || core_1.Names.uniqueId(this), this.compatibility = props.compatibility, props.volumes && props.volumes.forEach((v) => this.addVolume(v)), this.networkMode = props.networkMode ?? (this.isFargateCompatible ? NetworkMode.AWS_VPC : NetworkMode.BRIDGE), this.isFargateCompatible && this.networkMode !== NetworkMode.AWS_VPC)
          throw new Error(`Fargate tasks can only have AwsVpc network mode, got: ${this.networkMode}`);
        if (props.proxyConfiguration && this.networkMode !== NetworkMode.AWS_VPC)
          throw new Error(`ProxyConfiguration can only be used with AwsVpc network mode, got: ${this.networkMode}`);
        if (props.placementConstraints && props.placementConstraints.length > 0 && this.isFargateCompatible)
          throw new Error("Cannot set placement constraints on tasks that run on Fargate");
        if (this.isFargateCompatible && (!props.cpu || !props.memoryMiB))
          throw new Error(`Fargate-compatible tasks require both CPU (${props.cpu}) and memory (${props.memoryMiB}) specifications`);
        if (props.inferenceAccelerators && props.inferenceAccelerators.length > 0 && this.isFargateCompatible)
          throw new Error("Cannot use inference accelerators on tasks that run on Fargate");
        if (this.isExternalCompatible && ![NetworkMode.BRIDGE, NetworkMode.HOST, NetworkMode.NONE].includes(this.networkMode))
          throw new Error(`External tasks can only have Bridge, Host or None network mode, got: ${this.networkMode}`);
        if (!this.isFargateCompatible && props.runtimePlatform)
          throw new Error("Cannot specify runtimePlatform in non-Fargate compatible tasks");
        this._executionRole = props.executionRole, this.taskRole = props.taskRole || new iam.Role(this, "TaskRole", { assumedBy: new iam.ServicePrincipal("ecs-tasks.amazonaws.com") }), props.inferenceAccelerators && props.inferenceAccelerators.forEach((ia) => this.addInferenceAccelerator(ia)), this.ephemeralStorageGiB = props.ephemeralStorageGiB, props.runtimePlatform?.operatingSystemFamily?._operatingSystemFamily.includes("WINDOWS") && this.checkFargateWindowsBasedTasksSize(props.cpu, props.memoryMiB, props.runtimePlatform), this.runtimePlatform = props.runtimePlatform, this._cpu = props.cpu;
        const taskDef = new ecs_generated_1.CfnTaskDefinition(this, "Resource", { containerDefinitions: core_1.Lazy.any({ produce: () => this.renderContainers() }, { omitEmptyArray: true }), volumes: core_1.Lazy.any({ produce: () => this.renderVolumes() }, { omitEmptyArray: true }), executionRoleArn: core_1.Lazy.string({ produce: () => this.executionRole && this.executionRole.roleArn }), family: this.family, taskRoleArn: this.taskRole.roleArn, requiresCompatibilities: [...isEc2Compatible(props.compatibility) ? ["EC2"] : [], ...isFargateCompatible(props.compatibility) ? ["FARGATE"] : [], ...isExternalCompatible(props.compatibility) ? ["EXTERNAL"] : []], networkMode: this.renderNetworkMode(this.networkMode), placementConstraints: core_1.Lazy.any({ produce: () => isFargateCompatible(this.compatibility) ? void 0 : this.placementConstraints }, { omitEmptyArray: true }), proxyConfiguration: props.proxyConfiguration ? props.proxyConfiguration.bind(this.stack, this) : void 0, cpu: props.cpu, memory: props.memoryMiB, ipcMode: props.ipcMode, pidMode: props.pidMode, inferenceAccelerators: core_1.Lazy.any({ produce: () => isFargateCompatible(this.compatibility) ? void 0 : this.renderInferenceAccelerators() }, { omitEmptyArray: true }), ephemeralStorage: this.ephemeralStorageGiB ? { sizeInGiB: this.ephemeralStorageGiB } : void 0, runtimePlatform: this.isFargateCompatible && this.runtimePlatform ? { cpuArchitecture: this.runtimePlatform?.cpuArchitecture?._cpuArchitecture, operatingSystemFamily: this.runtimePlatform?.operatingSystemFamily?._operatingSystemFamily } : void 0 });
        props.placementConstraints && props.placementConstraints.forEach((pc) => this.addPlacementConstraint(pc)), this.taskDefinitionArn = taskDef.ref, this.node.addValidation({ validate: () => this.validateTaskDefinition() });
      }
      get executionRole() {
        return this._executionRole;
      }
      get inferenceAccelerators() {
        return this._inferenceAccelerators;
      }
      renderVolumes() {
        return this.volumes.map(renderVolume);
        function renderVolume(spec) {
          return { host: spec.host, name: spec.name, dockerVolumeConfiguration: spec.dockerVolumeConfiguration && { autoprovision: spec.dockerVolumeConfiguration.autoprovision, driver: spec.dockerVolumeConfiguration.driver, driverOpts: spec.dockerVolumeConfiguration.driverOpts, labels: spec.dockerVolumeConfiguration.labels, scope: spec.dockerVolumeConfiguration.scope }, efsVolumeConfiguration: spec.efsVolumeConfiguration && { filesystemId: spec.efsVolumeConfiguration.fileSystemId, authorizationConfig: spec.efsVolumeConfiguration.authorizationConfig, rootDirectory: spec.efsVolumeConfiguration.rootDirectory, transitEncryption: spec.efsVolumeConfiguration.transitEncryption, transitEncryptionPort: spec.efsVolumeConfiguration.transitEncryptionPort } };
        }
      }
      renderInferenceAccelerators() {
        return this._inferenceAccelerators.map(renderInferenceAccelerator);
        function renderInferenceAccelerator(inferenceAccelerator) {
          return { deviceName: inferenceAccelerator.deviceName, deviceType: inferenceAccelerator.deviceType };
        }
      }
      _validateTarget(options) {
        const targetContainer = this.findContainer(options.containerName);
        if (targetContainer === void 0)
          throw new Error(`No container named '${options.containerName}'. Did you call "addContainer()"?`);
        const targetProtocol = options.protocol || container_definition_1.Protocol.TCP, targetContainerPort = options.containerPort || targetContainer.containerPort, portMapping = targetContainer.findPortMapping(targetContainerPort, targetProtocol);
        if (portMapping === void 0)
          throw new Error(`Container '${targetContainer}' has no mapping for port ${options.containerPort} and protocol ${targetProtocol}. Did you call "container.addPortMappings()"?`);
        return { containerName: options.containerName, portMapping };
      }
      _portRangeFromPortMapping(portMapping) {
        return portMapping.hostPort !== void 0 && portMapping.hostPort !== 0 ? portMapping.protocol === container_definition_1.Protocol.UDP ? ec2.Port.udp(portMapping.hostPort) : ec2.Port.tcp(portMapping.hostPort) : this.networkMode === NetworkMode.BRIDGE || this.networkMode === NetworkMode.NAT ? EPHEMERAL_PORT_RANGE : portMapping.protocol === container_definition_1.Protocol.UDP ? ec2.Port.udp(portMapping.containerPort) : ec2.Port.tcp(portMapping.containerPort);
      }
      addToTaskRolePolicy(statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToTaskRolePolicy), error;
        }
        this.taskRole.addToPrincipalPolicy(statement);
      }
      addToExecutionRolePolicy(statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToExecutionRolePolicy), error;
        }
        this.obtainExecutionRole().addToPrincipalPolicy(statement);
      }
      addContainer(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_ContainerDefinitionOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addContainer), error;
        }
        return new container_definition_1.ContainerDefinition(this, id, { taskDefinition: this, ...props });
      }
      addFirelensLogRouter(id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_FirelensLogRouterDefinitionOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addFirelensLogRouter), error;
        }
        if (this.containers.find((x) => x instanceof firelens_log_router_1.FirelensLogRouter))
          throw new Error("Firelens log router is already added in this task.");
        return new firelens_log_router_1.FirelensLogRouter(this, id, { taskDefinition: this, ...props });
      }
      _linkContainer(container) {
        if (this._cpu) {
          const taskCpu = Number(this._cpu), sumOfContainerCpu = [...this.containers, container].map((c) => c.cpu).filter((cpu) => typeof cpu == "number").reduce((a, c) => a + c, 0);
          if (taskCpu < sumOfContainerCpu)
            throw new Error("The sum of all container cpu values cannot be greater than the value of the task cpu");
        }
        this.containers.push(container), this.defaultContainer === void 0 && container.essential && (this.defaultContainer = container);
      }
      addVolume(volume) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_Volume(volume);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addVolume), error;
        }
        this.volumes.push(volume);
      }
      addPlacementConstraint(constraint) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_PlacementConstraint(constraint);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addPlacementConstraint), error;
        }
        if (isFargateCompatible(this.compatibility))
          throw new Error("Cannot set placement constraints on tasks that run on Fargate");
        this.placementConstraints.push(...constraint.toJson());
      }
      addExtension(extension) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_ITaskDefinitionExtension(extension);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addExtension), error;
        }
        extension.extend(this);
      }
      addInferenceAccelerator(inferenceAccelerator) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_InferenceAccelerator(inferenceAccelerator);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addInferenceAccelerator), error;
        }
        if (isFargateCompatible(this.compatibility))
          throw new Error("Cannot use inference accelerators on tasks that run on Fargate");
        this._inferenceAccelerators.push(inferenceAccelerator);
      }
      grantRun(grantee) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(grantee);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantRun), error;
        }
        return grantee.grantPrincipal.addToPrincipalPolicy(this.passRoleStatement), iam.Grant.addToPrincipal({ grantee, actions: ["ecs:RunTask"], resourceArns: [this.taskDefinitionArn] });
      }
      obtainExecutionRole() {
        return this._executionRole || (this._executionRole = new iam.Role(this, "ExecutionRole", { assumedBy: new iam.ServicePrincipal("ecs-tasks.amazonaws.com"), roleName: core_1.PhysicalName.GENERATE_IF_NEEDED }), this.passRoleStatement.addResources(this._executionRole.roleArn)), this._executionRole;
      }
      get referencesSecretJsonField() {
        for (const container of this.containers)
          if (container.referencesSecretJsonField)
            return true;
        return false;
      }
      validateTaskDefinition() {
        const ret = new Array();
        if (isEc2Compatible(this.compatibility))
          for (const container of this.containers)
            container.memoryLimitSpecified || ret.push(`ECS Container ${container.containerName} must have at least one of 'memoryLimitMiB' or 'memoryReservationMiB' specified`);
        const portMappingNames = /* @__PURE__ */ new Map();
        return this.containers.forEach((container) => {
          for (const pm of container.portMappings)
            pm.name && (portMappingNames.has(pm.name) && ret.push(`Port mapping name '${pm.name}' cannot appear in both '${container.containerName}' and '${portMappingNames.get(pm.name)}'`), portMappingNames.set(pm.name, container.containerName));
        }), ret;
      }
      findPortMappingByName(name) {
        let portMapping;
        return this.containers.forEach((container) => {
          const pm = container.findPortMappingByName(name);
          pm && (portMapping = pm);
        }), portMapping;
      }
      findContainer(containerName) {
        return this.containers.find((c) => c.containerName === containerName);
      }
      get passRoleStatement() {
        return this._passRoleStatement || (this._passRoleStatement = new iam.PolicyStatement({ effect: iam.Effect.ALLOW, actions: ["iam:PassRole"], resources: this.executionRole ? [this.taskRole.roleArn, this.executionRole.roleArn] : [this.taskRole.roleArn], conditions: { StringLike: { "iam:PassedToService": "ecs-tasks.amazonaws.com" } } })), this._passRoleStatement;
      }
      renderNetworkMode(networkMode) {
        return networkMode === NetworkMode.NAT ? void 0 : networkMode;
      }
      renderContainers() {
        for (const container of this.containers)
          if (container.logDriverConfig && container.logDriverConfig.logDriver === "awsfirelens" && !this.containers.find((x) => x instanceof firelens_log_router_1.FirelensLogRouter)) {
            this.addFirelensLogRouter("log-router", { image: (0, firelens_log_router_1.obtainDefaultFluentBitECRImage)(this, container.logDriverConfig), firelensConfig: { type: firelens_log_router_1.FirelensLogRouterType.FLUENTBIT }, logging: new aws_log_driver_1.AwsLogDriver({ streamPrefix: "firelens" }), memoryReservationMiB: 50 });
            break;
          }
        return this.containers.map((x) => x.renderContainerDefinition());
      }
      checkFargateWindowsBasedTasksSize(cpu, memory, runtimePlatform) {
        if (Number(cpu) === 1024) {
          if (Number(memory) < 1024 || Number(memory) > 8192 || Number(memory) % 1024 !== 0)
            throw new Error(`If provided cpu is ${cpu}, then memoryMiB must have a min of 1024 and a max of 8192, in 1024 increments. Provided memoryMiB was ${Number(memory)}.`);
        } else if (Number(cpu) === 2048) {
          if (Number(memory) < 4096 || Number(memory) > 16384 || Number(memory) % 1024 !== 0)
            throw new Error(`If provided cpu is ${cpu}, then memoryMiB must have a min of 4096 and max of 16384, in 1024 increments. Provided memoryMiB ${Number(memory)}.`);
        } else if (Number(cpu) === 4096) {
          if (Number(memory) < 8192 || Number(memory) > 30720 || Number(memory) % 1024 !== 0)
            throw new Error(`If provided cpu is ${cpu}, then memoryMiB must have a min of 8192 and a max of 30720, in 1024 increments.Provided memoryMiB was ${Number(memory)}.`);
        } else
          throw new Error(`If operatingSystemFamily is ${runtimePlatform.operatingSystemFamily._operatingSystemFamily}, then cpu must be in 1024 (1 vCPU), 2048 (2 vCPU), or 4096 (4 vCPU). Provided value was: ${cpu}`);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, TaskDefinition[_a] = { fqn: "aws-cdk-lib.aws_ecs.TaskDefinition", version: "2.80.0" }, exports2.TaskDefinition = TaskDefinition;
    var EPHEMERAL_PORT_RANGE = ec2.Port.tcpRange(32768, 65535);
    var NetworkMode;
    (function(NetworkMode2) {
      NetworkMode2.NONE = "none", NetworkMode2.BRIDGE = "bridge", NetworkMode2.AWS_VPC = "awsvpc", NetworkMode2.HOST = "host", NetworkMode2.NAT = "nat";
    })(NetworkMode = exports2.NetworkMode || (exports2.NetworkMode = {}));
    var IpcMode;
    (function(IpcMode2) {
      IpcMode2.NONE = "none", IpcMode2.HOST = "host", IpcMode2.TASK = "task";
    })(IpcMode = exports2.IpcMode || (exports2.IpcMode = {}));
    var PidMode;
    (function(PidMode2) {
      PidMode2.HOST = "host", PidMode2.TASK = "task";
    })(PidMode = exports2.PidMode || (exports2.PidMode = {}));
    var Scope;
    (function(Scope2) {
      Scope2.TASK = "task", Scope2.SHARED = "shared";
    })(Scope = exports2.Scope || (exports2.Scope = {}));
    var Compatibility;
    (function(Compatibility2) {
      Compatibility2[Compatibility2.EC2 = 0] = "EC2", Compatibility2[Compatibility2.FARGATE = 1] = "FARGATE", Compatibility2[Compatibility2.EC2_AND_FARGATE = 2] = "EC2_AND_FARGATE", Compatibility2[Compatibility2.EXTERNAL = 3] = "EXTERNAL";
    })(Compatibility = exports2.Compatibility || (exports2.Compatibility = {}));
    function isEc2Compatible(compatibility) {
      return [Compatibility.EC2, Compatibility.EC2_AND_FARGATE].includes(compatibility);
    }
    exports2.isEc2Compatible = isEc2Compatible;
    function isFargateCompatible(compatibility) {
      return [Compatibility.FARGATE, Compatibility.EC2_AND_FARGATE].includes(compatibility);
    }
    exports2.isFargateCompatible = isFargateCompatible;
    function isExternalCompatible(compatibility) {
      return [Compatibility.EXTERNAL].includes(compatibility);
    }
    exports2.isExternalCompatible = isExternalCompatible;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/amis.js
var require_amis = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/amis.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.BottleRocketImage = exports2.BottlerocketEcsVariant = exports2.EcsOptimizedImage = exports2.EcsOptimizedAmi = exports2.WindowsOptimizedVersion = exports2.AmiHardwareType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var ec2 = require_aws_ec2();
    var ssm = require_aws_ssm();
    var AmiHardwareType;
    (function(AmiHardwareType2) {
      AmiHardwareType2.STANDARD = "Standard", AmiHardwareType2.GPU = "GPU", AmiHardwareType2.ARM = "ARM64";
    })(AmiHardwareType = exports2.AmiHardwareType || (exports2.AmiHardwareType = {}));
    var WindowsOptimizedVersion;
    (function(WindowsOptimizedVersion2) {
      WindowsOptimizedVersion2.SERVER_2019 = "2019", WindowsOptimizedVersion2.SERVER_2016 = "2016";
    })(WindowsOptimizedVersion = exports2.WindowsOptimizedVersion || (exports2.WindowsOptimizedVersion = {}));
    var BR_IMAGE_SYMBOL = Symbol.for("@aws-cdk/aws-ecs/lib/amis.BottleRocketImage");
    var EcsOptimizedAmi = class {
      constructor(props) {
        if (this.hwType = props && props.hardwareType || AmiHardwareType.STANDARD, props && props.generation) {
          if (props.generation === ec2.AmazonLinuxGeneration.AMAZON_LINUX && this.hwType !== AmiHardwareType.STANDARD)
            throw new Error("Amazon Linux does not support special hardware type. Use Amazon Linux 2 instead");
          if (props.windowsVersion)
            throw new Error('"windowsVersion" and Linux image "generation" cannot be both set');
          this.generation = props.generation;
        } else if (props && props.windowsVersion) {
          if (this.hwType !== AmiHardwareType.STANDARD)
            throw new Error("Windows Server does not support special hardware type");
          this.windowsVersion = props.windowsVersion;
        } else
          this.generation = ec2.AmazonLinuxGeneration.AMAZON_LINUX_2;
        this.amiParameterName = "/aws/service/ecs/optimized-ami/" + (this.generation === ec2.AmazonLinuxGeneration.AMAZON_LINUX ? "amazon-linux/" : "") + (this.generation === ec2.AmazonLinuxGeneration.AMAZON_LINUX_2 ? "amazon-linux-2/" : "") + (this.windowsVersion ? `windows_server/${this.windowsVersion}/english/full/` : "") + (this.hwType === AmiHardwareType.GPU ? "gpu/" : "") + (this.hwType === AmiHardwareType.ARM ? "arm64/" : "") + "recommended/image_id", this.cachedInContext = props?.cachedInContext ?? false;
      }
      getImage(scope) {
        const ami = lookupImage(scope, this.cachedInContext, this.amiParameterName), osType = this.windowsVersion ? ec2.OperatingSystemType.WINDOWS : ec2.OperatingSystemType.LINUX;
        return { imageId: ami, osType, userData: ec2.UserData.forOperatingSystem(osType) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EcsOptimizedAmi[_a] = { fqn: "aws-cdk-lib.aws_ecs.EcsOptimizedAmi", version: "2.80.0" }, exports2.EcsOptimizedAmi = EcsOptimizedAmi;
    var EcsOptimizedImage = class _EcsOptimizedImage {
      static amazonLinux2(hardwareType = AmiHardwareType.STANDARD, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_AmiHardwareType(hardwareType), jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_EcsOptimizedImageOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.amazonLinux2), error;
        }
        return new _EcsOptimizedImage({ generation: ec2.AmazonLinuxGeneration.AMAZON_LINUX_2, hardwareType, cachedInContext: options.cachedInContext });
      }
      static amazonLinux(options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_EcsOptimizedImageOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.amazonLinux), error;
        }
        return new _EcsOptimizedImage({ generation: ec2.AmazonLinuxGeneration.AMAZON_LINUX, cachedInContext: options.cachedInContext });
      }
      static windows(windowsVersion, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_WindowsOptimizedVersion(windowsVersion), jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_EcsOptimizedImageOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.windows), error;
        }
        return new _EcsOptimizedImage({ windowsVersion, cachedInContext: options.cachedInContext });
      }
      constructor(props) {
        if (this.hwType = props && props.hardwareType, props.windowsVersion)
          this.windowsVersion = props.windowsVersion;
        else if (props.generation)
          this.generation = props.generation;
        else
          throw new Error("This error should never be thrown");
        this.amiParameterName = "/aws/service/ecs/optimized-ami/" + (this.generation === ec2.AmazonLinuxGeneration.AMAZON_LINUX ? "amazon-linux/" : "") + (this.generation === ec2.AmazonLinuxGeneration.AMAZON_LINUX_2 ? "amazon-linux-2/" : "") + (this.windowsVersion ? `windows_server/${this.windowsVersion}/english/full/` : "") + (this.hwType === AmiHardwareType.GPU ? "gpu/" : "") + (this.hwType === AmiHardwareType.ARM ? "arm64/" : "") + "recommended/image_id", this.cachedInContext = props?.cachedInContext ?? false;
      }
      getImage(scope) {
        const ami = lookupImage(scope, this.cachedInContext, this.amiParameterName), osType = this.windowsVersion ? ec2.OperatingSystemType.WINDOWS : ec2.OperatingSystemType.LINUX;
        return { imageId: ami, osType, userData: ec2.UserData.forOperatingSystem(osType) };
      }
    };
    _b = JSII_RTTI_SYMBOL_1, EcsOptimizedImage[_b] = { fqn: "aws-cdk-lib.aws_ecs.EcsOptimizedImage", version: "2.80.0" }, exports2.EcsOptimizedImage = EcsOptimizedImage;
    var BottlerocketEcsVariant;
    (function(BottlerocketEcsVariant2) {
      BottlerocketEcsVariant2.AWS_ECS_1 = "aws-ecs-1";
    })(BottlerocketEcsVariant = exports2.BottlerocketEcsVariant || (exports2.BottlerocketEcsVariant = {}));
    var BottleRocketImage = class _BottleRocketImage {
      static isBottleRocketImage(x) {
        return x !== null && typeof x == "object" && BR_IMAGE_SYMBOL in x;
      }
      constructor(props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_BottleRocketImageProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _BottleRocketImage), error;
        }
        this.variant = props.variant ?? BottlerocketEcsVariant.AWS_ECS_1, this.architecture = props.architecture ?? ec2.InstanceArchitecture.X86_64, this.amiParameterName = `/aws/service/bottlerocket/${this.variant}/${this.architecture}/latest/image_id`, this.cachedInContext = props.cachedInContext ?? false;
      }
      getImage(scope) {
        return { imageId: lookupImage(scope, this.cachedInContext, this.amiParameterName), osType: ec2.OperatingSystemType.LINUX, userData: ec2.UserData.custom("") };
      }
    };
    _c = JSII_RTTI_SYMBOL_1, BottleRocketImage[_c] = { fqn: "aws-cdk-lib.aws_ecs.BottleRocketImage", version: "2.80.0" }, exports2.BottleRocketImage = BottleRocketImage, Object.defineProperty(BottleRocketImage.prototype, BR_IMAGE_SYMBOL, { value: true, enumerable: false, writable: false });
    function lookupImage(scope, cachedInContext, parameterName) {
      return cachedInContext ? ssm.StringParameter.valueFromLookup(scope, parameterName) : ssm.StringParameter.valueForTypedStringParameterV2(scope, parameterName, ssm.ParameterValueType.AWS_EC2_IMAGE_ID);
    }
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/drain-hook/instance-drain-hook.js
var require_instance_drain_hook = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/drain-hook/instance-drain-hook.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.InstanceDrainHook = void 0;
    var fs = require("fs");
    var path = require("path");
    var constructs_1 = require_lib2();
    var autoscaling = require_aws_autoscaling();
    var hooks = require_aws_autoscaling_hooktargets();
    var iam = require_aws_iam();
    var lambda2 = require_aws_lambda();
    var cdk = require_core2();
    var InstanceDrainHook = class extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id);
        const drainTime = props.drainTime || cdk.Duration.minutes(5), fn = new lambda2.Function(this, "Function", { code: lambda2.Code.fromInline(fs.readFileSync(path.join(__dirname, "lambda-source", "index.py"), { encoding: "utf-8" })), handler: "index.lambda_handler", runtime: lambda2.Runtime.PYTHON_3_9, timeout: cdk.Duration.seconds(Math.min(drainTime.toSeconds() + 10, 900)), environment: { CLUSTER: props.cluster.clusterName } });
        props.autoScalingGroup.addLifecycleHook("DrainHook", { lifecycleTransition: autoscaling.LifecycleTransition.INSTANCE_TERMINATING, defaultResult: autoscaling.DefaultResult.CONTINUE, notificationTarget: new hooks.FunctionHook(fn, props.topicEncryptionKey), heartbeatTimeout: drainTime }), fn.addToRolePolicy(new iam.PolicyStatement({ actions: ["ec2:DescribeInstances", "ec2:DescribeInstanceAttribute", "ec2:DescribeInstanceStatus", "ec2:DescribeHosts"], resources: ["*"] })), fn.addToRolePolicy(new iam.PolicyStatement({ actions: ["autoscaling:CompleteLifecycleAction"], resources: [props.autoScalingGroup.autoScalingGroupArn] })), fn.addToRolePolicy(new iam.PolicyStatement({ actions: ["ecs:DescribeContainerInstances", "ecs:DescribeTasks"], resources: ["*"], conditions: { ArnEquals: { "ecs:cluster": props.cluster.clusterArn } } })), fn.addToRolePolicy(new iam.PolicyStatement({ actions: ["ecs:ListContainerInstances", "ecs:SubmitContainerStateChange", "ecs:SubmitTaskStateChange"], resources: [props.cluster.clusterArn] })), fn.addToRolePolicy(new iam.PolicyStatement({ actions: ["ecs:UpdateContainerInstancesState", "ecs:ListTasks"], conditions: { ArnEquals: { "ecs:cluster": props.cluster.clusterArn } }, resources: ["*"] }));
      }
    };
    exports2.InstanceDrainHook = InstanceDrainHook;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/ecs-canned-metrics.generated.js
var require_ecs_canned_metrics_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/ecs-canned-metrics.generated.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ECSMetrics = void 0;
    var ECSMetrics = class {
      static cpuUtilizationAverage(dimensions) {
        return { namespace: "AWS/ECS", metricName: "CPUUtilization", dimensionsMap: dimensions, statistic: "Average" };
      }
      static memoryUtilizationAverage(dimensions) {
        return { namespace: "AWS/ECS", metricName: "MemoryUtilization", dimensionsMap: dimensions, statistic: "Average" };
      }
      static cpuReservationAverage(dimensions) {
        return { namespace: "AWS/ECS", metricName: "CPUReservation", dimensionsMap: dimensions, statistic: "Average" };
      }
      static memoryReservationAverage(dimensions) {
        return { namespace: "AWS/ECS", metricName: "MemoryReservation", dimensionsMap: dimensions, statistic: "Average" };
      }
      static gpuReservationAverage(dimensions) {
        return { namespace: "AWS/ECS", metricName: "GPUReservation", dimensionsMap: dimensions, statistic: "Average" };
      }
    };
    exports2.ECSMetrics = ECSMetrics;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/cluster.js
var require_cluster2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/cluster.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AsgCapacityProvider = exports2.ExecuteCommandLogging = exports2.Cluster = exports2.MachineImageType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var amis_1 = require_amis();
    var instance_drain_hook_1 = require_instance_drain_hook();
    var ecs_canned_metrics_generated_1 = require_ecs_canned_metrics_generated();
    var ecs_generated_1 = require_ecs_generated();
    var autoscaling = require_aws_autoscaling();
    var cloudwatch = require_aws_cloudwatch();
    var ec2 = require_aws_ec2();
    var iam = require_aws_iam();
    var cloudmap = require_aws_servicediscovery();
    var core_1 = require_core2();
    var CLUSTER_SYMBOL = Symbol.for("@aws-cdk/aws-ecs/lib/cluster.Cluster");
    var MachineImageType;
    (function(MachineImageType2) {
      MachineImageType2[MachineImageType2.AMAZON_LINUX_2 = 0] = "AMAZON_LINUX_2", MachineImageType2[MachineImageType2.BOTTLEROCKET = 1] = "BOTTLEROCKET";
    })(MachineImageType = exports2.MachineImageType || (exports2.MachineImageType = {}));
    var Cluster = class _Cluster extends core_1.Resource {
      static isCluster(x) {
        return x !== null && typeof x == "object" && CLUSTER_SYMBOL in x;
      }
      static fromClusterAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_ClusterAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromClusterAttributes), error;
        }
        return new ImportedCluster(scope, id, attrs);
      }
      static fromClusterArn(scope, id, clusterArn) {
        const clusterName = core_1.Stack.of(scope).splitArn(clusterArn, core_1.ArnFormat.SLASH_RESOURCE_NAME).resourceName;
        if (!clusterName)
          throw new Error(`Missing required Cluster Name from Cluster ARN: ${clusterArn}`);
        const errorSuffix = "is not available for a Cluster imported using fromClusterArn(), please use fromClusterAttributes() instead.";
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.clusterArn = clusterArn, this.clusterName = clusterName;
          }
          get hasEc2Capacity() {
            throw new Error(`hasEc2Capacity ${errorSuffix}`);
          }
          get connections() {
            throw new Error(`connections ${errorSuffix}`);
          }
          get vpc() {
            throw new Error(`vpc ${errorSuffix}`);
          }
        }
        return new Import(scope, id, { environmentFromArn: clusterArn });
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.clusterName }), this.connections = new ec2.Connections(), this._capacityProviderNames = [], this._defaultCapacityProviderStrategy = [], this._hasEc2Capacity = false;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_ClusterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Cluster), error;
        }
        let clusterSettings;
        if (props.containerInsights !== void 0 && (clusterSettings = [{ name: "containerInsights", value: props.containerInsights ? ContainerInsights.ENABLED : ContainerInsights.DISABLED }]), this._capacityProviderNames = props.capacityProviders ?? [], props.enableFargateCapacityProviders && this.enableFargateCapacityProviders(), props.executeCommandConfiguration) {
          if (props.executeCommandConfiguration.logging === ExecuteCommandLogging.OVERRIDE != (props.executeCommandConfiguration.logConfiguration !== void 0))
            throw new Error("Execute command log configuration must only be specified when logging is OVERRIDE.");
          this._executeCommandConfiguration = props.executeCommandConfiguration;
        }
        this._cfnCluster = new ecs_generated_1.CfnCluster(this, "Resource", { clusterName: this.physicalName, clusterSettings, configuration: this._executeCommandConfiguration && this.renderExecuteCommandConfiguration() }), this.clusterArn = this.getResourceArnAttribute(this._cfnCluster.attrArn, { service: "ecs", resource: "cluster", resourceName: this.physicalName }), this.clusterName = this.getResourceNameAttribute(this._cfnCluster.ref), this.vpc = props.vpc || new ec2.Vpc(this, "Vpc", { maxAzs: 2 }), this._defaultCloudMapNamespace = props.defaultCloudMapNamespace !== void 0 ? this.addDefaultCloudMapNamespace(props.defaultCloudMapNamespace) : void 0, this._autoscalingGroup = props.capacity !== void 0 ? this.addCapacity("DefaultAutoScalingGroup", props.capacity) : void 0, core_1.Aspects.of(this).add(new MaybeCreateCapacityProviderAssociations(this, id));
      }
      enableFargateCapacityProviders() {
        for (const provider of ["FARGATE", "FARGATE_SPOT"])
          this._capacityProviderNames.includes(provider) || this._capacityProviderNames.push(provider);
      }
      addDefaultCapacityProviderStrategy(defaultCapacityProviderStrategy) {
        if (this._defaultCapacityProviderStrategy.length > 0)
          throw new Error("Cluster default capacity provider strategy is already set.");
        if (defaultCapacityProviderStrategy.some((dcp) => dcp.capacityProvider.includes("FARGATE")) && defaultCapacityProviderStrategy.some((dcp) => !dcp.capacityProvider.includes("FARGATE")))
          throw new Error("A capacity provider strategy cannot contain a mix of capacity providers using Auto Scaling groups and Fargate providers. Specify one or the other and try again.");
        if (defaultCapacityProviderStrategy.forEach((dcp) => {
          if (!this._capacityProviderNames.includes(dcp.capacityProvider))
            throw new Error(`Capacity provider ${dcp.capacityProvider} must be added to the cluster with addAsgCapacityProvider() before it can be used in a default capacity provider strategy.`);
        }), defaultCapacityProviderStrategy.filter((dcp) => !!dcp.base).length > 1)
          throw new Error("Only 1 capacity provider in a capacity provider strategy can have a nonzero base.");
        this._defaultCapacityProviderStrategy = defaultCapacityProviderStrategy;
      }
      renderExecuteCommandConfiguration() {
        return { executeCommandConfiguration: { kmsKeyId: this._executeCommandConfiguration?.kmsKey?.keyArn, logConfiguration: this._executeCommandConfiguration?.logConfiguration && this.renderExecuteCommandLogConfiguration(), logging: this._executeCommandConfiguration?.logging } };
      }
      renderExecuteCommandLogConfiguration() {
        const logConfiguration = this._executeCommandConfiguration?.logConfiguration;
        if (logConfiguration?.s3EncryptionEnabled && !logConfiguration?.s3Bucket)
          throw new Error("You must specify an S3 bucket name in the execute command log configuration to enable S3 encryption.");
        if (logConfiguration?.cloudWatchEncryptionEnabled && !logConfiguration?.cloudWatchLogGroup)
          throw new Error("You must specify a CloudWatch log group in the execute command log configuration to enable CloudWatch encryption.");
        return { cloudWatchEncryptionEnabled: logConfiguration?.cloudWatchEncryptionEnabled, cloudWatchLogGroupName: logConfiguration?.cloudWatchLogGroup?.logGroupName, s3BucketName: logConfiguration?.s3Bucket?.bucketName, s3EncryptionEnabled: logConfiguration?.s3EncryptionEnabled, s3KeyPrefix: logConfiguration?.s3KeyPrefix };
      }
      addDefaultCloudMapNamespace(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_CloudMapNamespaceOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addDefaultCloudMapNamespace), error;
        }
        if (this._defaultCloudMapNamespace !== void 0)
          throw new Error("Can only add default namespace once.");
        const namespaceType = options.type !== void 0 ? options.type : cloudmap.NamespaceType.DNS_PRIVATE;
        let sdNamespace;
        switch (namespaceType) {
          case cloudmap.NamespaceType.DNS_PRIVATE:
            sdNamespace = new cloudmap.PrivateDnsNamespace(this, "DefaultServiceDiscoveryNamespace", { name: options.name, vpc: this.vpc });
            break;
          case cloudmap.NamespaceType.DNS_PUBLIC:
            sdNamespace = new cloudmap.PublicDnsNamespace(this, "DefaultServiceDiscoveryNamespace", { name: options.name });
            break;
          case cloudmap.NamespaceType.HTTP:
            sdNamespace = new cloudmap.HttpNamespace(this, "DefaultServiceDiscoveryNamespace", { name: options.name });
            break;
          default:
            throw new Error(`Namespace type ${namespaceType} is not supported.`);
        }
        return this._defaultCloudMapNamespace = sdNamespace, options.useForServiceConnect && (this._cfnCluster.serviceConnectDefaults = { namespace: options.name }), sdNamespace;
      }
      get defaultCapacityProviderStrategy() {
        return this._defaultCapacityProviderStrategy;
      }
      get capacityProviderNames() {
        return this._capacityProviderNames;
      }
      get defaultCloudMapNamespace() {
        return this._defaultCloudMapNamespace;
      }
      addCapacity(id, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_AddCapacityOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addCapacity), error;
        }
        const machineImage = options.machineImage ?? (options.machineImageType === MachineImageType.BOTTLEROCKET ? new amis_1.BottleRocketImage({ architecture: options.instanceType.architecture }) : new amis_1.EcsOptimizedAmi()), machineImageType = options.machineImageType ?? (amis_1.BottleRocketImage.isBottleRocketImage(machineImage) ? MachineImageType.BOTTLEROCKET : MachineImageType.AMAZON_LINUX_2), autoScalingGroup = new autoscaling.AutoScalingGroup(this, id, { vpc: this.vpc, machineImage, updateType: options.updatePolicy ? void 0 : options.updateType || autoscaling.UpdateType.REPLACING_UPDATE, ...options });
        return this.addAutoScalingGroup(autoScalingGroup, { machineImageType, ...options }), autoScalingGroup;
      }
      addAsgCapacityProvider(provider, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_AsgCapacityProvider(provider), jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_AddAutoScalingGroupCapacityOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addAsgCapacityProvider), error;
        }
        this._capacityProviderNames.includes(provider.capacityProviderName) || (this._hasEc2Capacity = true, this.configureAutoScalingGroup(provider.autoScalingGroup, { ...options, machineImageType: provider.machineImageType, taskDrainTime: provider.enableManagedTerminationProtection ? core_1.Duration.seconds(0) : options.taskDrainTime, canContainersAccessInstanceRole: options.canContainersAccessInstanceRole ?? provider.canContainersAccessInstanceRole }), this._capacityProviderNames.push(provider.capacityProviderName));
      }
      addAutoScalingGroup(autoScalingGroup, options = {}) {
        this._hasEc2Capacity = true, this.connections.connections.addSecurityGroup(...autoScalingGroup.connections.securityGroups), this.configureAutoScalingGroup(autoScalingGroup, options);
      }
      configureAutoScalingGroup(autoScalingGroup, options = {}) {
        if (autoScalingGroup.osType === ec2.OperatingSystemType.WINDOWS)
          this.configureWindowsAutoScalingGroup(autoScalingGroup, options);
        else
          switch (options.machineImageType) {
            case MachineImageType.BOTTLEROCKET: {
              autoScalingGroup.addUserData("[settings.ecs]", `cluster = "${this.clusterName}"`), autoScalingGroup.role.addManagedPolicy(iam.ManagedPolicy.fromAwsManagedPolicyName("AmazonSSMManagedInstanceCore")), autoScalingGroup.role.addManagedPolicy(iam.ManagedPolicy.fromAwsManagedPolicyName("service-role/AmazonEC2ContainerServiceforEC2Role"));
              break;
            }
            default:
              autoScalingGroup.addUserData(`echo ECS_CLUSTER=${this.clusterName} >> /etc/ecs/ecs.config`), options.canContainersAccessInstanceRole || (autoScalingGroup.addUserData("sudo iptables --insert FORWARD 1 --in-interface docker+ --destination 169.254.169.254/32 --jump DROP"), autoScalingGroup.addUserData("sudo service iptables save"), autoScalingGroup.addUserData("echo ECS_AWSVPC_BLOCK_IMDS=true >> /etc/ecs/ecs.config")), autoScalingGroup.spotPrice && options.spotInstanceDraining && autoScalingGroup.addUserData("echo ECS_ENABLE_SPOT_INSTANCE_DRAINING=true >> /etc/ecs/ecs.config");
          }
        autoScalingGroup.addToRolePolicy(new iam.PolicyStatement({ actions: ["ecs:DeregisterContainerInstance", "ecs:RegisterContainerInstance", "ecs:Submit*"], resources: [this.clusterArn] })), autoScalingGroup.addToRolePolicy(new iam.PolicyStatement({ actions: ["ecs:Poll", "ecs:StartTelemetrySession"], resources: ["*"], conditions: { ArnEquals: { "ecs:cluster": this.clusterArn } } })), autoScalingGroup.addToRolePolicy(new iam.PolicyStatement({ actions: ["ecs:DiscoverPollEndpoint", "ecr:GetAuthorizationToken", "logs:CreateLogStream", "logs:PutLogEvents"], resources: ["*"] })), (!options.taskDrainTime || options.taskDrainTime.toSeconds() !== 0) && new instance_drain_hook_1.InstanceDrainHook(autoScalingGroup, "DrainECSHook", { autoScalingGroup, cluster: this, drainTime: options.taskDrainTime, topicEncryptionKey: options.topicEncryptionKey });
      }
      addCapacityProvider(provider) {
        if (!(provider === "FARGATE" || provider === "FARGATE_SPOT"))
          throw new Error("CapacityProvider not supported");
        this._capacityProviderNames.includes(provider) || this._capacityProviderNames.push(provider);
      }
      configureWindowsAutoScalingGroup(autoScalingGroup, options = {}) {
        autoScalingGroup.addUserData("Remove-Item -Recurse C:\\ProgramData\\Amazon\\ECS\\Cache"), autoScalingGroup.addUserData("Import-Module ECSTools"), autoScalingGroup.addUserData(`[Environment]::SetEnvironmentVariable("ECS_CLUSTER", "${this.clusterName}", "Machine")`), autoScalingGroup.addUserData('[Environment]::SetEnvironmentVariable("ECS_ENABLE_AWSLOGS_EXECUTIONROLE_OVERRIDE", "true", "Machine")'), autoScalingGroup.addUserData(`[Environment]::SetEnvironmentVariable("ECS_AVAILABLE_LOGGING_DRIVERS", '["json-file","awslogs"]', "Machine")`), autoScalingGroup.spotPrice && options.spotInstanceDraining && autoScalingGroup.addUserData('[Environment]::SetEnvironmentVariable("ECS_ENABLE_SPOT_INSTANCE_DRAINING", "true", "Machine")'), options.canContainersAccessInstanceRole ? autoScalingGroup.addUserData(`Initialize-ECSAgent -Cluster '${this.clusterName}'`) : (autoScalingGroup.addUserData('[Environment]::SetEnvironmentVariable("ECS_ENABLE_TASK_IAM_ROLE", "true", "Machine")'), autoScalingGroup.addUserData(`Initialize-ECSAgent -Cluster '${this.clusterName}' -EnableTaskIAMRole`));
      }
      get autoscalingGroup() {
        return this._autoscalingGroup;
      }
      get hasEc2Capacity() {
        return this._hasEc2Capacity;
      }
      get executeCommandConfiguration() {
        return this._executeCommandConfiguration;
      }
      metricCpuReservation(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricCpuReservation), error;
        }
        return this.cannedMetric(ecs_canned_metrics_generated_1.ECSMetrics.cpuReservationAverage, props);
      }
      metricCpuUtilization(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricCpuUtilization), error;
        }
        return this.cannedMetric(ecs_canned_metrics_generated_1.ECSMetrics.cpuUtilizationAverage, props);
      }
      metricMemoryReservation(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricMemoryReservation), error;
        }
        return this.cannedMetric(ecs_canned_metrics_generated_1.ECSMetrics.memoryReservationAverage, props);
      }
      metricMemoryUtilization(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricMemoryUtilization), error;
        }
        return this.cannedMetric(ecs_canned_metrics_generated_1.ECSMetrics.memoryUtilizationAverage, props);
      }
      metric(metricName, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metric), error;
        }
        return new cloudwatch.Metric({ namespace: "AWS/ECS", metricName, dimensionsMap: { ClusterName: this.clusterName }, ...props }).attachTo(this);
      }
      cannedMetric(fn, props) {
        return new cloudwatch.Metric({ ...fn({ ClusterName: this.clusterName }), ...props }).attachTo(this);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Cluster[_a] = { fqn: "aws-cdk-lib.aws_ecs.Cluster", version: "2.80.0" }, exports2.Cluster = Cluster, Object.defineProperty(Cluster.prototype, CLUSTER_SYMBOL, { value: true, enumerable: false, writable: false });
    var ImportedCluster = class extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id), this.connections = new ec2.Connections(), this.clusterName = props.clusterName, this.vpc = props.vpc, this.hasEc2Capacity = props.hasEc2Capacity !== false, this._defaultCloudMapNamespace = props.defaultCloudMapNamespace, this._executeCommandConfiguration = props.executeCommandConfiguration, this.clusterArn = props.clusterArn ?? core_1.Stack.of(this).formatArn({ service: "ecs", resource: "cluster", resourceName: props.clusterName }), this.connections = new ec2.Connections({ securityGroups: props.securityGroups });
      }
      get defaultCloudMapNamespace() {
        return this._defaultCloudMapNamespace;
      }
      get executeCommandConfiguration() {
        return this._executeCommandConfiguration;
      }
    };
    var ContainerInsights;
    (function(ContainerInsights2) {
      ContainerInsights2.ENABLED = "enabled", ContainerInsights2.DISABLED = "disabled";
    })(ContainerInsights || (ContainerInsights = {}));
    var ExecuteCommandLogging;
    (function(ExecuteCommandLogging2) {
      ExecuteCommandLogging2.NONE = "NONE", ExecuteCommandLogging2.DEFAULT = "DEFAULT", ExecuteCommandLogging2.OVERRIDE = "OVERRIDE";
    })(ExecuteCommandLogging = exports2.ExecuteCommandLogging || (exports2.ExecuteCommandLogging = {}));
    var AsgCapacityProvider = class _AsgCapacityProvider extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_AsgCapacityProviderProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AsgCapacityProvider), error;
        }
        if (this.autoScalingGroup = props.autoScalingGroup, this.machineImageType = props.machineImageType ?? MachineImageType.AMAZON_LINUX_2, this.canContainersAccessInstanceRole = props.canContainersAccessInstanceRole, this.enableManagedTerminationProtection = props.enableManagedTerminationProtection ?? true, this.enableManagedTerminationProtection && props.enableManagedScaling === false)
          throw new Error("Cannot enable Managed Termination Protection on a Capacity Provider when Managed Scaling is disabled. Either enable Managed Scaling or disable Managed Termination Protection.");
        if (this.enableManagedTerminationProtection && this.autoScalingGroup.protectNewInstancesFromScaleIn(), props.capacityProviderName && !/^(?!aws|ecs|fargate).+/gm.test(props.capacityProviderName))
          throw new Error(`Invalid Capacity Provider Name: ${props.capacityProviderName}, If a name is specified, it cannot start with aws, ecs, or fargate.`);
        const capacityProvider = new ecs_generated_1.CfnCapacityProvider(this, id, { name: props.capacityProviderName, autoScalingGroupProvider: { autoScalingGroupArn: this.autoScalingGroup.autoScalingGroupName, managedScaling: props.enableManagedScaling === false ? void 0 : { status: "ENABLED", targetCapacity: props.targetCapacityPercent || 100, maximumScalingStepSize: props.maximumScalingStepSize, minimumScalingStepSize: props.minimumScalingStepSize }, managedTerminationProtection: this.enableManagedTerminationProtection ? "ENABLED" : "DISABLED" } });
        this.capacityProviderName = capacityProvider.ref;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, AsgCapacityProvider[_b] = { fqn: "aws-cdk-lib.aws_ecs.AsgCapacityProvider", version: "2.80.0" }, exports2.AsgCapacityProvider = AsgCapacityProvider;
    var MaybeCreateCapacityProviderAssociations = class {
      constructor(scope, id) {
        this.scope = scope, this.id = id;
      }
      visit(node) {
        Cluster.isCluster(node) && (this.scope.defaultCapacityProviderStrategy.length > 0 || this.scope.capacityProviderNames.length > 0 && !this.resource) && (this.resource = new ecs_generated_1.CfnClusterCapacityProviderAssociations(this.scope, this.id, { cluster: node.clusterName, defaultCapacityProviderStrategy: this.scope.defaultCapacityProviderStrategy, capacityProviders: this.scope.capacityProviderNames }));
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/base/base-service.js
var require_base_service = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/base/base-service.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PropagatedTagSource = exports2.DeploymentControllerType = exports2.LaunchType = exports2.BaseService = exports2.ListenerConfig = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var scalable_task_count_1 = require_scalable_task_count();
    var appscaling = require_aws_applicationautoscaling();
    var cloudwatch = require_aws_cloudwatch();
    var ec2 = require_aws_ec2();
    var elbv2 = require_aws_elasticloadbalancingv2();
    var iam = require_aws_iam();
    var cloudmap = require_aws_servicediscovery();
    var core_1 = require_core2();
    var cxapi = require_cx_api();
    var task_definition_1 = require_task_definition();
    var cluster_1 = require_cluster2();
    var ecs_generated_1 = require_ecs_generated();
    var ListenerConfig = class {
      static applicationListener(listener, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationListener(listener), jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_AddApplicationTargetsProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.applicationListener), error;
        }
        return new ApplicationListenerConfig(listener, props);
      }
      static networkListener(listener, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_NetworkListener(listener), jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_AddNetworkTargetsProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.networkListener), error;
        }
        return new NetworkListenerConfig(listener, props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ListenerConfig[_a] = { fqn: "aws-cdk-lib.aws_ecs.ListenerConfig", version: "2.80.0" }, exports2.ListenerConfig = ListenerConfig;
    var ApplicationListenerConfig = class extends ListenerConfig {
      constructor(listener, props) {
        super(), this.listener = listener, this.props = props;
      }
      addTargets(id, target, service) {
        const props = this.props || {}, protocol = props.protocol, port = props.port ?? (protocol === elbv2.ApplicationProtocol.HTTPS ? 443 : 80);
        this.listener.addTargets(id, { ...props, targets: [service.loadBalancerTarget({ ...target })], port });
      }
    };
    var NetworkListenerConfig = class extends ListenerConfig {
      constructor(listener, props) {
        super(), this.listener = listener, this.props = props;
      }
      addTargets(id, target, service) {
        const port = this.props?.port ?? 80;
        this.listener.addTargets(id, { ...this.props, targets: [service.loadBalancerTarget({ ...target })], port });
      }
    };
    var BaseService = class _BaseService extends core_1.Resource {
      static fromServiceArnWithCluster(scope, id, serviceArn) {
        const arn = core_1.Stack.of(scope).splitArn(serviceArn, core_1.ArnFormat.SLASH_RESOURCE_NAME), resourceName = arn.resourceName;
        if (!resourceName)
          throw new Error("Missing resource Name from service ARN: ${serviceArn}");
        const resourceNameParts = resourceName.split("/");
        if (resourceNameParts.length !== 2)
          throw new Error(`resource name ${resourceName} from service ARN: ${serviceArn} is not using the ARN cluster format`);
        const clusterName = resourceNameParts[0], serviceName = resourceNameParts[1], clusterArn = core_1.Stack.of(scope).formatArn({ partition: arn.partition, region: arn.region, account: arn.account, service: "ecs", resource: "cluster", resourceName: clusterName }), cluster = cluster_1.Cluster.fromClusterArn(scope, `${id}Cluster`, clusterArn);
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.serviceArn = serviceArn, this.serviceName = serviceName, this.cluster = cluster;
          }
        }
        return new Import(scope, id, { environmentFromArn: serviceArn });
      }
      constructor(scope, id, props, additionalProps, taskDefinition) {
        super(scope, id, { physicalName: props.serviceName }), this.connections = new ec2.Connections(), this.loadBalancers = new Array(), this.serviceRegistries = new Array();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_BaseServiceProps(props), jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_TaskDefinition(taskDefinition);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _BaseService), error;
        }
        if (props.propagateTags && props.propagateTaskTagsFrom)
          throw new Error("You can only specify either propagateTags or propagateTaskTagsFrom. Alternatively, you can leave both blank");
        this.taskDefinition = taskDefinition;
        const launchType = props.deploymentController?.type === DeploymentControllerType.EXTERNAL || props.capacityProviderStrategies !== void 0 ? void 0 : props.launchType, propagateTagsFromSource = props.propagateTaskTagsFrom ?? props.propagateTags ?? PropagatedTagSource.NONE, deploymentController = this.getDeploymentController(props);
        if (this.resource = new ecs_generated_1.CfnService(this, "Service", { desiredCount: props.desiredCount, serviceName: this.physicalName, loadBalancers: core_1.Lazy.any({ produce: () => this.loadBalancers }, { omitEmptyArray: true }), deploymentConfiguration: { maximumPercent: props.maxHealthyPercent || 200, minimumHealthyPercent: props.minHealthyPercent === void 0 ? 50 : props.minHealthyPercent, deploymentCircuitBreaker: props.circuitBreaker ? { enable: true, rollback: props.circuitBreaker.rollback ?? false } : void 0 }, propagateTags: propagateTagsFromSource === PropagatedTagSource.NONE ? void 0 : props.propagateTags, enableEcsManagedTags: props.enableECSManagedTags ?? false, deploymentController, launchType, enableExecuteCommand: props.enableExecuteCommand, capacityProviderStrategy: props.capacityProviderStrategies, healthCheckGracePeriodSeconds: this.evaluateHealthGracePeriod(props.healthCheckGracePeriod), networkConfiguration: core_1.Lazy.any({ produce: () => this.networkConfiguration }, { omitEmptyArray: true }), serviceRegistries: core_1.Lazy.any({ produce: () => this.serviceRegistries }, { omitEmptyArray: true }), serviceConnectConfiguration: core_1.Lazy.any({ produce: () => this._serviceConnectConfig }, { omitEmptyArray: true }), ...additionalProps }), props.deploymentController?.type === DeploymentControllerType.EXTERNAL && core_1.Annotations.of(this).addWarning("taskDefinition and launchType are blanked out when using external deployment controller."), props.circuitBreaker && deploymentController && deploymentController.type !== DeploymentControllerType.ECS && core_1.Annotations.of(this).addError("Deployment circuit breaker requires the ECS deployment controller."), props.deploymentController?.type === DeploymentControllerType.CODE_DEPLOY && (this.resource.taskDefinition = taskDefinition.family, this.node.addDependency(taskDefinition)), this.serviceArn = this.getResourceArnAttribute(this.resource.ref, { service: "ecs", resource: "service", resourceName: `${props.cluster.clusterName}/${this.physicalName}` }), this.serviceName = this.getResourceNameAttribute(this.resource.attrName), this.cluster = props.cluster, props.cloudMapOptions && this.enableCloudMap(props.cloudMapOptions), props.serviceConnectConfiguration && this.enableServiceConnect(props.serviceConnectConfiguration), props.enableExecuteCommand) {
          this.enableExecuteCommand();
          const logging = this.cluster.executeCommandConfiguration?.logging ?? cluster_1.ExecuteCommandLogging.DEFAULT;
          this.cluster.executeCommandConfiguration?.kmsKey && this.enableExecuteCommandEncryption(logging), logging !== cluster_1.ExecuteCommandLogging.NONE && this.executeCommandLogConfiguration();
        }
        this.node.defaultChild = this.resource;
      }
      enableServiceConnect(config) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_ServiceConnectProps(config);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.enableServiceConnect), error;
        }
        if (this._serviceConnectConfig)
          throw new Error("Service connect configuration cannot be specified more than once.");
        this.validateServiceConnectConfiguration(config);
        let cfg = config || {}, namespace;
        this.cluster.defaultCloudMapNamespace && (namespace = this.cluster.defaultCloudMapNamespace.namespaceName), cfg.namespace && (namespace = cfg.namespace);
        const services = cfg.services?.map((svc) => {
          const containerPort = this.taskDefinition.findPortMappingByName(svc.portMappingName)?.containerPort;
          if (!containerPort)
            throw new Error(`Port mapping with name ${svc.portMappingName} does not exist.`);
          const alias = { port: svc.port || containerPort, dnsName: svc.dnsName };
          return { portName: svc.portMappingName, discoveryName: svc.discoveryName, ingressPortOverride: svc.ingressPortOverride, clientAliases: [alias] };
        });
        let logConfig;
        cfg.logDriver && this.taskDefinition.defaultContainer && (logConfig = cfg.logDriver.bind(this, this.taskDefinition.defaultContainer)), this._serviceConnectConfig = { enabled: true, logConfiguration: logConfig, namespace, services };
      }
      validateServiceConnectConfiguration(config) {
        if (!this.taskDefinition.defaultContainer)
          throw new Error("Task definition must have at least one container to enable service connect.");
        if ((!config || !config.namespace) && !this.cluster.defaultCloudMapNamespace)
          throw new Error("Namespace must be defined either in serviceConnectConfig or cluster.defaultCloudMapNamespace");
        if (!config || !config.services)
          return;
        let portNames = /* @__PURE__ */ new Map();
        config.services.forEach((serviceConnectService) => {
          if (!this.taskDefinition.findPortMappingByName(serviceConnectService.portMappingName))
            throw new Error(`Port Mapping '${serviceConnectService.portMappingName}' does not exist on the task definition.`);
          const discoveryName = serviceConnectService.discoveryName || serviceConnectService.portMappingName;
          if (portNames.get(serviceConnectService.portMappingName)?.includes(discoveryName))
            throw new Error(`Cannot create multiple services with the discoveryName '${discoveryName}'.`);
          let currentDiscoveries = portNames.get(serviceConnectService.portMappingName);
          if (currentDiscoveries ? (currentDiscoveries.push(discoveryName), portNames.set(serviceConnectService.portMappingName, currentDiscoveries)) : portNames.set(serviceConnectService.portMappingName, [discoveryName]), serviceConnectService.ingressPortOverride && !this.isValidPort(serviceConnectService.ingressPortOverride))
            throw new Error(`ingressPortOverride ${serviceConnectService.ingressPortOverride} is not valid.`);
          if (serviceConnectService.port && !this.isValidPort(serviceConnectService.port))
            throw new Error(`Client Alias port ${serviceConnectService.port} is not valid.`);
        });
      }
      isValidPort(port) {
        return !!(port && Number.isInteger(port) && port >= _BaseService.MIN_PORT && port <= _BaseService.MAX_PORT);
      }
      get cloudMapService() {
        return this.cloudmapService;
      }
      getDeploymentController(props) {
        if (props.deploymentController)
          return props.deploymentController;
        if (!core_1.FeatureFlags.of(this).isEnabled(cxapi.ECS_DISABLE_EXPLICIT_DEPLOYMENT_CONTROLLER_FOR_CIRCUIT_BREAKER) && props.circuitBreaker)
          return { type: DeploymentControllerType.ECS };
      }
      executeCommandLogConfiguration() {
        const logConfiguration = this.cluster.executeCommandConfiguration?.logConfiguration;
        this.taskDefinition.addToTaskRolePolicy(new iam.PolicyStatement({ actions: ["logs:DescribeLogGroups"], resources: ["*"] }));
        const logGroupArn = logConfiguration?.cloudWatchLogGroup ? `arn:${this.stack.partition}:logs:${this.env.region}:${this.env.account}:log-group:${logConfiguration.cloudWatchLogGroup.logGroupName}:*` : "*";
        this.taskDefinition.addToTaskRolePolicy(new iam.PolicyStatement({ actions: ["logs:CreateLogStream", "logs:DescribeLogStreams", "logs:PutLogEvents"], resources: [logGroupArn] })), logConfiguration?.s3Bucket?.bucketName && (this.taskDefinition.addToTaskRolePolicy(new iam.PolicyStatement({ actions: ["s3:GetBucketLocation"], resources: ["*"] })), this.taskDefinition.addToTaskRolePolicy(new iam.PolicyStatement({ actions: ["s3:PutObject"], resources: [`arn:${this.stack.partition}:s3:::${logConfiguration.s3Bucket.bucketName}/*`] })), logConfiguration.s3EncryptionEnabled && this.taskDefinition.addToTaskRolePolicy(new iam.PolicyStatement({ actions: ["s3:GetEncryptionConfiguration"], resources: [`arn:${this.stack.partition}:s3:::${logConfiguration.s3Bucket.bucketName}`] })));
      }
      enableExecuteCommandEncryption(logging) {
        this.taskDefinition.addToTaskRolePolicy(new iam.PolicyStatement({ actions: ["kms:Decrypt", "kms:GenerateDataKey"], resources: [`${this.cluster.executeCommandConfiguration?.kmsKey?.keyArn}`] })), this.cluster.executeCommandConfiguration?.kmsKey?.addToResourcePolicy(new iam.PolicyStatement({ actions: ["kms:*"], resources: ["*"], principals: [new iam.ArnPrincipal(`arn:${this.stack.partition}:iam::${this.env.account}:root`)] })), (logging === cluster_1.ExecuteCommandLogging.DEFAULT || this.cluster.executeCommandConfiguration?.logConfiguration?.cloudWatchEncryptionEnabled) && this.cluster.executeCommandConfiguration?.kmsKey?.addToResourcePolicy(new iam.PolicyStatement({ actions: ["kms:Encrypt*", "kms:Decrypt*", "kms:ReEncrypt*", "kms:GenerateDataKey*", "kms:Describe*"], resources: ["*"], principals: [new iam.ServicePrincipal(`logs.${this.env.region}.amazonaws.com`)], conditions: { ArnLike: { "kms:EncryptionContext:aws:logs:arn": `arn:${this.stack.partition}:logs:${this.env.region}:${this.env.account}:*` } } }));
      }
      attachToApplicationTargetGroup(targetGroup) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_IApplicationTargetGroup(targetGroup);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.attachToApplicationTargetGroup), error;
        }
        return this.defaultLoadBalancerTarget.attachToApplicationTargetGroup(targetGroup);
      }
      attachToClassicLB(loadBalancer) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancing_LoadBalancer(loadBalancer);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.attachToClassicLB), error;
        }
        return this.defaultLoadBalancerTarget.attachToClassicLB(loadBalancer);
      }
      loadBalancerTarget(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_LoadBalancerTargetOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.loadBalancerTarget), error;
        }
        const self2 = this, target = this.taskDefinition._validateTarget(options), connections = self2.connections;
        return { attachToApplicationTargetGroup(targetGroup) {
          return targetGroup.registerConnectable(self2, self2.taskDefinition._portRangeFromPortMapping(target.portMapping)), self2.attachToELBv2(targetGroup, target.containerName, target.portMapping.containerPort);
        }, attachToNetworkTargetGroup(targetGroup) {
          return self2.attachToELBv2(targetGroup, target.containerName, target.portMapping.containerPort);
        }, connections, attachToClassicLB(loadBalancer) {
          return self2.attachToELB(loadBalancer, target.containerName, target.portMapping.containerPort);
        } };
      }
      registerLoadBalancerTargets(...targets) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_EcsTarget(targets);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.registerLoadBalancerTargets), error;
        }
        for (const target of targets)
          target.listener.addTargets(target.newTargetGroupId, { containerName: target.containerName, containerPort: target.containerPort, protocol: target.protocol }, this);
      }
      attachToNetworkTargetGroup(targetGroup) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_INetworkTargetGroup(targetGroup);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.attachToNetworkTargetGroup), error;
        }
        return this.defaultLoadBalancerTarget.attachToNetworkTargetGroup(targetGroup);
      }
      autoScaleTaskCount(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_applicationautoscaling_EnableScalingProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.autoScaleTaskCount), error;
        }
        if (this.scalableTaskCount)
          throw new Error("AutoScaling of task count already enabled for this service");
        return this.scalableTaskCount = new scalable_task_count_1.ScalableTaskCount(this, "TaskCount", { serviceNamespace: appscaling.ServiceNamespace.ECS, resourceId: `service/${this.cluster.clusterName}/${this.serviceName}`, dimension: "ecs:service:DesiredCount", role: this.makeAutoScalingRole(), ...props });
      }
      enableCloudMap(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_CloudMapOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.enableCloudMap), error;
        }
        const sdNamespace = options.cloudMapNamespace ?? this.cluster.defaultCloudMapNamespace;
        if (sdNamespace === void 0)
          throw new Error("Cannot enable service discovery if a Cloudmap Namespace has not been created in the cluster.");
        if (sdNamespace.type === cloudmap.NamespaceType.HTTP)
          throw new Error("Cannot enable DNS service discovery for HTTP Cloudmap Namespace.");
        const networkMode = this.taskDefinition.networkMode;
        if (networkMode === task_definition_1.NetworkMode.NONE)
          throw new Error("Cannot use a service discovery if NetworkMode is None. Use Bridge, Host or AwsVpc instead.");
        let dnsRecordType = options.dnsRecordType;
        if ((networkMode === task_definition_1.NetworkMode.BRIDGE || networkMode === task_definition_1.NetworkMode.HOST) && (dnsRecordType === void 0 && (dnsRecordType = cloudmap.DnsRecordType.SRV), dnsRecordType !== cloudmap.DnsRecordType.SRV))
          throw new Error("SRV records must be used when network mode is Bridge or Host.");
        networkMode === task_definition_1.NetworkMode.AWS_VPC && dnsRecordType === void 0 && (dnsRecordType = cloudmap.DnsRecordType.A);
        const { containerName, containerPort } = determineContainerNameAndPort({ taskDefinition: this.taskDefinition, dnsRecordType, container: options.container, containerPort: options.containerPort }), cloudmapService = new cloudmap.Service(this, "CloudmapService", { namespace: sdNamespace, name: options.name, dnsRecordType, customHealthCheck: { failureThreshold: options.failureThreshold || 1 }, dnsTtl: options.dnsTtl }), serviceArn = cloudmapService.serviceArn;
        return this.addServiceRegistry({ arn: serviceArn, containerName, containerPort }), this.cloudmapService = cloudmapService, cloudmapService;
      }
      associateCloudMapService(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_AssociateCloudMapServiceOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.associateCloudMapService), error;
        }
        const service = options.service, { containerName, containerPort } = determineContainerNameAndPort({ taskDefinition: this.taskDefinition, dnsRecordType: service.dnsRecordType, container: options.container, containerPort: options.containerPort });
        this.addServiceRegistry({ arn: service.serviceArn, containerName, containerPort });
      }
      metric(metricName, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metric), error;
        }
        return new cloudwatch.Metric({ namespace: "AWS/ECS", metricName, dimensionsMap: { ClusterName: this.cluster.clusterName, ServiceName: this.serviceName }, ...props }).attachTo(this);
      }
      metricMemoryUtilization(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricMemoryUtilization), error;
        }
        return this.metric("MemoryUtilization", props);
      }
      metricCpuUtilization(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_MetricOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.metricCpuUtilization), error;
        }
        return this.metric("CPUUtilization", props);
      }
      configureAwsVpcNetworking(vpc, assignPublicIp, vpcSubnets, securityGroup) {
        vpcSubnets === void 0 && (vpcSubnets = assignPublicIp ? { subnetType: ec2.SubnetType.PUBLIC } : {}), securityGroup === void 0 && (securityGroup = new ec2.SecurityGroup(this, "SecurityGroup", { vpc })), this.connections.addSecurityGroup(securityGroup), this.networkConfiguration = { awsvpcConfiguration: { assignPublicIp: assignPublicIp ? "ENABLED" : "DISABLED", subnets: vpc.selectSubnets(vpcSubnets).subnetIds, securityGroups: core_1.Lazy.list({ produce: () => [securityGroup.securityGroupId] }) } };
      }
      configureAwsVpcNetworkingWithSecurityGroups(vpc, assignPublicIp, vpcSubnets, securityGroups) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_IVpc(vpc), jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_SubnetSelection(vpcSubnets);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.configureAwsVpcNetworkingWithSecurityGroups), error;
        }
        vpcSubnets === void 0 && (vpcSubnets = assignPublicIp ? { subnetType: ec2.SubnetType.PUBLIC } : {}), (securityGroups === void 0 || securityGroups.length === 0) && (securityGroups = [new ec2.SecurityGroup(this, "SecurityGroup", { vpc })]), securityGroups.forEach((sg) => {
          this.connections.addSecurityGroup(sg);
        }, this), this.networkConfiguration = { awsvpcConfiguration: { assignPublicIp: assignPublicIp ? "ENABLED" : "DISABLED", subnets: vpc.selectSubnets(vpcSubnets).subnetIds, securityGroups: securityGroups.map((sg) => sg.securityGroupId) } };
      }
      renderServiceRegistry(registry) {
        return { registryArn: registry.arn, containerName: registry.containerName, containerPort: registry.containerPort };
      }
      attachToELB(loadBalancer, containerName, containerPort) {
        if (this.taskDefinition.networkMode === task_definition_1.NetworkMode.AWS_VPC)
          throw new Error("Cannot use a Classic Load Balancer if NetworkMode is AwsVpc. Use Host or Bridge instead.");
        if (this.taskDefinition.networkMode === task_definition_1.NetworkMode.NONE)
          throw new Error("Cannot use a Classic Load Balancer if NetworkMode is None. Use Host or Bridge instead.");
        this.loadBalancers.push({ loadBalancerName: loadBalancer.loadBalancerName, containerName, containerPort });
      }
      attachToELBv2(targetGroup, containerName, containerPort) {
        if (this.taskDefinition.networkMode === task_definition_1.NetworkMode.NONE)
          throw new Error("Cannot use a load balancer if NetworkMode is None. Use Bridge, Host or AwsVpc instead.");
        return this.loadBalancers.push({ targetGroupArn: targetGroup.targetGroupArn, containerName, containerPort }), this.resource.node.addDependency(targetGroup.loadBalancerAttached), { targetType: this.taskDefinition.networkMode === task_definition_1.NetworkMode.AWS_VPC ? elbv2.TargetType.IP : elbv2.TargetType.INSTANCE };
      }
      get defaultLoadBalancerTarget() {
        return this.loadBalancerTarget({ containerName: this.taskDefinition.defaultContainer.containerName });
      }
      makeAutoScalingRole() {
        return iam.Role.fromRoleArn(this, "ScalingRole", core_1.Stack.of(this).formatArn({ region: "", service: "iam", resource: "role/aws-service-role/ecs.application-autoscaling.amazonaws.com", resourceName: "AWSServiceRoleForApplicationAutoScaling_ECSService" }));
      }
      addServiceRegistry(registry) {
        if (this.serviceRegistries.length >= 1)
          throw new Error("Cannot associate with the given service discovery registry. ECS supports at most one service registry per service.");
        const sr = this.renderServiceRegistry(registry);
        this.serviceRegistries.push(sr);
      }
      evaluateHealthGracePeriod(providedHealthCheckGracePeriod) {
        return core_1.Lazy.any({ produce: () => providedHealthCheckGracePeriod?.toSeconds() ?? (this.loadBalancers.length > 0 ? 60 : void 0) });
      }
      enableExecuteCommand() {
        this.taskDefinition.addToTaskRolePolicy(new iam.PolicyStatement({ actions: ["ssmmessages:CreateControlChannel", "ssmmessages:CreateDataChannel", "ssmmessages:OpenControlChannel", "ssmmessages:OpenDataChannel"], resources: ["*"] }));
      }
    };
    _b = JSII_RTTI_SYMBOL_1, BaseService[_b] = { fqn: "aws-cdk-lib.aws_ecs.BaseService", version: "2.80.0" }, BaseService.MIN_PORT = 1, BaseService.MAX_PORT = 65535, exports2.BaseService = BaseService;
    var LaunchType;
    (function(LaunchType2) {
      LaunchType2.EC2 = "EC2", LaunchType2.FARGATE = "FARGATE", LaunchType2.EXTERNAL = "EXTERNAL";
    })(LaunchType = exports2.LaunchType || (exports2.LaunchType = {}));
    var DeploymentControllerType;
    (function(DeploymentControllerType2) {
      DeploymentControllerType2.ECS = "ECS", DeploymentControllerType2.CODE_DEPLOY = "CODE_DEPLOY", DeploymentControllerType2.EXTERNAL = "EXTERNAL";
    })(DeploymentControllerType = exports2.DeploymentControllerType || (exports2.DeploymentControllerType = {}));
    var PropagatedTagSource;
    (function(PropagatedTagSource2) {
      PropagatedTagSource2.SERVICE = "SERVICE", PropagatedTagSource2.TASK_DEFINITION = "TASK_DEFINITION", PropagatedTagSource2.NONE = "NONE";
    })(PropagatedTagSource = exports2.PropagatedTagSource || (exports2.PropagatedTagSource = {}));
    function determineContainerNameAndPort(options) {
      if (options.dnsRecordType === cloudmap.DnsRecordType.SRV) {
        if (options.container && options.container.taskDefinition != options.taskDefinition)
          throw new Error("Cannot add discovery for a container from another task definition");
        const container = options.container ?? options.taskDefinition.defaultContainer;
        if (options.containerPort && !container.portMappings.some((mapping) => mapping.containerPort === options.containerPort))
          throw new Error("Cannot add discovery for a container port that has not been mapped");
        return { containerName: container.containerName, containerPort: options.containerPort ?? options.taskDefinition.defaultContainer.containerPort };
      }
      return {};
    }
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/environment-file.js
var require_environment_file = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/environment-file.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EnvironmentFileType = exports2.S3EnvironmentFile = exports2.AssetEnvironmentFile = exports2.EnvironmentFile = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var aws_s3_assets_1 = require_aws_s3_assets();
    var EnvironmentFile = class {
      static fromAsset(path, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_assets_AssetOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromAsset), error;
        }
        return new AssetEnvironmentFile(path, options);
      }
      static fromBucket(bucket, key, objectVersion) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_IBucket(bucket);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromBucket), error;
        }
        return new S3EnvironmentFile(bucket, key, objectVersion);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EnvironmentFile[_a] = { fqn: "aws-cdk-lib.aws_ecs.EnvironmentFile", version: "2.80.0" }, exports2.EnvironmentFile = EnvironmentFile;
    var AssetEnvironmentFile = class _AssetEnvironmentFile extends EnvironmentFile {
      constructor(path, options = {}) {
        super(), this.path = path, this.options = options;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_assets_AssetOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AssetEnvironmentFile), error;
        }
      }
      bind(scope) {
        if (this.asset || (this.asset = new aws_s3_assets_1.Asset(scope, "EnvironmentFile", { path: this.path, ...this.options })), !this.asset.isFile)
          throw new Error(`Asset must be a single file (${this.path})`);
        return { fileType: EnvironmentFileType.S3, s3Location: { bucketName: this.asset.s3BucketName, objectKey: this.asset.s3ObjectKey } };
      }
    };
    _b = JSII_RTTI_SYMBOL_1, AssetEnvironmentFile[_b] = { fqn: "aws-cdk-lib.aws_ecs.AssetEnvironmentFile", version: "2.80.0" }, exports2.AssetEnvironmentFile = AssetEnvironmentFile;
    var S3EnvironmentFile = class _S3EnvironmentFile extends EnvironmentFile {
      constructor(bucket, key, objectVersion) {
        super(), this.key = key, this.objectVersion = objectVersion;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_IBucket(bucket);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _S3EnvironmentFile), error;
        }
        if (!bucket.bucketName)
          throw new Error("bucketName is undefined for the provided bucket");
        this.bucketName = bucket.bucketName;
      }
      bind(_scope) {
        return { fileType: EnvironmentFileType.S3, s3Location: { bucketName: this.bucketName, objectKey: this.key, objectVersion: this.objectVersion } };
      }
    };
    _c = JSII_RTTI_SYMBOL_1, S3EnvironmentFile[_c] = { fqn: "aws-cdk-lib.aws_ecs.S3EnvironmentFile", version: "2.80.0" }, exports2.S3EnvironmentFile = S3EnvironmentFile;
    var EnvironmentFileType;
    (function(EnvironmentFileType2) {
      EnvironmentFileType2.S3 = "s3";
    })(EnvironmentFileType = exports2.EnvironmentFileType || (exports2.EnvironmentFileType = {}));
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/base/from-service-attributes.js
var require_from_service_attributes = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/base/from-service-attributes.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.extractServiceNameFromArn = exports2.fromServiceAttributes = void 0;
    var core_1 = require_core2();
    var cx_api_1 = require_cx_api();
    function fromServiceAttributes(scope, id, attrs) {
      if (attrs.serviceArn && attrs.serviceName || !attrs.serviceArn && !attrs.serviceName)
        throw new Error("You can only specify either serviceArn or serviceName.");
      const newArnFormat = core_1.FeatureFlags.of(scope).isEnabled(cx_api_1.ECS_ARN_FORMAT_INCLUDES_CLUSTER_NAME), stack = core_1.Stack.of(scope);
      let name, arn;
      if (attrs.serviceName) {
        name = attrs.serviceName;
        const resourceName = newArnFormat ? `${attrs.cluster.clusterName}/${attrs.serviceName}` : attrs.serviceName;
        arn = stack.formatArn({ partition: stack.partition, service: "ecs", region: stack.region, account: stack.account, resource: "service", resourceName });
      } else
        arn = attrs.serviceArn, name = extractServiceNameFromArn(scope, arn);
      class Import extends core_1.Resource {
        constructor() {
          super(...arguments), this.serviceArn = arn, this.serviceName = name, this.cluster = attrs.cluster;
        }
      }
      return new Import(scope, id, { environmentFromArn: arn });
    }
    exports2.fromServiceAttributes = fromServiceAttributes;
    function extractServiceNameFromArn(scope, arn) {
      const newArnFormat = core_1.FeatureFlags.of(scope).isEnabled(cx_api_1.ECS_ARN_FORMAT_INCLUDES_CLUSTER_NAME), stack = core_1.Stack.of(scope);
      if (core_1.Token.isUnresolved(arn))
        if (newArnFormat) {
          const components = core_1.Fn.split(":", arn), lastComponents = core_1.Fn.split("/", core_1.Fn.select(5, components));
          return core_1.Fn.select(2, lastComponents);
        } else
          return stack.splitArn(arn, core_1.ArnFormat.SLASH_RESOURCE_NAME).resourceName;
      else {
        const resourceName = stack.splitArn(arn, core_1.ArnFormat.SLASH_RESOURCE_NAME).resourceName, resourceNameSplit = resourceName.split("/");
        return resourceNameSplit.length === 1 ? resourceName : resourceNameSplit[1];
      }
    }
    exports2.extractServiceNameFromArn = extractServiceNameFromArn;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/ec2/ec2-service.js
var require_ec2_service = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/ec2/ec2-service.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.BuiltInAttributes = exports2.Ec2Service = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var ec2 = require_aws_ec2();
    var core_1 = require_core2();
    var base_service_1 = require_base_service();
    var from_service_attributes_1 = require_from_service_attributes();
    var task_definition_1 = require_task_definition();
    var Ec2Service = class _Ec2Service extends base_service_1.BaseService {
      static fromEc2ServiceArn(scope, id, ec2ServiceArn) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.serviceArn = ec2ServiceArn, this.serviceName = (0, from_service_attributes_1.extractServiceNameFromArn)(this, ec2ServiceArn);
          }
        }
        return new Import(scope, id);
      }
      static fromEc2ServiceAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_Ec2ServiceAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromEc2ServiceAttributes), error;
        }
        return (0, from_service_attributes_1.fromServiceAttributes)(scope, id, attrs);
      }
      constructor(scope, id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_Ec2ServiceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Ec2Service), error;
        }
        if (props.daemon && props.desiredCount !== void 0)
          throw new Error("Daemon mode launches one task on every instance. Don't supply desiredCount.");
        if (props.daemon && props.maxHealthyPercent !== void 0 && props.maxHealthyPercent !== 100)
          throw new Error("Maximum percent must be 100 for daemon mode.");
        if (props.minHealthyPercent !== void 0 && props.maxHealthyPercent !== void 0 && props.minHealthyPercent >= props.maxHealthyPercent)
          throw new Error("Minimum healthy percent must be less than maximum healthy percent.");
        if (!props.taskDefinition.isEc2Compatible)
          throw new Error("Supplied TaskDefinition is not configured for compatibility with EC2");
        if (props.securityGroup !== void 0 && props.securityGroups !== void 0)
          throw new Error("Only one of SecurityGroup or SecurityGroups can be populated.");
        super(scope, id, { ...props, desiredCount: props.desiredCount, maxHealthyPercent: props.daemon && props.maxHealthyPercent === void 0 ? 100 : props.maxHealthyPercent, minHealthyPercent: props.daemon && props.minHealthyPercent === void 0 ? 0 : props.minHealthyPercent, launchType: base_service_1.LaunchType.EC2, enableECSManagedTags: props.enableECSManagedTags }, { cluster: props.cluster.clusterName, taskDefinition: props.deploymentController?.type === base_service_1.DeploymentControllerType.EXTERNAL ? void 0 : props.taskDefinition.taskDefinitionArn, placementConstraints: core_1.Lazy.any({ produce: () => this.constraints }, { omitEmptyArray: true }), placementStrategies: core_1.Lazy.any({ produce: () => this.strategies }, { omitEmptyArray: true }), schedulingStrategy: props.daemon ? "DAEMON" : "REPLICA" }, props.taskDefinition), this.constraints = [], this.strategies = [], this.daemon = props.daemon || false;
        let securityGroups;
        props.securityGroup !== void 0 ? securityGroups = [props.securityGroup] : props.securityGroups !== void 0 && (securityGroups = props.securityGroups), props.taskDefinition.networkMode === task_definition_1.NetworkMode.AWS_VPC ? this.configureAwsVpcNetworkingWithSecurityGroups(props.cluster.vpc, props.assignPublicIp, props.vpcSubnets, securityGroups) : (validateNoNetworkingProps(props), this.connections.addSecurityGroup(...securityGroupsInThisStack(this, props.cluster.connections.securityGroups))), this.addPlacementConstraints(...props.placementConstraints || []), this.addPlacementStrategies(...props.placementStrategies || []), this.node.addValidation({ validate: () => this.taskDefinition.defaultContainer ? [] : ["A TaskDefinition must have at least one essential container"] }), this.node.addValidation({ validate: this.validateEc2Service.bind(this) });
      }
      addPlacementStrategies(...strategies) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_PlacementStrategy(strategies);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addPlacementStrategies), error;
        }
        if (strategies.length > 0 && this.daemon)
          throw new Error("Can't configure placement strategies when daemon=true");
        for (const strategy of strategies)
          this.strategies.push(...strategy.toJson());
      }
      addPlacementConstraints(...constraints) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_PlacementConstraint(constraints);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addPlacementConstraints), error;
        }
        for (const constraint of constraints)
          this.constraints.push(...constraint.toJson());
      }
      validateEc2Service() {
        const ret = new Array();
        return !this.daemon && !this.cluster.hasEc2Capacity && ret.push("Cluster for this service needs Ec2 capacity. Call addXxxCapacity() on the cluster."), ret;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Ec2Service[_a] = { fqn: "aws-cdk-lib.aws_ecs.Ec2Service", version: "2.80.0" }, exports2.Ec2Service = Ec2Service;
    function validateNoNetworkingProps(props) {
      if (props.vpcSubnets !== void 0 || props.securityGroup !== void 0 || props.securityGroups !== void 0 || props.assignPublicIp)
        throw new Error("vpcSubnets, securityGroup(s) and assignPublicIp can only be used in AwsVpc networking mode");
    }
    function securityGroupsInThisStack(scope, groups) {
      const thisStack = core_1.Stack.of(scope);
      let i = 1;
      return groups.map((group) => thisStack === core_1.Stack.of(group) ? group : ec2.SecurityGroup.fromSecurityGroupId(scope, `SecurityGroup${i++}`, group.securityGroupId, { allowAllOutbound: group.allowAllOutbound, mutable: true }));
    }
    var BuiltInAttributes = class {
    };
    _b = JSII_RTTI_SYMBOL_1, BuiltInAttributes[_b] = { fqn: "aws-cdk-lib.aws_ecs.BuiltInAttributes", version: "2.80.0" }, BuiltInAttributes.INSTANCE_ID = "instanceId", BuiltInAttributes.AVAILABILITY_ZONE = "attribute:ecs.availability-zone", BuiltInAttributes.AMI_ID = "attribute:ecs.ami-id", BuiltInAttributes.INSTANCE_TYPE = "attribute:ecs.instance-type", BuiltInAttributes.OS_TYPE = "attribute:ecs.os-type", exports2.BuiltInAttributes = BuiltInAttributes;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/placement.js
var require_placement = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/placement.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PlacementConstraint = exports2.PlacementStrategy = exports2.BinPackResource = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var ec2_service_1 = require_ec2_service();
    var BinPackResource;
    (function(BinPackResource2) {
      BinPackResource2.CPU = "CPU", BinPackResource2.MEMORY = "MEMORY";
    })(BinPackResource = exports2.BinPackResource || (exports2.BinPackResource = {}));
    var PlacementStrategy = class _PlacementStrategy {
      static spreadAcrossInstances() {
        return new _PlacementStrategy([{ type: "spread", field: ec2_service_1.BuiltInAttributes.INSTANCE_ID }]);
      }
      static spreadAcross(...fields) {
        if (fields.length === 0)
          throw new Error("spreadAcross: give at least one field to spread by");
        return new _PlacementStrategy(fields.map((field) => ({ type: "spread", field })));
      }
      static packedByCpu() {
        return _PlacementStrategy.packedBy(BinPackResource.CPU);
      }
      static packedByMemory() {
        return _PlacementStrategy.packedBy(BinPackResource.MEMORY);
      }
      static packedBy(resource) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_BinPackResource(resource);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.packedBy), error;
        }
        return new _PlacementStrategy([{ type: "binpack", field: resource }]);
      }
      static randomly() {
        return new _PlacementStrategy([{ type: "random" }]);
      }
      constructor(json) {
        this.json = json;
      }
      toJson() {
        return this.json;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, PlacementStrategy[_a] = { fqn: "aws-cdk-lib.aws_ecs.PlacementStrategy", version: "2.80.0" }, exports2.PlacementStrategy = PlacementStrategy;
    var PlacementConstraint = class _PlacementConstraint {
      static distinctInstances() {
        return new _PlacementConstraint([{ type: "distinctInstance" }]);
      }
      static memberOf(...expressions) {
        return new _PlacementConstraint(expressions.map((expression) => ({ type: "memberOf", expression })));
      }
      constructor(json) {
        this.json = json;
      }
      toJson() {
        return this.json;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, PlacementConstraint[_b] = { fqn: "aws-cdk-lib.aws_ecs.PlacementConstraint", version: "2.80.0" }, exports2.PlacementConstraint = PlacementConstraint;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/ec2/ec2-task-definition.js
var require_ec2_task_definition = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/ec2/ec2-task-definition.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Ec2TaskDefinition = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var _imported_task_definition_1 = require_imported_task_definition();
    var task_definition_1 = require_task_definition();
    var Ec2TaskDefinition = class _Ec2TaskDefinition extends task_definition_1.TaskDefinition {
      static fromEc2TaskDefinitionArn(scope, id, ec2TaskDefinitionArn) {
        return new _imported_task_definition_1.ImportedTaskDefinition(scope, id, { taskDefinitionArn: ec2TaskDefinitionArn });
      }
      static fromEc2TaskDefinitionAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_Ec2TaskDefinitionAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromEc2TaskDefinitionAttributes), error;
        }
        return new _imported_task_definition_1.ImportedTaskDefinition(scope, id, { taskDefinitionArn: attrs.taskDefinitionArn, compatibility: task_definition_1.Compatibility.EC2, networkMode: attrs.networkMode, taskRole: attrs.taskRole, executionRole: attrs.executionRole });
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { ...props, compatibility: task_definition_1.Compatibility.EC2, placementConstraints: props.placementConstraints, ipcMode: props.ipcMode, pidMode: props.pidMode, inferenceAccelerators: props.inferenceAccelerators });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_Ec2TaskDefinitionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Ec2TaskDefinition), error;
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Ec2TaskDefinition[_a] = { fqn: "aws-cdk-lib.aws_ecs.Ec2TaskDefinition", version: "2.80.0" }, exports2.Ec2TaskDefinition = Ec2TaskDefinition;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/fargate/fargate-service.js
var require_fargate_service = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/fargate/fargate-service.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FargatePlatformVersion = exports2.FargateService = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var base_service_1 = require_base_service();
    var from_service_attributes_1 = require_from_service_attributes();
    var FargateService = class _FargateService extends base_service_1.BaseService {
      static fromFargateServiceArn(scope, id, fargateServiceArn) {
        class Import extends cdk.Resource {
          constructor() {
            super(...arguments), this.serviceArn = fargateServiceArn, this.serviceName = (0, from_service_attributes_1.extractServiceNameFromArn)(this, fargateServiceArn);
          }
        }
        return new Import(scope, id);
      }
      static fromFargateServiceAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_FargateServiceAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromFargateServiceAttributes), error;
        }
        return (0, from_service_attributes_1.fromServiceAttributes)(scope, id, attrs);
      }
      constructor(scope, id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_FargateServiceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _FargateService), error;
        }
        if (!props.taskDefinition.isFargateCompatible)
          throw new Error("Supplied TaskDefinition is not configured for compatibility with Fargate");
        if (props.securityGroup !== void 0 && props.securityGroups !== void 0)
          throw new Error("Only one of SecurityGroup or SecurityGroups can be populated.");
        super(scope, id, { ...props, desiredCount: props.desiredCount, launchType: base_service_1.LaunchType.FARGATE, capacityProviderStrategies: props.capacityProviderStrategies, enableECSManagedTags: props.enableECSManagedTags }, { cluster: props.cluster.clusterName, taskDefinition: props.deploymentController?.type === base_service_1.DeploymentControllerType.EXTERNAL ? void 0 : props.taskDefinition.taskDefinitionArn, platformVersion: props.platformVersion }, props.taskDefinition);
        let securityGroups;
        props.securityGroup !== void 0 ? securityGroups = [props.securityGroup] : props.securityGroups !== void 0 && (securityGroups = props.securityGroups), this.configureAwsVpcNetworkingWithSecurityGroups(props.cluster.vpc, props.assignPublicIp, props.vpcSubnets, securityGroups), this.node.addValidation({ validate: () => this.taskDefinition.referencesSecretJsonField && props.platformVersion && SECRET_JSON_FIELD_UNSUPPORTED_PLATFORM_VERSIONS.includes(props.platformVersion) ? [`The task definition of this service uses at least one container that references a secret JSON field. This feature requires platform version ${FargatePlatformVersion.VERSION1_4} or later.`] : [] }), this.node.addValidation({ validate: () => this.taskDefinition.defaultContainer ? [] : ["A TaskDefinition must have at least one essential container"] });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, FargateService[_a] = { fqn: "aws-cdk-lib.aws_ecs.FargateService", version: "2.80.0" }, exports2.FargateService = FargateService;
    var FargatePlatformVersion;
    (function(FargatePlatformVersion2) {
      FargatePlatformVersion2.LATEST = "LATEST", FargatePlatformVersion2.VERSION1_4 = "1.4.0", FargatePlatformVersion2.VERSION1_3 = "1.3.0", FargatePlatformVersion2.VERSION1_2 = "1.2.0", FargatePlatformVersion2.VERSION1_1 = "1.1.0", FargatePlatformVersion2.VERSION1_0 = "1.0.0";
    })(FargatePlatformVersion = exports2.FargatePlatformVersion || (exports2.FargatePlatformVersion = {}));
    var SECRET_JSON_FIELD_UNSUPPORTED_PLATFORM_VERSIONS = [FargatePlatformVersion.VERSION1_0, FargatePlatformVersion.VERSION1_1, FargatePlatformVersion.VERSION1_2, FargatePlatformVersion.VERSION1_3];
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/fargate/fargate-task-definition.js
var require_fargate_task_definition = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/fargate/fargate-task-definition.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FargateTaskDefinition = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core_1 = require_core2();
    var _imported_task_definition_1 = require_imported_task_definition();
    var task_definition_1 = require_task_definition();
    var FargateTaskDefinition = class _FargateTaskDefinition extends task_definition_1.TaskDefinition {
      static fromFargateTaskDefinitionArn(scope, id, fargateTaskDefinitionArn) {
        return new _imported_task_definition_1.ImportedTaskDefinition(scope, id, { taskDefinitionArn: fargateTaskDefinitionArn });
      }
      static fromFargateTaskDefinitionAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_FargateTaskDefinitionAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromFargateTaskDefinitionAttributes), error;
        }
        return new _imported_task_definition_1.ImportedTaskDefinition(scope, id, { taskDefinitionArn: attrs.taskDefinitionArn, compatibility: task_definition_1.Compatibility.FARGATE, networkMode: attrs.networkMode, taskRole: attrs.taskRole, executionRole: attrs.executionRole });
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { ...props, cpu: props.cpu !== void 0 ? core_1.Tokenization.stringifyNumber(props.cpu) : "256", memoryMiB: props.memoryLimitMiB !== void 0 ? core_1.Tokenization.stringifyNumber(props.memoryLimitMiB) : "512", compatibility: task_definition_1.Compatibility.FARGATE, networkMode: task_definition_1.NetworkMode.AWS_VPC }), this.networkMode = task_definition_1.NetworkMode.AWS_VPC;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_FargateTaskDefinitionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _FargateTaskDefinition), error;
        }
        if (props.ephemeralStorageGiB && !core_1.Token.isUnresolved(props.ephemeralStorageGiB) && (props.ephemeralStorageGiB < 21 || props.ephemeralStorageGiB > 200))
          throw new Error("Ephemeral storage size must be between 21GiB and 200GiB");
        this.ephemeralStorageGiB = props.ephemeralStorageGiB;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, FargateTaskDefinition[_a] = { fqn: "aws-cdk-lib.aws_ecs.FargateTaskDefinition", version: "2.80.0" }, exports2.FargateTaskDefinition = FargateTaskDefinition;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/external/external-service.js
var require_external_service = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/external/external-service.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ExternalService = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core_1 = require_core2();
    var base_service_1 = require_base_service();
    var from_service_attributes_1 = require_from_service_attributes();
    var task_definition_1 = require_task_definition();
    var ExternalService = class _ExternalService extends base_service_1.BaseService {
      static fromExternalServiceArn(scope, id, externalServiceArn) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.serviceArn = externalServiceArn, this.serviceName = core_1.Stack.of(scope).splitArn(externalServiceArn, core_1.ArnFormat.SLASH_RESOURCE_NAME).resourceName;
          }
        }
        return new Import(scope, id);
      }
      static fromExternalServiceAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_ExternalServiceAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromExternalServiceAttributes), error;
        }
        return (0, from_service_attributes_1.fromServiceAttributes)(scope, id, attrs);
      }
      constructor(scope, id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_ExternalServiceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ExternalService), error;
        }
        if (props.minHealthyPercent !== void 0 && props.maxHealthyPercent !== void 0 && props.minHealthyPercent >= props.maxHealthyPercent)
          throw new Error("Minimum healthy percent must be less than maximum healthy percent.");
        if (props.taskDefinition.compatibility !== task_definition_1.Compatibility.EXTERNAL)
          throw new Error("Supplied TaskDefinition is not configured for compatibility with ECS Anywhere cluster");
        if (props.cluster.defaultCloudMapNamespace !== void 0)
          throw new Error(`Cloud map integration is not supported for External service ${props.cluster.defaultCloudMapNamespace}`);
        if (props.cloudMapOptions !== void 0)
          throw new Error("Cloud map options are not supported for External service");
        if (props.enableExecuteCommand !== void 0)
          throw new Error("Enable Execute Command options are not supported for External service");
        if (props.capacityProviderStrategies !== void 0)
          throw new Error("Capacity Providers are not supported for External service");
        const propagateTagsFromSource = props.propagateTags ?? base_service_1.PropagatedTagSource.NONE;
        super(scope, id, { ...props, desiredCount: props.desiredCount, maxHealthyPercent: props.maxHealthyPercent === void 0 ? 100 : props.maxHealthyPercent, minHealthyPercent: props.minHealthyPercent === void 0 ? 0 : props.minHealthyPercent, launchType: base_service_1.LaunchType.EXTERNAL, propagateTags: propagateTagsFromSource, enableECSManagedTags: props.enableECSManagedTags }, { cluster: props.cluster.clusterName, taskDefinition: props.deploymentController?.type === base_service_1.DeploymentControllerType.EXTERNAL ? void 0 : props.taskDefinition.taskDefinitionArn }, props.taskDefinition), this.node.addValidation({ validate: () => this.taskDefinition.defaultContainer ? [] : ["A TaskDefinition must have at least one essential container"] }), this.node.addValidation({ validate: () => this.networkConfiguration !== void 0 ? ["Network configurations not supported for an external service"] : [] });
      }
      attachToApplicationTargetGroup(_targetGroup) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_IApplicationTargetGroup(_targetGroup);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.attachToApplicationTargetGroup), error;
        }
        throw new Error("Application load balancer cannot be attached to an external service");
      }
      loadBalancerTarget(_options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_LoadBalancerTargetOptions(_options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.loadBalancerTarget), error;
        }
        throw new Error("External service cannot be attached as load balancer targets");
      }
      registerLoadBalancerTargets(..._targets) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_EcsTarget(_targets);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.registerLoadBalancerTargets), error;
        }
        throw new Error("External service cannot be registered as load balancer targets");
      }
      configureAwsVpcNetworkingWithSecurityGroups(_vpc, _assignPublicIp, _vpcSubnets, _securityGroups) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_IVpc(_vpc), jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_SubnetSelection(_vpcSubnets);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.configureAwsVpcNetworkingWithSecurityGroups), error;
        }
        throw new Error("Only Bridge network mode is supported for external service");
      }
      autoScaleTaskCount(_props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_applicationautoscaling_EnableScalingProps(_props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.autoScaleTaskCount), error;
        }
        throw new Error("Autoscaling not supported for external service");
      }
      enableCloudMap(_options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_CloudMapOptions(_options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.enableCloudMap), error;
        }
        throw new Error("Cloud map integration not supported for an external service");
      }
      associateCloudMapService(_options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_AssociateCloudMapServiceOptions(_options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.associateCloudMapService), error;
        }
        throw new Error("Cloud map service association is not supported for an external service");
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ExternalService[_a] = { fqn: "aws-cdk-lib.aws_ecs.ExternalService", version: "2.80.0" }, exports2.ExternalService = ExternalService;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/external/external-task-definition.js
var require_external_task_definition = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/external/external-task-definition.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ExternalTaskDefinition = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var _imported_task_definition_1 = require_imported_task_definition();
    var task_definition_1 = require_task_definition();
    var ExternalTaskDefinition = class _ExternalTaskDefinition extends task_definition_1.TaskDefinition {
      static fromEc2TaskDefinitionArn(scope, id, externalTaskDefinitionArn) {
        return new _imported_task_definition_1.ImportedTaskDefinition(scope, id, { taskDefinitionArn: externalTaskDefinitionArn });
      }
      static fromExternalTaskDefinitionAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_ExternalTaskDefinitionAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromExternalTaskDefinitionAttributes), error;
        }
        return new _imported_task_definition_1.ImportedTaskDefinition(scope, id, { taskDefinitionArn: attrs.taskDefinitionArn, compatibility: task_definition_1.Compatibility.EXTERNAL, networkMode: attrs.networkMode, taskRole: attrs.taskRole, executionRole: attrs.executionRole });
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { ...props, compatibility: task_definition_1.Compatibility.EXTERNAL, networkMode: props.networkMode ?? task_definition_1.NetworkMode.BRIDGE });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_ExternalTaskDefinitionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ExternalTaskDefinition), error;
        }
      }
      addInferenceAccelerator(_inferenceAccelerator) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_InferenceAccelerator(_inferenceAccelerator);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addInferenceAccelerator), error;
        }
        throw new Error("Cannot use inference accelerators on tasks that run on External service");
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ExternalTaskDefinition[_a] = { fqn: "aws-cdk-lib.aws_ecs.ExternalTaskDefinition", version: "2.80.0" }, exports2.ExternalTaskDefinition = ExternalTaskDefinition;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/linux-parameters.js
var require_linux_parameters = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/linux-parameters.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.TmpfsMountOption = exports2.DevicePermission = exports2.Capability = exports2.LinuxParameters = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var cdk = require_core2();
    var LinuxParameters = class _LinuxParameters extends constructs_1.Construct {
      constructor(scope, id, props = {}) {
        super(scope, id), this.capAdd = new Array(), this.capDrop = new Array(), this.devices = new Array(), this.tmpfs = new Array();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_LinuxParametersProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _LinuxParameters), error;
        }
        this.validateProps(props), this.sharedMemorySize = props.sharedMemorySize, this.initProcessEnabled = props.initProcessEnabled, this.maxSwap = props.maxSwap, this.swappiness = props.maxSwap ? props.swappiness : void 0;
      }
      validateProps(props) {
        if (!cdk.Token.isUnresolved(props.sharedMemorySize) && props.sharedMemorySize !== void 0 && (!Number.isInteger(props.sharedMemorySize) || props.sharedMemorySize < 0))
          throw new Error(`sharedMemorySize: Must be an integer greater than 0; received ${props.sharedMemorySize}.`);
        if (!cdk.Token.isUnresolved(props.swappiness) && props.swappiness !== void 0 && (!Number.isInteger(props.swappiness) || props.swappiness < 0 || props.swappiness > 100))
          throw new Error(`swappiness: Must be an integer between 0 and 100; received ${props.swappiness}.`);
      }
      addCapabilities(...cap) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_Capability(cap);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addCapabilities), error;
        }
        this.capAdd.push(...cap);
      }
      dropCapabilities(...cap) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_Capability(cap);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.dropCapabilities), error;
        }
        this.capDrop.push(...cap);
      }
      addDevices(...device) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_Device(device);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addDevices), error;
        }
        this.devices.push(...device);
      }
      addTmpfs(...tmpfs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_Tmpfs(tmpfs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addTmpfs), error;
        }
        this.tmpfs.push(...tmpfs);
      }
      renderLinuxParameters() {
        return { initProcessEnabled: this.initProcessEnabled, sharedMemorySize: this.sharedMemorySize, maxSwap: this.maxSwap?.toMebibytes(), swappiness: this.swappiness, capabilities: { add: cdk.Lazy.list({ produce: () => this.capAdd }, { omitEmpty: true }), drop: cdk.Lazy.list({ produce: () => this.capDrop }, { omitEmpty: true }) }, devices: cdk.Lazy.any({ produce: () => this.devices.map(renderDevice) }, { omitEmptyArray: true }), tmpfs: cdk.Lazy.any({ produce: () => this.tmpfs.map(renderTmpfs) }, { omitEmptyArray: true }) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LinuxParameters[_a] = { fqn: "aws-cdk-lib.aws_ecs.LinuxParameters", version: "2.80.0" }, exports2.LinuxParameters = LinuxParameters;
    function renderDevice(device) {
      return { containerPath: device.containerPath, hostPath: device.hostPath, permissions: device.permissions };
    }
    function renderTmpfs(tmpfs) {
      return { containerPath: tmpfs.containerPath, size: tmpfs.size, mountOptions: tmpfs.mountOptions };
    }
    var Capability;
    (function(Capability2) {
      Capability2.ALL = "ALL", Capability2.AUDIT_CONTROL = "AUDIT_CONTROL", Capability2.AUDIT_WRITE = "AUDIT_WRITE", Capability2.BLOCK_SUSPEND = "BLOCK_SUSPEND", Capability2.CHOWN = "CHOWN", Capability2.DAC_OVERRIDE = "DAC_OVERRIDE", Capability2.DAC_READ_SEARCH = "DAC_READ_SEARCH", Capability2.FOWNER = "FOWNER", Capability2.FSETID = "FSETID", Capability2.IPC_LOCK = "IPC_LOCK", Capability2.IPC_OWNER = "IPC_OWNER", Capability2.KILL = "KILL", Capability2.LEASE = "LEASE", Capability2.LINUX_IMMUTABLE = "LINUX_IMMUTABLE", Capability2.MAC_ADMIN = "MAC_ADMIN", Capability2.MAC_OVERRIDE = "MAC_OVERRIDE", Capability2.MKNOD = "MKNOD", Capability2.NET_ADMIN = "NET_ADMIN", Capability2.NET_BIND_SERVICE = "NET_BIND_SERVICE", Capability2.NET_BROADCAST = "NET_BROADCAST", Capability2.NET_RAW = "NET_RAW", Capability2.SETFCAP = "SETFCAP", Capability2.SETGID = "SETGID", Capability2.SETPCAP = "SETPCAP", Capability2.SETUID = "SETUID", Capability2.SYS_ADMIN = "SYS_ADMIN", Capability2.SYS_BOOT = "SYS_BOOT", Capability2.SYS_CHROOT = "SYS_CHROOT", Capability2.SYS_MODULE = "SYS_MODULE", Capability2.SYS_NICE = "SYS_NICE", Capability2.SYS_PACCT = "SYS_PACCT", Capability2.SYS_PTRACE = "SYS_PTRACE", Capability2.SYS_RAWIO = "SYS_RAWIO", Capability2.SYS_RESOURCE = "SYS_RESOURCE", Capability2.SYS_TIME = "SYS_TIME", Capability2.SYS_TTY_CONFIG = "SYS_TTY_CONFIG", Capability2.SYSLOG = "SYSLOG", Capability2.WAKE_ALARM = "WAKE_ALARM";
    })(Capability = exports2.Capability || (exports2.Capability = {}));
    var DevicePermission;
    (function(DevicePermission2) {
      DevicePermission2.READ = "read", DevicePermission2.WRITE = "write", DevicePermission2.MKNOD = "mknod";
    })(DevicePermission = exports2.DevicePermission || (exports2.DevicePermission = {}));
    var TmpfsMountOption;
    (function(TmpfsMountOption2) {
      TmpfsMountOption2.DEFAULTS = "defaults", TmpfsMountOption2.RO = "ro", TmpfsMountOption2.RW = "rw", TmpfsMountOption2.SUID = "suid", TmpfsMountOption2.NOSUID = "nosuid", TmpfsMountOption2.DEV = "dev", TmpfsMountOption2.NODEV = "nodev", TmpfsMountOption2.EXEC = "exec", TmpfsMountOption2.NOEXEC = "noexec", TmpfsMountOption2.SYNC = "sync", TmpfsMountOption2.ASYNC = "async", TmpfsMountOption2.DIRSYNC = "dirsync", TmpfsMountOption2.REMOUNT = "remount", TmpfsMountOption2.MAND = "mand", TmpfsMountOption2.NOMAND = "nomand", TmpfsMountOption2.ATIME = "atime", TmpfsMountOption2.NOATIME = "noatime", TmpfsMountOption2.DIRATIME = "diratime", TmpfsMountOption2.NODIRATIME = "nodiratime", TmpfsMountOption2.BIND = "bind", TmpfsMountOption2.RBIND = "rbind", TmpfsMountOption2.UNBINDABLE = "unbindable", TmpfsMountOption2.RUNBINDABLE = "runbindable", TmpfsMountOption2.PRIVATE = "private", TmpfsMountOption2.RPRIVATE = "rprivate", TmpfsMountOption2.SHARED = "shared", TmpfsMountOption2.RSHARED = "rshared", TmpfsMountOption2.SLAVE = "slave", TmpfsMountOption2.RSLAVE = "rslave", TmpfsMountOption2.RELATIME = "relatime", TmpfsMountOption2.NORELATIME = "norelatime", TmpfsMountOption2.STRICTATIME = "strictatime", TmpfsMountOption2.NOSTRICTATIME = "nostrictatime", TmpfsMountOption2.MODE = "mode", TmpfsMountOption2.UID = "uid", TmpfsMountOption2.GID = "gid", TmpfsMountOption2.NR_INODES = "nr_inodes", TmpfsMountOption2.NR_BLOCKS = "nr_blocks", TmpfsMountOption2.MPOL = "mpol";
    })(TmpfsMountOption = exports2.TmpfsMountOption || (exports2.TmpfsMountOption = {}));
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/images/tag-parameter-container-image.js
var require_tag_parameter_container_image = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/images/tag-parameter-container-image.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.TagParameterContainerImage = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var container_image_1 = require_container_image();
    var TagParameterContainerImage = class _TagParameterContainerImage extends container_image_1.ContainerImage {
      constructor(repository) {
        super();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecr_IRepository(repository);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _TagParameterContainerImage), error;
        }
        this.repository = repository;
      }
      bind(scope, containerDefinition) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_ContainerDefinition(containerDefinition);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        this.repository.grantPull(containerDefinition.taskDefinition.obtainExecutionRole());
        const imageTagParameter = new cdk.CfnParameter(scope, "ImageTagParam");
        return this.imageTagParameter = imageTagParameter, { imageName: this.repository.repositoryUriForTag(imageTagParameter.valueAsString) };
      }
      get tagParameterName() {
        return cdk.Lazy.string({ produce: () => {
          if (this.imageTagParameter)
            return this.imageTagParameter.logicalId;
          throw new Error("TagParameterContainerImage must be used in a container definition when using tagParameterName");
        } });
      }
      get tagParameterValue() {
        return cdk.Lazy.string({ produce: () => {
          if (this.imageTagParameter)
            return this.imageTagParameter.valueAsString;
          throw new Error("TagParameterContainerImage must be used in a container definition when using tagParameterValue");
        } });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, TagParameterContainerImage[_a] = { fqn: "aws-cdk-lib.aws_ecs.TagParameterContainerImage", version: "2.80.0" }, exports2.TagParameterContainerImage = TagParameterContainerImage;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/log-drivers/base-log-driver.js
var require_base_log_driver = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/log-drivers/base-log-driver.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/log-drivers/firelens-log-driver.js
var require_firelens_log_driver = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/log-drivers/firelens-log-driver.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FireLensLogDriver = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var log_driver_1 = require_log_driver();
    var utils_1 = require_utils13();
    var FireLensLogDriver = class _FireLensLogDriver extends log_driver_1.LogDriver {
      constructor(props) {
        super();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_FireLensLogDriverProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _FireLensLogDriver), error;
        }
        this.options = props.options, this.secretOptions = props.secretOptions;
      }
      bind(_scope, _containerDefinition) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_ContainerDefinition(_containerDefinition);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { logDriver: "awsfirelens", ...this.options && { options: (0, utils_1.removeEmpty)(this.options) }, secretOptions: this.secretOptions && (0, utils_1.renderLogDriverSecretOptions)(this.secretOptions, _containerDefinition.taskDefinition) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, FireLensLogDriver[_a] = { fqn: "aws-cdk-lib.aws_ecs.FireLensLogDriver", version: "2.80.0" }, exports2.FireLensLogDriver = FireLensLogDriver;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/log-drivers/fluentd-log-driver.js
var require_fluentd_log_driver = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/log-drivers/fluentd-log-driver.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FluentdLogDriver = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var log_driver_1 = require_log_driver();
    var utils_1 = require_utils13();
    var FluentdLogDriver = class _FluentdLogDriver extends log_driver_1.LogDriver {
      constructor(props = {}) {
        super(), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_FluentdLogDriverProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _FluentdLogDriver), error;
        }
      }
      bind(_scope, _containerDefinition) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_ContainerDefinition(_containerDefinition);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { logDriver: "fluentd", options: (0, utils_1.stringifyOptions)({ "fluentd-address": this.props.address, "fluentd-async-connect": this.props.asyncConnect, "fluentd-buffer-limit": this.props.bufferLimit, "fluentd-retry-wait": this.props.retryWait && this.props.retryWait.toSeconds(), "fluentd-max-retries": this.props.maxRetries, "fluentd-sub-second-precision": this.props.subSecondPrecision, ...(0, utils_1.renderCommonLogDriverOptions)(this.props) }) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, FluentdLogDriver[_a] = { fqn: "aws-cdk-lib.aws_ecs.FluentdLogDriver", version: "2.80.0" }, exports2.FluentdLogDriver = FluentdLogDriver;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/log-drivers/gelf-log-driver.js
var require_gelf_log_driver = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/log-drivers/gelf-log-driver.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.GelfLogDriver = exports2.GelfCompressionType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var log_driver_1 = require_log_driver();
    var utils_1 = require_utils13();
    var GelfCompressionType;
    (function(GelfCompressionType2) {
      GelfCompressionType2.GZIP = "gzip", GelfCompressionType2.ZLIB = "zlib", GelfCompressionType2.NONE = "none";
    })(GelfCompressionType = exports2.GelfCompressionType || (exports2.GelfCompressionType = {}));
    var GelfLogDriver = class _GelfLogDriver extends log_driver_1.LogDriver {
      constructor(props) {
        super(), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_GelfLogDriverProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _GelfLogDriver), error;
        }
        props.compressionLevel && (0, utils_1.ensureInRange)(props.compressionLevel, -1, 9), props.tcpMaxReconnect && (0, utils_1.ensurePositiveInteger)(props.tcpMaxReconnect);
      }
      bind(_scope, _containerDefinition) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_ContainerDefinition(_containerDefinition);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { logDriver: "gelf", options: (0, utils_1.stringifyOptions)({ "gelf-address": this.props.address, "gelf-compression-type": this.props.compressionType, "gelf-compression-level": this.props.compressionLevel, "gelf-tcp-max-reconnect": this.props.tcpMaxReconnect, "gelf-tcp-reconnect-delay": this.props.tcpReconnectDelay && this.props.tcpReconnectDelay.toSeconds(), ...(0, utils_1.renderCommonLogDriverOptions)(this.props) }) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, GelfLogDriver[_a] = { fqn: "aws-cdk-lib.aws_ecs.GelfLogDriver", version: "2.80.0" }, exports2.GelfLogDriver = GelfLogDriver;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/log-drivers/journald-log-driver.js
var require_journald_log_driver = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/log-drivers/journald-log-driver.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.JournaldLogDriver = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var log_driver_1 = require_log_driver();
    var utils_1 = require_utils13();
    var JournaldLogDriver = class _JournaldLogDriver extends log_driver_1.LogDriver {
      constructor(props = {}) {
        super(), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_JournaldLogDriverProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _JournaldLogDriver), error;
        }
      }
      bind(_scope, _containerDefinition) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_ContainerDefinition(_containerDefinition);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { logDriver: "journald", options: (0, utils_1.stringifyOptions)({ ...(0, utils_1.renderCommonLogDriverOptions)(this.props) }) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, JournaldLogDriver[_a] = { fqn: "aws-cdk-lib.aws_ecs.JournaldLogDriver", version: "2.80.0" }, exports2.JournaldLogDriver = JournaldLogDriver;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/log-drivers/json-file-log-driver.js
var require_json_file_log_driver = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/log-drivers/json-file-log-driver.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.JsonFileLogDriver = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var log_driver_1 = require_log_driver();
    var utils_1 = require_utils13();
    var JsonFileLogDriver = class _JsonFileLogDriver extends log_driver_1.LogDriver {
      constructor(props = {}) {
        super(), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_JsonFileLogDriverProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _JsonFileLogDriver), error;
        }
        if (props.maxFile && props.maxFile < 0)
          throw new Error("`maxFile` must be a positive integer.");
      }
      bind(_scope, _containerDefinition) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_ContainerDefinition(_containerDefinition);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { logDriver: "json-file", options: (0, utils_1.stringifyOptions)({ "max-size": this.props.maxSize, "max-file": this.props.maxFile, compress: this.props.compress, labels: (0, utils_1.joinWithCommas)(this.props.labels), env: (0, utils_1.joinWithCommas)(this.props.env), "env-regex": this.props.envRegex }) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, JsonFileLogDriver[_a] = { fqn: "aws-cdk-lib.aws_ecs.JsonFileLogDriver", version: "2.80.0" }, exports2.JsonFileLogDriver = JsonFileLogDriver;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/log-drivers/splunk-log-driver.js
var require_splunk_log_driver = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/log-drivers/splunk-log-driver.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SplunkLogDriver = exports2.SplunkLogFormat = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var log_driver_1 = require_log_driver();
    var utils_1 = require_utils13();
    var SplunkLogFormat;
    (function(SplunkLogFormat2) {
      SplunkLogFormat2.INLINE = "inline", SplunkLogFormat2.JSON = "json", SplunkLogFormat2.RAW = "raw";
    })(SplunkLogFormat = exports2.SplunkLogFormat || (exports2.SplunkLogFormat = {}));
    var SplunkLogDriver = class _SplunkLogDriver extends log_driver_1.LogDriver {
      constructor(props) {
        super(), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_SplunkLogDriverProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SplunkLogDriver), error;
        }
        if (!props.token && !props.secretToken)
          throw new Error("Please provide either token or secretToken.");
        props.gzipLevel && (0, utils_1.ensureInRange)(props.gzipLevel, -1, 9);
      }
      bind(_scope, _containerDefinition) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_ContainerDefinition(_containerDefinition);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { logDriver: "splunk", options: (0, utils_1.stringifyOptions)({ "splunk-token": this.props.token?.unsafeUnwrap(), "splunk-url": this.props.url, "splunk-source": this.props.source, "splunk-sourcetype": this.props.sourceType, "splunk-index": this.props.index, "splunk-capath": this.props.caPath, "splunk-caname": this.props.caName, "splunk-insecureskipverify": this.props.insecureSkipVerify, "splunk-format": this.props.format, "splunk-verify-connection": this.props.verifyConnection, "splunk-gzip": this.props.gzip, "splunk-gzip-level": this.props.gzipLevel, ...(0, utils_1.renderCommonLogDriverOptions)(this.props) }), secretOptions: this.props.secretToken && (0, utils_1.renderLogDriverSecretOptions)({ "splunk-token": this.props.secretToken }, _containerDefinition.taskDefinition) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SplunkLogDriver[_a] = { fqn: "aws-cdk-lib.aws_ecs.SplunkLogDriver", version: "2.80.0" }, exports2.SplunkLogDriver = SplunkLogDriver;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/log-drivers/syslog-log-driver.js
var require_syslog_log_driver = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/log-drivers/syslog-log-driver.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SyslogLogDriver = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var log_driver_1 = require_log_driver();
    var utils_1 = require_utils13();
    var SyslogLogDriver = class _SyslogLogDriver extends log_driver_1.LogDriver {
      constructor(props = {}) {
        super(), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_SyslogLogDriverProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SyslogLogDriver), error;
        }
      }
      bind(_scope, _containerDefinition) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_ContainerDefinition(_containerDefinition);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { logDriver: "syslog", options: (0, utils_1.stringifyOptions)({ "syslog-address": this.props.address, "syslog-facility": this.props.facility, "syslog-tls-ca-cert": this.props.tlsCaCert, "syslog-tls-cert": this.props.tlsCert, "syslog-tls-key": this.props.tlsKey, "syslog-tls-skip-verify": this.props.tlsSkipVerify, "syslog-format": this.props.format, ...(0, utils_1.renderCommonLogDriverOptions)(this.props) }) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SyslogLogDriver[_a] = { fqn: "aws-cdk-lib.aws_ecs.SyslogLogDriver", version: "2.80.0" }, exports2.SyslogLogDriver = SyslogLogDriver;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/log-drivers/generic-log-driver.js
var require_generic_log_driver = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/log-drivers/generic-log-driver.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.GenericLogDriver = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var log_driver_1 = require_log_driver();
    var utils_1 = require_utils13();
    var GenericLogDriver = class _GenericLogDriver extends log_driver_1.LogDriver {
      constructor(props) {
        super();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_GenericLogDriverProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _GenericLogDriver), error;
        }
        this.logDriver = props.logDriver, this.options = props.options || {}, this.secretOptions = props.secretOptions;
      }
      bind(_scope, _containerDefinition) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_ContainerDefinition(_containerDefinition);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { logDriver: this.logDriver, options: (0, utils_1.removeEmpty)(this.options), secretOptions: this.secretOptions && (0, utils_1.renderLogDriverSecretOptions)(this.secretOptions, _containerDefinition.taskDefinition) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, GenericLogDriver[_a] = { fqn: "aws-cdk-lib.aws_ecs.GenericLogDriver", version: "2.80.0" }, exports2.GenericLogDriver = GenericLogDriver;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/log-drivers/log-drivers.js
var require_log_drivers = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/log-drivers/log-drivers.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LogDrivers = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var aws_log_driver_1 = require_aws_log_driver();
    var firelens_log_driver_1 = require_firelens_log_driver();
    var fluentd_log_driver_1 = require_fluentd_log_driver();
    var gelf_log_driver_1 = require_gelf_log_driver();
    var journald_log_driver_1 = require_journald_log_driver();
    var json_file_log_driver_1 = require_json_file_log_driver();
    var splunk_log_driver_1 = require_splunk_log_driver();
    var syslog_log_driver_1 = require_syslog_log_driver();
    var LogDrivers = class {
      static awsLogs(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_AwsLogDriverProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.awsLogs), error;
        }
        return new aws_log_driver_1.AwsLogDriver(props);
      }
      static fluentd(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_FluentdLogDriverProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fluentd), error;
        }
        return new fluentd_log_driver_1.FluentdLogDriver(props);
      }
      static gelf(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_GelfLogDriverProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.gelf), error;
        }
        return new gelf_log_driver_1.GelfLogDriver(props);
      }
      static journald(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_JournaldLogDriverProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.journald), error;
        }
        return new journald_log_driver_1.JournaldLogDriver(props);
      }
      static jsonFile(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_JsonFileLogDriverProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.jsonFile), error;
        }
        return new json_file_log_driver_1.JsonFileLogDriver(props);
      }
      static splunk(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_SplunkLogDriverProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.splunk), error;
        }
        return new splunk_log_driver_1.SplunkLogDriver(props);
      }
      static syslog(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_SyslogLogDriverProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.syslog), error;
        }
        return new syslog_log_driver_1.SyslogLogDriver(props);
      }
      static firelens(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_FireLensLogDriverProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.firelens), error;
        }
        return new firelens_log_driver_1.FireLensLogDriver(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LogDrivers[_a] = { fqn: "aws-cdk-lib.aws_ecs.LogDrivers", version: "2.80.0" }, exports2.LogDrivers = LogDrivers;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/proxy-configuration/proxy-configuration.js
var require_proxy_configuration = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/proxy-configuration/proxy-configuration.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ProxyConfiguration = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var ProxyConfiguration = class {
    };
    _a = JSII_RTTI_SYMBOL_1, ProxyConfiguration[_a] = { fqn: "aws-cdk-lib.aws_ecs.ProxyConfiguration", version: "2.80.0" }, exports2.ProxyConfiguration = ProxyConfiguration;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/proxy-configuration/app-mesh-proxy-configuration.js
var require_app_mesh_proxy_configuration = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/proxy-configuration/app-mesh-proxy-configuration.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AppMeshProxyConfiguration = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var proxy_configuration_1 = require_proxy_configuration();
    var AppMeshProxyConfiguration = class _AppMeshProxyConfiguration extends proxy_configuration_1.ProxyConfiguration {
      constructor(props) {
        super(), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_AppMeshProxyConfigurationConfigProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AppMeshProxyConfiguration), error;
        }
        if (props.properties && !props.properties.ignoredUID && !props.properties.ignoredGID)
          throw new Error("At least one of ignoredUID or ignoredGID should be specified.");
      }
      bind(_scope, _taskDefinition) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_TaskDefinition(_taskDefinition);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        const configProps = this.props.properties, configType = "APPMESH";
        return { containerName: this.props.containerName, proxyConfigurationProperties: renderProperties(configProps), type: configType };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AppMeshProxyConfiguration[_a] = { fqn: "aws-cdk-lib.aws_ecs.AppMeshProxyConfiguration", version: "2.80.0" }, exports2.AppMeshProxyConfiguration = AppMeshProxyConfiguration;
    function renderProperties(props) {
      const ret = new Array();
      for (const [k, v] of Object.entries(props)) {
        const key = String(k), value = String(v);
        if (value !== "undefined" && value !== "") {
          const capitalizedKey = key.charAt(0).toUpperCase() + key.slice(1);
          ret.push({ name: capitalizedKey, value });
        }
      }
      return ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/proxy-configuration/proxy-configurations.js
var require_proxy_configurations = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/proxy-configuration/proxy-configurations.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ProxyConfigurations = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var app_mesh_proxy_configuration_1 = require_app_mesh_proxy_configuration();
    var ProxyConfigurations = class {
      static appMeshProxyConfiguration(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_AppMeshProxyConfigurationConfigProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.appMeshProxyConfiguration), error;
        }
        return new app_mesh_proxy_configuration_1.AppMeshProxyConfiguration(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ProxyConfigurations[_a] = { fqn: "aws-cdk-lib.aws_ecs.ProxyConfigurations", version: "2.80.0" }, exports2.ProxyConfigurations = ProxyConfigurations;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/runtime-platform.js
var require_runtime_platform = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/runtime-platform.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.OperatingSystemFamily = exports2.CpuArchitecture = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var CpuArchitecture = class _CpuArchitecture {
      static of(cpuArchitecture) {
        return new _CpuArchitecture(cpuArchitecture);
      }
      constructor(_cpuArchitecture) {
        this._cpuArchitecture = _cpuArchitecture;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CpuArchitecture[_a] = { fqn: "aws-cdk-lib.aws_ecs.CpuArchitecture", version: "2.80.0" }, CpuArchitecture.ARM64 = CpuArchitecture.of("ARM64"), CpuArchitecture.X86_64 = CpuArchitecture.of("X86_64"), exports2.CpuArchitecture = CpuArchitecture;
    var OperatingSystemFamily = class _OperatingSystemFamily {
      static of(family) {
        return new _OperatingSystemFamily(family);
      }
      constructor(_operatingSystemFamily) {
        this._operatingSystemFamily = _operatingSystemFamily;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, OperatingSystemFamily[_b] = { fqn: "aws-cdk-lib.aws_ecs.OperatingSystemFamily", version: "2.80.0" }, OperatingSystemFamily.LINUX = OperatingSystemFamily.of("LINUX"), OperatingSystemFamily.WINDOWS_SERVER_2004_CORE = OperatingSystemFamily.of("WINDOWS_SERVER_2004_CORE"), OperatingSystemFamily.WINDOWS_SERVER_2016_FULL = OperatingSystemFamily.of("WINDOWS_SERVER_2016_FULL"), OperatingSystemFamily.WINDOWS_SERVER_2019_CORE = OperatingSystemFamily.of("WINDOWS_SERVER_2019_CORE"), OperatingSystemFamily.WINDOWS_SERVER_2019_FULL = OperatingSystemFamily.of("WINDOWS_SERVER_2019_FULL"), OperatingSystemFamily.WINDOWS_SERVER_2022_CORE = OperatingSystemFamily.of("WINDOWS_SERVER_2022_CORE"), OperatingSystemFamily.WINDOWS_SERVER_2022_FULL = OperatingSystemFamily.of("WINDOWS_SERVER_2022_FULL"), OperatingSystemFamily.WINDOWS_SERVER_20H2_CORE = OperatingSystemFamily.of("WINDOWS_SERVER_20H2_CORE"), exports2.OperatingSystemFamily = OperatingSystemFamily;
  }
});

// node_modules/aws-cdk-lib/aws-ecs/lib/index.js
var require_lib80 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_base_service(), exports2), __exportStar(require_scalable_task_count(), exports2), __exportStar(require_task_definition(), exports2), __exportStar(require_container_definition(), exports2), __exportStar(require_container_image(), exports2), __exportStar(require_amis(), exports2), __exportStar(require_cluster2(), exports2), __exportStar(require_environment_file(), exports2), __exportStar(require_firelens_log_router(), exports2), __exportStar(require_placement(), exports2), __exportStar(require_ec2_service(), exports2), __exportStar(require_ec2_task_definition(), exports2), __exportStar(require_fargate_service(), exports2), __exportStar(require_fargate_task_definition(), exports2), __exportStar(require_external_service(), exports2), __exportStar(require_external_task_definition(), exports2), __exportStar(require_linux_parameters(), exports2), __exportStar(require_asset_image(), exports2), __exportStar(require_repository3(), exports2), __exportStar(require_ecr2(), exports2), __exportStar(require_tag_parameter_container_image(), exports2), __exportStar(require_aws_log_driver(), exports2), __exportStar(require_base_log_driver(), exports2), __exportStar(require_firelens_log_driver(), exports2), __exportStar(require_fluentd_log_driver(), exports2), __exportStar(require_gelf_log_driver(), exports2), __exportStar(require_journald_log_driver(), exports2), __exportStar(require_json_file_log_driver(), exports2), __exportStar(require_splunk_log_driver(), exports2), __exportStar(require_syslog_log_driver(), exports2), __exportStar(require_log_driver(), exports2), __exportStar(require_generic_log_driver(), exports2), __exportStar(require_log_drivers(), exports2), __exportStar(require_app_mesh_proxy_configuration(), exports2), __exportStar(require_proxy_configuration(), exports2), __exportStar(require_proxy_configurations(), exports2), __exportStar(require_runtime_platform(), exports2), __exportStar(require_ecs_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-ecs/index.js
var require_aws_ecs = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib80(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-codedeploy/lib/private/predefined-deployment-config.js
var require_predefined_deployment_config = __commonJS({
  "node_modules/aws-cdk-lib/aws-codedeploy/lib/private/predefined-deployment-config.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.isPredefinedDeploymentConfig = void 0;
    function isPredefinedDeploymentConfig(x) {
      return typeof x == "object" && !!x && !!x.bindEnvironment;
    }
    exports2.isPredefinedDeploymentConfig = isPredefinedDeploymentConfig;
  }
});

// node_modules/aws-cdk-lib/aws-codedeploy/lib/private/base-deployment-group.js
var require_base_deployment_group = __commonJS({
  "node_modules/aws-cdk-lib/aws-codedeploy/lib/private/base-deployment-group.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DeploymentGroupBase = exports2.ImportedDeploymentGroupBase = void 0;
    var predefined_deployment_config_1 = require_predefined_deployment_config();
    var utils_1 = require_utils8();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var ImportedDeploymentGroupBase = class extends core_1.Resource {
      constructor(scope, id, props) {
        const deploymentGroupName = props.deploymentGroupName, deploymentGroupArn = core_1.Arn.format({ partition: core_1.Aws.PARTITION, account: props.application.env.account, region: props.application.env.region, service: "codedeploy", resource: "deploymentgroup", resourceName: `${props.application.applicationName}/${deploymentGroupName}`, arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME });
        super(scope, id, { environmentFromArn: deploymentGroupArn }), this.deploymentGroupName = deploymentGroupName, this.deploymentGroupArn = deploymentGroupArn;
      }
      _bindDeploymentConfig(config) {
        return (0, predefined_deployment_config_1.isPredefinedDeploymentConfig)(config) ? config.bindEnvironment(this) : config;
      }
    };
    exports2.ImportedDeploymentGroupBase = ImportedDeploymentGroupBase;
    var DeploymentGroupBase = class extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.deploymentGroupName }), this._role = props.role || new iam.Role(this, props.roleConstructId, { assumedBy: new iam.ServicePrincipal("codedeploy.amazonaws.com") }), this.node.addValidation({ validate: () => (0, utils_1.validateName)("Deployment group", this.physicalName) });
      }
      _bindDeploymentConfig(config) {
        return (0, predefined_deployment_config_1.isPredefinedDeploymentConfig)(config) ? config.bindEnvironment(this) : config;
      }
      _setNameAndArn(resource, application) {
        this.deploymentGroupName = this.getResourceNameAttribute(resource.ref), this.deploymentGroupArn = this.getResourceArnAttribute(this.stack.formatArn({ service: "codedeploy", resource: "deploymentgroup", resourceName: `${application.applicationName}/${resource.ref}`, arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME }), { service: "codedeploy", resource: "deploymentgroup", resourceName: `${application.applicationName}/${this.physicalName}`, arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME });
      }
    };
    exports2.DeploymentGroupBase = DeploymentGroupBase;
  }
});

// node_modules/aws-cdk-lib/aws-codedeploy/lib/ecs/deployment-group.js
var require_deployment_group = __commonJS({
  "node_modules/aws-cdk-lib/aws-codedeploy/lib/ecs/deployment-group.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EcsDeploymentGroup = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var application_1 = require_application();
    var deployment_config_1 = require_deployment_config();
    var ecs = require_aws_ecs();
    var iam = require_aws_iam();
    var cdk = require_core2();
    var cx_api_1 = require_cx_api();
    var codedeploy_generated_1 = require_codedeploy_generated();
    var base_deployment_group_1 = require_base_deployment_group();
    var utils_1 = require_utils8();
    var EcsDeploymentGroup = class _EcsDeploymentGroup extends base_deployment_group_1.DeploymentGroupBase {
      static fromEcsDeploymentGroupAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codedeploy_EcsDeploymentGroupAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromEcsDeploymentGroupAttributes), error;
        }
        return new ImportedEcsDeploymentGroup(scope, id, attrs);
      }
      constructor(scope, id, props) {
        super(scope, id, { deploymentGroupName: props.deploymentGroupName, role: props.role, roleConstructId: "ServiceRole" });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codedeploy_EcsDeploymentGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EcsDeploymentGroup), error;
        }
        if (this.role = this._role, this.application = props.application || new application_1.EcsApplication(this, "Application"), this.alarms = props.alarms || [], this.role.addManagedPolicy(iam.ManagedPolicy.fromAwsManagedPolicyName("AWSCodeDeployRoleForECS")), this.deploymentConfig = this._bindDeploymentConfig(props.deploymentConfig || deployment_config_1.EcsDeploymentConfig.ALL_AT_ONCE), cdk.Resource.isOwnedResource(props.service)) {
          const cfnSvc = props.service.node.defaultChild;
          if (cfnSvc.deploymentController === void 0 || cfnSvc.deploymentController.type !== ecs.DeploymentControllerType.CODE_DEPLOY)
            throw new Error("The ECS service associated with the deployment group must use the CODE_DEPLOY deployment controller type");
          if (cfnSvc.taskDefinition !== props.service.taskDefinition.family)
            throw new Error("The ECS service associated with the deployment group must specify the task definition using the task definition family name only. Otherwise, the task definition cannot be updated in the stack");
        }
        const removeAlarmsFromDeploymentGroup = cdk.FeatureFlags.of(this).isEnabled(cx_api_1.CODEDEPLOY_REMOVE_ALARMS_FROM_DEPLOYMENT_GROUP), resource = new codedeploy_generated_1.CfnDeploymentGroup(this, "Resource", { applicationName: this.application.applicationName, serviceRoleArn: this.role.roleArn, deploymentGroupName: this.physicalName, deploymentConfigName: this.deploymentConfig.deploymentConfigName, deploymentStyle: { deploymentType: "BLUE_GREEN", deploymentOption: "WITH_TRAFFIC_CONTROL" }, ecsServices: [{ clusterName: props.service.cluster.clusterName, serviceName: props.service.serviceName }], blueGreenDeploymentConfiguration: cdk.Lazy.any({ produce: () => this.renderBlueGreenDeploymentConfiguration(props.blueGreenDeploymentConfig) }), loadBalancerInfo: cdk.Lazy.any({ produce: () => this.renderLoadBalancerInfo(props.blueGreenDeploymentConfig) }), alarmConfiguration: cdk.Lazy.any({ produce: () => (0, utils_1.renderAlarmConfiguration)(this.alarms, props.ignorePollAlarmsFailure, removeAlarmsFromDeploymentGroup) }), autoRollbackConfiguration: cdk.Lazy.any({ produce: () => (0, utils_1.renderAutoRollbackConfiguration)(this.alarms, props.autoRollback) }) });
        this._setNameAndArn(resource, this.application), constructs_1.Construct.isConstruct(this.deploymentConfig) && this.node.addDependency(this.deploymentConfig);
      }
      addAlarm(alarm) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_IAlarm(alarm);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addAlarm), error;
        }
        this.alarms.push(alarm);
      }
      renderBlueGreenDeploymentConfiguration(options) {
        return { deploymentReadyOption: { actionOnTimeout: options.deploymentApprovalWaitTime ? "STOP_DEPLOYMENT" : "CONTINUE_DEPLOYMENT", waitTimeInMinutes: options.deploymentApprovalWaitTime?.toMinutes() ?? 0 }, terminateBlueInstancesOnDeploymentSuccess: { action: "TERMINATE", terminationWaitTimeInMinutes: options.terminationWaitTime?.toMinutes() ?? 0 } };
      }
      renderLoadBalancerInfo(options) {
        return { targetGroupPairInfoList: [{ targetGroups: [{ name: options.blueTargetGroup.targetGroupName }, { name: options.greenTargetGroup.targetGroupName }], prodTrafficRoute: { listenerArns: [options.listener.listenerArn] }, testTrafficRoute: options.testListener ? { listenerArns: [options.testListener.listenerArn] } : void 0 }] };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EcsDeploymentGroup[_a] = { fqn: "aws-cdk-lib.aws_codedeploy.EcsDeploymentGroup", version: "2.80.0" }, exports2.EcsDeploymentGroup = EcsDeploymentGroup;
    var ImportedEcsDeploymentGroup = class extends base_deployment_group_1.ImportedDeploymentGroupBase {
      constructor(scope, id, props) {
        super(scope, id, { application: props.application, deploymentGroupName: props.deploymentGroupName }), this.application = props.application, this.deploymentConfig = this._bindDeploymentConfig(props.deploymentConfig || deployment_config_1.EcsDeploymentConfig.ALL_AT_ONCE);
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-codedeploy/lib/ecs/index.js
var require_ecs2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codedeploy/lib/ecs/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_application(), exports2), __exportStar(require_deployment_config(), exports2), __exportStar(require_deployment_group(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-codedeploy/lib/lambda/application.js
var require_application2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codedeploy/lib/lambda/application.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LambdaApplication = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core_1 = require_core2();
    var codedeploy_generated_1 = require_codedeploy_generated();
    var utils_1 = require_utils8();
    var LambdaApplication = class _LambdaApplication extends core_1.Resource {
      static fromLambdaApplicationName(scope, id, lambdaApplicationName) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.applicationArn = (0, utils_1.arnForApplication)(core_1.Stack.of(scope), lambdaApplicationName), this.applicationName = lambdaApplicationName;
          }
        }
        return new Import(scope, id);
      }
      static fromLambdaApplicationArn(scope, id, lambdaApplicationArn) {
        return new class extends core_1.Resource {
          constructor() {
            super(...arguments), this.applicationArn = lambdaApplicationArn, this.applicationName = core_1.Arn.split(lambdaApplicationArn, core_1.ArnFormat.COLON_RESOURCE_NAME).resourceName ?? "<invalid arn>";
          }
        }(scope, id, { environmentFromArn: lambdaApplicationArn });
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.applicationName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codedeploy_LambdaApplicationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _LambdaApplication), error;
        }
        const resource = new codedeploy_generated_1.CfnApplication(this, "Resource", { applicationName: this.physicalName, computePlatform: "Lambda" });
        this.applicationName = this.getResourceNameAttribute(resource.ref), this.applicationArn = this.getResourceArnAttribute((0, utils_1.arnForApplication)(core_1.Stack.of(this), resource.ref), { service: "codedeploy", resource: "application", resourceName: this.physicalName, arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME }), this.node.addValidation({ validate: () => (0, utils_1.validateName)("Application", this.physicalName) });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LambdaApplication[_a] = { fqn: "aws-cdk-lib.aws_codedeploy.LambdaApplication", version: "2.80.0" }, exports2.LambdaApplication = LambdaApplication;
  }
});

// node_modules/aws-cdk-lib/aws-codedeploy/lib/lambda/deployment-config.js
var require_deployment_config2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codedeploy/lib/lambda/deployment-config.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LambdaDeploymentConfig = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var base_deployment_config_1 = require_base_deployment_config();
    var utils_1 = require_utils8();
    var traffic_routing_config_1 = require_traffic_routing_config();
    var LambdaDeploymentConfig = class _LambdaDeploymentConfig extends base_deployment_config_1.BaseDeploymentConfig {
      static fromLambdaDeploymentConfigName(scope, id, lambdaDeploymentConfigName) {
        return this.fromDeploymentConfigName(scope, id, lambdaDeploymentConfigName);
      }
      static import(_scope, _id, props) {
        try {
          jsiiDeprecationWarnings.print("aws-cdk-lib.aws_codedeploy.LambdaDeploymentConfig#import", "use `fromLambdaDeploymentConfigName`"), jsiiDeprecationWarnings.aws_cdk_lib_aws_codedeploy_LambdaDeploymentConfigImportProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.import), error;
        }
        return this.fromLambdaDeploymentConfigName(_scope, _id, props.deploymentConfigName);
      }
      static deploymentConfig(name) {
        return (0, utils_1.deploymentConfig)(name);
      }
      constructor(scope, id, props) {
        super(scope, id, { ...props, computePlatform: base_deployment_config_1.ComputePlatform.LAMBDA, trafficRouting: props?.trafficRouting ?? traffic_routing_config_1.TrafficRouting.allAtOnce() });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codedeploy_LambdaDeploymentConfigProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _LambdaDeploymentConfig), error;
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LambdaDeploymentConfig[_a] = { fqn: "aws-cdk-lib.aws_codedeploy.LambdaDeploymentConfig", version: "2.80.0" }, LambdaDeploymentConfig.ALL_AT_ONCE = LambdaDeploymentConfig.deploymentConfig("CodeDeployDefault.LambdaAllAtOnce"), LambdaDeploymentConfig.CANARY_10PERCENT_30MINUTES = LambdaDeploymentConfig.deploymentConfig("CodeDeployDefault.LambdaCanary10Percent30Minutes"), LambdaDeploymentConfig.CANARY_10PERCENT_5MINUTES = LambdaDeploymentConfig.deploymentConfig("CodeDeployDefault.LambdaCanary10Percent5Minutes"), LambdaDeploymentConfig.CANARY_10PERCENT_10MINUTES = LambdaDeploymentConfig.deploymentConfig("CodeDeployDefault.LambdaCanary10Percent10Minutes"), LambdaDeploymentConfig.CANARY_10PERCENT_15MINUTES = LambdaDeploymentConfig.deploymentConfig("CodeDeployDefault.LambdaCanary10Percent15Minutes"), LambdaDeploymentConfig.LINEAR_10PERCENT_EVERY_10MINUTES = LambdaDeploymentConfig.deploymentConfig("CodeDeployDefault.LambdaLinear10PercentEvery10Minutes"), LambdaDeploymentConfig.LINEAR_10PERCENT_EVERY_1MINUTE = LambdaDeploymentConfig.deploymentConfig("CodeDeployDefault.LambdaLinear10PercentEvery1Minute"), LambdaDeploymentConfig.LINEAR_10PERCENT_EVERY_2MINUTES = LambdaDeploymentConfig.deploymentConfig("CodeDeployDefault.LambdaLinear10PercentEvery2Minutes"), LambdaDeploymentConfig.LINEAR_10PERCENT_EVERY_3MINUTES = LambdaDeploymentConfig.deploymentConfig("CodeDeployDefault.LambdaLinear10PercentEvery3Minutes"), exports2.LambdaDeploymentConfig = LambdaDeploymentConfig;
  }
});

// node_modules/aws-cdk-lib/aws-codedeploy/lib/lambda/deployment-group.js
var require_deployment_group2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codedeploy/lib/lambda/deployment-group.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LambdaDeploymentGroup = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var application_1 = require_application2();
    var deployment_config_1 = require_deployment_config2();
    var iam = require_aws_iam();
    var cdk = require_core2();
    var cx_api_1 = require_cx_api();
    var codedeploy_generated_1 = require_codedeploy_generated();
    var base_deployment_group_1 = require_base_deployment_group();
    var utils_1 = require_utils8();
    var LambdaDeploymentGroup = class _LambdaDeploymentGroup extends base_deployment_group_1.DeploymentGroupBase {
      static fromLambdaDeploymentGroupAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codedeploy_LambdaDeploymentGroupAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromLambdaDeploymentGroupAttributes), error;
        }
        return new ImportedLambdaDeploymentGroup(scope, id, attrs);
      }
      constructor(scope, id, props) {
        super(scope, id, { deploymentGroupName: props.deploymentGroupName, role: props.role, roleConstructId: "ServiceRole" });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codedeploy_LambdaDeploymentGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _LambdaDeploymentGroup), error;
        }
        this.role = this._role, this.application = props.application || new application_1.LambdaApplication(this, "Application"), this.alarms = props.alarms || [], this.role.addManagedPolicy(iam.ManagedPolicy.fromAwsManagedPolicyName("service-role/AWSCodeDeployRoleForLambdaLimited")), this.deploymentConfig = this._bindDeploymentConfig(props.deploymentConfig || deployment_config_1.LambdaDeploymentConfig.CANARY_10PERCENT_5MINUTES);
        const removeAlarmsFromDeploymentGroup = cdk.FeatureFlags.of(this).isEnabled(cx_api_1.CODEDEPLOY_REMOVE_ALARMS_FROM_DEPLOYMENT_GROUP), resource = new codedeploy_generated_1.CfnDeploymentGroup(this, "Resource", { applicationName: this.application.applicationName, serviceRoleArn: this.role.roleArn, deploymentGroupName: this.physicalName, deploymentConfigName: this.deploymentConfig.deploymentConfigName, deploymentStyle: { deploymentType: "BLUE_GREEN", deploymentOption: "WITH_TRAFFIC_CONTROL" }, alarmConfiguration: cdk.Lazy.any({ produce: () => (0, utils_1.renderAlarmConfiguration)(this.alarms, props.ignorePollAlarmsFailure, removeAlarmsFromDeploymentGroup) }), autoRollbackConfiguration: cdk.Lazy.any({ produce: () => (0, utils_1.renderAutoRollbackConfiguration)(this.alarms, props.autoRollback) }) });
        this._setNameAndArn(resource, this.application), props.preHook && this.addPreHook(props.preHook), props.postHook && this.addPostHook(props.postHook), props.alias.node.defaultChild.cfnOptions.updatePolicy = { codeDeployLambdaAliasUpdate: { applicationName: this.application.applicationName, deploymentGroupName: resource.ref, beforeAllowTrafficHook: cdk.Lazy.string({ produce: () => this.preHook && this.preHook.functionName }), afterAllowTrafficHook: cdk.Lazy.string({ produce: () => this.postHook && this.postHook.functionName }) } }, this.deploymentConfig instanceof constructs_1.Construct && this.node.addDependency(this.deploymentConfig);
      }
      addAlarm(alarm) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_IAlarm(alarm);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addAlarm), error;
        }
        this.alarms.push(alarm);
      }
      addPreHook(preHook) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_IFunction(preHook);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addPreHook), error;
        }
        if (this.preHook !== void 0)
          throw new Error("A pre-hook function is already defined for this deployment group");
        this.preHook = preHook, this.grantPutLifecycleEventHookExecutionStatus(this.preHook), this.preHook.grantInvoke(this.role);
      }
      addPostHook(postHook) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_IFunction(postHook);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addPostHook), error;
        }
        if (this.postHook !== void 0)
          throw new Error("A post-hook function is already defined for this deployment group");
        this.postHook = postHook, this.grantPutLifecycleEventHookExecutionStatus(this.postHook), this.postHook.grantInvoke(this.role);
      }
      grantPutLifecycleEventHookExecutionStatus(grantee) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(grantee);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantPutLifecycleEventHookExecutionStatus), error;
        }
        return iam.Grant.addToPrincipal({ grantee, resourceArns: [this.deploymentGroupArn], actions: ["codedeploy:PutLifecycleEventHookExecutionStatus"] });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LambdaDeploymentGroup[_a] = { fqn: "aws-cdk-lib.aws_codedeploy.LambdaDeploymentGroup", version: "2.80.0" }, exports2.LambdaDeploymentGroup = LambdaDeploymentGroup;
    var ImportedLambdaDeploymentGroup = class extends base_deployment_group_1.ImportedDeploymentGroupBase {
      constructor(scope, id, props) {
        super(scope, id, { application: props.application, deploymentGroupName: props.deploymentGroupName }), this.application = props.application, this.deploymentConfig = this._bindDeploymentConfig(props.deploymentConfig || deployment_config_1.LambdaDeploymentConfig.CANARY_10PERCENT_5MINUTES);
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-codedeploy/lib/lambda/index.js
var require_lambda6 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codedeploy/lib/lambda/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_application2(), exports2), __exportStar(require_custom_deployment_config(), exports2), __exportStar(require_deployment_config2(), exports2), __exportStar(require_deployment_group2(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-codedeploy/lib/server/application.js
var require_application3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codedeploy/lib/server/application.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ServerApplication = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core_1 = require_core2();
    var codedeploy_generated_1 = require_codedeploy_generated();
    var utils_1 = require_utils8();
    var ServerApplication = class _ServerApplication extends core_1.Resource {
      static fromServerApplicationName(scope, id, serverApplicationName) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.applicationArn = (0, utils_1.arnForApplication)(core_1.Stack.of(scope), serverApplicationName), this.applicationName = serverApplicationName;
          }
        }
        return new Import(scope, id);
      }
      static fromServerApplicationArn(scope, id, serverApplicationArn) {
        return new class extends core_1.Resource {
          constructor() {
            super(...arguments), this.applicationArn = serverApplicationArn, this.applicationName = core_1.Arn.split(serverApplicationArn, core_1.ArnFormat.COLON_RESOURCE_NAME).resourceName ?? "<invalid arn>";
          }
        }(scope, id, { environmentFromArn: serverApplicationArn });
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.applicationName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codedeploy_ServerApplicationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ServerApplication), error;
        }
        const resource = new codedeploy_generated_1.CfnApplication(this, "Resource", { applicationName: this.physicalName, computePlatform: "Server" });
        this.applicationName = this.getResourceNameAttribute(resource.ref), this.applicationArn = this.getResourceArnAttribute((0, utils_1.arnForApplication)(core_1.Stack.of(scope), resource.ref), { service: "codedeploy", resource: "application", resourceName: this.physicalName, arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME }), this.node.addValidation({ validate: () => (0, utils_1.validateName)("Application", this.physicalName) });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ServerApplication[_a] = { fqn: "aws-cdk-lib.aws_codedeploy.ServerApplication", version: "2.80.0" }, exports2.ServerApplication = ServerApplication;
  }
});

// node_modules/aws-cdk-lib/aws-codedeploy/lib/server/deployment-config.js
var require_deployment_config3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codedeploy/lib/server/deployment-config.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ServerDeploymentConfig = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var base_deployment_config_1 = require_base_deployment_config();
    var utils_1 = require_utils8();
    var ServerDeploymentConfig = class _ServerDeploymentConfig extends base_deployment_config_1.BaseDeploymentConfig {
      static fromServerDeploymentConfigName(scope, id, serverDeploymentConfigName) {
        return this.fromDeploymentConfigName(scope, id, serverDeploymentConfigName);
      }
      static deploymentConfig(name) {
        return (0, utils_1.deploymentConfig)(name);
      }
      constructor(scope, id, props) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codedeploy_ServerDeploymentConfigProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ServerDeploymentConfig), error;
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ServerDeploymentConfig[_a] = { fqn: "aws-cdk-lib.aws_codedeploy.ServerDeploymentConfig", version: "2.80.0" }, ServerDeploymentConfig.ONE_AT_A_TIME = ServerDeploymentConfig.deploymentConfig("CodeDeployDefault.OneAtATime"), ServerDeploymentConfig.HALF_AT_A_TIME = ServerDeploymentConfig.deploymentConfig("CodeDeployDefault.HalfAtATime"), ServerDeploymentConfig.ALL_AT_ONCE = ServerDeploymentConfig.deploymentConfig("CodeDeployDefault.AllAtOnce"), exports2.ServerDeploymentConfig = ServerDeploymentConfig;
  }
});

// node_modules/aws-cdk-lib/aws-codedeploy/lib/server/load-balancer.js
var require_load_balancer2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codedeploy/lib/server/load-balancer.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LoadBalancer = exports2.LoadBalancerGeneration = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var LoadBalancerGeneration;
    (function(LoadBalancerGeneration2) {
      LoadBalancerGeneration2[LoadBalancerGeneration2.FIRST = 0] = "FIRST", LoadBalancerGeneration2[LoadBalancerGeneration2.SECOND = 1] = "SECOND";
    })(LoadBalancerGeneration = exports2.LoadBalancerGeneration || (exports2.LoadBalancerGeneration = {}));
    var LoadBalancer = class _LoadBalancer {
      static classic(loadBalancer) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancing_LoadBalancer(loadBalancer);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.classic), error;
        }
        class ClassicLoadBalancer extends _LoadBalancer {
          constructor() {
            super(...arguments), this.generation = LoadBalancerGeneration.FIRST, this.name = loadBalancer.loadBalancerName;
          }
        }
        return new ClassicLoadBalancer();
      }
      static application(albTargetGroup) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_IApplicationTargetGroup(albTargetGroup);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.application), error;
        }
        class AlbLoadBalancer extends _LoadBalancer {
          constructor() {
            super(...arguments), this.generation = LoadBalancerGeneration.SECOND, this.name = albTargetGroup.targetGroupName;
          }
        }
        return new AlbLoadBalancer();
      }
      static network(nlbTargetGroup) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_INetworkTargetGroup(nlbTargetGroup);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.network), error;
        }
        class NlbLoadBalancer extends _LoadBalancer {
          constructor() {
            super(...arguments), this.generation = LoadBalancerGeneration.SECOND, this.name = nlbTargetGroup.targetGroupName;
          }
        }
        return new NlbLoadBalancer();
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LoadBalancer[_a] = { fqn: "aws-cdk-lib.aws_codedeploy.LoadBalancer", version: "2.80.0" }, exports2.LoadBalancer = LoadBalancer;
  }
});

// node_modules/aws-cdk-lib/aws-codedeploy/lib/server/deployment-group.js
var require_deployment_group3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codedeploy/lib/server/deployment-group.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ServerDeploymentGroup = exports2.InstanceTagSet = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var application_1 = require_application3();
    var deployment_config_1 = require_deployment_config3();
    var load_balancer_1 = require_load_balancer2();
    var ec2 = require_aws_ec2();
    var iam = require_aws_iam();
    var s3 = require_aws_s3();
    var cdk = require_core2();
    var cx_api_1 = require_cx_api();
    var codedeploy_generated_1 = require_codedeploy_generated();
    var base_deployment_group_1 = require_base_deployment_group();
    var utils_1 = require_utils8();
    var ImportedServerDeploymentGroup = class extends base_deployment_group_1.ImportedDeploymentGroupBase {
      constructor(scope, id, props) {
        super(scope, id, { application: props.application, deploymentGroupName: props.deploymentGroupName }), this.role = void 0, this.autoScalingGroups = void 0, this.application = props.application, this.deploymentConfig = this._bindDeploymentConfig(props.deploymentConfig || deployment_config_1.ServerDeploymentConfig.ONE_AT_A_TIME);
      }
    };
    var InstanceTagSet = class {
      constructor(...instanceTagGroups) {
        if (instanceTagGroups.length > 3)
          throw new Error(`An instance tag set can have a maximum of 3 instance tag groups, but ${instanceTagGroups.length} were provided`);
        this._instanceTagGroups = instanceTagGroups;
      }
      get instanceTagGroups() {
        return this._instanceTagGroups.slice();
      }
    };
    _a = JSII_RTTI_SYMBOL_1, InstanceTagSet[_a] = { fqn: "aws-cdk-lib.aws_codedeploy.InstanceTagSet", version: "2.80.0" }, exports2.InstanceTagSet = InstanceTagSet;
    var ServerDeploymentGroup = class _ServerDeploymentGroup extends base_deployment_group_1.DeploymentGroupBase {
      static fromServerDeploymentGroupAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codedeploy_ServerDeploymentGroupAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromServerDeploymentGroupAttributes), error;
        }
        return new ImportedServerDeploymentGroup(scope, id, attrs);
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { deploymentGroupName: props.deploymentGroupName, role: props.role, roleConstructId: "Role" });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codedeploy_ServerDeploymentGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ServerDeploymentGroup), error;
        }
        this.role = this._role, this.application = props.application || new application_1.ServerApplication(this, "Application", { applicationName: props.deploymentGroupName === cdk.PhysicalName.GENERATE_IF_NEEDED ? cdk.PhysicalName.GENERATE_IF_NEEDED : void 0 }), this.deploymentConfig = this._bindDeploymentConfig(props.deploymentConfig || deployment_config_1.ServerDeploymentConfig.ONE_AT_A_TIME), this.role.addManagedPolicy(iam.ManagedPolicy.fromAwsManagedPolicyName("service-role/AWSCodeDeployRole")), this._autoScalingGroups = props.autoScalingGroups || [], this.installAgent = props.installAgent ?? true, this.codeDeployBucket = s3.Bucket.fromBucketName(this, "Bucket", `aws-codedeploy-${cdk.Stack.of(this).region}`);
        for (const asg of this._autoScalingGroups)
          this.addCodeDeployAgentInstallUserData(asg);
        this.alarms = props.alarms || [];
        const removeAlarmsFromDeploymentGroup = cdk.FeatureFlags.of(this).isEnabled(cx_api_1.CODEDEPLOY_REMOVE_ALARMS_FROM_DEPLOYMENT_GROUP), resource = new codedeploy_generated_1.CfnDeploymentGroup(this, "Resource", { applicationName: this.application.applicationName, deploymentGroupName: this.physicalName, serviceRoleArn: this.role.roleArn, deploymentConfigName: props.deploymentConfig && props.deploymentConfig.deploymentConfigName, autoScalingGroups: cdk.Lazy.list({ produce: () => this._autoScalingGroups.map((asg) => asg.autoScalingGroupName) }, { omitEmpty: true }), loadBalancerInfo: this.loadBalancerInfo(props.loadBalancer), deploymentStyle: props.loadBalancer === void 0 ? void 0 : { deploymentOption: "WITH_TRAFFIC_CONTROL" }, ec2TagSet: this.ec2TagSet(props.ec2InstanceTags), onPremisesTagSet: this.onPremiseTagSet(props.onPremiseInstanceTags), alarmConfiguration: cdk.Lazy.any({ produce: () => (0, utils_1.renderAlarmConfiguration)(this.alarms, props.ignorePollAlarmsFailure, removeAlarmsFromDeploymentGroup) }), autoRollbackConfiguration: cdk.Lazy.any({ produce: () => (0, utils_1.renderAutoRollbackConfiguration)(this.alarms, props.autoRollback) }) });
        this._setNameAndArn(resource, this.application);
      }
      addAutoScalingGroup(asg) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_autoscaling_AutoScalingGroup(asg);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addAutoScalingGroup), error;
        }
        this._autoScalingGroups.push(asg), this.addCodeDeployAgentInstallUserData(asg);
      }
      addAlarm(alarm) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudwatch_IAlarm(alarm);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addAlarm), error;
        }
        this.alarms.push(alarm);
      }
      get autoScalingGroups() {
        return this._autoScalingGroups.slice();
      }
      addCodeDeployAgentInstallUserData(asg) {
        if (this.installAgent)
          switch (this.codeDeployBucket.grantRead(asg, "latest/*"), asg.osType) {
            case ec2.OperatingSystemType.LINUX:
              asg.addUserData("set +e", "PKG_CMD=`which yum 2>/dev/null`", "set -e", 'if [ -z "$PKG_CMD" ]; then', "PKG_CMD=apt-get", "else", "PKG_CMD=yum", "fi", "$PKG_CMD update -y", "set +e", "$PKG_CMD install -y ruby2.0", "RUBY2_INSTALL=$?", "set -e", "if [ $RUBY2_INSTALL -ne 0 ]; then", "$PKG_CMD install -y ruby", "fi", "AWS_CLI_PACKAGE_NAME=awscli", 'if [ "$PKG_CMD" = "yum" ]; then', "AWS_CLI_PACKAGE_NAME=aws-cli", "fi", "$PKG_CMD install -y $AWS_CLI_PACKAGE_NAME", "TMP_DIR=`mktemp -d`", "cd $TMP_DIR", `aws s3 cp s3://aws-codedeploy-${cdk.Stack.of(this).region}/latest/install . --region ${cdk.Stack.of(this).region}`, "chmod +x ./install", "./install auto", "rm -fr $TMP_DIR");
              break;
            case ec2.OperatingSystemType.WINDOWS:
              asg.addUserData("Set-Variable -Name TEMPDIR -Value (New-TemporaryFile).DirectoryName", `aws s3 cp s3://aws-codedeploy-${cdk.Stack.of(this).region}/latest/codedeploy-agent.msi $TEMPDIR\\codedeploy-agent.msi`, "cd $TEMPDIR", ".\\codedeploy-agent.msi /quiet /l c:\\temp\\host-agent-install-log.txt");
              break;
          }
      }
      loadBalancerInfo(loadBalancer) {
        if (loadBalancer)
          switch (loadBalancer.generation) {
            case load_balancer_1.LoadBalancerGeneration.FIRST:
              return { elbInfoList: [{ name: loadBalancer.name }] };
            case load_balancer_1.LoadBalancerGeneration.SECOND:
              return { targetGroupInfoList: [{ name: loadBalancer.name }] };
          }
      }
      ec2TagSet(tagSet) {
        if (!(!tagSet || tagSet.instanceTagGroups.length === 0))
          return { ec2TagSetList: tagSet.instanceTagGroups.map((tagGroup) => ({ ec2TagGroup: this.tagGroup2TagsArray(tagGroup) })) };
      }
      onPremiseTagSet(tagSet) {
        if (!(!tagSet || tagSet.instanceTagGroups.length === 0))
          return { onPremisesTagSetList: tagSet.instanceTagGroups.map((tagGroup) => ({ onPremisesTagGroup: this.tagGroup2TagsArray(tagGroup) })) };
      }
      tagGroup2TagsArray(tagGroup) {
        const tagsInGroup = new Array();
        for (const tagKey in tagGroup)
          if (tagGroup.hasOwnProperty(tagKey)) {
            const tagValues = tagGroup[tagKey];
            if (tagKey.length > 0)
              if (tagValues.length > 0)
                for (const tagValue of tagValues)
                  tagsInGroup.push({ key: tagKey, value: tagValue, type: "KEY_AND_VALUE" });
              else
                tagsInGroup.push({ key: tagKey, type: "KEY_ONLY" });
            else if (tagValues.length > 0)
              for (const tagValue of tagValues)
                tagsInGroup.push({ value: tagValue, type: "VALUE_ONLY" });
            else
              throw new Error("Cannot specify both an empty key and no values for an instance tag filter");
          }
        return tagsInGroup;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, ServerDeploymentGroup[_b] = { fqn: "aws-cdk-lib.aws_codedeploy.ServerDeploymentGroup", version: "2.80.0" }, exports2.ServerDeploymentGroup = ServerDeploymentGroup;
  }
});

// node_modules/aws-cdk-lib/aws-codedeploy/lib/server/index.js
var require_server = __commonJS({
  "node_modules/aws-cdk-lib/aws-codedeploy/lib/server/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_application3(), exports2), __exportStar(require_deployment_config3(), exports2), __exportStar(require_deployment_group3(), exports2), __exportStar(require_load_balancer2(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-codedeploy/lib/index.js
var require_lib81 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codedeploy/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_base_deployment_config(), exports2), __exportStar(require_host_health_config(), exports2), __exportStar(require_rollback_config(), exports2), __exportStar(require_traffic_routing_config(), exports2), __exportStar(require_ecs2(), exports2), __exportStar(require_lambda6(), exports2), __exportStar(require_server(), exports2), __exportStar(require_codedeploy_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-codedeploy/index.js
var require_aws_codedeploy = __commonJS({
  "node_modules/aws-cdk-lib/aws-codedeploy/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib81(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-codegurureviewer/lib/codegurureviewer.generated.js
var require_codegurureviewer_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-codegurureviewer/lib/codegurureviewer.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnRepositoryAssociation = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnRepositoryAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.collect(cdk.propertyValidator("connectionArn", cdk.validateString)(properties.connectionArn)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("owner", cdk.validateString)(properties.owner)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnRepositoryAssociationProps"');
    }
    function cfnRepositoryAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRepositoryAssociationPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Type: cdk.stringToCloudFormation(properties.type), BucketName: cdk.stringToCloudFormation(properties.bucketName), ConnectionArn: cdk.stringToCloudFormation(properties.connectionArn), Owner: cdk.stringToCloudFormation(properties.owner), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnRepositoryAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("bucketName", "BucketName", properties.BucketName != null ? cfn_parse.FromCloudFormation.getString(properties.BucketName) : void 0), ret.addPropertyResult("connectionArn", "ConnectionArn", properties.ConnectionArn != null ? cfn_parse.FromCloudFormation.getString(properties.ConnectionArn) : void 0), ret.addPropertyResult("owner", "Owner", properties.Owner != null ? cfn_parse.FromCloudFormation.getString(properties.Owner) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRepositoryAssociation = class _CfnRepositoryAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRepositoryAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnRepositoryAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRepositoryAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codegurureviewer_CfnRepositoryAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRepositoryAssociation), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "type", this), this.attrAssociationArn = cdk.Token.asString(this.getAtt("AssociationArn", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.type = props.type, this.bucketName = props.bucketName, this.connectionArn = props.connectionArn, this.owner = props.owner, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::CodeGuruReviewer::RepositoryAssociation", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRepositoryAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, type: this.type, bucketName: this.bucketName, connectionArn: this.connectionArn, owner: this.owner, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnRepositoryAssociationPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnRepositoryAssociation[_a] = { fqn: "aws-cdk-lib.aws_codegurureviewer.CfnRepositoryAssociation", version: "2.80.0" }, CfnRepositoryAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::CodeGuruReviewer::RepositoryAssociation", exports2.CfnRepositoryAssociation = CfnRepositoryAssociation;
  }
});

// node_modules/aws-cdk-lib/aws-codegurureviewer/lib/index.js
var require_lib82 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codegurureviewer/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_codegurureviewer_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-codegurureviewer/index.js
var require_aws_codegurureviewer = __commonJS({
  "node_modules/aws-cdk-lib/aws-codegurureviewer/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib82(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline/lib/action.js
var require_action = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline/lib/action.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PipelineNotificationEvents = exports2.Action = exports2.GlobalVariables = exports2.ActionCategory = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var events = require_aws_events();
    var core_1 = require_core2();
    var ActionCategory;
    (function(ActionCategory2) {
      ActionCategory2.SOURCE = "Source", ActionCategory2.BUILD = "Build", ActionCategory2.TEST = "Test", ActionCategory2.APPROVAL = "Approval", ActionCategory2.DEPLOY = "Deploy", ActionCategory2.INVOKE = "Invoke";
    })(ActionCategory = exports2.ActionCategory || (exports2.ActionCategory = {}));
    var GlobalVariables = class {
    };
    _a = JSII_RTTI_SYMBOL_1, GlobalVariables[_a] = { fqn: "aws-cdk-lib.aws_codepipeline.GlobalVariables", version: "2.80.0" }, GlobalVariables.executionId = "#{codepipeline.PipelineExecutionId}", exports2.GlobalVariables = GlobalVariables;
    var Action = class {
      constructor() {
        this._variableReferenced = false, this._namespaceToken = core_1.Lazy.string({ produce: () => {
          if (this._actualNamespace === void 0)
            throw new Error(`Cannot reference variables of action '${this.actionProperties.actionName}', as that action was never added to a pipeline`);
          return this._customerProvidedNamespace !== void 0 ? this._customerProvidedNamespace : this._variableReferenced ? this._actualNamespace : void 0;
        } });
      }
      get actionProperties() {
        if (this.__actionProperties === void 0) {
          const actionProperties = this.providedActionProperties;
          this._customerProvidedNamespace = actionProperties.variablesNamespace, this.__actionProperties = { ...actionProperties, variablesNamespace: this._customerProvidedNamespace === void 0 ? this._namespaceToken : this._customerProvidedNamespace };
        }
        return this.__actionProperties;
      }
      bind(scope, stage, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_IStage(stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_ActionBindOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return this.__pipeline = stage.pipeline, this.__stage = stage, this.__scope = scope, this._actualNamespace = this._customerProvidedNamespace === void 0 ? `${stage.stageName}_${this.actionProperties.actionName}_NS` : this._customerProvidedNamespace, this.bound(scope, stage, options);
      }
      onStateChange(name, target, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_IRuleTarget(target), jsiiDeprecationWarnings.aws_cdk_lib_aws_events_RuleProps(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.onStateChange), error;
        }
        const rule = new events.Rule(this._scope, name, options);
        return rule.addTarget(target), rule.addEventPattern({ detailType: ["CodePipeline Action Execution State Change"], source: ["aws.codepipeline"], resources: [this._pipeline.pipelineArn], detail: { stage: [this._stage.stageName], action: [this.actionProperties.actionName] } }), rule;
      }
      variableExpression(variableName) {
        return this._variableReferenced = true, `#{${this._namespaceToken}.${variableName}}`;
      }
      get _pipeline() {
        if (this.__pipeline)
          return this.__pipeline;
        throw new Error("Action must be added to a stage that is part of a pipeline before using onStateChange");
      }
      get _stage() {
        if (this.__stage)
          return this.__stage;
        throw new Error("Action must be added to a stage that is part of a pipeline before using onStateChange");
      }
      get _scope() {
        if (this.__scope)
          return this.__scope;
        throw new Error("Action must be added to a stage that is part of a pipeline first");
      }
    };
    _b = JSII_RTTI_SYMBOL_1, Action[_b] = { fqn: "aws-cdk-lib.aws_codepipeline.Action", version: "2.80.0" }, exports2.Action = Action;
    var PipelineNotificationEvents;
    (function(PipelineNotificationEvents2) {
      PipelineNotificationEvents2.PIPELINE_EXECUTION_FAILED = "codepipeline-pipeline-pipeline-execution-failed", PipelineNotificationEvents2.PIPELINE_EXECUTION_CANCELED = "codepipeline-pipeline-pipeline-execution-canceled", PipelineNotificationEvents2.PIPELINE_EXECUTION_STARTED = "codepipeline-pipeline-pipeline-execution-started", PipelineNotificationEvents2.PIPELINE_EXECUTION_RESUMED = "codepipeline-pipeline-pipeline-execution-resumed", PipelineNotificationEvents2.PIPELINE_EXECUTION_SUCCEEDED = "codepipeline-pipeline-pipeline-execution-succeeded", PipelineNotificationEvents2.PIPELINE_EXECUTION_SUPERSEDED = "codepipeline-pipeline-pipeline-execution-superseded", PipelineNotificationEvents2.STAGE_EXECUTION_STARTED = "codepipeline-pipeline-stage-execution-started", PipelineNotificationEvents2.STAGE_EXECUTION_SUCCEEDED = "codepipeline-pipeline-stage-execution-succeeded", PipelineNotificationEvents2.STAGE_EXECUTION_RESUMED = "codepipeline-pipeline-stage-execution-resumed", PipelineNotificationEvents2.STAGE_EXECUTION_CANCELED = "codepipeline-pipeline-stage-execution-canceled", PipelineNotificationEvents2.STAGE_EXECUTION_FAILED = "codepipeline-pipeline-stage-execution-failed", PipelineNotificationEvents2.ACTION_EXECUTION_SUCCEEDED = "codepipeline-pipeline-action-execution-succeeded", PipelineNotificationEvents2.ACTION_EXECUTION_FAILED = "codepipeline-pipeline-action-execution-failed", PipelineNotificationEvents2.ACTION_EXECUTION_CANCELED = "codepipeline-pipeline-action-execution-canceled", PipelineNotificationEvents2.ACTION_EXECUTION_STARTED = "codepipeline-pipeline-action-execution-started", PipelineNotificationEvents2.MANUAL_APPROVAL_FAILED = "codepipeline-pipeline-manual-approval-failed", PipelineNotificationEvents2.MANUAL_APPROVAL_NEEDED = "codepipeline-pipeline-manual-approval-needed", PipelineNotificationEvents2.MANUAL_APPROVAL_SUCCEEDED = "codepipeline-pipeline-manual-approval-succeeded";
    })(PipelineNotificationEvents = exports2.PipelineNotificationEvents || (exports2.PipelineNotificationEvents = {}));
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline/lib/private/validation.js
var require_validation3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline/lib/private/validation.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.validateNamespaceName = exports2.validateArtifactName = exports2.validateName = exports2.validateSourceAction = exports2.validateArtifactBounds = void 0;
    var cdk = require_core2();
    var action_1 = require_action();
    function validateArtifactBounds(type, artifacts, min, max, category, provider) {
      const ret = [];
      return artifacts.length < min && ret.push(`${category}/${provider} must have at least ${min} ${type} artifacts`), artifacts.length > max && ret.push(`${category}/${provider} cannot have more than ${max} ${type} artifacts`), ret;
    }
    exports2.validateArtifactBounds = validateArtifactBounds;
    function validateSourceAction(mustBeSource, category, actionName, stageName) {
      return mustBeSource !== (category === action_1.ActionCategory.SOURCE) ? [`Action ${actionName} in stage ${stageName}: ` + (mustBeSource ? "first stage may only contain Source actions" : "Source actions may only occur in first stage")] : [];
    }
    exports2.validateSourceAction = validateSourceAction;
    var VALID_IDENTIFIER_REGEX = /^[a-zA-Z0-9.@_-]{1,100}$/;
    function validateName(thing, name) {
      validateAgainstRegex(VALID_IDENTIFIER_REGEX, thing, name);
    }
    exports2.validateName = validateName;
    function validateArtifactName(artifactName) {
      validateAgainstRegex(/^[a-zA-Z0-9_-]{1,100}$/, "Artifact", artifactName);
    }
    exports2.validateArtifactName = validateArtifactName;
    function validateNamespaceName(namespaceName) {
      validateAgainstRegex(/^[A-Za-z0-9@_-]{1,100}$/, "Namespace", namespaceName);
    }
    exports2.validateNamespaceName = validateNamespaceName;
    function validateAgainstRegex(regex, thing, name) {
      if (!cdk.Token.isUnresolved(name) && name !== void 0 && !regex.test(name))
        throw new Error(`${thing} name must match regular expression: ${regex.toString()}, got '${name}'`);
    }
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline/lib/artifact.js
var require_artifact = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline/lib/artifact.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ArtifactPath = exports2.Artifact = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var validation = require_validation3();
    var core_1 = require_core2();
    var Artifact = class _Artifact {
      static artifact(name) {
        return new _Artifact(name);
      }
      constructor(artifactName) {
        this.metadata = {}, validation.validateArtifactName(artifactName), this._artifactName = artifactName;
      }
      get artifactName() {
        return this._artifactName;
      }
      atPath(fileName) {
        return new ArtifactPath(this, fileName);
      }
      get bucketName() {
        return artifactAttribute(this, "BucketName");
      }
      get objectKey() {
        return artifactAttribute(this, "ObjectKey");
      }
      get url() {
        return artifactAttribute(this, "URL");
      }
      getParam(jsonFile, keyName) {
        return artifactGetParam(this, jsonFile, keyName);
      }
      get s3Location() {
        return { bucketName: this.bucketName, objectKey: this.objectKey };
      }
      setMetadata(key, value) {
        this.metadata[key] = value;
      }
      getMetadata(key) {
        return this.metadata[key];
      }
      toString() {
        return this.artifactName;
      }
      _setName(name) {
        if (this._artifactName)
          throw new Error(`Artifact already has name '${this._artifactName}', cannot override it`);
        this._artifactName = name;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Artifact[_a] = { fqn: "aws-cdk-lib.aws_codepipeline.Artifact", version: "2.80.0" }, exports2.Artifact = Artifact;
    var ArtifactPath = class _ArtifactPath {
      static artifactPath(artifactName, fileName) {
        return new _ArtifactPath(Artifact.artifact(artifactName), fileName);
      }
      constructor(artifact, fileName) {
        this.artifact = artifact, this.fileName = fileName;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_Artifact(artifact);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ArtifactPath), error;
        }
      }
      get location() {
        return `${this.artifact.artifactName ? this.artifact.artifactName : core_1.Lazy.string({ produce: () => this.artifact.artifactName })}::${this.fileName}`;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, ArtifactPath[_b] = { fqn: "aws-cdk-lib.aws_codepipeline.ArtifactPath", version: "2.80.0" }, exports2.ArtifactPath = ArtifactPath;
    function artifactAttribute(artifact, attributeName) {
      const lazyArtifactName = core_1.Lazy.string({ produce: () => artifact.artifactName });
      return core_1.Token.asString({ "Fn::GetArtifactAtt": [lazyArtifactName, attributeName] });
    }
    function artifactGetParam(artifact, jsonFile, keyName) {
      const lazyArtifactName = core_1.Lazy.string({ produce: () => artifact.artifactName });
      return core_1.Token.asString({ "Fn::GetParam": [lazyArtifactName, jsonFile, keyName] });
    }
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline/lib/codepipeline.generated.js
var require_codepipeline_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline/lib/codepipeline.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnWebhook = exports2.CfnPipeline = exports2.CfnCustomActionType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnCustomActionTypePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("category", cdk.requiredValidator)(properties.category)), errors.collect(cdk.propertyValidator("category", cdk.validateString)(properties.category)), errors.collect(cdk.propertyValidator("configurationProperties", cdk.listValidator(CfnCustomActionType_ConfigurationPropertiesPropertyValidator))(properties.configurationProperties)), errors.collect(cdk.propertyValidator("inputArtifactDetails", cdk.requiredValidator)(properties.inputArtifactDetails)), errors.collect(cdk.propertyValidator("inputArtifactDetails", CfnCustomActionType_ArtifactDetailsPropertyValidator)(properties.inputArtifactDetails)), errors.collect(cdk.propertyValidator("outputArtifactDetails", cdk.requiredValidator)(properties.outputArtifactDetails)), errors.collect(cdk.propertyValidator("outputArtifactDetails", CfnCustomActionType_ArtifactDetailsPropertyValidator)(properties.outputArtifactDetails)), errors.collect(cdk.propertyValidator("provider", cdk.requiredValidator)(properties.provider)), errors.collect(cdk.propertyValidator("provider", cdk.validateString)(properties.provider)), errors.collect(cdk.propertyValidator("settings", CfnCustomActionType_SettingsPropertyValidator)(properties.settings)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("version", cdk.requiredValidator)(properties.version)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "CfnCustomActionTypeProps"');
    }
    function cfnCustomActionTypePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCustomActionTypePropsValidator(properties).assertSuccess(), { Category: cdk.stringToCloudFormation(properties.category), InputArtifactDetails: cfnCustomActionTypeArtifactDetailsPropertyToCloudFormation(properties.inputArtifactDetails), OutputArtifactDetails: cfnCustomActionTypeArtifactDetailsPropertyToCloudFormation(properties.outputArtifactDetails), Provider: cdk.stringToCloudFormation(properties.provider), Version: cdk.stringToCloudFormation(properties.version), ConfigurationProperties: cdk.listMapper(cfnCustomActionTypeConfigurationPropertiesPropertyToCloudFormation)(properties.configurationProperties), Settings: cfnCustomActionTypeSettingsPropertyToCloudFormation(properties.settings), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnCustomActionTypePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("category", "Category", cfn_parse.FromCloudFormation.getString(properties.Category)), ret.addPropertyResult("inputArtifactDetails", "InputArtifactDetails", CfnCustomActionTypeArtifactDetailsPropertyFromCloudFormation(properties.InputArtifactDetails)), ret.addPropertyResult("outputArtifactDetails", "OutputArtifactDetails", CfnCustomActionTypeArtifactDetailsPropertyFromCloudFormation(properties.OutputArtifactDetails)), ret.addPropertyResult("provider", "Provider", cfn_parse.FromCloudFormation.getString(properties.Provider)), ret.addPropertyResult("version", "Version", cfn_parse.FromCloudFormation.getString(properties.Version)), ret.addPropertyResult("configurationProperties", "ConfigurationProperties", properties.ConfigurationProperties != null ? cfn_parse.FromCloudFormation.getArray(CfnCustomActionTypeConfigurationPropertiesPropertyFromCloudFormation)(properties.ConfigurationProperties) : void 0), ret.addPropertyResult("settings", "Settings", properties.Settings != null ? CfnCustomActionTypeSettingsPropertyFromCloudFormation(properties.Settings) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCustomActionType = class _CfnCustomActionType extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCustomActionTypePropsFromCloudFormation(resourceProperties), ret = new _CfnCustomActionType(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCustomActionType.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_CfnCustomActionTypeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCustomActionType), error;
        }
        cdk.requireProperty(props, "category", this), cdk.requireProperty(props, "inputArtifactDetails", this), cdk.requireProperty(props, "outputArtifactDetails", this), cdk.requireProperty(props, "provider", this), cdk.requireProperty(props, "version", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.category = props.category, this.inputArtifactDetails = props.inputArtifactDetails, this.outputArtifactDetails = props.outputArtifactDetails, this.provider = props.provider, this.version = props.version, this.configurationProperties = props.configurationProperties, this.settings = props.settings, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::CodePipeline::CustomActionType", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCustomActionType.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { category: this.category, inputArtifactDetails: this.inputArtifactDetails, outputArtifactDetails: this.outputArtifactDetails, provider: this.provider, version: this.version, configurationProperties: this.configurationProperties, settings: this.settings, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnCustomActionTypePropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnCustomActionType[_a] = { fqn: "aws-cdk-lib.aws_codepipeline.CfnCustomActionType", version: "2.80.0" }, CfnCustomActionType.CFN_RESOURCE_TYPE_NAME = "AWS::CodePipeline::CustomActionType", exports2.CfnCustomActionType = CfnCustomActionType;
    function CfnCustomActionType_ArtifactDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maximumCount", cdk.requiredValidator)(properties.maximumCount)), errors.collect(cdk.propertyValidator("maximumCount", cdk.validateNumber)(properties.maximumCount)), errors.collect(cdk.propertyValidator("minimumCount", cdk.requiredValidator)(properties.minimumCount)), errors.collect(cdk.propertyValidator("minimumCount", cdk.validateNumber)(properties.minimumCount)), errors.wrap('supplied properties not correct for "ArtifactDetailsProperty"');
    }
    function cfnCustomActionTypeArtifactDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCustomActionType_ArtifactDetailsPropertyValidator(properties).assertSuccess(), { MaximumCount: cdk.numberToCloudFormation(properties.maximumCount), MinimumCount: cdk.numberToCloudFormation(properties.minimumCount) }) : properties;
    }
    function CfnCustomActionTypeArtifactDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maximumCount", "MaximumCount", cfn_parse.FromCloudFormation.getNumber(properties.MaximumCount)), ret.addPropertyResult("minimumCount", "MinimumCount", cfn_parse.FromCloudFormation.getNumber(properties.MinimumCount)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCustomActionType_ConfigurationPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateBoolean)(properties.key)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("queryable", cdk.validateBoolean)(properties.queryable)), errors.collect(cdk.propertyValidator("required", cdk.requiredValidator)(properties.required)), errors.collect(cdk.propertyValidator("required", cdk.validateBoolean)(properties.required)), errors.collect(cdk.propertyValidator("secret", cdk.requiredValidator)(properties.secret)), errors.collect(cdk.propertyValidator("secret", cdk.validateBoolean)(properties.secret)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "ConfigurationPropertiesProperty"');
    }
    function cfnCustomActionTypeConfigurationPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCustomActionType_ConfigurationPropertiesPropertyValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), Key: cdk.booleanToCloudFormation(properties.key), Name: cdk.stringToCloudFormation(properties.name), Queryable: cdk.booleanToCloudFormation(properties.queryable), Required: cdk.booleanToCloudFormation(properties.required), Secret: cdk.booleanToCloudFormation(properties.secret), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnCustomActionTypeConfigurationPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getBoolean(properties.Key)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("queryable", "Queryable", properties.Queryable != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Queryable) : void 0), ret.addPropertyResult("required", "Required", cfn_parse.FromCloudFormation.getBoolean(properties.Required)), ret.addPropertyResult("secret", "Secret", cfn_parse.FromCloudFormation.getBoolean(properties.Secret)), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCustomActionType_SettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("entityUrlTemplate", cdk.validateString)(properties.entityUrlTemplate)), errors.collect(cdk.propertyValidator("executionUrlTemplate", cdk.validateString)(properties.executionUrlTemplate)), errors.collect(cdk.propertyValidator("revisionUrlTemplate", cdk.validateString)(properties.revisionUrlTemplate)), errors.collect(cdk.propertyValidator("thirdPartyConfigurationUrl", cdk.validateString)(properties.thirdPartyConfigurationUrl)), errors.wrap('supplied properties not correct for "SettingsProperty"');
    }
    function cfnCustomActionTypeSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCustomActionType_SettingsPropertyValidator(properties).assertSuccess(), { EntityUrlTemplate: cdk.stringToCloudFormation(properties.entityUrlTemplate), ExecutionUrlTemplate: cdk.stringToCloudFormation(properties.executionUrlTemplate), RevisionUrlTemplate: cdk.stringToCloudFormation(properties.revisionUrlTemplate), ThirdPartyConfigurationUrl: cdk.stringToCloudFormation(properties.thirdPartyConfigurationUrl) }) : properties;
    }
    function CfnCustomActionTypeSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("entityUrlTemplate", "EntityUrlTemplate", properties.EntityUrlTemplate != null ? cfn_parse.FromCloudFormation.getString(properties.EntityUrlTemplate) : void 0), ret.addPropertyResult("executionUrlTemplate", "ExecutionUrlTemplate", properties.ExecutionUrlTemplate != null ? cfn_parse.FromCloudFormation.getString(properties.ExecutionUrlTemplate) : void 0), ret.addPropertyResult("revisionUrlTemplate", "RevisionUrlTemplate", properties.RevisionUrlTemplate != null ? cfn_parse.FromCloudFormation.getString(properties.RevisionUrlTemplate) : void 0), ret.addPropertyResult("thirdPartyConfigurationUrl", "ThirdPartyConfigurationUrl", properties.ThirdPartyConfigurationUrl != null ? cfn_parse.FromCloudFormation.getString(properties.ThirdPartyConfigurationUrl) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipelinePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("artifactStore", CfnPipeline_ArtifactStorePropertyValidator)(properties.artifactStore)), errors.collect(cdk.propertyValidator("artifactStores", cdk.listValidator(CfnPipeline_ArtifactStoreMapPropertyValidator))(properties.artifactStores)), errors.collect(cdk.propertyValidator("disableInboundStageTransitions", cdk.listValidator(CfnPipeline_StageTransitionPropertyValidator))(properties.disableInboundStageTransitions)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("restartExecutionOnUpdate", cdk.validateBoolean)(properties.restartExecutionOnUpdate)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("stages", cdk.requiredValidator)(properties.stages)), errors.collect(cdk.propertyValidator("stages", cdk.listValidator(CfnPipeline_StageDeclarationPropertyValidator))(properties.stages)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnPipelineProps"');
    }
    function cfnPipelinePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipelinePropsValidator(properties).assertSuccess(), { RoleArn: cdk.stringToCloudFormation(properties.roleArn), Stages: cdk.listMapper(cfnPipelineStageDeclarationPropertyToCloudFormation)(properties.stages), ArtifactStore: cfnPipelineArtifactStorePropertyToCloudFormation(properties.artifactStore), ArtifactStores: cdk.listMapper(cfnPipelineArtifactStoreMapPropertyToCloudFormation)(properties.artifactStores), DisableInboundStageTransitions: cdk.listMapper(cfnPipelineStageTransitionPropertyToCloudFormation)(properties.disableInboundStageTransitions), Name: cdk.stringToCloudFormation(properties.name), RestartExecutionOnUpdate: cdk.booleanToCloudFormation(properties.restartExecutionOnUpdate), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnPipelinePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("stages", "Stages", cfn_parse.FromCloudFormation.getArray(CfnPipelineStageDeclarationPropertyFromCloudFormation)(properties.Stages)), ret.addPropertyResult("artifactStore", "ArtifactStore", properties.ArtifactStore != null ? CfnPipelineArtifactStorePropertyFromCloudFormation(properties.ArtifactStore) : void 0), ret.addPropertyResult("artifactStores", "ArtifactStores", properties.ArtifactStores != null ? cfn_parse.FromCloudFormation.getArray(CfnPipelineArtifactStoreMapPropertyFromCloudFormation)(properties.ArtifactStores) : void 0), ret.addPropertyResult("disableInboundStageTransitions", "DisableInboundStageTransitions", properties.DisableInboundStageTransitions != null ? cfn_parse.FromCloudFormation.getArray(CfnPipelineStageTransitionPropertyFromCloudFormation)(properties.DisableInboundStageTransitions) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("restartExecutionOnUpdate", "RestartExecutionOnUpdate", properties.RestartExecutionOnUpdate != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RestartExecutionOnUpdate) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPipeline = class _CfnPipeline extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPipelinePropsFromCloudFormation(resourceProperties), ret = new _CfnPipeline(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPipeline.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_CfnPipelineProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPipeline), error;
        }
        cdk.requireProperty(props, "roleArn", this), cdk.requireProperty(props, "stages", this), this.attrVersion = cdk.Token.asString(this.getAtt("Version", cdk.ResolutionTypeHint.STRING)), this.roleArn = props.roleArn, this.stages = props.stages, this.artifactStore = props.artifactStore, this.artifactStores = props.artifactStores, this.disableInboundStageTransitions = props.disableInboundStageTransitions, this.name = props.name, this.restartExecutionOnUpdate = props.restartExecutionOnUpdate, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::CodePipeline::Pipeline", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPipeline.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { roleArn: this.roleArn, stages: this.stages, artifactStore: this.artifactStore, artifactStores: this.artifactStores, disableInboundStageTransitions: this.disableInboundStageTransitions, name: this.name, restartExecutionOnUpdate: this.restartExecutionOnUpdate, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnPipelinePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnPipeline[_b] = { fqn: "aws-cdk-lib.aws_codepipeline.CfnPipeline", version: "2.80.0" }, CfnPipeline.CFN_RESOURCE_TYPE_NAME = "AWS::CodePipeline::Pipeline", exports2.CfnPipeline = CfnPipeline;
    function CfnPipeline_ActionDeclarationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actionTypeId", cdk.requiredValidator)(properties.actionTypeId)), errors.collect(cdk.propertyValidator("actionTypeId", CfnPipeline_ActionTypeIdPropertyValidator)(properties.actionTypeId)), errors.collect(cdk.propertyValidator("configuration", cdk.validateObject)(properties.configuration)), errors.collect(cdk.propertyValidator("inputArtifacts", cdk.listValidator(CfnPipeline_InputArtifactPropertyValidator))(properties.inputArtifacts)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("namespace", cdk.validateString)(properties.namespace)), errors.collect(cdk.propertyValidator("outputArtifacts", cdk.listValidator(CfnPipeline_OutputArtifactPropertyValidator))(properties.outputArtifacts)), errors.collect(cdk.propertyValidator("region", cdk.validateString)(properties.region)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("runOrder", cdk.validateNumber)(properties.runOrder)), errors.wrap('supplied properties not correct for "ActionDeclarationProperty"');
    }
    function cfnPipelineActionDeclarationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipeline_ActionDeclarationPropertyValidator(properties).assertSuccess(), { ActionTypeId: cfnPipelineActionTypeIdPropertyToCloudFormation(properties.actionTypeId), Configuration: cdk.objectToCloudFormation(properties.configuration), InputArtifacts: cdk.listMapper(cfnPipelineInputArtifactPropertyToCloudFormation)(properties.inputArtifacts), Name: cdk.stringToCloudFormation(properties.name), Namespace: cdk.stringToCloudFormation(properties.namespace), OutputArtifacts: cdk.listMapper(cfnPipelineOutputArtifactPropertyToCloudFormation)(properties.outputArtifacts), Region: cdk.stringToCloudFormation(properties.region), RoleArn: cdk.stringToCloudFormation(properties.roleArn), RunOrder: cdk.numberToCloudFormation(properties.runOrder) }) : properties;
    }
    function CfnPipelineActionDeclarationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actionTypeId", "ActionTypeId", CfnPipelineActionTypeIdPropertyFromCloudFormation(properties.ActionTypeId)), ret.addPropertyResult("configuration", "Configuration", properties.Configuration != null ? cfn_parse.FromCloudFormation.getAny(properties.Configuration) : void 0), ret.addPropertyResult("inputArtifacts", "InputArtifacts", properties.InputArtifacts != null ? cfn_parse.FromCloudFormation.getArray(CfnPipelineInputArtifactPropertyFromCloudFormation)(properties.InputArtifacts) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("namespace", "Namespace", properties.Namespace != null ? cfn_parse.FromCloudFormation.getString(properties.Namespace) : void 0), ret.addPropertyResult("outputArtifacts", "OutputArtifacts", properties.OutputArtifacts != null ? cfn_parse.FromCloudFormation.getArray(CfnPipelineOutputArtifactPropertyFromCloudFormation)(properties.OutputArtifacts) : void 0), ret.addPropertyResult("region", "Region", properties.Region != null ? cfn_parse.FromCloudFormation.getString(properties.Region) : void 0), ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addPropertyResult("runOrder", "RunOrder", properties.RunOrder != null ? cfn_parse.FromCloudFormation.getNumber(properties.RunOrder) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipeline_ActionTypeIdPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("category", cdk.requiredValidator)(properties.category)), errors.collect(cdk.propertyValidator("category", cdk.validateString)(properties.category)), errors.collect(cdk.propertyValidator("owner", cdk.requiredValidator)(properties.owner)), errors.collect(cdk.propertyValidator("owner", cdk.validateString)(properties.owner)), errors.collect(cdk.propertyValidator("provider", cdk.requiredValidator)(properties.provider)), errors.collect(cdk.propertyValidator("provider", cdk.validateString)(properties.provider)), errors.collect(cdk.propertyValidator("version", cdk.requiredValidator)(properties.version)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "ActionTypeIdProperty"');
    }
    function cfnPipelineActionTypeIdPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipeline_ActionTypeIdPropertyValidator(properties).assertSuccess(), { Category: cdk.stringToCloudFormation(properties.category), Owner: cdk.stringToCloudFormation(properties.owner), Provider: cdk.stringToCloudFormation(properties.provider), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnPipelineActionTypeIdPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("category", "Category", cfn_parse.FromCloudFormation.getString(properties.Category)), ret.addPropertyResult("owner", "Owner", cfn_parse.FromCloudFormation.getString(properties.Owner)), ret.addPropertyResult("provider", "Provider", cfn_parse.FromCloudFormation.getString(properties.Provider)), ret.addPropertyResult("version", "Version", cfn_parse.FromCloudFormation.getString(properties.Version)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipeline_ArtifactStorePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("encryptionKey", CfnPipeline_EncryptionKeyPropertyValidator)(properties.encryptionKey)), errors.collect(cdk.propertyValidator("location", cdk.requiredValidator)(properties.location)), errors.collect(cdk.propertyValidator("location", cdk.validateString)(properties.location)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "ArtifactStoreProperty"');
    }
    function cfnPipelineArtifactStorePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipeline_ArtifactStorePropertyValidator(properties).assertSuccess(), { EncryptionKey: cfnPipelineEncryptionKeyPropertyToCloudFormation(properties.encryptionKey), Location: cdk.stringToCloudFormation(properties.location), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnPipelineArtifactStorePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("encryptionKey", "EncryptionKey", properties.EncryptionKey != null ? CfnPipelineEncryptionKeyPropertyFromCloudFormation(properties.EncryptionKey) : void 0), ret.addPropertyResult("location", "Location", cfn_parse.FromCloudFormation.getString(properties.Location)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipeline_ArtifactStoreMapPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("artifactStore", cdk.requiredValidator)(properties.artifactStore)), errors.collect(cdk.propertyValidator("artifactStore", CfnPipeline_ArtifactStorePropertyValidator)(properties.artifactStore)), errors.collect(cdk.propertyValidator("region", cdk.requiredValidator)(properties.region)), errors.collect(cdk.propertyValidator("region", cdk.validateString)(properties.region)), errors.wrap('supplied properties not correct for "ArtifactStoreMapProperty"');
    }
    function cfnPipelineArtifactStoreMapPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipeline_ArtifactStoreMapPropertyValidator(properties).assertSuccess(), { ArtifactStore: cfnPipelineArtifactStorePropertyToCloudFormation(properties.artifactStore), Region: cdk.stringToCloudFormation(properties.region) }) : properties;
    }
    function CfnPipelineArtifactStoreMapPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("artifactStore", "ArtifactStore", CfnPipelineArtifactStorePropertyFromCloudFormation(properties.ArtifactStore)), ret.addPropertyResult("region", "Region", cfn_parse.FromCloudFormation.getString(properties.Region)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipeline_BlockerDeclarationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "BlockerDeclarationProperty"');
    }
    function cfnPipelineBlockerDeclarationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipeline_BlockerDeclarationPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnPipelineBlockerDeclarationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipeline_EncryptionKeyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "EncryptionKeyProperty"');
    }
    function cfnPipelineEncryptionKeyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipeline_EncryptionKeyPropertyValidator(properties).assertSuccess(), { Id: cdk.stringToCloudFormation(properties.id), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnPipelineEncryptionKeyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipeline_InputArtifactPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "InputArtifactProperty"');
    }
    function cfnPipelineInputArtifactPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipeline_InputArtifactPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnPipelineInputArtifactPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipeline_OutputArtifactPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "OutputArtifactProperty"');
    }
    function cfnPipelineOutputArtifactPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipeline_OutputArtifactPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnPipelineOutputArtifactPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipeline_StageDeclarationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.requiredValidator)(properties.actions)), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnPipeline_ActionDeclarationPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("blockers", cdk.listValidator(CfnPipeline_BlockerDeclarationPropertyValidator))(properties.blockers)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "StageDeclarationProperty"');
    }
    function cfnPipelineStageDeclarationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipeline_StageDeclarationPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnPipelineActionDeclarationPropertyToCloudFormation)(properties.actions), Blockers: cdk.listMapper(cfnPipelineBlockerDeclarationPropertyToCloudFormation)(properties.blockers), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnPipelineStageDeclarationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", cfn_parse.FromCloudFormation.getArray(CfnPipelineActionDeclarationPropertyFromCloudFormation)(properties.Actions)), ret.addPropertyResult("blockers", "Blockers", properties.Blockers != null ? cfn_parse.FromCloudFormation.getArray(CfnPipelineBlockerDeclarationPropertyFromCloudFormation)(properties.Blockers) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipeline_StageTransitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("reason", cdk.requiredValidator)(properties.reason)), errors.collect(cdk.propertyValidator("reason", cdk.validateString)(properties.reason)), errors.collect(cdk.propertyValidator("stageName", cdk.requiredValidator)(properties.stageName)), errors.collect(cdk.propertyValidator("stageName", cdk.validateString)(properties.stageName)), errors.wrap('supplied properties not correct for "StageTransitionProperty"');
    }
    function cfnPipelineStageTransitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipeline_StageTransitionPropertyValidator(properties).assertSuccess(), { Reason: cdk.stringToCloudFormation(properties.reason), StageName: cdk.stringToCloudFormation(properties.stageName) }) : properties;
    }
    function CfnPipelineStageTransitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("reason", "Reason", cfn_parse.FromCloudFormation.getString(properties.Reason)), ret.addPropertyResult("stageName", "StageName", cfn_parse.FromCloudFormation.getString(properties.StageName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebhookPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authentication", cdk.requiredValidator)(properties.authentication)), errors.collect(cdk.propertyValidator("authentication", cdk.validateString)(properties.authentication)), errors.collect(cdk.propertyValidator("authenticationConfiguration", cdk.requiredValidator)(properties.authenticationConfiguration)), errors.collect(cdk.propertyValidator("authenticationConfiguration", CfnWebhook_WebhookAuthConfigurationPropertyValidator)(properties.authenticationConfiguration)), errors.collect(cdk.propertyValidator("filters", cdk.requiredValidator)(properties.filters)), errors.collect(cdk.propertyValidator("filters", cdk.listValidator(CfnWebhook_WebhookFilterRulePropertyValidator))(properties.filters)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("registerWithThirdParty", cdk.validateBoolean)(properties.registerWithThirdParty)), errors.collect(cdk.propertyValidator("targetAction", cdk.requiredValidator)(properties.targetAction)), errors.collect(cdk.propertyValidator("targetAction", cdk.validateString)(properties.targetAction)), errors.collect(cdk.propertyValidator("targetPipeline", cdk.requiredValidator)(properties.targetPipeline)), errors.collect(cdk.propertyValidator("targetPipeline", cdk.validateString)(properties.targetPipeline)), errors.collect(cdk.propertyValidator("targetPipelineVersion", cdk.requiredValidator)(properties.targetPipelineVersion)), errors.collect(cdk.propertyValidator("targetPipelineVersion", cdk.validateNumber)(properties.targetPipelineVersion)), errors.wrap('supplied properties not correct for "CfnWebhookProps"');
    }
    function cfnWebhookPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebhookPropsValidator(properties).assertSuccess(), { Authentication: cdk.stringToCloudFormation(properties.authentication), AuthenticationConfiguration: cfnWebhookWebhookAuthConfigurationPropertyToCloudFormation(properties.authenticationConfiguration), Filters: cdk.listMapper(cfnWebhookWebhookFilterRulePropertyToCloudFormation)(properties.filters), TargetAction: cdk.stringToCloudFormation(properties.targetAction), TargetPipeline: cdk.stringToCloudFormation(properties.targetPipeline), TargetPipelineVersion: cdk.numberToCloudFormation(properties.targetPipelineVersion), Name: cdk.stringToCloudFormation(properties.name), RegisterWithThirdParty: cdk.booleanToCloudFormation(properties.registerWithThirdParty) }) : properties;
    }
    function CfnWebhookPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authentication", "Authentication", cfn_parse.FromCloudFormation.getString(properties.Authentication)), ret.addPropertyResult("authenticationConfiguration", "AuthenticationConfiguration", CfnWebhookWebhookAuthConfigurationPropertyFromCloudFormation(properties.AuthenticationConfiguration)), ret.addPropertyResult("filters", "Filters", cfn_parse.FromCloudFormation.getArray(CfnWebhookWebhookFilterRulePropertyFromCloudFormation)(properties.Filters)), ret.addPropertyResult("targetAction", "TargetAction", cfn_parse.FromCloudFormation.getString(properties.TargetAction)), ret.addPropertyResult("targetPipeline", "TargetPipeline", cfn_parse.FromCloudFormation.getString(properties.TargetPipeline)), ret.addPropertyResult("targetPipelineVersion", "TargetPipelineVersion", cfn_parse.FromCloudFormation.getNumber(properties.TargetPipelineVersion)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("registerWithThirdParty", "RegisterWithThirdParty", properties.RegisterWithThirdParty != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RegisterWithThirdParty) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnWebhook = class _CfnWebhook extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnWebhookPropsFromCloudFormation(resourceProperties), ret = new _CfnWebhook(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnWebhook.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_CfnWebhookProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnWebhook), error;
        }
        cdk.requireProperty(props, "authentication", this), cdk.requireProperty(props, "authenticationConfiguration", this), cdk.requireProperty(props, "filters", this), cdk.requireProperty(props, "targetAction", this), cdk.requireProperty(props, "targetPipeline", this), cdk.requireProperty(props, "targetPipelineVersion", this), this.attrUrl = cdk.Token.asString(this.getAtt("Url", cdk.ResolutionTypeHint.STRING)), this.authentication = props.authentication, this.authenticationConfiguration = props.authenticationConfiguration, this.filters = props.filters, this.targetAction = props.targetAction, this.targetPipeline = props.targetPipeline, this.targetPipelineVersion = props.targetPipelineVersion, this.name = props.name, this.registerWithThirdParty = props.registerWithThirdParty;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnWebhook.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { authentication: this.authentication, authenticationConfiguration: this.authenticationConfiguration, filters: this.filters, targetAction: this.targetAction, targetPipeline: this.targetPipeline, targetPipelineVersion: this.targetPipelineVersion, name: this.name, registerWithThirdParty: this.registerWithThirdParty };
      }
      renderProperties(props) {
        return cfnWebhookPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnWebhook[_c] = { fqn: "aws-cdk-lib.aws_codepipeline.CfnWebhook", version: "2.80.0" }, CfnWebhook.CFN_RESOURCE_TYPE_NAME = "AWS::CodePipeline::Webhook", exports2.CfnWebhook = CfnWebhook;
    function CfnWebhook_WebhookAuthConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowedIpRange", cdk.validateString)(properties.allowedIpRange)), errors.collect(cdk.propertyValidator("secretToken", cdk.validateString)(properties.secretToken)), errors.wrap('supplied properties not correct for "WebhookAuthConfigurationProperty"');
    }
    function cfnWebhookWebhookAuthConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebhook_WebhookAuthConfigurationPropertyValidator(properties).assertSuccess(), { AllowedIPRange: cdk.stringToCloudFormation(properties.allowedIpRange), SecretToken: cdk.stringToCloudFormation(properties.secretToken) }) : properties;
    }
    function CfnWebhookWebhookAuthConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowedIpRange", "AllowedIPRange", properties.AllowedIPRange != null ? cfn_parse.FromCloudFormation.getString(properties.AllowedIPRange) : void 0), ret.addPropertyResult("secretToken", "SecretToken", properties.SecretToken != null ? cfn_parse.FromCloudFormation.getString(properties.SecretToken) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebhook_WebhookFilterRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("jsonPath", cdk.requiredValidator)(properties.jsonPath)), errors.collect(cdk.propertyValidator("jsonPath", cdk.validateString)(properties.jsonPath)), errors.collect(cdk.propertyValidator("matchEquals", cdk.validateString)(properties.matchEquals)), errors.wrap('supplied properties not correct for "WebhookFilterRuleProperty"');
    }
    function cfnWebhookWebhookFilterRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebhook_WebhookFilterRulePropertyValidator(properties).assertSuccess(), { JsonPath: cdk.stringToCloudFormation(properties.jsonPath), MatchEquals: cdk.stringToCloudFormation(properties.matchEquals) }) : properties;
    }
    function CfnWebhookWebhookFilterRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("jsonPath", "JsonPath", cfn_parse.FromCloudFormation.getString(properties.JsonPath)), ret.addPropertyResult("matchEquals", "MatchEquals", properties.MatchEquals != null ? cfn_parse.FromCloudFormation.getString(properties.MatchEquals) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline/lib/private/cross-region-support-stack.js
var require_cross_region_support_stack = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline/lib/private/cross-region-support-stack.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CrossRegionSupportStack = exports2.CrossRegionSupportConstruct = void 0;
    var constructs_1 = require_lib2();
    var kms = require_aws_kms();
    var s3 = require_aws_s3();
    var cdk = require_core2();
    var REQUIRED_ALIAS_PREFIX = "alias/";
    var AliasWithShorterGeneratedName = class extends kms.Alias {
      generatePhysicalName() {
        let baseName = super.generatePhysicalName();
        baseName.startsWith(REQUIRED_ALIAS_PREFIX) && (baseName = baseName.substring(REQUIRED_ALIAS_PREFIX.length));
        const maxLength = 50 - REQUIRED_ALIAS_PREFIX.length;
        return REQUIRED_ALIAS_PREFIX + lastNCharacters(baseName, maxLength);
      }
    };
    function lastNCharacters(str, n) {
      const startIndex = Math.max(str.length - n, 0);
      return str.substring(startIndex);
    }
    var CrossRegionSupportConstruct = class extends constructs_1.Construct {
      constructor(scope, id, props = {}) {
        super(scope, id);
        const createKmsKey = props.createKmsKey ?? true;
        let encryptionAlias;
        if (createKmsKey) {
          const encryptionKey = new kms.Key(this, "CrossRegionCodePipelineReplicationBucketEncryptionKey", { removalPolicy: cdk.RemovalPolicy.DESTROY, enableKeyRotation: props.enableKeyRotation });
          encryptionAlias = new AliasWithShorterGeneratedName(this, "CrossRegionCodePipelineReplicationBucketEncryptionAlias", { targetKey: encryptionKey, aliasName: cdk.PhysicalName.GENERATE_IF_NEEDED, removalPolicy: cdk.RemovalPolicy.DESTROY });
        }
        this.replicationBucket = new s3.Bucket(this, "CrossRegionCodePipelineReplicationBucket", { bucketName: cdk.PhysicalName.GENERATE_IF_NEEDED, encryption: encryptionAlias ? s3.BucketEncryption.KMS : s3.BucketEncryption.KMS_MANAGED, encryptionKey: encryptionAlias, enforceSSL: true, blockPublicAccess: s3.BlockPublicAccess.BLOCK_ALL });
      }
    };
    exports2.CrossRegionSupportConstruct = CrossRegionSupportConstruct;
    var CrossRegionSupportStack = class extends cdk.Stack {
      constructor(scope, id, props) {
        super(scope, id, { stackName: generateStackName(props), env: { region: props.region, account: props.account }, synthesizer: props.synthesizer });
        const crossRegionSupportConstruct = new CrossRegionSupportConstruct(this, "Default", { createKmsKey: props.createKmsKey, enableKeyRotation: props.enableKeyRotation });
        this.replicationBucket = crossRegionSupportConstruct.replicationBucket;
      }
    };
    exports2.CrossRegionSupportStack = CrossRegionSupportStack;
    function generateStackName(props) {
      return `${props.pipelineStackName}-support-${props.region}`;
    }
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline/lib/private/full-action-descriptor.js
var require_full_action_descriptor = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline/lib/private/full-action-descriptor.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FullActionDescriptor = void 0;
    var FullActionDescriptor = class {
      constructor(props) {
        this.action = props.action;
        const actionProperties = props.action.actionProperties;
        this.actionName = actionProperties.actionName, this.category = actionProperties.category, this.owner = actionProperties.owner || "AWS", this.provider = actionProperties.provider, this.version = actionProperties.version || "1", this.runOrder = actionProperties.runOrder ?? 1, this.artifactBounds = actionProperties.artifactBounds, this.namespace = actionProperties.variablesNamespace, this.inputs = deduplicateArtifacts(actionProperties.inputs), this.outputs = deduplicateArtifacts(actionProperties.outputs), this.region = props.actionRegion || actionProperties.region, this.role = actionProperties.role ?? props.actionRole, this.configuration = props.actionConfig.configuration;
      }
    };
    exports2.FullActionDescriptor = FullActionDescriptor;
    function deduplicateArtifacts(artifacts) {
      const ret = new Array();
      for (const artifact of artifacts || []) {
        if (artifact.artifactName) {
          if (ret.find((a) => a.artifactName === artifact.artifactName))
            continue;
        } else if (ret.find((a) => a === artifact))
          continue;
        ret.push(artifact);
      }
      return ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline/lib/private/rich-action.js
var require_rich_action = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline/lib/private/rich-action.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.RichAction = void 0;
    var core_1 = require_core2();
    var RichAction = class {
      constructor(action, pipeline) {
        this.action = action, this.pipeline = pipeline, this.actionProperties = action.actionProperties;
      }
      bind(scope, stage, options) {
        return this.action.bind(scope, stage, options);
      }
      onStateChange(name, target, options) {
        return this.action.onStateChange(name, target, options);
      }
      get isCrossRegion() {
        return !actionDimensionSameAsPipelineDimension(this.effectiveRegion, this.pipeline.env.region);
      }
      get isCrossAccount() {
        return !actionDimensionSameAsPipelineDimension(this.effectiveAccount, this.pipeline.env.account);
      }
      get resourceStack() {
        const actionResource = this.actionProperties.resource;
        if (!actionResource)
          return;
        const actionResourceStack = core_1.Stack.of(actionResource), actionResourceStackEnv = { region: actionResourceStack.region, account: actionResourceStack.account };
        return sameEnv(actionResource.env, actionResourceStackEnv) ? actionResourceStack : void 0;
      }
      get effectiveRegion() {
        return this.action.actionProperties.resource?.env.region ?? this.action.actionProperties.region;
      }
      get effectiveAccount() {
        return this.action.actionProperties.role?.env.account ?? this.action.actionProperties?.resource?.env.account ?? this.action.actionProperties.account;
      }
    };
    exports2.RichAction = RichAction;
    function actionDimensionSameAsPipelineDimension(actionDim, pipelineDim) {
      return !actionDim || core_1.Token.isUnresolved(actionDim) ? true : core_1.Token.compareStrings(actionDim, pipelineDim) === core_1.TokenComparison.SAME;
    }
    function sameEnv(env1, env2) {
      return sameEnvDimension(env1.region, env2.region) && sameEnvDimension(env1.account, env2.account);
    }
    function sameEnvDimension(dim1, dim2) {
      return [core_1.TokenComparison.SAME, core_1.TokenComparison.BOTH_UNRESOLVED].includes(core_1.Token.compareStrings(dim1, dim2));
    }
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline/lib/private/stage.js
var require_stage3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline/lib/private/stage.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Stage = void 0;
    var constructs_1 = require_lib2();
    var validation = require_validation3();
    var events = require_aws_events();
    var cdk = require_core2();
    var core_1 = require_core2();
    var Stage = class {
      constructor(props, pipeline) {
        this._actions = new Array(), validation.validateName("Stage", props.stageName), this.stageName = props.stageName, this.transitionToEnabled = props.transitionToEnabled ?? true, this.transitionDisabledReason = props.transitionDisabledReason ?? "Transition disabled", this._pipeline = pipeline, this.scope = new constructs_1.Construct(pipeline, this.stageName);
        for (const action of props.actions || [])
          this.addAction(action);
      }
      get actionDescriptors() {
        return this._actions.slice();
      }
      get actions() {
        return this._actions.map((actionDescriptor) => actionDescriptor.action);
      }
      get pipeline() {
        return this._pipeline;
      }
      render() {
        for (const action of this._actions) {
          const outputArtifacts = action.outputs, unnamedOutputs = outputArtifacts.filter((o) => !o.artifactName);
          for (const outputArtifact of outputArtifacts)
            if (!outputArtifact.artifactName) {
              const unsanitizedArtifactName = `Artifact_${this.stageName}_${action.actionName}` + (unnamedOutputs.length === 1 ? "" : "_" + (unnamedOutputs.indexOf(outputArtifact) + 1)), artifactName = sanitizeArtifactName(unsanitizedArtifactName);
              outputArtifact._setName(artifactName);
            }
        }
        return { name: this.stageName, actions: this._actions.map((action) => this.renderAction(action)) };
      }
      addAction(action) {
        const actionName = action.actionProperties.actionName;
        if (validation.validateName("Action", actionName), this._actions.find((a) => a.actionName === actionName))
          throw new Error(`Stage ${this.stageName} already contains an action with name '${actionName}'`);
        this._actions.push(this.attachActionToPipeline(action));
      }
      onStateChange(name, target, options) {
        const rule = new events.Rule(this.scope, name, options);
        return rule.addTarget(target), rule.addEventPattern({ detailType: ["CodePipeline Stage Execution State Change"], source: ["aws.codepipeline"], resources: [this.pipeline.pipelineArn], detail: { stage: [this.stageName] } }), rule;
      }
      validate() {
        return [...this.validateHasActions(), ...this.validateActions()];
      }
      validateHasActions() {
        return this._actions.length === 0 ? [`Stage '${this.stageName}' must have at least one action`] : [];
      }
      validateActions() {
        const ret = new Array();
        for (const action of this.actionDescriptors)
          ret.push(...this.validateAction(action));
        return ret;
      }
      validateAction(action) {
        return validation.validateArtifactBounds("input", action.inputs, action.artifactBounds.minInputs, action.artifactBounds.maxInputs, action.category, action.provider).concat(validation.validateArtifactBounds("output", action.outputs, action.artifactBounds.minOutputs, action.artifactBounds.maxOutputs, action.category, action.provider));
      }
      attachActionToPipeline(action) {
        let actionScope = constructs_1.Node.of(this.scope).tryFindChild(action.actionProperties.actionName);
        if (!actionScope) {
          let id = action.actionProperties.actionName;
          core_1.Token.isUnresolved(id) && (id = findUniqueConstructId(this.scope, action.actionProperties.provider)), actionScope = new constructs_1.Construct(this.scope, id);
        }
        return this._pipeline._attachActionToPipeline(this, action, actionScope);
      }
      renderAction(action) {
        const outputArtifacts = cdk.Lazy.any({ produce: () => this.renderArtifacts(action.outputs) }, { omitEmptyArray: true }), inputArtifacts = cdk.Lazy.any({ produce: () => this.renderArtifacts(action.inputs) }, { omitEmptyArray: true });
        return { name: action.actionName, inputArtifacts, outputArtifacts, actionTypeId: { category: action.category.toString(), version: action.version, owner: action.owner, provider: action.provider }, configuration: action.configuration, runOrder: action.runOrder, roleArn: action.role ? action.role.roleArn : void 0, region: action.region, namespace: action.namespace };
      }
      renderArtifacts(artifacts) {
        return artifacts.filter((a) => a.artifactName).map((a) => ({ name: a.artifactName }));
      }
    };
    exports2.Stage = Stage;
    function sanitizeArtifactName(artifactName) {
      return artifactName.replace(/[@.]/g, "");
    }
    function findUniqueConstructId(scope, prefix) {
      let current = prefix, ctr = 1;
      for (; constructs_1.Node.of(scope).tryFindChild(current) !== void 0; )
        current = `${prefix}${++ctr}`;
      return current;
    }
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline/lib/pipeline.js
var require_pipeline = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline/lib/pipeline.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Pipeline = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var action_1 = require_action();
    var codepipeline_generated_1 = require_codepipeline_generated();
    var cross_region_support_stack_1 = require_cross_region_support_stack();
    var full_action_descriptor_1 = require_full_action_descriptor();
    var rich_action_1 = require_rich_action();
    var stage_1 = require_stage3();
    var validation_1 = require_validation3();
    var notifications = require_aws_codestarnotifications();
    var events = require_aws_events();
    var iam = require_aws_iam();
    var kms = require_aws_kms();
    var s3 = require_aws_s3();
    var core_1 = require_core2();
    var cxapi = require_cx_api();
    var PipelineBase = class extends core_1.Resource {
      onEvent(id, options = {}) {
        const rule = new events.Rule(this, id, options);
        return rule.addTarget(options.target), rule.addEventPattern({ source: ["aws.codepipeline"], resources: [this.pipelineArn] }), rule;
      }
      onStateChange(id, options = {}) {
        const rule = this.onEvent(id, options);
        return rule.addEventPattern({ detailType: ["CodePipeline Pipeline Execution State Change"] }), rule;
      }
      bindAsNotificationRuleSource(_scope) {
        return { sourceArn: this.pipelineArn };
      }
      notifyOn(id, target, options) {
        return new notifications.NotificationRule(this, id, { ...options, source: this, targets: [target] });
      }
      notifyOnExecutionStateChange(id, target, options) {
        return this.notifyOn(id, target, { ...options, events: [action_1.PipelineNotificationEvents.PIPELINE_EXECUTION_FAILED, action_1.PipelineNotificationEvents.PIPELINE_EXECUTION_CANCELED, action_1.PipelineNotificationEvents.PIPELINE_EXECUTION_STARTED, action_1.PipelineNotificationEvents.PIPELINE_EXECUTION_RESUMED, action_1.PipelineNotificationEvents.PIPELINE_EXECUTION_SUCCEEDED, action_1.PipelineNotificationEvents.PIPELINE_EXECUTION_SUPERSEDED] });
      }
      notifyOnAnyStageStateChange(id, target, options) {
        return this.notifyOn(id, target, { ...options, events: [action_1.PipelineNotificationEvents.STAGE_EXECUTION_CANCELED, action_1.PipelineNotificationEvents.STAGE_EXECUTION_FAILED, action_1.PipelineNotificationEvents.STAGE_EXECUTION_RESUMED, action_1.PipelineNotificationEvents.STAGE_EXECUTION_STARTED, action_1.PipelineNotificationEvents.STAGE_EXECUTION_SUCCEEDED] });
      }
      notifyOnAnyActionStateChange(id, target, options) {
        return this.notifyOn(id, target, { ...options, events: [action_1.PipelineNotificationEvents.ACTION_EXECUTION_CANCELED, action_1.PipelineNotificationEvents.ACTION_EXECUTION_FAILED, action_1.PipelineNotificationEvents.ACTION_EXECUTION_STARTED, action_1.PipelineNotificationEvents.ACTION_EXECUTION_SUCCEEDED] });
      }
      notifyOnAnyManualApprovalStateChange(id, target, options) {
        return this.notifyOn(id, target, { ...options, events: [action_1.PipelineNotificationEvents.MANUAL_APPROVAL_FAILED, action_1.PipelineNotificationEvents.MANUAL_APPROVAL_NEEDED, action_1.PipelineNotificationEvents.MANUAL_APPROVAL_SUCCEEDED] });
      }
    };
    var Pipeline = class _Pipeline extends PipelineBase {
      static fromPipelineArn(scope, id, pipelineArn) {
        class Import extends PipelineBase {
          constructor() {
            super(...arguments), this.pipelineName = core_1.Stack.of(scope).splitArn(pipelineArn, core_1.ArnFormat.SLASH_RESOURCE_NAME).resource, this.pipelineArn = pipelineArn;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.pipelineName }), this._stages = new Array(), this._crossRegionSupport = {}, this._crossAccountSupport = {};
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_PipelineProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Pipeline), error;
        }
        if ((0, validation_1.validateName)("Pipeline", this.physicalName), props.artifactBucket && props.crossRegionReplicationBuckets)
          throw new Error("Only one of artifactBucket and crossRegionReplicationBuckets can be specified!");
        if (this.crossAccountKeys = props.crossAccountKeys ?? true, this.enableKeyRotation = props.enableKeyRotation, this.enableKeyRotation && !this.crossAccountKeys)
          throw new Error("Setting 'enableKeyRotation' to true also requires 'crossAccountKeys' to be enabled");
        this.reuseCrossRegionSupportStacks = props.reuseCrossRegionSupportStacks ?? true;
        let propsBucket = this.getArtifactBucketFromProps(props);
        if (!propsBucket) {
          let encryptionKey;
          this.crossAccountKeys && (encryptionKey = new kms.Key(this, "ArtifactsBucketEncryptionKey", { removalPolicy: core_1.RemovalPolicy.DESTROY, enableKeyRotation: this.enableKeyRotation }), new kms.Alias(this, "ArtifactsBucketEncryptionKeyAlias", { aliasName: this.generateNameForDefaultBucketKeyAlias(), targetKey: encryptionKey, removalPolicy: core_1.RemovalPolicy.DESTROY })), propsBucket = new s3.Bucket(this, "ArtifactsBucket", { bucketName: core_1.PhysicalName.GENERATE_IF_NEEDED, encryptionKey, encryption: encryptionKey ? s3.BucketEncryption.KMS : s3.BucketEncryption.KMS_MANAGED, enforceSSL: true, blockPublicAccess: new s3.BlockPublicAccess(s3.BlockPublicAccess.BLOCK_ALL), removalPolicy: core_1.RemovalPolicy.RETAIN });
        }
        this.artifactBucket = propsBucket, this.role = props.role || new iam.Role(this, "Role", { assumedBy: new iam.ServicePrincipal("codepipeline.amazonaws.com") }), this.codePipeline = new codepipeline_generated_1.CfnPipeline(this, "Resource", { artifactStore: core_1.Lazy.any({ produce: () => this.renderArtifactStoreProperty() }), artifactStores: core_1.Lazy.any({ produce: () => this.renderArtifactStoresProperty() }), stages: core_1.Lazy.any({ produce: () => this.renderStages() }), disableInboundStageTransitions: core_1.Lazy.any({ produce: () => this.renderDisabledTransitions() }, { omitEmptyArray: true }), roleArn: this.role.roleArn, restartExecutionOnUpdate: props && props.restartExecutionOnUpdate, name: this.physicalName }), this.codePipeline.node.addDependency(this.role), this.artifactBucket.grantReadWrite(this.role), this.pipelineName = this.getResourceNameAttribute(this.codePipeline.ref), this.pipelineVersion = this.codePipeline.attrVersion, this.crossRegionBucketsPassed = !!props.crossRegionReplicationBuckets;
        for (const [region, replicationBucket] of Object.entries(props.crossRegionReplicationBuckets || {}))
          this._crossRegionSupport[region] = { replicationBucket, stack: core_1.Stack.of(replicationBucket) };
        this.pipelineArn = core_1.Stack.of(this).formatArn({ service: "codepipeline", resource: this.pipelineName });
        for (const stage of props.stages || [])
          this.addStage(stage);
        this.node.addValidation({ validate: () => this.validatePipeline() });
      }
      addStage(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_StageOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addStage), error;
        }
        if (this._stages.find((s) => s.stageName === props.stageName))
          throw new Error(`Stage with duplicate name '${props.stageName}' added to the Pipeline`);
        const stage = new stage_1.Stage(props, this), index = props.placement ? this.calculateInsertIndexFromPlacement(props.placement) : this.stageCount;
        return this._stages.splice(index, 0, stage), stage;
      }
      addToRolePolicy(statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToRolePolicy), error;
        }
        this.role.addToPrincipalPolicy(statement);
      }
      get stageCount() {
        return this._stages.length;
      }
      get stages() {
        return this._stages.slice();
      }
      stage(stageName) {
        for (const stage of this._stages)
          if (stage.stageName === stageName)
            return stage;
        throw new Error(`Pipeline does not contain a stage named '${stageName}'. Available stages: ${this._stages.map((s) => s.stageName).join(", ")}`);
      }
      get crossRegionSupport() {
        const ret = {};
        return Object.keys(this._crossRegionSupport).forEach((key) => {
          ret[key] = this._crossRegionSupport[key];
        }), ret;
      }
      _attachActionToPipeline(stage, action, actionScope) {
        const richAction = new rich_action_1.RichAction(action, this), crossRegionInfo = this.ensureReplicationResourcesExistFor(richAction), actionRole = this.getRoleForAction(stage, richAction, actionScope);
        (0, validation_1.validateNamespaceName)(richAction.actionProperties.variablesNamespace);
        const actionConfig = richAction.bind(actionScope, stage, { role: actionRole || this.role, bucket: crossRegionInfo.artifactBucket });
        return new full_action_descriptor_1.FullActionDescriptor({ action, actionConfig, actionRole, actionRegion: crossRegionInfo.region });
      }
      validatePipeline() {
        return [...this.validateSourceActionLocations(), ...this.validateHasStages(), ...this.validateStages(), ...this.validateArtifacts()];
      }
      ensureReplicationResourcesExistFor(action) {
        if (!action.isCrossRegion)
          return { artifactBucket: this.artifactBucket };
        if (this.requireRegion(), action.actionProperties.category === action_1.ActionCategory.SOURCE)
          throw new Error(`Source action '${action.actionProperties.actionName}' must be in the same region as the pipeline`);
        const crossRegionSupport = this.obtainCrossRegionSupportFor(action);
        return core_1.Stack.of(this).addDependency(crossRegionSupport.stack), crossRegionSupport.replicationBucket.grantReadWrite(this.role), { artifactBucket: crossRegionSupport.replicationBucket, region: action.effectiveRegion };
      }
      obtainCrossRegionSupportFor(action) {
        const actionRegion = action.effectiveRegion;
        let crossRegionSupport = this._crossRegionSupport[actionRegion];
        if (!crossRegionSupport) {
          const otherStack = action.resourceStack;
          crossRegionSupport = this.createSupportResourcesForRegion(otherStack, actionRegion), this._crossRegionSupport[actionRegion] = crossRegionSupport;
        }
        return crossRegionSupport;
      }
      createSupportResourcesForRegion(otherStack, actionRegion) {
        if (otherStack) {
          const id = `CrossRegionReplicationSupport-d823f1d8-a990-4e5c-be18-4ac698532e65-${actionRegion}`;
          let crossRegionSupportConstruct = otherStack.node.tryFindChild(id);
          return crossRegionSupportConstruct || (crossRegionSupportConstruct = new cross_region_support_stack_1.CrossRegionSupportConstruct(otherStack, id, { createKmsKey: this.crossAccountKeys, enableKeyRotation: this.enableKeyRotation })), { replicationBucket: crossRegionSupportConstruct.replicationBucket, stack: otherStack };
        }
        const pipelineStack = core_1.Stack.of(this), pipelineAccount = pipelineStack.account;
        if (core_1.Token.isUnresolved(pipelineAccount))
          throw new Error("You need to specify an explicit account when using CodePipeline's cross-region support");
        const app = this.supportScope(), supportStackId = `cross-region-stack-${this.reuseCrossRegionSupportStacks ? pipelineAccount : pipelineStack.stackName}:${actionRegion}`;
        let supportStack = app.node.tryFindChild(supportStackId);
        return supportStack || (supportStack = new cross_region_support_stack_1.CrossRegionSupportStack(app, supportStackId, { pipelineStackName: pipelineStack.stackName, region: actionRegion, account: pipelineAccount, synthesizer: this.getCrossRegionSupportSynthesizer(), createKmsKey: this.crossAccountKeys, enableKeyRotation: this.enableKeyRotation })), { stack: supportStack, replicationBucket: supportStack.replicationBucket };
      }
      getCrossRegionSupportSynthesizer() {
        if (this.stack.synthesizer instanceof core_1.DefaultStackSynthesizer)
          return new core_1.BootstraplessSynthesizer({ deployRoleArn: this.stack.synthesizer.deployRoleArn, cloudFormationExecutionRoleArn: this.stack.synthesizer.cloudFormationExecutionRoleArn });
      }
      generateNameForDefaultBucketKeyAlias() {
        const prefix = "alias/codepipeline-", maxResourceNameLength = 256 - prefix.length, uniqueId = core_1.FeatureFlags.of(this).isEnabled(cxapi.CODEPIPELINE_CROSS_ACCOUNT_KEY_ALIAS_STACK_SAFE_RESOURCE_NAME) ? core_1.Names.uniqueResourceName(this, { separator: "-", maxLength: maxResourceNameLength, allowedSpecialCharacters: "/_-" }) : core_1.Names.uniqueId(this).slice(-maxResourceNameLength);
        return prefix + uniqueId.toLowerCase();
      }
      getRoleForAction(stage, action, actionScope) {
        const pipelineStack = core_1.Stack.of(this);
        let actionRole = this.getRoleFromActionPropsOrGenerateIfCrossAccount(stage, action);
        return !actionRole && this.isAwsOwned(action) && (actionRole = new iam.Role(actionScope, "CodePipelineActionRole", { assumedBy: new iam.AccountPrincipal(pipelineStack.account) })), actionRole?.grantAssumeRole(this.role)?.applyBefore(this.codePipeline), actionRole;
      }
      getRoleFromActionPropsOrGenerateIfCrossAccount(stage, action) {
        const pipelineStack = core_1.Stack.of(this);
        if (action.isCrossAccount && !this.ensureReplicationResourcesExistFor(action).artifactBucket.encryptionKey)
          throw new Error(`Artifact Bucket must have a KMS Key to add cross-account action '${action.actionProperties.actionName}' (pipeline account: '${renderEnvDimension(this.env.account)}', action account: '${renderEnvDimension(action.effectiveAccount)}'). Create Pipeline with 'crossAccountKeys: true' (or pass an existing Bucket with a key)`);
        if (action.actionProperties.role)
          if (this.isAwsOwned(action)) {
            if (iam.Role.isRole(action.actionProperties.role)) {
              const roleStack = core_1.Stack.of(action.actionProperties.role);
              pipelineStack.addDependency(roleStack);
            }
            return action.actionProperties.role;
          } else
            throw new Error(`Specifying a Role is not supported for actions with an owner different than 'AWS' - got '${action.actionProperties.owner}' (Action: '${action.actionProperties.actionName}' in Stage: '${stage.stageName}')`);
        const otherAccountStack = this.getOtherStackIfActionIsCrossAccount(action);
        if (!otherAccountStack)
          return;
        const ret = new iam.Role(otherAccountStack, `${core_1.Names.uniqueId(this)}-${stage.stageName}-${action.actionProperties.actionName}-ActionRole`, { assumedBy: new iam.AccountPrincipal(pipelineStack.account), roleName: core_1.PhysicalName.GENERATE_IF_NEEDED });
        return pipelineStack.addDependency(otherAccountStack), ret;
      }
      getOtherStackIfActionIsCrossAccount(action) {
        const targetAccount = action.actionProperties.resource ? action.actionProperties.resource.env.account : action.actionProperties.account;
        if (targetAccount === void 0)
          return;
        if (core_1.Token.isUnresolved(targetAccount)) {
          if (core_1.Token.isUnresolved(this.env.account))
            return;
          throw new Error(`The 'account' property must be a concrete value (action: '${action.actionProperties.actionName}')`);
        }
        if (core_1.Token.isUnresolved(this.env.account))
          throw new Error("Pipeline stack which uses cross-environment actions must have an explicitly set account");
        if (this.env.account === targetAccount)
          return;
        const candidateActionResourceStack = action.actionProperties.resource ? core_1.Stack.of(action.actionProperties.resource) : void 0;
        if (candidateActionResourceStack?.account === targetAccount)
          return this._crossAccountSupport[targetAccount] = candidateActionResourceStack, candidateActionResourceStack;
        let targetAccountStack = this._crossAccountSupport[targetAccount];
        if (!targetAccountStack) {
          const stackId = `cross-account-support-stack-${targetAccount}`, app = this.supportScope();
          if (targetAccountStack = app.node.tryFindChild(stackId), !targetAccountStack) {
            const actionRegion = action.actionProperties.resource ? action.actionProperties.resource.env.region : action.actionProperties.region, pipelineStack = core_1.Stack.of(this);
            targetAccountStack = new core_1.Stack(app, stackId, { stackName: `${pipelineStack.stackName}-support-${targetAccount}`, env: { account: targetAccount, region: actionRegion ?? pipelineStack.region } });
          }
          this._crossAccountSupport[targetAccount] = targetAccountStack;
        }
        return targetAccountStack;
      }
      isAwsOwned(action) {
        const owner = action.actionProperties.owner;
        return !owner || owner === "AWS";
      }
      getArtifactBucketFromProps(props) {
        if (props.artifactBucket)
          return props.artifactBucket;
        if (props.crossRegionReplicationBuckets) {
          const pipelineRegion = this.requireRegion();
          return props.crossRegionReplicationBuckets[pipelineRegion];
        }
      }
      calculateInsertIndexFromPlacement(placement) {
        const providedPlacementProps = ["rightBefore", "justAfter", "atIndex"].filter((prop) => placement[prop] !== void 0);
        if (providedPlacementProps.length > 1)
          throw new Error(`Error adding Stage to the Pipeline: you can only provide at most one placement property, but '${providedPlacementProps.join(", ")}' were given`);
        if (placement.rightBefore !== void 0) {
          const targetIndex = this.findStageIndex(placement.rightBefore);
          if (targetIndex === -1)
            throw new Error(`Error adding Stage to the Pipeline: the requested Stage to add it before, '${placement.rightBefore.stageName}', was not found`);
          return targetIndex;
        }
        if (placement.justAfter !== void 0) {
          const targetIndex = this.findStageIndex(placement.justAfter);
          if (targetIndex === -1)
            throw new Error(`Error adding Stage to the Pipeline: the requested Stage to add it after, '${placement.justAfter.stageName}', was not found`);
          return targetIndex + 1;
        }
        return this.stageCount;
      }
      findStageIndex(targetStage) {
        return this._stages.findIndex((stage) => stage === targetStage);
      }
      validateSourceActionLocations() {
        const errors = new Array();
        let firstStage = true;
        for (const stage of this._stages) {
          const onlySourceActionsPermitted = firstStage;
          for (const action of stage.actionDescriptors)
            errors.push(...(0, validation_1.validateSourceAction)(onlySourceActionsPermitted, action.category, action.actionName, stage.stageName));
          firstStage = false;
        }
        return errors;
      }
      validateHasStages() {
        return this.stageCount < 2 ? ["Pipeline must have at least two stages"] : [];
      }
      validateStages() {
        const ret = new Array();
        for (const stage of this._stages)
          ret.push(...stage.validate());
        return ret;
      }
      validateArtifacts() {
        const ret = new Array(), producers = {}, firstConsumers = {};
        for (const [stageIndex, stage] of enumerate(this._stages))
          for (const action of stage.actionDescriptors) {
            const actionLoc = new PipelineLocation(stageIndex, stage, action);
            for (const outputArtifact of action.outputs) {
              const name = outputArtifact.artifactName;
              if (producers[name]) {
                ret.push(`Both Actions '${producers[name].actionName}' and '${action.actionName}' are producting Artifact '${name}'. Every artifact can only be produced once.`);
                continue;
              }
              producers[name] = actionLoc;
            }
            for (const inputArtifact of action.inputs) {
              const name = inputArtifact.artifactName;
              if (!name) {
                ret.push(`Action '${action.actionName}' is using an unnamed input Artifact, which is not being produced in this pipeline`);
                continue;
              }
              firstConsumers[name] = firstConsumers[name] ? firstConsumers[name].first(actionLoc) : actionLoc;
            }
          }
        for (const [artifactName, consumerLoc] of Object.entries(firstConsumers)) {
          const producerLoc = producers[artifactName];
          if (!producerLoc) {
            ret.push(`Action '${consumerLoc.actionName}' is using input Artifact '${artifactName}', which is not being produced in this pipeline`);
            continue;
          }
          consumerLoc.beforeOrEqual(producerLoc) && ret.push(`${consumerLoc} is consuming input Artifact '${artifactName}' before it is being produced at ${producerLoc}`);
        }
        return ret;
      }
      renderArtifactStoresProperty() {
        if (!this.crossRegion)
          return;
        const primaryRegion = this.requireRegion();
        return this._crossRegionSupport[primaryRegion] = { replicationBucket: this.artifactBucket, stack: core_1.Stack.of(this) }, Object.entries(this._crossRegionSupport).map(([region, support]) => ({ region, artifactStore: this.renderArtifactStore(support.replicationBucket) }));
      }
      renderArtifactStoreProperty() {
        if (!this.crossRegion)
          return this.renderPrimaryArtifactStore();
      }
      renderPrimaryArtifactStore() {
        return this.renderArtifactStore(this.artifactBucket);
      }
      renderArtifactStore(bucket) {
        let encryptionKey;
        const bucketKey = bucket.encryptionKey;
        return bucketKey && (encryptionKey = { type: "KMS", id: bucketKey.keyArn }), { type: "S3", location: bucket.bucketName, encryptionKey };
      }
      get crossRegion() {
        return this.crossRegionBucketsPassed ? true : this._stages.some((stage) => stage.actionDescriptors.some((action) => action.region !== void 0));
      }
      renderStages() {
        return this._stages.map((stage) => stage.render());
      }
      renderDisabledTransitions() {
        return this._stages.filter((stage) => !stage.transitionToEnabled).map((stage) => ({ reason: stage.transitionDisabledReason, stageName: stage.stageName }));
      }
      requireRegion() {
        const region = this.env.region;
        if (core_1.Token.isUnresolved(region))
          throw new Error("Pipeline stack which uses cross-environment actions must have an explicitly set region");
        return region;
      }
      supportScope() {
        const scope = core_1.Stage.of(this);
        if (!scope)
          throw new Error("Pipeline stack which uses cross-environment actions must be part of a CDK App or Stage");
        return scope;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Pipeline[_a] = { fqn: "aws-cdk-lib.aws_codepipeline.Pipeline", version: "2.80.0" }, exports2.Pipeline = Pipeline;
    function enumerate(xs) {
      const ret = new Array();
      for (let i = 0; i < xs.length; i++)
        ret.push([i, xs[i]]);
      return ret;
    }
    var PipelineLocation = class {
      constructor(stageIndex, stage, action) {
        this.stageIndex = stageIndex, this.stage = stage, this.action = action;
      }
      get stageName() {
        return this.stage.stageName;
      }
      get actionName() {
        return this.action.actionName;
      }
      beforeOrEqual(rhs) {
        return this.stageIndex !== rhs.stageIndex ? rhs.stageIndex < rhs.stageIndex : this.action.runOrder <= rhs.action.runOrder;
      }
      first(rhs) {
        return this.beforeOrEqual(rhs) ? this : rhs;
      }
      toString() {
        return `Stage ${this.stageIndex + 1} Action ${this.action.runOrder} ('${this.stageName}'/'${this.actionName}')`;
      }
    };
    function renderEnvDimension(s) {
      return core_1.Token.isUnresolved(s) ? "(current)" : s;
    }
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline/lib/custom-action-registration.js
var require_custom_action_registration = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline/lib/custom-action-registration.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CustomActionRegistration = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var codepipeline_generated_1 = require_codepipeline_generated();
    var CustomActionRegistration = class _CustomActionRegistration extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_CustomActionRegistrationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CustomActionRegistration), error;
        }
        new codepipeline_generated_1.CfnCustomActionType(this, "Resource", { category: props.category, inputArtifactDetails: { minimumCount: props.artifactBounds.minInputs, maximumCount: props.artifactBounds.maxInputs }, outputArtifactDetails: { minimumCount: props.artifactBounds.minOutputs, maximumCount: props.artifactBounds.maxOutputs }, provider: props.provider, version: props.version || "1", settings: { entityUrlTemplate: props.entityUrl, executionUrlTemplate: props.executionUrl }, configurationProperties: props.actionProperties?.map((ap) => ({ key: ap.key || false, secret: ap.secret || false, ...ap })) });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CustomActionRegistration[_a] = { fqn: "aws-cdk-lib.aws_codepipeline.CustomActionRegistration", version: "2.80.0" }, exports2.CustomActionRegistration = CustomActionRegistration;
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline/lib/index.js
var require_lib83 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_action(), exports2), __exportStar(require_artifact(), exports2), __exportStar(require_pipeline(), exports2), __exportStar(require_custom_action_registration(), exports2), __exportStar(require_codepipeline_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline/index.js
var require_aws_codepipeline = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib83(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/action.js
var require_action2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/action.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Action = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var codepipeline = require_aws_codepipeline();
    var Action = class _Action extends codepipeline.Action {
      constructor(actionProperties) {
        super();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_ActionProperties(actionProperties);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Action), error;
        }
        this.providedActionProperties = actionProperties;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Action[_a] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.Action", version: "2.80.0" }, exports2.Action = Action;
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/alexa-ask/deploy-action.js
var require_deploy_action = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/alexa-ask/deploy-action.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AlexaSkillDeployAction = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var codepipeline = require_aws_codepipeline();
    var action_1 = require_action2();
    var AlexaSkillDeployAction = class _AlexaSkillDeployAction extends action_1.Action {
      constructor(props) {
        super({ ...props, category: codepipeline.ActionCategory.DEPLOY, owner: "ThirdParty", provider: "AlexaSkillsKit", artifactBounds: { minInputs: 1, maxInputs: 2, minOutputs: 0, maxOutputs: 0 }, inputs: getInputs(props) });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_actions_AlexaSkillDeployActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AlexaSkillDeployAction), error;
        }
        this.props = props;
      }
      bound(_scope, _stage, _options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_IStage(_stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_ActionBindOptions(_options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bound), error;
        }
        return { configuration: { ClientId: this.props.clientId, ClientSecret: this.props.clientSecret.unsafeUnwrap(), RefreshToken: this.props.refreshToken.unsafeUnwrap(), SkillId: this.props.skillId } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AlexaSkillDeployAction[_a] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.AlexaSkillDeployAction", version: "2.80.0" }, exports2.AlexaSkillDeployAction = AlexaSkillDeployAction;
    function getInputs(props) {
      const ret = [props.input];
      return props.parameterOverridesArtifact && ret.push(props.parameterOverridesArtifact), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/common.js
var require_common4 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/common.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.validatePercentage = exports2.deployArtifactBounds = exports2.sourceArtifactBounds = void 0;
    var core_1 = require_core2();
    function sourceArtifactBounds() {
      return { minInputs: 0, maxInputs: 0, minOutputs: 1, maxOutputs: 1 };
    }
    exports2.sourceArtifactBounds = sourceArtifactBounds;
    function deployArtifactBounds() {
      return { minInputs: 1, maxInputs: 1, minOutputs: 0, maxOutputs: 0 };
    }
    exports2.deployArtifactBounds = deployArtifactBounds;
    function validatePercentage(name, value) {
      if (!(value === void 0 || core_1.Token.isUnresolved(value)) && (value < 0 || value > 100 || !Number.isInteger(value)))
        throw new Error(`'${name}': must be a whole number between 0 and 100, got: ${value}`);
    }
    exports2.validatePercentage = validatePercentage;
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/codestar-connections/source-action.js
var require_source_action = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/codestar-connections/source-action.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CodeStarConnectionsSourceAction = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var codepipeline = require_aws_codepipeline();
    var iam = require_aws_iam();
    var action_1 = require_action2();
    var common_1 = require_common4();
    var CodeStarConnectionsSourceAction = class _CodeStarConnectionsSourceAction extends action_1.Action {
      constructor(props) {
        super({ ...props, category: codepipeline.ActionCategory.SOURCE, owner: "AWS", provider: "CodeStarSourceConnection", artifactBounds: (0, common_1.sourceArtifactBounds)(), outputs: [props.output] });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_actions_CodeStarConnectionsSourceActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CodeStarConnectionsSourceAction), error;
        }
        this.props = props;
      }
      get variables() {
        return { fullRepositoryName: this.variableExpression("FullRepositoryName"), branchName: this.variableExpression("BranchName"), authorDate: this.variableExpression("AuthorDate"), commitId: this.variableExpression("CommitId"), commitMessage: this.variableExpression("CommitMessage"), connectionArn: this.variableExpression("ConnectionArn") };
      }
      bound(_scope, _stage, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_IStage(_stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_ActionBindOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bound), error;
        }
        return options.role.addToPolicy(new iam.PolicyStatement({ actions: ["codestar-connections:UseConnection"], resources: [this.props.connectionArn] })), options.bucket.grantReadWrite(options.role), options.bucket.grantPutAcl(options.role), this.props.codeBuildCloneOutput === true && this.props.output.setMetadata(_CodeStarConnectionsSourceAction._CONNECTION_ARN_PROPERTY, this.props.connectionArn), { configuration: { ConnectionArn: this.props.connectionArn, FullRepositoryId: `${this.props.owner}/${this.props.repo}`, BranchName: this.props.branch ?? "master", OutputArtifactFormat: this.props.codeBuildCloneOutput === true ? "CODEBUILD_CLONE_REF" : void 0, DetectChanges: this.props.triggerOnPush } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CodeStarConnectionsSourceAction[_a] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.CodeStarConnectionsSourceAction", version: "2.80.0" }, CodeStarConnectionsSourceAction._CONNECTION_ARN_PROPERTY = "CodeStarConnectionArnProperty", exports2.CodeStarConnectionsSourceAction = CodeStarConnectionsSourceAction;
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/bitbucket/source-action.js
var require_source_action2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/bitbucket/source-action.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.BitBucketSourceAction = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var source_action_1 = require_source_action();
    var BitBucketSourceAction = class {
      constructor(props) {
        this.codeStarConnectionsSourceAction = new source_action_1.CodeStarConnectionsSourceAction(props);
      }
      get actionProperties() {
        return this.codeStarConnectionsSourceAction.actionProperties;
      }
      bind(scope, stage, options) {
        return this.codeStarConnectionsSourceAction.bind(scope, stage, options);
      }
      onStateChange(name, target, options) {
        return this.codeStarConnectionsSourceAction.onStateChange(name, target, options);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, BitBucketSourceAction[_a] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.BitBucketSourceAction", version: "2.80.0" }, exports2.BitBucketSourceAction = BitBucketSourceAction;
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/cloudformation/private/singleton-policy.js
var require_singleton_policy = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/cloudformation/private/singleton-policy.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.parseCapabilities = exports2.SingletonPolicy = void 0;
    var constructs_1 = require_lib2();
    var iam = require_aws_iam();
    var cdk = require_core2();
    var SingletonPolicy = class _SingletonPolicy extends constructs_1.Construct {
      static forRole(role) {
        return role.node.tryFindChild(_SingletonPolicy.UUID) || new _SingletonPolicy(role);
      }
      constructor(role) {
        super(role, _SingletonPolicy.UUID), this.role = role, this.statements = {}, this.grantPrincipal = role;
      }
      grantExecuteChangeSet(props) {
        this.statementFor({ actions: ["cloudformation:DescribeStacks", "cloudformation:DescribeChangeSet", "cloudformation:ExecuteChangeSet"], conditions: { StringEqualsIfExists: { "cloudformation:ChangeSetName": props.changeSetName } } }).addResources(this.stackArnFromProps(props));
      }
      grantCreateReplaceChangeSet(props) {
        this.statementFor({ actions: ["cloudformation:CreateChangeSet", "cloudformation:DeleteChangeSet", "cloudformation:DescribeChangeSet", "cloudformation:DescribeStacks"], conditions: { StringEqualsIfExists: { "cloudformation:ChangeSetName": props.changeSetName } } }).addResources(this.stackArnFromProps(props));
      }
      grantCreateUpdateStack(props) {
        const actions = ["cloudformation:DescribeStack*", "cloudformation:CreateStack", "cloudformation:UpdateStack", "cloudformation:GetTemplate*", "cloudformation:ValidateTemplate", "cloudformation:GetStackPolicy", "cloudformation:SetStackPolicy"];
        props.replaceOnFailure && actions.push("cloudformation:DeleteStack"), this.statementFor({ actions }).addResources(this.stackArnFromProps(props));
      }
      grantCreateUpdateStackSet(props) {
        const actions = ["cloudformation:CreateStackSet", "cloudformation:UpdateStackSet", "cloudformation:DescribeStackSet", "cloudformation:DescribeStackSetOperation", "cloudformation:ListStackInstances", "cloudformation:CreateStackInstances"];
        this.statementFor({ actions }).addResources(this.stackSetArnFromProps(props));
      }
      grantDeleteStack(props) {
        this.statementFor({ actions: ["cloudformation:DescribeStack*", "cloudformation:DeleteStack"] }).addResources(this.stackArnFromProps(props));
      }
      grantPassRole(role) {
        this.statementFor({ actions: ["iam:PassRole"] }).addResources(typeof role == "string" ? role : role.roleArn);
      }
      statementFor(template) {
        const key = keyFor(template);
        return key in this.statements || (this.statements[key] = new iam.PolicyStatement({ actions: template.actions }), template.conditions && this.statements[key].addConditions(template.conditions), this.role.addToPolicy(this.statements[key])), this.statements[key];
        function keyFor(props) {
          const actions = `${props.actions.sort().join("")}`, conditions = formatConditions(props.conditions);
          return `${actions}${conditions}`;
          function formatConditions(cond) {
            if (cond == null)
              return "";
            let result = "";
            for (const op of Object.keys(cond).sort()) {
              result += `${op}`;
              const condition = cond[op];
              for (const attribute of Object.keys(condition).sort()) {
                const value = condition[attribute];
                result += `${value}`;
              }
            }
            return result;
          }
        }
      }
      stackArnFromProps(props) {
        return cdk.Stack.of(this).formatArn({ region: props.region, service: "cloudformation", resource: "stack", resourceName: `${props.stackName}/*` });
      }
      stackSetArnFromProps(props) {
        return cdk.Stack.of(this).formatArn({ region: props.region, service: "cloudformation", resource: "stackset", resourceName: `${props.stackSetName}:*` });
      }
    };
    SingletonPolicy.UUID = "8389e75f-0810-4838-bf64-d6f85a95cf83", exports2.SingletonPolicy = SingletonPolicy;
    function parseCapabilities(capabilities) {
      if (capabilities !== void 0) {
        if (capabilities.length === 1) {
          const capability = capabilities.toString();
          return capability === "" ? void 0 : capability;
        } else if (capabilities.length > 1)
          return capabilities.join(",");
      }
    }
    exports2.parseCapabilities = parseCapabilities;
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/cloudformation/pipeline-actions.js
var require_pipeline_actions = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/cloudformation/pipeline-actions.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CloudFormationDeleteStackAction = exports2.CloudFormationCreateUpdateStackAction = exports2.CloudFormationCreateReplaceChangeSetAction = exports2.CloudFormationExecuteChangeSetAction = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var singleton_policy_1 = require_singleton_policy();
    var cloudformation = require_aws_cloudformation();
    var codepipeline = require_aws_codepipeline();
    var iam = require_aws_iam();
    var cdk = require_core2();
    var action_1 = require_action2();
    var CloudFormationAction = class extends action_1.Action {
      constructor(props, inputs) {
        super({ ...props, provider: "CloudFormation", category: codepipeline.ActionCategory.DEPLOY, artifactBounds: { minInputs: 0, maxInputs: 10, minOutputs: 0, maxOutputs: 1 }, inputs, outputs: props.outputFileName ? [props.output || new codepipeline.Artifact(`${props.actionName}_${props.stackName}_Artifact`)] : void 0 }), this.props = props;
      }
      bound(_scope, _stage, options) {
        const singletonPolicy = singleton_policy_1.SingletonPolicy.forRole(options.role);
        return (this.actionProperties.outputs || []).length > 0 ? options.bucket.grantReadWrite(singletonPolicy) : (this.actionProperties.inputs || []).length > 0 && options.bucket.grantRead(singletonPolicy), { configuration: { StackName: this.props.stackName, OutputFileName: this.props.outputFileName } };
      }
    };
    var CloudFormationExecuteChangeSetAction = class _CloudFormationExecuteChangeSetAction extends CloudFormationAction {
      constructor(props) {
        super(props, void 0);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_actions_CloudFormationExecuteChangeSetActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CloudFormationExecuteChangeSetAction), error;
        }
        this.props2 = props;
      }
      bound(scope, stage, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_IStage(stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_ActionBindOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bound), error;
        }
        singleton_policy_1.SingletonPolicy.forRole(options.role).grantExecuteChangeSet(this.props2);
        const actionConfig = super.bound(scope, stage, options);
        return { ...actionConfig, configuration: { ...actionConfig.configuration, ActionMode: "CHANGE_SET_EXECUTE", ChangeSetName: this.props2.changeSetName } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CloudFormationExecuteChangeSetAction[_a] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.CloudFormationExecuteChangeSetAction", version: "2.80.0" }, exports2.CloudFormationExecuteChangeSetAction = CloudFormationExecuteChangeSetAction;
    var CloudFormationDeployAction = class extends CloudFormationAction {
      constructor(props, inputs) {
        super(props, (props.extraInputs || []).concat(inputs || [])), this.props2 = props;
      }
      addToDeploymentRolePolicy(statement) {
        return this.getDeploymentRole("method addToRolePolicy()").addToPolicy(statement);
      }
      get deploymentRole() {
        return this.getDeploymentRole("property role()");
      }
      bound(scope, stage, options) {
        if (this.props2.deploymentRole)
          this._deploymentRole = this.props2.deploymentRole;
        else {
          const roleStack = cdk.Stack.of(options.role), pipelineStack = cdk.Stack.of(scope);
          roleStack.account !== pipelineStack.account ? this._deploymentRole = new iam.Role(roleStack, `${cdk.Names.nodeUniqueId(stage.pipeline.node)}-${stage.stageName}-${this.actionProperties.actionName}-DeploymentRole`, { assumedBy: new iam.ServicePrincipal("cloudformation.amazonaws.com"), roleName: cdk.PhysicalName.GENERATE_IF_NEEDED }) : this._deploymentRole = new iam.Role(scope, "Role", { assumedBy: new iam.ServicePrincipal("cloudformation.amazonaws.com") }), options.bucket.grantRead(this._deploymentRole), this.props2.adminPermissions && this._deploymentRole.addToPolicy(new iam.PolicyStatement({ actions: ["*"], resources: ["*"] }));
        }
        singleton_policy_1.SingletonPolicy.forRole(options.role).grantPassRole(this._deploymentRole);
        const providedCapabilities = this.props2.cfnCapabilities ?? this.props2.capabilities?.map((c) => {
          switch (c) {
            case cloudformation.CloudFormationCapabilities.NONE:
              return cdk.CfnCapabilities.NONE;
            case cloudformation.CloudFormationCapabilities.ANONYMOUS_IAM:
              return cdk.CfnCapabilities.ANONYMOUS_IAM;
            case cloudformation.CloudFormationCapabilities.NAMED_IAM:
              return cdk.CfnCapabilities.NAMED_IAM;
            case cloudformation.CloudFormationCapabilities.AUTO_EXPAND:
              return cdk.CfnCapabilities.AUTO_EXPAND;
          }
        }), capabilities = this.props2.adminPermissions && providedCapabilities === void 0 ? [cdk.CfnCapabilities.NAMED_IAM] : providedCapabilities, actionConfig = super.bound(scope, stage, options);
        return { ...actionConfig, configuration: { ...actionConfig.configuration, Capabilities: (0, singleton_policy_1.parseCapabilities)(capabilities), RoleArn: this.deploymentRole.roleArn, ParameterOverrides: cdk.Stack.of(scope).toJsonString(this.props2.parameterOverrides), TemplateConfiguration: this.props2.templateConfiguration ? this.props2.templateConfiguration.location : void 0, StackName: this.props2.stackName } };
      }
      getDeploymentRole(member) {
        if (this._deploymentRole)
          return this._deploymentRole;
        throw new Error(`Cannot use the ${member} before the Action has been added to a Pipeline`);
      }
    };
    var CloudFormationCreateReplaceChangeSetAction = class _CloudFormationCreateReplaceChangeSetAction extends CloudFormationDeployAction {
      constructor(props) {
        super(props, props.templateConfiguration ? [props.templatePath.artifact, props.templateConfiguration.artifact] : [props.templatePath.artifact]);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_actions_CloudFormationCreateReplaceChangeSetActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CloudFormationCreateReplaceChangeSetAction), error;
        }
        this.props3 = props;
      }
      bound(scope, stage, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_IStage(stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_ActionBindOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bound), error;
        }
        const actionConfig = super.bound(scope, stage, options);
        return singleton_policy_1.SingletonPolicy.forRole(options.role).grantCreateReplaceChangeSet(this.props3), { ...actionConfig, configuration: { ...actionConfig.configuration, ActionMode: "CHANGE_SET_REPLACE", ChangeSetName: this.props3.changeSetName, TemplatePath: this.props3.templatePath.location } };
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CloudFormationCreateReplaceChangeSetAction[_b] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.CloudFormationCreateReplaceChangeSetAction", version: "2.80.0" }, exports2.CloudFormationCreateReplaceChangeSetAction = CloudFormationCreateReplaceChangeSetAction;
    var CloudFormationCreateUpdateStackAction = class _CloudFormationCreateUpdateStackAction extends CloudFormationDeployAction {
      constructor(props) {
        super(props, props.templateConfiguration ? [props.templatePath.artifact, props.templateConfiguration.artifact] : [props.templatePath.artifact]);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_actions_CloudFormationCreateUpdateStackActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CloudFormationCreateUpdateStackAction), error;
        }
        this.props3 = props;
      }
      bound(scope, stage, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_IStage(stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_ActionBindOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bound), error;
        }
        const actionConfig = super.bound(scope, stage, options);
        return singleton_policy_1.SingletonPolicy.forRole(options.role).grantCreateUpdateStack(this.props3), { ...actionConfig, configuration: { ...actionConfig.configuration, ActionMode: this.props3.replaceOnFailure ? "REPLACE_ON_FAILURE" : "CREATE_UPDATE", TemplatePath: this.props3.templatePath.location } };
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CloudFormationCreateUpdateStackAction[_c] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.CloudFormationCreateUpdateStackAction", version: "2.80.0" }, exports2.CloudFormationCreateUpdateStackAction = CloudFormationCreateUpdateStackAction;
    var CloudFormationDeleteStackAction = class _CloudFormationDeleteStackAction extends CloudFormationDeployAction {
      constructor(props) {
        super(props, void 0);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_actions_CloudFormationDeleteStackActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CloudFormationDeleteStackAction), error;
        }
        this.props3 = props;
      }
      bound(scope, stage, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_IStage(stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_ActionBindOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bound), error;
        }
        const actionConfig = super.bound(scope, stage, options);
        return singleton_policy_1.SingletonPolicy.forRole(options.role).grantDeleteStack(this.props3), { ...actionConfig, configuration: { ...actionConfig.configuration, ActionMode: "DELETE_ONLY" } };
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CloudFormationDeleteStackAction[_d] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.CloudFormationDeleteStackAction", version: "2.80.0" }, exports2.CloudFormationDeleteStackAction = CloudFormationDeleteStackAction;
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/cloudformation/stackset-types.js
var require_stackset_types = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/cloudformation/stackset-types.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.StackSetOrganizationsAutoDeployment = exports2.StackSetDeploymentModel = exports2.StackSetParameters = exports2.StackInstances = exports2.StackSetTemplate = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var cdk = require_core2();
    var StackSetTemplate = class _StackSetTemplate {
      static fromArtifactPath(artifactPath) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_ArtifactPath(artifactPath);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromArtifactPath), error;
        }
        return new class extends _StackSetTemplate {
          constructor() {
            super(...arguments), this._artifactsReferenced = [artifactPath.artifact];
          }
          _render() {
            return artifactPath.location;
          }
        }();
      }
    };
    _a = JSII_RTTI_SYMBOL_1, StackSetTemplate[_a] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.StackSetTemplate", version: "2.80.0" }, exports2.StackSetTemplate = StackSetTemplate;
    var StackInstances = class _StackInstances {
      static inAccounts(accounts, regions) {
        return _StackInstances.fromList(accounts, regions);
      }
      static inOrganizationalUnits(ous, regions) {
        return _StackInstances.fromList(ous, regions);
      }
      static fromArtifactPath(artifactPath, regions) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_ArtifactPath(artifactPath);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromArtifactPath), error;
        }
        if (regions.length === 0)
          throw new Error("'regions' may not be an empty list");
        return new class extends _StackInstances {
          constructor() {
            super(...arguments), this._artifactsReferenced = [artifactPath.artifact];
          }
          _bind(_scope) {
            return { stackSetConfiguration: { DeploymentTargets: artifactPath.location, Regions: regions.join(",") } };
          }
        }();
      }
      static fromList(targets, regions) {
        if (targets.length === 0)
          throw new Error("'targets' may not be an empty list");
        if (regions.length === 0)
          throw new Error("'regions' may not be an empty list");
        return new class extends _StackInstances {
          _bind(_scope) {
            return { stackSetConfiguration: { DeploymentTargets: targets.join(","), Regions: regions.join(",") } };
          }
        }();
      }
    };
    _b = JSII_RTTI_SYMBOL_1, StackInstances[_b] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.StackInstances", version: "2.80.0" }, exports2.StackInstances = StackInstances;
    var StackSetParameters = class _StackSetParameters {
      static fromLiteral(parameters, usePreviousValues) {
        return new class extends _StackSetParameters {
          constructor() {
            super(...arguments), this._artifactsReferenced = [];
          }
          _render() {
            return [...Object.entries(parameters).map(([key, value]) => `ParameterKey=${key},ParameterValue=${value}`), ...(usePreviousValues ?? []).map((key) => `ParameterKey=${key},UsePreviousValue=true`)].join(" ");
          }
        }();
      }
      static fromArtifactPath(artifactPath) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_ArtifactPath(artifactPath);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromArtifactPath), error;
        }
        return new class extends _StackSetParameters {
          constructor() {
            super(...arguments), this._artifactsReferenced = [artifactPath.artifact];
          }
          _render() {
            return artifactPath.location;
          }
        }();
      }
    };
    _c = JSII_RTTI_SYMBOL_1, StackSetParameters[_c] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.StackSetParameters", version: "2.80.0" }, exports2.StackSetParameters = StackSetParameters;
    var StackSetDeploymentModel = class _StackSetDeploymentModel {
      static organizations(props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_actions_OrganizationsDeploymentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.organizations), error;
        }
        return new class extends _StackSetDeploymentModel {
          _bind() {
            return { stackSetConfiguration: { PermissionModel: "SERVICE_MANAGED", OrganizationsAutoDeployment: props.autoDeployment } };
          }
        }();
      }
      static selfManaged(props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_actions_SelfManagedDeploymentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.selfManaged), error;
        }
        return new class extends _StackSetDeploymentModel {
          _bind(scope) {
            let administrationRole = props.administrationRole;
            return administrationRole || (administrationRole = new iam.Role(scope, "StackSetAdministrationRole", { assumedBy: new iam.ServicePrincipal("cloudformation.amazonaws.com", { conditions: { StringLike: { "aws:SourceArn": `arn:${cdk.Aws.PARTITION}:cloudformation:*:${cdk.Aws.ACCOUNT_ID}:stackset/*` } } }) }), administrationRole.addToPrincipalPolicy(new iam.PolicyStatement({ actions: ["sts:AssumeRole"], resources: [`arn:${cdk.Aws.PARTITION}:iam::*:role/${props.executionRoleName ?? "AWSCloudFormationStackSetExecutionRole"}`] }))), { stackSetConfiguration: { PermissionModel: "SELF_MANAGED", AdministrationRoleArn: administrationRole.roleArn, ExecutionRoleName: props.executionRoleName }, passedRoles: [administrationRole] };
          }
        }();
      }
    };
    _d = JSII_RTTI_SYMBOL_1, StackSetDeploymentModel[_d] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.StackSetDeploymentModel", version: "2.80.0" }, exports2.StackSetDeploymentModel = StackSetDeploymentModel;
    var StackSetOrganizationsAutoDeployment;
    (function(StackSetOrganizationsAutoDeployment2) {
      StackSetOrganizationsAutoDeployment2.ENABLED = "Enabled", StackSetOrganizationsAutoDeployment2.DISABLED = "Disabled", StackSetOrganizationsAutoDeployment2.ENABLED_WITH_STACK_RETENTION = "EnabledWithStackRetention";
    })(StackSetOrganizationsAutoDeployment = exports2.StackSetOrganizationsAutoDeployment || (exports2.StackSetOrganizationsAutoDeployment = {}));
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/cloudformation/stackset-action.js
var require_stackset_action = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/cloudformation/stackset-action.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CloudFormationDeployStackSetAction = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var singleton_policy_1 = require_singleton_policy();
    var stackset_types_1 = require_stackset_types();
    var codepipeline = require_aws_codepipeline();
    var action_1 = require_action2();
    var common_1 = require_common4();
    var CloudFormationDeployStackSetAction = class _CloudFormationDeployStackSetAction extends action_1.Action {
      constructor(props) {
        super({ ...props, region: props.stackSetRegion, provider: "CloudFormationStackSet", category: codepipeline.ActionCategory.DEPLOY, artifactBounds: { minInputs: 1, maxInputs: 3, minOutputs: 0, maxOutputs: 0 }, inputs: [...props.template._artifactsReferenced ?? [], ...props.parameters?._artifactsReferenced ?? [], ...props.stackInstances?._artifactsReferenced ?? []] });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_actions_CloudFormationDeployStackSetActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CloudFormationDeployStackSetAction), error;
        }
        this.props = props, this.deploymentModel = props.deploymentModel ?? stackset_types_1.StackSetDeploymentModel.selfManaged(), (0, common_1.validatePercentage)("failureTolerancePercentage", props.failureTolerancePercentage), (0, common_1.validatePercentage)("maxAccountConcurrencyPercentage", props.maxAccountConcurrencyPercentage);
      }
      bound(scope, _stage, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_IStage(_stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_ActionBindOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bound), error;
        }
        const singletonPolicy = singleton_policy_1.SingletonPolicy.forRole(options.role);
        singletonPolicy.grantCreateUpdateStackSet(this.props);
        const instancesResult = this.props.stackInstances?._bind(scope), permissionModelBind = this.deploymentModel?._bind(scope);
        for (const role of permissionModelBind?.passedRoles ?? [])
          singletonPolicy.grantPassRole(role);
        return (this.actionProperties.inputs || []).length > 0 && options.bucket.grantRead(singletonPolicy), { configuration: { StackSetName: this.props.stackSetName, Description: this.props.description, TemplatePath: this.props.template._render(), Parameters: this.props.parameters?._render(), Capabilities: (0, singleton_policy_1.parseCapabilities)(this.props.cfnCapabilities), FailureTolerancePercentage: this.props.failureTolerancePercentage, MaxConcurrentPercentage: this.props.maxAccountConcurrencyPercentage, ...instancesResult?.stackSetConfiguration, ...permissionModelBind?.stackSetConfiguration } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CloudFormationDeployStackSetAction[_a] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.CloudFormationDeployStackSetAction", version: "2.80.0" }, exports2.CloudFormationDeployStackSetAction = CloudFormationDeployStackSetAction;
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/cloudformation/stackinstances-action.js
var require_stackinstances_action = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/cloudformation/stackinstances-action.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CloudFormationDeployStackInstancesAction = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var singleton_policy_1 = require_singleton_policy();
    var codepipeline = require_aws_codepipeline();
    var action_1 = require_action2();
    var common_1 = require_common4();
    var CloudFormationDeployStackInstancesAction = class _CloudFormationDeployStackInstancesAction extends action_1.Action {
      constructor(props) {
        super({ ...props, region: props.stackSetRegion, provider: "CloudFormationStackInstances", category: codepipeline.ActionCategory.DEPLOY, artifactBounds: { minInputs: 0, maxInputs: 3, minOutputs: 0, maxOutputs: 0 }, inputs: [...props.parameterOverrides?._artifactsReferenced ?? [], ...props.stackInstances?._artifactsReferenced ?? []] });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_actions_CloudFormationDeployStackInstancesActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CloudFormationDeployStackInstancesAction), error;
        }
        this.props = props, (0, common_1.validatePercentage)("failureTolerancePercentage", props.failureTolerancePercentage), (0, common_1.validatePercentage)("maxAccountConcurrencyPercentage", props.maxAccountConcurrencyPercentage);
      }
      bound(scope, _stage, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_IStage(_stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_ActionBindOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bound), error;
        }
        const singletonPolicy = singleton_policy_1.SingletonPolicy.forRole(options.role);
        singletonPolicy.grantCreateUpdateStackSet(this.props);
        const instancesResult = this.props.stackInstances?._bind(scope);
        return (this.actionProperties.inputs || []).length > 0 && options.bucket.grantRead(singletonPolicy), { configuration: { StackSetName: this.props.stackSetName, ParameterOverrides: this.props.parameterOverrides?._render(), FailureTolerancePercentage: this.props.failureTolerancePercentage, MaxConcurrentPercentage: this.props.maxAccountConcurrencyPercentage, ...instancesResult?.stackSetConfiguration } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CloudFormationDeployStackInstancesAction[_a] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.CloudFormationDeployStackInstancesAction", version: "2.80.0" }, exports2.CloudFormationDeployStackInstancesAction = CloudFormationDeployStackInstancesAction;
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/cloudformation/index.js
var require_cloudformation2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/cloudformation/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_pipeline_actions(), exports2), __exportStar(require_stackset_action(), exports2), __exportStar(require_stackinstances_action(), exports2), __exportStar(require_stackset_types(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-events-targets/lib/util.js
var require_util17 = __commonJS({
  "node_modules/aws-cdk-lib/aws-events-targets/lib/util.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.addToDeadLetterQueueResourcePolicy = exports2.addLambdaPermission = exports2.singletonEventRole = exports2.bindBaseTargetConfig = void 0;
    var constructs_1 = require_lib2();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    function bindBaseTargetConfig(props) {
      let { deadLetterQueue, retryAttempts, maxEventAge } = props;
      return { deadLetterConfig: deadLetterQueue ? { arn: deadLetterQueue?.queueArn } : void 0, retryPolicy: retryAttempts !== void 0 && retryAttempts >= 0 || maxEventAge ? { maximumRetryAttempts: retryAttempts, maximumEventAgeInSeconds: maxEventAge?.toSeconds({ integral: true }) } : void 0 };
    }
    exports2.bindBaseTargetConfig = bindBaseTargetConfig;
    function singletonEventRole(scope) {
      const id = "EventsRole", existing = scope.node.tryFindChild(id);
      return existing || new iam.Role(scope, id, { roleName: core_1.PhysicalName.GENERATE_IF_NEEDED, assumedBy: new iam.ServicePrincipal("events.amazonaws.com") });
    }
    exports2.singletonEventRole = singletonEventRole;
    function addLambdaPermission(rule, handler2) {
      let scope, node = handler2.permissionsNode, permissionId = `AllowEventRule${core_1.Names.nodeUniqueId(rule.node)}`;
      rule instanceof constructs_1.Construct && (scope = rule, node = rule.node, permissionId = `AllowEventRule${core_1.Names.nodeUniqueId(handler2.node)}`), node.tryFindChild(permissionId) || handler2.addPermission(permissionId, { scope, action: "lambda:InvokeFunction", principal: new iam.ServicePrincipal("events.amazonaws.com"), sourceArn: rule.ruleArn });
    }
    exports2.addLambdaPermission = addLambdaPermission;
    function addToDeadLetterQueueResourcePolicy(rule, queue) {
      if (!sameEnvDimension(rule.env.region, queue.env.region))
        throw new Error(`Cannot assign Dead Letter Queue in region ${queue.env.region} to the rule ${core_1.Names.nodeUniqueId(rule.node)} in region ${rule.env.region}. Both the queue and the rule must be in the same region.`);
      if (sameEnvDimension(rule.env.account, queue.env.account)) {
        const policyStatementId = `AllowEventRule${core_1.Names.nodeUniqueId(rule.node)}`;
        queue.addToResourcePolicy(new iam.PolicyStatement({ sid: policyStatementId, principals: [new iam.ServicePrincipal("events.amazonaws.com")], effect: iam.Effect.ALLOW, actions: ["sqs:SendMessage"], resources: [queue.queueArn], conditions: { ArnEquals: { "aws:SourceArn": rule.ruleArn } } }));
      } else
        core_1.Annotations.of(rule).addWarning(`Cannot add a resource policy to your dead letter queue associated with rule ${rule.ruleName} because the queue is in a different account. You must add the resource policy manually to the dead letter queue in account ${queue.env.account}.`);
    }
    exports2.addToDeadLetterQueueResourcePolicy = addToDeadLetterQueueResourcePolicy;
    function sameEnvDimension(dim1, dim2) {
      return [core_1.TokenComparison.SAME, core_1.TokenComparison.BOTH_UNRESOLVED].includes(core_1.Token.compareStrings(dim1, dim2));
    }
  }
});

// node_modules/aws-cdk-lib/aws-events-targets/lib/batch.js
var require_batch2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-events-targets/lib/batch.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.BatchJob = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var util_1 = require_util17();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var BatchJob = class _BatchJob {
      constructor(jobQueueArn, jobQueueScope, jobDefinitionArn, jobDefinitionScope, props = {}) {
        this.jobQueueArn = jobQueueArn, this.jobQueueScope = jobQueueScope, this.jobDefinitionArn = jobDefinitionArn, this.jobDefinitionScope = jobDefinitionScope, this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_targets_BatchJobProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _BatchJob), error;
        }
      }
      bind(rule, _id) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_IRule(rule);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        this.validateJobName(this.props.jobName);
        const jobName = this.props.jobName ?? core_1.Names.uniqueResourceName(rule, { maxLength: 128 }), batchParameters = { jobDefinition: this.jobDefinitionArn, jobName, arrayProperties: this.props.size ? { size: this.props.size } : void 0, retryStrategy: this.props.attempts ? { attempts: this.props.attempts } : void 0 };
        this.props.deadLetterQueue && (0, util_1.addToDeadLetterQueueResourcePolicy)(rule, this.props.deadLetterQueue);
        const role = (0, util_1.singletonEventRole)(this.jobDefinitionScope);
        return role.addToPrincipalPolicy(new iam.PolicyStatement({ actions: ["batch:SubmitJob"], resources: [this.jobDefinitionArn, this.jobQueueArn] })), { ...(0, util_1.bindBaseTargetConfig)(this.props), arn: this.jobQueueArn, role, input: this.props.event, targetResource: this.jobQueueScope, batchParameters };
      }
      validateJobName(name) {
        if (!core_1.Token.isUnresolved(name) && name !== void 0 && (name.length < 1 || name.length > 128))
          throw new Error(`Invalid jobName value ${name}, must have length between 1 and 128, got: ${name.length}`);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, BatchJob[_a] = { fqn: "aws-cdk-lib.aws_events_targets.BatchJob", version: "2.80.0" }, exports2.BatchJob = BatchJob;
  }
});

// node_modules/aws-cdk-lib/aws-events-targets/lib/codepipeline.js
var require_codepipeline2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-events-targets/lib/codepipeline.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CodePipeline = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var util_1 = require_util17();
    var iam = require_aws_iam();
    var CodePipeline = class _CodePipeline {
      constructor(pipeline, options = {}) {
        this.pipeline = pipeline, this.options = options;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_IPipeline(pipeline), jsiiDeprecationWarnings.aws_cdk_lib_aws_events_targets_CodePipelineTargetOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CodePipeline), error;
        }
      }
      bind(_rule, _id) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_IRule(_rule);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        const role = this.options.eventRole || (0, util_1.singletonEventRole)(this.pipeline);
        return role.addToPrincipalPolicy(new iam.PolicyStatement({ resources: [this.pipeline.pipelineArn], actions: ["codepipeline:StartPipelineExecution"] })), { ...(0, util_1.bindBaseTargetConfig)(this.options), id: "", arn: this.pipeline.pipelineArn, role, targetResource: this.pipeline };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CodePipeline[_a] = { fqn: "aws-cdk-lib.aws_events_targets.CodePipeline", version: "2.80.0" }, exports2.CodePipeline = CodePipeline;
  }
});

// node_modules/aws-cdk-lib/aws-events-targets/lib/sns.js
var require_sns3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-events-targets/lib/sns.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SnsTopic = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var util_1 = require_util17();
    var iam = require_aws_iam();
    var SnsTopic = class _SnsTopic {
      constructor(topic, props = {}) {
        this.topic = topic, this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sns_ITopic(topic), jsiiDeprecationWarnings.aws_cdk_lib_aws_events_targets_SnsTopicProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SnsTopic), error;
        }
      }
      bind(_rule, _id) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_IRule(_rule);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return this.topic.grantPublish(new iam.ServicePrincipal("events.amazonaws.com")), this.props.deadLetterQueue && (0, util_1.addToDeadLetterQueueResourcePolicy)(_rule, this.props.deadLetterQueue), { ...(0, util_1.bindBaseTargetConfig)(this.props), arn: this.topic.topicArn, input: this.props.message, targetResource: this.topic };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SnsTopic[_a] = { fqn: "aws-cdk-lib.aws_events_targets.SnsTopic", version: "2.80.0" }, exports2.SnsTopic = SnsTopic;
  }
});

// node_modules/aws-cdk-lib/aws-events-targets/lib/sqs.js
var require_sqs4 = __commonJS({
  "node_modules/aws-cdk-lib/aws-events-targets/lib/sqs.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SqsQueue = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var util_1 = require_util17();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var cxapi = require_cx_api();
    var SqsQueue = class _SqsQueue {
      constructor(queue, props = {}) {
        this.queue = queue, this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sqs_IQueue(queue), jsiiDeprecationWarnings.aws_cdk_lib_aws_events_targets_SqsQueueProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SqsQueue), error;
        }
        if (props.messageGroupId !== void 0 && !queue.fifo)
          throw new Error("messageGroupId cannot be specified for non-FIFO queues");
      }
      bind(rule, _id) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_IRule(rule);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        const restrictToSameAccount = core_1.FeatureFlags.of(rule).isEnabled(cxapi.EVENTS_TARGET_QUEUE_SAME_ACCOUNT);
        let conditions = {};
        return this.queue.encryptionMasterKey ? restrictToSameAccount && (conditions = { StringEquals: { "aws:SourceAccount": rule.env.account } }) : conditions = { ArnEquals: { "aws:SourceArn": rule.ruleArn } }, this.queue.grantSendMessages(new iam.ServicePrincipal("events.amazonaws.com", { conditions })), this.props.deadLetterQueue && (0, util_1.addToDeadLetterQueueResourcePolicy)(rule, this.props.deadLetterQueue), { ...(0, util_1.bindBaseTargetConfig)(this.props), arn: this.queue.queueArn, input: this.props.message, targetResource: this.queue, sqsParameters: this.props.messageGroupId ? { messageGroupId: this.props.messageGroupId } : void 0 };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SqsQueue[_a] = { fqn: "aws-cdk-lib.aws_events_targets.SqsQueue", version: "2.80.0" }, exports2.SqsQueue = SqsQueue;
  }
});

// node_modules/aws-cdk-lib/aws-events-targets/lib/codebuild.js
var require_codebuild2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-events-targets/lib/codebuild.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CodeBuildProject = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var util_1 = require_util17();
    var iam = require_aws_iam();
    var CodeBuildProject = class _CodeBuildProject {
      constructor(project, props = {}) {
        this.project = project, this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codebuild_IProject(project), jsiiDeprecationWarnings.aws_cdk_lib_aws_events_targets_CodeBuildProjectProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CodeBuildProject), error;
        }
      }
      bind(_rule, _id) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_IRule(_rule);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        this.props.deadLetterQueue && (0, util_1.addToDeadLetterQueueResourcePolicy)(_rule, this.props.deadLetterQueue);
        const role = this.props.eventRole || (0, util_1.singletonEventRole)(this.project);
        return role.addToPrincipalPolicy(new iam.PolicyStatement({ actions: ["codebuild:StartBuild"], resources: [this.project.projectArn] })), { ...(0, util_1.bindBaseTargetConfig)(this.props), arn: this.project.projectArn, role, input: this.props.event, targetResource: this.project };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CodeBuildProject[_a] = { fqn: "aws-cdk-lib.aws_events_targets.CodeBuildProject", version: "2.80.0" }, exports2.CodeBuildProject = CodeBuildProject;
  }
});

// node_modules/aws-cdk-lib/aws-events-targets/lib/sdk-api-metadata.generated.js
var require_sdk_api_metadata_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-events-targets/lib/sdk-api-metadata.generated.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.metadata = void 0, exports2.metadata = { acm: { name: "ACM", cors: true }, apigateway: { name: "APIGateway", cors: true }, applicationautoscaling: { prefix: "application-autoscaling", name: "ApplicationAutoScaling", cors: true }, appstream: { name: "AppStream" }, autoscaling: { name: "AutoScaling", cors: true }, batch: { name: "Batch" }, budgets: { name: "Budgets" }, clouddirectory: { name: "CloudDirectory", versions: ["2016-05-10*"] }, cloudformation: { name: "CloudFormation", cors: true }, cloudfront: { name: "CloudFront", versions: ["2013-05-12*", "2013-11-11*", "2014-05-31*", "2014-10-21*", "2014-11-06*", "2015-04-17*", "2015-07-27*", "2015-09-17*", "2016-01-13*", "2016-01-28*", "2016-08-01*", "2016-08-20*", "2016-09-07*", "2016-09-29*", "2016-11-25*", "2017-03-25*", "2017-10-30*", "2018-06-18*", "2018-11-05*", "2019-03-26*"], cors: true }, cloudhsm: { name: "CloudHSM", cors: true }, cloudsearch: { name: "CloudSearch" }, cloudsearchdomain: { name: "CloudSearchDomain" }, cloudtrail: { name: "CloudTrail", cors: true }, cloudwatch: { prefix: "monitoring", name: "CloudWatch", cors: true }, cloudwatchevents: { prefix: "events", name: "CloudWatchEvents", versions: ["2014-02-03*"], cors: true }, cloudwatchlogs: { prefix: "logs", name: "CloudWatchLogs", cors: true }, codebuild: { name: "CodeBuild", cors: true }, codecommit: { name: "CodeCommit", cors: true }, codedeploy: { name: "CodeDeploy", cors: true }, codepipeline: { name: "CodePipeline", cors: true }, cognitoidentity: { prefix: "cognito-identity", name: "CognitoIdentity", cors: true }, cognitoidentityserviceprovider: { prefix: "cognito-idp", name: "CognitoIdentityServiceProvider", cors: true }, cognitosync: { prefix: "cognito-sync", name: "CognitoSync", cors: true }, configservice: { prefix: "config", name: "ConfigService", cors: true }, cur: { name: "CUR", cors: true }, datapipeline: { name: "DataPipeline" }, devicefarm: { name: "DeviceFarm", cors: true }, directconnect: { name: "DirectConnect", cors: true }, directoryservice: { prefix: "ds", name: "DirectoryService" }, discovery: { name: "Discovery" }, dms: { name: "DMS" }, dynamodb: { name: "DynamoDB", cors: true }, dynamodbstreams: { prefix: "streams.dynamodb", name: "DynamoDBStreams", cors: true }, ec2: { name: "EC2", versions: ["2013-06-15*", "2013-10-15*", "2014-02-01*", "2014-05-01*", "2014-06-15*", "2014-09-01*", "2014-10-01*", "2015-03-01*", "2015-04-15*", "2015-10-01*", "2016-04-01*", "2016-09-15*"], cors: true }, ecr: { name: "ECR", cors: true }, ecs: { name: "ECS", cors: true }, efs: { prefix: "elasticfilesystem", name: "EFS", cors: true }, elasticache: { name: "ElastiCache", versions: ["2012-11-15*", "2014-03-24*", "2014-07-15*", "2014-09-30*"], cors: true }, elasticbeanstalk: { name: "ElasticBeanstalk", cors: true }, elb: { prefix: "elasticloadbalancing", name: "ELB", cors: true }, elbv2: { prefix: "elasticloadbalancingv2", name: "ELBv2", cors: true }, emr: { prefix: "elasticmapreduce", name: "EMR", cors: true }, es: { name: "ES" }, elastictranscoder: { name: "ElasticTranscoder", cors: true }, firehose: { name: "Firehose", cors: true }, gamelift: { name: "GameLift", cors: true }, glacier: { name: "Glacier" }, health: { name: "Health" }, iam: { name: "IAM", cors: true }, importexport: { name: "ImportExport" }, inspector: { name: "Inspector", versions: ["2015-08-18*"], cors: true }, iot: { name: "Iot", cors: true }, iotdata: { prefix: "iot-data", name: "IotData", cors: true }, kinesis: { name: "Kinesis", cors: true }, kinesisanalytics: { name: "KinesisAnalytics" }, kms: { name: "KMS", cors: true }, lambda: { name: "Lambda", cors: true }, lexruntime: { prefix: "runtime.lex", name: "LexRuntime", cors: true }, lightsail: { name: "Lightsail" }, machinelearning: { name: "MachineLearning", cors: true }, marketplacecommerceanalytics: { name: "MarketplaceCommerceAnalytics", cors: true }, marketplacemetering: { prefix: "meteringmarketplace", name: "MarketplaceMetering" }, mturk: { prefix: "mturk-requester", name: "MTurk", cors: true }, mobileanalytics: { name: "MobileAnalytics", cors: true }, opsworks: { name: "OpsWorks", cors: true }, opsworkscm: { name: "OpsWorksCM" }, organizations: { name: "Organizations" }, pinpoint: { name: "Pinpoint" }, polly: { name: "Polly", cors: true }, rds: { name: "RDS", versions: ["2014-09-01*"], cors: true }, redshift: { name: "Redshift", cors: true }, rekognition: { name: "Rekognition", cors: true }, resourcegroupstaggingapi: { name: "ResourceGroupsTaggingAPI" }, route53: { name: "Route53", cors: true }, route53domains: { name: "Route53Domains", cors: true }, s3: { name: "S3", dualstackAvailable: true, cors: true }, s3control: { name: "S3Control", dualstackAvailable: true, xmlNoDefaultLists: true }, servicecatalog: { name: "ServiceCatalog", cors: true }, ses: { prefix: "email", name: "SES", cors: true }, shield: { name: "Shield" }, simpledb: { prefix: "sdb", name: "SimpleDB" }, sms: { name: "SMS" }, snowball: { name: "Snowball" }, sns: { name: "SNS", cors: true }, sqs: { name: "SQS", cors: true }, ssm: { name: "SSM", cors: true }, storagegateway: { name: "StorageGateway", cors: true }, stepfunctions: { prefix: "states", name: "StepFunctions" }, sts: { name: "STS", cors: true }, support: { name: "Support" }, swf: { name: "SWF" }, xray: { name: "XRay", cors: true }, waf: { name: "WAF", cors: true }, wafregional: { prefix: "waf-regional", name: "WAFRegional" }, workdocs: { name: "WorkDocs", cors: true }, workspaces: { name: "WorkSpaces" }, codestar: { name: "CodeStar" }, lexmodelbuildingservice: { prefix: "lex-models", name: "LexModelBuildingService", cors: true }, marketplaceentitlementservice: { prefix: "entitlement.marketplace", name: "MarketplaceEntitlementService" }, athena: { name: "Athena", cors: true }, greengrass: { name: "Greengrass" }, dax: { name: "DAX" }, migrationhub: { prefix: "AWSMigrationHub", name: "MigrationHub" }, cloudhsmv2: { name: "CloudHSMV2", cors: true }, glue: { name: "Glue" }, mobile: { name: "Mobile" }, pricing: { name: "Pricing", cors: true }, costexplorer: { prefix: "ce", name: "CostExplorer", cors: true }, mediaconvert: { name: "MediaConvert" }, medialive: { name: "MediaLive" }, mediapackage: { name: "MediaPackage" }, mediastore: { name: "MediaStore" }, mediastoredata: { prefix: "mediastore-data", name: "MediaStoreData", cors: true }, appsync: { name: "AppSync" }, guardduty: { name: "GuardDuty" }, mq: { name: "MQ" }, comprehend: { name: "Comprehend", cors: true }, iotjobsdataplane: { prefix: "iot-jobs-data", name: "IoTJobsDataPlane" }, kinesisvideoarchivedmedia: { prefix: "kinesis-video-archived-media", name: "KinesisVideoArchivedMedia", cors: true }, kinesisvideomedia: { prefix: "kinesis-video-media", name: "KinesisVideoMedia", cors: true }, kinesisvideo: { name: "KinesisVideo", cors: true }, sagemakerruntime: { prefix: "runtime.sagemaker", name: "SageMakerRuntime" }, sagemaker: { name: "SageMaker" }, translate: { name: "Translate", cors: true }, resourcegroups: { prefix: "resource-groups", name: "ResourceGroups", cors: true }, alexaforbusiness: { name: "AlexaForBusiness" }, cloud9: { name: "Cloud9" }, serverlessapplicationrepository: { prefix: "serverlessrepo", name: "ServerlessApplicationRepository" }, servicediscovery: { name: "ServiceDiscovery" }, workmail: { name: "WorkMail" }, autoscalingplans: { prefix: "autoscaling-plans", name: "AutoScalingPlans" }, transcribeservice: { prefix: "transcribe", name: "TranscribeService" }, connect: { name: "Connect", cors: true }, acmpca: { prefix: "acm-pca", name: "ACMPCA" }, fms: { name: "FMS" }, secretsmanager: { name: "SecretsManager", cors: true }, iotanalytics: { name: "IoTAnalytics", cors: true }, iot1clickdevicesservice: { prefix: "iot1click-devices", name: "IoT1ClickDevicesService" }, iot1clickprojects: { prefix: "iot1click-projects", name: "IoT1ClickProjects" }, pi: { name: "PI" }, neptune: { name: "Neptune" }, mediatailor: { name: "MediaTailor" }, eks: { name: "EKS" }, macie: { name: "Macie" }, dlm: { name: "DLM" }, signer: { name: "Signer" }, chime: { name: "Chime" }, pinpointemail: { prefix: "pinpoint-email", name: "PinpointEmail" }, ram: { name: "RAM" }, route53resolver: { name: "Route53Resolver" }, pinpointsmsvoice: { prefix: "sms-voice", name: "PinpointSMSVoice" }, quicksight: { name: "QuickSight" }, rdsdataservice: { prefix: "rds-data", name: "RDSDataService" }, amplify: { name: "Amplify" }, datasync: { name: "DataSync" }, robomaker: { name: "RoboMaker" }, transfer: { name: "Transfer" }, globalaccelerator: { name: "GlobalAccelerator" }, comprehendmedical: { name: "ComprehendMedical", cors: true }, kinesisanalyticsv2: { name: "KinesisAnalyticsV2" }, mediaconnect: { name: "MediaConnect" }, fsx: { name: "FSx" }, securityhub: { name: "SecurityHub" }, appmesh: { name: "AppMesh", versions: ["2018-10-01*"] }, licensemanager: { prefix: "license-manager", name: "LicenseManager" }, kafka: { name: "Kafka" }, apigatewaymanagementapi: { name: "ApiGatewayManagementApi" }, apigatewayv2: { name: "ApiGatewayV2" }, docdb: { name: "DocDB" }, backup: { name: "Backup" }, worklink: { name: "WorkLink" }, textract: { name: "Textract" }, managedblockchain: { name: "ManagedBlockchain" }, mediapackagevod: { prefix: "mediapackage-vod", name: "MediaPackageVod" }, groundstation: { name: "GroundStation" }, iotthingsgraph: { name: "IoTThingsGraph" }, iotevents: { name: "IoTEvents" }, ioteventsdata: { prefix: "iotevents-data", name: "IoTEventsData" }, personalize: { name: "Personalize", cors: true }, personalizeevents: { prefix: "personalize-events", name: "PersonalizeEvents", cors: true }, personalizeruntime: { prefix: "personalize-runtime", name: "PersonalizeRuntime", cors: true }, applicationinsights: { prefix: "application-insights", name: "ApplicationInsights" }, servicequotas: { prefix: "service-quotas", name: "ServiceQuotas" }, ec2instanceconnect: { prefix: "ec2-instance-connect", name: "EC2InstanceConnect" }, eventbridge: { name: "EventBridge" }, lakeformation: { name: "LakeFormation" }, forecastservice: { prefix: "forecast", name: "ForecastService", cors: true }, forecastqueryservice: { prefix: "forecastquery", name: "ForecastQueryService", cors: true }, qldb: { name: "QLDB" }, qldbsession: { prefix: "qldb-session", name: "QLDBSession" }, workmailmessageflow: { name: "WorkMailMessageFlow" }, codestarnotifications: { prefix: "codestar-notifications", name: "CodeStarNotifications" }, savingsplans: { name: "SavingsPlans" }, sso: { name: "SSO" }, ssooidc: { prefix: "sso-oidc", name: "SSOOIDC" }, marketplacecatalog: { prefix: "marketplace-catalog", name: "MarketplaceCatalog", cors: true }, dataexchange: { name: "DataExchange" }, sesv2: { name: "SESV2" }, migrationhubconfig: { prefix: "migrationhub-config", name: "MigrationHubConfig" }, connectparticipant: { name: "ConnectParticipant" }, appconfig: { name: "AppConfig" }, iotsecuretunneling: { name: "IoTSecureTunneling" }, wafv2: { name: "WAFV2" }, elasticinference: { prefix: "elastic-inference", name: "ElasticInference" }, imagebuilder: { name: "Imagebuilder" }, schemas: { name: "Schemas" }, accessanalyzer: { name: "AccessAnalyzer" }, codegurureviewer: { prefix: "codeguru-reviewer", name: "CodeGuruReviewer" }, codeguruprofiler: { name: "CodeGuruProfiler" }, computeoptimizer: { prefix: "compute-optimizer", name: "ComputeOptimizer" }, frauddetector: { name: "FraudDetector" }, kendra: { name: "Kendra" }, networkmanager: { name: "NetworkManager" }, outposts: { name: "Outposts" }, augmentedairuntime: { prefix: "sagemaker-a2i-runtime", name: "AugmentedAIRuntime" }, ebs: { name: "EBS" }, kinesisvideosignalingchannels: { prefix: "kinesis-video-signaling", name: "KinesisVideoSignalingChannels", cors: true }, detective: { name: "Detective" }, codestarconnections: { prefix: "codestar-connections", name: "CodeStarconnections" }, synthetics: { name: "Synthetics" }, iotsitewise: { name: "IoTSiteWise" }, macie2: { name: "Macie2" }, codeartifact: { name: "CodeArtifact" }, honeycode: { name: "Honeycode" }, ivs: { name: "IVS" }, braket: { name: "Braket" }, identitystore: { name: "IdentityStore" }, appflow: { name: "Appflow" }, redshiftdata: { prefix: "redshift-data", name: "RedshiftData" }, ssoadmin: { prefix: "sso-admin", name: "SSOAdmin" }, timestreamquery: { prefix: "timestream-query", name: "TimestreamQuery" }, timestreamwrite: { prefix: "timestream-write", name: "TimestreamWrite" }, s3outposts: { name: "S3Outposts" }, databrew: { name: "DataBrew" }, servicecatalogappregistry: { prefix: "servicecatalog-appregistry", name: "ServiceCatalogAppRegistry" }, networkfirewall: { prefix: "network-firewall", name: "NetworkFirewall" }, mwaa: { name: "MWAA" }, amplifybackend: { name: "AmplifyBackend" }, appintegrations: { name: "AppIntegrations" }, connectcontactlens: { prefix: "connect-contact-lens", name: "ConnectContactLens" }, devopsguru: { prefix: "devops-guru", name: "DevOpsGuru" }, ecrpublic: { prefix: "ecr-public", name: "ECRPUBLIC" }, lookoutvision: { name: "LookoutVision" }, sagemakerfeaturestoreruntime: { prefix: "sagemaker-featurestore-runtime", name: "SageMakerFeatureStoreRuntime" }, customerprofiles: { prefix: "customer-profiles", name: "CustomerProfiles" }, auditmanager: { name: "AuditManager" }, emrcontainers: { prefix: "emr-containers", name: "EMRcontainers" }, healthlake: { name: "HealthLake" }, sagemakeredge: { prefix: "sagemaker-edge", name: "SagemakerEdge" }, amp: { name: "Amp" }, greengrassv2: { name: "GreengrassV2" }, iotdeviceadvisor: { name: "IotDeviceAdvisor" }, iotfleethub: { name: "IoTFleetHub" }, iotwireless: { name: "IoTWireless" }, location: { name: "Location", cors: true }, wellarchitected: { name: "WellArchitected" }, lexmodelsv2: { prefix: "models.lex.v2", name: "LexModelsV2" }, lexruntimev2: { prefix: "runtime.lex.v2", name: "LexRuntimeV2", cors: true }, fis: { name: "Fis" }, lookoutmetrics: { name: "LookoutMetrics" }, mgn: { name: "Mgn" }, lookoutequipment: { name: "LookoutEquipment" }, nimble: { name: "Nimble" }, finspace: { name: "Finspace" }, finspacedata: { prefix: "finspace-data", name: "Finspacedata" }, ssmcontacts: { prefix: "ssm-contacts", name: "SSMContacts" }, ssmincidents: { prefix: "ssm-incidents", name: "SSMIncidents" }, applicationcostprofiler: { name: "ApplicationCostProfiler" }, apprunner: { name: "AppRunner" }, proton: { name: "Proton" }, route53recoverycluster: { prefix: "route53-recovery-cluster", name: "Route53RecoveryCluster" }, route53recoverycontrolconfig: { prefix: "route53-recovery-control-config", name: "Route53RecoveryControlConfig" }, route53recoveryreadiness: { prefix: "route53-recovery-readiness", name: "Route53RecoveryReadiness" }, chimesdkidentity: { prefix: "chime-sdk-identity", name: "ChimeSDKIdentity" }, chimesdkmessaging: { prefix: "chime-sdk-messaging", name: "ChimeSDKMessaging" }, snowdevicemanagement: { prefix: "snow-device-management", name: "SnowDeviceManagement" }, memorydb: { name: "MemoryDB" }, opensearch: { name: "OpenSearch" }, kafkaconnect: { name: "KafkaConnect" }, voiceid: { prefix: "voice-id", name: "VoiceID" }, wisdom: { name: "Wisdom" }, account: { name: "Account" }, cloudcontrol: { name: "CloudControl" }, grafana: { name: "Grafana" }, panorama: { name: "Panorama" }, chimesdkmeetings: { prefix: "chime-sdk-meetings", name: "ChimeSDKMeetings" }, resiliencehub: { name: "Resiliencehub" }, migrationhubstrategy: { name: "MigrationHubStrategy" }, appconfigdata: { name: "AppConfigData" }, drs: { name: "Drs" }, migrationhubrefactorspaces: { prefix: "migration-hub-refactor-spaces", name: "MigrationHubRefactorSpaces" }, evidently: { name: "Evidently" }, inspector2: { name: "Inspector2" }, rbin: { name: "Rbin" }, rum: { name: "RUM" }, backupgateway: { prefix: "backup-gateway", name: "BackupGateway" }, iottwinmaker: { name: "IoTTwinMaker" }, workspacesweb: { prefix: "workspaces-web", name: "WorkSpacesWeb" }, amplifyuibuilder: { name: "AmplifyUIBuilder" }, keyspaces: { name: "Keyspaces" }, billingconductor: { name: "Billingconductor" }, gamesparks: { name: "GameSparks" }, pinpointsmsvoicev2: { prefix: "pinpoint-sms-voice-v2", name: "PinpointSMSVoiceV2" }, ivschat: { name: "Ivschat" }, chimesdkmediapipelines: { prefix: "chime-sdk-media-pipelines", name: "ChimeSDKMediaPipelines" }, emrserverless: { prefix: "emr-serverless", name: "EMRServerless" }, m2: { name: "M2" }, connectcampaigns: { name: "ConnectCampaigns" }, redshiftserverless: { prefix: "redshift-serverless", name: "RedshiftServerless" }, rolesanywhere: { name: "RolesAnywhere" }, licensemanagerusersubscriptions: { prefix: "license-manager-user-subscriptions", name: "LicenseManagerUserSubscriptions" }, backupstorage: { name: "BackupStorage" }, privatenetworks: { name: "PrivateNetworks" }, supportapp: { prefix: "support-app", name: "SupportApp" }, controltower: { name: "ControlTower" }, iotfleetwise: { name: "IoTFleetWise" }, migrationhuborchestrator: { name: "MigrationHubOrchestrator" }, connectcases: { name: "ConnectCases" }, resourceexplorer2: { prefix: "resource-explorer-2", name: "ResourceExplorer2" }, scheduler: { name: "Scheduler" }, chimesdkvoice: { prefix: "chime-sdk-voice", name: "ChimeSDKVoice" }, iotroborunner: { prefix: "iot-roborunner", name: "IoTRoboRunner" }, ssmsap: { prefix: "ssm-sap", name: "SsmSap" }, oam: { name: "OAM" }, arczonalshift: { prefix: "arc-zonal-shift", name: "ARCZonalShift" }, omics: { name: "Omics" }, opensearchserverless: { name: "OpenSearchServerless" }, securitylake: { name: "SecurityLake" }, simspaceweaver: { name: "SimSpaceWeaver" }, docdbelastic: { prefix: "docdb-elastic", name: "DocDBElastic" }, sagemakergeospatial: { prefix: "sagemaker-geospatial", name: "SageMakerGeospatial" }, codecatalyst: { name: "CodeCatalyst" }, pipes: { name: "Pipes" }, sagemakermetrics: { prefix: "sagemaker-metrics", name: "SageMakerMetrics" }, kinesisvideowebrtcstorage: { prefix: "kinesis-video-webrtc-storage", name: "KinesisVideoWebRTCStorage" }, licensemanagerlinuxsubscriptions: { prefix: "license-manager-linux-subscriptions", name: "LicenseManagerLinuxSubscriptions" }, kendraranking: { prefix: "kendra-ranking", name: "KendraRanking" }, cleanrooms: { name: "CleanRooms" }, cloudtraildata: { prefix: "cloudtrail-data", name: "CloudTrailData" }, tnb: { name: "Tnb" }, internetmonitor: { name: "InternetMonitor" }, ivsrealtime: { prefix: "ivs-realtime", name: "IVSRealTime" }, vpclattice: { prefix: "vpc-lattice", name: "VPCLattice" }, osis: { name: "OSIS" } };
  }
});

// node_modules/aws-cdk-lib/aws-events-targets/lib/aws-api.js
var require_aws_api = __commonJS({
  "node_modules/aws-cdk-lib/aws-events-targets/lib/aws-api.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AwsApi = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var path = require("path");
    var sdk_api_metadata_generated_1 = require_sdk_api_metadata_generated();
    var util_1 = require_util17();
    var events = require_aws_events();
    var iam = require_aws_iam();
    var lambda2 = require_aws_lambda();
    var core_1 = require_core2();
    var awsSdkMetadata = sdk_api_metadata_generated_1.metadata;
    var AwsApi = class _AwsApi {
      constructor(props) {
        this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_targets_AwsApiProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AwsApi), error;
        }
      }
      bind(rule, id) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_IRule(rule);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        const handler2 = new lambda2.SingletonFunction(rule, `${rule.node.id}${id}Handler`, { code: lambda2.Code.fromAsset(path.join(__dirname, "aws-api-handler"), { exclude: ["*.ts"] }), runtime: lambda2.Runtime.NODEJS_14_X, handler: "index.handler", uuid: "b4cf1abd-4e4f-4bc6-9944-1af7ccd9ec37", lambdaPurpose: "AWS" });
        checkServiceExists(this.props.service, handler2), this.props.policyStatement ? handler2.addToRolePolicy(this.props.policyStatement) : handler2.addToRolePolicy(new iam.PolicyStatement({ actions: [awsSdkToIamAction(this.props.service, this.props.action)], resources: ["*"] })), (0, util_1.addLambdaPermission)(rule, handler2);
        const input = { service: this.props.service, action: this.props.action, parameters: this.props.parameters, catchErrorPattern: this.props.catchErrorPattern, apiVersion: this.props.apiVersion };
        return { arn: handler2.functionArn, input: events.RuleTargetInput.fromObject(input), targetResource: handler2 };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AwsApi[_a] = { fqn: "aws-cdk-lib.aws_events_targets.AwsApi", version: "2.80.0" }, exports2.AwsApi = AwsApi;
    function checkServiceExists(service, handler2) {
      awsSdkMetadata[service.toLowerCase()] || core_1.Annotations.of(handler2).addWarning(`Service ${service} does not exist in the AWS SDK. Check the list of available services and actions from https://docs.aws.amazon.com/AWSJavaScriptSDK/latest/index.html`);
    }
    function awsSdkToIamAction(service, action) {
      const srv = service.toLowerCase(), iamService = awsSdkMetadata[srv].prefix || srv, iamAction = action.charAt(0).toUpperCase() + action.slice(1);
      return `${iamService}:${iamAction}`;
    }
  }
});

// node_modules/aws-cdk-lib/aws-events-targets/lib/lambda.js
var require_lambda7 = __commonJS({
  "node_modules/aws-cdk-lib/aws-events-targets/lib/lambda.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LambdaFunction = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var util_1 = require_util17();
    var LambdaFunction = class _LambdaFunction {
      constructor(handler2, props = {}) {
        this.handler = handler2, this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_IFunction(handler2), jsiiDeprecationWarnings.aws_cdk_lib_aws_events_targets_LambdaFunctionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _LambdaFunction), error;
        }
      }
      bind(rule, _id) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_IRule(rule);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return (0, util_1.addLambdaPermission)(rule, this.handler), this.props.deadLetterQueue && (0, util_1.addToDeadLetterQueueResourcePolicy)(rule, this.props.deadLetterQueue), { ...(0, util_1.bindBaseTargetConfig)(this.props), arn: this.handler.functionArn, input: this.props.event, targetResource: this.handler };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LambdaFunction[_a] = { fqn: "aws-cdk-lib.aws_events_targets.LambdaFunction", version: "2.80.0" }, exports2.LambdaFunction = LambdaFunction;
  }
});

// node_modules/aws-cdk-lib/aws-events-targets/lib/ecs-task-properties.js
var require_ecs_task_properties = __commonJS({
  "node_modules/aws-cdk-lib/aws-events-targets/lib/ecs-task-properties.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-events-targets/lib/ecs-task.js
var require_ecs_task = __commonJS({
  "node_modules/aws-cdk-lib/aws-events-targets/lib/ecs-task.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EcsTask = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var util_1 = require_util17();
    var ec2 = require_aws_ec2();
    var ecs = require_aws_ecs();
    var events = require_aws_events();
    var iam = require_aws_iam();
    var cdk = require_core2();
    var EcsTask = class _EcsTask {
      constructor(props) {
        this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_targets_EcsTaskProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EcsTask), error;
        }
        if (props.securityGroup !== void 0 && props.securityGroups !== void 0)
          throw new Error("Only one of SecurityGroup or SecurityGroups can be populated.");
        this.cluster = props.cluster, this.taskDefinition = props.taskDefinition, this.taskCount = props.taskCount ?? 1, this.platformVersion = props.platformVersion;
        const propagateTagsValidValues = [ecs.PropagatedTagSource.TASK_DEFINITION, ecs.PropagatedTagSource.NONE];
        if (props.propagateTags && !propagateTagsValidValues.includes(props.propagateTags))
          throw new Error("When propagateTags is passed, it must be set to TASK_DEFINITION or NONE.");
        this.propagateTags = props.propagateTags, this.role = props.role ?? (0, util_1.singletonEventRole)(this.taskDefinition);
        for (const stmt of this.createEventRolePolicyStatements())
          this.role.addToPrincipalPolicy(stmt);
        if (this.tags = props.tags, this.taskDefinition.networkMode !== ecs.NetworkMode.AWS_VPC) {
          (props.securityGroup !== void 0 || props.securityGroups !== void 0) && cdk.Annotations.of(this.taskDefinition).addWarning("security groups are ignored when network mode is not awsvpc");
          return;
        }
        if (props.securityGroups) {
          this.securityGroups = props.securityGroups;
          return;
        }
        if (!constructs_1.Construct.isConstruct(this.taskDefinition))
          throw new Error("Cannot create a security group for ECS task. The task definition in ECS task is not a Construct. Please pass a taskDefinition as a Construct in EcsTaskProps.");
        let securityGroup = props.securityGroup || this.taskDefinition.node.tryFindChild("SecurityGroup");
        securityGroup = securityGroup || new ec2.SecurityGroup(this.taskDefinition, "SecurityGroup", { vpc: this.props.cluster.vpc }), this.securityGroup = securityGroup, this.securityGroups = [securityGroup];
      }
      bind(_rule, _id) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_IRule(_rule);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        const arn = this.cluster.clusterArn, role = this.role, input = { containerOverrides: this.props.containerOverrides && this.props.containerOverrides.map(({ containerName, ...overrides }) => ({ name: containerName, ...overrides })) }, taskCount = this.taskCount, taskDefinitionArn = this.taskDefinition.taskDefinitionArn, propagateTags = this.propagateTags, tagList = this.tags, subnetSelection = this.props.subnetSelection || { subnetType: ec2.SubnetType.PRIVATE_WITH_EGRESS }, assignPublicIp = subnetSelection.subnetType === ec2.SubnetType.PUBLIC ? "ENABLED" : "DISABLED", baseEcsParameters = { taskCount, taskDefinitionArn, propagateTags, tagList }, ecsParameters = this.taskDefinition.networkMode === ecs.NetworkMode.AWS_VPC ? { ...baseEcsParameters, launchType: this.taskDefinition.isEc2Compatible ? "EC2" : "FARGATE", platformVersion: this.platformVersion, networkConfiguration: { awsVpcConfiguration: { subnets: this.props.cluster.vpc.selectSubnets(subnetSelection).subnetIds, assignPublicIp, securityGroups: this.securityGroups && this.securityGroups.map((sg) => sg.securityGroupId) } } } : baseEcsParameters;
        return this.props.deadLetterQueue && (0, util_1.addToDeadLetterQueueResourcePolicy)(_rule, this.props.deadLetterQueue), { ...(0, util_1.bindBaseTargetConfig)(this.props), arn, role, ecsParameters, input: events.RuleTargetInput.fromObject(input), targetResource: this.taskDefinition };
      }
      createEventRolePolicyStatements() {
        const policyStatements = [new iam.PolicyStatement({ actions: ["ecs:RunTask"], resources: [this.taskDefinition.taskDefinitionArn], conditions: { ArnEquals: { "ecs:cluster": this.cluster.clusterArn } } })];
        return this.taskDefinition.executionRole !== void 0 && policyStatements.push(new iam.PolicyStatement({ actions: ["iam:PassRole"], resources: [this.taskDefinition.executionRole.roleArn] })), this.taskDefinition.isFargateCompatible && policyStatements.push(new iam.PolicyStatement({ actions: ["iam:PassRole"], resources: [this.taskDefinition.taskRole.roleArn] })), policyStatements;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EcsTask[_a] = { fqn: "aws-cdk-lib.aws_events_targets.EcsTask", version: "2.80.0" }, exports2.EcsTask = EcsTask;
  }
});

// node_modules/aws-cdk-lib/aws-events-targets/lib/event-bus.js
var require_event_bus2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-events-targets/lib/event-bus.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EventBus = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var util_1 = require_util17();
    var iam = require_aws_iam();
    var EventBus = class _EventBus {
      constructor(eventBus, props = {}) {
        this.eventBus = eventBus, this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_IEventBus(eventBus), jsiiDeprecationWarnings.aws_cdk_lib_aws_events_targets_EventBusProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EventBus), error;
        }
      }
      bind(rule, _id) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_IRule(rule);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        const role = this.props.role ?? (0, util_1.singletonEventRole)(rule);
        return role.addToPrincipalPolicy(this.putEventStatement()), this.props.deadLetterQueue && (0, util_1.addToDeadLetterQueueResourcePolicy)(rule, this.props.deadLetterQueue), { arn: this.eventBus.eventBusArn, deadLetterConfig: this.props.deadLetterQueue ? { arn: this.props.deadLetterQueue?.queueArn } : void 0, role };
      }
      putEventStatement() {
        return new iam.PolicyStatement({ actions: ["events:PutEvents"], resources: [this.eventBus.eventBusArn] });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EventBus[_a] = { fqn: "aws-cdk-lib.aws_events_targets.EventBus", version: "2.80.0" }, exports2.EventBus = EventBus;
  }
});

// node_modules/aws-cdk-lib/aws-events-targets/lib/state-machine.js
var require_state_machine3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-events-targets/lib/state-machine.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SfnStateMachine = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var util_1 = require_util17();
    var SfnStateMachine = class _SfnStateMachine {
      constructor(machine, props = {}) {
        this.machine = machine, this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_IStateMachine(machine), jsiiDeprecationWarnings.aws_cdk_lib_aws_events_targets_SfnStateMachineProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SfnStateMachine), error;
        }
        this.role = props.role ?? (0, util_1.singletonEventRole)(machine), machine.grantStartExecution(this.role);
      }
      bind(_rule, _id) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_IRule(_rule);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return this.props.deadLetterQueue && (0, util_1.addToDeadLetterQueueResourcePolicy)(_rule, this.props.deadLetterQueue), { ...(0, util_1.bindBaseTargetConfig)(this.props), arn: this.machine.stateMachineArn, role: this.role, input: this.props.input, targetResource: this.machine };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SfnStateMachine[_a] = { fqn: "aws-cdk-lib.aws_events_targets.SfnStateMachine", version: "2.80.0" }, exports2.SfnStateMachine = SfnStateMachine;
  }
});

// node_modules/aws-cdk-lib/aws-events-targets/lib/kinesis-stream.js
var require_kinesis_stream = __commonJS({
  "node_modules/aws-cdk-lib/aws-events-targets/lib/kinesis-stream.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.KinesisStream = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var util_1 = require_util17();
    var iam = require_aws_iam();
    var KinesisStream = class _KinesisStream {
      constructor(stream, props = {}) {
        this.stream = stream, this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kinesis_IStream(stream), jsiiDeprecationWarnings.aws_cdk_lib_aws_events_targets_KinesisStreamProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _KinesisStream), error;
        }
      }
      bind(_rule, _id) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_IRule(_rule);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        const role = (0, util_1.singletonEventRole)(this.stream);
        return role.addToPrincipalPolicy(new iam.PolicyStatement({ actions: ["kinesis:PutRecord", "kinesis:PutRecords"], resources: [this.stream.streamArn] })), { arn: this.stream.streamArn, role, input: this.props.message, targetResource: this.stream, kinesisParameters: this.props.partitionKeyPath ? { partitionKeyPath: this.props.partitionKeyPath } : void 0 };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, KinesisStream[_a] = { fqn: "aws-cdk-lib.aws_events_targets.KinesisStream", version: "2.80.0" }, exports2.KinesisStream = KinesisStream;
  }
});

// node_modules/aws-cdk-lib/aws-events-targets/lib/log-group-resource-policy.js
var require_log_group_resource_policy2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-events-targets/lib/log-group-resource-policy.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LogGroupResourcePolicy = void 0;
    var iam = require_aws_iam();
    var cdk = require_core2();
    var cr = require_custom_resources();
    var LogGroupResourcePolicy = class extends cr.AwsCustomResource {
      constructor(scope, id, props) {
        const policyDocument = new iam.PolicyDocument({ statements: props.policyStatements });
        let policyName = props.policyName || cdk.Lazy.string({ produce: () => cdk.Names.uniqueId(this) });
        super(scope, id, { resourceType: "Custom::CloudwatchLogResourcePolicy", onUpdate: { service: "CloudWatchLogs", action: "putResourcePolicy", parameters: { policyName, policyDocument: JSON.stringify(policyDocument) }, physicalResourceId: cr.PhysicalResourceId.of(id) }, onDelete: { service: "CloudWatchLogs", action: "deleteResourcePolicy", parameters: { policyName }, ignoreErrorCodesMatching: "400" }, policy: cr.AwsCustomResourcePolicy.fromSdkCalls({ resources: cr.AwsCustomResourcePolicy.ANY_RESOURCE }) });
      }
    };
    exports2.LogGroupResourcePolicy = LogGroupResourcePolicy;
  }
});

// node_modules/aws-cdk-lib/aws-events-targets/lib/log-group.js
var require_log_group2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-events-targets/lib/log-group.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CloudWatchLogGroup = exports2.LogGroupTargetInput = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var log_group_resource_policy_1 = require_log_group_resource_policy2();
    var util_1 = require_util17();
    var aws_events_1 = require_aws_events();
    var iam = require_aws_iam();
    var cdk = require_core2();
    var core_1 = require_core2();
    var LogGroupTargetInput = class {
      static fromObject(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_targets_LogGroupTargetInputOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromObject), error;
        }
        return aws_events_1.RuleTargetInput.fromObject({ timestamp: options?.timestamp ?? aws_events_1.EventField.time, message: options?.message ?? aws_events_1.EventField.detailType });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LogGroupTargetInput[_a] = { fqn: "aws-cdk-lib.aws_events_targets.LogGroupTargetInput", version: "2.80.0" }, exports2.LogGroupTargetInput = LogGroupTargetInput;
    var CloudWatchLogGroup = class _CloudWatchLogGroup {
      constructor(logGroup, props = {}) {
        this.logGroup = logGroup, this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_logs_ILogGroup(logGroup), jsiiDeprecationWarnings.aws_cdk_lib_aws_events_targets_LogGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CloudWatchLogGroup), error;
        }
      }
      bind(_rule, _id) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_IRule(_rule);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        const resourcePolicyId = `EventsLogGroupPolicy${cdk.Names.nodeUniqueId(_rule.node)}`, logGroupStack = cdk.Stack.of(this.logGroup);
        if (this.props.event && this.props.logEvent)
          throw new Error('Only one of "event" or "logEvent" can be specified');
        if (this.target = this.props.event?.bind(_rule), this.target?.inputPath || this.target?.input)
          throw new Error("CloudWatchLogGroup targets does not support input or inputPath");
        return _rule.node.addValidation({ validate: () => this.validateInputTemplate() }), this.logGroup.node.tryFindChild(resourcePolicyId) || new log_group_resource_policy_1.LogGroupResourcePolicy(logGroupStack, resourcePolicyId, { policyStatements: [new iam.PolicyStatement({ effect: iam.Effect.ALLOW, actions: ["logs:PutLogEvents", "logs:CreateLogStream"], resources: [this.logGroup.logGroupArn], principals: [new iam.ServicePrincipal("events.amazonaws.com")] })] }), { ...(0, util_1.bindBaseTargetConfig)(this.props), arn: logGroupStack.formatArn({ service: "logs", resource: "log-group", arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME, resourceName: this.logGroup.logGroupName }), input: this.props.event ?? this.props.logEvent, targetResource: this.logGroup };
      }
      validateInputTemplate() {
        if (this.target?.inputTemplate) {
          const resolvedTemplate = core_1.Stack.of(this.logGroup).resolve(this.target.inputTemplate);
          if (typeof resolvedTemplate == "string") {
            const quotedTemplate = resolvedTemplate.replace(new RegExp("(<.*?>)", "g"), '"$1"');
            try {
              const inputTemplate = JSON.parse(quotedTemplate), inputTemplateKeys = Object.keys(inputTemplate);
              if (inputTemplateKeys.length !== 2 || !inputTemplateKeys.includes("timestamp") || !inputTemplateKeys.includes("message"))
                return ["CloudWatchLogGroup targets only support input templates in the format {timestamp: <timestamp>, message: <message>}"];
            } catch (e) {
              return [`Could not parse input template as JSON.
CloudWatchLogGroup targets only support input templates in the format {timestamp: <timestamp>, message: <message>}`, e];
            }
          }
        }
        return [];
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CloudWatchLogGroup[_b] = { fqn: "aws-cdk-lib.aws_events_targets.CloudWatchLogGroup", version: "2.80.0" }, exports2.CloudWatchLogGroup = CloudWatchLogGroup;
  }
});

// node_modules/aws-cdk-lib/aws-events-targets/lib/kinesis-firehose-stream.js
var require_kinesis_firehose_stream = __commonJS({
  "node_modules/aws-cdk-lib/aws-events-targets/lib/kinesis-firehose-stream.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.KinesisFirehoseStream = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var util_1 = require_util17();
    var iam = require_aws_iam();
    var KinesisFirehoseStream = class _KinesisFirehoseStream {
      constructor(stream, props = {}) {
        this.stream = stream, this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStream(stream), jsiiDeprecationWarnings.aws_cdk_lib_aws_events_targets_KinesisFirehoseStreamProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _KinesisFirehoseStream), error;
        }
      }
      bind(_rule, _id) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_IRule(_rule);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        const role = (0, util_1.singletonEventRole)(this.stream);
        return role.addToPrincipalPolicy(new iam.PolicyStatement({ actions: ["firehose:PutRecord", "firehose:PutRecordBatch"], resources: [this.stream.attrArn] })), { arn: this.stream.attrArn, role, input: this.props.message, targetResource: this.stream };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, KinesisFirehoseStream[_a] = { fqn: "aws-cdk-lib.aws_events_targets.KinesisFirehoseStream", version: "2.80.0" }, exports2.KinesisFirehoseStream = KinesisFirehoseStream;
  }
});

// node_modules/aws-cdk-lib/aws-events-targets/lib/api-gateway.js
var require_api_gateway = __commonJS({
  "node_modules/aws-cdk-lib/aws-events-targets/lib/api-gateway.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ApiGateway = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var util_1 = require_util17();
    var iam = require_aws_iam();
    var ApiGateway = class _ApiGateway {
      constructor(restApi, props) {
        this.restApi = restApi, this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_RestApi(restApi), jsiiDeprecationWarnings.aws_cdk_lib_aws_events_targets_ApiGatewayProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ApiGateway), error;
        }
      }
      bind(rule, _id) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_IRule(rule);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        if (this.props?.deadLetterQueue && (0, util_1.addToDeadLetterQueueResourcePolicy)(rule, this.props.deadLetterQueue), (this.props?.path?.match(/\*/g)?.length ?? 0) !== (this.props?.pathParameterValues || []).length)
          throw new Error("The number of wildcards in the path does not match the number of path pathParameterValues.");
        const restApiArn = this.restApi.arnForExecuteApi(this.props?.method, this.props?.path || "/", this.props?.stage || this.restApi.deploymentStage.stageName), role = this.props?.eventRole || (0, util_1.singletonEventRole)(this.restApi);
        return role.addToPrincipalPolicy(new iam.PolicyStatement({ resources: [restApiArn], actions: ["execute-api:Invoke", "execute-api:ManageConnections"] })), { ...this.props ? (0, util_1.bindBaseTargetConfig)(this.props) : {}, arn: restApiArn, role, deadLetterConfig: this.props?.deadLetterQueue && { arn: this.props.deadLetterQueue?.queueArn }, input: this.props?.postBody, targetResource: this.restApi, httpParameters: { headerParameters: this.props?.headerParameters, queryStringParameters: this.props?.queryStringParameters, pathParameterValues: this.props?.pathParameterValues } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ApiGateway[_a] = { fqn: "aws-cdk-lib.aws_events_targets.ApiGateway", version: "2.80.0" }, exports2.ApiGateway = ApiGateway;
  }
});

// node_modules/aws-cdk-lib/aws-events-targets/lib/api-destination.js
var require_api_destination2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-events-targets/lib/api-destination.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ApiDestination = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var util_1 = require_util17();
    var iam = require_aws_iam();
    var ApiDestination = class _ApiDestination {
      constructor(apiDestination, props = {}) {
        this.apiDestination = apiDestination, this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_IApiDestination(apiDestination), jsiiDeprecationWarnings.aws_cdk_lib_aws_events_targets_ApiDestinationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ApiDestination), error;
        }
      }
      bind(_rule, _id) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_IRule(_rule);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        const httpParameters = this.props.headerParameters ?? this.props.pathParameterValues ?? this.props.queryStringParameters ? { headerParameters: this.props.headerParameters, pathParameterValues: this.props.pathParameterValues, queryStringParameters: this.props.queryStringParameters } : void 0;
        this.props?.deadLetterQueue && (0, util_1.addToDeadLetterQueueResourcePolicy)(_rule, this.props.deadLetterQueue);
        const role = this.props?.eventRole ?? (0, util_1.singletonEventRole)(this.apiDestination);
        return role.addToPrincipalPolicy(new iam.PolicyStatement({ resources: [this.apiDestination.apiDestinationArn], actions: ["events:InvokeApiDestination"] })), { ...this.props ? (0, util_1.bindBaseTargetConfig)(this.props) : {}, arn: this.apiDestination.apiDestinationArn, role, input: this.props.event, targetResource: this.apiDestination, httpParameters };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ApiDestination[_a] = { fqn: "aws-cdk-lib.aws_events_targets.ApiDestination", version: "2.80.0" }, exports2.ApiDestination = ApiDestination;
  }
});

// node_modules/aws-cdk-lib/aws-events-targets/lib/index.js
var require_lib84 = __commonJS({
  "node_modules/aws-cdk-lib/aws-events-targets/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_batch2(), exports2), __exportStar(require_codepipeline2(), exports2), __exportStar(require_sns3(), exports2), __exportStar(require_sqs4(), exports2), __exportStar(require_codebuild2(), exports2), __exportStar(require_aws_api(), exports2), __exportStar(require_lambda7(), exports2), __exportStar(require_ecs_task_properties(), exports2), __exportStar(require_ecs_task(), exports2), __exportStar(require_event_bus2(), exports2), __exportStar(require_state_machine3(), exports2), __exportStar(require_kinesis_stream(), exports2), __exportStar(require_log_group2(), exports2), __exportStar(require_kinesis_firehose_stream(), exports2), __exportStar(require_api_gateway(), exports2), __exportStar(require_api_destination2(), exports2), __exportStar(require_util17(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-events-targets/index.js
var require_aws_events_targets = __commonJS({
  "node_modules/aws-cdk-lib/aws-events-targets/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib84(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/codecommit/source-action.js
var require_source_action3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/codecommit/source-action.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CodeCommitSourceAction = exports2.CodeCommitTrigger = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var codepipeline = require_aws_codepipeline();
    var targets = require_aws_events_targets();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var action_1 = require_action2();
    var common_1 = require_common4();
    var CodeCommitTrigger;
    (function(CodeCommitTrigger2) {
      CodeCommitTrigger2.NONE = "None", CodeCommitTrigger2.POLL = "Poll", CodeCommitTrigger2.EVENTS = "Events";
    })(CodeCommitTrigger = exports2.CodeCommitTrigger || (exports2.CodeCommitTrigger = {}));
    var CodeCommitSourceAction = class _CodeCommitSourceAction extends action_1.Action {
      constructor(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_actions_CodeCommitSourceActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CodeCommitSourceAction), error;
        }
        const branch = props.branch ?? "master";
        if (!branch)
          throw new Error("'branch' parameter cannot be an empty string");
        props.codeBuildCloneOutput === true && props.output.setMetadata(_CodeCommitSourceAction._FULL_CLONE_ARN_PROPERTY, props.repository.repositoryArn), super({ ...props, resource: props.repository, category: codepipeline.ActionCategory.SOURCE, provider: "CodeCommit", artifactBounds: (0, common_1.sourceArtifactBounds)(), outputs: [props.output] }), this.branch = branch, this.props = props;
      }
      get variables() {
        return { repositoryName: this.variableExpression("RepositoryName"), branchName: this.variableExpression("BranchName"), authorDate: this.variableExpression("AuthorDate"), committerDate: this.variableExpression("CommitterDate"), commitId: this.variableExpression("CommitId"), commitMessage: this.variableExpression("CommitMessage") };
      }
      bound(_scope, stage, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_IStage(stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_ActionBindOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bound), error;
        }
        if (this.props.trigger === void 0 || this.props.trigger === CodeCommitTrigger.EVENTS) {
          const eventId = this.generateEventId(stage);
          this.props.repository.onCommit(eventId, { target: new targets.CodePipeline(stage.pipeline, { eventRole: this.props.eventRole }), branches: [this.branch], crossStackScope: stage.pipeline });
        }
        return options.bucket.grantReadWrite(options.role), core_1.Token.compareStrings(this.props.repository.env.account, core_1.Stack.of(stage.pipeline).account) === core_1.TokenComparison.DIFFERENT && options.bucket.grantPutAcl(options.role), options.role.addToPrincipalPolicy(new iam.PolicyStatement({ resources: [this.props.repository.repositoryArn], actions: ["codecommit:GetBranch", "codecommit:GetCommit", "codecommit:UploadArchive", "codecommit:GetUploadArchiveStatus", "codecommit:CancelUploadArchive", ...this.props.codeBuildCloneOutput === true ? ["codecommit:GetRepository"] : []] })), { configuration: { RepositoryName: this.props.repository.repositoryName, BranchName: this.branch, PollForSourceChanges: this.props.trigger === CodeCommitTrigger.POLL, OutputArtifactFormat: this.props.codeBuildCloneOutput === true ? "CODEBUILD_CLONE_REF" : void 0 } };
      }
      generateEventId(stage) {
        const baseId = core_1.Names.nodeUniqueId(stage.pipeline.node);
        if (core_1.Token.isUnresolved(this.branch)) {
          let candidate = "", counter = 0;
          do
            candidate = this.eventIdFromPrefix(`${baseId}${counter}`), counter += 1;
          while (this.props.repository.node.tryFindChild(candidate) !== void 0);
          return candidate;
        } else {
          const branchIdDisambiguator = this.branch === "master" ? "" : `-${this.branch}-`;
          return this.eventIdFromPrefix(`${baseId}${branchIdDisambiguator}`);
        }
      }
      eventIdFromPrefix(eventIdPrefix) {
        return `${eventIdPrefix}EventRule`;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CodeCommitSourceAction[_a] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.CodeCommitSourceAction", version: "2.80.0" }, CodeCommitSourceAction._FULL_CLONE_ARN_PROPERTY = "CodeCommitCloneRepositoryArn", exports2.CodeCommitSourceAction = CodeCommitSourceAction;
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/codebuild/build-action.js
var require_build_action = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/codebuild/build-action.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CodeBuildAction = exports2.CodeBuildActionType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var __1 = require_lib85();
    var codebuild = require_aws_codebuild();
    var codepipeline = require_aws_codepipeline();
    var iam = require_aws_iam();
    var cdk = require_core2();
    var action_1 = require_action2();
    var source_action_1 = require_source_action3();
    var CodeBuildActionType;
    (function(CodeBuildActionType2) {
      CodeBuildActionType2[CodeBuildActionType2.BUILD = 0] = "BUILD", CodeBuildActionType2[CodeBuildActionType2.TEST = 1] = "TEST";
    })(CodeBuildActionType = exports2.CodeBuildActionType || (exports2.CodeBuildActionType = {}));
    var CodeBuildAction = class _CodeBuildAction extends action_1.Action {
      constructor(props) {
        super({ ...props, category: props.type === CodeBuildActionType.TEST ? codepipeline.ActionCategory.TEST : codepipeline.ActionCategory.BUILD, provider: "CodeBuild", artifactBounds: { minInputs: 1, maxInputs: 5, minOutputs: 0, maxOutputs: 5 }, inputs: [props.input, ...props.extraInputs || []], resource: props.project });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_actions_CodeBuildActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CodeBuildAction), error;
        }
        this.props = props;
      }
      variable(variableName) {
        return this.variableExpression(variableName);
      }
      bound(scope, _stage, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_IStage(_stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_ActionBindOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bound), error;
        }
        if ((this.actionProperties.outputs || []).length > 0) {
          const pipelineStack = cdk.Stack.of(scope), projectStack = cdk.Stack.of(this.props.project);
          if (pipelineStack.account !== projectStack.account)
            throw new Error("A cross-account CodeBuild action cannot have outputs. This is a known CodeBuild limitation. See https://github.com/aws/aws-cdk/issues/4169 for details");
        }
        options.role.addToPolicy(new iam.PolicyStatement({ resources: [this.props.project.projectArn], actions: [`codebuild:${this.props.executeBatchBuild ? "BatchGetBuildBatches" : "BatchGetBuilds"}`, `codebuild:${this.props.executeBatchBuild ? "StartBuildBatch" : "StartBuild"}`, `codebuild:${this.props.executeBatchBuild ? "StopBuildBatch" : "StopBuild"}`] })), this.props.project.role && ((this.actionProperties.outputs || []).length > 0 ? options.bucket.grantReadWrite(this.props.project) : options.bucket.grantRead(this.props.project)), this.props.project instanceof codebuild.Project && this.props.project.bindToCodePipeline(scope, { artifactBucket: options.bucket });
        for (const inputArtifact of this.actionProperties.inputs || []) {
          const connectionArn = inputArtifact.getMetadata(__1.CodeStarConnectionsSourceAction._CONNECTION_ARN_PROPERTY);
          connectionArn && this.props.project.addToRolePolicy(new iam.PolicyStatement({ actions: ["codestar-connections:UseConnection"], resources: [connectionArn] }));
          const codecommitRepositoryArn = inputArtifact.getMetadata(source_action_1.CodeCommitSourceAction._FULL_CLONE_ARN_PROPERTY);
          codecommitRepositoryArn && this.props.project.addToRolePolicy(new iam.PolicyStatement({ actions: ["codecommit:GitPull"], resources: [codecommitRepositoryArn] }));
        }
        const configuration = { ProjectName: this.props.project.projectName, EnvironmentVariables: this.props.environmentVariables && cdk.Stack.of(scope).toJsonString(codebuild.Project.serializeEnvVariables(this.props.environmentVariables, this.props.checkSecretsInPlainTextEnvVariables ?? true, this.props.project)) };
        return (this.actionProperties.inputs || []).length > 1 && (configuration.PrimarySource = cdk.Lazy.string({ produce: () => this.props.input.artifactName })), this.props.executeBatchBuild && (configuration.BatchEnabled = "true", this.props.project.enableBatchBuilds(), this.props.combineBatchBuildArtifacts && (configuration.CombineArtifacts = "true")), { configuration };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CodeBuildAction[_a] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.CodeBuildAction", version: "2.80.0" }, exports2.CodeBuildAction = CodeBuildAction;
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/private/stack-dependency.js
var require_stack_dependency = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/private/stack-dependency.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.forceSupportStackDependency = void 0;
    var core_1 = require_core2();
    function forceSupportStackDependency(bucket, role) {
      core_1.Resource.isOwnedResource(bucket) && core_1.Resource.isOwnedResource(role) && core_1.Stack.of(bucket).addDependency(core_1.Stack.of(role), `replication bucket {${bucket.node.path}} to action role {${role}}`);
    }
    exports2.forceSupportStackDependency = forceSupportStackDependency;
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/codedeploy/ecs-deploy-action.js
var require_ecs_deploy_action = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/codedeploy/ecs-deploy-action.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CodeDeployEcsDeployAction = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var codepipeline = require_aws_codepipeline();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var action_1 = require_action2();
    var stack_dependency_1 = require_stack_dependency();
    var CodeDeployEcsDeployAction = class _CodeDeployEcsDeployAction extends action_1.Action {
      constructor(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_actions_CodeDeployEcsDeployActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CodeDeployEcsDeployAction), error;
        }
        const inputs = [];
        if (inputs.push(determineTaskDefinitionArtifact(props)), inputs.push(determineAppSpecArtifact(props)), props.containerImageInputs) {
          if (props.containerImageInputs.length > 4)
            throw new Error(`Action cannot have more than 4 container image inputs, got: ${props.containerImageInputs.length}`);
          for (const imageInput of props.containerImageInputs)
            inputs.push(imageInput.input);
        }
        super({ ...props, resource: props.deploymentGroup, category: codepipeline.ActionCategory.DEPLOY, provider: "CodeDeployToECS", artifactBounds: { minInputs: 1, maxInputs: 5, minOutputs: 0, maxOutputs: 0 }, inputs }), this.actionProps = props;
      }
      bound(_scope, _stage, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_IStage(_stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_ActionBindOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bound), error;
        }
        options.role.addToPolicy(new iam.PolicyStatement({ resources: [this.actionProps.deploymentGroup.application.applicationArn], actions: ["codedeploy:GetApplication", "codedeploy:GetApplicationRevision", "codedeploy:RegisterApplicationRevision"] })), options.role.addToPolicy(new iam.PolicyStatement({ resources: [this.actionProps.deploymentGroup.deploymentGroupArn], actions: ["codedeploy:CreateDeployment", "codedeploy:GetDeployment"] })), options.role.addToPolicy(new iam.PolicyStatement({ resources: [this.actionProps.deploymentGroup.deploymentConfig.deploymentConfigArn], actions: ["codedeploy:GetDeploymentConfig"] })), options.role.addToPolicy(new iam.PolicyStatement({ resources: ["*"], actions: ["ecs:RegisterTaskDefinition"] })), options.role.addToPolicy(new iam.PolicyStatement({ actions: ["iam:PassRole"], resources: ["*"], conditions: { StringEqualsIfExists: { "iam:PassedToService": ["ecs-tasks.amazonaws.com"] } } })), options.bucket.grantRead(options.role), (0, stack_dependency_1.forceSupportStackDependency)(options.bucket, options.role);
        const taskDefinitionTemplateArtifact = determineTaskDefinitionArtifact(this.actionProps), appSpecTemplateArtifact = determineAppSpecArtifact(this.actionProps), actionConfig = { configuration: { ApplicationName: this.actionProps.deploymentGroup.application.applicationName, DeploymentGroupName: this.actionProps.deploymentGroup.deploymentGroupName, TaskDefinitionTemplateArtifact: core_1.Lazy.string({ produce: () => taskDefinitionTemplateArtifact.artifactName }), TaskDefinitionTemplatePath: this.actionProps.taskDefinitionTemplateFile ? this.actionProps.taskDefinitionTemplateFile.fileName : "taskdef.json", AppSpecTemplateArtifact: core_1.Lazy.string({ produce: () => appSpecTemplateArtifact.artifactName }), AppSpecTemplatePath: this.actionProps.appSpecTemplateFile ? this.actionProps.appSpecTemplateFile.fileName : "appspec.yaml" } };
        if (this.actionProps.containerImageInputs)
          for (let i = 1; i <= this.actionProps.containerImageInputs.length; i++) {
            const imageInput = this.actionProps.containerImageInputs[i - 1];
            actionConfig.configuration[`Image${i}ArtifactName`] = core_1.Lazy.string({ produce: () => imageInput.input.artifactName }), actionConfig.configuration[`Image${i}ContainerName`] = imageInput.taskDefinitionPlaceholder ? imageInput.taskDefinitionPlaceholder : "IMAGE";
          }
        return actionConfig;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CodeDeployEcsDeployAction[_a] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.CodeDeployEcsDeployAction", version: "2.80.0" }, exports2.CodeDeployEcsDeployAction = CodeDeployEcsDeployAction;
    function determineTaskDefinitionArtifact(props) {
      if (props.taskDefinitionTemplateFile && props.taskDefinitionTemplateInput)
        throw new Error("Exactly one of 'taskDefinitionTemplateInput' or 'taskDefinitionTemplateFile' can be provided in the ECS CodeDeploy Action");
      if (props.taskDefinitionTemplateFile)
        return props.taskDefinitionTemplateFile.artifact;
      if (props.taskDefinitionTemplateInput)
        return props.taskDefinitionTemplateInput;
      throw new Error("Specifying one of 'taskDefinitionTemplateInput' or 'taskDefinitionTemplateFile' is required for the ECS CodeDeploy Action");
    }
    function determineAppSpecArtifact(props) {
      if (props.appSpecTemplateFile && props.appSpecTemplateInput)
        throw new Error("Exactly one of 'appSpecTemplateInput' or 'appSpecTemplateFile' can be provided in the ECS CodeDeploy Action");
      if (props.appSpecTemplateFile)
        return props.appSpecTemplateFile.artifact;
      if (props.appSpecTemplateInput)
        return props.appSpecTemplateInput;
      throw new Error("Specifying one of 'appSpecTemplateInput' or 'appSpecTemplateFile' is required for the ECS CodeDeploy Action");
    }
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/codedeploy/server-deploy-action.js
var require_server_deploy_action = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/codedeploy/server-deploy-action.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CodeDeployServerDeployAction = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var codepipeline = require_aws_codepipeline();
    var iam = require_aws_iam();
    var action_1 = require_action2();
    var common_1 = require_common4();
    var CodeDeployServerDeployAction = class _CodeDeployServerDeployAction extends action_1.Action {
      constructor(props) {
        super({ ...props, resource: props.deploymentGroup, category: codepipeline.ActionCategory.DEPLOY, provider: "CodeDeploy", artifactBounds: (0, common_1.deployArtifactBounds)(), inputs: [props.input] });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_actions_CodeDeployServerDeployActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CodeDeployServerDeployAction), error;
        }
        this.deploymentGroup = props.deploymentGroup;
      }
      bound(_scope, _stage, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_IStage(_stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_ActionBindOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bound), error;
        }
        options.role.addToPolicy(new iam.PolicyStatement({ resources: [this.deploymentGroup.application.applicationArn], actions: ["codedeploy:GetApplicationRevision", "codedeploy:RegisterApplicationRevision"] })), options.role.addToPolicy(new iam.PolicyStatement({ resources: [this.deploymentGroup.deploymentGroupArn], actions: ["codedeploy:CreateDeployment", "codedeploy:GetDeployment"] })), options.role.addToPolicy(new iam.PolicyStatement({ resources: [this.deploymentGroup.deploymentConfig.deploymentConfigArn], actions: ["codedeploy:GetDeploymentConfig"] }));
        for (const asg of this.deploymentGroup.autoScalingGroups || [])
          options.bucket.grantRead(asg);
        return options.bucket.grantRead(options.role), { configuration: { ApplicationName: this.deploymentGroup.application.applicationName, DeploymentGroupName: this.deploymentGroup.deploymentGroupName } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CodeDeployServerDeployAction[_a] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.CodeDeployServerDeployAction", version: "2.80.0" }, exports2.CodeDeployServerDeployAction = CodeDeployServerDeployAction;
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/ecr/source-action.js
var require_source_action4 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/ecr/source-action.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EcrSourceAction = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var codepipeline = require_aws_codepipeline();
    var aws_events_1 = require_aws_events();
    var targets = require_aws_events_targets();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var action_1 = require_action2();
    var common_1 = require_common4();
    var EcrSourceAction = class _EcrSourceAction extends action_1.Action {
      constructor(props) {
        super({ ...props, resource: props.repository, category: codepipeline.ActionCategory.SOURCE, provider: "ECR", artifactBounds: (0, common_1.sourceArtifactBounds)(), outputs: [props.output] });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_actions_EcrSourceActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EcrSourceAction), error;
        }
        this.props = props;
      }
      get variables() {
        return { registryId: this.variableExpression("RegistryId"), repositoryName: this.variableExpression("RepositoryName"), imageDigest: this.variableExpression("ImageDigest"), imageTag: this.variableExpression("ImageTag"), imageUri: this.variableExpression("ImageURI") };
      }
      bound(scope, stage, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_IStage(stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_ActionBindOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bound), error;
        }
        return options.role.addToPolicy(new iam.PolicyStatement({ actions: ["ecr:DescribeImages"], resources: [this.props.repository.repositoryArn] })), new aws_events_1.Rule(scope, core_1.Names.nodeUniqueId(stage.pipeline.node) + "SourceEventRule", { targets: [new targets.CodePipeline(stage.pipeline)], eventPattern: { detailType: ["ECR Image Action"], source: ["aws.ecr"], detail: { result: ["SUCCESS"], "repository-name": [this.props.repository.repositoryName], "image-tag": [this.props.imageTag === "" ? void 0 : this.props.imageTag ?? "latest"], "action-type": ["PUSH"] } } }), options.bucket.grantWrite(options.role), { configuration: { RepositoryName: this.props.repository.repositoryName, ImageTag: this.props.imageTag ? this.props.imageTag : void 0 } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EcrSourceAction[_a] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.EcrSourceAction", version: "2.80.0" }, exports2.EcrSourceAction = EcrSourceAction;
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/ecs/deploy-action.js
var require_deploy_action2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/ecs/deploy-action.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EcsDeployAction = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var codepipeline = require_aws_codepipeline();
    var iam = require_aws_iam();
    var action_1 = require_action2();
    var common_1 = require_common4();
    var EcsDeployAction = class _EcsDeployAction extends action_1.Action {
      constructor(props) {
        super({ ...props, category: codepipeline.ActionCategory.DEPLOY, provider: "ECS", artifactBounds: (0, common_1.deployArtifactBounds)(), inputs: [determineInputArtifact(props)], resource: props.service });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_actions_EcsDeployActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EcsDeployAction), error;
        }
        const deploymentTimeout = props.deploymentTimeout?.toMinutes({ integral: true });
        if (deploymentTimeout !== void 0 && (deploymentTimeout < 1 || deploymentTimeout > 60))
          throw new Error(`Deployment timeout must be between 1 and 60 minutes, got: ${deploymentTimeout}`);
        this.props = props, this.deploymentTimeout = deploymentTimeout;
      }
      bound(_scope, _stage, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_IStage(_stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_ActionBindOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bound), error;
        }
        return options.role.addToPolicy(new iam.PolicyStatement({ actions: ["ecs:DescribeServices", "ecs:DescribeTaskDefinition", "ecs:DescribeTasks", "ecs:ListTasks", "ecs:RegisterTaskDefinition", "ecs:UpdateService"], resources: ["*"] })), options.role.addToPolicy(new iam.PolicyStatement({ actions: ["iam:PassRole"], resources: ["*"], conditions: { StringEqualsIfExists: { "iam:PassedToService": ["ec2.amazonaws.com", "ecs-tasks.amazonaws.com"] } } })), options.bucket.grantRead(options.role), { configuration: { ClusterName: this.props.service.cluster.clusterName, ServiceName: this.props.service.serviceName, FileName: this.props.imageFile?.fileName, DeploymentTimeout: this.deploymentTimeout } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EcsDeployAction[_a] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.EcsDeployAction", version: "2.80.0" }, exports2.EcsDeployAction = EcsDeployAction;
    function determineInputArtifact(props) {
      if (props.imageFile && props.input)
        throw new Error("Exactly one of 'input' or 'imageFile' can be provided in the ECS deploy Action");
      if (props.imageFile)
        return props.imageFile.artifact;
      if (props.input)
        return props.input;
      throw new Error("Specifying one of 'input' or 'imageFile' is required for the ECS deploy Action");
    }
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/elastic-beanstalk/deploy-action.js
var require_deploy_action3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/elastic-beanstalk/deploy-action.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ElasticBeanstalkDeployAction = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var codepipeline = require_aws_codepipeline();
    var core_1 = require_core2();
    var action_1 = require_action2();
    var common_1 = require_common4();
    var ElasticBeanstalkDeployAction = class _ElasticBeanstalkDeployAction extends action_1.Action {
      constructor(props) {
        super({ ...props, category: codepipeline.ActionCategory.DEPLOY, provider: "ElasticBeanstalk", artifactBounds: (0, common_1.deployArtifactBounds)(), inputs: [props.input] });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_actions_ElasticBeanstalkDeployActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ElasticBeanstalkDeployAction), error;
        }
        this.applicationName = props.applicationName, this.environmentName = props.environmentName;
      }
      bound(_scope, _stage, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_IStage(_stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_ActionBindOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bound), error;
        }
        return options.role.addManagedPolicy({ managedPolicyArn: `arn:${core_1.Aws.PARTITION}:iam::aws:policy/AdministratorAccess-AWSElasticBeanstalk` }), options.bucket.grantRead(options.role), { configuration: { ApplicationName: this.applicationName, EnvironmentName: this.environmentName } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ElasticBeanstalkDeployAction[_a] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.ElasticBeanstalkDeployAction", version: "2.80.0" }, exports2.ElasticBeanstalkDeployAction = ElasticBeanstalkDeployAction;
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/github/source-action.js
var require_source_action5 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/github/source-action.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.GitHubSourceAction = exports2.GitHubTrigger = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var codepipeline = require_aws_codepipeline();
    var action_1 = require_action2();
    var common_1 = require_common4();
    var GitHubTrigger;
    (function(GitHubTrigger2) {
      GitHubTrigger2.NONE = "None", GitHubTrigger2.POLL = "Poll", GitHubTrigger2.WEBHOOK = "WebHook";
    })(GitHubTrigger = exports2.GitHubTrigger || (exports2.GitHubTrigger = {}));
    var GitHubSourceAction = class _GitHubSourceAction extends action_1.Action {
      constructor(props) {
        super({ ...props, category: codepipeline.ActionCategory.SOURCE, owner: "ThirdParty", provider: "GitHub", artifactBounds: (0, common_1.sourceArtifactBounds)(), outputs: [props.output] });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_actions_GitHubSourceActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _GitHubSourceAction), error;
        }
        this.props = props;
      }
      get variables() {
        return { repositoryName: this.variableExpression("RepositoryName"), branchName: this.variableExpression("BranchName"), authorDate: this.variableExpression("AuthorDate"), committerDate: this.variableExpression("CommitterDate"), commitId: this.variableExpression("CommitId"), commitMessage: this.variableExpression("CommitMessage"), commitUrl: this.variableExpression("CommitUrl") };
      }
      bound(scope, stage, _options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_IStage(stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_ActionBindOptions(_options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bound), error;
        }
        return (!this.props.trigger || this.props.trigger === GitHubTrigger.WEBHOOK) && new codepipeline.CfnWebhook(scope, "WebhookResource", { authentication: "GITHUB_HMAC", authenticationConfiguration: { secretToken: this.props.oauthToken.unsafeUnwrap() }, filters: [{ jsonPath: "$.ref", matchEquals: "refs/heads/{Branch}" }], targetAction: this.actionProperties.actionName, targetPipeline: stage.pipeline.pipelineName, targetPipelineVersion: 1, registerWithThirdParty: true }), { configuration: { Owner: this.props.owner, Repo: this.props.repo, Branch: this.props.branch || "master", OAuthToken: this.props.oauthToken.unsafeUnwrap(), PollForSourceChanges: this.props.trigger === GitHubTrigger.POLL } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, GitHubSourceAction[_a] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.GitHubSourceAction", version: "2.80.0" }, exports2.GitHubSourceAction = GitHubSourceAction;
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/jenkins/jenkins-provider.js
var require_jenkins_provider = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/jenkins/jenkins-provider.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.jenkinsArtifactsBounds = exports2.JenkinsProvider = exports2.BaseJenkinsProvider = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var codepipeline = require_aws_codepipeline();
    var BaseJenkinsProvider = class extends constructs_1.Construct {
      constructor(scope, id, version) {
        super(scope, id), this.version = version || "1";
      }
    };
    _a = JSII_RTTI_SYMBOL_1, BaseJenkinsProvider[_a] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.BaseJenkinsProvider", version: "2.80.0" }, exports2.BaseJenkinsProvider = BaseJenkinsProvider;
    var JenkinsProvider = class _JenkinsProvider extends BaseJenkinsProvider {
      static fromJenkinsProviderAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_actions_JenkinsProviderAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromJenkinsProviderAttributes), error;
        }
        return new ImportedJenkinsProvider(scope, id, attrs);
      }
      constructor(scope, id, props) {
        super(scope, id, props.version), this.buildIncluded = false, this.testIncluded = false;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_actions_JenkinsProviderProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _JenkinsProvider), error;
        }
        this.providerName = props.providerName, this.serverUrl = props.serverUrl, props.forBuild === true && this._registerBuildProvider(), props.forTest === true && this._registerTestProvider();
      }
      _registerBuildProvider() {
        this.buildIncluded || (this.buildIncluded = true, this.registerJenkinsCustomAction("JenkinsBuildProviderResource", codepipeline.ActionCategory.BUILD));
      }
      _registerTestProvider() {
        this.testIncluded || (this.testIncluded = true, this.registerJenkinsCustomAction("JenkinsTestProviderResource", codepipeline.ActionCategory.TEST));
      }
      registerJenkinsCustomAction(id, category) {
        new codepipeline.CustomActionRegistration(this, id, { category, artifactBounds: exports2.jenkinsArtifactsBounds, provider: this.providerName, version: this.version, entityUrl: appendToUrl(this.serverUrl, "job/{Config:ProjectName}"), executionUrl: appendToUrl(this.serverUrl, "job/{Config:ProjectName}/{ExternalExecutionId}"), actionProperties: [{ name: "ProjectName", required: true, key: true, queryable: true }] });
      }
    };
    _b = JSII_RTTI_SYMBOL_1, JenkinsProvider[_b] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.JenkinsProvider", version: "2.80.0" }, exports2.JenkinsProvider = JenkinsProvider;
    var ImportedJenkinsProvider = class extends BaseJenkinsProvider {
      constructor(scope, id, props) {
        super(scope, id, props.version), this.providerName = props.providerName, this.serverUrl = props.serverUrl;
      }
      _registerBuildProvider() {
      }
      _registerTestProvider() {
      }
    };
    function appendToUrl(baseUrl, path) {
      return baseUrl.endsWith("/") ? baseUrl + path : `${baseUrl}/${path}`;
    }
    exports2.jenkinsArtifactsBounds = { minInputs: 0, maxInputs: 5, minOutputs: 0, maxOutputs: 5 };
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/jenkins/jenkins-action.js
var require_jenkins_action = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/jenkins/jenkins-action.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.JenkinsAction = exports2.JenkinsActionType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var jenkins_provider_1 = require_jenkins_provider();
    var codepipeline = require_aws_codepipeline();
    var action_1 = require_action2();
    var JenkinsActionType;
    (function(JenkinsActionType2) {
      JenkinsActionType2[JenkinsActionType2.BUILD = 0] = "BUILD", JenkinsActionType2[JenkinsActionType2.TEST = 1] = "TEST";
    })(JenkinsActionType = exports2.JenkinsActionType || (exports2.JenkinsActionType = {}));
    var JenkinsAction = class _JenkinsAction extends action_1.Action {
      constructor(props) {
        super({ ...props, category: props.type === JenkinsActionType.BUILD ? codepipeline.ActionCategory.BUILD : codepipeline.ActionCategory.TEST, provider: props.jenkinsProvider.providerName, owner: "Custom", artifactBounds: jenkins_provider_1.jenkinsArtifactsBounds, version: props.jenkinsProvider.version });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_actions_JenkinsActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _JenkinsAction), error;
        }
        this.props = props;
      }
      bound(_scope, _stage, _options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_IStage(_stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_ActionBindOptions(_options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bound), error;
        }
        return this.actionProperties.category === codepipeline.ActionCategory.BUILD ? this.props.jenkinsProvider._registerBuildProvider() : this.props.jenkinsProvider._registerTestProvider(), { configuration: { ProjectName: this.props.projectName } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, JenkinsAction[_a] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.JenkinsAction", version: "2.80.0" }, exports2.JenkinsAction = JenkinsAction;
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/lambda/invoke-action.js
var require_invoke_action = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/lambda/invoke-action.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LambdaInvokeAction = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var codepipeline = require_aws_codepipeline();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var action_1 = require_action2();
    var LambdaInvokeAction = class _LambdaInvokeAction extends action_1.Action {
      constructor(props) {
        super({ ...props, resource: props.lambda, category: codepipeline.ActionCategory.INVOKE, provider: "Lambda", artifactBounds: { minInputs: 0, maxInputs: 5, minOutputs: 0, maxOutputs: 5 } });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_actions_LambdaInvokeActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _LambdaInvokeAction), error;
        }
        if (this.props = props, props.userParameters && props.userParametersString)
          throw new Error("Only one of userParameters or userParametersString can be specified");
      }
      variable(variableName) {
        return this.variableExpression(variableName);
      }
      bound(scope, _stage, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_IStage(_stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_ActionBindOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bound), error;
        }
        return options.role.addToPolicy(new iam.PolicyStatement({ actions: ["lambda:ListFunctions"], resources: ["*"] })), this.props.lambda.grantInvoke(options.role), (this.actionProperties.inputs || []).length > 0 && options.bucket.grantRead(options.role), (this.actionProperties.outputs || []).length > 0 && options.bucket.grantWrite(options.role), this.props.lambda.addToRolePolicy(new iam.PolicyStatement({ resources: ["*"], actions: ["codepipeline:PutJobSuccessResult", "codepipeline:PutJobFailureResult"] })), { configuration: { FunctionName: this.props.lambda.functionName, UserParameters: this.props.userParametersString ?? core_1.Stack.of(scope).toJsonString(this.props.userParameters) } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LambdaInvokeAction[_a] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.LambdaInvokeAction", version: "2.80.0" }, exports2.LambdaInvokeAction = LambdaInvokeAction;
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/manual-approval-action.js
var require_manual_approval_action = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/manual-approval-action.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ManualApprovalAction = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var action_1 = require_action2();
    var codepipeline = require_aws_codepipeline();
    var iam = require_aws_iam();
    var sns = require_aws_sns();
    var subs = require_aws_sns_subscriptions();
    var ManualApprovalAction = class _ManualApprovalAction extends action_1.Action {
      constructor(props) {
        super({ ...props, category: codepipeline.ActionCategory.APPROVAL, provider: "Manual", artifactBounds: { minInputs: 0, maxInputs: 0, minOutputs: 0, maxOutputs: 0 } });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_actions_ManualApprovalActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ManualApprovalAction), error;
        }
        this.props = props;
      }
      get notificationTopic() {
        return this._notificationTopic;
      }
      grantManualApproval(grantable) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IGrantable(grantable);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantManualApproval), error;
        }
        if (!this.stage)
          throw new Error("Cannot grant permissions before binding action to a stage");
        grantable.grantPrincipal.addToPrincipalPolicy(new iam.PolicyStatement({ actions: ["codepipeline:ListPipelines"], resources: ["*"] })), grantable.grantPrincipal.addToPrincipalPolicy(new iam.PolicyStatement({ actions: ["codepipeline:GetPipeline", "codepipeline:GetPipelineState", "codepipeline:GetPipelineExecution"], resources: [this.stage.pipeline.pipelineArn] })), grantable.grantPrincipal.addToPrincipalPolicy(new iam.PolicyStatement({ actions: ["codepipeline:PutApprovalResult"], resources: [`${this.stage.pipeline.pipelineArn}/${this.stage.stageName}/${this.props.actionName}`] }));
      }
      bound(scope, stage, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_IStage(stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_ActionBindOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bound), error;
        }
        if (this.props.notificationTopic ? this._notificationTopic = this.props.notificationTopic : (this.props.notifyEmails || []).length > 0 && (this._notificationTopic = new sns.Topic(scope, "TopicResource")), this._notificationTopic) {
          this._notificationTopic.grantPublish(options.role);
          for (const notifyEmail of this.props.notifyEmails || [])
            this._notificationTopic.addSubscription(new subs.EmailSubscription(notifyEmail));
        }
        return this.stage = stage, { configuration: undefinedIfAllValuesAreEmpty({ NotificationArn: this._notificationTopic?.topicArn, CustomData: this.props.additionalInformation, ExternalEntityLink: this.props.externalEntityLink }) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ManualApprovalAction[_a] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.ManualApprovalAction", version: "2.80.0" }, exports2.ManualApprovalAction = ManualApprovalAction;
    function undefinedIfAllValuesAreEmpty(object) {
      return Object.values(object).some((v) => v !== void 0) ? object : void 0;
    }
  }
});

// node_modules/aws-cdk-lib/node_modules/case/dist/Case.js
var require_Case = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/case/dist/Case.js"(exports2, module2) {
    "use strict";
    (function() {
      "use strict";
      var unicodes = function(s, prefix) {
        prefix = prefix || "";
        return s.replace(/(^|-)/g, "$1\\u" + prefix).replace(/,/g, "\\u" + prefix);
      }, basicSymbols = unicodes("20-26,28-2F,3A-40,5B-60,7B-7E,A0-BF,D7,F7", "00"), baseLowerCase = "a-z" + unicodes("DF-F6,F8-FF", "00"), baseUpperCase = "A-Z" + unicodes("C0-D6,D8-DE", "00"), improperInTitle = "A|An|And|As|At|But|By|En|For|If|In|Of|On|Or|The|To|Vs?\\.?|Via", regexps = function(symbols, lowers, uppers, impropers) {
        symbols = symbols || basicSymbols;
        lowers = lowers || baseLowerCase;
        uppers = uppers || baseUpperCase;
        impropers = impropers || improperInTitle;
        return {
          capitalize: new RegExp("(^|[" + symbols + "])([" + lowers + "])", "g"),
          pascal: new RegExp("(^|[" + symbols + "])+([" + lowers + uppers + "])", "g"),
          fill: new RegExp("[" + symbols + "]+(.|$)", "g"),
          sentence: new RegExp('(^\\s*|[\\?\\!\\.]+"?\\s+"?|,\\s+")([' + lowers + "])", "g"),
          improper: new RegExp("\\b(" + impropers + ")\\b", "g"),
          relax: new RegExp("([^" + uppers + "])([" + uppers + "]*)([" + uppers + "])(?=[^" + uppers + "]|$)", "g"),
          upper: new RegExp("^[^" + lowers + "]+$"),
          hole: /[^\s]\s[^\s]/,
          apostrophe: /'/g,
          room: new RegExp("[" + symbols + "]")
        };
      }, re = regexps(), _ = {
        re,
        unicodes,
        regexps,
        types: [],
        up: String.prototype.toUpperCase,
        low: String.prototype.toLowerCase,
        cap: function(s) {
          return _.up.call(s.charAt(0)) + s.slice(1);
        },
        decap: function(s) {
          return _.low.call(s.charAt(0)) + s.slice(1);
        },
        deapostrophe: function(s) {
          return s.replace(re.apostrophe, "");
        },
        fill: function(s, fill, deapostrophe) {
          if (fill != null) {
            s = s.replace(re.fill, function(m, next) {
              return next ? fill + next : "";
            });
          }
          if (deapostrophe) {
            s = _.deapostrophe(s);
          }
          return s;
        },
        prep: function(s, fill, pascal, upper) {
          s = s == null ? "" : s + "";
          if (!upper && re.upper.test(s)) {
            s = _.low.call(s);
          }
          if (!fill && !re.hole.test(s)) {
            var holey = _.fill(s, " ");
            if (re.hole.test(holey)) {
              s = holey;
            }
          }
          if (!pascal && !re.room.test(s)) {
            s = s.replace(re.relax, _.relax);
          }
          return s;
        },
        relax: function(m, before, acronym, caps) {
          return before + " " + (acronym ? acronym + " " : "") + caps;
        }
      }, Case = {
        _,
        of: function(s) {
          for (var i = 0, m = _.types.length; i < m; i++) {
            if (Case[_.types[i]].apply(Case, arguments) === s) {
              return _.types[i];
            }
          }
        },
        flip: function(s) {
          return s.replace(/\w/g, function(l) {
            return (l == _.up.call(l) ? _.low : _.up).call(l);
          });
        },
        random: function(s) {
          return s.replace(/\w/g, function(l) {
            return (Math.round(Math.random()) ? _.up : _.low).call(l);
          });
        },
        type: function(type2, fn) {
          Case[type2] = fn;
          _.types.push(type2);
        }
      }, types = {
        lower: function(s, fill, deapostrophe) {
          return _.fill(_.low.call(_.prep(s, fill)), fill, deapostrophe);
        },
        snake: function(s) {
          return Case.lower(s, "_", true);
        },
        constant: function(s) {
          return Case.upper(s, "_", true);
        },
        camel: function(s) {
          return _.decap(Case.pascal(s));
        },
        kebab: function(s) {
          return Case.lower(s, "-", true);
        },
        upper: function(s, fill, deapostrophe) {
          return _.fill(_.up.call(_.prep(s, fill, false, true)), fill, deapostrophe);
        },
        capital: function(s, fill, deapostrophe) {
          return _.fill(_.prep(s).replace(re.capitalize, function(m, border, letter) {
            return border + _.up.call(letter);
          }), fill, deapostrophe);
        },
        header: function(s) {
          return Case.capital(s, "-", true);
        },
        pascal: function(s) {
          return _.fill(_.prep(s, false, true).replace(re.pascal, function(m, border, letter) {
            return _.up.call(letter);
          }), "", true);
        },
        title: function(s) {
          return Case.capital(s).replace(re.improper, function(small, p, i, s2) {
            return i > 0 && i < s2.lastIndexOf(" ") ? _.low.call(small) : small;
          });
        },
        sentence: function(s, names, abbreviations) {
          s = Case.lower(s).replace(re.sentence, function(m, prelude, letter) {
            return prelude + _.up.call(letter);
          });
          if (names) {
            names.forEach(function(name) {
              s = s.replace(new RegExp("\\b" + Case.lower(name) + "\\b", "g"), _.cap);
            });
          }
          if (abbreviations) {
            abbreviations.forEach(function(abbr) {
              s = s.replace(new RegExp("(\\b" + Case.lower(abbr) + "\\. +)(\\w)"), function(m, abbrAndSpace, letter) {
                return abbrAndSpace + _.low.call(letter);
              });
            });
          }
          return s;
        }
      };
      types.squish = types.pascal;
      Case.default = Case;
      for (var type in types) {
        Case.type(type, types[type]);
      }
      var define = typeof define === "function" ? define : function() {
      };
      define(typeof module2 === "object" && module2.exports ? module2.exports = Case : this.Case = Case);
    }).call(exports2);
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/s3/deploy-action.js
var require_deploy_action4 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/s3/deploy-action.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.S3DeployAction = exports2.CacheControl = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var case_1 = require_Case();
    var codepipeline = require_aws_codepipeline();
    var action_1 = require_action2();
    var common_1 = require_common4();
    var CacheControl = class _CacheControl {
      static mustRevalidate() {
        return new _CacheControl("must-revalidate");
      }
      static noCache() {
        return new _CacheControl("no-cache");
      }
      static noTransform() {
        return new _CacheControl("no-transform");
      }
      static setPublic() {
        return new _CacheControl("public");
      }
      static setPrivate() {
        return new _CacheControl("private");
      }
      static proxyRevalidate() {
        return new _CacheControl("proxy-revalidate");
      }
      static maxAge(t) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Duration(t);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.maxAge), error;
        }
        return new _CacheControl(`max-age=${t.toSeconds()}`);
      }
      static sMaxAge(t) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Duration(t);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.sMaxAge), error;
        }
        return new _CacheControl(`s-maxage=${t.toSeconds()}`);
      }
      static fromString(s) {
        return new _CacheControl(s);
      }
      constructor(value) {
        this.value = value;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CacheControl[_a] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.CacheControl", version: "2.80.0" }, exports2.CacheControl = CacheControl;
    var S3DeployAction = class _S3DeployAction extends action_1.Action {
      constructor(props) {
        super({ ...props, resource: props.bucket, category: codepipeline.ActionCategory.DEPLOY, provider: "S3", artifactBounds: (0, common_1.deployArtifactBounds)(), inputs: [props.input] });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_actions_S3DeployActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _S3DeployAction), error;
        }
        this.props = props;
      }
      bound(_scope, _stage, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_IStage(_stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_ActionBindOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bound), error;
        }
        this.props.bucket.grantWrite(options.role), this.props.accessControl !== void 0 && this.props.bucket.grantPutAcl(options.role), options.bucket.grantRead(options.role), this.props.encryptionKey?.grantEncrypt(options.role);
        const acl = this.props.accessControl;
        return { configuration: { BucketName: this.props.bucket.bucketName, Extract: this.props.extract === false ? "false" : "true", ObjectKey: this.props.objectKey, CannedACL: acl ? (0, case_1.kebab)(acl.toString()) : void 0, CacheControl: this.props.cacheControl && this.props.cacheControl.map((ac) => ac.value).join(", "), KMSEncryptionKeyARN: this.props.encryptionKey?.keyArn } };
      }
    };
    _b = JSII_RTTI_SYMBOL_1, S3DeployAction[_b] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.S3DeployAction", version: "2.80.0" }, exports2.S3DeployAction = S3DeployAction;
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/s3/source-action.js
var require_source_action6 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/s3/source-action.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.S3SourceAction = exports2.S3Trigger = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var codepipeline = require_aws_codepipeline();
    var targets = require_aws_events_targets();
    var core_1 = require_core2();
    var action_1 = require_action2();
    var common_1 = require_common4();
    var S3Trigger;
    (function(S3Trigger2) {
      S3Trigger2.NONE = "None", S3Trigger2.POLL = "Poll", S3Trigger2.EVENTS = "Events";
    })(S3Trigger = exports2.S3Trigger || (exports2.S3Trigger = {}));
    var S3SourceAction = class _S3SourceAction extends action_1.Action {
      constructor(props) {
        super({ ...props, resource: props.bucket, category: codepipeline.ActionCategory.SOURCE, provider: "S3", artifactBounds: (0, common_1.sourceArtifactBounds)(), outputs: [props.output] });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_actions_S3SourceActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _S3SourceAction), error;
        }
        if (props.bucketKey.length === 0)
          throw new Error("Property bucketKey cannot be an empty string");
        this.props = props;
      }
      get variables() {
        return { versionId: this.variableExpression("VersionId"), eTag: this.variableExpression("ETag") };
      }
      bound(_scope, stage, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_IStage(stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_ActionBindOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bound), error;
        }
        if (this.props.trigger === S3Trigger.EVENTS) {
          const id = this.generateEventId(stage);
          this.props.bucket.onCloudTrailWriteObject(id, { target: new targets.CodePipeline(stage.pipeline), paths: [this.props.bucketKey], crossStackScope: stage.pipeline });
        }
        return this.props.bucket.grantRead(options.role, this.props.bucketKey), options.bucket.grantWrite(options.role), { configuration: { S3Bucket: this.props.bucket.bucketName, S3ObjectKey: this.props.bucketKey, PollForSourceChanges: this.props.trigger && this.props.trigger === S3Trigger.POLL } };
      }
      generateEventId(stage) {
        let ret;
        const baseId = core_1.Names.nodeUniqueId(stage.pipeline.node) + "SourceEventRule";
        if (core_1.Token.isUnresolved(this.props.bucketKey)) {
          let candidate = baseId, counter = 0;
          for (; this.props.bucket.node.tryFindChild(candidate) !== void 0; )
            counter += 1, candidate = baseId + counter;
          ret = candidate;
        } else if (ret = baseId + this.props.bucketKey, this.props.bucket.node.tryFindChild(ret))
          throw new Error(`S3 source action with path '${this.props.bucketKey}' is already present in the pipeline for this source bucket`);
        return ret;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, S3SourceAction[_a] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.S3SourceAction", version: "2.80.0" }, exports2.S3SourceAction = S3SourceAction;
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/stepfunctions/invoke-action.js
var require_invoke_action2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/stepfunctions/invoke-action.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.StepFunctionInvokeAction = exports2.StateMachineInput = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var codepipeline = require_aws_codepipeline();
    var iam = require_aws_iam();
    var cdk = require_core2();
    var action_1 = require_action2();
    var StateMachineInput = class _StateMachineInput {
      static filePath(inputFile) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_ArtifactPath(inputFile);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.filePath), error;
        }
        return new _StateMachineInput(inputFile.location, inputFile.artifact, "FilePath");
      }
      static literal(object) {
        return new _StateMachineInput(JSON.stringify(object), void 0, "Literal");
      }
      constructor(input, inputArtifact, inputType) {
        this.input = input, this.inputArtifact = inputArtifact, this.inputType = inputType;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, StateMachineInput[_a] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.StateMachineInput", version: "2.80.0" }, exports2.StateMachineInput = StateMachineInput;
    var StepFunctionInvokeAction = class _StepFunctionInvokeAction extends action_1.Action {
      constructor(props) {
        super({ ...props, resource: props.stateMachine, category: codepipeline.ActionCategory.INVOKE, provider: "StepFunctions", artifactBounds: { minInputs: 0, maxInputs: 1, minOutputs: 0, maxOutputs: 1 }, inputs: props.stateMachineInput && props.stateMachineInput.inputArtifact ? [props.stateMachineInput.inputArtifact] : [], outputs: props.output ? [props.output] : [] });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_actions_StepFunctionsInvokeActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _StepFunctionInvokeAction), error;
        }
        this.props = props;
      }
      bound(_scope, _stage, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_IStage(_stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_ActionBindOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bound), error;
        }
        return options.role.addToPrincipalPolicy(new iam.PolicyStatement({ actions: ["states:StartExecution", "states:DescribeStateMachine"], resources: [this.props.stateMachine.stateMachineArn] })), options.role.addToPrincipalPolicy(new iam.PolicyStatement({ actions: ["states:DescribeExecution"], resources: [cdk.Stack.of(this.props.stateMachine).formatArn({ service: "states", resource: "execution", resourceName: `${cdk.Stack.of(this.props.stateMachine).splitArn(this.props.stateMachine.stateMachineArn, cdk.ArnFormat.COLON_RESOURCE_NAME).resourceName}:${this.props.executionNamePrefix ?? ""}*`, arnFormat: cdk.ArnFormat.COLON_RESOURCE_NAME })] })), (this.actionProperties.inputs ?? []).length > 0 && options.bucket.grantRead(options.role), (this.actionProperties.outputs ?? []).length > 0 && options.bucket.grantWrite(options.role), { configuration: { StateMachineArn: this.props.stateMachine.stateMachineArn, Input: this.props.stateMachineInput?.input, InputType: this.props.stateMachineInput?.inputType, ExecutionNamePrefix: this.props.executionNamePrefix } };
      }
    };
    _b = JSII_RTTI_SYMBOL_1, StepFunctionInvokeAction[_b] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.StepFunctionInvokeAction", version: "2.80.0" }, exports2.StepFunctionInvokeAction = StepFunctionInvokeAction;
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/servicecatalog/deploy-action-beta1.js
var require_deploy_action_beta1 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/servicecatalog/deploy-action-beta1.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ServiceCatalogDeployActionBeta1 = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var codepipeline = require_aws_codepipeline();
    var iam = require_aws_iam();
    var action_1 = require_action2();
    var ServiceCatalogDeployActionBeta1 = class _ServiceCatalogDeployActionBeta1 extends action_1.Action {
      constructor(props) {
        super({ ...props, provider: "ServiceCatalog", category: codepipeline.ActionCategory.DEPLOY, artifactBounds: { minInputs: 1, maxInputs: 1, minOutputs: 0, maxOutputs: 0 }, inputs: [props.templatePath.artifact] });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_actions_ServiceCatalogDeployActionBeta1Props(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ServiceCatalogDeployActionBeta1), error;
        }
        this.templatePath = props.templatePath.fileName, this.productVersionName = props.productVersionName, this.productVersionDescription = props.productVersionDescription, this.productId = props.productId, this.productType = "CLOUD_FORMATION_TEMPLATE";
      }
      bound(_scope, _stage, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_IStage(_stage), jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_ActionBindOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bound), error;
        }
        return options.role.addManagedPolicy(iam.ManagedPolicy.fromAwsManagedPolicyName("AWSServiceCatalogAdminFullAccess")), options.bucket.grantRead(options.role), { configuration: { TemplateFilePath: this.templatePath, ProductVersionName: this.productVersionName, ProductVersionDescription: this.productVersionDescription, ProductType: this.productType, ProductId: this.productId } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ServiceCatalogDeployActionBeta1[_a] = { fqn: "aws-cdk-lib.aws_codepipeline_actions.ServiceCatalogDeployActionBeta1", version: "2.80.0" }, exports2.ServiceCatalogDeployActionBeta1 = ServiceCatalogDeployActionBeta1;
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/index.js
var require_lib85 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline-actions/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_deploy_action(), exports2), __exportStar(require_source_action2(), exports2), __exportStar(require_source_action(), exports2), __exportStar(require_cloudformation2(), exports2), __exportStar(require_build_action(), exports2), __exportStar(require_source_action3(), exports2), __exportStar(require_ecs_deploy_action(), exports2), __exportStar(require_server_deploy_action(), exports2), __exportStar(require_source_action4(), exports2), __exportStar(require_deploy_action2(), exports2), __exportStar(require_deploy_action3(), exports2), __exportStar(require_source_action5(), exports2), __exportStar(require_jenkins_action(), exports2), __exportStar(require_jenkins_provider(), exports2), __exportStar(require_invoke_action(), exports2), __exportStar(require_manual_approval_action(), exports2), __exportStar(require_deploy_action4(), exports2), __exportStar(require_source_action6(), exports2), __exportStar(require_invoke_action2(), exports2), __exportStar(require_deploy_action_beta1(), exports2), __exportStar(require_action2(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-codepipeline-actions/index.js
var require_aws_codepipeline_actions = __commonJS({
  "node_modules/aws-cdk-lib/aws-codepipeline-actions/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib85(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-codestar/lib/codestar.generated.js
var require_codestar_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-codestar/lib/codestar.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnGitHubRepository = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnGitHubRepositoryPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("code", CfnGitHubRepository_CodePropertyValidator)(properties.code)), errors.collect(cdk.propertyValidator("connectionArn", cdk.validateString)(properties.connectionArn)), errors.collect(cdk.propertyValidator("enableIssues", cdk.validateBoolean)(properties.enableIssues)), errors.collect(cdk.propertyValidator("isPrivate", cdk.validateBoolean)(properties.isPrivate)), errors.collect(cdk.propertyValidator("repositoryAccessToken", cdk.validateString)(properties.repositoryAccessToken)), errors.collect(cdk.propertyValidator("repositoryDescription", cdk.validateString)(properties.repositoryDescription)), errors.collect(cdk.propertyValidator("repositoryName", cdk.requiredValidator)(properties.repositoryName)), errors.collect(cdk.propertyValidator("repositoryName", cdk.validateString)(properties.repositoryName)), errors.collect(cdk.propertyValidator("repositoryOwner", cdk.requiredValidator)(properties.repositoryOwner)), errors.collect(cdk.propertyValidator("repositoryOwner", cdk.validateString)(properties.repositoryOwner)), errors.wrap('supplied properties not correct for "CfnGitHubRepositoryProps"');
    }
    function cfnGitHubRepositoryPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGitHubRepositoryPropsValidator(properties).assertSuccess(), { RepositoryName: cdk.stringToCloudFormation(properties.repositoryName), RepositoryOwner: cdk.stringToCloudFormation(properties.repositoryOwner), Code: cfnGitHubRepositoryCodePropertyToCloudFormation(properties.code), ConnectionArn: cdk.stringToCloudFormation(properties.connectionArn), EnableIssues: cdk.booleanToCloudFormation(properties.enableIssues), IsPrivate: cdk.booleanToCloudFormation(properties.isPrivate), RepositoryAccessToken: cdk.stringToCloudFormation(properties.repositoryAccessToken), RepositoryDescription: cdk.stringToCloudFormation(properties.repositoryDescription) }) : properties;
    }
    function CfnGitHubRepositoryPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("repositoryName", "RepositoryName", cfn_parse.FromCloudFormation.getString(properties.RepositoryName)), ret.addPropertyResult("repositoryOwner", "RepositoryOwner", cfn_parse.FromCloudFormation.getString(properties.RepositoryOwner)), ret.addPropertyResult("code", "Code", properties.Code != null ? CfnGitHubRepositoryCodePropertyFromCloudFormation(properties.Code) : void 0), ret.addPropertyResult("connectionArn", "ConnectionArn", properties.ConnectionArn != null ? cfn_parse.FromCloudFormation.getString(properties.ConnectionArn) : void 0), ret.addPropertyResult("enableIssues", "EnableIssues", properties.EnableIssues != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableIssues) : void 0), ret.addPropertyResult("isPrivate", "IsPrivate", properties.IsPrivate != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsPrivate) : void 0), ret.addPropertyResult("repositoryAccessToken", "RepositoryAccessToken", properties.RepositoryAccessToken != null ? cfn_parse.FromCloudFormation.getString(properties.RepositoryAccessToken) : void 0), ret.addPropertyResult("repositoryDescription", "RepositoryDescription", properties.RepositoryDescription != null ? cfn_parse.FromCloudFormation.getString(properties.RepositoryDescription) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnGitHubRepository = class _CfnGitHubRepository extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnGitHubRepositoryPropsFromCloudFormation(resourceProperties), ret = new _CfnGitHubRepository(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnGitHubRepository.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codestar_CfnGitHubRepositoryProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnGitHubRepository), error;
        }
        cdk.requireProperty(props, "repositoryName", this), cdk.requireProperty(props, "repositoryOwner", this), this.repositoryName = props.repositoryName, this.repositoryOwner = props.repositoryOwner, this.code = props.code, this.connectionArn = props.connectionArn, this.enableIssues = props.enableIssues, this.isPrivate = props.isPrivate, this.repositoryAccessToken = props.repositoryAccessToken, this.repositoryDescription = props.repositoryDescription;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnGitHubRepository.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { repositoryName: this.repositoryName, repositoryOwner: this.repositoryOwner, code: this.code, connectionArn: this.connectionArn, enableIssues: this.enableIssues, isPrivate: this.isPrivate, repositoryAccessToken: this.repositoryAccessToken, repositoryDescription: this.repositoryDescription };
      }
      renderProperties(props) {
        return cfnGitHubRepositoryPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnGitHubRepository[_a] = { fqn: "aws-cdk-lib.aws_codestar.CfnGitHubRepository", version: "2.80.0" }, CfnGitHubRepository.CFN_RESOURCE_TYPE_NAME = "AWS::CodeStar::GitHubRepository", exports2.CfnGitHubRepository = CfnGitHubRepository;
    function CfnGitHubRepository_CodePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3", cdk.requiredValidator)(properties.s3)), errors.collect(cdk.propertyValidator("s3", CfnGitHubRepository_S3PropertyValidator)(properties.s3)), errors.wrap('supplied properties not correct for "CodeProperty"');
    }
    function cfnGitHubRepositoryCodePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGitHubRepository_CodePropertyValidator(properties).assertSuccess(), { S3: cfnGitHubRepositoryS3PropertyToCloudFormation(properties.s3) }) : properties;
    }
    function CfnGitHubRepositoryCodePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3", "S3", CfnGitHubRepositoryS3PropertyFromCloudFormation(properties.S3)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGitHubRepository_S3PropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.requiredValidator)(properties.bucket)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("objectVersion", cdk.validateString)(properties.objectVersion)), errors.wrap('supplied properties not correct for "S3Property"');
    }
    function cfnGitHubRepositoryS3PropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGitHubRepository_S3PropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), Key: cdk.stringToCloudFormation(properties.key), ObjectVersion: cdk.stringToCloudFormation(properties.objectVersion) }) : properties;
    }
    function CfnGitHubRepositoryS3PropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", cfn_parse.FromCloudFormation.getString(properties.Bucket)), ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("objectVersion", "ObjectVersion", properties.ObjectVersion != null ? cfn_parse.FromCloudFormation.getString(properties.ObjectVersion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-codestar/lib/index.js
var require_lib86 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codestar/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_codestar_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-codestar/index.js
var require_aws_codestar = __commonJS({
  "node_modules/aws-cdk-lib/aws-codestar/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib86(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-codestarconnections/lib/codestarconnections.generated.js
var require_codestarconnections_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-codestarconnections/lib/codestarconnections.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnConnection = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnConnectionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectionName", cdk.requiredValidator)(properties.connectionName)), errors.collect(cdk.propertyValidator("connectionName", cdk.validateString)(properties.connectionName)), errors.collect(cdk.propertyValidator("hostArn", cdk.validateString)(properties.hostArn)), errors.collect(cdk.propertyValidator("providerType", cdk.validateString)(properties.providerType)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnConnectionProps"');
    }
    function cfnConnectionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectionPropsValidator(properties).assertSuccess(), { ConnectionName: cdk.stringToCloudFormation(properties.connectionName), HostArn: cdk.stringToCloudFormation(properties.hostArn), ProviderType: cdk.stringToCloudFormation(properties.providerType), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnConnectionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectionName", "ConnectionName", cfn_parse.FromCloudFormation.getString(properties.ConnectionName)), ret.addPropertyResult("hostArn", "HostArn", properties.HostArn != null ? cfn_parse.FromCloudFormation.getString(properties.HostArn) : void 0), ret.addPropertyResult("providerType", "ProviderType", properties.ProviderType != null ? cfn_parse.FromCloudFormation.getString(properties.ProviderType) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnConnection = class _CfnConnection extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnConnectionPropsFromCloudFormation(resourceProperties), ret = new _CfnConnection(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnConnection.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codestarconnections_CfnConnectionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnConnection), error;
        }
        cdk.requireProperty(props, "connectionName", this), this.attrConnectionArn = cdk.Token.asString(this.getAtt("ConnectionArn", cdk.ResolutionTypeHint.STRING)), this.attrConnectionStatus = cdk.Token.asString(this.getAtt("ConnectionStatus", cdk.ResolutionTypeHint.STRING)), this.attrOwnerAccountId = cdk.Token.asString(this.getAtt("OwnerAccountId", cdk.ResolutionTypeHint.STRING)), this.connectionName = props.connectionName, this.hostArn = props.hostArn, this.providerType = props.providerType, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::CodeStarConnections::Connection", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnConnection.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { connectionName: this.connectionName, hostArn: this.hostArn, providerType: this.providerType, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnConnectionPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnConnection[_a] = { fqn: "aws-cdk-lib.aws_codestarconnections.CfnConnection", version: "2.80.0" }, CfnConnection.CFN_RESOURCE_TYPE_NAME = "AWS::CodeStarConnections::Connection", exports2.CfnConnection = CfnConnection;
  }
});

// node_modules/aws-cdk-lib/aws-codestarconnections/lib/index.js
var require_lib87 = __commonJS({
  "node_modules/aws-cdk-lib/aws-codestarconnections/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_codestarconnections_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-codestarconnections/index.js
var require_aws_codestarconnections = __commonJS({
  "node_modules/aws-cdk-lib/aws-codestarconnections/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib87(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-cognito/lib/cognito.generated.js
var require_cognito_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-cognito/lib/cognito.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    var _l;
    var _m;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnUserPoolUserToGroupAttachment = exports2.CfnUserPoolUser = exports2.CfnUserPoolUICustomizationAttachment = exports2.CfnUserPoolRiskConfigurationAttachment = exports2.CfnUserPoolResourceServer = exports2.CfnUserPoolIdentityProvider = exports2.CfnUserPoolGroup = exports2.CfnUserPoolDomain = exports2.CfnUserPoolClient = exports2.CfnUserPool = exports2.CfnIdentityPoolRoleAttachment = exports2.CfnIdentityPool = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnIdentityPoolPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowClassicFlow", cdk.validateBoolean)(properties.allowClassicFlow)), errors.collect(cdk.propertyValidator("allowUnauthenticatedIdentities", cdk.requiredValidator)(properties.allowUnauthenticatedIdentities)), errors.collect(cdk.propertyValidator("allowUnauthenticatedIdentities", cdk.validateBoolean)(properties.allowUnauthenticatedIdentities)), errors.collect(cdk.propertyValidator("cognitoEvents", cdk.validateObject)(properties.cognitoEvents)), errors.collect(cdk.propertyValidator("cognitoIdentityProviders", cdk.listValidator(CfnIdentityPool_CognitoIdentityProviderPropertyValidator))(properties.cognitoIdentityProviders)), errors.collect(cdk.propertyValidator("cognitoStreams", CfnIdentityPool_CognitoStreamsPropertyValidator)(properties.cognitoStreams)), errors.collect(cdk.propertyValidator("developerProviderName", cdk.validateString)(properties.developerProviderName)), errors.collect(cdk.propertyValidator("identityPoolName", cdk.validateString)(properties.identityPoolName)), errors.collect(cdk.propertyValidator("openIdConnectProviderArns", cdk.listValidator(cdk.validateString))(properties.openIdConnectProviderArns)), errors.collect(cdk.propertyValidator("pushSync", CfnIdentityPool_PushSyncPropertyValidator)(properties.pushSync)), errors.collect(cdk.propertyValidator("samlProviderArns", cdk.listValidator(cdk.validateString))(properties.samlProviderArns)), errors.collect(cdk.propertyValidator("supportedLoginProviders", cdk.validateObject)(properties.supportedLoginProviders)), errors.wrap('supplied properties not correct for "CfnIdentityPoolProps"');
    }
    function cfnIdentityPoolPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIdentityPoolPropsValidator(properties).assertSuccess(), { AllowUnauthenticatedIdentities: cdk.booleanToCloudFormation(properties.allowUnauthenticatedIdentities), AllowClassicFlow: cdk.booleanToCloudFormation(properties.allowClassicFlow), CognitoEvents: cdk.objectToCloudFormation(properties.cognitoEvents), CognitoIdentityProviders: cdk.listMapper(cfnIdentityPoolCognitoIdentityProviderPropertyToCloudFormation)(properties.cognitoIdentityProviders), CognitoStreams: cfnIdentityPoolCognitoStreamsPropertyToCloudFormation(properties.cognitoStreams), DeveloperProviderName: cdk.stringToCloudFormation(properties.developerProviderName), IdentityPoolName: cdk.stringToCloudFormation(properties.identityPoolName), OpenIdConnectProviderARNs: cdk.listMapper(cdk.stringToCloudFormation)(properties.openIdConnectProviderArns), PushSync: cfnIdentityPoolPushSyncPropertyToCloudFormation(properties.pushSync), SamlProviderARNs: cdk.listMapper(cdk.stringToCloudFormation)(properties.samlProviderArns), SupportedLoginProviders: cdk.objectToCloudFormation(properties.supportedLoginProviders) }) : properties;
    }
    function CfnIdentityPoolPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowUnauthenticatedIdentities", "AllowUnauthenticatedIdentities", cfn_parse.FromCloudFormation.getBoolean(properties.AllowUnauthenticatedIdentities)), ret.addPropertyResult("allowClassicFlow", "AllowClassicFlow", properties.AllowClassicFlow != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllowClassicFlow) : void 0), ret.addPropertyResult("cognitoEvents", "CognitoEvents", properties.CognitoEvents != null ? cfn_parse.FromCloudFormation.getAny(properties.CognitoEvents) : void 0), ret.addPropertyResult("cognitoIdentityProviders", "CognitoIdentityProviders", properties.CognitoIdentityProviders != null ? cfn_parse.FromCloudFormation.getArray(CfnIdentityPoolCognitoIdentityProviderPropertyFromCloudFormation)(properties.CognitoIdentityProviders) : void 0), ret.addPropertyResult("cognitoStreams", "CognitoStreams", properties.CognitoStreams != null ? CfnIdentityPoolCognitoStreamsPropertyFromCloudFormation(properties.CognitoStreams) : void 0), ret.addPropertyResult("developerProviderName", "DeveloperProviderName", properties.DeveloperProviderName != null ? cfn_parse.FromCloudFormation.getString(properties.DeveloperProviderName) : void 0), ret.addPropertyResult("identityPoolName", "IdentityPoolName", properties.IdentityPoolName != null ? cfn_parse.FromCloudFormation.getString(properties.IdentityPoolName) : void 0), ret.addPropertyResult("openIdConnectProviderArns", "OpenIdConnectProviderARNs", properties.OpenIdConnectProviderARNs != null ? cfn_parse.FromCloudFormation.getStringArray(properties.OpenIdConnectProviderARNs) : void 0), ret.addPropertyResult("pushSync", "PushSync", properties.PushSync != null ? CfnIdentityPoolPushSyncPropertyFromCloudFormation(properties.PushSync) : void 0), ret.addPropertyResult("samlProviderArns", "SamlProviderARNs", properties.SamlProviderARNs != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SamlProviderARNs) : void 0), ret.addPropertyResult("supportedLoginProviders", "SupportedLoginProviders", properties.SupportedLoginProviders != null ? cfn_parse.FromCloudFormation.getAny(properties.SupportedLoginProviders) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnIdentityPool = class _CfnIdentityPool extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnIdentityPoolPropsFromCloudFormation(resourceProperties), ret = new _CfnIdentityPool(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnIdentityPool.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_CfnIdentityPoolProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnIdentityPool), error;
        }
        cdk.requireProperty(props, "allowUnauthenticatedIdentities", this), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.allowUnauthenticatedIdentities = props.allowUnauthenticatedIdentities, this.allowClassicFlow = props.allowClassicFlow, this.cognitoEvents = props.cognitoEvents, this.cognitoIdentityProviders = props.cognitoIdentityProviders, this.cognitoStreams = props.cognitoStreams, this.developerProviderName = props.developerProviderName, this.identityPoolName = props.identityPoolName, this.openIdConnectProviderArns = props.openIdConnectProviderArns, this.pushSync = props.pushSync, this.samlProviderArns = props.samlProviderArns, this.supportedLoginProviders = props.supportedLoginProviders;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnIdentityPool.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { allowUnauthenticatedIdentities: this.allowUnauthenticatedIdentities, allowClassicFlow: this.allowClassicFlow, cognitoEvents: this.cognitoEvents, cognitoIdentityProviders: this.cognitoIdentityProviders, cognitoStreams: this.cognitoStreams, developerProviderName: this.developerProviderName, identityPoolName: this.identityPoolName, openIdConnectProviderArns: this.openIdConnectProviderArns, pushSync: this.pushSync, samlProviderArns: this.samlProviderArns, supportedLoginProviders: this.supportedLoginProviders };
      }
      renderProperties(props) {
        return cfnIdentityPoolPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnIdentityPool[_a] = { fqn: "aws-cdk-lib.aws_cognito.CfnIdentityPool", version: "2.80.0" }, CfnIdentityPool.CFN_RESOURCE_TYPE_NAME = "AWS::Cognito::IdentityPool", exports2.CfnIdentityPool = CfnIdentityPool;
    function CfnIdentityPool_CognitoIdentityProviderPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clientId", cdk.validateString)(properties.clientId)), errors.collect(cdk.propertyValidator("providerName", cdk.validateString)(properties.providerName)), errors.collect(cdk.propertyValidator("serverSideTokenCheck", cdk.validateBoolean)(properties.serverSideTokenCheck)), errors.wrap('supplied properties not correct for "CognitoIdentityProviderProperty"');
    }
    function cfnIdentityPoolCognitoIdentityProviderPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIdentityPool_CognitoIdentityProviderPropertyValidator(properties).assertSuccess(), { ClientId: cdk.stringToCloudFormation(properties.clientId), ProviderName: cdk.stringToCloudFormation(properties.providerName), ServerSideTokenCheck: cdk.booleanToCloudFormation(properties.serverSideTokenCheck) }) : properties;
    }
    function CfnIdentityPoolCognitoIdentityProviderPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clientId", "ClientId", properties.ClientId != null ? cfn_parse.FromCloudFormation.getString(properties.ClientId) : void 0), ret.addPropertyResult("providerName", "ProviderName", properties.ProviderName != null ? cfn_parse.FromCloudFormation.getString(properties.ProviderName) : void 0), ret.addPropertyResult("serverSideTokenCheck", "ServerSideTokenCheck", properties.ServerSideTokenCheck != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ServerSideTokenCheck) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIdentityPool_CognitoStreamsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("streamName", cdk.validateString)(properties.streamName)), errors.collect(cdk.propertyValidator("streamingStatus", cdk.validateString)(properties.streamingStatus)), errors.wrap('supplied properties not correct for "CognitoStreamsProperty"');
    }
    function cfnIdentityPoolCognitoStreamsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIdentityPool_CognitoStreamsPropertyValidator(properties).assertSuccess(), { RoleArn: cdk.stringToCloudFormation(properties.roleArn), StreamName: cdk.stringToCloudFormation(properties.streamName), StreamingStatus: cdk.stringToCloudFormation(properties.streamingStatus) }) : properties;
    }
    function CfnIdentityPoolCognitoStreamsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addPropertyResult("streamName", "StreamName", properties.StreamName != null ? cfn_parse.FromCloudFormation.getString(properties.StreamName) : void 0), ret.addPropertyResult("streamingStatus", "StreamingStatus", properties.StreamingStatus != null ? cfn_parse.FromCloudFormation.getString(properties.StreamingStatus) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIdentityPool_PushSyncPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationArns", cdk.listValidator(cdk.validateString))(properties.applicationArns)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "PushSyncProperty"');
    }
    function cfnIdentityPoolPushSyncPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIdentityPool_PushSyncPropertyValidator(properties).assertSuccess(), { ApplicationArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.applicationArns), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnIdentityPoolPushSyncPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationArns", "ApplicationArns", properties.ApplicationArns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ApplicationArns) : void 0), ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIdentityPoolRoleAttachmentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("identityPoolId", cdk.requiredValidator)(properties.identityPoolId)), errors.collect(cdk.propertyValidator("identityPoolId", cdk.validateString)(properties.identityPoolId)), errors.collect(cdk.propertyValidator("roleMappings", cdk.hashValidator(CfnIdentityPoolRoleAttachment_RoleMappingPropertyValidator))(properties.roleMappings)), errors.collect(cdk.propertyValidator("roles", cdk.validateObject)(properties.roles)), errors.wrap('supplied properties not correct for "CfnIdentityPoolRoleAttachmentProps"');
    }
    function cfnIdentityPoolRoleAttachmentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIdentityPoolRoleAttachmentPropsValidator(properties).assertSuccess(), { IdentityPoolId: cdk.stringToCloudFormation(properties.identityPoolId), RoleMappings: cdk.hashMapper(cfnIdentityPoolRoleAttachmentRoleMappingPropertyToCloudFormation)(properties.roleMappings), Roles: cdk.objectToCloudFormation(properties.roles) }) : properties;
    }
    function CfnIdentityPoolRoleAttachmentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("identityPoolId", "IdentityPoolId", cfn_parse.FromCloudFormation.getString(properties.IdentityPoolId)), ret.addPropertyResult("roleMappings", "RoleMappings", properties.RoleMappings != null ? cfn_parse.FromCloudFormation.getMap(CfnIdentityPoolRoleAttachmentRoleMappingPropertyFromCloudFormation)(properties.RoleMappings) : void 0), ret.addPropertyResult("roles", "Roles", properties.Roles != null ? cfn_parse.FromCloudFormation.getAny(properties.Roles) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnIdentityPoolRoleAttachment = class _CfnIdentityPoolRoleAttachment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnIdentityPoolRoleAttachmentPropsFromCloudFormation(resourceProperties), ret = new _CfnIdentityPoolRoleAttachment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnIdentityPoolRoleAttachment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_CfnIdentityPoolRoleAttachmentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnIdentityPoolRoleAttachment), error;
        }
        cdk.requireProperty(props, "identityPoolId", this), this.identityPoolId = props.identityPoolId, this.roleMappings = props.roleMappings, this.roles = props.roles;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnIdentityPoolRoleAttachment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { identityPoolId: this.identityPoolId, roleMappings: this.roleMappings, roles: this.roles };
      }
      renderProperties(props) {
        return cfnIdentityPoolRoleAttachmentPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnIdentityPoolRoleAttachment[_b] = { fqn: "aws-cdk-lib.aws_cognito.CfnIdentityPoolRoleAttachment", version: "2.80.0" }, CfnIdentityPoolRoleAttachment.CFN_RESOURCE_TYPE_NAME = "AWS::Cognito::IdentityPoolRoleAttachment", exports2.CfnIdentityPoolRoleAttachment = CfnIdentityPoolRoleAttachment;
    function CfnIdentityPoolRoleAttachment_MappingRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("claim", cdk.requiredValidator)(properties.claim)), errors.collect(cdk.propertyValidator("claim", cdk.validateString)(properties.claim)), errors.collect(cdk.propertyValidator("matchType", cdk.requiredValidator)(properties.matchType)), errors.collect(cdk.propertyValidator("matchType", cdk.validateString)(properties.matchType)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "MappingRuleProperty"');
    }
    function cfnIdentityPoolRoleAttachmentMappingRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIdentityPoolRoleAttachment_MappingRulePropertyValidator(properties).assertSuccess(), { Claim: cdk.stringToCloudFormation(properties.claim), MatchType: cdk.stringToCloudFormation(properties.matchType), RoleARN: cdk.stringToCloudFormation(properties.roleArn), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnIdentityPoolRoleAttachmentMappingRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("claim", "Claim", cfn_parse.FromCloudFormation.getString(properties.Claim)), ret.addPropertyResult("matchType", "MatchType", cfn_parse.FromCloudFormation.getString(properties.MatchType)), ret.addPropertyResult("roleArn", "RoleARN", cfn_parse.FromCloudFormation.getString(properties.RoleARN)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIdentityPoolRoleAttachment_RoleMappingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ambiguousRoleResolution", cdk.validateString)(properties.ambiguousRoleResolution)), errors.collect(cdk.propertyValidator("identityProvider", cdk.validateString)(properties.identityProvider)), errors.collect(cdk.propertyValidator("rulesConfiguration", CfnIdentityPoolRoleAttachment_RulesConfigurationTypePropertyValidator)(properties.rulesConfiguration)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "RoleMappingProperty"');
    }
    function cfnIdentityPoolRoleAttachmentRoleMappingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIdentityPoolRoleAttachment_RoleMappingPropertyValidator(properties).assertSuccess(), { AmbiguousRoleResolution: cdk.stringToCloudFormation(properties.ambiguousRoleResolution), IdentityProvider: cdk.stringToCloudFormation(properties.identityProvider), RulesConfiguration: cfnIdentityPoolRoleAttachmentRulesConfigurationTypePropertyToCloudFormation(properties.rulesConfiguration), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnIdentityPoolRoleAttachmentRoleMappingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ambiguousRoleResolution", "AmbiguousRoleResolution", properties.AmbiguousRoleResolution != null ? cfn_parse.FromCloudFormation.getString(properties.AmbiguousRoleResolution) : void 0), ret.addPropertyResult("identityProvider", "IdentityProvider", properties.IdentityProvider != null ? cfn_parse.FromCloudFormation.getString(properties.IdentityProvider) : void 0), ret.addPropertyResult("rulesConfiguration", "RulesConfiguration", properties.RulesConfiguration != null ? CfnIdentityPoolRoleAttachmentRulesConfigurationTypePropertyFromCloudFormation(properties.RulesConfiguration) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIdentityPoolRoleAttachment_RulesConfigurationTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("rules", cdk.requiredValidator)(properties.rules)), errors.collect(cdk.propertyValidator("rules", cdk.listValidator(CfnIdentityPoolRoleAttachment_MappingRulePropertyValidator))(properties.rules)), errors.wrap('supplied properties not correct for "RulesConfigurationTypeProperty"');
    }
    function cfnIdentityPoolRoleAttachmentRulesConfigurationTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIdentityPoolRoleAttachment_RulesConfigurationTypePropertyValidator(properties).assertSuccess(), { Rules: cdk.listMapper(cfnIdentityPoolRoleAttachmentMappingRulePropertyToCloudFormation)(properties.rules) }) : properties;
    }
    function CfnIdentityPoolRoleAttachmentRulesConfigurationTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("rules", "Rules", cfn_parse.FromCloudFormation.getArray(CfnIdentityPoolRoleAttachmentMappingRulePropertyFromCloudFormation)(properties.Rules)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPoolPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accountRecoverySetting", CfnUserPool_AccountRecoverySettingPropertyValidator)(properties.accountRecoverySetting)), errors.collect(cdk.propertyValidator("adminCreateUserConfig", CfnUserPool_AdminCreateUserConfigPropertyValidator)(properties.adminCreateUserConfig)), errors.collect(cdk.propertyValidator("aliasAttributes", cdk.listValidator(cdk.validateString))(properties.aliasAttributes)), errors.collect(cdk.propertyValidator("autoVerifiedAttributes", cdk.listValidator(cdk.validateString))(properties.autoVerifiedAttributes)), errors.collect(cdk.propertyValidator("deletionProtection", cdk.validateString)(properties.deletionProtection)), errors.collect(cdk.propertyValidator("deviceConfiguration", CfnUserPool_DeviceConfigurationPropertyValidator)(properties.deviceConfiguration)), errors.collect(cdk.propertyValidator("emailConfiguration", CfnUserPool_EmailConfigurationPropertyValidator)(properties.emailConfiguration)), errors.collect(cdk.propertyValidator("emailVerificationMessage", cdk.validateString)(properties.emailVerificationMessage)), errors.collect(cdk.propertyValidator("emailVerificationSubject", cdk.validateString)(properties.emailVerificationSubject)), errors.collect(cdk.propertyValidator("enabledMfas", cdk.listValidator(cdk.validateString))(properties.enabledMfas)), errors.collect(cdk.propertyValidator("lambdaConfig", CfnUserPool_LambdaConfigPropertyValidator)(properties.lambdaConfig)), errors.collect(cdk.propertyValidator("mfaConfiguration", cdk.validateString)(properties.mfaConfiguration)), errors.collect(cdk.propertyValidator("policies", CfnUserPool_PoliciesPropertyValidator)(properties.policies)), errors.collect(cdk.propertyValidator("schema", cdk.listValidator(CfnUserPool_SchemaAttributePropertyValidator))(properties.schema)), errors.collect(cdk.propertyValidator("smsAuthenticationMessage", cdk.validateString)(properties.smsAuthenticationMessage)), errors.collect(cdk.propertyValidator("smsConfiguration", CfnUserPool_SmsConfigurationPropertyValidator)(properties.smsConfiguration)), errors.collect(cdk.propertyValidator("smsVerificationMessage", cdk.validateString)(properties.smsVerificationMessage)), errors.collect(cdk.propertyValidator("userAttributeUpdateSettings", CfnUserPool_UserAttributeUpdateSettingsPropertyValidator)(properties.userAttributeUpdateSettings)), errors.collect(cdk.propertyValidator("userPoolAddOns", CfnUserPool_UserPoolAddOnsPropertyValidator)(properties.userPoolAddOns)), errors.collect(cdk.propertyValidator("userPoolName", cdk.validateString)(properties.userPoolName)), errors.collect(cdk.propertyValidator("userPoolTags", cdk.validateObject)(properties.userPoolTags)), errors.collect(cdk.propertyValidator("usernameAttributes", cdk.listValidator(cdk.validateString))(properties.usernameAttributes)), errors.collect(cdk.propertyValidator("usernameConfiguration", CfnUserPool_UsernameConfigurationPropertyValidator)(properties.usernameConfiguration)), errors.collect(cdk.propertyValidator("verificationMessageTemplate", CfnUserPool_VerificationMessageTemplatePropertyValidator)(properties.verificationMessageTemplate)), errors.wrap('supplied properties not correct for "CfnUserPoolProps"');
    }
    function cfnUserPoolPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPoolPropsValidator(properties).assertSuccess(), { AccountRecoverySetting: cfnUserPoolAccountRecoverySettingPropertyToCloudFormation(properties.accountRecoverySetting), AdminCreateUserConfig: cfnUserPoolAdminCreateUserConfigPropertyToCloudFormation(properties.adminCreateUserConfig), AliasAttributes: cdk.listMapper(cdk.stringToCloudFormation)(properties.aliasAttributes), AutoVerifiedAttributes: cdk.listMapper(cdk.stringToCloudFormation)(properties.autoVerifiedAttributes), DeletionProtection: cdk.stringToCloudFormation(properties.deletionProtection), DeviceConfiguration: cfnUserPoolDeviceConfigurationPropertyToCloudFormation(properties.deviceConfiguration), EmailConfiguration: cfnUserPoolEmailConfigurationPropertyToCloudFormation(properties.emailConfiguration), EmailVerificationMessage: cdk.stringToCloudFormation(properties.emailVerificationMessage), EmailVerificationSubject: cdk.stringToCloudFormation(properties.emailVerificationSubject), EnabledMfas: cdk.listMapper(cdk.stringToCloudFormation)(properties.enabledMfas), LambdaConfig: cfnUserPoolLambdaConfigPropertyToCloudFormation(properties.lambdaConfig), MfaConfiguration: cdk.stringToCloudFormation(properties.mfaConfiguration), Policies: cfnUserPoolPoliciesPropertyToCloudFormation(properties.policies), Schema: cdk.listMapper(cfnUserPoolSchemaAttributePropertyToCloudFormation)(properties.schema), SmsAuthenticationMessage: cdk.stringToCloudFormation(properties.smsAuthenticationMessage), SmsConfiguration: cfnUserPoolSmsConfigurationPropertyToCloudFormation(properties.smsConfiguration), SmsVerificationMessage: cdk.stringToCloudFormation(properties.smsVerificationMessage), UserAttributeUpdateSettings: cfnUserPoolUserAttributeUpdateSettingsPropertyToCloudFormation(properties.userAttributeUpdateSettings), UsernameAttributes: cdk.listMapper(cdk.stringToCloudFormation)(properties.usernameAttributes), UsernameConfiguration: cfnUserPoolUsernameConfigurationPropertyToCloudFormation(properties.usernameConfiguration), UserPoolAddOns: cfnUserPoolUserPoolAddOnsPropertyToCloudFormation(properties.userPoolAddOns), UserPoolName: cdk.stringToCloudFormation(properties.userPoolName), UserPoolTags: cdk.objectToCloudFormation(properties.userPoolTags), VerificationMessageTemplate: cfnUserPoolVerificationMessageTemplatePropertyToCloudFormation(properties.verificationMessageTemplate) }) : properties;
    }
    function CfnUserPoolPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accountRecoverySetting", "AccountRecoverySetting", properties.AccountRecoverySetting != null ? CfnUserPoolAccountRecoverySettingPropertyFromCloudFormation(properties.AccountRecoverySetting) : void 0), ret.addPropertyResult("adminCreateUserConfig", "AdminCreateUserConfig", properties.AdminCreateUserConfig != null ? CfnUserPoolAdminCreateUserConfigPropertyFromCloudFormation(properties.AdminCreateUserConfig) : void 0), ret.addPropertyResult("aliasAttributes", "AliasAttributes", properties.AliasAttributes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AliasAttributes) : void 0), ret.addPropertyResult("autoVerifiedAttributes", "AutoVerifiedAttributes", properties.AutoVerifiedAttributes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AutoVerifiedAttributes) : void 0), ret.addPropertyResult("deletionProtection", "DeletionProtection", properties.DeletionProtection != null ? cfn_parse.FromCloudFormation.getString(properties.DeletionProtection) : void 0), ret.addPropertyResult("deviceConfiguration", "DeviceConfiguration", properties.DeviceConfiguration != null ? CfnUserPoolDeviceConfigurationPropertyFromCloudFormation(properties.DeviceConfiguration) : void 0), ret.addPropertyResult("emailConfiguration", "EmailConfiguration", properties.EmailConfiguration != null ? CfnUserPoolEmailConfigurationPropertyFromCloudFormation(properties.EmailConfiguration) : void 0), ret.addPropertyResult("emailVerificationMessage", "EmailVerificationMessage", properties.EmailVerificationMessage != null ? cfn_parse.FromCloudFormation.getString(properties.EmailVerificationMessage) : void 0), ret.addPropertyResult("emailVerificationSubject", "EmailVerificationSubject", properties.EmailVerificationSubject != null ? cfn_parse.FromCloudFormation.getString(properties.EmailVerificationSubject) : void 0), ret.addPropertyResult("enabledMfas", "EnabledMfas", properties.EnabledMfas != null ? cfn_parse.FromCloudFormation.getStringArray(properties.EnabledMfas) : void 0), ret.addPropertyResult("lambdaConfig", "LambdaConfig", properties.LambdaConfig != null ? CfnUserPoolLambdaConfigPropertyFromCloudFormation(properties.LambdaConfig) : void 0), ret.addPropertyResult("mfaConfiguration", "MfaConfiguration", properties.MfaConfiguration != null ? cfn_parse.FromCloudFormation.getString(properties.MfaConfiguration) : void 0), ret.addPropertyResult("policies", "Policies", properties.Policies != null ? CfnUserPoolPoliciesPropertyFromCloudFormation(properties.Policies) : void 0), ret.addPropertyResult("schema", "Schema", properties.Schema != null ? cfn_parse.FromCloudFormation.getArray(CfnUserPoolSchemaAttributePropertyFromCloudFormation)(properties.Schema) : void 0), ret.addPropertyResult("smsAuthenticationMessage", "SmsAuthenticationMessage", properties.SmsAuthenticationMessage != null ? cfn_parse.FromCloudFormation.getString(properties.SmsAuthenticationMessage) : void 0), ret.addPropertyResult("smsConfiguration", "SmsConfiguration", properties.SmsConfiguration != null ? CfnUserPoolSmsConfigurationPropertyFromCloudFormation(properties.SmsConfiguration) : void 0), ret.addPropertyResult("smsVerificationMessage", "SmsVerificationMessage", properties.SmsVerificationMessage != null ? cfn_parse.FromCloudFormation.getString(properties.SmsVerificationMessage) : void 0), ret.addPropertyResult("userAttributeUpdateSettings", "UserAttributeUpdateSettings", properties.UserAttributeUpdateSettings != null ? CfnUserPoolUserAttributeUpdateSettingsPropertyFromCloudFormation(properties.UserAttributeUpdateSettings) : void 0), ret.addPropertyResult("usernameAttributes", "UsernameAttributes", properties.UsernameAttributes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.UsernameAttributes) : void 0), ret.addPropertyResult("usernameConfiguration", "UsernameConfiguration", properties.UsernameConfiguration != null ? CfnUserPoolUsernameConfigurationPropertyFromCloudFormation(properties.UsernameConfiguration) : void 0), ret.addPropertyResult("userPoolAddOns", "UserPoolAddOns", properties.UserPoolAddOns != null ? CfnUserPoolUserPoolAddOnsPropertyFromCloudFormation(properties.UserPoolAddOns) : void 0), ret.addPropertyResult("userPoolName", "UserPoolName", properties.UserPoolName != null ? cfn_parse.FromCloudFormation.getString(properties.UserPoolName) : void 0), ret.addPropertyResult("userPoolTags", "UserPoolTags", properties.UserPoolTags != null ? cfn_parse.FromCloudFormation.getAny(properties.UserPoolTags) : void 0), ret.addPropertyResult("verificationMessageTemplate", "VerificationMessageTemplate", properties.VerificationMessageTemplate != null ? CfnUserPoolVerificationMessageTemplatePropertyFromCloudFormation(properties.VerificationMessageTemplate) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnUserPool = class _CfnUserPool extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnUserPoolPropsFromCloudFormation(resourceProperties), ret = new _CfnUserPool(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnUserPool.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_CfnUserPoolProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnUserPool), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrProviderName = cdk.Token.asString(this.getAtt("ProviderName", cdk.ResolutionTypeHint.STRING)), this.attrProviderUrl = cdk.Token.asString(this.getAtt("ProviderURL", cdk.ResolutionTypeHint.STRING)), this.accountRecoverySetting = props.accountRecoverySetting, this.adminCreateUserConfig = props.adminCreateUserConfig, this.aliasAttributes = props.aliasAttributes, this.autoVerifiedAttributes = props.autoVerifiedAttributes, this.deletionProtection = props.deletionProtection, this.deviceConfiguration = props.deviceConfiguration, this.emailConfiguration = props.emailConfiguration, this.emailVerificationMessage = props.emailVerificationMessage, this.emailVerificationSubject = props.emailVerificationSubject, this.enabledMfas = props.enabledMfas, this.lambdaConfig = props.lambdaConfig, this.mfaConfiguration = props.mfaConfiguration, this.policies = props.policies, this.schema = props.schema, this.smsAuthenticationMessage = props.smsAuthenticationMessage, this.smsConfiguration = props.smsConfiguration, this.smsVerificationMessage = props.smsVerificationMessage, this.userAttributeUpdateSettings = props.userAttributeUpdateSettings, this.usernameAttributes = props.usernameAttributes, this.usernameConfiguration = props.usernameConfiguration, this.userPoolAddOns = props.userPoolAddOns, this.userPoolName = props.userPoolName, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Cognito::UserPool", props.userPoolTags, { tagPropertyName: "userPoolTags" }), this.verificationMessageTemplate = props.verificationMessageTemplate, this.node.scope && cdk.Resource.isResource(this.node.scope) && this.node.addValidation({ validate: () => this.cfnOptions.deletionPolicy === void 0 ? ["'AWS::Cognito::UserPool' is a stateful resource type, and you must specify a Removal Policy for it. Call 'resource.applyRemovalPolicy()'."] : [] });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnUserPool.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { accountRecoverySetting: this.accountRecoverySetting, adminCreateUserConfig: this.adminCreateUserConfig, aliasAttributes: this.aliasAttributes, autoVerifiedAttributes: this.autoVerifiedAttributes, deletionProtection: this.deletionProtection, deviceConfiguration: this.deviceConfiguration, emailConfiguration: this.emailConfiguration, emailVerificationMessage: this.emailVerificationMessage, emailVerificationSubject: this.emailVerificationSubject, enabledMfas: this.enabledMfas, lambdaConfig: this.lambdaConfig, mfaConfiguration: this.mfaConfiguration, policies: this.policies, schema: this.schema, smsAuthenticationMessage: this.smsAuthenticationMessage, smsConfiguration: this.smsConfiguration, smsVerificationMessage: this.smsVerificationMessage, userAttributeUpdateSettings: this.userAttributeUpdateSettings, usernameAttributes: this.usernameAttributes, usernameConfiguration: this.usernameConfiguration, userPoolAddOns: this.userPoolAddOns, userPoolName: this.userPoolName, userPoolTags: this.tags.renderTags(), verificationMessageTemplate: this.verificationMessageTemplate };
      }
      renderProperties(props) {
        return cfnUserPoolPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnUserPool[_c] = { fqn: "aws-cdk-lib.aws_cognito.CfnUserPool", version: "2.80.0" }, CfnUserPool.CFN_RESOURCE_TYPE_NAME = "AWS::Cognito::UserPool", exports2.CfnUserPool = CfnUserPool;
    function CfnUserPool_AccountRecoverySettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("recoveryMechanisms", cdk.listValidator(CfnUserPool_RecoveryOptionPropertyValidator))(properties.recoveryMechanisms)), errors.wrap('supplied properties not correct for "AccountRecoverySettingProperty"');
    }
    function cfnUserPoolAccountRecoverySettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPool_AccountRecoverySettingPropertyValidator(properties).assertSuccess(), { RecoveryMechanisms: cdk.listMapper(cfnUserPoolRecoveryOptionPropertyToCloudFormation)(properties.recoveryMechanisms) }) : properties;
    }
    function CfnUserPoolAccountRecoverySettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("recoveryMechanisms", "RecoveryMechanisms", properties.RecoveryMechanisms != null ? cfn_parse.FromCloudFormation.getArray(CfnUserPoolRecoveryOptionPropertyFromCloudFormation)(properties.RecoveryMechanisms) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPool_AdminCreateUserConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowAdminCreateUserOnly", cdk.validateBoolean)(properties.allowAdminCreateUserOnly)), errors.collect(cdk.propertyValidator("inviteMessageTemplate", CfnUserPool_InviteMessageTemplatePropertyValidator)(properties.inviteMessageTemplate)), errors.collect(cdk.propertyValidator("unusedAccountValidityDays", cdk.validateNumber)(properties.unusedAccountValidityDays)), errors.wrap('supplied properties not correct for "AdminCreateUserConfigProperty"');
    }
    function cfnUserPoolAdminCreateUserConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPool_AdminCreateUserConfigPropertyValidator(properties).assertSuccess(), { AllowAdminCreateUserOnly: cdk.booleanToCloudFormation(properties.allowAdminCreateUserOnly), InviteMessageTemplate: cfnUserPoolInviteMessageTemplatePropertyToCloudFormation(properties.inviteMessageTemplate), UnusedAccountValidityDays: cdk.numberToCloudFormation(properties.unusedAccountValidityDays) }) : properties;
    }
    function CfnUserPoolAdminCreateUserConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowAdminCreateUserOnly", "AllowAdminCreateUserOnly", properties.AllowAdminCreateUserOnly != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllowAdminCreateUserOnly) : void 0), ret.addPropertyResult("inviteMessageTemplate", "InviteMessageTemplate", properties.InviteMessageTemplate != null ? CfnUserPoolInviteMessageTemplatePropertyFromCloudFormation(properties.InviteMessageTemplate) : void 0), ret.addPropertyResult("unusedAccountValidityDays", "UnusedAccountValidityDays", properties.UnusedAccountValidityDays != null ? cfn_parse.FromCloudFormation.getNumber(properties.UnusedAccountValidityDays) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPool_CustomEmailSenderPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("lambdaArn", cdk.validateString)(properties.lambdaArn)), errors.collect(cdk.propertyValidator("lambdaVersion", cdk.validateString)(properties.lambdaVersion)), errors.wrap('supplied properties not correct for "CustomEmailSenderProperty"');
    }
    function cfnUserPoolCustomEmailSenderPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPool_CustomEmailSenderPropertyValidator(properties).assertSuccess(), { LambdaArn: cdk.stringToCloudFormation(properties.lambdaArn), LambdaVersion: cdk.stringToCloudFormation(properties.lambdaVersion) }) : properties;
    }
    function CfnUserPoolCustomEmailSenderPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("lambdaArn", "LambdaArn", properties.LambdaArn != null ? cfn_parse.FromCloudFormation.getString(properties.LambdaArn) : void 0), ret.addPropertyResult("lambdaVersion", "LambdaVersion", properties.LambdaVersion != null ? cfn_parse.FromCloudFormation.getString(properties.LambdaVersion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPool_CustomSMSSenderPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("lambdaArn", cdk.validateString)(properties.lambdaArn)), errors.collect(cdk.propertyValidator("lambdaVersion", cdk.validateString)(properties.lambdaVersion)), errors.wrap('supplied properties not correct for "CustomSMSSenderProperty"');
    }
    function cfnUserPoolCustomSMSSenderPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPool_CustomSMSSenderPropertyValidator(properties).assertSuccess(), { LambdaArn: cdk.stringToCloudFormation(properties.lambdaArn), LambdaVersion: cdk.stringToCloudFormation(properties.lambdaVersion) }) : properties;
    }
    function CfnUserPoolCustomSMSSenderPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("lambdaArn", "LambdaArn", properties.LambdaArn != null ? cfn_parse.FromCloudFormation.getString(properties.LambdaArn) : void 0), ret.addPropertyResult("lambdaVersion", "LambdaVersion", properties.LambdaVersion != null ? cfn_parse.FromCloudFormation.getString(properties.LambdaVersion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPool_DeviceConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("challengeRequiredOnNewDevice", cdk.validateBoolean)(properties.challengeRequiredOnNewDevice)), errors.collect(cdk.propertyValidator("deviceOnlyRememberedOnUserPrompt", cdk.validateBoolean)(properties.deviceOnlyRememberedOnUserPrompt)), errors.wrap('supplied properties not correct for "DeviceConfigurationProperty"');
    }
    function cfnUserPoolDeviceConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPool_DeviceConfigurationPropertyValidator(properties).assertSuccess(), { ChallengeRequiredOnNewDevice: cdk.booleanToCloudFormation(properties.challengeRequiredOnNewDevice), DeviceOnlyRememberedOnUserPrompt: cdk.booleanToCloudFormation(properties.deviceOnlyRememberedOnUserPrompt) }) : properties;
    }
    function CfnUserPoolDeviceConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("challengeRequiredOnNewDevice", "ChallengeRequiredOnNewDevice", properties.ChallengeRequiredOnNewDevice != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ChallengeRequiredOnNewDevice) : void 0), ret.addPropertyResult("deviceOnlyRememberedOnUserPrompt", "DeviceOnlyRememberedOnUserPrompt", properties.DeviceOnlyRememberedOnUserPrompt != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeviceOnlyRememberedOnUserPrompt) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPool_EmailConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configurationSet", cdk.validateString)(properties.configurationSet)), errors.collect(cdk.propertyValidator("emailSendingAccount", cdk.validateString)(properties.emailSendingAccount)), errors.collect(cdk.propertyValidator("from", cdk.validateString)(properties.from)), errors.collect(cdk.propertyValidator("replyToEmailAddress", cdk.validateString)(properties.replyToEmailAddress)), errors.collect(cdk.propertyValidator("sourceArn", cdk.validateString)(properties.sourceArn)), errors.wrap('supplied properties not correct for "EmailConfigurationProperty"');
    }
    function cfnUserPoolEmailConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPool_EmailConfigurationPropertyValidator(properties).assertSuccess(), { ConfigurationSet: cdk.stringToCloudFormation(properties.configurationSet), EmailSendingAccount: cdk.stringToCloudFormation(properties.emailSendingAccount), From: cdk.stringToCloudFormation(properties.from), ReplyToEmailAddress: cdk.stringToCloudFormation(properties.replyToEmailAddress), SourceArn: cdk.stringToCloudFormation(properties.sourceArn) }) : properties;
    }
    function CfnUserPoolEmailConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configurationSet", "ConfigurationSet", properties.ConfigurationSet != null ? cfn_parse.FromCloudFormation.getString(properties.ConfigurationSet) : void 0), ret.addPropertyResult("emailSendingAccount", "EmailSendingAccount", properties.EmailSendingAccount != null ? cfn_parse.FromCloudFormation.getString(properties.EmailSendingAccount) : void 0), ret.addPropertyResult("from", "From", properties.From != null ? cfn_parse.FromCloudFormation.getString(properties.From) : void 0), ret.addPropertyResult("replyToEmailAddress", "ReplyToEmailAddress", properties.ReplyToEmailAddress != null ? cfn_parse.FromCloudFormation.getString(properties.ReplyToEmailAddress) : void 0), ret.addPropertyResult("sourceArn", "SourceArn", properties.SourceArn != null ? cfn_parse.FromCloudFormation.getString(properties.SourceArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPool_InviteMessageTemplatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("emailMessage", cdk.validateString)(properties.emailMessage)), errors.collect(cdk.propertyValidator("emailSubject", cdk.validateString)(properties.emailSubject)), errors.collect(cdk.propertyValidator("smsMessage", cdk.validateString)(properties.smsMessage)), errors.wrap('supplied properties not correct for "InviteMessageTemplateProperty"');
    }
    function cfnUserPoolInviteMessageTemplatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPool_InviteMessageTemplatePropertyValidator(properties).assertSuccess(), { EmailMessage: cdk.stringToCloudFormation(properties.emailMessage), EmailSubject: cdk.stringToCloudFormation(properties.emailSubject), SMSMessage: cdk.stringToCloudFormation(properties.smsMessage) }) : properties;
    }
    function CfnUserPoolInviteMessageTemplatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("emailMessage", "EmailMessage", properties.EmailMessage != null ? cfn_parse.FromCloudFormation.getString(properties.EmailMessage) : void 0), ret.addPropertyResult("emailSubject", "EmailSubject", properties.EmailSubject != null ? cfn_parse.FromCloudFormation.getString(properties.EmailSubject) : void 0), ret.addPropertyResult("smsMessage", "SMSMessage", properties.SMSMessage != null ? cfn_parse.FromCloudFormation.getString(properties.SMSMessage) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPool_LambdaConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("createAuthChallenge", cdk.validateString)(properties.createAuthChallenge)), errors.collect(cdk.propertyValidator("customEmailSender", CfnUserPool_CustomEmailSenderPropertyValidator)(properties.customEmailSender)), errors.collect(cdk.propertyValidator("customMessage", cdk.validateString)(properties.customMessage)), errors.collect(cdk.propertyValidator("customSmsSender", CfnUserPool_CustomSMSSenderPropertyValidator)(properties.customSmsSender)), errors.collect(cdk.propertyValidator("defineAuthChallenge", cdk.validateString)(properties.defineAuthChallenge)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("postAuthentication", cdk.validateString)(properties.postAuthentication)), errors.collect(cdk.propertyValidator("postConfirmation", cdk.validateString)(properties.postConfirmation)), errors.collect(cdk.propertyValidator("preAuthentication", cdk.validateString)(properties.preAuthentication)), errors.collect(cdk.propertyValidator("preSignUp", cdk.validateString)(properties.preSignUp)), errors.collect(cdk.propertyValidator("preTokenGeneration", cdk.validateString)(properties.preTokenGeneration)), errors.collect(cdk.propertyValidator("userMigration", cdk.validateString)(properties.userMigration)), errors.collect(cdk.propertyValidator("verifyAuthChallengeResponse", cdk.validateString)(properties.verifyAuthChallengeResponse)), errors.wrap('supplied properties not correct for "LambdaConfigProperty"');
    }
    function cfnUserPoolLambdaConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPool_LambdaConfigPropertyValidator(properties).assertSuccess(), { CreateAuthChallenge: cdk.stringToCloudFormation(properties.createAuthChallenge), CustomEmailSender: cfnUserPoolCustomEmailSenderPropertyToCloudFormation(properties.customEmailSender), CustomMessage: cdk.stringToCloudFormation(properties.customMessage), CustomSMSSender: cfnUserPoolCustomSMSSenderPropertyToCloudFormation(properties.customSmsSender), DefineAuthChallenge: cdk.stringToCloudFormation(properties.defineAuthChallenge), KMSKeyID: cdk.stringToCloudFormation(properties.kmsKeyId), PostAuthentication: cdk.stringToCloudFormation(properties.postAuthentication), PostConfirmation: cdk.stringToCloudFormation(properties.postConfirmation), PreAuthentication: cdk.stringToCloudFormation(properties.preAuthentication), PreSignUp: cdk.stringToCloudFormation(properties.preSignUp), PreTokenGeneration: cdk.stringToCloudFormation(properties.preTokenGeneration), UserMigration: cdk.stringToCloudFormation(properties.userMigration), VerifyAuthChallengeResponse: cdk.stringToCloudFormation(properties.verifyAuthChallengeResponse) }) : properties;
    }
    function CfnUserPoolLambdaConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("createAuthChallenge", "CreateAuthChallenge", properties.CreateAuthChallenge != null ? cfn_parse.FromCloudFormation.getString(properties.CreateAuthChallenge) : void 0), ret.addPropertyResult("customEmailSender", "CustomEmailSender", properties.CustomEmailSender != null ? CfnUserPoolCustomEmailSenderPropertyFromCloudFormation(properties.CustomEmailSender) : void 0), ret.addPropertyResult("customMessage", "CustomMessage", properties.CustomMessage != null ? cfn_parse.FromCloudFormation.getString(properties.CustomMessage) : void 0), ret.addPropertyResult("customSmsSender", "CustomSMSSender", properties.CustomSMSSender != null ? CfnUserPoolCustomSMSSenderPropertyFromCloudFormation(properties.CustomSMSSender) : void 0), ret.addPropertyResult("defineAuthChallenge", "DefineAuthChallenge", properties.DefineAuthChallenge != null ? cfn_parse.FromCloudFormation.getString(properties.DefineAuthChallenge) : void 0), ret.addPropertyResult("kmsKeyId", "KMSKeyID", properties.KMSKeyID != null ? cfn_parse.FromCloudFormation.getString(properties.KMSKeyID) : void 0), ret.addPropertyResult("postAuthentication", "PostAuthentication", properties.PostAuthentication != null ? cfn_parse.FromCloudFormation.getString(properties.PostAuthentication) : void 0), ret.addPropertyResult("postConfirmation", "PostConfirmation", properties.PostConfirmation != null ? cfn_parse.FromCloudFormation.getString(properties.PostConfirmation) : void 0), ret.addPropertyResult("preAuthentication", "PreAuthentication", properties.PreAuthentication != null ? cfn_parse.FromCloudFormation.getString(properties.PreAuthentication) : void 0), ret.addPropertyResult("preSignUp", "PreSignUp", properties.PreSignUp != null ? cfn_parse.FromCloudFormation.getString(properties.PreSignUp) : void 0), ret.addPropertyResult("preTokenGeneration", "PreTokenGeneration", properties.PreTokenGeneration != null ? cfn_parse.FromCloudFormation.getString(properties.PreTokenGeneration) : void 0), ret.addPropertyResult("userMigration", "UserMigration", properties.UserMigration != null ? cfn_parse.FromCloudFormation.getString(properties.UserMigration) : void 0), ret.addPropertyResult("verifyAuthChallengeResponse", "VerifyAuthChallengeResponse", properties.VerifyAuthChallengeResponse != null ? cfn_parse.FromCloudFormation.getString(properties.VerifyAuthChallengeResponse) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPool_NumberAttributeConstraintsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxValue", cdk.validateString)(properties.maxValue)), errors.collect(cdk.propertyValidator("minValue", cdk.validateString)(properties.minValue)), errors.wrap('supplied properties not correct for "NumberAttributeConstraintsProperty"');
    }
    function cfnUserPoolNumberAttributeConstraintsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPool_NumberAttributeConstraintsPropertyValidator(properties).assertSuccess(), { MaxValue: cdk.stringToCloudFormation(properties.maxValue), MinValue: cdk.stringToCloudFormation(properties.minValue) }) : properties;
    }
    function CfnUserPoolNumberAttributeConstraintsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxValue", "MaxValue", properties.MaxValue != null ? cfn_parse.FromCloudFormation.getString(properties.MaxValue) : void 0), ret.addPropertyResult("minValue", "MinValue", properties.MinValue != null ? cfn_parse.FromCloudFormation.getString(properties.MinValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPool_PasswordPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("minimumLength", cdk.validateNumber)(properties.minimumLength)), errors.collect(cdk.propertyValidator("requireLowercase", cdk.validateBoolean)(properties.requireLowercase)), errors.collect(cdk.propertyValidator("requireNumbers", cdk.validateBoolean)(properties.requireNumbers)), errors.collect(cdk.propertyValidator("requireSymbols", cdk.validateBoolean)(properties.requireSymbols)), errors.collect(cdk.propertyValidator("requireUppercase", cdk.validateBoolean)(properties.requireUppercase)), errors.collect(cdk.propertyValidator("temporaryPasswordValidityDays", cdk.validateNumber)(properties.temporaryPasswordValidityDays)), errors.wrap('supplied properties not correct for "PasswordPolicyProperty"');
    }
    function cfnUserPoolPasswordPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPool_PasswordPolicyPropertyValidator(properties).assertSuccess(), { MinimumLength: cdk.numberToCloudFormation(properties.minimumLength), RequireLowercase: cdk.booleanToCloudFormation(properties.requireLowercase), RequireNumbers: cdk.booleanToCloudFormation(properties.requireNumbers), RequireSymbols: cdk.booleanToCloudFormation(properties.requireSymbols), RequireUppercase: cdk.booleanToCloudFormation(properties.requireUppercase), TemporaryPasswordValidityDays: cdk.numberToCloudFormation(properties.temporaryPasswordValidityDays) }) : properties;
    }
    function CfnUserPoolPasswordPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("minimumLength", "MinimumLength", properties.MinimumLength != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinimumLength) : void 0), ret.addPropertyResult("requireLowercase", "RequireLowercase", properties.RequireLowercase != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RequireLowercase) : void 0), ret.addPropertyResult("requireNumbers", "RequireNumbers", properties.RequireNumbers != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RequireNumbers) : void 0), ret.addPropertyResult("requireSymbols", "RequireSymbols", properties.RequireSymbols != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RequireSymbols) : void 0), ret.addPropertyResult("requireUppercase", "RequireUppercase", properties.RequireUppercase != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RequireUppercase) : void 0), ret.addPropertyResult("temporaryPasswordValidityDays", "TemporaryPasswordValidityDays", properties.TemporaryPasswordValidityDays != null ? cfn_parse.FromCloudFormation.getNumber(properties.TemporaryPasswordValidityDays) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPool_PoliciesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("passwordPolicy", CfnUserPool_PasswordPolicyPropertyValidator)(properties.passwordPolicy)), errors.wrap('supplied properties not correct for "PoliciesProperty"');
    }
    function cfnUserPoolPoliciesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPool_PoliciesPropertyValidator(properties).assertSuccess(), { PasswordPolicy: cfnUserPoolPasswordPolicyPropertyToCloudFormation(properties.passwordPolicy) }) : properties;
    }
    function CfnUserPoolPoliciesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("passwordPolicy", "PasswordPolicy", properties.PasswordPolicy != null ? CfnUserPoolPasswordPolicyPropertyFromCloudFormation(properties.PasswordPolicy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPool_RecoveryOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("priority", cdk.validateNumber)(properties.priority)), errors.wrap('supplied properties not correct for "RecoveryOptionProperty"');
    }
    function cfnUserPoolRecoveryOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPool_RecoveryOptionPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Priority: cdk.numberToCloudFormation(properties.priority) }) : properties;
    }
    function CfnUserPoolRecoveryOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("priority", "Priority", properties.Priority != null ? cfn_parse.FromCloudFormation.getNumber(properties.Priority) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPool_SchemaAttributePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributeDataType", cdk.validateString)(properties.attributeDataType)), errors.collect(cdk.propertyValidator("developerOnlyAttribute", cdk.validateBoolean)(properties.developerOnlyAttribute)), errors.collect(cdk.propertyValidator("mutable", cdk.validateBoolean)(properties.mutable)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("numberAttributeConstraints", CfnUserPool_NumberAttributeConstraintsPropertyValidator)(properties.numberAttributeConstraints)), errors.collect(cdk.propertyValidator("required", cdk.validateBoolean)(properties.required)), errors.collect(cdk.propertyValidator("stringAttributeConstraints", CfnUserPool_StringAttributeConstraintsPropertyValidator)(properties.stringAttributeConstraints)), errors.wrap('supplied properties not correct for "SchemaAttributeProperty"');
    }
    function cfnUserPoolSchemaAttributePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPool_SchemaAttributePropertyValidator(properties).assertSuccess(), { AttributeDataType: cdk.stringToCloudFormation(properties.attributeDataType), DeveloperOnlyAttribute: cdk.booleanToCloudFormation(properties.developerOnlyAttribute), Mutable: cdk.booleanToCloudFormation(properties.mutable), Name: cdk.stringToCloudFormation(properties.name), NumberAttributeConstraints: cfnUserPoolNumberAttributeConstraintsPropertyToCloudFormation(properties.numberAttributeConstraints), Required: cdk.booleanToCloudFormation(properties.required), StringAttributeConstraints: cfnUserPoolStringAttributeConstraintsPropertyToCloudFormation(properties.stringAttributeConstraints) }) : properties;
    }
    function CfnUserPoolSchemaAttributePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attributeDataType", "AttributeDataType", properties.AttributeDataType != null ? cfn_parse.FromCloudFormation.getString(properties.AttributeDataType) : void 0), ret.addPropertyResult("developerOnlyAttribute", "DeveloperOnlyAttribute", properties.DeveloperOnlyAttribute != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeveloperOnlyAttribute) : void 0), ret.addPropertyResult("mutable", "Mutable", properties.Mutable != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Mutable) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("numberAttributeConstraints", "NumberAttributeConstraints", properties.NumberAttributeConstraints != null ? CfnUserPoolNumberAttributeConstraintsPropertyFromCloudFormation(properties.NumberAttributeConstraints) : void 0), ret.addPropertyResult("required", "Required", properties.Required != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Required) : void 0), ret.addPropertyResult("stringAttributeConstraints", "StringAttributeConstraints", properties.StringAttributeConstraints != null ? CfnUserPoolStringAttributeConstraintsPropertyFromCloudFormation(properties.StringAttributeConstraints) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPool_SmsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("externalId", cdk.validateString)(properties.externalId)), errors.collect(cdk.propertyValidator("snsCallerArn", cdk.validateString)(properties.snsCallerArn)), errors.collect(cdk.propertyValidator("snsRegion", cdk.validateString)(properties.snsRegion)), errors.wrap('supplied properties not correct for "SmsConfigurationProperty"');
    }
    function cfnUserPoolSmsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPool_SmsConfigurationPropertyValidator(properties).assertSuccess(), { ExternalId: cdk.stringToCloudFormation(properties.externalId), SnsCallerArn: cdk.stringToCloudFormation(properties.snsCallerArn), SnsRegion: cdk.stringToCloudFormation(properties.snsRegion) }) : properties;
    }
    function CfnUserPoolSmsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("externalId", "ExternalId", properties.ExternalId != null ? cfn_parse.FromCloudFormation.getString(properties.ExternalId) : void 0), ret.addPropertyResult("snsCallerArn", "SnsCallerArn", properties.SnsCallerArn != null ? cfn_parse.FromCloudFormation.getString(properties.SnsCallerArn) : void 0), ret.addPropertyResult("snsRegion", "SnsRegion", properties.SnsRegion != null ? cfn_parse.FromCloudFormation.getString(properties.SnsRegion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPool_StringAttributeConstraintsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxLength", cdk.validateString)(properties.maxLength)), errors.collect(cdk.propertyValidator("minLength", cdk.validateString)(properties.minLength)), errors.wrap('supplied properties not correct for "StringAttributeConstraintsProperty"');
    }
    function cfnUserPoolStringAttributeConstraintsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPool_StringAttributeConstraintsPropertyValidator(properties).assertSuccess(), { MaxLength: cdk.stringToCloudFormation(properties.maxLength), MinLength: cdk.stringToCloudFormation(properties.minLength) }) : properties;
    }
    function CfnUserPoolStringAttributeConstraintsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxLength", "MaxLength", properties.MaxLength != null ? cfn_parse.FromCloudFormation.getString(properties.MaxLength) : void 0), ret.addPropertyResult("minLength", "MinLength", properties.MinLength != null ? cfn_parse.FromCloudFormation.getString(properties.MinLength) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPool_UserAttributeUpdateSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributesRequireVerificationBeforeUpdate", cdk.requiredValidator)(properties.attributesRequireVerificationBeforeUpdate)), errors.collect(cdk.propertyValidator("attributesRequireVerificationBeforeUpdate", cdk.listValidator(cdk.validateString))(properties.attributesRequireVerificationBeforeUpdate)), errors.wrap('supplied properties not correct for "UserAttributeUpdateSettingsProperty"');
    }
    function cfnUserPoolUserAttributeUpdateSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPool_UserAttributeUpdateSettingsPropertyValidator(properties).assertSuccess(), { AttributesRequireVerificationBeforeUpdate: cdk.listMapper(cdk.stringToCloudFormation)(properties.attributesRequireVerificationBeforeUpdate) }) : properties;
    }
    function CfnUserPoolUserAttributeUpdateSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attributesRequireVerificationBeforeUpdate", "AttributesRequireVerificationBeforeUpdate", cfn_parse.FromCloudFormation.getStringArray(properties.AttributesRequireVerificationBeforeUpdate)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPool_UserPoolAddOnsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("advancedSecurityMode", cdk.validateString)(properties.advancedSecurityMode)), errors.wrap('supplied properties not correct for "UserPoolAddOnsProperty"');
    }
    function cfnUserPoolUserPoolAddOnsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPool_UserPoolAddOnsPropertyValidator(properties).assertSuccess(), { AdvancedSecurityMode: cdk.stringToCloudFormation(properties.advancedSecurityMode) }) : properties;
    }
    function CfnUserPoolUserPoolAddOnsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("advancedSecurityMode", "AdvancedSecurityMode", properties.AdvancedSecurityMode != null ? cfn_parse.FromCloudFormation.getString(properties.AdvancedSecurityMode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPool_UsernameConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("caseSensitive", cdk.validateBoolean)(properties.caseSensitive)), errors.wrap('supplied properties not correct for "UsernameConfigurationProperty"');
    }
    function cfnUserPoolUsernameConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPool_UsernameConfigurationPropertyValidator(properties).assertSuccess(), { CaseSensitive: cdk.booleanToCloudFormation(properties.caseSensitive) }) : properties;
    }
    function CfnUserPoolUsernameConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("caseSensitive", "CaseSensitive", properties.CaseSensitive != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CaseSensitive) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPool_VerificationMessageTemplatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultEmailOption", cdk.validateString)(properties.defaultEmailOption)), errors.collect(cdk.propertyValidator("emailMessage", cdk.validateString)(properties.emailMessage)), errors.collect(cdk.propertyValidator("emailMessageByLink", cdk.validateString)(properties.emailMessageByLink)), errors.collect(cdk.propertyValidator("emailSubject", cdk.validateString)(properties.emailSubject)), errors.collect(cdk.propertyValidator("emailSubjectByLink", cdk.validateString)(properties.emailSubjectByLink)), errors.collect(cdk.propertyValidator("smsMessage", cdk.validateString)(properties.smsMessage)), errors.wrap('supplied properties not correct for "VerificationMessageTemplateProperty"');
    }
    function cfnUserPoolVerificationMessageTemplatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPool_VerificationMessageTemplatePropertyValidator(properties).assertSuccess(), { DefaultEmailOption: cdk.stringToCloudFormation(properties.defaultEmailOption), EmailMessage: cdk.stringToCloudFormation(properties.emailMessage), EmailMessageByLink: cdk.stringToCloudFormation(properties.emailMessageByLink), EmailSubject: cdk.stringToCloudFormation(properties.emailSubject), EmailSubjectByLink: cdk.stringToCloudFormation(properties.emailSubjectByLink), SmsMessage: cdk.stringToCloudFormation(properties.smsMessage) }) : properties;
    }
    function CfnUserPoolVerificationMessageTemplatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultEmailOption", "DefaultEmailOption", properties.DefaultEmailOption != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultEmailOption) : void 0), ret.addPropertyResult("emailMessage", "EmailMessage", properties.EmailMessage != null ? cfn_parse.FromCloudFormation.getString(properties.EmailMessage) : void 0), ret.addPropertyResult("emailMessageByLink", "EmailMessageByLink", properties.EmailMessageByLink != null ? cfn_parse.FromCloudFormation.getString(properties.EmailMessageByLink) : void 0), ret.addPropertyResult("emailSubject", "EmailSubject", properties.EmailSubject != null ? cfn_parse.FromCloudFormation.getString(properties.EmailSubject) : void 0), ret.addPropertyResult("emailSubjectByLink", "EmailSubjectByLink", properties.EmailSubjectByLink != null ? cfn_parse.FromCloudFormation.getString(properties.EmailSubjectByLink) : void 0), ret.addPropertyResult("smsMessage", "SmsMessage", properties.SmsMessage != null ? cfn_parse.FromCloudFormation.getString(properties.SmsMessage) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPoolClientPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessTokenValidity", cdk.validateNumber)(properties.accessTokenValidity)), errors.collect(cdk.propertyValidator("allowedOAuthFlows", cdk.listValidator(cdk.validateString))(properties.allowedOAuthFlows)), errors.collect(cdk.propertyValidator("allowedOAuthFlowsUserPoolClient", cdk.validateBoolean)(properties.allowedOAuthFlowsUserPoolClient)), errors.collect(cdk.propertyValidator("allowedOAuthScopes", cdk.listValidator(cdk.validateString))(properties.allowedOAuthScopes)), errors.collect(cdk.propertyValidator("analyticsConfiguration", CfnUserPoolClient_AnalyticsConfigurationPropertyValidator)(properties.analyticsConfiguration)), errors.collect(cdk.propertyValidator("authSessionValidity", cdk.validateNumber)(properties.authSessionValidity)), errors.collect(cdk.propertyValidator("callbackUrLs", cdk.listValidator(cdk.validateString))(properties.callbackUrLs)), errors.collect(cdk.propertyValidator("clientName", cdk.validateString)(properties.clientName)), errors.collect(cdk.propertyValidator("defaultRedirectUri", cdk.validateString)(properties.defaultRedirectUri)), errors.collect(cdk.propertyValidator("enablePropagateAdditionalUserContextData", cdk.validateBoolean)(properties.enablePropagateAdditionalUserContextData)), errors.collect(cdk.propertyValidator("enableTokenRevocation", cdk.validateBoolean)(properties.enableTokenRevocation)), errors.collect(cdk.propertyValidator("explicitAuthFlows", cdk.listValidator(cdk.validateString))(properties.explicitAuthFlows)), errors.collect(cdk.propertyValidator("generateSecret", cdk.validateBoolean)(properties.generateSecret)), errors.collect(cdk.propertyValidator("idTokenValidity", cdk.validateNumber)(properties.idTokenValidity)), errors.collect(cdk.propertyValidator("logoutUrLs", cdk.listValidator(cdk.validateString))(properties.logoutUrLs)), errors.collect(cdk.propertyValidator("preventUserExistenceErrors", cdk.validateString)(properties.preventUserExistenceErrors)), errors.collect(cdk.propertyValidator("readAttributes", cdk.listValidator(cdk.validateString))(properties.readAttributes)), errors.collect(cdk.propertyValidator("refreshTokenValidity", cdk.validateNumber)(properties.refreshTokenValidity)), errors.collect(cdk.propertyValidator("supportedIdentityProviders", cdk.listValidator(cdk.validateString))(properties.supportedIdentityProviders)), errors.collect(cdk.propertyValidator("tokenValidityUnits", CfnUserPoolClient_TokenValidityUnitsPropertyValidator)(properties.tokenValidityUnits)), errors.collect(cdk.propertyValidator("userPoolId", cdk.requiredValidator)(properties.userPoolId)), errors.collect(cdk.propertyValidator("userPoolId", cdk.validateString)(properties.userPoolId)), errors.collect(cdk.propertyValidator("writeAttributes", cdk.listValidator(cdk.validateString))(properties.writeAttributes)), errors.wrap('supplied properties not correct for "CfnUserPoolClientProps"');
    }
    function cfnUserPoolClientPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPoolClientPropsValidator(properties).assertSuccess(), { UserPoolId: cdk.stringToCloudFormation(properties.userPoolId), AccessTokenValidity: cdk.numberToCloudFormation(properties.accessTokenValidity), AllowedOAuthFlows: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowedOAuthFlows), AllowedOAuthFlowsUserPoolClient: cdk.booleanToCloudFormation(properties.allowedOAuthFlowsUserPoolClient), AllowedOAuthScopes: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowedOAuthScopes), AnalyticsConfiguration: cfnUserPoolClientAnalyticsConfigurationPropertyToCloudFormation(properties.analyticsConfiguration), AuthSessionValidity: cdk.numberToCloudFormation(properties.authSessionValidity), CallbackURLs: cdk.listMapper(cdk.stringToCloudFormation)(properties.callbackUrLs), ClientName: cdk.stringToCloudFormation(properties.clientName), DefaultRedirectURI: cdk.stringToCloudFormation(properties.defaultRedirectUri), EnablePropagateAdditionalUserContextData: cdk.booleanToCloudFormation(properties.enablePropagateAdditionalUserContextData), EnableTokenRevocation: cdk.booleanToCloudFormation(properties.enableTokenRevocation), ExplicitAuthFlows: cdk.listMapper(cdk.stringToCloudFormation)(properties.explicitAuthFlows), GenerateSecret: cdk.booleanToCloudFormation(properties.generateSecret), IdTokenValidity: cdk.numberToCloudFormation(properties.idTokenValidity), LogoutURLs: cdk.listMapper(cdk.stringToCloudFormation)(properties.logoutUrLs), PreventUserExistenceErrors: cdk.stringToCloudFormation(properties.preventUserExistenceErrors), ReadAttributes: cdk.listMapper(cdk.stringToCloudFormation)(properties.readAttributes), RefreshTokenValidity: cdk.numberToCloudFormation(properties.refreshTokenValidity), SupportedIdentityProviders: cdk.listMapper(cdk.stringToCloudFormation)(properties.supportedIdentityProviders), TokenValidityUnits: cfnUserPoolClientTokenValidityUnitsPropertyToCloudFormation(properties.tokenValidityUnits), WriteAttributes: cdk.listMapper(cdk.stringToCloudFormation)(properties.writeAttributes) }) : properties;
    }
    function CfnUserPoolClientPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("userPoolId", "UserPoolId", cfn_parse.FromCloudFormation.getString(properties.UserPoolId)), ret.addPropertyResult("accessTokenValidity", "AccessTokenValidity", properties.AccessTokenValidity != null ? cfn_parse.FromCloudFormation.getNumber(properties.AccessTokenValidity) : void 0), ret.addPropertyResult("allowedOAuthFlows", "AllowedOAuthFlows", properties.AllowedOAuthFlows != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AllowedOAuthFlows) : void 0), ret.addPropertyResult("allowedOAuthFlowsUserPoolClient", "AllowedOAuthFlowsUserPoolClient", properties.AllowedOAuthFlowsUserPoolClient != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllowedOAuthFlowsUserPoolClient) : void 0), ret.addPropertyResult("allowedOAuthScopes", "AllowedOAuthScopes", properties.AllowedOAuthScopes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AllowedOAuthScopes) : void 0), ret.addPropertyResult("analyticsConfiguration", "AnalyticsConfiguration", properties.AnalyticsConfiguration != null ? CfnUserPoolClientAnalyticsConfigurationPropertyFromCloudFormation(properties.AnalyticsConfiguration) : void 0), ret.addPropertyResult("authSessionValidity", "AuthSessionValidity", properties.AuthSessionValidity != null ? cfn_parse.FromCloudFormation.getNumber(properties.AuthSessionValidity) : void 0), ret.addPropertyResult("callbackUrLs", "CallbackURLs", properties.CallbackURLs != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CallbackURLs) : void 0), ret.addPropertyResult("clientName", "ClientName", properties.ClientName != null ? cfn_parse.FromCloudFormation.getString(properties.ClientName) : void 0), ret.addPropertyResult("defaultRedirectUri", "DefaultRedirectURI", properties.DefaultRedirectURI != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultRedirectURI) : void 0), ret.addPropertyResult("enablePropagateAdditionalUserContextData", "EnablePropagateAdditionalUserContextData", properties.EnablePropagateAdditionalUserContextData != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnablePropagateAdditionalUserContextData) : void 0), ret.addPropertyResult("enableTokenRevocation", "EnableTokenRevocation", properties.EnableTokenRevocation != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableTokenRevocation) : void 0), ret.addPropertyResult("explicitAuthFlows", "ExplicitAuthFlows", properties.ExplicitAuthFlows != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExplicitAuthFlows) : void 0), ret.addPropertyResult("generateSecret", "GenerateSecret", properties.GenerateSecret != null ? cfn_parse.FromCloudFormation.getBoolean(properties.GenerateSecret) : void 0), ret.addPropertyResult("idTokenValidity", "IdTokenValidity", properties.IdTokenValidity != null ? cfn_parse.FromCloudFormation.getNumber(properties.IdTokenValidity) : void 0), ret.addPropertyResult("logoutUrLs", "LogoutURLs", properties.LogoutURLs != null ? cfn_parse.FromCloudFormation.getStringArray(properties.LogoutURLs) : void 0), ret.addPropertyResult("preventUserExistenceErrors", "PreventUserExistenceErrors", properties.PreventUserExistenceErrors != null ? cfn_parse.FromCloudFormation.getString(properties.PreventUserExistenceErrors) : void 0), ret.addPropertyResult("readAttributes", "ReadAttributes", properties.ReadAttributes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ReadAttributes) : void 0), ret.addPropertyResult("refreshTokenValidity", "RefreshTokenValidity", properties.RefreshTokenValidity != null ? cfn_parse.FromCloudFormation.getNumber(properties.RefreshTokenValidity) : void 0), ret.addPropertyResult("supportedIdentityProviders", "SupportedIdentityProviders", properties.SupportedIdentityProviders != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SupportedIdentityProviders) : void 0), ret.addPropertyResult("tokenValidityUnits", "TokenValidityUnits", properties.TokenValidityUnits != null ? CfnUserPoolClientTokenValidityUnitsPropertyFromCloudFormation(properties.TokenValidityUnits) : void 0), ret.addPropertyResult("writeAttributes", "WriteAttributes", properties.WriteAttributes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.WriteAttributes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnUserPoolClient = class _CfnUserPoolClient extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnUserPoolClientPropsFromCloudFormation(resourceProperties), ret = new _CfnUserPoolClient(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnUserPoolClient.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_CfnUserPoolClientProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnUserPoolClient), error;
        }
        cdk.requireProperty(props, "userPoolId", this), this.attrClientSecret = cdk.Token.asString(this.getAtt("ClientSecret", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.userPoolId = props.userPoolId, this.accessTokenValidity = props.accessTokenValidity, this.allowedOAuthFlows = props.allowedOAuthFlows, this.allowedOAuthFlowsUserPoolClient = props.allowedOAuthFlowsUserPoolClient, this.allowedOAuthScopes = props.allowedOAuthScopes, this.analyticsConfiguration = props.analyticsConfiguration, this.authSessionValidity = props.authSessionValidity, this.callbackUrLs = props.callbackUrLs, this.clientName = props.clientName, this.defaultRedirectUri = props.defaultRedirectUri, this.enablePropagateAdditionalUserContextData = props.enablePropagateAdditionalUserContextData, this.enableTokenRevocation = props.enableTokenRevocation, this.explicitAuthFlows = props.explicitAuthFlows, this.generateSecret = props.generateSecret, this.idTokenValidity = props.idTokenValidity, this.logoutUrLs = props.logoutUrLs, this.preventUserExistenceErrors = props.preventUserExistenceErrors, this.readAttributes = props.readAttributes, this.refreshTokenValidity = props.refreshTokenValidity, this.supportedIdentityProviders = props.supportedIdentityProviders, this.tokenValidityUnits = props.tokenValidityUnits, this.writeAttributes = props.writeAttributes;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnUserPoolClient.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { userPoolId: this.userPoolId, accessTokenValidity: this.accessTokenValidity, allowedOAuthFlows: this.allowedOAuthFlows, allowedOAuthFlowsUserPoolClient: this.allowedOAuthFlowsUserPoolClient, allowedOAuthScopes: this.allowedOAuthScopes, analyticsConfiguration: this.analyticsConfiguration, authSessionValidity: this.authSessionValidity, callbackUrLs: this.callbackUrLs, clientName: this.clientName, defaultRedirectUri: this.defaultRedirectUri, enablePropagateAdditionalUserContextData: this.enablePropagateAdditionalUserContextData, enableTokenRevocation: this.enableTokenRevocation, explicitAuthFlows: this.explicitAuthFlows, generateSecret: this.generateSecret, idTokenValidity: this.idTokenValidity, logoutUrLs: this.logoutUrLs, preventUserExistenceErrors: this.preventUserExistenceErrors, readAttributes: this.readAttributes, refreshTokenValidity: this.refreshTokenValidity, supportedIdentityProviders: this.supportedIdentityProviders, tokenValidityUnits: this.tokenValidityUnits, writeAttributes: this.writeAttributes };
      }
      renderProperties(props) {
        return cfnUserPoolClientPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnUserPoolClient[_d] = { fqn: "aws-cdk-lib.aws_cognito.CfnUserPoolClient", version: "2.80.0" }, CfnUserPoolClient.CFN_RESOURCE_TYPE_NAME = "AWS::Cognito::UserPoolClient", exports2.CfnUserPoolClient = CfnUserPoolClient;
    function CfnUserPoolClient_AnalyticsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationArn", cdk.validateString)(properties.applicationArn)), errors.collect(cdk.propertyValidator("applicationId", cdk.validateString)(properties.applicationId)), errors.collect(cdk.propertyValidator("externalId", cdk.validateString)(properties.externalId)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("userDataShared", cdk.validateBoolean)(properties.userDataShared)), errors.wrap('supplied properties not correct for "AnalyticsConfigurationProperty"');
    }
    function cfnUserPoolClientAnalyticsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPoolClient_AnalyticsConfigurationPropertyValidator(properties).assertSuccess(), { ApplicationArn: cdk.stringToCloudFormation(properties.applicationArn), ApplicationId: cdk.stringToCloudFormation(properties.applicationId), ExternalId: cdk.stringToCloudFormation(properties.externalId), RoleArn: cdk.stringToCloudFormation(properties.roleArn), UserDataShared: cdk.booleanToCloudFormation(properties.userDataShared) }) : properties;
    }
    function CfnUserPoolClientAnalyticsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationArn", "ApplicationArn", properties.ApplicationArn != null ? cfn_parse.FromCloudFormation.getString(properties.ApplicationArn) : void 0), ret.addPropertyResult("applicationId", "ApplicationId", properties.ApplicationId != null ? cfn_parse.FromCloudFormation.getString(properties.ApplicationId) : void 0), ret.addPropertyResult("externalId", "ExternalId", properties.ExternalId != null ? cfn_parse.FromCloudFormation.getString(properties.ExternalId) : void 0), ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addPropertyResult("userDataShared", "UserDataShared", properties.UserDataShared != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UserDataShared) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPoolClient_TokenValidityUnitsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessToken", cdk.validateString)(properties.accessToken)), errors.collect(cdk.propertyValidator("idToken", cdk.validateString)(properties.idToken)), errors.collect(cdk.propertyValidator("refreshToken", cdk.validateString)(properties.refreshToken)), errors.wrap('supplied properties not correct for "TokenValidityUnitsProperty"');
    }
    function cfnUserPoolClientTokenValidityUnitsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPoolClient_TokenValidityUnitsPropertyValidator(properties).assertSuccess(), { AccessToken: cdk.stringToCloudFormation(properties.accessToken), IdToken: cdk.stringToCloudFormation(properties.idToken), RefreshToken: cdk.stringToCloudFormation(properties.refreshToken) }) : properties;
    }
    function CfnUserPoolClientTokenValidityUnitsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessToken", "AccessToken", properties.AccessToken != null ? cfn_parse.FromCloudFormation.getString(properties.AccessToken) : void 0), ret.addPropertyResult("idToken", "IdToken", properties.IdToken != null ? cfn_parse.FromCloudFormation.getString(properties.IdToken) : void 0), ret.addPropertyResult("refreshToken", "RefreshToken", properties.RefreshToken != null ? cfn_parse.FromCloudFormation.getString(properties.RefreshToken) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPoolDomainPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customDomainConfig", CfnUserPoolDomain_CustomDomainConfigTypePropertyValidator)(properties.customDomainConfig)), errors.collect(cdk.propertyValidator("domain", cdk.requiredValidator)(properties.domain)), errors.collect(cdk.propertyValidator("domain", cdk.validateString)(properties.domain)), errors.collect(cdk.propertyValidator("userPoolId", cdk.requiredValidator)(properties.userPoolId)), errors.collect(cdk.propertyValidator("userPoolId", cdk.validateString)(properties.userPoolId)), errors.wrap('supplied properties not correct for "CfnUserPoolDomainProps"');
    }
    function cfnUserPoolDomainPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPoolDomainPropsValidator(properties).assertSuccess(), { Domain: cdk.stringToCloudFormation(properties.domain), UserPoolId: cdk.stringToCloudFormation(properties.userPoolId), CustomDomainConfig: cfnUserPoolDomainCustomDomainConfigTypePropertyToCloudFormation(properties.customDomainConfig) }) : properties;
    }
    function CfnUserPoolDomainPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("domain", "Domain", cfn_parse.FromCloudFormation.getString(properties.Domain)), ret.addPropertyResult("userPoolId", "UserPoolId", cfn_parse.FromCloudFormation.getString(properties.UserPoolId)), ret.addPropertyResult("customDomainConfig", "CustomDomainConfig", properties.CustomDomainConfig != null ? CfnUserPoolDomainCustomDomainConfigTypePropertyFromCloudFormation(properties.CustomDomainConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnUserPoolDomain = class _CfnUserPoolDomain extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnUserPoolDomainPropsFromCloudFormation(resourceProperties), ret = new _CfnUserPoolDomain(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnUserPoolDomain.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_CfnUserPoolDomainProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnUserPoolDomain), error;
        }
        cdk.requireProperty(props, "domain", this), cdk.requireProperty(props, "userPoolId", this), this.attrCloudFrontDistribution = cdk.Token.asString(this.getAtt("CloudFrontDistribution", cdk.ResolutionTypeHint.STRING)), this.domain = props.domain, this.userPoolId = props.userPoolId, this.customDomainConfig = props.customDomainConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnUserPoolDomain.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { domain: this.domain, userPoolId: this.userPoolId, customDomainConfig: this.customDomainConfig };
      }
      renderProperties(props) {
        return cfnUserPoolDomainPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnUserPoolDomain[_e] = { fqn: "aws-cdk-lib.aws_cognito.CfnUserPoolDomain", version: "2.80.0" }, CfnUserPoolDomain.CFN_RESOURCE_TYPE_NAME = "AWS::Cognito::UserPoolDomain", exports2.CfnUserPoolDomain = CfnUserPoolDomain;
    function CfnUserPoolDomain_CustomDomainConfigTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateArn", cdk.validateString)(properties.certificateArn)), errors.wrap('supplied properties not correct for "CustomDomainConfigTypeProperty"');
    }
    function cfnUserPoolDomainCustomDomainConfigTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPoolDomain_CustomDomainConfigTypePropertyValidator(properties).assertSuccess(), { CertificateArn: cdk.stringToCloudFormation(properties.certificateArn) }) : properties;
    }
    function CfnUserPoolDomainCustomDomainConfigTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificateArn", "CertificateArn", properties.CertificateArn != null ? cfn_parse.FromCloudFormation.getString(properties.CertificateArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPoolGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("groupName", cdk.validateString)(properties.groupName)), errors.collect(cdk.propertyValidator("precedence", cdk.validateNumber)(properties.precedence)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("userPoolId", cdk.requiredValidator)(properties.userPoolId)), errors.collect(cdk.propertyValidator("userPoolId", cdk.validateString)(properties.userPoolId)), errors.wrap('supplied properties not correct for "CfnUserPoolGroupProps"');
    }
    function cfnUserPoolGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPoolGroupPropsValidator(properties).assertSuccess(), { UserPoolId: cdk.stringToCloudFormation(properties.userPoolId), Description: cdk.stringToCloudFormation(properties.description), GroupName: cdk.stringToCloudFormation(properties.groupName), Precedence: cdk.numberToCloudFormation(properties.precedence), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnUserPoolGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("userPoolId", "UserPoolId", cfn_parse.FromCloudFormation.getString(properties.UserPoolId)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("groupName", "GroupName", properties.GroupName != null ? cfn_parse.FromCloudFormation.getString(properties.GroupName) : void 0), ret.addPropertyResult("precedence", "Precedence", properties.Precedence != null ? cfn_parse.FromCloudFormation.getNumber(properties.Precedence) : void 0), ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnUserPoolGroup = class _CfnUserPoolGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnUserPoolGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnUserPoolGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnUserPoolGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_CfnUserPoolGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnUserPoolGroup), error;
        }
        cdk.requireProperty(props, "userPoolId", this), this.userPoolId = props.userPoolId, this.description = props.description, this.groupName = props.groupName, this.precedence = props.precedence, this.roleArn = props.roleArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnUserPoolGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { userPoolId: this.userPoolId, description: this.description, groupName: this.groupName, precedence: this.precedence, roleArn: this.roleArn };
      }
      renderProperties(props) {
        return cfnUserPoolGroupPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnUserPoolGroup[_f] = { fqn: "aws-cdk-lib.aws_cognito.CfnUserPoolGroup", version: "2.80.0" }, CfnUserPoolGroup.CFN_RESOURCE_TYPE_NAME = "AWS::Cognito::UserPoolGroup", exports2.CfnUserPoolGroup = CfnUserPoolGroup;
    function CfnUserPoolIdentityProviderPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributeMapping", cdk.validateObject)(properties.attributeMapping)), errors.collect(cdk.propertyValidator("idpIdentifiers", cdk.listValidator(cdk.validateString))(properties.idpIdentifiers)), errors.collect(cdk.propertyValidator("providerDetails", cdk.validateObject)(properties.providerDetails)), errors.collect(cdk.propertyValidator("providerName", cdk.requiredValidator)(properties.providerName)), errors.collect(cdk.propertyValidator("providerName", cdk.validateString)(properties.providerName)), errors.collect(cdk.propertyValidator("providerType", cdk.requiredValidator)(properties.providerType)), errors.collect(cdk.propertyValidator("providerType", cdk.validateString)(properties.providerType)), errors.collect(cdk.propertyValidator("userPoolId", cdk.requiredValidator)(properties.userPoolId)), errors.collect(cdk.propertyValidator("userPoolId", cdk.validateString)(properties.userPoolId)), errors.wrap('supplied properties not correct for "CfnUserPoolIdentityProviderProps"');
    }
    function cfnUserPoolIdentityProviderPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPoolIdentityProviderPropsValidator(properties).assertSuccess(), { ProviderName: cdk.stringToCloudFormation(properties.providerName), ProviderType: cdk.stringToCloudFormation(properties.providerType), UserPoolId: cdk.stringToCloudFormation(properties.userPoolId), AttributeMapping: cdk.objectToCloudFormation(properties.attributeMapping), IdpIdentifiers: cdk.listMapper(cdk.stringToCloudFormation)(properties.idpIdentifiers), ProviderDetails: cdk.objectToCloudFormation(properties.providerDetails) }) : properties;
    }
    function CfnUserPoolIdentityProviderPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("providerName", "ProviderName", cfn_parse.FromCloudFormation.getString(properties.ProviderName)), ret.addPropertyResult("providerType", "ProviderType", cfn_parse.FromCloudFormation.getString(properties.ProviderType)), ret.addPropertyResult("userPoolId", "UserPoolId", cfn_parse.FromCloudFormation.getString(properties.UserPoolId)), ret.addPropertyResult("attributeMapping", "AttributeMapping", properties.AttributeMapping != null ? cfn_parse.FromCloudFormation.getAny(properties.AttributeMapping) : void 0), ret.addPropertyResult("idpIdentifiers", "IdpIdentifiers", properties.IdpIdentifiers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.IdpIdentifiers) : void 0), ret.addPropertyResult("providerDetails", "ProviderDetails", properties.ProviderDetails != null ? cfn_parse.FromCloudFormation.getAny(properties.ProviderDetails) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnUserPoolIdentityProvider = class _CfnUserPoolIdentityProvider extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnUserPoolIdentityProviderPropsFromCloudFormation(resourceProperties), ret = new _CfnUserPoolIdentityProvider(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnUserPoolIdentityProvider.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_CfnUserPoolIdentityProviderProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnUserPoolIdentityProvider), error;
        }
        cdk.requireProperty(props, "providerName", this), cdk.requireProperty(props, "providerType", this), cdk.requireProperty(props, "userPoolId", this), this.providerName = props.providerName, this.providerType = props.providerType, this.userPoolId = props.userPoolId, this.attributeMapping = props.attributeMapping, this.idpIdentifiers = props.idpIdentifiers, this.providerDetails = props.providerDetails;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnUserPoolIdentityProvider.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { providerName: this.providerName, providerType: this.providerType, userPoolId: this.userPoolId, attributeMapping: this.attributeMapping, idpIdentifiers: this.idpIdentifiers, providerDetails: this.providerDetails };
      }
      renderProperties(props) {
        return cfnUserPoolIdentityProviderPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnUserPoolIdentityProvider[_g] = { fqn: "aws-cdk-lib.aws_cognito.CfnUserPoolIdentityProvider", version: "2.80.0" }, CfnUserPoolIdentityProvider.CFN_RESOURCE_TYPE_NAME = "AWS::Cognito::UserPoolIdentityProvider", exports2.CfnUserPoolIdentityProvider = CfnUserPoolIdentityProvider;
    function CfnUserPoolResourceServerPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("identifier", cdk.requiredValidator)(properties.identifier)), errors.collect(cdk.propertyValidator("identifier", cdk.validateString)(properties.identifier)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("scopes", cdk.listValidator(CfnUserPoolResourceServer_ResourceServerScopeTypePropertyValidator))(properties.scopes)), errors.collect(cdk.propertyValidator("userPoolId", cdk.requiredValidator)(properties.userPoolId)), errors.collect(cdk.propertyValidator("userPoolId", cdk.validateString)(properties.userPoolId)), errors.wrap('supplied properties not correct for "CfnUserPoolResourceServerProps"');
    }
    function cfnUserPoolResourceServerPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPoolResourceServerPropsValidator(properties).assertSuccess(), { Identifier: cdk.stringToCloudFormation(properties.identifier), Name: cdk.stringToCloudFormation(properties.name), UserPoolId: cdk.stringToCloudFormation(properties.userPoolId), Scopes: cdk.listMapper(cfnUserPoolResourceServerResourceServerScopeTypePropertyToCloudFormation)(properties.scopes) }) : properties;
    }
    function CfnUserPoolResourceServerPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("identifier", "Identifier", cfn_parse.FromCloudFormation.getString(properties.Identifier)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("userPoolId", "UserPoolId", cfn_parse.FromCloudFormation.getString(properties.UserPoolId)), ret.addPropertyResult("scopes", "Scopes", properties.Scopes != null ? cfn_parse.FromCloudFormation.getArray(CfnUserPoolResourceServerResourceServerScopeTypePropertyFromCloudFormation)(properties.Scopes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnUserPoolResourceServer = class _CfnUserPoolResourceServer extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnUserPoolResourceServerPropsFromCloudFormation(resourceProperties), ret = new _CfnUserPoolResourceServer(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnUserPoolResourceServer.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_CfnUserPoolResourceServerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnUserPoolResourceServer), error;
        }
        cdk.requireProperty(props, "identifier", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "userPoolId", this), this.identifier = props.identifier, this.name = props.name, this.userPoolId = props.userPoolId, this.scopes = props.scopes;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnUserPoolResourceServer.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { identifier: this.identifier, name: this.name, userPoolId: this.userPoolId, scopes: this.scopes };
      }
      renderProperties(props) {
        return cfnUserPoolResourceServerPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnUserPoolResourceServer[_h] = { fqn: "aws-cdk-lib.aws_cognito.CfnUserPoolResourceServer", version: "2.80.0" }, CfnUserPoolResourceServer.CFN_RESOURCE_TYPE_NAME = "AWS::Cognito::UserPoolResourceServer", exports2.CfnUserPoolResourceServer = CfnUserPoolResourceServer;
    function CfnUserPoolResourceServer_ResourceServerScopeTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("scopeDescription", cdk.requiredValidator)(properties.scopeDescription)), errors.collect(cdk.propertyValidator("scopeDescription", cdk.validateString)(properties.scopeDescription)), errors.collect(cdk.propertyValidator("scopeName", cdk.requiredValidator)(properties.scopeName)), errors.collect(cdk.propertyValidator("scopeName", cdk.validateString)(properties.scopeName)), errors.wrap('supplied properties not correct for "ResourceServerScopeTypeProperty"');
    }
    function cfnUserPoolResourceServerResourceServerScopeTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPoolResourceServer_ResourceServerScopeTypePropertyValidator(properties).assertSuccess(), { ScopeDescription: cdk.stringToCloudFormation(properties.scopeDescription), ScopeName: cdk.stringToCloudFormation(properties.scopeName) }) : properties;
    }
    function CfnUserPoolResourceServerResourceServerScopeTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("scopeDescription", "ScopeDescription", cfn_parse.FromCloudFormation.getString(properties.ScopeDescription)), ret.addPropertyResult("scopeName", "ScopeName", cfn_parse.FromCloudFormation.getString(properties.ScopeName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPoolRiskConfigurationAttachmentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accountTakeoverRiskConfiguration", CfnUserPoolRiskConfigurationAttachment_AccountTakeoverRiskConfigurationTypePropertyValidator)(properties.accountTakeoverRiskConfiguration)), errors.collect(cdk.propertyValidator("clientId", cdk.requiredValidator)(properties.clientId)), errors.collect(cdk.propertyValidator("clientId", cdk.validateString)(properties.clientId)), errors.collect(cdk.propertyValidator("compromisedCredentialsRiskConfiguration", CfnUserPoolRiskConfigurationAttachment_CompromisedCredentialsRiskConfigurationTypePropertyValidator)(properties.compromisedCredentialsRiskConfiguration)), errors.collect(cdk.propertyValidator("riskExceptionConfiguration", CfnUserPoolRiskConfigurationAttachment_RiskExceptionConfigurationTypePropertyValidator)(properties.riskExceptionConfiguration)), errors.collect(cdk.propertyValidator("userPoolId", cdk.requiredValidator)(properties.userPoolId)), errors.collect(cdk.propertyValidator("userPoolId", cdk.validateString)(properties.userPoolId)), errors.wrap('supplied properties not correct for "CfnUserPoolRiskConfigurationAttachmentProps"');
    }
    function cfnUserPoolRiskConfigurationAttachmentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPoolRiskConfigurationAttachmentPropsValidator(properties).assertSuccess(), { ClientId: cdk.stringToCloudFormation(properties.clientId), UserPoolId: cdk.stringToCloudFormation(properties.userPoolId), AccountTakeoverRiskConfiguration: cfnUserPoolRiskConfigurationAttachmentAccountTakeoverRiskConfigurationTypePropertyToCloudFormation(properties.accountTakeoverRiskConfiguration), CompromisedCredentialsRiskConfiguration: cfnUserPoolRiskConfigurationAttachmentCompromisedCredentialsRiskConfigurationTypePropertyToCloudFormation(properties.compromisedCredentialsRiskConfiguration), RiskExceptionConfiguration: cfnUserPoolRiskConfigurationAttachmentRiskExceptionConfigurationTypePropertyToCloudFormation(properties.riskExceptionConfiguration) }) : properties;
    }
    function CfnUserPoolRiskConfigurationAttachmentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clientId", "ClientId", cfn_parse.FromCloudFormation.getString(properties.ClientId)), ret.addPropertyResult("userPoolId", "UserPoolId", cfn_parse.FromCloudFormation.getString(properties.UserPoolId)), ret.addPropertyResult("accountTakeoverRiskConfiguration", "AccountTakeoverRiskConfiguration", properties.AccountTakeoverRiskConfiguration != null ? CfnUserPoolRiskConfigurationAttachmentAccountTakeoverRiskConfigurationTypePropertyFromCloudFormation(properties.AccountTakeoverRiskConfiguration) : void 0), ret.addPropertyResult("compromisedCredentialsRiskConfiguration", "CompromisedCredentialsRiskConfiguration", properties.CompromisedCredentialsRiskConfiguration != null ? CfnUserPoolRiskConfigurationAttachmentCompromisedCredentialsRiskConfigurationTypePropertyFromCloudFormation(properties.CompromisedCredentialsRiskConfiguration) : void 0), ret.addPropertyResult("riskExceptionConfiguration", "RiskExceptionConfiguration", properties.RiskExceptionConfiguration != null ? CfnUserPoolRiskConfigurationAttachmentRiskExceptionConfigurationTypePropertyFromCloudFormation(properties.RiskExceptionConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnUserPoolRiskConfigurationAttachment = class _CfnUserPoolRiskConfigurationAttachment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnUserPoolRiskConfigurationAttachmentPropsFromCloudFormation(resourceProperties), ret = new _CfnUserPoolRiskConfigurationAttachment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnUserPoolRiskConfigurationAttachment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_CfnUserPoolRiskConfigurationAttachmentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnUserPoolRiskConfigurationAttachment), error;
        }
        cdk.requireProperty(props, "clientId", this), cdk.requireProperty(props, "userPoolId", this), this.clientId = props.clientId, this.userPoolId = props.userPoolId, this.accountTakeoverRiskConfiguration = props.accountTakeoverRiskConfiguration, this.compromisedCredentialsRiskConfiguration = props.compromisedCredentialsRiskConfiguration, this.riskExceptionConfiguration = props.riskExceptionConfiguration;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnUserPoolRiskConfigurationAttachment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { clientId: this.clientId, userPoolId: this.userPoolId, accountTakeoverRiskConfiguration: this.accountTakeoverRiskConfiguration, compromisedCredentialsRiskConfiguration: this.compromisedCredentialsRiskConfiguration, riskExceptionConfiguration: this.riskExceptionConfiguration };
      }
      renderProperties(props) {
        return cfnUserPoolRiskConfigurationAttachmentPropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnUserPoolRiskConfigurationAttachment[_j] = { fqn: "aws-cdk-lib.aws_cognito.CfnUserPoolRiskConfigurationAttachment", version: "2.80.0" }, CfnUserPoolRiskConfigurationAttachment.CFN_RESOURCE_TYPE_NAME = "AWS::Cognito::UserPoolRiskConfigurationAttachment", exports2.CfnUserPoolRiskConfigurationAttachment = CfnUserPoolRiskConfigurationAttachment;
    function CfnUserPoolRiskConfigurationAttachment_AccountTakeoverActionTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("eventAction", cdk.requiredValidator)(properties.eventAction)), errors.collect(cdk.propertyValidator("eventAction", cdk.validateString)(properties.eventAction)), errors.collect(cdk.propertyValidator("notify", cdk.requiredValidator)(properties.notify)), errors.collect(cdk.propertyValidator("notify", cdk.validateBoolean)(properties.notify)), errors.wrap('supplied properties not correct for "AccountTakeoverActionTypeProperty"');
    }
    function cfnUserPoolRiskConfigurationAttachmentAccountTakeoverActionTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPoolRiskConfigurationAttachment_AccountTakeoverActionTypePropertyValidator(properties).assertSuccess(), { EventAction: cdk.stringToCloudFormation(properties.eventAction), Notify: cdk.booleanToCloudFormation(properties.notify) }) : properties;
    }
    function CfnUserPoolRiskConfigurationAttachmentAccountTakeoverActionTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("eventAction", "EventAction", cfn_parse.FromCloudFormation.getString(properties.EventAction)), ret.addPropertyResult("notify", "Notify", cfn_parse.FromCloudFormation.getBoolean(properties.Notify)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPoolRiskConfigurationAttachment_AccountTakeoverActionsTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("highAction", CfnUserPoolRiskConfigurationAttachment_AccountTakeoverActionTypePropertyValidator)(properties.highAction)), errors.collect(cdk.propertyValidator("lowAction", CfnUserPoolRiskConfigurationAttachment_AccountTakeoverActionTypePropertyValidator)(properties.lowAction)), errors.collect(cdk.propertyValidator("mediumAction", CfnUserPoolRiskConfigurationAttachment_AccountTakeoverActionTypePropertyValidator)(properties.mediumAction)), errors.wrap('supplied properties not correct for "AccountTakeoverActionsTypeProperty"');
    }
    function cfnUserPoolRiskConfigurationAttachmentAccountTakeoverActionsTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPoolRiskConfigurationAttachment_AccountTakeoverActionsTypePropertyValidator(properties).assertSuccess(), { HighAction: cfnUserPoolRiskConfigurationAttachmentAccountTakeoverActionTypePropertyToCloudFormation(properties.highAction), LowAction: cfnUserPoolRiskConfigurationAttachmentAccountTakeoverActionTypePropertyToCloudFormation(properties.lowAction), MediumAction: cfnUserPoolRiskConfigurationAttachmentAccountTakeoverActionTypePropertyToCloudFormation(properties.mediumAction) }) : properties;
    }
    function CfnUserPoolRiskConfigurationAttachmentAccountTakeoverActionsTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("highAction", "HighAction", properties.HighAction != null ? CfnUserPoolRiskConfigurationAttachmentAccountTakeoverActionTypePropertyFromCloudFormation(properties.HighAction) : void 0), ret.addPropertyResult("lowAction", "LowAction", properties.LowAction != null ? CfnUserPoolRiskConfigurationAttachmentAccountTakeoverActionTypePropertyFromCloudFormation(properties.LowAction) : void 0), ret.addPropertyResult("mediumAction", "MediumAction", properties.MediumAction != null ? CfnUserPoolRiskConfigurationAttachmentAccountTakeoverActionTypePropertyFromCloudFormation(properties.MediumAction) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPoolRiskConfigurationAttachment_AccountTakeoverRiskConfigurationTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.requiredValidator)(properties.actions)), errors.collect(cdk.propertyValidator("actions", CfnUserPoolRiskConfigurationAttachment_AccountTakeoverActionsTypePropertyValidator)(properties.actions)), errors.collect(cdk.propertyValidator("notifyConfiguration", CfnUserPoolRiskConfigurationAttachment_NotifyConfigurationTypePropertyValidator)(properties.notifyConfiguration)), errors.wrap('supplied properties not correct for "AccountTakeoverRiskConfigurationTypeProperty"');
    }
    function cfnUserPoolRiskConfigurationAttachmentAccountTakeoverRiskConfigurationTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPoolRiskConfigurationAttachment_AccountTakeoverRiskConfigurationTypePropertyValidator(properties).assertSuccess(), { Actions: cfnUserPoolRiskConfigurationAttachmentAccountTakeoverActionsTypePropertyToCloudFormation(properties.actions), NotifyConfiguration: cfnUserPoolRiskConfigurationAttachmentNotifyConfigurationTypePropertyToCloudFormation(properties.notifyConfiguration) }) : properties;
    }
    function CfnUserPoolRiskConfigurationAttachmentAccountTakeoverRiskConfigurationTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", CfnUserPoolRiskConfigurationAttachmentAccountTakeoverActionsTypePropertyFromCloudFormation(properties.Actions)), ret.addPropertyResult("notifyConfiguration", "NotifyConfiguration", properties.NotifyConfiguration != null ? CfnUserPoolRiskConfigurationAttachmentNotifyConfigurationTypePropertyFromCloudFormation(properties.NotifyConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPoolRiskConfigurationAttachment_CompromisedCredentialsActionsTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("eventAction", cdk.requiredValidator)(properties.eventAction)), errors.collect(cdk.propertyValidator("eventAction", cdk.validateString)(properties.eventAction)), errors.wrap('supplied properties not correct for "CompromisedCredentialsActionsTypeProperty"');
    }
    function cfnUserPoolRiskConfigurationAttachmentCompromisedCredentialsActionsTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPoolRiskConfigurationAttachment_CompromisedCredentialsActionsTypePropertyValidator(properties).assertSuccess(), { EventAction: cdk.stringToCloudFormation(properties.eventAction) }) : properties;
    }
    function CfnUserPoolRiskConfigurationAttachmentCompromisedCredentialsActionsTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("eventAction", "EventAction", cfn_parse.FromCloudFormation.getString(properties.EventAction)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPoolRiskConfigurationAttachment_CompromisedCredentialsRiskConfigurationTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.requiredValidator)(properties.actions)), errors.collect(cdk.propertyValidator("actions", CfnUserPoolRiskConfigurationAttachment_CompromisedCredentialsActionsTypePropertyValidator)(properties.actions)), errors.collect(cdk.propertyValidator("eventFilter", cdk.listValidator(cdk.validateString))(properties.eventFilter)), errors.wrap('supplied properties not correct for "CompromisedCredentialsRiskConfigurationTypeProperty"');
    }
    function cfnUserPoolRiskConfigurationAttachmentCompromisedCredentialsRiskConfigurationTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPoolRiskConfigurationAttachment_CompromisedCredentialsRiskConfigurationTypePropertyValidator(properties).assertSuccess(), { Actions: cfnUserPoolRiskConfigurationAttachmentCompromisedCredentialsActionsTypePropertyToCloudFormation(properties.actions), EventFilter: cdk.listMapper(cdk.stringToCloudFormation)(properties.eventFilter) }) : properties;
    }
    function CfnUserPoolRiskConfigurationAttachmentCompromisedCredentialsRiskConfigurationTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", CfnUserPoolRiskConfigurationAttachmentCompromisedCredentialsActionsTypePropertyFromCloudFormation(properties.Actions)), ret.addPropertyResult("eventFilter", "EventFilter", properties.EventFilter != null ? cfn_parse.FromCloudFormation.getStringArray(properties.EventFilter) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPoolRiskConfigurationAttachment_NotifyConfigurationTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("blockEmail", CfnUserPoolRiskConfigurationAttachment_NotifyEmailTypePropertyValidator)(properties.blockEmail)), errors.collect(cdk.propertyValidator("from", cdk.validateString)(properties.from)), errors.collect(cdk.propertyValidator("mfaEmail", CfnUserPoolRiskConfigurationAttachment_NotifyEmailTypePropertyValidator)(properties.mfaEmail)), errors.collect(cdk.propertyValidator("noActionEmail", CfnUserPoolRiskConfigurationAttachment_NotifyEmailTypePropertyValidator)(properties.noActionEmail)), errors.collect(cdk.propertyValidator("replyTo", cdk.validateString)(properties.replyTo)), errors.collect(cdk.propertyValidator("sourceArn", cdk.requiredValidator)(properties.sourceArn)), errors.collect(cdk.propertyValidator("sourceArn", cdk.validateString)(properties.sourceArn)), errors.wrap('supplied properties not correct for "NotifyConfigurationTypeProperty"');
    }
    function cfnUserPoolRiskConfigurationAttachmentNotifyConfigurationTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPoolRiskConfigurationAttachment_NotifyConfigurationTypePropertyValidator(properties).assertSuccess(), { BlockEmail: cfnUserPoolRiskConfigurationAttachmentNotifyEmailTypePropertyToCloudFormation(properties.blockEmail), From: cdk.stringToCloudFormation(properties.from), MfaEmail: cfnUserPoolRiskConfigurationAttachmentNotifyEmailTypePropertyToCloudFormation(properties.mfaEmail), NoActionEmail: cfnUserPoolRiskConfigurationAttachmentNotifyEmailTypePropertyToCloudFormation(properties.noActionEmail), ReplyTo: cdk.stringToCloudFormation(properties.replyTo), SourceArn: cdk.stringToCloudFormation(properties.sourceArn) }) : properties;
    }
    function CfnUserPoolRiskConfigurationAttachmentNotifyConfigurationTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("blockEmail", "BlockEmail", properties.BlockEmail != null ? CfnUserPoolRiskConfigurationAttachmentNotifyEmailTypePropertyFromCloudFormation(properties.BlockEmail) : void 0), ret.addPropertyResult("from", "From", properties.From != null ? cfn_parse.FromCloudFormation.getString(properties.From) : void 0), ret.addPropertyResult("mfaEmail", "MfaEmail", properties.MfaEmail != null ? CfnUserPoolRiskConfigurationAttachmentNotifyEmailTypePropertyFromCloudFormation(properties.MfaEmail) : void 0), ret.addPropertyResult("noActionEmail", "NoActionEmail", properties.NoActionEmail != null ? CfnUserPoolRiskConfigurationAttachmentNotifyEmailTypePropertyFromCloudFormation(properties.NoActionEmail) : void 0), ret.addPropertyResult("replyTo", "ReplyTo", properties.ReplyTo != null ? cfn_parse.FromCloudFormation.getString(properties.ReplyTo) : void 0), ret.addPropertyResult("sourceArn", "SourceArn", cfn_parse.FromCloudFormation.getString(properties.SourceArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPoolRiskConfigurationAttachment_NotifyEmailTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("htmlBody", cdk.validateString)(properties.htmlBody)), errors.collect(cdk.propertyValidator("subject", cdk.requiredValidator)(properties.subject)), errors.collect(cdk.propertyValidator("subject", cdk.validateString)(properties.subject)), errors.collect(cdk.propertyValidator("textBody", cdk.validateString)(properties.textBody)), errors.wrap('supplied properties not correct for "NotifyEmailTypeProperty"');
    }
    function cfnUserPoolRiskConfigurationAttachmentNotifyEmailTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPoolRiskConfigurationAttachment_NotifyEmailTypePropertyValidator(properties).assertSuccess(), { HtmlBody: cdk.stringToCloudFormation(properties.htmlBody), Subject: cdk.stringToCloudFormation(properties.subject), TextBody: cdk.stringToCloudFormation(properties.textBody) }) : properties;
    }
    function CfnUserPoolRiskConfigurationAttachmentNotifyEmailTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("htmlBody", "HtmlBody", properties.HtmlBody != null ? cfn_parse.FromCloudFormation.getString(properties.HtmlBody) : void 0), ret.addPropertyResult("subject", "Subject", cfn_parse.FromCloudFormation.getString(properties.Subject)), ret.addPropertyResult("textBody", "TextBody", properties.TextBody != null ? cfn_parse.FromCloudFormation.getString(properties.TextBody) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPoolRiskConfigurationAttachment_RiskExceptionConfigurationTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("blockedIpRangeList", cdk.listValidator(cdk.validateString))(properties.blockedIpRangeList)), errors.collect(cdk.propertyValidator("skippedIpRangeList", cdk.listValidator(cdk.validateString))(properties.skippedIpRangeList)), errors.wrap('supplied properties not correct for "RiskExceptionConfigurationTypeProperty"');
    }
    function cfnUserPoolRiskConfigurationAttachmentRiskExceptionConfigurationTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPoolRiskConfigurationAttachment_RiskExceptionConfigurationTypePropertyValidator(properties).assertSuccess(), { BlockedIPRangeList: cdk.listMapper(cdk.stringToCloudFormation)(properties.blockedIpRangeList), SkippedIPRangeList: cdk.listMapper(cdk.stringToCloudFormation)(properties.skippedIpRangeList) }) : properties;
    }
    function CfnUserPoolRiskConfigurationAttachmentRiskExceptionConfigurationTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("blockedIpRangeList", "BlockedIPRangeList", properties.BlockedIPRangeList != null ? cfn_parse.FromCloudFormation.getStringArray(properties.BlockedIPRangeList) : void 0), ret.addPropertyResult("skippedIpRangeList", "SkippedIPRangeList", properties.SkippedIPRangeList != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SkippedIPRangeList) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPoolUICustomizationAttachmentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("css", cdk.validateString)(properties.css)), errors.collect(cdk.propertyValidator("clientId", cdk.requiredValidator)(properties.clientId)), errors.collect(cdk.propertyValidator("clientId", cdk.validateString)(properties.clientId)), errors.collect(cdk.propertyValidator("userPoolId", cdk.requiredValidator)(properties.userPoolId)), errors.collect(cdk.propertyValidator("userPoolId", cdk.validateString)(properties.userPoolId)), errors.wrap('supplied properties not correct for "CfnUserPoolUICustomizationAttachmentProps"');
    }
    function cfnUserPoolUICustomizationAttachmentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPoolUICustomizationAttachmentPropsValidator(properties).assertSuccess(), { ClientId: cdk.stringToCloudFormation(properties.clientId), UserPoolId: cdk.stringToCloudFormation(properties.userPoolId), CSS: cdk.stringToCloudFormation(properties.css) }) : properties;
    }
    function CfnUserPoolUICustomizationAttachmentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clientId", "ClientId", cfn_parse.FromCloudFormation.getString(properties.ClientId)), ret.addPropertyResult("userPoolId", "UserPoolId", cfn_parse.FromCloudFormation.getString(properties.UserPoolId)), ret.addPropertyResult("css", "CSS", properties.CSS != null ? cfn_parse.FromCloudFormation.getString(properties.CSS) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnUserPoolUICustomizationAttachment = class _CfnUserPoolUICustomizationAttachment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnUserPoolUICustomizationAttachmentPropsFromCloudFormation(resourceProperties), ret = new _CfnUserPoolUICustomizationAttachment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnUserPoolUICustomizationAttachment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_CfnUserPoolUICustomizationAttachmentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnUserPoolUICustomizationAttachment), error;
        }
        cdk.requireProperty(props, "clientId", this), cdk.requireProperty(props, "userPoolId", this), this.clientId = props.clientId, this.userPoolId = props.userPoolId, this.css = props.css;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnUserPoolUICustomizationAttachment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { clientId: this.clientId, userPoolId: this.userPoolId, css: this.css };
      }
      renderProperties(props) {
        return cfnUserPoolUICustomizationAttachmentPropsToCloudFormation(props);
      }
    };
    _k = JSII_RTTI_SYMBOL_1, CfnUserPoolUICustomizationAttachment[_k] = { fqn: "aws-cdk-lib.aws_cognito.CfnUserPoolUICustomizationAttachment", version: "2.80.0" }, CfnUserPoolUICustomizationAttachment.CFN_RESOURCE_TYPE_NAME = "AWS::Cognito::UserPoolUICustomizationAttachment", exports2.CfnUserPoolUICustomizationAttachment = CfnUserPoolUICustomizationAttachment;
    function CfnUserPoolUserPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clientMetadata", cdk.validateObject)(properties.clientMetadata)), errors.collect(cdk.propertyValidator("desiredDeliveryMediums", cdk.listValidator(cdk.validateString))(properties.desiredDeliveryMediums)), errors.collect(cdk.propertyValidator("forceAliasCreation", cdk.validateBoolean)(properties.forceAliasCreation)), errors.collect(cdk.propertyValidator("messageAction", cdk.validateString)(properties.messageAction)), errors.collect(cdk.propertyValidator("userAttributes", cdk.listValidator(CfnUserPoolUser_AttributeTypePropertyValidator))(properties.userAttributes)), errors.collect(cdk.propertyValidator("userPoolId", cdk.requiredValidator)(properties.userPoolId)), errors.collect(cdk.propertyValidator("userPoolId", cdk.validateString)(properties.userPoolId)), errors.collect(cdk.propertyValidator("username", cdk.validateString)(properties.username)), errors.collect(cdk.propertyValidator("validationData", cdk.listValidator(CfnUserPoolUser_AttributeTypePropertyValidator))(properties.validationData)), errors.wrap('supplied properties not correct for "CfnUserPoolUserProps"');
    }
    function cfnUserPoolUserPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPoolUserPropsValidator(properties).assertSuccess(), { UserPoolId: cdk.stringToCloudFormation(properties.userPoolId), ClientMetadata: cdk.objectToCloudFormation(properties.clientMetadata), DesiredDeliveryMediums: cdk.listMapper(cdk.stringToCloudFormation)(properties.desiredDeliveryMediums), ForceAliasCreation: cdk.booleanToCloudFormation(properties.forceAliasCreation), MessageAction: cdk.stringToCloudFormation(properties.messageAction), UserAttributes: cdk.listMapper(cfnUserPoolUserAttributeTypePropertyToCloudFormation)(properties.userAttributes), Username: cdk.stringToCloudFormation(properties.username), ValidationData: cdk.listMapper(cfnUserPoolUserAttributeTypePropertyToCloudFormation)(properties.validationData) }) : properties;
    }
    function CfnUserPoolUserPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("userPoolId", "UserPoolId", cfn_parse.FromCloudFormation.getString(properties.UserPoolId)), ret.addPropertyResult("clientMetadata", "ClientMetadata", properties.ClientMetadata != null ? cfn_parse.FromCloudFormation.getAny(properties.ClientMetadata) : void 0), ret.addPropertyResult("desiredDeliveryMediums", "DesiredDeliveryMediums", properties.DesiredDeliveryMediums != null ? cfn_parse.FromCloudFormation.getStringArray(properties.DesiredDeliveryMediums) : void 0), ret.addPropertyResult("forceAliasCreation", "ForceAliasCreation", properties.ForceAliasCreation != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ForceAliasCreation) : void 0), ret.addPropertyResult("messageAction", "MessageAction", properties.MessageAction != null ? cfn_parse.FromCloudFormation.getString(properties.MessageAction) : void 0), ret.addPropertyResult("userAttributes", "UserAttributes", properties.UserAttributes != null ? cfn_parse.FromCloudFormation.getArray(CfnUserPoolUserAttributeTypePropertyFromCloudFormation)(properties.UserAttributes) : void 0), ret.addPropertyResult("username", "Username", properties.Username != null ? cfn_parse.FromCloudFormation.getString(properties.Username) : void 0), ret.addPropertyResult("validationData", "ValidationData", properties.ValidationData != null ? cfn_parse.FromCloudFormation.getArray(CfnUserPoolUserAttributeTypePropertyFromCloudFormation)(properties.ValidationData) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnUserPoolUser = class _CfnUserPoolUser extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnUserPoolUserPropsFromCloudFormation(resourceProperties), ret = new _CfnUserPoolUser(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnUserPoolUser.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_CfnUserPoolUserProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnUserPoolUser), error;
        }
        cdk.requireProperty(props, "userPoolId", this), this.userPoolId = props.userPoolId, this.clientMetadata = props.clientMetadata, this.desiredDeliveryMediums = props.desiredDeliveryMediums, this.forceAliasCreation = props.forceAliasCreation, this.messageAction = props.messageAction, this.userAttributes = props.userAttributes, this.username = props.username, this.validationData = props.validationData;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnUserPoolUser.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { userPoolId: this.userPoolId, clientMetadata: this.clientMetadata, desiredDeliveryMediums: this.desiredDeliveryMediums, forceAliasCreation: this.forceAliasCreation, messageAction: this.messageAction, userAttributes: this.userAttributes, username: this.username, validationData: this.validationData };
      }
      renderProperties(props) {
        return cfnUserPoolUserPropsToCloudFormation(props);
      }
    };
    _l = JSII_RTTI_SYMBOL_1, CfnUserPoolUser[_l] = { fqn: "aws-cdk-lib.aws_cognito.CfnUserPoolUser", version: "2.80.0" }, CfnUserPoolUser.CFN_RESOURCE_TYPE_NAME = "AWS::Cognito::UserPoolUser", exports2.CfnUserPoolUser = CfnUserPoolUser;
    function CfnUserPoolUser_AttributeTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "AttributeTypeProperty"');
    }
    function cfnUserPoolUserAttributeTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPoolUser_AttributeTypePropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnUserPoolUserAttributeTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPoolUserToGroupAttachmentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groupName", cdk.requiredValidator)(properties.groupName)), errors.collect(cdk.propertyValidator("groupName", cdk.validateString)(properties.groupName)), errors.collect(cdk.propertyValidator("userPoolId", cdk.requiredValidator)(properties.userPoolId)), errors.collect(cdk.propertyValidator("userPoolId", cdk.validateString)(properties.userPoolId)), errors.collect(cdk.propertyValidator("username", cdk.requiredValidator)(properties.username)), errors.collect(cdk.propertyValidator("username", cdk.validateString)(properties.username)), errors.wrap('supplied properties not correct for "CfnUserPoolUserToGroupAttachmentProps"');
    }
    function cfnUserPoolUserToGroupAttachmentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPoolUserToGroupAttachmentPropsValidator(properties).assertSuccess(), { GroupName: cdk.stringToCloudFormation(properties.groupName), Username: cdk.stringToCloudFormation(properties.username), UserPoolId: cdk.stringToCloudFormation(properties.userPoolId) }) : properties;
    }
    function CfnUserPoolUserToGroupAttachmentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupName", "GroupName", cfn_parse.FromCloudFormation.getString(properties.GroupName)), ret.addPropertyResult("username", "Username", cfn_parse.FromCloudFormation.getString(properties.Username)), ret.addPropertyResult("userPoolId", "UserPoolId", cfn_parse.FromCloudFormation.getString(properties.UserPoolId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnUserPoolUserToGroupAttachment = class _CfnUserPoolUserToGroupAttachment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnUserPoolUserToGroupAttachmentPropsFromCloudFormation(resourceProperties), ret = new _CfnUserPoolUserToGroupAttachment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnUserPoolUserToGroupAttachment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_CfnUserPoolUserToGroupAttachmentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnUserPoolUserToGroupAttachment), error;
        }
        cdk.requireProperty(props, "groupName", this), cdk.requireProperty(props, "userPoolId", this), cdk.requireProperty(props, "username", this), this.groupName = props.groupName, this.username = props.username, this.userPoolId = props.userPoolId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnUserPoolUserToGroupAttachment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { groupName: this.groupName, username: this.username, userPoolId: this.userPoolId };
      }
      renderProperties(props) {
        return cfnUserPoolUserToGroupAttachmentPropsToCloudFormation(props);
      }
    };
    _m = JSII_RTTI_SYMBOL_1, CfnUserPoolUserToGroupAttachment[_m] = { fqn: "aws-cdk-lib.aws_cognito.CfnUserPoolUserToGroupAttachment", version: "2.80.0" }, CfnUserPoolUserToGroupAttachment.CFN_RESOURCE_TYPE_NAME = "AWS::Cognito::UserPoolUserToGroupAttachment", exports2.CfnUserPoolUserToGroupAttachment = CfnUserPoolUserToGroupAttachment;
  }
});

// node_modules/aws-cdk-lib/node_modules/punycode/punycode.js
var require_punycode = __commonJS({
  "node_modules/aws-cdk-lib/node_modules/punycode/punycode.js"(exports2, module2) {
    "use strict";
    var maxInt = 2147483647;
    var base = 36;
    var tMin = 1;
    var tMax = 26;
    var skew = 38;
    var damp = 700;
    var initialBias = 72;
    var initialN = 128;
    var delimiter = "-";
    var regexPunycode = /^xn--/;
    var regexNonASCII = /[^\0-\x7F]/;
    var regexSeparators = /[\x2E\u3002\uFF0E\uFF61]/g;
    var errors = {
      "overflow": "Overflow: input needs wider integers to process",
      "not-basic": "Illegal input >= 0x80 (not a basic code point)",
      "invalid-input": "Invalid input"
    };
    var baseMinusTMin = base - tMin;
    var floor = Math.floor;
    var stringFromCharCode = String.fromCharCode;
    function error(type) {
      throw new RangeError(errors[type]);
    }
    function map(array, callback) {
      const result = [];
      let length = array.length;
      while (length--) {
        result[length] = callback(array[length]);
      }
      return result;
    }
    function mapDomain(domain, callback) {
      const parts = domain.split("@");
      let result = "";
      if (parts.length > 1) {
        result = parts[0] + "@";
        domain = parts[1];
      }
      domain = domain.replace(regexSeparators, ".");
      const labels = domain.split(".");
      const encoded = map(labels, callback).join(".");
      return result + encoded;
    }
    function ucs2decode(string) {
      const output = [];
      let counter = 0;
      const length = string.length;
      while (counter < length) {
        const value = string.charCodeAt(counter++);
        if (value >= 55296 && value <= 56319 && counter < length) {
          const extra = string.charCodeAt(counter++);
          if ((extra & 64512) == 56320) {
            output.push(((value & 1023) << 10) + (extra & 1023) + 65536);
          } else {
            output.push(value);
            counter--;
          }
        } else {
          output.push(value);
        }
      }
      return output;
    }
    var ucs2encode = (codePoints) => String.fromCodePoint(...codePoints);
    var basicToDigit = function(codePoint) {
      if (codePoint >= 48 && codePoint < 58) {
        return 26 + (codePoint - 48);
      }
      if (codePoint >= 65 && codePoint < 91) {
        return codePoint - 65;
      }
      if (codePoint >= 97 && codePoint < 123) {
        return codePoint - 97;
      }
      return base;
    };
    var digitToBasic = function(digit, flag) {
      return digit + 22 + 75 * (digit < 26) - ((flag != 0) << 5);
    };
    var adapt = function(delta, numPoints, firstTime) {
      let k = 0;
      delta = firstTime ? floor(delta / damp) : delta >> 1;
      delta += floor(delta / numPoints);
      for (; delta > baseMinusTMin * tMax >> 1; k += base) {
        delta = floor(delta / baseMinusTMin);
      }
      return floor(k + (baseMinusTMin + 1) * delta / (delta + skew));
    };
    var decode = function(input) {
      const output = [];
      const inputLength = input.length;
      let i = 0;
      let n = initialN;
      let bias = initialBias;
      let basic = input.lastIndexOf(delimiter);
      if (basic < 0) {
        basic = 0;
      }
      for (let j = 0; j < basic; ++j) {
        if (input.charCodeAt(j) >= 128) {
          error("not-basic");
        }
        output.push(input.charCodeAt(j));
      }
      for (let index = basic > 0 ? basic + 1 : 0; index < inputLength; ) {
        const oldi = i;
        for (let w = 1, k = base; ; k += base) {
          if (index >= inputLength) {
            error("invalid-input");
          }
          const digit = basicToDigit(input.charCodeAt(index++));
          if (digit >= base) {
            error("invalid-input");
          }
          if (digit > floor((maxInt - i) / w)) {
            error("overflow");
          }
          i += digit * w;
          const t = k <= bias ? tMin : k >= bias + tMax ? tMax : k - bias;
          if (digit < t) {
            break;
          }
          const baseMinusT = base - t;
          if (w > floor(maxInt / baseMinusT)) {
            error("overflow");
          }
          w *= baseMinusT;
        }
        const out = output.length + 1;
        bias = adapt(i - oldi, out, oldi == 0);
        if (floor(i / out) > maxInt - n) {
          error("overflow");
        }
        n += floor(i / out);
        i %= out;
        output.splice(i++, 0, n);
      }
      return String.fromCodePoint(...output);
    };
    var encode = function(input) {
      const output = [];
      input = ucs2decode(input);
      const inputLength = input.length;
      let n = initialN;
      let delta = 0;
      let bias = initialBias;
      for (const currentValue of input) {
        if (currentValue < 128) {
          output.push(stringFromCharCode(currentValue));
        }
      }
      const basicLength = output.length;
      let handledCPCount = basicLength;
      if (basicLength) {
        output.push(delimiter);
      }
      while (handledCPCount < inputLength) {
        let m = maxInt;
        for (const currentValue of input) {
          if (currentValue >= n && currentValue < m) {
            m = currentValue;
          }
        }
        const handledCPCountPlusOne = handledCPCount + 1;
        if (m - n > floor((maxInt - delta) / handledCPCountPlusOne)) {
          error("overflow");
        }
        delta += (m - n) * handledCPCountPlusOne;
        n = m;
        for (const currentValue of input) {
          if (currentValue < n && ++delta > maxInt) {
            error("overflow");
          }
          if (currentValue === n) {
            let q = delta;
            for (let k = base; ; k += base) {
              const t = k <= bias ? tMin : k >= bias + tMax ? tMax : k - bias;
              if (q < t) {
                break;
              }
              const qMinusT = q - t;
              const baseMinusT = base - t;
              output.push(
                stringFromCharCode(digitToBasic(t + qMinusT % baseMinusT, 0))
              );
              q = floor(qMinusT / baseMinusT);
            }
            output.push(stringFromCharCode(digitToBasic(q, 0)));
            bias = adapt(delta, handledCPCountPlusOne, handledCPCount === basicLength);
            delta = 0;
            ++handledCPCount;
          }
        }
        ++delta;
        ++n;
      }
      return output.join("");
    };
    var toUnicode = function(input) {
      return mapDomain(input, function(string) {
        return regexPunycode.test(string) ? decode(string.slice(4).toLowerCase()) : string;
      });
    };
    var toASCII = function(input) {
      return mapDomain(input, function(string) {
        return regexNonASCII.test(string) ? "xn--" + encode(string) : string;
      });
    };
    var punycode = {
      /**
       * A string representing the current Punycode.js version number.
       * @memberOf punycode
       * @type String
       */
      "version": "2.1.0",
      /**
       * An object of methods to convert from JavaScript's internal character
       * representation (UCS-2) to Unicode code points, and back.
       * @see <https://mathiasbynens.be/notes/javascript-encoding>
       * @memberOf punycode
       * @type Object
       */
      "ucs2": {
        "decode": ucs2decode,
        "encode": ucs2encode
      },
      "decode": decode,
      "encode": encode,
      "toASCII": toASCII,
      "toUnicode": toUnicode
    };
    module2.exports = punycode;
  }
});

// node_modules/aws-cdk-lib/aws-cognito/lib/private/attr-names.js
var require_attr_names = __commonJS({
  "node_modules/aws-cdk-lib/aws-cognito/lib/private/attr-names.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.StandardAttributeNames = void 0, exports2.StandardAttributeNames = { address: "address", birthdate: "birthdate", email: "email", familyName: "family_name", gender: "gender", givenName: "given_name", locale: "locale", middleName: "middle_name", fullname: "name", nickname: "nickname", phoneNumber: "phone_number", profilePicture: "picture", preferredUsername: "preferred_username", profilePage: "profile", timezone: "zoneinfo", lastUpdateTime: "updated_at", website: "website", emailVerified: "email_verified", phoneNumberVerified: "phone_number_verified" };
  }
});

// node_modules/aws-cdk-lib/aws-cognito/lib/user-pool-client.js
var require_user_pool_client = __commonJS({
  "node_modules/aws-cdk-lib/aws-cognito/lib/user-pool-client.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.UserPoolClient = exports2.UserPoolClientIdentityProvider = exports2.OAuthScope = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cognito_generated_1 = require_cognito_generated();
    var core_1 = require_core2();
    var custom_resources_1 = require_custom_resources();
    var OAuthScope = class _OAuthScope {
      static custom(name) {
        return new _OAuthScope(name);
      }
      static resourceServer(server, scope) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_IUserPoolResourceServer(server), jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_ResourceServerScope(scope);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.resourceServer), error;
        }
        return new _OAuthScope(`${server.userPoolResourceServerId}/${scope.scopeName}`);
      }
      constructor(scopeName) {
        this.scopeName = scopeName;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, OAuthScope[_a] = { fqn: "aws-cdk-lib.aws_cognito.OAuthScope", version: "2.80.0" }, OAuthScope.PHONE = new OAuthScope("phone"), OAuthScope.EMAIL = new OAuthScope("email"), OAuthScope.OPENID = new OAuthScope("openid"), OAuthScope.PROFILE = new OAuthScope("profile"), OAuthScope.COGNITO_ADMIN = new OAuthScope("aws.cognito.signin.user.admin"), exports2.OAuthScope = OAuthScope;
    var UserPoolClientIdentityProvider = class _UserPoolClientIdentityProvider {
      static custom(name) {
        return new _UserPoolClientIdentityProvider(name);
      }
      constructor(name) {
        this.name = name;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, UserPoolClientIdentityProvider[_b] = { fqn: "aws-cdk-lib.aws_cognito.UserPoolClientIdentityProvider", version: "2.80.0" }, UserPoolClientIdentityProvider.APPLE = new UserPoolClientIdentityProvider("SignInWithApple"), UserPoolClientIdentityProvider.FACEBOOK = new UserPoolClientIdentityProvider("Facebook"), UserPoolClientIdentityProvider.GOOGLE = new UserPoolClientIdentityProvider("Google"), UserPoolClientIdentityProvider.AMAZON = new UserPoolClientIdentityProvider("LoginWithAmazon"), UserPoolClientIdentityProvider.COGNITO = new UserPoolClientIdentityProvider("COGNITO"), exports2.UserPoolClientIdentityProvider = UserPoolClientIdentityProvider;
    var UserPoolClient = class _UserPoolClient extends core_1.Resource {
      static fromUserPoolClientId(scope, id, userPoolClientId) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.userPoolClientId = userPoolClientId;
          }
          get userPoolClientSecret() {
            throw new Error("UserPool Client Secret is not available for imported Clients");
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_UserPoolClientProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _UserPoolClient), error;
        }
        if (props.disableOAuth && props.oAuth)
          throw new Error("OAuth settings cannot be specified when disableOAuth is set.");
        this.oAuthFlows = props.oAuth?.flows ?? { implicitCodeGrant: true, authorizationCodeGrant: true };
        let callbackUrls = props.oAuth?.callbackUrls;
        if (this.oAuthFlows.authorizationCodeGrant || this.oAuthFlows.implicitCodeGrant) {
          if (callbackUrls === void 0)
            callbackUrls = ["https://example.com"];
          else if (callbackUrls.length === 0)
            throw new Error("callbackUrl must not be empty when codeGrant or implicitGrant OAuth flows are enabled.");
        }
        this._generateSecret = props.generateSecret, this.userPool = props.userPool;
        const resource = new cognito_generated_1.CfnUserPoolClient(this, "Resource", { clientName: props.userPoolClientName, generateSecret: props.generateSecret, userPoolId: props.userPool.userPoolId, explicitAuthFlows: this.configureAuthFlows(props), allowedOAuthFlows: props.disableOAuth ? void 0 : this.configureOAuthFlows(), allowedOAuthScopes: props.disableOAuth ? void 0 : this.configureOAuthScopes(props.oAuth), callbackUrLs: callbackUrls && callbackUrls.length > 0 && !props.disableOAuth ? callbackUrls : void 0, logoutUrLs: props.oAuth?.logoutUrls, allowedOAuthFlowsUserPoolClient: !props.disableOAuth, preventUserExistenceErrors: this.configurePreventUserExistenceErrors(props.preventUserExistenceErrors), supportedIdentityProviders: this.configureIdentityProviders(props), readAttributes: props.readAttributes?.attributes(), writeAttributes: props.writeAttributes?.attributes(), enableTokenRevocation: props.enableTokenRevocation });
        this.configureAuthSessionValidity(resource, props), this.configureTokenValidity(resource, props), this.userPoolClientId = resource.ref, this._userPoolClientName = props.userPoolClientName;
      }
      get userPoolClientName() {
        if (this._userPoolClientName === void 0)
          throw new Error("userPoolClientName is available only if specified on the UserPoolClient during initialization");
        return this._userPoolClientName;
      }
      get userPoolClientSecret() {
        if (!this._generateSecret)
          throw new Error("userPoolClientSecret is available only if generateSecret is set to true.");
        return this._userPoolClientSecret || (this._userPoolClientSecret = core_1.SecretValue.resourceAttribute(new custom_resources_1.AwsCustomResource(this, "DescribeCognitoUserPoolClient", { resourceType: "Custom::DescribeCognitoUserPoolClient", onUpdate: { region: core_1.Stack.of(this).region, service: "CognitoIdentityServiceProvider", action: "describeUserPoolClient", parameters: { UserPoolId: this.userPool.userPoolId, ClientId: this.userPoolClientId }, physicalResourceId: custom_resources_1.PhysicalResourceId.of(this.userPoolClientId) }, policy: custom_resources_1.AwsCustomResourcePolicy.fromSdkCalls({ resources: [this.userPool.userPoolArn] }), installLatestAwsSdk: false }).getResponseField("UserPoolClient.ClientSecret"))), this._userPoolClientSecret;
      }
      configureAuthFlows(props) {
        if (!props.authFlows || Object.keys(props.authFlows).length === 0)
          return;
        const authFlows = [];
        return props.authFlows.userPassword && authFlows.push("ALLOW_USER_PASSWORD_AUTH"), props.authFlows.adminUserPassword && authFlows.push("ALLOW_ADMIN_USER_PASSWORD_AUTH"), props.authFlows.custom && authFlows.push("ALLOW_CUSTOM_AUTH"), props.authFlows.userSrp && authFlows.push("ALLOW_USER_SRP_AUTH"), authFlows.push("ALLOW_REFRESH_TOKEN_AUTH"), authFlows;
      }
      configureOAuthFlows() {
        if ((this.oAuthFlows.authorizationCodeGrant || this.oAuthFlows.implicitCodeGrant) && this.oAuthFlows.clientCredentials)
          throw new Error("clientCredentials OAuth flow cannot be selected along with codeGrant or implicitGrant.");
        const oAuthFlows = [];
        if (this.oAuthFlows.clientCredentials && oAuthFlows.push("client_credentials"), this.oAuthFlows.implicitCodeGrant && oAuthFlows.push("implicit"), this.oAuthFlows.authorizationCodeGrant && oAuthFlows.push("code"), oAuthFlows.length !== 0)
          return oAuthFlows;
      }
      configureOAuthScopes(oAuth) {
        const scopes = oAuth?.scopes ?? [OAuthScope.PROFILE, OAuthScope.PHONE, OAuthScope.EMAIL, OAuthScope.OPENID, OAuthScope.COGNITO_ADMIN], scopeNames = new Set(scopes.map((x) => x.scopeName));
        return [OAuthScope.PHONE, OAuthScope.EMAIL, OAuthScope.PROFILE].reduce((agg, s) => agg || scopeNames.has(s.scopeName), false) && scopeNames.add(OAuthScope.OPENID.scopeName), Array.from(scopeNames);
      }
      configurePreventUserExistenceErrors(prevent) {
        if (prevent !== void 0)
          return prevent ? "ENABLED" : "LEGACY";
      }
      configureIdentityProviders(props) {
        let providers;
        if (props.supportedIdentityProviders)
          providers = props.supportedIdentityProviders.map((p) => p.name);
        else {
          const providerSet = new Set(props.userPool.identityProviders.map((p) => p.providerName));
          providerSet.add("COGNITO"), providers = Array.from(providerSet);
        }
        if (providers.length !== 0)
          return Array.from(providers);
      }
      configureAuthSessionValidity(resource, props) {
        this.validateDuration("authSessionValidity", core_1.Duration.minutes(3), core_1.Duration.minutes(15), props.authSessionValidity), resource.authSessionValidity = props.authSessionValidity ? props.authSessionValidity.toMinutes() : void 0;
      }
      configureTokenValidity(resource, props) {
        this.validateDuration("idTokenValidity", core_1.Duration.minutes(5), core_1.Duration.days(1), props.idTokenValidity), this.validateDuration("accessTokenValidity", core_1.Duration.minutes(5), core_1.Duration.days(1), props.accessTokenValidity), this.validateDuration("refreshTokenValidity", core_1.Duration.minutes(60), core_1.Duration.days(10 * 365), props.refreshTokenValidity), props.refreshTokenValidity && (this.validateDuration("idTokenValidity", core_1.Duration.minutes(5), props.refreshTokenValidity, props.idTokenValidity), this.validateDuration("accessTokenValidity", core_1.Duration.minutes(5), props.refreshTokenValidity, props.accessTokenValidity)), (props.accessTokenValidity || props.idTokenValidity || props.refreshTokenValidity) && (resource.tokenValidityUnits = { idToken: props.idTokenValidity ? "minutes" : void 0, accessToken: props.accessTokenValidity ? "minutes" : void 0, refreshToken: props.refreshTokenValidity ? "minutes" : void 0 }), resource.idTokenValidity = props.idTokenValidity ? props.idTokenValidity.toMinutes() : void 0, resource.refreshTokenValidity = props.refreshTokenValidity ? props.refreshTokenValidity.toMinutes() : void 0, resource.accessTokenValidity = props.accessTokenValidity ? props.accessTokenValidity.toMinutes() : void 0;
      }
      validateDuration(name, min, max, value) {
        if (value !== void 0 && (value.toMilliseconds() < min.toMilliseconds() || value.toMilliseconds() > max.toMilliseconds()))
          throw new Error(`${name}: Must be a duration between ${min.toHumanString()} and ${max.toHumanString()} (inclusive); received ${value.toHumanString()}.`);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, UserPoolClient[_c] = { fqn: "aws-cdk-lib.aws_cognito.UserPoolClient", version: "2.80.0" }, exports2.UserPoolClient = UserPoolClient;
  }
});

// node_modules/aws-cdk-lib/aws-cognito/lib/user-pool-domain.js
var require_user_pool_domain = __commonJS({
  "node_modules/aws-cdk-lib/aws-cognito/lib/user-pool-domain.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.UserPoolDomain = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cognito_generated_1 = require_cognito_generated();
    var core_1 = require_core2();
    var custom_resources_1 = require_custom_resources();
    var UserPoolDomain = class _UserPoolDomain extends core_1.Resource {
      static fromDomainName(scope, id, userPoolDomainName) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.domainName = userPoolDomainName;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_UserPoolDomainProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _UserPoolDomain), error;
        }
        if (!!props.customDomain == !!props.cognitoDomain)
          throw new Error("One of, and only one of, cognitoDomain or customDomain must be specified");
        if (props.cognitoDomain?.domainPrefix && !core_1.Token.isUnresolved(props.cognitoDomain?.domainPrefix) && !/^[a-z0-9-]+$/.test(props.cognitoDomain.domainPrefix))
          throw new Error("domainPrefix for cognitoDomain can contain only lowercase alphabets, numbers and hyphens");
        this.isCognitoDomain = !!props.cognitoDomain;
        const domainName = props.cognitoDomain?.domainPrefix || props.customDomain?.domainName, resource = new cognito_generated_1.CfnUserPoolDomain(this, "Resource", { userPoolId: props.userPool.userPoolId, domain: domainName, customDomainConfig: props.customDomain ? { certificateArn: props.customDomain.certificate.certificateArn } : void 0 });
        this.domainName = resource.ref;
      }
      get cloudFrontDomainName() {
        if (!this.cloudFrontCustomResource) {
          const sdkCall = { service: "CognitoIdentityServiceProvider", action: "describeUserPoolDomain", parameters: { Domain: this.domainName }, physicalResourceId: custom_resources_1.PhysicalResourceId.of(this.domainName) };
          this.cloudFrontCustomResource = new custom_resources_1.AwsCustomResource(this, "CloudFrontDomainName", { resourceType: "Custom::UserPoolCloudFrontDomainName", onCreate: sdkCall, onUpdate: sdkCall, policy: custom_resources_1.AwsCustomResourcePolicy.fromSdkCalls({ resources: ["*"] }), installLatestAwsSdk: false });
        }
        return this.cloudFrontCustomResource.getResponseField("DomainDescription.CloudFrontDistribution");
      }
      baseUrl(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_BaseUrlOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.baseUrl), error;
        }
        if (this.isCognitoDomain) {
          const authDomain = "auth" + (options?.fips ? "-fips" : "");
          return `https://${this.domainName}.${authDomain}.${core_1.Stack.of(this).region}.amazoncognito.com`;
        }
        return `https://${this.domainName}`;
      }
      signInUrl(client, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_UserPoolClient(client), jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_SignInUrlOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.signInUrl), error;
        }
        let responseType;
        if (client.oAuthFlows.authorizationCodeGrant)
          responseType = "code";
        else if (client.oAuthFlows.implicitCodeGrant)
          responseType = "token";
        else
          throw new Error("signInUrl is not supported for clients without authorizationCodeGrant or implicitCodeGrant flow enabled");
        const path = options.signInPath ?? "/login";
        return `${this.baseUrl(options)}${path}?client_id=${client.userPoolClientId}&response_type=${responseType}&redirect_uri=${options.redirectUri}`;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, UserPoolDomain[_a] = { fqn: "aws-cdk-lib.aws_cognito.UserPoolDomain", version: "2.80.0" }, exports2.UserPoolDomain = UserPoolDomain;
  }
});

// node_modules/aws-cdk-lib/aws-cognito/lib/user-pool-resource-server.js
var require_user_pool_resource_server = __commonJS({
  "node_modules/aws-cdk-lib/aws-cognito/lib/user-pool-resource-server.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.UserPoolResourceServer = exports2.ResourceServerScope = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cognito_generated_1 = require_cognito_generated();
    var core_1 = require_core2();
    var ResourceServerScope = class _ResourceServerScope {
      constructor(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_ResourceServerScopeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ResourceServerScope), error;
        }
        this.scopeName = props.scopeName, this.scopeDescription = props.scopeDescription;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ResourceServerScope[_a] = { fqn: "aws-cdk-lib.aws_cognito.ResourceServerScope", version: "2.80.0" }, exports2.ResourceServerScope = ResourceServerScope;
    var UserPoolResourceServer = class _UserPoolResourceServer extends core_1.Resource {
      static fromUserPoolResourceServerId(scope, id, userPoolResourceServerId) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.userPoolResourceServerId = userPoolResourceServerId;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.identifier });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_UserPoolResourceServerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _UserPoolResourceServer), error;
        }
        const resource = new cognito_generated_1.CfnUserPoolResourceServer(this, "Resource", { identifier: this.physicalName, name: props.userPoolResourceServerName ?? this.physicalName, scopes: props.scopes, userPoolId: props.userPool.userPoolId });
        this.userPoolResourceServerId = resource.ref;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, UserPoolResourceServer[_b] = { fqn: "aws-cdk-lib.aws_cognito.UserPoolResourceServer", version: "2.80.0" }, exports2.UserPoolResourceServer = UserPoolResourceServer;
  }
});

// node_modules/aws-cdk-lib/aws-cognito/lib/user-pool.js
var require_user_pool = __commonJS({
  "node_modules/aws-cdk-lib/aws-cognito/lib/user-pool.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.UserPool = exports2.AdvancedSecurityMode = exports2.AccountRecovery = exports2.Mfa = exports2.VerificationEmailStyle = exports2.UserPoolOperation = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var punycode_1 = require_punycode();
    var cognito_generated_1 = require_cognito_generated();
    var attr_names_1 = require_attr_names();
    var user_pool_client_1 = require_user_pool_client();
    var user_pool_domain_1 = require_user_pool_domain();
    var user_pool_resource_server_1 = require_user_pool_resource_server();
    var aws_iam_1 = require_aws_iam();
    var core_1 = require_core2();
    var UserPoolOperation = class _UserPoolOperation {
      static of(name) {
        const lowerCamelCase = name.charAt(0).toLowerCase() + name.slice(1);
        return new _UserPoolOperation(lowerCamelCase);
      }
      constructor(operationName) {
        this.operationName = operationName;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, UserPoolOperation[_a] = { fqn: "aws-cdk-lib.aws_cognito.UserPoolOperation", version: "2.80.0" }, UserPoolOperation.CREATE_AUTH_CHALLENGE = new UserPoolOperation("createAuthChallenge"), UserPoolOperation.CUSTOM_MESSAGE = new UserPoolOperation("customMessage"), UserPoolOperation.DEFINE_AUTH_CHALLENGE = new UserPoolOperation("defineAuthChallenge"), UserPoolOperation.POST_AUTHENTICATION = new UserPoolOperation("postAuthentication"), UserPoolOperation.POST_CONFIRMATION = new UserPoolOperation("postConfirmation"), UserPoolOperation.PRE_AUTHENTICATION = new UserPoolOperation("preAuthentication"), UserPoolOperation.PRE_SIGN_UP = new UserPoolOperation("preSignUp"), UserPoolOperation.PRE_TOKEN_GENERATION = new UserPoolOperation("preTokenGeneration"), UserPoolOperation.USER_MIGRATION = new UserPoolOperation("userMigration"), UserPoolOperation.VERIFY_AUTH_CHALLENGE_RESPONSE = new UserPoolOperation("verifyAuthChallengeResponse"), UserPoolOperation.CUSTOM_EMAIL_SENDER = new UserPoolOperation("customEmailSender"), UserPoolOperation.CUSTOM_SMS_SENDER = new UserPoolOperation("customSmsSender"), exports2.UserPoolOperation = UserPoolOperation;
    var VerificationEmailStyle;
    (function(VerificationEmailStyle2) {
      VerificationEmailStyle2.CODE = "CONFIRM_WITH_CODE", VerificationEmailStyle2.LINK = "CONFIRM_WITH_LINK";
    })(VerificationEmailStyle = exports2.VerificationEmailStyle || (exports2.VerificationEmailStyle = {}));
    var Mfa;
    (function(Mfa2) {
      Mfa2.OFF = "OFF", Mfa2.OPTIONAL = "OPTIONAL", Mfa2.REQUIRED = "ON";
    })(Mfa = exports2.Mfa || (exports2.Mfa = {}));
    var AccountRecovery;
    (function(AccountRecovery2) {
      AccountRecovery2[AccountRecovery2.EMAIL_AND_PHONE_WITHOUT_MFA = 0] = "EMAIL_AND_PHONE_WITHOUT_MFA", AccountRecovery2[AccountRecovery2.PHONE_WITHOUT_MFA_AND_EMAIL = 1] = "PHONE_WITHOUT_MFA_AND_EMAIL", AccountRecovery2[AccountRecovery2.EMAIL_ONLY = 2] = "EMAIL_ONLY", AccountRecovery2[AccountRecovery2.PHONE_ONLY_WITHOUT_MFA = 3] = "PHONE_ONLY_WITHOUT_MFA", AccountRecovery2[AccountRecovery2.PHONE_AND_EMAIL = 4] = "PHONE_AND_EMAIL", AccountRecovery2[AccountRecovery2.NONE = 5] = "NONE";
    })(AccountRecovery = exports2.AccountRecovery || (exports2.AccountRecovery = {}));
    var AdvancedSecurityMode;
    (function(AdvancedSecurityMode2) {
      AdvancedSecurityMode2.ENFORCED = "ENFORCED", AdvancedSecurityMode2.AUDIT = "AUDIT", AdvancedSecurityMode2.OFF = "OFF";
    })(AdvancedSecurityMode = exports2.AdvancedSecurityMode || (exports2.AdvancedSecurityMode = {}));
    var UserPoolBase = class extends core_1.Resource {
      constructor() {
        super(...arguments), this.identityProviders = [];
      }
      addClient(id, options) {
        return new user_pool_client_1.UserPoolClient(this, id, { userPool: this, ...options });
      }
      addDomain(id, options) {
        return new user_pool_domain_1.UserPoolDomain(this, id, { userPool: this, ...options });
      }
      addResourceServer(id, options) {
        return new user_pool_resource_server_1.UserPoolResourceServer(this, id, { userPool: this, ...options });
      }
      registerIdentityProvider(provider) {
        this.identityProviders.push(provider);
      }
      grant(grantee, ...actions) {
        return aws_iam_1.Grant.addToPrincipal({ grantee, actions, resourceArns: [this.userPoolArn], scope: this });
      }
    };
    var UserPool = class _UserPool extends UserPoolBase {
      static fromUserPoolId(scope, id, userPoolId) {
        let userPoolArn = core_1.Stack.of(scope).formatArn({ service: "cognito-idp", resource: "userpool", resourceName: userPoolId });
        return _UserPool.fromUserPoolArn(scope, id, userPoolArn);
      }
      static fromUserPoolArn(scope, id, userPoolArn) {
        const arnParts = core_1.Stack.of(scope).splitArn(userPoolArn, core_1.ArnFormat.SLASH_RESOURCE_NAME);
        if (!arnParts.resourceName)
          throw new Error("invalid user pool ARN");
        const userPoolId = arnParts.resourceName;
        class ImportedUserPool extends UserPoolBase {
          constructor() {
            super(scope, id, { account: arnParts.account, region: arnParts.region }), this.userPoolArn = userPoolArn, this.userPoolId = userPoolId;
          }
        }
        return new ImportedUserPool();
      }
      constructor(scope, id, props = {}) {
        super(scope, id), this.triggers = {};
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_UserPoolProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _UserPool), error;
        }
        const signIn = this.signInConfiguration(props);
        if (props.customSenderKmsKey) {
          const kmsKey = props.customSenderKmsKey;
          this.triggers.kmsKeyId = kmsKey.keyArn;
        }
        if (props.lambdaTriggers)
          for (const t of Object.keys(props.lambdaTriggers)) {
            let trigger;
            switch (t) {
              case "customSmsSender":
              case "customEmailSender":
                if (!this.triggers.kmsKeyId)
                  throw new Error("you must specify a KMS key if you are using customSmsSender or customEmailSender.");
                trigger = props.lambdaTriggers[t];
                const version = "V1_0";
                trigger !== void 0 && (this.addLambdaPermission(trigger, t), this.triggers[t] = { lambdaArn: trigger.functionArn, lambdaVersion: version });
                break;
              default:
                trigger = props.lambdaTriggers[t], trigger !== void 0 && (this.addLambdaPermission(trigger, t), this.triggers[t] = trigger.functionArn);
                break;
            }
          }
        const verificationMessageTemplate = this.verificationMessageConfiguration(props);
        let emailVerificationMessage, emailVerificationSubject;
        verificationMessageTemplate.defaultEmailOption === VerificationEmailStyle.CODE && (emailVerificationMessage = verificationMessageTemplate.emailMessage, emailVerificationSubject = verificationMessageTemplate.emailSubject);
        const smsVerificationMessage = verificationMessageTemplate.smsMessage, inviteMessageTemplate = { emailMessage: props.userInvitation?.emailBody, emailSubject: props.userInvitation?.emailSubject, smsMessage: props.userInvitation?.smsMessage }, adminCreateUserConfig = { allowAdminCreateUserOnly: !(props.selfSignUpEnabled ?? false), inviteMessageTemplate: props.userInvitation !== void 0 ? inviteMessageTemplate : void 0 }, passwordPolicy = this.configurePasswordPolicy(props);
        if (props.email && props.emailSettings)
          throw new Error('you must either provide "email" or "emailSettings", but not both');
        const emailConfiguration = props.email ? props.email._bind(this) : undefinedIfNoKeys({ from: encodePuny(props.emailSettings?.from), replyToEmailAddress: encodePuny(props.emailSettings?.replyTo) }), userPool = new cognito_generated_1.CfnUserPool(this, "Resource", { userPoolName: props.userPoolName, usernameAttributes: signIn.usernameAttrs, aliasAttributes: signIn.aliasAttrs, autoVerifiedAttributes: signIn.autoVerifyAttrs, lambdaConfig: core_1.Lazy.any({ produce: () => undefinedIfNoKeys(this.triggers) }), smsAuthenticationMessage: this.mfaMessage(props), smsConfiguration: this.smsConfiguration(props), adminCreateUserConfig, emailVerificationMessage, emailVerificationSubject, smsVerificationMessage, verificationMessageTemplate, userPoolAddOns: undefinedIfNoKeys({ advancedSecurityMode: props.advancedSecurityMode }), schema: this.schemaConfiguration(props), mfaConfiguration: props.mfa, enabledMfas: this.mfaConfiguration(props), policies: passwordPolicy !== void 0 ? { passwordPolicy } : void 0, emailConfiguration, usernameConfiguration: undefinedIfNoKeys({ caseSensitive: props.signInCaseSensitive }), accountRecoverySetting: this.accountRecovery(props), deviceConfiguration: props.deviceTracking, userAttributeUpdateSettings: this.configureUserAttributeChanges(props), deletionProtection: defaultDeletionProtection(props.deletionProtection) });
        userPool.applyRemovalPolicy(props.removalPolicy), this.userPoolId = userPool.ref, this.userPoolArn = userPool.attrArn, this.userPoolProviderName = userPool.attrProviderName, this.userPoolProviderUrl = userPool.attrProviderUrl;
      }
      addTrigger(operation, fn) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_UserPoolOperation(operation), jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_IFunction(fn);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addTrigger), error;
        }
        if (operation.operationName in this.triggers)
          throw new Error(`A trigger for the operation ${operation.operationName} already exists.`);
        switch (this.addLambdaPermission(fn, operation.operationName), operation.operationName) {
          case "customEmailSender":
          case "customSmsSender":
            if (!this.triggers.kmsKeyId)
              throw new Error("you must specify a KMS key if you are using customSmsSender or customEmailSender.");
            this.triggers[operation.operationName] = { lambdaArn: fn.functionArn, lambdaVersion: "V1_0" };
            break;
          default:
            this.triggers[operation.operationName] = fn.functionArn;
        }
      }
      addLambdaPermission(fn, name) {
        const capitalize = name.charAt(0).toUpperCase() + name.slice(1);
        fn.addPermission(`${capitalize}Cognito`, { principal: new aws_iam_1.ServicePrincipal("cognito-idp.amazonaws.com"), sourceArn: core_1.Lazy.string({ produce: () => this.userPoolArn }), scope: this });
      }
      mfaMessage(props) {
        const CODE_TEMPLATE = "{####}", message = props.mfaMessage;
        if (message && !core_1.Token.isUnresolved(message)) {
          if (!message.includes(CODE_TEMPLATE))
            throw new Error(`MFA message must contain the template string '${CODE_TEMPLATE}'`);
          if (message.length > 140)
            throw new Error(`MFA message must be between ${CODE_TEMPLATE.length} and 140 characters`);
        }
        return message;
      }
      verificationMessageConfiguration(props) {
        const CODE_TEMPLATE = "{####}", VERIFY_EMAIL_TEMPLATE = "{##Verify Email##}", emailStyle = props.userVerification?.emailStyle ?? VerificationEmailStyle.CODE, emailSubject = props.userVerification?.emailSubject ?? "Verify your new account", smsMessage = props.userVerification?.smsMessage ?? `The verification code to your new account is ${CODE_TEMPLATE}`;
        if (emailStyle === VerificationEmailStyle.CODE) {
          const emailMessage = props.userVerification?.emailBody ?? `The verification code to your new account is ${CODE_TEMPLATE}`;
          if (!core_1.Token.isUnresolved(emailMessage) && emailMessage.indexOf(CODE_TEMPLATE) < 0)
            throw new Error(`Verification email body must contain the template string '${CODE_TEMPLATE}'`);
          if (!core_1.Token.isUnresolved(smsMessage) && smsMessage.indexOf(CODE_TEMPLATE) < 0)
            throw new Error(`SMS message must contain the template string '${CODE_TEMPLATE}'`);
          return { defaultEmailOption: VerificationEmailStyle.CODE, emailMessage, emailSubject, smsMessage };
        } else {
          const emailMessage = props.userVerification?.emailBody ?? `Verify your account by clicking on ${VERIFY_EMAIL_TEMPLATE}`;
          if (!core_1.Token.isUnresolved(emailMessage) && emailMessage.indexOf(VERIFY_EMAIL_TEMPLATE) < 0)
            throw new Error(`Verification email body must contain the template string '${VERIFY_EMAIL_TEMPLATE}'`);
          return { defaultEmailOption: VerificationEmailStyle.LINK, emailMessageByLink: emailMessage, emailSubjectByLink: emailSubject, smsMessage };
        }
      }
      signInConfiguration(props) {
        let aliasAttrs, usernameAttrs, autoVerifyAttrs;
        const signIn = props.signInAliases ?? { username: true };
        if (signIn.preferredUsername && !signIn.username)
          throw new Error("username signIn must be enabled if preferredUsername is enabled");
        return signIn.username ? (aliasAttrs = [], signIn.email && aliasAttrs.push(attr_names_1.StandardAttributeNames.email), signIn.phone && aliasAttrs.push(attr_names_1.StandardAttributeNames.phoneNumber), signIn.preferredUsername && aliasAttrs.push(attr_names_1.StandardAttributeNames.preferredUsername), aliasAttrs.length === 0 && (aliasAttrs = void 0)) : (usernameAttrs = [], signIn.email && usernameAttrs.push(attr_names_1.StandardAttributeNames.email), signIn.phone && usernameAttrs.push(attr_names_1.StandardAttributeNames.phoneNumber)), props.autoVerify ? (autoVerifyAttrs = [], props.autoVerify.email && autoVerifyAttrs.push(attr_names_1.StandardAttributeNames.email), props.autoVerify.phone && autoVerifyAttrs.push(attr_names_1.StandardAttributeNames.phoneNumber)) : (signIn.email || signIn.phone) && (autoVerifyAttrs = [], signIn.email && autoVerifyAttrs.push(attr_names_1.StandardAttributeNames.email), signIn.phone && autoVerifyAttrs.push(attr_names_1.StandardAttributeNames.phoneNumber)), { usernameAttrs, aliasAttrs, autoVerifyAttrs };
      }
      smsConfiguration(props) {
        if (props.enableSmsRole === false && props.smsRole)
          throw new Error("enableSmsRole cannot be disabled when smsRole is specified");
        if (props.smsRole)
          return { snsCallerArn: props.smsRole.roleArn, externalId: props.smsRoleExternalId, snsRegion: props.snsRegion };
        if (props.enableSmsRole === false)
          return;
        const mfaConfiguration = this.mfaConfiguration(props), phoneVerification = props.signInAliases?.phone === true || props.autoVerify?.phone === true;
        if (!(mfaConfiguration?.includes("SMS_MFA") || phoneVerification) && props.enableSmsRole === void 0)
          return;
        const smsRoleExternalId = core_1.Names.uniqueId(this).slice(0, 1223), smsRole = props.smsRole ?? new aws_iam_1.Role(this, "smsRole", { assumedBy: new aws_iam_1.ServicePrincipal("cognito-idp.amazonaws.com", { conditions: { StringEquals: { "sts:ExternalId": smsRoleExternalId } } }), inlinePolicies: { "sns-publish": new aws_iam_1.PolicyDocument({ statements: [new aws_iam_1.PolicyStatement({ actions: ["sns:Publish"], resources: ["*"] })] }) } });
        return { externalId: smsRoleExternalId, snsCallerArn: smsRole.roleArn, snsRegion: props.snsRegion };
      }
      mfaConfiguration(props) {
        if (!(props.mfa === void 0 || props.mfa === Mfa.OFF)) {
          if (props.mfaSecondFactor === void 0 && (props.mfa === Mfa.OPTIONAL || props.mfa === Mfa.REQUIRED))
            return ["SMS_MFA"];
          {
            const enabledMfas = [];
            return props.mfaSecondFactor.sms && enabledMfas.push("SMS_MFA"), props.mfaSecondFactor.otp && enabledMfas.push("SOFTWARE_TOKEN_MFA"), enabledMfas;
          }
        }
      }
      configurePasswordPolicy(props) {
        const tempPasswordValidity = props.passwordPolicy?.tempPasswordValidity;
        if (tempPasswordValidity !== void 0 && tempPasswordValidity.toDays() > core_1.Duration.days(365).toDays())
          throw new Error(`tempPasswordValidity cannot be greater than 365 days (received: ${tempPasswordValidity.toDays()})`);
        const minLength = props.passwordPolicy ? props.passwordPolicy.minLength ?? 8 : void 0;
        if (minLength !== void 0 && (minLength < 6 || minLength > 99))
          throw new Error(`minLength for password must be between 6 and 99 (received: ${minLength})`);
        return undefinedIfNoKeys({ temporaryPasswordValidityDays: tempPasswordValidity?.toDays({ integral: true }), minimumLength: minLength, requireLowercase: props.passwordPolicy?.requireLowercase, requireUppercase: props.passwordPolicy?.requireUppercase, requireNumbers: props.passwordPolicy?.requireDigits, requireSymbols: props.passwordPolicy?.requireSymbols });
      }
      schemaConfiguration(props) {
        const schema = [];
        if (props.standardAttributes) {
          const stdAttributes = Object.entries(props.standardAttributes).filter(([, attr]) => !!attr).map(([attrName, attr]) => ({ name: attr_names_1.StandardAttributeNames[attrName], mutable: attr.mutable ?? true, required: attr.required ?? false }));
          schema.push(...stdAttributes);
        }
        if (props.customAttributes) {
          const customAttrs = Object.keys(props.customAttributes).map((attrName) => {
            const attrConfig = props.customAttributes[attrName].bind(), numberConstraints = { minValue: attrConfig.numberConstraints?.min?.toString(), maxValue: attrConfig.numberConstraints?.max?.toString() }, stringConstraints = { minLength: attrConfig.stringConstraints?.minLen?.toString(), maxLength: attrConfig.stringConstraints?.maxLen?.toString() };
            return { name: attrName, attributeDataType: attrConfig.dataType, numberAttributeConstraints: attrConfig.numberConstraints ? numberConstraints : void 0, stringAttributeConstraints: attrConfig.stringConstraints ? stringConstraints : void 0, mutable: attrConfig.mutable };
          });
          schema.push(...customAttrs);
        }
        if (schema.length !== 0)
          return schema;
      }
      accountRecovery(props) {
        const accountRecovery = props.accountRecovery ?? AccountRecovery.PHONE_WITHOUT_MFA_AND_EMAIL;
        switch (accountRecovery) {
          case AccountRecovery.EMAIL_AND_PHONE_WITHOUT_MFA:
            return { recoveryMechanisms: [{ name: "verified_email", priority: 1 }, { name: "verified_phone_number", priority: 2 }] };
          case AccountRecovery.PHONE_WITHOUT_MFA_AND_EMAIL:
            return { recoveryMechanisms: [{ name: "verified_phone_number", priority: 1 }, { name: "verified_email", priority: 2 }] };
          case AccountRecovery.EMAIL_ONLY:
            return { recoveryMechanisms: [{ name: "verified_email", priority: 1 }] };
          case AccountRecovery.PHONE_ONLY_WITHOUT_MFA:
            return { recoveryMechanisms: [{ name: "verified_phone_number", priority: 1 }] };
          case AccountRecovery.NONE:
            return { recoveryMechanisms: [{ name: "admin_only", priority: 1 }] };
          case AccountRecovery.PHONE_AND_EMAIL:
            return;
          default:
            throw new Error(`Unsupported AccountRecovery type - ${accountRecovery}`);
        }
      }
      configureUserAttributeChanges(props) {
        if (!props.keepOriginal)
          return;
        const attributesRequireVerificationBeforeUpdate = [];
        return props.keepOriginal.email && attributesRequireVerificationBeforeUpdate.push(attr_names_1.StandardAttributeNames.email), props.keepOriginal.phone && attributesRequireVerificationBeforeUpdate.push(attr_names_1.StandardAttributeNames.phoneNumber), { attributesRequireVerificationBeforeUpdate };
      }
    };
    _b = JSII_RTTI_SYMBOL_1, UserPool[_b] = { fqn: "aws-cdk-lib.aws_cognito.UserPool", version: "2.80.0" }, exports2.UserPool = UserPool;
    function undefinedIfNoKeys(struct) {
      return Object.values(struct).every((val) => val === void 0) ? void 0 : struct;
    }
    function encodePuny(input) {
      return input !== void 0 ? (0, punycode_1.toASCII)(input) : input;
    }
    function defaultDeletionProtection(deletionProtection) {
      if (deletionProtection === true)
        return "ACTIVE";
      if (deletionProtection === false)
        return "INACTIVE";
    }
  }
});

// node_modules/aws-cdk-lib/aws-cognito/lib/user-pool-attr.js
var require_user_pool_attr = __commonJS({
  "node_modules/aws-cdk-lib/aws-cognito/lib/user-pool-attr.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ClientAttributes = exports2.DateTimeAttribute = exports2.BooleanAttribute = exports2.NumberAttribute = exports2.StringAttribute = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var attr_names_1 = require_attr_names();
    var core_1 = require_core2();
    var StringAttribute = class _StringAttribute {
      constructor(props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_StringAttributeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _StringAttribute), error;
        }
        if (props.minLen && !core_1.Token.isUnresolved(props.minLen) && props.minLen < 0)
          throw new Error(`minLen cannot be less than 0 (value: ${props.minLen}).`);
        if (props.maxLen && !core_1.Token.isUnresolved(props.maxLen) && props.maxLen > 2048)
          throw new Error(`maxLen cannot be greater than 2048 (value: ${props.maxLen}).`);
        this.minLen = props?.minLen, this.maxLen = props?.maxLen, this.mutable = props?.mutable;
      }
      bind() {
        let stringConstraints;
        return (this.minLen || this.maxLen) && (stringConstraints = { minLen: this.minLen, maxLen: this.maxLen }), { dataType: "String", stringConstraints, mutable: this.mutable };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, StringAttribute[_a] = { fqn: "aws-cdk-lib.aws_cognito.StringAttribute", version: "2.80.0" }, exports2.StringAttribute = StringAttribute;
    var NumberAttribute = class _NumberAttribute {
      constructor(props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_NumberAttributeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _NumberAttribute), error;
        }
        this.min = props?.min, this.max = props?.max, this.mutable = props?.mutable;
      }
      bind() {
        let numberConstraints;
        return (this.min || this.max) && (numberConstraints = { min: this.min, max: this.max }), { dataType: "Number", numberConstraints, mutable: this.mutable };
      }
    };
    _b = JSII_RTTI_SYMBOL_1, NumberAttribute[_b] = { fqn: "aws-cdk-lib.aws_cognito.NumberAttribute", version: "2.80.0" }, exports2.NumberAttribute = NumberAttribute;
    var BooleanAttribute = class _BooleanAttribute {
      constructor(props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_CustomAttributeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _BooleanAttribute), error;
        }
        this.mutable = props?.mutable;
      }
      bind() {
        return { dataType: "Boolean", mutable: this.mutable };
      }
    };
    _c = JSII_RTTI_SYMBOL_1, BooleanAttribute[_c] = { fqn: "aws-cdk-lib.aws_cognito.BooleanAttribute", version: "2.80.0" }, exports2.BooleanAttribute = BooleanAttribute;
    var DateTimeAttribute = class _DateTimeAttribute {
      constructor(props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_CustomAttributeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _DateTimeAttribute), error;
        }
        this.mutable = props?.mutable;
      }
      bind() {
        return { dataType: "DateTime", mutable: this.mutable };
      }
    };
    _d = JSII_RTTI_SYMBOL_1, DateTimeAttribute[_d] = { fqn: "aws-cdk-lib.aws_cognito.DateTimeAttribute", version: "2.80.0" }, exports2.DateTimeAttribute = DateTimeAttribute;
    var ClientAttributes = class _ClientAttributes {
      constructor() {
        this.attributesSet = /* @__PURE__ */ new Set();
      }
      withStandardAttributes(attributes) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_StandardAttributesMask(attributes);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.withStandardAttributes), error;
        }
        let attributesSet = new Set(this.attributesSet);
        for (const attributeKey in attr_names_1.StandardAttributeNames)
          if (attributes[attributeKey] === true) {
            const attributeName = attr_names_1.StandardAttributeNames[attributeKey];
            attributesSet.add(attributeName);
          }
        let aux = new _ClientAttributes();
        return aux.attributesSet = attributesSet, aux;
      }
      withCustomAttributes(...attributes) {
        let attributesSet = new Set(this.attributesSet);
        for (let attribute of attributes)
          attribute.startsWith("custom:") || (attribute = "custom:" + attribute), attributesSet.add(attribute);
        let aux = new _ClientAttributes();
        return aux.attributesSet = attributesSet, aux;
      }
      attributes() {
        return Array.from(this.attributesSet).sort();
      }
    };
    _e = JSII_RTTI_SYMBOL_1, ClientAttributes[_e] = { fqn: "aws-cdk-lib.aws_cognito.ClientAttributes", version: "2.80.0" }, exports2.ClientAttributes = ClientAttributes;
  }
});

// node_modules/aws-cdk-lib/aws-cognito/lib/user-pool-email.js
var require_user_pool_email = __commonJS({
  "node_modules/aws-cdk-lib/aws-cognito/lib/user-pool-email.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.UserPoolEmail = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var punycode_1 = require_punycode();
    var core_1 = require_core2();
    var UserPoolEmail = class {
      static withCognito(replyTo) {
        return new CognitoEmail(replyTo);
      }
      static withSES(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_UserPoolSESOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.withSES), error;
        }
        return new SESEmail(options);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, UserPoolEmail[_a] = { fqn: "aws-cdk-lib.aws_cognito.UserPoolEmail", version: "2.80.0" }, exports2.UserPoolEmail = UserPoolEmail;
    var CognitoEmail = class extends UserPoolEmail {
      constructor(replyTo) {
        super(), this.replyTo = replyTo;
      }
      _bind(_scope) {
        return { replyToEmailAddress: encodeAndTest(this.replyTo), emailSendingAccount: "COGNITO_DEFAULT" };
      }
    };
    var SESEmail = class extends UserPoolEmail {
      constructor(options) {
        super(), this.options = options;
      }
      _bind(scope) {
        const region = core_1.Stack.of(scope).region;
        if (core_1.Token.isUnresolved(region) && !this.options.sesRegion)
          throw new Error('Your stack region cannot be determined so "sesRegion" is required in SESOptions');
        let from = encodeAndTest(this.options.fromEmail);
        if (this.options.fromName && (from = `${formatFromName(this.options.fromName)} <${from}>`), this.options.sesVerifiedDomain && this.options.fromEmail.split("@").pop() !== this.options.sesVerifiedDomain)
          throw new Error('"fromEmail" contains a different domain than the "sesVerifiedDomain"');
        return { from, replyToEmailAddress: encodeAndTest(this.options.replyTo), configurationSet: this.options.configurationSetName, emailSendingAccount: "DEVELOPER", sourceArn: core_1.Stack.of(scope).formatArn({ service: "ses", resource: "identity", resourceName: encodeAndTest(this.options.sesVerifiedDomain ?? this.options.fromEmail), region: this.options.sesRegion ?? region }) };
      }
    };
    function encodeAndTest(input) {
      if (input) {
        const local = input.split("@")[0];
        if (!/[\p{ASCII}]+/u.test(local))
          throw new Error("the local part of the email address must use ASCII characters only");
        return (0, punycode_1.toASCII)(input);
      } else
        return;
    }
    function formatFromName(fromName) {
      return isAscii(fromName) ? isSimplePhrase(fromName) || isQuotedString(fromName) ? fromName : `"${fromName.replace(/[\\"]/g, (ch) => `\\${ch}`)}"` : `=?UTF-8?B?${Buffer.from(fromName, "utf-8").toString("base64")}?=`;
    }
    function isAscii(input) {
      return /^[\u0020-\u007E]+$/u.test(input);
    }
    function isSimplePhrase(input) {
      return /^[\w !#$%&'*+-\/=?^_`{|}~]+$/.test(input);
    }
    function isQuotedString(input) {
      return /^"(?:[^\\"]|\\.)*"$/.test(input);
    }
  }
});

// node_modules/aws-cdk-lib/aws-cognito/lib/user-pool-idp.js
var require_user_pool_idp = __commonJS({
  "node_modules/aws-cdk-lib/aws-cognito/lib/user-pool-idp.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.UserPoolIdentityProvider = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core_1 = require_core2();
    var UserPoolIdentityProvider = class {
      static fromProviderName(scope, id, providerName) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.providerName = providerName;
          }
        }
        return new Import(scope, id);
      }
      constructor() {
      }
    };
    _a = JSII_RTTI_SYMBOL_1, UserPoolIdentityProvider[_a] = { fqn: "aws-cdk-lib.aws_cognito.UserPoolIdentityProvider", version: "2.80.0" }, exports2.UserPoolIdentityProvider = UserPoolIdentityProvider;
  }
});

// node_modules/aws-cdk-lib/aws-cognito/lib/user-pool-idps/base.js
var require_base = __commonJS({
  "node_modules/aws-cdk-lib/aws-cognito/lib/user-pool-idps/base.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ProviderAttribute = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var ProviderAttribute = class _ProviderAttribute {
      static other(attributeName) {
        return new _ProviderAttribute(attributeName);
      }
      constructor(attributeName) {
        this.attributeName = attributeName;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ProviderAttribute[_a] = { fqn: "aws-cdk-lib.aws_cognito.ProviderAttribute", version: "2.80.0" }, ProviderAttribute.APPLE_EMAIL = new ProviderAttribute("email"), ProviderAttribute.APPLE_NAME = new ProviderAttribute("name"), ProviderAttribute.APPLE_FIRST_NAME = new ProviderAttribute("firstName"), ProviderAttribute.APPLE_LAST_NAME = new ProviderAttribute("lastName"), ProviderAttribute.AMAZON_USER_ID = new ProviderAttribute("user_id"), ProviderAttribute.AMAZON_EMAIL = new ProviderAttribute("email"), ProviderAttribute.AMAZON_NAME = new ProviderAttribute("name"), ProviderAttribute.AMAZON_POSTAL_CODE = new ProviderAttribute("postal_code"), ProviderAttribute.FACEBOOK_ID = new ProviderAttribute("id"), ProviderAttribute.FACEBOOK_BIRTHDAY = new ProviderAttribute("birthday"), ProviderAttribute.FACEBOOK_EMAIL = new ProviderAttribute("email"), ProviderAttribute.FACEBOOK_NAME = new ProviderAttribute("name"), ProviderAttribute.FACEBOOK_FIRST_NAME = new ProviderAttribute("first_name"), ProviderAttribute.FACEBOOK_LAST_NAME = new ProviderAttribute("last_name"), ProviderAttribute.FACEBOOK_MIDDLE_NAME = new ProviderAttribute("middle_name"), ProviderAttribute.FACEBOOK_GENDER = new ProviderAttribute("gender"), ProviderAttribute.FACEBOOK_LOCALE = new ProviderAttribute("locale"), ProviderAttribute.GOOGLE_NAMES = new ProviderAttribute("names"), ProviderAttribute.GOOGLE_GENDER = new ProviderAttribute("gender"), ProviderAttribute.GOOGLE_BIRTHDAYS = new ProviderAttribute("birthdays"), ProviderAttribute.GOOGLE_PHONE_NUMBERS = new ProviderAttribute("phoneNumbers"), ProviderAttribute.GOOGLE_EMAIL = new ProviderAttribute("email"), ProviderAttribute.GOOGLE_NAME = new ProviderAttribute("name"), ProviderAttribute.GOOGLE_PICTURE = new ProviderAttribute("picture"), ProviderAttribute.GOOGLE_GIVEN_NAME = new ProviderAttribute("given_name"), ProviderAttribute.GOOGLE_FAMILY_NAME = new ProviderAttribute("family_name"), exports2.ProviderAttribute = ProviderAttribute;
  }
});

// node_modules/aws-cdk-lib/aws-cognito/lib/user-pool-idps/private/user-pool-idp-base.js
var require_user_pool_idp_base = __commonJS({
  "node_modules/aws-cdk-lib/aws-cognito/lib/user-pool-idps/private/user-pool-idp-base.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.UserPoolIdentityProviderBase = void 0;
    var core_1 = require_core2();
    var attr_names_1 = require_attr_names();
    var UserPoolIdentityProviderBase = class extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id), this.props = props, props.userPool.registerIdentityProvider(this);
      }
      configureAttributeMapping() {
        if (!this.props.attributeMapping)
          return;
        let mapping = {};
        if (mapping = Object.entries(this.props.attributeMapping).filter(([k, _]) => k !== "custom").reduce((agg, [k, v]) => ({ ...agg, [attr_names_1.StandardAttributeNames[k]]: v.attributeName }), mapping), this.props.attributeMapping.custom && (mapping = Object.entries(this.props.attributeMapping.custom).reduce((agg, [k, v]) => ({ ...agg, [k]: v.attributeName }), mapping)), Object.keys(mapping).length !== 0)
          return mapping;
      }
    };
    exports2.UserPoolIdentityProviderBase = UserPoolIdentityProviderBase;
  }
});

// node_modules/aws-cdk-lib/aws-cognito/lib/user-pool-idps/apple.js
var require_apple = __commonJS({
  "node_modules/aws-cdk-lib/aws-cognito/lib/user-pool-idps/apple.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.UserPoolIdentityProviderApple = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var user_pool_idp_base_1 = require_user_pool_idp_base();
    var cognito_generated_1 = require_cognito_generated();
    var UserPoolIdentityProviderApple = class _UserPoolIdentityProviderApple extends user_pool_idp_base_1.UserPoolIdentityProviderBase {
      constructor(scope, id, props) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_UserPoolIdentityProviderAppleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _UserPoolIdentityProviderApple), error;
        }
        const scopes = props.scopes ?? ["name"], resource = new cognito_generated_1.CfnUserPoolIdentityProvider(this, "Resource", { userPoolId: props.userPool.userPoolId, providerName: "SignInWithApple", providerType: "SignInWithApple", providerDetails: { client_id: props.clientId, team_id: props.teamId, key_id: props.keyId, private_key: props.privateKey, authorize_scopes: scopes.join(" ") }, attributeMapping: super.configureAttributeMapping() });
        this.providerName = super.getResourceNameAttribute(resource.ref);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, UserPoolIdentityProviderApple[_a] = { fqn: "aws-cdk-lib.aws_cognito.UserPoolIdentityProviderApple", version: "2.80.0" }, exports2.UserPoolIdentityProviderApple = UserPoolIdentityProviderApple;
  }
});

// node_modules/aws-cdk-lib/aws-cognito/lib/user-pool-idps/amazon.js
var require_amazon = __commonJS({
  "node_modules/aws-cdk-lib/aws-cognito/lib/user-pool-idps/amazon.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.UserPoolIdentityProviderAmazon = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var user_pool_idp_base_1 = require_user_pool_idp_base();
    var cognito_generated_1 = require_cognito_generated();
    var UserPoolIdentityProviderAmazon = class _UserPoolIdentityProviderAmazon extends user_pool_idp_base_1.UserPoolIdentityProviderBase {
      constructor(scope, id, props) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_UserPoolIdentityProviderAmazonProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _UserPoolIdentityProviderAmazon), error;
        }
        const scopes = props.scopes ?? ["profile"], resource = new cognito_generated_1.CfnUserPoolIdentityProvider(this, "Resource", { userPoolId: props.userPool.userPoolId, providerName: "LoginWithAmazon", providerType: "LoginWithAmazon", providerDetails: { client_id: props.clientId, client_secret: props.clientSecret, authorize_scopes: scopes.join(" ") }, attributeMapping: super.configureAttributeMapping() });
        this.providerName = super.getResourceNameAttribute(resource.ref);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, UserPoolIdentityProviderAmazon[_a] = { fqn: "aws-cdk-lib.aws_cognito.UserPoolIdentityProviderAmazon", version: "2.80.0" }, exports2.UserPoolIdentityProviderAmazon = UserPoolIdentityProviderAmazon;
  }
});

// node_modules/aws-cdk-lib/aws-cognito/lib/user-pool-idps/facebook.js
var require_facebook = __commonJS({
  "node_modules/aws-cdk-lib/aws-cognito/lib/user-pool-idps/facebook.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.UserPoolIdentityProviderFacebook = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var user_pool_idp_base_1 = require_user_pool_idp_base();
    var cognito_generated_1 = require_cognito_generated();
    var UserPoolIdentityProviderFacebook = class _UserPoolIdentityProviderFacebook extends user_pool_idp_base_1.UserPoolIdentityProviderBase {
      constructor(scope, id, props) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_UserPoolIdentityProviderFacebookProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _UserPoolIdentityProviderFacebook), error;
        }
        const scopes = props.scopes ?? ["public_profile"], resource = new cognito_generated_1.CfnUserPoolIdentityProvider(this, "Resource", { userPoolId: props.userPool.userPoolId, providerName: "Facebook", providerType: "Facebook", providerDetails: { client_id: props.clientId, client_secret: props.clientSecret, authorize_scopes: scopes.join(","), api_version: props.apiVersion }, attributeMapping: super.configureAttributeMapping() });
        this.providerName = super.getResourceNameAttribute(resource.ref);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, UserPoolIdentityProviderFacebook[_a] = { fqn: "aws-cdk-lib.aws_cognito.UserPoolIdentityProviderFacebook", version: "2.80.0" }, exports2.UserPoolIdentityProviderFacebook = UserPoolIdentityProviderFacebook;
  }
});

// node_modules/aws-cdk-lib/aws-cognito/lib/user-pool-idps/google.js
var require_google = __commonJS({
  "node_modules/aws-cdk-lib/aws-cognito/lib/user-pool-idps/google.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.UserPoolIdentityProviderGoogle = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var user_pool_idp_base_1 = require_user_pool_idp_base();
    var cognito_generated_1 = require_cognito_generated();
    var UserPoolIdentityProviderGoogle = class _UserPoolIdentityProviderGoogle extends user_pool_idp_base_1.UserPoolIdentityProviderBase {
      constructor(scope, id, props) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_UserPoolIdentityProviderGoogleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _UserPoolIdentityProviderGoogle), error;
        }
        const scopes = props.scopes ?? ["profile"];
        if (!props.clientSecret && !props.clientSecretValue || props.clientSecret && props.clientSecretValue)
          throw new Error('Exactly one of "clientSecret" or "clientSecretValue" must be configured.');
        const resource = new cognito_generated_1.CfnUserPoolIdentityProvider(this, "Resource", { userPoolId: props.userPool.userPoolId, providerName: "Google", providerType: "Google", providerDetails: { client_id: props.clientId, client_secret: props.clientSecretValue ? props.clientSecretValue.unsafeUnwrap() : props.clientSecret, authorize_scopes: scopes.join(" ") }, attributeMapping: super.configureAttributeMapping() });
        this.providerName = super.getResourceNameAttribute(resource.ref);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, UserPoolIdentityProviderGoogle[_a] = { fqn: "aws-cdk-lib.aws_cognito.UserPoolIdentityProviderGoogle", version: "2.80.0" }, exports2.UserPoolIdentityProviderGoogle = UserPoolIdentityProviderGoogle;
  }
});

// node_modules/aws-cdk-lib/aws-cognito/lib/user-pool-idps/oidc.js
var require_oidc = __commonJS({
  "node_modules/aws-cdk-lib/aws-cognito/lib/user-pool-idps/oidc.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.UserPoolIdentityProviderOidc = exports2.OidcAttributeRequestMethod = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var user_pool_idp_base_1 = require_user_pool_idp_base();
    var core_1 = require_core2();
    var cognito_generated_1 = require_cognito_generated();
    var OidcAttributeRequestMethod;
    (function(OidcAttributeRequestMethod2) {
      OidcAttributeRequestMethod2.GET = "GET", OidcAttributeRequestMethod2.POST = "POST";
    })(OidcAttributeRequestMethod = exports2.OidcAttributeRequestMethod || (exports2.OidcAttributeRequestMethod = {}));
    var UserPoolIdentityProviderOidc = class _UserPoolIdentityProviderOidc extends user_pool_idp_base_1.UserPoolIdentityProviderBase {
      constructor(scope, id, props) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_UserPoolIdentityProviderOidcProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _UserPoolIdentityProviderOidc), error;
        }
        if (props.name && !core_1.Token.isUnresolved(props.name) && (props.name.length < 3 || props.name.length > 32))
          throw new Error(`Expected provider name to be between 3 and 32 characters, received ${props.name} (${props.name.length} characters)`);
        const scopes = props.scopes ?? ["openid"], resource = new cognito_generated_1.CfnUserPoolIdentityProvider(this, "Resource", { userPoolId: props.userPool.userPoolId, providerName: this.getProviderName(props.name), providerType: "OIDC", providerDetails: { client_id: props.clientId, client_secret: props.clientSecret, authorize_scopes: scopes.join(" "), attributes_request_method: props.attributeRequestMethod ?? OidcAttributeRequestMethod.GET, oidc_issuer: props.issuerUrl, authorize_url: props.endpoints?.authorization, token_url: props.endpoints?.token, attributes_url: props.endpoints?.userInfo, jwks_uri: props.endpoints?.jwksUri }, idpIdentifiers: props.identifiers, attributeMapping: super.configureAttributeMapping() });
        this.providerName = super.getResourceNameAttribute(resource.ref);
      }
      getProviderName(name) {
        if (name) {
          if (!core_1.Token.isUnresolved(name) && (name.length < 3 || name.length > 32))
            throw new Error(`Expected provider name to be between 3 and 32 characters, received ${name} (${name.length} characters)`);
          return name;
        }
        const uniqueId = core_1.Names.uniqueId(this);
        return uniqueId.length < 3 ? `${uniqueId}oidc` : uniqueId.length > 32 ? uniqueId.substring(0, 16) + uniqueId.substring(uniqueId.length - 16) : uniqueId;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, UserPoolIdentityProviderOidc[_a] = { fqn: "aws-cdk-lib.aws_cognito.UserPoolIdentityProviderOidc", version: "2.80.0" }, exports2.UserPoolIdentityProviderOidc = UserPoolIdentityProviderOidc;
  }
});

// node_modules/aws-cdk-lib/aws-cognito/lib/user-pool-idps/saml.js
var require_saml = __commonJS({
  "node_modules/aws-cdk-lib/aws-cognito/lib/user-pool-idps/saml.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.UserPoolIdentityProviderSaml = exports2.UserPoolIdentityProviderSamlMetadata = exports2.UserPoolIdentityProviderSamlMetadataType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var user_pool_idp_base_1 = require_user_pool_idp_base();
    var core_1 = require_core2();
    var cognito_generated_1 = require_cognito_generated();
    var UserPoolIdentityProviderSamlMetadataType;
    (function(UserPoolIdentityProviderSamlMetadataType2) {
      UserPoolIdentityProviderSamlMetadataType2.URL = "url", UserPoolIdentityProviderSamlMetadataType2.FILE = "file";
    })(UserPoolIdentityProviderSamlMetadataType = exports2.UserPoolIdentityProviderSamlMetadataType || (exports2.UserPoolIdentityProviderSamlMetadataType = {}));
    var UserPoolIdentityProviderSamlMetadata = class _UserPoolIdentityProviderSamlMetadata {
      static url(url) {
        return new _UserPoolIdentityProviderSamlMetadata(url, UserPoolIdentityProviderSamlMetadataType.URL);
      }
      static file(fileContent) {
        return new _UserPoolIdentityProviderSamlMetadata(fileContent, UserPoolIdentityProviderSamlMetadataType.FILE);
      }
      constructor(metadataContent, metadataType) {
        this.metadataContent = metadataContent, this.metadataType = metadataType;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, UserPoolIdentityProviderSamlMetadata[_a] = { fqn: "aws-cdk-lib.aws_cognito.UserPoolIdentityProviderSamlMetadata", version: "2.80.0" }, exports2.UserPoolIdentityProviderSamlMetadata = UserPoolIdentityProviderSamlMetadata;
    var UserPoolIdentityProviderSaml = class _UserPoolIdentityProviderSaml extends user_pool_idp_base_1.UserPoolIdentityProviderBase {
      constructor(scope, id, props) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_UserPoolIdentityProviderSamlProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _UserPoolIdentityProviderSaml), error;
        }
        this.validateName(props.name);
        const { metadataType, metadataContent } = props.metadata, resource = new cognito_generated_1.CfnUserPoolIdentityProvider(this, "Resource", { userPoolId: props.userPool.userPoolId, providerName: this.getProviderName(props.name), providerType: "SAML", providerDetails: { IDPSignout: props.idpSignout ?? false, MetadataURL: metadataType === UserPoolIdentityProviderSamlMetadataType.URL ? metadataContent : void 0, MetadataFile: metadataType === UserPoolIdentityProviderSamlMetadataType.FILE ? metadataContent : void 0 }, idpIdentifiers: props.identifiers, attributeMapping: super.configureAttributeMapping() });
        this.providerName = super.getResourceNameAttribute(resource.ref);
      }
      getProviderName(name) {
        if (name)
          return this.validateName(name), name;
        const uniqueName = core_1.Names.uniqueResourceName(this, { maxLength: 32 });
        return uniqueName.length < 3 ? `${uniqueName}saml` : uniqueName;
      }
      validateName(name) {
        if (name && !core_1.Token.isUnresolved(name) && (name.length < 3 || name.length > 32))
          throw new Error(`Expected provider name to be between 3 and 32 characters, received ${name} (${name.length} characters)`);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, UserPoolIdentityProviderSaml[_b] = { fqn: "aws-cdk-lib.aws_cognito.UserPoolIdentityProviderSaml", version: "2.80.0" }, exports2.UserPoolIdentityProviderSaml = UserPoolIdentityProviderSaml;
  }
});

// node_modules/aws-cdk-lib/aws-cognito/lib/user-pool-idps/index.js
var require_user_pool_idps = __commonJS({
  "node_modules/aws-cdk-lib/aws-cognito/lib/user-pool-idps/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_base(), exports2), __exportStar(require_apple(), exports2), __exportStar(require_amazon(), exports2), __exportStar(require_facebook(), exports2), __exportStar(require_google(), exports2), __exportStar(require_oidc(), exports2), __exportStar(require_saml(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-cognito/lib/index.js
var require_lib88 = __commonJS({
  "node_modules/aws-cdk-lib/aws-cognito/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_cognito_generated(), exports2), __exportStar(require_user_pool(), exports2), __exportStar(require_user_pool_attr(), exports2), __exportStar(require_user_pool_client(), exports2), __exportStar(require_user_pool_domain(), exports2), __exportStar(require_user_pool_email(), exports2), __exportStar(require_user_pool_idp(), exports2), __exportStar(require_user_pool_idps(), exports2), __exportStar(require_user_pool_resource_server(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-cognito/index.js
var require_aws_cognito = __commonJS({
  "node_modules/aws-cdk-lib/aws-cognito/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib88(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-comprehend/lib/comprehend.generated.js
var require_comprehend_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-comprehend/lib/comprehend.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnFlywheel = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnFlywheelPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("activeModelArn", cdk.validateString)(properties.activeModelArn)), errors.collect(cdk.propertyValidator("dataAccessRoleArn", cdk.requiredValidator)(properties.dataAccessRoleArn)), errors.collect(cdk.propertyValidator("dataAccessRoleArn", cdk.validateString)(properties.dataAccessRoleArn)), errors.collect(cdk.propertyValidator("dataLakeS3Uri", cdk.requiredValidator)(properties.dataLakeS3Uri)), errors.collect(cdk.propertyValidator("dataLakeS3Uri", cdk.validateString)(properties.dataLakeS3Uri)), errors.collect(cdk.propertyValidator("dataSecurityConfig", CfnFlywheel_DataSecurityConfigPropertyValidator)(properties.dataSecurityConfig)), errors.collect(cdk.propertyValidator("flywheelName", cdk.requiredValidator)(properties.flywheelName)), errors.collect(cdk.propertyValidator("flywheelName", cdk.validateString)(properties.flywheelName)), errors.collect(cdk.propertyValidator("modelType", cdk.validateString)(properties.modelType)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("taskConfig", CfnFlywheel_TaskConfigPropertyValidator)(properties.taskConfig)), errors.wrap('supplied properties not correct for "CfnFlywheelProps"');
    }
    function cfnFlywheelPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlywheelPropsValidator(properties).assertSuccess(), { DataAccessRoleArn: cdk.stringToCloudFormation(properties.dataAccessRoleArn), DataLakeS3Uri: cdk.stringToCloudFormation(properties.dataLakeS3Uri), FlywheelName: cdk.stringToCloudFormation(properties.flywheelName), ActiveModelArn: cdk.stringToCloudFormation(properties.activeModelArn), DataSecurityConfig: cfnFlywheelDataSecurityConfigPropertyToCloudFormation(properties.dataSecurityConfig), ModelType: cdk.stringToCloudFormation(properties.modelType), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TaskConfig: cfnFlywheelTaskConfigPropertyToCloudFormation(properties.taskConfig) }) : properties;
    }
    function CfnFlywheelPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataAccessRoleArn", "DataAccessRoleArn", cfn_parse.FromCloudFormation.getString(properties.DataAccessRoleArn)), ret.addPropertyResult("dataLakeS3Uri", "DataLakeS3Uri", cfn_parse.FromCloudFormation.getString(properties.DataLakeS3Uri)), ret.addPropertyResult("flywheelName", "FlywheelName", cfn_parse.FromCloudFormation.getString(properties.FlywheelName)), ret.addPropertyResult("activeModelArn", "ActiveModelArn", properties.ActiveModelArn != null ? cfn_parse.FromCloudFormation.getString(properties.ActiveModelArn) : void 0), ret.addPropertyResult("dataSecurityConfig", "DataSecurityConfig", properties.DataSecurityConfig != null ? CfnFlywheelDataSecurityConfigPropertyFromCloudFormation(properties.DataSecurityConfig) : void 0), ret.addPropertyResult("modelType", "ModelType", properties.ModelType != null ? cfn_parse.FromCloudFormation.getString(properties.ModelType) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("taskConfig", "TaskConfig", properties.TaskConfig != null ? CfnFlywheelTaskConfigPropertyFromCloudFormation(properties.TaskConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFlywheel = class _CfnFlywheel extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFlywheelPropsFromCloudFormation(resourceProperties), ret = new _CfnFlywheel(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFlywheel.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_comprehend_CfnFlywheelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFlywheel), error;
        }
        cdk.requireProperty(props, "dataAccessRoleArn", this), cdk.requireProperty(props, "dataLakeS3Uri", this), cdk.requireProperty(props, "flywheelName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.dataAccessRoleArn = props.dataAccessRoleArn, this.dataLakeS3Uri = props.dataLakeS3Uri, this.flywheelName = props.flywheelName, this.activeModelArn = props.activeModelArn, this.dataSecurityConfig = props.dataSecurityConfig, this.modelType = props.modelType, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Comprehend::Flywheel", props.tags, { tagPropertyName: "tags" }), this.taskConfig = props.taskConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFlywheel.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { dataAccessRoleArn: this.dataAccessRoleArn, dataLakeS3Uri: this.dataLakeS3Uri, flywheelName: this.flywheelName, activeModelArn: this.activeModelArn, dataSecurityConfig: this.dataSecurityConfig, modelType: this.modelType, tags: this.tags.renderTags(), taskConfig: this.taskConfig };
      }
      renderProperties(props) {
        return cfnFlywheelPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnFlywheel[_a] = { fqn: "aws-cdk-lib.aws_comprehend.CfnFlywheel", version: "2.80.0" }, CfnFlywheel.CFN_RESOURCE_TYPE_NAME = "AWS::Comprehend::Flywheel", exports2.CfnFlywheel = CfnFlywheel;
    function CfnFlywheel_DataSecurityConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataLakeKmsKeyId", cdk.validateString)(properties.dataLakeKmsKeyId)), errors.collect(cdk.propertyValidator("modelKmsKeyId", cdk.validateString)(properties.modelKmsKeyId)), errors.collect(cdk.propertyValidator("volumeKmsKeyId", cdk.validateString)(properties.volumeKmsKeyId)), errors.collect(cdk.propertyValidator("vpcConfig", CfnFlywheel_VpcConfigPropertyValidator)(properties.vpcConfig)), errors.wrap('supplied properties not correct for "DataSecurityConfigProperty"');
    }
    function cfnFlywheelDataSecurityConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlywheel_DataSecurityConfigPropertyValidator(properties).assertSuccess(), { DataLakeKmsKeyId: cdk.stringToCloudFormation(properties.dataLakeKmsKeyId), ModelKmsKeyId: cdk.stringToCloudFormation(properties.modelKmsKeyId), VolumeKmsKeyId: cdk.stringToCloudFormation(properties.volumeKmsKeyId), VpcConfig: cfnFlywheelVpcConfigPropertyToCloudFormation(properties.vpcConfig) }) : properties;
    }
    function CfnFlywheelDataSecurityConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataLakeKmsKeyId", "DataLakeKmsKeyId", properties.DataLakeKmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.DataLakeKmsKeyId) : void 0), ret.addPropertyResult("modelKmsKeyId", "ModelKmsKeyId", properties.ModelKmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.ModelKmsKeyId) : void 0), ret.addPropertyResult("volumeKmsKeyId", "VolumeKmsKeyId", properties.VolumeKmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.VolumeKmsKeyId) : void 0), ret.addPropertyResult("vpcConfig", "VpcConfig", properties.VpcConfig != null ? CfnFlywheelVpcConfigPropertyFromCloudFormation(properties.VpcConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlywheel_DocumentClassificationConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("labels", cdk.listValidator(cdk.validateString))(properties.labels)), errors.collect(cdk.propertyValidator("mode", cdk.requiredValidator)(properties.mode)), errors.collect(cdk.propertyValidator("mode", cdk.validateString)(properties.mode)), errors.wrap('supplied properties not correct for "DocumentClassificationConfigProperty"');
    }
    function cfnFlywheelDocumentClassificationConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlywheel_DocumentClassificationConfigPropertyValidator(properties).assertSuccess(), { Labels: cdk.listMapper(cdk.stringToCloudFormation)(properties.labels), Mode: cdk.stringToCloudFormation(properties.mode) }) : properties;
    }
    function CfnFlywheelDocumentClassificationConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("labels", "Labels", properties.Labels != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Labels) : void 0), ret.addPropertyResult("mode", "Mode", cfn_parse.FromCloudFormation.getString(properties.Mode)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlywheel_EntityRecognitionConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("entityTypes", cdk.listValidator(CfnFlywheel_EntityTypesListItemPropertyValidator))(properties.entityTypes)), errors.wrap('supplied properties not correct for "EntityRecognitionConfigProperty"');
    }
    function cfnFlywheelEntityRecognitionConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlywheel_EntityRecognitionConfigPropertyValidator(properties).assertSuccess(), { EntityTypes: cdk.listMapper(cfnFlywheelEntityTypesListItemPropertyToCloudFormation)(properties.entityTypes) }) : properties;
    }
    function CfnFlywheelEntityRecognitionConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("entityTypes", "EntityTypes", properties.EntityTypes != null ? cfn_parse.FromCloudFormation.getArray(CfnFlywheelEntityTypesListItemPropertyFromCloudFormation)(properties.EntityTypes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlywheel_EntityTypesListItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "EntityTypesListItemProperty"');
    }
    function cfnFlywheelEntityTypesListItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlywheel_EntityTypesListItemPropertyValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnFlywheelEntityTypesListItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlywheel_TaskConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("documentClassificationConfig", CfnFlywheel_DocumentClassificationConfigPropertyValidator)(properties.documentClassificationConfig)), errors.collect(cdk.propertyValidator("entityRecognitionConfig", CfnFlywheel_EntityRecognitionConfigPropertyValidator)(properties.entityRecognitionConfig)), errors.collect(cdk.propertyValidator("languageCode", cdk.requiredValidator)(properties.languageCode)), errors.collect(cdk.propertyValidator("languageCode", cdk.validateString)(properties.languageCode)), errors.wrap('supplied properties not correct for "TaskConfigProperty"');
    }
    function cfnFlywheelTaskConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlywheel_TaskConfigPropertyValidator(properties).assertSuccess(), { DocumentClassificationConfig: cfnFlywheelDocumentClassificationConfigPropertyToCloudFormation(properties.documentClassificationConfig), EntityRecognitionConfig: cfnFlywheelEntityRecognitionConfigPropertyToCloudFormation(properties.entityRecognitionConfig), LanguageCode: cdk.stringToCloudFormation(properties.languageCode) }) : properties;
    }
    function CfnFlywheelTaskConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("documentClassificationConfig", "DocumentClassificationConfig", properties.DocumentClassificationConfig != null ? CfnFlywheelDocumentClassificationConfigPropertyFromCloudFormation(properties.DocumentClassificationConfig) : void 0), ret.addPropertyResult("entityRecognitionConfig", "EntityRecognitionConfig", properties.EntityRecognitionConfig != null ? CfnFlywheelEntityRecognitionConfigPropertyFromCloudFormation(properties.EntityRecognitionConfig) : void 0), ret.addPropertyResult("languageCode", "LanguageCode", cfn_parse.FromCloudFormation.getString(properties.LanguageCode)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlywheel_VpcConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.requiredValidator)(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnets", cdk.requiredValidator)(properties.subnets)), errors.collect(cdk.propertyValidator("subnets", cdk.listValidator(cdk.validateString))(properties.subnets)), errors.wrap('supplied properties not correct for "VpcConfigProperty"');
    }
    function cfnFlywheelVpcConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlywheel_VpcConfigPropertyValidator(properties).assertSuccess(), { SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), Subnets: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnets) }) : properties;
    }
    function CfnFlywheelVpcConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds)), ret.addPropertyResult("subnets", "Subnets", cfn_parse.FromCloudFormation.getStringArray(properties.Subnets)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-comprehend/lib/index.js
var require_lib89 = __commonJS({
  "node_modules/aws-cdk-lib/aws-comprehend/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_comprehend_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-comprehend/index.js
var require_aws_comprehend = __commonJS({
  "node_modules/aws-cdk-lib/aws-comprehend/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib89(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-config/lib/config.generated.js
var require_config_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-config/lib/config.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnStoredQuery = exports2.CfnRemediationConfiguration = exports2.CfnOrganizationConformancePack = exports2.CfnOrganizationConfigRule = exports2.CfnDeliveryChannel = exports2.CfnConformancePack = exports2.CfnConfigurationRecorder = exports2.CfnConfigurationAggregator = exports2.CfnConfigRule = exports2.CfnAggregationAuthorization = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAggregationAuthorizationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authorizedAccountId", cdk.requiredValidator)(properties.authorizedAccountId)), errors.collect(cdk.propertyValidator("authorizedAccountId", cdk.validateString)(properties.authorizedAccountId)), errors.collect(cdk.propertyValidator("authorizedAwsRegion", cdk.requiredValidator)(properties.authorizedAwsRegion)), errors.collect(cdk.propertyValidator("authorizedAwsRegion", cdk.validateString)(properties.authorizedAwsRegion)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnAggregationAuthorizationProps"');
    }
    function cfnAggregationAuthorizationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAggregationAuthorizationPropsValidator(properties).assertSuccess(), { AuthorizedAccountId: cdk.stringToCloudFormation(properties.authorizedAccountId), AuthorizedAwsRegion: cdk.stringToCloudFormation(properties.authorizedAwsRegion), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnAggregationAuthorizationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authorizedAccountId", "AuthorizedAccountId", cfn_parse.FromCloudFormation.getString(properties.AuthorizedAccountId)), ret.addPropertyResult("authorizedAwsRegion", "AuthorizedAwsRegion", cfn_parse.FromCloudFormation.getString(properties.AuthorizedAwsRegion)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAggregationAuthorization = class _CfnAggregationAuthorization extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAggregationAuthorizationPropsFromCloudFormation(resourceProperties), ret = new _CfnAggregationAuthorization(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAggregationAuthorization.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_config_CfnAggregationAuthorizationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAggregationAuthorization), error;
        }
        cdk.requireProperty(props, "authorizedAccountId", this), cdk.requireProperty(props, "authorizedAwsRegion", this), this.attrAggregationAuthorizationArn = cdk.Token.asString(this.getAtt("AggregationAuthorizationArn", cdk.ResolutionTypeHint.STRING)), this.authorizedAccountId = props.authorizedAccountId, this.authorizedAwsRegion = props.authorizedAwsRegion, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Config::AggregationAuthorization", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAggregationAuthorization.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { authorizedAccountId: this.authorizedAccountId, authorizedAwsRegion: this.authorizedAwsRegion, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnAggregationAuthorizationPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAggregationAuthorization[_a] = { fqn: "aws-cdk-lib.aws_config.CfnAggregationAuthorization", version: "2.80.0" }, CfnAggregationAuthorization.CFN_RESOURCE_TYPE_NAME = "AWS::Config::AggregationAuthorization", exports2.CfnAggregationAuthorization = CfnAggregationAuthorization;
    function CfnConfigRulePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configRuleName", cdk.validateString)(properties.configRuleName)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("inputParameters", cdk.validateObject)(properties.inputParameters)), errors.collect(cdk.propertyValidator("maximumExecutionFrequency", cdk.validateString)(properties.maximumExecutionFrequency)), errors.collect(cdk.propertyValidator("scope", CfnConfigRule_ScopePropertyValidator)(properties.scope)), errors.collect(cdk.propertyValidator("source", cdk.requiredValidator)(properties.source)), errors.collect(cdk.propertyValidator("source", CfnConfigRule_SourcePropertyValidator)(properties.source)), errors.wrap('supplied properties not correct for "CfnConfigRuleProps"');
    }
    function cfnConfigRulePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigRulePropsValidator(properties).assertSuccess(), { Source: cfnConfigRuleSourcePropertyToCloudFormation(properties.source), ConfigRuleName: cdk.stringToCloudFormation(properties.configRuleName), Description: cdk.stringToCloudFormation(properties.description), InputParameters: cdk.objectToCloudFormation(properties.inputParameters), MaximumExecutionFrequency: cdk.stringToCloudFormation(properties.maximumExecutionFrequency), Scope: cfnConfigRuleScopePropertyToCloudFormation(properties.scope) }) : properties;
    }
    function CfnConfigRulePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("source", "Source", CfnConfigRuleSourcePropertyFromCloudFormation(properties.Source)), ret.addPropertyResult("configRuleName", "ConfigRuleName", properties.ConfigRuleName != null ? cfn_parse.FromCloudFormation.getString(properties.ConfigRuleName) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("inputParameters", "InputParameters", properties.InputParameters != null ? cfn_parse.FromCloudFormation.getAny(properties.InputParameters) : void 0), ret.addPropertyResult("maximumExecutionFrequency", "MaximumExecutionFrequency", properties.MaximumExecutionFrequency != null ? cfn_parse.FromCloudFormation.getString(properties.MaximumExecutionFrequency) : void 0), ret.addPropertyResult("scope", "Scope", properties.Scope != null ? CfnConfigRuleScopePropertyFromCloudFormation(properties.Scope) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnConfigRule = class _CfnConfigRule extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnConfigRulePropsFromCloudFormation(resourceProperties), ret = new _CfnConfigRule(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnConfigRule.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_config_CfnConfigRuleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnConfigRule), error;
        }
        cdk.requireProperty(props, "source", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrComplianceType = cdk.Token.asString(this.getAtt("Compliance.Type", cdk.ResolutionTypeHint.STRING)), this.attrConfigRuleId = cdk.Token.asString(this.getAtt("ConfigRuleId", cdk.ResolutionTypeHint.STRING)), this.source = props.source, this.configRuleName = props.configRuleName, this.description = props.description, this.inputParameters = props.inputParameters, this.maximumExecutionFrequency = props.maximumExecutionFrequency, this.scope = props.scope;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnConfigRule.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { source: this.source, configRuleName: this.configRuleName, description: this.description, inputParameters: this.inputParameters, maximumExecutionFrequency: this.maximumExecutionFrequency, scope: this.scope };
      }
      renderProperties(props) {
        return cfnConfigRulePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnConfigRule[_b] = { fqn: "aws-cdk-lib.aws_config.CfnConfigRule", version: "2.80.0" }, CfnConfigRule.CFN_RESOURCE_TYPE_NAME = "AWS::Config::ConfigRule", exports2.CfnConfigRule = CfnConfigRule;
    function CfnConfigRule_CustomPolicyDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enableDebugLogDelivery", cdk.validateBoolean)(properties.enableDebugLogDelivery)), errors.collect(cdk.propertyValidator("policyRuntime", cdk.validateString)(properties.policyRuntime)), errors.collect(cdk.propertyValidator("policyText", cdk.validateString)(properties.policyText)), errors.wrap('supplied properties not correct for "CustomPolicyDetailsProperty"');
    }
    function cfnConfigRuleCustomPolicyDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigRule_CustomPolicyDetailsPropertyValidator(properties).assertSuccess(), { EnableDebugLogDelivery: cdk.booleanToCloudFormation(properties.enableDebugLogDelivery), PolicyRuntime: cdk.stringToCloudFormation(properties.policyRuntime), PolicyText: cdk.stringToCloudFormation(properties.policyText) }) : properties;
    }
    function CfnConfigRuleCustomPolicyDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enableDebugLogDelivery", "EnableDebugLogDelivery", properties.EnableDebugLogDelivery != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableDebugLogDelivery) : void 0), ret.addPropertyResult("policyRuntime", "PolicyRuntime", properties.PolicyRuntime != null ? cfn_parse.FromCloudFormation.getString(properties.PolicyRuntime) : void 0), ret.addPropertyResult("policyText", "PolicyText", properties.PolicyText != null ? cfn_parse.FromCloudFormation.getString(properties.PolicyText) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigRule_ScopePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("complianceResourceId", cdk.validateString)(properties.complianceResourceId)), errors.collect(cdk.propertyValidator("complianceResourceTypes", cdk.listValidator(cdk.validateString))(properties.complianceResourceTypes)), errors.collect(cdk.propertyValidator("tagKey", cdk.validateString)(properties.tagKey)), errors.collect(cdk.propertyValidator("tagValue", cdk.validateString)(properties.tagValue)), errors.wrap('supplied properties not correct for "ScopeProperty"');
    }
    function cfnConfigRuleScopePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigRule_ScopePropertyValidator(properties).assertSuccess(), { ComplianceResourceId: cdk.stringToCloudFormation(properties.complianceResourceId), ComplianceResourceTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.complianceResourceTypes), TagKey: cdk.stringToCloudFormation(properties.tagKey), TagValue: cdk.stringToCloudFormation(properties.tagValue) }) : properties;
    }
    function CfnConfigRuleScopePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("complianceResourceId", "ComplianceResourceId", properties.ComplianceResourceId != null ? cfn_parse.FromCloudFormation.getString(properties.ComplianceResourceId) : void 0), ret.addPropertyResult("complianceResourceTypes", "ComplianceResourceTypes", properties.ComplianceResourceTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ComplianceResourceTypes) : void 0), ret.addPropertyResult("tagKey", "TagKey", properties.TagKey != null ? cfn_parse.FromCloudFormation.getString(properties.TagKey) : void 0), ret.addPropertyResult("tagValue", "TagValue", properties.TagValue != null ? cfn_parse.FromCloudFormation.getString(properties.TagValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigRule_SourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customPolicyDetails", CfnConfigRule_CustomPolicyDetailsPropertyValidator)(properties.customPolicyDetails)), errors.collect(cdk.propertyValidator("owner", cdk.requiredValidator)(properties.owner)), errors.collect(cdk.propertyValidator("owner", cdk.validateString)(properties.owner)), errors.collect(cdk.propertyValidator("sourceDetails", cdk.listValidator(CfnConfigRule_SourceDetailPropertyValidator))(properties.sourceDetails)), errors.collect(cdk.propertyValidator("sourceIdentifier", cdk.validateString)(properties.sourceIdentifier)), errors.wrap('supplied properties not correct for "SourceProperty"');
    }
    function cfnConfigRuleSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigRule_SourcePropertyValidator(properties).assertSuccess(), { CustomPolicyDetails: cfnConfigRuleCustomPolicyDetailsPropertyToCloudFormation(properties.customPolicyDetails), Owner: cdk.stringToCloudFormation(properties.owner), SourceDetails: cdk.listMapper(cfnConfigRuleSourceDetailPropertyToCloudFormation)(properties.sourceDetails), SourceIdentifier: cdk.stringToCloudFormation(properties.sourceIdentifier) }) : properties;
    }
    function CfnConfigRuleSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customPolicyDetails", "CustomPolicyDetails", properties.CustomPolicyDetails != null ? CfnConfigRuleCustomPolicyDetailsPropertyFromCloudFormation(properties.CustomPolicyDetails) : void 0), ret.addPropertyResult("owner", "Owner", cfn_parse.FromCloudFormation.getString(properties.Owner)), ret.addPropertyResult("sourceDetails", "SourceDetails", properties.SourceDetails != null ? cfn_parse.FromCloudFormation.getArray(CfnConfigRuleSourceDetailPropertyFromCloudFormation)(properties.SourceDetails) : void 0), ret.addPropertyResult("sourceIdentifier", "SourceIdentifier", properties.SourceIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.SourceIdentifier) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigRule_SourceDetailPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("eventSource", cdk.requiredValidator)(properties.eventSource)), errors.collect(cdk.propertyValidator("eventSource", cdk.validateString)(properties.eventSource)), errors.collect(cdk.propertyValidator("maximumExecutionFrequency", cdk.validateString)(properties.maximumExecutionFrequency)), errors.collect(cdk.propertyValidator("messageType", cdk.requiredValidator)(properties.messageType)), errors.collect(cdk.propertyValidator("messageType", cdk.validateString)(properties.messageType)), errors.wrap('supplied properties not correct for "SourceDetailProperty"');
    }
    function cfnConfigRuleSourceDetailPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigRule_SourceDetailPropertyValidator(properties).assertSuccess(), { EventSource: cdk.stringToCloudFormation(properties.eventSource), MaximumExecutionFrequency: cdk.stringToCloudFormation(properties.maximumExecutionFrequency), MessageType: cdk.stringToCloudFormation(properties.messageType) }) : properties;
    }
    function CfnConfigRuleSourceDetailPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("eventSource", "EventSource", cfn_parse.FromCloudFormation.getString(properties.EventSource)), ret.addPropertyResult("maximumExecutionFrequency", "MaximumExecutionFrequency", properties.MaximumExecutionFrequency != null ? cfn_parse.FromCloudFormation.getString(properties.MaximumExecutionFrequency) : void 0), ret.addPropertyResult("messageType", "MessageType", cfn_parse.FromCloudFormation.getString(properties.MessageType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigurationAggregatorPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accountAggregationSources", cdk.listValidator(CfnConfigurationAggregator_AccountAggregationSourcePropertyValidator))(properties.accountAggregationSources)), errors.collect(cdk.propertyValidator("configurationAggregatorName", cdk.validateString)(properties.configurationAggregatorName)), errors.collect(cdk.propertyValidator("organizationAggregationSource", CfnConfigurationAggregator_OrganizationAggregationSourcePropertyValidator)(properties.organizationAggregationSource)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnConfigurationAggregatorProps"');
    }
    function cfnConfigurationAggregatorPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationAggregatorPropsValidator(properties).assertSuccess(), { AccountAggregationSources: cdk.listMapper(cfnConfigurationAggregatorAccountAggregationSourcePropertyToCloudFormation)(properties.accountAggregationSources), ConfigurationAggregatorName: cdk.stringToCloudFormation(properties.configurationAggregatorName), OrganizationAggregationSource: cfnConfigurationAggregatorOrganizationAggregationSourcePropertyToCloudFormation(properties.organizationAggregationSource), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnConfigurationAggregatorPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accountAggregationSources", "AccountAggregationSources", properties.AccountAggregationSources != null ? cfn_parse.FromCloudFormation.getArray(CfnConfigurationAggregatorAccountAggregationSourcePropertyFromCloudFormation)(properties.AccountAggregationSources) : void 0), ret.addPropertyResult("configurationAggregatorName", "ConfigurationAggregatorName", properties.ConfigurationAggregatorName != null ? cfn_parse.FromCloudFormation.getString(properties.ConfigurationAggregatorName) : void 0), ret.addPropertyResult("organizationAggregationSource", "OrganizationAggregationSource", properties.OrganizationAggregationSource != null ? CfnConfigurationAggregatorOrganizationAggregationSourcePropertyFromCloudFormation(properties.OrganizationAggregationSource) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnConfigurationAggregator = class _CfnConfigurationAggregator extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnConfigurationAggregatorPropsFromCloudFormation(resourceProperties), ret = new _CfnConfigurationAggregator(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnConfigurationAggregator.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_config_CfnConfigurationAggregatorProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnConfigurationAggregator), error;
        }
        this.attrConfigurationAggregatorArn = cdk.Token.asString(this.getAtt("ConfigurationAggregatorArn", cdk.ResolutionTypeHint.STRING)), this.accountAggregationSources = props.accountAggregationSources, this.configurationAggregatorName = props.configurationAggregatorName, this.organizationAggregationSource = props.organizationAggregationSource, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Config::ConfigurationAggregator", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnConfigurationAggregator.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { accountAggregationSources: this.accountAggregationSources, configurationAggregatorName: this.configurationAggregatorName, organizationAggregationSource: this.organizationAggregationSource, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnConfigurationAggregatorPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnConfigurationAggregator[_c] = { fqn: "aws-cdk-lib.aws_config.CfnConfigurationAggregator", version: "2.80.0" }, CfnConfigurationAggregator.CFN_RESOURCE_TYPE_NAME = "AWS::Config::ConfigurationAggregator", exports2.CfnConfigurationAggregator = CfnConfigurationAggregator;
    function CfnConfigurationAggregator_AccountAggregationSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accountIds", cdk.requiredValidator)(properties.accountIds)), errors.collect(cdk.propertyValidator("accountIds", cdk.listValidator(cdk.validateString))(properties.accountIds)), errors.collect(cdk.propertyValidator("allAwsRegions", cdk.validateBoolean)(properties.allAwsRegions)), errors.collect(cdk.propertyValidator("awsRegions", cdk.listValidator(cdk.validateString))(properties.awsRegions)), errors.wrap('supplied properties not correct for "AccountAggregationSourceProperty"');
    }
    function cfnConfigurationAggregatorAccountAggregationSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationAggregator_AccountAggregationSourcePropertyValidator(properties).assertSuccess(), { AccountIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.accountIds), AllAwsRegions: cdk.booleanToCloudFormation(properties.allAwsRegions), AwsRegions: cdk.listMapper(cdk.stringToCloudFormation)(properties.awsRegions) }) : properties;
    }
    function CfnConfigurationAggregatorAccountAggregationSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accountIds", "AccountIds", cfn_parse.FromCloudFormation.getStringArray(properties.AccountIds)), ret.addPropertyResult("allAwsRegions", "AllAwsRegions", properties.AllAwsRegions != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllAwsRegions) : void 0), ret.addPropertyResult("awsRegions", "AwsRegions", properties.AwsRegions != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AwsRegions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigurationAggregator_OrganizationAggregationSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allAwsRegions", cdk.validateBoolean)(properties.allAwsRegions)), errors.collect(cdk.propertyValidator("awsRegions", cdk.listValidator(cdk.validateString))(properties.awsRegions)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "OrganizationAggregationSourceProperty"');
    }
    function cfnConfigurationAggregatorOrganizationAggregationSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationAggregator_OrganizationAggregationSourcePropertyValidator(properties).assertSuccess(), { AllAwsRegions: cdk.booleanToCloudFormation(properties.allAwsRegions), AwsRegions: cdk.listMapper(cdk.stringToCloudFormation)(properties.awsRegions), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnConfigurationAggregatorOrganizationAggregationSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allAwsRegions", "AllAwsRegions", properties.AllAwsRegions != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllAwsRegions) : void 0), ret.addPropertyResult("awsRegions", "AwsRegions", properties.AwsRegions != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AwsRegions) : void 0), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigurationRecorderPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("recordingGroup", CfnConfigurationRecorder_RecordingGroupPropertyValidator)(properties.recordingGroup)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "CfnConfigurationRecorderProps"');
    }
    function cfnConfigurationRecorderPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationRecorderPropsValidator(properties).assertSuccess(), { RoleARN: cdk.stringToCloudFormation(properties.roleArn), Name: cdk.stringToCloudFormation(properties.name), RecordingGroup: cfnConfigurationRecorderRecordingGroupPropertyToCloudFormation(properties.recordingGroup) }) : properties;
    }
    function CfnConfigurationRecorderPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("roleArn", "RoleARN", cfn_parse.FromCloudFormation.getString(properties.RoleARN)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("recordingGroup", "RecordingGroup", properties.RecordingGroup != null ? CfnConfigurationRecorderRecordingGroupPropertyFromCloudFormation(properties.RecordingGroup) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnConfigurationRecorder = class _CfnConfigurationRecorder extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnConfigurationRecorderPropsFromCloudFormation(resourceProperties), ret = new _CfnConfigurationRecorder(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnConfigurationRecorder.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_config_CfnConfigurationRecorderProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnConfigurationRecorder), error;
        }
        cdk.requireProperty(props, "roleArn", this), this.roleArn = props.roleArn, this.name = props.name, this.recordingGroup = props.recordingGroup;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnConfigurationRecorder.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { roleArn: this.roleArn, name: this.name, recordingGroup: this.recordingGroup };
      }
      renderProperties(props) {
        return cfnConfigurationRecorderPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnConfigurationRecorder[_d] = { fqn: "aws-cdk-lib.aws_config.CfnConfigurationRecorder", version: "2.80.0" }, CfnConfigurationRecorder.CFN_RESOURCE_TYPE_NAME = "AWS::Config::ConfigurationRecorder", exports2.CfnConfigurationRecorder = CfnConfigurationRecorder;
    function CfnConfigurationRecorder_RecordingGroupPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allSupported", cdk.validateBoolean)(properties.allSupported)), errors.collect(cdk.propertyValidator("includeGlobalResourceTypes", cdk.validateBoolean)(properties.includeGlobalResourceTypes)), errors.collect(cdk.propertyValidator("resourceTypes", cdk.listValidator(cdk.validateString))(properties.resourceTypes)), errors.wrap('supplied properties not correct for "RecordingGroupProperty"');
    }
    function cfnConfigurationRecorderRecordingGroupPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationRecorder_RecordingGroupPropertyValidator(properties).assertSuccess(), { AllSupported: cdk.booleanToCloudFormation(properties.allSupported), IncludeGlobalResourceTypes: cdk.booleanToCloudFormation(properties.includeGlobalResourceTypes), ResourceTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.resourceTypes) }) : properties;
    }
    function CfnConfigurationRecorderRecordingGroupPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allSupported", "AllSupported", properties.AllSupported != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllSupported) : void 0), ret.addPropertyResult("includeGlobalResourceTypes", "IncludeGlobalResourceTypes", properties.IncludeGlobalResourceTypes != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeGlobalResourceTypes) : void 0), ret.addPropertyResult("resourceTypes", "ResourceTypes", properties.ResourceTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ResourceTypes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConformancePackPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("conformancePackInputParameters", cdk.listValidator(CfnConformancePack_ConformancePackInputParameterPropertyValidator))(properties.conformancePackInputParameters)), errors.collect(cdk.propertyValidator("conformancePackName", cdk.requiredValidator)(properties.conformancePackName)), errors.collect(cdk.propertyValidator("conformancePackName", cdk.validateString)(properties.conformancePackName)), errors.collect(cdk.propertyValidator("deliveryS3Bucket", cdk.validateString)(properties.deliveryS3Bucket)), errors.collect(cdk.propertyValidator("deliveryS3KeyPrefix", cdk.validateString)(properties.deliveryS3KeyPrefix)), errors.collect(cdk.propertyValidator("templateBody", cdk.validateString)(properties.templateBody)), errors.collect(cdk.propertyValidator("templateS3Uri", cdk.validateString)(properties.templateS3Uri)), errors.collect(cdk.propertyValidator("templateSsmDocumentDetails", cdk.validateObject)(properties.templateSsmDocumentDetails)), errors.wrap('supplied properties not correct for "CfnConformancePackProps"');
    }
    function cfnConformancePackPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConformancePackPropsValidator(properties).assertSuccess(), { ConformancePackName: cdk.stringToCloudFormation(properties.conformancePackName), ConformancePackInputParameters: cdk.listMapper(cfnConformancePackConformancePackInputParameterPropertyToCloudFormation)(properties.conformancePackInputParameters), DeliveryS3Bucket: cdk.stringToCloudFormation(properties.deliveryS3Bucket), DeliveryS3KeyPrefix: cdk.stringToCloudFormation(properties.deliveryS3KeyPrefix), TemplateBody: cdk.stringToCloudFormation(properties.templateBody), TemplateS3Uri: cdk.stringToCloudFormation(properties.templateS3Uri), TemplateSSMDocumentDetails: cdk.objectToCloudFormation(properties.templateSsmDocumentDetails) }) : properties;
    }
    function CfnConformancePackPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("conformancePackName", "ConformancePackName", cfn_parse.FromCloudFormation.getString(properties.ConformancePackName)), ret.addPropertyResult("conformancePackInputParameters", "ConformancePackInputParameters", properties.ConformancePackInputParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnConformancePackConformancePackInputParameterPropertyFromCloudFormation)(properties.ConformancePackInputParameters) : void 0), ret.addPropertyResult("deliveryS3Bucket", "DeliveryS3Bucket", properties.DeliveryS3Bucket != null ? cfn_parse.FromCloudFormation.getString(properties.DeliveryS3Bucket) : void 0), ret.addPropertyResult("deliveryS3KeyPrefix", "DeliveryS3KeyPrefix", properties.DeliveryS3KeyPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.DeliveryS3KeyPrefix) : void 0), ret.addPropertyResult("templateBody", "TemplateBody", properties.TemplateBody != null ? cfn_parse.FromCloudFormation.getString(properties.TemplateBody) : void 0), ret.addPropertyResult("templateS3Uri", "TemplateS3Uri", properties.TemplateS3Uri != null ? cfn_parse.FromCloudFormation.getString(properties.TemplateS3Uri) : void 0), ret.addPropertyResult("templateSsmDocumentDetails", "TemplateSSMDocumentDetails", properties.TemplateSSMDocumentDetails != null ? cfn_parse.FromCloudFormation.getAny(properties.TemplateSSMDocumentDetails) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnConformancePack = class _CfnConformancePack extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnConformancePackPropsFromCloudFormation(resourceProperties), ret = new _CfnConformancePack(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnConformancePack.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_config_CfnConformancePackProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnConformancePack), error;
        }
        cdk.requireProperty(props, "conformancePackName", this), this.conformancePackName = props.conformancePackName, this.conformancePackInputParameters = props.conformancePackInputParameters, this.deliveryS3Bucket = props.deliveryS3Bucket, this.deliveryS3KeyPrefix = props.deliveryS3KeyPrefix, this.templateBody = props.templateBody, this.templateS3Uri = props.templateS3Uri, this.templateSsmDocumentDetails = props.templateSsmDocumentDetails;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnConformancePack.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { conformancePackName: this.conformancePackName, conformancePackInputParameters: this.conformancePackInputParameters, deliveryS3Bucket: this.deliveryS3Bucket, deliveryS3KeyPrefix: this.deliveryS3KeyPrefix, templateBody: this.templateBody, templateS3Uri: this.templateS3Uri, templateSsmDocumentDetails: this.templateSsmDocumentDetails };
      }
      renderProperties(props) {
        return cfnConformancePackPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnConformancePack[_e] = { fqn: "aws-cdk-lib.aws_config.CfnConformancePack", version: "2.80.0" }, CfnConformancePack.CFN_RESOURCE_TYPE_NAME = "AWS::Config::ConformancePack", exports2.CfnConformancePack = CfnConformancePack;
    function CfnConformancePack_ConformancePackInputParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("parameterName", cdk.requiredValidator)(properties.parameterName)), errors.collect(cdk.propertyValidator("parameterName", cdk.validateString)(properties.parameterName)), errors.collect(cdk.propertyValidator("parameterValue", cdk.requiredValidator)(properties.parameterValue)), errors.collect(cdk.propertyValidator("parameterValue", cdk.validateString)(properties.parameterValue)), errors.wrap('supplied properties not correct for "ConformancePackInputParameterProperty"');
    }
    function cfnConformancePackConformancePackInputParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConformancePack_ConformancePackInputParameterPropertyValidator(properties).assertSuccess(), { ParameterName: cdk.stringToCloudFormation(properties.parameterName), ParameterValue: cdk.stringToCloudFormation(properties.parameterValue) }) : properties;
    }
    function CfnConformancePackConformancePackInputParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("parameterName", "ParameterName", cfn_parse.FromCloudFormation.getString(properties.ParameterName)), ret.addPropertyResult("parameterValue", "ParameterValue", cfn_parse.FromCloudFormation.getString(properties.ParameterValue)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryChannelPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configSnapshotDeliveryProperties", CfnDeliveryChannel_ConfigSnapshotDeliveryPropertiesPropertyValidator)(properties.configSnapshotDeliveryProperties)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("s3BucketName", cdk.requiredValidator)(properties.s3BucketName)), errors.collect(cdk.propertyValidator("s3BucketName", cdk.validateString)(properties.s3BucketName)), errors.collect(cdk.propertyValidator("s3KeyPrefix", cdk.validateString)(properties.s3KeyPrefix)), errors.collect(cdk.propertyValidator("s3KmsKeyArn", cdk.validateString)(properties.s3KmsKeyArn)), errors.collect(cdk.propertyValidator("snsTopicArn", cdk.validateString)(properties.snsTopicArn)), errors.wrap('supplied properties not correct for "CfnDeliveryChannelProps"');
    }
    function cfnDeliveryChannelPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryChannelPropsValidator(properties).assertSuccess(), { S3BucketName: cdk.stringToCloudFormation(properties.s3BucketName), ConfigSnapshotDeliveryProperties: cfnDeliveryChannelConfigSnapshotDeliveryPropertiesPropertyToCloudFormation(properties.configSnapshotDeliveryProperties), Name: cdk.stringToCloudFormation(properties.name), S3KeyPrefix: cdk.stringToCloudFormation(properties.s3KeyPrefix), S3KmsKeyArn: cdk.stringToCloudFormation(properties.s3KmsKeyArn), SnsTopicARN: cdk.stringToCloudFormation(properties.snsTopicArn) }) : properties;
    }
    function CfnDeliveryChannelPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3BucketName", "S3BucketName", cfn_parse.FromCloudFormation.getString(properties.S3BucketName)), ret.addPropertyResult("configSnapshotDeliveryProperties", "ConfigSnapshotDeliveryProperties", properties.ConfigSnapshotDeliveryProperties != null ? CfnDeliveryChannelConfigSnapshotDeliveryPropertiesPropertyFromCloudFormation(properties.ConfigSnapshotDeliveryProperties) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("s3KeyPrefix", "S3KeyPrefix", properties.S3KeyPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.S3KeyPrefix) : void 0), ret.addPropertyResult("s3KmsKeyArn", "S3KmsKeyArn", properties.S3KmsKeyArn != null ? cfn_parse.FromCloudFormation.getString(properties.S3KmsKeyArn) : void 0), ret.addPropertyResult("snsTopicArn", "SnsTopicARN", properties.SnsTopicARN != null ? cfn_parse.FromCloudFormation.getString(properties.SnsTopicARN) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDeliveryChannel = class _CfnDeliveryChannel extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDeliveryChannelPropsFromCloudFormation(resourceProperties), ret = new _CfnDeliveryChannel(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDeliveryChannel.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_config_CfnDeliveryChannelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDeliveryChannel), error;
        }
        cdk.requireProperty(props, "s3BucketName", this), this.s3BucketName = props.s3BucketName, this.configSnapshotDeliveryProperties = props.configSnapshotDeliveryProperties, this.name = props.name, this.s3KeyPrefix = props.s3KeyPrefix, this.s3KmsKeyArn = props.s3KmsKeyArn, this.snsTopicArn = props.snsTopicArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDeliveryChannel.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { s3BucketName: this.s3BucketName, configSnapshotDeliveryProperties: this.configSnapshotDeliveryProperties, name: this.name, s3KeyPrefix: this.s3KeyPrefix, s3KmsKeyArn: this.s3KmsKeyArn, snsTopicArn: this.snsTopicArn };
      }
      renderProperties(props) {
        return cfnDeliveryChannelPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnDeliveryChannel[_f] = { fqn: "aws-cdk-lib.aws_config.CfnDeliveryChannel", version: "2.80.0" }, CfnDeliveryChannel.CFN_RESOURCE_TYPE_NAME = "AWS::Config::DeliveryChannel", exports2.CfnDeliveryChannel = CfnDeliveryChannel;
    function CfnDeliveryChannel_ConfigSnapshotDeliveryPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deliveryFrequency", cdk.validateString)(properties.deliveryFrequency)), errors.wrap('supplied properties not correct for "ConfigSnapshotDeliveryPropertiesProperty"');
    }
    function cfnDeliveryChannelConfigSnapshotDeliveryPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryChannel_ConfigSnapshotDeliveryPropertiesPropertyValidator(properties).assertSuccess(), { DeliveryFrequency: cdk.stringToCloudFormation(properties.deliveryFrequency) }) : properties;
    }
    function CfnDeliveryChannelConfigSnapshotDeliveryPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deliveryFrequency", "DeliveryFrequency", properties.DeliveryFrequency != null ? cfn_parse.FromCloudFormation.getString(properties.DeliveryFrequency) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnOrganizationConfigRulePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("excludedAccounts", cdk.listValidator(cdk.validateString))(properties.excludedAccounts)), errors.collect(cdk.propertyValidator("organizationConfigRuleName", cdk.requiredValidator)(properties.organizationConfigRuleName)), errors.collect(cdk.propertyValidator("organizationConfigRuleName", cdk.validateString)(properties.organizationConfigRuleName)), errors.collect(cdk.propertyValidator("organizationCustomPolicyRuleMetadata", CfnOrganizationConfigRule_OrganizationCustomPolicyRuleMetadataPropertyValidator)(properties.organizationCustomPolicyRuleMetadata)), errors.collect(cdk.propertyValidator("organizationCustomRuleMetadata", CfnOrganizationConfigRule_OrganizationCustomRuleMetadataPropertyValidator)(properties.organizationCustomRuleMetadata)), errors.collect(cdk.propertyValidator("organizationManagedRuleMetadata", CfnOrganizationConfigRule_OrganizationManagedRuleMetadataPropertyValidator)(properties.organizationManagedRuleMetadata)), errors.wrap('supplied properties not correct for "CfnOrganizationConfigRuleProps"');
    }
    function cfnOrganizationConfigRulePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOrganizationConfigRulePropsValidator(properties).assertSuccess(), { OrganizationConfigRuleName: cdk.stringToCloudFormation(properties.organizationConfigRuleName), ExcludedAccounts: cdk.listMapper(cdk.stringToCloudFormation)(properties.excludedAccounts), OrganizationCustomPolicyRuleMetadata: cfnOrganizationConfigRuleOrganizationCustomPolicyRuleMetadataPropertyToCloudFormation(properties.organizationCustomPolicyRuleMetadata), OrganizationCustomRuleMetadata: cfnOrganizationConfigRuleOrganizationCustomRuleMetadataPropertyToCloudFormation(properties.organizationCustomRuleMetadata), OrganizationManagedRuleMetadata: cfnOrganizationConfigRuleOrganizationManagedRuleMetadataPropertyToCloudFormation(properties.organizationManagedRuleMetadata) }) : properties;
    }
    function CfnOrganizationConfigRulePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("organizationConfigRuleName", "OrganizationConfigRuleName", cfn_parse.FromCloudFormation.getString(properties.OrganizationConfigRuleName)), ret.addPropertyResult("excludedAccounts", "ExcludedAccounts", properties.ExcludedAccounts != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExcludedAccounts) : void 0), ret.addPropertyResult("organizationCustomPolicyRuleMetadata", "OrganizationCustomPolicyRuleMetadata", properties.OrganizationCustomPolicyRuleMetadata != null ? CfnOrganizationConfigRuleOrganizationCustomPolicyRuleMetadataPropertyFromCloudFormation(properties.OrganizationCustomPolicyRuleMetadata) : void 0), ret.addPropertyResult("organizationCustomRuleMetadata", "OrganizationCustomRuleMetadata", properties.OrganizationCustomRuleMetadata != null ? CfnOrganizationConfigRuleOrganizationCustomRuleMetadataPropertyFromCloudFormation(properties.OrganizationCustomRuleMetadata) : void 0), ret.addPropertyResult("organizationManagedRuleMetadata", "OrganizationManagedRuleMetadata", properties.OrganizationManagedRuleMetadata != null ? CfnOrganizationConfigRuleOrganizationManagedRuleMetadataPropertyFromCloudFormation(properties.OrganizationManagedRuleMetadata) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnOrganizationConfigRule = class _CfnOrganizationConfigRule extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnOrganizationConfigRulePropsFromCloudFormation(resourceProperties), ret = new _CfnOrganizationConfigRule(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnOrganizationConfigRule.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_config_CfnOrganizationConfigRuleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnOrganizationConfigRule), error;
        }
        cdk.requireProperty(props, "organizationConfigRuleName", this), this.organizationConfigRuleName = props.organizationConfigRuleName, this.excludedAccounts = props.excludedAccounts, this.organizationCustomPolicyRuleMetadata = props.organizationCustomPolicyRuleMetadata, this.organizationCustomRuleMetadata = props.organizationCustomRuleMetadata, this.organizationManagedRuleMetadata = props.organizationManagedRuleMetadata;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnOrganizationConfigRule.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { organizationConfigRuleName: this.organizationConfigRuleName, excludedAccounts: this.excludedAccounts, organizationCustomPolicyRuleMetadata: this.organizationCustomPolicyRuleMetadata, organizationCustomRuleMetadata: this.organizationCustomRuleMetadata, organizationManagedRuleMetadata: this.organizationManagedRuleMetadata };
      }
      renderProperties(props) {
        return cfnOrganizationConfigRulePropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnOrganizationConfigRule[_g] = { fqn: "aws-cdk-lib.aws_config.CfnOrganizationConfigRule", version: "2.80.0" }, CfnOrganizationConfigRule.CFN_RESOURCE_TYPE_NAME = "AWS::Config::OrganizationConfigRule", exports2.CfnOrganizationConfigRule = CfnOrganizationConfigRule;
    function CfnOrganizationConfigRule_OrganizationCustomPolicyRuleMetadataPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("debugLogDeliveryAccounts", cdk.listValidator(cdk.validateString))(properties.debugLogDeliveryAccounts)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("inputParameters", cdk.validateString)(properties.inputParameters)), errors.collect(cdk.propertyValidator("maximumExecutionFrequency", cdk.validateString)(properties.maximumExecutionFrequency)), errors.collect(cdk.propertyValidator("organizationConfigRuleTriggerTypes", cdk.listValidator(cdk.validateString))(properties.organizationConfigRuleTriggerTypes)), errors.collect(cdk.propertyValidator("policyText", cdk.requiredValidator)(properties.policyText)), errors.collect(cdk.propertyValidator("policyText", cdk.validateString)(properties.policyText)), errors.collect(cdk.propertyValidator("resourceIdScope", cdk.validateString)(properties.resourceIdScope)), errors.collect(cdk.propertyValidator("resourceTypesScope", cdk.listValidator(cdk.validateString))(properties.resourceTypesScope)), errors.collect(cdk.propertyValidator("runtime", cdk.requiredValidator)(properties.runtime)), errors.collect(cdk.propertyValidator("runtime", cdk.validateString)(properties.runtime)), errors.collect(cdk.propertyValidator("tagKeyScope", cdk.validateString)(properties.tagKeyScope)), errors.collect(cdk.propertyValidator("tagValueScope", cdk.validateString)(properties.tagValueScope)), errors.wrap('supplied properties not correct for "OrganizationCustomPolicyRuleMetadataProperty"');
    }
    function cfnOrganizationConfigRuleOrganizationCustomPolicyRuleMetadataPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOrganizationConfigRule_OrganizationCustomPolicyRuleMetadataPropertyValidator(properties).assertSuccess(), { DebugLogDeliveryAccounts: cdk.listMapper(cdk.stringToCloudFormation)(properties.debugLogDeliveryAccounts), Description: cdk.stringToCloudFormation(properties.description), InputParameters: cdk.stringToCloudFormation(properties.inputParameters), MaximumExecutionFrequency: cdk.stringToCloudFormation(properties.maximumExecutionFrequency), OrganizationConfigRuleTriggerTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.organizationConfigRuleTriggerTypes), PolicyText: cdk.stringToCloudFormation(properties.policyText), ResourceIdScope: cdk.stringToCloudFormation(properties.resourceIdScope), ResourceTypesScope: cdk.listMapper(cdk.stringToCloudFormation)(properties.resourceTypesScope), Runtime: cdk.stringToCloudFormation(properties.runtime), TagKeyScope: cdk.stringToCloudFormation(properties.tagKeyScope), TagValueScope: cdk.stringToCloudFormation(properties.tagValueScope) }) : properties;
    }
    function CfnOrganizationConfigRuleOrganizationCustomPolicyRuleMetadataPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("debugLogDeliveryAccounts", "DebugLogDeliveryAccounts", properties.DebugLogDeliveryAccounts != null ? cfn_parse.FromCloudFormation.getStringArray(properties.DebugLogDeliveryAccounts) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("inputParameters", "InputParameters", properties.InputParameters != null ? cfn_parse.FromCloudFormation.getString(properties.InputParameters) : void 0), ret.addPropertyResult("maximumExecutionFrequency", "MaximumExecutionFrequency", properties.MaximumExecutionFrequency != null ? cfn_parse.FromCloudFormation.getString(properties.MaximumExecutionFrequency) : void 0), ret.addPropertyResult("organizationConfigRuleTriggerTypes", "OrganizationConfigRuleTriggerTypes", properties.OrganizationConfigRuleTriggerTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.OrganizationConfigRuleTriggerTypes) : void 0), ret.addPropertyResult("policyText", "PolicyText", cfn_parse.FromCloudFormation.getString(properties.PolicyText)), ret.addPropertyResult("resourceIdScope", "ResourceIdScope", properties.ResourceIdScope != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceIdScope) : void 0), ret.addPropertyResult("resourceTypesScope", "ResourceTypesScope", properties.ResourceTypesScope != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ResourceTypesScope) : void 0), ret.addPropertyResult("runtime", "Runtime", cfn_parse.FromCloudFormation.getString(properties.Runtime)), ret.addPropertyResult("tagKeyScope", "TagKeyScope", properties.TagKeyScope != null ? cfn_parse.FromCloudFormation.getString(properties.TagKeyScope) : void 0), ret.addPropertyResult("tagValueScope", "TagValueScope", properties.TagValueScope != null ? cfn_parse.FromCloudFormation.getString(properties.TagValueScope) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnOrganizationConfigRule_OrganizationCustomRuleMetadataPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("inputParameters", cdk.validateString)(properties.inputParameters)), errors.collect(cdk.propertyValidator("lambdaFunctionArn", cdk.requiredValidator)(properties.lambdaFunctionArn)), errors.collect(cdk.propertyValidator("lambdaFunctionArn", cdk.validateString)(properties.lambdaFunctionArn)), errors.collect(cdk.propertyValidator("maximumExecutionFrequency", cdk.validateString)(properties.maximumExecutionFrequency)), errors.collect(cdk.propertyValidator("organizationConfigRuleTriggerTypes", cdk.requiredValidator)(properties.organizationConfigRuleTriggerTypes)), errors.collect(cdk.propertyValidator("organizationConfigRuleTriggerTypes", cdk.listValidator(cdk.validateString))(properties.organizationConfigRuleTriggerTypes)), errors.collect(cdk.propertyValidator("resourceIdScope", cdk.validateString)(properties.resourceIdScope)), errors.collect(cdk.propertyValidator("resourceTypesScope", cdk.listValidator(cdk.validateString))(properties.resourceTypesScope)), errors.collect(cdk.propertyValidator("tagKeyScope", cdk.validateString)(properties.tagKeyScope)), errors.collect(cdk.propertyValidator("tagValueScope", cdk.validateString)(properties.tagValueScope)), errors.wrap('supplied properties not correct for "OrganizationCustomRuleMetadataProperty"');
    }
    function cfnOrganizationConfigRuleOrganizationCustomRuleMetadataPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOrganizationConfigRule_OrganizationCustomRuleMetadataPropertyValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), InputParameters: cdk.stringToCloudFormation(properties.inputParameters), LambdaFunctionArn: cdk.stringToCloudFormation(properties.lambdaFunctionArn), MaximumExecutionFrequency: cdk.stringToCloudFormation(properties.maximumExecutionFrequency), OrganizationConfigRuleTriggerTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.organizationConfigRuleTriggerTypes), ResourceIdScope: cdk.stringToCloudFormation(properties.resourceIdScope), ResourceTypesScope: cdk.listMapper(cdk.stringToCloudFormation)(properties.resourceTypesScope), TagKeyScope: cdk.stringToCloudFormation(properties.tagKeyScope), TagValueScope: cdk.stringToCloudFormation(properties.tagValueScope) }) : properties;
    }
    function CfnOrganizationConfigRuleOrganizationCustomRuleMetadataPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("inputParameters", "InputParameters", properties.InputParameters != null ? cfn_parse.FromCloudFormation.getString(properties.InputParameters) : void 0), ret.addPropertyResult("lambdaFunctionArn", "LambdaFunctionArn", cfn_parse.FromCloudFormation.getString(properties.LambdaFunctionArn)), ret.addPropertyResult("maximumExecutionFrequency", "MaximumExecutionFrequency", properties.MaximumExecutionFrequency != null ? cfn_parse.FromCloudFormation.getString(properties.MaximumExecutionFrequency) : void 0), ret.addPropertyResult("organizationConfigRuleTriggerTypes", "OrganizationConfigRuleTriggerTypes", cfn_parse.FromCloudFormation.getStringArray(properties.OrganizationConfigRuleTriggerTypes)), ret.addPropertyResult("resourceIdScope", "ResourceIdScope", properties.ResourceIdScope != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceIdScope) : void 0), ret.addPropertyResult("resourceTypesScope", "ResourceTypesScope", properties.ResourceTypesScope != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ResourceTypesScope) : void 0), ret.addPropertyResult("tagKeyScope", "TagKeyScope", properties.TagKeyScope != null ? cfn_parse.FromCloudFormation.getString(properties.TagKeyScope) : void 0), ret.addPropertyResult("tagValueScope", "TagValueScope", properties.TagValueScope != null ? cfn_parse.FromCloudFormation.getString(properties.TagValueScope) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnOrganizationConfigRule_OrganizationManagedRuleMetadataPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("inputParameters", cdk.validateString)(properties.inputParameters)), errors.collect(cdk.propertyValidator("maximumExecutionFrequency", cdk.validateString)(properties.maximumExecutionFrequency)), errors.collect(cdk.propertyValidator("resourceIdScope", cdk.validateString)(properties.resourceIdScope)), errors.collect(cdk.propertyValidator("resourceTypesScope", cdk.listValidator(cdk.validateString))(properties.resourceTypesScope)), errors.collect(cdk.propertyValidator("ruleIdentifier", cdk.requiredValidator)(properties.ruleIdentifier)), errors.collect(cdk.propertyValidator("ruleIdentifier", cdk.validateString)(properties.ruleIdentifier)), errors.collect(cdk.propertyValidator("tagKeyScope", cdk.validateString)(properties.tagKeyScope)), errors.collect(cdk.propertyValidator("tagValueScope", cdk.validateString)(properties.tagValueScope)), errors.wrap('supplied properties not correct for "OrganizationManagedRuleMetadataProperty"');
    }
    function cfnOrganizationConfigRuleOrganizationManagedRuleMetadataPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOrganizationConfigRule_OrganizationManagedRuleMetadataPropertyValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), InputParameters: cdk.stringToCloudFormation(properties.inputParameters), MaximumExecutionFrequency: cdk.stringToCloudFormation(properties.maximumExecutionFrequency), ResourceIdScope: cdk.stringToCloudFormation(properties.resourceIdScope), ResourceTypesScope: cdk.listMapper(cdk.stringToCloudFormation)(properties.resourceTypesScope), RuleIdentifier: cdk.stringToCloudFormation(properties.ruleIdentifier), TagKeyScope: cdk.stringToCloudFormation(properties.tagKeyScope), TagValueScope: cdk.stringToCloudFormation(properties.tagValueScope) }) : properties;
    }
    function CfnOrganizationConfigRuleOrganizationManagedRuleMetadataPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("inputParameters", "InputParameters", properties.InputParameters != null ? cfn_parse.FromCloudFormation.getString(properties.InputParameters) : void 0), ret.addPropertyResult("maximumExecutionFrequency", "MaximumExecutionFrequency", properties.MaximumExecutionFrequency != null ? cfn_parse.FromCloudFormation.getString(properties.MaximumExecutionFrequency) : void 0), ret.addPropertyResult("resourceIdScope", "ResourceIdScope", properties.ResourceIdScope != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceIdScope) : void 0), ret.addPropertyResult("resourceTypesScope", "ResourceTypesScope", properties.ResourceTypesScope != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ResourceTypesScope) : void 0), ret.addPropertyResult("ruleIdentifier", "RuleIdentifier", cfn_parse.FromCloudFormation.getString(properties.RuleIdentifier)), ret.addPropertyResult("tagKeyScope", "TagKeyScope", properties.TagKeyScope != null ? cfn_parse.FromCloudFormation.getString(properties.TagKeyScope) : void 0), ret.addPropertyResult("tagValueScope", "TagValueScope", properties.TagValueScope != null ? cfn_parse.FromCloudFormation.getString(properties.TagValueScope) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnOrganizationConformancePackPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("conformancePackInputParameters", cdk.listValidator(CfnOrganizationConformancePack_ConformancePackInputParameterPropertyValidator))(properties.conformancePackInputParameters)), errors.collect(cdk.propertyValidator("deliveryS3Bucket", cdk.validateString)(properties.deliveryS3Bucket)), errors.collect(cdk.propertyValidator("deliveryS3KeyPrefix", cdk.validateString)(properties.deliveryS3KeyPrefix)), errors.collect(cdk.propertyValidator("excludedAccounts", cdk.listValidator(cdk.validateString))(properties.excludedAccounts)), errors.collect(cdk.propertyValidator("organizationConformancePackName", cdk.requiredValidator)(properties.organizationConformancePackName)), errors.collect(cdk.propertyValidator("organizationConformancePackName", cdk.validateString)(properties.organizationConformancePackName)), errors.collect(cdk.propertyValidator("templateBody", cdk.validateString)(properties.templateBody)), errors.collect(cdk.propertyValidator("templateS3Uri", cdk.validateString)(properties.templateS3Uri)), errors.wrap('supplied properties not correct for "CfnOrganizationConformancePackProps"');
    }
    function cfnOrganizationConformancePackPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOrganizationConformancePackPropsValidator(properties).assertSuccess(), { OrganizationConformancePackName: cdk.stringToCloudFormation(properties.organizationConformancePackName), ConformancePackInputParameters: cdk.listMapper(cfnOrganizationConformancePackConformancePackInputParameterPropertyToCloudFormation)(properties.conformancePackInputParameters), DeliveryS3Bucket: cdk.stringToCloudFormation(properties.deliveryS3Bucket), DeliveryS3KeyPrefix: cdk.stringToCloudFormation(properties.deliveryS3KeyPrefix), ExcludedAccounts: cdk.listMapper(cdk.stringToCloudFormation)(properties.excludedAccounts), TemplateBody: cdk.stringToCloudFormation(properties.templateBody), TemplateS3Uri: cdk.stringToCloudFormation(properties.templateS3Uri) }) : properties;
    }
    function CfnOrganizationConformancePackPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("organizationConformancePackName", "OrganizationConformancePackName", cfn_parse.FromCloudFormation.getString(properties.OrganizationConformancePackName)), ret.addPropertyResult("conformancePackInputParameters", "ConformancePackInputParameters", properties.ConformancePackInputParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnOrganizationConformancePackConformancePackInputParameterPropertyFromCloudFormation)(properties.ConformancePackInputParameters) : void 0), ret.addPropertyResult("deliveryS3Bucket", "DeliveryS3Bucket", properties.DeliveryS3Bucket != null ? cfn_parse.FromCloudFormation.getString(properties.DeliveryS3Bucket) : void 0), ret.addPropertyResult("deliveryS3KeyPrefix", "DeliveryS3KeyPrefix", properties.DeliveryS3KeyPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.DeliveryS3KeyPrefix) : void 0), ret.addPropertyResult("excludedAccounts", "ExcludedAccounts", properties.ExcludedAccounts != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExcludedAccounts) : void 0), ret.addPropertyResult("templateBody", "TemplateBody", properties.TemplateBody != null ? cfn_parse.FromCloudFormation.getString(properties.TemplateBody) : void 0), ret.addPropertyResult("templateS3Uri", "TemplateS3Uri", properties.TemplateS3Uri != null ? cfn_parse.FromCloudFormation.getString(properties.TemplateS3Uri) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnOrganizationConformancePack = class _CfnOrganizationConformancePack extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnOrganizationConformancePackPropsFromCloudFormation(resourceProperties), ret = new _CfnOrganizationConformancePack(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnOrganizationConformancePack.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_config_CfnOrganizationConformancePackProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnOrganizationConformancePack), error;
        }
        cdk.requireProperty(props, "organizationConformancePackName", this), this.organizationConformancePackName = props.organizationConformancePackName, this.conformancePackInputParameters = props.conformancePackInputParameters, this.deliveryS3Bucket = props.deliveryS3Bucket, this.deliveryS3KeyPrefix = props.deliveryS3KeyPrefix, this.excludedAccounts = props.excludedAccounts, this.templateBody = props.templateBody, this.templateS3Uri = props.templateS3Uri;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnOrganizationConformancePack.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { organizationConformancePackName: this.organizationConformancePackName, conformancePackInputParameters: this.conformancePackInputParameters, deliveryS3Bucket: this.deliveryS3Bucket, deliveryS3KeyPrefix: this.deliveryS3KeyPrefix, excludedAccounts: this.excludedAccounts, templateBody: this.templateBody, templateS3Uri: this.templateS3Uri };
      }
      renderProperties(props) {
        return cfnOrganizationConformancePackPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnOrganizationConformancePack[_h] = { fqn: "aws-cdk-lib.aws_config.CfnOrganizationConformancePack", version: "2.80.0" }, CfnOrganizationConformancePack.CFN_RESOURCE_TYPE_NAME = "AWS::Config::OrganizationConformancePack", exports2.CfnOrganizationConformancePack = CfnOrganizationConformancePack;
    function CfnOrganizationConformancePack_ConformancePackInputParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("parameterName", cdk.requiredValidator)(properties.parameterName)), errors.collect(cdk.propertyValidator("parameterName", cdk.validateString)(properties.parameterName)), errors.collect(cdk.propertyValidator("parameterValue", cdk.requiredValidator)(properties.parameterValue)), errors.collect(cdk.propertyValidator("parameterValue", cdk.validateString)(properties.parameterValue)), errors.wrap('supplied properties not correct for "ConformancePackInputParameterProperty"');
    }
    function cfnOrganizationConformancePackConformancePackInputParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOrganizationConformancePack_ConformancePackInputParameterPropertyValidator(properties).assertSuccess(), { ParameterName: cdk.stringToCloudFormation(properties.parameterName), ParameterValue: cdk.stringToCloudFormation(properties.parameterValue) }) : properties;
    }
    function CfnOrganizationConformancePackConformancePackInputParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("parameterName", "ParameterName", cfn_parse.FromCloudFormation.getString(properties.ParameterName)), ret.addPropertyResult("parameterValue", "ParameterValue", cfn_parse.FromCloudFormation.getString(properties.ParameterValue)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRemediationConfigurationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("automatic", cdk.validateBoolean)(properties.automatic)), errors.collect(cdk.propertyValidator("configRuleName", cdk.requiredValidator)(properties.configRuleName)), errors.collect(cdk.propertyValidator("configRuleName", cdk.validateString)(properties.configRuleName)), errors.collect(cdk.propertyValidator("executionControls", CfnRemediationConfiguration_ExecutionControlsPropertyValidator)(properties.executionControls)), errors.collect(cdk.propertyValidator("maximumAutomaticAttempts", cdk.validateNumber)(properties.maximumAutomaticAttempts)), errors.collect(cdk.propertyValidator("parameters", cdk.validateObject)(properties.parameters)), errors.collect(cdk.propertyValidator("resourceType", cdk.validateString)(properties.resourceType)), errors.collect(cdk.propertyValidator("retryAttemptSeconds", cdk.validateNumber)(properties.retryAttemptSeconds)), errors.collect(cdk.propertyValidator("targetId", cdk.requiredValidator)(properties.targetId)), errors.collect(cdk.propertyValidator("targetId", cdk.validateString)(properties.targetId)), errors.collect(cdk.propertyValidator("targetType", cdk.requiredValidator)(properties.targetType)), errors.collect(cdk.propertyValidator("targetType", cdk.validateString)(properties.targetType)), errors.collect(cdk.propertyValidator("targetVersion", cdk.validateString)(properties.targetVersion)), errors.wrap('supplied properties not correct for "CfnRemediationConfigurationProps"');
    }
    function cfnRemediationConfigurationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRemediationConfigurationPropsValidator(properties).assertSuccess(), { ConfigRuleName: cdk.stringToCloudFormation(properties.configRuleName), TargetId: cdk.stringToCloudFormation(properties.targetId), TargetType: cdk.stringToCloudFormation(properties.targetType), Automatic: cdk.booleanToCloudFormation(properties.automatic), ExecutionControls: cfnRemediationConfigurationExecutionControlsPropertyToCloudFormation(properties.executionControls), MaximumAutomaticAttempts: cdk.numberToCloudFormation(properties.maximumAutomaticAttempts), Parameters: cdk.objectToCloudFormation(properties.parameters), ResourceType: cdk.stringToCloudFormation(properties.resourceType), RetryAttemptSeconds: cdk.numberToCloudFormation(properties.retryAttemptSeconds), TargetVersion: cdk.stringToCloudFormation(properties.targetVersion) }) : properties;
    }
    function CfnRemediationConfigurationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configRuleName", "ConfigRuleName", cfn_parse.FromCloudFormation.getString(properties.ConfigRuleName)), ret.addPropertyResult("targetId", "TargetId", cfn_parse.FromCloudFormation.getString(properties.TargetId)), ret.addPropertyResult("targetType", "TargetType", cfn_parse.FromCloudFormation.getString(properties.TargetType)), ret.addPropertyResult("automatic", "Automatic", properties.Automatic != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Automatic) : void 0), ret.addPropertyResult("executionControls", "ExecutionControls", properties.ExecutionControls != null ? CfnRemediationConfigurationExecutionControlsPropertyFromCloudFormation(properties.ExecutionControls) : void 0), ret.addPropertyResult("maximumAutomaticAttempts", "MaximumAutomaticAttempts", properties.MaximumAutomaticAttempts != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumAutomaticAttempts) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getAny(properties.Parameters) : void 0), ret.addPropertyResult("resourceType", "ResourceType", properties.ResourceType != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceType) : void 0), ret.addPropertyResult("retryAttemptSeconds", "RetryAttemptSeconds", properties.RetryAttemptSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.RetryAttemptSeconds) : void 0), ret.addPropertyResult("targetVersion", "TargetVersion", properties.TargetVersion != null ? cfn_parse.FromCloudFormation.getString(properties.TargetVersion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRemediationConfiguration = class _CfnRemediationConfiguration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRemediationConfigurationPropsFromCloudFormation(resourceProperties), ret = new _CfnRemediationConfiguration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRemediationConfiguration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_config_CfnRemediationConfigurationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRemediationConfiguration), error;
        }
        cdk.requireProperty(props, "configRuleName", this), cdk.requireProperty(props, "targetId", this), cdk.requireProperty(props, "targetType", this), this.configRuleName = props.configRuleName, this.targetId = props.targetId, this.targetType = props.targetType, this.automatic = props.automatic, this.executionControls = props.executionControls, this.maximumAutomaticAttempts = props.maximumAutomaticAttempts, this.parameters = props.parameters, this.resourceType = props.resourceType, this.retryAttemptSeconds = props.retryAttemptSeconds, this.targetVersion = props.targetVersion;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRemediationConfiguration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { configRuleName: this.configRuleName, targetId: this.targetId, targetType: this.targetType, automatic: this.automatic, executionControls: this.executionControls, maximumAutomaticAttempts: this.maximumAutomaticAttempts, parameters: this.parameters, resourceType: this.resourceType, retryAttemptSeconds: this.retryAttemptSeconds, targetVersion: this.targetVersion };
      }
      renderProperties(props) {
        return cfnRemediationConfigurationPropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnRemediationConfiguration[_j] = { fqn: "aws-cdk-lib.aws_config.CfnRemediationConfiguration", version: "2.80.0" }, CfnRemediationConfiguration.CFN_RESOURCE_TYPE_NAME = "AWS::Config::RemediationConfiguration", exports2.CfnRemediationConfiguration = CfnRemediationConfiguration;
    function CfnRemediationConfiguration_ExecutionControlsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ssmControls", CfnRemediationConfiguration_SsmControlsPropertyValidator)(properties.ssmControls)), errors.wrap('supplied properties not correct for "ExecutionControlsProperty"');
    }
    function cfnRemediationConfigurationExecutionControlsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRemediationConfiguration_ExecutionControlsPropertyValidator(properties).assertSuccess(), { SsmControls: cfnRemediationConfigurationSsmControlsPropertyToCloudFormation(properties.ssmControls) }) : properties;
    }
    function CfnRemediationConfigurationExecutionControlsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ssmControls", "SsmControls", properties.SsmControls != null ? CfnRemediationConfigurationSsmControlsPropertyFromCloudFormation(properties.SsmControls) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRemediationConfiguration_SsmControlsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("concurrentExecutionRatePercentage", cdk.validateNumber)(properties.concurrentExecutionRatePercentage)), errors.collect(cdk.propertyValidator("errorPercentage", cdk.validateNumber)(properties.errorPercentage)), errors.wrap('supplied properties not correct for "SsmControlsProperty"');
    }
    function cfnRemediationConfigurationSsmControlsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRemediationConfiguration_SsmControlsPropertyValidator(properties).assertSuccess(), { ConcurrentExecutionRatePercentage: cdk.numberToCloudFormation(properties.concurrentExecutionRatePercentage), ErrorPercentage: cdk.numberToCloudFormation(properties.errorPercentage) }) : properties;
    }
    function CfnRemediationConfigurationSsmControlsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("concurrentExecutionRatePercentage", "ConcurrentExecutionRatePercentage", properties.ConcurrentExecutionRatePercentage != null ? cfn_parse.FromCloudFormation.getNumber(properties.ConcurrentExecutionRatePercentage) : void 0), ret.addPropertyResult("errorPercentage", "ErrorPercentage", properties.ErrorPercentage != null ? cfn_parse.FromCloudFormation.getNumber(properties.ErrorPercentage) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStoredQueryPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("queryDescription", cdk.validateString)(properties.queryDescription)), errors.collect(cdk.propertyValidator("queryExpression", cdk.requiredValidator)(properties.queryExpression)), errors.collect(cdk.propertyValidator("queryExpression", cdk.validateString)(properties.queryExpression)), errors.collect(cdk.propertyValidator("queryName", cdk.requiredValidator)(properties.queryName)), errors.collect(cdk.propertyValidator("queryName", cdk.validateString)(properties.queryName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnStoredQueryProps"');
    }
    function cfnStoredQueryPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStoredQueryPropsValidator(properties).assertSuccess(), { QueryExpression: cdk.stringToCloudFormation(properties.queryExpression), QueryName: cdk.stringToCloudFormation(properties.queryName), QueryDescription: cdk.stringToCloudFormation(properties.queryDescription), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnStoredQueryPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("queryExpression", "QueryExpression", cfn_parse.FromCloudFormation.getString(properties.QueryExpression)), ret.addPropertyResult("queryName", "QueryName", cfn_parse.FromCloudFormation.getString(properties.QueryName)), ret.addPropertyResult("queryDescription", "QueryDescription", properties.QueryDescription != null ? cfn_parse.FromCloudFormation.getString(properties.QueryDescription) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnStoredQuery = class _CfnStoredQuery extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnStoredQueryPropsFromCloudFormation(resourceProperties), ret = new _CfnStoredQuery(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnStoredQuery.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_config_CfnStoredQueryProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnStoredQuery), error;
        }
        cdk.requireProperty(props, "queryExpression", this), cdk.requireProperty(props, "queryName", this), this.attrQueryArn = cdk.Token.asString(this.getAtt("QueryArn", cdk.ResolutionTypeHint.STRING)), this.attrQueryId = cdk.Token.asString(this.getAtt("QueryId", cdk.ResolutionTypeHint.STRING)), this.queryExpression = props.queryExpression, this.queryName = props.queryName, this.queryDescription = props.queryDescription, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Config::StoredQuery", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStoredQuery.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { queryExpression: this.queryExpression, queryName: this.queryName, queryDescription: this.queryDescription, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnStoredQueryPropsToCloudFormation(props);
      }
    };
    _k = JSII_RTTI_SYMBOL_1, CfnStoredQuery[_k] = { fqn: "aws-cdk-lib.aws_config.CfnStoredQuery", version: "2.80.0" }, CfnStoredQuery.CFN_RESOURCE_TYPE_NAME = "AWS::Config::StoredQuery", exports2.CfnStoredQuery = CfnStoredQuery;
  }
});

// node_modules/aws-cdk-lib/aws-config/lib/rule.js
var require_rule4 = __commonJS({
  "node_modules/aws-cdk-lib/aws-config/lib/rule.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ResourceType = exports2.ManagedRuleIdentifiers = exports2.CustomPolicy = exports2.CustomRule = exports2.ManagedRule = exports2.MaximumExecutionFrequency = exports2.RuleScope = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var crypto_1 = require("crypto");
    var config_generated_1 = require_config_generated();
    var events = require_aws_events();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var RuleBase = class extends core_1.Resource {
      onEvent(id, options = {}) {
        const rule = new events.Rule(this, id, options);
        return rule.addEventPattern({ source: ["aws.config"], detail: { configRuleName: [this.configRuleName] } }), rule.addTarget(options.target), rule;
      }
      onComplianceChange(id, options = {}) {
        const rule = this.onEvent(id, options);
        return rule.addEventPattern({ detailType: ["Config Rules Compliance Change"] }), rule;
      }
      onReEvaluationStatus(id, options = {}) {
        const rule = this.onEvent(id, options);
        return rule.addEventPattern({ detailType: ["Config Rules Re-evaluation Status"] }), rule;
      }
    };
    var RuleNew = class extends RuleBase {
      static fromConfigRuleName(scope, id, configRuleName) {
        class Import extends RuleBase {
          constructor() {
            super(...arguments), this.configRuleName = configRuleName;
          }
        }
        return new Import(scope, id);
      }
    };
    var RuleScope = class _RuleScope {
      static fromResource(resourceType, resourceId) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_config_ResourceType(resourceType);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromResource), error;
        }
        return new _RuleScope(resourceId, [resourceType]);
      }
      static fromResources(resourceTypes) {
        return new _RuleScope(void 0, resourceTypes);
      }
      static fromTag(key, value) {
        return new _RuleScope(void 0, void 0, key, value);
      }
      constructor(resourceId, resourceTypes, tagKey, tagValue) {
        this.resourceTypes = resourceTypes, this.resourceId = resourceId, this.key = tagKey, this.value = tagValue;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, RuleScope[_a] = { fqn: "aws-cdk-lib.aws_config.RuleScope", version: "2.80.0" }, exports2.RuleScope = RuleScope;
    var MaximumExecutionFrequency;
    (function(MaximumExecutionFrequency2) {
      MaximumExecutionFrequency2.ONE_HOUR = "One_Hour", MaximumExecutionFrequency2.THREE_HOURS = "Three_Hours", MaximumExecutionFrequency2.SIX_HOURS = "Six_Hours", MaximumExecutionFrequency2.TWELVE_HOURS = "Twelve_Hours", MaximumExecutionFrequency2.TWENTY_FOUR_HOURS = "TwentyFour_Hours";
    })(MaximumExecutionFrequency = exports2.MaximumExecutionFrequency || (exports2.MaximumExecutionFrequency = {}));
    var ManagedRule = class _ManagedRule extends RuleNew {
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.configRuleName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_config_ManagedRuleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ManagedRule), error;
        }
        this.ruleScope = props.ruleScope;
        const rule = new config_generated_1.CfnConfigRule(this, "Resource", { configRuleName: this.physicalName, description: props.description, inputParameters: props.inputParameters, maximumExecutionFrequency: props.maximumExecutionFrequency, scope: core_1.Lazy.any({ produce: () => renderScope(this.ruleScope) }), source: { owner: "AWS", sourceIdentifier: props.identifier } });
        this.configRuleName = rule.ref, this.configRuleArn = rule.attrArn, this.configRuleId = rule.attrConfigRuleId, this.configRuleComplianceType = rule.attrComplianceType, this.isManaged = true;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, ManagedRule[_b] = { fqn: "aws-cdk-lib.aws_config.ManagedRule", version: "2.80.0" }, exports2.ManagedRule = ManagedRule;
    var EventSource;
    (function(EventSource2) {
      EventSource2.AWS_CONFIG = "aws.config";
    })(EventSource || (EventSource = {}));
    var MessageType;
    (function(MessageType2) {
      MessageType2.CONFIGURATION_ITEM_CHANGE_NOTIFICATION = "ConfigurationItemChangeNotification", MessageType2.OVERSIZED_CONFIGURATION_ITEM_CHANGE_NOTIFICATION = "OversizedConfigurationItemChangeNotification", MessageType2.SCHEDULED_NOTIFICATION = "ScheduledNotification", MessageType2.CONFIGURATION_SNAPSHOT_DELIVERY_COMPLETED = "ConfigurationSnapshotDeliveryCompleted";
    })(MessageType || (MessageType = {}));
    var CustomRule = class _CustomRule extends RuleNew {
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.configRuleName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_config_CustomRuleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CustomRule), error;
        }
        if (!props.configurationChanges && !props.periodic)
          throw new Error("At least one of `configurationChanges` or `periodic` must be set to true.");
        const sourceDetails = [];
        this.ruleScope = props.ruleScope, props.configurationChanges && (sourceDetails.push({ eventSource: EventSource.AWS_CONFIG, messageType: MessageType.CONFIGURATION_ITEM_CHANGE_NOTIFICATION }), sourceDetails.push({ eventSource: EventSource.AWS_CONFIG, messageType: MessageType.OVERSIZED_CONFIGURATION_ITEM_CHANGE_NOTIFICATION })), props.periodic && sourceDetails.push({ eventSource: EventSource.AWS_CONFIG, maximumExecutionFrequency: props.maximumExecutionFrequency, messageType: MessageType.SCHEDULED_NOTIFICATION });
        const customRulePermissionId = `CustomRulePermission${(0, crypto_1.createHash)("sha256").update(JSON.stringify({ fnName: props.lambdaFunction.functionName.toString, accountId: core_1.Stack.of(this).resolve(this.env.account), region: core_1.Stack.of(this).resolve(this.env.region) }), "utf8").digest("base64")}`;
        props.lambdaFunction.permissionsNode.tryFindChild(customRulePermissionId) || props.lambdaFunction.addPermission(customRulePermissionId, { principal: new iam.ServicePrincipal("config.amazonaws.com"), sourceAccount: this.env.account }), props.lambdaFunction.role && props.lambdaFunction.role.addManagedPolicy(iam.ManagedPolicy.fromAwsManagedPolicyName("service-role/AWSConfigRulesExecutionRole")), this.node.addDependency(props.lambdaFunction);
        const rule = new config_generated_1.CfnConfigRule(this, "Resource", { configRuleName: this.physicalName, description: props.description, inputParameters: props.inputParameters, maximumExecutionFrequency: props.maximumExecutionFrequency, scope: core_1.Lazy.any({ produce: () => renderScope(this.ruleScope) }), source: { owner: "CUSTOM_LAMBDA", sourceDetails, sourceIdentifier: props.lambdaFunction.functionArn } });
        this.configRuleName = rule.ref, this.configRuleArn = rule.attrArn, this.configRuleId = rule.attrConfigRuleId, this.configRuleComplianceType = rule.attrComplianceType, props.configurationChanges && (this.isCustomWithChanges = true);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CustomRule[_c] = { fqn: "aws-cdk-lib.aws_config.CustomRule", version: "2.80.0" }, exports2.CustomRule = CustomRule;
    var CustomPolicy = class _CustomPolicy extends RuleNew {
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.configRuleName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_config_CustomPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CustomPolicy), error;
        }
        if (!props.policyText || [...props.policyText].length === 0)
          throw new Error("Policy Text cannot be empty.");
        if ([...props.policyText].length > 1e4)
          throw new Error("Policy Text is limited to 10,000 characters or less.");
        const sourceDetails = [];
        this.ruleScope = props.ruleScope, sourceDetails.push({ eventSource: EventSource.AWS_CONFIG, messageType: MessageType.CONFIGURATION_ITEM_CHANGE_NOTIFICATION }), sourceDetails.push({ eventSource: EventSource.AWS_CONFIG, messageType: MessageType.OVERSIZED_CONFIGURATION_ITEM_CHANGE_NOTIFICATION });
        const rule = new config_generated_1.CfnConfigRule(this, "Resource", { configRuleName: this.physicalName, description: props.description, inputParameters: props.inputParameters, scope: core_1.Lazy.any({ produce: () => renderScope(this.ruleScope) }), source: { owner: "CUSTOM_POLICY", sourceDetails, customPolicyDetails: { enableDebugLogDelivery: props.enableDebugLog, policyRuntime: "guard-2.x.x", policyText: props.policyText } } });
        this.configRuleName = rule.ref, this.configRuleArn = rule.attrArn, this.configRuleId = rule.attrConfigRuleId, this.configRuleComplianceType = rule.attrComplianceType, this.isCustomWithChanges = true;
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CustomPolicy[_d] = { fqn: "aws-cdk-lib.aws_config.CustomPolicy", version: "2.80.0" }, exports2.CustomPolicy = CustomPolicy;
    var ManagedRuleIdentifiers = class {
      constructor() {
      }
    };
    _e = JSII_RTTI_SYMBOL_1, ManagedRuleIdentifiers[_e] = { fqn: "aws-cdk-lib.aws_config.ManagedRuleIdentifiers", version: "2.80.0" }, ManagedRuleIdentifiers.IAM_INLINE_POLICY_BLOCKED_KMS_ACTIONS = "IAM_INLINE_POLICY_BLOCKED_KMS_ACTIONS", ManagedRuleIdentifiers.IAM_CUSTOMER_POLICY_BLOCKED_KMS_ACTIONS = "IAM_CUSTOMER_POLICY_BLOCKED_KMS_ACTIONS", ManagedRuleIdentifiers.ACCESS_KEYS_ROTATED = "ACCESS_KEYS_ROTATED", ManagedRuleIdentifiers.ACCOUNT_PART_OF_ORGANIZATIONS = "ACCOUNT_PART_OF_ORGANIZATIONS", ManagedRuleIdentifiers.ACM_CERTIFICATE_EXPIRATION_CHECK = "ACM_CERTIFICATE_EXPIRATION_CHECK", ManagedRuleIdentifiers.ALB_DESYNC_MODE_CHECK = "ALB_DESYNC_MODE_CHECK", ManagedRuleIdentifiers.ALB_HTTP_DROP_INVALID_HEADER_ENABLED = "ALB_HTTP_DROP_INVALID_HEADER_ENABLED", ManagedRuleIdentifiers.ALB_HTTP_TO_HTTPS_REDIRECTION_CHECK = "ALB_HTTP_TO_HTTPS_REDIRECTION_CHECK", ManagedRuleIdentifiers.ALB_WAF_ENABLED = "ALB_WAF_ENABLED", ManagedRuleIdentifiers.API_GWV2_ACCESS_LOGS_ENABLED = "API_GWV2_ACCESS_LOGS_ENABLED", ManagedRuleIdentifiers.API_GWV2_AUTHORIZATION_TYPE_CONFIGURED = "API_GWV2_AUTHORIZATION_TYPE_CONFIGURED", ManagedRuleIdentifiers.API_GW_ASSOCIATED_WITH_WAF = "API_GW_ASSOCIATED_WITH_WAF", ManagedRuleIdentifiers.API_GW_CACHE_ENABLED_AND_ENCRYPTED = "API_GW_CACHE_ENABLED_AND_ENCRYPTED", ManagedRuleIdentifiers.API_GW_ENDPOINT_TYPE_CHECK = "API_GW_ENDPOINT_TYPE_CHECK", ManagedRuleIdentifiers.API_GW_EXECUTION_LOGGING_ENABLED = "API_GW_EXECUTION_LOGGING_ENABLED", ManagedRuleIdentifiers.API_GW_SSL_ENABLED = "API_GW_SSL_ENABLED", ManagedRuleIdentifiers.API_GW_XRAY_ENABLED = "API_GW_XRAY_ENABLED", ManagedRuleIdentifiers.APPROVED_AMIS_BY_ID = "APPROVED_AMIS_BY_ID", ManagedRuleIdentifiers.APPROVED_AMIS_BY_TAG = "APPROVED_AMIS_BY_TAG", ManagedRuleIdentifiers.AURORA_LAST_BACKUP_RECOVERY_POINT_CREATED = "AURORA_LAST_BACKUP_RECOVERY_POINT_CREATED", ManagedRuleIdentifiers.AURORA_MYSQL_BACKTRACKING_ENABLED = "AURORA_MYSQL_BACKTRACKING_ENABLED", ManagedRuleIdentifiers.AURORA_RESOURCES_PROTECTED_BY_BACKUP_PLAN = "AURORA_RESOURCES_PROTECTED_BY_BACKUP_PLAN", ManagedRuleIdentifiers.AUTOSCALING_CAPACITY_REBALANCING = "AUTOSCALING_CAPACITY_REBALANCING", ManagedRuleIdentifiers.AUTOSCALING_GROUP_ELB_HEALTHCHECK_REQUIRED = "AUTOSCALING_GROUP_ELB_HEALTHCHECK_REQUIRED", ManagedRuleIdentifiers.AUTOSCALING_LAUNCHCONFIG_REQUIRES_IMDSV2 = "AUTOSCALING_LAUNCHCONFIG_REQUIRES_IMDSV2", ManagedRuleIdentifiers.AUTOSCALING_LAUNCH_CONFIG_HOP_LIMIT = "AUTOSCALING_LAUNCH_CONFIG_HOP_LIMIT", ManagedRuleIdentifiers.AUTOSCALING_LAUNCH_CONFIG_PUBLIC_IP_DISABLED = "AUTOSCALING_LAUNCH_CONFIG_PUBLIC_IP_DISABLED", ManagedRuleIdentifiers.AUTOSCALING_LAUNCH_TEMPLATE = "AUTOSCALING_LAUNCH_TEMPLATE", ManagedRuleIdentifiers.AUTOSCALING_MULTIPLE_AZ = "AUTOSCALING_MULTIPLE_AZ", ManagedRuleIdentifiers.AUTOSCALING_MULTIPLE_INSTANCE_TYPES = "AUTOSCALING_MULTIPLE_INSTANCE_TYPES", ManagedRuleIdentifiers.BACKUP_PLAN_MIN_FREQUENCY_AND_MIN_RETENTION_CHECK = "BACKUP_PLAN_MIN_FREQUENCY_AND_MIN_RETENTION_CHECK", ManagedRuleIdentifiers.BACKUP_RECOVERY_POINT_ENCRYPTED = "BACKUP_RECOVERY_POINT_ENCRYPTED", ManagedRuleIdentifiers.BACKUP_RECOVERY_POINT_MANUAL_DELETION_DISABLED = "BACKUP_RECOVERY_POINT_MANUAL_DELETION_DISABLED", ManagedRuleIdentifiers.BACKUP_RECOVERY_POINT_MINIMUM_RETENTION_CHECK = "BACKUP_RECOVERY_POINT_MINIMUM_RETENTION_CHECK", ManagedRuleIdentifiers.BEANSTALK_ENHANCED_HEALTH_REPORTING_ENABLED = "BEANSTALK_ENHANCED_HEALTH_REPORTING_ENABLED", ManagedRuleIdentifiers.CLB_DESYNC_MODE_CHECK = "CLB_DESYNC_MODE_CHECK", ManagedRuleIdentifiers.CLB_MULTIPLE_AZ = "CLB_MULTIPLE_AZ", ManagedRuleIdentifiers.CLOUDFORMATION_STACK_DRIFT_DETECTION_CHECK = "CLOUDFORMATION_STACK_DRIFT_DETECTION_CHECK", ManagedRuleIdentifiers.CLOUDFORMATION_STACK_NOTIFICATION_CHECK = "CLOUDFORMATION_STACK_NOTIFICATION_CHECK", ManagedRuleIdentifiers.CLOUDFRONT_ACCESSLOGS_ENABLED = "CLOUDFRONT_ACCESSLOGS_ENABLED", ManagedRuleIdentifiers.CLOUDFRONT_ASSOCIATED_WITH_WAF = "CLOUDFRONT_ASSOCIATED_WITH_WAF", ManagedRuleIdentifiers.CLOUDFRONT_CUSTOM_SSL_CERTIFICATE = "CLOUDFRONT_CUSTOM_SSL_CERTIFICATE", ManagedRuleIdentifiers.CLOUDFRONT_DEFAULT_ROOT_OBJECT_CONFIGURED = "CLOUDFRONT_DEFAULT_ROOT_OBJECT_CONFIGURED", ManagedRuleIdentifiers.CLOUDFRONT_NO_DEPRECATED_SSL_PROTOCOLS = "CLOUDFRONT_NO_DEPRECATED_SSL_PROTOCOLS", ManagedRuleIdentifiers.CLOUDFRONT_ORIGIN_ACCESS_IDENTITY_ENABLED = "CLOUDFRONT_ORIGIN_ACCESS_IDENTITY_ENABLED", ManagedRuleIdentifiers.CLOUDFRONT_ORIGIN_FAILOVER_ENABLED = "CLOUDFRONT_ORIGIN_FAILOVER_ENABLED", ManagedRuleIdentifiers.CLOUDFRONT_SECURITY_POLICY_CHECK = "CLOUDFRONT_SECURITY_POLICY_CHECK", ManagedRuleIdentifiers.CLOUDFRONT_SNI_ENABLED = "CLOUDFRONT_SNI_ENABLED", ManagedRuleIdentifiers.CLOUDFRONT_TRAFFIC_TO_ORIGIN_ENCRYPTED = "CLOUDFRONT_TRAFFIC_TO_ORIGIN_ENCRYPTED", ManagedRuleIdentifiers.CLOUDFRONT_VIEWER_POLICY_HTTPS = "CLOUDFRONT_VIEWER_POLICY_HTTPS", ManagedRuleIdentifiers.CLOUD_TRAIL_CLOUD_WATCH_LOGS_ENABLED = "CLOUD_TRAIL_CLOUD_WATCH_LOGS_ENABLED", ManagedRuleIdentifiers.CLOUD_TRAIL_ENABLED = "CLOUD_TRAIL_ENABLED", ManagedRuleIdentifiers.CLOUD_TRAIL_ENCRYPTION_ENABLED = "CLOUD_TRAIL_ENCRYPTION_ENABLED", ManagedRuleIdentifiers.CLOUD_TRAIL_LOG_FILE_VALIDATION_ENABLED = "CLOUD_TRAIL_LOG_FILE_VALIDATION_ENABLED", ManagedRuleIdentifiers.CLOUDTRAIL_S3_DATAEVENTS_ENABLED = "CLOUDTRAIL_S3_DATAEVENTS_ENABLED", ManagedRuleIdentifiers.CLOUDTRAIL_SECURITY_TRAIL_ENABLED = "CLOUDTRAIL_SECURITY_TRAIL_ENABLED", ManagedRuleIdentifiers.CLOUDWATCH_ALARM_ACTION_CHECK = "CLOUDWATCH_ALARM_ACTION_CHECK", ManagedRuleIdentifiers.CLOUDWATCH_ALARM_ACTION_ENABLED_CHECK = "CLOUDWATCH_ALARM_ACTION_ENABLED_CHECK", ManagedRuleIdentifiers.CLOUDWATCH_ALARM_RESOURCE_CHECK = "CLOUDWATCH_ALARM_RESOURCE_CHECK", ManagedRuleIdentifiers.CLOUDWATCH_ALARM_SETTINGS_CHECK = "CLOUDWATCH_ALARM_SETTINGS_CHECK", ManagedRuleIdentifiers.CLOUDWATCH_LOG_GROUP_ENCRYPTED = "CLOUDWATCH_LOG_GROUP_ENCRYPTED", ManagedRuleIdentifiers.CMK_BACKING_KEY_ROTATION_ENABLED = "CMK_BACKING_KEY_ROTATION_ENABLED", ManagedRuleIdentifiers.CODEBUILD_PROJECT_ARTIFACT_ENCRYPTION = "CODEBUILD_PROJECT_ARTIFACT_ENCRYPTION", ManagedRuleIdentifiers.CODEBUILD_PROJECT_ENVIRONMENT_PRIVILEGED_CHECK = "CODEBUILD_PROJECT_ENVIRONMENT_PRIVILEGED_CHECK", ManagedRuleIdentifiers.CODEBUILD_PROJECT_ENVVAR_AWSCRED_CHECK = "CODEBUILD_PROJECT_ENVVAR_AWSCRED_CHECK", ManagedRuleIdentifiers.CODEBUILD_PROJECT_LOGGING_ENABLED = "CODEBUILD_PROJECT_LOGGING_ENABLED", ManagedRuleIdentifiers.CODEBUILD_PROJECT_S3_LOGS_ENCRYPTED = "CODEBUILD_PROJECT_S3_LOGS_ENCRYPTED", ManagedRuleIdentifiers.CODEBUILD_PROJECT_SOURCE_REPO_URL_CHECK = "CODEBUILD_PROJECT_SOURCE_REPO_URL_CHECK", ManagedRuleIdentifiers.CODEDEPLOY_AUTO_ROLLBACK_MONITOR_ENABLED = "CODEDEPLOY_AUTO_ROLLBACK_MONITOR_ENABLED", ManagedRuleIdentifiers.CODEDEPLOY_EC2_MINIMUM_HEALTHY_HOSTS_CONFIGURED = "CODEDEPLOY_EC2_MINIMUM_HEALTHY_HOSTS_CONFIGURED", ManagedRuleIdentifiers.CODEDEPLOY_LAMBDA_ALLATONCE_TRAFFIC_SHIFT_DISABLED = "CODEDEPLOY_LAMBDA_ALLATONCE_TRAFFIC_SHIFT_DISABLED", ManagedRuleIdentifiers.CODEPIPELINE_DEPLOYMENT_COUNT_CHECK = "CODEPIPELINE_DEPLOYMENT_COUNT_CHECK", ManagedRuleIdentifiers.CODEPIPELINE_REGION_FANOUT_CHECK = "CODEPIPELINE_REGION_FANOUT_CHECK", ManagedRuleIdentifiers.CW_LOGGROUP_RETENTION_PERIOD_CHECK = "CW_LOGGROUP_RETENTION_PERIOD_CHECK", ManagedRuleIdentifiers.DAX_ENCRYPTION_ENABLED = "DAX_ENCRYPTION_ENABLED", ManagedRuleIdentifiers.RDS_DB_INSTANCE_BACKUP_ENABLED = "DB_INSTANCE_BACKUP_ENABLED", ManagedRuleIdentifiers.EC2_DESIRED_INSTANCE_TENANCY = "DESIRED_INSTANCE_TENANCY", ManagedRuleIdentifiers.EC2_DESIRED_INSTANCE_TYPE = "DESIRED_INSTANCE_TYPE", ManagedRuleIdentifiers.DMS_REPLICATION_NOT_PUBLIC = "DMS_REPLICATION_NOT_PUBLIC", ManagedRuleIdentifiers.DYNAMODB_AUTOSCALING_ENABLED = "DYNAMODB_AUTOSCALING_ENABLED", ManagedRuleIdentifiers.DYNAMODB_IN_BACKUP_PLAN = "DYNAMODB_IN_BACKUP_PLAN", ManagedRuleIdentifiers.DYNAMODB_LAST_BACKUP_RECOVERY_POINT_CREATED = "DYNAMODB_LAST_BACKUP_RECOVERY_POINT_CREATED", ManagedRuleIdentifiers.DYNAMODB_PITR_ENABLED = "DYNAMODB_PITR_ENABLED", ManagedRuleIdentifiers.DYNAMODB_RESOURCES_PROTECTED_BY_BACKUP_PLAN = "DYNAMODB_RESOURCES_PROTECTED_BY_BACKUP_PLAN", ManagedRuleIdentifiers.DYNAMODB_TABLE_ENCRYPTED_KMS = "DYNAMODB_TABLE_ENCRYPTED_KMS", ManagedRuleIdentifiers.DYNAMODB_TABLE_ENCRYPTION_ENABLED = "DYNAMODB_TABLE_ENCRYPTION_ENABLED", ManagedRuleIdentifiers.DYNAMODB_THROUGHPUT_LIMIT_CHECK = "DYNAMODB_THROUGHPUT_LIMIT_CHECK", ManagedRuleIdentifiers.EBS_IN_BACKUP_PLAN = "EBS_IN_BACKUP_PLAN", ManagedRuleIdentifiers.EFS_IN_BACKUP_PLAN = "EFS_IN_BACKUP_PLAN", ManagedRuleIdentifiers.EC2_EBS_ENCRYPTION_BY_DEFAULT = "EC2_EBS_ENCRYPTION_BY_DEFAULT", ManagedRuleIdentifiers.EBS_OPTIMIZED_INSTANCE = "EBS_OPTIMIZED_INSTANCE", ManagedRuleIdentifiers.EBS_RESOURCES_PROTECTED_BY_BACKUP_PLAN = "EBS_RESOURCES_PROTECTED_BY_BACKUP_PLAN", ManagedRuleIdentifiers.EBS_SNAPSHOT_PUBLIC_RESTORABLE_CHECK = "EBS_SNAPSHOT_PUBLIC_RESTORABLE_CHECK", ManagedRuleIdentifiers.EC2_INSTANCE_DETAILED_MONITORING_ENABLED = "EC2_INSTANCE_DETAILED_MONITORING_ENABLED", ManagedRuleIdentifiers.EC2_INSTANCE_MANAGED_BY_SSM = "EC2_INSTANCE_MANAGED_BY_SSM", ManagedRuleIdentifiers.EC2_INSTANCE_PROFILE_ATTACHED = "EC2_INSTANCE_PROFILE_ATTACHED", ManagedRuleIdentifiers.EC2_INSTANCE_MULTIPLE_ENI_CHECK = "EC2_INSTANCE_MULTIPLE_ENI_CHECK", ManagedRuleIdentifiers.EC2_INSTANCE_NO_PUBLIC_IP = "EC2_INSTANCE_NO_PUBLIC_IP", ManagedRuleIdentifiers.EC2_LAST_BACKUP_RECOVERY_POINT_CREATED = "EC2_LAST_BACKUP_RECOVERY_POINT_CREATED", ManagedRuleIdentifiers.EC2_INSTANCES_IN_VPC = "INSTANCES_IN_VPC", ManagedRuleIdentifiers.EC2_MANAGED_INSTANCE_APPLICATIONS_BLOCKED = "EC2_MANAGEDINSTANCE_APPLICATIONS_BLACKLISTED", ManagedRuleIdentifiers.EC2_MANAGED_INSTANCE_APPLICATIONS_REQUIRED = "EC2_MANAGEDINSTANCE_APPLICATIONS_REQUIRED", ManagedRuleIdentifiers.EC2_MANAGED_INSTANCE_ASSOCIATION_COMPLIANCE_STATUS_CHECK = "EC2_MANAGEDINSTANCE_ASSOCIATION_COMPLIANCE_STATUS_CHECK", ManagedRuleIdentifiers.EC2_MANAGED_INSTANCE_INVENTORY_BLOCKED = "EC2_MANAGEDINSTANCE_INVENTORY_BLACKLISTED", ManagedRuleIdentifiers.EC2_MANAGED_INSTANCE_PATCH_COMPLIANCE_STATUS_CHECK = "EC2_MANAGEDINSTANCE_PATCH_COMPLIANCE_STATUS_CHECK", ManagedRuleIdentifiers.EC2_MANAGED_INSTANCE_PLATFORM_CHECK = "EC2_MANAGEDINSTANCE_PLATFORM_CHECK", ManagedRuleIdentifiers.EC2_NO_AMAZON_KEY_PAIR = "EC2_NO_AMAZON_KEY_PAIR", ManagedRuleIdentifiers.EC2_PARAVIRTUAL_INSTANCE_CHECK = "EC2_PARAVIRTUAL_INSTANCE_CHECK", ManagedRuleIdentifiers.EC2_RESOURCES_PROTECTED_BY_BACKUP_PLAN = "EC2_RESOURCES_PROTECTED_BY_BACKUP_PLAN", ManagedRuleIdentifiers.EC2_SECURITY_GROUP_ATTACHED_TO_ENI = "EC2_SECURITY_GROUP_ATTACHED_TO_ENI", ManagedRuleIdentifiers.EC2_SECURITY_GROUP_ATTACHED_TO_ENI_PERIODIC = "EC2_SECURITY_GROUP_ATTACHED_TO_ENI_PERIODIC", ManagedRuleIdentifiers.EC2_STOPPED_INSTANCE = "EC2_STOPPED_INSTANCE", ManagedRuleIdentifiers.EC2_TOKEN_HOP_LIMIT_CHECK = "EC2_TOKEN_HOP_LIMIT_CHECK", ManagedRuleIdentifiers.EC2_TRANSIT_GATEWAY_AUTO_VPC_ATTACH_DISABLED = "EC2_TRANSIT_GATEWAY_AUTO_VPC_ATTACH_DISABLED", ManagedRuleIdentifiers.EC2_VOLUME_INUSE_CHECK = "EC2_VOLUME_INUSE_CHECK", ManagedRuleIdentifiers.ECR_PRIVATE_IMAGE_SCANNING_ENABLED = "ECR_PRIVATE_IMAGE_SCANNING_ENABLED", ManagedRuleIdentifiers.ECR_PRIVATE_LIFECYCLE_POLICY_CONFIGURED = "ECR_PRIVATE_LIFECYCLE_POLICY_CONFIGURED", ManagedRuleIdentifiers.ECR_PRIVATE_TAG_IMMUTABILITY_ENABLED = "ECR_PRIVATE_TAG_IMMUTABILITY_ENABLED", ManagedRuleIdentifiers.ECS_AWSVPC_NETWORKING_ENABLED = "ECS_AWSVPC_NETWORKING_ENABLED", ManagedRuleIdentifiers.ECS_CONTAINERS_NONPRIVILEGED = "ECS_CONTAINERS_NONPRIVILEGED", ManagedRuleIdentifiers.ECS_CONTAINERS_READONLY_ACCESS = "ECS_CONTAINERS_READONLY_ACCESS", ManagedRuleIdentifiers.ECS_CONTAINER_INSIGHTS_ENABLED = "ECS_CONTAINER_INSIGHTS_ENABLED", ManagedRuleIdentifiers.ECS_FARGATE_LATEST_PLATFORM_VERSION = "ECS_FARGATE_LATEST_PLATFORM_VERSION", ManagedRuleIdentifiers.ECS_NO_ENVIRONMENT_SECRETS = "ECS_NO_ENVIRONMENT_SECRETS", ManagedRuleIdentifiers.ECS_TASK_DEFINITION_LOG_CONFIGURATION = "ECS_TASK_DEFINITION_LOG_CONFIGURATION", ManagedRuleIdentifiers.ECS_TASK_DEFINITION_MEMORY_HARD_LIMIT = "ECS_TASK_DEFINITION_MEMORY_HARD_LIMIT", ManagedRuleIdentifiers.ECS_TASK_DEFINITION_NONROOT_USER = "ECS_TASK_DEFINITION_NONROOT_USER", ManagedRuleIdentifiers.ECS_TASK_DEFINITION_PID_MODE_CHECK = "ECS_TASK_DEFINITION_PID_MODE_CHECK", ManagedRuleIdentifiers.EC2_VOLUME_IECS_TASK_DEFINITION_USER_FOR_HOST_MODE_CHECKNUSE_CHECK = "ECS_TASK_DEFINITION_USER_FOR_HOST_MODE_CHECK", ManagedRuleIdentifiers.EFS_ACCESS_POINT_ENFORCE_ROOT_DIRECTORY = "EFS_ACCESS_POINT_ENFORCE_ROOT_DIRECTORY", ManagedRuleIdentifiers.EFS_ACCESS_POINT_ENFORCE_USER_IDENTITY = "EFS_ACCESS_POINT_ENFORCE_USER_IDENTITY", ManagedRuleIdentifiers.EFS_ENCRYPTED_CHECK = "EFS_ENCRYPTED_CHECK", ManagedRuleIdentifiers.EFS_LAST_BACKUP_RECOVERY_POINT_CREATED = "EFS_LAST_BACKUP_RECOVERY_POINT_CREATED", ManagedRuleIdentifiers.EFS_RESOURCES_PROTECTED_BY_BACKUP_PLAN = "EFS_RESOURCES_PROTECTED_BY_BACKUP_PLAN", ManagedRuleIdentifiers.EIP_ATTACHED = "EIP_ATTACHED", ManagedRuleIdentifiers.ELASTICSEARCH_ENCRYPTED_AT_REST = "ELASTICSEARCH_ENCRYPTED_AT_REST", ManagedRuleIdentifiers.ELASTICSEARCH_IN_VPC_ONLY = "ELASTICSEARCH_IN_VPC_ONLY", ManagedRuleIdentifiers.ELASTICACHE_REDIS_CLUSTER_AUTOMATIC_BACKUP_CHECK = "ELASTICACHE_REDIS_CLUSTER_AUTOMATIC_BACKUP_CHECK", ManagedRuleIdentifiers.EC2_IMDSV2_CHECK = "EC2_IMDSV2_CHECK", ManagedRuleIdentifiers.EKS_CLUSTER_OLDEST_SUPPORTED_VERSION = "EKS_CLUSTER_OLDEST_SUPPORTED_VERSION", ManagedRuleIdentifiers.EKS_CLUSTER_SUPPORTED_VERSION = "EKS_CLUSTER_SUPPORTED_VERSION", ManagedRuleIdentifiers.EKS_ENDPOINT_NO_PUBLIC_ACCESS = "EKS_ENDPOINT_NO_PUBLIC_ACCESS", ManagedRuleIdentifiers.EKS_SECRETS_ENCRYPTED = "EKS_SECRETS_ENCRYPTED", ManagedRuleIdentifiers.ELASTICSEARCH_NODE_TO_NODE_ENCRYPTION_CHECK = "ELASTICSEARCH_NODE_TO_NODE_ENCRYPTION_CHECK", ManagedRuleIdentifiers.ELASTIC_BEANSTALK_MANAGED_UPDATES_ENABLED = "ELASTIC_BEANSTALK_MANAGED_UPDATES_ENABLED", ManagedRuleIdentifiers.ELBV2_ACM_CERTIFICATE_REQUIRED = "ELBV2_ACM_CERTIFICATE_REQUIRED", ManagedRuleIdentifiers.ELBV2_MULTIPLE_AZ = "ELBV2_MULTIPLE_AZ", ManagedRuleIdentifiers.ELB_CROSS_ZONE_LOAD_BALANCING_ENABLED = "ELB_CROSS_ZONE_LOAD_BALANCING_ENABLED", ManagedRuleIdentifiers.ELB_TLS_HTTPS_LISTENERS_ONLY = "ELB_TLS_HTTPS_LISTENERS_ONLY", ManagedRuleIdentifiers.ELB_ACM_CERTIFICATE_REQUIRED = "ELB_ACM_CERTIFICATE_REQUIRED", ManagedRuleIdentifiers.ELB_CUSTOM_SECURITY_POLICY_SSL_CHECK = "ELB_CUSTOM_SECURITY_POLICY_SSL_CHECK", ManagedRuleIdentifiers.ELB_DELETION_PROTECTION_ENABLED = "ELB_DELETION_PROTECTION_ENABLED", ManagedRuleIdentifiers.ELB_LOGGING_ENABLED = "ELB_LOGGING_ENABLED", ManagedRuleIdentifiers.ELB_PREDEFINED_SECURITY_POLICY_SSL_CHECK = "ELB_PREDEFINED_SECURITY_POLICY_SSL_CHECK", ManagedRuleIdentifiers.EMR_KERBEROS_ENABLED = "EMR_KERBEROS_ENABLED", ManagedRuleIdentifiers.EMR_MASTER_NO_PUBLIC_IP = "EMR_MASTER_NO_PUBLIC_IP", ManagedRuleIdentifiers.EBS_ENCRYPTED_VOLUMES = "ENCRYPTED_VOLUMES", ManagedRuleIdentifiers.FMS_SECURITY_GROUP_AUDIT_POLICY_CHECK = "FMS_SECURITY_GROUP_AUDIT_POLICY_CHECK", ManagedRuleIdentifiers.FMS_SECURITY_GROUP_CONTENT_CHECK = "FMS_SECURITY_GROUP_CONTENT_CHECK", ManagedRuleIdentifiers.FMS_SECURITY_GROUP_RESOURCE_ASSOCIATION_CHECK = "FMS_SECURITY_GROUP_RESOURCE_ASSOCIATION_CHECK", ManagedRuleIdentifiers.FMS_SHIELD_RESOURCE_POLICY_CHECK = "FMS_SHIELD_RESOURCE_POLICY_CHECK", ManagedRuleIdentifiers.FMS_WEBACL_RESOURCE_POLICY_CHECK = "FMS_WEBACL_RESOURCE_POLICY_CHECK", ManagedRuleIdentifiers.FMS_WEBACL_RULEGROUP_ASSOCIATION_CHECK = "FMS_WEBACL_RULEGROUP_ASSOCIATION_CHECK", ManagedRuleIdentifiers.FSX_LAST_BACKUP_RECOVERY_POINT_CREATED = "FSX_LAST_BACKUP_RECOVERY_POINT_CREATED", ManagedRuleIdentifiers.FSX_RESOURCES_PROTECTED_BY_BACKUP_PLAN = "FSX_RESOURCES_PROTECTED_BY_BACKUP_PLAN", ManagedRuleIdentifiers.GUARDDUTY_ENABLED_CENTRALIZED = "GUARDDUTY_ENABLED_CENTRALIZED", ManagedRuleIdentifiers.GUARDDUTY_NON_ARCHIVED_FINDINGS = "GUARDDUTY_NON_ARCHIVED_FINDINGS", ManagedRuleIdentifiers.IAM_NO_INLINE_POLICY_CHECK = "IAM_NO_INLINE_POLICY_CHECK", ManagedRuleIdentifiers.IAM_GROUP_HAS_USERS_CHECK = "IAM_GROUP_HAS_USERS_CHECK", ManagedRuleIdentifiers.IAM_PASSWORD_POLICY = "IAM_PASSWORD_POLICY", ManagedRuleIdentifiers.IAM_POLICY_BLOCKED_CHECK = "IAM_POLICY_BLACKLISTED_CHECK", ManagedRuleIdentifiers.IAM_POLICY_IN_USE = "IAM_POLICY_IN_USE", ManagedRuleIdentifiers.IAM_POLICY_NO_STATEMENTS_WITH_ADMIN_ACCESS = "IAM_POLICY_NO_STATEMENTS_WITH_ADMIN_ACCESS", ManagedRuleIdentifiers.IAM_POLICY_NO_STATEMENTS_WITH_FULL_ACCESS = "IAM_POLICY_NO_STATEMENTS_WITH_FULL_ACCESS", ManagedRuleIdentifiers.IAM_ROLE_MANAGED_POLICY_CHECK = "IAM_ROLE_MANAGED_POLICY_CHECK", ManagedRuleIdentifiers.IAM_ROOT_ACCESS_KEY_CHECK = "IAM_ROOT_ACCESS_KEY_CHECK", ManagedRuleIdentifiers.IAM_USER_GROUP_MEMBERSHIP_CHECK = "IAM_USER_GROUP_MEMBERSHIP_CHECK", ManagedRuleIdentifiers.IAM_USER_MFA_ENABLED = "IAM_USER_MFA_ENABLED", ManagedRuleIdentifiers.IAM_USER_NO_POLICIES_CHECK = "IAM_USER_NO_POLICIES_CHECK", ManagedRuleIdentifiers.IAM_USER_UNUSED_CREDENTIALS_CHECK = "IAM_USER_UNUSED_CREDENTIALS_CHECK", ManagedRuleIdentifiers.INTERNET_GATEWAY_AUTHORIZED_VPC_ONLY = "INTERNET_GATEWAY_AUTHORIZED_VPC_ONLY", ManagedRuleIdentifiers.KINESIS_STREAM_ENCRYPTED = "KINESIS_STREAM_ENCRYPTED", ManagedRuleIdentifiers.KMS_CMK_NOT_SCHEDULED_FOR_DELETION = "KMS_CMK_NOT_SCHEDULED_FOR_DELETION", ManagedRuleIdentifiers.LAMBDA_CONCURRENCY_CHECK = "LAMBDA_CONCURRENCY_CHECK", ManagedRuleIdentifiers.LAMBDA_DLQ_CHECK = "LAMBDA_DLQ_CHECK", ManagedRuleIdentifiers.LAMBDA_FUNCTION_PUBLIC_ACCESS_PROHIBITED = "LAMBDA_FUNCTION_PUBLIC_ACCESS_PROHIBITED", ManagedRuleIdentifiers.LAMBDA_FUNCTION_SETTINGS_CHECK = "LAMBDA_FUNCTION_SETTINGS_CHECK", ManagedRuleIdentifiers.LAMBDA_INSIDE_VPC = "LAMBDA_INSIDE_VPC", ManagedRuleIdentifiers.LAMBDA_VPC_MULTI_AZ_CHECK = "LAMBDA_VPC_MULTI_AZ_CHECK", ManagedRuleIdentifiers.MFA_ENABLED_FOR_IAM_CONSOLE_ACCESS = "MFA_ENABLED_FOR_IAM_CONSOLE_ACCESS", ManagedRuleIdentifiers.CLOUDTRAIL_MULTI_REGION_ENABLED = "MULTI_REGION_CLOUD_TRAIL_ENABLED", ManagedRuleIdentifiers.NACL_NO_UNRESTRICTED_SSH_RDP = "NACL_NO_UNRESTRICTED_SSH_RDP", ManagedRuleIdentifiers.NETFW_POLICY_DEFAULT_ACTION_FRAGMENT_PACKETS = "NETFW_POLICY_DEFAULT_ACTION_FRAGMENT_PACKETS", ManagedRuleIdentifiers.NETFW_POLICY_DEFAULT_ACTION_FULL_PACKETS = "NETFW_POLICY_DEFAULT_ACTION_FULL_PACKETS", ManagedRuleIdentifiers.NETFW_POLICY_RULE_GROUP_ASSOCIATED = "NETFW_POLICY_RULE_GROUP_ASSOCIATED", ManagedRuleIdentifiers.NETFW_STATELESS_RULE_GROUP_NOT_EMPTY = "NETFW_STATELESS_RULE_GROUP_NOT_EMPTY", ManagedRuleIdentifiers.NLB_CROSS_ZONE_LOAD_BALANCING_ENABLED = "NLB_CROSS_ZONE_LOAD_BALANCING_ENABLED", ManagedRuleIdentifiers.OPENSEARCH_ACCESS_CONTROL_ENABLED = "OPENSEARCH_ACCESS_CONTROL_ENABLED", ManagedRuleIdentifiers.OPENSEARCH_AUDIT_LOGGING_ENABLED = "OPENSEARCH_AUDIT_LOGGING_ENABLED", ManagedRuleIdentifiers.OPENSEARCH_DATA_NODE_FAULT_TOLERANCE = "OPENSEARCH_DATA_NODE_FAULT_TOLERANCE", ManagedRuleIdentifiers.OPENSEARCH_ENCRYPTED_AT_REST = "OPENSEARCH_ENCRYPTED_AT_REST", ManagedRuleIdentifiers.OPENSEARCH_HTTPS_REQUIRED = "OPENSEARCH_HTTPS_REQUIRED", ManagedRuleIdentifiers.OPENSEARCH_IN_VPC_ONLY = "OPENSEARCH_IN_VPC_ONLY", ManagedRuleIdentifiers.OPENSEARCH_LOGS_TO_CLOUDWATCH = "OPENSEARCH_LOGS_TO_CLOUDWATCH", ManagedRuleIdentifiers.OPENSEARCH_NODE_TO_NODE_ENCRYPTION_CHECK = "OPENSEARCH_NODE_TO_NODE_ENCRYPTION_CHECK", ManagedRuleIdentifiers.RDS_AUTOMATIC_MINOR_VERSION_UPGRADE_ENABLED = "RDS_AUTOMATIC_MINOR_VERSION_UPGRADE_ENABLED", ManagedRuleIdentifiers.RDS_CLUSTER_DEFAULT_ADMIN_CHECK = "RDS_CLUSTER_DEFAULT_ADMIN_CHECK", ManagedRuleIdentifiers.RDS_CLUSTER_DELETION_PROTECTION_ENABLED = "RDS_CLUSTER_DELETION_PROTECTION_ENABLED", ManagedRuleIdentifiers.RDS_CLUSTER_IAM_AUTHENTICATION_ENABLED = "RDS_CLUSTER_IAM_AUTHENTICATION_ENABLED", ManagedRuleIdentifiers.RDS_CLUSTER_MULTI_AZ_ENABLED = "RDS_CLUSTER_MULTI_AZ_ENABLED", ManagedRuleIdentifiers.RDS_INSTANCE_DEFAULT_ADMIN_CHECK = "RDS_INSTANCE_DEFAULT_ADMIN_CHECK", ManagedRuleIdentifiers.RDS_DB_SECURITY_GROUP_NOT_ALLOWED = "RDS_DB_SECURITY_GROUP_NOT_ALLOWED", ManagedRuleIdentifiers.RDS_INSTANCE_DELETION_PROTECTION_ENABLED = "RDS_INSTANCE_DELETION_PROTECTION_ENABLED", ManagedRuleIdentifiers.RDS_INSTANCE_IAM_AUTHENTICATION_ENABLED = "RDS_INSTANCE_IAM_AUTHENTICATION_ENABLED", ManagedRuleIdentifiers.RDS_LOGGING_ENABLED = "RDS_LOGGING_ENABLED", ManagedRuleIdentifiers.REDSHIFT_BACKUP_ENABLED = "REDSHIFT_BACKUP_ENABLED", ManagedRuleIdentifiers.RDS_ENHANCED_MONITORING_ENABLED = "RDS_ENHANCED_MONITORING_ENABLED", ManagedRuleIdentifiers.RDS_SNAPSHOT_ENCRYPTED = "RDS_SNAPSHOT_ENCRYPTED", ManagedRuleIdentifiers.REDSHIFT_REQUIRE_TLS_SSL = "REDSHIFT_REQUIRE_TLS_SSL", ManagedRuleIdentifiers.RDS_IN_BACKUP_PLAN = "RDS_IN_BACKUP_PLAN", ManagedRuleIdentifiers.RDS_LAST_BACKUP_RECOVERY_POINT_CREATED = "RDS_LAST_BACKUP_RECOVERY_POINT_CREATED", ManagedRuleIdentifiers.RDS_INSTANCE_PUBLIC_ACCESS_CHECK = "RDS_INSTANCE_PUBLIC_ACCESS_CHECK", ManagedRuleIdentifiers.RDS_MULTI_AZ_SUPPORT = "RDS_MULTI_AZ_SUPPORT", ManagedRuleIdentifiers.RDS_RESOURCES_PROTECTED_BY_BACKUP_PLAN = "RDS_RESOURCES_PROTECTED_BY_BACKUP_PLAN", ManagedRuleIdentifiers.RDS_SNAPSHOTS_PUBLIC_PROHIBITED = "RDS_SNAPSHOTS_PUBLIC_PROHIBITED", ManagedRuleIdentifiers.RDS_STORAGE_ENCRYPTED = "RDS_STORAGE_ENCRYPTED", ManagedRuleIdentifiers.REDSHIFT_AUDIT_LOGGING_ENABLED = "REDSHIFT_AUDIT_LOGGING_ENABLED", ManagedRuleIdentifiers.REDSHIFT_CLUSTER_CONFIGURATION_CHECK = "REDSHIFT_CLUSTER_CONFIGURATION_CHECK", ManagedRuleIdentifiers.REDSHIFT_CLUSTER_KMS_ENABLED = "REDSHIFT_CLUSTER_KMS_ENABLED", ManagedRuleIdentifiers.REDSHIFT_CLUSTER_MAINTENANCE_SETTINGS_CHECK = "REDSHIFT_CLUSTER_MAINTENANCESETTINGS_CHECK", ManagedRuleIdentifiers.REDSHIFT_CLUSTER_PUBLIC_ACCESS_CHECK = "REDSHIFT_CLUSTER_PUBLIC_ACCESS_CHECK", ManagedRuleIdentifiers.REDSHIFT_DEFAULT_ADMIN_CHECK = "REDSHIFT_DEFAULT_ADMIN_CHECK", ManagedRuleIdentifiers.REDSHIFT_DEFAULT_DB_NAME_CHECK = "REDSHIFT_DEFAULT_DB_NAME_CHECK", ManagedRuleIdentifiers.REDSHIFT_ENHANCED_VPC_ROUTING_ENABLED = "REDSHIFT_ENHANCED_VPC_ROUTING_ENABLED", ManagedRuleIdentifiers.REQUIRED_TAGS = "REQUIRED_TAGS", ManagedRuleIdentifiers.EC2_SECURITY_GROUPS_RESTRICTED_INCOMING_TRAFFIC = "RESTRICTED_INCOMING_TRAFFIC", ManagedRuleIdentifiers.EC2_SECURITY_GROUPS_INCOMING_SSH_DISABLED = "INCOMING_SSH_DISABLED", ManagedRuleIdentifiers.ROOT_ACCOUNT_HARDWARE_MFA_ENABLED = "ROOT_ACCOUNT_HARDWARE_MFA_ENABLED", ManagedRuleIdentifiers.ROOT_ACCOUNT_MFA_ENABLED = "ROOT_ACCOUNT_MFA_ENABLED", ManagedRuleIdentifiers.S3_BUCKET_DEFAULT_LOCK_ENABLED = "S3_BUCKET_DEFAULT_LOCK_ENABLED", ManagedRuleIdentifiers.S3_DEFAULT_ENCRYPTION_KMS = "S3_DEFAULT_ENCRYPTION_KMS", ManagedRuleIdentifiers.SECURITYHUB_ENABLED = "SECURITYHUB_ENABLED", ManagedRuleIdentifiers.SNS_ENCRYPTED_KMS = "SNS_ENCRYPTED_KMS", ManagedRuleIdentifiers.SNS_TOPIC_MESSAGE_DELIVERY_NOTIFICATION_ENABLED = "SNS_TOPIC_MESSAGE_DELIVERY_NOTIFICATION_ENABLED", ManagedRuleIdentifiers.SSM_DOCUMENT_NOT_PUBLIC = "SSM_DOCUMENT_NOT_PUBLIC", ManagedRuleIdentifiers.STORAGEGATEWAY_LAST_BACKUP_RECOVERY_POINT_CREATED = "STORAGEGATEWAY_LAST_BACKUP_RECOVERY_POINT_CREATED", ManagedRuleIdentifiers.SUBNET_AUTO_ASSIGN_PUBLIC_IP_DISABLED = "SUBNET_AUTO_ASSIGN_PUBLIC_IP_DISABLED", ManagedRuleIdentifiers.S3_ACCOUNT_LEVEL_PUBLIC_ACCESS_BLOCKS = "S3_ACCOUNT_LEVEL_PUBLIC_ACCESS_BLOCKS", ManagedRuleIdentifiers.S3_ACCOUNT_LEVEL_PUBLIC_ACCESS_BLOCKS_PERIODIC = "S3_ACCOUNT_LEVEL_PUBLIC_ACCESS_BLOCKS_PERIODIC", ManagedRuleIdentifiers.S3_BUCKET_ACL_PROHIBITED = "S3_BUCKET_ACL_PROHIBITED", ManagedRuleIdentifiers.S3_BUCKET_BLOCKED_ACTIONS_PROHIBITED = "S3_BUCKET_BLACKLISTED_ACTIONS_PROHIBITED", ManagedRuleIdentifiers.S3_BUCKET_LEVEL_PUBLIC_ACCESS_PROHIBITED = "S3_BUCKET_LEVEL_PUBLIC_ACCESS_PROHIBITED", ManagedRuleIdentifiers.S3_BUCKET_LOGGING_ENABLED = "S3_BUCKET_LOGGING_ENABLED", ManagedRuleIdentifiers.S3_BUCKET_POLICY_GRANTEE_CHECK = "S3_BUCKET_POLICY_GRANTEE_CHECK", ManagedRuleIdentifiers.S3_BUCKET_POLICY_NOT_MORE_PERMISSIVE = "S3_BUCKET_POLICY_NOT_MORE_PERMISSIVE", ManagedRuleIdentifiers.S3_BUCKET_PUBLIC_READ_PROHIBITED = "S3_BUCKET_PUBLIC_READ_PROHIBITED", ManagedRuleIdentifiers.S3_BUCKET_PUBLIC_WRITE_PROHIBITED = "S3_BUCKET_PUBLIC_WRITE_PROHIBITED", ManagedRuleIdentifiers.S3_BUCKET_REPLICATION_ENABLED = "S3_BUCKET_REPLICATION_ENABLED", ManagedRuleIdentifiers.S3_BUCKET_SERVER_SIDE_ENCRYPTION_ENABLED = "S3_BUCKET_SERVER_SIDE_ENCRYPTION_ENABLED", ManagedRuleIdentifiers.S3_BUCKET_SSL_REQUESTS_ONLY = "S3_BUCKET_SSL_REQUESTS_ONLY", ManagedRuleIdentifiers.S3_BUCKET_VERSIONING_ENABLED = "S3_BUCKET_VERSIONING_ENABLED", ManagedRuleIdentifiers.S3_EVENT_NOTIFICATIONS_ENABLED = "S3_EVENT_NOTIFICATIONS_ENABLED", ManagedRuleIdentifiers.S3_LAST_BACKUP_RECOVERY_POINT_CREATED = "S3_LAST_BACKUP_RECOVERY_POINT_CREATED", ManagedRuleIdentifiers.S3_LIFECYCLE_POLICY_CHECK = "S3_LIFECYCLE_POLICY_CHECK", ManagedRuleIdentifiers.S3_RESOURCES_PROTECTED_BY_BACKUP_PLAN = "S3_RESOURCES_PROTECTED_BY_BACKUP_PLAN", ManagedRuleIdentifiers.S3_VERSION_LIFECYCLE_POLICY_CHECK = "S3_VERSION_LIFECYCLE_POLICY_CHECK", ManagedRuleIdentifiers.SAGEMAKER_ENDPOINT_CONFIGURATION_KMS_KEY_CONFIGURED = "SAGEMAKER_ENDPOINT_CONFIGURATION_KMS_KEY_CONFIGURED", ManagedRuleIdentifiers.SAGEMAKER_NOTEBOOK_INSTANCE_KMS_KEY_CONFIGURED = "SAGEMAKER_NOTEBOOK_INSTANCE_KMS_KEY_CONFIGURED", ManagedRuleIdentifiers.SAGEMAKER_NOTEBOOK_NO_DIRECT_INTERNET_ACCESS = "SAGEMAKER_NOTEBOOK_NO_DIRECT_INTERNET_ACCESS", ManagedRuleIdentifiers.SECRETSMANAGER_ROTATION_ENABLED_CHECK = "SECRETSMANAGER_ROTATION_ENABLED_CHECK", ManagedRuleIdentifiers.SECRETSMANAGER_SCHEDULED_ROTATION_SUCCESS_CHECK = "SECRETSMANAGER_SCHEDULED_ROTATION_SUCCESS_CHECK", ManagedRuleIdentifiers.SECRETSMANAGER_SECRET_PERIODIC_ROTATION = "SECRETSMANAGER_SECRET_PERIODIC_ROTATION", ManagedRuleIdentifiers.SECRETSMANAGER_SECRET_UNUSED = "SECRETSMANAGER_SECRET_UNUSED", ManagedRuleIdentifiers.SECRETSMANAGER_USING_CMK = "SECRETSMANAGER_USING_CMK", ManagedRuleIdentifiers.SERVICE_VPC_ENDPOINT_ENABLED = "SERVICE_VPC_ENDPOINT_ENABLED", ManagedRuleIdentifiers.SHIELD_ADVANCED_ENABLED_AUTO_RENEW = "SHIELD_ADVANCED_ENABLED_AUTORENEW", ManagedRuleIdentifiers.SHIELD_DRT_ACCESS = "SHIELD_DRT_ACCESS", ManagedRuleIdentifiers.VIRTUALMACHINE_LAST_BACKUP_RECOVERY_POINT_CREATED = "VIRTUALMACHINE_LAST_BACKUP_RECOVERY_POINT_CREATED", ManagedRuleIdentifiers.VIRTUALMACHINE_RESOURCES_PROTECTED_BY_BACKUP_PLAN = "VIRTUALMACHINE_RESOURCES_PROTECTED_BY_BACKUP_PLAN", ManagedRuleIdentifiers.VPC_DEFAULT_SECURITY_GROUP_CLOSED = "VPC_DEFAULT_SECURITY_GROUP_CLOSED", ManagedRuleIdentifiers.VPC_FLOW_LOGS_ENABLED = "VPC_FLOW_LOGS_ENABLED", ManagedRuleIdentifiers.VPC_NETWORK_ACL_UNUSED_CHECK = "VPC_NETWORK_ACL_UNUSED_CHECK", ManagedRuleIdentifiers.VPC_PEERING_DNS_RESOLUTION_CHECK = "VPC_PEERING_DNS_RESOLUTION_CHECK", ManagedRuleIdentifiers.VPC_SG_OPEN_ONLY_TO_AUTHORIZED_PORTS = "VPC_SG_OPEN_ONLY_TO_AUTHORIZED_PORTS", ManagedRuleIdentifiers.VPC_VPN_2_TUNNELS_UP = "VPC_VPN_2_TUNNELS_UP", ManagedRuleIdentifiers.WAF_CLASSIC_LOGGING_ENABLED = "WAF_CLASSIC_LOGGING_ENABLED", ManagedRuleIdentifiers.WAFV2_LOGGING_ENABLED = "WAFV2_LOGGING_ENABLED", ManagedRuleIdentifiers.WAF_GLOBAL_RULEGROUP_NOT_EMPTY = "WAF_GLOBAL_RULEGROUP_NOT_EMPTY", ManagedRuleIdentifiers.WAF_GLOBAL_RULE_NOT_EMPTY = "WAF_GLOBAL_RULE_NOT_EMPTY", ManagedRuleIdentifiers.WAF_GLOBAL_WEBACL_NOT_EMPTY = "WAF_GLOBAL_WEBACL_NOT_EMPTY", ManagedRuleIdentifiers.WAF_REGIONAL_RULEGROUP_NOT_EMPTY = "WAF_REGIONAL_RULEGROUP_NOT_EMPTY", ManagedRuleIdentifiers.WAF_REGIONAL_RULE_NOT_EMPTY = "WAF_REGIONAL_RULE_NOT_EMPTY", ManagedRuleIdentifiers.WAF_REGIONAL_WEBACL_NOT_EMPTY = "WAF_REGIONAL_WEBACL_NOT_EMPTY", exports2.ManagedRuleIdentifiers = ManagedRuleIdentifiers;
    var ResourceType = class _ResourceType {
      static of(type) {
        return new _ResourceType(type);
      }
      constructor(type) {
        this.complianceResourceType = type;
      }
    };
    _f = JSII_RTTI_SYMBOL_1, ResourceType[_f] = { fqn: "aws-cdk-lib.aws_config.ResourceType", version: "2.80.0" }, ResourceType.APIGATEWAY_STAGE = new ResourceType("AWS::ApiGateway::Stage"), ResourceType.APIGATEWAYV2_STAGE = new ResourceType("AWS::ApiGatewayV2::Stage"), ResourceType.APIGATEWAY_REST_API = new ResourceType("AWS::ApiGateway::RestApi"), ResourceType.APIGATEWAYV2_API = new ResourceType("AWS::ApiGatewayV2::Api"), ResourceType.CLOUDFRONT_DISTRIBUTION = new ResourceType("AWS::CloudFront::Distribution"), ResourceType.CLOUDFRONT_STREAMING_DISTRIBUTION = new ResourceType("AWS::CloudFront::StreamingDistribution"), ResourceType.CLOUDWATCH_ALARM = new ResourceType("AWS::CloudWatch::Alarm"), ResourceType.CLOUDWATCH_RUM_APP_MONITOR = new ResourceType("AWS::RUM::AppMonitor"), ResourceType.DYNAMODB_TABLE = new ResourceType("AWS::DynamoDB::Table"), ResourceType.EBS_VOLUME = new ResourceType("AWS::EC2::Volume"), ResourceType.EC2_HOST = new ResourceType("AWS::EC2::Host"), ResourceType.EC2_EIP = new ResourceType("AWS::EC2::EIP"), ResourceType.EC2_INSTANCE = new ResourceType("AWS::EC2::Instance"), ResourceType.EC2_NETWORK_INTERFACE = new ResourceType("AWS::EC2::NetworkInterface"), ResourceType.EC2_SECURITY_GROUP = new ResourceType("AWS::EC2::SecurityGroup"), ResourceType.EC2_NAT_GATEWAY = new ResourceType("AWS::EC2::NatGateway"), ResourceType.EC2_EGRESS_ONLY_INTERNET_GATEWAY = new ResourceType("AWS::EC2::EgressOnlyInternetGateway"), ResourceType.EC2_FLOW_LOG = new ResourceType("AWS::EC2::FlowLog"), ResourceType.EC2_TRANSIT_GATEWAY = new ResourceType("AWS::EC2::TransitGateway"), ResourceType.EC2_TRANSIT_GATEWAY_ATTACHMENT = new ResourceType("AWS::EC2::TransitGatewayAttachment"), ResourceType.EC2_TRANSIT_GATEWAY_ROUTE_TABLE = new ResourceType("AWS::EC2::TransitGatewayRouteTable"), ResourceType.EC2_VPC_ENDPOINT = new ResourceType("AWS::EC2::VPCEndpoint"), ResourceType.EC2_VPC_ENDPOINT_SERVICE = new ResourceType("AWS::EC2::VPCEndpointService"), ResourceType.EC2_VPC_PEERING_CONNECTION = new ResourceType("AWS::EC2::VPCPeeringConnection"), ResourceType.EC2_REGISTERED_HA_INSTANCE = new ResourceType("AWS::EC2::RegisteredHAInstance"), ResourceType.EC2_LAUNCH_TEMPLATE = new ResourceType("AWS::EC2::LaunchTemplate"), ResourceType.EC2_NETWORK_INSIGHTS_ACCESS_SCOPE_ANALYSIS = new ResourceType("AWS::EC2::NetworkInsightsAccessScopeAnalysis"), ResourceType.IMAGEBUILDER_CONTAINER_RECIPE = new ResourceType("AWS::ImageBuilder::ContainerRecipe"), ResourceType.IMAGEBUILDER_DISTRIBUTION_CONFIGURATION = new ResourceType("AWS::ImageBuilder::DistributionConfiguration"), ResourceType.IMAGEBUILDER_INFRASTRUCTURE_CONFIGURATION = new ResourceType("AWS::ImageBuilder::InfrastructureConfiguration"), ResourceType.ECR_REPOSITORY = new ResourceType("AWS::ECR::Repository"), ResourceType.ECR_REGISTRY_POLICY = new ResourceType("AWS::ECR::RegistryPolicy"), ResourceType.ECR_PUBLIC_REPOSITORY = new ResourceType("AWS::ECR::PublicRepository"), ResourceType.ECS_CLUSTER = new ResourceType("AWS::ECS::Cluster"), ResourceType.ECS_TASK_DEFINITION = new ResourceType("AWS::ECS::TaskDefinition"), ResourceType.ECS_SERVICE = new ResourceType("AWS::ECS::Service"), ResourceType.EFS_FILE_SYSTEM = new ResourceType("AWS::EFS::FileSystem"), ResourceType.EFS_ACCESS_POINT = new ResourceType("AWS::EFS::AccessPoint"), ResourceType.EKS_CLUSTER = new ResourceType("AWS::EKS::Cluster"), ResourceType.EKS_IDENTITY_PROVIDER_CONFIG = new ResourceType("AWS::EKS::IdentityProviderConfig"), ResourceType.EKS_ADDON = new ResourceType("AWS::EKS::Addon"), ResourceType.EMR_SECURITY_CONFIGURATION = new ResourceType("AWS::EMR::SecurityConfiguration"), ResourceType.EVENTBRIDGE_EVENTBUS = new ResourceType("AWS::Events::EventBus"), ResourceType.EVENTBRIDGE_API_DESTINATION = new ResourceType("AWS::Events::ApiDestination"), ResourceType.EVENTBRIDGE_ARCHIVE = new ResourceType("AWS::Events::Archive"), ResourceType.EVENTBRIDGE_ENDPOINT = new ResourceType("AWS::Events::Endpoint"), ResourceType.EVENTSCHEMAS_REGISTRY = new ResourceType("AWS::EventSchemas::Registry"), ResourceType.EVENTSCHEMAS_REGISTRY_POLICY = new ResourceType("AWS::EventSchemas::RegistryPolicy"), ResourceType.EVENTSCHEMAS_DISCOVERER = new ResourceType("AWS::EventSchemas::Discoverer"), ResourceType.FRAUDDETECTOR_LABEL = new ResourceType("AWS::FraudDetector::Label"), ResourceType.FRAUDDETECTOR_ENTITY_TYPE = new ResourceType("AWS::FraudDetector::EntityType"), ResourceType.FRAUDDETECTOR_VARIABLE = new ResourceType("AWS::FraudDetector::Variable"), ResourceType.FRAUDDETECTOR_OUTCOME = new ResourceType("AWS::FraudDetector::Outcome"), ResourceType.GUARDDUTY_DETECTOR = new ResourceType("AWS::GuardDuty::Detector"), ResourceType.GUARDDUTY_THREAT_INTEL_SET = new ResourceType("AWS::GuardDuty::ThreatIntelSet"), ResourceType.GUARDDUTY_IP_SET = new ResourceType(" AWS::GuardDuty::IPSet"), ResourceType.GUARDDUTY_FILTER = new ResourceType("AWS::GuardDuty::Filter"), ResourceType.ELASTICSEARCH_DOMAIN = new ResourceType("AWS::Elasticsearch::Domain"), ResourceType.IVS_CHANNEL = new ResourceType("AWS::IVS::Channel"), ResourceType.IVS_RECORDING_CONFIGURATION = new ResourceType("AWS::IVS::RecordingConfiguration"), ResourceType.IVS_PLAYBACK_KEYPAIR = new ResourceType("AWS::IVS::PlaybackKeyPair"), ResourceType.OPENSEARCH_DOMAIN = new ResourceType("AWS::OpenSearch::Domain"), ResourceType.QLDB_LEDGER = new ResourceType("AWS::QLDB::Ledger"), ResourceType.KINESIS_STREAM = new ResourceType("AWS::Kinesis::Stream"), ResourceType.KINESIS_STREAM_CONSUMER = new ResourceType("AWS::Kinesis::StreamConsumer"), ResourceType.KINESIS_ANALYTICS_V2_APPLICATION = new ResourceType("AWS::KinesisAnalyticsV2::Application"), ResourceType.LIGHTSAIL_CERTIFICATE = new ResourceType("AWS::Lightsail::Certificate"), ResourceType.LIGHTSAIL_DISK = new ResourceType("AWS::Lightsail::Disk"), ResourceType.LIGHTSAIL_BUCKET = new ResourceType("AWS::Lightsail::Bucket"), ResourceType.LIGHTSAIL_STATIC_IP = new ResourceType("AWS::Lightsail::StaticIp"), ResourceType.AMAZON_MQ_BROKER = new ResourceType("AWS::AmazonMQ::Broker"), ResourceType.MSK_CLUSTER = new ResourceType("AWS::MSK::Cluster"), ResourceType.REDSHIFT_CLUSTER = new ResourceType("AWS::Redshift::Cluster"), ResourceType.REDSHIFT_CLUSTER_PARAMETER_GROUP = new ResourceType("AWS::Redshift::ClusterParameterGroup"), ResourceType.REDSHIFT_CLUSTER_SECURITY_GROUP = new ResourceType("AWS::Redshift::ClusterSecurityGroup"), ResourceType.REDSHIFT_CLUSTER_SNAPSHOT = new ResourceType("AWS::Redshift::ClusterSnapshot"), ResourceType.REDSHIFT_CLUSTER_SUBNET_GROUP = new ResourceType("AWS::Redshift::ClusterSubnetGroup"), ResourceType.REDSHIFT_EVENT_SUBSCRIPTION = new ResourceType("AWS::Redshift::EventSubscription"), ResourceType.RDS_DB_INSTANCE = new ResourceType("AWS::RDS::DBInstance"), ResourceType.RDS_DB_SECURITY_GROUP = new ResourceType("AWS::RDS::DBSecurityGroup"), ResourceType.RDS_DB_SNAPSHOT = new ResourceType("AWS::RDS::DBSnapshot"), ResourceType.RDS_DB_SUBNET_GROUP = new ResourceType("AWS::RDS::DBSubnetGroup"), ResourceType.RDS_EVENT_SUBSCRIPTION = new ResourceType("AWS::RDS::EventSubscription"), ResourceType.RDS_DB_CLUSTER = new ResourceType("AWS::RDS::DBCluster"), ResourceType.RDS_DB_CLUSTER_SNAPSHOT = new ResourceType("AWS::RDS::DBClusterSnapshot"), ResourceType.RDS_GLOBAL_CLUSTER = new ResourceType("AWS::RDS::GlobalCluster"), ResourceType.ROUTE53_HOSTED_ZONE = new ResourceType("AWS::Route53::HostedZone"), ResourceType.ROUTE53_HEALTH_CHECK = new ResourceType("AWS::Route53::HealthCheck"), ResourceType.ROUTE53_RESOLVER_RESOLVER_ENDPOINT = new ResourceType("AWS::Route53Resolver::ResolverEndpoint"), ResourceType.ROUTE53_RESOLVER_RESOLVER_RULE = new ResourceType("AWS::Route53Resolver::ResolverRule"), ResourceType.ROUTE53_RESOLVER_RESOLVER_RULE_ASSOCIATION = new ResourceType("AWS::Route53Resolver::ResolverRuleAssociation"), ResourceType.ROUTE53_RECOVERY_READINESS_CELL = new ResourceType("AWS::Route53RecoveryReadiness::Cell"), ResourceType.ROUTE53_RECOVERY_READINESS_READINESS_CHECK = new ResourceType("AWS::Route53RecoveryReadiness::ReadinessCheck"), ResourceType.ROUTE53_RECOVERY_READINESS_RECOVERY_GROUP = new ResourceType("AWS::Route53RecoveryReadiness::RecoveryGroup"), ResourceType.SQS_QUEUE = new ResourceType("AWS::SQS::Queue"), ResourceType.SNS_TOPIC = new ResourceType("AWS::SNS::Topic"), ResourceType.S3_BUCKET = new ResourceType("AWS::S3::Bucket"), ResourceType.S3_MULTIREGION_ACCESS_POINT = new ResourceType("AWS::S3::MultiRegionAccessPoint"), ResourceType.SAGEMAKER_CODE_REPOSITORY = new ResourceType("AWS::SageMaker::CodeRepository"), ResourceType.SAGEMAKER_MODEL = new ResourceType("AWS::SageMaker::Model"), ResourceType.SAGEMAKER_NOTEBOOK_INSTANCE = new ResourceType("AWS::SageMaker::NotebookInstance"), ResourceType.SAGEMAKER_WORKTEAM = new ResourceType("AWS::SageMaker::Workteam"), ResourceType.SES_CONFIGURATION_SET = new ResourceType("AWS::SES::ConfigurationSet"), ResourceType.SES_CONTACT_LIST = new ResourceType("AWS::SES::ContactList"), ResourceType.SES_TEMPLATE = new ResourceType("AWS::SES::Template"), ResourceType.SES_RECEIPT_FILTER = new ResourceType("AWS::SES::ReceiptFilter"), ResourceType.SES_RECEIPT_RECEIPT_RULE_SET = new ResourceType("AWS::SES::ReceiptRuleSet"), ResourceType.S3_ACCOUNT_PUBLIC_ACCESS_BLOCK = new ResourceType("AWS::S3::AccountPublicAccessBlock"), ResourceType.EC2_CUSTOMER_GATEWAY = new ResourceType("AWS::EC2::CustomerGateway"), ResourceType.EC2_INTERNET_GATEWAY = new ResourceType("AWS::EC2::InternetGateway"), ResourceType.EC2_NETWORK_ACL = new ResourceType("AWS::EC2::NetworkAcl"), ResourceType.EC2_ROUTE_TABLE = new ResourceType("AWS::EC2::RouteTable"), ResourceType.EC2_SUBNET = new ResourceType("AWS::EC2::Subnet"), ResourceType.EC2_VPC = new ResourceType("AWS::EC2::VPC"), ResourceType.EC2_VPN_CONNECTION = new ResourceType("AWS::EC2::VPNConnection"), ResourceType.EC2_VPN_GATEWAY = new ResourceType("AWS::EC2::VPNGateway"), ResourceType.AUTO_SCALING_GROUP = new ResourceType("AWS::AutoScaling::AutoScalingGroup"), ResourceType.AUTO_SCALING_LAUNCH_CONFIGURATION = new ResourceType("AWS::AutoScaling::LaunchConfiguration"), ResourceType.AUTO_SCALING_POLICY = new ResourceType("AWS::AutoScaling::ScalingPolicy"), ResourceType.AUTO_SCALING_SCHEDULED_ACTION = new ResourceType("AWS::AutoScaling::ScheduledAction"), ResourceType.WORKSPACES_CONNECTION_ALIAS = new ResourceType("AWS::WorkSpaces::ConnectionAlias"), ResourceType.WORKSPACES_WORKSPACE = new ResourceType("AWS::WorkSpaces::Workspace"), ResourceType.APPCONFIG_APPLICATION = new ResourceType("AWS::AppConfig::Application"), ResourceType.APPCONFIG_ENVIRONMENT = new ResourceType("AWS::AppConfig::Environment"), ResourceType.APPCONFIG_CONFIGURATION_PROFILE = new ResourceType("AWS::AppConfig::ConfigurationProfile"), ResourceType.APPSYNC_GRAPHQL_API = new ResourceType("AWS::AppSync::GraphQLApi"), ResourceType.BACKUP_BACKUP_PLAN = new ResourceType("AWS::Backup::BackupPlan"), ResourceType.BACKUP_BACKUP_SELECTION = new ResourceType("AWS::Backup::BackupSelection"), ResourceType.BACKUP_BACKUP_VAULT = new ResourceType("AWS::Backup::BackupVault"), ResourceType.BACKUP_RECOVERY_POINT = new ResourceType("AWS::Backup::RecoveryPoint"), ResourceType.BACKUP_REPORT_PLAN = new ResourceType("AWS::Backup::ReportPlan"), ResourceType.BATCH_JOB_QUEUE = new ResourceType("AWS::Batch::JobQueue"), ResourceType.BATCH_COMPUTE_ENVIRONMENT = new ResourceType("AWS::Batch::ComputeEnvironment"), ResourceType.ACM_CERTIFICATE = new ResourceType("AWS::ACM::Certificate"), ResourceType.CLOUDFORMATION_STACK = new ResourceType("AWS::CloudFormation::Stack"), ResourceType.CLOUDTRAIL_TRAIL = new ResourceType("AWS::CloudTrail::Trail"), ResourceType.CLOUD9_ENVIRONMENT_EC2 = new ResourceType("AWS::Cloud9::EnvironmentEC2"), ResourceType.SERVICEDISCOVERY_SERVICE = new ResourceType("AWS::ServiceDiscovery::Service"), ResourceType.SERVICEDISCOVERY_PUBLIC_DNS_NAMESPACE = new ResourceType("AWS::ServiceDiscovery::PublicDnsNamespace"), ResourceType.SERVICEDISCOVERY_HTTP_NAMESPACE = new ResourceType("AWS::ServiceDiscovery::HttpNamespace"), ResourceType.CODEBUILD_PROJECT = new ResourceType("AWS::CodeBuild::Project"), ResourceType.CODEDEPLOY_APPLICATION = new ResourceType("AWS::CodeDeploy::Application"), ResourceType.CODEDEPLOY_DEPLOYMENT_CONFIG = new ResourceType("AWS::CodeDeploy::DeploymentConfig"), ResourceType.CODEDEPLOY_DEPLOYMENT_GROUP = new ResourceType("AWS::CodeDeploy::DeploymentGroup"), ResourceType.CODEPIPELINE_PIPELINE = new ResourceType("AWS::CodePipeline::Pipeline"), ResourceType.CONFIG_RESOURCE_COMPLIANCE = new ResourceType("AWS::Config::ResourceCompliance"), ResourceType.CONFIG_CONFORMANCE_PACK_COMPLIANCE = new ResourceType("AWS::Config::ConformancePackCompliance"), ResourceType.DMS_EVENT_SUBSCRIPTION = new ResourceType("AWS::DMS::EventSubscription"), ResourceType.DMS_REPLICATION_SUBNET_GROUP = new ResourceType("AWS::DMS::ReplicationSubnetGroup"), ResourceType.DATASYNC_LOCATION_SMB = new ResourceType("AWS::DataSync::LocationSMB"), ResourceType.DATASYNC_LOCATION_FSX_LUSTRE = new ResourceType("AWS::DataSync::LocationFSxLustre"), ResourceType.DATASYNC_LOCATION_FSX_WINDOWS = new ResourceType("AWS::DataSync::LocationFSxWindows"), ResourceType.DATASYNC_LOCATION_S3 = new ResourceType("AWS::DataSync::LocationS3"), ResourceType.DATASYNC_LOCATION_EFS = new ResourceType("AWS::DataSync::LocationEFS"), ResourceType.DATASYNC_TASK = new ResourceType("AWS::DataSync::Task"), ResourceType.DATASYNC_LOCATION_NFS = new ResourceType("AWS::DataSync::LocationNFS"), ResourceType.DATASYNC_LOCATION_OBJECT_STORAGE = new ResourceType("AWS::DataSync::LocationObjectStorage"), ResourceType.DATASYNC_LOCATION_HDFS = new ResourceType("AWS::DataSync::LocationHDFS"), ResourceType.ELASTIC_BEANSTALK_APPLICATION = new ResourceType("AWS::ElasticBeanstalk::Application"), ResourceType.ELASTIC_BEANSTALK_APPLICATION_VERSION = new ResourceType("AWS::ElasticBeanstalk::ApplicationVersion"), ResourceType.ELASTIC_BEANSTALK_ENVIRONMENT = new ResourceType("AWS::ElasticBeanstalk::Environment"), ResourceType.FIS_EXPERIMENT_TEMPLATE = new ResourceType("AWS::FIS::ExperimentTemplate"), ResourceType.GLOBALACCELERATOR_LISTENER = new ResourceType("AWS::GlobalAccelerator::Listener"), ResourceType.GLOBALACCELERATOR_ENDPOINT_GROUP = new ResourceType("AWS::GlobalAccelerator::EndpointGroup"), ResourceType.GLOBALACCELERATOR_ACCELERATOR = new ResourceType("AWS::GlobalAccelerator::Accelerator"), ResourceType.GLUE_JOB = new ResourceType("AWS::Glue::Job"), ResourceType.GLUE_CLASSIFIER = new ResourceType("AWS::Glue::Classifier"), ResourceType.GLUE_ML_TRANSFORM = new ResourceType("AWS::Glue::MLTransform"), ResourceType.IAM_USER = new ResourceType("AWS::IAM::User"), ResourceType.IAM_GROUP = new ResourceType("AWS::IAM::Group"), ResourceType.IAM_ROLE = new ResourceType("AWS::IAM::Role"), ResourceType.IAM_POLICY = new ResourceType("AWS::IAM::Policy"), ResourceType.IAM_ACCESSANALYZER_ANALYZER = new ResourceType("AWS::AccessAnalyzer::Analyzer"), ResourceType.IOT_AUTHORIZER = new ResourceType("AWS::IoT::Authorizer"), ResourceType.IOT_SECURITY_PROFILE = new ResourceType("AWS::IoT::SecurityProfile"), ResourceType.IOT_ROLE_ALIAS = new ResourceType("AWS::IoT::RoleAlias"), ResourceType.IOT_DIMENSION = new ResourceType("AWS::IoT::Dimension"), ResourceType.IOT_POLICY = new ResourceType("AWS::IoT::Policy"), ResourceType.IOT_MITIGATION_ACTION = new ResourceType("AWS::IoT::MitigationAction"), ResourceType.IOT_TWINMAKER_WORKSPACE = new ResourceType("AWS::IoTwinMaker::Workspace"), ResourceType.IOT_TWINMAKER_ENTITY = new ResourceType("AWS::IoTTwinMaker::Entity"), ResourceType.IOT_ANALYTICS_DATASTORE = new ResourceType("AWS::IoTAnalytics::Datastore"), ResourceType.IOT_ANALYTICS_DATASET = new ResourceType("AWS::IoTAnalytics::Dataset"), ResourceType.IOT_ANALYTICS_PIPELINE = new ResourceType("AWS::IoTAnalytics::Pipeline"), ResourceType.IOT_ANALYTICS_CHANNEL = new ResourceType("AWS::IoTAnalytics::Channel"), ResourceType.IOT_EVENTS_INPUT = new ResourceType("AWS::IoTEvents::Input"), ResourceType.IOT_EVENTS_DETECTOR_MODEL = new ResourceType("AWS::IoTEvents::DetectorModel"), ResourceType.IOT_EVENTS_ALARM_MODEL = new ResourceType("AWS::IoTEvents::AlarmModel"), ResourceType.IOT_SITEWISE_DASHBOARD = new ResourceType("AWS::IoTSiteWise::Dashboard"), ResourceType.IOT_SITEWISE_PROJECT = new ResourceType("AWS::IoTSiteWise::Project"), ResourceType.IOT_SITEWISE_PORTAL = new ResourceType("AWS::IoTSiteWise::Portal"), ResourceType.IOT_SITEWISE_ASSETMODEL = new ResourceType("AWS::IoTSiteWise::AssetModel"), ResourceType.KMS_KEY = new ResourceType("AWS::KMS::Key"), ResourceType.LAMBDA_FUNCTION = new ResourceType("AWS::Lambda::Function"), ResourceType.NETWORK_FIREWALL_FIREWALL = new ResourceType("AWS::NetworkFirewall::Firewall"), ResourceType.NETWORK_FIREWALL_FIREWALL_POLICY = new ResourceType("AWS::NetworkFirewall::FirewallPolicy"), ResourceType.NETWORK_FIREWALL_RULE_GROUP = new ResourceType("AWS::NetworkFirewall::RuleGroup"), ResourceType.RESILIENCEHUB_RESILIENCY_POLICY = new ResourceType("AWS::ResilienceHub::ResiliencyPolicy"), ResourceType.SECRETS_MANAGER_SECRET = new ResourceType("AWS::SecretsManager::Secret"), ResourceType.SERVICE_CATALOG_CLOUDFORMATION_PRODUCT = new ResourceType("AWS::ServiceCatalog::CloudFormationProduct"), ResourceType.SERVICE_CATALOG_CLOUDFORMATION_PROVISIONED_PRODUCT = new ResourceType("AWS::ServiceCatalog::CloudFormationProvisionedProduct"), ResourceType.SERVICE_CATALOG_PORTFOLIO = new ResourceType("AWS::ServiceCatalog::Portfolio"), ResourceType.SHIELD_PROTECTION = new ResourceType("AWS::Shield::Protection"), ResourceType.SHIELD_REGIONAL_PROTECTION = new ResourceType("AWS::ShieldRegional::Protection"), ResourceType.STEPFUNCTIONS_ACTIVITY = new ResourceType("AWS::StepFunctions::Activity"), ResourceType.STEPFUNCTIONS_STATE_MACHINE = new ResourceType("AWS::StepFunctions::StateMachine"), ResourceType.SYSTEMS_MANAGER_MANAGED_INSTANCE_INVENTORY = new ResourceType("AWS::SSM::ManagedInstanceInventory"), ResourceType.SYSTEMS_MANAGER_PATCH_COMPLIANCE = new ResourceType("AWS::SSM::PatchCompliance"), ResourceType.SYSTEMS_MANAGER_ASSOCIATION_COMPLIANCE = new ResourceType("AWS::SSM::AssociationCompliance"), ResourceType.SYSTEMS_MANAGER_FILE_DATA = new ResourceType("AWS::SSM::FileData"), ResourceType.TRANSFER_WORKFLOW = new ResourceType("AWS::Transfer::Workflow"), ResourceType.WAF_RATE_BASED_RULE = new ResourceType("AWS::WAF::RateBasedRule"), ResourceType.WAF_RULE = new ResourceType("AWS::WAF::Rule"), ResourceType.WAF_WEB_ACL = new ResourceType("AWS::WAF::WebACL"), ResourceType.WAF_RULE_GROUP = new ResourceType("AWS::WAF::RuleGroup"), ResourceType.WAF_REGIONAL_RATE_BASED_RULE = new ResourceType("AWS::WAFRegional::RateBasedRule"), ResourceType.WAF_REGIONAL_RULE = new ResourceType("AWS::WAFRegional::Rule"), ResourceType.WAF_REGIONAL_WEB_ACL = new ResourceType("AWS::WAFRegional::WebACL"), ResourceType.WAF_REGIONAL_RULE_GROUP = new ResourceType("AWS::WAFRegional::RuleGroup"), ResourceType.WAFV2_WEB_ACL = new ResourceType("AWS::WAFv2::WebACL"), ResourceType.WAFV2_RULE_GROUP = new ResourceType("AWS::WAFv2::RuleGroup"), ResourceType.WAFV2_MANAGED_RULE_SET = new ResourceType("AWS::WAFv2::ManagedRuleSet"), ResourceType.WAFV2_IP_SET = new ResourceType("AWS::WAFv2::IPSet"), ResourceType.WAFV2_REGEX_PATTERN_SET = new ResourceType("AWS::WAFv2::RegexPatternSet"), ResourceType.XRAY_ENCRYPTION_CONFIGURATION = new ResourceType("AWS::XRay::EncryptionConfig"), ResourceType.ELB_LOAD_BALANCER = new ResourceType("AWS::ElasticLoadBalancing::LoadBalancer"), ResourceType.ELBV2_LOAD_BALANCER = new ResourceType("AWS::ElasticLoadBalancingV2::LoadBalancer"), ResourceType.ELBV2_LISTENER = new ResourceType("AWS::ElasticLoadBalancingV2::Listener"), ResourceType.MEDIAPACKAGE_PACKAGING_GROUP = new ResourceType("AWS::MediaPackage::PackagingGroup"), exports2.ResourceType = ResourceType;
    function renderScope(ruleScope) {
      return ruleScope ? { complianceResourceId: ruleScope.resourceId, complianceResourceTypes: ruleScope.resourceTypes?.map((resource) => resource.complianceResourceType), tagKey: ruleScope.key, tagValue: ruleScope.value } : void 0;
    }
  }
});

// node_modules/aws-cdk-lib/aws-config/lib/managed-rules.js
var require_managed_rules = __commonJS({
  "node_modules/aws-cdk-lib/aws-config/lib/managed-rules.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CloudFormationStackNotificationCheck = exports2.CloudFormationStackDriftDetectionCheck = exports2.AccessKeysRotated = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var rule_1 = require_rule4();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var AccessKeysRotated = class _AccessKeysRotated extends rule_1.ManagedRule {
      constructor(scope, id, props = {}) {
        super(scope, id, { ...props, identifier: rule_1.ManagedRuleIdentifiers.ACCESS_KEYS_ROTATED, inputParameters: { ...props.maxAge ? { maxAccessKeyAge: props.maxAge.toDays() } : {} } });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_config_AccessKeysRotatedProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AccessKeysRotated), error;
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AccessKeysRotated[_a] = { fqn: "aws-cdk-lib.aws_config.AccessKeysRotated", version: "2.80.0" }, exports2.AccessKeysRotated = AccessKeysRotated;
    var CloudFormationStackDriftDetectionCheck = class _CloudFormationStackDriftDetectionCheck extends rule_1.ManagedRule {
      constructor(scope, id, props = {}) {
        super(scope, id, { ...props, identifier: rule_1.ManagedRuleIdentifiers.CLOUDFORMATION_STACK_DRIFT_DETECTION_CHECK, inputParameters: { cloudformationRoleArn: core_1.Lazy.string({ produce: () => this.role.roleArn }) } });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_config_CloudFormationStackDriftDetectionCheckProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CloudFormationStackDriftDetectionCheck), error;
        }
        this.ruleScope = rule_1.RuleScope.fromResource(rule_1.ResourceType.CLOUDFORMATION_STACK, props.ownStackOnly ? core_1.Stack.of(this).stackId : void 0), this.role = props.role || new iam.Role(this, "Role", { assumedBy: new iam.ServicePrincipal("config.amazonaws.com"), managedPolicies: [iam.ManagedPolicy.fromAwsManagedPolicyName("ReadOnlyAccess")] });
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CloudFormationStackDriftDetectionCheck[_b] = { fqn: "aws-cdk-lib.aws_config.CloudFormationStackDriftDetectionCheck", version: "2.80.0" }, exports2.CloudFormationStackDriftDetectionCheck = CloudFormationStackDriftDetectionCheck;
    var CloudFormationStackNotificationCheck = class _CloudFormationStackNotificationCheck extends rule_1.ManagedRule {
      constructor(scope, id, props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_config_CloudFormationStackNotificationCheckProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CloudFormationStackNotificationCheck), error;
        }
        if (props.topics && props.topics.length > 5)
          throw new Error("At most 5 topics can be specified.");
        super(scope, id, { ...props, identifier: rule_1.ManagedRuleIdentifiers.CLOUDFORMATION_STACK_NOTIFICATION_CHECK, inputParameters: props.topics && props.topics.reduce((params, topic, idx) => ({ ...params, [`snsTopic${idx + 1}`]: topic.topicArn }), {}), ruleScope: rule_1.RuleScope.fromResources([rule_1.ResourceType.CLOUDFORMATION_STACK]) });
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CloudFormationStackNotificationCheck[_c] = { fqn: "aws-cdk-lib.aws_config.CloudFormationStackNotificationCheck", version: "2.80.0" }, exports2.CloudFormationStackNotificationCheck = CloudFormationStackNotificationCheck;
  }
});

// node_modules/aws-cdk-lib/aws-config/lib/index.js
var require_lib90 = __commonJS({
  "node_modules/aws-cdk-lib/aws-config/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_rule4(), exports2), __exportStar(require_managed_rules(), exports2), __exportStar(require_config_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-config/index.js
var require_aws_config = __commonJS({
  "node_modules/aws-cdk-lib/aws-config/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib90(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-connect/lib/connect.generated.js
var require_connect_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-connect/lib/connect.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    var _l;
    var _m;
    var _o;
    var _p;
    var _q;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnUserHierarchyGroup = exports2.CfnUser = exports2.CfnTaskTemplate = exports2.CfnSecurityKey = exports2.CfnRule = exports2.CfnQuickConnect = exports2.CfnPhoneNumber = exports2.CfnIntegrationAssociation = exports2.CfnInstanceStorageConfig = exports2.CfnInstance = exports2.CfnHoursOfOperation = exports2.CfnEvaluationForm = exports2.CfnContactFlowModule = exports2.CfnContactFlow = exports2.CfnApprovedOrigin = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnApprovedOriginPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceId", cdk.requiredValidator)(properties.instanceId)), errors.collect(cdk.propertyValidator("instanceId", cdk.validateString)(properties.instanceId)), errors.collect(cdk.propertyValidator("origin", cdk.requiredValidator)(properties.origin)), errors.collect(cdk.propertyValidator("origin", cdk.validateString)(properties.origin)), errors.wrap('supplied properties not correct for "CfnApprovedOriginProps"');
    }
    function cfnApprovedOriginPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApprovedOriginPropsValidator(properties).assertSuccess(), { InstanceId: cdk.stringToCloudFormation(properties.instanceId), Origin: cdk.stringToCloudFormation(properties.origin) }) : properties;
    }
    function CfnApprovedOriginPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceId", "InstanceId", cfn_parse.FromCloudFormation.getString(properties.InstanceId)), ret.addPropertyResult("origin", "Origin", cfn_parse.FromCloudFormation.getString(properties.Origin)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApprovedOrigin = class _CfnApprovedOrigin extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApprovedOriginPropsFromCloudFormation(resourceProperties), ret = new _CfnApprovedOrigin(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApprovedOrigin.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_connect_CfnApprovedOriginProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApprovedOrigin), error;
        }
        cdk.requireProperty(props, "instanceId", this), cdk.requireProperty(props, "origin", this), this.instanceId = props.instanceId, this.origin = props.origin;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApprovedOrigin.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { instanceId: this.instanceId, origin: this.origin };
      }
      renderProperties(props) {
        return cfnApprovedOriginPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnApprovedOrigin[_a] = { fqn: "aws-cdk-lib.aws_connect.CfnApprovedOrigin", version: "2.80.0" }, CfnApprovedOrigin.CFN_RESOURCE_TYPE_NAME = "AWS::Connect::ApprovedOrigin", exports2.CfnApprovedOrigin = CfnApprovedOrigin;
    function CfnContactFlowPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("content", cdk.requiredValidator)(properties.content)), errors.collect(cdk.propertyValidator("content", cdk.validateString)(properties.content)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("instanceArn", cdk.requiredValidator)(properties.instanceArn)), errors.collect(cdk.propertyValidator("instanceArn", cdk.validateString)(properties.instanceArn)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("state", cdk.validateString)(properties.state)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnContactFlowProps"');
    }
    function cfnContactFlowPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContactFlowPropsValidator(properties).assertSuccess(), { Content: cdk.stringToCloudFormation(properties.content), InstanceArn: cdk.stringToCloudFormation(properties.instanceArn), Name: cdk.stringToCloudFormation(properties.name), Type: cdk.stringToCloudFormation(properties.type), Description: cdk.stringToCloudFormation(properties.description), State: cdk.stringToCloudFormation(properties.state), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnContactFlowPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("content", "Content", cfn_parse.FromCloudFormation.getString(properties.Content)), ret.addPropertyResult("instanceArn", "InstanceArn", cfn_parse.FromCloudFormation.getString(properties.InstanceArn)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("state", "State", properties.State != null ? cfn_parse.FromCloudFormation.getString(properties.State) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnContactFlow = class _CfnContactFlow extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnContactFlowPropsFromCloudFormation(resourceProperties), ret = new _CfnContactFlow(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnContactFlow.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_connect_CfnContactFlowProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnContactFlow), error;
        }
        cdk.requireProperty(props, "content", this), cdk.requireProperty(props, "instanceArn", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "type", this), this.attrContactFlowArn = cdk.Token.asString(this.getAtt("ContactFlowArn", cdk.ResolutionTypeHint.STRING)), this.content = props.content, this.instanceArn = props.instanceArn, this.name = props.name, this.type = props.type, this.description = props.description, this.state = props.state, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Connect::ContactFlow", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnContactFlow.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { content: this.content, instanceArn: this.instanceArn, name: this.name, type: this.type, description: this.description, state: this.state, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnContactFlowPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnContactFlow[_b] = { fqn: "aws-cdk-lib.aws_connect.CfnContactFlow", version: "2.80.0" }, CfnContactFlow.CFN_RESOURCE_TYPE_NAME = "AWS::Connect::ContactFlow", exports2.CfnContactFlow = CfnContactFlow;
    function CfnContactFlowModulePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("content", cdk.requiredValidator)(properties.content)), errors.collect(cdk.propertyValidator("content", cdk.validateString)(properties.content)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("instanceArn", cdk.requiredValidator)(properties.instanceArn)), errors.collect(cdk.propertyValidator("instanceArn", cdk.validateString)(properties.instanceArn)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("state", cdk.validateString)(properties.state)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnContactFlowModuleProps"');
    }
    function cfnContactFlowModulePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContactFlowModulePropsValidator(properties).assertSuccess(), { Content: cdk.stringToCloudFormation(properties.content), InstanceArn: cdk.stringToCloudFormation(properties.instanceArn), Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), State: cdk.stringToCloudFormation(properties.state), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnContactFlowModulePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("content", "Content", cfn_parse.FromCloudFormation.getString(properties.Content)), ret.addPropertyResult("instanceArn", "InstanceArn", cfn_parse.FromCloudFormation.getString(properties.InstanceArn)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("state", "State", properties.State != null ? cfn_parse.FromCloudFormation.getString(properties.State) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnContactFlowModule = class _CfnContactFlowModule extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnContactFlowModulePropsFromCloudFormation(resourceProperties), ret = new _CfnContactFlowModule(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnContactFlowModule.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_connect_CfnContactFlowModuleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnContactFlowModule), error;
        }
        cdk.requireProperty(props, "content", this), cdk.requireProperty(props, "instanceArn", this), cdk.requireProperty(props, "name", this), this.attrContactFlowModuleArn = cdk.Token.asString(this.getAtt("ContactFlowModuleArn", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.content = props.content, this.instanceArn = props.instanceArn, this.name = props.name, this.description = props.description, this.state = props.state, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Connect::ContactFlowModule", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnContactFlowModule.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { content: this.content, instanceArn: this.instanceArn, name: this.name, description: this.description, state: this.state, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnContactFlowModulePropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnContactFlowModule[_c] = { fqn: "aws-cdk-lib.aws_connect.CfnContactFlowModule", version: "2.80.0" }, CfnContactFlowModule.CFN_RESOURCE_TYPE_NAME = "AWS::Connect::ContactFlowModule", exports2.CfnContactFlowModule = CfnContactFlowModule;
    function CfnEvaluationFormPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("instanceArn", cdk.requiredValidator)(properties.instanceArn)), errors.collect(cdk.propertyValidator("instanceArn", cdk.validateString)(properties.instanceArn)), errors.collect(cdk.propertyValidator("items", cdk.requiredValidator)(properties.items)), errors.collect(cdk.propertyValidator("items", cdk.listValidator(CfnEvaluationForm_EvaluationFormBaseItemPropertyValidator))(properties.items)), errors.collect(cdk.propertyValidator("scoringStrategy", CfnEvaluationForm_ScoringStrategyPropertyValidator)(properties.scoringStrategy)), errors.collect(cdk.propertyValidator("status", cdk.requiredValidator)(properties.status)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.wrap('supplied properties not correct for "CfnEvaluationFormProps"');
    }
    function cfnEvaluationFormPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEvaluationFormPropsValidator(properties).assertSuccess(), { InstanceArn: cdk.stringToCloudFormation(properties.instanceArn), Items: cdk.listMapper(cfnEvaluationFormEvaluationFormBaseItemPropertyToCloudFormation)(properties.items), Status: cdk.stringToCloudFormation(properties.status), Title: cdk.stringToCloudFormation(properties.title), Description: cdk.stringToCloudFormation(properties.description), ScoringStrategy: cfnEvaluationFormScoringStrategyPropertyToCloudFormation(properties.scoringStrategy), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnEvaluationFormPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceArn", "InstanceArn", cfn_parse.FromCloudFormation.getString(properties.InstanceArn)), ret.addPropertyResult("items", "Items", cfn_parse.FromCloudFormation.getArray(CfnEvaluationFormEvaluationFormBaseItemPropertyFromCloudFormation)(properties.Items)), ret.addPropertyResult("status", "Status", cfn_parse.FromCloudFormation.getString(properties.Status)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("scoringStrategy", "ScoringStrategy", properties.ScoringStrategy != null ? CfnEvaluationFormScoringStrategyPropertyFromCloudFormation(properties.ScoringStrategy) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEvaluationForm = class _CfnEvaluationForm extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEvaluationFormPropsFromCloudFormation(resourceProperties), ret = new _CfnEvaluationForm(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEvaluationForm.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_connect_CfnEvaluationFormProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEvaluationForm), error;
        }
        cdk.requireProperty(props, "instanceArn", this), cdk.requireProperty(props, "items", this), cdk.requireProperty(props, "status", this), cdk.requireProperty(props, "title", this), this.attrEvaluationFormArn = cdk.Token.asString(this.getAtt("EvaluationFormArn", cdk.ResolutionTypeHint.STRING)), this.instanceArn = props.instanceArn, this.items = props.items, this.status = props.status, this.title = props.title, this.description = props.description, this.scoringStrategy = props.scoringStrategy, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Connect::EvaluationForm", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEvaluationForm.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { instanceArn: this.instanceArn, items: this.items, status: this.status, title: this.title, description: this.description, scoringStrategy: this.scoringStrategy, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnEvaluationFormPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnEvaluationForm[_d] = { fqn: "aws-cdk-lib.aws_connect.CfnEvaluationForm", version: "2.80.0" }, CfnEvaluationForm.CFN_RESOURCE_TYPE_NAME = "AWS::Connect::EvaluationForm", exports2.CfnEvaluationForm = CfnEvaluationForm;
    function CfnEvaluationForm_EvaluationFormBaseItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("section", cdk.requiredValidator)(properties.section)), errors.collect(cdk.propertyValidator("section", CfnEvaluationForm_EvaluationFormSectionPropertyValidator)(properties.section)), errors.wrap('supplied properties not correct for "EvaluationFormBaseItemProperty"');
    }
    function cfnEvaluationFormEvaluationFormBaseItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEvaluationForm_EvaluationFormBaseItemPropertyValidator(properties).assertSuccess(), { Section: cfnEvaluationFormEvaluationFormSectionPropertyToCloudFormation(properties.section) }) : properties;
    }
    function CfnEvaluationFormEvaluationFormBaseItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("section", "Section", CfnEvaluationFormEvaluationFormSectionPropertyFromCloudFormation(properties.Section)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEvaluationForm_EvaluationFormItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("question", CfnEvaluationForm_EvaluationFormQuestionPropertyValidator)(properties.question)), errors.collect(cdk.propertyValidator("section", CfnEvaluationForm_EvaluationFormSectionPropertyValidator)(properties.section)), errors.wrap('supplied properties not correct for "EvaluationFormItemProperty"');
    }
    function cfnEvaluationFormEvaluationFormItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEvaluationForm_EvaluationFormItemPropertyValidator(properties).assertSuccess(), { Question: cfnEvaluationFormEvaluationFormQuestionPropertyToCloudFormation(properties.question), Section: cfnEvaluationFormEvaluationFormSectionPropertyToCloudFormation(properties.section) }) : properties;
    }
    function CfnEvaluationFormEvaluationFormItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("question", "Question", properties.Question != null ? CfnEvaluationFormEvaluationFormQuestionPropertyFromCloudFormation(properties.Question) : void 0), ret.addPropertyResult("section", "Section", properties.Section != null ? CfnEvaluationFormEvaluationFormSectionPropertyFromCloudFormation(properties.Section) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEvaluationForm_EvaluationFormNumericQuestionAutomationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("propertyValue", cdk.requiredValidator)(properties.propertyValue)), errors.collect(cdk.propertyValidator("propertyValue", CfnEvaluationForm_NumericQuestionPropertyValueAutomationPropertyValidator)(properties.propertyValue)), errors.wrap('supplied properties not correct for "EvaluationFormNumericQuestionAutomationProperty"');
    }
    function cfnEvaluationFormEvaluationFormNumericQuestionAutomationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEvaluationForm_EvaluationFormNumericQuestionAutomationPropertyValidator(properties).assertSuccess(), { PropertyValue: cfnEvaluationFormNumericQuestionPropertyValueAutomationPropertyToCloudFormation(properties.propertyValue) }) : properties;
    }
    function CfnEvaluationFormEvaluationFormNumericQuestionAutomationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("propertyValue", "PropertyValue", CfnEvaluationFormNumericQuestionPropertyValueAutomationPropertyFromCloudFormation(properties.PropertyValue)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEvaluationForm_EvaluationFormNumericQuestionOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("automaticFail", cdk.validateBoolean)(properties.automaticFail)), errors.collect(cdk.propertyValidator("maxValue", cdk.requiredValidator)(properties.maxValue)), errors.collect(cdk.propertyValidator("maxValue", cdk.validateNumber)(properties.maxValue)), errors.collect(cdk.propertyValidator("minValue", cdk.requiredValidator)(properties.minValue)), errors.collect(cdk.propertyValidator("minValue", cdk.validateNumber)(properties.minValue)), errors.collect(cdk.propertyValidator("score", cdk.validateNumber)(properties.score)), errors.wrap('supplied properties not correct for "EvaluationFormNumericQuestionOptionProperty"');
    }
    function cfnEvaluationFormEvaluationFormNumericQuestionOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEvaluationForm_EvaluationFormNumericQuestionOptionPropertyValidator(properties).assertSuccess(), { AutomaticFail: cdk.booleanToCloudFormation(properties.automaticFail), MaxValue: cdk.numberToCloudFormation(properties.maxValue), MinValue: cdk.numberToCloudFormation(properties.minValue), Score: cdk.numberToCloudFormation(properties.score) }) : properties;
    }
    function CfnEvaluationFormEvaluationFormNumericQuestionOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("automaticFail", "AutomaticFail", properties.AutomaticFail != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AutomaticFail) : void 0), ret.addPropertyResult("maxValue", "MaxValue", cfn_parse.FromCloudFormation.getNumber(properties.MaxValue)), ret.addPropertyResult("minValue", "MinValue", cfn_parse.FromCloudFormation.getNumber(properties.MinValue)), ret.addPropertyResult("score", "Score", properties.Score != null ? cfn_parse.FromCloudFormation.getNumber(properties.Score) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEvaluationForm_EvaluationFormNumericQuestionPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("automation", CfnEvaluationForm_EvaluationFormNumericQuestionAutomationPropertyValidator)(properties.automation)), errors.collect(cdk.propertyValidator("maxValue", cdk.requiredValidator)(properties.maxValue)), errors.collect(cdk.propertyValidator("maxValue", cdk.validateNumber)(properties.maxValue)), errors.collect(cdk.propertyValidator("minValue", cdk.requiredValidator)(properties.minValue)), errors.collect(cdk.propertyValidator("minValue", cdk.validateNumber)(properties.minValue)), errors.collect(cdk.propertyValidator("options", cdk.listValidator(CfnEvaluationForm_EvaluationFormNumericQuestionOptionPropertyValidator))(properties.options)), errors.wrap('supplied properties not correct for "EvaluationFormNumericQuestionPropertiesProperty"');
    }
    function cfnEvaluationFormEvaluationFormNumericQuestionPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEvaluationForm_EvaluationFormNumericQuestionPropertiesPropertyValidator(properties).assertSuccess(), { Automation: cfnEvaluationFormEvaluationFormNumericQuestionAutomationPropertyToCloudFormation(properties.automation), MaxValue: cdk.numberToCloudFormation(properties.maxValue), MinValue: cdk.numberToCloudFormation(properties.minValue), Options: cdk.listMapper(cfnEvaluationFormEvaluationFormNumericQuestionOptionPropertyToCloudFormation)(properties.options) }) : properties;
    }
    function CfnEvaluationFormEvaluationFormNumericQuestionPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("automation", "Automation", properties.Automation != null ? CfnEvaluationFormEvaluationFormNumericQuestionAutomationPropertyFromCloudFormation(properties.Automation) : void 0), ret.addPropertyResult("maxValue", "MaxValue", cfn_parse.FromCloudFormation.getNumber(properties.MaxValue)), ret.addPropertyResult("minValue", "MinValue", cfn_parse.FromCloudFormation.getNumber(properties.MinValue)), ret.addPropertyResult("options", "Options", properties.Options != null ? cfn_parse.FromCloudFormation.getArray(CfnEvaluationFormEvaluationFormNumericQuestionOptionPropertyFromCloudFormation)(properties.Options) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEvaluationForm_EvaluationFormQuestionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instructions", cdk.validateString)(properties.instructions)), errors.collect(cdk.propertyValidator("notApplicableEnabled", cdk.validateBoolean)(properties.notApplicableEnabled)), errors.collect(cdk.propertyValidator("questionType", cdk.requiredValidator)(properties.questionType)), errors.collect(cdk.propertyValidator("questionType", cdk.validateString)(properties.questionType)), errors.collect(cdk.propertyValidator("questionTypeProperties", CfnEvaluationForm_EvaluationFormQuestionTypePropertiesPropertyValidator)(properties.questionTypeProperties)), errors.collect(cdk.propertyValidator("refId", cdk.requiredValidator)(properties.refId)), errors.collect(cdk.propertyValidator("refId", cdk.validateString)(properties.refId)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.collect(cdk.propertyValidator("weight", cdk.validateNumber)(properties.weight)), errors.wrap('supplied properties not correct for "EvaluationFormQuestionProperty"');
    }
    function cfnEvaluationFormEvaluationFormQuestionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEvaluationForm_EvaluationFormQuestionPropertyValidator(properties).assertSuccess(), { Instructions: cdk.stringToCloudFormation(properties.instructions), NotApplicableEnabled: cdk.booleanToCloudFormation(properties.notApplicableEnabled), QuestionType: cdk.stringToCloudFormation(properties.questionType), QuestionTypeProperties: cfnEvaluationFormEvaluationFormQuestionTypePropertiesPropertyToCloudFormation(properties.questionTypeProperties), RefId: cdk.stringToCloudFormation(properties.refId), Title: cdk.stringToCloudFormation(properties.title), Weight: cdk.numberToCloudFormation(properties.weight) }) : properties;
    }
    function CfnEvaluationFormEvaluationFormQuestionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instructions", "Instructions", properties.Instructions != null ? cfn_parse.FromCloudFormation.getString(properties.Instructions) : void 0), ret.addPropertyResult("notApplicableEnabled", "NotApplicableEnabled", properties.NotApplicableEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.NotApplicableEnabled) : void 0), ret.addPropertyResult("questionType", "QuestionType", cfn_parse.FromCloudFormation.getString(properties.QuestionType)), ret.addPropertyResult("questionTypeProperties", "QuestionTypeProperties", properties.QuestionTypeProperties != null ? CfnEvaluationFormEvaluationFormQuestionTypePropertiesPropertyFromCloudFormation(properties.QuestionTypeProperties) : void 0), ret.addPropertyResult("refId", "RefId", cfn_parse.FromCloudFormation.getString(properties.RefId)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addPropertyResult("weight", "Weight", properties.Weight != null ? cfn_parse.FromCloudFormation.getNumber(properties.Weight) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEvaluationForm_EvaluationFormQuestionTypePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("numeric", CfnEvaluationForm_EvaluationFormNumericQuestionPropertiesPropertyValidator)(properties.numeric)), errors.collect(cdk.propertyValidator("singleSelect", CfnEvaluationForm_EvaluationFormSingleSelectQuestionPropertiesPropertyValidator)(properties.singleSelect)), errors.wrap('supplied properties not correct for "EvaluationFormQuestionTypePropertiesProperty"');
    }
    function cfnEvaluationFormEvaluationFormQuestionTypePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEvaluationForm_EvaluationFormQuestionTypePropertiesPropertyValidator(properties).assertSuccess(), { Numeric: cfnEvaluationFormEvaluationFormNumericQuestionPropertiesPropertyToCloudFormation(properties.numeric), SingleSelect: cfnEvaluationFormEvaluationFormSingleSelectQuestionPropertiesPropertyToCloudFormation(properties.singleSelect) }) : properties;
    }
    function CfnEvaluationFormEvaluationFormQuestionTypePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("numeric", "Numeric", properties.Numeric != null ? CfnEvaluationFormEvaluationFormNumericQuestionPropertiesPropertyFromCloudFormation(properties.Numeric) : void 0), ret.addPropertyResult("singleSelect", "SingleSelect", properties.SingleSelect != null ? CfnEvaluationFormEvaluationFormSingleSelectQuestionPropertiesPropertyFromCloudFormation(properties.SingleSelect) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEvaluationForm_EvaluationFormSectionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instructions", cdk.validateString)(properties.instructions)), errors.collect(cdk.propertyValidator("items", cdk.listValidator(CfnEvaluationForm_EvaluationFormItemPropertyValidator))(properties.items)), errors.collect(cdk.propertyValidator("refId", cdk.requiredValidator)(properties.refId)), errors.collect(cdk.propertyValidator("refId", cdk.validateString)(properties.refId)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.collect(cdk.propertyValidator("weight", cdk.validateNumber)(properties.weight)), errors.wrap('supplied properties not correct for "EvaluationFormSectionProperty"');
    }
    function cfnEvaluationFormEvaluationFormSectionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEvaluationForm_EvaluationFormSectionPropertyValidator(properties).assertSuccess(), { Instructions: cdk.stringToCloudFormation(properties.instructions), Items: cdk.listMapper(cfnEvaluationFormEvaluationFormItemPropertyToCloudFormation)(properties.items), RefId: cdk.stringToCloudFormation(properties.refId), Title: cdk.stringToCloudFormation(properties.title), Weight: cdk.numberToCloudFormation(properties.weight) }) : properties;
    }
    function CfnEvaluationFormEvaluationFormSectionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instructions", "Instructions", properties.Instructions != null ? cfn_parse.FromCloudFormation.getString(properties.Instructions) : void 0), ret.addPropertyResult("items", "Items", properties.Items != null ? cfn_parse.FromCloudFormation.getArray(CfnEvaluationFormEvaluationFormItemPropertyFromCloudFormation)(properties.Items) : void 0), ret.addPropertyResult("refId", "RefId", cfn_parse.FromCloudFormation.getString(properties.RefId)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addPropertyResult("weight", "Weight", properties.Weight != null ? cfn_parse.FromCloudFormation.getNumber(properties.Weight) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEvaluationForm_EvaluationFormSingleSelectQuestionAutomationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultOptionRefId", cdk.validateString)(properties.defaultOptionRefId)), errors.collect(cdk.propertyValidator("options", cdk.requiredValidator)(properties.options)), errors.collect(cdk.propertyValidator("options", cdk.listValidator(CfnEvaluationForm_EvaluationFormSingleSelectQuestionAutomationOptionPropertyValidator))(properties.options)), errors.wrap('supplied properties not correct for "EvaluationFormSingleSelectQuestionAutomationProperty"');
    }
    function cfnEvaluationFormEvaluationFormSingleSelectQuestionAutomationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEvaluationForm_EvaluationFormSingleSelectQuestionAutomationPropertyValidator(properties).assertSuccess(), { DefaultOptionRefId: cdk.stringToCloudFormation(properties.defaultOptionRefId), Options: cdk.listMapper(cfnEvaluationFormEvaluationFormSingleSelectQuestionAutomationOptionPropertyToCloudFormation)(properties.options) }) : properties;
    }
    function CfnEvaluationFormEvaluationFormSingleSelectQuestionAutomationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultOptionRefId", "DefaultOptionRefId", properties.DefaultOptionRefId != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultOptionRefId) : void 0), ret.addPropertyResult("options", "Options", cfn_parse.FromCloudFormation.getArray(CfnEvaluationFormEvaluationFormSingleSelectQuestionAutomationOptionPropertyFromCloudFormation)(properties.Options)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEvaluationForm_EvaluationFormSingleSelectQuestionAutomationOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ruleCategory", cdk.requiredValidator)(properties.ruleCategory)), errors.collect(cdk.propertyValidator("ruleCategory", CfnEvaluationForm_SingleSelectQuestionRuleCategoryAutomationPropertyValidator)(properties.ruleCategory)), errors.wrap('supplied properties not correct for "EvaluationFormSingleSelectQuestionAutomationOptionProperty"');
    }
    function cfnEvaluationFormEvaluationFormSingleSelectQuestionAutomationOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEvaluationForm_EvaluationFormSingleSelectQuestionAutomationOptionPropertyValidator(properties).assertSuccess(), { RuleCategory: cfnEvaluationFormSingleSelectQuestionRuleCategoryAutomationPropertyToCloudFormation(properties.ruleCategory) }) : properties;
    }
    function CfnEvaluationFormEvaluationFormSingleSelectQuestionAutomationOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ruleCategory", "RuleCategory", CfnEvaluationFormSingleSelectQuestionRuleCategoryAutomationPropertyFromCloudFormation(properties.RuleCategory)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEvaluationForm_EvaluationFormSingleSelectQuestionOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("automaticFail", cdk.validateBoolean)(properties.automaticFail)), errors.collect(cdk.propertyValidator("refId", cdk.requiredValidator)(properties.refId)), errors.collect(cdk.propertyValidator("refId", cdk.validateString)(properties.refId)), errors.collect(cdk.propertyValidator("score", cdk.validateNumber)(properties.score)), errors.collect(cdk.propertyValidator("text", cdk.requiredValidator)(properties.text)), errors.collect(cdk.propertyValidator("text", cdk.validateString)(properties.text)), errors.wrap('supplied properties not correct for "EvaluationFormSingleSelectQuestionOptionProperty"');
    }
    function cfnEvaluationFormEvaluationFormSingleSelectQuestionOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEvaluationForm_EvaluationFormSingleSelectQuestionOptionPropertyValidator(properties).assertSuccess(), { AutomaticFail: cdk.booleanToCloudFormation(properties.automaticFail), RefId: cdk.stringToCloudFormation(properties.refId), Score: cdk.numberToCloudFormation(properties.score), Text: cdk.stringToCloudFormation(properties.text) }) : properties;
    }
    function CfnEvaluationFormEvaluationFormSingleSelectQuestionOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("automaticFail", "AutomaticFail", properties.AutomaticFail != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AutomaticFail) : void 0), ret.addPropertyResult("refId", "RefId", cfn_parse.FromCloudFormation.getString(properties.RefId)), ret.addPropertyResult("score", "Score", properties.Score != null ? cfn_parse.FromCloudFormation.getNumber(properties.Score) : void 0), ret.addPropertyResult("text", "Text", cfn_parse.FromCloudFormation.getString(properties.Text)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEvaluationForm_EvaluationFormSingleSelectQuestionPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("automation", CfnEvaluationForm_EvaluationFormSingleSelectQuestionAutomationPropertyValidator)(properties.automation)), errors.collect(cdk.propertyValidator("displayAs", cdk.validateString)(properties.displayAs)), errors.collect(cdk.propertyValidator("options", cdk.requiredValidator)(properties.options)), errors.collect(cdk.propertyValidator("options", cdk.listValidator(CfnEvaluationForm_EvaluationFormSingleSelectQuestionOptionPropertyValidator))(properties.options)), errors.wrap('supplied properties not correct for "EvaluationFormSingleSelectQuestionPropertiesProperty"');
    }
    function cfnEvaluationFormEvaluationFormSingleSelectQuestionPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEvaluationForm_EvaluationFormSingleSelectQuestionPropertiesPropertyValidator(properties).assertSuccess(), { Automation: cfnEvaluationFormEvaluationFormSingleSelectQuestionAutomationPropertyToCloudFormation(properties.automation), DisplayAs: cdk.stringToCloudFormation(properties.displayAs), Options: cdk.listMapper(cfnEvaluationFormEvaluationFormSingleSelectQuestionOptionPropertyToCloudFormation)(properties.options) }) : properties;
    }
    function CfnEvaluationFormEvaluationFormSingleSelectQuestionPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("automation", "Automation", properties.Automation != null ? CfnEvaluationFormEvaluationFormSingleSelectQuestionAutomationPropertyFromCloudFormation(properties.Automation) : void 0), ret.addPropertyResult("displayAs", "DisplayAs", properties.DisplayAs != null ? cfn_parse.FromCloudFormation.getString(properties.DisplayAs) : void 0), ret.addPropertyResult("options", "Options", cfn_parse.FromCloudFormation.getArray(CfnEvaluationFormEvaluationFormSingleSelectQuestionOptionPropertyFromCloudFormation)(properties.Options)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEvaluationForm_NumericQuestionPropertyValueAutomationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("label", cdk.requiredValidator)(properties.label)), errors.collect(cdk.propertyValidator("label", cdk.validateString)(properties.label)), errors.wrap('supplied properties not correct for "NumericQuestionPropertyValueAutomationProperty"');
    }
    function cfnEvaluationFormNumericQuestionPropertyValueAutomationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEvaluationForm_NumericQuestionPropertyValueAutomationPropertyValidator(properties).assertSuccess(), { Label: cdk.stringToCloudFormation(properties.label) }) : properties;
    }
    function CfnEvaluationFormNumericQuestionPropertyValueAutomationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("label", "Label", cfn_parse.FromCloudFormation.getString(properties.Label)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEvaluationForm_ScoringStrategyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mode", cdk.requiredValidator)(properties.mode)), errors.collect(cdk.propertyValidator("mode", cdk.validateString)(properties.mode)), errors.collect(cdk.propertyValidator("status", cdk.requiredValidator)(properties.status)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "ScoringStrategyProperty"');
    }
    function cfnEvaluationFormScoringStrategyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEvaluationForm_ScoringStrategyPropertyValidator(properties).assertSuccess(), { Mode: cdk.stringToCloudFormation(properties.mode), Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnEvaluationFormScoringStrategyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mode", "Mode", cfn_parse.FromCloudFormation.getString(properties.Mode)), ret.addPropertyResult("status", "Status", cfn_parse.FromCloudFormation.getString(properties.Status)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEvaluationForm_SingleSelectQuestionRuleCategoryAutomationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("category", cdk.requiredValidator)(properties.category)), errors.collect(cdk.propertyValidator("category", cdk.validateString)(properties.category)), errors.collect(cdk.propertyValidator("condition", cdk.requiredValidator)(properties.condition)), errors.collect(cdk.propertyValidator("condition", cdk.validateString)(properties.condition)), errors.collect(cdk.propertyValidator("optionRefId", cdk.requiredValidator)(properties.optionRefId)), errors.collect(cdk.propertyValidator("optionRefId", cdk.validateString)(properties.optionRefId)), errors.wrap('supplied properties not correct for "SingleSelectQuestionRuleCategoryAutomationProperty"');
    }
    function cfnEvaluationFormSingleSelectQuestionRuleCategoryAutomationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEvaluationForm_SingleSelectQuestionRuleCategoryAutomationPropertyValidator(properties).assertSuccess(), { Category: cdk.stringToCloudFormation(properties.category), Condition: cdk.stringToCloudFormation(properties.condition), OptionRefId: cdk.stringToCloudFormation(properties.optionRefId) }) : properties;
    }
    function CfnEvaluationFormSingleSelectQuestionRuleCategoryAutomationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("category", "Category", cfn_parse.FromCloudFormation.getString(properties.Category)), ret.addPropertyResult("condition", "Condition", cfn_parse.FromCloudFormation.getString(properties.Condition)), ret.addPropertyResult("optionRefId", "OptionRefId", cfn_parse.FromCloudFormation.getString(properties.OptionRefId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnHoursOfOperationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("config", cdk.requiredValidator)(properties.config)), errors.collect(cdk.propertyValidator("config", cdk.listValidator(CfnHoursOfOperation_HoursOfOperationConfigPropertyValidator))(properties.config)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("instanceArn", cdk.requiredValidator)(properties.instanceArn)), errors.collect(cdk.propertyValidator("instanceArn", cdk.validateString)(properties.instanceArn)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("timeZone", cdk.requiredValidator)(properties.timeZone)), errors.collect(cdk.propertyValidator("timeZone", cdk.validateString)(properties.timeZone)), errors.wrap('supplied properties not correct for "CfnHoursOfOperationProps"');
    }
    function cfnHoursOfOperationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHoursOfOperationPropsValidator(properties).assertSuccess(), { Config: cdk.listMapper(cfnHoursOfOperationHoursOfOperationConfigPropertyToCloudFormation)(properties.config), InstanceArn: cdk.stringToCloudFormation(properties.instanceArn), Name: cdk.stringToCloudFormation(properties.name), TimeZone: cdk.stringToCloudFormation(properties.timeZone), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnHoursOfOperationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("config", "Config", cfn_parse.FromCloudFormation.getArray(CfnHoursOfOperationHoursOfOperationConfigPropertyFromCloudFormation)(properties.Config)), ret.addPropertyResult("instanceArn", "InstanceArn", cfn_parse.FromCloudFormation.getString(properties.InstanceArn)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("timeZone", "TimeZone", cfn_parse.FromCloudFormation.getString(properties.TimeZone)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnHoursOfOperation = class _CfnHoursOfOperation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnHoursOfOperationPropsFromCloudFormation(resourceProperties), ret = new _CfnHoursOfOperation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnHoursOfOperation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_connect_CfnHoursOfOperationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnHoursOfOperation), error;
        }
        cdk.requireProperty(props, "config", this), cdk.requireProperty(props, "instanceArn", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "timeZone", this), this.attrHoursOfOperationArn = cdk.Token.asString(this.getAtt("HoursOfOperationArn", cdk.ResolutionTypeHint.STRING)), this.config = props.config, this.instanceArn = props.instanceArn, this.name = props.name, this.timeZone = props.timeZone, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Connect::HoursOfOperation", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnHoursOfOperation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { config: this.config, instanceArn: this.instanceArn, name: this.name, timeZone: this.timeZone, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnHoursOfOperationPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnHoursOfOperation[_e] = { fqn: "aws-cdk-lib.aws_connect.CfnHoursOfOperation", version: "2.80.0" }, CfnHoursOfOperation.CFN_RESOURCE_TYPE_NAME = "AWS::Connect::HoursOfOperation", exports2.CfnHoursOfOperation = CfnHoursOfOperation;
    function CfnHoursOfOperation_HoursOfOperationConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("day", cdk.requiredValidator)(properties.day)), errors.collect(cdk.propertyValidator("day", cdk.validateString)(properties.day)), errors.collect(cdk.propertyValidator("endTime", cdk.requiredValidator)(properties.endTime)), errors.collect(cdk.propertyValidator("endTime", CfnHoursOfOperation_HoursOfOperationTimeSlicePropertyValidator)(properties.endTime)), errors.collect(cdk.propertyValidator("startTime", cdk.requiredValidator)(properties.startTime)), errors.collect(cdk.propertyValidator("startTime", CfnHoursOfOperation_HoursOfOperationTimeSlicePropertyValidator)(properties.startTime)), errors.wrap('supplied properties not correct for "HoursOfOperationConfigProperty"');
    }
    function cfnHoursOfOperationHoursOfOperationConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHoursOfOperation_HoursOfOperationConfigPropertyValidator(properties).assertSuccess(), { Day: cdk.stringToCloudFormation(properties.day), EndTime: cfnHoursOfOperationHoursOfOperationTimeSlicePropertyToCloudFormation(properties.endTime), StartTime: cfnHoursOfOperationHoursOfOperationTimeSlicePropertyToCloudFormation(properties.startTime) }) : properties;
    }
    function CfnHoursOfOperationHoursOfOperationConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("day", "Day", cfn_parse.FromCloudFormation.getString(properties.Day)), ret.addPropertyResult("endTime", "EndTime", CfnHoursOfOperationHoursOfOperationTimeSlicePropertyFromCloudFormation(properties.EndTime)), ret.addPropertyResult("startTime", "StartTime", CfnHoursOfOperationHoursOfOperationTimeSlicePropertyFromCloudFormation(properties.StartTime)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnHoursOfOperation_HoursOfOperationTimeSlicePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("hours", cdk.requiredValidator)(properties.hours)), errors.collect(cdk.propertyValidator("hours", cdk.validateNumber)(properties.hours)), errors.collect(cdk.propertyValidator("minutes", cdk.requiredValidator)(properties.minutes)), errors.collect(cdk.propertyValidator("minutes", cdk.validateNumber)(properties.minutes)), errors.wrap('supplied properties not correct for "HoursOfOperationTimeSliceProperty"');
    }
    function cfnHoursOfOperationHoursOfOperationTimeSlicePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHoursOfOperation_HoursOfOperationTimeSlicePropertyValidator(properties).assertSuccess(), { Hours: cdk.numberToCloudFormation(properties.hours), Minutes: cdk.numberToCloudFormation(properties.minutes) }) : properties;
    }
    function CfnHoursOfOperationHoursOfOperationTimeSlicePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("hours", "Hours", cfn_parse.FromCloudFormation.getNumber(properties.Hours)), ret.addPropertyResult("minutes", "Minutes", cfn_parse.FromCloudFormation.getNumber(properties.Minutes)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstancePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributes", cdk.requiredValidator)(properties.attributes)), errors.collect(cdk.propertyValidator("attributes", CfnInstance_AttributesPropertyValidator)(properties.attributes)), errors.collect(cdk.propertyValidator("directoryId", cdk.validateString)(properties.directoryId)), errors.collect(cdk.propertyValidator("identityManagementType", cdk.requiredValidator)(properties.identityManagementType)), errors.collect(cdk.propertyValidator("identityManagementType", cdk.validateString)(properties.identityManagementType)), errors.collect(cdk.propertyValidator("instanceAlias", cdk.validateString)(properties.instanceAlias)), errors.wrap('supplied properties not correct for "CfnInstanceProps"');
    }
    function cfnInstancePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstancePropsValidator(properties).assertSuccess(), { Attributes: cfnInstanceAttributesPropertyToCloudFormation(properties.attributes), IdentityManagementType: cdk.stringToCloudFormation(properties.identityManagementType), DirectoryId: cdk.stringToCloudFormation(properties.directoryId), InstanceAlias: cdk.stringToCloudFormation(properties.instanceAlias) }) : properties;
    }
    function CfnInstancePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attributes", "Attributes", CfnInstanceAttributesPropertyFromCloudFormation(properties.Attributes)), ret.addPropertyResult("identityManagementType", "IdentityManagementType", cfn_parse.FromCloudFormation.getString(properties.IdentityManagementType)), ret.addPropertyResult("directoryId", "DirectoryId", properties.DirectoryId != null ? cfn_parse.FromCloudFormation.getString(properties.DirectoryId) : void 0), ret.addPropertyResult("instanceAlias", "InstanceAlias", properties.InstanceAlias != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceAlias) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnInstance = class _CfnInstance extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnInstancePropsFromCloudFormation(resourceProperties), ret = new _CfnInstance(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnInstance.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_connect_CfnInstanceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnInstance), error;
        }
        cdk.requireProperty(props, "attributes", this), cdk.requireProperty(props, "identityManagementType", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreatedTime = cdk.Token.asString(this.getAtt("CreatedTime", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrInstanceStatus = cdk.Token.asString(this.getAtt("InstanceStatus", cdk.ResolutionTypeHint.STRING)), this.attrServiceRole = cdk.Token.asString(this.getAtt("ServiceRole", cdk.ResolutionTypeHint.STRING)), this.attributes = props.attributes, this.identityManagementType = props.identityManagementType, this.directoryId = props.directoryId, this.instanceAlias = props.instanceAlias;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnInstance.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { attributes: this.attributes, identityManagementType: this.identityManagementType, directoryId: this.directoryId, instanceAlias: this.instanceAlias };
      }
      renderProperties(props) {
        return cfnInstancePropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnInstance[_f] = { fqn: "aws-cdk-lib.aws_connect.CfnInstance", version: "2.80.0" }, CfnInstance.CFN_RESOURCE_TYPE_NAME = "AWS::Connect::Instance", exports2.CfnInstance = CfnInstance;
    function CfnInstance_AttributesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoResolveBestVoices", cdk.validateBoolean)(properties.autoResolveBestVoices)), errors.collect(cdk.propertyValidator("contactLens", cdk.validateBoolean)(properties.contactLens)), errors.collect(cdk.propertyValidator("contactflowLogs", cdk.validateBoolean)(properties.contactflowLogs)), errors.collect(cdk.propertyValidator("earlyMedia", cdk.validateBoolean)(properties.earlyMedia)), errors.collect(cdk.propertyValidator("inboundCalls", cdk.requiredValidator)(properties.inboundCalls)), errors.collect(cdk.propertyValidator("inboundCalls", cdk.validateBoolean)(properties.inboundCalls)), errors.collect(cdk.propertyValidator("outboundCalls", cdk.requiredValidator)(properties.outboundCalls)), errors.collect(cdk.propertyValidator("outboundCalls", cdk.validateBoolean)(properties.outboundCalls)), errors.collect(cdk.propertyValidator("useCustomTtsVoices", cdk.validateBoolean)(properties.useCustomTtsVoices)), errors.wrap('supplied properties not correct for "AttributesProperty"');
    }
    function cfnInstanceAttributesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstance_AttributesPropertyValidator(properties).assertSuccess(), { AutoResolveBestVoices: cdk.booleanToCloudFormation(properties.autoResolveBestVoices), ContactLens: cdk.booleanToCloudFormation(properties.contactLens), ContactflowLogs: cdk.booleanToCloudFormation(properties.contactflowLogs), EarlyMedia: cdk.booleanToCloudFormation(properties.earlyMedia), InboundCalls: cdk.booleanToCloudFormation(properties.inboundCalls), OutboundCalls: cdk.booleanToCloudFormation(properties.outboundCalls), UseCustomTTSVoices: cdk.booleanToCloudFormation(properties.useCustomTtsVoices) }) : properties;
    }
    function CfnInstanceAttributesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("autoResolveBestVoices", "AutoResolveBestVoices", properties.AutoResolveBestVoices != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AutoResolveBestVoices) : void 0), ret.addPropertyResult("contactLens", "ContactLens", properties.ContactLens != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ContactLens) : void 0), ret.addPropertyResult("contactflowLogs", "ContactflowLogs", properties.ContactflowLogs != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ContactflowLogs) : void 0), ret.addPropertyResult("earlyMedia", "EarlyMedia", properties.EarlyMedia != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EarlyMedia) : void 0), ret.addPropertyResult("inboundCalls", "InboundCalls", cfn_parse.FromCloudFormation.getBoolean(properties.InboundCalls)), ret.addPropertyResult("outboundCalls", "OutboundCalls", cfn_parse.FromCloudFormation.getBoolean(properties.OutboundCalls)), ret.addPropertyResult("useCustomTtsVoices", "UseCustomTTSVoices", properties.UseCustomTTSVoices != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseCustomTTSVoices) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstanceStorageConfigPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceArn", cdk.requiredValidator)(properties.instanceArn)), errors.collect(cdk.propertyValidator("instanceArn", cdk.validateString)(properties.instanceArn)), errors.collect(cdk.propertyValidator("kinesisFirehoseConfig", CfnInstanceStorageConfig_KinesisFirehoseConfigPropertyValidator)(properties.kinesisFirehoseConfig)), errors.collect(cdk.propertyValidator("kinesisStreamConfig", CfnInstanceStorageConfig_KinesisStreamConfigPropertyValidator)(properties.kinesisStreamConfig)), errors.collect(cdk.propertyValidator("kinesisVideoStreamConfig", CfnInstanceStorageConfig_KinesisVideoStreamConfigPropertyValidator)(properties.kinesisVideoStreamConfig)), errors.collect(cdk.propertyValidator("resourceType", cdk.requiredValidator)(properties.resourceType)), errors.collect(cdk.propertyValidator("resourceType", cdk.validateString)(properties.resourceType)), errors.collect(cdk.propertyValidator("s3Config", CfnInstanceStorageConfig_S3ConfigPropertyValidator)(properties.s3Config)), errors.collect(cdk.propertyValidator("storageType", cdk.requiredValidator)(properties.storageType)), errors.collect(cdk.propertyValidator("storageType", cdk.validateString)(properties.storageType)), errors.wrap('supplied properties not correct for "CfnInstanceStorageConfigProps"');
    }
    function cfnInstanceStorageConfigPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceStorageConfigPropsValidator(properties).assertSuccess(), { InstanceArn: cdk.stringToCloudFormation(properties.instanceArn), ResourceType: cdk.stringToCloudFormation(properties.resourceType), StorageType: cdk.stringToCloudFormation(properties.storageType), KinesisFirehoseConfig: cfnInstanceStorageConfigKinesisFirehoseConfigPropertyToCloudFormation(properties.kinesisFirehoseConfig), KinesisStreamConfig: cfnInstanceStorageConfigKinesisStreamConfigPropertyToCloudFormation(properties.kinesisStreamConfig), KinesisVideoStreamConfig: cfnInstanceStorageConfigKinesisVideoStreamConfigPropertyToCloudFormation(properties.kinesisVideoStreamConfig), S3Config: cfnInstanceStorageConfigS3ConfigPropertyToCloudFormation(properties.s3Config) }) : properties;
    }
    function CfnInstanceStorageConfigPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceArn", "InstanceArn", cfn_parse.FromCloudFormation.getString(properties.InstanceArn)), ret.addPropertyResult("resourceType", "ResourceType", cfn_parse.FromCloudFormation.getString(properties.ResourceType)), ret.addPropertyResult("storageType", "StorageType", cfn_parse.FromCloudFormation.getString(properties.StorageType)), ret.addPropertyResult("kinesisFirehoseConfig", "KinesisFirehoseConfig", properties.KinesisFirehoseConfig != null ? CfnInstanceStorageConfigKinesisFirehoseConfigPropertyFromCloudFormation(properties.KinesisFirehoseConfig) : void 0), ret.addPropertyResult("kinesisStreamConfig", "KinesisStreamConfig", properties.KinesisStreamConfig != null ? CfnInstanceStorageConfigKinesisStreamConfigPropertyFromCloudFormation(properties.KinesisStreamConfig) : void 0), ret.addPropertyResult("kinesisVideoStreamConfig", "KinesisVideoStreamConfig", properties.KinesisVideoStreamConfig != null ? CfnInstanceStorageConfigKinesisVideoStreamConfigPropertyFromCloudFormation(properties.KinesisVideoStreamConfig) : void 0), ret.addPropertyResult("s3Config", "S3Config", properties.S3Config != null ? CfnInstanceStorageConfigS3ConfigPropertyFromCloudFormation(properties.S3Config) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnInstanceStorageConfig = class _CfnInstanceStorageConfig extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnInstanceStorageConfigPropsFromCloudFormation(resourceProperties), ret = new _CfnInstanceStorageConfig(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnInstanceStorageConfig.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_connect_CfnInstanceStorageConfigProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnInstanceStorageConfig), error;
        }
        cdk.requireProperty(props, "instanceArn", this), cdk.requireProperty(props, "resourceType", this), cdk.requireProperty(props, "storageType", this), this.attrAssociationId = cdk.Token.asString(this.getAtt("AssociationId", cdk.ResolutionTypeHint.STRING)), this.instanceArn = props.instanceArn, this.resourceType = props.resourceType, this.storageType = props.storageType, this.kinesisFirehoseConfig = props.kinesisFirehoseConfig, this.kinesisStreamConfig = props.kinesisStreamConfig, this.kinesisVideoStreamConfig = props.kinesisVideoStreamConfig, this.s3Config = props.s3Config;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnInstanceStorageConfig.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { instanceArn: this.instanceArn, resourceType: this.resourceType, storageType: this.storageType, kinesisFirehoseConfig: this.kinesisFirehoseConfig, kinesisStreamConfig: this.kinesisStreamConfig, kinesisVideoStreamConfig: this.kinesisVideoStreamConfig, s3Config: this.s3Config };
      }
      renderProperties(props) {
        return cfnInstanceStorageConfigPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnInstanceStorageConfig[_g] = { fqn: "aws-cdk-lib.aws_connect.CfnInstanceStorageConfig", version: "2.80.0" }, CfnInstanceStorageConfig.CFN_RESOURCE_TYPE_NAME = "AWS::Connect::InstanceStorageConfig", exports2.CfnInstanceStorageConfig = CfnInstanceStorageConfig;
    function CfnInstanceStorageConfig_EncryptionConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("encryptionType", cdk.requiredValidator)(properties.encryptionType)), errors.collect(cdk.propertyValidator("encryptionType", cdk.validateString)(properties.encryptionType)), errors.collect(cdk.propertyValidator("keyId", cdk.requiredValidator)(properties.keyId)), errors.collect(cdk.propertyValidator("keyId", cdk.validateString)(properties.keyId)), errors.wrap('supplied properties not correct for "EncryptionConfigProperty"');
    }
    function cfnInstanceStorageConfigEncryptionConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceStorageConfig_EncryptionConfigPropertyValidator(properties).assertSuccess(), { EncryptionType: cdk.stringToCloudFormation(properties.encryptionType), KeyId: cdk.stringToCloudFormation(properties.keyId) }) : properties;
    }
    function CfnInstanceStorageConfigEncryptionConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("encryptionType", "EncryptionType", cfn_parse.FromCloudFormation.getString(properties.EncryptionType)), ret.addPropertyResult("keyId", "KeyId", cfn_parse.FromCloudFormation.getString(properties.KeyId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstanceStorageConfig_KinesisFirehoseConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("firehoseArn", cdk.requiredValidator)(properties.firehoseArn)), errors.collect(cdk.propertyValidator("firehoseArn", cdk.validateString)(properties.firehoseArn)), errors.wrap('supplied properties not correct for "KinesisFirehoseConfigProperty"');
    }
    function cfnInstanceStorageConfigKinesisFirehoseConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceStorageConfig_KinesisFirehoseConfigPropertyValidator(properties).assertSuccess(), { FirehoseArn: cdk.stringToCloudFormation(properties.firehoseArn) }) : properties;
    }
    function CfnInstanceStorageConfigKinesisFirehoseConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("firehoseArn", "FirehoseArn", cfn_parse.FromCloudFormation.getString(properties.FirehoseArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstanceStorageConfig_KinesisStreamConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("streamArn", cdk.requiredValidator)(properties.streamArn)), errors.collect(cdk.propertyValidator("streamArn", cdk.validateString)(properties.streamArn)), errors.wrap('supplied properties not correct for "KinesisStreamConfigProperty"');
    }
    function cfnInstanceStorageConfigKinesisStreamConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceStorageConfig_KinesisStreamConfigPropertyValidator(properties).assertSuccess(), { StreamArn: cdk.stringToCloudFormation(properties.streamArn) }) : properties;
    }
    function CfnInstanceStorageConfigKinesisStreamConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("streamArn", "StreamArn", cfn_parse.FromCloudFormation.getString(properties.StreamArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstanceStorageConfig_KinesisVideoStreamConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("encryptionConfig", CfnInstanceStorageConfig_EncryptionConfigPropertyValidator)(properties.encryptionConfig)), errors.collect(cdk.propertyValidator("prefix", cdk.requiredValidator)(properties.prefix)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.collect(cdk.propertyValidator("retentionPeriodHours", cdk.requiredValidator)(properties.retentionPeriodHours)), errors.collect(cdk.propertyValidator("retentionPeriodHours", cdk.validateNumber)(properties.retentionPeriodHours)), errors.wrap('supplied properties not correct for "KinesisVideoStreamConfigProperty"');
    }
    function cfnInstanceStorageConfigKinesisVideoStreamConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceStorageConfig_KinesisVideoStreamConfigPropertyValidator(properties).assertSuccess(), { EncryptionConfig: cfnInstanceStorageConfigEncryptionConfigPropertyToCloudFormation(properties.encryptionConfig), Prefix: cdk.stringToCloudFormation(properties.prefix), RetentionPeriodHours: cdk.numberToCloudFormation(properties.retentionPeriodHours) }) : properties;
    }
    function CfnInstanceStorageConfigKinesisVideoStreamConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("encryptionConfig", "EncryptionConfig", properties.EncryptionConfig != null ? CfnInstanceStorageConfigEncryptionConfigPropertyFromCloudFormation(properties.EncryptionConfig) : void 0), ret.addPropertyResult("prefix", "Prefix", cfn_parse.FromCloudFormation.getString(properties.Prefix)), ret.addPropertyResult("retentionPeriodHours", "RetentionPeriodHours", cfn_parse.FromCloudFormation.getNumber(properties.RetentionPeriodHours)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstanceStorageConfig_S3ConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketName", cdk.requiredValidator)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketPrefix", cdk.requiredValidator)(properties.bucketPrefix)), errors.collect(cdk.propertyValidator("bucketPrefix", cdk.validateString)(properties.bucketPrefix)), errors.collect(cdk.propertyValidator("encryptionConfig", CfnInstanceStorageConfig_EncryptionConfigPropertyValidator)(properties.encryptionConfig)), errors.wrap('supplied properties not correct for "S3ConfigProperty"');
    }
    function cfnInstanceStorageConfigS3ConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceStorageConfig_S3ConfigPropertyValidator(properties).assertSuccess(), { BucketName: cdk.stringToCloudFormation(properties.bucketName), BucketPrefix: cdk.stringToCloudFormation(properties.bucketPrefix), EncryptionConfig: cfnInstanceStorageConfigEncryptionConfigPropertyToCloudFormation(properties.encryptionConfig) }) : properties;
    }
    function CfnInstanceStorageConfigS3ConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketName", "BucketName", cfn_parse.FromCloudFormation.getString(properties.BucketName)), ret.addPropertyResult("bucketPrefix", "BucketPrefix", cfn_parse.FromCloudFormation.getString(properties.BucketPrefix)), ret.addPropertyResult("encryptionConfig", "EncryptionConfig", properties.EncryptionConfig != null ? CfnInstanceStorageConfigEncryptionConfigPropertyFromCloudFormation(properties.EncryptionConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIntegrationAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceId", cdk.requiredValidator)(properties.instanceId)), errors.collect(cdk.propertyValidator("instanceId", cdk.validateString)(properties.instanceId)), errors.collect(cdk.propertyValidator("integrationArn", cdk.requiredValidator)(properties.integrationArn)), errors.collect(cdk.propertyValidator("integrationArn", cdk.validateString)(properties.integrationArn)), errors.collect(cdk.propertyValidator("integrationType", cdk.requiredValidator)(properties.integrationType)), errors.collect(cdk.propertyValidator("integrationType", cdk.validateString)(properties.integrationType)), errors.wrap('supplied properties not correct for "CfnIntegrationAssociationProps"');
    }
    function cfnIntegrationAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIntegrationAssociationPropsValidator(properties).assertSuccess(), { InstanceId: cdk.stringToCloudFormation(properties.instanceId), IntegrationArn: cdk.stringToCloudFormation(properties.integrationArn), IntegrationType: cdk.stringToCloudFormation(properties.integrationType) }) : properties;
    }
    function CfnIntegrationAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceId", "InstanceId", cfn_parse.FromCloudFormation.getString(properties.InstanceId)), ret.addPropertyResult("integrationArn", "IntegrationArn", cfn_parse.FromCloudFormation.getString(properties.IntegrationArn)), ret.addPropertyResult("integrationType", "IntegrationType", cfn_parse.FromCloudFormation.getString(properties.IntegrationType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnIntegrationAssociation = class _CfnIntegrationAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnIntegrationAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnIntegrationAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnIntegrationAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_connect_CfnIntegrationAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnIntegrationAssociation), error;
        }
        cdk.requireProperty(props, "instanceId", this), cdk.requireProperty(props, "integrationArn", this), cdk.requireProperty(props, "integrationType", this), this.attrIntegrationAssociationId = cdk.Token.asString(this.getAtt("IntegrationAssociationId", cdk.ResolutionTypeHint.STRING)), this.instanceId = props.instanceId, this.integrationArn = props.integrationArn, this.integrationType = props.integrationType;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnIntegrationAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { instanceId: this.instanceId, integrationArn: this.integrationArn, integrationType: this.integrationType };
      }
      renderProperties(props) {
        return cfnIntegrationAssociationPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnIntegrationAssociation[_h] = { fqn: "aws-cdk-lib.aws_connect.CfnIntegrationAssociation", version: "2.80.0" }, CfnIntegrationAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::Connect::IntegrationAssociation", exports2.CfnIntegrationAssociation = CfnIntegrationAssociation;
    function CfnPhoneNumberPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("countryCode", cdk.requiredValidator)(properties.countryCode)), errors.collect(cdk.propertyValidator("countryCode", cdk.validateString)(properties.countryCode)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("targetArn", cdk.requiredValidator)(properties.targetArn)), errors.collect(cdk.propertyValidator("targetArn", cdk.validateString)(properties.targetArn)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnPhoneNumberProps"');
    }
    function cfnPhoneNumberPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPhoneNumberPropsValidator(properties).assertSuccess(), { CountryCode: cdk.stringToCloudFormation(properties.countryCode), TargetArn: cdk.stringToCloudFormation(properties.targetArn), Type: cdk.stringToCloudFormation(properties.type), Description: cdk.stringToCloudFormation(properties.description), Prefix: cdk.stringToCloudFormation(properties.prefix), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnPhoneNumberPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("countryCode", "CountryCode", cfn_parse.FromCloudFormation.getString(properties.CountryCode)), ret.addPropertyResult("targetArn", "TargetArn", cfn_parse.FromCloudFormation.getString(properties.TargetArn)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPhoneNumber = class _CfnPhoneNumber extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPhoneNumberPropsFromCloudFormation(resourceProperties), ret = new _CfnPhoneNumber(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPhoneNumber.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_connect_CfnPhoneNumberProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPhoneNumber), error;
        }
        cdk.requireProperty(props, "countryCode", this), cdk.requireProperty(props, "targetArn", this), cdk.requireProperty(props, "type", this), this.attrAddress = cdk.Token.asString(this.getAtt("Address", cdk.ResolutionTypeHint.STRING)), this.attrPhoneNumberArn = cdk.Token.asString(this.getAtt("PhoneNumberArn", cdk.ResolutionTypeHint.STRING)), this.countryCode = props.countryCode, this.targetArn = props.targetArn, this.type = props.type, this.description = props.description, this.prefix = props.prefix, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Connect::PhoneNumber", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPhoneNumber.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { countryCode: this.countryCode, targetArn: this.targetArn, type: this.type, description: this.description, prefix: this.prefix, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnPhoneNumberPropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnPhoneNumber[_j] = { fqn: "aws-cdk-lib.aws_connect.CfnPhoneNumber", version: "2.80.0" }, CfnPhoneNumber.CFN_RESOURCE_TYPE_NAME = "AWS::Connect::PhoneNumber", exports2.CfnPhoneNumber = CfnPhoneNumber;
    function CfnQuickConnectPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("instanceArn", cdk.requiredValidator)(properties.instanceArn)), errors.collect(cdk.propertyValidator("instanceArn", cdk.validateString)(properties.instanceArn)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("quickConnectConfig", cdk.requiredValidator)(properties.quickConnectConfig)), errors.collect(cdk.propertyValidator("quickConnectConfig", CfnQuickConnect_QuickConnectConfigPropertyValidator)(properties.quickConnectConfig)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnQuickConnectProps"');
    }
    function cfnQuickConnectPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnQuickConnectPropsValidator(properties).assertSuccess(), { InstanceArn: cdk.stringToCloudFormation(properties.instanceArn), Name: cdk.stringToCloudFormation(properties.name), QuickConnectConfig: cfnQuickConnectQuickConnectConfigPropertyToCloudFormation(properties.quickConnectConfig), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnQuickConnectPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceArn", "InstanceArn", cfn_parse.FromCloudFormation.getString(properties.InstanceArn)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("quickConnectConfig", "QuickConnectConfig", CfnQuickConnectQuickConnectConfigPropertyFromCloudFormation(properties.QuickConnectConfig)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnQuickConnect = class _CfnQuickConnect extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnQuickConnectPropsFromCloudFormation(resourceProperties), ret = new _CfnQuickConnect(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnQuickConnect.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_connect_CfnQuickConnectProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnQuickConnect), error;
        }
        cdk.requireProperty(props, "instanceArn", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "quickConnectConfig", this), this.attrQuickConnectArn = cdk.Token.asString(this.getAtt("QuickConnectArn", cdk.ResolutionTypeHint.STRING)), this.instanceArn = props.instanceArn, this.name = props.name, this.quickConnectConfig = props.quickConnectConfig, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Connect::QuickConnect", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnQuickConnect.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { instanceArn: this.instanceArn, name: this.name, quickConnectConfig: this.quickConnectConfig, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnQuickConnectPropsToCloudFormation(props);
      }
    };
    _k = JSII_RTTI_SYMBOL_1, CfnQuickConnect[_k] = { fqn: "aws-cdk-lib.aws_connect.CfnQuickConnect", version: "2.80.0" }, CfnQuickConnect.CFN_RESOURCE_TYPE_NAME = "AWS::Connect::QuickConnect", exports2.CfnQuickConnect = CfnQuickConnect;
    function CfnQuickConnect_PhoneNumberQuickConnectConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("phoneNumber", cdk.requiredValidator)(properties.phoneNumber)), errors.collect(cdk.propertyValidator("phoneNumber", cdk.validateString)(properties.phoneNumber)), errors.wrap('supplied properties not correct for "PhoneNumberQuickConnectConfigProperty"');
    }
    function cfnQuickConnectPhoneNumberQuickConnectConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnQuickConnect_PhoneNumberQuickConnectConfigPropertyValidator(properties).assertSuccess(), { PhoneNumber: cdk.stringToCloudFormation(properties.phoneNumber) }) : properties;
    }
    function CfnQuickConnectPhoneNumberQuickConnectConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("phoneNumber", "PhoneNumber", cfn_parse.FromCloudFormation.getString(properties.PhoneNumber)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnQuickConnect_QueueQuickConnectConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contactFlowArn", cdk.requiredValidator)(properties.contactFlowArn)), errors.collect(cdk.propertyValidator("contactFlowArn", cdk.validateString)(properties.contactFlowArn)), errors.collect(cdk.propertyValidator("queueArn", cdk.requiredValidator)(properties.queueArn)), errors.collect(cdk.propertyValidator("queueArn", cdk.validateString)(properties.queueArn)), errors.wrap('supplied properties not correct for "QueueQuickConnectConfigProperty"');
    }
    function cfnQuickConnectQueueQuickConnectConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnQuickConnect_QueueQuickConnectConfigPropertyValidator(properties).assertSuccess(), { ContactFlowArn: cdk.stringToCloudFormation(properties.contactFlowArn), QueueArn: cdk.stringToCloudFormation(properties.queueArn) }) : properties;
    }
    function CfnQuickConnectQueueQuickConnectConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contactFlowArn", "ContactFlowArn", cfn_parse.FromCloudFormation.getString(properties.ContactFlowArn)), ret.addPropertyResult("queueArn", "QueueArn", cfn_parse.FromCloudFormation.getString(properties.QueueArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnQuickConnect_QuickConnectConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("phoneConfig", CfnQuickConnect_PhoneNumberQuickConnectConfigPropertyValidator)(properties.phoneConfig)), errors.collect(cdk.propertyValidator("queueConfig", CfnQuickConnect_QueueQuickConnectConfigPropertyValidator)(properties.queueConfig)), errors.collect(cdk.propertyValidator("quickConnectType", cdk.requiredValidator)(properties.quickConnectType)), errors.collect(cdk.propertyValidator("quickConnectType", cdk.validateString)(properties.quickConnectType)), errors.collect(cdk.propertyValidator("userConfig", CfnQuickConnect_UserQuickConnectConfigPropertyValidator)(properties.userConfig)), errors.wrap('supplied properties not correct for "QuickConnectConfigProperty"');
    }
    function cfnQuickConnectQuickConnectConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnQuickConnect_QuickConnectConfigPropertyValidator(properties).assertSuccess(), { PhoneConfig: cfnQuickConnectPhoneNumberQuickConnectConfigPropertyToCloudFormation(properties.phoneConfig), QueueConfig: cfnQuickConnectQueueQuickConnectConfigPropertyToCloudFormation(properties.queueConfig), QuickConnectType: cdk.stringToCloudFormation(properties.quickConnectType), UserConfig: cfnQuickConnectUserQuickConnectConfigPropertyToCloudFormation(properties.userConfig) }) : properties;
    }
    function CfnQuickConnectQuickConnectConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("phoneConfig", "PhoneConfig", properties.PhoneConfig != null ? CfnQuickConnectPhoneNumberQuickConnectConfigPropertyFromCloudFormation(properties.PhoneConfig) : void 0), ret.addPropertyResult("queueConfig", "QueueConfig", properties.QueueConfig != null ? CfnQuickConnectQueueQuickConnectConfigPropertyFromCloudFormation(properties.QueueConfig) : void 0), ret.addPropertyResult("quickConnectType", "QuickConnectType", cfn_parse.FromCloudFormation.getString(properties.QuickConnectType)), ret.addPropertyResult("userConfig", "UserConfig", properties.UserConfig != null ? CfnQuickConnectUserQuickConnectConfigPropertyFromCloudFormation(properties.UserConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnQuickConnect_UserQuickConnectConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contactFlowArn", cdk.requiredValidator)(properties.contactFlowArn)), errors.collect(cdk.propertyValidator("contactFlowArn", cdk.validateString)(properties.contactFlowArn)), errors.collect(cdk.propertyValidator("userArn", cdk.requiredValidator)(properties.userArn)), errors.collect(cdk.propertyValidator("userArn", cdk.validateString)(properties.userArn)), errors.wrap('supplied properties not correct for "UserQuickConnectConfigProperty"');
    }
    function cfnQuickConnectUserQuickConnectConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnQuickConnect_UserQuickConnectConfigPropertyValidator(properties).assertSuccess(), { ContactFlowArn: cdk.stringToCloudFormation(properties.contactFlowArn), UserArn: cdk.stringToCloudFormation(properties.userArn) }) : properties;
    }
    function CfnQuickConnectUserQuickConnectConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contactFlowArn", "ContactFlowArn", cfn_parse.FromCloudFormation.getString(properties.ContactFlowArn)), ret.addPropertyResult("userArn", "UserArn", cfn_parse.FromCloudFormation.getString(properties.UserArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRulePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.requiredValidator)(properties.actions)), errors.collect(cdk.propertyValidator("actions", CfnRule_ActionsPropertyValidator)(properties.actions)), errors.collect(cdk.propertyValidator("function", cdk.requiredValidator)(properties.function)), errors.collect(cdk.propertyValidator("function", cdk.validateString)(properties.function)), errors.collect(cdk.propertyValidator("instanceArn", cdk.requiredValidator)(properties.instanceArn)), errors.collect(cdk.propertyValidator("instanceArn", cdk.validateString)(properties.instanceArn)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("publishStatus", cdk.requiredValidator)(properties.publishStatus)), errors.collect(cdk.propertyValidator("publishStatus", cdk.validateString)(properties.publishStatus)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("triggerEventSource", cdk.requiredValidator)(properties.triggerEventSource)), errors.collect(cdk.propertyValidator("triggerEventSource", CfnRule_RuleTriggerEventSourcePropertyValidator)(properties.triggerEventSource)), errors.wrap('supplied properties not correct for "CfnRuleProps"');
    }
    function cfnRulePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRulePropsValidator(properties).assertSuccess(), { Actions: cfnRuleActionsPropertyToCloudFormation(properties.actions), Function: cdk.stringToCloudFormation(properties.function), InstanceArn: cdk.stringToCloudFormation(properties.instanceArn), Name: cdk.stringToCloudFormation(properties.name), PublishStatus: cdk.stringToCloudFormation(properties.publishStatus), TriggerEventSource: cfnRuleRuleTriggerEventSourcePropertyToCloudFormation(properties.triggerEventSource), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnRulePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", CfnRuleActionsPropertyFromCloudFormation(properties.Actions)), ret.addPropertyResult("function", "Function", cfn_parse.FromCloudFormation.getString(properties.Function)), ret.addPropertyResult("instanceArn", "InstanceArn", cfn_parse.FromCloudFormation.getString(properties.InstanceArn)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("publishStatus", "PublishStatus", cfn_parse.FromCloudFormation.getString(properties.PublishStatus)), ret.addPropertyResult("triggerEventSource", "TriggerEventSource", CfnRuleRuleTriggerEventSourcePropertyFromCloudFormation(properties.TriggerEventSource)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRule = class _CfnRule extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRulePropsFromCloudFormation(resourceProperties), ret = new _CfnRule(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRule.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_connect_CfnRuleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRule), error;
        }
        cdk.requireProperty(props, "actions", this), cdk.requireProperty(props, "function", this), cdk.requireProperty(props, "instanceArn", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "publishStatus", this), cdk.requireProperty(props, "triggerEventSource", this), this.attrRuleArn = cdk.Token.asString(this.getAtt("RuleArn", cdk.ResolutionTypeHint.STRING)), this.actions = props.actions, this.function = props.function, this.instanceArn = props.instanceArn, this.name = props.name, this.publishStatus = props.publishStatus, this.triggerEventSource = props.triggerEventSource, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Connect::Rule", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRule.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { actions: this.actions, function: this.function, instanceArn: this.instanceArn, name: this.name, publishStatus: this.publishStatus, triggerEventSource: this.triggerEventSource, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnRulePropsToCloudFormation(props);
      }
    };
    _l = JSII_RTTI_SYMBOL_1, CfnRule[_l] = { fqn: "aws-cdk-lib.aws_connect.CfnRule", version: "2.80.0" }, CfnRule.CFN_RESOURCE_TYPE_NAME = "AWS::Connect::Rule", exports2.CfnRule = CfnRule;
    function CfnRule_ActionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("assignContactCategoryActions", cdk.listValidator(cdk.validateObject))(properties.assignContactCategoryActions)), errors.collect(cdk.propertyValidator("eventBridgeActions", cdk.listValidator(CfnRule_EventBridgeActionPropertyValidator))(properties.eventBridgeActions)), errors.collect(cdk.propertyValidator("sendNotificationActions", cdk.listValidator(CfnRule_SendNotificationActionPropertyValidator))(properties.sendNotificationActions)), errors.collect(cdk.propertyValidator("taskActions", cdk.listValidator(CfnRule_TaskActionPropertyValidator))(properties.taskActions)), errors.wrap('supplied properties not correct for "ActionsProperty"');
    }
    function cfnRuleActionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_ActionsPropertyValidator(properties).assertSuccess(), { AssignContactCategoryActions: cdk.listMapper(cdk.objectToCloudFormation)(properties.assignContactCategoryActions), EventBridgeActions: cdk.listMapper(cfnRuleEventBridgeActionPropertyToCloudFormation)(properties.eventBridgeActions), SendNotificationActions: cdk.listMapper(cfnRuleSendNotificationActionPropertyToCloudFormation)(properties.sendNotificationActions), TaskActions: cdk.listMapper(cfnRuleTaskActionPropertyToCloudFormation)(properties.taskActions) }) : properties;
    }
    function CfnRuleActionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("assignContactCategoryActions", "AssignContactCategoryActions", properties.AssignContactCategoryActions != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getAny)(properties.AssignContactCategoryActions) : void 0), ret.addPropertyResult("eventBridgeActions", "EventBridgeActions", properties.EventBridgeActions != null ? cfn_parse.FromCloudFormation.getArray(CfnRuleEventBridgeActionPropertyFromCloudFormation)(properties.EventBridgeActions) : void 0), ret.addPropertyResult("sendNotificationActions", "SendNotificationActions", properties.SendNotificationActions != null ? cfn_parse.FromCloudFormation.getArray(CfnRuleSendNotificationActionPropertyFromCloudFormation)(properties.SendNotificationActions) : void 0), ret.addPropertyResult("taskActions", "TaskActions", properties.TaskActions != null ? cfn_parse.FromCloudFormation.getArray(CfnRuleTaskActionPropertyFromCloudFormation)(properties.TaskActions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_EventBridgeActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "EventBridgeActionProperty"');
    }
    function cfnRuleEventBridgeActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_EventBridgeActionPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnRuleEventBridgeActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_NotificationRecipientTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("userArns", cdk.listValidator(cdk.validateString))(properties.userArns)), errors.collect(cdk.propertyValidator("userTags", cdk.hashValidator(cdk.validateString))(properties.userTags)), errors.wrap('supplied properties not correct for "NotificationRecipientTypeProperty"');
    }
    function cfnRuleNotificationRecipientTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_NotificationRecipientTypePropertyValidator(properties).assertSuccess(), { UserArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.userArns), UserTags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.userTags) }) : properties;
    }
    function CfnRuleNotificationRecipientTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("userArns", "UserArns", properties.UserArns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.UserArns) : void 0), ret.addPropertyResult("userTags", "UserTags", properties.UserTags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.UserTags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_ReferencePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "ReferenceProperty"');
    }
    function cfnRuleReferencePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_ReferencePropertyValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnRuleReferencePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_RuleTriggerEventSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("eventSourceName", cdk.requiredValidator)(properties.eventSourceName)), errors.collect(cdk.propertyValidator("eventSourceName", cdk.validateString)(properties.eventSourceName)), errors.collect(cdk.propertyValidator("integrationAssociationArn", cdk.validateString)(properties.integrationAssociationArn)), errors.wrap('supplied properties not correct for "RuleTriggerEventSourceProperty"');
    }
    function cfnRuleRuleTriggerEventSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_RuleTriggerEventSourcePropertyValidator(properties).assertSuccess(), { EventSourceName: cdk.stringToCloudFormation(properties.eventSourceName), IntegrationAssociationArn: cdk.stringToCloudFormation(properties.integrationAssociationArn) }) : properties;
    }
    function CfnRuleRuleTriggerEventSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("eventSourceName", "EventSourceName", cfn_parse.FromCloudFormation.getString(properties.EventSourceName)), ret.addPropertyResult("integrationAssociationArn", "IntegrationAssociationArn", properties.IntegrationAssociationArn != null ? cfn_parse.FromCloudFormation.getString(properties.IntegrationAssociationArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_SendNotificationActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("content", cdk.requiredValidator)(properties.content)), errors.collect(cdk.propertyValidator("content", cdk.validateString)(properties.content)), errors.collect(cdk.propertyValidator("contentType", cdk.requiredValidator)(properties.contentType)), errors.collect(cdk.propertyValidator("contentType", cdk.validateString)(properties.contentType)), errors.collect(cdk.propertyValidator("deliveryMethod", cdk.requiredValidator)(properties.deliveryMethod)), errors.collect(cdk.propertyValidator("deliveryMethod", cdk.validateString)(properties.deliveryMethod)), errors.collect(cdk.propertyValidator("recipient", cdk.requiredValidator)(properties.recipient)), errors.collect(cdk.propertyValidator("recipient", CfnRule_NotificationRecipientTypePropertyValidator)(properties.recipient)), errors.collect(cdk.propertyValidator("subject", cdk.validateString)(properties.subject)), errors.wrap('supplied properties not correct for "SendNotificationActionProperty"');
    }
    function cfnRuleSendNotificationActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_SendNotificationActionPropertyValidator(properties).assertSuccess(), { Content: cdk.stringToCloudFormation(properties.content), ContentType: cdk.stringToCloudFormation(properties.contentType), DeliveryMethod: cdk.stringToCloudFormation(properties.deliveryMethod), Recipient: cfnRuleNotificationRecipientTypePropertyToCloudFormation(properties.recipient), Subject: cdk.stringToCloudFormation(properties.subject) }) : properties;
    }
    function CfnRuleSendNotificationActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("content", "Content", cfn_parse.FromCloudFormation.getString(properties.Content)), ret.addPropertyResult("contentType", "ContentType", cfn_parse.FromCloudFormation.getString(properties.ContentType)), ret.addPropertyResult("deliveryMethod", "DeliveryMethod", cfn_parse.FromCloudFormation.getString(properties.DeliveryMethod)), ret.addPropertyResult("recipient", "Recipient", CfnRuleNotificationRecipientTypePropertyFromCloudFormation(properties.Recipient)), ret.addPropertyResult("subject", "Subject", properties.Subject != null ? cfn_parse.FromCloudFormation.getString(properties.Subject) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_TaskActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contactFlowArn", cdk.requiredValidator)(properties.contactFlowArn)), errors.collect(cdk.propertyValidator("contactFlowArn", cdk.validateString)(properties.contactFlowArn)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("references", cdk.hashValidator(CfnRule_ReferencePropertyValidator))(properties.references)), errors.wrap('supplied properties not correct for "TaskActionProperty"');
    }
    function cfnRuleTaskActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_TaskActionPropertyValidator(properties).assertSuccess(), { ContactFlowArn: cdk.stringToCloudFormation(properties.contactFlowArn), Description: cdk.stringToCloudFormation(properties.description), Name: cdk.stringToCloudFormation(properties.name), References: cdk.hashMapper(cfnRuleReferencePropertyToCloudFormation)(properties.references) }) : properties;
    }
    function CfnRuleTaskActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contactFlowArn", "ContactFlowArn", cfn_parse.FromCloudFormation.getString(properties.ContactFlowArn)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("references", "References", properties.References != null ? cfn_parse.FromCloudFormation.getMap(CfnRuleReferencePropertyFromCloudFormation)(properties.References) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSecurityKeyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceId", cdk.requiredValidator)(properties.instanceId)), errors.collect(cdk.propertyValidator("instanceId", cdk.validateString)(properties.instanceId)), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.wrap('supplied properties not correct for "CfnSecurityKeyProps"');
    }
    function cfnSecurityKeyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSecurityKeyPropsValidator(properties).assertSuccess(), { InstanceId: cdk.stringToCloudFormation(properties.instanceId), Key: cdk.stringToCloudFormation(properties.key) }) : properties;
    }
    function CfnSecurityKeyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceId", "InstanceId", cfn_parse.FromCloudFormation.getString(properties.InstanceId)), ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSecurityKey = class _CfnSecurityKey extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSecurityKeyPropsFromCloudFormation(resourceProperties), ret = new _CfnSecurityKey(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSecurityKey.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_connect_CfnSecurityKeyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSecurityKey), error;
        }
        cdk.requireProperty(props, "instanceId", this), cdk.requireProperty(props, "key", this), this.attrAssociationId = cdk.Token.asString(this.getAtt("AssociationId", cdk.ResolutionTypeHint.STRING)), this.instanceId = props.instanceId, this.key = props.key;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSecurityKey.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { instanceId: this.instanceId, key: this.key };
      }
      renderProperties(props) {
        return cfnSecurityKeyPropsToCloudFormation(props);
      }
    };
    _m = JSII_RTTI_SYMBOL_1, CfnSecurityKey[_m] = { fqn: "aws-cdk-lib.aws_connect.CfnSecurityKey", version: "2.80.0" }, CfnSecurityKey.CFN_RESOURCE_TYPE_NAME = "AWS::Connect::SecurityKey", exports2.CfnSecurityKey = CfnSecurityKey;
    function CfnTaskTemplatePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clientToken", cdk.validateString)(properties.clientToken)), errors.collect(cdk.propertyValidator("constraints", cdk.validateObject)(properties.constraints)), errors.collect(cdk.propertyValidator("contactFlowArn", cdk.validateString)(properties.contactFlowArn)), errors.collect(cdk.propertyValidator("defaults", cdk.listValidator(CfnTaskTemplate_DefaultFieldValuePropertyValidator))(properties.defaults)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("fields", cdk.listValidator(CfnTaskTemplate_FieldPropertyValidator))(properties.fields)), errors.collect(cdk.propertyValidator("instanceArn", cdk.requiredValidator)(properties.instanceArn)), errors.collect(cdk.propertyValidator("instanceArn", cdk.validateString)(properties.instanceArn)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnTaskTemplateProps"');
    }
    function cfnTaskTemplatePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskTemplatePropsValidator(properties).assertSuccess(), { InstanceArn: cdk.stringToCloudFormation(properties.instanceArn), ClientToken: cdk.stringToCloudFormation(properties.clientToken), Constraints: cdk.objectToCloudFormation(properties.constraints), ContactFlowArn: cdk.stringToCloudFormation(properties.contactFlowArn), Defaults: cdk.listMapper(cfnTaskTemplateDefaultFieldValuePropertyToCloudFormation)(properties.defaults), Description: cdk.stringToCloudFormation(properties.description), Fields: cdk.listMapper(cfnTaskTemplateFieldPropertyToCloudFormation)(properties.fields), Name: cdk.stringToCloudFormation(properties.name), Status: cdk.stringToCloudFormation(properties.status), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnTaskTemplatePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceArn", "InstanceArn", cfn_parse.FromCloudFormation.getString(properties.InstanceArn)), ret.addPropertyResult("clientToken", "ClientToken", properties.ClientToken != null ? cfn_parse.FromCloudFormation.getString(properties.ClientToken) : void 0), ret.addPropertyResult("constraints", "Constraints", properties.Constraints != null ? cfn_parse.FromCloudFormation.getAny(properties.Constraints) : void 0), ret.addPropertyResult("contactFlowArn", "ContactFlowArn", properties.ContactFlowArn != null ? cfn_parse.FromCloudFormation.getString(properties.ContactFlowArn) : void 0), ret.addPropertyResult("defaults", "Defaults", properties.Defaults != null ? cfn_parse.FromCloudFormation.getArray(CfnTaskTemplateDefaultFieldValuePropertyFromCloudFormation)(properties.Defaults) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("fields", "Fields", properties.Fields != null ? cfn_parse.FromCloudFormation.getArray(CfnTaskTemplateFieldPropertyFromCloudFormation)(properties.Fields) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTaskTemplate = class _CfnTaskTemplate extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTaskTemplatePropsFromCloudFormation(resourceProperties), ret = new _CfnTaskTemplate(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTaskTemplate.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_connect_CfnTaskTemplateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTaskTemplate), error;
        }
        cdk.requireProperty(props, "instanceArn", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.instanceArn = props.instanceArn, this.clientToken = props.clientToken, this.constraints = props.constraints, this.contactFlowArn = props.contactFlowArn, this.defaults = props.defaults, this.description = props.description, this.fields = props.fields, this.name = props.name, this.status = props.status, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Connect::TaskTemplate", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTaskTemplate.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { instanceArn: this.instanceArn, clientToken: this.clientToken, constraints: this.constraints, contactFlowArn: this.contactFlowArn, defaults: this.defaults, description: this.description, fields: this.fields, name: this.name, status: this.status, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnTaskTemplatePropsToCloudFormation(props);
      }
    };
    _o = JSII_RTTI_SYMBOL_1, CfnTaskTemplate[_o] = { fqn: "aws-cdk-lib.aws_connect.CfnTaskTemplate", version: "2.80.0" }, CfnTaskTemplate.CFN_RESOURCE_TYPE_NAME = "AWS::Connect::TaskTemplate", exports2.CfnTaskTemplate = CfnTaskTemplate;
    function CfnTaskTemplate_DefaultFieldValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultValue", cdk.requiredValidator)(properties.defaultValue)), errors.collect(cdk.propertyValidator("defaultValue", cdk.validateString)(properties.defaultValue)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", CfnTaskTemplate_FieldIdentifierPropertyValidator)(properties.id)), errors.wrap('supplied properties not correct for "DefaultFieldValueProperty"');
    }
    function cfnTaskTemplateDefaultFieldValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskTemplate_DefaultFieldValuePropertyValidator(properties).assertSuccess(), { DefaultValue: cdk.stringToCloudFormation(properties.defaultValue), Id: cfnTaskTemplateFieldIdentifierPropertyToCloudFormation(properties.id) }) : properties;
    }
    function CfnTaskTemplateDefaultFieldValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultValue", "DefaultValue", cfn_parse.FromCloudFormation.getString(properties.DefaultValue)), ret.addPropertyResult("id", "Id", CfnTaskTemplateFieldIdentifierPropertyFromCloudFormation(properties.Id)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskTemplate_FieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", CfnTaskTemplate_FieldIdentifierPropertyValidator)(properties.id)), errors.collect(cdk.propertyValidator("singleSelectOptions", cdk.listValidator(cdk.validateString))(properties.singleSelectOptions)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "FieldProperty"');
    }
    function cfnTaskTemplateFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskTemplate_FieldPropertyValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), Id: cfnTaskTemplateFieldIdentifierPropertyToCloudFormation(properties.id), SingleSelectOptions: cdk.listMapper(cdk.stringToCloudFormation)(properties.singleSelectOptions), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnTaskTemplateFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("id", "Id", CfnTaskTemplateFieldIdentifierPropertyFromCloudFormation(properties.Id)), ret.addPropertyResult("singleSelectOptions", "SingleSelectOptions", properties.SingleSelectOptions != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SingleSelectOptions) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskTemplate_FieldIdentifierPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "FieldIdentifierProperty"');
    }
    function cfnTaskTemplateFieldIdentifierPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskTemplate_FieldIdentifierPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnTaskTemplateFieldIdentifierPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("directoryUserId", cdk.validateString)(properties.directoryUserId)), errors.collect(cdk.propertyValidator("hierarchyGroupArn", cdk.validateString)(properties.hierarchyGroupArn)), errors.collect(cdk.propertyValidator("identityInfo", CfnUser_UserIdentityInfoPropertyValidator)(properties.identityInfo)), errors.collect(cdk.propertyValidator("instanceArn", cdk.requiredValidator)(properties.instanceArn)), errors.collect(cdk.propertyValidator("instanceArn", cdk.validateString)(properties.instanceArn)), errors.collect(cdk.propertyValidator("password", cdk.validateString)(properties.password)), errors.collect(cdk.propertyValidator("phoneConfig", cdk.requiredValidator)(properties.phoneConfig)), errors.collect(cdk.propertyValidator("phoneConfig", CfnUser_UserPhoneConfigPropertyValidator)(properties.phoneConfig)), errors.collect(cdk.propertyValidator("routingProfileArn", cdk.requiredValidator)(properties.routingProfileArn)), errors.collect(cdk.propertyValidator("routingProfileArn", cdk.validateString)(properties.routingProfileArn)), errors.collect(cdk.propertyValidator("securityProfileArns", cdk.requiredValidator)(properties.securityProfileArns)), errors.collect(cdk.propertyValidator("securityProfileArns", cdk.listValidator(cdk.validateString))(properties.securityProfileArns)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("username", cdk.requiredValidator)(properties.username)), errors.collect(cdk.propertyValidator("username", cdk.validateString)(properties.username)), errors.wrap('supplied properties not correct for "CfnUserProps"');
    }
    function cfnUserPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPropsValidator(properties).assertSuccess(), { InstanceArn: cdk.stringToCloudFormation(properties.instanceArn), PhoneConfig: cfnUserUserPhoneConfigPropertyToCloudFormation(properties.phoneConfig), RoutingProfileArn: cdk.stringToCloudFormation(properties.routingProfileArn), SecurityProfileArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityProfileArns), Username: cdk.stringToCloudFormation(properties.username), DirectoryUserId: cdk.stringToCloudFormation(properties.directoryUserId), HierarchyGroupArn: cdk.stringToCloudFormation(properties.hierarchyGroupArn), IdentityInfo: cfnUserUserIdentityInfoPropertyToCloudFormation(properties.identityInfo), Password: cdk.stringToCloudFormation(properties.password), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnUserPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceArn", "InstanceArn", cfn_parse.FromCloudFormation.getString(properties.InstanceArn)), ret.addPropertyResult("phoneConfig", "PhoneConfig", CfnUserUserPhoneConfigPropertyFromCloudFormation(properties.PhoneConfig)), ret.addPropertyResult("routingProfileArn", "RoutingProfileArn", cfn_parse.FromCloudFormation.getString(properties.RoutingProfileArn)), ret.addPropertyResult("securityProfileArns", "SecurityProfileArns", cfn_parse.FromCloudFormation.getStringArray(properties.SecurityProfileArns)), ret.addPropertyResult("username", "Username", cfn_parse.FromCloudFormation.getString(properties.Username)), ret.addPropertyResult("directoryUserId", "DirectoryUserId", properties.DirectoryUserId != null ? cfn_parse.FromCloudFormation.getString(properties.DirectoryUserId) : void 0), ret.addPropertyResult("hierarchyGroupArn", "HierarchyGroupArn", properties.HierarchyGroupArn != null ? cfn_parse.FromCloudFormation.getString(properties.HierarchyGroupArn) : void 0), ret.addPropertyResult("identityInfo", "IdentityInfo", properties.IdentityInfo != null ? CfnUserUserIdentityInfoPropertyFromCloudFormation(properties.IdentityInfo) : void 0), ret.addPropertyResult("password", "Password", properties.Password != null ? cfn_parse.FromCloudFormation.getString(properties.Password) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnUser = class _CfnUser extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnUserPropsFromCloudFormation(resourceProperties), ret = new _CfnUser(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnUser.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_connect_CfnUserProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnUser), error;
        }
        cdk.requireProperty(props, "instanceArn", this), cdk.requireProperty(props, "phoneConfig", this), cdk.requireProperty(props, "routingProfileArn", this), cdk.requireProperty(props, "securityProfileArns", this), cdk.requireProperty(props, "username", this), this.attrUserArn = cdk.Token.asString(this.getAtt("UserArn", cdk.ResolutionTypeHint.STRING)), this.instanceArn = props.instanceArn, this.phoneConfig = props.phoneConfig, this.routingProfileArn = props.routingProfileArn, this.securityProfileArns = props.securityProfileArns, this.username = props.username, this.directoryUserId = props.directoryUserId, this.hierarchyGroupArn = props.hierarchyGroupArn, this.identityInfo = props.identityInfo, this.password = props.password, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Connect::User", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnUser.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { instanceArn: this.instanceArn, phoneConfig: this.phoneConfig, routingProfileArn: this.routingProfileArn, securityProfileArns: this.securityProfileArns, username: this.username, directoryUserId: this.directoryUserId, hierarchyGroupArn: this.hierarchyGroupArn, identityInfo: this.identityInfo, password: this.password, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnUserPropsToCloudFormation(props);
      }
    };
    _p = JSII_RTTI_SYMBOL_1, CfnUser[_p] = { fqn: "aws-cdk-lib.aws_connect.CfnUser", version: "2.80.0" }, CfnUser.CFN_RESOURCE_TYPE_NAME = "AWS::Connect::User", exports2.CfnUser = CfnUser;
    function CfnUser_UserIdentityInfoPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("email", cdk.validateString)(properties.email)), errors.collect(cdk.propertyValidator("firstName", cdk.validateString)(properties.firstName)), errors.collect(cdk.propertyValidator("lastName", cdk.validateString)(properties.lastName)), errors.collect(cdk.propertyValidator("mobile", cdk.validateString)(properties.mobile)), errors.collect(cdk.propertyValidator("secondaryEmail", cdk.validateString)(properties.secondaryEmail)), errors.wrap('supplied properties not correct for "UserIdentityInfoProperty"');
    }
    function cfnUserUserIdentityInfoPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUser_UserIdentityInfoPropertyValidator(properties).assertSuccess(), { Email: cdk.stringToCloudFormation(properties.email), FirstName: cdk.stringToCloudFormation(properties.firstName), LastName: cdk.stringToCloudFormation(properties.lastName), Mobile: cdk.stringToCloudFormation(properties.mobile), SecondaryEmail: cdk.stringToCloudFormation(properties.secondaryEmail) }) : properties;
    }
    function CfnUserUserIdentityInfoPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("email", "Email", properties.Email != null ? cfn_parse.FromCloudFormation.getString(properties.Email) : void 0), ret.addPropertyResult("firstName", "FirstName", properties.FirstName != null ? cfn_parse.FromCloudFormation.getString(properties.FirstName) : void 0), ret.addPropertyResult("lastName", "LastName", properties.LastName != null ? cfn_parse.FromCloudFormation.getString(properties.LastName) : void 0), ret.addPropertyResult("mobile", "Mobile", properties.Mobile != null ? cfn_parse.FromCloudFormation.getString(properties.Mobile) : void 0), ret.addPropertyResult("secondaryEmail", "SecondaryEmail", properties.SecondaryEmail != null ? cfn_parse.FromCloudFormation.getString(properties.SecondaryEmail) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUser_UserPhoneConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("afterContactWorkTimeLimit", cdk.validateNumber)(properties.afterContactWorkTimeLimit)), errors.collect(cdk.propertyValidator("autoAccept", cdk.validateBoolean)(properties.autoAccept)), errors.collect(cdk.propertyValidator("deskPhoneNumber", cdk.validateString)(properties.deskPhoneNumber)), errors.collect(cdk.propertyValidator("phoneType", cdk.requiredValidator)(properties.phoneType)), errors.collect(cdk.propertyValidator("phoneType", cdk.validateString)(properties.phoneType)), errors.wrap('supplied properties not correct for "UserPhoneConfigProperty"');
    }
    function cfnUserUserPhoneConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUser_UserPhoneConfigPropertyValidator(properties).assertSuccess(), { AfterContactWorkTimeLimit: cdk.numberToCloudFormation(properties.afterContactWorkTimeLimit), AutoAccept: cdk.booleanToCloudFormation(properties.autoAccept), DeskPhoneNumber: cdk.stringToCloudFormation(properties.deskPhoneNumber), PhoneType: cdk.stringToCloudFormation(properties.phoneType) }) : properties;
    }
    function CfnUserUserPhoneConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("afterContactWorkTimeLimit", "AfterContactWorkTimeLimit", properties.AfterContactWorkTimeLimit != null ? cfn_parse.FromCloudFormation.getNumber(properties.AfterContactWorkTimeLimit) : void 0), ret.addPropertyResult("autoAccept", "AutoAccept", properties.AutoAccept != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AutoAccept) : void 0), ret.addPropertyResult("deskPhoneNumber", "DeskPhoneNumber", properties.DeskPhoneNumber != null ? cfn_parse.FromCloudFormation.getString(properties.DeskPhoneNumber) : void 0), ret.addPropertyResult("phoneType", "PhoneType", cfn_parse.FromCloudFormation.getString(properties.PhoneType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserHierarchyGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceArn", cdk.requiredValidator)(properties.instanceArn)), errors.collect(cdk.propertyValidator("instanceArn", cdk.validateString)(properties.instanceArn)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("parentGroupArn", cdk.validateString)(properties.parentGroupArn)), errors.wrap('supplied properties not correct for "CfnUserHierarchyGroupProps"');
    }
    function cfnUserHierarchyGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserHierarchyGroupPropsValidator(properties).assertSuccess(), { InstanceArn: cdk.stringToCloudFormation(properties.instanceArn), Name: cdk.stringToCloudFormation(properties.name), ParentGroupArn: cdk.stringToCloudFormation(properties.parentGroupArn) }) : properties;
    }
    function CfnUserHierarchyGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceArn", "InstanceArn", cfn_parse.FromCloudFormation.getString(properties.InstanceArn)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("parentGroupArn", "ParentGroupArn", properties.ParentGroupArn != null ? cfn_parse.FromCloudFormation.getString(properties.ParentGroupArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnUserHierarchyGroup = class _CfnUserHierarchyGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnUserHierarchyGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnUserHierarchyGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnUserHierarchyGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_connect_CfnUserHierarchyGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnUserHierarchyGroup), error;
        }
        cdk.requireProperty(props, "instanceArn", this), cdk.requireProperty(props, "name", this), this.attrUserHierarchyGroupArn = cdk.Token.asString(this.getAtt("UserHierarchyGroupArn", cdk.ResolutionTypeHint.STRING)), this.instanceArn = props.instanceArn, this.name = props.name, this.parentGroupArn = props.parentGroupArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnUserHierarchyGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { instanceArn: this.instanceArn, name: this.name, parentGroupArn: this.parentGroupArn };
      }
      renderProperties(props) {
        return cfnUserHierarchyGroupPropsToCloudFormation(props);
      }
    };
    _q = JSII_RTTI_SYMBOL_1, CfnUserHierarchyGroup[_q] = { fqn: "aws-cdk-lib.aws_connect.CfnUserHierarchyGroup", version: "2.80.0" }, CfnUserHierarchyGroup.CFN_RESOURCE_TYPE_NAME = "AWS::Connect::UserHierarchyGroup", exports2.CfnUserHierarchyGroup = CfnUserHierarchyGroup;
  }
});

// node_modules/aws-cdk-lib/aws-connect/lib/index.js
var require_lib91 = __commonJS({
  "node_modules/aws-cdk-lib/aws-connect/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_connect_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-connect/index.js
var require_aws_connect = __commonJS({
  "node_modules/aws-cdk-lib/aws-connect/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib91(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-connectcampaigns/lib/connectcampaigns.generated.js
var require_connectcampaigns_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-connectcampaigns/lib/connectcampaigns.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnCampaign = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnCampaignPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectInstanceArn", cdk.requiredValidator)(properties.connectInstanceArn)), errors.collect(cdk.propertyValidator("connectInstanceArn", cdk.validateString)(properties.connectInstanceArn)), errors.collect(cdk.propertyValidator("dialerConfig", cdk.requiredValidator)(properties.dialerConfig)), errors.collect(cdk.propertyValidator("dialerConfig", CfnCampaign_DialerConfigPropertyValidator)(properties.dialerConfig)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("outboundCallConfig", cdk.requiredValidator)(properties.outboundCallConfig)), errors.collect(cdk.propertyValidator("outboundCallConfig", CfnCampaign_OutboundCallConfigPropertyValidator)(properties.outboundCallConfig)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnCampaignProps"');
    }
    function cfnCampaignPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaignPropsValidator(properties).assertSuccess(), { ConnectInstanceArn: cdk.stringToCloudFormation(properties.connectInstanceArn), DialerConfig: cfnCampaignDialerConfigPropertyToCloudFormation(properties.dialerConfig), Name: cdk.stringToCloudFormation(properties.name), OutboundCallConfig: cfnCampaignOutboundCallConfigPropertyToCloudFormation(properties.outboundCallConfig), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnCampaignPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectInstanceArn", "ConnectInstanceArn", cfn_parse.FromCloudFormation.getString(properties.ConnectInstanceArn)), ret.addPropertyResult("dialerConfig", "DialerConfig", CfnCampaignDialerConfigPropertyFromCloudFormation(properties.DialerConfig)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("outboundCallConfig", "OutboundCallConfig", CfnCampaignOutboundCallConfigPropertyFromCloudFormation(properties.OutboundCallConfig)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCampaign = class _CfnCampaign extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCampaignPropsFromCloudFormation(resourceProperties), ret = new _CfnCampaign(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCampaign.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_connectcampaigns_CfnCampaignProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCampaign), error;
        }
        cdk.requireProperty(props, "connectInstanceArn", this), cdk.requireProperty(props, "dialerConfig", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "outboundCallConfig", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.connectInstanceArn = props.connectInstanceArn, this.dialerConfig = props.dialerConfig, this.name = props.name, this.outboundCallConfig = props.outboundCallConfig, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ConnectCampaigns::Campaign", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCampaign.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { connectInstanceArn: this.connectInstanceArn, dialerConfig: this.dialerConfig, name: this.name, outboundCallConfig: this.outboundCallConfig, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnCampaignPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnCampaign[_a] = { fqn: "aws-cdk-lib.aws_connectcampaigns.CfnCampaign", version: "2.80.0" }, CfnCampaign.CFN_RESOURCE_TYPE_NAME = "AWS::ConnectCampaigns::Campaign", exports2.CfnCampaign = CfnCampaign;
    function CfnCampaign_AnswerMachineDetectionConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enableAnswerMachineDetection", cdk.requiredValidator)(properties.enableAnswerMachineDetection)), errors.collect(cdk.propertyValidator("enableAnswerMachineDetection", cdk.validateBoolean)(properties.enableAnswerMachineDetection)), errors.wrap('supplied properties not correct for "AnswerMachineDetectionConfigProperty"');
    }
    function cfnCampaignAnswerMachineDetectionConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_AnswerMachineDetectionConfigPropertyValidator(properties).assertSuccess(), { EnableAnswerMachineDetection: cdk.booleanToCloudFormation(properties.enableAnswerMachineDetection) }) : properties;
    }
    function CfnCampaignAnswerMachineDetectionConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enableAnswerMachineDetection", "EnableAnswerMachineDetection", cfn_parse.FromCloudFormation.getBoolean(properties.EnableAnswerMachineDetection)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCampaign_DialerConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("predictiveDialerConfig", CfnCampaign_PredictiveDialerConfigPropertyValidator)(properties.predictiveDialerConfig)), errors.collect(cdk.propertyValidator("progressiveDialerConfig", CfnCampaign_ProgressiveDialerConfigPropertyValidator)(properties.progressiveDialerConfig)), errors.wrap('supplied properties not correct for "DialerConfigProperty"');
    }
    function cfnCampaignDialerConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_DialerConfigPropertyValidator(properties).assertSuccess(), { PredictiveDialerConfig: cfnCampaignPredictiveDialerConfigPropertyToCloudFormation(properties.predictiveDialerConfig), ProgressiveDialerConfig: cfnCampaignProgressiveDialerConfigPropertyToCloudFormation(properties.progressiveDialerConfig) }) : properties;
    }
    function CfnCampaignDialerConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("predictiveDialerConfig", "PredictiveDialerConfig", properties.PredictiveDialerConfig != null ? CfnCampaignPredictiveDialerConfigPropertyFromCloudFormation(properties.PredictiveDialerConfig) : void 0), ret.addPropertyResult("progressiveDialerConfig", "ProgressiveDialerConfig", properties.ProgressiveDialerConfig != null ? CfnCampaignProgressiveDialerConfigPropertyFromCloudFormation(properties.ProgressiveDialerConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCampaign_OutboundCallConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("answerMachineDetectionConfig", CfnCampaign_AnswerMachineDetectionConfigPropertyValidator)(properties.answerMachineDetectionConfig)), errors.collect(cdk.propertyValidator("connectContactFlowArn", cdk.requiredValidator)(properties.connectContactFlowArn)), errors.collect(cdk.propertyValidator("connectContactFlowArn", cdk.validateString)(properties.connectContactFlowArn)), errors.collect(cdk.propertyValidator("connectQueueArn", cdk.requiredValidator)(properties.connectQueueArn)), errors.collect(cdk.propertyValidator("connectQueueArn", cdk.validateString)(properties.connectQueueArn)), errors.collect(cdk.propertyValidator("connectSourcePhoneNumber", cdk.validateString)(properties.connectSourcePhoneNumber)), errors.wrap('supplied properties not correct for "OutboundCallConfigProperty"');
    }
    function cfnCampaignOutboundCallConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_OutboundCallConfigPropertyValidator(properties).assertSuccess(), { AnswerMachineDetectionConfig: cfnCampaignAnswerMachineDetectionConfigPropertyToCloudFormation(properties.answerMachineDetectionConfig), ConnectContactFlowArn: cdk.stringToCloudFormation(properties.connectContactFlowArn), ConnectQueueArn: cdk.stringToCloudFormation(properties.connectQueueArn), ConnectSourcePhoneNumber: cdk.stringToCloudFormation(properties.connectSourcePhoneNumber) }) : properties;
    }
    function CfnCampaignOutboundCallConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("answerMachineDetectionConfig", "AnswerMachineDetectionConfig", properties.AnswerMachineDetectionConfig != null ? CfnCampaignAnswerMachineDetectionConfigPropertyFromCloudFormation(properties.AnswerMachineDetectionConfig) : void 0), ret.addPropertyResult("connectContactFlowArn", "ConnectContactFlowArn", cfn_parse.FromCloudFormation.getString(properties.ConnectContactFlowArn)), ret.addPropertyResult("connectQueueArn", "ConnectQueueArn", cfn_parse.FromCloudFormation.getString(properties.ConnectQueueArn)), ret.addPropertyResult("connectSourcePhoneNumber", "ConnectSourcePhoneNumber", properties.ConnectSourcePhoneNumber != null ? cfn_parse.FromCloudFormation.getString(properties.ConnectSourcePhoneNumber) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCampaign_PredictiveDialerConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bandwidthAllocation", cdk.requiredValidator)(properties.bandwidthAllocation)), errors.collect(cdk.propertyValidator("bandwidthAllocation", cdk.validateNumber)(properties.bandwidthAllocation)), errors.wrap('supplied properties not correct for "PredictiveDialerConfigProperty"');
    }
    function cfnCampaignPredictiveDialerConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_PredictiveDialerConfigPropertyValidator(properties).assertSuccess(), { BandwidthAllocation: cdk.numberToCloudFormation(properties.bandwidthAllocation) }) : properties;
    }
    function CfnCampaignPredictiveDialerConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bandwidthAllocation", "BandwidthAllocation", cfn_parse.FromCloudFormation.getNumber(properties.BandwidthAllocation)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCampaign_ProgressiveDialerConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bandwidthAllocation", cdk.requiredValidator)(properties.bandwidthAllocation)), errors.collect(cdk.propertyValidator("bandwidthAllocation", cdk.validateNumber)(properties.bandwidthAllocation)), errors.wrap('supplied properties not correct for "ProgressiveDialerConfigProperty"');
    }
    function cfnCampaignProgressiveDialerConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_ProgressiveDialerConfigPropertyValidator(properties).assertSuccess(), { BandwidthAllocation: cdk.numberToCloudFormation(properties.bandwidthAllocation) }) : properties;
    }
    function CfnCampaignProgressiveDialerConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bandwidthAllocation", "BandwidthAllocation", cfn_parse.FromCloudFormation.getNumber(properties.BandwidthAllocation)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-connectcampaigns/lib/index.js
var require_lib92 = __commonJS({
  "node_modules/aws-cdk-lib/aws-connectcampaigns/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_connectcampaigns_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-connectcampaigns/index.js
var require_aws_connectcampaigns = __commonJS({
  "node_modules/aws-cdk-lib/aws-connectcampaigns/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib92(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-controltower/lib/controltower.generated.js
var require_controltower_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-controltower/lib/controltower.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnEnabledControl = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnEnabledControlPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("controlIdentifier", cdk.requiredValidator)(properties.controlIdentifier)), errors.collect(cdk.propertyValidator("controlIdentifier", cdk.validateString)(properties.controlIdentifier)), errors.collect(cdk.propertyValidator("targetIdentifier", cdk.requiredValidator)(properties.targetIdentifier)), errors.collect(cdk.propertyValidator("targetIdentifier", cdk.validateString)(properties.targetIdentifier)), errors.wrap('supplied properties not correct for "CfnEnabledControlProps"');
    }
    function cfnEnabledControlPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEnabledControlPropsValidator(properties).assertSuccess(), { ControlIdentifier: cdk.stringToCloudFormation(properties.controlIdentifier), TargetIdentifier: cdk.stringToCloudFormation(properties.targetIdentifier) }) : properties;
    }
    function CfnEnabledControlPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("controlIdentifier", "ControlIdentifier", cfn_parse.FromCloudFormation.getString(properties.ControlIdentifier)), ret.addPropertyResult("targetIdentifier", "TargetIdentifier", cfn_parse.FromCloudFormation.getString(properties.TargetIdentifier)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEnabledControl = class _CfnEnabledControl extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEnabledControlPropsFromCloudFormation(resourceProperties), ret = new _CfnEnabledControl(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEnabledControl.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_controltower_CfnEnabledControlProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEnabledControl), error;
        }
        cdk.requireProperty(props, "controlIdentifier", this), cdk.requireProperty(props, "targetIdentifier", this), this.controlIdentifier = props.controlIdentifier, this.targetIdentifier = props.targetIdentifier;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEnabledControl.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { controlIdentifier: this.controlIdentifier, targetIdentifier: this.targetIdentifier };
      }
      renderProperties(props) {
        return cfnEnabledControlPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnEnabledControl[_a] = { fqn: "aws-cdk-lib.aws_controltower.CfnEnabledControl", version: "2.80.0" }, CfnEnabledControl.CFN_RESOURCE_TYPE_NAME = "AWS::ControlTower::EnabledControl", exports2.CfnEnabledControl = CfnEnabledControl;
  }
});

// node_modules/aws-cdk-lib/aws-controltower/lib/index.js
var require_lib93 = __commonJS({
  "node_modules/aws-cdk-lib/aws-controltower/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_controltower_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-controltower/index.js
var require_aws_controltower = __commonJS({
  "node_modules/aws-cdk-lib/aws-controltower/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib93(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-cur/lib/cur.generated.js
var require_cur_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-cur/lib/cur.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnReportDefinition = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnReportDefinitionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("additionalArtifacts", cdk.listValidator(cdk.validateString))(properties.additionalArtifacts)), errors.collect(cdk.propertyValidator("additionalSchemaElements", cdk.listValidator(cdk.validateString))(properties.additionalSchemaElements)), errors.collect(cdk.propertyValidator("billingViewArn", cdk.validateString)(properties.billingViewArn)), errors.collect(cdk.propertyValidator("compression", cdk.requiredValidator)(properties.compression)), errors.collect(cdk.propertyValidator("compression", cdk.validateString)(properties.compression)), errors.collect(cdk.propertyValidator("format", cdk.requiredValidator)(properties.format)), errors.collect(cdk.propertyValidator("format", cdk.validateString)(properties.format)), errors.collect(cdk.propertyValidator("refreshClosedReports", cdk.requiredValidator)(properties.refreshClosedReports)), errors.collect(cdk.propertyValidator("refreshClosedReports", cdk.validateBoolean)(properties.refreshClosedReports)), errors.collect(cdk.propertyValidator("reportName", cdk.requiredValidator)(properties.reportName)), errors.collect(cdk.propertyValidator("reportName", cdk.validateString)(properties.reportName)), errors.collect(cdk.propertyValidator("reportVersioning", cdk.requiredValidator)(properties.reportVersioning)), errors.collect(cdk.propertyValidator("reportVersioning", cdk.validateString)(properties.reportVersioning)), errors.collect(cdk.propertyValidator("s3Bucket", cdk.requiredValidator)(properties.s3Bucket)), errors.collect(cdk.propertyValidator("s3Bucket", cdk.validateString)(properties.s3Bucket)), errors.collect(cdk.propertyValidator("s3Prefix", cdk.requiredValidator)(properties.s3Prefix)), errors.collect(cdk.propertyValidator("s3Prefix", cdk.validateString)(properties.s3Prefix)), errors.collect(cdk.propertyValidator("s3Region", cdk.requiredValidator)(properties.s3Region)), errors.collect(cdk.propertyValidator("s3Region", cdk.validateString)(properties.s3Region)), errors.collect(cdk.propertyValidator("timeUnit", cdk.requiredValidator)(properties.timeUnit)), errors.collect(cdk.propertyValidator("timeUnit", cdk.validateString)(properties.timeUnit)), errors.wrap('supplied properties not correct for "CfnReportDefinitionProps"');
    }
    function cfnReportDefinitionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReportDefinitionPropsValidator(properties).assertSuccess(), { Compression: cdk.stringToCloudFormation(properties.compression), Format: cdk.stringToCloudFormation(properties.format), RefreshClosedReports: cdk.booleanToCloudFormation(properties.refreshClosedReports), ReportName: cdk.stringToCloudFormation(properties.reportName), ReportVersioning: cdk.stringToCloudFormation(properties.reportVersioning), S3Bucket: cdk.stringToCloudFormation(properties.s3Bucket), S3Prefix: cdk.stringToCloudFormation(properties.s3Prefix), S3Region: cdk.stringToCloudFormation(properties.s3Region), TimeUnit: cdk.stringToCloudFormation(properties.timeUnit), AdditionalArtifacts: cdk.listMapper(cdk.stringToCloudFormation)(properties.additionalArtifacts), AdditionalSchemaElements: cdk.listMapper(cdk.stringToCloudFormation)(properties.additionalSchemaElements), BillingViewArn: cdk.stringToCloudFormation(properties.billingViewArn) }) : properties;
    }
    function CfnReportDefinitionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("compression", "Compression", cfn_parse.FromCloudFormation.getString(properties.Compression)), ret.addPropertyResult("format", "Format", cfn_parse.FromCloudFormation.getString(properties.Format)), ret.addPropertyResult("refreshClosedReports", "RefreshClosedReports", cfn_parse.FromCloudFormation.getBoolean(properties.RefreshClosedReports)), ret.addPropertyResult("reportName", "ReportName", cfn_parse.FromCloudFormation.getString(properties.ReportName)), ret.addPropertyResult("reportVersioning", "ReportVersioning", cfn_parse.FromCloudFormation.getString(properties.ReportVersioning)), ret.addPropertyResult("s3Bucket", "S3Bucket", cfn_parse.FromCloudFormation.getString(properties.S3Bucket)), ret.addPropertyResult("s3Prefix", "S3Prefix", cfn_parse.FromCloudFormation.getString(properties.S3Prefix)), ret.addPropertyResult("s3Region", "S3Region", cfn_parse.FromCloudFormation.getString(properties.S3Region)), ret.addPropertyResult("timeUnit", "TimeUnit", cfn_parse.FromCloudFormation.getString(properties.TimeUnit)), ret.addPropertyResult("additionalArtifacts", "AdditionalArtifacts", properties.AdditionalArtifacts != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AdditionalArtifacts) : void 0), ret.addPropertyResult("additionalSchemaElements", "AdditionalSchemaElements", properties.AdditionalSchemaElements != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AdditionalSchemaElements) : void 0), ret.addPropertyResult("billingViewArn", "BillingViewArn", properties.BillingViewArn != null ? cfn_parse.FromCloudFormation.getString(properties.BillingViewArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnReportDefinition = class _CfnReportDefinition extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnReportDefinitionPropsFromCloudFormation(resourceProperties), ret = new _CfnReportDefinition(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnReportDefinition.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cur_CfnReportDefinitionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnReportDefinition), error;
        }
        cdk.requireProperty(props, "compression", this), cdk.requireProperty(props, "format", this), cdk.requireProperty(props, "refreshClosedReports", this), cdk.requireProperty(props, "reportName", this), cdk.requireProperty(props, "reportVersioning", this), cdk.requireProperty(props, "s3Bucket", this), cdk.requireProperty(props, "s3Prefix", this), cdk.requireProperty(props, "s3Region", this), cdk.requireProperty(props, "timeUnit", this), this.compression = props.compression, this.format = props.format, this.refreshClosedReports = props.refreshClosedReports, this.reportName = props.reportName, this.reportVersioning = props.reportVersioning, this.s3Bucket = props.s3Bucket, this.s3Prefix = props.s3Prefix, this.s3Region = props.s3Region, this.timeUnit = props.timeUnit, this.additionalArtifacts = props.additionalArtifacts, this.additionalSchemaElements = props.additionalSchemaElements, this.billingViewArn = props.billingViewArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnReportDefinition.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { compression: this.compression, format: this.format, refreshClosedReports: this.refreshClosedReports, reportName: this.reportName, reportVersioning: this.reportVersioning, s3Bucket: this.s3Bucket, s3Prefix: this.s3Prefix, s3Region: this.s3Region, timeUnit: this.timeUnit, additionalArtifacts: this.additionalArtifacts, additionalSchemaElements: this.additionalSchemaElements, billingViewArn: this.billingViewArn };
      }
      renderProperties(props) {
        return cfnReportDefinitionPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnReportDefinition[_a] = { fqn: "aws-cdk-lib.aws_cur.CfnReportDefinition", version: "2.80.0" }, CfnReportDefinition.CFN_RESOURCE_TYPE_NAME = "AWS::CUR::ReportDefinition", exports2.CfnReportDefinition = CfnReportDefinition;
  }
});

// node_modules/aws-cdk-lib/aws-cur/lib/index.js
var require_lib94 = __commonJS({
  "node_modules/aws-cdk-lib/aws-cur/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_cur_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-cur/index.js
var require_aws_cur = __commonJS({
  "node_modules/aws-cdk-lib/aws-cur/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib94(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-customerprofiles/lib/customerprofiles.generated.js
var require_customerprofiles_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-customerprofiles/lib/customerprofiles.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnObjectType = exports2.CfnIntegration = exports2.CfnDomain = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnDomainPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deadLetterQueueUrl", cdk.validateString)(properties.deadLetterQueueUrl)), errors.collect(cdk.propertyValidator("defaultEncryptionKey", cdk.validateString)(properties.defaultEncryptionKey)), errors.collect(cdk.propertyValidator("defaultExpirationDays", cdk.validateNumber)(properties.defaultExpirationDays)), errors.collect(cdk.propertyValidator("domainName", cdk.requiredValidator)(properties.domainName)), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDomainProps"');
    }
    function cfnDomainPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomainPropsValidator(properties).assertSuccess(), { DomainName: cdk.stringToCloudFormation(properties.domainName), DeadLetterQueueUrl: cdk.stringToCloudFormation(properties.deadLetterQueueUrl), DefaultEncryptionKey: cdk.stringToCloudFormation(properties.defaultEncryptionKey), DefaultExpirationDays: cdk.numberToCloudFormation(properties.defaultExpirationDays), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDomainPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("domainName", "DomainName", cfn_parse.FromCloudFormation.getString(properties.DomainName)), ret.addPropertyResult("deadLetterQueueUrl", "DeadLetterQueueUrl", properties.DeadLetterQueueUrl != null ? cfn_parse.FromCloudFormation.getString(properties.DeadLetterQueueUrl) : void 0), ret.addPropertyResult("defaultEncryptionKey", "DefaultEncryptionKey", properties.DefaultEncryptionKey != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultEncryptionKey) : void 0), ret.addPropertyResult("defaultExpirationDays", "DefaultExpirationDays", properties.DefaultExpirationDays != null ? cfn_parse.FromCloudFormation.getNumber(properties.DefaultExpirationDays) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDomain = class _CfnDomain extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDomainPropsFromCloudFormation(resourceProperties), ret = new _CfnDomain(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDomain.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_customerprofiles_CfnDomainProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDomain), error;
        }
        cdk.requireProperty(props, "domainName", this), this.attrCreatedAt = cdk.Token.asString(this.getAtt("CreatedAt", cdk.ResolutionTypeHint.STRING)), this.attrLastUpdatedAt = cdk.Token.asString(this.getAtt("LastUpdatedAt", cdk.ResolutionTypeHint.STRING)), this.domainName = props.domainName, this.deadLetterQueueUrl = props.deadLetterQueueUrl, this.defaultEncryptionKey = props.defaultEncryptionKey, this.defaultExpirationDays = props.defaultExpirationDays, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::CustomerProfiles::Domain", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDomain.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { domainName: this.domainName, deadLetterQueueUrl: this.deadLetterQueueUrl, defaultEncryptionKey: this.defaultEncryptionKey, defaultExpirationDays: this.defaultExpirationDays, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDomainPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnDomain[_a] = { fqn: "aws-cdk-lib.aws_customerprofiles.CfnDomain", version: "2.80.0" }, CfnDomain.CFN_RESOURCE_TYPE_NAME = "AWS::CustomerProfiles::Domain", exports2.CfnDomain = CfnDomain;
    function CfnIntegrationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("domainName", cdk.requiredValidator)(properties.domainName)), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.collect(cdk.propertyValidator("flowDefinition", CfnIntegration_FlowDefinitionPropertyValidator)(properties.flowDefinition)), errors.collect(cdk.propertyValidator("objectTypeName", cdk.validateString)(properties.objectTypeName)), errors.collect(cdk.propertyValidator("objectTypeNames", cdk.listValidator(CfnIntegration_ObjectTypeMappingPropertyValidator))(properties.objectTypeNames)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("uri", cdk.validateString)(properties.uri)), errors.wrap('supplied properties not correct for "CfnIntegrationProps"');
    }
    function cfnIntegrationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIntegrationPropsValidator(properties).assertSuccess(), { DomainName: cdk.stringToCloudFormation(properties.domainName), FlowDefinition: cfnIntegrationFlowDefinitionPropertyToCloudFormation(properties.flowDefinition), ObjectTypeName: cdk.stringToCloudFormation(properties.objectTypeName), ObjectTypeNames: cdk.listMapper(cfnIntegrationObjectTypeMappingPropertyToCloudFormation)(properties.objectTypeNames), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), Uri: cdk.stringToCloudFormation(properties.uri) }) : properties;
    }
    function CfnIntegrationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("domainName", "DomainName", cfn_parse.FromCloudFormation.getString(properties.DomainName)), ret.addPropertyResult("flowDefinition", "FlowDefinition", properties.FlowDefinition != null ? CfnIntegrationFlowDefinitionPropertyFromCloudFormation(properties.FlowDefinition) : void 0), ret.addPropertyResult("objectTypeName", "ObjectTypeName", properties.ObjectTypeName != null ? cfn_parse.FromCloudFormation.getString(properties.ObjectTypeName) : void 0), ret.addPropertyResult("objectTypeNames", "ObjectTypeNames", properties.ObjectTypeNames != null ? cfn_parse.FromCloudFormation.getArray(CfnIntegrationObjectTypeMappingPropertyFromCloudFormation)(properties.ObjectTypeNames) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("uri", "Uri", properties.Uri != null ? cfn_parse.FromCloudFormation.getString(properties.Uri) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnIntegration = class _CfnIntegration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnIntegrationPropsFromCloudFormation(resourceProperties), ret = new _CfnIntegration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnIntegration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_customerprofiles_CfnIntegrationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnIntegration), error;
        }
        cdk.requireProperty(props, "domainName", this), this.attrCreatedAt = cdk.Token.asString(this.getAtt("CreatedAt", cdk.ResolutionTypeHint.STRING)), this.attrLastUpdatedAt = cdk.Token.asString(this.getAtt("LastUpdatedAt", cdk.ResolutionTypeHint.STRING)), this.domainName = props.domainName, this.flowDefinition = props.flowDefinition, this.objectTypeName = props.objectTypeName, this.objectTypeNames = props.objectTypeNames, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::CustomerProfiles::Integration", props.tags, { tagPropertyName: "tags" }), this.uri = props.uri;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnIntegration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { domainName: this.domainName, flowDefinition: this.flowDefinition, objectTypeName: this.objectTypeName, objectTypeNames: this.objectTypeNames, tags: this.tags.renderTags(), uri: this.uri };
      }
      renderProperties(props) {
        return cfnIntegrationPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnIntegration[_b] = { fqn: "aws-cdk-lib.aws_customerprofiles.CfnIntegration", version: "2.80.0" }, CfnIntegration.CFN_RESOURCE_TYPE_NAME = "AWS::CustomerProfiles::Integration", exports2.CfnIntegration = CfnIntegration;
    function CfnIntegration_ConnectorOperatorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("marketo", cdk.validateString)(properties.marketo)), errors.collect(cdk.propertyValidator("s3", cdk.validateString)(properties.s3)), errors.collect(cdk.propertyValidator("salesforce", cdk.validateString)(properties.salesforce)), errors.collect(cdk.propertyValidator("serviceNow", cdk.validateString)(properties.serviceNow)), errors.collect(cdk.propertyValidator("zendesk", cdk.validateString)(properties.zendesk)), errors.wrap('supplied properties not correct for "ConnectorOperatorProperty"');
    }
    function cfnIntegrationConnectorOperatorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIntegration_ConnectorOperatorPropertyValidator(properties).assertSuccess(), { Marketo: cdk.stringToCloudFormation(properties.marketo), S3: cdk.stringToCloudFormation(properties.s3), Salesforce: cdk.stringToCloudFormation(properties.salesforce), ServiceNow: cdk.stringToCloudFormation(properties.serviceNow), Zendesk: cdk.stringToCloudFormation(properties.zendesk) }) : properties;
    }
    function CfnIntegrationConnectorOperatorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("marketo", "Marketo", properties.Marketo != null ? cfn_parse.FromCloudFormation.getString(properties.Marketo) : void 0), ret.addPropertyResult("s3", "S3", properties.S3 != null ? cfn_parse.FromCloudFormation.getString(properties.S3) : void 0), ret.addPropertyResult("salesforce", "Salesforce", properties.Salesforce != null ? cfn_parse.FromCloudFormation.getString(properties.Salesforce) : void 0), ret.addPropertyResult("serviceNow", "ServiceNow", properties.ServiceNow != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceNow) : void 0), ret.addPropertyResult("zendesk", "Zendesk", properties.Zendesk != null ? cfn_parse.FromCloudFormation.getString(properties.Zendesk) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIntegration_FlowDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("flowName", cdk.requiredValidator)(properties.flowName)), errors.collect(cdk.propertyValidator("flowName", cdk.validateString)(properties.flowName)), errors.collect(cdk.propertyValidator("kmsArn", cdk.requiredValidator)(properties.kmsArn)), errors.collect(cdk.propertyValidator("kmsArn", cdk.validateString)(properties.kmsArn)), errors.collect(cdk.propertyValidator("sourceFlowConfig", cdk.requiredValidator)(properties.sourceFlowConfig)), errors.collect(cdk.propertyValidator("sourceFlowConfig", CfnIntegration_SourceFlowConfigPropertyValidator)(properties.sourceFlowConfig)), errors.collect(cdk.propertyValidator("tasks", cdk.requiredValidator)(properties.tasks)), errors.collect(cdk.propertyValidator("tasks", cdk.listValidator(CfnIntegration_TaskPropertyValidator))(properties.tasks)), errors.collect(cdk.propertyValidator("triggerConfig", cdk.requiredValidator)(properties.triggerConfig)), errors.collect(cdk.propertyValidator("triggerConfig", CfnIntegration_TriggerConfigPropertyValidator)(properties.triggerConfig)), errors.wrap('supplied properties not correct for "FlowDefinitionProperty"');
    }
    function cfnIntegrationFlowDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIntegration_FlowDefinitionPropertyValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), FlowName: cdk.stringToCloudFormation(properties.flowName), KmsArn: cdk.stringToCloudFormation(properties.kmsArn), SourceFlowConfig: cfnIntegrationSourceFlowConfigPropertyToCloudFormation(properties.sourceFlowConfig), Tasks: cdk.listMapper(cfnIntegrationTaskPropertyToCloudFormation)(properties.tasks), TriggerConfig: cfnIntegrationTriggerConfigPropertyToCloudFormation(properties.triggerConfig) }) : properties;
    }
    function CfnIntegrationFlowDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("flowName", "FlowName", cfn_parse.FromCloudFormation.getString(properties.FlowName)), ret.addPropertyResult("kmsArn", "KmsArn", cfn_parse.FromCloudFormation.getString(properties.KmsArn)), ret.addPropertyResult("sourceFlowConfig", "SourceFlowConfig", CfnIntegrationSourceFlowConfigPropertyFromCloudFormation(properties.SourceFlowConfig)), ret.addPropertyResult("tasks", "Tasks", cfn_parse.FromCloudFormation.getArray(CfnIntegrationTaskPropertyFromCloudFormation)(properties.Tasks)), ret.addPropertyResult("triggerConfig", "TriggerConfig", CfnIntegrationTriggerConfigPropertyFromCloudFormation(properties.TriggerConfig)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIntegration_IncrementalPullConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("datetimeTypeFieldName", cdk.validateString)(properties.datetimeTypeFieldName)), errors.wrap('supplied properties not correct for "IncrementalPullConfigProperty"');
    }
    function cfnIntegrationIncrementalPullConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIntegration_IncrementalPullConfigPropertyValidator(properties).assertSuccess(), { DatetimeTypeFieldName: cdk.stringToCloudFormation(properties.datetimeTypeFieldName) }) : properties;
    }
    function CfnIntegrationIncrementalPullConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("datetimeTypeFieldName", "DatetimeTypeFieldName", properties.DatetimeTypeFieldName != null ? cfn_parse.FromCloudFormation.getString(properties.DatetimeTypeFieldName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIntegration_MarketoSourcePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("object", cdk.requiredValidator)(properties.object)), errors.collect(cdk.propertyValidator("object", cdk.validateString)(properties.object)), errors.wrap('supplied properties not correct for "MarketoSourcePropertiesProperty"');
    }
    function cfnIntegrationMarketoSourcePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIntegration_MarketoSourcePropertiesPropertyValidator(properties).assertSuccess(), { Object: cdk.stringToCloudFormation(properties.object) }) : properties;
    }
    function CfnIntegrationMarketoSourcePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("object", "Object", cfn_parse.FromCloudFormation.getString(properties.Object)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIntegration_ObjectTypeMappingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "ObjectTypeMappingProperty"');
    }
    function cfnIntegrationObjectTypeMappingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIntegration_ObjectTypeMappingPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnIntegrationObjectTypeMappingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIntegration_S3SourcePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketName", cdk.requiredValidator)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketPrefix", cdk.validateString)(properties.bucketPrefix)), errors.wrap('supplied properties not correct for "S3SourcePropertiesProperty"');
    }
    function cfnIntegrationS3SourcePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIntegration_S3SourcePropertiesPropertyValidator(properties).assertSuccess(), { BucketName: cdk.stringToCloudFormation(properties.bucketName), BucketPrefix: cdk.stringToCloudFormation(properties.bucketPrefix) }) : properties;
    }
    function CfnIntegrationS3SourcePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketName", "BucketName", cfn_parse.FromCloudFormation.getString(properties.BucketName)), ret.addPropertyResult("bucketPrefix", "BucketPrefix", properties.BucketPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.BucketPrefix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIntegration_SalesforceSourcePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enableDynamicFieldUpdate", cdk.validateBoolean)(properties.enableDynamicFieldUpdate)), errors.collect(cdk.propertyValidator("includeDeletedRecords", cdk.validateBoolean)(properties.includeDeletedRecords)), errors.collect(cdk.propertyValidator("object", cdk.requiredValidator)(properties.object)), errors.collect(cdk.propertyValidator("object", cdk.validateString)(properties.object)), errors.wrap('supplied properties not correct for "SalesforceSourcePropertiesProperty"');
    }
    function cfnIntegrationSalesforceSourcePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIntegration_SalesforceSourcePropertiesPropertyValidator(properties).assertSuccess(), { EnableDynamicFieldUpdate: cdk.booleanToCloudFormation(properties.enableDynamicFieldUpdate), IncludeDeletedRecords: cdk.booleanToCloudFormation(properties.includeDeletedRecords), Object: cdk.stringToCloudFormation(properties.object) }) : properties;
    }
    function CfnIntegrationSalesforceSourcePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enableDynamicFieldUpdate", "EnableDynamicFieldUpdate", properties.EnableDynamicFieldUpdate != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableDynamicFieldUpdate) : void 0), ret.addPropertyResult("includeDeletedRecords", "IncludeDeletedRecords", properties.IncludeDeletedRecords != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeDeletedRecords) : void 0), ret.addPropertyResult("object", "Object", cfn_parse.FromCloudFormation.getString(properties.Object)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIntegration_ScheduledTriggerPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataPullMode", cdk.validateString)(properties.dataPullMode)), errors.collect(cdk.propertyValidator("firstExecutionFrom", cdk.validateNumber)(properties.firstExecutionFrom)), errors.collect(cdk.propertyValidator("scheduleEndTime", cdk.validateNumber)(properties.scheduleEndTime)), errors.collect(cdk.propertyValidator("scheduleExpression", cdk.requiredValidator)(properties.scheduleExpression)), errors.collect(cdk.propertyValidator("scheduleExpression", cdk.validateString)(properties.scheduleExpression)), errors.collect(cdk.propertyValidator("scheduleOffset", cdk.validateNumber)(properties.scheduleOffset)), errors.collect(cdk.propertyValidator("scheduleStartTime", cdk.validateNumber)(properties.scheduleStartTime)), errors.collect(cdk.propertyValidator("timezone", cdk.validateString)(properties.timezone)), errors.wrap('supplied properties not correct for "ScheduledTriggerPropertiesProperty"');
    }
    function cfnIntegrationScheduledTriggerPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIntegration_ScheduledTriggerPropertiesPropertyValidator(properties).assertSuccess(), { DataPullMode: cdk.stringToCloudFormation(properties.dataPullMode), FirstExecutionFrom: cdk.numberToCloudFormation(properties.firstExecutionFrom), ScheduleEndTime: cdk.numberToCloudFormation(properties.scheduleEndTime), ScheduleExpression: cdk.stringToCloudFormation(properties.scheduleExpression), ScheduleOffset: cdk.numberToCloudFormation(properties.scheduleOffset), ScheduleStartTime: cdk.numberToCloudFormation(properties.scheduleStartTime), Timezone: cdk.stringToCloudFormation(properties.timezone) }) : properties;
    }
    function CfnIntegrationScheduledTriggerPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataPullMode", "DataPullMode", properties.DataPullMode != null ? cfn_parse.FromCloudFormation.getString(properties.DataPullMode) : void 0), ret.addPropertyResult("firstExecutionFrom", "FirstExecutionFrom", properties.FirstExecutionFrom != null ? cfn_parse.FromCloudFormation.getNumber(properties.FirstExecutionFrom) : void 0), ret.addPropertyResult("scheduleEndTime", "ScheduleEndTime", properties.ScheduleEndTime != null ? cfn_parse.FromCloudFormation.getNumber(properties.ScheduleEndTime) : void 0), ret.addPropertyResult("scheduleExpression", "ScheduleExpression", cfn_parse.FromCloudFormation.getString(properties.ScheduleExpression)), ret.addPropertyResult("scheduleOffset", "ScheduleOffset", properties.ScheduleOffset != null ? cfn_parse.FromCloudFormation.getNumber(properties.ScheduleOffset) : void 0), ret.addPropertyResult("scheduleStartTime", "ScheduleStartTime", properties.ScheduleStartTime != null ? cfn_parse.FromCloudFormation.getNumber(properties.ScheduleStartTime) : void 0), ret.addPropertyResult("timezone", "Timezone", properties.Timezone != null ? cfn_parse.FromCloudFormation.getString(properties.Timezone) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIntegration_ServiceNowSourcePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("object", cdk.requiredValidator)(properties.object)), errors.collect(cdk.propertyValidator("object", cdk.validateString)(properties.object)), errors.wrap('supplied properties not correct for "ServiceNowSourcePropertiesProperty"');
    }
    function cfnIntegrationServiceNowSourcePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIntegration_ServiceNowSourcePropertiesPropertyValidator(properties).assertSuccess(), { Object: cdk.stringToCloudFormation(properties.object) }) : properties;
    }
    function CfnIntegrationServiceNowSourcePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("object", "Object", cfn_parse.FromCloudFormation.getString(properties.Object)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIntegration_SourceConnectorPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("marketo", CfnIntegration_MarketoSourcePropertiesPropertyValidator)(properties.marketo)), errors.collect(cdk.propertyValidator("s3", CfnIntegration_S3SourcePropertiesPropertyValidator)(properties.s3)), errors.collect(cdk.propertyValidator("salesforce", CfnIntegration_SalesforceSourcePropertiesPropertyValidator)(properties.salesforce)), errors.collect(cdk.propertyValidator("serviceNow", CfnIntegration_ServiceNowSourcePropertiesPropertyValidator)(properties.serviceNow)), errors.collect(cdk.propertyValidator("zendesk", CfnIntegration_ZendeskSourcePropertiesPropertyValidator)(properties.zendesk)), errors.wrap('supplied properties not correct for "SourceConnectorPropertiesProperty"');
    }
    function cfnIntegrationSourceConnectorPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIntegration_SourceConnectorPropertiesPropertyValidator(properties).assertSuccess(), { Marketo: cfnIntegrationMarketoSourcePropertiesPropertyToCloudFormation(properties.marketo), S3: cfnIntegrationS3SourcePropertiesPropertyToCloudFormation(properties.s3), Salesforce: cfnIntegrationSalesforceSourcePropertiesPropertyToCloudFormation(properties.salesforce), ServiceNow: cfnIntegrationServiceNowSourcePropertiesPropertyToCloudFormation(properties.serviceNow), Zendesk: cfnIntegrationZendeskSourcePropertiesPropertyToCloudFormation(properties.zendesk) }) : properties;
    }
    function CfnIntegrationSourceConnectorPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("marketo", "Marketo", properties.Marketo != null ? CfnIntegrationMarketoSourcePropertiesPropertyFromCloudFormation(properties.Marketo) : void 0), ret.addPropertyResult("s3", "S3", properties.S3 != null ? CfnIntegrationS3SourcePropertiesPropertyFromCloudFormation(properties.S3) : void 0), ret.addPropertyResult("salesforce", "Salesforce", properties.Salesforce != null ? CfnIntegrationSalesforceSourcePropertiesPropertyFromCloudFormation(properties.Salesforce) : void 0), ret.addPropertyResult("serviceNow", "ServiceNow", properties.ServiceNow != null ? CfnIntegrationServiceNowSourcePropertiesPropertyFromCloudFormation(properties.ServiceNow) : void 0), ret.addPropertyResult("zendesk", "Zendesk", properties.Zendesk != null ? CfnIntegrationZendeskSourcePropertiesPropertyFromCloudFormation(properties.Zendesk) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIntegration_SourceFlowConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectorProfileName", cdk.validateString)(properties.connectorProfileName)), errors.collect(cdk.propertyValidator("connectorType", cdk.requiredValidator)(properties.connectorType)), errors.collect(cdk.propertyValidator("connectorType", cdk.validateString)(properties.connectorType)), errors.collect(cdk.propertyValidator("incrementalPullConfig", CfnIntegration_IncrementalPullConfigPropertyValidator)(properties.incrementalPullConfig)), errors.collect(cdk.propertyValidator("sourceConnectorProperties", cdk.requiredValidator)(properties.sourceConnectorProperties)), errors.collect(cdk.propertyValidator("sourceConnectorProperties", CfnIntegration_SourceConnectorPropertiesPropertyValidator)(properties.sourceConnectorProperties)), errors.wrap('supplied properties not correct for "SourceFlowConfigProperty"');
    }
    function cfnIntegrationSourceFlowConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIntegration_SourceFlowConfigPropertyValidator(properties).assertSuccess(), { ConnectorProfileName: cdk.stringToCloudFormation(properties.connectorProfileName), ConnectorType: cdk.stringToCloudFormation(properties.connectorType), IncrementalPullConfig: cfnIntegrationIncrementalPullConfigPropertyToCloudFormation(properties.incrementalPullConfig), SourceConnectorProperties: cfnIntegrationSourceConnectorPropertiesPropertyToCloudFormation(properties.sourceConnectorProperties) }) : properties;
    }
    function CfnIntegrationSourceFlowConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectorProfileName", "ConnectorProfileName", properties.ConnectorProfileName != null ? cfn_parse.FromCloudFormation.getString(properties.ConnectorProfileName) : void 0), ret.addPropertyResult("connectorType", "ConnectorType", cfn_parse.FromCloudFormation.getString(properties.ConnectorType)), ret.addPropertyResult("incrementalPullConfig", "IncrementalPullConfig", properties.IncrementalPullConfig != null ? CfnIntegrationIncrementalPullConfigPropertyFromCloudFormation(properties.IncrementalPullConfig) : void 0), ret.addPropertyResult("sourceConnectorProperties", "SourceConnectorProperties", CfnIntegrationSourceConnectorPropertiesPropertyFromCloudFormation(properties.SourceConnectorProperties)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIntegration_TaskPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectorOperator", CfnIntegration_ConnectorOperatorPropertyValidator)(properties.connectorOperator)), errors.collect(cdk.propertyValidator("destinationField", cdk.validateString)(properties.destinationField)), errors.collect(cdk.propertyValidator("sourceFields", cdk.requiredValidator)(properties.sourceFields)), errors.collect(cdk.propertyValidator("sourceFields", cdk.listValidator(cdk.validateString))(properties.sourceFields)), errors.collect(cdk.propertyValidator("taskProperties", cdk.listValidator(CfnIntegration_TaskPropertiesMapPropertyValidator))(properties.taskProperties)), errors.collect(cdk.propertyValidator("taskType", cdk.requiredValidator)(properties.taskType)), errors.collect(cdk.propertyValidator("taskType", cdk.validateString)(properties.taskType)), errors.wrap('supplied properties not correct for "TaskProperty"');
    }
    function cfnIntegrationTaskPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIntegration_TaskPropertyValidator(properties).assertSuccess(), { ConnectorOperator: cfnIntegrationConnectorOperatorPropertyToCloudFormation(properties.connectorOperator), DestinationField: cdk.stringToCloudFormation(properties.destinationField), SourceFields: cdk.listMapper(cdk.stringToCloudFormation)(properties.sourceFields), TaskProperties: cdk.listMapper(cfnIntegrationTaskPropertiesMapPropertyToCloudFormation)(properties.taskProperties), TaskType: cdk.stringToCloudFormation(properties.taskType) }) : properties;
    }
    function CfnIntegrationTaskPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectorOperator", "ConnectorOperator", properties.ConnectorOperator != null ? CfnIntegrationConnectorOperatorPropertyFromCloudFormation(properties.ConnectorOperator) : void 0), ret.addPropertyResult("destinationField", "DestinationField", properties.DestinationField != null ? cfn_parse.FromCloudFormation.getString(properties.DestinationField) : void 0), ret.addPropertyResult("sourceFields", "SourceFields", cfn_parse.FromCloudFormation.getStringArray(properties.SourceFields)), ret.addPropertyResult("taskProperties", "TaskProperties", properties.TaskProperties != null ? cfn_parse.FromCloudFormation.getArray(CfnIntegrationTaskPropertiesMapPropertyFromCloudFormation)(properties.TaskProperties) : void 0), ret.addPropertyResult("taskType", "TaskType", cfn_parse.FromCloudFormation.getString(properties.TaskType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIntegration_TaskPropertiesMapPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("operatorPropertyKey", cdk.requiredValidator)(properties.operatorPropertyKey)), errors.collect(cdk.propertyValidator("operatorPropertyKey", cdk.validateString)(properties.operatorPropertyKey)), errors.collect(cdk.propertyValidator("property", cdk.requiredValidator)(properties.property)), errors.collect(cdk.propertyValidator("property", cdk.validateString)(properties.property)), errors.wrap('supplied properties not correct for "TaskPropertiesMapProperty"');
    }
    function cfnIntegrationTaskPropertiesMapPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIntegration_TaskPropertiesMapPropertyValidator(properties).assertSuccess(), { OperatorPropertyKey: cdk.stringToCloudFormation(properties.operatorPropertyKey), Property: cdk.stringToCloudFormation(properties.property) }) : properties;
    }
    function CfnIntegrationTaskPropertiesMapPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("operatorPropertyKey", "OperatorPropertyKey", cfn_parse.FromCloudFormation.getString(properties.OperatorPropertyKey)), ret.addPropertyResult("property", "Property", cfn_parse.FromCloudFormation.getString(properties.Property)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIntegration_TriggerConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("triggerProperties", CfnIntegration_TriggerPropertiesPropertyValidator)(properties.triggerProperties)), errors.collect(cdk.propertyValidator("triggerType", cdk.requiredValidator)(properties.triggerType)), errors.collect(cdk.propertyValidator("triggerType", cdk.validateString)(properties.triggerType)), errors.wrap('supplied properties not correct for "TriggerConfigProperty"');
    }
    function cfnIntegrationTriggerConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIntegration_TriggerConfigPropertyValidator(properties).assertSuccess(), { TriggerProperties: cfnIntegrationTriggerPropertiesPropertyToCloudFormation(properties.triggerProperties), TriggerType: cdk.stringToCloudFormation(properties.triggerType) }) : properties;
    }
    function CfnIntegrationTriggerConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("triggerProperties", "TriggerProperties", properties.TriggerProperties != null ? CfnIntegrationTriggerPropertiesPropertyFromCloudFormation(properties.TriggerProperties) : void 0), ret.addPropertyResult("triggerType", "TriggerType", cfn_parse.FromCloudFormation.getString(properties.TriggerType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIntegration_TriggerPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("scheduled", CfnIntegration_ScheduledTriggerPropertiesPropertyValidator)(properties.scheduled)), errors.wrap('supplied properties not correct for "TriggerPropertiesProperty"');
    }
    function cfnIntegrationTriggerPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIntegration_TriggerPropertiesPropertyValidator(properties).assertSuccess(), { Scheduled: cfnIntegrationScheduledTriggerPropertiesPropertyToCloudFormation(properties.scheduled) }) : properties;
    }
    function CfnIntegrationTriggerPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("scheduled", "Scheduled", properties.Scheduled != null ? CfnIntegrationScheduledTriggerPropertiesPropertyFromCloudFormation(properties.Scheduled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIntegration_ZendeskSourcePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("object", cdk.requiredValidator)(properties.object)), errors.collect(cdk.propertyValidator("object", cdk.validateString)(properties.object)), errors.wrap('supplied properties not correct for "ZendeskSourcePropertiesProperty"');
    }
    function cfnIntegrationZendeskSourcePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIntegration_ZendeskSourcePropertiesPropertyValidator(properties).assertSuccess(), { Object: cdk.stringToCloudFormation(properties.object) }) : properties;
    }
    function CfnIntegrationZendeskSourcePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("object", "Object", cfn_parse.FromCloudFormation.getString(properties.Object)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnObjectTypePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowProfileCreation", cdk.validateBoolean)(properties.allowProfileCreation)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("domainName", cdk.requiredValidator)(properties.domainName)), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.collect(cdk.propertyValidator("encryptionKey", cdk.validateString)(properties.encryptionKey)), errors.collect(cdk.propertyValidator("expirationDays", cdk.validateNumber)(properties.expirationDays)), errors.collect(cdk.propertyValidator("fields", cdk.listValidator(CfnObjectType_FieldMapPropertyValidator))(properties.fields)), errors.collect(cdk.propertyValidator("keys", cdk.listValidator(CfnObjectType_KeyMapPropertyValidator))(properties.keys)), errors.collect(cdk.propertyValidator("objectTypeName", cdk.validateString)(properties.objectTypeName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("templateId", cdk.validateString)(properties.templateId)), errors.wrap('supplied properties not correct for "CfnObjectTypeProps"');
    }
    function cfnObjectTypePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnObjectTypePropsValidator(properties).assertSuccess(), { DomainName: cdk.stringToCloudFormation(properties.domainName), AllowProfileCreation: cdk.booleanToCloudFormation(properties.allowProfileCreation), Description: cdk.stringToCloudFormation(properties.description), EncryptionKey: cdk.stringToCloudFormation(properties.encryptionKey), ExpirationDays: cdk.numberToCloudFormation(properties.expirationDays), Fields: cdk.listMapper(cfnObjectTypeFieldMapPropertyToCloudFormation)(properties.fields), Keys: cdk.listMapper(cfnObjectTypeKeyMapPropertyToCloudFormation)(properties.keys), ObjectTypeName: cdk.stringToCloudFormation(properties.objectTypeName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TemplateId: cdk.stringToCloudFormation(properties.templateId) }) : properties;
    }
    function CfnObjectTypePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("domainName", "DomainName", cfn_parse.FromCloudFormation.getString(properties.DomainName)), ret.addPropertyResult("allowProfileCreation", "AllowProfileCreation", properties.AllowProfileCreation != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllowProfileCreation) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("encryptionKey", "EncryptionKey", properties.EncryptionKey != null ? cfn_parse.FromCloudFormation.getString(properties.EncryptionKey) : void 0), ret.addPropertyResult("expirationDays", "ExpirationDays", properties.ExpirationDays != null ? cfn_parse.FromCloudFormation.getNumber(properties.ExpirationDays) : void 0), ret.addPropertyResult("fields", "Fields", properties.Fields != null ? cfn_parse.FromCloudFormation.getArray(CfnObjectTypeFieldMapPropertyFromCloudFormation)(properties.Fields) : void 0), ret.addPropertyResult("keys", "Keys", properties.Keys != null ? cfn_parse.FromCloudFormation.getArray(CfnObjectTypeKeyMapPropertyFromCloudFormation)(properties.Keys) : void 0), ret.addPropertyResult("objectTypeName", "ObjectTypeName", properties.ObjectTypeName != null ? cfn_parse.FromCloudFormation.getString(properties.ObjectTypeName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("templateId", "TemplateId", properties.TemplateId != null ? cfn_parse.FromCloudFormation.getString(properties.TemplateId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnObjectType = class _CfnObjectType extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnObjectTypePropsFromCloudFormation(resourceProperties), ret = new _CfnObjectType(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnObjectType.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_customerprofiles_CfnObjectTypeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnObjectType), error;
        }
        cdk.requireProperty(props, "domainName", this), this.attrCreatedAt = cdk.Token.asString(this.getAtt("CreatedAt", cdk.ResolutionTypeHint.STRING)), this.attrLastUpdatedAt = cdk.Token.asString(this.getAtt("LastUpdatedAt", cdk.ResolutionTypeHint.STRING)), this.domainName = props.domainName, this.allowProfileCreation = props.allowProfileCreation, this.description = props.description, this.encryptionKey = props.encryptionKey, this.expirationDays = props.expirationDays, this.fields = props.fields, this.keys = props.keys, this.objectTypeName = props.objectTypeName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::CustomerProfiles::ObjectType", props.tags, { tagPropertyName: "tags" }), this.templateId = props.templateId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnObjectType.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { domainName: this.domainName, allowProfileCreation: this.allowProfileCreation, description: this.description, encryptionKey: this.encryptionKey, expirationDays: this.expirationDays, fields: this.fields, keys: this.keys, objectTypeName: this.objectTypeName, tags: this.tags.renderTags(), templateId: this.templateId };
      }
      renderProperties(props) {
        return cfnObjectTypePropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnObjectType[_c] = { fqn: "aws-cdk-lib.aws_customerprofiles.CfnObjectType", version: "2.80.0" }, CfnObjectType.CFN_RESOURCE_TYPE_NAME = "AWS::CustomerProfiles::ObjectType", exports2.CfnObjectType = CfnObjectType;
    function CfnObjectType_FieldMapPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("objectTypeField", CfnObjectType_ObjectTypeFieldPropertyValidator)(properties.objectTypeField)), errors.wrap('supplied properties not correct for "FieldMapProperty"');
    }
    function cfnObjectTypeFieldMapPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnObjectType_FieldMapPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), ObjectTypeField: cfnObjectTypeObjectTypeFieldPropertyToCloudFormation(properties.objectTypeField) }) : properties;
    }
    function CfnObjectTypeFieldMapPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("objectTypeField", "ObjectTypeField", properties.ObjectTypeField != null ? CfnObjectTypeObjectTypeFieldPropertyFromCloudFormation(properties.ObjectTypeField) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnObjectType_KeyMapPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("objectTypeKeyList", cdk.listValidator(CfnObjectType_ObjectTypeKeyPropertyValidator))(properties.objectTypeKeyList)), errors.wrap('supplied properties not correct for "KeyMapProperty"');
    }
    function cfnObjectTypeKeyMapPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnObjectType_KeyMapPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), ObjectTypeKeyList: cdk.listMapper(cfnObjectTypeObjectTypeKeyPropertyToCloudFormation)(properties.objectTypeKeyList) }) : properties;
    }
    function CfnObjectTypeKeyMapPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("objectTypeKeyList", "ObjectTypeKeyList", properties.ObjectTypeKeyList != null ? cfn_parse.FromCloudFormation.getArray(CfnObjectTypeObjectTypeKeyPropertyFromCloudFormation)(properties.ObjectTypeKeyList) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnObjectType_ObjectTypeFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contentType", cdk.validateString)(properties.contentType)), errors.collect(cdk.propertyValidator("source", cdk.validateString)(properties.source)), errors.collect(cdk.propertyValidator("target", cdk.validateString)(properties.target)), errors.wrap('supplied properties not correct for "ObjectTypeFieldProperty"');
    }
    function cfnObjectTypeObjectTypeFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnObjectType_ObjectTypeFieldPropertyValidator(properties).assertSuccess(), { ContentType: cdk.stringToCloudFormation(properties.contentType), Source: cdk.stringToCloudFormation(properties.source), Target: cdk.stringToCloudFormation(properties.target) }) : properties;
    }
    function CfnObjectTypeObjectTypeFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contentType", "ContentType", properties.ContentType != null ? cfn_parse.FromCloudFormation.getString(properties.ContentType) : void 0), ret.addPropertyResult("source", "Source", properties.Source != null ? cfn_parse.FromCloudFormation.getString(properties.Source) : void 0), ret.addPropertyResult("target", "Target", properties.Target != null ? cfn_parse.FromCloudFormation.getString(properties.Target) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnObjectType_ObjectTypeKeyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldNames", cdk.listValidator(cdk.validateString))(properties.fieldNames)), errors.collect(cdk.propertyValidator("standardIdentifiers", cdk.listValidator(cdk.validateString))(properties.standardIdentifiers)), errors.wrap('supplied properties not correct for "ObjectTypeKeyProperty"');
    }
    function cfnObjectTypeObjectTypeKeyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnObjectType_ObjectTypeKeyPropertyValidator(properties).assertSuccess(), { FieldNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.fieldNames), StandardIdentifiers: cdk.listMapper(cdk.stringToCloudFormation)(properties.standardIdentifiers) }) : properties;
    }
    function CfnObjectTypeObjectTypeKeyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldNames", "FieldNames", properties.FieldNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.FieldNames) : void 0), ret.addPropertyResult("standardIdentifiers", "StandardIdentifiers", properties.StandardIdentifiers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.StandardIdentifiers) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-customerprofiles/lib/index.js
var require_lib95 = __commonJS({
  "node_modules/aws-cdk-lib/aws-customerprofiles/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_customerprofiles_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-customerprofiles/index.js
var require_aws_customerprofiles = __commonJS({
  "node_modules/aws-cdk-lib/aws-customerprofiles/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib95(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-databrew/lib/databrew.generated.js
var require_databrew_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-databrew/lib/databrew.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnSchedule = exports2.CfnRuleset = exports2.CfnRecipe = exports2.CfnProject = exports2.CfnJob = exports2.CfnDataset = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnDatasetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("format", cdk.validateString)(properties.format)), errors.collect(cdk.propertyValidator("formatOptions", CfnDataset_FormatOptionsPropertyValidator)(properties.formatOptions)), errors.collect(cdk.propertyValidator("input", cdk.requiredValidator)(properties.input)), errors.collect(cdk.propertyValidator("input", CfnDataset_InputPropertyValidator)(properties.input)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("pathOptions", CfnDataset_PathOptionsPropertyValidator)(properties.pathOptions)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDatasetProps"');
    }
    function cfnDatasetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDatasetPropsValidator(properties).assertSuccess(), { Input: cfnDatasetInputPropertyToCloudFormation(properties.input), Name: cdk.stringToCloudFormation(properties.name), Format: cdk.stringToCloudFormation(properties.format), FormatOptions: cfnDatasetFormatOptionsPropertyToCloudFormation(properties.formatOptions), PathOptions: cfnDatasetPathOptionsPropertyToCloudFormation(properties.pathOptions), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDatasetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("input", "Input", CfnDatasetInputPropertyFromCloudFormation(properties.Input)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("format", "Format", properties.Format != null ? cfn_parse.FromCloudFormation.getString(properties.Format) : void 0), ret.addPropertyResult("formatOptions", "FormatOptions", properties.FormatOptions != null ? CfnDatasetFormatOptionsPropertyFromCloudFormation(properties.FormatOptions) : void 0), ret.addPropertyResult("pathOptions", "PathOptions", properties.PathOptions != null ? CfnDatasetPathOptionsPropertyFromCloudFormation(properties.PathOptions) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDataset = class _CfnDataset extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDatasetPropsFromCloudFormation(resourceProperties), ret = new _CfnDataset(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDataset.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_databrew_CfnDatasetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDataset), error;
        }
        cdk.requireProperty(props, "input", this), cdk.requireProperty(props, "name", this), this.input = props.input, this.name = props.name, this.format = props.format, this.formatOptions = props.formatOptions, this.pathOptions = props.pathOptions, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DataBrew::Dataset", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDataset.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { input: this.input, name: this.name, format: this.format, formatOptions: this.formatOptions, pathOptions: this.pathOptions, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDatasetPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnDataset[_a] = { fqn: "aws-cdk-lib.aws_databrew.CfnDataset", version: "2.80.0" }, CfnDataset.CFN_RESOURCE_TYPE_NAME = "AWS::DataBrew::Dataset", exports2.CfnDataset = CfnDataset;
    function CfnDataset_CsvOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("delimiter", cdk.validateString)(properties.delimiter)), errors.collect(cdk.propertyValidator("headerRow", cdk.validateBoolean)(properties.headerRow)), errors.wrap('supplied properties not correct for "CsvOptionsProperty"');
    }
    function cfnDatasetCsvOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_CsvOptionsPropertyValidator(properties).assertSuccess(), { Delimiter: cdk.stringToCloudFormation(properties.delimiter), HeaderRow: cdk.booleanToCloudFormation(properties.headerRow) }) : properties;
    }
    function CfnDatasetCsvOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("delimiter", "Delimiter", properties.Delimiter != null ? cfn_parse.FromCloudFormation.getString(properties.Delimiter) : void 0), ret.addPropertyResult("headerRow", "HeaderRow", properties.HeaderRow != null ? cfn_parse.FromCloudFormation.getBoolean(properties.HeaderRow) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_DataCatalogInputDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalogId", cdk.validateString)(properties.catalogId)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("tableName", cdk.validateString)(properties.tableName)), errors.collect(cdk.propertyValidator("tempDirectory", CfnDataset_S3LocationPropertyValidator)(properties.tempDirectory)), errors.wrap('supplied properties not correct for "DataCatalogInputDefinitionProperty"');
    }
    function cfnDatasetDataCatalogInputDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_DataCatalogInputDefinitionPropertyValidator(properties).assertSuccess(), { CatalogId: cdk.stringToCloudFormation(properties.catalogId), DatabaseName: cdk.stringToCloudFormation(properties.databaseName), TableName: cdk.stringToCloudFormation(properties.tableName), TempDirectory: cfnDatasetS3LocationPropertyToCloudFormation(properties.tempDirectory) }) : properties;
    }
    function CfnDatasetDataCatalogInputDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalogId", "CatalogId", properties.CatalogId != null ? cfn_parse.FromCloudFormation.getString(properties.CatalogId) : void 0), ret.addPropertyResult("databaseName", "DatabaseName", properties.DatabaseName != null ? cfn_parse.FromCloudFormation.getString(properties.DatabaseName) : void 0), ret.addPropertyResult("tableName", "TableName", properties.TableName != null ? cfn_parse.FromCloudFormation.getString(properties.TableName) : void 0), ret.addPropertyResult("tempDirectory", "TempDirectory", properties.TempDirectory != null ? CfnDatasetS3LocationPropertyFromCloudFormation(properties.TempDirectory) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_DatabaseInputDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("databaseTableName", cdk.validateString)(properties.databaseTableName)), errors.collect(cdk.propertyValidator("glueConnectionName", cdk.requiredValidator)(properties.glueConnectionName)), errors.collect(cdk.propertyValidator("glueConnectionName", cdk.validateString)(properties.glueConnectionName)), errors.collect(cdk.propertyValidator("queryString", cdk.validateString)(properties.queryString)), errors.collect(cdk.propertyValidator("tempDirectory", CfnDataset_S3LocationPropertyValidator)(properties.tempDirectory)), errors.wrap('supplied properties not correct for "DatabaseInputDefinitionProperty"');
    }
    function cfnDatasetDatabaseInputDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_DatabaseInputDefinitionPropertyValidator(properties).assertSuccess(), { DatabaseTableName: cdk.stringToCloudFormation(properties.databaseTableName), GlueConnectionName: cdk.stringToCloudFormation(properties.glueConnectionName), QueryString: cdk.stringToCloudFormation(properties.queryString), TempDirectory: cfnDatasetS3LocationPropertyToCloudFormation(properties.tempDirectory) }) : properties;
    }
    function CfnDatasetDatabaseInputDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("databaseTableName", "DatabaseTableName", properties.DatabaseTableName != null ? cfn_parse.FromCloudFormation.getString(properties.DatabaseTableName) : void 0), ret.addPropertyResult("glueConnectionName", "GlueConnectionName", cfn_parse.FromCloudFormation.getString(properties.GlueConnectionName)), ret.addPropertyResult("queryString", "QueryString", properties.QueryString != null ? cfn_parse.FromCloudFormation.getString(properties.QueryString) : void 0), ret.addPropertyResult("tempDirectory", "TempDirectory", properties.TempDirectory != null ? CfnDatasetS3LocationPropertyFromCloudFormation(properties.TempDirectory) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_DatasetParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("createColumn", cdk.validateBoolean)(properties.createColumn)), errors.collect(cdk.propertyValidator("datetimeOptions", CfnDataset_DatetimeOptionsPropertyValidator)(properties.datetimeOptions)), errors.collect(cdk.propertyValidator("filter", CfnDataset_FilterExpressionPropertyValidator)(properties.filter)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "DatasetParameterProperty"');
    }
    function cfnDatasetDatasetParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_DatasetParameterPropertyValidator(properties).assertSuccess(), { CreateColumn: cdk.booleanToCloudFormation(properties.createColumn), DatetimeOptions: cfnDatasetDatetimeOptionsPropertyToCloudFormation(properties.datetimeOptions), Filter: cfnDatasetFilterExpressionPropertyToCloudFormation(properties.filter), Name: cdk.stringToCloudFormation(properties.name), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnDatasetDatasetParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("createColumn", "CreateColumn", properties.CreateColumn != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CreateColumn) : void 0), ret.addPropertyResult("datetimeOptions", "DatetimeOptions", properties.DatetimeOptions != null ? CfnDatasetDatetimeOptionsPropertyFromCloudFormation(properties.DatetimeOptions) : void 0), ret.addPropertyResult("filter", "Filter", properties.Filter != null ? CfnDatasetFilterExpressionPropertyFromCloudFormation(properties.Filter) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_DatetimeOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("format", cdk.requiredValidator)(properties.format)), errors.collect(cdk.propertyValidator("format", cdk.validateString)(properties.format)), errors.collect(cdk.propertyValidator("localeCode", cdk.validateString)(properties.localeCode)), errors.collect(cdk.propertyValidator("timezoneOffset", cdk.validateString)(properties.timezoneOffset)), errors.wrap('supplied properties not correct for "DatetimeOptionsProperty"');
    }
    function cfnDatasetDatetimeOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_DatetimeOptionsPropertyValidator(properties).assertSuccess(), { Format: cdk.stringToCloudFormation(properties.format), LocaleCode: cdk.stringToCloudFormation(properties.localeCode), TimezoneOffset: cdk.stringToCloudFormation(properties.timezoneOffset) }) : properties;
    }
    function CfnDatasetDatetimeOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("format", "Format", cfn_parse.FromCloudFormation.getString(properties.Format)), ret.addPropertyResult("localeCode", "LocaleCode", properties.LocaleCode != null ? cfn_parse.FromCloudFormation.getString(properties.LocaleCode) : void 0), ret.addPropertyResult("timezoneOffset", "TimezoneOffset", properties.TimezoneOffset != null ? cfn_parse.FromCloudFormation.getString(properties.TimezoneOffset) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_ExcelOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("headerRow", cdk.validateBoolean)(properties.headerRow)), errors.collect(cdk.propertyValidator("sheetIndexes", cdk.listValidator(cdk.validateNumber))(properties.sheetIndexes)), errors.collect(cdk.propertyValidator("sheetNames", cdk.listValidator(cdk.validateString))(properties.sheetNames)), errors.wrap('supplied properties not correct for "ExcelOptionsProperty"');
    }
    function cfnDatasetExcelOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_ExcelOptionsPropertyValidator(properties).assertSuccess(), { HeaderRow: cdk.booleanToCloudFormation(properties.headerRow), SheetIndexes: cdk.listMapper(cdk.numberToCloudFormation)(properties.sheetIndexes), SheetNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.sheetNames) }) : properties;
    }
    function CfnDatasetExcelOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("headerRow", "HeaderRow", properties.HeaderRow != null ? cfn_parse.FromCloudFormation.getBoolean(properties.HeaderRow) : void 0), ret.addPropertyResult("sheetIndexes", "SheetIndexes", properties.SheetIndexes != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getNumber)(properties.SheetIndexes) : void 0), ret.addPropertyResult("sheetNames", "SheetNames", properties.SheetNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SheetNames) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_FilesLimitPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxFiles", cdk.requiredValidator)(properties.maxFiles)), errors.collect(cdk.propertyValidator("maxFiles", cdk.validateNumber)(properties.maxFiles)), errors.collect(cdk.propertyValidator("order", cdk.validateString)(properties.order)), errors.collect(cdk.propertyValidator("orderedBy", cdk.validateString)(properties.orderedBy)), errors.wrap('supplied properties not correct for "FilesLimitProperty"');
    }
    function cfnDatasetFilesLimitPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_FilesLimitPropertyValidator(properties).assertSuccess(), { MaxFiles: cdk.numberToCloudFormation(properties.maxFiles), Order: cdk.stringToCloudFormation(properties.order), OrderedBy: cdk.stringToCloudFormation(properties.orderedBy) }) : properties;
    }
    function CfnDatasetFilesLimitPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxFiles", "MaxFiles", cfn_parse.FromCloudFormation.getNumber(properties.MaxFiles)), ret.addPropertyResult("order", "Order", properties.Order != null ? cfn_parse.FromCloudFormation.getString(properties.Order) : void 0), ret.addPropertyResult("orderedBy", "OrderedBy", properties.OrderedBy != null ? cfn_parse.FromCloudFormation.getString(properties.OrderedBy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_FilterExpressionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.collect(cdk.propertyValidator("valuesMap", cdk.requiredValidator)(properties.valuesMap)), errors.collect(cdk.propertyValidator("valuesMap", cdk.listValidator(CfnDataset_FilterValuePropertyValidator))(properties.valuesMap)), errors.wrap('supplied properties not correct for "FilterExpressionProperty"');
    }
    function cfnDatasetFilterExpressionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_FilterExpressionPropertyValidator(properties).assertSuccess(), { Expression: cdk.stringToCloudFormation(properties.expression), ValuesMap: cdk.listMapper(cfnDatasetFilterValuePropertyToCloudFormation)(properties.valuesMap) }) : properties;
    }
    function CfnDatasetFilterExpressionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getString(properties.Expression)), ret.addPropertyResult("valuesMap", "ValuesMap", cfn_parse.FromCloudFormation.getArray(CfnDatasetFilterValuePropertyFromCloudFormation)(properties.ValuesMap)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_FilterValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.collect(cdk.propertyValidator("valueReference", cdk.requiredValidator)(properties.valueReference)), errors.collect(cdk.propertyValidator("valueReference", cdk.validateString)(properties.valueReference)), errors.wrap('supplied properties not correct for "FilterValueProperty"');
    }
    function cfnDatasetFilterValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_FilterValuePropertyValidator(properties).assertSuccess(), { Value: cdk.stringToCloudFormation(properties.value), ValueReference: cdk.stringToCloudFormation(properties.valueReference) }) : properties;
    }
    function CfnDatasetFilterValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addPropertyResult("valueReference", "ValueReference", cfn_parse.FromCloudFormation.getString(properties.ValueReference)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_FormatOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("csv", CfnDataset_CsvOptionsPropertyValidator)(properties.csv)), errors.collect(cdk.propertyValidator("excel", CfnDataset_ExcelOptionsPropertyValidator)(properties.excel)), errors.collect(cdk.propertyValidator("json", CfnDataset_JsonOptionsPropertyValidator)(properties.json)), errors.wrap('supplied properties not correct for "FormatOptionsProperty"');
    }
    function cfnDatasetFormatOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_FormatOptionsPropertyValidator(properties).assertSuccess(), { Csv: cfnDatasetCsvOptionsPropertyToCloudFormation(properties.csv), Excel: cfnDatasetExcelOptionsPropertyToCloudFormation(properties.excel), Json: cfnDatasetJsonOptionsPropertyToCloudFormation(properties.json) }) : properties;
    }
    function CfnDatasetFormatOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("csv", "Csv", properties.Csv != null ? CfnDatasetCsvOptionsPropertyFromCloudFormation(properties.Csv) : void 0), ret.addPropertyResult("excel", "Excel", properties.Excel != null ? CfnDatasetExcelOptionsPropertyFromCloudFormation(properties.Excel) : void 0), ret.addPropertyResult("json", "Json", properties.Json != null ? CfnDatasetJsonOptionsPropertyFromCloudFormation(properties.Json) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_InputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataCatalogInputDefinition", CfnDataset_DataCatalogInputDefinitionPropertyValidator)(properties.dataCatalogInputDefinition)), errors.collect(cdk.propertyValidator("databaseInputDefinition", CfnDataset_DatabaseInputDefinitionPropertyValidator)(properties.databaseInputDefinition)), errors.collect(cdk.propertyValidator("metadata", CfnDataset_MetadataPropertyValidator)(properties.metadata)), errors.collect(cdk.propertyValidator("s3InputDefinition", CfnDataset_S3LocationPropertyValidator)(properties.s3InputDefinition)), errors.wrap('supplied properties not correct for "InputProperty"');
    }
    function cfnDatasetInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_InputPropertyValidator(properties).assertSuccess(), { DataCatalogInputDefinition: cfnDatasetDataCatalogInputDefinitionPropertyToCloudFormation(properties.dataCatalogInputDefinition), DatabaseInputDefinition: cfnDatasetDatabaseInputDefinitionPropertyToCloudFormation(properties.databaseInputDefinition), Metadata: cfnDatasetMetadataPropertyToCloudFormation(properties.metadata), S3InputDefinition: cfnDatasetS3LocationPropertyToCloudFormation(properties.s3InputDefinition) }) : properties;
    }
    function CfnDatasetInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataCatalogInputDefinition", "DataCatalogInputDefinition", properties.DataCatalogInputDefinition != null ? CfnDatasetDataCatalogInputDefinitionPropertyFromCloudFormation(properties.DataCatalogInputDefinition) : void 0), ret.addPropertyResult("databaseInputDefinition", "DatabaseInputDefinition", properties.DatabaseInputDefinition != null ? CfnDatasetDatabaseInputDefinitionPropertyFromCloudFormation(properties.DatabaseInputDefinition) : void 0), ret.addPropertyResult("metadata", "Metadata", properties.Metadata != null ? CfnDatasetMetadataPropertyFromCloudFormation(properties.Metadata) : void 0), ret.addPropertyResult("s3InputDefinition", "S3InputDefinition", properties.S3InputDefinition != null ? CfnDatasetS3LocationPropertyFromCloudFormation(properties.S3InputDefinition) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_JsonOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("multiLine", cdk.validateBoolean)(properties.multiLine)), errors.wrap('supplied properties not correct for "JsonOptionsProperty"');
    }
    function cfnDatasetJsonOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_JsonOptionsPropertyValidator(properties).assertSuccess(), { MultiLine: cdk.booleanToCloudFormation(properties.multiLine) }) : properties;
    }
    function CfnDatasetJsonOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("multiLine", "MultiLine", properties.MultiLine != null ? cfn_parse.FromCloudFormation.getBoolean(properties.MultiLine) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_MetadataPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sourceArn", cdk.validateString)(properties.sourceArn)), errors.wrap('supplied properties not correct for "MetadataProperty"');
    }
    function cfnDatasetMetadataPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_MetadataPropertyValidator(properties).assertSuccess(), { SourceArn: cdk.stringToCloudFormation(properties.sourceArn) }) : properties;
    }
    function CfnDatasetMetadataPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sourceArn", "SourceArn", properties.SourceArn != null ? cfn_parse.FromCloudFormation.getString(properties.SourceArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_PathOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("filesLimit", CfnDataset_FilesLimitPropertyValidator)(properties.filesLimit)), errors.collect(cdk.propertyValidator("lastModifiedDateCondition", CfnDataset_FilterExpressionPropertyValidator)(properties.lastModifiedDateCondition)), errors.collect(cdk.propertyValidator("parameters", cdk.listValidator(CfnDataset_PathParameterPropertyValidator))(properties.parameters)), errors.wrap('supplied properties not correct for "PathOptionsProperty"');
    }
    function cfnDatasetPathOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_PathOptionsPropertyValidator(properties).assertSuccess(), { FilesLimit: cfnDatasetFilesLimitPropertyToCloudFormation(properties.filesLimit), LastModifiedDateCondition: cfnDatasetFilterExpressionPropertyToCloudFormation(properties.lastModifiedDateCondition), Parameters: cdk.listMapper(cfnDatasetPathParameterPropertyToCloudFormation)(properties.parameters) }) : properties;
    }
    function CfnDatasetPathOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("filesLimit", "FilesLimit", properties.FilesLimit != null ? CfnDatasetFilesLimitPropertyFromCloudFormation(properties.FilesLimit) : void 0), ret.addPropertyResult("lastModifiedDateCondition", "LastModifiedDateCondition", properties.LastModifiedDateCondition != null ? CfnDatasetFilterExpressionPropertyFromCloudFormation(properties.LastModifiedDateCondition) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getArray(CfnDatasetPathParameterPropertyFromCloudFormation)(properties.Parameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_PathParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("datasetParameter", cdk.requiredValidator)(properties.datasetParameter)), errors.collect(cdk.propertyValidator("datasetParameter", CfnDataset_DatasetParameterPropertyValidator)(properties.datasetParameter)), errors.collect(cdk.propertyValidator("pathParameterName", cdk.requiredValidator)(properties.pathParameterName)), errors.collect(cdk.propertyValidator("pathParameterName", cdk.validateString)(properties.pathParameterName)), errors.wrap('supplied properties not correct for "PathParameterProperty"');
    }
    function cfnDatasetPathParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_PathParameterPropertyValidator(properties).assertSuccess(), { DatasetParameter: cfnDatasetDatasetParameterPropertyToCloudFormation(properties.datasetParameter), PathParameterName: cdk.stringToCloudFormation(properties.pathParameterName) }) : properties;
    }
    function CfnDatasetPathParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("datasetParameter", "DatasetParameter", CfnDatasetDatasetParameterPropertyFromCloudFormation(properties.DatasetParameter)), ret.addPropertyResult("pathParameterName", "PathParameterName", cfn_parse.FromCloudFormation.getString(properties.PathParameterName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_S3LocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.requiredValidator)(properties.bucket)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.wrap('supplied properties not correct for "S3LocationProperty"');
    }
    function cfnDatasetS3LocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_S3LocationPropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), Key: cdk.stringToCloudFormation(properties.key) }) : properties;
    }
    function CfnDatasetS3LocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", cfn_parse.FromCloudFormation.getString(properties.Bucket)), ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataCatalogOutputs", cdk.listValidator(CfnJob_DataCatalogOutputPropertyValidator))(properties.dataCatalogOutputs)), errors.collect(cdk.propertyValidator("databaseOutputs", cdk.listValidator(CfnJob_DatabaseOutputPropertyValidator))(properties.databaseOutputs)), errors.collect(cdk.propertyValidator("datasetName", cdk.validateString)(properties.datasetName)), errors.collect(cdk.propertyValidator("encryptionKeyArn", cdk.validateString)(properties.encryptionKeyArn)), errors.collect(cdk.propertyValidator("encryptionMode", cdk.validateString)(properties.encryptionMode)), errors.collect(cdk.propertyValidator("jobSample", CfnJob_JobSamplePropertyValidator)(properties.jobSample)), errors.collect(cdk.propertyValidator("logSubscription", cdk.validateString)(properties.logSubscription)), errors.collect(cdk.propertyValidator("maxCapacity", cdk.validateNumber)(properties.maxCapacity)), errors.collect(cdk.propertyValidator("maxRetries", cdk.validateNumber)(properties.maxRetries)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("outputLocation", CfnJob_OutputLocationPropertyValidator)(properties.outputLocation)), errors.collect(cdk.propertyValidator("outputs", cdk.listValidator(CfnJob_OutputPropertyValidator))(properties.outputs)), errors.collect(cdk.propertyValidator("profileConfiguration", CfnJob_ProfileConfigurationPropertyValidator)(properties.profileConfiguration)), errors.collect(cdk.propertyValidator("projectName", cdk.validateString)(properties.projectName)), errors.collect(cdk.propertyValidator("recipe", CfnJob_RecipePropertyValidator)(properties.recipe)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("timeout", cdk.validateNumber)(properties.timeout)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("validationConfigurations", cdk.listValidator(CfnJob_ValidationConfigurationPropertyValidator))(properties.validationConfigurations)), errors.wrap('supplied properties not correct for "CfnJobProps"');
    }
    function cfnJobPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), RoleArn: cdk.stringToCloudFormation(properties.roleArn), Type: cdk.stringToCloudFormation(properties.type), DatabaseOutputs: cdk.listMapper(cfnJobDatabaseOutputPropertyToCloudFormation)(properties.databaseOutputs), DataCatalogOutputs: cdk.listMapper(cfnJobDataCatalogOutputPropertyToCloudFormation)(properties.dataCatalogOutputs), DatasetName: cdk.stringToCloudFormation(properties.datasetName), EncryptionKeyArn: cdk.stringToCloudFormation(properties.encryptionKeyArn), EncryptionMode: cdk.stringToCloudFormation(properties.encryptionMode), JobSample: cfnJobJobSamplePropertyToCloudFormation(properties.jobSample), LogSubscription: cdk.stringToCloudFormation(properties.logSubscription), MaxCapacity: cdk.numberToCloudFormation(properties.maxCapacity), MaxRetries: cdk.numberToCloudFormation(properties.maxRetries), OutputLocation: cfnJobOutputLocationPropertyToCloudFormation(properties.outputLocation), Outputs: cdk.listMapper(cfnJobOutputPropertyToCloudFormation)(properties.outputs), ProfileConfiguration: cfnJobProfileConfigurationPropertyToCloudFormation(properties.profileConfiguration), ProjectName: cdk.stringToCloudFormation(properties.projectName), Recipe: cfnJobRecipePropertyToCloudFormation(properties.recipe), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), Timeout: cdk.numberToCloudFormation(properties.timeout), ValidationConfigurations: cdk.listMapper(cfnJobValidationConfigurationPropertyToCloudFormation)(properties.validationConfigurations) }) : properties;
    }
    function CfnJobPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("databaseOutputs", "DatabaseOutputs", properties.DatabaseOutputs != null ? cfn_parse.FromCloudFormation.getArray(CfnJobDatabaseOutputPropertyFromCloudFormation)(properties.DatabaseOutputs) : void 0), ret.addPropertyResult("dataCatalogOutputs", "DataCatalogOutputs", properties.DataCatalogOutputs != null ? cfn_parse.FromCloudFormation.getArray(CfnJobDataCatalogOutputPropertyFromCloudFormation)(properties.DataCatalogOutputs) : void 0), ret.addPropertyResult("datasetName", "DatasetName", properties.DatasetName != null ? cfn_parse.FromCloudFormation.getString(properties.DatasetName) : void 0), ret.addPropertyResult("encryptionKeyArn", "EncryptionKeyArn", properties.EncryptionKeyArn != null ? cfn_parse.FromCloudFormation.getString(properties.EncryptionKeyArn) : void 0), ret.addPropertyResult("encryptionMode", "EncryptionMode", properties.EncryptionMode != null ? cfn_parse.FromCloudFormation.getString(properties.EncryptionMode) : void 0), ret.addPropertyResult("jobSample", "JobSample", properties.JobSample != null ? CfnJobJobSamplePropertyFromCloudFormation(properties.JobSample) : void 0), ret.addPropertyResult("logSubscription", "LogSubscription", properties.LogSubscription != null ? cfn_parse.FromCloudFormation.getString(properties.LogSubscription) : void 0), ret.addPropertyResult("maxCapacity", "MaxCapacity", properties.MaxCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxCapacity) : void 0), ret.addPropertyResult("maxRetries", "MaxRetries", properties.MaxRetries != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxRetries) : void 0), ret.addPropertyResult("outputLocation", "OutputLocation", properties.OutputLocation != null ? CfnJobOutputLocationPropertyFromCloudFormation(properties.OutputLocation) : void 0), ret.addPropertyResult("outputs", "Outputs", properties.Outputs != null ? cfn_parse.FromCloudFormation.getArray(CfnJobOutputPropertyFromCloudFormation)(properties.Outputs) : void 0), ret.addPropertyResult("profileConfiguration", "ProfileConfiguration", properties.ProfileConfiguration != null ? CfnJobProfileConfigurationPropertyFromCloudFormation(properties.ProfileConfiguration) : void 0), ret.addPropertyResult("projectName", "ProjectName", properties.ProjectName != null ? cfn_parse.FromCloudFormation.getString(properties.ProjectName) : void 0), ret.addPropertyResult("recipe", "Recipe", properties.Recipe != null ? CfnJobRecipePropertyFromCloudFormation(properties.Recipe) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("timeout", "Timeout", properties.Timeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.Timeout) : void 0), ret.addPropertyResult("validationConfigurations", "ValidationConfigurations", properties.ValidationConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnJobValidationConfigurationPropertyFromCloudFormation)(properties.ValidationConfigurations) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnJob = class _CfnJob extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnJobPropsFromCloudFormation(resourceProperties), ret = new _CfnJob(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnJob.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_databrew_CfnJobProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnJob), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "roleArn", this), cdk.requireProperty(props, "type", this), this.name = props.name, this.roleArn = props.roleArn, this.type = props.type, this.databaseOutputs = props.databaseOutputs, this.dataCatalogOutputs = props.dataCatalogOutputs, this.datasetName = props.datasetName, this.encryptionKeyArn = props.encryptionKeyArn, this.encryptionMode = props.encryptionMode, this.jobSample = props.jobSample, this.logSubscription = props.logSubscription, this.maxCapacity = props.maxCapacity, this.maxRetries = props.maxRetries, this.outputLocation = props.outputLocation, this.outputs = props.outputs, this.profileConfiguration = props.profileConfiguration, this.projectName = props.projectName, this.recipe = props.recipe, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DataBrew::Job", props.tags, { tagPropertyName: "tags" }), this.timeout = props.timeout, this.validationConfigurations = props.validationConfigurations;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnJob.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, roleArn: this.roleArn, type: this.type, databaseOutputs: this.databaseOutputs, dataCatalogOutputs: this.dataCatalogOutputs, datasetName: this.datasetName, encryptionKeyArn: this.encryptionKeyArn, encryptionMode: this.encryptionMode, jobSample: this.jobSample, logSubscription: this.logSubscription, maxCapacity: this.maxCapacity, maxRetries: this.maxRetries, outputLocation: this.outputLocation, outputs: this.outputs, profileConfiguration: this.profileConfiguration, projectName: this.projectName, recipe: this.recipe, tags: this.tags.renderTags(), timeout: this.timeout, validationConfigurations: this.validationConfigurations };
      }
      renderProperties(props) {
        return cfnJobPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnJob[_b] = { fqn: "aws-cdk-lib.aws_databrew.CfnJob", version: "2.80.0" }, CfnJob.CFN_RESOURCE_TYPE_NAME = "AWS::DataBrew::Job", exports2.CfnJob = CfnJob;
    function CfnJob_AllowedStatisticsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("statistics", cdk.requiredValidator)(properties.statistics)), errors.collect(cdk.propertyValidator("statistics", cdk.listValidator(cdk.validateString))(properties.statistics)), errors.wrap('supplied properties not correct for "AllowedStatisticsProperty"');
    }
    function cfnJobAllowedStatisticsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJob_AllowedStatisticsPropertyValidator(properties).assertSuccess(), { Statistics: cdk.listMapper(cdk.stringToCloudFormation)(properties.statistics) }) : properties;
    }
    function CfnJobAllowedStatisticsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("statistics", "Statistics", cfn_parse.FromCloudFormation.getStringArray(properties.Statistics)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJob_ColumnSelectorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("regex", cdk.validateString)(properties.regex)), errors.wrap('supplied properties not correct for "ColumnSelectorProperty"');
    }
    function cfnJobColumnSelectorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJob_ColumnSelectorPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Regex: cdk.stringToCloudFormation(properties.regex) }) : properties;
    }
    function CfnJobColumnSelectorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("regex", "Regex", properties.Regex != null ? cfn_parse.FromCloudFormation.getString(properties.Regex) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJob_ColumnStatisticsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("selectors", cdk.listValidator(CfnJob_ColumnSelectorPropertyValidator))(properties.selectors)), errors.collect(cdk.propertyValidator("statistics", cdk.requiredValidator)(properties.statistics)), errors.collect(cdk.propertyValidator("statistics", CfnJob_StatisticsConfigurationPropertyValidator)(properties.statistics)), errors.wrap('supplied properties not correct for "ColumnStatisticsConfigurationProperty"');
    }
    function cfnJobColumnStatisticsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJob_ColumnStatisticsConfigurationPropertyValidator(properties).assertSuccess(), { Selectors: cdk.listMapper(cfnJobColumnSelectorPropertyToCloudFormation)(properties.selectors), Statistics: cfnJobStatisticsConfigurationPropertyToCloudFormation(properties.statistics) }) : properties;
    }
    function CfnJobColumnStatisticsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("selectors", "Selectors", properties.Selectors != null ? cfn_parse.FromCloudFormation.getArray(CfnJobColumnSelectorPropertyFromCloudFormation)(properties.Selectors) : void 0), ret.addPropertyResult("statistics", "Statistics", CfnJobStatisticsConfigurationPropertyFromCloudFormation(properties.Statistics)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJob_CsvOutputOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("delimiter", cdk.validateString)(properties.delimiter)), errors.wrap('supplied properties not correct for "CsvOutputOptionsProperty"');
    }
    function cfnJobCsvOutputOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJob_CsvOutputOptionsPropertyValidator(properties).assertSuccess(), { Delimiter: cdk.stringToCloudFormation(properties.delimiter) }) : properties;
    }
    function CfnJobCsvOutputOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("delimiter", "Delimiter", properties.Delimiter != null ? cfn_parse.FromCloudFormation.getString(properties.Delimiter) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJob_DataCatalogOutputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalogId", cdk.validateString)(properties.catalogId)), errors.collect(cdk.propertyValidator("databaseName", cdk.requiredValidator)(properties.databaseName)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("databaseOptions", CfnJob_DatabaseTableOutputOptionsPropertyValidator)(properties.databaseOptions)), errors.collect(cdk.propertyValidator("overwrite", cdk.validateBoolean)(properties.overwrite)), errors.collect(cdk.propertyValidator("s3Options", CfnJob_S3TableOutputOptionsPropertyValidator)(properties.s3Options)), errors.collect(cdk.propertyValidator("tableName", cdk.requiredValidator)(properties.tableName)), errors.collect(cdk.propertyValidator("tableName", cdk.validateString)(properties.tableName)), errors.wrap('supplied properties not correct for "DataCatalogOutputProperty"');
    }
    function cfnJobDataCatalogOutputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJob_DataCatalogOutputPropertyValidator(properties).assertSuccess(), { CatalogId: cdk.stringToCloudFormation(properties.catalogId), DatabaseName: cdk.stringToCloudFormation(properties.databaseName), DatabaseOptions: cfnJobDatabaseTableOutputOptionsPropertyToCloudFormation(properties.databaseOptions), Overwrite: cdk.booleanToCloudFormation(properties.overwrite), S3Options: cfnJobS3TableOutputOptionsPropertyToCloudFormation(properties.s3Options), TableName: cdk.stringToCloudFormation(properties.tableName) }) : properties;
    }
    function CfnJobDataCatalogOutputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalogId", "CatalogId", properties.CatalogId != null ? cfn_parse.FromCloudFormation.getString(properties.CatalogId) : void 0), ret.addPropertyResult("databaseName", "DatabaseName", cfn_parse.FromCloudFormation.getString(properties.DatabaseName)), ret.addPropertyResult("databaseOptions", "DatabaseOptions", properties.DatabaseOptions != null ? CfnJobDatabaseTableOutputOptionsPropertyFromCloudFormation(properties.DatabaseOptions) : void 0), ret.addPropertyResult("overwrite", "Overwrite", properties.Overwrite != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Overwrite) : void 0), ret.addPropertyResult("s3Options", "S3Options", properties.S3Options != null ? CfnJobS3TableOutputOptionsPropertyFromCloudFormation(properties.S3Options) : void 0), ret.addPropertyResult("tableName", "TableName", cfn_parse.FromCloudFormation.getString(properties.TableName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJob_DatabaseOutputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("databaseOptions", cdk.requiredValidator)(properties.databaseOptions)), errors.collect(cdk.propertyValidator("databaseOptions", CfnJob_DatabaseTableOutputOptionsPropertyValidator)(properties.databaseOptions)), errors.collect(cdk.propertyValidator("databaseOutputMode", cdk.validateString)(properties.databaseOutputMode)), errors.collect(cdk.propertyValidator("glueConnectionName", cdk.requiredValidator)(properties.glueConnectionName)), errors.collect(cdk.propertyValidator("glueConnectionName", cdk.validateString)(properties.glueConnectionName)), errors.wrap('supplied properties not correct for "DatabaseOutputProperty"');
    }
    function cfnJobDatabaseOutputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJob_DatabaseOutputPropertyValidator(properties).assertSuccess(), { DatabaseOptions: cfnJobDatabaseTableOutputOptionsPropertyToCloudFormation(properties.databaseOptions), DatabaseOutputMode: cdk.stringToCloudFormation(properties.databaseOutputMode), GlueConnectionName: cdk.stringToCloudFormation(properties.glueConnectionName) }) : properties;
    }
    function CfnJobDatabaseOutputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("databaseOptions", "DatabaseOptions", CfnJobDatabaseTableOutputOptionsPropertyFromCloudFormation(properties.DatabaseOptions)), ret.addPropertyResult("databaseOutputMode", "DatabaseOutputMode", properties.DatabaseOutputMode != null ? cfn_parse.FromCloudFormation.getString(properties.DatabaseOutputMode) : void 0), ret.addPropertyResult("glueConnectionName", "GlueConnectionName", cfn_parse.FromCloudFormation.getString(properties.GlueConnectionName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJob_DatabaseTableOutputOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("tableName", cdk.requiredValidator)(properties.tableName)), errors.collect(cdk.propertyValidator("tableName", cdk.validateString)(properties.tableName)), errors.collect(cdk.propertyValidator("tempDirectory", CfnJob_S3LocationPropertyValidator)(properties.tempDirectory)), errors.wrap('supplied properties not correct for "DatabaseTableOutputOptionsProperty"');
    }
    function cfnJobDatabaseTableOutputOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJob_DatabaseTableOutputOptionsPropertyValidator(properties).assertSuccess(), { TableName: cdk.stringToCloudFormation(properties.tableName), TempDirectory: cfnJobS3LocationPropertyToCloudFormation(properties.tempDirectory) }) : properties;
    }
    function CfnJobDatabaseTableOutputOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("tableName", "TableName", cfn_parse.FromCloudFormation.getString(properties.TableName)), ret.addPropertyResult("tempDirectory", "TempDirectory", properties.TempDirectory != null ? CfnJobS3LocationPropertyFromCloudFormation(properties.TempDirectory) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJob_EntityDetectorConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowedStatistics", CfnJob_AllowedStatisticsPropertyValidator)(properties.allowedStatistics)), errors.collect(cdk.propertyValidator("entityTypes", cdk.requiredValidator)(properties.entityTypes)), errors.collect(cdk.propertyValidator("entityTypes", cdk.listValidator(cdk.validateString))(properties.entityTypes)), errors.wrap('supplied properties not correct for "EntityDetectorConfigurationProperty"');
    }
    function cfnJobEntityDetectorConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJob_EntityDetectorConfigurationPropertyValidator(properties).assertSuccess(), { AllowedStatistics: cfnJobAllowedStatisticsPropertyToCloudFormation(properties.allowedStatistics), EntityTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.entityTypes) }) : properties;
    }
    function CfnJobEntityDetectorConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowedStatistics", "AllowedStatistics", properties.AllowedStatistics != null ? CfnJobAllowedStatisticsPropertyFromCloudFormation(properties.AllowedStatistics) : void 0), ret.addPropertyResult("entityTypes", "EntityTypes", cfn_parse.FromCloudFormation.getStringArray(properties.EntityTypes)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJob_JobSamplePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mode", cdk.validateString)(properties.mode)), errors.collect(cdk.propertyValidator("size", cdk.validateNumber)(properties.size)), errors.wrap('supplied properties not correct for "JobSampleProperty"');
    }
    function cfnJobJobSamplePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJob_JobSamplePropertyValidator(properties).assertSuccess(), { Mode: cdk.stringToCloudFormation(properties.mode), Size: cdk.numberToCloudFormation(properties.size) }) : properties;
    }
    function CfnJobJobSamplePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mode", "Mode", properties.Mode != null ? cfn_parse.FromCloudFormation.getString(properties.Mode) : void 0), ret.addPropertyResult("size", "Size", properties.Size != null ? cfn_parse.FromCloudFormation.getNumber(properties.Size) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJob_OutputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("compressionFormat", cdk.validateString)(properties.compressionFormat)), errors.collect(cdk.propertyValidator("format", cdk.validateString)(properties.format)), errors.collect(cdk.propertyValidator("formatOptions", CfnJob_OutputFormatOptionsPropertyValidator)(properties.formatOptions)), errors.collect(cdk.propertyValidator("location", cdk.requiredValidator)(properties.location)), errors.collect(cdk.propertyValidator("location", CfnJob_S3LocationPropertyValidator)(properties.location)), errors.collect(cdk.propertyValidator("maxOutputFiles", cdk.validateNumber)(properties.maxOutputFiles)), errors.collect(cdk.propertyValidator("overwrite", cdk.validateBoolean)(properties.overwrite)), errors.collect(cdk.propertyValidator("partitionColumns", cdk.listValidator(cdk.validateString))(properties.partitionColumns)), errors.wrap('supplied properties not correct for "OutputProperty"');
    }
    function cfnJobOutputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJob_OutputPropertyValidator(properties).assertSuccess(), { CompressionFormat: cdk.stringToCloudFormation(properties.compressionFormat), Format: cdk.stringToCloudFormation(properties.format), FormatOptions: cfnJobOutputFormatOptionsPropertyToCloudFormation(properties.formatOptions), Location: cfnJobS3LocationPropertyToCloudFormation(properties.location), MaxOutputFiles: cdk.numberToCloudFormation(properties.maxOutputFiles), Overwrite: cdk.booleanToCloudFormation(properties.overwrite), PartitionColumns: cdk.listMapper(cdk.stringToCloudFormation)(properties.partitionColumns) }) : properties;
    }
    function CfnJobOutputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("compressionFormat", "CompressionFormat", properties.CompressionFormat != null ? cfn_parse.FromCloudFormation.getString(properties.CompressionFormat) : void 0), ret.addPropertyResult("format", "Format", properties.Format != null ? cfn_parse.FromCloudFormation.getString(properties.Format) : void 0), ret.addPropertyResult("formatOptions", "FormatOptions", properties.FormatOptions != null ? CfnJobOutputFormatOptionsPropertyFromCloudFormation(properties.FormatOptions) : void 0), ret.addPropertyResult("location", "Location", CfnJobS3LocationPropertyFromCloudFormation(properties.Location)), ret.addPropertyResult("maxOutputFiles", "MaxOutputFiles", properties.MaxOutputFiles != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxOutputFiles) : void 0), ret.addPropertyResult("overwrite", "Overwrite", properties.Overwrite != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Overwrite) : void 0), ret.addPropertyResult("partitionColumns", "PartitionColumns", properties.PartitionColumns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.PartitionColumns) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJob_OutputFormatOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("csv", CfnJob_CsvOutputOptionsPropertyValidator)(properties.csv)), errors.wrap('supplied properties not correct for "OutputFormatOptionsProperty"');
    }
    function cfnJobOutputFormatOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJob_OutputFormatOptionsPropertyValidator(properties).assertSuccess(), { Csv: cfnJobCsvOutputOptionsPropertyToCloudFormation(properties.csv) }) : properties;
    }
    function CfnJobOutputFormatOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("csv", "Csv", properties.Csv != null ? CfnJobCsvOutputOptionsPropertyFromCloudFormation(properties.Csv) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJob_OutputLocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.requiredValidator)(properties.bucket)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("bucketOwner", cdk.validateString)(properties.bucketOwner)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.wrap('supplied properties not correct for "OutputLocationProperty"');
    }
    function cfnJobOutputLocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJob_OutputLocationPropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), BucketOwner: cdk.stringToCloudFormation(properties.bucketOwner), Key: cdk.stringToCloudFormation(properties.key) }) : properties;
    }
    function CfnJobOutputLocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", cfn_parse.FromCloudFormation.getString(properties.Bucket)), ret.addPropertyResult("bucketOwner", "BucketOwner", properties.BucketOwner != null ? cfn_parse.FromCloudFormation.getString(properties.BucketOwner) : void 0), ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJob_ProfileConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnStatisticsConfigurations", cdk.listValidator(CfnJob_ColumnStatisticsConfigurationPropertyValidator))(properties.columnStatisticsConfigurations)), errors.collect(cdk.propertyValidator("datasetStatisticsConfiguration", CfnJob_StatisticsConfigurationPropertyValidator)(properties.datasetStatisticsConfiguration)), errors.collect(cdk.propertyValidator("entityDetectorConfiguration", CfnJob_EntityDetectorConfigurationPropertyValidator)(properties.entityDetectorConfiguration)), errors.collect(cdk.propertyValidator("profileColumns", cdk.listValidator(CfnJob_ColumnSelectorPropertyValidator))(properties.profileColumns)), errors.wrap('supplied properties not correct for "ProfileConfigurationProperty"');
    }
    function cfnJobProfileConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJob_ProfileConfigurationPropertyValidator(properties).assertSuccess(), { ColumnStatisticsConfigurations: cdk.listMapper(cfnJobColumnStatisticsConfigurationPropertyToCloudFormation)(properties.columnStatisticsConfigurations), DatasetStatisticsConfiguration: cfnJobStatisticsConfigurationPropertyToCloudFormation(properties.datasetStatisticsConfiguration), EntityDetectorConfiguration: cfnJobEntityDetectorConfigurationPropertyToCloudFormation(properties.entityDetectorConfiguration), ProfileColumns: cdk.listMapper(cfnJobColumnSelectorPropertyToCloudFormation)(properties.profileColumns) }) : properties;
    }
    function CfnJobProfileConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columnStatisticsConfigurations", "ColumnStatisticsConfigurations", properties.ColumnStatisticsConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnJobColumnStatisticsConfigurationPropertyFromCloudFormation)(properties.ColumnStatisticsConfigurations) : void 0), ret.addPropertyResult("datasetStatisticsConfiguration", "DatasetStatisticsConfiguration", properties.DatasetStatisticsConfiguration != null ? CfnJobStatisticsConfigurationPropertyFromCloudFormation(properties.DatasetStatisticsConfiguration) : void 0), ret.addPropertyResult("entityDetectorConfiguration", "EntityDetectorConfiguration", properties.EntityDetectorConfiguration != null ? CfnJobEntityDetectorConfigurationPropertyFromCloudFormation(properties.EntityDetectorConfiguration) : void 0), ret.addPropertyResult("profileColumns", "ProfileColumns", properties.ProfileColumns != null ? cfn_parse.FromCloudFormation.getArray(CfnJobColumnSelectorPropertyFromCloudFormation)(properties.ProfileColumns) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJob_RecipePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "RecipeProperty"');
    }
    function cfnJobRecipePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJob_RecipePropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnJobRecipePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getString(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJob_S3LocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.requiredValidator)(properties.bucket)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("bucketOwner", cdk.validateString)(properties.bucketOwner)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.wrap('supplied properties not correct for "S3LocationProperty"');
    }
    function cfnJobS3LocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJob_S3LocationPropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), BucketOwner: cdk.stringToCloudFormation(properties.bucketOwner), Key: cdk.stringToCloudFormation(properties.key) }) : properties;
    }
    function CfnJobS3LocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", cfn_parse.FromCloudFormation.getString(properties.Bucket)), ret.addPropertyResult("bucketOwner", "BucketOwner", properties.BucketOwner != null ? cfn_parse.FromCloudFormation.getString(properties.BucketOwner) : void 0), ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJob_S3TableOutputOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("location", cdk.requiredValidator)(properties.location)), errors.collect(cdk.propertyValidator("location", CfnJob_S3LocationPropertyValidator)(properties.location)), errors.wrap('supplied properties not correct for "S3TableOutputOptionsProperty"');
    }
    function cfnJobS3TableOutputOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJob_S3TableOutputOptionsPropertyValidator(properties).assertSuccess(), { Location: cfnJobS3LocationPropertyToCloudFormation(properties.location) }) : properties;
    }
    function CfnJobS3TableOutputOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("location", "Location", CfnJobS3LocationPropertyFromCloudFormation(properties.Location)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJob_StatisticOverridePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("parameters", cdk.requiredValidator)(properties.parameters)), errors.collect(cdk.propertyValidator("parameters", cdk.hashValidator(cdk.validateString))(properties.parameters)), errors.collect(cdk.propertyValidator("statistic", cdk.requiredValidator)(properties.statistic)), errors.collect(cdk.propertyValidator("statistic", cdk.validateString)(properties.statistic)), errors.wrap('supplied properties not correct for "StatisticOverrideProperty"');
    }
    function cfnJobStatisticOverridePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJob_StatisticOverridePropertyValidator(properties).assertSuccess(), { Parameters: cdk.hashMapper(cdk.stringToCloudFormation)(properties.parameters), Statistic: cdk.stringToCloudFormation(properties.statistic) }) : properties;
    }
    function CfnJobStatisticOverridePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("parameters", "Parameters", cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Parameters)), ret.addPropertyResult("statistic", "Statistic", cfn_parse.FromCloudFormation.getString(properties.Statistic)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJob_StatisticsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("includedStatistics", cdk.listValidator(cdk.validateString))(properties.includedStatistics)), errors.collect(cdk.propertyValidator("overrides", cdk.listValidator(CfnJob_StatisticOverridePropertyValidator))(properties.overrides)), errors.wrap('supplied properties not correct for "StatisticsConfigurationProperty"');
    }
    function cfnJobStatisticsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJob_StatisticsConfigurationPropertyValidator(properties).assertSuccess(), { IncludedStatistics: cdk.listMapper(cdk.stringToCloudFormation)(properties.includedStatistics), Overrides: cdk.listMapper(cfnJobStatisticOverridePropertyToCloudFormation)(properties.overrides) }) : properties;
    }
    function CfnJobStatisticsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("includedStatistics", "IncludedStatistics", properties.IncludedStatistics != null ? cfn_parse.FromCloudFormation.getStringArray(properties.IncludedStatistics) : void 0), ret.addPropertyResult("overrides", "Overrides", properties.Overrides != null ? cfn_parse.FromCloudFormation.getArray(CfnJobStatisticOverridePropertyFromCloudFormation)(properties.Overrides) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJob_ValidationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("rulesetArn", cdk.requiredValidator)(properties.rulesetArn)), errors.collect(cdk.propertyValidator("rulesetArn", cdk.validateString)(properties.rulesetArn)), errors.collect(cdk.propertyValidator("validationMode", cdk.validateString)(properties.validationMode)), errors.wrap('supplied properties not correct for "ValidationConfigurationProperty"');
    }
    function cfnJobValidationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJob_ValidationConfigurationPropertyValidator(properties).assertSuccess(), { RulesetArn: cdk.stringToCloudFormation(properties.rulesetArn), ValidationMode: cdk.stringToCloudFormation(properties.validationMode) }) : properties;
    }
    function CfnJobValidationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("rulesetArn", "RulesetArn", cfn_parse.FromCloudFormation.getString(properties.RulesetArn)), ret.addPropertyResult("validationMode", "ValidationMode", properties.ValidationMode != null ? cfn_parse.FromCloudFormation.getString(properties.ValidationMode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnProjectPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("datasetName", cdk.requiredValidator)(properties.datasetName)), errors.collect(cdk.propertyValidator("datasetName", cdk.validateString)(properties.datasetName)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("recipeName", cdk.requiredValidator)(properties.recipeName)), errors.collect(cdk.propertyValidator("recipeName", cdk.validateString)(properties.recipeName)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("sample", CfnProject_SamplePropertyValidator)(properties.sample)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnProjectProps"');
    }
    function cfnProjectPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProjectPropsValidator(properties).assertSuccess(), { DatasetName: cdk.stringToCloudFormation(properties.datasetName), Name: cdk.stringToCloudFormation(properties.name), RecipeName: cdk.stringToCloudFormation(properties.recipeName), RoleArn: cdk.stringToCloudFormation(properties.roleArn), Sample: cfnProjectSamplePropertyToCloudFormation(properties.sample), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnProjectPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("datasetName", "DatasetName", cfn_parse.FromCloudFormation.getString(properties.DatasetName)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("recipeName", "RecipeName", cfn_parse.FromCloudFormation.getString(properties.RecipeName)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("sample", "Sample", properties.Sample != null ? CfnProjectSamplePropertyFromCloudFormation(properties.Sample) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnProject = class _CfnProject extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnProjectPropsFromCloudFormation(resourceProperties), ret = new _CfnProject(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnProject.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_databrew_CfnProjectProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnProject), error;
        }
        cdk.requireProperty(props, "datasetName", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "recipeName", this), cdk.requireProperty(props, "roleArn", this), this.datasetName = props.datasetName, this.name = props.name, this.recipeName = props.recipeName, this.roleArn = props.roleArn, this.sample = props.sample, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DataBrew::Project", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnProject.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { datasetName: this.datasetName, name: this.name, recipeName: this.recipeName, roleArn: this.roleArn, sample: this.sample, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnProjectPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnProject[_c] = { fqn: "aws-cdk-lib.aws_databrew.CfnProject", version: "2.80.0" }, CfnProject.CFN_RESOURCE_TYPE_NAME = "AWS::DataBrew::Project", exports2.CfnProject = CfnProject;
    function CfnProject_SamplePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("size", cdk.validateNumber)(properties.size)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "SampleProperty"');
    }
    function cfnProjectSamplePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProject_SamplePropertyValidator(properties).assertSuccess(), { Size: cdk.numberToCloudFormation(properties.size), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnProjectSamplePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("size", "Size", properties.Size != null ? cfn_parse.FromCloudFormation.getNumber(properties.Size) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRecipePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("steps", cdk.requiredValidator)(properties.steps)), errors.collect(cdk.propertyValidator("steps", cdk.listValidator(CfnRecipe_RecipeStepPropertyValidator))(properties.steps)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnRecipeProps"');
    }
    function cfnRecipePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRecipePropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Steps: cdk.listMapper(cfnRecipeRecipeStepPropertyToCloudFormation)(properties.steps), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnRecipePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("steps", "Steps", cfn_parse.FromCloudFormation.getArray(CfnRecipeRecipeStepPropertyFromCloudFormation)(properties.Steps)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRecipe = class _CfnRecipe extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRecipePropsFromCloudFormation(resourceProperties), ret = new _CfnRecipe(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRecipe.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_databrew_CfnRecipeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRecipe), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "steps", this), this.name = props.name, this.steps = props.steps, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DataBrew::Recipe", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRecipe.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, steps: this.steps, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnRecipePropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnRecipe[_d] = { fqn: "aws-cdk-lib.aws_databrew.CfnRecipe", version: "2.80.0" }, CfnRecipe.CFN_RESOURCE_TYPE_NAME = "AWS::DataBrew::Recipe", exports2.CfnRecipe = CfnRecipe;
    function CfnRecipe_ActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("operation", cdk.requiredValidator)(properties.operation)), errors.collect(cdk.propertyValidator("operation", cdk.validateString)(properties.operation)), errors.collect(cdk.propertyValidator("parameters", cdk.hashValidator(cdk.validateString))(properties.parameters)), errors.wrap('supplied properties not correct for "ActionProperty"');
    }
    function cfnRecipeActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRecipe_ActionPropertyValidator(properties).assertSuccess(), { Operation: cdk.stringToCloudFormation(properties.operation), Parameters: cdk.hashMapper(cdk.stringToCloudFormation)(properties.parameters) }) : properties;
    }
    function CfnRecipeActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("operation", "Operation", cfn_parse.FromCloudFormation.getString(properties.Operation)), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Parameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRecipe_ConditionExpressionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("condition", cdk.requiredValidator)(properties.condition)), errors.collect(cdk.propertyValidator("condition", cdk.validateString)(properties.condition)), errors.collect(cdk.propertyValidator("targetColumn", cdk.requiredValidator)(properties.targetColumn)), errors.collect(cdk.propertyValidator("targetColumn", cdk.validateString)(properties.targetColumn)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "ConditionExpressionProperty"');
    }
    function cfnRecipeConditionExpressionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRecipe_ConditionExpressionPropertyValidator(properties).assertSuccess(), { Condition: cdk.stringToCloudFormation(properties.condition), TargetColumn: cdk.stringToCloudFormation(properties.targetColumn), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnRecipeConditionExpressionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("condition", "Condition", cfn_parse.FromCloudFormation.getString(properties.Condition)), ret.addPropertyResult("targetColumn", "TargetColumn", cfn_parse.FromCloudFormation.getString(properties.TargetColumn)), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRecipe_RecipeStepPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.requiredValidator)(properties.action)), errors.collect(cdk.propertyValidator("action", CfnRecipe_ActionPropertyValidator)(properties.action)), errors.collect(cdk.propertyValidator("conditionExpressions", cdk.listValidator(CfnRecipe_ConditionExpressionPropertyValidator))(properties.conditionExpressions)), errors.wrap('supplied properties not correct for "RecipeStepProperty"');
    }
    function cfnRecipeRecipeStepPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRecipe_RecipeStepPropertyValidator(properties).assertSuccess(), { Action: cfnRecipeActionPropertyToCloudFormation(properties.action), ConditionExpressions: cdk.listMapper(cfnRecipeConditionExpressionPropertyToCloudFormation)(properties.conditionExpressions) }) : properties;
    }
    function CfnRecipeRecipeStepPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", CfnRecipeActionPropertyFromCloudFormation(properties.Action)), ret.addPropertyResult("conditionExpressions", "ConditionExpressions", properties.ConditionExpressions != null ? cfn_parse.FromCloudFormation.getArray(CfnRecipeConditionExpressionPropertyFromCloudFormation)(properties.ConditionExpressions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRulesetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("rules", cdk.requiredValidator)(properties.rules)), errors.collect(cdk.propertyValidator("rules", cdk.listValidator(CfnRuleset_RulePropertyValidator))(properties.rules)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("targetArn", cdk.requiredValidator)(properties.targetArn)), errors.collect(cdk.propertyValidator("targetArn", cdk.validateString)(properties.targetArn)), errors.wrap('supplied properties not correct for "CfnRulesetProps"');
    }
    function cfnRulesetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRulesetPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Rules: cdk.listMapper(cfnRulesetRulePropertyToCloudFormation)(properties.rules), TargetArn: cdk.stringToCloudFormation(properties.targetArn), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnRulesetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("rules", "Rules", cfn_parse.FromCloudFormation.getArray(CfnRulesetRulePropertyFromCloudFormation)(properties.Rules)), ret.addPropertyResult("targetArn", "TargetArn", cfn_parse.FromCloudFormation.getString(properties.TargetArn)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRuleset = class _CfnRuleset extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRulesetPropsFromCloudFormation(resourceProperties), ret = new _CfnRuleset(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRuleset.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_databrew_CfnRulesetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRuleset), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "rules", this), cdk.requireProperty(props, "targetArn", this), this.name = props.name, this.rules = props.rules, this.targetArn = props.targetArn, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DataBrew::Ruleset", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRuleset.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, rules: this.rules, targetArn: this.targetArn, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnRulesetPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnRuleset[_e] = { fqn: "aws-cdk-lib.aws_databrew.CfnRuleset", version: "2.80.0" }, CfnRuleset.CFN_RESOURCE_TYPE_NAME = "AWS::DataBrew::Ruleset", exports2.CfnRuleset = CfnRuleset;
    function CfnRuleset_ColumnSelectorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("regex", cdk.validateString)(properties.regex)), errors.wrap('supplied properties not correct for "ColumnSelectorProperty"');
    }
    function cfnRulesetColumnSelectorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleset_ColumnSelectorPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Regex: cdk.stringToCloudFormation(properties.regex) }) : properties;
    }
    function CfnRulesetColumnSelectorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("regex", "Regex", properties.Regex != null ? cfn_parse.FromCloudFormation.getString(properties.Regex) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleset_RulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("checkExpression", cdk.requiredValidator)(properties.checkExpression)), errors.collect(cdk.propertyValidator("checkExpression", cdk.validateString)(properties.checkExpression)), errors.collect(cdk.propertyValidator("columnSelectors", cdk.listValidator(CfnRuleset_ColumnSelectorPropertyValidator))(properties.columnSelectors)), errors.collect(cdk.propertyValidator("disabled", cdk.validateBoolean)(properties.disabled)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("substitutionMap", cdk.listValidator(CfnRuleset_SubstitutionValuePropertyValidator))(properties.substitutionMap)), errors.collect(cdk.propertyValidator("threshold", CfnRuleset_ThresholdPropertyValidator)(properties.threshold)), errors.wrap('supplied properties not correct for "RuleProperty"');
    }
    function cfnRulesetRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleset_RulePropertyValidator(properties).assertSuccess(), { CheckExpression: cdk.stringToCloudFormation(properties.checkExpression), ColumnSelectors: cdk.listMapper(cfnRulesetColumnSelectorPropertyToCloudFormation)(properties.columnSelectors), Disabled: cdk.booleanToCloudFormation(properties.disabled), Name: cdk.stringToCloudFormation(properties.name), SubstitutionMap: cdk.listMapper(cfnRulesetSubstitutionValuePropertyToCloudFormation)(properties.substitutionMap), Threshold: cfnRulesetThresholdPropertyToCloudFormation(properties.threshold) }) : properties;
    }
    function CfnRulesetRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("checkExpression", "CheckExpression", cfn_parse.FromCloudFormation.getString(properties.CheckExpression)), ret.addPropertyResult("columnSelectors", "ColumnSelectors", properties.ColumnSelectors != null ? cfn_parse.FromCloudFormation.getArray(CfnRulesetColumnSelectorPropertyFromCloudFormation)(properties.ColumnSelectors) : void 0), ret.addPropertyResult("disabled", "Disabled", properties.Disabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Disabled) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("substitutionMap", "SubstitutionMap", properties.SubstitutionMap != null ? cfn_parse.FromCloudFormation.getArray(CfnRulesetSubstitutionValuePropertyFromCloudFormation)(properties.SubstitutionMap) : void 0), ret.addPropertyResult("threshold", "Threshold", properties.Threshold != null ? CfnRulesetThresholdPropertyFromCloudFormation(properties.Threshold) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleset_SubstitutionValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.collect(cdk.propertyValidator("valueReference", cdk.requiredValidator)(properties.valueReference)), errors.collect(cdk.propertyValidator("valueReference", cdk.validateString)(properties.valueReference)), errors.wrap('supplied properties not correct for "SubstitutionValueProperty"');
    }
    function cfnRulesetSubstitutionValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleset_SubstitutionValuePropertyValidator(properties).assertSuccess(), { Value: cdk.stringToCloudFormation(properties.value), ValueReference: cdk.stringToCloudFormation(properties.valueReference) }) : properties;
    }
    function CfnRulesetSubstitutionValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addPropertyResult("valueReference", "ValueReference", cfn_parse.FromCloudFormation.getString(properties.ValueReference)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleset_ThresholdPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("unit", cdk.validateString)(properties.unit)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "ThresholdProperty"');
    }
    function cfnRulesetThresholdPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleset_ThresholdPropertyValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type), Unit: cdk.stringToCloudFormation(properties.unit), Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnRulesetThresholdPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addPropertyResult("unit", "Unit", properties.Unit != null ? cfn_parse.FromCloudFormation.getString(properties.Unit) : void 0), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getNumber(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSchedulePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cronExpression", cdk.requiredValidator)(properties.cronExpression)), errors.collect(cdk.propertyValidator("cronExpression", cdk.validateString)(properties.cronExpression)), errors.collect(cdk.propertyValidator("jobNames", cdk.listValidator(cdk.validateString))(properties.jobNames)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnScheduleProps"');
    }
    function cfnSchedulePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSchedulePropsValidator(properties).assertSuccess(), { CronExpression: cdk.stringToCloudFormation(properties.cronExpression), Name: cdk.stringToCloudFormation(properties.name), JobNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.jobNames), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnSchedulePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cronExpression", "CronExpression", cfn_parse.FromCloudFormation.getString(properties.CronExpression)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("jobNames", "JobNames", properties.JobNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.JobNames) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSchedule = class _CfnSchedule extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSchedulePropsFromCloudFormation(resourceProperties), ret = new _CfnSchedule(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSchedule.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_databrew_CfnScheduleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSchedule), error;
        }
        cdk.requireProperty(props, "cronExpression", this), cdk.requireProperty(props, "name", this), this.cronExpression = props.cronExpression, this.name = props.name, this.jobNames = props.jobNames, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DataBrew::Schedule", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSchedule.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { cronExpression: this.cronExpression, name: this.name, jobNames: this.jobNames, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnSchedulePropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnSchedule[_f] = { fqn: "aws-cdk-lib.aws_databrew.CfnSchedule", version: "2.80.0" }, CfnSchedule.CFN_RESOURCE_TYPE_NAME = "AWS::DataBrew::Schedule", exports2.CfnSchedule = CfnSchedule;
  }
});

// node_modules/aws-cdk-lib/aws-databrew/lib/index.js
var require_lib96 = __commonJS({
  "node_modules/aws-cdk-lib/aws-databrew/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_databrew_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-databrew/index.js
var require_aws_databrew = __commonJS({
  "node_modules/aws-cdk-lib/aws-databrew/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib96(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-datapipeline/lib/datapipeline.generated.js
var require_datapipeline_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-datapipeline/lib/datapipeline.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnPipeline = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnPipelinePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("activate", cdk.validateBoolean)(properties.activate)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("parameterObjects", cdk.listValidator(CfnPipeline_ParameterObjectPropertyValidator))(properties.parameterObjects)), errors.collect(cdk.propertyValidator("parameterValues", cdk.listValidator(CfnPipeline_ParameterValuePropertyValidator))(properties.parameterValues)), errors.collect(cdk.propertyValidator("pipelineObjects", cdk.listValidator(CfnPipeline_PipelineObjectPropertyValidator))(properties.pipelineObjects)), errors.collect(cdk.propertyValidator("pipelineTags", cdk.listValidator(CfnPipeline_PipelineTagPropertyValidator))(properties.pipelineTags)), errors.wrap('supplied properties not correct for "CfnPipelineProps"');
    }
    function cfnPipelinePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipelinePropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Activate: cdk.booleanToCloudFormation(properties.activate), Description: cdk.stringToCloudFormation(properties.description), ParameterObjects: cdk.listMapper(cfnPipelineParameterObjectPropertyToCloudFormation)(properties.parameterObjects), ParameterValues: cdk.listMapper(cfnPipelineParameterValuePropertyToCloudFormation)(properties.parameterValues), PipelineObjects: cdk.listMapper(cfnPipelinePipelineObjectPropertyToCloudFormation)(properties.pipelineObjects), PipelineTags: cdk.listMapper(cfnPipelinePipelineTagPropertyToCloudFormation)(properties.pipelineTags) }) : properties;
    }
    function CfnPipelinePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("activate", "Activate", properties.Activate != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Activate) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("parameterObjects", "ParameterObjects", properties.ParameterObjects != null ? cfn_parse.FromCloudFormation.getArray(CfnPipelineParameterObjectPropertyFromCloudFormation)(properties.ParameterObjects) : void 0), ret.addPropertyResult("parameterValues", "ParameterValues", properties.ParameterValues != null ? cfn_parse.FromCloudFormation.getArray(CfnPipelineParameterValuePropertyFromCloudFormation)(properties.ParameterValues) : void 0), ret.addPropertyResult("pipelineObjects", "PipelineObjects", properties.PipelineObjects != null ? cfn_parse.FromCloudFormation.getArray(CfnPipelinePipelineObjectPropertyFromCloudFormation)(properties.PipelineObjects) : void 0), ret.addPropertyResult("pipelineTags", "PipelineTags", properties.PipelineTags != null ? cfn_parse.FromCloudFormation.getArray(CfnPipelinePipelineTagPropertyFromCloudFormation)(properties.PipelineTags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPipeline = class _CfnPipeline extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPipelinePropsFromCloudFormation(resourceProperties), ret = new _CfnPipeline(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPipeline.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_datapipeline_CfnPipelineProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPipeline), error;
        }
        cdk.requireProperty(props, "name", this), this.attrPipelineId = cdk.Token.asString(this.getAtt("PipelineId", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.activate = props.activate, this.description = props.description, this.parameterObjects = props.parameterObjects, this.parameterValues = props.parameterValues, this.pipelineObjects = props.pipelineObjects, this.pipelineTags = props.pipelineTags;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPipeline.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, activate: this.activate, description: this.description, parameterObjects: this.parameterObjects, parameterValues: this.parameterValues, pipelineObjects: this.pipelineObjects, pipelineTags: this.pipelineTags };
      }
      renderProperties(props) {
        return cfnPipelinePropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnPipeline[_a] = { fqn: "aws-cdk-lib.aws_datapipeline.CfnPipeline", version: "2.80.0" }, CfnPipeline.CFN_RESOURCE_TYPE_NAME = "AWS::DataPipeline::Pipeline", exports2.CfnPipeline = CfnPipeline;
    function CfnPipeline_FieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("refValue", cdk.validateString)(properties.refValue)), errors.collect(cdk.propertyValidator("stringValue", cdk.validateString)(properties.stringValue)), errors.wrap('supplied properties not correct for "FieldProperty"');
    }
    function cfnPipelineFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipeline_FieldPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), RefValue: cdk.stringToCloudFormation(properties.refValue), StringValue: cdk.stringToCloudFormation(properties.stringValue) }) : properties;
    }
    function CfnPipelineFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("refValue", "RefValue", properties.RefValue != null ? cfn_parse.FromCloudFormation.getString(properties.RefValue) : void 0), ret.addPropertyResult("stringValue", "StringValue", properties.StringValue != null ? cfn_parse.FromCloudFormation.getString(properties.StringValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipeline_ParameterAttributePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("stringValue", cdk.requiredValidator)(properties.stringValue)), errors.collect(cdk.propertyValidator("stringValue", cdk.validateString)(properties.stringValue)), errors.wrap('supplied properties not correct for "ParameterAttributeProperty"');
    }
    function cfnPipelineParameterAttributePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipeline_ParameterAttributePropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), StringValue: cdk.stringToCloudFormation(properties.stringValue) }) : properties;
    }
    function CfnPipelineParameterAttributePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("stringValue", "StringValue", cfn_parse.FromCloudFormation.getString(properties.StringValue)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipeline_ParameterObjectPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributes", cdk.requiredValidator)(properties.attributes)), errors.collect(cdk.propertyValidator("attributes", cdk.listValidator(CfnPipeline_ParameterAttributePropertyValidator))(properties.attributes)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.wrap('supplied properties not correct for "ParameterObjectProperty"');
    }
    function cfnPipelineParameterObjectPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipeline_ParameterObjectPropertyValidator(properties).assertSuccess(), { Attributes: cdk.listMapper(cfnPipelineParameterAttributePropertyToCloudFormation)(properties.attributes), Id: cdk.stringToCloudFormation(properties.id) }) : properties;
    }
    function CfnPipelineParameterObjectPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attributes", "Attributes", cfn_parse.FromCloudFormation.getArray(CfnPipelineParameterAttributePropertyFromCloudFormation)(properties.Attributes)), ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipeline_ParameterValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("stringValue", cdk.requiredValidator)(properties.stringValue)), errors.collect(cdk.propertyValidator("stringValue", cdk.validateString)(properties.stringValue)), errors.wrap('supplied properties not correct for "ParameterValueProperty"');
    }
    function cfnPipelineParameterValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipeline_ParameterValuePropertyValidator(properties).assertSuccess(), { Id: cdk.stringToCloudFormation(properties.id), StringValue: cdk.stringToCloudFormation(properties.stringValue) }) : properties;
    }
    function CfnPipelineParameterValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("stringValue", "StringValue", cfn_parse.FromCloudFormation.getString(properties.StringValue)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipeline_PipelineObjectPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fields", cdk.requiredValidator)(properties.fields)), errors.collect(cdk.propertyValidator("fields", cdk.listValidator(CfnPipeline_FieldPropertyValidator))(properties.fields)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "PipelineObjectProperty"');
    }
    function cfnPipelinePipelineObjectPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipeline_PipelineObjectPropertyValidator(properties).assertSuccess(), { Fields: cdk.listMapper(cfnPipelineFieldPropertyToCloudFormation)(properties.fields), Id: cdk.stringToCloudFormation(properties.id), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnPipelinePipelineObjectPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fields", "Fields", cfn_parse.FromCloudFormation.getArray(CfnPipelineFieldPropertyFromCloudFormation)(properties.Fields)), ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipeline_PipelineTagPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "PipelineTagProperty"');
    }
    function cfnPipelinePipelineTagPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipeline_PipelineTagPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnPipelinePipelineTagPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-datapipeline/lib/index.js
var require_lib97 = __commonJS({
  "node_modules/aws-cdk-lib/aws-datapipeline/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_datapipeline_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-datapipeline/index.js
var require_aws_datapipeline = __commonJS({
  "node_modules/aws-cdk-lib/aws-datapipeline/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib97(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-datasync/lib/datasync.generated.js
var require_datasync_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-datasync/lib/datasync.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    var _l;
    var _m;
    var _o;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnTask = exports2.CfnStorageSystem = exports2.CfnLocationSMB = exports2.CfnLocationS3 = exports2.CfnLocationObjectStorage = exports2.CfnLocationNFS = exports2.CfnLocationHDFS = exports2.CfnLocationFSxWindows = exports2.CfnLocationFSxOpenZFS = exports2.CfnLocationFSxONTAP = exports2.CfnLocationFSxLustre = exports2.CfnLocationEFS = exports2.CfnAgent = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAgentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("activationKey", cdk.validateString)(properties.activationKey)), errors.collect(cdk.propertyValidator("agentName", cdk.validateString)(properties.agentName)), errors.collect(cdk.propertyValidator("securityGroupArns", cdk.listValidator(cdk.validateString))(properties.securityGroupArns)), errors.collect(cdk.propertyValidator("subnetArns", cdk.listValidator(cdk.validateString))(properties.subnetArns)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpcEndpointId", cdk.validateString)(properties.vpcEndpointId)), errors.wrap('supplied properties not correct for "CfnAgentProps"');
    }
    function cfnAgentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAgentPropsValidator(properties).assertSuccess(), { ActivationKey: cdk.stringToCloudFormation(properties.activationKey), AgentName: cdk.stringToCloudFormation(properties.agentName), SecurityGroupArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupArns), SubnetArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetArns), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VpcEndpointId: cdk.stringToCloudFormation(properties.vpcEndpointId) }) : properties;
    }
    function CfnAgentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("activationKey", "ActivationKey", properties.ActivationKey != null ? cfn_parse.FromCloudFormation.getString(properties.ActivationKey) : void 0), ret.addPropertyResult("agentName", "AgentName", properties.AgentName != null ? cfn_parse.FromCloudFormation.getString(properties.AgentName) : void 0), ret.addPropertyResult("securityGroupArns", "SecurityGroupArns", properties.SecurityGroupArns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupArns) : void 0), ret.addPropertyResult("subnetArns", "SubnetArns", properties.SubnetArns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SubnetArns) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("vpcEndpointId", "VpcEndpointId", properties.VpcEndpointId != null ? cfn_parse.FromCloudFormation.getString(properties.VpcEndpointId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAgent = class _CfnAgent extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAgentPropsFromCloudFormation(resourceProperties), ret = new _CfnAgent(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnAgent.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_datasync_CfnAgentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAgent), error;
        }
        this.attrAgentArn = cdk.Token.asString(this.getAtt("AgentArn", cdk.ResolutionTypeHint.STRING)), this.attrEndpointType = cdk.Token.asString(this.getAtt("EndpointType", cdk.ResolutionTypeHint.STRING)), this.activationKey = props.activationKey, this.agentName = props.agentName, this.securityGroupArns = props.securityGroupArns, this.subnetArns = props.subnetArns, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DataSync::Agent", props.tags, { tagPropertyName: "tags" }), this.vpcEndpointId = props.vpcEndpointId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAgent.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { activationKey: this.activationKey, agentName: this.agentName, securityGroupArns: this.securityGroupArns, subnetArns: this.subnetArns, tags: this.tags.renderTags(), vpcEndpointId: this.vpcEndpointId };
      }
      renderProperties(props) {
        return cfnAgentPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAgent[_a] = { fqn: "aws-cdk-lib.aws_datasync.CfnAgent", version: "2.80.0" }, CfnAgent.CFN_RESOURCE_TYPE_NAME = "AWS::DataSync::Agent", exports2.CfnAgent = CfnAgent;
    function CfnLocationEFSPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessPointArn", cdk.validateString)(properties.accessPointArn)), errors.collect(cdk.propertyValidator("ec2Config", cdk.requiredValidator)(properties.ec2Config)), errors.collect(cdk.propertyValidator("ec2Config", CfnLocationEFS_Ec2ConfigPropertyValidator)(properties.ec2Config)), errors.collect(cdk.propertyValidator("efsFilesystemArn", cdk.validateString)(properties.efsFilesystemArn)), errors.collect(cdk.propertyValidator("fileSystemAccessRoleArn", cdk.validateString)(properties.fileSystemAccessRoleArn)), errors.collect(cdk.propertyValidator("inTransitEncryption", cdk.validateString)(properties.inTransitEncryption)), errors.collect(cdk.propertyValidator("subdirectory", cdk.validateString)(properties.subdirectory)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnLocationEFSProps"');
    }
    function cfnLocationEFSPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLocationEFSPropsValidator(properties).assertSuccess(), { Ec2Config: cfnLocationEFSEc2ConfigPropertyToCloudFormation(properties.ec2Config), AccessPointArn: cdk.stringToCloudFormation(properties.accessPointArn), EfsFilesystemArn: cdk.stringToCloudFormation(properties.efsFilesystemArn), FileSystemAccessRoleArn: cdk.stringToCloudFormation(properties.fileSystemAccessRoleArn), InTransitEncryption: cdk.stringToCloudFormation(properties.inTransitEncryption), Subdirectory: cdk.stringToCloudFormation(properties.subdirectory), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnLocationEFSPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ec2Config", "Ec2Config", CfnLocationEFSEc2ConfigPropertyFromCloudFormation(properties.Ec2Config)), ret.addPropertyResult("accessPointArn", "AccessPointArn", properties.AccessPointArn != null ? cfn_parse.FromCloudFormation.getString(properties.AccessPointArn) : void 0), ret.addPropertyResult("efsFilesystemArn", "EfsFilesystemArn", properties.EfsFilesystemArn != null ? cfn_parse.FromCloudFormation.getString(properties.EfsFilesystemArn) : void 0), ret.addPropertyResult("fileSystemAccessRoleArn", "FileSystemAccessRoleArn", properties.FileSystemAccessRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.FileSystemAccessRoleArn) : void 0), ret.addPropertyResult("inTransitEncryption", "InTransitEncryption", properties.InTransitEncryption != null ? cfn_parse.FromCloudFormation.getString(properties.InTransitEncryption) : void 0), ret.addPropertyResult("subdirectory", "Subdirectory", properties.Subdirectory != null ? cfn_parse.FromCloudFormation.getString(properties.Subdirectory) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLocationEFS = class _CfnLocationEFS extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLocationEFSPropsFromCloudFormation(resourceProperties), ret = new _CfnLocationEFS(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLocationEFS.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_datasync_CfnLocationEFSProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLocationEFS), error;
        }
        cdk.requireProperty(props, "ec2Config", this), this.attrLocationArn = cdk.Token.asString(this.getAtt("LocationArn", cdk.ResolutionTypeHint.STRING)), this.attrLocationUri = cdk.Token.asString(this.getAtt("LocationUri", cdk.ResolutionTypeHint.STRING)), this.ec2Config = props.ec2Config, this.accessPointArn = props.accessPointArn, this.efsFilesystemArn = props.efsFilesystemArn, this.fileSystemAccessRoleArn = props.fileSystemAccessRoleArn, this.inTransitEncryption = props.inTransitEncryption, this.subdirectory = props.subdirectory, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DataSync::LocationEFS", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLocationEFS.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { ec2Config: this.ec2Config, accessPointArn: this.accessPointArn, efsFilesystemArn: this.efsFilesystemArn, fileSystemAccessRoleArn: this.fileSystemAccessRoleArn, inTransitEncryption: this.inTransitEncryption, subdirectory: this.subdirectory, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnLocationEFSPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnLocationEFS[_b] = { fqn: "aws-cdk-lib.aws_datasync.CfnLocationEFS", version: "2.80.0" }, CfnLocationEFS.CFN_RESOURCE_TYPE_NAME = "AWS::DataSync::LocationEFS", exports2.CfnLocationEFS = CfnLocationEFS;
    function CfnLocationEFS_Ec2ConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroupArns", cdk.requiredValidator)(properties.securityGroupArns)), errors.collect(cdk.propertyValidator("securityGroupArns", cdk.listValidator(cdk.validateString))(properties.securityGroupArns)), errors.collect(cdk.propertyValidator("subnetArn", cdk.requiredValidator)(properties.subnetArn)), errors.collect(cdk.propertyValidator("subnetArn", cdk.validateString)(properties.subnetArn)), errors.wrap('supplied properties not correct for "Ec2ConfigProperty"');
    }
    function cfnLocationEFSEc2ConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLocationEFS_Ec2ConfigPropertyValidator(properties).assertSuccess(), { SecurityGroupArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupArns), SubnetArn: cdk.stringToCloudFormation(properties.subnetArn) }) : properties;
    }
    function CfnLocationEFSEc2ConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroupArns", "SecurityGroupArns", cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupArns)), ret.addPropertyResult("subnetArn", "SubnetArn", cfn_parse.FromCloudFormation.getString(properties.SubnetArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLocationFSxLustrePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fsxFilesystemArn", cdk.validateString)(properties.fsxFilesystemArn)), errors.collect(cdk.propertyValidator("securityGroupArns", cdk.requiredValidator)(properties.securityGroupArns)), errors.collect(cdk.propertyValidator("securityGroupArns", cdk.listValidator(cdk.validateString))(properties.securityGroupArns)), errors.collect(cdk.propertyValidator("subdirectory", cdk.validateString)(properties.subdirectory)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnLocationFSxLustreProps"');
    }
    function cfnLocationFSxLustrePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLocationFSxLustrePropsValidator(properties).assertSuccess(), { SecurityGroupArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupArns), FsxFilesystemArn: cdk.stringToCloudFormation(properties.fsxFilesystemArn), Subdirectory: cdk.stringToCloudFormation(properties.subdirectory), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnLocationFSxLustrePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroupArns", "SecurityGroupArns", cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupArns)), ret.addPropertyResult("fsxFilesystemArn", "FsxFilesystemArn", properties.FsxFilesystemArn != null ? cfn_parse.FromCloudFormation.getString(properties.FsxFilesystemArn) : void 0), ret.addPropertyResult("subdirectory", "Subdirectory", properties.Subdirectory != null ? cfn_parse.FromCloudFormation.getString(properties.Subdirectory) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLocationFSxLustre = class _CfnLocationFSxLustre extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLocationFSxLustrePropsFromCloudFormation(resourceProperties), ret = new _CfnLocationFSxLustre(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLocationFSxLustre.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_datasync_CfnLocationFSxLustreProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLocationFSxLustre), error;
        }
        cdk.requireProperty(props, "securityGroupArns", this), this.attrLocationArn = cdk.Token.asString(this.getAtt("LocationArn", cdk.ResolutionTypeHint.STRING)), this.attrLocationUri = cdk.Token.asString(this.getAtt("LocationUri", cdk.ResolutionTypeHint.STRING)), this.securityGroupArns = props.securityGroupArns, this.fsxFilesystemArn = props.fsxFilesystemArn, this.subdirectory = props.subdirectory, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DataSync::LocationFSxLustre", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLocationFSxLustre.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { securityGroupArns: this.securityGroupArns, fsxFilesystemArn: this.fsxFilesystemArn, subdirectory: this.subdirectory, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnLocationFSxLustrePropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnLocationFSxLustre[_c] = { fqn: "aws-cdk-lib.aws_datasync.CfnLocationFSxLustre", version: "2.80.0" }, CfnLocationFSxLustre.CFN_RESOURCE_TYPE_NAME = "AWS::DataSync::LocationFSxLustre", exports2.CfnLocationFSxLustre = CfnLocationFSxLustre;
    function CfnLocationFSxONTAPPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("protocol", CfnLocationFSxONTAP_ProtocolPropertyValidator)(properties.protocol)), errors.collect(cdk.propertyValidator("securityGroupArns", cdk.requiredValidator)(properties.securityGroupArns)), errors.collect(cdk.propertyValidator("securityGroupArns", cdk.listValidator(cdk.validateString))(properties.securityGroupArns)), errors.collect(cdk.propertyValidator("storageVirtualMachineArn", cdk.requiredValidator)(properties.storageVirtualMachineArn)), errors.collect(cdk.propertyValidator("storageVirtualMachineArn", cdk.validateString)(properties.storageVirtualMachineArn)), errors.collect(cdk.propertyValidator("subdirectory", cdk.validateString)(properties.subdirectory)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnLocationFSxONTAPProps"');
    }
    function cfnLocationFSxONTAPPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLocationFSxONTAPPropsValidator(properties).assertSuccess(), { SecurityGroupArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupArns), StorageVirtualMachineArn: cdk.stringToCloudFormation(properties.storageVirtualMachineArn), Protocol: cfnLocationFSxONTAPProtocolPropertyToCloudFormation(properties.protocol), Subdirectory: cdk.stringToCloudFormation(properties.subdirectory), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnLocationFSxONTAPPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroupArns", "SecurityGroupArns", cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupArns)), ret.addPropertyResult("storageVirtualMachineArn", "StorageVirtualMachineArn", cfn_parse.FromCloudFormation.getString(properties.StorageVirtualMachineArn)), ret.addPropertyResult("protocol", "Protocol", properties.Protocol != null ? CfnLocationFSxONTAPProtocolPropertyFromCloudFormation(properties.Protocol) : void 0), ret.addPropertyResult("subdirectory", "Subdirectory", properties.Subdirectory != null ? cfn_parse.FromCloudFormation.getString(properties.Subdirectory) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLocationFSxONTAP = class _CfnLocationFSxONTAP extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLocationFSxONTAPPropsFromCloudFormation(resourceProperties), ret = new _CfnLocationFSxONTAP(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLocationFSxONTAP.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_datasync_CfnLocationFSxONTAPProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLocationFSxONTAP), error;
        }
        cdk.requireProperty(props, "securityGroupArns", this), cdk.requireProperty(props, "storageVirtualMachineArn", this), this.attrFsxFilesystemArn = cdk.Token.asString(this.getAtt("FsxFilesystemArn", cdk.ResolutionTypeHint.STRING)), this.attrLocationArn = cdk.Token.asString(this.getAtt("LocationArn", cdk.ResolutionTypeHint.STRING)), this.attrLocationUri = cdk.Token.asString(this.getAtt("LocationUri", cdk.ResolutionTypeHint.STRING)), this.securityGroupArns = props.securityGroupArns, this.storageVirtualMachineArn = props.storageVirtualMachineArn, this.protocol = props.protocol, this.subdirectory = props.subdirectory, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DataSync::LocationFSxONTAP", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLocationFSxONTAP.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { securityGroupArns: this.securityGroupArns, storageVirtualMachineArn: this.storageVirtualMachineArn, protocol: this.protocol, subdirectory: this.subdirectory, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnLocationFSxONTAPPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnLocationFSxONTAP[_d] = { fqn: "aws-cdk-lib.aws_datasync.CfnLocationFSxONTAP", version: "2.80.0" }, CfnLocationFSxONTAP.CFN_RESOURCE_TYPE_NAME = "AWS::DataSync::LocationFSxONTAP", exports2.CfnLocationFSxONTAP = CfnLocationFSxONTAP;
    function CfnLocationFSxONTAP_NFSPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mountOptions", cdk.requiredValidator)(properties.mountOptions)), errors.collect(cdk.propertyValidator("mountOptions", CfnLocationFSxONTAP_NfsMountOptionsPropertyValidator)(properties.mountOptions)), errors.wrap('supplied properties not correct for "NFSProperty"');
    }
    function cfnLocationFSxONTAPNFSPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLocationFSxONTAP_NFSPropertyValidator(properties).assertSuccess(), { MountOptions: cfnLocationFSxONTAPNfsMountOptionsPropertyToCloudFormation(properties.mountOptions) }) : properties;
    }
    function CfnLocationFSxONTAPNFSPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mountOptions", "MountOptions", CfnLocationFSxONTAPNfsMountOptionsPropertyFromCloudFormation(properties.MountOptions)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLocationFSxONTAP_NfsMountOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "NfsMountOptionsProperty"');
    }
    function cfnLocationFSxONTAPNfsMountOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLocationFSxONTAP_NfsMountOptionsPropertyValidator(properties).assertSuccess(), { Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnLocationFSxONTAPNfsMountOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getString(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLocationFSxONTAP_ProtocolPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("nfs", CfnLocationFSxONTAP_NFSPropertyValidator)(properties.nfs)), errors.collect(cdk.propertyValidator("smb", CfnLocationFSxONTAP_SMBPropertyValidator)(properties.smb)), errors.wrap('supplied properties not correct for "ProtocolProperty"');
    }
    function cfnLocationFSxONTAPProtocolPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLocationFSxONTAP_ProtocolPropertyValidator(properties).assertSuccess(), { NFS: cfnLocationFSxONTAPNFSPropertyToCloudFormation(properties.nfs), SMB: cfnLocationFSxONTAPSMBPropertyToCloudFormation(properties.smb) }) : properties;
    }
    function CfnLocationFSxONTAPProtocolPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("nfs", "NFS", properties.NFS != null ? CfnLocationFSxONTAPNFSPropertyFromCloudFormation(properties.NFS) : void 0), ret.addPropertyResult("smb", "SMB", properties.SMB != null ? CfnLocationFSxONTAPSMBPropertyFromCloudFormation(properties.SMB) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLocationFSxONTAP_SMBPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("domain", cdk.validateString)(properties.domain)), errors.collect(cdk.propertyValidator("mountOptions", cdk.requiredValidator)(properties.mountOptions)), errors.collect(cdk.propertyValidator("mountOptions", CfnLocationFSxONTAP_SmbMountOptionsPropertyValidator)(properties.mountOptions)), errors.collect(cdk.propertyValidator("password", cdk.requiredValidator)(properties.password)), errors.collect(cdk.propertyValidator("password", cdk.validateString)(properties.password)), errors.collect(cdk.propertyValidator("user", cdk.requiredValidator)(properties.user)), errors.collect(cdk.propertyValidator("user", cdk.validateString)(properties.user)), errors.wrap('supplied properties not correct for "SMBProperty"');
    }
    function cfnLocationFSxONTAPSMBPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLocationFSxONTAP_SMBPropertyValidator(properties).assertSuccess(), { Domain: cdk.stringToCloudFormation(properties.domain), MountOptions: cfnLocationFSxONTAPSmbMountOptionsPropertyToCloudFormation(properties.mountOptions), Password: cdk.stringToCloudFormation(properties.password), User: cdk.stringToCloudFormation(properties.user) }) : properties;
    }
    function CfnLocationFSxONTAPSMBPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("domain", "Domain", properties.Domain != null ? cfn_parse.FromCloudFormation.getString(properties.Domain) : void 0), ret.addPropertyResult("mountOptions", "MountOptions", CfnLocationFSxONTAPSmbMountOptionsPropertyFromCloudFormation(properties.MountOptions)), ret.addPropertyResult("password", "Password", cfn_parse.FromCloudFormation.getString(properties.Password)), ret.addPropertyResult("user", "User", cfn_parse.FromCloudFormation.getString(properties.User)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLocationFSxONTAP_SmbMountOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "SmbMountOptionsProperty"');
    }
    function cfnLocationFSxONTAPSmbMountOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLocationFSxONTAP_SmbMountOptionsPropertyValidator(properties).assertSuccess(), { Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnLocationFSxONTAPSmbMountOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getString(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLocationFSxOpenZFSPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fsxFilesystemArn", cdk.validateString)(properties.fsxFilesystemArn)), errors.collect(cdk.propertyValidator("protocol", cdk.requiredValidator)(properties.protocol)), errors.collect(cdk.propertyValidator("protocol", CfnLocationFSxOpenZFS_ProtocolPropertyValidator)(properties.protocol)), errors.collect(cdk.propertyValidator("securityGroupArns", cdk.requiredValidator)(properties.securityGroupArns)), errors.collect(cdk.propertyValidator("securityGroupArns", cdk.listValidator(cdk.validateString))(properties.securityGroupArns)), errors.collect(cdk.propertyValidator("subdirectory", cdk.validateString)(properties.subdirectory)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnLocationFSxOpenZFSProps"');
    }
    function cfnLocationFSxOpenZFSPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLocationFSxOpenZFSPropsValidator(properties).assertSuccess(), { Protocol: cfnLocationFSxOpenZFSProtocolPropertyToCloudFormation(properties.protocol), SecurityGroupArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupArns), FsxFilesystemArn: cdk.stringToCloudFormation(properties.fsxFilesystemArn), Subdirectory: cdk.stringToCloudFormation(properties.subdirectory), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnLocationFSxOpenZFSPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("protocol", "Protocol", CfnLocationFSxOpenZFSProtocolPropertyFromCloudFormation(properties.Protocol)), ret.addPropertyResult("securityGroupArns", "SecurityGroupArns", cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupArns)), ret.addPropertyResult("fsxFilesystemArn", "FsxFilesystemArn", properties.FsxFilesystemArn != null ? cfn_parse.FromCloudFormation.getString(properties.FsxFilesystemArn) : void 0), ret.addPropertyResult("subdirectory", "Subdirectory", properties.Subdirectory != null ? cfn_parse.FromCloudFormation.getString(properties.Subdirectory) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLocationFSxOpenZFS = class _CfnLocationFSxOpenZFS extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLocationFSxOpenZFSPropsFromCloudFormation(resourceProperties), ret = new _CfnLocationFSxOpenZFS(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLocationFSxOpenZFS.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_datasync_CfnLocationFSxOpenZFSProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLocationFSxOpenZFS), error;
        }
        cdk.requireProperty(props, "protocol", this), cdk.requireProperty(props, "securityGroupArns", this), this.attrLocationArn = cdk.Token.asString(this.getAtt("LocationArn", cdk.ResolutionTypeHint.STRING)), this.attrLocationUri = cdk.Token.asString(this.getAtt("LocationUri", cdk.ResolutionTypeHint.STRING)), this.protocol = props.protocol, this.securityGroupArns = props.securityGroupArns, this.fsxFilesystemArn = props.fsxFilesystemArn, this.subdirectory = props.subdirectory, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DataSync::LocationFSxOpenZFS", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLocationFSxOpenZFS.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { protocol: this.protocol, securityGroupArns: this.securityGroupArns, fsxFilesystemArn: this.fsxFilesystemArn, subdirectory: this.subdirectory, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnLocationFSxOpenZFSPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnLocationFSxOpenZFS[_e] = { fqn: "aws-cdk-lib.aws_datasync.CfnLocationFSxOpenZFS", version: "2.80.0" }, CfnLocationFSxOpenZFS.CFN_RESOURCE_TYPE_NAME = "AWS::DataSync::LocationFSxOpenZFS", exports2.CfnLocationFSxOpenZFS = CfnLocationFSxOpenZFS;
    function CfnLocationFSxOpenZFS_MountOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "MountOptionsProperty"');
    }
    function cfnLocationFSxOpenZFSMountOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLocationFSxOpenZFS_MountOptionsPropertyValidator(properties).assertSuccess(), { Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnLocationFSxOpenZFSMountOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getString(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLocationFSxOpenZFS_NFSPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mountOptions", cdk.requiredValidator)(properties.mountOptions)), errors.collect(cdk.propertyValidator("mountOptions", CfnLocationFSxOpenZFS_MountOptionsPropertyValidator)(properties.mountOptions)), errors.wrap('supplied properties not correct for "NFSProperty"');
    }
    function cfnLocationFSxOpenZFSNFSPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLocationFSxOpenZFS_NFSPropertyValidator(properties).assertSuccess(), { MountOptions: cfnLocationFSxOpenZFSMountOptionsPropertyToCloudFormation(properties.mountOptions) }) : properties;
    }
    function CfnLocationFSxOpenZFSNFSPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mountOptions", "MountOptions", CfnLocationFSxOpenZFSMountOptionsPropertyFromCloudFormation(properties.MountOptions)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLocationFSxOpenZFS_ProtocolPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("nfs", CfnLocationFSxOpenZFS_NFSPropertyValidator)(properties.nfs)), errors.wrap('supplied properties not correct for "ProtocolProperty"');
    }
    function cfnLocationFSxOpenZFSProtocolPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLocationFSxOpenZFS_ProtocolPropertyValidator(properties).assertSuccess(), { NFS: cfnLocationFSxOpenZFSNFSPropertyToCloudFormation(properties.nfs) }) : properties;
    }
    function CfnLocationFSxOpenZFSProtocolPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("nfs", "NFS", properties.NFS != null ? CfnLocationFSxOpenZFSNFSPropertyFromCloudFormation(properties.NFS) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLocationFSxWindowsPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("domain", cdk.validateString)(properties.domain)), errors.collect(cdk.propertyValidator("fsxFilesystemArn", cdk.validateString)(properties.fsxFilesystemArn)), errors.collect(cdk.propertyValidator("password", cdk.validateString)(properties.password)), errors.collect(cdk.propertyValidator("securityGroupArns", cdk.requiredValidator)(properties.securityGroupArns)), errors.collect(cdk.propertyValidator("securityGroupArns", cdk.listValidator(cdk.validateString))(properties.securityGroupArns)), errors.collect(cdk.propertyValidator("subdirectory", cdk.validateString)(properties.subdirectory)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("user", cdk.requiredValidator)(properties.user)), errors.collect(cdk.propertyValidator("user", cdk.validateString)(properties.user)), errors.wrap('supplied properties not correct for "CfnLocationFSxWindowsProps"');
    }
    function cfnLocationFSxWindowsPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLocationFSxWindowsPropsValidator(properties).assertSuccess(), { SecurityGroupArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupArns), User: cdk.stringToCloudFormation(properties.user), Domain: cdk.stringToCloudFormation(properties.domain), FsxFilesystemArn: cdk.stringToCloudFormation(properties.fsxFilesystemArn), Password: cdk.stringToCloudFormation(properties.password), Subdirectory: cdk.stringToCloudFormation(properties.subdirectory), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnLocationFSxWindowsPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroupArns", "SecurityGroupArns", cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupArns)), ret.addPropertyResult("user", "User", cfn_parse.FromCloudFormation.getString(properties.User)), ret.addPropertyResult("domain", "Domain", properties.Domain != null ? cfn_parse.FromCloudFormation.getString(properties.Domain) : void 0), ret.addPropertyResult("fsxFilesystemArn", "FsxFilesystemArn", properties.FsxFilesystemArn != null ? cfn_parse.FromCloudFormation.getString(properties.FsxFilesystemArn) : void 0), ret.addPropertyResult("password", "Password", properties.Password != null ? cfn_parse.FromCloudFormation.getString(properties.Password) : void 0), ret.addPropertyResult("subdirectory", "Subdirectory", properties.Subdirectory != null ? cfn_parse.FromCloudFormation.getString(properties.Subdirectory) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLocationFSxWindows = class _CfnLocationFSxWindows extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLocationFSxWindowsPropsFromCloudFormation(resourceProperties), ret = new _CfnLocationFSxWindows(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLocationFSxWindows.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_datasync_CfnLocationFSxWindowsProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLocationFSxWindows), error;
        }
        cdk.requireProperty(props, "securityGroupArns", this), cdk.requireProperty(props, "user", this), this.attrLocationArn = cdk.Token.asString(this.getAtt("LocationArn", cdk.ResolutionTypeHint.STRING)), this.attrLocationUri = cdk.Token.asString(this.getAtt("LocationUri", cdk.ResolutionTypeHint.STRING)), this.securityGroupArns = props.securityGroupArns, this.user = props.user, this.domain = props.domain, this.fsxFilesystemArn = props.fsxFilesystemArn, this.password = props.password, this.subdirectory = props.subdirectory, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DataSync::LocationFSxWindows", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLocationFSxWindows.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { securityGroupArns: this.securityGroupArns, user: this.user, domain: this.domain, fsxFilesystemArn: this.fsxFilesystemArn, password: this.password, subdirectory: this.subdirectory, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnLocationFSxWindowsPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnLocationFSxWindows[_f] = { fqn: "aws-cdk-lib.aws_datasync.CfnLocationFSxWindows", version: "2.80.0" }, CfnLocationFSxWindows.CFN_RESOURCE_TYPE_NAME = "AWS::DataSync::LocationFSxWindows", exports2.CfnLocationFSxWindows = CfnLocationFSxWindows;
    function CfnLocationHDFSPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("agentArns", cdk.requiredValidator)(properties.agentArns)), errors.collect(cdk.propertyValidator("agentArns", cdk.listValidator(cdk.validateString))(properties.agentArns)), errors.collect(cdk.propertyValidator("authenticationType", cdk.requiredValidator)(properties.authenticationType)), errors.collect(cdk.propertyValidator("authenticationType", cdk.validateString)(properties.authenticationType)), errors.collect(cdk.propertyValidator("blockSize", cdk.validateNumber)(properties.blockSize)), errors.collect(cdk.propertyValidator("kerberosKeytab", cdk.validateString)(properties.kerberosKeytab)), errors.collect(cdk.propertyValidator("kerberosKrb5Conf", cdk.validateString)(properties.kerberosKrb5Conf)), errors.collect(cdk.propertyValidator("kerberosPrincipal", cdk.validateString)(properties.kerberosPrincipal)), errors.collect(cdk.propertyValidator("kmsKeyProviderUri", cdk.validateString)(properties.kmsKeyProviderUri)), errors.collect(cdk.propertyValidator("nameNodes", cdk.requiredValidator)(properties.nameNodes)), errors.collect(cdk.propertyValidator("nameNodes", cdk.listValidator(CfnLocationHDFS_NameNodePropertyValidator))(properties.nameNodes)), errors.collect(cdk.propertyValidator("qopConfiguration", CfnLocationHDFS_QopConfigurationPropertyValidator)(properties.qopConfiguration)), errors.collect(cdk.propertyValidator("replicationFactor", cdk.validateNumber)(properties.replicationFactor)), errors.collect(cdk.propertyValidator("simpleUser", cdk.validateString)(properties.simpleUser)), errors.collect(cdk.propertyValidator("subdirectory", cdk.validateString)(properties.subdirectory)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnLocationHDFSProps"');
    }
    function cfnLocationHDFSPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLocationHDFSPropsValidator(properties).assertSuccess(), { AgentArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.agentArns), AuthenticationType: cdk.stringToCloudFormation(properties.authenticationType), NameNodes: cdk.listMapper(cfnLocationHDFSNameNodePropertyToCloudFormation)(properties.nameNodes), BlockSize: cdk.numberToCloudFormation(properties.blockSize), KerberosKeytab: cdk.stringToCloudFormation(properties.kerberosKeytab), KerberosKrb5Conf: cdk.stringToCloudFormation(properties.kerberosKrb5Conf), KerberosPrincipal: cdk.stringToCloudFormation(properties.kerberosPrincipal), KmsKeyProviderUri: cdk.stringToCloudFormation(properties.kmsKeyProviderUri), QopConfiguration: cfnLocationHDFSQopConfigurationPropertyToCloudFormation(properties.qopConfiguration), ReplicationFactor: cdk.numberToCloudFormation(properties.replicationFactor), SimpleUser: cdk.stringToCloudFormation(properties.simpleUser), Subdirectory: cdk.stringToCloudFormation(properties.subdirectory), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnLocationHDFSPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("agentArns", "AgentArns", cfn_parse.FromCloudFormation.getStringArray(properties.AgentArns)), ret.addPropertyResult("authenticationType", "AuthenticationType", cfn_parse.FromCloudFormation.getString(properties.AuthenticationType)), ret.addPropertyResult("nameNodes", "NameNodes", cfn_parse.FromCloudFormation.getArray(CfnLocationHDFSNameNodePropertyFromCloudFormation)(properties.NameNodes)), ret.addPropertyResult("blockSize", "BlockSize", properties.BlockSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.BlockSize) : void 0), ret.addPropertyResult("kerberosKeytab", "KerberosKeytab", properties.KerberosKeytab != null ? cfn_parse.FromCloudFormation.getString(properties.KerberosKeytab) : void 0), ret.addPropertyResult("kerberosKrb5Conf", "KerberosKrb5Conf", properties.KerberosKrb5Conf != null ? cfn_parse.FromCloudFormation.getString(properties.KerberosKrb5Conf) : void 0), ret.addPropertyResult("kerberosPrincipal", "KerberosPrincipal", properties.KerberosPrincipal != null ? cfn_parse.FromCloudFormation.getString(properties.KerberosPrincipal) : void 0), ret.addPropertyResult("kmsKeyProviderUri", "KmsKeyProviderUri", properties.KmsKeyProviderUri != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyProviderUri) : void 0), ret.addPropertyResult("qopConfiguration", "QopConfiguration", properties.QopConfiguration != null ? CfnLocationHDFSQopConfigurationPropertyFromCloudFormation(properties.QopConfiguration) : void 0), ret.addPropertyResult("replicationFactor", "ReplicationFactor", properties.ReplicationFactor != null ? cfn_parse.FromCloudFormation.getNumber(properties.ReplicationFactor) : void 0), ret.addPropertyResult("simpleUser", "SimpleUser", properties.SimpleUser != null ? cfn_parse.FromCloudFormation.getString(properties.SimpleUser) : void 0), ret.addPropertyResult("subdirectory", "Subdirectory", properties.Subdirectory != null ? cfn_parse.FromCloudFormation.getString(properties.Subdirectory) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLocationHDFS = class _CfnLocationHDFS extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLocationHDFSPropsFromCloudFormation(resourceProperties), ret = new _CfnLocationHDFS(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLocationHDFS.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_datasync_CfnLocationHDFSProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLocationHDFS), error;
        }
        cdk.requireProperty(props, "agentArns", this), cdk.requireProperty(props, "authenticationType", this), cdk.requireProperty(props, "nameNodes", this), this.attrLocationArn = cdk.Token.asString(this.getAtt("LocationArn", cdk.ResolutionTypeHint.STRING)), this.attrLocationUri = cdk.Token.asString(this.getAtt("LocationUri", cdk.ResolutionTypeHint.STRING)), this.agentArns = props.agentArns, this.authenticationType = props.authenticationType, this.nameNodes = props.nameNodes, this.blockSize = props.blockSize, this.kerberosKeytab = props.kerberosKeytab, this.kerberosKrb5Conf = props.kerberosKrb5Conf, this.kerberosPrincipal = props.kerberosPrincipal, this.kmsKeyProviderUri = props.kmsKeyProviderUri, this.qopConfiguration = props.qopConfiguration, this.replicationFactor = props.replicationFactor, this.simpleUser = props.simpleUser, this.subdirectory = props.subdirectory, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DataSync::LocationHDFS", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLocationHDFS.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { agentArns: this.agentArns, authenticationType: this.authenticationType, nameNodes: this.nameNodes, blockSize: this.blockSize, kerberosKeytab: this.kerberosKeytab, kerberosKrb5Conf: this.kerberosKrb5Conf, kerberosPrincipal: this.kerberosPrincipal, kmsKeyProviderUri: this.kmsKeyProviderUri, qopConfiguration: this.qopConfiguration, replicationFactor: this.replicationFactor, simpleUser: this.simpleUser, subdirectory: this.subdirectory, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnLocationHDFSPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnLocationHDFS[_g] = { fqn: "aws-cdk-lib.aws_datasync.CfnLocationHDFS", version: "2.80.0" }, CfnLocationHDFS.CFN_RESOURCE_TYPE_NAME = "AWS::DataSync::LocationHDFS", exports2.CfnLocationHDFS = CfnLocationHDFS;
    function CfnLocationHDFS_NameNodePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("hostname", cdk.requiredValidator)(properties.hostname)), errors.collect(cdk.propertyValidator("hostname", cdk.validateString)(properties.hostname)), errors.collect(cdk.propertyValidator("port", cdk.requiredValidator)(properties.port)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.wrap('supplied properties not correct for "NameNodeProperty"');
    }
    function cfnLocationHDFSNameNodePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLocationHDFS_NameNodePropertyValidator(properties).assertSuccess(), { Hostname: cdk.stringToCloudFormation(properties.hostname), Port: cdk.numberToCloudFormation(properties.port) }) : properties;
    }
    function CfnLocationHDFSNameNodePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("hostname", "Hostname", cfn_parse.FromCloudFormation.getString(properties.Hostname)), ret.addPropertyResult("port", "Port", cfn_parse.FromCloudFormation.getNumber(properties.Port)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLocationHDFS_QopConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataTransferProtection", cdk.validateString)(properties.dataTransferProtection)), errors.collect(cdk.propertyValidator("rpcProtection", cdk.validateString)(properties.rpcProtection)), errors.wrap('supplied properties not correct for "QopConfigurationProperty"');
    }
    function cfnLocationHDFSQopConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLocationHDFS_QopConfigurationPropertyValidator(properties).assertSuccess(), { DataTransferProtection: cdk.stringToCloudFormation(properties.dataTransferProtection), RpcProtection: cdk.stringToCloudFormation(properties.rpcProtection) }) : properties;
    }
    function CfnLocationHDFSQopConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataTransferProtection", "DataTransferProtection", properties.DataTransferProtection != null ? cfn_parse.FromCloudFormation.getString(properties.DataTransferProtection) : void 0), ret.addPropertyResult("rpcProtection", "RpcProtection", properties.RpcProtection != null ? cfn_parse.FromCloudFormation.getString(properties.RpcProtection) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLocationNFSPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mountOptions", CfnLocationNFS_MountOptionsPropertyValidator)(properties.mountOptions)), errors.collect(cdk.propertyValidator("onPremConfig", cdk.requiredValidator)(properties.onPremConfig)), errors.collect(cdk.propertyValidator("onPremConfig", CfnLocationNFS_OnPremConfigPropertyValidator)(properties.onPremConfig)), errors.collect(cdk.propertyValidator("serverHostname", cdk.validateString)(properties.serverHostname)), errors.collect(cdk.propertyValidator("subdirectory", cdk.validateString)(properties.subdirectory)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnLocationNFSProps"');
    }
    function cfnLocationNFSPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLocationNFSPropsValidator(properties).assertSuccess(), { OnPremConfig: cfnLocationNFSOnPremConfigPropertyToCloudFormation(properties.onPremConfig), MountOptions: cfnLocationNFSMountOptionsPropertyToCloudFormation(properties.mountOptions), ServerHostname: cdk.stringToCloudFormation(properties.serverHostname), Subdirectory: cdk.stringToCloudFormation(properties.subdirectory), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnLocationNFSPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("onPremConfig", "OnPremConfig", CfnLocationNFSOnPremConfigPropertyFromCloudFormation(properties.OnPremConfig)), ret.addPropertyResult("mountOptions", "MountOptions", properties.MountOptions != null ? CfnLocationNFSMountOptionsPropertyFromCloudFormation(properties.MountOptions) : void 0), ret.addPropertyResult("serverHostname", "ServerHostname", properties.ServerHostname != null ? cfn_parse.FromCloudFormation.getString(properties.ServerHostname) : void 0), ret.addPropertyResult("subdirectory", "Subdirectory", properties.Subdirectory != null ? cfn_parse.FromCloudFormation.getString(properties.Subdirectory) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLocationNFS = class _CfnLocationNFS extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLocationNFSPropsFromCloudFormation(resourceProperties), ret = new _CfnLocationNFS(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLocationNFS.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_datasync_CfnLocationNFSProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLocationNFS), error;
        }
        cdk.requireProperty(props, "onPremConfig", this), this.attrLocationArn = cdk.Token.asString(this.getAtt("LocationArn", cdk.ResolutionTypeHint.STRING)), this.attrLocationUri = cdk.Token.asString(this.getAtt("LocationUri", cdk.ResolutionTypeHint.STRING)), this.onPremConfig = props.onPremConfig, this.mountOptions = props.mountOptions, this.serverHostname = props.serverHostname, this.subdirectory = props.subdirectory, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DataSync::LocationNFS", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLocationNFS.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { onPremConfig: this.onPremConfig, mountOptions: this.mountOptions, serverHostname: this.serverHostname, subdirectory: this.subdirectory, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnLocationNFSPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnLocationNFS[_h] = { fqn: "aws-cdk-lib.aws_datasync.CfnLocationNFS", version: "2.80.0" }, CfnLocationNFS.CFN_RESOURCE_TYPE_NAME = "AWS::DataSync::LocationNFS", exports2.CfnLocationNFS = CfnLocationNFS;
    function CfnLocationNFS_MountOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "MountOptionsProperty"');
    }
    function cfnLocationNFSMountOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLocationNFS_MountOptionsPropertyValidator(properties).assertSuccess(), { Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnLocationNFSMountOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getString(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLocationNFS_OnPremConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("agentArns", cdk.requiredValidator)(properties.agentArns)), errors.collect(cdk.propertyValidator("agentArns", cdk.listValidator(cdk.validateString))(properties.agentArns)), errors.wrap('supplied properties not correct for "OnPremConfigProperty"');
    }
    function cfnLocationNFSOnPremConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLocationNFS_OnPremConfigPropertyValidator(properties).assertSuccess(), { AgentArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.agentArns) }) : properties;
    }
    function CfnLocationNFSOnPremConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("agentArns", "AgentArns", cfn_parse.FromCloudFormation.getStringArray(properties.AgentArns)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLocationObjectStoragePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessKey", cdk.validateString)(properties.accessKey)), errors.collect(cdk.propertyValidator("agentArns", cdk.requiredValidator)(properties.agentArns)), errors.collect(cdk.propertyValidator("agentArns", cdk.listValidator(cdk.validateString))(properties.agentArns)), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.collect(cdk.propertyValidator("secretKey", cdk.validateString)(properties.secretKey)), errors.collect(cdk.propertyValidator("serverCertificate", cdk.validateString)(properties.serverCertificate)), errors.collect(cdk.propertyValidator("serverHostname", cdk.validateString)(properties.serverHostname)), errors.collect(cdk.propertyValidator("serverPort", cdk.validateNumber)(properties.serverPort)), errors.collect(cdk.propertyValidator("serverProtocol", cdk.validateString)(properties.serverProtocol)), errors.collect(cdk.propertyValidator("subdirectory", cdk.validateString)(properties.subdirectory)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnLocationObjectStorageProps"');
    }
    function cfnLocationObjectStoragePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLocationObjectStoragePropsValidator(properties).assertSuccess(), { AgentArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.agentArns), AccessKey: cdk.stringToCloudFormation(properties.accessKey), BucketName: cdk.stringToCloudFormation(properties.bucketName), SecretKey: cdk.stringToCloudFormation(properties.secretKey), ServerCertificate: cdk.stringToCloudFormation(properties.serverCertificate), ServerHostname: cdk.stringToCloudFormation(properties.serverHostname), ServerPort: cdk.numberToCloudFormation(properties.serverPort), ServerProtocol: cdk.stringToCloudFormation(properties.serverProtocol), Subdirectory: cdk.stringToCloudFormation(properties.subdirectory), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnLocationObjectStoragePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("agentArns", "AgentArns", cfn_parse.FromCloudFormation.getStringArray(properties.AgentArns)), ret.addPropertyResult("accessKey", "AccessKey", properties.AccessKey != null ? cfn_parse.FromCloudFormation.getString(properties.AccessKey) : void 0), ret.addPropertyResult("bucketName", "BucketName", properties.BucketName != null ? cfn_parse.FromCloudFormation.getString(properties.BucketName) : void 0), ret.addPropertyResult("secretKey", "SecretKey", properties.SecretKey != null ? cfn_parse.FromCloudFormation.getString(properties.SecretKey) : void 0), ret.addPropertyResult("serverCertificate", "ServerCertificate", properties.ServerCertificate != null ? cfn_parse.FromCloudFormation.getString(properties.ServerCertificate) : void 0), ret.addPropertyResult("serverHostname", "ServerHostname", properties.ServerHostname != null ? cfn_parse.FromCloudFormation.getString(properties.ServerHostname) : void 0), ret.addPropertyResult("serverPort", "ServerPort", properties.ServerPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.ServerPort) : void 0), ret.addPropertyResult("serverProtocol", "ServerProtocol", properties.ServerProtocol != null ? cfn_parse.FromCloudFormation.getString(properties.ServerProtocol) : void 0), ret.addPropertyResult("subdirectory", "Subdirectory", properties.Subdirectory != null ? cfn_parse.FromCloudFormation.getString(properties.Subdirectory) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLocationObjectStorage = class _CfnLocationObjectStorage extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLocationObjectStoragePropsFromCloudFormation(resourceProperties), ret = new _CfnLocationObjectStorage(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLocationObjectStorage.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_datasync_CfnLocationObjectStorageProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLocationObjectStorage), error;
        }
        cdk.requireProperty(props, "agentArns", this), this.attrLocationArn = cdk.Token.asString(this.getAtt("LocationArn", cdk.ResolutionTypeHint.STRING)), this.attrLocationUri = cdk.Token.asString(this.getAtt("LocationUri", cdk.ResolutionTypeHint.STRING)), this.agentArns = props.agentArns, this.accessKey = props.accessKey, this.bucketName = props.bucketName, this.secretKey = props.secretKey, this.serverCertificate = props.serverCertificate, this.serverHostname = props.serverHostname, this.serverPort = props.serverPort, this.serverProtocol = props.serverProtocol, this.subdirectory = props.subdirectory, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DataSync::LocationObjectStorage", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLocationObjectStorage.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { agentArns: this.agentArns, accessKey: this.accessKey, bucketName: this.bucketName, secretKey: this.secretKey, serverCertificate: this.serverCertificate, serverHostname: this.serverHostname, serverPort: this.serverPort, serverProtocol: this.serverProtocol, subdirectory: this.subdirectory, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnLocationObjectStoragePropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnLocationObjectStorage[_j] = { fqn: "aws-cdk-lib.aws_datasync.CfnLocationObjectStorage", version: "2.80.0" }, CfnLocationObjectStorage.CFN_RESOURCE_TYPE_NAME = "AWS::DataSync::LocationObjectStorage", exports2.CfnLocationObjectStorage = CfnLocationObjectStorage;
    function CfnLocationS3PropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3BucketArn", cdk.validateString)(properties.s3BucketArn)), errors.collect(cdk.propertyValidator("s3Config", cdk.requiredValidator)(properties.s3Config)), errors.collect(cdk.propertyValidator("s3Config", CfnLocationS3_S3ConfigPropertyValidator)(properties.s3Config)), errors.collect(cdk.propertyValidator("s3StorageClass", cdk.validateString)(properties.s3StorageClass)), errors.collect(cdk.propertyValidator("subdirectory", cdk.validateString)(properties.subdirectory)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnLocationS3Props"');
    }
    function cfnLocationS3PropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLocationS3PropsValidator(properties).assertSuccess(), { S3Config: cfnLocationS3S3ConfigPropertyToCloudFormation(properties.s3Config), S3BucketArn: cdk.stringToCloudFormation(properties.s3BucketArn), S3StorageClass: cdk.stringToCloudFormation(properties.s3StorageClass), Subdirectory: cdk.stringToCloudFormation(properties.subdirectory), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnLocationS3PropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Config", "S3Config", CfnLocationS3S3ConfigPropertyFromCloudFormation(properties.S3Config)), ret.addPropertyResult("s3BucketArn", "S3BucketArn", properties.S3BucketArn != null ? cfn_parse.FromCloudFormation.getString(properties.S3BucketArn) : void 0), ret.addPropertyResult("s3StorageClass", "S3StorageClass", properties.S3StorageClass != null ? cfn_parse.FromCloudFormation.getString(properties.S3StorageClass) : void 0), ret.addPropertyResult("subdirectory", "Subdirectory", properties.Subdirectory != null ? cfn_parse.FromCloudFormation.getString(properties.Subdirectory) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLocationS3 = class _CfnLocationS3 extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLocationS3PropsFromCloudFormation(resourceProperties), ret = new _CfnLocationS3(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLocationS3.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_datasync_CfnLocationS3Props(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLocationS3), error;
        }
        cdk.requireProperty(props, "s3Config", this), this.attrLocationArn = cdk.Token.asString(this.getAtt("LocationArn", cdk.ResolutionTypeHint.STRING)), this.attrLocationUri = cdk.Token.asString(this.getAtt("LocationUri", cdk.ResolutionTypeHint.STRING)), this.s3Config = props.s3Config, this.s3BucketArn = props.s3BucketArn, this.s3StorageClass = props.s3StorageClass, this.subdirectory = props.subdirectory, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DataSync::LocationS3", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLocationS3.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { s3Config: this.s3Config, s3BucketArn: this.s3BucketArn, s3StorageClass: this.s3StorageClass, subdirectory: this.subdirectory, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnLocationS3PropsToCloudFormation(props);
      }
    };
    _k = JSII_RTTI_SYMBOL_1, CfnLocationS3[_k] = { fqn: "aws-cdk-lib.aws_datasync.CfnLocationS3", version: "2.80.0" }, CfnLocationS3.CFN_RESOURCE_TYPE_NAME = "AWS::DataSync::LocationS3", exports2.CfnLocationS3 = CfnLocationS3;
    function CfnLocationS3_S3ConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketAccessRoleArn", cdk.requiredValidator)(properties.bucketAccessRoleArn)), errors.collect(cdk.propertyValidator("bucketAccessRoleArn", cdk.validateString)(properties.bucketAccessRoleArn)), errors.wrap('supplied properties not correct for "S3ConfigProperty"');
    }
    function cfnLocationS3S3ConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLocationS3_S3ConfigPropertyValidator(properties).assertSuccess(), { BucketAccessRoleArn: cdk.stringToCloudFormation(properties.bucketAccessRoleArn) }) : properties;
    }
    function CfnLocationS3S3ConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketAccessRoleArn", "BucketAccessRoleArn", cfn_parse.FromCloudFormation.getString(properties.BucketAccessRoleArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLocationSMBPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("agentArns", cdk.requiredValidator)(properties.agentArns)), errors.collect(cdk.propertyValidator("agentArns", cdk.listValidator(cdk.validateString))(properties.agentArns)), errors.collect(cdk.propertyValidator("domain", cdk.validateString)(properties.domain)), errors.collect(cdk.propertyValidator("mountOptions", CfnLocationSMB_MountOptionsPropertyValidator)(properties.mountOptions)), errors.collect(cdk.propertyValidator("password", cdk.validateString)(properties.password)), errors.collect(cdk.propertyValidator("serverHostname", cdk.validateString)(properties.serverHostname)), errors.collect(cdk.propertyValidator("subdirectory", cdk.validateString)(properties.subdirectory)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("user", cdk.requiredValidator)(properties.user)), errors.collect(cdk.propertyValidator("user", cdk.validateString)(properties.user)), errors.wrap('supplied properties not correct for "CfnLocationSMBProps"');
    }
    function cfnLocationSMBPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLocationSMBPropsValidator(properties).assertSuccess(), { AgentArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.agentArns), User: cdk.stringToCloudFormation(properties.user), Domain: cdk.stringToCloudFormation(properties.domain), MountOptions: cfnLocationSMBMountOptionsPropertyToCloudFormation(properties.mountOptions), Password: cdk.stringToCloudFormation(properties.password), ServerHostname: cdk.stringToCloudFormation(properties.serverHostname), Subdirectory: cdk.stringToCloudFormation(properties.subdirectory), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnLocationSMBPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("agentArns", "AgentArns", cfn_parse.FromCloudFormation.getStringArray(properties.AgentArns)), ret.addPropertyResult("user", "User", cfn_parse.FromCloudFormation.getString(properties.User)), ret.addPropertyResult("domain", "Domain", properties.Domain != null ? cfn_parse.FromCloudFormation.getString(properties.Domain) : void 0), ret.addPropertyResult("mountOptions", "MountOptions", properties.MountOptions != null ? CfnLocationSMBMountOptionsPropertyFromCloudFormation(properties.MountOptions) : void 0), ret.addPropertyResult("password", "Password", properties.Password != null ? cfn_parse.FromCloudFormation.getString(properties.Password) : void 0), ret.addPropertyResult("serverHostname", "ServerHostname", properties.ServerHostname != null ? cfn_parse.FromCloudFormation.getString(properties.ServerHostname) : void 0), ret.addPropertyResult("subdirectory", "Subdirectory", properties.Subdirectory != null ? cfn_parse.FromCloudFormation.getString(properties.Subdirectory) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLocationSMB = class _CfnLocationSMB extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLocationSMBPropsFromCloudFormation(resourceProperties), ret = new _CfnLocationSMB(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLocationSMB.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_datasync_CfnLocationSMBProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLocationSMB), error;
        }
        cdk.requireProperty(props, "agentArns", this), cdk.requireProperty(props, "user", this), this.attrLocationArn = cdk.Token.asString(this.getAtt("LocationArn", cdk.ResolutionTypeHint.STRING)), this.attrLocationUri = cdk.Token.asString(this.getAtt("LocationUri", cdk.ResolutionTypeHint.STRING)), this.agentArns = props.agentArns, this.user = props.user, this.domain = props.domain, this.mountOptions = props.mountOptions, this.password = props.password, this.serverHostname = props.serverHostname, this.subdirectory = props.subdirectory, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DataSync::LocationSMB", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLocationSMB.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { agentArns: this.agentArns, user: this.user, domain: this.domain, mountOptions: this.mountOptions, password: this.password, serverHostname: this.serverHostname, subdirectory: this.subdirectory, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnLocationSMBPropsToCloudFormation(props);
      }
    };
    _l = JSII_RTTI_SYMBOL_1, CfnLocationSMB[_l] = { fqn: "aws-cdk-lib.aws_datasync.CfnLocationSMB", version: "2.80.0" }, CfnLocationSMB.CFN_RESOURCE_TYPE_NAME = "AWS::DataSync::LocationSMB", exports2.CfnLocationSMB = CfnLocationSMB;
    function CfnLocationSMB_MountOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "MountOptionsProperty"');
    }
    function cfnLocationSMBMountOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLocationSMB_MountOptionsPropertyValidator(properties).assertSuccess(), { Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnLocationSMBMountOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getString(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStorageSystemPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("agentArns", cdk.requiredValidator)(properties.agentArns)), errors.collect(cdk.propertyValidator("agentArns", cdk.listValidator(cdk.validateString))(properties.agentArns)), errors.collect(cdk.propertyValidator("cloudWatchLogGroupArn", cdk.validateString)(properties.cloudWatchLogGroupArn)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("serverConfiguration", cdk.requiredValidator)(properties.serverConfiguration)), errors.collect(cdk.propertyValidator("serverConfiguration", CfnStorageSystem_ServerConfigurationPropertyValidator)(properties.serverConfiguration)), errors.collect(cdk.propertyValidator("serverCredentials", CfnStorageSystem_ServerCredentialsPropertyValidator)(properties.serverCredentials)), errors.collect(cdk.propertyValidator("systemType", cdk.requiredValidator)(properties.systemType)), errors.collect(cdk.propertyValidator("systemType", cdk.validateString)(properties.systemType)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnStorageSystemProps"');
    }
    function cfnStorageSystemPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStorageSystemPropsValidator(properties).assertSuccess(), { AgentArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.agentArns), ServerConfiguration: cfnStorageSystemServerConfigurationPropertyToCloudFormation(properties.serverConfiguration), SystemType: cdk.stringToCloudFormation(properties.systemType), CloudWatchLogGroupArn: cdk.stringToCloudFormation(properties.cloudWatchLogGroupArn), Name: cdk.stringToCloudFormation(properties.name), ServerCredentials: cfnStorageSystemServerCredentialsPropertyToCloudFormation(properties.serverCredentials), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnStorageSystemPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("agentArns", "AgentArns", cfn_parse.FromCloudFormation.getStringArray(properties.AgentArns)), ret.addPropertyResult("serverConfiguration", "ServerConfiguration", CfnStorageSystemServerConfigurationPropertyFromCloudFormation(properties.ServerConfiguration)), ret.addPropertyResult("systemType", "SystemType", cfn_parse.FromCloudFormation.getString(properties.SystemType)), ret.addPropertyResult("cloudWatchLogGroupArn", "CloudWatchLogGroupArn", properties.CloudWatchLogGroupArn != null ? cfn_parse.FromCloudFormation.getString(properties.CloudWatchLogGroupArn) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("serverCredentials", "ServerCredentials", properties.ServerCredentials != null ? CfnStorageSystemServerCredentialsPropertyFromCloudFormation(properties.ServerCredentials) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnStorageSystem = class _CfnStorageSystem extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnStorageSystemPropsFromCloudFormation(resourceProperties), ret = new _CfnStorageSystem(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnStorageSystem.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_datasync_CfnStorageSystemProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnStorageSystem), error;
        }
        cdk.requireProperty(props, "agentArns", this), cdk.requireProperty(props, "serverConfiguration", this), cdk.requireProperty(props, "systemType", this), this.attrConnectivityStatus = cdk.Token.asString(this.getAtt("ConnectivityStatus", cdk.ResolutionTypeHint.STRING)), this.attrSecretsManagerArn = cdk.Token.asString(this.getAtt("SecretsManagerArn", cdk.ResolutionTypeHint.STRING)), this.attrStorageSystemArn = cdk.Token.asString(this.getAtt("StorageSystemArn", cdk.ResolutionTypeHint.STRING)), this.agentArns = props.agentArns, this.serverConfiguration = props.serverConfiguration, this.systemType = props.systemType, this.cloudWatchLogGroupArn = props.cloudWatchLogGroupArn, this.name = props.name, this.serverCredentials = props.serverCredentials, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DataSync::StorageSystem", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStorageSystem.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { agentArns: this.agentArns, serverConfiguration: this.serverConfiguration, systemType: this.systemType, cloudWatchLogGroupArn: this.cloudWatchLogGroupArn, name: this.name, serverCredentials: this.serverCredentials, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnStorageSystemPropsToCloudFormation(props);
      }
    };
    _m = JSII_RTTI_SYMBOL_1, CfnStorageSystem[_m] = { fqn: "aws-cdk-lib.aws_datasync.CfnStorageSystem", version: "2.80.0" }, CfnStorageSystem.CFN_RESOURCE_TYPE_NAME = "AWS::DataSync::StorageSystem", exports2.CfnStorageSystem = CfnStorageSystem;
    function CfnStorageSystem_ServerConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("serverHostname", cdk.requiredValidator)(properties.serverHostname)), errors.collect(cdk.propertyValidator("serverHostname", cdk.validateString)(properties.serverHostname)), errors.collect(cdk.propertyValidator("serverPort", cdk.validateNumber)(properties.serverPort)), errors.wrap('supplied properties not correct for "ServerConfigurationProperty"');
    }
    function cfnStorageSystemServerConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStorageSystem_ServerConfigurationPropertyValidator(properties).assertSuccess(), { ServerHostname: cdk.stringToCloudFormation(properties.serverHostname), ServerPort: cdk.numberToCloudFormation(properties.serverPort) }) : properties;
    }
    function CfnStorageSystemServerConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("serverHostname", "ServerHostname", cfn_parse.FromCloudFormation.getString(properties.ServerHostname)), ret.addPropertyResult("serverPort", "ServerPort", properties.ServerPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.ServerPort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStorageSystem_ServerCredentialsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("password", cdk.requiredValidator)(properties.password)), errors.collect(cdk.propertyValidator("password", cdk.validateString)(properties.password)), errors.collect(cdk.propertyValidator("username", cdk.requiredValidator)(properties.username)), errors.collect(cdk.propertyValidator("username", cdk.validateString)(properties.username)), errors.wrap('supplied properties not correct for "ServerCredentialsProperty"');
    }
    function cfnStorageSystemServerCredentialsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStorageSystem_ServerCredentialsPropertyValidator(properties).assertSuccess(), { Password: cdk.stringToCloudFormation(properties.password), Username: cdk.stringToCloudFormation(properties.username) }) : properties;
    }
    function CfnStorageSystemServerCredentialsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("password", "Password", cfn_parse.FromCloudFormation.getString(properties.Password)), ret.addPropertyResult("username", "Username", cfn_parse.FromCloudFormation.getString(properties.Username)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchLogGroupArn", cdk.validateString)(properties.cloudWatchLogGroupArn)), errors.collect(cdk.propertyValidator("destinationLocationArn", cdk.requiredValidator)(properties.destinationLocationArn)), errors.collect(cdk.propertyValidator("destinationLocationArn", cdk.validateString)(properties.destinationLocationArn)), errors.collect(cdk.propertyValidator("excludes", cdk.listValidator(CfnTask_FilterRulePropertyValidator))(properties.excludes)), errors.collect(cdk.propertyValidator("includes", cdk.listValidator(CfnTask_FilterRulePropertyValidator))(properties.includes)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("options", CfnTask_OptionsPropertyValidator)(properties.options)), errors.collect(cdk.propertyValidator("schedule", CfnTask_TaskSchedulePropertyValidator)(properties.schedule)), errors.collect(cdk.propertyValidator("sourceLocationArn", cdk.requiredValidator)(properties.sourceLocationArn)), errors.collect(cdk.propertyValidator("sourceLocationArn", cdk.validateString)(properties.sourceLocationArn)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnTaskProps"');
    }
    function cfnTaskPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskPropsValidator(properties).assertSuccess(), { DestinationLocationArn: cdk.stringToCloudFormation(properties.destinationLocationArn), SourceLocationArn: cdk.stringToCloudFormation(properties.sourceLocationArn), CloudWatchLogGroupArn: cdk.stringToCloudFormation(properties.cloudWatchLogGroupArn), Excludes: cdk.listMapper(cfnTaskFilterRulePropertyToCloudFormation)(properties.excludes), Includes: cdk.listMapper(cfnTaskFilterRulePropertyToCloudFormation)(properties.includes), Name: cdk.stringToCloudFormation(properties.name), Options: cfnTaskOptionsPropertyToCloudFormation(properties.options), Schedule: cfnTaskTaskSchedulePropertyToCloudFormation(properties.schedule), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnTaskPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationLocationArn", "DestinationLocationArn", cfn_parse.FromCloudFormation.getString(properties.DestinationLocationArn)), ret.addPropertyResult("sourceLocationArn", "SourceLocationArn", cfn_parse.FromCloudFormation.getString(properties.SourceLocationArn)), ret.addPropertyResult("cloudWatchLogGroupArn", "CloudWatchLogGroupArn", properties.CloudWatchLogGroupArn != null ? cfn_parse.FromCloudFormation.getString(properties.CloudWatchLogGroupArn) : void 0), ret.addPropertyResult("excludes", "Excludes", properties.Excludes != null ? cfn_parse.FromCloudFormation.getArray(CfnTaskFilterRulePropertyFromCloudFormation)(properties.Excludes) : void 0), ret.addPropertyResult("includes", "Includes", properties.Includes != null ? cfn_parse.FromCloudFormation.getArray(CfnTaskFilterRulePropertyFromCloudFormation)(properties.Includes) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("options", "Options", properties.Options != null ? CfnTaskOptionsPropertyFromCloudFormation(properties.Options) : void 0), ret.addPropertyResult("schedule", "Schedule", properties.Schedule != null ? CfnTaskTaskSchedulePropertyFromCloudFormation(properties.Schedule) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTask = class _CfnTask extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTaskPropsFromCloudFormation(resourceProperties), ret = new _CfnTask(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTask.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_datasync_CfnTaskProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTask), error;
        }
        cdk.requireProperty(props, "destinationLocationArn", this), cdk.requireProperty(props, "sourceLocationArn", this), this.attrDestinationNetworkInterfaceArns = cdk.Token.asList(this.getAtt("DestinationNetworkInterfaceArns", cdk.ResolutionTypeHint.STRING_LIST)), this.attrSourceNetworkInterfaceArns = cdk.Token.asList(this.getAtt("SourceNetworkInterfaceArns", cdk.ResolutionTypeHint.STRING_LIST)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.attrTaskArn = cdk.Token.asString(this.getAtt("TaskArn", cdk.ResolutionTypeHint.STRING)), this.destinationLocationArn = props.destinationLocationArn, this.sourceLocationArn = props.sourceLocationArn, this.cloudWatchLogGroupArn = props.cloudWatchLogGroupArn, this.excludes = props.excludes, this.includes = props.includes, this.name = props.name, this.options = props.options, this.schedule = props.schedule, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DataSync::Task", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTask.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { destinationLocationArn: this.destinationLocationArn, sourceLocationArn: this.sourceLocationArn, cloudWatchLogGroupArn: this.cloudWatchLogGroupArn, excludes: this.excludes, includes: this.includes, name: this.name, options: this.options, schedule: this.schedule, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnTaskPropsToCloudFormation(props);
      }
    };
    _o = JSII_RTTI_SYMBOL_1, CfnTask[_o] = { fqn: "aws-cdk-lib.aws_datasync.CfnTask", version: "2.80.0" }, CfnTask.CFN_RESOURCE_TYPE_NAME = "AWS::DataSync::Task", exports2.CfnTask = CfnTask;
    function CfnTask_FilterRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("filterType", cdk.validateString)(properties.filterType)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "FilterRuleProperty"');
    }
    function cfnTaskFilterRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTask_FilterRulePropertyValidator(properties).assertSuccess(), { FilterType: cdk.stringToCloudFormation(properties.filterType), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnTaskFilterRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("filterType", "FilterType", properties.FilterType != null ? cfn_parse.FromCloudFormation.getString(properties.FilterType) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTask_OptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("atime", cdk.validateString)(properties.atime)), errors.collect(cdk.propertyValidator("bytesPerSecond", cdk.validateNumber)(properties.bytesPerSecond)), errors.collect(cdk.propertyValidator("gid", cdk.validateString)(properties.gid)), errors.collect(cdk.propertyValidator("logLevel", cdk.validateString)(properties.logLevel)), errors.collect(cdk.propertyValidator("mtime", cdk.validateString)(properties.mtime)), errors.collect(cdk.propertyValidator("objectTags", cdk.validateString)(properties.objectTags)), errors.collect(cdk.propertyValidator("overwriteMode", cdk.validateString)(properties.overwriteMode)), errors.collect(cdk.propertyValidator("posixPermissions", cdk.validateString)(properties.posixPermissions)), errors.collect(cdk.propertyValidator("preserveDeletedFiles", cdk.validateString)(properties.preserveDeletedFiles)), errors.collect(cdk.propertyValidator("preserveDevices", cdk.validateString)(properties.preserveDevices)), errors.collect(cdk.propertyValidator("securityDescriptorCopyFlags", cdk.validateString)(properties.securityDescriptorCopyFlags)), errors.collect(cdk.propertyValidator("taskQueueing", cdk.validateString)(properties.taskQueueing)), errors.collect(cdk.propertyValidator("transferMode", cdk.validateString)(properties.transferMode)), errors.collect(cdk.propertyValidator("uid", cdk.validateString)(properties.uid)), errors.collect(cdk.propertyValidator("verifyMode", cdk.validateString)(properties.verifyMode)), errors.wrap('supplied properties not correct for "OptionsProperty"');
    }
    function cfnTaskOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTask_OptionsPropertyValidator(properties).assertSuccess(), { Atime: cdk.stringToCloudFormation(properties.atime), BytesPerSecond: cdk.numberToCloudFormation(properties.bytesPerSecond), Gid: cdk.stringToCloudFormation(properties.gid), LogLevel: cdk.stringToCloudFormation(properties.logLevel), Mtime: cdk.stringToCloudFormation(properties.mtime), ObjectTags: cdk.stringToCloudFormation(properties.objectTags), OverwriteMode: cdk.stringToCloudFormation(properties.overwriteMode), PosixPermissions: cdk.stringToCloudFormation(properties.posixPermissions), PreserveDeletedFiles: cdk.stringToCloudFormation(properties.preserveDeletedFiles), PreserveDevices: cdk.stringToCloudFormation(properties.preserveDevices), SecurityDescriptorCopyFlags: cdk.stringToCloudFormation(properties.securityDescriptorCopyFlags), TaskQueueing: cdk.stringToCloudFormation(properties.taskQueueing), TransferMode: cdk.stringToCloudFormation(properties.transferMode), Uid: cdk.stringToCloudFormation(properties.uid), VerifyMode: cdk.stringToCloudFormation(properties.verifyMode) }) : properties;
    }
    function CfnTaskOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("atime", "Atime", properties.Atime != null ? cfn_parse.FromCloudFormation.getString(properties.Atime) : void 0), ret.addPropertyResult("bytesPerSecond", "BytesPerSecond", properties.BytesPerSecond != null ? cfn_parse.FromCloudFormation.getNumber(properties.BytesPerSecond) : void 0), ret.addPropertyResult("gid", "Gid", properties.Gid != null ? cfn_parse.FromCloudFormation.getString(properties.Gid) : void 0), ret.addPropertyResult("logLevel", "LogLevel", properties.LogLevel != null ? cfn_parse.FromCloudFormation.getString(properties.LogLevel) : void 0), ret.addPropertyResult("mtime", "Mtime", properties.Mtime != null ? cfn_parse.FromCloudFormation.getString(properties.Mtime) : void 0), ret.addPropertyResult("objectTags", "ObjectTags", properties.ObjectTags != null ? cfn_parse.FromCloudFormation.getString(properties.ObjectTags) : void 0), ret.addPropertyResult("overwriteMode", "OverwriteMode", properties.OverwriteMode != null ? cfn_parse.FromCloudFormation.getString(properties.OverwriteMode) : void 0), ret.addPropertyResult("posixPermissions", "PosixPermissions", properties.PosixPermissions != null ? cfn_parse.FromCloudFormation.getString(properties.PosixPermissions) : void 0), ret.addPropertyResult("preserveDeletedFiles", "PreserveDeletedFiles", properties.PreserveDeletedFiles != null ? cfn_parse.FromCloudFormation.getString(properties.PreserveDeletedFiles) : void 0), ret.addPropertyResult("preserveDevices", "PreserveDevices", properties.PreserveDevices != null ? cfn_parse.FromCloudFormation.getString(properties.PreserveDevices) : void 0), ret.addPropertyResult("securityDescriptorCopyFlags", "SecurityDescriptorCopyFlags", properties.SecurityDescriptorCopyFlags != null ? cfn_parse.FromCloudFormation.getString(properties.SecurityDescriptorCopyFlags) : void 0), ret.addPropertyResult("taskQueueing", "TaskQueueing", properties.TaskQueueing != null ? cfn_parse.FromCloudFormation.getString(properties.TaskQueueing) : void 0), ret.addPropertyResult("transferMode", "TransferMode", properties.TransferMode != null ? cfn_parse.FromCloudFormation.getString(properties.TransferMode) : void 0), ret.addPropertyResult("uid", "Uid", properties.Uid != null ? cfn_parse.FromCloudFormation.getString(properties.Uid) : void 0), ret.addPropertyResult("verifyMode", "VerifyMode", properties.VerifyMode != null ? cfn_parse.FromCloudFormation.getString(properties.VerifyMode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTask_TaskSchedulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("scheduleExpression", cdk.requiredValidator)(properties.scheduleExpression)), errors.collect(cdk.propertyValidator("scheduleExpression", cdk.validateString)(properties.scheduleExpression)), errors.wrap('supplied properties not correct for "TaskScheduleProperty"');
    }
    function cfnTaskTaskSchedulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTask_TaskSchedulePropertyValidator(properties).assertSuccess(), { ScheduleExpression: cdk.stringToCloudFormation(properties.scheduleExpression) }) : properties;
    }
    function CfnTaskTaskSchedulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("scheduleExpression", "ScheduleExpression", cfn_parse.FromCloudFormation.getString(properties.ScheduleExpression)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-datasync/lib/index.js
var require_lib98 = __commonJS({
  "node_modules/aws-cdk-lib/aws-datasync/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_datasync_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-datasync/index.js
var require_aws_datasync = __commonJS({
  "node_modules/aws-cdk-lib/aws-datasync/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib98(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-dax/lib/dax.generated.js
var require_dax_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-dax/lib/dax.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnSubnetGroup = exports2.CfnParameterGroup = exports2.CfnCluster = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnClusterPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availabilityZones", cdk.listValidator(cdk.validateString))(properties.availabilityZones)), errors.collect(cdk.propertyValidator("clusterEndpointEncryptionType", cdk.validateString)(properties.clusterEndpointEncryptionType)), errors.collect(cdk.propertyValidator("clusterName", cdk.validateString)(properties.clusterName)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("iamRoleArn", cdk.requiredValidator)(properties.iamRoleArn)), errors.collect(cdk.propertyValidator("iamRoleArn", cdk.validateString)(properties.iamRoleArn)), errors.collect(cdk.propertyValidator("nodeType", cdk.requiredValidator)(properties.nodeType)), errors.collect(cdk.propertyValidator("nodeType", cdk.validateString)(properties.nodeType)), errors.collect(cdk.propertyValidator("notificationTopicArn", cdk.validateString)(properties.notificationTopicArn)), errors.collect(cdk.propertyValidator("parameterGroupName", cdk.validateString)(properties.parameterGroupName)), errors.collect(cdk.propertyValidator("preferredMaintenanceWindow", cdk.validateString)(properties.preferredMaintenanceWindow)), errors.collect(cdk.propertyValidator("replicationFactor", cdk.requiredValidator)(properties.replicationFactor)), errors.collect(cdk.propertyValidator("replicationFactor", cdk.validateNumber)(properties.replicationFactor)), errors.collect(cdk.propertyValidator("sseSpecification", CfnCluster_SSESpecificationPropertyValidator)(properties.sseSpecification)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnetGroupName", cdk.validateString)(properties.subnetGroupName)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.wrap('supplied properties not correct for "CfnClusterProps"');
    }
    function cfnClusterPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClusterPropsValidator(properties).assertSuccess(), { IAMRoleARN: cdk.stringToCloudFormation(properties.iamRoleArn), NodeType: cdk.stringToCloudFormation(properties.nodeType), ReplicationFactor: cdk.numberToCloudFormation(properties.replicationFactor), AvailabilityZones: cdk.listMapper(cdk.stringToCloudFormation)(properties.availabilityZones), ClusterEndpointEncryptionType: cdk.stringToCloudFormation(properties.clusterEndpointEncryptionType), ClusterName: cdk.stringToCloudFormation(properties.clusterName), Description: cdk.stringToCloudFormation(properties.description), NotificationTopicARN: cdk.stringToCloudFormation(properties.notificationTopicArn), ParameterGroupName: cdk.stringToCloudFormation(properties.parameterGroupName), PreferredMaintenanceWindow: cdk.stringToCloudFormation(properties.preferredMaintenanceWindow), SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SSESpecification: cfnClusterSSESpecificationPropertyToCloudFormation(properties.sseSpecification), SubnetGroupName: cdk.stringToCloudFormation(properties.subnetGroupName), Tags: cdk.objectToCloudFormation(properties.tags) }) : properties;
    }
    function CfnClusterPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("iamRoleArn", "IAMRoleARN", cfn_parse.FromCloudFormation.getString(properties.IAMRoleARN)), ret.addPropertyResult("nodeType", "NodeType", cfn_parse.FromCloudFormation.getString(properties.NodeType)), ret.addPropertyResult("replicationFactor", "ReplicationFactor", cfn_parse.FromCloudFormation.getNumber(properties.ReplicationFactor)), ret.addPropertyResult("availabilityZones", "AvailabilityZones", properties.AvailabilityZones != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AvailabilityZones) : void 0), ret.addPropertyResult("clusterEndpointEncryptionType", "ClusterEndpointEncryptionType", properties.ClusterEndpointEncryptionType != null ? cfn_parse.FromCloudFormation.getString(properties.ClusterEndpointEncryptionType) : void 0), ret.addPropertyResult("clusterName", "ClusterName", properties.ClusterName != null ? cfn_parse.FromCloudFormation.getString(properties.ClusterName) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("notificationTopicArn", "NotificationTopicARN", properties.NotificationTopicARN != null ? cfn_parse.FromCloudFormation.getString(properties.NotificationTopicARN) : void 0), ret.addPropertyResult("parameterGroupName", "ParameterGroupName", properties.ParameterGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.ParameterGroupName) : void 0), ret.addPropertyResult("preferredMaintenanceWindow", "PreferredMaintenanceWindow", properties.PreferredMaintenanceWindow != null ? cfn_parse.FromCloudFormation.getString(properties.PreferredMaintenanceWindow) : void 0), ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("sseSpecification", "SSESpecification", properties.SSESpecification != null ? CfnClusterSSESpecificationPropertyFromCloudFormation(properties.SSESpecification) : void 0), ret.addPropertyResult("subnetGroupName", "SubnetGroupName", properties.SubnetGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.SubnetGroupName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCluster = class _CfnCluster extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnClusterPropsFromCloudFormation(resourceProperties), ret = new _CfnCluster(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCluster.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_dax_CfnClusterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCluster), error;
        }
        cdk.requireProperty(props, "iamRoleArn", this), cdk.requireProperty(props, "nodeType", this), cdk.requireProperty(props, "replicationFactor", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrClusterDiscoveryEndpoint = cdk.Token.asString(this.getAtt("ClusterDiscoveryEndpoint", cdk.ResolutionTypeHint.STRING)), this.attrClusterDiscoveryEndpointUrl = cdk.Token.asString(this.getAtt("ClusterDiscoveryEndpointURL", cdk.ResolutionTypeHint.STRING)), this.iamRoleArn = props.iamRoleArn, this.nodeType = props.nodeType, this.replicationFactor = props.replicationFactor, this.availabilityZones = props.availabilityZones, this.clusterEndpointEncryptionType = props.clusterEndpointEncryptionType, this.clusterName = props.clusterName, this.description = props.description, this.notificationTopicArn = props.notificationTopicArn, this.parameterGroupName = props.parameterGroupName, this.preferredMaintenanceWindow = props.preferredMaintenanceWindow, this.securityGroupIds = props.securityGroupIds, this.sseSpecification = props.sseSpecification, this.subnetGroupName = props.subnetGroupName, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::DAX::Cluster", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCluster.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { iamRoleArn: this.iamRoleArn, nodeType: this.nodeType, replicationFactor: this.replicationFactor, availabilityZones: this.availabilityZones, clusterEndpointEncryptionType: this.clusterEndpointEncryptionType, clusterName: this.clusterName, description: this.description, notificationTopicArn: this.notificationTopicArn, parameterGroupName: this.parameterGroupName, preferredMaintenanceWindow: this.preferredMaintenanceWindow, securityGroupIds: this.securityGroupIds, sseSpecification: this.sseSpecification, subnetGroupName: this.subnetGroupName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnClusterPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnCluster[_a] = { fqn: "aws-cdk-lib.aws_dax.CfnCluster", version: "2.80.0" }, CfnCluster.CFN_RESOURCE_TYPE_NAME = "AWS::DAX::Cluster", exports2.CfnCluster = CfnCluster;
    function CfnCluster_SSESpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sseEnabled", cdk.validateBoolean)(properties.sseEnabled)), errors.wrap('supplied properties not correct for "SSESpecificationProperty"');
    }
    function cfnClusterSSESpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_SSESpecificationPropertyValidator(properties).assertSuccess(), { SSEEnabled: cdk.booleanToCloudFormation(properties.sseEnabled) }) : properties;
    }
    function CfnClusterSSESpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sseEnabled", "SSEEnabled", properties.SSEEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SSEEnabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnParameterGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("parameterGroupName", cdk.validateString)(properties.parameterGroupName)), errors.collect(cdk.propertyValidator("parameterNameValues", cdk.validateObject)(properties.parameterNameValues)), errors.wrap('supplied properties not correct for "CfnParameterGroupProps"');
    }
    function cfnParameterGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnParameterGroupPropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), ParameterGroupName: cdk.stringToCloudFormation(properties.parameterGroupName), ParameterNameValues: cdk.objectToCloudFormation(properties.parameterNameValues) }) : properties;
    }
    function CfnParameterGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("parameterGroupName", "ParameterGroupName", properties.ParameterGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.ParameterGroupName) : void 0), ret.addPropertyResult("parameterNameValues", "ParameterNameValues", properties.ParameterNameValues != null ? cfn_parse.FromCloudFormation.getAny(properties.ParameterNameValues) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnParameterGroup = class _CfnParameterGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnParameterGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnParameterGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnParameterGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_dax_CfnParameterGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnParameterGroup), error;
        }
        this.description = props.description, this.parameterGroupName = props.parameterGroupName, this.parameterNameValues = props.parameterNameValues;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnParameterGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, parameterGroupName: this.parameterGroupName, parameterNameValues: this.parameterNameValues };
      }
      renderProperties(props) {
        return cfnParameterGroupPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnParameterGroup[_b] = { fqn: "aws-cdk-lib.aws_dax.CfnParameterGroup", version: "2.80.0" }, CfnParameterGroup.CFN_RESOURCE_TYPE_NAME = "AWS::DAX::ParameterGroup", exports2.CfnParameterGroup = CfnParameterGroup;
    function CfnSubnetGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("subnetGroupName", cdk.validateString)(properties.subnetGroupName)), errors.collect(cdk.propertyValidator("subnetIds", cdk.requiredValidator)(properties.subnetIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.wrap('supplied properties not correct for "CfnSubnetGroupProps"');
    }
    function cfnSubnetGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSubnetGroupPropsValidator(properties).assertSuccess(), { SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds), Description: cdk.stringToCloudFormation(properties.description), SubnetGroupName: cdk.stringToCloudFormation(properties.subnetGroupName) }) : properties;
    }
    function CfnSubnetGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("subnetIds", "SubnetIds", cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("subnetGroupName", "SubnetGroupName", properties.SubnetGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.SubnetGroupName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSubnetGroup = class _CfnSubnetGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSubnetGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnSubnetGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSubnetGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_dax_CfnSubnetGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSubnetGroup), error;
        }
        cdk.requireProperty(props, "subnetIds", this), this.subnetIds = props.subnetIds, this.description = props.description, this.subnetGroupName = props.subnetGroupName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSubnetGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { subnetIds: this.subnetIds, description: this.description, subnetGroupName: this.subnetGroupName };
      }
      renderProperties(props) {
        return cfnSubnetGroupPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnSubnetGroup[_c] = { fqn: "aws-cdk-lib.aws_dax.CfnSubnetGroup", version: "2.80.0" }, CfnSubnetGroup.CFN_RESOURCE_TYPE_NAME = "AWS::DAX::SubnetGroup", exports2.CfnSubnetGroup = CfnSubnetGroup;
  }
});

// node_modules/aws-cdk-lib/aws-dax/lib/index.js
var require_lib99 = __commonJS({
  "node_modules/aws-cdk-lib/aws-dax/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_dax_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-dax/index.js
var require_aws_dax = __commonJS({
  "node_modules/aws-cdk-lib/aws-dax/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib99(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-detective/lib/detective.generated.js
var require_detective_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-detective/lib/detective.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnMemberInvitation = exports2.CfnGraph = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnGraphPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoEnableMembers", cdk.validateBoolean)(properties.autoEnableMembers)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnGraphProps"');
    }
    function cfnGraphPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGraphPropsValidator(properties).assertSuccess(), { AutoEnableMembers: cdk.booleanToCloudFormation(properties.autoEnableMembers), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnGraphPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("autoEnableMembers", "AutoEnableMembers", properties.AutoEnableMembers != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AutoEnableMembers) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnGraph = class _CfnGraph extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnGraphPropsFromCloudFormation(resourceProperties), ret = new _CfnGraph(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnGraph.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_detective_CfnGraphProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnGraph), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.autoEnableMembers = props.autoEnableMembers, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Detective::Graph", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnGraph.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { autoEnableMembers: this.autoEnableMembers, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnGraphPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnGraph[_a] = { fqn: "aws-cdk-lib.aws_detective.CfnGraph", version: "2.80.0" }, CfnGraph.CFN_RESOURCE_TYPE_NAME = "AWS::Detective::Graph", exports2.CfnGraph = CfnGraph;
    function CfnMemberInvitationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("disableEmailNotification", cdk.validateBoolean)(properties.disableEmailNotification)), errors.collect(cdk.propertyValidator("graphArn", cdk.requiredValidator)(properties.graphArn)), errors.collect(cdk.propertyValidator("graphArn", cdk.validateString)(properties.graphArn)), errors.collect(cdk.propertyValidator("memberEmailAddress", cdk.requiredValidator)(properties.memberEmailAddress)), errors.collect(cdk.propertyValidator("memberEmailAddress", cdk.validateString)(properties.memberEmailAddress)), errors.collect(cdk.propertyValidator("memberId", cdk.requiredValidator)(properties.memberId)), errors.collect(cdk.propertyValidator("memberId", cdk.validateString)(properties.memberId)), errors.collect(cdk.propertyValidator("message", cdk.validateString)(properties.message)), errors.wrap('supplied properties not correct for "CfnMemberInvitationProps"');
    }
    function cfnMemberInvitationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMemberInvitationPropsValidator(properties).assertSuccess(), { GraphArn: cdk.stringToCloudFormation(properties.graphArn), MemberEmailAddress: cdk.stringToCloudFormation(properties.memberEmailAddress), MemberId: cdk.stringToCloudFormation(properties.memberId), DisableEmailNotification: cdk.booleanToCloudFormation(properties.disableEmailNotification), Message: cdk.stringToCloudFormation(properties.message) }) : properties;
    }
    function CfnMemberInvitationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("graphArn", "GraphArn", cfn_parse.FromCloudFormation.getString(properties.GraphArn)), ret.addPropertyResult("memberEmailAddress", "MemberEmailAddress", cfn_parse.FromCloudFormation.getString(properties.MemberEmailAddress)), ret.addPropertyResult("memberId", "MemberId", cfn_parse.FromCloudFormation.getString(properties.MemberId)), ret.addPropertyResult("disableEmailNotification", "DisableEmailNotification", properties.DisableEmailNotification != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DisableEmailNotification) : void 0), ret.addPropertyResult("message", "Message", properties.Message != null ? cfn_parse.FromCloudFormation.getString(properties.Message) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnMemberInvitation = class _CfnMemberInvitation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnMemberInvitationPropsFromCloudFormation(resourceProperties), ret = new _CfnMemberInvitation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnMemberInvitation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_detective_CfnMemberInvitationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnMemberInvitation), error;
        }
        cdk.requireProperty(props, "graphArn", this), cdk.requireProperty(props, "memberEmailAddress", this), cdk.requireProperty(props, "memberId", this), this.graphArn = props.graphArn, this.memberEmailAddress = props.memberEmailAddress, this.memberId = props.memberId, this.disableEmailNotification = props.disableEmailNotification, this.message = props.message;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnMemberInvitation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { graphArn: this.graphArn, memberEmailAddress: this.memberEmailAddress, memberId: this.memberId, disableEmailNotification: this.disableEmailNotification, message: this.message };
      }
      renderProperties(props) {
        return cfnMemberInvitationPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnMemberInvitation[_b] = { fqn: "aws-cdk-lib.aws_detective.CfnMemberInvitation", version: "2.80.0" }, CfnMemberInvitation.CFN_RESOURCE_TYPE_NAME = "AWS::Detective::MemberInvitation", exports2.CfnMemberInvitation = CfnMemberInvitation;
  }
});

// node_modules/aws-cdk-lib/aws-detective/lib/index.js
var require_lib100 = __commonJS({
  "node_modules/aws-cdk-lib/aws-detective/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_detective_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-detective/index.js
var require_aws_detective = __commonJS({
  "node_modules/aws-cdk-lib/aws-detective/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib100(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-devicefarm/lib/devicefarm.generated.js
var require_devicefarm_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-devicefarm/lib/devicefarm.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnVPCEConfiguration = exports2.CfnTestGridProject = exports2.CfnProject = exports2.CfnNetworkProfile = exports2.CfnInstanceProfile = exports2.CfnDevicePool = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnDevicePoolPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("maxDevices", cdk.validateNumber)(properties.maxDevices)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("projectArn", cdk.requiredValidator)(properties.projectArn)), errors.collect(cdk.propertyValidator("projectArn", cdk.validateString)(properties.projectArn)), errors.collect(cdk.propertyValidator("rules", cdk.requiredValidator)(properties.rules)), errors.collect(cdk.propertyValidator("rules", cdk.listValidator(CfnDevicePool_RulePropertyValidator))(properties.rules)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDevicePoolProps"');
    }
    function cfnDevicePoolPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDevicePoolPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), ProjectArn: cdk.stringToCloudFormation(properties.projectArn), Rules: cdk.listMapper(cfnDevicePoolRulePropertyToCloudFormation)(properties.rules), Description: cdk.stringToCloudFormation(properties.description), MaxDevices: cdk.numberToCloudFormation(properties.maxDevices), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDevicePoolPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("projectArn", "ProjectArn", cfn_parse.FromCloudFormation.getString(properties.ProjectArn)), ret.addPropertyResult("rules", "Rules", cfn_parse.FromCloudFormation.getArray(CfnDevicePoolRulePropertyFromCloudFormation)(properties.Rules)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("maxDevices", "MaxDevices", properties.MaxDevices != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxDevices) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDevicePool = class _CfnDevicePool extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDevicePoolPropsFromCloudFormation(resourceProperties), ret = new _CfnDevicePool(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDevicePool.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_devicefarm_CfnDevicePoolProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDevicePool), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "projectArn", this), cdk.requireProperty(props, "rules", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.projectArn = props.projectArn, this.rules = props.rules, this.description = props.description, this.maxDevices = props.maxDevices, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DeviceFarm::DevicePool", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDevicePool.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, projectArn: this.projectArn, rules: this.rules, description: this.description, maxDevices: this.maxDevices, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDevicePoolPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnDevicePool[_a] = { fqn: "aws-cdk-lib.aws_devicefarm.CfnDevicePool", version: "2.80.0" }, CfnDevicePool.CFN_RESOURCE_TYPE_NAME = "AWS::DeviceFarm::DevicePool", exports2.CfnDevicePool = CfnDevicePool;
    function CfnDevicePool_RulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attribute", cdk.validateString)(properties.attribute)), errors.collect(cdk.propertyValidator("operator", cdk.validateString)(properties.operator)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "RuleProperty"');
    }
    function cfnDevicePoolRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDevicePool_RulePropertyValidator(properties).assertSuccess(), { Attribute: cdk.stringToCloudFormation(properties.attribute), Operator: cdk.stringToCloudFormation(properties.operator), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnDevicePoolRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attribute", "Attribute", properties.Attribute != null ? cfn_parse.FromCloudFormation.getString(properties.Attribute) : void 0), ret.addPropertyResult("operator", "Operator", properties.Operator != null ? cfn_parse.FromCloudFormation.getString(properties.Operator) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstanceProfilePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("excludeAppPackagesFromCleanup", cdk.listValidator(cdk.validateString))(properties.excludeAppPackagesFromCleanup)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("packageCleanup", cdk.validateBoolean)(properties.packageCleanup)), errors.collect(cdk.propertyValidator("rebootAfterUse", cdk.validateBoolean)(properties.rebootAfterUse)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnInstanceProfileProps"');
    }
    function cfnInstanceProfilePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceProfilePropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), ExcludeAppPackagesFromCleanup: cdk.listMapper(cdk.stringToCloudFormation)(properties.excludeAppPackagesFromCleanup), PackageCleanup: cdk.booleanToCloudFormation(properties.packageCleanup), RebootAfterUse: cdk.booleanToCloudFormation(properties.rebootAfterUse), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnInstanceProfilePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("excludeAppPackagesFromCleanup", "ExcludeAppPackagesFromCleanup", properties.ExcludeAppPackagesFromCleanup != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExcludeAppPackagesFromCleanup) : void 0), ret.addPropertyResult("packageCleanup", "PackageCleanup", properties.PackageCleanup != null ? cfn_parse.FromCloudFormation.getBoolean(properties.PackageCleanup) : void 0), ret.addPropertyResult("rebootAfterUse", "RebootAfterUse", properties.RebootAfterUse != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RebootAfterUse) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnInstanceProfile = class _CfnInstanceProfile extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnInstanceProfilePropsFromCloudFormation(resourceProperties), ret = new _CfnInstanceProfile(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnInstanceProfile.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_devicefarm_CfnInstanceProfileProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnInstanceProfile), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.description = props.description, this.excludeAppPackagesFromCleanup = props.excludeAppPackagesFromCleanup, this.packageCleanup = props.packageCleanup, this.rebootAfterUse = props.rebootAfterUse, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DeviceFarm::InstanceProfile", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnInstanceProfile.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, description: this.description, excludeAppPackagesFromCleanup: this.excludeAppPackagesFromCleanup, packageCleanup: this.packageCleanup, rebootAfterUse: this.rebootAfterUse, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnInstanceProfilePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnInstanceProfile[_b] = { fqn: "aws-cdk-lib.aws_devicefarm.CfnInstanceProfile", version: "2.80.0" }, CfnInstanceProfile.CFN_RESOURCE_TYPE_NAME = "AWS::DeviceFarm::InstanceProfile", exports2.CfnInstanceProfile = CfnInstanceProfile;
    function CfnNetworkProfilePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("downlinkBandwidthBits", cdk.validateNumber)(properties.downlinkBandwidthBits)), errors.collect(cdk.propertyValidator("downlinkDelayMs", cdk.validateNumber)(properties.downlinkDelayMs)), errors.collect(cdk.propertyValidator("downlinkJitterMs", cdk.validateNumber)(properties.downlinkJitterMs)), errors.collect(cdk.propertyValidator("downlinkLossPercent", cdk.validateNumber)(properties.downlinkLossPercent)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("projectArn", cdk.requiredValidator)(properties.projectArn)), errors.collect(cdk.propertyValidator("projectArn", cdk.validateString)(properties.projectArn)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("uplinkBandwidthBits", cdk.validateNumber)(properties.uplinkBandwidthBits)), errors.collect(cdk.propertyValidator("uplinkDelayMs", cdk.validateNumber)(properties.uplinkDelayMs)), errors.collect(cdk.propertyValidator("uplinkJitterMs", cdk.validateNumber)(properties.uplinkJitterMs)), errors.collect(cdk.propertyValidator("uplinkLossPercent", cdk.validateNumber)(properties.uplinkLossPercent)), errors.wrap('supplied properties not correct for "CfnNetworkProfileProps"');
    }
    function cfnNetworkProfilePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNetworkProfilePropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), ProjectArn: cdk.stringToCloudFormation(properties.projectArn), Description: cdk.stringToCloudFormation(properties.description), DownlinkBandwidthBits: cdk.numberToCloudFormation(properties.downlinkBandwidthBits), DownlinkDelayMs: cdk.numberToCloudFormation(properties.downlinkDelayMs), DownlinkJitterMs: cdk.numberToCloudFormation(properties.downlinkJitterMs), DownlinkLossPercent: cdk.numberToCloudFormation(properties.downlinkLossPercent), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), UplinkBandwidthBits: cdk.numberToCloudFormation(properties.uplinkBandwidthBits), UplinkDelayMs: cdk.numberToCloudFormation(properties.uplinkDelayMs), UplinkJitterMs: cdk.numberToCloudFormation(properties.uplinkJitterMs), UplinkLossPercent: cdk.numberToCloudFormation(properties.uplinkLossPercent) }) : properties;
    }
    function CfnNetworkProfilePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("projectArn", "ProjectArn", cfn_parse.FromCloudFormation.getString(properties.ProjectArn)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("downlinkBandwidthBits", "DownlinkBandwidthBits", properties.DownlinkBandwidthBits != null ? cfn_parse.FromCloudFormation.getNumber(properties.DownlinkBandwidthBits) : void 0), ret.addPropertyResult("downlinkDelayMs", "DownlinkDelayMs", properties.DownlinkDelayMs != null ? cfn_parse.FromCloudFormation.getNumber(properties.DownlinkDelayMs) : void 0), ret.addPropertyResult("downlinkJitterMs", "DownlinkJitterMs", properties.DownlinkJitterMs != null ? cfn_parse.FromCloudFormation.getNumber(properties.DownlinkJitterMs) : void 0), ret.addPropertyResult("downlinkLossPercent", "DownlinkLossPercent", properties.DownlinkLossPercent != null ? cfn_parse.FromCloudFormation.getNumber(properties.DownlinkLossPercent) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("uplinkBandwidthBits", "UplinkBandwidthBits", properties.UplinkBandwidthBits != null ? cfn_parse.FromCloudFormation.getNumber(properties.UplinkBandwidthBits) : void 0), ret.addPropertyResult("uplinkDelayMs", "UplinkDelayMs", properties.UplinkDelayMs != null ? cfn_parse.FromCloudFormation.getNumber(properties.UplinkDelayMs) : void 0), ret.addPropertyResult("uplinkJitterMs", "UplinkJitterMs", properties.UplinkJitterMs != null ? cfn_parse.FromCloudFormation.getNumber(properties.UplinkJitterMs) : void 0), ret.addPropertyResult("uplinkLossPercent", "UplinkLossPercent", properties.UplinkLossPercent != null ? cfn_parse.FromCloudFormation.getNumber(properties.UplinkLossPercent) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnNetworkProfile = class _CfnNetworkProfile extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnNetworkProfilePropsFromCloudFormation(resourceProperties), ret = new _CfnNetworkProfile(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnNetworkProfile.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_devicefarm_CfnNetworkProfileProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnNetworkProfile), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "projectArn", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.projectArn = props.projectArn, this.description = props.description, this.downlinkBandwidthBits = props.downlinkBandwidthBits, this.downlinkDelayMs = props.downlinkDelayMs, this.downlinkJitterMs = props.downlinkJitterMs, this.downlinkLossPercent = props.downlinkLossPercent, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DeviceFarm::NetworkProfile", props.tags, { tagPropertyName: "tags" }), this.uplinkBandwidthBits = props.uplinkBandwidthBits, this.uplinkDelayMs = props.uplinkDelayMs, this.uplinkJitterMs = props.uplinkJitterMs, this.uplinkLossPercent = props.uplinkLossPercent;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnNetworkProfile.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, projectArn: this.projectArn, description: this.description, downlinkBandwidthBits: this.downlinkBandwidthBits, downlinkDelayMs: this.downlinkDelayMs, downlinkJitterMs: this.downlinkJitterMs, downlinkLossPercent: this.downlinkLossPercent, tags: this.tags.renderTags(), uplinkBandwidthBits: this.uplinkBandwidthBits, uplinkDelayMs: this.uplinkDelayMs, uplinkJitterMs: this.uplinkJitterMs, uplinkLossPercent: this.uplinkLossPercent };
      }
      renderProperties(props) {
        return cfnNetworkProfilePropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnNetworkProfile[_c] = { fqn: "aws-cdk-lib.aws_devicefarm.CfnNetworkProfile", version: "2.80.0" }, CfnNetworkProfile.CFN_RESOURCE_TYPE_NAME = "AWS::DeviceFarm::NetworkProfile", exports2.CfnNetworkProfile = CfnNetworkProfile;
    function CfnProjectPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultJobTimeoutMinutes", cdk.validateNumber)(properties.defaultJobTimeoutMinutes)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpcConfig", CfnProject_VpcConfigPropertyValidator)(properties.vpcConfig)), errors.wrap('supplied properties not correct for "CfnProjectProps"');
    }
    function cfnProjectPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProjectPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), DefaultJobTimeoutMinutes: cdk.numberToCloudFormation(properties.defaultJobTimeoutMinutes), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VpcConfig: cfnProjectVpcConfigPropertyToCloudFormation(properties.vpcConfig) }) : properties;
    }
    function CfnProjectPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("defaultJobTimeoutMinutes", "DefaultJobTimeoutMinutes", properties.DefaultJobTimeoutMinutes != null ? cfn_parse.FromCloudFormation.getNumber(properties.DefaultJobTimeoutMinutes) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("vpcConfig", "VpcConfig", properties.VpcConfig != null ? CfnProjectVpcConfigPropertyFromCloudFormation(properties.VpcConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnProject = class _CfnProject extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnProjectPropsFromCloudFormation(resourceProperties), ret = new _CfnProject(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnProject.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_devicefarm_CfnProjectProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnProject), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.defaultJobTimeoutMinutes = props.defaultJobTimeoutMinutes, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DeviceFarm::Project", props.tags, { tagPropertyName: "tags" }), this.vpcConfig = props.vpcConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnProject.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, defaultJobTimeoutMinutes: this.defaultJobTimeoutMinutes, tags: this.tags.renderTags(), vpcConfig: this.vpcConfig };
      }
      renderProperties(props) {
        return cfnProjectPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnProject[_d] = { fqn: "aws-cdk-lib.aws_devicefarm.CfnProject", version: "2.80.0" }, CfnProject.CFN_RESOURCE_TYPE_NAME = "AWS::DeviceFarm::Project", exports2.CfnProject = CfnProject;
    function CfnProject_VpcConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.requiredValidator)(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.requiredValidator)(properties.subnetIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.collect(cdk.propertyValidator("vpcId", cdk.requiredValidator)(properties.vpcId)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "VpcConfigProperty"');
    }
    function cfnProjectVpcConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProject_VpcConfigPropertyValidator(properties).assertSuccess(), { SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds), VpcId: cdk.stringToCloudFormation(properties.vpcId) }) : properties;
    }
    function CfnProjectVpcConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds)), ret.addPropertyResult("subnetIds", "SubnetIds", cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds)), ret.addPropertyResult("vpcId", "VpcId", cfn_parse.FromCloudFormation.getString(properties.VpcId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTestGridProjectPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpcConfig", CfnTestGridProject_VpcConfigPropertyValidator)(properties.vpcConfig)), errors.wrap('supplied properties not correct for "CfnTestGridProjectProps"');
    }
    function cfnTestGridProjectPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTestGridProjectPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VpcConfig: cfnTestGridProjectVpcConfigPropertyToCloudFormation(properties.vpcConfig) }) : properties;
    }
    function CfnTestGridProjectPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("vpcConfig", "VpcConfig", properties.VpcConfig != null ? CfnTestGridProjectVpcConfigPropertyFromCloudFormation(properties.VpcConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTestGridProject = class _CfnTestGridProject extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTestGridProjectPropsFromCloudFormation(resourceProperties), ret = new _CfnTestGridProject(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTestGridProject.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_devicefarm_CfnTestGridProjectProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTestGridProject), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DeviceFarm::TestGridProject", props.tags, { tagPropertyName: "tags" }), this.vpcConfig = props.vpcConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTestGridProject.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, description: this.description, tags: this.tags.renderTags(), vpcConfig: this.vpcConfig };
      }
      renderProperties(props) {
        return cfnTestGridProjectPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnTestGridProject[_e] = { fqn: "aws-cdk-lib.aws_devicefarm.CfnTestGridProject", version: "2.80.0" }, CfnTestGridProject.CFN_RESOURCE_TYPE_NAME = "AWS::DeviceFarm::TestGridProject", exports2.CfnTestGridProject = CfnTestGridProject;
    function CfnTestGridProject_VpcConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.requiredValidator)(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.requiredValidator)(properties.subnetIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.collect(cdk.propertyValidator("vpcId", cdk.requiredValidator)(properties.vpcId)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "VpcConfigProperty"');
    }
    function cfnTestGridProjectVpcConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTestGridProject_VpcConfigPropertyValidator(properties).assertSuccess(), { SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds), VpcId: cdk.stringToCloudFormation(properties.vpcId) }) : properties;
    }
    function CfnTestGridProjectVpcConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds)), ret.addPropertyResult("subnetIds", "SubnetIds", cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds)), ret.addPropertyResult("vpcId", "VpcId", cfn_parse.FromCloudFormation.getString(properties.VpcId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVPCEConfigurationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("serviceDnsName", cdk.requiredValidator)(properties.serviceDnsName)), errors.collect(cdk.propertyValidator("serviceDnsName", cdk.validateString)(properties.serviceDnsName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpceConfigurationDescription", cdk.validateString)(properties.vpceConfigurationDescription)), errors.collect(cdk.propertyValidator("vpceConfigurationName", cdk.requiredValidator)(properties.vpceConfigurationName)), errors.collect(cdk.propertyValidator("vpceConfigurationName", cdk.validateString)(properties.vpceConfigurationName)), errors.collect(cdk.propertyValidator("vpceServiceName", cdk.requiredValidator)(properties.vpceServiceName)), errors.collect(cdk.propertyValidator("vpceServiceName", cdk.validateString)(properties.vpceServiceName)), errors.wrap('supplied properties not correct for "CfnVPCEConfigurationProps"');
    }
    function cfnVPCEConfigurationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVPCEConfigurationPropsValidator(properties).assertSuccess(), { ServiceDnsName: cdk.stringToCloudFormation(properties.serviceDnsName), VpceConfigurationName: cdk.stringToCloudFormation(properties.vpceConfigurationName), VpceServiceName: cdk.stringToCloudFormation(properties.vpceServiceName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VpceConfigurationDescription: cdk.stringToCloudFormation(properties.vpceConfigurationDescription) }) : properties;
    }
    function CfnVPCEConfigurationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("serviceDnsName", "ServiceDnsName", cfn_parse.FromCloudFormation.getString(properties.ServiceDnsName)), ret.addPropertyResult("vpceConfigurationName", "VpceConfigurationName", cfn_parse.FromCloudFormation.getString(properties.VpceConfigurationName)), ret.addPropertyResult("vpceServiceName", "VpceServiceName", cfn_parse.FromCloudFormation.getString(properties.VpceServiceName)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("vpceConfigurationDescription", "VpceConfigurationDescription", properties.VpceConfigurationDescription != null ? cfn_parse.FromCloudFormation.getString(properties.VpceConfigurationDescription) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVPCEConfiguration = class _CfnVPCEConfiguration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVPCEConfigurationPropsFromCloudFormation(resourceProperties), ret = new _CfnVPCEConfiguration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVPCEConfiguration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_devicefarm_CfnVPCEConfigurationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVPCEConfiguration), error;
        }
        cdk.requireProperty(props, "serviceDnsName", this), cdk.requireProperty(props, "vpceConfigurationName", this), cdk.requireProperty(props, "vpceServiceName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.serviceDnsName = props.serviceDnsName, this.vpceConfigurationName = props.vpceConfigurationName, this.vpceServiceName = props.vpceServiceName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DeviceFarm::VPCEConfiguration", props.tags, { tagPropertyName: "tags" }), this.vpceConfigurationDescription = props.vpceConfigurationDescription;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVPCEConfiguration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { serviceDnsName: this.serviceDnsName, vpceConfigurationName: this.vpceConfigurationName, vpceServiceName: this.vpceServiceName, tags: this.tags.renderTags(), vpceConfigurationDescription: this.vpceConfigurationDescription };
      }
      renderProperties(props) {
        return cfnVPCEConfigurationPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnVPCEConfiguration[_f] = { fqn: "aws-cdk-lib.aws_devicefarm.CfnVPCEConfiguration", version: "2.80.0" }, CfnVPCEConfiguration.CFN_RESOURCE_TYPE_NAME = "AWS::DeviceFarm::VPCEConfiguration", exports2.CfnVPCEConfiguration = CfnVPCEConfiguration;
  }
});

// node_modules/aws-cdk-lib/aws-devicefarm/lib/index.js
var require_lib101 = __commonJS({
  "node_modules/aws-cdk-lib/aws-devicefarm/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_devicefarm_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-devicefarm/index.js
var require_aws_devicefarm = __commonJS({
  "node_modules/aws-cdk-lib/aws-devicefarm/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib101(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-devopsguru/lib/devopsguru.generated.js
var require_devopsguru_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-devopsguru/lib/devopsguru.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnResourceCollection = exports2.CfnNotificationChannel = exports2.CfnLogAnomalyDetectionIntegration = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    var CfnLogAnomalyDetectionIntegration = class _CfnLogAnomalyDetectionIntegration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const ret = new _CfnLogAnomalyDetectionIntegration(scope, id);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id) {
        super(scope, id, { type: _CfnLogAnomalyDetectionIntegration.CFN_RESOURCE_TYPE_NAME }), this.attrAccountId = cdk.Token.asString(this.getAtt("AccountId", cdk.ResolutionTypeHint.STRING));
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLogAnomalyDetectionIntegration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnLogAnomalyDetectionIntegration[_a] = { fqn: "aws-cdk-lib.aws_devopsguru.CfnLogAnomalyDetectionIntegration", version: "2.80.0" }, CfnLogAnomalyDetectionIntegration.CFN_RESOURCE_TYPE_NAME = "AWS::DevOpsGuru::LogAnomalyDetectionIntegration", exports2.CfnLogAnomalyDetectionIntegration = CfnLogAnomalyDetectionIntegration;
    function CfnNotificationChannelPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("config", cdk.requiredValidator)(properties.config)), errors.collect(cdk.propertyValidator("config", CfnNotificationChannel_NotificationChannelConfigPropertyValidator)(properties.config)), errors.wrap('supplied properties not correct for "CfnNotificationChannelProps"');
    }
    function cfnNotificationChannelPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNotificationChannelPropsValidator(properties).assertSuccess(), { Config: cfnNotificationChannelNotificationChannelConfigPropertyToCloudFormation(properties.config) }) : properties;
    }
    function CfnNotificationChannelPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("config", "Config", CfnNotificationChannelNotificationChannelConfigPropertyFromCloudFormation(properties.Config)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnNotificationChannel = class _CfnNotificationChannel extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnNotificationChannelPropsFromCloudFormation(resourceProperties), ret = new _CfnNotificationChannel(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnNotificationChannel.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_devopsguru_CfnNotificationChannelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnNotificationChannel), error;
        }
        cdk.requireProperty(props, "config", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.config = props.config;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnNotificationChannel.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { config: this.config };
      }
      renderProperties(props) {
        return cfnNotificationChannelPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnNotificationChannel[_b] = { fqn: "aws-cdk-lib.aws_devopsguru.CfnNotificationChannel", version: "2.80.0" }, CfnNotificationChannel.CFN_RESOURCE_TYPE_NAME = "AWS::DevOpsGuru::NotificationChannel", exports2.CfnNotificationChannel = CfnNotificationChannel;
    function CfnNotificationChannel_NotificationChannelConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("filters", CfnNotificationChannel_NotificationFilterConfigPropertyValidator)(properties.filters)), errors.collect(cdk.propertyValidator("sns", CfnNotificationChannel_SnsChannelConfigPropertyValidator)(properties.sns)), errors.wrap('supplied properties not correct for "NotificationChannelConfigProperty"');
    }
    function cfnNotificationChannelNotificationChannelConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNotificationChannel_NotificationChannelConfigPropertyValidator(properties).assertSuccess(), { Filters: cfnNotificationChannelNotificationFilterConfigPropertyToCloudFormation(properties.filters), Sns: cfnNotificationChannelSnsChannelConfigPropertyToCloudFormation(properties.sns) }) : properties;
    }
    function CfnNotificationChannelNotificationChannelConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("filters", "Filters", properties.Filters != null ? CfnNotificationChannelNotificationFilterConfigPropertyFromCloudFormation(properties.Filters) : void 0), ret.addPropertyResult("sns", "Sns", properties.Sns != null ? CfnNotificationChannelSnsChannelConfigPropertyFromCloudFormation(properties.Sns) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnNotificationChannel_NotificationFilterConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("messageTypes", cdk.listValidator(cdk.validateString))(properties.messageTypes)), errors.collect(cdk.propertyValidator("severities", cdk.listValidator(cdk.validateString))(properties.severities)), errors.wrap('supplied properties not correct for "NotificationFilterConfigProperty"');
    }
    function cfnNotificationChannelNotificationFilterConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNotificationChannel_NotificationFilterConfigPropertyValidator(properties).assertSuccess(), { MessageTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.messageTypes), Severities: cdk.listMapper(cdk.stringToCloudFormation)(properties.severities) }) : properties;
    }
    function CfnNotificationChannelNotificationFilterConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("messageTypes", "MessageTypes", properties.MessageTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.MessageTypes) : void 0), ret.addPropertyResult("severities", "Severities", properties.Severities != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Severities) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnNotificationChannel_SnsChannelConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("topicArn", cdk.validateString)(properties.topicArn)), errors.wrap('supplied properties not correct for "SnsChannelConfigProperty"');
    }
    function cfnNotificationChannelSnsChannelConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNotificationChannel_SnsChannelConfigPropertyValidator(properties).assertSuccess(), { TopicArn: cdk.stringToCloudFormation(properties.topicArn) }) : properties;
    }
    function CfnNotificationChannelSnsChannelConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("topicArn", "TopicArn", properties.TopicArn != null ? cfn_parse.FromCloudFormation.getString(properties.TopicArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourceCollectionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceCollectionFilter", cdk.requiredValidator)(properties.resourceCollectionFilter)), errors.collect(cdk.propertyValidator("resourceCollectionFilter", CfnResourceCollection_ResourceCollectionFilterPropertyValidator)(properties.resourceCollectionFilter)), errors.wrap('supplied properties not correct for "CfnResourceCollectionProps"');
    }
    function cfnResourceCollectionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceCollectionPropsValidator(properties).assertSuccess(), { ResourceCollectionFilter: cfnResourceCollectionResourceCollectionFilterPropertyToCloudFormation(properties.resourceCollectionFilter) }) : properties;
    }
    function CfnResourceCollectionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceCollectionFilter", "ResourceCollectionFilter", CfnResourceCollectionResourceCollectionFilterPropertyFromCloudFormation(properties.ResourceCollectionFilter)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResourceCollection = class _CfnResourceCollection extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResourceCollectionPropsFromCloudFormation(resourceProperties), ret = new _CfnResourceCollection(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnResourceCollection.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_devopsguru_CfnResourceCollectionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResourceCollection), error;
        }
        cdk.requireProperty(props, "resourceCollectionFilter", this), this.attrResourceCollectionType = cdk.Token.asString(this.getAtt("ResourceCollectionType", cdk.ResolutionTypeHint.STRING)), this.resourceCollectionFilter = props.resourceCollectionFilter;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResourceCollection.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { resourceCollectionFilter: this.resourceCollectionFilter };
      }
      renderProperties(props) {
        return cfnResourceCollectionPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnResourceCollection[_c] = { fqn: "aws-cdk-lib.aws_devopsguru.CfnResourceCollection", version: "2.80.0" }, CfnResourceCollection.CFN_RESOURCE_TYPE_NAME = "AWS::DevOpsGuru::ResourceCollection", exports2.CfnResourceCollection = CfnResourceCollection;
    function CfnResourceCollection_CloudFormationCollectionFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("stackNames", cdk.listValidator(cdk.validateString))(properties.stackNames)), errors.wrap('supplied properties not correct for "CloudFormationCollectionFilterProperty"');
    }
    function cfnResourceCollectionCloudFormationCollectionFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceCollection_CloudFormationCollectionFilterPropertyValidator(properties).assertSuccess(), { StackNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.stackNames) }) : properties;
    }
    function CfnResourceCollectionCloudFormationCollectionFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("stackNames", "StackNames", properties.StackNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.StackNames) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourceCollection_ResourceCollectionFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudFormation", CfnResourceCollection_CloudFormationCollectionFilterPropertyValidator)(properties.cloudFormation)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(CfnResourceCollection_TagCollectionPropertyValidator))(properties.tags)), errors.wrap('supplied properties not correct for "ResourceCollectionFilterProperty"');
    }
    function cfnResourceCollectionResourceCollectionFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceCollection_ResourceCollectionFilterPropertyValidator(properties).assertSuccess(), { CloudFormation: cfnResourceCollectionCloudFormationCollectionFilterPropertyToCloudFormation(properties.cloudFormation), Tags: cdk.listMapper(cfnResourceCollectionTagCollectionPropertyToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnResourceCollectionResourceCollectionFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudFormation", "CloudFormation", properties.CloudFormation != null ? CfnResourceCollectionCloudFormationCollectionFilterPropertyFromCloudFormation(properties.CloudFormation) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(CfnResourceCollectionTagCollectionPropertyFromCloudFormation)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourceCollection_TagCollectionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("appBoundaryKey", cdk.validateString)(properties.appBoundaryKey)), errors.collect(cdk.propertyValidator("tagValues", cdk.listValidator(cdk.validateString))(properties.tagValues)), errors.wrap('supplied properties not correct for "TagCollectionProperty"');
    }
    function cfnResourceCollectionTagCollectionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceCollection_TagCollectionPropertyValidator(properties).assertSuccess(), { AppBoundaryKey: cdk.stringToCloudFormation(properties.appBoundaryKey), TagValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.tagValues) }) : properties;
    }
    function CfnResourceCollectionTagCollectionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("appBoundaryKey", "AppBoundaryKey", properties.AppBoundaryKey != null ? cfn_parse.FromCloudFormation.getString(properties.AppBoundaryKey) : void 0), ret.addPropertyResult("tagValues", "TagValues", properties.TagValues != null ? cfn_parse.FromCloudFormation.getStringArray(properties.TagValues) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-devopsguru/lib/index.js
var require_lib102 = __commonJS({
  "node_modules/aws-cdk-lib/aws-devopsguru/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_devopsguru_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-devopsguru/index.js
var require_aws_devopsguru = __commonJS({
  "node_modules/aws-cdk-lib/aws-devopsguru/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib102(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-directoryservice/lib/directoryservice.generated.js
var require_directoryservice_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-directoryservice/lib/directoryservice.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnSimpleAD = exports2.CfnMicrosoftAD = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnMicrosoftADPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("createAlias", cdk.validateBoolean)(properties.createAlias)), errors.collect(cdk.propertyValidator("edition", cdk.validateString)(properties.edition)), errors.collect(cdk.propertyValidator("enableSso", cdk.validateBoolean)(properties.enableSso)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("password", cdk.requiredValidator)(properties.password)), errors.collect(cdk.propertyValidator("password", cdk.validateString)(properties.password)), errors.collect(cdk.propertyValidator("shortName", cdk.validateString)(properties.shortName)), errors.collect(cdk.propertyValidator("vpcSettings", cdk.requiredValidator)(properties.vpcSettings)), errors.collect(cdk.propertyValidator("vpcSettings", CfnMicrosoftAD_VpcSettingsPropertyValidator)(properties.vpcSettings)), errors.wrap('supplied properties not correct for "CfnMicrosoftADProps"');
    }
    function cfnMicrosoftADPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMicrosoftADPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Password: cdk.stringToCloudFormation(properties.password), VpcSettings: cfnMicrosoftADVpcSettingsPropertyToCloudFormation(properties.vpcSettings), CreateAlias: cdk.booleanToCloudFormation(properties.createAlias), Edition: cdk.stringToCloudFormation(properties.edition), EnableSso: cdk.booleanToCloudFormation(properties.enableSso), ShortName: cdk.stringToCloudFormation(properties.shortName) }) : properties;
    }
    function CfnMicrosoftADPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("password", "Password", cfn_parse.FromCloudFormation.getString(properties.Password)), ret.addPropertyResult("vpcSettings", "VpcSettings", CfnMicrosoftADVpcSettingsPropertyFromCloudFormation(properties.VpcSettings)), ret.addPropertyResult("createAlias", "CreateAlias", properties.CreateAlias != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CreateAlias) : void 0), ret.addPropertyResult("edition", "Edition", properties.Edition != null ? cfn_parse.FromCloudFormation.getString(properties.Edition) : void 0), ret.addPropertyResult("enableSso", "EnableSso", properties.EnableSso != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableSso) : void 0), ret.addPropertyResult("shortName", "ShortName", properties.ShortName != null ? cfn_parse.FromCloudFormation.getString(properties.ShortName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnMicrosoftAD = class _CfnMicrosoftAD extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnMicrosoftADPropsFromCloudFormation(resourceProperties), ret = new _CfnMicrosoftAD(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnMicrosoftAD.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_directoryservice_CfnMicrosoftADProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnMicrosoftAD), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "password", this), cdk.requireProperty(props, "vpcSettings", this), this.attrAlias = cdk.Token.asString(this.getAtt("Alias", cdk.ResolutionTypeHint.STRING)), this.attrDnsIpAddresses = cdk.Token.asList(this.getAtt("DnsIpAddresses", cdk.ResolutionTypeHint.STRING_LIST)), this.name = props.name, this.password = props.password, this.vpcSettings = props.vpcSettings, this.createAlias = props.createAlias, this.edition = props.edition, this.enableSso = props.enableSso, this.shortName = props.shortName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnMicrosoftAD.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, password: this.password, vpcSettings: this.vpcSettings, createAlias: this.createAlias, edition: this.edition, enableSso: this.enableSso, shortName: this.shortName };
      }
      renderProperties(props) {
        return cfnMicrosoftADPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnMicrosoftAD[_a] = { fqn: "aws-cdk-lib.aws_directoryservice.CfnMicrosoftAD", version: "2.80.0" }, CfnMicrosoftAD.CFN_RESOURCE_TYPE_NAME = "AWS::DirectoryService::MicrosoftAD", exports2.CfnMicrosoftAD = CfnMicrosoftAD;
    function CfnMicrosoftAD_VpcSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("subnetIds", cdk.requiredValidator)(properties.subnetIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.collect(cdk.propertyValidator("vpcId", cdk.requiredValidator)(properties.vpcId)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "VpcSettingsProperty"');
    }
    function cfnMicrosoftADVpcSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMicrosoftAD_VpcSettingsPropertyValidator(properties).assertSuccess(), { SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds), VpcId: cdk.stringToCloudFormation(properties.vpcId) }) : properties;
    }
    function CfnMicrosoftADVpcSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("subnetIds", "SubnetIds", cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds)), ret.addPropertyResult("vpcId", "VpcId", cfn_parse.FromCloudFormation.getString(properties.VpcId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSimpleADPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("createAlias", cdk.validateBoolean)(properties.createAlias)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("enableSso", cdk.validateBoolean)(properties.enableSso)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("password", cdk.validateString)(properties.password)), errors.collect(cdk.propertyValidator("shortName", cdk.validateString)(properties.shortName)), errors.collect(cdk.propertyValidator("size", cdk.requiredValidator)(properties.size)), errors.collect(cdk.propertyValidator("size", cdk.validateString)(properties.size)), errors.collect(cdk.propertyValidator("vpcSettings", cdk.requiredValidator)(properties.vpcSettings)), errors.collect(cdk.propertyValidator("vpcSettings", CfnSimpleAD_VpcSettingsPropertyValidator)(properties.vpcSettings)), errors.wrap('supplied properties not correct for "CfnSimpleADProps"');
    }
    function cfnSimpleADPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSimpleADPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Size: cdk.stringToCloudFormation(properties.size), VpcSettings: cfnSimpleADVpcSettingsPropertyToCloudFormation(properties.vpcSettings), CreateAlias: cdk.booleanToCloudFormation(properties.createAlias), Description: cdk.stringToCloudFormation(properties.description), EnableSso: cdk.booleanToCloudFormation(properties.enableSso), Password: cdk.stringToCloudFormation(properties.password), ShortName: cdk.stringToCloudFormation(properties.shortName) }) : properties;
    }
    function CfnSimpleADPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("size", "Size", cfn_parse.FromCloudFormation.getString(properties.Size)), ret.addPropertyResult("vpcSettings", "VpcSettings", CfnSimpleADVpcSettingsPropertyFromCloudFormation(properties.VpcSettings)), ret.addPropertyResult("createAlias", "CreateAlias", properties.CreateAlias != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CreateAlias) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("enableSso", "EnableSso", properties.EnableSso != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableSso) : void 0), ret.addPropertyResult("password", "Password", properties.Password != null ? cfn_parse.FromCloudFormation.getString(properties.Password) : void 0), ret.addPropertyResult("shortName", "ShortName", properties.ShortName != null ? cfn_parse.FromCloudFormation.getString(properties.ShortName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSimpleAD = class _CfnSimpleAD extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSimpleADPropsFromCloudFormation(resourceProperties), ret = new _CfnSimpleAD(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSimpleAD.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_directoryservice_CfnSimpleADProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSimpleAD), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "size", this), cdk.requireProperty(props, "vpcSettings", this), this.attrAlias = cdk.Token.asString(this.getAtt("Alias", cdk.ResolutionTypeHint.STRING)), this.attrDirectoryId = cdk.Token.asString(this.getAtt("DirectoryId", cdk.ResolutionTypeHint.STRING)), this.attrDnsIpAddresses = cdk.Token.asList(this.getAtt("DnsIpAddresses", cdk.ResolutionTypeHint.STRING_LIST)), this.name = props.name, this.size = props.size, this.vpcSettings = props.vpcSettings, this.createAlias = props.createAlias, this.description = props.description, this.enableSso = props.enableSso, this.password = props.password, this.shortName = props.shortName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSimpleAD.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, size: this.size, vpcSettings: this.vpcSettings, createAlias: this.createAlias, description: this.description, enableSso: this.enableSso, password: this.password, shortName: this.shortName };
      }
      renderProperties(props) {
        return cfnSimpleADPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnSimpleAD[_b] = { fqn: "aws-cdk-lib.aws_directoryservice.CfnSimpleAD", version: "2.80.0" }, CfnSimpleAD.CFN_RESOURCE_TYPE_NAME = "AWS::DirectoryService::SimpleAD", exports2.CfnSimpleAD = CfnSimpleAD;
    function CfnSimpleAD_VpcSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("subnetIds", cdk.requiredValidator)(properties.subnetIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.collect(cdk.propertyValidator("vpcId", cdk.requiredValidator)(properties.vpcId)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "VpcSettingsProperty"');
    }
    function cfnSimpleADVpcSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSimpleAD_VpcSettingsPropertyValidator(properties).assertSuccess(), { SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds), VpcId: cdk.stringToCloudFormation(properties.vpcId) }) : properties;
    }
    function CfnSimpleADVpcSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("subnetIds", "SubnetIds", cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds)), ret.addPropertyResult("vpcId", "VpcId", cfn_parse.FromCloudFormation.getString(properties.VpcId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-directoryservice/lib/index.js
var require_lib103 = __commonJS({
  "node_modules/aws-cdk-lib/aws-directoryservice/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_directoryservice_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-directoryservice/index.js
var require_aws_directoryservice = __commonJS({
  "node_modules/aws-cdk-lib/aws-directoryservice/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib103(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-dlm/lib/dlm.generated.js
var require_dlm_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-dlm/lib/dlm.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnLifecyclePolicy = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnLifecyclePolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("executionRoleArn", cdk.validateString)(properties.executionRoleArn)), errors.collect(cdk.propertyValidator("policyDetails", CfnLifecyclePolicy_PolicyDetailsPropertyValidator)(properties.policyDetails)), errors.collect(cdk.propertyValidator("state", cdk.validateString)(properties.state)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnLifecyclePolicyProps"');
    }
    function cfnLifecyclePolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLifecyclePolicyPropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), ExecutionRoleArn: cdk.stringToCloudFormation(properties.executionRoleArn), PolicyDetails: cfnLifecyclePolicyPolicyDetailsPropertyToCloudFormation(properties.policyDetails), State: cdk.stringToCloudFormation(properties.state), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnLifecyclePolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("executionRoleArn", "ExecutionRoleArn", properties.ExecutionRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.ExecutionRoleArn) : void 0), ret.addPropertyResult("policyDetails", "PolicyDetails", properties.PolicyDetails != null ? CfnLifecyclePolicyPolicyDetailsPropertyFromCloudFormation(properties.PolicyDetails) : void 0), ret.addPropertyResult("state", "State", properties.State != null ? cfn_parse.FromCloudFormation.getString(properties.State) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLifecyclePolicy = class _CfnLifecyclePolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLifecyclePolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnLifecyclePolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnLifecyclePolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_dlm_CfnLifecyclePolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLifecyclePolicy), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.description = props.description, this.executionRoleArn = props.executionRoleArn, this.policyDetails = props.policyDetails, this.state = props.state, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DLM::LifecyclePolicy", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLifecyclePolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, executionRoleArn: this.executionRoleArn, policyDetails: this.policyDetails, state: this.state, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnLifecyclePolicyPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnLifecyclePolicy[_a] = { fqn: "aws-cdk-lib.aws_dlm.CfnLifecyclePolicy", version: "2.80.0" }, CfnLifecyclePolicy.CFN_RESOURCE_TYPE_NAME = "AWS::DLM::LifecyclePolicy", exports2.CfnLifecyclePolicy = CfnLifecyclePolicy;
    function CfnLifecyclePolicy_ActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("crossRegionCopy", cdk.requiredValidator)(properties.crossRegionCopy)), errors.collect(cdk.propertyValidator("crossRegionCopy", cdk.listValidator(CfnLifecyclePolicy_CrossRegionCopyActionPropertyValidator))(properties.crossRegionCopy)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "ActionProperty"');
    }
    function cfnLifecyclePolicyActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLifecyclePolicy_ActionPropertyValidator(properties).assertSuccess(), { CrossRegionCopy: cdk.listMapper(cfnLifecyclePolicyCrossRegionCopyActionPropertyToCloudFormation)(properties.crossRegionCopy), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnLifecyclePolicyActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("crossRegionCopy", "CrossRegionCopy", cfn_parse.FromCloudFormation.getArray(CfnLifecyclePolicyCrossRegionCopyActionPropertyFromCloudFormation)(properties.CrossRegionCopy)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLifecyclePolicy_ArchiveRetainRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("retentionArchiveTier", cdk.requiredValidator)(properties.retentionArchiveTier)), errors.collect(cdk.propertyValidator("retentionArchiveTier", CfnLifecyclePolicy_RetentionArchiveTierPropertyValidator)(properties.retentionArchiveTier)), errors.wrap('supplied properties not correct for "ArchiveRetainRuleProperty"');
    }
    function cfnLifecyclePolicyArchiveRetainRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLifecyclePolicy_ArchiveRetainRulePropertyValidator(properties).assertSuccess(), { RetentionArchiveTier: cfnLifecyclePolicyRetentionArchiveTierPropertyToCloudFormation(properties.retentionArchiveTier) }) : properties;
    }
    function CfnLifecyclePolicyArchiveRetainRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("retentionArchiveTier", "RetentionArchiveTier", CfnLifecyclePolicyRetentionArchiveTierPropertyFromCloudFormation(properties.RetentionArchiveTier)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLifecyclePolicy_ArchiveRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("retainRule", cdk.requiredValidator)(properties.retainRule)), errors.collect(cdk.propertyValidator("retainRule", CfnLifecyclePolicy_ArchiveRetainRulePropertyValidator)(properties.retainRule)), errors.wrap('supplied properties not correct for "ArchiveRuleProperty"');
    }
    function cfnLifecyclePolicyArchiveRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLifecyclePolicy_ArchiveRulePropertyValidator(properties).assertSuccess(), { RetainRule: cfnLifecyclePolicyArchiveRetainRulePropertyToCloudFormation(properties.retainRule) }) : properties;
    }
    function CfnLifecyclePolicyArchiveRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("retainRule", "RetainRule", CfnLifecyclePolicyArchiveRetainRulePropertyFromCloudFormation(properties.RetainRule)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLifecyclePolicy_CreateRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cronExpression", cdk.validateString)(properties.cronExpression)), errors.collect(cdk.propertyValidator("interval", cdk.validateNumber)(properties.interval)), errors.collect(cdk.propertyValidator("intervalUnit", cdk.validateString)(properties.intervalUnit)), errors.collect(cdk.propertyValidator("location", cdk.validateString)(properties.location)), errors.collect(cdk.propertyValidator("times", cdk.listValidator(cdk.validateString))(properties.times)), errors.wrap('supplied properties not correct for "CreateRuleProperty"');
    }
    function cfnLifecyclePolicyCreateRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLifecyclePolicy_CreateRulePropertyValidator(properties).assertSuccess(), { CronExpression: cdk.stringToCloudFormation(properties.cronExpression), Interval: cdk.numberToCloudFormation(properties.interval), IntervalUnit: cdk.stringToCloudFormation(properties.intervalUnit), Location: cdk.stringToCloudFormation(properties.location), Times: cdk.listMapper(cdk.stringToCloudFormation)(properties.times) }) : properties;
    }
    function CfnLifecyclePolicyCreateRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cronExpression", "CronExpression", properties.CronExpression != null ? cfn_parse.FromCloudFormation.getString(properties.CronExpression) : void 0), ret.addPropertyResult("interval", "Interval", properties.Interval != null ? cfn_parse.FromCloudFormation.getNumber(properties.Interval) : void 0), ret.addPropertyResult("intervalUnit", "IntervalUnit", properties.IntervalUnit != null ? cfn_parse.FromCloudFormation.getString(properties.IntervalUnit) : void 0), ret.addPropertyResult("location", "Location", properties.Location != null ? cfn_parse.FromCloudFormation.getString(properties.Location) : void 0), ret.addPropertyResult("times", "Times", properties.Times != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Times) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLifecyclePolicy_CrossRegionCopyActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("encryptionConfiguration", cdk.requiredValidator)(properties.encryptionConfiguration)), errors.collect(cdk.propertyValidator("encryptionConfiguration", CfnLifecyclePolicy_EncryptionConfigurationPropertyValidator)(properties.encryptionConfiguration)), errors.collect(cdk.propertyValidator("retainRule", CfnLifecyclePolicy_CrossRegionCopyRetainRulePropertyValidator)(properties.retainRule)), errors.collect(cdk.propertyValidator("target", cdk.requiredValidator)(properties.target)), errors.collect(cdk.propertyValidator("target", cdk.validateString)(properties.target)), errors.wrap('supplied properties not correct for "CrossRegionCopyActionProperty"');
    }
    function cfnLifecyclePolicyCrossRegionCopyActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLifecyclePolicy_CrossRegionCopyActionPropertyValidator(properties).assertSuccess(), { EncryptionConfiguration: cfnLifecyclePolicyEncryptionConfigurationPropertyToCloudFormation(properties.encryptionConfiguration), RetainRule: cfnLifecyclePolicyCrossRegionCopyRetainRulePropertyToCloudFormation(properties.retainRule), Target: cdk.stringToCloudFormation(properties.target) }) : properties;
    }
    function CfnLifecyclePolicyCrossRegionCopyActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("encryptionConfiguration", "EncryptionConfiguration", CfnLifecyclePolicyEncryptionConfigurationPropertyFromCloudFormation(properties.EncryptionConfiguration)), ret.addPropertyResult("retainRule", "RetainRule", properties.RetainRule != null ? CfnLifecyclePolicyCrossRegionCopyRetainRulePropertyFromCloudFormation(properties.RetainRule) : void 0), ret.addPropertyResult("target", "Target", cfn_parse.FromCloudFormation.getString(properties.Target)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLifecyclePolicy_CrossRegionCopyDeprecateRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("interval", cdk.requiredValidator)(properties.interval)), errors.collect(cdk.propertyValidator("interval", cdk.validateNumber)(properties.interval)), errors.collect(cdk.propertyValidator("intervalUnit", cdk.requiredValidator)(properties.intervalUnit)), errors.collect(cdk.propertyValidator("intervalUnit", cdk.validateString)(properties.intervalUnit)), errors.wrap('supplied properties not correct for "CrossRegionCopyDeprecateRuleProperty"');
    }
    function cfnLifecyclePolicyCrossRegionCopyDeprecateRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLifecyclePolicy_CrossRegionCopyDeprecateRulePropertyValidator(properties).assertSuccess(), { Interval: cdk.numberToCloudFormation(properties.interval), IntervalUnit: cdk.stringToCloudFormation(properties.intervalUnit) }) : properties;
    }
    function CfnLifecyclePolicyCrossRegionCopyDeprecateRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("interval", "Interval", cfn_parse.FromCloudFormation.getNumber(properties.Interval)), ret.addPropertyResult("intervalUnit", "IntervalUnit", cfn_parse.FromCloudFormation.getString(properties.IntervalUnit)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLifecyclePolicy_CrossRegionCopyRetainRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("interval", cdk.requiredValidator)(properties.interval)), errors.collect(cdk.propertyValidator("interval", cdk.validateNumber)(properties.interval)), errors.collect(cdk.propertyValidator("intervalUnit", cdk.requiredValidator)(properties.intervalUnit)), errors.collect(cdk.propertyValidator("intervalUnit", cdk.validateString)(properties.intervalUnit)), errors.wrap('supplied properties not correct for "CrossRegionCopyRetainRuleProperty"');
    }
    function cfnLifecyclePolicyCrossRegionCopyRetainRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLifecyclePolicy_CrossRegionCopyRetainRulePropertyValidator(properties).assertSuccess(), { Interval: cdk.numberToCloudFormation(properties.interval), IntervalUnit: cdk.stringToCloudFormation(properties.intervalUnit) }) : properties;
    }
    function CfnLifecyclePolicyCrossRegionCopyRetainRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("interval", "Interval", cfn_parse.FromCloudFormation.getNumber(properties.Interval)), ret.addPropertyResult("intervalUnit", "IntervalUnit", cfn_parse.FromCloudFormation.getString(properties.IntervalUnit)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLifecyclePolicy_CrossRegionCopyRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cmkArn", cdk.validateString)(properties.cmkArn)), errors.collect(cdk.propertyValidator("copyTags", cdk.validateBoolean)(properties.copyTags)), errors.collect(cdk.propertyValidator("deprecateRule", CfnLifecyclePolicy_CrossRegionCopyDeprecateRulePropertyValidator)(properties.deprecateRule)), errors.collect(cdk.propertyValidator("encrypted", cdk.requiredValidator)(properties.encrypted)), errors.collect(cdk.propertyValidator("encrypted", cdk.validateBoolean)(properties.encrypted)), errors.collect(cdk.propertyValidator("retainRule", CfnLifecyclePolicy_CrossRegionCopyRetainRulePropertyValidator)(properties.retainRule)), errors.collect(cdk.propertyValidator("target", cdk.validateString)(properties.target)), errors.collect(cdk.propertyValidator("targetRegion", cdk.validateString)(properties.targetRegion)), errors.wrap('supplied properties not correct for "CrossRegionCopyRuleProperty"');
    }
    function cfnLifecyclePolicyCrossRegionCopyRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLifecyclePolicy_CrossRegionCopyRulePropertyValidator(properties).assertSuccess(), { CmkArn: cdk.stringToCloudFormation(properties.cmkArn), CopyTags: cdk.booleanToCloudFormation(properties.copyTags), DeprecateRule: cfnLifecyclePolicyCrossRegionCopyDeprecateRulePropertyToCloudFormation(properties.deprecateRule), Encrypted: cdk.booleanToCloudFormation(properties.encrypted), RetainRule: cfnLifecyclePolicyCrossRegionCopyRetainRulePropertyToCloudFormation(properties.retainRule), Target: cdk.stringToCloudFormation(properties.target), TargetRegion: cdk.stringToCloudFormation(properties.targetRegion) }) : properties;
    }
    function CfnLifecyclePolicyCrossRegionCopyRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cmkArn", "CmkArn", properties.CmkArn != null ? cfn_parse.FromCloudFormation.getString(properties.CmkArn) : void 0), ret.addPropertyResult("copyTags", "CopyTags", properties.CopyTags != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CopyTags) : void 0), ret.addPropertyResult("deprecateRule", "DeprecateRule", properties.DeprecateRule != null ? CfnLifecyclePolicyCrossRegionCopyDeprecateRulePropertyFromCloudFormation(properties.DeprecateRule) : void 0), ret.addPropertyResult("encrypted", "Encrypted", cfn_parse.FromCloudFormation.getBoolean(properties.Encrypted)), ret.addPropertyResult("retainRule", "RetainRule", properties.RetainRule != null ? CfnLifecyclePolicyCrossRegionCopyRetainRulePropertyFromCloudFormation(properties.RetainRule) : void 0), ret.addPropertyResult("target", "Target", properties.Target != null ? cfn_parse.FromCloudFormation.getString(properties.Target) : void 0), ret.addPropertyResult("targetRegion", "TargetRegion", properties.TargetRegion != null ? cfn_parse.FromCloudFormation.getString(properties.TargetRegion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLifecyclePolicy_DeprecateRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("count", cdk.validateNumber)(properties.count)), errors.collect(cdk.propertyValidator("interval", cdk.validateNumber)(properties.interval)), errors.collect(cdk.propertyValidator("intervalUnit", cdk.validateString)(properties.intervalUnit)), errors.wrap('supplied properties not correct for "DeprecateRuleProperty"');
    }
    function cfnLifecyclePolicyDeprecateRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLifecyclePolicy_DeprecateRulePropertyValidator(properties).assertSuccess(), { Count: cdk.numberToCloudFormation(properties.count), Interval: cdk.numberToCloudFormation(properties.interval), IntervalUnit: cdk.stringToCloudFormation(properties.intervalUnit) }) : properties;
    }
    function CfnLifecyclePolicyDeprecateRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("count", "Count", properties.Count != null ? cfn_parse.FromCloudFormation.getNumber(properties.Count) : void 0), ret.addPropertyResult("interval", "Interval", properties.Interval != null ? cfn_parse.FromCloudFormation.getNumber(properties.Interval) : void 0), ret.addPropertyResult("intervalUnit", "IntervalUnit", properties.IntervalUnit != null ? cfn_parse.FromCloudFormation.getString(properties.IntervalUnit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLifecyclePolicy_EncryptionConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cmkArn", cdk.validateString)(properties.cmkArn)), errors.collect(cdk.propertyValidator("encrypted", cdk.requiredValidator)(properties.encrypted)), errors.collect(cdk.propertyValidator("encrypted", cdk.validateBoolean)(properties.encrypted)), errors.wrap('supplied properties not correct for "EncryptionConfigurationProperty"');
    }
    function cfnLifecyclePolicyEncryptionConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLifecyclePolicy_EncryptionConfigurationPropertyValidator(properties).assertSuccess(), { CmkArn: cdk.stringToCloudFormation(properties.cmkArn), Encrypted: cdk.booleanToCloudFormation(properties.encrypted) }) : properties;
    }
    function CfnLifecyclePolicyEncryptionConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cmkArn", "CmkArn", properties.CmkArn != null ? cfn_parse.FromCloudFormation.getString(properties.CmkArn) : void 0), ret.addPropertyResult("encrypted", "Encrypted", cfn_parse.FromCloudFormation.getBoolean(properties.Encrypted)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLifecyclePolicy_EventParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("descriptionRegex", cdk.validateString)(properties.descriptionRegex)), errors.collect(cdk.propertyValidator("eventType", cdk.requiredValidator)(properties.eventType)), errors.collect(cdk.propertyValidator("eventType", cdk.validateString)(properties.eventType)), errors.collect(cdk.propertyValidator("snapshotOwner", cdk.requiredValidator)(properties.snapshotOwner)), errors.collect(cdk.propertyValidator("snapshotOwner", cdk.listValidator(cdk.validateString))(properties.snapshotOwner)), errors.wrap('supplied properties not correct for "EventParametersProperty"');
    }
    function cfnLifecyclePolicyEventParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLifecyclePolicy_EventParametersPropertyValidator(properties).assertSuccess(), { DescriptionRegex: cdk.stringToCloudFormation(properties.descriptionRegex), EventType: cdk.stringToCloudFormation(properties.eventType), SnapshotOwner: cdk.listMapper(cdk.stringToCloudFormation)(properties.snapshotOwner) }) : properties;
    }
    function CfnLifecyclePolicyEventParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("descriptionRegex", "DescriptionRegex", properties.DescriptionRegex != null ? cfn_parse.FromCloudFormation.getString(properties.DescriptionRegex) : void 0), ret.addPropertyResult("eventType", "EventType", cfn_parse.FromCloudFormation.getString(properties.EventType)), ret.addPropertyResult("snapshotOwner", "SnapshotOwner", cfn_parse.FromCloudFormation.getStringArray(properties.SnapshotOwner)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLifecyclePolicy_EventSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("parameters", CfnLifecyclePolicy_EventParametersPropertyValidator)(properties.parameters)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "EventSourceProperty"');
    }
    function cfnLifecyclePolicyEventSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLifecyclePolicy_EventSourcePropertyValidator(properties).assertSuccess(), { Parameters: cfnLifecyclePolicyEventParametersPropertyToCloudFormation(properties.parameters), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnLifecyclePolicyEventSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? CfnLifecyclePolicyEventParametersPropertyFromCloudFormation(properties.Parameters) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLifecyclePolicy_FastRestoreRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availabilityZones", cdk.listValidator(cdk.validateString))(properties.availabilityZones)), errors.collect(cdk.propertyValidator("count", cdk.validateNumber)(properties.count)), errors.collect(cdk.propertyValidator("interval", cdk.validateNumber)(properties.interval)), errors.collect(cdk.propertyValidator("intervalUnit", cdk.validateString)(properties.intervalUnit)), errors.wrap('supplied properties not correct for "FastRestoreRuleProperty"');
    }
    function cfnLifecyclePolicyFastRestoreRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLifecyclePolicy_FastRestoreRulePropertyValidator(properties).assertSuccess(), { AvailabilityZones: cdk.listMapper(cdk.stringToCloudFormation)(properties.availabilityZones), Count: cdk.numberToCloudFormation(properties.count), Interval: cdk.numberToCloudFormation(properties.interval), IntervalUnit: cdk.stringToCloudFormation(properties.intervalUnit) }) : properties;
    }
    function CfnLifecyclePolicyFastRestoreRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("availabilityZones", "AvailabilityZones", properties.AvailabilityZones != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AvailabilityZones) : void 0), ret.addPropertyResult("count", "Count", properties.Count != null ? cfn_parse.FromCloudFormation.getNumber(properties.Count) : void 0), ret.addPropertyResult("interval", "Interval", properties.Interval != null ? cfn_parse.FromCloudFormation.getNumber(properties.Interval) : void 0), ret.addPropertyResult("intervalUnit", "IntervalUnit", properties.IntervalUnit != null ? cfn_parse.FromCloudFormation.getString(properties.IntervalUnit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLifecyclePolicy_ParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("excludeBootVolume", cdk.validateBoolean)(properties.excludeBootVolume)), errors.collect(cdk.propertyValidator("excludeDataVolumeTags", cdk.listValidator(cdk.validateCfnTag))(properties.excludeDataVolumeTags)), errors.collect(cdk.propertyValidator("noReboot", cdk.validateBoolean)(properties.noReboot)), errors.wrap('supplied properties not correct for "ParametersProperty"');
    }
    function cfnLifecyclePolicyParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLifecyclePolicy_ParametersPropertyValidator(properties).assertSuccess(), { ExcludeBootVolume: cdk.booleanToCloudFormation(properties.excludeBootVolume), ExcludeDataVolumeTags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.excludeDataVolumeTags), NoReboot: cdk.booleanToCloudFormation(properties.noReboot) }) : properties;
    }
    function CfnLifecyclePolicyParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("excludeBootVolume", "ExcludeBootVolume", properties.ExcludeBootVolume != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ExcludeBootVolume) : void 0), ret.addPropertyResult("excludeDataVolumeTags", "ExcludeDataVolumeTags", properties.ExcludeDataVolumeTags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.ExcludeDataVolumeTags) : void 0), ret.addPropertyResult("noReboot", "NoReboot", properties.NoReboot != null ? cfn_parse.FromCloudFormation.getBoolean(properties.NoReboot) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLifecyclePolicy_PolicyDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnLifecyclePolicy_ActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("eventSource", CfnLifecyclePolicy_EventSourcePropertyValidator)(properties.eventSource)), errors.collect(cdk.propertyValidator("parameters", CfnLifecyclePolicy_ParametersPropertyValidator)(properties.parameters)), errors.collect(cdk.propertyValidator("policyType", cdk.validateString)(properties.policyType)), errors.collect(cdk.propertyValidator("resourceLocations", cdk.listValidator(cdk.validateString))(properties.resourceLocations)), errors.collect(cdk.propertyValidator("resourceTypes", cdk.listValidator(cdk.validateString))(properties.resourceTypes)), errors.collect(cdk.propertyValidator("schedules", cdk.listValidator(CfnLifecyclePolicy_SchedulePropertyValidator))(properties.schedules)), errors.collect(cdk.propertyValidator("targetTags", cdk.listValidator(cdk.validateCfnTag))(properties.targetTags)), errors.wrap('supplied properties not correct for "PolicyDetailsProperty"');
    }
    function cfnLifecyclePolicyPolicyDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLifecyclePolicy_PolicyDetailsPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnLifecyclePolicyActionPropertyToCloudFormation)(properties.actions), EventSource: cfnLifecyclePolicyEventSourcePropertyToCloudFormation(properties.eventSource), Parameters: cfnLifecyclePolicyParametersPropertyToCloudFormation(properties.parameters), PolicyType: cdk.stringToCloudFormation(properties.policyType), ResourceLocations: cdk.listMapper(cdk.stringToCloudFormation)(properties.resourceLocations), ResourceTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.resourceTypes), Schedules: cdk.listMapper(cfnLifecyclePolicySchedulePropertyToCloudFormation)(properties.schedules), TargetTags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.targetTags) }) : properties;
    }
    function CfnLifecyclePolicyPolicyDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnLifecyclePolicyActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("eventSource", "EventSource", properties.EventSource != null ? CfnLifecyclePolicyEventSourcePropertyFromCloudFormation(properties.EventSource) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? CfnLifecyclePolicyParametersPropertyFromCloudFormation(properties.Parameters) : void 0), ret.addPropertyResult("policyType", "PolicyType", properties.PolicyType != null ? cfn_parse.FromCloudFormation.getString(properties.PolicyType) : void 0), ret.addPropertyResult("resourceLocations", "ResourceLocations", properties.ResourceLocations != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ResourceLocations) : void 0), ret.addPropertyResult("resourceTypes", "ResourceTypes", properties.ResourceTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ResourceTypes) : void 0), ret.addPropertyResult("schedules", "Schedules", properties.Schedules != null ? cfn_parse.FromCloudFormation.getArray(CfnLifecyclePolicySchedulePropertyFromCloudFormation)(properties.Schedules) : void 0), ret.addPropertyResult("targetTags", "TargetTags", properties.TargetTags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.TargetTags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLifecyclePolicy_RetainRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("count", cdk.validateNumber)(properties.count)), errors.collect(cdk.propertyValidator("interval", cdk.validateNumber)(properties.interval)), errors.collect(cdk.propertyValidator("intervalUnit", cdk.validateString)(properties.intervalUnit)), errors.wrap('supplied properties not correct for "RetainRuleProperty"');
    }
    function cfnLifecyclePolicyRetainRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLifecyclePolicy_RetainRulePropertyValidator(properties).assertSuccess(), { Count: cdk.numberToCloudFormation(properties.count), Interval: cdk.numberToCloudFormation(properties.interval), IntervalUnit: cdk.stringToCloudFormation(properties.intervalUnit) }) : properties;
    }
    function CfnLifecyclePolicyRetainRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("count", "Count", properties.Count != null ? cfn_parse.FromCloudFormation.getNumber(properties.Count) : void 0), ret.addPropertyResult("interval", "Interval", properties.Interval != null ? cfn_parse.FromCloudFormation.getNumber(properties.Interval) : void 0), ret.addPropertyResult("intervalUnit", "IntervalUnit", properties.IntervalUnit != null ? cfn_parse.FromCloudFormation.getString(properties.IntervalUnit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLifecyclePolicy_RetentionArchiveTierPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("count", cdk.validateNumber)(properties.count)), errors.collect(cdk.propertyValidator("interval", cdk.validateNumber)(properties.interval)), errors.collect(cdk.propertyValidator("intervalUnit", cdk.validateString)(properties.intervalUnit)), errors.wrap('supplied properties not correct for "RetentionArchiveTierProperty"');
    }
    function cfnLifecyclePolicyRetentionArchiveTierPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLifecyclePolicy_RetentionArchiveTierPropertyValidator(properties).assertSuccess(), { Count: cdk.numberToCloudFormation(properties.count), Interval: cdk.numberToCloudFormation(properties.interval), IntervalUnit: cdk.stringToCloudFormation(properties.intervalUnit) }) : properties;
    }
    function CfnLifecyclePolicyRetentionArchiveTierPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("count", "Count", properties.Count != null ? cfn_parse.FromCloudFormation.getNumber(properties.Count) : void 0), ret.addPropertyResult("interval", "Interval", properties.Interval != null ? cfn_parse.FromCloudFormation.getNumber(properties.Interval) : void 0), ret.addPropertyResult("intervalUnit", "IntervalUnit", properties.IntervalUnit != null ? cfn_parse.FromCloudFormation.getString(properties.IntervalUnit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLifecyclePolicy_SchedulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("archiveRule", CfnLifecyclePolicy_ArchiveRulePropertyValidator)(properties.archiveRule)), errors.collect(cdk.propertyValidator("copyTags", cdk.validateBoolean)(properties.copyTags)), errors.collect(cdk.propertyValidator("createRule", CfnLifecyclePolicy_CreateRulePropertyValidator)(properties.createRule)), errors.collect(cdk.propertyValidator("crossRegionCopyRules", cdk.listValidator(CfnLifecyclePolicy_CrossRegionCopyRulePropertyValidator))(properties.crossRegionCopyRules)), errors.collect(cdk.propertyValidator("deprecateRule", CfnLifecyclePolicy_DeprecateRulePropertyValidator)(properties.deprecateRule)), errors.collect(cdk.propertyValidator("fastRestoreRule", CfnLifecyclePolicy_FastRestoreRulePropertyValidator)(properties.fastRestoreRule)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("retainRule", CfnLifecyclePolicy_RetainRulePropertyValidator)(properties.retainRule)), errors.collect(cdk.propertyValidator("shareRules", cdk.listValidator(CfnLifecyclePolicy_ShareRulePropertyValidator))(properties.shareRules)), errors.collect(cdk.propertyValidator("tagsToAdd", cdk.listValidator(cdk.validateCfnTag))(properties.tagsToAdd)), errors.collect(cdk.propertyValidator("variableTags", cdk.listValidator(cdk.validateCfnTag))(properties.variableTags)), errors.wrap('supplied properties not correct for "ScheduleProperty"');
    }
    function cfnLifecyclePolicySchedulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLifecyclePolicy_SchedulePropertyValidator(properties).assertSuccess(), { ArchiveRule: cfnLifecyclePolicyArchiveRulePropertyToCloudFormation(properties.archiveRule), CopyTags: cdk.booleanToCloudFormation(properties.copyTags), CreateRule: cfnLifecyclePolicyCreateRulePropertyToCloudFormation(properties.createRule), CrossRegionCopyRules: cdk.listMapper(cfnLifecyclePolicyCrossRegionCopyRulePropertyToCloudFormation)(properties.crossRegionCopyRules), DeprecateRule: cfnLifecyclePolicyDeprecateRulePropertyToCloudFormation(properties.deprecateRule), FastRestoreRule: cfnLifecyclePolicyFastRestoreRulePropertyToCloudFormation(properties.fastRestoreRule), Name: cdk.stringToCloudFormation(properties.name), RetainRule: cfnLifecyclePolicyRetainRulePropertyToCloudFormation(properties.retainRule), ShareRules: cdk.listMapper(cfnLifecyclePolicyShareRulePropertyToCloudFormation)(properties.shareRules), TagsToAdd: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tagsToAdd), VariableTags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.variableTags) }) : properties;
    }
    function CfnLifecyclePolicySchedulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("archiveRule", "ArchiveRule", properties.ArchiveRule != null ? CfnLifecyclePolicyArchiveRulePropertyFromCloudFormation(properties.ArchiveRule) : void 0), ret.addPropertyResult("copyTags", "CopyTags", properties.CopyTags != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CopyTags) : void 0), ret.addPropertyResult("createRule", "CreateRule", properties.CreateRule != null ? CfnLifecyclePolicyCreateRulePropertyFromCloudFormation(properties.CreateRule) : void 0), ret.addPropertyResult("crossRegionCopyRules", "CrossRegionCopyRules", properties.CrossRegionCopyRules != null ? cfn_parse.FromCloudFormation.getArray(CfnLifecyclePolicyCrossRegionCopyRulePropertyFromCloudFormation)(properties.CrossRegionCopyRules) : void 0), ret.addPropertyResult("deprecateRule", "DeprecateRule", properties.DeprecateRule != null ? CfnLifecyclePolicyDeprecateRulePropertyFromCloudFormation(properties.DeprecateRule) : void 0), ret.addPropertyResult("fastRestoreRule", "FastRestoreRule", properties.FastRestoreRule != null ? CfnLifecyclePolicyFastRestoreRulePropertyFromCloudFormation(properties.FastRestoreRule) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("retainRule", "RetainRule", properties.RetainRule != null ? CfnLifecyclePolicyRetainRulePropertyFromCloudFormation(properties.RetainRule) : void 0), ret.addPropertyResult("shareRules", "ShareRules", properties.ShareRules != null ? cfn_parse.FromCloudFormation.getArray(CfnLifecyclePolicyShareRulePropertyFromCloudFormation)(properties.ShareRules) : void 0), ret.addPropertyResult("tagsToAdd", "TagsToAdd", properties.TagsToAdd != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.TagsToAdd) : void 0), ret.addPropertyResult("variableTags", "VariableTags", properties.VariableTags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.VariableTags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLifecyclePolicy_ShareRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("targetAccounts", cdk.listValidator(cdk.validateString))(properties.targetAccounts)), errors.collect(cdk.propertyValidator("unshareInterval", cdk.validateNumber)(properties.unshareInterval)), errors.collect(cdk.propertyValidator("unshareIntervalUnit", cdk.validateString)(properties.unshareIntervalUnit)), errors.wrap('supplied properties not correct for "ShareRuleProperty"');
    }
    function cfnLifecyclePolicyShareRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLifecyclePolicy_ShareRulePropertyValidator(properties).assertSuccess(), { TargetAccounts: cdk.listMapper(cdk.stringToCloudFormation)(properties.targetAccounts), UnshareInterval: cdk.numberToCloudFormation(properties.unshareInterval), UnshareIntervalUnit: cdk.stringToCloudFormation(properties.unshareIntervalUnit) }) : properties;
    }
    function CfnLifecyclePolicyShareRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("targetAccounts", "TargetAccounts", properties.TargetAccounts != null ? cfn_parse.FromCloudFormation.getStringArray(properties.TargetAccounts) : void 0), ret.addPropertyResult("unshareInterval", "UnshareInterval", properties.UnshareInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.UnshareInterval) : void 0), ret.addPropertyResult("unshareIntervalUnit", "UnshareIntervalUnit", properties.UnshareIntervalUnit != null ? cfn_parse.FromCloudFormation.getString(properties.UnshareIntervalUnit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-dlm/lib/index.js
var require_lib104 = __commonJS({
  "node_modules/aws-cdk-lib/aws-dlm/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_dlm_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-dlm/index.js
var require_aws_dlm = __commonJS({
  "node_modules/aws-cdk-lib/aws-dlm/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib104(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-dms/lib/dms.generated.js
var require_dms_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-dms/lib/dms.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnReplicationTask = exports2.CfnReplicationSubnetGroup = exports2.CfnReplicationInstance = exports2.CfnEventSubscription = exports2.CfnEndpoint = exports2.CfnCertificate = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnCertificatePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateIdentifier", cdk.validateString)(properties.certificateIdentifier)), errors.collect(cdk.propertyValidator("certificatePem", cdk.validateString)(properties.certificatePem)), errors.collect(cdk.propertyValidator("certificateWallet", cdk.validateString)(properties.certificateWallet)), errors.wrap('supplied properties not correct for "CfnCertificateProps"');
    }
    function cfnCertificatePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificatePropsValidator(properties).assertSuccess(), { CertificateIdentifier: cdk.stringToCloudFormation(properties.certificateIdentifier), CertificatePem: cdk.stringToCloudFormation(properties.certificatePem), CertificateWallet: cdk.stringToCloudFormation(properties.certificateWallet) }) : properties;
    }
    function CfnCertificatePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificateIdentifier", "CertificateIdentifier", properties.CertificateIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.CertificateIdentifier) : void 0), ret.addPropertyResult("certificatePem", "CertificatePem", properties.CertificatePem != null ? cfn_parse.FromCloudFormation.getString(properties.CertificatePem) : void 0), ret.addPropertyResult("certificateWallet", "CertificateWallet", properties.CertificateWallet != null ? cfn_parse.FromCloudFormation.getString(properties.CertificateWallet) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCertificate = class _CfnCertificate extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCertificatePropsFromCloudFormation(resourceProperties), ret = new _CfnCertificate(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnCertificate.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_dms_CfnCertificateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCertificate), error;
        }
        this.certificateIdentifier = props.certificateIdentifier, this.certificatePem = props.certificatePem, this.certificateWallet = props.certificateWallet;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCertificate.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { certificateIdentifier: this.certificateIdentifier, certificatePem: this.certificatePem, certificateWallet: this.certificateWallet };
      }
      renderProperties(props) {
        return cfnCertificatePropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnCertificate[_a] = { fqn: "aws-cdk-lib.aws_dms.CfnCertificate", version: "2.80.0" }, CfnCertificate.CFN_RESOURCE_TYPE_NAME = "AWS::DMS::Certificate", exports2.CfnCertificate = CfnCertificate;
    function CfnEndpointPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateArn", cdk.validateString)(properties.certificateArn)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("docDbSettings", CfnEndpoint_DocDbSettingsPropertyValidator)(properties.docDbSettings)), errors.collect(cdk.propertyValidator("dynamoDbSettings", CfnEndpoint_DynamoDbSettingsPropertyValidator)(properties.dynamoDbSettings)), errors.collect(cdk.propertyValidator("elasticsearchSettings", CfnEndpoint_ElasticsearchSettingsPropertyValidator)(properties.elasticsearchSettings)), errors.collect(cdk.propertyValidator("endpointIdentifier", cdk.validateString)(properties.endpointIdentifier)), errors.collect(cdk.propertyValidator("endpointType", cdk.requiredValidator)(properties.endpointType)), errors.collect(cdk.propertyValidator("endpointType", cdk.validateString)(properties.endpointType)), errors.collect(cdk.propertyValidator("engineName", cdk.requiredValidator)(properties.engineName)), errors.collect(cdk.propertyValidator("engineName", cdk.validateString)(properties.engineName)), errors.collect(cdk.propertyValidator("extraConnectionAttributes", cdk.validateString)(properties.extraConnectionAttributes)), errors.collect(cdk.propertyValidator("gcpMySqlSettings", CfnEndpoint_GcpMySQLSettingsPropertyValidator)(properties.gcpMySqlSettings)), errors.collect(cdk.propertyValidator("ibmDb2Settings", CfnEndpoint_IbmDb2SettingsPropertyValidator)(properties.ibmDb2Settings)), errors.collect(cdk.propertyValidator("kafkaSettings", CfnEndpoint_KafkaSettingsPropertyValidator)(properties.kafkaSettings)), errors.collect(cdk.propertyValidator("kinesisSettings", CfnEndpoint_KinesisSettingsPropertyValidator)(properties.kinesisSettings)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("microsoftSqlServerSettings", CfnEndpoint_MicrosoftSqlServerSettingsPropertyValidator)(properties.microsoftSqlServerSettings)), errors.collect(cdk.propertyValidator("mongoDbSettings", CfnEndpoint_MongoDbSettingsPropertyValidator)(properties.mongoDbSettings)), errors.collect(cdk.propertyValidator("mySqlSettings", CfnEndpoint_MySqlSettingsPropertyValidator)(properties.mySqlSettings)), errors.collect(cdk.propertyValidator("neptuneSettings", CfnEndpoint_NeptuneSettingsPropertyValidator)(properties.neptuneSettings)), errors.collect(cdk.propertyValidator("oracleSettings", CfnEndpoint_OracleSettingsPropertyValidator)(properties.oracleSettings)), errors.collect(cdk.propertyValidator("password", cdk.validateString)(properties.password)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("postgreSqlSettings", CfnEndpoint_PostgreSqlSettingsPropertyValidator)(properties.postgreSqlSettings)), errors.collect(cdk.propertyValidator("redisSettings", CfnEndpoint_RedisSettingsPropertyValidator)(properties.redisSettings)), errors.collect(cdk.propertyValidator("redshiftSettings", CfnEndpoint_RedshiftSettingsPropertyValidator)(properties.redshiftSettings)), errors.collect(cdk.propertyValidator("resourceIdentifier", cdk.validateString)(properties.resourceIdentifier)), errors.collect(cdk.propertyValidator("s3Settings", CfnEndpoint_S3SettingsPropertyValidator)(properties.s3Settings)), errors.collect(cdk.propertyValidator("serverName", cdk.validateString)(properties.serverName)), errors.collect(cdk.propertyValidator("sslMode", cdk.validateString)(properties.sslMode)), errors.collect(cdk.propertyValidator("sybaseSettings", CfnEndpoint_SybaseSettingsPropertyValidator)(properties.sybaseSettings)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("username", cdk.validateString)(properties.username)), errors.wrap('supplied properties not correct for "CfnEndpointProps"');
    }
    function cfnEndpointPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpointPropsValidator(properties).assertSuccess(), { EndpointType: cdk.stringToCloudFormation(properties.endpointType), EngineName: cdk.stringToCloudFormation(properties.engineName), CertificateArn: cdk.stringToCloudFormation(properties.certificateArn), DatabaseName: cdk.stringToCloudFormation(properties.databaseName), DocDbSettings: cfnEndpointDocDbSettingsPropertyToCloudFormation(properties.docDbSettings), DynamoDbSettings: cfnEndpointDynamoDbSettingsPropertyToCloudFormation(properties.dynamoDbSettings), ElasticsearchSettings: cfnEndpointElasticsearchSettingsPropertyToCloudFormation(properties.elasticsearchSettings), EndpointIdentifier: cdk.stringToCloudFormation(properties.endpointIdentifier), ExtraConnectionAttributes: cdk.stringToCloudFormation(properties.extraConnectionAttributes), GcpMySQLSettings: cfnEndpointGcpMySQLSettingsPropertyToCloudFormation(properties.gcpMySqlSettings), IbmDb2Settings: cfnEndpointIbmDb2SettingsPropertyToCloudFormation(properties.ibmDb2Settings), KafkaSettings: cfnEndpointKafkaSettingsPropertyToCloudFormation(properties.kafkaSettings), KinesisSettings: cfnEndpointKinesisSettingsPropertyToCloudFormation(properties.kinesisSettings), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), MicrosoftSqlServerSettings: cfnEndpointMicrosoftSqlServerSettingsPropertyToCloudFormation(properties.microsoftSqlServerSettings), MongoDbSettings: cfnEndpointMongoDbSettingsPropertyToCloudFormation(properties.mongoDbSettings), MySqlSettings: cfnEndpointMySqlSettingsPropertyToCloudFormation(properties.mySqlSettings), NeptuneSettings: cfnEndpointNeptuneSettingsPropertyToCloudFormation(properties.neptuneSettings), OracleSettings: cfnEndpointOracleSettingsPropertyToCloudFormation(properties.oracleSettings), Password: cdk.stringToCloudFormation(properties.password), Port: cdk.numberToCloudFormation(properties.port), PostgreSqlSettings: cfnEndpointPostgreSqlSettingsPropertyToCloudFormation(properties.postgreSqlSettings), RedisSettings: cfnEndpointRedisSettingsPropertyToCloudFormation(properties.redisSettings), RedshiftSettings: cfnEndpointRedshiftSettingsPropertyToCloudFormation(properties.redshiftSettings), ResourceIdentifier: cdk.stringToCloudFormation(properties.resourceIdentifier), S3Settings: cfnEndpointS3SettingsPropertyToCloudFormation(properties.s3Settings), ServerName: cdk.stringToCloudFormation(properties.serverName), SslMode: cdk.stringToCloudFormation(properties.sslMode), SybaseSettings: cfnEndpointSybaseSettingsPropertyToCloudFormation(properties.sybaseSettings), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), Username: cdk.stringToCloudFormation(properties.username) }) : properties;
    }
    function CfnEndpointPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endpointType", "EndpointType", cfn_parse.FromCloudFormation.getString(properties.EndpointType)), ret.addPropertyResult("engineName", "EngineName", cfn_parse.FromCloudFormation.getString(properties.EngineName)), ret.addPropertyResult("certificateArn", "CertificateArn", properties.CertificateArn != null ? cfn_parse.FromCloudFormation.getString(properties.CertificateArn) : void 0), ret.addPropertyResult("databaseName", "DatabaseName", properties.DatabaseName != null ? cfn_parse.FromCloudFormation.getString(properties.DatabaseName) : void 0), ret.addPropertyResult("docDbSettings", "DocDbSettings", properties.DocDbSettings != null ? CfnEndpointDocDbSettingsPropertyFromCloudFormation(properties.DocDbSettings) : void 0), ret.addPropertyResult("dynamoDbSettings", "DynamoDbSettings", properties.DynamoDbSettings != null ? CfnEndpointDynamoDbSettingsPropertyFromCloudFormation(properties.DynamoDbSettings) : void 0), ret.addPropertyResult("elasticsearchSettings", "ElasticsearchSettings", properties.ElasticsearchSettings != null ? CfnEndpointElasticsearchSettingsPropertyFromCloudFormation(properties.ElasticsearchSettings) : void 0), ret.addPropertyResult("endpointIdentifier", "EndpointIdentifier", properties.EndpointIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.EndpointIdentifier) : void 0), ret.addPropertyResult("extraConnectionAttributes", "ExtraConnectionAttributes", properties.ExtraConnectionAttributes != null ? cfn_parse.FromCloudFormation.getString(properties.ExtraConnectionAttributes) : void 0), ret.addPropertyResult("gcpMySqlSettings", "GcpMySQLSettings", properties.GcpMySQLSettings != null ? CfnEndpointGcpMySQLSettingsPropertyFromCloudFormation(properties.GcpMySQLSettings) : void 0), ret.addPropertyResult("ibmDb2Settings", "IbmDb2Settings", properties.IbmDb2Settings != null ? CfnEndpointIbmDb2SettingsPropertyFromCloudFormation(properties.IbmDb2Settings) : void 0), ret.addPropertyResult("kafkaSettings", "KafkaSettings", properties.KafkaSettings != null ? CfnEndpointKafkaSettingsPropertyFromCloudFormation(properties.KafkaSettings) : void 0), ret.addPropertyResult("kinesisSettings", "KinesisSettings", properties.KinesisSettings != null ? CfnEndpointKinesisSettingsPropertyFromCloudFormation(properties.KinesisSettings) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("microsoftSqlServerSettings", "MicrosoftSqlServerSettings", properties.MicrosoftSqlServerSettings != null ? CfnEndpointMicrosoftSqlServerSettingsPropertyFromCloudFormation(properties.MicrosoftSqlServerSettings) : void 0), ret.addPropertyResult("mongoDbSettings", "MongoDbSettings", properties.MongoDbSettings != null ? CfnEndpointMongoDbSettingsPropertyFromCloudFormation(properties.MongoDbSettings) : void 0), ret.addPropertyResult("mySqlSettings", "MySqlSettings", properties.MySqlSettings != null ? CfnEndpointMySqlSettingsPropertyFromCloudFormation(properties.MySqlSettings) : void 0), ret.addPropertyResult("neptuneSettings", "NeptuneSettings", properties.NeptuneSettings != null ? CfnEndpointNeptuneSettingsPropertyFromCloudFormation(properties.NeptuneSettings) : void 0), ret.addPropertyResult("oracleSettings", "OracleSettings", properties.OracleSettings != null ? CfnEndpointOracleSettingsPropertyFromCloudFormation(properties.OracleSettings) : void 0), ret.addPropertyResult("password", "Password", properties.Password != null ? cfn_parse.FromCloudFormation.getString(properties.Password) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addPropertyResult("postgreSqlSettings", "PostgreSqlSettings", properties.PostgreSqlSettings != null ? CfnEndpointPostgreSqlSettingsPropertyFromCloudFormation(properties.PostgreSqlSettings) : void 0), ret.addPropertyResult("redisSettings", "RedisSettings", properties.RedisSettings != null ? CfnEndpointRedisSettingsPropertyFromCloudFormation(properties.RedisSettings) : void 0), ret.addPropertyResult("redshiftSettings", "RedshiftSettings", properties.RedshiftSettings != null ? CfnEndpointRedshiftSettingsPropertyFromCloudFormation(properties.RedshiftSettings) : void 0), ret.addPropertyResult("resourceIdentifier", "ResourceIdentifier", properties.ResourceIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceIdentifier) : void 0), ret.addPropertyResult("s3Settings", "S3Settings", properties.S3Settings != null ? CfnEndpointS3SettingsPropertyFromCloudFormation(properties.S3Settings) : void 0), ret.addPropertyResult("serverName", "ServerName", properties.ServerName != null ? cfn_parse.FromCloudFormation.getString(properties.ServerName) : void 0), ret.addPropertyResult("sslMode", "SslMode", properties.SslMode != null ? cfn_parse.FromCloudFormation.getString(properties.SslMode) : void 0), ret.addPropertyResult("sybaseSettings", "SybaseSettings", properties.SybaseSettings != null ? CfnEndpointSybaseSettingsPropertyFromCloudFormation(properties.SybaseSettings) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("username", "Username", properties.Username != null ? cfn_parse.FromCloudFormation.getString(properties.Username) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEndpoint = class _CfnEndpoint extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEndpointPropsFromCloudFormation(resourceProperties), ret = new _CfnEndpoint(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEndpoint.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_dms_CfnEndpointProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEndpoint), error;
        }
        cdk.requireProperty(props, "endpointType", this), cdk.requireProperty(props, "engineName", this), this.attrExternalId = cdk.Token.asString(this.getAtt("ExternalId", cdk.ResolutionTypeHint.STRING)), this.endpointType = props.endpointType, this.engineName = props.engineName, this.certificateArn = props.certificateArn, this.databaseName = props.databaseName, this.docDbSettings = props.docDbSettings, this.dynamoDbSettings = props.dynamoDbSettings, this.elasticsearchSettings = props.elasticsearchSettings, this.endpointIdentifier = props.endpointIdentifier, this.extraConnectionAttributes = props.extraConnectionAttributes, this.gcpMySqlSettings = props.gcpMySqlSettings, this.ibmDb2Settings = props.ibmDb2Settings, this.kafkaSettings = props.kafkaSettings, this.kinesisSettings = props.kinesisSettings, this.kmsKeyId = props.kmsKeyId, this.microsoftSqlServerSettings = props.microsoftSqlServerSettings, this.mongoDbSettings = props.mongoDbSettings, this.mySqlSettings = props.mySqlSettings, this.neptuneSettings = props.neptuneSettings, this.oracleSettings = props.oracleSettings, this.password = props.password, this.port = props.port, this.postgreSqlSettings = props.postgreSqlSettings, this.redisSettings = props.redisSettings, this.redshiftSettings = props.redshiftSettings, this.resourceIdentifier = props.resourceIdentifier, this.s3Settings = props.s3Settings, this.serverName = props.serverName, this.sslMode = props.sslMode, this.sybaseSettings = props.sybaseSettings, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DMS::Endpoint", props.tags, { tagPropertyName: "tags" }), this.username = props.username;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEndpoint.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { endpointType: this.endpointType, engineName: this.engineName, certificateArn: this.certificateArn, databaseName: this.databaseName, docDbSettings: this.docDbSettings, dynamoDbSettings: this.dynamoDbSettings, elasticsearchSettings: this.elasticsearchSettings, endpointIdentifier: this.endpointIdentifier, extraConnectionAttributes: this.extraConnectionAttributes, gcpMySqlSettings: this.gcpMySqlSettings, ibmDb2Settings: this.ibmDb2Settings, kafkaSettings: this.kafkaSettings, kinesisSettings: this.kinesisSettings, kmsKeyId: this.kmsKeyId, microsoftSqlServerSettings: this.microsoftSqlServerSettings, mongoDbSettings: this.mongoDbSettings, mySqlSettings: this.mySqlSettings, neptuneSettings: this.neptuneSettings, oracleSettings: this.oracleSettings, password: this.password, port: this.port, postgreSqlSettings: this.postgreSqlSettings, redisSettings: this.redisSettings, redshiftSettings: this.redshiftSettings, resourceIdentifier: this.resourceIdentifier, s3Settings: this.s3Settings, serverName: this.serverName, sslMode: this.sslMode, sybaseSettings: this.sybaseSettings, tags: this.tags.renderTags(), username: this.username };
      }
      renderProperties(props) {
        return cfnEndpointPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnEndpoint[_b] = { fqn: "aws-cdk-lib.aws_dms.CfnEndpoint", version: "2.80.0" }, CfnEndpoint.CFN_RESOURCE_TYPE_NAME = "AWS::DMS::Endpoint", exports2.CfnEndpoint = CfnEndpoint;
    function CfnEndpoint_DocDbSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("docsToInvestigate", cdk.validateNumber)(properties.docsToInvestigate)), errors.collect(cdk.propertyValidator("extractDocId", cdk.validateBoolean)(properties.extractDocId)), errors.collect(cdk.propertyValidator("nestingLevel", cdk.validateString)(properties.nestingLevel)), errors.collect(cdk.propertyValidator("secretsManagerAccessRoleArn", cdk.validateString)(properties.secretsManagerAccessRoleArn)), errors.collect(cdk.propertyValidator("secretsManagerSecretId", cdk.validateString)(properties.secretsManagerSecretId)), errors.wrap('supplied properties not correct for "DocDbSettingsProperty"');
    }
    function cfnEndpointDocDbSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpoint_DocDbSettingsPropertyValidator(properties).assertSuccess(), { DocsToInvestigate: cdk.numberToCloudFormation(properties.docsToInvestigate), ExtractDocId: cdk.booleanToCloudFormation(properties.extractDocId), NestingLevel: cdk.stringToCloudFormation(properties.nestingLevel), SecretsManagerAccessRoleArn: cdk.stringToCloudFormation(properties.secretsManagerAccessRoleArn), SecretsManagerSecretId: cdk.stringToCloudFormation(properties.secretsManagerSecretId) }) : properties;
    }
    function CfnEndpointDocDbSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("docsToInvestigate", "DocsToInvestigate", properties.DocsToInvestigate != null ? cfn_parse.FromCloudFormation.getNumber(properties.DocsToInvestigate) : void 0), ret.addPropertyResult("extractDocId", "ExtractDocId", properties.ExtractDocId != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ExtractDocId) : void 0), ret.addPropertyResult("nestingLevel", "NestingLevel", properties.NestingLevel != null ? cfn_parse.FromCloudFormation.getString(properties.NestingLevel) : void 0), ret.addPropertyResult("secretsManagerAccessRoleArn", "SecretsManagerAccessRoleArn", properties.SecretsManagerAccessRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.SecretsManagerAccessRoleArn) : void 0), ret.addPropertyResult("secretsManagerSecretId", "SecretsManagerSecretId", properties.SecretsManagerSecretId != null ? cfn_parse.FromCloudFormation.getString(properties.SecretsManagerSecretId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpoint_DynamoDbSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("serviceAccessRoleArn", cdk.validateString)(properties.serviceAccessRoleArn)), errors.wrap('supplied properties not correct for "DynamoDbSettingsProperty"');
    }
    function cfnEndpointDynamoDbSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpoint_DynamoDbSettingsPropertyValidator(properties).assertSuccess(), { ServiceAccessRoleArn: cdk.stringToCloudFormation(properties.serviceAccessRoleArn) }) : properties;
    }
    function CfnEndpointDynamoDbSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("serviceAccessRoleArn", "ServiceAccessRoleArn", properties.ServiceAccessRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceAccessRoleArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpoint_ElasticsearchSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endpointUri", cdk.validateString)(properties.endpointUri)), errors.collect(cdk.propertyValidator("errorRetryDuration", cdk.validateNumber)(properties.errorRetryDuration)), errors.collect(cdk.propertyValidator("fullLoadErrorPercentage", cdk.validateNumber)(properties.fullLoadErrorPercentage)), errors.collect(cdk.propertyValidator("serviceAccessRoleArn", cdk.validateString)(properties.serviceAccessRoleArn)), errors.wrap('supplied properties not correct for "ElasticsearchSettingsProperty"');
    }
    function cfnEndpointElasticsearchSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpoint_ElasticsearchSettingsPropertyValidator(properties).assertSuccess(), { EndpointUri: cdk.stringToCloudFormation(properties.endpointUri), ErrorRetryDuration: cdk.numberToCloudFormation(properties.errorRetryDuration), FullLoadErrorPercentage: cdk.numberToCloudFormation(properties.fullLoadErrorPercentage), ServiceAccessRoleArn: cdk.stringToCloudFormation(properties.serviceAccessRoleArn) }) : properties;
    }
    function CfnEndpointElasticsearchSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endpointUri", "EndpointUri", properties.EndpointUri != null ? cfn_parse.FromCloudFormation.getString(properties.EndpointUri) : void 0), ret.addPropertyResult("errorRetryDuration", "ErrorRetryDuration", properties.ErrorRetryDuration != null ? cfn_parse.FromCloudFormation.getNumber(properties.ErrorRetryDuration) : void 0), ret.addPropertyResult("fullLoadErrorPercentage", "FullLoadErrorPercentage", properties.FullLoadErrorPercentage != null ? cfn_parse.FromCloudFormation.getNumber(properties.FullLoadErrorPercentage) : void 0), ret.addPropertyResult("serviceAccessRoleArn", "ServiceAccessRoleArn", properties.ServiceAccessRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceAccessRoleArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpoint_GcpMySQLSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("afterConnectScript", cdk.validateString)(properties.afterConnectScript)), errors.collect(cdk.propertyValidator("cleanSourceMetadataOnMismatch", cdk.validateBoolean)(properties.cleanSourceMetadataOnMismatch)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("eventsPollInterval", cdk.validateNumber)(properties.eventsPollInterval)), errors.collect(cdk.propertyValidator("maxFileSize", cdk.validateNumber)(properties.maxFileSize)), errors.collect(cdk.propertyValidator("parallelLoadThreads", cdk.validateNumber)(properties.parallelLoadThreads)), errors.collect(cdk.propertyValidator("password", cdk.validateString)(properties.password)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("secretsManagerAccessRoleArn", cdk.validateString)(properties.secretsManagerAccessRoleArn)), errors.collect(cdk.propertyValidator("secretsManagerSecretId", cdk.validateString)(properties.secretsManagerSecretId)), errors.collect(cdk.propertyValidator("serverName", cdk.validateString)(properties.serverName)), errors.collect(cdk.propertyValidator("serverTimezone", cdk.validateString)(properties.serverTimezone)), errors.collect(cdk.propertyValidator("username", cdk.validateString)(properties.username)), errors.wrap('supplied properties not correct for "GcpMySQLSettingsProperty"');
    }
    function cfnEndpointGcpMySQLSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpoint_GcpMySQLSettingsPropertyValidator(properties).assertSuccess(), { AfterConnectScript: cdk.stringToCloudFormation(properties.afterConnectScript), CleanSourceMetadataOnMismatch: cdk.booleanToCloudFormation(properties.cleanSourceMetadataOnMismatch), DatabaseName: cdk.stringToCloudFormation(properties.databaseName), EventsPollInterval: cdk.numberToCloudFormation(properties.eventsPollInterval), MaxFileSize: cdk.numberToCloudFormation(properties.maxFileSize), ParallelLoadThreads: cdk.numberToCloudFormation(properties.parallelLoadThreads), Password: cdk.stringToCloudFormation(properties.password), Port: cdk.numberToCloudFormation(properties.port), SecretsManagerAccessRoleArn: cdk.stringToCloudFormation(properties.secretsManagerAccessRoleArn), SecretsManagerSecretId: cdk.stringToCloudFormation(properties.secretsManagerSecretId), ServerName: cdk.stringToCloudFormation(properties.serverName), ServerTimezone: cdk.stringToCloudFormation(properties.serverTimezone), Username: cdk.stringToCloudFormation(properties.username) }) : properties;
    }
    function CfnEndpointGcpMySQLSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("afterConnectScript", "AfterConnectScript", properties.AfterConnectScript != null ? cfn_parse.FromCloudFormation.getString(properties.AfterConnectScript) : void 0), ret.addPropertyResult("cleanSourceMetadataOnMismatch", "CleanSourceMetadataOnMismatch", properties.CleanSourceMetadataOnMismatch != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CleanSourceMetadataOnMismatch) : void 0), ret.addPropertyResult("databaseName", "DatabaseName", properties.DatabaseName != null ? cfn_parse.FromCloudFormation.getString(properties.DatabaseName) : void 0), ret.addPropertyResult("eventsPollInterval", "EventsPollInterval", properties.EventsPollInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.EventsPollInterval) : void 0), ret.addPropertyResult("maxFileSize", "MaxFileSize", properties.MaxFileSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxFileSize) : void 0), ret.addPropertyResult("parallelLoadThreads", "ParallelLoadThreads", properties.ParallelLoadThreads != null ? cfn_parse.FromCloudFormation.getNumber(properties.ParallelLoadThreads) : void 0), ret.addPropertyResult("password", "Password", properties.Password != null ? cfn_parse.FromCloudFormation.getString(properties.Password) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addPropertyResult("secretsManagerAccessRoleArn", "SecretsManagerAccessRoleArn", properties.SecretsManagerAccessRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.SecretsManagerAccessRoleArn) : void 0), ret.addPropertyResult("secretsManagerSecretId", "SecretsManagerSecretId", properties.SecretsManagerSecretId != null ? cfn_parse.FromCloudFormation.getString(properties.SecretsManagerSecretId) : void 0), ret.addPropertyResult("serverName", "ServerName", properties.ServerName != null ? cfn_parse.FromCloudFormation.getString(properties.ServerName) : void 0), ret.addPropertyResult("serverTimezone", "ServerTimezone", properties.ServerTimezone != null ? cfn_parse.FromCloudFormation.getString(properties.ServerTimezone) : void 0), ret.addPropertyResult("username", "Username", properties.Username != null ? cfn_parse.FromCloudFormation.getString(properties.Username) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpoint_IbmDb2SettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("currentLsn", cdk.validateString)(properties.currentLsn)), errors.collect(cdk.propertyValidator("maxKBytesPerRead", cdk.validateNumber)(properties.maxKBytesPerRead)), errors.collect(cdk.propertyValidator("secretsManagerAccessRoleArn", cdk.validateString)(properties.secretsManagerAccessRoleArn)), errors.collect(cdk.propertyValidator("secretsManagerSecretId", cdk.validateString)(properties.secretsManagerSecretId)), errors.collect(cdk.propertyValidator("setDataCaptureChanges", cdk.validateBoolean)(properties.setDataCaptureChanges)), errors.wrap('supplied properties not correct for "IbmDb2SettingsProperty"');
    }
    function cfnEndpointIbmDb2SettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpoint_IbmDb2SettingsPropertyValidator(properties).assertSuccess(), { CurrentLsn: cdk.stringToCloudFormation(properties.currentLsn), MaxKBytesPerRead: cdk.numberToCloudFormation(properties.maxKBytesPerRead), SecretsManagerAccessRoleArn: cdk.stringToCloudFormation(properties.secretsManagerAccessRoleArn), SecretsManagerSecretId: cdk.stringToCloudFormation(properties.secretsManagerSecretId), SetDataCaptureChanges: cdk.booleanToCloudFormation(properties.setDataCaptureChanges) }) : properties;
    }
    function CfnEndpointIbmDb2SettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("currentLsn", "CurrentLsn", properties.CurrentLsn != null ? cfn_parse.FromCloudFormation.getString(properties.CurrentLsn) : void 0), ret.addPropertyResult("maxKBytesPerRead", "MaxKBytesPerRead", properties.MaxKBytesPerRead != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxKBytesPerRead) : void 0), ret.addPropertyResult("secretsManagerAccessRoleArn", "SecretsManagerAccessRoleArn", properties.SecretsManagerAccessRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.SecretsManagerAccessRoleArn) : void 0), ret.addPropertyResult("secretsManagerSecretId", "SecretsManagerSecretId", properties.SecretsManagerSecretId != null ? cfn_parse.FromCloudFormation.getString(properties.SecretsManagerSecretId) : void 0), ret.addPropertyResult("setDataCaptureChanges", "SetDataCaptureChanges", properties.SetDataCaptureChanges != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SetDataCaptureChanges) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpoint_KafkaSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("broker", cdk.validateString)(properties.broker)), errors.collect(cdk.propertyValidator("includeControlDetails", cdk.validateBoolean)(properties.includeControlDetails)), errors.collect(cdk.propertyValidator("includeNullAndEmpty", cdk.validateBoolean)(properties.includeNullAndEmpty)), errors.collect(cdk.propertyValidator("includePartitionValue", cdk.validateBoolean)(properties.includePartitionValue)), errors.collect(cdk.propertyValidator("includeTableAlterOperations", cdk.validateBoolean)(properties.includeTableAlterOperations)), errors.collect(cdk.propertyValidator("includeTransactionDetails", cdk.validateBoolean)(properties.includeTransactionDetails)), errors.collect(cdk.propertyValidator("messageFormat", cdk.validateString)(properties.messageFormat)), errors.collect(cdk.propertyValidator("messageMaxBytes", cdk.validateNumber)(properties.messageMaxBytes)), errors.collect(cdk.propertyValidator("noHexPrefix", cdk.validateBoolean)(properties.noHexPrefix)), errors.collect(cdk.propertyValidator("partitionIncludeSchemaTable", cdk.validateBoolean)(properties.partitionIncludeSchemaTable)), errors.collect(cdk.propertyValidator("saslPassword", cdk.validateString)(properties.saslPassword)), errors.collect(cdk.propertyValidator("saslUserName", cdk.validateString)(properties.saslUserName)), errors.collect(cdk.propertyValidator("securityProtocol", cdk.validateString)(properties.securityProtocol)), errors.collect(cdk.propertyValidator("sslCaCertificateArn", cdk.validateString)(properties.sslCaCertificateArn)), errors.collect(cdk.propertyValidator("sslClientCertificateArn", cdk.validateString)(properties.sslClientCertificateArn)), errors.collect(cdk.propertyValidator("sslClientKeyArn", cdk.validateString)(properties.sslClientKeyArn)), errors.collect(cdk.propertyValidator("sslClientKeyPassword", cdk.validateString)(properties.sslClientKeyPassword)), errors.collect(cdk.propertyValidator("topic", cdk.validateString)(properties.topic)), errors.wrap('supplied properties not correct for "KafkaSettingsProperty"');
    }
    function cfnEndpointKafkaSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpoint_KafkaSettingsPropertyValidator(properties).assertSuccess(), { Broker: cdk.stringToCloudFormation(properties.broker), IncludeControlDetails: cdk.booleanToCloudFormation(properties.includeControlDetails), IncludeNullAndEmpty: cdk.booleanToCloudFormation(properties.includeNullAndEmpty), IncludePartitionValue: cdk.booleanToCloudFormation(properties.includePartitionValue), IncludeTableAlterOperations: cdk.booleanToCloudFormation(properties.includeTableAlterOperations), IncludeTransactionDetails: cdk.booleanToCloudFormation(properties.includeTransactionDetails), MessageFormat: cdk.stringToCloudFormation(properties.messageFormat), MessageMaxBytes: cdk.numberToCloudFormation(properties.messageMaxBytes), NoHexPrefix: cdk.booleanToCloudFormation(properties.noHexPrefix), PartitionIncludeSchemaTable: cdk.booleanToCloudFormation(properties.partitionIncludeSchemaTable), SaslPassword: cdk.stringToCloudFormation(properties.saslPassword), SaslUserName: cdk.stringToCloudFormation(properties.saslUserName), SecurityProtocol: cdk.stringToCloudFormation(properties.securityProtocol), SslCaCertificateArn: cdk.stringToCloudFormation(properties.sslCaCertificateArn), SslClientCertificateArn: cdk.stringToCloudFormation(properties.sslClientCertificateArn), SslClientKeyArn: cdk.stringToCloudFormation(properties.sslClientKeyArn), SslClientKeyPassword: cdk.stringToCloudFormation(properties.sslClientKeyPassword), Topic: cdk.stringToCloudFormation(properties.topic) }) : properties;
    }
    function CfnEndpointKafkaSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("broker", "Broker", properties.Broker != null ? cfn_parse.FromCloudFormation.getString(properties.Broker) : void 0), ret.addPropertyResult("includeControlDetails", "IncludeControlDetails", properties.IncludeControlDetails != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeControlDetails) : void 0), ret.addPropertyResult("includeNullAndEmpty", "IncludeNullAndEmpty", properties.IncludeNullAndEmpty != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeNullAndEmpty) : void 0), ret.addPropertyResult("includePartitionValue", "IncludePartitionValue", properties.IncludePartitionValue != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludePartitionValue) : void 0), ret.addPropertyResult("includeTableAlterOperations", "IncludeTableAlterOperations", properties.IncludeTableAlterOperations != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeTableAlterOperations) : void 0), ret.addPropertyResult("includeTransactionDetails", "IncludeTransactionDetails", properties.IncludeTransactionDetails != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeTransactionDetails) : void 0), ret.addPropertyResult("messageFormat", "MessageFormat", properties.MessageFormat != null ? cfn_parse.FromCloudFormation.getString(properties.MessageFormat) : void 0), ret.addPropertyResult("messageMaxBytes", "MessageMaxBytes", properties.MessageMaxBytes != null ? cfn_parse.FromCloudFormation.getNumber(properties.MessageMaxBytes) : void 0), ret.addPropertyResult("noHexPrefix", "NoHexPrefix", properties.NoHexPrefix != null ? cfn_parse.FromCloudFormation.getBoolean(properties.NoHexPrefix) : void 0), ret.addPropertyResult("partitionIncludeSchemaTable", "PartitionIncludeSchemaTable", properties.PartitionIncludeSchemaTable != null ? cfn_parse.FromCloudFormation.getBoolean(properties.PartitionIncludeSchemaTable) : void 0), ret.addPropertyResult("saslPassword", "SaslPassword", properties.SaslPassword != null ? cfn_parse.FromCloudFormation.getString(properties.SaslPassword) : void 0), ret.addPropertyResult("saslUserName", "SaslUserName", properties.SaslUserName != null ? cfn_parse.FromCloudFormation.getString(properties.SaslUserName) : void 0), ret.addPropertyResult("securityProtocol", "SecurityProtocol", properties.SecurityProtocol != null ? cfn_parse.FromCloudFormation.getString(properties.SecurityProtocol) : void 0), ret.addPropertyResult("sslCaCertificateArn", "SslCaCertificateArn", properties.SslCaCertificateArn != null ? cfn_parse.FromCloudFormation.getString(properties.SslCaCertificateArn) : void 0), ret.addPropertyResult("sslClientCertificateArn", "SslClientCertificateArn", properties.SslClientCertificateArn != null ? cfn_parse.FromCloudFormation.getString(properties.SslClientCertificateArn) : void 0), ret.addPropertyResult("sslClientKeyArn", "SslClientKeyArn", properties.SslClientKeyArn != null ? cfn_parse.FromCloudFormation.getString(properties.SslClientKeyArn) : void 0), ret.addPropertyResult("sslClientKeyPassword", "SslClientKeyPassword", properties.SslClientKeyPassword != null ? cfn_parse.FromCloudFormation.getString(properties.SslClientKeyPassword) : void 0), ret.addPropertyResult("topic", "Topic", properties.Topic != null ? cfn_parse.FromCloudFormation.getString(properties.Topic) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpoint_KinesisSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("includeControlDetails", cdk.validateBoolean)(properties.includeControlDetails)), errors.collect(cdk.propertyValidator("includeNullAndEmpty", cdk.validateBoolean)(properties.includeNullAndEmpty)), errors.collect(cdk.propertyValidator("includePartitionValue", cdk.validateBoolean)(properties.includePartitionValue)), errors.collect(cdk.propertyValidator("includeTableAlterOperations", cdk.validateBoolean)(properties.includeTableAlterOperations)), errors.collect(cdk.propertyValidator("includeTransactionDetails", cdk.validateBoolean)(properties.includeTransactionDetails)), errors.collect(cdk.propertyValidator("messageFormat", cdk.validateString)(properties.messageFormat)), errors.collect(cdk.propertyValidator("noHexPrefix", cdk.validateBoolean)(properties.noHexPrefix)), errors.collect(cdk.propertyValidator("partitionIncludeSchemaTable", cdk.validateBoolean)(properties.partitionIncludeSchemaTable)), errors.collect(cdk.propertyValidator("serviceAccessRoleArn", cdk.validateString)(properties.serviceAccessRoleArn)), errors.collect(cdk.propertyValidator("streamArn", cdk.validateString)(properties.streamArn)), errors.wrap('supplied properties not correct for "KinesisSettingsProperty"');
    }
    function cfnEndpointKinesisSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpoint_KinesisSettingsPropertyValidator(properties).assertSuccess(), { IncludeControlDetails: cdk.booleanToCloudFormation(properties.includeControlDetails), IncludeNullAndEmpty: cdk.booleanToCloudFormation(properties.includeNullAndEmpty), IncludePartitionValue: cdk.booleanToCloudFormation(properties.includePartitionValue), IncludeTableAlterOperations: cdk.booleanToCloudFormation(properties.includeTableAlterOperations), IncludeTransactionDetails: cdk.booleanToCloudFormation(properties.includeTransactionDetails), MessageFormat: cdk.stringToCloudFormation(properties.messageFormat), NoHexPrefix: cdk.booleanToCloudFormation(properties.noHexPrefix), PartitionIncludeSchemaTable: cdk.booleanToCloudFormation(properties.partitionIncludeSchemaTable), ServiceAccessRoleArn: cdk.stringToCloudFormation(properties.serviceAccessRoleArn), StreamArn: cdk.stringToCloudFormation(properties.streamArn) }) : properties;
    }
    function CfnEndpointKinesisSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("includeControlDetails", "IncludeControlDetails", properties.IncludeControlDetails != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeControlDetails) : void 0), ret.addPropertyResult("includeNullAndEmpty", "IncludeNullAndEmpty", properties.IncludeNullAndEmpty != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeNullAndEmpty) : void 0), ret.addPropertyResult("includePartitionValue", "IncludePartitionValue", properties.IncludePartitionValue != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludePartitionValue) : void 0), ret.addPropertyResult("includeTableAlterOperations", "IncludeTableAlterOperations", properties.IncludeTableAlterOperations != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeTableAlterOperations) : void 0), ret.addPropertyResult("includeTransactionDetails", "IncludeTransactionDetails", properties.IncludeTransactionDetails != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeTransactionDetails) : void 0), ret.addPropertyResult("messageFormat", "MessageFormat", properties.MessageFormat != null ? cfn_parse.FromCloudFormation.getString(properties.MessageFormat) : void 0), ret.addPropertyResult("noHexPrefix", "NoHexPrefix", properties.NoHexPrefix != null ? cfn_parse.FromCloudFormation.getBoolean(properties.NoHexPrefix) : void 0), ret.addPropertyResult("partitionIncludeSchemaTable", "PartitionIncludeSchemaTable", properties.PartitionIncludeSchemaTable != null ? cfn_parse.FromCloudFormation.getBoolean(properties.PartitionIncludeSchemaTable) : void 0), ret.addPropertyResult("serviceAccessRoleArn", "ServiceAccessRoleArn", properties.ServiceAccessRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceAccessRoleArn) : void 0), ret.addPropertyResult("streamArn", "StreamArn", properties.StreamArn != null ? cfn_parse.FromCloudFormation.getString(properties.StreamArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpoint_MicrosoftSqlServerSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bcpPacketSize", cdk.validateNumber)(properties.bcpPacketSize)), errors.collect(cdk.propertyValidator("controlTablesFileGroup", cdk.validateString)(properties.controlTablesFileGroup)), errors.collect(cdk.propertyValidator("querySingleAlwaysOnNode", cdk.validateBoolean)(properties.querySingleAlwaysOnNode)), errors.collect(cdk.propertyValidator("readBackupOnly", cdk.validateBoolean)(properties.readBackupOnly)), errors.collect(cdk.propertyValidator("safeguardPolicy", cdk.validateString)(properties.safeguardPolicy)), errors.collect(cdk.propertyValidator("secretsManagerAccessRoleArn", cdk.validateString)(properties.secretsManagerAccessRoleArn)), errors.collect(cdk.propertyValidator("secretsManagerSecretId", cdk.validateString)(properties.secretsManagerSecretId)), errors.collect(cdk.propertyValidator("useBcpFullLoad", cdk.validateBoolean)(properties.useBcpFullLoad)), errors.collect(cdk.propertyValidator("useThirdPartyBackupDevice", cdk.validateBoolean)(properties.useThirdPartyBackupDevice)), errors.wrap('supplied properties not correct for "MicrosoftSqlServerSettingsProperty"');
    }
    function cfnEndpointMicrosoftSqlServerSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpoint_MicrosoftSqlServerSettingsPropertyValidator(properties).assertSuccess(), { BcpPacketSize: cdk.numberToCloudFormation(properties.bcpPacketSize), ControlTablesFileGroup: cdk.stringToCloudFormation(properties.controlTablesFileGroup), QuerySingleAlwaysOnNode: cdk.booleanToCloudFormation(properties.querySingleAlwaysOnNode), ReadBackupOnly: cdk.booleanToCloudFormation(properties.readBackupOnly), SafeguardPolicy: cdk.stringToCloudFormation(properties.safeguardPolicy), SecretsManagerAccessRoleArn: cdk.stringToCloudFormation(properties.secretsManagerAccessRoleArn), SecretsManagerSecretId: cdk.stringToCloudFormation(properties.secretsManagerSecretId), UseBcpFullLoad: cdk.booleanToCloudFormation(properties.useBcpFullLoad), UseThirdPartyBackupDevice: cdk.booleanToCloudFormation(properties.useThirdPartyBackupDevice) }) : properties;
    }
    function CfnEndpointMicrosoftSqlServerSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bcpPacketSize", "BcpPacketSize", properties.BcpPacketSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.BcpPacketSize) : void 0), ret.addPropertyResult("controlTablesFileGroup", "ControlTablesFileGroup", properties.ControlTablesFileGroup != null ? cfn_parse.FromCloudFormation.getString(properties.ControlTablesFileGroup) : void 0), ret.addPropertyResult("querySingleAlwaysOnNode", "QuerySingleAlwaysOnNode", properties.QuerySingleAlwaysOnNode != null ? cfn_parse.FromCloudFormation.getBoolean(properties.QuerySingleAlwaysOnNode) : void 0), ret.addPropertyResult("readBackupOnly", "ReadBackupOnly", properties.ReadBackupOnly != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ReadBackupOnly) : void 0), ret.addPropertyResult("safeguardPolicy", "SafeguardPolicy", properties.SafeguardPolicy != null ? cfn_parse.FromCloudFormation.getString(properties.SafeguardPolicy) : void 0), ret.addPropertyResult("secretsManagerAccessRoleArn", "SecretsManagerAccessRoleArn", properties.SecretsManagerAccessRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.SecretsManagerAccessRoleArn) : void 0), ret.addPropertyResult("secretsManagerSecretId", "SecretsManagerSecretId", properties.SecretsManagerSecretId != null ? cfn_parse.FromCloudFormation.getString(properties.SecretsManagerSecretId) : void 0), ret.addPropertyResult("useBcpFullLoad", "UseBcpFullLoad", properties.UseBcpFullLoad != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseBcpFullLoad) : void 0), ret.addPropertyResult("useThirdPartyBackupDevice", "UseThirdPartyBackupDevice", properties.UseThirdPartyBackupDevice != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseThirdPartyBackupDevice) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpoint_MongoDbSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authMechanism", cdk.validateString)(properties.authMechanism)), errors.collect(cdk.propertyValidator("authSource", cdk.validateString)(properties.authSource)), errors.collect(cdk.propertyValidator("authType", cdk.validateString)(properties.authType)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("docsToInvestigate", cdk.validateString)(properties.docsToInvestigate)), errors.collect(cdk.propertyValidator("extractDocId", cdk.validateString)(properties.extractDocId)), errors.collect(cdk.propertyValidator("nestingLevel", cdk.validateString)(properties.nestingLevel)), errors.collect(cdk.propertyValidator("password", cdk.validateString)(properties.password)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("secretsManagerAccessRoleArn", cdk.validateString)(properties.secretsManagerAccessRoleArn)), errors.collect(cdk.propertyValidator("secretsManagerSecretId", cdk.validateString)(properties.secretsManagerSecretId)), errors.collect(cdk.propertyValidator("serverName", cdk.validateString)(properties.serverName)), errors.collect(cdk.propertyValidator("username", cdk.validateString)(properties.username)), errors.wrap('supplied properties not correct for "MongoDbSettingsProperty"');
    }
    function cfnEndpointMongoDbSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpoint_MongoDbSettingsPropertyValidator(properties).assertSuccess(), { AuthMechanism: cdk.stringToCloudFormation(properties.authMechanism), AuthSource: cdk.stringToCloudFormation(properties.authSource), AuthType: cdk.stringToCloudFormation(properties.authType), DatabaseName: cdk.stringToCloudFormation(properties.databaseName), DocsToInvestigate: cdk.stringToCloudFormation(properties.docsToInvestigate), ExtractDocId: cdk.stringToCloudFormation(properties.extractDocId), NestingLevel: cdk.stringToCloudFormation(properties.nestingLevel), Password: cdk.stringToCloudFormation(properties.password), Port: cdk.numberToCloudFormation(properties.port), SecretsManagerAccessRoleArn: cdk.stringToCloudFormation(properties.secretsManagerAccessRoleArn), SecretsManagerSecretId: cdk.stringToCloudFormation(properties.secretsManagerSecretId), ServerName: cdk.stringToCloudFormation(properties.serverName), Username: cdk.stringToCloudFormation(properties.username) }) : properties;
    }
    function CfnEndpointMongoDbSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authMechanism", "AuthMechanism", properties.AuthMechanism != null ? cfn_parse.FromCloudFormation.getString(properties.AuthMechanism) : void 0), ret.addPropertyResult("authSource", "AuthSource", properties.AuthSource != null ? cfn_parse.FromCloudFormation.getString(properties.AuthSource) : void 0), ret.addPropertyResult("authType", "AuthType", properties.AuthType != null ? cfn_parse.FromCloudFormation.getString(properties.AuthType) : void 0), ret.addPropertyResult("databaseName", "DatabaseName", properties.DatabaseName != null ? cfn_parse.FromCloudFormation.getString(properties.DatabaseName) : void 0), ret.addPropertyResult("docsToInvestigate", "DocsToInvestigate", properties.DocsToInvestigate != null ? cfn_parse.FromCloudFormation.getString(properties.DocsToInvestigate) : void 0), ret.addPropertyResult("extractDocId", "ExtractDocId", properties.ExtractDocId != null ? cfn_parse.FromCloudFormation.getString(properties.ExtractDocId) : void 0), ret.addPropertyResult("nestingLevel", "NestingLevel", properties.NestingLevel != null ? cfn_parse.FromCloudFormation.getString(properties.NestingLevel) : void 0), ret.addPropertyResult("password", "Password", properties.Password != null ? cfn_parse.FromCloudFormation.getString(properties.Password) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addPropertyResult("secretsManagerAccessRoleArn", "SecretsManagerAccessRoleArn", properties.SecretsManagerAccessRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.SecretsManagerAccessRoleArn) : void 0), ret.addPropertyResult("secretsManagerSecretId", "SecretsManagerSecretId", properties.SecretsManagerSecretId != null ? cfn_parse.FromCloudFormation.getString(properties.SecretsManagerSecretId) : void 0), ret.addPropertyResult("serverName", "ServerName", properties.ServerName != null ? cfn_parse.FromCloudFormation.getString(properties.ServerName) : void 0), ret.addPropertyResult("username", "Username", properties.Username != null ? cfn_parse.FromCloudFormation.getString(properties.Username) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpoint_MySqlSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("afterConnectScript", cdk.validateString)(properties.afterConnectScript)), errors.collect(cdk.propertyValidator("cleanSourceMetadataOnMismatch", cdk.validateBoolean)(properties.cleanSourceMetadataOnMismatch)), errors.collect(cdk.propertyValidator("eventsPollInterval", cdk.validateNumber)(properties.eventsPollInterval)), errors.collect(cdk.propertyValidator("maxFileSize", cdk.validateNumber)(properties.maxFileSize)), errors.collect(cdk.propertyValidator("parallelLoadThreads", cdk.validateNumber)(properties.parallelLoadThreads)), errors.collect(cdk.propertyValidator("secretsManagerAccessRoleArn", cdk.validateString)(properties.secretsManagerAccessRoleArn)), errors.collect(cdk.propertyValidator("secretsManagerSecretId", cdk.validateString)(properties.secretsManagerSecretId)), errors.collect(cdk.propertyValidator("serverTimezone", cdk.validateString)(properties.serverTimezone)), errors.collect(cdk.propertyValidator("targetDbType", cdk.validateString)(properties.targetDbType)), errors.wrap('supplied properties not correct for "MySqlSettingsProperty"');
    }
    function cfnEndpointMySqlSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpoint_MySqlSettingsPropertyValidator(properties).assertSuccess(), { AfterConnectScript: cdk.stringToCloudFormation(properties.afterConnectScript), CleanSourceMetadataOnMismatch: cdk.booleanToCloudFormation(properties.cleanSourceMetadataOnMismatch), EventsPollInterval: cdk.numberToCloudFormation(properties.eventsPollInterval), MaxFileSize: cdk.numberToCloudFormation(properties.maxFileSize), ParallelLoadThreads: cdk.numberToCloudFormation(properties.parallelLoadThreads), SecretsManagerAccessRoleArn: cdk.stringToCloudFormation(properties.secretsManagerAccessRoleArn), SecretsManagerSecretId: cdk.stringToCloudFormation(properties.secretsManagerSecretId), ServerTimezone: cdk.stringToCloudFormation(properties.serverTimezone), TargetDbType: cdk.stringToCloudFormation(properties.targetDbType) }) : properties;
    }
    function CfnEndpointMySqlSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("afterConnectScript", "AfterConnectScript", properties.AfterConnectScript != null ? cfn_parse.FromCloudFormation.getString(properties.AfterConnectScript) : void 0), ret.addPropertyResult("cleanSourceMetadataOnMismatch", "CleanSourceMetadataOnMismatch", properties.CleanSourceMetadataOnMismatch != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CleanSourceMetadataOnMismatch) : void 0), ret.addPropertyResult("eventsPollInterval", "EventsPollInterval", properties.EventsPollInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.EventsPollInterval) : void 0), ret.addPropertyResult("maxFileSize", "MaxFileSize", properties.MaxFileSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxFileSize) : void 0), ret.addPropertyResult("parallelLoadThreads", "ParallelLoadThreads", properties.ParallelLoadThreads != null ? cfn_parse.FromCloudFormation.getNumber(properties.ParallelLoadThreads) : void 0), ret.addPropertyResult("secretsManagerAccessRoleArn", "SecretsManagerAccessRoleArn", properties.SecretsManagerAccessRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.SecretsManagerAccessRoleArn) : void 0), ret.addPropertyResult("secretsManagerSecretId", "SecretsManagerSecretId", properties.SecretsManagerSecretId != null ? cfn_parse.FromCloudFormation.getString(properties.SecretsManagerSecretId) : void 0), ret.addPropertyResult("serverTimezone", "ServerTimezone", properties.ServerTimezone != null ? cfn_parse.FromCloudFormation.getString(properties.ServerTimezone) : void 0), ret.addPropertyResult("targetDbType", "TargetDbType", properties.TargetDbType != null ? cfn_parse.FromCloudFormation.getString(properties.TargetDbType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpoint_NeptuneSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("errorRetryDuration", cdk.validateNumber)(properties.errorRetryDuration)), errors.collect(cdk.propertyValidator("iamAuthEnabled", cdk.validateBoolean)(properties.iamAuthEnabled)), errors.collect(cdk.propertyValidator("maxFileSize", cdk.validateNumber)(properties.maxFileSize)), errors.collect(cdk.propertyValidator("maxRetryCount", cdk.validateNumber)(properties.maxRetryCount)), errors.collect(cdk.propertyValidator("s3BucketFolder", cdk.validateString)(properties.s3BucketFolder)), errors.collect(cdk.propertyValidator("s3BucketName", cdk.validateString)(properties.s3BucketName)), errors.collect(cdk.propertyValidator("serviceAccessRoleArn", cdk.validateString)(properties.serviceAccessRoleArn)), errors.wrap('supplied properties not correct for "NeptuneSettingsProperty"');
    }
    function cfnEndpointNeptuneSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpoint_NeptuneSettingsPropertyValidator(properties).assertSuccess(), { ErrorRetryDuration: cdk.numberToCloudFormation(properties.errorRetryDuration), IamAuthEnabled: cdk.booleanToCloudFormation(properties.iamAuthEnabled), MaxFileSize: cdk.numberToCloudFormation(properties.maxFileSize), MaxRetryCount: cdk.numberToCloudFormation(properties.maxRetryCount), S3BucketFolder: cdk.stringToCloudFormation(properties.s3BucketFolder), S3BucketName: cdk.stringToCloudFormation(properties.s3BucketName), ServiceAccessRoleArn: cdk.stringToCloudFormation(properties.serviceAccessRoleArn) }) : properties;
    }
    function CfnEndpointNeptuneSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("errorRetryDuration", "ErrorRetryDuration", properties.ErrorRetryDuration != null ? cfn_parse.FromCloudFormation.getNumber(properties.ErrorRetryDuration) : void 0), ret.addPropertyResult("iamAuthEnabled", "IamAuthEnabled", properties.IamAuthEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IamAuthEnabled) : void 0), ret.addPropertyResult("maxFileSize", "MaxFileSize", properties.MaxFileSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxFileSize) : void 0), ret.addPropertyResult("maxRetryCount", "MaxRetryCount", properties.MaxRetryCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxRetryCount) : void 0), ret.addPropertyResult("s3BucketFolder", "S3BucketFolder", properties.S3BucketFolder != null ? cfn_parse.FromCloudFormation.getString(properties.S3BucketFolder) : void 0), ret.addPropertyResult("s3BucketName", "S3BucketName", properties.S3BucketName != null ? cfn_parse.FromCloudFormation.getString(properties.S3BucketName) : void 0), ret.addPropertyResult("serviceAccessRoleArn", "ServiceAccessRoleArn", properties.ServiceAccessRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceAccessRoleArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpoint_OracleSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessAlternateDirectly", cdk.validateBoolean)(properties.accessAlternateDirectly)), errors.collect(cdk.propertyValidator("addSupplementalLogging", cdk.validateBoolean)(properties.addSupplementalLogging)), errors.collect(cdk.propertyValidator("additionalArchivedLogDestId", cdk.validateNumber)(properties.additionalArchivedLogDestId)), errors.collect(cdk.propertyValidator("allowSelectNestedTables", cdk.validateBoolean)(properties.allowSelectNestedTables)), errors.collect(cdk.propertyValidator("archivedLogDestId", cdk.validateNumber)(properties.archivedLogDestId)), errors.collect(cdk.propertyValidator("archivedLogsOnly", cdk.validateBoolean)(properties.archivedLogsOnly)), errors.collect(cdk.propertyValidator("asmPassword", cdk.validateString)(properties.asmPassword)), errors.collect(cdk.propertyValidator("asmServer", cdk.validateString)(properties.asmServer)), errors.collect(cdk.propertyValidator("asmUser", cdk.validateString)(properties.asmUser)), errors.collect(cdk.propertyValidator("charLengthSemantics", cdk.validateString)(properties.charLengthSemantics)), errors.collect(cdk.propertyValidator("directPathNoLog", cdk.validateBoolean)(properties.directPathNoLog)), errors.collect(cdk.propertyValidator("directPathParallelLoad", cdk.validateBoolean)(properties.directPathParallelLoad)), errors.collect(cdk.propertyValidator("enableHomogenousTablespace", cdk.validateBoolean)(properties.enableHomogenousTablespace)), errors.collect(cdk.propertyValidator("extraArchivedLogDestIds", cdk.listValidator(cdk.validateNumber))(properties.extraArchivedLogDestIds)), errors.collect(cdk.propertyValidator("failTasksOnLobTruncation", cdk.validateBoolean)(properties.failTasksOnLobTruncation)), errors.collect(cdk.propertyValidator("numberDatatypeScale", cdk.validateNumber)(properties.numberDatatypeScale)), errors.collect(cdk.propertyValidator("oraclePathPrefix", cdk.validateString)(properties.oraclePathPrefix)), errors.collect(cdk.propertyValidator("parallelAsmReadThreads", cdk.validateNumber)(properties.parallelAsmReadThreads)), errors.collect(cdk.propertyValidator("readAheadBlocks", cdk.validateNumber)(properties.readAheadBlocks)), errors.collect(cdk.propertyValidator("readTableSpaceName", cdk.validateBoolean)(properties.readTableSpaceName)), errors.collect(cdk.propertyValidator("replacePathPrefix", cdk.validateBoolean)(properties.replacePathPrefix)), errors.collect(cdk.propertyValidator("retryInterval", cdk.validateNumber)(properties.retryInterval)), errors.collect(cdk.propertyValidator("secretsManagerAccessRoleArn", cdk.validateString)(properties.secretsManagerAccessRoleArn)), errors.collect(cdk.propertyValidator("secretsManagerOracleAsmAccessRoleArn", cdk.validateString)(properties.secretsManagerOracleAsmAccessRoleArn)), errors.collect(cdk.propertyValidator("secretsManagerOracleAsmSecretId", cdk.validateString)(properties.secretsManagerOracleAsmSecretId)), errors.collect(cdk.propertyValidator("secretsManagerSecretId", cdk.validateString)(properties.secretsManagerSecretId)), errors.collect(cdk.propertyValidator("securityDbEncryption", cdk.validateString)(properties.securityDbEncryption)), errors.collect(cdk.propertyValidator("securityDbEncryptionName", cdk.validateString)(properties.securityDbEncryptionName)), errors.collect(cdk.propertyValidator("spatialDataOptionToGeoJsonFunctionName", cdk.validateString)(properties.spatialDataOptionToGeoJsonFunctionName)), errors.collect(cdk.propertyValidator("standbyDelayTime", cdk.validateNumber)(properties.standbyDelayTime)), errors.collect(cdk.propertyValidator("useAlternateFolderForOnline", cdk.validateBoolean)(properties.useAlternateFolderForOnline)), errors.collect(cdk.propertyValidator("useBFile", cdk.validateBoolean)(properties.useBFile)), errors.collect(cdk.propertyValidator("useDirectPathFullLoad", cdk.validateBoolean)(properties.useDirectPathFullLoad)), errors.collect(cdk.propertyValidator("useLogminerReader", cdk.validateBoolean)(properties.useLogminerReader)), errors.collect(cdk.propertyValidator("usePathPrefix", cdk.validateString)(properties.usePathPrefix)), errors.wrap('supplied properties not correct for "OracleSettingsProperty"');
    }
    function cfnEndpointOracleSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpoint_OracleSettingsPropertyValidator(properties).assertSuccess(), { AccessAlternateDirectly: cdk.booleanToCloudFormation(properties.accessAlternateDirectly), AddSupplementalLogging: cdk.booleanToCloudFormation(properties.addSupplementalLogging), AdditionalArchivedLogDestId: cdk.numberToCloudFormation(properties.additionalArchivedLogDestId), AllowSelectNestedTables: cdk.booleanToCloudFormation(properties.allowSelectNestedTables), ArchivedLogDestId: cdk.numberToCloudFormation(properties.archivedLogDestId), ArchivedLogsOnly: cdk.booleanToCloudFormation(properties.archivedLogsOnly), AsmPassword: cdk.stringToCloudFormation(properties.asmPassword), AsmServer: cdk.stringToCloudFormation(properties.asmServer), AsmUser: cdk.stringToCloudFormation(properties.asmUser), CharLengthSemantics: cdk.stringToCloudFormation(properties.charLengthSemantics), DirectPathNoLog: cdk.booleanToCloudFormation(properties.directPathNoLog), DirectPathParallelLoad: cdk.booleanToCloudFormation(properties.directPathParallelLoad), EnableHomogenousTablespace: cdk.booleanToCloudFormation(properties.enableHomogenousTablespace), ExtraArchivedLogDestIds: cdk.listMapper(cdk.numberToCloudFormation)(properties.extraArchivedLogDestIds), FailTasksOnLobTruncation: cdk.booleanToCloudFormation(properties.failTasksOnLobTruncation), NumberDatatypeScale: cdk.numberToCloudFormation(properties.numberDatatypeScale), OraclePathPrefix: cdk.stringToCloudFormation(properties.oraclePathPrefix), ParallelAsmReadThreads: cdk.numberToCloudFormation(properties.parallelAsmReadThreads), ReadAheadBlocks: cdk.numberToCloudFormation(properties.readAheadBlocks), ReadTableSpaceName: cdk.booleanToCloudFormation(properties.readTableSpaceName), ReplacePathPrefix: cdk.booleanToCloudFormation(properties.replacePathPrefix), RetryInterval: cdk.numberToCloudFormation(properties.retryInterval), SecretsManagerAccessRoleArn: cdk.stringToCloudFormation(properties.secretsManagerAccessRoleArn), SecretsManagerOracleAsmAccessRoleArn: cdk.stringToCloudFormation(properties.secretsManagerOracleAsmAccessRoleArn), SecretsManagerOracleAsmSecretId: cdk.stringToCloudFormation(properties.secretsManagerOracleAsmSecretId), SecretsManagerSecretId: cdk.stringToCloudFormation(properties.secretsManagerSecretId), SecurityDbEncryption: cdk.stringToCloudFormation(properties.securityDbEncryption), SecurityDbEncryptionName: cdk.stringToCloudFormation(properties.securityDbEncryptionName), SpatialDataOptionToGeoJsonFunctionName: cdk.stringToCloudFormation(properties.spatialDataOptionToGeoJsonFunctionName), StandbyDelayTime: cdk.numberToCloudFormation(properties.standbyDelayTime), UseAlternateFolderForOnline: cdk.booleanToCloudFormation(properties.useAlternateFolderForOnline), UseBFile: cdk.booleanToCloudFormation(properties.useBFile), UseDirectPathFullLoad: cdk.booleanToCloudFormation(properties.useDirectPathFullLoad), UseLogminerReader: cdk.booleanToCloudFormation(properties.useLogminerReader), UsePathPrefix: cdk.stringToCloudFormation(properties.usePathPrefix) }) : properties;
    }
    function CfnEndpointOracleSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessAlternateDirectly", "AccessAlternateDirectly", properties.AccessAlternateDirectly != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AccessAlternateDirectly) : void 0), ret.addPropertyResult("addSupplementalLogging", "AddSupplementalLogging", properties.AddSupplementalLogging != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AddSupplementalLogging) : void 0), ret.addPropertyResult("additionalArchivedLogDestId", "AdditionalArchivedLogDestId", properties.AdditionalArchivedLogDestId != null ? cfn_parse.FromCloudFormation.getNumber(properties.AdditionalArchivedLogDestId) : void 0), ret.addPropertyResult("allowSelectNestedTables", "AllowSelectNestedTables", properties.AllowSelectNestedTables != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllowSelectNestedTables) : void 0), ret.addPropertyResult("archivedLogDestId", "ArchivedLogDestId", properties.ArchivedLogDestId != null ? cfn_parse.FromCloudFormation.getNumber(properties.ArchivedLogDestId) : void 0), ret.addPropertyResult("archivedLogsOnly", "ArchivedLogsOnly", properties.ArchivedLogsOnly != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ArchivedLogsOnly) : void 0), ret.addPropertyResult("asmPassword", "AsmPassword", properties.AsmPassword != null ? cfn_parse.FromCloudFormation.getString(properties.AsmPassword) : void 0), ret.addPropertyResult("asmServer", "AsmServer", properties.AsmServer != null ? cfn_parse.FromCloudFormation.getString(properties.AsmServer) : void 0), ret.addPropertyResult("asmUser", "AsmUser", properties.AsmUser != null ? cfn_parse.FromCloudFormation.getString(properties.AsmUser) : void 0), ret.addPropertyResult("charLengthSemantics", "CharLengthSemantics", properties.CharLengthSemantics != null ? cfn_parse.FromCloudFormation.getString(properties.CharLengthSemantics) : void 0), ret.addPropertyResult("directPathNoLog", "DirectPathNoLog", properties.DirectPathNoLog != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DirectPathNoLog) : void 0), ret.addPropertyResult("directPathParallelLoad", "DirectPathParallelLoad", properties.DirectPathParallelLoad != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DirectPathParallelLoad) : void 0), ret.addPropertyResult("enableHomogenousTablespace", "EnableHomogenousTablespace", properties.EnableHomogenousTablespace != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableHomogenousTablespace) : void 0), ret.addPropertyResult("extraArchivedLogDestIds", "ExtraArchivedLogDestIds", properties.ExtraArchivedLogDestIds != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getNumber)(properties.ExtraArchivedLogDestIds) : void 0), ret.addPropertyResult("failTasksOnLobTruncation", "FailTasksOnLobTruncation", properties.FailTasksOnLobTruncation != null ? cfn_parse.FromCloudFormation.getBoolean(properties.FailTasksOnLobTruncation) : void 0), ret.addPropertyResult("numberDatatypeScale", "NumberDatatypeScale", properties.NumberDatatypeScale != null ? cfn_parse.FromCloudFormation.getNumber(properties.NumberDatatypeScale) : void 0), ret.addPropertyResult("oraclePathPrefix", "OraclePathPrefix", properties.OraclePathPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.OraclePathPrefix) : void 0), ret.addPropertyResult("parallelAsmReadThreads", "ParallelAsmReadThreads", properties.ParallelAsmReadThreads != null ? cfn_parse.FromCloudFormation.getNumber(properties.ParallelAsmReadThreads) : void 0), ret.addPropertyResult("readAheadBlocks", "ReadAheadBlocks", properties.ReadAheadBlocks != null ? cfn_parse.FromCloudFormation.getNumber(properties.ReadAheadBlocks) : void 0), ret.addPropertyResult("readTableSpaceName", "ReadTableSpaceName", properties.ReadTableSpaceName != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ReadTableSpaceName) : void 0), ret.addPropertyResult("replacePathPrefix", "ReplacePathPrefix", properties.ReplacePathPrefix != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ReplacePathPrefix) : void 0), ret.addPropertyResult("retryInterval", "RetryInterval", properties.RetryInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.RetryInterval) : void 0), ret.addPropertyResult("secretsManagerAccessRoleArn", "SecretsManagerAccessRoleArn", properties.SecretsManagerAccessRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.SecretsManagerAccessRoleArn) : void 0), ret.addPropertyResult("secretsManagerOracleAsmAccessRoleArn", "SecretsManagerOracleAsmAccessRoleArn", properties.SecretsManagerOracleAsmAccessRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.SecretsManagerOracleAsmAccessRoleArn) : void 0), ret.addPropertyResult("secretsManagerOracleAsmSecretId", "SecretsManagerOracleAsmSecretId", properties.SecretsManagerOracleAsmSecretId != null ? cfn_parse.FromCloudFormation.getString(properties.SecretsManagerOracleAsmSecretId) : void 0), ret.addPropertyResult("secretsManagerSecretId", "SecretsManagerSecretId", properties.SecretsManagerSecretId != null ? cfn_parse.FromCloudFormation.getString(properties.SecretsManagerSecretId) : void 0), ret.addPropertyResult("securityDbEncryption", "SecurityDbEncryption", properties.SecurityDbEncryption != null ? cfn_parse.FromCloudFormation.getString(properties.SecurityDbEncryption) : void 0), ret.addPropertyResult("securityDbEncryptionName", "SecurityDbEncryptionName", properties.SecurityDbEncryptionName != null ? cfn_parse.FromCloudFormation.getString(properties.SecurityDbEncryptionName) : void 0), ret.addPropertyResult("spatialDataOptionToGeoJsonFunctionName", "SpatialDataOptionToGeoJsonFunctionName", properties.SpatialDataOptionToGeoJsonFunctionName != null ? cfn_parse.FromCloudFormation.getString(properties.SpatialDataOptionToGeoJsonFunctionName) : void 0), ret.addPropertyResult("standbyDelayTime", "StandbyDelayTime", properties.StandbyDelayTime != null ? cfn_parse.FromCloudFormation.getNumber(properties.StandbyDelayTime) : void 0), ret.addPropertyResult("useAlternateFolderForOnline", "UseAlternateFolderForOnline", properties.UseAlternateFolderForOnline != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseAlternateFolderForOnline) : void 0), ret.addPropertyResult("useBFile", "UseBFile", properties.UseBFile != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseBFile) : void 0), ret.addPropertyResult("useDirectPathFullLoad", "UseDirectPathFullLoad", properties.UseDirectPathFullLoad != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseDirectPathFullLoad) : void 0), ret.addPropertyResult("useLogminerReader", "UseLogminerReader", properties.UseLogminerReader != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseLogminerReader) : void 0), ret.addPropertyResult("usePathPrefix", "UsePathPrefix", properties.UsePathPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.UsePathPrefix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpoint_PostgreSqlSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("afterConnectScript", cdk.validateString)(properties.afterConnectScript)), errors.collect(cdk.propertyValidator("captureDdls", cdk.validateBoolean)(properties.captureDdls)), errors.collect(cdk.propertyValidator("ddlArtifactsSchema", cdk.validateString)(properties.ddlArtifactsSchema)), errors.collect(cdk.propertyValidator("executeTimeout", cdk.validateNumber)(properties.executeTimeout)), errors.collect(cdk.propertyValidator("failTasksOnLobTruncation", cdk.validateBoolean)(properties.failTasksOnLobTruncation)), errors.collect(cdk.propertyValidator("heartbeatEnable", cdk.validateBoolean)(properties.heartbeatEnable)), errors.collect(cdk.propertyValidator("heartbeatFrequency", cdk.validateNumber)(properties.heartbeatFrequency)), errors.collect(cdk.propertyValidator("heartbeatSchema", cdk.validateString)(properties.heartbeatSchema)), errors.collect(cdk.propertyValidator("mapBooleanAsBoolean", cdk.validateBoolean)(properties.mapBooleanAsBoolean)), errors.collect(cdk.propertyValidator("maxFileSize", cdk.validateNumber)(properties.maxFileSize)), errors.collect(cdk.propertyValidator("pluginName", cdk.validateString)(properties.pluginName)), errors.collect(cdk.propertyValidator("secretsManagerAccessRoleArn", cdk.validateString)(properties.secretsManagerAccessRoleArn)), errors.collect(cdk.propertyValidator("secretsManagerSecretId", cdk.validateString)(properties.secretsManagerSecretId)), errors.collect(cdk.propertyValidator("slotName", cdk.validateString)(properties.slotName)), errors.wrap('supplied properties not correct for "PostgreSqlSettingsProperty"');
    }
    function cfnEndpointPostgreSqlSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpoint_PostgreSqlSettingsPropertyValidator(properties).assertSuccess(), { AfterConnectScript: cdk.stringToCloudFormation(properties.afterConnectScript), CaptureDdls: cdk.booleanToCloudFormation(properties.captureDdls), DdlArtifactsSchema: cdk.stringToCloudFormation(properties.ddlArtifactsSchema), ExecuteTimeout: cdk.numberToCloudFormation(properties.executeTimeout), FailTasksOnLobTruncation: cdk.booleanToCloudFormation(properties.failTasksOnLobTruncation), HeartbeatEnable: cdk.booleanToCloudFormation(properties.heartbeatEnable), HeartbeatFrequency: cdk.numberToCloudFormation(properties.heartbeatFrequency), HeartbeatSchema: cdk.stringToCloudFormation(properties.heartbeatSchema), MapBooleanAsBoolean: cdk.booleanToCloudFormation(properties.mapBooleanAsBoolean), MaxFileSize: cdk.numberToCloudFormation(properties.maxFileSize), PluginName: cdk.stringToCloudFormation(properties.pluginName), SecretsManagerAccessRoleArn: cdk.stringToCloudFormation(properties.secretsManagerAccessRoleArn), SecretsManagerSecretId: cdk.stringToCloudFormation(properties.secretsManagerSecretId), SlotName: cdk.stringToCloudFormation(properties.slotName) }) : properties;
    }
    function CfnEndpointPostgreSqlSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("afterConnectScript", "AfterConnectScript", properties.AfterConnectScript != null ? cfn_parse.FromCloudFormation.getString(properties.AfterConnectScript) : void 0), ret.addPropertyResult("captureDdls", "CaptureDdls", properties.CaptureDdls != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CaptureDdls) : void 0), ret.addPropertyResult("ddlArtifactsSchema", "DdlArtifactsSchema", properties.DdlArtifactsSchema != null ? cfn_parse.FromCloudFormation.getString(properties.DdlArtifactsSchema) : void 0), ret.addPropertyResult("executeTimeout", "ExecuteTimeout", properties.ExecuteTimeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.ExecuteTimeout) : void 0), ret.addPropertyResult("failTasksOnLobTruncation", "FailTasksOnLobTruncation", properties.FailTasksOnLobTruncation != null ? cfn_parse.FromCloudFormation.getBoolean(properties.FailTasksOnLobTruncation) : void 0), ret.addPropertyResult("heartbeatEnable", "HeartbeatEnable", properties.HeartbeatEnable != null ? cfn_parse.FromCloudFormation.getBoolean(properties.HeartbeatEnable) : void 0), ret.addPropertyResult("heartbeatFrequency", "HeartbeatFrequency", properties.HeartbeatFrequency != null ? cfn_parse.FromCloudFormation.getNumber(properties.HeartbeatFrequency) : void 0), ret.addPropertyResult("heartbeatSchema", "HeartbeatSchema", properties.HeartbeatSchema != null ? cfn_parse.FromCloudFormation.getString(properties.HeartbeatSchema) : void 0), ret.addPropertyResult("mapBooleanAsBoolean", "MapBooleanAsBoolean", properties.MapBooleanAsBoolean != null ? cfn_parse.FromCloudFormation.getBoolean(properties.MapBooleanAsBoolean) : void 0), ret.addPropertyResult("maxFileSize", "MaxFileSize", properties.MaxFileSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxFileSize) : void 0), ret.addPropertyResult("pluginName", "PluginName", properties.PluginName != null ? cfn_parse.FromCloudFormation.getString(properties.PluginName) : void 0), ret.addPropertyResult("secretsManagerAccessRoleArn", "SecretsManagerAccessRoleArn", properties.SecretsManagerAccessRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.SecretsManagerAccessRoleArn) : void 0), ret.addPropertyResult("secretsManagerSecretId", "SecretsManagerSecretId", properties.SecretsManagerSecretId != null ? cfn_parse.FromCloudFormation.getString(properties.SecretsManagerSecretId) : void 0), ret.addPropertyResult("slotName", "SlotName", properties.SlotName != null ? cfn_parse.FromCloudFormation.getString(properties.SlotName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpoint_RedisSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authPassword", cdk.validateString)(properties.authPassword)), errors.collect(cdk.propertyValidator("authType", cdk.validateString)(properties.authType)), errors.collect(cdk.propertyValidator("authUserName", cdk.validateString)(properties.authUserName)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("serverName", cdk.validateString)(properties.serverName)), errors.collect(cdk.propertyValidator("sslCaCertificateArn", cdk.validateString)(properties.sslCaCertificateArn)), errors.collect(cdk.propertyValidator("sslSecurityProtocol", cdk.validateString)(properties.sslSecurityProtocol)), errors.wrap('supplied properties not correct for "RedisSettingsProperty"');
    }
    function cfnEndpointRedisSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpoint_RedisSettingsPropertyValidator(properties).assertSuccess(), { AuthPassword: cdk.stringToCloudFormation(properties.authPassword), AuthType: cdk.stringToCloudFormation(properties.authType), AuthUserName: cdk.stringToCloudFormation(properties.authUserName), Port: cdk.numberToCloudFormation(properties.port), ServerName: cdk.stringToCloudFormation(properties.serverName), SslCaCertificateArn: cdk.stringToCloudFormation(properties.sslCaCertificateArn), SslSecurityProtocol: cdk.stringToCloudFormation(properties.sslSecurityProtocol) }) : properties;
    }
    function CfnEndpointRedisSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authPassword", "AuthPassword", properties.AuthPassword != null ? cfn_parse.FromCloudFormation.getString(properties.AuthPassword) : void 0), ret.addPropertyResult("authType", "AuthType", properties.AuthType != null ? cfn_parse.FromCloudFormation.getString(properties.AuthType) : void 0), ret.addPropertyResult("authUserName", "AuthUserName", properties.AuthUserName != null ? cfn_parse.FromCloudFormation.getString(properties.AuthUserName) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addPropertyResult("serverName", "ServerName", properties.ServerName != null ? cfn_parse.FromCloudFormation.getString(properties.ServerName) : void 0), ret.addPropertyResult("sslCaCertificateArn", "SslCaCertificateArn", properties.SslCaCertificateArn != null ? cfn_parse.FromCloudFormation.getString(properties.SslCaCertificateArn) : void 0), ret.addPropertyResult("sslSecurityProtocol", "SslSecurityProtocol", properties.SslSecurityProtocol != null ? cfn_parse.FromCloudFormation.getString(properties.SslSecurityProtocol) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpoint_RedshiftSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acceptAnyDate", cdk.validateBoolean)(properties.acceptAnyDate)), errors.collect(cdk.propertyValidator("afterConnectScript", cdk.validateString)(properties.afterConnectScript)), errors.collect(cdk.propertyValidator("bucketFolder", cdk.validateString)(properties.bucketFolder)), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.collect(cdk.propertyValidator("caseSensitiveNames", cdk.validateBoolean)(properties.caseSensitiveNames)), errors.collect(cdk.propertyValidator("compUpdate", cdk.validateBoolean)(properties.compUpdate)), errors.collect(cdk.propertyValidator("connectionTimeout", cdk.validateNumber)(properties.connectionTimeout)), errors.collect(cdk.propertyValidator("dateFormat", cdk.validateString)(properties.dateFormat)), errors.collect(cdk.propertyValidator("emptyAsNull", cdk.validateBoolean)(properties.emptyAsNull)), errors.collect(cdk.propertyValidator("encryptionMode", cdk.validateString)(properties.encryptionMode)), errors.collect(cdk.propertyValidator("explicitIds", cdk.validateBoolean)(properties.explicitIds)), errors.collect(cdk.propertyValidator("fileTransferUploadStreams", cdk.validateNumber)(properties.fileTransferUploadStreams)), errors.collect(cdk.propertyValidator("loadTimeout", cdk.validateNumber)(properties.loadTimeout)), errors.collect(cdk.propertyValidator("mapBooleanAsBoolean", cdk.validateBoolean)(properties.mapBooleanAsBoolean)), errors.collect(cdk.propertyValidator("maxFileSize", cdk.validateNumber)(properties.maxFileSize)), errors.collect(cdk.propertyValidator("removeQuotes", cdk.validateBoolean)(properties.removeQuotes)), errors.collect(cdk.propertyValidator("replaceChars", cdk.validateString)(properties.replaceChars)), errors.collect(cdk.propertyValidator("replaceInvalidChars", cdk.validateString)(properties.replaceInvalidChars)), errors.collect(cdk.propertyValidator("secretsManagerAccessRoleArn", cdk.validateString)(properties.secretsManagerAccessRoleArn)), errors.collect(cdk.propertyValidator("secretsManagerSecretId", cdk.validateString)(properties.secretsManagerSecretId)), errors.collect(cdk.propertyValidator("serverSideEncryptionKmsKeyId", cdk.validateString)(properties.serverSideEncryptionKmsKeyId)), errors.collect(cdk.propertyValidator("serviceAccessRoleArn", cdk.validateString)(properties.serviceAccessRoleArn)), errors.collect(cdk.propertyValidator("timeFormat", cdk.validateString)(properties.timeFormat)), errors.collect(cdk.propertyValidator("trimBlanks", cdk.validateBoolean)(properties.trimBlanks)), errors.collect(cdk.propertyValidator("truncateColumns", cdk.validateBoolean)(properties.truncateColumns)), errors.collect(cdk.propertyValidator("writeBufferSize", cdk.validateNumber)(properties.writeBufferSize)), errors.wrap('supplied properties not correct for "RedshiftSettingsProperty"');
    }
    function cfnEndpointRedshiftSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpoint_RedshiftSettingsPropertyValidator(properties).assertSuccess(), { AcceptAnyDate: cdk.booleanToCloudFormation(properties.acceptAnyDate), AfterConnectScript: cdk.stringToCloudFormation(properties.afterConnectScript), BucketFolder: cdk.stringToCloudFormation(properties.bucketFolder), BucketName: cdk.stringToCloudFormation(properties.bucketName), CaseSensitiveNames: cdk.booleanToCloudFormation(properties.caseSensitiveNames), CompUpdate: cdk.booleanToCloudFormation(properties.compUpdate), ConnectionTimeout: cdk.numberToCloudFormation(properties.connectionTimeout), DateFormat: cdk.stringToCloudFormation(properties.dateFormat), EmptyAsNull: cdk.booleanToCloudFormation(properties.emptyAsNull), EncryptionMode: cdk.stringToCloudFormation(properties.encryptionMode), ExplicitIds: cdk.booleanToCloudFormation(properties.explicitIds), FileTransferUploadStreams: cdk.numberToCloudFormation(properties.fileTransferUploadStreams), LoadTimeout: cdk.numberToCloudFormation(properties.loadTimeout), MapBooleanAsBoolean: cdk.booleanToCloudFormation(properties.mapBooleanAsBoolean), MaxFileSize: cdk.numberToCloudFormation(properties.maxFileSize), RemoveQuotes: cdk.booleanToCloudFormation(properties.removeQuotes), ReplaceChars: cdk.stringToCloudFormation(properties.replaceChars), ReplaceInvalidChars: cdk.stringToCloudFormation(properties.replaceInvalidChars), SecretsManagerAccessRoleArn: cdk.stringToCloudFormation(properties.secretsManagerAccessRoleArn), SecretsManagerSecretId: cdk.stringToCloudFormation(properties.secretsManagerSecretId), ServerSideEncryptionKmsKeyId: cdk.stringToCloudFormation(properties.serverSideEncryptionKmsKeyId), ServiceAccessRoleArn: cdk.stringToCloudFormation(properties.serviceAccessRoleArn), TimeFormat: cdk.stringToCloudFormation(properties.timeFormat), TrimBlanks: cdk.booleanToCloudFormation(properties.trimBlanks), TruncateColumns: cdk.booleanToCloudFormation(properties.truncateColumns), WriteBufferSize: cdk.numberToCloudFormation(properties.writeBufferSize) }) : properties;
    }
    function CfnEndpointRedshiftSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("acceptAnyDate", "AcceptAnyDate", properties.AcceptAnyDate != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AcceptAnyDate) : void 0), ret.addPropertyResult("afterConnectScript", "AfterConnectScript", properties.AfterConnectScript != null ? cfn_parse.FromCloudFormation.getString(properties.AfterConnectScript) : void 0), ret.addPropertyResult("bucketFolder", "BucketFolder", properties.BucketFolder != null ? cfn_parse.FromCloudFormation.getString(properties.BucketFolder) : void 0), ret.addPropertyResult("bucketName", "BucketName", properties.BucketName != null ? cfn_parse.FromCloudFormation.getString(properties.BucketName) : void 0), ret.addPropertyResult("caseSensitiveNames", "CaseSensitiveNames", properties.CaseSensitiveNames != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CaseSensitiveNames) : void 0), ret.addPropertyResult("compUpdate", "CompUpdate", properties.CompUpdate != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CompUpdate) : void 0), ret.addPropertyResult("connectionTimeout", "ConnectionTimeout", properties.ConnectionTimeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.ConnectionTimeout) : void 0), ret.addPropertyResult("dateFormat", "DateFormat", properties.DateFormat != null ? cfn_parse.FromCloudFormation.getString(properties.DateFormat) : void 0), ret.addPropertyResult("emptyAsNull", "EmptyAsNull", properties.EmptyAsNull != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EmptyAsNull) : void 0), ret.addPropertyResult("encryptionMode", "EncryptionMode", properties.EncryptionMode != null ? cfn_parse.FromCloudFormation.getString(properties.EncryptionMode) : void 0), ret.addPropertyResult("explicitIds", "ExplicitIds", properties.ExplicitIds != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ExplicitIds) : void 0), ret.addPropertyResult("fileTransferUploadStreams", "FileTransferUploadStreams", properties.FileTransferUploadStreams != null ? cfn_parse.FromCloudFormation.getNumber(properties.FileTransferUploadStreams) : void 0), ret.addPropertyResult("loadTimeout", "LoadTimeout", properties.LoadTimeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.LoadTimeout) : void 0), ret.addPropertyResult("mapBooleanAsBoolean", "MapBooleanAsBoolean", properties.MapBooleanAsBoolean != null ? cfn_parse.FromCloudFormation.getBoolean(properties.MapBooleanAsBoolean) : void 0), ret.addPropertyResult("maxFileSize", "MaxFileSize", properties.MaxFileSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxFileSize) : void 0), ret.addPropertyResult("removeQuotes", "RemoveQuotes", properties.RemoveQuotes != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RemoveQuotes) : void 0), ret.addPropertyResult("replaceChars", "ReplaceChars", properties.ReplaceChars != null ? cfn_parse.FromCloudFormation.getString(properties.ReplaceChars) : void 0), ret.addPropertyResult("replaceInvalidChars", "ReplaceInvalidChars", properties.ReplaceInvalidChars != null ? cfn_parse.FromCloudFormation.getString(properties.ReplaceInvalidChars) : void 0), ret.addPropertyResult("secretsManagerAccessRoleArn", "SecretsManagerAccessRoleArn", properties.SecretsManagerAccessRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.SecretsManagerAccessRoleArn) : void 0), ret.addPropertyResult("secretsManagerSecretId", "SecretsManagerSecretId", properties.SecretsManagerSecretId != null ? cfn_parse.FromCloudFormation.getString(properties.SecretsManagerSecretId) : void 0), ret.addPropertyResult("serverSideEncryptionKmsKeyId", "ServerSideEncryptionKmsKeyId", properties.ServerSideEncryptionKmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.ServerSideEncryptionKmsKeyId) : void 0), ret.addPropertyResult("serviceAccessRoleArn", "ServiceAccessRoleArn", properties.ServiceAccessRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceAccessRoleArn) : void 0), ret.addPropertyResult("timeFormat", "TimeFormat", properties.TimeFormat != null ? cfn_parse.FromCloudFormation.getString(properties.TimeFormat) : void 0), ret.addPropertyResult("trimBlanks", "TrimBlanks", properties.TrimBlanks != null ? cfn_parse.FromCloudFormation.getBoolean(properties.TrimBlanks) : void 0), ret.addPropertyResult("truncateColumns", "TruncateColumns", properties.TruncateColumns != null ? cfn_parse.FromCloudFormation.getBoolean(properties.TruncateColumns) : void 0), ret.addPropertyResult("writeBufferSize", "WriteBufferSize", properties.WriteBufferSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.WriteBufferSize) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpoint_S3SettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("addColumnName", cdk.validateBoolean)(properties.addColumnName)), errors.collect(cdk.propertyValidator("bucketFolder", cdk.validateString)(properties.bucketFolder)), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.collect(cdk.propertyValidator("cannedAclForObjects", cdk.validateString)(properties.cannedAclForObjects)), errors.collect(cdk.propertyValidator("cdcInsertsAndUpdates", cdk.validateBoolean)(properties.cdcInsertsAndUpdates)), errors.collect(cdk.propertyValidator("cdcInsertsOnly", cdk.validateBoolean)(properties.cdcInsertsOnly)), errors.collect(cdk.propertyValidator("cdcMaxBatchInterval", cdk.validateNumber)(properties.cdcMaxBatchInterval)), errors.collect(cdk.propertyValidator("cdcMinFileSize", cdk.validateNumber)(properties.cdcMinFileSize)), errors.collect(cdk.propertyValidator("cdcPath", cdk.validateString)(properties.cdcPath)), errors.collect(cdk.propertyValidator("compressionType", cdk.validateString)(properties.compressionType)), errors.collect(cdk.propertyValidator("csvDelimiter", cdk.validateString)(properties.csvDelimiter)), errors.collect(cdk.propertyValidator("csvNoSupValue", cdk.validateString)(properties.csvNoSupValue)), errors.collect(cdk.propertyValidator("csvNullValue", cdk.validateString)(properties.csvNullValue)), errors.collect(cdk.propertyValidator("csvRowDelimiter", cdk.validateString)(properties.csvRowDelimiter)), errors.collect(cdk.propertyValidator("dataFormat", cdk.validateString)(properties.dataFormat)), errors.collect(cdk.propertyValidator("dataPageSize", cdk.validateNumber)(properties.dataPageSize)), errors.collect(cdk.propertyValidator("datePartitionDelimiter", cdk.validateString)(properties.datePartitionDelimiter)), errors.collect(cdk.propertyValidator("datePartitionEnabled", cdk.validateBoolean)(properties.datePartitionEnabled)), errors.collect(cdk.propertyValidator("datePartitionSequence", cdk.validateString)(properties.datePartitionSequence)), errors.collect(cdk.propertyValidator("datePartitionTimezone", cdk.validateString)(properties.datePartitionTimezone)), errors.collect(cdk.propertyValidator("dictPageSizeLimit", cdk.validateNumber)(properties.dictPageSizeLimit)), errors.collect(cdk.propertyValidator("enableStatistics", cdk.validateBoolean)(properties.enableStatistics)), errors.collect(cdk.propertyValidator("encodingType", cdk.validateString)(properties.encodingType)), errors.collect(cdk.propertyValidator("encryptionMode", cdk.validateString)(properties.encryptionMode)), errors.collect(cdk.propertyValidator("externalTableDefinition", cdk.validateString)(properties.externalTableDefinition)), errors.collect(cdk.propertyValidator("ignoreHeaderRows", cdk.validateNumber)(properties.ignoreHeaderRows)), errors.collect(cdk.propertyValidator("includeOpForFullLoad", cdk.validateBoolean)(properties.includeOpForFullLoad)), errors.collect(cdk.propertyValidator("maxFileSize", cdk.validateNumber)(properties.maxFileSize)), errors.collect(cdk.propertyValidator("parquetTimestampInMillisecond", cdk.validateBoolean)(properties.parquetTimestampInMillisecond)), errors.collect(cdk.propertyValidator("parquetVersion", cdk.validateString)(properties.parquetVersion)), errors.collect(cdk.propertyValidator("preserveTransactions", cdk.validateBoolean)(properties.preserveTransactions)), errors.collect(cdk.propertyValidator("rfc4180", cdk.validateBoolean)(properties.rfc4180)), errors.collect(cdk.propertyValidator("rowGroupLength", cdk.validateNumber)(properties.rowGroupLength)), errors.collect(cdk.propertyValidator("serverSideEncryptionKmsKeyId", cdk.validateString)(properties.serverSideEncryptionKmsKeyId)), errors.collect(cdk.propertyValidator("serviceAccessRoleArn", cdk.validateString)(properties.serviceAccessRoleArn)), errors.collect(cdk.propertyValidator("timestampColumnName", cdk.validateString)(properties.timestampColumnName)), errors.collect(cdk.propertyValidator("useCsvNoSupValue", cdk.validateBoolean)(properties.useCsvNoSupValue)), errors.collect(cdk.propertyValidator("useTaskStartTimeForFullLoadTimestamp", cdk.validateBoolean)(properties.useTaskStartTimeForFullLoadTimestamp)), errors.wrap('supplied properties not correct for "S3SettingsProperty"');
    }
    function cfnEndpointS3SettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpoint_S3SettingsPropertyValidator(properties).assertSuccess(), { AddColumnName: cdk.booleanToCloudFormation(properties.addColumnName), BucketFolder: cdk.stringToCloudFormation(properties.bucketFolder), BucketName: cdk.stringToCloudFormation(properties.bucketName), CannedAclForObjects: cdk.stringToCloudFormation(properties.cannedAclForObjects), CdcInsertsAndUpdates: cdk.booleanToCloudFormation(properties.cdcInsertsAndUpdates), CdcInsertsOnly: cdk.booleanToCloudFormation(properties.cdcInsertsOnly), CdcMaxBatchInterval: cdk.numberToCloudFormation(properties.cdcMaxBatchInterval), CdcMinFileSize: cdk.numberToCloudFormation(properties.cdcMinFileSize), CdcPath: cdk.stringToCloudFormation(properties.cdcPath), CompressionType: cdk.stringToCloudFormation(properties.compressionType), CsvDelimiter: cdk.stringToCloudFormation(properties.csvDelimiter), CsvNoSupValue: cdk.stringToCloudFormation(properties.csvNoSupValue), CsvNullValue: cdk.stringToCloudFormation(properties.csvNullValue), CsvRowDelimiter: cdk.stringToCloudFormation(properties.csvRowDelimiter), DataFormat: cdk.stringToCloudFormation(properties.dataFormat), DataPageSize: cdk.numberToCloudFormation(properties.dataPageSize), DatePartitionDelimiter: cdk.stringToCloudFormation(properties.datePartitionDelimiter), DatePartitionEnabled: cdk.booleanToCloudFormation(properties.datePartitionEnabled), DatePartitionSequence: cdk.stringToCloudFormation(properties.datePartitionSequence), DatePartitionTimezone: cdk.stringToCloudFormation(properties.datePartitionTimezone), DictPageSizeLimit: cdk.numberToCloudFormation(properties.dictPageSizeLimit), EnableStatistics: cdk.booleanToCloudFormation(properties.enableStatistics), EncodingType: cdk.stringToCloudFormation(properties.encodingType), EncryptionMode: cdk.stringToCloudFormation(properties.encryptionMode), ExternalTableDefinition: cdk.stringToCloudFormation(properties.externalTableDefinition), IgnoreHeaderRows: cdk.numberToCloudFormation(properties.ignoreHeaderRows), IncludeOpForFullLoad: cdk.booleanToCloudFormation(properties.includeOpForFullLoad), MaxFileSize: cdk.numberToCloudFormation(properties.maxFileSize), ParquetTimestampInMillisecond: cdk.booleanToCloudFormation(properties.parquetTimestampInMillisecond), ParquetVersion: cdk.stringToCloudFormation(properties.parquetVersion), PreserveTransactions: cdk.booleanToCloudFormation(properties.preserveTransactions), Rfc4180: cdk.booleanToCloudFormation(properties.rfc4180), RowGroupLength: cdk.numberToCloudFormation(properties.rowGroupLength), ServerSideEncryptionKmsKeyId: cdk.stringToCloudFormation(properties.serverSideEncryptionKmsKeyId), ServiceAccessRoleArn: cdk.stringToCloudFormation(properties.serviceAccessRoleArn), TimestampColumnName: cdk.stringToCloudFormation(properties.timestampColumnName), UseCsvNoSupValue: cdk.booleanToCloudFormation(properties.useCsvNoSupValue), UseTaskStartTimeForFullLoadTimestamp: cdk.booleanToCloudFormation(properties.useTaskStartTimeForFullLoadTimestamp) }) : properties;
    }
    function CfnEndpointS3SettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("addColumnName", "AddColumnName", properties.AddColumnName != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AddColumnName) : void 0), ret.addPropertyResult("bucketFolder", "BucketFolder", properties.BucketFolder != null ? cfn_parse.FromCloudFormation.getString(properties.BucketFolder) : void 0), ret.addPropertyResult("bucketName", "BucketName", properties.BucketName != null ? cfn_parse.FromCloudFormation.getString(properties.BucketName) : void 0), ret.addPropertyResult("cannedAclForObjects", "CannedAclForObjects", properties.CannedAclForObjects != null ? cfn_parse.FromCloudFormation.getString(properties.CannedAclForObjects) : void 0), ret.addPropertyResult("cdcInsertsAndUpdates", "CdcInsertsAndUpdates", properties.CdcInsertsAndUpdates != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CdcInsertsAndUpdates) : void 0), ret.addPropertyResult("cdcInsertsOnly", "CdcInsertsOnly", properties.CdcInsertsOnly != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CdcInsertsOnly) : void 0), ret.addPropertyResult("cdcMaxBatchInterval", "CdcMaxBatchInterval", properties.CdcMaxBatchInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.CdcMaxBatchInterval) : void 0), ret.addPropertyResult("cdcMinFileSize", "CdcMinFileSize", properties.CdcMinFileSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.CdcMinFileSize) : void 0), ret.addPropertyResult("cdcPath", "CdcPath", properties.CdcPath != null ? cfn_parse.FromCloudFormation.getString(properties.CdcPath) : void 0), ret.addPropertyResult("compressionType", "CompressionType", properties.CompressionType != null ? cfn_parse.FromCloudFormation.getString(properties.CompressionType) : void 0), ret.addPropertyResult("csvDelimiter", "CsvDelimiter", properties.CsvDelimiter != null ? cfn_parse.FromCloudFormation.getString(properties.CsvDelimiter) : void 0), ret.addPropertyResult("csvNoSupValue", "CsvNoSupValue", properties.CsvNoSupValue != null ? cfn_parse.FromCloudFormation.getString(properties.CsvNoSupValue) : void 0), ret.addPropertyResult("csvNullValue", "CsvNullValue", properties.CsvNullValue != null ? cfn_parse.FromCloudFormation.getString(properties.CsvNullValue) : void 0), ret.addPropertyResult("csvRowDelimiter", "CsvRowDelimiter", properties.CsvRowDelimiter != null ? cfn_parse.FromCloudFormation.getString(properties.CsvRowDelimiter) : void 0), ret.addPropertyResult("dataFormat", "DataFormat", properties.DataFormat != null ? cfn_parse.FromCloudFormation.getString(properties.DataFormat) : void 0), ret.addPropertyResult("dataPageSize", "DataPageSize", properties.DataPageSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.DataPageSize) : void 0), ret.addPropertyResult("datePartitionDelimiter", "DatePartitionDelimiter", properties.DatePartitionDelimiter != null ? cfn_parse.FromCloudFormation.getString(properties.DatePartitionDelimiter) : void 0), ret.addPropertyResult("datePartitionEnabled", "DatePartitionEnabled", properties.DatePartitionEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DatePartitionEnabled) : void 0), ret.addPropertyResult("datePartitionSequence", "DatePartitionSequence", properties.DatePartitionSequence != null ? cfn_parse.FromCloudFormation.getString(properties.DatePartitionSequence) : void 0), ret.addPropertyResult("datePartitionTimezone", "DatePartitionTimezone", properties.DatePartitionTimezone != null ? cfn_parse.FromCloudFormation.getString(properties.DatePartitionTimezone) : void 0), ret.addPropertyResult("dictPageSizeLimit", "DictPageSizeLimit", properties.DictPageSizeLimit != null ? cfn_parse.FromCloudFormation.getNumber(properties.DictPageSizeLimit) : void 0), ret.addPropertyResult("enableStatistics", "EnableStatistics", properties.EnableStatistics != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableStatistics) : void 0), ret.addPropertyResult("encodingType", "EncodingType", properties.EncodingType != null ? cfn_parse.FromCloudFormation.getString(properties.EncodingType) : void 0), ret.addPropertyResult("encryptionMode", "EncryptionMode", properties.EncryptionMode != null ? cfn_parse.FromCloudFormation.getString(properties.EncryptionMode) : void 0), ret.addPropertyResult("externalTableDefinition", "ExternalTableDefinition", properties.ExternalTableDefinition != null ? cfn_parse.FromCloudFormation.getString(properties.ExternalTableDefinition) : void 0), ret.addPropertyResult("ignoreHeaderRows", "IgnoreHeaderRows", properties.IgnoreHeaderRows != null ? cfn_parse.FromCloudFormation.getNumber(properties.IgnoreHeaderRows) : void 0), ret.addPropertyResult("includeOpForFullLoad", "IncludeOpForFullLoad", properties.IncludeOpForFullLoad != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeOpForFullLoad) : void 0), ret.addPropertyResult("maxFileSize", "MaxFileSize", properties.MaxFileSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxFileSize) : void 0), ret.addPropertyResult("parquetTimestampInMillisecond", "ParquetTimestampInMillisecond", properties.ParquetTimestampInMillisecond != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ParquetTimestampInMillisecond) : void 0), ret.addPropertyResult("parquetVersion", "ParquetVersion", properties.ParquetVersion != null ? cfn_parse.FromCloudFormation.getString(properties.ParquetVersion) : void 0), ret.addPropertyResult("preserveTransactions", "PreserveTransactions", properties.PreserveTransactions != null ? cfn_parse.FromCloudFormation.getBoolean(properties.PreserveTransactions) : void 0), ret.addPropertyResult("rfc4180", "Rfc4180", properties.Rfc4180 != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Rfc4180) : void 0), ret.addPropertyResult("rowGroupLength", "RowGroupLength", properties.RowGroupLength != null ? cfn_parse.FromCloudFormation.getNumber(properties.RowGroupLength) : void 0), ret.addPropertyResult("serverSideEncryptionKmsKeyId", "ServerSideEncryptionKmsKeyId", properties.ServerSideEncryptionKmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.ServerSideEncryptionKmsKeyId) : void 0), ret.addPropertyResult("serviceAccessRoleArn", "ServiceAccessRoleArn", properties.ServiceAccessRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceAccessRoleArn) : void 0), ret.addPropertyResult("timestampColumnName", "TimestampColumnName", properties.TimestampColumnName != null ? cfn_parse.FromCloudFormation.getString(properties.TimestampColumnName) : void 0), ret.addPropertyResult("useCsvNoSupValue", "UseCsvNoSupValue", properties.UseCsvNoSupValue != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseCsvNoSupValue) : void 0), ret.addPropertyResult("useTaskStartTimeForFullLoadTimestamp", "UseTaskStartTimeForFullLoadTimestamp", properties.UseTaskStartTimeForFullLoadTimestamp != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseTaskStartTimeForFullLoadTimestamp) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpoint_SybaseSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("secretsManagerAccessRoleArn", cdk.validateString)(properties.secretsManagerAccessRoleArn)), errors.collect(cdk.propertyValidator("secretsManagerSecretId", cdk.validateString)(properties.secretsManagerSecretId)), errors.wrap('supplied properties not correct for "SybaseSettingsProperty"');
    }
    function cfnEndpointSybaseSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpoint_SybaseSettingsPropertyValidator(properties).assertSuccess(), { SecretsManagerAccessRoleArn: cdk.stringToCloudFormation(properties.secretsManagerAccessRoleArn), SecretsManagerSecretId: cdk.stringToCloudFormation(properties.secretsManagerSecretId) }) : properties;
    }
    function CfnEndpointSybaseSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("secretsManagerAccessRoleArn", "SecretsManagerAccessRoleArn", properties.SecretsManagerAccessRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.SecretsManagerAccessRoleArn) : void 0), ret.addPropertyResult("secretsManagerSecretId", "SecretsManagerSecretId", properties.SecretsManagerSecretId != null ? cfn_parse.FromCloudFormation.getString(properties.SecretsManagerSecretId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEventSubscriptionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("eventCategories", cdk.listValidator(cdk.validateString))(properties.eventCategories)), errors.collect(cdk.propertyValidator("snsTopicArn", cdk.requiredValidator)(properties.snsTopicArn)), errors.collect(cdk.propertyValidator("snsTopicArn", cdk.validateString)(properties.snsTopicArn)), errors.collect(cdk.propertyValidator("sourceIds", cdk.listValidator(cdk.validateString))(properties.sourceIds)), errors.collect(cdk.propertyValidator("sourceType", cdk.validateString)(properties.sourceType)), errors.collect(cdk.propertyValidator("subscriptionName", cdk.validateString)(properties.subscriptionName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnEventSubscriptionProps"');
    }
    function cfnEventSubscriptionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventSubscriptionPropsValidator(properties).assertSuccess(), { SnsTopicArn: cdk.stringToCloudFormation(properties.snsTopicArn), Enabled: cdk.booleanToCloudFormation(properties.enabled), EventCategories: cdk.listMapper(cdk.stringToCloudFormation)(properties.eventCategories), SourceIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.sourceIds), SourceType: cdk.stringToCloudFormation(properties.sourceType), SubscriptionName: cdk.stringToCloudFormation(properties.subscriptionName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnEventSubscriptionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("snsTopicArn", "SnsTopicArn", cfn_parse.FromCloudFormation.getString(properties.SnsTopicArn)), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("eventCategories", "EventCategories", properties.EventCategories != null ? cfn_parse.FromCloudFormation.getStringArray(properties.EventCategories) : void 0), ret.addPropertyResult("sourceIds", "SourceIds", properties.SourceIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SourceIds) : void 0), ret.addPropertyResult("sourceType", "SourceType", properties.SourceType != null ? cfn_parse.FromCloudFormation.getString(properties.SourceType) : void 0), ret.addPropertyResult("subscriptionName", "SubscriptionName", properties.SubscriptionName != null ? cfn_parse.FromCloudFormation.getString(properties.SubscriptionName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEventSubscription = class _CfnEventSubscription extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEventSubscriptionPropsFromCloudFormation(resourceProperties), ret = new _CfnEventSubscription(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEventSubscription.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_dms_CfnEventSubscriptionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEventSubscription), error;
        }
        cdk.requireProperty(props, "snsTopicArn", this), this.snsTopicArn = props.snsTopicArn, this.enabled = props.enabled, this.eventCategories = props.eventCategories, this.sourceIds = props.sourceIds, this.sourceType = props.sourceType, this.subscriptionName = props.subscriptionName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DMS::EventSubscription", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEventSubscription.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { snsTopicArn: this.snsTopicArn, enabled: this.enabled, eventCategories: this.eventCategories, sourceIds: this.sourceIds, sourceType: this.sourceType, subscriptionName: this.subscriptionName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnEventSubscriptionPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnEventSubscription[_c] = { fqn: "aws-cdk-lib.aws_dms.CfnEventSubscription", version: "2.80.0" }, CfnEventSubscription.CFN_RESOURCE_TYPE_NAME = "AWS::DMS::EventSubscription", exports2.CfnEventSubscription = CfnEventSubscription;
    function CfnReplicationInstancePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allocatedStorage", cdk.validateNumber)(properties.allocatedStorage)), errors.collect(cdk.propertyValidator("allowMajorVersionUpgrade", cdk.validateBoolean)(properties.allowMajorVersionUpgrade)), errors.collect(cdk.propertyValidator("autoMinorVersionUpgrade", cdk.validateBoolean)(properties.autoMinorVersionUpgrade)), errors.collect(cdk.propertyValidator("availabilityZone", cdk.validateString)(properties.availabilityZone)), errors.collect(cdk.propertyValidator("engineVersion", cdk.validateString)(properties.engineVersion)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("multiAz", cdk.validateBoolean)(properties.multiAz)), errors.collect(cdk.propertyValidator("preferredMaintenanceWindow", cdk.validateString)(properties.preferredMaintenanceWindow)), errors.collect(cdk.propertyValidator("publiclyAccessible", cdk.validateBoolean)(properties.publiclyAccessible)), errors.collect(cdk.propertyValidator("replicationInstanceClass", cdk.requiredValidator)(properties.replicationInstanceClass)), errors.collect(cdk.propertyValidator("replicationInstanceClass", cdk.validateString)(properties.replicationInstanceClass)), errors.collect(cdk.propertyValidator("replicationInstanceIdentifier", cdk.validateString)(properties.replicationInstanceIdentifier)), errors.collect(cdk.propertyValidator("replicationSubnetGroupIdentifier", cdk.validateString)(properties.replicationSubnetGroupIdentifier)), errors.collect(cdk.propertyValidator("resourceIdentifier", cdk.validateString)(properties.resourceIdentifier)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpcSecurityGroupIds", cdk.listValidator(cdk.validateString))(properties.vpcSecurityGroupIds)), errors.wrap('supplied properties not correct for "CfnReplicationInstanceProps"');
    }
    function cfnReplicationInstancePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReplicationInstancePropsValidator(properties).assertSuccess(), { ReplicationInstanceClass: cdk.stringToCloudFormation(properties.replicationInstanceClass), AllocatedStorage: cdk.numberToCloudFormation(properties.allocatedStorage), AllowMajorVersionUpgrade: cdk.booleanToCloudFormation(properties.allowMajorVersionUpgrade), AutoMinorVersionUpgrade: cdk.booleanToCloudFormation(properties.autoMinorVersionUpgrade), AvailabilityZone: cdk.stringToCloudFormation(properties.availabilityZone), EngineVersion: cdk.stringToCloudFormation(properties.engineVersion), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), MultiAZ: cdk.booleanToCloudFormation(properties.multiAz), PreferredMaintenanceWindow: cdk.stringToCloudFormation(properties.preferredMaintenanceWindow), PubliclyAccessible: cdk.booleanToCloudFormation(properties.publiclyAccessible), ReplicationInstanceIdentifier: cdk.stringToCloudFormation(properties.replicationInstanceIdentifier), ReplicationSubnetGroupIdentifier: cdk.stringToCloudFormation(properties.replicationSubnetGroupIdentifier), ResourceIdentifier: cdk.stringToCloudFormation(properties.resourceIdentifier), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VpcSecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.vpcSecurityGroupIds) }) : properties;
    }
    function CfnReplicationInstancePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("replicationInstanceClass", "ReplicationInstanceClass", cfn_parse.FromCloudFormation.getString(properties.ReplicationInstanceClass)), ret.addPropertyResult("allocatedStorage", "AllocatedStorage", properties.AllocatedStorage != null ? cfn_parse.FromCloudFormation.getNumber(properties.AllocatedStorage) : void 0), ret.addPropertyResult("allowMajorVersionUpgrade", "AllowMajorVersionUpgrade", properties.AllowMajorVersionUpgrade != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllowMajorVersionUpgrade) : void 0), ret.addPropertyResult("autoMinorVersionUpgrade", "AutoMinorVersionUpgrade", properties.AutoMinorVersionUpgrade != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AutoMinorVersionUpgrade) : void 0), ret.addPropertyResult("availabilityZone", "AvailabilityZone", properties.AvailabilityZone != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityZone) : void 0), ret.addPropertyResult("engineVersion", "EngineVersion", properties.EngineVersion != null ? cfn_parse.FromCloudFormation.getString(properties.EngineVersion) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("multiAz", "MultiAZ", properties.MultiAZ != null ? cfn_parse.FromCloudFormation.getBoolean(properties.MultiAZ) : void 0), ret.addPropertyResult("preferredMaintenanceWindow", "PreferredMaintenanceWindow", properties.PreferredMaintenanceWindow != null ? cfn_parse.FromCloudFormation.getString(properties.PreferredMaintenanceWindow) : void 0), ret.addPropertyResult("publiclyAccessible", "PubliclyAccessible", properties.PubliclyAccessible != null ? cfn_parse.FromCloudFormation.getBoolean(properties.PubliclyAccessible) : void 0), ret.addPropertyResult("replicationInstanceIdentifier", "ReplicationInstanceIdentifier", properties.ReplicationInstanceIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.ReplicationInstanceIdentifier) : void 0), ret.addPropertyResult("replicationSubnetGroupIdentifier", "ReplicationSubnetGroupIdentifier", properties.ReplicationSubnetGroupIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.ReplicationSubnetGroupIdentifier) : void 0), ret.addPropertyResult("resourceIdentifier", "ResourceIdentifier", properties.ResourceIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceIdentifier) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("vpcSecurityGroupIds", "VpcSecurityGroupIds", properties.VpcSecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.VpcSecurityGroupIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnReplicationInstance = class _CfnReplicationInstance extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnReplicationInstancePropsFromCloudFormation(resourceProperties), ret = new _CfnReplicationInstance(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnReplicationInstance.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_dms_CfnReplicationInstanceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnReplicationInstance), error;
        }
        cdk.requireProperty(props, "replicationInstanceClass", this), this.attrReplicationInstancePrivateIpAddresses = cdk.Token.asString(this.getAtt("ReplicationInstancePrivateIpAddresses", cdk.ResolutionTypeHint.STRING)), this.attrReplicationInstancePublicIpAddresses = cdk.Token.asString(this.getAtt("ReplicationInstancePublicIpAddresses", cdk.ResolutionTypeHint.STRING)), this.replicationInstanceClass = props.replicationInstanceClass, this.allocatedStorage = props.allocatedStorage, this.allowMajorVersionUpgrade = props.allowMajorVersionUpgrade, this.autoMinorVersionUpgrade = props.autoMinorVersionUpgrade, this.availabilityZone = props.availabilityZone, this.engineVersion = props.engineVersion, this.kmsKeyId = props.kmsKeyId, this.multiAz = props.multiAz, this.preferredMaintenanceWindow = props.preferredMaintenanceWindow, this.publiclyAccessible = props.publiclyAccessible, this.replicationInstanceIdentifier = props.replicationInstanceIdentifier, this.replicationSubnetGroupIdentifier = props.replicationSubnetGroupIdentifier, this.resourceIdentifier = props.resourceIdentifier, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DMS::ReplicationInstance", props.tags, { tagPropertyName: "tags" }), this.vpcSecurityGroupIds = props.vpcSecurityGroupIds;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnReplicationInstance.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { replicationInstanceClass: this.replicationInstanceClass, allocatedStorage: this.allocatedStorage, allowMajorVersionUpgrade: this.allowMajorVersionUpgrade, autoMinorVersionUpgrade: this.autoMinorVersionUpgrade, availabilityZone: this.availabilityZone, engineVersion: this.engineVersion, kmsKeyId: this.kmsKeyId, multiAz: this.multiAz, preferredMaintenanceWindow: this.preferredMaintenanceWindow, publiclyAccessible: this.publiclyAccessible, replicationInstanceIdentifier: this.replicationInstanceIdentifier, replicationSubnetGroupIdentifier: this.replicationSubnetGroupIdentifier, resourceIdentifier: this.resourceIdentifier, tags: this.tags.renderTags(), vpcSecurityGroupIds: this.vpcSecurityGroupIds };
      }
      renderProperties(props) {
        return cfnReplicationInstancePropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnReplicationInstance[_d] = { fqn: "aws-cdk-lib.aws_dms.CfnReplicationInstance", version: "2.80.0" }, CfnReplicationInstance.CFN_RESOURCE_TYPE_NAME = "AWS::DMS::ReplicationInstance", exports2.CfnReplicationInstance = CfnReplicationInstance;
    function CfnReplicationSubnetGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("replicationSubnetGroupDescription", cdk.requiredValidator)(properties.replicationSubnetGroupDescription)), errors.collect(cdk.propertyValidator("replicationSubnetGroupDescription", cdk.validateString)(properties.replicationSubnetGroupDescription)), errors.collect(cdk.propertyValidator("replicationSubnetGroupIdentifier", cdk.validateString)(properties.replicationSubnetGroupIdentifier)), errors.collect(cdk.propertyValidator("subnetIds", cdk.requiredValidator)(properties.subnetIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnReplicationSubnetGroupProps"');
    }
    function cfnReplicationSubnetGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReplicationSubnetGroupPropsValidator(properties).assertSuccess(), { ReplicationSubnetGroupDescription: cdk.stringToCloudFormation(properties.replicationSubnetGroupDescription), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds), ReplicationSubnetGroupIdentifier: cdk.stringToCloudFormation(properties.replicationSubnetGroupIdentifier), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnReplicationSubnetGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("replicationSubnetGroupDescription", "ReplicationSubnetGroupDescription", cfn_parse.FromCloudFormation.getString(properties.ReplicationSubnetGroupDescription)), ret.addPropertyResult("subnetIds", "SubnetIds", cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds)), ret.addPropertyResult("replicationSubnetGroupIdentifier", "ReplicationSubnetGroupIdentifier", properties.ReplicationSubnetGroupIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.ReplicationSubnetGroupIdentifier) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnReplicationSubnetGroup = class _CfnReplicationSubnetGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnReplicationSubnetGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnReplicationSubnetGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnReplicationSubnetGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_dms_CfnReplicationSubnetGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnReplicationSubnetGroup), error;
        }
        cdk.requireProperty(props, "replicationSubnetGroupDescription", this), cdk.requireProperty(props, "subnetIds", this), this.replicationSubnetGroupDescription = props.replicationSubnetGroupDescription, this.subnetIds = props.subnetIds, this.replicationSubnetGroupIdentifier = props.replicationSubnetGroupIdentifier, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DMS::ReplicationSubnetGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnReplicationSubnetGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { replicationSubnetGroupDescription: this.replicationSubnetGroupDescription, subnetIds: this.subnetIds, replicationSubnetGroupIdentifier: this.replicationSubnetGroupIdentifier, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnReplicationSubnetGroupPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnReplicationSubnetGroup[_e] = { fqn: "aws-cdk-lib.aws_dms.CfnReplicationSubnetGroup", version: "2.80.0" }, CfnReplicationSubnetGroup.CFN_RESOURCE_TYPE_NAME = "AWS::DMS::ReplicationSubnetGroup", exports2.CfnReplicationSubnetGroup = CfnReplicationSubnetGroup;
    function CfnReplicationTaskPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cdcStartPosition", cdk.validateString)(properties.cdcStartPosition)), errors.collect(cdk.propertyValidator("cdcStartTime", cdk.validateNumber)(properties.cdcStartTime)), errors.collect(cdk.propertyValidator("cdcStopPosition", cdk.validateString)(properties.cdcStopPosition)), errors.collect(cdk.propertyValidator("migrationType", cdk.requiredValidator)(properties.migrationType)), errors.collect(cdk.propertyValidator("migrationType", cdk.validateString)(properties.migrationType)), errors.collect(cdk.propertyValidator("replicationInstanceArn", cdk.requiredValidator)(properties.replicationInstanceArn)), errors.collect(cdk.propertyValidator("replicationInstanceArn", cdk.validateString)(properties.replicationInstanceArn)), errors.collect(cdk.propertyValidator("replicationTaskIdentifier", cdk.validateString)(properties.replicationTaskIdentifier)), errors.collect(cdk.propertyValidator("replicationTaskSettings", cdk.validateString)(properties.replicationTaskSettings)), errors.collect(cdk.propertyValidator("resourceIdentifier", cdk.validateString)(properties.resourceIdentifier)), errors.collect(cdk.propertyValidator("sourceEndpointArn", cdk.requiredValidator)(properties.sourceEndpointArn)), errors.collect(cdk.propertyValidator("sourceEndpointArn", cdk.validateString)(properties.sourceEndpointArn)), errors.collect(cdk.propertyValidator("tableMappings", cdk.requiredValidator)(properties.tableMappings)), errors.collect(cdk.propertyValidator("tableMappings", cdk.validateString)(properties.tableMappings)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("targetEndpointArn", cdk.requiredValidator)(properties.targetEndpointArn)), errors.collect(cdk.propertyValidator("targetEndpointArn", cdk.validateString)(properties.targetEndpointArn)), errors.collect(cdk.propertyValidator("taskData", cdk.validateString)(properties.taskData)), errors.wrap('supplied properties not correct for "CfnReplicationTaskProps"');
    }
    function cfnReplicationTaskPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReplicationTaskPropsValidator(properties).assertSuccess(), { MigrationType: cdk.stringToCloudFormation(properties.migrationType), ReplicationInstanceArn: cdk.stringToCloudFormation(properties.replicationInstanceArn), SourceEndpointArn: cdk.stringToCloudFormation(properties.sourceEndpointArn), TableMappings: cdk.stringToCloudFormation(properties.tableMappings), TargetEndpointArn: cdk.stringToCloudFormation(properties.targetEndpointArn), CdcStartPosition: cdk.stringToCloudFormation(properties.cdcStartPosition), CdcStartTime: cdk.numberToCloudFormation(properties.cdcStartTime), CdcStopPosition: cdk.stringToCloudFormation(properties.cdcStopPosition), ReplicationTaskIdentifier: cdk.stringToCloudFormation(properties.replicationTaskIdentifier), ReplicationTaskSettings: cdk.stringToCloudFormation(properties.replicationTaskSettings), ResourceIdentifier: cdk.stringToCloudFormation(properties.resourceIdentifier), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TaskData: cdk.stringToCloudFormation(properties.taskData) }) : properties;
    }
    function CfnReplicationTaskPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("migrationType", "MigrationType", cfn_parse.FromCloudFormation.getString(properties.MigrationType)), ret.addPropertyResult("replicationInstanceArn", "ReplicationInstanceArn", cfn_parse.FromCloudFormation.getString(properties.ReplicationInstanceArn)), ret.addPropertyResult("sourceEndpointArn", "SourceEndpointArn", cfn_parse.FromCloudFormation.getString(properties.SourceEndpointArn)), ret.addPropertyResult("tableMappings", "TableMappings", cfn_parse.FromCloudFormation.getString(properties.TableMappings)), ret.addPropertyResult("targetEndpointArn", "TargetEndpointArn", cfn_parse.FromCloudFormation.getString(properties.TargetEndpointArn)), ret.addPropertyResult("cdcStartPosition", "CdcStartPosition", properties.CdcStartPosition != null ? cfn_parse.FromCloudFormation.getString(properties.CdcStartPosition) : void 0), ret.addPropertyResult("cdcStartTime", "CdcStartTime", properties.CdcStartTime != null ? cfn_parse.FromCloudFormation.getNumber(properties.CdcStartTime) : void 0), ret.addPropertyResult("cdcStopPosition", "CdcStopPosition", properties.CdcStopPosition != null ? cfn_parse.FromCloudFormation.getString(properties.CdcStopPosition) : void 0), ret.addPropertyResult("replicationTaskIdentifier", "ReplicationTaskIdentifier", properties.ReplicationTaskIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.ReplicationTaskIdentifier) : void 0), ret.addPropertyResult("replicationTaskSettings", "ReplicationTaskSettings", properties.ReplicationTaskSettings != null ? cfn_parse.FromCloudFormation.getString(properties.ReplicationTaskSettings) : void 0), ret.addPropertyResult("resourceIdentifier", "ResourceIdentifier", properties.ResourceIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceIdentifier) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("taskData", "TaskData", properties.TaskData != null ? cfn_parse.FromCloudFormation.getString(properties.TaskData) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnReplicationTask = class _CfnReplicationTask extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnReplicationTaskPropsFromCloudFormation(resourceProperties), ret = new _CfnReplicationTask(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnReplicationTask.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_dms_CfnReplicationTaskProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnReplicationTask), error;
        }
        cdk.requireProperty(props, "migrationType", this), cdk.requireProperty(props, "replicationInstanceArn", this), cdk.requireProperty(props, "sourceEndpointArn", this), cdk.requireProperty(props, "tableMappings", this), cdk.requireProperty(props, "targetEndpointArn", this), this.migrationType = props.migrationType, this.replicationInstanceArn = props.replicationInstanceArn, this.sourceEndpointArn = props.sourceEndpointArn, this.tableMappings = props.tableMappings, this.targetEndpointArn = props.targetEndpointArn, this.cdcStartPosition = props.cdcStartPosition, this.cdcStartTime = props.cdcStartTime, this.cdcStopPosition = props.cdcStopPosition, this.replicationTaskIdentifier = props.replicationTaskIdentifier, this.replicationTaskSettings = props.replicationTaskSettings, this.resourceIdentifier = props.resourceIdentifier, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DMS::ReplicationTask", props.tags, { tagPropertyName: "tags" }), this.taskData = props.taskData;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnReplicationTask.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { migrationType: this.migrationType, replicationInstanceArn: this.replicationInstanceArn, sourceEndpointArn: this.sourceEndpointArn, tableMappings: this.tableMappings, targetEndpointArn: this.targetEndpointArn, cdcStartPosition: this.cdcStartPosition, cdcStartTime: this.cdcStartTime, cdcStopPosition: this.cdcStopPosition, replicationTaskIdentifier: this.replicationTaskIdentifier, replicationTaskSettings: this.replicationTaskSettings, resourceIdentifier: this.resourceIdentifier, tags: this.tags.renderTags(), taskData: this.taskData };
      }
      renderProperties(props) {
        return cfnReplicationTaskPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnReplicationTask[_f] = { fqn: "aws-cdk-lib.aws_dms.CfnReplicationTask", version: "2.80.0" }, CfnReplicationTask.CFN_RESOURCE_TYPE_NAME = "AWS::DMS::ReplicationTask", exports2.CfnReplicationTask = CfnReplicationTask;
  }
});

// node_modules/aws-cdk-lib/aws-dms/lib/index.js
var require_lib105 = __commonJS({
  "node_modules/aws-cdk-lib/aws-dms/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_dms_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-dms/index.js
var require_aws_dms = __commonJS({
  "node_modules/aws-cdk-lib/aws-dms/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib105(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-docdb/lib/database-secret.js
var require_database_secret2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-docdb/lib/database-secret.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DatabaseSecret = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var aws_secretsmanager_1 = require_aws_secretsmanager();
    var core_1 = require_core2();
    var DatabaseSecret = class _DatabaseSecret extends aws_secretsmanager_1.Secret {
      constructor(scope, id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_docdb_DatabaseSecretProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _DatabaseSecret), error;
        }
        const excludedCharacters = props.excludeCharacters ?? '"@/';
        super(scope, id, { secretName: props.secretName, description: `Generated by the CDK for stack: ${core_1.Aws.STACK_NAME}`, encryptionKey: props.encryptionKey, generateSecretString: { passwordLength: 41, secretStringTemplate: JSON.stringify({ username: props.username, masterarn: props.masterSecret?.secretArn }), generateStringKey: "password", excludeCharacters: excludedCharacters } }), this._excludedCharacters = excludedCharacters;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, DatabaseSecret[_a] = { fqn: "aws-cdk-lib.aws_docdb.DatabaseSecret", version: "2.80.0" }, exports2.DatabaseSecret = DatabaseSecret;
  }
});

// node_modules/aws-cdk-lib/aws-docdb/lib/docdb.generated.js
var require_docdb_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-docdb/lib/docdb.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnDBSubnetGroup = exports2.CfnDBInstance = exports2.CfnDBClusterParameterGroup = exports2.CfnDBCluster = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnDBClusterPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availabilityZones", cdk.listValidator(cdk.validateString))(properties.availabilityZones)), errors.collect(cdk.propertyValidator("backupRetentionPeriod", cdk.validateNumber)(properties.backupRetentionPeriod)), errors.collect(cdk.propertyValidator("copyTagsToSnapshot", cdk.validateBoolean)(properties.copyTagsToSnapshot)), errors.collect(cdk.propertyValidator("dbClusterIdentifier", cdk.validateString)(properties.dbClusterIdentifier)), errors.collect(cdk.propertyValidator("dbClusterParameterGroupName", cdk.validateString)(properties.dbClusterParameterGroupName)), errors.collect(cdk.propertyValidator("dbSubnetGroupName", cdk.validateString)(properties.dbSubnetGroupName)), errors.collect(cdk.propertyValidator("deletionProtection", cdk.validateBoolean)(properties.deletionProtection)), errors.collect(cdk.propertyValidator("enableCloudwatchLogsExports", cdk.listValidator(cdk.validateString))(properties.enableCloudwatchLogsExports)), errors.collect(cdk.propertyValidator("engineVersion", cdk.validateString)(properties.engineVersion)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("masterUserPassword", cdk.validateString)(properties.masterUserPassword)), errors.collect(cdk.propertyValidator("masterUsername", cdk.validateString)(properties.masterUsername)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("preferredBackupWindow", cdk.validateString)(properties.preferredBackupWindow)), errors.collect(cdk.propertyValidator("preferredMaintenanceWindow", cdk.validateString)(properties.preferredMaintenanceWindow)), errors.collect(cdk.propertyValidator("restoreToTime", cdk.validateString)(properties.restoreToTime)), errors.collect(cdk.propertyValidator("restoreType", cdk.validateString)(properties.restoreType)), errors.collect(cdk.propertyValidator("snapshotIdentifier", cdk.validateString)(properties.snapshotIdentifier)), errors.collect(cdk.propertyValidator("sourceDbClusterIdentifier", cdk.validateString)(properties.sourceDbClusterIdentifier)), errors.collect(cdk.propertyValidator("storageEncrypted", cdk.validateBoolean)(properties.storageEncrypted)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("useLatestRestorableTime", cdk.validateBoolean)(properties.useLatestRestorableTime)), errors.collect(cdk.propertyValidator("vpcSecurityGroupIds", cdk.listValidator(cdk.validateString))(properties.vpcSecurityGroupIds)), errors.wrap('supplied properties not correct for "CfnDBClusterProps"');
    }
    function cfnDBClusterPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBClusterPropsValidator(properties).assertSuccess(), { AvailabilityZones: cdk.listMapper(cdk.stringToCloudFormation)(properties.availabilityZones), BackupRetentionPeriod: cdk.numberToCloudFormation(properties.backupRetentionPeriod), CopyTagsToSnapshot: cdk.booleanToCloudFormation(properties.copyTagsToSnapshot), DBClusterIdentifier: cdk.stringToCloudFormation(properties.dbClusterIdentifier), DBClusterParameterGroupName: cdk.stringToCloudFormation(properties.dbClusterParameterGroupName), DBSubnetGroupName: cdk.stringToCloudFormation(properties.dbSubnetGroupName), DeletionProtection: cdk.booleanToCloudFormation(properties.deletionProtection), EnableCloudwatchLogsExports: cdk.listMapper(cdk.stringToCloudFormation)(properties.enableCloudwatchLogsExports), EngineVersion: cdk.stringToCloudFormation(properties.engineVersion), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), MasterUsername: cdk.stringToCloudFormation(properties.masterUsername), MasterUserPassword: cdk.stringToCloudFormation(properties.masterUserPassword), Port: cdk.numberToCloudFormation(properties.port), PreferredBackupWindow: cdk.stringToCloudFormation(properties.preferredBackupWindow), PreferredMaintenanceWindow: cdk.stringToCloudFormation(properties.preferredMaintenanceWindow), RestoreToTime: cdk.stringToCloudFormation(properties.restoreToTime), RestoreType: cdk.stringToCloudFormation(properties.restoreType), SnapshotIdentifier: cdk.stringToCloudFormation(properties.snapshotIdentifier), SourceDBClusterIdentifier: cdk.stringToCloudFormation(properties.sourceDbClusterIdentifier), StorageEncrypted: cdk.booleanToCloudFormation(properties.storageEncrypted), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), UseLatestRestorableTime: cdk.booleanToCloudFormation(properties.useLatestRestorableTime), VpcSecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.vpcSecurityGroupIds) }) : properties;
    }
    function CfnDBClusterPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("availabilityZones", "AvailabilityZones", properties.AvailabilityZones != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AvailabilityZones) : void 0), ret.addPropertyResult("backupRetentionPeriod", "BackupRetentionPeriod", properties.BackupRetentionPeriod != null ? cfn_parse.FromCloudFormation.getNumber(properties.BackupRetentionPeriod) : void 0), ret.addPropertyResult("copyTagsToSnapshot", "CopyTagsToSnapshot", properties.CopyTagsToSnapshot != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CopyTagsToSnapshot) : void 0), ret.addPropertyResult("dbClusterIdentifier", "DBClusterIdentifier", properties.DBClusterIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.DBClusterIdentifier) : void 0), ret.addPropertyResult("dbClusterParameterGroupName", "DBClusterParameterGroupName", properties.DBClusterParameterGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.DBClusterParameterGroupName) : void 0), ret.addPropertyResult("dbSubnetGroupName", "DBSubnetGroupName", properties.DBSubnetGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.DBSubnetGroupName) : void 0), ret.addPropertyResult("deletionProtection", "DeletionProtection", properties.DeletionProtection != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeletionProtection) : void 0), ret.addPropertyResult("enableCloudwatchLogsExports", "EnableCloudwatchLogsExports", properties.EnableCloudwatchLogsExports != null ? cfn_parse.FromCloudFormation.getStringArray(properties.EnableCloudwatchLogsExports) : void 0), ret.addPropertyResult("engineVersion", "EngineVersion", properties.EngineVersion != null ? cfn_parse.FromCloudFormation.getString(properties.EngineVersion) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("masterUsername", "MasterUsername", properties.MasterUsername != null ? cfn_parse.FromCloudFormation.getString(properties.MasterUsername) : void 0), ret.addPropertyResult("masterUserPassword", "MasterUserPassword", properties.MasterUserPassword != null ? cfn_parse.FromCloudFormation.getString(properties.MasterUserPassword) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addPropertyResult("preferredBackupWindow", "PreferredBackupWindow", properties.PreferredBackupWindow != null ? cfn_parse.FromCloudFormation.getString(properties.PreferredBackupWindow) : void 0), ret.addPropertyResult("preferredMaintenanceWindow", "PreferredMaintenanceWindow", properties.PreferredMaintenanceWindow != null ? cfn_parse.FromCloudFormation.getString(properties.PreferredMaintenanceWindow) : void 0), ret.addPropertyResult("restoreToTime", "RestoreToTime", properties.RestoreToTime != null ? cfn_parse.FromCloudFormation.getString(properties.RestoreToTime) : void 0), ret.addPropertyResult("restoreType", "RestoreType", properties.RestoreType != null ? cfn_parse.FromCloudFormation.getString(properties.RestoreType) : void 0), ret.addPropertyResult("snapshotIdentifier", "SnapshotIdentifier", properties.SnapshotIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.SnapshotIdentifier) : void 0), ret.addPropertyResult("sourceDbClusterIdentifier", "SourceDBClusterIdentifier", properties.SourceDBClusterIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.SourceDBClusterIdentifier) : void 0), ret.addPropertyResult("storageEncrypted", "StorageEncrypted", properties.StorageEncrypted != null ? cfn_parse.FromCloudFormation.getBoolean(properties.StorageEncrypted) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("useLatestRestorableTime", "UseLatestRestorableTime", properties.UseLatestRestorableTime != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseLatestRestorableTime) : void 0), ret.addPropertyResult("vpcSecurityGroupIds", "VpcSecurityGroupIds", properties.VpcSecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.VpcSecurityGroupIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDBCluster = class _CfnDBCluster extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDBClusterPropsFromCloudFormation(resourceProperties), ret = new _CfnDBCluster(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnDBCluster.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_docdb_CfnDBClusterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDBCluster), error;
        }
        this.attrClusterResourceId = cdk.Token.asString(this.getAtt("ClusterResourceId", cdk.ResolutionTypeHint.STRING)), this.attrEndpoint = cdk.Token.asString(this.getAtt("Endpoint", cdk.ResolutionTypeHint.STRING)), this.attrPort = cdk.Token.asString(this.getAtt("Port", cdk.ResolutionTypeHint.STRING)), this.attrReadEndpoint = cdk.Token.asString(this.getAtt("ReadEndpoint", cdk.ResolutionTypeHint.STRING)), this.availabilityZones = props.availabilityZones, this.backupRetentionPeriod = props.backupRetentionPeriod, this.copyTagsToSnapshot = props.copyTagsToSnapshot, this.dbClusterIdentifier = props.dbClusterIdentifier, this.dbClusterParameterGroupName = props.dbClusterParameterGroupName, this.dbSubnetGroupName = props.dbSubnetGroupName, this.deletionProtection = props.deletionProtection, this.enableCloudwatchLogsExports = props.enableCloudwatchLogsExports, this.engineVersion = props.engineVersion, this.kmsKeyId = props.kmsKeyId, this.masterUsername = props.masterUsername, this.masterUserPassword = props.masterUserPassword, this.port = props.port, this.preferredBackupWindow = props.preferredBackupWindow, this.preferredMaintenanceWindow = props.preferredMaintenanceWindow, this.restoreToTime = props.restoreToTime, this.restoreType = props.restoreType, this.snapshotIdentifier = props.snapshotIdentifier, this.sourceDbClusterIdentifier = props.sourceDbClusterIdentifier, this.storageEncrypted = props.storageEncrypted, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DocDB::DBCluster", props.tags, { tagPropertyName: "tags" }), this.useLatestRestorableTime = props.useLatestRestorableTime, this.vpcSecurityGroupIds = props.vpcSecurityGroupIds, this.node.scope && cdk.Resource.isResource(this.node.scope) && this.node.addValidation({ validate: () => this.cfnOptions.deletionPolicy === void 0 ? ["'AWS::DocDB::DBCluster' is a stateful resource type, and you must specify a Removal Policy for it. Call 'resource.applyRemovalPolicy()'."] : [] });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDBCluster.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { availabilityZones: this.availabilityZones, backupRetentionPeriod: this.backupRetentionPeriod, copyTagsToSnapshot: this.copyTagsToSnapshot, dbClusterIdentifier: this.dbClusterIdentifier, dbClusterParameterGroupName: this.dbClusterParameterGroupName, dbSubnetGroupName: this.dbSubnetGroupName, deletionProtection: this.deletionProtection, enableCloudwatchLogsExports: this.enableCloudwatchLogsExports, engineVersion: this.engineVersion, kmsKeyId: this.kmsKeyId, masterUsername: this.masterUsername, masterUserPassword: this.masterUserPassword, port: this.port, preferredBackupWindow: this.preferredBackupWindow, preferredMaintenanceWindow: this.preferredMaintenanceWindow, restoreToTime: this.restoreToTime, restoreType: this.restoreType, snapshotIdentifier: this.snapshotIdentifier, sourceDbClusterIdentifier: this.sourceDbClusterIdentifier, storageEncrypted: this.storageEncrypted, tags: this.tags.renderTags(), useLatestRestorableTime: this.useLatestRestorableTime, vpcSecurityGroupIds: this.vpcSecurityGroupIds };
      }
      renderProperties(props) {
        return cfnDBClusterPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnDBCluster[_a] = { fqn: "aws-cdk-lib.aws_docdb.CfnDBCluster", version: "2.80.0" }, CfnDBCluster.CFN_RESOURCE_TYPE_NAME = "AWS::DocDB::DBCluster", exports2.CfnDBCluster = CfnDBCluster;
    function CfnDBClusterParameterGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.requiredValidator)(properties.description)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("family", cdk.requiredValidator)(properties.family)), errors.collect(cdk.propertyValidator("family", cdk.validateString)(properties.family)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("parameters", cdk.requiredValidator)(properties.parameters)), errors.collect(cdk.propertyValidator("parameters", cdk.validateObject)(properties.parameters)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDBClusterParameterGroupProps"');
    }
    function cfnDBClusterParameterGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBClusterParameterGroupPropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), Family: cdk.stringToCloudFormation(properties.family), Parameters: cdk.objectToCloudFormation(properties.parameters), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDBClusterParameterGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", cfn_parse.FromCloudFormation.getString(properties.Description)), ret.addPropertyResult("family", "Family", cfn_parse.FromCloudFormation.getString(properties.Family)), ret.addPropertyResult("parameters", "Parameters", cfn_parse.FromCloudFormation.getAny(properties.Parameters)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDBClusterParameterGroup = class _CfnDBClusterParameterGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDBClusterParameterGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnDBClusterParameterGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDBClusterParameterGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_docdb_CfnDBClusterParameterGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDBClusterParameterGroup), error;
        }
        cdk.requireProperty(props, "description", this), cdk.requireProperty(props, "family", this), cdk.requireProperty(props, "parameters", this), this.description = props.description, this.family = props.family, this.parameters = props.parameters, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DocDB::DBClusterParameterGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDBClusterParameterGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, family: this.family, parameters: this.parameters, name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDBClusterParameterGroupPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnDBClusterParameterGroup[_b] = { fqn: "aws-cdk-lib.aws_docdb.CfnDBClusterParameterGroup", version: "2.80.0" }, CfnDBClusterParameterGroup.CFN_RESOURCE_TYPE_NAME = "AWS::DocDB::DBClusterParameterGroup", exports2.CfnDBClusterParameterGroup = CfnDBClusterParameterGroup;
    function CfnDBInstancePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoMinorVersionUpgrade", cdk.validateBoolean)(properties.autoMinorVersionUpgrade)), errors.collect(cdk.propertyValidator("availabilityZone", cdk.validateString)(properties.availabilityZone)), errors.collect(cdk.propertyValidator("dbClusterIdentifier", cdk.requiredValidator)(properties.dbClusterIdentifier)), errors.collect(cdk.propertyValidator("dbClusterIdentifier", cdk.validateString)(properties.dbClusterIdentifier)), errors.collect(cdk.propertyValidator("dbInstanceClass", cdk.requiredValidator)(properties.dbInstanceClass)), errors.collect(cdk.propertyValidator("dbInstanceClass", cdk.validateString)(properties.dbInstanceClass)), errors.collect(cdk.propertyValidator("dbInstanceIdentifier", cdk.validateString)(properties.dbInstanceIdentifier)), errors.collect(cdk.propertyValidator("enablePerformanceInsights", cdk.validateBoolean)(properties.enablePerformanceInsights)), errors.collect(cdk.propertyValidator("preferredMaintenanceWindow", cdk.validateString)(properties.preferredMaintenanceWindow)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDBInstanceProps"');
    }
    function cfnDBInstancePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBInstancePropsValidator(properties).assertSuccess(), { DBClusterIdentifier: cdk.stringToCloudFormation(properties.dbClusterIdentifier), DBInstanceClass: cdk.stringToCloudFormation(properties.dbInstanceClass), AutoMinorVersionUpgrade: cdk.booleanToCloudFormation(properties.autoMinorVersionUpgrade), AvailabilityZone: cdk.stringToCloudFormation(properties.availabilityZone), DBInstanceIdentifier: cdk.stringToCloudFormation(properties.dbInstanceIdentifier), EnablePerformanceInsights: cdk.booleanToCloudFormation(properties.enablePerformanceInsights), PreferredMaintenanceWindow: cdk.stringToCloudFormation(properties.preferredMaintenanceWindow), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDBInstancePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dbClusterIdentifier", "DBClusterIdentifier", cfn_parse.FromCloudFormation.getString(properties.DBClusterIdentifier)), ret.addPropertyResult("dbInstanceClass", "DBInstanceClass", cfn_parse.FromCloudFormation.getString(properties.DBInstanceClass)), ret.addPropertyResult("autoMinorVersionUpgrade", "AutoMinorVersionUpgrade", properties.AutoMinorVersionUpgrade != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AutoMinorVersionUpgrade) : void 0), ret.addPropertyResult("availabilityZone", "AvailabilityZone", properties.AvailabilityZone != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityZone) : void 0), ret.addPropertyResult("dbInstanceIdentifier", "DBInstanceIdentifier", properties.DBInstanceIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.DBInstanceIdentifier) : void 0), ret.addPropertyResult("enablePerformanceInsights", "EnablePerformanceInsights", properties.EnablePerformanceInsights != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnablePerformanceInsights) : void 0), ret.addPropertyResult("preferredMaintenanceWindow", "PreferredMaintenanceWindow", properties.PreferredMaintenanceWindow != null ? cfn_parse.FromCloudFormation.getString(properties.PreferredMaintenanceWindow) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDBInstance = class _CfnDBInstance extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDBInstancePropsFromCloudFormation(resourceProperties), ret = new _CfnDBInstance(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDBInstance.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_docdb_CfnDBInstanceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDBInstance), error;
        }
        cdk.requireProperty(props, "dbClusterIdentifier", this), cdk.requireProperty(props, "dbInstanceClass", this), this.attrEndpoint = cdk.Token.asString(this.getAtt("Endpoint", cdk.ResolutionTypeHint.STRING)), this.attrPort = cdk.Token.asString(this.getAtt("Port", cdk.ResolutionTypeHint.STRING)), this.dbClusterIdentifier = props.dbClusterIdentifier, this.dbInstanceClass = props.dbInstanceClass, this.autoMinorVersionUpgrade = props.autoMinorVersionUpgrade, this.availabilityZone = props.availabilityZone, this.dbInstanceIdentifier = props.dbInstanceIdentifier, this.enablePerformanceInsights = props.enablePerformanceInsights, this.preferredMaintenanceWindow = props.preferredMaintenanceWindow, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DocDB::DBInstance", props.tags, { tagPropertyName: "tags" }), this.node.scope && cdk.Resource.isResource(this.node.scope) && this.node.addValidation({ validate: () => this.cfnOptions.deletionPolicy === void 0 ? ["'AWS::DocDB::DBInstance' is a stateful resource type, and you must specify a Removal Policy for it. Call 'resource.applyRemovalPolicy()'."] : [] });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDBInstance.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { dbClusterIdentifier: this.dbClusterIdentifier, dbInstanceClass: this.dbInstanceClass, autoMinorVersionUpgrade: this.autoMinorVersionUpgrade, availabilityZone: this.availabilityZone, dbInstanceIdentifier: this.dbInstanceIdentifier, enablePerformanceInsights: this.enablePerformanceInsights, preferredMaintenanceWindow: this.preferredMaintenanceWindow, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDBInstancePropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnDBInstance[_c] = { fqn: "aws-cdk-lib.aws_docdb.CfnDBInstance", version: "2.80.0" }, CfnDBInstance.CFN_RESOURCE_TYPE_NAME = "AWS::DocDB::DBInstance", exports2.CfnDBInstance = CfnDBInstance;
    function CfnDBSubnetGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dbSubnetGroupDescription", cdk.requiredValidator)(properties.dbSubnetGroupDescription)), errors.collect(cdk.propertyValidator("dbSubnetGroupDescription", cdk.validateString)(properties.dbSubnetGroupDescription)), errors.collect(cdk.propertyValidator("dbSubnetGroupName", cdk.validateString)(properties.dbSubnetGroupName)), errors.collect(cdk.propertyValidator("subnetIds", cdk.requiredValidator)(properties.subnetIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDBSubnetGroupProps"');
    }
    function cfnDBSubnetGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBSubnetGroupPropsValidator(properties).assertSuccess(), { DBSubnetGroupDescription: cdk.stringToCloudFormation(properties.dbSubnetGroupDescription), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds), DBSubnetGroupName: cdk.stringToCloudFormation(properties.dbSubnetGroupName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDBSubnetGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dbSubnetGroupDescription", "DBSubnetGroupDescription", cfn_parse.FromCloudFormation.getString(properties.DBSubnetGroupDescription)), ret.addPropertyResult("subnetIds", "SubnetIds", cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds)), ret.addPropertyResult("dbSubnetGroupName", "DBSubnetGroupName", properties.DBSubnetGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.DBSubnetGroupName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDBSubnetGroup = class _CfnDBSubnetGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDBSubnetGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnDBSubnetGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDBSubnetGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_docdb_CfnDBSubnetGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDBSubnetGroup), error;
        }
        cdk.requireProperty(props, "dbSubnetGroupDescription", this), cdk.requireProperty(props, "subnetIds", this), this.dbSubnetGroupDescription = props.dbSubnetGroupDescription, this.subnetIds = props.subnetIds, this.dbSubnetGroupName = props.dbSubnetGroupName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DocDB::DBSubnetGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDBSubnetGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { dbSubnetGroupDescription: this.dbSubnetGroupDescription, subnetIds: this.subnetIds, dbSubnetGroupName: this.dbSubnetGroupName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDBSubnetGroupPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnDBSubnetGroup[_d] = { fqn: "aws-cdk-lib.aws_docdb.CfnDBSubnetGroup", version: "2.80.0" }, CfnDBSubnetGroup.CFN_RESOURCE_TYPE_NAME = "AWS::DocDB::DBSubnetGroup", exports2.CfnDBSubnetGroup = CfnDBSubnetGroup;
  }
});

// node_modules/aws-cdk-lib/aws-docdb/lib/endpoint.js
var require_endpoint2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-docdb/lib/endpoint.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Endpoint = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core_1 = require_core2();
    var Endpoint = class _Endpoint {
      static isValidPort(port) {
        return Number.isInteger(port) && port >= _Endpoint.MIN_PORT && port <= _Endpoint.MAX_PORT;
      }
      constructor(address, port) {
        if (!core_1.Token.isUnresolved(port) && !_Endpoint.isValidPort(port))
          throw new Error(`Port must be an integer between [${_Endpoint.MIN_PORT}, ${_Endpoint.MAX_PORT}] but got: ${port}`);
        this.hostname = address, this.port = port;
        const portDesc = core_1.Token.isUnresolved(port) ? core_1.Token.asString(port) : port;
        this.socketAddress = `${address}:${portDesc}`;
      }
      portAsString() {
        return core_1.Token.isUnresolved(this.port) ? core_1.Token.asString(this.port) : this.port.toString();
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Endpoint[_a] = { fqn: "aws-cdk-lib.aws_docdb.Endpoint", version: "2.80.0" }, Endpoint.MIN_PORT = 1, Endpoint.MAX_PORT = 65535, exports2.Endpoint = Endpoint;
  }
});

// node_modules/aws-cdk-lib/aws-docdb/lib/cluster.js
var require_cluster3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-docdb/lib/cluster.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DatabaseCluster = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var database_secret_1 = require_database_secret2();
    var docdb_generated_1 = require_docdb_generated();
    var endpoint_1 = require_endpoint2();
    var ec2 = require_aws_ec2();
    var logs = require_aws_logs();
    var secretsmanager = require_aws_secretsmanager();
    var core_1 = require_core2();
    var DatabaseClusterBase = class extends core_1.Resource {
      asSecretAttachmentTarget() {
        return { targetId: this.clusterIdentifier, targetType: secretsmanager.AttachmentTargetType.DOCDB_DB_CLUSTER };
      }
    };
    var DatabaseCluster = class _DatabaseCluster extends DatabaseClusterBase {
      static fromDatabaseClusterAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_docdb_DatabaseClusterAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromDatabaseClusterAttributes), error;
        }
        class Import extends DatabaseClusterBase {
          constructor() {
            super(...arguments), this.defaultPort = typeof attrs.port < "u" ? ec2.Port.tcp(attrs.port) : void 0, this.connections = new ec2.Connections({ securityGroups: attrs.securityGroup ? [attrs.securityGroup] : void 0, defaultPort: this.defaultPort }), this.clusterIdentifier = attrs.clusterIdentifier, this._instanceIdentifiers = attrs.instanceIdentifiers, this._clusterEndpoint = attrs.clusterEndpointAddress && typeof attrs.port < "u" ? new endpoint_1.Endpoint(attrs.clusterEndpointAddress, attrs.port) : void 0, this._clusterReadEndpoint = attrs.readerEndpointAddress && typeof attrs.port < "u" ? new endpoint_1.Endpoint(attrs.readerEndpointAddress, attrs.port) : void 0, this._instanceEndpoints = attrs.instanceEndpointAddresses && typeof attrs.port < "u" ? attrs.instanceEndpointAddresses.map((addr) => new endpoint_1.Endpoint(addr, attrs.port)) : void 0, this._securityGroupId = attrs.securityGroup?.securityGroupId;
          }
          get instanceIdentifiers() {
            if (!this._instanceIdentifiers)
              throw new Error("Cannot access `instanceIdentifiers` of an imported cluster without provided instanceIdentifiers");
            return this._instanceIdentifiers;
          }
          get clusterEndpoint() {
            if (!this._clusterEndpoint)
              throw new Error("Cannot access `clusterEndpoint` of an imported cluster without an endpoint address and port");
            return this._clusterEndpoint;
          }
          get clusterReadEndpoint() {
            if (!this._clusterReadEndpoint)
              throw new Error("Cannot access `clusterReadEndpoint` of an imported cluster without a readerEndpointAddress and port");
            return this._clusterReadEndpoint;
          }
          get instanceEndpoints() {
            if (!this._instanceEndpoints)
              throw new Error("Cannot access `instanceEndpoints` of an imported cluster without instanceEndpointAddresses and port");
            return this._instanceEndpoints;
          }
          get securityGroupId() {
            if (!this._securityGroupId)
              throw new Error("Cannot access `securityGroupId` of an imported cluster without securityGroupId");
            return this._securityGroupId;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id), this.instanceIdentifiers = [], this.instanceEndpoints = [];
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_docdb_DatabaseClusterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _DatabaseCluster), error;
        }
        this.vpc = props.vpc, this.vpcSubnets = props.vpcSubnets;
        const { subnetIds, internetConnectivityEstablished } = this.vpc.selectSubnets(this.vpcSubnets);
        if (subnetIds.length < 2)
          throw new Error(`Cluster requires at least 2 subnets, got ${subnetIds.length}`);
        const subnetGroup = new docdb_generated_1.CfnDBSubnetGroup(this, "Subnets", { dbSubnetGroupDescription: `Subnets for ${id} database`, subnetIds });
        let securityGroup;
        props.securityGroup ? securityGroup = props.securityGroup : (securityGroup = new ec2.SecurityGroup(this, "SecurityGroup", { description: "DocumentDB security group", vpc: this.vpc }), securityGroup.node.defaultChild.applyRemovalPolicy(props.removalPolicy, { applyToUpdateReplacePolicy: true })), this.securityGroupId = securityGroup.securityGroupId;
        const enableCloudwatchLogsExports = [];
        props.exportAuditLogsToCloudWatch && enableCloudwatchLogsExports.push("audit"), props.exportProfilerLogsToCloudWatch && enableCloudwatchLogsExports.push("profiler");
        let secret;
        props.masterUser.password || (secret = new database_secret_1.DatabaseSecret(this, "Secret", { username: props.masterUser.username, encryptionKey: props.masterUser.kmsKey, excludeCharacters: props.masterUser.excludeCharacters, secretName: props.masterUser.secretName }));
        const storageEncrypted = props.storageEncrypted ?? true;
        if (props.kmsKey && !storageEncrypted)
          throw new Error("KMS key supplied but storageEncrypted is false");
        this.cluster = new docdb_generated_1.CfnDBCluster(this, "Resource", { engineVersion: props.engineVersion, dbClusterIdentifier: props.dbClusterName, dbSubnetGroupName: subnetGroup.ref, port: props.port, vpcSecurityGroupIds: [this.securityGroupId], dbClusterParameterGroupName: props.parameterGroup?.parameterGroupName, deletionProtection: props.deletionProtection, masterUsername: secret ? secret.secretValueFromJson("username").unsafeUnwrap() : props.masterUser.username, masterUserPassword: secret ? secret.secretValueFromJson("password").unsafeUnwrap() : props.masterUser.password.unsafeUnwrap(), backupRetentionPeriod: props.backup?.retention?.toDays(), preferredBackupWindow: props.backup?.preferredWindow, preferredMaintenanceWindow: props.preferredMaintenanceWindow, enableCloudwatchLogsExports: enableCloudwatchLogsExports.length > 0 ? enableCloudwatchLogsExports : void 0, kmsKeyId: props.kmsKey?.keyArn, storageEncrypted }), this.cluster.applyRemovalPolicy(props.removalPolicy, { applyToUpdateReplacePolicy: true }), this.clusterIdentifier = this.cluster.ref, this.clusterResourceIdentifier = this.cluster.attrClusterResourceId;
        const port = core_1.Token.asNumber(this.cluster.attrPort);
        this.clusterEndpoint = new endpoint_1.Endpoint(this.cluster.attrEndpoint, port), this.clusterReadEndpoint = new endpoint_1.Endpoint(this.cluster.attrReadEndpoint, port), this.setLogRetention(this, props, enableCloudwatchLogsExports), secret && (this.secret = secret.attach(this));
        const instanceCount = props.instances ?? _DatabaseCluster.DEFAULT_NUM_INSTANCES;
        if (instanceCount < 1)
          throw new Error("At least one instance is required");
        for (let i = 0; i < instanceCount; i++) {
          const instanceIndex = i + 1, instanceIdentifier = props.instanceIdentifierBase != null ? `${props.instanceIdentifierBase}${instanceIndex}` : props.dbClusterName != null ? `${props.dbClusterName}instance${instanceIndex}` : void 0, instance = new docdb_generated_1.CfnDBInstance(this, `Instance${instanceIndex}`, { dbClusterIdentifier: this.cluster.ref, dbInstanceIdentifier: instanceIdentifier, dbInstanceClass: databaseInstanceType(props.instanceType), enablePerformanceInsights: props.enablePerformanceInsights });
          instance.applyRemovalPolicy(props.removalPolicy, { applyToUpdateReplacePolicy: true }), instance.node.addDependency(internetConnectivityEstablished), this.instanceIdentifiers.push(instance.ref), this.instanceEndpoints.push(new endpoint_1.Endpoint(instance.attrEndpoint, port));
        }
        this.connections = new ec2.Connections({ defaultPort: ec2.Port.tcp(port), securityGroups: [securityGroup] });
      }
      setLogRetention(cluster, props, cloudwatchLogsExports) {
        if (props.cloudWatchLogsRetention)
          for (const log of cloudwatchLogsExports)
            new logs.LogRetention(cluster, `LogRetention${log}`, { logGroupName: `/aws/docdb/${cluster.clusterIdentifier}/${log}`, retention: props.cloudWatchLogsRetention, role: props.cloudWatchLogsRetentionRole });
      }
      addRotationSingleUser(automaticallyAfter) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Duration(automaticallyAfter);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addRotationSingleUser), error;
        }
        if (!this.secret)
          throw new Error("Cannot add single user rotation for a cluster without secret.");
        const id = "RotationSingleUser";
        if (this.node.tryFindChild(id))
          throw new Error("A single user rotation was already added to this cluster.");
        return new secretsmanager.SecretRotation(this, id, { secret: this.secret, automaticallyAfter, application: _DatabaseCluster.SINGLE_USER_ROTATION_APPLICATION, excludeCharacters: this.node.tryFindChild("Secret")._excludedCharacters, vpc: this.vpc, vpcSubnets: this.vpcSubnets, target: this });
      }
      addRotationMultiUser(id, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_docdb_RotationMultiUserOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addRotationMultiUser), error;
        }
        if (!this.secret)
          throw new Error("Cannot add multi user rotation for a cluster without secret.");
        return new secretsmanager.SecretRotation(this, id, { secret: options.secret, masterSecret: this.secret, automaticallyAfter: options.automaticallyAfter, excludeCharacters: this.node.tryFindChild("Secret")._excludedCharacters, application: _DatabaseCluster.MULTI_USER_ROTATION_APPLICATION, vpc: this.vpc, vpcSubnets: this.vpcSubnets, target: this });
      }
      addSecurityGroups(...securityGroups) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_ISecurityGroup(securityGroups);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addSecurityGroups), error;
        }
        this.cluster.vpcSecurityGroupIds === void 0 && (this.cluster.vpcSecurityGroupIds = []), this.cluster.vpcSecurityGroupIds.push(...securityGroups.map((sg) => sg.securityGroupId));
      }
    };
    _a = JSII_RTTI_SYMBOL_1, DatabaseCluster[_a] = { fqn: "aws-cdk-lib.aws_docdb.DatabaseCluster", version: "2.80.0" }, DatabaseCluster.DEFAULT_NUM_INSTANCES = 1, DatabaseCluster.DEFAULT_PORT = 27017, DatabaseCluster.SINGLE_USER_ROTATION_APPLICATION = secretsmanager.SecretRotationApplication.MONGODB_ROTATION_SINGLE_USER, DatabaseCluster.MULTI_USER_ROTATION_APPLICATION = secretsmanager.SecretRotationApplication.MONGODB_ROTATION_MULTI_USER, exports2.DatabaseCluster = DatabaseCluster;
    function databaseInstanceType(instanceType) {
      return "db." + instanceType.toString();
    }
  }
});

// node_modules/aws-cdk-lib/aws-docdb/lib/cluster-ref.js
var require_cluster_ref2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-docdb/lib/cluster-ref.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-docdb/lib/instance.js
var require_instance4 = __commonJS({
  "node_modules/aws-cdk-lib/aws-docdb/lib/instance.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DatabaseInstance = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var docdb_generated_1 = require_docdb_generated();
    var endpoint_1 = require_endpoint2();
    var ec2 = require_aws_ec2();
    var core_1 = require_core2();
    var cdk = require_core2();
    var DatabaseInstanceBase = class _DatabaseInstanceBase extends cdk.Resource {
      static fromDatabaseInstanceAttributes(scope, id, attrs) {
        class Import extends _DatabaseInstanceBase {
          constructor() {
            super(...arguments), this.defaultPort = ec2.Port.tcp(attrs.port), this.instanceIdentifier = attrs.instanceIdentifier, this.dbInstanceEndpointAddress = attrs.instanceEndpointAddress, this.dbInstanceEndpointPort = attrs.port.toString(), this.instanceEndpoint = new endpoint_1.Endpoint(attrs.instanceEndpointAddress, attrs.port);
          }
        }
        return new Import(scope, id);
      }
      get instanceArn() {
        return cdk.Stack.of(this).formatArn({ service: "rds", resource: "db", arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME, resourceName: this.instanceIdentifier });
      }
    };
    var DatabaseInstance = class _DatabaseInstance extends DatabaseInstanceBase {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_docdb_DatabaseInstanceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _DatabaseInstance), error;
        }
        const instance = new docdb_generated_1.CfnDBInstance(this, "Resource", { dbClusterIdentifier: props.cluster.clusterIdentifier, dbInstanceClass: `db.${props.instanceType}`, autoMinorVersionUpgrade: props.autoMinorVersionUpgrade ?? true, availabilityZone: props.availabilityZone, dbInstanceIdentifier: props.dbInstanceName, preferredMaintenanceWindow: props.preferredMaintenanceWindow, enablePerformanceInsights: props.enablePerformanceInsights });
        this.cluster = props.cluster, this.instanceIdentifier = instance.ref, this.dbInstanceEndpointAddress = instance.attrEndpoint, this.dbInstanceEndpointPort = instance.attrPort;
        const portAttribute = cdk.Token.asNumber(instance.attrPort);
        this.instanceEndpoint = new endpoint_1.Endpoint(instance.attrEndpoint, portAttribute), instance.applyRemovalPolicy(props.removalPolicy, { applyToUpdateReplacePolicy: true });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, DatabaseInstance[_a] = { fqn: "aws-cdk-lib.aws_docdb.DatabaseInstance", version: "2.80.0" }, exports2.DatabaseInstance = DatabaseInstance;
  }
});

// node_modules/aws-cdk-lib/aws-docdb/lib/parameter-group.js
var require_parameter_group2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-docdb/lib/parameter-group.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ClusterParameterGroup = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var docdb_generated_1 = require_docdb_generated();
    var core_1 = require_core2();
    var ClusterParameterGroupBase = class extends core_1.Resource {
      static fromParameterGroupName(scope, id, parameterGroupName) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.parameterGroupName = parameterGroupName;
          }
        }
        return new Import(scope, id);
      }
    };
    var ClusterParameterGroup = class _ClusterParameterGroup extends ClusterParameterGroupBase {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_docdb_ClusterParameterGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ClusterParameterGroup), error;
        }
        const resource = new docdb_generated_1.CfnDBClusterParameterGroup(this, "Resource", { name: props.dbClusterParameterGroupName, description: props.description || `Cluster parameter group for ${props.family}`, family: props.family, parameters: props.parameters });
        this.parameterGroupName = resource.ref;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ClusterParameterGroup[_a] = { fqn: "aws-cdk-lib.aws_docdb.ClusterParameterGroup", version: "2.80.0" }, exports2.ClusterParameterGroup = ClusterParameterGroup;
  }
});

// node_modules/aws-cdk-lib/aws-docdb/lib/props.js
var require_props2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-docdb/lib/props.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-docdb/lib/index.js
var require_lib106 = __commonJS({
  "node_modules/aws-cdk-lib/aws-docdb/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_cluster3(), exports2), __exportStar(require_cluster_ref2(), exports2), __exportStar(require_database_secret2(), exports2), __exportStar(require_endpoint2(), exports2), __exportStar(require_instance4(), exports2), __exportStar(require_parameter_group2(), exports2), __exportStar(require_props2(), exports2), __exportStar(require_docdb_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-docdb/index.js
var require_aws_docdb = __commonJS({
  "node_modules/aws-cdk-lib/aws-docdb/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib106(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-docdbelastic/lib/docdbelastic.generated.js
var require_docdbelastic_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-docdbelastic/lib/docdbelastic.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnCluster = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnClusterPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("adminUserName", cdk.requiredValidator)(properties.adminUserName)), errors.collect(cdk.propertyValidator("adminUserName", cdk.validateString)(properties.adminUserName)), errors.collect(cdk.propertyValidator("adminUserPassword", cdk.validateString)(properties.adminUserPassword)), errors.collect(cdk.propertyValidator("authType", cdk.requiredValidator)(properties.authType)), errors.collect(cdk.propertyValidator("authType", cdk.validateString)(properties.authType)), errors.collect(cdk.propertyValidator("clusterName", cdk.requiredValidator)(properties.clusterName)), errors.collect(cdk.propertyValidator("clusterName", cdk.validateString)(properties.clusterName)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("preferredMaintenanceWindow", cdk.validateString)(properties.preferredMaintenanceWindow)), errors.collect(cdk.propertyValidator("shardCapacity", cdk.requiredValidator)(properties.shardCapacity)), errors.collect(cdk.propertyValidator("shardCapacity", cdk.validateNumber)(properties.shardCapacity)), errors.collect(cdk.propertyValidator("shardCount", cdk.requiredValidator)(properties.shardCount)), errors.collect(cdk.propertyValidator("shardCount", cdk.validateNumber)(properties.shardCount)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpcSecurityGroupIds", cdk.listValidator(cdk.validateString))(properties.vpcSecurityGroupIds)), errors.wrap('supplied properties not correct for "CfnClusterProps"');
    }
    function cfnClusterPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClusterPropsValidator(properties).assertSuccess(), { AdminUserName: cdk.stringToCloudFormation(properties.adminUserName), AuthType: cdk.stringToCloudFormation(properties.authType), ClusterName: cdk.stringToCloudFormation(properties.clusterName), ShardCapacity: cdk.numberToCloudFormation(properties.shardCapacity), ShardCount: cdk.numberToCloudFormation(properties.shardCount), AdminUserPassword: cdk.stringToCloudFormation(properties.adminUserPassword), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), PreferredMaintenanceWindow: cdk.stringToCloudFormation(properties.preferredMaintenanceWindow), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VpcSecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.vpcSecurityGroupIds) }) : properties;
    }
    function CfnClusterPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("adminUserName", "AdminUserName", cfn_parse.FromCloudFormation.getString(properties.AdminUserName)), ret.addPropertyResult("authType", "AuthType", cfn_parse.FromCloudFormation.getString(properties.AuthType)), ret.addPropertyResult("clusterName", "ClusterName", cfn_parse.FromCloudFormation.getString(properties.ClusterName)), ret.addPropertyResult("shardCapacity", "ShardCapacity", cfn_parse.FromCloudFormation.getNumber(properties.ShardCapacity)), ret.addPropertyResult("shardCount", "ShardCount", cfn_parse.FromCloudFormation.getNumber(properties.ShardCount)), ret.addPropertyResult("adminUserPassword", "AdminUserPassword", properties.AdminUserPassword != null ? cfn_parse.FromCloudFormation.getString(properties.AdminUserPassword) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("preferredMaintenanceWindow", "PreferredMaintenanceWindow", properties.PreferredMaintenanceWindow != null ? cfn_parse.FromCloudFormation.getString(properties.PreferredMaintenanceWindow) : void 0), ret.addPropertyResult("subnetIds", "SubnetIds", properties.SubnetIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("vpcSecurityGroupIds", "VpcSecurityGroupIds", properties.VpcSecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.VpcSecurityGroupIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCluster = class _CfnCluster extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnClusterPropsFromCloudFormation(resourceProperties), ret = new _CfnCluster(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCluster.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_docdbelastic_CfnClusterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCluster), error;
        }
        cdk.requireProperty(props, "adminUserName", this), cdk.requireProperty(props, "authType", this), cdk.requireProperty(props, "clusterName", this), cdk.requireProperty(props, "shardCapacity", this), cdk.requireProperty(props, "shardCount", this), this.attrClusterArn = cdk.Token.asString(this.getAtt("ClusterArn", cdk.ResolutionTypeHint.STRING)), this.attrClusterEndpoint = cdk.Token.asString(this.getAtt("ClusterEndpoint", cdk.ResolutionTypeHint.STRING)), this.adminUserName = props.adminUserName, this.authType = props.authType, this.clusterName = props.clusterName, this.shardCapacity = props.shardCapacity, this.shardCount = props.shardCount, this.adminUserPassword = props.adminUserPassword, this.kmsKeyId = props.kmsKeyId, this.preferredMaintenanceWindow = props.preferredMaintenanceWindow, this.subnetIds = props.subnetIds, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::DocDBElastic::Cluster", props.tags, { tagPropertyName: "tags" }), this.vpcSecurityGroupIds = props.vpcSecurityGroupIds;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCluster.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { adminUserName: this.adminUserName, authType: this.authType, clusterName: this.clusterName, shardCapacity: this.shardCapacity, shardCount: this.shardCount, adminUserPassword: this.adminUserPassword, kmsKeyId: this.kmsKeyId, preferredMaintenanceWindow: this.preferredMaintenanceWindow, subnetIds: this.subnetIds, tags: this.tags.renderTags(), vpcSecurityGroupIds: this.vpcSecurityGroupIds };
      }
      renderProperties(props) {
        return cfnClusterPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnCluster[_a] = { fqn: "aws-cdk-lib.aws_docdbelastic.CfnCluster", version: "2.80.0" }, CfnCluster.CFN_RESOURCE_TYPE_NAME = "AWS::DocDBElastic::Cluster", exports2.CfnCluster = CfnCluster;
  }
});

// node_modules/aws-cdk-lib/aws-docdbelastic/lib/index.js
var require_lib107 = __commonJS({
  "node_modules/aws-cdk-lib/aws-docdbelastic/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_docdbelastic_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-docdbelastic/index.js
var require_aws_docdbelastic = __commonJS({
  "node_modules/aws-cdk-lib/aws-docdbelastic/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib107(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-ecs-patterns/lib/base/queue-processing-service-base.js
var require_queue_processing_service_base = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs-patterns/lib/base/queue-processing-service-base.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.QueueProcessingServiceBase = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var aws_ecs_1 = require_aws_ecs();
    var aws_sqs_1 = require_aws_sqs();
    var core_1 = require_core2();
    var cxapi = require_cx_api();
    var QueueProcessingServiceBase = class _QueueProcessingServiceBase extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_patterns_QueueProcessingServiceBaseProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _QueueProcessingServiceBase), error;
        }
        if (props.cluster && props.vpc)
          throw new Error("You can only specify either vpc or cluster. Alternatively, you can leave both blank");
        if (this.cluster = props.cluster || this.getDefaultCluster(this, props.vpc), props.queue && (props.retentionPeriod || props.visibilityTimeout || props.maxReceiveCount)) {
          const errorProps = ["retentionPeriod", "visibilityTimeout", "maxReceiveCount"].filter((prop) => props.hasOwnProperty(prop));
          throw new Error(`${errorProps.join(", ")} can be set only when queue is not set. Specify them in the QueueProps of the queue`);
        }
        props.queue ? this.sqsQueue = props.queue : (this.deadLetterQueue = new aws_sqs_1.Queue(this, "EcsProcessingDeadLetterQueue", { retentionPeriod: props.retentionPeriod || core_1.Duration.days(14) }), this.sqsQueue = new aws_sqs_1.Queue(this, "EcsProcessingQueue", { visibilityTimeout: props.visibilityTimeout, deadLetterQueue: { queue: this.deadLetterQueue, maxReceiveCount: props.maxReceiveCount || 3 } }), new core_1.CfnOutput(this, "SQSDeadLetterQueue", { value: this.deadLetterQueue.queueName }), new core_1.CfnOutput(this, "SQSDeadLetterQueueArn", { value: this.deadLetterQueue.queueArn }));
        const defaultScalingSteps = [{ upper: 0, change: -1 }, { lower: 100, change: 1 }, { lower: 500, change: 5 }];
        this.scalingSteps = props.scalingSteps ?? defaultScalingSteps;
        const enableLogging = props.enableLogging ?? true;
        if (this.logDriver = props.logDriver ?? (enableLogging ? this.createAWSLogDriver(this.node.id) : void 0), this.environment = { ...props.environment || {}, QUEUE_NAME: this.sqsQueue.queueName }, this.secrets = props.secrets, this.desiredCount = props.desiredTaskCount ?? 1, core_1.FeatureFlags.of(this).isEnabled(cxapi.ECS_REMOVE_DEFAULT_DESIRED_COUNT) ? props.desiredTaskCount != null ? (this.minCapacity = props.minScalingCapacity ?? this.desiredCount, this.maxCapacity = props.maxScalingCapacity || 2 * this.desiredCount) : (this.minCapacity = props.minScalingCapacity ?? 1, this.maxCapacity = props.maxScalingCapacity || 2) : (this.minCapacity = props.minScalingCapacity ?? this.desiredCount, this.maxCapacity = props.maxScalingCapacity || 2 * this.desiredCount), !this.desiredCount && !this.maxCapacity)
          throw new Error("maxScalingCapacity must be set and greater than 0 if desiredCount is 0");
        new core_1.CfnOutput(this, "SQSQueue", { value: this.sqsQueue.queueName }), new core_1.CfnOutput(this, "SQSQueueArn", { value: this.sqsQueue.queueArn });
      }
      configureAutoscalingForService(service) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_BaseService(service);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.configureAutoscalingForService), error;
        }
        const scalingTarget = service.autoScaleTaskCount({ maxCapacity: this.maxCapacity, minCapacity: this.minCapacity });
        scalingTarget.scaleOnCpuUtilization("CpuScaling", { targetUtilizationPercent: 50 }), scalingTarget.scaleOnMetric("QueueMessagesVisibleScaling", { metric: this.sqsQueue.metricApproximateNumberOfMessagesVisible(), scalingSteps: this.scalingSteps });
      }
      grantPermissionsToService(service) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_BaseService(service);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.grantPermissionsToService), error;
        }
        this.sqsQueue.grantConsumeMessages(service.taskDefinition.taskRole);
      }
      getDefaultCluster(scope, vpc) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_IVpc(vpc);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.getDefaultCluster), error;
        }
        const DEFAULT_CLUSTER_ID = `EcsDefaultClusterMnL3mNNYN${vpc ? vpc.node.id : ""}`, stack = core_1.Stack.of(scope);
        return stack.node.tryFindChild(DEFAULT_CLUSTER_ID) || new aws_ecs_1.Cluster(stack, DEFAULT_CLUSTER_ID, { vpc });
      }
      createAWSLogDriver(prefix) {
        return new aws_ecs_1.AwsLogDriver({ streamPrefix: prefix });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, QueueProcessingServiceBase[_a] = { fqn: "aws-cdk-lib.aws_ecs_patterns.QueueProcessingServiceBase", version: "2.80.0" }, exports2.QueueProcessingServiceBase = QueueProcessingServiceBase;
  }
});

// node_modules/aws-cdk-lib/aws-ecs-patterns/lib/ecs/queue-processing-ecs-service.js
var require_queue_processing_ecs_service = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs-patterns/lib/ecs/queue-processing-ecs-service.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.QueueProcessingEc2Service = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var aws_ecs_1 = require_aws_ecs();
    var core_1 = require_core2();
    var cxapi = require_cx_api();
    var queue_processing_service_base_1 = require_queue_processing_service_base();
    var QueueProcessingEc2Service = class _QueueProcessingEc2Service extends queue_processing_service_base_1.QueueProcessingServiceBase {
      constructor(scope, id, props) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_patterns_QueueProcessingEc2ServiceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _QueueProcessingEc2Service), error;
        }
        const containerName = props.containerName ?? "QueueProcessingContainer";
        this.taskDefinition = new aws_ecs_1.Ec2TaskDefinition(this, "QueueProcessingTaskDef", { family: props.family }), this.taskDefinition.addContainer(containerName, { image: props.image, memoryLimitMiB: props.memoryLimitMiB, memoryReservationMiB: props.memoryReservationMiB, cpu: props.cpu, gpuCount: props.gpuCount, command: props.command, environment: this.environment, secrets: this.secrets, logging: this.logDriver });
        const desiredCount = core_1.FeatureFlags.of(this).isEnabled(cxapi.ECS_REMOVE_DEFAULT_DESIRED_COUNT) ? void 0 : this.desiredCount;
        this.service = new aws_ecs_1.Ec2Service(this, "QueueProcessingService", { cluster: this.cluster, desiredCount, taskDefinition: this.taskDefinition, serviceName: props.serviceName, minHealthyPercent: props.minHealthyPercent, maxHealthyPercent: props.maxHealthyPercent, propagateTags: props.propagateTags, enableECSManagedTags: props.enableECSManagedTags, deploymentController: props.deploymentController, circuitBreaker: props.circuitBreaker, capacityProviderStrategies: props.capacityProviderStrategies, enableExecuteCommand: props.enableExecuteCommand, placementConstraints: props.placementConstraints, placementStrategies: props.placementStrategies }), this.configureAutoscalingForService(this.service), this.grantPermissionsToService(this.service);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, QueueProcessingEc2Service[_a] = { fqn: "aws-cdk-lib.aws_ecs_patterns.QueueProcessingEc2Service", version: "2.80.0" }, exports2.QueueProcessingEc2Service = QueueProcessingEc2Service;
  }
});

// node_modules/aws-cdk-lib/aws-ecs-patterns/lib/fargate/queue-processing-fargate-service.js
var require_queue_processing_fargate_service = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs-patterns/lib/fargate/queue-processing-fargate-service.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.QueueProcessingFargateService = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var aws_ecs_1 = require_aws_ecs();
    var core_1 = require_core2();
    var cxapi = require_cx_api();
    var queue_processing_service_base_1 = require_queue_processing_service_base();
    var QueueProcessingFargateService = class _QueueProcessingFargateService extends queue_processing_service_base_1.QueueProcessingServiceBase {
      constructor(scope, id, props) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_patterns_QueueProcessingFargateServiceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _QueueProcessingFargateService), error;
        }
        this.taskDefinition = new aws_ecs_1.FargateTaskDefinition(this, "QueueProcessingTaskDef", { memoryLimitMiB: props.memoryLimitMiB || 512, cpu: props.cpu || 256, family: props.family, runtimePlatform: props.runtimePlatform });
        const containerName = props.containerName ?? "QueueProcessingContainer";
        this.taskDefinition.addContainer(containerName, { image: props.image, command: props.command, environment: this.environment, secrets: this.secrets, logging: this.logDriver, healthCheck: props.healthCheck });
        const desiredCount = core_1.FeatureFlags.of(this).isEnabled(cxapi.ECS_REMOVE_DEFAULT_DESIRED_COUNT) ? void 0 : this.desiredCount;
        this.service = new aws_ecs_1.FargateService(this, "QueueProcessingFargateService", { cluster: this.cluster, desiredCount, taskDefinition: this.taskDefinition, serviceName: props.serviceName, minHealthyPercent: props.minHealthyPercent, maxHealthyPercent: props.maxHealthyPercent, propagateTags: props.propagateTags, enableECSManagedTags: props.enableECSManagedTags, platformVersion: props.platformVersion, deploymentController: props.deploymentController, securityGroups: props.securityGroups, vpcSubnets: props.taskSubnets, assignPublicIp: props.assignPublicIp, circuitBreaker: props.circuitBreaker, capacityProviderStrategies: props.capacityProviderStrategies, enableExecuteCommand: props.enableExecuteCommand }), this.configureAutoscalingForService(this.service), this.grantPermissionsToService(this.service);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, QueueProcessingFargateService[_a] = { fqn: "aws-cdk-lib.aws_ecs_patterns.QueueProcessingFargateService", version: "2.80.0" }, exports2.QueueProcessingFargateService = QueueProcessingFargateService;
  }
});

// node_modules/aws-cdk-lib/aws-route53-targets/lib/api-gateway-domain-name.js
var require_api_gateway_domain_name = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53-targets/lib/api-gateway-domain-name.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ApiGateway = exports2.ApiGatewayDomain = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var ApiGatewayDomain = class _ApiGatewayDomain {
      constructor(domainName) {
        this.domainName = domainName;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_IDomainName(domainName);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ApiGatewayDomain), error;
        }
      }
      bind(_record, _zone) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_IRecordSet(_record), jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_IHostedZone(_zone);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { dnsName: this.domainName.domainNameAliasDomainName, hostedZoneId: this.domainName.domainNameAliasHostedZoneId };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ApiGatewayDomain[_a] = { fqn: "aws-cdk-lib.aws_route53_targets.ApiGatewayDomain", version: "2.80.0" }, exports2.ApiGatewayDomain = ApiGatewayDomain;
    var ApiGateway = class _ApiGateway extends ApiGatewayDomain {
      constructor(api) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_RestApiBase(api);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ApiGateway), error;
        }
        if (!api.domainName)
          throw new Error("API does not define a default domain name");
        super(api.domainName);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, ApiGateway[_b] = { fqn: "aws-cdk-lib.aws_route53_targets.ApiGateway", version: "2.80.0" }, exports2.ApiGateway = ApiGateway;
  }
});

// node_modules/aws-cdk-lib/aws-route53-targets/lib/api-gatewayv2-domain-name.js
var require_api_gatewayv2_domain_name = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53-targets/lib/api-gatewayv2-domain-name.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ApiGatewayv2DomainProperties = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var ApiGatewayv2DomainProperties = class {
      constructor(regionalDomainName, regionalHostedZoneId) {
        this.regionalDomainName = regionalDomainName, this.regionalHostedZoneId = regionalHostedZoneId;
      }
      bind(_record, _zone) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_IRecordSet(_record), jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_IHostedZone(_zone);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { dnsName: this.regionalDomainName, hostedZoneId: this.regionalHostedZoneId };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ApiGatewayv2DomainProperties[_a] = { fqn: "aws-cdk-lib.aws_route53_targets.ApiGatewayv2DomainProperties", version: "2.80.0" }, exports2.ApiGatewayv2DomainProperties = ApiGatewayv2DomainProperties;
  }
});

// node_modules/aws-cdk-lib/aws-route53-targets/lib/bucket-website-target.js
var require_bucket_website_target = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53-targets/lib/bucket-website-target.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.BucketWebsiteTarget = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core_1 = require_core2();
    var region_info_1 = require_region_info2();
    var BucketWebsiteTarget = class _BucketWebsiteTarget {
      constructor(bucket) {
        this.bucket = bucket;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_IBucket(bucket);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _BucketWebsiteTarget), error;
        }
      }
      bind(_record, _zone) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_IRecordSet(_record), jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_IHostedZone(_zone);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        const { region } = core_1.Stack.of(this.bucket.stack);
        if (core_1.Token.isUnresolved(region))
          throw new Error(["Cannot use an S3 record alias in region-agnostic stacks.", "You must specify a specific region when you define the stack", "(see https://docs.aws.amazon.com/cdk/latest/guide/environments.html)"].join(" "));
        const { s3StaticWebsiteHostedZoneId: hostedZoneId, s3StaticWebsiteEndpoint: dnsName } = region_info_1.RegionInfo.get(region);
        if (!hostedZoneId || !dnsName)
          throw new Error(`Bucket website target is not supported for the "${region}" region`);
        return { hostedZoneId, dnsName };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, BucketWebsiteTarget[_a] = { fqn: "aws-cdk-lib.aws_route53_targets.BucketWebsiteTarget", version: "2.80.0" }, exports2.BucketWebsiteTarget = BucketWebsiteTarget;
  }
});

// node_modules/aws-cdk-lib/aws-route53-targets/lib/elastic-beanstalk-environment-target.js
var require_elastic_beanstalk_environment_target = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53-targets/lib/elastic-beanstalk-environment-target.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ElasticBeanstalkEnvironmentEndpointTarget = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var region_info_1 = require_region_info2();
    var ElasticBeanstalkEnvironmentEndpointTarget = class {
      constructor(environmentEndpoint) {
        this.environmentEndpoint = environmentEndpoint;
      }
      bind(_record, _zone) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_IRecordSet(_record), jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_IHostedZone(_zone);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        if (cdk.Token.isUnresolved(this.environmentEndpoint))
          throw new Error("Cannot use an EBS alias as `environmentEndpoint`. You must find your EBS environment endpoint via the AWS console. See the Elastic Beanstalk developer guide: https://docs.aws.amazon.com/elasticbeanstalk/latest/dg/customdomains.html");
        const dnsName = this.environmentEndpoint, subDomains = cdk.Fn.split(".", dnsName), regionSubdomainIndex = subDomains.length - 3, region = cdk.Fn.select(regionSubdomainIndex, subDomains), { ebsEnvEndpointHostedZoneId: hostedZoneId } = region_info_1.RegionInfo.get(region);
        if (!hostedZoneId || !dnsName)
          throw new Error(`Elastic Beanstalk environment target is not supported for the "${region}" region.`);
        return { hostedZoneId, dnsName };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ElasticBeanstalkEnvironmentEndpointTarget[_a] = { fqn: "aws-cdk-lib.aws_route53_targets.ElasticBeanstalkEnvironmentEndpointTarget", version: "2.80.0" }, exports2.ElasticBeanstalkEnvironmentEndpointTarget = ElasticBeanstalkEnvironmentEndpointTarget;
  }
});

// node_modules/aws-cdk-lib/aws-route53-targets/lib/classic-load-balancer-target.js
var require_classic_load_balancer_target = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53-targets/lib/classic-load-balancer-target.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ClassicLoadBalancerTarget = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var ClassicLoadBalancerTarget = class _ClassicLoadBalancerTarget {
      constructor(loadBalancer) {
        this.loadBalancer = loadBalancer;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancing_LoadBalancer(loadBalancer);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ClassicLoadBalancerTarget), error;
        }
      }
      bind(_record, _zone) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_IRecordSet(_record), jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_IHostedZone(_zone);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { hostedZoneId: this.loadBalancer.loadBalancerCanonicalHostedZoneNameId, dnsName: `dualstack.${this.loadBalancer.loadBalancerDnsName}` };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ClassicLoadBalancerTarget[_a] = { fqn: "aws-cdk-lib.aws_route53_targets.ClassicLoadBalancerTarget", version: "2.80.0" }, exports2.ClassicLoadBalancerTarget = ClassicLoadBalancerTarget;
  }
});

// node_modules/aws-cdk-lib/aws-route53-targets/lib/cloudfront-target.js
var require_cloudfront_target = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53-targets/lib/cloudfront-target.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CloudFrontTarget = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core_1 = require_core2();
    var CloudFrontTarget = class _CloudFrontTarget {
      static getHostedZoneId(scope) {
        const mappingName = "AWSCloudFrontPartitionHostedZoneIdMap", scopeStack = core_1.Stack.of(scope);
        return (scopeStack.node.tryFindChild(mappingName) ?? new core_1.CfnMapping(scopeStack, mappingName, { mapping: { aws: { zoneId: "Z2FDTNDATAQYW2" }, ["aws-cn"]: { zoneId: "Z3RFFRIM2A3IF5" } } })).findInMap(core_1.Aws.PARTITION, "zoneId");
      }
      constructor(distribution) {
        this.distribution = distribution;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cloudfront_IDistribution(distribution);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CloudFrontTarget), error;
        }
      }
      bind(_record, _zone) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_IRecordSet(_record), jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_IHostedZone(_zone);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { hostedZoneId: _CloudFrontTarget.getHostedZoneId(this.distribution), dnsName: this.distribution.distributionDomainName };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CloudFrontTarget[_a] = { fqn: "aws-cdk-lib.aws_route53_targets.CloudFrontTarget", version: "2.80.0" }, CloudFrontTarget.CLOUDFRONT_ZONE_ID = "Z2FDTNDATAQYW2", exports2.CloudFrontTarget = CloudFrontTarget;
  }
});

// node_modules/aws-cdk-lib/aws-route53-targets/lib/load-balancer-target.js
var require_load_balancer_target = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53-targets/lib/load-balancer-target.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LoadBalancerTarget = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var LoadBalancerTarget = class _LoadBalancerTarget {
      constructor(loadBalancer) {
        this.loadBalancer = loadBalancer;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_ILoadBalancerV2(loadBalancer);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _LoadBalancerTarget), error;
        }
      }
      bind(_record, _zone) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_IRecordSet(_record), jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_IHostedZone(_zone);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { hostedZoneId: this.loadBalancer.loadBalancerCanonicalHostedZoneId, dnsName: `dualstack.${this.loadBalancer.loadBalancerDnsName}` };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LoadBalancerTarget[_a] = { fqn: "aws-cdk-lib.aws_route53_targets.LoadBalancerTarget", version: "2.80.0" }, exports2.LoadBalancerTarget = LoadBalancerTarget;
  }
});

// node_modules/aws-cdk-lib/aws-route53-targets/lib/interface-vpc-endpoint-target.js
var require_interface_vpc_endpoint_target = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53-targets/lib/interface-vpc-endpoint-target.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.InterfaceVpcEndpointTarget = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var InterfaceVpcEndpointTarget = class _InterfaceVpcEndpointTarget {
      constructor(vpcEndpoint) {
        this.vpcEndpoint = vpcEndpoint;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InterfaceVpcEndpoint(vpcEndpoint);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _InterfaceVpcEndpointTarget), error;
        }
        this.cfnVpcEndpoint = this.vpcEndpoint.node.findChild("Resource");
      }
      bind(_record, _zone) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_IRecordSet(_record), jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_IHostedZone(_zone);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { dnsName: cdk.Fn.select(1, cdk.Fn.split(":", cdk.Fn.select(0, this.cfnVpcEndpoint.attrDnsEntries))), hostedZoneId: cdk.Fn.select(0, cdk.Fn.split(":", cdk.Fn.select(0, this.cfnVpcEndpoint.attrDnsEntries))) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, InterfaceVpcEndpointTarget[_a] = { fqn: "aws-cdk-lib.aws_route53_targets.InterfaceVpcEndpointTarget", version: "2.80.0" }, exports2.InterfaceVpcEndpointTarget = InterfaceVpcEndpointTarget;
  }
});

// node_modules/aws-cdk-lib/aws-route53-targets/lib/userpool-domain.js
var require_userpool_domain = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53-targets/lib/userpool-domain.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.UserPoolDomainTarget = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cloudfront_target_1 = require_cloudfront_target();
    var UserPoolDomainTarget = class _UserPoolDomainTarget {
      constructor(domain) {
        this.domain = domain;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_cognito_UserPoolDomain(domain);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _UserPoolDomainTarget), error;
        }
      }
      bind(_record, _zone) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_IRecordSet(_record), jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_IHostedZone(_zone);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { dnsName: this.domain.cloudFrontDomainName, hostedZoneId: cloudfront_target_1.CloudFrontTarget.getHostedZoneId(this.domain) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, UserPoolDomainTarget[_a] = { fqn: "aws-cdk-lib.aws_route53_targets.UserPoolDomainTarget", version: "2.80.0" }, exports2.UserPoolDomainTarget = UserPoolDomainTarget;
  }
});

// node_modules/aws-cdk-lib/aws-route53-targets/lib/global-accelerator-target.js
var require_global_accelerator_target = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53-targets/lib/global-accelerator-target.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.GlobalAcceleratorTarget = exports2.GlobalAcceleratorDomainTarget = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var GlobalAcceleratorDomainTarget = class {
      constructor(acceleratorDomainName) {
        this.acceleratorDomainName = acceleratorDomainName;
      }
      bind(_record, _zone) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_IRecordSet(_record), jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_IHostedZone(_zone);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { hostedZoneId: GlobalAcceleratorTarget.GLOBAL_ACCELERATOR_ZONE_ID, dnsName: this.acceleratorDomainName };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, GlobalAcceleratorDomainTarget[_a] = { fqn: "aws-cdk-lib.aws_route53_targets.GlobalAcceleratorDomainTarget", version: "2.80.0" }, GlobalAcceleratorDomainTarget.GLOBAL_ACCELERATOR_ZONE_ID = "Z2BJ6XQ5FK7U4H", exports2.GlobalAcceleratorDomainTarget = GlobalAcceleratorDomainTarget;
    var GlobalAcceleratorTarget = class _GlobalAcceleratorTarget extends GlobalAcceleratorDomainTarget {
      constructor(accelerator) {
        super(accelerator.dnsName);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_globalaccelerator_IAccelerator(accelerator);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _GlobalAcceleratorTarget), error;
        }
      }
    };
    _b = JSII_RTTI_SYMBOL_1, GlobalAcceleratorTarget[_b] = { fqn: "aws-cdk-lib.aws_route53_targets.GlobalAcceleratorTarget", version: "2.80.0" }, exports2.GlobalAcceleratorTarget = GlobalAcceleratorTarget;
  }
});

// node_modules/aws-cdk-lib/aws-route53-targets/lib/route53-record.js
var require_route53_record = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53-targets/lib/route53-record.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Route53RecordTarget = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var Route53RecordTarget = class _Route53RecordTarget {
      constructor(record) {
        this.record = record;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_IRecordSet(record);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Route53RecordTarget), error;
        }
      }
      bind(_record, zone) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_IRecordSet(_record), jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_IHostedZone(zone);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        if (!zone)
          throw new Error("Cannot bind to record without a zone");
        return { dnsName: this.record.domainName, hostedZoneId: zone.hostedZoneId };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Route53RecordTarget[_a] = { fqn: "aws-cdk-lib.aws_route53_targets.Route53RecordTarget", version: "2.80.0" }, exports2.Route53RecordTarget = Route53RecordTarget;
  }
});

// node_modules/aws-cdk-lib/aws-route53-targets/lib/index.js
var require_lib108 = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53-targets/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_api_gateway_domain_name(), exports2), __exportStar(require_api_gatewayv2_domain_name(), exports2), __exportStar(require_bucket_website_target(), exports2), __exportStar(require_elastic_beanstalk_environment_target(), exports2), __exportStar(require_classic_load_balancer_target(), exports2), __exportStar(require_cloudfront_target(), exports2), __exportStar(require_load_balancer_target(), exports2), __exportStar(require_interface_vpc_endpoint_target(), exports2), __exportStar(require_userpool_domain(), exports2), __exportStar(require_global_accelerator_target(), exports2), __exportStar(require_route53_record(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-route53-targets/index.js
var require_aws_route53_targets = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53-targets/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib108(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-ecs-patterns/lib/base/network-load-balanced-service-base.js
var require_network_load_balanced_service_base = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs-patterns/lib/base/network-load-balanced-service-base.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.NetworkLoadBalancedServiceBase = exports2.NetworkLoadBalancedServiceRecordType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var aws_ecs_1 = require_aws_ecs();
    var aws_elasticloadbalancingv2_1 = require_aws_elasticloadbalancingv2();
    var aws_route53_1 = require_aws_route53();
    var aws_route53_targets_1 = require_aws_route53_targets();
    var cdk = require_core2();
    var NetworkLoadBalancedServiceRecordType;
    (function(NetworkLoadBalancedServiceRecordType2) {
      NetworkLoadBalancedServiceRecordType2[NetworkLoadBalancedServiceRecordType2.ALIAS = 0] = "ALIAS", NetworkLoadBalancedServiceRecordType2[NetworkLoadBalancedServiceRecordType2.CNAME = 1] = "CNAME", NetworkLoadBalancedServiceRecordType2[NetworkLoadBalancedServiceRecordType2.NONE = 2] = "NONE";
    })(NetworkLoadBalancedServiceRecordType = exports2.NetworkLoadBalancedServiceRecordType || (exports2.NetworkLoadBalancedServiceRecordType = {}));
    var NetworkLoadBalancedServiceBase = class _NetworkLoadBalancedServiceBase extends constructs_1.Construct {
      get loadBalancer() {
        if (!this._networkLoadBalancer)
          throw new Error(".loadBalancer can only be accessed if the class was constructed with an owned, not imported, load balancer");
        return this._networkLoadBalancer;
      }
      constructor(scope, id, props = {}) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancedServiceBaseProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _NetworkLoadBalancedServiceBase), error;
        }
        if (props.cluster && props.vpc)
          throw new Error("You can only specify either vpc or cluster. Alternatively, you can leave both blank");
        if (this.cluster = props.cluster || this.getDefaultCluster(this, props.vpc), props.desiredCount !== void 0 && props.desiredCount < 1)
          throw new Error("You must specify a desiredCount greater than 0");
        this.desiredCount = props.desiredCount || 1, this.internalDesiredCount = props.desiredCount;
        const internetFacing = props.publicLoadBalancer ?? true, lbProps = { vpc: this.cluster.vpc, internetFacing }, loadBalancer = props.loadBalancer ?? new aws_elasticloadbalancingv2_1.NetworkLoadBalancer(this, "LB", lbProps), listenerPort = props.listenerPort ?? 80, targetProps = { port: props.taskImageOptions?.containerPort ?? 80 };
        if (this.listener = loadBalancer.addListener("PublicListener", { port: listenerPort }), this.targetGroup = this.listener.addTargets("ECS", targetProps), typeof props.domainName < "u") {
          if (typeof props.domainZone > "u")
            throw new Error("A Route53 hosted domain zone name is required to configure the specified domain name");
          switch (props.recordType ?? NetworkLoadBalancedServiceRecordType.ALIAS) {
            case NetworkLoadBalancedServiceRecordType.ALIAS:
              new aws_route53_1.ARecord(this, "DNS", { zone: props.domainZone, recordName: props.domainName, target: aws_route53_1.RecordTarget.fromAlias(new aws_route53_targets_1.LoadBalancerTarget(loadBalancer)) });
              break;
            case NetworkLoadBalancedServiceRecordType.CNAME:
              new aws_route53_1.CnameRecord(this, "DNS", { zone: props.domainZone, recordName: props.domainName, domainName: loadBalancer.loadBalancerDnsName });
              break;
            case NetworkLoadBalancedServiceRecordType.NONE:
              break;
          }
        }
        loadBalancer instanceof aws_elasticloadbalancingv2_1.NetworkLoadBalancer && (this._networkLoadBalancer = loadBalancer), props.loadBalancer === void 0 && new cdk.CfnOutput(this, "LoadBalancerDNS", { value: this.loadBalancer.loadBalancerDnsName });
      }
      getDefaultCluster(scope, vpc) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_IVpc(vpc);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.getDefaultCluster), error;
        }
        const DEFAULT_CLUSTER_ID = `EcsDefaultClusterMnL3mNNYN${vpc ? vpc.node.id : ""}`, stack = cdk.Stack.of(scope);
        return stack.node.tryFindChild(DEFAULT_CLUSTER_ID) || new aws_ecs_1.Cluster(stack, DEFAULT_CLUSTER_ID, { vpc });
      }
      addServiceAsTarget(service) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_BaseService(service);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addServiceAsTarget), error;
        }
        this.targetGroup.addTarget(service);
      }
      createAWSLogDriver(prefix) {
        return new aws_ecs_1.AwsLogDriver({ streamPrefix: prefix });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, NetworkLoadBalancedServiceBase[_a] = { fqn: "aws-cdk-lib.aws_ecs_patterns.NetworkLoadBalancedServiceBase", version: "2.80.0" }, exports2.NetworkLoadBalancedServiceBase = NetworkLoadBalancedServiceBase;
  }
});

// node_modules/aws-cdk-lib/aws-ecs-patterns/lib/ecs/network-load-balanced-ecs-service.js
var require_network_load_balanced_ecs_service = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs-patterns/lib/ecs/network-load-balanced-ecs-service.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.NetworkLoadBalancedEc2Service = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var aws_ecs_1 = require_aws_ecs();
    var core_1 = require_core2();
    var cxapi = require_cx_api();
    var network_load_balanced_service_base_1 = require_network_load_balanced_service_base();
    var NetworkLoadBalancedEc2Service = class _NetworkLoadBalancedEc2Service extends network_load_balanced_service_base_1.NetworkLoadBalancedServiceBase {
      constructor(scope, id, props = {}) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancedEc2ServiceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _NetworkLoadBalancedEc2Service), error;
        }
        if (props.taskDefinition && props.taskImageOptions)
          throw new Error("You must specify either a taskDefinition or an image, not both.");
        if (props.taskDefinition)
          this.taskDefinition = props.taskDefinition;
        else if (props.taskImageOptions) {
          const taskImageOptions = props.taskImageOptions;
          this.taskDefinition = new aws_ecs_1.Ec2TaskDefinition(this, "TaskDef", { executionRole: taskImageOptions.executionRole, taskRole: taskImageOptions.taskRole, family: taskImageOptions.family });
          const enableLogging = taskImageOptions.enableLogging ?? true, logDriver = taskImageOptions.logDriver ?? (enableLogging ? this.createAWSLogDriver(this.node.id) : void 0), containerName = taskImageOptions.containerName ?? "web";
          this.taskDefinition.addContainer(containerName, { image: taskImageOptions.image, cpu: props.cpu, memoryLimitMiB: props.memoryLimitMiB, memoryReservationMiB: props.memoryReservationMiB, environment: taskImageOptions.environment, secrets: taskImageOptions.secrets, logging: logDriver, dockerLabels: taskImageOptions.dockerLabels }).addPortMappings({ containerPort: taskImageOptions.containerPort || 80 });
        } else
          throw new Error("You must specify one of: taskDefinition or image");
        const desiredCount = core_1.FeatureFlags.of(this).isEnabled(cxapi.ECS_REMOVE_DEFAULT_DESIRED_COUNT) ? this.internalDesiredCount : this.desiredCount;
        this.service = new aws_ecs_1.Ec2Service(this, "Service", { cluster: this.cluster, desiredCount, taskDefinition: this.taskDefinition, assignPublicIp: false, serviceName: props.serviceName, healthCheckGracePeriod: props.healthCheckGracePeriod, minHealthyPercent: props.minHealthyPercent, maxHealthyPercent: props.maxHealthyPercent, propagateTags: props.propagateTags, enableECSManagedTags: props.enableECSManagedTags, cloudMapOptions: props.cloudMapOptions, deploymentController: props.deploymentController, circuitBreaker: props.circuitBreaker, enableExecuteCommand: props.enableExecuteCommand, placementConstraints: props.placementConstraints, placementStrategies: props.placementStrategies, capacityProviderStrategies: props.capacityProviderStrategies }), this.addServiceAsTarget(this.service);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, NetworkLoadBalancedEc2Service[_a] = { fqn: "aws-cdk-lib.aws_ecs_patterns.NetworkLoadBalancedEc2Service", version: "2.80.0" }, exports2.NetworkLoadBalancedEc2Service = NetworkLoadBalancedEc2Service;
  }
});

// node_modules/aws-cdk-lib/aws-ecs-patterns/lib/fargate/network-load-balanced-fargate-service.js
var require_network_load_balanced_fargate_service = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs-patterns/lib/fargate/network-load-balanced-fargate-service.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.NetworkLoadBalancedFargateService = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var aws_ecs_1 = require_aws_ecs();
    var core_1 = require_core2();
    var cxapi = require_cx_api();
    var network_load_balanced_service_base_1 = require_network_load_balanced_service_base();
    var NetworkLoadBalancedFargateService = class _NetworkLoadBalancedFargateService extends network_load_balanced_service_base_1.NetworkLoadBalancedServiceBase {
      constructor(scope, id, props = {}) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_patterns_NetworkLoadBalancedFargateServiceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _NetworkLoadBalancedFargateService), error;
        }
        if (this.assignPublicIp = props.assignPublicIp ?? false, props.taskDefinition && props.taskImageOptions)
          throw new Error("You must specify either a taskDefinition or an image, not both.");
        if (props.taskDefinition)
          this.taskDefinition = props.taskDefinition;
        else if (props.taskImageOptions) {
          const taskImageOptions = props.taskImageOptions;
          this.taskDefinition = new aws_ecs_1.FargateTaskDefinition(this, "TaskDef", { memoryLimitMiB: props.memoryLimitMiB, cpu: props.cpu, executionRole: taskImageOptions.executionRole, taskRole: taskImageOptions.taskRole, family: taskImageOptions.family, runtimePlatform: props.runtimePlatform });
          const enableLogging = taskImageOptions.enableLogging ?? true, logDriver = taskImageOptions.logDriver ?? (enableLogging ? this.createAWSLogDriver(this.node.id) : void 0), containerName = taskImageOptions.containerName ?? "web";
          this.taskDefinition.addContainer(containerName, { image: taskImageOptions.image, logging: logDriver, environment: taskImageOptions.environment, secrets: taskImageOptions.secrets, dockerLabels: taskImageOptions.dockerLabels }).addPortMappings({ containerPort: taskImageOptions.containerPort || 80 });
        } else
          throw new Error("You must specify one of: taskDefinition or image");
        const desiredCount = core_1.FeatureFlags.of(this).isEnabled(cxapi.ECS_REMOVE_DEFAULT_DESIRED_COUNT) ? this.internalDesiredCount : this.desiredCount;
        this.service = new aws_ecs_1.FargateService(this, "Service", { cluster: this.cluster, desiredCount, taskDefinition: this.taskDefinition, assignPublicIp: this.assignPublicIp, serviceName: props.serviceName, healthCheckGracePeriod: props.healthCheckGracePeriod, minHealthyPercent: props.minHealthyPercent, maxHealthyPercent: props.maxHealthyPercent, propagateTags: props.propagateTags, enableECSManagedTags: props.enableECSManagedTags, cloudMapOptions: props.cloudMapOptions, platformVersion: props.platformVersion, deploymentController: props.deploymentController, circuitBreaker: props.circuitBreaker, vpcSubnets: props.taskSubnets, enableExecuteCommand: props.enableExecuteCommand, capacityProviderStrategies: props.capacityProviderStrategies }), this.addServiceAsTarget(this.service);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, NetworkLoadBalancedFargateService[_a] = { fqn: "aws-cdk-lib.aws_ecs_patterns.NetworkLoadBalancedFargateService", version: "2.80.0" }, exports2.NetworkLoadBalancedFargateService = NetworkLoadBalancedFargateService;
  }
});

// node_modules/aws-cdk-lib/aws-ecs-patterns/lib/base/application-load-balanced-service-base.js
var require_application_load_balanced_service_base = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs-patterns/lib/base/application-load-balanced-service-base.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ApplicationLoadBalancedServiceBase = exports2.ApplicationLoadBalancedServiceRecordType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var aws_certificatemanager_1 = require_aws_certificatemanager();
    var aws_ecs_1 = require_aws_ecs();
    var aws_elasticloadbalancingv2_1 = require_aws_elasticloadbalancingv2();
    var aws_route53_1 = require_aws_route53();
    var aws_route53_targets_1 = require_aws_route53_targets();
    var cdk = require_core2();
    var core_1 = require_core2();
    var ApplicationLoadBalancedServiceRecordType;
    (function(ApplicationLoadBalancedServiceRecordType2) {
      ApplicationLoadBalancedServiceRecordType2[ApplicationLoadBalancedServiceRecordType2.ALIAS = 0] = "ALIAS", ApplicationLoadBalancedServiceRecordType2[ApplicationLoadBalancedServiceRecordType2.CNAME = 1] = "CNAME", ApplicationLoadBalancedServiceRecordType2[ApplicationLoadBalancedServiceRecordType2.NONE = 2] = "NONE";
    })(ApplicationLoadBalancedServiceRecordType = exports2.ApplicationLoadBalancedServiceRecordType || (exports2.ApplicationLoadBalancedServiceRecordType = {}));
    var ApplicationLoadBalancedServiceBase = class _ApplicationLoadBalancedServiceBase extends constructs_1.Construct {
      get loadBalancer() {
        if (!this._applicationLoadBalancer)
          throw new Error(".loadBalancer can only be accessed if the class was constructed with an owned, not imported, load balancer");
        return this._applicationLoadBalancer;
      }
      constructor(scope, id, props = {}) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancedServiceBaseProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ApplicationLoadBalancedServiceBase), error;
        }
        if (props.cluster && props.vpc)
          throw new Error("You can only specify either vpc or cluster. Alternatively, you can leave both blank");
        if (this.cluster = props.cluster || this.getDefaultCluster(this, props.vpc), props.desiredCount !== void 0 && !cdk.Token.isUnresolved(props.desiredCount) && props.desiredCount < 1)
          throw new Error("You must specify a desiredCount greater than 0");
        this.desiredCount = props.desiredCount || 1, this.internalDesiredCount = props.desiredCount;
        const internetFacing = props.publicLoadBalancer ?? true;
        if (props.idleTimeout) {
          const idleTimeout = props.idleTimeout.toSeconds();
          if (idleTimeout > core_1.Duration.seconds(4e3).toSeconds() || idleTimeout < core_1.Duration.seconds(1).toSeconds())
            throw new Error("Load balancer idle timeout must be between 1 and 4000 seconds.");
        }
        const lbProps = { vpc: this.cluster.vpc, loadBalancerName: props.loadBalancerName, internetFacing, idleTimeout: props.idleTimeout }, loadBalancer = props.loadBalancer ?? new aws_elasticloadbalancingv2_1.ApplicationLoadBalancer(this, "LB", lbProps);
        if (props.certificate !== void 0 && props.protocol !== void 0 && props.protocol !== aws_elasticloadbalancingv2_1.ApplicationProtocol.HTTPS)
          throw new Error("The HTTPS protocol must be used when a certificate is given");
        const protocol = props.protocol ?? (props.certificate ? aws_elasticloadbalancingv2_1.ApplicationProtocol.HTTPS : aws_elasticloadbalancingv2_1.ApplicationProtocol.HTTP);
        if (protocol !== aws_elasticloadbalancingv2_1.ApplicationProtocol.HTTPS && props.redirectHTTP === true)
          throw new Error("The HTTPS protocol must be used when redirecting HTTP traffic");
        const targetProps = { protocol: props.targetProtocol ?? aws_elasticloadbalancingv2_1.ApplicationProtocol.HTTP, protocolVersion: props.protocolVersion };
        if (this.listener = loadBalancer.addListener("PublicListener", { protocol, port: props.listenerPort, open: props.openListener ?? true, sslPolicy: props.sslPolicy }), this.targetGroup = this.listener.addTargets("ECS", targetProps), protocol === aws_elasticloadbalancingv2_1.ApplicationProtocol.HTTPS)
          if (props.certificate !== void 0)
            this.certificate = props.certificate;
          else {
            if (typeof props.domainName > "u" || typeof props.domainZone > "u")
              throw new Error("A domain name and zone is required when using the HTTPS protocol");
            this.certificate = new aws_certificatemanager_1.Certificate(this, "Certificate", { domainName: props.domainName, validation: aws_certificatemanager_1.CertificateValidation.fromDns(props.domainZone) });
          }
        this.certificate !== void 0 && this.listener.addCertificates("Arns", [aws_elasticloadbalancingv2_1.ListenerCertificate.fromCertificateManager(this.certificate)]), props.redirectHTTP && (this.redirectListener = loadBalancer.addListener("PublicRedirectListener", { protocol: aws_elasticloadbalancingv2_1.ApplicationProtocol.HTTP, port: 80, open: props.openListener ?? true, defaultAction: aws_elasticloadbalancingv2_1.ListenerAction.redirect({ port: props.listenerPort?.toString() || "443", protocol: aws_elasticloadbalancingv2_1.ApplicationProtocol.HTTPS, permanent: true }) }));
        let domainName = loadBalancer.loadBalancerDnsName;
        if (typeof props.domainName < "u") {
          if (typeof props.domainZone > "u")
            throw new Error("A Route53 hosted domain zone name is required to configure the specified domain name");
          switch (props.recordType ?? ApplicationLoadBalancedServiceRecordType.ALIAS) {
            case ApplicationLoadBalancedServiceRecordType.ALIAS:
              domainName = new aws_route53_1.ARecord(this, "DNS", { zone: props.domainZone, recordName: props.domainName, target: aws_route53_1.RecordTarget.fromAlias(new aws_route53_targets_1.LoadBalancerTarget(loadBalancer)) }).domainName;
              break;
            case ApplicationLoadBalancedServiceRecordType.CNAME:
              domainName = new aws_route53_1.CnameRecord(this, "DNS", { zone: props.domainZone, recordName: props.domainName, domainName: loadBalancer.loadBalancerDnsName }).domainName;
              break;
            case ApplicationLoadBalancedServiceRecordType.NONE:
              break;
          }
        }
        loadBalancer instanceof aws_elasticloadbalancingv2_1.ApplicationLoadBalancer && (this._applicationLoadBalancer = loadBalancer), new cdk.CfnOutput(this, "LoadBalancerDNS", { value: loadBalancer.loadBalancerDnsName }), new cdk.CfnOutput(this, "ServiceURL", { value: protocol.toLowerCase() + "://" + domainName });
      }
      getDefaultCluster(scope, vpc) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_IVpc(vpc);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.getDefaultCluster), error;
        }
        const DEFAULT_CLUSTER_ID = `EcsDefaultClusterMnL3mNNYN${vpc ? vpc.node.id : ""}`, stack = cdk.Stack.of(scope);
        return stack.node.tryFindChild(DEFAULT_CLUSTER_ID) || new aws_ecs_1.Cluster(stack, DEFAULT_CLUSTER_ID, { vpc });
      }
      addServiceAsTarget(service) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_BaseService(service);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addServiceAsTarget), error;
        }
        this.targetGroup.addTarget(service);
      }
      createAWSLogDriver(prefix) {
        return new aws_ecs_1.AwsLogDriver({ streamPrefix: prefix });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ApplicationLoadBalancedServiceBase[_a] = { fqn: "aws-cdk-lib.aws_ecs_patterns.ApplicationLoadBalancedServiceBase", version: "2.80.0" }, exports2.ApplicationLoadBalancedServiceBase = ApplicationLoadBalancedServiceBase;
  }
});

// node_modules/aws-cdk-lib/aws-ecs-patterns/lib/ecs/application-load-balanced-ecs-service.js
var require_application_load_balanced_ecs_service = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs-patterns/lib/ecs/application-load-balanced-ecs-service.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ApplicationLoadBalancedEc2Service = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var aws_ecs_1 = require_aws_ecs();
    var core_1 = require_core2();
    var cxapi = require_cx_api();
    var application_load_balanced_service_base_1 = require_application_load_balanced_service_base();
    var ApplicationLoadBalancedEc2Service = class _ApplicationLoadBalancedEc2Service extends application_load_balanced_service_base_1.ApplicationLoadBalancedServiceBase {
      constructor(scope, id, props = {}) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancedEc2ServiceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ApplicationLoadBalancedEc2Service), error;
        }
        if (props.taskDefinition && props.taskImageOptions)
          throw new Error("You must specify either a taskDefinition or taskImageOptions, not both.");
        if (props.taskDefinition)
          this.taskDefinition = props.taskDefinition;
        else if (props.taskImageOptions) {
          const taskImageOptions = props.taskImageOptions;
          this.taskDefinition = new aws_ecs_1.Ec2TaskDefinition(this, "TaskDef", { executionRole: taskImageOptions.executionRole, taskRole: taskImageOptions.taskRole, family: taskImageOptions.family });
          const enableLogging = taskImageOptions.enableLogging ?? true, logDriver = taskImageOptions.logDriver ?? (enableLogging ? this.createAWSLogDriver(this.node.id) : void 0), containerName = taskImageOptions.containerName ?? "web";
          this.taskDefinition.addContainer(containerName, { image: taskImageOptions.image, cpu: props.cpu, memoryLimitMiB: props.memoryLimitMiB, memoryReservationMiB: props.memoryReservationMiB, environment: taskImageOptions.environment, secrets: taskImageOptions.secrets, logging: logDriver, dockerLabels: taskImageOptions.dockerLabels, command: taskImageOptions.command, entryPoint: taskImageOptions.entryPoint }).addPortMappings({ containerPort: taskImageOptions.containerPort || 80 });
        } else
          throw new Error("You must specify one of: taskDefinition or image");
        const desiredCount = core_1.FeatureFlags.of(this).isEnabled(cxapi.ECS_REMOVE_DEFAULT_DESIRED_COUNT) ? this.internalDesiredCount : this.desiredCount;
        this.service = new aws_ecs_1.Ec2Service(this, "Service", { cluster: this.cluster, desiredCount, taskDefinition: this.taskDefinition, assignPublicIp: false, serviceName: props.serviceName, healthCheckGracePeriod: props.healthCheckGracePeriod, minHealthyPercent: props.minHealthyPercent, maxHealthyPercent: props.maxHealthyPercent, propagateTags: props.propagateTags, enableECSManagedTags: props.enableECSManagedTags, cloudMapOptions: props.cloudMapOptions, deploymentController: props.deploymentController, circuitBreaker: props.circuitBreaker, enableExecuteCommand: props.enableExecuteCommand, placementConstraints: props.placementConstraints, placementStrategies: props.placementStrategies, capacityProviderStrategies: props.capacityProviderStrategies }), this.addServiceAsTarget(this.service);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ApplicationLoadBalancedEc2Service[_a] = { fqn: "aws-cdk-lib.aws_ecs_patterns.ApplicationLoadBalancedEc2Service", version: "2.80.0" }, exports2.ApplicationLoadBalancedEc2Service = ApplicationLoadBalancedEc2Service;
  }
});

// node_modules/aws-cdk-lib/aws-ecs-patterns/lib/fargate/application-load-balanced-fargate-service.js
var require_application_load_balanced_fargate_service = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs-patterns/lib/fargate/application-load-balanced-fargate-service.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ApplicationLoadBalancedFargateService = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var aws_ecs_1 = require_aws_ecs();
    var core_1 = require_core2();
    var cxapi = require_cx_api();
    var application_load_balanced_service_base_1 = require_application_load_balanced_service_base();
    var ApplicationLoadBalancedFargateService = class _ApplicationLoadBalancedFargateService extends application_load_balanced_service_base_1.ApplicationLoadBalancedServiceBase {
      constructor(scope, id, props = {}) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_patterns_ApplicationLoadBalancedFargateServiceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ApplicationLoadBalancedFargateService), error;
        }
        if (this.assignPublicIp = props.assignPublicIp ?? false, props.taskDefinition && props.taskImageOptions)
          throw new Error("You must specify either a taskDefinition or an image, not both.");
        if (props.taskDefinition)
          this.taskDefinition = props.taskDefinition;
        else if (props.taskImageOptions) {
          const taskImageOptions = props.taskImageOptions;
          this.taskDefinition = new aws_ecs_1.FargateTaskDefinition(this, "TaskDef", { memoryLimitMiB: props.memoryLimitMiB, cpu: props.cpu, executionRole: taskImageOptions.executionRole, taskRole: taskImageOptions.taskRole, family: taskImageOptions.family, runtimePlatform: props.runtimePlatform });
          const enableLogging = taskImageOptions.enableLogging ?? true, logDriver = taskImageOptions.logDriver !== void 0 ? taskImageOptions.logDriver : enableLogging ? this.createAWSLogDriver(this.node.id) : void 0, containerName = taskImageOptions.containerName ?? "web";
          this.taskDefinition.addContainer(containerName, { image: taskImageOptions.image, logging: logDriver, environment: taskImageOptions.environment, secrets: taskImageOptions.secrets, dockerLabels: taskImageOptions.dockerLabels, command: taskImageOptions.command, entryPoint: taskImageOptions.entryPoint }).addPortMappings({ containerPort: taskImageOptions.containerPort || 80 });
        } else
          throw new Error("You must specify one of: taskDefinition or image");
        const desiredCount = core_1.FeatureFlags.of(this).isEnabled(cxapi.ECS_REMOVE_DEFAULT_DESIRED_COUNT) ? this.internalDesiredCount : this.desiredCount;
        this.service = new aws_ecs_1.FargateService(this, "Service", { cluster: this.cluster, desiredCount, taskDefinition: this.taskDefinition, assignPublicIp: this.assignPublicIp, serviceName: props.serviceName, healthCheckGracePeriod: props.healthCheckGracePeriod, minHealthyPercent: props.minHealthyPercent, maxHealthyPercent: props.maxHealthyPercent, propagateTags: props.propagateTags, enableECSManagedTags: props.enableECSManagedTags, cloudMapOptions: props.cloudMapOptions, platformVersion: props.platformVersion, deploymentController: props.deploymentController, circuitBreaker: props.circuitBreaker, securityGroups: props.securityGroups, vpcSubnets: props.taskSubnets, enableExecuteCommand: props.enableExecuteCommand, capacityProviderStrategies: props.capacityProviderStrategies }), this.addServiceAsTarget(this.service);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ApplicationLoadBalancedFargateService[_a] = { fqn: "aws-cdk-lib.aws_ecs_patterns.ApplicationLoadBalancedFargateService", version: "2.80.0" }, exports2.ApplicationLoadBalancedFargateService = ApplicationLoadBalancedFargateService;
  }
});

// node_modules/aws-cdk-lib/aws-ecs-patterns/lib/base/fargate-service-base.js
var require_fargate_service_base = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs-patterns/lib/base/fargate-service-base.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-ecs-patterns/lib/base/scheduled-task-base.js
var require_scheduled_task_base = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs-patterns/lib/base/scheduled-task-base.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ScheduledTaskBase = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var aws_ec2_1 = require_aws_ec2();
    var aws_ecs_1 = require_aws_ecs();
    var aws_events_1 = require_aws_events();
    var aws_events_targets_1 = require_aws_events_targets();
    var core_1 = require_core2();
    var ScheduledTaskBase = class _ScheduledTaskBase extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_patterns_ScheduledTaskBaseProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ScheduledTaskBase), error;
        }
        if (this.cluster = props.cluster || this.getDefaultCluster(this, props.vpc), props.desiredTaskCount !== void 0 && props.desiredTaskCount < 1)
          throw new Error("You must specify a desiredTaskCount greater than 0");
        this.desiredTaskCount = props.desiredTaskCount || 1, this.subnetSelection = props.subnetSelection || { subnetType: aws_ec2_1.SubnetType.PRIVATE_WITH_EGRESS }, this._securityGroups = props.securityGroups, this.propagateTags = props.propagateTags, this.tags = props.tags, this.eventRule = new aws_events_1.Rule(this, "ScheduledEventRule", { schedule: props.schedule, ruleName: props.ruleName, enabled: props.enabled }), props.schedule._bind(scope);
      }
      addTaskDefinitionToEventTarget(taskDefinition) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_TaskDefinition(taskDefinition);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addTaskDefinitionToEventTarget), error;
        }
        const eventRuleTarget = new aws_events_targets_1.EcsTask({ cluster: this.cluster, taskDefinition, taskCount: this.desiredTaskCount, subnetSelection: this.subnetSelection, securityGroups: this._securityGroups, propagateTags: this.propagateTags, tags: this.tags });
        return this.addTaskAsTarget(eventRuleTarget), eventRuleTarget;
      }
      addTaskAsTarget(ecsTaskTarget) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_targets_EcsTask(ecsTaskTarget);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addTaskAsTarget), error;
        }
        this.eventRule.addTarget(ecsTaskTarget);
      }
      getDefaultCluster(scope, vpc) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_IVpc(vpc);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.getDefaultCluster), error;
        }
        const DEFAULT_CLUSTER_ID = `EcsDefaultClusterMnL3mNNYN${vpc ? vpc.node.id : ""}`, stack = core_1.Stack.of(scope);
        return stack.node.tryFindChild(DEFAULT_CLUSTER_ID) || new aws_ecs_1.Cluster(stack, DEFAULT_CLUSTER_ID, { vpc });
      }
      createAWSLogDriver(prefix) {
        return new aws_ecs_1.AwsLogDriver({ streamPrefix: prefix });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ScheduledTaskBase[_a] = { fqn: "aws-cdk-lib.aws_ecs_patterns.ScheduledTaskBase", version: "2.80.0" }, exports2.ScheduledTaskBase = ScheduledTaskBase;
  }
});

// node_modules/aws-cdk-lib/aws-ecs-patterns/lib/ecs/scheduled-ecs-task.js
var require_scheduled_ecs_task = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs-patterns/lib/ecs/scheduled-ecs-task.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ScheduledEc2Task = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var aws_ecs_1 = require_aws_ecs();
    var scheduled_task_base_1 = require_scheduled_task_base();
    var ScheduledEc2Task = class _ScheduledEc2Task extends scheduled_task_base_1.ScheduledTaskBase {
      constructor(scope, id, props) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_patterns_ScheduledEc2TaskProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ScheduledEc2Task), error;
        }
        if (props.scheduledEc2TaskDefinitionOptions && props.scheduledEc2TaskImageOptions)
          throw new Error("You must specify either a scheduledEc2TaskDefinitionOptions or scheduledEc2TaskOptions, not both.");
        if (props.scheduledEc2TaskDefinitionOptions)
          this.taskDefinition = props.scheduledEc2TaskDefinitionOptions.taskDefinition;
        else if (props.scheduledEc2TaskImageOptions) {
          const taskImageOptions = props.scheduledEc2TaskImageOptions;
          this.taskDefinition = new aws_ecs_1.Ec2TaskDefinition(this, "ScheduledTaskDef"), this.taskDefinition.addContainer("ScheduledContainer", { image: taskImageOptions.image, memoryLimitMiB: taskImageOptions.memoryLimitMiB, memoryReservationMiB: taskImageOptions.memoryReservationMiB, cpu: taskImageOptions.cpu, command: taskImageOptions.command, environment: taskImageOptions.environment, secrets: taskImageOptions.secrets, logging: taskImageOptions.logDriver ?? this.createAWSLogDriver(this.node.id) });
        } else
          throw new Error("You must specify a taskDefinition or image");
        this.task = this.addTaskDefinitionToEventTarget(this.taskDefinition);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ScheduledEc2Task[_a] = { fqn: "aws-cdk-lib.aws_ecs_patterns.ScheduledEc2Task", version: "2.80.0" }, exports2.ScheduledEc2Task = ScheduledEc2Task;
  }
});

// node_modules/aws-cdk-lib/aws-ecs-patterns/lib/fargate/scheduled-fargate-task.js
var require_scheduled_fargate_task = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs-patterns/lib/fargate/scheduled-fargate-task.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ScheduledFargateTask = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var aws_ecs_1 = require_aws_ecs();
    var aws_events_targets_1 = require_aws_events_targets();
    var scheduled_task_base_1 = require_scheduled_task_base();
    var ScheduledFargateTask = class _ScheduledFargateTask extends scheduled_task_base_1.ScheduledTaskBase {
      constructor(scope, id, props) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_patterns_ScheduledFargateTaskProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ScheduledFargateTask), error;
        }
        if (props.scheduledFargateTaskDefinitionOptions && props.scheduledFargateTaskImageOptions)
          throw new Error("You must specify either a scheduledFargateTaskDefinitionOptions or scheduledFargateTaskOptions, not both.");
        if (props.scheduledFargateTaskDefinitionOptions)
          this.taskDefinition = props.scheduledFargateTaskDefinitionOptions.taskDefinition;
        else if (props.scheduledFargateTaskImageOptions) {
          const taskImageOptions = props.scheduledFargateTaskImageOptions;
          this.taskDefinition = new aws_ecs_1.FargateTaskDefinition(this, "ScheduledTaskDef", { memoryLimitMiB: taskImageOptions.memoryLimitMiB || 512, cpu: taskImageOptions.cpu || 256 }), this.taskDefinition.addContainer("ScheduledContainer", { image: taskImageOptions.image, command: taskImageOptions.command, environment: taskImageOptions.environment, secrets: taskImageOptions.secrets, logging: taskImageOptions.logDriver ?? this.createAWSLogDriver(this.node.id) });
        } else
          throw new Error("You must specify one of: taskDefinition or image");
        this.task = new aws_events_targets_1.EcsTask({ cluster: this.cluster, taskDefinition: this.taskDefinition, taskCount: this.desiredTaskCount, subnetSelection: this.subnetSelection, platformVersion: props.platformVersion, securityGroups: props.securityGroups, propagateTags: props.propagateTags, tags: props.tags }), this.addTaskAsTarget(this.task);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ScheduledFargateTask[_a] = { fqn: "aws-cdk-lib.aws_ecs_patterns.ScheduledFargateTask", version: "2.80.0" }, exports2.ScheduledFargateTask = ScheduledFargateTask;
  }
});

// node_modules/aws-cdk-lib/aws-ecs-patterns/lib/base/application-multiple-target-groups-service-base.js
var require_application_multiple_target_groups_service_base = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs-patterns/lib/base/application-multiple-target-groups-service-base.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ApplicationMultipleTargetGroupsServiceBase = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var aws_certificatemanager_1 = require_aws_certificatemanager();
    var aws_ecs_1 = require_aws_ecs();
    var aws_elasticloadbalancingv2_1 = require_aws_elasticloadbalancingv2();
    var aws_route53_1 = require_aws_route53();
    var aws_route53_targets_1 = require_aws_route53_targets();
    var core_1 = require_core2();
    var ApplicationMultipleTargetGroupsServiceBase = class _ApplicationMultipleTargetGroupsServiceBase extends constructs_1.Construct {
      constructor(scope, id, props = {}) {
        super(scope, id), this.listeners = new Array(), this.targetGroups = new Array(), this.loadBalancers = new Array();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_patterns_ApplicationMultipleTargetGroupsServiceBaseProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ApplicationMultipleTargetGroupsServiceBase), error;
        }
        if (this.validateInput(props), this.cluster = props.cluster || this.getDefaultCluster(this, props.vpc), this.desiredCount = props.desiredCount || 1, this.internalDesiredCount = props.desiredCount, props.taskImageOptions && (this.logDriver = this.createLogDriver(props.taskImageOptions.enableLogging, props.taskImageOptions.logDriver)), props.loadBalancers) {
          this.validateLbProps(props.loadBalancers);
          for (const lbProps of props.loadBalancers) {
            const lb = this.createLoadBalancer(lbProps.name, lbProps.publicLoadBalancer, lbProps.idleTimeout);
            this.loadBalancers.push(lb);
            const protocolType = /* @__PURE__ */ new Set();
            for (const listenerProps of lbProps.listeners) {
              const protocol = this.createListenerProtocol(listenerProps.protocol, listenerProps.certificate);
              if (listenerProps.certificate !== void 0 && protocol !== void 0 && protocol !== aws_elasticloadbalancingv2_1.ApplicationProtocol.HTTPS)
                throw new Error("The HTTPS protocol must be used when a certificate is given");
              protocolType.add(protocol);
              const listener = this.configListener(protocol, { certificate: listenerProps.certificate, domainName: lbProps.domainName, domainZone: lbProps.domainZone, listenerName: listenerProps.name, loadBalancer: lb, port: listenerProps.port, sslPolicy: listenerProps.sslPolicy });
              this.listeners.push(listener);
            }
            const domainName = this.createDomainName(lb, lbProps.domainName, lbProps.domainZone);
            new core_1.CfnOutput(this, `LoadBalancerDNS${lb.node.id}`, { value: lb.loadBalancerDnsName });
            for (const protocol of protocolType)
              new core_1.CfnOutput(this, `ServiceURL${lb.node.id}${protocol.toLowerCase()}`, { value: protocol.toLowerCase() + "://" + domainName });
          }
          this.loadBalancer = this.loadBalancers[0], this.listener = this.listeners[0];
        } else {
          this.loadBalancer = this.createLoadBalancer("LB");
          const protocol = this.createListenerProtocol();
          this.listener = this.configListener(protocol, { listenerName: "PublicListener", loadBalancer: this.loadBalancer });
          const domainName = this.createDomainName(this.loadBalancer);
          new core_1.CfnOutput(this, "LoadBalancerDNS", { value: this.loadBalancer.loadBalancerDnsName }), new core_1.CfnOutput(this, "ServiceURL", { value: protocol.toLowerCase() + "://" + domainName });
        }
      }
      getDefaultCluster(scope, vpc) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_IVpc(vpc);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.getDefaultCluster), error;
        }
        const DEFAULT_CLUSTER_ID = `EcsDefaultClusterMnL3mNNYN${vpc ? vpc.node.id : ""}`, stack = core_1.Stack.of(scope);
        return stack.node.tryFindChild(DEFAULT_CLUSTER_ID) || new aws_ecs_1.Cluster(stack, DEFAULT_CLUSTER_ID, { vpc });
      }
      createAWSLogDriver(prefix) {
        return new aws_ecs_1.AwsLogDriver({ streamPrefix: prefix });
      }
      findListener(name) {
        if (!name)
          return this.listener;
        for (const listener of this.listeners)
          if (listener.node.id === name)
            return listener;
        throw new Error(`Listener ${name} is not defined. Did you define listener with name ${name}?`);
      }
      registerECSTargets(service, container, targets) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_BaseService(service), jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_ContainerDefinition(container);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.registerECSTargets), error;
        }
        for (const targetProps of targets) {
          const conditions = [];
          targetProps.hostHeader && conditions.push(aws_elasticloadbalancingv2_1.ListenerCondition.hostHeaders([targetProps.hostHeader])), targetProps.pathPattern && conditions.push(aws_elasticloadbalancingv2_1.ListenerCondition.pathPatterns([targetProps.pathPattern]));
          const targetGroup = this.findListener(targetProps.listener).addTargets(`ECSTargetGroup${container.containerName}${targetProps.containerPort}`, { port: 80, targets: [service.loadBalancerTarget({ containerName: container.containerName, containerPort: targetProps.containerPort, protocol: targetProps.protocol })], conditions, priority: targetProps.priority });
          this.targetGroups.push(targetGroup);
        }
        if (this.targetGroups.length === 0)
          throw new Error("At least one target group should be specified.");
        return this.targetGroups[0];
      }
      addPortMappingForTargets(container, targets) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_ContainerDefinition(container);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addPortMappingForTargets), error;
        }
        for (const target of targets)
          container.findPortMapping(target.containerPort, target.protocol || aws_ecs_1.Protocol.TCP) || container.addPortMappings({ containerPort: target.containerPort, protocol: target.protocol });
      }
      createLogDriver(enableLoggingProp, logDriverProp) {
        return logDriverProp ?? (enableLoggingProp ?? true ? this.createAWSLogDriver(this.node.id) : void 0);
      }
      configListener(protocol, props) {
        const listener = this.createListener(props, protocol);
        let certificate;
        return protocol === aws_elasticloadbalancingv2_1.ApplicationProtocol.HTTPS ? certificate = this.createListenerCertificate(props.listenerName, props.certificate, props.domainName, props.domainZone) : certificate = void 0, certificate !== void 0 && listener.addCertificates(`Arns${props.listenerName}`, [aws_elasticloadbalancingv2_1.ListenerCertificate.fromArn(certificate.certificateArn)]), listener;
      }
      validateInput(props) {
        if (props.cluster && props.vpc)
          throw new Error("You can only specify either vpc or cluster. Alternatively, you can leave both blank");
        if (props.desiredCount !== void 0 && props.desiredCount < 1)
          throw new Error("You must specify a desiredCount greater than 0");
        if (props.loadBalancers) {
          if (props.loadBalancers.length === 0)
            throw new Error("At least one load balancer must be specified");
          for (const lbProps of props.loadBalancers)
            if (lbProps.listeners.length === 0)
              throw new Error("At least one listener must be specified");
        }
      }
      validateLbProps(props) {
        for (let prop of props)
          if (prop.idleTimeout && (prop.idleTimeout > core_1.Duration.seconds(4e3) || prop.idleTimeout < core_1.Duration.seconds(1)))
            throw new Error("Load balancer idle timeout must be between 1 and 4000 seconds.");
      }
      createLoadBalancer(name, publicLoadBalancer, idleTimeout) {
        const internetFacing = publicLoadBalancer ?? true, lbProps = { vpc: this.cluster.vpc, internetFacing, idleTimeout };
        return new aws_elasticloadbalancingv2_1.ApplicationLoadBalancer(this, name, lbProps);
      }
      createListenerProtocol(listenerProtocol, certificate) {
        return listenerProtocol ?? (certificate ? aws_elasticloadbalancingv2_1.ApplicationProtocol.HTTPS : aws_elasticloadbalancingv2_1.ApplicationProtocol.HTTP);
      }
      createListenerCertificate(listenerName, certificate, domainName, domainZone) {
        if (typeof domainName > "u" || typeof domainZone > "u")
          throw new Error("A domain name and zone is required when using the HTTPS protocol");
        return certificate !== void 0 ? certificate : new aws_certificatemanager_1.Certificate(this, `Certificate${listenerName}`, { domainName, validation: aws_certificatemanager_1.CertificateValidation.fromDns(domainZone) });
      }
      createListener({ loadBalancer, listenerName, port, sslPolicy }, protocol) {
        return loadBalancer.addListener(listenerName, { protocol, open: true, port, sslPolicy });
      }
      createDomainName(loadBalancer, name, zone) {
        let domainName = loadBalancer.loadBalancerDnsName;
        if (typeof name < "u") {
          if (typeof zone > "u")
            throw new Error("A Route53 hosted domain zone name is required to configure the specified domain name");
          domainName = new aws_route53_1.ARecord(this, `DNS${loadBalancer.node.id}`, { zone, recordName: name, target: aws_route53_1.RecordTarget.fromAlias(new aws_route53_targets_1.LoadBalancerTarget(loadBalancer)) }).domainName;
        }
        return domainName;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ApplicationMultipleTargetGroupsServiceBase[_a] = { fqn: "aws-cdk-lib.aws_ecs_patterns.ApplicationMultipleTargetGroupsServiceBase", version: "2.80.0" }, exports2.ApplicationMultipleTargetGroupsServiceBase = ApplicationMultipleTargetGroupsServiceBase;
  }
});

// node_modules/aws-cdk-lib/aws-ecs-patterns/lib/ecs/application-multiple-target-groups-ecs-service.js
var require_application_multiple_target_groups_ecs_service = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs-patterns/lib/ecs/application-multiple-target-groups-ecs-service.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ApplicationMultipleTargetGroupsEc2Service = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var aws_ecs_1 = require_aws_ecs();
    var core_1 = require_core2();
    var cxapi = require_cx_api();
    var application_multiple_target_groups_service_base_1 = require_application_multiple_target_groups_service_base();
    var ApplicationMultipleTargetGroupsEc2Service = class _ApplicationMultipleTargetGroupsEc2Service extends application_multiple_target_groups_service_base_1.ApplicationMultipleTargetGroupsServiceBase {
      constructor(scope, id, props = {}) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_patterns_ApplicationMultipleTargetGroupsEc2ServiceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ApplicationMultipleTargetGroupsEc2Service), error;
        }
        if (props.taskDefinition && props.taskImageOptions)
          throw new Error("You must specify only one of TaskDefinition or TaskImageOptions.");
        if (props.taskDefinition)
          this.taskDefinition = props.taskDefinition;
        else if (props.taskImageOptions) {
          const taskImageOptions = props.taskImageOptions;
          this.taskDefinition = new aws_ecs_1.Ec2TaskDefinition(this, "TaskDef", { executionRole: taskImageOptions.executionRole, taskRole: taskImageOptions.taskRole });
          const containerName = taskImageOptions.containerName ?? "web", container = this.taskDefinition.addContainer(containerName, { image: taskImageOptions.image, cpu: props.cpu, memoryLimitMiB: props.memoryLimitMiB, memoryReservationMiB: props.memoryReservationMiB, environment: taskImageOptions.environment, secrets: taskImageOptions.secrets, logging: this.logDriver, dockerLabels: taskImageOptions.dockerLabels });
          if (taskImageOptions.containerPorts)
            for (const containerPort of taskImageOptions.containerPorts)
              container.addPortMappings({ containerPort });
        } else
          throw new Error("You must specify one of: taskDefinition or image");
        if (!this.taskDefinition.defaultContainer)
          throw new Error("At least one essential container must be specified");
        this.taskDefinition.defaultContainer.portMappings.length === 0 && this.taskDefinition.defaultContainer.addPortMappings({ containerPort: 80 }), this.service = this.createEc2Service(props), props.targetGroups ? (this.addPortMappingForTargets(this.taskDefinition.defaultContainer, props.targetGroups), this.targetGroup = this.registerECSTargets(this.service, this.taskDefinition.defaultContainer, props.targetGroups)) : this.targetGroup = this.listener.addTargets("ECS", { targets: [this.service], port: this.taskDefinition.defaultContainer.portMappings[0].containerPort });
      }
      createEc2Service(props) {
        const desiredCount = core_1.FeatureFlags.of(this).isEnabled(cxapi.ECS_REMOVE_DEFAULT_DESIRED_COUNT) ? this.internalDesiredCount : this.desiredCount;
        return new aws_ecs_1.Ec2Service(this, "Service", { cluster: this.cluster, desiredCount, taskDefinition: this.taskDefinition, assignPublicIp: false, serviceName: props.serviceName, healthCheckGracePeriod: props.healthCheckGracePeriod, propagateTags: props.propagateTags, enableECSManagedTags: props.enableECSManagedTags, cloudMapOptions: props.cloudMapOptions, enableExecuteCommand: props.enableExecuteCommand, placementConstraints: props.placementConstraints, placementStrategies: props.placementStrategies });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ApplicationMultipleTargetGroupsEc2Service[_a] = { fqn: "aws-cdk-lib.aws_ecs_patterns.ApplicationMultipleTargetGroupsEc2Service", version: "2.80.0" }, exports2.ApplicationMultipleTargetGroupsEc2Service = ApplicationMultipleTargetGroupsEc2Service;
  }
});

// node_modules/aws-cdk-lib/aws-ecs-patterns/lib/fargate/application-multiple-target-groups-fargate-service.js
var require_application_multiple_target_groups_fargate_service = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs-patterns/lib/fargate/application-multiple-target-groups-fargate-service.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ApplicationMultipleTargetGroupsFargateService = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var aws_ecs_1 = require_aws_ecs();
    var core_1 = require_core2();
    var cxapi = require_cx_api();
    var application_multiple_target_groups_service_base_1 = require_application_multiple_target_groups_service_base();
    var ApplicationMultipleTargetGroupsFargateService = class _ApplicationMultipleTargetGroupsFargateService extends application_multiple_target_groups_service_base_1.ApplicationMultipleTargetGroupsServiceBase {
      constructor(scope, id, props = {}) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_patterns_ApplicationMultipleTargetGroupsFargateServiceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ApplicationMultipleTargetGroupsFargateService), error;
        }
        if (this.assignPublicIp = props.assignPublicIp ?? false, props.taskDefinition && props.taskImageOptions)
          throw new Error("You must specify only one of TaskDefinition or TaskImageOptions.");
        if (props.taskDefinition)
          this.taskDefinition = props.taskDefinition;
        else if (props.taskImageOptions) {
          const taskImageOptions = props.taskImageOptions;
          this.taskDefinition = new aws_ecs_1.FargateTaskDefinition(this, "TaskDef", { memoryLimitMiB: props.memoryLimitMiB, cpu: props.cpu, executionRole: taskImageOptions.executionRole, taskRole: taskImageOptions.taskRole, family: taskImageOptions.family, runtimePlatform: props.runtimePlatform });
          const containerName = taskImageOptions.containerName ?? "web", container = this.taskDefinition.addContainer(containerName, { image: taskImageOptions.image, logging: this.logDriver, environment: taskImageOptions.environment, secrets: taskImageOptions.secrets, dockerLabels: taskImageOptions.dockerLabels });
          if (taskImageOptions.containerPorts)
            for (const containerPort of taskImageOptions.containerPorts)
              container.addPortMappings({ containerPort });
        } else
          throw new Error("You must specify one of: taskDefinition or image");
        if (!this.taskDefinition.defaultContainer)
          throw new Error("At least one essential container must be specified");
        this.taskDefinition.defaultContainer.portMappings.length === 0 && this.taskDefinition.defaultContainer.addPortMappings({ containerPort: 80 }), this.service = this.createFargateService(props), props.targetGroups ? (this.addPortMappingForTargets(this.taskDefinition.defaultContainer, props.targetGroups), this.targetGroup = this.registerECSTargets(this.service, this.taskDefinition.defaultContainer, props.targetGroups)) : this.targetGroup = this.listener.addTargets("ECS", { targets: [this.service], port: this.taskDefinition.defaultContainer.portMappings[0].containerPort });
      }
      createFargateService(props) {
        const desiredCount = core_1.FeatureFlags.of(this).isEnabled(cxapi.ECS_REMOVE_DEFAULT_DESIRED_COUNT) ? this.internalDesiredCount : this.desiredCount;
        return new aws_ecs_1.FargateService(this, "Service", { cluster: this.cluster, desiredCount, taskDefinition: this.taskDefinition, assignPublicIp: this.assignPublicIp, serviceName: props.serviceName, healthCheckGracePeriod: props.healthCheckGracePeriod, propagateTags: props.propagateTags, enableECSManagedTags: props.enableECSManagedTags, cloudMapOptions: props.cloudMapOptions, platformVersion: props.platformVersion, enableExecuteCommand: props.enableExecuteCommand });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ApplicationMultipleTargetGroupsFargateService[_a] = { fqn: "aws-cdk-lib.aws_ecs_patterns.ApplicationMultipleTargetGroupsFargateService", version: "2.80.0" }, exports2.ApplicationMultipleTargetGroupsFargateService = ApplicationMultipleTargetGroupsFargateService;
  }
});

// node_modules/aws-cdk-lib/aws-ecs-patterns/lib/base/network-multiple-target-groups-service-base.js
var require_network_multiple_target_groups_service_base = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs-patterns/lib/base/network-multiple-target-groups-service-base.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.NetworkMultipleTargetGroupsServiceBase = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var aws_ecs_1 = require_aws_ecs();
    var aws_elasticloadbalancingv2_1 = require_aws_elasticloadbalancingv2();
    var aws_route53_1 = require_aws_route53();
    var aws_route53_targets_1 = require_aws_route53_targets();
    var core_1 = require_core2();
    var NetworkMultipleTargetGroupsServiceBase = class _NetworkMultipleTargetGroupsServiceBase extends constructs_1.Construct {
      constructor(scope, id, props = {}) {
        super(scope, id), this.listeners = new Array(), this.targetGroups = new Array(), this.loadBalancers = new Array();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_patterns_NetworkMultipleTargetGroupsServiceBaseProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _NetworkMultipleTargetGroupsServiceBase), error;
        }
        if (this.validateInput(props), this.cluster = props.cluster || this.getDefaultCluster(this, props.vpc), this.desiredCount = props.desiredCount || 1, this.internalDesiredCount = props.desiredCount, props.taskImageOptions && (this.logDriver = this.createLogDriver(props.taskImageOptions.enableLogging, props.taskImageOptions.logDriver)), props.loadBalancers) {
          for (const lbProps of props.loadBalancers) {
            const lb = this.createLoadBalancer(lbProps.name, lbProps.publicLoadBalancer);
            this.loadBalancers.push(lb);
            for (const listenerProps of lbProps.listeners) {
              const listener = this.createListener(listenerProps.name, lb, listenerProps.port || 80);
              this.listeners.push(listener);
            }
            this.createDomainName(lb, lbProps.domainName, lbProps.domainZone), new core_1.CfnOutput(this, `LoadBalancerDNS${lb.node.id}`, { value: lb.loadBalancerDnsName });
          }
          this.loadBalancer = this.loadBalancers[0], this.listener = this.listeners[0];
        } else
          this.loadBalancer = this.createLoadBalancer("LB"), this.listener = this.createListener("PublicListener", this.loadBalancer, 80), this.createDomainName(this.loadBalancer), new core_1.CfnOutput(this, "LoadBalancerDNS", { value: this.loadBalancer.loadBalancerDnsName });
      }
      getDefaultCluster(scope, vpc) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_IVpc(vpc);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.getDefaultCluster), error;
        }
        const DEFAULT_CLUSTER_ID = `EcsDefaultClusterMnL3mNNYN${vpc ? vpc.node.id : ""}`, stack = core_1.Stack.of(scope);
        return stack.node.tryFindChild(DEFAULT_CLUSTER_ID) || new aws_ecs_1.Cluster(stack, DEFAULT_CLUSTER_ID, { vpc });
      }
      createAWSLogDriver(prefix) {
        return new aws_ecs_1.AwsLogDriver({ streamPrefix: prefix });
      }
      findListener(name) {
        if (!name)
          return this.listener;
        for (const listener of this.listeners)
          if (listener.node.id === name)
            return listener;
        throw new Error(`Listener ${name} is not defined. Did you define listener with name ${name}?`);
      }
      registerECSTargets(service, container, targets) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_BaseService(service), jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_ContainerDefinition(container);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.registerECSTargets), error;
        }
        for (const targetProps of targets) {
          const targetGroup = this.findListener(targetProps.listener).addTargets(`ECSTargetGroup${container.containerName}${targetProps.containerPort}`, { port: targetProps.containerPort ?? 80, targets: [service.loadBalancerTarget({ containerName: container.containerName, containerPort: targetProps.containerPort })] });
          this.targetGroups.push(targetGroup);
        }
        if (this.targetGroups.length === 0)
          throw new Error("At least one target group should be specified.");
        return this.targetGroups[0];
      }
      addPortMappingForTargets(container, targets) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_ContainerDefinition(container);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addPortMappingForTargets), error;
        }
        for (const target of targets)
          container.findPortMapping(target.containerPort, aws_ecs_1.Protocol.TCP) || container.addPortMappings({ containerPort: target.containerPort });
      }
      createLogDriver(enableLoggingProp, logDriverProp) {
        return logDriverProp ?? (enableLoggingProp ?? true ? this.createAWSLogDriver(this.node.id) : void 0);
      }
      validateInput(props) {
        if (props.cluster && props.vpc)
          throw new Error("You can only specify either vpc or cluster. Alternatively, you can leave both blank");
        if (props.desiredCount !== void 0 && props.desiredCount < 1)
          throw new Error("You must specify a desiredCount greater than 0");
        if (props.loadBalancers) {
          if (props.loadBalancers.length === 0)
            throw new Error("At least one load balancer must be specified");
          for (const lbProps of props.loadBalancers)
            if (lbProps.listeners.length === 0)
              throw new Error("At least one listener must be specified");
        }
      }
      createLoadBalancer(name, publicLoadBalancer) {
        const internetFacing = publicLoadBalancer ?? true, lbProps = { vpc: this.cluster.vpc, internetFacing };
        return new aws_elasticloadbalancingv2_1.NetworkLoadBalancer(this, name, lbProps);
      }
      createListener(name, lb, port) {
        return lb.addListener(name, { port });
      }
      createDomainName(loadBalancer, name, zone) {
        if (typeof name < "u") {
          if (typeof zone > "u")
            throw new Error("A Route53 hosted domain zone name is required to configure the specified domain name");
          new aws_route53_1.ARecord(this, `DNS${loadBalancer.node.id}`, { zone, recordName: name, target: aws_route53_1.RecordTarget.fromAlias(new aws_route53_targets_1.LoadBalancerTarget(loadBalancer)) });
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, NetworkMultipleTargetGroupsServiceBase[_a] = { fqn: "aws-cdk-lib.aws_ecs_patterns.NetworkMultipleTargetGroupsServiceBase", version: "2.80.0" }, exports2.NetworkMultipleTargetGroupsServiceBase = NetworkMultipleTargetGroupsServiceBase;
  }
});

// node_modules/aws-cdk-lib/aws-ecs-patterns/lib/ecs/network-multiple-target-groups-ecs-service.js
var require_network_multiple_target_groups_ecs_service = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs-patterns/lib/ecs/network-multiple-target-groups-ecs-service.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.NetworkMultipleTargetGroupsEc2Service = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var aws_ecs_1 = require_aws_ecs();
    var core_1 = require_core2();
    var cxapi = require_cx_api();
    var network_multiple_target_groups_service_base_1 = require_network_multiple_target_groups_service_base();
    var NetworkMultipleTargetGroupsEc2Service = class _NetworkMultipleTargetGroupsEc2Service extends network_multiple_target_groups_service_base_1.NetworkMultipleTargetGroupsServiceBase {
      constructor(scope, id, props = {}) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_patterns_NetworkMultipleTargetGroupsEc2ServiceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _NetworkMultipleTargetGroupsEc2Service), error;
        }
        if (props.taskDefinition && props.taskImageOptions)
          throw new Error("You must specify only one of TaskDefinition or TaskImageOptions.");
        if (props.taskDefinition)
          this.taskDefinition = props.taskDefinition;
        else if (props.taskImageOptions) {
          const taskImageOptions = props.taskImageOptions;
          this.taskDefinition = new aws_ecs_1.Ec2TaskDefinition(this, "TaskDef", { executionRole: taskImageOptions.executionRole, taskRole: taskImageOptions.taskRole });
          const containerName = taskImageOptions.containerName ?? "web", container = this.taskDefinition.addContainer(containerName, { image: taskImageOptions.image, cpu: props.cpu, memoryLimitMiB: props.memoryLimitMiB, memoryReservationMiB: props.memoryReservationMiB, environment: taskImageOptions.environment, secrets: taskImageOptions.secrets, logging: this.logDriver, dockerLabels: taskImageOptions.dockerLabels });
          if (taskImageOptions.containerPorts)
            for (const containerPort of taskImageOptions.containerPorts)
              container.addPortMappings({ containerPort });
        } else
          throw new Error("You must specify one of: taskDefinition or image");
        if (!this.taskDefinition.defaultContainer)
          throw new Error("At least one essential container must be specified");
        this.taskDefinition.defaultContainer.portMappings.length === 0 && this.taskDefinition.defaultContainer.addPortMappings({ containerPort: 80 }), this.service = this.createEc2Service(props), props.targetGroups ? (this.addPortMappingForTargets(this.taskDefinition.defaultContainer, props.targetGroups), this.targetGroup = this.registerECSTargets(this.service, this.taskDefinition.defaultContainer, props.targetGroups)) : this.targetGroup = this.listener.addTargets("ECS", { targets: [this.service], port: this.taskDefinition.defaultContainer.portMappings[0].containerPort });
      }
      createEc2Service(props) {
        const desiredCount = core_1.FeatureFlags.of(this).isEnabled(cxapi.ECS_REMOVE_DEFAULT_DESIRED_COUNT) ? this.internalDesiredCount : this.desiredCount;
        return new aws_ecs_1.Ec2Service(this, "Service", { cluster: this.cluster, desiredCount, taskDefinition: this.taskDefinition, assignPublicIp: false, serviceName: props.serviceName, healthCheckGracePeriod: props.healthCheckGracePeriod, propagateTags: props.propagateTags, enableECSManagedTags: props.enableECSManagedTags, cloudMapOptions: props.cloudMapOptions, enableExecuteCommand: props.enableExecuteCommand, placementConstraints: props.placementConstraints, placementStrategies: props.placementStrategies });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, NetworkMultipleTargetGroupsEc2Service[_a] = { fqn: "aws-cdk-lib.aws_ecs_patterns.NetworkMultipleTargetGroupsEc2Service", version: "2.80.0" }, exports2.NetworkMultipleTargetGroupsEc2Service = NetworkMultipleTargetGroupsEc2Service;
  }
});

// node_modules/aws-cdk-lib/aws-ecs-patterns/lib/fargate/network-multiple-target-groups-fargate-service.js
var require_network_multiple_target_groups_fargate_service = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs-patterns/lib/fargate/network-multiple-target-groups-fargate-service.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.NetworkMultipleTargetGroupsFargateService = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var aws_ecs_1 = require_aws_ecs();
    var core_1 = require_core2();
    var cxapi = require_cx_api();
    var network_multiple_target_groups_service_base_1 = require_network_multiple_target_groups_service_base();
    var NetworkMultipleTargetGroupsFargateService = class _NetworkMultipleTargetGroupsFargateService extends network_multiple_target_groups_service_base_1.NetworkMultipleTargetGroupsServiceBase {
      constructor(scope, id, props = {}) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecs_patterns_NetworkMultipleTargetGroupsFargateServiceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _NetworkMultipleTargetGroupsFargateService), error;
        }
        if (this.assignPublicIp = props.assignPublicIp ?? false, props.taskDefinition && props.taskImageOptions)
          throw new Error("You must specify only one of TaskDefinition or TaskImageOptions.");
        if (props.taskDefinition)
          this.taskDefinition = props.taskDefinition;
        else if (props.taskImageOptions) {
          const taskImageOptions = props.taskImageOptions;
          this.taskDefinition = new aws_ecs_1.FargateTaskDefinition(this, "TaskDef", { memoryLimitMiB: props.memoryLimitMiB, cpu: props.cpu, executionRole: taskImageOptions.executionRole, taskRole: taskImageOptions.taskRole, family: taskImageOptions.family, runtimePlatform: props.runtimePlatform });
          const containerName = taskImageOptions.containerName ?? "web", container = this.taskDefinition.addContainer(containerName, { image: taskImageOptions.image, logging: this.logDriver, environment: taskImageOptions.environment, secrets: taskImageOptions.secrets, dockerLabels: taskImageOptions.dockerLabels });
          if (taskImageOptions.containerPorts)
            for (const containerPort of taskImageOptions.containerPorts)
              container.addPortMappings({ containerPort });
        } else
          throw new Error("You must specify one of: taskDefinition or image");
        if (!this.taskDefinition.defaultContainer)
          throw new Error("At least one essential container must be specified");
        this.taskDefinition.defaultContainer.portMappings.length === 0 && this.taskDefinition.defaultContainer.addPortMappings({ containerPort: 80 }), this.service = this.createFargateService(props), props.targetGroups ? (this.addPortMappingForTargets(this.taskDefinition.defaultContainer, props.targetGroups), this.targetGroup = this.registerECSTargets(this.service, this.taskDefinition.defaultContainer, props.targetGroups)) : this.targetGroup = this.listener.addTargets("ECS", { targets: [this.service], port: this.taskDefinition.defaultContainer.portMappings[0].containerPort });
      }
      createFargateService(props) {
        const desiredCount = core_1.FeatureFlags.of(this).isEnabled(cxapi.ECS_REMOVE_DEFAULT_DESIRED_COUNT) ? this.internalDesiredCount : this.desiredCount;
        return new aws_ecs_1.FargateService(this, "Service", { cluster: this.cluster, desiredCount, taskDefinition: this.taskDefinition, assignPublicIp: this.assignPublicIp, serviceName: props.serviceName, healthCheckGracePeriod: props.healthCheckGracePeriod, propagateTags: props.propagateTags, enableECSManagedTags: props.enableECSManagedTags, cloudMapOptions: props.cloudMapOptions, platformVersion: props.platformVersion, enableExecuteCommand: props.enableExecuteCommand });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, NetworkMultipleTargetGroupsFargateService[_a] = { fqn: "aws-cdk-lib.aws_ecs_patterns.NetworkMultipleTargetGroupsFargateService", version: "2.80.0" }, exports2.NetworkMultipleTargetGroupsFargateService = NetworkMultipleTargetGroupsFargateService;
  }
});

// node_modules/aws-cdk-lib/aws-ecs-patterns/lib/index.js
var require_lib109 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs-patterns/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_queue_processing_ecs_service(), exports2), __exportStar(require_queue_processing_fargate_service(), exports2), __exportStar(require_queue_processing_service_base(), exports2), __exportStar(require_network_load_balanced_ecs_service(), exports2), __exportStar(require_network_load_balanced_fargate_service(), exports2), __exportStar(require_network_load_balanced_service_base(), exports2), __exportStar(require_application_load_balanced_ecs_service(), exports2), __exportStar(require_application_load_balanced_fargate_service(), exports2), __exportStar(require_application_load_balanced_service_base(), exports2), __exportStar(require_fargate_service_base(), exports2), __exportStar(require_scheduled_ecs_task(), exports2), __exportStar(require_scheduled_fargate_task(), exports2), __exportStar(require_scheduled_task_base(), exports2), __exportStar(require_application_multiple_target_groups_service_base(), exports2), __exportStar(require_application_multiple_target_groups_ecs_service(), exports2), __exportStar(require_application_multiple_target_groups_fargate_service(), exports2), __exportStar(require_network_multiple_target_groups_service_base(), exports2), __exportStar(require_network_multiple_target_groups_ecs_service(), exports2), __exportStar(require_network_multiple_target_groups_fargate_service(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-ecs-patterns/index.js
var require_aws_ecs_patterns = __commonJS({
  "node_modules/aws-cdk-lib/aws-ecs-patterns/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib109(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-eks/lib/cluster-resource-handler/consts.js
var require_consts2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-eks/lib/cluster-resource-handler/consts.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FARGATE_PROFILE_RESOURCE_TYPE = exports2.CLUSTER_RESOURCE_TYPE = void 0, exports2.CLUSTER_RESOURCE_TYPE = "Custom::AWSCDK-EKS-Cluster", exports2.FARGATE_PROFILE_RESOURCE_TYPE = "Custom::AWSCDK-EKS-FargateProfile";
  }
});

// node_modules/@aws-cdk/asset-node-proxy-agent-v5/lib/node-proxy-agent-layer.js
var require_node_proxy_agent_layer = __commonJS({
  "node_modules/@aws-cdk/asset-node-proxy-agent-v5/lib/node-proxy-agent-layer.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.LAYER_SOURCE = exports2.LAYER_SOURCE_DIR = exports2.ASSET_FILE = void 0;
    var path = require("path");
    exports2.ASSET_FILE = path.join(__dirname, "layer.zip");
    exports2.LAYER_SOURCE_DIR = path.join(__dirname, "..", "layer");
    exports2.LAYER_SOURCE = path.join(__dirname, "..", "layer", "Dockerfile");
  }
});

// node_modules/@aws-cdk/asset-node-proxy-agent-v5/lib/index.js
var require_lib110 = __commonJS({
  "node_modules/@aws-cdk/asset-node-proxy-agent-v5/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports3) {
      for (var p in m)
        if (p !== "default" && !exports3.hasOwnProperty(p))
          __createBinding(exports3, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar(require_node_proxy_agent_layer(), exports2);
  }
});

// node_modules/aws-cdk-lib/lambda-layer-node-proxy-agent/lib/node-proxy-agent-layer.js
var require_node_proxy_agent_layer2 = __commonJS({
  "node_modules/aws-cdk-lib/lambda-layer-node-proxy-agent/lib/node-proxy-agent-layer.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.NodeProxyAgentLayer = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var asset_node_proxy_agent_v5_1 = require_lib110();
    var lambda2 = require_aws_lambda();
    var core_1 = require_core2();
    var NodeProxyAgentLayer = class extends lambda2.LayerVersion {
      constructor(scope, id) {
        super(scope, id, { code: lambda2.Code.fromAsset(asset_node_proxy_agent_v5_1.ASSET_FILE, { assetHash: core_1.FileSystem.fingerprint(asset_node_proxy_agent_v5_1.LAYER_SOURCE_DIR) }), description: "/opt/nodejs/node_modules/proxy-agent" });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, NodeProxyAgentLayer[_a] = { fqn: "aws-cdk-lib.lambda_layer_node_proxy_agent.NodeProxyAgentLayer", version: "2.80.0" }, exports2.NodeProxyAgentLayer = NodeProxyAgentLayer;
  }
});

// node_modules/aws-cdk-lib/lambda-layer-node-proxy-agent/lib/index.js
var require_lib111 = __commonJS({
  "node_modules/aws-cdk-lib/lambda-layer-node-proxy-agent/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_node_proxy_agent_layer2(), exports2);
  }
});

// node_modules/aws-cdk-lib/lambda-layer-node-proxy-agent/index.js
var require_lambda_layer_node_proxy_agent = __commonJS({
  "node_modules/aws-cdk-lib/lambda-layer-node-proxy-agent/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib111(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-eks/lib/cluster-resource-provider.js
var require_cluster_resource_provider = __commonJS({
  "node_modules/aws-cdk-lib/aws-eks/lib/cluster-resource-provider.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ClusterResourceProvider = void 0;
    var path = require("path");
    var lambda2 = require_aws_lambda();
    var core_1 = require_core2();
    var cr = require_custom_resources();
    var lambda_layer_node_proxy_agent_1 = require_lambda_layer_node_proxy_agent();
    var HANDLER_DIR = path.join(__dirname, "cluster-resource-handler");
    var HANDLER_RUNTIME = lambda2.Runtime.NODEJS_14_X;
    var ClusterResourceProvider = class _ClusterResourceProvider extends core_1.NestedStack {
      static getOrCreate(scope, props) {
        const stack = core_1.Stack.of(scope), uid = "@aws-cdk/aws-eks.ClusterResourceProvider";
        return stack.node.tryFindChild(uid) ?? new _ClusterResourceProvider(stack, uid, props);
      }
      constructor(scope, id, props) {
        super(scope, id);
        const nodeProxyAgentLayer = new lambda_layer_node_proxy_agent_1.NodeProxyAgentLayer(this, "NodeProxyAgentLayer"), onEvent = new lambda2.Function(this, "OnEventHandler", { code: lambda2.Code.fromAsset(HANDLER_DIR), description: "onEvent handler for EKS cluster resource provider", runtime: HANDLER_RUNTIME, environment: { AWS_STS_REGIONAL_ENDPOINTS: "regional", ...props.environment }, handler: "index.onEvent", timeout: core_1.Duration.minutes(1), vpc: props.subnets ? props.vpc : void 0, vpcSubnets: props.subnets ? { subnets: props.subnets } : void 0, securityGroups: props.securityGroup ? [props.securityGroup] : void 0, layers: props.onEventLayer ? [props.onEventLayer] : [nodeProxyAgentLayer] }), isComplete = new lambda2.Function(this, "IsCompleteHandler", { code: lambda2.Code.fromAsset(HANDLER_DIR), description: "isComplete handler for EKS cluster resource provider", runtime: HANDLER_RUNTIME, environment: { AWS_STS_REGIONAL_ENDPOINTS: "regional", ...props.environment }, handler: "index.isComplete", timeout: core_1.Duration.minutes(1), vpc: props.subnets ? props.vpc : void 0, vpcSubnets: props.subnets ? { subnets: props.subnets } : void 0, securityGroups: props.securityGroup ? [props.securityGroup] : void 0, layers: [nodeProxyAgentLayer] });
        this.provider = new cr.Provider(this, "Provider", { onEventHandler: onEvent, isCompleteHandler: isComplete, totalTimeout: core_1.Duration.hours(1), queryInterval: core_1.Duration.minutes(1), vpc: props.subnets ? props.vpc : void 0, vpcSubnets: props.subnets ? { subnets: props.subnets } : void 0, securityGroups: props.securityGroup ? [props.securityGroup] : void 0 });
      }
      get serviceToken() {
        return this.provider.serviceToken;
      }
    };
    exports2.ClusterResourceProvider = ClusterResourceProvider;
  }
});

// node_modules/aws-cdk-lib/aws-eks/lib/cluster-resource.js
var require_cluster_resource = __commonJS({
  "node_modules/aws-cdk-lib/aws-eks/lib/cluster-resource.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.clusterArnComponents = exports2.ClusterResource = void 0;
    var constructs_1 = require_lib2();
    var consts_1 = require_consts2();
    var cluster_resource_provider_1 = require_cluster_resource_provider();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var ClusterResource = class extends constructs_1.Construct {
      constructor(scope, id, props) {
        if (super(scope, id), !props.roleArn)
          throw new Error('"roleArn" is required');
        const provider = cluster_resource_provider_1.ClusterResourceProvider.getOrCreate(this, { subnets: props.subnets, vpc: props.vpc, environment: props.environment, onEventLayer: props.onEventLayer, securityGroup: props.clusterHandlerSecurityGroup });
        this.adminRole = this.createAdminRole(provider, props);
        const resource = new core_1.CustomResource(this, "Resource", { resourceType: consts_1.CLUSTER_RESOURCE_TYPE, serviceToken: provider.serviceToken, properties: { Config: { name: props.name, version: props.version, roleArn: props.roleArn, encryptionConfig: props.encryptionConfig, kubernetesNetworkConfig: props.kubernetesNetworkConfig, resourcesVpcConfig: { subnetIds: props.resourcesVpcConfig.subnetIds, securityGroupIds: props.resourcesVpcConfig.securityGroupIds, endpointPublicAccess: props.endpointPublicAccess, endpointPrivateAccess: props.endpointPrivateAccess, publicAccessCidrs: props.publicAccessCidrs }, tags: props.tags, logging: props.logging }, AssumeRoleArn: this.adminRole.roleArn, AttributesRevision: 2 } });
        resource.node.addDependency(this.adminRole), this.ref = resource.ref, this.attrEndpoint = core_1.Token.asString(resource.getAtt("Endpoint")), this.attrArn = core_1.Token.asString(resource.getAtt("Arn")), this.attrCertificateAuthorityData = core_1.Token.asString(resource.getAtt("CertificateAuthorityData")), this.attrClusterSecurityGroupId = core_1.Token.asString(resource.getAtt("ClusterSecurityGroupId")), this.attrEncryptionConfigKeyArn = core_1.Token.asString(resource.getAtt("EncryptionConfigKeyArn")), this.attrOpenIdConnectIssuerUrl = core_1.Token.asString(resource.getAtt("OpenIdConnectIssuerUrl")), this.attrOpenIdConnectIssuer = core_1.Token.asString(resource.getAtt("OpenIdConnectIssuer"));
      }
      createAdminRole(provider, props) {
        const stack = core_1.Stack.of(this), creationRole = new iam.Role(this, "CreationRole", { assumedBy: new iam.CompositePrincipal(provider.provider.onEventHandler.role, provider.provider.isCompleteHandler.role) });
        creationRole.addToPolicy(new iam.PolicyStatement({ actions: ["iam:PassRole"], resources: [props.roleArn] }));
        const resourceArns = core_1.Lazy.list({ produce: () => {
          const arn = stack.formatArn(clusterArnComponents(stack.resolve(props.name)));
          return stack.resolve(props.name) ? [arn, `${arn}/*`] : ["*"];
        } }), fargateProfileResourceArn = core_1.Lazy.string({ produce: () => stack.resolve(props.name) ? stack.formatArn({ service: "eks", resource: "fargateprofile", resourceName: stack.resolve(props.name) + "/*" }) : "*" });
        return creationRole.addToPolicy(new iam.PolicyStatement({ actions: ["eks:CreateCluster", "eks:DescribeCluster", "eks:DescribeUpdate", "eks:DeleteCluster", "eks:UpdateClusterVersion", "eks:UpdateClusterConfig", "eks:CreateFargateProfile", "eks:TagResource", "eks:UntagResource"], resources: resourceArns })), creationRole.addToPolicy(new iam.PolicyStatement({ actions: ["eks:DescribeFargateProfile", "eks:DeleteFargateProfile"], resources: [fargateProfileResourceArn] })), creationRole.addToPolicy(new iam.PolicyStatement({ actions: ["iam:GetRole", "iam:listAttachedRolePolicies"], resources: ["*"] })), creationRole.addToPolicy(new iam.PolicyStatement({ actions: ["iam:CreateServiceLinkedRole"], resources: ["*"] })), creationRole.addToPolicy(new iam.PolicyStatement({ actions: ["ec2:DescribeInstances", "ec2:DescribeNetworkInterfaces", "ec2:DescribeSecurityGroups", "ec2:DescribeSubnets", "ec2:DescribeRouteTables", "ec2:DescribeDhcpOptions", "ec2:DescribeVpcs"], resources: ["*"] })), props.secretsEncryptionKey && creationRole.addToPolicy(new iam.PolicyStatement({ actions: ["kms:Encrypt", "kms:Decrypt", "kms:DescribeKey", "kms:CreateGrant"], resources: [props.secretsEncryptionKey.keyArn] })), creationRole;
      }
    };
    exports2.ClusterResource = ClusterResource;
    function clusterArnComponents(clusterName) {
      return { service: "eks", resource: "cluster", resourceName: clusterName };
    }
    exports2.clusterArnComponents = clusterArnComponents;
  }
});

// node_modules/aws-cdk-lib/aws-eks/lib/fargate-profile.js
var require_fargate_profile = __commonJS({
  "node_modules/aws-cdk-lib/aws-eks/lib/fargate-profile.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FargateProfile = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var consts_1 = require_consts2();
    var cluster_resource_provider_1 = require_cluster_resource_provider();
    var ec2 = require_aws_ec2();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var FargateProfile = class _FargateProfile extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eks_FargateProfileProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _FargateProfile), error;
        }
        const provider = cluster_resource_provider_1.ClusterResourceProvider.getOrCreate(this, { onEventLayer: props.cluster.onEventLayer });
        this.podExecutionRole = props.podExecutionRole ?? new iam.Role(this, "PodExecutionRole", { assumedBy: new iam.ServicePrincipal("eks-fargate-pods.amazonaws.com"), managedPolicies: [iam.ManagedPolicy.fromAwsManagedPolicyName("AmazonEKSFargatePodExecutionRolePolicy")] }), this.podExecutionRole.grantPassRole(props.cluster.adminRole), props.subnetSelection && !props.vpc && core_1.Annotations.of(this).addWarning("Vpc must be defined to use a custom subnet selection. All private subnets belonging to the EKS cluster will be used by default");
        let subnets;
        if (props.vpc) {
          const selection = props.subnetSelection ?? { subnetType: ec2.SubnetType.PRIVATE_WITH_EGRESS };
          subnets = props.vpc.selectSubnets(selection).subnetIds;
        }
        if (props.selectors.length < 1)
          throw new Error("Fargate profile requires at least one selector");
        if (props.selectors.length > 5)
          throw new Error("Fargate profile supports up to five selectors");
        this.tags = new core_1.TagManager(core_1.TagType.MAP, "AWS::EKS::FargateProfile");
        const resource = new core_1.CustomResource(this, "Resource", { serviceToken: provider.serviceToken, resourceType: consts_1.FARGATE_PROFILE_RESOURCE_TYPE, properties: { AssumeRoleArn: props.cluster.adminRole.roleArn, Config: { clusterName: props.cluster.clusterName, fargateProfileName: props.fargateProfileName, podExecutionRoleArn: this.podExecutionRole.roleArn, selectors: props.selectors, subnets, tags: core_1.Lazy.any({ produce: () => this.tags.renderTags() }) } } });
        this.fargateProfileArn = resource.getAttString("fargateProfileArn"), this.fargateProfileName = resource.ref;
        const clusterFargateProfiles = props.cluster._attachFargateProfile(this);
        if (clusterFargateProfiles.length > 1) {
          const previousProfile = clusterFargateProfiles[clusterFargateProfiles.length - 2];
          resource.node.addDependency(previousProfile);
        }
        props.cluster.awsAuth.addRoleMapping(this.podExecutionRole, { username: "system:node:{{SessionName}}", groups: ["system:bootstrappers", "system:nodes", "system:node-proxier"] });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, FargateProfile[_a] = { fqn: "aws-cdk-lib.aws_eks.FargateProfile", version: "2.80.0" }, exports2.FargateProfile = FargateProfile;
  }
});

// node_modules/aws-cdk-lib/aws-eks/lib/instance-types.js
var require_instance_types2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-eks/lib/instance-types.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.INSTANCE_TYPES = void 0, exports2.INSTANCE_TYPES = { gpu: ["p2", "p3", "g2", "g3", "g4"], inferentia: ["inf1"], graviton: ["a1"], graviton2: ["c6g", "m6g", "r6g", "t4g"], graviton3: ["c7g"] };
  }
});

// node_modules/aws-cdk-lib/aws-eks/lib/k8s-object-value.js
var require_k8s_object_value = __commonJS({
  "node_modules/aws-cdk-lib/aws-eks/lib/k8s-object-value.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.KubernetesObjectValue = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var kubectl_provider_1 = require_kubectl_provider();
    var core_1 = require_core2();
    var KubernetesObjectValue = class _KubernetesObjectValue extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eks_KubernetesObjectValueProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _KubernetesObjectValue), error;
        }
        const provider = kubectl_provider_1.KubectlProvider.getOrCreate(this, props.cluster);
        this._resource = new core_1.CustomResource(this, "Resource", { resourceType: _KubernetesObjectValue.RESOURCE_TYPE, serviceToken: provider.serviceToken, properties: { ClusterName: props.cluster.clusterName, RoleArn: provider.roleArn, ObjectType: props.objectType, ObjectName: props.objectName, ObjectNamespace: props.objectNamespace ?? "default", JsonPath: props.jsonPath, TimeoutSeconds: (props?.timeout ?? core_1.Duration.minutes(5)).toSeconds() } });
      }
      get value() {
        return core_1.Token.asString(this._resource.getAtt("Value"));
      }
    };
    _a = JSII_RTTI_SYMBOL_1, KubernetesObjectValue[_a] = { fqn: "aws-cdk-lib.aws_eks.KubernetesObjectValue", version: "2.80.0" }, KubernetesObjectValue.RESOURCE_TYPE = "Custom::AWSCDK-EKS-KubernetesObjectValue", exports2.KubernetesObjectValue = KubernetesObjectValue;
  }
});

// node_modules/aws-cdk-lib/aws-eks/lib/k8s-patch.js
var require_k8s_patch = __commonJS({
  "node_modules/aws-cdk-lib/aws-eks/lib/k8s-patch.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.KubernetesPatch = exports2.PatchType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var kubectl_provider_1 = require_kubectl_provider();
    var core_1 = require_core2();
    var PatchType;
    (function(PatchType2) {
      PatchType2.JSON = "json", PatchType2.MERGE = "merge", PatchType2.STRATEGIC = "strategic";
    })(PatchType = exports2.PatchType || (exports2.PatchType = {}));
    var KubernetesPatch = class _KubernetesPatch extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eks_KubernetesPatchProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _KubernetesPatch), error;
        }
        const stack = core_1.Stack.of(this), provider = kubectl_provider_1.KubectlProvider.getOrCreate(this, props.cluster);
        new core_1.CustomResource(this, "Resource", { serviceToken: provider.serviceToken, resourceType: "Custom::AWSCDK-EKS-KubernetesPatch", properties: { ResourceName: props.resourceName, ResourceNamespace: props.resourceNamespace ?? "default", ApplyPatchJson: stack.toJsonString(props.applyPatch), RestorePatchJson: stack.toJsonString(props.restorePatch), ClusterName: props.cluster.clusterName, RoleArn: provider.roleArn, PatchType: props.patchType ?? PatchType.STRATEGIC } });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, KubernetesPatch[_a] = { fqn: "aws-cdk-lib.aws_eks.KubernetesPatch", version: "2.80.0" }, exports2.KubernetesPatch = KubernetesPatch;
  }
});

// node_modules/aws-cdk-lib/aws-eks/lib/eks.generated.js
var require_eks_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-eks/lib/eks.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnNodegroup = exports2.CfnIdentityProviderConfig = exports2.CfnFargateProfile = exports2.CfnCluster = exports2.CfnAddon = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAddonPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("addonName", cdk.requiredValidator)(properties.addonName)), errors.collect(cdk.propertyValidator("addonName", cdk.validateString)(properties.addonName)), errors.collect(cdk.propertyValidator("addonVersion", cdk.validateString)(properties.addonVersion)), errors.collect(cdk.propertyValidator("clusterName", cdk.requiredValidator)(properties.clusterName)), errors.collect(cdk.propertyValidator("clusterName", cdk.validateString)(properties.clusterName)), errors.collect(cdk.propertyValidator("configurationValues", cdk.validateString)(properties.configurationValues)), errors.collect(cdk.propertyValidator("preserveOnDelete", cdk.validateBoolean)(properties.preserveOnDelete)), errors.collect(cdk.propertyValidator("resolveConflicts", cdk.validateString)(properties.resolveConflicts)), errors.collect(cdk.propertyValidator("serviceAccountRoleArn", cdk.validateString)(properties.serviceAccountRoleArn)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnAddonProps"');
    }
    function cfnAddonPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAddonPropsValidator(properties).assertSuccess(), { AddonName: cdk.stringToCloudFormation(properties.addonName), ClusterName: cdk.stringToCloudFormation(properties.clusterName), AddonVersion: cdk.stringToCloudFormation(properties.addonVersion), ConfigurationValues: cdk.stringToCloudFormation(properties.configurationValues), PreserveOnDelete: cdk.booleanToCloudFormation(properties.preserveOnDelete), ResolveConflicts: cdk.stringToCloudFormation(properties.resolveConflicts), ServiceAccountRoleArn: cdk.stringToCloudFormation(properties.serviceAccountRoleArn), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnAddonPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("addonName", "AddonName", cfn_parse.FromCloudFormation.getString(properties.AddonName)), ret.addPropertyResult("clusterName", "ClusterName", cfn_parse.FromCloudFormation.getString(properties.ClusterName)), ret.addPropertyResult("addonVersion", "AddonVersion", properties.AddonVersion != null ? cfn_parse.FromCloudFormation.getString(properties.AddonVersion) : void 0), ret.addPropertyResult("configurationValues", "ConfigurationValues", properties.ConfigurationValues != null ? cfn_parse.FromCloudFormation.getString(properties.ConfigurationValues) : void 0), ret.addPropertyResult("preserveOnDelete", "PreserveOnDelete", properties.PreserveOnDelete != null ? cfn_parse.FromCloudFormation.getBoolean(properties.PreserveOnDelete) : void 0), ret.addPropertyResult("resolveConflicts", "ResolveConflicts", properties.ResolveConflicts != null ? cfn_parse.FromCloudFormation.getString(properties.ResolveConflicts) : void 0), ret.addPropertyResult("serviceAccountRoleArn", "ServiceAccountRoleArn", properties.ServiceAccountRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceAccountRoleArn) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAddon = class _CfnAddon extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAddonPropsFromCloudFormation(resourceProperties), ret = new _CfnAddon(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAddon.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eks_CfnAddonProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAddon), error;
        }
        cdk.requireProperty(props, "addonName", this), cdk.requireProperty(props, "clusterName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.addonName = props.addonName, this.clusterName = props.clusterName, this.addonVersion = props.addonVersion, this.configurationValues = props.configurationValues, this.preserveOnDelete = props.preserveOnDelete, this.resolveConflicts = props.resolveConflicts, this.serviceAccountRoleArn = props.serviceAccountRoleArn, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EKS::Addon", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAddon.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { addonName: this.addonName, clusterName: this.clusterName, addonVersion: this.addonVersion, configurationValues: this.configurationValues, preserveOnDelete: this.preserveOnDelete, resolveConflicts: this.resolveConflicts, serviceAccountRoleArn: this.serviceAccountRoleArn, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnAddonPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAddon[_a] = { fqn: "aws-cdk-lib.aws_eks.CfnAddon", version: "2.80.0" }, CfnAddon.CFN_RESOURCE_TYPE_NAME = "AWS::EKS::Addon", exports2.CfnAddon = CfnAddon;
    function CfnClusterPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("encryptionConfig", cdk.listValidator(CfnCluster_EncryptionConfigPropertyValidator))(properties.encryptionConfig)), errors.collect(cdk.propertyValidator("kubernetesNetworkConfig", CfnCluster_KubernetesNetworkConfigPropertyValidator)(properties.kubernetesNetworkConfig)), errors.collect(cdk.propertyValidator("logging", CfnCluster_LoggingPropertyValidator)(properties.logging)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("outpostConfig", CfnCluster_OutpostConfigPropertyValidator)(properties.outpostConfig)), errors.collect(cdk.propertyValidator("resourcesVpcConfig", cdk.requiredValidator)(properties.resourcesVpcConfig)), errors.collect(cdk.propertyValidator("resourcesVpcConfig", CfnCluster_ResourcesVpcConfigPropertyValidator)(properties.resourcesVpcConfig)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "CfnClusterProps"');
    }
    function cfnClusterPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClusterPropsValidator(properties).assertSuccess(), { ResourcesVpcConfig: cfnClusterResourcesVpcConfigPropertyToCloudFormation(properties.resourcesVpcConfig), RoleArn: cdk.stringToCloudFormation(properties.roleArn), EncryptionConfig: cdk.listMapper(cfnClusterEncryptionConfigPropertyToCloudFormation)(properties.encryptionConfig), KubernetesNetworkConfig: cfnClusterKubernetesNetworkConfigPropertyToCloudFormation(properties.kubernetesNetworkConfig), Logging: cfnClusterLoggingPropertyToCloudFormation(properties.logging), Name: cdk.stringToCloudFormation(properties.name), OutpostConfig: cfnClusterOutpostConfigPropertyToCloudFormation(properties.outpostConfig), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnClusterPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourcesVpcConfig", "ResourcesVpcConfig", CfnClusterResourcesVpcConfigPropertyFromCloudFormation(properties.ResourcesVpcConfig)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("encryptionConfig", "EncryptionConfig", properties.EncryptionConfig != null ? cfn_parse.FromCloudFormation.getArray(CfnClusterEncryptionConfigPropertyFromCloudFormation)(properties.EncryptionConfig) : void 0), ret.addPropertyResult("kubernetesNetworkConfig", "KubernetesNetworkConfig", properties.KubernetesNetworkConfig != null ? CfnClusterKubernetesNetworkConfigPropertyFromCloudFormation(properties.KubernetesNetworkConfig) : void 0), ret.addPropertyResult("logging", "Logging", properties.Logging != null ? CfnClusterLoggingPropertyFromCloudFormation(properties.Logging) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("outpostConfig", "OutpostConfig", properties.OutpostConfig != null ? CfnClusterOutpostConfigPropertyFromCloudFormation(properties.OutpostConfig) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getString(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCluster = class _CfnCluster extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnClusterPropsFromCloudFormation(resourceProperties), ret = new _CfnCluster(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCluster.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eks_CfnClusterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCluster), error;
        }
        cdk.requireProperty(props, "resourcesVpcConfig", this), cdk.requireProperty(props, "roleArn", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCertificateAuthorityData = cdk.Token.asString(this.getAtt("CertificateAuthorityData", cdk.ResolutionTypeHint.STRING)), this.attrClusterSecurityGroupId = cdk.Token.asString(this.getAtt("ClusterSecurityGroupId", cdk.ResolutionTypeHint.STRING)), this.attrEncryptionConfigKeyArn = cdk.Token.asString(this.getAtt("EncryptionConfigKeyArn", cdk.ResolutionTypeHint.STRING)), this.attrEndpoint = cdk.Token.asString(this.getAtt("Endpoint", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrKubernetesNetworkConfigServiceIpv6Cidr = cdk.Token.asString(this.getAtt("KubernetesNetworkConfig.ServiceIpv6Cidr", cdk.ResolutionTypeHint.STRING)), this.attrOpenIdConnectIssuerUrl = cdk.Token.asString(this.getAtt("OpenIdConnectIssuerUrl", cdk.ResolutionTypeHint.STRING)), this.resourcesVpcConfig = props.resourcesVpcConfig, this.roleArn = props.roleArn, this.encryptionConfig = props.encryptionConfig, this.kubernetesNetworkConfig = props.kubernetesNetworkConfig, this.logging = props.logging, this.name = props.name, this.outpostConfig = props.outpostConfig, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EKS::Cluster", props.tags, { tagPropertyName: "tags" }), this.version = props.version;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCluster.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { resourcesVpcConfig: this.resourcesVpcConfig, roleArn: this.roleArn, encryptionConfig: this.encryptionConfig, kubernetesNetworkConfig: this.kubernetesNetworkConfig, logging: this.logging, name: this.name, outpostConfig: this.outpostConfig, tags: this.tags.renderTags(), version: this.version };
      }
      renderProperties(props) {
        return cfnClusterPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnCluster[_b] = { fqn: "aws-cdk-lib.aws_eks.CfnCluster", version: "2.80.0" }, CfnCluster.CFN_RESOURCE_TYPE_NAME = "AWS::EKS::Cluster", exports2.CfnCluster = CfnCluster;
    function CfnCluster_ClusterLoggingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabledTypes", cdk.listValidator(CfnCluster_LoggingTypeConfigPropertyValidator))(properties.enabledTypes)), errors.wrap('supplied properties not correct for "ClusterLoggingProperty"');
    }
    function cfnClusterClusterLoggingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_ClusterLoggingPropertyValidator(properties).assertSuccess(), { EnabledTypes: cdk.listMapper(cfnClusterLoggingTypeConfigPropertyToCloudFormation)(properties.enabledTypes) }) : properties;
    }
    function CfnClusterClusterLoggingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabledTypes", "EnabledTypes", properties.EnabledTypes != null ? cfn_parse.FromCloudFormation.getArray(CfnClusterLoggingTypeConfigPropertyFromCloudFormation)(properties.EnabledTypes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_ControlPlanePlacementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groupName", cdk.validateString)(properties.groupName)), errors.wrap('supplied properties not correct for "ControlPlanePlacementProperty"');
    }
    function cfnClusterControlPlanePlacementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_ControlPlanePlacementPropertyValidator(properties).assertSuccess(), { GroupName: cdk.stringToCloudFormation(properties.groupName) }) : properties;
    }
    function CfnClusterControlPlanePlacementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupName", "GroupName", properties.GroupName != null ? cfn_parse.FromCloudFormation.getString(properties.GroupName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_EncryptionConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("provider", CfnCluster_ProviderPropertyValidator)(properties.provider)), errors.collect(cdk.propertyValidator("resources", cdk.listValidator(cdk.validateString))(properties.resources)), errors.wrap('supplied properties not correct for "EncryptionConfigProperty"');
    }
    function cfnClusterEncryptionConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_EncryptionConfigPropertyValidator(properties).assertSuccess(), { Provider: cfnClusterProviderPropertyToCloudFormation(properties.provider), Resources: cdk.listMapper(cdk.stringToCloudFormation)(properties.resources) }) : properties;
    }
    function CfnClusterEncryptionConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("provider", "Provider", properties.Provider != null ? CfnClusterProviderPropertyFromCloudFormation(properties.Provider) : void 0), ret.addPropertyResult("resources", "Resources", properties.Resources != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Resources) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_KubernetesNetworkConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ipFamily", cdk.validateString)(properties.ipFamily)), errors.collect(cdk.propertyValidator("serviceIpv4Cidr", cdk.validateString)(properties.serviceIpv4Cidr)), errors.collect(cdk.propertyValidator("serviceIpv6Cidr", cdk.validateString)(properties.serviceIpv6Cidr)), errors.wrap('supplied properties not correct for "KubernetesNetworkConfigProperty"');
    }
    function cfnClusterKubernetesNetworkConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_KubernetesNetworkConfigPropertyValidator(properties).assertSuccess(), { IpFamily: cdk.stringToCloudFormation(properties.ipFamily), ServiceIpv4Cidr: cdk.stringToCloudFormation(properties.serviceIpv4Cidr), ServiceIpv6Cidr: cdk.stringToCloudFormation(properties.serviceIpv6Cidr) }) : properties;
    }
    function CfnClusterKubernetesNetworkConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ipFamily", "IpFamily", properties.IpFamily != null ? cfn_parse.FromCloudFormation.getString(properties.IpFamily) : void 0), ret.addPropertyResult("serviceIpv4Cidr", "ServiceIpv4Cidr", properties.ServiceIpv4Cidr != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceIpv4Cidr) : void 0), ret.addPropertyResult("serviceIpv6Cidr", "ServiceIpv6Cidr", properties.ServiceIpv6Cidr != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceIpv6Cidr) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_LoggingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clusterLogging", CfnCluster_ClusterLoggingPropertyValidator)(properties.clusterLogging)), errors.wrap('supplied properties not correct for "LoggingProperty"');
    }
    function cfnClusterLoggingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_LoggingPropertyValidator(properties).assertSuccess(), { ClusterLogging: cfnClusterClusterLoggingPropertyToCloudFormation(properties.clusterLogging) }) : properties;
    }
    function CfnClusterLoggingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clusterLogging", "ClusterLogging", properties.ClusterLogging != null ? CfnClusterClusterLoggingPropertyFromCloudFormation(properties.ClusterLogging) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_LoggingTypeConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "LoggingTypeConfigProperty"');
    }
    function cfnClusterLoggingTypeConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_LoggingTypeConfigPropertyValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnClusterLoggingTypeConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_OutpostConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("controlPlaneInstanceType", cdk.requiredValidator)(properties.controlPlaneInstanceType)), errors.collect(cdk.propertyValidator("controlPlaneInstanceType", cdk.validateString)(properties.controlPlaneInstanceType)), errors.collect(cdk.propertyValidator("controlPlanePlacement", CfnCluster_ControlPlanePlacementPropertyValidator)(properties.controlPlanePlacement)), errors.collect(cdk.propertyValidator("outpostArns", cdk.requiredValidator)(properties.outpostArns)), errors.collect(cdk.propertyValidator("outpostArns", cdk.listValidator(cdk.validateString))(properties.outpostArns)), errors.wrap('supplied properties not correct for "OutpostConfigProperty"');
    }
    function cfnClusterOutpostConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_OutpostConfigPropertyValidator(properties).assertSuccess(), { ControlPlaneInstanceType: cdk.stringToCloudFormation(properties.controlPlaneInstanceType), ControlPlanePlacement: cfnClusterControlPlanePlacementPropertyToCloudFormation(properties.controlPlanePlacement), OutpostArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.outpostArns) }) : properties;
    }
    function CfnClusterOutpostConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("controlPlaneInstanceType", "ControlPlaneInstanceType", cfn_parse.FromCloudFormation.getString(properties.ControlPlaneInstanceType)), ret.addPropertyResult("controlPlanePlacement", "ControlPlanePlacement", properties.ControlPlanePlacement != null ? CfnClusterControlPlanePlacementPropertyFromCloudFormation(properties.ControlPlanePlacement) : void 0), ret.addPropertyResult("outpostArns", "OutpostArns", cfn_parse.FromCloudFormation.getStringArray(properties.OutpostArns)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_ProviderPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("keyArn", cdk.validateString)(properties.keyArn)), errors.wrap('supplied properties not correct for "ProviderProperty"');
    }
    function cfnClusterProviderPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_ProviderPropertyValidator(properties).assertSuccess(), { KeyArn: cdk.stringToCloudFormation(properties.keyArn) }) : properties;
    }
    function CfnClusterProviderPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("keyArn", "KeyArn", properties.KeyArn != null ? cfn_parse.FromCloudFormation.getString(properties.KeyArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_ResourcesVpcConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endpointPrivateAccess", cdk.validateBoolean)(properties.endpointPrivateAccess)), errors.collect(cdk.propertyValidator("endpointPublicAccess", cdk.validateBoolean)(properties.endpointPublicAccess)), errors.collect(cdk.propertyValidator("publicAccessCidrs", cdk.listValidator(cdk.validateString))(properties.publicAccessCidrs)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.requiredValidator)(properties.subnetIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.wrap('supplied properties not correct for "ResourcesVpcConfigProperty"');
    }
    function cfnClusterResourcesVpcConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_ResourcesVpcConfigPropertyValidator(properties).assertSuccess(), { EndpointPrivateAccess: cdk.booleanToCloudFormation(properties.endpointPrivateAccess), EndpointPublicAccess: cdk.booleanToCloudFormation(properties.endpointPublicAccess), PublicAccessCidrs: cdk.listMapper(cdk.stringToCloudFormation)(properties.publicAccessCidrs), SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds) }) : properties;
    }
    function CfnClusterResourcesVpcConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endpointPrivateAccess", "EndpointPrivateAccess", properties.EndpointPrivateAccess != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EndpointPrivateAccess) : void 0), ret.addPropertyResult("endpointPublicAccess", "EndpointPublicAccess", properties.EndpointPublicAccess != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EndpointPublicAccess) : void 0), ret.addPropertyResult("publicAccessCidrs", "PublicAccessCidrs", properties.PublicAccessCidrs != null ? cfn_parse.FromCloudFormation.getStringArray(properties.PublicAccessCidrs) : void 0), ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("subnetIds", "SubnetIds", cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFargateProfilePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clusterName", cdk.requiredValidator)(properties.clusterName)), errors.collect(cdk.propertyValidator("clusterName", cdk.validateString)(properties.clusterName)), errors.collect(cdk.propertyValidator("fargateProfileName", cdk.validateString)(properties.fargateProfileName)), errors.collect(cdk.propertyValidator("podExecutionRoleArn", cdk.requiredValidator)(properties.podExecutionRoleArn)), errors.collect(cdk.propertyValidator("podExecutionRoleArn", cdk.validateString)(properties.podExecutionRoleArn)), errors.collect(cdk.propertyValidator("selectors", cdk.requiredValidator)(properties.selectors)), errors.collect(cdk.propertyValidator("selectors", cdk.listValidator(CfnFargateProfile_SelectorPropertyValidator))(properties.selectors)), errors.collect(cdk.propertyValidator("subnets", cdk.listValidator(cdk.validateString))(properties.subnets)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnFargateProfileProps"');
    }
    function cfnFargateProfilePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFargateProfilePropsValidator(properties).assertSuccess(), { ClusterName: cdk.stringToCloudFormation(properties.clusterName), PodExecutionRoleArn: cdk.stringToCloudFormation(properties.podExecutionRoleArn), Selectors: cdk.listMapper(cfnFargateProfileSelectorPropertyToCloudFormation)(properties.selectors), FargateProfileName: cdk.stringToCloudFormation(properties.fargateProfileName), Subnets: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnets), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnFargateProfilePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clusterName", "ClusterName", cfn_parse.FromCloudFormation.getString(properties.ClusterName)), ret.addPropertyResult("podExecutionRoleArn", "PodExecutionRoleArn", cfn_parse.FromCloudFormation.getString(properties.PodExecutionRoleArn)), ret.addPropertyResult("selectors", "Selectors", cfn_parse.FromCloudFormation.getArray(CfnFargateProfileSelectorPropertyFromCloudFormation)(properties.Selectors)), ret.addPropertyResult("fargateProfileName", "FargateProfileName", properties.FargateProfileName != null ? cfn_parse.FromCloudFormation.getString(properties.FargateProfileName) : void 0), ret.addPropertyResult("subnets", "Subnets", properties.Subnets != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Subnets) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFargateProfile = class _CfnFargateProfile extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFargateProfilePropsFromCloudFormation(resourceProperties), ret = new _CfnFargateProfile(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFargateProfile.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eks_CfnFargateProfileProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFargateProfile), error;
        }
        cdk.requireProperty(props, "clusterName", this), cdk.requireProperty(props, "podExecutionRoleArn", this), cdk.requireProperty(props, "selectors", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.clusterName = props.clusterName, this.podExecutionRoleArn = props.podExecutionRoleArn, this.selectors = props.selectors, this.fargateProfileName = props.fargateProfileName, this.subnets = props.subnets, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EKS::FargateProfile", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFargateProfile.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { clusterName: this.clusterName, podExecutionRoleArn: this.podExecutionRoleArn, selectors: this.selectors, fargateProfileName: this.fargateProfileName, subnets: this.subnets, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnFargateProfilePropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnFargateProfile[_c] = { fqn: "aws-cdk-lib.aws_eks.CfnFargateProfile", version: "2.80.0" }, CfnFargateProfile.CFN_RESOURCE_TYPE_NAME = "AWS::EKS::FargateProfile", exports2.CfnFargateProfile = CfnFargateProfile;
    function CfnFargateProfile_LabelPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "LabelProperty"');
    }
    function cfnFargateProfileLabelPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFargateProfile_LabelPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnFargateProfileLabelPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFargateProfile_SelectorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("labels", cdk.listValidator(CfnFargateProfile_LabelPropertyValidator))(properties.labels)), errors.collect(cdk.propertyValidator("namespace", cdk.requiredValidator)(properties.namespace)), errors.collect(cdk.propertyValidator("namespace", cdk.validateString)(properties.namespace)), errors.wrap('supplied properties not correct for "SelectorProperty"');
    }
    function cfnFargateProfileSelectorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFargateProfile_SelectorPropertyValidator(properties).assertSuccess(), { Labels: cdk.listMapper(cfnFargateProfileLabelPropertyToCloudFormation)(properties.labels), Namespace: cdk.stringToCloudFormation(properties.namespace) }) : properties;
    }
    function CfnFargateProfileSelectorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("labels", "Labels", properties.Labels != null ? cfn_parse.FromCloudFormation.getArray(CfnFargateProfileLabelPropertyFromCloudFormation)(properties.Labels) : void 0), ret.addPropertyResult("namespace", "Namespace", cfn_parse.FromCloudFormation.getString(properties.Namespace)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIdentityProviderConfigPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clusterName", cdk.requiredValidator)(properties.clusterName)), errors.collect(cdk.propertyValidator("clusterName", cdk.validateString)(properties.clusterName)), errors.collect(cdk.propertyValidator("identityProviderConfigName", cdk.validateString)(properties.identityProviderConfigName)), errors.collect(cdk.propertyValidator("oidc", CfnIdentityProviderConfig_OidcIdentityProviderConfigPropertyValidator)(properties.oidc)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnIdentityProviderConfigProps"');
    }
    function cfnIdentityProviderConfigPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIdentityProviderConfigPropsValidator(properties).assertSuccess(), { ClusterName: cdk.stringToCloudFormation(properties.clusterName), Type: cdk.stringToCloudFormation(properties.type), IdentityProviderConfigName: cdk.stringToCloudFormation(properties.identityProviderConfigName), Oidc: cfnIdentityProviderConfigOidcIdentityProviderConfigPropertyToCloudFormation(properties.oidc), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnIdentityProviderConfigPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clusterName", "ClusterName", cfn_parse.FromCloudFormation.getString(properties.ClusterName)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("identityProviderConfigName", "IdentityProviderConfigName", properties.IdentityProviderConfigName != null ? cfn_parse.FromCloudFormation.getString(properties.IdentityProviderConfigName) : void 0), ret.addPropertyResult("oidc", "Oidc", properties.Oidc != null ? CfnIdentityProviderConfigOidcIdentityProviderConfigPropertyFromCloudFormation(properties.Oidc) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnIdentityProviderConfig = class _CfnIdentityProviderConfig extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnIdentityProviderConfigPropsFromCloudFormation(resourceProperties), ret = new _CfnIdentityProviderConfig(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnIdentityProviderConfig.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eks_CfnIdentityProviderConfigProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnIdentityProviderConfig), error;
        }
        cdk.requireProperty(props, "clusterName", this), cdk.requireProperty(props, "type", this), this.attrIdentityProviderConfigArn = cdk.Token.asString(this.getAtt("IdentityProviderConfigArn", cdk.ResolutionTypeHint.STRING)), this.clusterName = props.clusterName, this.type = props.type, this.identityProviderConfigName = props.identityProviderConfigName, this.oidc = props.oidc, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EKS::IdentityProviderConfig", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnIdentityProviderConfig.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { clusterName: this.clusterName, type: this.type, identityProviderConfigName: this.identityProviderConfigName, oidc: this.oidc, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnIdentityProviderConfigPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnIdentityProviderConfig[_d] = { fqn: "aws-cdk-lib.aws_eks.CfnIdentityProviderConfig", version: "2.80.0" }, CfnIdentityProviderConfig.CFN_RESOURCE_TYPE_NAME = "AWS::EKS::IdentityProviderConfig", exports2.CfnIdentityProviderConfig = CfnIdentityProviderConfig;
    function CfnIdentityProviderConfig_OidcIdentityProviderConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clientId", cdk.requiredValidator)(properties.clientId)), errors.collect(cdk.propertyValidator("clientId", cdk.validateString)(properties.clientId)), errors.collect(cdk.propertyValidator("groupsClaim", cdk.validateString)(properties.groupsClaim)), errors.collect(cdk.propertyValidator("groupsPrefix", cdk.validateString)(properties.groupsPrefix)), errors.collect(cdk.propertyValidator("issuerUrl", cdk.requiredValidator)(properties.issuerUrl)), errors.collect(cdk.propertyValidator("issuerUrl", cdk.validateString)(properties.issuerUrl)), errors.collect(cdk.propertyValidator("requiredClaims", cdk.listValidator(CfnIdentityProviderConfig_RequiredClaimPropertyValidator))(properties.requiredClaims)), errors.collect(cdk.propertyValidator("usernameClaim", cdk.validateString)(properties.usernameClaim)), errors.collect(cdk.propertyValidator("usernamePrefix", cdk.validateString)(properties.usernamePrefix)), errors.wrap('supplied properties not correct for "OidcIdentityProviderConfigProperty"');
    }
    function cfnIdentityProviderConfigOidcIdentityProviderConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIdentityProviderConfig_OidcIdentityProviderConfigPropertyValidator(properties).assertSuccess(), { ClientId: cdk.stringToCloudFormation(properties.clientId), GroupsClaim: cdk.stringToCloudFormation(properties.groupsClaim), GroupsPrefix: cdk.stringToCloudFormation(properties.groupsPrefix), IssuerUrl: cdk.stringToCloudFormation(properties.issuerUrl), RequiredClaims: cdk.listMapper(cfnIdentityProviderConfigRequiredClaimPropertyToCloudFormation)(properties.requiredClaims), UsernameClaim: cdk.stringToCloudFormation(properties.usernameClaim), UsernamePrefix: cdk.stringToCloudFormation(properties.usernamePrefix) }) : properties;
    }
    function CfnIdentityProviderConfigOidcIdentityProviderConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clientId", "ClientId", cfn_parse.FromCloudFormation.getString(properties.ClientId)), ret.addPropertyResult("groupsClaim", "GroupsClaim", properties.GroupsClaim != null ? cfn_parse.FromCloudFormation.getString(properties.GroupsClaim) : void 0), ret.addPropertyResult("groupsPrefix", "GroupsPrefix", properties.GroupsPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.GroupsPrefix) : void 0), ret.addPropertyResult("issuerUrl", "IssuerUrl", cfn_parse.FromCloudFormation.getString(properties.IssuerUrl)), ret.addPropertyResult("requiredClaims", "RequiredClaims", properties.RequiredClaims != null ? cfn_parse.FromCloudFormation.getArray(CfnIdentityProviderConfigRequiredClaimPropertyFromCloudFormation)(properties.RequiredClaims) : void 0), ret.addPropertyResult("usernameClaim", "UsernameClaim", properties.UsernameClaim != null ? cfn_parse.FromCloudFormation.getString(properties.UsernameClaim) : void 0), ret.addPropertyResult("usernamePrefix", "UsernamePrefix", properties.UsernamePrefix != null ? cfn_parse.FromCloudFormation.getString(properties.UsernamePrefix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIdentityProviderConfig_RequiredClaimPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "RequiredClaimProperty"');
    }
    function cfnIdentityProviderConfigRequiredClaimPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIdentityProviderConfig_RequiredClaimPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnIdentityProviderConfigRequiredClaimPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnNodegroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("amiType", cdk.validateString)(properties.amiType)), errors.collect(cdk.propertyValidator("capacityType", cdk.validateString)(properties.capacityType)), errors.collect(cdk.propertyValidator("clusterName", cdk.requiredValidator)(properties.clusterName)), errors.collect(cdk.propertyValidator("clusterName", cdk.validateString)(properties.clusterName)), errors.collect(cdk.propertyValidator("diskSize", cdk.validateNumber)(properties.diskSize)), errors.collect(cdk.propertyValidator("forceUpdateEnabled", cdk.validateBoolean)(properties.forceUpdateEnabled)), errors.collect(cdk.propertyValidator("instanceTypes", cdk.listValidator(cdk.validateString))(properties.instanceTypes)), errors.collect(cdk.propertyValidator("labels", cdk.hashValidator(cdk.validateString))(properties.labels)), errors.collect(cdk.propertyValidator("launchTemplate", CfnNodegroup_LaunchTemplateSpecificationPropertyValidator)(properties.launchTemplate)), errors.collect(cdk.propertyValidator("nodeRole", cdk.requiredValidator)(properties.nodeRole)), errors.collect(cdk.propertyValidator("nodeRole", cdk.validateString)(properties.nodeRole)), errors.collect(cdk.propertyValidator("nodegroupName", cdk.validateString)(properties.nodegroupName)), errors.collect(cdk.propertyValidator("releaseVersion", cdk.validateString)(properties.releaseVersion)), errors.collect(cdk.propertyValidator("remoteAccess", CfnNodegroup_RemoteAccessPropertyValidator)(properties.remoteAccess)), errors.collect(cdk.propertyValidator("scalingConfig", CfnNodegroup_ScalingConfigPropertyValidator)(properties.scalingConfig)), errors.collect(cdk.propertyValidator("subnets", cdk.requiredValidator)(properties.subnets)), errors.collect(cdk.propertyValidator("subnets", cdk.listValidator(cdk.validateString))(properties.subnets)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.collect(cdk.propertyValidator("taints", cdk.listValidator(CfnNodegroup_TaintPropertyValidator))(properties.taints)), errors.collect(cdk.propertyValidator("updateConfig", CfnNodegroup_UpdateConfigPropertyValidator)(properties.updateConfig)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "CfnNodegroupProps"');
    }
    function cfnNodegroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNodegroupPropsValidator(properties).assertSuccess(), { ClusterName: cdk.stringToCloudFormation(properties.clusterName), NodeRole: cdk.stringToCloudFormation(properties.nodeRole), Subnets: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnets), AmiType: cdk.stringToCloudFormation(properties.amiType), CapacityType: cdk.stringToCloudFormation(properties.capacityType), DiskSize: cdk.numberToCloudFormation(properties.diskSize), ForceUpdateEnabled: cdk.booleanToCloudFormation(properties.forceUpdateEnabled), InstanceTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.instanceTypes), Labels: cdk.hashMapper(cdk.stringToCloudFormation)(properties.labels), LaunchTemplate: cfnNodegroupLaunchTemplateSpecificationPropertyToCloudFormation(properties.launchTemplate), NodegroupName: cdk.stringToCloudFormation(properties.nodegroupName), ReleaseVersion: cdk.stringToCloudFormation(properties.releaseVersion), RemoteAccess: cfnNodegroupRemoteAccessPropertyToCloudFormation(properties.remoteAccess), ScalingConfig: cfnNodegroupScalingConfigPropertyToCloudFormation(properties.scalingConfig), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags), Taints: cdk.listMapper(cfnNodegroupTaintPropertyToCloudFormation)(properties.taints), UpdateConfig: cfnNodegroupUpdateConfigPropertyToCloudFormation(properties.updateConfig), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnNodegroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clusterName", "ClusterName", cfn_parse.FromCloudFormation.getString(properties.ClusterName)), ret.addPropertyResult("nodeRole", "NodeRole", cfn_parse.FromCloudFormation.getString(properties.NodeRole)), ret.addPropertyResult("subnets", "Subnets", cfn_parse.FromCloudFormation.getStringArray(properties.Subnets)), ret.addPropertyResult("amiType", "AmiType", properties.AmiType != null ? cfn_parse.FromCloudFormation.getString(properties.AmiType) : void 0), ret.addPropertyResult("capacityType", "CapacityType", properties.CapacityType != null ? cfn_parse.FromCloudFormation.getString(properties.CapacityType) : void 0), ret.addPropertyResult("diskSize", "DiskSize", properties.DiskSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.DiskSize) : void 0), ret.addPropertyResult("forceUpdateEnabled", "ForceUpdateEnabled", properties.ForceUpdateEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ForceUpdateEnabled) : void 0), ret.addPropertyResult("instanceTypes", "InstanceTypes", properties.InstanceTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.InstanceTypes) : void 0), ret.addPropertyResult("labels", "Labels", properties.Labels != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Labels) : void 0), ret.addPropertyResult("launchTemplate", "LaunchTemplate", properties.LaunchTemplate != null ? CfnNodegroupLaunchTemplateSpecificationPropertyFromCloudFormation(properties.LaunchTemplate) : void 0), ret.addPropertyResult("nodegroupName", "NodegroupName", properties.NodegroupName != null ? cfn_parse.FromCloudFormation.getString(properties.NodegroupName) : void 0), ret.addPropertyResult("releaseVersion", "ReleaseVersion", properties.ReleaseVersion != null ? cfn_parse.FromCloudFormation.getString(properties.ReleaseVersion) : void 0), ret.addPropertyResult("remoteAccess", "RemoteAccess", properties.RemoteAccess != null ? CfnNodegroupRemoteAccessPropertyFromCloudFormation(properties.RemoteAccess) : void 0), ret.addPropertyResult("scalingConfig", "ScalingConfig", properties.ScalingConfig != null ? CfnNodegroupScalingConfigPropertyFromCloudFormation(properties.ScalingConfig) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addPropertyResult("taints", "Taints", properties.Taints != null ? cfn_parse.FromCloudFormation.getArray(CfnNodegroupTaintPropertyFromCloudFormation)(properties.Taints) : void 0), ret.addPropertyResult("updateConfig", "UpdateConfig", properties.UpdateConfig != null ? CfnNodegroupUpdateConfigPropertyFromCloudFormation(properties.UpdateConfig) : void 0), ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getString(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnNodegroup = class _CfnNodegroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnNodegroupPropsFromCloudFormation(resourceProperties), ret = new _CfnNodegroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnNodegroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eks_CfnNodegroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnNodegroup), error;
        }
        cdk.requireProperty(props, "clusterName", this), cdk.requireProperty(props, "nodeRole", this), cdk.requireProperty(props, "subnets", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrClusterName = cdk.Token.asString(this.getAtt("ClusterName", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrNodegroupName = cdk.Token.asString(this.getAtt("NodegroupName", cdk.ResolutionTypeHint.STRING)), this.clusterName = props.clusterName, this.nodeRole = props.nodeRole, this.subnets = props.subnets, this.amiType = props.amiType, this.capacityType = props.capacityType, this.diskSize = props.diskSize, this.forceUpdateEnabled = props.forceUpdateEnabled, this.instanceTypes = props.instanceTypes, this.labels = props.labels, this.launchTemplate = props.launchTemplate, this.nodegroupName = props.nodegroupName, this.releaseVersion = props.releaseVersion, this.remoteAccess = props.remoteAccess, this.scalingConfig = props.scalingConfig, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::EKS::Nodegroup", props.tags, { tagPropertyName: "tags" }), this.taints = props.taints, this.updateConfig = props.updateConfig, this.version = props.version;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnNodegroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { clusterName: this.clusterName, nodeRole: this.nodeRole, subnets: this.subnets, amiType: this.amiType, capacityType: this.capacityType, diskSize: this.diskSize, forceUpdateEnabled: this.forceUpdateEnabled, instanceTypes: this.instanceTypes, labels: this.labels, launchTemplate: this.launchTemplate, nodegroupName: this.nodegroupName, releaseVersion: this.releaseVersion, remoteAccess: this.remoteAccess, scalingConfig: this.scalingConfig, tags: this.tags.renderTags(), taints: this.taints, updateConfig: this.updateConfig, version: this.version };
      }
      renderProperties(props) {
        return cfnNodegroupPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnNodegroup[_e] = { fqn: "aws-cdk-lib.aws_eks.CfnNodegroup", version: "2.80.0" }, CfnNodegroup.CFN_RESOURCE_TYPE_NAME = "AWS::EKS::Nodegroup", exports2.CfnNodegroup = CfnNodegroup;
    function CfnNodegroup_LaunchTemplateSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "LaunchTemplateSpecificationProperty"');
    }
    function cfnNodegroupLaunchTemplateSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNodegroup_LaunchTemplateSpecificationPropertyValidator(properties).assertSuccess(), { Id: cdk.stringToCloudFormation(properties.id), Name: cdk.stringToCloudFormation(properties.name), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnNodegroupLaunchTemplateSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("id", "Id", properties.Id != null ? cfn_parse.FromCloudFormation.getString(properties.Id) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getString(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnNodegroup_RemoteAccessPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ec2SshKey", cdk.requiredValidator)(properties.ec2SshKey)), errors.collect(cdk.propertyValidator("ec2SshKey", cdk.validateString)(properties.ec2SshKey)), errors.collect(cdk.propertyValidator("sourceSecurityGroups", cdk.listValidator(cdk.validateString))(properties.sourceSecurityGroups)), errors.wrap('supplied properties not correct for "RemoteAccessProperty"');
    }
    function cfnNodegroupRemoteAccessPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNodegroup_RemoteAccessPropertyValidator(properties).assertSuccess(), { Ec2SshKey: cdk.stringToCloudFormation(properties.ec2SshKey), SourceSecurityGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.sourceSecurityGroups) }) : properties;
    }
    function CfnNodegroupRemoteAccessPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ec2SshKey", "Ec2SshKey", cfn_parse.FromCloudFormation.getString(properties.Ec2SshKey)), ret.addPropertyResult("sourceSecurityGroups", "SourceSecurityGroups", properties.SourceSecurityGroups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SourceSecurityGroups) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnNodegroup_ScalingConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("desiredSize", cdk.validateNumber)(properties.desiredSize)), errors.collect(cdk.propertyValidator("maxSize", cdk.validateNumber)(properties.maxSize)), errors.collect(cdk.propertyValidator("minSize", cdk.validateNumber)(properties.minSize)), errors.wrap('supplied properties not correct for "ScalingConfigProperty"');
    }
    function cfnNodegroupScalingConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNodegroup_ScalingConfigPropertyValidator(properties).assertSuccess(), { DesiredSize: cdk.numberToCloudFormation(properties.desiredSize), MaxSize: cdk.numberToCloudFormation(properties.maxSize), MinSize: cdk.numberToCloudFormation(properties.minSize) }) : properties;
    }
    function CfnNodegroupScalingConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("desiredSize", "DesiredSize", properties.DesiredSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.DesiredSize) : void 0), ret.addPropertyResult("maxSize", "MaxSize", properties.MaxSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxSize) : void 0), ret.addPropertyResult("minSize", "MinSize", properties.MinSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinSize) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnNodegroup_TaintPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("effect", cdk.validateString)(properties.effect)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TaintProperty"');
    }
    function cfnNodegroupTaintPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNodegroup_TaintPropertyValidator(properties).assertSuccess(), { Effect: cdk.stringToCloudFormation(properties.effect), Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnNodegroupTaintPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("effect", "Effect", properties.Effect != null ? cfn_parse.FromCloudFormation.getString(properties.Effect) : void 0), ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnNodegroup_UpdateConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxUnavailable", cdk.validateNumber)(properties.maxUnavailable)), errors.collect(cdk.propertyValidator("maxUnavailablePercentage", cdk.validateNumber)(properties.maxUnavailablePercentage)), errors.wrap('supplied properties not correct for "UpdateConfigProperty"');
    }
    function cfnNodegroupUpdateConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNodegroup_UpdateConfigPropertyValidator(properties).assertSuccess(), { MaxUnavailable: cdk.numberToCloudFormation(properties.maxUnavailable), MaxUnavailablePercentage: cdk.numberToCloudFormation(properties.maxUnavailablePercentage) }) : properties;
    }
    function CfnNodegroupUpdateConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxUnavailable", "MaxUnavailable", properties.MaxUnavailable != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxUnavailable) : void 0), ret.addPropertyResult("maxUnavailablePercentage", "MaxUnavailablePercentage", properties.MaxUnavailablePercentage != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxUnavailablePercentage) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-eks/lib/managed-nodegroup.js
var require_managed_nodegroup = __commonJS({
  "node_modules/aws-cdk-lib/aws-eks/lib/managed-nodegroup.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Nodegroup = exports2.TaintEffect = exports2.CapacityType = exports2.NodegroupAmiType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var cluster_1 = require_cluster4();
    var eks_generated_1 = require_eks_generated();
    var aws_ec2_1 = require_aws_ec2();
    var aws_iam_1 = require_aws_iam();
    var core_1 = require_core2();
    var NodegroupAmiType;
    (function(NodegroupAmiType2) {
      NodegroupAmiType2.AL2_X86_64 = "AL2_x86_64", NodegroupAmiType2.AL2_X86_64_GPU = "AL2_x86_64_GPU", NodegroupAmiType2.AL2_ARM_64 = "AL2_ARM_64", NodegroupAmiType2.BOTTLEROCKET_ARM_64 = "BOTTLEROCKET_ARM_64", NodegroupAmiType2.BOTTLEROCKET_X86_64 = "BOTTLEROCKET_x86_64", NodegroupAmiType2.WINDOWS_CORE_2019_X86_64 = "WINDOWS_CORE_2019_x86_64", NodegroupAmiType2.WINDOWS_CORE_2022_X86_64 = "WINDOWS_CORE_2022_x86_64", NodegroupAmiType2.WINDOWS_FULL_2019_X86_64 = "WINDOWS_FULL_2019_x86_64", NodegroupAmiType2.WINDOWS_FULL_2022_X86_64 = "WINDOWS_FULL_2022_x86_64";
    })(NodegroupAmiType = exports2.NodegroupAmiType || (exports2.NodegroupAmiType = {}));
    var CapacityType;
    (function(CapacityType2) {
      CapacityType2.SPOT = "SPOT", CapacityType2.ON_DEMAND = "ON_DEMAND";
    })(CapacityType = exports2.CapacityType || (exports2.CapacityType = {}));
    var TaintEffect;
    (function(TaintEffect2) {
      TaintEffect2.NO_SCHEDULE = "NO_SCHEDULE", TaintEffect2.PREFER_NO_SCHEDULE = "PREFER_NO_SCHEDULE", TaintEffect2.NO_EXECUTE = "NO_EXECUTE";
    })(TaintEffect = exports2.TaintEffect || (exports2.TaintEffect = {}));
    var Nodegroup = class _Nodegroup extends core_1.Resource {
      static fromNodegroupName(scope, id, nodegroupName) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.nodegroupName = nodegroupName;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.nodegroupName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eks_NodegroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Nodegroup), error;
        }
        if (this.cluster = props.cluster, this.desiredSize = props.desiredSize ?? props.minSize ?? 2, this.maxSize = props.maxSize ?? this.desiredSize, this.minSize = props.minSize ?? 1, (0, core_1.withResolved)(this.desiredSize, this.maxSize, (desired, max) => {
          if (desired !== void 0 && desired > max)
            throw new Error(`Desired capacity ${desired} can't be greater than max size ${max}`);
        }), (0, core_1.withResolved)(this.desiredSize, this.minSize, (desired, min) => {
          if (desired !== void 0 && desired < min)
            throw new Error(`Minimum capacity ${min} can't be greater than desired size ${desired}`);
        }), props.launchTemplateSpec && props.diskSize)
          throw new Error("diskSize must be specified within the launch template");
        if (props.instanceType && props.instanceTypes)
          throw new Error('"instanceType is deprecated, please use "instanceTypes" only.');
        props.instanceType && core_1.Annotations.of(this).addWarning('"instanceType" is deprecated and will be removed in the next major version. please use "instanceTypes" instead');
        const instanceTypes = props.instanceTypes ?? (props.instanceType ? [props.instanceType] : void 0);
        let possibleAmiTypes = [];
        if (instanceTypes && instanceTypes.length > 0) {
          if (possibleAmiTypes = getPossibleAmiTypes(instanceTypes), props.amiType && !possibleAmiTypes.includes(props.amiType))
            throw new Error(`The specified AMI does not match the instance types architecture, either specify one of ${possibleAmiTypes} or don't specify any`);
          if (props.amiType && windowsAmiTypes.includes(props.amiType) && instanceTypes.filter(isWindowsSupportedInstanceType).length < instanceTypes.length)
            throw new Error("The specified instanceType does not support Windows workloads. Amazon EC2 instance types C3, C4, D2, I2, M4 (excluding m4.16xlarge), M6a.x, and R3 instances aren't supported for Windows workloads.");
        }
        if (props.nodeRole)
          this.role = props.nodeRole;
        else {
          const ngRole = new aws_iam_1.Role(this, "NodeGroupRole", { assumedBy: new aws_iam_1.ServicePrincipal("ec2.amazonaws.com") });
          ngRole.addManagedPolicy(aws_iam_1.ManagedPolicy.fromAwsManagedPolicyName("AmazonEKSWorkerNodePolicy")), ngRole.addManagedPolicy(aws_iam_1.ManagedPolicy.fromAwsManagedPolicyName("AmazonEKS_CNI_Policy")), ngRole.addManagedPolicy(aws_iam_1.ManagedPolicy.fromAwsManagedPolicyName("AmazonEC2ContainerRegistryReadOnly")), this.role = ngRole;
        }
        const resource = new eks_generated_1.CfnNodegroup(this, "Resource", { clusterName: this.cluster.clusterName, nodegroupName: props.nodegroupName, nodeRole: this.role.roleArn, subnets: this.cluster.vpc.selectSubnets(props.subnets).subnetIds, amiType: props.launchTemplateSpec ? props.amiType : props.amiType ?? possibleAmiTypes[0], capacityType: props.capacityType ? props.capacityType.valueOf() : void 0, diskSize: props.diskSize, forceUpdateEnabled: props.forceUpdate ?? true, instanceTypes: instanceTypes?.map((t) => t.toString()), labels: props.labels, taints: props.taints, launchTemplate: props.launchTemplateSpec, releaseVersion: props.releaseVersion, remoteAccess: props.remoteAccess ? { ec2SshKey: props.remoteAccess.sshKeyName, sourceSecurityGroups: props.remoteAccess.sourceSecurityGroups ? props.remoteAccess.sourceSecurityGroups.map((m) => m.securityGroupId) : void 0 } : void 0, scalingConfig: { desiredSize: this.desiredSize, maxSize: this.maxSize, minSize: this.minSize }, tags: props.tags });
        this.cluster instanceof cluster_1.Cluster && (this.cluster.awsAuth.addRoleMapping(this.role, { username: "system:node:{{EC2PrivateDNSName}}", groups: ["system:bootstrappers", "system:nodes"] }), this.cluster.albController && constructs_1.Node.of(this.cluster.albController).addDependency(this)), this.nodegroupArn = this.getResourceArnAttribute(resource.attrArn, { service: "eks", resource: "nodegroup", resourceName: this.physicalName }), this.nodegroupName = this.getResourceNameAttribute(resource.ref);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Nodegroup[_a] = { fqn: "aws-cdk-lib.aws_eks.Nodegroup", version: "2.80.0" }, exports2.Nodegroup = Nodegroup;
    var arm64AmiTypes = [NodegroupAmiType.AL2_ARM_64, NodegroupAmiType.BOTTLEROCKET_ARM_64];
    var x8664AmiTypes = [NodegroupAmiType.AL2_X86_64, NodegroupAmiType.BOTTLEROCKET_X86_64, NodegroupAmiType.WINDOWS_CORE_2019_X86_64, NodegroupAmiType.WINDOWS_CORE_2022_X86_64, NodegroupAmiType.WINDOWS_FULL_2019_X86_64, NodegroupAmiType.WINDOWS_FULL_2022_X86_64];
    var windowsAmiTypes = [NodegroupAmiType.WINDOWS_CORE_2019_X86_64, NodegroupAmiType.WINDOWS_CORE_2022_X86_64, NodegroupAmiType.WINDOWS_FULL_2019_X86_64, NodegroupAmiType.WINDOWS_FULL_2022_X86_64];
    var gpuAmiTypes = [NodegroupAmiType.AL2_X86_64_GPU];
    function isGpuInstanceType(instanceType) {
      return [aws_ec2_1.InstanceClass.P2, aws_ec2_1.InstanceClass.P3, aws_ec2_1.InstanceClass.P3DN, aws_ec2_1.InstanceClass.P4DE, aws_ec2_1.InstanceClass.P4D, aws_ec2_1.InstanceClass.G3S, aws_ec2_1.InstanceClass.G3, aws_ec2_1.InstanceClass.G4DN, aws_ec2_1.InstanceClass.G4AD, aws_ec2_1.InstanceClass.G5, aws_ec2_1.InstanceClass.G5G, aws_ec2_1.InstanceClass.INF1].some((c) => instanceType.sameInstanceClassAs(aws_ec2_1.InstanceType.of(c, aws_ec2_1.InstanceSize.LARGE)));
    }
    function isWindowsSupportedInstanceType(instanceType) {
      const forbiddenInstanceClasses = [aws_ec2_1.InstanceClass.C3, aws_ec2_1.InstanceClass.C4, aws_ec2_1.InstanceClass.D2, aws_ec2_1.InstanceClass.M4, aws_ec2_1.InstanceClass.M6A, aws_ec2_1.InstanceClass.R3];
      return instanceType.toString() === aws_ec2_1.InstanceType.of(aws_ec2_1.InstanceClass.M4, aws_ec2_1.InstanceSize.XLARGE16).toString() || forbiddenInstanceClasses.every((c) => !instanceType.sameInstanceClassAs(aws_ec2_1.InstanceType.of(c, aws_ec2_1.InstanceSize.LARGE)) && !instanceType.toString().match(/^i2/));
    }
    function getPossibleAmiTypes(instanceTypes) {
      function typeToArch(instanceType) {
        return isGpuInstanceType(instanceType) ? "GPU" : instanceType.architecture;
      }
      const archAmiMap = /* @__PURE__ */ new Map([[aws_ec2_1.InstanceArchitecture.ARM_64, arm64AmiTypes], [aws_ec2_1.InstanceArchitecture.X86_64, x8664AmiTypes], ["GPU", gpuAmiTypes]]), architectures = new Set(instanceTypes.map(typeToArch));
      if (architectures.size === 0)
        throw new Error(`Cannot determine any ami type comptaible with instance types: ${instanceTypes.map((i) => i.toString).join(",")}`);
      if (architectures.size > 1)
        throw new Error("instanceTypes of different architectures is not allowed");
      return archAmiMap.get(Array.from(architectures)[0]);
    }
  }
});

// node_modules/aws-cdk-lib/aws-eks/lib/oidc-provider.js
var require_oidc_provider2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-eks/lib/oidc-provider.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.OpenIdConnectProvider = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var OpenIdConnectProvider = class _OpenIdConnectProvider extends iam.OpenIdConnectProvider {
      constructor(scope, id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eks_OpenIdConnectProviderProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _OpenIdConnectProvider), error;
        }
        const clientIds = ["sts.amazonaws.com"];
        super(scope, id, { url: props.url, clientIds });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, OpenIdConnectProvider[_a] = { fqn: "aws-cdk-lib.aws_eks.OpenIdConnectProvider", version: "2.80.0" }, exports2.OpenIdConnectProvider = OpenIdConnectProvider;
  }
});

// node_modules/aws-cdk-lib/aws-eks/lib/private/bottlerocket.js
var require_bottlerocket = __commonJS({
  "node_modules/aws-cdk-lib/aws-eks/lib/private/bottlerocket.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.BottleRocketImage = void 0;
    var ec2 = require_aws_ec2();
    var ssm = require_aws_ssm();
    var BottleRocketImage = class {
      constructor(props) {
        this.kubernetesVersion = props.kubernetesVersion, this.amiParameterName = `/aws/service/bottlerocket/aws-k8s-${this.kubernetesVersion}/x86_64/latest/image_id`;
      }
      getImage(scope) {
        return { imageId: ssm.StringParameter.valueForStringParameter(scope, this.amiParameterName), osType: ec2.OperatingSystemType.LINUX, userData: ec2.UserData.custom("") };
      }
    };
    exports2.BottleRocketImage = BottleRocketImage;
  }
});

// node_modules/aws-cdk-lib/aws-eks/lib/service-account.js
var require_service_account = __commonJS({
  "node_modules/aws-cdk-lib/aws-eks/lib/service-account.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ServiceAccount = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var k8s_manifest_1 = require_k8s_manifest();
    var aws_iam_1 = require_aws_iam();
    var core_1 = require_core2();
    var ServiceAccount = class _ServiceAccount extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eks_ServiceAccountProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ServiceAccount), error;
        }
        const { cluster } = props;
        if (this.serviceAccountName = props.name ?? core_1.Names.uniqueId(this).toLowerCase(), this.serviceAccountNamespace = props.namespace ?? "default", !this.isValidDnsSubdomainName(this.serviceAccountName))
          throw RangeError("The name of a ServiceAccount object must be a valid DNS subdomain name.");
        if (!this.isValidDnsLabelName(this.serviceAccountNamespace))
          throw RangeError("All namespace names must be valid RFC 1123 DNS labels.");
        const conditions = new core_1.CfnJson(this, "ConditionJson", { value: { [`${cluster.openIdConnectProvider.openIdConnectProviderIssuer}:aud`]: "sts.amazonaws.com", [`${cluster.openIdConnectProvider.openIdConnectProviderIssuer}:sub`]: `system:serviceaccount:${this.serviceAccountNamespace}:${this.serviceAccountName}` } }), principal = new aws_iam_1.OpenIdConnectPrincipal(cluster.openIdConnectProvider).withConditions({ StringEquals: conditions });
        this.role = new aws_iam_1.Role(this, "Role", { assumedBy: principal }), this.assumeRoleAction = this.role.assumeRoleAction, this.grantPrincipal = this.role.grantPrincipal, this.policyFragment = this.role.policyFragment, new k8s_manifest_1.KubernetesManifest(this, `manifest-${id}ServiceAccountResource`, { cluster, manifest: [{ apiVersion: "v1", kind: "ServiceAccount", metadata: { name: this.serviceAccountName, namespace: this.serviceAccountNamespace, labels: { "app.kubernetes.io/name": this.serviceAccountName, ...props.labels }, annotations: { "eks.amazonaws.com/role-arn": this.role.roleArn, ...props.annotations } } }] });
      }
      addToPolicy(statement) {
        return this.addToPrincipalPolicy(statement).statementAdded;
      }
      addToPrincipalPolicy(statement) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(statement);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addToPrincipalPolicy), error;
        }
        return this.role.addToPrincipalPolicy(statement);
      }
      isValidDnsSubdomainName(value) {
        return value.length <= 253 && /^[a-z0-9]+[a-z0-9-.]*[a-z0-9]+$/.test(value);
      }
      isValidDnsLabelName(value) {
        return value.length <= 63 && /^[a-z0-9]+[a-z0-9-]*[a-z0-9]+$/.test(value);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ServiceAccount[_a] = { fqn: "aws-cdk-lib.aws_eks.ServiceAccount", version: "2.80.0" }, exports2.ServiceAccount = ServiceAccount;
  }
});

// node_modules/aws-cdk-lib/aws-eks/lib/user-data.js
var require_user_data2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-eks/lib/user-data.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LifecycleLabel = exports2.renderBottlerocketUserData = exports2.renderAmazonLinuxUserData = void 0;
    var core_1 = require_core2();
    function renderAmazonLinuxUserData(cluster, autoScalingGroup, options = {}) {
      const stack = core_1.Stack.of(autoScalingGroup), asgLogicalId = autoScalingGroup.node.defaultChild.logicalId, extraArgs = new Array();
      try {
        const clusterEndpoint = cluster.clusterEndpoint, clusterCertificateAuthorityData = cluster.clusterCertificateAuthorityData;
        extraArgs.push(`--apiserver-endpoint '${clusterEndpoint}'`), extraArgs.push(`--b64-cluster-ca '${clusterCertificateAuthorityData}'`);
      } catch {
      }
      extraArgs.push(`--use-max-pods ${options.useMaxPods ?? true}`), options.awsApiRetryAttempts && extraArgs.push(`--aws-api-retry-attempts ${options.awsApiRetryAttempts}`), options.enableDockerBridge && extraArgs.push("--enable-docker-bridge true"), options.dockerConfigJson && extraArgs.push(`--docker-config-json '${options.dockerConfigJson}'`), options.dnsClusterIp && extraArgs.push(`--dns-cluster-ip ${options.dnsClusterIp}`), options.additionalArgs && extraArgs.push(options.additionalArgs);
      const commandLineSuffix = extraArgs.join(" "), kubeletExtraArgsSuffix = options.kubeletExtraArgs || "", lifecycleLabel = autoScalingGroup.spotPrice ? LifecycleLabel.SPOT : LifecycleLabel.ON_DEMAND, withTaints = autoScalingGroup.spotPrice ? "--register-with-taints=spotInstance=true:PreferNoSchedule" : "", kubeletExtraArgs = `--node-labels lifecycle=${lifecycleLabel} ${withTaints} ${kubeletExtraArgsSuffix}`.trim();
      return ["set -o xtrace", `/etc/eks/bootstrap.sh ${cluster.clusterName} --kubelet-extra-args "${kubeletExtraArgs}" ${commandLineSuffix}`.trim(), `/opt/aws/bin/cfn-signal --exit-code $? --stack ${stack.stackName} --resource ${asgLogicalId} --region ${stack.region}`];
    }
    exports2.renderAmazonLinuxUserData = renderAmazonLinuxUserData;
    function renderBottlerocketUserData(cluster) {
      return ["[settings.kubernetes]", `api-server="${cluster.clusterEndpoint}"`, `cluster-certificate="${cluster.clusterCertificateAuthorityData}"`, `cluster-name="${cluster.clusterName}"`];
    }
    exports2.renderBottlerocketUserData = renderBottlerocketUserData;
    var LifecycleLabel;
    (function(LifecycleLabel2) {
      LifecycleLabel2.ON_DEMAND = "OnDemand", LifecycleLabel2.SPOT = "Ec2Spot";
    })(LifecycleLabel = exports2.LifecycleLabel || (exports2.LifecycleLabel = {}));
  }
});

// node_modules/aws-cdk-lib/aws-eks/lib/cluster.js
var require_cluster4 = __commonJS({
  "node_modules/aws-cdk-lib/aws-eks/lib/cluster.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.MachineImageType = exports2.DefaultCapacityType = exports2.CoreDnsComputeType = exports2.CpuArch = exports2.NodeType = exports2.EksOptimizedImage = exports2.Cluster = exports2.ClusterLoggingTypes = exports2.KubernetesVersion = exports2.EndpointAccess = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var fs = require("fs");
    var path = require("path");
    var constructs_1 = require_lib2();
    var semver = require_semver2();
    var YAML = require_yaml();
    var alb_controller_1 = require_alb_controller();
    var aws_auth_1 = require_aws_auth();
    var cluster_resource_1 = require_cluster_resource();
    var fargate_profile_1 = require_fargate_profile();
    var helm_chart_1 = require_helm_chart();
    var instance_types_1 = require_instance_types2();
    var k8s_manifest_1 = require_k8s_manifest();
    var k8s_object_value_1 = require_k8s_object_value();
    var k8s_patch_1 = require_k8s_patch();
    var kubectl_provider_1 = require_kubectl_provider();
    var managed_nodegroup_1 = require_managed_nodegroup();
    var oidc_provider_1 = require_oidc_provider2();
    var bottlerocket_1 = require_bottlerocket();
    var service_account_1 = require_service_account();
    var user_data_1 = require_user_data2();
    var autoscaling = require_aws_autoscaling();
    var ec2 = require_aws_ec2();
    var iam = require_aws_iam();
    var ssm = require_aws_ssm();
    var core_1 = require_core2();
    var DEFAULT_CAPACITY_COUNT = 2;
    var DEFAULT_CAPACITY_TYPE = ec2.InstanceType.of(ec2.InstanceClass.M5, ec2.InstanceSize.LARGE);
    var EndpointAccess = class _EndpointAccess {
      constructor(_config) {
        if (this._config = _config, !_config.publicAccess && _config.publicCidrs && _config.publicCidrs.length > 0)
          throw new Error("CIDR blocks can only be configured when public access is enabled");
      }
      onlyFrom(...cidr) {
        if (!this._config.privateAccess)
          throw new Error("Cannot restric public access to endpoint when private access is disabled. Use PUBLIC_AND_PRIVATE.onlyFrom() instead.");
        return new _EndpointAccess({ ...this._config, publicCidrs: cidr });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EndpointAccess[_a] = { fqn: "aws-cdk-lib.aws_eks.EndpointAccess", version: "2.80.0" }, EndpointAccess.PUBLIC = new EndpointAccess({ privateAccess: false, publicAccess: true }), EndpointAccess.PRIVATE = new EndpointAccess({ privateAccess: true, publicAccess: false }), EndpointAccess.PUBLIC_AND_PRIVATE = new EndpointAccess({ privateAccess: true, publicAccess: true }), exports2.EndpointAccess = EndpointAccess;
    var KubernetesVersion = class _KubernetesVersion {
      static of(version) {
        return new _KubernetesVersion(version);
      }
      constructor(version) {
        this.version = version;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, KubernetesVersion[_b] = { fqn: "aws-cdk-lib.aws_eks.KubernetesVersion", version: "2.80.0" }, KubernetesVersion.V1_14 = KubernetesVersion.of("1.14"), KubernetesVersion.V1_15 = KubernetesVersion.of("1.15"), KubernetesVersion.V1_16 = KubernetesVersion.of("1.16"), KubernetesVersion.V1_17 = KubernetesVersion.of("1.17"), KubernetesVersion.V1_18 = KubernetesVersion.of("1.18"), KubernetesVersion.V1_19 = KubernetesVersion.of("1.19"), KubernetesVersion.V1_20 = KubernetesVersion.of("1.20"), KubernetesVersion.V1_21 = KubernetesVersion.of("1.21"), KubernetesVersion.V1_22 = KubernetesVersion.of("1.22"), KubernetesVersion.V1_23 = KubernetesVersion.of("1.23"), KubernetesVersion.V1_24 = KubernetesVersion.of("1.24"), KubernetesVersion.V1_25 = KubernetesVersion.of("1.25"), KubernetesVersion.V1_26 = KubernetesVersion.of("1.26"), exports2.KubernetesVersion = KubernetesVersion;
    var ClusterLoggingTypes;
    (function(ClusterLoggingTypes2) {
      ClusterLoggingTypes2.API = "api", ClusterLoggingTypes2.AUDIT = "audit", ClusterLoggingTypes2.AUTHENTICATOR = "authenticator", ClusterLoggingTypes2.CONTROLLER_MANAGER = "controllerManager", ClusterLoggingTypes2.SCHEDULER = "scheduler";
    })(ClusterLoggingTypes = exports2.ClusterLoggingTypes || (exports2.ClusterLoggingTypes = {}));
    var ClusterBase = class extends core_1.Resource {
      addManifest(id, ...manifest) {
        return new k8s_manifest_1.KubernetesManifest(this, `manifest-${id}`, { cluster: this, manifest });
      }
      addHelmChart(id, options) {
        return new helm_chart_1.HelmChart(this, `chart-${id}`, { cluster: this, ...options });
      }
      addCdk8sChart(id, chart, options = {}) {
        const cdk8sChart = chart;
        if (typeof cdk8sChart.toJson != "function")
          throw new Error(`Invalid cdk8s chart. Must contain a 'toJson' method, but found ${typeof cdk8sChart.toJson}`);
        return new k8s_manifest_1.KubernetesManifest(this, id, { cluster: this, manifest: cdk8sChart.toJson(), ...options });
      }
      addServiceAccount(id, options = {}) {
        return new service_account_1.ServiceAccount(this, id, { ...options, cluster: this });
      }
      addSpotInterruptHandler() {
        return this._spotInterruptHandler || (this._spotInterruptHandler = this.addHelmChart("spot-interrupt-handler", { chart: "aws-node-termination-handler", version: "0.18.0", repository: "https://aws.github.io/eks-charts", namespace: "kube-system", values: { nodeSelector: { lifecycle: user_data_1.LifecycleLabel.SPOT } } })), this._spotInterruptHandler;
      }
      connectAutoScalingGroupCapacity(autoScalingGroup, options) {
        autoScalingGroup.connections.allowInternally(ec2.Port.allTraffic()), autoScalingGroup.connections.allowFrom(this, ec2.Port.tcp(443)), autoScalingGroup.connections.allowFrom(this, ec2.Port.tcpRange(1025, 65535)), autoScalingGroup.connections.allowTo(this, ec2.Port.tcp(443)), autoScalingGroup.connections.allowToAnyIpv4(ec2.Port.allTcp()), autoScalingGroup.connections.allowToAnyIpv4(ec2.Port.allUdp()), autoScalingGroup.connections.allowToAnyIpv4(ec2.Port.allIcmp()), autoScalingGroup.addSecurityGroup(this.clusterSecurityGroup);
        const bootstrapEnabled = options.bootstrapEnabled ?? true;
        if (options.bootstrapOptions && !bootstrapEnabled)
          throw new Error('Cannot specify "bootstrapOptions" if "bootstrapEnabled" is false');
        if (bootstrapEnabled) {
          const userData = options.machineImageType === MachineImageType.BOTTLEROCKET ? (0, user_data_1.renderBottlerocketUserData)(this) : (0, user_data_1.renderAmazonLinuxUserData)(this, autoScalingGroup, options.bootstrapOptions);
          autoScalingGroup.addUserData(...userData);
        }
        autoScalingGroup.role.addManagedPolicy(iam.ManagedPolicy.fromAwsManagedPolicyName("AmazonEKSWorkerNodePolicy")), autoScalingGroup.role.addManagedPolicy(iam.ManagedPolicy.fromAwsManagedPolicyName("AmazonEKS_CNI_Policy")), autoScalingGroup.role.addManagedPolicy(iam.ManagedPolicy.fromAwsManagedPolicyName("AmazonEC2ContainerRegistryReadOnly")), core_1.Tags.of(autoScalingGroup).add(`kubernetes.io/cluster/${this.clusterName}`, "owned", { applyToLaunchedInstances: true, excludeResourceTypes: ["AWS::EC2::SecurityGroup"] });
        let mapRole = options.mapRole ?? true;
        mapRole && !(this instanceof Cluster) && (core_1.Annotations.of(autoScalingGroup).addWarning("Auto-mapping aws-auth role for imported cluster is not supported, please map role manually"), mapRole = false), mapRole ? this.awsAuth.addRoleMapping(autoScalingGroup.role, { username: "system:node:{{EC2PrivateDNSName}}", groups: ["system:bootstrappers", "system:nodes"] }) : new core_1.CfnOutput(autoScalingGroup, "InstanceRoleARN", { value: autoScalingGroup.role.roleArn });
        const addSpotInterruptHandler = options.spotInterruptHandler ?? true;
        autoScalingGroup.spotPrice && addSpotInterruptHandler && this.addSpotInterruptHandler(), this instanceof Cluster && this.albController && constructs_1.Node.of(this.albController).addDependency(autoScalingGroup);
      }
    };
    var Cluster = class _Cluster extends ClusterBase {
      static fromClusterAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eks_ClusterAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromClusterAttributes), error;
        }
        return new ImportedCluster(scope, id, attrs);
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.clusterName }), this._fargateProfiles = [];
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eks_ClusterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Cluster), error;
        }
        const stack = core_1.Stack.of(this);
        this.prune = props.prune ?? true, this.vpc = props.vpc || new ec2.Vpc(this, "DefaultVpc");
        const kubectlVersion = new semver.SemVer(`${props.version.version}.0`);
        semver.gte(kubectlVersion, "1.22.0") && !props.kubectlLayer && core_1.Annotations.of(this).addWarning(`You created a cluster with Kubernetes Version ${props.version.version} without specifying the kubectlLayer property. This may cause failures as the kubectl version provided with aws-cdk-lib is 1.20, which is only guaranteed to be compatible with Kubernetes versions 1.19-1.21. Please provide a kubectlLayer from @aws-cdk/lambda-layer-kubectl-v${kubectlVersion.minor}.`), this.version = props.version, this.kubectlLambdaRole = props.kubectlLambdaRole ? props.kubectlLambdaRole : new iam.Role(this, "KubectlHandlerRole", { assumedBy: new iam.ServicePrincipal("lambda.amazonaws.com"), managedPolicies: [iam.ManagedPolicy.fromAwsManagedPolicyName("service-role/AWSLambdaBasicExecutionRole")] }), this.tagSubnets(), this.role = props.role || new iam.Role(this, "Role", { assumedBy: new iam.ServicePrincipal("eks.amazonaws.com"), managedPolicies: [iam.ManagedPolicy.fromAwsManagedPolicyName("AmazonEKSClusterPolicy")] });
        const securityGroup = props.securityGroup || new ec2.SecurityGroup(this, "ControlPlaneSecurityGroup", { vpc: this.vpc, description: "EKS Control Plane Security Group" });
        this.vpcSubnets = props.vpcSubnets ?? [{ subnetType: ec2.SubnetType.PUBLIC }, { subnetType: ec2.SubnetType.PRIVATE_WITH_EGRESS }];
        const selectedSubnetIdsPerGroup = this.vpcSubnets.map((s) => this.vpc.selectSubnets(s).subnetIds);
        if (selectedSubnetIdsPerGroup.some(core_1.Token.isUnresolved) && selectedSubnetIdsPerGroup.length > 1)
          throw new Error("eks.Cluster: cannot select multiple subnet groups from a VPC imported from list tokens with unknown length. Select only one subnet group, pass a length to Fn.split, or switch to Vpc.fromLookup.");
        const subnetIds = Array.from(new Set(flatten(selectedSubnetIdsPerGroup)));
        this.logging = props.clusterLogging ? { clusterLogging: [{ enabled: true, types: Object.values(props.clusterLogging) }] } : void 0, this.endpointAccess = props.endpointAccess ?? EndpointAccess.PUBLIC_AND_PRIVATE, this.kubectlEnvironment = props.kubectlEnvironment, this.kubectlLayer = props.kubectlLayer, this.awscliLayer = props.awscliLayer, this.kubectlMemory = props.kubectlMemory, this.onEventLayer = props.onEventLayer, this.clusterHandlerSecurityGroup = props.clusterHandlerSecurityGroup;
        const privateSubnets = this.selectPrivateSubnets().slice(0, 16), publicAccessDisabled = !this.endpointAccess._config.publicAccess, publicAccessRestricted = !publicAccessDisabled && this.endpointAccess._config.publicCidrs && this.endpointAccess._config.publicCidrs.length !== 0;
        if (privateSubnets.length === 0 && publicAccessDisabled)
          throw new Error("Vpc must contain private subnets when public endpoint access is disabled");
        if (privateSubnets.length === 0 && publicAccessRestricted)
          throw new Error("Vpc must contain private subnets when public endpoint access is restricted");
        const placeClusterHandlerInVpc = props.placeClusterHandlerInVpc ?? false;
        if (placeClusterHandlerInVpc && privateSubnets.length === 0)
          throw new Error("Cannot place cluster handler in the VPC since no private subnets could be selected");
        if (props.clusterHandlerSecurityGroup && !placeClusterHandlerInVpc)
          throw new Error("Cannot specify clusterHandlerSecurityGroup without placeClusterHandlerInVpc set to true");
        const resource = this._clusterResource = new cluster_resource_1.ClusterResource(this, "Resource", { name: this.physicalName, environment: props.clusterHandlerEnvironment, roleArn: this.role.roleArn, version: props.version.version, resourcesVpcConfig: { securityGroupIds: [securityGroup.securityGroupId], subnetIds }, ...props.secretsEncryptionKey ? { encryptionConfig: [{ provider: { keyArn: props.secretsEncryptionKey.keyArn }, resources: ["secrets"] }] } : {}, kubernetesNetworkConfig: props.serviceIpv4Cidr ? { serviceIpv4Cidr: props.serviceIpv4Cidr } : void 0, endpointPrivateAccess: this.endpointAccess._config.privateAccess, endpointPublicAccess: this.endpointAccess._config.publicAccess, publicAccessCidrs: this.endpointAccess._config.publicCidrs, secretsEncryptionKey: props.secretsEncryptionKey, vpc: this.vpc, subnets: placeClusterHandlerInVpc ? privateSubnets : void 0, clusterHandlerSecurityGroup: this.clusterHandlerSecurityGroup, onEventLayer: this.onEventLayer, tags: props.tags, logging: this.logging });
        if (this.endpointAccess._config.privateAccess && privateSubnets.length !== 0) {
          if (this.vpc instanceof ec2.Vpc && !(this.vpc.dnsHostnamesEnabled && this.vpc.dnsSupportEnabled))
            throw new Error("Private endpoint access requires the VPC to have DNS support and DNS hostnames enabled. Use `enableDnsHostnames: true` and `enableDnsSupport: true` when creating the VPC.");
          this.kubectlPrivateSubnets = privateSubnets, this._clusterResource.node.addDependency(this.vpc);
        }
        this.adminRole = resource.adminRole, this._kubectlReadyBarrier = new core_1.CfnResource(this, "KubectlReadyBarrier", { type: "AWS::SSM::Parameter", properties: { Type: "String", Value: "aws:cdk:eks:kubectl-ready" } }), this._kubectlReadyBarrier.node.addDependency(this._clusterResource), this.clusterName = this.getResourceNameAttribute(resource.ref), this.clusterArn = this.getResourceArnAttribute(resource.attrArn, (0, cluster_resource_1.clusterArnComponents)(this.physicalName)), this.clusterEndpoint = resource.attrEndpoint, this.clusterCertificateAuthorityData = resource.attrCertificateAuthorityData, this.clusterSecurityGroupId = resource.attrClusterSecurityGroupId, this.clusterEncryptionConfigKeyArn = resource.attrEncryptionConfigKeyArn, this.clusterSecurityGroup = ec2.SecurityGroup.fromSecurityGroupId(this, "ClusterSecurityGroup", this.clusterSecurityGroupId), this.connections = new ec2.Connections({ securityGroups: [this.clusterSecurityGroup, securityGroup], defaultPort: ec2.Port.tcp(443) }), this.kubectlSecurityGroup = this.clusterSecurityGroup, this.adminRole.assumeRolePolicy?.addStatements(new iam.PolicyStatement({ actions: ["sts:AssumeRole"], principals: [this.kubectlLambdaRole] })), this.kubectlRole = this.adminRole, this._kubectlResourceProvider = this.defineKubectlProvider();
        const updateConfigCommandPrefix = `aws eks update-kubeconfig --name ${this.clusterName}`, getTokenCommandPrefix = `aws eks get-token --cluster-name ${this.clusterName}`, commonCommandOptions = [`--region ${stack.region}`];
        if (props.outputClusterName && new core_1.CfnOutput(this, "ClusterName", { value: this.clusterName }), props.mastersRole) {
          const mastersRole = props.mastersRole;
          this.awsAuth.addMastersRole(mastersRole), props.outputMastersRoleArn && new core_1.CfnOutput(this, "MastersRoleArn", { value: mastersRole.roleArn }), commonCommandOptions.push(`--role-arn ${mastersRole.roleArn}`);
        }
        props.albController && (this.albController = alb_controller_1.AlbController.create(this, { ...props.albController, cluster: this }));
        const minCapacity = props.defaultCapacity ?? DEFAULT_CAPACITY_COUNT;
        if (minCapacity > 0) {
          const instanceType = props.defaultCapacityInstance || DEFAULT_CAPACITY_TYPE;
          this.defaultCapacity = props.defaultCapacityType === DefaultCapacityType.EC2 ? this.addAutoScalingGroupCapacity("DefaultCapacity", { instanceType, minCapacity }) : void 0, this.defaultNodegroup = props.defaultCapacityType !== DefaultCapacityType.EC2 ? this.addNodegroupCapacity("DefaultCapacity", { instanceTypes: [instanceType], minSize: minCapacity }) : void 0;
        }
        if ((props.outputConfigCommand ?? true) && props.mastersRole) {
          const postfix = commonCommandOptions.join(" ");
          new core_1.CfnOutput(this, "ConfigCommand", { value: `${updateConfigCommandPrefix} ${postfix}` }), new core_1.CfnOutput(this, "GetTokenCommand", { value: `${getTokenCommandPrefix} ${postfix}` });
        }
        this.defineCoreDnsComputeType(props.coreDnsComputeType ?? CoreDnsComputeType.EC2);
      }
      getServiceLoadBalancerAddress(serviceName, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eks_ServiceLoadBalancerAddressOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.getServiceLoadBalancerAddress), error;
        }
        return new k8s_object_value_1.KubernetesObjectValue(this, `${serviceName}LoadBalancerAddress`, { cluster: this, objectType: "service", objectName: serviceName, objectNamespace: options.namespace, jsonPath: ".status.loadBalancer.ingress[0].hostname", timeout: options.timeout }).value;
      }
      getIngressLoadBalancerAddress(ingressName, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eks_IngressLoadBalancerAddressOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.getIngressLoadBalancerAddress), error;
        }
        return new k8s_object_value_1.KubernetesObjectValue(this, `${ingressName}LoadBalancerAddress`, { cluster: this, objectType: "ingress", objectName: ingressName, objectNamespace: options.namespace, jsonPath: ".status.loadBalancer.ingress[0].hostname", timeout: options.timeout }).value;
      }
      addAutoScalingGroupCapacity(id, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eks_AutoScalingGroupCapacityOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addAutoScalingGroupCapacity), error;
        }
        if (options.machineImageType === MachineImageType.BOTTLEROCKET && options.bootstrapOptions !== void 0)
          throw new Error("bootstrapOptions is not supported for Bottlerocket");
        const asg = new autoscaling.AutoScalingGroup(this, id, { ...options, vpc: this.vpc, machineImage: options.machineImageType === MachineImageType.BOTTLEROCKET ? new bottlerocket_1.BottleRocketImage({ kubernetesVersion: this.version.version }) : new EksOptimizedImage({ nodeType: nodeTypeForInstanceType(options.instanceType), cpuArch: cpuArchForInstanceType(options.instanceType), kubernetesVersion: this.version.version }) });
        return this.connectAutoScalingGroupCapacity(asg, { mapRole: options.mapRole, bootstrapOptions: options.bootstrapOptions, bootstrapEnabled: options.bootstrapEnabled, machineImageType: options.machineImageType, spotInterruptHandler: options.spotInterruptHandler }), nodeTypeForInstanceType(options.instanceType) === NodeType.INFERENTIA && this.addNeuronDevicePlugin(), asg;
      }
      addNodegroupCapacity(id, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eks_NodegroupOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addNodegroupCapacity), error;
        }
        return new managed_nodegroup_1.Nodegroup(this, `Nodegroup${id}`, { cluster: this, ...options });
      }
      get awsAuth() {
        return this._awsAuth || (this._awsAuth = new aws_auth_1.AwsAuth(this, "AwsAuth", { cluster: this })), this._awsAuth;
      }
      get clusterOpenIdConnectIssuerUrl() {
        return this._clusterResource.attrOpenIdConnectIssuerUrl;
      }
      get clusterOpenIdConnectIssuer() {
        return this._clusterResource.attrOpenIdConnectIssuer;
      }
      get openIdConnectProvider() {
        return this._openIdConnectProvider || (this._openIdConnectProvider = new oidc_provider_1.OpenIdConnectProvider(this, "OpenIdConnectProvider", { url: this.clusterOpenIdConnectIssuerUrl })), this._openIdConnectProvider;
      }
      addFargateProfile(id, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eks_FargateProfileOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addFargateProfile), error;
        }
        return new fargate_profile_1.FargateProfile(this, `fargate-profile-${id}`, { ...options, cluster: this });
      }
      _attachFargateProfile(fargateProfile) {
        return this._fargateProfiles.push(fargateProfile), this._kubectlReadyBarrier.node.addDependency(fargateProfile), this._fargateProfiles;
      }
      _attachKubectlResourceScope(resourceScope) {
        return constructs_1.Node.of(resourceScope).addDependency(this._kubectlReadyBarrier), this._kubectlResourceProvider;
      }
      defineKubectlProvider() {
        const uid = "@aws-cdk/aws-eks.KubectlProvider";
        if (this.stack.node.tryFindChild(uid))
          throw new Error("Only a single EKS cluster can be defined within a CloudFormation stack");
        return new kubectl_provider_1.KubectlProvider(this.stack, uid, { cluster: this });
      }
      selectPrivateSubnets() {
        const privateSubnets = [], vpcPrivateSubnetIds = this.vpc.privateSubnets.map((s) => s.subnetId), vpcPublicSubnetIds = this.vpc.publicSubnets.map((s) => s.subnetId);
        for (const placement of this.vpcSubnets)
          for (const subnet of this.vpc.selectSubnets(placement).subnets) {
            if (vpcPrivateSubnetIds.includes(subnet.subnetId)) {
              privateSubnets.push(subnet);
              continue;
            }
            vpcPublicSubnetIds.includes(subnet.subnetId) || privateSubnets.push(subnet);
          }
        return privateSubnets;
      }
      addNeuronDevicePlugin() {
        if (!this._neuronDevicePlugin) {
          const fileContents = fs.readFileSync(path.join(__dirname, "addons/neuron-device-plugin.yaml"), "utf8"), sanitized = YAML.parse(fileContents);
          this._neuronDevicePlugin = this.addManifest("NeuronDevicePlugin", sanitized);
        }
        return this._neuronDevicePlugin;
      }
      tagSubnets() {
        const tagAllSubnets = (type, subnets, tag) => {
          for (const subnet of subnets) {
            if (!ec2.Subnet.isVpcSubnet(subnet)) {
              const subnetID = core_1.Token.isUnresolved(subnet.subnetId) || core_1.Token.isUnresolved([subnet.subnetId]) ? "" : ` ${subnet.subnetId}`;
              core_1.Annotations.of(this).addWarning(`Could not auto-tag ${type} subnet${subnetID} with "${tag}=1", please remember to do this manually`);
              continue;
            }
            core_1.Tags.of(subnet).add(tag, "1");
          }
        };
        tagAllSubnets("private", this.vpc.privateSubnets, "kubernetes.io/role/internal-elb"), tagAllSubnets("public", this.vpc.publicSubnets, "kubernetes.io/role/elb");
      }
      defineCoreDnsComputeType(type) {
        if (type === CoreDnsComputeType.EC2)
          return;
        const renderPatch = (computeType) => ({ spec: { template: { metadata: { annotations: { "eks.amazonaws.com/compute-type": computeType } } } } });
        new k8s_patch_1.KubernetesPatch(this, "CoreDnsComputeTypePatch", { cluster: this, resourceName: "deployment/coredns", resourceNamespace: "kube-system", applyPatch: renderPatch(CoreDnsComputeType.FARGATE), restorePatch: renderPatch(CoreDnsComputeType.EC2) });
      }
    };
    _c = JSII_RTTI_SYMBOL_1, Cluster[_c] = { fqn: "aws-cdk-lib.aws_eks.Cluster", version: "2.80.0" }, exports2.Cluster = Cluster;
    var ImportedCluster = class extends ClusterBase {
      constructor(scope, id, props) {
        super(scope, id), this.props = props, this.connections = new ec2.Connections(), this.clusterName = props.clusterName, this.clusterArn = this.stack.formatArn((0, cluster_resource_1.clusterArnComponents)(props.clusterName)), this.kubectlRole = props.kubectlRoleArn ? iam.Role.fromRoleArn(this, "KubectlRole", props.kubectlRoleArn) : void 0, this.kubectlLambdaRole = props.kubectlLambdaRole, this.kubectlSecurityGroup = props.kubectlSecurityGroupId ? ec2.SecurityGroup.fromSecurityGroupId(this, "KubectlSecurityGroup", props.kubectlSecurityGroupId) : void 0, this.kubectlEnvironment = props.kubectlEnvironment, this.kubectlPrivateSubnets = props.kubectlPrivateSubnetIds ? props.kubectlPrivateSubnetIds.map((subnetid, index) => ec2.Subnet.fromSubnetId(this, `KubectlSubnet${index}`, subnetid)) : void 0, this.kubectlLayer = props.kubectlLayer, this.awscliLayer = props.awscliLayer, this.kubectlMemory = props.kubectlMemory, this.clusterHandlerSecurityGroup = props.clusterHandlerSecurityGroupId ? ec2.SecurityGroup.fromSecurityGroupId(this, "ClusterHandlerSecurityGroup", props.clusterHandlerSecurityGroupId) : void 0, this.kubectlProvider = props.kubectlProvider, this.onEventLayer = props.onEventLayer, this.prune = props.prune ?? true;
        let i = 1;
        for (const sgid of props.securityGroupIds ?? [])
          this.connections.addSecurityGroup(ec2.SecurityGroup.fromSecurityGroupId(this, `SecurityGroup${i}`, sgid)), i++;
        props.clusterSecurityGroupId && (this._clusterSecurityGroup = ec2.SecurityGroup.fromSecurityGroupId(this, "ClusterSecurityGroup", this.clusterSecurityGroupId), this.connections.addSecurityGroup(this._clusterSecurityGroup));
      }
      get vpc() {
        if (!this.props.vpc)
          throw new Error('"vpc" is not defined for this imported cluster');
        return this.props.vpc;
      }
      get clusterSecurityGroup() {
        if (!this._clusterSecurityGroup)
          throw new Error('"clusterSecurityGroup" is not defined for this imported cluster');
        return this._clusterSecurityGroup;
      }
      get clusterSecurityGroupId() {
        if (!this.props.clusterSecurityGroupId)
          throw new Error('"clusterSecurityGroupId" is not defined for this imported cluster');
        return this.props.clusterSecurityGroupId;
      }
      get clusterEndpoint() {
        if (!this.props.clusterEndpoint)
          throw new Error('"clusterEndpoint" is not defined for this imported cluster');
        return this.props.clusterEndpoint;
      }
      get clusterCertificateAuthorityData() {
        if (!this.props.clusterCertificateAuthorityData)
          throw new Error('"clusterCertificateAuthorityData" is not defined for this imported cluster');
        return this.props.clusterCertificateAuthorityData;
      }
      get clusterEncryptionConfigKeyArn() {
        if (!this.props.clusterEncryptionConfigKeyArn)
          throw new Error('"clusterEncryptionConfigKeyArn" is not defined for this imported cluster');
        return this.props.clusterEncryptionConfigKeyArn;
      }
      get openIdConnectProvider() {
        if (!this.props.openIdConnectProvider)
          throw new Error('"openIdConnectProvider" is not defined for this imported cluster');
        return this.props.openIdConnectProvider;
      }
      get awsAuth() {
        throw new Error('"awsAuth" is not supported on imported clusters');
      }
    };
    var EksOptimizedImage = class _EksOptimizedImage {
      constructor(props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eks_EksOptimizedImageProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EksOptimizedImage), error;
        }
        this.nodeType = props.nodeType ?? NodeType.STANDARD, this.cpuArch = props.cpuArch ?? CpuArch.X86_64, this.kubernetesVersion = props.kubernetesVersion ?? LATEST_KUBERNETES_VERSION, this.amiParameterName = `/aws/service/eks/optimized-ami/${this.kubernetesVersion}/` + (this.nodeType === NodeType.STANDARD ? this.cpuArch === CpuArch.X86_64 ? "amazon-linux-2/" : "amazon-linux-2-arm64/" : "") + (this.nodeType === NodeType.GPU ? "amazon-linux-2-gpu/" : "") + (this.nodeType === NodeType.INFERENTIA ? "amazon-linux-2-gpu/" : "") + "recommended/image_id";
      }
      getImage(scope) {
        return { imageId: ssm.StringParameter.valueForStringParameter(scope, this.amiParameterName), osType: ec2.OperatingSystemType.LINUX, userData: ec2.UserData.forLinux() };
      }
    };
    _d = JSII_RTTI_SYMBOL_1, EksOptimizedImage[_d] = { fqn: "aws-cdk-lib.aws_eks.EksOptimizedImage", version: "2.80.0" }, exports2.EksOptimizedImage = EksOptimizedImage;
    var LATEST_KUBERNETES_VERSION = "1.24";
    var NodeType;
    (function(NodeType2) {
      NodeType2.STANDARD = "Standard", NodeType2.GPU = "GPU", NodeType2.INFERENTIA = "INFERENTIA";
    })(NodeType = exports2.NodeType || (exports2.NodeType = {}));
    var CpuArch;
    (function(CpuArch2) {
      CpuArch2.ARM_64 = "arm64", CpuArch2.X86_64 = "x86_64";
    })(CpuArch = exports2.CpuArch || (exports2.CpuArch = {}));
    var CoreDnsComputeType;
    (function(CoreDnsComputeType2) {
      CoreDnsComputeType2.EC2 = "ec2", CoreDnsComputeType2.FARGATE = "fargate";
    })(CoreDnsComputeType = exports2.CoreDnsComputeType || (exports2.CoreDnsComputeType = {}));
    var DefaultCapacityType;
    (function(DefaultCapacityType2) {
      DefaultCapacityType2[DefaultCapacityType2.NODEGROUP = 0] = "NODEGROUP", DefaultCapacityType2[DefaultCapacityType2.EC2 = 1] = "EC2";
    })(DefaultCapacityType = exports2.DefaultCapacityType || (exports2.DefaultCapacityType = {}));
    var MachineImageType;
    (function(MachineImageType2) {
      MachineImageType2[MachineImageType2.AMAZON_LINUX_2 = 0] = "AMAZON_LINUX_2", MachineImageType2[MachineImageType2.BOTTLEROCKET = 1] = "BOTTLEROCKET";
    })(MachineImageType = exports2.MachineImageType || (exports2.MachineImageType = {}));
    function nodeTypeForInstanceType(instanceType) {
      return instance_types_1.INSTANCE_TYPES.gpu.includes(instanceType.toString().substring(0, 2)) ? NodeType.GPU : instance_types_1.INSTANCE_TYPES.inferentia.includes(instanceType.toString().substring(0, 4)) ? NodeType.INFERENTIA : NodeType.STANDARD;
    }
    function cpuArchForInstanceType(instanceType) {
      return instance_types_1.INSTANCE_TYPES.graviton2.includes(instanceType.toString().substring(0, 3)) || instance_types_1.INSTANCE_TYPES.graviton3.includes(instanceType.toString().substring(0, 3)) || instance_types_1.INSTANCE_TYPES.graviton.includes(instanceType.toString().substring(0, 2)) ? CpuArch.ARM_64 : CpuArch.X86_64;
    }
    function flatten(xss) {
      return Array.prototype.concat.call([], ...xss);
    }
  }
});

// node_modules/@aws-cdk/asset-awscli-v1/lib/awscli-asset.js
var require_awscli_asset = __commonJS({
  "node_modules/@aws-cdk/asset-awscli-v1/lib/awscli-asset.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.LAYER_SOURCE_DIR = exports2.ASSET_FILE = void 0;
    var path = require("path");
    exports2.ASSET_FILE = path.join(__dirname, "layer.zip");
    exports2.LAYER_SOURCE_DIR = path.join(__dirname, "..", "layer");
  }
});

// node_modules/@aws-cdk/asset-awscli-v1/lib/index.js
var require_lib112 = __commonJS({
  "node_modules/@aws-cdk/asset-awscli-v1/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m, k);
      if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m[k];
        } };
      }
      Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports3) {
      for (var p in m)
        if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p))
          __createBinding(exports3, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar(require_awscli_asset(), exports2);
  }
});

// node_modules/aws-cdk-lib/lambda-layer-awscli/lib/awscli-layer.js
var require_awscli_layer = __commonJS({
  "node_modules/aws-cdk-lib/lambda-layer-awscli/lib/awscli-layer.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AwsCliLayer = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var asset_awscli_v1_1 = require_lib112();
    var lambda2 = require_aws_lambda();
    var core_1 = require_core2();
    var AwsCliLayer = class extends lambda2.LayerVersion {
      constructor(scope, id) {
        super(scope, id, { code: lambda2.Code.fromAsset(asset_awscli_v1_1.ASSET_FILE, { assetHash: core_1.FileSystem.fingerprint(asset_awscli_v1_1.LAYER_SOURCE_DIR) }), description: "/opt/awscli/aws" });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AwsCliLayer[_a] = { fqn: "aws-cdk-lib.lambda_layer_awscli.AwsCliLayer", version: "2.80.0" }, exports2.AwsCliLayer = AwsCliLayer;
  }
});

// node_modules/aws-cdk-lib/lambda-layer-awscli/lib/index.js
var require_lib113 = __commonJS({
  "node_modules/aws-cdk-lib/lambda-layer-awscli/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_awscli_layer(), exports2);
  }
});

// node_modules/aws-cdk-lib/lambda-layer-awscli/index.js
var require_lambda_layer_awscli = __commonJS({
  "node_modules/aws-cdk-lib/lambda-layer-awscli/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib113(), exports2);
  }
});

// node_modules/@aws-cdk/asset-kubectl-v20/lib/kubectl-asset.js
var require_kubectl_asset = __commonJS({
  "node_modules/@aws-cdk/asset-kubectl-v20/lib/kubectl-asset.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.LAYER_SOURCE_DIR = exports2.LAYER_SOURCE = exports2.ASSET_FILE = void 0;
    var path = require("path");
    exports2.ASSET_FILE = path.join(__dirname, "layer.zip");
    exports2.LAYER_SOURCE = path.join(__dirname, "..", "layer", "Dockerfile");
    exports2.LAYER_SOURCE_DIR = path.join(__dirname, "..", "layer");
  }
});

// node_modules/@aws-cdk/asset-kubectl-v20/lib/index.js
var require_lib114 = __commonJS({
  "node_modules/@aws-cdk/asset-kubectl-v20/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports3) {
      for (var p in m)
        if (p !== "default" && !exports3.hasOwnProperty(p))
          __createBinding(exports3, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar(require_kubectl_asset(), exports2);
  }
});

// node_modules/aws-cdk-lib/lambda-layer-kubectl/lib/kubectl-layer.js
var require_kubectl_layer = __commonJS({
  "node_modules/aws-cdk-lib/lambda-layer-kubectl/lib/kubectl-layer.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.KubectlLayer = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var asset_kubectl_v20_1 = require_lib114();
    var lambda2 = require_aws_lambda();
    var core_1 = require_core2();
    var KubectlLayer = class extends lambda2.LayerVersion {
      constructor(scope, id) {
        super(scope, id, { code: lambda2.Code.fromAsset(asset_kubectl_v20_1.ASSET_FILE, { assetHash: core_1.FileSystem.fingerprint(asset_kubectl_v20_1.LAYER_SOURCE_DIR) }), description: "/opt/kubectl/kubectl and /opt/helm/helm" });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, KubectlLayer[_a] = { fqn: "aws-cdk-lib.lambda_layer_kubectl.KubectlLayer", version: "2.80.0" }, exports2.KubectlLayer = KubectlLayer;
  }
});

// node_modules/aws-cdk-lib/lambda-layer-kubectl/lib/index.js
var require_lib115 = __commonJS({
  "node_modules/aws-cdk-lib/lambda-layer-kubectl/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_kubectl_layer(), exports2);
  }
});

// node_modules/aws-cdk-lib/lambda-layer-kubectl/index.js
var require_lambda_layer_kubectl = __commonJS({
  "node_modules/aws-cdk-lib/lambda-layer-kubectl/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib115(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-eks/lib/kubectl-provider.js
var require_kubectl_provider = __commonJS({
  "node_modules/aws-cdk-lib/aws-eks/lib/kubectl-provider.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.KubectlProvider = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var path = require("path");
    var constructs_1 = require_lib2();
    var cluster_1 = require_cluster4();
    var iam = require_aws_iam();
    var lambda2 = require_aws_lambda();
    var core_1 = require_core2();
    var cr = require_custom_resources();
    var lambda_layer_awscli_1 = require_lambda_layer_awscli();
    var lambda_layer_kubectl_1 = require_lambda_layer_kubectl();
    var KubectlProvider = class _KubectlProvider extends core_1.NestedStack {
      static getOrCreate(scope, cluster) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eks_ICluster(cluster);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.getOrCreate), error;
        }
        if (cluster instanceof cluster_1.Cluster)
          return cluster._attachKubectlResourceScope(scope);
        if (cluster.kubectlProvider)
          return cluster.kubectlProvider;
        const uid = `${core_1.Names.nodeUniqueId(cluster.node)}-KubectlProvider`, stack = core_1.Stack.of(scope);
        let provider = stack.node.tryFindChild(uid);
        return provider || (provider = new _KubectlProvider(stack, uid, { cluster })), provider;
      }
      static fromKubectlProviderAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eks_KubectlProviderAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromKubectlProviderAttributes), error;
        }
        return new ImportedKubectlProvider(scope, id, attrs);
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eks_KubectlProviderProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _KubectlProvider), error;
        }
        const cluster = props.cluster;
        if (!cluster.kubectlRole)
          throw new Error('"kubectlRole" is not defined, cannot issue kubectl commands against this cluster');
        if (cluster.kubectlPrivateSubnets && !cluster.kubectlSecurityGroup)
          throw new Error('"kubectlSecurityGroup" is required if "kubectlSubnets" is specified');
        const memorySize = cluster.kubectlMemory ? cluster.kubectlMemory.toMebibytes() : 1024, handler2 = new lambda2.Function(this, "Handler", { code: lambda2.Code.fromAsset(path.join(__dirname, "kubectl-handler")), runtime: lambda2.Runtime.PYTHON_3_7, handler: "index.handler", timeout: core_1.Duration.minutes(15), description: "onEvent handler for EKS kubectl resource provider", memorySize, environment: cluster.kubectlEnvironment, role: cluster.kubectlLambdaRole ? cluster.kubectlLambdaRole : void 0, vpc: cluster.kubectlPrivateSubnets ? cluster.vpc : void 0, securityGroups: cluster.kubectlSecurityGroup ? [cluster.kubectlSecurityGroup] : void 0, vpcSubnets: cluster.kubectlPrivateSubnets ? { subnets: cluster.kubectlPrivateSubnets } : void 0 });
        handler2.addLayers(props.cluster.awscliLayer ?? new lambda_layer_awscli_1.AwsCliLayer(this, "AwsCliLayer")), handler2.addLayers(props.cluster.kubectlLayer ?? new lambda_layer_kubectl_1.KubectlLayer(this, "KubectlLayer")), this.handlerRole = handler2.role, this.handlerRole.addToPrincipalPolicy(new iam.PolicyStatement({ actions: ["eks:DescribeCluster"], resources: [cluster.clusterArn] })), handler2.isBoundToVpc && handler2.role?.addManagedPolicy(iam.ManagedPolicy.fromAwsManagedPolicyName("service-role/AWSLambdaVPCAccessExecutionRole")), this.handlerRole.addManagedPolicy(iam.ManagedPolicy.fromAwsManagedPolicyName("AmazonEC2ContainerRegistryReadOnly"));
        const hasEcrPublicCondition = new core_1.CfnCondition(this.handlerRole.node.scope, "HasEcrPublic", { expression: core_1.Fn.conditionEquals(core_1.Aws.PARTITION, "aws") }), conditionalPolicy = iam.ManagedPolicy.fromManagedPolicyArn(this, "ConditionalPolicyArn", core_1.Fn.conditionIf(hasEcrPublicCondition.logicalId, iam.ManagedPolicy.fromAwsManagedPolicyName("AmazonElasticContainerRegistryPublicReadOnly").managedPolicyArn, core_1.Aws.NO_VALUE).toString());
        this.handlerRole.addManagedPolicy(iam.ManagedPolicy.fromManagedPolicyArn(this, "conditionalPolicy", conditionalPolicy.managedPolicyArn)), cluster.kubectlRole.grant(this.handlerRole, "sts:AssumeRole");
        const provider = new cr.Provider(this, "Provider", { onEventHandler: handler2, vpc: cluster.kubectlPrivateSubnets ? cluster.vpc : void 0, vpcSubnets: cluster.kubectlPrivateSubnets ? { subnets: cluster.kubectlPrivateSubnets } : void 0, securityGroups: cluster.kubectlSecurityGroup ? [cluster.kubectlSecurityGroup] : void 0 });
        this.serviceToken = provider.serviceToken, this.roleArn = cluster.kubectlRole.roleArn;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, KubectlProvider[_a] = { fqn: "aws-cdk-lib.aws_eks.KubectlProvider", version: "2.80.0" }, exports2.KubectlProvider = KubectlProvider;
    var ImportedKubectlProvider = class extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id), this.serviceToken = props.functionArn, this.roleArn = props.kubectlRoleArn, this.handlerRole = props.handlerRole;
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-eks/lib/helm-chart.js
var require_helm_chart = __commonJS({
  "node_modules/aws-cdk-lib/aws-eks/lib/helm-chart.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.HelmChart = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var kubectl_provider_1 = require_kubectl_provider();
    var core_1 = require_core2();
    var HelmChart = class _HelmChart extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eks_HelmChartProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _HelmChart), error;
        }
        const stack = core_1.Stack.of(this), provider = kubectl_provider_1.KubectlProvider.getOrCreate(this, props.cluster), timeout = props.timeout?.toSeconds();
        if (timeout && timeout > 900)
          throw new Error("Helm chart timeout cannot be higher than 15 minutes.");
        if (!props.chart && !props.chartAsset)
          throw new Error("Either 'chart' or 'chartAsset' must be specified to install a helm chart");
        if (props.chartAsset && (props.repository || props.version))
          throw new Error("Neither 'repository' nor 'version' can be used when configuring 'chartAsset'");
        const wait = props.wait ?? false, createNamespace = props.createNamespace ?? true, skipCrds = props.skipCrds ?? false;
        props.chartAsset?.grantRead(provider.handlerRole), new core_1.CustomResource(this, "Resource", { serviceToken: provider.serviceToken, resourceType: _HelmChart.RESOURCE_TYPE, properties: { ClusterName: props.cluster.clusterName, RoleArn: provider.roleArn, Release: props.release ?? core_1.Names.uniqueId(this).slice(-53).toLowerCase(), Chart: props.chart, ChartAssetURL: props.chartAsset?.s3ObjectUrl, Version: props.version, Wait: wait || void 0, Timeout: timeout ? `${timeout.toString()}s` : void 0, Values: props.values ? stack.toJsonString(props.values) : void 0, Namespace: props.namespace ?? "default", Repository: props.repository, CreateNamespace: createNamespace || void 0, SkipCrds: skipCrds || void 0 } });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, HelmChart[_a] = { fqn: "aws-cdk-lib.aws_eks.HelmChart", version: "2.80.0" }, HelmChart.RESOURCE_TYPE = "Custom::AWSCDK-EKS-HelmChart", exports2.HelmChart = HelmChart;
  }
});

// node_modules/aws-cdk-lib/aws-eks/lib/alb-controller.js
var require_alb_controller = __commonJS({
  "node_modules/aws-cdk-lib/aws-eks/lib/alb-controller.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AlbController = exports2.AlbScheme = exports2.AlbControllerVersion = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var fs = require("fs");
    var path = require("path");
    var constructs_1 = require_lib2();
    var helm_chart_1 = require_helm_chart();
    var service_account_1 = require_service_account();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var AlbControllerVersion = class _AlbControllerVersion {
      static of(version, helmChartVersion = "1.4.1") {
        return new _AlbControllerVersion(version, helmChartVersion, true);
      }
      constructor(version, helmChartVersion, custom) {
        this.version = version, this.helmChartVersion = helmChartVersion, this.custom = custom;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AlbControllerVersion[_a] = { fqn: "aws-cdk-lib.aws_eks.AlbControllerVersion", version: "2.80.0" }, AlbControllerVersion.V2_0_0 = new AlbControllerVersion("v2.0.0", "1.4.1", false), AlbControllerVersion.V2_0_1 = new AlbControllerVersion("v2.0.1", "1.4.1", false), AlbControllerVersion.V2_1_0 = new AlbControllerVersion("v2.1.0", "1.4.1", false), AlbControllerVersion.V2_1_1 = new AlbControllerVersion("v2.1.1", "1.4.1", false), AlbControllerVersion.V2_1_2 = new AlbControllerVersion("v2.1.2", "1.4.1", false), AlbControllerVersion.V2_1_3 = new AlbControllerVersion("v2.1.3", "1.4.1", false), AlbControllerVersion.V2_2_0 = new AlbControllerVersion("v2.2.0", "1.4.1", false), AlbControllerVersion.V2_2_1 = new AlbControllerVersion("v2.2.1", "1.4.1", false), AlbControllerVersion.V2_2_2 = new AlbControllerVersion("v2.2.2", "1.4.1", false), AlbControllerVersion.V2_2_3 = new AlbControllerVersion("v2.2.3", "1.4.1", false), AlbControllerVersion.V2_2_4 = new AlbControllerVersion("v2.2.4", "1.4.1", false), AlbControllerVersion.V2_3_0 = new AlbControllerVersion("v2.3.0", "1.4.1", false), AlbControllerVersion.V2_3_1 = new AlbControllerVersion("v2.3.1", "1.4.1", false), AlbControllerVersion.V2_4_1 = new AlbControllerVersion("v2.4.1", "1.4.1", false), AlbControllerVersion.V2_4_2 = new AlbControllerVersion("v2.4.2", "1.4.3", false), AlbControllerVersion.V2_4_3 = new AlbControllerVersion("v2.4.3", "1.4.4", false), AlbControllerVersion.V2_4_4 = new AlbControllerVersion("v2.4.4", "1.4.5", false), AlbControllerVersion.V2_4_5 = new AlbControllerVersion("v2.4.5", "1.4.6", false), AlbControllerVersion.V2_4_6 = new AlbControllerVersion("v2.4.6", "1.4.7", false), AlbControllerVersion.V2_4_7 = new AlbControllerVersion("v2.4.7", "1.4.8", false), AlbControllerVersion.V2_5_0 = new AlbControllerVersion("v2.5.0", "1.5.0", false), AlbControllerVersion.V2_5_1 = new AlbControllerVersion("v2.5.1", "1.5.2", false), exports2.AlbControllerVersion = AlbControllerVersion;
    var AlbScheme;
    (function(AlbScheme2) {
      AlbScheme2.INTERNAL = "internal", AlbScheme2.INTERNET_FACING = "internet-facing";
    })(AlbScheme = exports2.AlbScheme || (exports2.AlbScheme = {}));
    var AlbController = class _AlbController extends constructs_1.Construct {
      static create(scope, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eks_AlbControllerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.create), error;
        }
        const stack = core_1.Stack.of(scope), uid = _AlbController.uid(props.cluster);
        return new _AlbController(stack, uid, props);
      }
      static uid(cluster) {
        return `${core_1.Names.nodeUniqueId(cluster.node)}-AlbController`;
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eks_AlbControllerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AlbController), error;
        }
        const namespace = "kube-system", serviceAccount = new service_account_1.ServiceAccount(this, "alb-sa", { namespace, name: "aws-load-balancer-controller", cluster: props.cluster });
        if (props.version.custom && !props.policy)
          throw new Error("'albControllerOptions.policy' is required when using a custom controller version");
        const policy = props.policy ?? JSON.parse(fs.readFileSync(path.join(__dirname, "addons", `alb-iam_policy-${props.version.version}.json`), "utf8"));
        for (const statement of policy.Statement)
          serviceAccount.addToPrincipalPolicy(iam.PolicyStatement.fromJson(statement));
        const chart = new helm_chart_1.HelmChart(this, "Resource", { cluster: props.cluster, chart: "aws-load-balancer-controller", repository: "https://aws.github.io/eks-charts", namespace, release: "aws-load-balancer-controller", version: props.version.helmChartVersion, wait: true, timeout: core_1.Duration.minutes(15), values: { clusterName: props.cluster.clusterName, serviceAccount: { create: false, name: serviceAccount.serviceAccountName }, region: core_1.Stack.of(this).region, vpcId: props.cluster.vpc.vpcId, image: { repository: props.repository ?? "602401143452.dkr.ecr.us-west-2.amazonaws.com/amazon/aws-load-balancer-controller", tag: props.version.version } } });
        constructs_1.Node.of(chart).addDependency(serviceAccount), constructs_1.Node.of(chart).addDependency(props.cluster.openIdConnectProvider), constructs_1.Node.of(chart).addDependency(props.cluster.awsAuth);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, AlbController[_b] = { fqn: "aws-cdk-lib.aws_eks.AlbController", version: "2.80.0" }, exports2.AlbController = AlbController;
  }
});

// node_modules/aws-cdk-lib/aws-eks/lib/k8s-manifest.js
var require_k8s_manifest = __commonJS({
  "node_modules/aws-cdk-lib/aws-eks/lib/k8s-manifest.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.KubernetesManifest = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var alb_controller_1 = require_alb_controller();
    var kubectl_provider_1 = require_kubectl_provider();
    var core_1 = require_core2();
    var PRUNE_LABEL_PREFIX = "aws.cdk.eks/prune-";
    var KubernetesManifest = class _KubernetesManifest extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eks_KubernetesManifestProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _KubernetesManifest), error;
        }
        const stack = core_1.Stack.of(this), provider = kubectl_provider_1.KubectlProvider.getOrCreate(this, props.cluster), pruneLabel = props.prune ?? props.cluster.prune ? this.injectPruneLabel(props.manifest) : void 0;
        (props.ingressAlb ?? false) && this.injectIngressAlbAnnotations(props.manifest, props.ingressAlbScheme ?? alb_controller_1.AlbScheme.INTERNAL);
        const customResource = new core_1.CustomResource(this, "Resource", { serviceToken: provider.serviceToken, resourceType: _KubernetesManifest.RESOURCE_TYPE, properties: { Manifest: stack.toJsonString(props.manifest), ClusterName: props.cluster.clusterName, RoleArn: provider.roleArn, PruneLabel: pruneLabel, Overwrite: props.overwrite, SkipValidation: props.skipValidation } });
        this.node.defaultChild = customResource.node.defaultChild;
      }
      injectPruneLabel(manifest) {
        const pruneLabel = PRUNE_LABEL_PREFIX + constructs_1.Node.of(this).addr;
        for (const resource of manifest)
          typeof resource != "object" || !resource.kind || (resource.metadata || (resource.metadata = {}), resource.metadata.labels || (resource.metadata.labels = {}), resource.metadata.labels = { [pruneLabel]: "", ...resource.metadata.labels });
        return pruneLabel;
      }
      injectIngressAlbAnnotations(manifest, scheme) {
        for (const resource of manifest)
          typeof resource != "object" || !resource.kind || resource.kind === "Ingress" && (resource.metadata.annotations = { "kubernetes.io/ingress.class": "alb", "alb.ingress.kubernetes.io/scheme": scheme, ...resource.metadata.annotations });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, KubernetesManifest[_a] = { fqn: "aws-cdk-lib.aws_eks.KubernetesManifest", version: "2.80.0" }, KubernetesManifest.RESOURCE_TYPE = "Custom::AWSCDK-EKS-KubernetesResource", exports2.KubernetesManifest = KubernetesManifest;
  }
});

// node_modules/aws-cdk-lib/aws-eks/lib/aws-auth.js
var require_aws_auth = __commonJS({
  "node_modules/aws-cdk-lib/aws-eks/lib/aws-auth.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AwsAuth = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var k8s_manifest_1 = require_k8s_manifest();
    var core_1 = require_core2();
    var AwsAuth = class _AwsAuth extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id), this.roleMappings = new Array(), this.userMappings = new Array(), this.accounts = new Array();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eks_AwsAuthProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AwsAuth), error;
        }
        this.stack = core_1.Stack.of(this), new k8s_manifest_1.KubernetesManifest(this, "manifest", { cluster: props.cluster, overwrite: true, manifest: [{ apiVersion: "v1", kind: "ConfigMap", metadata: { name: "aws-auth", namespace: "kube-system" }, data: { mapRoles: this.synthesizeMapRoles(), mapUsers: this.synthesizeMapUsers(), mapAccounts: this.synthesizeMapAccounts() } }] });
      }
      addMastersRole(role, username) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IRole(role);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addMastersRole), error;
        }
        this.addRoleMapping(role, { username, groups: ["system:masters"] });
      }
      addRoleMapping(role, mapping) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IRole(role), jsiiDeprecationWarnings.aws_cdk_lib_aws_eks_AwsAuthMapping(mapping);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addRoleMapping), error;
        }
        this.assertSameStack(role), this.roleMappings.push({ role, mapping });
      }
      addUserMapping(user, mapping) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_IUser(user), jsiiDeprecationWarnings.aws_cdk_lib_aws_eks_AwsAuthMapping(mapping);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addUserMapping), error;
        }
        this.assertSameStack(user), this.userMappings.push({ user, mapping });
      }
      addAccount(accountId) {
        this.accounts.push(accountId);
      }
      assertSameStack(construct) {
        const thisStack = core_1.Stack.of(this);
        if (core_1.Stack.of(construct) !== thisStack)
          throw new Error(`${construct.node.path} should be defined in the scope of the ${thisStack.stackName} stack to prevent circular dependencies`);
      }
      synthesizeMapRoles() {
        return core_1.Lazy.any({ produce: () => this.stack.toJsonString(this.roleMappings.map((m) => ({ rolearn: m.role.roleArn, username: m.mapping.username ?? m.role.roleArn, groups: m.mapping.groups }))) });
      }
      synthesizeMapUsers() {
        return core_1.Lazy.any({ produce: () => this.stack.toJsonString(this.userMappings.map((m) => ({ userarn: m.user.userArn, username: m.mapping.username ?? m.user.userArn, groups: m.mapping.groups }))) });
      }
      synthesizeMapAccounts() {
        return core_1.Lazy.any({ produce: () => this.stack.toJsonString(this.accounts) });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AwsAuth[_a] = { fqn: "aws-cdk-lib.aws_eks.AwsAuth", version: "2.80.0" }, exports2.AwsAuth = AwsAuth;
  }
});

// node_modules/aws-cdk-lib/aws-eks/lib/aws-auth-mapping.js
var require_aws_auth_mapping = __commonJS({
  "node_modules/aws-cdk-lib/aws-eks/lib/aws-auth-mapping.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-eks/lib/fargate-cluster.js
var require_fargate_cluster = __commonJS({
  "node_modules/aws-cdk-lib/aws-eks/lib/fargate-cluster.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FargateCluster = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cluster_1 = require_cluster4();
    var FargateCluster = class _FargateCluster extends cluster_1.Cluster {
      constructor(scope, id, props) {
        super(scope, id, { ...props, defaultCapacity: 0, coreDnsComputeType: props.coreDnsComputeType ?? cluster_1.CoreDnsComputeType.FARGATE, version: props.version });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eks_FargateClusterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _FargateCluster), error;
        }
        this.defaultProfile = this.addFargateProfile(props.defaultProfile?.fargateProfileName ?? (props.defaultProfile ? "custom" : "default"), props.defaultProfile ?? { selectors: [{ namespace: "default" }, { namespace: "kube-system" }] });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, FargateCluster[_a] = { fqn: "aws-cdk-lib.aws_eks.FargateCluster", version: "2.80.0" }, exports2.FargateCluster = FargateCluster;
  }
});

// node_modules/aws-cdk-lib/aws-eks/lib/index.js
var require_lib116 = __commonJS({
  "node_modules/aws-cdk-lib/aws-eks/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_aws_auth(), exports2), __exportStar(require_aws_auth_mapping(), exports2), __exportStar(require_cluster4(), exports2), __exportStar(require_eks_generated(), exports2), __exportStar(require_fargate_profile(), exports2), __exportStar(require_helm_chart(), exports2), __exportStar(require_k8s_patch(), exports2), __exportStar(require_k8s_manifest(), exports2), __exportStar(require_k8s_object_value(), exports2), __exportStar(require_kubectl_provider(), exports2), __exportStar(require_fargate_cluster(), exports2), __exportStar(require_service_account(), exports2), __exportStar(require_managed_nodegroup(), exports2), __exportStar(require_oidc_provider2(), exports2), __exportStar(require_alb_controller(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-eks/index.js
var require_aws_eks = __commonJS({
  "node_modules/aws-cdk-lib/aws-eks/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib116(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-elasticache/lib/elasticache.generated.js
var require_elasticache_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticache/lib/elasticache.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnUserGroup = exports2.CfnUser = exports2.CfnSubnetGroup = exports2.CfnSecurityGroupIngress = exports2.CfnSecurityGroup = exports2.CfnReplicationGroup = exports2.CfnParameterGroup = exports2.CfnGlobalReplicationGroup = exports2.CfnCacheCluster = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnCacheClusterPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("azMode", cdk.validateString)(properties.azMode)), errors.collect(cdk.propertyValidator("autoMinorVersionUpgrade", cdk.validateBoolean)(properties.autoMinorVersionUpgrade)), errors.collect(cdk.propertyValidator("cacheNodeType", cdk.requiredValidator)(properties.cacheNodeType)), errors.collect(cdk.propertyValidator("cacheNodeType", cdk.validateString)(properties.cacheNodeType)), errors.collect(cdk.propertyValidator("cacheParameterGroupName", cdk.validateString)(properties.cacheParameterGroupName)), errors.collect(cdk.propertyValidator("cacheSecurityGroupNames", cdk.listValidator(cdk.validateString))(properties.cacheSecurityGroupNames)), errors.collect(cdk.propertyValidator("cacheSubnetGroupName", cdk.validateString)(properties.cacheSubnetGroupName)), errors.collect(cdk.propertyValidator("clusterName", cdk.validateString)(properties.clusterName)), errors.collect(cdk.propertyValidator("engine", cdk.requiredValidator)(properties.engine)), errors.collect(cdk.propertyValidator("engine", cdk.validateString)(properties.engine)), errors.collect(cdk.propertyValidator("engineVersion", cdk.validateString)(properties.engineVersion)), errors.collect(cdk.propertyValidator("ipDiscovery", cdk.validateString)(properties.ipDiscovery)), errors.collect(cdk.propertyValidator("logDeliveryConfigurations", cdk.listValidator(CfnCacheCluster_LogDeliveryConfigurationRequestPropertyValidator))(properties.logDeliveryConfigurations)), errors.collect(cdk.propertyValidator("networkType", cdk.validateString)(properties.networkType)), errors.collect(cdk.propertyValidator("notificationTopicArn", cdk.validateString)(properties.notificationTopicArn)), errors.collect(cdk.propertyValidator("numCacheNodes", cdk.requiredValidator)(properties.numCacheNodes)), errors.collect(cdk.propertyValidator("numCacheNodes", cdk.validateNumber)(properties.numCacheNodes)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("preferredAvailabilityZone", cdk.validateString)(properties.preferredAvailabilityZone)), errors.collect(cdk.propertyValidator("preferredAvailabilityZones", cdk.listValidator(cdk.validateString))(properties.preferredAvailabilityZones)), errors.collect(cdk.propertyValidator("preferredMaintenanceWindow", cdk.validateString)(properties.preferredMaintenanceWindow)), errors.collect(cdk.propertyValidator("snapshotArns", cdk.listValidator(cdk.validateString))(properties.snapshotArns)), errors.collect(cdk.propertyValidator("snapshotName", cdk.validateString)(properties.snapshotName)), errors.collect(cdk.propertyValidator("snapshotRetentionLimit", cdk.validateNumber)(properties.snapshotRetentionLimit)), errors.collect(cdk.propertyValidator("snapshotWindow", cdk.validateString)(properties.snapshotWindow)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("transitEncryptionEnabled", cdk.validateBoolean)(properties.transitEncryptionEnabled)), errors.collect(cdk.propertyValidator("vpcSecurityGroupIds", cdk.listValidator(cdk.validateString))(properties.vpcSecurityGroupIds)), errors.wrap('supplied properties not correct for "CfnCacheClusterProps"');
    }
    function cfnCacheClusterPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCacheClusterPropsValidator(properties).assertSuccess(), { CacheNodeType: cdk.stringToCloudFormation(properties.cacheNodeType), Engine: cdk.stringToCloudFormation(properties.engine), NumCacheNodes: cdk.numberToCloudFormation(properties.numCacheNodes), AutoMinorVersionUpgrade: cdk.booleanToCloudFormation(properties.autoMinorVersionUpgrade), AZMode: cdk.stringToCloudFormation(properties.azMode), CacheParameterGroupName: cdk.stringToCloudFormation(properties.cacheParameterGroupName), CacheSecurityGroupNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.cacheSecurityGroupNames), CacheSubnetGroupName: cdk.stringToCloudFormation(properties.cacheSubnetGroupName), ClusterName: cdk.stringToCloudFormation(properties.clusterName), EngineVersion: cdk.stringToCloudFormation(properties.engineVersion), IpDiscovery: cdk.stringToCloudFormation(properties.ipDiscovery), LogDeliveryConfigurations: cdk.listMapper(cfnCacheClusterLogDeliveryConfigurationRequestPropertyToCloudFormation)(properties.logDeliveryConfigurations), NetworkType: cdk.stringToCloudFormation(properties.networkType), NotificationTopicArn: cdk.stringToCloudFormation(properties.notificationTopicArn), Port: cdk.numberToCloudFormation(properties.port), PreferredAvailabilityZone: cdk.stringToCloudFormation(properties.preferredAvailabilityZone), PreferredAvailabilityZones: cdk.listMapper(cdk.stringToCloudFormation)(properties.preferredAvailabilityZones), PreferredMaintenanceWindow: cdk.stringToCloudFormation(properties.preferredMaintenanceWindow), SnapshotArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.snapshotArns), SnapshotName: cdk.stringToCloudFormation(properties.snapshotName), SnapshotRetentionLimit: cdk.numberToCloudFormation(properties.snapshotRetentionLimit), SnapshotWindow: cdk.stringToCloudFormation(properties.snapshotWindow), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TransitEncryptionEnabled: cdk.booleanToCloudFormation(properties.transitEncryptionEnabled), VpcSecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.vpcSecurityGroupIds) }) : properties;
    }
    function CfnCacheClusterPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cacheNodeType", "CacheNodeType", cfn_parse.FromCloudFormation.getString(properties.CacheNodeType)), ret.addPropertyResult("engine", "Engine", cfn_parse.FromCloudFormation.getString(properties.Engine)), ret.addPropertyResult("numCacheNodes", "NumCacheNodes", cfn_parse.FromCloudFormation.getNumber(properties.NumCacheNodes)), ret.addPropertyResult("autoMinorVersionUpgrade", "AutoMinorVersionUpgrade", properties.AutoMinorVersionUpgrade != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AutoMinorVersionUpgrade) : void 0), ret.addPropertyResult("azMode", "AZMode", properties.AZMode != null ? cfn_parse.FromCloudFormation.getString(properties.AZMode) : void 0), ret.addPropertyResult("cacheParameterGroupName", "CacheParameterGroupName", properties.CacheParameterGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.CacheParameterGroupName) : void 0), ret.addPropertyResult("cacheSecurityGroupNames", "CacheSecurityGroupNames", properties.CacheSecurityGroupNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CacheSecurityGroupNames) : void 0), ret.addPropertyResult("cacheSubnetGroupName", "CacheSubnetGroupName", properties.CacheSubnetGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.CacheSubnetGroupName) : void 0), ret.addPropertyResult("clusterName", "ClusterName", properties.ClusterName != null ? cfn_parse.FromCloudFormation.getString(properties.ClusterName) : void 0), ret.addPropertyResult("engineVersion", "EngineVersion", properties.EngineVersion != null ? cfn_parse.FromCloudFormation.getString(properties.EngineVersion) : void 0), ret.addPropertyResult("ipDiscovery", "IpDiscovery", properties.IpDiscovery != null ? cfn_parse.FromCloudFormation.getString(properties.IpDiscovery) : void 0), ret.addPropertyResult("logDeliveryConfigurations", "LogDeliveryConfigurations", properties.LogDeliveryConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnCacheClusterLogDeliveryConfigurationRequestPropertyFromCloudFormation)(properties.LogDeliveryConfigurations) : void 0), ret.addPropertyResult("networkType", "NetworkType", properties.NetworkType != null ? cfn_parse.FromCloudFormation.getString(properties.NetworkType) : void 0), ret.addPropertyResult("notificationTopicArn", "NotificationTopicArn", properties.NotificationTopicArn != null ? cfn_parse.FromCloudFormation.getString(properties.NotificationTopicArn) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addPropertyResult("preferredAvailabilityZone", "PreferredAvailabilityZone", properties.PreferredAvailabilityZone != null ? cfn_parse.FromCloudFormation.getString(properties.PreferredAvailabilityZone) : void 0), ret.addPropertyResult("preferredAvailabilityZones", "PreferredAvailabilityZones", properties.PreferredAvailabilityZones != null ? cfn_parse.FromCloudFormation.getStringArray(properties.PreferredAvailabilityZones) : void 0), ret.addPropertyResult("preferredMaintenanceWindow", "PreferredMaintenanceWindow", properties.PreferredMaintenanceWindow != null ? cfn_parse.FromCloudFormation.getString(properties.PreferredMaintenanceWindow) : void 0), ret.addPropertyResult("snapshotArns", "SnapshotArns", properties.SnapshotArns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SnapshotArns) : void 0), ret.addPropertyResult("snapshotName", "SnapshotName", properties.SnapshotName != null ? cfn_parse.FromCloudFormation.getString(properties.SnapshotName) : void 0), ret.addPropertyResult("snapshotRetentionLimit", "SnapshotRetentionLimit", properties.SnapshotRetentionLimit != null ? cfn_parse.FromCloudFormation.getNumber(properties.SnapshotRetentionLimit) : void 0), ret.addPropertyResult("snapshotWindow", "SnapshotWindow", properties.SnapshotWindow != null ? cfn_parse.FromCloudFormation.getString(properties.SnapshotWindow) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("transitEncryptionEnabled", "TransitEncryptionEnabled", properties.TransitEncryptionEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.TransitEncryptionEnabled) : void 0), ret.addPropertyResult("vpcSecurityGroupIds", "VpcSecurityGroupIds", properties.VpcSecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.VpcSecurityGroupIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCacheCluster = class _CfnCacheCluster extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCacheClusterPropsFromCloudFormation(resourceProperties), ret = new _CfnCacheCluster(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCacheCluster.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticache_CfnCacheClusterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCacheCluster), error;
        }
        cdk.requireProperty(props, "cacheNodeType", this), cdk.requireProperty(props, "engine", this), cdk.requireProperty(props, "numCacheNodes", this), this.attrConfigurationEndpointAddress = cdk.Token.asString(this.getAtt("ConfigurationEndpoint.Address", cdk.ResolutionTypeHint.STRING)), this.attrConfigurationEndpointPort = cdk.Token.asString(this.getAtt("ConfigurationEndpoint.Port", cdk.ResolutionTypeHint.STRING)), this.attrRedisEndpointAddress = cdk.Token.asString(this.getAtt("RedisEndpoint.Address", cdk.ResolutionTypeHint.STRING)), this.attrRedisEndpointPort = cdk.Token.asString(this.getAtt("RedisEndpoint.Port", cdk.ResolutionTypeHint.STRING)), this.cacheNodeType = props.cacheNodeType, this.engine = props.engine, this.numCacheNodes = props.numCacheNodes, this.autoMinorVersionUpgrade = props.autoMinorVersionUpgrade, this.azMode = props.azMode, this.cacheParameterGroupName = props.cacheParameterGroupName, this.cacheSecurityGroupNames = props.cacheSecurityGroupNames, this.cacheSubnetGroupName = props.cacheSubnetGroupName, this.clusterName = props.clusterName, this.engineVersion = props.engineVersion, this.ipDiscovery = props.ipDiscovery, this.logDeliveryConfigurations = props.logDeliveryConfigurations, this.networkType = props.networkType, this.notificationTopicArn = props.notificationTopicArn, this.port = props.port, this.preferredAvailabilityZone = props.preferredAvailabilityZone, this.preferredAvailabilityZones = props.preferredAvailabilityZones, this.preferredMaintenanceWindow = props.preferredMaintenanceWindow, this.snapshotArns = props.snapshotArns, this.snapshotName = props.snapshotName, this.snapshotRetentionLimit = props.snapshotRetentionLimit, this.snapshotWindow = props.snapshotWindow, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ElastiCache::CacheCluster", props.tags, { tagPropertyName: "tags" }), this.transitEncryptionEnabled = props.transitEncryptionEnabled, this.vpcSecurityGroupIds = props.vpcSecurityGroupIds, this.node.scope && cdk.Resource.isResource(this.node.scope) && this.node.addValidation({ validate: () => this.cfnOptions.deletionPolicy === void 0 ? ["'AWS::ElastiCache::CacheCluster' is a stateful resource type, and you must specify a Removal Policy for it. Call 'resource.applyRemovalPolicy()'."] : [] });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCacheCluster.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { cacheNodeType: this.cacheNodeType, engine: this.engine, numCacheNodes: this.numCacheNodes, autoMinorVersionUpgrade: this.autoMinorVersionUpgrade, azMode: this.azMode, cacheParameterGroupName: this.cacheParameterGroupName, cacheSecurityGroupNames: this.cacheSecurityGroupNames, cacheSubnetGroupName: this.cacheSubnetGroupName, clusterName: this.clusterName, engineVersion: this.engineVersion, ipDiscovery: this.ipDiscovery, logDeliveryConfigurations: this.logDeliveryConfigurations, networkType: this.networkType, notificationTopicArn: this.notificationTopicArn, port: this.port, preferredAvailabilityZone: this.preferredAvailabilityZone, preferredAvailabilityZones: this.preferredAvailabilityZones, preferredMaintenanceWindow: this.preferredMaintenanceWindow, snapshotArns: this.snapshotArns, snapshotName: this.snapshotName, snapshotRetentionLimit: this.snapshotRetentionLimit, snapshotWindow: this.snapshotWindow, tags: this.tags.renderTags(), transitEncryptionEnabled: this.transitEncryptionEnabled, vpcSecurityGroupIds: this.vpcSecurityGroupIds };
      }
      renderProperties(props) {
        return cfnCacheClusterPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnCacheCluster[_a] = { fqn: "aws-cdk-lib.aws_elasticache.CfnCacheCluster", version: "2.80.0" }, CfnCacheCluster.CFN_RESOURCE_TYPE_NAME = "AWS::ElastiCache::CacheCluster", exports2.CfnCacheCluster = CfnCacheCluster;
    function CfnCacheCluster_CloudWatchLogsDestinationDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logGroup", cdk.requiredValidator)(properties.logGroup)), errors.collect(cdk.propertyValidator("logGroup", cdk.validateString)(properties.logGroup)), errors.wrap('supplied properties not correct for "CloudWatchLogsDestinationDetailsProperty"');
    }
    function cfnCacheClusterCloudWatchLogsDestinationDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCacheCluster_CloudWatchLogsDestinationDetailsPropertyValidator(properties).assertSuccess(), { LogGroup: cdk.stringToCloudFormation(properties.logGroup) }) : properties;
    }
    function CfnCacheClusterCloudWatchLogsDestinationDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logGroup", "LogGroup", cfn_parse.FromCloudFormation.getString(properties.LogGroup)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCacheCluster_DestinationDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchLogsDetails", CfnCacheCluster_CloudWatchLogsDestinationDetailsPropertyValidator)(properties.cloudWatchLogsDetails)), errors.collect(cdk.propertyValidator("kinesisFirehoseDetails", CfnCacheCluster_KinesisFirehoseDestinationDetailsPropertyValidator)(properties.kinesisFirehoseDetails)), errors.wrap('supplied properties not correct for "DestinationDetailsProperty"');
    }
    function cfnCacheClusterDestinationDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCacheCluster_DestinationDetailsPropertyValidator(properties).assertSuccess(), { CloudWatchLogsDetails: cfnCacheClusterCloudWatchLogsDestinationDetailsPropertyToCloudFormation(properties.cloudWatchLogsDetails), KinesisFirehoseDetails: cfnCacheClusterKinesisFirehoseDestinationDetailsPropertyToCloudFormation(properties.kinesisFirehoseDetails) }) : properties;
    }
    function CfnCacheClusterDestinationDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchLogsDetails", "CloudWatchLogsDetails", properties.CloudWatchLogsDetails != null ? CfnCacheClusterCloudWatchLogsDestinationDetailsPropertyFromCloudFormation(properties.CloudWatchLogsDetails) : void 0), ret.addPropertyResult("kinesisFirehoseDetails", "KinesisFirehoseDetails", properties.KinesisFirehoseDetails != null ? CfnCacheClusterKinesisFirehoseDestinationDetailsPropertyFromCloudFormation(properties.KinesisFirehoseDetails) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCacheCluster_KinesisFirehoseDestinationDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deliveryStream", cdk.requiredValidator)(properties.deliveryStream)), errors.collect(cdk.propertyValidator("deliveryStream", cdk.validateString)(properties.deliveryStream)), errors.wrap('supplied properties not correct for "KinesisFirehoseDestinationDetailsProperty"');
    }
    function cfnCacheClusterKinesisFirehoseDestinationDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCacheCluster_KinesisFirehoseDestinationDetailsPropertyValidator(properties).assertSuccess(), { DeliveryStream: cdk.stringToCloudFormation(properties.deliveryStream) }) : properties;
    }
    function CfnCacheClusterKinesisFirehoseDestinationDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deliveryStream", "DeliveryStream", cfn_parse.FromCloudFormation.getString(properties.DeliveryStream)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCacheCluster_LogDeliveryConfigurationRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationDetails", cdk.requiredValidator)(properties.destinationDetails)), errors.collect(cdk.propertyValidator("destinationDetails", CfnCacheCluster_DestinationDetailsPropertyValidator)(properties.destinationDetails)), errors.collect(cdk.propertyValidator("destinationType", cdk.requiredValidator)(properties.destinationType)), errors.collect(cdk.propertyValidator("destinationType", cdk.validateString)(properties.destinationType)), errors.collect(cdk.propertyValidator("logFormat", cdk.requiredValidator)(properties.logFormat)), errors.collect(cdk.propertyValidator("logFormat", cdk.validateString)(properties.logFormat)), errors.collect(cdk.propertyValidator("logType", cdk.requiredValidator)(properties.logType)), errors.collect(cdk.propertyValidator("logType", cdk.validateString)(properties.logType)), errors.wrap('supplied properties not correct for "LogDeliveryConfigurationRequestProperty"');
    }
    function cfnCacheClusterLogDeliveryConfigurationRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCacheCluster_LogDeliveryConfigurationRequestPropertyValidator(properties).assertSuccess(), { DestinationDetails: cfnCacheClusterDestinationDetailsPropertyToCloudFormation(properties.destinationDetails), DestinationType: cdk.stringToCloudFormation(properties.destinationType), LogFormat: cdk.stringToCloudFormation(properties.logFormat), LogType: cdk.stringToCloudFormation(properties.logType) }) : properties;
    }
    function CfnCacheClusterLogDeliveryConfigurationRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationDetails", "DestinationDetails", CfnCacheClusterDestinationDetailsPropertyFromCloudFormation(properties.DestinationDetails)), ret.addPropertyResult("destinationType", "DestinationType", cfn_parse.FromCloudFormation.getString(properties.DestinationType)), ret.addPropertyResult("logFormat", "LogFormat", cfn_parse.FromCloudFormation.getString(properties.LogFormat)), ret.addPropertyResult("logType", "LogType", cfn_parse.FromCloudFormation.getString(properties.LogType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGlobalReplicationGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("automaticFailoverEnabled", cdk.validateBoolean)(properties.automaticFailoverEnabled)), errors.collect(cdk.propertyValidator("cacheNodeType", cdk.validateString)(properties.cacheNodeType)), errors.collect(cdk.propertyValidator("cacheParameterGroupName", cdk.validateString)(properties.cacheParameterGroupName)), errors.collect(cdk.propertyValidator("engineVersion", cdk.validateString)(properties.engineVersion)), errors.collect(cdk.propertyValidator("globalNodeGroupCount", cdk.validateNumber)(properties.globalNodeGroupCount)), errors.collect(cdk.propertyValidator("globalReplicationGroupDescription", cdk.validateString)(properties.globalReplicationGroupDescription)), errors.collect(cdk.propertyValidator("globalReplicationGroupIdSuffix", cdk.validateString)(properties.globalReplicationGroupIdSuffix)), errors.collect(cdk.propertyValidator("members", cdk.requiredValidator)(properties.members)), errors.collect(cdk.propertyValidator("members", cdk.listValidator(CfnGlobalReplicationGroup_GlobalReplicationGroupMemberPropertyValidator))(properties.members)), errors.collect(cdk.propertyValidator("regionalConfigurations", cdk.listValidator(CfnGlobalReplicationGroup_RegionalConfigurationPropertyValidator))(properties.regionalConfigurations)), errors.wrap('supplied properties not correct for "CfnGlobalReplicationGroupProps"');
    }
    function cfnGlobalReplicationGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGlobalReplicationGroupPropsValidator(properties).assertSuccess(), { Members: cdk.listMapper(cfnGlobalReplicationGroupGlobalReplicationGroupMemberPropertyToCloudFormation)(properties.members), AutomaticFailoverEnabled: cdk.booleanToCloudFormation(properties.automaticFailoverEnabled), CacheNodeType: cdk.stringToCloudFormation(properties.cacheNodeType), CacheParameterGroupName: cdk.stringToCloudFormation(properties.cacheParameterGroupName), EngineVersion: cdk.stringToCloudFormation(properties.engineVersion), GlobalNodeGroupCount: cdk.numberToCloudFormation(properties.globalNodeGroupCount), GlobalReplicationGroupDescription: cdk.stringToCloudFormation(properties.globalReplicationGroupDescription), GlobalReplicationGroupIdSuffix: cdk.stringToCloudFormation(properties.globalReplicationGroupIdSuffix), RegionalConfigurations: cdk.listMapper(cfnGlobalReplicationGroupRegionalConfigurationPropertyToCloudFormation)(properties.regionalConfigurations) }) : properties;
    }
    function CfnGlobalReplicationGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("members", "Members", cfn_parse.FromCloudFormation.getArray(CfnGlobalReplicationGroupGlobalReplicationGroupMemberPropertyFromCloudFormation)(properties.Members)), ret.addPropertyResult("automaticFailoverEnabled", "AutomaticFailoverEnabled", properties.AutomaticFailoverEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AutomaticFailoverEnabled) : void 0), ret.addPropertyResult("cacheNodeType", "CacheNodeType", properties.CacheNodeType != null ? cfn_parse.FromCloudFormation.getString(properties.CacheNodeType) : void 0), ret.addPropertyResult("cacheParameterGroupName", "CacheParameterGroupName", properties.CacheParameterGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.CacheParameterGroupName) : void 0), ret.addPropertyResult("engineVersion", "EngineVersion", properties.EngineVersion != null ? cfn_parse.FromCloudFormation.getString(properties.EngineVersion) : void 0), ret.addPropertyResult("globalNodeGroupCount", "GlobalNodeGroupCount", properties.GlobalNodeGroupCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.GlobalNodeGroupCount) : void 0), ret.addPropertyResult("globalReplicationGroupDescription", "GlobalReplicationGroupDescription", properties.GlobalReplicationGroupDescription != null ? cfn_parse.FromCloudFormation.getString(properties.GlobalReplicationGroupDescription) : void 0), ret.addPropertyResult("globalReplicationGroupIdSuffix", "GlobalReplicationGroupIdSuffix", properties.GlobalReplicationGroupIdSuffix != null ? cfn_parse.FromCloudFormation.getString(properties.GlobalReplicationGroupIdSuffix) : void 0), ret.addPropertyResult("regionalConfigurations", "RegionalConfigurations", properties.RegionalConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnGlobalReplicationGroupRegionalConfigurationPropertyFromCloudFormation)(properties.RegionalConfigurations) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnGlobalReplicationGroup = class _CfnGlobalReplicationGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnGlobalReplicationGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnGlobalReplicationGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnGlobalReplicationGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticache_CfnGlobalReplicationGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnGlobalReplicationGroup), error;
        }
        cdk.requireProperty(props, "members", this), this.attrGlobalReplicationGroupId = cdk.Token.asString(this.getAtt("GlobalReplicationGroupId", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.members = props.members, this.automaticFailoverEnabled = props.automaticFailoverEnabled, this.cacheNodeType = props.cacheNodeType, this.cacheParameterGroupName = props.cacheParameterGroupName, this.engineVersion = props.engineVersion, this.globalNodeGroupCount = props.globalNodeGroupCount, this.globalReplicationGroupDescription = props.globalReplicationGroupDescription, this.globalReplicationGroupIdSuffix = props.globalReplicationGroupIdSuffix, this.regionalConfigurations = props.regionalConfigurations;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnGlobalReplicationGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { members: this.members, automaticFailoverEnabled: this.automaticFailoverEnabled, cacheNodeType: this.cacheNodeType, cacheParameterGroupName: this.cacheParameterGroupName, engineVersion: this.engineVersion, globalNodeGroupCount: this.globalNodeGroupCount, globalReplicationGroupDescription: this.globalReplicationGroupDescription, globalReplicationGroupIdSuffix: this.globalReplicationGroupIdSuffix, regionalConfigurations: this.regionalConfigurations };
      }
      renderProperties(props) {
        return cfnGlobalReplicationGroupPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnGlobalReplicationGroup[_b] = { fqn: "aws-cdk-lib.aws_elasticache.CfnGlobalReplicationGroup", version: "2.80.0" }, CfnGlobalReplicationGroup.CFN_RESOURCE_TYPE_NAME = "AWS::ElastiCache::GlobalReplicationGroup", exports2.CfnGlobalReplicationGroup = CfnGlobalReplicationGroup;
    function CfnGlobalReplicationGroup_GlobalReplicationGroupMemberPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("replicationGroupId", cdk.validateString)(properties.replicationGroupId)), errors.collect(cdk.propertyValidator("replicationGroupRegion", cdk.validateString)(properties.replicationGroupRegion)), errors.collect(cdk.propertyValidator("role", cdk.validateString)(properties.role)), errors.wrap('supplied properties not correct for "GlobalReplicationGroupMemberProperty"');
    }
    function cfnGlobalReplicationGroupGlobalReplicationGroupMemberPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGlobalReplicationGroup_GlobalReplicationGroupMemberPropertyValidator(properties).assertSuccess(), { ReplicationGroupId: cdk.stringToCloudFormation(properties.replicationGroupId), ReplicationGroupRegion: cdk.stringToCloudFormation(properties.replicationGroupRegion), Role: cdk.stringToCloudFormation(properties.role) }) : properties;
    }
    function CfnGlobalReplicationGroupGlobalReplicationGroupMemberPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("replicationGroupId", "ReplicationGroupId", properties.ReplicationGroupId != null ? cfn_parse.FromCloudFormation.getString(properties.ReplicationGroupId) : void 0), ret.addPropertyResult("replicationGroupRegion", "ReplicationGroupRegion", properties.ReplicationGroupRegion != null ? cfn_parse.FromCloudFormation.getString(properties.ReplicationGroupRegion) : void 0), ret.addPropertyResult("role", "Role", properties.Role != null ? cfn_parse.FromCloudFormation.getString(properties.Role) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGlobalReplicationGroup_RegionalConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("replicationGroupId", cdk.validateString)(properties.replicationGroupId)), errors.collect(cdk.propertyValidator("replicationGroupRegion", cdk.validateString)(properties.replicationGroupRegion)), errors.collect(cdk.propertyValidator("reshardingConfigurations", cdk.listValidator(CfnGlobalReplicationGroup_ReshardingConfigurationPropertyValidator))(properties.reshardingConfigurations)), errors.wrap('supplied properties not correct for "RegionalConfigurationProperty"');
    }
    function cfnGlobalReplicationGroupRegionalConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGlobalReplicationGroup_RegionalConfigurationPropertyValidator(properties).assertSuccess(), { ReplicationGroupId: cdk.stringToCloudFormation(properties.replicationGroupId), ReplicationGroupRegion: cdk.stringToCloudFormation(properties.replicationGroupRegion), ReshardingConfigurations: cdk.listMapper(cfnGlobalReplicationGroupReshardingConfigurationPropertyToCloudFormation)(properties.reshardingConfigurations) }) : properties;
    }
    function CfnGlobalReplicationGroupRegionalConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("replicationGroupId", "ReplicationGroupId", properties.ReplicationGroupId != null ? cfn_parse.FromCloudFormation.getString(properties.ReplicationGroupId) : void 0), ret.addPropertyResult("replicationGroupRegion", "ReplicationGroupRegion", properties.ReplicationGroupRegion != null ? cfn_parse.FromCloudFormation.getString(properties.ReplicationGroupRegion) : void 0), ret.addPropertyResult("reshardingConfigurations", "ReshardingConfigurations", properties.ReshardingConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnGlobalReplicationGroupReshardingConfigurationPropertyFromCloudFormation)(properties.ReshardingConfigurations) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGlobalReplicationGroup_ReshardingConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("nodeGroupId", cdk.validateString)(properties.nodeGroupId)), errors.collect(cdk.propertyValidator("preferredAvailabilityZones", cdk.listValidator(cdk.validateString))(properties.preferredAvailabilityZones)), errors.wrap('supplied properties not correct for "ReshardingConfigurationProperty"');
    }
    function cfnGlobalReplicationGroupReshardingConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGlobalReplicationGroup_ReshardingConfigurationPropertyValidator(properties).assertSuccess(), { NodeGroupId: cdk.stringToCloudFormation(properties.nodeGroupId), PreferredAvailabilityZones: cdk.listMapper(cdk.stringToCloudFormation)(properties.preferredAvailabilityZones) }) : properties;
    }
    function CfnGlobalReplicationGroupReshardingConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("nodeGroupId", "NodeGroupId", properties.NodeGroupId != null ? cfn_parse.FromCloudFormation.getString(properties.NodeGroupId) : void 0), ret.addPropertyResult("preferredAvailabilityZones", "PreferredAvailabilityZones", properties.PreferredAvailabilityZones != null ? cfn_parse.FromCloudFormation.getStringArray(properties.PreferredAvailabilityZones) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnParameterGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cacheParameterGroupFamily", cdk.requiredValidator)(properties.cacheParameterGroupFamily)), errors.collect(cdk.propertyValidator("cacheParameterGroupFamily", cdk.validateString)(properties.cacheParameterGroupFamily)), errors.collect(cdk.propertyValidator("description", cdk.requiredValidator)(properties.description)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("properties", cdk.hashValidator(cdk.validateString))(properties.properties)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnParameterGroupProps"');
    }
    function cfnParameterGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnParameterGroupPropsValidator(properties).assertSuccess(), { CacheParameterGroupFamily: cdk.stringToCloudFormation(properties.cacheParameterGroupFamily), Description: cdk.stringToCloudFormation(properties.description), Properties: cdk.hashMapper(cdk.stringToCloudFormation)(properties.properties), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnParameterGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cacheParameterGroupFamily", "CacheParameterGroupFamily", cfn_parse.FromCloudFormation.getString(properties.CacheParameterGroupFamily)), ret.addPropertyResult("description", "Description", cfn_parse.FromCloudFormation.getString(properties.Description)), ret.addPropertyResult("properties", "Properties", properties.Properties != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Properties) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnParameterGroup = class _CfnParameterGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnParameterGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnParameterGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnParameterGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticache_CfnParameterGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnParameterGroup), error;
        }
        cdk.requireProperty(props, "cacheParameterGroupFamily", this), cdk.requireProperty(props, "description", this), this.cacheParameterGroupFamily = props.cacheParameterGroupFamily, this.description = props.description, this.properties = props.properties, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ElastiCache::ParameterGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnParameterGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { cacheParameterGroupFamily: this.cacheParameterGroupFamily, description: this.description, properties: this.properties, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnParameterGroupPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnParameterGroup[_c] = { fqn: "aws-cdk-lib.aws_elasticache.CfnParameterGroup", version: "2.80.0" }, CfnParameterGroup.CFN_RESOURCE_TYPE_NAME = "AWS::ElastiCache::ParameterGroup", exports2.CfnParameterGroup = CfnParameterGroup;
    function CfnReplicationGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("atRestEncryptionEnabled", cdk.validateBoolean)(properties.atRestEncryptionEnabled)), errors.collect(cdk.propertyValidator("authToken", cdk.validateString)(properties.authToken)), errors.collect(cdk.propertyValidator("autoMinorVersionUpgrade", cdk.validateBoolean)(properties.autoMinorVersionUpgrade)), errors.collect(cdk.propertyValidator("automaticFailoverEnabled", cdk.validateBoolean)(properties.automaticFailoverEnabled)), errors.collect(cdk.propertyValidator("cacheNodeType", cdk.validateString)(properties.cacheNodeType)), errors.collect(cdk.propertyValidator("cacheParameterGroupName", cdk.validateString)(properties.cacheParameterGroupName)), errors.collect(cdk.propertyValidator("cacheSecurityGroupNames", cdk.listValidator(cdk.validateString))(properties.cacheSecurityGroupNames)), errors.collect(cdk.propertyValidator("cacheSubnetGroupName", cdk.validateString)(properties.cacheSubnetGroupName)), errors.collect(cdk.propertyValidator("clusterMode", cdk.validateString)(properties.clusterMode)), errors.collect(cdk.propertyValidator("dataTieringEnabled", cdk.validateBoolean)(properties.dataTieringEnabled)), errors.collect(cdk.propertyValidator("engine", cdk.validateString)(properties.engine)), errors.collect(cdk.propertyValidator("engineVersion", cdk.validateString)(properties.engineVersion)), errors.collect(cdk.propertyValidator("globalReplicationGroupId", cdk.validateString)(properties.globalReplicationGroupId)), errors.collect(cdk.propertyValidator("ipDiscovery", cdk.validateString)(properties.ipDiscovery)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("logDeliveryConfigurations", cdk.listValidator(CfnReplicationGroup_LogDeliveryConfigurationRequestPropertyValidator))(properties.logDeliveryConfigurations)), errors.collect(cdk.propertyValidator("multiAzEnabled", cdk.validateBoolean)(properties.multiAzEnabled)), errors.collect(cdk.propertyValidator("networkType", cdk.validateString)(properties.networkType)), errors.collect(cdk.propertyValidator("nodeGroupConfiguration", cdk.listValidator(CfnReplicationGroup_NodeGroupConfigurationPropertyValidator))(properties.nodeGroupConfiguration)), errors.collect(cdk.propertyValidator("notificationTopicArn", cdk.validateString)(properties.notificationTopicArn)), errors.collect(cdk.propertyValidator("numCacheClusters", cdk.validateNumber)(properties.numCacheClusters)), errors.collect(cdk.propertyValidator("numNodeGroups", cdk.validateNumber)(properties.numNodeGroups)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("preferredCacheClusterAZs", cdk.listValidator(cdk.validateString))(properties.preferredCacheClusterAZs)), errors.collect(cdk.propertyValidator("preferredMaintenanceWindow", cdk.validateString)(properties.preferredMaintenanceWindow)), errors.collect(cdk.propertyValidator("primaryClusterId", cdk.validateString)(properties.primaryClusterId)), errors.collect(cdk.propertyValidator("replicasPerNodeGroup", cdk.validateNumber)(properties.replicasPerNodeGroup)), errors.collect(cdk.propertyValidator("replicationGroupDescription", cdk.requiredValidator)(properties.replicationGroupDescription)), errors.collect(cdk.propertyValidator("replicationGroupDescription", cdk.validateString)(properties.replicationGroupDescription)), errors.collect(cdk.propertyValidator("replicationGroupId", cdk.validateString)(properties.replicationGroupId)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("snapshotArns", cdk.listValidator(cdk.validateString))(properties.snapshotArns)), errors.collect(cdk.propertyValidator("snapshotName", cdk.validateString)(properties.snapshotName)), errors.collect(cdk.propertyValidator("snapshotRetentionLimit", cdk.validateNumber)(properties.snapshotRetentionLimit)), errors.collect(cdk.propertyValidator("snapshotWindow", cdk.validateString)(properties.snapshotWindow)), errors.collect(cdk.propertyValidator("snapshottingClusterId", cdk.validateString)(properties.snapshottingClusterId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("transitEncryptionEnabled", cdk.validateBoolean)(properties.transitEncryptionEnabled)), errors.collect(cdk.propertyValidator("transitEncryptionMode", cdk.validateString)(properties.transitEncryptionMode)), errors.collect(cdk.propertyValidator("userGroupIds", cdk.listValidator(cdk.validateString))(properties.userGroupIds)), errors.wrap('supplied properties not correct for "CfnReplicationGroupProps"');
    }
    function cfnReplicationGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReplicationGroupPropsValidator(properties).assertSuccess(), { ReplicationGroupDescription: cdk.stringToCloudFormation(properties.replicationGroupDescription), AtRestEncryptionEnabled: cdk.booleanToCloudFormation(properties.atRestEncryptionEnabled), AuthToken: cdk.stringToCloudFormation(properties.authToken), AutomaticFailoverEnabled: cdk.booleanToCloudFormation(properties.automaticFailoverEnabled), AutoMinorVersionUpgrade: cdk.booleanToCloudFormation(properties.autoMinorVersionUpgrade), CacheNodeType: cdk.stringToCloudFormation(properties.cacheNodeType), CacheParameterGroupName: cdk.stringToCloudFormation(properties.cacheParameterGroupName), CacheSecurityGroupNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.cacheSecurityGroupNames), CacheSubnetGroupName: cdk.stringToCloudFormation(properties.cacheSubnetGroupName), ClusterMode: cdk.stringToCloudFormation(properties.clusterMode), DataTieringEnabled: cdk.booleanToCloudFormation(properties.dataTieringEnabled), Engine: cdk.stringToCloudFormation(properties.engine), EngineVersion: cdk.stringToCloudFormation(properties.engineVersion), GlobalReplicationGroupId: cdk.stringToCloudFormation(properties.globalReplicationGroupId), IpDiscovery: cdk.stringToCloudFormation(properties.ipDiscovery), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), LogDeliveryConfigurations: cdk.listMapper(cfnReplicationGroupLogDeliveryConfigurationRequestPropertyToCloudFormation)(properties.logDeliveryConfigurations), MultiAZEnabled: cdk.booleanToCloudFormation(properties.multiAzEnabled), NetworkType: cdk.stringToCloudFormation(properties.networkType), NodeGroupConfiguration: cdk.listMapper(cfnReplicationGroupNodeGroupConfigurationPropertyToCloudFormation)(properties.nodeGroupConfiguration), NotificationTopicArn: cdk.stringToCloudFormation(properties.notificationTopicArn), NumCacheClusters: cdk.numberToCloudFormation(properties.numCacheClusters), NumNodeGroups: cdk.numberToCloudFormation(properties.numNodeGroups), Port: cdk.numberToCloudFormation(properties.port), PreferredCacheClusterAZs: cdk.listMapper(cdk.stringToCloudFormation)(properties.preferredCacheClusterAZs), PreferredMaintenanceWindow: cdk.stringToCloudFormation(properties.preferredMaintenanceWindow), PrimaryClusterId: cdk.stringToCloudFormation(properties.primaryClusterId), ReplicasPerNodeGroup: cdk.numberToCloudFormation(properties.replicasPerNodeGroup), ReplicationGroupId: cdk.stringToCloudFormation(properties.replicationGroupId), SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SnapshotArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.snapshotArns), SnapshotName: cdk.stringToCloudFormation(properties.snapshotName), SnapshotRetentionLimit: cdk.numberToCloudFormation(properties.snapshotRetentionLimit), SnapshottingClusterId: cdk.stringToCloudFormation(properties.snapshottingClusterId), SnapshotWindow: cdk.stringToCloudFormation(properties.snapshotWindow), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TransitEncryptionEnabled: cdk.booleanToCloudFormation(properties.transitEncryptionEnabled), TransitEncryptionMode: cdk.stringToCloudFormation(properties.transitEncryptionMode), UserGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.userGroupIds) }) : properties;
    }
    function CfnReplicationGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("replicationGroupDescription", "ReplicationGroupDescription", cfn_parse.FromCloudFormation.getString(properties.ReplicationGroupDescription)), ret.addPropertyResult("atRestEncryptionEnabled", "AtRestEncryptionEnabled", properties.AtRestEncryptionEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AtRestEncryptionEnabled) : void 0), ret.addPropertyResult("authToken", "AuthToken", properties.AuthToken != null ? cfn_parse.FromCloudFormation.getString(properties.AuthToken) : void 0), ret.addPropertyResult("automaticFailoverEnabled", "AutomaticFailoverEnabled", properties.AutomaticFailoverEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AutomaticFailoverEnabled) : void 0), ret.addPropertyResult("autoMinorVersionUpgrade", "AutoMinorVersionUpgrade", properties.AutoMinorVersionUpgrade != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AutoMinorVersionUpgrade) : void 0), ret.addPropertyResult("cacheNodeType", "CacheNodeType", properties.CacheNodeType != null ? cfn_parse.FromCloudFormation.getString(properties.CacheNodeType) : void 0), ret.addPropertyResult("cacheParameterGroupName", "CacheParameterGroupName", properties.CacheParameterGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.CacheParameterGroupName) : void 0), ret.addPropertyResult("cacheSecurityGroupNames", "CacheSecurityGroupNames", properties.CacheSecurityGroupNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CacheSecurityGroupNames) : void 0), ret.addPropertyResult("cacheSubnetGroupName", "CacheSubnetGroupName", properties.CacheSubnetGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.CacheSubnetGroupName) : void 0), ret.addPropertyResult("clusterMode", "ClusterMode", properties.ClusterMode != null ? cfn_parse.FromCloudFormation.getString(properties.ClusterMode) : void 0), ret.addPropertyResult("dataTieringEnabled", "DataTieringEnabled", properties.DataTieringEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DataTieringEnabled) : void 0), ret.addPropertyResult("engine", "Engine", properties.Engine != null ? cfn_parse.FromCloudFormation.getString(properties.Engine) : void 0), ret.addPropertyResult("engineVersion", "EngineVersion", properties.EngineVersion != null ? cfn_parse.FromCloudFormation.getString(properties.EngineVersion) : void 0), ret.addPropertyResult("globalReplicationGroupId", "GlobalReplicationGroupId", properties.GlobalReplicationGroupId != null ? cfn_parse.FromCloudFormation.getString(properties.GlobalReplicationGroupId) : void 0), ret.addPropertyResult("ipDiscovery", "IpDiscovery", properties.IpDiscovery != null ? cfn_parse.FromCloudFormation.getString(properties.IpDiscovery) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("logDeliveryConfigurations", "LogDeliveryConfigurations", properties.LogDeliveryConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnReplicationGroupLogDeliveryConfigurationRequestPropertyFromCloudFormation)(properties.LogDeliveryConfigurations) : void 0), ret.addPropertyResult("multiAzEnabled", "MultiAZEnabled", properties.MultiAZEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.MultiAZEnabled) : void 0), ret.addPropertyResult("networkType", "NetworkType", properties.NetworkType != null ? cfn_parse.FromCloudFormation.getString(properties.NetworkType) : void 0), ret.addPropertyResult("nodeGroupConfiguration", "NodeGroupConfiguration", properties.NodeGroupConfiguration != null ? cfn_parse.FromCloudFormation.getArray(CfnReplicationGroupNodeGroupConfigurationPropertyFromCloudFormation)(properties.NodeGroupConfiguration) : void 0), ret.addPropertyResult("notificationTopicArn", "NotificationTopicArn", properties.NotificationTopicArn != null ? cfn_parse.FromCloudFormation.getString(properties.NotificationTopicArn) : void 0), ret.addPropertyResult("numCacheClusters", "NumCacheClusters", properties.NumCacheClusters != null ? cfn_parse.FromCloudFormation.getNumber(properties.NumCacheClusters) : void 0), ret.addPropertyResult("numNodeGroups", "NumNodeGroups", properties.NumNodeGroups != null ? cfn_parse.FromCloudFormation.getNumber(properties.NumNodeGroups) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addPropertyResult("preferredCacheClusterAZs", "PreferredCacheClusterAZs", properties.PreferredCacheClusterAZs != null ? cfn_parse.FromCloudFormation.getStringArray(properties.PreferredCacheClusterAZs) : void 0), ret.addPropertyResult("preferredMaintenanceWindow", "PreferredMaintenanceWindow", properties.PreferredMaintenanceWindow != null ? cfn_parse.FromCloudFormation.getString(properties.PreferredMaintenanceWindow) : void 0), ret.addPropertyResult("primaryClusterId", "PrimaryClusterId", properties.PrimaryClusterId != null ? cfn_parse.FromCloudFormation.getString(properties.PrimaryClusterId) : void 0), ret.addPropertyResult("replicasPerNodeGroup", "ReplicasPerNodeGroup", properties.ReplicasPerNodeGroup != null ? cfn_parse.FromCloudFormation.getNumber(properties.ReplicasPerNodeGroup) : void 0), ret.addPropertyResult("replicationGroupId", "ReplicationGroupId", properties.ReplicationGroupId != null ? cfn_parse.FromCloudFormation.getString(properties.ReplicationGroupId) : void 0), ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("snapshotArns", "SnapshotArns", properties.SnapshotArns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SnapshotArns) : void 0), ret.addPropertyResult("snapshotName", "SnapshotName", properties.SnapshotName != null ? cfn_parse.FromCloudFormation.getString(properties.SnapshotName) : void 0), ret.addPropertyResult("snapshotRetentionLimit", "SnapshotRetentionLimit", properties.SnapshotRetentionLimit != null ? cfn_parse.FromCloudFormation.getNumber(properties.SnapshotRetentionLimit) : void 0), ret.addPropertyResult("snapshottingClusterId", "SnapshottingClusterId", properties.SnapshottingClusterId != null ? cfn_parse.FromCloudFormation.getString(properties.SnapshottingClusterId) : void 0), ret.addPropertyResult("snapshotWindow", "SnapshotWindow", properties.SnapshotWindow != null ? cfn_parse.FromCloudFormation.getString(properties.SnapshotWindow) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("transitEncryptionEnabled", "TransitEncryptionEnabled", properties.TransitEncryptionEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.TransitEncryptionEnabled) : void 0), ret.addPropertyResult("transitEncryptionMode", "TransitEncryptionMode", properties.TransitEncryptionMode != null ? cfn_parse.FromCloudFormation.getString(properties.TransitEncryptionMode) : void 0), ret.addPropertyResult("userGroupIds", "UserGroupIds", properties.UserGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.UserGroupIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnReplicationGroup = class _CfnReplicationGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnReplicationGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnReplicationGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnReplicationGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticache_CfnReplicationGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnReplicationGroup), error;
        }
        cdk.requireProperty(props, "replicationGroupDescription", this), this.attrConfigurationEndPointAddress = cdk.Token.asString(this.getAtt("ConfigurationEndPoint.Address", cdk.ResolutionTypeHint.STRING)), this.attrConfigurationEndPointPort = cdk.Token.asString(this.getAtt("ConfigurationEndPoint.Port", cdk.ResolutionTypeHint.STRING)), this.attrPrimaryEndPointAddress = cdk.Token.asString(this.getAtt("PrimaryEndPoint.Address", cdk.ResolutionTypeHint.STRING)), this.attrPrimaryEndPointPort = cdk.Token.asString(this.getAtt("PrimaryEndPoint.Port", cdk.ResolutionTypeHint.STRING)), this.attrReadEndPointAddresses = cdk.Token.asString(this.getAtt("ReadEndPoint.Addresses", cdk.ResolutionTypeHint.STRING)), this.attrReadEndPointAddressesList = cdk.Token.asList(this.getAtt("ReadEndPoint.Addresses.List", cdk.ResolutionTypeHint.STRING_LIST)), this.attrReadEndPointPorts = cdk.Token.asString(this.getAtt("ReadEndPoint.Ports", cdk.ResolutionTypeHint.STRING)), this.attrReadEndPointPortsList = cdk.Token.asList(this.getAtt("ReadEndPoint.Ports.List", cdk.ResolutionTypeHint.STRING_LIST)), this.attrReaderEndPointAddress = cdk.Token.asString(this.getAtt("ReaderEndPoint.Address", cdk.ResolutionTypeHint.STRING)), this.attrReaderEndPointPort = cdk.Token.asString(this.getAtt("ReaderEndPoint.Port", cdk.ResolutionTypeHint.STRING)), this.replicationGroupDescription = props.replicationGroupDescription, this.atRestEncryptionEnabled = props.atRestEncryptionEnabled, this.authToken = props.authToken, this.automaticFailoverEnabled = props.automaticFailoverEnabled, this.autoMinorVersionUpgrade = props.autoMinorVersionUpgrade, this.cacheNodeType = props.cacheNodeType, this.cacheParameterGroupName = props.cacheParameterGroupName, this.cacheSecurityGroupNames = props.cacheSecurityGroupNames, this.cacheSubnetGroupName = props.cacheSubnetGroupName, this.clusterMode = props.clusterMode, this.dataTieringEnabled = props.dataTieringEnabled, this.engine = props.engine, this.engineVersion = props.engineVersion, this.globalReplicationGroupId = props.globalReplicationGroupId, this.ipDiscovery = props.ipDiscovery, this.kmsKeyId = props.kmsKeyId, this.logDeliveryConfigurations = props.logDeliveryConfigurations, this.multiAzEnabled = props.multiAzEnabled, this.networkType = props.networkType, this.nodeGroupConfiguration = props.nodeGroupConfiguration, this.notificationTopicArn = props.notificationTopicArn, this.numCacheClusters = props.numCacheClusters, this.numNodeGroups = props.numNodeGroups, this.port = props.port, this.preferredCacheClusterAZs = props.preferredCacheClusterAZs, this.preferredMaintenanceWindow = props.preferredMaintenanceWindow, this.primaryClusterId = props.primaryClusterId, this.replicasPerNodeGroup = props.replicasPerNodeGroup, this.replicationGroupId = props.replicationGroupId, this.securityGroupIds = props.securityGroupIds, this.snapshotArns = props.snapshotArns, this.snapshotName = props.snapshotName, this.snapshotRetentionLimit = props.snapshotRetentionLimit, this.snapshottingClusterId = props.snapshottingClusterId, this.snapshotWindow = props.snapshotWindow, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ElastiCache::ReplicationGroup", props.tags, { tagPropertyName: "tags" }), this.transitEncryptionEnabled = props.transitEncryptionEnabled, this.transitEncryptionMode = props.transitEncryptionMode, this.userGroupIds = props.userGroupIds, this.node.scope && cdk.Resource.isResource(this.node.scope) && this.node.addValidation({ validate: () => this.cfnOptions.deletionPolicy === void 0 ? ["'AWS::ElastiCache::ReplicationGroup' is a stateful resource type, and you must specify a Removal Policy for it. Call 'resource.applyRemovalPolicy()'."] : [] });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnReplicationGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { replicationGroupDescription: this.replicationGroupDescription, atRestEncryptionEnabled: this.atRestEncryptionEnabled, authToken: this.authToken, automaticFailoverEnabled: this.automaticFailoverEnabled, autoMinorVersionUpgrade: this.autoMinorVersionUpgrade, cacheNodeType: this.cacheNodeType, cacheParameterGroupName: this.cacheParameterGroupName, cacheSecurityGroupNames: this.cacheSecurityGroupNames, cacheSubnetGroupName: this.cacheSubnetGroupName, clusterMode: this.clusterMode, dataTieringEnabled: this.dataTieringEnabled, engine: this.engine, engineVersion: this.engineVersion, globalReplicationGroupId: this.globalReplicationGroupId, ipDiscovery: this.ipDiscovery, kmsKeyId: this.kmsKeyId, logDeliveryConfigurations: this.logDeliveryConfigurations, multiAzEnabled: this.multiAzEnabled, networkType: this.networkType, nodeGroupConfiguration: this.nodeGroupConfiguration, notificationTopicArn: this.notificationTopicArn, numCacheClusters: this.numCacheClusters, numNodeGroups: this.numNodeGroups, port: this.port, preferredCacheClusterAZs: this.preferredCacheClusterAZs, preferredMaintenanceWindow: this.preferredMaintenanceWindow, primaryClusterId: this.primaryClusterId, replicasPerNodeGroup: this.replicasPerNodeGroup, replicationGroupId: this.replicationGroupId, securityGroupIds: this.securityGroupIds, snapshotArns: this.snapshotArns, snapshotName: this.snapshotName, snapshotRetentionLimit: this.snapshotRetentionLimit, snapshottingClusterId: this.snapshottingClusterId, snapshotWindow: this.snapshotWindow, tags: this.tags.renderTags(), transitEncryptionEnabled: this.transitEncryptionEnabled, transitEncryptionMode: this.transitEncryptionMode, userGroupIds: this.userGroupIds };
      }
      renderProperties(props) {
        return cfnReplicationGroupPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnReplicationGroup[_d] = { fqn: "aws-cdk-lib.aws_elasticache.CfnReplicationGroup", version: "2.80.0" }, CfnReplicationGroup.CFN_RESOURCE_TYPE_NAME = "AWS::ElastiCache::ReplicationGroup", exports2.CfnReplicationGroup = CfnReplicationGroup;
    function CfnReplicationGroup_CloudWatchLogsDestinationDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logGroup", cdk.requiredValidator)(properties.logGroup)), errors.collect(cdk.propertyValidator("logGroup", cdk.validateString)(properties.logGroup)), errors.wrap('supplied properties not correct for "CloudWatchLogsDestinationDetailsProperty"');
    }
    function cfnReplicationGroupCloudWatchLogsDestinationDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReplicationGroup_CloudWatchLogsDestinationDetailsPropertyValidator(properties).assertSuccess(), { LogGroup: cdk.stringToCloudFormation(properties.logGroup) }) : properties;
    }
    function CfnReplicationGroupCloudWatchLogsDestinationDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logGroup", "LogGroup", cfn_parse.FromCloudFormation.getString(properties.LogGroup)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnReplicationGroup_DestinationDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchLogsDetails", CfnReplicationGroup_CloudWatchLogsDestinationDetailsPropertyValidator)(properties.cloudWatchLogsDetails)), errors.collect(cdk.propertyValidator("kinesisFirehoseDetails", CfnReplicationGroup_KinesisFirehoseDestinationDetailsPropertyValidator)(properties.kinesisFirehoseDetails)), errors.wrap('supplied properties not correct for "DestinationDetailsProperty"');
    }
    function cfnReplicationGroupDestinationDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReplicationGroup_DestinationDetailsPropertyValidator(properties).assertSuccess(), { CloudWatchLogsDetails: cfnReplicationGroupCloudWatchLogsDestinationDetailsPropertyToCloudFormation(properties.cloudWatchLogsDetails), KinesisFirehoseDetails: cfnReplicationGroupKinesisFirehoseDestinationDetailsPropertyToCloudFormation(properties.kinesisFirehoseDetails) }) : properties;
    }
    function CfnReplicationGroupDestinationDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchLogsDetails", "CloudWatchLogsDetails", properties.CloudWatchLogsDetails != null ? CfnReplicationGroupCloudWatchLogsDestinationDetailsPropertyFromCloudFormation(properties.CloudWatchLogsDetails) : void 0), ret.addPropertyResult("kinesisFirehoseDetails", "KinesisFirehoseDetails", properties.KinesisFirehoseDetails != null ? CfnReplicationGroupKinesisFirehoseDestinationDetailsPropertyFromCloudFormation(properties.KinesisFirehoseDetails) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnReplicationGroup_KinesisFirehoseDestinationDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deliveryStream", cdk.requiredValidator)(properties.deliveryStream)), errors.collect(cdk.propertyValidator("deliveryStream", cdk.validateString)(properties.deliveryStream)), errors.wrap('supplied properties not correct for "KinesisFirehoseDestinationDetailsProperty"');
    }
    function cfnReplicationGroupKinesisFirehoseDestinationDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReplicationGroup_KinesisFirehoseDestinationDetailsPropertyValidator(properties).assertSuccess(), { DeliveryStream: cdk.stringToCloudFormation(properties.deliveryStream) }) : properties;
    }
    function CfnReplicationGroupKinesisFirehoseDestinationDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deliveryStream", "DeliveryStream", cfn_parse.FromCloudFormation.getString(properties.DeliveryStream)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnReplicationGroup_LogDeliveryConfigurationRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationDetails", cdk.requiredValidator)(properties.destinationDetails)), errors.collect(cdk.propertyValidator("destinationDetails", CfnReplicationGroup_DestinationDetailsPropertyValidator)(properties.destinationDetails)), errors.collect(cdk.propertyValidator("destinationType", cdk.requiredValidator)(properties.destinationType)), errors.collect(cdk.propertyValidator("destinationType", cdk.validateString)(properties.destinationType)), errors.collect(cdk.propertyValidator("logFormat", cdk.requiredValidator)(properties.logFormat)), errors.collect(cdk.propertyValidator("logFormat", cdk.validateString)(properties.logFormat)), errors.collect(cdk.propertyValidator("logType", cdk.requiredValidator)(properties.logType)), errors.collect(cdk.propertyValidator("logType", cdk.validateString)(properties.logType)), errors.wrap('supplied properties not correct for "LogDeliveryConfigurationRequestProperty"');
    }
    function cfnReplicationGroupLogDeliveryConfigurationRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReplicationGroup_LogDeliveryConfigurationRequestPropertyValidator(properties).assertSuccess(), { DestinationDetails: cfnReplicationGroupDestinationDetailsPropertyToCloudFormation(properties.destinationDetails), DestinationType: cdk.stringToCloudFormation(properties.destinationType), LogFormat: cdk.stringToCloudFormation(properties.logFormat), LogType: cdk.stringToCloudFormation(properties.logType) }) : properties;
    }
    function CfnReplicationGroupLogDeliveryConfigurationRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationDetails", "DestinationDetails", CfnReplicationGroupDestinationDetailsPropertyFromCloudFormation(properties.DestinationDetails)), ret.addPropertyResult("destinationType", "DestinationType", cfn_parse.FromCloudFormation.getString(properties.DestinationType)), ret.addPropertyResult("logFormat", "LogFormat", cfn_parse.FromCloudFormation.getString(properties.LogFormat)), ret.addPropertyResult("logType", "LogType", cfn_parse.FromCloudFormation.getString(properties.LogType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnReplicationGroup_NodeGroupConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("nodeGroupId", cdk.validateString)(properties.nodeGroupId)), errors.collect(cdk.propertyValidator("primaryAvailabilityZone", cdk.validateString)(properties.primaryAvailabilityZone)), errors.collect(cdk.propertyValidator("replicaAvailabilityZones", cdk.listValidator(cdk.validateString))(properties.replicaAvailabilityZones)), errors.collect(cdk.propertyValidator("replicaCount", cdk.validateNumber)(properties.replicaCount)), errors.collect(cdk.propertyValidator("slots", cdk.validateString)(properties.slots)), errors.wrap('supplied properties not correct for "NodeGroupConfigurationProperty"');
    }
    function cfnReplicationGroupNodeGroupConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReplicationGroup_NodeGroupConfigurationPropertyValidator(properties).assertSuccess(), { NodeGroupId: cdk.stringToCloudFormation(properties.nodeGroupId), PrimaryAvailabilityZone: cdk.stringToCloudFormation(properties.primaryAvailabilityZone), ReplicaAvailabilityZones: cdk.listMapper(cdk.stringToCloudFormation)(properties.replicaAvailabilityZones), ReplicaCount: cdk.numberToCloudFormation(properties.replicaCount), Slots: cdk.stringToCloudFormation(properties.slots) }) : properties;
    }
    function CfnReplicationGroupNodeGroupConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("nodeGroupId", "NodeGroupId", properties.NodeGroupId != null ? cfn_parse.FromCloudFormation.getString(properties.NodeGroupId) : void 0), ret.addPropertyResult("primaryAvailabilityZone", "PrimaryAvailabilityZone", properties.PrimaryAvailabilityZone != null ? cfn_parse.FromCloudFormation.getString(properties.PrimaryAvailabilityZone) : void 0), ret.addPropertyResult("replicaAvailabilityZones", "ReplicaAvailabilityZones", properties.ReplicaAvailabilityZones != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ReplicaAvailabilityZones) : void 0), ret.addPropertyResult("replicaCount", "ReplicaCount", properties.ReplicaCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.ReplicaCount) : void 0), ret.addPropertyResult("slots", "Slots", properties.Slots != null ? cfn_parse.FromCloudFormation.getString(properties.Slots) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSecurityGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.requiredValidator)(properties.description)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnSecurityGroupProps"');
    }
    function cfnSecurityGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSecurityGroupPropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnSecurityGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", cfn_parse.FromCloudFormation.getString(properties.Description)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSecurityGroup = class _CfnSecurityGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSecurityGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnSecurityGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSecurityGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticache_CfnSecurityGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSecurityGroup), error;
        }
        cdk.requireProperty(props, "description", this), this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ElastiCache::SecurityGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSecurityGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnSecurityGroupPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnSecurityGroup[_e] = { fqn: "aws-cdk-lib.aws_elasticache.CfnSecurityGroup", version: "2.80.0" }, CfnSecurityGroup.CFN_RESOURCE_TYPE_NAME = "AWS::ElastiCache::SecurityGroup", exports2.CfnSecurityGroup = CfnSecurityGroup;
    function CfnSecurityGroupIngressPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cacheSecurityGroupName", cdk.requiredValidator)(properties.cacheSecurityGroupName)), errors.collect(cdk.propertyValidator("cacheSecurityGroupName", cdk.validateString)(properties.cacheSecurityGroupName)), errors.collect(cdk.propertyValidator("ec2SecurityGroupName", cdk.requiredValidator)(properties.ec2SecurityGroupName)), errors.collect(cdk.propertyValidator("ec2SecurityGroupName", cdk.validateString)(properties.ec2SecurityGroupName)), errors.collect(cdk.propertyValidator("ec2SecurityGroupOwnerId", cdk.validateString)(properties.ec2SecurityGroupOwnerId)), errors.wrap('supplied properties not correct for "CfnSecurityGroupIngressProps"');
    }
    function cfnSecurityGroupIngressPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSecurityGroupIngressPropsValidator(properties).assertSuccess(), { CacheSecurityGroupName: cdk.stringToCloudFormation(properties.cacheSecurityGroupName), EC2SecurityGroupName: cdk.stringToCloudFormation(properties.ec2SecurityGroupName), EC2SecurityGroupOwnerId: cdk.stringToCloudFormation(properties.ec2SecurityGroupOwnerId) }) : properties;
    }
    function CfnSecurityGroupIngressPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cacheSecurityGroupName", "CacheSecurityGroupName", cfn_parse.FromCloudFormation.getString(properties.CacheSecurityGroupName)), ret.addPropertyResult("ec2SecurityGroupName", "EC2SecurityGroupName", cfn_parse.FromCloudFormation.getString(properties.EC2SecurityGroupName)), ret.addPropertyResult("ec2SecurityGroupOwnerId", "EC2SecurityGroupOwnerId", properties.EC2SecurityGroupOwnerId != null ? cfn_parse.FromCloudFormation.getString(properties.EC2SecurityGroupOwnerId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSecurityGroupIngress = class _CfnSecurityGroupIngress extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSecurityGroupIngressPropsFromCloudFormation(resourceProperties), ret = new _CfnSecurityGroupIngress(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSecurityGroupIngress.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticache_CfnSecurityGroupIngressProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSecurityGroupIngress), error;
        }
        cdk.requireProperty(props, "cacheSecurityGroupName", this), cdk.requireProperty(props, "ec2SecurityGroupName", this), this.cacheSecurityGroupName = props.cacheSecurityGroupName, this.ec2SecurityGroupName = props.ec2SecurityGroupName, this.ec2SecurityGroupOwnerId = props.ec2SecurityGroupOwnerId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSecurityGroupIngress.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { cacheSecurityGroupName: this.cacheSecurityGroupName, ec2SecurityGroupName: this.ec2SecurityGroupName, ec2SecurityGroupOwnerId: this.ec2SecurityGroupOwnerId };
      }
      renderProperties(props) {
        return cfnSecurityGroupIngressPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnSecurityGroupIngress[_f] = { fqn: "aws-cdk-lib.aws_elasticache.CfnSecurityGroupIngress", version: "2.80.0" }, CfnSecurityGroupIngress.CFN_RESOURCE_TYPE_NAME = "AWS::ElastiCache::SecurityGroupIngress", exports2.CfnSecurityGroupIngress = CfnSecurityGroupIngress;
    function CfnSubnetGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cacheSubnetGroupName", cdk.validateString)(properties.cacheSubnetGroupName)), errors.collect(cdk.propertyValidator("description", cdk.requiredValidator)(properties.description)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("subnetIds", cdk.requiredValidator)(properties.subnetIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnSubnetGroupProps"');
    }
    function cfnSubnetGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSubnetGroupPropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds), CacheSubnetGroupName: cdk.stringToCloudFormation(properties.cacheSubnetGroupName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnSubnetGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", cfn_parse.FromCloudFormation.getString(properties.Description)), ret.addPropertyResult("subnetIds", "SubnetIds", cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds)), ret.addPropertyResult("cacheSubnetGroupName", "CacheSubnetGroupName", properties.CacheSubnetGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.CacheSubnetGroupName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSubnetGroup = class _CfnSubnetGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSubnetGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnSubnetGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSubnetGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticache_CfnSubnetGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSubnetGroup), error;
        }
        cdk.requireProperty(props, "description", this), cdk.requireProperty(props, "subnetIds", this), this.description = props.description, this.subnetIds = props.subnetIds, this.cacheSubnetGroupName = props.cacheSubnetGroupName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ElastiCache::SubnetGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSubnetGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, subnetIds: this.subnetIds, cacheSubnetGroupName: this.cacheSubnetGroupName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnSubnetGroupPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnSubnetGroup[_g] = { fqn: "aws-cdk-lib.aws_elasticache.CfnSubnetGroup", version: "2.80.0" }, CfnSubnetGroup.CFN_RESOURCE_TYPE_NAME = "AWS::ElastiCache::SubnetGroup", exports2.CfnSubnetGroup = CfnSubnetGroup;
    function CfnUserPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessString", cdk.validateString)(properties.accessString)), errors.collect(cdk.propertyValidator("authenticationMode", cdk.validateObject)(properties.authenticationMode)), errors.collect(cdk.propertyValidator("engine", cdk.requiredValidator)(properties.engine)), errors.collect(cdk.propertyValidator("engine", cdk.validateString)(properties.engine)), errors.collect(cdk.propertyValidator("noPasswordRequired", cdk.validateBoolean)(properties.noPasswordRequired)), errors.collect(cdk.propertyValidator("passwords", cdk.listValidator(cdk.validateString))(properties.passwords)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("userId", cdk.requiredValidator)(properties.userId)), errors.collect(cdk.propertyValidator("userId", cdk.validateString)(properties.userId)), errors.collect(cdk.propertyValidator("userName", cdk.requiredValidator)(properties.userName)), errors.collect(cdk.propertyValidator("userName", cdk.validateString)(properties.userName)), errors.wrap('supplied properties not correct for "CfnUserProps"');
    }
    function cfnUserPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPropsValidator(properties).assertSuccess(), { Engine: cdk.stringToCloudFormation(properties.engine), UserId: cdk.stringToCloudFormation(properties.userId), UserName: cdk.stringToCloudFormation(properties.userName), AccessString: cdk.stringToCloudFormation(properties.accessString), AuthenticationMode: cdk.objectToCloudFormation(properties.authenticationMode), NoPasswordRequired: cdk.booleanToCloudFormation(properties.noPasswordRequired), Passwords: cdk.listMapper(cdk.stringToCloudFormation)(properties.passwords), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnUserPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("engine", "Engine", cfn_parse.FromCloudFormation.getString(properties.Engine)), ret.addPropertyResult("userId", "UserId", cfn_parse.FromCloudFormation.getString(properties.UserId)), ret.addPropertyResult("userName", "UserName", cfn_parse.FromCloudFormation.getString(properties.UserName)), ret.addPropertyResult("accessString", "AccessString", properties.AccessString != null ? cfn_parse.FromCloudFormation.getString(properties.AccessString) : void 0), ret.addPropertyResult("authenticationMode", "AuthenticationMode", properties.AuthenticationMode != null ? cfn_parse.FromCloudFormation.getAny(properties.AuthenticationMode) : void 0), ret.addPropertyResult("noPasswordRequired", "NoPasswordRequired", properties.NoPasswordRequired != null ? cfn_parse.FromCloudFormation.getBoolean(properties.NoPasswordRequired) : void 0), ret.addPropertyResult("passwords", "Passwords", properties.Passwords != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Passwords) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnUser = class _CfnUser extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnUserPropsFromCloudFormation(resourceProperties), ret = new _CfnUser(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnUser.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticache_CfnUserProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnUser), error;
        }
        cdk.requireProperty(props, "engine", this), cdk.requireProperty(props, "userId", this), cdk.requireProperty(props, "userName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.engine = props.engine, this.userId = props.userId, this.userName = props.userName, this.accessString = props.accessString, this.authenticationMode = props.authenticationMode, this.noPasswordRequired = props.noPasswordRequired, this.passwords = props.passwords, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ElastiCache::User", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnUser.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { engine: this.engine, userId: this.userId, userName: this.userName, accessString: this.accessString, authenticationMode: this.authenticationMode, noPasswordRequired: this.noPasswordRequired, passwords: this.passwords, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnUserPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnUser[_h] = { fqn: "aws-cdk-lib.aws_elasticache.CfnUser", version: "2.80.0" }, CfnUser.CFN_RESOURCE_TYPE_NAME = "AWS::ElastiCache::User", exports2.CfnUser = CfnUser;
    function CfnUserGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("engine", cdk.requiredValidator)(properties.engine)), errors.collect(cdk.propertyValidator("engine", cdk.validateString)(properties.engine)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("userGroupId", cdk.requiredValidator)(properties.userGroupId)), errors.collect(cdk.propertyValidator("userGroupId", cdk.validateString)(properties.userGroupId)), errors.collect(cdk.propertyValidator("userIds", cdk.requiredValidator)(properties.userIds)), errors.collect(cdk.propertyValidator("userIds", cdk.listValidator(cdk.validateString))(properties.userIds)), errors.wrap('supplied properties not correct for "CfnUserGroupProps"');
    }
    function cfnUserGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserGroupPropsValidator(properties).assertSuccess(), { Engine: cdk.stringToCloudFormation(properties.engine), UserGroupId: cdk.stringToCloudFormation(properties.userGroupId), UserIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.userIds), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnUserGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("engine", "Engine", cfn_parse.FromCloudFormation.getString(properties.Engine)), ret.addPropertyResult("userGroupId", "UserGroupId", cfn_parse.FromCloudFormation.getString(properties.UserGroupId)), ret.addPropertyResult("userIds", "UserIds", cfn_parse.FromCloudFormation.getStringArray(properties.UserIds)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnUserGroup = class _CfnUserGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnUserGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnUserGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnUserGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticache_CfnUserGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnUserGroup), error;
        }
        cdk.requireProperty(props, "engine", this), cdk.requireProperty(props, "userGroupId", this), cdk.requireProperty(props, "userIds", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.engine = props.engine, this.userGroupId = props.userGroupId, this.userIds = props.userIds, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ElastiCache::UserGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnUserGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { engine: this.engine, userGroupId: this.userGroupId, userIds: this.userIds, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnUserGroupPropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnUserGroup[_j] = { fqn: "aws-cdk-lib.aws_elasticache.CfnUserGroup", version: "2.80.0" }, CfnUserGroup.CFN_RESOURCE_TYPE_NAME = "AWS::ElastiCache::UserGroup", exports2.CfnUserGroup = CfnUserGroup;
  }
});

// node_modules/aws-cdk-lib/aws-elasticache/lib/index.js
var require_lib117 = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticache/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_elasticache_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-elasticache/index.js
var require_aws_elasticache = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticache/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib117(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-elasticbeanstalk/lib/elasticbeanstalk.generated.js
var require_elasticbeanstalk_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticbeanstalk/lib/elasticbeanstalk.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnEnvironment = exports2.CfnConfigurationTemplate = exports2.CfnApplicationVersion = exports2.CfnApplication = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnApplicationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationName", cdk.validateString)(properties.applicationName)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("resourceLifecycleConfig", CfnApplication_ApplicationResourceLifecycleConfigPropertyValidator)(properties.resourceLifecycleConfig)), errors.wrap('supplied properties not correct for "CfnApplicationProps"');
    }
    function cfnApplicationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationPropsValidator(properties).assertSuccess(), { ApplicationName: cdk.stringToCloudFormation(properties.applicationName), Description: cdk.stringToCloudFormation(properties.description), ResourceLifecycleConfig: cfnApplicationApplicationResourceLifecycleConfigPropertyToCloudFormation(properties.resourceLifecycleConfig) }) : properties;
    }
    function CfnApplicationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationName", "ApplicationName", properties.ApplicationName != null ? cfn_parse.FromCloudFormation.getString(properties.ApplicationName) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("resourceLifecycleConfig", "ResourceLifecycleConfig", properties.ResourceLifecycleConfig != null ? CfnApplicationApplicationResourceLifecycleConfigPropertyFromCloudFormation(properties.ResourceLifecycleConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApplication = class _CfnApplication extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApplicationPropsFromCloudFormation(resourceProperties), ret = new _CfnApplication(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnApplication.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticbeanstalk_CfnApplicationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApplication), error;
        }
        this.applicationName = props.applicationName, this.description = props.description, this.resourceLifecycleConfig = props.resourceLifecycleConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApplication.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationName: this.applicationName, description: this.description, resourceLifecycleConfig: this.resourceLifecycleConfig };
      }
      renderProperties(props) {
        return cfnApplicationPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnApplication[_a] = { fqn: "aws-cdk-lib.aws_elasticbeanstalk.CfnApplication", version: "2.80.0" }, CfnApplication.CFN_RESOURCE_TYPE_NAME = "AWS::ElasticBeanstalk::Application", exports2.CfnApplication = CfnApplication;
    function CfnApplication_ApplicationResourceLifecycleConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("serviceRole", cdk.validateString)(properties.serviceRole)), errors.collect(cdk.propertyValidator("versionLifecycleConfig", CfnApplication_ApplicationVersionLifecycleConfigPropertyValidator)(properties.versionLifecycleConfig)), errors.wrap('supplied properties not correct for "ApplicationResourceLifecycleConfigProperty"');
    }
    function cfnApplicationApplicationResourceLifecycleConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_ApplicationResourceLifecycleConfigPropertyValidator(properties).assertSuccess(), { ServiceRole: cdk.stringToCloudFormation(properties.serviceRole), VersionLifecycleConfig: cfnApplicationApplicationVersionLifecycleConfigPropertyToCloudFormation(properties.versionLifecycleConfig) }) : properties;
    }
    function CfnApplicationApplicationResourceLifecycleConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("serviceRole", "ServiceRole", properties.ServiceRole != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceRole) : void 0), ret.addPropertyResult("versionLifecycleConfig", "VersionLifecycleConfig", properties.VersionLifecycleConfig != null ? CfnApplicationApplicationVersionLifecycleConfigPropertyFromCloudFormation(properties.VersionLifecycleConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_ApplicationVersionLifecycleConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxAgeRule", CfnApplication_MaxAgeRulePropertyValidator)(properties.maxAgeRule)), errors.collect(cdk.propertyValidator("maxCountRule", CfnApplication_MaxCountRulePropertyValidator)(properties.maxCountRule)), errors.wrap('supplied properties not correct for "ApplicationVersionLifecycleConfigProperty"');
    }
    function cfnApplicationApplicationVersionLifecycleConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_ApplicationVersionLifecycleConfigPropertyValidator(properties).assertSuccess(), { MaxAgeRule: cfnApplicationMaxAgeRulePropertyToCloudFormation(properties.maxAgeRule), MaxCountRule: cfnApplicationMaxCountRulePropertyToCloudFormation(properties.maxCountRule) }) : properties;
    }
    function CfnApplicationApplicationVersionLifecycleConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxAgeRule", "MaxAgeRule", properties.MaxAgeRule != null ? CfnApplicationMaxAgeRulePropertyFromCloudFormation(properties.MaxAgeRule) : void 0), ret.addPropertyResult("maxCountRule", "MaxCountRule", properties.MaxCountRule != null ? CfnApplicationMaxCountRulePropertyFromCloudFormation(properties.MaxCountRule) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_MaxAgeRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deleteSourceFromS3", cdk.validateBoolean)(properties.deleteSourceFromS3)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("maxAgeInDays", cdk.validateNumber)(properties.maxAgeInDays)), errors.wrap('supplied properties not correct for "MaxAgeRuleProperty"');
    }
    function cfnApplicationMaxAgeRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_MaxAgeRulePropertyValidator(properties).assertSuccess(), { DeleteSourceFromS3: cdk.booleanToCloudFormation(properties.deleteSourceFromS3), Enabled: cdk.booleanToCloudFormation(properties.enabled), MaxAgeInDays: cdk.numberToCloudFormation(properties.maxAgeInDays) }) : properties;
    }
    function CfnApplicationMaxAgeRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deleteSourceFromS3", "DeleteSourceFromS3", properties.DeleteSourceFromS3 != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeleteSourceFromS3) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("maxAgeInDays", "MaxAgeInDays", properties.MaxAgeInDays != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxAgeInDays) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_MaxCountRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deleteSourceFromS3", cdk.validateBoolean)(properties.deleteSourceFromS3)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("maxCount", cdk.validateNumber)(properties.maxCount)), errors.wrap('supplied properties not correct for "MaxCountRuleProperty"');
    }
    function cfnApplicationMaxCountRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_MaxCountRulePropertyValidator(properties).assertSuccess(), { DeleteSourceFromS3: cdk.booleanToCloudFormation(properties.deleteSourceFromS3), Enabled: cdk.booleanToCloudFormation(properties.enabled), MaxCount: cdk.numberToCloudFormation(properties.maxCount) }) : properties;
    }
    function CfnApplicationMaxCountRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deleteSourceFromS3", "DeleteSourceFromS3", properties.DeleteSourceFromS3 != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeleteSourceFromS3) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("maxCount", "MaxCount", properties.MaxCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxCount) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationName", cdk.requiredValidator)(properties.applicationName)), errors.collect(cdk.propertyValidator("applicationName", cdk.validateString)(properties.applicationName)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("sourceBundle", cdk.requiredValidator)(properties.sourceBundle)), errors.collect(cdk.propertyValidator("sourceBundle", CfnApplicationVersion_SourceBundlePropertyValidator)(properties.sourceBundle)), errors.wrap('supplied properties not correct for "CfnApplicationVersionProps"');
    }
    function cfnApplicationVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationVersionPropsValidator(properties).assertSuccess(), { ApplicationName: cdk.stringToCloudFormation(properties.applicationName), SourceBundle: cfnApplicationVersionSourceBundlePropertyToCloudFormation(properties.sourceBundle), Description: cdk.stringToCloudFormation(properties.description) }) : properties;
    }
    function CfnApplicationVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationName", "ApplicationName", cfn_parse.FromCloudFormation.getString(properties.ApplicationName)), ret.addPropertyResult("sourceBundle", "SourceBundle", CfnApplicationVersionSourceBundlePropertyFromCloudFormation(properties.SourceBundle)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApplicationVersion = class _CfnApplicationVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApplicationVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnApplicationVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApplicationVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticbeanstalk_CfnApplicationVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApplicationVersion), error;
        }
        cdk.requireProperty(props, "applicationName", this), cdk.requireProperty(props, "sourceBundle", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.applicationName = props.applicationName, this.sourceBundle = props.sourceBundle, this.description = props.description;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApplicationVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationName: this.applicationName, sourceBundle: this.sourceBundle, description: this.description };
      }
      renderProperties(props) {
        return cfnApplicationVersionPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnApplicationVersion[_b] = { fqn: "aws-cdk-lib.aws_elasticbeanstalk.CfnApplicationVersion", version: "2.80.0" }, CfnApplicationVersion.CFN_RESOURCE_TYPE_NAME = "AWS::ElasticBeanstalk::ApplicationVersion", exports2.CfnApplicationVersion = CfnApplicationVersion;
    function CfnApplicationVersion_SourceBundlePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3Bucket", cdk.requiredValidator)(properties.s3Bucket)), errors.collect(cdk.propertyValidator("s3Bucket", cdk.validateString)(properties.s3Bucket)), errors.collect(cdk.propertyValidator("s3Key", cdk.requiredValidator)(properties.s3Key)), errors.collect(cdk.propertyValidator("s3Key", cdk.validateString)(properties.s3Key)), errors.wrap('supplied properties not correct for "SourceBundleProperty"');
    }
    function cfnApplicationVersionSourceBundlePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationVersion_SourceBundlePropertyValidator(properties).assertSuccess(), { S3Bucket: cdk.stringToCloudFormation(properties.s3Bucket), S3Key: cdk.stringToCloudFormation(properties.s3Key) }) : properties;
    }
    function CfnApplicationVersionSourceBundlePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Bucket", "S3Bucket", cfn_parse.FromCloudFormation.getString(properties.S3Bucket)), ret.addPropertyResult("s3Key", "S3Key", cfn_parse.FromCloudFormation.getString(properties.S3Key)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigurationTemplatePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationName", cdk.requiredValidator)(properties.applicationName)), errors.collect(cdk.propertyValidator("applicationName", cdk.validateString)(properties.applicationName)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("environmentId", cdk.validateString)(properties.environmentId)), errors.collect(cdk.propertyValidator("optionSettings", cdk.listValidator(CfnConfigurationTemplate_ConfigurationOptionSettingPropertyValidator))(properties.optionSettings)), errors.collect(cdk.propertyValidator("platformArn", cdk.validateString)(properties.platformArn)), errors.collect(cdk.propertyValidator("solutionStackName", cdk.validateString)(properties.solutionStackName)), errors.collect(cdk.propertyValidator("sourceConfiguration", CfnConfigurationTemplate_SourceConfigurationPropertyValidator)(properties.sourceConfiguration)), errors.wrap('supplied properties not correct for "CfnConfigurationTemplateProps"');
    }
    function cfnConfigurationTemplatePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationTemplatePropsValidator(properties).assertSuccess(), { ApplicationName: cdk.stringToCloudFormation(properties.applicationName), Description: cdk.stringToCloudFormation(properties.description), EnvironmentId: cdk.stringToCloudFormation(properties.environmentId), OptionSettings: cdk.listMapper(cfnConfigurationTemplateConfigurationOptionSettingPropertyToCloudFormation)(properties.optionSettings), PlatformArn: cdk.stringToCloudFormation(properties.platformArn), SolutionStackName: cdk.stringToCloudFormation(properties.solutionStackName), SourceConfiguration: cfnConfigurationTemplateSourceConfigurationPropertyToCloudFormation(properties.sourceConfiguration) }) : properties;
    }
    function CfnConfigurationTemplatePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationName", "ApplicationName", cfn_parse.FromCloudFormation.getString(properties.ApplicationName)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("environmentId", "EnvironmentId", properties.EnvironmentId != null ? cfn_parse.FromCloudFormation.getString(properties.EnvironmentId) : void 0), ret.addPropertyResult("optionSettings", "OptionSettings", properties.OptionSettings != null ? cfn_parse.FromCloudFormation.getArray(CfnConfigurationTemplateConfigurationOptionSettingPropertyFromCloudFormation)(properties.OptionSettings) : void 0), ret.addPropertyResult("platformArn", "PlatformArn", properties.PlatformArn != null ? cfn_parse.FromCloudFormation.getString(properties.PlatformArn) : void 0), ret.addPropertyResult("solutionStackName", "SolutionStackName", properties.SolutionStackName != null ? cfn_parse.FromCloudFormation.getString(properties.SolutionStackName) : void 0), ret.addPropertyResult("sourceConfiguration", "SourceConfiguration", properties.SourceConfiguration != null ? CfnConfigurationTemplateSourceConfigurationPropertyFromCloudFormation(properties.SourceConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnConfigurationTemplate = class _CfnConfigurationTemplate extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnConfigurationTemplatePropsFromCloudFormation(resourceProperties), ret = new _CfnConfigurationTemplate(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnConfigurationTemplate.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticbeanstalk_CfnConfigurationTemplateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnConfigurationTemplate), error;
        }
        cdk.requireProperty(props, "applicationName", this), this.attrTemplateName = cdk.Token.asString(this.getAtt("TemplateName", cdk.ResolutionTypeHint.STRING)), this.applicationName = props.applicationName, this.description = props.description, this.environmentId = props.environmentId, this.optionSettings = props.optionSettings, this.platformArn = props.platformArn, this.solutionStackName = props.solutionStackName, this.sourceConfiguration = props.sourceConfiguration;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnConfigurationTemplate.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationName: this.applicationName, description: this.description, environmentId: this.environmentId, optionSettings: this.optionSettings, platformArn: this.platformArn, solutionStackName: this.solutionStackName, sourceConfiguration: this.sourceConfiguration };
      }
      renderProperties(props) {
        return cfnConfigurationTemplatePropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnConfigurationTemplate[_c] = { fqn: "aws-cdk-lib.aws_elasticbeanstalk.CfnConfigurationTemplate", version: "2.80.0" }, CfnConfigurationTemplate.CFN_RESOURCE_TYPE_NAME = "AWS::ElasticBeanstalk::ConfigurationTemplate", exports2.CfnConfigurationTemplate = CfnConfigurationTemplate;
    function CfnConfigurationTemplate_ConfigurationOptionSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("namespace", cdk.requiredValidator)(properties.namespace)), errors.collect(cdk.propertyValidator("namespace", cdk.validateString)(properties.namespace)), errors.collect(cdk.propertyValidator("optionName", cdk.requiredValidator)(properties.optionName)), errors.collect(cdk.propertyValidator("optionName", cdk.validateString)(properties.optionName)), errors.collect(cdk.propertyValidator("resourceName", cdk.validateString)(properties.resourceName)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "ConfigurationOptionSettingProperty"');
    }
    function cfnConfigurationTemplateConfigurationOptionSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationTemplate_ConfigurationOptionSettingPropertyValidator(properties).assertSuccess(), { Namespace: cdk.stringToCloudFormation(properties.namespace), OptionName: cdk.stringToCloudFormation(properties.optionName), ResourceName: cdk.stringToCloudFormation(properties.resourceName), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnConfigurationTemplateConfigurationOptionSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("namespace", "Namespace", cfn_parse.FromCloudFormation.getString(properties.Namespace)), ret.addPropertyResult("optionName", "OptionName", cfn_parse.FromCloudFormation.getString(properties.OptionName)), ret.addPropertyResult("resourceName", "ResourceName", properties.ResourceName != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceName) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigurationTemplate_SourceConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationName", cdk.requiredValidator)(properties.applicationName)), errors.collect(cdk.propertyValidator("applicationName", cdk.validateString)(properties.applicationName)), errors.collect(cdk.propertyValidator("templateName", cdk.requiredValidator)(properties.templateName)), errors.collect(cdk.propertyValidator("templateName", cdk.validateString)(properties.templateName)), errors.wrap('supplied properties not correct for "SourceConfigurationProperty"');
    }
    function cfnConfigurationTemplateSourceConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationTemplate_SourceConfigurationPropertyValidator(properties).assertSuccess(), { ApplicationName: cdk.stringToCloudFormation(properties.applicationName), TemplateName: cdk.stringToCloudFormation(properties.templateName) }) : properties;
    }
    function CfnConfigurationTemplateSourceConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationName", "ApplicationName", cfn_parse.FromCloudFormation.getString(properties.ApplicationName)), ret.addPropertyResult("templateName", "TemplateName", cfn_parse.FromCloudFormation.getString(properties.TemplateName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEnvironmentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationName", cdk.requiredValidator)(properties.applicationName)), errors.collect(cdk.propertyValidator("applicationName", cdk.validateString)(properties.applicationName)), errors.collect(cdk.propertyValidator("cnamePrefix", cdk.validateString)(properties.cnamePrefix)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("environmentName", cdk.validateString)(properties.environmentName)), errors.collect(cdk.propertyValidator("operationsRole", cdk.validateString)(properties.operationsRole)), errors.collect(cdk.propertyValidator("optionSettings", cdk.listValidator(CfnEnvironment_OptionSettingPropertyValidator))(properties.optionSettings)), errors.collect(cdk.propertyValidator("platformArn", cdk.validateString)(properties.platformArn)), errors.collect(cdk.propertyValidator("solutionStackName", cdk.validateString)(properties.solutionStackName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("templateName", cdk.validateString)(properties.templateName)), errors.collect(cdk.propertyValidator("tier", CfnEnvironment_TierPropertyValidator)(properties.tier)), errors.collect(cdk.propertyValidator("versionLabel", cdk.validateString)(properties.versionLabel)), errors.wrap('supplied properties not correct for "CfnEnvironmentProps"');
    }
    function cfnEnvironmentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEnvironmentPropsValidator(properties).assertSuccess(), { ApplicationName: cdk.stringToCloudFormation(properties.applicationName), CNAMEPrefix: cdk.stringToCloudFormation(properties.cnamePrefix), Description: cdk.stringToCloudFormation(properties.description), EnvironmentName: cdk.stringToCloudFormation(properties.environmentName), OperationsRole: cdk.stringToCloudFormation(properties.operationsRole), OptionSettings: cdk.listMapper(cfnEnvironmentOptionSettingPropertyToCloudFormation)(properties.optionSettings), PlatformArn: cdk.stringToCloudFormation(properties.platformArn), SolutionStackName: cdk.stringToCloudFormation(properties.solutionStackName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TemplateName: cdk.stringToCloudFormation(properties.templateName), Tier: cfnEnvironmentTierPropertyToCloudFormation(properties.tier), VersionLabel: cdk.stringToCloudFormation(properties.versionLabel) }) : properties;
    }
    function CfnEnvironmentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationName", "ApplicationName", cfn_parse.FromCloudFormation.getString(properties.ApplicationName)), ret.addPropertyResult("cnamePrefix", "CNAMEPrefix", properties.CNAMEPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.CNAMEPrefix) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("environmentName", "EnvironmentName", properties.EnvironmentName != null ? cfn_parse.FromCloudFormation.getString(properties.EnvironmentName) : void 0), ret.addPropertyResult("operationsRole", "OperationsRole", properties.OperationsRole != null ? cfn_parse.FromCloudFormation.getString(properties.OperationsRole) : void 0), ret.addPropertyResult("optionSettings", "OptionSettings", properties.OptionSettings != null ? cfn_parse.FromCloudFormation.getArray(CfnEnvironmentOptionSettingPropertyFromCloudFormation)(properties.OptionSettings) : void 0), ret.addPropertyResult("platformArn", "PlatformArn", properties.PlatformArn != null ? cfn_parse.FromCloudFormation.getString(properties.PlatformArn) : void 0), ret.addPropertyResult("solutionStackName", "SolutionStackName", properties.SolutionStackName != null ? cfn_parse.FromCloudFormation.getString(properties.SolutionStackName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("templateName", "TemplateName", properties.TemplateName != null ? cfn_parse.FromCloudFormation.getString(properties.TemplateName) : void 0), ret.addPropertyResult("tier", "Tier", properties.Tier != null ? CfnEnvironmentTierPropertyFromCloudFormation(properties.Tier) : void 0), ret.addPropertyResult("versionLabel", "VersionLabel", properties.VersionLabel != null ? cfn_parse.FromCloudFormation.getString(properties.VersionLabel) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEnvironment = class _CfnEnvironment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEnvironmentPropsFromCloudFormation(resourceProperties), ret = new _CfnEnvironment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEnvironment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticbeanstalk_CfnEnvironmentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEnvironment), error;
        }
        cdk.requireProperty(props, "applicationName", this), this.attrEndpointUrl = cdk.Token.asString(this.getAtt("EndpointURL", cdk.ResolutionTypeHint.STRING)), this.applicationName = props.applicationName, this.cnamePrefix = props.cnamePrefix, this.description = props.description, this.environmentName = props.environmentName, this.operationsRole = props.operationsRole, this.optionSettings = props.optionSettings, this.platformArn = props.platformArn, this.solutionStackName = props.solutionStackName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ElasticBeanstalk::Environment", props.tags, { tagPropertyName: "tags" }), this.templateName = props.templateName, this.tier = props.tier, this.versionLabel = props.versionLabel;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEnvironment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationName: this.applicationName, cnamePrefix: this.cnamePrefix, description: this.description, environmentName: this.environmentName, operationsRole: this.operationsRole, optionSettings: this.optionSettings, platformArn: this.platformArn, solutionStackName: this.solutionStackName, tags: this.tags.renderTags(), templateName: this.templateName, tier: this.tier, versionLabel: this.versionLabel };
      }
      renderProperties(props) {
        return cfnEnvironmentPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnEnvironment[_d] = { fqn: "aws-cdk-lib.aws_elasticbeanstalk.CfnEnvironment", version: "2.80.0" }, CfnEnvironment.CFN_RESOURCE_TYPE_NAME = "AWS::ElasticBeanstalk::Environment", exports2.CfnEnvironment = CfnEnvironment;
    function CfnEnvironment_OptionSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("namespace", cdk.requiredValidator)(properties.namespace)), errors.collect(cdk.propertyValidator("namespace", cdk.validateString)(properties.namespace)), errors.collect(cdk.propertyValidator("optionName", cdk.requiredValidator)(properties.optionName)), errors.collect(cdk.propertyValidator("optionName", cdk.validateString)(properties.optionName)), errors.collect(cdk.propertyValidator("resourceName", cdk.validateString)(properties.resourceName)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "OptionSettingProperty"');
    }
    function cfnEnvironmentOptionSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEnvironment_OptionSettingPropertyValidator(properties).assertSuccess(), { Namespace: cdk.stringToCloudFormation(properties.namespace), OptionName: cdk.stringToCloudFormation(properties.optionName), ResourceName: cdk.stringToCloudFormation(properties.resourceName), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnEnvironmentOptionSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("namespace", "Namespace", cfn_parse.FromCloudFormation.getString(properties.Namespace)), ret.addPropertyResult("optionName", "OptionName", cfn_parse.FromCloudFormation.getString(properties.OptionName)), ret.addPropertyResult("resourceName", "ResourceName", properties.ResourceName != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceName) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEnvironment_TierPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "TierProperty"');
    }
    function cfnEnvironmentTierPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEnvironment_TierPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Type: cdk.stringToCloudFormation(properties.type), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnEnvironmentTierPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getString(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-elasticbeanstalk/lib/index.js
var require_lib118 = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticbeanstalk/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_elasticbeanstalk_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-elasticbeanstalk/index.js
var require_aws_elasticbeanstalk = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticbeanstalk/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib118(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancing/lib/elasticloadbalancing.generated.js
var require_elasticloadbalancing_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancing/lib/elasticloadbalancing.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnLoadBalancer = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnLoadBalancerPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessLoggingPolicy", CfnLoadBalancer_AccessLoggingPolicyPropertyValidator)(properties.accessLoggingPolicy)), errors.collect(cdk.propertyValidator("appCookieStickinessPolicy", cdk.listValidator(CfnLoadBalancer_AppCookieStickinessPolicyPropertyValidator))(properties.appCookieStickinessPolicy)), errors.collect(cdk.propertyValidator("availabilityZones", cdk.listValidator(cdk.validateString))(properties.availabilityZones)), errors.collect(cdk.propertyValidator("connectionDrainingPolicy", CfnLoadBalancer_ConnectionDrainingPolicyPropertyValidator)(properties.connectionDrainingPolicy)), errors.collect(cdk.propertyValidator("connectionSettings", CfnLoadBalancer_ConnectionSettingsPropertyValidator)(properties.connectionSettings)), errors.collect(cdk.propertyValidator("crossZone", cdk.validateBoolean)(properties.crossZone)), errors.collect(cdk.propertyValidator("healthCheck", CfnLoadBalancer_HealthCheckPropertyValidator)(properties.healthCheck)), errors.collect(cdk.propertyValidator("instances", cdk.listValidator(cdk.validateString))(properties.instances)), errors.collect(cdk.propertyValidator("lbCookieStickinessPolicy", cdk.listValidator(CfnLoadBalancer_LBCookieStickinessPolicyPropertyValidator))(properties.lbCookieStickinessPolicy)), errors.collect(cdk.propertyValidator("listeners", cdk.requiredValidator)(properties.listeners)), errors.collect(cdk.propertyValidator("listeners", cdk.listValidator(CfnLoadBalancer_ListenersPropertyValidator))(properties.listeners)), errors.collect(cdk.propertyValidator("loadBalancerName", cdk.validateString)(properties.loadBalancerName)), errors.collect(cdk.propertyValidator("policies", cdk.listValidator(CfnLoadBalancer_PoliciesPropertyValidator))(properties.policies)), errors.collect(cdk.propertyValidator("scheme", cdk.validateString)(properties.scheme)), errors.collect(cdk.propertyValidator("securityGroups", cdk.listValidator(cdk.validateString))(properties.securityGroups)), errors.collect(cdk.propertyValidator("subnets", cdk.listValidator(cdk.validateString))(properties.subnets)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnLoadBalancerProps"');
    }
    function cfnLoadBalancerPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLoadBalancerPropsValidator(properties).assertSuccess(), { Listeners: cdk.listMapper(cfnLoadBalancerListenersPropertyToCloudFormation)(properties.listeners), AccessLoggingPolicy: cfnLoadBalancerAccessLoggingPolicyPropertyToCloudFormation(properties.accessLoggingPolicy), AppCookieStickinessPolicy: cdk.listMapper(cfnLoadBalancerAppCookieStickinessPolicyPropertyToCloudFormation)(properties.appCookieStickinessPolicy), AvailabilityZones: cdk.listMapper(cdk.stringToCloudFormation)(properties.availabilityZones), ConnectionDrainingPolicy: cfnLoadBalancerConnectionDrainingPolicyPropertyToCloudFormation(properties.connectionDrainingPolicy), ConnectionSettings: cfnLoadBalancerConnectionSettingsPropertyToCloudFormation(properties.connectionSettings), CrossZone: cdk.booleanToCloudFormation(properties.crossZone), HealthCheck: cfnLoadBalancerHealthCheckPropertyToCloudFormation(properties.healthCheck), Instances: cdk.listMapper(cdk.stringToCloudFormation)(properties.instances), LBCookieStickinessPolicy: cdk.listMapper(cfnLoadBalancerLBCookieStickinessPolicyPropertyToCloudFormation)(properties.lbCookieStickinessPolicy), LoadBalancerName: cdk.stringToCloudFormation(properties.loadBalancerName), Policies: cdk.listMapper(cfnLoadBalancerPoliciesPropertyToCloudFormation)(properties.policies), Scheme: cdk.stringToCloudFormation(properties.scheme), SecurityGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroups), Subnets: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnets), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnLoadBalancerPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("listeners", "Listeners", cfn_parse.FromCloudFormation.getArray(CfnLoadBalancerListenersPropertyFromCloudFormation)(properties.Listeners)), ret.addPropertyResult("accessLoggingPolicy", "AccessLoggingPolicy", properties.AccessLoggingPolicy != null ? CfnLoadBalancerAccessLoggingPolicyPropertyFromCloudFormation(properties.AccessLoggingPolicy) : void 0), ret.addPropertyResult("appCookieStickinessPolicy", "AppCookieStickinessPolicy", properties.AppCookieStickinessPolicy != null ? cfn_parse.FromCloudFormation.getArray(CfnLoadBalancerAppCookieStickinessPolicyPropertyFromCloudFormation)(properties.AppCookieStickinessPolicy) : void 0), ret.addPropertyResult("availabilityZones", "AvailabilityZones", properties.AvailabilityZones != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AvailabilityZones) : void 0), ret.addPropertyResult("connectionDrainingPolicy", "ConnectionDrainingPolicy", properties.ConnectionDrainingPolicy != null ? CfnLoadBalancerConnectionDrainingPolicyPropertyFromCloudFormation(properties.ConnectionDrainingPolicy) : void 0), ret.addPropertyResult("connectionSettings", "ConnectionSettings", properties.ConnectionSettings != null ? CfnLoadBalancerConnectionSettingsPropertyFromCloudFormation(properties.ConnectionSettings) : void 0), ret.addPropertyResult("crossZone", "CrossZone", properties.CrossZone != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CrossZone) : void 0), ret.addPropertyResult("healthCheck", "HealthCheck", properties.HealthCheck != null ? CfnLoadBalancerHealthCheckPropertyFromCloudFormation(properties.HealthCheck) : void 0), ret.addPropertyResult("instances", "Instances", properties.Instances != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Instances) : void 0), ret.addPropertyResult("lbCookieStickinessPolicy", "LBCookieStickinessPolicy", properties.LBCookieStickinessPolicy != null ? cfn_parse.FromCloudFormation.getArray(CfnLoadBalancerLBCookieStickinessPolicyPropertyFromCloudFormation)(properties.LBCookieStickinessPolicy) : void 0), ret.addPropertyResult("loadBalancerName", "LoadBalancerName", properties.LoadBalancerName != null ? cfn_parse.FromCloudFormation.getString(properties.LoadBalancerName) : void 0), ret.addPropertyResult("policies", "Policies", properties.Policies != null ? cfn_parse.FromCloudFormation.getArray(CfnLoadBalancerPoliciesPropertyFromCloudFormation)(properties.Policies) : void 0), ret.addPropertyResult("scheme", "Scheme", properties.Scheme != null ? cfn_parse.FromCloudFormation.getString(properties.Scheme) : void 0), ret.addPropertyResult("securityGroups", "SecurityGroups", properties.SecurityGroups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroups) : void 0), ret.addPropertyResult("subnets", "Subnets", properties.Subnets != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Subnets) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLoadBalancer = class _CfnLoadBalancer extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLoadBalancerPropsFromCloudFormation(resourceProperties), ret = new _CfnLoadBalancer(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLoadBalancer.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancing_CfnLoadBalancerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLoadBalancer), error;
        }
        cdk.requireProperty(props, "listeners", this), this.attrCanonicalHostedZoneName = cdk.Token.asString(this.getAtt("CanonicalHostedZoneName", cdk.ResolutionTypeHint.STRING)), this.attrCanonicalHostedZoneNameId = cdk.Token.asString(this.getAtt("CanonicalHostedZoneNameID", cdk.ResolutionTypeHint.STRING)), this.attrDnsName = cdk.Token.asString(this.getAtt("DNSName", cdk.ResolutionTypeHint.STRING)), this.attrSourceSecurityGroupGroupName = cdk.Token.asString(this.getAtt("SourceSecurityGroup.GroupName", cdk.ResolutionTypeHint.STRING)), this.attrSourceSecurityGroupOwnerAlias = cdk.Token.asString(this.getAtt("SourceSecurityGroup.OwnerAlias", cdk.ResolutionTypeHint.STRING)), this.listeners = props.listeners, this.accessLoggingPolicy = props.accessLoggingPolicy, this.appCookieStickinessPolicy = props.appCookieStickinessPolicy, this.availabilityZones = props.availabilityZones, this.connectionDrainingPolicy = props.connectionDrainingPolicy, this.connectionSettings = props.connectionSettings, this.crossZone = props.crossZone, this.healthCheck = props.healthCheck, this.instances = props.instances, this.lbCookieStickinessPolicy = props.lbCookieStickinessPolicy, this.loadBalancerName = props.loadBalancerName, this.policies = props.policies, this.scheme = props.scheme, this.securityGroups = props.securityGroups, this.subnets = props.subnets, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ElasticLoadBalancing::LoadBalancer", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLoadBalancer.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { listeners: this.listeners, accessLoggingPolicy: this.accessLoggingPolicy, appCookieStickinessPolicy: this.appCookieStickinessPolicy, availabilityZones: this.availabilityZones, connectionDrainingPolicy: this.connectionDrainingPolicy, connectionSettings: this.connectionSettings, crossZone: this.crossZone, healthCheck: this.healthCheck, instances: this.instances, lbCookieStickinessPolicy: this.lbCookieStickinessPolicy, loadBalancerName: this.loadBalancerName, policies: this.policies, scheme: this.scheme, securityGroups: this.securityGroups, subnets: this.subnets, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnLoadBalancerPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnLoadBalancer[_a] = { fqn: "aws-cdk-lib.aws_elasticloadbalancing.CfnLoadBalancer", version: "2.80.0" }, CfnLoadBalancer.CFN_RESOURCE_TYPE_NAME = "AWS::ElasticLoadBalancing::LoadBalancer", exports2.CfnLoadBalancer = CfnLoadBalancer;
    function CfnLoadBalancer_AccessLoggingPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("emitInterval", cdk.validateNumber)(properties.emitInterval)), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("s3BucketName", cdk.requiredValidator)(properties.s3BucketName)), errors.collect(cdk.propertyValidator("s3BucketName", cdk.validateString)(properties.s3BucketName)), errors.collect(cdk.propertyValidator("s3BucketPrefix", cdk.validateString)(properties.s3BucketPrefix)), errors.wrap('supplied properties not correct for "AccessLoggingPolicyProperty"');
    }
    function cfnLoadBalancerAccessLoggingPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLoadBalancer_AccessLoggingPolicyPropertyValidator(properties).assertSuccess(), { EmitInterval: cdk.numberToCloudFormation(properties.emitInterval), Enabled: cdk.booleanToCloudFormation(properties.enabled), S3BucketName: cdk.stringToCloudFormation(properties.s3BucketName), S3BucketPrefix: cdk.stringToCloudFormation(properties.s3BucketPrefix) }) : properties;
    }
    function CfnLoadBalancerAccessLoggingPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("emitInterval", "EmitInterval", properties.EmitInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.EmitInterval) : void 0), ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addPropertyResult("s3BucketName", "S3BucketName", cfn_parse.FromCloudFormation.getString(properties.S3BucketName)), ret.addPropertyResult("s3BucketPrefix", "S3BucketPrefix", properties.S3BucketPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.S3BucketPrefix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLoadBalancer_AppCookieStickinessPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cookieName", cdk.requiredValidator)(properties.cookieName)), errors.collect(cdk.propertyValidator("cookieName", cdk.validateString)(properties.cookieName)), errors.collect(cdk.propertyValidator("policyName", cdk.requiredValidator)(properties.policyName)), errors.collect(cdk.propertyValidator("policyName", cdk.validateString)(properties.policyName)), errors.wrap('supplied properties not correct for "AppCookieStickinessPolicyProperty"');
    }
    function cfnLoadBalancerAppCookieStickinessPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLoadBalancer_AppCookieStickinessPolicyPropertyValidator(properties).assertSuccess(), { CookieName: cdk.stringToCloudFormation(properties.cookieName), PolicyName: cdk.stringToCloudFormation(properties.policyName) }) : properties;
    }
    function CfnLoadBalancerAppCookieStickinessPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cookieName", "CookieName", cfn_parse.FromCloudFormation.getString(properties.CookieName)), ret.addPropertyResult("policyName", "PolicyName", cfn_parse.FromCloudFormation.getString(properties.PolicyName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLoadBalancer_ConnectionDrainingPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("timeout", cdk.validateNumber)(properties.timeout)), errors.wrap('supplied properties not correct for "ConnectionDrainingPolicyProperty"');
    }
    function cfnLoadBalancerConnectionDrainingPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLoadBalancer_ConnectionDrainingPolicyPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled), Timeout: cdk.numberToCloudFormation(properties.timeout) }) : properties;
    }
    function CfnLoadBalancerConnectionDrainingPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addPropertyResult("timeout", "Timeout", properties.Timeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.Timeout) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLoadBalancer_ConnectionSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("idleTimeout", cdk.requiredValidator)(properties.idleTimeout)), errors.collect(cdk.propertyValidator("idleTimeout", cdk.validateNumber)(properties.idleTimeout)), errors.wrap('supplied properties not correct for "ConnectionSettingsProperty"');
    }
    function cfnLoadBalancerConnectionSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLoadBalancer_ConnectionSettingsPropertyValidator(properties).assertSuccess(), { IdleTimeout: cdk.numberToCloudFormation(properties.idleTimeout) }) : properties;
    }
    function CfnLoadBalancerConnectionSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("idleTimeout", "IdleTimeout", cfn_parse.FromCloudFormation.getNumber(properties.IdleTimeout)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLoadBalancer_HealthCheckPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("healthyThreshold", cdk.requiredValidator)(properties.healthyThreshold)), errors.collect(cdk.propertyValidator("healthyThreshold", cdk.validateString)(properties.healthyThreshold)), errors.collect(cdk.propertyValidator("interval", cdk.requiredValidator)(properties.interval)), errors.collect(cdk.propertyValidator("interval", cdk.validateString)(properties.interval)), errors.collect(cdk.propertyValidator("target", cdk.requiredValidator)(properties.target)), errors.collect(cdk.propertyValidator("target", cdk.validateString)(properties.target)), errors.collect(cdk.propertyValidator("timeout", cdk.requiredValidator)(properties.timeout)), errors.collect(cdk.propertyValidator("timeout", cdk.validateString)(properties.timeout)), errors.collect(cdk.propertyValidator("unhealthyThreshold", cdk.requiredValidator)(properties.unhealthyThreshold)), errors.collect(cdk.propertyValidator("unhealthyThreshold", cdk.validateString)(properties.unhealthyThreshold)), errors.wrap('supplied properties not correct for "HealthCheckProperty"');
    }
    function cfnLoadBalancerHealthCheckPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLoadBalancer_HealthCheckPropertyValidator(properties).assertSuccess(), { HealthyThreshold: cdk.stringToCloudFormation(properties.healthyThreshold), Interval: cdk.stringToCloudFormation(properties.interval), Target: cdk.stringToCloudFormation(properties.target), Timeout: cdk.stringToCloudFormation(properties.timeout), UnhealthyThreshold: cdk.stringToCloudFormation(properties.unhealthyThreshold) }) : properties;
    }
    function CfnLoadBalancerHealthCheckPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("healthyThreshold", "HealthyThreshold", cfn_parse.FromCloudFormation.getString(properties.HealthyThreshold)), ret.addPropertyResult("interval", "Interval", cfn_parse.FromCloudFormation.getString(properties.Interval)), ret.addPropertyResult("target", "Target", cfn_parse.FromCloudFormation.getString(properties.Target)), ret.addPropertyResult("timeout", "Timeout", cfn_parse.FromCloudFormation.getString(properties.Timeout)), ret.addPropertyResult("unhealthyThreshold", "UnhealthyThreshold", cfn_parse.FromCloudFormation.getString(properties.UnhealthyThreshold)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLoadBalancer_LBCookieStickinessPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cookieExpirationPeriod", cdk.validateString)(properties.cookieExpirationPeriod)), errors.collect(cdk.propertyValidator("policyName", cdk.validateString)(properties.policyName)), errors.wrap('supplied properties not correct for "LBCookieStickinessPolicyProperty"');
    }
    function cfnLoadBalancerLBCookieStickinessPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLoadBalancer_LBCookieStickinessPolicyPropertyValidator(properties).assertSuccess(), { CookieExpirationPeriod: cdk.stringToCloudFormation(properties.cookieExpirationPeriod), PolicyName: cdk.stringToCloudFormation(properties.policyName) }) : properties;
    }
    function CfnLoadBalancerLBCookieStickinessPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cookieExpirationPeriod", "CookieExpirationPeriod", properties.CookieExpirationPeriod != null ? cfn_parse.FromCloudFormation.getString(properties.CookieExpirationPeriod) : void 0), ret.addPropertyResult("policyName", "PolicyName", properties.PolicyName != null ? cfn_parse.FromCloudFormation.getString(properties.PolicyName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLoadBalancer_ListenersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instancePort", cdk.requiredValidator)(properties.instancePort)), errors.collect(cdk.propertyValidator("instancePort", cdk.validateString)(properties.instancePort)), errors.collect(cdk.propertyValidator("instanceProtocol", cdk.validateString)(properties.instanceProtocol)), errors.collect(cdk.propertyValidator("loadBalancerPort", cdk.requiredValidator)(properties.loadBalancerPort)), errors.collect(cdk.propertyValidator("loadBalancerPort", cdk.validateString)(properties.loadBalancerPort)), errors.collect(cdk.propertyValidator("policyNames", cdk.listValidator(cdk.validateString))(properties.policyNames)), errors.collect(cdk.propertyValidator("protocol", cdk.requiredValidator)(properties.protocol)), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.collect(cdk.propertyValidator("sslCertificateId", cdk.validateString)(properties.sslCertificateId)), errors.wrap('supplied properties not correct for "ListenersProperty"');
    }
    function cfnLoadBalancerListenersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLoadBalancer_ListenersPropertyValidator(properties).assertSuccess(), { InstancePort: cdk.stringToCloudFormation(properties.instancePort), InstanceProtocol: cdk.stringToCloudFormation(properties.instanceProtocol), LoadBalancerPort: cdk.stringToCloudFormation(properties.loadBalancerPort), PolicyNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.policyNames), Protocol: cdk.stringToCloudFormation(properties.protocol), SSLCertificateId: cdk.stringToCloudFormation(properties.sslCertificateId) }) : properties;
    }
    function CfnLoadBalancerListenersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instancePort", "InstancePort", cfn_parse.FromCloudFormation.getString(properties.InstancePort)), ret.addPropertyResult("instanceProtocol", "InstanceProtocol", properties.InstanceProtocol != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceProtocol) : void 0), ret.addPropertyResult("loadBalancerPort", "LoadBalancerPort", cfn_parse.FromCloudFormation.getString(properties.LoadBalancerPort)), ret.addPropertyResult("policyNames", "PolicyNames", properties.PolicyNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.PolicyNames) : void 0), ret.addPropertyResult("protocol", "Protocol", cfn_parse.FromCloudFormation.getString(properties.Protocol)), ret.addPropertyResult("sslCertificateId", "SSLCertificateId", properties.SSLCertificateId != null ? cfn_parse.FromCloudFormation.getString(properties.SSLCertificateId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLoadBalancer_PoliciesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributes", cdk.requiredValidator)(properties.attributes)), errors.collect(cdk.propertyValidator("attributes", cdk.listValidator(cdk.validateObject))(properties.attributes)), errors.collect(cdk.propertyValidator("instancePorts", cdk.listValidator(cdk.validateString))(properties.instancePorts)), errors.collect(cdk.propertyValidator("loadBalancerPorts", cdk.listValidator(cdk.validateString))(properties.loadBalancerPorts)), errors.collect(cdk.propertyValidator("policyName", cdk.requiredValidator)(properties.policyName)), errors.collect(cdk.propertyValidator("policyName", cdk.validateString)(properties.policyName)), errors.collect(cdk.propertyValidator("policyType", cdk.requiredValidator)(properties.policyType)), errors.collect(cdk.propertyValidator("policyType", cdk.validateString)(properties.policyType)), errors.wrap('supplied properties not correct for "PoliciesProperty"');
    }
    function cfnLoadBalancerPoliciesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLoadBalancer_PoliciesPropertyValidator(properties).assertSuccess(), { Attributes: cdk.listMapper(cdk.objectToCloudFormation)(properties.attributes), InstancePorts: cdk.listMapper(cdk.stringToCloudFormation)(properties.instancePorts), LoadBalancerPorts: cdk.listMapper(cdk.stringToCloudFormation)(properties.loadBalancerPorts), PolicyName: cdk.stringToCloudFormation(properties.policyName), PolicyType: cdk.stringToCloudFormation(properties.policyType) }) : properties;
    }
    function CfnLoadBalancerPoliciesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attributes", "Attributes", cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getAny)(properties.Attributes)), ret.addPropertyResult("instancePorts", "InstancePorts", properties.InstancePorts != null ? cfn_parse.FromCloudFormation.getStringArray(properties.InstancePorts) : void 0), ret.addPropertyResult("loadBalancerPorts", "LoadBalancerPorts", properties.LoadBalancerPorts != null ? cfn_parse.FromCloudFormation.getStringArray(properties.LoadBalancerPorts) : void 0), ret.addPropertyResult("policyName", "PolicyName", cfn_parse.FromCloudFormation.getString(properties.PolicyName)), ret.addPropertyResult("policyType", "PolicyType", cfn_parse.FromCloudFormation.getString(properties.PolicyType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancing/lib/load-balancer.js
var require_load_balancer3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancing/lib/load-balancer.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ListenerPort = exports2.InstanceTarget = exports2.LoadBalancer = exports2.LoadBalancingProtocol = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var elasticloadbalancing_generated_1 = require_elasticloadbalancing_generated();
    var aws_ec2_1 = require_aws_ec2();
    var core_1 = require_core2();
    var LoadBalancingProtocol;
    (function(LoadBalancingProtocol2) {
      LoadBalancingProtocol2.TCP = "tcp", LoadBalancingProtocol2.SSL = "ssl", LoadBalancingProtocol2.HTTP = "http", LoadBalancingProtocol2.HTTPS = "https";
    })(LoadBalancingProtocol = exports2.LoadBalancingProtocol || (exports2.LoadBalancingProtocol = {}));
    var LoadBalancer = class _LoadBalancer extends core_1.Resource {
      constructor(scope, id, props) {
        super(scope, id), this.listenerPorts = [], this.listeners = [], this.instancePorts = [], this.targets = [], this.instanceIds = [];
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancing_LoadBalancerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _LoadBalancer), error;
        }
        this.securityGroup = new aws_ec2_1.SecurityGroup(this, "SecurityGroup", { vpc: props.vpc, allowAllOutbound: false }), this.connections = new aws_ec2_1.Connections({ securityGroups: [this.securityGroup] });
        const selectedSubnets = loadBalancerSubnets(props);
        this.elb = new elasticloadbalancing_generated_1.CfnLoadBalancer(this, "Resource", { securityGroups: [this.securityGroup.securityGroupId], subnets: selectedSubnets.subnetIds, listeners: core_1.Lazy.any({ produce: () => this.listeners }), instances: core_1.Lazy.list({ produce: () => this.instanceIds }, { omitEmpty: true }), scheme: props.internetFacing ? "internet-facing" : "internal", healthCheck: props.healthCheck && healthCheckToJSON(props.healthCheck), crossZone: props.crossZone ?? true }), props.internetFacing && this.elb.node.addDependency(selectedSubnets.internetConnectivityEstablished), props.accessLoggingPolicy !== void 0 && (this.elb.accessLoggingPolicy = props.accessLoggingPolicy), ifUndefined(props.listeners, []).forEach((b) => this.addListener(b)), ifUndefined(props.targets, []).forEach((t) => this.addTarget(t));
      }
      addListener(listener) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancing_LoadBalancerListener(listener);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addListener), error;
        }
        if (listener.sslCertificateArn && listener.sslCertificateId)
          throw new Error('"sslCertificateId" is deprecated, please use "sslCertificateArn" only.');
        const protocol = ifUndefinedLazy(listener.externalProtocol, () => wellKnownProtocol(listener.externalPort)), instancePort = listener.internalPort || listener.externalPort, sslCertificateArn = listener.sslCertificateArn || listener.sslCertificateId, instanceProtocol = ifUndefined(listener.internalProtocol, ifUndefined(tryWellKnownProtocol(instancePort), isHttpProtocol(protocol) ? LoadBalancingProtocol.HTTP : LoadBalancingProtocol.TCP));
        this.listeners.push({ loadBalancerPort: listener.externalPort.toString(), protocol, instancePort: instancePort.toString(), instanceProtocol, sslCertificateId: sslCertificateArn, policyNames: listener.policyNames });
        const port = new ListenerPort(this.securityGroup, aws_ec2_1.Port.tcp(listener.externalPort));
        return ifUndefined(listener.allowConnectionsFrom, [aws_ec2_1.Peer.anyIpv4()]).forEach((peer) => {
          port.connections.allowDefaultPortFrom(peer, `Default rule allow on ${listener.externalPort}`);
        }), this.newInstancePort(instancePort), this.listenerPorts.push(port), port;
      }
      addTarget(target) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancing_ILoadBalancerTarget(target);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addTarget), error;
        }
        target.attachToClassicLB(this), this.newTarget(target);
      }
      get loadBalancerName() {
        return this.elb.ref;
      }
      get loadBalancerCanonicalHostedZoneNameId() {
        return this.elb.attrCanonicalHostedZoneNameId;
      }
      get loadBalancerCanonicalHostedZoneName() {
        return this.elb.attrCanonicalHostedZoneName;
      }
      get loadBalancerDnsName() {
        return this.elb.attrDnsName;
      }
      get loadBalancerSourceSecurityGroupGroupName() {
        return this.elb.attrSourceSecurityGroupGroupName;
      }
      get loadBalancerSourceSecurityGroupOwnerAlias() {
        return this.elb.attrSourceSecurityGroupOwnerAlias;
      }
      newInstancePort(instancePort) {
        this.targets.forEach((t) => this.allowTargetConnection(instancePort, t)), this.instancePorts.push(instancePort);
      }
      newTarget(target) {
        this.instancePorts.forEach((p) => this.allowTargetConnection(p, target)), this.targets.push(target);
      }
      allowTargetConnection(instancePort, target) {
        this.connections.allowTo(target, aws_ec2_1.Port.tcp(instancePort), `Port ${instancePort} LB to fleet`);
      }
      _addInstanceId(instanceId) {
        this.instanceIds.push(instanceId);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LoadBalancer[_a] = { fqn: "aws-cdk-lib.aws_elasticloadbalancing.LoadBalancer", version: "2.80.0" }, exports2.LoadBalancer = LoadBalancer;
    var InstanceTarget = class _InstanceTarget {
      constructor(instance) {
        this.instance = instance;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_Instance(instance);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _InstanceTarget), error;
        }
        this.connections = instance.connections;
      }
      attachToClassicLB(loadBalancer) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancing_LoadBalancer(loadBalancer);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.attachToClassicLB), error;
        }
        loadBalancer._addInstanceId(this.instance.instanceId);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, InstanceTarget[_b] = { fqn: "aws-cdk-lib.aws_elasticloadbalancing.InstanceTarget", version: "2.80.0" }, exports2.InstanceTarget = InstanceTarget;
    var ListenerPort = class _ListenerPort {
      constructor(securityGroup, defaultPort) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_ISecurityGroup(securityGroup), jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_Port(defaultPort);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ListenerPort), error;
        }
        this.connections = new aws_ec2_1.Connections({ securityGroups: [securityGroup], defaultPort });
      }
    };
    _c = JSII_RTTI_SYMBOL_1, ListenerPort[_c] = { fqn: "aws-cdk-lib.aws_elasticloadbalancing.ListenerPort", version: "2.80.0" }, exports2.ListenerPort = ListenerPort;
    function wellKnownProtocol(port) {
      const proto = tryWellKnownProtocol(port);
      if (!proto)
        throw new Error(`Please supply protocol to go with port ${port}`);
      return proto;
    }
    function tryWellKnownProtocol(port) {
      if (port === 80)
        return LoadBalancingProtocol.HTTP;
      if (port === 443)
        return LoadBalancingProtocol.HTTPS;
    }
    function isHttpProtocol(proto) {
      return proto === LoadBalancingProtocol.HTTPS || proto === LoadBalancingProtocol.HTTP;
    }
    function ifUndefined(x, def) {
      return x ?? def;
    }
    function ifUndefinedLazy(x, def) {
      return x ?? def();
    }
    function healthCheckToJSON(healthCheck) {
      const protocol = ifUndefined(healthCheck.protocol, ifUndefined(tryWellKnownProtocol(healthCheck.port), LoadBalancingProtocol.TCP)), path = protocol === LoadBalancingProtocol.HTTP || protocol === LoadBalancingProtocol.HTTPS ? ifUndefined(healthCheck.path, "/") : "", target = `${protocol.toUpperCase()}:${healthCheck.port}${path}`;
      return { healthyThreshold: ifUndefined(healthCheck.healthyThreshold, 2).toString(), interval: (healthCheck.interval || core_1.Duration.seconds(30)).toSeconds().toString(), target, timeout: (healthCheck.timeout || core_1.Duration.seconds(5)).toSeconds().toString(), unhealthyThreshold: ifUndefined(healthCheck.unhealthyThreshold, 5).toString() };
    }
    function loadBalancerSubnets(props) {
      return props.subnetSelection !== void 0 ? props.vpc.selectSubnets(props.subnetSelection) : props.internetFacing ? props.vpc.selectSubnets({ subnetType: aws_ec2_1.SubnetType.PUBLIC }) : props.vpc.selectSubnets({ subnetType: aws_ec2_1.SubnetType.PRIVATE_WITH_EGRESS });
    }
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancing/lib/index.js
var require_lib119 = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancing/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_elasticloadbalancing_generated(), exports2), __exportStar(require_load_balancer3(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancing/index.js
var require_aws_elasticloadbalancing = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancing/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib119(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2-actions/lib/cognito-action.js
var require_cognito_action = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2-actions/lib/cognito-action.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AuthenticateCognitoAction = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var aws_ec2_1 = require_aws_ec2();
    var elbv2 = require_aws_elasticloadbalancingv2();
    var AuthenticateCognitoAction = class _AuthenticateCognitoAction extends elbv2.ListenerAction {
      static config(options) {
        return { userPoolArn: options.userPool.userPoolArn, userPoolClientId: options.userPoolClient.userPoolClientId, userPoolDomain: options.userPoolDomain.domainName, authenticationRequestExtraParams: options.authenticationRequestExtraParams, onUnauthenticatedRequest: options.onUnauthenticatedRequest, scope: options.scope, sessionCookieName: options.sessionCookieName, sessionTimeout: options.sessionTimeout?.toSeconds().toString() };
      }
      constructor(options) {
        super({ type: "authenticate-cognito", authenticateCognitoConfig: _AuthenticateCognitoAction.config(options) }, options.next);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_actions_AuthenticateCognitoActionProps(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AuthenticateCognitoAction), error;
        }
        this.allowHttpsOutbound = options.allowHttpsOutbound ?? true, this.addRuleAction({ type: "authenticate-cognito", authenticateCognitoConfig: { ..._AuthenticateCognitoAction.config(options), sessionTimeout: options.sessionTimeout?.toSeconds() } });
      }
      bind(scope, listener, associatingConstruct) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_IApplicationListener(listener);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        super.bind(scope, listener, associatingConstruct), this.allowHttpsOutbound && listener.connections.allowToAnyIpv4(aws_ec2_1.Port.tcp(443), "Allow to IdP endpoint");
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AuthenticateCognitoAction[_a] = { fqn: "aws-cdk-lib.aws_elasticloadbalancingv2_actions.AuthenticateCognitoAction", version: "2.80.0" }, exports2.AuthenticateCognitoAction = AuthenticateCognitoAction;
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2-actions/lib/index.js
var require_lib120 = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2-actions/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_cognito_action(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2-actions/index.js
var require_aws_elasticloadbalancingv2_actions = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2-actions/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib120(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2-targets/lib/alb-target.js
var require_alb_target = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2-targets/lib/alb-target.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AlbTarget = exports2.AlbArnTarget = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var elbv2 = require_aws_elasticloadbalancingv2();
    var AlbArnTarget = class {
      constructor(albArn, port) {
        this.albArn = albArn, this.port = port;
      }
      attachToNetworkTargetGroup(targetGroup) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_INetworkTargetGroup(targetGroup);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.attachToNetworkTargetGroup), error;
        }
        return this.attach(targetGroup);
      }
      attach(_targetGroup) {
        return { targetType: elbv2.TargetType.ALB, targetJson: { id: this.albArn, port: this.port } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AlbArnTarget[_a] = { fqn: "aws-cdk-lib.aws_elasticloadbalancingv2_targets.AlbArnTarget", version: "2.80.0" }, exports2.AlbArnTarget = AlbArnTarget;
    var AlbTarget = class _AlbTarget extends AlbArnTarget {
      constructor(alb, port) {
        super(alb.loadBalancerArn, port);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_ApplicationLoadBalancer(alb);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AlbTarget), error;
        }
      }
    };
    _b = JSII_RTTI_SYMBOL_1, AlbTarget[_b] = { fqn: "aws-cdk-lib.aws_elasticloadbalancingv2_targets.AlbTarget", version: "2.80.0" }, exports2.AlbTarget = AlbTarget;
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2-targets/lib/ip-target.js
var require_ip_target = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2-targets/lib/ip-target.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.IpTarget = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var elbv2 = require_aws_elasticloadbalancingv2();
    var IpTarget = class {
      constructor(ipAddress, port, availabilityZone) {
        this.ipAddress = ipAddress, this.port = port, this.availabilityZone = availabilityZone;
      }
      attachToApplicationTargetGroup(targetGroup) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_IApplicationTargetGroup(targetGroup);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.attachToApplicationTargetGroup), error;
        }
        return this.attach(targetGroup);
      }
      attachToNetworkTargetGroup(targetGroup) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_INetworkTargetGroup(targetGroup);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.attachToNetworkTargetGroup), error;
        }
        return this.attach(targetGroup);
      }
      attach(_targetGroup) {
        return { targetType: elbv2.TargetType.IP, targetJson: { id: this.ipAddress, port: this.port, availabilityZone: this.availabilityZone } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, IpTarget[_a] = { fqn: "aws-cdk-lib.aws_elasticloadbalancingv2_targets.IpTarget", version: "2.80.0" }, exports2.IpTarget = IpTarget;
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2-targets/lib/instance-target.js
var require_instance_target = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2-targets/lib/instance-target.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.InstanceTarget = exports2.InstanceIdTarget = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var elbv2 = require_aws_elasticloadbalancingv2();
    var InstanceIdTarget = class {
      constructor(instanceId, port) {
        this.instanceId = instanceId, this.port = port;
      }
      attachToApplicationTargetGroup(targetGroup) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_IApplicationTargetGroup(targetGroup);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.attachToApplicationTargetGroup), error;
        }
        return this.attach(targetGroup);
      }
      attachToNetworkTargetGroup(targetGroup) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_INetworkTargetGroup(targetGroup);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.attachToNetworkTargetGroup), error;
        }
        return this.attach(targetGroup);
      }
      attach(_targetGroup) {
        return { targetType: elbv2.TargetType.INSTANCE, targetJson: { id: this.instanceId, port: this.port } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, InstanceIdTarget[_a] = { fqn: "aws-cdk-lib.aws_elasticloadbalancingv2_targets.InstanceIdTarget", version: "2.80.0" }, exports2.InstanceIdTarget = InstanceIdTarget;
    var InstanceTarget = class _InstanceTarget extends InstanceIdTarget {
      constructor(instance, port) {
        super(instance.instanceId, port);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_Instance(instance);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _InstanceTarget), error;
        }
      }
    };
    _b = JSII_RTTI_SYMBOL_1, InstanceTarget[_b] = { fqn: "aws-cdk-lib.aws_elasticloadbalancingv2_targets.InstanceTarget", version: "2.80.0" }, exports2.InstanceTarget = InstanceTarget;
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2-targets/lib/lambda-target.js
var require_lambda_target = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2-targets/lib/lambda-target.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LambdaTarget = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var elbv2 = require_aws_elasticloadbalancingv2();
    var iam = require_aws_iam();
    var LambdaTarget = class _LambdaTarget {
      constructor(fn) {
        this.fn = fn;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_IFunction(fn);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _LambdaTarget), error;
        }
      }
      attachToApplicationTargetGroup(targetGroup) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_IApplicationTargetGroup(targetGroup);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.attachToApplicationTargetGroup), error;
        }
        return this.fn.grantInvoke(new iam.ServicePrincipal("elasticloadbalancing.amazonaws.com")).applyBefore(targetGroup), this.attach(targetGroup);
      }
      attachToNetworkTargetGroup(targetGroup) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_INetworkTargetGroup(targetGroup);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.attachToNetworkTargetGroup), error;
        }
        return this.fn.grantInvoke(new iam.ServicePrincipal("elasticloadbalancing.amazonaws.com")).applyBefore(targetGroup), this.attach(targetGroup);
      }
      attach(_targetGroup) {
        return { targetType: elbv2.TargetType.LAMBDA, targetJson: { id: this.fn.functionArn } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LambdaTarget[_a] = { fqn: "aws-cdk-lib.aws_elasticloadbalancingv2_targets.LambdaTarget", version: "2.80.0" }, exports2.LambdaTarget = LambdaTarget;
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2-targets/lib/index.js
var require_lib121 = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2-targets/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_alb_target(), exports2), __exportStar(require_ip_target(), exports2), __exportStar(require_instance_target(), exports2), __exportStar(require_lambda_target(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-elasticloadbalancingv2-targets/index.js
var require_aws_elasticloadbalancingv2_targets = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticloadbalancingv2-targets/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib121(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-elasticsearch/lib/index.js
var require_lib122 = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticsearch/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_domain(), exports2), __exportStar(require_elasticsearch_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-elasticsearch/index.js
var require_aws_elasticsearch = __commonJS({
  "node_modules/aws-cdk-lib/aws-elasticsearch/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib122(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-emr/lib/emr.generated.js
var require_emr_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-emr/lib/emr.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnStudioSessionMapping = exports2.CfnStudio = exports2.CfnStep = exports2.CfnSecurityConfiguration = exports2.CfnInstanceGroupConfig = exports2.CfnInstanceFleetConfig = exports2.CfnCluster = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnClusterPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("additionalInfo", cdk.validateObject)(properties.additionalInfo)), errors.collect(cdk.propertyValidator("applications", cdk.listValidator(CfnCluster_ApplicationPropertyValidator))(properties.applications)), errors.collect(cdk.propertyValidator("autoScalingRole", cdk.validateString)(properties.autoScalingRole)), errors.collect(cdk.propertyValidator("autoTerminationPolicy", CfnCluster_AutoTerminationPolicyPropertyValidator)(properties.autoTerminationPolicy)), errors.collect(cdk.propertyValidator("bootstrapActions", cdk.listValidator(CfnCluster_BootstrapActionConfigPropertyValidator))(properties.bootstrapActions)), errors.collect(cdk.propertyValidator("configurations", cdk.listValidator(CfnCluster_ConfigurationPropertyValidator))(properties.configurations)), errors.collect(cdk.propertyValidator("customAmiId", cdk.validateString)(properties.customAmiId)), errors.collect(cdk.propertyValidator("ebsRootVolumeSize", cdk.validateNumber)(properties.ebsRootVolumeSize)), errors.collect(cdk.propertyValidator("instances", cdk.requiredValidator)(properties.instances)), errors.collect(cdk.propertyValidator("instances", CfnCluster_JobFlowInstancesConfigPropertyValidator)(properties.instances)), errors.collect(cdk.propertyValidator("jobFlowRole", cdk.requiredValidator)(properties.jobFlowRole)), errors.collect(cdk.propertyValidator("jobFlowRole", cdk.validateString)(properties.jobFlowRole)), errors.collect(cdk.propertyValidator("kerberosAttributes", CfnCluster_KerberosAttributesPropertyValidator)(properties.kerberosAttributes)), errors.collect(cdk.propertyValidator("logEncryptionKmsKeyId", cdk.validateString)(properties.logEncryptionKmsKeyId)), errors.collect(cdk.propertyValidator("logUri", cdk.validateString)(properties.logUri)), errors.collect(cdk.propertyValidator("managedScalingPolicy", CfnCluster_ManagedScalingPolicyPropertyValidator)(properties.managedScalingPolicy)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("osReleaseLabel", cdk.validateString)(properties.osReleaseLabel)), errors.collect(cdk.propertyValidator("releaseLabel", cdk.validateString)(properties.releaseLabel)), errors.collect(cdk.propertyValidator("scaleDownBehavior", cdk.validateString)(properties.scaleDownBehavior)), errors.collect(cdk.propertyValidator("securityConfiguration", cdk.validateString)(properties.securityConfiguration)), errors.collect(cdk.propertyValidator("serviceRole", cdk.requiredValidator)(properties.serviceRole)), errors.collect(cdk.propertyValidator("serviceRole", cdk.validateString)(properties.serviceRole)), errors.collect(cdk.propertyValidator("stepConcurrencyLevel", cdk.validateNumber)(properties.stepConcurrencyLevel)), errors.collect(cdk.propertyValidator("steps", cdk.listValidator(CfnCluster_StepConfigPropertyValidator))(properties.steps)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("visibleToAllUsers", cdk.validateBoolean)(properties.visibleToAllUsers)), errors.wrap('supplied properties not correct for "CfnClusterProps"');
    }
    function cfnClusterPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClusterPropsValidator(properties).assertSuccess(), { Instances: cfnClusterJobFlowInstancesConfigPropertyToCloudFormation(properties.instances), JobFlowRole: cdk.stringToCloudFormation(properties.jobFlowRole), Name: cdk.stringToCloudFormation(properties.name), ServiceRole: cdk.stringToCloudFormation(properties.serviceRole), AdditionalInfo: cdk.objectToCloudFormation(properties.additionalInfo), Applications: cdk.listMapper(cfnClusterApplicationPropertyToCloudFormation)(properties.applications), AutoScalingRole: cdk.stringToCloudFormation(properties.autoScalingRole), AutoTerminationPolicy: cfnClusterAutoTerminationPolicyPropertyToCloudFormation(properties.autoTerminationPolicy), BootstrapActions: cdk.listMapper(cfnClusterBootstrapActionConfigPropertyToCloudFormation)(properties.bootstrapActions), Configurations: cdk.listMapper(cfnClusterConfigurationPropertyToCloudFormation)(properties.configurations), CustomAmiId: cdk.stringToCloudFormation(properties.customAmiId), EbsRootVolumeSize: cdk.numberToCloudFormation(properties.ebsRootVolumeSize), KerberosAttributes: cfnClusterKerberosAttributesPropertyToCloudFormation(properties.kerberosAttributes), LogEncryptionKmsKeyId: cdk.stringToCloudFormation(properties.logEncryptionKmsKeyId), LogUri: cdk.stringToCloudFormation(properties.logUri), ManagedScalingPolicy: cfnClusterManagedScalingPolicyPropertyToCloudFormation(properties.managedScalingPolicy), OSReleaseLabel: cdk.stringToCloudFormation(properties.osReleaseLabel), ReleaseLabel: cdk.stringToCloudFormation(properties.releaseLabel), ScaleDownBehavior: cdk.stringToCloudFormation(properties.scaleDownBehavior), SecurityConfiguration: cdk.stringToCloudFormation(properties.securityConfiguration), StepConcurrencyLevel: cdk.numberToCloudFormation(properties.stepConcurrencyLevel), Steps: cdk.listMapper(cfnClusterStepConfigPropertyToCloudFormation)(properties.steps), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VisibleToAllUsers: cdk.booleanToCloudFormation(properties.visibleToAllUsers) }) : properties;
    }
    function CfnClusterPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instances", "Instances", CfnClusterJobFlowInstancesConfigPropertyFromCloudFormation(properties.Instances)), ret.addPropertyResult("jobFlowRole", "JobFlowRole", cfn_parse.FromCloudFormation.getString(properties.JobFlowRole)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("serviceRole", "ServiceRole", cfn_parse.FromCloudFormation.getString(properties.ServiceRole)), ret.addPropertyResult("additionalInfo", "AdditionalInfo", properties.AdditionalInfo != null ? cfn_parse.FromCloudFormation.getAny(properties.AdditionalInfo) : void 0), ret.addPropertyResult("applications", "Applications", properties.Applications != null ? cfn_parse.FromCloudFormation.getArray(CfnClusterApplicationPropertyFromCloudFormation)(properties.Applications) : void 0), ret.addPropertyResult("autoScalingRole", "AutoScalingRole", properties.AutoScalingRole != null ? cfn_parse.FromCloudFormation.getString(properties.AutoScalingRole) : void 0), ret.addPropertyResult("autoTerminationPolicy", "AutoTerminationPolicy", properties.AutoTerminationPolicy != null ? CfnClusterAutoTerminationPolicyPropertyFromCloudFormation(properties.AutoTerminationPolicy) : void 0), ret.addPropertyResult("bootstrapActions", "BootstrapActions", properties.BootstrapActions != null ? cfn_parse.FromCloudFormation.getArray(CfnClusterBootstrapActionConfigPropertyFromCloudFormation)(properties.BootstrapActions) : void 0), ret.addPropertyResult("configurations", "Configurations", properties.Configurations != null ? cfn_parse.FromCloudFormation.getArray(CfnClusterConfigurationPropertyFromCloudFormation)(properties.Configurations) : void 0), ret.addPropertyResult("customAmiId", "CustomAmiId", properties.CustomAmiId != null ? cfn_parse.FromCloudFormation.getString(properties.CustomAmiId) : void 0), ret.addPropertyResult("ebsRootVolumeSize", "EbsRootVolumeSize", properties.EbsRootVolumeSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.EbsRootVolumeSize) : void 0), ret.addPropertyResult("kerberosAttributes", "KerberosAttributes", properties.KerberosAttributes != null ? CfnClusterKerberosAttributesPropertyFromCloudFormation(properties.KerberosAttributes) : void 0), ret.addPropertyResult("logEncryptionKmsKeyId", "LogEncryptionKmsKeyId", properties.LogEncryptionKmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.LogEncryptionKmsKeyId) : void 0), ret.addPropertyResult("logUri", "LogUri", properties.LogUri != null ? cfn_parse.FromCloudFormation.getString(properties.LogUri) : void 0), ret.addPropertyResult("managedScalingPolicy", "ManagedScalingPolicy", properties.ManagedScalingPolicy != null ? CfnClusterManagedScalingPolicyPropertyFromCloudFormation(properties.ManagedScalingPolicy) : void 0), ret.addPropertyResult("osReleaseLabel", "OSReleaseLabel", properties.OSReleaseLabel != null ? cfn_parse.FromCloudFormation.getString(properties.OSReleaseLabel) : void 0), ret.addPropertyResult("releaseLabel", "ReleaseLabel", properties.ReleaseLabel != null ? cfn_parse.FromCloudFormation.getString(properties.ReleaseLabel) : void 0), ret.addPropertyResult("scaleDownBehavior", "ScaleDownBehavior", properties.ScaleDownBehavior != null ? cfn_parse.FromCloudFormation.getString(properties.ScaleDownBehavior) : void 0), ret.addPropertyResult("securityConfiguration", "SecurityConfiguration", properties.SecurityConfiguration != null ? cfn_parse.FromCloudFormation.getString(properties.SecurityConfiguration) : void 0), ret.addPropertyResult("stepConcurrencyLevel", "StepConcurrencyLevel", properties.StepConcurrencyLevel != null ? cfn_parse.FromCloudFormation.getNumber(properties.StepConcurrencyLevel) : void 0), ret.addPropertyResult("steps", "Steps", properties.Steps != null ? cfn_parse.FromCloudFormation.getArray(CfnClusterStepConfigPropertyFromCloudFormation)(properties.Steps) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("visibleToAllUsers", "VisibleToAllUsers", properties.VisibleToAllUsers != null ? cfn_parse.FromCloudFormation.getBoolean(properties.VisibleToAllUsers) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCluster = class _CfnCluster extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnClusterPropsFromCloudFormation(resourceProperties), ret = new _CfnCluster(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCluster.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_emr_CfnClusterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCluster), error;
        }
        cdk.requireProperty(props, "instances", this), cdk.requireProperty(props, "jobFlowRole", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "serviceRole", this), this.attrMasterPublicDns = cdk.Token.asString(this.getAtt("MasterPublicDNS", cdk.ResolutionTypeHint.STRING)), this.instances = props.instances, this.jobFlowRole = props.jobFlowRole, this.name = props.name, this.serviceRole = props.serviceRole, this.additionalInfo = props.additionalInfo, this.applications = props.applications, this.autoScalingRole = props.autoScalingRole, this.autoTerminationPolicy = props.autoTerminationPolicy, this.bootstrapActions = props.bootstrapActions, this.configurations = props.configurations, this.customAmiId = props.customAmiId, this.ebsRootVolumeSize = props.ebsRootVolumeSize, this.kerberosAttributes = props.kerberosAttributes, this.logEncryptionKmsKeyId = props.logEncryptionKmsKeyId, this.logUri = props.logUri, this.managedScalingPolicy = props.managedScalingPolicy, this.osReleaseLabel = props.osReleaseLabel, this.releaseLabel = props.releaseLabel, this.scaleDownBehavior = props.scaleDownBehavior, this.securityConfiguration = props.securityConfiguration, this.stepConcurrencyLevel = props.stepConcurrencyLevel, this.steps = props.steps, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EMR::Cluster", props.tags, { tagPropertyName: "tags" }), this.visibleToAllUsers = props.visibleToAllUsers, this.node.scope && cdk.Resource.isResource(this.node.scope) && this.node.addValidation({ validate: () => this.cfnOptions.deletionPolicy === void 0 ? ["'AWS::EMR::Cluster' is a stateful resource type, and you must specify a Removal Policy for it. Call 'resource.applyRemovalPolicy()'."] : [] });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCluster.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { instances: this.instances, jobFlowRole: this.jobFlowRole, name: this.name, serviceRole: this.serviceRole, additionalInfo: this.additionalInfo, applications: this.applications, autoScalingRole: this.autoScalingRole, autoTerminationPolicy: this.autoTerminationPolicy, bootstrapActions: this.bootstrapActions, configurations: this.configurations, customAmiId: this.customAmiId, ebsRootVolumeSize: this.ebsRootVolumeSize, kerberosAttributes: this.kerberosAttributes, logEncryptionKmsKeyId: this.logEncryptionKmsKeyId, logUri: this.logUri, managedScalingPolicy: this.managedScalingPolicy, osReleaseLabel: this.osReleaseLabel, releaseLabel: this.releaseLabel, scaleDownBehavior: this.scaleDownBehavior, securityConfiguration: this.securityConfiguration, stepConcurrencyLevel: this.stepConcurrencyLevel, steps: this.steps, tags: this.tags.renderTags(), visibleToAllUsers: this.visibleToAllUsers };
      }
      renderProperties(props) {
        return cfnClusterPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnCluster[_a] = { fqn: "aws-cdk-lib.aws_emr.CfnCluster", version: "2.80.0" }, CfnCluster.CFN_RESOURCE_TYPE_NAME = "AWS::EMR::Cluster", exports2.CfnCluster = CfnCluster;
    function CfnCluster_ApplicationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("additionalInfo", cdk.hashValidator(cdk.validateString))(properties.additionalInfo)), errors.collect(cdk.propertyValidator("args", cdk.listValidator(cdk.validateString))(properties.args)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "ApplicationProperty"');
    }
    function cfnClusterApplicationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_ApplicationPropertyValidator(properties).assertSuccess(), { AdditionalInfo: cdk.hashMapper(cdk.stringToCloudFormation)(properties.additionalInfo), Args: cdk.listMapper(cdk.stringToCloudFormation)(properties.args), Name: cdk.stringToCloudFormation(properties.name), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnClusterApplicationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("additionalInfo", "AdditionalInfo", properties.AdditionalInfo != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.AdditionalInfo) : void 0), ret.addPropertyResult("args", "Args", properties.Args != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Args) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getString(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_AutoScalingPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("constraints", cdk.requiredValidator)(properties.constraints)), errors.collect(cdk.propertyValidator("constraints", CfnCluster_ScalingConstraintsPropertyValidator)(properties.constraints)), errors.collect(cdk.propertyValidator("rules", cdk.requiredValidator)(properties.rules)), errors.collect(cdk.propertyValidator("rules", cdk.listValidator(CfnCluster_ScalingRulePropertyValidator))(properties.rules)), errors.wrap('supplied properties not correct for "AutoScalingPolicyProperty"');
    }
    function cfnClusterAutoScalingPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_AutoScalingPolicyPropertyValidator(properties).assertSuccess(), { Constraints: cfnClusterScalingConstraintsPropertyToCloudFormation(properties.constraints), Rules: cdk.listMapper(cfnClusterScalingRulePropertyToCloudFormation)(properties.rules) }) : properties;
    }
    function CfnClusterAutoScalingPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("constraints", "Constraints", CfnClusterScalingConstraintsPropertyFromCloudFormation(properties.Constraints)), ret.addPropertyResult("rules", "Rules", cfn_parse.FromCloudFormation.getArray(CfnClusterScalingRulePropertyFromCloudFormation)(properties.Rules)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_AutoTerminationPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("idleTimeout", cdk.validateNumber)(properties.idleTimeout)), errors.wrap('supplied properties not correct for "AutoTerminationPolicyProperty"');
    }
    function cfnClusterAutoTerminationPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_AutoTerminationPolicyPropertyValidator(properties).assertSuccess(), { IdleTimeout: cdk.numberToCloudFormation(properties.idleTimeout) }) : properties;
    }
    function CfnClusterAutoTerminationPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("idleTimeout", "IdleTimeout", properties.IdleTimeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.IdleTimeout) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_BootstrapActionConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("scriptBootstrapAction", cdk.requiredValidator)(properties.scriptBootstrapAction)), errors.collect(cdk.propertyValidator("scriptBootstrapAction", CfnCluster_ScriptBootstrapActionConfigPropertyValidator)(properties.scriptBootstrapAction)), errors.wrap('supplied properties not correct for "BootstrapActionConfigProperty"');
    }
    function cfnClusterBootstrapActionConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_BootstrapActionConfigPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), ScriptBootstrapAction: cfnClusterScriptBootstrapActionConfigPropertyToCloudFormation(properties.scriptBootstrapAction) }) : properties;
    }
    function CfnClusterBootstrapActionConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("scriptBootstrapAction", "ScriptBootstrapAction", CfnClusterScriptBootstrapActionConfigPropertyFromCloudFormation(properties.ScriptBootstrapAction)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_CloudWatchAlarmDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("comparisonOperator", cdk.requiredValidator)(properties.comparisonOperator)), errors.collect(cdk.propertyValidator("comparisonOperator", cdk.validateString)(properties.comparisonOperator)), errors.collect(cdk.propertyValidator("dimensions", cdk.listValidator(CfnCluster_MetricDimensionPropertyValidator))(properties.dimensions)), errors.collect(cdk.propertyValidator("evaluationPeriods", cdk.validateNumber)(properties.evaluationPeriods)), errors.collect(cdk.propertyValidator("metricName", cdk.requiredValidator)(properties.metricName)), errors.collect(cdk.propertyValidator("metricName", cdk.validateString)(properties.metricName)), errors.collect(cdk.propertyValidator("namespace", cdk.validateString)(properties.namespace)), errors.collect(cdk.propertyValidator("period", cdk.requiredValidator)(properties.period)), errors.collect(cdk.propertyValidator("period", cdk.validateNumber)(properties.period)), errors.collect(cdk.propertyValidator("statistic", cdk.validateString)(properties.statistic)), errors.collect(cdk.propertyValidator("threshold", cdk.requiredValidator)(properties.threshold)), errors.collect(cdk.propertyValidator("threshold", cdk.validateNumber)(properties.threshold)), errors.collect(cdk.propertyValidator("unit", cdk.validateString)(properties.unit)), errors.wrap('supplied properties not correct for "CloudWatchAlarmDefinitionProperty"');
    }
    function cfnClusterCloudWatchAlarmDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_CloudWatchAlarmDefinitionPropertyValidator(properties).assertSuccess(), { ComparisonOperator: cdk.stringToCloudFormation(properties.comparisonOperator), Dimensions: cdk.listMapper(cfnClusterMetricDimensionPropertyToCloudFormation)(properties.dimensions), EvaluationPeriods: cdk.numberToCloudFormation(properties.evaluationPeriods), MetricName: cdk.stringToCloudFormation(properties.metricName), Namespace: cdk.stringToCloudFormation(properties.namespace), Period: cdk.numberToCloudFormation(properties.period), Statistic: cdk.stringToCloudFormation(properties.statistic), Threshold: cdk.numberToCloudFormation(properties.threshold), Unit: cdk.stringToCloudFormation(properties.unit) }) : properties;
    }
    function CfnClusterCloudWatchAlarmDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("comparisonOperator", "ComparisonOperator", cfn_parse.FromCloudFormation.getString(properties.ComparisonOperator)), ret.addPropertyResult("dimensions", "Dimensions", properties.Dimensions != null ? cfn_parse.FromCloudFormation.getArray(CfnClusterMetricDimensionPropertyFromCloudFormation)(properties.Dimensions) : void 0), ret.addPropertyResult("evaluationPeriods", "EvaluationPeriods", properties.EvaluationPeriods != null ? cfn_parse.FromCloudFormation.getNumber(properties.EvaluationPeriods) : void 0), ret.addPropertyResult("metricName", "MetricName", cfn_parse.FromCloudFormation.getString(properties.MetricName)), ret.addPropertyResult("namespace", "Namespace", properties.Namespace != null ? cfn_parse.FromCloudFormation.getString(properties.Namespace) : void 0), ret.addPropertyResult("period", "Period", cfn_parse.FromCloudFormation.getNumber(properties.Period)), ret.addPropertyResult("statistic", "Statistic", properties.Statistic != null ? cfn_parse.FromCloudFormation.getString(properties.Statistic) : void 0), ret.addPropertyResult("threshold", "Threshold", cfn_parse.FromCloudFormation.getNumber(properties.Threshold)), ret.addPropertyResult("unit", "Unit", properties.Unit != null ? cfn_parse.FromCloudFormation.getString(properties.Unit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_ComputeLimitsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maximumCapacityUnits", cdk.requiredValidator)(properties.maximumCapacityUnits)), errors.collect(cdk.propertyValidator("maximumCapacityUnits", cdk.validateNumber)(properties.maximumCapacityUnits)), errors.collect(cdk.propertyValidator("maximumCoreCapacityUnits", cdk.validateNumber)(properties.maximumCoreCapacityUnits)), errors.collect(cdk.propertyValidator("maximumOnDemandCapacityUnits", cdk.validateNumber)(properties.maximumOnDemandCapacityUnits)), errors.collect(cdk.propertyValidator("minimumCapacityUnits", cdk.requiredValidator)(properties.minimumCapacityUnits)), errors.collect(cdk.propertyValidator("minimumCapacityUnits", cdk.validateNumber)(properties.minimumCapacityUnits)), errors.collect(cdk.propertyValidator("unitType", cdk.requiredValidator)(properties.unitType)), errors.collect(cdk.propertyValidator("unitType", cdk.validateString)(properties.unitType)), errors.wrap('supplied properties not correct for "ComputeLimitsProperty"');
    }
    function cfnClusterComputeLimitsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_ComputeLimitsPropertyValidator(properties).assertSuccess(), { MaximumCapacityUnits: cdk.numberToCloudFormation(properties.maximumCapacityUnits), MaximumCoreCapacityUnits: cdk.numberToCloudFormation(properties.maximumCoreCapacityUnits), MaximumOnDemandCapacityUnits: cdk.numberToCloudFormation(properties.maximumOnDemandCapacityUnits), MinimumCapacityUnits: cdk.numberToCloudFormation(properties.minimumCapacityUnits), UnitType: cdk.stringToCloudFormation(properties.unitType) }) : properties;
    }
    function CfnClusterComputeLimitsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maximumCapacityUnits", "MaximumCapacityUnits", cfn_parse.FromCloudFormation.getNumber(properties.MaximumCapacityUnits)), ret.addPropertyResult("maximumCoreCapacityUnits", "MaximumCoreCapacityUnits", properties.MaximumCoreCapacityUnits != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumCoreCapacityUnits) : void 0), ret.addPropertyResult("maximumOnDemandCapacityUnits", "MaximumOnDemandCapacityUnits", properties.MaximumOnDemandCapacityUnits != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumOnDemandCapacityUnits) : void 0), ret.addPropertyResult("minimumCapacityUnits", "MinimumCapacityUnits", cfn_parse.FromCloudFormation.getNumber(properties.MinimumCapacityUnits)), ret.addPropertyResult("unitType", "UnitType", cfn_parse.FromCloudFormation.getString(properties.UnitType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_ConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("classification", cdk.validateString)(properties.classification)), errors.collect(cdk.propertyValidator("configurationProperties", cdk.hashValidator(cdk.validateString))(properties.configurationProperties)), errors.collect(cdk.propertyValidator("configurations", cdk.listValidator(CfnCluster_ConfigurationPropertyValidator))(properties.configurations)), errors.wrap('supplied properties not correct for "ConfigurationProperty"');
    }
    function cfnClusterConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_ConfigurationPropertyValidator(properties).assertSuccess(), { Classification: cdk.stringToCloudFormation(properties.classification), ConfigurationProperties: cdk.hashMapper(cdk.stringToCloudFormation)(properties.configurationProperties), Configurations: cdk.listMapper(cfnClusterConfigurationPropertyToCloudFormation)(properties.configurations) }) : properties;
    }
    function CfnClusterConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("classification", "Classification", properties.Classification != null ? cfn_parse.FromCloudFormation.getString(properties.Classification) : void 0), ret.addPropertyResult("configurationProperties", "ConfigurationProperties", properties.ConfigurationProperties != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.ConfigurationProperties) : void 0), ret.addPropertyResult("configurations", "Configurations", properties.Configurations != null ? cfn_parse.FromCloudFormation.getArray(CfnClusterConfigurationPropertyFromCloudFormation)(properties.Configurations) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_EbsBlockDeviceConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("volumeSpecification", cdk.requiredValidator)(properties.volumeSpecification)), errors.collect(cdk.propertyValidator("volumeSpecification", CfnCluster_VolumeSpecificationPropertyValidator)(properties.volumeSpecification)), errors.collect(cdk.propertyValidator("volumesPerInstance", cdk.validateNumber)(properties.volumesPerInstance)), errors.wrap('supplied properties not correct for "EbsBlockDeviceConfigProperty"');
    }
    function cfnClusterEbsBlockDeviceConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_EbsBlockDeviceConfigPropertyValidator(properties).assertSuccess(), { VolumeSpecification: cfnClusterVolumeSpecificationPropertyToCloudFormation(properties.volumeSpecification), VolumesPerInstance: cdk.numberToCloudFormation(properties.volumesPerInstance) }) : properties;
    }
    function CfnClusterEbsBlockDeviceConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("volumeSpecification", "VolumeSpecification", CfnClusterVolumeSpecificationPropertyFromCloudFormation(properties.VolumeSpecification)), ret.addPropertyResult("volumesPerInstance", "VolumesPerInstance", properties.VolumesPerInstance != null ? cfn_parse.FromCloudFormation.getNumber(properties.VolumesPerInstance) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_EbsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ebsBlockDeviceConfigs", cdk.listValidator(CfnCluster_EbsBlockDeviceConfigPropertyValidator))(properties.ebsBlockDeviceConfigs)), errors.collect(cdk.propertyValidator("ebsOptimized", cdk.validateBoolean)(properties.ebsOptimized)), errors.wrap('supplied properties not correct for "EbsConfigurationProperty"');
    }
    function cfnClusterEbsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_EbsConfigurationPropertyValidator(properties).assertSuccess(), { EbsBlockDeviceConfigs: cdk.listMapper(cfnClusterEbsBlockDeviceConfigPropertyToCloudFormation)(properties.ebsBlockDeviceConfigs), EbsOptimized: cdk.booleanToCloudFormation(properties.ebsOptimized) }) : properties;
    }
    function CfnClusterEbsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ebsBlockDeviceConfigs", "EbsBlockDeviceConfigs", properties.EbsBlockDeviceConfigs != null ? cfn_parse.FromCloudFormation.getArray(CfnClusterEbsBlockDeviceConfigPropertyFromCloudFormation)(properties.EbsBlockDeviceConfigs) : void 0), ret.addPropertyResult("ebsOptimized", "EbsOptimized", properties.EbsOptimized != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EbsOptimized) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_HadoopJarStepConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("args", cdk.listValidator(cdk.validateString))(properties.args)), errors.collect(cdk.propertyValidator("jar", cdk.requiredValidator)(properties.jar)), errors.collect(cdk.propertyValidator("jar", cdk.validateString)(properties.jar)), errors.collect(cdk.propertyValidator("mainClass", cdk.validateString)(properties.mainClass)), errors.collect(cdk.propertyValidator("stepProperties", cdk.listValidator(CfnCluster_KeyValuePropertyValidator))(properties.stepProperties)), errors.wrap('supplied properties not correct for "HadoopJarStepConfigProperty"');
    }
    function cfnClusterHadoopJarStepConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_HadoopJarStepConfigPropertyValidator(properties).assertSuccess(), { Args: cdk.listMapper(cdk.stringToCloudFormation)(properties.args), Jar: cdk.stringToCloudFormation(properties.jar), MainClass: cdk.stringToCloudFormation(properties.mainClass), StepProperties: cdk.listMapper(cfnClusterKeyValuePropertyToCloudFormation)(properties.stepProperties) }) : properties;
    }
    function CfnClusterHadoopJarStepConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("args", "Args", properties.Args != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Args) : void 0), ret.addPropertyResult("jar", "Jar", cfn_parse.FromCloudFormation.getString(properties.Jar)), ret.addPropertyResult("mainClass", "MainClass", properties.MainClass != null ? cfn_parse.FromCloudFormation.getString(properties.MainClass) : void 0), ret.addPropertyResult("stepProperties", "StepProperties", properties.StepProperties != null ? cfn_parse.FromCloudFormation.getArray(CfnClusterKeyValuePropertyFromCloudFormation)(properties.StepProperties) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_InstanceFleetConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceTypeConfigs", cdk.listValidator(CfnCluster_InstanceTypeConfigPropertyValidator))(properties.instanceTypeConfigs)), errors.collect(cdk.propertyValidator("launchSpecifications", CfnCluster_InstanceFleetProvisioningSpecificationsPropertyValidator)(properties.launchSpecifications)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("targetOnDemandCapacity", cdk.validateNumber)(properties.targetOnDemandCapacity)), errors.collect(cdk.propertyValidator("targetSpotCapacity", cdk.validateNumber)(properties.targetSpotCapacity)), errors.wrap('supplied properties not correct for "InstanceFleetConfigProperty"');
    }
    function cfnClusterInstanceFleetConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_InstanceFleetConfigPropertyValidator(properties).assertSuccess(), { InstanceTypeConfigs: cdk.listMapper(cfnClusterInstanceTypeConfigPropertyToCloudFormation)(properties.instanceTypeConfigs), LaunchSpecifications: cfnClusterInstanceFleetProvisioningSpecificationsPropertyToCloudFormation(properties.launchSpecifications), Name: cdk.stringToCloudFormation(properties.name), TargetOnDemandCapacity: cdk.numberToCloudFormation(properties.targetOnDemandCapacity), TargetSpotCapacity: cdk.numberToCloudFormation(properties.targetSpotCapacity) }) : properties;
    }
    function CfnClusterInstanceFleetConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceTypeConfigs", "InstanceTypeConfigs", properties.InstanceTypeConfigs != null ? cfn_parse.FromCloudFormation.getArray(CfnClusterInstanceTypeConfigPropertyFromCloudFormation)(properties.InstanceTypeConfigs) : void 0), ret.addPropertyResult("launchSpecifications", "LaunchSpecifications", properties.LaunchSpecifications != null ? CfnClusterInstanceFleetProvisioningSpecificationsPropertyFromCloudFormation(properties.LaunchSpecifications) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("targetOnDemandCapacity", "TargetOnDemandCapacity", properties.TargetOnDemandCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.TargetOnDemandCapacity) : void 0), ret.addPropertyResult("targetSpotCapacity", "TargetSpotCapacity", properties.TargetSpotCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.TargetSpotCapacity) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_InstanceFleetProvisioningSpecificationsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("onDemandSpecification", CfnCluster_OnDemandProvisioningSpecificationPropertyValidator)(properties.onDemandSpecification)), errors.collect(cdk.propertyValidator("spotSpecification", CfnCluster_SpotProvisioningSpecificationPropertyValidator)(properties.spotSpecification)), errors.wrap('supplied properties not correct for "InstanceFleetProvisioningSpecificationsProperty"');
    }
    function cfnClusterInstanceFleetProvisioningSpecificationsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_InstanceFleetProvisioningSpecificationsPropertyValidator(properties).assertSuccess(), { OnDemandSpecification: cfnClusterOnDemandProvisioningSpecificationPropertyToCloudFormation(properties.onDemandSpecification), SpotSpecification: cfnClusterSpotProvisioningSpecificationPropertyToCloudFormation(properties.spotSpecification) }) : properties;
    }
    function CfnClusterInstanceFleetProvisioningSpecificationsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("onDemandSpecification", "OnDemandSpecification", properties.OnDemandSpecification != null ? CfnClusterOnDemandProvisioningSpecificationPropertyFromCloudFormation(properties.OnDemandSpecification) : void 0), ret.addPropertyResult("spotSpecification", "SpotSpecification", properties.SpotSpecification != null ? CfnClusterSpotProvisioningSpecificationPropertyFromCloudFormation(properties.SpotSpecification) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_InstanceGroupConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoScalingPolicy", CfnCluster_AutoScalingPolicyPropertyValidator)(properties.autoScalingPolicy)), errors.collect(cdk.propertyValidator("bidPrice", cdk.validateString)(properties.bidPrice)), errors.collect(cdk.propertyValidator("configurations", cdk.listValidator(CfnCluster_ConfigurationPropertyValidator))(properties.configurations)), errors.collect(cdk.propertyValidator("customAmiId", cdk.validateString)(properties.customAmiId)), errors.collect(cdk.propertyValidator("ebsConfiguration", CfnCluster_EbsConfigurationPropertyValidator)(properties.ebsConfiguration)), errors.collect(cdk.propertyValidator("instanceCount", cdk.requiredValidator)(properties.instanceCount)), errors.collect(cdk.propertyValidator("instanceCount", cdk.validateNumber)(properties.instanceCount)), errors.collect(cdk.propertyValidator("instanceType", cdk.requiredValidator)(properties.instanceType)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("market", cdk.validateString)(properties.market)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "InstanceGroupConfigProperty"');
    }
    function cfnClusterInstanceGroupConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_InstanceGroupConfigPropertyValidator(properties).assertSuccess(), { AutoScalingPolicy: cfnClusterAutoScalingPolicyPropertyToCloudFormation(properties.autoScalingPolicy), BidPrice: cdk.stringToCloudFormation(properties.bidPrice), Configurations: cdk.listMapper(cfnClusterConfigurationPropertyToCloudFormation)(properties.configurations), CustomAmiId: cdk.stringToCloudFormation(properties.customAmiId), EbsConfiguration: cfnClusterEbsConfigurationPropertyToCloudFormation(properties.ebsConfiguration), InstanceCount: cdk.numberToCloudFormation(properties.instanceCount), InstanceType: cdk.stringToCloudFormation(properties.instanceType), Market: cdk.stringToCloudFormation(properties.market), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnClusterInstanceGroupConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("autoScalingPolicy", "AutoScalingPolicy", properties.AutoScalingPolicy != null ? CfnClusterAutoScalingPolicyPropertyFromCloudFormation(properties.AutoScalingPolicy) : void 0), ret.addPropertyResult("bidPrice", "BidPrice", properties.BidPrice != null ? cfn_parse.FromCloudFormation.getString(properties.BidPrice) : void 0), ret.addPropertyResult("configurations", "Configurations", properties.Configurations != null ? cfn_parse.FromCloudFormation.getArray(CfnClusterConfigurationPropertyFromCloudFormation)(properties.Configurations) : void 0), ret.addPropertyResult("customAmiId", "CustomAmiId", properties.CustomAmiId != null ? cfn_parse.FromCloudFormation.getString(properties.CustomAmiId) : void 0), ret.addPropertyResult("ebsConfiguration", "EbsConfiguration", properties.EbsConfiguration != null ? CfnClusterEbsConfigurationPropertyFromCloudFormation(properties.EbsConfiguration) : void 0), ret.addPropertyResult("instanceCount", "InstanceCount", cfn_parse.FromCloudFormation.getNumber(properties.InstanceCount)), ret.addPropertyResult("instanceType", "InstanceType", cfn_parse.FromCloudFormation.getString(properties.InstanceType)), ret.addPropertyResult("market", "Market", properties.Market != null ? cfn_parse.FromCloudFormation.getString(properties.Market) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_InstanceTypeConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bidPrice", cdk.validateString)(properties.bidPrice)), errors.collect(cdk.propertyValidator("bidPriceAsPercentageOfOnDemandPrice", cdk.validateNumber)(properties.bidPriceAsPercentageOfOnDemandPrice)), errors.collect(cdk.propertyValidator("configurations", cdk.listValidator(CfnCluster_ConfigurationPropertyValidator))(properties.configurations)), errors.collect(cdk.propertyValidator("customAmiId", cdk.validateString)(properties.customAmiId)), errors.collect(cdk.propertyValidator("ebsConfiguration", CfnCluster_EbsConfigurationPropertyValidator)(properties.ebsConfiguration)), errors.collect(cdk.propertyValidator("instanceType", cdk.requiredValidator)(properties.instanceType)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("weightedCapacity", cdk.validateNumber)(properties.weightedCapacity)), errors.wrap('supplied properties not correct for "InstanceTypeConfigProperty"');
    }
    function cfnClusterInstanceTypeConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_InstanceTypeConfigPropertyValidator(properties).assertSuccess(), { BidPrice: cdk.stringToCloudFormation(properties.bidPrice), BidPriceAsPercentageOfOnDemandPrice: cdk.numberToCloudFormation(properties.bidPriceAsPercentageOfOnDemandPrice), Configurations: cdk.listMapper(cfnClusterConfigurationPropertyToCloudFormation)(properties.configurations), CustomAmiId: cdk.stringToCloudFormation(properties.customAmiId), EbsConfiguration: cfnClusterEbsConfigurationPropertyToCloudFormation(properties.ebsConfiguration), InstanceType: cdk.stringToCloudFormation(properties.instanceType), WeightedCapacity: cdk.numberToCloudFormation(properties.weightedCapacity) }) : properties;
    }
    function CfnClusterInstanceTypeConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bidPrice", "BidPrice", properties.BidPrice != null ? cfn_parse.FromCloudFormation.getString(properties.BidPrice) : void 0), ret.addPropertyResult("bidPriceAsPercentageOfOnDemandPrice", "BidPriceAsPercentageOfOnDemandPrice", properties.BidPriceAsPercentageOfOnDemandPrice != null ? cfn_parse.FromCloudFormation.getNumber(properties.BidPriceAsPercentageOfOnDemandPrice) : void 0), ret.addPropertyResult("configurations", "Configurations", properties.Configurations != null ? cfn_parse.FromCloudFormation.getArray(CfnClusterConfigurationPropertyFromCloudFormation)(properties.Configurations) : void 0), ret.addPropertyResult("customAmiId", "CustomAmiId", properties.CustomAmiId != null ? cfn_parse.FromCloudFormation.getString(properties.CustomAmiId) : void 0), ret.addPropertyResult("ebsConfiguration", "EbsConfiguration", properties.EbsConfiguration != null ? CfnClusterEbsConfigurationPropertyFromCloudFormation(properties.EbsConfiguration) : void 0), ret.addPropertyResult("instanceType", "InstanceType", cfn_parse.FromCloudFormation.getString(properties.InstanceType)), ret.addPropertyResult("weightedCapacity", "WeightedCapacity", properties.WeightedCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.WeightedCapacity) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_JobFlowInstancesConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("additionalMasterSecurityGroups", cdk.listValidator(cdk.validateString))(properties.additionalMasterSecurityGroups)), errors.collect(cdk.propertyValidator("additionalSlaveSecurityGroups", cdk.listValidator(cdk.validateString))(properties.additionalSlaveSecurityGroups)), errors.collect(cdk.propertyValidator("coreInstanceFleet", CfnCluster_InstanceFleetConfigPropertyValidator)(properties.coreInstanceFleet)), errors.collect(cdk.propertyValidator("coreInstanceGroup", CfnCluster_InstanceGroupConfigPropertyValidator)(properties.coreInstanceGroup)), errors.collect(cdk.propertyValidator("ec2KeyName", cdk.validateString)(properties.ec2KeyName)), errors.collect(cdk.propertyValidator("ec2SubnetId", cdk.validateString)(properties.ec2SubnetId)), errors.collect(cdk.propertyValidator("ec2SubnetIds", cdk.listValidator(cdk.validateString))(properties.ec2SubnetIds)), errors.collect(cdk.propertyValidator("emrManagedMasterSecurityGroup", cdk.validateString)(properties.emrManagedMasterSecurityGroup)), errors.collect(cdk.propertyValidator("emrManagedSlaveSecurityGroup", cdk.validateString)(properties.emrManagedSlaveSecurityGroup)), errors.collect(cdk.propertyValidator("hadoopVersion", cdk.validateString)(properties.hadoopVersion)), errors.collect(cdk.propertyValidator("keepJobFlowAliveWhenNoSteps", cdk.validateBoolean)(properties.keepJobFlowAliveWhenNoSteps)), errors.collect(cdk.propertyValidator("masterInstanceFleet", CfnCluster_InstanceFleetConfigPropertyValidator)(properties.masterInstanceFleet)), errors.collect(cdk.propertyValidator("masterInstanceGroup", CfnCluster_InstanceGroupConfigPropertyValidator)(properties.masterInstanceGroup)), errors.collect(cdk.propertyValidator("placement", CfnCluster_PlacementTypePropertyValidator)(properties.placement)), errors.collect(cdk.propertyValidator("serviceAccessSecurityGroup", cdk.validateString)(properties.serviceAccessSecurityGroup)), errors.collect(cdk.propertyValidator("taskInstanceFleets", cdk.listValidator(CfnCluster_InstanceFleetConfigPropertyValidator))(properties.taskInstanceFleets)), errors.collect(cdk.propertyValidator("taskInstanceGroups", cdk.listValidator(CfnCluster_InstanceGroupConfigPropertyValidator))(properties.taskInstanceGroups)), errors.collect(cdk.propertyValidator("terminationProtected", cdk.validateBoolean)(properties.terminationProtected)), errors.wrap('supplied properties not correct for "JobFlowInstancesConfigProperty"');
    }
    function cfnClusterJobFlowInstancesConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_JobFlowInstancesConfigPropertyValidator(properties).assertSuccess(), { AdditionalMasterSecurityGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.additionalMasterSecurityGroups), AdditionalSlaveSecurityGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.additionalSlaveSecurityGroups), CoreInstanceFleet: cfnClusterInstanceFleetConfigPropertyToCloudFormation(properties.coreInstanceFleet), CoreInstanceGroup: cfnClusterInstanceGroupConfigPropertyToCloudFormation(properties.coreInstanceGroup), Ec2KeyName: cdk.stringToCloudFormation(properties.ec2KeyName), Ec2SubnetId: cdk.stringToCloudFormation(properties.ec2SubnetId), Ec2SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.ec2SubnetIds), EmrManagedMasterSecurityGroup: cdk.stringToCloudFormation(properties.emrManagedMasterSecurityGroup), EmrManagedSlaveSecurityGroup: cdk.stringToCloudFormation(properties.emrManagedSlaveSecurityGroup), HadoopVersion: cdk.stringToCloudFormation(properties.hadoopVersion), KeepJobFlowAliveWhenNoSteps: cdk.booleanToCloudFormation(properties.keepJobFlowAliveWhenNoSteps), MasterInstanceFleet: cfnClusterInstanceFleetConfigPropertyToCloudFormation(properties.masterInstanceFleet), MasterInstanceGroup: cfnClusterInstanceGroupConfigPropertyToCloudFormation(properties.masterInstanceGroup), Placement: cfnClusterPlacementTypePropertyToCloudFormation(properties.placement), ServiceAccessSecurityGroup: cdk.stringToCloudFormation(properties.serviceAccessSecurityGroup), TaskInstanceFleets: cdk.listMapper(cfnClusterInstanceFleetConfigPropertyToCloudFormation)(properties.taskInstanceFleets), TaskInstanceGroups: cdk.listMapper(cfnClusterInstanceGroupConfigPropertyToCloudFormation)(properties.taskInstanceGroups), TerminationProtected: cdk.booleanToCloudFormation(properties.terminationProtected) }) : properties;
    }
    function CfnClusterJobFlowInstancesConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("additionalMasterSecurityGroups", "AdditionalMasterSecurityGroups", properties.AdditionalMasterSecurityGroups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AdditionalMasterSecurityGroups) : void 0), ret.addPropertyResult("additionalSlaveSecurityGroups", "AdditionalSlaveSecurityGroups", properties.AdditionalSlaveSecurityGroups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AdditionalSlaveSecurityGroups) : void 0), ret.addPropertyResult("coreInstanceFleet", "CoreInstanceFleet", properties.CoreInstanceFleet != null ? CfnClusterInstanceFleetConfigPropertyFromCloudFormation(properties.CoreInstanceFleet) : void 0), ret.addPropertyResult("coreInstanceGroup", "CoreInstanceGroup", properties.CoreInstanceGroup != null ? CfnClusterInstanceGroupConfigPropertyFromCloudFormation(properties.CoreInstanceGroup) : void 0), ret.addPropertyResult("ec2KeyName", "Ec2KeyName", properties.Ec2KeyName != null ? cfn_parse.FromCloudFormation.getString(properties.Ec2KeyName) : void 0), ret.addPropertyResult("ec2SubnetId", "Ec2SubnetId", properties.Ec2SubnetId != null ? cfn_parse.FromCloudFormation.getString(properties.Ec2SubnetId) : void 0), ret.addPropertyResult("ec2SubnetIds", "Ec2SubnetIds", properties.Ec2SubnetIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Ec2SubnetIds) : void 0), ret.addPropertyResult("emrManagedMasterSecurityGroup", "EmrManagedMasterSecurityGroup", properties.EmrManagedMasterSecurityGroup != null ? cfn_parse.FromCloudFormation.getString(properties.EmrManagedMasterSecurityGroup) : void 0), ret.addPropertyResult("emrManagedSlaveSecurityGroup", "EmrManagedSlaveSecurityGroup", properties.EmrManagedSlaveSecurityGroup != null ? cfn_parse.FromCloudFormation.getString(properties.EmrManagedSlaveSecurityGroup) : void 0), ret.addPropertyResult("hadoopVersion", "HadoopVersion", properties.HadoopVersion != null ? cfn_parse.FromCloudFormation.getString(properties.HadoopVersion) : void 0), ret.addPropertyResult("keepJobFlowAliveWhenNoSteps", "KeepJobFlowAliveWhenNoSteps", properties.KeepJobFlowAliveWhenNoSteps != null ? cfn_parse.FromCloudFormation.getBoolean(properties.KeepJobFlowAliveWhenNoSteps) : void 0), ret.addPropertyResult("masterInstanceFleet", "MasterInstanceFleet", properties.MasterInstanceFleet != null ? CfnClusterInstanceFleetConfigPropertyFromCloudFormation(properties.MasterInstanceFleet) : void 0), ret.addPropertyResult("masterInstanceGroup", "MasterInstanceGroup", properties.MasterInstanceGroup != null ? CfnClusterInstanceGroupConfigPropertyFromCloudFormation(properties.MasterInstanceGroup) : void 0), ret.addPropertyResult("placement", "Placement", properties.Placement != null ? CfnClusterPlacementTypePropertyFromCloudFormation(properties.Placement) : void 0), ret.addPropertyResult("serviceAccessSecurityGroup", "ServiceAccessSecurityGroup", properties.ServiceAccessSecurityGroup != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceAccessSecurityGroup) : void 0), ret.addPropertyResult("taskInstanceFleets", "TaskInstanceFleets", properties.TaskInstanceFleets != null ? cfn_parse.FromCloudFormation.getArray(CfnClusterInstanceFleetConfigPropertyFromCloudFormation)(properties.TaskInstanceFleets) : void 0), ret.addPropertyResult("taskInstanceGroups", "TaskInstanceGroups", properties.TaskInstanceGroups != null ? cfn_parse.FromCloudFormation.getArray(CfnClusterInstanceGroupConfigPropertyFromCloudFormation)(properties.TaskInstanceGroups) : void 0), ret.addPropertyResult("terminationProtected", "TerminationProtected", properties.TerminationProtected != null ? cfn_parse.FromCloudFormation.getBoolean(properties.TerminationProtected) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_KerberosAttributesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("adDomainJoinPassword", cdk.validateString)(properties.adDomainJoinPassword)), errors.collect(cdk.propertyValidator("adDomainJoinUser", cdk.validateString)(properties.adDomainJoinUser)), errors.collect(cdk.propertyValidator("crossRealmTrustPrincipalPassword", cdk.validateString)(properties.crossRealmTrustPrincipalPassword)), errors.collect(cdk.propertyValidator("kdcAdminPassword", cdk.requiredValidator)(properties.kdcAdminPassword)), errors.collect(cdk.propertyValidator("kdcAdminPassword", cdk.validateString)(properties.kdcAdminPassword)), errors.collect(cdk.propertyValidator("realm", cdk.requiredValidator)(properties.realm)), errors.collect(cdk.propertyValidator("realm", cdk.validateString)(properties.realm)), errors.wrap('supplied properties not correct for "KerberosAttributesProperty"');
    }
    function cfnClusterKerberosAttributesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_KerberosAttributesPropertyValidator(properties).assertSuccess(), { ADDomainJoinPassword: cdk.stringToCloudFormation(properties.adDomainJoinPassword), ADDomainJoinUser: cdk.stringToCloudFormation(properties.adDomainJoinUser), CrossRealmTrustPrincipalPassword: cdk.stringToCloudFormation(properties.crossRealmTrustPrincipalPassword), KdcAdminPassword: cdk.stringToCloudFormation(properties.kdcAdminPassword), Realm: cdk.stringToCloudFormation(properties.realm) }) : properties;
    }
    function CfnClusterKerberosAttributesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("adDomainJoinPassword", "ADDomainJoinPassword", properties.ADDomainJoinPassword != null ? cfn_parse.FromCloudFormation.getString(properties.ADDomainJoinPassword) : void 0), ret.addPropertyResult("adDomainJoinUser", "ADDomainJoinUser", properties.ADDomainJoinUser != null ? cfn_parse.FromCloudFormation.getString(properties.ADDomainJoinUser) : void 0), ret.addPropertyResult("crossRealmTrustPrincipalPassword", "CrossRealmTrustPrincipalPassword", properties.CrossRealmTrustPrincipalPassword != null ? cfn_parse.FromCloudFormation.getString(properties.CrossRealmTrustPrincipalPassword) : void 0), ret.addPropertyResult("kdcAdminPassword", "KdcAdminPassword", cfn_parse.FromCloudFormation.getString(properties.KdcAdminPassword)), ret.addPropertyResult("realm", "Realm", cfn_parse.FromCloudFormation.getString(properties.Realm)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_KeyValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "KeyValueProperty"');
    }
    function cfnClusterKeyValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_KeyValuePropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnClusterKeyValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_ManagedScalingPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computeLimits", CfnCluster_ComputeLimitsPropertyValidator)(properties.computeLimits)), errors.wrap('supplied properties not correct for "ManagedScalingPolicyProperty"');
    }
    function cfnClusterManagedScalingPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_ManagedScalingPolicyPropertyValidator(properties).assertSuccess(), { ComputeLimits: cfnClusterComputeLimitsPropertyToCloudFormation(properties.computeLimits) }) : properties;
    }
    function CfnClusterManagedScalingPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computeLimits", "ComputeLimits", properties.ComputeLimits != null ? CfnClusterComputeLimitsPropertyFromCloudFormation(properties.ComputeLimits) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_MetricDimensionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "MetricDimensionProperty"');
    }
    function cfnClusterMetricDimensionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_MetricDimensionPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnClusterMetricDimensionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_OnDemandProvisioningSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allocationStrategy", cdk.requiredValidator)(properties.allocationStrategy)), errors.collect(cdk.propertyValidator("allocationStrategy", cdk.validateString)(properties.allocationStrategy)), errors.wrap('supplied properties not correct for "OnDemandProvisioningSpecificationProperty"');
    }
    function cfnClusterOnDemandProvisioningSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_OnDemandProvisioningSpecificationPropertyValidator(properties).assertSuccess(), { AllocationStrategy: cdk.stringToCloudFormation(properties.allocationStrategy) }) : properties;
    }
    function CfnClusterOnDemandProvisioningSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allocationStrategy", "AllocationStrategy", cfn_parse.FromCloudFormation.getString(properties.AllocationStrategy)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_PlacementTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availabilityZone", cdk.requiredValidator)(properties.availabilityZone)), errors.collect(cdk.propertyValidator("availabilityZone", cdk.validateString)(properties.availabilityZone)), errors.wrap('supplied properties not correct for "PlacementTypeProperty"');
    }
    function cfnClusterPlacementTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_PlacementTypePropertyValidator(properties).assertSuccess(), { AvailabilityZone: cdk.stringToCloudFormation(properties.availabilityZone) }) : properties;
    }
    function CfnClusterPlacementTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("availabilityZone", "AvailabilityZone", cfn_parse.FromCloudFormation.getString(properties.AvailabilityZone)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_ScalingActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("market", cdk.validateString)(properties.market)), errors.collect(cdk.propertyValidator("simpleScalingPolicyConfiguration", cdk.requiredValidator)(properties.simpleScalingPolicyConfiguration)), errors.collect(cdk.propertyValidator("simpleScalingPolicyConfiguration", CfnCluster_SimpleScalingPolicyConfigurationPropertyValidator)(properties.simpleScalingPolicyConfiguration)), errors.wrap('supplied properties not correct for "ScalingActionProperty"');
    }
    function cfnClusterScalingActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_ScalingActionPropertyValidator(properties).assertSuccess(), { Market: cdk.stringToCloudFormation(properties.market), SimpleScalingPolicyConfiguration: cfnClusterSimpleScalingPolicyConfigurationPropertyToCloudFormation(properties.simpleScalingPolicyConfiguration) }) : properties;
    }
    function CfnClusterScalingActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("market", "Market", properties.Market != null ? cfn_parse.FromCloudFormation.getString(properties.Market) : void 0), ret.addPropertyResult("simpleScalingPolicyConfiguration", "SimpleScalingPolicyConfiguration", CfnClusterSimpleScalingPolicyConfigurationPropertyFromCloudFormation(properties.SimpleScalingPolicyConfiguration)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_ScalingConstraintsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxCapacity", cdk.requiredValidator)(properties.maxCapacity)), errors.collect(cdk.propertyValidator("maxCapacity", cdk.validateNumber)(properties.maxCapacity)), errors.collect(cdk.propertyValidator("minCapacity", cdk.requiredValidator)(properties.minCapacity)), errors.collect(cdk.propertyValidator("minCapacity", cdk.validateNumber)(properties.minCapacity)), errors.wrap('supplied properties not correct for "ScalingConstraintsProperty"');
    }
    function cfnClusterScalingConstraintsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_ScalingConstraintsPropertyValidator(properties).assertSuccess(), { MaxCapacity: cdk.numberToCloudFormation(properties.maxCapacity), MinCapacity: cdk.numberToCloudFormation(properties.minCapacity) }) : properties;
    }
    function CfnClusterScalingConstraintsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxCapacity", "MaxCapacity", cfn_parse.FromCloudFormation.getNumber(properties.MaxCapacity)), ret.addPropertyResult("minCapacity", "MinCapacity", cfn_parse.FromCloudFormation.getNumber(properties.MinCapacity)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_ScalingRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.requiredValidator)(properties.action)), errors.collect(cdk.propertyValidator("action", CfnCluster_ScalingActionPropertyValidator)(properties.action)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("trigger", cdk.requiredValidator)(properties.trigger)), errors.collect(cdk.propertyValidator("trigger", CfnCluster_ScalingTriggerPropertyValidator)(properties.trigger)), errors.wrap('supplied properties not correct for "ScalingRuleProperty"');
    }
    function cfnClusterScalingRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_ScalingRulePropertyValidator(properties).assertSuccess(), { Action: cfnClusterScalingActionPropertyToCloudFormation(properties.action), Description: cdk.stringToCloudFormation(properties.description), Name: cdk.stringToCloudFormation(properties.name), Trigger: cfnClusterScalingTriggerPropertyToCloudFormation(properties.trigger) }) : properties;
    }
    function CfnClusterScalingRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", CfnClusterScalingActionPropertyFromCloudFormation(properties.Action)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("trigger", "Trigger", CfnClusterScalingTriggerPropertyFromCloudFormation(properties.Trigger)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_ScalingTriggerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchAlarmDefinition", cdk.requiredValidator)(properties.cloudWatchAlarmDefinition)), errors.collect(cdk.propertyValidator("cloudWatchAlarmDefinition", CfnCluster_CloudWatchAlarmDefinitionPropertyValidator)(properties.cloudWatchAlarmDefinition)), errors.wrap('supplied properties not correct for "ScalingTriggerProperty"');
    }
    function cfnClusterScalingTriggerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_ScalingTriggerPropertyValidator(properties).assertSuccess(), { CloudWatchAlarmDefinition: cfnClusterCloudWatchAlarmDefinitionPropertyToCloudFormation(properties.cloudWatchAlarmDefinition) }) : properties;
    }
    function CfnClusterScalingTriggerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchAlarmDefinition", "CloudWatchAlarmDefinition", CfnClusterCloudWatchAlarmDefinitionPropertyFromCloudFormation(properties.CloudWatchAlarmDefinition)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_ScriptBootstrapActionConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("args", cdk.listValidator(cdk.validateString))(properties.args)), errors.collect(cdk.propertyValidator("path", cdk.requiredValidator)(properties.path)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.wrap('supplied properties not correct for "ScriptBootstrapActionConfigProperty"');
    }
    function cfnClusterScriptBootstrapActionConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_ScriptBootstrapActionConfigPropertyValidator(properties).assertSuccess(), { Args: cdk.listMapper(cdk.stringToCloudFormation)(properties.args), Path: cdk.stringToCloudFormation(properties.path) }) : properties;
    }
    function CfnClusterScriptBootstrapActionConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("args", "Args", properties.Args != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Args) : void 0), ret.addPropertyResult("path", "Path", cfn_parse.FromCloudFormation.getString(properties.Path)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_SimpleScalingPolicyConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("adjustmentType", cdk.validateString)(properties.adjustmentType)), errors.collect(cdk.propertyValidator("coolDown", cdk.validateNumber)(properties.coolDown)), errors.collect(cdk.propertyValidator("scalingAdjustment", cdk.requiredValidator)(properties.scalingAdjustment)), errors.collect(cdk.propertyValidator("scalingAdjustment", cdk.validateNumber)(properties.scalingAdjustment)), errors.wrap('supplied properties not correct for "SimpleScalingPolicyConfigurationProperty"');
    }
    function cfnClusterSimpleScalingPolicyConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_SimpleScalingPolicyConfigurationPropertyValidator(properties).assertSuccess(), { AdjustmentType: cdk.stringToCloudFormation(properties.adjustmentType), CoolDown: cdk.numberToCloudFormation(properties.coolDown), ScalingAdjustment: cdk.numberToCloudFormation(properties.scalingAdjustment) }) : properties;
    }
    function CfnClusterSimpleScalingPolicyConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("adjustmentType", "AdjustmentType", properties.AdjustmentType != null ? cfn_parse.FromCloudFormation.getString(properties.AdjustmentType) : void 0), ret.addPropertyResult("coolDown", "CoolDown", properties.CoolDown != null ? cfn_parse.FromCloudFormation.getNumber(properties.CoolDown) : void 0), ret.addPropertyResult("scalingAdjustment", "ScalingAdjustment", cfn_parse.FromCloudFormation.getNumber(properties.ScalingAdjustment)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_SpotProvisioningSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allocationStrategy", cdk.validateString)(properties.allocationStrategy)), errors.collect(cdk.propertyValidator("blockDurationMinutes", cdk.validateNumber)(properties.blockDurationMinutes)), errors.collect(cdk.propertyValidator("timeoutAction", cdk.requiredValidator)(properties.timeoutAction)), errors.collect(cdk.propertyValidator("timeoutAction", cdk.validateString)(properties.timeoutAction)), errors.collect(cdk.propertyValidator("timeoutDurationMinutes", cdk.requiredValidator)(properties.timeoutDurationMinutes)), errors.collect(cdk.propertyValidator("timeoutDurationMinutes", cdk.validateNumber)(properties.timeoutDurationMinutes)), errors.wrap('supplied properties not correct for "SpotProvisioningSpecificationProperty"');
    }
    function cfnClusterSpotProvisioningSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_SpotProvisioningSpecificationPropertyValidator(properties).assertSuccess(), { AllocationStrategy: cdk.stringToCloudFormation(properties.allocationStrategy), BlockDurationMinutes: cdk.numberToCloudFormation(properties.blockDurationMinutes), TimeoutAction: cdk.stringToCloudFormation(properties.timeoutAction), TimeoutDurationMinutes: cdk.numberToCloudFormation(properties.timeoutDurationMinutes) }) : properties;
    }
    function CfnClusterSpotProvisioningSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allocationStrategy", "AllocationStrategy", properties.AllocationStrategy != null ? cfn_parse.FromCloudFormation.getString(properties.AllocationStrategy) : void 0), ret.addPropertyResult("blockDurationMinutes", "BlockDurationMinutes", properties.BlockDurationMinutes != null ? cfn_parse.FromCloudFormation.getNumber(properties.BlockDurationMinutes) : void 0), ret.addPropertyResult("timeoutAction", "TimeoutAction", cfn_parse.FromCloudFormation.getString(properties.TimeoutAction)), ret.addPropertyResult("timeoutDurationMinutes", "TimeoutDurationMinutes", cfn_parse.FromCloudFormation.getNumber(properties.TimeoutDurationMinutes)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_StepConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actionOnFailure", cdk.validateString)(properties.actionOnFailure)), errors.collect(cdk.propertyValidator("hadoopJarStep", cdk.requiredValidator)(properties.hadoopJarStep)), errors.collect(cdk.propertyValidator("hadoopJarStep", CfnCluster_HadoopJarStepConfigPropertyValidator)(properties.hadoopJarStep)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "StepConfigProperty"');
    }
    function cfnClusterStepConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_StepConfigPropertyValidator(properties).assertSuccess(), { ActionOnFailure: cdk.stringToCloudFormation(properties.actionOnFailure), HadoopJarStep: cfnClusterHadoopJarStepConfigPropertyToCloudFormation(properties.hadoopJarStep), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnClusterStepConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actionOnFailure", "ActionOnFailure", properties.ActionOnFailure != null ? cfn_parse.FromCloudFormation.getString(properties.ActionOnFailure) : void 0), ret.addPropertyResult("hadoopJarStep", "HadoopJarStep", CfnClusterHadoopJarStepConfigPropertyFromCloudFormation(properties.HadoopJarStep)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_VolumeSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("iops", cdk.validateNumber)(properties.iops)), errors.collect(cdk.propertyValidator("sizeInGb", cdk.requiredValidator)(properties.sizeInGb)), errors.collect(cdk.propertyValidator("sizeInGb", cdk.validateNumber)(properties.sizeInGb)), errors.collect(cdk.propertyValidator("volumeType", cdk.requiredValidator)(properties.volumeType)), errors.collect(cdk.propertyValidator("volumeType", cdk.validateString)(properties.volumeType)), errors.wrap('supplied properties not correct for "VolumeSpecificationProperty"');
    }
    function cfnClusterVolumeSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_VolumeSpecificationPropertyValidator(properties).assertSuccess(), { Iops: cdk.numberToCloudFormation(properties.iops), SizeInGB: cdk.numberToCloudFormation(properties.sizeInGb), VolumeType: cdk.stringToCloudFormation(properties.volumeType) }) : properties;
    }
    function CfnClusterVolumeSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("iops", "Iops", properties.Iops != null ? cfn_parse.FromCloudFormation.getNumber(properties.Iops) : void 0), ret.addPropertyResult("sizeInGb", "SizeInGB", cfn_parse.FromCloudFormation.getNumber(properties.SizeInGB)), ret.addPropertyResult("volumeType", "VolumeType", cfn_parse.FromCloudFormation.getString(properties.VolumeType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstanceFleetConfigPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clusterId", cdk.requiredValidator)(properties.clusterId)), errors.collect(cdk.propertyValidator("clusterId", cdk.validateString)(properties.clusterId)), errors.collect(cdk.propertyValidator("instanceFleetType", cdk.requiredValidator)(properties.instanceFleetType)), errors.collect(cdk.propertyValidator("instanceFleetType", cdk.validateString)(properties.instanceFleetType)), errors.collect(cdk.propertyValidator("instanceTypeConfigs", cdk.listValidator(CfnInstanceFleetConfig_InstanceTypeConfigPropertyValidator))(properties.instanceTypeConfigs)), errors.collect(cdk.propertyValidator("launchSpecifications", CfnInstanceFleetConfig_InstanceFleetProvisioningSpecificationsPropertyValidator)(properties.launchSpecifications)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("targetOnDemandCapacity", cdk.validateNumber)(properties.targetOnDemandCapacity)), errors.collect(cdk.propertyValidator("targetSpotCapacity", cdk.validateNumber)(properties.targetSpotCapacity)), errors.wrap('supplied properties not correct for "CfnInstanceFleetConfigProps"');
    }
    function cfnInstanceFleetConfigPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceFleetConfigPropsValidator(properties).assertSuccess(), { ClusterId: cdk.stringToCloudFormation(properties.clusterId), InstanceFleetType: cdk.stringToCloudFormation(properties.instanceFleetType), InstanceTypeConfigs: cdk.listMapper(cfnInstanceFleetConfigInstanceTypeConfigPropertyToCloudFormation)(properties.instanceTypeConfigs), LaunchSpecifications: cfnInstanceFleetConfigInstanceFleetProvisioningSpecificationsPropertyToCloudFormation(properties.launchSpecifications), Name: cdk.stringToCloudFormation(properties.name), TargetOnDemandCapacity: cdk.numberToCloudFormation(properties.targetOnDemandCapacity), TargetSpotCapacity: cdk.numberToCloudFormation(properties.targetSpotCapacity) }) : properties;
    }
    function CfnInstanceFleetConfigPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clusterId", "ClusterId", cfn_parse.FromCloudFormation.getString(properties.ClusterId)), ret.addPropertyResult("instanceFleetType", "InstanceFleetType", cfn_parse.FromCloudFormation.getString(properties.InstanceFleetType)), ret.addPropertyResult("instanceTypeConfigs", "InstanceTypeConfigs", properties.InstanceTypeConfigs != null ? cfn_parse.FromCloudFormation.getArray(CfnInstanceFleetConfigInstanceTypeConfigPropertyFromCloudFormation)(properties.InstanceTypeConfigs) : void 0), ret.addPropertyResult("launchSpecifications", "LaunchSpecifications", properties.LaunchSpecifications != null ? CfnInstanceFleetConfigInstanceFleetProvisioningSpecificationsPropertyFromCloudFormation(properties.LaunchSpecifications) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("targetOnDemandCapacity", "TargetOnDemandCapacity", properties.TargetOnDemandCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.TargetOnDemandCapacity) : void 0), ret.addPropertyResult("targetSpotCapacity", "TargetSpotCapacity", properties.TargetSpotCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.TargetSpotCapacity) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnInstanceFleetConfig = class _CfnInstanceFleetConfig extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnInstanceFleetConfigPropsFromCloudFormation(resourceProperties), ret = new _CfnInstanceFleetConfig(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnInstanceFleetConfig.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_emr_CfnInstanceFleetConfigProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnInstanceFleetConfig), error;
        }
        cdk.requireProperty(props, "clusterId", this), cdk.requireProperty(props, "instanceFleetType", this), this.clusterId = props.clusterId, this.instanceFleetType = props.instanceFleetType, this.instanceTypeConfigs = props.instanceTypeConfigs, this.launchSpecifications = props.launchSpecifications, this.name = props.name, this.targetOnDemandCapacity = props.targetOnDemandCapacity, this.targetSpotCapacity = props.targetSpotCapacity;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnInstanceFleetConfig.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { clusterId: this.clusterId, instanceFleetType: this.instanceFleetType, instanceTypeConfigs: this.instanceTypeConfigs, launchSpecifications: this.launchSpecifications, name: this.name, targetOnDemandCapacity: this.targetOnDemandCapacity, targetSpotCapacity: this.targetSpotCapacity };
      }
      renderProperties(props) {
        return cfnInstanceFleetConfigPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnInstanceFleetConfig[_b] = { fqn: "aws-cdk-lib.aws_emr.CfnInstanceFleetConfig", version: "2.80.0" }, CfnInstanceFleetConfig.CFN_RESOURCE_TYPE_NAME = "AWS::EMR::InstanceFleetConfig", exports2.CfnInstanceFleetConfig = CfnInstanceFleetConfig;
    function CfnInstanceFleetConfig_ConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("classification", cdk.validateString)(properties.classification)), errors.collect(cdk.propertyValidator("configurationProperties", cdk.hashValidator(cdk.validateString))(properties.configurationProperties)), errors.collect(cdk.propertyValidator("configurations", cdk.listValidator(CfnInstanceFleetConfig_ConfigurationPropertyValidator))(properties.configurations)), errors.wrap('supplied properties not correct for "ConfigurationProperty"');
    }
    function cfnInstanceFleetConfigConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceFleetConfig_ConfigurationPropertyValidator(properties).assertSuccess(), { Classification: cdk.stringToCloudFormation(properties.classification), ConfigurationProperties: cdk.hashMapper(cdk.stringToCloudFormation)(properties.configurationProperties), Configurations: cdk.listMapper(cfnInstanceFleetConfigConfigurationPropertyToCloudFormation)(properties.configurations) }) : properties;
    }
    function CfnInstanceFleetConfigConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("classification", "Classification", properties.Classification != null ? cfn_parse.FromCloudFormation.getString(properties.Classification) : void 0), ret.addPropertyResult("configurationProperties", "ConfigurationProperties", properties.ConfigurationProperties != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.ConfigurationProperties) : void 0), ret.addPropertyResult("configurations", "Configurations", properties.Configurations != null ? cfn_parse.FromCloudFormation.getArray(CfnInstanceFleetConfigConfigurationPropertyFromCloudFormation)(properties.Configurations) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstanceFleetConfig_EbsBlockDeviceConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("volumeSpecification", cdk.requiredValidator)(properties.volumeSpecification)), errors.collect(cdk.propertyValidator("volumeSpecification", CfnInstanceFleetConfig_VolumeSpecificationPropertyValidator)(properties.volumeSpecification)), errors.collect(cdk.propertyValidator("volumesPerInstance", cdk.validateNumber)(properties.volumesPerInstance)), errors.wrap('supplied properties not correct for "EbsBlockDeviceConfigProperty"');
    }
    function cfnInstanceFleetConfigEbsBlockDeviceConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceFleetConfig_EbsBlockDeviceConfigPropertyValidator(properties).assertSuccess(), { VolumeSpecification: cfnInstanceFleetConfigVolumeSpecificationPropertyToCloudFormation(properties.volumeSpecification), VolumesPerInstance: cdk.numberToCloudFormation(properties.volumesPerInstance) }) : properties;
    }
    function CfnInstanceFleetConfigEbsBlockDeviceConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("volumeSpecification", "VolumeSpecification", CfnInstanceFleetConfigVolumeSpecificationPropertyFromCloudFormation(properties.VolumeSpecification)), ret.addPropertyResult("volumesPerInstance", "VolumesPerInstance", properties.VolumesPerInstance != null ? cfn_parse.FromCloudFormation.getNumber(properties.VolumesPerInstance) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstanceFleetConfig_EbsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ebsBlockDeviceConfigs", cdk.listValidator(CfnInstanceFleetConfig_EbsBlockDeviceConfigPropertyValidator))(properties.ebsBlockDeviceConfigs)), errors.collect(cdk.propertyValidator("ebsOptimized", cdk.validateBoolean)(properties.ebsOptimized)), errors.wrap('supplied properties not correct for "EbsConfigurationProperty"');
    }
    function cfnInstanceFleetConfigEbsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceFleetConfig_EbsConfigurationPropertyValidator(properties).assertSuccess(), { EbsBlockDeviceConfigs: cdk.listMapper(cfnInstanceFleetConfigEbsBlockDeviceConfigPropertyToCloudFormation)(properties.ebsBlockDeviceConfigs), EbsOptimized: cdk.booleanToCloudFormation(properties.ebsOptimized) }) : properties;
    }
    function CfnInstanceFleetConfigEbsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ebsBlockDeviceConfigs", "EbsBlockDeviceConfigs", properties.EbsBlockDeviceConfigs != null ? cfn_parse.FromCloudFormation.getArray(CfnInstanceFleetConfigEbsBlockDeviceConfigPropertyFromCloudFormation)(properties.EbsBlockDeviceConfigs) : void 0), ret.addPropertyResult("ebsOptimized", "EbsOptimized", properties.EbsOptimized != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EbsOptimized) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstanceFleetConfig_InstanceFleetProvisioningSpecificationsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("onDemandSpecification", CfnInstanceFleetConfig_OnDemandProvisioningSpecificationPropertyValidator)(properties.onDemandSpecification)), errors.collect(cdk.propertyValidator("spotSpecification", CfnInstanceFleetConfig_SpotProvisioningSpecificationPropertyValidator)(properties.spotSpecification)), errors.wrap('supplied properties not correct for "InstanceFleetProvisioningSpecificationsProperty"');
    }
    function cfnInstanceFleetConfigInstanceFleetProvisioningSpecificationsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceFleetConfig_InstanceFleetProvisioningSpecificationsPropertyValidator(properties).assertSuccess(), { OnDemandSpecification: cfnInstanceFleetConfigOnDemandProvisioningSpecificationPropertyToCloudFormation(properties.onDemandSpecification), SpotSpecification: cfnInstanceFleetConfigSpotProvisioningSpecificationPropertyToCloudFormation(properties.spotSpecification) }) : properties;
    }
    function CfnInstanceFleetConfigInstanceFleetProvisioningSpecificationsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("onDemandSpecification", "OnDemandSpecification", properties.OnDemandSpecification != null ? CfnInstanceFleetConfigOnDemandProvisioningSpecificationPropertyFromCloudFormation(properties.OnDemandSpecification) : void 0), ret.addPropertyResult("spotSpecification", "SpotSpecification", properties.SpotSpecification != null ? CfnInstanceFleetConfigSpotProvisioningSpecificationPropertyFromCloudFormation(properties.SpotSpecification) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstanceFleetConfig_InstanceTypeConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bidPrice", cdk.validateString)(properties.bidPrice)), errors.collect(cdk.propertyValidator("bidPriceAsPercentageOfOnDemandPrice", cdk.validateNumber)(properties.bidPriceAsPercentageOfOnDemandPrice)), errors.collect(cdk.propertyValidator("configurations", cdk.listValidator(CfnInstanceFleetConfig_ConfigurationPropertyValidator))(properties.configurations)), errors.collect(cdk.propertyValidator("customAmiId", cdk.validateString)(properties.customAmiId)), errors.collect(cdk.propertyValidator("ebsConfiguration", CfnInstanceFleetConfig_EbsConfigurationPropertyValidator)(properties.ebsConfiguration)), errors.collect(cdk.propertyValidator("instanceType", cdk.requiredValidator)(properties.instanceType)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("weightedCapacity", cdk.validateNumber)(properties.weightedCapacity)), errors.wrap('supplied properties not correct for "InstanceTypeConfigProperty"');
    }
    function cfnInstanceFleetConfigInstanceTypeConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceFleetConfig_InstanceTypeConfigPropertyValidator(properties).assertSuccess(), { BidPrice: cdk.stringToCloudFormation(properties.bidPrice), BidPriceAsPercentageOfOnDemandPrice: cdk.numberToCloudFormation(properties.bidPriceAsPercentageOfOnDemandPrice), Configurations: cdk.listMapper(cfnInstanceFleetConfigConfigurationPropertyToCloudFormation)(properties.configurations), CustomAmiId: cdk.stringToCloudFormation(properties.customAmiId), EbsConfiguration: cfnInstanceFleetConfigEbsConfigurationPropertyToCloudFormation(properties.ebsConfiguration), InstanceType: cdk.stringToCloudFormation(properties.instanceType), WeightedCapacity: cdk.numberToCloudFormation(properties.weightedCapacity) }) : properties;
    }
    function CfnInstanceFleetConfigInstanceTypeConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bidPrice", "BidPrice", properties.BidPrice != null ? cfn_parse.FromCloudFormation.getString(properties.BidPrice) : void 0), ret.addPropertyResult("bidPriceAsPercentageOfOnDemandPrice", "BidPriceAsPercentageOfOnDemandPrice", properties.BidPriceAsPercentageOfOnDemandPrice != null ? cfn_parse.FromCloudFormation.getNumber(properties.BidPriceAsPercentageOfOnDemandPrice) : void 0), ret.addPropertyResult("configurations", "Configurations", properties.Configurations != null ? cfn_parse.FromCloudFormation.getArray(CfnInstanceFleetConfigConfigurationPropertyFromCloudFormation)(properties.Configurations) : void 0), ret.addPropertyResult("customAmiId", "CustomAmiId", properties.CustomAmiId != null ? cfn_parse.FromCloudFormation.getString(properties.CustomAmiId) : void 0), ret.addPropertyResult("ebsConfiguration", "EbsConfiguration", properties.EbsConfiguration != null ? CfnInstanceFleetConfigEbsConfigurationPropertyFromCloudFormation(properties.EbsConfiguration) : void 0), ret.addPropertyResult("instanceType", "InstanceType", cfn_parse.FromCloudFormation.getString(properties.InstanceType)), ret.addPropertyResult("weightedCapacity", "WeightedCapacity", properties.WeightedCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.WeightedCapacity) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstanceFleetConfig_OnDemandProvisioningSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allocationStrategy", cdk.requiredValidator)(properties.allocationStrategy)), errors.collect(cdk.propertyValidator("allocationStrategy", cdk.validateString)(properties.allocationStrategy)), errors.wrap('supplied properties not correct for "OnDemandProvisioningSpecificationProperty"');
    }
    function cfnInstanceFleetConfigOnDemandProvisioningSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceFleetConfig_OnDemandProvisioningSpecificationPropertyValidator(properties).assertSuccess(), { AllocationStrategy: cdk.stringToCloudFormation(properties.allocationStrategy) }) : properties;
    }
    function CfnInstanceFleetConfigOnDemandProvisioningSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allocationStrategy", "AllocationStrategy", cfn_parse.FromCloudFormation.getString(properties.AllocationStrategy)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstanceFleetConfig_SpotProvisioningSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allocationStrategy", cdk.validateString)(properties.allocationStrategy)), errors.collect(cdk.propertyValidator("blockDurationMinutes", cdk.validateNumber)(properties.blockDurationMinutes)), errors.collect(cdk.propertyValidator("timeoutAction", cdk.requiredValidator)(properties.timeoutAction)), errors.collect(cdk.propertyValidator("timeoutAction", cdk.validateString)(properties.timeoutAction)), errors.collect(cdk.propertyValidator("timeoutDurationMinutes", cdk.requiredValidator)(properties.timeoutDurationMinutes)), errors.collect(cdk.propertyValidator("timeoutDurationMinutes", cdk.validateNumber)(properties.timeoutDurationMinutes)), errors.wrap('supplied properties not correct for "SpotProvisioningSpecificationProperty"');
    }
    function cfnInstanceFleetConfigSpotProvisioningSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceFleetConfig_SpotProvisioningSpecificationPropertyValidator(properties).assertSuccess(), { AllocationStrategy: cdk.stringToCloudFormation(properties.allocationStrategy), BlockDurationMinutes: cdk.numberToCloudFormation(properties.blockDurationMinutes), TimeoutAction: cdk.stringToCloudFormation(properties.timeoutAction), TimeoutDurationMinutes: cdk.numberToCloudFormation(properties.timeoutDurationMinutes) }) : properties;
    }
    function CfnInstanceFleetConfigSpotProvisioningSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allocationStrategy", "AllocationStrategy", properties.AllocationStrategy != null ? cfn_parse.FromCloudFormation.getString(properties.AllocationStrategy) : void 0), ret.addPropertyResult("blockDurationMinutes", "BlockDurationMinutes", properties.BlockDurationMinutes != null ? cfn_parse.FromCloudFormation.getNumber(properties.BlockDurationMinutes) : void 0), ret.addPropertyResult("timeoutAction", "TimeoutAction", cfn_parse.FromCloudFormation.getString(properties.TimeoutAction)), ret.addPropertyResult("timeoutDurationMinutes", "TimeoutDurationMinutes", cfn_parse.FromCloudFormation.getNumber(properties.TimeoutDurationMinutes)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstanceFleetConfig_VolumeSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("iops", cdk.validateNumber)(properties.iops)), errors.collect(cdk.propertyValidator("sizeInGb", cdk.requiredValidator)(properties.sizeInGb)), errors.collect(cdk.propertyValidator("sizeInGb", cdk.validateNumber)(properties.sizeInGb)), errors.collect(cdk.propertyValidator("volumeType", cdk.requiredValidator)(properties.volumeType)), errors.collect(cdk.propertyValidator("volumeType", cdk.validateString)(properties.volumeType)), errors.wrap('supplied properties not correct for "VolumeSpecificationProperty"');
    }
    function cfnInstanceFleetConfigVolumeSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceFleetConfig_VolumeSpecificationPropertyValidator(properties).assertSuccess(), { Iops: cdk.numberToCloudFormation(properties.iops), SizeInGB: cdk.numberToCloudFormation(properties.sizeInGb), VolumeType: cdk.stringToCloudFormation(properties.volumeType) }) : properties;
    }
    function CfnInstanceFleetConfigVolumeSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("iops", "Iops", properties.Iops != null ? cfn_parse.FromCloudFormation.getNumber(properties.Iops) : void 0), ret.addPropertyResult("sizeInGb", "SizeInGB", cfn_parse.FromCloudFormation.getNumber(properties.SizeInGB)), ret.addPropertyResult("volumeType", "VolumeType", cfn_parse.FromCloudFormation.getString(properties.VolumeType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstanceGroupConfigPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoScalingPolicy", CfnInstanceGroupConfig_AutoScalingPolicyPropertyValidator)(properties.autoScalingPolicy)), errors.collect(cdk.propertyValidator("bidPrice", cdk.validateString)(properties.bidPrice)), errors.collect(cdk.propertyValidator("configurations", cdk.listValidator(CfnInstanceGroupConfig_ConfigurationPropertyValidator))(properties.configurations)), errors.collect(cdk.propertyValidator("customAmiId", cdk.validateString)(properties.customAmiId)), errors.collect(cdk.propertyValidator("ebsConfiguration", CfnInstanceGroupConfig_EbsConfigurationPropertyValidator)(properties.ebsConfiguration)), errors.collect(cdk.propertyValidator("instanceCount", cdk.requiredValidator)(properties.instanceCount)), errors.collect(cdk.propertyValidator("instanceCount", cdk.validateNumber)(properties.instanceCount)), errors.collect(cdk.propertyValidator("instanceRole", cdk.requiredValidator)(properties.instanceRole)), errors.collect(cdk.propertyValidator("instanceRole", cdk.validateString)(properties.instanceRole)), errors.collect(cdk.propertyValidator("instanceType", cdk.requiredValidator)(properties.instanceType)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("jobFlowId", cdk.requiredValidator)(properties.jobFlowId)), errors.collect(cdk.propertyValidator("jobFlowId", cdk.validateString)(properties.jobFlowId)), errors.collect(cdk.propertyValidator("market", cdk.validateString)(properties.market)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "CfnInstanceGroupConfigProps"');
    }
    function cfnInstanceGroupConfigPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceGroupConfigPropsValidator(properties).assertSuccess(), { InstanceCount: cdk.numberToCloudFormation(properties.instanceCount), InstanceRole: cdk.stringToCloudFormation(properties.instanceRole), InstanceType: cdk.stringToCloudFormation(properties.instanceType), JobFlowId: cdk.stringToCloudFormation(properties.jobFlowId), AutoScalingPolicy: cfnInstanceGroupConfigAutoScalingPolicyPropertyToCloudFormation(properties.autoScalingPolicy), BidPrice: cdk.stringToCloudFormation(properties.bidPrice), Configurations: cdk.listMapper(cfnInstanceGroupConfigConfigurationPropertyToCloudFormation)(properties.configurations), CustomAmiId: cdk.stringToCloudFormation(properties.customAmiId), EbsConfiguration: cfnInstanceGroupConfigEbsConfigurationPropertyToCloudFormation(properties.ebsConfiguration), Market: cdk.stringToCloudFormation(properties.market), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnInstanceGroupConfigPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceCount", "InstanceCount", cfn_parse.FromCloudFormation.getNumber(properties.InstanceCount)), ret.addPropertyResult("instanceRole", "InstanceRole", cfn_parse.FromCloudFormation.getString(properties.InstanceRole)), ret.addPropertyResult("instanceType", "InstanceType", cfn_parse.FromCloudFormation.getString(properties.InstanceType)), ret.addPropertyResult("jobFlowId", "JobFlowId", cfn_parse.FromCloudFormation.getString(properties.JobFlowId)), ret.addPropertyResult("autoScalingPolicy", "AutoScalingPolicy", properties.AutoScalingPolicy != null ? CfnInstanceGroupConfigAutoScalingPolicyPropertyFromCloudFormation(properties.AutoScalingPolicy) : void 0), ret.addPropertyResult("bidPrice", "BidPrice", properties.BidPrice != null ? cfn_parse.FromCloudFormation.getString(properties.BidPrice) : void 0), ret.addPropertyResult("configurations", "Configurations", properties.Configurations != null ? cfn_parse.FromCloudFormation.getArray(CfnInstanceGroupConfigConfigurationPropertyFromCloudFormation)(properties.Configurations) : void 0), ret.addPropertyResult("customAmiId", "CustomAmiId", properties.CustomAmiId != null ? cfn_parse.FromCloudFormation.getString(properties.CustomAmiId) : void 0), ret.addPropertyResult("ebsConfiguration", "EbsConfiguration", properties.EbsConfiguration != null ? CfnInstanceGroupConfigEbsConfigurationPropertyFromCloudFormation(properties.EbsConfiguration) : void 0), ret.addPropertyResult("market", "Market", properties.Market != null ? cfn_parse.FromCloudFormation.getString(properties.Market) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnInstanceGroupConfig = class _CfnInstanceGroupConfig extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnInstanceGroupConfigPropsFromCloudFormation(resourceProperties), ret = new _CfnInstanceGroupConfig(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnInstanceGroupConfig.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_emr_CfnInstanceGroupConfigProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnInstanceGroupConfig), error;
        }
        cdk.requireProperty(props, "instanceCount", this), cdk.requireProperty(props, "instanceRole", this), cdk.requireProperty(props, "instanceType", this), cdk.requireProperty(props, "jobFlowId", this), this.instanceCount = props.instanceCount, this.instanceRole = props.instanceRole, this.instanceType = props.instanceType, this.jobFlowId = props.jobFlowId, this.autoScalingPolicy = props.autoScalingPolicy, this.bidPrice = props.bidPrice, this.configurations = props.configurations, this.customAmiId = props.customAmiId, this.ebsConfiguration = props.ebsConfiguration, this.market = props.market, this.name = props.name;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnInstanceGroupConfig.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { instanceCount: this.instanceCount, instanceRole: this.instanceRole, instanceType: this.instanceType, jobFlowId: this.jobFlowId, autoScalingPolicy: this.autoScalingPolicy, bidPrice: this.bidPrice, configurations: this.configurations, customAmiId: this.customAmiId, ebsConfiguration: this.ebsConfiguration, market: this.market, name: this.name };
      }
      renderProperties(props) {
        return cfnInstanceGroupConfigPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnInstanceGroupConfig[_c] = { fqn: "aws-cdk-lib.aws_emr.CfnInstanceGroupConfig", version: "2.80.0" }, CfnInstanceGroupConfig.CFN_RESOURCE_TYPE_NAME = "AWS::EMR::InstanceGroupConfig", exports2.CfnInstanceGroupConfig = CfnInstanceGroupConfig;
    function CfnInstanceGroupConfig_AutoScalingPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("constraints", cdk.requiredValidator)(properties.constraints)), errors.collect(cdk.propertyValidator("constraints", CfnInstanceGroupConfig_ScalingConstraintsPropertyValidator)(properties.constraints)), errors.collect(cdk.propertyValidator("rules", cdk.requiredValidator)(properties.rules)), errors.collect(cdk.propertyValidator("rules", cdk.listValidator(CfnInstanceGroupConfig_ScalingRulePropertyValidator))(properties.rules)), errors.wrap('supplied properties not correct for "AutoScalingPolicyProperty"');
    }
    function cfnInstanceGroupConfigAutoScalingPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceGroupConfig_AutoScalingPolicyPropertyValidator(properties).assertSuccess(), { Constraints: cfnInstanceGroupConfigScalingConstraintsPropertyToCloudFormation(properties.constraints), Rules: cdk.listMapper(cfnInstanceGroupConfigScalingRulePropertyToCloudFormation)(properties.rules) }) : properties;
    }
    function CfnInstanceGroupConfigAutoScalingPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("constraints", "Constraints", CfnInstanceGroupConfigScalingConstraintsPropertyFromCloudFormation(properties.Constraints)), ret.addPropertyResult("rules", "Rules", cfn_parse.FromCloudFormation.getArray(CfnInstanceGroupConfigScalingRulePropertyFromCloudFormation)(properties.Rules)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstanceGroupConfig_CloudWatchAlarmDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("comparisonOperator", cdk.requiredValidator)(properties.comparisonOperator)), errors.collect(cdk.propertyValidator("comparisonOperator", cdk.validateString)(properties.comparisonOperator)), errors.collect(cdk.propertyValidator("dimensions", cdk.listValidator(CfnInstanceGroupConfig_MetricDimensionPropertyValidator))(properties.dimensions)), errors.collect(cdk.propertyValidator("evaluationPeriods", cdk.validateNumber)(properties.evaluationPeriods)), errors.collect(cdk.propertyValidator("metricName", cdk.requiredValidator)(properties.metricName)), errors.collect(cdk.propertyValidator("metricName", cdk.validateString)(properties.metricName)), errors.collect(cdk.propertyValidator("namespace", cdk.validateString)(properties.namespace)), errors.collect(cdk.propertyValidator("period", cdk.requiredValidator)(properties.period)), errors.collect(cdk.propertyValidator("period", cdk.validateNumber)(properties.period)), errors.collect(cdk.propertyValidator("statistic", cdk.validateString)(properties.statistic)), errors.collect(cdk.propertyValidator("threshold", cdk.requiredValidator)(properties.threshold)), errors.collect(cdk.propertyValidator("threshold", cdk.validateNumber)(properties.threshold)), errors.collect(cdk.propertyValidator("unit", cdk.validateString)(properties.unit)), errors.wrap('supplied properties not correct for "CloudWatchAlarmDefinitionProperty"');
    }
    function cfnInstanceGroupConfigCloudWatchAlarmDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceGroupConfig_CloudWatchAlarmDefinitionPropertyValidator(properties).assertSuccess(), { ComparisonOperator: cdk.stringToCloudFormation(properties.comparisonOperator), Dimensions: cdk.listMapper(cfnInstanceGroupConfigMetricDimensionPropertyToCloudFormation)(properties.dimensions), EvaluationPeriods: cdk.numberToCloudFormation(properties.evaluationPeriods), MetricName: cdk.stringToCloudFormation(properties.metricName), Namespace: cdk.stringToCloudFormation(properties.namespace), Period: cdk.numberToCloudFormation(properties.period), Statistic: cdk.stringToCloudFormation(properties.statistic), Threshold: cdk.numberToCloudFormation(properties.threshold), Unit: cdk.stringToCloudFormation(properties.unit) }) : properties;
    }
    function CfnInstanceGroupConfigCloudWatchAlarmDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("comparisonOperator", "ComparisonOperator", cfn_parse.FromCloudFormation.getString(properties.ComparisonOperator)), ret.addPropertyResult("dimensions", "Dimensions", properties.Dimensions != null ? cfn_parse.FromCloudFormation.getArray(CfnInstanceGroupConfigMetricDimensionPropertyFromCloudFormation)(properties.Dimensions) : void 0), ret.addPropertyResult("evaluationPeriods", "EvaluationPeriods", properties.EvaluationPeriods != null ? cfn_parse.FromCloudFormation.getNumber(properties.EvaluationPeriods) : void 0), ret.addPropertyResult("metricName", "MetricName", cfn_parse.FromCloudFormation.getString(properties.MetricName)), ret.addPropertyResult("namespace", "Namespace", properties.Namespace != null ? cfn_parse.FromCloudFormation.getString(properties.Namespace) : void 0), ret.addPropertyResult("period", "Period", cfn_parse.FromCloudFormation.getNumber(properties.Period)), ret.addPropertyResult("statistic", "Statistic", properties.Statistic != null ? cfn_parse.FromCloudFormation.getString(properties.Statistic) : void 0), ret.addPropertyResult("threshold", "Threshold", cfn_parse.FromCloudFormation.getNumber(properties.Threshold)), ret.addPropertyResult("unit", "Unit", properties.Unit != null ? cfn_parse.FromCloudFormation.getString(properties.Unit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstanceGroupConfig_ConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("classification", cdk.validateString)(properties.classification)), errors.collect(cdk.propertyValidator("configurationProperties", cdk.hashValidator(cdk.validateString))(properties.configurationProperties)), errors.collect(cdk.propertyValidator("configurations", cdk.listValidator(CfnInstanceGroupConfig_ConfigurationPropertyValidator))(properties.configurations)), errors.wrap('supplied properties not correct for "ConfigurationProperty"');
    }
    function cfnInstanceGroupConfigConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceGroupConfig_ConfigurationPropertyValidator(properties).assertSuccess(), { Classification: cdk.stringToCloudFormation(properties.classification), ConfigurationProperties: cdk.hashMapper(cdk.stringToCloudFormation)(properties.configurationProperties), Configurations: cdk.listMapper(cfnInstanceGroupConfigConfigurationPropertyToCloudFormation)(properties.configurations) }) : properties;
    }
    function CfnInstanceGroupConfigConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("classification", "Classification", properties.Classification != null ? cfn_parse.FromCloudFormation.getString(properties.Classification) : void 0), ret.addPropertyResult("configurationProperties", "ConfigurationProperties", properties.ConfigurationProperties != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.ConfigurationProperties) : void 0), ret.addPropertyResult("configurations", "Configurations", properties.Configurations != null ? cfn_parse.FromCloudFormation.getArray(CfnInstanceGroupConfigConfigurationPropertyFromCloudFormation)(properties.Configurations) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstanceGroupConfig_EbsBlockDeviceConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("volumeSpecification", cdk.requiredValidator)(properties.volumeSpecification)), errors.collect(cdk.propertyValidator("volumeSpecification", CfnInstanceGroupConfig_VolumeSpecificationPropertyValidator)(properties.volumeSpecification)), errors.collect(cdk.propertyValidator("volumesPerInstance", cdk.validateNumber)(properties.volumesPerInstance)), errors.wrap('supplied properties not correct for "EbsBlockDeviceConfigProperty"');
    }
    function cfnInstanceGroupConfigEbsBlockDeviceConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceGroupConfig_EbsBlockDeviceConfigPropertyValidator(properties).assertSuccess(), { VolumeSpecification: cfnInstanceGroupConfigVolumeSpecificationPropertyToCloudFormation(properties.volumeSpecification), VolumesPerInstance: cdk.numberToCloudFormation(properties.volumesPerInstance) }) : properties;
    }
    function CfnInstanceGroupConfigEbsBlockDeviceConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("volumeSpecification", "VolumeSpecification", CfnInstanceGroupConfigVolumeSpecificationPropertyFromCloudFormation(properties.VolumeSpecification)), ret.addPropertyResult("volumesPerInstance", "VolumesPerInstance", properties.VolumesPerInstance != null ? cfn_parse.FromCloudFormation.getNumber(properties.VolumesPerInstance) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstanceGroupConfig_EbsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ebsBlockDeviceConfigs", cdk.listValidator(CfnInstanceGroupConfig_EbsBlockDeviceConfigPropertyValidator))(properties.ebsBlockDeviceConfigs)), errors.collect(cdk.propertyValidator("ebsOptimized", cdk.validateBoolean)(properties.ebsOptimized)), errors.wrap('supplied properties not correct for "EbsConfigurationProperty"');
    }
    function cfnInstanceGroupConfigEbsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceGroupConfig_EbsConfigurationPropertyValidator(properties).assertSuccess(), { EbsBlockDeviceConfigs: cdk.listMapper(cfnInstanceGroupConfigEbsBlockDeviceConfigPropertyToCloudFormation)(properties.ebsBlockDeviceConfigs), EbsOptimized: cdk.booleanToCloudFormation(properties.ebsOptimized) }) : properties;
    }
    function CfnInstanceGroupConfigEbsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ebsBlockDeviceConfigs", "EbsBlockDeviceConfigs", properties.EbsBlockDeviceConfigs != null ? cfn_parse.FromCloudFormation.getArray(CfnInstanceGroupConfigEbsBlockDeviceConfigPropertyFromCloudFormation)(properties.EbsBlockDeviceConfigs) : void 0), ret.addPropertyResult("ebsOptimized", "EbsOptimized", properties.EbsOptimized != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EbsOptimized) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstanceGroupConfig_MetricDimensionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "MetricDimensionProperty"');
    }
    function cfnInstanceGroupConfigMetricDimensionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceGroupConfig_MetricDimensionPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnInstanceGroupConfigMetricDimensionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstanceGroupConfig_ScalingActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("market", cdk.validateString)(properties.market)), errors.collect(cdk.propertyValidator("simpleScalingPolicyConfiguration", cdk.requiredValidator)(properties.simpleScalingPolicyConfiguration)), errors.collect(cdk.propertyValidator("simpleScalingPolicyConfiguration", CfnInstanceGroupConfig_SimpleScalingPolicyConfigurationPropertyValidator)(properties.simpleScalingPolicyConfiguration)), errors.wrap('supplied properties not correct for "ScalingActionProperty"');
    }
    function cfnInstanceGroupConfigScalingActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceGroupConfig_ScalingActionPropertyValidator(properties).assertSuccess(), { Market: cdk.stringToCloudFormation(properties.market), SimpleScalingPolicyConfiguration: cfnInstanceGroupConfigSimpleScalingPolicyConfigurationPropertyToCloudFormation(properties.simpleScalingPolicyConfiguration) }) : properties;
    }
    function CfnInstanceGroupConfigScalingActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("market", "Market", properties.Market != null ? cfn_parse.FromCloudFormation.getString(properties.Market) : void 0), ret.addPropertyResult("simpleScalingPolicyConfiguration", "SimpleScalingPolicyConfiguration", CfnInstanceGroupConfigSimpleScalingPolicyConfigurationPropertyFromCloudFormation(properties.SimpleScalingPolicyConfiguration)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstanceGroupConfig_ScalingConstraintsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxCapacity", cdk.requiredValidator)(properties.maxCapacity)), errors.collect(cdk.propertyValidator("maxCapacity", cdk.validateNumber)(properties.maxCapacity)), errors.collect(cdk.propertyValidator("minCapacity", cdk.requiredValidator)(properties.minCapacity)), errors.collect(cdk.propertyValidator("minCapacity", cdk.validateNumber)(properties.minCapacity)), errors.wrap('supplied properties not correct for "ScalingConstraintsProperty"');
    }
    function cfnInstanceGroupConfigScalingConstraintsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceGroupConfig_ScalingConstraintsPropertyValidator(properties).assertSuccess(), { MaxCapacity: cdk.numberToCloudFormation(properties.maxCapacity), MinCapacity: cdk.numberToCloudFormation(properties.minCapacity) }) : properties;
    }
    function CfnInstanceGroupConfigScalingConstraintsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxCapacity", "MaxCapacity", cfn_parse.FromCloudFormation.getNumber(properties.MaxCapacity)), ret.addPropertyResult("minCapacity", "MinCapacity", cfn_parse.FromCloudFormation.getNumber(properties.MinCapacity)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstanceGroupConfig_ScalingRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.requiredValidator)(properties.action)), errors.collect(cdk.propertyValidator("action", CfnInstanceGroupConfig_ScalingActionPropertyValidator)(properties.action)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("trigger", cdk.requiredValidator)(properties.trigger)), errors.collect(cdk.propertyValidator("trigger", CfnInstanceGroupConfig_ScalingTriggerPropertyValidator)(properties.trigger)), errors.wrap('supplied properties not correct for "ScalingRuleProperty"');
    }
    function cfnInstanceGroupConfigScalingRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceGroupConfig_ScalingRulePropertyValidator(properties).assertSuccess(), { Action: cfnInstanceGroupConfigScalingActionPropertyToCloudFormation(properties.action), Description: cdk.stringToCloudFormation(properties.description), Name: cdk.stringToCloudFormation(properties.name), Trigger: cfnInstanceGroupConfigScalingTriggerPropertyToCloudFormation(properties.trigger) }) : properties;
    }
    function CfnInstanceGroupConfigScalingRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", CfnInstanceGroupConfigScalingActionPropertyFromCloudFormation(properties.Action)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("trigger", "Trigger", CfnInstanceGroupConfigScalingTriggerPropertyFromCloudFormation(properties.Trigger)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstanceGroupConfig_ScalingTriggerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchAlarmDefinition", cdk.requiredValidator)(properties.cloudWatchAlarmDefinition)), errors.collect(cdk.propertyValidator("cloudWatchAlarmDefinition", CfnInstanceGroupConfig_CloudWatchAlarmDefinitionPropertyValidator)(properties.cloudWatchAlarmDefinition)), errors.wrap('supplied properties not correct for "ScalingTriggerProperty"');
    }
    function cfnInstanceGroupConfigScalingTriggerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceGroupConfig_ScalingTriggerPropertyValidator(properties).assertSuccess(), { CloudWatchAlarmDefinition: cfnInstanceGroupConfigCloudWatchAlarmDefinitionPropertyToCloudFormation(properties.cloudWatchAlarmDefinition) }) : properties;
    }
    function CfnInstanceGroupConfigScalingTriggerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchAlarmDefinition", "CloudWatchAlarmDefinition", CfnInstanceGroupConfigCloudWatchAlarmDefinitionPropertyFromCloudFormation(properties.CloudWatchAlarmDefinition)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstanceGroupConfig_SimpleScalingPolicyConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("adjustmentType", cdk.validateString)(properties.adjustmentType)), errors.collect(cdk.propertyValidator("coolDown", cdk.validateNumber)(properties.coolDown)), errors.collect(cdk.propertyValidator("scalingAdjustment", cdk.requiredValidator)(properties.scalingAdjustment)), errors.collect(cdk.propertyValidator("scalingAdjustment", cdk.validateNumber)(properties.scalingAdjustment)), errors.wrap('supplied properties not correct for "SimpleScalingPolicyConfigurationProperty"');
    }
    function cfnInstanceGroupConfigSimpleScalingPolicyConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceGroupConfig_SimpleScalingPolicyConfigurationPropertyValidator(properties).assertSuccess(), { AdjustmentType: cdk.stringToCloudFormation(properties.adjustmentType), CoolDown: cdk.numberToCloudFormation(properties.coolDown), ScalingAdjustment: cdk.numberToCloudFormation(properties.scalingAdjustment) }) : properties;
    }
    function CfnInstanceGroupConfigSimpleScalingPolicyConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("adjustmentType", "AdjustmentType", properties.AdjustmentType != null ? cfn_parse.FromCloudFormation.getString(properties.AdjustmentType) : void 0), ret.addPropertyResult("coolDown", "CoolDown", properties.CoolDown != null ? cfn_parse.FromCloudFormation.getNumber(properties.CoolDown) : void 0), ret.addPropertyResult("scalingAdjustment", "ScalingAdjustment", cfn_parse.FromCloudFormation.getNumber(properties.ScalingAdjustment)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstanceGroupConfig_VolumeSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("iops", cdk.validateNumber)(properties.iops)), errors.collect(cdk.propertyValidator("sizeInGb", cdk.requiredValidator)(properties.sizeInGb)), errors.collect(cdk.propertyValidator("sizeInGb", cdk.validateNumber)(properties.sizeInGb)), errors.collect(cdk.propertyValidator("volumeType", cdk.requiredValidator)(properties.volumeType)), errors.collect(cdk.propertyValidator("volumeType", cdk.validateString)(properties.volumeType)), errors.wrap('supplied properties not correct for "VolumeSpecificationProperty"');
    }
    function cfnInstanceGroupConfigVolumeSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceGroupConfig_VolumeSpecificationPropertyValidator(properties).assertSuccess(), { Iops: cdk.numberToCloudFormation(properties.iops), SizeInGB: cdk.numberToCloudFormation(properties.sizeInGb), VolumeType: cdk.stringToCloudFormation(properties.volumeType) }) : properties;
    }
    function CfnInstanceGroupConfigVolumeSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("iops", "Iops", properties.Iops != null ? cfn_parse.FromCloudFormation.getNumber(properties.Iops) : void 0), ret.addPropertyResult("sizeInGb", "SizeInGB", cfn_parse.FromCloudFormation.getNumber(properties.SizeInGB)), ret.addPropertyResult("volumeType", "VolumeType", cfn_parse.FromCloudFormation.getString(properties.VolumeType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSecurityConfigurationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("securityConfiguration", cdk.requiredValidator)(properties.securityConfiguration)), errors.collect(cdk.propertyValidator("securityConfiguration", cdk.validateObject)(properties.securityConfiguration)), errors.wrap('supplied properties not correct for "CfnSecurityConfigurationProps"');
    }
    function cfnSecurityConfigurationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSecurityConfigurationPropsValidator(properties).assertSuccess(), { SecurityConfiguration: cdk.objectToCloudFormation(properties.securityConfiguration), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnSecurityConfigurationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityConfiguration", "SecurityConfiguration", cfn_parse.FromCloudFormation.getAny(properties.SecurityConfiguration)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSecurityConfiguration = class _CfnSecurityConfiguration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSecurityConfigurationPropsFromCloudFormation(resourceProperties), ret = new _CfnSecurityConfiguration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSecurityConfiguration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_emr_CfnSecurityConfigurationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSecurityConfiguration), error;
        }
        cdk.requireProperty(props, "securityConfiguration", this), this.securityConfiguration = props.securityConfiguration, this.name = props.name;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSecurityConfiguration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { securityConfiguration: this.securityConfiguration, name: this.name };
      }
      renderProperties(props) {
        return cfnSecurityConfigurationPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnSecurityConfiguration[_d] = { fqn: "aws-cdk-lib.aws_emr.CfnSecurityConfiguration", version: "2.80.0" }, CfnSecurityConfiguration.CFN_RESOURCE_TYPE_NAME = "AWS::EMR::SecurityConfiguration", exports2.CfnSecurityConfiguration = CfnSecurityConfiguration;
    function CfnStepPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actionOnFailure", cdk.requiredValidator)(properties.actionOnFailure)), errors.collect(cdk.propertyValidator("actionOnFailure", cdk.validateString)(properties.actionOnFailure)), errors.collect(cdk.propertyValidator("hadoopJarStep", cdk.requiredValidator)(properties.hadoopJarStep)), errors.collect(cdk.propertyValidator("hadoopJarStep", CfnStep_HadoopJarStepConfigPropertyValidator)(properties.hadoopJarStep)), errors.collect(cdk.propertyValidator("jobFlowId", cdk.requiredValidator)(properties.jobFlowId)), errors.collect(cdk.propertyValidator("jobFlowId", cdk.validateString)(properties.jobFlowId)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "CfnStepProps"');
    }
    function cfnStepPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStepPropsValidator(properties).assertSuccess(), { ActionOnFailure: cdk.stringToCloudFormation(properties.actionOnFailure), HadoopJarStep: cfnStepHadoopJarStepConfigPropertyToCloudFormation(properties.hadoopJarStep), JobFlowId: cdk.stringToCloudFormation(properties.jobFlowId), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnStepPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actionOnFailure", "ActionOnFailure", cfn_parse.FromCloudFormation.getString(properties.ActionOnFailure)), ret.addPropertyResult("hadoopJarStep", "HadoopJarStep", CfnStepHadoopJarStepConfigPropertyFromCloudFormation(properties.HadoopJarStep)), ret.addPropertyResult("jobFlowId", "JobFlowId", cfn_parse.FromCloudFormation.getString(properties.JobFlowId)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnStep = class _CfnStep extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnStepPropsFromCloudFormation(resourceProperties), ret = new _CfnStep(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnStep.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_emr_CfnStepProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnStep), error;
        }
        cdk.requireProperty(props, "actionOnFailure", this), cdk.requireProperty(props, "hadoopJarStep", this), cdk.requireProperty(props, "jobFlowId", this), cdk.requireProperty(props, "name", this), this.actionOnFailure = props.actionOnFailure, this.hadoopJarStep = props.hadoopJarStep, this.jobFlowId = props.jobFlowId, this.name = props.name;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStep.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { actionOnFailure: this.actionOnFailure, hadoopJarStep: this.hadoopJarStep, jobFlowId: this.jobFlowId, name: this.name };
      }
      renderProperties(props) {
        return cfnStepPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnStep[_e] = { fqn: "aws-cdk-lib.aws_emr.CfnStep", version: "2.80.0" }, CfnStep.CFN_RESOURCE_TYPE_NAME = "AWS::EMR::Step", exports2.CfnStep = CfnStep;
    function CfnStep_HadoopJarStepConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("args", cdk.listValidator(cdk.validateString))(properties.args)), errors.collect(cdk.propertyValidator("jar", cdk.requiredValidator)(properties.jar)), errors.collect(cdk.propertyValidator("jar", cdk.validateString)(properties.jar)), errors.collect(cdk.propertyValidator("mainClass", cdk.validateString)(properties.mainClass)), errors.collect(cdk.propertyValidator("stepProperties", cdk.listValidator(CfnStep_KeyValuePropertyValidator))(properties.stepProperties)), errors.wrap('supplied properties not correct for "HadoopJarStepConfigProperty"');
    }
    function cfnStepHadoopJarStepConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStep_HadoopJarStepConfigPropertyValidator(properties).assertSuccess(), { Args: cdk.listMapper(cdk.stringToCloudFormation)(properties.args), Jar: cdk.stringToCloudFormation(properties.jar), MainClass: cdk.stringToCloudFormation(properties.mainClass), StepProperties: cdk.listMapper(cfnStepKeyValuePropertyToCloudFormation)(properties.stepProperties) }) : properties;
    }
    function CfnStepHadoopJarStepConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("args", "Args", properties.Args != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Args) : void 0), ret.addPropertyResult("jar", "Jar", cfn_parse.FromCloudFormation.getString(properties.Jar)), ret.addPropertyResult("mainClass", "MainClass", properties.MainClass != null ? cfn_parse.FromCloudFormation.getString(properties.MainClass) : void 0), ret.addPropertyResult("stepProperties", "StepProperties", properties.StepProperties != null ? cfn_parse.FromCloudFormation.getArray(CfnStepKeyValuePropertyFromCloudFormation)(properties.StepProperties) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStep_KeyValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "KeyValueProperty"');
    }
    function cfnStepKeyValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStep_KeyValuePropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnStepKeyValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStudioPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authMode", cdk.requiredValidator)(properties.authMode)), errors.collect(cdk.propertyValidator("authMode", cdk.validateString)(properties.authMode)), errors.collect(cdk.propertyValidator("defaultS3Location", cdk.requiredValidator)(properties.defaultS3Location)), errors.collect(cdk.propertyValidator("defaultS3Location", cdk.validateString)(properties.defaultS3Location)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("engineSecurityGroupId", cdk.requiredValidator)(properties.engineSecurityGroupId)), errors.collect(cdk.propertyValidator("engineSecurityGroupId", cdk.validateString)(properties.engineSecurityGroupId)), errors.collect(cdk.propertyValidator("idpAuthUrl", cdk.validateString)(properties.idpAuthUrl)), errors.collect(cdk.propertyValidator("idpRelayStateParameterName", cdk.validateString)(properties.idpRelayStateParameterName)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("serviceRole", cdk.requiredValidator)(properties.serviceRole)), errors.collect(cdk.propertyValidator("serviceRole", cdk.validateString)(properties.serviceRole)), errors.collect(cdk.propertyValidator("subnetIds", cdk.requiredValidator)(properties.subnetIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("userRole", cdk.validateString)(properties.userRole)), errors.collect(cdk.propertyValidator("vpcId", cdk.requiredValidator)(properties.vpcId)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.collect(cdk.propertyValidator("workspaceSecurityGroupId", cdk.requiredValidator)(properties.workspaceSecurityGroupId)), errors.collect(cdk.propertyValidator("workspaceSecurityGroupId", cdk.validateString)(properties.workspaceSecurityGroupId)), errors.wrap('supplied properties not correct for "CfnStudioProps"');
    }
    function cfnStudioPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStudioPropsValidator(properties).assertSuccess(), { AuthMode: cdk.stringToCloudFormation(properties.authMode), DefaultS3Location: cdk.stringToCloudFormation(properties.defaultS3Location), EngineSecurityGroupId: cdk.stringToCloudFormation(properties.engineSecurityGroupId), Name: cdk.stringToCloudFormation(properties.name), ServiceRole: cdk.stringToCloudFormation(properties.serviceRole), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds), VpcId: cdk.stringToCloudFormation(properties.vpcId), WorkspaceSecurityGroupId: cdk.stringToCloudFormation(properties.workspaceSecurityGroupId), Description: cdk.stringToCloudFormation(properties.description), IdpAuthUrl: cdk.stringToCloudFormation(properties.idpAuthUrl), IdpRelayStateParameterName: cdk.stringToCloudFormation(properties.idpRelayStateParameterName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), UserRole: cdk.stringToCloudFormation(properties.userRole) }) : properties;
    }
    function CfnStudioPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authMode", "AuthMode", cfn_parse.FromCloudFormation.getString(properties.AuthMode)), ret.addPropertyResult("defaultS3Location", "DefaultS3Location", cfn_parse.FromCloudFormation.getString(properties.DefaultS3Location)), ret.addPropertyResult("engineSecurityGroupId", "EngineSecurityGroupId", cfn_parse.FromCloudFormation.getString(properties.EngineSecurityGroupId)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("serviceRole", "ServiceRole", cfn_parse.FromCloudFormation.getString(properties.ServiceRole)), ret.addPropertyResult("subnetIds", "SubnetIds", cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds)), ret.addPropertyResult("vpcId", "VpcId", cfn_parse.FromCloudFormation.getString(properties.VpcId)), ret.addPropertyResult("workspaceSecurityGroupId", "WorkspaceSecurityGroupId", cfn_parse.FromCloudFormation.getString(properties.WorkspaceSecurityGroupId)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("idpAuthUrl", "IdpAuthUrl", properties.IdpAuthUrl != null ? cfn_parse.FromCloudFormation.getString(properties.IdpAuthUrl) : void 0), ret.addPropertyResult("idpRelayStateParameterName", "IdpRelayStateParameterName", properties.IdpRelayStateParameterName != null ? cfn_parse.FromCloudFormation.getString(properties.IdpRelayStateParameterName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("userRole", "UserRole", properties.UserRole != null ? cfn_parse.FromCloudFormation.getString(properties.UserRole) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnStudio = class _CfnStudio extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnStudioPropsFromCloudFormation(resourceProperties), ret = new _CfnStudio(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnStudio.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_emr_CfnStudioProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnStudio), error;
        }
        cdk.requireProperty(props, "authMode", this), cdk.requireProperty(props, "defaultS3Location", this), cdk.requireProperty(props, "engineSecurityGroupId", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "serviceRole", this), cdk.requireProperty(props, "subnetIds", this), cdk.requireProperty(props, "vpcId", this), cdk.requireProperty(props, "workspaceSecurityGroupId", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrStudioId = cdk.Token.asString(this.getAtt("StudioId", cdk.ResolutionTypeHint.STRING)), this.attrUrl = cdk.Token.asString(this.getAtt("Url", cdk.ResolutionTypeHint.STRING)), this.authMode = props.authMode, this.defaultS3Location = props.defaultS3Location, this.engineSecurityGroupId = props.engineSecurityGroupId, this.name = props.name, this.serviceRole = props.serviceRole, this.subnetIds = props.subnetIds, this.vpcId = props.vpcId, this.workspaceSecurityGroupId = props.workspaceSecurityGroupId, this.description = props.description, this.idpAuthUrl = props.idpAuthUrl, this.idpRelayStateParameterName = props.idpRelayStateParameterName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EMR::Studio", props.tags, { tagPropertyName: "tags" }), this.userRole = props.userRole;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStudio.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { authMode: this.authMode, defaultS3Location: this.defaultS3Location, engineSecurityGroupId: this.engineSecurityGroupId, name: this.name, serviceRole: this.serviceRole, subnetIds: this.subnetIds, vpcId: this.vpcId, workspaceSecurityGroupId: this.workspaceSecurityGroupId, description: this.description, idpAuthUrl: this.idpAuthUrl, idpRelayStateParameterName: this.idpRelayStateParameterName, tags: this.tags.renderTags(), userRole: this.userRole };
      }
      renderProperties(props) {
        return cfnStudioPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnStudio[_f] = { fqn: "aws-cdk-lib.aws_emr.CfnStudio", version: "2.80.0" }, CfnStudio.CFN_RESOURCE_TYPE_NAME = "AWS::EMR::Studio", exports2.CfnStudio = CfnStudio;
    function CfnStudioSessionMappingPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("identityName", cdk.requiredValidator)(properties.identityName)), errors.collect(cdk.propertyValidator("identityName", cdk.validateString)(properties.identityName)), errors.collect(cdk.propertyValidator("identityType", cdk.requiredValidator)(properties.identityType)), errors.collect(cdk.propertyValidator("identityType", cdk.validateString)(properties.identityType)), errors.collect(cdk.propertyValidator("sessionPolicyArn", cdk.requiredValidator)(properties.sessionPolicyArn)), errors.collect(cdk.propertyValidator("sessionPolicyArn", cdk.validateString)(properties.sessionPolicyArn)), errors.collect(cdk.propertyValidator("studioId", cdk.requiredValidator)(properties.studioId)), errors.collect(cdk.propertyValidator("studioId", cdk.validateString)(properties.studioId)), errors.wrap('supplied properties not correct for "CfnStudioSessionMappingProps"');
    }
    function cfnStudioSessionMappingPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStudioSessionMappingPropsValidator(properties).assertSuccess(), { IdentityName: cdk.stringToCloudFormation(properties.identityName), IdentityType: cdk.stringToCloudFormation(properties.identityType), SessionPolicyArn: cdk.stringToCloudFormation(properties.sessionPolicyArn), StudioId: cdk.stringToCloudFormation(properties.studioId) }) : properties;
    }
    function CfnStudioSessionMappingPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("identityName", "IdentityName", cfn_parse.FromCloudFormation.getString(properties.IdentityName)), ret.addPropertyResult("identityType", "IdentityType", cfn_parse.FromCloudFormation.getString(properties.IdentityType)), ret.addPropertyResult("sessionPolicyArn", "SessionPolicyArn", cfn_parse.FromCloudFormation.getString(properties.SessionPolicyArn)), ret.addPropertyResult("studioId", "StudioId", cfn_parse.FromCloudFormation.getString(properties.StudioId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnStudioSessionMapping = class _CfnStudioSessionMapping extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnStudioSessionMappingPropsFromCloudFormation(resourceProperties), ret = new _CfnStudioSessionMapping(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnStudioSessionMapping.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_emr_CfnStudioSessionMappingProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnStudioSessionMapping), error;
        }
        cdk.requireProperty(props, "identityName", this), cdk.requireProperty(props, "identityType", this), cdk.requireProperty(props, "sessionPolicyArn", this), cdk.requireProperty(props, "studioId", this), this.identityName = props.identityName, this.identityType = props.identityType, this.sessionPolicyArn = props.sessionPolicyArn, this.studioId = props.studioId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStudioSessionMapping.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { identityName: this.identityName, identityType: this.identityType, sessionPolicyArn: this.sessionPolicyArn, studioId: this.studioId };
      }
      renderProperties(props) {
        return cfnStudioSessionMappingPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnStudioSessionMapping[_g] = { fqn: "aws-cdk-lib.aws_emr.CfnStudioSessionMapping", version: "2.80.0" }, CfnStudioSessionMapping.CFN_RESOURCE_TYPE_NAME = "AWS::EMR::StudioSessionMapping", exports2.CfnStudioSessionMapping = CfnStudioSessionMapping;
  }
});

// node_modules/aws-cdk-lib/aws-emr/lib/index.js
var require_lib123 = __commonJS({
  "node_modules/aws-cdk-lib/aws-emr/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_emr_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-emr/index.js
var require_aws_emr = __commonJS({
  "node_modules/aws-cdk-lib/aws-emr/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib123(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-emrcontainers/lib/emrcontainers.generated.js
var require_emrcontainers_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-emrcontainers/lib/emrcontainers.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnVirtualCluster = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnVirtualClusterPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containerProvider", cdk.requiredValidator)(properties.containerProvider)), errors.collect(cdk.propertyValidator("containerProvider", CfnVirtualCluster_ContainerProviderPropertyValidator)(properties.containerProvider)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnVirtualClusterProps"');
    }
    function cfnVirtualClusterPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualClusterPropsValidator(properties).assertSuccess(), { ContainerProvider: cfnVirtualClusterContainerProviderPropertyToCloudFormation(properties.containerProvider), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnVirtualClusterPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containerProvider", "ContainerProvider", CfnVirtualClusterContainerProviderPropertyFromCloudFormation(properties.ContainerProvider)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVirtualCluster = class _CfnVirtualCluster extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVirtualClusterPropsFromCloudFormation(resourceProperties), ret = new _CfnVirtualCluster(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVirtualCluster.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_emrcontainers_CfnVirtualClusterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVirtualCluster), error;
        }
        cdk.requireProperty(props, "containerProvider", this), cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.containerProvider = props.containerProvider, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EMRContainers::VirtualCluster", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVirtualCluster.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { containerProvider: this.containerProvider, name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnVirtualClusterPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnVirtualCluster[_a] = { fqn: "aws-cdk-lib.aws_emrcontainers.CfnVirtualCluster", version: "2.80.0" }, CfnVirtualCluster.CFN_RESOURCE_TYPE_NAME = "AWS::EMRContainers::VirtualCluster", exports2.CfnVirtualCluster = CfnVirtualCluster;
    function CfnVirtualCluster_ContainerInfoPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("eksInfo", cdk.requiredValidator)(properties.eksInfo)), errors.collect(cdk.propertyValidator("eksInfo", CfnVirtualCluster_EksInfoPropertyValidator)(properties.eksInfo)), errors.wrap('supplied properties not correct for "ContainerInfoProperty"');
    }
    function cfnVirtualClusterContainerInfoPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualCluster_ContainerInfoPropertyValidator(properties).assertSuccess(), { EksInfo: cfnVirtualClusterEksInfoPropertyToCloudFormation(properties.eksInfo) }) : properties;
    }
    function CfnVirtualClusterContainerInfoPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("eksInfo", "EksInfo", CfnVirtualClusterEksInfoPropertyFromCloudFormation(properties.EksInfo)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualCluster_ContainerProviderPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("info", cdk.requiredValidator)(properties.info)), errors.collect(cdk.propertyValidator("info", CfnVirtualCluster_ContainerInfoPropertyValidator)(properties.info)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "ContainerProviderProperty"');
    }
    function cfnVirtualClusterContainerProviderPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualCluster_ContainerProviderPropertyValidator(properties).assertSuccess(), { Id: cdk.stringToCloudFormation(properties.id), Info: cfnVirtualClusterContainerInfoPropertyToCloudFormation(properties.info), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnVirtualClusterContainerProviderPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("info", "Info", CfnVirtualClusterContainerInfoPropertyFromCloudFormation(properties.Info)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVirtualCluster_EksInfoPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("namespace", cdk.requiredValidator)(properties.namespace)), errors.collect(cdk.propertyValidator("namespace", cdk.validateString)(properties.namespace)), errors.wrap('supplied properties not correct for "EksInfoProperty"');
    }
    function cfnVirtualClusterEksInfoPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVirtualCluster_EksInfoPropertyValidator(properties).assertSuccess(), { Namespace: cdk.stringToCloudFormation(properties.namespace) }) : properties;
    }
    function CfnVirtualClusterEksInfoPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("namespace", "Namespace", cfn_parse.FromCloudFormation.getString(properties.Namespace)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-emrcontainers/lib/index.js
var require_lib124 = __commonJS({
  "node_modules/aws-cdk-lib/aws-emrcontainers/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_emrcontainers_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-emrcontainers/index.js
var require_aws_emrcontainers = __commonJS({
  "node_modules/aws-cdk-lib/aws-emrcontainers/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib124(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-emrserverless/lib/emrserverless.generated.js
var require_emrserverless_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-emrserverless/lib/emrserverless.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnApplication = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnApplicationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("architecture", cdk.validateString)(properties.architecture)), errors.collect(cdk.propertyValidator("autoStartConfiguration", CfnApplication_AutoStartConfigurationPropertyValidator)(properties.autoStartConfiguration)), errors.collect(cdk.propertyValidator("autoStopConfiguration", CfnApplication_AutoStopConfigurationPropertyValidator)(properties.autoStopConfiguration)), errors.collect(cdk.propertyValidator("imageConfiguration", CfnApplication_ImageConfigurationInputPropertyValidator)(properties.imageConfiguration)), errors.collect(cdk.propertyValidator("initialCapacity", cdk.listValidator(CfnApplication_InitialCapacityConfigKeyValuePairPropertyValidator))(properties.initialCapacity)), errors.collect(cdk.propertyValidator("maximumCapacity", CfnApplication_MaximumAllowedResourcesPropertyValidator)(properties.maximumCapacity)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("networkConfiguration", CfnApplication_NetworkConfigurationPropertyValidator)(properties.networkConfiguration)), errors.collect(cdk.propertyValidator("releaseLabel", cdk.requiredValidator)(properties.releaseLabel)), errors.collect(cdk.propertyValidator("releaseLabel", cdk.validateString)(properties.releaseLabel)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("workerTypeSpecifications", cdk.hashValidator(CfnApplication_WorkerTypeSpecificationInputPropertyValidator))(properties.workerTypeSpecifications)), errors.wrap('supplied properties not correct for "CfnApplicationProps"');
    }
    function cfnApplicationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationPropsValidator(properties).assertSuccess(), { ReleaseLabel: cdk.stringToCloudFormation(properties.releaseLabel), Type: cdk.stringToCloudFormation(properties.type), Architecture: cdk.stringToCloudFormation(properties.architecture), AutoStartConfiguration: cfnApplicationAutoStartConfigurationPropertyToCloudFormation(properties.autoStartConfiguration), AutoStopConfiguration: cfnApplicationAutoStopConfigurationPropertyToCloudFormation(properties.autoStopConfiguration), ImageConfiguration: cfnApplicationImageConfigurationInputPropertyToCloudFormation(properties.imageConfiguration), InitialCapacity: cdk.listMapper(cfnApplicationInitialCapacityConfigKeyValuePairPropertyToCloudFormation)(properties.initialCapacity), MaximumCapacity: cfnApplicationMaximumAllowedResourcesPropertyToCloudFormation(properties.maximumCapacity), Name: cdk.stringToCloudFormation(properties.name), NetworkConfiguration: cfnApplicationNetworkConfigurationPropertyToCloudFormation(properties.networkConfiguration), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), WorkerTypeSpecifications: cdk.hashMapper(cfnApplicationWorkerTypeSpecificationInputPropertyToCloudFormation)(properties.workerTypeSpecifications) }) : properties;
    }
    function CfnApplicationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("releaseLabel", "ReleaseLabel", cfn_parse.FromCloudFormation.getString(properties.ReleaseLabel)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("architecture", "Architecture", properties.Architecture != null ? cfn_parse.FromCloudFormation.getString(properties.Architecture) : void 0), ret.addPropertyResult("autoStartConfiguration", "AutoStartConfiguration", properties.AutoStartConfiguration != null ? CfnApplicationAutoStartConfigurationPropertyFromCloudFormation(properties.AutoStartConfiguration) : void 0), ret.addPropertyResult("autoStopConfiguration", "AutoStopConfiguration", properties.AutoStopConfiguration != null ? CfnApplicationAutoStopConfigurationPropertyFromCloudFormation(properties.AutoStopConfiguration) : void 0), ret.addPropertyResult("imageConfiguration", "ImageConfiguration", properties.ImageConfiguration != null ? CfnApplicationImageConfigurationInputPropertyFromCloudFormation(properties.ImageConfiguration) : void 0), ret.addPropertyResult("initialCapacity", "InitialCapacity", properties.InitialCapacity != null ? cfn_parse.FromCloudFormation.getArray(CfnApplicationInitialCapacityConfigKeyValuePairPropertyFromCloudFormation)(properties.InitialCapacity) : void 0), ret.addPropertyResult("maximumCapacity", "MaximumCapacity", properties.MaximumCapacity != null ? CfnApplicationMaximumAllowedResourcesPropertyFromCloudFormation(properties.MaximumCapacity) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("networkConfiguration", "NetworkConfiguration", properties.NetworkConfiguration != null ? CfnApplicationNetworkConfigurationPropertyFromCloudFormation(properties.NetworkConfiguration) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("workerTypeSpecifications", "WorkerTypeSpecifications", properties.WorkerTypeSpecifications != null ? cfn_parse.FromCloudFormation.getMap(CfnApplicationWorkerTypeSpecificationInputPropertyFromCloudFormation)(properties.WorkerTypeSpecifications) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApplication = class _CfnApplication extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApplicationPropsFromCloudFormation(resourceProperties), ret = new _CfnApplication(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApplication.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_emrserverless_CfnApplicationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApplication), error;
        }
        cdk.requireProperty(props, "releaseLabel", this), cdk.requireProperty(props, "type", this), this.attrApplicationId = cdk.Token.asString(this.getAtt("ApplicationId", cdk.ResolutionTypeHint.STRING)), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.releaseLabel = props.releaseLabel, this.type = props.type, this.architecture = props.architecture, this.autoStartConfiguration = props.autoStartConfiguration, this.autoStopConfiguration = props.autoStopConfiguration, this.imageConfiguration = props.imageConfiguration, this.initialCapacity = props.initialCapacity, this.maximumCapacity = props.maximumCapacity, this.name = props.name, this.networkConfiguration = props.networkConfiguration, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EMRServerless::Application", props.tags, { tagPropertyName: "tags" }), this.workerTypeSpecifications = props.workerTypeSpecifications;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApplication.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { releaseLabel: this.releaseLabel, type: this.type, architecture: this.architecture, autoStartConfiguration: this.autoStartConfiguration, autoStopConfiguration: this.autoStopConfiguration, imageConfiguration: this.imageConfiguration, initialCapacity: this.initialCapacity, maximumCapacity: this.maximumCapacity, name: this.name, networkConfiguration: this.networkConfiguration, tags: this.tags.renderTags(), workerTypeSpecifications: this.workerTypeSpecifications };
      }
      renderProperties(props) {
        return cfnApplicationPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnApplication[_a] = { fqn: "aws-cdk-lib.aws_emrserverless.CfnApplication", version: "2.80.0" }, CfnApplication.CFN_RESOURCE_TYPE_NAME = "AWS::EMRServerless::Application", exports2.CfnApplication = CfnApplication;
    function CfnApplication_AutoStartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "AutoStartConfigurationProperty"');
    }
    function cfnApplicationAutoStartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_AutoStartConfigurationPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnApplicationAutoStartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_AutoStopConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("idleTimeoutMinutes", cdk.validateNumber)(properties.idleTimeoutMinutes)), errors.wrap('supplied properties not correct for "AutoStopConfigurationProperty"');
    }
    function cfnApplicationAutoStopConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_AutoStopConfigurationPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled), IdleTimeoutMinutes: cdk.numberToCloudFormation(properties.idleTimeoutMinutes) }) : properties;
    }
    function CfnApplicationAutoStopConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("idleTimeoutMinutes", "IdleTimeoutMinutes", properties.IdleTimeoutMinutes != null ? cfn_parse.FromCloudFormation.getNumber(properties.IdleTimeoutMinutes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_ImageConfigurationInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("imageUri", cdk.validateString)(properties.imageUri)), errors.wrap('supplied properties not correct for "ImageConfigurationInputProperty"');
    }
    function cfnApplicationImageConfigurationInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_ImageConfigurationInputPropertyValidator(properties).assertSuccess(), { ImageUri: cdk.stringToCloudFormation(properties.imageUri) }) : properties;
    }
    function CfnApplicationImageConfigurationInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("imageUri", "ImageUri", properties.ImageUri != null ? cfn_parse.FromCloudFormation.getString(properties.ImageUri) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_InitialCapacityConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("workerConfiguration", cdk.requiredValidator)(properties.workerConfiguration)), errors.collect(cdk.propertyValidator("workerConfiguration", CfnApplication_WorkerConfigurationPropertyValidator)(properties.workerConfiguration)), errors.collect(cdk.propertyValidator("workerCount", cdk.requiredValidator)(properties.workerCount)), errors.collect(cdk.propertyValidator("workerCount", cdk.validateNumber)(properties.workerCount)), errors.wrap('supplied properties not correct for "InitialCapacityConfigProperty"');
    }
    function cfnApplicationInitialCapacityConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_InitialCapacityConfigPropertyValidator(properties).assertSuccess(), { WorkerConfiguration: cfnApplicationWorkerConfigurationPropertyToCloudFormation(properties.workerConfiguration), WorkerCount: cdk.numberToCloudFormation(properties.workerCount) }) : properties;
    }
    function CfnApplicationInitialCapacityConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("workerConfiguration", "WorkerConfiguration", CfnApplicationWorkerConfigurationPropertyFromCloudFormation(properties.WorkerConfiguration)), ret.addPropertyResult("workerCount", "WorkerCount", cfn_parse.FromCloudFormation.getNumber(properties.WorkerCount)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_InitialCapacityConfigKeyValuePairPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", CfnApplication_InitialCapacityConfigPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "InitialCapacityConfigKeyValuePairProperty"');
    }
    function cfnApplicationInitialCapacityConfigKeyValuePairPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_InitialCapacityConfigKeyValuePairPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cfnApplicationInitialCapacityConfigPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnApplicationInitialCapacityConfigKeyValuePairPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", CfnApplicationInitialCapacityConfigPropertyFromCloudFormation(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_MaximumAllowedResourcesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cpu", cdk.requiredValidator)(properties.cpu)), errors.collect(cdk.propertyValidator("cpu", cdk.validateString)(properties.cpu)), errors.collect(cdk.propertyValidator("disk", cdk.validateString)(properties.disk)), errors.collect(cdk.propertyValidator("memory", cdk.requiredValidator)(properties.memory)), errors.collect(cdk.propertyValidator("memory", cdk.validateString)(properties.memory)), errors.wrap('supplied properties not correct for "MaximumAllowedResourcesProperty"');
    }
    function cfnApplicationMaximumAllowedResourcesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_MaximumAllowedResourcesPropertyValidator(properties).assertSuccess(), { Cpu: cdk.stringToCloudFormation(properties.cpu), Disk: cdk.stringToCloudFormation(properties.disk), Memory: cdk.stringToCloudFormation(properties.memory) }) : properties;
    }
    function CfnApplicationMaximumAllowedResourcesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cpu", "Cpu", cfn_parse.FromCloudFormation.getString(properties.Cpu)), ret.addPropertyResult("disk", "Disk", properties.Disk != null ? cfn_parse.FromCloudFormation.getString(properties.Disk) : void 0), ret.addPropertyResult("memory", "Memory", cfn_parse.FromCloudFormation.getString(properties.Memory)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_NetworkConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.wrap('supplied properties not correct for "NetworkConfigurationProperty"');
    }
    function cfnApplicationNetworkConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_NetworkConfigurationPropertyValidator(properties).assertSuccess(), { SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds) }) : properties;
    }
    function CfnApplicationNetworkConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("subnetIds", "SubnetIds", properties.SubnetIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_WorkerConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cpu", cdk.requiredValidator)(properties.cpu)), errors.collect(cdk.propertyValidator("cpu", cdk.validateString)(properties.cpu)), errors.collect(cdk.propertyValidator("disk", cdk.validateString)(properties.disk)), errors.collect(cdk.propertyValidator("memory", cdk.requiredValidator)(properties.memory)), errors.collect(cdk.propertyValidator("memory", cdk.validateString)(properties.memory)), errors.wrap('supplied properties not correct for "WorkerConfigurationProperty"');
    }
    function cfnApplicationWorkerConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_WorkerConfigurationPropertyValidator(properties).assertSuccess(), { Cpu: cdk.stringToCloudFormation(properties.cpu), Disk: cdk.stringToCloudFormation(properties.disk), Memory: cdk.stringToCloudFormation(properties.memory) }) : properties;
    }
    function CfnApplicationWorkerConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cpu", "Cpu", cfn_parse.FromCloudFormation.getString(properties.Cpu)), ret.addPropertyResult("disk", "Disk", properties.Disk != null ? cfn_parse.FromCloudFormation.getString(properties.Disk) : void 0), ret.addPropertyResult("memory", "Memory", cfn_parse.FromCloudFormation.getString(properties.Memory)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_WorkerTypeSpecificationInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("imageConfiguration", CfnApplication_ImageConfigurationInputPropertyValidator)(properties.imageConfiguration)), errors.wrap('supplied properties not correct for "WorkerTypeSpecificationInputProperty"');
    }
    function cfnApplicationWorkerTypeSpecificationInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_WorkerTypeSpecificationInputPropertyValidator(properties).assertSuccess(), { ImageConfiguration: cfnApplicationImageConfigurationInputPropertyToCloudFormation(properties.imageConfiguration) }) : properties;
    }
    function CfnApplicationWorkerTypeSpecificationInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("imageConfiguration", "ImageConfiguration", properties.ImageConfiguration != null ? CfnApplicationImageConfigurationInputPropertyFromCloudFormation(properties.ImageConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-emrserverless/lib/index.js
var require_lib125 = __commonJS({
  "node_modules/aws-cdk-lib/aws-emrserverless/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_emrserverless_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-emrserverless/index.js
var require_aws_emrserverless = __commonJS({
  "node_modules/aws-cdk-lib/aws-emrserverless/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib125(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-eventschemas/lib/eventschemas.generated.js
var require_eventschemas_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-eventschemas/lib/eventschemas.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnSchema = exports2.CfnRegistryPolicy = exports2.CfnRegistry = exports2.CfnDiscoverer = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnDiscovererPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("crossAccount", cdk.validateBoolean)(properties.crossAccount)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("sourceArn", cdk.requiredValidator)(properties.sourceArn)), errors.collect(cdk.propertyValidator("sourceArn", cdk.validateString)(properties.sourceArn)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(CfnDiscoverer_TagsEntryPropertyValidator))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDiscovererProps"');
    }
    function cfnDiscovererPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDiscovererPropsValidator(properties).assertSuccess(), { SourceArn: cdk.stringToCloudFormation(properties.sourceArn), CrossAccount: cdk.booleanToCloudFormation(properties.crossAccount), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cfnDiscovererTagsEntryPropertyToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDiscovererPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sourceArn", "SourceArn", cfn_parse.FromCloudFormation.getString(properties.SourceArn)), ret.addPropertyResult("crossAccount", "CrossAccount", properties.CrossAccount != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CrossAccount) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(CfnDiscovererTagsEntryPropertyFromCloudFormation)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDiscoverer = class _CfnDiscoverer extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDiscovererPropsFromCloudFormation(resourceProperties), ret = new _CfnDiscoverer(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDiscoverer.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eventschemas_CfnDiscovererProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDiscoverer), error;
        }
        cdk.requireProperty(props, "sourceArn", this), this.attrCrossAccount = this.getAtt("CrossAccount", cdk.ResolutionTypeHint.STRING), this.attrDiscovererArn = cdk.Token.asString(this.getAtt("DiscovererArn", cdk.ResolutionTypeHint.STRING)), this.attrDiscovererId = cdk.Token.asString(this.getAtt("DiscovererId", cdk.ResolutionTypeHint.STRING)), this.sourceArn = props.sourceArn, this.crossAccount = props.crossAccount, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EventSchemas::Discoverer", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDiscoverer.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { sourceArn: this.sourceArn, crossAccount: this.crossAccount, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDiscovererPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnDiscoverer[_a] = { fqn: "aws-cdk-lib.aws_eventschemas.CfnDiscoverer", version: "2.80.0" }, CfnDiscoverer.CFN_RESOURCE_TYPE_NAME = "AWS::EventSchemas::Discoverer", exports2.CfnDiscoverer = CfnDiscoverer;
    function CfnDiscoverer_TagsEntryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TagsEntryProperty"');
    }
    function cfnDiscovererTagsEntryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDiscoverer_TagsEntryPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnDiscovererTagsEntryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRegistryPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("registryName", cdk.validateString)(properties.registryName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(CfnRegistry_TagsEntryPropertyValidator))(properties.tags)), errors.wrap('supplied properties not correct for "CfnRegistryProps"');
    }
    function cfnRegistryPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRegistryPropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), RegistryName: cdk.stringToCloudFormation(properties.registryName), Tags: cdk.listMapper(cfnRegistryTagsEntryPropertyToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnRegistryPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("registryName", "RegistryName", properties.RegistryName != null ? cfn_parse.FromCloudFormation.getString(properties.RegistryName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(CfnRegistryTagsEntryPropertyFromCloudFormation)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRegistry = class _CfnRegistry extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRegistryPropsFromCloudFormation(resourceProperties), ret = new _CfnRegistry(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnRegistry.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eventschemas_CfnRegistryProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRegistry), error;
        }
        this.attrRegistryArn = cdk.Token.asString(this.getAtt("RegistryArn", cdk.ResolutionTypeHint.STRING)), this.attrRegistryName = cdk.Token.asString(this.getAtt("RegistryName", cdk.ResolutionTypeHint.STRING)), this.description = props.description, this.registryName = props.registryName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EventSchemas::Registry", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRegistry.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, registryName: this.registryName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnRegistryPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnRegistry[_b] = { fqn: "aws-cdk-lib.aws_eventschemas.CfnRegistry", version: "2.80.0" }, CfnRegistry.CFN_RESOURCE_TYPE_NAME = "AWS::EventSchemas::Registry", exports2.CfnRegistry = CfnRegistry;
    function CfnRegistry_TagsEntryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TagsEntryProperty"');
    }
    function cfnRegistryTagsEntryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRegistry_TagsEntryPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnRegistryTagsEntryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRegistryPolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("policy", cdk.requiredValidator)(properties.policy)), errors.collect(cdk.propertyValidator("policy", cdk.validateObject)(properties.policy)), errors.collect(cdk.propertyValidator("registryName", cdk.requiredValidator)(properties.registryName)), errors.collect(cdk.propertyValidator("registryName", cdk.validateString)(properties.registryName)), errors.collect(cdk.propertyValidator("revisionId", cdk.validateString)(properties.revisionId)), errors.wrap('supplied properties not correct for "CfnRegistryPolicyProps"');
    }
    function cfnRegistryPolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRegistryPolicyPropsValidator(properties).assertSuccess(), { Policy: cdk.objectToCloudFormation(properties.policy), RegistryName: cdk.stringToCloudFormation(properties.registryName), RevisionId: cdk.stringToCloudFormation(properties.revisionId) }) : properties;
    }
    function CfnRegistryPolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("policy", "Policy", cfn_parse.FromCloudFormation.getAny(properties.Policy)), ret.addPropertyResult("registryName", "RegistryName", cfn_parse.FromCloudFormation.getString(properties.RegistryName)), ret.addPropertyResult("revisionId", "RevisionId", properties.RevisionId != null ? cfn_parse.FromCloudFormation.getString(properties.RevisionId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRegistryPolicy = class _CfnRegistryPolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRegistryPolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnRegistryPolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRegistryPolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eventschemas_CfnRegistryPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRegistryPolicy), error;
        }
        cdk.requireProperty(props, "policy", this), cdk.requireProperty(props, "registryName", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.policy = props.policy, this.registryName = props.registryName, this.revisionId = props.revisionId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRegistryPolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { policy: this.policy, registryName: this.registryName, revisionId: this.revisionId };
      }
      renderProperties(props) {
        return cfnRegistryPolicyPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnRegistryPolicy[_c] = { fqn: "aws-cdk-lib.aws_eventschemas.CfnRegistryPolicy", version: "2.80.0" }, CfnRegistryPolicy.CFN_RESOURCE_TYPE_NAME = "AWS::EventSchemas::RegistryPolicy", exports2.CfnRegistryPolicy = CfnRegistryPolicy;
    function CfnSchemaPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("content", cdk.requiredValidator)(properties.content)), errors.collect(cdk.propertyValidator("content", cdk.validateString)(properties.content)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("registryName", cdk.requiredValidator)(properties.registryName)), errors.collect(cdk.propertyValidator("registryName", cdk.validateString)(properties.registryName)), errors.collect(cdk.propertyValidator("schemaName", cdk.validateString)(properties.schemaName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(CfnSchema_TagsEntryPropertyValidator))(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnSchemaProps"');
    }
    function cfnSchemaPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSchemaPropsValidator(properties).assertSuccess(), { Content: cdk.stringToCloudFormation(properties.content), RegistryName: cdk.stringToCloudFormation(properties.registryName), Type: cdk.stringToCloudFormation(properties.type), Description: cdk.stringToCloudFormation(properties.description), SchemaName: cdk.stringToCloudFormation(properties.schemaName), Tags: cdk.listMapper(cfnSchemaTagsEntryPropertyToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnSchemaPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("content", "Content", cfn_parse.FromCloudFormation.getString(properties.Content)), ret.addPropertyResult("registryName", "RegistryName", cfn_parse.FromCloudFormation.getString(properties.RegistryName)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("schemaName", "SchemaName", properties.SchemaName != null ? cfn_parse.FromCloudFormation.getString(properties.SchemaName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(CfnSchemaTagsEntryPropertyFromCloudFormation)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSchema = class _CfnSchema extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSchemaPropsFromCloudFormation(resourceProperties), ret = new _CfnSchema(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSchema.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eventschemas_CfnSchemaProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSchema), error;
        }
        cdk.requireProperty(props, "content", this), cdk.requireProperty(props, "registryName", this), cdk.requireProperty(props, "type", this), this.attrSchemaArn = cdk.Token.asString(this.getAtt("SchemaArn", cdk.ResolutionTypeHint.STRING)), this.attrSchemaName = cdk.Token.asString(this.getAtt("SchemaName", cdk.ResolutionTypeHint.STRING)), this.attrSchemaVersion = cdk.Token.asString(this.getAtt("SchemaVersion", cdk.ResolutionTypeHint.STRING)), this.content = props.content, this.registryName = props.registryName, this.type = props.type, this.description = props.description, this.schemaName = props.schemaName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::EventSchemas::Schema", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSchema.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { content: this.content, registryName: this.registryName, type: this.type, description: this.description, schemaName: this.schemaName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnSchemaPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnSchema[_d] = { fqn: "aws-cdk-lib.aws_eventschemas.CfnSchema", version: "2.80.0" }, CfnSchema.CFN_RESOURCE_TYPE_NAME = "AWS::EventSchemas::Schema", exports2.CfnSchema = CfnSchema;
    function CfnSchema_TagsEntryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TagsEntryProperty"');
    }
    function cfnSchemaTagsEntryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSchema_TagsEntryPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnSchemaTagsEntryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-eventschemas/lib/index.js
var require_lib126 = __commonJS({
  "node_modules/aws-cdk-lib/aws-eventschemas/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_eventschemas_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-eventschemas/index.js
var require_aws_eventschemas = __commonJS({
  "node_modules/aws-cdk-lib/aws-eventschemas/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib126(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-evidently/lib/evidently.generated.js
var require_evidently_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-evidently/lib/evidently.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnSegment = exports2.CfnProject = exports2.CfnLaunch = exports2.CfnFeature = exports2.CfnExperiment = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnExperimentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("metricGoals", cdk.requiredValidator)(properties.metricGoals)), errors.collect(cdk.propertyValidator("metricGoals", cdk.listValidator(CfnExperiment_MetricGoalObjectPropertyValidator))(properties.metricGoals)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("onlineAbConfig", cdk.requiredValidator)(properties.onlineAbConfig)), errors.collect(cdk.propertyValidator("onlineAbConfig", CfnExperiment_OnlineAbConfigObjectPropertyValidator)(properties.onlineAbConfig)), errors.collect(cdk.propertyValidator("project", cdk.requiredValidator)(properties.project)), errors.collect(cdk.propertyValidator("project", cdk.validateString)(properties.project)), errors.collect(cdk.propertyValidator("randomizationSalt", cdk.validateString)(properties.randomizationSalt)), errors.collect(cdk.propertyValidator("removeSegment", cdk.validateBoolean)(properties.removeSegment)), errors.collect(cdk.propertyValidator("runningStatus", CfnExperiment_RunningStatusObjectPropertyValidator)(properties.runningStatus)), errors.collect(cdk.propertyValidator("samplingRate", cdk.validateNumber)(properties.samplingRate)), errors.collect(cdk.propertyValidator("segment", cdk.validateString)(properties.segment)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("treatments", cdk.requiredValidator)(properties.treatments)), errors.collect(cdk.propertyValidator("treatments", cdk.listValidator(CfnExperiment_TreatmentObjectPropertyValidator))(properties.treatments)), errors.wrap('supplied properties not correct for "CfnExperimentProps"');
    }
    function cfnExperimentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnExperimentPropsValidator(properties).assertSuccess(), { MetricGoals: cdk.listMapper(cfnExperimentMetricGoalObjectPropertyToCloudFormation)(properties.metricGoals), Name: cdk.stringToCloudFormation(properties.name), OnlineAbConfig: cfnExperimentOnlineAbConfigObjectPropertyToCloudFormation(properties.onlineAbConfig), Project: cdk.stringToCloudFormation(properties.project), Treatments: cdk.listMapper(cfnExperimentTreatmentObjectPropertyToCloudFormation)(properties.treatments), Description: cdk.stringToCloudFormation(properties.description), RandomizationSalt: cdk.stringToCloudFormation(properties.randomizationSalt), RemoveSegment: cdk.booleanToCloudFormation(properties.removeSegment), RunningStatus: cfnExperimentRunningStatusObjectPropertyToCloudFormation(properties.runningStatus), SamplingRate: cdk.numberToCloudFormation(properties.samplingRate), Segment: cdk.stringToCloudFormation(properties.segment), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnExperimentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("metricGoals", "MetricGoals", cfn_parse.FromCloudFormation.getArray(CfnExperimentMetricGoalObjectPropertyFromCloudFormation)(properties.MetricGoals)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("onlineAbConfig", "OnlineAbConfig", CfnExperimentOnlineAbConfigObjectPropertyFromCloudFormation(properties.OnlineAbConfig)), ret.addPropertyResult("project", "Project", cfn_parse.FromCloudFormation.getString(properties.Project)), ret.addPropertyResult("treatments", "Treatments", cfn_parse.FromCloudFormation.getArray(CfnExperimentTreatmentObjectPropertyFromCloudFormation)(properties.Treatments)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("randomizationSalt", "RandomizationSalt", properties.RandomizationSalt != null ? cfn_parse.FromCloudFormation.getString(properties.RandomizationSalt) : void 0), ret.addPropertyResult("removeSegment", "RemoveSegment", properties.RemoveSegment != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RemoveSegment) : void 0), ret.addPropertyResult("runningStatus", "RunningStatus", properties.RunningStatus != null ? CfnExperimentRunningStatusObjectPropertyFromCloudFormation(properties.RunningStatus) : void 0), ret.addPropertyResult("samplingRate", "SamplingRate", properties.SamplingRate != null ? cfn_parse.FromCloudFormation.getNumber(properties.SamplingRate) : void 0), ret.addPropertyResult("segment", "Segment", properties.Segment != null ? cfn_parse.FromCloudFormation.getString(properties.Segment) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnExperiment = class _CfnExperiment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnExperimentPropsFromCloudFormation(resourceProperties), ret = new _CfnExperiment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnExperiment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_evidently_CfnExperimentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnExperiment), error;
        }
        cdk.requireProperty(props, "metricGoals", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "onlineAbConfig", this), cdk.requireProperty(props, "project", this), cdk.requireProperty(props, "treatments", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.metricGoals = props.metricGoals, this.name = props.name, this.onlineAbConfig = props.onlineAbConfig, this.project = props.project, this.treatments = props.treatments, this.description = props.description, this.randomizationSalt = props.randomizationSalt, this.removeSegment = props.removeSegment, this.runningStatus = props.runningStatus, this.samplingRate = props.samplingRate, this.segment = props.segment, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Evidently::Experiment", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnExperiment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { metricGoals: this.metricGoals, name: this.name, onlineAbConfig: this.onlineAbConfig, project: this.project, treatments: this.treatments, description: this.description, randomizationSalt: this.randomizationSalt, removeSegment: this.removeSegment, runningStatus: this.runningStatus, samplingRate: this.samplingRate, segment: this.segment, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnExperimentPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnExperiment[_a] = { fqn: "aws-cdk-lib.aws_evidently.CfnExperiment", version: "2.80.0" }, CfnExperiment.CFN_RESOURCE_TYPE_NAME = "AWS::Evidently::Experiment", exports2.CfnExperiment = CfnExperiment;
    function CfnExperiment_MetricGoalObjectPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("desiredChange", cdk.requiredValidator)(properties.desiredChange)), errors.collect(cdk.propertyValidator("desiredChange", cdk.validateString)(properties.desiredChange)), errors.collect(cdk.propertyValidator("entityIdKey", cdk.requiredValidator)(properties.entityIdKey)), errors.collect(cdk.propertyValidator("entityIdKey", cdk.validateString)(properties.entityIdKey)), errors.collect(cdk.propertyValidator("eventPattern", cdk.validateString)(properties.eventPattern)), errors.collect(cdk.propertyValidator("metricName", cdk.requiredValidator)(properties.metricName)), errors.collect(cdk.propertyValidator("metricName", cdk.validateString)(properties.metricName)), errors.collect(cdk.propertyValidator("unitLabel", cdk.validateString)(properties.unitLabel)), errors.collect(cdk.propertyValidator("valueKey", cdk.requiredValidator)(properties.valueKey)), errors.collect(cdk.propertyValidator("valueKey", cdk.validateString)(properties.valueKey)), errors.wrap('supplied properties not correct for "MetricGoalObjectProperty"');
    }
    function cfnExperimentMetricGoalObjectPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnExperiment_MetricGoalObjectPropertyValidator(properties).assertSuccess(), { DesiredChange: cdk.stringToCloudFormation(properties.desiredChange), EntityIdKey: cdk.stringToCloudFormation(properties.entityIdKey), EventPattern: cdk.stringToCloudFormation(properties.eventPattern), MetricName: cdk.stringToCloudFormation(properties.metricName), UnitLabel: cdk.stringToCloudFormation(properties.unitLabel), ValueKey: cdk.stringToCloudFormation(properties.valueKey) }) : properties;
    }
    function CfnExperimentMetricGoalObjectPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("desiredChange", "DesiredChange", cfn_parse.FromCloudFormation.getString(properties.DesiredChange)), ret.addPropertyResult("entityIdKey", "EntityIdKey", cfn_parse.FromCloudFormation.getString(properties.EntityIdKey)), ret.addPropertyResult("eventPattern", "EventPattern", properties.EventPattern != null ? cfn_parse.FromCloudFormation.getString(properties.EventPattern) : void 0), ret.addPropertyResult("metricName", "MetricName", cfn_parse.FromCloudFormation.getString(properties.MetricName)), ret.addPropertyResult("unitLabel", "UnitLabel", properties.UnitLabel != null ? cfn_parse.FromCloudFormation.getString(properties.UnitLabel) : void 0), ret.addPropertyResult("valueKey", "ValueKey", cfn_parse.FromCloudFormation.getString(properties.ValueKey)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnExperiment_OnlineAbConfigObjectPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("controlTreatmentName", cdk.validateString)(properties.controlTreatmentName)), errors.collect(cdk.propertyValidator("treatmentWeights", cdk.listValidator(CfnExperiment_TreatmentToWeightPropertyValidator))(properties.treatmentWeights)), errors.wrap('supplied properties not correct for "OnlineAbConfigObjectProperty"');
    }
    function cfnExperimentOnlineAbConfigObjectPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnExperiment_OnlineAbConfigObjectPropertyValidator(properties).assertSuccess(), { ControlTreatmentName: cdk.stringToCloudFormation(properties.controlTreatmentName), TreatmentWeights: cdk.listMapper(cfnExperimentTreatmentToWeightPropertyToCloudFormation)(properties.treatmentWeights) }) : properties;
    }
    function CfnExperimentOnlineAbConfigObjectPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("controlTreatmentName", "ControlTreatmentName", properties.ControlTreatmentName != null ? cfn_parse.FromCloudFormation.getString(properties.ControlTreatmentName) : void 0), ret.addPropertyResult("treatmentWeights", "TreatmentWeights", properties.TreatmentWeights != null ? cfn_parse.FromCloudFormation.getArray(CfnExperimentTreatmentToWeightPropertyFromCloudFormation)(properties.TreatmentWeights) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnExperiment_RunningStatusObjectPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("analysisCompleteTime", cdk.validateString)(properties.analysisCompleteTime)), errors.collect(cdk.propertyValidator("desiredState", cdk.validateString)(properties.desiredState)), errors.collect(cdk.propertyValidator("reason", cdk.validateString)(properties.reason)), errors.collect(cdk.propertyValidator("status", cdk.requiredValidator)(properties.status)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "RunningStatusObjectProperty"');
    }
    function cfnExperimentRunningStatusObjectPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnExperiment_RunningStatusObjectPropertyValidator(properties).assertSuccess(), { AnalysisCompleteTime: cdk.stringToCloudFormation(properties.analysisCompleteTime), DesiredState: cdk.stringToCloudFormation(properties.desiredState), Reason: cdk.stringToCloudFormation(properties.reason), Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnExperimentRunningStatusObjectPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("analysisCompleteTime", "AnalysisCompleteTime", properties.AnalysisCompleteTime != null ? cfn_parse.FromCloudFormation.getString(properties.AnalysisCompleteTime) : void 0), ret.addPropertyResult("desiredState", "DesiredState", properties.DesiredState != null ? cfn_parse.FromCloudFormation.getString(properties.DesiredState) : void 0), ret.addPropertyResult("reason", "Reason", properties.Reason != null ? cfn_parse.FromCloudFormation.getString(properties.Reason) : void 0), ret.addPropertyResult("status", "Status", cfn_parse.FromCloudFormation.getString(properties.Status)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnExperiment_TreatmentObjectPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("feature", cdk.requiredValidator)(properties.feature)), errors.collect(cdk.propertyValidator("feature", cdk.validateString)(properties.feature)), errors.collect(cdk.propertyValidator("treatmentName", cdk.requiredValidator)(properties.treatmentName)), errors.collect(cdk.propertyValidator("treatmentName", cdk.validateString)(properties.treatmentName)), errors.collect(cdk.propertyValidator("variation", cdk.requiredValidator)(properties.variation)), errors.collect(cdk.propertyValidator("variation", cdk.validateString)(properties.variation)), errors.wrap('supplied properties not correct for "TreatmentObjectProperty"');
    }
    function cfnExperimentTreatmentObjectPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnExperiment_TreatmentObjectPropertyValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), Feature: cdk.stringToCloudFormation(properties.feature), TreatmentName: cdk.stringToCloudFormation(properties.treatmentName), Variation: cdk.stringToCloudFormation(properties.variation) }) : properties;
    }
    function CfnExperimentTreatmentObjectPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("feature", "Feature", cfn_parse.FromCloudFormation.getString(properties.Feature)), ret.addPropertyResult("treatmentName", "TreatmentName", cfn_parse.FromCloudFormation.getString(properties.TreatmentName)), ret.addPropertyResult("variation", "Variation", cfn_parse.FromCloudFormation.getString(properties.Variation)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnExperiment_TreatmentToWeightPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("splitWeight", cdk.requiredValidator)(properties.splitWeight)), errors.collect(cdk.propertyValidator("splitWeight", cdk.validateNumber)(properties.splitWeight)), errors.collect(cdk.propertyValidator("treatment", cdk.requiredValidator)(properties.treatment)), errors.collect(cdk.propertyValidator("treatment", cdk.validateString)(properties.treatment)), errors.wrap('supplied properties not correct for "TreatmentToWeightProperty"');
    }
    function cfnExperimentTreatmentToWeightPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnExperiment_TreatmentToWeightPropertyValidator(properties).assertSuccess(), { SplitWeight: cdk.numberToCloudFormation(properties.splitWeight), Treatment: cdk.stringToCloudFormation(properties.treatment) }) : properties;
    }
    function CfnExperimentTreatmentToWeightPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("splitWeight", "SplitWeight", cfn_parse.FromCloudFormation.getNumber(properties.SplitWeight)), ret.addPropertyResult("treatment", "Treatment", cfn_parse.FromCloudFormation.getString(properties.Treatment)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFeaturePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultVariation", cdk.validateString)(properties.defaultVariation)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("entityOverrides", cdk.listValidator(CfnFeature_EntityOverridePropertyValidator))(properties.entityOverrides)), errors.collect(cdk.propertyValidator("evaluationStrategy", cdk.validateString)(properties.evaluationStrategy)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("project", cdk.requiredValidator)(properties.project)), errors.collect(cdk.propertyValidator("project", cdk.validateString)(properties.project)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("variations", cdk.requiredValidator)(properties.variations)), errors.collect(cdk.propertyValidator("variations", cdk.listValidator(CfnFeature_VariationObjectPropertyValidator))(properties.variations)), errors.wrap('supplied properties not correct for "CfnFeatureProps"');
    }
    function cfnFeaturePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFeaturePropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Project: cdk.stringToCloudFormation(properties.project), Variations: cdk.listMapper(cfnFeatureVariationObjectPropertyToCloudFormation)(properties.variations), DefaultVariation: cdk.stringToCloudFormation(properties.defaultVariation), Description: cdk.stringToCloudFormation(properties.description), EntityOverrides: cdk.listMapper(cfnFeatureEntityOverridePropertyToCloudFormation)(properties.entityOverrides), EvaluationStrategy: cdk.stringToCloudFormation(properties.evaluationStrategy), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnFeaturePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("project", "Project", cfn_parse.FromCloudFormation.getString(properties.Project)), ret.addPropertyResult("variations", "Variations", cfn_parse.FromCloudFormation.getArray(CfnFeatureVariationObjectPropertyFromCloudFormation)(properties.Variations)), ret.addPropertyResult("defaultVariation", "DefaultVariation", properties.DefaultVariation != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultVariation) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("entityOverrides", "EntityOverrides", properties.EntityOverrides != null ? cfn_parse.FromCloudFormation.getArray(CfnFeatureEntityOverridePropertyFromCloudFormation)(properties.EntityOverrides) : void 0), ret.addPropertyResult("evaluationStrategy", "EvaluationStrategy", properties.EvaluationStrategy != null ? cfn_parse.FromCloudFormation.getString(properties.EvaluationStrategy) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFeature = class _CfnFeature extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFeaturePropsFromCloudFormation(resourceProperties), ret = new _CfnFeature(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFeature.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_evidently_CfnFeatureProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFeature), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "project", this), cdk.requireProperty(props, "variations", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.project = props.project, this.variations = props.variations, this.defaultVariation = props.defaultVariation, this.description = props.description, this.entityOverrides = props.entityOverrides, this.evaluationStrategy = props.evaluationStrategy, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Evidently::Feature", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFeature.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, project: this.project, variations: this.variations, defaultVariation: this.defaultVariation, description: this.description, entityOverrides: this.entityOverrides, evaluationStrategy: this.evaluationStrategy, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnFeaturePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnFeature[_b] = { fqn: "aws-cdk-lib.aws_evidently.CfnFeature", version: "2.80.0" }, CfnFeature.CFN_RESOURCE_TYPE_NAME = "AWS::Evidently::Feature", exports2.CfnFeature = CfnFeature;
    function CfnFeature_EntityOverridePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("entityId", cdk.validateString)(properties.entityId)), errors.collect(cdk.propertyValidator("variation", cdk.validateString)(properties.variation)), errors.wrap('supplied properties not correct for "EntityOverrideProperty"');
    }
    function cfnFeatureEntityOverridePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFeature_EntityOverridePropertyValidator(properties).assertSuccess(), { EntityId: cdk.stringToCloudFormation(properties.entityId), Variation: cdk.stringToCloudFormation(properties.variation) }) : properties;
    }
    function CfnFeatureEntityOverridePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("entityId", "EntityId", properties.EntityId != null ? cfn_parse.FromCloudFormation.getString(properties.EntityId) : void 0), ret.addPropertyResult("variation", "Variation", properties.Variation != null ? cfn_parse.FromCloudFormation.getString(properties.Variation) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFeature_VariationObjectPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("booleanValue", cdk.validateBoolean)(properties.booleanValue)), errors.collect(cdk.propertyValidator("doubleValue", cdk.validateNumber)(properties.doubleValue)), errors.collect(cdk.propertyValidator("longValue", cdk.validateNumber)(properties.longValue)), errors.collect(cdk.propertyValidator("stringValue", cdk.validateString)(properties.stringValue)), errors.collect(cdk.propertyValidator("variationName", cdk.requiredValidator)(properties.variationName)), errors.collect(cdk.propertyValidator("variationName", cdk.validateString)(properties.variationName)), errors.wrap('supplied properties not correct for "VariationObjectProperty"');
    }
    function cfnFeatureVariationObjectPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFeature_VariationObjectPropertyValidator(properties).assertSuccess(), { BooleanValue: cdk.booleanToCloudFormation(properties.booleanValue), DoubleValue: cdk.numberToCloudFormation(properties.doubleValue), LongValue: cdk.numberToCloudFormation(properties.longValue), StringValue: cdk.stringToCloudFormation(properties.stringValue), VariationName: cdk.stringToCloudFormation(properties.variationName) }) : properties;
    }
    function CfnFeatureVariationObjectPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("booleanValue", "BooleanValue", properties.BooleanValue != null ? cfn_parse.FromCloudFormation.getBoolean(properties.BooleanValue) : void 0), ret.addPropertyResult("doubleValue", "DoubleValue", properties.DoubleValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.DoubleValue) : void 0), ret.addPropertyResult("longValue", "LongValue", properties.LongValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.LongValue) : void 0), ret.addPropertyResult("stringValue", "StringValue", properties.StringValue != null ? cfn_parse.FromCloudFormation.getString(properties.StringValue) : void 0), ret.addPropertyResult("variationName", "VariationName", cfn_parse.FromCloudFormation.getString(properties.VariationName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("executionStatus", CfnLaunch_ExecutionStatusObjectPropertyValidator)(properties.executionStatus)), errors.collect(cdk.propertyValidator("groups", cdk.requiredValidator)(properties.groups)), errors.collect(cdk.propertyValidator("groups", cdk.listValidator(CfnLaunch_LaunchGroupObjectPropertyValidator))(properties.groups)), errors.collect(cdk.propertyValidator("metricMonitors", cdk.listValidator(CfnLaunch_MetricDefinitionObjectPropertyValidator))(properties.metricMonitors)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("project", cdk.requiredValidator)(properties.project)), errors.collect(cdk.propertyValidator("project", cdk.validateString)(properties.project)), errors.collect(cdk.propertyValidator("randomizationSalt", cdk.validateString)(properties.randomizationSalt)), errors.collect(cdk.propertyValidator("scheduledSplitsConfig", cdk.requiredValidator)(properties.scheduledSplitsConfig)), errors.collect(cdk.propertyValidator("scheduledSplitsConfig", cdk.listValidator(CfnLaunch_StepConfigPropertyValidator))(properties.scheduledSplitsConfig)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnLaunchProps"');
    }
    function cfnLaunchPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchPropsValidator(properties).assertSuccess(), { Groups: cdk.listMapper(cfnLaunchLaunchGroupObjectPropertyToCloudFormation)(properties.groups), Name: cdk.stringToCloudFormation(properties.name), Project: cdk.stringToCloudFormation(properties.project), ScheduledSplitsConfig: cdk.listMapper(cfnLaunchStepConfigPropertyToCloudFormation)(properties.scheduledSplitsConfig), Description: cdk.stringToCloudFormation(properties.description), ExecutionStatus: cfnLaunchExecutionStatusObjectPropertyToCloudFormation(properties.executionStatus), MetricMonitors: cdk.listMapper(cfnLaunchMetricDefinitionObjectPropertyToCloudFormation)(properties.metricMonitors), RandomizationSalt: cdk.stringToCloudFormation(properties.randomizationSalt), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnLaunchPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groups", "Groups", cfn_parse.FromCloudFormation.getArray(CfnLaunchLaunchGroupObjectPropertyFromCloudFormation)(properties.Groups)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("project", "Project", cfn_parse.FromCloudFormation.getString(properties.Project)), ret.addPropertyResult("scheduledSplitsConfig", "ScheduledSplitsConfig", cfn_parse.FromCloudFormation.getArray(CfnLaunchStepConfigPropertyFromCloudFormation)(properties.ScheduledSplitsConfig)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("executionStatus", "ExecutionStatus", properties.ExecutionStatus != null ? CfnLaunchExecutionStatusObjectPropertyFromCloudFormation(properties.ExecutionStatus) : void 0), ret.addPropertyResult("metricMonitors", "MetricMonitors", properties.MetricMonitors != null ? cfn_parse.FromCloudFormation.getArray(CfnLaunchMetricDefinitionObjectPropertyFromCloudFormation)(properties.MetricMonitors) : void 0), ret.addPropertyResult("randomizationSalt", "RandomizationSalt", properties.RandomizationSalt != null ? cfn_parse.FromCloudFormation.getString(properties.RandomizationSalt) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLaunch = class _CfnLaunch extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLaunchPropsFromCloudFormation(resourceProperties), ret = new _CfnLaunch(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLaunch.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_evidently_CfnLaunchProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLaunch), error;
        }
        cdk.requireProperty(props, "groups", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "project", this), cdk.requireProperty(props, "scheduledSplitsConfig", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.groups = props.groups, this.name = props.name, this.project = props.project, this.scheduledSplitsConfig = props.scheduledSplitsConfig, this.description = props.description, this.executionStatus = props.executionStatus, this.metricMonitors = props.metricMonitors, this.randomizationSalt = props.randomizationSalt, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Evidently::Launch", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLaunch.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { groups: this.groups, name: this.name, project: this.project, scheduledSplitsConfig: this.scheduledSplitsConfig, description: this.description, executionStatus: this.executionStatus, metricMonitors: this.metricMonitors, randomizationSalt: this.randomizationSalt, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnLaunchPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnLaunch[_c] = { fqn: "aws-cdk-lib.aws_evidently.CfnLaunch", version: "2.80.0" }, CfnLaunch.CFN_RESOURCE_TYPE_NAME = "AWS::Evidently::Launch", exports2.CfnLaunch = CfnLaunch;
    function CfnLaunch_ExecutionStatusObjectPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("desiredState", cdk.validateString)(properties.desiredState)), errors.collect(cdk.propertyValidator("reason", cdk.validateString)(properties.reason)), errors.collect(cdk.propertyValidator("status", cdk.requiredValidator)(properties.status)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "ExecutionStatusObjectProperty"');
    }
    function cfnLaunchExecutionStatusObjectPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunch_ExecutionStatusObjectPropertyValidator(properties).assertSuccess(), { DesiredState: cdk.stringToCloudFormation(properties.desiredState), Reason: cdk.stringToCloudFormation(properties.reason), Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnLaunchExecutionStatusObjectPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("desiredState", "DesiredState", properties.DesiredState != null ? cfn_parse.FromCloudFormation.getString(properties.DesiredState) : void 0), ret.addPropertyResult("reason", "Reason", properties.Reason != null ? cfn_parse.FromCloudFormation.getString(properties.Reason) : void 0), ret.addPropertyResult("status", "Status", cfn_parse.FromCloudFormation.getString(properties.Status)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunch_GroupToWeightPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groupName", cdk.requiredValidator)(properties.groupName)), errors.collect(cdk.propertyValidator("groupName", cdk.validateString)(properties.groupName)), errors.collect(cdk.propertyValidator("splitWeight", cdk.requiredValidator)(properties.splitWeight)), errors.collect(cdk.propertyValidator("splitWeight", cdk.validateNumber)(properties.splitWeight)), errors.wrap('supplied properties not correct for "GroupToWeightProperty"');
    }
    function cfnLaunchGroupToWeightPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunch_GroupToWeightPropertyValidator(properties).assertSuccess(), { GroupName: cdk.stringToCloudFormation(properties.groupName), SplitWeight: cdk.numberToCloudFormation(properties.splitWeight) }) : properties;
    }
    function CfnLaunchGroupToWeightPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupName", "GroupName", cfn_parse.FromCloudFormation.getString(properties.GroupName)), ret.addPropertyResult("splitWeight", "SplitWeight", cfn_parse.FromCloudFormation.getNumber(properties.SplitWeight)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunch_LaunchGroupObjectPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("feature", cdk.requiredValidator)(properties.feature)), errors.collect(cdk.propertyValidator("feature", cdk.validateString)(properties.feature)), errors.collect(cdk.propertyValidator("groupName", cdk.requiredValidator)(properties.groupName)), errors.collect(cdk.propertyValidator("groupName", cdk.validateString)(properties.groupName)), errors.collect(cdk.propertyValidator("variation", cdk.requiredValidator)(properties.variation)), errors.collect(cdk.propertyValidator("variation", cdk.validateString)(properties.variation)), errors.wrap('supplied properties not correct for "LaunchGroupObjectProperty"');
    }
    function cfnLaunchLaunchGroupObjectPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunch_LaunchGroupObjectPropertyValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), Feature: cdk.stringToCloudFormation(properties.feature), GroupName: cdk.stringToCloudFormation(properties.groupName), Variation: cdk.stringToCloudFormation(properties.variation) }) : properties;
    }
    function CfnLaunchLaunchGroupObjectPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("feature", "Feature", cfn_parse.FromCloudFormation.getString(properties.Feature)), ret.addPropertyResult("groupName", "GroupName", cfn_parse.FromCloudFormation.getString(properties.GroupName)), ret.addPropertyResult("variation", "Variation", cfn_parse.FromCloudFormation.getString(properties.Variation)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunch_MetricDefinitionObjectPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("entityIdKey", cdk.requiredValidator)(properties.entityIdKey)), errors.collect(cdk.propertyValidator("entityIdKey", cdk.validateString)(properties.entityIdKey)), errors.collect(cdk.propertyValidator("eventPattern", cdk.validateString)(properties.eventPattern)), errors.collect(cdk.propertyValidator("metricName", cdk.requiredValidator)(properties.metricName)), errors.collect(cdk.propertyValidator("metricName", cdk.validateString)(properties.metricName)), errors.collect(cdk.propertyValidator("unitLabel", cdk.validateString)(properties.unitLabel)), errors.collect(cdk.propertyValidator("valueKey", cdk.requiredValidator)(properties.valueKey)), errors.collect(cdk.propertyValidator("valueKey", cdk.validateString)(properties.valueKey)), errors.wrap('supplied properties not correct for "MetricDefinitionObjectProperty"');
    }
    function cfnLaunchMetricDefinitionObjectPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunch_MetricDefinitionObjectPropertyValidator(properties).assertSuccess(), { EntityIdKey: cdk.stringToCloudFormation(properties.entityIdKey), EventPattern: cdk.stringToCloudFormation(properties.eventPattern), MetricName: cdk.stringToCloudFormation(properties.metricName), UnitLabel: cdk.stringToCloudFormation(properties.unitLabel), ValueKey: cdk.stringToCloudFormation(properties.valueKey) }) : properties;
    }
    function CfnLaunchMetricDefinitionObjectPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("entityIdKey", "EntityIdKey", cfn_parse.FromCloudFormation.getString(properties.EntityIdKey)), ret.addPropertyResult("eventPattern", "EventPattern", properties.EventPattern != null ? cfn_parse.FromCloudFormation.getString(properties.EventPattern) : void 0), ret.addPropertyResult("metricName", "MetricName", cfn_parse.FromCloudFormation.getString(properties.MetricName)), ret.addPropertyResult("unitLabel", "UnitLabel", properties.UnitLabel != null ? cfn_parse.FromCloudFormation.getString(properties.UnitLabel) : void 0), ret.addPropertyResult("valueKey", "ValueKey", cfn_parse.FromCloudFormation.getString(properties.ValueKey)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunch_SegmentOverridePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("evaluationOrder", cdk.requiredValidator)(properties.evaluationOrder)), errors.collect(cdk.propertyValidator("evaluationOrder", cdk.validateNumber)(properties.evaluationOrder)), errors.collect(cdk.propertyValidator("segment", cdk.requiredValidator)(properties.segment)), errors.collect(cdk.propertyValidator("segment", cdk.validateString)(properties.segment)), errors.collect(cdk.propertyValidator("weights", cdk.requiredValidator)(properties.weights)), errors.collect(cdk.propertyValidator("weights", cdk.listValidator(CfnLaunch_GroupToWeightPropertyValidator))(properties.weights)), errors.wrap('supplied properties not correct for "SegmentOverrideProperty"');
    }
    function cfnLaunchSegmentOverridePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunch_SegmentOverridePropertyValidator(properties).assertSuccess(), { EvaluationOrder: cdk.numberToCloudFormation(properties.evaluationOrder), Segment: cdk.stringToCloudFormation(properties.segment), Weights: cdk.listMapper(cfnLaunchGroupToWeightPropertyToCloudFormation)(properties.weights) }) : properties;
    }
    function CfnLaunchSegmentOverridePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("evaluationOrder", "EvaluationOrder", cfn_parse.FromCloudFormation.getNumber(properties.EvaluationOrder)), ret.addPropertyResult("segment", "Segment", cfn_parse.FromCloudFormation.getString(properties.Segment)), ret.addPropertyResult("weights", "Weights", cfn_parse.FromCloudFormation.getArray(CfnLaunchGroupToWeightPropertyFromCloudFormation)(properties.Weights)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunch_StepConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groupWeights", cdk.requiredValidator)(properties.groupWeights)), errors.collect(cdk.propertyValidator("groupWeights", cdk.listValidator(CfnLaunch_GroupToWeightPropertyValidator))(properties.groupWeights)), errors.collect(cdk.propertyValidator("segmentOverrides", cdk.listValidator(CfnLaunch_SegmentOverridePropertyValidator))(properties.segmentOverrides)), errors.collect(cdk.propertyValidator("startTime", cdk.requiredValidator)(properties.startTime)), errors.collect(cdk.propertyValidator("startTime", cdk.validateString)(properties.startTime)), errors.wrap('supplied properties not correct for "StepConfigProperty"');
    }
    function cfnLaunchStepConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunch_StepConfigPropertyValidator(properties).assertSuccess(), { GroupWeights: cdk.listMapper(cfnLaunchGroupToWeightPropertyToCloudFormation)(properties.groupWeights), SegmentOverrides: cdk.listMapper(cfnLaunchSegmentOverridePropertyToCloudFormation)(properties.segmentOverrides), StartTime: cdk.stringToCloudFormation(properties.startTime) }) : properties;
    }
    function CfnLaunchStepConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupWeights", "GroupWeights", cfn_parse.FromCloudFormation.getArray(CfnLaunchGroupToWeightPropertyFromCloudFormation)(properties.GroupWeights)), ret.addPropertyResult("segmentOverrides", "SegmentOverrides", properties.SegmentOverrides != null ? cfn_parse.FromCloudFormation.getArray(CfnLaunchSegmentOverridePropertyFromCloudFormation)(properties.SegmentOverrides) : void 0), ret.addPropertyResult("startTime", "StartTime", cfn_parse.FromCloudFormation.getString(properties.StartTime)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnProjectPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("appConfigResource", CfnProject_AppConfigResourceObjectPropertyValidator)(properties.appConfigResource)), errors.collect(cdk.propertyValidator("dataDelivery", CfnProject_DataDeliveryObjectPropertyValidator)(properties.dataDelivery)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnProjectProps"');
    }
    function cfnProjectPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProjectPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), AppConfigResource: cfnProjectAppConfigResourceObjectPropertyToCloudFormation(properties.appConfigResource), DataDelivery: cfnProjectDataDeliveryObjectPropertyToCloudFormation(properties.dataDelivery), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnProjectPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("appConfigResource", "AppConfigResource", properties.AppConfigResource != null ? CfnProjectAppConfigResourceObjectPropertyFromCloudFormation(properties.AppConfigResource) : void 0), ret.addPropertyResult("dataDelivery", "DataDelivery", properties.DataDelivery != null ? CfnProjectDataDeliveryObjectPropertyFromCloudFormation(properties.DataDelivery) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnProject = class _CfnProject extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnProjectPropsFromCloudFormation(resourceProperties), ret = new _CfnProject(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnProject.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_evidently_CfnProjectProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnProject), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.appConfigResource = props.appConfigResource, this.dataDelivery = props.dataDelivery, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Evidently::Project", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnProject.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, appConfigResource: this.appConfigResource, dataDelivery: this.dataDelivery, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnProjectPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnProject[_d] = { fqn: "aws-cdk-lib.aws_evidently.CfnProject", version: "2.80.0" }, CfnProject.CFN_RESOURCE_TYPE_NAME = "AWS::Evidently::Project", exports2.CfnProject = CfnProject;
    function CfnProject_AppConfigResourceObjectPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationId", cdk.requiredValidator)(properties.applicationId)), errors.collect(cdk.propertyValidator("applicationId", cdk.validateString)(properties.applicationId)), errors.collect(cdk.propertyValidator("environmentId", cdk.requiredValidator)(properties.environmentId)), errors.collect(cdk.propertyValidator("environmentId", cdk.validateString)(properties.environmentId)), errors.wrap('supplied properties not correct for "AppConfigResourceObjectProperty"');
    }
    function cfnProjectAppConfigResourceObjectPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProject_AppConfigResourceObjectPropertyValidator(properties).assertSuccess(), { ApplicationId: cdk.stringToCloudFormation(properties.applicationId), EnvironmentId: cdk.stringToCloudFormation(properties.environmentId) }) : properties;
    }
    function CfnProjectAppConfigResourceObjectPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationId", "ApplicationId", cfn_parse.FromCloudFormation.getString(properties.ApplicationId)), ret.addPropertyResult("environmentId", "EnvironmentId", cfn_parse.FromCloudFormation.getString(properties.EnvironmentId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnProject_DataDeliveryObjectPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logGroup", cdk.validateString)(properties.logGroup)), errors.collect(cdk.propertyValidator("s3", CfnProject_S3DestinationPropertyValidator)(properties.s3)), errors.wrap('supplied properties not correct for "DataDeliveryObjectProperty"');
    }
    function cfnProjectDataDeliveryObjectPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProject_DataDeliveryObjectPropertyValidator(properties).assertSuccess(), { LogGroup: cdk.stringToCloudFormation(properties.logGroup), S3: cfnProjectS3DestinationPropertyToCloudFormation(properties.s3) }) : properties;
    }
    function CfnProjectDataDeliveryObjectPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logGroup", "LogGroup", properties.LogGroup != null ? cfn_parse.FromCloudFormation.getString(properties.LogGroup) : void 0), ret.addPropertyResult("s3", "S3", properties.S3 != null ? CfnProjectS3DestinationPropertyFromCloudFormation(properties.S3) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnProject_S3DestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketName", cdk.requiredValidator)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.wrap('supplied properties not correct for "S3DestinationProperty"');
    }
    function cfnProjectS3DestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProject_S3DestinationPropertyValidator(properties).assertSuccess(), { BucketName: cdk.stringToCloudFormation(properties.bucketName), Prefix: cdk.stringToCloudFormation(properties.prefix) }) : properties;
    }
    function CfnProjectS3DestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketName", "BucketName", cfn_parse.FromCloudFormation.getString(properties.BucketName)), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSegmentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("pattern", cdk.validateString)(properties.pattern)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnSegmentProps"');
    }
    function cfnSegmentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSegmentPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), Pattern: cdk.stringToCloudFormation(properties.pattern), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnSegmentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("pattern", "Pattern", properties.Pattern != null ? cfn_parse.FromCloudFormation.getString(properties.Pattern) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSegment = class _CfnSegment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSegmentPropsFromCloudFormation(resourceProperties), ret = new _CfnSegment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSegment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_evidently_CfnSegmentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSegment), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.description = props.description, this.pattern = props.pattern, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Evidently::Segment", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSegment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, description: this.description, pattern: this.pattern, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnSegmentPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnSegment[_e] = { fqn: "aws-cdk-lib.aws_evidently.CfnSegment", version: "2.80.0" }, CfnSegment.CFN_RESOURCE_TYPE_NAME = "AWS::Evidently::Segment", exports2.CfnSegment = CfnSegment;
  }
});

// node_modules/aws-cdk-lib/aws-evidently/lib/index.js
var require_lib127 = __commonJS({
  "node_modules/aws-cdk-lib/aws-evidently/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_evidently_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-evidently/index.js
var require_aws_evidently = __commonJS({
  "node_modules/aws-cdk-lib/aws-evidently/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib127(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-finspace/lib/finspace.generated.js
var require_finspace_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-finspace/lib/finspace.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnEnvironment = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnEnvironmentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("federationMode", cdk.validateString)(properties.federationMode)), errors.collect(cdk.propertyValidator("federationParameters", CfnEnvironment_FederationParametersPropertyValidator)(properties.federationParameters)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("superuserParameters", CfnEnvironment_SuperuserParametersPropertyValidator)(properties.superuserParameters)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnEnvironmentProps"');
    }
    function cfnEnvironmentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEnvironmentPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), FederationMode: cdk.stringToCloudFormation(properties.federationMode), FederationParameters: cfnEnvironmentFederationParametersPropertyToCloudFormation(properties.federationParameters), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), SuperuserParameters: cfnEnvironmentSuperuserParametersPropertyToCloudFormation(properties.superuserParameters), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnEnvironmentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("federationMode", "FederationMode", properties.FederationMode != null ? cfn_parse.FromCloudFormation.getString(properties.FederationMode) : void 0), ret.addPropertyResult("federationParameters", "FederationParameters", properties.FederationParameters != null ? CfnEnvironmentFederationParametersPropertyFromCloudFormation(properties.FederationParameters) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("superuserParameters", "SuperuserParameters", properties.SuperuserParameters != null ? CfnEnvironmentSuperuserParametersPropertyFromCloudFormation(properties.SuperuserParameters) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEnvironment = class _CfnEnvironment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEnvironmentPropsFromCloudFormation(resourceProperties), ret = new _CfnEnvironment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEnvironment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_finspace_CfnEnvironmentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEnvironment), error;
        }
        cdk.requireProperty(props, "name", this), this.attrAwsAccountId = cdk.Token.asString(this.getAtt("AwsAccountId", cdk.ResolutionTypeHint.STRING)), this.attrDedicatedServiceAccountId = cdk.Token.asString(this.getAtt("DedicatedServiceAccountId", cdk.ResolutionTypeHint.STRING)), this.attrEnvironmentArn = cdk.Token.asString(this.getAtt("EnvironmentArn", cdk.ResolutionTypeHint.STRING)), this.attrEnvironmentId = cdk.Token.asString(this.getAtt("EnvironmentId", cdk.ResolutionTypeHint.STRING)), this.attrEnvironmentUrl = cdk.Token.asString(this.getAtt("EnvironmentUrl", cdk.ResolutionTypeHint.STRING)), this.attrSageMakerStudioDomainUrl = cdk.Token.asString(this.getAtt("SageMakerStudioDomainUrl", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.description = props.description, this.federationMode = props.federationMode, this.federationParameters = props.federationParameters, this.kmsKeyId = props.kmsKeyId, this.superuserParameters = props.superuserParameters, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::FinSpace::Environment", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEnvironment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, description: this.description, federationMode: this.federationMode, federationParameters: this.federationParameters, kmsKeyId: this.kmsKeyId, superuserParameters: this.superuserParameters, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnEnvironmentPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnEnvironment[_a] = { fqn: "aws-cdk-lib.aws_finspace.CfnEnvironment", version: "2.80.0" }, CfnEnvironment.CFN_RESOURCE_TYPE_NAME = "AWS::FinSpace::Environment", exports2.CfnEnvironment = CfnEnvironment;
    function CfnEnvironment_AttributeMapItemsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "AttributeMapItemsProperty"');
    }
    function cfnEnvironmentAttributeMapItemsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEnvironment_AttributeMapItemsPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnEnvironmentAttributeMapItemsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEnvironment_FederationParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationCallBackUrl", cdk.validateString)(properties.applicationCallBackUrl)), errors.collect(cdk.propertyValidator("attributeMap", cdk.listValidator(CfnEnvironment_AttributeMapItemsPropertyValidator))(properties.attributeMap)), errors.collect(cdk.propertyValidator("federationProviderName", cdk.validateString)(properties.federationProviderName)), errors.collect(cdk.propertyValidator("federationUrn", cdk.validateString)(properties.federationUrn)), errors.collect(cdk.propertyValidator("samlMetadataDocument", cdk.validateString)(properties.samlMetadataDocument)), errors.collect(cdk.propertyValidator("samlMetadataUrl", cdk.validateString)(properties.samlMetadataUrl)), errors.wrap('supplied properties not correct for "FederationParametersProperty"');
    }
    function cfnEnvironmentFederationParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEnvironment_FederationParametersPropertyValidator(properties).assertSuccess(), { ApplicationCallBackURL: cdk.stringToCloudFormation(properties.applicationCallBackUrl), AttributeMap: cdk.listMapper(cfnEnvironmentAttributeMapItemsPropertyToCloudFormation)(properties.attributeMap), FederationProviderName: cdk.stringToCloudFormation(properties.federationProviderName), FederationURN: cdk.stringToCloudFormation(properties.federationUrn), SamlMetadataDocument: cdk.stringToCloudFormation(properties.samlMetadataDocument), SamlMetadataURL: cdk.stringToCloudFormation(properties.samlMetadataUrl) }) : properties;
    }
    function CfnEnvironmentFederationParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationCallBackUrl", "ApplicationCallBackURL", properties.ApplicationCallBackURL != null ? cfn_parse.FromCloudFormation.getString(properties.ApplicationCallBackURL) : void 0), ret.addPropertyResult("attributeMap", "AttributeMap", properties.AttributeMap != null ? cfn_parse.FromCloudFormation.getArray(CfnEnvironmentAttributeMapItemsPropertyFromCloudFormation)(properties.AttributeMap) : void 0), ret.addPropertyResult("federationProviderName", "FederationProviderName", properties.FederationProviderName != null ? cfn_parse.FromCloudFormation.getString(properties.FederationProviderName) : void 0), ret.addPropertyResult("federationUrn", "FederationURN", properties.FederationURN != null ? cfn_parse.FromCloudFormation.getString(properties.FederationURN) : void 0), ret.addPropertyResult("samlMetadataDocument", "SamlMetadataDocument", properties.SamlMetadataDocument != null ? cfn_parse.FromCloudFormation.getString(properties.SamlMetadataDocument) : void 0), ret.addPropertyResult("samlMetadataUrl", "SamlMetadataURL", properties.SamlMetadataURL != null ? cfn_parse.FromCloudFormation.getString(properties.SamlMetadataURL) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEnvironment_SuperuserParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("emailAddress", cdk.validateString)(properties.emailAddress)), errors.collect(cdk.propertyValidator("firstName", cdk.validateString)(properties.firstName)), errors.collect(cdk.propertyValidator("lastName", cdk.validateString)(properties.lastName)), errors.wrap('supplied properties not correct for "SuperuserParametersProperty"');
    }
    function cfnEnvironmentSuperuserParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEnvironment_SuperuserParametersPropertyValidator(properties).assertSuccess(), { EmailAddress: cdk.stringToCloudFormation(properties.emailAddress), FirstName: cdk.stringToCloudFormation(properties.firstName), LastName: cdk.stringToCloudFormation(properties.lastName) }) : properties;
    }
    function CfnEnvironmentSuperuserParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("emailAddress", "EmailAddress", properties.EmailAddress != null ? cfn_parse.FromCloudFormation.getString(properties.EmailAddress) : void 0), ret.addPropertyResult("firstName", "FirstName", properties.FirstName != null ? cfn_parse.FromCloudFormation.getString(properties.FirstName) : void 0), ret.addPropertyResult("lastName", "LastName", properties.LastName != null ? cfn_parse.FromCloudFormation.getString(properties.LastName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-finspace/lib/index.js
var require_lib128 = __commonJS({
  "node_modules/aws-cdk-lib/aws-finspace/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_finspace_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-finspace/index.js
var require_aws_finspace = __commonJS({
  "node_modules/aws-cdk-lib/aws-finspace/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib128(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-fis/lib/fis.generated.js
var require_fis_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-fis/lib/fis.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnExperimentTemplate = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnExperimentTemplatePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.hashValidator(CfnExperimentTemplate_ExperimentTemplateActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("description", cdk.requiredValidator)(properties.description)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("logConfiguration", CfnExperimentTemplate_ExperimentTemplateLogConfigurationPropertyValidator)(properties.logConfiguration)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("stopConditions", cdk.requiredValidator)(properties.stopConditions)), errors.collect(cdk.propertyValidator("stopConditions", cdk.listValidator(CfnExperimentTemplate_ExperimentTemplateStopConditionPropertyValidator))(properties.stopConditions)), errors.collect(cdk.propertyValidator("tags", cdk.requiredValidator)(properties.tags)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.collect(cdk.propertyValidator("targets", cdk.requiredValidator)(properties.targets)), errors.collect(cdk.propertyValidator("targets", cdk.hashValidator(CfnExperimentTemplate_ExperimentTemplateTargetPropertyValidator))(properties.targets)), errors.wrap('supplied properties not correct for "CfnExperimentTemplateProps"');
    }
    function cfnExperimentTemplatePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnExperimentTemplatePropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), RoleArn: cdk.stringToCloudFormation(properties.roleArn), StopConditions: cdk.listMapper(cfnExperimentTemplateExperimentTemplateStopConditionPropertyToCloudFormation)(properties.stopConditions), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags), Targets: cdk.hashMapper(cfnExperimentTemplateExperimentTemplateTargetPropertyToCloudFormation)(properties.targets), Actions: cdk.hashMapper(cfnExperimentTemplateExperimentTemplateActionPropertyToCloudFormation)(properties.actions), LogConfiguration: cfnExperimentTemplateExperimentTemplateLogConfigurationPropertyToCloudFormation(properties.logConfiguration) }) : properties;
    }
    function CfnExperimentTemplatePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", cfn_parse.FromCloudFormation.getString(properties.Description)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("stopConditions", "StopConditions", cfn_parse.FromCloudFormation.getArray(CfnExperimentTemplateExperimentTemplateStopConditionPropertyFromCloudFormation)(properties.StopConditions)), ret.addPropertyResult("tags", "Tags", cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags)), ret.addPropertyResult("targets", "Targets", cfn_parse.FromCloudFormation.getMap(CfnExperimentTemplateExperimentTemplateTargetPropertyFromCloudFormation)(properties.Targets)), ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getMap(CfnExperimentTemplateExperimentTemplateActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("logConfiguration", "LogConfiguration", properties.LogConfiguration != null ? CfnExperimentTemplateExperimentTemplateLogConfigurationPropertyFromCloudFormation(properties.LogConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnExperimentTemplate = class _CfnExperimentTemplate extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnExperimentTemplatePropsFromCloudFormation(resourceProperties), ret = new _CfnExperimentTemplate(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnExperimentTemplate.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_fis_CfnExperimentTemplateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnExperimentTemplate), error;
        }
        cdk.requireProperty(props, "description", this), cdk.requireProperty(props, "roleArn", this), cdk.requireProperty(props, "stopConditions", this), cdk.requireProperty(props, "tags", this), cdk.requireProperty(props, "targets", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.description = props.description, this.roleArn = props.roleArn, this.stopConditions = props.stopConditions, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::FIS::ExperimentTemplate", props.tags, { tagPropertyName: "tags" }), this.targets = props.targets, this.actions = props.actions, this.logConfiguration = props.logConfiguration;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnExperimentTemplate.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, roleArn: this.roleArn, stopConditions: this.stopConditions, tags: this.tags.renderTags(), targets: this.targets, actions: this.actions, logConfiguration: this.logConfiguration };
      }
      renderProperties(props) {
        return cfnExperimentTemplatePropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnExperimentTemplate[_a] = { fqn: "aws-cdk-lib.aws_fis.CfnExperimentTemplate", version: "2.80.0" }, CfnExperimentTemplate.CFN_RESOURCE_TYPE_NAME = "AWS::FIS::ExperimentTemplate", exports2.CfnExperimentTemplate = CfnExperimentTemplate;
    function CfnExperimentTemplate_ExperimentTemplateActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actionId", cdk.requiredValidator)(properties.actionId)), errors.collect(cdk.propertyValidator("actionId", cdk.validateString)(properties.actionId)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("parameters", cdk.hashValidator(cdk.validateString))(properties.parameters)), errors.collect(cdk.propertyValidator("startAfter", cdk.listValidator(cdk.validateString))(properties.startAfter)), errors.collect(cdk.propertyValidator("targets", cdk.hashValidator(cdk.validateString))(properties.targets)), errors.wrap('supplied properties not correct for "ExperimentTemplateActionProperty"');
    }
    function cfnExperimentTemplateExperimentTemplateActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnExperimentTemplate_ExperimentTemplateActionPropertyValidator(properties).assertSuccess(), { ActionId: cdk.stringToCloudFormation(properties.actionId), Description: cdk.stringToCloudFormation(properties.description), Parameters: cdk.hashMapper(cdk.stringToCloudFormation)(properties.parameters), StartAfter: cdk.listMapper(cdk.stringToCloudFormation)(properties.startAfter), Targets: cdk.hashMapper(cdk.stringToCloudFormation)(properties.targets) }) : properties;
    }
    function CfnExperimentTemplateExperimentTemplateActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actionId", "ActionId", cfn_parse.FromCloudFormation.getString(properties.ActionId)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Parameters) : void 0), ret.addPropertyResult("startAfter", "StartAfter", properties.StartAfter != null ? cfn_parse.FromCloudFormation.getStringArray(properties.StartAfter) : void 0), ret.addPropertyResult("targets", "Targets", properties.Targets != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Targets) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnExperimentTemplate_ExperimentTemplateLogConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchLogsConfiguration", cdk.validateObject)(properties.cloudWatchLogsConfiguration)), errors.collect(cdk.propertyValidator("logSchemaVersion", cdk.requiredValidator)(properties.logSchemaVersion)), errors.collect(cdk.propertyValidator("logSchemaVersion", cdk.validateNumber)(properties.logSchemaVersion)), errors.collect(cdk.propertyValidator("s3Configuration", cdk.validateObject)(properties.s3Configuration)), errors.wrap('supplied properties not correct for "ExperimentTemplateLogConfigurationProperty"');
    }
    function cfnExperimentTemplateExperimentTemplateLogConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnExperimentTemplate_ExperimentTemplateLogConfigurationPropertyValidator(properties).assertSuccess(), { CloudWatchLogsConfiguration: cdk.objectToCloudFormation(properties.cloudWatchLogsConfiguration), LogSchemaVersion: cdk.numberToCloudFormation(properties.logSchemaVersion), S3Configuration: cdk.objectToCloudFormation(properties.s3Configuration) }) : properties;
    }
    function CfnExperimentTemplateExperimentTemplateLogConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchLogsConfiguration", "CloudWatchLogsConfiguration", properties.CloudWatchLogsConfiguration != null ? cfn_parse.FromCloudFormation.getAny(properties.CloudWatchLogsConfiguration) : void 0), ret.addPropertyResult("logSchemaVersion", "LogSchemaVersion", cfn_parse.FromCloudFormation.getNumber(properties.LogSchemaVersion)), ret.addPropertyResult("s3Configuration", "S3Configuration", properties.S3Configuration != null ? cfn_parse.FromCloudFormation.getAny(properties.S3Configuration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnExperimentTemplate_ExperimentTemplateStopConditionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("source", cdk.requiredValidator)(properties.source)), errors.collect(cdk.propertyValidator("source", cdk.validateString)(properties.source)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "ExperimentTemplateStopConditionProperty"');
    }
    function cfnExperimentTemplateExperimentTemplateStopConditionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnExperimentTemplate_ExperimentTemplateStopConditionPropertyValidator(properties).assertSuccess(), { Source: cdk.stringToCloudFormation(properties.source), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnExperimentTemplateExperimentTemplateStopConditionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("source", "Source", cfn_parse.FromCloudFormation.getString(properties.Source)), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnExperimentTemplate_ExperimentTemplateTargetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("filters", cdk.listValidator(CfnExperimentTemplate_ExperimentTemplateTargetFilterPropertyValidator))(properties.filters)), errors.collect(cdk.propertyValidator("parameters", cdk.hashValidator(cdk.validateString))(properties.parameters)), errors.collect(cdk.propertyValidator("resourceArns", cdk.listValidator(cdk.validateString))(properties.resourceArns)), errors.collect(cdk.propertyValidator("resourceTags", cdk.hashValidator(cdk.validateString))(properties.resourceTags)), errors.collect(cdk.propertyValidator("resourceType", cdk.requiredValidator)(properties.resourceType)), errors.collect(cdk.propertyValidator("resourceType", cdk.validateString)(properties.resourceType)), errors.collect(cdk.propertyValidator("selectionMode", cdk.requiredValidator)(properties.selectionMode)), errors.collect(cdk.propertyValidator("selectionMode", cdk.validateString)(properties.selectionMode)), errors.wrap('supplied properties not correct for "ExperimentTemplateTargetProperty"');
    }
    function cfnExperimentTemplateExperimentTemplateTargetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnExperimentTemplate_ExperimentTemplateTargetPropertyValidator(properties).assertSuccess(), { Filters: cdk.listMapper(cfnExperimentTemplateExperimentTemplateTargetFilterPropertyToCloudFormation)(properties.filters), Parameters: cdk.hashMapper(cdk.stringToCloudFormation)(properties.parameters), ResourceArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.resourceArns), ResourceTags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.resourceTags), ResourceType: cdk.stringToCloudFormation(properties.resourceType), SelectionMode: cdk.stringToCloudFormation(properties.selectionMode) }) : properties;
    }
    function CfnExperimentTemplateExperimentTemplateTargetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("filters", "Filters", properties.Filters != null ? cfn_parse.FromCloudFormation.getArray(CfnExperimentTemplateExperimentTemplateTargetFilterPropertyFromCloudFormation)(properties.Filters) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Parameters) : void 0), ret.addPropertyResult("resourceArns", "ResourceArns", properties.ResourceArns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ResourceArns) : void 0), ret.addPropertyResult("resourceTags", "ResourceTags", properties.ResourceTags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.ResourceTags) : void 0), ret.addPropertyResult("resourceType", "ResourceType", cfn_parse.FromCloudFormation.getString(properties.ResourceType)), ret.addPropertyResult("selectionMode", "SelectionMode", cfn_parse.FromCloudFormation.getString(properties.SelectionMode)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnExperimentTemplate_ExperimentTemplateTargetFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("path", cdk.requiredValidator)(properties.path)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.collect(cdk.propertyValidator("values", cdk.requiredValidator)(properties.values)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "ExperimentTemplateTargetFilterProperty"');
    }
    function cfnExperimentTemplateExperimentTemplateTargetFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnExperimentTemplate_ExperimentTemplateTargetFilterPropertyValidator(properties).assertSuccess(), { Path: cdk.stringToCloudFormation(properties.path), Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnExperimentTemplateExperimentTemplateTargetFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("path", "Path", cfn_parse.FromCloudFormation.getString(properties.Path)), ret.addPropertyResult("values", "Values", cfn_parse.FromCloudFormation.getStringArray(properties.Values)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-fis/lib/index.js
var require_lib129 = __commonJS({
  "node_modules/aws-cdk-lib/aws-fis/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_fis_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-fis/index.js
var require_aws_fis = __commonJS({
  "node_modules/aws-cdk-lib/aws-fis/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib129(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-fms/lib/fms.generated.js
var require_fms_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-fms/lib/fms.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnResourceSet = exports2.CfnPolicy = exports2.CfnNotificationChannel = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnNotificationChannelPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("snsRoleName", cdk.requiredValidator)(properties.snsRoleName)), errors.collect(cdk.propertyValidator("snsRoleName", cdk.validateString)(properties.snsRoleName)), errors.collect(cdk.propertyValidator("snsTopicArn", cdk.requiredValidator)(properties.snsTopicArn)), errors.collect(cdk.propertyValidator("snsTopicArn", cdk.validateString)(properties.snsTopicArn)), errors.wrap('supplied properties not correct for "CfnNotificationChannelProps"');
    }
    function cfnNotificationChannelPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNotificationChannelPropsValidator(properties).assertSuccess(), { SnsRoleName: cdk.stringToCloudFormation(properties.snsRoleName), SnsTopicArn: cdk.stringToCloudFormation(properties.snsTopicArn) }) : properties;
    }
    function CfnNotificationChannelPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("snsRoleName", "SnsRoleName", cfn_parse.FromCloudFormation.getString(properties.SnsRoleName)), ret.addPropertyResult("snsTopicArn", "SnsTopicArn", cfn_parse.FromCloudFormation.getString(properties.SnsTopicArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnNotificationChannel = class _CfnNotificationChannel extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnNotificationChannelPropsFromCloudFormation(resourceProperties), ret = new _CfnNotificationChannel(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnNotificationChannel.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_fms_CfnNotificationChannelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnNotificationChannel), error;
        }
        cdk.requireProperty(props, "snsRoleName", this), cdk.requireProperty(props, "snsTopicArn", this), this.snsRoleName = props.snsRoleName, this.snsTopicArn = props.snsTopicArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnNotificationChannel.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { snsRoleName: this.snsRoleName, snsTopicArn: this.snsTopicArn };
      }
      renderProperties(props) {
        return cfnNotificationChannelPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnNotificationChannel[_a] = { fqn: "aws-cdk-lib.aws_fms.CfnNotificationChannel", version: "2.80.0" }, CfnNotificationChannel.CFN_RESOURCE_TYPE_NAME = "AWS::FMS::NotificationChannel", exports2.CfnNotificationChannel = CfnNotificationChannel;
    function CfnPolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deleteAllPolicyResources", cdk.validateBoolean)(properties.deleteAllPolicyResources)), errors.collect(cdk.propertyValidator("excludeMap", CfnPolicy_IEMapPropertyValidator)(properties.excludeMap)), errors.collect(cdk.propertyValidator("excludeResourceTags", cdk.requiredValidator)(properties.excludeResourceTags)), errors.collect(cdk.propertyValidator("excludeResourceTags", cdk.validateBoolean)(properties.excludeResourceTags)), errors.collect(cdk.propertyValidator("includeMap", CfnPolicy_IEMapPropertyValidator)(properties.includeMap)), errors.collect(cdk.propertyValidator("policyDescription", cdk.validateString)(properties.policyDescription)), errors.collect(cdk.propertyValidator("policyName", cdk.requiredValidator)(properties.policyName)), errors.collect(cdk.propertyValidator("policyName", cdk.validateString)(properties.policyName)), errors.collect(cdk.propertyValidator("remediationEnabled", cdk.requiredValidator)(properties.remediationEnabled)), errors.collect(cdk.propertyValidator("remediationEnabled", cdk.validateBoolean)(properties.remediationEnabled)), errors.collect(cdk.propertyValidator("resourceSetIds", cdk.listValidator(cdk.validateString))(properties.resourceSetIds)), errors.collect(cdk.propertyValidator("resourceTags", cdk.listValidator(CfnPolicy_ResourceTagPropertyValidator))(properties.resourceTags)), errors.collect(cdk.propertyValidator("resourceType", cdk.validateString)(properties.resourceType)), errors.collect(cdk.propertyValidator("resourceTypeList", cdk.listValidator(cdk.validateString))(properties.resourceTypeList)), errors.collect(cdk.propertyValidator("resourcesCleanUp", cdk.validateBoolean)(properties.resourcesCleanUp)), errors.collect(cdk.propertyValidator("securityServicePolicyData", cdk.requiredValidator)(properties.securityServicePolicyData)), errors.collect(cdk.propertyValidator("securityServicePolicyData", CfnPolicy_SecurityServicePolicyDataPropertyValidator)(properties.securityServicePolicyData)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(CfnPolicy_PolicyTagPropertyValidator))(properties.tags)), errors.wrap('supplied properties not correct for "CfnPolicyProps"');
    }
    function cfnPolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPolicyPropsValidator(properties).assertSuccess(), { ExcludeResourceTags: cdk.booleanToCloudFormation(properties.excludeResourceTags), PolicyName: cdk.stringToCloudFormation(properties.policyName), RemediationEnabled: cdk.booleanToCloudFormation(properties.remediationEnabled), SecurityServicePolicyData: cfnPolicySecurityServicePolicyDataPropertyToCloudFormation(properties.securityServicePolicyData), DeleteAllPolicyResources: cdk.booleanToCloudFormation(properties.deleteAllPolicyResources), ExcludeMap: cfnPolicyIEMapPropertyToCloudFormation(properties.excludeMap), IncludeMap: cfnPolicyIEMapPropertyToCloudFormation(properties.includeMap), PolicyDescription: cdk.stringToCloudFormation(properties.policyDescription), ResourcesCleanUp: cdk.booleanToCloudFormation(properties.resourcesCleanUp), ResourceSetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.resourceSetIds), ResourceTags: cdk.listMapper(cfnPolicyResourceTagPropertyToCloudFormation)(properties.resourceTags), ResourceType: cdk.stringToCloudFormation(properties.resourceType), ResourceTypeList: cdk.listMapper(cdk.stringToCloudFormation)(properties.resourceTypeList), Tags: cdk.listMapper(cfnPolicyPolicyTagPropertyToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnPolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("excludeResourceTags", "ExcludeResourceTags", cfn_parse.FromCloudFormation.getBoolean(properties.ExcludeResourceTags)), ret.addPropertyResult("policyName", "PolicyName", cfn_parse.FromCloudFormation.getString(properties.PolicyName)), ret.addPropertyResult("remediationEnabled", "RemediationEnabled", cfn_parse.FromCloudFormation.getBoolean(properties.RemediationEnabled)), ret.addPropertyResult("securityServicePolicyData", "SecurityServicePolicyData", CfnPolicySecurityServicePolicyDataPropertyFromCloudFormation(properties.SecurityServicePolicyData)), ret.addPropertyResult("deleteAllPolicyResources", "DeleteAllPolicyResources", properties.DeleteAllPolicyResources != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeleteAllPolicyResources) : void 0), ret.addPropertyResult("excludeMap", "ExcludeMap", properties.ExcludeMap != null ? CfnPolicyIEMapPropertyFromCloudFormation(properties.ExcludeMap) : void 0), ret.addPropertyResult("includeMap", "IncludeMap", properties.IncludeMap != null ? CfnPolicyIEMapPropertyFromCloudFormation(properties.IncludeMap) : void 0), ret.addPropertyResult("policyDescription", "PolicyDescription", properties.PolicyDescription != null ? cfn_parse.FromCloudFormation.getString(properties.PolicyDescription) : void 0), ret.addPropertyResult("resourcesCleanUp", "ResourcesCleanUp", properties.ResourcesCleanUp != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ResourcesCleanUp) : void 0), ret.addPropertyResult("resourceSetIds", "ResourceSetIds", properties.ResourceSetIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ResourceSetIds) : void 0), ret.addPropertyResult("resourceTags", "ResourceTags", properties.ResourceTags != null ? cfn_parse.FromCloudFormation.getArray(CfnPolicyResourceTagPropertyFromCloudFormation)(properties.ResourceTags) : void 0), ret.addPropertyResult("resourceType", "ResourceType", properties.ResourceType != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceType) : void 0), ret.addPropertyResult("resourceTypeList", "ResourceTypeList", properties.ResourceTypeList != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ResourceTypeList) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(CfnPolicyPolicyTagPropertyFromCloudFormation)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPolicy = class _CfnPolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnPolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_fms_CfnPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPolicy), error;
        }
        cdk.requireProperty(props, "excludeResourceTags", this), cdk.requireProperty(props, "policyName", this), cdk.requireProperty(props, "remediationEnabled", this), cdk.requireProperty(props, "securityServicePolicyData", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.excludeResourceTags = props.excludeResourceTags, this.policyName = props.policyName, this.remediationEnabled = props.remediationEnabled, this.securityServicePolicyData = props.securityServicePolicyData, this.deleteAllPolicyResources = props.deleteAllPolicyResources, this.excludeMap = props.excludeMap, this.includeMap = props.includeMap, this.policyDescription = props.policyDescription, this.resourcesCleanUp = props.resourcesCleanUp, this.resourceSetIds = props.resourceSetIds, this.resourceTags = props.resourceTags, this.resourceType = props.resourceType, this.resourceTypeList = props.resourceTypeList, this.tags = props.tags;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { excludeResourceTags: this.excludeResourceTags, policyName: this.policyName, remediationEnabled: this.remediationEnabled, securityServicePolicyData: this.securityServicePolicyData, deleteAllPolicyResources: this.deleteAllPolicyResources, excludeMap: this.excludeMap, includeMap: this.includeMap, policyDescription: this.policyDescription, resourcesCleanUp: this.resourcesCleanUp, resourceSetIds: this.resourceSetIds, resourceTags: this.resourceTags, resourceType: this.resourceType, resourceTypeList: this.resourceTypeList, tags: this.tags };
      }
      renderProperties(props) {
        return cfnPolicyPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnPolicy[_b] = { fqn: "aws-cdk-lib.aws_fms.CfnPolicy", version: "2.80.0" }, CfnPolicy.CFN_RESOURCE_TYPE_NAME = "AWS::FMS::Policy", exports2.CfnPolicy = CfnPolicy;
    function CfnPolicy_IEMapPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("account", cdk.listValidator(cdk.validateString))(properties.account)), errors.collect(cdk.propertyValidator("orgunit", cdk.listValidator(cdk.validateString))(properties.orgunit)), errors.wrap('supplied properties not correct for "IEMapProperty"');
    }
    function cfnPolicyIEMapPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPolicy_IEMapPropertyValidator(properties).assertSuccess(), { ACCOUNT: cdk.listMapper(cdk.stringToCloudFormation)(properties.account), ORGUNIT: cdk.listMapper(cdk.stringToCloudFormation)(properties.orgunit) }) : properties;
    }
    function CfnPolicyIEMapPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("account", "ACCOUNT", properties.ACCOUNT != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ACCOUNT) : void 0), ret.addPropertyResult("orgunit", "ORGUNIT", properties.ORGUNIT != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ORGUNIT) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPolicy_NetworkFirewallPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("firewallDeploymentModel", cdk.requiredValidator)(properties.firewallDeploymentModel)), errors.collect(cdk.propertyValidator("firewallDeploymentModel", cdk.validateString)(properties.firewallDeploymentModel)), errors.wrap('supplied properties not correct for "NetworkFirewallPolicyProperty"');
    }
    function cfnPolicyNetworkFirewallPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPolicy_NetworkFirewallPolicyPropertyValidator(properties).assertSuccess(), { FirewallDeploymentModel: cdk.stringToCloudFormation(properties.firewallDeploymentModel) }) : properties;
    }
    function CfnPolicyNetworkFirewallPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("firewallDeploymentModel", "FirewallDeploymentModel", cfn_parse.FromCloudFormation.getString(properties.FirewallDeploymentModel)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPolicy_PolicyOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("networkFirewallPolicy", CfnPolicy_NetworkFirewallPolicyPropertyValidator)(properties.networkFirewallPolicy)), errors.collect(cdk.propertyValidator("thirdPartyFirewallPolicy", CfnPolicy_ThirdPartyFirewallPolicyPropertyValidator)(properties.thirdPartyFirewallPolicy)), errors.wrap('supplied properties not correct for "PolicyOptionProperty"');
    }
    function cfnPolicyPolicyOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPolicy_PolicyOptionPropertyValidator(properties).assertSuccess(), { NetworkFirewallPolicy: cfnPolicyNetworkFirewallPolicyPropertyToCloudFormation(properties.networkFirewallPolicy), ThirdPartyFirewallPolicy: cfnPolicyThirdPartyFirewallPolicyPropertyToCloudFormation(properties.thirdPartyFirewallPolicy) }) : properties;
    }
    function CfnPolicyPolicyOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("networkFirewallPolicy", "NetworkFirewallPolicy", properties.NetworkFirewallPolicy != null ? CfnPolicyNetworkFirewallPolicyPropertyFromCloudFormation(properties.NetworkFirewallPolicy) : void 0), ret.addPropertyResult("thirdPartyFirewallPolicy", "ThirdPartyFirewallPolicy", properties.ThirdPartyFirewallPolicy != null ? CfnPolicyThirdPartyFirewallPolicyPropertyFromCloudFormation(properties.ThirdPartyFirewallPolicy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPolicy_PolicyTagPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "PolicyTagProperty"');
    }
    function cfnPolicyPolicyTagPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPolicy_PolicyTagPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnPolicyPolicyTagPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPolicy_ResourceTagPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "ResourceTagProperty"');
    }
    function cfnPolicyResourceTagPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPolicy_ResourceTagPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnPolicyResourceTagPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPolicy_SecurityServicePolicyDataPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("managedServiceData", cdk.validateString)(properties.managedServiceData)), errors.collect(cdk.propertyValidator("policyOption", CfnPolicy_PolicyOptionPropertyValidator)(properties.policyOption)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "SecurityServicePolicyDataProperty"');
    }
    function cfnPolicySecurityServicePolicyDataPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPolicy_SecurityServicePolicyDataPropertyValidator(properties).assertSuccess(), { ManagedServiceData: cdk.stringToCloudFormation(properties.managedServiceData), PolicyOption: cfnPolicyPolicyOptionPropertyToCloudFormation(properties.policyOption), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnPolicySecurityServicePolicyDataPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("managedServiceData", "ManagedServiceData", properties.ManagedServiceData != null ? cfn_parse.FromCloudFormation.getString(properties.ManagedServiceData) : void 0), ret.addPropertyResult("policyOption", "PolicyOption", properties.PolicyOption != null ? CfnPolicyPolicyOptionPropertyFromCloudFormation(properties.PolicyOption) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPolicy_ThirdPartyFirewallPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("firewallDeploymentModel", cdk.requiredValidator)(properties.firewallDeploymentModel)), errors.collect(cdk.propertyValidator("firewallDeploymentModel", cdk.validateString)(properties.firewallDeploymentModel)), errors.wrap('supplied properties not correct for "ThirdPartyFirewallPolicyProperty"');
    }
    function cfnPolicyThirdPartyFirewallPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPolicy_ThirdPartyFirewallPolicyPropertyValidator(properties).assertSuccess(), { FirewallDeploymentModel: cdk.stringToCloudFormation(properties.firewallDeploymentModel) }) : properties;
    }
    function CfnPolicyThirdPartyFirewallPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("firewallDeploymentModel", "FirewallDeploymentModel", cfn_parse.FromCloudFormation.getString(properties.FirewallDeploymentModel)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourceSetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("resourceTypeList", cdk.requiredValidator)(properties.resourceTypeList)), errors.collect(cdk.propertyValidator("resourceTypeList", cdk.listValidator(cdk.validateString))(properties.resourceTypeList)), errors.collect(cdk.propertyValidator("resources", cdk.listValidator(cdk.validateString))(properties.resources)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnResourceSetProps"');
    }
    function cfnResourceSetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceSetPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), ResourceTypeList: cdk.listMapper(cdk.stringToCloudFormation)(properties.resourceTypeList), Description: cdk.stringToCloudFormation(properties.description), Resources: cdk.listMapper(cdk.stringToCloudFormation)(properties.resources), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnResourceSetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("resourceTypeList", "ResourceTypeList", cfn_parse.FromCloudFormation.getStringArray(properties.ResourceTypeList)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("resources", "Resources", properties.Resources != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Resources) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResourceSet = class _CfnResourceSet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResourceSetPropsFromCloudFormation(resourceProperties), ret = new _CfnResourceSet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnResourceSet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_fms_CfnResourceSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResourceSet), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "resourceTypeList", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.resourceTypeList = props.resourceTypeList, this.description = props.description, this.resources = props.resources, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::FMS::ResourceSet", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResourceSet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, resourceTypeList: this.resourceTypeList, description: this.description, resources: this.resources, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnResourceSetPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnResourceSet[_c] = { fqn: "aws-cdk-lib.aws_fms.CfnResourceSet", version: "2.80.0" }, CfnResourceSet.CFN_RESOURCE_TYPE_NAME = "AWS::FMS::ResourceSet", exports2.CfnResourceSet = CfnResourceSet;
  }
});

// node_modules/aws-cdk-lib/aws-fms/lib/index.js
var require_lib130 = __commonJS({
  "node_modules/aws-cdk-lib/aws-fms/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_fms_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-fms/index.js
var require_aws_fms = __commonJS({
  "node_modules/aws-cdk-lib/aws-fms/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib130(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-forecast/lib/forecast.generated.js
var require_forecast_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-forecast/lib/forecast.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnDatasetGroup = exports2.CfnDataset = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnDatasetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataFrequency", cdk.validateString)(properties.dataFrequency)), errors.collect(cdk.propertyValidator("datasetName", cdk.requiredValidator)(properties.datasetName)), errors.collect(cdk.propertyValidator("datasetName", cdk.validateString)(properties.datasetName)), errors.collect(cdk.propertyValidator("datasetType", cdk.requiredValidator)(properties.datasetType)), errors.collect(cdk.propertyValidator("datasetType", cdk.validateString)(properties.datasetType)), errors.collect(cdk.propertyValidator("domain", cdk.requiredValidator)(properties.domain)), errors.collect(cdk.propertyValidator("domain", cdk.validateString)(properties.domain)), errors.collect(cdk.propertyValidator("encryptionConfig", cdk.validateObject)(properties.encryptionConfig)), errors.collect(cdk.propertyValidator("schema", cdk.requiredValidator)(properties.schema)), errors.collect(cdk.propertyValidator("schema", cdk.validateObject)(properties.schema)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(CfnDataset_TagsItemsPropertyValidator))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDatasetProps"');
    }
    function cfnDatasetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDatasetPropsValidator(properties).assertSuccess(), { DatasetName: cdk.stringToCloudFormation(properties.datasetName), DatasetType: cdk.stringToCloudFormation(properties.datasetType), Domain: cdk.stringToCloudFormation(properties.domain), Schema: cdk.objectToCloudFormation(properties.schema), DataFrequency: cdk.stringToCloudFormation(properties.dataFrequency), EncryptionConfig: cdk.objectToCloudFormation(properties.encryptionConfig), Tags: cdk.listMapper(cfnDatasetTagsItemsPropertyToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDatasetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("datasetName", "DatasetName", cfn_parse.FromCloudFormation.getString(properties.DatasetName)), ret.addPropertyResult("datasetType", "DatasetType", cfn_parse.FromCloudFormation.getString(properties.DatasetType)), ret.addPropertyResult("domain", "Domain", cfn_parse.FromCloudFormation.getString(properties.Domain)), ret.addPropertyResult("schema", "Schema", cfn_parse.FromCloudFormation.getAny(properties.Schema)), ret.addPropertyResult("dataFrequency", "DataFrequency", properties.DataFrequency != null ? cfn_parse.FromCloudFormation.getString(properties.DataFrequency) : void 0), ret.addPropertyResult("encryptionConfig", "EncryptionConfig", properties.EncryptionConfig != null ? cfn_parse.FromCloudFormation.getAny(properties.EncryptionConfig) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(CfnDatasetTagsItemsPropertyFromCloudFormation)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDataset = class _CfnDataset extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDatasetPropsFromCloudFormation(resourceProperties), ret = new _CfnDataset(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDataset.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_forecast_CfnDatasetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDataset), error;
        }
        cdk.requireProperty(props, "datasetName", this), cdk.requireProperty(props, "datasetType", this), cdk.requireProperty(props, "domain", this), cdk.requireProperty(props, "schema", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.datasetName = props.datasetName, this.datasetType = props.datasetType, this.domain = props.domain, this.schema = props.schema, this.dataFrequency = props.dataFrequency, this.encryptionConfig = props.encryptionConfig, this.tags = props.tags;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDataset.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { datasetName: this.datasetName, datasetType: this.datasetType, domain: this.domain, schema: this.schema, dataFrequency: this.dataFrequency, encryptionConfig: this.encryptionConfig, tags: this.tags };
      }
      renderProperties(props) {
        return cfnDatasetPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnDataset[_a] = { fqn: "aws-cdk-lib.aws_forecast.CfnDataset", version: "2.80.0" }, CfnDataset.CFN_RESOURCE_TYPE_NAME = "AWS::Forecast::Dataset", exports2.CfnDataset = CfnDataset;
    function CfnDataset_TagsItemsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TagsItemsProperty"');
    }
    function cfnDatasetTagsItemsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_TagsItemsPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnDatasetTagsItemsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDatasetGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("datasetArns", cdk.listValidator(cdk.validateString))(properties.datasetArns)), errors.collect(cdk.propertyValidator("datasetGroupName", cdk.requiredValidator)(properties.datasetGroupName)), errors.collect(cdk.propertyValidator("datasetGroupName", cdk.validateString)(properties.datasetGroupName)), errors.collect(cdk.propertyValidator("domain", cdk.requiredValidator)(properties.domain)), errors.collect(cdk.propertyValidator("domain", cdk.validateString)(properties.domain)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDatasetGroupProps"');
    }
    function cfnDatasetGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDatasetGroupPropsValidator(properties).assertSuccess(), { DatasetGroupName: cdk.stringToCloudFormation(properties.datasetGroupName), Domain: cdk.stringToCloudFormation(properties.domain), DatasetArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.datasetArns), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDatasetGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("datasetGroupName", "DatasetGroupName", cfn_parse.FromCloudFormation.getString(properties.DatasetGroupName)), ret.addPropertyResult("domain", "Domain", cfn_parse.FromCloudFormation.getString(properties.Domain)), ret.addPropertyResult("datasetArns", "DatasetArns", properties.DatasetArns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.DatasetArns) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDatasetGroup = class _CfnDatasetGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDatasetGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnDatasetGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDatasetGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_forecast_CfnDatasetGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDatasetGroup), error;
        }
        cdk.requireProperty(props, "datasetGroupName", this), cdk.requireProperty(props, "domain", this), this.attrDatasetGroupArn = cdk.Token.asString(this.getAtt("DatasetGroupArn", cdk.ResolutionTypeHint.STRING)), this.datasetGroupName = props.datasetGroupName, this.domain = props.domain, this.datasetArns = props.datasetArns, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Forecast::DatasetGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDatasetGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { datasetGroupName: this.datasetGroupName, domain: this.domain, datasetArns: this.datasetArns, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDatasetGroupPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnDatasetGroup[_b] = { fqn: "aws-cdk-lib.aws_forecast.CfnDatasetGroup", version: "2.80.0" }, CfnDatasetGroup.CFN_RESOURCE_TYPE_NAME = "AWS::Forecast::DatasetGroup", exports2.CfnDatasetGroup = CfnDatasetGroup;
  }
});

// node_modules/aws-cdk-lib/aws-forecast/lib/index.js
var require_lib131 = __commonJS({
  "node_modules/aws-cdk-lib/aws-forecast/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_forecast_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-forecast/index.js
var require_aws_forecast = __commonJS({
  "node_modules/aws-cdk-lib/aws-forecast/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib131(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-frauddetector/lib/frauddetector.generated.js
var require_frauddetector_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-frauddetector/lib/frauddetector.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnVariable = exports2.CfnOutcome = exports2.CfnList = exports2.CfnLabel = exports2.CfnEventType = exports2.CfnEntityType = exports2.CfnDetector = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnDetectorPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("associatedModels", cdk.listValidator(CfnDetector_ModelPropertyValidator))(properties.associatedModels)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("detectorId", cdk.requiredValidator)(properties.detectorId)), errors.collect(cdk.propertyValidator("detectorId", cdk.validateString)(properties.detectorId)), errors.collect(cdk.propertyValidator("detectorVersionStatus", cdk.validateString)(properties.detectorVersionStatus)), errors.collect(cdk.propertyValidator("eventType", cdk.requiredValidator)(properties.eventType)), errors.collect(cdk.propertyValidator("eventType", CfnDetector_EventTypePropertyValidator)(properties.eventType)), errors.collect(cdk.propertyValidator("ruleExecutionMode", cdk.validateString)(properties.ruleExecutionMode)), errors.collect(cdk.propertyValidator("rules", cdk.requiredValidator)(properties.rules)), errors.collect(cdk.propertyValidator("rules", cdk.listValidator(CfnDetector_RulePropertyValidator))(properties.rules)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDetectorProps"');
    }
    function cfnDetectorPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetectorPropsValidator(properties).assertSuccess(), { DetectorId: cdk.stringToCloudFormation(properties.detectorId), EventType: cfnDetectorEventTypePropertyToCloudFormation(properties.eventType), Rules: cdk.listMapper(cfnDetectorRulePropertyToCloudFormation)(properties.rules), AssociatedModels: cdk.listMapper(cfnDetectorModelPropertyToCloudFormation)(properties.associatedModels), Description: cdk.stringToCloudFormation(properties.description), DetectorVersionStatus: cdk.stringToCloudFormation(properties.detectorVersionStatus), RuleExecutionMode: cdk.stringToCloudFormation(properties.ruleExecutionMode), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDetectorPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("detectorId", "DetectorId", cfn_parse.FromCloudFormation.getString(properties.DetectorId)), ret.addPropertyResult("eventType", "EventType", CfnDetectorEventTypePropertyFromCloudFormation(properties.EventType)), ret.addPropertyResult("rules", "Rules", cfn_parse.FromCloudFormation.getArray(CfnDetectorRulePropertyFromCloudFormation)(properties.Rules)), ret.addPropertyResult("associatedModels", "AssociatedModels", properties.AssociatedModels != null ? cfn_parse.FromCloudFormation.getArray(CfnDetectorModelPropertyFromCloudFormation)(properties.AssociatedModels) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("detectorVersionStatus", "DetectorVersionStatus", properties.DetectorVersionStatus != null ? cfn_parse.FromCloudFormation.getString(properties.DetectorVersionStatus) : void 0), ret.addPropertyResult("ruleExecutionMode", "RuleExecutionMode", properties.RuleExecutionMode != null ? cfn_parse.FromCloudFormation.getString(properties.RuleExecutionMode) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDetector = class _CfnDetector extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDetectorPropsFromCloudFormation(resourceProperties), ret = new _CfnDetector(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDetector.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_frauddetector_CfnDetectorProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDetector), error;
        }
        cdk.requireProperty(props, "detectorId", this), cdk.requireProperty(props, "eventType", this), cdk.requireProperty(props, "rules", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreatedTime = cdk.Token.asString(this.getAtt("CreatedTime", cdk.ResolutionTypeHint.STRING)), this.attrDetectorVersionId = cdk.Token.asString(this.getAtt("DetectorVersionId", cdk.ResolutionTypeHint.STRING)), this.attrEventTypeArn = cdk.Token.asString(this.getAtt("EventType.Arn", cdk.ResolutionTypeHint.STRING)), this.attrEventTypeCreatedTime = cdk.Token.asString(this.getAtt("EventType.CreatedTime", cdk.ResolutionTypeHint.STRING)), this.attrEventTypeLastUpdatedTime = cdk.Token.asString(this.getAtt("EventType.LastUpdatedTime", cdk.ResolutionTypeHint.STRING)), this.attrLastUpdatedTime = cdk.Token.asString(this.getAtt("LastUpdatedTime", cdk.ResolutionTypeHint.STRING)), this.detectorId = props.detectorId, this.eventType = props.eventType, this.rules = props.rules, this.associatedModels = props.associatedModels, this.description = props.description, this.detectorVersionStatus = props.detectorVersionStatus, this.ruleExecutionMode = props.ruleExecutionMode, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::FraudDetector::Detector", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDetector.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { detectorId: this.detectorId, eventType: this.eventType, rules: this.rules, associatedModels: this.associatedModels, description: this.description, detectorVersionStatus: this.detectorVersionStatus, ruleExecutionMode: this.ruleExecutionMode, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDetectorPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnDetector[_a] = { fqn: "aws-cdk-lib.aws_frauddetector.CfnDetector", version: "2.80.0" }, CfnDetector.CFN_RESOURCE_TYPE_NAME = "AWS::FraudDetector::Detector", exports2.CfnDetector = CfnDetector;
    function CfnDetector_EntityTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("createdTime", cdk.validateString)(properties.createdTime)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("inline", cdk.validateBoolean)(properties.inline)), errors.collect(cdk.propertyValidator("lastUpdatedTime", cdk.validateString)(properties.lastUpdatedTime)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "EntityTypeProperty"');
    }
    function cfnDetectorEntityTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetector_EntityTypePropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn), CreatedTime: cdk.stringToCloudFormation(properties.createdTime), Description: cdk.stringToCloudFormation(properties.description), Inline: cdk.booleanToCloudFormation(properties.inline), LastUpdatedTime: cdk.stringToCloudFormation(properties.lastUpdatedTime), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDetectorEntityTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", properties.Arn != null ? cfn_parse.FromCloudFormation.getString(properties.Arn) : void 0), ret.addPropertyResult("createdTime", "CreatedTime", properties.CreatedTime != null ? cfn_parse.FromCloudFormation.getString(properties.CreatedTime) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("inline", "Inline", properties.Inline != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Inline) : void 0), ret.addPropertyResult("lastUpdatedTime", "LastUpdatedTime", properties.LastUpdatedTime != null ? cfn_parse.FromCloudFormation.getString(properties.LastUpdatedTime) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetector_EventTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("createdTime", cdk.validateString)(properties.createdTime)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("entityTypes", cdk.listValidator(CfnDetector_EntityTypePropertyValidator))(properties.entityTypes)), errors.collect(cdk.propertyValidator("eventVariables", cdk.listValidator(CfnDetector_EventVariablePropertyValidator))(properties.eventVariables)), errors.collect(cdk.propertyValidator("inline", cdk.validateBoolean)(properties.inline)), errors.collect(cdk.propertyValidator("labels", cdk.listValidator(CfnDetector_LabelPropertyValidator))(properties.labels)), errors.collect(cdk.propertyValidator("lastUpdatedTime", cdk.validateString)(properties.lastUpdatedTime)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "EventTypeProperty"');
    }
    function cfnDetectorEventTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetector_EventTypePropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn), CreatedTime: cdk.stringToCloudFormation(properties.createdTime), Description: cdk.stringToCloudFormation(properties.description), EntityTypes: cdk.listMapper(cfnDetectorEntityTypePropertyToCloudFormation)(properties.entityTypes), EventVariables: cdk.listMapper(cfnDetectorEventVariablePropertyToCloudFormation)(properties.eventVariables), Inline: cdk.booleanToCloudFormation(properties.inline), Labels: cdk.listMapper(cfnDetectorLabelPropertyToCloudFormation)(properties.labels), LastUpdatedTime: cdk.stringToCloudFormation(properties.lastUpdatedTime), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDetectorEventTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", properties.Arn != null ? cfn_parse.FromCloudFormation.getString(properties.Arn) : void 0), ret.addPropertyResult("createdTime", "CreatedTime", properties.CreatedTime != null ? cfn_parse.FromCloudFormation.getString(properties.CreatedTime) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("entityTypes", "EntityTypes", properties.EntityTypes != null ? cfn_parse.FromCloudFormation.getArray(CfnDetectorEntityTypePropertyFromCloudFormation)(properties.EntityTypes) : void 0), ret.addPropertyResult("eventVariables", "EventVariables", properties.EventVariables != null ? cfn_parse.FromCloudFormation.getArray(CfnDetectorEventVariablePropertyFromCloudFormation)(properties.EventVariables) : void 0), ret.addPropertyResult("inline", "Inline", properties.Inline != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Inline) : void 0), ret.addPropertyResult("labels", "Labels", properties.Labels != null ? cfn_parse.FromCloudFormation.getArray(CfnDetectorLabelPropertyFromCloudFormation)(properties.Labels) : void 0), ret.addPropertyResult("lastUpdatedTime", "LastUpdatedTime", properties.LastUpdatedTime != null ? cfn_parse.FromCloudFormation.getString(properties.LastUpdatedTime) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetector_EventVariablePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("createdTime", cdk.validateString)(properties.createdTime)), errors.collect(cdk.propertyValidator("dataSource", cdk.validateString)(properties.dataSource)), errors.collect(cdk.propertyValidator("dataType", cdk.validateString)(properties.dataType)), errors.collect(cdk.propertyValidator("defaultValue", cdk.validateString)(properties.defaultValue)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("inline", cdk.validateBoolean)(properties.inline)), errors.collect(cdk.propertyValidator("lastUpdatedTime", cdk.validateString)(properties.lastUpdatedTime)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("variableType", cdk.validateString)(properties.variableType)), errors.wrap('supplied properties not correct for "EventVariableProperty"');
    }
    function cfnDetectorEventVariablePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetector_EventVariablePropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn), CreatedTime: cdk.stringToCloudFormation(properties.createdTime), DataSource: cdk.stringToCloudFormation(properties.dataSource), DataType: cdk.stringToCloudFormation(properties.dataType), DefaultValue: cdk.stringToCloudFormation(properties.defaultValue), Description: cdk.stringToCloudFormation(properties.description), Inline: cdk.booleanToCloudFormation(properties.inline), LastUpdatedTime: cdk.stringToCloudFormation(properties.lastUpdatedTime), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VariableType: cdk.stringToCloudFormation(properties.variableType) }) : properties;
    }
    function CfnDetectorEventVariablePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", properties.Arn != null ? cfn_parse.FromCloudFormation.getString(properties.Arn) : void 0), ret.addPropertyResult("createdTime", "CreatedTime", properties.CreatedTime != null ? cfn_parse.FromCloudFormation.getString(properties.CreatedTime) : void 0), ret.addPropertyResult("dataSource", "DataSource", properties.DataSource != null ? cfn_parse.FromCloudFormation.getString(properties.DataSource) : void 0), ret.addPropertyResult("dataType", "DataType", properties.DataType != null ? cfn_parse.FromCloudFormation.getString(properties.DataType) : void 0), ret.addPropertyResult("defaultValue", "DefaultValue", properties.DefaultValue != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultValue) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("inline", "Inline", properties.Inline != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Inline) : void 0), ret.addPropertyResult("lastUpdatedTime", "LastUpdatedTime", properties.LastUpdatedTime != null ? cfn_parse.FromCloudFormation.getString(properties.LastUpdatedTime) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("variableType", "VariableType", properties.VariableType != null ? cfn_parse.FromCloudFormation.getString(properties.VariableType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetector_LabelPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("createdTime", cdk.validateString)(properties.createdTime)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("inline", cdk.validateBoolean)(properties.inline)), errors.collect(cdk.propertyValidator("lastUpdatedTime", cdk.validateString)(properties.lastUpdatedTime)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "LabelProperty"');
    }
    function cfnDetectorLabelPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetector_LabelPropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn), CreatedTime: cdk.stringToCloudFormation(properties.createdTime), Description: cdk.stringToCloudFormation(properties.description), Inline: cdk.booleanToCloudFormation(properties.inline), LastUpdatedTime: cdk.stringToCloudFormation(properties.lastUpdatedTime), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDetectorLabelPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", properties.Arn != null ? cfn_parse.FromCloudFormation.getString(properties.Arn) : void 0), ret.addPropertyResult("createdTime", "CreatedTime", properties.CreatedTime != null ? cfn_parse.FromCloudFormation.getString(properties.CreatedTime) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("inline", "Inline", properties.Inline != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Inline) : void 0), ret.addPropertyResult("lastUpdatedTime", "LastUpdatedTime", properties.LastUpdatedTime != null ? cfn_parse.FromCloudFormation.getString(properties.LastUpdatedTime) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetector_ModelPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.wrap('supplied properties not correct for "ModelProperty"');
    }
    function cfnDetectorModelPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetector_ModelPropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn) }) : properties;
    }
    function CfnDetectorModelPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", properties.Arn != null ? cfn_parse.FromCloudFormation.getString(properties.Arn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetector_OutcomePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("createdTime", cdk.validateString)(properties.createdTime)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("inline", cdk.validateBoolean)(properties.inline)), errors.collect(cdk.propertyValidator("lastUpdatedTime", cdk.validateString)(properties.lastUpdatedTime)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "OutcomeProperty"');
    }
    function cfnDetectorOutcomePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetector_OutcomePropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn), CreatedTime: cdk.stringToCloudFormation(properties.createdTime), Description: cdk.stringToCloudFormation(properties.description), Inline: cdk.booleanToCloudFormation(properties.inline), LastUpdatedTime: cdk.stringToCloudFormation(properties.lastUpdatedTime), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDetectorOutcomePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", properties.Arn != null ? cfn_parse.FromCloudFormation.getString(properties.Arn) : void 0), ret.addPropertyResult("createdTime", "CreatedTime", properties.CreatedTime != null ? cfn_parse.FromCloudFormation.getString(properties.CreatedTime) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("inline", "Inline", properties.Inline != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Inline) : void 0), ret.addPropertyResult("lastUpdatedTime", "LastUpdatedTime", properties.LastUpdatedTime != null ? cfn_parse.FromCloudFormation.getString(properties.LastUpdatedTime) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetector_RulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("createdTime", cdk.validateString)(properties.createdTime)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("detectorId", cdk.validateString)(properties.detectorId)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.collect(cdk.propertyValidator("language", cdk.validateString)(properties.language)), errors.collect(cdk.propertyValidator("lastUpdatedTime", cdk.validateString)(properties.lastUpdatedTime)), errors.collect(cdk.propertyValidator("outcomes", cdk.listValidator(CfnDetector_OutcomePropertyValidator))(properties.outcomes)), errors.collect(cdk.propertyValidator("ruleId", cdk.validateString)(properties.ruleId)), errors.collect(cdk.propertyValidator("ruleVersion", cdk.validateString)(properties.ruleVersion)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "RuleProperty"');
    }
    function cfnDetectorRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetector_RulePropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn), CreatedTime: cdk.stringToCloudFormation(properties.createdTime), Description: cdk.stringToCloudFormation(properties.description), DetectorId: cdk.stringToCloudFormation(properties.detectorId), Expression: cdk.stringToCloudFormation(properties.expression), Language: cdk.stringToCloudFormation(properties.language), LastUpdatedTime: cdk.stringToCloudFormation(properties.lastUpdatedTime), Outcomes: cdk.listMapper(cfnDetectorOutcomePropertyToCloudFormation)(properties.outcomes), RuleId: cdk.stringToCloudFormation(properties.ruleId), RuleVersion: cdk.stringToCloudFormation(properties.ruleVersion), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDetectorRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", properties.Arn != null ? cfn_parse.FromCloudFormation.getString(properties.Arn) : void 0), ret.addPropertyResult("createdTime", "CreatedTime", properties.CreatedTime != null ? cfn_parse.FromCloudFormation.getString(properties.CreatedTime) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("detectorId", "DetectorId", properties.DetectorId != null ? cfn_parse.FromCloudFormation.getString(properties.DetectorId) : void 0), ret.addPropertyResult("expression", "Expression", properties.Expression != null ? cfn_parse.FromCloudFormation.getString(properties.Expression) : void 0), ret.addPropertyResult("language", "Language", properties.Language != null ? cfn_parse.FromCloudFormation.getString(properties.Language) : void 0), ret.addPropertyResult("lastUpdatedTime", "LastUpdatedTime", properties.LastUpdatedTime != null ? cfn_parse.FromCloudFormation.getString(properties.LastUpdatedTime) : void 0), ret.addPropertyResult("outcomes", "Outcomes", properties.Outcomes != null ? cfn_parse.FromCloudFormation.getArray(CfnDetectorOutcomePropertyFromCloudFormation)(properties.Outcomes) : void 0), ret.addPropertyResult("ruleId", "RuleId", properties.RuleId != null ? cfn_parse.FromCloudFormation.getString(properties.RuleId) : void 0), ret.addPropertyResult("ruleVersion", "RuleVersion", properties.RuleVersion != null ? cfn_parse.FromCloudFormation.getString(properties.RuleVersion) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEntityTypePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnEntityTypeProps"');
    }
    function cfnEntityTypePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEntityTypePropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnEntityTypePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEntityType = class _CfnEntityType extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEntityTypePropsFromCloudFormation(resourceProperties), ret = new _CfnEntityType(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEntityType.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_frauddetector_CfnEntityTypeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEntityType), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreatedTime = cdk.Token.asString(this.getAtt("CreatedTime", cdk.ResolutionTypeHint.STRING)), this.attrLastUpdatedTime = cdk.Token.asString(this.getAtt("LastUpdatedTime", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::FraudDetector::EntityType", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEntityType.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnEntityTypePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnEntityType[_b] = { fqn: "aws-cdk-lib.aws_frauddetector.CfnEntityType", version: "2.80.0" }, CfnEntityType.CFN_RESOURCE_TYPE_NAME = "AWS::FraudDetector::EntityType", exports2.CfnEntityType = CfnEntityType;
    function CfnEventTypePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("entityTypes", cdk.requiredValidator)(properties.entityTypes)), errors.collect(cdk.propertyValidator("entityTypes", cdk.listValidator(CfnEventType_EntityTypePropertyValidator))(properties.entityTypes)), errors.collect(cdk.propertyValidator("eventVariables", cdk.requiredValidator)(properties.eventVariables)), errors.collect(cdk.propertyValidator("eventVariables", cdk.listValidator(CfnEventType_EventVariablePropertyValidator))(properties.eventVariables)), errors.collect(cdk.propertyValidator("labels", cdk.requiredValidator)(properties.labels)), errors.collect(cdk.propertyValidator("labels", cdk.listValidator(CfnEventType_LabelPropertyValidator))(properties.labels)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnEventTypeProps"');
    }
    function cfnEventTypePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventTypePropsValidator(properties).assertSuccess(), { EntityTypes: cdk.listMapper(cfnEventTypeEntityTypePropertyToCloudFormation)(properties.entityTypes), EventVariables: cdk.listMapper(cfnEventTypeEventVariablePropertyToCloudFormation)(properties.eventVariables), Labels: cdk.listMapper(cfnEventTypeLabelPropertyToCloudFormation)(properties.labels), Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnEventTypePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("entityTypes", "EntityTypes", cfn_parse.FromCloudFormation.getArray(CfnEventTypeEntityTypePropertyFromCloudFormation)(properties.EntityTypes)), ret.addPropertyResult("eventVariables", "EventVariables", cfn_parse.FromCloudFormation.getArray(CfnEventTypeEventVariablePropertyFromCloudFormation)(properties.EventVariables)), ret.addPropertyResult("labels", "Labels", cfn_parse.FromCloudFormation.getArray(CfnEventTypeLabelPropertyFromCloudFormation)(properties.Labels)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEventType = class _CfnEventType extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEventTypePropsFromCloudFormation(resourceProperties), ret = new _CfnEventType(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEventType.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_frauddetector_CfnEventTypeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEventType), error;
        }
        cdk.requireProperty(props, "entityTypes", this), cdk.requireProperty(props, "eventVariables", this), cdk.requireProperty(props, "labels", this), cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreatedTime = cdk.Token.asString(this.getAtt("CreatedTime", cdk.ResolutionTypeHint.STRING)), this.attrLastUpdatedTime = cdk.Token.asString(this.getAtt("LastUpdatedTime", cdk.ResolutionTypeHint.STRING)), this.entityTypes = props.entityTypes, this.eventVariables = props.eventVariables, this.labels = props.labels, this.name = props.name, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::FraudDetector::EventType", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEventType.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { entityTypes: this.entityTypes, eventVariables: this.eventVariables, labels: this.labels, name: this.name, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnEventTypePropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnEventType[_c] = { fqn: "aws-cdk-lib.aws_frauddetector.CfnEventType", version: "2.80.0" }, CfnEventType.CFN_RESOURCE_TYPE_NAME = "AWS::FraudDetector::EventType", exports2.CfnEventType = CfnEventType;
    function CfnEventType_EntityTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("createdTime", cdk.validateString)(properties.createdTime)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("inline", cdk.validateBoolean)(properties.inline)), errors.collect(cdk.propertyValidator("lastUpdatedTime", cdk.validateString)(properties.lastUpdatedTime)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "EntityTypeProperty"');
    }
    function cfnEventTypeEntityTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventType_EntityTypePropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn), CreatedTime: cdk.stringToCloudFormation(properties.createdTime), Description: cdk.stringToCloudFormation(properties.description), Inline: cdk.booleanToCloudFormation(properties.inline), LastUpdatedTime: cdk.stringToCloudFormation(properties.lastUpdatedTime), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnEventTypeEntityTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", properties.Arn != null ? cfn_parse.FromCloudFormation.getString(properties.Arn) : void 0), ret.addPropertyResult("createdTime", "CreatedTime", properties.CreatedTime != null ? cfn_parse.FromCloudFormation.getString(properties.CreatedTime) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("inline", "Inline", properties.Inline != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Inline) : void 0), ret.addPropertyResult("lastUpdatedTime", "LastUpdatedTime", properties.LastUpdatedTime != null ? cfn_parse.FromCloudFormation.getString(properties.LastUpdatedTime) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEventType_EventVariablePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("createdTime", cdk.validateString)(properties.createdTime)), errors.collect(cdk.propertyValidator("dataSource", cdk.validateString)(properties.dataSource)), errors.collect(cdk.propertyValidator("dataType", cdk.validateString)(properties.dataType)), errors.collect(cdk.propertyValidator("defaultValue", cdk.validateString)(properties.defaultValue)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("inline", cdk.validateBoolean)(properties.inline)), errors.collect(cdk.propertyValidator("lastUpdatedTime", cdk.validateString)(properties.lastUpdatedTime)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("variableType", cdk.validateString)(properties.variableType)), errors.wrap('supplied properties not correct for "EventVariableProperty"');
    }
    function cfnEventTypeEventVariablePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventType_EventVariablePropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn), CreatedTime: cdk.stringToCloudFormation(properties.createdTime), DataSource: cdk.stringToCloudFormation(properties.dataSource), DataType: cdk.stringToCloudFormation(properties.dataType), DefaultValue: cdk.stringToCloudFormation(properties.defaultValue), Description: cdk.stringToCloudFormation(properties.description), Inline: cdk.booleanToCloudFormation(properties.inline), LastUpdatedTime: cdk.stringToCloudFormation(properties.lastUpdatedTime), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VariableType: cdk.stringToCloudFormation(properties.variableType) }) : properties;
    }
    function CfnEventTypeEventVariablePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", properties.Arn != null ? cfn_parse.FromCloudFormation.getString(properties.Arn) : void 0), ret.addPropertyResult("createdTime", "CreatedTime", properties.CreatedTime != null ? cfn_parse.FromCloudFormation.getString(properties.CreatedTime) : void 0), ret.addPropertyResult("dataSource", "DataSource", properties.DataSource != null ? cfn_parse.FromCloudFormation.getString(properties.DataSource) : void 0), ret.addPropertyResult("dataType", "DataType", properties.DataType != null ? cfn_parse.FromCloudFormation.getString(properties.DataType) : void 0), ret.addPropertyResult("defaultValue", "DefaultValue", properties.DefaultValue != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultValue) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("inline", "Inline", properties.Inline != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Inline) : void 0), ret.addPropertyResult("lastUpdatedTime", "LastUpdatedTime", properties.LastUpdatedTime != null ? cfn_parse.FromCloudFormation.getString(properties.LastUpdatedTime) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("variableType", "VariableType", properties.VariableType != null ? cfn_parse.FromCloudFormation.getString(properties.VariableType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEventType_LabelPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("createdTime", cdk.validateString)(properties.createdTime)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("inline", cdk.validateBoolean)(properties.inline)), errors.collect(cdk.propertyValidator("lastUpdatedTime", cdk.validateString)(properties.lastUpdatedTime)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "LabelProperty"');
    }
    function cfnEventTypeLabelPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventType_LabelPropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn), CreatedTime: cdk.stringToCloudFormation(properties.createdTime), Description: cdk.stringToCloudFormation(properties.description), Inline: cdk.booleanToCloudFormation(properties.inline), LastUpdatedTime: cdk.stringToCloudFormation(properties.lastUpdatedTime), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnEventTypeLabelPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", properties.Arn != null ? cfn_parse.FromCloudFormation.getString(properties.Arn) : void 0), ret.addPropertyResult("createdTime", "CreatedTime", properties.CreatedTime != null ? cfn_parse.FromCloudFormation.getString(properties.CreatedTime) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("inline", "Inline", properties.Inline != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Inline) : void 0), ret.addPropertyResult("lastUpdatedTime", "LastUpdatedTime", properties.LastUpdatedTime != null ? cfn_parse.FromCloudFormation.getString(properties.LastUpdatedTime) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLabelPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnLabelProps"');
    }
    function cfnLabelPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLabelPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnLabelPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLabel = class _CfnLabel extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLabelPropsFromCloudFormation(resourceProperties), ret = new _CfnLabel(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLabel.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_frauddetector_CfnLabelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLabel), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreatedTime = cdk.Token.asString(this.getAtt("CreatedTime", cdk.ResolutionTypeHint.STRING)), this.attrLastUpdatedTime = cdk.Token.asString(this.getAtt("LastUpdatedTime", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::FraudDetector::Label", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLabel.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnLabelPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnLabel[_d] = { fqn: "aws-cdk-lib.aws_frauddetector.CfnLabel", version: "2.80.0" }, CfnLabel.CFN_RESOURCE_TYPE_NAME = "AWS::FraudDetector::Label", exports2.CfnLabel = CfnLabel;
    function CfnListPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("elements", cdk.listValidator(cdk.validateString))(properties.elements)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("variableType", cdk.validateString)(properties.variableType)), errors.wrap('supplied properties not correct for "CfnListProps"');
    }
    function cfnListPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), Elements: cdk.listMapper(cdk.stringToCloudFormation)(properties.elements), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VariableType: cdk.stringToCloudFormation(properties.variableType) }) : properties;
    }
    function CfnListPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("elements", "Elements", properties.Elements != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Elements) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("variableType", "VariableType", properties.VariableType != null ? cfn_parse.FromCloudFormation.getString(properties.VariableType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnList = class _CfnList extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnListPropsFromCloudFormation(resourceProperties), ret = new _CfnList(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnList.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_frauddetector_CfnListProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnList), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreatedTime = cdk.Token.asString(this.getAtt("CreatedTime", cdk.ResolutionTypeHint.STRING)), this.attrLastUpdatedTime = cdk.Token.asString(this.getAtt("LastUpdatedTime", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.description = props.description, this.elements = props.elements, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::FraudDetector::List", props.tags, { tagPropertyName: "tags" }), this.variableType = props.variableType;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnList.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, description: this.description, elements: this.elements, tags: this.tags.renderTags(), variableType: this.variableType };
      }
      renderProperties(props) {
        return cfnListPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnList[_e] = { fqn: "aws-cdk-lib.aws_frauddetector.CfnList", version: "2.80.0" }, CfnList.CFN_RESOURCE_TYPE_NAME = "AWS::FraudDetector::List", exports2.CfnList = CfnList;
    function CfnOutcomePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnOutcomeProps"');
    }
    function cfnOutcomePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOutcomePropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnOutcomePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnOutcome = class _CfnOutcome extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnOutcomePropsFromCloudFormation(resourceProperties), ret = new _CfnOutcome(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnOutcome.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_frauddetector_CfnOutcomeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnOutcome), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreatedTime = cdk.Token.asString(this.getAtt("CreatedTime", cdk.ResolutionTypeHint.STRING)), this.attrLastUpdatedTime = cdk.Token.asString(this.getAtt("LastUpdatedTime", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::FraudDetector::Outcome", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnOutcome.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnOutcomePropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnOutcome[_f] = { fqn: "aws-cdk-lib.aws_frauddetector.CfnOutcome", version: "2.80.0" }, CfnOutcome.CFN_RESOURCE_TYPE_NAME = "AWS::FraudDetector::Outcome", exports2.CfnOutcome = CfnOutcome;
    function CfnVariablePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataSource", cdk.requiredValidator)(properties.dataSource)), errors.collect(cdk.propertyValidator("dataSource", cdk.validateString)(properties.dataSource)), errors.collect(cdk.propertyValidator("dataType", cdk.requiredValidator)(properties.dataType)), errors.collect(cdk.propertyValidator("dataType", cdk.validateString)(properties.dataType)), errors.collect(cdk.propertyValidator("defaultValue", cdk.requiredValidator)(properties.defaultValue)), errors.collect(cdk.propertyValidator("defaultValue", cdk.validateString)(properties.defaultValue)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("variableType", cdk.validateString)(properties.variableType)), errors.wrap('supplied properties not correct for "CfnVariableProps"');
    }
    function cfnVariablePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVariablePropsValidator(properties).assertSuccess(), { DataSource: cdk.stringToCloudFormation(properties.dataSource), DataType: cdk.stringToCloudFormation(properties.dataType), DefaultValue: cdk.stringToCloudFormation(properties.defaultValue), Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VariableType: cdk.stringToCloudFormation(properties.variableType) }) : properties;
    }
    function CfnVariablePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataSource", "DataSource", cfn_parse.FromCloudFormation.getString(properties.DataSource)), ret.addPropertyResult("dataType", "DataType", cfn_parse.FromCloudFormation.getString(properties.DataType)), ret.addPropertyResult("defaultValue", "DefaultValue", cfn_parse.FromCloudFormation.getString(properties.DefaultValue)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("variableType", "VariableType", properties.VariableType != null ? cfn_parse.FromCloudFormation.getString(properties.VariableType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVariable = class _CfnVariable extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVariablePropsFromCloudFormation(resourceProperties), ret = new _CfnVariable(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVariable.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_frauddetector_CfnVariableProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVariable), error;
        }
        cdk.requireProperty(props, "dataSource", this), cdk.requireProperty(props, "dataType", this), cdk.requireProperty(props, "defaultValue", this), cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreatedTime = cdk.Token.asString(this.getAtt("CreatedTime", cdk.ResolutionTypeHint.STRING)), this.attrLastUpdatedTime = cdk.Token.asString(this.getAtt("LastUpdatedTime", cdk.ResolutionTypeHint.STRING)), this.dataSource = props.dataSource, this.dataType = props.dataType, this.defaultValue = props.defaultValue, this.name = props.name, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::FraudDetector::Variable", props.tags, { tagPropertyName: "tags" }), this.variableType = props.variableType;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVariable.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { dataSource: this.dataSource, dataType: this.dataType, defaultValue: this.defaultValue, name: this.name, description: this.description, tags: this.tags.renderTags(), variableType: this.variableType };
      }
      renderProperties(props) {
        return cfnVariablePropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnVariable[_g] = { fqn: "aws-cdk-lib.aws_frauddetector.CfnVariable", version: "2.80.0" }, CfnVariable.CFN_RESOURCE_TYPE_NAME = "AWS::FraudDetector::Variable", exports2.CfnVariable = CfnVariable;
  }
});

// node_modules/aws-cdk-lib/aws-frauddetector/lib/index.js
var require_lib132 = __commonJS({
  "node_modules/aws-cdk-lib/aws-frauddetector/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_frauddetector_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-frauddetector/index.js
var require_aws_frauddetector = __commonJS({
  "node_modules/aws-cdk-lib/aws-frauddetector/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib132(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-fsx/lib/file-system.js
var require_file_system = __commonJS({
  "node_modules/aws-cdk-lib/aws-fsx/lib/file-system.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FileSystemBase = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core_1 = require_core2();
    var FileSystemBase = class extends core_1.Resource {
    };
    _a = JSII_RTTI_SYMBOL_1, FileSystemBase[_a] = { fqn: "aws-cdk-lib.aws_fsx.FileSystemBase", version: "2.80.0" }, exports2.FileSystemBase = FileSystemBase;
  }
});

// node_modules/aws-cdk-lib/aws-fsx/lib/fsx.generated.js
var require_fsx_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-fsx/lib/fsx.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnVolume = exports2.CfnStorageVirtualMachine = exports2.CfnSnapshot = exports2.CfnFileSystem = exports2.CfnDataRepositoryAssociation = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnDataRepositoryAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("batchImportMetaDataOnCreate", cdk.validateBoolean)(properties.batchImportMetaDataOnCreate)), errors.collect(cdk.propertyValidator("dataRepositoryPath", cdk.requiredValidator)(properties.dataRepositoryPath)), errors.collect(cdk.propertyValidator("dataRepositoryPath", cdk.validateString)(properties.dataRepositoryPath)), errors.collect(cdk.propertyValidator("fileSystemId", cdk.requiredValidator)(properties.fileSystemId)), errors.collect(cdk.propertyValidator("fileSystemId", cdk.validateString)(properties.fileSystemId)), errors.collect(cdk.propertyValidator("fileSystemPath", cdk.requiredValidator)(properties.fileSystemPath)), errors.collect(cdk.propertyValidator("fileSystemPath", cdk.validateString)(properties.fileSystemPath)), errors.collect(cdk.propertyValidator("importedFileChunkSize", cdk.validateNumber)(properties.importedFileChunkSize)), errors.collect(cdk.propertyValidator("s3", CfnDataRepositoryAssociation_S3PropertyValidator)(properties.s3)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDataRepositoryAssociationProps"');
    }
    function cfnDataRepositoryAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataRepositoryAssociationPropsValidator(properties).assertSuccess(), { DataRepositoryPath: cdk.stringToCloudFormation(properties.dataRepositoryPath), FileSystemId: cdk.stringToCloudFormation(properties.fileSystemId), FileSystemPath: cdk.stringToCloudFormation(properties.fileSystemPath), BatchImportMetaDataOnCreate: cdk.booleanToCloudFormation(properties.batchImportMetaDataOnCreate), ImportedFileChunkSize: cdk.numberToCloudFormation(properties.importedFileChunkSize), S3: cfnDataRepositoryAssociationS3PropertyToCloudFormation(properties.s3), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDataRepositoryAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataRepositoryPath", "DataRepositoryPath", cfn_parse.FromCloudFormation.getString(properties.DataRepositoryPath)), ret.addPropertyResult("fileSystemId", "FileSystemId", cfn_parse.FromCloudFormation.getString(properties.FileSystemId)), ret.addPropertyResult("fileSystemPath", "FileSystemPath", cfn_parse.FromCloudFormation.getString(properties.FileSystemPath)), ret.addPropertyResult("batchImportMetaDataOnCreate", "BatchImportMetaDataOnCreate", properties.BatchImportMetaDataOnCreate != null ? cfn_parse.FromCloudFormation.getBoolean(properties.BatchImportMetaDataOnCreate) : void 0), ret.addPropertyResult("importedFileChunkSize", "ImportedFileChunkSize", properties.ImportedFileChunkSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.ImportedFileChunkSize) : void 0), ret.addPropertyResult("s3", "S3", properties.S3 != null ? CfnDataRepositoryAssociationS3PropertyFromCloudFormation(properties.S3) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDataRepositoryAssociation = class _CfnDataRepositoryAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDataRepositoryAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnDataRepositoryAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDataRepositoryAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_fsx_CfnDataRepositoryAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDataRepositoryAssociation), error;
        }
        cdk.requireProperty(props, "dataRepositoryPath", this), cdk.requireProperty(props, "fileSystemId", this), cdk.requireProperty(props, "fileSystemPath", this), this.attrAssociationId = cdk.Token.asString(this.getAtt("AssociationId", cdk.ResolutionTypeHint.STRING)), this.attrResourceArn = cdk.Token.asString(this.getAtt("ResourceARN", cdk.ResolutionTypeHint.STRING)), this.dataRepositoryPath = props.dataRepositoryPath, this.fileSystemId = props.fileSystemId, this.fileSystemPath = props.fileSystemPath, this.batchImportMetaDataOnCreate = props.batchImportMetaDataOnCreate, this.importedFileChunkSize = props.importedFileChunkSize, this.s3 = props.s3, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::FSx::DataRepositoryAssociation", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDataRepositoryAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { dataRepositoryPath: this.dataRepositoryPath, fileSystemId: this.fileSystemId, fileSystemPath: this.fileSystemPath, batchImportMetaDataOnCreate: this.batchImportMetaDataOnCreate, importedFileChunkSize: this.importedFileChunkSize, s3: this.s3, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDataRepositoryAssociationPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnDataRepositoryAssociation[_a] = { fqn: "aws-cdk-lib.aws_fsx.CfnDataRepositoryAssociation", version: "2.80.0" }, CfnDataRepositoryAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::FSx::DataRepositoryAssociation", exports2.CfnDataRepositoryAssociation = CfnDataRepositoryAssociation;
    function CfnDataRepositoryAssociation_AutoExportPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("events", cdk.requiredValidator)(properties.events)), errors.collect(cdk.propertyValidator("events", cdk.listValidator(cdk.validateString))(properties.events)), errors.wrap('supplied properties not correct for "AutoExportPolicyProperty"');
    }
    function cfnDataRepositoryAssociationAutoExportPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataRepositoryAssociation_AutoExportPolicyPropertyValidator(properties).assertSuccess(), { Events: cdk.listMapper(cdk.stringToCloudFormation)(properties.events) }) : properties;
    }
    function CfnDataRepositoryAssociationAutoExportPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("events", "Events", cfn_parse.FromCloudFormation.getStringArray(properties.Events)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataRepositoryAssociation_AutoImportPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("events", cdk.requiredValidator)(properties.events)), errors.collect(cdk.propertyValidator("events", cdk.listValidator(cdk.validateString))(properties.events)), errors.wrap('supplied properties not correct for "AutoImportPolicyProperty"');
    }
    function cfnDataRepositoryAssociationAutoImportPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataRepositoryAssociation_AutoImportPolicyPropertyValidator(properties).assertSuccess(), { Events: cdk.listMapper(cdk.stringToCloudFormation)(properties.events) }) : properties;
    }
    function CfnDataRepositoryAssociationAutoImportPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("events", "Events", cfn_parse.FromCloudFormation.getStringArray(properties.Events)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataRepositoryAssociation_S3PropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoExportPolicy", CfnDataRepositoryAssociation_AutoExportPolicyPropertyValidator)(properties.autoExportPolicy)), errors.collect(cdk.propertyValidator("autoImportPolicy", CfnDataRepositoryAssociation_AutoImportPolicyPropertyValidator)(properties.autoImportPolicy)), errors.wrap('supplied properties not correct for "S3Property"');
    }
    function cfnDataRepositoryAssociationS3PropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataRepositoryAssociation_S3PropertyValidator(properties).assertSuccess(), { AutoExportPolicy: cfnDataRepositoryAssociationAutoExportPolicyPropertyToCloudFormation(properties.autoExportPolicy), AutoImportPolicy: cfnDataRepositoryAssociationAutoImportPolicyPropertyToCloudFormation(properties.autoImportPolicy) }) : properties;
    }
    function CfnDataRepositoryAssociationS3PropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("autoExportPolicy", "AutoExportPolicy", properties.AutoExportPolicy != null ? CfnDataRepositoryAssociationAutoExportPolicyPropertyFromCloudFormation(properties.AutoExportPolicy) : void 0), ret.addPropertyResult("autoImportPolicy", "AutoImportPolicy", properties.AutoImportPolicy != null ? CfnDataRepositoryAssociationAutoImportPolicyPropertyFromCloudFormation(properties.AutoImportPolicy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFileSystemPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("backupId", cdk.validateString)(properties.backupId)), errors.collect(cdk.propertyValidator("fileSystemType", cdk.requiredValidator)(properties.fileSystemType)), errors.collect(cdk.propertyValidator("fileSystemType", cdk.validateString)(properties.fileSystemType)), errors.collect(cdk.propertyValidator("fileSystemTypeVersion", cdk.validateString)(properties.fileSystemTypeVersion)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("lustreConfiguration", CfnFileSystem_LustreConfigurationPropertyValidator)(properties.lustreConfiguration)), errors.collect(cdk.propertyValidator("ontapConfiguration", CfnFileSystem_OntapConfigurationPropertyValidator)(properties.ontapConfiguration)), errors.collect(cdk.propertyValidator("openZfsConfiguration", CfnFileSystem_OpenZFSConfigurationPropertyValidator)(properties.openZfsConfiguration)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("storageCapacity", cdk.validateNumber)(properties.storageCapacity)), errors.collect(cdk.propertyValidator("storageType", cdk.validateString)(properties.storageType)), errors.collect(cdk.propertyValidator("subnetIds", cdk.requiredValidator)(properties.subnetIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("windowsConfiguration", CfnFileSystem_WindowsConfigurationPropertyValidator)(properties.windowsConfiguration)), errors.wrap('supplied properties not correct for "CfnFileSystemProps"');
    }
    function cfnFileSystemPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFileSystemPropsValidator(properties).assertSuccess(), { FileSystemType: cdk.stringToCloudFormation(properties.fileSystemType), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds), BackupId: cdk.stringToCloudFormation(properties.backupId), FileSystemTypeVersion: cdk.stringToCloudFormation(properties.fileSystemTypeVersion), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), LustreConfiguration: cfnFileSystemLustreConfigurationPropertyToCloudFormation(properties.lustreConfiguration), OntapConfiguration: cfnFileSystemOntapConfigurationPropertyToCloudFormation(properties.ontapConfiguration), OpenZFSConfiguration: cfnFileSystemOpenZFSConfigurationPropertyToCloudFormation(properties.openZfsConfiguration), SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), StorageCapacity: cdk.numberToCloudFormation(properties.storageCapacity), StorageType: cdk.stringToCloudFormation(properties.storageType), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), WindowsConfiguration: cfnFileSystemWindowsConfigurationPropertyToCloudFormation(properties.windowsConfiguration) }) : properties;
    }
    function CfnFileSystemPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fileSystemType", "FileSystemType", cfn_parse.FromCloudFormation.getString(properties.FileSystemType)), ret.addPropertyResult("subnetIds", "SubnetIds", cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds)), ret.addPropertyResult("backupId", "BackupId", properties.BackupId != null ? cfn_parse.FromCloudFormation.getString(properties.BackupId) : void 0), ret.addPropertyResult("fileSystemTypeVersion", "FileSystemTypeVersion", properties.FileSystemTypeVersion != null ? cfn_parse.FromCloudFormation.getString(properties.FileSystemTypeVersion) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("lustreConfiguration", "LustreConfiguration", properties.LustreConfiguration != null ? CfnFileSystemLustreConfigurationPropertyFromCloudFormation(properties.LustreConfiguration) : void 0), ret.addPropertyResult("ontapConfiguration", "OntapConfiguration", properties.OntapConfiguration != null ? CfnFileSystemOntapConfigurationPropertyFromCloudFormation(properties.OntapConfiguration) : void 0), ret.addPropertyResult("openZfsConfiguration", "OpenZFSConfiguration", properties.OpenZFSConfiguration != null ? CfnFileSystemOpenZFSConfigurationPropertyFromCloudFormation(properties.OpenZFSConfiguration) : void 0), ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("storageCapacity", "StorageCapacity", properties.StorageCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.StorageCapacity) : void 0), ret.addPropertyResult("storageType", "StorageType", properties.StorageType != null ? cfn_parse.FromCloudFormation.getString(properties.StorageType) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("windowsConfiguration", "WindowsConfiguration", properties.WindowsConfiguration != null ? CfnFileSystemWindowsConfigurationPropertyFromCloudFormation(properties.WindowsConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFileSystem = class _CfnFileSystem extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFileSystemPropsFromCloudFormation(resourceProperties), ret = new _CfnFileSystem(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFileSystem.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_fsx_CfnFileSystemProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFileSystem), error;
        }
        cdk.requireProperty(props, "fileSystemType", this), cdk.requireProperty(props, "subnetIds", this), this.attrDnsName = cdk.Token.asString(this.getAtt("DNSName", cdk.ResolutionTypeHint.STRING)), this.attrLustreMountName = cdk.Token.asString(this.getAtt("LustreMountName", cdk.ResolutionTypeHint.STRING)), this.attrResourceArn = cdk.Token.asString(this.getAtt("ResourceARN", cdk.ResolutionTypeHint.STRING)), this.attrRootVolumeId = cdk.Token.asString(this.getAtt("RootVolumeId", cdk.ResolutionTypeHint.STRING)), this.fileSystemType = props.fileSystemType, this.subnetIds = props.subnetIds, this.backupId = props.backupId, this.fileSystemTypeVersion = props.fileSystemTypeVersion, this.kmsKeyId = props.kmsKeyId, this.lustreConfiguration = props.lustreConfiguration, this.ontapConfiguration = props.ontapConfiguration, this.openZfsConfiguration = props.openZfsConfiguration, this.securityGroupIds = props.securityGroupIds, this.storageCapacity = props.storageCapacity, this.storageType = props.storageType, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::FSx::FileSystem", props.tags, { tagPropertyName: "tags" }), this.windowsConfiguration = props.windowsConfiguration, this.node.scope && cdk.Resource.isResource(this.node.scope) && this.node.addValidation({ validate: () => this.cfnOptions.deletionPolicy === void 0 ? ["'AWS::FSx::FileSystem' is a stateful resource type, and you must specify a Removal Policy for it. Call 'resource.applyRemovalPolicy()'."] : [] });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFileSystem.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { fileSystemType: this.fileSystemType, subnetIds: this.subnetIds, backupId: this.backupId, fileSystemTypeVersion: this.fileSystemTypeVersion, kmsKeyId: this.kmsKeyId, lustreConfiguration: this.lustreConfiguration, ontapConfiguration: this.ontapConfiguration, openZfsConfiguration: this.openZfsConfiguration, securityGroupIds: this.securityGroupIds, storageCapacity: this.storageCapacity, storageType: this.storageType, tags: this.tags.renderTags(), windowsConfiguration: this.windowsConfiguration };
      }
      renderProperties(props) {
        return cfnFileSystemPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnFileSystem[_b] = { fqn: "aws-cdk-lib.aws_fsx.CfnFileSystem", version: "2.80.0" }, CfnFileSystem.CFN_RESOURCE_TYPE_NAME = "AWS::FSx::FileSystem", exports2.CfnFileSystem = CfnFileSystem;
    function CfnFileSystem_AuditLogConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("auditLogDestination", cdk.validateString)(properties.auditLogDestination)), errors.collect(cdk.propertyValidator("fileAccessAuditLogLevel", cdk.requiredValidator)(properties.fileAccessAuditLogLevel)), errors.collect(cdk.propertyValidator("fileAccessAuditLogLevel", cdk.validateString)(properties.fileAccessAuditLogLevel)), errors.collect(cdk.propertyValidator("fileShareAccessAuditLogLevel", cdk.requiredValidator)(properties.fileShareAccessAuditLogLevel)), errors.collect(cdk.propertyValidator("fileShareAccessAuditLogLevel", cdk.validateString)(properties.fileShareAccessAuditLogLevel)), errors.wrap('supplied properties not correct for "AuditLogConfigurationProperty"');
    }
    function cfnFileSystemAuditLogConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFileSystem_AuditLogConfigurationPropertyValidator(properties).assertSuccess(), { AuditLogDestination: cdk.stringToCloudFormation(properties.auditLogDestination), FileAccessAuditLogLevel: cdk.stringToCloudFormation(properties.fileAccessAuditLogLevel), FileShareAccessAuditLogLevel: cdk.stringToCloudFormation(properties.fileShareAccessAuditLogLevel) }) : properties;
    }
    function CfnFileSystemAuditLogConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("auditLogDestination", "AuditLogDestination", properties.AuditLogDestination != null ? cfn_parse.FromCloudFormation.getString(properties.AuditLogDestination) : void 0), ret.addPropertyResult("fileAccessAuditLogLevel", "FileAccessAuditLogLevel", cfn_parse.FromCloudFormation.getString(properties.FileAccessAuditLogLevel)), ret.addPropertyResult("fileShareAccessAuditLogLevel", "FileShareAccessAuditLogLevel", cfn_parse.FromCloudFormation.getString(properties.FileShareAccessAuditLogLevel)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFileSystem_ClientConfigurationsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clients", cdk.validateString)(properties.clients)), errors.collect(cdk.propertyValidator("options", cdk.listValidator(cdk.validateString))(properties.options)), errors.wrap('supplied properties not correct for "ClientConfigurationsProperty"');
    }
    function cfnFileSystemClientConfigurationsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFileSystem_ClientConfigurationsPropertyValidator(properties).assertSuccess(), { Clients: cdk.stringToCloudFormation(properties.clients), Options: cdk.listMapper(cdk.stringToCloudFormation)(properties.options) }) : properties;
    }
    function CfnFileSystemClientConfigurationsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clients", "Clients", properties.Clients != null ? cfn_parse.FromCloudFormation.getString(properties.Clients) : void 0), ret.addPropertyResult("options", "Options", properties.Options != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Options) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFileSystem_DiskIopsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("iops", cdk.validateNumber)(properties.iops)), errors.collect(cdk.propertyValidator("mode", cdk.validateString)(properties.mode)), errors.wrap('supplied properties not correct for "DiskIopsConfigurationProperty"');
    }
    function cfnFileSystemDiskIopsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFileSystem_DiskIopsConfigurationPropertyValidator(properties).assertSuccess(), { Iops: cdk.numberToCloudFormation(properties.iops), Mode: cdk.stringToCloudFormation(properties.mode) }) : properties;
    }
    function CfnFileSystemDiskIopsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("iops", "Iops", properties.Iops != null ? cfn_parse.FromCloudFormation.getNumber(properties.Iops) : void 0), ret.addPropertyResult("mode", "Mode", properties.Mode != null ? cfn_parse.FromCloudFormation.getString(properties.Mode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFileSystem_LustreConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoImportPolicy", cdk.validateString)(properties.autoImportPolicy)), errors.collect(cdk.propertyValidator("automaticBackupRetentionDays", cdk.validateNumber)(properties.automaticBackupRetentionDays)), errors.collect(cdk.propertyValidator("copyTagsToBackups", cdk.validateBoolean)(properties.copyTagsToBackups)), errors.collect(cdk.propertyValidator("dailyAutomaticBackupStartTime", cdk.validateString)(properties.dailyAutomaticBackupStartTime)), errors.collect(cdk.propertyValidator("dataCompressionType", cdk.validateString)(properties.dataCompressionType)), errors.collect(cdk.propertyValidator("deploymentType", cdk.validateString)(properties.deploymentType)), errors.collect(cdk.propertyValidator("driveCacheType", cdk.validateString)(properties.driveCacheType)), errors.collect(cdk.propertyValidator("exportPath", cdk.validateString)(properties.exportPath)), errors.collect(cdk.propertyValidator("importPath", cdk.validateString)(properties.importPath)), errors.collect(cdk.propertyValidator("importedFileChunkSize", cdk.validateNumber)(properties.importedFileChunkSize)), errors.collect(cdk.propertyValidator("perUnitStorageThroughput", cdk.validateNumber)(properties.perUnitStorageThroughput)), errors.collect(cdk.propertyValidator("weeklyMaintenanceStartTime", cdk.validateString)(properties.weeklyMaintenanceStartTime)), errors.wrap('supplied properties not correct for "LustreConfigurationProperty"');
    }
    function cfnFileSystemLustreConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFileSystem_LustreConfigurationPropertyValidator(properties).assertSuccess(), { AutoImportPolicy: cdk.stringToCloudFormation(properties.autoImportPolicy), AutomaticBackupRetentionDays: cdk.numberToCloudFormation(properties.automaticBackupRetentionDays), CopyTagsToBackups: cdk.booleanToCloudFormation(properties.copyTagsToBackups), DailyAutomaticBackupStartTime: cdk.stringToCloudFormation(properties.dailyAutomaticBackupStartTime), DataCompressionType: cdk.stringToCloudFormation(properties.dataCompressionType), DeploymentType: cdk.stringToCloudFormation(properties.deploymentType), DriveCacheType: cdk.stringToCloudFormation(properties.driveCacheType), ExportPath: cdk.stringToCloudFormation(properties.exportPath), ImportPath: cdk.stringToCloudFormation(properties.importPath), ImportedFileChunkSize: cdk.numberToCloudFormation(properties.importedFileChunkSize), PerUnitStorageThroughput: cdk.numberToCloudFormation(properties.perUnitStorageThroughput), WeeklyMaintenanceStartTime: cdk.stringToCloudFormation(properties.weeklyMaintenanceStartTime) }) : properties;
    }
    function CfnFileSystemLustreConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("autoImportPolicy", "AutoImportPolicy", properties.AutoImportPolicy != null ? cfn_parse.FromCloudFormation.getString(properties.AutoImportPolicy) : void 0), ret.addPropertyResult("automaticBackupRetentionDays", "AutomaticBackupRetentionDays", properties.AutomaticBackupRetentionDays != null ? cfn_parse.FromCloudFormation.getNumber(properties.AutomaticBackupRetentionDays) : void 0), ret.addPropertyResult("copyTagsToBackups", "CopyTagsToBackups", properties.CopyTagsToBackups != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CopyTagsToBackups) : void 0), ret.addPropertyResult("dailyAutomaticBackupStartTime", "DailyAutomaticBackupStartTime", properties.DailyAutomaticBackupStartTime != null ? cfn_parse.FromCloudFormation.getString(properties.DailyAutomaticBackupStartTime) : void 0), ret.addPropertyResult("dataCompressionType", "DataCompressionType", properties.DataCompressionType != null ? cfn_parse.FromCloudFormation.getString(properties.DataCompressionType) : void 0), ret.addPropertyResult("deploymentType", "DeploymentType", properties.DeploymentType != null ? cfn_parse.FromCloudFormation.getString(properties.DeploymentType) : void 0), ret.addPropertyResult("driveCacheType", "DriveCacheType", properties.DriveCacheType != null ? cfn_parse.FromCloudFormation.getString(properties.DriveCacheType) : void 0), ret.addPropertyResult("exportPath", "ExportPath", properties.ExportPath != null ? cfn_parse.FromCloudFormation.getString(properties.ExportPath) : void 0), ret.addPropertyResult("importPath", "ImportPath", properties.ImportPath != null ? cfn_parse.FromCloudFormation.getString(properties.ImportPath) : void 0), ret.addPropertyResult("importedFileChunkSize", "ImportedFileChunkSize", properties.ImportedFileChunkSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.ImportedFileChunkSize) : void 0), ret.addPropertyResult("perUnitStorageThroughput", "PerUnitStorageThroughput", properties.PerUnitStorageThroughput != null ? cfn_parse.FromCloudFormation.getNumber(properties.PerUnitStorageThroughput) : void 0), ret.addPropertyResult("weeklyMaintenanceStartTime", "WeeklyMaintenanceStartTime", properties.WeeklyMaintenanceStartTime != null ? cfn_parse.FromCloudFormation.getString(properties.WeeklyMaintenanceStartTime) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFileSystem_NfsExportsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clientConfigurations", cdk.listValidator(CfnFileSystem_ClientConfigurationsPropertyValidator))(properties.clientConfigurations)), errors.wrap('supplied properties not correct for "NfsExportsProperty"');
    }
    function cfnFileSystemNfsExportsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFileSystem_NfsExportsPropertyValidator(properties).assertSuccess(), { ClientConfigurations: cdk.listMapper(cfnFileSystemClientConfigurationsPropertyToCloudFormation)(properties.clientConfigurations) }) : properties;
    }
    function CfnFileSystemNfsExportsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clientConfigurations", "ClientConfigurations", properties.ClientConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnFileSystemClientConfigurationsPropertyFromCloudFormation)(properties.ClientConfigurations) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFileSystem_OntapConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("automaticBackupRetentionDays", cdk.validateNumber)(properties.automaticBackupRetentionDays)), errors.collect(cdk.propertyValidator("dailyAutomaticBackupStartTime", cdk.validateString)(properties.dailyAutomaticBackupStartTime)), errors.collect(cdk.propertyValidator("deploymentType", cdk.requiredValidator)(properties.deploymentType)), errors.collect(cdk.propertyValidator("deploymentType", cdk.validateString)(properties.deploymentType)), errors.collect(cdk.propertyValidator("diskIopsConfiguration", CfnFileSystem_DiskIopsConfigurationPropertyValidator)(properties.diskIopsConfiguration)), errors.collect(cdk.propertyValidator("endpointIpAddressRange", cdk.validateString)(properties.endpointIpAddressRange)), errors.collect(cdk.propertyValidator("fsxAdminPassword", cdk.validateString)(properties.fsxAdminPassword)), errors.collect(cdk.propertyValidator("preferredSubnetId", cdk.validateString)(properties.preferredSubnetId)), errors.collect(cdk.propertyValidator("routeTableIds", cdk.listValidator(cdk.validateString))(properties.routeTableIds)), errors.collect(cdk.propertyValidator("throughputCapacity", cdk.validateNumber)(properties.throughputCapacity)), errors.collect(cdk.propertyValidator("weeklyMaintenanceStartTime", cdk.validateString)(properties.weeklyMaintenanceStartTime)), errors.wrap('supplied properties not correct for "OntapConfigurationProperty"');
    }
    function cfnFileSystemOntapConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFileSystem_OntapConfigurationPropertyValidator(properties).assertSuccess(), { AutomaticBackupRetentionDays: cdk.numberToCloudFormation(properties.automaticBackupRetentionDays), DailyAutomaticBackupStartTime: cdk.stringToCloudFormation(properties.dailyAutomaticBackupStartTime), DeploymentType: cdk.stringToCloudFormation(properties.deploymentType), DiskIopsConfiguration: cfnFileSystemDiskIopsConfigurationPropertyToCloudFormation(properties.diskIopsConfiguration), EndpointIpAddressRange: cdk.stringToCloudFormation(properties.endpointIpAddressRange), FsxAdminPassword: cdk.stringToCloudFormation(properties.fsxAdminPassword), PreferredSubnetId: cdk.stringToCloudFormation(properties.preferredSubnetId), RouteTableIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.routeTableIds), ThroughputCapacity: cdk.numberToCloudFormation(properties.throughputCapacity), WeeklyMaintenanceStartTime: cdk.stringToCloudFormation(properties.weeklyMaintenanceStartTime) }) : properties;
    }
    function CfnFileSystemOntapConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("automaticBackupRetentionDays", "AutomaticBackupRetentionDays", properties.AutomaticBackupRetentionDays != null ? cfn_parse.FromCloudFormation.getNumber(properties.AutomaticBackupRetentionDays) : void 0), ret.addPropertyResult("dailyAutomaticBackupStartTime", "DailyAutomaticBackupStartTime", properties.DailyAutomaticBackupStartTime != null ? cfn_parse.FromCloudFormation.getString(properties.DailyAutomaticBackupStartTime) : void 0), ret.addPropertyResult("deploymentType", "DeploymentType", cfn_parse.FromCloudFormation.getString(properties.DeploymentType)), ret.addPropertyResult("diskIopsConfiguration", "DiskIopsConfiguration", properties.DiskIopsConfiguration != null ? CfnFileSystemDiskIopsConfigurationPropertyFromCloudFormation(properties.DiskIopsConfiguration) : void 0), ret.addPropertyResult("endpointIpAddressRange", "EndpointIpAddressRange", properties.EndpointIpAddressRange != null ? cfn_parse.FromCloudFormation.getString(properties.EndpointIpAddressRange) : void 0), ret.addPropertyResult("fsxAdminPassword", "FsxAdminPassword", properties.FsxAdminPassword != null ? cfn_parse.FromCloudFormation.getString(properties.FsxAdminPassword) : void 0), ret.addPropertyResult("preferredSubnetId", "PreferredSubnetId", properties.PreferredSubnetId != null ? cfn_parse.FromCloudFormation.getString(properties.PreferredSubnetId) : void 0), ret.addPropertyResult("routeTableIds", "RouteTableIds", properties.RouteTableIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.RouteTableIds) : void 0), ret.addPropertyResult("throughputCapacity", "ThroughputCapacity", properties.ThroughputCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.ThroughputCapacity) : void 0), ret.addPropertyResult("weeklyMaintenanceStartTime", "WeeklyMaintenanceStartTime", properties.WeeklyMaintenanceStartTime != null ? cfn_parse.FromCloudFormation.getString(properties.WeeklyMaintenanceStartTime) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFileSystem_OpenZFSConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("automaticBackupRetentionDays", cdk.validateNumber)(properties.automaticBackupRetentionDays)), errors.collect(cdk.propertyValidator("copyTagsToBackups", cdk.validateBoolean)(properties.copyTagsToBackups)), errors.collect(cdk.propertyValidator("copyTagsToVolumes", cdk.validateBoolean)(properties.copyTagsToVolumes)), errors.collect(cdk.propertyValidator("dailyAutomaticBackupStartTime", cdk.validateString)(properties.dailyAutomaticBackupStartTime)), errors.collect(cdk.propertyValidator("deploymentType", cdk.requiredValidator)(properties.deploymentType)), errors.collect(cdk.propertyValidator("deploymentType", cdk.validateString)(properties.deploymentType)), errors.collect(cdk.propertyValidator("diskIopsConfiguration", CfnFileSystem_DiskIopsConfigurationPropertyValidator)(properties.diskIopsConfiguration)), errors.collect(cdk.propertyValidator("options", cdk.listValidator(cdk.validateString))(properties.options)), errors.collect(cdk.propertyValidator("rootVolumeConfiguration", CfnFileSystem_RootVolumeConfigurationPropertyValidator)(properties.rootVolumeConfiguration)), errors.collect(cdk.propertyValidator("throughputCapacity", cdk.validateNumber)(properties.throughputCapacity)), errors.collect(cdk.propertyValidator("weeklyMaintenanceStartTime", cdk.validateString)(properties.weeklyMaintenanceStartTime)), errors.wrap('supplied properties not correct for "OpenZFSConfigurationProperty"');
    }
    function cfnFileSystemOpenZFSConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFileSystem_OpenZFSConfigurationPropertyValidator(properties).assertSuccess(), { AutomaticBackupRetentionDays: cdk.numberToCloudFormation(properties.automaticBackupRetentionDays), CopyTagsToBackups: cdk.booleanToCloudFormation(properties.copyTagsToBackups), CopyTagsToVolumes: cdk.booleanToCloudFormation(properties.copyTagsToVolumes), DailyAutomaticBackupStartTime: cdk.stringToCloudFormation(properties.dailyAutomaticBackupStartTime), DeploymentType: cdk.stringToCloudFormation(properties.deploymentType), DiskIopsConfiguration: cfnFileSystemDiskIopsConfigurationPropertyToCloudFormation(properties.diskIopsConfiguration), Options: cdk.listMapper(cdk.stringToCloudFormation)(properties.options), RootVolumeConfiguration: cfnFileSystemRootVolumeConfigurationPropertyToCloudFormation(properties.rootVolumeConfiguration), ThroughputCapacity: cdk.numberToCloudFormation(properties.throughputCapacity), WeeklyMaintenanceStartTime: cdk.stringToCloudFormation(properties.weeklyMaintenanceStartTime) }) : properties;
    }
    function CfnFileSystemOpenZFSConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("automaticBackupRetentionDays", "AutomaticBackupRetentionDays", properties.AutomaticBackupRetentionDays != null ? cfn_parse.FromCloudFormation.getNumber(properties.AutomaticBackupRetentionDays) : void 0), ret.addPropertyResult("copyTagsToBackups", "CopyTagsToBackups", properties.CopyTagsToBackups != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CopyTagsToBackups) : void 0), ret.addPropertyResult("copyTagsToVolumes", "CopyTagsToVolumes", properties.CopyTagsToVolumes != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CopyTagsToVolumes) : void 0), ret.addPropertyResult("dailyAutomaticBackupStartTime", "DailyAutomaticBackupStartTime", properties.DailyAutomaticBackupStartTime != null ? cfn_parse.FromCloudFormation.getString(properties.DailyAutomaticBackupStartTime) : void 0), ret.addPropertyResult("deploymentType", "DeploymentType", cfn_parse.FromCloudFormation.getString(properties.DeploymentType)), ret.addPropertyResult("diskIopsConfiguration", "DiskIopsConfiguration", properties.DiskIopsConfiguration != null ? CfnFileSystemDiskIopsConfigurationPropertyFromCloudFormation(properties.DiskIopsConfiguration) : void 0), ret.addPropertyResult("options", "Options", properties.Options != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Options) : void 0), ret.addPropertyResult("rootVolumeConfiguration", "RootVolumeConfiguration", properties.RootVolumeConfiguration != null ? CfnFileSystemRootVolumeConfigurationPropertyFromCloudFormation(properties.RootVolumeConfiguration) : void 0), ret.addPropertyResult("throughputCapacity", "ThroughputCapacity", properties.ThroughputCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.ThroughputCapacity) : void 0), ret.addPropertyResult("weeklyMaintenanceStartTime", "WeeklyMaintenanceStartTime", properties.WeeklyMaintenanceStartTime != null ? cfn_parse.FromCloudFormation.getString(properties.WeeklyMaintenanceStartTime) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFileSystem_RootVolumeConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("copyTagsToSnapshots", cdk.validateBoolean)(properties.copyTagsToSnapshots)), errors.collect(cdk.propertyValidator("dataCompressionType", cdk.validateString)(properties.dataCompressionType)), errors.collect(cdk.propertyValidator("nfsExports", cdk.listValidator(CfnFileSystem_NfsExportsPropertyValidator))(properties.nfsExports)), errors.collect(cdk.propertyValidator("readOnly", cdk.validateBoolean)(properties.readOnly)), errors.collect(cdk.propertyValidator("recordSizeKiB", cdk.validateNumber)(properties.recordSizeKiB)), errors.collect(cdk.propertyValidator("userAndGroupQuotas", cdk.listValidator(CfnFileSystem_UserAndGroupQuotasPropertyValidator))(properties.userAndGroupQuotas)), errors.wrap('supplied properties not correct for "RootVolumeConfigurationProperty"');
    }
    function cfnFileSystemRootVolumeConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFileSystem_RootVolumeConfigurationPropertyValidator(properties).assertSuccess(), { CopyTagsToSnapshots: cdk.booleanToCloudFormation(properties.copyTagsToSnapshots), DataCompressionType: cdk.stringToCloudFormation(properties.dataCompressionType), NfsExports: cdk.listMapper(cfnFileSystemNfsExportsPropertyToCloudFormation)(properties.nfsExports), ReadOnly: cdk.booleanToCloudFormation(properties.readOnly), RecordSizeKiB: cdk.numberToCloudFormation(properties.recordSizeKiB), UserAndGroupQuotas: cdk.listMapper(cfnFileSystemUserAndGroupQuotasPropertyToCloudFormation)(properties.userAndGroupQuotas) }) : properties;
    }
    function CfnFileSystemRootVolumeConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("copyTagsToSnapshots", "CopyTagsToSnapshots", properties.CopyTagsToSnapshots != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CopyTagsToSnapshots) : void 0), ret.addPropertyResult("dataCompressionType", "DataCompressionType", properties.DataCompressionType != null ? cfn_parse.FromCloudFormation.getString(properties.DataCompressionType) : void 0), ret.addPropertyResult("nfsExports", "NfsExports", properties.NfsExports != null ? cfn_parse.FromCloudFormation.getArray(CfnFileSystemNfsExportsPropertyFromCloudFormation)(properties.NfsExports) : void 0), ret.addPropertyResult("readOnly", "ReadOnly", properties.ReadOnly != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ReadOnly) : void 0), ret.addPropertyResult("recordSizeKiB", "RecordSizeKiB", properties.RecordSizeKiB != null ? cfn_parse.FromCloudFormation.getNumber(properties.RecordSizeKiB) : void 0), ret.addPropertyResult("userAndGroupQuotas", "UserAndGroupQuotas", properties.UserAndGroupQuotas != null ? cfn_parse.FromCloudFormation.getArray(CfnFileSystemUserAndGroupQuotasPropertyFromCloudFormation)(properties.UserAndGroupQuotas) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFileSystem_SelfManagedActiveDirectoryConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dnsIps", cdk.listValidator(cdk.validateString))(properties.dnsIps)), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.collect(cdk.propertyValidator("fileSystemAdministratorsGroup", cdk.validateString)(properties.fileSystemAdministratorsGroup)), errors.collect(cdk.propertyValidator("organizationalUnitDistinguishedName", cdk.validateString)(properties.organizationalUnitDistinguishedName)), errors.collect(cdk.propertyValidator("password", cdk.validateString)(properties.password)), errors.collect(cdk.propertyValidator("userName", cdk.validateString)(properties.userName)), errors.wrap('supplied properties not correct for "SelfManagedActiveDirectoryConfigurationProperty"');
    }
    function cfnFileSystemSelfManagedActiveDirectoryConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFileSystem_SelfManagedActiveDirectoryConfigurationPropertyValidator(properties).assertSuccess(), { DnsIps: cdk.listMapper(cdk.stringToCloudFormation)(properties.dnsIps), DomainName: cdk.stringToCloudFormation(properties.domainName), FileSystemAdministratorsGroup: cdk.stringToCloudFormation(properties.fileSystemAdministratorsGroup), OrganizationalUnitDistinguishedName: cdk.stringToCloudFormation(properties.organizationalUnitDistinguishedName), Password: cdk.stringToCloudFormation(properties.password), UserName: cdk.stringToCloudFormation(properties.userName) }) : properties;
    }
    function CfnFileSystemSelfManagedActiveDirectoryConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dnsIps", "DnsIps", properties.DnsIps != null ? cfn_parse.FromCloudFormation.getStringArray(properties.DnsIps) : void 0), ret.addPropertyResult("domainName", "DomainName", properties.DomainName != null ? cfn_parse.FromCloudFormation.getString(properties.DomainName) : void 0), ret.addPropertyResult("fileSystemAdministratorsGroup", "FileSystemAdministratorsGroup", properties.FileSystemAdministratorsGroup != null ? cfn_parse.FromCloudFormation.getString(properties.FileSystemAdministratorsGroup) : void 0), ret.addPropertyResult("organizationalUnitDistinguishedName", "OrganizationalUnitDistinguishedName", properties.OrganizationalUnitDistinguishedName != null ? cfn_parse.FromCloudFormation.getString(properties.OrganizationalUnitDistinguishedName) : void 0), ret.addPropertyResult("password", "Password", properties.Password != null ? cfn_parse.FromCloudFormation.getString(properties.Password) : void 0), ret.addPropertyResult("userName", "UserName", properties.UserName != null ? cfn_parse.FromCloudFormation.getString(properties.UserName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFileSystem_UserAndGroupQuotasPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("id", cdk.validateNumber)(properties.id)), errors.collect(cdk.propertyValidator("storageCapacityQuotaGiB", cdk.validateNumber)(properties.storageCapacityQuotaGiB)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "UserAndGroupQuotasProperty"');
    }
    function cfnFileSystemUserAndGroupQuotasPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFileSystem_UserAndGroupQuotasPropertyValidator(properties).assertSuccess(), { Id: cdk.numberToCloudFormation(properties.id), StorageCapacityQuotaGiB: cdk.numberToCloudFormation(properties.storageCapacityQuotaGiB), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnFileSystemUserAndGroupQuotasPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("id", "Id", properties.Id != null ? cfn_parse.FromCloudFormation.getNumber(properties.Id) : void 0), ret.addPropertyResult("storageCapacityQuotaGiB", "StorageCapacityQuotaGiB", properties.StorageCapacityQuotaGiB != null ? cfn_parse.FromCloudFormation.getNumber(properties.StorageCapacityQuotaGiB) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFileSystem_WindowsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("activeDirectoryId", cdk.validateString)(properties.activeDirectoryId)), errors.collect(cdk.propertyValidator("aliases", cdk.listValidator(cdk.validateString))(properties.aliases)), errors.collect(cdk.propertyValidator("auditLogConfiguration", CfnFileSystem_AuditLogConfigurationPropertyValidator)(properties.auditLogConfiguration)), errors.collect(cdk.propertyValidator("automaticBackupRetentionDays", cdk.validateNumber)(properties.automaticBackupRetentionDays)), errors.collect(cdk.propertyValidator("copyTagsToBackups", cdk.validateBoolean)(properties.copyTagsToBackups)), errors.collect(cdk.propertyValidator("dailyAutomaticBackupStartTime", cdk.validateString)(properties.dailyAutomaticBackupStartTime)), errors.collect(cdk.propertyValidator("deploymentType", cdk.validateString)(properties.deploymentType)), errors.collect(cdk.propertyValidator("preferredSubnetId", cdk.validateString)(properties.preferredSubnetId)), errors.collect(cdk.propertyValidator("selfManagedActiveDirectoryConfiguration", CfnFileSystem_SelfManagedActiveDirectoryConfigurationPropertyValidator)(properties.selfManagedActiveDirectoryConfiguration)), errors.collect(cdk.propertyValidator("throughputCapacity", cdk.requiredValidator)(properties.throughputCapacity)), errors.collect(cdk.propertyValidator("throughputCapacity", cdk.validateNumber)(properties.throughputCapacity)), errors.collect(cdk.propertyValidator("weeklyMaintenanceStartTime", cdk.validateString)(properties.weeklyMaintenanceStartTime)), errors.wrap('supplied properties not correct for "WindowsConfigurationProperty"');
    }
    function cfnFileSystemWindowsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFileSystem_WindowsConfigurationPropertyValidator(properties).assertSuccess(), { ActiveDirectoryId: cdk.stringToCloudFormation(properties.activeDirectoryId), Aliases: cdk.listMapper(cdk.stringToCloudFormation)(properties.aliases), AuditLogConfiguration: cfnFileSystemAuditLogConfigurationPropertyToCloudFormation(properties.auditLogConfiguration), AutomaticBackupRetentionDays: cdk.numberToCloudFormation(properties.automaticBackupRetentionDays), CopyTagsToBackups: cdk.booleanToCloudFormation(properties.copyTagsToBackups), DailyAutomaticBackupStartTime: cdk.stringToCloudFormation(properties.dailyAutomaticBackupStartTime), DeploymentType: cdk.stringToCloudFormation(properties.deploymentType), PreferredSubnetId: cdk.stringToCloudFormation(properties.preferredSubnetId), SelfManagedActiveDirectoryConfiguration: cfnFileSystemSelfManagedActiveDirectoryConfigurationPropertyToCloudFormation(properties.selfManagedActiveDirectoryConfiguration), ThroughputCapacity: cdk.numberToCloudFormation(properties.throughputCapacity), WeeklyMaintenanceStartTime: cdk.stringToCloudFormation(properties.weeklyMaintenanceStartTime) }) : properties;
    }
    function CfnFileSystemWindowsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("activeDirectoryId", "ActiveDirectoryId", properties.ActiveDirectoryId != null ? cfn_parse.FromCloudFormation.getString(properties.ActiveDirectoryId) : void 0), ret.addPropertyResult("aliases", "Aliases", properties.Aliases != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Aliases) : void 0), ret.addPropertyResult("auditLogConfiguration", "AuditLogConfiguration", properties.AuditLogConfiguration != null ? CfnFileSystemAuditLogConfigurationPropertyFromCloudFormation(properties.AuditLogConfiguration) : void 0), ret.addPropertyResult("automaticBackupRetentionDays", "AutomaticBackupRetentionDays", properties.AutomaticBackupRetentionDays != null ? cfn_parse.FromCloudFormation.getNumber(properties.AutomaticBackupRetentionDays) : void 0), ret.addPropertyResult("copyTagsToBackups", "CopyTagsToBackups", properties.CopyTagsToBackups != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CopyTagsToBackups) : void 0), ret.addPropertyResult("dailyAutomaticBackupStartTime", "DailyAutomaticBackupStartTime", properties.DailyAutomaticBackupStartTime != null ? cfn_parse.FromCloudFormation.getString(properties.DailyAutomaticBackupStartTime) : void 0), ret.addPropertyResult("deploymentType", "DeploymentType", properties.DeploymentType != null ? cfn_parse.FromCloudFormation.getString(properties.DeploymentType) : void 0), ret.addPropertyResult("preferredSubnetId", "PreferredSubnetId", properties.PreferredSubnetId != null ? cfn_parse.FromCloudFormation.getString(properties.PreferredSubnetId) : void 0), ret.addPropertyResult("selfManagedActiveDirectoryConfiguration", "SelfManagedActiveDirectoryConfiguration", properties.SelfManagedActiveDirectoryConfiguration != null ? CfnFileSystemSelfManagedActiveDirectoryConfigurationPropertyFromCloudFormation(properties.SelfManagedActiveDirectoryConfiguration) : void 0), ret.addPropertyResult("throughputCapacity", "ThroughputCapacity", cfn_parse.FromCloudFormation.getNumber(properties.ThroughputCapacity)), ret.addPropertyResult("weeklyMaintenanceStartTime", "WeeklyMaintenanceStartTime", properties.WeeklyMaintenanceStartTime != null ? cfn_parse.FromCloudFormation.getString(properties.WeeklyMaintenanceStartTime) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSnapshotPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("volumeId", cdk.requiredValidator)(properties.volumeId)), errors.collect(cdk.propertyValidator("volumeId", cdk.validateString)(properties.volumeId)), errors.wrap('supplied properties not correct for "CfnSnapshotProps"');
    }
    function cfnSnapshotPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSnapshotPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), VolumeId: cdk.stringToCloudFormation(properties.volumeId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnSnapshotPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("volumeId", "VolumeId", cfn_parse.FromCloudFormation.getString(properties.VolumeId)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSnapshot = class _CfnSnapshot extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSnapshotPropsFromCloudFormation(resourceProperties), ret = new _CfnSnapshot(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSnapshot.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_fsx_CfnSnapshotProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSnapshot), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "volumeId", this), this.attrResourceArn = cdk.Token.asString(this.getAtt("ResourceARN", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.volumeId = props.volumeId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::FSx::Snapshot", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSnapshot.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, volumeId: this.volumeId, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnSnapshotPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnSnapshot[_c] = { fqn: "aws-cdk-lib.aws_fsx.CfnSnapshot", version: "2.80.0" }, CfnSnapshot.CFN_RESOURCE_TYPE_NAME = "AWS::FSx::Snapshot", exports2.CfnSnapshot = CfnSnapshot;
    function CfnStorageVirtualMachinePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("activeDirectoryConfiguration", CfnStorageVirtualMachine_ActiveDirectoryConfigurationPropertyValidator)(properties.activeDirectoryConfiguration)), errors.collect(cdk.propertyValidator("fileSystemId", cdk.requiredValidator)(properties.fileSystemId)), errors.collect(cdk.propertyValidator("fileSystemId", cdk.validateString)(properties.fileSystemId)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("rootVolumeSecurityStyle", cdk.validateString)(properties.rootVolumeSecurityStyle)), errors.collect(cdk.propertyValidator("svmAdminPassword", cdk.validateString)(properties.svmAdminPassword)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnStorageVirtualMachineProps"');
    }
    function cfnStorageVirtualMachinePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStorageVirtualMachinePropsValidator(properties).assertSuccess(), { FileSystemId: cdk.stringToCloudFormation(properties.fileSystemId), Name: cdk.stringToCloudFormation(properties.name), ActiveDirectoryConfiguration: cfnStorageVirtualMachineActiveDirectoryConfigurationPropertyToCloudFormation(properties.activeDirectoryConfiguration), RootVolumeSecurityStyle: cdk.stringToCloudFormation(properties.rootVolumeSecurityStyle), SvmAdminPassword: cdk.stringToCloudFormation(properties.svmAdminPassword), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnStorageVirtualMachinePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fileSystemId", "FileSystemId", cfn_parse.FromCloudFormation.getString(properties.FileSystemId)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("activeDirectoryConfiguration", "ActiveDirectoryConfiguration", properties.ActiveDirectoryConfiguration != null ? CfnStorageVirtualMachineActiveDirectoryConfigurationPropertyFromCloudFormation(properties.ActiveDirectoryConfiguration) : void 0), ret.addPropertyResult("rootVolumeSecurityStyle", "RootVolumeSecurityStyle", properties.RootVolumeSecurityStyle != null ? cfn_parse.FromCloudFormation.getString(properties.RootVolumeSecurityStyle) : void 0), ret.addPropertyResult("svmAdminPassword", "SvmAdminPassword", properties.SvmAdminPassword != null ? cfn_parse.FromCloudFormation.getString(properties.SvmAdminPassword) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnStorageVirtualMachine = class _CfnStorageVirtualMachine extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnStorageVirtualMachinePropsFromCloudFormation(resourceProperties), ret = new _CfnStorageVirtualMachine(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnStorageVirtualMachine.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_fsx_CfnStorageVirtualMachineProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnStorageVirtualMachine), error;
        }
        cdk.requireProperty(props, "fileSystemId", this), cdk.requireProperty(props, "name", this), this.attrResourceArn = cdk.Token.asString(this.getAtt("ResourceARN", cdk.ResolutionTypeHint.STRING)), this.attrStorageVirtualMachineId = cdk.Token.asString(this.getAtt("StorageVirtualMachineId", cdk.ResolutionTypeHint.STRING)), this.attrUuid = cdk.Token.asString(this.getAtt("UUID", cdk.ResolutionTypeHint.STRING)), this.fileSystemId = props.fileSystemId, this.name = props.name, this.activeDirectoryConfiguration = props.activeDirectoryConfiguration, this.rootVolumeSecurityStyle = props.rootVolumeSecurityStyle, this.svmAdminPassword = props.svmAdminPassword, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::FSx::StorageVirtualMachine", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStorageVirtualMachine.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { fileSystemId: this.fileSystemId, name: this.name, activeDirectoryConfiguration: this.activeDirectoryConfiguration, rootVolumeSecurityStyle: this.rootVolumeSecurityStyle, svmAdminPassword: this.svmAdminPassword, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnStorageVirtualMachinePropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnStorageVirtualMachine[_d] = { fqn: "aws-cdk-lib.aws_fsx.CfnStorageVirtualMachine", version: "2.80.0" }, CfnStorageVirtualMachine.CFN_RESOURCE_TYPE_NAME = "AWS::FSx::StorageVirtualMachine", exports2.CfnStorageVirtualMachine = CfnStorageVirtualMachine;
    function CfnStorageVirtualMachine_ActiveDirectoryConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("netBiosName", cdk.validateString)(properties.netBiosName)), errors.collect(cdk.propertyValidator("selfManagedActiveDirectoryConfiguration", CfnStorageVirtualMachine_SelfManagedActiveDirectoryConfigurationPropertyValidator)(properties.selfManagedActiveDirectoryConfiguration)), errors.wrap('supplied properties not correct for "ActiveDirectoryConfigurationProperty"');
    }
    function cfnStorageVirtualMachineActiveDirectoryConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStorageVirtualMachine_ActiveDirectoryConfigurationPropertyValidator(properties).assertSuccess(), { NetBiosName: cdk.stringToCloudFormation(properties.netBiosName), SelfManagedActiveDirectoryConfiguration: cfnStorageVirtualMachineSelfManagedActiveDirectoryConfigurationPropertyToCloudFormation(properties.selfManagedActiveDirectoryConfiguration) }) : properties;
    }
    function CfnStorageVirtualMachineActiveDirectoryConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("netBiosName", "NetBiosName", properties.NetBiosName != null ? cfn_parse.FromCloudFormation.getString(properties.NetBiosName) : void 0), ret.addPropertyResult("selfManagedActiveDirectoryConfiguration", "SelfManagedActiveDirectoryConfiguration", properties.SelfManagedActiveDirectoryConfiguration != null ? CfnStorageVirtualMachineSelfManagedActiveDirectoryConfigurationPropertyFromCloudFormation(properties.SelfManagedActiveDirectoryConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStorageVirtualMachine_SelfManagedActiveDirectoryConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dnsIps", cdk.listValidator(cdk.validateString))(properties.dnsIps)), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.collect(cdk.propertyValidator("fileSystemAdministratorsGroup", cdk.validateString)(properties.fileSystemAdministratorsGroup)), errors.collect(cdk.propertyValidator("organizationalUnitDistinguishedName", cdk.validateString)(properties.organizationalUnitDistinguishedName)), errors.collect(cdk.propertyValidator("password", cdk.validateString)(properties.password)), errors.collect(cdk.propertyValidator("userName", cdk.validateString)(properties.userName)), errors.wrap('supplied properties not correct for "SelfManagedActiveDirectoryConfigurationProperty"');
    }
    function cfnStorageVirtualMachineSelfManagedActiveDirectoryConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStorageVirtualMachine_SelfManagedActiveDirectoryConfigurationPropertyValidator(properties).assertSuccess(), { DnsIps: cdk.listMapper(cdk.stringToCloudFormation)(properties.dnsIps), DomainName: cdk.stringToCloudFormation(properties.domainName), FileSystemAdministratorsGroup: cdk.stringToCloudFormation(properties.fileSystemAdministratorsGroup), OrganizationalUnitDistinguishedName: cdk.stringToCloudFormation(properties.organizationalUnitDistinguishedName), Password: cdk.stringToCloudFormation(properties.password), UserName: cdk.stringToCloudFormation(properties.userName) }) : properties;
    }
    function CfnStorageVirtualMachineSelfManagedActiveDirectoryConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dnsIps", "DnsIps", properties.DnsIps != null ? cfn_parse.FromCloudFormation.getStringArray(properties.DnsIps) : void 0), ret.addPropertyResult("domainName", "DomainName", properties.DomainName != null ? cfn_parse.FromCloudFormation.getString(properties.DomainName) : void 0), ret.addPropertyResult("fileSystemAdministratorsGroup", "FileSystemAdministratorsGroup", properties.FileSystemAdministratorsGroup != null ? cfn_parse.FromCloudFormation.getString(properties.FileSystemAdministratorsGroup) : void 0), ret.addPropertyResult("organizationalUnitDistinguishedName", "OrganizationalUnitDistinguishedName", properties.OrganizationalUnitDistinguishedName != null ? cfn_parse.FromCloudFormation.getString(properties.OrganizationalUnitDistinguishedName) : void 0), ret.addPropertyResult("password", "Password", properties.Password != null ? cfn_parse.FromCloudFormation.getString(properties.Password) : void 0), ret.addPropertyResult("userName", "UserName", properties.UserName != null ? cfn_parse.FromCloudFormation.getString(properties.UserName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVolumePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("backupId", cdk.validateString)(properties.backupId)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("ontapConfiguration", CfnVolume_OntapConfigurationPropertyValidator)(properties.ontapConfiguration)), errors.collect(cdk.propertyValidator("openZfsConfiguration", CfnVolume_OpenZFSConfigurationPropertyValidator)(properties.openZfsConfiguration)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("volumeType", cdk.validateString)(properties.volumeType)), errors.wrap('supplied properties not correct for "CfnVolumeProps"');
    }
    function cfnVolumePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVolumePropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), BackupId: cdk.stringToCloudFormation(properties.backupId), OntapConfiguration: cfnVolumeOntapConfigurationPropertyToCloudFormation(properties.ontapConfiguration), OpenZFSConfiguration: cfnVolumeOpenZFSConfigurationPropertyToCloudFormation(properties.openZfsConfiguration), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VolumeType: cdk.stringToCloudFormation(properties.volumeType) }) : properties;
    }
    function CfnVolumePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("backupId", "BackupId", properties.BackupId != null ? cfn_parse.FromCloudFormation.getString(properties.BackupId) : void 0), ret.addPropertyResult("ontapConfiguration", "OntapConfiguration", properties.OntapConfiguration != null ? CfnVolumeOntapConfigurationPropertyFromCloudFormation(properties.OntapConfiguration) : void 0), ret.addPropertyResult("openZfsConfiguration", "OpenZFSConfiguration", properties.OpenZFSConfiguration != null ? CfnVolumeOpenZFSConfigurationPropertyFromCloudFormation(properties.OpenZFSConfiguration) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("volumeType", "VolumeType", properties.VolumeType != null ? cfn_parse.FromCloudFormation.getString(properties.VolumeType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVolume = class _CfnVolume extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVolumePropsFromCloudFormation(resourceProperties), ret = new _CfnVolume(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVolume.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_fsx_CfnVolumeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVolume), error;
        }
        cdk.requireProperty(props, "name", this), this.attrResourceArn = cdk.Token.asString(this.getAtt("ResourceARN", cdk.ResolutionTypeHint.STRING)), this.attrUuid = cdk.Token.asString(this.getAtt("UUID", cdk.ResolutionTypeHint.STRING)), this.attrVolumeId = cdk.Token.asString(this.getAtt("VolumeId", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.backupId = props.backupId, this.ontapConfiguration = props.ontapConfiguration, this.openZfsConfiguration = props.openZfsConfiguration, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::FSx::Volume", props.tags, { tagPropertyName: "tags" }), this.volumeType = props.volumeType;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVolume.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, backupId: this.backupId, ontapConfiguration: this.ontapConfiguration, openZfsConfiguration: this.openZfsConfiguration, tags: this.tags.renderTags(), volumeType: this.volumeType };
      }
      renderProperties(props) {
        return cfnVolumePropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnVolume[_e] = { fqn: "aws-cdk-lib.aws_fsx.CfnVolume", version: "2.80.0" }, CfnVolume.CFN_RESOURCE_TYPE_NAME = "AWS::FSx::Volume", exports2.CfnVolume = CfnVolume;
    function CfnVolume_ClientConfigurationsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clients", cdk.requiredValidator)(properties.clients)), errors.collect(cdk.propertyValidator("clients", cdk.validateString)(properties.clients)), errors.collect(cdk.propertyValidator("options", cdk.requiredValidator)(properties.options)), errors.collect(cdk.propertyValidator("options", cdk.listValidator(cdk.validateString))(properties.options)), errors.wrap('supplied properties not correct for "ClientConfigurationsProperty"');
    }
    function cfnVolumeClientConfigurationsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVolume_ClientConfigurationsPropertyValidator(properties).assertSuccess(), { Clients: cdk.stringToCloudFormation(properties.clients), Options: cdk.listMapper(cdk.stringToCloudFormation)(properties.options) }) : properties;
    }
    function CfnVolumeClientConfigurationsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clients", "Clients", cfn_parse.FromCloudFormation.getString(properties.Clients)), ret.addPropertyResult("options", "Options", cfn_parse.FromCloudFormation.getStringArray(properties.Options)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVolume_NfsExportsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clientConfigurations", cdk.requiredValidator)(properties.clientConfigurations)), errors.collect(cdk.propertyValidator("clientConfigurations", cdk.listValidator(CfnVolume_ClientConfigurationsPropertyValidator))(properties.clientConfigurations)), errors.wrap('supplied properties not correct for "NfsExportsProperty"');
    }
    function cfnVolumeNfsExportsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVolume_NfsExportsPropertyValidator(properties).assertSuccess(), { ClientConfigurations: cdk.listMapper(cfnVolumeClientConfigurationsPropertyToCloudFormation)(properties.clientConfigurations) }) : properties;
    }
    function CfnVolumeNfsExportsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clientConfigurations", "ClientConfigurations", cfn_parse.FromCloudFormation.getArray(CfnVolumeClientConfigurationsPropertyFromCloudFormation)(properties.ClientConfigurations)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVolume_OntapConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("copyTagsToBackups", cdk.validateString)(properties.copyTagsToBackups)), errors.collect(cdk.propertyValidator("junctionPath", cdk.validateString)(properties.junctionPath)), errors.collect(cdk.propertyValidator("ontapVolumeType", cdk.validateString)(properties.ontapVolumeType)), errors.collect(cdk.propertyValidator("securityStyle", cdk.validateString)(properties.securityStyle)), errors.collect(cdk.propertyValidator("sizeInMegabytes", cdk.requiredValidator)(properties.sizeInMegabytes)), errors.collect(cdk.propertyValidator("sizeInMegabytes", cdk.validateString)(properties.sizeInMegabytes)), errors.collect(cdk.propertyValidator("snapshotPolicy", cdk.validateString)(properties.snapshotPolicy)), errors.collect(cdk.propertyValidator("storageEfficiencyEnabled", cdk.validateString)(properties.storageEfficiencyEnabled)), errors.collect(cdk.propertyValidator("storageVirtualMachineId", cdk.requiredValidator)(properties.storageVirtualMachineId)), errors.collect(cdk.propertyValidator("storageVirtualMachineId", cdk.validateString)(properties.storageVirtualMachineId)), errors.collect(cdk.propertyValidator("tieringPolicy", CfnVolume_TieringPolicyPropertyValidator)(properties.tieringPolicy)), errors.wrap('supplied properties not correct for "OntapConfigurationProperty"');
    }
    function cfnVolumeOntapConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVolume_OntapConfigurationPropertyValidator(properties).assertSuccess(), { CopyTagsToBackups: cdk.stringToCloudFormation(properties.copyTagsToBackups), JunctionPath: cdk.stringToCloudFormation(properties.junctionPath), OntapVolumeType: cdk.stringToCloudFormation(properties.ontapVolumeType), SecurityStyle: cdk.stringToCloudFormation(properties.securityStyle), SizeInMegabytes: cdk.stringToCloudFormation(properties.sizeInMegabytes), SnapshotPolicy: cdk.stringToCloudFormation(properties.snapshotPolicy), StorageEfficiencyEnabled: cdk.stringToCloudFormation(properties.storageEfficiencyEnabled), StorageVirtualMachineId: cdk.stringToCloudFormation(properties.storageVirtualMachineId), TieringPolicy: cfnVolumeTieringPolicyPropertyToCloudFormation(properties.tieringPolicy) }) : properties;
    }
    function CfnVolumeOntapConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("copyTagsToBackups", "CopyTagsToBackups", properties.CopyTagsToBackups != null ? cfn_parse.FromCloudFormation.getString(properties.CopyTagsToBackups) : void 0), ret.addPropertyResult("junctionPath", "JunctionPath", properties.JunctionPath != null ? cfn_parse.FromCloudFormation.getString(properties.JunctionPath) : void 0), ret.addPropertyResult("ontapVolumeType", "OntapVolumeType", properties.OntapVolumeType != null ? cfn_parse.FromCloudFormation.getString(properties.OntapVolumeType) : void 0), ret.addPropertyResult("securityStyle", "SecurityStyle", properties.SecurityStyle != null ? cfn_parse.FromCloudFormation.getString(properties.SecurityStyle) : void 0), ret.addPropertyResult("sizeInMegabytes", "SizeInMegabytes", cfn_parse.FromCloudFormation.getString(properties.SizeInMegabytes)), ret.addPropertyResult("snapshotPolicy", "SnapshotPolicy", properties.SnapshotPolicy != null ? cfn_parse.FromCloudFormation.getString(properties.SnapshotPolicy) : void 0), ret.addPropertyResult("storageEfficiencyEnabled", "StorageEfficiencyEnabled", properties.StorageEfficiencyEnabled != null ? cfn_parse.FromCloudFormation.getString(properties.StorageEfficiencyEnabled) : void 0), ret.addPropertyResult("storageVirtualMachineId", "StorageVirtualMachineId", cfn_parse.FromCloudFormation.getString(properties.StorageVirtualMachineId)), ret.addPropertyResult("tieringPolicy", "TieringPolicy", properties.TieringPolicy != null ? CfnVolumeTieringPolicyPropertyFromCloudFormation(properties.TieringPolicy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVolume_OpenZFSConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("copyTagsToSnapshots", cdk.validateBoolean)(properties.copyTagsToSnapshots)), errors.collect(cdk.propertyValidator("dataCompressionType", cdk.validateString)(properties.dataCompressionType)), errors.collect(cdk.propertyValidator("nfsExports", cdk.listValidator(CfnVolume_NfsExportsPropertyValidator))(properties.nfsExports)), errors.collect(cdk.propertyValidator("options", cdk.listValidator(cdk.validateString))(properties.options)), errors.collect(cdk.propertyValidator("originSnapshot", CfnVolume_OriginSnapshotPropertyValidator)(properties.originSnapshot)), errors.collect(cdk.propertyValidator("parentVolumeId", cdk.requiredValidator)(properties.parentVolumeId)), errors.collect(cdk.propertyValidator("parentVolumeId", cdk.validateString)(properties.parentVolumeId)), errors.collect(cdk.propertyValidator("readOnly", cdk.validateBoolean)(properties.readOnly)), errors.collect(cdk.propertyValidator("recordSizeKiB", cdk.validateNumber)(properties.recordSizeKiB)), errors.collect(cdk.propertyValidator("storageCapacityQuotaGiB", cdk.validateNumber)(properties.storageCapacityQuotaGiB)), errors.collect(cdk.propertyValidator("storageCapacityReservationGiB", cdk.validateNumber)(properties.storageCapacityReservationGiB)), errors.collect(cdk.propertyValidator("userAndGroupQuotas", cdk.listValidator(CfnVolume_UserAndGroupQuotasPropertyValidator))(properties.userAndGroupQuotas)), errors.wrap('supplied properties not correct for "OpenZFSConfigurationProperty"');
    }
    function cfnVolumeOpenZFSConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVolume_OpenZFSConfigurationPropertyValidator(properties).assertSuccess(), { CopyTagsToSnapshots: cdk.booleanToCloudFormation(properties.copyTagsToSnapshots), DataCompressionType: cdk.stringToCloudFormation(properties.dataCompressionType), NfsExports: cdk.listMapper(cfnVolumeNfsExportsPropertyToCloudFormation)(properties.nfsExports), Options: cdk.listMapper(cdk.stringToCloudFormation)(properties.options), OriginSnapshot: cfnVolumeOriginSnapshotPropertyToCloudFormation(properties.originSnapshot), ParentVolumeId: cdk.stringToCloudFormation(properties.parentVolumeId), ReadOnly: cdk.booleanToCloudFormation(properties.readOnly), RecordSizeKiB: cdk.numberToCloudFormation(properties.recordSizeKiB), StorageCapacityQuotaGiB: cdk.numberToCloudFormation(properties.storageCapacityQuotaGiB), StorageCapacityReservationGiB: cdk.numberToCloudFormation(properties.storageCapacityReservationGiB), UserAndGroupQuotas: cdk.listMapper(cfnVolumeUserAndGroupQuotasPropertyToCloudFormation)(properties.userAndGroupQuotas) }) : properties;
    }
    function CfnVolumeOpenZFSConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("copyTagsToSnapshots", "CopyTagsToSnapshots", properties.CopyTagsToSnapshots != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CopyTagsToSnapshots) : void 0), ret.addPropertyResult("dataCompressionType", "DataCompressionType", properties.DataCompressionType != null ? cfn_parse.FromCloudFormation.getString(properties.DataCompressionType) : void 0), ret.addPropertyResult("nfsExports", "NfsExports", properties.NfsExports != null ? cfn_parse.FromCloudFormation.getArray(CfnVolumeNfsExportsPropertyFromCloudFormation)(properties.NfsExports) : void 0), ret.addPropertyResult("options", "Options", properties.Options != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Options) : void 0), ret.addPropertyResult("originSnapshot", "OriginSnapshot", properties.OriginSnapshot != null ? CfnVolumeOriginSnapshotPropertyFromCloudFormation(properties.OriginSnapshot) : void 0), ret.addPropertyResult("parentVolumeId", "ParentVolumeId", cfn_parse.FromCloudFormation.getString(properties.ParentVolumeId)), ret.addPropertyResult("readOnly", "ReadOnly", properties.ReadOnly != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ReadOnly) : void 0), ret.addPropertyResult("recordSizeKiB", "RecordSizeKiB", properties.RecordSizeKiB != null ? cfn_parse.FromCloudFormation.getNumber(properties.RecordSizeKiB) : void 0), ret.addPropertyResult("storageCapacityQuotaGiB", "StorageCapacityQuotaGiB", properties.StorageCapacityQuotaGiB != null ? cfn_parse.FromCloudFormation.getNumber(properties.StorageCapacityQuotaGiB) : void 0), ret.addPropertyResult("storageCapacityReservationGiB", "StorageCapacityReservationGiB", properties.StorageCapacityReservationGiB != null ? cfn_parse.FromCloudFormation.getNumber(properties.StorageCapacityReservationGiB) : void 0), ret.addPropertyResult("userAndGroupQuotas", "UserAndGroupQuotas", properties.UserAndGroupQuotas != null ? cfn_parse.FromCloudFormation.getArray(CfnVolumeUserAndGroupQuotasPropertyFromCloudFormation)(properties.UserAndGroupQuotas) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVolume_OriginSnapshotPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("copyStrategy", cdk.requiredValidator)(properties.copyStrategy)), errors.collect(cdk.propertyValidator("copyStrategy", cdk.validateString)(properties.copyStrategy)), errors.collect(cdk.propertyValidator("snapshotArn", cdk.requiredValidator)(properties.snapshotArn)), errors.collect(cdk.propertyValidator("snapshotArn", cdk.validateString)(properties.snapshotArn)), errors.wrap('supplied properties not correct for "OriginSnapshotProperty"');
    }
    function cfnVolumeOriginSnapshotPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVolume_OriginSnapshotPropertyValidator(properties).assertSuccess(), { CopyStrategy: cdk.stringToCloudFormation(properties.copyStrategy), SnapshotARN: cdk.stringToCloudFormation(properties.snapshotArn) }) : properties;
    }
    function CfnVolumeOriginSnapshotPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("copyStrategy", "CopyStrategy", cfn_parse.FromCloudFormation.getString(properties.CopyStrategy)), ret.addPropertyResult("snapshotArn", "SnapshotARN", cfn_parse.FromCloudFormation.getString(properties.SnapshotARN)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVolume_TieringPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("coolingPeriod", cdk.validateNumber)(properties.coolingPeriod)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "TieringPolicyProperty"');
    }
    function cfnVolumeTieringPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVolume_TieringPolicyPropertyValidator(properties).assertSuccess(), { CoolingPeriod: cdk.numberToCloudFormation(properties.coolingPeriod), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnVolumeTieringPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("coolingPeriod", "CoolingPeriod", properties.CoolingPeriod != null ? cfn_parse.FromCloudFormation.getNumber(properties.CoolingPeriod) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVolume_UserAndGroupQuotasPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateNumber)(properties.id)), errors.collect(cdk.propertyValidator("storageCapacityQuotaGiB", cdk.requiredValidator)(properties.storageCapacityQuotaGiB)), errors.collect(cdk.propertyValidator("storageCapacityQuotaGiB", cdk.validateNumber)(properties.storageCapacityQuotaGiB)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "UserAndGroupQuotasProperty"');
    }
    function cfnVolumeUserAndGroupQuotasPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVolume_UserAndGroupQuotasPropertyValidator(properties).assertSuccess(), { Id: cdk.numberToCloudFormation(properties.id), StorageCapacityQuotaGiB: cdk.numberToCloudFormation(properties.storageCapacityQuotaGiB), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnVolumeUserAndGroupQuotasPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getNumber(properties.Id)), ret.addPropertyResult("storageCapacityQuotaGiB", "StorageCapacityQuotaGiB", cfn_parse.FromCloudFormation.getNumber(properties.StorageCapacityQuotaGiB)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-fsx/lib/lustre-file-system.js
var require_lustre_file_system = __commonJS({
  "node_modules/aws-cdk-lib/aws-fsx/lib/lustre-file-system.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LustreFileSystem = exports2.LustreDataCompressionType = exports2.LustreAutoImportPolicy = exports2.LustreDeploymentType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var file_system_1 = require_file_system();
    var fsx_generated_1 = require_fsx_generated();
    var aws_ec2_1 = require_aws_ec2();
    var core_1 = require_core2();
    var LustreDeploymentType;
    (function(LustreDeploymentType2) {
      LustreDeploymentType2.SCRATCH_1 = "SCRATCH_1", LustreDeploymentType2.SCRATCH_2 = "SCRATCH_2", LustreDeploymentType2.PERSISTENT_1 = "PERSISTENT_1", LustreDeploymentType2.PERSISTENT_2 = "PERSISTENT_2";
    })(LustreDeploymentType = exports2.LustreDeploymentType || (exports2.LustreDeploymentType = {}));
    var LustreAutoImportPolicy;
    (function(LustreAutoImportPolicy2) {
      LustreAutoImportPolicy2.NONE = "NONE", LustreAutoImportPolicy2.NEW = "NEW", LustreAutoImportPolicy2.NEW_CHANGED = "NEW_CHANGED", LustreAutoImportPolicy2.NEW_CHANGED_DELETED = "NEW_CHANGED_DELETED";
    })(LustreAutoImportPolicy = exports2.LustreAutoImportPolicy || (exports2.LustreAutoImportPolicy = {}));
    var LustreDataCompressionType;
    (function(LustreDataCompressionType2) {
      LustreDataCompressionType2.NONE = "NONE", LustreDataCompressionType2.LZ4 = "LZ4";
    })(LustreDataCompressionType = exports2.LustreDataCompressionType || (exports2.LustreDataCompressionType = {}));
    var LustreFileSystem = class _LustreFileSystem extends file_system_1.FileSystemBase {
      static fromLustreFileSystemAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_fsx_FileSystemAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromLustreFileSystemAttributes), error;
        }
        class Import extends file_system_1.FileSystemBase {
          constructor() {
            super(...arguments), this.dnsName = attrs.dnsName, this.fileSystemId = attrs.fileSystemId, this.connections = _LustreFileSystem.configureConnections(attrs.securityGroup);
          }
        }
        return new Import(scope, id);
      }
      static configureConnections(securityGroup) {
        return new aws_ec2_1.Connections({ securityGroups: [securityGroup], defaultPort: aws_ec2_1.Port.tcpRange(_LustreFileSystem.DEFAULT_PORT_RANGE.startPort, _LustreFileSystem.DEFAULT_PORT_RANGE.endPort) });
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_fsx_LustreFileSystemProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _LustreFileSystem), error;
        }
        this.validateProps(props);
        const updatedLustureProps = { importedFileChunkSize: props.lustreConfiguration.importedFileChunkSizeMiB, weeklyMaintenanceStartTime: props.lustreConfiguration.weeklyMaintenanceStartTime?.toTimestamp() }, lustreConfiguration = Object.assign({}, props.lustreConfiguration, updatedLustureProps), securityGroup = props.securityGroup || new aws_ec2_1.SecurityGroup(this, "FsxLustreSecurityGroup", { vpc: props.vpc });
        securityGroup.addIngressRule(securityGroup, aws_ec2_1.Port.tcpRange(_LustreFileSystem.DEFAULT_PORT_RANGE.startPort, _LustreFileSystem.DEFAULT_PORT_RANGE.endPort)), this.connections = _LustreFileSystem.configureConnections(securityGroup), this.fileSystem = new fsx_generated_1.CfnFileSystem(this, "Resource", { fileSystemType: _LustreFileSystem.DEFAULT_FILE_SYSTEM_TYPE, subnetIds: [props.vpcSubnet.subnetId], backupId: props.backupId, kmsKeyId: props.kmsKey ? props.kmsKey.keyId : void 0, lustreConfiguration, securityGroupIds: [securityGroup.securityGroupId], storageCapacity: props.storageCapacityGiB }), this.fileSystem.applyRemovalPolicy(props.removalPolicy), this.fileSystemId = this.fileSystem.ref, this.dnsName = `${this.fileSystemId}.fsx.${this.env.region}.${core_1.Aws.URL_SUFFIX}`, this.mountName = this.fileSystem.attrLustreMountName;
      }
      validateProps(props) {
        const lustreConfiguration = props.lustreConfiguration, deploymentType = lustreConfiguration.deploymentType;
        this.validateImportPath(lustreConfiguration.importPath), this.validateExportPath(lustreConfiguration.exportPath, lustreConfiguration.importPath), this.validateImportedFileChunkSize(lustreConfiguration.importedFileChunkSizeMiB), this.validateAutoImportPolicy(deploymentType, lustreConfiguration.importPath, lustreConfiguration.autoImportPolicy), this.validatePerUnitStorageThroughput(deploymentType, lustreConfiguration.perUnitStorageThroughput), this.validateStorageCapacity(deploymentType, props.storageCapacityGiB);
      }
      validateAutoImportPolicy(deploymentType, importPath, autoImportPolicy) {
        if (autoImportPolicy !== void 0) {
          if (importPath === void 0)
            throw new Error("autoImportPolicy requires importPath to be defined");
          if (deploymentType === LustreDeploymentType.PERSISTENT_2)
            throw new Error("autoImportPolicy is not supported with PERSISTENT_2 deployments");
        }
      }
      validateExportPath(exportPath, importPath) {
        if (exportPath !== void 0) {
          if (importPath === void 0)
            throw new Error("Cannot define an export path without also defining an import path");
          if (!(core_1.Token.isUnresolved(exportPath) && core_1.Token.isUnresolved(importPath))) {
            if (core_1.Token.isUnresolved(importPath) !== core_1.Token.isUnresolved(exportPath))
              throw new Error("The importPath and exportPath must each be Tokens or not Tokens, you cannot use a mix");
            if (!exportPath.startsWith(importPath))
              throw new Error(`The export path "${exportPath}" is invalid. Expecting the format: s3://{IMPORT_PATH}/optional-prefix`);
            if (exportPath.length > 900)
              throw new Error(`The export path "${exportPath}" exceeds the maximum length of 900 characters`);
          }
        }
      }
      validateImportedFileChunkSize(importedFileChunkSize) {
        if (importedFileChunkSize !== void 0 && (importedFileChunkSize < 1 || importedFileChunkSize > 512e3))
          throw new Error(`importedFileChunkSize cannot be ${importedFileChunkSize} MiB. It must be a value from 1 to 512,000 MiB`);
      }
      validateImportPath(importPath) {
        if (importPath === void 0 || core_1.Token.isUnresolved(importPath))
          return;
        const regexp = /^s3:\/\//;
        if (importPath.search(regexp) === -1)
          throw new Error(`The import path "${importPath}" is invalid. Expecting the format: s3://{BUCKET_NAME}/optional-prefix`);
        if (importPath.length > 900)
          throw new Error(`The import path "${importPath}" exceeds the maximum length of 900 characters`);
      }
      validatePerUnitStorageThroughput(deploymentType, perUnitStorageThroughput) {
        if (perUnitStorageThroughput !== void 0) {
          if (deploymentType !== LustreDeploymentType.PERSISTENT_1 && deploymentType !== LustreDeploymentType.PERSISTENT_2)
            throw new Error("perUnitStorageThroughput can only be set for the PERSISTENT_1/PERSISTENT_2 deployment types, received: " + deploymentType);
          if (deploymentType === LustreDeploymentType.PERSISTENT_1 && ![50, 100, 200].includes(perUnitStorageThroughput))
            throw new Error("perUnitStorageThroughput must be 50, 100, or 200 MB/s/TiB for PERSISTENT_1 deployment type, got: " + perUnitStorageThroughput);
          if (deploymentType === LustreDeploymentType.PERSISTENT_2 && ![125, 250, 500, 1e3].includes(perUnitStorageThroughput))
            throw new Error("perUnitStorageThroughput must be 125, 250, 500 or 1000 MB/s/TiB for PERSISTENT_2 deployment type, got: " + perUnitStorageThroughput);
        }
      }
      validateStorageCapacity(deploymentType, storageCapacity) {
        if (deploymentType === LustreDeploymentType.SCRATCH_1) {
          if (![1200, 2400, 3600].includes(storageCapacity) && storageCapacity % 3600 !== 0)
            throw new Error("storageCapacity must be 1,200, 2,400, 3,600, or a multiple of 3,600");
        } else if (![1200, 2400].includes(storageCapacity) && storageCapacity % 2400 !== 0)
          throw new Error("storageCapacity must be 1,200, 2,400, or a multiple of 2,400");
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LustreFileSystem[_a] = { fqn: "aws-cdk-lib.aws_fsx.LustreFileSystem", version: "2.80.0" }, LustreFileSystem.DEFAULT_FILE_SYSTEM_TYPE = "LUSTRE", LustreFileSystem.DEFAULT_PORT_RANGE = { startPort: 988, endPort: 1023 }, exports2.LustreFileSystem = LustreFileSystem;
  }
});

// node_modules/aws-cdk-lib/aws-fsx/lib/maintenance-time.js
var require_maintenance_time = __commonJS({
  "node_modules/aws-cdk-lib/aws-fsx/lib/maintenance-time.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LustreMaintenanceTime = exports2.Weekday = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var Weekday;
    (function(Weekday2) {
      Weekday2.MONDAY = "1", Weekday2.TUESDAY = "2", Weekday2.WEDNESDAY = "3", Weekday2.THURSDAY = "4", Weekday2.FRIDAY = "5", Weekday2.SATURDAY = "6", Weekday2.SUNDAY = "7";
    })(Weekday = exports2.Weekday || (exports2.Weekday = {}));
    var LustreMaintenanceTime = class _LustreMaintenanceTime {
      constructor(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_fsx_LustreMaintenanceTimeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _LustreMaintenanceTime), error;
        }
        this.validate(props.hour, props.minute), this.day = props.day, this.hour = this.getTwoDigitString(props.hour), this.minute = this.getTwoDigitString(props.minute);
      }
      toTimestamp() {
        return `${this.day.valueOf()}:${this.hour}:${this.minute}`;
      }
      getTwoDigitString(n) {
        const numberString = n.toString();
        return numberString.length === 1 ? `0${n}` : numberString;
      }
      validate(hour, minute) {
        if (!Number.isInteger(hour) || hour < 0 || hour > 24)
          throw new Error("Maintenance time hour must be an integer between 0 and 24");
        if (!Number.isInteger(minute) || minute < 0 || minute > 59)
          throw new Error("Maintenance time minute must be an integer between 0 and 59");
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LustreMaintenanceTime[_a] = { fqn: "aws-cdk-lib.aws_fsx.LustreMaintenanceTime", version: "2.80.0" }, exports2.LustreMaintenanceTime = LustreMaintenanceTime;
  }
});

// node_modules/aws-cdk-lib/aws-fsx/lib/index.js
var require_lib133 = __commonJS({
  "node_modules/aws-cdk-lib/aws-fsx/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_file_system(), exports2), __exportStar(require_fsx_generated(), exports2), __exportStar(require_lustre_file_system(), exports2), __exportStar(require_maintenance_time(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-fsx/index.js
var require_aws_fsx = __commonJS({
  "node_modules/aws-cdk-lib/aws-fsx/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib133(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-gamelift/lib/gamelift.generated.js
var require_gamelift_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-gamelift/lib/gamelift.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnScript = exports2.CfnMatchmakingRuleSet = exports2.CfnMatchmakingConfiguration = exports2.CfnLocation = exports2.CfnGameSessionQueue = exports2.CfnGameServerGroup = exports2.CfnFleet = exports2.CfnBuild = exports2.CfnAlias = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAliasPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("routingStrategy", cdk.requiredValidator)(properties.routingStrategy)), errors.collect(cdk.propertyValidator("routingStrategy", CfnAlias_RoutingStrategyPropertyValidator)(properties.routingStrategy)), errors.wrap('supplied properties not correct for "CfnAliasProps"');
    }
    function cfnAliasPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAliasPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), RoutingStrategy: cfnAliasRoutingStrategyPropertyToCloudFormation(properties.routingStrategy), Description: cdk.stringToCloudFormation(properties.description) }) : properties;
    }
    function CfnAliasPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("routingStrategy", "RoutingStrategy", CfnAliasRoutingStrategyPropertyFromCloudFormation(properties.RoutingStrategy)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAlias = class _CfnAlias extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAliasPropsFromCloudFormation(resourceProperties), ret = new _CfnAlias(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAlias.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_gamelift_CfnAliasProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAlias), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "routingStrategy", this), this.attrAliasId = cdk.Token.asString(this.getAtt("AliasId", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.routingStrategy = props.routingStrategy, this.description = props.description;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAlias.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, routingStrategy: this.routingStrategy, description: this.description };
      }
      renderProperties(props) {
        return cfnAliasPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAlias[_a] = { fqn: "aws-cdk-lib.aws_gamelift.CfnAlias", version: "2.80.0" }, CfnAlias.CFN_RESOURCE_TYPE_NAME = "AWS::GameLift::Alias", exports2.CfnAlias = CfnAlias;
    function CfnAlias_RoutingStrategyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fleetId", cdk.validateString)(properties.fleetId)), errors.collect(cdk.propertyValidator("message", cdk.validateString)(properties.message)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "RoutingStrategyProperty"');
    }
    function cfnAliasRoutingStrategyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlias_RoutingStrategyPropertyValidator(properties).assertSuccess(), { FleetId: cdk.stringToCloudFormation(properties.fleetId), Message: cdk.stringToCloudFormation(properties.message), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnAliasRoutingStrategyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fleetId", "FleetId", properties.FleetId != null ? cfn_parse.FromCloudFormation.getString(properties.FleetId) : void 0), ret.addPropertyResult("message", "Message", properties.Message != null ? cfn_parse.FromCloudFormation.getString(properties.Message) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBuildPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("operatingSystem", cdk.validateString)(properties.operatingSystem)), errors.collect(cdk.propertyValidator("serverSdkVersion", cdk.validateString)(properties.serverSdkVersion)), errors.collect(cdk.propertyValidator("storageLocation", CfnBuild_StorageLocationPropertyValidator)(properties.storageLocation)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "CfnBuildProps"');
    }
    function cfnBuildPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBuildPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), OperatingSystem: cdk.stringToCloudFormation(properties.operatingSystem), ServerSdkVersion: cdk.stringToCloudFormation(properties.serverSdkVersion), StorageLocation: cfnBuildStorageLocationPropertyToCloudFormation(properties.storageLocation), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnBuildPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("operatingSystem", "OperatingSystem", properties.OperatingSystem != null ? cfn_parse.FromCloudFormation.getString(properties.OperatingSystem) : void 0), ret.addPropertyResult("serverSdkVersion", "ServerSdkVersion", properties.ServerSdkVersion != null ? cfn_parse.FromCloudFormation.getString(properties.ServerSdkVersion) : void 0), ret.addPropertyResult("storageLocation", "StorageLocation", properties.StorageLocation != null ? CfnBuildStorageLocationPropertyFromCloudFormation(properties.StorageLocation) : void 0), ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getString(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnBuild = class _CfnBuild extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnBuildPropsFromCloudFormation(resourceProperties), ret = new _CfnBuild(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnBuild.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_gamelift_CfnBuildProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnBuild), error;
        }
        this.attrBuildId = cdk.Token.asString(this.getAtt("BuildId", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.operatingSystem = props.operatingSystem, this.serverSdkVersion = props.serverSdkVersion, this.storageLocation = props.storageLocation, this.version = props.version;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnBuild.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, operatingSystem: this.operatingSystem, serverSdkVersion: this.serverSdkVersion, storageLocation: this.storageLocation, version: this.version };
      }
      renderProperties(props) {
        return cfnBuildPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnBuild[_b] = { fqn: "aws-cdk-lib.aws_gamelift.CfnBuild", version: "2.80.0" }, CfnBuild.CFN_RESOURCE_TYPE_NAME = "AWS::GameLift::Build", exports2.CfnBuild = CfnBuild;
    function CfnBuild_StorageLocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.requiredValidator)(properties.bucket)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("objectVersion", cdk.validateString)(properties.objectVersion)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "StorageLocationProperty"');
    }
    function cfnBuildStorageLocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBuild_StorageLocationPropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), Key: cdk.stringToCloudFormation(properties.key), ObjectVersion: cdk.stringToCloudFormation(properties.objectVersion), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnBuildStorageLocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", cfn_parse.FromCloudFormation.getString(properties.Bucket)), ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("objectVersion", "ObjectVersion", properties.ObjectVersion != null ? cfn_parse.FromCloudFormation.getString(properties.ObjectVersion) : void 0), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFleetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("anywhereConfiguration", CfnFleet_AnywhereConfigurationPropertyValidator)(properties.anywhereConfiguration)), errors.collect(cdk.propertyValidator("buildId", cdk.validateString)(properties.buildId)), errors.collect(cdk.propertyValidator("certificateConfiguration", CfnFleet_CertificateConfigurationPropertyValidator)(properties.certificateConfiguration)), errors.collect(cdk.propertyValidator("computeType", cdk.validateString)(properties.computeType)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("desiredEc2Instances", cdk.validateNumber)(properties.desiredEc2Instances)), errors.collect(cdk.propertyValidator("ec2InboundPermissions", cdk.listValidator(CfnFleet_IpPermissionPropertyValidator))(properties.ec2InboundPermissions)), errors.collect(cdk.propertyValidator("ec2InstanceType", cdk.validateString)(properties.ec2InstanceType)), errors.collect(cdk.propertyValidator("fleetType", cdk.validateString)(properties.fleetType)), errors.collect(cdk.propertyValidator("instanceRoleArn", cdk.validateString)(properties.instanceRoleArn)), errors.collect(cdk.propertyValidator("locations", cdk.listValidator(CfnFleet_LocationConfigurationPropertyValidator))(properties.locations)), errors.collect(cdk.propertyValidator("maxSize", cdk.validateNumber)(properties.maxSize)), errors.collect(cdk.propertyValidator("metricGroups", cdk.listValidator(cdk.validateString))(properties.metricGroups)), errors.collect(cdk.propertyValidator("minSize", cdk.validateNumber)(properties.minSize)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("newGameSessionProtectionPolicy", cdk.validateString)(properties.newGameSessionProtectionPolicy)), errors.collect(cdk.propertyValidator("peerVpcAwsAccountId", cdk.validateString)(properties.peerVpcAwsAccountId)), errors.collect(cdk.propertyValidator("peerVpcId", cdk.validateString)(properties.peerVpcId)), errors.collect(cdk.propertyValidator("resourceCreationLimitPolicy", CfnFleet_ResourceCreationLimitPolicyPropertyValidator)(properties.resourceCreationLimitPolicy)), errors.collect(cdk.propertyValidator("runtimeConfiguration", CfnFleet_RuntimeConfigurationPropertyValidator)(properties.runtimeConfiguration)), errors.collect(cdk.propertyValidator("scriptId", cdk.validateString)(properties.scriptId)), errors.wrap('supplied properties not correct for "CfnFleetProps"');
    }
    function cfnFleetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFleetPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), AnywhereConfiguration: cfnFleetAnywhereConfigurationPropertyToCloudFormation(properties.anywhereConfiguration), BuildId: cdk.stringToCloudFormation(properties.buildId), CertificateConfiguration: cfnFleetCertificateConfigurationPropertyToCloudFormation(properties.certificateConfiguration), ComputeType: cdk.stringToCloudFormation(properties.computeType), Description: cdk.stringToCloudFormation(properties.description), DesiredEC2Instances: cdk.numberToCloudFormation(properties.desiredEc2Instances), EC2InboundPermissions: cdk.listMapper(cfnFleetIpPermissionPropertyToCloudFormation)(properties.ec2InboundPermissions), EC2InstanceType: cdk.stringToCloudFormation(properties.ec2InstanceType), FleetType: cdk.stringToCloudFormation(properties.fleetType), InstanceRoleARN: cdk.stringToCloudFormation(properties.instanceRoleArn), Locations: cdk.listMapper(cfnFleetLocationConfigurationPropertyToCloudFormation)(properties.locations), MaxSize: cdk.numberToCloudFormation(properties.maxSize), MetricGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.metricGroups), MinSize: cdk.numberToCloudFormation(properties.minSize), NewGameSessionProtectionPolicy: cdk.stringToCloudFormation(properties.newGameSessionProtectionPolicy), PeerVpcAwsAccountId: cdk.stringToCloudFormation(properties.peerVpcAwsAccountId), PeerVpcId: cdk.stringToCloudFormation(properties.peerVpcId), ResourceCreationLimitPolicy: cfnFleetResourceCreationLimitPolicyPropertyToCloudFormation(properties.resourceCreationLimitPolicy), RuntimeConfiguration: cfnFleetRuntimeConfigurationPropertyToCloudFormation(properties.runtimeConfiguration), ScriptId: cdk.stringToCloudFormation(properties.scriptId) }) : properties;
    }
    function CfnFleetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("anywhereConfiguration", "AnywhereConfiguration", properties.AnywhereConfiguration != null ? CfnFleetAnywhereConfigurationPropertyFromCloudFormation(properties.AnywhereConfiguration) : void 0), ret.addPropertyResult("buildId", "BuildId", properties.BuildId != null ? cfn_parse.FromCloudFormation.getString(properties.BuildId) : void 0), ret.addPropertyResult("certificateConfiguration", "CertificateConfiguration", properties.CertificateConfiguration != null ? CfnFleetCertificateConfigurationPropertyFromCloudFormation(properties.CertificateConfiguration) : void 0), ret.addPropertyResult("computeType", "ComputeType", properties.ComputeType != null ? cfn_parse.FromCloudFormation.getString(properties.ComputeType) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("desiredEc2Instances", "DesiredEC2Instances", properties.DesiredEC2Instances != null ? cfn_parse.FromCloudFormation.getNumber(properties.DesiredEC2Instances) : void 0), ret.addPropertyResult("ec2InboundPermissions", "EC2InboundPermissions", properties.EC2InboundPermissions != null ? cfn_parse.FromCloudFormation.getArray(CfnFleetIpPermissionPropertyFromCloudFormation)(properties.EC2InboundPermissions) : void 0), ret.addPropertyResult("ec2InstanceType", "EC2InstanceType", properties.EC2InstanceType != null ? cfn_parse.FromCloudFormation.getString(properties.EC2InstanceType) : void 0), ret.addPropertyResult("fleetType", "FleetType", properties.FleetType != null ? cfn_parse.FromCloudFormation.getString(properties.FleetType) : void 0), ret.addPropertyResult("instanceRoleArn", "InstanceRoleARN", properties.InstanceRoleARN != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceRoleARN) : void 0), ret.addPropertyResult("locations", "Locations", properties.Locations != null ? cfn_parse.FromCloudFormation.getArray(CfnFleetLocationConfigurationPropertyFromCloudFormation)(properties.Locations) : void 0), ret.addPropertyResult("maxSize", "MaxSize", properties.MaxSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxSize) : void 0), ret.addPropertyResult("metricGroups", "MetricGroups", properties.MetricGroups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.MetricGroups) : void 0), ret.addPropertyResult("minSize", "MinSize", properties.MinSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinSize) : void 0), ret.addPropertyResult("newGameSessionProtectionPolicy", "NewGameSessionProtectionPolicy", properties.NewGameSessionProtectionPolicy != null ? cfn_parse.FromCloudFormation.getString(properties.NewGameSessionProtectionPolicy) : void 0), ret.addPropertyResult("peerVpcAwsAccountId", "PeerVpcAwsAccountId", properties.PeerVpcAwsAccountId != null ? cfn_parse.FromCloudFormation.getString(properties.PeerVpcAwsAccountId) : void 0), ret.addPropertyResult("peerVpcId", "PeerVpcId", properties.PeerVpcId != null ? cfn_parse.FromCloudFormation.getString(properties.PeerVpcId) : void 0), ret.addPropertyResult("resourceCreationLimitPolicy", "ResourceCreationLimitPolicy", properties.ResourceCreationLimitPolicy != null ? CfnFleetResourceCreationLimitPolicyPropertyFromCloudFormation(properties.ResourceCreationLimitPolicy) : void 0), ret.addPropertyResult("runtimeConfiguration", "RuntimeConfiguration", properties.RuntimeConfiguration != null ? CfnFleetRuntimeConfigurationPropertyFromCloudFormation(properties.RuntimeConfiguration) : void 0), ret.addPropertyResult("scriptId", "ScriptId", properties.ScriptId != null ? cfn_parse.FromCloudFormation.getString(properties.ScriptId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFleet = class _CfnFleet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFleetPropsFromCloudFormation(resourceProperties), ret = new _CfnFleet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFleet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_gamelift_CfnFleetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFleet), error;
        }
        cdk.requireProperty(props, "name", this), this.attrFleetId = cdk.Token.asString(this.getAtt("FleetId", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.anywhereConfiguration = props.anywhereConfiguration, this.buildId = props.buildId, this.certificateConfiguration = props.certificateConfiguration, this.computeType = props.computeType, this.description = props.description, this.desiredEc2Instances = props.desiredEc2Instances, this.ec2InboundPermissions = props.ec2InboundPermissions, this.ec2InstanceType = props.ec2InstanceType, this.fleetType = props.fleetType, this.instanceRoleArn = props.instanceRoleArn, this.locations = props.locations, this.maxSize = props.maxSize, this.metricGroups = props.metricGroups, this.minSize = props.minSize, this.newGameSessionProtectionPolicy = props.newGameSessionProtectionPolicy, this.peerVpcAwsAccountId = props.peerVpcAwsAccountId, this.peerVpcId = props.peerVpcId, this.resourceCreationLimitPolicy = props.resourceCreationLimitPolicy, this.runtimeConfiguration = props.runtimeConfiguration, this.scriptId = props.scriptId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFleet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, anywhereConfiguration: this.anywhereConfiguration, buildId: this.buildId, certificateConfiguration: this.certificateConfiguration, computeType: this.computeType, description: this.description, desiredEc2Instances: this.desiredEc2Instances, ec2InboundPermissions: this.ec2InboundPermissions, ec2InstanceType: this.ec2InstanceType, fleetType: this.fleetType, instanceRoleArn: this.instanceRoleArn, locations: this.locations, maxSize: this.maxSize, metricGroups: this.metricGroups, minSize: this.minSize, newGameSessionProtectionPolicy: this.newGameSessionProtectionPolicy, peerVpcAwsAccountId: this.peerVpcAwsAccountId, peerVpcId: this.peerVpcId, resourceCreationLimitPolicy: this.resourceCreationLimitPolicy, runtimeConfiguration: this.runtimeConfiguration, scriptId: this.scriptId };
      }
      renderProperties(props) {
        return cfnFleetPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnFleet[_c] = { fqn: "aws-cdk-lib.aws_gamelift.CfnFleet", version: "2.80.0" }, CfnFleet.CFN_RESOURCE_TYPE_NAME = "AWS::GameLift::Fleet", exports2.CfnFleet = CfnFleet;
    function CfnFleet_AnywhereConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cost", cdk.requiredValidator)(properties.cost)), errors.collect(cdk.propertyValidator("cost", cdk.validateString)(properties.cost)), errors.wrap('supplied properties not correct for "AnywhereConfigurationProperty"');
    }
    function cfnFleetAnywhereConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFleet_AnywhereConfigurationPropertyValidator(properties).assertSuccess(), { Cost: cdk.stringToCloudFormation(properties.cost) }) : properties;
    }
    function CfnFleetAnywhereConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cost", "Cost", cfn_parse.FromCloudFormation.getString(properties.Cost)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFleet_CertificateConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateType", cdk.requiredValidator)(properties.certificateType)), errors.collect(cdk.propertyValidator("certificateType", cdk.validateString)(properties.certificateType)), errors.wrap('supplied properties not correct for "CertificateConfigurationProperty"');
    }
    function cfnFleetCertificateConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFleet_CertificateConfigurationPropertyValidator(properties).assertSuccess(), { CertificateType: cdk.stringToCloudFormation(properties.certificateType) }) : properties;
    }
    function CfnFleetCertificateConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificateType", "CertificateType", cfn_parse.FromCloudFormation.getString(properties.CertificateType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFleet_IpPermissionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fromPort", cdk.requiredValidator)(properties.fromPort)), errors.collect(cdk.propertyValidator("fromPort", cdk.validateNumber)(properties.fromPort)), errors.collect(cdk.propertyValidator("ipRange", cdk.requiredValidator)(properties.ipRange)), errors.collect(cdk.propertyValidator("ipRange", cdk.validateString)(properties.ipRange)), errors.collect(cdk.propertyValidator("protocol", cdk.requiredValidator)(properties.protocol)), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.collect(cdk.propertyValidator("toPort", cdk.requiredValidator)(properties.toPort)), errors.collect(cdk.propertyValidator("toPort", cdk.validateNumber)(properties.toPort)), errors.wrap('supplied properties not correct for "IpPermissionProperty"');
    }
    function cfnFleetIpPermissionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFleet_IpPermissionPropertyValidator(properties).assertSuccess(), { FromPort: cdk.numberToCloudFormation(properties.fromPort), IpRange: cdk.stringToCloudFormation(properties.ipRange), Protocol: cdk.stringToCloudFormation(properties.protocol), ToPort: cdk.numberToCloudFormation(properties.toPort) }) : properties;
    }
    function CfnFleetIpPermissionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fromPort", "FromPort", cfn_parse.FromCloudFormation.getNumber(properties.FromPort)), ret.addPropertyResult("ipRange", "IpRange", cfn_parse.FromCloudFormation.getString(properties.IpRange)), ret.addPropertyResult("protocol", "Protocol", cfn_parse.FromCloudFormation.getString(properties.Protocol)), ret.addPropertyResult("toPort", "ToPort", cfn_parse.FromCloudFormation.getNumber(properties.ToPort)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFleet_LocationCapacityPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("desiredEc2Instances", cdk.requiredValidator)(properties.desiredEc2Instances)), errors.collect(cdk.propertyValidator("desiredEc2Instances", cdk.validateNumber)(properties.desiredEc2Instances)), errors.collect(cdk.propertyValidator("maxSize", cdk.requiredValidator)(properties.maxSize)), errors.collect(cdk.propertyValidator("maxSize", cdk.validateNumber)(properties.maxSize)), errors.collect(cdk.propertyValidator("minSize", cdk.requiredValidator)(properties.minSize)), errors.collect(cdk.propertyValidator("minSize", cdk.validateNumber)(properties.minSize)), errors.wrap('supplied properties not correct for "LocationCapacityProperty"');
    }
    function cfnFleetLocationCapacityPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFleet_LocationCapacityPropertyValidator(properties).assertSuccess(), { DesiredEC2Instances: cdk.numberToCloudFormation(properties.desiredEc2Instances), MaxSize: cdk.numberToCloudFormation(properties.maxSize), MinSize: cdk.numberToCloudFormation(properties.minSize) }) : properties;
    }
    function CfnFleetLocationCapacityPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("desiredEc2Instances", "DesiredEC2Instances", cfn_parse.FromCloudFormation.getNumber(properties.DesiredEC2Instances)), ret.addPropertyResult("maxSize", "MaxSize", cfn_parse.FromCloudFormation.getNumber(properties.MaxSize)), ret.addPropertyResult("minSize", "MinSize", cfn_parse.FromCloudFormation.getNumber(properties.MinSize)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFleet_LocationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("location", cdk.requiredValidator)(properties.location)), errors.collect(cdk.propertyValidator("location", cdk.validateString)(properties.location)), errors.collect(cdk.propertyValidator("locationCapacity", CfnFleet_LocationCapacityPropertyValidator)(properties.locationCapacity)), errors.wrap('supplied properties not correct for "LocationConfigurationProperty"');
    }
    function cfnFleetLocationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFleet_LocationConfigurationPropertyValidator(properties).assertSuccess(), { Location: cdk.stringToCloudFormation(properties.location), LocationCapacity: cfnFleetLocationCapacityPropertyToCloudFormation(properties.locationCapacity) }) : properties;
    }
    function CfnFleetLocationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("location", "Location", cfn_parse.FromCloudFormation.getString(properties.Location)), ret.addPropertyResult("locationCapacity", "LocationCapacity", properties.LocationCapacity != null ? CfnFleetLocationCapacityPropertyFromCloudFormation(properties.LocationCapacity) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFleet_ResourceCreationLimitPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("newGameSessionsPerCreator", cdk.validateNumber)(properties.newGameSessionsPerCreator)), errors.collect(cdk.propertyValidator("policyPeriodInMinutes", cdk.validateNumber)(properties.policyPeriodInMinutes)), errors.wrap('supplied properties not correct for "ResourceCreationLimitPolicyProperty"');
    }
    function cfnFleetResourceCreationLimitPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFleet_ResourceCreationLimitPolicyPropertyValidator(properties).assertSuccess(), { NewGameSessionsPerCreator: cdk.numberToCloudFormation(properties.newGameSessionsPerCreator), PolicyPeriodInMinutes: cdk.numberToCloudFormation(properties.policyPeriodInMinutes) }) : properties;
    }
    function CfnFleetResourceCreationLimitPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("newGameSessionsPerCreator", "NewGameSessionsPerCreator", properties.NewGameSessionsPerCreator != null ? cfn_parse.FromCloudFormation.getNumber(properties.NewGameSessionsPerCreator) : void 0), ret.addPropertyResult("policyPeriodInMinutes", "PolicyPeriodInMinutes", properties.PolicyPeriodInMinutes != null ? cfn_parse.FromCloudFormation.getNumber(properties.PolicyPeriodInMinutes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFleet_RuntimeConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("gameSessionActivationTimeoutSeconds", cdk.validateNumber)(properties.gameSessionActivationTimeoutSeconds)), errors.collect(cdk.propertyValidator("maxConcurrentGameSessionActivations", cdk.validateNumber)(properties.maxConcurrentGameSessionActivations)), errors.collect(cdk.propertyValidator("serverProcesses", cdk.listValidator(CfnFleet_ServerProcessPropertyValidator))(properties.serverProcesses)), errors.wrap('supplied properties not correct for "RuntimeConfigurationProperty"');
    }
    function cfnFleetRuntimeConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFleet_RuntimeConfigurationPropertyValidator(properties).assertSuccess(), { GameSessionActivationTimeoutSeconds: cdk.numberToCloudFormation(properties.gameSessionActivationTimeoutSeconds), MaxConcurrentGameSessionActivations: cdk.numberToCloudFormation(properties.maxConcurrentGameSessionActivations), ServerProcesses: cdk.listMapper(cfnFleetServerProcessPropertyToCloudFormation)(properties.serverProcesses) }) : properties;
    }
    function CfnFleetRuntimeConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("gameSessionActivationTimeoutSeconds", "GameSessionActivationTimeoutSeconds", properties.GameSessionActivationTimeoutSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.GameSessionActivationTimeoutSeconds) : void 0), ret.addPropertyResult("maxConcurrentGameSessionActivations", "MaxConcurrentGameSessionActivations", properties.MaxConcurrentGameSessionActivations != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxConcurrentGameSessionActivations) : void 0), ret.addPropertyResult("serverProcesses", "ServerProcesses", properties.ServerProcesses != null ? cfn_parse.FromCloudFormation.getArray(CfnFleetServerProcessPropertyFromCloudFormation)(properties.ServerProcesses) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFleet_ServerProcessPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("concurrentExecutions", cdk.requiredValidator)(properties.concurrentExecutions)), errors.collect(cdk.propertyValidator("concurrentExecutions", cdk.validateNumber)(properties.concurrentExecutions)), errors.collect(cdk.propertyValidator("launchPath", cdk.requiredValidator)(properties.launchPath)), errors.collect(cdk.propertyValidator("launchPath", cdk.validateString)(properties.launchPath)), errors.collect(cdk.propertyValidator("parameters", cdk.validateString)(properties.parameters)), errors.wrap('supplied properties not correct for "ServerProcessProperty"');
    }
    function cfnFleetServerProcessPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFleet_ServerProcessPropertyValidator(properties).assertSuccess(), { ConcurrentExecutions: cdk.numberToCloudFormation(properties.concurrentExecutions), LaunchPath: cdk.stringToCloudFormation(properties.launchPath), Parameters: cdk.stringToCloudFormation(properties.parameters) }) : properties;
    }
    function CfnFleetServerProcessPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("concurrentExecutions", "ConcurrentExecutions", cfn_parse.FromCloudFormation.getNumber(properties.ConcurrentExecutions)), ret.addPropertyResult("launchPath", "LaunchPath", cfn_parse.FromCloudFormation.getString(properties.LaunchPath)), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getString(properties.Parameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGameServerGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoScalingPolicy", CfnGameServerGroup_AutoScalingPolicyPropertyValidator)(properties.autoScalingPolicy)), errors.collect(cdk.propertyValidator("balancingStrategy", cdk.validateString)(properties.balancingStrategy)), errors.collect(cdk.propertyValidator("deleteOption", cdk.validateString)(properties.deleteOption)), errors.collect(cdk.propertyValidator("gameServerGroupName", cdk.requiredValidator)(properties.gameServerGroupName)), errors.collect(cdk.propertyValidator("gameServerGroupName", cdk.validateString)(properties.gameServerGroupName)), errors.collect(cdk.propertyValidator("gameServerProtectionPolicy", cdk.validateString)(properties.gameServerProtectionPolicy)), errors.collect(cdk.propertyValidator("instanceDefinitions", cdk.requiredValidator)(properties.instanceDefinitions)), errors.collect(cdk.propertyValidator("instanceDefinitions", cdk.listValidator(CfnGameServerGroup_InstanceDefinitionPropertyValidator))(properties.instanceDefinitions)), errors.collect(cdk.propertyValidator("launchTemplate", CfnGameServerGroup_LaunchTemplatePropertyValidator)(properties.launchTemplate)), errors.collect(cdk.propertyValidator("maxSize", cdk.validateNumber)(properties.maxSize)), errors.collect(cdk.propertyValidator("minSize", cdk.validateNumber)(properties.minSize)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpcSubnets", cdk.listValidator(cdk.validateString))(properties.vpcSubnets)), errors.wrap('supplied properties not correct for "CfnGameServerGroupProps"');
    }
    function cfnGameServerGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGameServerGroupPropsValidator(properties).assertSuccess(), { GameServerGroupName: cdk.stringToCloudFormation(properties.gameServerGroupName), InstanceDefinitions: cdk.listMapper(cfnGameServerGroupInstanceDefinitionPropertyToCloudFormation)(properties.instanceDefinitions), RoleArn: cdk.stringToCloudFormation(properties.roleArn), AutoScalingPolicy: cfnGameServerGroupAutoScalingPolicyPropertyToCloudFormation(properties.autoScalingPolicy), BalancingStrategy: cdk.stringToCloudFormation(properties.balancingStrategy), DeleteOption: cdk.stringToCloudFormation(properties.deleteOption), GameServerProtectionPolicy: cdk.stringToCloudFormation(properties.gameServerProtectionPolicy), LaunchTemplate: cfnGameServerGroupLaunchTemplatePropertyToCloudFormation(properties.launchTemplate), MaxSize: cdk.numberToCloudFormation(properties.maxSize), MinSize: cdk.numberToCloudFormation(properties.minSize), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VpcSubnets: cdk.listMapper(cdk.stringToCloudFormation)(properties.vpcSubnets) }) : properties;
    }
    function CfnGameServerGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("gameServerGroupName", "GameServerGroupName", cfn_parse.FromCloudFormation.getString(properties.GameServerGroupName)), ret.addPropertyResult("instanceDefinitions", "InstanceDefinitions", cfn_parse.FromCloudFormation.getArray(CfnGameServerGroupInstanceDefinitionPropertyFromCloudFormation)(properties.InstanceDefinitions)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("autoScalingPolicy", "AutoScalingPolicy", properties.AutoScalingPolicy != null ? CfnGameServerGroupAutoScalingPolicyPropertyFromCloudFormation(properties.AutoScalingPolicy) : void 0), ret.addPropertyResult("balancingStrategy", "BalancingStrategy", properties.BalancingStrategy != null ? cfn_parse.FromCloudFormation.getString(properties.BalancingStrategy) : void 0), ret.addPropertyResult("deleteOption", "DeleteOption", properties.DeleteOption != null ? cfn_parse.FromCloudFormation.getString(properties.DeleteOption) : void 0), ret.addPropertyResult("gameServerProtectionPolicy", "GameServerProtectionPolicy", properties.GameServerProtectionPolicy != null ? cfn_parse.FromCloudFormation.getString(properties.GameServerProtectionPolicy) : void 0), ret.addPropertyResult("launchTemplate", "LaunchTemplate", properties.LaunchTemplate != null ? CfnGameServerGroupLaunchTemplatePropertyFromCloudFormation(properties.LaunchTemplate) : void 0), ret.addPropertyResult("maxSize", "MaxSize", properties.MaxSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxSize) : void 0), ret.addPropertyResult("minSize", "MinSize", properties.MinSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinSize) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("vpcSubnets", "VpcSubnets", properties.VpcSubnets != null ? cfn_parse.FromCloudFormation.getStringArray(properties.VpcSubnets) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnGameServerGroup = class _CfnGameServerGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnGameServerGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnGameServerGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnGameServerGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_gamelift_CfnGameServerGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnGameServerGroup), error;
        }
        cdk.requireProperty(props, "gameServerGroupName", this), cdk.requireProperty(props, "instanceDefinitions", this), cdk.requireProperty(props, "roleArn", this), this.attrAutoScalingGroupArn = cdk.Token.asString(this.getAtt("AutoScalingGroupArn", cdk.ResolutionTypeHint.STRING)), this.attrGameServerGroupArn = cdk.Token.asString(this.getAtt("GameServerGroupArn", cdk.ResolutionTypeHint.STRING)), this.gameServerGroupName = props.gameServerGroupName, this.instanceDefinitions = props.instanceDefinitions, this.roleArn = props.roleArn, this.autoScalingPolicy = props.autoScalingPolicy, this.balancingStrategy = props.balancingStrategy, this.deleteOption = props.deleteOption, this.gameServerProtectionPolicy = props.gameServerProtectionPolicy, this.launchTemplate = props.launchTemplate, this.maxSize = props.maxSize, this.minSize = props.minSize, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::GameLift::GameServerGroup", props.tags, { tagPropertyName: "tags" }), this.vpcSubnets = props.vpcSubnets;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnGameServerGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { gameServerGroupName: this.gameServerGroupName, instanceDefinitions: this.instanceDefinitions, roleArn: this.roleArn, autoScalingPolicy: this.autoScalingPolicy, balancingStrategy: this.balancingStrategy, deleteOption: this.deleteOption, gameServerProtectionPolicy: this.gameServerProtectionPolicy, launchTemplate: this.launchTemplate, maxSize: this.maxSize, minSize: this.minSize, tags: this.tags.renderTags(), vpcSubnets: this.vpcSubnets };
      }
      renderProperties(props) {
        return cfnGameServerGroupPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnGameServerGroup[_d] = { fqn: "aws-cdk-lib.aws_gamelift.CfnGameServerGroup", version: "2.80.0" }, CfnGameServerGroup.CFN_RESOURCE_TYPE_NAME = "AWS::GameLift::GameServerGroup", exports2.CfnGameServerGroup = CfnGameServerGroup;
    function CfnGameServerGroup_AutoScalingPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("estimatedInstanceWarmup", cdk.validateNumber)(properties.estimatedInstanceWarmup)), errors.collect(cdk.propertyValidator("targetTrackingConfiguration", cdk.requiredValidator)(properties.targetTrackingConfiguration)), errors.collect(cdk.propertyValidator("targetTrackingConfiguration", CfnGameServerGroup_TargetTrackingConfigurationPropertyValidator)(properties.targetTrackingConfiguration)), errors.wrap('supplied properties not correct for "AutoScalingPolicyProperty"');
    }
    function cfnGameServerGroupAutoScalingPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGameServerGroup_AutoScalingPolicyPropertyValidator(properties).assertSuccess(), { EstimatedInstanceWarmup: cdk.numberToCloudFormation(properties.estimatedInstanceWarmup), TargetTrackingConfiguration: cfnGameServerGroupTargetTrackingConfigurationPropertyToCloudFormation(properties.targetTrackingConfiguration) }) : properties;
    }
    function CfnGameServerGroupAutoScalingPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("estimatedInstanceWarmup", "EstimatedInstanceWarmup", properties.EstimatedInstanceWarmup != null ? cfn_parse.FromCloudFormation.getNumber(properties.EstimatedInstanceWarmup) : void 0), ret.addPropertyResult("targetTrackingConfiguration", "TargetTrackingConfiguration", CfnGameServerGroupTargetTrackingConfigurationPropertyFromCloudFormation(properties.TargetTrackingConfiguration)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGameServerGroup_InstanceDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceType", cdk.requiredValidator)(properties.instanceType)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("weightedCapacity", cdk.validateString)(properties.weightedCapacity)), errors.wrap('supplied properties not correct for "InstanceDefinitionProperty"');
    }
    function cfnGameServerGroupInstanceDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGameServerGroup_InstanceDefinitionPropertyValidator(properties).assertSuccess(), { InstanceType: cdk.stringToCloudFormation(properties.instanceType), WeightedCapacity: cdk.stringToCloudFormation(properties.weightedCapacity) }) : properties;
    }
    function CfnGameServerGroupInstanceDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceType", "InstanceType", cfn_parse.FromCloudFormation.getString(properties.InstanceType)), ret.addPropertyResult("weightedCapacity", "WeightedCapacity", properties.WeightedCapacity != null ? cfn_parse.FromCloudFormation.getString(properties.WeightedCapacity) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGameServerGroup_LaunchTemplatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("launchTemplateId", cdk.validateString)(properties.launchTemplateId)), errors.collect(cdk.propertyValidator("launchTemplateName", cdk.validateString)(properties.launchTemplateName)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "LaunchTemplateProperty"');
    }
    function cfnGameServerGroupLaunchTemplatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGameServerGroup_LaunchTemplatePropertyValidator(properties).assertSuccess(), { LaunchTemplateId: cdk.stringToCloudFormation(properties.launchTemplateId), LaunchTemplateName: cdk.stringToCloudFormation(properties.launchTemplateName), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnGameServerGroupLaunchTemplatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("launchTemplateId", "LaunchTemplateId", properties.LaunchTemplateId != null ? cfn_parse.FromCloudFormation.getString(properties.LaunchTemplateId) : void 0), ret.addPropertyResult("launchTemplateName", "LaunchTemplateName", properties.LaunchTemplateName != null ? cfn_parse.FromCloudFormation.getString(properties.LaunchTemplateName) : void 0), ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getString(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGameServerGroup_TargetTrackingConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("targetValue", cdk.requiredValidator)(properties.targetValue)), errors.collect(cdk.propertyValidator("targetValue", cdk.validateNumber)(properties.targetValue)), errors.wrap('supplied properties not correct for "TargetTrackingConfigurationProperty"');
    }
    function cfnGameServerGroupTargetTrackingConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGameServerGroup_TargetTrackingConfigurationPropertyValidator(properties).assertSuccess(), { TargetValue: cdk.numberToCloudFormation(properties.targetValue) }) : properties;
    }
    function CfnGameServerGroupTargetTrackingConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("targetValue", "TargetValue", cfn_parse.FromCloudFormation.getNumber(properties.TargetValue)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGameSessionQueuePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customEventData", cdk.validateString)(properties.customEventData)), errors.collect(cdk.propertyValidator("destinations", cdk.listValidator(CfnGameSessionQueue_DestinationPropertyValidator))(properties.destinations)), errors.collect(cdk.propertyValidator("filterConfiguration", CfnGameSessionQueue_FilterConfigurationPropertyValidator)(properties.filterConfiguration)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("notificationTarget", cdk.validateString)(properties.notificationTarget)), errors.collect(cdk.propertyValidator("playerLatencyPolicies", cdk.listValidator(CfnGameSessionQueue_PlayerLatencyPolicyPropertyValidator))(properties.playerLatencyPolicies)), errors.collect(cdk.propertyValidator("priorityConfiguration", CfnGameSessionQueue_PriorityConfigurationPropertyValidator)(properties.priorityConfiguration)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("timeoutInSeconds", cdk.validateNumber)(properties.timeoutInSeconds)), errors.wrap('supplied properties not correct for "CfnGameSessionQueueProps"');
    }
    function cfnGameSessionQueuePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGameSessionQueuePropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), CustomEventData: cdk.stringToCloudFormation(properties.customEventData), Destinations: cdk.listMapper(cfnGameSessionQueueDestinationPropertyToCloudFormation)(properties.destinations), FilterConfiguration: cfnGameSessionQueueFilterConfigurationPropertyToCloudFormation(properties.filterConfiguration), NotificationTarget: cdk.stringToCloudFormation(properties.notificationTarget), PlayerLatencyPolicies: cdk.listMapper(cfnGameSessionQueuePlayerLatencyPolicyPropertyToCloudFormation)(properties.playerLatencyPolicies), PriorityConfiguration: cfnGameSessionQueuePriorityConfigurationPropertyToCloudFormation(properties.priorityConfiguration), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TimeoutInSeconds: cdk.numberToCloudFormation(properties.timeoutInSeconds) }) : properties;
    }
    function CfnGameSessionQueuePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("customEventData", "CustomEventData", properties.CustomEventData != null ? cfn_parse.FromCloudFormation.getString(properties.CustomEventData) : void 0), ret.addPropertyResult("destinations", "Destinations", properties.Destinations != null ? cfn_parse.FromCloudFormation.getArray(CfnGameSessionQueueDestinationPropertyFromCloudFormation)(properties.Destinations) : void 0), ret.addPropertyResult("filterConfiguration", "FilterConfiguration", properties.FilterConfiguration != null ? CfnGameSessionQueueFilterConfigurationPropertyFromCloudFormation(properties.FilterConfiguration) : void 0), ret.addPropertyResult("notificationTarget", "NotificationTarget", properties.NotificationTarget != null ? cfn_parse.FromCloudFormation.getString(properties.NotificationTarget) : void 0), ret.addPropertyResult("playerLatencyPolicies", "PlayerLatencyPolicies", properties.PlayerLatencyPolicies != null ? cfn_parse.FromCloudFormation.getArray(CfnGameSessionQueuePlayerLatencyPolicyPropertyFromCloudFormation)(properties.PlayerLatencyPolicies) : void 0), ret.addPropertyResult("priorityConfiguration", "PriorityConfiguration", properties.PriorityConfiguration != null ? CfnGameSessionQueuePriorityConfigurationPropertyFromCloudFormation(properties.PriorityConfiguration) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("timeoutInSeconds", "TimeoutInSeconds", properties.TimeoutInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.TimeoutInSeconds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnGameSessionQueue = class _CfnGameSessionQueue extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnGameSessionQueuePropsFromCloudFormation(resourceProperties), ret = new _CfnGameSessionQueue(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnGameSessionQueue.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_gamelift_CfnGameSessionQueueProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnGameSessionQueue), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.customEventData = props.customEventData, this.destinations = props.destinations, this.filterConfiguration = props.filterConfiguration, this.notificationTarget = props.notificationTarget, this.playerLatencyPolicies = props.playerLatencyPolicies, this.priorityConfiguration = props.priorityConfiguration, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::GameLift::GameSessionQueue", props.tags, { tagPropertyName: "tags" }), this.timeoutInSeconds = props.timeoutInSeconds;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnGameSessionQueue.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, customEventData: this.customEventData, destinations: this.destinations, filterConfiguration: this.filterConfiguration, notificationTarget: this.notificationTarget, playerLatencyPolicies: this.playerLatencyPolicies, priorityConfiguration: this.priorityConfiguration, tags: this.tags.renderTags(), timeoutInSeconds: this.timeoutInSeconds };
      }
      renderProperties(props) {
        return cfnGameSessionQueuePropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnGameSessionQueue[_e] = { fqn: "aws-cdk-lib.aws_gamelift.CfnGameSessionQueue", version: "2.80.0" }, CfnGameSessionQueue.CFN_RESOURCE_TYPE_NAME = "AWS::GameLift::GameSessionQueue", exports2.CfnGameSessionQueue = CfnGameSessionQueue;
    function CfnGameSessionQueue_DestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationArn", cdk.validateString)(properties.destinationArn)), errors.wrap('supplied properties not correct for "DestinationProperty"');
    }
    function cfnGameSessionQueueDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGameSessionQueue_DestinationPropertyValidator(properties).assertSuccess(), { DestinationArn: cdk.stringToCloudFormation(properties.destinationArn) }) : properties;
    }
    function CfnGameSessionQueueDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationArn", "DestinationArn", properties.DestinationArn != null ? cfn_parse.FromCloudFormation.getString(properties.DestinationArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGameSessionQueue_FilterConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowedLocations", cdk.listValidator(cdk.validateString))(properties.allowedLocations)), errors.wrap('supplied properties not correct for "FilterConfigurationProperty"');
    }
    function cfnGameSessionQueueFilterConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGameSessionQueue_FilterConfigurationPropertyValidator(properties).assertSuccess(), { AllowedLocations: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowedLocations) }) : properties;
    }
    function CfnGameSessionQueueFilterConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowedLocations", "AllowedLocations", properties.AllowedLocations != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AllowedLocations) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGameSessionQueue_PlayerLatencyPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maximumIndividualPlayerLatencyMilliseconds", cdk.validateNumber)(properties.maximumIndividualPlayerLatencyMilliseconds)), errors.collect(cdk.propertyValidator("policyDurationSeconds", cdk.validateNumber)(properties.policyDurationSeconds)), errors.wrap('supplied properties not correct for "PlayerLatencyPolicyProperty"');
    }
    function cfnGameSessionQueuePlayerLatencyPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGameSessionQueue_PlayerLatencyPolicyPropertyValidator(properties).assertSuccess(), { MaximumIndividualPlayerLatencyMilliseconds: cdk.numberToCloudFormation(properties.maximumIndividualPlayerLatencyMilliseconds), PolicyDurationSeconds: cdk.numberToCloudFormation(properties.policyDurationSeconds) }) : properties;
    }
    function CfnGameSessionQueuePlayerLatencyPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maximumIndividualPlayerLatencyMilliseconds", "MaximumIndividualPlayerLatencyMilliseconds", properties.MaximumIndividualPlayerLatencyMilliseconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumIndividualPlayerLatencyMilliseconds) : void 0), ret.addPropertyResult("policyDurationSeconds", "PolicyDurationSeconds", properties.PolicyDurationSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.PolicyDurationSeconds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGameSessionQueue_PriorityConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("locationOrder", cdk.listValidator(cdk.validateString))(properties.locationOrder)), errors.collect(cdk.propertyValidator("priorityOrder", cdk.listValidator(cdk.validateString))(properties.priorityOrder)), errors.wrap('supplied properties not correct for "PriorityConfigurationProperty"');
    }
    function cfnGameSessionQueuePriorityConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGameSessionQueue_PriorityConfigurationPropertyValidator(properties).assertSuccess(), { LocationOrder: cdk.listMapper(cdk.stringToCloudFormation)(properties.locationOrder), PriorityOrder: cdk.listMapper(cdk.stringToCloudFormation)(properties.priorityOrder) }) : properties;
    }
    function CfnGameSessionQueuePriorityConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("locationOrder", "LocationOrder", properties.LocationOrder != null ? cfn_parse.FromCloudFormation.getStringArray(properties.LocationOrder) : void 0), ret.addPropertyResult("priorityOrder", "PriorityOrder", properties.PriorityOrder != null ? cfn_parse.FromCloudFormation.getStringArray(properties.PriorityOrder) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLocationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("locationName", cdk.requiredValidator)(properties.locationName)), errors.collect(cdk.propertyValidator("locationName", cdk.validateString)(properties.locationName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnLocationProps"');
    }
    function cfnLocationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLocationPropsValidator(properties).assertSuccess(), { LocationName: cdk.stringToCloudFormation(properties.locationName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnLocationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("locationName", "LocationName", cfn_parse.FromCloudFormation.getString(properties.LocationName)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLocation = class _CfnLocation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLocationPropsFromCloudFormation(resourceProperties), ret = new _CfnLocation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLocation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_gamelift_CfnLocationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLocation), error;
        }
        cdk.requireProperty(props, "locationName", this), this.attrLocationArn = cdk.Token.asString(this.getAtt("LocationArn", cdk.ResolutionTypeHint.STRING)), this.locationName = props.locationName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::GameLift::Location", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLocation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { locationName: this.locationName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnLocationPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnLocation[_f] = { fqn: "aws-cdk-lib.aws_gamelift.CfnLocation", version: "2.80.0" }, CfnLocation.CFN_RESOURCE_TYPE_NAME = "AWS::GameLift::Location", exports2.CfnLocation = CfnLocation;
    function CfnMatchmakingConfigurationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acceptanceRequired", cdk.requiredValidator)(properties.acceptanceRequired)), errors.collect(cdk.propertyValidator("acceptanceRequired", cdk.validateBoolean)(properties.acceptanceRequired)), errors.collect(cdk.propertyValidator("acceptanceTimeoutSeconds", cdk.validateNumber)(properties.acceptanceTimeoutSeconds)), errors.collect(cdk.propertyValidator("additionalPlayerCount", cdk.validateNumber)(properties.additionalPlayerCount)), errors.collect(cdk.propertyValidator("backfillMode", cdk.validateString)(properties.backfillMode)), errors.collect(cdk.propertyValidator("customEventData", cdk.validateString)(properties.customEventData)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("flexMatchMode", cdk.validateString)(properties.flexMatchMode)), errors.collect(cdk.propertyValidator("gameProperties", cdk.listValidator(CfnMatchmakingConfiguration_GamePropertyPropertyValidator))(properties.gameProperties)), errors.collect(cdk.propertyValidator("gameSessionData", cdk.validateString)(properties.gameSessionData)), errors.collect(cdk.propertyValidator("gameSessionQueueArns", cdk.listValidator(cdk.validateString))(properties.gameSessionQueueArns)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("notificationTarget", cdk.validateString)(properties.notificationTarget)), errors.collect(cdk.propertyValidator("requestTimeoutSeconds", cdk.requiredValidator)(properties.requestTimeoutSeconds)), errors.collect(cdk.propertyValidator("requestTimeoutSeconds", cdk.validateNumber)(properties.requestTimeoutSeconds)), errors.collect(cdk.propertyValidator("ruleSetName", cdk.requiredValidator)(properties.ruleSetName)), errors.collect(cdk.propertyValidator("ruleSetName", cdk.validateString)(properties.ruleSetName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnMatchmakingConfigurationProps"');
    }
    function cfnMatchmakingConfigurationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMatchmakingConfigurationPropsValidator(properties).assertSuccess(), { AcceptanceRequired: cdk.booleanToCloudFormation(properties.acceptanceRequired), Name: cdk.stringToCloudFormation(properties.name), RequestTimeoutSeconds: cdk.numberToCloudFormation(properties.requestTimeoutSeconds), RuleSetName: cdk.stringToCloudFormation(properties.ruleSetName), AcceptanceTimeoutSeconds: cdk.numberToCloudFormation(properties.acceptanceTimeoutSeconds), AdditionalPlayerCount: cdk.numberToCloudFormation(properties.additionalPlayerCount), BackfillMode: cdk.stringToCloudFormation(properties.backfillMode), CustomEventData: cdk.stringToCloudFormation(properties.customEventData), Description: cdk.stringToCloudFormation(properties.description), FlexMatchMode: cdk.stringToCloudFormation(properties.flexMatchMode), GameProperties: cdk.listMapper(cfnMatchmakingConfigurationGamePropertyPropertyToCloudFormation)(properties.gameProperties), GameSessionData: cdk.stringToCloudFormation(properties.gameSessionData), GameSessionQueueArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.gameSessionQueueArns), NotificationTarget: cdk.stringToCloudFormation(properties.notificationTarget), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnMatchmakingConfigurationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("acceptanceRequired", "AcceptanceRequired", cfn_parse.FromCloudFormation.getBoolean(properties.AcceptanceRequired)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("requestTimeoutSeconds", "RequestTimeoutSeconds", cfn_parse.FromCloudFormation.getNumber(properties.RequestTimeoutSeconds)), ret.addPropertyResult("ruleSetName", "RuleSetName", cfn_parse.FromCloudFormation.getString(properties.RuleSetName)), ret.addPropertyResult("acceptanceTimeoutSeconds", "AcceptanceTimeoutSeconds", properties.AcceptanceTimeoutSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.AcceptanceTimeoutSeconds) : void 0), ret.addPropertyResult("additionalPlayerCount", "AdditionalPlayerCount", properties.AdditionalPlayerCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.AdditionalPlayerCount) : void 0), ret.addPropertyResult("backfillMode", "BackfillMode", properties.BackfillMode != null ? cfn_parse.FromCloudFormation.getString(properties.BackfillMode) : void 0), ret.addPropertyResult("customEventData", "CustomEventData", properties.CustomEventData != null ? cfn_parse.FromCloudFormation.getString(properties.CustomEventData) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("flexMatchMode", "FlexMatchMode", properties.FlexMatchMode != null ? cfn_parse.FromCloudFormation.getString(properties.FlexMatchMode) : void 0), ret.addPropertyResult("gameProperties", "GameProperties", properties.GameProperties != null ? cfn_parse.FromCloudFormation.getArray(CfnMatchmakingConfigurationGamePropertyPropertyFromCloudFormation)(properties.GameProperties) : void 0), ret.addPropertyResult("gameSessionData", "GameSessionData", properties.GameSessionData != null ? cfn_parse.FromCloudFormation.getString(properties.GameSessionData) : void 0), ret.addPropertyResult("gameSessionQueueArns", "GameSessionQueueArns", properties.GameSessionQueueArns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.GameSessionQueueArns) : void 0), ret.addPropertyResult("notificationTarget", "NotificationTarget", properties.NotificationTarget != null ? cfn_parse.FromCloudFormation.getString(properties.NotificationTarget) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnMatchmakingConfiguration = class _CfnMatchmakingConfiguration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnMatchmakingConfigurationPropsFromCloudFormation(resourceProperties), ret = new _CfnMatchmakingConfiguration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnMatchmakingConfiguration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_gamelift_CfnMatchmakingConfigurationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnMatchmakingConfiguration), error;
        }
        cdk.requireProperty(props, "acceptanceRequired", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "requestTimeoutSeconds", this), cdk.requireProperty(props, "ruleSetName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.acceptanceRequired = props.acceptanceRequired, this.name = props.name, this.requestTimeoutSeconds = props.requestTimeoutSeconds, this.ruleSetName = props.ruleSetName, this.acceptanceTimeoutSeconds = props.acceptanceTimeoutSeconds, this.additionalPlayerCount = props.additionalPlayerCount, this.backfillMode = props.backfillMode, this.customEventData = props.customEventData, this.description = props.description, this.flexMatchMode = props.flexMatchMode, this.gameProperties = props.gameProperties, this.gameSessionData = props.gameSessionData, this.gameSessionQueueArns = props.gameSessionQueueArns, this.notificationTarget = props.notificationTarget, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::GameLift::MatchmakingConfiguration", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnMatchmakingConfiguration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { acceptanceRequired: this.acceptanceRequired, name: this.name, requestTimeoutSeconds: this.requestTimeoutSeconds, ruleSetName: this.ruleSetName, acceptanceTimeoutSeconds: this.acceptanceTimeoutSeconds, additionalPlayerCount: this.additionalPlayerCount, backfillMode: this.backfillMode, customEventData: this.customEventData, description: this.description, flexMatchMode: this.flexMatchMode, gameProperties: this.gameProperties, gameSessionData: this.gameSessionData, gameSessionQueueArns: this.gameSessionQueueArns, notificationTarget: this.notificationTarget, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnMatchmakingConfigurationPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnMatchmakingConfiguration[_g] = { fqn: "aws-cdk-lib.aws_gamelift.CfnMatchmakingConfiguration", version: "2.80.0" }, CfnMatchmakingConfiguration.CFN_RESOURCE_TYPE_NAME = "AWS::GameLift::MatchmakingConfiguration", exports2.CfnMatchmakingConfiguration = CfnMatchmakingConfiguration;
    function CfnMatchmakingConfiguration_GamePropertyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "GamePropertyProperty"');
    }
    function cfnMatchmakingConfigurationGamePropertyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMatchmakingConfiguration_GamePropertyPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnMatchmakingConfigurationGamePropertyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMatchmakingRuleSetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("ruleSetBody", cdk.requiredValidator)(properties.ruleSetBody)), errors.collect(cdk.propertyValidator("ruleSetBody", cdk.validateString)(properties.ruleSetBody)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnMatchmakingRuleSetProps"');
    }
    function cfnMatchmakingRuleSetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMatchmakingRuleSetPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), RuleSetBody: cdk.stringToCloudFormation(properties.ruleSetBody), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnMatchmakingRuleSetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("ruleSetBody", "RuleSetBody", cfn_parse.FromCloudFormation.getString(properties.RuleSetBody)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnMatchmakingRuleSet = class _CfnMatchmakingRuleSet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnMatchmakingRuleSetPropsFromCloudFormation(resourceProperties), ret = new _CfnMatchmakingRuleSet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnMatchmakingRuleSet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_gamelift_CfnMatchmakingRuleSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnMatchmakingRuleSet), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "ruleSetBody", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.ruleSetBody = props.ruleSetBody, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::GameLift::MatchmakingRuleSet", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnMatchmakingRuleSet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, ruleSetBody: this.ruleSetBody, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnMatchmakingRuleSetPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnMatchmakingRuleSet[_h] = { fqn: "aws-cdk-lib.aws_gamelift.CfnMatchmakingRuleSet", version: "2.80.0" }, CfnMatchmakingRuleSet.CFN_RESOURCE_TYPE_NAME = "AWS::GameLift::MatchmakingRuleSet", exports2.CfnMatchmakingRuleSet = CfnMatchmakingRuleSet;
    function CfnScriptPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("storageLocation", cdk.requiredValidator)(properties.storageLocation)), errors.collect(cdk.propertyValidator("storageLocation", CfnScript_S3LocationPropertyValidator)(properties.storageLocation)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "CfnScriptProps"');
    }
    function cfnScriptPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScriptPropsValidator(properties).assertSuccess(), { StorageLocation: cfnScriptS3LocationPropertyToCloudFormation(properties.storageLocation), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnScriptPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("storageLocation", "StorageLocation", CfnScriptS3LocationPropertyFromCloudFormation(properties.StorageLocation)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getString(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnScript = class _CfnScript extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnScriptPropsFromCloudFormation(resourceProperties), ret = new _CfnScript(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnScript.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_gamelift_CfnScriptProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnScript), error;
        }
        cdk.requireProperty(props, "storageLocation", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.storageLocation = props.storageLocation, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::GameLift::Script", props.tags, { tagPropertyName: "tags" }), this.version = props.version;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnScript.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { storageLocation: this.storageLocation, name: this.name, tags: this.tags.renderTags(), version: this.version };
      }
      renderProperties(props) {
        return cfnScriptPropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnScript[_j] = { fqn: "aws-cdk-lib.aws_gamelift.CfnScript", version: "2.80.0" }, CfnScript.CFN_RESOURCE_TYPE_NAME = "AWS::GameLift::Script", exports2.CfnScript = CfnScript;
    function CfnScript_S3LocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.requiredValidator)(properties.bucket)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("objectVersion", cdk.validateString)(properties.objectVersion)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "S3LocationProperty"');
    }
    function cfnScriptS3LocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScript_S3LocationPropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), Key: cdk.stringToCloudFormation(properties.key), ObjectVersion: cdk.stringToCloudFormation(properties.objectVersion), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnScriptS3LocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", cfn_parse.FromCloudFormation.getString(properties.Bucket)), ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("objectVersion", "ObjectVersion", properties.ObjectVersion != null ? cfn_parse.FromCloudFormation.getString(properties.ObjectVersion) : void 0), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-gamelift/lib/index.js
var require_lib134 = __commonJS({
  "node_modules/aws-cdk-lib/aws-gamelift/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_gamelift_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-gamelift/index.js
var require_aws_gamelift = __commonJS({
  "node_modules/aws-cdk-lib/aws-gamelift/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib134(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-globalaccelerator/lib/globalaccelerator.generated.js
var require_globalaccelerator_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-globalaccelerator/lib/globalaccelerator.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnListener = exports2.CfnEndpointGroup = exports2.CfnAccelerator = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAcceleratorPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("ipAddressType", cdk.validateString)(properties.ipAddressType)), errors.collect(cdk.propertyValidator("ipAddresses", cdk.listValidator(cdk.validateString))(properties.ipAddresses)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnAcceleratorProps"');
    }
    function cfnAcceleratorPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAcceleratorPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Enabled: cdk.booleanToCloudFormation(properties.enabled), IpAddresses: cdk.listMapper(cdk.stringToCloudFormation)(properties.ipAddresses), IpAddressType: cdk.stringToCloudFormation(properties.ipAddressType), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnAcceleratorPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("ipAddresses", "IpAddresses", properties.IpAddresses != null ? cfn_parse.FromCloudFormation.getStringArray(properties.IpAddresses) : void 0), ret.addPropertyResult("ipAddressType", "IpAddressType", properties.IpAddressType != null ? cfn_parse.FromCloudFormation.getString(properties.IpAddressType) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAccelerator = class _CfnAccelerator extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAcceleratorPropsFromCloudFormation(resourceProperties), ret = new _CfnAccelerator(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAccelerator.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_globalaccelerator_CfnAcceleratorProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAccelerator), error;
        }
        cdk.requireProperty(props, "name", this), this.attrAcceleratorArn = cdk.Token.asString(this.getAtt("AcceleratorArn", cdk.ResolutionTypeHint.STRING)), this.attrDnsName = cdk.Token.asString(this.getAtt("DnsName", cdk.ResolutionTypeHint.STRING)), this.attrDualStackDnsName = cdk.Token.asString(this.getAtt("DualStackDnsName", cdk.ResolutionTypeHint.STRING)), this.attrIpv4Addresses = cdk.Token.asList(this.getAtt("Ipv4Addresses", cdk.ResolutionTypeHint.STRING_LIST)), this.attrIpv6Addresses = cdk.Token.asList(this.getAtt("Ipv6Addresses", cdk.ResolutionTypeHint.STRING_LIST)), this.name = props.name, this.enabled = props.enabled, this.ipAddresses = props.ipAddresses, this.ipAddressType = props.ipAddressType, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::GlobalAccelerator::Accelerator", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAccelerator.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, enabled: this.enabled, ipAddresses: this.ipAddresses, ipAddressType: this.ipAddressType, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnAcceleratorPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAccelerator[_a] = { fqn: "aws-cdk-lib.aws_globalaccelerator.CfnAccelerator", version: "2.80.0" }, CfnAccelerator.CFN_RESOURCE_TYPE_NAME = "AWS::GlobalAccelerator::Accelerator", exports2.CfnAccelerator = CfnAccelerator;
    function CfnEndpointGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endpointConfigurations", cdk.listValidator(CfnEndpointGroup_EndpointConfigurationPropertyValidator))(properties.endpointConfigurations)), errors.collect(cdk.propertyValidator("endpointGroupRegion", cdk.requiredValidator)(properties.endpointGroupRegion)), errors.collect(cdk.propertyValidator("endpointGroupRegion", cdk.validateString)(properties.endpointGroupRegion)), errors.collect(cdk.propertyValidator("healthCheckIntervalSeconds", cdk.validateNumber)(properties.healthCheckIntervalSeconds)), errors.collect(cdk.propertyValidator("healthCheckPath", cdk.validateString)(properties.healthCheckPath)), errors.collect(cdk.propertyValidator("healthCheckPort", cdk.validateNumber)(properties.healthCheckPort)), errors.collect(cdk.propertyValidator("healthCheckProtocol", cdk.validateString)(properties.healthCheckProtocol)), errors.collect(cdk.propertyValidator("listenerArn", cdk.requiredValidator)(properties.listenerArn)), errors.collect(cdk.propertyValidator("listenerArn", cdk.validateString)(properties.listenerArn)), errors.collect(cdk.propertyValidator("portOverrides", cdk.listValidator(CfnEndpointGroup_PortOverridePropertyValidator))(properties.portOverrides)), errors.collect(cdk.propertyValidator("thresholdCount", cdk.validateNumber)(properties.thresholdCount)), errors.collect(cdk.propertyValidator("trafficDialPercentage", cdk.validateNumber)(properties.trafficDialPercentage)), errors.wrap('supplied properties not correct for "CfnEndpointGroupProps"');
    }
    function cfnEndpointGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpointGroupPropsValidator(properties).assertSuccess(), { EndpointGroupRegion: cdk.stringToCloudFormation(properties.endpointGroupRegion), ListenerArn: cdk.stringToCloudFormation(properties.listenerArn), EndpointConfigurations: cdk.listMapper(cfnEndpointGroupEndpointConfigurationPropertyToCloudFormation)(properties.endpointConfigurations), HealthCheckIntervalSeconds: cdk.numberToCloudFormation(properties.healthCheckIntervalSeconds), HealthCheckPath: cdk.stringToCloudFormation(properties.healthCheckPath), HealthCheckPort: cdk.numberToCloudFormation(properties.healthCheckPort), HealthCheckProtocol: cdk.stringToCloudFormation(properties.healthCheckProtocol), PortOverrides: cdk.listMapper(cfnEndpointGroupPortOverridePropertyToCloudFormation)(properties.portOverrides), ThresholdCount: cdk.numberToCloudFormation(properties.thresholdCount), TrafficDialPercentage: cdk.numberToCloudFormation(properties.trafficDialPercentage) }) : properties;
    }
    function CfnEndpointGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endpointGroupRegion", "EndpointGroupRegion", cfn_parse.FromCloudFormation.getString(properties.EndpointGroupRegion)), ret.addPropertyResult("listenerArn", "ListenerArn", cfn_parse.FromCloudFormation.getString(properties.ListenerArn)), ret.addPropertyResult("endpointConfigurations", "EndpointConfigurations", properties.EndpointConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnEndpointGroupEndpointConfigurationPropertyFromCloudFormation)(properties.EndpointConfigurations) : void 0), ret.addPropertyResult("healthCheckIntervalSeconds", "HealthCheckIntervalSeconds", properties.HealthCheckIntervalSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.HealthCheckIntervalSeconds) : void 0), ret.addPropertyResult("healthCheckPath", "HealthCheckPath", properties.HealthCheckPath != null ? cfn_parse.FromCloudFormation.getString(properties.HealthCheckPath) : void 0), ret.addPropertyResult("healthCheckPort", "HealthCheckPort", properties.HealthCheckPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.HealthCheckPort) : void 0), ret.addPropertyResult("healthCheckProtocol", "HealthCheckProtocol", properties.HealthCheckProtocol != null ? cfn_parse.FromCloudFormation.getString(properties.HealthCheckProtocol) : void 0), ret.addPropertyResult("portOverrides", "PortOverrides", properties.PortOverrides != null ? cfn_parse.FromCloudFormation.getArray(CfnEndpointGroupPortOverridePropertyFromCloudFormation)(properties.PortOverrides) : void 0), ret.addPropertyResult("thresholdCount", "ThresholdCount", properties.ThresholdCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.ThresholdCount) : void 0), ret.addPropertyResult("trafficDialPercentage", "TrafficDialPercentage", properties.TrafficDialPercentage != null ? cfn_parse.FromCloudFormation.getNumber(properties.TrafficDialPercentage) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEndpointGroup = class _CfnEndpointGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEndpointGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnEndpointGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEndpointGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_globalaccelerator_CfnEndpointGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEndpointGroup), error;
        }
        cdk.requireProperty(props, "endpointGroupRegion", this), cdk.requireProperty(props, "listenerArn", this), this.attrEndpointGroupArn = cdk.Token.asString(this.getAtt("EndpointGroupArn", cdk.ResolutionTypeHint.STRING)), this.endpointGroupRegion = props.endpointGroupRegion, this.listenerArn = props.listenerArn, this.endpointConfigurations = props.endpointConfigurations, this.healthCheckIntervalSeconds = props.healthCheckIntervalSeconds, this.healthCheckPath = props.healthCheckPath, this.healthCheckPort = props.healthCheckPort, this.healthCheckProtocol = props.healthCheckProtocol, this.portOverrides = props.portOverrides, this.thresholdCount = props.thresholdCount, this.trafficDialPercentage = props.trafficDialPercentage;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEndpointGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { endpointGroupRegion: this.endpointGroupRegion, listenerArn: this.listenerArn, endpointConfigurations: this.endpointConfigurations, healthCheckIntervalSeconds: this.healthCheckIntervalSeconds, healthCheckPath: this.healthCheckPath, healthCheckPort: this.healthCheckPort, healthCheckProtocol: this.healthCheckProtocol, portOverrides: this.portOverrides, thresholdCount: this.thresholdCount, trafficDialPercentage: this.trafficDialPercentage };
      }
      renderProperties(props) {
        return cfnEndpointGroupPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnEndpointGroup[_b] = { fqn: "aws-cdk-lib.aws_globalaccelerator.CfnEndpointGroup", version: "2.80.0" }, CfnEndpointGroup.CFN_RESOURCE_TYPE_NAME = "AWS::GlobalAccelerator::EndpointGroup", exports2.CfnEndpointGroup = CfnEndpointGroup;
    function CfnEndpointGroup_EndpointConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clientIpPreservationEnabled", cdk.validateBoolean)(properties.clientIpPreservationEnabled)), errors.collect(cdk.propertyValidator("endpointId", cdk.requiredValidator)(properties.endpointId)), errors.collect(cdk.propertyValidator("endpointId", cdk.validateString)(properties.endpointId)), errors.collect(cdk.propertyValidator("weight", cdk.validateNumber)(properties.weight)), errors.wrap('supplied properties not correct for "EndpointConfigurationProperty"');
    }
    function cfnEndpointGroupEndpointConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpointGroup_EndpointConfigurationPropertyValidator(properties).assertSuccess(), { ClientIPPreservationEnabled: cdk.booleanToCloudFormation(properties.clientIpPreservationEnabled), EndpointId: cdk.stringToCloudFormation(properties.endpointId), Weight: cdk.numberToCloudFormation(properties.weight) }) : properties;
    }
    function CfnEndpointGroupEndpointConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clientIpPreservationEnabled", "ClientIPPreservationEnabled", properties.ClientIPPreservationEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ClientIPPreservationEnabled) : void 0), ret.addPropertyResult("endpointId", "EndpointId", cfn_parse.FromCloudFormation.getString(properties.EndpointId)), ret.addPropertyResult("weight", "Weight", properties.Weight != null ? cfn_parse.FromCloudFormation.getNumber(properties.Weight) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpointGroup_PortOverridePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endpointPort", cdk.requiredValidator)(properties.endpointPort)), errors.collect(cdk.propertyValidator("endpointPort", cdk.validateNumber)(properties.endpointPort)), errors.collect(cdk.propertyValidator("listenerPort", cdk.requiredValidator)(properties.listenerPort)), errors.collect(cdk.propertyValidator("listenerPort", cdk.validateNumber)(properties.listenerPort)), errors.wrap('supplied properties not correct for "PortOverrideProperty"');
    }
    function cfnEndpointGroupPortOverridePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpointGroup_PortOverridePropertyValidator(properties).assertSuccess(), { EndpointPort: cdk.numberToCloudFormation(properties.endpointPort), ListenerPort: cdk.numberToCloudFormation(properties.listenerPort) }) : properties;
    }
    function CfnEndpointGroupPortOverridePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endpointPort", "EndpointPort", cfn_parse.FromCloudFormation.getNumber(properties.EndpointPort)), ret.addPropertyResult("listenerPort", "ListenerPort", cfn_parse.FromCloudFormation.getNumber(properties.ListenerPort)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnListenerPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acceleratorArn", cdk.requiredValidator)(properties.acceleratorArn)), errors.collect(cdk.propertyValidator("acceleratorArn", cdk.validateString)(properties.acceleratorArn)), errors.collect(cdk.propertyValidator("clientAffinity", cdk.validateString)(properties.clientAffinity)), errors.collect(cdk.propertyValidator("portRanges", cdk.requiredValidator)(properties.portRanges)), errors.collect(cdk.propertyValidator("portRanges", cdk.listValidator(CfnListener_PortRangePropertyValidator))(properties.portRanges)), errors.collect(cdk.propertyValidator("protocol", cdk.requiredValidator)(properties.protocol)), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.wrap('supplied properties not correct for "CfnListenerProps"');
    }
    function cfnListenerPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListenerPropsValidator(properties).assertSuccess(), { AcceleratorArn: cdk.stringToCloudFormation(properties.acceleratorArn), PortRanges: cdk.listMapper(cfnListenerPortRangePropertyToCloudFormation)(properties.portRanges), Protocol: cdk.stringToCloudFormation(properties.protocol), ClientAffinity: cdk.stringToCloudFormation(properties.clientAffinity) }) : properties;
    }
    function CfnListenerPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("acceleratorArn", "AcceleratorArn", cfn_parse.FromCloudFormation.getString(properties.AcceleratorArn)), ret.addPropertyResult("portRanges", "PortRanges", cfn_parse.FromCloudFormation.getArray(CfnListenerPortRangePropertyFromCloudFormation)(properties.PortRanges)), ret.addPropertyResult("protocol", "Protocol", cfn_parse.FromCloudFormation.getString(properties.Protocol)), ret.addPropertyResult("clientAffinity", "ClientAffinity", properties.ClientAffinity != null ? cfn_parse.FromCloudFormation.getString(properties.ClientAffinity) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnListener = class _CfnListener extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnListenerPropsFromCloudFormation(resourceProperties), ret = new _CfnListener(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnListener.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_globalaccelerator_CfnListenerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnListener), error;
        }
        cdk.requireProperty(props, "acceleratorArn", this), cdk.requireProperty(props, "portRanges", this), cdk.requireProperty(props, "protocol", this), this.attrListenerArn = cdk.Token.asString(this.getAtt("ListenerArn", cdk.ResolutionTypeHint.STRING)), this.acceleratorArn = props.acceleratorArn, this.portRanges = props.portRanges, this.protocol = props.protocol, this.clientAffinity = props.clientAffinity;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnListener.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { acceleratorArn: this.acceleratorArn, portRanges: this.portRanges, protocol: this.protocol, clientAffinity: this.clientAffinity };
      }
      renderProperties(props) {
        return cfnListenerPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnListener[_c] = { fqn: "aws-cdk-lib.aws_globalaccelerator.CfnListener", version: "2.80.0" }, CfnListener.CFN_RESOURCE_TYPE_NAME = "AWS::GlobalAccelerator::Listener", exports2.CfnListener = CfnListener;
    function CfnListener_PortRangePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fromPort", cdk.requiredValidator)(properties.fromPort)), errors.collect(cdk.propertyValidator("fromPort", cdk.validateNumber)(properties.fromPort)), errors.collect(cdk.propertyValidator("toPort", cdk.requiredValidator)(properties.toPort)), errors.collect(cdk.propertyValidator("toPort", cdk.validateNumber)(properties.toPort)), errors.wrap('supplied properties not correct for "PortRangeProperty"');
    }
    function cfnListenerPortRangePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListener_PortRangePropertyValidator(properties).assertSuccess(), { FromPort: cdk.numberToCloudFormation(properties.fromPort), ToPort: cdk.numberToCloudFormation(properties.toPort) }) : properties;
    }
    function CfnListenerPortRangePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fromPort", "FromPort", cfn_parse.FromCloudFormation.getNumber(properties.FromPort)), ret.addPropertyResult("toPort", "ToPort", cfn_parse.FromCloudFormation.getNumber(properties.ToPort)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-globalaccelerator/lib/_accelerator-security-group.js
var require_accelerator_security_group = __commonJS({
  "node_modules/aws-cdk-lib/aws-globalaccelerator/lib/_accelerator-security-group.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AcceleratorSecurityGroupPeer = void 0;
    var ec2 = require_aws_ec2();
    var custom_resources_1 = require_custom_resources();
    var AcceleratorSecurityGroupPeer = class _AcceleratorSecurityGroupPeer {
      static fromVpc(scope, id, vpc, endpointGroup) {
        const globalAcceleratorSGName = "GlobalAccelerator", ec2ResponseSGIdField = "SecurityGroups.0.GroupId", lookupAcceleratorSGCustomResource = new custom_resources_1.AwsCustomResource(scope, id + "CustomResource", { onCreate: { service: "EC2", action: "describeSecurityGroups", parameters: { Filters: [{ Name: "group-name", Values: [globalAcceleratorSGName] }, { Name: "vpc-id", Values: [vpc.vpcId] }] }, physicalResourceId: custom_resources_1.PhysicalResourceId.fromResponse(ec2ResponseSGIdField) }, policy: custom_resources_1.AwsCustomResourcePolicy.fromSdkCalls({ resources: custom_resources_1.AwsCustomResourcePolicy.ANY_RESOURCE }), installLatestAwsSdk: false });
        return lookupAcceleratorSGCustomResource.node.addDependency(endpointGroup.node.defaultChild), new _AcceleratorSecurityGroupPeer(lookupAcceleratorSGCustomResource.getResponseField(ec2ResponseSGIdField));
      }
      constructor(securityGroupId) {
        this.securityGroupId = securityGroupId, this.canInlineRule = false, this.connections = new ec2.Connections({ peer: this }), this.uniqueId = "GlobalAcceleratorGroup";
      }
      toIngressRuleConfig() {
        return { sourceSecurityGroupId: this.securityGroupId };
      }
      toEgressRuleConfig() {
        return { destinationSecurityGroupId: this.securityGroupId };
      }
    };
    exports2.AcceleratorSecurityGroupPeer = AcceleratorSecurityGroupPeer;
  }
});

// node_modules/aws-cdk-lib/aws-globalaccelerator/lib/endpoint-group.js
var require_endpoint_group = __commonJS({
  "node_modules/aws-cdk-lib/aws-globalaccelerator/lib/endpoint-group.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EndpointGroup = exports2.HealthCheckProtocol = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var _accelerator_security_group_1 = require_accelerator_security_group();
    var ga = require_globalaccelerator_generated();
    var cdk = require_core2();
    var HealthCheckProtocol;
    (function(HealthCheckProtocol2) {
      HealthCheckProtocol2.TCP = "TCP", HealthCheckProtocol2.HTTP = "HTTP", HealthCheckProtocol2.HTTPS = "HTTPS";
    })(HealthCheckProtocol = exports2.HealthCheckProtocol || (exports2.HealthCheckProtocol = {}));
    var EndpointGroup = class _EndpointGroup extends cdk.Resource {
      static fromEndpointGroupArn(scope, id, endpointGroupArn) {
        class Import extends cdk.Resource {
          constructor() {
            super(...arguments), this.endpointGroupArn = endpointGroupArn;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id), this.endpoints = new Array();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_globalaccelerator_EndpointGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EndpointGroup), error;
        }
        const resource = new ga.CfnEndpointGroup(this, "Resource", { listenerArn: props.listener.listenerArn, endpointGroupRegion: props.region ?? cdk.Lazy.string({ produce: () => this.firstEndpointRegion() }), endpointConfigurations: cdk.Lazy.any({ produce: () => this.renderEndpoints() }, { omitEmptyArray: true }), healthCheckIntervalSeconds: props.healthCheckInterval?.toSeconds({ integral: true }), healthCheckPath: props.healthCheckPath, healthCheckPort: props.healthCheckPort, healthCheckProtocol: props.healthCheckProtocol, thresholdCount: props.healthCheckThreshold, trafficDialPercentage: props.trafficDialPercentage, portOverrides: props.portOverrides?.map((o) => ({ endpointPort: o.endpointPort, listenerPort: o.listenerPort })) });
        this.endpointGroupArn = resource.attrEndpointGroupArn, this.endpointGroupName = props.endpointGroupName ?? resource.logicalId;
        for (const endpoint of props.endpoints ?? [])
          this.addEndpoint(endpoint);
      }
      addEndpoint(endpoint) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_globalaccelerator_IEndpoint(endpoint);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addEndpoint), error;
        }
        this.endpoints.push(endpoint);
      }
      connectionsPeer(id, vpc) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_IVpc(vpc);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.connectionsPeer), error;
        }
        return _accelerator_security_group_1.AcceleratorSecurityGroupPeer.fromVpc(this, id, vpc, this);
      }
      renderEndpoints() {
        return this.endpoints.map((e) => e.renderEndpointConfiguration());
      }
      firstEndpointRegion() {
        for (const endpoint of this.endpoints)
          if (endpoint.region)
            return endpoint.region;
        return cdk.Stack.of(this).region;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EndpointGroup[_a] = { fqn: "aws-cdk-lib.aws_globalaccelerator.EndpointGroup", version: "2.80.0" }, exports2.EndpointGroup = EndpointGroup;
  }
});

// node_modules/aws-cdk-lib/aws-globalaccelerator/lib/listener.js
var require_listener = __commonJS({
  "node_modules/aws-cdk-lib/aws-globalaccelerator/lib/listener.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Listener = exports2.ClientAffinity = exports2.ConnectionProtocol = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var endpoint_group_1 = require_endpoint_group();
    var ga = require_globalaccelerator_generated();
    var cdk = require_core2();
    var ConnectionProtocol;
    (function(ConnectionProtocol2) {
      ConnectionProtocol2.TCP = "TCP", ConnectionProtocol2.UDP = "UDP";
    })(ConnectionProtocol = exports2.ConnectionProtocol || (exports2.ConnectionProtocol = {}));
    var ClientAffinity;
    (function(ClientAffinity2) {
      ClientAffinity2.NONE = "NONE", ClientAffinity2.SOURCE_IP = "SOURCE_IP";
    })(ClientAffinity = exports2.ClientAffinity || (exports2.ClientAffinity = {}));
    var Listener = class _Listener extends cdk.Resource {
      static fromListenerArn(scope, id, listenerArn) {
        class Import extends cdk.Resource {
          constructor() {
            super(...arguments), this.listenerArn = listenerArn;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_globalaccelerator_ListenerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Listener), error;
        }
        const resource = new ga.CfnListener(this, "Resource", { acceleratorArn: props.accelerator.acceleratorArn, portRanges: props.portRanges.map((m) => ({ fromPort: m.fromPort, toPort: m.toPort ?? m.fromPort })), protocol: props.protocol ?? ConnectionProtocol.TCP, clientAffinity: props.clientAffinity ?? ClientAffinity.NONE });
        this.listenerArn = resource.attrListenerArn, this.listenerName = props.listenerName ?? resource.logicalId;
      }
      addEndpointGroup(id, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_globalaccelerator_EndpointGroupOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addEndpointGroup), error;
        }
        return new endpoint_group_1.EndpointGroup(this, id, { listener: this, ...options });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Listener[_a] = { fqn: "aws-cdk-lib.aws_globalaccelerator.Listener", version: "2.80.0" }, exports2.Listener = Listener;
  }
});

// node_modules/aws-cdk-lib/aws-globalaccelerator/lib/accelerator.js
var require_accelerator = __commonJS({
  "node_modules/aws-cdk-lib/aws-globalaccelerator/lib/accelerator.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Accelerator = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var ga = require_globalaccelerator_generated();
    var listener_1 = require_listener();
    var cdk = require_core2();
    var Accelerator = class _Accelerator extends cdk.Resource {
      static fromAcceleratorAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_globalaccelerator_AcceleratorAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromAcceleratorAttributes), error;
        }
        class Import extends cdk.Resource {
          constructor() {
            super(...arguments), this.acceleratorArn = attrs.acceleratorArn, this.dnsName = attrs.dnsName;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props = {}) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_globalaccelerator_AcceleratorProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Accelerator), error;
        }
        this.validateAcceleratorName(props.acceleratorName);
        const name = props.acceleratorName ?? cdk.Names.uniqueResourceName(this, { maxLength: 64 }), resource = new ga.CfnAccelerator(this, "Resource", { enabled: props.enabled ?? true, name });
        this.acceleratorArn = resource.attrAcceleratorArn, this.dnsName = resource.attrDnsName;
      }
      addListener(id, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_globalaccelerator_ListenerOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addListener), error;
        }
        return new listener_1.Listener(this, id, { accelerator: this, ...options });
      }
      validateAcceleratorName(name) {
        if (!cdk.Token.isUnresolved(name) && name !== void 0 && (name.length < 1 || name.length > 64))
          throw new Error(`Invalid acceleratorName value ${name}, must have length between 1 and 64, got: ${name.length}`);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Accelerator[_a] = { fqn: "aws-cdk-lib.aws_globalaccelerator.Accelerator", version: "2.80.0" }, exports2.Accelerator = Accelerator;
  }
});

// node_modules/aws-cdk-lib/aws-globalaccelerator/lib/endpoint.js
var require_endpoint3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-globalaccelerator/lib/endpoint.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.RawEndpoint = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var RawEndpoint = class _RawEndpoint {
      constructor(props) {
        this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_globalaccelerator_RawEndpointProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _RawEndpoint), error;
        }
        this.region = props.region;
      }
      renderEndpointConfiguration() {
        return { endpointId: this.props.endpointId, weight: this.props.weight, clientIpPreservationEnabled: this.props.preserveClientIp };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, RawEndpoint[_a] = { fqn: "aws-cdk-lib.aws_globalaccelerator.RawEndpoint", version: "2.80.0" }, exports2.RawEndpoint = RawEndpoint;
  }
});

// node_modules/aws-cdk-lib/aws-globalaccelerator/lib/index.js
var require_lib135 = __commonJS({
  "node_modules/aws-cdk-lib/aws-globalaccelerator/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_globalaccelerator_generated(), exports2), __exportStar(require_accelerator(), exports2), __exportStar(require_listener(), exports2), __exportStar(require_endpoint_group(), exports2), __exportStar(require_endpoint3(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-globalaccelerator/index.js
var require_aws_globalaccelerator = __commonJS({
  "node_modules/aws-cdk-lib/aws-globalaccelerator/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib135(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-globalaccelerator-endpoints/lib/_util.js
var require_util18 = __commonJS({
  "node_modules/aws-cdk-lib/aws-globalaccelerator-endpoints/lib/_util.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.validateWeight = void 0;
    var core_1 = require_core2();
    function validateWeight(x) {
      if (x !== void 0 && !core_1.Token.isUnresolved(x) && (x < 0 || x > 255))
        throw new Error(`'weight' must be between 0 and 255, got: ${x}`);
    }
    exports2.validateWeight = validateWeight;
  }
});

// node_modules/aws-cdk-lib/aws-globalaccelerator-endpoints/lib/alb.js
var require_alb = __commonJS({
  "node_modules/aws-cdk-lib/aws-globalaccelerator-endpoints/lib/alb.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ApplicationLoadBalancerEndpoint = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var _util_1 = require_util18();
    var ApplicationLoadBalancerEndpoint = class _ApplicationLoadBalancerEndpoint {
      constructor(loadBalancer, options = {}) {
        this.loadBalancer = loadBalancer, this.options = options;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_IApplicationLoadBalancer(loadBalancer), jsiiDeprecationWarnings.aws_cdk_lib_aws_globalaccelerator_endpoints_ApplicationLoadBalancerEndpointOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ApplicationLoadBalancerEndpoint), error;
        }
        (0, _util_1.validateWeight)(options.weight), this.region = loadBalancer.env.region;
      }
      renderEndpointConfiguration() {
        return { endpointId: this.loadBalancer.loadBalancerArn, weight: this.options.weight, clientIpPreservationEnabled: this.options.preserveClientIp };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ApplicationLoadBalancerEndpoint[_a] = { fqn: "aws-cdk-lib.aws_globalaccelerator_endpoints.ApplicationLoadBalancerEndpoint", version: "2.80.0" }, exports2.ApplicationLoadBalancerEndpoint = ApplicationLoadBalancerEndpoint;
  }
});

// node_modules/aws-cdk-lib/aws-globalaccelerator-endpoints/lib/nlb.js
var require_nlb = __commonJS({
  "node_modules/aws-cdk-lib/aws-globalaccelerator-endpoints/lib/nlb.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.NetworkLoadBalancerEndpoint = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var _util_1 = require_util18();
    var NetworkLoadBalancerEndpoint = class _NetworkLoadBalancerEndpoint {
      constructor(loadBalancer, options = {}) {
        this.loadBalancer = loadBalancer, this.options = options;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_elasticloadbalancingv2_INetworkLoadBalancer(loadBalancer), jsiiDeprecationWarnings.aws_cdk_lib_aws_globalaccelerator_endpoints_NetworkLoadBalancerEndpointProps(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _NetworkLoadBalancerEndpoint), error;
        }
        (0, _util_1.validateWeight)(options.weight), this.region = loadBalancer.env.region;
      }
      renderEndpointConfiguration() {
        return { endpointId: this.loadBalancer.loadBalancerArn, weight: this.options.weight };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, NetworkLoadBalancerEndpoint[_a] = { fqn: "aws-cdk-lib.aws_globalaccelerator_endpoints.NetworkLoadBalancerEndpoint", version: "2.80.0" }, exports2.NetworkLoadBalancerEndpoint = NetworkLoadBalancerEndpoint;
  }
});

// node_modules/aws-cdk-lib/aws-globalaccelerator-endpoints/lib/instance.js
var require_instance5 = __commonJS({
  "node_modules/aws-cdk-lib/aws-globalaccelerator-endpoints/lib/instance.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.InstanceEndpoint = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var _util_1 = require_util18();
    var InstanceEndpoint = class _InstanceEndpoint {
      constructor(instance, options = {}) {
        this.instance = instance, this.options = options;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_IInstance(instance), jsiiDeprecationWarnings.aws_cdk_lib_aws_globalaccelerator_endpoints_InstanceEndpointProps(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _InstanceEndpoint), error;
        }
        (0, _util_1.validateWeight)(options.weight), this.region = instance.env.region;
      }
      renderEndpointConfiguration() {
        return { endpointId: this.instance.instanceId, weight: this.options.weight, clientIpPreservationEnabled: this.options.preserveClientIp };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, InstanceEndpoint[_a] = { fqn: "aws-cdk-lib.aws_globalaccelerator_endpoints.InstanceEndpoint", version: "2.80.0" }, exports2.InstanceEndpoint = InstanceEndpoint;
  }
});

// node_modules/aws-cdk-lib/aws-globalaccelerator-endpoints/lib/eip.js
var require_eip = __commonJS({
  "node_modules/aws-cdk-lib/aws-globalaccelerator-endpoints/lib/eip.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnEipEndpoint = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var _util_1 = require_util18();
    var core_1 = require_core2();
    var CfnEipEndpoint = class _CfnEipEndpoint {
      constructor(eip, options = {}) {
        this.eip = eip, this.options = options;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_CfnEIP(eip), jsiiDeprecationWarnings.aws_cdk_lib_aws_globalaccelerator_endpoints_CfnEipEndpointProps(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEipEndpoint), error;
        }
        (0, _util_1.validateWeight)(options.weight), this.region = core_1.Stack.of(eip).region;
      }
      renderEndpointConfiguration() {
        return { endpointId: this.eip.attrAllocationId, weight: this.options.weight };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnEipEndpoint[_a] = { fqn: "aws-cdk-lib.aws_globalaccelerator_endpoints.CfnEipEndpoint", version: "2.80.0" }, exports2.CfnEipEndpoint = CfnEipEndpoint;
  }
});

// node_modules/aws-cdk-lib/aws-globalaccelerator-endpoints/lib/index.js
var require_lib136 = __commonJS({
  "node_modules/aws-cdk-lib/aws-globalaccelerator-endpoints/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_alb(), exports2), __exportStar(require_nlb(), exports2), __exportStar(require_instance5(), exports2), __exportStar(require_eip(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-globalaccelerator-endpoints/index.js
var require_aws_globalaccelerator_endpoints = __commonJS({
  "node_modules/aws-cdk-lib/aws-globalaccelerator-endpoints/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib136(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-glue/lib/glue.generated.js
var require_glue_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-glue/lib/glue.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    var _l;
    var _m;
    var _o;
    var _p;
    var _q;
    var _r;
    var _s;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnWorkflow = exports2.CfnTrigger = exports2.CfnTable = exports2.CfnSecurityConfiguration = exports2.CfnSchemaVersionMetadata = exports2.CfnSchemaVersion = exports2.CfnSchema = exports2.CfnRegistry = exports2.CfnPartition = exports2.CfnMLTransform = exports2.CfnJob = exports2.CfnDevEndpoint = exports2.CfnDatabase = exports2.CfnDataCatalogEncryptionSettings = exports2.CfnCrawler = exports2.CfnConnection = exports2.CfnClassifier = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnClassifierPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("csvClassifier", CfnClassifier_CsvClassifierPropertyValidator)(properties.csvClassifier)), errors.collect(cdk.propertyValidator("grokClassifier", CfnClassifier_GrokClassifierPropertyValidator)(properties.grokClassifier)), errors.collect(cdk.propertyValidator("jsonClassifier", CfnClassifier_JsonClassifierPropertyValidator)(properties.jsonClassifier)), errors.collect(cdk.propertyValidator("xmlClassifier", CfnClassifier_XMLClassifierPropertyValidator)(properties.xmlClassifier)), errors.wrap('supplied properties not correct for "CfnClassifierProps"');
    }
    function cfnClassifierPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClassifierPropsValidator(properties).assertSuccess(), { CsvClassifier: cfnClassifierCsvClassifierPropertyToCloudFormation(properties.csvClassifier), GrokClassifier: cfnClassifierGrokClassifierPropertyToCloudFormation(properties.grokClassifier), JsonClassifier: cfnClassifierJsonClassifierPropertyToCloudFormation(properties.jsonClassifier), XMLClassifier: cfnClassifierXMLClassifierPropertyToCloudFormation(properties.xmlClassifier) }) : properties;
    }
    function CfnClassifierPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("csvClassifier", "CsvClassifier", properties.CsvClassifier != null ? CfnClassifierCsvClassifierPropertyFromCloudFormation(properties.CsvClassifier) : void 0), ret.addPropertyResult("grokClassifier", "GrokClassifier", properties.GrokClassifier != null ? CfnClassifierGrokClassifierPropertyFromCloudFormation(properties.GrokClassifier) : void 0), ret.addPropertyResult("jsonClassifier", "JsonClassifier", properties.JsonClassifier != null ? CfnClassifierJsonClassifierPropertyFromCloudFormation(properties.JsonClassifier) : void 0), ret.addPropertyResult("xmlClassifier", "XMLClassifier", properties.XMLClassifier != null ? CfnClassifierXMLClassifierPropertyFromCloudFormation(properties.XMLClassifier) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnClassifier = class _CfnClassifier extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnClassifierPropsFromCloudFormation(resourceProperties), ret = new _CfnClassifier(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnClassifier.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_glue_CfnClassifierProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnClassifier), error;
        }
        this.csvClassifier = props.csvClassifier, this.grokClassifier = props.grokClassifier, this.jsonClassifier = props.jsonClassifier, this.xmlClassifier = props.xmlClassifier;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnClassifier.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { csvClassifier: this.csvClassifier, grokClassifier: this.grokClassifier, jsonClassifier: this.jsonClassifier, xmlClassifier: this.xmlClassifier };
      }
      renderProperties(props) {
        return cfnClassifierPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnClassifier[_a] = { fqn: "aws-cdk-lib.aws_glue.CfnClassifier", version: "2.80.0" }, CfnClassifier.CFN_RESOURCE_TYPE_NAME = "AWS::Glue::Classifier", exports2.CfnClassifier = CfnClassifier;
    function CfnClassifier_CsvClassifierPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowSingleColumn", cdk.validateBoolean)(properties.allowSingleColumn)), errors.collect(cdk.propertyValidator("containsHeader", cdk.validateString)(properties.containsHeader)), errors.collect(cdk.propertyValidator("delimiter", cdk.validateString)(properties.delimiter)), errors.collect(cdk.propertyValidator("disableValueTrimming", cdk.validateBoolean)(properties.disableValueTrimming)), errors.collect(cdk.propertyValidator("header", cdk.listValidator(cdk.validateString))(properties.header)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("quoteSymbol", cdk.validateString)(properties.quoteSymbol)), errors.wrap('supplied properties not correct for "CsvClassifierProperty"');
    }
    function cfnClassifierCsvClassifierPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClassifier_CsvClassifierPropertyValidator(properties).assertSuccess(), { AllowSingleColumn: cdk.booleanToCloudFormation(properties.allowSingleColumn), ContainsHeader: cdk.stringToCloudFormation(properties.containsHeader), Delimiter: cdk.stringToCloudFormation(properties.delimiter), DisableValueTrimming: cdk.booleanToCloudFormation(properties.disableValueTrimming), Header: cdk.listMapper(cdk.stringToCloudFormation)(properties.header), Name: cdk.stringToCloudFormation(properties.name), QuoteSymbol: cdk.stringToCloudFormation(properties.quoteSymbol) }) : properties;
    }
    function CfnClassifierCsvClassifierPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowSingleColumn", "AllowSingleColumn", properties.AllowSingleColumn != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllowSingleColumn) : void 0), ret.addPropertyResult("containsHeader", "ContainsHeader", properties.ContainsHeader != null ? cfn_parse.FromCloudFormation.getString(properties.ContainsHeader) : void 0), ret.addPropertyResult("delimiter", "Delimiter", properties.Delimiter != null ? cfn_parse.FromCloudFormation.getString(properties.Delimiter) : void 0), ret.addPropertyResult("disableValueTrimming", "DisableValueTrimming", properties.DisableValueTrimming != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DisableValueTrimming) : void 0), ret.addPropertyResult("header", "Header", properties.Header != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Header) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("quoteSymbol", "QuoteSymbol", properties.QuoteSymbol != null ? cfn_parse.FromCloudFormation.getString(properties.QuoteSymbol) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnClassifier_GrokClassifierPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("classification", cdk.requiredValidator)(properties.classification)), errors.collect(cdk.propertyValidator("classification", cdk.validateString)(properties.classification)), errors.collect(cdk.propertyValidator("customPatterns", cdk.validateString)(properties.customPatterns)), errors.collect(cdk.propertyValidator("grokPattern", cdk.requiredValidator)(properties.grokPattern)), errors.collect(cdk.propertyValidator("grokPattern", cdk.validateString)(properties.grokPattern)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "GrokClassifierProperty"');
    }
    function cfnClassifierGrokClassifierPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClassifier_GrokClassifierPropertyValidator(properties).assertSuccess(), { Classification: cdk.stringToCloudFormation(properties.classification), CustomPatterns: cdk.stringToCloudFormation(properties.customPatterns), GrokPattern: cdk.stringToCloudFormation(properties.grokPattern), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnClassifierGrokClassifierPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("classification", "Classification", cfn_parse.FromCloudFormation.getString(properties.Classification)), ret.addPropertyResult("customPatterns", "CustomPatterns", properties.CustomPatterns != null ? cfn_parse.FromCloudFormation.getString(properties.CustomPatterns) : void 0), ret.addPropertyResult("grokPattern", "GrokPattern", cfn_parse.FromCloudFormation.getString(properties.GrokPattern)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnClassifier_JsonClassifierPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("jsonPath", cdk.requiredValidator)(properties.jsonPath)), errors.collect(cdk.propertyValidator("jsonPath", cdk.validateString)(properties.jsonPath)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "JsonClassifierProperty"');
    }
    function cfnClassifierJsonClassifierPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClassifier_JsonClassifierPropertyValidator(properties).assertSuccess(), { JsonPath: cdk.stringToCloudFormation(properties.jsonPath), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnClassifierJsonClassifierPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("jsonPath", "JsonPath", cfn_parse.FromCloudFormation.getString(properties.JsonPath)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnClassifier_XMLClassifierPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("classification", cdk.requiredValidator)(properties.classification)), errors.collect(cdk.propertyValidator("classification", cdk.validateString)(properties.classification)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("rowTag", cdk.requiredValidator)(properties.rowTag)), errors.collect(cdk.propertyValidator("rowTag", cdk.validateString)(properties.rowTag)), errors.wrap('supplied properties not correct for "XMLClassifierProperty"');
    }
    function cfnClassifierXMLClassifierPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClassifier_XMLClassifierPropertyValidator(properties).assertSuccess(), { Classification: cdk.stringToCloudFormation(properties.classification), Name: cdk.stringToCloudFormation(properties.name), RowTag: cdk.stringToCloudFormation(properties.rowTag) }) : properties;
    }
    function CfnClassifierXMLClassifierPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("classification", "Classification", cfn_parse.FromCloudFormation.getString(properties.Classification)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("rowTag", "RowTag", cfn_parse.FromCloudFormation.getString(properties.RowTag)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalogId", cdk.requiredValidator)(properties.catalogId)), errors.collect(cdk.propertyValidator("catalogId", cdk.validateString)(properties.catalogId)), errors.collect(cdk.propertyValidator("connectionInput", cdk.requiredValidator)(properties.connectionInput)), errors.collect(cdk.propertyValidator("connectionInput", CfnConnection_ConnectionInputPropertyValidator)(properties.connectionInput)), errors.wrap('supplied properties not correct for "CfnConnectionProps"');
    }
    function cfnConnectionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectionPropsValidator(properties).assertSuccess(), { CatalogId: cdk.stringToCloudFormation(properties.catalogId), ConnectionInput: cfnConnectionConnectionInputPropertyToCloudFormation(properties.connectionInput) }) : properties;
    }
    function CfnConnectionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalogId", "CatalogId", cfn_parse.FromCloudFormation.getString(properties.CatalogId)), ret.addPropertyResult("connectionInput", "ConnectionInput", CfnConnectionConnectionInputPropertyFromCloudFormation(properties.ConnectionInput)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnConnection = class _CfnConnection extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnConnectionPropsFromCloudFormation(resourceProperties), ret = new _CfnConnection(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnConnection.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_glue_CfnConnectionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnConnection), error;
        }
        cdk.requireProperty(props, "catalogId", this), cdk.requireProperty(props, "connectionInput", this), this.catalogId = props.catalogId, this.connectionInput = props.connectionInput;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnConnection.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { catalogId: this.catalogId, connectionInput: this.connectionInput };
      }
      renderProperties(props) {
        return cfnConnectionPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnConnection[_b] = { fqn: "aws-cdk-lib.aws_glue.CfnConnection", version: "2.80.0" }, CfnConnection.CFN_RESOURCE_TYPE_NAME = "AWS::Glue::Connection", exports2.CfnConnection = CfnConnection;
    function CfnConnection_ConnectionInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectionProperties", cdk.validateObject)(properties.connectionProperties)), errors.collect(cdk.propertyValidator("connectionType", cdk.requiredValidator)(properties.connectionType)), errors.collect(cdk.propertyValidator("connectionType", cdk.validateString)(properties.connectionType)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("matchCriteria", cdk.listValidator(cdk.validateString))(properties.matchCriteria)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("physicalConnectionRequirements", CfnConnection_PhysicalConnectionRequirementsPropertyValidator)(properties.physicalConnectionRequirements)), errors.wrap('supplied properties not correct for "ConnectionInputProperty"');
    }
    function cfnConnectionConnectionInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnection_ConnectionInputPropertyValidator(properties).assertSuccess(), { ConnectionProperties: cdk.objectToCloudFormation(properties.connectionProperties), ConnectionType: cdk.stringToCloudFormation(properties.connectionType), Description: cdk.stringToCloudFormation(properties.description), MatchCriteria: cdk.listMapper(cdk.stringToCloudFormation)(properties.matchCriteria), Name: cdk.stringToCloudFormation(properties.name), PhysicalConnectionRequirements: cfnConnectionPhysicalConnectionRequirementsPropertyToCloudFormation(properties.physicalConnectionRequirements) }) : properties;
    }
    function CfnConnectionConnectionInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectionProperties", "ConnectionProperties", properties.ConnectionProperties != null ? cfn_parse.FromCloudFormation.getAny(properties.ConnectionProperties) : void 0), ret.addPropertyResult("connectionType", "ConnectionType", cfn_parse.FromCloudFormation.getString(properties.ConnectionType)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("matchCriteria", "MatchCriteria", properties.MatchCriteria != null ? cfn_parse.FromCloudFormation.getStringArray(properties.MatchCriteria) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("physicalConnectionRequirements", "PhysicalConnectionRequirements", properties.PhysicalConnectionRequirements != null ? CfnConnectionPhysicalConnectionRequirementsPropertyFromCloudFormation(properties.PhysicalConnectionRequirements) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnection_PhysicalConnectionRequirementsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availabilityZone", cdk.validateString)(properties.availabilityZone)), errors.collect(cdk.propertyValidator("securityGroupIdList", cdk.listValidator(cdk.validateString))(properties.securityGroupIdList)), errors.collect(cdk.propertyValidator("subnetId", cdk.validateString)(properties.subnetId)), errors.wrap('supplied properties not correct for "PhysicalConnectionRequirementsProperty"');
    }
    function cfnConnectionPhysicalConnectionRequirementsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnection_PhysicalConnectionRequirementsPropertyValidator(properties).assertSuccess(), { AvailabilityZone: cdk.stringToCloudFormation(properties.availabilityZone), SecurityGroupIdList: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIdList), SubnetId: cdk.stringToCloudFormation(properties.subnetId) }) : properties;
    }
    function CfnConnectionPhysicalConnectionRequirementsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("availabilityZone", "AvailabilityZone", properties.AvailabilityZone != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityZone) : void 0), ret.addPropertyResult("securityGroupIdList", "SecurityGroupIdList", properties.SecurityGroupIdList != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIdList) : void 0), ret.addPropertyResult("subnetId", "SubnetId", properties.SubnetId != null ? cfn_parse.FromCloudFormation.getString(properties.SubnetId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCrawlerPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("classifiers", cdk.listValidator(cdk.validateString))(properties.classifiers)), errors.collect(cdk.propertyValidator("configuration", cdk.validateString)(properties.configuration)), errors.collect(cdk.propertyValidator("crawlerSecurityConfiguration", cdk.validateString)(properties.crawlerSecurityConfiguration)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("recrawlPolicy", CfnCrawler_RecrawlPolicyPropertyValidator)(properties.recrawlPolicy)), errors.collect(cdk.propertyValidator("role", cdk.requiredValidator)(properties.role)), errors.collect(cdk.propertyValidator("role", cdk.validateString)(properties.role)), errors.collect(cdk.propertyValidator("schedule", CfnCrawler_SchedulePropertyValidator)(properties.schedule)), errors.collect(cdk.propertyValidator("schemaChangePolicy", CfnCrawler_SchemaChangePolicyPropertyValidator)(properties.schemaChangePolicy)), errors.collect(cdk.propertyValidator("tablePrefix", cdk.validateString)(properties.tablePrefix)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.collect(cdk.propertyValidator("targets", cdk.requiredValidator)(properties.targets)), errors.collect(cdk.propertyValidator("targets", CfnCrawler_TargetsPropertyValidator)(properties.targets)), errors.wrap('supplied properties not correct for "CfnCrawlerProps"');
    }
    function cfnCrawlerPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCrawlerPropsValidator(properties).assertSuccess(), { Role: cdk.stringToCloudFormation(properties.role), Targets: cfnCrawlerTargetsPropertyToCloudFormation(properties.targets), Classifiers: cdk.listMapper(cdk.stringToCloudFormation)(properties.classifiers), Configuration: cdk.stringToCloudFormation(properties.configuration), CrawlerSecurityConfiguration: cdk.stringToCloudFormation(properties.crawlerSecurityConfiguration), DatabaseName: cdk.stringToCloudFormation(properties.databaseName), Description: cdk.stringToCloudFormation(properties.description), Name: cdk.stringToCloudFormation(properties.name), RecrawlPolicy: cfnCrawlerRecrawlPolicyPropertyToCloudFormation(properties.recrawlPolicy), Schedule: cfnCrawlerSchedulePropertyToCloudFormation(properties.schedule), SchemaChangePolicy: cfnCrawlerSchemaChangePolicyPropertyToCloudFormation(properties.schemaChangePolicy), TablePrefix: cdk.stringToCloudFormation(properties.tablePrefix), Tags: cdk.objectToCloudFormation(properties.tags) }) : properties;
    }
    function CfnCrawlerPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("role", "Role", cfn_parse.FromCloudFormation.getString(properties.Role)), ret.addPropertyResult("targets", "Targets", CfnCrawlerTargetsPropertyFromCloudFormation(properties.Targets)), ret.addPropertyResult("classifiers", "Classifiers", properties.Classifiers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Classifiers) : void 0), ret.addPropertyResult("configuration", "Configuration", properties.Configuration != null ? cfn_parse.FromCloudFormation.getString(properties.Configuration) : void 0), ret.addPropertyResult("crawlerSecurityConfiguration", "CrawlerSecurityConfiguration", properties.CrawlerSecurityConfiguration != null ? cfn_parse.FromCloudFormation.getString(properties.CrawlerSecurityConfiguration) : void 0), ret.addPropertyResult("databaseName", "DatabaseName", properties.DatabaseName != null ? cfn_parse.FromCloudFormation.getString(properties.DatabaseName) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("recrawlPolicy", "RecrawlPolicy", properties.RecrawlPolicy != null ? CfnCrawlerRecrawlPolicyPropertyFromCloudFormation(properties.RecrawlPolicy) : void 0), ret.addPropertyResult("schedule", "Schedule", properties.Schedule != null ? CfnCrawlerSchedulePropertyFromCloudFormation(properties.Schedule) : void 0), ret.addPropertyResult("schemaChangePolicy", "SchemaChangePolicy", properties.SchemaChangePolicy != null ? CfnCrawlerSchemaChangePolicyPropertyFromCloudFormation(properties.SchemaChangePolicy) : void 0), ret.addPropertyResult("tablePrefix", "TablePrefix", properties.TablePrefix != null ? cfn_parse.FromCloudFormation.getString(properties.TablePrefix) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCrawler = class _CfnCrawler extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCrawlerPropsFromCloudFormation(resourceProperties), ret = new _CfnCrawler(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCrawler.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_glue_CfnCrawlerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCrawler), error;
        }
        cdk.requireProperty(props, "role", this), cdk.requireProperty(props, "targets", this), this.role = props.role, this.targets = props.targets, this.classifiers = props.classifiers, this.configuration = props.configuration, this.crawlerSecurityConfiguration = props.crawlerSecurityConfiguration, this.databaseName = props.databaseName, this.description = props.description, this.name = props.name, this.recrawlPolicy = props.recrawlPolicy, this.schedule = props.schedule, this.schemaChangePolicy = props.schemaChangePolicy, this.tablePrefix = props.tablePrefix, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Glue::Crawler", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCrawler.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { role: this.role, targets: this.targets, classifiers: this.classifiers, configuration: this.configuration, crawlerSecurityConfiguration: this.crawlerSecurityConfiguration, databaseName: this.databaseName, description: this.description, name: this.name, recrawlPolicy: this.recrawlPolicy, schedule: this.schedule, schemaChangePolicy: this.schemaChangePolicy, tablePrefix: this.tablePrefix, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnCrawlerPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnCrawler[_c] = { fqn: "aws-cdk-lib.aws_glue.CfnCrawler", version: "2.80.0" }, CfnCrawler.CFN_RESOURCE_TYPE_NAME = "AWS::Glue::Crawler", exports2.CfnCrawler = CfnCrawler;
    function CfnCrawler_CatalogTargetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("tables", cdk.listValidator(cdk.validateString))(properties.tables)), errors.wrap('supplied properties not correct for "CatalogTargetProperty"');
    }
    function cfnCrawlerCatalogTargetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCrawler_CatalogTargetPropertyValidator(properties).assertSuccess(), { DatabaseName: cdk.stringToCloudFormation(properties.databaseName), Tables: cdk.listMapper(cdk.stringToCloudFormation)(properties.tables) }) : properties;
    }
    function CfnCrawlerCatalogTargetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("databaseName", "DatabaseName", properties.DatabaseName != null ? cfn_parse.FromCloudFormation.getString(properties.DatabaseName) : void 0), ret.addPropertyResult("tables", "Tables", properties.Tables != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Tables) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCrawler_DeltaTargetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectionName", cdk.validateString)(properties.connectionName)), errors.collect(cdk.propertyValidator("createNativeDeltaTable", cdk.validateBoolean)(properties.createNativeDeltaTable)), errors.collect(cdk.propertyValidator("deltaTables", cdk.listValidator(cdk.validateString))(properties.deltaTables)), errors.collect(cdk.propertyValidator("writeManifest", cdk.validateBoolean)(properties.writeManifest)), errors.wrap('supplied properties not correct for "DeltaTargetProperty"');
    }
    function cfnCrawlerDeltaTargetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCrawler_DeltaTargetPropertyValidator(properties).assertSuccess(), { ConnectionName: cdk.stringToCloudFormation(properties.connectionName), CreateNativeDeltaTable: cdk.booleanToCloudFormation(properties.createNativeDeltaTable), DeltaTables: cdk.listMapper(cdk.stringToCloudFormation)(properties.deltaTables), WriteManifest: cdk.booleanToCloudFormation(properties.writeManifest) }) : properties;
    }
    function CfnCrawlerDeltaTargetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectionName", "ConnectionName", properties.ConnectionName != null ? cfn_parse.FromCloudFormation.getString(properties.ConnectionName) : void 0), ret.addPropertyResult("createNativeDeltaTable", "CreateNativeDeltaTable", properties.CreateNativeDeltaTable != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CreateNativeDeltaTable) : void 0), ret.addPropertyResult("deltaTables", "DeltaTables", properties.DeltaTables != null ? cfn_parse.FromCloudFormation.getStringArray(properties.DeltaTables) : void 0), ret.addPropertyResult("writeManifest", "WriteManifest", properties.WriteManifest != null ? cfn_parse.FromCloudFormation.getBoolean(properties.WriteManifest) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCrawler_DynamoDBTargetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.wrap('supplied properties not correct for "DynamoDBTargetProperty"');
    }
    function cfnCrawlerDynamoDBTargetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCrawler_DynamoDBTargetPropertyValidator(properties).assertSuccess(), { Path: cdk.stringToCloudFormation(properties.path) }) : properties;
    }
    function CfnCrawlerDynamoDBTargetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("path", "Path", properties.Path != null ? cfn_parse.FromCloudFormation.getString(properties.Path) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCrawler_JdbcTargetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectionName", cdk.validateString)(properties.connectionName)), errors.collect(cdk.propertyValidator("exclusions", cdk.listValidator(cdk.validateString))(properties.exclusions)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.wrap('supplied properties not correct for "JdbcTargetProperty"');
    }
    function cfnCrawlerJdbcTargetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCrawler_JdbcTargetPropertyValidator(properties).assertSuccess(), { ConnectionName: cdk.stringToCloudFormation(properties.connectionName), Exclusions: cdk.listMapper(cdk.stringToCloudFormation)(properties.exclusions), Path: cdk.stringToCloudFormation(properties.path) }) : properties;
    }
    function CfnCrawlerJdbcTargetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectionName", "ConnectionName", properties.ConnectionName != null ? cfn_parse.FromCloudFormation.getString(properties.ConnectionName) : void 0), ret.addPropertyResult("exclusions", "Exclusions", properties.Exclusions != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Exclusions) : void 0), ret.addPropertyResult("path", "Path", properties.Path != null ? cfn_parse.FromCloudFormation.getString(properties.Path) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCrawler_MongoDBTargetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectionName", cdk.validateString)(properties.connectionName)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.wrap('supplied properties not correct for "MongoDBTargetProperty"');
    }
    function cfnCrawlerMongoDBTargetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCrawler_MongoDBTargetPropertyValidator(properties).assertSuccess(), { ConnectionName: cdk.stringToCloudFormation(properties.connectionName), Path: cdk.stringToCloudFormation(properties.path) }) : properties;
    }
    function CfnCrawlerMongoDBTargetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectionName", "ConnectionName", properties.ConnectionName != null ? cfn_parse.FromCloudFormation.getString(properties.ConnectionName) : void 0), ret.addPropertyResult("path", "Path", properties.Path != null ? cfn_parse.FromCloudFormation.getString(properties.Path) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCrawler_RecrawlPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("recrawlBehavior", cdk.validateString)(properties.recrawlBehavior)), errors.wrap('supplied properties not correct for "RecrawlPolicyProperty"');
    }
    function cfnCrawlerRecrawlPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCrawler_RecrawlPolicyPropertyValidator(properties).assertSuccess(), { RecrawlBehavior: cdk.stringToCloudFormation(properties.recrawlBehavior) }) : properties;
    }
    function CfnCrawlerRecrawlPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("recrawlBehavior", "RecrawlBehavior", properties.RecrawlBehavior != null ? cfn_parse.FromCloudFormation.getString(properties.RecrawlBehavior) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCrawler_S3TargetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectionName", cdk.validateString)(properties.connectionName)), errors.collect(cdk.propertyValidator("dlqEventQueueArn", cdk.validateString)(properties.dlqEventQueueArn)), errors.collect(cdk.propertyValidator("eventQueueArn", cdk.validateString)(properties.eventQueueArn)), errors.collect(cdk.propertyValidator("exclusions", cdk.listValidator(cdk.validateString))(properties.exclusions)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.collect(cdk.propertyValidator("sampleSize", cdk.validateNumber)(properties.sampleSize)), errors.wrap('supplied properties not correct for "S3TargetProperty"');
    }
    function cfnCrawlerS3TargetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCrawler_S3TargetPropertyValidator(properties).assertSuccess(), { ConnectionName: cdk.stringToCloudFormation(properties.connectionName), DlqEventQueueArn: cdk.stringToCloudFormation(properties.dlqEventQueueArn), EventQueueArn: cdk.stringToCloudFormation(properties.eventQueueArn), Exclusions: cdk.listMapper(cdk.stringToCloudFormation)(properties.exclusions), Path: cdk.stringToCloudFormation(properties.path), SampleSize: cdk.numberToCloudFormation(properties.sampleSize) }) : properties;
    }
    function CfnCrawlerS3TargetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectionName", "ConnectionName", properties.ConnectionName != null ? cfn_parse.FromCloudFormation.getString(properties.ConnectionName) : void 0), ret.addPropertyResult("dlqEventQueueArn", "DlqEventQueueArn", properties.DlqEventQueueArn != null ? cfn_parse.FromCloudFormation.getString(properties.DlqEventQueueArn) : void 0), ret.addPropertyResult("eventQueueArn", "EventQueueArn", properties.EventQueueArn != null ? cfn_parse.FromCloudFormation.getString(properties.EventQueueArn) : void 0), ret.addPropertyResult("exclusions", "Exclusions", properties.Exclusions != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Exclusions) : void 0), ret.addPropertyResult("path", "Path", properties.Path != null ? cfn_parse.FromCloudFormation.getString(properties.Path) : void 0), ret.addPropertyResult("sampleSize", "SampleSize", properties.SampleSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.SampleSize) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCrawler_SchedulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("scheduleExpression", cdk.validateString)(properties.scheduleExpression)), errors.wrap('supplied properties not correct for "ScheduleProperty"');
    }
    function cfnCrawlerSchedulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCrawler_SchedulePropertyValidator(properties).assertSuccess(), { ScheduleExpression: cdk.stringToCloudFormation(properties.scheduleExpression) }) : properties;
    }
    function CfnCrawlerSchedulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("scheduleExpression", "ScheduleExpression", properties.ScheduleExpression != null ? cfn_parse.FromCloudFormation.getString(properties.ScheduleExpression) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCrawler_SchemaChangePolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deleteBehavior", cdk.validateString)(properties.deleteBehavior)), errors.collect(cdk.propertyValidator("updateBehavior", cdk.validateString)(properties.updateBehavior)), errors.wrap('supplied properties not correct for "SchemaChangePolicyProperty"');
    }
    function cfnCrawlerSchemaChangePolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCrawler_SchemaChangePolicyPropertyValidator(properties).assertSuccess(), { DeleteBehavior: cdk.stringToCloudFormation(properties.deleteBehavior), UpdateBehavior: cdk.stringToCloudFormation(properties.updateBehavior) }) : properties;
    }
    function CfnCrawlerSchemaChangePolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deleteBehavior", "DeleteBehavior", properties.DeleteBehavior != null ? cfn_parse.FromCloudFormation.getString(properties.DeleteBehavior) : void 0), ret.addPropertyResult("updateBehavior", "UpdateBehavior", properties.UpdateBehavior != null ? cfn_parse.FromCloudFormation.getString(properties.UpdateBehavior) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCrawler_TargetsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalogTargets", cdk.listValidator(CfnCrawler_CatalogTargetPropertyValidator))(properties.catalogTargets)), errors.collect(cdk.propertyValidator("deltaTargets", cdk.listValidator(CfnCrawler_DeltaTargetPropertyValidator))(properties.deltaTargets)), errors.collect(cdk.propertyValidator("dynamoDbTargets", cdk.listValidator(CfnCrawler_DynamoDBTargetPropertyValidator))(properties.dynamoDbTargets)), errors.collect(cdk.propertyValidator("jdbcTargets", cdk.listValidator(CfnCrawler_JdbcTargetPropertyValidator))(properties.jdbcTargets)), errors.collect(cdk.propertyValidator("mongoDbTargets", cdk.listValidator(CfnCrawler_MongoDBTargetPropertyValidator))(properties.mongoDbTargets)), errors.collect(cdk.propertyValidator("s3Targets", cdk.listValidator(CfnCrawler_S3TargetPropertyValidator))(properties.s3Targets)), errors.wrap('supplied properties not correct for "TargetsProperty"');
    }
    function cfnCrawlerTargetsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCrawler_TargetsPropertyValidator(properties).assertSuccess(), { CatalogTargets: cdk.listMapper(cfnCrawlerCatalogTargetPropertyToCloudFormation)(properties.catalogTargets), DeltaTargets: cdk.listMapper(cfnCrawlerDeltaTargetPropertyToCloudFormation)(properties.deltaTargets), DynamoDBTargets: cdk.listMapper(cfnCrawlerDynamoDBTargetPropertyToCloudFormation)(properties.dynamoDbTargets), JdbcTargets: cdk.listMapper(cfnCrawlerJdbcTargetPropertyToCloudFormation)(properties.jdbcTargets), MongoDBTargets: cdk.listMapper(cfnCrawlerMongoDBTargetPropertyToCloudFormation)(properties.mongoDbTargets), S3Targets: cdk.listMapper(cfnCrawlerS3TargetPropertyToCloudFormation)(properties.s3Targets) }) : properties;
    }
    function CfnCrawlerTargetsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalogTargets", "CatalogTargets", properties.CatalogTargets != null ? cfn_parse.FromCloudFormation.getArray(CfnCrawlerCatalogTargetPropertyFromCloudFormation)(properties.CatalogTargets) : void 0), ret.addPropertyResult("deltaTargets", "DeltaTargets", properties.DeltaTargets != null ? cfn_parse.FromCloudFormation.getArray(CfnCrawlerDeltaTargetPropertyFromCloudFormation)(properties.DeltaTargets) : void 0), ret.addPropertyResult("dynamoDbTargets", "DynamoDBTargets", properties.DynamoDBTargets != null ? cfn_parse.FromCloudFormation.getArray(CfnCrawlerDynamoDBTargetPropertyFromCloudFormation)(properties.DynamoDBTargets) : void 0), ret.addPropertyResult("jdbcTargets", "JdbcTargets", properties.JdbcTargets != null ? cfn_parse.FromCloudFormation.getArray(CfnCrawlerJdbcTargetPropertyFromCloudFormation)(properties.JdbcTargets) : void 0), ret.addPropertyResult("mongoDbTargets", "MongoDBTargets", properties.MongoDBTargets != null ? cfn_parse.FromCloudFormation.getArray(CfnCrawlerMongoDBTargetPropertyFromCloudFormation)(properties.MongoDBTargets) : void 0), ret.addPropertyResult("s3Targets", "S3Targets", properties.S3Targets != null ? cfn_parse.FromCloudFormation.getArray(CfnCrawlerS3TargetPropertyFromCloudFormation)(properties.S3Targets) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataCatalogEncryptionSettingsPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalogId", cdk.requiredValidator)(properties.catalogId)), errors.collect(cdk.propertyValidator("catalogId", cdk.validateString)(properties.catalogId)), errors.collect(cdk.propertyValidator("dataCatalogEncryptionSettings", cdk.requiredValidator)(properties.dataCatalogEncryptionSettings)), errors.collect(cdk.propertyValidator("dataCatalogEncryptionSettings", CfnDataCatalogEncryptionSettings_DataCatalogEncryptionSettingsPropertyValidator)(properties.dataCatalogEncryptionSettings)), errors.wrap('supplied properties not correct for "CfnDataCatalogEncryptionSettingsProps"');
    }
    function cfnDataCatalogEncryptionSettingsPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataCatalogEncryptionSettingsPropsValidator(properties).assertSuccess(), { CatalogId: cdk.stringToCloudFormation(properties.catalogId), DataCatalogEncryptionSettings: cfnDataCatalogEncryptionSettingsDataCatalogEncryptionSettingsPropertyToCloudFormation(properties.dataCatalogEncryptionSettings) }) : properties;
    }
    function CfnDataCatalogEncryptionSettingsPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalogId", "CatalogId", cfn_parse.FromCloudFormation.getString(properties.CatalogId)), ret.addPropertyResult("dataCatalogEncryptionSettings", "DataCatalogEncryptionSettings", CfnDataCatalogEncryptionSettingsDataCatalogEncryptionSettingsPropertyFromCloudFormation(properties.DataCatalogEncryptionSettings)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDataCatalogEncryptionSettings = class _CfnDataCatalogEncryptionSettings extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDataCatalogEncryptionSettingsPropsFromCloudFormation(resourceProperties), ret = new _CfnDataCatalogEncryptionSettings(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDataCatalogEncryptionSettings.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_glue_CfnDataCatalogEncryptionSettingsProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDataCatalogEncryptionSettings), error;
        }
        cdk.requireProperty(props, "catalogId", this), cdk.requireProperty(props, "dataCatalogEncryptionSettings", this), this.catalogId = props.catalogId, this.dataCatalogEncryptionSettings = props.dataCatalogEncryptionSettings;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDataCatalogEncryptionSettings.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { catalogId: this.catalogId, dataCatalogEncryptionSettings: this.dataCatalogEncryptionSettings };
      }
      renderProperties(props) {
        return cfnDataCatalogEncryptionSettingsPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnDataCatalogEncryptionSettings[_d] = { fqn: "aws-cdk-lib.aws_glue.CfnDataCatalogEncryptionSettings", version: "2.80.0" }, CfnDataCatalogEncryptionSettings.CFN_RESOURCE_TYPE_NAME = "AWS::Glue::DataCatalogEncryptionSettings", exports2.CfnDataCatalogEncryptionSettings = CfnDataCatalogEncryptionSettings;
    function CfnDataCatalogEncryptionSettings_ConnectionPasswordEncryptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("returnConnectionPasswordEncrypted", cdk.validateBoolean)(properties.returnConnectionPasswordEncrypted)), errors.wrap('supplied properties not correct for "ConnectionPasswordEncryptionProperty"');
    }
    function cfnDataCatalogEncryptionSettingsConnectionPasswordEncryptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataCatalogEncryptionSettings_ConnectionPasswordEncryptionPropertyValidator(properties).assertSuccess(), { KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), ReturnConnectionPasswordEncrypted: cdk.booleanToCloudFormation(properties.returnConnectionPasswordEncrypted) }) : properties;
    }
    function CfnDataCatalogEncryptionSettingsConnectionPasswordEncryptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("returnConnectionPasswordEncrypted", "ReturnConnectionPasswordEncrypted", properties.ReturnConnectionPasswordEncrypted != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ReturnConnectionPasswordEncrypted) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataCatalogEncryptionSettings_DataCatalogEncryptionSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectionPasswordEncryption", CfnDataCatalogEncryptionSettings_ConnectionPasswordEncryptionPropertyValidator)(properties.connectionPasswordEncryption)), errors.collect(cdk.propertyValidator("encryptionAtRest", CfnDataCatalogEncryptionSettings_EncryptionAtRestPropertyValidator)(properties.encryptionAtRest)), errors.wrap('supplied properties not correct for "DataCatalogEncryptionSettingsProperty"');
    }
    function cfnDataCatalogEncryptionSettingsDataCatalogEncryptionSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataCatalogEncryptionSettings_DataCatalogEncryptionSettingsPropertyValidator(properties).assertSuccess(), { ConnectionPasswordEncryption: cfnDataCatalogEncryptionSettingsConnectionPasswordEncryptionPropertyToCloudFormation(properties.connectionPasswordEncryption), EncryptionAtRest: cfnDataCatalogEncryptionSettingsEncryptionAtRestPropertyToCloudFormation(properties.encryptionAtRest) }) : properties;
    }
    function CfnDataCatalogEncryptionSettingsDataCatalogEncryptionSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectionPasswordEncryption", "ConnectionPasswordEncryption", properties.ConnectionPasswordEncryption != null ? CfnDataCatalogEncryptionSettingsConnectionPasswordEncryptionPropertyFromCloudFormation(properties.ConnectionPasswordEncryption) : void 0), ret.addPropertyResult("encryptionAtRest", "EncryptionAtRest", properties.EncryptionAtRest != null ? CfnDataCatalogEncryptionSettingsEncryptionAtRestPropertyFromCloudFormation(properties.EncryptionAtRest) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataCatalogEncryptionSettings_EncryptionAtRestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalogEncryptionMode", cdk.validateString)(properties.catalogEncryptionMode)), errors.collect(cdk.propertyValidator("sseAwsKmsKeyId", cdk.validateString)(properties.sseAwsKmsKeyId)), errors.wrap('supplied properties not correct for "EncryptionAtRestProperty"');
    }
    function cfnDataCatalogEncryptionSettingsEncryptionAtRestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataCatalogEncryptionSettings_EncryptionAtRestPropertyValidator(properties).assertSuccess(), { CatalogEncryptionMode: cdk.stringToCloudFormation(properties.catalogEncryptionMode), SseAwsKmsKeyId: cdk.stringToCloudFormation(properties.sseAwsKmsKeyId) }) : properties;
    }
    function CfnDataCatalogEncryptionSettingsEncryptionAtRestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalogEncryptionMode", "CatalogEncryptionMode", properties.CatalogEncryptionMode != null ? cfn_parse.FromCloudFormation.getString(properties.CatalogEncryptionMode) : void 0), ret.addPropertyResult("sseAwsKmsKeyId", "SseAwsKmsKeyId", properties.SseAwsKmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.SseAwsKmsKeyId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDatabasePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalogId", cdk.requiredValidator)(properties.catalogId)), errors.collect(cdk.propertyValidator("catalogId", cdk.validateString)(properties.catalogId)), errors.collect(cdk.propertyValidator("databaseInput", cdk.requiredValidator)(properties.databaseInput)), errors.collect(cdk.propertyValidator("databaseInput", CfnDatabase_DatabaseInputPropertyValidator)(properties.databaseInput)), errors.wrap('supplied properties not correct for "CfnDatabaseProps"');
    }
    function cfnDatabasePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDatabasePropsValidator(properties).assertSuccess(), { CatalogId: cdk.stringToCloudFormation(properties.catalogId), DatabaseInput: cfnDatabaseDatabaseInputPropertyToCloudFormation(properties.databaseInput) }) : properties;
    }
    function CfnDatabasePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalogId", "CatalogId", cfn_parse.FromCloudFormation.getString(properties.CatalogId)), ret.addPropertyResult("databaseInput", "DatabaseInput", CfnDatabaseDatabaseInputPropertyFromCloudFormation(properties.DatabaseInput)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDatabase = class _CfnDatabase extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDatabasePropsFromCloudFormation(resourceProperties), ret = new _CfnDatabase(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDatabase.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_glue_CfnDatabaseProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDatabase), error;
        }
        cdk.requireProperty(props, "catalogId", this), cdk.requireProperty(props, "databaseInput", this), this.catalogId = props.catalogId, this.databaseInput = props.databaseInput;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDatabase.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { catalogId: this.catalogId, databaseInput: this.databaseInput };
      }
      renderProperties(props) {
        return cfnDatabasePropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnDatabase[_e] = { fqn: "aws-cdk-lib.aws_glue.CfnDatabase", version: "2.80.0" }, CfnDatabase.CFN_RESOURCE_TYPE_NAME = "AWS::Glue::Database", exports2.CfnDatabase = CfnDatabase;
    function CfnDatabase_DataLakePrincipalPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataLakePrincipalIdentifier", cdk.validateString)(properties.dataLakePrincipalIdentifier)), errors.wrap('supplied properties not correct for "DataLakePrincipalProperty"');
    }
    function cfnDatabaseDataLakePrincipalPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDatabase_DataLakePrincipalPropertyValidator(properties).assertSuccess(), { DataLakePrincipalIdentifier: cdk.stringToCloudFormation(properties.dataLakePrincipalIdentifier) }) : properties;
    }
    function CfnDatabaseDataLakePrincipalPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataLakePrincipalIdentifier", "DataLakePrincipalIdentifier", properties.DataLakePrincipalIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.DataLakePrincipalIdentifier) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDatabase_DatabaseIdentifierPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalogId", cdk.validateString)(properties.catalogId)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.wrap('supplied properties not correct for "DatabaseIdentifierProperty"');
    }
    function cfnDatabaseDatabaseIdentifierPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDatabase_DatabaseIdentifierPropertyValidator(properties).assertSuccess(), { CatalogId: cdk.stringToCloudFormation(properties.catalogId), DatabaseName: cdk.stringToCloudFormation(properties.databaseName) }) : properties;
    }
    function CfnDatabaseDatabaseIdentifierPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalogId", "CatalogId", properties.CatalogId != null ? cfn_parse.FromCloudFormation.getString(properties.CatalogId) : void 0), ret.addPropertyResult("databaseName", "DatabaseName", properties.DatabaseName != null ? cfn_parse.FromCloudFormation.getString(properties.DatabaseName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDatabase_DatabaseInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("createTableDefaultPermissions", cdk.listValidator(CfnDatabase_PrincipalPrivilegesPropertyValidator))(properties.createTableDefaultPermissions)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("federatedDatabase", CfnDatabase_FederatedDatabasePropertyValidator)(properties.federatedDatabase)), errors.collect(cdk.propertyValidator("locationUri", cdk.validateString)(properties.locationUri)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("parameters", cdk.validateObject)(properties.parameters)), errors.collect(cdk.propertyValidator("targetDatabase", CfnDatabase_DatabaseIdentifierPropertyValidator)(properties.targetDatabase)), errors.wrap('supplied properties not correct for "DatabaseInputProperty"');
    }
    function cfnDatabaseDatabaseInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDatabase_DatabaseInputPropertyValidator(properties).assertSuccess(), { CreateTableDefaultPermissions: cdk.listMapper(cfnDatabasePrincipalPrivilegesPropertyToCloudFormation)(properties.createTableDefaultPermissions), Description: cdk.stringToCloudFormation(properties.description), FederatedDatabase: cfnDatabaseFederatedDatabasePropertyToCloudFormation(properties.federatedDatabase), LocationUri: cdk.stringToCloudFormation(properties.locationUri), Name: cdk.stringToCloudFormation(properties.name), Parameters: cdk.objectToCloudFormation(properties.parameters), TargetDatabase: cfnDatabaseDatabaseIdentifierPropertyToCloudFormation(properties.targetDatabase) }) : properties;
    }
    function CfnDatabaseDatabaseInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("createTableDefaultPermissions", "CreateTableDefaultPermissions", properties.CreateTableDefaultPermissions != null ? cfn_parse.FromCloudFormation.getArray(CfnDatabasePrincipalPrivilegesPropertyFromCloudFormation)(properties.CreateTableDefaultPermissions) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("federatedDatabase", "FederatedDatabase", properties.FederatedDatabase != null ? CfnDatabaseFederatedDatabasePropertyFromCloudFormation(properties.FederatedDatabase) : void 0), ret.addPropertyResult("locationUri", "LocationUri", properties.LocationUri != null ? cfn_parse.FromCloudFormation.getString(properties.LocationUri) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getAny(properties.Parameters) : void 0), ret.addPropertyResult("targetDatabase", "TargetDatabase", properties.TargetDatabase != null ? CfnDatabaseDatabaseIdentifierPropertyFromCloudFormation(properties.TargetDatabase) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDatabase_FederatedDatabasePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectionName", cdk.validateString)(properties.connectionName)), errors.collect(cdk.propertyValidator("identifier", cdk.validateString)(properties.identifier)), errors.wrap('supplied properties not correct for "FederatedDatabaseProperty"');
    }
    function cfnDatabaseFederatedDatabasePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDatabase_FederatedDatabasePropertyValidator(properties).assertSuccess(), { ConnectionName: cdk.stringToCloudFormation(properties.connectionName), Identifier: cdk.stringToCloudFormation(properties.identifier) }) : properties;
    }
    function CfnDatabaseFederatedDatabasePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectionName", "ConnectionName", properties.ConnectionName != null ? cfn_parse.FromCloudFormation.getString(properties.ConnectionName) : void 0), ret.addPropertyResult("identifier", "Identifier", properties.Identifier != null ? cfn_parse.FromCloudFormation.getString(properties.Identifier) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDatabase_PrincipalPrivilegesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("permissions", cdk.listValidator(cdk.validateString))(properties.permissions)), errors.collect(cdk.propertyValidator("principal", CfnDatabase_DataLakePrincipalPropertyValidator)(properties.principal)), errors.wrap('supplied properties not correct for "PrincipalPrivilegesProperty"');
    }
    function cfnDatabasePrincipalPrivilegesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDatabase_PrincipalPrivilegesPropertyValidator(properties).assertSuccess(), { Permissions: cdk.listMapper(cdk.stringToCloudFormation)(properties.permissions), Principal: cfnDatabaseDataLakePrincipalPropertyToCloudFormation(properties.principal) }) : properties;
    }
    function CfnDatabasePrincipalPrivilegesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("permissions", "Permissions", properties.Permissions != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Permissions) : void 0), ret.addPropertyResult("principal", "Principal", properties.Principal != null ? CfnDatabaseDataLakePrincipalPropertyFromCloudFormation(properties.Principal) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDevEndpointPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arguments", cdk.validateObject)(properties.arguments)), errors.collect(cdk.propertyValidator("endpointName", cdk.validateString)(properties.endpointName)), errors.collect(cdk.propertyValidator("extraJarsS3Path", cdk.validateString)(properties.extraJarsS3Path)), errors.collect(cdk.propertyValidator("extraPythonLibsS3Path", cdk.validateString)(properties.extraPythonLibsS3Path)), errors.collect(cdk.propertyValidator("glueVersion", cdk.validateString)(properties.glueVersion)), errors.collect(cdk.propertyValidator("numberOfNodes", cdk.validateNumber)(properties.numberOfNodes)), errors.collect(cdk.propertyValidator("numberOfWorkers", cdk.validateNumber)(properties.numberOfWorkers)), errors.collect(cdk.propertyValidator("publicKey", cdk.validateString)(properties.publicKey)), errors.collect(cdk.propertyValidator("publicKeys", cdk.listValidator(cdk.validateString))(properties.publicKeys)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("securityConfiguration", cdk.validateString)(properties.securityConfiguration)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnetId", cdk.validateString)(properties.subnetId)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.collect(cdk.propertyValidator("workerType", cdk.validateString)(properties.workerType)), errors.wrap('supplied properties not correct for "CfnDevEndpointProps"');
    }
    function cfnDevEndpointPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDevEndpointPropsValidator(properties).assertSuccess(), { RoleArn: cdk.stringToCloudFormation(properties.roleArn), Arguments: cdk.objectToCloudFormation(properties.arguments), EndpointName: cdk.stringToCloudFormation(properties.endpointName), ExtraJarsS3Path: cdk.stringToCloudFormation(properties.extraJarsS3Path), ExtraPythonLibsS3Path: cdk.stringToCloudFormation(properties.extraPythonLibsS3Path), GlueVersion: cdk.stringToCloudFormation(properties.glueVersion), NumberOfNodes: cdk.numberToCloudFormation(properties.numberOfNodes), NumberOfWorkers: cdk.numberToCloudFormation(properties.numberOfWorkers), PublicKey: cdk.stringToCloudFormation(properties.publicKey), PublicKeys: cdk.listMapper(cdk.stringToCloudFormation)(properties.publicKeys), SecurityConfiguration: cdk.stringToCloudFormation(properties.securityConfiguration), SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SubnetId: cdk.stringToCloudFormation(properties.subnetId), Tags: cdk.objectToCloudFormation(properties.tags), WorkerType: cdk.stringToCloudFormation(properties.workerType) }) : properties;
    }
    function CfnDevEndpointPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("arguments", "Arguments", properties.Arguments != null ? cfn_parse.FromCloudFormation.getAny(properties.Arguments) : void 0), ret.addPropertyResult("endpointName", "EndpointName", properties.EndpointName != null ? cfn_parse.FromCloudFormation.getString(properties.EndpointName) : void 0), ret.addPropertyResult("extraJarsS3Path", "ExtraJarsS3Path", properties.ExtraJarsS3Path != null ? cfn_parse.FromCloudFormation.getString(properties.ExtraJarsS3Path) : void 0), ret.addPropertyResult("extraPythonLibsS3Path", "ExtraPythonLibsS3Path", properties.ExtraPythonLibsS3Path != null ? cfn_parse.FromCloudFormation.getString(properties.ExtraPythonLibsS3Path) : void 0), ret.addPropertyResult("glueVersion", "GlueVersion", properties.GlueVersion != null ? cfn_parse.FromCloudFormation.getString(properties.GlueVersion) : void 0), ret.addPropertyResult("numberOfNodes", "NumberOfNodes", properties.NumberOfNodes != null ? cfn_parse.FromCloudFormation.getNumber(properties.NumberOfNodes) : void 0), ret.addPropertyResult("numberOfWorkers", "NumberOfWorkers", properties.NumberOfWorkers != null ? cfn_parse.FromCloudFormation.getNumber(properties.NumberOfWorkers) : void 0), ret.addPropertyResult("publicKey", "PublicKey", properties.PublicKey != null ? cfn_parse.FromCloudFormation.getString(properties.PublicKey) : void 0), ret.addPropertyResult("publicKeys", "PublicKeys", properties.PublicKeys != null ? cfn_parse.FromCloudFormation.getStringArray(properties.PublicKeys) : void 0), ret.addPropertyResult("securityConfiguration", "SecurityConfiguration", properties.SecurityConfiguration != null ? cfn_parse.FromCloudFormation.getString(properties.SecurityConfiguration) : void 0), ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("subnetId", "SubnetId", properties.SubnetId != null ? cfn_parse.FromCloudFormation.getString(properties.SubnetId) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addPropertyResult("workerType", "WorkerType", properties.WorkerType != null ? cfn_parse.FromCloudFormation.getString(properties.WorkerType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDevEndpoint = class _CfnDevEndpoint extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDevEndpointPropsFromCloudFormation(resourceProperties), ret = new _CfnDevEndpoint(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDevEndpoint.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_glue_CfnDevEndpointProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDevEndpoint), error;
        }
        cdk.requireProperty(props, "roleArn", this), this.roleArn = props.roleArn, this.arguments = props.arguments, this.endpointName = props.endpointName, this.extraJarsS3Path = props.extraJarsS3Path, this.extraPythonLibsS3Path = props.extraPythonLibsS3Path, this.glueVersion = props.glueVersion, this.numberOfNodes = props.numberOfNodes, this.numberOfWorkers = props.numberOfWorkers, this.publicKey = props.publicKey, this.publicKeys = props.publicKeys, this.securityConfiguration = props.securityConfiguration, this.securityGroupIds = props.securityGroupIds, this.subnetId = props.subnetId, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Glue::DevEndpoint", props.tags, { tagPropertyName: "tags" }), this.workerType = props.workerType;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDevEndpoint.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { roleArn: this.roleArn, arguments: this.arguments, endpointName: this.endpointName, extraJarsS3Path: this.extraJarsS3Path, extraPythonLibsS3Path: this.extraPythonLibsS3Path, glueVersion: this.glueVersion, numberOfNodes: this.numberOfNodes, numberOfWorkers: this.numberOfWorkers, publicKey: this.publicKey, publicKeys: this.publicKeys, securityConfiguration: this.securityConfiguration, securityGroupIds: this.securityGroupIds, subnetId: this.subnetId, tags: this.tags.renderTags(), workerType: this.workerType };
      }
      renderProperties(props) {
        return cfnDevEndpointPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnDevEndpoint[_f] = { fqn: "aws-cdk-lib.aws_glue.CfnDevEndpoint", version: "2.80.0" }, CfnDevEndpoint.CFN_RESOURCE_TYPE_NAME = "AWS::Glue::DevEndpoint", exports2.CfnDevEndpoint = CfnDevEndpoint;
    function CfnJobPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allocatedCapacity", cdk.validateNumber)(properties.allocatedCapacity)), errors.collect(cdk.propertyValidator("command", cdk.requiredValidator)(properties.command)), errors.collect(cdk.propertyValidator("command", CfnJob_JobCommandPropertyValidator)(properties.command)), errors.collect(cdk.propertyValidator("connections", CfnJob_ConnectionsListPropertyValidator)(properties.connections)), errors.collect(cdk.propertyValidator("defaultArguments", cdk.validateObject)(properties.defaultArguments)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("executionClass", cdk.validateString)(properties.executionClass)), errors.collect(cdk.propertyValidator("executionProperty", CfnJob_ExecutionPropertyPropertyValidator)(properties.executionProperty)), errors.collect(cdk.propertyValidator("glueVersion", cdk.validateString)(properties.glueVersion)), errors.collect(cdk.propertyValidator("logUri", cdk.validateString)(properties.logUri)), errors.collect(cdk.propertyValidator("maxCapacity", cdk.validateNumber)(properties.maxCapacity)), errors.collect(cdk.propertyValidator("maxRetries", cdk.validateNumber)(properties.maxRetries)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("nonOverridableArguments", cdk.validateObject)(properties.nonOverridableArguments)), errors.collect(cdk.propertyValidator("notificationProperty", CfnJob_NotificationPropertyPropertyValidator)(properties.notificationProperty)), errors.collect(cdk.propertyValidator("numberOfWorkers", cdk.validateNumber)(properties.numberOfWorkers)), errors.collect(cdk.propertyValidator("role", cdk.requiredValidator)(properties.role)), errors.collect(cdk.propertyValidator("role", cdk.validateString)(properties.role)), errors.collect(cdk.propertyValidator("securityConfiguration", cdk.validateString)(properties.securityConfiguration)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.collect(cdk.propertyValidator("timeout", cdk.validateNumber)(properties.timeout)), errors.collect(cdk.propertyValidator("workerType", cdk.validateString)(properties.workerType)), errors.wrap('supplied properties not correct for "CfnJobProps"');
    }
    function cfnJobPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobPropsValidator(properties).assertSuccess(), { Command: cfnJobJobCommandPropertyToCloudFormation(properties.command), Role: cdk.stringToCloudFormation(properties.role), AllocatedCapacity: cdk.numberToCloudFormation(properties.allocatedCapacity), Connections: cfnJobConnectionsListPropertyToCloudFormation(properties.connections), DefaultArguments: cdk.objectToCloudFormation(properties.defaultArguments), Description: cdk.stringToCloudFormation(properties.description), ExecutionClass: cdk.stringToCloudFormation(properties.executionClass), ExecutionProperty: cfnJobExecutionPropertyPropertyToCloudFormation(properties.executionProperty), GlueVersion: cdk.stringToCloudFormation(properties.glueVersion), LogUri: cdk.stringToCloudFormation(properties.logUri), MaxCapacity: cdk.numberToCloudFormation(properties.maxCapacity), MaxRetries: cdk.numberToCloudFormation(properties.maxRetries), Name: cdk.stringToCloudFormation(properties.name), NonOverridableArguments: cdk.objectToCloudFormation(properties.nonOverridableArguments), NotificationProperty: cfnJobNotificationPropertyPropertyToCloudFormation(properties.notificationProperty), NumberOfWorkers: cdk.numberToCloudFormation(properties.numberOfWorkers), SecurityConfiguration: cdk.stringToCloudFormation(properties.securityConfiguration), Tags: cdk.objectToCloudFormation(properties.tags), Timeout: cdk.numberToCloudFormation(properties.timeout), WorkerType: cdk.stringToCloudFormation(properties.workerType) }) : properties;
    }
    function CfnJobPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("command", "Command", CfnJobJobCommandPropertyFromCloudFormation(properties.Command)), ret.addPropertyResult("role", "Role", cfn_parse.FromCloudFormation.getString(properties.Role)), ret.addPropertyResult("allocatedCapacity", "AllocatedCapacity", properties.AllocatedCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.AllocatedCapacity) : void 0), ret.addPropertyResult("connections", "Connections", properties.Connections != null ? CfnJobConnectionsListPropertyFromCloudFormation(properties.Connections) : void 0), ret.addPropertyResult("defaultArguments", "DefaultArguments", properties.DefaultArguments != null ? cfn_parse.FromCloudFormation.getAny(properties.DefaultArguments) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("executionClass", "ExecutionClass", properties.ExecutionClass != null ? cfn_parse.FromCloudFormation.getString(properties.ExecutionClass) : void 0), ret.addPropertyResult("executionProperty", "ExecutionProperty", properties.ExecutionProperty != null ? CfnJobExecutionPropertyPropertyFromCloudFormation(properties.ExecutionProperty) : void 0), ret.addPropertyResult("glueVersion", "GlueVersion", properties.GlueVersion != null ? cfn_parse.FromCloudFormation.getString(properties.GlueVersion) : void 0), ret.addPropertyResult("logUri", "LogUri", properties.LogUri != null ? cfn_parse.FromCloudFormation.getString(properties.LogUri) : void 0), ret.addPropertyResult("maxCapacity", "MaxCapacity", properties.MaxCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxCapacity) : void 0), ret.addPropertyResult("maxRetries", "MaxRetries", properties.MaxRetries != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxRetries) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("nonOverridableArguments", "NonOverridableArguments", properties.NonOverridableArguments != null ? cfn_parse.FromCloudFormation.getAny(properties.NonOverridableArguments) : void 0), ret.addPropertyResult("notificationProperty", "NotificationProperty", properties.NotificationProperty != null ? CfnJobNotificationPropertyPropertyFromCloudFormation(properties.NotificationProperty) : void 0), ret.addPropertyResult("numberOfWorkers", "NumberOfWorkers", properties.NumberOfWorkers != null ? cfn_parse.FromCloudFormation.getNumber(properties.NumberOfWorkers) : void 0), ret.addPropertyResult("securityConfiguration", "SecurityConfiguration", properties.SecurityConfiguration != null ? cfn_parse.FromCloudFormation.getString(properties.SecurityConfiguration) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addPropertyResult("timeout", "Timeout", properties.Timeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.Timeout) : void 0), ret.addPropertyResult("workerType", "WorkerType", properties.WorkerType != null ? cfn_parse.FromCloudFormation.getString(properties.WorkerType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnJob = class _CfnJob extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnJobPropsFromCloudFormation(resourceProperties), ret = new _CfnJob(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnJob.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_glue_CfnJobProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnJob), error;
        }
        cdk.requireProperty(props, "command", this), cdk.requireProperty(props, "role", this), this.command = props.command, this.role = props.role, this.allocatedCapacity = props.allocatedCapacity, this.connections = props.connections, this.defaultArguments = props.defaultArguments, this.description = props.description, this.executionClass = props.executionClass, this.executionProperty = props.executionProperty, this.glueVersion = props.glueVersion, this.logUri = props.logUri, this.maxCapacity = props.maxCapacity, this.maxRetries = props.maxRetries, this.name = props.name, this.nonOverridableArguments = props.nonOverridableArguments, this.notificationProperty = props.notificationProperty, this.numberOfWorkers = props.numberOfWorkers, this.securityConfiguration = props.securityConfiguration, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Glue::Job", props.tags, { tagPropertyName: "tags" }), this.timeout = props.timeout, this.workerType = props.workerType;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnJob.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { command: this.command, role: this.role, allocatedCapacity: this.allocatedCapacity, connections: this.connections, defaultArguments: this.defaultArguments, description: this.description, executionClass: this.executionClass, executionProperty: this.executionProperty, glueVersion: this.glueVersion, logUri: this.logUri, maxCapacity: this.maxCapacity, maxRetries: this.maxRetries, name: this.name, nonOverridableArguments: this.nonOverridableArguments, notificationProperty: this.notificationProperty, numberOfWorkers: this.numberOfWorkers, securityConfiguration: this.securityConfiguration, tags: this.tags.renderTags(), timeout: this.timeout, workerType: this.workerType };
      }
      renderProperties(props) {
        return cfnJobPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnJob[_g] = { fqn: "aws-cdk-lib.aws_glue.CfnJob", version: "2.80.0" }, CfnJob.CFN_RESOURCE_TYPE_NAME = "AWS::Glue::Job", exports2.CfnJob = CfnJob;
    function CfnJob_ConnectionsListPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connections", cdk.listValidator(cdk.validateString))(properties.connections)), errors.wrap('supplied properties not correct for "ConnectionsListProperty"');
    }
    function cfnJobConnectionsListPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJob_ConnectionsListPropertyValidator(properties).assertSuccess(), { Connections: cdk.listMapper(cdk.stringToCloudFormation)(properties.connections) }) : properties;
    }
    function CfnJobConnectionsListPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connections", "Connections", properties.Connections != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Connections) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJob_ExecutionPropertyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxConcurrentRuns", cdk.validateNumber)(properties.maxConcurrentRuns)), errors.wrap('supplied properties not correct for "ExecutionPropertyProperty"');
    }
    function cfnJobExecutionPropertyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJob_ExecutionPropertyPropertyValidator(properties).assertSuccess(), { MaxConcurrentRuns: cdk.numberToCloudFormation(properties.maxConcurrentRuns) }) : properties;
    }
    function CfnJobExecutionPropertyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxConcurrentRuns", "MaxConcurrentRuns", properties.MaxConcurrentRuns != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxConcurrentRuns) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJob_JobCommandPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("pythonVersion", cdk.validateString)(properties.pythonVersion)), errors.collect(cdk.propertyValidator("scriptLocation", cdk.validateString)(properties.scriptLocation)), errors.wrap('supplied properties not correct for "JobCommandProperty"');
    }
    function cfnJobJobCommandPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJob_JobCommandPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), PythonVersion: cdk.stringToCloudFormation(properties.pythonVersion), ScriptLocation: cdk.stringToCloudFormation(properties.scriptLocation) }) : properties;
    }
    function CfnJobJobCommandPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("pythonVersion", "PythonVersion", properties.PythonVersion != null ? cfn_parse.FromCloudFormation.getString(properties.PythonVersion) : void 0), ret.addPropertyResult("scriptLocation", "ScriptLocation", properties.ScriptLocation != null ? cfn_parse.FromCloudFormation.getString(properties.ScriptLocation) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJob_NotificationPropertyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("notifyDelayAfter", cdk.validateNumber)(properties.notifyDelayAfter)), errors.wrap('supplied properties not correct for "NotificationPropertyProperty"');
    }
    function cfnJobNotificationPropertyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJob_NotificationPropertyPropertyValidator(properties).assertSuccess(), { NotifyDelayAfter: cdk.numberToCloudFormation(properties.notifyDelayAfter) }) : properties;
    }
    function CfnJobNotificationPropertyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("notifyDelayAfter", "NotifyDelayAfter", properties.NotifyDelayAfter != null ? cfn_parse.FromCloudFormation.getNumber(properties.NotifyDelayAfter) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMLTransformPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("glueVersion", cdk.validateString)(properties.glueVersion)), errors.collect(cdk.propertyValidator("inputRecordTables", cdk.requiredValidator)(properties.inputRecordTables)), errors.collect(cdk.propertyValidator("inputRecordTables", CfnMLTransform_InputRecordTablesPropertyValidator)(properties.inputRecordTables)), errors.collect(cdk.propertyValidator("maxCapacity", cdk.validateNumber)(properties.maxCapacity)), errors.collect(cdk.propertyValidator("maxRetries", cdk.validateNumber)(properties.maxRetries)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("numberOfWorkers", cdk.validateNumber)(properties.numberOfWorkers)), errors.collect(cdk.propertyValidator("role", cdk.requiredValidator)(properties.role)), errors.collect(cdk.propertyValidator("role", cdk.validateString)(properties.role)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.collect(cdk.propertyValidator("timeout", cdk.validateNumber)(properties.timeout)), errors.collect(cdk.propertyValidator("transformEncryption", CfnMLTransform_TransformEncryptionPropertyValidator)(properties.transformEncryption)), errors.collect(cdk.propertyValidator("transformParameters", cdk.requiredValidator)(properties.transformParameters)), errors.collect(cdk.propertyValidator("transformParameters", CfnMLTransform_TransformParametersPropertyValidator)(properties.transformParameters)), errors.collect(cdk.propertyValidator("workerType", cdk.validateString)(properties.workerType)), errors.wrap('supplied properties not correct for "CfnMLTransformProps"');
    }
    function cfnMLTransformPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMLTransformPropsValidator(properties).assertSuccess(), { InputRecordTables: cfnMLTransformInputRecordTablesPropertyToCloudFormation(properties.inputRecordTables), Role: cdk.stringToCloudFormation(properties.role), TransformParameters: cfnMLTransformTransformParametersPropertyToCloudFormation(properties.transformParameters), Description: cdk.stringToCloudFormation(properties.description), GlueVersion: cdk.stringToCloudFormation(properties.glueVersion), MaxCapacity: cdk.numberToCloudFormation(properties.maxCapacity), MaxRetries: cdk.numberToCloudFormation(properties.maxRetries), Name: cdk.stringToCloudFormation(properties.name), NumberOfWorkers: cdk.numberToCloudFormation(properties.numberOfWorkers), Tags: cdk.objectToCloudFormation(properties.tags), Timeout: cdk.numberToCloudFormation(properties.timeout), TransformEncryption: cfnMLTransformTransformEncryptionPropertyToCloudFormation(properties.transformEncryption), WorkerType: cdk.stringToCloudFormation(properties.workerType) }) : properties;
    }
    function CfnMLTransformPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("inputRecordTables", "InputRecordTables", CfnMLTransformInputRecordTablesPropertyFromCloudFormation(properties.InputRecordTables)), ret.addPropertyResult("role", "Role", cfn_parse.FromCloudFormation.getString(properties.Role)), ret.addPropertyResult("transformParameters", "TransformParameters", CfnMLTransformTransformParametersPropertyFromCloudFormation(properties.TransformParameters)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("glueVersion", "GlueVersion", properties.GlueVersion != null ? cfn_parse.FromCloudFormation.getString(properties.GlueVersion) : void 0), ret.addPropertyResult("maxCapacity", "MaxCapacity", properties.MaxCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxCapacity) : void 0), ret.addPropertyResult("maxRetries", "MaxRetries", properties.MaxRetries != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxRetries) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("numberOfWorkers", "NumberOfWorkers", properties.NumberOfWorkers != null ? cfn_parse.FromCloudFormation.getNumber(properties.NumberOfWorkers) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addPropertyResult("timeout", "Timeout", properties.Timeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.Timeout) : void 0), ret.addPropertyResult("transformEncryption", "TransformEncryption", properties.TransformEncryption != null ? CfnMLTransformTransformEncryptionPropertyFromCloudFormation(properties.TransformEncryption) : void 0), ret.addPropertyResult("workerType", "WorkerType", properties.WorkerType != null ? cfn_parse.FromCloudFormation.getString(properties.WorkerType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnMLTransform = class _CfnMLTransform extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnMLTransformPropsFromCloudFormation(resourceProperties), ret = new _CfnMLTransform(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnMLTransform.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_glue_CfnMLTransformProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnMLTransform), error;
        }
        cdk.requireProperty(props, "inputRecordTables", this), cdk.requireProperty(props, "role", this), cdk.requireProperty(props, "transformParameters", this), this.inputRecordTables = props.inputRecordTables, this.role = props.role, this.transformParameters = props.transformParameters, this.description = props.description, this.glueVersion = props.glueVersion, this.maxCapacity = props.maxCapacity, this.maxRetries = props.maxRetries, this.name = props.name, this.numberOfWorkers = props.numberOfWorkers, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Glue::MLTransform", props.tags, { tagPropertyName: "tags" }), this.timeout = props.timeout, this.transformEncryption = props.transformEncryption, this.workerType = props.workerType;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnMLTransform.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { inputRecordTables: this.inputRecordTables, role: this.role, transformParameters: this.transformParameters, description: this.description, glueVersion: this.glueVersion, maxCapacity: this.maxCapacity, maxRetries: this.maxRetries, name: this.name, numberOfWorkers: this.numberOfWorkers, tags: this.tags.renderTags(), timeout: this.timeout, transformEncryption: this.transformEncryption, workerType: this.workerType };
      }
      renderProperties(props) {
        return cfnMLTransformPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnMLTransform[_h] = { fqn: "aws-cdk-lib.aws_glue.CfnMLTransform", version: "2.80.0" }, CfnMLTransform.CFN_RESOURCE_TYPE_NAME = "AWS::Glue::MLTransform", exports2.CfnMLTransform = CfnMLTransform;
    function CfnMLTransform_FindMatchesParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accuracyCostTradeoff", cdk.validateNumber)(properties.accuracyCostTradeoff)), errors.collect(cdk.propertyValidator("enforceProvidedLabels", cdk.validateBoolean)(properties.enforceProvidedLabels)), errors.collect(cdk.propertyValidator("precisionRecallTradeoff", cdk.validateNumber)(properties.precisionRecallTradeoff)), errors.collect(cdk.propertyValidator("primaryKeyColumnName", cdk.requiredValidator)(properties.primaryKeyColumnName)), errors.collect(cdk.propertyValidator("primaryKeyColumnName", cdk.validateString)(properties.primaryKeyColumnName)), errors.wrap('supplied properties not correct for "FindMatchesParametersProperty"');
    }
    function cfnMLTransformFindMatchesParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMLTransform_FindMatchesParametersPropertyValidator(properties).assertSuccess(), { AccuracyCostTradeoff: cdk.numberToCloudFormation(properties.accuracyCostTradeoff), EnforceProvidedLabels: cdk.booleanToCloudFormation(properties.enforceProvidedLabels), PrecisionRecallTradeoff: cdk.numberToCloudFormation(properties.precisionRecallTradeoff), PrimaryKeyColumnName: cdk.stringToCloudFormation(properties.primaryKeyColumnName) }) : properties;
    }
    function CfnMLTransformFindMatchesParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accuracyCostTradeoff", "AccuracyCostTradeoff", properties.AccuracyCostTradeoff != null ? cfn_parse.FromCloudFormation.getNumber(properties.AccuracyCostTradeoff) : void 0), ret.addPropertyResult("enforceProvidedLabels", "EnforceProvidedLabels", properties.EnforceProvidedLabels != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnforceProvidedLabels) : void 0), ret.addPropertyResult("precisionRecallTradeoff", "PrecisionRecallTradeoff", properties.PrecisionRecallTradeoff != null ? cfn_parse.FromCloudFormation.getNumber(properties.PrecisionRecallTradeoff) : void 0), ret.addPropertyResult("primaryKeyColumnName", "PrimaryKeyColumnName", cfn_parse.FromCloudFormation.getString(properties.PrimaryKeyColumnName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMLTransform_GlueTablesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalogId", cdk.validateString)(properties.catalogId)), errors.collect(cdk.propertyValidator("connectionName", cdk.validateString)(properties.connectionName)), errors.collect(cdk.propertyValidator("databaseName", cdk.requiredValidator)(properties.databaseName)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("tableName", cdk.requiredValidator)(properties.tableName)), errors.collect(cdk.propertyValidator("tableName", cdk.validateString)(properties.tableName)), errors.wrap('supplied properties not correct for "GlueTablesProperty"');
    }
    function cfnMLTransformGlueTablesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMLTransform_GlueTablesPropertyValidator(properties).assertSuccess(), { CatalogId: cdk.stringToCloudFormation(properties.catalogId), ConnectionName: cdk.stringToCloudFormation(properties.connectionName), DatabaseName: cdk.stringToCloudFormation(properties.databaseName), TableName: cdk.stringToCloudFormation(properties.tableName) }) : properties;
    }
    function CfnMLTransformGlueTablesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalogId", "CatalogId", properties.CatalogId != null ? cfn_parse.FromCloudFormation.getString(properties.CatalogId) : void 0), ret.addPropertyResult("connectionName", "ConnectionName", properties.ConnectionName != null ? cfn_parse.FromCloudFormation.getString(properties.ConnectionName) : void 0), ret.addPropertyResult("databaseName", "DatabaseName", cfn_parse.FromCloudFormation.getString(properties.DatabaseName)), ret.addPropertyResult("tableName", "TableName", cfn_parse.FromCloudFormation.getString(properties.TableName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMLTransform_InputRecordTablesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("glueTables", cdk.listValidator(CfnMLTransform_GlueTablesPropertyValidator))(properties.glueTables)), errors.wrap('supplied properties not correct for "InputRecordTablesProperty"');
    }
    function cfnMLTransformInputRecordTablesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMLTransform_InputRecordTablesPropertyValidator(properties).assertSuccess(), { GlueTables: cdk.listMapper(cfnMLTransformGlueTablesPropertyToCloudFormation)(properties.glueTables) }) : properties;
    }
    function CfnMLTransformInputRecordTablesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("glueTables", "GlueTables", properties.GlueTables != null ? cfn_parse.FromCloudFormation.getArray(CfnMLTransformGlueTablesPropertyFromCloudFormation)(properties.GlueTables) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMLTransform_MLUserDataEncryptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("mlUserDataEncryptionMode", cdk.requiredValidator)(properties.mlUserDataEncryptionMode)), errors.collect(cdk.propertyValidator("mlUserDataEncryptionMode", cdk.validateString)(properties.mlUserDataEncryptionMode)), errors.wrap('supplied properties not correct for "MLUserDataEncryptionProperty"');
    }
    function cfnMLTransformMLUserDataEncryptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMLTransform_MLUserDataEncryptionPropertyValidator(properties).assertSuccess(), { KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), MLUserDataEncryptionMode: cdk.stringToCloudFormation(properties.mlUserDataEncryptionMode) }) : properties;
    }
    function CfnMLTransformMLUserDataEncryptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("mlUserDataEncryptionMode", "MLUserDataEncryptionMode", cfn_parse.FromCloudFormation.getString(properties.MLUserDataEncryptionMode)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMLTransform_TransformEncryptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mlUserDataEncryption", CfnMLTransform_MLUserDataEncryptionPropertyValidator)(properties.mlUserDataEncryption)), errors.collect(cdk.propertyValidator("taskRunSecurityConfigurationName", cdk.validateString)(properties.taskRunSecurityConfigurationName)), errors.wrap('supplied properties not correct for "TransformEncryptionProperty"');
    }
    function cfnMLTransformTransformEncryptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMLTransform_TransformEncryptionPropertyValidator(properties).assertSuccess(), { MLUserDataEncryption: cfnMLTransformMLUserDataEncryptionPropertyToCloudFormation(properties.mlUserDataEncryption), TaskRunSecurityConfigurationName: cdk.stringToCloudFormation(properties.taskRunSecurityConfigurationName) }) : properties;
    }
    function CfnMLTransformTransformEncryptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mlUserDataEncryption", "MLUserDataEncryption", properties.MLUserDataEncryption != null ? CfnMLTransformMLUserDataEncryptionPropertyFromCloudFormation(properties.MLUserDataEncryption) : void 0), ret.addPropertyResult("taskRunSecurityConfigurationName", "TaskRunSecurityConfigurationName", properties.TaskRunSecurityConfigurationName != null ? cfn_parse.FromCloudFormation.getString(properties.TaskRunSecurityConfigurationName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMLTransform_TransformParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("findMatchesParameters", CfnMLTransform_FindMatchesParametersPropertyValidator)(properties.findMatchesParameters)), errors.collect(cdk.propertyValidator("transformType", cdk.requiredValidator)(properties.transformType)), errors.collect(cdk.propertyValidator("transformType", cdk.validateString)(properties.transformType)), errors.wrap('supplied properties not correct for "TransformParametersProperty"');
    }
    function cfnMLTransformTransformParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMLTransform_TransformParametersPropertyValidator(properties).assertSuccess(), { FindMatchesParameters: cfnMLTransformFindMatchesParametersPropertyToCloudFormation(properties.findMatchesParameters), TransformType: cdk.stringToCloudFormation(properties.transformType) }) : properties;
    }
    function CfnMLTransformTransformParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("findMatchesParameters", "FindMatchesParameters", properties.FindMatchesParameters != null ? CfnMLTransformFindMatchesParametersPropertyFromCloudFormation(properties.FindMatchesParameters) : void 0), ret.addPropertyResult("transformType", "TransformType", cfn_parse.FromCloudFormation.getString(properties.TransformType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPartitionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalogId", cdk.requiredValidator)(properties.catalogId)), errors.collect(cdk.propertyValidator("catalogId", cdk.validateString)(properties.catalogId)), errors.collect(cdk.propertyValidator("databaseName", cdk.requiredValidator)(properties.databaseName)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("partitionInput", cdk.requiredValidator)(properties.partitionInput)), errors.collect(cdk.propertyValidator("partitionInput", CfnPartition_PartitionInputPropertyValidator)(properties.partitionInput)), errors.collect(cdk.propertyValidator("tableName", cdk.requiredValidator)(properties.tableName)), errors.collect(cdk.propertyValidator("tableName", cdk.validateString)(properties.tableName)), errors.wrap('supplied properties not correct for "CfnPartitionProps"');
    }
    function cfnPartitionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPartitionPropsValidator(properties).assertSuccess(), { CatalogId: cdk.stringToCloudFormation(properties.catalogId), DatabaseName: cdk.stringToCloudFormation(properties.databaseName), PartitionInput: cfnPartitionPartitionInputPropertyToCloudFormation(properties.partitionInput), TableName: cdk.stringToCloudFormation(properties.tableName) }) : properties;
    }
    function CfnPartitionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalogId", "CatalogId", cfn_parse.FromCloudFormation.getString(properties.CatalogId)), ret.addPropertyResult("databaseName", "DatabaseName", cfn_parse.FromCloudFormation.getString(properties.DatabaseName)), ret.addPropertyResult("partitionInput", "PartitionInput", CfnPartitionPartitionInputPropertyFromCloudFormation(properties.PartitionInput)), ret.addPropertyResult("tableName", "TableName", cfn_parse.FromCloudFormation.getString(properties.TableName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPartition = class _CfnPartition extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPartitionPropsFromCloudFormation(resourceProperties), ret = new _CfnPartition(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPartition.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_glue_CfnPartitionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPartition), error;
        }
        cdk.requireProperty(props, "catalogId", this), cdk.requireProperty(props, "databaseName", this), cdk.requireProperty(props, "partitionInput", this), cdk.requireProperty(props, "tableName", this), this.catalogId = props.catalogId, this.databaseName = props.databaseName, this.partitionInput = props.partitionInput, this.tableName = props.tableName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPartition.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { catalogId: this.catalogId, databaseName: this.databaseName, partitionInput: this.partitionInput, tableName: this.tableName };
      }
      renderProperties(props) {
        return cfnPartitionPropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnPartition[_j] = { fqn: "aws-cdk-lib.aws_glue.CfnPartition", version: "2.80.0" }, CfnPartition.CFN_RESOURCE_TYPE_NAME = "AWS::Glue::Partition", exports2.CfnPartition = CfnPartition;
    function CfnPartition_ColumnPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("comment", cdk.validateString)(properties.comment)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "ColumnProperty"');
    }
    function cfnPartitionColumnPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPartition_ColumnPropertyValidator(properties).assertSuccess(), { Comment: cdk.stringToCloudFormation(properties.comment), Name: cdk.stringToCloudFormation(properties.name), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnPartitionColumnPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("comment", "Comment", properties.Comment != null ? cfn_parse.FromCloudFormation.getString(properties.Comment) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPartition_OrderPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", cdk.validateString)(properties.column)), errors.collect(cdk.propertyValidator("sortOrder", cdk.validateNumber)(properties.sortOrder)), errors.wrap('supplied properties not correct for "OrderProperty"');
    }
    function cfnPartitionOrderPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPartition_OrderPropertyValidator(properties).assertSuccess(), { Column: cdk.stringToCloudFormation(properties.column), SortOrder: cdk.numberToCloudFormation(properties.sortOrder) }) : properties;
    }
    function CfnPartitionOrderPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", cfn_parse.FromCloudFormation.getString(properties.Column)), ret.addPropertyResult("sortOrder", "SortOrder", properties.SortOrder != null ? cfn_parse.FromCloudFormation.getNumber(properties.SortOrder) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPartition_PartitionInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("parameters", cdk.validateObject)(properties.parameters)), errors.collect(cdk.propertyValidator("storageDescriptor", CfnPartition_StorageDescriptorPropertyValidator)(properties.storageDescriptor)), errors.collect(cdk.propertyValidator("values", cdk.requiredValidator)(properties.values)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "PartitionInputProperty"');
    }
    function cfnPartitionPartitionInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPartition_PartitionInputPropertyValidator(properties).assertSuccess(), { Parameters: cdk.objectToCloudFormation(properties.parameters), StorageDescriptor: cfnPartitionStorageDescriptorPropertyToCloudFormation(properties.storageDescriptor), Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnPartitionPartitionInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getAny(properties.Parameters) : void 0), ret.addPropertyResult("storageDescriptor", "StorageDescriptor", properties.StorageDescriptor != null ? CfnPartitionStorageDescriptorPropertyFromCloudFormation(properties.StorageDescriptor) : void 0), ret.addPropertyResult("values", "Values", cfn_parse.FromCloudFormation.getStringArray(properties.Values)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPartition_SchemaIdPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("registryName", cdk.validateString)(properties.registryName)), errors.collect(cdk.propertyValidator("schemaArn", cdk.validateString)(properties.schemaArn)), errors.collect(cdk.propertyValidator("schemaName", cdk.validateString)(properties.schemaName)), errors.wrap('supplied properties not correct for "SchemaIdProperty"');
    }
    function cfnPartitionSchemaIdPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPartition_SchemaIdPropertyValidator(properties).assertSuccess(), { RegistryName: cdk.stringToCloudFormation(properties.registryName), SchemaArn: cdk.stringToCloudFormation(properties.schemaArn), SchemaName: cdk.stringToCloudFormation(properties.schemaName) }) : properties;
    }
    function CfnPartitionSchemaIdPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("registryName", "RegistryName", properties.RegistryName != null ? cfn_parse.FromCloudFormation.getString(properties.RegistryName) : void 0), ret.addPropertyResult("schemaArn", "SchemaArn", properties.SchemaArn != null ? cfn_parse.FromCloudFormation.getString(properties.SchemaArn) : void 0), ret.addPropertyResult("schemaName", "SchemaName", properties.SchemaName != null ? cfn_parse.FromCloudFormation.getString(properties.SchemaName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPartition_SchemaReferencePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("schemaId", CfnPartition_SchemaIdPropertyValidator)(properties.schemaId)), errors.collect(cdk.propertyValidator("schemaVersionId", cdk.validateString)(properties.schemaVersionId)), errors.collect(cdk.propertyValidator("schemaVersionNumber", cdk.validateNumber)(properties.schemaVersionNumber)), errors.wrap('supplied properties not correct for "SchemaReferenceProperty"');
    }
    function cfnPartitionSchemaReferencePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPartition_SchemaReferencePropertyValidator(properties).assertSuccess(), { SchemaId: cfnPartitionSchemaIdPropertyToCloudFormation(properties.schemaId), SchemaVersionId: cdk.stringToCloudFormation(properties.schemaVersionId), SchemaVersionNumber: cdk.numberToCloudFormation(properties.schemaVersionNumber) }) : properties;
    }
    function CfnPartitionSchemaReferencePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("schemaId", "SchemaId", properties.SchemaId != null ? CfnPartitionSchemaIdPropertyFromCloudFormation(properties.SchemaId) : void 0), ret.addPropertyResult("schemaVersionId", "SchemaVersionId", properties.SchemaVersionId != null ? cfn_parse.FromCloudFormation.getString(properties.SchemaVersionId) : void 0), ret.addPropertyResult("schemaVersionNumber", "SchemaVersionNumber", properties.SchemaVersionNumber != null ? cfn_parse.FromCloudFormation.getNumber(properties.SchemaVersionNumber) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPartition_SerdeInfoPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("parameters", cdk.validateObject)(properties.parameters)), errors.collect(cdk.propertyValidator("serializationLibrary", cdk.validateString)(properties.serializationLibrary)), errors.wrap('supplied properties not correct for "SerdeInfoProperty"');
    }
    function cfnPartitionSerdeInfoPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPartition_SerdeInfoPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Parameters: cdk.objectToCloudFormation(properties.parameters), SerializationLibrary: cdk.stringToCloudFormation(properties.serializationLibrary) }) : properties;
    }
    function CfnPartitionSerdeInfoPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getAny(properties.Parameters) : void 0), ret.addPropertyResult("serializationLibrary", "SerializationLibrary", properties.SerializationLibrary != null ? cfn_parse.FromCloudFormation.getString(properties.SerializationLibrary) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPartition_SkewedInfoPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("skewedColumnNames", cdk.listValidator(cdk.validateString))(properties.skewedColumnNames)), errors.collect(cdk.propertyValidator("skewedColumnValueLocationMaps", cdk.validateObject)(properties.skewedColumnValueLocationMaps)), errors.collect(cdk.propertyValidator("skewedColumnValues", cdk.listValidator(cdk.validateString))(properties.skewedColumnValues)), errors.wrap('supplied properties not correct for "SkewedInfoProperty"');
    }
    function cfnPartitionSkewedInfoPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPartition_SkewedInfoPropertyValidator(properties).assertSuccess(), { SkewedColumnNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.skewedColumnNames), SkewedColumnValueLocationMaps: cdk.objectToCloudFormation(properties.skewedColumnValueLocationMaps), SkewedColumnValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.skewedColumnValues) }) : properties;
    }
    function CfnPartitionSkewedInfoPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("skewedColumnNames", "SkewedColumnNames", properties.SkewedColumnNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SkewedColumnNames) : void 0), ret.addPropertyResult("skewedColumnValueLocationMaps", "SkewedColumnValueLocationMaps", properties.SkewedColumnValueLocationMaps != null ? cfn_parse.FromCloudFormation.getAny(properties.SkewedColumnValueLocationMaps) : void 0), ret.addPropertyResult("skewedColumnValues", "SkewedColumnValues", properties.SkewedColumnValues != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SkewedColumnValues) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPartition_StorageDescriptorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketColumns", cdk.listValidator(cdk.validateString))(properties.bucketColumns)), errors.collect(cdk.propertyValidator("columns", cdk.listValidator(CfnPartition_ColumnPropertyValidator))(properties.columns)), errors.collect(cdk.propertyValidator("compressed", cdk.validateBoolean)(properties.compressed)), errors.collect(cdk.propertyValidator("inputFormat", cdk.validateString)(properties.inputFormat)), errors.collect(cdk.propertyValidator("location", cdk.validateString)(properties.location)), errors.collect(cdk.propertyValidator("numberOfBuckets", cdk.validateNumber)(properties.numberOfBuckets)), errors.collect(cdk.propertyValidator("outputFormat", cdk.validateString)(properties.outputFormat)), errors.collect(cdk.propertyValidator("parameters", cdk.validateObject)(properties.parameters)), errors.collect(cdk.propertyValidator("schemaReference", CfnPartition_SchemaReferencePropertyValidator)(properties.schemaReference)), errors.collect(cdk.propertyValidator("serdeInfo", CfnPartition_SerdeInfoPropertyValidator)(properties.serdeInfo)), errors.collect(cdk.propertyValidator("skewedInfo", CfnPartition_SkewedInfoPropertyValidator)(properties.skewedInfo)), errors.collect(cdk.propertyValidator("sortColumns", cdk.listValidator(CfnPartition_OrderPropertyValidator))(properties.sortColumns)), errors.collect(cdk.propertyValidator("storedAsSubDirectories", cdk.validateBoolean)(properties.storedAsSubDirectories)), errors.wrap('supplied properties not correct for "StorageDescriptorProperty"');
    }
    function cfnPartitionStorageDescriptorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPartition_StorageDescriptorPropertyValidator(properties).assertSuccess(), { BucketColumns: cdk.listMapper(cdk.stringToCloudFormation)(properties.bucketColumns), Columns: cdk.listMapper(cfnPartitionColumnPropertyToCloudFormation)(properties.columns), Compressed: cdk.booleanToCloudFormation(properties.compressed), InputFormat: cdk.stringToCloudFormation(properties.inputFormat), Location: cdk.stringToCloudFormation(properties.location), NumberOfBuckets: cdk.numberToCloudFormation(properties.numberOfBuckets), OutputFormat: cdk.stringToCloudFormation(properties.outputFormat), Parameters: cdk.objectToCloudFormation(properties.parameters), SchemaReference: cfnPartitionSchemaReferencePropertyToCloudFormation(properties.schemaReference), SerdeInfo: cfnPartitionSerdeInfoPropertyToCloudFormation(properties.serdeInfo), SkewedInfo: cfnPartitionSkewedInfoPropertyToCloudFormation(properties.skewedInfo), SortColumns: cdk.listMapper(cfnPartitionOrderPropertyToCloudFormation)(properties.sortColumns), StoredAsSubDirectories: cdk.booleanToCloudFormation(properties.storedAsSubDirectories) }) : properties;
    }
    function CfnPartitionStorageDescriptorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketColumns", "BucketColumns", properties.BucketColumns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.BucketColumns) : void 0), ret.addPropertyResult("columns", "Columns", properties.Columns != null ? cfn_parse.FromCloudFormation.getArray(CfnPartitionColumnPropertyFromCloudFormation)(properties.Columns) : void 0), ret.addPropertyResult("compressed", "Compressed", properties.Compressed != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Compressed) : void 0), ret.addPropertyResult("inputFormat", "InputFormat", properties.InputFormat != null ? cfn_parse.FromCloudFormation.getString(properties.InputFormat) : void 0), ret.addPropertyResult("location", "Location", properties.Location != null ? cfn_parse.FromCloudFormation.getString(properties.Location) : void 0), ret.addPropertyResult("numberOfBuckets", "NumberOfBuckets", properties.NumberOfBuckets != null ? cfn_parse.FromCloudFormation.getNumber(properties.NumberOfBuckets) : void 0), ret.addPropertyResult("outputFormat", "OutputFormat", properties.OutputFormat != null ? cfn_parse.FromCloudFormation.getString(properties.OutputFormat) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getAny(properties.Parameters) : void 0), ret.addPropertyResult("schemaReference", "SchemaReference", properties.SchemaReference != null ? CfnPartitionSchemaReferencePropertyFromCloudFormation(properties.SchemaReference) : void 0), ret.addPropertyResult("serdeInfo", "SerdeInfo", properties.SerdeInfo != null ? CfnPartitionSerdeInfoPropertyFromCloudFormation(properties.SerdeInfo) : void 0), ret.addPropertyResult("skewedInfo", "SkewedInfo", properties.SkewedInfo != null ? CfnPartitionSkewedInfoPropertyFromCloudFormation(properties.SkewedInfo) : void 0), ret.addPropertyResult("sortColumns", "SortColumns", properties.SortColumns != null ? cfn_parse.FromCloudFormation.getArray(CfnPartitionOrderPropertyFromCloudFormation)(properties.SortColumns) : void 0), ret.addPropertyResult("storedAsSubDirectories", "StoredAsSubDirectories", properties.StoredAsSubDirectories != null ? cfn_parse.FromCloudFormation.getBoolean(properties.StoredAsSubDirectories) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRegistryPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnRegistryProps"');
    }
    function cfnRegistryPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRegistryPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnRegistryPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRegistry = class _CfnRegistry extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRegistryPropsFromCloudFormation(resourceProperties), ret = new _CfnRegistry(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRegistry.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_glue_CfnRegistryProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRegistry), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Glue::Registry", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRegistry.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnRegistryPropsToCloudFormation(props);
      }
    };
    _k = JSII_RTTI_SYMBOL_1, CfnRegistry[_k] = { fqn: "aws-cdk-lib.aws_glue.CfnRegistry", version: "2.80.0" }, CfnRegistry.CFN_RESOURCE_TYPE_NAME = "AWS::Glue::Registry", exports2.CfnRegistry = CfnRegistry;
    function CfnSchemaPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("checkpointVersion", CfnSchema_SchemaVersionPropertyValidator)(properties.checkpointVersion)), errors.collect(cdk.propertyValidator("compatibility", cdk.requiredValidator)(properties.compatibility)), errors.collect(cdk.propertyValidator("compatibility", cdk.validateString)(properties.compatibility)), errors.collect(cdk.propertyValidator("dataFormat", cdk.requiredValidator)(properties.dataFormat)), errors.collect(cdk.propertyValidator("dataFormat", cdk.validateString)(properties.dataFormat)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("registry", CfnSchema_RegistryPropertyValidator)(properties.registry)), errors.collect(cdk.propertyValidator("schemaDefinition", cdk.requiredValidator)(properties.schemaDefinition)), errors.collect(cdk.propertyValidator("schemaDefinition", cdk.validateString)(properties.schemaDefinition)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnSchemaProps"');
    }
    function cfnSchemaPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSchemaPropsValidator(properties).assertSuccess(), { Compatibility: cdk.stringToCloudFormation(properties.compatibility), DataFormat: cdk.stringToCloudFormation(properties.dataFormat), Name: cdk.stringToCloudFormation(properties.name), SchemaDefinition: cdk.stringToCloudFormation(properties.schemaDefinition), CheckpointVersion: cfnSchemaSchemaVersionPropertyToCloudFormation(properties.checkpointVersion), Description: cdk.stringToCloudFormation(properties.description), Registry: cfnSchemaRegistryPropertyToCloudFormation(properties.registry), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnSchemaPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("compatibility", "Compatibility", cfn_parse.FromCloudFormation.getString(properties.Compatibility)), ret.addPropertyResult("dataFormat", "DataFormat", cfn_parse.FromCloudFormation.getString(properties.DataFormat)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("schemaDefinition", "SchemaDefinition", cfn_parse.FromCloudFormation.getString(properties.SchemaDefinition)), ret.addPropertyResult("checkpointVersion", "CheckpointVersion", properties.CheckpointVersion != null ? CfnSchemaSchemaVersionPropertyFromCloudFormation(properties.CheckpointVersion) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("registry", "Registry", properties.Registry != null ? CfnSchemaRegistryPropertyFromCloudFormation(properties.Registry) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSchema = class _CfnSchema extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSchemaPropsFromCloudFormation(resourceProperties), ret = new _CfnSchema(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSchema.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_glue_CfnSchemaProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSchema), error;
        }
        cdk.requireProperty(props, "compatibility", this), cdk.requireProperty(props, "dataFormat", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "schemaDefinition", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrInitialSchemaVersionId = cdk.Token.asString(this.getAtt("InitialSchemaVersionId", cdk.ResolutionTypeHint.STRING)), this.compatibility = props.compatibility, this.dataFormat = props.dataFormat, this.name = props.name, this.schemaDefinition = props.schemaDefinition, this.checkpointVersion = props.checkpointVersion, this.description = props.description, this.registry = props.registry, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Glue::Schema", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSchema.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { compatibility: this.compatibility, dataFormat: this.dataFormat, name: this.name, schemaDefinition: this.schemaDefinition, checkpointVersion: this.checkpointVersion, description: this.description, registry: this.registry, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnSchemaPropsToCloudFormation(props);
      }
    };
    _l = JSII_RTTI_SYMBOL_1, CfnSchema[_l] = { fqn: "aws-cdk-lib.aws_glue.CfnSchema", version: "2.80.0" }, CfnSchema.CFN_RESOURCE_TYPE_NAME = "AWS::Glue::Schema", exports2.CfnSchema = CfnSchema;
    function CfnSchema_RegistryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "RegistryProperty"');
    }
    function cfnSchemaRegistryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSchema_RegistryPropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnSchemaRegistryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", properties.Arn != null ? cfn_parse.FromCloudFormation.getString(properties.Arn) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSchema_SchemaVersionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("isLatest", cdk.validateBoolean)(properties.isLatest)), errors.collect(cdk.propertyValidator("versionNumber", cdk.validateNumber)(properties.versionNumber)), errors.wrap('supplied properties not correct for "SchemaVersionProperty"');
    }
    function cfnSchemaSchemaVersionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSchema_SchemaVersionPropertyValidator(properties).assertSuccess(), { IsLatest: cdk.booleanToCloudFormation(properties.isLatest), VersionNumber: cdk.numberToCloudFormation(properties.versionNumber) }) : properties;
    }
    function CfnSchemaSchemaVersionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("isLatest", "IsLatest", properties.IsLatest != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsLatest) : void 0), ret.addPropertyResult("versionNumber", "VersionNumber", properties.VersionNumber != null ? cfn_parse.FromCloudFormation.getNumber(properties.VersionNumber) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSchemaVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("schema", cdk.requiredValidator)(properties.schema)), errors.collect(cdk.propertyValidator("schema", CfnSchemaVersion_SchemaPropertyValidator)(properties.schema)), errors.collect(cdk.propertyValidator("schemaDefinition", cdk.requiredValidator)(properties.schemaDefinition)), errors.collect(cdk.propertyValidator("schemaDefinition", cdk.validateString)(properties.schemaDefinition)), errors.wrap('supplied properties not correct for "CfnSchemaVersionProps"');
    }
    function cfnSchemaVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSchemaVersionPropsValidator(properties).assertSuccess(), { Schema: cfnSchemaVersionSchemaPropertyToCloudFormation(properties.schema), SchemaDefinition: cdk.stringToCloudFormation(properties.schemaDefinition) }) : properties;
    }
    function CfnSchemaVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("schema", "Schema", CfnSchemaVersionSchemaPropertyFromCloudFormation(properties.Schema)), ret.addPropertyResult("schemaDefinition", "SchemaDefinition", cfn_parse.FromCloudFormation.getString(properties.SchemaDefinition)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSchemaVersion = class _CfnSchemaVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSchemaVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnSchemaVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSchemaVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_glue_CfnSchemaVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSchemaVersion), error;
        }
        cdk.requireProperty(props, "schema", this), cdk.requireProperty(props, "schemaDefinition", this), this.attrVersionId = cdk.Token.asString(this.getAtt("VersionId", cdk.ResolutionTypeHint.STRING)), this.schema = props.schema, this.schemaDefinition = props.schemaDefinition;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSchemaVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { schema: this.schema, schemaDefinition: this.schemaDefinition };
      }
      renderProperties(props) {
        return cfnSchemaVersionPropsToCloudFormation(props);
      }
    };
    _m = JSII_RTTI_SYMBOL_1, CfnSchemaVersion[_m] = { fqn: "aws-cdk-lib.aws_glue.CfnSchemaVersion", version: "2.80.0" }, CfnSchemaVersion.CFN_RESOURCE_TYPE_NAME = "AWS::Glue::SchemaVersion", exports2.CfnSchemaVersion = CfnSchemaVersion;
    function CfnSchemaVersion_SchemaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("registryName", cdk.validateString)(properties.registryName)), errors.collect(cdk.propertyValidator("schemaArn", cdk.validateString)(properties.schemaArn)), errors.collect(cdk.propertyValidator("schemaName", cdk.validateString)(properties.schemaName)), errors.wrap('supplied properties not correct for "SchemaProperty"');
    }
    function cfnSchemaVersionSchemaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSchemaVersion_SchemaPropertyValidator(properties).assertSuccess(), { RegistryName: cdk.stringToCloudFormation(properties.registryName), SchemaArn: cdk.stringToCloudFormation(properties.schemaArn), SchemaName: cdk.stringToCloudFormation(properties.schemaName) }) : properties;
    }
    function CfnSchemaVersionSchemaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("registryName", "RegistryName", properties.RegistryName != null ? cfn_parse.FromCloudFormation.getString(properties.RegistryName) : void 0), ret.addPropertyResult("schemaArn", "SchemaArn", properties.SchemaArn != null ? cfn_parse.FromCloudFormation.getString(properties.SchemaArn) : void 0), ret.addPropertyResult("schemaName", "SchemaName", properties.SchemaName != null ? cfn_parse.FromCloudFormation.getString(properties.SchemaName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSchemaVersionMetadataPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("schemaVersionId", cdk.requiredValidator)(properties.schemaVersionId)), errors.collect(cdk.propertyValidator("schemaVersionId", cdk.validateString)(properties.schemaVersionId)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "CfnSchemaVersionMetadataProps"');
    }
    function cfnSchemaVersionMetadataPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSchemaVersionMetadataPropsValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), SchemaVersionId: cdk.stringToCloudFormation(properties.schemaVersionId), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnSchemaVersionMetadataPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("schemaVersionId", "SchemaVersionId", cfn_parse.FromCloudFormation.getString(properties.SchemaVersionId)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSchemaVersionMetadata = class _CfnSchemaVersionMetadata extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSchemaVersionMetadataPropsFromCloudFormation(resourceProperties), ret = new _CfnSchemaVersionMetadata(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSchemaVersionMetadata.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_glue_CfnSchemaVersionMetadataProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSchemaVersionMetadata), error;
        }
        cdk.requireProperty(props, "key", this), cdk.requireProperty(props, "schemaVersionId", this), cdk.requireProperty(props, "value", this), this.key = props.key, this.schemaVersionId = props.schemaVersionId, this.value = props.value;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSchemaVersionMetadata.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { key: this.key, schemaVersionId: this.schemaVersionId, value: this.value };
      }
      renderProperties(props) {
        return cfnSchemaVersionMetadataPropsToCloudFormation(props);
      }
    };
    _o = JSII_RTTI_SYMBOL_1, CfnSchemaVersionMetadata[_o] = { fqn: "aws-cdk-lib.aws_glue.CfnSchemaVersionMetadata", version: "2.80.0" }, CfnSchemaVersionMetadata.CFN_RESOURCE_TYPE_NAME = "AWS::Glue::SchemaVersionMetadata", exports2.CfnSchemaVersionMetadata = CfnSchemaVersionMetadata;
    function CfnSecurityConfigurationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("encryptionConfiguration", cdk.requiredValidator)(properties.encryptionConfiguration)), errors.collect(cdk.propertyValidator("encryptionConfiguration", CfnSecurityConfiguration_EncryptionConfigurationPropertyValidator)(properties.encryptionConfiguration)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "CfnSecurityConfigurationProps"');
    }
    function cfnSecurityConfigurationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSecurityConfigurationPropsValidator(properties).assertSuccess(), { EncryptionConfiguration: cfnSecurityConfigurationEncryptionConfigurationPropertyToCloudFormation(properties.encryptionConfiguration), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnSecurityConfigurationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("encryptionConfiguration", "EncryptionConfiguration", CfnSecurityConfigurationEncryptionConfigurationPropertyFromCloudFormation(properties.EncryptionConfiguration)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSecurityConfiguration = class _CfnSecurityConfiguration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSecurityConfigurationPropsFromCloudFormation(resourceProperties), ret = new _CfnSecurityConfiguration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSecurityConfiguration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_glue_CfnSecurityConfigurationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSecurityConfiguration), error;
        }
        cdk.requireProperty(props, "encryptionConfiguration", this), cdk.requireProperty(props, "name", this), this.encryptionConfiguration = props.encryptionConfiguration, this.name = props.name;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSecurityConfiguration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { encryptionConfiguration: this.encryptionConfiguration, name: this.name };
      }
      renderProperties(props) {
        return cfnSecurityConfigurationPropsToCloudFormation(props);
      }
    };
    _p = JSII_RTTI_SYMBOL_1, CfnSecurityConfiguration[_p] = { fqn: "aws-cdk-lib.aws_glue.CfnSecurityConfiguration", version: "2.80.0" }, CfnSecurityConfiguration.CFN_RESOURCE_TYPE_NAME = "AWS::Glue::SecurityConfiguration", exports2.CfnSecurityConfiguration = CfnSecurityConfiguration;
    function CfnSecurityConfiguration_CloudWatchEncryptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchEncryptionMode", cdk.validateString)(properties.cloudWatchEncryptionMode)), errors.collect(cdk.propertyValidator("kmsKeyArn", cdk.validateString)(properties.kmsKeyArn)), errors.wrap('supplied properties not correct for "CloudWatchEncryptionProperty"');
    }
    function cfnSecurityConfigurationCloudWatchEncryptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSecurityConfiguration_CloudWatchEncryptionPropertyValidator(properties).assertSuccess(), { CloudWatchEncryptionMode: cdk.stringToCloudFormation(properties.cloudWatchEncryptionMode), KmsKeyArn: cdk.stringToCloudFormation(properties.kmsKeyArn) }) : properties;
    }
    function CfnSecurityConfigurationCloudWatchEncryptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchEncryptionMode", "CloudWatchEncryptionMode", properties.CloudWatchEncryptionMode != null ? cfn_parse.FromCloudFormation.getString(properties.CloudWatchEncryptionMode) : void 0), ret.addPropertyResult("kmsKeyArn", "KmsKeyArn", properties.KmsKeyArn != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSecurityConfiguration_EncryptionConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchEncryption", CfnSecurityConfiguration_CloudWatchEncryptionPropertyValidator)(properties.cloudWatchEncryption)), errors.collect(cdk.propertyValidator("jobBookmarksEncryption", CfnSecurityConfiguration_JobBookmarksEncryptionPropertyValidator)(properties.jobBookmarksEncryption)), errors.collect(cdk.propertyValidator("s3Encryptions", cdk.listValidator(CfnSecurityConfiguration_S3EncryptionPropertyValidator))(properties.s3Encryptions)), errors.wrap('supplied properties not correct for "EncryptionConfigurationProperty"');
    }
    function cfnSecurityConfigurationEncryptionConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSecurityConfiguration_EncryptionConfigurationPropertyValidator(properties).assertSuccess(), { CloudWatchEncryption: cfnSecurityConfigurationCloudWatchEncryptionPropertyToCloudFormation(properties.cloudWatchEncryption), JobBookmarksEncryption: cfnSecurityConfigurationJobBookmarksEncryptionPropertyToCloudFormation(properties.jobBookmarksEncryption), S3Encryptions: cdk.listMapper(cfnSecurityConfigurationS3EncryptionPropertyToCloudFormation)(properties.s3Encryptions) }) : properties;
    }
    function CfnSecurityConfigurationEncryptionConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchEncryption", "CloudWatchEncryption", properties.CloudWatchEncryption != null ? CfnSecurityConfigurationCloudWatchEncryptionPropertyFromCloudFormation(properties.CloudWatchEncryption) : void 0), ret.addPropertyResult("jobBookmarksEncryption", "JobBookmarksEncryption", properties.JobBookmarksEncryption != null ? CfnSecurityConfigurationJobBookmarksEncryptionPropertyFromCloudFormation(properties.JobBookmarksEncryption) : void 0), ret.addPropertyResult("s3Encryptions", "S3Encryptions", properties.S3Encryptions != null ? cfn_parse.FromCloudFormation.getArray(CfnSecurityConfigurationS3EncryptionPropertyFromCloudFormation)(properties.S3Encryptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSecurityConfiguration_JobBookmarksEncryptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("jobBookmarksEncryptionMode", cdk.validateString)(properties.jobBookmarksEncryptionMode)), errors.collect(cdk.propertyValidator("kmsKeyArn", cdk.validateString)(properties.kmsKeyArn)), errors.wrap('supplied properties not correct for "JobBookmarksEncryptionProperty"');
    }
    function cfnSecurityConfigurationJobBookmarksEncryptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSecurityConfiguration_JobBookmarksEncryptionPropertyValidator(properties).assertSuccess(), { JobBookmarksEncryptionMode: cdk.stringToCloudFormation(properties.jobBookmarksEncryptionMode), KmsKeyArn: cdk.stringToCloudFormation(properties.kmsKeyArn) }) : properties;
    }
    function CfnSecurityConfigurationJobBookmarksEncryptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("jobBookmarksEncryptionMode", "JobBookmarksEncryptionMode", properties.JobBookmarksEncryptionMode != null ? cfn_parse.FromCloudFormation.getString(properties.JobBookmarksEncryptionMode) : void 0), ret.addPropertyResult("kmsKeyArn", "KmsKeyArn", properties.KmsKeyArn != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSecurityConfiguration_S3EncryptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kmsKeyArn", cdk.validateString)(properties.kmsKeyArn)), errors.collect(cdk.propertyValidator("s3EncryptionMode", cdk.validateString)(properties.s3EncryptionMode)), errors.wrap('supplied properties not correct for "S3EncryptionProperty"');
    }
    function cfnSecurityConfigurationS3EncryptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSecurityConfiguration_S3EncryptionPropertyValidator(properties).assertSuccess(), { KmsKeyArn: cdk.stringToCloudFormation(properties.kmsKeyArn), S3EncryptionMode: cdk.stringToCloudFormation(properties.s3EncryptionMode) }) : properties;
    }
    function CfnSecurityConfigurationS3EncryptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsKeyArn", "KmsKeyArn", properties.KmsKeyArn != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyArn) : void 0), ret.addPropertyResult("s3EncryptionMode", "S3EncryptionMode", properties.S3EncryptionMode != null ? cfn_parse.FromCloudFormation.getString(properties.S3EncryptionMode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTablePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalogId", cdk.requiredValidator)(properties.catalogId)), errors.collect(cdk.propertyValidator("catalogId", cdk.validateString)(properties.catalogId)), errors.collect(cdk.propertyValidator("databaseName", cdk.requiredValidator)(properties.databaseName)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("tableInput", cdk.requiredValidator)(properties.tableInput)), errors.collect(cdk.propertyValidator("tableInput", CfnTable_TableInputPropertyValidator)(properties.tableInput)), errors.wrap('supplied properties not correct for "CfnTableProps"');
    }
    function cfnTablePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTablePropsValidator(properties).assertSuccess(), { CatalogId: cdk.stringToCloudFormation(properties.catalogId), DatabaseName: cdk.stringToCloudFormation(properties.databaseName), TableInput: cfnTableTableInputPropertyToCloudFormation(properties.tableInput) }) : properties;
    }
    function CfnTablePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalogId", "CatalogId", cfn_parse.FromCloudFormation.getString(properties.CatalogId)), ret.addPropertyResult("databaseName", "DatabaseName", cfn_parse.FromCloudFormation.getString(properties.DatabaseName)), ret.addPropertyResult("tableInput", "TableInput", CfnTableTableInputPropertyFromCloudFormation(properties.TableInput)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTable = class _CfnTable extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTablePropsFromCloudFormation(resourceProperties), ret = new _CfnTable(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTable.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_glue_CfnTableProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTable), error;
        }
        cdk.requireProperty(props, "catalogId", this), cdk.requireProperty(props, "databaseName", this), cdk.requireProperty(props, "tableInput", this), this.catalogId = props.catalogId, this.databaseName = props.databaseName, this.tableInput = props.tableInput;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTable.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { catalogId: this.catalogId, databaseName: this.databaseName, tableInput: this.tableInput };
      }
      renderProperties(props) {
        return cfnTablePropsToCloudFormation(props);
      }
    };
    _q = JSII_RTTI_SYMBOL_1, CfnTable[_q] = { fqn: "aws-cdk-lib.aws_glue.CfnTable", version: "2.80.0" }, CfnTable.CFN_RESOURCE_TYPE_NAME = "AWS::Glue::Table", exports2.CfnTable = CfnTable;
    function CfnTable_ColumnPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("comment", cdk.validateString)(properties.comment)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "ColumnProperty"');
    }
    function cfnTableColumnPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTable_ColumnPropertyValidator(properties).assertSuccess(), { Comment: cdk.stringToCloudFormation(properties.comment), Name: cdk.stringToCloudFormation(properties.name), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnTableColumnPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("comment", "Comment", properties.Comment != null ? cfn_parse.FromCloudFormation.getString(properties.Comment) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTable_OrderPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", cdk.validateString)(properties.column)), errors.collect(cdk.propertyValidator("sortOrder", cdk.requiredValidator)(properties.sortOrder)), errors.collect(cdk.propertyValidator("sortOrder", cdk.validateNumber)(properties.sortOrder)), errors.wrap('supplied properties not correct for "OrderProperty"');
    }
    function cfnTableOrderPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTable_OrderPropertyValidator(properties).assertSuccess(), { Column: cdk.stringToCloudFormation(properties.column), SortOrder: cdk.numberToCloudFormation(properties.sortOrder) }) : properties;
    }
    function CfnTableOrderPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", cfn_parse.FromCloudFormation.getString(properties.Column)), ret.addPropertyResult("sortOrder", "SortOrder", cfn_parse.FromCloudFormation.getNumber(properties.SortOrder)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTable_SchemaIdPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("registryName", cdk.validateString)(properties.registryName)), errors.collect(cdk.propertyValidator("schemaArn", cdk.validateString)(properties.schemaArn)), errors.collect(cdk.propertyValidator("schemaName", cdk.validateString)(properties.schemaName)), errors.wrap('supplied properties not correct for "SchemaIdProperty"');
    }
    function cfnTableSchemaIdPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTable_SchemaIdPropertyValidator(properties).assertSuccess(), { RegistryName: cdk.stringToCloudFormation(properties.registryName), SchemaArn: cdk.stringToCloudFormation(properties.schemaArn), SchemaName: cdk.stringToCloudFormation(properties.schemaName) }) : properties;
    }
    function CfnTableSchemaIdPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("registryName", "RegistryName", properties.RegistryName != null ? cfn_parse.FromCloudFormation.getString(properties.RegistryName) : void 0), ret.addPropertyResult("schemaArn", "SchemaArn", properties.SchemaArn != null ? cfn_parse.FromCloudFormation.getString(properties.SchemaArn) : void 0), ret.addPropertyResult("schemaName", "SchemaName", properties.SchemaName != null ? cfn_parse.FromCloudFormation.getString(properties.SchemaName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTable_SchemaReferencePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("schemaId", CfnTable_SchemaIdPropertyValidator)(properties.schemaId)), errors.collect(cdk.propertyValidator("schemaVersionId", cdk.validateString)(properties.schemaVersionId)), errors.collect(cdk.propertyValidator("schemaVersionNumber", cdk.validateNumber)(properties.schemaVersionNumber)), errors.wrap('supplied properties not correct for "SchemaReferenceProperty"');
    }
    function cfnTableSchemaReferencePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTable_SchemaReferencePropertyValidator(properties).assertSuccess(), { SchemaId: cfnTableSchemaIdPropertyToCloudFormation(properties.schemaId), SchemaVersionId: cdk.stringToCloudFormation(properties.schemaVersionId), SchemaVersionNumber: cdk.numberToCloudFormation(properties.schemaVersionNumber) }) : properties;
    }
    function CfnTableSchemaReferencePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("schemaId", "SchemaId", properties.SchemaId != null ? CfnTableSchemaIdPropertyFromCloudFormation(properties.SchemaId) : void 0), ret.addPropertyResult("schemaVersionId", "SchemaVersionId", properties.SchemaVersionId != null ? cfn_parse.FromCloudFormation.getString(properties.SchemaVersionId) : void 0), ret.addPropertyResult("schemaVersionNumber", "SchemaVersionNumber", properties.SchemaVersionNumber != null ? cfn_parse.FromCloudFormation.getNumber(properties.SchemaVersionNumber) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTable_SerdeInfoPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("parameters", cdk.validateObject)(properties.parameters)), errors.collect(cdk.propertyValidator("serializationLibrary", cdk.validateString)(properties.serializationLibrary)), errors.wrap('supplied properties not correct for "SerdeInfoProperty"');
    }
    function cfnTableSerdeInfoPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTable_SerdeInfoPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Parameters: cdk.objectToCloudFormation(properties.parameters), SerializationLibrary: cdk.stringToCloudFormation(properties.serializationLibrary) }) : properties;
    }
    function CfnTableSerdeInfoPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getAny(properties.Parameters) : void 0), ret.addPropertyResult("serializationLibrary", "SerializationLibrary", properties.SerializationLibrary != null ? cfn_parse.FromCloudFormation.getString(properties.SerializationLibrary) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTable_SkewedInfoPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("skewedColumnNames", cdk.listValidator(cdk.validateString))(properties.skewedColumnNames)), errors.collect(cdk.propertyValidator("skewedColumnValueLocationMaps", cdk.validateObject)(properties.skewedColumnValueLocationMaps)), errors.collect(cdk.propertyValidator("skewedColumnValues", cdk.listValidator(cdk.validateString))(properties.skewedColumnValues)), errors.wrap('supplied properties not correct for "SkewedInfoProperty"');
    }
    function cfnTableSkewedInfoPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTable_SkewedInfoPropertyValidator(properties).assertSuccess(), { SkewedColumnNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.skewedColumnNames), SkewedColumnValueLocationMaps: cdk.objectToCloudFormation(properties.skewedColumnValueLocationMaps), SkewedColumnValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.skewedColumnValues) }) : properties;
    }
    function CfnTableSkewedInfoPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("skewedColumnNames", "SkewedColumnNames", properties.SkewedColumnNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SkewedColumnNames) : void 0), ret.addPropertyResult("skewedColumnValueLocationMaps", "SkewedColumnValueLocationMaps", properties.SkewedColumnValueLocationMaps != null ? cfn_parse.FromCloudFormation.getAny(properties.SkewedColumnValueLocationMaps) : void 0), ret.addPropertyResult("skewedColumnValues", "SkewedColumnValues", properties.SkewedColumnValues != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SkewedColumnValues) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTable_StorageDescriptorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketColumns", cdk.listValidator(cdk.validateString))(properties.bucketColumns)), errors.collect(cdk.propertyValidator("columns", cdk.listValidator(CfnTable_ColumnPropertyValidator))(properties.columns)), errors.collect(cdk.propertyValidator("compressed", cdk.validateBoolean)(properties.compressed)), errors.collect(cdk.propertyValidator("inputFormat", cdk.validateString)(properties.inputFormat)), errors.collect(cdk.propertyValidator("location", cdk.validateString)(properties.location)), errors.collect(cdk.propertyValidator("numberOfBuckets", cdk.validateNumber)(properties.numberOfBuckets)), errors.collect(cdk.propertyValidator("outputFormat", cdk.validateString)(properties.outputFormat)), errors.collect(cdk.propertyValidator("parameters", cdk.validateObject)(properties.parameters)), errors.collect(cdk.propertyValidator("schemaReference", CfnTable_SchemaReferencePropertyValidator)(properties.schemaReference)), errors.collect(cdk.propertyValidator("serdeInfo", CfnTable_SerdeInfoPropertyValidator)(properties.serdeInfo)), errors.collect(cdk.propertyValidator("skewedInfo", CfnTable_SkewedInfoPropertyValidator)(properties.skewedInfo)), errors.collect(cdk.propertyValidator("sortColumns", cdk.listValidator(CfnTable_OrderPropertyValidator))(properties.sortColumns)), errors.collect(cdk.propertyValidator("storedAsSubDirectories", cdk.validateBoolean)(properties.storedAsSubDirectories)), errors.wrap('supplied properties not correct for "StorageDescriptorProperty"');
    }
    function cfnTableStorageDescriptorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTable_StorageDescriptorPropertyValidator(properties).assertSuccess(), { BucketColumns: cdk.listMapper(cdk.stringToCloudFormation)(properties.bucketColumns), Columns: cdk.listMapper(cfnTableColumnPropertyToCloudFormation)(properties.columns), Compressed: cdk.booleanToCloudFormation(properties.compressed), InputFormat: cdk.stringToCloudFormation(properties.inputFormat), Location: cdk.stringToCloudFormation(properties.location), NumberOfBuckets: cdk.numberToCloudFormation(properties.numberOfBuckets), OutputFormat: cdk.stringToCloudFormation(properties.outputFormat), Parameters: cdk.objectToCloudFormation(properties.parameters), SchemaReference: cfnTableSchemaReferencePropertyToCloudFormation(properties.schemaReference), SerdeInfo: cfnTableSerdeInfoPropertyToCloudFormation(properties.serdeInfo), SkewedInfo: cfnTableSkewedInfoPropertyToCloudFormation(properties.skewedInfo), SortColumns: cdk.listMapper(cfnTableOrderPropertyToCloudFormation)(properties.sortColumns), StoredAsSubDirectories: cdk.booleanToCloudFormation(properties.storedAsSubDirectories) }) : properties;
    }
    function CfnTableStorageDescriptorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketColumns", "BucketColumns", properties.BucketColumns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.BucketColumns) : void 0), ret.addPropertyResult("columns", "Columns", properties.Columns != null ? cfn_parse.FromCloudFormation.getArray(CfnTableColumnPropertyFromCloudFormation)(properties.Columns) : void 0), ret.addPropertyResult("compressed", "Compressed", properties.Compressed != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Compressed) : void 0), ret.addPropertyResult("inputFormat", "InputFormat", properties.InputFormat != null ? cfn_parse.FromCloudFormation.getString(properties.InputFormat) : void 0), ret.addPropertyResult("location", "Location", properties.Location != null ? cfn_parse.FromCloudFormation.getString(properties.Location) : void 0), ret.addPropertyResult("numberOfBuckets", "NumberOfBuckets", properties.NumberOfBuckets != null ? cfn_parse.FromCloudFormation.getNumber(properties.NumberOfBuckets) : void 0), ret.addPropertyResult("outputFormat", "OutputFormat", properties.OutputFormat != null ? cfn_parse.FromCloudFormation.getString(properties.OutputFormat) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getAny(properties.Parameters) : void 0), ret.addPropertyResult("schemaReference", "SchemaReference", properties.SchemaReference != null ? CfnTableSchemaReferencePropertyFromCloudFormation(properties.SchemaReference) : void 0), ret.addPropertyResult("serdeInfo", "SerdeInfo", properties.SerdeInfo != null ? CfnTableSerdeInfoPropertyFromCloudFormation(properties.SerdeInfo) : void 0), ret.addPropertyResult("skewedInfo", "SkewedInfo", properties.SkewedInfo != null ? CfnTableSkewedInfoPropertyFromCloudFormation(properties.SkewedInfo) : void 0), ret.addPropertyResult("sortColumns", "SortColumns", properties.SortColumns != null ? cfn_parse.FromCloudFormation.getArray(CfnTableOrderPropertyFromCloudFormation)(properties.SortColumns) : void 0), ret.addPropertyResult("storedAsSubDirectories", "StoredAsSubDirectories", properties.StoredAsSubDirectories != null ? cfn_parse.FromCloudFormation.getBoolean(properties.StoredAsSubDirectories) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTable_TableIdentifierPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalogId", cdk.validateString)(properties.catalogId)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "TableIdentifierProperty"');
    }
    function cfnTableTableIdentifierPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTable_TableIdentifierPropertyValidator(properties).assertSuccess(), { CatalogId: cdk.stringToCloudFormation(properties.catalogId), DatabaseName: cdk.stringToCloudFormation(properties.databaseName), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnTableTableIdentifierPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalogId", "CatalogId", properties.CatalogId != null ? cfn_parse.FromCloudFormation.getString(properties.CatalogId) : void 0), ret.addPropertyResult("databaseName", "DatabaseName", properties.DatabaseName != null ? cfn_parse.FromCloudFormation.getString(properties.DatabaseName) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTable_TableInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("owner", cdk.validateString)(properties.owner)), errors.collect(cdk.propertyValidator("parameters", cdk.validateObject)(properties.parameters)), errors.collect(cdk.propertyValidator("partitionKeys", cdk.listValidator(CfnTable_ColumnPropertyValidator))(properties.partitionKeys)), errors.collect(cdk.propertyValidator("retention", cdk.validateNumber)(properties.retention)), errors.collect(cdk.propertyValidator("storageDescriptor", CfnTable_StorageDescriptorPropertyValidator)(properties.storageDescriptor)), errors.collect(cdk.propertyValidator("tableType", cdk.validateString)(properties.tableType)), errors.collect(cdk.propertyValidator("targetTable", CfnTable_TableIdentifierPropertyValidator)(properties.targetTable)), errors.collect(cdk.propertyValidator("viewExpandedText", cdk.validateString)(properties.viewExpandedText)), errors.collect(cdk.propertyValidator("viewOriginalText", cdk.validateString)(properties.viewOriginalText)), errors.wrap('supplied properties not correct for "TableInputProperty"');
    }
    function cfnTableTableInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTable_TableInputPropertyValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), Name: cdk.stringToCloudFormation(properties.name), Owner: cdk.stringToCloudFormation(properties.owner), Parameters: cdk.objectToCloudFormation(properties.parameters), PartitionKeys: cdk.listMapper(cfnTableColumnPropertyToCloudFormation)(properties.partitionKeys), Retention: cdk.numberToCloudFormation(properties.retention), StorageDescriptor: cfnTableStorageDescriptorPropertyToCloudFormation(properties.storageDescriptor), TableType: cdk.stringToCloudFormation(properties.tableType), TargetTable: cfnTableTableIdentifierPropertyToCloudFormation(properties.targetTable), ViewExpandedText: cdk.stringToCloudFormation(properties.viewExpandedText), ViewOriginalText: cdk.stringToCloudFormation(properties.viewOriginalText) }) : properties;
    }
    function CfnTableTableInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("owner", "Owner", properties.Owner != null ? cfn_parse.FromCloudFormation.getString(properties.Owner) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getAny(properties.Parameters) : void 0), ret.addPropertyResult("partitionKeys", "PartitionKeys", properties.PartitionKeys != null ? cfn_parse.FromCloudFormation.getArray(CfnTableColumnPropertyFromCloudFormation)(properties.PartitionKeys) : void 0), ret.addPropertyResult("retention", "Retention", properties.Retention != null ? cfn_parse.FromCloudFormation.getNumber(properties.Retention) : void 0), ret.addPropertyResult("storageDescriptor", "StorageDescriptor", properties.StorageDescriptor != null ? CfnTableStorageDescriptorPropertyFromCloudFormation(properties.StorageDescriptor) : void 0), ret.addPropertyResult("tableType", "TableType", properties.TableType != null ? cfn_parse.FromCloudFormation.getString(properties.TableType) : void 0), ret.addPropertyResult("targetTable", "TargetTable", properties.TargetTable != null ? CfnTableTableIdentifierPropertyFromCloudFormation(properties.TargetTable) : void 0), ret.addPropertyResult("viewExpandedText", "ViewExpandedText", properties.ViewExpandedText != null ? cfn_parse.FromCloudFormation.getString(properties.ViewExpandedText) : void 0), ret.addPropertyResult("viewOriginalText", "ViewOriginalText", properties.ViewOriginalText != null ? cfn_parse.FromCloudFormation.getString(properties.ViewOriginalText) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTriggerPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.requiredValidator)(properties.actions)), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnTrigger_ActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("eventBatchingCondition", CfnTrigger_EventBatchingConditionPropertyValidator)(properties.eventBatchingCondition)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("predicate", CfnTrigger_PredicatePropertyValidator)(properties.predicate)), errors.collect(cdk.propertyValidator("schedule", cdk.validateString)(properties.schedule)), errors.collect(cdk.propertyValidator("startOnCreation", cdk.validateBoolean)(properties.startOnCreation)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("workflowName", cdk.validateString)(properties.workflowName)), errors.wrap('supplied properties not correct for "CfnTriggerProps"');
    }
    function cfnTriggerPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTriggerPropsValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnTriggerActionPropertyToCloudFormation)(properties.actions), Type: cdk.stringToCloudFormation(properties.type), Description: cdk.stringToCloudFormation(properties.description), EventBatchingCondition: cfnTriggerEventBatchingConditionPropertyToCloudFormation(properties.eventBatchingCondition), Name: cdk.stringToCloudFormation(properties.name), Predicate: cfnTriggerPredicatePropertyToCloudFormation(properties.predicate), Schedule: cdk.stringToCloudFormation(properties.schedule), StartOnCreation: cdk.booleanToCloudFormation(properties.startOnCreation), Tags: cdk.objectToCloudFormation(properties.tags), WorkflowName: cdk.stringToCloudFormation(properties.workflowName) }) : properties;
    }
    function CfnTriggerPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", cfn_parse.FromCloudFormation.getArray(CfnTriggerActionPropertyFromCloudFormation)(properties.Actions)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("eventBatchingCondition", "EventBatchingCondition", properties.EventBatchingCondition != null ? CfnTriggerEventBatchingConditionPropertyFromCloudFormation(properties.EventBatchingCondition) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("predicate", "Predicate", properties.Predicate != null ? CfnTriggerPredicatePropertyFromCloudFormation(properties.Predicate) : void 0), ret.addPropertyResult("schedule", "Schedule", properties.Schedule != null ? cfn_parse.FromCloudFormation.getString(properties.Schedule) : void 0), ret.addPropertyResult("startOnCreation", "StartOnCreation", properties.StartOnCreation != null ? cfn_parse.FromCloudFormation.getBoolean(properties.StartOnCreation) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addPropertyResult("workflowName", "WorkflowName", properties.WorkflowName != null ? cfn_parse.FromCloudFormation.getString(properties.WorkflowName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTrigger = class _CfnTrigger extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTriggerPropsFromCloudFormation(resourceProperties), ret = new _CfnTrigger(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTrigger.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_glue_CfnTriggerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTrigger), error;
        }
        cdk.requireProperty(props, "actions", this), cdk.requireProperty(props, "type", this), this.actions = props.actions, this.type = props.type, this.description = props.description, this.eventBatchingCondition = props.eventBatchingCondition, this.name = props.name, this.predicate = props.predicate, this.schedule = props.schedule, this.startOnCreation = props.startOnCreation, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Glue::Trigger", props.tags, { tagPropertyName: "tags" }), this.workflowName = props.workflowName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTrigger.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { actions: this.actions, type: this.type, description: this.description, eventBatchingCondition: this.eventBatchingCondition, name: this.name, predicate: this.predicate, schedule: this.schedule, startOnCreation: this.startOnCreation, tags: this.tags.renderTags(), workflowName: this.workflowName };
      }
      renderProperties(props) {
        return cfnTriggerPropsToCloudFormation(props);
      }
    };
    _r = JSII_RTTI_SYMBOL_1, CfnTrigger[_r] = { fqn: "aws-cdk-lib.aws_glue.CfnTrigger", version: "2.80.0" }, CfnTrigger.CFN_RESOURCE_TYPE_NAME = "AWS::Glue::Trigger", exports2.CfnTrigger = CfnTrigger;
    function CfnTrigger_ActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arguments", cdk.validateObject)(properties.arguments)), errors.collect(cdk.propertyValidator("crawlerName", cdk.validateString)(properties.crawlerName)), errors.collect(cdk.propertyValidator("jobName", cdk.validateString)(properties.jobName)), errors.collect(cdk.propertyValidator("notificationProperty", CfnTrigger_NotificationPropertyPropertyValidator)(properties.notificationProperty)), errors.collect(cdk.propertyValidator("securityConfiguration", cdk.validateString)(properties.securityConfiguration)), errors.collect(cdk.propertyValidator("timeout", cdk.validateNumber)(properties.timeout)), errors.wrap('supplied properties not correct for "ActionProperty"');
    }
    function cfnTriggerActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTrigger_ActionPropertyValidator(properties).assertSuccess(), { Arguments: cdk.objectToCloudFormation(properties.arguments), CrawlerName: cdk.stringToCloudFormation(properties.crawlerName), JobName: cdk.stringToCloudFormation(properties.jobName), NotificationProperty: cfnTriggerNotificationPropertyPropertyToCloudFormation(properties.notificationProperty), SecurityConfiguration: cdk.stringToCloudFormation(properties.securityConfiguration), Timeout: cdk.numberToCloudFormation(properties.timeout) }) : properties;
    }
    function CfnTriggerActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arguments", "Arguments", properties.Arguments != null ? cfn_parse.FromCloudFormation.getAny(properties.Arguments) : void 0), ret.addPropertyResult("crawlerName", "CrawlerName", properties.CrawlerName != null ? cfn_parse.FromCloudFormation.getString(properties.CrawlerName) : void 0), ret.addPropertyResult("jobName", "JobName", properties.JobName != null ? cfn_parse.FromCloudFormation.getString(properties.JobName) : void 0), ret.addPropertyResult("notificationProperty", "NotificationProperty", properties.NotificationProperty != null ? CfnTriggerNotificationPropertyPropertyFromCloudFormation(properties.NotificationProperty) : void 0), ret.addPropertyResult("securityConfiguration", "SecurityConfiguration", properties.SecurityConfiguration != null ? cfn_parse.FromCloudFormation.getString(properties.SecurityConfiguration) : void 0), ret.addPropertyResult("timeout", "Timeout", properties.Timeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.Timeout) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTrigger_ConditionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("crawlState", cdk.validateString)(properties.crawlState)), errors.collect(cdk.propertyValidator("crawlerName", cdk.validateString)(properties.crawlerName)), errors.collect(cdk.propertyValidator("jobName", cdk.validateString)(properties.jobName)), errors.collect(cdk.propertyValidator("logicalOperator", cdk.validateString)(properties.logicalOperator)), errors.collect(cdk.propertyValidator("state", cdk.validateString)(properties.state)), errors.wrap('supplied properties not correct for "ConditionProperty"');
    }
    function cfnTriggerConditionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTrigger_ConditionPropertyValidator(properties).assertSuccess(), { CrawlState: cdk.stringToCloudFormation(properties.crawlState), CrawlerName: cdk.stringToCloudFormation(properties.crawlerName), JobName: cdk.stringToCloudFormation(properties.jobName), LogicalOperator: cdk.stringToCloudFormation(properties.logicalOperator), State: cdk.stringToCloudFormation(properties.state) }) : properties;
    }
    function CfnTriggerConditionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("crawlState", "CrawlState", properties.CrawlState != null ? cfn_parse.FromCloudFormation.getString(properties.CrawlState) : void 0), ret.addPropertyResult("crawlerName", "CrawlerName", properties.CrawlerName != null ? cfn_parse.FromCloudFormation.getString(properties.CrawlerName) : void 0), ret.addPropertyResult("jobName", "JobName", properties.JobName != null ? cfn_parse.FromCloudFormation.getString(properties.JobName) : void 0), ret.addPropertyResult("logicalOperator", "LogicalOperator", properties.LogicalOperator != null ? cfn_parse.FromCloudFormation.getString(properties.LogicalOperator) : void 0), ret.addPropertyResult("state", "State", properties.State != null ? cfn_parse.FromCloudFormation.getString(properties.State) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTrigger_EventBatchingConditionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("batchSize", cdk.requiredValidator)(properties.batchSize)), errors.collect(cdk.propertyValidator("batchSize", cdk.validateNumber)(properties.batchSize)), errors.collect(cdk.propertyValidator("batchWindow", cdk.validateNumber)(properties.batchWindow)), errors.wrap('supplied properties not correct for "EventBatchingConditionProperty"');
    }
    function cfnTriggerEventBatchingConditionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTrigger_EventBatchingConditionPropertyValidator(properties).assertSuccess(), { BatchSize: cdk.numberToCloudFormation(properties.batchSize), BatchWindow: cdk.numberToCloudFormation(properties.batchWindow) }) : properties;
    }
    function CfnTriggerEventBatchingConditionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("batchSize", "BatchSize", cfn_parse.FromCloudFormation.getNumber(properties.BatchSize)), ret.addPropertyResult("batchWindow", "BatchWindow", properties.BatchWindow != null ? cfn_parse.FromCloudFormation.getNumber(properties.BatchWindow) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTrigger_NotificationPropertyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("notifyDelayAfter", cdk.validateNumber)(properties.notifyDelayAfter)), errors.wrap('supplied properties not correct for "NotificationPropertyProperty"');
    }
    function cfnTriggerNotificationPropertyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTrigger_NotificationPropertyPropertyValidator(properties).assertSuccess(), { NotifyDelayAfter: cdk.numberToCloudFormation(properties.notifyDelayAfter) }) : properties;
    }
    function CfnTriggerNotificationPropertyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("notifyDelayAfter", "NotifyDelayAfter", properties.NotifyDelayAfter != null ? cfn_parse.FromCloudFormation.getNumber(properties.NotifyDelayAfter) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTrigger_PredicatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("conditions", cdk.listValidator(CfnTrigger_ConditionPropertyValidator))(properties.conditions)), errors.collect(cdk.propertyValidator("logical", cdk.validateString)(properties.logical)), errors.wrap('supplied properties not correct for "PredicateProperty"');
    }
    function cfnTriggerPredicatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTrigger_PredicatePropertyValidator(properties).assertSuccess(), { Conditions: cdk.listMapper(cfnTriggerConditionPropertyToCloudFormation)(properties.conditions), Logical: cdk.stringToCloudFormation(properties.logical) }) : properties;
    }
    function CfnTriggerPredicatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("conditions", "Conditions", properties.Conditions != null ? cfn_parse.FromCloudFormation.getArray(CfnTriggerConditionPropertyFromCloudFormation)(properties.Conditions) : void 0), ret.addPropertyResult("logical", "Logical", properties.Logical != null ? cfn_parse.FromCloudFormation.getString(properties.Logical) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWorkflowPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultRunProperties", cdk.validateObject)(properties.defaultRunProperties)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("maxConcurrentRuns", cdk.validateNumber)(properties.maxConcurrentRuns)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.wrap('supplied properties not correct for "CfnWorkflowProps"');
    }
    function cfnWorkflowPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkflowPropsValidator(properties).assertSuccess(), { DefaultRunProperties: cdk.objectToCloudFormation(properties.defaultRunProperties), Description: cdk.stringToCloudFormation(properties.description), MaxConcurrentRuns: cdk.numberToCloudFormation(properties.maxConcurrentRuns), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.objectToCloudFormation(properties.tags) }) : properties;
    }
    function CfnWorkflowPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultRunProperties", "DefaultRunProperties", properties.DefaultRunProperties != null ? cfn_parse.FromCloudFormation.getAny(properties.DefaultRunProperties) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("maxConcurrentRuns", "MaxConcurrentRuns", properties.MaxConcurrentRuns != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxConcurrentRuns) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnWorkflow = class _CfnWorkflow extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnWorkflowPropsFromCloudFormation(resourceProperties), ret = new _CfnWorkflow(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnWorkflow.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_glue_CfnWorkflowProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnWorkflow), error;
        }
        this.defaultRunProperties = props.defaultRunProperties, this.description = props.description, this.maxConcurrentRuns = props.maxConcurrentRuns, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Glue::Workflow", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnWorkflow.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { defaultRunProperties: this.defaultRunProperties, description: this.description, maxConcurrentRuns: this.maxConcurrentRuns, name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnWorkflowPropsToCloudFormation(props);
      }
    };
    _s = JSII_RTTI_SYMBOL_1, CfnWorkflow[_s] = { fqn: "aws-cdk-lib.aws_glue.CfnWorkflow", version: "2.80.0" }, CfnWorkflow.CFN_RESOURCE_TYPE_NAME = "AWS::Glue::Workflow", exports2.CfnWorkflow = CfnWorkflow;
  }
});

// node_modules/aws-cdk-lib/aws-glue/lib/index.js
var require_lib137 = __commonJS({
  "node_modules/aws-cdk-lib/aws-glue/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_glue_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-glue/index.js
var require_aws_glue = __commonJS({
  "node_modules/aws-cdk-lib/aws-glue/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib137(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-grafana/lib/grafana.generated.js
var require_grafana_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-grafana/lib/grafana.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnWorkspace = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnWorkspacePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accountAccessType", cdk.requiredValidator)(properties.accountAccessType)), errors.collect(cdk.propertyValidator("accountAccessType", cdk.validateString)(properties.accountAccessType)), errors.collect(cdk.propertyValidator("authenticationProviders", cdk.requiredValidator)(properties.authenticationProviders)), errors.collect(cdk.propertyValidator("authenticationProviders", cdk.listValidator(cdk.validateString))(properties.authenticationProviders)), errors.collect(cdk.propertyValidator("clientToken", cdk.validateString)(properties.clientToken)), errors.collect(cdk.propertyValidator("dataSources", cdk.listValidator(cdk.validateString))(properties.dataSources)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("networkAccessControl", CfnWorkspace_NetworkAccessControlPropertyValidator)(properties.networkAccessControl)), errors.collect(cdk.propertyValidator("notificationDestinations", cdk.listValidator(cdk.validateString))(properties.notificationDestinations)), errors.collect(cdk.propertyValidator("organizationRoleName", cdk.validateString)(properties.organizationRoleName)), errors.collect(cdk.propertyValidator("organizationalUnits", cdk.listValidator(cdk.validateString))(properties.organizationalUnits)), errors.collect(cdk.propertyValidator("permissionType", cdk.requiredValidator)(properties.permissionType)), errors.collect(cdk.propertyValidator("permissionType", cdk.validateString)(properties.permissionType)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("samlConfiguration", CfnWorkspace_SamlConfigurationPropertyValidator)(properties.samlConfiguration)), errors.collect(cdk.propertyValidator("stackSetName", cdk.validateString)(properties.stackSetName)), errors.collect(cdk.propertyValidator("vpcConfiguration", CfnWorkspace_VpcConfigurationPropertyValidator)(properties.vpcConfiguration)), errors.wrap('supplied properties not correct for "CfnWorkspaceProps"');
    }
    function cfnWorkspacePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkspacePropsValidator(properties).assertSuccess(), { AccountAccessType: cdk.stringToCloudFormation(properties.accountAccessType), AuthenticationProviders: cdk.listMapper(cdk.stringToCloudFormation)(properties.authenticationProviders), PermissionType: cdk.stringToCloudFormation(properties.permissionType), ClientToken: cdk.stringToCloudFormation(properties.clientToken), DataSources: cdk.listMapper(cdk.stringToCloudFormation)(properties.dataSources), Description: cdk.stringToCloudFormation(properties.description), Name: cdk.stringToCloudFormation(properties.name), NetworkAccessControl: cfnWorkspaceNetworkAccessControlPropertyToCloudFormation(properties.networkAccessControl), NotificationDestinations: cdk.listMapper(cdk.stringToCloudFormation)(properties.notificationDestinations), OrganizationalUnits: cdk.listMapper(cdk.stringToCloudFormation)(properties.organizationalUnits), OrganizationRoleName: cdk.stringToCloudFormation(properties.organizationRoleName), RoleArn: cdk.stringToCloudFormation(properties.roleArn), SamlConfiguration: cfnWorkspaceSamlConfigurationPropertyToCloudFormation(properties.samlConfiguration), StackSetName: cdk.stringToCloudFormation(properties.stackSetName), VpcConfiguration: cfnWorkspaceVpcConfigurationPropertyToCloudFormation(properties.vpcConfiguration) }) : properties;
    }
    function CfnWorkspacePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accountAccessType", "AccountAccessType", cfn_parse.FromCloudFormation.getString(properties.AccountAccessType)), ret.addPropertyResult("authenticationProviders", "AuthenticationProviders", cfn_parse.FromCloudFormation.getStringArray(properties.AuthenticationProviders)), ret.addPropertyResult("permissionType", "PermissionType", cfn_parse.FromCloudFormation.getString(properties.PermissionType)), ret.addPropertyResult("clientToken", "ClientToken", properties.ClientToken != null ? cfn_parse.FromCloudFormation.getString(properties.ClientToken) : void 0), ret.addPropertyResult("dataSources", "DataSources", properties.DataSources != null ? cfn_parse.FromCloudFormation.getStringArray(properties.DataSources) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("networkAccessControl", "NetworkAccessControl", properties.NetworkAccessControl != null ? CfnWorkspaceNetworkAccessControlPropertyFromCloudFormation(properties.NetworkAccessControl) : void 0), ret.addPropertyResult("notificationDestinations", "NotificationDestinations", properties.NotificationDestinations != null ? cfn_parse.FromCloudFormation.getStringArray(properties.NotificationDestinations) : void 0), ret.addPropertyResult("organizationalUnits", "OrganizationalUnits", properties.OrganizationalUnits != null ? cfn_parse.FromCloudFormation.getStringArray(properties.OrganizationalUnits) : void 0), ret.addPropertyResult("organizationRoleName", "OrganizationRoleName", properties.OrganizationRoleName != null ? cfn_parse.FromCloudFormation.getString(properties.OrganizationRoleName) : void 0), ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addPropertyResult("samlConfiguration", "SamlConfiguration", properties.SamlConfiguration != null ? CfnWorkspaceSamlConfigurationPropertyFromCloudFormation(properties.SamlConfiguration) : void 0), ret.addPropertyResult("stackSetName", "StackSetName", properties.StackSetName != null ? cfn_parse.FromCloudFormation.getString(properties.StackSetName) : void 0), ret.addPropertyResult("vpcConfiguration", "VpcConfiguration", properties.VpcConfiguration != null ? CfnWorkspaceVpcConfigurationPropertyFromCloudFormation(properties.VpcConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnWorkspace = class _CfnWorkspace extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnWorkspacePropsFromCloudFormation(resourceProperties), ret = new _CfnWorkspace(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnWorkspace.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_grafana_CfnWorkspaceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnWorkspace), error;
        }
        cdk.requireProperty(props, "accountAccessType", this), cdk.requireProperty(props, "authenticationProviders", this), cdk.requireProperty(props, "permissionType", this), this.attrCreationTimestamp = cdk.Token.asString(this.getAtt("CreationTimestamp", cdk.ResolutionTypeHint.STRING)), this.attrEndpoint = cdk.Token.asString(this.getAtt("Endpoint", cdk.ResolutionTypeHint.STRING)), this.attrGrafanaVersion = cdk.Token.asString(this.getAtt("GrafanaVersion", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrModificationTimestamp = cdk.Token.asString(this.getAtt("ModificationTimestamp", cdk.ResolutionTypeHint.STRING)), this.attrSamlConfigurationStatus = cdk.Token.asString(this.getAtt("SamlConfigurationStatus", cdk.ResolutionTypeHint.STRING)), this.attrSsoClientId = cdk.Token.asString(this.getAtt("SsoClientId", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.accountAccessType = props.accountAccessType, this.authenticationProviders = props.authenticationProviders, this.permissionType = props.permissionType, this.clientToken = props.clientToken, this.dataSources = props.dataSources, this.description = props.description, this.name = props.name, this.networkAccessControl = props.networkAccessControl, this.notificationDestinations = props.notificationDestinations, this.organizationalUnits = props.organizationalUnits, this.organizationRoleName = props.organizationRoleName, this.roleArn = props.roleArn, this.samlConfiguration = props.samlConfiguration, this.stackSetName = props.stackSetName, this.vpcConfiguration = props.vpcConfiguration;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnWorkspace.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { accountAccessType: this.accountAccessType, authenticationProviders: this.authenticationProviders, permissionType: this.permissionType, clientToken: this.clientToken, dataSources: this.dataSources, description: this.description, name: this.name, networkAccessControl: this.networkAccessControl, notificationDestinations: this.notificationDestinations, organizationalUnits: this.organizationalUnits, organizationRoleName: this.organizationRoleName, roleArn: this.roleArn, samlConfiguration: this.samlConfiguration, stackSetName: this.stackSetName, vpcConfiguration: this.vpcConfiguration };
      }
      renderProperties(props) {
        return cfnWorkspacePropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnWorkspace[_a] = { fqn: "aws-cdk-lib.aws_grafana.CfnWorkspace", version: "2.80.0" }, CfnWorkspace.CFN_RESOURCE_TYPE_NAME = "AWS::Grafana::Workspace", exports2.CfnWorkspace = CfnWorkspace;
    function CfnWorkspace_AssertionAttributesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("email", cdk.validateString)(properties.email)), errors.collect(cdk.propertyValidator("groups", cdk.validateString)(properties.groups)), errors.collect(cdk.propertyValidator("login", cdk.validateString)(properties.login)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("org", cdk.validateString)(properties.org)), errors.collect(cdk.propertyValidator("role", cdk.validateString)(properties.role)), errors.wrap('supplied properties not correct for "AssertionAttributesProperty"');
    }
    function cfnWorkspaceAssertionAttributesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkspace_AssertionAttributesPropertyValidator(properties).assertSuccess(), { Email: cdk.stringToCloudFormation(properties.email), Groups: cdk.stringToCloudFormation(properties.groups), Login: cdk.stringToCloudFormation(properties.login), Name: cdk.stringToCloudFormation(properties.name), Org: cdk.stringToCloudFormation(properties.org), Role: cdk.stringToCloudFormation(properties.role) }) : properties;
    }
    function CfnWorkspaceAssertionAttributesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("email", "Email", properties.Email != null ? cfn_parse.FromCloudFormation.getString(properties.Email) : void 0), ret.addPropertyResult("groups", "Groups", properties.Groups != null ? cfn_parse.FromCloudFormation.getString(properties.Groups) : void 0), ret.addPropertyResult("login", "Login", properties.Login != null ? cfn_parse.FromCloudFormation.getString(properties.Login) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("org", "Org", properties.Org != null ? cfn_parse.FromCloudFormation.getString(properties.Org) : void 0), ret.addPropertyResult("role", "Role", properties.Role != null ? cfn_parse.FromCloudFormation.getString(properties.Role) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWorkspace_IdpMetadataPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("url", cdk.validateString)(properties.url)), errors.collect(cdk.propertyValidator("xml", cdk.validateString)(properties.xml)), errors.wrap('supplied properties not correct for "IdpMetadataProperty"');
    }
    function cfnWorkspaceIdpMetadataPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkspace_IdpMetadataPropertyValidator(properties).assertSuccess(), { Url: cdk.stringToCloudFormation(properties.url), Xml: cdk.stringToCloudFormation(properties.xml) }) : properties;
    }
    function CfnWorkspaceIdpMetadataPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("url", "Url", properties.Url != null ? cfn_parse.FromCloudFormation.getString(properties.Url) : void 0), ret.addPropertyResult("xml", "Xml", properties.Xml != null ? cfn_parse.FromCloudFormation.getString(properties.Xml) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWorkspace_NetworkAccessControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("prefixListIds", cdk.listValidator(cdk.validateString))(properties.prefixListIds)), errors.collect(cdk.propertyValidator("vpceIds", cdk.listValidator(cdk.validateString))(properties.vpceIds)), errors.wrap('supplied properties not correct for "NetworkAccessControlProperty"');
    }
    function cfnWorkspaceNetworkAccessControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkspace_NetworkAccessControlPropertyValidator(properties).assertSuccess(), { PrefixListIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.prefixListIds), VpceIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.vpceIds) }) : properties;
    }
    function CfnWorkspaceNetworkAccessControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("prefixListIds", "PrefixListIds", properties.PrefixListIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.PrefixListIds) : void 0), ret.addPropertyResult("vpceIds", "VpceIds", properties.VpceIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.VpceIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWorkspace_RoleValuesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("admin", cdk.listValidator(cdk.validateString))(properties.admin)), errors.collect(cdk.propertyValidator("editor", cdk.listValidator(cdk.validateString))(properties.editor)), errors.wrap('supplied properties not correct for "RoleValuesProperty"');
    }
    function cfnWorkspaceRoleValuesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkspace_RoleValuesPropertyValidator(properties).assertSuccess(), { Admin: cdk.listMapper(cdk.stringToCloudFormation)(properties.admin), Editor: cdk.listMapper(cdk.stringToCloudFormation)(properties.editor) }) : properties;
    }
    function CfnWorkspaceRoleValuesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("admin", "Admin", properties.Admin != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Admin) : void 0), ret.addPropertyResult("editor", "Editor", properties.Editor != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Editor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWorkspace_SamlConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowedOrganizations", cdk.listValidator(cdk.validateString))(properties.allowedOrganizations)), errors.collect(cdk.propertyValidator("assertionAttributes", CfnWorkspace_AssertionAttributesPropertyValidator)(properties.assertionAttributes)), errors.collect(cdk.propertyValidator("idpMetadata", cdk.requiredValidator)(properties.idpMetadata)), errors.collect(cdk.propertyValidator("idpMetadata", CfnWorkspace_IdpMetadataPropertyValidator)(properties.idpMetadata)), errors.collect(cdk.propertyValidator("loginValidityDuration", cdk.validateNumber)(properties.loginValidityDuration)), errors.collect(cdk.propertyValidator("roleValues", CfnWorkspace_RoleValuesPropertyValidator)(properties.roleValues)), errors.wrap('supplied properties not correct for "SamlConfigurationProperty"');
    }
    function cfnWorkspaceSamlConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkspace_SamlConfigurationPropertyValidator(properties).assertSuccess(), { AllowedOrganizations: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowedOrganizations), AssertionAttributes: cfnWorkspaceAssertionAttributesPropertyToCloudFormation(properties.assertionAttributes), IdpMetadata: cfnWorkspaceIdpMetadataPropertyToCloudFormation(properties.idpMetadata), LoginValidityDuration: cdk.numberToCloudFormation(properties.loginValidityDuration), RoleValues: cfnWorkspaceRoleValuesPropertyToCloudFormation(properties.roleValues) }) : properties;
    }
    function CfnWorkspaceSamlConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowedOrganizations", "AllowedOrganizations", properties.AllowedOrganizations != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AllowedOrganizations) : void 0), ret.addPropertyResult("assertionAttributes", "AssertionAttributes", properties.AssertionAttributes != null ? CfnWorkspaceAssertionAttributesPropertyFromCloudFormation(properties.AssertionAttributes) : void 0), ret.addPropertyResult("idpMetadata", "IdpMetadata", CfnWorkspaceIdpMetadataPropertyFromCloudFormation(properties.IdpMetadata)), ret.addPropertyResult("loginValidityDuration", "LoginValidityDuration", properties.LoginValidityDuration != null ? cfn_parse.FromCloudFormation.getNumber(properties.LoginValidityDuration) : void 0), ret.addPropertyResult("roleValues", "RoleValues", properties.RoleValues != null ? CfnWorkspaceRoleValuesPropertyFromCloudFormation(properties.RoleValues) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWorkspace_VpcConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.requiredValidator)(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.requiredValidator)(properties.subnetIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.wrap('supplied properties not correct for "VpcConfigurationProperty"');
    }
    function cfnWorkspaceVpcConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkspace_VpcConfigurationPropertyValidator(properties).assertSuccess(), { SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds) }) : properties;
    }
    function CfnWorkspaceVpcConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds)), ret.addPropertyResult("subnetIds", "SubnetIds", cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-grafana/lib/index.js
var require_lib138 = __commonJS({
  "node_modules/aws-cdk-lib/aws-grafana/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_grafana_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-grafana/index.js
var require_aws_grafana = __commonJS({
  "node_modules/aws-cdk-lib/aws-grafana/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib138(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-greengrass/lib/greengrass.generated.js
var require_greengrass_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-greengrass/lib/greengrass.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    var _l;
    var _m;
    var _o;
    var _p;
    var _q;
    var _r;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnSubscriptionDefinitionVersion = exports2.CfnSubscriptionDefinition = exports2.CfnResourceDefinitionVersion = exports2.CfnResourceDefinition = exports2.CfnLoggerDefinitionVersion = exports2.CfnLoggerDefinition = exports2.CfnGroupVersion = exports2.CfnGroup = exports2.CfnFunctionDefinitionVersion = exports2.CfnFunctionDefinition = exports2.CfnDeviceDefinitionVersion = exports2.CfnDeviceDefinition = exports2.CfnCoreDefinitionVersion = exports2.CfnCoreDefinition = exports2.CfnConnectorDefinitionVersion = exports2.CfnConnectorDefinition = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnConnectorDefinitionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("initialVersion", CfnConnectorDefinition_ConnectorDefinitionVersionPropertyValidator)(properties.initialVersion)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.wrap('supplied properties not correct for "CfnConnectorDefinitionProps"');
    }
    function cfnConnectorDefinitionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorDefinitionPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), InitialVersion: cfnConnectorDefinitionConnectorDefinitionVersionPropertyToCloudFormation(properties.initialVersion), Tags: cdk.objectToCloudFormation(properties.tags) }) : properties;
    }
    function CfnConnectorDefinitionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("initialVersion", "InitialVersion", properties.InitialVersion != null ? CfnConnectorDefinitionConnectorDefinitionVersionPropertyFromCloudFormation(properties.InitialVersion) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnConnectorDefinition = class _CfnConnectorDefinition extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnConnectorDefinitionPropsFromCloudFormation(resourceProperties), ret = new _CfnConnectorDefinition(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnConnectorDefinition.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_greengrass_CfnConnectorDefinitionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnConnectorDefinition), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrLatestVersionArn = cdk.Token.asString(this.getAtt("LatestVersionArn", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.initialVersion = props.initialVersion, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Greengrass::ConnectorDefinition", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnConnectorDefinition.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, initialVersion: this.initialVersion, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnConnectorDefinitionPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnConnectorDefinition[_a] = { fqn: "aws-cdk-lib.aws_greengrass.CfnConnectorDefinition", version: "2.80.0" }, CfnConnectorDefinition.CFN_RESOURCE_TYPE_NAME = "AWS::Greengrass::ConnectorDefinition", exports2.CfnConnectorDefinition = CfnConnectorDefinition;
    function CfnConnectorDefinition_ConnectorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectorArn", cdk.requiredValidator)(properties.connectorArn)), errors.collect(cdk.propertyValidator("connectorArn", cdk.validateString)(properties.connectorArn)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("parameters", cdk.validateObject)(properties.parameters)), errors.wrap('supplied properties not correct for "ConnectorProperty"');
    }
    function cfnConnectorDefinitionConnectorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorDefinition_ConnectorPropertyValidator(properties).assertSuccess(), { ConnectorArn: cdk.stringToCloudFormation(properties.connectorArn), Id: cdk.stringToCloudFormation(properties.id), Parameters: cdk.objectToCloudFormation(properties.parameters) }) : properties;
    }
    function CfnConnectorDefinitionConnectorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectorArn", "ConnectorArn", cfn_parse.FromCloudFormation.getString(properties.ConnectorArn)), ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getAny(properties.Parameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorDefinition_ConnectorDefinitionVersionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectors", cdk.requiredValidator)(properties.connectors)), errors.collect(cdk.propertyValidator("connectors", cdk.listValidator(CfnConnectorDefinition_ConnectorPropertyValidator))(properties.connectors)), errors.wrap('supplied properties not correct for "ConnectorDefinitionVersionProperty"');
    }
    function cfnConnectorDefinitionConnectorDefinitionVersionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorDefinition_ConnectorDefinitionVersionPropertyValidator(properties).assertSuccess(), { Connectors: cdk.listMapper(cfnConnectorDefinitionConnectorPropertyToCloudFormation)(properties.connectors) }) : properties;
    }
    function CfnConnectorDefinitionConnectorDefinitionVersionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectors", "Connectors", cfn_parse.FromCloudFormation.getArray(CfnConnectorDefinitionConnectorPropertyFromCloudFormation)(properties.Connectors)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectorDefinitionVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectorDefinitionId", cdk.requiredValidator)(properties.connectorDefinitionId)), errors.collect(cdk.propertyValidator("connectorDefinitionId", cdk.validateString)(properties.connectorDefinitionId)), errors.collect(cdk.propertyValidator("connectors", cdk.requiredValidator)(properties.connectors)), errors.collect(cdk.propertyValidator("connectors", cdk.listValidator(CfnConnectorDefinitionVersion_ConnectorPropertyValidator))(properties.connectors)), errors.wrap('supplied properties not correct for "CfnConnectorDefinitionVersionProps"');
    }
    function cfnConnectorDefinitionVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorDefinitionVersionPropsValidator(properties).assertSuccess(), { ConnectorDefinitionId: cdk.stringToCloudFormation(properties.connectorDefinitionId), Connectors: cdk.listMapper(cfnConnectorDefinitionVersionConnectorPropertyToCloudFormation)(properties.connectors) }) : properties;
    }
    function CfnConnectorDefinitionVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectorDefinitionId", "ConnectorDefinitionId", cfn_parse.FromCloudFormation.getString(properties.ConnectorDefinitionId)), ret.addPropertyResult("connectors", "Connectors", cfn_parse.FromCloudFormation.getArray(CfnConnectorDefinitionVersionConnectorPropertyFromCloudFormation)(properties.Connectors)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnConnectorDefinitionVersion = class _CfnConnectorDefinitionVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnConnectorDefinitionVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnConnectorDefinitionVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnConnectorDefinitionVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_greengrass_CfnConnectorDefinitionVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnConnectorDefinitionVersion), error;
        }
        cdk.requireProperty(props, "connectorDefinitionId", this), cdk.requireProperty(props, "connectors", this), this.connectorDefinitionId = props.connectorDefinitionId, this.connectors = props.connectors;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnConnectorDefinitionVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { connectorDefinitionId: this.connectorDefinitionId, connectors: this.connectors };
      }
      renderProperties(props) {
        return cfnConnectorDefinitionVersionPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnConnectorDefinitionVersion[_b] = { fqn: "aws-cdk-lib.aws_greengrass.CfnConnectorDefinitionVersion", version: "2.80.0" }, CfnConnectorDefinitionVersion.CFN_RESOURCE_TYPE_NAME = "AWS::Greengrass::ConnectorDefinitionVersion", exports2.CfnConnectorDefinitionVersion = CfnConnectorDefinitionVersion;
    function CfnConnectorDefinitionVersion_ConnectorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectorArn", cdk.requiredValidator)(properties.connectorArn)), errors.collect(cdk.propertyValidator("connectorArn", cdk.validateString)(properties.connectorArn)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("parameters", cdk.validateObject)(properties.parameters)), errors.wrap('supplied properties not correct for "ConnectorProperty"');
    }
    function cfnConnectorDefinitionVersionConnectorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorDefinitionVersion_ConnectorPropertyValidator(properties).assertSuccess(), { ConnectorArn: cdk.stringToCloudFormation(properties.connectorArn), Id: cdk.stringToCloudFormation(properties.id), Parameters: cdk.objectToCloudFormation(properties.parameters) }) : properties;
    }
    function CfnConnectorDefinitionVersionConnectorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectorArn", "ConnectorArn", cfn_parse.FromCloudFormation.getString(properties.ConnectorArn)), ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getAny(properties.Parameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCoreDefinitionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("initialVersion", CfnCoreDefinition_CoreDefinitionVersionPropertyValidator)(properties.initialVersion)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.wrap('supplied properties not correct for "CfnCoreDefinitionProps"');
    }
    function cfnCoreDefinitionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCoreDefinitionPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), InitialVersion: cfnCoreDefinitionCoreDefinitionVersionPropertyToCloudFormation(properties.initialVersion), Tags: cdk.objectToCloudFormation(properties.tags) }) : properties;
    }
    function CfnCoreDefinitionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("initialVersion", "InitialVersion", properties.InitialVersion != null ? CfnCoreDefinitionCoreDefinitionVersionPropertyFromCloudFormation(properties.InitialVersion) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCoreDefinition = class _CfnCoreDefinition extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCoreDefinitionPropsFromCloudFormation(resourceProperties), ret = new _CfnCoreDefinition(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCoreDefinition.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_greengrass_CfnCoreDefinitionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCoreDefinition), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrLatestVersionArn = cdk.Token.asString(this.getAtt("LatestVersionArn", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.initialVersion = props.initialVersion, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Greengrass::CoreDefinition", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCoreDefinition.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, initialVersion: this.initialVersion, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnCoreDefinitionPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnCoreDefinition[_c] = { fqn: "aws-cdk-lib.aws_greengrass.CfnCoreDefinition", version: "2.80.0" }, CfnCoreDefinition.CFN_RESOURCE_TYPE_NAME = "AWS::Greengrass::CoreDefinition", exports2.CfnCoreDefinition = CfnCoreDefinition;
    function CfnCoreDefinition_CorePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateArn", cdk.requiredValidator)(properties.certificateArn)), errors.collect(cdk.propertyValidator("certificateArn", cdk.validateString)(properties.certificateArn)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("syncShadow", cdk.validateBoolean)(properties.syncShadow)), errors.collect(cdk.propertyValidator("thingArn", cdk.requiredValidator)(properties.thingArn)), errors.collect(cdk.propertyValidator("thingArn", cdk.validateString)(properties.thingArn)), errors.wrap('supplied properties not correct for "CoreProperty"');
    }
    function cfnCoreDefinitionCorePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCoreDefinition_CorePropertyValidator(properties).assertSuccess(), { CertificateArn: cdk.stringToCloudFormation(properties.certificateArn), Id: cdk.stringToCloudFormation(properties.id), SyncShadow: cdk.booleanToCloudFormation(properties.syncShadow), ThingArn: cdk.stringToCloudFormation(properties.thingArn) }) : properties;
    }
    function CfnCoreDefinitionCorePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificateArn", "CertificateArn", cfn_parse.FromCloudFormation.getString(properties.CertificateArn)), ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("syncShadow", "SyncShadow", properties.SyncShadow != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SyncShadow) : void 0), ret.addPropertyResult("thingArn", "ThingArn", cfn_parse.FromCloudFormation.getString(properties.ThingArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCoreDefinition_CoreDefinitionVersionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cores", cdk.requiredValidator)(properties.cores)), errors.collect(cdk.propertyValidator("cores", cdk.listValidator(CfnCoreDefinition_CorePropertyValidator))(properties.cores)), errors.wrap('supplied properties not correct for "CoreDefinitionVersionProperty"');
    }
    function cfnCoreDefinitionCoreDefinitionVersionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCoreDefinition_CoreDefinitionVersionPropertyValidator(properties).assertSuccess(), { Cores: cdk.listMapper(cfnCoreDefinitionCorePropertyToCloudFormation)(properties.cores) }) : properties;
    }
    function CfnCoreDefinitionCoreDefinitionVersionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cores", "Cores", cfn_parse.FromCloudFormation.getArray(CfnCoreDefinitionCorePropertyFromCloudFormation)(properties.Cores)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCoreDefinitionVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("coreDefinitionId", cdk.requiredValidator)(properties.coreDefinitionId)), errors.collect(cdk.propertyValidator("coreDefinitionId", cdk.validateString)(properties.coreDefinitionId)), errors.collect(cdk.propertyValidator("cores", cdk.requiredValidator)(properties.cores)), errors.collect(cdk.propertyValidator("cores", cdk.listValidator(CfnCoreDefinitionVersion_CorePropertyValidator))(properties.cores)), errors.wrap('supplied properties not correct for "CfnCoreDefinitionVersionProps"');
    }
    function cfnCoreDefinitionVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCoreDefinitionVersionPropsValidator(properties).assertSuccess(), { CoreDefinitionId: cdk.stringToCloudFormation(properties.coreDefinitionId), Cores: cdk.listMapper(cfnCoreDefinitionVersionCorePropertyToCloudFormation)(properties.cores) }) : properties;
    }
    function CfnCoreDefinitionVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("coreDefinitionId", "CoreDefinitionId", cfn_parse.FromCloudFormation.getString(properties.CoreDefinitionId)), ret.addPropertyResult("cores", "Cores", cfn_parse.FromCloudFormation.getArray(CfnCoreDefinitionVersionCorePropertyFromCloudFormation)(properties.Cores)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCoreDefinitionVersion = class _CfnCoreDefinitionVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCoreDefinitionVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnCoreDefinitionVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCoreDefinitionVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_greengrass_CfnCoreDefinitionVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCoreDefinitionVersion), error;
        }
        cdk.requireProperty(props, "coreDefinitionId", this), cdk.requireProperty(props, "cores", this), this.coreDefinitionId = props.coreDefinitionId, this.cores = props.cores;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCoreDefinitionVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { coreDefinitionId: this.coreDefinitionId, cores: this.cores };
      }
      renderProperties(props) {
        return cfnCoreDefinitionVersionPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnCoreDefinitionVersion[_d] = { fqn: "aws-cdk-lib.aws_greengrass.CfnCoreDefinitionVersion", version: "2.80.0" }, CfnCoreDefinitionVersion.CFN_RESOURCE_TYPE_NAME = "AWS::Greengrass::CoreDefinitionVersion", exports2.CfnCoreDefinitionVersion = CfnCoreDefinitionVersion;
    function CfnCoreDefinitionVersion_CorePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateArn", cdk.requiredValidator)(properties.certificateArn)), errors.collect(cdk.propertyValidator("certificateArn", cdk.validateString)(properties.certificateArn)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("syncShadow", cdk.validateBoolean)(properties.syncShadow)), errors.collect(cdk.propertyValidator("thingArn", cdk.requiredValidator)(properties.thingArn)), errors.collect(cdk.propertyValidator("thingArn", cdk.validateString)(properties.thingArn)), errors.wrap('supplied properties not correct for "CoreProperty"');
    }
    function cfnCoreDefinitionVersionCorePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCoreDefinitionVersion_CorePropertyValidator(properties).assertSuccess(), { CertificateArn: cdk.stringToCloudFormation(properties.certificateArn), Id: cdk.stringToCloudFormation(properties.id), SyncShadow: cdk.booleanToCloudFormation(properties.syncShadow), ThingArn: cdk.stringToCloudFormation(properties.thingArn) }) : properties;
    }
    function CfnCoreDefinitionVersionCorePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificateArn", "CertificateArn", cfn_parse.FromCloudFormation.getString(properties.CertificateArn)), ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("syncShadow", "SyncShadow", properties.SyncShadow != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SyncShadow) : void 0), ret.addPropertyResult("thingArn", "ThingArn", cfn_parse.FromCloudFormation.getString(properties.ThingArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeviceDefinitionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("initialVersion", CfnDeviceDefinition_DeviceDefinitionVersionPropertyValidator)(properties.initialVersion)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.wrap('supplied properties not correct for "CfnDeviceDefinitionProps"');
    }
    function cfnDeviceDefinitionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeviceDefinitionPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), InitialVersion: cfnDeviceDefinitionDeviceDefinitionVersionPropertyToCloudFormation(properties.initialVersion), Tags: cdk.objectToCloudFormation(properties.tags) }) : properties;
    }
    function CfnDeviceDefinitionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("initialVersion", "InitialVersion", properties.InitialVersion != null ? CfnDeviceDefinitionDeviceDefinitionVersionPropertyFromCloudFormation(properties.InitialVersion) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDeviceDefinition = class _CfnDeviceDefinition extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDeviceDefinitionPropsFromCloudFormation(resourceProperties), ret = new _CfnDeviceDefinition(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDeviceDefinition.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_greengrass_CfnDeviceDefinitionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDeviceDefinition), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrLatestVersionArn = cdk.Token.asString(this.getAtt("LatestVersionArn", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.initialVersion = props.initialVersion, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Greengrass::DeviceDefinition", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDeviceDefinition.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, initialVersion: this.initialVersion, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDeviceDefinitionPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnDeviceDefinition[_e] = { fqn: "aws-cdk-lib.aws_greengrass.CfnDeviceDefinition", version: "2.80.0" }, CfnDeviceDefinition.CFN_RESOURCE_TYPE_NAME = "AWS::Greengrass::DeviceDefinition", exports2.CfnDeviceDefinition = CfnDeviceDefinition;
    function CfnDeviceDefinition_DevicePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateArn", cdk.requiredValidator)(properties.certificateArn)), errors.collect(cdk.propertyValidator("certificateArn", cdk.validateString)(properties.certificateArn)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("syncShadow", cdk.validateBoolean)(properties.syncShadow)), errors.collect(cdk.propertyValidator("thingArn", cdk.requiredValidator)(properties.thingArn)), errors.collect(cdk.propertyValidator("thingArn", cdk.validateString)(properties.thingArn)), errors.wrap('supplied properties not correct for "DeviceProperty"');
    }
    function cfnDeviceDefinitionDevicePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeviceDefinition_DevicePropertyValidator(properties).assertSuccess(), { CertificateArn: cdk.stringToCloudFormation(properties.certificateArn), Id: cdk.stringToCloudFormation(properties.id), SyncShadow: cdk.booleanToCloudFormation(properties.syncShadow), ThingArn: cdk.stringToCloudFormation(properties.thingArn) }) : properties;
    }
    function CfnDeviceDefinitionDevicePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificateArn", "CertificateArn", cfn_parse.FromCloudFormation.getString(properties.CertificateArn)), ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("syncShadow", "SyncShadow", properties.SyncShadow != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SyncShadow) : void 0), ret.addPropertyResult("thingArn", "ThingArn", cfn_parse.FromCloudFormation.getString(properties.ThingArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeviceDefinition_DeviceDefinitionVersionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("devices", cdk.requiredValidator)(properties.devices)), errors.collect(cdk.propertyValidator("devices", cdk.listValidator(CfnDeviceDefinition_DevicePropertyValidator))(properties.devices)), errors.wrap('supplied properties not correct for "DeviceDefinitionVersionProperty"');
    }
    function cfnDeviceDefinitionDeviceDefinitionVersionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeviceDefinition_DeviceDefinitionVersionPropertyValidator(properties).assertSuccess(), { Devices: cdk.listMapper(cfnDeviceDefinitionDevicePropertyToCloudFormation)(properties.devices) }) : properties;
    }
    function CfnDeviceDefinitionDeviceDefinitionVersionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("devices", "Devices", cfn_parse.FromCloudFormation.getArray(CfnDeviceDefinitionDevicePropertyFromCloudFormation)(properties.Devices)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeviceDefinitionVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deviceDefinitionId", cdk.requiredValidator)(properties.deviceDefinitionId)), errors.collect(cdk.propertyValidator("deviceDefinitionId", cdk.validateString)(properties.deviceDefinitionId)), errors.collect(cdk.propertyValidator("devices", cdk.requiredValidator)(properties.devices)), errors.collect(cdk.propertyValidator("devices", cdk.listValidator(CfnDeviceDefinitionVersion_DevicePropertyValidator))(properties.devices)), errors.wrap('supplied properties not correct for "CfnDeviceDefinitionVersionProps"');
    }
    function cfnDeviceDefinitionVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeviceDefinitionVersionPropsValidator(properties).assertSuccess(), { DeviceDefinitionId: cdk.stringToCloudFormation(properties.deviceDefinitionId), Devices: cdk.listMapper(cfnDeviceDefinitionVersionDevicePropertyToCloudFormation)(properties.devices) }) : properties;
    }
    function CfnDeviceDefinitionVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deviceDefinitionId", "DeviceDefinitionId", cfn_parse.FromCloudFormation.getString(properties.DeviceDefinitionId)), ret.addPropertyResult("devices", "Devices", cfn_parse.FromCloudFormation.getArray(CfnDeviceDefinitionVersionDevicePropertyFromCloudFormation)(properties.Devices)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDeviceDefinitionVersion = class _CfnDeviceDefinitionVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDeviceDefinitionVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnDeviceDefinitionVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDeviceDefinitionVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_greengrass_CfnDeviceDefinitionVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDeviceDefinitionVersion), error;
        }
        cdk.requireProperty(props, "deviceDefinitionId", this), cdk.requireProperty(props, "devices", this), this.deviceDefinitionId = props.deviceDefinitionId, this.devices = props.devices;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDeviceDefinitionVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { deviceDefinitionId: this.deviceDefinitionId, devices: this.devices };
      }
      renderProperties(props) {
        return cfnDeviceDefinitionVersionPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnDeviceDefinitionVersion[_f] = { fqn: "aws-cdk-lib.aws_greengrass.CfnDeviceDefinitionVersion", version: "2.80.0" }, CfnDeviceDefinitionVersion.CFN_RESOURCE_TYPE_NAME = "AWS::Greengrass::DeviceDefinitionVersion", exports2.CfnDeviceDefinitionVersion = CfnDeviceDefinitionVersion;
    function CfnDeviceDefinitionVersion_DevicePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateArn", cdk.requiredValidator)(properties.certificateArn)), errors.collect(cdk.propertyValidator("certificateArn", cdk.validateString)(properties.certificateArn)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("syncShadow", cdk.validateBoolean)(properties.syncShadow)), errors.collect(cdk.propertyValidator("thingArn", cdk.requiredValidator)(properties.thingArn)), errors.collect(cdk.propertyValidator("thingArn", cdk.validateString)(properties.thingArn)), errors.wrap('supplied properties not correct for "DeviceProperty"');
    }
    function cfnDeviceDefinitionVersionDevicePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeviceDefinitionVersion_DevicePropertyValidator(properties).assertSuccess(), { CertificateArn: cdk.stringToCloudFormation(properties.certificateArn), Id: cdk.stringToCloudFormation(properties.id), SyncShadow: cdk.booleanToCloudFormation(properties.syncShadow), ThingArn: cdk.stringToCloudFormation(properties.thingArn) }) : properties;
    }
    function CfnDeviceDefinitionVersionDevicePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificateArn", "CertificateArn", cfn_parse.FromCloudFormation.getString(properties.CertificateArn)), ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("syncShadow", "SyncShadow", properties.SyncShadow != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SyncShadow) : void 0), ret.addPropertyResult("thingArn", "ThingArn", cfn_parse.FromCloudFormation.getString(properties.ThingArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunctionDefinitionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("initialVersion", CfnFunctionDefinition_FunctionDefinitionVersionPropertyValidator)(properties.initialVersion)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.wrap('supplied properties not correct for "CfnFunctionDefinitionProps"');
    }
    function cfnFunctionDefinitionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunctionDefinitionPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), InitialVersion: cfnFunctionDefinitionFunctionDefinitionVersionPropertyToCloudFormation(properties.initialVersion), Tags: cdk.objectToCloudFormation(properties.tags) }) : properties;
    }
    function CfnFunctionDefinitionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("initialVersion", "InitialVersion", properties.InitialVersion != null ? CfnFunctionDefinitionFunctionDefinitionVersionPropertyFromCloudFormation(properties.InitialVersion) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFunctionDefinition = class _CfnFunctionDefinition extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFunctionDefinitionPropsFromCloudFormation(resourceProperties), ret = new _CfnFunctionDefinition(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFunctionDefinition.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_greengrass_CfnFunctionDefinitionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFunctionDefinition), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrLatestVersionArn = cdk.Token.asString(this.getAtt("LatestVersionArn", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.initialVersion = props.initialVersion, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Greengrass::FunctionDefinition", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFunctionDefinition.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, initialVersion: this.initialVersion, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnFunctionDefinitionPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnFunctionDefinition[_g] = { fqn: "aws-cdk-lib.aws_greengrass.CfnFunctionDefinition", version: "2.80.0" }, CfnFunctionDefinition.CFN_RESOURCE_TYPE_NAME = "AWS::Greengrass::FunctionDefinition", exports2.CfnFunctionDefinition = CfnFunctionDefinition;
    function CfnFunctionDefinition_DefaultConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("execution", cdk.requiredValidator)(properties.execution)), errors.collect(cdk.propertyValidator("execution", CfnFunctionDefinition_ExecutionPropertyValidator)(properties.execution)), errors.wrap('supplied properties not correct for "DefaultConfigProperty"');
    }
    function cfnFunctionDefinitionDefaultConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunctionDefinition_DefaultConfigPropertyValidator(properties).assertSuccess(), { Execution: cfnFunctionDefinitionExecutionPropertyToCloudFormation(properties.execution) }) : properties;
    }
    function CfnFunctionDefinitionDefaultConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("execution", "Execution", CfnFunctionDefinitionExecutionPropertyFromCloudFormation(properties.Execution)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunctionDefinition_EnvironmentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessSysfs", cdk.validateBoolean)(properties.accessSysfs)), errors.collect(cdk.propertyValidator("execution", CfnFunctionDefinition_ExecutionPropertyValidator)(properties.execution)), errors.collect(cdk.propertyValidator("resourceAccessPolicies", cdk.listValidator(CfnFunctionDefinition_ResourceAccessPolicyPropertyValidator))(properties.resourceAccessPolicies)), errors.collect(cdk.propertyValidator("variables", cdk.validateObject)(properties.variables)), errors.wrap('supplied properties not correct for "EnvironmentProperty"');
    }
    function cfnFunctionDefinitionEnvironmentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunctionDefinition_EnvironmentPropertyValidator(properties).assertSuccess(), { AccessSysfs: cdk.booleanToCloudFormation(properties.accessSysfs), Execution: cfnFunctionDefinitionExecutionPropertyToCloudFormation(properties.execution), ResourceAccessPolicies: cdk.listMapper(cfnFunctionDefinitionResourceAccessPolicyPropertyToCloudFormation)(properties.resourceAccessPolicies), Variables: cdk.objectToCloudFormation(properties.variables) }) : properties;
    }
    function CfnFunctionDefinitionEnvironmentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessSysfs", "AccessSysfs", properties.AccessSysfs != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AccessSysfs) : void 0), ret.addPropertyResult("execution", "Execution", properties.Execution != null ? CfnFunctionDefinitionExecutionPropertyFromCloudFormation(properties.Execution) : void 0), ret.addPropertyResult("resourceAccessPolicies", "ResourceAccessPolicies", properties.ResourceAccessPolicies != null ? cfn_parse.FromCloudFormation.getArray(CfnFunctionDefinitionResourceAccessPolicyPropertyFromCloudFormation)(properties.ResourceAccessPolicies) : void 0), ret.addPropertyResult("variables", "Variables", properties.Variables != null ? cfn_parse.FromCloudFormation.getAny(properties.Variables) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunctionDefinition_ExecutionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("isolationMode", cdk.validateString)(properties.isolationMode)), errors.collect(cdk.propertyValidator("runAs", CfnFunctionDefinition_RunAsPropertyValidator)(properties.runAs)), errors.wrap('supplied properties not correct for "ExecutionProperty"');
    }
    function cfnFunctionDefinitionExecutionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunctionDefinition_ExecutionPropertyValidator(properties).assertSuccess(), { IsolationMode: cdk.stringToCloudFormation(properties.isolationMode), RunAs: cfnFunctionDefinitionRunAsPropertyToCloudFormation(properties.runAs) }) : properties;
    }
    function CfnFunctionDefinitionExecutionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("isolationMode", "IsolationMode", properties.IsolationMode != null ? cfn_parse.FromCloudFormation.getString(properties.IsolationMode) : void 0), ret.addPropertyResult("runAs", "RunAs", properties.RunAs != null ? CfnFunctionDefinitionRunAsPropertyFromCloudFormation(properties.RunAs) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunctionDefinition_FunctionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("functionArn", cdk.requiredValidator)(properties.functionArn)), errors.collect(cdk.propertyValidator("functionArn", cdk.validateString)(properties.functionArn)), errors.collect(cdk.propertyValidator("functionConfiguration", cdk.requiredValidator)(properties.functionConfiguration)), errors.collect(cdk.propertyValidator("functionConfiguration", CfnFunctionDefinition_FunctionConfigurationPropertyValidator)(properties.functionConfiguration)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.wrap('supplied properties not correct for "FunctionProperty"');
    }
    function cfnFunctionDefinitionFunctionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunctionDefinition_FunctionPropertyValidator(properties).assertSuccess(), { FunctionArn: cdk.stringToCloudFormation(properties.functionArn), FunctionConfiguration: cfnFunctionDefinitionFunctionConfigurationPropertyToCloudFormation(properties.functionConfiguration), Id: cdk.stringToCloudFormation(properties.id) }) : properties;
    }
    function CfnFunctionDefinitionFunctionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("functionArn", "FunctionArn", cfn_parse.FromCloudFormation.getString(properties.FunctionArn)), ret.addPropertyResult("functionConfiguration", "FunctionConfiguration", CfnFunctionDefinitionFunctionConfigurationPropertyFromCloudFormation(properties.FunctionConfiguration)), ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunctionDefinition_FunctionConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("encodingType", cdk.validateString)(properties.encodingType)), errors.collect(cdk.propertyValidator("environment", CfnFunctionDefinition_EnvironmentPropertyValidator)(properties.environment)), errors.collect(cdk.propertyValidator("execArgs", cdk.validateString)(properties.execArgs)), errors.collect(cdk.propertyValidator("executable", cdk.validateString)(properties.executable)), errors.collect(cdk.propertyValidator("memorySize", cdk.validateNumber)(properties.memorySize)), errors.collect(cdk.propertyValidator("pinned", cdk.validateBoolean)(properties.pinned)), errors.collect(cdk.propertyValidator("timeout", cdk.validateNumber)(properties.timeout)), errors.wrap('supplied properties not correct for "FunctionConfigurationProperty"');
    }
    function cfnFunctionDefinitionFunctionConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunctionDefinition_FunctionConfigurationPropertyValidator(properties).assertSuccess(), { EncodingType: cdk.stringToCloudFormation(properties.encodingType), Environment: cfnFunctionDefinitionEnvironmentPropertyToCloudFormation(properties.environment), ExecArgs: cdk.stringToCloudFormation(properties.execArgs), Executable: cdk.stringToCloudFormation(properties.executable), MemorySize: cdk.numberToCloudFormation(properties.memorySize), Pinned: cdk.booleanToCloudFormation(properties.pinned), Timeout: cdk.numberToCloudFormation(properties.timeout) }) : properties;
    }
    function CfnFunctionDefinitionFunctionConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("encodingType", "EncodingType", properties.EncodingType != null ? cfn_parse.FromCloudFormation.getString(properties.EncodingType) : void 0), ret.addPropertyResult("environment", "Environment", properties.Environment != null ? CfnFunctionDefinitionEnvironmentPropertyFromCloudFormation(properties.Environment) : void 0), ret.addPropertyResult("execArgs", "ExecArgs", properties.ExecArgs != null ? cfn_parse.FromCloudFormation.getString(properties.ExecArgs) : void 0), ret.addPropertyResult("executable", "Executable", properties.Executable != null ? cfn_parse.FromCloudFormation.getString(properties.Executable) : void 0), ret.addPropertyResult("memorySize", "MemorySize", properties.MemorySize != null ? cfn_parse.FromCloudFormation.getNumber(properties.MemorySize) : void 0), ret.addPropertyResult("pinned", "Pinned", properties.Pinned != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Pinned) : void 0), ret.addPropertyResult("timeout", "Timeout", properties.Timeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.Timeout) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunctionDefinition_FunctionDefinitionVersionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultConfig", CfnFunctionDefinition_DefaultConfigPropertyValidator)(properties.defaultConfig)), errors.collect(cdk.propertyValidator("functions", cdk.requiredValidator)(properties.functions)), errors.collect(cdk.propertyValidator("functions", cdk.listValidator(CfnFunctionDefinition_FunctionPropertyValidator))(properties.functions)), errors.wrap('supplied properties not correct for "FunctionDefinitionVersionProperty"');
    }
    function cfnFunctionDefinitionFunctionDefinitionVersionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunctionDefinition_FunctionDefinitionVersionPropertyValidator(properties).assertSuccess(), { DefaultConfig: cfnFunctionDefinitionDefaultConfigPropertyToCloudFormation(properties.defaultConfig), Functions: cdk.listMapper(cfnFunctionDefinitionFunctionPropertyToCloudFormation)(properties.functions) }) : properties;
    }
    function CfnFunctionDefinitionFunctionDefinitionVersionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultConfig", "DefaultConfig", properties.DefaultConfig != null ? CfnFunctionDefinitionDefaultConfigPropertyFromCloudFormation(properties.DefaultConfig) : void 0), ret.addPropertyResult("functions", "Functions", cfn_parse.FromCloudFormation.getArray(CfnFunctionDefinitionFunctionPropertyFromCloudFormation)(properties.Functions)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunctionDefinition_ResourceAccessPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("permission", cdk.validateString)(properties.permission)), errors.collect(cdk.propertyValidator("resourceId", cdk.requiredValidator)(properties.resourceId)), errors.collect(cdk.propertyValidator("resourceId", cdk.validateString)(properties.resourceId)), errors.wrap('supplied properties not correct for "ResourceAccessPolicyProperty"');
    }
    function cfnFunctionDefinitionResourceAccessPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunctionDefinition_ResourceAccessPolicyPropertyValidator(properties).assertSuccess(), { Permission: cdk.stringToCloudFormation(properties.permission), ResourceId: cdk.stringToCloudFormation(properties.resourceId) }) : properties;
    }
    function CfnFunctionDefinitionResourceAccessPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("permission", "Permission", properties.Permission != null ? cfn_parse.FromCloudFormation.getString(properties.Permission) : void 0), ret.addPropertyResult("resourceId", "ResourceId", cfn_parse.FromCloudFormation.getString(properties.ResourceId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunctionDefinition_RunAsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("gid", cdk.validateNumber)(properties.gid)), errors.collect(cdk.propertyValidator("uid", cdk.validateNumber)(properties.uid)), errors.wrap('supplied properties not correct for "RunAsProperty"');
    }
    function cfnFunctionDefinitionRunAsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunctionDefinition_RunAsPropertyValidator(properties).assertSuccess(), { Gid: cdk.numberToCloudFormation(properties.gid), Uid: cdk.numberToCloudFormation(properties.uid) }) : properties;
    }
    function CfnFunctionDefinitionRunAsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("gid", "Gid", properties.Gid != null ? cfn_parse.FromCloudFormation.getNumber(properties.Gid) : void 0), ret.addPropertyResult("uid", "Uid", properties.Uid != null ? cfn_parse.FromCloudFormation.getNumber(properties.Uid) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunctionDefinitionVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultConfig", CfnFunctionDefinitionVersion_DefaultConfigPropertyValidator)(properties.defaultConfig)), errors.collect(cdk.propertyValidator("functionDefinitionId", cdk.requiredValidator)(properties.functionDefinitionId)), errors.collect(cdk.propertyValidator("functionDefinitionId", cdk.validateString)(properties.functionDefinitionId)), errors.collect(cdk.propertyValidator("functions", cdk.requiredValidator)(properties.functions)), errors.collect(cdk.propertyValidator("functions", cdk.listValidator(CfnFunctionDefinitionVersion_FunctionPropertyValidator))(properties.functions)), errors.wrap('supplied properties not correct for "CfnFunctionDefinitionVersionProps"');
    }
    function cfnFunctionDefinitionVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunctionDefinitionVersionPropsValidator(properties).assertSuccess(), { FunctionDefinitionId: cdk.stringToCloudFormation(properties.functionDefinitionId), Functions: cdk.listMapper(cfnFunctionDefinitionVersionFunctionPropertyToCloudFormation)(properties.functions), DefaultConfig: cfnFunctionDefinitionVersionDefaultConfigPropertyToCloudFormation(properties.defaultConfig) }) : properties;
    }
    function CfnFunctionDefinitionVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("functionDefinitionId", "FunctionDefinitionId", cfn_parse.FromCloudFormation.getString(properties.FunctionDefinitionId)), ret.addPropertyResult("functions", "Functions", cfn_parse.FromCloudFormation.getArray(CfnFunctionDefinitionVersionFunctionPropertyFromCloudFormation)(properties.Functions)), ret.addPropertyResult("defaultConfig", "DefaultConfig", properties.DefaultConfig != null ? CfnFunctionDefinitionVersionDefaultConfigPropertyFromCloudFormation(properties.DefaultConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFunctionDefinitionVersion = class _CfnFunctionDefinitionVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFunctionDefinitionVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnFunctionDefinitionVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFunctionDefinitionVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_greengrass_CfnFunctionDefinitionVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFunctionDefinitionVersion), error;
        }
        cdk.requireProperty(props, "functionDefinitionId", this), cdk.requireProperty(props, "functions", this), this.functionDefinitionId = props.functionDefinitionId, this.functions = props.functions, this.defaultConfig = props.defaultConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFunctionDefinitionVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { functionDefinitionId: this.functionDefinitionId, functions: this.functions, defaultConfig: this.defaultConfig };
      }
      renderProperties(props) {
        return cfnFunctionDefinitionVersionPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnFunctionDefinitionVersion[_h] = { fqn: "aws-cdk-lib.aws_greengrass.CfnFunctionDefinitionVersion", version: "2.80.0" }, CfnFunctionDefinitionVersion.CFN_RESOURCE_TYPE_NAME = "AWS::Greengrass::FunctionDefinitionVersion", exports2.CfnFunctionDefinitionVersion = CfnFunctionDefinitionVersion;
    function CfnFunctionDefinitionVersion_DefaultConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("execution", cdk.requiredValidator)(properties.execution)), errors.collect(cdk.propertyValidator("execution", CfnFunctionDefinitionVersion_ExecutionPropertyValidator)(properties.execution)), errors.wrap('supplied properties not correct for "DefaultConfigProperty"');
    }
    function cfnFunctionDefinitionVersionDefaultConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunctionDefinitionVersion_DefaultConfigPropertyValidator(properties).assertSuccess(), { Execution: cfnFunctionDefinitionVersionExecutionPropertyToCloudFormation(properties.execution) }) : properties;
    }
    function CfnFunctionDefinitionVersionDefaultConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("execution", "Execution", CfnFunctionDefinitionVersionExecutionPropertyFromCloudFormation(properties.Execution)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunctionDefinitionVersion_EnvironmentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessSysfs", cdk.validateBoolean)(properties.accessSysfs)), errors.collect(cdk.propertyValidator("execution", CfnFunctionDefinitionVersion_ExecutionPropertyValidator)(properties.execution)), errors.collect(cdk.propertyValidator("resourceAccessPolicies", cdk.listValidator(CfnFunctionDefinitionVersion_ResourceAccessPolicyPropertyValidator))(properties.resourceAccessPolicies)), errors.collect(cdk.propertyValidator("variables", cdk.validateObject)(properties.variables)), errors.wrap('supplied properties not correct for "EnvironmentProperty"');
    }
    function cfnFunctionDefinitionVersionEnvironmentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunctionDefinitionVersion_EnvironmentPropertyValidator(properties).assertSuccess(), { AccessSysfs: cdk.booleanToCloudFormation(properties.accessSysfs), Execution: cfnFunctionDefinitionVersionExecutionPropertyToCloudFormation(properties.execution), ResourceAccessPolicies: cdk.listMapper(cfnFunctionDefinitionVersionResourceAccessPolicyPropertyToCloudFormation)(properties.resourceAccessPolicies), Variables: cdk.objectToCloudFormation(properties.variables) }) : properties;
    }
    function CfnFunctionDefinitionVersionEnvironmentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessSysfs", "AccessSysfs", properties.AccessSysfs != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AccessSysfs) : void 0), ret.addPropertyResult("execution", "Execution", properties.Execution != null ? CfnFunctionDefinitionVersionExecutionPropertyFromCloudFormation(properties.Execution) : void 0), ret.addPropertyResult("resourceAccessPolicies", "ResourceAccessPolicies", properties.ResourceAccessPolicies != null ? cfn_parse.FromCloudFormation.getArray(CfnFunctionDefinitionVersionResourceAccessPolicyPropertyFromCloudFormation)(properties.ResourceAccessPolicies) : void 0), ret.addPropertyResult("variables", "Variables", properties.Variables != null ? cfn_parse.FromCloudFormation.getAny(properties.Variables) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunctionDefinitionVersion_ExecutionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("isolationMode", cdk.validateString)(properties.isolationMode)), errors.collect(cdk.propertyValidator("runAs", CfnFunctionDefinitionVersion_RunAsPropertyValidator)(properties.runAs)), errors.wrap('supplied properties not correct for "ExecutionProperty"');
    }
    function cfnFunctionDefinitionVersionExecutionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunctionDefinitionVersion_ExecutionPropertyValidator(properties).assertSuccess(), { IsolationMode: cdk.stringToCloudFormation(properties.isolationMode), RunAs: cfnFunctionDefinitionVersionRunAsPropertyToCloudFormation(properties.runAs) }) : properties;
    }
    function CfnFunctionDefinitionVersionExecutionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("isolationMode", "IsolationMode", properties.IsolationMode != null ? cfn_parse.FromCloudFormation.getString(properties.IsolationMode) : void 0), ret.addPropertyResult("runAs", "RunAs", properties.RunAs != null ? CfnFunctionDefinitionVersionRunAsPropertyFromCloudFormation(properties.RunAs) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunctionDefinitionVersion_FunctionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("functionArn", cdk.requiredValidator)(properties.functionArn)), errors.collect(cdk.propertyValidator("functionArn", cdk.validateString)(properties.functionArn)), errors.collect(cdk.propertyValidator("functionConfiguration", cdk.requiredValidator)(properties.functionConfiguration)), errors.collect(cdk.propertyValidator("functionConfiguration", CfnFunctionDefinitionVersion_FunctionConfigurationPropertyValidator)(properties.functionConfiguration)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.wrap('supplied properties not correct for "FunctionProperty"');
    }
    function cfnFunctionDefinitionVersionFunctionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunctionDefinitionVersion_FunctionPropertyValidator(properties).assertSuccess(), { FunctionArn: cdk.stringToCloudFormation(properties.functionArn), FunctionConfiguration: cfnFunctionDefinitionVersionFunctionConfigurationPropertyToCloudFormation(properties.functionConfiguration), Id: cdk.stringToCloudFormation(properties.id) }) : properties;
    }
    function CfnFunctionDefinitionVersionFunctionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("functionArn", "FunctionArn", cfn_parse.FromCloudFormation.getString(properties.FunctionArn)), ret.addPropertyResult("functionConfiguration", "FunctionConfiguration", CfnFunctionDefinitionVersionFunctionConfigurationPropertyFromCloudFormation(properties.FunctionConfiguration)), ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunctionDefinitionVersion_FunctionConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("encodingType", cdk.validateString)(properties.encodingType)), errors.collect(cdk.propertyValidator("environment", CfnFunctionDefinitionVersion_EnvironmentPropertyValidator)(properties.environment)), errors.collect(cdk.propertyValidator("execArgs", cdk.validateString)(properties.execArgs)), errors.collect(cdk.propertyValidator("executable", cdk.validateString)(properties.executable)), errors.collect(cdk.propertyValidator("memorySize", cdk.validateNumber)(properties.memorySize)), errors.collect(cdk.propertyValidator("pinned", cdk.validateBoolean)(properties.pinned)), errors.collect(cdk.propertyValidator("timeout", cdk.validateNumber)(properties.timeout)), errors.wrap('supplied properties not correct for "FunctionConfigurationProperty"');
    }
    function cfnFunctionDefinitionVersionFunctionConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunctionDefinitionVersion_FunctionConfigurationPropertyValidator(properties).assertSuccess(), { EncodingType: cdk.stringToCloudFormation(properties.encodingType), Environment: cfnFunctionDefinitionVersionEnvironmentPropertyToCloudFormation(properties.environment), ExecArgs: cdk.stringToCloudFormation(properties.execArgs), Executable: cdk.stringToCloudFormation(properties.executable), MemorySize: cdk.numberToCloudFormation(properties.memorySize), Pinned: cdk.booleanToCloudFormation(properties.pinned), Timeout: cdk.numberToCloudFormation(properties.timeout) }) : properties;
    }
    function CfnFunctionDefinitionVersionFunctionConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("encodingType", "EncodingType", properties.EncodingType != null ? cfn_parse.FromCloudFormation.getString(properties.EncodingType) : void 0), ret.addPropertyResult("environment", "Environment", properties.Environment != null ? CfnFunctionDefinitionVersionEnvironmentPropertyFromCloudFormation(properties.Environment) : void 0), ret.addPropertyResult("execArgs", "ExecArgs", properties.ExecArgs != null ? cfn_parse.FromCloudFormation.getString(properties.ExecArgs) : void 0), ret.addPropertyResult("executable", "Executable", properties.Executable != null ? cfn_parse.FromCloudFormation.getString(properties.Executable) : void 0), ret.addPropertyResult("memorySize", "MemorySize", properties.MemorySize != null ? cfn_parse.FromCloudFormation.getNumber(properties.MemorySize) : void 0), ret.addPropertyResult("pinned", "Pinned", properties.Pinned != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Pinned) : void 0), ret.addPropertyResult("timeout", "Timeout", properties.Timeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.Timeout) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunctionDefinitionVersion_ResourceAccessPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("permission", cdk.validateString)(properties.permission)), errors.collect(cdk.propertyValidator("resourceId", cdk.requiredValidator)(properties.resourceId)), errors.collect(cdk.propertyValidator("resourceId", cdk.validateString)(properties.resourceId)), errors.wrap('supplied properties not correct for "ResourceAccessPolicyProperty"');
    }
    function cfnFunctionDefinitionVersionResourceAccessPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunctionDefinitionVersion_ResourceAccessPolicyPropertyValidator(properties).assertSuccess(), { Permission: cdk.stringToCloudFormation(properties.permission), ResourceId: cdk.stringToCloudFormation(properties.resourceId) }) : properties;
    }
    function CfnFunctionDefinitionVersionResourceAccessPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("permission", "Permission", properties.Permission != null ? cfn_parse.FromCloudFormation.getString(properties.Permission) : void 0), ret.addPropertyResult("resourceId", "ResourceId", cfn_parse.FromCloudFormation.getString(properties.ResourceId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFunctionDefinitionVersion_RunAsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("gid", cdk.validateNumber)(properties.gid)), errors.collect(cdk.propertyValidator("uid", cdk.validateNumber)(properties.uid)), errors.wrap('supplied properties not correct for "RunAsProperty"');
    }
    function cfnFunctionDefinitionVersionRunAsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFunctionDefinitionVersion_RunAsPropertyValidator(properties).assertSuccess(), { Gid: cdk.numberToCloudFormation(properties.gid), Uid: cdk.numberToCloudFormation(properties.uid) }) : properties;
    }
    function CfnFunctionDefinitionVersionRunAsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("gid", "Gid", properties.Gid != null ? cfn_parse.FromCloudFormation.getNumber(properties.Gid) : void 0), ret.addPropertyResult("uid", "Uid", properties.Uid != null ? cfn_parse.FromCloudFormation.getNumber(properties.Uid) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("initialVersion", CfnGroup_GroupVersionPropertyValidator)(properties.initialVersion)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.wrap('supplied properties not correct for "CfnGroupProps"');
    }
    function cfnGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGroupPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), InitialVersion: cfnGroupGroupVersionPropertyToCloudFormation(properties.initialVersion), RoleArn: cdk.stringToCloudFormation(properties.roleArn), Tags: cdk.objectToCloudFormation(properties.tags) }) : properties;
    }
    function CfnGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("initialVersion", "InitialVersion", properties.InitialVersion != null ? CfnGroupGroupVersionPropertyFromCloudFormation(properties.InitialVersion) : void 0), ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnGroup = class _CfnGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_greengrass_CfnGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnGroup), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrLatestVersionArn = cdk.Token.asString(this.getAtt("LatestVersionArn", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.attrRoleArn = cdk.Token.asString(this.getAtt("RoleArn", cdk.ResolutionTypeHint.STRING)), this.attrRoleAttachedAt = cdk.Token.asString(this.getAtt("RoleAttachedAt", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.initialVersion = props.initialVersion, this.roleArn = props.roleArn, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Greengrass::Group", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, initialVersion: this.initialVersion, roleArn: this.roleArn, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnGroupPropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnGroup[_j] = { fqn: "aws-cdk-lib.aws_greengrass.CfnGroup", version: "2.80.0" }, CfnGroup.CFN_RESOURCE_TYPE_NAME = "AWS::Greengrass::Group", exports2.CfnGroup = CfnGroup;
    function CfnGroup_GroupVersionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectorDefinitionVersionArn", cdk.validateString)(properties.connectorDefinitionVersionArn)), errors.collect(cdk.propertyValidator("coreDefinitionVersionArn", cdk.validateString)(properties.coreDefinitionVersionArn)), errors.collect(cdk.propertyValidator("deviceDefinitionVersionArn", cdk.validateString)(properties.deviceDefinitionVersionArn)), errors.collect(cdk.propertyValidator("functionDefinitionVersionArn", cdk.validateString)(properties.functionDefinitionVersionArn)), errors.collect(cdk.propertyValidator("loggerDefinitionVersionArn", cdk.validateString)(properties.loggerDefinitionVersionArn)), errors.collect(cdk.propertyValidator("resourceDefinitionVersionArn", cdk.validateString)(properties.resourceDefinitionVersionArn)), errors.collect(cdk.propertyValidator("subscriptionDefinitionVersionArn", cdk.validateString)(properties.subscriptionDefinitionVersionArn)), errors.wrap('supplied properties not correct for "GroupVersionProperty"');
    }
    function cfnGroupGroupVersionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGroup_GroupVersionPropertyValidator(properties).assertSuccess(), { ConnectorDefinitionVersionArn: cdk.stringToCloudFormation(properties.connectorDefinitionVersionArn), CoreDefinitionVersionArn: cdk.stringToCloudFormation(properties.coreDefinitionVersionArn), DeviceDefinitionVersionArn: cdk.stringToCloudFormation(properties.deviceDefinitionVersionArn), FunctionDefinitionVersionArn: cdk.stringToCloudFormation(properties.functionDefinitionVersionArn), LoggerDefinitionVersionArn: cdk.stringToCloudFormation(properties.loggerDefinitionVersionArn), ResourceDefinitionVersionArn: cdk.stringToCloudFormation(properties.resourceDefinitionVersionArn), SubscriptionDefinitionVersionArn: cdk.stringToCloudFormation(properties.subscriptionDefinitionVersionArn) }) : properties;
    }
    function CfnGroupGroupVersionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectorDefinitionVersionArn", "ConnectorDefinitionVersionArn", properties.ConnectorDefinitionVersionArn != null ? cfn_parse.FromCloudFormation.getString(properties.ConnectorDefinitionVersionArn) : void 0), ret.addPropertyResult("coreDefinitionVersionArn", "CoreDefinitionVersionArn", properties.CoreDefinitionVersionArn != null ? cfn_parse.FromCloudFormation.getString(properties.CoreDefinitionVersionArn) : void 0), ret.addPropertyResult("deviceDefinitionVersionArn", "DeviceDefinitionVersionArn", properties.DeviceDefinitionVersionArn != null ? cfn_parse.FromCloudFormation.getString(properties.DeviceDefinitionVersionArn) : void 0), ret.addPropertyResult("functionDefinitionVersionArn", "FunctionDefinitionVersionArn", properties.FunctionDefinitionVersionArn != null ? cfn_parse.FromCloudFormation.getString(properties.FunctionDefinitionVersionArn) : void 0), ret.addPropertyResult("loggerDefinitionVersionArn", "LoggerDefinitionVersionArn", properties.LoggerDefinitionVersionArn != null ? cfn_parse.FromCloudFormation.getString(properties.LoggerDefinitionVersionArn) : void 0), ret.addPropertyResult("resourceDefinitionVersionArn", "ResourceDefinitionVersionArn", properties.ResourceDefinitionVersionArn != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceDefinitionVersionArn) : void 0), ret.addPropertyResult("subscriptionDefinitionVersionArn", "SubscriptionDefinitionVersionArn", properties.SubscriptionDefinitionVersionArn != null ? cfn_parse.FromCloudFormation.getString(properties.SubscriptionDefinitionVersionArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGroupVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectorDefinitionVersionArn", cdk.validateString)(properties.connectorDefinitionVersionArn)), errors.collect(cdk.propertyValidator("coreDefinitionVersionArn", cdk.validateString)(properties.coreDefinitionVersionArn)), errors.collect(cdk.propertyValidator("deviceDefinitionVersionArn", cdk.validateString)(properties.deviceDefinitionVersionArn)), errors.collect(cdk.propertyValidator("functionDefinitionVersionArn", cdk.validateString)(properties.functionDefinitionVersionArn)), errors.collect(cdk.propertyValidator("groupId", cdk.requiredValidator)(properties.groupId)), errors.collect(cdk.propertyValidator("groupId", cdk.validateString)(properties.groupId)), errors.collect(cdk.propertyValidator("loggerDefinitionVersionArn", cdk.validateString)(properties.loggerDefinitionVersionArn)), errors.collect(cdk.propertyValidator("resourceDefinitionVersionArn", cdk.validateString)(properties.resourceDefinitionVersionArn)), errors.collect(cdk.propertyValidator("subscriptionDefinitionVersionArn", cdk.validateString)(properties.subscriptionDefinitionVersionArn)), errors.wrap('supplied properties not correct for "CfnGroupVersionProps"');
    }
    function cfnGroupVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGroupVersionPropsValidator(properties).assertSuccess(), { GroupId: cdk.stringToCloudFormation(properties.groupId), ConnectorDefinitionVersionArn: cdk.stringToCloudFormation(properties.connectorDefinitionVersionArn), CoreDefinitionVersionArn: cdk.stringToCloudFormation(properties.coreDefinitionVersionArn), DeviceDefinitionVersionArn: cdk.stringToCloudFormation(properties.deviceDefinitionVersionArn), FunctionDefinitionVersionArn: cdk.stringToCloudFormation(properties.functionDefinitionVersionArn), LoggerDefinitionVersionArn: cdk.stringToCloudFormation(properties.loggerDefinitionVersionArn), ResourceDefinitionVersionArn: cdk.stringToCloudFormation(properties.resourceDefinitionVersionArn), SubscriptionDefinitionVersionArn: cdk.stringToCloudFormation(properties.subscriptionDefinitionVersionArn) }) : properties;
    }
    function CfnGroupVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupId", "GroupId", cfn_parse.FromCloudFormation.getString(properties.GroupId)), ret.addPropertyResult("connectorDefinitionVersionArn", "ConnectorDefinitionVersionArn", properties.ConnectorDefinitionVersionArn != null ? cfn_parse.FromCloudFormation.getString(properties.ConnectorDefinitionVersionArn) : void 0), ret.addPropertyResult("coreDefinitionVersionArn", "CoreDefinitionVersionArn", properties.CoreDefinitionVersionArn != null ? cfn_parse.FromCloudFormation.getString(properties.CoreDefinitionVersionArn) : void 0), ret.addPropertyResult("deviceDefinitionVersionArn", "DeviceDefinitionVersionArn", properties.DeviceDefinitionVersionArn != null ? cfn_parse.FromCloudFormation.getString(properties.DeviceDefinitionVersionArn) : void 0), ret.addPropertyResult("functionDefinitionVersionArn", "FunctionDefinitionVersionArn", properties.FunctionDefinitionVersionArn != null ? cfn_parse.FromCloudFormation.getString(properties.FunctionDefinitionVersionArn) : void 0), ret.addPropertyResult("loggerDefinitionVersionArn", "LoggerDefinitionVersionArn", properties.LoggerDefinitionVersionArn != null ? cfn_parse.FromCloudFormation.getString(properties.LoggerDefinitionVersionArn) : void 0), ret.addPropertyResult("resourceDefinitionVersionArn", "ResourceDefinitionVersionArn", properties.ResourceDefinitionVersionArn != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceDefinitionVersionArn) : void 0), ret.addPropertyResult("subscriptionDefinitionVersionArn", "SubscriptionDefinitionVersionArn", properties.SubscriptionDefinitionVersionArn != null ? cfn_parse.FromCloudFormation.getString(properties.SubscriptionDefinitionVersionArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnGroupVersion = class _CfnGroupVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnGroupVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnGroupVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnGroupVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_greengrass_CfnGroupVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnGroupVersion), error;
        }
        cdk.requireProperty(props, "groupId", this), this.groupId = props.groupId, this.connectorDefinitionVersionArn = props.connectorDefinitionVersionArn, this.coreDefinitionVersionArn = props.coreDefinitionVersionArn, this.deviceDefinitionVersionArn = props.deviceDefinitionVersionArn, this.functionDefinitionVersionArn = props.functionDefinitionVersionArn, this.loggerDefinitionVersionArn = props.loggerDefinitionVersionArn, this.resourceDefinitionVersionArn = props.resourceDefinitionVersionArn, this.subscriptionDefinitionVersionArn = props.subscriptionDefinitionVersionArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnGroupVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { groupId: this.groupId, connectorDefinitionVersionArn: this.connectorDefinitionVersionArn, coreDefinitionVersionArn: this.coreDefinitionVersionArn, deviceDefinitionVersionArn: this.deviceDefinitionVersionArn, functionDefinitionVersionArn: this.functionDefinitionVersionArn, loggerDefinitionVersionArn: this.loggerDefinitionVersionArn, resourceDefinitionVersionArn: this.resourceDefinitionVersionArn, subscriptionDefinitionVersionArn: this.subscriptionDefinitionVersionArn };
      }
      renderProperties(props) {
        return cfnGroupVersionPropsToCloudFormation(props);
      }
    };
    _k = JSII_RTTI_SYMBOL_1, CfnGroupVersion[_k] = { fqn: "aws-cdk-lib.aws_greengrass.CfnGroupVersion", version: "2.80.0" }, CfnGroupVersion.CFN_RESOURCE_TYPE_NAME = "AWS::Greengrass::GroupVersion", exports2.CfnGroupVersion = CfnGroupVersion;
    function CfnLoggerDefinitionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("initialVersion", CfnLoggerDefinition_LoggerDefinitionVersionPropertyValidator)(properties.initialVersion)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.wrap('supplied properties not correct for "CfnLoggerDefinitionProps"');
    }
    function cfnLoggerDefinitionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLoggerDefinitionPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), InitialVersion: cfnLoggerDefinitionLoggerDefinitionVersionPropertyToCloudFormation(properties.initialVersion), Tags: cdk.objectToCloudFormation(properties.tags) }) : properties;
    }
    function CfnLoggerDefinitionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("initialVersion", "InitialVersion", properties.InitialVersion != null ? CfnLoggerDefinitionLoggerDefinitionVersionPropertyFromCloudFormation(properties.InitialVersion) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLoggerDefinition = class _CfnLoggerDefinition extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLoggerDefinitionPropsFromCloudFormation(resourceProperties), ret = new _CfnLoggerDefinition(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLoggerDefinition.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_greengrass_CfnLoggerDefinitionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLoggerDefinition), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrLatestVersionArn = cdk.Token.asString(this.getAtt("LatestVersionArn", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.initialVersion = props.initialVersion, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Greengrass::LoggerDefinition", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLoggerDefinition.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, initialVersion: this.initialVersion, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnLoggerDefinitionPropsToCloudFormation(props);
      }
    };
    _l = JSII_RTTI_SYMBOL_1, CfnLoggerDefinition[_l] = { fqn: "aws-cdk-lib.aws_greengrass.CfnLoggerDefinition", version: "2.80.0" }, CfnLoggerDefinition.CFN_RESOURCE_TYPE_NAME = "AWS::Greengrass::LoggerDefinition", exports2.CfnLoggerDefinition = CfnLoggerDefinition;
    function CfnLoggerDefinition_LoggerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("component", cdk.requiredValidator)(properties.component)), errors.collect(cdk.propertyValidator("component", cdk.validateString)(properties.component)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("level", cdk.requiredValidator)(properties.level)), errors.collect(cdk.propertyValidator("level", cdk.validateString)(properties.level)), errors.collect(cdk.propertyValidator("space", cdk.validateNumber)(properties.space)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "LoggerProperty"');
    }
    function cfnLoggerDefinitionLoggerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLoggerDefinition_LoggerPropertyValidator(properties).assertSuccess(), { Component: cdk.stringToCloudFormation(properties.component), Id: cdk.stringToCloudFormation(properties.id), Level: cdk.stringToCloudFormation(properties.level), Space: cdk.numberToCloudFormation(properties.space), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnLoggerDefinitionLoggerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("component", "Component", cfn_parse.FromCloudFormation.getString(properties.Component)), ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("level", "Level", cfn_parse.FromCloudFormation.getString(properties.Level)), ret.addPropertyResult("space", "Space", properties.Space != null ? cfn_parse.FromCloudFormation.getNumber(properties.Space) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLoggerDefinition_LoggerDefinitionVersionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("loggers", cdk.requiredValidator)(properties.loggers)), errors.collect(cdk.propertyValidator("loggers", cdk.listValidator(CfnLoggerDefinition_LoggerPropertyValidator))(properties.loggers)), errors.wrap('supplied properties not correct for "LoggerDefinitionVersionProperty"');
    }
    function cfnLoggerDefinitionLoggerDefinitionVersionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLoggerDefinition_LoggerDefinitionVersionPropertyValidator(properties).assertSuccess(), { Loggers: cdk.listMapper(cfnLoggerDefinitionLoggerPropertyToCloudFormation)(properties.loggers) }) : properties;
    }
    function CfnLoggerDefinitionLoggerDefinitionVersionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("loggers", "Loggers", cfn_parse.FromCloudFormation.getArray(CfnLoggerDefinitionLoggerPropertyFromCloudFormation)(properties.Loggers)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLoggerDefinitionVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("loggerDefinitionId", cdk.requiredValidator)(properties.loggerDefinitionId)), errors.collect(cdk.propertyValidator("loggerDefinitionId", cdk.validateString)(properties.loggerDefinitionId)), errors.collect(cdk.propertyValidator("loggers", cdk.requiredValidator)(properties.loggers)), errors.collect(cdk.propertyValidator("loggers", cdk.listValidator(CfnLoggerDefinitionVersion_LoggerPropertyValidator))(properties.loggers)), errors.wrap('supplied properties not correct for "CfnLoggerDefinitionVersionProps"');
    }
    function cfnLoggerDefinitionVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLoggerDefinitionVersionPropsValidator(properties).assertSuccess(), { LoggerDefinitionId: cdk.stringToCloudFormation(properties.loggerDefinitionId), Loggers: cdk.listMapper(cfnLoggerDefinitionVersionLoggerPropertyToCloudFormation)(properties.loggers) }) : properties;
    }
    function CfnLoggerDefinitionVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("loggerDefinitionId", "LoggerDefinitionId", cfn_parse.FromCloudFormation.getString(properties.LoggerDefinitionId)), ret.addPropertyResult("loggers", "Loggers", cfn_parse.FromCloudFormation.getArray(CfnLoggerDefinitionVersionLoggerPropertyFromCloudFormation)(properties.Loggers)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLoggerDefinitionVersion = class _CfnLoggerDefinitionVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLoggerDefinitionVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnLoggerDefinitionVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLoggerDefinitionVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_greengrass_CfnLoggerDefinitionVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLoggerDefinitionVersion), error;
        }
        cdk.requireProperty(props, "loggerDefinitionId", this), cdk.requireProperty(props, "loggers", this), this.loggerDefinitionId = props.loggerDefinitionId, this.loggers = props.loggers;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLoggerDefinitionVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { loggerDefinitionId: this.loggerDefinitionId, loggers: this.loggers };
      }
      renderProperties(props) {
        return cfnLoggerDefinitionVersionPropsToCloudFormation(props);
      }
    };
    _m = JSII_RTTI_SYMBOL_1, CfnLoggerDefinitionVersion[_m] = { fqn: "aws-cdk-lib.aws_greengrass.CfnLoggerDefinitionVersion", version: "2.80.0" }, CfnLoggerDefinitionVersion.CFN_RESOURCE_TYPE_NAME = "AWS::Greengrass::LoggerDefinitionVersion", exports2.CfnLoggerDefinitionVersion = CfnLoggerDefinitionVersion;
    function CfnLoggerDefinitionVersion_LoggerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("component", cdk.requiredValidator)(properties.component)), errors.collect(cdk.propertyValidator("component", cdk.validateString)(properties.component)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("level", cdk.requiredValidator)(properties.level)), errors.collect(cdk.propertyValidator("level", cdk.validateString)(properties.level)), errors.collect(cdk.propertyValidator("space", cdk.validateNumber)(properties.space)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "LoggerProperty"');
    }
    function cfnLoggerDefinitionVersionLoggerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLoggerDefinitionVersion_LoggerPropertyValidator(properties).assertSuccess(), { Component: cdk.stringToCloudFormation(properties.component), Id: cdk.stringToCloudFormation(properties.id), Level: cdk.stringToCloudFormation(properties.level), Space: cdk.numberToCloudFormation(properties.space), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnLoggerDefinitionVersionLoggerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("component", "Component", cfn_parse.FromCloudFormation.getString(properties.Component)), ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("level", "Level", cfn_parse.FromCloudFormation.getString(properties.Level)), ret.addPropertyResult("space", "Space", properties.Space != null ? cfn_parse.FromCloudFormation.getNumber(properties.Space) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourceDefinitionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("initialVersion", CfnResourceDefinition_ResourceDefinitionVersionPropertyValidator)(properties.initialVersion)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.wrap('supplied properties not correct for "CfnResourceDefinitionProps"');
    }
    function cfnResourceDefinitionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceDefinitionPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), InitialVersion: cfnResourceDefinitionResourceDefinitionVersionPropertyToCloudFormation(properties.initialVersion), Tags: cdk.objectToCloudFormation(properties.tags) }) : properties;
    }
    function CfnResourceDefinitionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("initialVersion", "InitialVersion", properties.InitialVersion != null ? CfnResourceDefinitionResourceDefinitionVersionPropertyFromCloudFormation(properties.InitialVersion) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResourceDefinition = class _CfnResourceDefinition extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResourceDefinitionPropsFromCloudFormation(resourceProperties), ret = new _CfnResourceDefinition(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnResourceDefinition.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_greengrass_CfnResourceDefinitionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResourceDefinition), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrLatestVersionArn = cdk.Token.asString(this.getAtt("LatestVersionArn", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.initialVersion = props.initialVersion, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Greengrass::ResourceDefinition", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResourceDefinition.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, initialVersion: this.initialVersion, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnResourceDefinitionPropsToCloudFormation(props);
      }
    };
    _o = JSII_RTTI_SYMBOL_1, CfnResourceDefinition[_o] = { fqn: "aws-cdk-lib.aws_greengrass.CfnResourceDefinition", version: "2.80.0" }, CfnResourceDefinition.CFN_RESOURCE_TYPE_NAME = "AWS::Greengrass::ResourceDefinition", exports2.CfnResourceDefinition = CfnResourceDefinition;
    function CfnResourceDefinition_GroupOwnerSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoAddGroupOwner", cdk.requiredValidator)(properties.autoAddGroupOwner)), errors.collect(cdk.propertyValidator("autoAddGroupOwner", cdk.validateBoolean)(properties.autoAddGroupOwner)), errors.collect(cdk.propertyValidator("groupOwner", cdk.validateString)(properties.groupOwner)), errors.wrap('supplied properties not correct for "GroupOwnerSettingProperty"');
    }
    function cfnResourceDefinitionGroupOwnerSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceDefinition_GroupOwnerSettingPropertyValidator(properties).assertSuccess(), { AutoAddGroupOwner: cdk.booleanToCloudFormation(properties.autoAddGroupOwner), GroupOwner: cdk.stringToCloudFormation(properties.groupOwner) }) : properties;
    }
    function CfnResourceDefinitionGroupOwnerSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("autoAddGroupOwner", "AutoAddGroupOwner", cfn_parse.FromCloudFormation.getBoolean(properties.AutoAddGroupOwner)), ret.addPropertyResult("groupOwner", "GroupOwner", properties.GroupOwner != null ? cfn_parse.FromCloudFormation.getString(properties.GroupOwner) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourceDefinition_LocalDeviceResourceDataPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groupOwnerSetting", CfnResourceDefinition_GroupOwnerSettingPropertyValidator)(properties.groupOwnerSetting)), errors.collect(cdk.propertyValidator("sourcePath", cdk.requiredValidator)(properties.sourcePath)), errors.collect(cdk.propertyValidator("sourcePath", cdk.validateString)(properties.sourcePath)), errors.wrap('supplied properties not correct for "LocalDeviceResourceDataProperty"');
    }
    function cfnResourceDefinitionLocalDeviceResourceDataPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceDefinition_LocalDeviceResourceDataPropertyValidator(properties).assertSuccess(), { GroupOwnerSetting: cfnResourceDefinitionGroupOwnerSettingPropertyToCloudFormation(properties.groupOwnerSetting), SourcePath: cdk.stringToCloudFormation(properties.sourcePath) }) : properties;
    }
    function CfnResourceDefinitionLocalDeviceResourceDataPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupOwnerSetting", "GroupOwnerSetting", properties.GroupOwnerSetting != null ? CfnResourceDefinitionGroupOwnerSettingPropertyFromCloudFormation(properties.GroupOwnerSetting) : void 0), ret.addPropertyResult("sourcePath", "SourcePath", cfn_parse.FromCloudFormation.getString(properties.SourcePath)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourceDefinition_LocalVolumeResourceDataPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationPath", cdk.requiredValidator)(properties.destinationPath)), errors.collect(cdk.propertyValidator("destinationPath", cdk.validateString)(properties.destinationPath)), errors.collect(cdk.propertyValidator("groupOwnerSetting", CfnResourceDefinition_GroupOwnerSettingPropertyValidator)(properties.groupOwnerSetting)), errors.collect(cdk.propertyValidator("sourcePath", cdk.requiredValidator)(properties.sourcePath)), errors.collect(cdk.propertyValidator("sourcePath", cdk.validateString)(properties.sourcePath)), errors.wrap('supplied properties not correct for "LocalVolumeResourceDataProperty"');
    }
    function cfnResourceDefinitionLocalVolumeResourceDataPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceDefinition_LocalVolumeResourceDataPropertyValidator(properties).assertSuccess(), { DestinationPath: cdk.stringToCloudFormation(properties.destinationPath), GroupOwnerSetting: cfnResourceDefinitionGroupOwnerSettingPropertyToCloudFormation(properties.groupOwnerSetting), SourcePath: cdk.stringToCloudFormation(properties.sourcePath) }) : properties;
    }
    function CfnResourceDefinitionLocalVolumeResourceDataPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationPath", "DestinationPath", cfn_parse.FromCloudFormation.getString(properties.DestinationPath)), ret.addPropertyResult("groupOwnerSetting", "GroupOwnerSetting", properties.GroupOwnerSetting != null ? CfnResourceDefinitionGroupOwnerSettingPropertyFromCloudFormation(properties.GroupOwnerSetting) : void 0), ret.addPropertyResult("sourcePath", "SourcePath", cfn_parse.FromCloudFormation.getString(properties.SourcePath)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourceDefinition_ResourceDataContainerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("localDeviceResourceData", CfnResourceDefinition_LocalDeviceResourceDataPropertyValidator)(properties.localDeviceResourceData)), errors.collect(cdk.propertyValidator("localVolumeResourceData", CfnResourceDefinition_LocalVolumeResourceDataPropertyValidator)(properties.localVolumeResourceData)), errors.collect(cdk.propertyValidator("s3MachineLearningModelResourceData", CfnResourceDefinition_S3MachineLearningModelResourceDataPropertyValidator)(properties.s3MachineLearningModelResourceData)), errors.collect(cdk.propertyValidator("sageMakerMachineLearningModelResourceData", CfnResourceDefinition_SageMakerMachineLearningModelResourceDataPropertyValidator)(properties.sageMakerMachineLearningModelResourceData)), errors.collect(cdk.propertyValidator("secretsManagerSecretResourceData", CfnResourceDefinition_SecretsManagerSecretResourceDataPropertyValidator)(properties.secretsManagerSecretResourceData)), errors.wrap('supplied properties not correct for "ResourceDataContainerProperty"');
    }
    function cfnResourceDefinitionResourceDataContainerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceDefinition_ResourceDataContainerPropertyValidator(properties).assertSuccess(), { LocalDeviceResourceData: cfnResourceDefinitionLocalDeviceResourceDataPropertyToCloudFormation(properties.localDeviceResourceData), LocalVolumeResourceData: cfnResourceDefinitionLocalVolumeResourceDataPropertyToCloudFormation(properties.localVolumeResourceData), S3MachineLearningModelResourceData: cfnResourceDefinitionS3MachineLearningModelResourceDataPropertyToCloudFormation(properties.s3MachineLearningModelResourceData), SageMakerMachineLearningModelResourceData: cfnResourceDefinitionSageMakerMachineLearningModelResourceDataPropertyToCloudFormation(properties.sageMakerMachineLearningModelResourceData), SecretsManagerSecretResourceData: cfnResourceDefinitionSecretsManagerSecretResourceDataPropertyToCloudFormation(properties.secretsManagerSecretResourceData) }) : properties;
    }
    function CfnResourceDefinitionResourceDataContainerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("localDeviceResourceData", "LocalDeviceResourceData", properties.LocalDeviceResourceData != null ? CfnResourceDefinitionLocalDeviceResourceDataPropertyFromCloudFormation(properties.LocalDeviceResourceData) : void 0), ret.addPropertyResult("localVolumeResourceData", "LocalVolumeResourceData", properties.LocalVolumeResourceData != null ? CfnResourceDefinitionLocalVolumeResourceDataPropertyFromCloudFormation(properties.LocalVolumeResourceData) : void 0), ret.addPropertyResult("s3MachineLearningModelResourceData", "S3MachineLearningModelResourceData", properties.S3MachineLearningModelResourceData != null ? CfnResourceDefinitionS3MachineLearningModelResourceDataPropertyFromCloudFormation(properties.S3MachineLearningModelResourceData) : void 0), ret.addPropertyResult("sageMakerMachineLearningModelResourceData", "SageMakerMachineLearningModelResourceData", properties.SageMakerMachineLearningModelResourceData != null ? CfnResourceDefinitionSageMakerMachineLearningModelResourceDataPropertyFromCloudFormation(properties.SageMakerMachineLearningModelResourceData) : void 0), ret.addPropertyResult("secretsManagerSecretResourceData", "SecretsManagerSecretResourceData", properties.SecretsManagerSecretResourceData != null ? CfnResourceDefinitionSecretsManagerSecretResourceDataPropertyFromCloudFormation(properties.SecretsManagerSecretResourceData) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourceDefinition_ResourceDefinitionVersionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resources", cdk.requiredValidator)(properties.resources)), errors.collect(cdk.propertyValidator("resources", cdk.listValidator(CfnResourceDefinition_ResourceInstancePropertyValidator))(properties.resources)), errors.wrap('supplied properties not correct for "ResourceDefinitionVersionProperty"');
    }
    function cfnResourceDefinitionResourceDefinitionVersionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceDefinition_ResourceDefinitionVersionPropertyValidator(properties).assertSuccess(), { Resources: cdk.listMapper(cfnResourceDefinitionResourceInstancePropertyToCloudFormation)(properties.resources) }) : properties;
    }
    function CfnResourceDefinitionResourceDefinitionVersionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resources", "Resources", cfn_parse.FromCloudFormation.getArray(CfnResourceDefinitionResourceInstancePropertyFromCloudFormation)(properties.Resources)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourceDefinition_ResourceDownloadOwnerSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groupOwner", cdk.requiredValidator)(properties.groupOwner)), errors.collect(cdk.propertyValidator("groupOwner", cdk.validateString)(properties.groupOwner)), errors.collect(cdk.propertyValidator("groupPermission", cdk.requiredValidator)(properties.groupPermission)), errors.collect(cdk.propertyValidator("groupPermission", cdk.validateString)(properties.groupPermission)), errors.wrap('supplied properties not correct for "ResourceDownloadOwnerSettingProperty"');
    }
    function cfnResourceDefinitionResourceDownloadOwnerSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceDefinition_ResourceDownloadOwnerSettingPropertyValidator(properties).assertSuccess(), { GroupOwner: cdk.stringToCloudFormation(properties.groupOwner), GroupPermission: cdk.stringToCloudFormation(properties.groupPermission) }) : properties;
    }
    function CfnResourceDefinitionResourceDownloadOwnerSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupOwner", "GroupOwner", cfn_parse.FromCloudFormation.getString(properties.GroupOwner)), ret.addPropertyResult("groupPermission", "GroupPermission", cfn_parse.FromCloudFormation.getString(properties.GroupPermission)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourceDefinition_ResourceInstancePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("resourceDataContainer", cdk.requiredValidator)(properties.resourceDataContainer)), errors.collect(cdk.propertyValidator("resourceDataContainer", CfnResourceDefinition_ResourceDataContainerPropertyValidator)(properties.resourceDataContainer)), errors.wrap('supplied properties not correct for "ResourceInstanceProperty"');
    }
    function cfnResourceDefinitionResourceInstancePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceDefinition_ResourceInstancePropertyValidator(properties).assertSuccess(), { Id: cdk.stringToCloudFormation(properties.id), Name: cdk.stringToCloudFormation(properties.name), ResourceDataContainer: cfnResourceDefinitionResourceDataContainerPropertyToCloudFormation(properties.resourceDataContainer) }) : properties;
    }
    function CfnResourceDefinitionResourceInstancePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("resourceDataContainer", "ResourceDataContainer", CfnResourceDefinitionResourceDataContainerPropertyFromCloudFormation(properties.ResourceDataContainer)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourceDefinition_S3MachineLearningModelResourceDataPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationPath", cdk.requiredValidator)(properties.destinationPath)), errors.collect(cdk.propertyValidator("destinationPath", cdk.validateString)(properties.destinationPath)), errors.collect(cdk.propertyValidator("ownerSetting", CfnResourceDefinition_ResourceDownloadOwnerSettingPropertyValidator)(properties.ownerSetting)), errors.collect(cdk.propertyValidator("s3Uri", cdk.requiredValidator)(properties.s3Uri)), errors.collect(cdk.propertyValidator("s3Uri", cdk.validateString)(properties.s3Uri)), errors.wrap('supplied properties not correct for "S3MachineLearningModelResourceDataProperty"');
    }
    function cfnResourceDefinitionS3MachineLearningModelResourceDataPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceDefinition_S3MachineLearningModelResourceDataPropertyValidator(properties).assertSuccess(), { DestinationPath: cdk.stringToCloudFormation(properties.destinationPath), OwnerSetting: cfnResourceDefinitionResourceDownloadOwnerSettingPropertyToCloudFormation(properties.ownerSetting), S3Uri: cdk.stringToCloudFormation(properties.s3Uri) }) : properties;
    }
    function CfnResourceDefinitionS3MachineLearningModelResourceDataPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationPath", "DestinationPath", cfn_parse.FromCloudFormation.getString(properties.DestinationPath)), ret.addPropertyResult("ownerSetting", "OwnerSetting", properties.OwnerSetting != null ? CfnResourceDefinitionResourceDownloadOwnerSettingPropertyFromCloudFormation(properties.OwnerSetting) : void 0), ret.addPropertyResult("s3Uri", "S3Uri", cfn_parse.FromCloudFormation.getString(properties.S3Uri)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourceDefinition_SageMakerMachineLearningModelResourceDataPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationPath", cdk.requiredValidator)(properties.destinationPath)), errors.collect(cdk.propertyValidator("destinationPath", cdk.validateString)(properties.destinationPath)), errors.collect(cdk.propertyValidator("ownerSetting", CfnResourceDefinition_ResourceDownloadOwnerSettingPropertyValidator)(properties.ownerSetting)), errors.collect(cdk.propertyValidator("sageMakerJobArn", cdk.requiredValidator)(properties.sageMakerJobArn)), errors.collect(cdk.propertyValidator("sageMakerJobArn", cdk.validateString)(properties.sageMakerJobArn)), errors.wrap('supplied properties not correct for "SageMakerMachineLearningModelResourceDataProperty"');
    }
    function cfnResourceDefinitionSageMakerMachineLearningModelResourceDataPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceDefinition_SageMakerMachineLearningModelResourceDataPropertyValidator(properties).assertSuccess(), { DestinationPath: cdk.stringToCloudFormation(properties.destinationPath), OwnerSetting: cfnResourceDefinitionResourceDownloadOwnerSettingPropertyToCloudFormation(properties.ownerSetting), SageMakerJobArn: cdk.stringToCloudFormation(properties.sageMakerJobArn) }) : properties;
    }
    function CfnResourceDefinitionSageMakerMachineLearningModelResourceDataPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationPath", "DestinationPath", cfn_parse.FromCloudFormation.getString(properties.DestinationPath)), ret.addPropertyResult("ownerSetting", "OwnerSetting", properties.OwnerSetting != null ? CfnResourceDefinitionResourceDownloadOwnerSettingPropertyFromCloudFormation(properties.OwnerSetting) : void 0), ret.addPropertyResult("sageMakerJobArn", "SageMakerJobArn", cfn_parse.FromCloudFormation.getString(properties.SageMakerJobArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourceDefinition_SecretsManagerSecretResourceDataPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.requiredValidator)(properties.arn)), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("additionalStagingLabelsToDownload", cdk.listValidator(cdk.validateString))(properties.additionalStagingLabelsToDownload)), errors.wrap('supplied properties not correct for "SecretsManagerSecretResourceDataProperty"');
    }
    function cfnResourceDefinitionSecretsManagerSecretResourceDataPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceDefinition_SecretsManagerSecretResourceDataPropertyValidator(properties).assertSuccess(), { ARN: cdk.stringToCloudFormation(properties.arn), AdditionalStagingLabelsToDownload: cdk.listMapper(cdk.stringToCloudFormation)(properties.additionalStagingLabelsToDownload) }) : properties;
    }
    function CfnResourceDefinitionSecretsManagerSecretResourceDataPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "ARN", cfn_parse.FromCloudFormation.getString(properties.ARN)), ret.addPropertyResult("additionalStagingLabelsToDownload", "AdditionalStagingLabelsToDownload", properties.AdditionalStagingLabelsToDownload != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AdditionalStagingLabelsToDownload) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourceDefinitionVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceDefinitionId", cdk.requiredValidator)(properties.resourceDefinitionId)), errors.collect(cdk.propertyValidator("resourceDefinitionId", cdk.validateString)(properties.resourceDefinitionId)), errors.collect(cdk.propertyValidator("resources", cdk.requiredValidator)(properties.resources)), errors.collect(cdk.propertyValidator("resources", cdk.listValidator(CfnResourceDefinitionVersion_ResourceInstancePropertyValidator))(properties.resources)), errors.wrap('supplied properties not correct for "CfnResourceDefinitionVersionProps"');
    }
    function cfnResourceDefinitionVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceDefinitionVersionPropsValidator(properties).assertSuccess(), { ResourceDefinitionId: cdk.stringToCloudFormation(properties.resourceDefinitionId), Resources: cdk.listMapper(cfnResourceDefinitionVersionResourceInstancePropertyToCloudFormation)(properties.resources) }) : properties;
    }
    function CfnResourceDefinitionVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceDefinitionId", "ResourceDefinitionId", cfn_parse.FromCloudFormation.getString(properties.ResourceDefinitionId)), ret.addPropertyResult("resources", "Resources", cfn_parse.FromCloudFormation.getArray(CfnResourceDefinitionVersionResourceInstancePropertyFromCloudFormation)(properties.Resources)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResourceDefinitionVersion = class _CfnResourceDefinitionVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResourceDefinitionVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnResourceDefinitionVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnResourceDefinitionVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_greengrass_CfnResourceDefinitionVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResourceDefinitionVersion), error;
        }
        cdk.requireProperty(props, "resourceDefinitionId", this), cdk.requireProperty(props, "resources", this), this.resourceDefinitionId = props.resourceDefinitionId, this.resources = props.resources;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResourceDefinitionVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { resourceDefinitionId: this.resourceDefinitionId, resources: this.resources };
      }
      renderProperties(props) {
        return cfnResourceDefinitionVersionPropsToCloudFormation(props);
      }
    };
    _p = JSII_RTTI_SYMBOL_1, CfnResourceDefinitionVersion[_p] = { fqn: "aws-cdk-lib.aws_greengrass.CfnResourceDefinitionVersion", version: "2.80.0" }, CfnResourceDefinitionVersion.CFN_RESOURCE_TYPE_NAME = "AWS::Greengrass::ResourceDefinitionVersion", exports2.CfnResourceDefinitionVersion = CfnResourceDefinitionVersion;
    function CfnResourceDefinitionVersion_GroupOwnerSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoAddGroupOwner", cdk.requiredValidator)(properties.autoAddGroupOwner)), errors.collect(cdk.propertyValidator("autoAddGroupOwner", cdk.validateBoolean)(properties.autoAddGroupOwner)), errors.collect(cdk.propertyValidator("groupOwner", cdk.validateString)(properties.groupOwner)), errors.wrap('supplied properties not correct for "GroupOwnerSettingProperty"');
    }
    function cfnResourceDefinitionVersionGroupOwnerSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceDefinitionVersion_GroupOwnerSettingPropertyValidator(properties).assertSuccess(), { AutoAddGroupOwner: cdk.booleanToCloudFormation(properties.autoAddGroupOwner), GroupOwner: cdk.stringToCloudFormation(properties.groupOwner) }) : properties;
    }
    function CfnResourceDefinitionVersionGroupOwnerSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("autoAddGroupOwner", "AutoAddGroupOwner", cfn_parse.FromCloudFormation.getBoolean(properties.AutoAddGroupOwner)), ret.addPropertyResult("groupOwner", "GroupOwner", properties.GroupOwner != null ? cfn_parse.FromCloudFormation.getString(properties.GroupOwner) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourceDefinitionVersion_LocalDeviceResourceDataPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groupOwnerSetting", CfnResourceDefinitionVersion_GroupOwnerSettingPropertyValidator)(properties.groupOwnerSetting)), errors.collect(cdk.propertyValidator("sourcePath", cdk.requiredValidator)(properties.sourcePath)), errors.collect(cdk.propertyValidator("sourcePath", cdk.validateString)(properties.sourcePath)), errors.wrap('supplied properties not correct for "LocalDeviceResourceDataProperty"');
    }
    function cfnResourceDefinitionVersionLocalDeviceResourceDataPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceDefinitionVersion_LocalDeviceResourceDataPropertyValidator(properties).assertSuccess(), { GroupOwnerSetting: cfnResourceDefinitionVersionGroupOwnerSettingPropertyToCloudFormation(properties.groupOwnerSetting), SourcePath: cdk.stringToCloudFormation(properties.sourcePath) }) : properties;
    }
    function CfnResourceDefinitionVersionLocalDeviceResourceDataPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupOwnerSetting", "GroupOwnerSetting", properties.GroupOwnerSetting != null ? CfnResourceDefinitionVersionGroupOwnerSettingPropertyFromCloudFormation(properties.GroupOwnerSetting) : void 0), ret.addPropertyResult("sourcePath", "SourcePath", cfn_parse.FromCloudFormation.getString(properties.SourcePath)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourceDefinitionVersion_LocalVolumeResourceDataPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationPath", cdk.requiredValidator)(properties.destinationPath)), errors.collect(cdk.propertyValidator("destinationPath", cdk.validateString)(properties.destinationPath)), errors.collect(cdk.propertyValidator("groupOwnerSetting", CfnResourceDefinitionVersion_GroupOwnerSettingPropertyValidator)(properties.groupOwnerSetting)), errors.collect(cdk.propertyValidator("sourcePath", cdk.requiredValidator)(properties.sourcePath)), errors.collect(cdk.propertyValidator("sourcePath", cdk.validateString)(properties.sourcePath)), errors.wrap('supplied properties not correct for "LocalVolumeResourceDataProperty"');
    }
    function cfnResourceDefinitionVersionLocalVolumeResourceDataPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceDefinitionVersion_LocalVolumeResourceDataPropertyValidator(properties).assertSuccess(), { DestinationPath: cdk.stringToCloudFormation(properties.destinationPath), GroupOwnerSetting: cfnResourceDefinitionVersionGroupOwnerSettingPropertyToCloudFormation(properties.groupOwnerSetting), SourcePath: cdk.stringToCloudFormation(properties.sourcePath) }) : properties;
    }
    function CfnResourceDefinitionVersionLocalVolumeResourceDataPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationPath", "DestinationPath", cfn_parse.FromCloudFormation.getString(properties.DestinationPath)), ret.addPropertyResult("groupOwnerSetting", "GroupOwnerSetting", properties.GroupOwnerSetting != null ? CfnResourceDefinitionVersionGroupOwnerSettingPropertyFromCloudFormation(properties.GroupOwnerSetting) : void 0), ret.addPropertyResult("sourcePath", "SourcePath", cfn_parse.FromCloudFormation.getString(properties.SourcePath)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourceDefinitionVersion_ResourceDataContainerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("localDeviceResourceData", CfnResourceDefinitionVersion_LocalDeviceResourceDataPropertyValidator)(properties.localDeviceResourceData)), errors.collect(cdk.propertyValidator("localVolumeResourceData", CfnResourceDefinitionVersion_LocalVolumeResourceDataPropertyValidator)(properties.localVolumeResourceData)), errors.collect(cdk.propertyValidator("s3MachineLearningModelResourceData", CfnResourceDefinitionVersion_S3MachineLearningModelResourceDataPropertyValidator)(properties.s3MachineLearningModelResourceData)), errors.collect(cdk.propertyValidator("sageMakerMachineLearningModelResourceData", CfnResourceDefinitionVersion_SageMakerMachineLearningModelResourceDataPropertyValidator)(properties.sageMakerMachineLearningModelResourceData)), errors.collect(cdk.propertyValidator("secretsManagerSecretResourceData", CfnResourceDefinitionVersion_SecretsManagerSecretResourceDataPropertyValidator)(properties.secretsManagerSecretResourceData)), errors.wrap('supplied properties not correct for "ResourceDataContainerProperty"');
    }
    function cfnResourceDefinitionVersionResourceDataContainerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceDefinitionVersion_ResourceDataContainerPropertyValidator(properties).assertSuccess(), { LocalDeviceResourceData: cfnResourceDefinitionVersionLocalDeviceResourceDataPropertyToCloudFormation(properties.localDeviceResourceData), LocalVolumeResourceData: cfnResourceDefinitionVersionLocalVolumeResourceDataPropertyToCloudFormation(properties.localVolumeResourceData), S3MachineLearningModelResourceData: cfnResourceDefinitionVersionS3MachineLearningModelResourceDataPropertyToCloudFormation(properties.s3MachineLearningModelResourceData), SageMakerMachineLearningModelResourceData: cfnResourceDefinitionVersionSageMakerMachineLearningModelResourceDataPropertyToCloudFormation(properties.sageMakerMachineLearningModelResourceData), SecretsManagerSecretResourceData: cfnResourceDefinitionVersionSecretsManagerSecretResourceDataPropertyToCloudFormation(properties.secretsManagerSecretResourceData) }) : properties;
    }
    function CfnResourceDefinitionVersionResourceDataContainerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("localDeviceResourceData", "LocalDeviceResourceData", properties.LocalDeviceResourceData != null ? CfnResourceDefinitionVersionLocalDeviceResourceDataPropertyFromCloudFormation(properties.LocalDeviceResourceData) : void 0), ret.addPropertyResult("localVolumeResourceData", "LocalVolumeResourceData", properties.LocalVolumeResourceData != null ? CfnResourceDefinitionVersionLocalVolumeResourceDataPropertyFromCloudFormation(properties.LocalVolumeResourceData) : void 0), ret.addPropertyResult("s3MachineLearningModelResourceData", "S3MachineLearningModelResourceData", properties.S3MachineLearningModelResourceData != null ? CfnResourceDefinitionVersionS3MachineLearningModelResourceDataPropertyFromCloudFormation(properties.S3MachineLearningModelResourceData) : void 0), ret.addPropertyResult("sageMakerMachineLearningModelResourceData", "SageMakerMachineLearningModelResourceData", properties.SageMakerMachineLearningModelResourceData != null ? CfnResourceDefinitionVersionSageMakerMachineLearningModelResourceDataPropertyFromCloudFormation(properties.SageMakerMachineLearningModelResourceData) : void 0), ret.addPropertyResult("secretsManagerSecretResourceData", "SecretsManagerSecretResourceData", properties.SecretsManagerSecretResourceData != null ? CfnResourceDefinitionVersionSecretsManagerSecretResourceDataPropertyFromCloudFormation(properties.SecretsManagerSecretResourceData) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourceDefinitionVersion_ResourceDownloadOwnerSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groupOwner", cdk.requiredValidator)(properties.groupOwner)), errors.collect(cdk.propertyValidator("groupOwner", cdk.validateString)(properties.groupOwner)), errors.collect(cdk.propertyValidator("groupPermission", cdk.requiredValidator)(properties.groupPermission)), errors.collect(cdk.propertyValidator("groupPermission", cdk.validateString)(properties.groupPermission)), errors.wrap('supplied properties not correct for "ResourceDownloadOwnerSettingProperty"');
    }
    function cfnResourceDefinitionVersionResourceDownloadOwnerSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceDefinitionVersion_ResourceDownloadOwnerSettingPropertyValidator(properties).assertSuccess(), { GroupOwner: cdk.stringToCloudFormation(properties.groupOwner), GroupPermission: cdk.stringToCloudFormation(properties.groupPermission) }) : properties;
    }
    function CfnResourceDefinitionVersionResourceDownloadOwnerSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupOwner", "GroupOwner", cfn_parse.FromCloudFormation.getString(properties.GroupOwner)), ret.addPropertyResult("groupPermission", "GroupPermission", cfn_parse.FromCloudFormation.getString(properties.GroupPermission)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourceDefinitionVersion_ResourceInstancePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("resourceDataContainer", cdk.requiredValidator)(properties.resourceDataContainer)), errors.collect(cdk.propertyValidator("resourceDataContainer", CfnResourceDefinitionVersion_ResourceDataContainerPropertyValidator)(properties.resourceDataContainer)), errors.wrap('supplied properties not correct for "ResourceInstanceProperty"');
    }
    function cfnResourceDefinitionVersionResourceInstancePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceDefinitionVersion_ResourceInstancePropertyValidator(properties).assertSuccess(), { Id: cdk.stringToCloudFormation(properties.id), Name: cdk.stringToCloudFormation(properties.name), ResourceDataContainer: cfnResourceDefinitionVersionResourceDataContainerPropertyToCloudFormation(properties.resourceDataContainer) }) : properties;
    }
    function CfnResourceDefinitionVersionResourceInstancePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("resourceDataContainer", "ResourceDataContainer", CfnResourceDefinitionVersionResourceDataContainerPropertyFromCloudFormation(properties.ResourceDataContainer)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourceDefinitionVersion_S3MachineLearningModelResourceDataPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationPath", cdk.requiredValidator)(properties.destinationPath)), errors.collect(cdk.propertyValidator("destinationPath", cdk.validateString)(properties.destinationPath)), errors.collect(cdk.propertyValidator("ownerSetting", CfnResourceDefinitionVersion_ResourceDownloadOwnerSettingPropertyValidator)(properties.ownerSetting)), errors.collect(cdk.propertyValidator("s3Uri", cdk.requiredValidator)(properties.s3Uri)), errors.collect(cdk.propertyValidator("s3Uri", cdk.validateString)(properties.s3Uri)), errors.wrap('supplied properties not correct for "S3MachineLearningModelResourceDataProperty"');
    }
    function cfnResourceDefinitionVersionS3MachineLearningModelResourceDataPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceDefinitionVersion_S3MachineLearningModelResourceDataPropertyValidator(properties).assertSuccess(), { DestinationPath: cdk.stringToCloudFormation(properties.destinationPath), OwnerSetting: cfnResourceDefinitionVersionResourceDownloadOwnerSettingPropertyToCloudFormation(properties.ownerSetting), S3Uri: cdk.stringToCloudFormation(properties.s3Uri) }) : properties;
    }
    function CfnResourceDefinitionVersionS3MachineLearningModelResourceDataPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationPath", "DestinationPath", cfn_parse.FromCloudFormation.getString(properties.DestinationPath)), ret.addPropertyResult("ownerSetting", "OwnerSetting", properties.OwnerSetting != null ? CfnResourceDefinitionVersionResourceDownloadOwnerSettingPropertyFromCloudFormation(properties.OwnerSetting) : void 0), ret.addPropertyResult("s3Uri", "S3Uri", cfn_parse.FromCloudFormation.getString(properties.S3Uri)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourceDefinitionVersion_SageMakerMachineLearningModelResourceDataPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationPath", cdk.requiredValidator)(properties.destinationPath)), errors.collect(cdk.propertyValidator("destinationPath", cdk.validateString)(properties.destinationPath)), errors.collect(cdk.propertyValidator("ownerSetting", CfnResourceDefinitionVersion_ResourceDownloadOwnerSettingPropertyValidator)(properties.ownerSetting)), errors.collect(cdk.propertyValidator("sageMakerJobArn", cdk.requiredValidator)(properties.sageMakerJobArn)), errors.collect(cdk.propertyValidator("sageMakerJobArn", cdk.validateString)(properties.sageMakerJobArn)), errors.wrap('supplied properties not correct for "SageMakerMachineLearningModelResourceDataProperty"');
    }
    function cfnResourceDefinitionVersionSageMakerMachineLearningModelResourceDataPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceDefinitionVersion_SageMakerMachineLearningModelResourceDataPropertyValidator(properties).assertSuccess(), { DestinationPath: cdk.stringToCloudFormation(properties.destinationPath), OwnerSetting: cfnResourceDefinitionVersionResourceDownloadOwnerSettingPropertyToCloudFormation(properties.ownerSetting), SageMakerJobArn: cdk.stringToCloudFormation(properties.sageMakerJobArn) }) : properties;
    }
    function CfnResourceDefinitionVersionSageMakerMachineLearningModelResourceDataPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationPath", "DestinationPath", cfn_parse.FromCloudFormation.getString(properties.DestinationPath)), ret.addPropertyResult("ownerSetting", "OwnerSetting", properties.OwnerSetting != null ? CfnResourceDefinitionVersionResourceDownloadOwnerSettingPropertyFromCloudFormation(properties.OwnerSetting) : void 0), ret.addPropertyResult("sageMakerJobArn", "SageMakerJobArn", cfn_parse.FromCloudFormation.getString(properties.SageMakerJobArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourceDefinitionVersion_SecretsManagerSecretResourceDataPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.requiredValidator)(properties.arn)), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("additionalStagingLabelsToDownload", cdk.listValidator(cdk.validateString))(properties.additionalStagingLabelsToDownload)), errors.wrap('supplied properties not correct for "SecretsManagerSecretResourceDataProperty"');
    }
    function cfnResourceDefinitionVersionSecretsManagerSecretResourceDataPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceDefinitionVersion_SecretsManagerSecretResourceDataPropertyValidator(properties).assertSuccess(), { ARN: cdk.stringToCloudFormation(properties.arn), AdditionalStagingLabelsToDownload: cdk.listMapper(cdk.stringToCloudFormation)(properties.additionalStagingLabelsToDownload) }) : properties;
    }
    function CfnResourceDefinitionVersionSecretsManagerSecretResourceDataPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "ARN", cfn_parse.FromCloudFormation.getString(properties.ARN)), ret.addPropertyResult("additionalStagingLabelsToDownload", "AdditionalStagingLabelsToDownload", properties.AdditionalStagingLabelsToDownload != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AdditionalStagingLabelsToDownload) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSubscriptionDefinitionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("initialVersion", CfnSubscriptionDefinition_SubscriptionDefinitionVersionPropertyValidator)(properties.initialVersion)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.wrap('supplied properties not correct for "CfnSubscriptionDefinitionProps"');
    }
    function cfnSubscriptionDefinitionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSubscriptionDefinitionPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), InitialVersion: cfnSubscriptionDefinitionSubscriptionDefinitionVersionPropertyToCloudFormation(properties.initialVersion), Tags: cdk.objectToCloudFormation(properties.tags) }) : properties;
    }
    function CfnSubscriptionDefinitionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("initialVersion", "InitialVersion", properties.InitialVersion != null ? CfnSubscriptionDefinitionSubscriptionDefinitionVersionPropertyFromCloudFormation(properties.InitialVersion) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSubscriptionDefinition = class _CfnSubscriptionDefinition extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSubscriptionDefinitionPropsFromCloudFormation(resourceProperties), ret = new _CfnSubscriptionDefinition(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSubscriptionDefinition.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_greengrass_CfnSubscriptionDefinitionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSubscriptionDefinition), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrLatestVersionArn = cdk.Token.asString(this.getAtt("LatestVersionArn", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.initialVersion = props.initialVersion, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Greengrass::SubscriptionDefinition", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSubscriptionDefinition.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, initialVersion: this.initialVersion, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnSubscriptionDefinitionPropsToCloudFormation(props);
      }
    };
    _q = JSII_RTTI_SYMBOL_1, CfnSubscriptionDefinition[_q] = { fqn: "aws-cdk-lib.aws_greengrass.CfnSubscriptionDefinition", version: "2.80.0" }, CfnSubscriptionDefinition.CFN_RESOURCE_TYPE_NAME = "AWS::Greengrass::SubscriptionDefinition", exports2.CfnSubscriptionDefinition = CfnSubscriptionDefinition;
    function CfnSubscriptionDefinition_SubscriptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("source", cdk.requiredValidator)(properties.source)), errors.collect(cdk.propertyValidator("source", cdk.validateString)(properties.source)), errors.collect(cdk.propertyValidator("subject", cdk.requiredValidator)(properties.subject)), errors.collect(cdk.propertyValidator("subject", cdk.validateString)(properties.subject)), errors.collect(cdk.propertyValidator("target", cdk.requiredValidator)(properties.target)), errors.collect(cdk.propertyValidator("target", cdk.validateString)(properties.target)), errors.wrap('supplied properties not correct for "SubscriptionProperty"');
    }
    function cfnSubscriptionDefinitionSubscriptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSubscriptionDefinition_SubscriptionPropertyValidator(properties).assertSuccess(), { Id: cdk.stringToCloudFormation(properties.id), Source: cdk.stringToCloudFormation(properties.source), Subject: cdk.stringToCloudFormation(properties.subject), Target: cdk.stringToCloudFormation(properties.target) }) : properties;
    }
    function CfnSubscriptionDefinitionSubscriptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("source", "Source", cfn_parse.FromCloudFormation.getString(properties.Source)), ret.addPropertyResult("subject", "Subject", cfn_parse.FromCloudFormation.getString(properties.Subject)), ret.addPropertyResult("target", "Target", cfn_parse.FromCloudFormation.getString(properties.Target)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSubscriptionDefinition_SubscriptionDefinitionVersionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("subscriptions", cdk.requiredValidator)(properties.subscriptions)), errors.collect(cdk.propertyValidator("subscriptions", cdk.listValidator(CfnSubscriptionDefinition_SubscriptionPropertyValidator))(properties.subscriptions)), errors.wrap('supplied properties not correct for "SubscriptionDefinitionVersionProperty"');
    }
    function cfnSubscriptionDefinitionSubscriptionDefinitionVersionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSubscriptionDefinition_SubscriptionDefinitionVersionPropertyValidator(properties).assertSuccess(), { Subscriptions: cdk.listMapper(cfnSubscriptionDefinitionSubscriptionPropertyToCloudFormation)(properties.subscriptions) }) : properties;
    }
    function CfnSubscriptionDefinitionSubscriptionDefinitionVersionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("subscriptions", "Subscriptions", cfn_parse.FromCloudFormation.getArray(CfnSubscriptionDefinitionSubscriptionPropertyFromCloudFormation)(properties.Subscriptions)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSubscriptionDefinitionVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("subscriptionDefinitionId", cdk.requiredValidator)(properties.subscriptionDefinitionId)), errors.collect(cdk.propertyValidator("subscriptionDefinitionId", cdk.validateString)(properties.subscriptionDefinitionId)), errors.collect(cdk.propertyValidator("subscriptions", cdk.requiredValidator)(properties.subscriptions)), errors.collect(cdk.propertyValidator("subscriptions", cdk.listValidator(CfnSubscriptionDefinitionVersion_SubscriptionPropertyValidator))(properties.subscriptions)), errors.wrap('supplied properties not correct for "CfnSubscriptionDefinitionVersionProps"');
    }
    function cfnSubscriptionDefinitionVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSubscriptionDefinitionVersionPropsValidator(properties).assertSuccess(), { SubscriptionDefinitionId: cdk.stringToCloudFormation(properties.subscriptionDefinitionId), Subscriptions: cdk.listMapper(cfnSubscriptionDefinitionVersionSubscriptionPropertyToCloudFormation)(properties.subscriptions) }) : properties;
    }
    function CfnSubscriptionDefinitionVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("subscriptionDefinitionId", "SubscriptionDefinitionId", cfn_parse.FromCloudFormation.getString(properties.SubscriptionDefinitionId)), ret.addPropertyResult("subscriptions", "Subscriptions", cfn_parse.FromCloudFormation.getArray(CfnSubscriptionDefinitionVersionSubscriptionPropertyFromCloudFormation)(properties.Subscriptions)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSubscriptionDefinitionVersion = class _CfnSubscriptionDefinitionVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSubscriptionDefinitionVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnSubscriptionDefinitionVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSubscriptionDefinitionVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_greengrass_CfnSubscriptionDefinitionVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSubscriptionDefinitionVersion), error;
        }
        cdk.requireProperty(props, "subscriptionDefinitionId", this), cdk.requireProperty(props, "subscriptions", this), this.subscriptionDefinitionId = props.subscriptionDefinitionId, this.subscriptions = props.subscriptions;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSubscriptionDefinitionVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { subscriptionDefinitionId: this.subscriptionDefinitionId, subscriptions: this.subscriptions };
      }
      renderProperties(props) {
        return cfnSubscriptionDefinitionVersionPropsToCloudFormation(props);
      }
    };
    _r = JSII_RTTI_SYMBOL_1, CfnSubscriptionDefinitionVersion[_r] = { fqn: "aws-cdk-lib.aws_greengrass.CfnSubscriptionDefinitionVersion", version: "2.80.0" }, CfnSubscriptionDefinitionVersion.CFN_RESOURCE_TYPE_NAME = "AWS::Greengrass::SubscriptionDefinitionVersion", exports2.CfnSubscriptionDefinitionVersion = CfnSubscriptionDefinitionVersion;
    function CfnSubscriptionDefinitionVersion_SubscriptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("source", cdk.requiredValidator)(properties.source)), errors.collect(cdk.propertyValidator("source", cdk.validateString)(properties.source)), errors.collect(cdk.propertyValidator("subject", cdk.requiredValidator)(properties.subject)), errors.collect(cdk.propertyValidator("subject", cdk.validateString)(properties.subject)), errors.collect(cdk.propertyValidator("target", cdk.requiredValidator)(properties.target)), errors.collect(cdk.propertyValidator("target", cdk.validateString)(properties.target)), errors.wrap('supplied properties not correct for "SubscriptionProperty"');
    }
    function cfnSubscriptionDefinitionVersionSubscriptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSubscriptionDefinitionVersion_SubscriptionPropertyValidator(properties).assertSuccess(), { Id: cdk.stringToCloudFormation(properties.id), Source: cdk.stringToCloudFormation(properties.source), Subject: cdk.stringToCloudFormation(properties.subject), Target: cdk.stringToCloudFormation(properties.target) }) : properties;
    }
    function CfnSubscriptionDefinitionVersionSubscriptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("source", "Source", cfn_parse.FromCloudFormation.getString(properties.Source)), ret.addPropertyResult("subject", "Subject", cfn_parse.FromCloudFormation.getString(properties.Subject)), ret.addPropertyResult("target", "Target", cfn_parse.FromCloudFormation.getString(properties.Target)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-greengrass/lib/index.js
var require_lib139 = __commonJS({
  "node_modules/aws-cdk-lib/aws-greengrass/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_greengrass_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-greengrass/index.js
var require_aws_greengrass = __commonJS({
  "node_modules/aws-cdk-lib/aws-greengrass/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib139(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-greengrassv2/lib/greengrassv2.generated.js
var require_greengrassv2_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-greengrassv2/lib/greengrassv2.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnDeployment = exports2.CfnComponentVersion = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnComponentVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("inlineRecipe", cdk.validateString)(properties.inlineRecipe)), errors.collect(cdk.propertyValidator("lambdaFunction", CfnComponentVersion_LambdaFunctionRecipeSourcePropertyValidator)(properties.lambdaFunction)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.wrap('supplied properties not correct for "CfnComponentVersionProps"');
    }
    function cfnComponentVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponentVersionPropsValidator(properties).assertSuccess(), { InlineRecipe: cdk.stringToCloudFormation(properties.inlineRecipe), LambdaFunction: cfnComponentVersionLambdaFunctionRecipeSourcePropertyToCloudFormation(properties.lambdaFunction), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnComponentVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("inlineRecipe", "InlineRecipe", properties.InlineRecipe != null ? cfn_parse.FromCloudFormation.getString(properties.InlineRecipe) : void 0), ret.addPropertyResult("lambdaFunction", "LambdaFunction", properties.LambdaFunction != null ? CfnComponentVersionLambdaFunctionRecipeSourcePropertyFromCloudFormation(properties.LambdaFunction) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnComponentVersion = class _CfnComponentVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnComponentVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnComponentVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnComponentVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_greengrassv2_CfnComponentVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnComponentVersion), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrComponentName = cdk.Token.asString(this.getAtt("ComponentName", cdk.ResolutionTypeHint.STRING)), this.attrComponentVersion = cdk.Token.asString(this.getAtt("ComponentVersion", cdk.ResolutionTypeHint.STRING)), this.inlineRecipe = props.inlineRecipe, this.lambdaFunction = props.lambdaFunction, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::GreengrassV2::ComponentVersion", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnComponentVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { inlineRecipe: this.inlineRecipe, lambdaFunction: this.lambdaFunction, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnComponentVersionPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnComponentVersion[_a] = { fqn: "aws-cdk-lib.aws_greengrassv2.CfnComponentVersion", version: "2.80.0" }, CfnComponentVersion.CFN_RESOURCE_TYPE_NAME = "AWS::GreengrassV2::ComponentVersion", exports2.CfnComponentVersion = CfnComponentVersion;
    function CfnComponentVersion_ComponentDependencyRequirementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dependencyType", cdk.validateString)(properties.dependencyType)), errors.collect(cdk.propertyValidator("versionRequirement", cdk.validateString)(properties.versionRequirement)), errors.wrap('supplied properties not correct for "ComponentDependencyRequirementProperty"');
    }
    function cfnComponentVersionComponentDependencyRequirementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponentVersion_ComponentDependencyRequirementPropertyValidator(properties).assertSuccess(), { DependencyType: cdk.stringToCloudFormation(properties.dependencyType), VersionRequirement: cdk.stringToCloudFormation(properties.versionRequirement) }) : properties;
    }
    function CfnComponentVersionComponentDependencyRequirementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dependencyType", "DependencyType", properties.DependencyType != null ? cfn_parse.FromCloudFormation.getString(properties.DependencyType) : void 0), ret.addPropertyResult("versionRequirement", "VersionRequirement", properties.VersionRequirement != null ? cfn_parse.FromCloudFormation.getString(properties.VersionRequirement) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComponentVersion_ComponentPlatformPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributes", cdk.hashValidator(cdk.validateString))(properties.attributes)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "ComponentPlatformProperty"');
    }
    function cfnComponentVersionComponentPlatformPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponentVersion_ComponentPlatformPropertyValidator(properties).assertSuccess(), { Attributes: cdk.hashMapper(cdk.stringToCloudFormation)(properties.attributes), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnComponentVersionComponentPlatformPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attributes", "Attributes", properties.Attributes != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Attributes) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComponentVersion_LambdaContainerParamsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("devices", cdk.listValidator(CfnComponentVersion_LambdaDeviceMountPropertyValidator))(properties.devices)), errors.collect(cdk.propertyValidator("memorySizeInKb", cdk.validateNumber)(properties.memorySizeInKb)), errors.collect(cdk.propertyValidator("mountRoSysfs", cdk.validateBoolean)(properties.mountRoSysfs)), errors.collect(cdk.propertyValidator("volumes", cdk.listValidator(CfnComponentVersion_LambdaVolumeMountPropertyValidator))(properties.volumes)), errors.wrap('supplied properties not correct for "LambdaContainerParamsProperty"');
    }
    function cfnComponentVersionLambdaContainerParamsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponentVersion_LambdaContainerParamsPropertyValidator(properties).assertSuccess(), { Devices: cdk.listMapper(cfnComponentVersionLambdaDeviceMountPropertyToCloudFormation)(properties.devices), MemorySizeInKB: cdk.numberToCloudFormation(properties.memorySizeInKb), MountROSysfs: cdk.booleanToCloudFormation(properties.mountRoSysfs), Volumes: cdk.listMapper(cfnComponentVersionLambdaVolumeMountPropertyToCloudFormation)(properties.volumes) }) : properties;
    }
    function CfnComponentVersionLambdaContainerParamsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("devices", "Devices", properties.Devices != null ? cfn_parse.FromCloudFormation.getArray(CfnComponentVersionLambdaDeviceMountPropertyFromCloudFormation)(properties.Devices) : void 0), ret.addPropertyResult("memorySizeInKb", "MemorySizeInKB", properties.MemorySizeInKB != null ? cfn_parse.FromCloudFormation.getNumber(properties.MemorySizeInKB) : void 0), ret.addPropertyResult("mountRoSysfs", "MountROSysfs", properties.MountROSysfs != null ? cfn_parse.FromCloudFormation.getBoolean(properties.MountROSysfs) : void 0), ret.addPropertyResult("volumes", "Volumes", properties.Volumes != null ? cfn_parse.FromCloudFormation.getArray(CfnComponentVersionLambdaVolumeMountPropertyFromCloudFormation)(properties.Volumes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComponentVersion_LambdaDeviceMountPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("addGroupOwner", cdk.validateBoolean)(properties.addGroupOwner)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.collect(cdk.propertyValidator("permission", cdk.validateString)(properties.permission)), errors.wrap('supplied properties not correct for "LambdaDeviceMountProperty"');
    }
    function cfnComponentVersionLambdaDeviceMountPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponentVersion_LambdaDeviceMountPropertyValidator(properties).assertSuccess(), { AddGroupOwner: cdk.booleanToCloudFormation(properties.addGroupOwner), Path: cdk.stringToCloudFormation(properties.path), Permission: cdk.stringToCloudFormation(properties.permission) }) : properties;
    }
    function CfnComponentVersionLambdaDeviceMountPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("addGroupOwner", "AddGroupOwner", properties.AddGroupOwner != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AddGroupOwner) : void 0), ret.addPropertyResult("path", "Path", properties.Path != null ? cfn_parse.FromCloudFormation.getString(properties.Path) : void 0), ret.addPropertyResult("permission", "Permission", properties.Permission != null ? cfn_parse.FromCloudFormation.getString(properties.Permission) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComponentVersion_LambdaEventSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("topic", cdk.validateString)(properties.topic)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "LambdaEventSourceProperty"');
    }
    function cfnComponentVersionLambdaEventSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponentVersion_LambdaEventSourcePropertyValidator(properties).assertSuccess(), { Topic: cdk.stringToCloudFormation(properties.topic), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnComponentVersionLambdaEventSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("topic", "Topic", properties.Topic != null ? cfn_parse.FromCloudFormation.getString(properties.Topic) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComponentVersion_LambdaExecutionParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("environmentVariables", cdk.hashValidator(cdk.validateString))(properties.environmentVariables)), errors.collect(cdk.propertyValidator("eventSources", cdk.listValidator(CfnComponentVersion_LambdaEventSourcePropertyValidator))(properties.eventSources)), errors.collect(cdk.propertyValidator("execArgs", cdk.listValidator(cdk.validateString))(properties.execArgs)), errors.collect(cdk.propertyValidator("inputPayloadEncodingType", cdk.validateString)(properties.inputPayloadEncodingType)), errors.collect(cdk.propertyValidator("linuxProcessParams", CfnComponentVersion_LambdaLinuxProcessParamsPropertyValidator)(properties.linuxProcessParams)), errors.collect(cdk.propertyValidator("maxIdleTimeInSeconds", cdk.validateNumber)(properties.maxIdleTimeInSeconds)), errors.collect(cdk.propertyValidator("maxInstancesCount", cdk.validateNumber)(properties.maxInstancesCount)), errors.collect(cdk.propertyValidator("maxQueueSize", cdk.validateNumber)(properties.maxQueueSize)), errors.collect(cdk.propertyValidator("pinned", cdk.validateBoolean)(properties.pinned)), errors.collect(cdk.propertyValidator("statusTimeoutInSeconds", cdk.validateNumber)(properties.statusTimeoutInSeconds)), errors.collect(cdk.propertyValidator("timeoutInSeconds", cdk.validateNumber)(properties.timeoutInSeconds)), errors.wrap('supplied properties not correct for "LambdaExecutionParametersProperty"');
    }
    function cfnComponentVersionLambdaExecutionParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponentVersion_LambdaExecutionParametersPropertyValidator(properties).assertSuccess(), { EnvironmentVariables: cdk.hashMapper(cdk.stringToCloudFormation)(properties.environmentVariables), EventSources: cdk.listMapper(cfnComponentVersionLambdaEventSourcePropertyToCloudFormation)(properties.eventSources), ExecArgs: cdk.listMapper(cdk.stringToCloudFormation)(properties.execArgs), InputPayloadEncodingType: cdk.stringToCloudFormation(properties.inputPayloadEncodingType), LinuxProcessParams: cfnComponentVersionLambdaLinuxProcessParamsPropertyToCloudFormation(properties.linuxProcessParams), MaxIdleTimeInSeconds: cdk.numberToCloudFormation(properties.maxIdleTimeInSeconds), MaxInstancesCount: cdk.numberToCloudFormation(properties.maxInstancesCount), MaxQueueSize: cdk.numberToCloudFormation(properties.maxQueueSize), Pinned: cdk.booleanToCloudFormation(properties.pinned), StatusTimeoutInSeconds: cdk.numberToCloudFormation(properties.statusTimeoutInSeconds), TimeoutInSeconds: cdk.numberToCloudFormation(properties.timeoutInSeconds) }) : properties;
    }
    function CfnComponentVersionLambdaExecutionParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("environmentVariables", "EnvironmentVariables", properties.EnvironmentVariables != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.EnvironmentVariables) : void 0), ret.addPropertyResult("eventSources", "EventSources", properties.EventSources != null ? cfn_parse.FromCloudFormation.getArray(CfnComponentVersionLambdaEventSourcePropertyFromCloudFormation)(properties.EventSources) : void 0), ret.addPropertyResult("execArgs", "ExecArgs", properties.ExecArgs != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExecArgs) : void 0), ret.addPropertyResult("inputPayloadEncodingType", "InputPayloadEncodingType", properties.InputPayloadEncodingType != null ? cfn_parse.FromCloudFormation.getString(properties.InputPayloadEncodingType) : void 0), ret.addPropertyResult("linuxProcessParams", "LinuxProcessParams", properties.LinuxProcessParams != null ? CfnComponentVersionLambdaLinuxProcessParamsPropertyFromCloudFormation(properties.LinuxProcessParams) : void 0), ret.addPropertyResult("maxIdleTimeInSeconds", "MaxIdleTimeInSeconds", properties.MaxIdleTimeInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxIdleTimeInSeconds) : void 0), ret.addPropertyResult("maxInstancesCount", "MaxInstancesCount", properties.MaxInstancesCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxInstancesCount) : void 0), ret.addPropertyResult("maxQueueSize", "MaxQueueSize", properties.MaxQueueSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxQueueSize) : void 0), ret.addPropertyResult("pinned", "Pinned", properties.Pinned != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Pinned) : void 0), ret.addPropertyResult("statusTimeoutInSeconds", "StatusTimeoutInSeconds", properties.StatusTimeoutInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.StatusTimeoutInSeconds) : void 0), ret.addPropertyResult("timeoutInSeconds", "TimeoutInSeconds", properties.TimeoutInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.TimeoutInSeconds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComponentVersion_LambdaFunctionRecipeSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("componentDependencies", cdk.hashValidator(CfnComponentVersion_ComponentDependencyRequirementPropertyValidator))(properties.componentDependencies)), errors.collect(cdk.propertyValidator("componentLambdaParameters", CfnComponentVersion_LambdaExecutionParametersPropertyValidator)(properties.componentLambdaParameters)), errors.collect(cdk.propertyValidator("componentName", cdk.validateString)(properties.componentName)), errors.collect(cdk.propertyValidator("componentPlatforms", cdk.listValidator(CfnComponentVersion_ComponentPlatformPropertyValidator))(properties.componentPlatforms)), errors.collect(cdk.propertyValidator("componentVersion", cdk.validateString)(properties.componentVersion)), errors.collect(cdk.propertyValidator("lambdaArn", cdk.validateString)(properties.lambdaArn)), errors.wrap('supplied properties not correct for "LambdaFunctionRecipeSourceProperty"');
    }
    function cfnComponentVersionLambdaFunctionRecipeSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponentVersion_LambdaFunctionRecipeSourcePropertyValidator(properties).assertSuccess(), { ComponentDependencies: cdk.hashMapper(cfnComponentVersionComponentDependencyRequirementPropertyToCloudFormation)(properties.componentDependencies), ComponentLambdaParameters: cfnComponentVersionLambdaExecutionParametersPropertyToCloudFormation(properties.componentLambdaParameters), ComponentName: cdk.stringToCloudFormation(properties.componentName), ComponentPlatforms: cdk.listMapper(cfnComponentVersionComponentPlatformPropertyToCloudFormation)(properties.componentPlatforms), ComponentVersion: cdk.stringToCloudFormation(properties.componentVersion), LambdaArn: cdk.stringToCloudFormation(properties.lambdaArn) }) : properties;
    }
    function CfnComponentVersionLambdaFunctionRecipeSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("componentDependencies", "ComponentDependencies", properties.ComponentDependencies != null ? cfn_parse.FromCloudFormation.getMap(CfnComponentVersionComponentDependencyRequirementPropertyFromCloudFormation)(properties.ComponentDependencies) : void 0), ret.addPropertyResult("componentLambdaParameters", "ComponentLambdaParameters", properties.ComponentLambdaParameters != null ? CfnComponentVersionLambdaExecutionParametersPropertyFromCloudFormation(properties.ComponentLambdaParameters) : void 0), ret.addPropertyResult("componentName", "ComponentName", properties.ComponentName != null ? cfn_parse.FromCloudFormation.getString(properties.ComponentName) : void 0), ret.addPropertyResult("componentPlatforms", "ComponentPlatforms", properties.ComponentPlatforms != null ? cfn_parse.FromCloudFormation.getArray(CfnComponentVersionComponentPlatformPropertyFromCloudFormation)(properties.ComponentPlatforms) : void 0), ret.addPropertyResult("componentVersion", "ComponentVersion", properties.ComponentVersion != null ? cfn_parse.FromCloudFormation.getString(properties.ComponentVersion) : void 0), ret.addPropertyResult("lambdaArn", "LambdaArn", properties.LambdaArn != null ? cfn_parse.FromCloudFormation.getString(properties.LambdaArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComponentVersion_LambdaLinuxProcessParamsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containerParams", CfnComponentVersion_LambdaContainerParamsPropertyValidator)(properties.containerParams)), errors.collect(cdk.propertyValidator("isolationMode", cdk.validateString)(properties.isolationMode)), errors.wrap('supplied properties not correct for "LambdaLinuxProcessParamsProperty"');
    }
    function cfnComponentVersionLambdaLinuxProcessParamsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponentVersion_LambdaLinuxProcessParamsPropertyValidator(properties).assertSuccess(), { ContainerParams: cfnComponentVersionLambdaContainerParamsPropertyToCloudFormation(properties.containerParams), IsolationMode: cdk.stringToCloudFormation(properties.isolationMode) }) : properties;
    }
    function CfnComponentVersionLambdaLinuxProcessParamsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containerParams", "ContainerParams", properties.ContainerParams != null ? CfnComponentVersionLambdaContainerParamsPropertyFromCloudFormation(properties.ContainerParams) : void 0), ret.addPropertyResult("isolationMode", "IsolationMode", properties.IsolationMode != null ? cfn_parse.FromCloudFormation.getString(properties.IsolationMode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComponentVersion_LambdaVolumeMountPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("addGroupOwner", cdk.validateBoolean)(properties.addGroupOwner)), errors.collect(cdk.propertyValidator("destinationPath", cdk.validateString)(properties.destinationPath)), errors.collect(cdk.propertyValidator("permission", cdk.validateString)(properties.permission)), errors.collect(cdk.propertyValidator("sourcePath", cdk.validateString)(properties.sourcePath)), errors.wrap('supplied properties not correct for "LambdaVolumeMountProperty"');
    }
    function cfnComponentVersionLambdaVolumeMountPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponentVersion_LambdaVolumeMountPropertyValidator(properties).assertSuccess(), { AddGroupOwner: cdk.booleanToCloudFormation(properties.addGroupOwner), DestinationPath: cdk.stringToCloudFormation(properties.destinationPath), Permission: cdk.stringToCloudFormation(properties.permission), SourcePath: cdk.stringToCloudFormation(properties.sourcePath) }) : properties;
    }
    function CfnComponentVersionLambdaVolumeMountPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("addGroupOwner", "AddGroupOwner", properties.AddGroupOwner != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AddGroupOwner) : void 0), ret.addPropertyResult("destinationPath", "DestinationPath", properties.DestinationPath != null ? cfn_parse.FromCloudFormation.getString(properties.DestinationPath) : void 0), ret.addPropertyResult("permission", "Permission", properties.Permission != null ? cfn_parse.FromCloudFormation.getString(properties.Permission) : void 0), ret.addPropertyResult("sourcePath", "SourcePath", properties.SourcePath != null ? cfn_parse.FromCloudFormation.getString(properties.SourcePath) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeploymentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("components", cdk.hashValidator(CfnDeployment_ComponentDeploymentSpecificationPropertyValidator))(properties.components)), errors.collect(cdk.propertyValidator("deploymentName", cdk.validateString)(properties.deploymentName)), errors.collect(cdk.propertyValidator("deploymentPolicies", CfnDeployment_DeploymentPoliciesPropertyValidator)(properties.deploymentPolicies)), errors.collect(cdk.propertyValidator("iotJobConfiguration", CfnDeployment_DeploymentIoTJobConfigurationPropertyValidator)(properties.iotJobConfiguration)), errors.collect(cdk.propertyValidator("parentTargetArn", cdk.validateString)(properties.parentTargetArn)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.collect(cdk.propertyValidator("targetArn", cdk.requiredValidator)(properties.targetArn)), errors.collect(cdk.propertyValidator("targetArn", cdk.validateString)(properties.targetArn)), errors.wrap('supplied properties not correct for "CfnDeploymentProps"');
    }
    function cfnDeploymentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeploymentPropsValidator(properties).assertSuccess(), { TargetArn: cdk.stringToCloudFormation(properties.targetArn), Components: cdk.hashMapper(cfnDeploymentComponentDeploymentSpecificationPropertyToCloudFormation)(properties.components), DeploymentName: cdk.stringToCloudFormation(properties.deploymentName), DeploymentPolicies: cfnDeploymentDeploymentPoliciesPropertyToCloudFormation(properties.deploymentPolicies), IotJobConfiguration: cfnDeploymentDeploymentIoTJobConfigurationPropertyToCloudFormation(properties.iotJobConfiguration), ParentTargetArn: cdk.stringToCloudFormation(properties.parentTargetArn), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDeploymentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("targetArn", "TargetArn", cfn_parse.FromCloudFormation.getString(properties.TargetArn)), ret.addPropertyResult("components", "Components", properties.Components != null ? cfn_parse.FromCloudFormation.getMap(CfnDeploymentComponentDeploymentSpecificationPropertyFromCloudFormation)(properties.Components) : void 0), ret.addPropertyResult("deploymentName", "DeploymentName", properties.DeploymentName != null ? cfn_parse.FromCloudFormation.getString(properties.DeploymentName) : void 0), ret.addPropertyResult("deploymentPolicies", "DeploymentPolicies", properties.DeploymentPolicies != null ? CfnDeploymentDeploymentPoliciesPropertyFromCloudFormation(properties.DeploymentPolicies) : void 0), ret.addPropertyResult("iotJobConfiguration", "IotJobConfiguration", properties.IotJobConfiguration != null ? CfnDeploymentDeploymentIoTJobConfigurationPropertyFromCloudFormation(properties.IotJobConfiguration) : void 0), ret.addPropertyResult("parentTargetArn", "ParentTargetArn", properties.ParentTargetArn != null ? cfn_parse.FromCloudFormation.getString(properties.ParentTargetArn) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDeployment = class _CfnDeployment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDeploymentPropsFromCloudFormation(resourceProperties), ret = new _CfnDeployment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDeployment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_greengrassv2_CfnDeploymentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDeployment), error;
        }
        cdk.requireProperty(props, "targetArn", this), this.attrDeploymentId = cdk.Token.asString(this.getAtt("DeploymentId", cdk.ResolutionTypeHint.STRING)), this.targetArn = props.targetArn, this.components = props.components, this.deploymentName = props.deploymentName, this.deploymentPolicies = props.deploymentPolicies, this.iotJobConfiguration = props.iotJobConfiguration, this.parentTargetArn = props.parentTargetArn, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::GreengrassV2::Deployment", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDeployment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { targetArn: this.targetArn, components: this.components, deploymentName: this.deploymentName, deploymentPolicies: this.deploymentPolicies, iotJobConfiguration: this.iotJobConfiguration, parentTargetArn: this.parentTargetArn, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDeploymentPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnDeployment[_b] = { fqn: "aws-cdk-lib.aws_greengrassv2.CfnDeployment", version: "2.80.0" }, CfnDeployment.CFN_RESOURCE_TYPE_NAME = "AWS::GreengrassV2::Deployment", exports2.CfnDeployment = CfnDeployment;
    function CfnDeployment_ComponentConfigurationUpdatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("merge", cdk.validateString)(properties.merge)), errors.collect(cdk.propertyValidator("reset", cdk.listValidator(cdk.validateString))(properties.reset)), errors.wrap('supplied properties not correct for "ComponentConfigurationUpdateProperty"');
    }
    function cfnDeploymentComponentConfigurationUpdatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeployment_ComponentConfigurationUpdatePropertyValidator(properties).assertSuccess(), { Merge: cdk.stringToCloudFormation(properties.merge), Reset: cdk.listMapper(cdk.stringToCloudFormation)(properties.reset) }) : properties;
    }
    function CfnDeploymentComponentConfigurationUpdatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("merge", "Merge", properties.Merge != null ? cfn_parse.FromCloudFormation.getString(properties.Merge) : void 0), ret.addPropertyResult("reset", "Reset", properties.Reset != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Reset) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeployment_ComponentDeploymentSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("componentVersion", cdk.validateString)(properties.componentVersion)), errors.collect(cdk.propertyValidator("configurationUpdate", CfnDeployment_ComponentConfigurationUpdatePropertyValidator)(properties.configurationUpdate)), errors.collect(cdk.propertyValidator("runWith", CfnDeployment_ComponentRunWithPropertyValidator)(properties.runWith)), errors.wrap('supplied properties not correct for "ComponentDeploymentSpecificationProperty"');
    }
    function cfnDeploymentComponentDeploymentSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeployment_ComponentDeploymentSpecificationPropertyValidator(properties).assertSuccess(), { ComponentVersion: cdk.stringToCloudFormation(properties.componentVersion), ConfigurationUpdate: cfnDeploymentComponentConfigurationUpdatePropertyToCloudFormation(properties.configurationUpdate), RunWith: cfnDeploymentComponentRunWithPropertyToCloudFormation(properties.runWith) }) : properties;
    }
    function CfnDeploymentComponentDeploymentSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("componentVersion", "ComponentVersion", properties.ComponentVersion != null ? cfn_parse.FromCloudFormation.getString(properties.ComponentVersion) : void 0), ret.addPropertyResult("configurationUpdate", "ConfigurationUpdate", properties.ConfigurationUpdate != null ? CfnDeploymentComponentConfigurationUpdatePropertyFromCloudFormation(properties.ConfigurationUpdate) : void 0), ret.addPropertyResult("runWith", "RunWith", properties.RunWith != null ? CfnDeploymentComponentRunWithPropertyFromCloudFormation(properties.RunWith) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeployment_ComponentRunWithPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("posixUser", cdk.validateString)(properties.posixUser)), errors.collect(cdk.propertyValidator("systemResourceLimits", CfnDeployment_SystemResourceLimitsPropertyValidator)(properties.systemResourceLimits)), errors.collect(cdk.propertyValidator("windowsUser", cdk.validateString)(properties.windowsUser)), errors.wrap('supplied properties not correct for "ComponentRunWithProperty"');
    }
    function cfnDeploymentComponentRunWithPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeployment_ComponentRunWithPropertyValidator(properties).assertSuccess(), { PosixUser: cdk.stringToCloudFormation(properties.posixUser), SystemResourceLimits: cfnDeploymentSystemResourceLimitsPropertyToCloudFormation(properties.systemResourceLimits), WindowsUser: cdk.stringToCloudFormation(properties.windowsUser) }) : properties;
    }
    function CfnDeploymentComponentRunWithPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("posixUser", "PosixUser", properties.PosixUser != null ? cfn_parse.FromCloudFormation.getString(properties.PosixUser) : void 0), ret.addPropertyResult("systemResourceLimits", "SystemResourceLimits", properties.SystemResourceLimits != null ? CfnDeploymentSystemResourceLimitsPropertyFromCloudFormation(properties.SystemResourceLimits) : void 0), ret.addPropertyResult("windowsUser", "WindowsUser", properties.WindowsUser != null ? cfn_parse.FromCloudFormation.getString(properties.WindowsUser) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeployment_DeploymentComponentUpdatePolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.validateString)(properties.action)), errors.collect(cdk.propertyValidator("timeoutInSeconds", cdk.validateNumber)(properties.timeoutInSeconds)), errors.wrap('supplied properties not correct for "DeploymentComponentUpdatePolicyProperty"');
    }
    function cfnDeploymentDeploymentComponentUpdatePolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeployment_DeploymentComponentUpdatePolicyPropertyValidator(properties).assertSuccess(), { Action: cdk.stringToCloudFormation(properties.action), TimeoutInSeconds: cdk.numberToCloudFormation(properties.timeoutInSeconds) }) : properties;
    }
    function CfnDeploymentDeploymentComponentUpdatePolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", properties.Action != null ? cfn_parse.FromCloudFormation.getString(properties.Action) : void 0), ret.addPropertyResult("timeoutInSeconds", "TimeoutInSeconds", properties.TimeoutInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.TimeoutInSeconds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeployment_DeploymentConfigurationValidationPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("timeoutInSeconds", cdk.validateNumber)(properties.timeoutInSeconds)), errors.wrap('supplied properties not correct for "DeploymentConfigurationValidationPolicyProperty"');
    }
    function cfnDeploymentDeploymentConfigurationValidationPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeployment_DeploymentConfigurationValidationPolicyPropertyValidator(properties).assertSuccess(), { TimeoutInSeconds: cdk.numberToCloudFormation(properties.timeoutInSeconds) }) : properties;
    }
    function CfnDeploymentDeploymentConfigurationValidationPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("timeoutInSeconds", "TimeoutInSeconds", properties.TimeoutInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.TimeoutInSeconds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeployment_DeploymentIoTJobConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("abortConfig", CfnDeployment_IoTJobAbortConfigPropertyValidator)(properties.abortConfig)), errors.collect(cdk.propertyValidator("jobExecutionsRolloutConfig", CfnDeployment_IoTJobExecutionsRolloutConfigPropertyValidator)(properties.jobExecutionsRolloutConfig)), errors.collect(cdk.propertyValidator("timeoutConfig", CfnDeployment_IoTJobTimeoutConfigPropertyValidator)(properties.timeoutConfig)), errors.wrap('supplied properties not correct for "DeploymentIoTJobConfigurationProperty"');
    }
    function cfnDeploymentDeploymentIoTJobConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeployment_DeploymentIoTJobConfigurationPropertyValidator(properties).assertSuccess(), { AbortConfig: cfnDeploymentIoTJobAbortConfigPropertyToCloudFormation(properties.abortConfig), JobExecutionsRolloutConfig: cfnDeploymentIoTJobExecutionsRolloutConfigPropertyToCloudFormation(properties.jobExecutionsRolloutConfig), TimeoutConfig: cfnDeploymentIoTJobTimeoutConfigPropertyToCloudFormation(properties.timeoutConfig) }) : properties;
    }
    function CfnDeploymentDeploymentIoTJobConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("abortConfig", "AbortConfig", properties.AbortConfig != null ? CfnDeploymentIoTJobAbortConfigPropertyFromCloudFormation(properties.AbortConfig) : void 0), ret.addPropertyResult("jobExecutionsRolloutConfig", "JobExecutionsRolloutConfig", properties.JobExecutionsRolloutConfig != null ? CfnDeploymentIoTJobExecutionsRolloutConfigPropertyFromCloudFormation(properties.JobExecutionsRolloutConfig) : void 0), ret.addPropertyResult("timeoutConfig", "TimeoutConfig", properties.TimeoutConfig != null ? CfnDeploymentIoTJobTimeoutConfigPropertyFromCloudFormation(properties.TimeoutConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeployment_DeploymentPoliciesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("componentUpdatePolicy", CfnDeployment_DeploymentComponentUpdatePolicyPropertyValidator)(properties.componentUpdatePolicy)), errors.collect(cdk.propertyValidator("configurationValidationPolicy", CfnDeployment_DeploymentConfigurationValidationPolicyPropertyValidator)(properties.configurationValidationPolicy)), errors.collect(cdk.propertyValidator("failureHandlingPolicy", cdk.validateString)(properties.failureHandlingPolicy)), errors.wrap('supplied properties not correct for "DeploymentPoliciesProperty"');
    }
    function cfnDeploymentDeploymentPoliciesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeployment_DeploymentPoliciesPropertyValidator(properties).assertSuccess(), { ComponentUpdatePolicy: cfnDeploymentDeploymentComponentUpdatePolicyPropertyToCloudFormation(properties.componentUpdatePolicy), ConfigurationValidationPolicy: cfnDeploymentDeploymentConfigurationValidationPolicyPropertyToCloudFormation(properties.configurationValidationPolicy), FailureHandlingPolicy: cdk.stringToCloudFormation(properties.failureHandlingPolicy) }) : properties;
    }
    function CfnDeploymentDeploymentPoliciesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("componentUpdatePolicy", "ComponentUpdatePolicy", properties.ComponentUpdatePolicy != null ? CfnDeploymentDeploymentComponentUpdatePolicyPropertyFromCloudFormation(properties.ComponentUpdatePolicy) : void 0), ret.addPropertyResult("configurationValidationPolicy", "ConfigurationValidationPolicy", properties.ConfigurationValidationPolicy != null ? CfnDeploymentDeploymentConfigurationValidationPolicyPropertyFromCloudFormation(properties.ConfigurationValidationPolicy) : void 0), ret.addPropertyResult("failureHandlingPolicy", "FailureHandlingPolicy", properties.FailureHandlingPolicy != null ? cfn_parse.FromCloudFormation.getString(properties.FailureHandlingPolicy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeployment_IoTJobAbortConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("criteriaList", cdk.requiredValidator)(properties.criteriaList)), errors.collect(cdk.propertyValidator("criteriaList", cdk.listValidator(CfnDeployment_IoTJobAbortCriteriaPropertyValidator))(properties.criteriaList)), errors.wrap('supplied properties not correct for "IoTJobAbortConfigProperty"');
    }
    function cfnDeploymentIoTJobAbortConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeployment_IoTJobAbortConfigPropertyValidator(properties).assertSuccess(), { CriteriaList: cdk.listMapper(cfnDeploymentIoTJobAbortCriteriaPropertyToCloudFormation)(properties.criteriaList) }) : properties;
    }
    function CfnDeploymentIoTJobAbortConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("criteriaList", "CriteriaList", cfn_parse.FromCloudFormation.getArray(CfnDeploymentIoTJobAbortCriteriaPropertyFromCloudFormation)(properties.CriteriaList)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeployment_IoTJobAbortCriteriaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.requiredValidator)(properties.action)), errors.collect(cdk.propertyValidator("action", cdk.validateString)(properties.action)), errors.collect(cdk.propertyValidator("failureType", cdk.requiredValidator)(properties.failureType)), errors.collect(cdk.propertyValidator("failureType", cdk.validateString)(properties.failureType)), errors.collect(cdk.propertyValidator("minNumberOfExecutedThings", cdk.requiredValidator)(properties.minNumberOfExecutedThings)), errors.collect(cdk.propertyValidator("minNumberOfExecutedThings", cdk.validateNumber)(properties.minNumberOfExecutedThings)), errors.collect(cdk.propertyValidator("thresholdPercentage", cdk.requiredValidator)(properties.thresholdPercentage)), errors.collect(cdk.propertyValidator("thresholdPercentage", cdk.validateNumber)(properties.thresholdPercentage)), errors.wrap('supplied properties not correct for "IoTJobAbortCriteriaProperty"');
    }
    function cfnDeploymentIoTJobAbortCriteriaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeployment_IoTJobAbortCriteriaPropertyValidator(properties).assertSuccess(), { Action: cdk.stringToCloudFormation(properties.action), FailureType: cdk.stringToCloudFormation(properties.failureType), MinNumberOfExecutedThings: cdk.numberToCloudFormation(properties.minNumberOfExecutedThings), ThresholdPercentage: cdk.numberToCloudFormation(properties.thresholdPercentage) }) : properties;
    }
    function CfnDeploymentIoTJobAbortCriteriaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", cfn_parse.FromCloudFormation.getString(properties.Action)), ret.addPropertyResult("failureType", "FailureType", cfn_parse.FromCloudFormation.getString(properties.FailureType)), ret.addPropertyResult("minNumberOfExecutedThings", "MinNumberOfExecutedThings", cfn_parse.FromCloudFormation.getNumber(properties.MinNumberOfExecutedThings)), ret.addPropertyResult("thresholdPercentage", "ThresholdPercentage", cfn_parse.FromCloudFormation.getNumber(properties.ThresholdPercentage)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeployment_IoTJobExecutionsRolloutConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("exponentialRate", CfnDeployment_IoTJobExponentialRolloutRatePropertyValidator)(properties.exponentialRate)), errors.collect(cdk.propertyValidator("maximumPerMinute", cdk.validateNumber)(properties.maximumPerMinute)), errors.wrap('supplied properties not correct for "IoTJobExecutionsRolloutConfigProperty"');
    }
    function cfnDeploymentIoTJobExecutionsRolloutConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeployment_IoTJobExecutionsRolloutConfigPropertyValidator(properties).assertSuccess(), { ExponentialRate: cfnDeploymentIoTJobExponentialRolloutRatePropertyToCloudFormation(properties.exponentialRate), MaximumPerMinute: cdk.numberToCloudFormation(properties.maximumPerMinute) }) : properties;
    }
    function CfnDeploymentIoTJobExecutionsRolloutConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("exponentialRate", "ExponentialRate", properties.ExponentialRate != null ? CfnDeploymentIoTJobExponentialRolloutRatePropertyFromCloudFormation(properties.ExponentialRate) : void 0), ret.addPropertyResult("maximumPerMinute", "MaximumPerMinute", properties.MaximumPerMinute != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumPerMinute) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeployment_IoTJobExponentialRolloutRatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("baseRatePerMinute", cdk.requiredValidator)(properties.baseRatePerMinute)), errors.collect(cdk.propertyValidator("baseRatePerMinute", cdk.validateNumber)(properties.baseRatePerMinute)), errors.collect(cdk.propertyValidator("incrementFactor", cdk.requiredValidator)(properties.incrementFactor)), errors.collect(cdk.propertyValidator("incrementFactor", cdk.validateNumber)(properties.incrementFactor)), errors.collect(cdk.propertyValidator("rateIncreaseCriteria", cdk.requiredValidator)(properties.rateIncreaseCriteria)), errors.collect(cdk.propertyValidator("rateIncreaseCriteria", cdk.validateObject)(properties.rateIncreaseCriteria)), errors.wrap('supplied properties not correct for "IoTJobExponentialRolloutRateProperty"');
    }
    function cfnDeploymentIoTJobExponentialRolloutRatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeployment_IoTJobExponentialRolloutRatePropertyValidator(properties).assertSuccess(), { BaseRatePerMinute: cdk.numberToCloudFormation(properties.baseRatePerMinute), IncrementFactor: cdk.numberToCloudFormation(properties.incrementFactor), RateIncreaseCriteria: cdk.objectToCloudFormation(properties.rateIncreaseCriteria) }) : properties;
    }
    function CfnDeploymentIoTJobExponentialRolloutRatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("baseRatePerMinute", "BaseRatePerMinute", cfn_parse.FromCloudFormation.getNumber(properties.BaseRatePerMinute)), ret.addPropertyResult("incrementFactor", "IncrementFactor", cfn_parse.FromCloudFormation.getNumber(properties.IncrementFactor)), ret.addPropertyResult("rateIncreaseCriteria", "RateIncreaseCriteria", cfn_parse.FromCloudFormation.getAny(properties.RateIncreaseCriteria)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeployment_IoTJobTimeoutConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("inProgressTimeoutInMinutes", cdk.validateNumber)(properties.inProgressTimeoutInMinutes)), errors.wrap('supplied properties not correct for "IoTJobTimeoutConfigProperty"');
    }
    function cfnDeploymentIoTJobTimeoutConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeployment_IoTJobTimeoutConfigPropertyValidator(properties).assertSuccess(), { InProgressTimeoutInMinutes: cdk.numberToCloudFormation(properties.inProgressTimeoutInMinutes) }) : properties;
    }
    function CfnDeploymentIoTJobTimeoutConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("inProgressTimeoutInMinutes", "InProgressTimeoutInMinutes", properties.InProgressTimeoutInMinutes != null ? cfn_parse.FromCloudFormation.getNumber(properties.InProgressTimeoutInMinutes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeployment_SystemResourceLimitsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cpus", cdk.validateNumber)(properties.cpus)), errors.collect(cdk.propertyValidator("memory", cdk.validateNumber)(properties.memory)), errors.wrap('supplied properties not correct for "SystemResourceLimitsProperty"');
    }
    function cfnDeploymentSystemResourceLimitsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeployment_SystemResourceLimitsPropertyValidator(properties).assertSuccess(), { Cpus: cdk.numberToCloudFormation(properties.cpus), Memory: cdk.numberToCloudFormation(properties.memory) }) : properties;
    }
    function CfnDeploymentSystemResourceLimitsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cpus", "Cpus", properties.Cpus != null ? cfn_parse.FromCloudFormation.getNumber(properties.Cpus) : void 0), ret.addPropertyResult("memory", "Memory", properties.Memory != null ? cfn_parse.FromCloudFormation.getNumber(properties.Memory) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-greengrassv2/lib/index.js
var require_lib140 = __commonJS({
  "node_modules/aws-cdk-lib/aws-greengrassv2/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_greengrassv2_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-greengrassv2/index.js
var require_aws_greengrassv2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-greengrassv2/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib140(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-groundstation/lib/groundstation.generated.js
var require_groundstation_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-groundstation/lib/groundstation.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnMissionProfile = exports2.CfnDataflowEndpointGroup = exports2.CfnConfig = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnConfigPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configData", cdk.requiredValidator)(properties.configData)), errors.collect(cdk.propertyValidator("configData", CfnConfig_ConfigDataPropertyValidator)(properties.configData)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnConfigProps"');
    }
    function cfnConfigPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigPropsValidator(properties).assertSuccess(), { ConfigData: cfnConfigConfigDataPropertyToCloudFormation(properties.configData), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnConfigPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configData", "ConfigData", CfnConfigConfigDataPropertyFromCloudFormation(properties.ConfigData)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnConfig = class _CfnConfig extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnConfigPropsFromCloudFormation(resourceProperties), ret = new _CfnConfig(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnConfig.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_groundstation_CfnConfigProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnConfig), error;
        }
        cdk.requireProperty(props, "configData", this), cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrType = cdk.Token.asString(this.getAtt("Type", cdk.ResolutionTypeHint.STRING)), this.configData = props.configData, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::GroundStation::Config", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnConfig.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { configData: this.configData, name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnConfigPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnConfig[_a] = { fqn: "aws-cdk-lib.aws_groundstation.CfnConfig", version: "2.80.0" }, CfnConfig.CFN_RESOURCE_TYPE_NAME = "AWS::GroundStation::Config", exports2.CfnConfig = CfnConfig;
    function CfnConfig_AntennaDownlinkConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("spectrumConfig", CfnConfig_SpectrumConfigPropertyValidator)(properties.spectrumConfig)), errors.wrap('supplied properties not correct for "AntennaDownlinkConfigProperty"');
    }
    function cfnConfigAntennaDownlinkConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfig_AntennaDownlinkConfigPropertyValidator(properties).assertSuccess(), { SpectrumConfig: cfnConfigSpectrumConfigPropertyToCloudFormation(properties.spectrumConfig) }) : properties;
    }
    function CfnConfigAntennaDownlinkConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("spectrumConfig", "SpectrumConfig", properties.SpectrumConfig != null ? CfnConfigSpectrumConfigPropertyFromCloudFormation(properties.SpectrumConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfig_AntennaDownlinkDemodDecodeConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("decodeConfig", CfnConfig_DecodeConfigPropertyValidator)(properties.decodeConfig)), errors.collect(cdk.propertyValidator("demodulationConfig", CfnConfig_DemodulationConfigPropertyValidator)(properties.demodulationConfig)), errors.collect(cdk.propertyValidator("spectrumConfig", CfnConfig_SpectrumConfigPropertyValidator)(properties.spectrumConfig)), errors.wrap('supplied properties not correct for "AntennaDownlinkDemodDecodeConfigProperty"');
    }
    function cfnConfigAntennaDownlinkDemodDecodeConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfig_AntennaDownlinkDemodDecodeConfigPropertyValidator(properties).assertSuccess(), { DecodeConfig: cfnConfigDecodeConfigPropertyToCloudFormation(properties.decodeConfig), DemodulationConfig: cfnConfigDemodulationConfigPropertyToCloudFormation(properties.demodulationConfig), SpectrumConfig: cfnConfigSpectrumConfigPropertyToCloudFormation(properties.spectrumConfig) }) : properties;
    }
    function CfnConfigAntennaDownlinkDemodDecodeConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("decodeConfig", "DecodeConfig", properties.DecodeConfig != null ? CfnConfigDecodeConfigPropertyFromCloudFormation(properties.DecodeConfig) : void 0), ret.addPropertyResult("demodulationConfig", "DemodulationConfig", properties.DemodulationConfig != null ? CfnConfigDemodulationConfigPropertyFromCloudFormation(properties.DemodulationConfig) : void 0), ret.addPropertyResult("spectrumConfig", "SpectrumConfig", properties.SpectrumConfig != null ? CfnConfigSpectrumConfigPropertyFromCloudFormation(properties.SpectrumConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfig_AntennaUplinkConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("spectrumConfig", CfnConfig_UplinkSpectrumConfigPropertyValidator)(properties.spectrumConfig)), errors.collect(cdk.propertyValidator("targetEirp", CfnConfig_EirpPropertyValidator)(properties.targetEirp)), errors.collect(cdk.propertyValidator("transmitDisabled", cdk.validateBoolean)(properties.transmitDisabled)), errors.wrap('supplied properties not correct for "AntennaUplinkConfigProperty"');
    }
    function cfnConfigAntennaUplinkConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfig_AntennaUplinkConfigPropertyValidator(properties).assertSuccess(), { SpectrumConfig: cfnConfigUplinkSpectrumConfigPropertyToCloudFormation(properties.spectrumConfig), TargetEirp: cfnConfigEirpPropertyToCloudFormation(properties.targetEirp), TransmitDisabled: cdk.booleanToCloudFormation(properties.transmitDisabled) }) : properties;
    }
    function CfnConfigAntennaUplinkConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("spectrumConfig", "SpectrumConfig", properties.SpectrumConfig != null ? CfnConfigUplinkSpectrumConfigPropertyFromCloudFormation(properties.SpectrumConfig) : void 0), ret.addPropertyResult("targetEirp", "TargetEirp", properties.TargetEirp != null ? CfnConfigEirpPropertyFromCloudFormation(properties.TargetEirp) : void 0), ret.addPropertyResult("transmitDisabled", "TransmitDisabled", properties.TransmitDisabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.TransmitDisabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfig_ConfigDataPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("antennaDownlinkConfig", CfnConfig_AntennaDownlinkConfigPropertyValidator)(properties.antennaDownlinkConfig)), errors.collect(cdk.propertyValidator("antennaDownlinkDemodDecodeConfig", CfnConfig_AntennaDownlinkDemodDecodeConfigPropertyValidator)(properties.antennaDownlinkDemodDecodeConfig)), errors.collect(cdk.propertyValidator("antennaUplinkConfig", CfnConfig_AntennaUplinkConfigPropertyValidator)(properties.antennaUplinkConfig)), errors.collect(cdk.propertyValidator("dataflowEndpointConfig", CfnConfig_DataflowEndpointConfigPropertyValidator)(properties.dataflowEndpointConfig)), errors.collect(cdk.propertyValidator("s3RecordingConfig", CfnConfig_S3RecordingConfigPropertyValidator)(properties.s3RecordingConfig)), errors.collect(cdk.propertyValidator("trackingConfig", CfnConfig_TrackingConfigPropertyValidator)(properties.trackingConfig)), errors.collect(cdk.propertyValidator("uplinkEchoConfig", CfnConfig_UplinkEchoConfigPropertyValidator)(properties.uplinkEchoConfig)), errors.wrap('supplied properties not correct for "ConfigDataProperty"');
    }
    function cfnConfigConfigDataPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfig_ConfigDataPropertyValidator(properties).assertSuccess(), { AntennaDownlinkConfig: cfnConfigAntennaDownlinkConfigPropertyToCloudFormation(properties.antennaDownlinkConfig), AntennaDownlinkDemodDecodeConfig: cfnConfigAntennaDownlinkDemodDecodeConfigPropertyToCloudFormation(properties.antennaDownlinkDemodDecodeConfig), AntennaUplinkConfig: cfnConfigAntennaUplinkConfigPropertyToCloudFormation(properties.antennaUplinkConfig), DataflowEndpointConfig: cfnConfigDataflowEndpointConfigPropertyToCloudFormation(properties.dataflowEndpointConfig), S3RecordingConfig: cfnConfigS3RecordingConfigPropertyToCloudFormation(properties.s3RecordingConfig), TrackingConfig: cfnConfigTrackingConfigPropertyToCloudFormation(properties.trackingConfig), UplinkEchoConfig: cfnConfigUplinkEchoConfigPropertyToCloudFormation(properties.uplinkEchoConfig) }) : properties;
    }
    function CfnConfigConfigDataPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("antennaDownlinkConfig", "AntennaDownlinkConfig", properties.AntennaDownlinkConfig != null ? CfnConfigAntennaDownlinkConfigPropertyFromCloudFormation(properties.AntennaDownlinkConfig) : void 0), ret.addPropertyResult("antennaDownlinkDemodDecodeConfig", "AntennaDownlinkDemodDecodeConfig", properties.AntennaDownlinkDemodDecodeConfig != null ? CfnConfigAntennaDownlinkDemodDecodeConfigPropertyFromCloudFormation(properties.AntennaDownlinkDemodDecodeConfig) : void 0), ret.addPropertyResult("antennaUplinkConfig", "AntennaUplinkConfig", properties.AntennaUplinkConfig != null ? CfnConfigAntennaUplinkConfigPropertyFromCloudFormation(properties.AntennaUplinkConfig) : void 0), ret.addPropertyResult("dataflowEndpointConfig", "DataflowEndpointConfig", properties.DataflowEndpointConfig != null ? CfnConfigDataflowEndpointConfigPropertyFromCloudFormation(properties.DataflowEndpointConfig) : void 0), ret.addPropertyResult("s3RecordingConfig", "S3RecordingConfig", properties.S3RecordingConfig != null ? CfnConfigS3RecordingConfigPropertyFromCloudFormation(properties.S3RecordingConfig) : void 0), ret.addPropertyResult("trackingConfig", "TrackingConfig", properties.TrackingConfig != null ? CfnConfigTrackingConfigPropertyFromCloudFormation(properties.TrackingConfig) : void 0), ret.addPropertyResult("uplinkEchoConfig", "UplinkEchoConfig", properties.UplinkEchoConfig != null ? CfnConfigUplinkEchoConfigPropertyFromCloudFormation(properties.UplinkEchoConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfig_DataflowEndpointConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataflowEndpointName", cdk.validateString)(properties.dataflowEndpointName)), errors.collect(cdk.propertyValidator("dataflowEndpointRegion", cdk.validateString)(properties.dataflowEndpointRegion)), errors.wrap('supplied properties not correct for "DataflowEndpointConfigProperty"');
    }
    function cfnConfigDataflowEndpointConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfig_DataflowEndpointConfigPropertyValidator(properties).assertSuccess(), { DataflowEndpointName: cdk.stringToCloudFormation(properties.dataflowEndpointName), DataflowEndpointRegion: cdk.stringToCloudFormation(properties.dataflowEndpointRegion) }) : properties;
    }
    function CfnConfigDataflowEndpointConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataflowEndpointName", "DataflowEndpointName", properties.DataflowEndpointName != null ? cfn_parse.FromCloudFormation.getString(properties.DataflowEndpointName) : void 0), ret.addPropertyResult("dataflowEndpointRegion", "DataflowEndpointRegion", properties.DataflowEndpointRegion != null ? cfn_parse.FromCloudFormation.getString(properties.DataflowEndpointRegion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfig_DecodeConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("unvalidatedJson", cdk.validateString)(properties.unvalidatedJson)), errors.wrap('supplied properties not correct for "DecodeConfigProperty"');
    }
    function cfnConfigDecodeConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfig_DecodeConfigPropertyValidator(properties).assertSuccess(), { UnvalidatedJSON: cdk.stringToCloudFormation(properties.unvalidatedJson) }) : properties;
    }
    function CfnConfigDecodeConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("unvalidatedJson", "UnvalidatedJSON", properties.UnvalidatedJSON != null ? cfn_parse.FromCloudFormation.getString(properties.UnvalidatedJSON) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfig_DemodulationConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("unvalidatedJson", cdk.validateString)(properties.unvalidatedJson)), errors.wrap('supplied properties not correct for "DemodulationConfigProperty"');
    }
    function cfnConfigDemodulationConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfig_DemodulationConfigPropertyValidator(properties).assertSuccess(), { UnvalidatedJSON: cdk.stringToCloudFormation(properties.unvalidatedJson) }) : properties;
    }
    function CfnConfigDemodulationConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("unvalidatedJson", "UnvalidatedJSON", properties.UnvalidatedJSON != null ? cfn_parse.FromCloudFormation.getString(properties.UnvalidatedJSON) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfig_EirpPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("units", cdk.validateString)(properties.units)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "EirpProperty"');
    }
    function cfnConfigEirpPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfig_EirpPropertyValidator(properties).assertSuccess(), { Units: cdk.stringToCloudFormation(properties.units), Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnConfigEirpPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("units", "Units", properties.Units != null ? cfn_parse.FromCloudFormation.getString(properties.Units) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getNumber(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfig_FrequencyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("units", cdk.validateString)(properties.units)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "FrequencyProperty"');
    }
    function cfnConfigFrequencyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfig_FrequencyPropertyValidator(properties).assertSuccess(), { Units: cdk.stringToCloudFormation(properties.units), Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnConfigFrequencyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("units", "Units", properties.Units != null ? cfn_parse.FromCloudFormation.getString(properties.Units) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getNumber(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfig_FrequencyBandwidthPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("units", cdk.validateString)(properties.units)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "FrequencyBandwidthProperty"');
    }
    function cfnConfigFrequencyBandwidthPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfig_FrequencyBandwidthPropertyValidator(properties).assertSuccess(), { Units: cdk.stringToCloudFormation(properties.units), Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnConfigFrequencyBandwidthPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("units", "Units", properties.Units != null ? cfn_parse.FromCloudFormation.getString(properties.Units) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getNumber(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfig_S3RecordingConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketArn", cdk.validateString)(properties.bucketArn)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "S3RecordingConfigProperty"');
    }
    function cfnConfigS3RecordingConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfig_S3RecordingConfigPropertyValidator(properties).assertSuccess(), { BucketArn: cdk.stringToCloudFormation(properties.bucketArn), Prefix: cdk.stringToCloudFormation(properties.prefix), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnConfigS3RecordingConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketArn", "BucketArn", properties.BucketArn != null ? cfn_parse.FromCloudFormation.getString(properties.BucketArn) : void 0), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfig_SpectrumConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bandwidth", CfnConfig_FrequencyBandwidthPropertyValidator)(properties.bandwidth)), errors.collect(cdk.propertyValidator("centerFrequency", CfnConfig_FrequencyPropertyValidator)(properties.centerFrequency)), errors.collect(cdk.propertyValidator("polarization", cdk.validateString)(properties.polarization)), errors.wrap('supplied properties not correct for "SpectrumConfigProperty"');
    }
    function cfnConfigSpectrumConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfig_SpectrumConfigPropertyValidator(properties).assertSuccess(), { Bandwidth: cfnConfigFrequencyBandwidthPropertyToCloudFormation(properties.bandwidth), CenterFrequency: cfnConfigFrequencyPropertyToCloudFormation(properties.centerFrequency), Polarization: cdk.stringToCloudFormation(properties.polarization) }) : properties;
    }
    function CfnConfigSpectrumConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bandwidth", "Bandwidth", properties.Bandwidth != null ? CfnConfigFrequencyBandwidthPropertyFromCloudFormation(properties.Bandwidth) : void 0), ret.addPropertyResult("centerFrequency", "CenterFrequency", properties.CenterFrequency != null ? CfnConfigFrequencyPropertyFromCloudFormation(properties.CenterFrequency) : void 0), ret.addPropertyResult("polarization", "Polarization", properties.Polarization != null ? cfn_parse.FromCloudFormation.getString(properties.Polarization) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfig_TrackingConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autotrack", cdk.validateString)(properties.autotrack)), errors.wrap('supplied properties not correct for "TrackingConfigProperty"');
    }
    function cfnConfigTrackingConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfig_TrackingConfigPropertyValidator(properties).assertSuccess(), { Autotrack: cdk.stringToCloudFormation(properties.autotrack) }) : properties;
    }
    function CfnConfigTrackingConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("autotrack", "Autotrack", properties.Autotrack != null ? cfn_parse.FromCloudFormation.getString(properties.Autotrack) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfig_UplinkEchoConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("antennaUplinkConfigArn", cdk.validateString)(properties.antennaUplinkConfigArn)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "UplinkEchoConfigProperty"');
    }
    function cfnConfigUplinkEchoConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfig_UplinkEchoConfigPropertyValidator(properties).assertSuccess(), { AntennaUplinkConfigArn: cdk.stringToCloudFormation(properties.antennaUplinkConfigArn), Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnConfigUplinkEchoConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("antennaUplinkConfigArn", "AntennaUplinkConfigArn", properties.AntennaUplinkConfigArn != null ? cfn_parse.FromCloudFormation.getString(properties.AntennaUplinkConfigArn) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfig_UplinkSpectrumConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("centerFrequency", CfnConfig_FrequencyPropertyValidator)(properties.centerFrequency)), errors.collect(cdk.propertyValidator("polarization", cdk.validateString)(properties.polarization)), errors.wrap('supplied properties not correct for "UplinkSpectrumConfigProperty"');
    }
    function cfnConfigUplinkSpectrumConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfig_UplinkSpectrumConfigPropertyValidator(properties).assertSuccess(), { CenterFrequency: cfnConfigFrequencyPropertyToCloudFormation(properties.centerFrequency), Polarization: cdk.stringToCloudFormation(properties.polarization) }) : properties;
    }
    function CfnConfigUplinkSpectrumConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("centerFrequency", "CenterFrequency", properties.CenterFrequency != null ? CfnConfigFrequencyPropertyFromCloudFormation(properties.CenterFrequency) : void 0), ret.addPropertyResult("polarization", "Polarization", properties.Polarization != null ? cfn_parse.FromCloudFormation.getString(properties.Polarization) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataflowEndpointGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contactPostPassDurationSeconds", cdk.validateNumber)(properties.contactPostPassDurationSeconds)), errors.collect(cdk.propertyValidator("contactPrePassDurationSeconds", cdk.validateNumber)(properties.contactPrePassDurationSeconds)), errors.collect(cdk.propertyValidator("endpointDetails", cdk.requiredValidator)(properties.endpointDetails)), errors.collect(cdk.propertyValidator("endpointDetails", cdk.listValidator(CfnDataflowEndpointGroup_EndpointDetailsPropertyValidator))(properties.endpointDetails)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDataflowEndpointGroupProps"');
    }
    function cfnDataflowEndpointGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataflowEndpointGroupPropsValidator(properties).assertSuccess(), { EndpointDetails: cdk.listMapper(cfnDataflowEndpointGroupEndpointDetailsPropertyToCloudFormation)(properties.endpointDetails), ContactPostPassDurationSeconds: cdk.numberToCloudFormation(properties.contactPostPassDurationSeconds), ContactPrePassDurationSeconds: cdk.numberToCloudFormation(properties.contactPrePassDurationSeconds), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDataflowEndpointGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endpointDetails", "EndpointDetails", cfn_parse.FromCloudFormation.getArray(CfnDataflowEndpointGroupEndpointDetailsPropertyFromCloudFormation)(properties.EndpointDetails)), ret.addPropertyResult("contactPostPassDurationSeconds", "ContactPostPassDurationSeconds", properties.ContactPostPassDurationSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.ContactPostPassDurationSeconds) : void 0), ret.addPropertyResult("contactPrePassDurationSeconds", "ContactPrePassDurationSeconds", properties.ContactPrePassDurationSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.ContactPrePassDurationSeconds) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDataflowEndpointGroup = class _CfnDataflowEndpointGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDataflowEndpointGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnDataflowEndpointGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDataflowEndpointGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_groundstation_CfnDataflowEndpointGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDataflowEndpointGroup), error;
        }
        cdk.requireProperty(props, "endpointDetails", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.endpointDetails = props.endpointDetails, this.contactPostPassDurationSeconds = props.contactPostPassDurationSeconds, this.contactPrePassDurationSeconds = props.contactPrePassDurationSeconds, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::GroundStation::DataflowEndpointGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDataflowEndpointGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { endpointDetails: this.endpointDetails, contactPostPassDurationSeconds: this.contactPostPassDurationSeconds, contactPrePassDurationSeconds: this.contactPrePassDurationSeconds, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDataflowEndpointGroupPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnDataflowEndpointGroup[_b] = { fqn: "aws-cdk-lib.aws_groundstation.CfnDataflowEndpointGroup", version: "2.80.0" }, CfnDataflowEndpointGroup.CFN_RESOURCE_TYPE_NAME = "AWS::GroundStation::DataflowEndpointGroup", exports2.CfnDataflowEndpointGroup = CfnDataflowEndpointGroup;
    function CfnDataflowEndpointGroup_AwsGroundStationAgentEndpointPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("agentStatus", cdk.validateString)(properties.agentStatus)), errors.collect(cdk.propertyValidator("auditResults", cdk.validateString)(properties.auditResults)), errors.collect(cdk.propertyValidator("egressAddress", CfnDataflowEndpointGroup_ConnectionDetailsPropertyValidator)(properties.egressAddress)), errors.collect(cdk.propertyValidator("ingressAddress", CfnDataflowEndpointGroup_RangedConnectionDetailsPropertyValidator)(properties.ingressAddress)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "AwsGroundStationAgentEndpointProperty"');
    }
    function cfnDataflowEndpointGroupAwsGroundStationAgentEndpointPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataflowEndpointGroup_AwsGroundStationAgentEndpointPropertyValidator(properties).assertSuccess(), { AgentStatus: cdk.stringToCloudFormation(properties.agentStatus), AuditResults: cdk.stringToCloudFormation(properties.auditResults), EgressAddress: cfnDataflowEndpointGroupConnectionDetailsPropertyToCloudFormation(properties.egressAddress), IngressAddress: cfnDataflowEndpointGroupRangedConnectionDetailsPropertyToCloudFormation(properties.ingressAddress), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnDataflowEndpointGroupAwsGroundStationAgentEndpointPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("agentStatus", "AgentStatus", properties.AgentStatus != null ? cfn_parse.FromCloudFormation.getString(properties.AgentStatus) : void 0), ret.addPropertyResult("auditResults", "AuditResults", properties.AuditResults != null ? cfn_parse.FromCloudFormation.getString(properties.AuditResults) : void 0), ret.addPropertyResult("egressAddress", "EgressAddress", properties.EgressAddress != null ? CfnDataflowEndpointGroupConnectionDetailsPropertyFromCloudFormation(properties.EgressAddress) : void 0), ret.addPropertyResult("ingressAddress", "IngressAddress", properties.IngressAddress != null ? CfnDataflowEndpointGroupRangedConnectionDetailsPropertyFromCloudFormation(properties.IngressAddress) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataflowEndpointGroup_ConnectionDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mtu", cdk.validateNumber)(properties.mtu)), errors.collect(cdk.propertyValidator("socketAddress", CfnDataflowEndpointGroup_SocketAddressPropertyValidator)(properties.socketAddress)), errors.wrap('supplied properties not correct for "ConnectionDetailsProperty"');
    }
    function cfnDataflowEndpointGroupConnectionDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataflowEndpointGroup_ConnectionDetailsPropertyValidator(properties).assertSuccess(), { Mtu: cdk.numberToCloudFormation(properties.mtu), SocketAddress: cfnDataflowEndpointGroupSocketAddressPropertyToCloudFormation(properties.socketAddress) }) : properties;
    }
    function CfnDataflowEndpointGroupConnectionDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mtu", "Mtu", properties.Mtu != null ? cfn_parse.FromCloudFormation.getNumber(properties.Mtu) : void 0), ret.addPropertyResult("socketAddress", "SocketAddress", properties.SocketAddress != null ? CfnDataflowEndpointGroupSocketAddressPropertyFromCloudFormation(properties.SocketAddress) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataflowEndpointGroup_DataflowEndpointPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("address", CfnDataflowEndpointGroup_SocketAddressPropertyValidator)(properties.address)), errors.collect(cdk.propertyValidator("mtu", cdk.validateNumber)(properties.mtu)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "DataflowEndpointProperty"');
    }
    function cfnDataflowEndpointGroupDataflowEndpointPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataflowEndpointGroup_DataflowEndpointPropertyValidator(properties).assertSuccess(), { Address: cfnDataflowEndpointGroupSocketAddressPropertyToCloudFormation(properties.address), Mtu: cdk.numberToCloudFormation(properties.mtu), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnDataflowEndpointGroupDataflowEndpointPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("address", "Address", properties.Address != null ? CfnDataflowEndpointGroupSocketAddressPropertyFromCloudFormation(properties.Address) : void 0), ret.addPropertyResult("mtu", "Mtu", properties.Mtu != null ? cfn_parse.FromCloudFormation.getNumber(properties.Mtu) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataflowEndpointGroup_EndpointDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("awsGroundStationAgentEndpoint", CfnDataflowEndpointGroup_AwsGroundStationAgentEndpointPropertyValidator)(properties.awsGroundStationAgentEndpoint)), errors.collect(cdk.propertyValidator("endpoint", CfnDataflowEndpointGroup_DataflowEndpointPropertyValidator)(properties.endpoint)), errors.collect(cdk.propertyValidator("securityDetails", CfnDataflowEndpointGroup_SecurityDetailsPropertyValidator)(properties.securityDetails)), errors.wrap('supplied properties not correct for "EndpointDetailsProperty"');
    }
    function cfnDataflowEndpointGroupEndpointDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataflowEndpointGroup_EndpointDetailsPropertyValidator(properties).assertSuccess(), { AwsGroundStationAgentEndpoint: cfnDataflowEndpointGroupAwsGroundStationAgentEndpointPropertyToCloudFormation(properties.awsGroundStationAgentEndpoint), Endpoint: cfnDataflowEndpointGroupDataflowEndpointPropertyToCloudFormation(properties.endpoint), SecurityDetails: cfnDataflowEndpointGroupSecurityDetailsPropertyToCloudFormation(properties.securityDetails) }) : properties;
    }
    function CfnDataflowEndpointGroupEndpointDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("awsGroundStationAgentEndpoint", "AwsGroundStationAgentEndpoint", properties.AwsGroundStationAgentEndpoint != null ? CfnDataflowEndpointGroupAwsGroundStationAgentEndpointPropertyFromCloudFormation(properties.AwsGroundStationAgentEndpoint) : void 0), ret.addPropertyResult("endpoint", "Endpoint", properties.Endpoint != null ? CfnDataflowEndpointGroupDataflowEndpointPropertyFromCloudFormation(properties.Endpoint) : void 0), ret.addPropertyResult("securityDetails", "SecurityDetails", properties.SecurityDetails != null ? CfnDataflowEndpointGroupSecurityDetailsPropertyFromCloudFormation(properties.SecurityDetails) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataflowEndpointGroup_IntegerRangePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maximum", cdk.validateNumber)(properties.maximum)), errors.collect(cdk.propertyValidator("minimum", cdk.validateNumber)(properties.minimum)), errors.wrap('supplied properties not correct for "IntegerRangeProperty"');
    }
    function cfnDataflowEndpointGroupIntegerRangePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataflowEndpointGroup_IntegerRangePropertyValidator(properties).assertSuccess(), { Maximum: cdk.numberToCloudFormation(properties.maximum), Minimum: cdk.numberToCloudFormation(properties.minimum) }) : properties;
    }
    function CfnDataflowEndpointGroupIntegerRangePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maximum", "Maximum", properties.Maximum != null ? cfn_parse.FromCloudFormation.getNumber(properties.Maximum) : void 0), ret.addPropertyResult("minimum", "Minimum", properties.Minimum != null ? cfn_parse.FromCloudFormation.getNumber(properties.Minimum) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataflowEndpointGroup_RangedConnectionDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mtu", cdk.validateNumber)(properties.mtu)), errors.collect(cdk.propertyValidator("socketAddress", CfnDataflowEndpointGroup_RangedSocketAddressPropertyValidator)(properties.socketAddress)), errors.wrap('supplied properties not correct for "RangedConnectionDetailsProperty"');
    }
    function cfnDataflowEndpointGroupRangedConnectionDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataflowEndpointGroup_RangedConnectionDetailsPropertyValidator(properties).assertSuccess(), { Mtu: cdk.numberToCloudFormation(properties.mtu), SocketAddress: cfnDataflowEndpointGroupRangedSocketAddressPropertyToCloudFormation(properties.socketAddress) }) : properties;
    }
    function CfnDataflowEndpointGroupRangedConnectionDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mtu", "Mtu", properties.Mtu != null ? cfn_parse.FromCloudFormation.getNumber(properties.Mtu) : void 0), ret.addPropertyResult("socketAddress", "SocketAddress", properties.SocketAddress != null ? CfnDataflowEndpointGroupRangedSocketAddressPropertyFromCloudFormation(properties.SocketAddress) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataflowEndpointGroup_RangedSocketAddressPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("portRange", CfnDataflowEndpointGroup_IntegerRangePropertyValidator)(properties.portRange)), errors.wrap('supplied properties not correct for "RangedSocketAddressProperty"');
    }
    function cfnDataflowEndpointGroupRangedSocketAddressPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataflowEndpointGroup_RangedSocketAddressPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), PortRange: cfnDataflowEndpointGroupIntegerRangePropertyToCloudFormation(properties.portRange) }) : properties;
    }
    function CfnDataflowEndpointGroupRangedSocketAddressPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("portRange", "PortRange", properties.PortRange != null ? CfnDataflowEndpointGroupIntegerRangePropertyFromCloudFormation(properties.PortRange) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataflowEndpointGroup_SecurityDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.wrap('supplied properties not correct for "SecurityDetailsProperty"');
    }
    function cfnDataflowEndpointGroupSecurityDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataflowEndpointGroup_SecurityDetailsPropertyValidator(properties).assertSuccess(), { RoleArn: cdk.stringToCloudFormation(properties.roleArn), SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds) }) : properties;
    }
    function CfnDataflowEndpointGroupSecurityDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("subnetIds", "SubnetIds", properties.SubnetIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataflowEndpointGroup_SocketAddressPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.wrap('supplied properties not correct for "SocketAddressProperty"');
    }
    function cfnDataflowEndpointGroupSocketAddressPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataflowEndpointGroup_SocketAddressPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Port: cdk.numberToCloudFormation(properties.port) }) : properties;
    }
    function CfnDataflowEndpointGroupSocketAddressPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMissionProfilePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contactPostPassDurationSeconds", cdk.validateNumber)(properties.contactPostPassDurationSeconds)), errors.collect(cdk.propertyValidator("contactPrePassDurationSeconds", cdk.validateNumber)(properties.contactPrePassDurationSeconds)), errors.collect(cdk.propertyValidator("dataflowEdges", cdk.requiredValidator)(properties.dataflowEdges)), errors.collect(cdk.propertyValidator("dataflowEdges", cdk.listValidator(CfnMissionProfile_DataflowEdgePropertyValidator))(properties.dataflowEdges)), errors.collect(cdk.propertyValidator("minimumViableContactDurationSeconds", cdk.requiredValidator)(properties.minimumViableContactDurationSeconds)), errors.collect(cdk.propertyValidator("minimumViableContactDurationSeconds", cdk.validateNumber)(properties.minimumViableContactDurationSeconds)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("streamsKmsKey", CfnMissionProfile_StreamsKmsKeyPropertyValidator)(properties.streamsKmsKey)), errors.collect(cdk.propertyValidator("streamsKmsRole", cdk.validateString)(properties.streamsKmsRole)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("trackingConfigArn", cdk.requiredValidator)(properties.trackingConfigArn)), errors.collect(cdk.propertyValidator("trackingConfigArn", cdk.validateString)(properties.trackingConfigArn)), errors.wrap('supplied properties not correct for "CfnMissionProfileProps"');
    }
    function cfnMissionProfilePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMissionProfilePropsValidator(properties).assertSuccess(), { DataflowEdges: cdk.listMapper(cfnMissionProfileDataflowEdgePropertyToCloudFormation)(properties.dataflowEdges), MinimumViableContactDurationSeconds: cdk.numberToCloudFormation(properties.minimumViableContactDurationSeconds), Name: cdk.stringToCloudFormation(properties.name), TrackingConfigArn: cdk.stringToCloudFormation(properties.trackingConfigArn), ContactPostPassDurationSeconds: cdk.numberToCloudFormation(properties.contactPostPassDurationSeconds), ContactPrePassDurationSeconds: cdk.numberToCloudFormation(properties.contactPrePassDurationSeconds), StreamsKmsKey: cfnMissionProfileStreamsKmsKeyPropertyToCloudFormation(properties.streamsKmsKey), StreamsKmsRole: cdk.stringToCloudFormation(properties.streamsKmsRole), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnMissionProfilePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataflowEdges", "DataflowEdges", cfn_parse.FromCloudFormation.getArray(CfnMissionProfileDataflowEdgePropertyFromCloudFormation)(properties.DataflowEdges)), ret.addPropertyResult("minimumViableContactDurationSeconds", "MinimumViableContactDurationSeconds", cfn_parse.FromCloudFormation.getNumber(properties.MinimumViableContactDurationSeconds)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("trackingConfigArn", "TrackingConfigArn", cfn_parse.FromCloudFormation.getString(properties.TrackingConfigArn)), ret.addPropertyResult("contactPostPassDurationSeconds", "ContactPostPassDurationSeconds", properties.ContactPostPassDurationSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.ContactPostPassDurationSeconds) : void 0), ret.addPropertyResult("contactPrePassDurationSeconds", "ContactPrePassDurationSeconds", properties.ContactPrePassDurationSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.ContactPrePassDurationSeconds) : void 0), ret.addPropertyResult("streamsKmsKey", "StreamsKmsKey", properties.StreamsKmsKey != null ? CfnMissionProfileStreamsKmsKeyPropertyFromCloudFormation(properties.StreamsKmsKey) : void 0), ret.addPropertyResult("streamsKmsRole", "StreamsKmsRole", properties.StreamsKmsRole != null ? cfn_parse.FromCloudFormation.getString(properties.StreamsKmsRole) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnMissionProfile = class _CfnMissionProfile extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnMissionProfilePropsFromCloudFormation(resourceProperties), ret = new _CfnMissionProfile(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnMissionProfile.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_groundstation_CfnMissionProfileProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnMissionProfile), error;
        }
        cdk.requireProperty(props, "dataflowEdges", this), cdk.requireProperty(props, "minimumViableContactDurationSeconds", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "trackingConfigArn", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrRegion = cdk.Token.asString(this.getAtt("Region", cdk.ResolutionTypeHint.STRING)), this.dataflowEdges = props.dataflowEdges, this.minimumViableContactDurationSeconds = props.minimumViableContactDurationSeconds, this.name = props.name, this.trackingConfigArn = props.trackingConfigArn, this.contactPostPassDurationSeconds = props.contactPostPassDurationSeconds, this.contactPrePassDurationSeconds = props.contactPrePassDurationSeconds, this.streamsKmsKey = props.streamsKmsKey, this.streamsKmsRole = props.streamsKmsRole, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::GroundStation::MissionProfile", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnMissionProfile.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { dataflowEdges: this.dataflowEdges, minimumViableContactDurationSeconds: this.minimumViableContactDurationSeconds, name: this.name, trackingConfigArn: this.trackingConfigArn, contactPostPassDurationSeconds: this.contactPostPassDurationSeconds, contactPrePassDurationSeconds: this.contactPrePassDurationSeconds, streamsKmsKey: this.streamsKmsKey, streamsKmsRole: this.streamsKmsRole, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnMissionProfilePropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnMissionProfile[_c] = { fqn: "aws-cdk-lib.aws_groundstation.CfnMissionProfile", version: "2.80.0" }, CfnMissionProfile.CFN_RESOURCE_TYPE_NAME = "AWS::GroundStation::MissionProfile", exports2.CfnMissionProfile = CfnMissionProfile;
    function CfnMissionProfile_DataflowEdgePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destination", cdk.validateString)(properties.destination)), errors.collect(cdk.propertyValidator("source", cdk.validateString)(properties.source)), errors.wrap('supplied properties not correct for "DataflowEdgeProperty"');
    }
    function cfnMissionProfileDataflowEdgePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMissionProfile_DataflowEdgePropertyValidator(properties).assertSuccess(), { Destination: cdk.stringToCloudFormation(properties.destination), Source: cdk.stringToCloudFormation(properties.source) }) : properties;
    }
    function CfnMissionProfileDataflowEdgePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destination", "Destination", properties.Destination != null ? cfn_parse.FromCloudFormation.getString(properties.Destination) : void 0), ret.addPropertyResult("source", "Source", properties.Source != null ? cfn_parse.FromCloudFormation.getString(properties.Source) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMissionProfile_StreamsKmsKeyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kmsAliasArn", cdk.validateString)(properties.kmsAliasArn)), errors.collect(cdk.propertyValidator("kmsKeyArn", cdk.validateString)(properties.kmsKeyArn)), errors.wrap('supplied properties not correct for "StreamsKmsKeyProperty"');
    }
    function cfnMissionProfileStreamsKmsKeyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMissionProfile_StreamsKmsKeyPropertyValidator(properties).assertSuccess(), { KmsAliasArn: cdk.stringToCloudFormation(properties.kmsAliasArn), KmsKeyArn: cdk.stringToCloudFormation(properties.kmsKeyArn) }) : properties;
    }
    function CfnMissionProfileStreamsKmsKeyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsAliasArn", "KmsAliasArn", properties.KmsAliasArn != null ? cfn_parse.FromCloudFormation.getString(properties.KmsAliasArn) : void 0), ret.addPropertyResult("kmsKeyArn", "KmsKeyArn", properties.KmsKeyArn != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-groundstation/lib/index.js
var require_lib141 = __commonJS({
  "node_modules/aws-cdk-lib/aws-groundstation/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_groundstation_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-groundstation/index.js
var require_aws_groundstation = __commonJS({
  "node_modules/aws-cdk-lib/aws-groundstation/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib141(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-guardduty/lib/guardduty.generated.js
var require_guardduty_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-guardduty/lib/guardduty.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnThreatIntelSet = exports2.CfnMember = exports2.CfnMaster = exports2.CfnIPSet = exports2.CfnFilter = exports2.CfnDetector = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnDetectorPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataSources", CfnDetector_CFNDataSourceConfigurationsPropertyValidator)(properties.dataSources)), errors.collect(cdk.propertyValidator("enable", cdk.requiredValidator)(properties.enable)), errors.collect(cdk.propertyValidator("enable", cdk.validateBoolean)(properties.enable)), errors.collect(cdk.propertyValidator("features", cdk.listValidator(CfnDetector_FeatureConfigurationsPropertyValidator))(properties.features)), errors.collect(cdk.propertyValidator("findingPublishingFrequency", cdk.validateString)(properties.findingPublishingFrequency)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDetectorProps"');
    }
    function cfnDetectorPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetectorPropsValidator(properties).assertSuccess(), { Enable: cdk.booleanToCloudFormation(properties.enable), DataSources: cfnDetectorCFNDataSourceConfigurationsPropertyToCloudFormation(properties.dataSources), Features: cdk.listMapper(cfnDetectorFeatureConfigurationsPropertyToCloudFormation)(properties.features), FindingPublishingFrequency: cdk.stringToCloudFormation(properties.findingPublishingFrequency), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDetectorPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enable", "Enable", cfn_parse.FromCloudFormation.getBoolean(properties.Enable)), ret.addPropertyResult("dataSources", "DataSources", properties.DataSources != null ? CfnDetectorCFNDataSourceConfigurationsPropertyFromCloudFormation(properties.DataSources) : void 0), ret.addPropertyResult("features", "Features", properties.Features != null ? cfn_parse.FromCloudFormation.getArray(CfnDetectorFeatureConfigurationsPropertyFromCloudFormation)(properties.Features) : void 0), ret.addPropertyResult("findingPublishingFrequency", "FindingPublishingFrequency", properties.FindingPublishingFrequency != null ? cfn_parse.FromCloudFormation.getString(properties.FindingPublishingFrequency) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDetector = class _CfnDetector extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDetectorPropsFromCloudFormation(resourceProperties), ret = new _CfnDetector(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDetector.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_guardduty_CfnDetectorProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDetector), error;
        }
        cdk.requireProperty(props, "enable", this), this.enable = props.enable, this.dataSources = props.dataSources, this.features = props.features, this.findingPublishingFrequency = props.findingPublishingFrequency, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::GuardDuty::Detector", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDetector.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { enable: this.enable, dataSources: this.dataSources, features: this.features, findingPublishingFrequency: this.findingPublishingFrequency, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDetectorPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnDetector[_a] = { fqn: "aws-cdk-lib.aws_guardduty.CfnDetector", version: "2.80.0" }, CfnDetector.CFN_RESOURCE_TYPE_NAME = "AWS::GuardDuty::Detector", exports2.CfnDetector = CfnDetector;
    function CfnDetector_CFNDataSourceConfigurationsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kubernetes", CfnDetector_CFNKubernetesConfigurationPropertyValidator)(properties.kubernetes)), errors.collect(cdk.propertyValidator("malwareProtection", CfnDetector_CFNMalwareProtectionConfigurationPropertyValidator)(properties.malwareProtection)), errors.collect(cdk.propertyValidator("s3Logs", CfnDetector_CFNS3LogsConfigurationPropertyValidator)(properties.s3Logs)), errors.wrap('supplied properties not correct for "CFNDataSourceConfigurationsProperty"');
    }
    function cfnDetectorCFNDataSourceConfigurationsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetector_CFNDataSourceConfigurationsPropertyValidator(properties).assertSuccess(), { Kubernetes: cfnDetectorCFNKubernetesConfigurationPropertyToCloudFormation(properties.kubernetes), MalwareProtection: cfnDetectorCFNMalwareProtectionConfigurationPropertyToCloudFormation(properties.malwareProtection), S3Logs: cfnDetectorCFNS3LogsConfigurationPropertyToCloudFormation(properties.s3Logs) }) : properties;
    }
    function CfnDetectorCFNDataSourceConfigurationsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kubernetes", "Kubernetes", properties.Kubernetes != null ? CfnDetectorCFNKubernetesConfigurationPropertyFromCloudFormation(properties.Kubernetes) : void 0), ret.addPropertyResult("malwareProtection", "MalwareProtection", properties.MalwareProtection != null ? CfnDetectorCFNMalwareProtectionConfigurationPropertyFromCloudFormation(properties.MalwareProtection) : void 0), ret.addPropertyResult("s3Logs", "S3Logs", properties.S3Logs != null ? CfnDetectorCFNS3LogsConfigurationPropertyFromCloudFormation(properties.S3Logs) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetector_CFNKubernetesAuditLogsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enable", cdk.validateBoolean)(properties.enable)), errors.wrap('supplied properties not correct for "CFNKubernetesAuditLogsConfigurationProperty"');
    }
    function cfnDetectorCFNKubernetesAuditLogsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetector_CFNKubernetesAuditLogsConfigurationPropertyValidator(properties).assertSuccess(), { Enable: cdk.booleanToCloudFormation(properties.enable) }) : properties;
    }
    function CfnDetectorCFNKubernetesAuditLogsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enable", "Enable", properties.Enable != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enable) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetector_CFNKubernetesConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("auditLogs", CfnDetector_CFNKubernetesAuditLogsConfigurationPropertyValidator)(properties.auditLogs)), errors.wrap('supplied properties not correct for "CFNKubernetesConfigurationProperty"');
    }
    function cfnDetectorCFNKubernetesConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetector_CFNKubernetesConfigurationPropertyValidator(properties).assertSuccess(), { AuditLogs: cfnDetectorCFNKubernetesAuditLogsConfigurationPropertyToCloudFormation(properties.auditLogs) }) : properties;
    }
    function CfnDetectorCFNKubernetesConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("auditLogs", "AuditLogs", properties.AuditLogs != null ? CfnDetectorCFNKubernetesAuditLogsConfigurationPropertyFromCloudFormation(properties.AuditLogs) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetector_CFNMalwareProtectionConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("scanEc2InstanceWithFindings", CfnDetector_CFNScanEc2InstanceWithFindingsConfigurationPropertyValidator)(properties.scanEc2InstanceWithFindings)), errors.wrap('supplied properties not correct for "CFNMalwareProtectionConfigurationProperty"');
    }
    function cfnDetectorCFNMalwareProtectionConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetector_CFNMalwareProtectionConfigurationPropertyValidator(properties).assertSuccess(), { ScanEc2InstanceWithFindings: cfnDetectorCFNScanEc2InstanceWithFindingsConfigurationPropertyToCloudFormation(properties.scanEc2InstanceWithFindings) }) : properties;
    }
    function CfnDetectorCFNMalwareProtectionConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("scanEc2InstanceWithFindings", "ScanEc2InstanceWithFindings", properties.ScanEc2InstanceWithFindings != null ? CfnDetectorCFNScanEc2InstanceWithFindingsConfigurationPropertyFromCloudFormation(properties.ScanEc2InstanceWithFindings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetector_CFNS3LogsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enable", cdk.validateBoolean)(properties.enable)), errors.wrap('supplied properties not correct for "CFNS3LogsConfigurationProperty"');
    }
    function cfnDetectorCFNS3LogsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetector_CFNS3LogsConfigurationPropertyValidator(properties).assertSuccess(), { Enable: cdk.booleanToCloudFormation(properties.enable) }) : properties;
    }
    function CfnDetectorCFNS3LogsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enable", "Enable", properties.Enable != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enable) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetector_CFNScanEc2InstanceWithFindingsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ebsVolumes", cdk.validateBoolean)(properties.ebsVolumes)), errors.wrap('supplied properties not correct for "CFNScanEc2InstanceWithFindingsConfigurationProperty"');
    }
    function cfnDetectorCFNScanEc2InstanceWithFindingsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetector_CFNScanEc2InstanceWithFindingsConfigurationPropertyValidator(properties).assertSuccess(), { EbsVolumes: cdk.booleanToCloudFormation(properties.ebsVolumes) }) : properties;
    }
    function CfnDetectorCFNScanEc2InstanceWithFindingsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ebsVolumes", "EbsVolumes", properties.EbsVolumes != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EbsVolumes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetector_FeatureAdditionalConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "FeatureAdditionalConfigurationProperty"');
    }
    function cfnDetectorFeatureAdditionalConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetector_FeatureAdditionalConfigurationPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnDetectorFeatureAdditionalConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetector_FeatureConfigurationsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("additionalConfiguration", cdk.listValidator(CfnDetector_FeatureAdditionalConfigurationPropertyValidator))(properties.additionalConfiguration)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "FeatureConfigurationsProperty"');
    }
    function cfnDetectorFeatureConfigurationsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetector_FeatureConfigurationsPropertyValidator(properties).assertSuccess(), { AdditionalConfiguration: cdk.listMapper(cfnDetectorFeatureAdditionalConfigurationPropertyToCloudFormation)(properties.additionalConfiguration), Name: cdk.stringToCloudFormation(properties.name), Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnDetectorFeatureConfigurationsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("additionalConfiguration", "AdditionalConfiguration", properties.AdditionalConfiguration != null ? cfn_parse.FromCloudFormation.getArray(CfnDetectorFeatureAdditionalConfigurationPropertyFromCloudFormation)(properties.AdditionalConfiguration) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFilterPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.requiredValidator)(properties.action)), errors.collect(cdk.propertyValidator("action", cdk.validateString)(properties.action)), errors.collect(cdk.propertyValidator("description", cdk.requiredValidator)(properties.description)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("detectorId", cdk.requiredValidator)(properties.detectorId)), errors.collect(cdk.propertyValidator("detectorId", cdk.validateString)(properties.detectorId)), errors.collect(cdk.propertyValidator("findingCriteria", cdk.requiredValidator)(properties.findingCriteria)), errors.collect(cdk.propertyValidator("findingCriteria", CfnFilter_FindingCriteriaPropertyValidator)(properties.findingCriteria)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("rank", cdk.requiredValidator)(properties.rank)), errors.collect(cdk.propertyValidator("rank", cdk.validateNumber)(properties.rank)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnFilterProps"');
    }
    function cfnFilterPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFilterPropsValidator(properties).assertSuccess(), { Action: cdk.stringToCloudFormation(properties.action), Description: cdk.stringToCloudFormation(properties.description), DetectorId: cdk.stringToCloudFormation(properties.detectorId), FindingCriteria: cfnFilterFindingCriteriaPropertyToCloudFormation(properties.findingCriteria), Name: cdk.stringToCloudFormation(properties.name), Rank: cdk.numberToCloudFormation(properties.rank), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnFilterPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", cfn_parse.FromCloudFormation.getString(properties.Action)), ret.addPropertyResult("description", "Description", cfn_parse.FromCloudFormation.getString(properties.Description)), ret.addPropertyResult("detectorId", "DetectorId", cfn_parse.FromCloudFormation.getString(properties.DetectorId)), ret.addPropertyResult("findingCriteria", "FindingCriteria", CfnFilterFindingCriteriaPropertyFromCloudFormation(properties.FindingCriteria)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("rank", "Rank", cfn_parse.FromCloudFormation.getNumber(properties.Rank)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFilter = class _CfnFilter extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFilterPropsFromCloudFormation(resourceProperties), ret = new _CfnFilter(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFilter.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_guardduty_CfnFilterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFilter), error;
        }
        cdk.requireProperty(props, "action", this), cdk.requireProperty(props, "description", this), cdk.requireProperty(props, "detectorId", this), cdk.requireProperty(props, "findingCriteria", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "rank", this), this.action = props.action, this.description = props.description, this.detectorId = props.detectorId, this.findingCriteria = props.findingCriteria, this.name = props.name, this.rank = props.rank, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::GuardDuty::Filter", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFilter.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { action: this.action, description: this.description, detectorId: this.detectorId, findingCriteria: this.findingCriteria, name: this.name, rank: this.rank, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnFilterPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnFilter[_b] = { fqn: "aws-cdk-lib.aws_guardduty.CfnFilter", version: "2.80.0" }, CfnFilter.CFN_RESOURCE_TYPE_NAME = "AWS::GuardDuty::Filter", exports2.CfnFilter = CfnFilter;
    function CfnFilter_ConditionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("eq", cdk.listValidator(cdk.validateString))(properties.eq)), errors.collect(cdk.propertyValidator("equalTo", cdk.listValidator(cdk.validateString))(properties.equalTo)), errors.collect(cdk.propertyValidator("greaterThan", cdk.validateNumber)(properties.greaterThan)), errors.collect(cdk.propertyValidator("greaterThanOrEqual", cdk.validateNumber)(properties.greaterThanOrEqual)), errors.collect(cdk.propertyValidator("gt", cdk.validateNumber)(properties.gt)), errors.collect(cdk.propertyValidator("gte", cdk.validateNumber)(properties.gte)), errors.collect(cdk.propertyValidator("lessThan", cdk.validateNumber)(properties.lessThan)), errors.collect(cdk.propertyValidator("lessThanOrEqual", cdk.validateNumber)(properties.lessThanOrEqual)), errors.collect(cdk.propertyValidator("lt", cdk.validateNumber)(properties.lt)), errors.collect(cdk.propertyValidator("lte", cdk.validateNumber)(properties.lte)), errors.collect(cdk.propertyValidator("neq", cdk.listValidator(cdk.validateString))(properties.neq)), errors.collect(cdk.propertyValidator("notEquals", cdk.listValidator(cdk.validateString))(properties.notEquals)), errors.wrap('supplied properties not correct for "ConditionProperty"');
    }
    function cfnFilterConditionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFilter_ConditionPropertyValidator(properties).assertSuccess(), { Eq: cdk.listMapper(cdk.stringToCloudFormation)(properties.eq), Equals: cdk.listMapper(cdk.stringToCloudFormation)(properties.equalTo), GreaterThan: cdk.numberToCloudFormation(properties.greaterThan), GreaterThanOrEqual: cdk.numberToCloudFormation(properties.greaterThanOrEqual), Gt: cdk.numberToCloudFormation(properties.gt), Gte: cdk.numberToCloudFormation(properties.gte), LessThan: cdk.numberToCloudFormation(properties.lessThan), LessThanOrEqual: cdk.numberToCloudFormation(properties.lessThanOrEqual), Lt: cdk.numberToCloudFormation(properties.lt), Lte: cdk.numberToCloudFormation(properties.lte), Neq: cdk.listMapper(cdk.stringToCloudFormation)(properties.neq), NotEquals: cdk.listMapper(cdk.stringToCloudFormation)(properties.notEquals) }) : properties;
    }
    function CfnFilterConditionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("eq", "Eq", properties.Eq != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Eq) : void 0), ret.addPropertyResult("equalTo", "Equals", properties.Equals != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Equals) : void 0), ret.addPropertyResult("greaterThan", "GreaterThan", properties.GreaterThan != null ? cfn_parse.FromCloudFormation.getNumber(properties.GreaterThan) : void 0), ret.addPropertyResult("greaterThanOrEqual", "GreaterThanOrEqual", properties.GreaterThanOrEqual != null ? cfn_parse.FromCloudFormation.getNumber(properties.GreaterThanOrEqual) : void 0), ret.addPropertyResult("gt", "Gt", properties.Gt != null ? cfn_parse.FromCloudFormation.getNumber(properties.Gt) : void 0), ret.addPropertyResult("gte", "Gte", properties.Gte != null ? cfn_parse.FromCloudFormation.getNumber(properties.Gte) : void 0), ret.addPropertyResult("lessThan", "LessThan", properties.LessThan != null ? cfn_parse.FromCloudFormation.getNumber(properties.LessThan) : void 0), ret.addPropertyResult("lessThanOrEqual", "LessThanOrEqual", properties.LessThanOrEqual != null ? cfn_parse.FromCloudFormation.getNumber(properties.LessThanOrEqual) : void 0), ret.addPropertyResult("lt", "Lt", properties.Lt != null ? cfn_parse.FromCloudFormation.getNumber(properties.Lt) : void 0), ret.addPropertyResult("lte", "Lte", properties.Lte != null ? cfn_parse.FromCloudFormation.getNumber(properties.Lte) : void 0), ret.addPropertyResult("neq", "Neq", properties.Neq != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Neq) : void 0), ret.addPropertyResult("notEquals", "NotEquals", properties.NotEquals != null ? cfn_parse.FromCloudFormation.getStringArray(properties.NotEquals) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFilter_FindingCriteriaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("criterion", cdk.validateObject)(properties.criterion)), errors.collect(cdk.propertyValidator("itemType", CfnFilter_ConditionPropertyValidator)(properties.itemType)), errors.wrap('supplied properties not correct for "FindingCriteriaProperty"');
    }
    function cfnFilterFindingCriteriaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFilter_FindingCriteriaPropertyValidator(properties).assertSuccess(), { Criterion: cdk.objectToCloudFormation(properties.criterion), ItemType: cfnFilterConditionPropertyToCloudFormation(properties.itemType) }) : properties;
    }
    function CfnFilterFindingCriteriaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("criterion", "Criterion", properties.Criterion != null ? cfn_parse.FromCloudFormation.getAny(properties.Criterion) : void 0), ret.addPropertyResult("itemType", "ItemType", properties.ItemType != null ? CfnFilterConditionPropertyFromCloudFormation(properties.ItemType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIPSetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("activate", cdk.requiredValidator)(properties.activate)), errors.collect(cdk.propertyValidator("activate", cdk.validateBoolean)(properties.activate)), errors.collect(cdk.propertyValidator("detectorId", cdk.requiredValidator)(properties.detectorId)), errors.collect(cdk.propertyValidator("detectorId", cdk.validateString)(properties.detectorId)), errors.collect(cdk.propertyValidator("format", cdk.requiredValidator)(properties.format)), errors.collect(cdk.propertyValidator("format", cdk.validateString)(properties.format)), errors.collect(cdk.propertyValidator("location", cdk.requiredValidator)(properties.location)), errors.collect(cdk.propertyValidator("location", cdk.validateString)(properties.location)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnIPSetProps"');
    }
    function cfnIPSetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIPSetPropsValidator(properties).assertSuccess(), { Activate: cdk.booleanToCloudFormation(properties.activate), DetectorId: cdk.stringToCloudFormation(properties.detectorId), Format: cdk.stringToCloudFormation(properties.format), Location: cdk.stringToCloudFormation(properties.location), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnIPSetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("activate", "Activate", cfn_parse.FromCloudFormation.getBoolean(properties.Activate)), ret.addPropertyResult("detectorId", "DetectorId", cfn_parse.FromCloudFormation.getString(properties.DetectorId)), ret.addPropertyResult("format", "Format", cfn_parse.FromCloudFormation.getString(properties.Format)), ret.addPropertyResult("location", "Location", cfn_parse.FromCloudFormation.getString(properties.Location)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnIPSet = class _CfnIPSet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnIPSetPropsFromCloudFormation(resourceProperties), ret = new _CfnIPSet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnIPSet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_guardduty_CfnIPSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnIPSet), error;
        }
        cdk.requireProperty(props, "activate", this), cdk.requireProperty(props, "detectorId", this), cdk.requireProperty(props, "format", this), cdk.requireProperty(props, "location", this), this.activate = props.activate, this.detectorId = props.detectorId, this.format = props.format, this.location = props.location, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::GuardDuty::IPSet", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnIPSet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { activate: this.activate, detectorId: this.detectorId, format: this.format, location: this.location, name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnIPSetPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnIPSet[_c] = { fqn: "aws-cdk-lib.aws_guardduty.CfnIPSet", version: "2.80.0" }, CfnIPSet.CFN_RESOURCE_TYPE_NAME = "AWS::GuardDuty::IPSet", exports2.CfnIPSet = CfnIPSet;
    function CfnMasterPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("detectorId", cdk.requiredValidator)(properties.detectorId)), errors.collect(cdk.propertyValidator("detectorId", cdk.validateString)(properties.detectorId)), errors.collect(cdk.propertyValidator("invitationId", cdk.validateString)(properties.invitationId)), errors.collect(cdk.propertyValidator("masterId", cdk.requiredValidator)(properties.masterId)), errors.collect(cdk.propertyValidator("masterId", cdk.validateString)(properties.masterId)), errors.wrap('supplied properties not correct for "CfnMasterProps"');
    }
    function cfnMasterPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMasterPropsValidator(properties).assertSuccess(), { DetectorId: cdk.stringToCloudFormation(properties.detectorId), MasterId: cdk.stringToCloudFormation(properties.masterId), InvitationId: cdk.stringToCloudFormation(properties.invitationId) }) : properties;
    }
    function CfnMasterPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("detectorId", "DetectorId", cfn_parse.FromCloudFormation.getString(properties.DetectorId)), ret.addPropertyResult("masterId", "MasterId", cfn_parse.FromCloudFormation.getString(properties.MasterId)), ret.addPropertyResult("invitationId", "InvitationId", properties.InvitationId != null ? cfn_parse.FromCloudFormation.getString(properties.InvitationId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnMaster = class _CfnMaster extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnMasterPropsFromCloudFormation(resourceProperties), ret = new _CfnMaster(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnMaster.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_guardduty_CfnMasterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnMaster), error;
        }
        cdk.requireProperty(props, "detectorId", this), cdk.requireProperty(props, "masterId", this), this.detectorId = props.detectorId, this.masterId = props.masterId, this.invitationId = props.invitationId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnMaster.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { detectorId: this.detectorId, masterId: this.masterId, invitationId: this.invitationId };
      }
      renderProperties(props) {
        return cfnMasterPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnMaster[_d] = { fqn: "aws-cdk-lib.aws_guardduty.CfnMaster", version: "2.80.0" }, CfnMaster.CFN_RESOURCE_TYPE_NAME = "AWS::GuardDuty::Master", exports2.CfnMaster = CfnMaster;
    function CfnMemberPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("detectorId", cdk.requiredValidator)(properties.detectorId)), errors.collect(cdk.propertyValidator("detectorId", cdk.validateString)(properties.detectorId)), errors.collect(cdk.propertyValidator("disableEmailNotification", cdk.validateBoolean)(properties.disableEmailNotification)), errors.collect(cdk.propertyValidator("email", cdk.requiredValidator)(properties.email)), errors.collect(cdk.propertyValidator("email", cdk.validateString)(properties.email)), errors.collect(cdk.propertyValidator("memberId", cdk.requiredValidator)(properties.memberId)), errors.collect(cdk.propertyValidator("memberId", cdk.validateString)(properties.memberId)), errors.collect(cdk.propertyValidator("message", cdk.validateString)(properties.message)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "CfnMemberProps"');
    }
    function cfnMemberPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMemberPropsValidator(properties).assertSuccess(), { DetectorId: cdk.stringToCloudFormation(properties.detectorId), Email: cdk.stringToCloudFormation(properties.email), MemberId: cdk.stringToCloudFormation(properties.memberId), DisableEmailNotification: cdk.booleanToCloudFormation(properties.disableEmailNotification), Message: cdk.stringToCloudFormation(properties.message), Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnMemberPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("detectorId", "DetectorId", cfn_parse.FromCloudFormation.getString(properties.DetectorId)), ret.addPropertyResult("email", "Email", cfn_parse.FromCloudFormation.getString(properties.Email)), ret.addPropertyResult("memberId", "MemberId", cfn_parse.FromCloudFormation.getString(properties.MemberId)), ret.addPropertyResult("disableEmailNotification", "DisableEmailNotification", properties.DisableEmailNotification != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DisableEmailNotification) : void 0), ret.addPropertyResult("message", "Message", properties.Message != null ? cfn_parse.FromCloudFormation.getString(properties.Message) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnMember = class _CfnMember extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnMemberPropsFromCloudFormation(resourceProperties), ret = new _CfnMember(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnMember.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_guardduty_CfnMemberProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnMember), error;
        }
        cdk.requireProperty(props, "detectorId", this), cdk.requireProperty(props, "email", this), cdk.requireProperty(props, "memberId", this), this.detectorId = props.detectorId, this.email = props.email, this.memberId = props.memberId, this.disableEmailNotification = props.disableEmailNotification, this.message = props.message, this.status = props.status;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnMember.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { detectorId: this.detectorId, email: this.email, memberId: this.memberId, disableEmailNotification: this.disableEmailNotification, message: this.message, status: this.status };
      }
      renderProperties(props) {
        return cfnMemberPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnMember[_e] = { fqn: "aws-cdk-lib.aws_guardduty.CfnMember", version: "2.80.0" }, CfnMember.CFN_RESOURCE_TYPE_NAME = "AWS::GuardDuty::Member", exports2.CfnMember = CfnMember;
    function CfnThreatIntelSetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("activate", cdk.requiredValidator)(properties.activate)), errors.collect(cdk.propertyValidator("activate", cdk.validateBoolean)(properties.activate)), errors.collect(cdk.propertyValidator("detectorId", cdk.requiredValidator)(properties.detectorId)), errors.collect(cdk.propertyValidator("detectorId", cdk.validateString)(properties.detectorId)), errors.collect(cdk.propertyValidator("format", cdk.requiredValidator)(properties.format)), errors.collect(cdk.propertyValidator("format", cdk.validateString)(properties.format)), errors.collect(cdk.propertyValidator("location", cdk.requiredValidator)(properties.location)), errors.collect(cdk.propertyValidator("location", cdk.validateString)(properties.location)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnThreatIntelSetProps"');
    }
    function cfnThreatIntelSetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnThreatIntelSetPropsValidator(properties).assertSuccess(), { Activate: cdk.booleanToCloudFormation(properties.activate), DetectorId: cdk.stringToCloudFormation(properties.detectorId), Format: cdk.stringToCloudFormation(properties.format), Location: cdk.stringToCloudFormation(properties.location), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnThreatIntelSetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("activate", "Activate", cfn_parse.FromCloudFormation.getBoolean(properties.Activate)), ret.addPropertyResult("detectorId", "DetectorId", cfn_parse.FromCloudFormation.getString(properties.DetectorId)), ret.addPropertyResult("format", "Format", cfn_parse.FromCloudFormation.getString(properties.Format)), ret.addPropertyResult("location", "Location", cfn_parse.FromCloudFormation.getString(properties.Location)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnThreatIntelSet = class _CfnThreatIntelSet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnThreatIntelSetPropsFromCloudFormation(resourceProperties), ret = new _CfnThreatIntelSet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnThreatIntelSet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_guardduty_CfnThreatIntelSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnThreatIntelSet), error;
        }
        cdk.requireProperty(props, "activate", this), cdk.requireProperty(props, "detectorId", this), cdk.requireProperty(props, "format", this), cdk.requireProperty(props, "location", this), this.activate = props.activate, this.detectorId = props.detectorId, this.format = props.format, this.location = props.location, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::GuardDuty::ThreatIntelSet", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnThreatIntelSet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { activate: this.activate, detectorId: this.detectorId, format: this.format, location: this.location, name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnThreatIntelSetPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnThreatIntelSet[_f] = { fqn: "aws-cdk-lib.aws_guardduty.CfnThreatIntelSet", version: "2.80.0" }, CfnThreatIntelSet.CFN_RESOURCE_TYPE_NAME = "AWS::GuardDuty::ThreatIntelSet", exports2.CfnThreatIntelSet = CfnThreatIntelSet;
  }
});

// node_modules/aws-cdk-lib/aws-guardduty/lib/index.js
var require_lib142 = __commonJS({
  "node_modules/aws-cdk-lib/aws-guardduty/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_guardduty_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-guardduty/index.js
var require_aws_guardduty = __commonJS({
  "node_modules/aws-cdk-lib/aws-guardduty/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib142(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-healthlake/lib/healthlake.generated.js
var require_healthlake_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-healthlake/lib/healthlake.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnFHIRDatastore = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnFHIRDatastorePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("datastoreName", cdk.validateString)(properties.datastoreName)), errors.collect(cdk.propertyValidator("datastoreTypeVersion", cdk.requiredValidator)(properties.datastoreTypeVersion)), errors.collect(cdk.propertyValidator("datastoreTypeVersion", cdk.validateString)(properties.datastoreTypeVersion)), errors.collect(cdk.propertyValidator("preloadDataConfig", CfnFHIRDatastore_PreloadDataConfigPropertyValidator)(properties.preloadDataConfig)), errors.collect(cdk.propertyValidator("sseConfiguration", CfnFHIRDatastore_SseConfigurationPropertyValidator)(properties.sseConfiguration)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnFHIRDatastoreProps"');
    }
    function cfnFHIRDatastorePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFHIRDatastorePropsValidator(properties).assertSuccess(), { DatastoreTypeVersion: cdk.stringToCloudFormation(properties.datastoreTypeVersion), DatastoreName: cdk.stringToCloudFormation(properties.datastoreName), PreloadDataConfig: cfnFHIRDatastorePreloadDataConfigPropertyToCloudFormation(properties.preloadDataConfig), SseConfiguration: cfnFHIRDatastoreSseConfigurationPropertyToCloudFormation(properties.sseConfiguration), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnFHIRDatastorePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("datastoreTypeVersion", "DatastoreTypeVersion", cfn_parse.FromCloudFormation.getString(properties.DatastoreTypeVersion)), ret.addPropertyResult("datastoreName", "DatastoreName", properties.DatastoreName != null ? cfn_parse.FromCloudFormation.getString(properties.DatastoreName) : void 0), ret.addPropertyResult("preloadDataConfig", "PreloadDataConfig", properties.PreloadDataConfig != null ? CfnFHIRDatastorePreloadDataConfigPropertyFromCloudFormation(properties.PreloadDataConfig) : void 0), ret.addPropertyResult("sseConfiguration", "SseConfiguration", properties.SseConfiguration != null ? CfnFHIRDatastoreSseConfigurationPropertyFromCloudFormation(properties.SseConfiguration) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFHIRDatastore = class _CfnFHIRDatastore extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFHIRDatastorePropsFromCloudFormation(resourceProperties), ret = new _CfnFHIRDatastore(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFHIRDatastore.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_healthlake_CfnFHIRDatastoreProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFHIRDatastore), error;
        }
        cdk.requireProperty(props, "datastoreTypeVersion", this), this.attrCreatedAtNanos = cdk.Token.asNumber(this.getAtt("CreatedAt.Nanos", cdk.ResolutionTypeHint.NUMBER)), this.attrCreatedAtSeconds = cdk.Token.asString(this.getAtt("CreatedAt.Seconds", cdk.ResolutionTypeHint.STRING)), this.attrDatastoreArn = cdk.Token.asString(this.getAtt("DatastoreArn", cdk.ResolutionTypeHint.STRING)), this.attrDatastoreEndpoint = cdk.Token.asString(this.getAtt("DatastoreEndpoint", cdk.ResolutionTypeHint.STRING)), this.attrDatastoreId = cdk.Token.asString(this.getAtt("DatastoreId", cdk.ResolutionTypeHint.STRING)), this.attrDatastoreStatus = cdk.Token.asString(this.getAtt("DatastoreStatus", cdk.ResolutionTypeHint.STRING)), this.datastoreTypeVersion = props.datastoreTypeVersion, this.datastoreName = props.datastoreName, this.preloadDataConfig = props.preloadDataConfig, this.sseConfiguration = props.sseConfiguration, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::HealthLake::FHIRDatastore", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFHIRDatastore.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { datastoreTypeVersion: this.datastoreTypeVersion, datastoreName: this.datastoreName, preloadDataConfig: this.preloadDataConfig, sseConfiguration: this.sseConfiguration, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnFHIRDatastorePropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnFHIRDatastore[_a] = { fqn: "aws-cdk-lib.aws_healthlake.CfnFHIRDatastore", version: "2.80.0" }, CfnFHIRDatastore.CFN_RESOURCE_TYPE_NAME = "AWS::HealthLake::FHIRDatastore", exports2.CfnFHIRDatastore = CfnFHIRDatastore;
    function CfnFHIRDatastore_KmsEncryptionConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cmkType", cdk.requiredValidator)(properties.cmkType)), errors.collect(cdk.propertyValidator("cmkType", cdk.validateString)(properties.cmkType)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.wrap('supplied properties not correct for "KmsEncryptionConfigProperty"');
    }
    function cfnFHIRDatastoreKmsEncryptionConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFHIRDatastore_KmsEncryptionConfigPropertyValidator(properties).assertSuccess(), { CmkType: cdk.stringToCloudFormation(properties.cmkType), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId) }) : properties;
    }
    function CfnFHIRDatastoreKmsEncryptionConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cmkType", "CmkType", cfn_parse.FromCloudFormation.getString(properties.CmkType)), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFHIRDatastore_PreloadDataConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("preloadDataType", cdk.requiredValidator)(properties.preloadDataType)), errors.collect(cdk.propertyValidator("preloadDataType", cdk.validateString)(properties.preloadDataType)), errors.wrap('supplied properties not correct for "PreloadDataConfigProperty"');
    }
    function cfnFHIRDatastorePreloadDataConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFHIRDatastore_PreloadDataConfigPropertyValidator(properties).assertSuccess(), { PreloadDataType: cdk.stringToCloudFormation(properties.preloadDataType) }) : properties;
    }
    function CfnFHIRDatastorePreloadDataConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("preloadDataType", "PreloadDataType", cfn_parse.FromCloudFormation.getString(properties.PreloadDataType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFHIRDatastore_SseConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kmsEncryptionConfig", cdk.requiredValidator)(properties.kmsEncryptionConfig)), errors.collect(cdk.propertyValidator("kmsEncryptionConfig", CfnFHIRDatastore_KmsEncryptionConfigPropertyValidator)(properties.kmsEncryptionConfig)), errors.wrap('supplied properties not correct for "SseConfigurationProperty"');
    }
    function cfnFHIRDatastoreSseConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFHIRDatastore_SseConfigurationPropertyValidator(properties).assertSuccess(), { KmsEncryptionConfig: cfnFHIRDatastoreKmsEncryptionConfigPropertyToCloudFormation(properties.kmsEncryptionConfig) }) : properties;
    }
    function CfnFHIRDatastoreSseConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsEncryptionConfig", "KmsEncryptionConfig", CfnFHIRDatastoreKmsEncryptionConfigPropertyFromCloudFormation(properties.KmsEncryptionConfig)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-healthlake/lib/index.js
var require_lib143 = __commonJS({
  "node_modules/aws-cdk-lib/aws-healthlake/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_healthlake_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-healthlake/index.js
var require_aws_healthlake = __commonJS({
  "node_modules/aws-cdk-lib/aws-healthlake/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib143(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-identitystore/lib/identitystore.generated.js
var require_identitystore_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-identitystore/lib/identitystore.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnGroupMembership = exports2.CfnGroup = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("displayName", cdk.requiredValidator)(properties.displayName)), errors.collect(cdk.propertyValidator("displayName", cdk.validateString)(properties.displayName)), errors.collect(cdk.propertyValidator("identityStoreId", cdk.requiredValidator)(properties.identityStoreId)), errors.collect(cdk.propertyValidator("identityStoreId", cdk.validateString)(properties.identityStoreId)), errors.wrap('supplied properties not correct for "CfnGroupProps"');
    }
    function cfnGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGroupPropsValidator(properties).assertSuccess(), { DisplayName: cdk.stringToCloudFormation(properties.displayName), IdentityStoreId: cdk.stringToCloudFormation(properties.identityStoreId), Description: cdk.stringToCloudFormation(properties.description) }) : properties;
    }
    function CfnGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("displayName", "DisplayName", cfn_parse.FromCloudFormation.getString(properties.DisplayName)), ret.addPropertyResult("identityStoreId", "IdentityStoreId", cfn_parse.FromCloudFormation.getString(properties.IdentityStoreId)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnGroup = class _CfnGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_identitystore_CfnGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnGroup), error;
        }
        cdk.requireProperty(props, "displayName", this), cdk.requireProperty(props, "identityStoreId", this), this.attrGroupId = cdk.Token.asString(this.getAtt("GroupId", cdk.ResolutionTypeHint.STRING)), this.displayName = props.displayName, this.identityStoreId = props.identityStoreId, this.description = props.description;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { displayName: this.displayName, identityStoreId: this.identityStoreId, description: this.description };
      }
      renderProperties(props) {
        return cfnGroupPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnGroup[_a] = { fqn: "aws-cdk-lib.aws_identitystore.CfnGroup", version: "2.80.0" }, CfnGroup.CFN_RESOURCE_TYPE_NAME = "AWS::IdentityStore::Group", exports2.CfnGroup = CfnGroup;
    function CfnGroupMembershipPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groupId", cdk.requiredValidator)(properties.groupId)), errors.collect(cdk.propertyValidator("groupId", cdk.validateString)(properties.groupId)), errors.collect(cdk.propertyValidator("identityStoreId", cdk.requiredValidator)(properties.identityStoreId)), errors.collect(cdk.propertyValidator("identityStoreId", cdk.validateString)(properties.identityStoreId)), errors.collect(cdk.propertyValidator("memberId", cdk.requiredValidator)(properties.memberId)), errors.collect(cdk.propertyValidator("memberId", CfnGroupMembership_MemberIdPropertyValidator)(properties.memberId)), errors.wrap('supplied properties not correct for "CfnGroupMembershipProps"');
    }
    function cfnGroupMembershipPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGroupMembershipPropsValidator(properties).assertSuccess(), { GroupId: cdk.stringToCloudFormation(properties.groupId), IdentityStoreId: cdk.stringToCloudFormation(properties.identityStoreId), MemberId: cfnGroupMembershipMemberIdPropertyToCloudFormation(properties.memberId) }) : properties;
    }
    function CfnGroupMembershipPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupId", "GroupId", cfn_parse.FromCloudFormation.getString(properties.GroupId)), ret.addPropertyResult("identityStoreId", "IdentityStoreId", cfn_parse.FromCloudFormation.getString(properties.IdentityStoreId)), ret.addPropertyResult("memberId", "MemberId", CfnGroupMembershipMemberIdPropertyFromCloudFormation(properties.MemberId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnGroupMembership = class _CfnGroupMembership extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnGroupMembershipPropsFromCloudFormation(resourceProperties), ret = new _CfnGroupMembership(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnGroupMembership.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_identitystore_CfnGroupMembershipProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnGroupMembership), error;
        }
        cdk.requireProperty(props, "groupId", this), cdk.requireProperty(props, "identityStoreId", this), cdk.requireProperty(props, "memberId", this), this.attrMembershipId = cdk.Token.asString(this.getAtt("MembershipId", cdk.ResolutionTypeHint.STRING)), this.groupId = props.groupId, this.identityStoreId = props.identityStoreId, this.memberId = props.memberId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnGroupMembership.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { groupId: this.groupId, identityStoreId: this.identityStoreId, memberId: this.memberId };
      }
      renderProperties(props) {
        return cfnGroupMembershipPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnGroupMembership[_b] = { fqn: "aws-cdk-lib.aws_identitystore.CfnGroupMembership", version: "2.80.0" }, CfnGroupMembership.CFN_RESOURCE_TYPE_NAME = "AWS::IdentityStore::GroupMembership", exports2.CfnGroupMembership = CfnGroupMembership;
    function CfnGroupMembership_MemberIdPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("userId", cdk.requiredValidator)(properties.userId)), errors.collect(cdk.propertyValidator("userId", cdk.validateString)(properties.userId)), errors.wrap('supplied properties not correct for "MemberIdProperty"');
    }
    function cfnGroupMembershipMemberIdPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGroupMembership_MemberIdPropertyValidator(properties).assertSuccess(), { UserId: cdk.stringToCloudFormation(properties.userId) }) : properties;
    }
    function CfnGroupMembershipMemberIdPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("userId", "UserId", cfn_parse.FromCloudFormation.getString(properties.UserId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-identitystore/lib/index.js
var require_lib144 = __commonJS({
  "node_modules/aws-cdk-lib/aws-identitystore/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_identitystore_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-identitystore/index.js
var require_aws_identitystore = __commonJS({
  "node_modules/aws-cdk-lib/aws-identitystore/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib144(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-imagebuilder/lib/imagebuilder.generated.js
var require_imagebuilder_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-imagebuilder/lib/imagebuilder.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnInfrastructureConfiguration = exports2.CfnImageRecipe = exports2.CfnImagePipeline = exports2.CfnImage = exports2.CfnDistributionConfiguration = exports2.CfnContainerRecipe = exports2.CfnComponent = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnComponentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("changeDescription", cdk.validateString)(properties.changeDescription)), errors.collect(cdk.propertyValidator("data", cdk.validateString)(properties.data)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("platform", cdk.requiredValidator)(properties.platform)), errors.collect(cdk.propertyValidator("platform", cdk.validateString)(properties.platform)), errors.collect(cdk.propertyValidator("supportedOsVersions", cdk.listValidator(cdk.validateString))(properties.supportedOsVersions)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.collect(cdk.propertyValidator("uri", cdk.validateString)(properties.uri)), errors.collect(cdk.propertyValidator("version", cdk.requiredValidator)(properties.version)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "CfnComponentProps"');
    }
    function cfnComponentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponentPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Platform: cdk.stringToCloudFormation(properties.platform), Version: cdk.stringToCloudFormation(properties.version), ChangeDescription: cdk.stringToCloudFormation(properties.changeDescription), Data: cdk.stringToCloudFormation(properties.data), Description: cdk.stringToCloudFormation(properties.description), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), SupportedOsVersions: cdk.listMapper(cdk.stringToCloudFormation)(properties.supportedOsVersions), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags), Uri: cdk.stringToCloudFormation(properties.uri) }) : properties;
    }
    function CfnComponentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("platform", "Platform", cfn_parse.FromCloudFormation.getString(properties.Platform)), ret.addPropertyResult("version", "Version", cfn_parse.FromCloudFormation.getString(properties.Version)), ret.addPropertyResult("changeDescription", "ChangeDescription", properties.ChangeDescription != null ? cfn_parse.FromCloudFormation.getString(properties.ChangeDescription) : void 0), ret.addPropertyResult("data", "Data", properties.Data != null ? cfn_parse.FromCloudFormation.getString(properties.Data) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("supportedOsVersions", "SupportedOsVersions", properties.SupportedOsVersions != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SupportedOsVersions) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addPropertyResult("uri", "Uri", properties.Uri != null ? cfn_parse.FromCloudFormation.getString(properties.Uri) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnComponent = class _CfnComponent extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnComponentPropsFromCloudFormation(resourceProperties), ret = new _CfnComponent(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnComponent.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_imagebuilder_CfnComponentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnComponent), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "platform", this), cdk.requireProperty(props, "version", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrEncrypted = this.getAtt("Encrypted", cdk.ResolutionTypeHint.STRING), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.attrType = cdk.Token.asString(this.getAtt("Type", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.platform = props.platform, this.version = props.version, this.changeDescription = props.changeDescription, this.data = props.data, this.description = props.description, this.kmsKeyId = props.kmsKeyId, this.supportedOsVersions = props.supportedOsVersions, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::ImageBuilder::Component", props.tags, { tagPropertyName: "tags" }), this.uri = props.uri;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnComponent.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, platform: this.platform, version: this.version, changeDescription: this.changeDescription, data: this.data, description: this.description, kmsKeyId: this.kmsKeyId, supportedOsVersions: this.supportedOsVersions, tags: this.tags.renderTags(), uri: this.uri };
      }
      renderProperties(props) {
        return cfnComponentPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnComponent[_a] = { fqn: "aws-cdk-lib.aws_imagebuilder.CfnComponent", version: "2.80.0" }, CfnComponent.CFN_RESOURCE_TYPE_NAME = "AWS::ImageBuilder::Component", exports2.CfnComponent = CfnComponent;
    function CfnContainerRecipePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("components", cdk.requiredValidator)(properties.components)), errors.collect(cdk.propertyValidator("components", cdk.listValidator(CfnContainerRecipe_ComponentConfigurationPropertyValidator))(properties.components)), errors.collect(cdk.propertyValidator("containerType", cdk.requiredValidator)(properties.containerType)), errors.collect(cdk.propertyValidator("containerType", cdk.validateString)(properties.containerType)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("dockerfileTemplateData", cdk.validateString)(properties.dockerfileTemplateData)), errors.collect(cdk.propertyValidator("dockerfileTemplateUri", cdk.validateString)(properties.dockerfileTemplateUri)), errors.collect(cdk.propertyValidator("imageOsVersionOverride", cdk.validateString)(properties.imageOsVersionOverride)), errors.collect(cdk.propertyValidator("instanceConfiguration", CfnContainerRecipe_InstanceConfigurationPropertyValidator)(properties.instanceConfiguration)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("parentImage", cdk.requiredValidator)(properties.parentImage)), errors.collect(cdk.propertyValidator("parentImage", cdk.validateString)(properties.parentImage)), errors.collect(cdk.propertyValidator("platformOverride", cdk.validateString)(properties.platformOverride)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.collect(cdk.propertyValidator("targetRepository", cdk.requiredValidator)(properties.targetRepository)), errors.collect(cdk.propertyValidator("targetRepository", CfnContainerRecipe_TargetContainerRepositoryPropertyValidator)(properties.targetRepository)), errors.collect(cdk.propertyValidator("version", cdk.requiredValidator)(properties.version)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.collect(cdk.propertyValidator("workingDirectory", cdk.validateString)(properties.workingDirectory)), errors.wrap('supplied properties not correct for "CfnContainerRecipeProps"');
    }
    function cfnContainerRecipePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContainerRecipePropsValidator(properties).assertSuccess(), { Components: cdk.listMapper(cfnContainerRecipeComponentConfigurationPropertyToCloudFormation)(properties.components), ContainerType: cdk.stringToCloudFormation(properties.containerType), Name: cdk.stringToCloudFormation(properties.name), ParentImage: cdk.stringToCloudFormation(properties.parentImage), TargetRepository: cfnContainerRecipeTargetContainerRepositoryPropertyToCloudFormation(properties.targetRepository), Version: cdk.stringToCloudFormation(properties.version), Description: cdk.stringToCloudFormation(properties.description), DockerfileTemplateData: cdk.stringToCloudFormation(properties.dockerfileTemplateData), DockerfileTemplateUri: cdk.stringToCloudFormation(properties.dockerfileTemplateUri), ImageOsVersionOverride: cdk.stringToCloudFormation(properties.imageOsVersionOverride), InstanceConfiguration: cfnContainerRecipeInstanceConfigurationPropertyToCloudFormation(properties.instanceConfiguration), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), PlatformOverride: cdk.stringToCloudFormation(properties.platformOverride), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags), WorkingDirectory: cdk.stringToCloudFormation(properties.workingDirectory) }) : properties;
    }
    function CfnContainerRecipePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("components", "Components", cfn_parse.FromCloudFormation.getArray(CfnContainerRecipeComponentConfigurationPropertyFromCloudFormation)(properties.Components)), ret.addPropertyResult("containerType", "ContainerType", cfn_parse.FromCloudFormation.getString(properties.ContainerType)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("parentImage", "ParentImage", cfn_parse.FromCloudFormation.getString(properties.ParentImage)), ret.addPropertyResult("targetRepository", "TargetRepository", CfnContainerRecipeTargetContainerRepositoryPropertyFromCloudFormation(properties.TargetRepository)), ret.addPropertyResult("version", "Version", cfn_parse.FromCloudFormation.getString(properties.Version)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("dockerfileTemplateData", "DockerfileTemplateData", properties.DockerfileTemplateData != null ? cfn_parse.FromCloudFormation.getString(properties.DockerfileTemplateData) : void 0), ret.addPropertyResult("dockerfileTemplateUri", "DockerfileTemplateUri", properties.DockerfileTemplateUri != null ? cfn_parse.FromCloudFormation.getString(properties.DockerfileTemplateUri) : void 0), ret.addPropertyResult("imageOsVersionOverride", "ImageOsVersionOverride", properties.ImageOsVersionOverride != null ? cfn_parse.FromCloudFormation.getString(properties.ImageOsVersionOverride) : void 0), ret.addPropertyResult("instanceConfiguration", "InstanceConfiguration", properties.InstanceConfiguration != null ? CfnContainerRecipeInstanceConfigurationPropertyFromCloudFormation(properties.InstanceConfiguration) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("platformOverride", "PlatformOverride", properties.PlatformOverride != null ? cfn_parse.FromCloudFormation.getString(properties.PlatformOverride) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addPropertyResult("workingDirectory", "WorkingDirectory", properties.WorkingDirectory != null ? cfn_parse.FromCloudFormation.getString(properties.WorkingDirectory) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnContainerRecipe = class _CfnContainerRecipe extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnContainerRecipePropsFromCloudFormation(resourceProperties), ret = new _CfnContainerRecipe(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnContainerRecipe.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_imagebuilder_CfnContainerRecipeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnContainerRecipe), error;
        }
        cdk.requireProperty(props, "components", this), cdk.requireProperty(props, "containerType", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "parentImage", this), cdk.requireProperty(props, "targetRepository", this), cdk.requireProperty(props, "version", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.components = props.components, this.containerType = props.containerType, this.name = props.name, this.parentImage = props.parentImage, this.targetRepository = props.targetRepository, this.version = props.version, this.description = props.description, this.dockerfileTemplateData = props.dockerfileTemplateData, this.dockerfileTemplateUri = props.dockerfileTemplateUri, this.imageOsVersionOverride = props.imageOsVersionOverride, this.instanceConfiguration = props.instanceConfiguration, this.kmsKeyId = props.kmsKeyId, this.platformOverride = props.platformOverride, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::ImageBuilder::ContainerRecipe", props.tags, { tagPropertyName: "tags" }), this.workingDirectory = props.workingDirectory;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnContainerRecipe.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { components: this.components, containerType: this.containerType, name: this.name, parentImage: this.parentImage, targetRepository: this.targetRepository, version: this.version, description: this.description, dockerfileTemplateData: this.dockerfileTemplateData, dockerfileTemplateUri: this.dockerfileTemplateUri, imageOsVersionOverride: this.imageOsVersionOverride, instanceConfiguration: this.instanceConfiguration, kmsKeyId: this.kmsKeyId, platformOverride: this.platformOverride, tags: this.tags.renderTags(), workingDirectory: this.workingDirectory };
      }
      renderProperties(props) {
        return cfnContainerRecipePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnContainerRecipe[_b] = { fqn: "aws-cdk-lib.aws_imagebuilder.CfnContainerRecipe", version: "2.80.0" }, CfnContainerRecipe.CFN_RESOURCE_TYPE_NAME = "AWS::ImageBuilder::ContainerRecipe", exports2.CfnContainerRecipe = CfnContainerRecipe;
    function CfnContainerRecipe_ComponentConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("componentArn", cdk.validateString)(properties.componentArn)), errors.collect(cdk.propertyValidator("parameters", cdk.listValidator(CfnContainerRecipe_ComponentParameterPropertyValidator))(properties.parameters)), errors.wrap('supplied properties not correct for "ComponentConfigurationProperty"');
    }
    function cfnContainerRecipeComponentConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContainerRecipe_ComponentConfigurationPropertyValidator(properties).assertSuccess(), { ComponentArn: cdk.stringToCloudFormation(properties.componentArn), Parameters: cdk.listMapper(cfnContainerRecipeComponentParameterPropertyToCloudFormation)(properties.parameters) }) : properties;
    }
    function CfnContainerRecipeComponentConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("componentArn", "ComponentArn", properties.ComponentArn != null ? cfn_parse.FromCloudFormation.getString(properties.ComponentArn) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getArray(CfnContainerRecipeComponentParameterPropertyFromCloudFormation)(properties.Parameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnContainerRecipe_ComponentParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.listValidator(cdk.validateString))(properties.value)), errors.wrap('supplied properties not correct for "ComponentParameterProperty"');
    }
    function cfnContainerRecipeComponentParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContainerRecipe_ComponentParameterPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cdk.listMapper(cdk.stringToCloudFormation)(properties.value) }) : properties;
    }
    function CfnContainerRecipeComponentParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getStringArray(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnContainerRecipe_EbsInstanceBlockDeviceSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deleteOnTermination", cdk.validateBoolean)(properties.deleteOnTermination)), errors.collect(cdk.propertyValidator("encrypted", cdk.validateBoolean)(properties.encrypted)), errors.collect(cdk.propertyValidator("iops", cdk.validateNumber)(properties.iops)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("snapshotId", cdk.validateString)(properties.snapshotId)), errors.collect(cdk.propertyValidator("throughput", cdk.validateNumber)(properties.throughput)), errors.collect(cdk.propertyValidator("volumeSize", cdk.validateNumber)(properties.volumeSize)), errors.collect(cdk.propertyValidator("volumeType", cdk.validateString)(properties.volumeType)), errors.wrap('supplied properties not correct for "EbsInstanceBlockDeviceSpecificationProperty"');
    }
    function cfnContainerRecipeEbsInstanceBlockDeviceSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContainerRecipe_EbsInstanceBlockDeviceSpecificationPropertyValidator(properties).assertSuccess(), { DeleteOnTermination: cdk.booleanToCloudFormation(properties.deleteOnTermination), Encrypted: cdk.booleanToCloudFormation(properties.encrypted), Iops: cdk.numberToCloudFormation(properties.iops), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), SnapshotId: cdk.stringToCloudFormation(properties.snapshotId), Throughput: cdk.numberToCloudFormation(properties.throughput), VolumeSize: cdk.numberToCloudFormation(properties.volumeSize), VolumeType: cdk.stringToCloudFormation(properties.volumeType) }) : properties;
    }
    function CfnContainerRecipeEbsInstanceBlockDeviceSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deleteOnTermination", "DeleteOnTermination", properties.DeleteOnTermination != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeleteOnTermination) : void 0), ret.addPropertyResult("encrypted", "Encrypted", properties.Encrypted != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Encrypted) : void 0), ret.addPropertyResult("iops", "Iops", properties.Iops != null ? cfn_parse.FromCloudFormation.getNumber(properties.Iops) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("snapshotId", "SnapshotId", properties.SnapshotId != null ? cfn_parse.FromCloudFormation.getString(properties.SnapshotId) : void 0), ret.addPropertyResult("throughput", "Throughput", properties.Throughput != null ? cfn_parse.FromCloudFormation.getNumber(properties.Throughput) : void 0), ret.addPropertyResult("volumeSize", "VolumeSize", properties.VolumeSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.VolumeSize) : void 0), ret.addPropertyResult("volumeType", "VolumeType", properties.VolumeType != null ? cfn_parse.FromCloudFormation.getString(properties.VolumeType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnContainerRecipe_InstanceBlockDeviceMappingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deviceName", cdk.validateString)(properties.deviceName)), errors.collect(cdk.propertyValidator("ebs", CfnContainerRecipe_EbsInstanceBlockDeviceSpecificationPropertyValidator)(properties.ebs)), errors.collect(cdk.propertyValidator("noDevice", cdk.validateString)(properties.noDevice)), errors.collect(cdk.propertyValidator("virtualName", cdk.validateString)(properties.virtualName)), errors.wrap('supplied properties not correct for "InstanceBlockDeviceMappingProperty"');
    }
    function cfnContainerRecipeInstanceBlockDeviceMappingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContainerRecipe_InstanceBlockDeviceMappingPropertyValidator(properties).assertSuccess(), { DeviceName: cdk.stringToCloudFormation(properties.deviceName), Ebs: cfnContainerRecipeEbsInstanceBlockDeviceSpecificationPropertyToCloudFormation(properties.ebs), NoDevice: cdk.stringToCloudFormation(properties.noDevice), VirtualName: cdk.stringToCloudFormation(properties.virtualName) }) : properties;
    }
    function CfnContainerRecipeInstanceBlockDeviceMappingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deviceName", "DeviceName", properties.DeviceName != null ? cfn_parse.FromCloudFormation.getString(properties.DeviceName) : void 0), ret.addPropertyResult("ebs", "Ebs", properties.Ebs != null ? CfnContainerRecipeEbsInstanceBlockDeviceSpecificationPropertyFromCloudFormation(properties.Ebs) : void 0), ret.addPropertyResult("noDevice", "NoDevice", properties.NoDevice != null ? cfn_parse.FromCloudFormation.getString(properties.NoDevice) : void 0), ret.addPropertyResult("virtualName", "VirtualName", properties.VirtualName != null ? cfn_parse.FromCloudFormation.getString(properties.VirtualName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnContainerRecipe_InstanceConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("blockDeviceMappings", cdk.listValidator(CfnContainerRecipe_InstanceBlockDeviceMappingPropertyValidator))(properties.blockDeviceMappings)), errors.collect(cdk.propertyValidator("image", cdk.validateString)(properties.image)), errors.wrap('supplied properties not correct for "InstanceConfigurationProperty"');
    }
    function cfnContainerRecipeInstanceConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContainerRecipe_InstanceConfigurationPropertyValidator(properties).assertSuccess(), { BlockDeviceMappings: cdk.listMapper(cfnContainerRecipeInstanceBlockDeviceMappingPropertyToCloudFormation)(properties.blockDeviceMappings), Image: cdk.stringToCloudFormation(properties.image) }) : properties;
    }
    function CfnContainerRecipeInstanceConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("blockDeviceMappings", "BlockDeviceMappings", properties.BlockDeviceMappings != null ? cfn_parse.FromCloudFormation.getArray(CfnContainerRecipeInstanceBlockDeviceMappingPropertyFromCloudFormation)(properties.BlockDeviceMappings) : void 0), ret.addPropertyResult("image", "Image", properties.Image != null ? cfn_parse.FromCloudFormation.getString(properties.Image) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnContainerRecipe_TargetContainerRepositoryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("repositoryName", cdk.validateString)(properties.repositoryName)), errors.collect(cdk.propertyValidator("service", cdk.validateString)(properties.service)), errors.wrap('supplied properties not correct for "TargetContainerRepositoryProperty"');
    }
    function cfnContainerRecipeTargetContainerRepositoryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContainerRecipe_TargetContainerRepositoryPropertyValidator(properties).assertSuccess(), { RepositoryName: cdk.stringToCloudFormation(properties.repositoryName), Service: cdk.stringToCloudFormation(properties.service) }) : properties;
    }
    function CfnContainerRecipeTargetContainerRepositoryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("repositoryName", "RepositoryName", properties.RepositoryName != null ? cfn_parse.FromCloudFormation.getString(properties.RepositoryName) : void 0), ret.addPropertyResult("service", "Service", properties.Service != null ? cfn_parse.FromCloudFormation.getString(properties.Service) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistributionConfigurationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("distributions", cdk.requiredValidator)(properties.distributions)), errors.collect(cdk.propertyValidator("distributions", cdk.listValidator(CfnDistributionConfiguration_DistributionPropertyValidator))(properties.distributions)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDistributionConfigurationProps"');
    }
    function cfnDistributionConfigurationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistributionConfigurationPropsValidator(properties).assertSuccess(), { Distributions: cdk.listMapper(cfnDistributionConfigurationDistributionPropertyToCloudFormation)(properties.distributions), Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDistributionConfigurationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("distributions", "Distributions", cfn_parse.FromCloudFormation.getArray(CfnDistributionConfigurationDistributionPropertyFromCloudFormation)(properties.Distributions)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDistributionConfiguration = class _CfnDistributionConfiguration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDistributionConfigurationPropsFromCloudFormation(resourceProperties), ret = new _CfnDistributionConfiguration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDistributionConfiguration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_imagebuilder_CfnDistributionConfigurationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDistributionConfiguration), error;
        }
        cdk.requireProperty(props, "distributions", this), cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.distributions = props.distributions, this.name = props.name, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::ImageBuilder::DistributionConfiguration", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDistributionConfiguration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { distributions: this.distributions, name: this.name, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDistributionConfigurationPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnDistributionConfiguration[_c] = { fqn: "aws-cdk-lib.aws_imagebuilder.CfnDistributionConfiguration", version: "2.80.0" }, CfnDistributionConfiguration.CFN_RESOURCE_TYPE_NAME = "AWS::ImageBuilder::DistributionConfiguration", exports2.CfnDistributionConfiguration = CfnDistributionConfiguration;
    function CfnDistributionConfiguration_DistributionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("amiDistributionConfiguration", cdk.validateObject)(properties.amiDistributionConfiguration)), errors.collect(cdk.propertyValidator("containerDistributionConfiguration", cdk.validateObject)(properties.containerDistributionConfiguration)), errors.collect(cdk.propertyValidator("fastLaunchConfigurations", cdk.listValidator(CfnDistributionConfiguration_FastLaunchConfigurationPropertyValidator))(properties.fastLaunchConfigurations)), errors.collect(cdk.propertyValidator("launchTemplateConfigurations", cdk.listValidator(CfnDistributionConfiguration_LaunchTemplateConfigurationPropertyValidator))(properties.launchTemplateConfigurations)), errors.collect(cdk.propertyValidator("licenseConfigurationArns", cdk.listValidator(cdk.validateString))(properties.licenseConfigurationArns)), errors.collect(cdk.propertyValidator("region", cdk.requiredValidator)(properties.region)), errors.collect(cdk.propertyValidator("region", cdk.validateString)(properties.region)), errors.wrap('supplied properties not correct for "DistributionProperty"');
    }
    function cfnDistributionConfigurationDistributionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistributionConfiguration_DistributionPropertyValidator(properties).assertSuccess(), { AmiDistributionConfiguration: cdk.objectToCloudFormation(properties.amiDistributionConfiguration), ContainerDistributionConfiguration: cdk.objectToCloudFormation(properties.containerDistributionConfiguration), FastLaunchConfigurations: cdk.listMapper(cfnDistributionConfigurationFastLaunchConfigurationPropertyToCloudFormation)(properties.fastLaunchConfigurations), LaunchTemplateConfigurations: cdk.listMapper(cfnDistributionConfigurationLaunchTemplateConfigurationPropertyToCloudFormation)(properties.launchTemplateConfigurations), LicenseConfigurationArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.licenseConfigurationArns), Region: cdk.stringToCloudFormation(properties.region) }) : properties;
    }
    function CfnDistributionConfigurationDistributionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("amiDistributionConfiguration", "AmiDistributionConfiguration", properties.AmiDistributionConfiguration != null ? cfn_parse.FromCloudFormation.getAny(properties.AmiDistributionConfiguration) : void 0), ret.addPropertyResult("containerDistributionConfiguration", "ContainerDistributionConfiguration", properties.ContainerDistributionConfiguration != null ? cfn_parse.FromCloudFormation.getAny(properties.ContainerDistributionConfiguration) : void 0), ret.addPropertyResult("fastLaunchConfigurations", "FastLaunchConfigurations", properties.FastLaunchConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnDistributionConfigurationFastLaunchConfigurationPropertyFromCloudFormation)(properties.FastLaunchConfigurations) : void 0), ret.addPropertyResult("launchTemplateConfigurations", "LaunchTemplateConfigurations", properties.LaunchTemplateConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnDistributionConfigurationLaunchTemplateConfigurationPropertyFromCloudFormation)(properties.LaunchTemplateConfigurations) : void 0), ret.addPropertyResult("licenseConfigurationArns", "LicenseConfigurationArns", properties.LicenseConfigurationArns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.LicenseConfigurationArns) : void 0), ret.addPropertyResult("region", "Region", cfn_parse.FromCloudFormation.getString(properties.Region)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistributionConfiguration_FastLaunchConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accountId", cdk.validateString)(properties.accountId)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("launchTemplate", CfnDistributionConfiguration_FastLaunchLaunchTemplateSpecificationPropertyValidator)(properties.launchTemplate)), errors.collect(cdk.propertyValidator("maxParallelLaunches", cdk.validateNumber)(properties.maxParallelLaunches)), errors.collect(cdk.propertyValidator("snapshotConfiguration", CfnDistributionConfiguration_FastLaunchSnapshotConfigurationPropertyValidator)(properties.snapshotConfiguration)), errors.wrap('supplied properties not correct for "FastLaunchConfigurationProperty"');
    }
    function cfnDistributionConfigurationFastLaunchConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistributionConfiguration_FastLaunchConfigurationPropertyValidator(properties).assertSuccess(), { AccountId: cdk.stringToCloudFormation(properties.accountId), Enabled: cdk.booleanToCloudFormation(properties.enabled), LaunchTemplate: cfnDistributionConfigurationFastLaunchLaunchTemplateSpecificationPropertyToCloudFormation(properties.launchTemplate), MaxParallelLaunches: cdk.numberToCloudFormation(properties.maxParallelLaunches), SnapshotConfiguration: cfnDistributionConfigurationFastLaunchSnapshotConfigurationPropertyToCloudFormation(properties.snapshotConfiguration) }) : properties;
    }
    function CfnDistributionConfigurationFastLaunchConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accountId", "AccountId", properties.AccountId != null ? cfn_parse.FromCloudFormation.getString(properties.AccountId) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("launchTemplate", "LaunchTemplate", properties.LaunchTemplate != null ? CfnDistributionConfigurationFastLaunchLaunchTemplateSpecificationPropertyFromCloudFormation(properties.LaunchTemplate) : void 0), ret.addPropertyResult("maxParallelLaunches", "MaxParallelLaunches", properties.MaxParallelLaunches != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxParallelLaunches) : void 0), ret.addPropertyResult("snapshotConfiguration", "SnapshotConfiguration", properties.SnapshotConfiguration != null ? CfnDistributionConfigurationFastLaunchSnapshotConfigurationPropertyFromCloudFormation(properties.SnapshotConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistributionConfiguration_FastLaunchLaunchTemplateSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("launchTemplateId", cdk.validateString)(properties.launchTemplateId)), errors.collect(cdk.propertyValidator("launchTemplateName", cdk.validateString)(properties.launchTemplateName)), errors.collect(cdk.propertyValidator("launchTemplateVersion", cdk.validateString)(properties.launchTemplateVersion)), errors.wrap('supplied properties not correct for "FastLaunchLaunchTemplateSpecificationProperty"');
    }
    function cfnDistributionConfigurationFastLaunchLaunchTemplateSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistributionConfiguration_FastLaunchLaunchTemplateSpecificationPropertyValidator(properties).assertSuccess(), { LaunchTemplateId: cdk.stringToCloudFormation(properties.launchTemplateId), LaunchTemplateName: cdk.stringToCloudFormation(properties.launchTemplateName), LaunchTemplateVersion: cdk.stringToCloudFormation(properties.launchTemplateVersion) }) : properties;
    }
    function CfnDistributionConfigurationFastLaunchLaunchTemplateSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("launchTemplateId", "LaunchTemplateId", properties.LaunchTemplateId != null ? cfn_parse.FromCloudFormation.getString(properties.LaunchTemplateId) : void 0), ret.addPropertyResult("launchTemplateName", "LaunchTemplateName", properties.LaunchTemplateName != null ? cfn_parse.FromCloudFormation.getString(properties.LaunchTemplateName) : void 0), ret.addPropertyResult("launchTemplateVersion", "LaunchTemplateVersion", properties.LaunchTemplateVersion != null ? cfn_parse.FromCloudFormation.getString(properties.LaunchTemplateVersion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistributionConfiguration_FastLaunchSnapshotConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("targetResourceCount", cdk.validateNumber)(properties.targetResourceCount)), errors.wrap('supplied properties not correct for "FastLaunchSnapshotConfigurationProperty"');
    }
    function cfnDistributionConfigurationFastLaunchSnapshotConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistributionConfiguration_FastLaunchSnapshotConfigurationPropertyValidator(properties).assertSuccess(), { TargetResourceCount: cdk.numberToCloudFormation(properties.targetResourceCount) }) : properties;
    }
    function CfnDistributionConfigurationFastLaunchSnapshotConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("targetResourceCount", "TargetResourceCount", properties.TargetResourceCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.TargetResourceCount) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistributionConfiguration_LaunchTemplateConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accountId", cdk.validateString)(properties.accountId)), errors.collect(cdk.propertyValidator("launchTemplateId", cdk.validateString)(properties.launchTemplateId)), errors.collect(cdk.propertyValidator("setDefaultVersion", cdk.validateBoolean)(properties.setDefaultVersion)), errors.wrap('supplied properties not correct for "LaunchTemplateConfigurationProperty"');
    }
    function cfnDistributionConfigurationLaunchTemplateConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistributionConfiguration_LaunchTemplateConfigurationPropertyValidator(properties).assertSuccess(), { AccountId: cdk.stringToCloudFormation(properties.accountId), LaunchTemplateId: cdk.stringToCloudFormation(properties.launchTemplateId), SetDefaultVersion: cdk.booleanToCloudFormation(properties.setDefaultVersion) }) : properties;
    }
    function CfnDistributionConfigurationLaunchTemplateConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accountId", "AccountId", properties.AccountId != null ? cfn_parse.FromCloudFormation.getString(properties.AccountId) : void 0), ret.addPropertyResult("launchTemplateId", "LaunchTemplateId", properties.LaunchTemplateId != null ? cfn_parse.FromCloudFormation.getString(properties.LaunchTemplateId) : void 0), ret.addPropertyResult("setDefaultVersion", "SetDefaultVersion", properties.SetDefaultVersion != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SetDefaultVersion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnImagePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containerRecipeArn", cdk.validateString)(properties.containerRecipeArn)), errors.collect(cdk.propertyValidator("distributionConfigurationArn", cdk.validateString)(properties.distributionConfigurationArn)), errors.collect(cdk.propertyValidator("enhancedImageMetadataEnabled", cdk.validateBoolean)(properties.enhancedImageMetadataEnabled)), errors.collect(cdk.propertyValidator("imageRecipeArn", cdk.validateString)(properties.imageRecipeArn)), errors.collect(cdk.propertyValidator("imageScanningConfiguration", CfnImage_ImageScanningConfigurationPropertyValidator)(properties.imageScanningConfiguration)), errors.collect(cdk.propertyValidator("imageTestsConfiguration", CfnImage_ImageTestsConfigurationPropertyValidator)(properties.imageTestsConfiguration)), errors.collect(cdk.propertyValidator("infrastructureConfigurationArn", cdk.requiredValidator)(properties.infrastructureConfigurationArn)), errors.collect(cdk.propertyValidator("infrastructureConfigurationArn", cdk.validateString)(properties.infrastructureConfigurationArn)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.wrap('supplied properties not correct for "CfnImageProps"');
    }
    function cfnImagePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnImagePropsValidator(properties).assertSuccess(), { InfrastructureConfigurationArn: cdk.stringToCloudFormation(properties.infrastructureConfigurationArn), ContainerRecipeArn: cdk.stringToCloudFormation(properties.containerRecipeArn), DistributionConfigurationArn: cdk.stringToCloudFormation(properties.distributionConfigurationArn), EnhancedImageMetadataEnabled: cdk.booleanToCloudFormation(properties.enhancedImageMetadataEnabled), ImageRecipeArn: cdk.stringToCloudFormation(properties.imageRecipeArn), ImageScanningConfiguration: cfnImageImageScanningConfigurationPropertyToCloudFormation(properties.imageScanningConfiguration), ImageTestsConfiguration: cfnImageImageTestsConfigurationPropertyToCloudFormation(properties.imageTestsConfiguration), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnImagePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("infrastructureConfigurationArn", "InfrastructureConfigurationArn", cfn_parse.FromCloudFormation.getString(properties.InfrastructureConfigurationArn)), ret.addPropertyResult("containerRecipeArn", "ContainerRecipeArn", properties.ContainerRecipeArn != null ? cfn_parse.FromCloudFormation.getString(properties.ContainerRecipeArn) : void 0), ret.addPropertyResult("distributionConfigurationArn", "DistributionConfigurationArn", properties.DistributionConfigurationArn != null ? cfn_parse.FromCloudFormation.getString(properties.DistributionConfigurationArn) : void 0), ret.addPropertyResult("enhancedImageMetadataEnabled", "EnhancedImageMetadataEnabled", properties.EnhancedImageMetadataEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnhancedImageMetadataEnabled) : void 0), ret.addPropertyResult("imageRecipeArn", "ImageRecipeArn", properties.ImageRecipeArn != null ? cfn_parse.FromCloudFormation.getString(properties.ImageRecipeArn) : void 0), ret.addPropertyResult("imageScanningConfiguration", "ImageScanningConfiguration", properties.ImageScanningConfiguration != null ? CfnImageImageScanningConfigurationPropertyFromCloudFormation(properties.ImageScanningConfiguration) : void 0), ret.addPropertyResult("imageTestsConfiguration", "ImageTestsConfiguration", properties.ImageTestsConfiguration != null ? CfnImageImageTestsConfigurationPropertyFromCloudFormation(properties.ImageTestsConfiguration) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnImage = class _CfnImage extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnImagePropsFromCloudFormation(resourceProperties), ret = new _CfnImage(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnImage.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_imagebuilder_CfnImageProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnImage), error;
        }
        cdk.requireProperty(props, "infrastructureConfigurationArn", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrImageId = cdk.Token.asString(this.getAtt("ImageId", cdk.ResolutionTypeHint.STRING)), this.attrImageUri = cdk.Token.asString(this.getAtt("ImageUri", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.infrastructureConfigurationArn = props.infrastructureConfigurationArn, this.containerRecipeArn = props.containerRecipeArn, this.distributionConfigurationArn = props.distributionConfigurationArn, this.enhancedImageMetadataEnabled = props.enhancedImageMetadataEnabled, this.imageRecipeArn = props.imageRecipeArn, this.imageScanningConfiguration = props.imageScanningConfiguration, this.imageTestsConfiguration = props.imageTestsConfiguration, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::ImageBuilder::Image", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnImage.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { infrastructureConfigurationArn: this.infrastructureConfigurationArn, containerRecipeArn: this.containerRecipeArn, distributionConfigurationArn: this.distributionConfigurationArn, enhancedImageMetadataEnabled: this.enhancedImageMetadataEnabled, imageRecipeArn: this.imageRecipeArn, imageScanningConfiguration: this.imageScanningConfiguration, imageTestsConfiguration: this.imageTestsConfiguration, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnImagePropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnImage[_d] = { fqn: "aws-cdk-lib.aws_imagebuilder.CfnImage", version: "2.80.0" }, CfnImage.CFN_RESOURCE_TYPE_NAME = "AWS::ImageBuilder::Image", exports2.CfnImage = CfnImage;
    function CfnImage_EcrConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containerTags", cdk.listValidator(cdk.validateString))(properties.containerTags)), errors.collect(cdk.propertyValidator("repositoryName", cdk.validateString)(properties.repositoryName)), errors.wrap('supplied properties not correct for "EcrConfigurationProperty"');
    }
    function cfnImageEcrConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnImage_EcrConfigurationPropertyValidator(properties).assertSuccess(), { ContainerTags: cdk.listMapper(cdk.stringToCloudFormation)(properties.containerTags), RepositoryName: cdk.stringToCloudFormation(properties.repositoryName) }) : properties;
    }
    function CfnImageEcrConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containerTags", "ContainerTags", properties.ContainerTags != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ContainerTags) : void 0), ret.addPropertyResult("repositoryName", "RepositoryName", properties.RepositoryName != null ? cfn_parse.FromCloudFormation.getString(properties.RepositoryName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnImage_ImageScanningConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ecrConfiguration", CfnImage_EcrConfigurationPropertyValidator)(properties.ecrConfiguration)), errors.collect(cdk.propertyValidator("imageScanningEnabled", cdk.validateBoolean)(properties.imageScanningEnabled)), errors.wrap('supplied properties not correct for "ImageScanningConfigurationProperty"');
    }
    function cfnImageImageScanningConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnImage_ImageScanningConfigurationPropertyValidator(properties).assertSuccess(), { EcrConfiguration: cfnImageEcrConfigurationPropertyToCloudFormation(properties.ecrConfiguration), ImageScanningEnabled: cdk.booleanToCloudFormation(properties.imageScanningEnabled) }) : properties;
    }
    function CfnImageImageScanningConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ecrConfiguration", "EcrConfiguration", properties.EcrConfiguration != null ? CfnImageEcrConfigurationPropertyFromCloudFormation(properties.EcrConfiguration) : void 0), ret.addPropertyResult("imageScanningEnabled", "ImageScanningEnabled", properties.ImageScanningEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ImageScanningEnabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnImage_ImageTestsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("imageTestsEnabled", cdk.validateBoolean)(properties.imageTestsEnabled)), errors.collect(cdk.propertyValidator("timeoutMinutes", cdk.validateNumber)(properties.timeoutMinutes)), errors.wrap('supplied properties not correct for "ImageTestsConfigurationProperty"');
    }
    function cfnImageImageTestsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnImage_ImageTestsConfigurationPropertyValidator(properties).assertSuccess(), { ImageTestsEnabled: cdk.booleanToCloudFormation(properties.imageTestsEnabled), TimeoutMinutes: cdk.numberToCloudFormation(properties.timeoutMinutes) }) : properties;
    }
    function CfnImageImageTestsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("imageTestsEnabled", "ImageTestsEnabled", properties.ImageTestsEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ImageTestsEnabled) : void 0), ret.addPropertyResult("timeoutMinutes", "TimeoutMinutes", properties.TimeoutMinutes != null ? cfn_parse.FromCloudFormation.getNumber(properties.TimeoutMinutes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnImagePipelinePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containerRecipeArn", cdk.validateString)(properties.containerRecipeArn)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("distributionConfigurationArn", cdk.validateString)(properties.distributionConfigurationArn)), errors.collect(cdk.propertyValidator("enhancedImageMetadataEnabled", cdk.validateBoolean)(properties.enhancedImageMetadataEnabled)), errors.collect(cdk.propertyValidator("imageRecipeArn", cdk.validateString)(properties.imageRecipeArn)), errors.collect(cdk.propertyValidator("imageScanningConfiguration", CfnImagePipeline_ImageScanningConfigurationPropertyValidator)(properties.imageScanningConfiguration)), errors.collect(cdk.propertyValidator("imageTestsConfiguration", CfnImagePipeline_ImageTestsConfigurationPropertyValidator)(properties.imageTestsConfiguration)), errors.collect(cdk.propertyValidator("infrastructureConfigurationArn", cdk.requiredValidator)(properties.infrastructureConfigurationArn)), errors.collect(cdk.propertyValidator("infrastructureConfigurationArn", cdk.validateString)(properties.infrastructureConfigurationArn)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("schedule", CfnImagePipeline_SchedulePropertyValidator)(properties.schedule)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.wrap('supplied properties not correct for "CfnImagePipelineProps"');
    }
    function cfnImagePipelinePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnImagePipelinePropsValidator(properties).assertSuccess(), { InfrastructureConfigurationArn: cdk.stringToCloudFormation(properties.infrastructureConfigurationArn), Name: cdk.stringToCloudFormation(properties.name), ContainerRecipeArn: cdk.stringToCloudFormation(properties.containerRecipeArn), Description: cdk.stringToCloudFormation(properties.description), DistributionConfigurationArn: cdk.stringToCloudFormation(properties.distributionConfigurationArn), EnhancedImageMetadataEnabled: cdk.booleanToCloudFormation(properties.enhancedImageMetadataEnabled), ImageRecipeArn: cdk.stringToCloudFormation(properties.imageRecipeArn), ImageScanningConfiguration: cfnImagePipelineImageScanningConfigurationPropertyToCloudFormation(properties.imageScanningConfiguration), ImageTestsConfiguration: cfnImagePipelineImageTestsConfigurationPropertyToCloudFormation(properties.imageTestsConfiguration), Schedule: cfnImagePipelineSchedulePropertyToCloudFormation(properties.schedule), Status: cdk.stringToCloudFormation(properties.status), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnImagePipelinePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("infrastructureConfigurationArn", "InfrastructureConfigurationArn", cfn_parse.FromCloudFormation.getString(properties.InfrastructureConfigurationArn)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("containerRecipeArn", "ContainerRecipeArn", properties.ContainerRecipeArn != null ? cfn_parse.FromCloudFormation.getString(properties.ContainerRecipeArn) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("distributionConfigurationArn", "DistributionConfigurationArn", properties.DistributionConfigurationArn != null ? cfn_parse.FromCloudFormation.getString(properties.DistributionConfigurationArn) : void 0), ret.addPropertyResult("enhancedImageMetadataEnabled", "EnhancedImageMetadataEnabled", properties.EnhancedImageMetadataEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnhancedImageMetadataEnabled) : void 0), ret.addPropertyResult("imageRecipeArn", "ImageRecipeArn", properties.ImageRecipeArn != null ? cfn_parse.FromCloudFormation.getString(properties.ImageRecipeArn) : void 0), ret.addPropertyResult("imageScanningConfiguration", "ImageScanningConfiguration", properties.ImageScanningConfiguration != null ? CfnImagePipelineImageScanningConfigurationPropertyFromCloudFormation(properties.ImageScanningConfiguration) : void 0), ret.addPropertyResult("imageTestsConfiguration", "ImageTestsConfiguration", properties.ImageTestsConfiguration != null ? CfnImagePipelineImageTestsConfigurationPropertyFromCloudFormation(properties.ImageTestsConfiguration) : void 0), ret.addPropertyResult("schedule", "Schedule", properties.Schedule != null ? CfnImagePipelineSchedulePropertyFromCloudFormation(properties.Schedule) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnImagePipeline = class _CfnImagePipeline extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnImagePipelinePropsFromCloudFormation(resourceProperties), ret = new _CfnImagePipeline(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnImagePipeline.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_imagebuilder_CfnImagePipelineProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnImagePipeline), error;
        }
        cdk.requireProperty(props, "infrastructureConfigurationArn", this), cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.infrastructureConfigurationArn = props.infrastructureConfigurationArn, this.name = props.name, this.containerRecipeArn = props.containerRecipeArn, this.description = props.description, this.distributionConfigurationArn = props.distributionConfigurationArn, this.enhancedImageMetadataEnabled = props.enhancedImageMetadataEnabled, this.imageRecipeArn = props.imageRecipeArn, this.imageScanningConfiguration = props.imageScanningConfiguration, this.imageTestsConfiguration = props.imageTestsConfiguration, this.schedule = props.schedule, this.status = props.status, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::ImageBuilder::ImagePipeline", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnImagePipeline.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { infrastructureConfigurationArn: this.infrastructureConfigurationArn, name: this.name, containerRecipeArn: this.containerRecipeArn, description: this.description, distributionConfigurationArn: this.distributionConfigurationArn, enhancedImageMetadataEnabled: this.enhancedImageMetadataEnabled, imageRecipeArn: this.imageRecipeArn, imageScanningConfiguration: this.imageScanningConfiguration, imageTestsConfiguration: this.imageTestsConfiguration, schedule: this.schedule, status: this.status, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnImagePipelinePropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnImagePipeline[_e] = { fqn: "aws-cdk-lib.aws_imagebuilder.CfnImagePipeline", version: "2.80.0" }, CfnImagePipeline.CFN_RESOURCE_TYPE_NAME = "AWS::ImageBuilder::ImagePipeline", exports2.CfnImagePipeline = CfnImagePipeline;
    function CfnImagePipeline_EcrConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containerTags", cdk.listValidator(cdk.validateString))(properties.containerTags)), errors.collect(cdk.propertyValidator("repositoryName", cdk.validateString)(properties.repositoryName)), errors.wrap('supplied properties not correct for "EcrConfigurationProperty"');
    }
    function cfnImagePipelineEcrConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnImagePipeline_EcrConfigurationPropertyValidator(properties).assertSuccess(), { ContainerTags: cdk.listMapper(cdk.stringToCloudFormation)(properties.containerTags), RepositoryName: cdk.stringToCloudFormation(properties.repositoryName) }) : properties;
    }
    function CfnImagePipelineEcrConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containerTags", "ContainerTags", properties.ContainerTags != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ContainerTags) : void 0), ret.addPropertyResult("repositoryName", "RepositoryName", properties.RepositoryName != null ? cfn_parse.FromCloudFormation.getString(properties.RepositoryName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnImagePipeline_ImageScanningConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ecrConfiguration", CfnImagePipeline_EcrConfigurationPropertyValidator)(properties.ecrConfiguration)), errors.collect(cdk.propertyValidator("imageScanningEnabled", cdk.validateBoolean)(properties.imageScanningEnabled)), errors.wrap('supplied properties not correct for "ImageScanningConfigurationProperty"');
    }
    function cfnImagePipelineImageScanningConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnImagePipeline_ImageScanningConfigurationPropertyValidator(properties).assertSuccess(), { EcrConfiguration: cfnImagePipelineEcrConfigurationPropertyToCloudFormation(properties.ecrConfiguration), ImageScanningEnabled: cdk.booleanToCloudFormation(properties.imageScanningEnabled) }) : properties;
    }
    function CfnImagePipelineImageScanningConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ecrConfiguration", "EcrConfiguration", properties.EcrConfiguration != null ? CfnImagePipelineEcrConfigurationPropertyFromCloudFormation(properties.EcrConfiguration) : void 0), ret.addPropertyResult("imageScanningEnabled", "ImageScanningEnabled", properties.ImageScanningEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ImageScanningEnabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnImagePipeline_ImageTestsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("imageTestsEnabled", cdk.validateBoolean)(properties.imageTestsEnabled)), errors.collect(cdk.propertyValidator("timeoutMinutes", cdk.validateNumber)(properties.timeoutMinutes)), errors.wrap('supplied properties not correct for "ImageTestsConfigurationProperty"');
    }
    function cfnImagePipelineImageTestsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnImagePipeline_ImageTestsConfigurationPropertyValidator(properties).assertSuccess(), { ImageTestsEnabled: cdk.booleanToCloudFormation(properties.imageTestsEnabled), TimeoutMinutes: cdk.numberToCloudFormation(properties.timeoutMinutes) }) : properties;
    }
    function CfnImagePipelineImageTestsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("imageTestsEnabled", "ImageTestsEnabled", properties.ImageTestsEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ImageTestsEnabled) : void 0), ret.addPropertyResult("timeoutMinutes", "TimeoutMinutes", properties.TimeoutMinutes != null ? cfn_parse.FromCloudFormation.getNumber(properties.TimeoutMinutes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnImagePipeline_SchedulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("pipelineExecutionStartCondition", cdk.validateString)(properties.pipelineExecutionStartCondition)), errors.collect(cdk.propertyValidator("scheduleExpression", cdk.validateString)(properties.scheduleExpression)), errors.wrap('supplied properties not correct for "ScheduleProperty"');
    }
    function cfnImagePipelineSchedulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnImagePipeline_SchedulePropertyValidator(properties).assertSuccess(), { PipelineExecutionStartCondition: cdk.stringToCloudFormation(properties.pipelineExecutionStartCondition), ScheduleExpression: cdk.stringToCloudFormation(properties.scheduleExpression) }) : properties;
    }
    function CfnImagePipelineSchedulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("pipelineExecutionStartCondition", "PipelineExecutionStartCondition", properties.PipelineExecutionStartCondition != null ? cfn_parse.FromCloudFormation.getString(properties.PipelineExecutionStartCondition) : void 0), ret.addPropertyResult("scheduleExpression", "ScheduleExpression", properties.ScheduleExpression != null ? cfn_parse.FromCloudFormation.getString(properties.ScheduleExpression) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnImageRecipePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("additionalInstanceConfiguration", CfnImageRecipe_AdditionalInstanceConfigurationPropertyValidator)(properties.additionalInstanceConfiguration)), errors.collect(cdk.propertyValidator("blockDeviceMappings", cdk.listValidator(CfnImageRecipe_InstanceBlockDeviceMappingPropertyValidator))(properties.blockDeviceMappings)), errors.collect(cdk.propertyValidator("components", cdk.requiredValidator)(properties.components)), errors.collect(cdk.propertyValidator("components", cdk.listValidator(CfnImageRecipe_ComponentConfigurationPropertyValidator))(properties.components)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("parentImage", cdk.requiredValidator)(properties.parentImage)), errors.collect(cdk.propertyValidator("parentImage", cdk.validateString)(properties.parentImage)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.collect(cdk.propertyValidator("version", cdk.requiredValidator)(properties.version)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.collect(cdk.propertyValidator("workingDirectory", cdk.validateString)(properties.workingDirectory)), errors.wrap('supplied properties not correct for "CfnImageRecipeProps"');
    }
    function cfnImageRecipePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnImageRecipePropsValidator(properties).assertSuccess(), { Components: cdk.listMapper(cfnImageRecipeComponentConfigurationPropertyToCloudFormation)(properties.components), Name: cdk.stringToCloudFormation(properties.name), ParentImage: cdk.stringToCloudFormation(properties.parentImage), Version: cdk.stringToCloudFormation(properties.version), AdditionalInstanceConfiguration: cfnImageRecipeAdditionalInstanceConfigurationPropertyToCloudFormation(properties.additionalInstanceConfiguration), BlockDeviceMappings: cdk.listMapper(cfnImageRecipeInstanceBlockDeviceMappingPropertyToCloudFormation)(properties.blockDeviceMappings), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags), WorkingDirectory: cdk.stringToCloudFormation(properties.workingDirectory) }) : properties;
    }
    function CfnImageRecipePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("components", "Components", cfn_parse.FromCloudFormation.getArray(CfnImageRecipeComponentConfigurationPropertyFromCloudFormation)(properties.Components)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("parentImage", "ParentImage", cfn_parse.FromCloudFormation.getString(properties.ParentImage)), ret.addPropertyResult("version", "Version", cfn_parse.FromCloudFormation.getString(properties.Version)), ret.addPropertyResult("additionalInstanceConfiguration", "AdditionalInstanceConfiguration", properties.AdditionalInstanceConfiguration != null ? CfnImageRecipeAdditionalInstanceConfigurationPropertyFromCloudFormation(properties.AdditionalInstanceConfiguration) : void 0), ret.addPropertyResult("blockDeviceMappings", "BlockDeviceMappings", properties.BlockDeviceMappings != null ? cfn_parse.FromCloudFormation.getArray(CfnImageRecipeInstanceBlockDeviceMappingPropertyFromCloudFormation)(properties.BlockDeviceMappings) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addPropertyResult("workingDirectory", "WorkingDirectory", properties.WorkingDirectory != null ? cfn_parse.FromCloudFormation.getString(properties.WorkingDirectory) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnImageRecipe = class _CfnImageRecipe extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnImageRecipePropsFromCloudFormation(resourceProperties), ret = new _CfnImageRecipe(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnImageRecipe.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_imagebuilder_CfnImageRecipeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnImageRecipe), error;
        }
        cdk.requireProperty(props, "components", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "parentImage", this), cdk.requireProperty(props, "version", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.components = props.components, this.name = props.name, this.parentImage = props.parentImage, this.version = props.version, this.additionalInstanceConfiguration = props.additionalInstanceConfiguration, this.blockDeviceMappings = props.blockDeviceMappings, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::ImageBuilder::ImageRecipe", props.tags, { tagPropertyName: "tags" }), this.workingDirectory = props.workingDirectory;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnImageRecipe.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { components: this.components, name: this.name, parentImage: this.parentImage, version: this.version, additionalInstanceConfiguration: this.additionalInstanceConfiguration, blockDeviceMappings: this.blockDeviceMappings, description: this.description, tags: this.tags.renderTags(), workingDirectory: this.workingDirectory };
      }
      renderProperties(props) {
        return cfnImageRecipePropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnImageRecipe[_f] = { fqn: "aws-cdk-lib.aws_imagebuilder.CfnImageRecipe", version: "2.80.0" }, CfnImageRecipe.CFN_RESOURCE_TYPE_NAME = "AWS::ImageBuilder::ImageRecipe", exports2.CfnImageRecipe = CfnImageRecipe;
    function CfnImageRecipe_AdditionalInstanceConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("systemsManagerAgent", CfnImageRecipe_SystemsManagerAgentPropertyValidator)(properties.systemsManagerAgent)), errors.collect(cdk.propertyValidator("userDataOverride", cdk.validateString)(properties.userDataOverride)), errors.wrap('supplied properties not correct for "AdditionalInstanceConfigurationProperty"');
    }
    function cfnImageRecipeAdditionalInstanceConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnImageRecipe_AdditionalInstanceConfigurationPropertyValidator(properties).assertSuccess(), { SystemsManagerAgent: cfnImageRecipeSystemsManagerAgentPropertyToCloudFormation(properties.systemsManagerAgent), UserDataOverride: cdk.stringToCloudFormation(properties.userDataOverride) }) : properties;
    }
    function CfnImageRecipeAdditionalInstanceConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("systemsManagerAgent", "SystemsManagerAgent", properties.SystemsManagerAgent != null ? CfnImageRecipeSystemsManagerAgentPropertyFromCloudFormation(properties.SystemsManagerAgent) : void 0), ret.addPropertyResult("userDataOverride", "UserDataOverride", properties.UserDataOverride != null ? cfn_parse.FromCloudFormation.getString(properties.UserDataOverride) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnImageRecipe_ComponentConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("componentArn", cdk.validateString)(properties.componentArn)), errors.collect(cdk.propertyValidator("parameters", cdk.listValidator(CfnImageRecipe_ComponentParameterPropertyValidator))(properties.parameters)), errors.wrap('supplied properties not correct for "ComponentConfigurationProperty"');
    }
    function cfnImageRecipeComponentConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnImageRecipe_ComponentConfigurationPropertyValidator(properties).assertSuccess(), { ComponentArn: cdk.stringToCloudFormation(properties.componentArn), Parameters: cdk.listMapper(cfnImageRecipeComponentParameterPropertyToCloudFormation)(properties.parameters) }) : properties;
    }
    function CfnImageRecipeComponentConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("componentArn", "ComponentArn", properties.ComponentArn != null ? cfn_parse.FromCloudFormation.getString(properties.ComponentArn) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getArray(CfnImageRecipeComponentParameterPropertyFromCloudFormation)(properties.Parameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnImageRecipe_ComponentParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.listValidator(cdk.validateString))(properties.value)), errors.wrap('supplied properties not correct for "ComponentParameterProperty"');
    }
    function cfnImageRecipeComponentParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnImageRecipe_ComponentParameterPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cdk.listMapper(cdk.stringToCloudFormation)(properties.value) }) : properties;
    }
    function CfnImageRecipeComponentParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getStringArray(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnImageRecipe_EbsInstanceBlockDeviceSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deleteOnTermination", cdk.validateBoolean)(properties.deleteOnTermination)), errors.collect(cdk.propertyValidator("encrypted", cdk.validateBoolean)(properties.encrypted)), errors.collect(cdk.propertyValidator("iops", cdk.validateNumber)(properties.iops)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("snapshotId", cdk.validateString)(properties.snapshotId)), errors.collect(cdk.propertyValidator("throughput", cdk.validateNumber)(properties.throughput)), errors.collect(cdk.propertyValidator("volumeSize", cdk.validateNumber)(properties.volumeSize)), errors.collect(cdk.propertyValidator("volumeType", cdk.validateString)(properties.volumeType)), errors.wrap('supplied properties not correct for "EbsInstanceBlockDeviceSpecificationProperty"');
    }
    function cfnImageRecipeEbsInstanceBlockDeviceSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnImageRecipe_EbsInstanceBlockDeviceSpecificationPropertyValidator(properties).assertSuccess(), { DeleteOnTermination: cdk.booleanToCloudFormation(properties.deleteOnTermination), Encrypted: cdk.booleanToCloudFormation(properties.encrypted), Iops: cdk.numberToCloudFormation(properties.iops), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), SnapshotId: cdk.stringToCloudFormation(properties.snapshotId), Throughput: cdk.numberToCloudFormation(properties.throughput), VolumeSize: cdk.numberToCloudFormation(properties.volumeSize), VolumeType: cdk.stringToCloudFormation(properties.volumeType) }) : properties;
    }
    function CfnImageRecipeEbsInstanceBlockDeviceSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deleteOnTermination", "DeleteOnTermination", properties.DeleteOnTermination != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeleteOnTermination) : void 0), ret.addPropertyResult("encrypted", "Encrypted", properties.Encrypted != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Encrypted) : void 0), ret.addPropertyResult("iops", "Iops", properties.Iops != null ? cfn_parse.FromCloudFormation.getNumber(properties.Iops) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("snapshotId", "SnapshotId", properties.SnapshotId != null ? cfn_parse.FromCloudFormation.getString(properties.SnapshotId) : void 0), ret.addPropertyResult("throughput", "Throughput", properties.Throughput != null ? cfn_parse.FromCloudFormation.getNumber(properties.Throughput) : void 0), ret.addPropertyResult("volumeSize", "VolumeSize", properties.VolumeSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.VolumeSize) : void 0), ret.addPropertyResult("volumeType", "VolumeType", properties.VolumeType != null ? cfn_parse.FromCloudFormation.getString(properties.VolumeType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnImageRecipe_InstanceBlockDeviceMappingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deviceName", cdk.validateString)(properties.deviceName)), errors.collect(cdk.propertyValidator("ebs", CfnImageRecipe_EbsInstanceBlockDeviceSpecificationPropertyValidator)(properties.ebs)), errors.collect(cdk.propertyValidator("noDevice", cdk.validateString)(properties.noDevice)), errors.collect(cdk.propertyValidator("virtualName", cdk.validateString)(properties.virtualName)), errors.wrap('supplied properties not correct for "InstanceBlockDeviceMappingProperty"');
    }
    function cfnImageRecipeInstanceBlockDeviceMappingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnImageRecipe_InstanceBlockDeviceMappingPropertyValidator(properties).assertSuccess(), { DeviceName: cdk.stringToCloudFormation(properties.deviceName), Ebs: cfnImageRecipeEbsInstanceBlockDeviceSpecificationPropertyToCloudFormation(properties.ebs), NoDevice: cdk.stringToCloudFormation(properties.noDevice), VirtualName: cdk.stringToCloudFormation(properties.virtualName) }) : properties;
    }
    function CfnImageRecipeInstanceBlockDeviceMappingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deviceName", "DeviceName", properties.DeviceName != null ? cfn_parse.FromCloudFormation.getString(properties.DeviceName) : void 0), ret.addPropertyResult("ebs", "Ebs", properties.Ebs != null ? CfnImageRecipeEbsInstanceBlockDeviceSpecificationPropertyFromCloudFormation(properties.Ebs) : void 0), ret.addPropertyResult("noDevice", "NoDevice", properties.NoDevice != null ? cfn_parse.FromCloudFormation.getString(properties.NoDevice) : void 0), ret.addPropertyResult("virtualName", "VirtualName", properties.VirtualName != null ? cfn_parse.FromCloudFormation.getString(properties.VirtualName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnImageRecipe_SystemsManagerAgentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("uninstallAfterBuild", cdk.validateBoolean)(properties.uninstallAfterBuild)), errors.wrap('supplied properties not correct for "SystemsManagerAgentProperty"');
    }
    function cfnImageRecipeSystemsManagerAgentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnImageRecipe_SystemsManagerAgentPropertyValidator(properties).assertSuccess(), { UninstallAfterBuild: cdk.booleanToCloudFormation(properties.uninstallAfterBuild) }) : properties;
    }
    function CfnImageRecipeSystemsManagerAgentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("uninstallAfterBuild", "UninstallAfterBuild", properties.UninstallAfterBuild != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UninstallAfterBuild) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInfrastructureConfigurationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("instanceMetadataOptions", CfnInfrastructureConfiguration_InstanceMetadataOptionsPropertyValidator)(properties.instanceMetadataOptions)), errors.collect(cdk.propertyValidator("instanceProfileName", cdk.requiredValidator)(properties.instanceProfileName)), errors.collect(cdk.propertyValidator("instanceProfileName", cdk.validateString)(properties.instanceProfileName)), errors.collect(cdk.propertyValidator("instanceTypes", cdk.listValidator(cdk.validateString))(properties.instanceTypes)), errors.collect(cdk.propertyValidator("keyPair", cdk.validateString)(properties.keyPair)), errors.collect(cdk.propertyValidator("logging", CfnInfrastructureConfiguration_LoggingPropertyValidator)(properties.logging)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("resourceTags", cdk.hashValidator(cdk.validateString))(properties.resourceTags)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("snsTopicArn", cdk.validateString)(properties.snsTopicArn)), errors.collect(cdk.propertyValidator("subnetId", cdk.validateString)(properties.subnetId)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.collect(cdk.propertyValidator("terminateInstanceOnFailure", cdk.validateBoolean)(properties.terminateInstanceOnFailure)), errors.wrap('supplied properties not correct for "CfnInfrastructureConfigurationProps"');
    }
    function cfnInfrastructureConfigurationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInfrastructureConfigurationPropsValidator(properties).assertSuccess(), { InstanceProfileName: cdk.stringToCloudFormation(properties.instanceProfileName), Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), InstanceMetadataOptions: cfnInfrastructureConfigurationInstanceMetadataOptionsPropertyToCloudFormation(properties.instanceMetadataOptions), InstanceTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.instanceTypes), KeyPair: cdk.stringToCloudFormation(properties.keyPair), Logging: cfnInfrastructureConfigurationLoggingPropertyToCloudFormation(properties.logging), ResourceTags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.resourceTags), SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SnsTopicArn: cdk.stringToCloudFormation(properties.snsTopicArn), SubnetId: cdk.stringToCloudFormation(properties.subnetId), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags), TerminateInstanceOnFailure: cdk.booleanToCloudFormation(properties.terminateInstanceOnFailure) }) : properties;
    }
    function CfnInfrastructureConfigurationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceProfileName", "InstanceProfileName", cfn_parse.FromCloudFormation.getString(properties.InstanceProfileName)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("instanceMetadataOptions", "InstanceMetadataOptions", properties.InstanceMetadataOptions != null ? CfnInfrastructureConfigurationInstanceMetadataOptionsPropertyFromCloudFormation(properties.InstanceMetadataOptions) : void 0), ret.addPropertyResult("instanceTypes", "InstanceTypes", properties.InstanceTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.InstanceTypes) : void 0), ret.addPropertyResult("keyPair", "KeyPair", properties.KeyPair != null ? cfn_parse.FromCloudFormation.getString(properties.KeyPair) : void 0), ret.addPropertyResult("logging", "Logging", properties.Logging != null ? CfnInfrastructureConfigurationLoggingPropertyFromCloudFormation(properties.Logging) : void 0), ret.addPropertyResult("resourceTags", "ResourceTags", properties.ResourceTags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.ResourceTags) : void 0), ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("snsTopicArn", "SnsTopicArn", properties.SnsTopicArn != null ? cfn_parse.FromCloudFormation.getString(properties.SnsTopicArn) : void 0), ret.addPropertyResult("subnetId", "SubnetId", properties.SubnetId != null ? cfn_parse.FromCloudFormation.getString(properties.SubnetId) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addPropertyResult("terminateInstanceOnFailure", "TerminateInstanceOnFailure", properties.TerminateInstanceOnFailure != null ? cfn_parse.FromCloudFormation.getBoolean(properties.TerminateInstanceOnFailure) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnInfrastructureConfiguration = class _CfnInfrastructureConfiguration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnInfrastructureConfigurationPropsFromCloudFormation(resourceProperties), ret = new _CfnInfrastructureConfiguration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnInfrastructureConfiguration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_imagebuilder_CfnInfrastructureConfigurationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnInfrastructureConfiguration), error;
        }
        cdk.requireProperty(props, "instanceProfileName", this), cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.instanceProfileName = props.instanceProfileName, this.name = props.name, this.description = props.description, this.instanceMetadataOptions = props.instanceMetadataOptions, this.instanceTypes = props.instanceTypes, this.keyPair = props.keyPair, this.logging = props.logging, this.resourceTags = props.resourceTags, this.securityGroupIds = props.securityGroupIds, this.snsTopicArn = props.snsTopicArn, this.subnetId = props.subnetId, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::ImageBuilder::InfrastructureConfiguration", props.tags, { tagPropertyName: "tags" }), this.terminateInstanceOnFailure = props.terminateInstanceOnFailure;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnInfrastructureConfiguration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { instanceProfileName: this.instanceProfileName, name: this.name, description: this.description, instanceMetadataOptions: this.instanceMetadataOptions, instanceTypes: this.instanceTypes, keyPair: this.keyPair, logging: this.logging, resourceTags: this.resourceTags, securityGroupIds: this.securityGroupIds, snsTopicArn: this.snsTopicArn, subnetId: this.subnetId, tags: this.tags.renderTags(), terminateInstanceOnFailure: this.terminateInstanceOnFailure };
      }
      renderProperties(props) {
        return cfnInfrastructureConfigurationPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnInfrastructureConfiguration[_g] = { fqn: "aws-cdk-lib.aws_imagebuilder.CfnInfrastructureConfiguration", version: "2.80.0" }, CfnInfrastructureConfiguration.CFN_RESOURCE_TYPE_NAME = "AWS::ImageBuilder::InfrastructureConfiguration", exports2.CfnInfrastructureConfiguration = CfnInfrastructureConfiguration;
    function CfnInfrastructureConfiguration_InstanceMetadataOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("httpPutResponseHopLimit", cdk.validateNumber)(properties.httpPutResponseHopLimit)), errors.collect(cdk.propertyValidator("httpTokens", cdk.validateString)(properties.httpTokens)), errors.wrap('supplied properties not correct for "InstanceMetadataOptionsProperty"');
    }
    function cfnInfrastructureConfigurationInstanceMetadataOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInfrastructureConfiguration_InstanceMetadataOptionsPropertyValidator(properties).assertSuccess(), { HttpPutResponseHopLimit: cdk.numberToCloudFormation(properties.httpPutResponseHopLimit), HttpTokens: cdk.stringToCloudFormation(properties.httpTokens) }) : properties;
    }
    function CfnInfrastructureConfigurationInstanceMetadataOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("httpPutResponseHopLimit", "HttpPutResponseHopLimit", properties.HttpPutResponseHopLimit != null ? cfn_parse.FromCloudFormation.getNumber(properties.HttpPutResponseHopLimit) : void 0), ret.addPropertyResult("httpTokens", "HttpTokens", properties.HttpTokens != null ? cfn_parse.FromCloudFormation.getString(properties.HttpTokens) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInfrastructureConfiguration_LoggingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3Logs", CfnInfrastructureConfiguration_S3LogsPropertyValidator)(properties.s3Logs)), errors.wrap('supplied properties not correct for "LoggingProperty"');
    }
    function cfnInfrastructureConfigurationLoggingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInfrastructureConfiguration_LoggingPropertyValidator(properties).assertSuccess(), { S3Logs: cfnInfrastructureConfigurationS3LogsPropertyToCloudFormation(properties.s3Logs) }) : properties;
    }
    function CfnInfrastructureConfigurationLoggingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Logs", "S3Logs", properties.S3Logs != null ? CfnInfrastructureConfigurationS3LogsPropertyFromCloudFormation(properties.S3Logs) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInfrastructureConfiguration_S3LogsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3BucketName", cdk.validateString)(properties.s3BucketName)), errors.collect(cdk.propertyValidator("s3KeyPrefix", cdk.validateString)(properties.s3KeyPrefix)), errors.wrap('supplied properties not correct for "S3LogsProperty"');
    }
    function cfnInfrastructureConfigurationS3LogsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInfrastructureConfiguration_S3LogsPropertyValidator(properties).assertSuccess(), { S3BucketName: cdk.stringToCloudFormation(properties.s3BucketName), S3KeyPrefix: cdk.stringToCloudFormation(properties.s3KeyPrefix) }) : properties;
    }
    function CfnInfrastructureConfigurationS3LogsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3BucketName", "S3BucketName", properties.S3BucketName != null ? cfn_parse.FromCloudFormation.getString(properties.S3BucketName) : void 0), ret.addPropertyResult("s3KeyPrefix", "S3KeyPrefix", properties.S3KeyPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.S3KeyPrefix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-imagebuilder/lib/index.js
var require_lib145 = __commonJS({
  "node_modules/aws-cdk-lib/aws-imagebuilder/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_imagebuilder_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-imagebuilder/index.js
var require_aws_imagebuilder = __commonJS({
  "node_modules/aws-cdk-lib/aws-imagebuilder/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib145(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-inspector/lib/inspector.generated.js
var require_inspector_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-inspector/lib/inspector.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnResourceGroup = exports2.CfnAssessmentTemplate = exports2.CfnAssessmentTarget = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAssessmentTargetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("assessmentTargetName", cdk.validateString)(properties.assessmentTargetName)), errors.collect(cdk.propertyValidator("resourceGroupArn", cdk.validateString)(properties.resourceGroupArn)), errors.wrap('supplied properties not correct for "CfnAssessmentTargetProps"');
    }
    function cfnAssessmentTargetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssessmentTargetPropsValidator(properties).assertSuccess(), { AssessmentTargetName: cdk.stringToCloudFormation(properties.assessmentTargetName), ResourceGroupArn: cdk.stringToCloudFormation(properties.resourceGroupArn) }) : properties;
    }
    function CfnAssessmentTargetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("assessmentTargetName", "AssessmentTargetName", properties.AssessmentTargetName != null ? cfn_parse.FromCloudFormation.getString(properties.AssessmentTargetName) : void 0), ret.addPropertyResult("resourceGroupArn", "ResourceGroupArn", properties.ResourceGroupArn != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceGroupArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAssessmentTarget = class _CfnAssessmentTarget extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAssessmentTargetPropsFromCloudFormation(resourceProperties), ret = new _CfnAssessmentTarget(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnAssessmentTarget.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_inspector_CfnAssessmentTargetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAssessmentTarget), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.assessmentTargetName = props.assessmentTargetName, this.resourceGroupArn = props.resourceGroupArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAssessmentTarget.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { assessmentTargetName: this.assessmentTargetName, resourceGroupArn: this.resourceGroupArn };
      }
      renderProperties(props) {
        return cfnAssessmentTargetPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAssessmentTarget[_a] = { fqn: "aws-cdk-lib.aws_inspector.CfnAssessmentTarget", version: "2.80.0" }, CfnAssessmentTarget.CFN_RESOURCE_TYPE_NAME = "AWS::Inspector::AssessmentTarget", exports2.CfnAssessmentTarget = CfnAssessmentTarget;
    function CfnAssessmentTemplatePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("assessmentTargetArn", cdk.requiredValidator)(properties.assessmentTargetArn)), errors.collect(cdk.propertyValidator("assessmentTargetArn", cdk.validateString)(properties.assessmentTargetArn)), errors.collect(cdk.propertyValidator("assessmentTemplateName", cdk.validateString)(properties.assessmentTemplateName)), errors.collect(cdk.propertyValidator("durationInSeconds", cdk.requiredValidator)(properties.durationInSeconds)), errors.collect(cdk.propertyValidator("durationInSeconds", cdk.validateNumber)(properties.durationInSeconds)), errors.collect(cdk.propertyValidator("rulesPackageArns", cdk.requiredValidator)(properties.rulesPackageArns)), errors.collect(cdk.propertyValidator("rulesPackageArns", cdk.listValidator(cdk.validateString))(properties.rulesPackageArns)), errors.collect(cdk.propertyValidator("userAttributesForFindings", cdk.listValidator(cdk.validateCfnTag))(properties.userAttributesForFindings)), errors.wrap('supplied properties not correct for "CfnAssessmentTemplateProps"');
    }
    function cfnAssessmentTemplatePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssessmentTemplatePropsValidator(properties).assertSuccess(), { AssessmentTargetArn: cdk.stringToCloudFormation(properties.assessmentTargetArn), DurationInSeconds: cdk.numberToCloudFormation(properties.durationInSeconds), RulesPackageArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.rulesPackageArns), AssessmentTemplateName: cdk.stringToCloudFormation(properties.assessmentTemplateName), UserAttributesForFindings: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.userAttributesForFindings) }) : properties;
    }
    function CfnAssessmentTemplatePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("assessmentTargetArn", "AssessmentTargetArn", cfn_parse.FromCloudFormation.getString(properties.AssessmentTargetArn)), ret.addPropertyResult("durationInSeconds", "DurationInSeconds", cfn_parse.FromCloudFormation.getNumber(properties.DurationInSeconds)), ret.addPropertyResult("rulesPackageArns", "RulesPackageArns", cfn_parse.FromCloudFormation.getStringArray(properties.RulesPackageArns)), ret.addPropertyResult("assessmentTemplateName", "AssessmentTemplateName", properties.AssessmentTemplateName != null ? cfn_parse.FromCloudFormation.getString(properties.AssessmentTemplateName) : void 0), ret.addPropertyResult("userAttributesForFindings", "UserAttributesForFindings", properties.UserAttributesForFindings != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.UserAttributesForFindings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAssessmentTemplate = class _CfnAssessmentTemplate extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAssessmentTemplatePropsFromCloudFormation(resourceProperties), ret = new _CfnAssessmentTemplate(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAssessmentTemplate.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_inspector_CfnAssessmentTemplateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAssessmentTemplate), error;
        }
        cdk.requireProperty(props, "assessmentTargetArn", this), cdk.requireProperty(props, "durationInSeconds", this), cdk.requireProperty(props, "rulesPackageArns", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.assessmentTargetArn = props.assessmentTargetArn, this.durationInSeconds = props.durationInSeconds, this.rulesPackageArns = props.rulesPackageArns, this.assessmentTemplateName = props.assessmentTemplateName, this.userAttributesForFindings = props.userAttributesForFindings;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAssessmentTemplate.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { assessmentTargetArn: this.assessmentTargetArn, durationInSeconds: this.durationInSeconds, rulesPackageArns: this.rulesPackageArns, assessmentTemplateName: this.assessmentTemplateName, userAttributesForFindings: this.userAttributesForFindings };
      }
      renderProperties(props) {
        return cfnAssessmentTemplatePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnAssessmentTemplate[_b] = { fqn: "aws-cdk-lib.aws_inspector.CfnAssessmentTemplate", version: "2.80.0" }, CfnAssessmentTemplate.CFN_RESOURCE_TYPE_NAME = "AWS::Inspector::AssessmentTemplate", exports2.CfnAssessmentTemplate = CfnAssessmentTemplate;
    function CfnResourceGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceGroupTags", cdk.requiredValidator)(properties.resourceGroupTags)), errors.collect(cdk.propertyValidator("resourceGroupTags", cdk.listValidator(cdk.validateCfnTag))(properties.resourceGroupTags)), errors.wrap('supplied properties not correct for "CfnResourceGroupProps"');
    }
    function cfnResourceGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceGroupPropsValidator(properties).assertSuccess(), { ResourceGroupTags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.resourceGroupTags) }) : properties;
    }
    function CfnResourceGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceGroupTags", "ResourceGroupTags", cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.ResourceGroupTags)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResourceGroup = class _CfnResourceGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResourceGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnResourceGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnResourceGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_inspector_CfnResourceGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResourceGroup), error;
        }
        cdk.requireProperty(props, "resourceGroupTags", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.resourceGroupTags = props.resourceGroupTags;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResourceGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { resourceGroupTags: this.resourceGroupTags };
      }
      renderProperties(props) {
        return cfnResourceGroupPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnResourceGroup[_c] = { fqn: "aws-cdk-lib.aws_inspector.CfnResourceGroup", version: "2.80.0" }, CfnResourceGroup.CFN_RESOURCE_TYPE_NAME = "AWS::Inspector::ResourceGroup", exports2.CfnResourceGroup = CfnResourceGroup;
  }
});

// node_modules/aws-cdk-lib/aws-inspector/lib/index.js
var require_lib146 = __commonJS({
  "node_modules/aws-cdk-lib/aws-inspector/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_inspector_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-inspector/index.js
var require_aws_inspector = __commonJS({
  "node_modules/aws-cdk-lib/aws-inspector/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib146(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-inspectorv2/lib/inspectorv2.generated.js
var require_inspectorv2_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-inspectorv2/lib/inspectorv2.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnFilter = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnFilterPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("filterAction", cdk.requiredValidator)(properties.filterAction)), errors.collect(cdk.propertyValidator("filterAction", cdk.validateString)(properties.filterAction)), errors.collect(cdk.propertyValidator("filterCriteria", cdk.requiredValidator)(properties.filterCriteria)), errors.collect(cdk.propertyValidator("filterCriteria", CfnFilter_FilterCriteriaPropertyValidator)(properties.filterCriteria)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "CfnFilterProps"');
    }
    function cfnFilterPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFilterPropsValidator(properties).assertSuccess(), { FilterAction: cdk.stringToCloudFormation(properties.filterAction), FilterCriteria: cfnFilterFilterCriteriaPropertyToCloudFormation(properties.filterCriteria), Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description) }) : properties;
    }
    function CfnFilterPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("filterAction", "FilterAction", cfn_parse.FromCloudFormation.getString(properties.FilterAction)), ret.addPropertyResult("filterCriteria", "FilterCriteria", CfnFilterFilterCriteriaPropertyFromCloudFormation(properties.FilterCriteria)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFilter = class _CfnFilter extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFilterPropsFromCloudFormation(resourceProperties), ret = new _CfnFilter(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFilter.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_inspectorv2_CfnFilterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFilter), error;
        }
        cdk.requireProperty(props, "filterAction", this), cdk.requireProperty(props, "filterCriteria", this), cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.filterAction = props.filterAction, this.filterCriteria = props.filterCriteria, this.name = props.name, this.description = props.description;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFilter.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { filterAction: this.filterAction, filterCriteria: this.filterCriteria, name: this.name, description: this.description };
      }
      renderProperties(props) {
        return cfnFilterPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnFilter[_a] = { fqn: "aws-cdk-lib.aws_inspectorv2.CfnFilter", version: "2.80.0" }, CfnFilter.CFN_RESOURCE_TYPE_NAME = "AWS::InspectorV2::Filter", exports2.CfnFilter = CfnFilter;
    function CfnFilter_DateFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endInclusive", cdk.validateNumber)(properties.endInclusive)), errors.collect(cdk.propertyValidator("startInclusive", cdk.validateNumber)(properties.startInclusive)), errors.wrap('supplied properties not correct for "DateFilterProperty"');
    }
    function cfnFilterDateFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFilter_DateFilterPropertyValidator(properties).assertSuccess(), { EndInclusive: cdk.numberToCloudFormation(properties.endInclusive), StartInclusive: cdk.numberToCloudFormation(properties.startInclusive) }) : properties;
    }
    function CfnFilterDateFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endInclusive", "EndInclusive", properties.EndInclusive != null ? cfn_parse.FromCloudFormation.getNumber(properties.EndInclusive) : void 0), ret.addPropertyResult("startInclusive", "StartInclusive", properties.StartInclusive != null ? cfn_parse.FromCloudFormation.getNumber(properties.StartInclusive) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFilter_FilterCriteriaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("awsAccountId", cdk.listValidator(CfnFilter_StringFilterPropertyValidator))(properties.awsAccountId)), errors.collect(cdk.propertyValidator("componentId", cdk.listValidator(CfnFilter_StringFilterPropertyValidator))(properties.componentId)), errors.collect(cdk.propertyValidator("componentType", cdk.listValidator(CfnFilter_StringFilterPropertyValidator))(properties.componentType)), errors.collect(cdk.propertyValidator("ec2InstanceImageId", cdk.listValidator(CfnFilter_StringFilterPropertyValidator))(properties.ec2InstanceImageId)), errors.collect(cdk.propertyValidator("ec2InstanceSubnetId", cdk.listValidator(CfnFilter_StringFilterPropertyValidator))(properties.ec2InstanceSubnetId)), errors.collect(cdk.propertyValidator("ec2InstanceVpcId", cdk.listValidator(CfnFilter_StringFilterPropertyValidator))(properties.ec2InstanceVpcId)), errors.collect(cdk.propertyValidator("ecrImageArchitecture", cdk.listValidator(CfnFilter_StringFilterPropertyValidator))(properties.ecrImageArchitecture)), errors.collect(cdk.propertyValidator("ecrImageHash", cdk.listValidator(CfnFilter_StringFilterPropertyValidator))(properties.ecrImageHash)), errors.collect(cdk.propertyValidator("ecrImagePushedAt", cdk.listValidator(CfnFilter_DateFilterPropertyValidator))(properties.ecrImagePushedAt)), errors.collect(cdk.propertyValidator("ecrImageRegistry", cdk.listValidator(CfnFilter_StringFilterPropertyValidator))(properties.ecrImageRegistry)), errors.collect(cdk.propertyValidator("ecrImageRepositoryName", cdk.listValidator(CfnFilter_StringFilterPropertyValidator))(properties.ecrImageRepositoryName)), errors.collect(cdk.propertyValidator("ecrImageTags", cdk.listValidator(CfnFilter_StringFilterPropertyValidator))(properties.ecrImageTags)), errors.collect(cdk.propertyValidator("findingArn", cdk.listValidator(CfnFilter_StringFilterPropertyValidator))(properties.findingArn)), errors.collect(cdk.propertyValidator("findingStatus", cdk.listValidator(CfnFilter_StringFilterPropertyValidator))(properties.findingStatus)), errors.collect(cdk.propertyValidator("findingType", cdk.listValidator(CfnFilter_StringFilterPropertyValidator))(properties.findingType)), errors.collect(cdk.propertyValidator("firstObservedAt", cdk.listValidator(CfnFilter_DateFilterPropertyValidator))(properties.firstObservedAt)), errors.collect(cdk.propertyValidator("inspectorScore", cdk.listValidator(CfnFilter_NumberFilterPropertyValidator))(properties.inspectorScore)), errors.collect(cdk.propertyValidator("lastObservedAt", cdk.listValidator(CfnFilter_DateFilterPropertyValidator))(properties.lastObservedAt)), errors.collect(cdk.propertyValidator("networkProtocol", cdk.listValidator(CfnFilter_StringFilterPropertyValidator))(properties.networkProtocol)), errors.collect(cdk.propertyValidator("portRange", cdk.listValidator(CfnFilter_PortRangeFilterPropertyValidator))(properties.portRange)), errors.collect(cdk.propertyValidator("relatedVulnerabilities", cdk.listValidator(CfnFilter_StringFilterPropertyValidator))(properties.relatedVulnerabilities)), errors.collect(cdk.propertyValidator("resourceId", cdk.listValidator(CfnFilter_StringFilterPropertyValidator))(properties.resourceId)), errors.collect(cdk.propertyValidator("resourceTags", cdk.listValidator(CfnFilter_MapFilterPropertyValidator))(properties.resourceTags)), errors.collect(cdk.propertyValidator("resourceType", cdk.listValidator(CfnFilter_StringFilterPropertyValidator))(properties.resourceType)), errors.collect(cdk.propertyValidator("severity", cdk.listValidator(CfnFilter_StringFilterPropertyValidator))(properties.severity)), errors.collect(cdk.propertyValidator("title", cdk.listValidator(CfnFilter_StringFilterPropertyValidator))(properties.title)), errors.collect(cdk.propertyValidator("updatedAt", cdk.listValidator(CfnFilter_DateFilterPropertyValidator))(properties.updatedAt)), errors.collect(cdk.propertyValidator("vendorSeverity", cdk.listValidator(CfnFilter_StringFilterPropertyValidator))(properties.vendorSeverity)), errors.collect(cdk.propertyValidator("vulnerabilityId", cdk.listValidator(CfnFilter_StringFilterPropertyValidator))(properties.vulnerabilityId)), errors.collect(cdk.propertyValidator("vulnerabilitySource", cdk.listValidator(CfnFilter_StringFilterPropertyValidator))(properties.vulnerabilitySource)), errors.collect(cdk.propertyValidator("vulnerablePackages", cdk.listValidator(CfnFilter_PackageFilterPropertyValidator))(properties.vulnerablePackages)), errors.wrap('supplied properties not correct for "FilterCriteriaProperty"');
    }
    function cfnFilterFilterCriteriaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFilter_FilterCriteriaPropertyValidator(properties).assertSuccess(), { AwsAccountId: cdk.listMapper(cfnFilterStringFilterPropertyToCloudFormation)(properties.awsAccountId), ComponentId: cdk.listMapper(cfnFilterStringFilterPropertyToCloudFormation)(properties.componentId), ComponentType: cdk.listMapper(cfnFilterStringFilterPropertyToCloudFormation)(properties.componentType), Ec2InstanceImageId: cdk.listMapper(cfnFilterStringFilterPropertyToCloudFormation)(properties.ec2InstanceImageId), Ec2InstanceSubnetId: cdk.listMapper(cfnFilterStringFilterPropertyToCloudFormation)(properties.ec2InstanceSubnetId), Ec2InstanceVpcId: cdk.listMapper(cfnFilterStringFilterPropertyToCloudFormation)(properties.ec2InstanceVpcId), EcrImageArchitecture: cdk.listMapper(cfnFilterStringFilterPropertyToCloudFormation)(properties.ecrImageArchitecture), EcrImageHash: cdk.listMapper(cfnFilterStringFilterPropertyToCloudFormation)(properties.ecrImageHash), EcrImagePushedAt: cdk.listMapper(cfnFilterDateFilterPropertyToCloudFormation)(properties.ecrImagePushedAt), EcrImageRegistry: cdk.listMapper(cfnFilterStringFilterPropertyToCloudFormation)(properties.ecrImageRegistry), EcrImageRepositoryName: cdk.listMapper(cfnFilterStringFilterPropertyToCloudFormation)(properties.ecrImageRepositoryName), EcrImageTags: cdk.listMapper(cfnFilterStringFilterPropertyToCloudFormation)(properties.ecrImageTags), FindingArn: cdk.listMapper(cfnFilterStringFilterPropertyToCloudFormation)(properties.findingArn), FindingStatus: cdk.listMapper(cfnFilterStringFilterPropertyToCloudFormation)(properties.findingStatus), FindingType: cdk.listMapper(cfnFilterStringFilterPropertyToCloudFormation)(properties.findingType), FirstObservedAt: cdk.listMapper(cfnFilterDateFilterPropertyToCloudFormation)(properties.firstObservedAt), InspectorScore: cdk.listMapper(cfnFilterNumberFilterPropertyToCloudFormation)(properties.inspectorScore), LastObservedAt: cdk.listMapper(cfnFilterDateFilterPropertyToCloudFormation)(properties.lastObservedAt), NetworkProtocol: cdk.listMapper(cfnFilterStringFilterPropertyToCloudFormation)(properties.networkProtocol), PortRange: cdk.listMapper(cfnFilterPortRangeFilterPropertyToCloudFormation)(properties.portRange), RelatedVulnerabilities: cdk.listMapper(cfnFilterStringFilterPropertyToCloudFormation)(properties.relatedVulnerabilities), ResourceId: cdk.listMapper(cfnFilterStringFilterPropertyToCloudFormation)(properties.resourceId), ResourceTags: cdk.listMapper(cfnFilterMapFilterPropertyToCloudFormation)(properties.resourceTags), ResourceType: cdk.listMapper(cfnFilterStringFilterPropertyToCloudFormation)(properties.resourceType), Severity: cdk.listMapper(cfnFilterStringFilterPropertyToCloudFormation)(properties.severity), Title: cdk.listMapper(cfnFilterStringFilterPropertyToCloudFormation)(properties.title), UpdatedAt: cdk.listMapper(cfnFilterDateFilterPropertyToCloudFormation)(properties.updatedAt), VendorSeverity: cdk.listMapper(cfnFilterStringFilterPropertyToCloudFormation)(properties.vendorSeverity), VulnerabilityId: cdk.listMapper(cfnFilterStringFilterPropertyToCloudFormation)(properties.vulnerabilityId), VulnerabilitySource: cdk.listMapper(cfnFilterStringFilterPropertyToCloudFormation)(properties.vulnerabilitySource), VulnerablePackages: cdk.listMapper(cfnFilterPackageFilterPropertyToCloudFormation)(properties.vulnerablePackages) }) : properties;
    }
    function CfnFilterFilterCriteriaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("awsAccountId", "AwsAccountId", properties.AwsAccountId != null ? cfn_parse.FromCloudFormation.getArray(CfnFilterStringFilterPropertyFromCloudFormation)(properties.AwsAccountId) : void 0), ret.addPropertyResult("componentId", "ComponentId", properties.ComponentId != null ? cfn_parse.FromCloudFormation.getArray(CfnFilterStringFilterPropertyFromCloudFormation)(properties.ComponentId) : void 0), ret.addPropertyResult("componentType", "ComponentType", properties.ComponentType != null ? cfn_parse.FromCloudFormation.getArray(CfnFilterStringFilterPropertyFromCloudFormation)(properties.ComponentType) : void 0), ret.addPropertyResult("ec2InstanceImageId", "Ec2InstanceImageId", properties.Ec2InstanceImageId != null ? cfn_parse.FromCloudFormation.getArray(CfnFilterStringFilterPropertyFromCloudFormation)(properties.Ec2InstanceImageId) : void 0), ret.addPropertyResult("ec2InstanceSubnetId", "Ec2InstanceSubnetId", properties.Ec2InstanceSubnetId != null ? cfn_parse.FromCloudFormation.getArray(CfnFilterStringFilterPropertyFromCloudFormation)(properties.Ec2InstanceSubnetId) : void 0), ret.addPropertyResult("ec2InstanceVpcId", "Ec2InstanceVpcId", properties.Ec2InstanceVpcId != null ? cfn_parse.FromCloudFormation.getArray(CfnFilterStringFilterPropertyFromCloudFormation)(properties.Ec2InstanceVpcId) : void 0), ret.addPropertyResult("ecrImageArchitecture", "EcrImageArchitecture", properties.EcrImageArchitecture != null ? cfn_parse.FromCloudFormation.getArray(CfnFilterStringFilterPropertyFromCloudFormation)(properties.EcrImageArchitecture) : void 0), ret.addPropertyResult("ecrImageHash", "EcrImageHash", properties.EcrImageHash != null ? cfn_parse.FromCloudFormation.getArray(CfnFilterStringFilterPropertyFromCloudFormation)(properties.EcrImageHash) : void 0), ret.addPropertyResult("ecrImagePushedAt", "EcrImagePushedAt", properties.EcrImagePushedAt != null ? cfn_parse.FromCloudFormation.getArray(CfnFilterDateFilterPropertyFromCloudFormation)(properties.EcrImagePushedAt) : void 0), ret.addPropertyResult("ecrImageRegistry", "EcrImageRegistry", properties.EcrImageRegistry != null ? cfn_parse.FromCloudFormation.getArray(CfnFilterStringFilterPropertyFromCloudFormation)(properties.EcrImageRegistry) : void 0), ret.addPropertyResult("ecrImageRepositoryName", "EcrImageRepositoryName", properties.EcrImageRepositoryName != null ? cfn_parse.FromCloudFormation.getArray(CfnFilterStringFilterPropertyFromCloudFormation)(properties.EcrImageRepositoryName) : void 0), ret.addPropertyResult("ecrImageTags", "EcrImageTags", properties.EcrImageTags != null ? cfn_parse.FromCloudFormation.getArray(CfnFilterStringFilterPropertyFromCloudFormation)(properties.EcrImageTags) : void 0), ret.addPropertyResult("findingArn", "FindingArn", properties.FindingArn != null ? cfn_parse.FromCloudFormation.getArray(CfnFilterStringFilterPropertyFromCloudFormation)(properties.FindingArn) : void 0), ret.addPropertyResult("findingStatus", "FindingStatus", properties.FindingStatus != null ? cfn_parse.FromCloudFormation.getArray(CfnFilterStringFilterPropertyFromCloudFormation)(properties.FindingStatus) : void 0), ret.addPropertyResult("findingType", "FindingType", properties.FindingType != null ? cfn_parse.FromCloudFormation.getArray(CfnFilterStringFilterPropertyFromCloudFormation)(properties.FindingType) : void 0), ret.addPropertyResult("firstObservedAt", "FirstObservedAt", properties.FirstObservedAt != null ? cfn_parse.FromCloudFormation.getArray(CfnFilterDateFilterPropertyFromCloudFormation)(properties.FirstObservedAt) : void 0), ret.addPropertyResult("inspectorScore", "InspectorScore", properties.InspectorScore != null ? cfn_parse.FromCloudFormation.getArray(CfnFilterNumberFilterPropertyFromCloudFormation)(properties.InspectorScore) : void 0), ret.addPropertyResult("lastObservedAt", "LastObservedAt", properties.LastObservedAt != null ? cfn_parse.FromCloudFormation.getArray(CfnFilterDateFilterPropertyFromCloudFormation)(properties.LastObservedAt) : void 0), ret.addPropertyResult("networkProtocol", "NetworkProtocol", properties.NetworkProtocol != null ? cfn_parse.FromCloudFormation.getArray(CfnFilterStringFilterPropertyFromCloudFormation)(properties.NetworkProtocol) : void 0), ret.addPropertyResult("portRange", "PortRange", properties.PortRange != null ? cfn_parse.FromCloudFormation.getArray(CfnFilterPortRangeFilterPropertyFromCloudFormation)(properties.PortRange) : void 0), ret.addPropertyResult("relatedVulnerabilities", "RelatedVulnerabilities", properties.RelatedVulnerabilities != null ? cfn_parse.FromCloudFormation.getArray(CfnFilterStringFilterPropertyFromCloudFormation)(properties.RelatedVulnerabilities) : void 0), ret.addPropertyResult("resourceId", "ResourceId", properties.ResourceId != null ? cfn_parse.FromCloudFormation.getArray(CfnFilterStringFilterPropertyFromCloudFormation)(properties.ResourceId) : void 0), ret.addPropertyResult("resourceTags", "ResourceTags", properties.ResourceTags != null ? cfn_parse.FromCloudFormation.getArray(CfnFilterMapFilterPropertyFromCloudFormation)(properties.ResourceTags) : void 0), ret.addPropertyResult("resourceType", "ResourceType", properties.ResourceType != null ? cfn_parse.FromCloudFormation.getArray(CfnFilterStringFilterPropertyFromCloudFormation)(properties.ResourceType) : void 0), ret.addPropertyResult("severity", "Severity", properties.Severity != null ? cfn_parse.FromCloudFormation.getArray(CfnFilterStringFilterPropertyFromCloudFormation)(properties.Severity) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? cfn_parse.FromCloudFormation.getArray(CfnFilterStringFilterPropertyFromCloudFormation)(properties.Title) : void 0), ret.addPropertyResult("updatedAt", "UpdatedAt", properties.UpdatedAt != null ? cfn_parse.FromCloudFormation.getArray(CfnFilterDateFilterPropertyFromCloudFormation)(properties.UpdatedAt) : void 0), ret.addPropertyResult("vendorSeverity", "VendorSeverity", properties.VendorSeverity != null ? cfn_parse.FromCloudFormation.getArray(CfnFilterStringFilterPropertyFromCloudFormation)(properties.VendorSeverity) : void 0), ret.addPropertyResult("vulnerabilityId", "VulnerabilityId", properties.VulnerabilityId != null ? cfn_parse.FromCloudFormation.getArray(CfnFilterStringFilterPropertyFromCloudFormation)(properties.VulnerabilityId) : void 0), ret.addPropertyResult("vulnerabilitySource", "VulnerabilitySource", properties.VulnerabilitySource != null ? cfn_parse.FromCloudFormation.getArray(CfnFilterStringFilterPropertyFromCloudFormation)(properties.VulnerabilitySource) : void 0), ret.addPropertyResult("vulnerablePackages", "VulnerablePackages", properties.VulnerablePackages != null ? cfn_parse.FromCloudFormation.getArray(CfnFilterPackageFilterPropertyFromCloudFormation)(properties.VulnerablePackages) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFilter_MapFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("comparison", cdk.requiredValidator)(properties.comparison)), errors.collect(cdk.propertyValidator("comparison", cdk.validateString)(properties.comparison)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "MapFilterProperty"');
    }
    function cfnFilterMapFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFilter_MapFilterPropertyValidator(properties).assertSuccess(), { Comparison: cdk.stringToCloudFormation(properties.comparison), Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnFilterMapFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("comparison", "Comparison", cfn_parse.FromCloudFormation.getString(properties.Comparison)), ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFilter_NumberFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("lowerInclusive", cdk.validateNumber)(properties.lowerInclusive)), errors.collect(cdk.propertyValidator("upperInclusive", cdk.validateNumber)(properties.upperInclusive)), errors.wrap('supplied properties not correct for "NumberFilterProperty"');
    }
    function cfnFilterNumberFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFilter_NumberFilterPropertyValidator(properties).assertSuccess(), { LowerInclusive: cdk.numberToCloudFormation(properties.lowerInclusive), UpperInclusive: cdk.numberToCloudFormation(properties.upperInclusive) }) : properties;
    }
    function CfnFilterNumberFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("lowerInclusive", "LowerInclusive", properties.LowerInclusive != null ? cfn_parse.FromCloudFormation.getNumber(properties.LowerInclusive) : void 0), ret.addPropertyResult("upperInclusive", "UpperInclusive", properties.UpperInclusive != null ? cfn_parse.FromCloudFormation.getNumber(properties.UpperInclusive) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFilter_PackageFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("architecture", CfnFilter_StringFilterPropertyValidator)(properties.architecture)), errors.collect(cdk.propertyValidator("epoch", CfnFilter_NumberFilterPropertyValidator)(properties.epoch)), errors.collect(cdk.propertyValidator("name", CfnFilter_StringFilterPropertyValidator)(properties.name)), errors.collect(cdk.propertyValidator("release", CfnFilter_StringFilterPropertyValidator)(properties.release)), errors.collect(cdk.propertyValidator("sourceLayerHash", CfnFilter_StringFilterPropertyValidator)(properties.sourceLayerHash)), errors.collect(cdk.propertyValidator("version", CfnFilter_StringFilterPropertyValidator)(properties.version)), errors.wrap('supplied properties not correct for "PackageFilterProperty"');
    }
    function cfnFilterPackageFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFilter_PackageFilterPropertyValidator(properties).assertSuccess(), { Architecture: cfnFilterStringFilterPropertyToCloudFormation(properties.architecture), Epoch: cfnFilterNumberFilterPropertyToCloudFormation(properties.epoch), Name: cfnFilterStringFilterPropertyToCloudFormation(properties.name), Release: cfnFilterStringFilterPropertyToCloudFormation(properties.release), SourceLayerHash: cfnFilterStringFilterPropertyToCloudFormation(properties.sourceLayerHash), Version: cfnFilterStringFilterPropertyToCloudFormation(properties.version) }) : properties;
    }
    function CfnFilterPackageFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("architecture", "Architecture", properties.Architecture != null ? CfnFilterStringFilterPropertyFromCloudFormation(properties.Architecture) : void 0), ret.addPropertyResult("epoch", "Epoch", properties.Epoch != null ? CfnFilterNumberFilterPropertyFromCloudFormation(properties.Epoch) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? CfnFilterStringFilterPropertyFromCloudFormation(properties.Name) : void 0), ret.addPropertyResult("release", "Release", properties.Release != null ? CfnFilterStringFilterPropertyFromCloudFormation(properties.Release) : void 0), ret.addPropertyResult("sourceLayerHash", "SourceLayerHash", properties.SourceLayerHash != null ? CfnFilterStringFilterPropertyFromCloudFormation(properties.SourceLayerHash) : void 0), ret.addPropertyResult("version", "Version", properties.Version != null ? CfnFilterStringFilterPropertyFromCloudFormation(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFilter_PortRangeFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("beginInclusive", cdk.validateNumber)(properties.beginInclusive)), errors.collect(cdk.propertyValidator("endInclusive", cdk.validateNumber)(properties.endInclusive)), errors.wrap('supplied properties not correct for "PortRangeFilterProperty"');
    }
    function cfnFilterPortRangeFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFilter_PortRangeFilterPropertyValidator(properties).assertSuccess(), { BeginInclusive: cdk.numberToCloudFormation(properties.beginInclusive), EndInclusive: cdk.numberToCloudFormation(properties.endInclusive) }) : properties;
    }
    function CfnFilterPortRangeFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("beginInclusive", "BeginInclusive", properties.BeginInclusive != null ? cfn_parse.FromCloudFormation.getNumber(properties.BeginInclusive) : void 0), ret.addPropertyResult("endInclusive", "EndInclusive", properties.EndInclusive != null ? cfn_parse.FromCloudFormation.getNumber(properties.EndInclusive) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFilter_StringFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("comparison", cdk.requiredValidator)(properties.comparison)), errors.collect(cdk.propertyValidator("comparison", cdk.validateString)(properties.comparison)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "StringFilterProperty"');
    }
    function cfnFilterStringFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFilter_StringFilterPropertyValidator(properties).assertSuccess(), { Comparison: cdk.stringToCloudFormation(properties.comparison), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnFilterStringFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("comparison", "Comparison", cfn_parse.FromCloudFormation.getString(properties.Comparison)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-inspectorv2/lib/index.js
var require_lib147 = __commonJS({
  "node_modules/aws-cdk-lib/aws-inspectorv2/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_inspectorv2_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-inspectorv2/index.js
var require_aws_inspectorv2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-inspectorv2/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib147(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-internetmonitor/lib/internetmonitor.generated.js
var require_internetmonitor_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-internetmonitor/lib/internetmonitor.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnMonitor = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnMonitorPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("internetMeasurementsLogDelivery", CfnMonitor_InternetMeasurementsLogDeliveryPropertyValidator)(properties.internetMeasurementsLogDelivery)), errors.collect(cdk.propertyValidator("maxCityNetworksToMonitor", cdk.validateNumber)(properties.maxCityNetworksToMonitor)), errors.collect(cdk.propertyValidator("monitorName", cdk.requiredValidator)(properties.monitorName)), errors.collect(cdk.propertyValidator("monitorName", cdk.validateString)(properties.monitorName)), errors.collect(cdk.propertyValidator("resources", cdk.listValidator(cdk.validateString))(properties.resources)), errors.collect(cdk.propertyValidator("resourcesToAdd", cdk.listValidator(cdk.validateString))(properties.resourcesToAdd)), errors.collect(cdk.propertyValidator("resourcesToRemove", cdk.listValidator(cdk.validateString))(properties.resourcesToRemove)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("trafficPercentageToMonitor", cdk.validateNumber)(properties.trafficPercentageToMonitor)), errors.wrap('supplied properties not correct for "CfnMonitorProps"');
    }
    function cfnMonitorPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMonitorPropsValidator(properties).assertSuccess(), { MonitorName: cdk.stringToCloudFormation(properties.monitorName), InternetMeasurementsLogDelivery: cfnMonitorInternetMeasurementsLogDeliveryPropertyToCloudFormation(properties.internetMeasurementsLogDelivery), MaxCityNetworksToMonitor: cdk.numberToCloudFormation(properties.maxCityNetworksToMonitor), Resources: cdk.listMapper(cdk.stringToCloudFormation)(properties.resources), ResourcesToAdd: cdk.listMapper(cdk.stringToCloudFormation)(properties.resourcesToAdd), ResourcesToRemove: cdk.listMapper(cdk.stringToCloudFormation)(properties.resourcesToRemove), Status: cdk.stringToCloudFormation(properties.status), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TrafficPercentageToMonitor: cdk.numberToCloudFormation(properties.trafficPercentageToMonitor) }) : properties;
    }
    function CfnMonitorPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("monitorName", "MonitorName", cfn_parse.FromCloudFormation.getString(properties.MonitorName)), ret.addPropertyResult("internetMeasurementsLogDelivery", "InternetMeasurementsLogDelivery", properties.InternetMeasurementsLogDelivery != null ? CfnMonitorInternetMeasurementsLogDeliveryPropertyFromCloudFormation(properties.InternetMeasurementsLogDelivery) : void 0), ret.addPropertyResult("maxCityNetworksToMonitor", "MaxCityNetworksToMonitor", properties.MaxCityNetworksToMonitor != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxCityNetworksToMonitor) : void 0), ret.addPropertyResult("resources", "Resources", properties.Resources != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Resources) : void 0), ret.addPropertyResult("resourcesToAdd", "ResourcesToAdd", properties.ResourcesToAdd != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ResourcesToAdd) : void 0), ret.addPropertyResult("resourcesToRemove", "ResourcesToRemove", properties.ResourcesToRemove != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ResourcesToRemove) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("trafficPercentageToMonitor", "TrafficPercentageToMonitor", properties.TrafficPercentageToMonitor != null ? cfn_parse.FromCloudFormation.getNumber(properties.TrafficPercentageToMonitor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnMonitor = class _CfnMonitor extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnMonitorPropsFromCloudFormation(resourceProperties), ret = new _CfnMonitor(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnMonitor.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_internetmonitor_CfnMonitorProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnMonitor), error;
        }
        cdk.requireProperty(props, "monitorName", this), this.attrCreatedAt = cdk.Token.asString(this.getAtt("CreatedAt", cdk.ResolutionTypeHint.STRING)), this.attrModifiedAt = cdk.Token.asString(this.getAtt("ModifiedAt", cdk.ResolutionTypeHint.STRING)), this.attrMonitorArn = cdk.Token.asString(this.getAtt("MonitorArn", cdk.ResolutionTypeHint.STRING)), this.attrProcessingStatus = cdk.Token.asString(this.getAtt("ProcessingStatus", cdk.ResolutionTypeHint.STRING)), this.attrProcessingStatusInfo = cdk.Token.asString(this.getAtt("ProcessingStatusInfo", cdk.ResolutionTypeHint.STRING)), this.monitorName = props.monitorName, this.internetMeasurementsLogDelivery = props.internetMeasurementsLogDelivery, this.maxCityNetworksToMonitor = props.maxCityNetworksToMonitor, this.resources = props.resources, this.resourcesToAdd = props.resourcesToAdd, this.resourcesToRemove = props.resourcesToRemove, this.status = props.status, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::InternetMonitor::Monitor", props.tags, { tagPropertyName: "tags" }), this.trafficPercentageToMonitor = props.trafficPercentageToMonitor;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnMonitor.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { monitorName: this.monitorName, internetMeasurementsLogDelivery: this.internetMeasurementsLogDelivery, maxCityNetworksToMonitor: this.maxCityNetworksToMonitor, resources: this.resources, resourcesToAdd: this.resourcesToAdd, resourcesToRemove: this.resourcesToRemove, status: this.status, tags: this.tags.renderTags(), trafficPercentageToMonitor: this.trafficPercentageToMonitor };
      }
      renderProperties(props) {
        return cfnMonitorPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnMonitor[_a] = { fqn: "aws-cdk-lib.aws_internetmonitor.CfnMonitor", version: "2.80.0" }, CfnMonitor.CFN_RESOURCE_TYPE_NAME = "AWS::InternetMonitor::Monitor", exports2.CfnMonitor = CfnMonitor;
    function CfnMonitor_InternetMeasurementsLogDeliveryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3Config", CfnMonitor_S3ConfigPropertyValidator)(properties.s3Config)), errors.wrap('supplied properties not correct for "InternetMeasurementsLogDeliveryProperty"');
    }
    function cfnMonitorInternetMeasurementsLogDeliveryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMonitor_InternetMeasurementsLogDeliveryPropertyValidator(properties).assertSuccess(), { S3Config: cfnMonitorS3ConfigPropertyToCloudFormation(properties.s3Config) }) : properties;
    }
    function CfnMonitorInternetMeasurementsLogDeliveryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Config", "S3Config", properties.S3Config != null ? CfnMonitorS3ConfigPropertyFromCloudFormation(properties.S3Config) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMonitor_S3ConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketPrefix", cdk.validateString)(properties.bucketPrefix)), errors.collect(cdk.propertyValidator("logDeliveryStatus", cdk.validateString)(properties.logDeliveryStatus)), errors.wrap('supplied properties not correct for "S3ConfigProperty"');
    }
    function cfnMonitorS3ConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMonitor_S3ConfigPropertyValidator(properties).assertSuccess(), { BucketName: cdk.stringToCloudFormation(properties.bucketName), BucketPrefix: cdk.stringToCloudFormation(properties.bucketPrefix), LogDeliveryStatus: cdk.stringToCloudFormation(properties.logDeliveryStatus) }) : properties;
    }
    function CfnMonitorS3ConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketName", "BucketName", properties.BucketName != null ? cfn_parse.FromCloudFormation.getString(properties.BucketName) : void 0), ret.addPropertyResult("bucketPrefix", "BucketPrefix", properties.BucketPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.BucketPrefix) : void 0), ret.addPropertyResult("logDeliveryStatus", "LogDeliveryStatus", properties.LogDeliveryStatus != null ? cfn_parse.FromCloudFormation.getString(properties.LogDeliveryStatus) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-internetmonitor/lib/index.js
var require_lib148 = __commonJS({
  "node_modules/aws-cdk-lib/aws-internetmonitor/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_internetmonitor_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-internetmonitor/index.js
var require_aws_internetmonitor = __commonJS({
  "node_modules/aws-cdk-lib/aws-internetmonitor/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib148(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-iot/lib/iot.generated.js
var require_iot_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-iot/lib/iot.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    var _l;
    var _m;
    var _o;
    var _p;
    var _q;
    var _r;
    var _s;
    var _t;
    var _u;
    var _v;
    var _w;
    var _x;
    var _y;
    var _z;
    var _0;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnTopicRuleDestination = exports2.CfnTopicRule = exports2.CfnThingType = exports2.CfnThingPrincipalAttachment = exports2.CfnThingGroup = exports2.CfnThing = exports2.CfnSecurityProfile = exports2.CfnScheduledAudit = exports2.CfnRoleAlias = exports2.CfnResourceSpecificLogging = exports2.CfnProvisioningTemplate = exports2.CfnPolicyPrincipalAttachment = exports2.CfnPolicy = exports2.CfnMitigationAction = exports2.CfnLogging = exports2.CfnJobTemplate = exports2.CfnFleetMetric = exports2.CfnDomainConfiguration = exports2.CfnDimension = exports2.CfnCustomMetric = exports2.CfnCertificate = exports2.CfnCACertificate = exports2.CfnBillingGroup = exports2.CfnAuthorizer = exports2.CfnAccountAuditConfiguration = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAccountAuditConfigurationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accountId", cdk.requiredValidator)(properties.accountId)), errors.collect(cdk.propertyValidator("accountId", cdk.validateString)(properties.accountId)), errors.collect(cdk.propertyValidator("auditCheckConfigurations", cdk.requiredValidator)(properties.auditCheckConfigurations)), errors.collect(cdk.propertyValidator("auditCheckConfigurations", CfnAccountAuditConfiguration_AuditCheckConfigurationsPropertyValidator)(properties.auditCheckConfigurations)), errors.collect(cdk.propertyValidator("auditNotificationTargetConfigurations", CfnAccountAuditConfiguration_AuditNotificationTargetConfigurationsPropertyValidator)(properties.auditNotificationTargetConfigurations)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "CfnAccountAuditConfigurationProps"');
    }
    function cfnAccountAuditConfigurationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccountAuditConfigurationPropsValidator(properties).assertSuccess(), { AccountId: cdk.stringToCloudFormation(properties.accountId), AuditCheckConfigurations: cfnAccountAuditConfigurationAuditCheckConfigurationsPropertyToCloudFormation(properties.auditCheckConfigurations), RoleArn: cdk.stringToCloudFormation(properties.roleArn), AuditNotificationTargetConfigurations: cfnAccountAuditConfigurationAuditNotificationTargetConfigurationsPropertyToCloudFormation(properties.auditNotificationTargetConfigurations) }) : properties;
    }
    function CfnAccountAuditConfigurationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accountId", "AccountId", cfn_parse.FromCloudFormation.getString(properties.AccountId)), ret.addPropertyResult("auditCheckConfigurations", "AuditCheckConfigurations", CfnAccountAuditConfigurationAuditCheckConfigurationsPropertyFromCloudFormation(properties.AuditCheckConfigurations)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("auditNotificationTargetConfigurations", "AuditNotificationTargetConfigurations", properties.AuditNotificationTargetConfigurations != null ? CfnAccountAuditConfigurationAuditNotificationTargetConfigurationsPropertyFromCloudFormation(properties.AuditNotificationTargetConfigurations) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAccountAuditConfiguration = class _CfnAccountAuditConfiguration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAccountAuditConfigurationPropsFromCloudFormation(resourceProperties), ret = new _CfnAccountAuditConfiguration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAccountAuditConfiguration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iot_CfnAccountAuditConfigurationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAccountAuditConfiguration), error;
        }
        cdk.requireProperty(props, "accountId", this), cdk.requireProperty(props, "auditCheckConfigurations", this), cdk.requireProperty(props, "roleArn", this), this.accountId = props.accountId, this.auditCheckConfigurations = props.auditCheckConfigurations, this.roleArn = props.roleArn, this.auditNotificationTargetConfigurations = props.auditNotificationTargetConfigurations;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAccountAuditConfiguration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { accountId: this.accountId, auditCheckConfigurations: this.auditCheckConfigurations, roleArn: this.roleArn, auditNotificationTargetConfigurations: this.auditNotificationTargetConfigurations };
      }
      renderProperties(props) {
        return cfnAccountAuditConfigurationPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAccountAuditConfiguration[_a] = { fqn: "aws-cdk-lib.aws_iot.CfnAccountAuditConfiguration", version: "2.80.0" }, CfnAccountAuditConfiguration.CFN_RESOURCE_TYPE_NAME = "AWS::IoT::AccountAuditConfiguration", exports2.CfnAccountAuditConfiguration = CfnAccountAuditConfiguration;
    function CfnAccountAuditConfiguration_AuditCheckConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "AuditCheckConfigurationProperty"');
    }
    function cfnAccountAuditConfigurationAuditCheckConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccountAuditConfiguration_AuditCheckConfigurationPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnAccountAuditConfigurationAuditCheckConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAccountAuditConfiguration_AuditCheckConfigurationsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authenticatedCognitoRoleOverlyPermissiveCheck", CfnAccountAuditConfiguration_AuditCheckConfigurationPropertyValidator)(properties.authenticatedCognitoRoleOverlyPermissiveCheck)), errors.collect(cdk.propertyValidator("caCertificateExpiringCheck", CfnAccountAuditConfiguration_AuditCheckConfigurationPropertyValidator)(properties.caCertificateExpiringCheck)), errors.collect(cdk.propertyValidator("caCertificateKeyQualityCheck", CfnAccountAuditConfiguration_AuditCheckConfigurationPropertyValidator)(properties.caCertificateKeyQualityCheck)), errors.collect(cdk.propertyValidator("conflictingClientIdsCheck", CfnAccountAuditConfiguration_AuditCheckConfigurationPropertyValidator)(properties.conflictingClientIdsCheck)), errors.collect(cdk.propertyValidator("deviceCertificateExpiringCheck", CfnAccountAuditConfiguration_AuditCheckConfigurationPropertyValidator)(properties.deviceCertificateExpiringCheck)), errors.collect(cdk.propertyValidator("deviceCertificateKeyQualityCheck", CfnAccountAuditConfiguration_AuditCheckConfigurationPropertyValidator)(properties.deviceCertificateKeyQualityCheck)), errors.collect(cdk.propertyValidator("deviceCertificateSharedCheck", CfnAccountAuditConfiguration_AuditCheckConfigurationPropertyValidator)(properties.deviceCertificateSharedCheck)), errors.collect(cdk.propertyValidator("intermediateCaRevokedForActiveDeviceCertificatesCheck", CfnAccountAuditConfiguration_AuditCheckConfigurationPropertyValidator)(properties.intermediateCaRevokedForActiveDeviceCertificatesCheck)), errors.collect(cdk.propertyValidator("ioTPolicyPotentialMisConfigurationCheck", CfnAccountAuditConfiguration_AuditCheckConfigurationPropertyValidator)(properties.ioTPolicyPotentialMisConfigurationCheck)), errors.collect(cdk.propertyValidator("iotPolicyOverlyPermissiveCheck", CfnAccountAuditConfiguration_AuditCheckConfigurationPropertyValidator)(properties.iotPolicyOverlyPermissiveCheck)), errors.collect(cdk.propertyValidator("iotRoleAliasAllowsAccessToUnusedServicesCheck", CfnAccountAuditConfiguration_AuditCheckConfigurationPropertyValidator)(properties.iotRoleAliasAllowsAccessToUnusedServicesCheck)), errors.collect(cdk.propertyValidator("iotRoleAliasOverlyPermissiveCheck", CfnAccountAuditConfiguration_AuditCheckConfigurationPropertyValidator)(properties.iotRoleAliasOverlyPermissiveCheck)), errors.collect(cdk.propertyValidator("loggingDisabledCheck", CfnAccountAuditConfiguration_AuditCheckConfigurationPropertyValidator)(properties.loggingDisabledCheck)), errors.collect(cdk.propertyValidator("revokedCaCertificateStillActiveCheck", CfnAccountAuditConfiguration_AuditCheckConfigurationPropertyValidator)(properties.revokedCaCertificateStillActiveCheck)), errors.collect(cdk.propertyValidator("revokedDeviceCertificateStillActiveCheck", CfnAccountAuditConfiguration_AuditCheckConfigurationPropertyValidator)(properties.revokedDeviceCertificateStillActiveCheck)), errors.collect(cdk.propertyValidator("unauthenticatedCognitoRoleOverlyPermissiveCheck", CfnAccountAuditConfiguration_AuditCheckConfigurationPropertyValidator)(properties.unauthenticatedCognitoRoleOverlyPermissiveCheck)), errors.wrap('supplied properties not correct for "AuditCheckConfigurationsProperty"');
    }
    function cfnAccountAuditConfigurationAuditCheckConfigurationsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccountAuditConfiguration_AuditCheckConfigurationsPropertyValidator(properties).assertSuccess(), { AuthenticatedCognitoRoleOverlyPermissiveCheck: cfnAccountAuditConfigurationAuditCheckConfigurationPropertyToCloudFormation(properties.authenticatedCognitoRoleOverlyPermissiveCheck), CaCertificateExpiringCheck: cfnAccountAuditConfigurationAuditCheckConfigurationPropertyToCloudFormation(properties.caCertificateExpiringCheck), CaCertificateKeyQualityCheck: cfnAccountAuditConfigurationAuditCheckConfigurationPropertyToCloudFormation(properties.caCertificateKeyQualityCheck), ConflictingClientIdsCheck: cfnAccountAuditConfigurationAuditCheckConfigurationPropertyToCloudFormation(properties.conflictingClientIdsCheck), DeviceCertificateExpiringCheck: cfnAccountAuditConfigurationAuditCheckConfigurationPropertyToCloudFormation(properties.deviceCertificateExpiringCheck), DeviceCertificateKeyQualityCheck: cfnAccountAuditConfigurationAuditCheckConfigurationPropertyToCloudFormation(properties.deviceCertificateKeyQualityCheck), DeviceCertificateSharedCheck: cfnAccountAuditConfigurationAuditCheckConfigurationPropertyToCloudFormation(properties.deviceCertificateSharedCheck), IntermediateCaRevokedForActiveDeviceCertificatesCheck: cfnAccountAuditConfigurationAuditCheckConfigurationPropertyToCloudFormation(properties.intermediateCaRevokedForActiveDeviceCertificatesCheck), IoTPolicyPotentialMisConfigurationCheck: cfnAccountAuditConfigurationAuditCheckConfigurationPropertyToCloudFormation(properties.ioTPolicyPotentialMisConfigurationCheck), IotPolicyOverlyPermissiveCheck: cfnAccountAuditConfigurationAuditCheckConfigurationPropertyToCloudFormation(properties.iotPolicyOverlyPermissiveCheck), IotRoleAliasAllowsAccessToUnusedServicesCheck: cfnAccountAuditConfigurationAuditCheckConfigurationPropertyToCloudFormation(properties.iotRoleAliasAllowsAccessToUnusedServicesCheck), IotRoleAliasOverlyPermissiveCheck: cfnAccountAuditConfigurationAuditCheckConfigurationPropertyToCloudFormation(properties.iotRoleAliasOverlyPermissiveCheck), LoggingDisabledCheck: cfnAccountAuditConfigurationAuditCheckConfigurationPropertyToCloudFormation(properties.loggingDisabledCheck), RevokedCaCertificateStillActiveCheck: cfnAccountAuditConfigurationAuditCheckConfigurationPropertyToCloudFormation(properties.revokedCaCertificateStillActiveCheck), RevokedDeviceCertificateStillActiveCheck: cfnAccountAuditConfigurationAuditCheckConfigurationPropertyToCloudFormation(properties.revokedDeviceCertificateStillActiveCheck), UnauthenticatedCognitoRoleOverlyPermissiveCheck: cfnAccountAuditConfigurationAuditCheckConfigurationPropertyToCloudFormation(properties.unauthenticatedCognitoRoleOverlyPermissiveCheck) }) : properties;
    }
    function CfnAccountAuditConfigurationAuditCheckConfigurationsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authenticatedCognitoRoleOverlyPermissiveCheck", "AuthenticatedCognitoRoleOverlyPermissiveCheck", properties.AuthenticatedCognitoRoleOverlyPermissiveCheck != null ? CfnAccountAuditConfigurationAuditCheckConfigurationPropertyFromCloudFormation(properties.AuthenticatedCognitoRoleOverlyPermissiveCheck) : void 0), ret.addPropertyResult("caCertificateExpiringCheck", "CaCertificateExpiringCheck", properties.CaCertificateExpiringCheck != null ? CfnAccountAuditConfigurationAuditCheckConfigurationPropertyFromCloudFormation(properties.CaCertificateExpiringCheck) : void 0), ret.addPropertyResult("caCertificateKeyQualityCheck", "CaCertificateKeyQualityCheck", properties.CaCertificateKeyQualityCheck != null ? CfnAccountAuditConfigurationAuditCheckConfigurationPropertyFromCloudFormation(properties.CaCertificateKeyQualityCheck) : void 0), ret.addPropertyResult("conflictingClientIdsCheck", "ConflictingClientIdsCheck", properties.ConflictingClientIdsCheck != null ? CfnAccountAuditConfigurationAuditCheckConfigurationPropertyFromCloudFormation(properties.ConflictingClientIdsCheck) : void 0), ret.addPropertyResult("deviceCertificateExpiringCheck", "DeviceCertificateExpiringCheck", properties.DeviceCertificateExpiringCheck != null ? CfnAccountAuditConfigurationAuditCheckConfigurationPropertyFromCloudFormation(properties.DeviceCertificateExpiringCheck) : void 0), ret.addPropertyResult("deviceCertificateKeyQualityCheck", "DeviceCertificateKeyQualityCheck", properties.DeviceCertificateKeyQualityCheck != null ? CfnAccountAuditConfigurationAuditCheckConfigurationPropertyFromCloudFormation(properties.DeviceCertificateKeyQualityCheck) : void 0), ret.addPropertyResult("deviceCertificateSharedCheck", "DeviceCertificateSharedCheck", properties.DeviceCertificateSharedCheck != null ? CfnAccountAuditConfigurationAuditCheckConfigurationPropertyFromCloudFormation(properties.DeviceCertificateSharedCheck) : void 0), ret.addPropertyResult("intermediateCaRevokedForActiveDeviceCertificatesCheck", "IntermediateCaRevokedForActiveDeviceCertificatesCheck", properties.IntermediateCaRevokedForActiveDeviceCertificatesCheck != null ? CfnAccountAuditConfigurationAuditCheckConfigurationPropertyFromCloudFormation(properties.IntermediateCaRevokedForActiveDeviceCertificatesCheck) : void 0), ret.addPropertyResult("ioTPolicyPotentialMisConfigurationCheck", "IoTPolicyPotentialMisConfigurationCheck", properties.IoTPolicyPotentialMisConfigurationCheck != null ? CfnAccountAuditConfigurationAuditCheckConfigurationPropertyFromCloudFormation(properties.IoTPolicyPotentialMisConfigurationCheck) : void 0), ret.addPropertyResult("iotPolicyOverlyPermissiveCheck", "IotPolicyOverlyPermissiveCheck", properties.IotPolicyOverlyPermissiveCheck != null ? CfnAccountAuditConfigurationAuditCheckConfigurationPropertyFromCloudFormation(properties.IotPolicyOverlyPermissiveCheck) : void 0), ret.addPropertyResult("iotRoleAliasAllowsAccessToUnusedServicesCheck", "IotRoleAliasAllowsAccessToUnusedServicesCheck", properties.IotRoleAliasAllowsAccessToUnusedServicesCheck != null ? CfnAccountAuditConfigurationAuditCheckConfigurationPropertyFromCloudFormation(properties.IotRoleAliasAllowsAccessToUnusedServicesCheck) : void 0), ret.addPropertyResult("iotRoleAliasOverlyPermissiveCheck", "IotRoleAliasOverlyPermissiveCheck", properties.IotRoleAliasOverlyPermissiveCheck != null ? CfnAccountAuditConfigurationAuditCheckConfigurationPropertyFromCloudFormation(properties.IotRoleAliasOverlyPermissiveCheck) : void 0), ret.addPropertyResult("loggingDisabledCheck", "LoggingDisabledCheck", properties.LoggingDisabledCheck != null ? CfnAccountAuditConfigurationAuditCheckConfigurationPropertyFromCloudFormation(properties.LoggingDisabledCheck) : void 0), ret.addPropertyResult("revokedCaCertificateStillActiveCheck", "RevokedCaCertificateStillActiveCheck", properties.RevokedCaCertificateStillActiveCheck != null ? CfnAccountAuditConfigurationAuditCheckConfigurationPropertyFromCloudFormation(properties.RevokedCaCertificateStillActiveCheck) : void 0), ret.addPropertyResult("revokedDeviceCertificateStillActiveCheck", "RevokedDeviceCertificateStillActiveCheck", properties.RevokedDeviceCertificateStillActiveCheck != null ? CfnAccountAuditConfigurationAuditCheckConfigurationPropertyFromCloudFormation(properties.RevokedDeviceCertificateStillActiveCheck) : void 0), ret.addPropertyResult("unauthenticatedCognitoRoleOverlyPermissiveCheck", "UnauthenticatedCognitoRoleOverlyPermissiveCheck", properties.UnauthenticatedCognitoRoleOverlyPermissiveCheck != null ? CfnAccountAuditConfigurationAuditCheckConfigurationPropertyFromCloudFormation(properties.UnauthenticatedCognitoRoleOverlyPermissiveCheck) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAccountAuditConfiguration_AuditNotificationTargetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("targetArn", cdk.validateString)(properties.targetArn)), errors.wrap('supplied properties not correct for "AuditNotificationTargetProperty"');
    }
    function cfnAccountAuditConfigurationAuditNotificationTargetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccountAuditConfiguration_AuditNotificationTargetPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled), RoleArn: cdk.stringToCloudFormation(properties.roleArn), TargetArn: cdk.stringToCloudFormation(properties.targetArn) }) : properties;
    }
    function CfnAccountAuditConfigurationAuditNotificationTargetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addPropertyResult("targetArn", "TargetArn", properties.TargetArn != null ? cfn_parse.FromCloudFormation.getString(properties.TargetArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAccountAuditConfiguration_AuditNotificationTargetConfigurationsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sns", CfnAccountAuditConfiguration_AuditNotificationTargetPropertyValidator)(properties.sns)), errors.wrap('supplied properties not correct for "AuditNotificationTargetConfigurationsProperty"');
    }
    function cfnAccountAuditConfigurationAuditNotificationTargetConfigurationsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccountAuditConfiguration_AuditNotificationTargetConfigurationsPropertyValidator(properties).assertSuccess(), { Sns: cfnAccountAuditConfigurationAuditNotificationTargetPropertyToCloudFormation(properties.sns) }) : properties;
    }
    function CfnAccountAuditConfigurationAuditNotificationTargetConfigurationsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sns", "Sns", properties.Sns != null ? CfnAccountAuditConfigurationAuditNotificationTargetPropertyFromCloudFormation(properties.Sns) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAuthorizerPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authorizerFunctionArn", cdk.requiredValidator)(properties.authorizerFunctionArn)), errors.collect(cdk.propertyValidator("authorizerFunctionArn", cdk.validateString)(properties.authorizerFunctionArn)), errors.collect(cdk.propertyValidator("authorizerName", cdk.validateString)(properties.authorizerName)), errors.collect(cdk.propertyValidator("enableCachingForHttp", cdk.validateBoolean)(properties.enableCachingForHttp)), errors.collect(cdk.propertyValidator("signingDisabled", cdk.validateBoolean)(properties.signingDisabled)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("tokenKeyName", cdk.validateString)(properties.tokenKeyName)), errors.collect(cdk.propertyValidator("tokenSigningPublicKeys", cdk.hashValidator(cdk.validateString))(properties.tokenSigningPublicKeys)), errors.wrap('supplied properties not correct for "CfnAuthorizerProps"');
    }
    function cfnAuthorizerPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAuthorizerPropsValidator(properties).assertSuccess(), { AuthorizerFunctionArn: cdk.stringToCloudFormation(properties.authorizerFunctionArn), AuthorizerName: cdk.stringToCloudFormation(properties.authorizerName), EnableCachingForHttp: cdk.booleanToCloudFormation(properties.enableCachingForHttp), SigningDisabled: cdk.booleanToCloudFormation(properties.signingDisabled), Status: cdk.stringToCloudFormation(properties.status), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TokenKeyName: cdk.stringToCloudFormation(properties.tokenKeyName), TokenSigningPublicKeys: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tokenSigningPublicKeys) }) : properties;
    }
    function CfnAuthorizerPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authorizerFunctionArn", "AuthorizerFunctionArn", cfn_parse.FromCloudFormation.getString(properties.AuthorizerFunctionArn)), ret.addPropertyResult("authorizerName", "AuthorizerName", properties.AuthorizerName != null ? cfn_parse.FromCloudFormation.getString(properties.AuthorizerName) : void 0), ret.addPropertyResult("enableCachingForHttp", "EnableCachingForHttp", properties.EnableCachingForHttp != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableCachingForHttp) : void 0), ret.addPropertyResult("signingDisabled", "SigningDisabled", properties.SigningDisabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SigningDisabled) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("tokenKeyName", "TokenKeyName", properties.TokenKeyName != null ? cfn_parse.FromCloudFormation.getString(properties.TokenKeyName) : void 0), ret.addPropertyResult("tokenSigningPublicKeys", "TokenSigningPublicKeys", properties.TokenSigningPublicKeys != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.TokenSigningPublicKeys) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAuthorizer = class _CfnAuthorizer extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAuthorizerPropsFromCloudFormation(resourceProperties), ret = new _CfnAuthorizer(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAuthorizer.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iot_CfnAuthorizerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAuthorizer), error;
        }
        cdk.requireProperty(props, "authorizerFunctionArn", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.authorizerFunctionArn = props.authorizerFunctionArn, this.authorizerName = props.authorizerName, this.enableCachingForHttp = props.enableCachingForHttp, this.signingDisabled = props.signingDisabled, this.status = props.status, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoT::Authorizer", props.tags, { tagPropertyName: "tags" }), this.tokenKeyName = props.tokenKeyName, this.tokenSigningPublicKeys = props.tokenSigningPublicKeys;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAuthorizer.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { authorizerFunctionArn: this.authorizerFunctionArn, authorizerName: this.authorizerName, enableCachingForHttp: this.enableCachingForHttp, signingDisabled: this.signingDisabled, status: this.status, tags: this.tags.renderTags(), tokenKeyName: this.tokenKeyName, tokenSigningPublicKeys: this.tokenSigningPublicKeys };
      }
      renderProperties(props) {
        return cfnAuthorizerPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnAuthorizer[_b] = { fqn: "aws-cdk-lib.aws_iot.CfnAuthorizer", version: "2.80.0" }, CfnAuthorizer.CFN_RESOURCE_TYPE_NAME = "AWS::IoT::Authorizer", exports2.CfnAuthorizer = CfnAuthorizer;
    function CfnBillingGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("billingGroupName", cdk.validateString)(properties.billingGroupName)), errors.collect(cdk.propertyValidator("billingGroupProperties", CfnBillingGroup_BillingGroupPropertiesPropertyValidator)(properties.billingGroupProperties)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnBillingGroupProps"');
    }
    function cfnBillingGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBillingGroupPropsValidator(properties).assertSuccess(), { BillingGroupName: cdk.stringToCloudFormation(properties.billingGroupName), BillingGroupProperties: cfnBillingGroupBillingGroupPropertiesPropertyToCloudFormation(properties.billingGroupProperties), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnBillingGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("billingGroupName", "BillingGroupName", properties.BillingGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.BillingGroupName) : void 0), ret.addPropertyResult("billingGroupProperties", "BillingGroupProperties", properties.BillingGroupProperties != null ? CfnBillingGroupBillingGroupPropertiesPropertyFromCloudFormation(properties.BillingGroupProperties) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnBillingGroup = class _CfnBillingGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnBillingGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnBillingGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnBillingGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iot_CfnBillingGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnBillingGroup), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.billingGroupName = props.billingGroupName, this.billingGroupProperties = props.billingGroupProperties, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoT::BillingGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnBillingGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { billingGroupName: this.billingGroupName, billingGroupProperties: this.billingGroupProperties, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnBillingGroupPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnBillingGroup[_c] = { fqn: "aws-cdk-lib.aws_iot.CfnBillingGroup", version: "2.80.0" }, CfnBillingGroup.CFN_RESOURCE_TYPE_NAME = "AWS::IoT::BillingGroup", exports2.CfnBillingGroup = CfnBillingGroup;
    function CfnBillingGroup_BillingGroupPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("billingGroupDescription", cdk.validateString)(properties.billingGroupDescription)), errors.wrap('supplied properties not correct for "BillingGroupPropertiesProperty"');
    }
    function cfnBillingGroupBillingGroupPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBillingGroup_BillingGroupPropertiesPropertyValidator(properties).assertSuccess(), { BillingGroupDescription: cdk.stringToCloudFormation(properties.billingGroupDescription) }) : properties;
    }
    function CfnBillingGroupBillingGroupPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("billingGroupDescription", "BillingGroupDescription", properties.BillingGroupDescription != null ? cfn_parse.FromCloudFormation.getString(properties.BillingGroupDescription) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCACertificatePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoRegistrationStatus", cdk.validateString)(properties.autoRegistrationStatus)), errors.collect(cdk.propertyValidator("caCertificatePem", cdk.requiredValidator)(properties.caCertificatePem)), errors.collect(cdk.propertyValidator("caCertificatePem", cdk.validateString)(properties.caCertificatePem)), errors.collect(cdk.propertyValidator("certificateMode", cdk.validateString)(properties.certificateMode)), errors.collect(cdk.propertyValidator("registrationConfig", CfnCACertificate_RegistrationConfigPropertyValidator)(properties.registrationConfig)), errors.collect(cdk.propertyValidator("removeAutoRegistration", cdk.validateBoolean)(properties.removeAutoRegistration)), errors.collect(cdk.propertyValidator("status", cdk.requiredValidator)(properties.status)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("verificationCertificatePem", cdk.validateString)(properties.verificationCertificatePem)), errors.wrap('supplied properties not correct for "CfnCACertificateProps"');
    }
    function cfnCACertificatePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCACertificatePropsValidator(properties).assertSuccess(), { CACertificatePem: cdk.stringToCloudFormation(properties.caCertificatePem), Status: cdk.stringToCloudFormation(properties.status), AutoRegistrationStatus: cdk.stringToCloudFormation(properties.autoRegistrationStatus), CertificateMode: cdk.stringToCloudFormation(properties.certificateMode), RegistrationConfig: cfnCACertificateRegistrationConfigPropertyToCloudFormation(properties.registrationConfig), RemoveAutoRegistration: cdk.booleanToCloudFormation(properties.removeAutoRegistration), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VerificationCertificatePem: cdk.stringToCloudFormation(properties.verificationCertificatePem) }) : properties;
    }
    function CfnCACertificatePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("caCertificatePem", "CACertificatePem", cfn_parse.FromCloudFormation.getString(properties.CACertificatePem)), ret.addPropertyResult("status", "Status", cfn_parse.FromCloudFormation.getString(properties.Status)), ret.addPropertyResult("autoRegistrationStatus", "AutoRegistrationStatus", properties.AutoRegistrationStatus != null ? cfn_parse.FromCloudFormation.getString(properties.AutoRegistrationStatus) : void 0), ret.addPropertyResult("certificateMode", "CertificateMode", properties.CertificateMode != null ? cfn_parse.FromCloudFormation.getString(properties.CertificateMode) : void 0), ret.addPropertyResult("registrationConfig", "RegistrationConfig", properties.RegistrationConfig != null ? CfnCACertificateRegistrationConfigPropertyFromCloudFormation(properties.RegistrationConfig) : void 0), ret.addPropertyResult("removeAutoRegistration", "RemoveAutoRegistration", properties.RemoveAutoRegistration != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RemoveAutoRegistration) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("verificationCertificatePem", "VerificationCertificatePem", properties.VerificationCertificatePem != null ? cfn_parse.FromCloudFormation.getString(properties.VerificationCertificatePem) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCACertificate = class _CfnCACertificate extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCACertificatePropsFromCloudFormation(resourceProperties), ret = new _CfnCACertificate(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCACertificate.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iot_CfnCACertificateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCACertificate), error;
        }
        cdk.requireProperty(props, "caCertificatePem", this), cdk.requireProperty(props, "status", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.caCertificatePem = props.caCertificatePem, this.status = props.status, this.autoRegistrationStatus = props.autoRegistrationStatus, this.certificateMode = props.certificateMode, this.registrationConfig = props.registrationConfig, this.removeAutoRegistration = props.removeAutoRegistration, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoT::CACertificate", props.tags, { tagPropertyName: "tags" }), this.verificationCertificatePem = props.verificationCertificatePem;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCACertificate.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { caCertificatePem: this.caCertificatePem, status: this.status, autoRegistrationStatus: this.autoRegistrationStatus, certificateMode: this.certificateMode, registrationConfig: this.registrationConfig, removeAutoRegistration: this.removeAutoRegistration, tags: this.tags.renderTags(), verificationCertificatePem: this.verificationCertificatePem };
      }
      renderProperties(props) {
        return cfnCACertificatePropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnCACertificate[_d] = { fqn: "aws-cdk-lib.aws_iot.CfnCACertificate", version: "2.80.0" }, CfnCACertificate.CFN_RESOURCE_TYPE_NAME = "AWS::IoT::CACertificate", exports2.CfnCACertificate = CfnCACertificate;
    function CfnCACertificate_RegistrationConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("templateBody", cdk.validateString)(properties.templateBody)), errors.collect(cdk.propertyValidator("templateName", cdk.validateString)(properties.templateName)), errors.wrap('supplied properties not correct for "RegistrationConfigProperty"');
    }
    function cfnCACertificateRegistrationConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCACertificate_RegistrationConfigPropertyValidator(properties).assertSuccess(), { RoleArn: cdk.stringToCloudFormation(properties.roleArn), TemplateBody: cdk.stringToCloudFormation(properties.templateBody), TemplateName: cdk.stringToCloudFormation(properties.templateName) }) : properties;
    }
    function CfnCACertificateRegistrationConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addPropertyResult("templateBody", "TemplateBody", properties.TemplateBody != null ? cfn_parse.FromCloudFormation.getString(properties.TemplateBody) : void 0), ret.addPropertyResult("templateName", "TemplateName", properties.TemplateName != null ? cfn_parse.FromCloudFormation.getString(properties.TemplateName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCertificatePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("caCertificatePem", cdk.validateString)(properties.caCertificatePem)), errors.collect(cdk.propertyValidator("certificateMode", cdk.validateString)(properties.certificateMode)), errors.collect(cdk.propertyValidator("certificatePem", cdk.validateString)(properties.certificatePem)), errors.collect(cdk.propertyValidator("certificateSigningRequest", cdk.validateString)(properties.certificateSigningRequest)), errors.collect(cdk.propertyValidator("status", cdk.requiredValidator)(properties.status)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "CfnCertificateProps"');
    }
    function cfnCertificatePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificatePropsValidator(properties).assertSuccess(), { Status: cdk.stringToCloudFormation(properties.status), CACertificatePem: cdk.stringToCloudFormation(properties.caCertificatePem), CertificateMode: cdk.stringToCloudFormation(properties.certificateMode), CertificatePem: cdk.stringToCloudFormation(properties.certificatePem), CertificateSigningRequest: cdk.stringToCloudFormation(properties.certificateSigningRequest) }) : properties;
    }
    function CfnCertificatePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("status", "Status", cfn_parse.FromCloudFormation.getString(properties.Status)), ret.addPropertyResult("caCertificatePem", "CACertificatePem", properties.CACertificatePem != null ? cfn_parse.FromCloudFormation.getString(properties.CACertificatePem) : void 0), ret.addPropertyResult("certificateMode", "CertificateMode", properties.CertificateMode != null ? cfn_parse.FromCloudFormation.getString(properties.CertificateMode) : void 0), ret.addPropertyResult("certificatePem", "CertificatePem", properties.CertificatePem != null ? cfn_parse.FromCloudFormation.getString(properties.CertificatePem) : void 0), ret.addPropertyResult("certificateSigningRequest", "CertificateSigningRequest", properties.CertificateSigningRequest != null ? cfn_parse.FromCloudFormation.getString(properties.CertificateSigningRequest) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCertificate = class _CfnCertificate extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCertificatePropsFromCloudFormation(resourceProperties), ret = new _CfnCertificate(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCertificate.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iot_CfnCertificateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCertificate), error;
        }
        cdk.requireProperty(props, "status", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.status = props.status, this.caCertificatePem = props.caCertificatePem, this.certificateMode = props.certificateMode, this.certificatePem = props.certificatePem, this.certificateSigningRequest = props.certificateSigningRequest;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCertificate.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { status: this.status, caCertificatePem: this.caCertificatePem, certificateMode: this.certificateMode, certificatePem: this.certificatePem, certificateSigningRequest: this.certificateSigningRequest };
      }
      renderProperties(props) {
        return cfnCertificatePropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnCertificate[_e] = { fqn: "aws-cdk-lib.aws_iot.CfnCertificate", version: "2.80.0" }, CfnCertificate.CFN_RESOURCE_TYPE_NAME = "AWS::IoT::Certificate", exports2.CfnCertificate = CfnCertificate;
    function CfnCustomMetricPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("displayName", cdk.validateString)(properties.displayName)), errors.collect(cdk.propertyValidator("metricName", cdk.validateString)(properties.metricName)), errors.collect(cdk.propertyValidator("metricType", cdk.requiredValidator)(properties.metricType)), errors.collect(cdk.propertyValidator("metricType", cdk.validateString)(properties.metricType)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnCustomMetricProps"');
    }
    function cfnCustomMetricPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCustomMetricPropsValidator(properties).assertSuccess(), { MetricType: cdk.stringToCloudFormation(properties.metricType), DisplayName: cdk.stringToCloudFormation(properties.displayName), MetricName: cdk.stringToCloudFormation(properties.metricName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnCustomMetricPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("metricType", "MetricType", cfn_parse.FromCloudFormation.getString(properties.MetricType)), ret.addPropertyResult("displayName", "DisplayName", properties.DisplayName != null ? cfn_parse.FromCloudFormation.getString(properties.DisplayName) : void 0), ret.addPropertyResult("metricName", "MetricName", properties.MetricName != null ? cfn_parse.FromCloudFormation.getString(properties.MetricName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCustomMetric = class _CfnCustomMetric extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCustomMetricPropsFromCloudFormation(resourceProperties), ret = new _CfnCustomMetric(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCustomMetric.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iot_CfnCustomMetricProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCustomMetric), error;
        }
        cdk.requireProperty(props, "metricType", this), this.attrMetricArn = cdk.Token.asString(this.getAtt("MetricArn", cdk.ResolutionTypeHint.STRING)), this.metricType = props.metricType, this.displayName = props.displayName, this.metricName = props.metricName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoT::CustomMetric", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCustomMetric.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { metricType: this.metricType, displayName: this.displayName, metricName: this.metricName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnCustomMetricPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnCustomMetric[_f] = { fqn: "aws-cdk-lib.aws_iot.CfnCustomMetric", version: "2.80.0" }, CfnCustomMetric.CFN_RESOURCE_TYPE_NAME = "AWS::IoT::CustomMetric", exports2.CfnCustomMetric = CfnCustomMetric;
    function CfnDimensionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("stringValues", cdk.requiredValidator)(properties.stringValues)), errors.collect(cdk.propertyValidator("stringValues", cdk.listValidator(cdk.validateString))(properties.stringValues)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnDimensionProps"');
    }
    function cfnDimensionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDimensionPropsValidator(properties).assertSuccess(), { StringValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.stringValues), Type: cdk.stringToCloudFormation(properties.type), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDimensionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("stringValues", "StringValues", cfn_parse.FromCloudFormation.getStringArray(properties.StringValues)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDimension = class _CfnDimension extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDimensionPropsFromCloudFormation(resourceProperties), ret = new _CfnDimension(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDimension.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iot_CfnDimensionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDimension), error;
        }
        cdk.requireProperty(props, "stringValues", this), cdk.requireProperty(props, "type", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.stringValues = props.stringValues, this.type = props.type, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoT::Dimension", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDimension.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { stringValues: this.stringValues, type: this.type, name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDimensionPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnDimension[_g] = { fqn: "aws-cdk-lib.aws_iot.CfnDimension", version: "2.80.0" }, CfnDimension.CFN_RESOURCE_TYPE_NAME = "AWS::IoT::Dimension", exports2.CfnDimension = CfnDimension;
    function CfnDomainConfigurationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authorizerConfig", CfnDomainConfiguration_AuthorizerConfigPropertyValidator)(properties.authorizerConfig)), errors.collect(cdk.propertyValidator("domainConfigurationName", cdk.validateString)(properties.domainConfigurationName)), errors.collect(cdk.propertyValidator("domainConfigurationStatus", cdk.validateString)(properties.domainConfigurationStatus)), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.collect(cdk.propertyValidator("serverCertificateArns", cdk.listValidator(cdk.validateString))(properties.serverCertificateArns)), errors.collect(cdk.propertyValidator("serviceType", cdk.validateString)(properties.serviceType)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("tlsConfig", CfnDomainConfiguration_TlsConfigPropertyValidator)(properties.tlsConfig)), errors.collect(cdk.propertyValidator("validationCertificateArn", cdk.validateString)(properties.validationCertificateArn)), errors.wrap('supplied properties not correct for "CfnDomainConfigurationProps"');
    }
    function cfnDomainConfigurationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomainConfigurationPropsValidator(properties).assertSuccess(), { AuthorizerConfig: cfnDomainConfigurationAuthorizerConfigPropertyToCloudFormation(properties.authorizerConfig), DomainConfigurationName: cdk.stringToCloudFormation(properties.domainConfigurationName), DomainConfigurationStatus: cdk.stringToCloudFormation(properties.domainConfigurationStatus), DomainName: cdk.stringToCloudFormation(properties.domainName), ServerCertificateArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.serverCertificateArns), ServiceType: cdk.stringToCloudFormation(properties.serviceType), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TlsConfig: cfnDomainConfigurationTlsConfigPropertyToCloudFormation(properties.tlsConfig), ValidationCertificateArn: cdk.stringToCloudFormation(properties.validationCertificateArn) }) : properties;
    }
    function CfnDomainConfigurationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authorizerConfig", "AuthorizerConfig", properties.AuthorizerConfig != null ? CfnDomainConfigurationAuthorizerConfigPropertyFromCloudFormation(properties.AuthorizerConfig) : void 0), ret.addPropertyResult("domainConfigurationName", "DomainConfigurationName", properties.DomainConfigurationName != null ? cfn_parse.FromCloudFormation.getString(properties.DomainConfigurationName) : void 0), ret.addPropertyResult("domainConfigurationStatus", "DomainConfigurationStatus", properties.DomainConfigurationStatus != null ? cfn_parse.FromCloudFormation.getString(properties.DomainConfigurationStatus) : void 0), ret.addPropertyResult("domainName", "DomainName", properties.DomainName != null ? cfn_parse.FromCloudFormation.getString(properties.DomainName) : void 0), ret.addPropertyResult("serverCertificateArns", "ServerCertificateArns", properties.ServerCertificateArns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ServerCertificateArns) : void 0), ret.addPropertyResult("serviceType", "ServiceType", properties.ServiceType != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceType) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("tlsConfig", "TlsConfig", properties.TlsConfig != null ? CfnDomainConfigurationTlsConfigPropertyFromCloudFormation(properties.TlsConfig) : void 0), ret.addPropertyResult("validationCertificateArn", "ValidationCertificateArn", properties.ValidationCertificateArn != null ? cfn_parse.FromCloudFormation.getString(properties.ValidationCertificateArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDomainConfiguration = class _CfnDomainConfiguration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDomainConfigurationPropsFromCloudFormation(resourceProperties), ret = new _CfnDomainConfiguration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnDomainConfiguration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iot_CfnDomainConfigurationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDomainConfiguration), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrDomainType = cdk.Token.asString(this.getAtt("DomainType", cdk.ResolutionTypeHint.STRING)), this.attrServerCertificates = this.getAtt("ServerCertificates", cdk.ResolutionTypeHint.STRING), this.authorizerConfig = props.authorizerConfig, this.domainConfigurationName = props.domainConfigurationName, this.domainConfigurationStatus = props.domainConfigurationStatus, this.domainName = props.domainName, this.serverCertificateArns = props.serverCertificateArns, this.serviceType = props.serviceType, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoT::DomainConfiguration", props.tags, { tagPropertyName: "tags" }), this.tlsConfig = props.tlsConfig, this.validationCertificateArn = props.validationCertificateArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDomainConfiguration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { authorizerConfig: this.authorizerConfig, domainConfigurationName: this.domainConfigurationName, domainConfigurationStatus: this.domainConfigurationStatus, domainName: this.domainName, serverCertificateArns: this.serverCertificateArns, serviceType: this.serviceType, tags: this.tags.renderTags(), tlsConfig: this.tlsConfig, validationCertificateArn: this.validationCertificateArn };
      }
      renderProperties(props) {
        return cfnDomainConfigurationPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnDomainConfiguration[_h] = { fqn: "aws-cdk-lib.aws_iot.CfnDomainConfiguration", version: "2.80.0" }, CfnDomainConfiguration.CFN_RESOURCE_TYPE_NAME = "AWS::IoT::DomainConfiguration", exports2.CfnDomainConfiguration = CfnDomainConfiguration;
    function CfnDomainConfiguration_AuthorizerConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowAuthorizerOverride", cdk.validateBoolean)(properties.allowAuthorizerOverride)), errors.collect(cdk.propertyValidator("defaultAuthorizerName", cdk.validateString)(properties.defaultAuthorizerName)), errors.wrap('supplied properties not correct for "AuthorizerConfigProperty"');
    }
    function cfnDomainConfigurationAuthorizerConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomainConfiguration_AuthorizerConfigPropertyValidator(properties).assertSuccess(), { AllowAuthorizerOverride: cdk.booleanToCloudFormation(properties.allowAuthorizerOverride), DefaultAuthorizerName: cdk.stringToCloudFormation(properties.defaultAuthorizerName) }) : properties;
    }
    function CfnDomainConfigurationAuthorizerConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowAuthorizerOverride", "AllowAuthorizerOverride", properties.AllowAuthorizerOverride != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllowAuthorizerOverride) : void 0), ret.addPropertyResult("defaultAuthorizerName", "DefaultAuthorizerName", properties.DefaultAuthorizerName != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultAuthorizerName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomainConfiguration_TlsConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityPolicy", cdk.validateString)(properties.securityPolicy)), errors.wrap('supplied properties not correct for "TlsConfigProperty"');
    }
    function cfnDomainConfigurationTlsConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomainConfiguration_TlsConfigPropertyValidator(properties).assertSuccess(), { SecurityPolicy: cdk.stringToCloudFormation(properties.securityPolicy) }) : properties;
    }
    function CfnDomainConfigurationTlsConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityPolicy", "SecurityPolicy", properties.SecurityPolicy != null ? cfn_parse.FromCloudFormation.getString(properties.SecurityPolicy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFleetMetricPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationField", cdk.validateString)(properties.aggregationField)), errors.collect(cdk.propertyValidator("aggregationType", CfnFleetMetric_AggregationTypePropertyValidator)(properties.aggregationType)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("indexName", cdk.validateString)(properties.indexName)), errors.collect(cdk.propertyValidator("metricName", cdk.requiredValidator)(properties.metricName)), errors.collect(cdk.propertyValidator("metricName", cdk.validateString)(properties.metricName)), errors.collect(cdk.propertyValidator("period", cdk.validateNumber)(properties.period)), errors.collect(cdk.propertyValidator("queryString", cdk.validateString)(properties.queryString)), errors.collect(cdk.propertyValidator("queryVersion", cdk.validateString)(properties.queryVersion)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("unit", cdk.validateString)(properties.unit)), errors.wrap('supplied properties not correct for "CfnFleetMetricProps"');
    }
    function cfnFleetMetricPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFleetMetricPropsValidator(properties).assertSuccess(), { MetricName: cdk.stringToCloudFormation(properties.metricName), AggregationField: cdk.stringToCloudFormation(properties.aggregationField), AggregationType: cfnFleetMetricAggregationTypePropertyToCloudFormation(properties.aggregationType), Description: cdk.stringToCloudFormation(properties.description), IndexName: cdk.stringToCloudFormation(properties.indexName), Period: cdk.numberToCloudFormation(properties.period), QueryString: cdk.stringToCloudFormation(properties.queryString), QueryVersion: cdk.stringToCloudFormation(properties.queryVersion), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), Unit: cdk.stringToCloudFormation(properties.unit) }) : properties;
    }
    function CfnFleetMetricPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("metricName", "MetricName", cfn_parse.FromCloudFormation.getString(properties.MetricName)), ret.addPropertyResult("aggregationField", "AggregationField", properties.AggregationField != null ? cfn_parse.FromCloudFormation.getString(properties.AggregationField) : void 0), ret.addPropertyResult("aggregationType", "AggregationType", properties.AggregationType != null ? CfnFleetMetricAggregationTypePropertyFromCloudFormation(properties.AggregationType) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("indexName", "IndexName", properties.IndexName != null ? cfn_parse.FromCloudFormation.getString(properties.IndexName) : void 0), ret.addPropertyResult("period", "Period", properties.Period != null ? cfn_parse.FromCloudFormation.getNumber(properties.Period) : void 0), ret.addPropertyResult("queryString", "QueryString", properties.QueryString != null ? cfn_parse.FromCloudFormation.getString(properties.QueryString) : void 0), ret.addPropertyResult("queryVersion", "QueryVersion", properties.QueryVersion != null ? cfn_parse.FromCloudFormation.getString(properties.QueryVersion) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("unit", "Unit", properties.Unit != null ? cfn_parse.FromCloudFormation.getString(properties.Unit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFleetMetric = class _CfnFleetMetric extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFleetMetricPropsFromCloudFormation(resourceProperties), ret = new _CfnFleetMetric(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFleetMetric.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iot_CfnFleetMetricProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFleetMetric), error;
        }
        cdk.requireProperty(props, "metricName", this), this.attrCreationDate = this.getAtt("CreationDate", cdk.ResolutionTypeHint.STRING), this.attrLastModifiedDate = this.getAtt("LastModifiedDate", cdk.ResolutionTypeHint.STRING), this.attrMetricArn = cdk.Token.asString(this.getAtt("MetricArn", cdk.ResolutionTypeHint.STRING)), this.attrVersion = this.getAtt("Version", cdk.ResolutionTypeHint.STRING), this.metricName = props.metricName, this.aggregationField = props.aggregationField, this.aggregationType = props.aggregationType, this.description = props.description, this.indexName = props.indexName, this.period = props.period, this.queryString = props.queryString, this.queryVersion = props.queryVersion, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoT::FleetMetric", props.tags, { tagPropertyName: "tags" }), this.unit = props.unit;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFleetMetric.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { metricName: this.metricName, aggregationField: this.aggregationField, aggregationType: this.aggregationType, description: this.description, indexName: this.indexName, period: this.period, queryString: this.queryString, queryVersion: this.queryVersion, tags: this.tags.renderTags(), unit: this.unit };
      }
      renderProperties(props) {
        return cfnFleetMetricPropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnFleetMetric[_j] = { fqn: "aws-cdk-lib.aws_iot.CfnFleetMetric", version: "2.80.0" }, CfnFleetMetric.CFN_RESOURCE_TYPE_NAME = "AWS::IoT::FleetMetric", exports2.CfnFleetMetric = CfnFleetMetric;
    function CfnFleetMetric_AggregationTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("values", cdk.requiredValidator)(properties.values)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "AggregationTypeProperty"');
    }
    function cfnFleetMetricAggregationTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFleetMetric_AggregationTypePropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnFleetMetricAggregationTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("values", "Values", cfn_parse.FromCloudFormation.getStringArray(properties.Values)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobTemplatePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("abortConfig", cdk.validateObject)(properties.abortConfig)), errors.collect(cdk.propertyValidator("description", cdk.requiredValidator)(properties.description)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("document", cdk.validateString)(properties.document)), errors.collect(cdk.propertyValidator("documentSource", cdk.validateString)(properties.documentSource)), errors.collect(cdk.propertyValidator("jobArn", cdk.validateString)(properties.jobArn)), errors.collect(cdk.propertyValidator("jobExecutionsRetryConfig", CfnJobTemplate_JobExecutionsRetryConfigPropertyValidator)(properties.jobExecutionsRetryConfig)), errors.collect(cdk.propertyValidator("jobExecutionsRolloutConfig", cdk.validateObject)(properties.jobExecutionsRolloutConfig)), errors.collect(cdk.propertyValidator("jobTemplateId", cdk.requiredValidator)(properties.jobTemplateId)), errors.collect(cdk.propertyValidator("jobTemplateId", cdk.validateString)(properties.jobTemplateId)), errors.collect(cdk.propertyValidator("maintenanceWindows", cdk.listValidator(CfnJobTemplate_MaintenanceWindowPropertyValidator))(properties.maintenanceWindows)), errors.collect(cdk.propertyValidator("presignedUrlConfig", cdk.validateObject)(properties.presignedUrlConfig)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("timeoutConfig", cdk.validateObject)(properties.timeoutConfig)), errors.wrap('supplied properties not correct for "CfnJobTemplateProps"');
    }
    function cfnJobTemplatePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobTemplatePropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), JobTemplateId: cdk.stringToCloudFormation(properties.jobTemplateId), AbortConfig: cdk.objectToCloudFormation(properties.abortConfig), Document: cdk.stringToCloudFormation(properties.document), DocumentSource: cdk.stringToCloudFormation(properties.documentSource), JobArn: cdk.stringToCloudFormation(properties.jobArn), JobExecutionsRetryConfig: cfnJobTemplateJobExecutionsRetryConfigPropertyToCloudFormation(properties.jobExecutionsRetryConfig), JobExecutionsRolloutConfig: cdk.objectToCloudFormation(properties.jobExecutionsRolloutConfig), MaintenanceWindows: cdk.listMapper(cfnJobTemplateMaintenanceWindowPropertyToCloudFormation)(properties.maintenanceWindows), PresignedUrlConfig: cdk.objectToCloudFormation(properties.presignedUrlConfig), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TimeoutConfig: cdk.objectToCloudFormation(properties.timeoutConfig) }) : properties;
    }
    function CfnJobTemplatePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", cfn_parse.FromCloudFormation.getString(properties.Description)), ret.addPropertyResult("jobTemplateId", "JobTemplateId", cfn_parse.FromCloudFormation.getString(properties.JobTemplateId)), ret.addPropertyResult("abortConfig", "AbortConfig", properties.AbortConfig != null ? cfn_parse.FromCloudFormation.getAny(properties.AbortConfig) : void 0), ret.addPropertyResult("document", "Document", properties.Document != null ? cfn_parse.FromCloudFormation.getString(properties.Document) : void 0), ret.addPropertyResult("documentSource", "DocumentSource", properties.DocumentSource != null ? cfn_parse.FromCloudFormation.getString(properties.DocumentSource) : void 0), ret.addPropertyResult("jobArn", "JobArn", properties.JobArn != null ? cfn_parse.FromCloudFormation.getString(properties.JobArn) : void 0), ret.addPropertyResult("jobExecutionsRetryConfig", "JobExecutionsRetryConfig", properties.JobExecutionsRetryConfig != null ? CfnJobTemplateJobExecutionsRetryConfigPropertyFromCloudFormation(properties.JobExecutionsRetryConfig) : void 0), ret.addPropertyResult("jobExecutionsRolloutConfig", "JobExecutionsRolloutConfig", properties.JobExecutionsRolloutConfig != null ? cfn_parse.FromCloudFormation.getAny(properties.JobExecutionsRolloutConfig) : void 0), ret.addPropertyResult("maintenanceWindows", "MaintenanceWindows", properties.MaintenanceWindows != null ? cfn_parse.FromCloudFormation.getArray(CfnJobTemplateMaintenanceWindowPropertyFromCloudFormation)(properties.MaintenanceWindows) : void 0), ret.addPropertyResult("presignedUrlConfig", "PresignedUrlConfig", properties.PresignedUrlConfig != null ? cfn_parse.FromCloudFormation.getAny(properties.PresignedUrlConfig) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("timeoutConfig", "TimeoutConfig", properties.TimeoutConfig != null ? cfn_parse.FromCloudFormation.getAny(properties.TimeoutConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnJobTemplate = class _CfnJobTemplate extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnJobTemplatePropsFromCloudFormation(resourceProperties), ret = new _CfnJobTemplate(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnJobTemplate.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iot_CfnJobTemplateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnJobTemplate), error;
        }
        cdk.requireProperty(props, "description", this), cdk.requireProperty(props, "jobTemplateId", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.description = props.description, this.jobTemplateId = props.jobTemplateId, this.abortConfig = props.abortConfig, this.document = props.document, this.documentSource = props.documentSource, this.jobArn = props.jobArn, this.jobExecutionsRetryConfig = props.jobExecutionsRetryConfig, this.jobExecutionsRolloutConfig = props.jobExecutionsRolloutConfig, this.maintenanceWindows = props.maintenanceWindows, this.presignedUrlConfig = props.presignedUrlConfig, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoT::JobTemplate", props.tags, { tagPropertyName: "tags" }), this.timeoutConfig = props.timeoutConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnJobTemplate.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, jobTemplateId: this.jobTemplateId, abortConfig: this.abortConfig, document: this.document, documentSource: this.documentSource, jobArn: this.jobArn, jobExecutionsRetryConfig: this.jobExecutionsRetryConfig, jobExecutionsRolloutConfig: this.jobExecutionsRolloutConfig, maintenanceWindows: this.maintenanceWindows, presignedUrlConfig: this.presignedUrlConfig, tags: this.tags.renderTags(), timeoutConfig: this.timeoutConfig };
      }
      renderProperties(props) {
        return cfnJobTemplatePropsToCloudFormation(props);
      }
    };
    _k = JSII_RTTI_SYMBOL_1, CfnJobTemplate[_k] = { fqn: "aws-cdk-lib.aws_iot.CfnJobTemplate", version: "2.80.0" }, CfnJobTemplate.CFN_RESOURCE_TYPE_NAME = "AWS::IoT::JobTemplate", exports2.CfnJobTemplate = CfnJobTemplate;
    function CfnJobTemplate_JobExecutionsRetryConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("retryCriteriaList", cdk.listValidator(CfnJobTemplate_RetryCriteriaPropertyValidator))(properties.retryCriteriaList)), errors.wrap('supplied properties not correct for "JobExecutionsRetryConfigProperty"');
    }
    function cfnJobTemplateJobExecutionsRetryConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobTemplate_JobExecutionsRetryConfigPropertyValidator(properties).assertSuccess(), { RetryCriteriaList: cdk.listMapper(cfnJobTemplateRetryCriteriaPropertyToCloudFormation)(properties.retryCriteriaList) }) : properties;
    }
    function CfnJobTemplateJobExecutionsRetryConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("retryCriteriaList", "RetryCriteriaList", properties.RetryCriteriaList != null ? cfn_parse.FromCloudFormation.getArray(CfnJobTemplateRetryCriteriaPropertyFromCloudFormation)(properties.RetryCriteriaList) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobTemplate_MaintenanceWindowPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("durationInMinutes", cdk.validateNumber)(properties.durationInMinutes)), errors.collect(cdk.propertyValidator("startTime", cdk.validateString)(properties.startTime)), errors.wrap('supplied properties not correct for "MaintenanceWindowProperty"');
    }
    function cfnJobTemplateMaintenanceWindowPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobTemplate_MaintenanceWindowPropertyValidator(properties).assertSuccess(), { DurationInMinutes: cdk.numberToCloudFormation(properties.durationInMinutes), StartTime: cdk.stringToCloudFormation(properties.startTime) }) : properties;
    }
    function CfnJobTemplateMaintenanceWindowPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("durationInMinutes", "DurationInMinutes", properties.DurationInMinutes != null ? cfn_parse.FromCloudFormation.getNumber(properties.DurationInMinutes) : void 0), ret.addPropertyResult("startTime", "StartTime", properties.StartTime != null ? cfn_parse.FromCloudFormation.getString(properties.StartTime) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobTemplate_RetryCriteriaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("failureType", cdk.validateString)(properties.failureType)), errors.collect(cdk.propertyValidator("numberOfRetries", cdk.validateNumber)(properties.numberOfRetries)), errors.wrap('supplied properties not correct for "RetryCriteriaProperty"');
    }
    function cfnJobTemplateRetryCriteriaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobTemplate_RetryCriteriaPropertyValidator(properties).assertSuccess(), { FailureType: cdk.stringToCloudFormation(properties.failureType), NumberOfRetries: cdk.numberToCloudFormation(properties.numberOfRetries) }) : properties;
    }
    function CfnJobTemplateRetryCriteriaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("failureType", "FailureType", properties.FailureType != null ? cfn_parse.FromCloudFormation.getString(properties.FailureType) : void 0), ret.addPropertyResult("numberOfRetries", "NumberOfRetries", properties.NumberOfRetries != null ? cfn_parse.FromCloudFormation.getNumber(properties.NumberOfRetries) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLoggingPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accountId", cdk.requiredValidator)(properties.accountId)), errors.collect(cdk.propertyValidator("accountId", cdk.validateString)(properties.accountId)), errors.collect(cdk.propertyValidator("defaultLogLevel", cdk.requiredValidator)(properties.defaultLogLevel)), errors.collect(cdk.propertyValidator("defaultLogLevel", cdk.validateString)(properties.defaultLogLevel)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "CfnLoggingProps"');
    }
    function cfnLoggingPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLoggingPropsValidator(properties).assertSuccess(), { AccountId: cdk.stringToCloudFormation(properties.accountId), DefaultLogLevel: cdk.stringToCloudFormation(properties.defaultLogLevel), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnLoggingPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accountId", "AccountId", cfn_parse.FromCloudFormation.getString(properties.AccountId)), ret.addPropertyResult("defaultLogLevel", "DefaultLogLevel", cfn_parse.FromCloudFormation.getString(properties.DefaultLogLevel)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLogging = class _CfnLogging extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLoggingPropsFromCloudFormation(resourceProperties), ret = new _CfnLogging(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLogging.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iot_CfnLoggingProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLogging), error;
        }
        cdk.requireProperty(props, "accountId", this), cdk.requireProperty(props, "defaultLogLevel", this), cdk.requireProperty(props, "roleArn", this), this.accountId = props.accountId, this.defaultLogLevel = props.defaultLogLevel, this.roleArn = props.roleArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLogging.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { accountId: this.accountId, defaultLogLevel: this.defaultLogLevel, roleArn: this.roleArn };
      }
      renderProperties(props) {
        return cfnLoggingPropsToCloudFormation(props);
      }
    };
    _l = JSII_RTTI_SYMBOL_1, CfnLogging[_l] = { fqn: "aws-cdk-lib.aws_iot.CfnLogging", version: "2.80.0" }, CfnLogging.CFN_RESOURCE_TYPE_NAME = "AWS::IoT::Logging", exports2.CfnLogging = CfnLogging;
    function CfnMitigationActionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actionName", cdk.validateString)(properties.actionName)), errors.collect(cdk.propertyValidator("actionParams", cdk.requiredValidator)(properties.actionParams)), errors.collect(cdk.propertyValidator("actionParams", CfnMitigationAction_ActionParamsPropertyValidator)(properties.actionParams)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnMitigationActionProps"');
    }
    function cfnMitigationActionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMitigationActionPropsValidator(properties).assertSuccess(), { ActionParams: cfnMitigationActionActionParamsPropertyToCloudFormation(properties.actionParams), RoleArn: cdk.stringToCloudFormation(properties.roleArn), ActionName: cdk.stringToCloudFormation(properties.actionName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnMitigationActionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actionParams", "ActionParams", CfnMitigationActionActionParamsPropertyFromCloudFormation(properties.ActionParams)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("actionName", "ActionName", properties.ActionName != null ? cfn_parse.FromCloudFormation.getString(properties.ActionName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnMitigationAction = class _CfnMitigationAction extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnMitigationActionPropsFromCloudFormation(resourceProperties), ret = new _CfnMitigationAction(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnMitigationAction.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iot_CfnMitigationActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnMitigationAction), error;
        }
        cdk.requireProperty(props, "actionParams", this), cdk.requireProperty(props, "roleArn", this), this.attrMitigationActionArn = cdk.Token.asString(this.getAtt("MitigationActionArn", cdk.ResolutionTypeHint.STRING)), this.attrMitigationActionId = cdk.Token.asString(this.getAtt("MitigationActionId", cdk.ResolutionTypeHint.STRING)), this.actionParams = props.actionParams, this.roleArn = props.roleArn, this.actionName = props.actionName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoT::MitigationAction", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnMitigationAction.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { actionParams: this.actionParams, roleArn: this.roleArn, actionName: this.actionName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnMitigationActionPropsToCloudFormation(props);
      }
    };
    _m = JSII_RTTI_SYMBOL_1, CfnMitigationAction[_m] = { fqn: "aws-cdk-lib.aws_iot.CfnMitigationAction", version: "2.80.0" }, CfnMitigationAction.CFN_RESOURCE_TYPE_NAME = "AWS::IoT::MitigationAction", exports2.CfnMitigationAction = CfnMitigationAction;
    function CfnMitigationAction_ActionParamsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("addThingsToThingGroupParams", CfnMitigationAction_AddThingsToThingGroupParamsPropertyValidator)(properties.addThingsToThingGroupParams)), errors.collect(cdk.propertyValidator("enableIoTLoggingParams", CfnMitigationAction_EnableIoTLoggingParamsPropertyValidator)(properties.enableIoTLoggingParams)), errors.collect(cdk.propertyValidator("publishFindingToSnsParams", CfnMitigationAction_PublishFindingToSnsParamsPropertyValidator)(properties.publishFindingToSnsParams)), errors.collect(cdk.propertyValidator("replaceDefaultPolicyVersionParams", CfnMitigationAction_ReplaceDefaultPolicyVersionParamsPropertyValidator)(properties.replaceDefaultPolicyVersionParams)), errors.collect(cdk.propertyValidator("updateCaCertificateParams", CfnMitigationAction_UpdateCACertificateParamsPropertyValidator)(properties.updateCaCertificateParams)), errors.collect(cdk.propertyValidator("updateDeviceCertificateParams", CfnMitigationAction_UpdateDeviceCertificateParamsPropertyValidator)(properties.updateDeviceCertificateParams)), errors.wrap('supplied properties not correct for "ActionParamsProperty"');
    }
    function cfnMitigationActionActionParamsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMitigationAction_ActionParamsPropertyValidator(properties).assertSuccess(), { AddThingsToThingGroupParams: cfnMitigationActionAddThingsToThingGroupParamsPropertyToCloudFormation(properties.addThingsToThingGroupParams), EnableIoTLoggingParams: cfnMitigationActionEnableIoTLoggingParamsPropertyToCloudFormation(properties.enableIoTLoggingParams), PublishFindingToSnsParams: cfnMitigationActionPublishFindingToSnsParamsPropertyToCloudFormation(properties.publishFindingToSnsParams), ReplaceDefaultPolicyVersionParams: cfnMitigationActionReplaceDefaultPolicyVersionParamsPropertyToCloudFormation(properties.replaceDefaultPolicyVersionParams), UpdateCACertificateParams: cfnMitigationActionUpdateCACertificateParamsPropertyToCloudFormation(properties.updateCaCertificateParams), UpdateDeviceCertificateParams: cfnMitigationActionUpdateDeviceCertificateParamsPropertyToCloudFormation(properties.updateDeviceCertificateParams) }) : properties;
    }
    function CfnMitigationActionActionParamsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("addThingsToThingGroupParams", "AddThingsToThingGroupParams", properties.AddThingsToThingGroupParams != null ? CfnMitigationActionAddThingsToThingGroupParamsPropertyFromCloudFormation(properties.AddThingsToThingGroupParams) : void 0), ret.addPropertyResult("enableIoTLoggingParams", "EnableIoTLoggingParams", properties.EnableIoTLoggingParams != null ? CfnMitigationActionEnableIoTLoggingParamsPropertyFromCloudFormation(properties.EnableIoTLoggingParams) : void 0), ret.addPropertyResult("publishFindingToSnsParams", "PublishFindingToSnsParams", properties.PublishFindingToSnsParams != null ? CfnMitigationActionPublishFindingToSnsParamsPropertyFromCloudFormation(properties.PublishFindingToSnsParams) : void 0), ret.addPropertyResult("replaceDefaultPolicyVersionParams", "ReplaceDefaultPolicyVersionParams", properties.ReplaceDefaultPolicyVersionParams != null ? CfnMitigationActionReplaceDefaultPolicyVersionParamsPropertyFromCloudFormation(properties.ReplaceDefaultPolicyVersionParams) : void 0), ret.addPropertyResult("updateCaCertificateParams", "UpdateCACertificateParams", properties.UpdateCACertificateParams != null ? CfnMitigationActionUpdateCACertificateParamsPropertyFromCloudFormation(properties.UpdateCACertificateParams) : void 0), ret.addPropertyResult("updateDeviceCertificateParams", "UpdateDeviceCertificateParams", properties.UpdateDeviceCertificateParams != null ? CfnMitigationActionUpdateDeviceCertificateParamsPropertyFromCloudFormation(properties.UpdateDeviceCertificateParams) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMitigationAction_AddThingsToThingGroupParamsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("overrideDynamicGroups", cdk.validateBoolean)(properties.overrideDynamicGroups)), errors.collect(cdk.propertyValidator("thingGroupNames", cdk.requiredValidator)(properties.thingGroupNames)), errors.collect(cdk.propertyValidator("thingGroupNames", cdk.listValidator(cdk.validateString))(properties.thingGroupNames)), errors.wrap('supplied properties not correct for "AddThingsToThingGroupParamsProperty"');
    }
    function cfnMitigationActionAddThingsToThingGroupParamsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMitigationAction_AddThingsToThingGroupParamsPropertyValidator(properties).assertSuccess(), { OverrideDynamicGroups: cdk.booleanToCloudFormation(properties.overrideDynamicGroups), ThingGroupNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.thingGroupNames) }) : properties;
    }
    function CfnMitigationActionAddThingsToThingGroupParamsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("overrideDynamicGroups", "OverrideDynamicGroups", properties.OverrideDynamicGroups != null ? cfn_parse.FromCloudFormation.getBoolean(properties.OverrideDynamicGroups) : void 0), ret.addPropertyResult("thingGroupNames", "ThingGroupNames", cfn_parse.FromCloudFormation.getStringArray(properties.ThingGroupNames)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMitigationAction_EnableIoTLoggingParamsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logLevel", cdk.requiredValidator)(properties.logLevel)), errors.collect(cdk.propertyValidator("logLevel", cdk.validateString)(properties.logLevel)), errors.collect(cdk.propertyValidator("roleArnForLogging", cdk.requiredValidator)(properties.roleArnForLogging)), errors.collect(cdk.propertyValidator("roleArnForLogging", cdk.validateString)(properties.roleArnForLogging)), errors.wrap('supplied properties not correct for "EnableIoTLoggingParamsProperty"');
    }
    function cfnMitigationActionEnableIoTLoggingParamsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMitigationAction_EnableIoTLoggingParamsPropertyValidator(properties).assertSuccess(), { LogLevel: cdk.stringToCloudFormation(properties.logLevel), RoleArnForLogging: cdk.stringToCloudFormation(properties.roleArnForLogging) }) : properties;
    }
    function CfnMitigationActionEnableIoTLoggingParamsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logLevel", "LogLevel", cfn_parse.FromCloudFormation.getString(properties.LogLevel)), ret.addPropertyResult("roleArnForLogging", "RoleArnForLogging", cfn_parse.FromCloudFormation.getString(properties.RoleArnForLogging)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMitigationAction_PublishFindingToSnsParamsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("topicArn", cdk.requiredValidator)(properties.topicArn)), errors.collect(cdk.propertyValidator("topicArn", cdk.validateString)(properties.topicArn)), errors.wrap('supplied properties not correct for "PublishFindingToSnsParamsProperty"');
    }
    function cfnMitigationActionPublishFindingToSnsParamsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMitigationAction_PublishFindingToSnsParamsPropertyValidator(properties).assertSuccess(), { TopicArn: cdk.stringToCloudFormation(properties.topicArn) }) : properties;
    }
    function CfnMitigationActionPublishFindingToSnsParamsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("topicArn", "TopicArn", cfn_parse.FromCloudFormation.getString(properties.TopicArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMitigationAction_ReplaceDefaultPolicyVersionParamsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("templateName", cdk.requiredValidator)(properties.templateName)), errors.collect(cdk.propertyValidator("templateName", cdk.validateString)(properties.templateName)), errors.wrap('supplied properties not correct for "ReplaceDefaultPolicyVersionParamsProperty"');
    }
    function cfnMitigationActionReplaceDefaultPolicyVersionParamsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMitigationAction_ReplaceDefaultPolicyVersionParamsPropertyValidator(properties).assertSuccess(), { TemplateName: cdk.stringToCloudFormation(properties.templateName) }) : properties;
    }
    function CfnMitigationActionReplaceDefaultPolicyVersionParamsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("templateName", "TemplateName", cfn_parse.FromCloudFormation.getString(properties.TemplateName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMitigationAction_UpdateCACertificateParamsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.requiredValidator)(properties.action)), errors.collect(cdk.propertyValidator("action", cdk.validateString)(properties.action)), errors.wrap('supplied properties not correct for "UpdateCACertificateParamsProperty"');
    }
    function cfnMitigationActionUpdateCACertificateParamsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMitigationAction_UpdateCACertificateParamsPropertyValidator(properties).assertSuccess(), { Action: cdk.stringToCloudFormation(properties.action) }) : properties;
    }
    function CfnMitigationActionUpdateCACertificateParamsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", cfn_parse.FromCloudFormation.getString(properties.Action)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMitigationAction_UpdateDeviceCertificateParamsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.requiredValidator)(properties.action)), errors.collect(cdk.propertyValidator("action", cdk.validateString)(properties.action)), errors.wrap('supplied properties not correct for "UpdateDeviceCertificateParamsProperty"');
    }
    function cfnMitigationActionUpdateDeviceCertificateParamsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMitigationAction_UpdateDeviceCertificateParamsPropertyValidator(properties).assertSuccess(), { Action: cdk.stringToCloudFormation(properties.action) }) : properties;
    }
    function CfnMitigationActionUpdateDeviceCertificateParamsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", cfn_parse.FromCloudFormation.getString(properties.Action)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("policyDocument", cdk.requiredValidator)(properties.policyDocument)), errors.collect(cdk.propertyValidator("policyDocument", cdk.validateObject)(properties.policyDocument)), errors.collect(cdk.propertyValidator("policyName", cdk.validateString)(properties.policyName)), errors.wrap('supplied properties not correct for "CfnPolicyProps"');
    }
    function cfnPolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPolicyPropsValidator(properties).assertSuccess(), { PolicyDocument: cdk.objectToCloudFormation(properties.policyDocument), PolicyName: cdk.stringToCloudFormation(properties.policyName) }) : properties;
    }
    function CfnPolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("policyDocument", "PolicyDocument", cfn_parse.FromCloudFormation.getAny(properties.PolicyDocument)), ret.addPropertyResult("policyName", "PolicyName", properties.PolicyName != null ? cfn_parse.FromCloudFormation.getString(properties.PolicyName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPolicy = class _CfnPolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnPolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iot_CfnPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPolicy), error;
        }
        cdk.requireProperty(props, "policyDocument", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.policyDocument = props.policyDocument, this.policyName = props.policyName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { policyDocument: this.policyDocument, policyName: this.policyName };
      }
      renderProperties(props) {
        return cfnPolicyPropsToCloudFormation(props);
      }
    };
    _o = JSII_RTTI_SYMBOL_1, CfnPolicy[_o] = { fqn: "aws-cdk-lib.aws_iot.CfnPolicy", version: "2.80.0" }, CfnPolicy.CFN_RESOURCE_TYPE_NAME = "AWS::IoT::Policy", exports2.CfnPolicy = CfnPolicy;
    function CfnPolicyPrincipalAttachmentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("policyName", cdk.requiredValidator)(properties.policyName)), errors.collect(cdk.propertyValidator("policyName", cdk.validateString)(properties.policyName)), errors.collect(cdk.propertyValidator("principal", cdk.requiredValidator)(properties.principal)), errors.collect(cdk.propertyValidator("principal", cdk.validateString)(properties.principal)), errors.wrap('supplied properties not correct for "CfnPolicyPrincipalAttachmentProps"');
    }
    function cfnPolicyPrincipalAttachmentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPolicyPrincipalAttachmentPropsValidator(properties).assertSuccess(), { PolicyName: cdk.stringToCloudFormation(properties.policyName), Principal: cdk.stringToCloudFormation(properties.principal) }) : properties;
    }
    function CfnPolicyPrincipalAttachmentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("policyName", "PolicyName", cfn_parse.FromCloudFormation.getString(properties.PolicyName)), ret.addPropertyResult("principal", "Principal", cfn_parse.FromCloudFormation.getString(properties.Principal)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPolicyPrincipalAttachment = class _CfnPolicyPrincipalAttachment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPolicyPrincipalAttachmentPropsFromCloudFormation(resourceProperties), ret = new _CfnPolicyPrincipalAttachment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPolicyPrincipalAttachment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iot_CfnPolicyPrincipalAttachmentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPolicyPrincipalAttachment), error;
        }
        cdk.requireProperty(props, "policyName", this), cdk.requireProperty(props, "principal", this), this.policyName = props.policyName, this.principal = props.principal;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPolicyPrincipalAttachment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { policyName: this.policyName, principal: this.principal };
      }
      renderProperties(props) {
        return cfnPolicyPrincipalAttachmentPropsToCloudFormation(props);
      }
    };
    _p = JSII_RTTI_SYMBOL_1, CfnPolicyPrincipalAttachment[_p] = { fqn: "aws-cdk-lib.aws_iot.CfnPolicyPrincipalAttachment", version: "2.80.0" }, CfnPolicyPrincipalAttachment.CFN_RESOURCE_TYPE_NAME = "AWS::IoT::PolicyPrincipalAttachment", exports2.CfnPolicyPrincipalAttachment = CfnPolicyPrincipalAttachment;
    function CfnProvisioningTemplatePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("preProvisioningHook", CfnProvisioningTemplate_ProvisioningHookPropertyValidator)(properties.preProvisioningHook)), errors.collect(cdk.propertyValidator("provisioningRoleArn", cdk.requiredValidator)(properties.provisioningRoleArn)), errors.collect(cdk.propertyValidator("provisioningRoleArn", cdk.validateString)(properties.provisioningRoleArn)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("templateBody", cdk.requiredValidator)(properties.templateBody)), errors.collect(cdk.propertyValidator("templateBody", cdk.validateString)(properties.templateBody)), errors.collect(cdk.propertyValidator("templateName", cdk.validateString)(properties.templateName)), errors.collect(cdk.propertyValidator("templateType", cdk.validateString)(properties.templateType)), errors.wrap('supplied properties not correct for "CfnProvisioningTemplateProps"');
    }
    function cfnProvisioningTemplatePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProvisioningTemplatePropsValidator(properties).assertSuccess(), { ProvisioningRoleArn: cdk.stringToCloudFormation(properties.provisioningRoleArn), TemplateBody: cdk.stringToCloudFormation(properties.templateBody), Description: cdk.stringToCloudFormation(properties.description), Enabled: cdk.booleanToCloudFormation(properties.enabled), PreProvisioningHook: cfnProvisioningTemplateProvisioningHookPropertyToCloudFormation(properties.preProvisioningHook), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TemplateName: cdk.stringToCloudFormation(properties.templateName), TemplateType: cdk.stringToCloudFormation(properties.templateType) }) : properties;
    }
    function CfnProvisioningTemplatePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("provisioningRoleArn", "ProvisioningRoleArn", cfn_parse.FromCloudFormation.getString(properties.ProvisioningRoleArn)), ret.addPropertyResult("templateBody", "TemplateBody", cfn_parse.FromCloudFormation.getString(properties.TemplateBody)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("preProvisioningHook", "PreProvisioningHook", properties.PreProvisioningHook != null ? CfnProvisioningTemplateProvisioningHookPropertyFromCloudFormation(properties.PreProvisioningHook) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("templateName", "TemplateName", properties.TemplateName != null ? cfn_parse.FromCloudFormation.getString(properties.TemplateName) : void 0), ret.addPropertyResult("templateType", "TemplateType", properties.TemplateType != null ? cfn_parse.FromCloudFormation.getString(properties.TemplateType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnProvisioningTemplate = class _CfnProvisioningTemplate extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnProvisioningTemplatePropsFromCloudFormation(resourceProperties), ret = new _CfnProvisioningTemplate(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnProvisioningTemplate.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iot_CfnProvisioningTemplateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnProvisioningTemplate), error;
        }
        cdk.requireProperty(props, "provisioningRoleArn", this), cdk.requireProperty(props, "templateBody", this), this.attrTemplateArn = cdk.Token.asString(this.getAtt("TemplateArn", cdk.ResolutionTypeHint.STRING)), this.provisioningRoleArn = props.provisioningRoleArn, this.templateBody = props.templateBody, this.description = props.description, this.enabled = props.enabled, this.preProvisioningHook = props.preProvisioningHook, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoT::ProvisioningTemplate", props.tags, { tagPropertyName: "tags" }), this.templateName = props.templateName, this.templateType = props.templateType;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnProvisioningTemplate.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { provisioningRoleArn: this.provisioningRoleArn, templateBody: this.templateBody, description: this.description, enabled: this.enabled, preProvisioningHook: this.preProvisioningHook, tags: this.tags.renderTags(), templateName: this.templateName, templateType: this.templateType };
      }
      renderProperties(props) {
        return cfnProvisioningTemplatePropsToCloudFormation(props);
      }
    };
    _q = JSII_RTTI_SYMBOL_1, CfnProvisioningTemplate[_q] = { fqn: "aws-cdk-lib.aws_iot.CfnProvisioningTemplate", version: "2.80.0" }, CfnProvisioningTemplate.CFN_RESOURCE_TYPE_NAME = "AWS::IoT::ProvisioningTemplate", exports2.CfnProvisioningTemplate = CfnProvisioningTemplate;
    function CfnProvisioningTemplate_ProvisioningHookPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("payloadVersion", cdk.validateString)(properties.payloadVersion)), errors.collect(cdk.propertyValidator("targetArn", cdk.validateString)(properties.targetArn)), errors.wrap('supplied properties not correct for "ProvisioningHookProperty"');
    }
    function cfnProvisioningTemplateProvisioningHookPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProvisioningTemplate_ProvisioningHookPropertyValidator(properties).assertSuccess(), { PayloadVersion: cdk.stringToCloudFormation(properties.payloadVersion), TargetArn: cdk.stringToCloudFormation(properties.targetArn) }) : properties;
    }
    function CfnProvisioningTemplateProvisioningHookPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("payloadVersion", "PayloadVersion", properties.PayloadVersion != null ? cfn_parse.FromCloudFormation.getString(properties.PayloadVersion) : void 0), ret.addPropertyResult("targetArn", "TargetArn", properties.TargetArn != null ? cfn_parse.FromCloudFormation.getString(properties.TargetArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourceSpecificLoggingPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logLevel", cdk.requiredValidator)(properties.logLevel)), errors.collect(cdk.propertyValidator("logLevel", cdk.validateString)(properties.logLevel)), errors.collect(cdk.propertyValidator("targetName", cdk.requiredValidator)(properties.targetName)), errors.collect(cdk.propertyValidator("targetName", cdk.validateString)(properties.targetName)), errors.collect(cdk.propertyValidator("targetType", cdk.requiredValidator)(properties.targetType)), errors.collect(cdk.propertyValidator("targetType", cdk.validateString)(properties.targetType)), errors.wrap('supplied properties not correct for "CfnResourceSpecificLoggingProps"');
    }
    function cfnResourceSpecificLoggingPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceSpecificLoggingPropsValidator(properties).assertSuccess(), { LogLevel: cdk.stringToCloudFormation(properties.logLevel), TargetName: cdk.stringToCloudFormation(properties.targetName), TargetType: cdk.stringToCloudFormation(properties.targetType) }) : properties;
    }
    function CfnResourceSpecificLoggingPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logLevel", "LogLevel", cfn_parse.FromCloudFormation.getString(properties.LogLevel)), ret.addPropertyResult("targetName", "TargetName", cfn_parse.FromCloudFormation.getString(properties.TargetName)), ret.addPropertyResult("targetType", "TargetType", cfn_parse.FromCloudFormation.getString(properties.TargetType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResourceSpecificLogging = class _CfnResourceSpecificLogging extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResourceSpecificLoggingPropsFromCloudFormation(resourceProperties), ret = new _CfnResourceSpecificLogging(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnResourceSpecificLogging.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iot_CfnResourceSpecificLoggingProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResourceSpecificLogging), error;
        }
        cdk.requireProperty(props, "logLevel", this), cdk.requireProperty(props, "targetName", this), cdk.requireProperty(props, "targetType", this), this.attrTargetId = cdk.Token.asString(this.getAtt("TargetId", cdk.ResolutionTypeHint.STRING)), this.logLevel = props.logLevel, this.targetName = props.targetName, this.targetType = props.targetType;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResourceSpecificLogging.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { logLevel: this.logLevel, targetName: this.targetName, targetType: this.targetType };
      }
      renderProperties(props) {
        return cfnResourceSpecificLoggingPropsToCloudFormation(props);
      }
    };
    _r = JSII_RTTI_SYMBOL_1, CfnResourceSpecificLogging[_r] = { fqn: "aws-cdk-lib.aws_iot.CfnResourceSpecificLogging", version: "2.80.0" }, CfnResourceSpecificLogging.CFN_RESOURCE_TYPE_NAME = "AWS::IoT::ResourceSpecificLogging", exports2.CfnResourceSpecificLogging = CfnResourceSpecificLogging;
    function CfnRoleAliasPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("credentialDurationSeconds", cdk.validateNumber)(properties.credentialDurationSeconds)), errors.collect(cdk.propertyValidator("roleAlias", cdk.validateString)(properties.roleAlias)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnRoleAliasProps"');
    }
    function cfnRoleAliasPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoleAliasPropsValidator(properties).assertSuccess(), { RoleArn: cdk.stringToCloudFormation(properties.roleArn), CredentialDurationSeconds: cdk.numberToCloudFormation(properties.credentialDurationSeconds), RoleAlias: cdk.stringToCloudFormation(properties.roleAlias), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnRoleAliasPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("credentialDurationSeconds", "CredentialDurationSeconds", properties.CredentialDurationSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.CredentialDurationSeconds) : void 0), ret.addPropertyResult("roleAlias", "RoleAlias", properties.RoleAlias != null ? cfn_parse.FromCloudFormation.getString(properties.RoleAlias) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRoleAlias = class _CfnRoleAlias extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRoleAliasPropsFromCloudFormation(resourceProperties), ret = new _CfnRoleAlias(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRoleAlias.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iot_CfnRoleAliasProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRoleAlias), error;
        }
        cdk.requireProperty(props, "roleArn", this), this.attrRoleAliasArn = cdk.Token.asString(this.getAtt("RoleAliasArn", cdk.ResolutionTypeHint.STRING)), this.roleArn = props.roleArn, this.credentialDurationSeconds = props.credentialDurationSeconds, this.roleAlias = props.roleAlias, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoT::RoleAlias", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRoleAlias.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { roleArn: this.roleArn, credentialDurationSeconds: this.credentialDurationSeconds, roleAlias: this.roleAlias, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnRoleAliasPropsToCloudFormation(props);
      }
    };
    _s = JSII_RTTI_SYMBOL_1, CfnRoleAlias[_s] = { fqn: "aws-cdk-lib.aws_iot.CfnRoleAlias", version: "2.80.0" }, CfnRoleAlias.CFN_RESOURCE_TYPE_NAME = "AWS::IoT::RoleAlias", exports2.CfnRoleAlias = CfnRoleAlias;
    function CfnScheduledAuditPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dayOfMonth", cdk.validateString)(properties.dayOfMonth)), errors.collect(cdk.propertyValidator("dayOfWeek", cdk.validateString)(properties.dayOfWeek)), errors.collect(cdk.propertyValidator("frequency", cdk.requiredValidator)(properties.frequency)), errors.collect(cdk.propertyValidator("frequency", cdk.validateString)(properties.frequency)), errors.collect(cdk.propertyValidator("scheduledAuditName", cdk.validateString)(properties.scheduledAuditName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("targetCheckNames", cdk.requiredValidator)(properties.targetCheckNames)), errors.collect(cdk.propertyValidator("targetCheckNames", cdk.listValidator(cdk.validateString))(properties.targetCheckNames)), errors.wrap('supplied properties not correct for "CfnScheduledAuditProps"');
    }
    function cfnScheduledAuditPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScheduledAuditPropsValidator(properties).assertSuccess(), { Frequency: cdk.stringToCloudFormation(properties.frequency), TargetCheckNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.targetCheckNames), DayOfMonth: cdk.stringToCloudFormation(properties.dayOfMonth), DayOfWeek: cdk.stringToCloudFormation(properties.dayOfWeek), ScheduledAuditName: cdk.stringToCloudFormation(properties.scheduledAuditName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnScheduledAuditPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("frequency", "Frequency", cfn_parse.FromCloudFormation.getString(properties.Frequency)), ret.addPropertyResult("targetCheckNames", "TargetCheckNames", cfn_parse.FromCloudFormation.getStringArray(properties.TargetCheckNames)), ret.addPropertyResult("dayOfMonth", "DayOfMonth", properties.DayOfMonth != null ? cfn_parse.FromCloudFormation.getString(properties.DayOfMonth) : void 0), ret.addPropertyResult("dayOfWeek", "DayOfWeek", properties.DayOfWeek != null ? cfn_parse.FromCloudFormation.getString(properties.DayOfWeek) : void 0), ret.addPropertyResult("scheduledAuditName", "ScheduledAuditName", properties.ScheduledAuditName != null ? cfn_parse.FromCloudFormation.getString(properties.ScheduledAuditName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnScheduledAudit = class _CfnScheduledAudit extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnScheduledAuditPropsFromCloudFormation(resourceProperties), ret = new _CfnScheduledAudit(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnScheduledAudit.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iot_CfnScheduledAuditProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnScheduledAudit), error;
        }
        cdk.requireProperty(props, "frequency", this), cdk.requireProperty(props, "targetCheckNames", this), this.attrScheduledAuditArn = cdk.Token.asString(this.getAtt("ScheduledAuditArn", cdk.ResolutionTypeHint.STRING)), this.frequency = props.frequency, this.targetCheckNames = props.targetCheckNames, this.dayOfMonth = props.dayOfMonth, this.dayOfWeek = props.dayOfWeek, this.scheduledAuditName = props.scheduledAuditName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoT::ScheduledAudit", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnScheduledAudit.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { frequency: this.frequency, targetCheckNames: this.targetCheckNames, dayOfMonth: this.dayOfMonth, dayOfWeek: this.dayOfWeek, scheduledAuditName: this.scheduledAuditName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnScheduledAuditPropsToCloudFormation(props);
      }
    };
    _t = JSII_RTTI_SYMBOL_1, CfnScheduledAudit[_t] = { fqn: "aws-cdk-lib.aws_iot.CfnScheduledAudit", version: "2.80.0" }, CfnScheduledAudit.CFN_RESOURCE_TYPE_NAME = "AWS::IoT::ScheduledAudit", exports2.CfnScheduledAudit = CfnScheduledAudit;
    function CfnSecurityProfilePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("additionalMetricsToRetainV2", cdk.listValidator(CfnSecurityProfile_MetricToRetainPropertyValidator))(properties.additionalMetricsToRetainV2)), errors.collect(cdk.propertyValidator("alertTargets", cdk.hashValidator(CfnSecurityProfile_AlertTargetPropertyValidator))(properties.alertTargets)), errors.collect(cdk.propertyValidator("behaviors", cdk.listValidator(CfnSecurityProfile_BehaviorPropertyValidator))(properties.behaviors)), errors.collect(cdk.propertyValidator("securityProfileDescription", cdk.validateString)(properties.securityProfileDescription)), errors.collect(cdk.propertyValidator("securityProfileName", cdk.validateString)(properties.securityProfileName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("targetArns", cdk.listValidator(cdk.validateString))(properties.targetArns)), errors.wrap('supplied properties not correct for "CfnSecurityProfileProps"');
    }
    function cfnSecurityProfilePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSecurityProfilePropsValidator(properties).assertSuccess(), { AdditionalMetricsToRetainV2: cdk.listMapper(cfnSecurityProfileMetricToRetainPropertyToCloudFormation)(properties.additionalMetricsToRetainV2), AlertTargets: cdk.hashMapper(cfnSecurityProfileAlertTargetPropertyToCloudFormation)(properties.alertTargets), Behaviors: cdk.listMapper(cfnSecurityProfileBehaviorPropertyToCloudFormation)(properties.behaviors), SecurityProfileDescription: cdk.stringToCloudFormation(properties.securityProfileDescription), SecurityProfileName: cdk.stringToCloudFormation(properties.securityProfileName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TargetArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.targetArns) }) : properties;
    }
    function CfnSecurityProfilePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("additionalMetricsToRetainV2", "AdditionalMetricsToRetainV2", properties.AdditionalMetricsToRetainV2 != null ? cfn_parse.FromCloudFormation.getArray(CfnSecurityProfileMetricToRetainPropertyFromCloudFormation)(properties.AdditionalMetricsToRetainV2) : void 0), ret.addPropertyResult("alertTargets", "AlertTargets", properties.AlertTargets != null ? cfn_parse.FromCloudFormation.getMap(CfnSecurityProfileAlertTargetPropertyFromCloudFormation)(properties.AlertTargets) : void 0), ret.addPropertyResult("behaviors", "Behaviors", properties.Behaviors != null ? cfn_parse.FromCloudFormation.getArray(CfnSecurityProfileBehaviorPropertyFromCloudFormation)(properties.Behaviors) : void 0), ret.addPropertyResult("securityProfileDescription", "SecurityProfileDescription", properties.SecurityProfileDescription != null ? cfn_parse.FromCloudFormation.getString(properties.SecurityProfileDescription) : void 0), ret.addPropertyResult("securityProfileName", "SecurityProfileName", properties.SecurityProfileName != null ? cfn_parse.FromCloudFormation.getString(properties.SecurityProfileName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("targetArns", "TargetArns", properties.TargetArns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.TargetArns) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSecurityProfile = class _CfnSecurityProfile extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSecurityProfilePropsFromCloudFormation(resourceProperties), ret = new _CfnSecurityProfile(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnSecurityProfile.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iot_CfnSecurityProfileProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSecurityProfile), error;
        }
        this.attrSecurityProfileArn = cdk.Token.asString(this.getAtt("SecurityProfileArn", cdk.ResolutionTypeHint.STRING)), this.additionalMetricsToRetainV2 = props.additionalMetricsToRetainV2, this.alertTargets = props.alertTargets, this.behaviors = props.behaviors, this.securityProfileDescription = props.securityProfileDescription, this.securityProfileName = props.securityProfileName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoT::SecurityProfile", props.tags, { tagPropertyName: "tags" }), this.targetArns = props.targetArns;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSecurityProfile.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { additionalMetricsToRetainV2: this.additionalMetricsToRetainV2, alertTargets: this.alertTargets, behaviors: this.behaviors, securityProfileDescription: this.securityProfileDescription, securityProfileName: this.securityProfileName, tags: this.tags.renderTags(), targetArns: this.targetArns };
      }
      renderProperties(props) {
        return cfnSecurityProfilePropsToCloudFormation(props);
      }
    };
    _u = JSII_RTTI_SYMBOL_1, CfnSecurityProfile[_u] = { fqn: "aws-cdk-lib.aws_iot.CfnSecurityProfile", version: "2.80.0" }, CfnSecurityProfile.CFN_RESOURCE_TYPE_NAME = "AWS::IoT::SecurityProfile", exports2.CfnSecurityProfile = CfnSecurityProfile;
    function CfnSecurityProfile_AlertTargetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alertTargetArn", cdk.requiredValidator)(properties.alertTargetArn)), errors.collect(cdk.propertyValidator("alertTargetArn", cdk.validateString)(properties.alertTargetArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "AlertTargetProperty"');
    }
    function cfnSecurityProfileAlertTargetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSecurityProfile_AlertTargetPropertyValidator(properties).assertSuccess(), { AlertTargetArn: cdk.stringToCloudFormation(properties.alertTargetArn), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnSecurityProfileAlertTargetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alertTargetArn", "AlertTargetArn", cfn_parse.FromCloudFormation.getString(properties.AlertTargetArn)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSecurityProfile_BehaviorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("criteria", CfnSecurityProfile_BehaviorCriteriaPropertyValidator)(properties.criteria)), errors.collect(cdk.propertyValidator("metric", cdk.validateString)(properties.metric)), errors.collect(cdk.propertyValidator("metricDimension", CfnSecurityProfile_MetricDimensionPropertyValidator)(properties.metricDimension)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("suppressAlerts", cdk.validateBoolean)(properties.suppressAlerts)), errors.wrap('supplied properties not correct for "BehaviorProperty"');
    }
    function cfnSecurityProfileBehaviorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSecurityProfile_BehaviorPropertyValidator(properties).assertSuccess(), { Criteria: cfnSecurityProfileBehaviorCriteriaPropertyToCloudFormation(properties.criteria), Metric: cdk.stringToCloudFormation(properties.metric), MetricDimension: cfnSecurityProfileMetricDimensionPropertyToCloudFormation(properties.metricDimension), Name: cdk.stringToCloudFormation(properties.name), SuppressAlerts: cdk.booleanToCloudFormation(properties.suppressAlerts) }) : properties;
    }
    function CfnSecurityProfileBehaviorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("criteria", "Criteria", properties.Criteria != null ? CfnSecurityProfileBehaviorCriteriaPropertyFromCloudFormation(properties.Criteria) : void 0), ret.addPropertyResult("metric", "Metric", properties.Metric != null ? cfn_parse.FromCloudFormation.getString(properties.Metric) : void 0), ret.addPropertyResult("metricDimension", "MetricDimension", properties.MetricDimension != null ? CfnSecurityProfileMetricDimensionPropertyFromCloudFormation(properties.MetricDimension) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("suppressAlerts", "SuppressAlerts", properties.SuppressAlerts != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SuppressAlerts) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSecurityProfile_BehaviorCriteriaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("comparisonOperator", cdk.validateString)(properties.comparisonOperator)), errors.collect(cdk.propertyValidator("consecutiveDatapointsToAlarm", cdk.validateNumber)(properties.consecutiveDatapointsToAlarm)), errors.collect(cdk.propertyValidator("consecutiveDatapointsToClear", cdk.validateNumber)(properties.consecutiveDatapointsToClear)), errors.collect(cdk.propertyValidator("durationSeconds", cdk.validateNumber)(properties.durationSeconds)), errors.collect(cdk.propertyValidator("mlDetectionConfig", CfnSecurityProfile_MachineLearningDetectionConfigPropertyValidator)(properties.mlDetectionConfig)), errors.collect(cdk.propertyValidator("statisticalThreshold", CfnSecurityProfile_StatisticalThresholdPropertyValidator)(properties.statisticalThreshold)), errors.collect(cdk.propertyValidator("value", CfnSecurityProfile_MetricValuePropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "BehaviorCriteriaProperty"');
    }
    function cfnSecurityProfileBehaviorCriteriaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSecurityProfile_BehaviorCriteriaPropertyValidator(properties).assertSuccess(), { ComparisonOperator: cdk.stringToCloudFormation(properties.comparisonOperator), ConsecutiveDatapointsToAlarm: cdk.numberToCloudFormation(properties.consecutiveDatapointsToAlarm), ConsecutiveDatapointsToClear: cdk.numberToCloudFormation(properties.consecutiveDatapointsToClear), DurationSeconds: cdk.numberToCloudFormation(properties.durationSeconds), MlDetectionConfig: cfnSecurityProfileMachineLearningDetectionConfigPropertyToCloudFormation(properties.mlDetectionConfig), StatisticalThreshold: cfnSecurityProfileStatisticalThresholdPropertyToCloudFormation(properties.statisticalThreshold), Value: cfnSecurityProfileMetricValuePropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnSecurityProfileBehaviorCriteriaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("comparisonOperator", "ComparisonOperator", properties.ComparisonOperator != null ? cfn_parse.FromCloudFormation.getString(properties.ComparisonOperator) : void 0), ret.addPropertyResult("consecutiveDatapointsToAlarm", "ConsecutiveDatapointsToAlarm", properties.ConsecutiveDatapointsToAlarm != null ? cfn_parse.FromCloudFormation.getNumber(properties.ConsecutiveDatapointsToAlarm) : void 0), ret.addPropertyResult("consecutiveDatapointsToClear", "ConsecutiveDatapointsToClear", properties.ConsecutiveDatapointsToClear != null ? cfn_parse.FromCloudFormation.getNumber(properties.ConsecutiveDatapointsToClear) : void 0), ret.addPropertyResult("durationSeconds", "DurationSeconds", properties.DurationSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.DurationSeconds) : void 0), ret.addPropertyResult("mlDetectionConfig", "MlDetectionConfig", properties.MlDetectionConfig != null ? CfnSecurityProfileMachineLearningDetectionConfigPropertyFromCloudFormation(properties.MlDetectionConfig) : void 0), ret.addPropertyResult("statisticalThreshold", "StatisticalThreshold", properties.StatisticalThreshold != null ? CfnSecurityProfileStatisticalThresholdPropertyFromCloudFormation(properties.StatisticalThreshold) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? CfnSecurityProfileMetricValuePropertyFromCloudFormation(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSecurityProfile_MachineLearningDetectionConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("confidenceLevel", cdk.validateString)(properties.confidenceLevel)), errors.wrap('supplied properties not correct for "MachineLearningDetectionConfigProperty"');
    }
    function cfnSecurityProfileMachineLearningDetectionConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSecurityProfile_MachineLearningDetectionConfigPropertyValidator(properties).assertSuccess(), { ConfidenceLevel: cdk.stringToCloudFormation(properties.confidenceLevel) }) : properties;
    }
    function CfnSecurityProfileMachineLearningDetectionConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("confidenceLevel", "ConfidenceLevel", properties.ConfidenceLevel != null ? cfn_parse.FromCloudFormation.getString(properties.ConfidenceLevel) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSecurityProfile_MetricDimensionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dimensionName", cdk.requiredValidator)(properties.dimensionName)), errors.collect(cdk.propertyValidator("dimensionName", cdk.validateString)(properties.dimensionName)), errors.collect(cdk.propertyValidator("operator", cdk.validateString)(properties.operator)), errors.wrap('supplied properties not correct for "MetricDimensionProperty"');
    }
    function cfnSecurityProfileMetricDimensionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSecurityProfile_MetricDimensionPropertyValidator(properties).assertSuccess(), { DimensionName: cdk.stringToCloudFormation(properties.dimensionName), Operator: cdk.stringToCloudFormation(properties.operator) }) : properties;
    }
    function CfnSecurityProfileMetricDimensionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dimensionName", "DimensionName", cfn_parse.FromCloudFormation.getString(properties.DimensionName)), ret.addPropertyResult("operator", "Operator", properties.Operator != null ? cfn_parse.FromCloudFormation.getString(properties.Operator) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSecurityProfile_MetricToRetainPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("metric", cdk.requiredValidator)(properties.metric)), errors.collect(cdk.propertyValidator("metric", cdk.validateString)(properties.metric)), errors.collect(cdk.propertyValidator("metricDimension", CfnSecurityProfile_MetricDimensionPropertyValidator)(properties.metricDimension)), errors.wrap('supplied properties not correct for "MetricToRetainProperty"');
    }
    function cfnSecurityProfileMetricToRetainPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSecurityProfile_MetricToRetainPropertyValidator(properties).assertSuccess(), { Metric: cdk.stringToCloudFormation(properties.metric), MetricDimension: cfnSecurityProfileMetricDimensionPropertyToCloudFormation(properties.metricDimension) }) : properties;
    }
    function CfnSecurityProfileMetricToRetainPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("metric", "Metric", cfn_parse.FromCloudFormation.getString(properties.Metric)), ret.addPropertyResult("metricDimension", "MetricDimension", properties.MetricDimension != null ? CfnSecurityProfileMetricDimensionPropertyFromCloudFormation(properties.MetricDimension) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSecurityProfile_MetricValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cidrs", cdk.listValidator(cdk.validateString))(properties.cidrs)), errors.collect(cdk.propertyValidator("count", cdk.validateString)(properties.count)), errors.collect(cdk.propertyValidator("number", cdk.validateNumber)(properties.number)), errors.collect(cdk.propertyValidator("numbers", cdk.listValidator(cdk.validateNumber))(properties.numbers)), errors.collect(cdk.propertyValidator("ports", cdk.listValidator(cdk.validateNumber))(properties.ports)), errors.collect(cdk.propertyValidator("strings", cdk.listValidator(cdk.validateString))(properties.strings)), errors.wrap('supplied properties not correct for "MetricValueProperty"');
    }
    function cfnSecurityProfileMetricValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSecurityProfile_MetricValuePropertyValidator(properties).assertSuccess(), { Cidrs: cdk.listMapper(cdk.stringToCloudFormation)(properties.cidrs), Count: cdk.stringToCloudFormation(properties.count), Number: cdk.numberToCloudFormation(properties.number), Numbers: cdk.listMapper(cdk.numberToCloudFormation)(properties.numbers), Ports: cdk.listMapper(cdk.numberToCloudFormation)(properties.ports), Strings: cdk.listMapper(cdk.stringToCloudFormation)(properties.strings) }) : properties;
    }
    function CfnSecurityProfileMetricValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cidrs", "Cidrs", properties.Cidrs != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Cidrs) : void 0), ret.addPropertyResult("count", "Count", properties.Count != null ? cfn_parse.FromCloudFormation.getString(properties.Count) : void 0), ret.addPropertyResult("number", "Number", properties.Number != null ? cfn_parse.FromCloudFormation.getNumber(properties.Number) : void 0), ret.addPropertyResult("numbers", "Numbers", properties.Numbers != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getNumber)(properties.Numbers) : void 0), ret.addPropertyResult("ports", "Ports", properties.Ports != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getNumber)(properties.Ports) : void 0), ret.addPropertyResult("strings", "Strings", properties.Strings != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Strings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSecurityProfile_StatisticalThresholdPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("statistic", cdk.validateString)(properties.statistic)), errors.wrap('supplied properties not correct for "StatisticalThresholdProperty"');
    }
    function cfnSecurityProfileStatisticalThresholdPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSecurityProfile_StatisticalThresholdPropertyValidator(properties).assertSuccess(), { Statistic: cdk.stringToCloudFormation(properties.statistic) }) : properties;
    }
    function CfnSecurityProfileStatisticalThresholdPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("statistic", "Statistic", properties.Statistic != null ? cfn_parse.FromCloudFormation.getString(properties.Statistic) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnThingPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributePayload", CfnThing_AttributePayloadPropertyValidator)(properties.attributePayload)), errors.collect(cdk.propertyValidator("thingName", cdk.validateString)(properties.thingName)), errors.wrap('supplied properties not correct for "CfnThingProps"');
    }
    function cfnThingPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnThingPropsValidator(properties).assertSuccess(), { AttributePayload: cfnThingAttributePayloadPropertyToCloudFormation(properties.attributePayload), ThingName: cdk.stringToCloudFormation(properties.thingName) }) : properties;
    }
    function CfnThingPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attributePayload", "AttributePayload", properties.AttributePayload != null ? CfnThingAttributePayloadPropertyFromCloudFormation(properties.AttributePayload) : void 0), ret.addPropertyResult("thingName", "ThingName", properties.ThingName != null ? cfn_parse.FromCloudFormation.getString(properties.ThingName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnThing = class _CfnThing extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnThingPropsFromCloudFormation(resourceProperties), ret = new _CfnThing(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnThing.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iot_CfnThingProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnThing), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attributePayload = props.attributePayload, this.thingName = props.thingName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnThing.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { attributePayload: this.attributePayload, thingName: this.thingName };
      }
      renderProperties(props) {
        return cfnThingPropsToCloudFormation(props);
      }
    };
    _v = JSII_RTTI_SYMBOL_1, CfnThing[_v] = { fqn: "aws-cdk-lib.aws_iot.CfnThing", version: "2.80.0" }, CfnThing.CFN_RESOURCE_TYPE_NAME = "AWS::IoT::Thing", exports2.CfnThing = CfnThing;
    function CfnThing_AttributePayloadPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributes", cdk.hashValidator(cdk.validateString))(properties.attributes)), errors.wrap('supplied properties not correct for "AttributePayloadProperty"');
    }
    function cfnThingAttributePayloadPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnThing_AttributePayloadPropertyValidator(properties).assertSuccess(), { Attributes: cdk.hashMapper(cdk.stringToCloudFormation)(properties.attributes) }) : properties;
    }
    function CfnThingAttributePayloadPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attributes", "Attributes", properties.Attributes != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Attributes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnThingGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("parentGroupName", cdk.validateString)(properties.parentGroupName)), errors.collect(cdk.propertyValidator("queryString", cdk.validateString)(properties.queryString)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("thingGroupName", cdk.validateString)(properties.thingGroupName)), errors.collect(cdk.propertyValidator("thingGroupProperties", CfnThingGroup_ThingGroupPropertiesPropertyValidator)(properties.thingGroupProperties)), errors.wrap('supplied properties not correct for "CfnThingGroupProps"');
    }
    function cfnThingGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnThingGroupPropsValidator(properties).assertSuccess(), { ParentGroupName: cdk.stringToCloudFormation(properties.parentGroupName), QueryString: cdk.stringToCloudFormation(properties.queryString), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), ThingGroupName: cdk.stringToCloudFormation(properties.thingGroupName), ThingGroupProperties: cfnThingGroupThingGroupPropertiesPropertyToCloudFormation(properties.thingGroupProperties) }) : properties;
    }
    function CfnThingGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("parentGroupName", "ParentGroupName", properties.ParentGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.ParentGroupName) : void 0), ret.addPropertyResult("queryString", "QueryString", properties.QueryString != null ? cfn_parse.FromCloudFormation.getString(properties.QueryString) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("thingGroupName", "ThingGroupName", properties.ThingGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.ThingGroupName) : void 0), ret.addPropertyResult("thingGroupProperties", "ThingGroupProperties", properties.ThingGroupProperties != null ? CfnThingGroupThingGroupPropertiesPropertyFromCloudFormation(properties.ThingGroupProperties) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnThingGroup = class _CfnThingGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnThingGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnThingGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnThingGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iot_CfnThingGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnThingGroup), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.parentGroupName = props.parentGroupName, this.queryString = props.queryString, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoT::ThingGroup", props.tags, { tagPropertyName: "tags" }), this.thingGroupName = props.thingGroupName, this.thingGroupProperties = props.thingGroupProperties;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnThingGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { parentGroupName: this.parentGroupName, queryString: this.queryString, tags: this.tags.renderTags(), thingGroupName: this.thingGroupName, thingGroupProperties: this.thingGroupProperties };
      }
      renderProperties(props) {
        return cfnThingGroupPropsToCloudFormation(props);
      }
    };
    _w = JSII_RTTI_SYMBOL_1, CfnThingGroup[_w] = { fqn: "aws-cdk-lib.aws_iot.CfnThingGroup", version: "2.80.0" }, CfnThingGroup.CFN_RESOURCE_TYPE_NAME = "AWS::IoT::ThingGroup", exports2.CfnThingGroup = CfnThingGroup;
    function CfnThingGroup_AttributePayloadPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributes", cdk.hashValidator(cdk.validateString))(properties.attributes)), errors.wrap('supplied properties not correct for "AttributePayloadProperty"');
    }
    function cfnThingGroupAttributePayloadPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnThingGroup_AttributePayloadPropertyValidator(properties).assertSuccess(), { Attributes: cdk.hashMapper(cdk.stringToCloudFormation)(properties.attributes) }) : properties;
    }
    function CfnThingGroupAttributePayloadPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attributes", "Attributes", properties.Attributes != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Attributes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnThingGroup_ThingGroupPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributePayload", CfnThingGroup_AttributePayloadPropertyValidator)(properties.attributePayload)), errors.collect(cdk.propertyValidator("thingGroupDescription", cdk.validateString)(properties.thingGroupDescription)), errors.wrap('supplied properties not correct for "ThingGroupPropertiesProperty"');
    }
    function cfnThingGroupThingGroupPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnThingGroup_ThingGroupPropertiesPropertyValidator(properties).assertSuccess(), { AttributePayload: cfnThingGroupAttributePayloadPropertyToCloudFormation(properties.attributePayload), ThingGroupDescription: cdk.stringToCloudFormation(properties.thingGroupDescription) }) : properties;
    }
    function CfnThingGroupThingGroupPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attributePayload", "AttributePayload", properties.AttributePayload != null ? CfnThingGroupAttributePayloadPropertyFromCloudFormation(properties.AttributePayload) : void 0), ret.addPropertyResult("thingGroupDescription", "ThingGroupDescription", properties.ThingGroupDescription != null ? cfn_parse.FromCloudFormation.getString(properties.ThingGroupDescription) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnThingPrincipalAttachmentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("principal", cdk.requiredValidator)(properties.principal)), errors.collect(cdk.propertyValidator("principal", cdk.validateString)(properties.principal)), errors.collect(cdk.propertyValidator("thingName", cdk.requiredValidator)(properties.thingName)), errors.collect(cdk.propertyValidator("thingName", cdk.validateString)(properties.thingName)), errors.wrap('supplied properties not correct for "CfnThingPrincipalAttachmentProps"');
    }
    function cfnThingPrincipalAttachmentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnThingPrincipalAttachmentPropsValidator(properties).assertSuccess(), { Principal: cdk.stringToCloudFormation(properties.principal), ThingName: cdk.stringToCloudFormation(properties.thingName) }) : properties;
    }
    function CfnThingPrincipalAttachmentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("principal", "Principal", cfn_parse.FromCloudFormation.getString(properties.Principal)), ret.addPropertyResult("thingName", "ThingName", cfn_parse.FromCloudFormation.getString(properties.ThingName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnThingPrincipalAttachment = class _CfnThingPrincipalAttachment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnThingPrincipalAttachmentPropsFromCloudFormation(resourceProperties), ret = new _CfnThingPrincipalAttachment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnThingPrincipalAttachment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iot_CfnThingPrincipalAttachmentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnThingPrincipalAttachment), error;
        }
        cdk.requireProperty(props, "principal", this), cdk.requireProperty(props, "thingName", this), this.principal = props.principal, this.thingName = props.thingName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnThingPrincipalAttachment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { principal: this.principal, thingName: this.thingName };
      }
      renderProperties(props) {
        return cfnThingPrincipalAttachmentPropsToCloudFormation(props);
      }
    };
    _x = JSII_RTTI_SYMBOL_1, CfnThingPrincipalAttachment[_x] = { fqn: "aws-cdk-lib.aws_iot.CfnThingPrincipalAttachment", version: "2.80.0" }, CfnThingPrincipalAttachment.CFN_RESOURCE_TYPE_NAME = "AWS::IoT::ThingPrincipalAttachment", exports2.CfnThingPrincipalAttachment = CfnThingPrincipalAttachment;
    function CfnThingTypePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deprecateThingType", cdk.validateBoolean)(properties.deprecateThingType)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("thingTypeName", cdk.validateString)(properties.thingTypeName)), errors.collect(cdk.propertyValidator("thingTypeProperties", CfnThingType_ThingTypePropertiesPropertyValidator)(properties.thingTypeProperties)), errors.wrap('supplied properties not correct for "CfnThingTypeProps"');
    }
    function cfnThingTypePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnThingTypePropsValidator(properties).assertSuccess(), { DeprecateThingType: cdk.booleanToCloudFormation(properties.deprecateThingType), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), ThingTypeName: cdk.stringToCloudFormation(properties.thingTypeName), ThingTypeProperties: cfnThingTypeThingTypePropertiesPropertyToCloudFormation(properties.thingTypeProperties) }) : properties;
    }
    function CfnThingTypePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deprecateThingType", "DeprecateThingType", properties.DeprecateThingType != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeprecateThingType) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("thingTypeName", "ThingTypeName", properties.ThingTypeName != null ? cfn_parse.FromCloudFormation.getString(properties.ThingTypeName) : void 0), ret.addPropertyResult("thingTypeProperties", "ThingTypeProperties", properties.ThingTypeProperties != null ? CfnThingTypeThingTypePropertiesPropertyFromCloudFormation(properties.ThingTypeProperties) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnThingType = class _CfnThingType extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnThingTypePropsFromCloudFormation(resourceProperties), ret = new _CfnThingType(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnThingType.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iot_CfnThingTypeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnThingType), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.deprecateThingType = props.deprecateThingType, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoT::ThingType", props.tags, { tagPropertyName: "tags" }), this.thingTypeName = props.thingTypeName, this.thingTypeProperties = props.thingTypeProperties;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnThingType.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { deprecateThingType: this.deprecateThingType, tags: this.tags.renderTags(), thingTypeName: this.thingTypeName, thingTypeProperties: this.thingTypeProperties };
      }
      renderProperties(props) {
        return cfnThingTypePropsToCloudFormation(props);
      }
    };
    _y = JSII_RTTI_SYMBOL_1, CfnThingType[_y] = { fqn: "aws-cdk-lib.aws_iot.CfnThingType", version: "2.80.0" }, CfnThingType.CFN_RESOURCE_TYPE_NAME = "AWS::IoT::ThingType", exports2.CfnThingType = CfnThingType;
    function CfnThingType_ThingTypePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("searchableAttributes", cdk.listValidator(cdk.validateString))(properties.searchableAttributes)), errors.collect(cdk.propertyValidator("thingTypeDescription", cdk.validateString)(properties.thingTypeDescription)), errors.wrap('supplied properties not correct for "ThingTypePropertiesProperty"');
    }
    function cfnThingTypeThingTypePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnThingType_ThingTypePropertiesPropertyValidator(properties).assertSuccess(), { SearchableAttributes: cdk.listMapper(cdk.stringToCloudFormation)(properties.searchableAttributes), ThingTypeDescription: cdk.stringToCloudFormation(properties.thingTypeDescription) }) : properties;
    }
    function CfnThingTypeThingTypePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("searchableAttributes", "SearchableAttributes", properties.SearchableAttributes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SearchableAttributes) : void 0), ret.addPropertyResult("thingTypeDescription", "ThingTypeDescription", properties.ThingTypeDescription != null ? cfn_parse.FromCloudFormation.getString(properties.ThingTypeDescription) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRulePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ruleName", cdk.validateString)(properties.ruleName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("topicRulePayload", cdk.requiredValidator)(properties.topicRulePayload)), errors.collect(cdk.propertyValidator("topicRulePayload", CfnTopicRule_TopicRulePayloadPropertyValidator)(properties.topicRulePayload)), errors.wrap('supplied properties not correct for "CfnTopicRuleProps"');
    }
    function cfnTopicRulePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRulePropsValidator(properties).assertSuccess(), { TopicRulePayload: cfnTopicRuleTopicRulePayloadPropertyToCloudFormation(properties.topicRulePayload), RuleName: cdk.stringToCloudFormation(properties.ruleName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnTopicRulePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("topicRulePayload", "TopicRulePayload", CfnTopicRuleTopicRulePayloadPropertyFromCloudFormation(properties.TopicRulePayload)), ret.addPropertyResult("ruleName", "RuleName", properties.RuleName != null ? cfn_parse.FromCloudFormation.getString(properties.RuleName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTopicRule = class _CfnTopicRule extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTopicRulePropsFromCloudFormation(resourceProperties), ret = new _CfnTopicRule(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTopicRule.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iot_CfnTopicRuleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTopicRule), error;
        }
        cdk.requireProperty(props, "topicRulePayload", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.topicRulePayload = props.topicRulePayload, this.ruleName = props.ruleName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoT::TopicRule", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTopicRule.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { topicRulePayload: this.topicRulePayload, ruleName: this.ruleName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnTopicRulePropsToCloudFormation(props);
      }
    };
    _z = JSII_RTTI_SYMBOL_1, CfnTopicRule[_z] = { fqn: "aws-cdk-lib.aws_iot.CfnTopicRule", version: "2.80.0" }, CfnTopicRule.CFN_RESOURCE_TYPE_NAME = "AWS::IoT::TopicRule", exports2.CfnTopicRule = CfnTopicRule;
    function CfnTopicRule_ActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudwatchAlarm", CfnTopicRule_CloudwatchAlarmActionPropertyValidator)(properties.cloudwatchAlarm)), errors.collect(cdk.propertyValidator("cloudwatchLogs", CfnTopicRule_CloudwatchLogsActionPropertyValidator)(properties.cloudwatchLogs)), errors.collect(cdk.propertyValidator("cloudwatchMetric", CfnTopicRule_CloudwatchMetricActionPropertyValidator)(properties.cloudwatchMetric)), errors.collect(cdk.propertyValidator("dynamoDb", CfnTopicRule_DynamoDBActionPropertyValidator)(properties.dynamoDb)), errors.collect(cdk.propertyValidator("dynamoDBv2", CfnTopicRule_DynamoDBv2ActionPropertyValidator)(properties.dynamoDBv2)), errors.collect(cdk.propertyValidator("elasticsearch", CfnTopicRule_ElasticsearchActionPropertyValidator)(properties.elasticsearch)), errors.collect(cdk.propertyValidator("firehose", CfnTopicRule_FirehoseActionPropertyValidator)(properties.firehose)), errors.collect(cdk.propertyValidator("http", CfnTopicRule_HttpActionPropertyValidator)(properties.http)), errors.collect(cdk.propertyValidator("iotAnalytics", CfnTopicRule_IotAnalyticsActionPropertyValidator)(properties.iotAnalytics)), errors.collect(cdk.propertyValidator("iotEvents", CfnTopicRule_IotEventsActionPropertyValidator)(properties.iotEvents)), errors.collect(cdk.propertyValidator("iotSiteWise", CfnTopicRule_IotSiteWiseActionPropertyValidator)(properties.iotSiteWise)), errors.collect(cdk.propertyValidator("kafka", CfnTopicRule_KafkaActionPropertyValidator)(properties.kafka)), errors.collect(cdk.propertyValidator("kinesis", CfnTopicRule_KinesisActionPropertyValidator)(properties.kinesis)), errors.collect(cdk.propertyValidator("lambda", CfnTopicRule_LambdaActionPropertyValidator)(properties.lambda)), errors.collect(cdk.propertyValidator("location", CfnTopicRule_LocationActionPropertyValidator)(properties.location)), errors.collect(cdk.propertyValidator("openSearch", CfnTopicRule_OpenSearchActionPropertyValidator)(properties.openSearch)), errors.collect(cdk.propertyValidator("republish", CfnTopicRule_RepublishActionPropertyValidator)(properties.republish)), errors.collect(cdk.propertyValidator("s3", CfnTopicRule_S3ActionPropertyValidator)(properties.s3)), errors.collect(cdk.propertyValidator("sns", CfnTopicRule_SnsActionPropertyValidator)(properties.sns)), errors.collect(cdk.propertyValidator("sqs", CfnTopicRule_SqsActionPropertyValidator)(properties.sqs)), errors.collect(cdk.propertyValidator("stepFunctions", CfnTopicRule_StepFunctionsActionPropertyValidator)(properties.stepFunctions)), errors.collect(cdk.propertyValidator("timestream", CfnTopicRule_TimestreamActionPropertyValidator)(properties.timestream)), errors.wrap('supplied properties not correct for "ActionProperty"');
    }
    function cfnTopicRuleActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_ActionPropertyValidator(properties).assertSuccess(), { CloudwatchAlarm: cfnTopicRuleCloudwatchAlarmActionPropertyToCloudFormation(properties.cloudwatchAlarm), CloudwatchLogs: cfnTopicRuleCloudwatchLogsActionPropertyToCloudFormation(properties.cloudwatchLogs), CloudwatchMetric: cfnTopicRuleCloudwatchMetricActionPropertyToCloudFormation(properties.cloudwatchMetric), DynamoDB: cfnTopicRuleDynamoDBActionPropertyToCloudFormation(properties.dynamoDb), DynamoDBv2: cfnTopicRuleDynamoDBv2ActionPropertyToCloudFormation(properties.dynamoDBv2), Elasticsearch: cfnTopicRuleElasticsearchActionPropertyToCloudFormation(properties.elasticsearch), Firehose: cfnTopicRuleFirehoseActionPropertyToCloudFormation(properties.firehose), Http: cfnTopicRuleHttpActionPropertyToCloudFormation(properties.http), IotAnalytics: cfnTopicRuleIotAnalyticsActionPropertyToCloudFormation(properties.iotAnalytics), IotEvents: cfnTopicRuleIotEventsActionPropertyToCloudFormation(properties.iotEvents), IotSiteWise: cfnTopicRuleIotSiteWiseActionPropertyToCloudFormation(properties.iotSiteWise), Kafka: cfnTopicRuleKafkaActionPropertyToCloudFormation(properties.kafka), Kinesis: cfnTopicRuleKinesisActionPropertyToCloudFormation(properties.kinesis), Lambda: cfnTopicRuleLambdaActionPropertyToCloudFormation(properties.lambda), Location: cfnTopicRuleLocationActionPropertyToCloudFormation(properties.location), OpenSearch: cfnTopicRuleOpenSearchActionPropertyToCloudFormation(properties.openSearch), Republish: cfnTopicRuleRepublishActionPropertyToCloudFormation(properties.republish), S3: cfnTopicRuleS3ActionPropertyToCloudFormation(properties.s3), Sns: cfnTopicRuleSnsActionPropertyToCloudFormation(properties.sns), Sqs: cfnTopicRuleSqsActionPropertyToCloudFormation(properties.sqs), StepFunctions: cfnTopicRuleStepFunctionsActionPropertyToCloudFormation(properties.stepFunctions), Timestream: cfnTopicRuleTimestreamActionPropertyToCloudFormation(properties.timestream) }) : properties;
    }
    function CfnTopicRuleActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudwatchAlarm", "CloudwatchAlarm", properties.CloudwatchAlarm != null ? CfnTopicRuleCloudwatchAlarmActionPropertyFromCloudFormation(properties.CloudwatchAlarm) : void 0), ret.addPropertyResult("cloudwatchLogs", "CloudwatchLogs", properties.CloudwatchLogs != null ? CfnTopicRuleCloudwatchLogsActionPropertyFromCloudFormation(properties.CloudwatchLogs) : void 0), ret.addPropertyResult("cloudwatchMetric", "CloudwatchMetric", properties.CloudwatchMetric != null ? CfnTopicRuleCloudwatchMetricActionPropertyFromCloudFormation(properties.CloudwatchMetric) : void 0), ret.addPropertyResult("dynamoDb", "DynamoDB", properties.DynamoDB != null ? CfnTopicRuleDynamoDBActionPropertyFromCloudFormation(properties.DynamoDB) : void 0), ret.addPropertyResult("dynamoDBv2", "DynamoDBv2", properties.DynamoDBv2 != null ? CfnTopicRuleDynamoDBv2ActionPropertyFromCloudFormation(properties.DynamoDBv2) : void 0), ret.addPropertyResult("elasticsearch", "Elasticsearch", properties.Elasticsearch != null ? CfnTopicRuleElasticsearchActionPropertyFromCloudFormation(properties.Elasticsearch) : void 0), ret.addPropertyResult("firehose", "Firehose", properties.Firehose != null ? CfnTopicRuleFirehoseActionPropertyFromCloudFormation(properties.Firehose) : void 0), ret.addPropertyResult("http", "Http", properties.Http != null ? CfnTopicRuleHttpActionPropertyFromCloudFormation(properties.Http) : void 0), ret.addPropertyResult("iotAnalytics", "IotAnalytics", properties.IotAnalytics != null ? CfnTopicRuleIotAnalyticsActionPropertyFromCloudFormation(properties.IotAnalytics) : void 0), ret.addPropertyResult("iotEvents", "IotEvents", properties.IotEvents != null ? CfnTopicRuleIotEventsActionPropertyFromCloudFormation(properties.IotEvents) : void 0), ret.addPropertyResult("iotSiteWise", "IotSiteWise", properties.IotSiteWise != null ? CfnTopicRuleIotSiteWiseActionPropertyFromCloudFormation(properties.IotSiteWise) : void 0), ret.addPropertyResult("kafka", "Kafka", properties.Kafka != null ? CfnTopicRuleKafkaActionPropertyFromCloudFormation(properties.Kafka) : void 0), ret.addPropertyResult("kinesis", "Kinesis", properties.Kinesis != null ? CfnTopicRuleKinesisActionPropertyFromCloudFormation(properties.Kinesis) : void 0), ret.addPropertyResult("lambda", "Lambda", properties.Lambda != null ? CfnTopicRuleLambdaActionPropertyFromCloudFormation(properties.Lambda) : void 0), ret.addPropertyResult("location", "Location", properties.Location != null ? CfnTopicRuleLocationActionPropertyFromCloudFormation(properties.Location) : void 0), ret.addPropertyResult("openSearch", "OpenSearch", properties.OpenSearch != null ? CfnTopicRuleOpenSearchActionPropertyFromCloudFormation(properties.OpenSearch) : void 0), ret.addPropertyResult("republish", "Republish", properties.Republish != null ? CfnTopicRuleRepublishActionPropertyFromCloudFormation(properties.Republish) : void 0), ret.addPropertyResult("s3", "S3", properties.S3 != null ? CfnTopicRuleS3ActionPropertyFromCloudFormation(properties.S3) : void 0), ret.addPropertyResult("sns", "Sns", properties.Sns != null ? CfnTopicRuleSnsActionPropertyFromCloudFormation(properties.Sns) : void 0), ret.addPropertyResult("sqs", "Sqs", properties.Sqs != null ? CfnTopicRuleSqsActionPropertyFromCloudFormation(properties.Sqs) : void 0), ret.addPropertyResult("stepFunctions", "StepFunctions", properties.StepFunctions != null ? CfnTopicRuleStepFunctionsActionPropertyFromCloudFormation(properties.StepFunctions) : void 0), ret.addPropertyResult("timestream", "Timestream", properties.Timestream != null ? CfnTopicRuleTimestreamActionPropertyFromCloudFormation(properties.Timestream) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_AssetPropertyTimestampPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("offsetInNanos", cdk.validateString)(properties.offsetInNanos)), errors.collect(cdk.propertyValidator("timeInSeconds", cdk.requiredValidator)(properties.timeInSeconds)), errors.collect(cdk.propertyValidator("timeInSeconds", cdk.validateString)(properties.timeInSeconds)), errors.wrap('supplied properties not correct for "AssetPropertyTimestampProperty"');
    }
    function cfnTopicRuleAssetPropertyTimestampPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_AssetPropertyTimestampPropertyValidator(properties).assertSuccess(), { OffsetInNanos: cdk.stringToCloudFormation(properties.offsetInNanos), TimeInSeconds: cdk.stringToCloudFormation(properties.timeInSeconds) }) : properties;
    }
    function CfnTopicRuleAssetPropertyTimestampPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("offsetInNanos", "OffsetInNanos", properties.OffsetInNanos != null ? cfn_parse.FromCloudFormation.getString(properties.OffsetInNanos) : void 0), ret.addPropertyResult("timeInSeconds", "TimeInSeconds", cfn_parse.FromCloudFormation.getString(properties.TimeInSeconds)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_AssetPropertyValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("quality", cdk.validateString)(properties.quality)), errors.collect(cdk.propertyValidator("timestamp", cdk.requiredValidator)(properties.timestamp)), errors.collect(cdk.propertyValidator("timestamp", CfnTopicRule_AssetPropertyTimestampPropertyValidator)(properties.timestamp)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", CfnTopicRule_AssetPropertyVariantPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "AssetPropertyValueProperty"');
    }
    function cfnTopicRuleAssetPropertyValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_AssetPropertyValuePropertyValidator(properties).assertSuccess(), { Quality: cdk.stringToCloudFormation(properties.quality), Timestamp: cfnTopicRuleAssetPropertyTimestampPropertyToCloudFormation(properties.timestamp), Value: cfnTopicRuleAssetPropertyVariantPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnTopicRuleAssetPropertyValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("quality", "Quality", properties.Quality != null ? cfn_parse.FromCloudFormation.getString(properties.Quality) : void 0), ret.addPropertyResult("timestamp", "Timestamp", CfnTopicRuleAssetPropertyTimestampPropertyFromCloudFormation(properties.Timestamp)), ret.addPropertyResult("value", "Value", CfnTopicRuleAssetPropertyVariantPropertyFromCloudFormation(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_AssetPropertyVariantPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("booleanValue", cdk.validateString)(properties.booleanValue)), errors.collect(cdk.propertyValidator("doubleValue", cdk.validateString)(properties.doubleValue)), errors.collect(cdk.propertyValidator("integerValue", cdk.validateString)(properties.integerValue)), errors.collect(cdk.propertyValidator("stringValue", cdk.validateString)(properties.stringValue)), errors.wrap('supplied properties not correct for "AssetPropertyVariantProperty"');
    }
    function cfnTopicRuleAssetPropertyVariantPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_AssetPropertyVariantPropertyValidator(properties).assertSuccess(), { BooleanValue: cdk.stringToCloudFormation(properties.booleanValue), DoubleValue: cdk.stringToCloudFormation(properties.doubleValue), IntegerValue: cdk.stringToCloudFormation(properties.integerValue), StringValue: cdk.stringToCloudFormation(properties.stringValue) }) : properties;
    }
    function CfnTopicRuleAssetPropertyVariantPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("booleanValue", "BooleanValue", properties.BooleanValue != null ? cfn_parse.FromCloudFormation.getString(properties.BooleanValue) : void 0), ret.addPropertyResult("doubleValue", "DoubleValue", properties.DoubleValue != null ? cfn_parse.FromCloudFormation.getString(properties.DoubleValue) : void 0), ret.addPropertyResult("integerValue", "IntegerValue", properties.IntegerValue != null ? cfn_parse.FromCloudFormation.getString(properties.IntegerValue) : void 0), ret.addPropertyResult("stringValue", "StringValue", properties.StringValue != null ? cfn_parse.FromCloudFormation.getString(properties.StringValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_CloudwatchAlarmActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alarmName", cdk.requiredValidator)(properties.alarmName)), errors.collect(cdk.propertyValidator("alarmName", cdk.validateString)(properties.alarmName)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("stateReason", cdk.requiredValidator)(properties.stateReason)), errors.collect(cdk.propertyValidator("stateReason", cdk.validateString)(properties.stateReason)), errors.collect(cdk.propertyValidator("stateValue", cdk.requiredValidator)(properties.stateValue)), errors.collect(cdk.propertyValidator("stateValue", cdk.validateString)(properties.stateValue)), errors.wrap('supplied properties not correct for "CloudwatchAlarmActionProperty"');
    }
    function cfnTopicRuleCloudwatchAlarmActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_CloudwatchAlarmActionPropertyValidator(properties).assertSuccess(), { AlarmName: cdk.stringToCloudFormation(properties.alarmName), RoleArn: cdk.stringToCloudFormation(properties.roleArn), StateReason: cdk.stringToCloudFormation(properties.stateReason), StateValue: cdk.stringToCloudFormation(properties.stateValue) }) : properties;
    }
    function CfnTopicRuleCloudwatchAlarmActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alarmName", "AlarmName", cfn_parse.FromCloudFormation.getString(properties.AlarmName)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("stateReason", "StateReason", cfn_parse.FromCloudFormation.getString(properties.StateReason)), ret.addPropertyResult("stateValue", "StateValue", cfn_parse.FromCloudFormation.getString(properties.StateValue)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_CloudwatchLogsActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("batchMode", cdk.validateBoolean)(properties.batchMode)), errors.collect(cdk.propertyValidator("logGroupName", cdk.requiredValidator)(properties.logGroupName)), errors.collect(cdk.propertyValidator("logGroupName", cdk.validateString)(properties.logGroupName)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "CloudwatchLogsActionProperty"');
    }
    function cfnTopicRuleCloudwatchLogsActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_CloudwatchLogsActionPropertyValidator(properties).assertSuccess(), { BatchMode: cdk.booleanToCloudFormation(properties.batchMode), LogGroupName: cdk.stringToCloudFormation(properties.logGroupName), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnTopicRuleCloudwatchLogsActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("batchMode", "BatchMode", properties.BatchMode != null ? cfn_parse.FromCloudFormation.getBoolean(properties.BatchMode) : void 0), ret.addPropertyResult("logGroupName", "LogGroupName", cfn_parse.FromCloudFormation.getString(properties.LogGroupName)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_CloudwatchMetricActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("metricName", cdk.requiredValidator)(properties.metricName)), errors.collect(cdk.propertyValidator("metricName", cdk.validateString)(properties.metricName)), errors.collect(cdk.propertyValidator("metricNamespace", cdk.requiredValidator)(properties.metricNamespace)), errors.collect(cdk.propertyValidator("metricNamespace", cdk.validateString)(properties.metricNamespace)), errors.collect(cdk.propertyValidator("metricTimestamp", cdk.validateString)(properties.metricTimestamp)), errors.collect(cdk.propertyValidator("metricUnit", cdk.requiredValidator)(properties.metricUnit)), errors.collect(cdk.propertyValidator("metricUnit", cdk.validateString)(properties.metricUnit)), errors.collect(cdk.propertyValidator("metricValue", cdk.requiredValidator)(properties.metricValue)), errors.collect(cdk.propertyValidator("metricValue", cdk.validateString)(properties.metricValue)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "CloudwatchMetricActionProperty"');
    }
    function cfnTopicRuleCloudwatchMetricActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_CloudwatchMetricActionPropertyValidator(properties).assertSuccess(), { MetricName: cdk.stringToCloudFormation(properties.metricName), MetricNamespace: cdk.stringToCloudFormation(properties.metricNamespace), MetricTimestamp: cdk.stringToCloudFormation(properties.metricTimestamp), MetricUnit: cdk.stringToCloudFormation(properties.metricUnit), MetricValue: cdk.stringToCloudFormation(properties.metricValue), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnTopicRuleCloudwatchMetricActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("metricName", "MetricName", cfn_parse.FromCloudFormation.getString(properties.MetricName)), ret.addPropertyResult("metricNamespace", "MetricNamespace", cfn_parse.FromCloudFormation.getString(properties.MetricNamespace)), ret.addPropertyResult("metricTimestamp", "MetricTimestamp", properties.MetricTimestamp != null ? cfn_parse.FromCloudFormation.getString(properties.MetricTimestamp) : void 0), ret.addPropertyResult("metricUnit", "MetricUnit", cfn_parse.FromCloudFormation.getString(properties.MetricUnit)), ret.addPropertyResult("metricValue", "MetricValue", cfn_parse.FromCloudFormation.getString(properties.MetricValue)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_DynamoDBActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("hashKeyField", cdk.requiredValidator)(properties.hashKeyField)), errors.collect(cdk.propertyValidator("hashKeyField", cdk.validateString)(properties.hashKeyField)), errors.collect(cdk.propertyValidator("hashKeyType", cdk.validateString)(properties.hashKeyType)), errors.collect(cdk.propertyValidator("hashKeyValue", cdk.requiredValidator)(properties.hashKeyValue)), errors.collect(cdk.propertyValidator("hashKeyValue", cdk.validateString)(properties.hashKeyValue)), errors.collect(cdk.propertyValidator("payloadField", cdk.validateString)(properties.payloadField)), errors.collect(cdk.propertyValidator("rangeKeyField", cdk.validateString)(properties.rangeKeyField)), errors.collect(cdk.propertyValidator("rangeKeyType", cdk.validateString)(properties.rangeKeyType)), errors.collect(cdk.propertyValidator("rangeKeyValue", cdk.validateString)(properties.rangeKeyValue)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("tableName", cdk.requiredValidator)(properties.tableName)), errors.collect(cdk.propertyValidator("tableName", cdk.validateString)(properties.tableName)), errors.wrap('supplied properties not correct for "DynamoDBActionProperty"');
    }
    function cfnTopicRuleDynamoDBActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_DynamoDBActionPropertyValidator(properties).assertSuccess(), { HashKeyField: cdk.stringToCloudFormation(properties.hashKeyField), HashKeyType: cdk.stringToCloudFormation(properties.hashKeyType), HashKeyValue: cdk.stringToCloudFormation(properties.hashKeyValue), PayloadField: cdk.stringToCloudFormation(properties.payloadField), RangeKeyField: cdk.stringToCloudFormation(properties.rangeKeyField), RangeKeyType: cdk.stringToCloudFormation(properties.rangeKeyType), RangeKeyValue: cdk.stringToCloudFormation(properties.rangeKeyValue), RoleArn: cdk.stringToCloudFormation(properties.roleArn), TableName: cdk.stringToCloudFormation(properties.tableName) }) : properties;
    }
    function CfnTopicRuleDynamoDBActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("hashKeyField", "HashKeyField", cfn_parse.FromCloudFormation.getString(properties.HashKeyField)), ret.addPropertyResult("hashKeyType", "HashKeyType", properties.HashKeyType != null ? cfn_parse.FromCloudFormation.getString(properties.HashKeyType) : void 0), ret.addPropertyResult("hashKeyValue", "HashKeyValue", cfn_parse.FromCloudFormation.getString(properties.HashKeyValue)), ret.addPropertyResult("payloadField", "PayloadField", properties.PayloadField != null ? cfn_parse.FromCloudFormation.getString(properties.PayloadField) : void 0), ret.addPropertyResult("rangeKeyField", "RangeKeyField", properties.RangeKeyField != null ? cfn_parse.FromCloudFormation.getString(properties.RangeKeyField) : void 0), ret.addPropertyResult("rangeKeyType", "RangeKeyType", properties.RangeKeyType != null ? cfn_parse.FromCloudFormation.getString(properties.RangeKeyType) : void 0), ret.addPropertyResult("rangeKeyValue", "RangeKeyValue", properties.RangeKeyValue != null ? cfn_parse.FromCloudFormation.getString(properties.RangeKeyValue) : void 0), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("tableName", "TableName", cfn_parse.FromCloudFormation.getString(properties.TableName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_DynamoDBv2ActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("putItem", CfnTopicRule_PutItemInputPropertyValidator)(properties.putItem)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "DynamoDBv2ActionProperty"');
    }
    function cfnTopicRuleDynamoDBv2ActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_DynamoDBv2ActionPropertyValidator(properties).assertSuccess(), { PutItem: cfnTopicRulePutItemInputPropertyToCloudFormation(properties.putItem), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnTopicRuleDynamoDBv2ActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("putItem", "PutItem", properties.PutItem != null ? CfnTopicRulePutItemInputPropertyFromCloudFormation(properties.PutItem) : void 0), ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_ElasticsearchActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endpoint", cdk.requiredValidator)(properties.endpoint)), errors.collect(cdk.propertyValidator("endpoint", cdk.validateString)(properties.endpoint)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("index", cdk.requiredValidator)(properties.index)), errors.collect(cdk.propertyValidator("index", cdk.validateString)(properties.index)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "ElasticsearchActionProperty"');
    }
    function cfnTopicRuleElasticsearchActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_ElasticsearchActionPropertyValidator(properties).assertSuccess(), { Endpoint: cdk.stringToCloudFormation(properties.endpoint), Id: cdk.stringToCloudFormation(properties.id), Index: cdk.stringToCloudFormation(properties.index), RoleArn: cdk.stringToCloudFormation(properties.roleArn), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnTopicRuleElasticsearchActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endpoint", "Endpoint", cfn_parse.FromCloudFormation.getString(properties.Endpoint)), ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("index", "Index", cfn_parse.FromCloudFormation.getString(properties.Index)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_FirehoseActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("batchMode", cdk.validateBoolean)(properties.batchMode)), errors.collect(cdk.propertyValidator("deliveryStreamName", cdk.requiredValidator)(properties.deliveryStreamName)), errors.collect(cdk.propertyValidator("deliveryStreamName", cdk.validateString)(properties.deliveryStreamName)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("separator", cdk.validateString)(properties.separator)), errors.wrap('supplied properties not correct for "FirehoseActionProperty"');
    }
    function cfnTopicRuleFirehoseActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_FirehoseActionPropertyValidator(properties).assertSuccess(), { BatchMode: cdk.booleanToCloudFormation(properties.batchMode), DeliveryStreamName: cdk.stringToCloudFormation(properties.deliveryStreamName), RoleArn: cdk.stringToCloudFormation(properties.roleArn), Separator: cdk.stringToCloudFormation(properties.separator) }) : properties;
    }
    function CfnTopicRuleFirehoseActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("batchMode", "BatchMode", properties.BatchMode != null ? cfn_parse.FromCloudFormation.getBoolean(properties.BatchMode) : void 0), ret.addPropertyResult("deliveryStreamName", "DeliveryStreamName", cfn_parse.FromCloudFormation.getString(properties.DeliveryStreamName)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("separator", "Separator", properties.Separator != null ? cfn_parse.FromCloudFormation.getString(properties.Separator) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_HttpActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("auth", CfnTopicRule_HttpAuthorizationPropertyValidator)(properties.auth)), errors.collect(cdk.propertyValidator("confirmationUrl", cdk.validateString)(properties.confirmationUrl)), errors.collect(cdk.propertyValidator("headers", cdk.listValidator(CfnTopicRule_HttpActionHeaderPropertyValidator))(properties.headers)), errors.collect(cdk.propertyValidator("url", cdk.requiredValidator)(properties.url)), errors.collect(cdk.propertyValidator("url", cdk.validateString)(properties.url)), errors.wrap('supplied properties not correct for "HttpActionProperty"');
    }
    function cfnTopicRuleHttpActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_HttpActionPropertyValidator(properties).assertSuccess(), { Auth: cfnTopicRuleHttpAuthorizationPropertyToCloudFormation(properties.auth), ConfirmationUrl: cdk.stringToCloudFormation(properties.confirmationUrl), Headers: cdk.listMapper(cfnTopicRuleHttpActionHeaderPropertyToCloudFormation)(properties.headers), Url: cdk.stringToCloudFormation(properties.url) }) : properties;
    }
    function CfnTopicRuleHttpActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("auth", "Auth", properties.Auth != null ? CfnTopicRuleHttpAuthorizationPropertyFromCloudFormation(properties.Auth) : void 0), ret.addPropertyResult("confirmationUrl", "ConfirmationUrl", properties.ConfirmationUrl != null ? cfn_parse.FromCloudFormation.getString(properties.ConfirmationUrl) : void 0), ret.addPropertyResult("headers", "Headers", properties.Headers != null ? cfn_parse.FromCloudFormation.getArray(CfnTopicRuleHttpActionHeaderPropertyFromCloudFormation)(properties.Headers) : void 0), ret.addPropertyResult("url", "Url", cfn_parse.FromCloudFormation.getString(properties.Url)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_HttpActionHeaderPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "HttpActionHeaderProperty"');
    }
    function cfnTopicRuleHttpActionHeaderPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_HttpActionHeaderPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnTopicRuleHttpActionHeaderPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_HttpAuthorizationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sigv4", CfnTopicRule_SigV4AuthorizationPropertyValidator)(properties.sigv4)), errors.wrap('supplied properties not correct for "HttpAuthorizationProperty"');
    }
    function cfnTopicRuleHttpAuthorizationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_HttpAuthorizationPropertyValidator(properties).assertSuccess(), { Sigv4: cfnTopicRuleSigV4AuthorizationPropertyToCloudFormation(properties.sigv4) }) : properties;
    }
    function CfnTopicRuleHttpAuthorizationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sigv4", "Sigv4", properties.Sigv4 != null ? CfnTopicRuleSigV4AuthorizationPropertyFromCloudFormation(properties.Sigv4) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_IotAnalyticsActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("batchMode", cdk.validateBoolean)(properties.batchMode)), errors.collect(cdk.propertyValidator("channelName", cdk.requiredValidator)(properties.channelName)), errors.collect(cdk.propertyValidator("channelName", cdk.validateString)(properties.channelName)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "IotAnalyticsActionProperty"');
    }
    function cfnTopicRuleIotAnalyticsActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_IotAnalyticsActionPropertyValidator(properties).assertSuccess(), { BatchMode: cdk.booleanToCloudFormation(properties.batchMode), ChannelName: cdk.stringToCloudFormation(properties.channelName), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnTopicRuleIotAnalyticsActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("batchMode", "BatchMode", properties.BatchMode != null ? cfn_parse.FromCloudFormation.getBoolean(properties.BatchMode) : void 0), ret.addPropertyResult("channelName", "ChannelName", cfn_parse.FromCloudFormation.getString(properties.ChannelName)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_IotEventsActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("batchMode", cdk.validateBoolean)(properties.batchMode)), errors.collect(cdk.propertyValidator("inputName", cdk.requiredValidator)(properties.inputName)), errors.collect(cdk.propertyValidator("inputName", cdk.validateString)(properties.inputName)), errors.collect(cdk.propertyValidator("messageId", cdk.validateString)(properties.messageId)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "IotEventsActionProperty"');
    }
    function cfnTopicRuleIotEventsActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_IotEventsActionPropertyValidator(properties).assertSuccess(), { BatchMode: cdk.booleanToCloudFormation(properties.batchMode), InputName: cdk.stringToCloudFormation(properties.inputName), MessageId: cdk.stringToCloudFormation(properties.messageId), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnTopicRuleIotEventsActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("batchMode", "BatchMode", properties.BatchMode != null ? cfn_parse.FromCloudFormation.getBoolean(properties.BatchMode) : void 0), ret.addPropertyResult("inputName", "InputName", cfn_parse.FromCloudFormation.getString(properties.InputName)), ret.addPropertyResult("messageId", "MessageId", properties.MessageId != null ? cfn_parse.FromCloudFormation.getString(properties.MessageId) : void 0), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_IotSiteWiseActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("putAssetPropertyValueEntries", cdk.requiredValidator)(properties.putAssetPropertyValueEntries)), errors.collect(cdk.propertyValidator("putAssetPropertyValueEntries", cdk.listValidator(CfnTopicRule_PutAssetPropertyValueEntryPropertyValidator))(properties.putAssetPropertyValueEntries)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "IotSiteWiseActionProperty"');
    }
    function cfnTopicRuleIotSiteWiseActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_IotSiteWiseActionPropertyValidator(properties).assertSuccess(), { PutAssetPropertyValueEntries: cdk.listMapper(cfnTopicRulePutAssetPropertyValueEntryPropertyToCloudFormation)(properties.putAssetPropertyValueEntries), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnTopicRuleIotSiteWiseActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("putAssetPropertyValueEntries", "PutAssetPropertyValueEntries", cfn_parse.FromCloudFormation.getArray(CfnTopicRulePutAssetPropertyValueEntryPropertyFromCloudFormation)(properties.PutAssetPropertyValueEntries)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_KafkaActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clientProperties", cdk.requiredValidator)(properties.clientProperties)), errors.collect(cdk.propertyValidator("clientProperties", cdk.hashValidator(cdk.validateString))(properties.clientProperties)), errors.collect(cdk.propertyValidator("destinationArn", cdk.requiredValidator)(properties.destinationArn)), errors.collect(cdk.propertyValidator("destinationArn", cdk.validateString)(properties.destinationArn)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("partition", cdk.validateString)(properties.partition)), errors.collect(cdk.propertyValidator("topic", cdk.requiredValidator)(properties.topic)), errors.collect(cdk.propertyValidator("topic", cdk.validateString)(properties.topic)), errors.wrap('supplied properties not correct for "KafkaActionProperty"');
    }
    function cfnTopicRuleKafkaActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_KafkaActionPropertyValidator(properties).assertSuccess(), { ClientProperties: cdk.hashMapper(cdk.stringToCloudFormation)(properties.clientProperties), DestinationArn: cdk.stringToCloudFormation(properties.destinationArn), Key: cdk.stringToCloudFormation(properties.key), Partition: cdk.stringToCloudFormation(properties.partition), Topic: cdk.stringToCloudFormation(properties.topic) }) : properties;
    }
    function CfnTopicRuleKafkaActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clientProperties", "ClientProperties", cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.ClientProperties)), ret.addPropertyResult("destinationArn", "DestinationArn", cfn_parse.FromCloudFormation.getString(properties.DestinationArn)), ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("partition", "Partition", properties.Partition != null ? cfn_parse.FromCloudFormation.getString(properties.Partition) : void 0), ret.addPropertyResult("topic", "Topic", cfn_parse.FromCloudFormation.getString(properties.Topic)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_KinesisActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("partitionKey", cdk.validateString)(properties.partitionKey)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("streamName", cdk.requiredValidator)(properties.streamName)), errors.collect(cdk.propertyValidator("streamName", cdk.validateString)(properties.streamName)), errors.wrap('supplied properties not correct for "KinesisActionProperty"');
    }
    function cfnTopicRuleKinesisActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_KinesisActionPropertyValidator(properties).assertSuccess(), { PartitionKey: cdk.stringToCloudFormation(properties.partitionKey), RoleArn: cdk.stringToCloudFormation(properties.roleArn), StreamName: cdk.stringToCloudFormation(properties.streamName) }) : properties;
    }
    function CfnTopicRuleKinesisActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("partitionKey", "PartitionKey", properties.PartitionKey != null ? cfn_parse.FromCloudFormation.getString(properties.PartitionKey) : void 0), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("streamName", "StreamName", cfn_parse.FromCloudFormation.getString(properties.StreamName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_LambdaActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("functionArn", cdk.validateString)(properties.functionArn)), errors.wrap('supplied properties not correct for "LambdaActionProperty"');
    }
    function cfnTopicRuleLambdaActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_LambdaActionPropertyValidator(properties).assertSuccess(), { FunctionArn: cdk.stringToCloudFormation(properties.functionArn) }) : properties;
    }
    function CfnTopicRuleLambdaActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("functionArn", "FunctionArn", properties.FunctionArn != null ? cfn_parse.FromCloudFormation.getString(properties.FunctionArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_LocationActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deviceId", cdk.requiredValidator)(properties.deviceId)), errors.collect(cdk.propertyValidator("deviceId", cdk.validateString)(properties.deviceId)), errors.collect(cdk.propertyValidator("latitude", cdk.requiredValidator)(properties.latitude)), errors.collect(cdk.propertyValidator("latitude", cdk.validateString)(properties.latitude)), errors.collect(cdk.propertyValidator("longitude", cdk.requiredValidator)(properties.longitude)), errors.collect(cdk.propertyValidator("longitude", cdk.validateString)(properties.longitude)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("timestamp", CfnTopicRule_TimestampPropertyValidator)(properties.timestamp)), errors.collect(cdk.propertyValidator("trackerName", cdk.requiredValidator)(properties.trackerName)), errors.collect(cdk.propertyValidator("trackerName", cdk.validateString)(properties.trackerName)), errors.wrap('supplied properties not correct for "LocationActionProperty"');
    }
    function cfnTopicRuleLocationActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_LocationActionPropertyValidator(properties).assertSuccess(), { DeviceId: cdk.stringToCloudFormation(properties.deviceId), Latitude: cdk.stringToCloudFormation(properties.latitude), Longitude: cdk.stringToCloudFormation(properties.longitude), RoleArn: cdk.stringToCloudFormation(properties.roleArn), Timestamp: cfnTopicRuleTimestampPropertyToCloudFormation(properties.timestamp), TrackerName: cdk.stringToCloudFormation(properties.trackerName) }) : properties;
    }
    function CfnTopicRuleLocationActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deviceId", "DeviceId", cfn_parse.FromCloudFormation.getString(properties.DeviceId)), ret.addPropertyResult("latitude", "Latitude", cfn_parse.FromCloudFormation.getString(properties.Latitude)), ret.addPropertyResult("longitude", "Longitude", cfn_parse.FromCloudFormation.getString(properties.Longitude)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("timestamp", "Timestamp", properties.Timestamp != null ? CfnTopicRuleTimestampPropertyFromCloudFormation(properties.Timestamp) : void 0), ret.addPropertyResult("trackerName", "TrackerName", cfn_parse.FromCloudFormation.getString(properties.TrackerName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_OpenSearchActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endpoint", cdk.requiredValidator)(properties.endpoint)), errors.collect(cdk.propertyValidator("endpoint", cdk.validateString)(properties.endpoint)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("index", cdk.requiredValidator)(properties.index)), errors.collect(cdk.propertyValidator("index", cdk.validateString)(properties.index)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "OpenSearchActionProperty"');
    }
    function cfnTopicRuleOpenSearchActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_OpenSearchActionPropertyValidator(properties).assertSuccess(), { Endpoint: cdk.stringToCloudFormation(properties.endpoint), Id: cdk.stringToCloudFormation(properties.id), Index: cdk.stringToCloudFormation(properties.index), RoleArn: cdk.stringToCloudFormation(properties.roleArn), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnTopicRuleOpenSearchActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endpoint", "Endpoint", cfn_parse.FromCloudFormation.getString(properties.Endpoint)), ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("index", "Index", cfn_parse.FromCloudFormation.getString(properties.Index)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_PutAssetPropertyValueEntryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("assetId", cdk.validateString)(properties.assetId)), errors.collect(cdk.propertyValidator("entryId", cdk.validateString)(properties.entryId)), errors.collect(cdk.propertyValidator("propertyAlias", cdk.validateString)(properties.propertyAlias)), errors.collect(cdk.propertyValidator("propertyId", cdk.validateString)(properties.propertyId)), errors.collect(cdk.propertyValidator("propertyValues", cdk.requiredValidator)(properties.propertyValues)), errors.collect(cdk.propertyValidator("propertyValues", cdk.listValidator(CfnTopicRule_AssetPropertyValuePropertyValidator))(properties.propertyValues)), errors.wrap('supplied properties not correct for "PutAssetPropertyValueEntryProperty"');
    }
    function cfnTopicRulePutAssetPropertyValueEntryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_PutAssetPropertyValueEntryPropertyValidator(properties).assertSuccess(), { AssetId: cdk.stringToCloudFormation(properties.assetId), EntryId: cdk.stringToCloudFormation(properties.entryId), PropertyAlias: cdk.stringToCloudFormation(properties.propertyAlias), PropertyId: cdk.stringToCloudFormation(properties.propertyId), PropertyValues: cdk.listMapper(cfnTopicRuleAssetPropertyValuePropertyToCloudFormation)(properties.propertyValues) }) : properties;
    }
    function CfnTopicRulePutAssetPropertyValueEntryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("assetId", "AssetId", properties.AssetId != null ? cfn_parse.FromCloudFormation.getString(properties.AssetId) : void 0), ret.addPropertyResult("entryId", "EntryId", properties.EntryId != null ? cfn_parse.FromCloudFormation.getString(properties.EntryId) : void 0), ret.addPropertyResult("propertyAlias", "PropertyAlias", properties.PropertyAlias != null ? cfn_parse.FromCloudFormation.getString(properties.PropertyAlias) : void 0), ret.addPropertyResult("propertyId", "PropertyId", properties.PropertyId != null ? cfn_parse.FromCloudFormation.getString(properties.PropertyId) : void 0), ret.addPropertyResult("propertyValues", "PropertyValues", cfn_parse.FromCloudFormation.getArray(CfnTopicRuleAssetPropertyValuePropertyFromCloudFormation)(properties.PropertyValues)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_PutItemInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("tableName", cdk.requiredValidator)(properties.tableName)), errors.collect(cdk.propertyValidator("tableName", cdk.validateString)(properties.tableName)), errors.wrap('supplied properties not correct for "PutItemInputProperty"');
    }
    function cfnTopicRulePutItemInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_PutItemInputPropertyValidator(properties).assertSuccess(), { TableName: cdk.stringToCloudFormation(properties.tableName) }) : properties;
    }
    function CfnTopicRulePutItemInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("tableName", "TableName", cfn_parse.FromCloudFormation.getString(properties.TableName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_RepublishActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("headers", CfnTopicRule_RepublishActionHeadersPropertyValidator)(properties.headers)), errors.collect(cdk.propertyValidator("qos", cdk.validateNumber)(properties.qos)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("topic", cdk.requiredValidator)(properties.topic)), errors.collect(cdk.propertyValidator("topic", cdk.validateString)(properties.topic)), errors.wrap('supplied properties not correct for "RepublishActionProperty"');
    }
    function cfnTopicRuleRepublishActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_RepublishActionPropertyValidator(properties).assertSuccess(), { Headers: cfnTopicRuleRepublishActionHeadersPropertyToCloudFormation(properties.headers), Qos: cdk.numberToCloudFormation(properties.qos), RoleArn: cdk.stringToCloudFormation(properties.roleArn), Topic: cdk.stringToCloudFormation(properties.topic) }) : properties;
    }
    function CfnTopicRuleRepublishActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("headers", "Headers", properties.Headers != null ? CfnTopicRuleRepublishActionHeadersPropertyFromCloudFormation(properties.Headers) : void 0), ret.addPropertyResult("qos", "Qos", properties.Qos != null ? cfn_parse.FromCloudFormation.getNumber(properties.Qos) : void 0), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("topic", "Topic", cfn_parse.FromCloudFormation.getString(properties.Topic)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_RepublishActionHeadersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contentType", cdk.validateString)(properties.contentType)), errors.collect(cdk.propertyValidator("correlationData", cdk.validateString)(properties.correlationData)), errors.collect(cdk.propertyValidator("messageExpiry", cdk.validateString)(properties.messageExpiry)), errors.collect(cdk.propertyValidator("payloadFormatIndicator", cdk.validateString)(properties.payloadFormatIndicator)), errors.collect(cdk.propertyValidator("responseTopic", cdk.validateString)(properties.responseTopic)), errors.collect(cdk.propertyValidator("userProperties", cdk.listValidator(CfnTopicRule_UserPropertyPropertyValidator))(properties.userProperties)), errors.wrap('supplied properties not correct for "RepublishActionHeadersProperty"');
    }
    function cfnTopicRuleRepublishActionHeadersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_RepublishActionHeadersPropertyValidator(properties).assertSuccess(), { ContentType: cdk.stringToCloudFormation(properties.contentType), CorrelationData: cdk.stringToCloudFormation(properties.correlationData), MessageExpiry: cdk.stringToCloudFormation(properties.messageExpiry), PayloadFormatIndicator: cdk.stringToCloudFormation(properties.payloadFormatIndicator), ResponseTopic: cdk.stringToCloudFormation(properties.responseTopic), UserProperties: cdk.listMapper(cfnTopicRuleUserPropertyPropertyToCloudFormation)(properties.userProperties) }) : properties;
    }
    function CfnTopicRuleRepublishActionHeadersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contentType", "ContentType", properties.ContentType != null ? cfn_parse.FromCloudFormation.getString(properties.ContentType) : void 0), ret.addPropertyResult("correlationData", "CorrelationData", properties.CorrelationData != null ? cfn_parse.FromCloudFormation.getString(properties.CorrelationData) : void 0), ret.addPropertyResult("messageExpiry", "MessageExpiry", properties.MessageExpiry != null ? cfn_parse.FromCloudFormation.getString(properties.MessageExpiry) : void 0), ret.addPropertyResult("payloadFormatIndicator", "PayloadFormatIndicator", properties.PayloadFormatIndicator != null ? cfn_parse.FromCloudFormation.getString(properties.PayloadFormatIndicator) : void 0), ret.addPropertyResult("responseTopic", "ResponseTopic", properties.ResponseTopic != null ? cfn_parse.FromCloudFormation.getString(properties.ResponseTopic) : void 0), ret.addPropertyResult("userProperties", "UserProperties", properties.UserProperties != null ? cfn_parse.FromCloudFormation.getArray(CfnTopicRuleUserPropertyPropertyFromCloudFormation)(properties.UserProperties) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_S3ActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketName", cdk.requiredValidator)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.collect(cdk.propertyValidator("cannedAcl", cdk.validateString)(properties.cannedAcl)), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "S3ActionProperty"');
    }
    function cfnTopicRuleS3ActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_S3ActionPropertyValidator(properties).assertSuccess(), { BucketName: cdk.stringToCloudFormation(properties.bucketName), CannedAcl: cdk.stringToCloudFormation(properties.cannedAcl), Key: cdk.stringToCloudFormation(properties.key), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnTopicRuleS3ActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketName", "BucketName", cfn_parse.FromCloudFormation.getString(properties.BucketName)), ret.addPropertyResult("cannedAcl", "CannedAcl", properties.CannedAcl != null ? cfn_parse.FromCloudFormation.getString(properties.CannedAcl) : void 0), ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_SigV4AuthorizationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("serviceName", cdk.requiredValidator)(properties.serviceName)), errors.collect(cdk.propertyValidator("serviceName", cdk.validateString)(properties.serviceName)), errors.collect(cdk.propertyValidator("signingRegion", cdk.requiredValidator)(properties.signingRegion)), errors.collect(cdk.propertyValidator("signingRegion", cdk.validateString)(properties.signingRegion)), errors.wrap('supplied properties not correct for "SigV4AuthorizationProperty"');
    }
    function cfnTopicRuleSigV4AuthorizationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_SigV4AuthorizationPropertyValidator(properties).assertSuccess(), { RoleArn: cdk.stringToCloudFormation(properties.roleArn), ServiceName: cdk.stringToCloudFormation(properties.serviceName), SigningRegion: cdk.stringToCloudFormation(properties.signingRegion) }) : properties;
    }
    function CfnTopicRuleSigV4AuthorizationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("serviceName", "ServiceName", cfn_parse.FromCloudFormation.getString(properties.ServiceName)), ret.addPropertyResult("signingRegion", "SigningRegion", cfn_parse.FromCloudFormation.getString(properties.SigningRegion)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_SnsActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("messageFormat", cdk.validateString)(properties.messageFormat)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("targetArn", cdk.requiredValidator)(properties.targetArn)), errors.collect(cdk.propertyValidator("targetArn", cdk.validateString)(properties.targetArn)), errors.wrap('supplied properties not correct for "SnsActionProperty"');
    }
    function cfnTopicRuleSnsActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_SnsActionPropertyValidator(properties).assertSuccess(), { MessageFormat: cdk.stringToCloudFormation(properties.messageFormat), RoleArn: cdk.stringToCloudFormation(properties.roleArn), TargetArn: cdk.stringToCloudFormation(properties.targetArn) }) : properties;
    }
    function CfnTopicRuleSnsActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("messageFormat", "MessageFormat", properties.MessageFormat != null ? cfn_parse.FromCloudFormation.getString(properties.MessageFormat) : void 0), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("targetArn", "TargetArn", cfn_parse.FromCloudFormation.getString(properties.TargetArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_SqsActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("queueUrl", cdk.requiredValidator)(properties.queueUrl)), errors.collect(cdk.propertyValidator("queueUrl", cdk.validateString)(properties.queueUrl)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("useBase64", cdk.validateBoolean)(properties.useBase64)), errors.wrap('supplied properties not correct for "SqsActionProperty"');
    }
    function cfnTopicRuleSqsActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_SqsActionPropertyValidator(properties).assertSuccess(), { QueueUrl: cdk.stringToCloudFormation(properties.queueUrl), RoleArn: cdk.stringToCloudFormation(properties.roleArn), UseBase64: cdk.booleanToCloudFormation(properties.useBase64) }) : properties;
    }
    function CfnTopicRuleSqsActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("queueUrl", "QueueUrl", cfn_parse.FromCloudFormation.getString(properties.QueueUrl)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("useBase64", "UseBase64", properties.UseBase64 != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseBase64) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_StepFunctionsActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("executionNamePrefix", cdk.validateString)(properties.executionNamePrefix)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("stateMachineName", cdk.requiredValidator)(properties.stateMachineName)), errors.collect(cdk.propertyValidator("stateMachineName", cdk.validateString)(properties.stateMachineName)), errors.wrap('supplied properties not correct for "StepFunctionsActionProperty"');
    }
    function cfnTopicRuleStepFunctionsActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_StepFunctionsActionPropertyValidator(properties).assertSuccess(), { ExecutionNamePrefix: cdk.stringToCloudFormation(properties.executionNamePrefix), RoleArn: cdk.stringToCloudFormation(properties.roleArn), StateMachineName: cdk.stringToCloudFormation(properties.stateMachineName) }) : properties;
    }
    function CfnTopicRuleStepFunctionsActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("executionNamePrefix", "ExecutionNamePrefix", properties.ExecutionNamePrefix != null ? cfn_parse.FromCloudFormation.getString(properties.ExecutionNamePrefix) : void 0), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("stateMachineName", "StateMachineName", cfn_parse.FromCloudFormation.getString(properties.StateMachineName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_TimestampPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("unit", cdk.validateString)(properties.unit)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TimestampProperty"');
    }
    function cfnTopicRuleTimestampPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_TimestampPropertyValidator(properties).assertSuccess(), { Unit: cdk.stringToCloudFormation(properties.unit), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnTopicRuleTimestampPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("unit", "Unit", properties.Unit != null ? cfn_parse.FromCloudFormation.getString(properties.Unit) : void 0), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_TimestreamActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("databaseName", cdk.requiredValidator)(properties.databaseName)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("dimensions", cdk.requiredValidator)(properties.dimensions)), errors.collect(cdk.propertyValidator("dimensions", cdk.listValidator(CfnTopicRule_TimestreamDimensionPropertyValidator))(properties.dimensions)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("tableName", cdk.requiredValidator)(properties.tableName)), errors.collect(cdk.propertyValidator("tableName", cdk.validateString)(properties.tableName)), errors.collect(cdk.propertyValidator("timestamp", CfnTopicRule_TimestreamTimestampPropertyValidator)(properties.timestamp)), errors.wrap('supplied properties not correct for "TimestreamActionProperty"');
    }
    function cfnTopicRuleTimestreamActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_TimestreamActionPropertyValidator(properties).assertSuccess(), { DatabaseName: cdk.stringToCloudFormation(properties.databaseName), Dimensions: cdk.listMapper(cfnTopicRuleTimestreamDimensionPropertyToCloudFormation)(properties.dimensions), RoleArn: cdk.stringToCloudFormation(properties.roleArn), TableName: cdk.stringToCloudFormation(properties.tableName), Timestamp: cfnTopicRuleTimestreamTimestampPropertyToCloudFormation(properties.timestamp) }) : properties;
    }
    function CfnTopicRuleTimestreamActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("databaseName", "DatabaseName", cfn_parse.FromCloudFormation.getString(properties.DatabaseName)), ret.addPropertyResult("dimensions", "Dimensions", cfn_parse.FromCloudFormation.getArray(CfnTopicRuleTimestreamDimensionPropertyFromCloudFormation)(properties.Dimensions)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("tableName", "TableName", cfn_parse.FromCloudFormation.getString(properties.TableName)), ret.addPropertyResult("timestamp", "Timestamp", properties.Timestamp != null ? CfnTopicRuleTimestreamTimestampPropertyFromCloudFormation(properties.Timestamp) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_TimestreamDimensionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TimestreamDimensionProperty"');
    }
    function cfnTopicRuleTimestreamDimensionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_TimestreamDimensionPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnTopicRuleTimestreamDimensionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_TimestreamTimestampPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("unit", cdk.requiredValidator)(properties.unit)), errors.collect(cdk.propertyValidator("unit", cdk.validateString)(properties.unit)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TimestreamTimestampProperty"');
    }
    function cfnTopicRuleTimestreamTimestampPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_TimestreamTimestampPropertyValidator(properties).assertSuccess(), { Unit: cdk.stringToCloudFormation(properties.unit), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnTopicRuleTimestreamTimestampPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("unit", "Unit", cfn_parse.FromCloudFormation.getString(properties.Unit)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_TopicRulePayloadPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.requiredValidator)(properties.actions)), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnTopicRule_ActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("awsIotSqlVersion", cdk.validateString)(properties.awsIotSqlVersion)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("errorAction", CfnTopicRule_ActionPropertyValidator)(properties.errorAction)), errors.collect(cdk.propertyValidator("ruleDisabled", cdk.validateBoolean)(properties.ruleDisabled)), errors.collect(cdk.propertyValidator("sql", cdk.requiredValidator)(properties.sql)), errors.collect(cdk.propertyValidator("sql", cdk.validateString)(properties.sql)), errors.wrap('supplied properties not correct for "TopicRulePayloadProperty"');
    }
    function cfnTopicRuleTopicRulePayloadPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_TopicRulePayloadPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnTopicRuleActionPropertyToCloudFormation)(properties.actions), AwsIotSqlVersion: cdk.stringToCloudFormation(properties.awsIotSqlVersion), Description: cdk.stringToCloudFormation(properties.description), ErrorAction: cfnTopicRuleActionPropertyToCloudFormation(properties.errorAction), RuleDisabled: cdk.booleanToCloudFormation(properties.ruleDisabled), Sql: cdk.stringToCloudFormation(properties.sql) }) : properties;
    }
    function CfnTopicRuleTopicRulePayloadPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", cfn_parse.FromCloudFormation.getArray(CfnTopicRuleActionPropertyFromCloudFormation)(properties.Actions)), ret.addPropertyResult("awsIotSqlVersion", "AwsIotSqlVersion", properties.AwsIotSqlVersion != null ? cfn_parse.FromCloudFormation.getString(properties.AwsIotSqlVersion) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("errorAction", "ErrorAction", properties.ErrorAction != null ? CfnTopicRuleActionPropertyFromCloudFormation(properties.ErrorAction) : void 0), ret.addPropertyResult("ruleDisabled", "RuleDisabled", properties.RuleDisabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RuleDisabled) : void 0), ret.addPropertyResult("sql", "Sql", cfn_parse.FromCloudFormation.getString(properties.Sql)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRule_UserPropertyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "UserPropertyProperty"');
    }
    function cfnTopicRuleUserPropertyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRule_UserPropertyPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnTopicRuleUserPropertyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRuleDestinationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("httpUrlProperties", CfnTopicRuleDestination_HttpUrlDestinationSummaryPropertyValidator)(properties.httpUrlProperties)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.collect(cdk.propertyValidator("vpcProperties", CfnTopicRuleDestination_VpcDestinationPropertiesPropertyValidator)(properties.vpcProperties)), errors.wrap('supplied properties not correct for "CfnTopicRuleDestinationProps"');
    }
    function cfnTopicRuleDestinationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRuleDestinationPropsValidator(properties).assertSuccess(), { HttpUrlProperties: cfnTopicRuleDestinationHttpUrlDestinationSummaryPropertyToCloudFormation(properties.httpUrlProperties), Status: cdk.stringToCloudFormation(properties.status), VpcProperties: cfnTopicRuleDestinationVpcDestinationPropertiesPropertyToCloudFormation(properties.vpcProperties) }) : properties;
    }
    function CfnTopicRuleDestinationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("httpUrlProperties", "HttpUrlProperties", properties.HttpUrlProperties != null ? CfnTopicRuleDestinationHttpUrlDestinationSummaryPropertyFromCloudFormation(properties.HttpUrlProperties) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addPropertyResult("vpcProperties", "VpcProperties", properties.VpcProperties != null ? CfnTopicRuleDestinationVpcDestinationPropertiesPropertyFromCloudFormation(properties.VpcProperties) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTopicRuleDestination = class _CfnTopicRuleDestination extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTopicRuleDestinationPropsFromCloudFormation(resourceProperties), ret = new _CfnTopicRuleDestination(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnTopicRuleDestination.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iot_CfnTopicRuleDestinationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTopicRuleDestination), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrStatusReason = cdk.Token.asString(this.getAtt("StatusReason", cdk.ResolutionTypeHint.STRING)), this.httpUrlProperties = props.httpUrlProperties, this.status = props.status, this.vpcProperties = props.vpcProperties;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTopicRuleDestination.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { httpUrlProperties: this.httpUrlProperties, status: this.status, vpcProperties: this.vpcProperties };
      }
      renderProperties(props) {
        return cfnTopicRuleDestinationPropsToCloudFormation(props);
      }
    };
    _0 = JSII_RTTI_SYMBOL_1, CfnTopicRuleDestination[_0] = { fqn: "aws-cdk-lib.aws_iot.CfnTopicRuleDestination", version: "2.80.0" }, CfnTopicRuleDestination.CFN_RESOURCE_TYPE_NAME = "AWS::IoT::TopicRuleDestination", exports2.CfnTopicRuleDestination = CfnTopicRuleDestination;
    function CfnTopicRuleDestination_HttpUrlDestinationSummaryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("confirmationUrl", cdk.validateString)(properties.confirmationUrl)), errors.wrap('supplied properties not correct for "HttpUrlDestinationSummaryProperty"');
    }
    function cfnTopicRuleDestinationHttpUrlDestinationSummaryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRuleDestination_HttpUrlDestinationSummaryPropertyValidator(properties).assertSuccess(), { ConfirmationUrl: cdk.stringToCloudFormation(properties.confirmationUrl) }) : properties;
    }
    function CfnTopicRuleDestinationHttpUrlDestinationSummaryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("confirmationUrl", "ConfirmationUrl", properties.ConfirmationUrl != null ? cfn_parse.FromCloudFormation.getString(properties.ConfirmationUrl) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTopicRuleDestination_VpcDestinationPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("securityGroups", cdk.listValidator(cdk.validateString))(properties.securityGroups)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "VpcDestinationPropertiesProperty"');
    }
    function cfnTopicRuleDestinationVpcDestinationPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTopicRuleDestination_VpcDestinationPropertiesPropertyValidator(properties).assertSuccess(), { RoleArn: cdk.stringToCloudFormation(properties.roleArn), SecurityGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroups), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds), VpcId: cdk.stringToCloudFormation(properties.vpcId) }) : properties;
    }
    function CfnTopicRuleDestinationVpcDestinationPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addPropertyResult("securityGroups", "SecurityGroups", properties.SecurityGroups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroups) : void 0), ret.addPropertyResult("subnetIds", "SubnetIds", properties.SubnetIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds) : void 0), ret.addPropertyResult("vpcId", "VpcId", properties.VpcId != null ? cfn_parse.FromCloudFormation.getString(properties.VpcId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-iot/lib/index.js
var require_lib149 = __commonJS({
  "node_modules/aws-cdk-lib/aws-iot/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_iot_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-iot/index.js
var require_aws_iot = __commonJS({
  "node_modules/aws-cdk-lib/aws-iot/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib149(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-iot1click/lib/iot1click.generated.js
var require_iot1click_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-iot1click/lib/iot1click.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnProject = exports2.CfnPlacement = exports2.CfnDevice = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnDevicePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deviceId", cdk.requiredValidator)(properties.deviceId)), errors.collect(cdk.propertyValidator("deviceId", cdk.validateString)(properties.deviceId)), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "CfnDeviceProps"');
    }
    function cfnDevicePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDevicePropsValidator(properties).assertSuccess(), { DeviceId: cdk.stringToCloudFormation(properties.deviceId), Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnDevicePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deviceId", "DeviceId", cfn_parse.FromCloudFormation.getString(properties.DeviceId)), ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDevice = class _CfnDevice extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDevicePropsFromCloudFormation(resourceProperties), ret = new _CfnDevice(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDevice.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iot1click_CfnDeviceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDevice), error;
        }
        cdk.requireProperty(props, "deviceId", this), cdk.requireProperty(props, "enabled", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrDeviceId = cdk.Token.asString(this.getAtt("DeviceId", cdk.ResolutionTypeHint.STRING)), this.attrEnabled = this.getAtt("Enabled", cdk.ResolutionTypeHint.STRING), this.deviceId = props.deviceId, this.enabled = props.enabled;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDevice.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { deviceId: this.deviceId, enabled: this.enabled };
      }
      renderProperties(props) {
        return cfnDevicePropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnDevice[_a] = { fqn: "aws-cdk-lib.aws_iot1click.CfnDevice", version: "2.80.0" }, CfnDevice.CFN_RESOURCE_TYPE_NAME = "AWS::IoT1Click::Device", exports2.CfnDevice = CfnDevice;
    function CfnPlacementPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("associatedDevices", cdk.validateObject)(properties.associatedDevices)), errors.collect(cdk.propertyValidator("attributes", cdk.validateObject)(properties.attributes)), errors.collect(cdk.propertyValidator("placementName", cdk.validateString)(properties.placementName)), errors.collect(cdk.propertyValidator("projectName", cdk.requiredValidator)(properties.projectName)), errors.collect(cdk.propertyValidator("projectName", cdk.validateString)(properties.projectName)), errors.wrap('supplied properties not correct for "CfnPlacementProps"');
    }
    function cfnPlacementPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPlacementPropsValidator(properties).assertSuccess(), { ProjectName: cdk.stringToCloudFormation(properties.projectName), AssociatedDevices: cdk.objectToCloudFormation(properties.associatedDevices), Attributes: cdk.objectToCloudFormation(properties.attributes), PlacementName: cdk.stringToCloudFormation(properties.placementName) }) : properties;
    }
    function CfnPlacementPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("projectName", "ProjectName", cfn_parse.FromCloudFormation.getString(properties.ProjectName)), ret.addPropertyResult("associatedDevices", "AssociatedDevices", properties.AssociatedDevices != null ? cfn_parse.FromCloudFormation.getAny(properties.AssociatedDevices) : void 0), ret.addPropertyResult("attributes", "Attributes", properties.Attributes != null ? cfn_parse.FromCloudFormation.getAny(properties.Attributes) : void 0), ret.addPropertyResult("placementName", "PlacementName", properties.PlacementName != null ? cfn_parse.FromCloudFormation.getString(properties.PlacementName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPlacement = class _CfnPlacement extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPlacementPropsFromCloudFormation(resourceProperties), ret = new _CfnPlacement(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPlacement.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iot1click_CfnPlacementProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPlacement), error;
        }
        cdk.requireProperty(props, "projectName", this), this.attrPlacementName = cdk.Token.asString(this.getAtt("PlacementName", cdk.ResolutionTypeHint.STRING)), this.attrProjectName = cdk.Token.asString(this.getAtt("ProjectName", cdk.ResolutionTypeHint.STRING)), this.projectName = props.projectName, this.associatedDevices = props.associatedDevices, this.attributes = props.attributes, this.placementName = props.placementName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPlacement.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { projectName: this.projectName, associatedDevices: this.associatedDevices, attributes: this.attributes, placementName: this.placementName };
      }
      renderProperties(props) {
        return cfnPlacementPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnPlacement[_b] = { fqn: "aws-cdk-lib.aws_iot1click.CfnPlacement", version: "2.80.0" }, CfnPlacement.CFN_RESOURCE_TYPE_NAME = "AWS::IoT1Click::Placement", exports2.CfnPlacement = CfnPlacement;
    function CfnProjectPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("placementTemplate", cdk.requiredValidator)(properties.placementTemplate)), errors.collect(cdk.propertyValidator("placementTemplate", CfnProject_PlacementTemplatePropertyValidator)(properties.placementTemplate)), errors.collect(cdk.propertyValidator("projectName", cdk.validateString)(properties.projectName)), errors.wrap('supplied properties not correct for "CfnProjectProps"');
    }
    function cfnProjectPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProjectPropsValidator(properties).assertSuccess(), { PlacementTemplate: cfnProjectPlacementTemplatePropertyToCloudFormation(properties.placementTemplate), Description: cdk.stringToCloudFormation(properties.description), ProjectName: cdk.stringToCloudFormation(properties.projectName) }) : properties;
    }
    function CfnProjectPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("placementTemplate", "PlacementTemplate", CfnProjectPlacementTemplatePropertyFromCloudFormation(properties.PlacementTemplate)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("projectName", "ProjectName", properties.ProjectName != null ? cfn_parse.FromCloudFormation.getString(properties.ProjectName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnProject = class _CfnProject extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnProjectPropsFromCloudFormation(resourceProperties), ret = new _CfnProject(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnProject.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iot1click_CfnProjectProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnProject), error;
        }
        cdk.requireProperty(props, "placementTemplate", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrProjectName = cdk.Token.asString(this.getAtt("ProjectName", cdk.ResolutionTypeHint.STRING)), this.placementTemplate = props.placementTemplate, this.description = props.description, this.projectName = props.projectName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnProject.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { placementTemplate: this.placementTemplate, description: this.description, projectName: this.projectName };
      }
      renderProperties(props) {
        return cfnProjectPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnProject[_c] = { fqn: "aws-cdk-lib.aws_iot1click.CfnProject", version: "2.80.0" }, CfnProject.CFN_RESOURCE_TYPE_NAME = "AWS::IoT1Click::Project", exports2.CfnProject = CfnProject;
    function CfnProject_DeviceTemplatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("callbackOverrides", cdk.validateObject)(properties.callbackOverrides)), errors.collect(cdk.propertyValidator("deviceType", cdk.validateString)(properties.deviceType)), errors.wrap('supplied properties not correct for "DeviceTemplateProperty"');
    }
    function cfnProjectDeviceTemplatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProject_DeviceTemplatePropertyValidator(properties).assertSuccess(), { CallbackOverrides: cdk.objectToCloudFormation(properties.callbackOverrides), DeviceType: cdk.stringToCloudFormation(properties.deviceType) }) : properties;
    }
    function CfnProjectDeviceTemplatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("callbackOverrides", "CallbackOverrides", properties.CallbackOverrides != null ? cfn_parse.FromCloudFormation.getAny(properties.CallbackOverrides) : void 0), ret.addPropertyResult("deviceType", "DeviceType", properties.DeviceType != null ? cfn_parse.FromCloudFormation.getString(properties.DeviceType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnProject_PlacementTemplatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultAttributes", cdk.validateObject)(properties.defaultAttributes)), errors.collect(cdk.propertyValidator("deviceTemplates", cdk.hashValidator(CfnProject_DeviceTemplatePropertyValidator))(properties.deviceTemplates)), errors.wrap('supplied properties not correct for "PlacementTemplateProperty"');
    }
    function cfnProjectPlacementTemplatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProject_PlacementTemplatePropertyValidator(properties).assertSuccess(), { DefaultAttributes: cdk.objectToCloudFormation(properties.defaultAttributes), DeviceTemplates: cdk.hashMapper(cfnProjectDeviceTemplatePropertyToCloudFormation)(properties.deviceTemplates) }) : properties;
    }
    function CfnProjectPlacementTemplatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultAttributes", "DefaultAttributes", properties.DefaultAttributes != null ? cfn_parse.FromCloudFormation.getAny(properties.DefaultAttributes) : void 0), ret.addPropertyResult("deviceTemplates", "DeviceTemplates", properties.DeviceTemplates != null ? cfn_parse.FromCloudFormation.getMap(CfnProjectDeviceTemplatePropertyFromCloudFormation)(properties.DeviceTemplates) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-iot1click/lib/index.js
var require_lib150 = __commonJS({
  "node_modules/aws-cdk-lib/aws-iot1click/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_iot1click_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-iot1click/index.js
var require_aws_iot1click = __commonJS({
  "node_modules/aws-cdk-lib/aws-iot1click/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib150(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-iotanalytics/lib/iotanalytics.generated.js
var require_iotanalytics_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-iotanalytics/lib/iotanalytics.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnPipeline = exports2.CfnDatastore = exports2.CfnDataset = exports2.CfnChannel = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnChannelPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("channelName", cdk.validateString)(properties.channelName)), errors.collect(cdk.propertyValidator("channelStorage", CfnChannel_ChannelStoragePropertyValidator)(properties.channelStorage)), errors.collect(cdk.propertyValidator("retentionPeriod", CfnChannel_RetentionPeriodPropertyValidator)(properties.retentionPeriod)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnChannelProps"');
    }
    function cfnChannelPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannelPropsValidator(properties).assertSuccess(), { ChannelName: cdk.stringToCloudFormation(properties.channelName), ChannelStorage: cfnChannelChannelStoragePropertyToCloudFormation(properties.channelStorage), RetentionPeriod: cfnChannelRetentionPeriodPropertyToCloudFormation(properties.retentionPeriod), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnChannelPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("channelName", "ChannelName", properties.ChannelName != null ? cfn_parse.FromCloudFormation.getString(properties.ChannelName) : void 0), ret.addPropertyResult("channelStorage", "ChannelStorage", properties.ChannelStorage != null ? CfnChannelChannelStoragePropertyFromCloudFormation(properties.ChannelStorage) : void 0), ret.addPropertyResult("retentionPeriod", "RetentionPeriod", properties.RetentionPeriod != null ? CfnChannelRetentionPeriodPropertyFromCloudFormation(properties.RetentionPeriod) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnChannel = class _CfnChannel extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnChannelPropsFromCloudFormation(resourceProperties), ret = new _CfnChannel(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnChannel.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotanalytics_CfnChannelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnChannel), error;
        }
        this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.channelName = props.channelName, this.channelStorage = props.channelStorage, this.retentionPeriod = props.retentionPeriod, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTAnalytics::Channel", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnChannel.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { channelName: this.channelName, channelStorage: this.channelStorage, retentionPeriod: this.retentionPeriod, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnChannelPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnChannel[_a] = { fqn: "aws-cdk-lib.aws_iotanalytics.CfnChannel", version: "2.80.0" }, CfnChannel.CFN_RESOURCE_TYPE_NAME = "AWS::IoTAnalytics::Channel", exports2.CfnChannel = CfnChannel;
    function CfnChannel_ChannelStoragePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customerManagedS3", CfnChannel_CustomerManagedS3PropertyValidator)(properties.customerManagedS3)), errors.collect(cdk.propertyValidator("serviceManagedS3", cdk.validateObject)(properties.serviceManagedS3)), errors.wrap('supplied properties not correct for "ChannelStorageProperty"');
    }
    function cfnChannelChannelStoragePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_ChannelStoragePropertyValidator(properties).assertSuccess(), { CustomerManagedS3: cfnChannelCustomerManagedS3PropertyToCloudFormation(properties.customerManagedS3), ServiceManagedS3: cdk.objectToCloudFormation(properties.serviceManagedS3) }) : properties;
    }
    function CfnChannelChannelStoragePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customerManagedS3", "CustomerManagedS3", properties.CustomerManagedS3 != null ? CfnChannelCustomerManagedS3PropertyFromCloudFormation(properties.CustomerManagedS3) : void 0), ret.addPropertyResult("serviceManagedS3", "ServiceManagedS3", properties.ServiceManagedS3 != null ? cfn_parse.FromCloudFormation.getAny(properties.ServiceManagedS3) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_CustomerManagedS3PropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.requiredValidator)(properties.bucket)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("keyPrefix", cdk.validateString)(properties.keyPrefix)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "CustomerManagedS3Property"');
    }
    function cfnChannelCustomerManagedS3PropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_CustomerManagedS3PropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), KeyPrefix: cdk.stringToCloudFormation(properties.keyPrefix), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnChannelCustomerManagedS3PropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", cfn_parse.FromCloudFormation.getString(properties.Bucket)), ret.addPropertyResult("keyPrefix", "KeyPrefix", properties.KeyPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.KeyPrefix) : void 0), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_RetentionPeriodPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("numberOfDays", cdk.validateNumber)(properties.numberOfDays)), errors.collect(cdk.propertyValidator("unlimited", cdk.validateBoolean)(properties.unlimited)), errors.wrap('supplied properties not correct for "RetentionPeriodProperty"');
    }
    function cfnChannelRetentionPeriodPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_RetentionPeriodPropertyValidator(properties).assertSuccess(), { NumberOfDays: cdk.numberToCloudFormation(properties.numberOfDays), Unlimited: cdk.booleanToCloudFormation(properties.unlimited) }) : properties;
    }
    function CfnChannelRetentionPeriodPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("numberOfDays", "NumberOfDays", properties.NumberOfDays != null ? cfn_parse.FromCloudFormation.getNumber(properties.NumberOfDays) : void 0), ret.addPropertyResult("unlimited", "Unlimited", properties.Unlimited != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Unlimited) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDatasetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.requiredValidator)(properties.actions)), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnDataset_ActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("contentDeliveryRules", cdk.listValidator(CfnDataset_DatasetContentDeliveryRulePropertyValidator))(properties.contentDeliveryRules)), errors.collect(cdk.propertyValidator("datasetName", cdk.validateString)(properties.datasetName)), errors.collect(cdk.propertyValidator("lateDataRules", cdk.listValidator(CfnDataset_LateDataRulePropertyValidator))(properties.lateDataRules)), errors.collect(cdk.propertyValidator("retentionPeriod", CfnDataset_RetentionPeriodPropertyValidator)(properties.retentionPeriod)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("triggers", cdk.listValidator(CfnDataset_TriggerPropertyValidator))(properties.triggers)), errors.collect(cdk.propertyValidator("versioningConfiguration", CfnDataset_VersioningConfigurationPropertyValidator)(properties.versioningConfiguration)), errors.wrap('supplied properties not correct for "CfnDatasetProps"');
    }
    function cfnDatasetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDatasetPropsValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnDatasetActionPropertyToCloudFormation)(properties.actions), ContentDeliveryRules: cdk.listMapper(cfnDatasetDatasetContentDeliveryRulePropertyToCloudFormation)(properties.contentDeliveryRules), DatasetName: cdk.stringToCloudFormation(properties.datasetName), LateDataRules: cdk.listMapper(cfnDatasetLateDataRulePropertyToCloudFormation)(properties.lateDataRules), RetentionPeriod: cfnDatasetRetentionPeriodPropertyToCloudFormation(properties.retentionPeriod), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), Triggers: cdk.listMapper(cfnDatasetTriggerPropertyToCloudFormation)(properties.triggers), VersioningConfiguration: cfnDatasetVersioningConfigurationPropertyToCloudFormation(properties.versioningConfiguration) }) : properties;
    }
    function CfnDatasetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", cfn_parse.FromCloudFormation.getArray(CfnDatasetActionPropertyFromCloudFormation)(properties.Actions)), ret.addPropertyResult("contentDeliveryRules", "ContentDeliveryRules", properties.ContentDeliveryRules != null ? cfn_parse.FromCloudFormation.getArray(CfnDatasetDatasetContentDeliveryRulePropertyFromCloudFormation)(properties.ContentDeliveryRules) : void 0), ret.addPropertyResult("datasetName", "DatasetName", properties.DatasetName != null ? cfn_parse.FromCloudFormation.getString(properties.DatasetName) : void 0), ret.addPropertyResult("lateDataRules", "LateDataRules", properties.LateDataRules != null ? cfn_parse.FromCloudFormation.getArray(CfnDatasetLateDataRulePropertyFromCloudFormation)(properties.LateDataRules) : void 0), ret.addPropertyResult("retentionPeriod", "RetentionPeriod", properties.RetentionPeriod != null ? CfnDatasetRetentionPeriodPropertyFromCloudFormation(properties.RetentionPeriod) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("triggers", "Triggers", properties.Triggers != null ? cfn_parse.FromCloudFormation.getArray(CfnDatasetTriggerPropertyFromCloudFormation)(properties.Triggers) : void 0), ret.addPropertyResult("versioningConfiguration", "VersioningConfiguration", properties.VersioningConfiguration != null ? CfnDatasetVersioningConfigurationPropertyFromCloudFormation(properties.VersioningConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDataset = class _CfnDataset extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDatasetPropsFromCloudFormation(resourceProperties), ret = new _CfnDataset(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDataset.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotanalytics_CfnDatasetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDataset), error;
        }
        cdk.requireProperty(props, "actions", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.actions = props.actions, this.contentDeliveryRules = props.contentDeliveryRules, this.datasetName = props.datasetName, this.lateDataRules = props.lateDataRules, this.retentionPeriod = props.retentionPeriod, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTAnalytics::Dataset", props.tags, { tagPropertyName: "tags" }), this.triggers = props.triggers, this.versioningConfiguration = props.versioningConfiguration;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDataset.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { actions: this.actions, contentDeliveryRules: this.contentDeliveryRules, datasetName: this.datasetName, lateDataRules: this.lateDataRules, retentionPeriod: this.retentionPeriod, tags: this.tags.renderTags(), triggers: this.triggers, versioningConfiguration: this.versioningConfiguration };
      }
      renderProperties(props) {
        return cfnDatasetPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnDataset[_b] = { fqn: "aws-cdk-lib.aws_iotanalytics.CfnDataset", version: "2.80.0" }, CfnDataset.CFN_RESOURCE_TYPE_NAME = "AWS::IoTAnalytics::Dataset", exports2.CfnDataset = CfnDataset;
    function CfnDataset_ActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actionName", cdk.requiredValidator)(properties.actionName)), errors.collect(cdk.propertyValidator("actionName", cdk.validateString)(properties.actionName)), errors.collect(cdk.propertyValidator("containerAction", CfnDataset_ContainerActionPropertyValidator)(properties.containerAction)), errors.collect(cdk.propertyValidator("queryAction", CfnDataset_QueryActionPropertyValidator)(properties.queryAction)), errors.wrap('supplied properties not correct for "ActionProperty"');
    }
    function cfnDatasetActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_ActionPropertyValidator(properties).assertSuccess(), { ActionName: cdk.stringToCloudFormation(properties.actionName), ContainerAction: cfnDatasetContainerActionPropertyToCloudFormation(properties.containerAction), QueryAction: cfnDatasetQueryActionPropertyToCloudFormation(properties.queryAction) }) : properties;
    }
    function CfnDatasetActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actionName", "ActionName", cfn_parse.FromCloudFormation.getString(properties.ActionName)), ret.addPropertyResult("containerAction", "ContainerAction", properties.ContainerAction != null ? CfnDatasetContainerActionPropertyFromCloudFormation(properties.ContainerAction) : void 0), ret.addPropertyResult("queryAction", "QueryAction", properties.QueryAction != null ? CfnDatasetQueryActionPropertyFromCloudFormation(properties.QueryAction) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_ContainerActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("executionRoleArn", cdk.requiredValidator)(properties.executionRoleArn)), errors.collect(cdk.propertyValidator("executionRoleArn", cdk.validateString)(properties.executionRoleArn)), errors.collect(cdk.propertyValidator("image", cdk.requiredValidator)(properties.image)), errors.collect(cdk.propertyValidator("image", cdk.validateString)(properties.image)), errors.collect(cdk.propertyValidator("resourceConfiguration", cdk.requiredValidator)(properties.resourceConfiguration)), errors.collect(cdk.propertyValidator("resourceConfiguration", CfnDataset_ResourceConfigurationPropertyValidator)(properties.resourceConfiguration)), errors.collect(cdk.propertyValidator("variables", cdk.listValidator(CfnDataset_VariablePropertyValidator))(properties.variables)), errors.wrap('supplied properties not correct for "ContainerActionProperty"');
    }
    function cfnDatasetContainerActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_ContainerActionPropertyValidator(properties).assertSuccess(), { ExecutionRoleArn: cdk.stringToCloudFormation(properties.executionRoleArn), Image: cdk.stringToCloudFormation(properties.image), ResourceConfiguration: cfnDatasetResourceConfigurationPropertyToCloudFormation(properties.resourceConfiguration), Variables: cdk.listMapper(cfnDatasetVariablePropertyToCloudFormation)(properties.variables) }) : properties;
    }
    function CfnDatasetContainerActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("executionRoleArn", "ExecutionRoleArn", cfn_parse.FromCloudFormation.getString(properties.ExecutionRoleArn)), ret.addPropertyResult("image", "Image", cfn_parse.FromCloudFormation.getString(properties.Image)), ret.addPropertyResult("resourceConfiguration", "ResourceConfiguration", CfnDatasetResourceConfigurationPropertyFromCloudFormation(properties.ResourceConfiguration)), ret.addPropertyResult("variables", "Variables", properties.Variables != null ? cfn_parse.FromCloudFormation.getArray(CfnDatasetVariablePropertyFromCloudFormation)(properties.Variables) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_DatasetContentDeliveryRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destination", cdk.requiredValidator)(properties.destination)), errors.collect(cdk.propertyValidator("destination", CfnDataset_DatasetContentDeliveryRuleDestinationPropertyValidator)(properties.destination)), errors.collect(cdk.propertyValidator("entryName", cdk.validateString)(properties.entryName)), errors.wrap('supplied properties not correct for "DatasetContentDeliveryRuleProperty"');
    }
    function cfnDatasetDatasetContentDeliveryRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_DatasetContentDeliveryRulePropertyValidator(properties).assertSuccess(), { Destination: cfnDatasetDatasetContentDeliveryRuleDestinationPropertyToCloudFormation(properties.destination), EntryName: cdk.stringToCloudFormation(properties.entryName) }) : properties;
    }
    function CfnDatasetDatasetContentDeliveryRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destination", "Destination", CfnDatasetDatasetContentDeliveryRuleDestinationPropertyFromCloudFormation(properties.Destination)), ret.addPropertyResult("entryName", "EntryName", properties.EntryName != null ? cfn_parse.FromCloudFormation.getString(properties.EntryName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_DatasetContentDeliveryRuleDestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("iotEventsDestinationConfiguration", CfnDataset_IotEventsDestinationConfigurationPropertyValidator)(properties.iotEventsDestinationConfiguration)), errors.collect(cdk.propertyValidator("s3DestinationConfiguration", CfnDataset_S3DestinationConfigurationPropertyValidator)(properties.s3DestinationConfiguration)), errors.wrap('supplied properties not correct for "DatasetContentDeliveryRuleDestinationProperty"');
    }
    function cfnDatasetDatasetContentDeliveryRuleDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_DatasetContentDeliveryRuleDestinationPropertyValidator(properties).assertSuccess(), { IotEventsDestinationConfiguration: cfnDatasetIotEventsDestinationConfigurationPropertyToCloudFormation(properties.iotEventsDestinationConfiguration), S3DestinationConfiguration: cfnDatasetS3DestinationConfigurationPropertyToCloudFormation(properties.s3DestinationConfiguration) }) : properties;
    }
    function CfnDatasetDatasetContentDeliveryRuleDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("iotEventsDestinationConfiguration", "IotEventsDestinationConfiguration", properties.IotEventsDestinationConfiguration != null ? CfnDatasetIotEventsDestinationConfigurationPropertyFromCloudFormation(properties.IotEventsDestinationConfiguration) : void 0), ret.addPropertyResult("s3DestinationConfiguration", "S3DestinationConfiguration", properties.S3DestinationConfiguration != null ? CfnDatasetS3DestinationConfigurationPropertyFromCloudFormation(properties.S3DestinationConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_DatasetContentVersionValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("datasetName", cdk.requiredValidator)(properties.datasetName)), errors.collect(cdk.propertyValidator("datasetName", cdk.validateString)(properties.datasetName)), errors.wrap('supplied properties not correct for "DatasetContentVersionValueProperty"');
    }
    function cfnDatasetDatasetContentVersionValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_DatasetContentVersionValuePropertyValidator(properties).assertSuccess(), { DatasetName: cdk.stringToCloudFormation(properties.datasetName) }) : properties;
    }
    function CfnDatasetDatasetContentVersionValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("datasetName", "DatasetName", cfn_parse.FromCloudFormation.getString(properties.DatasetName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_DeltaTimePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("offsetSeconds", cdk.requiredValidator)(properties.offsetSeconds)), errors.collect(cdk.propertyValidator("offsetSeconds", cdk.validateNumber)(properties.offsetSeconds)), errors.collect(cdk.propertyValidator("timeExpression", cdk.requiredValidator)(properties.timeExpression)), errors.collect(cdk.propertyValidator("timeExpression", cdk.validateString)(properties.timeExpression)), errors.wrap('supplied properties not correct for "DeltaTimeProperty"');
    }
    function cfnDatasetDeltaTimePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_DeltaTimePropertyValidator(properties).assertSuccess(), { OffsetSeconds: cdk.numberToCloudFormation(properties.offsetSeconds), TimeExpression: cdk.stringToCloudFormation(properties.timeExpression) }) : properties;
    }
    function CfnDatasetDeltaTimePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("offsetSeconds", "OffsetSeconds", cfn_parse.FromCloudFormation.getNumber(properties.OffsetSeconds)), ret.addPropertyResult("timeExpression", "TimeExpression", cfn_parse.FromCloudFormation.getString(properties.TimeExpression)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_DeltaTimeSessionWindowConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("timeoutInMinutes", cdk.requiredValidator)(properties.timeoutInMinutes)), errors.collect(cdk.propertyValidator("timeoutInMinutes", cdk.validateNumber)(properties.timeoutInMinutes)), errors.wrap('supplied properties not correct for "DeltaTimeSessionWindowConfigurationProperty"');
    }
    function cfnDatasetDeltaTimeSessionWindowConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_DeltaTimeSessionWindowConfigurationPropertyValidator(properties).assertSuccess(), { TimeoutInMinutes: cdk.numberToCloudFormation(properties.timeoutInMinutes) }) : properties;
    }
    function CfnDatasetDeltaTimeSessionWindowConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("timeoutInMinutes", "TimeoutInMinutes", cfn_parse.FromCloudFormation.getNumber(properties.TimeoutInMinutes)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_FilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deltaTime", CfnDataset_DeltaTimePropertyValidator)(properties.deltaTime)), errors.wrap('supplied properties not correct for "FilterProperty"');
    }
    function cfnDatasetFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_FilterPropertyValidator(properties).assertSuccess(), { DeltaTime: cfnDatasetDeltaTimePropertyToCloudFormation(properties.deltaTime) }) : properties;
    }
    function CfnDatasetFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deltaTime", "DeltaTime", properties.DeltaTime != null ? CfnDatasetDeltaTimePropertyFromCloudFormation(properties.DeltaTime) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_GlueConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("databaseName", cdk.requiredValidator)(properties.databaseName)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("tableName", cdk.requiredValidator)(properties.tableName)), errors.collect(cdk.propertyValidator("tableName", cdk.validateString)(properties.tableName)), errors.wrap('supplied properties not correct for "GlueConfigurationProperty"');
    }
    function cfnDatasetGlueConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_GlueConfigurationPropertyValidator(properties).assertSuccess(), { DatabaseName: cdk.stringToCloudFormation(properties.databaseName), TableName: cdk.stringToCloudFormation(properties.tableName) }) : properties;
    }
    function CfnDatasetGlueConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("databaseName", "DatabaseName", cfn_parse.FromCloudFormation.getString(properties.DatabaseName)), ret.addPropertyResult("tableName", "TableName", cfn_parse.FromCloudFormation.getString(properties.TableName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_IotEventsDestinationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("inputName", cdk.requiredValidator)(properties.inputName)), errors.collect(cdk.propertyValidator("inputName", cdk.validateString)(properties.inputName)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "IotEventsDestinationConfigurationProperty"');
    }
    function cfnDatasetIotEventsDestinationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_IotEventsDestinationConfigurationPropertyValidator(properties).assertSuccess(), { InputName: cdk.stringToCloudFormation(properties.inputName), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnDatasetIotEventsDestinationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("inputName", "InputName", cfn_parse.FromCloudFormation.getString(properties.InputName)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_LateDataRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ruleConfiguration", cdk.requiredValidator)(properties.ruleConfiguration)), errors.collect(cdk.propertyValidator("ruleConfiguration", CfnDataset_LateDataRuleConfigurationPropertyValidator)(properties.ruleConfiguration)), errors.collect(cdk.propertyValidator("ruleName", cdk.validateString)(properties.ruleName)), errors.wrap('supplied properties not correct for "LateDataRuleProperty"');
    }
    function cfnDatasetLateDataRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_LateDataRulePropertyValidator(properties).assertSuccess(), { RuleConfiguration: cfnDatasetLateDataRuleConfigurationPropertyToCloudFormation(properties.ruleConfiguration), RuleName: cdk.stringToCloudFormation(properties.ruleName) }) : properties;
    }
    function CfnDatasetLateDataRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ruleConfiguration", "RuleConfiguration", CfnDatasetLateDataRuleConfigurationPropertyFromCloudFormation(properties.RuleConfiguration)), ret.addPropertyResult("ruleName", "RuleName", properties.RuleName != null ? cfn_parse.FromCloudFormation.getString(properties.RuleName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_LateDataRuleConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deltaTimeSessionWindowConfiguration", CfnDataset_DeltaTimeSessionWindowConfigurationPropertyValidator)(properties.deltaTimeSessionWindowConfiguration)), errors.wrap('supplied properties not correct for "LateDataRuleConfigurationProperty"');
    }
    function cfnDatasetLateDataRuleConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_LateDataRuleConfigurationPropertyValidator(properties).assertSuccess(), { DeltaTimeSessionWindowConfiguration: cfnDatasetDeltaTimeSessionWindowConfigurationPropertyToCloudFormation(properties.deltaTimeSessionWindowConfiguration) }) : properties;
    }
    function CfnDatasetLateDataRuleConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deltaTimeSessionWindowConfiguration", "DeltaTimeSessionWindowConfiguration", properties.DeltaTimeSessionWindowConfiguration != null ? CfnDatasetDeltaTimeSessionWindowConfigurationPropertyFromCloudFormation(properties.DeltaTimeSessionWindowConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_OutputFileUriValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fileName", cdk.requiredValidator)(properties.fileName)), errors.collect(cdk.propertyValidator("fileName", cdk.validateString)(properties.fileName)), errors.wrap('supplied properties not correct for "OutputFileUriValueProperty"');
    }
    function cfnDatasetOutputFileUriValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_OutputFileUriValuePropertyValidator(properties).assertSuccess(), { FileName: cdk.stringToCloudFormation(properties.fileName) }) : properties;
    }
    function CfnDatasetOutputFileUriValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fileName", "FileName", cfn_parse.FromCloudFormation.getString(properties.FileName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_QueryActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("filters", cdk.listValidator(CfnDataset_FilterPropertyValidator))(properties.filters)), errors.collect(cdk.propertyValidator("sqlQuery", cdk.requiredValidator)(properties.sqlQuery)), errors.collect(cdk.propertyValidator("sqlQuery", cdk.validateString)(properties.sqlQuery)), errors.wrap('supplied properties not correct for "QueryActionProperty"');
    }
    function cfnDatasetQueryActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_QueryActionPropertyValidator(properties).assertSuccess(), { Filters: cdk.listMapper(cfnDatasetFilterPropertyToCloudFormation)(properties.filters), SqlQuery: cdk.stringToCloudFormation(properties.sqlQuery) }) : properties;
    }
    function CfnDatasetQueryActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("filters", "Filters", properties.Filters != null ? cfn_parse.FromCloudFormation.getArray(CfnDatasetFilterPropertyFromCloudFormation)(properties.Filters) : void 0), ret.addPropertyResult("sqlQuery", "SqlQuery", cfn_parse.FromCloudFormation.getString(properties.SqlQuery)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_ResourceConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computeType", cdk.requiredValidator)(properties.computeType)), errors.collect(cdk.propertyValidator("computeType", cdk.validateString)(properties.computeType)), errors.collect(cdk.propertyValidator("volumeSizeInGb", cdk.requiredValidator)(properties.volumeSizeInGb)), errors.collect(cdk.propertyValidator("volumeSizeInGb", cdk.validateNumber)(properties.volumeSizeInGb)), errors.wrap('supplied properties not correct for "ResourceConfigurationProperty"');
    }
    function cfnDatasetResourceConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_ResourceConfigurationPropertyValidator(properties).assertSuccess(), { ComputeType: cdk.stringToCloudFormation(properties.computeType), VolumeSizeInGB: cdk.numberToCloudFormation(properties.volumeSizeInGb) }) : properties;
    }
    function CfnDatasetResourceConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computeType", "ComputeType", cfn_parse.FromCloudFormation.getString(properties.ComputeType)), ret.addPropertyResult("volumeSizeInGb", "VolumeSizeInGB", cfn_parse.FromCloudFormation.getNumber(properties.VolumeSizeInGB)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_RetentionPeriodPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("numberOfDays", cdk.validateNumber)(properties.numberOfDays)), errors.collect(cdk.propertyValidator("unlimited", cdk.validateBoolean)(properties.unlimited)), errors.wrap('supplied properties not correct for "RetentionPeriodProperty"');
    }
    function cfnDatasetRetentionPeriodPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_RetentionPeriodPropertyValidator(properties).assertSuccess(), { NumberOfDays: cdk.numberToCloudFormation(properties.numberOfDays), Unlimited: cdk.booleanToCloudFormation(properties.unlimited) }) : properties;
    }
    function CfnDatasetRetentionPeriodPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("numberOfDays", "NumberOfDays", properties.NumberOfDays != null ? cfn_parse.FromCloudFormation.getNumber(properties.NumberOfDays) : void 0), ret.addPropertyResult("unlimited", "Unlimited", properties.Unlimited != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Unlimited) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_S3DestinationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.requiredValidator)(properties.bucket)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("glueConfiguration", CfnDataset_GlueConfigurationPropertyValidator)(properties.glueConfiguration)), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "S3DestinationConfigurationProperty"');
    }
    function cfnDatasetS3DestinationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_S3DestinationConfigurationPropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), GlueConfiguration: cfnDatasetGlueConfigurationPropertyToCloudFormation(properties.glueConfiguration), Key: cdk.stringToCloudFormation(properties.key), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnDatasetS3DestinationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", cfn_parse.FromCloudFormation.getString(properties.Bucket)), ret.addPropertyResult("glueConfiguration", "GlueConfiguration", properties.GlueConfiguration != null ? CfnDatasetGlueConfigurationPropertyFromCloudFormation(properties.GlueConfiguration) : void 0), ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_SchedulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("scheduleExpression", cdk.requiredValidator)(properties.scheduleExpression)), errors.collect(cdk.propertyValidator("scheduleExpression", cdk.validateString)(properties.scheduleExpression)), errors.wrap('supplied properties not correct for "ScheduleProperty"');
    }
    function cfnDatasetSchedulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_SchedulePropertyValidator(properties).assertSuccess(), { ScheduleExpression: cdk.stringToCloudFormation(properties.scheduleExpression) }) : properties;
    }
    function CfnDatasetSchedulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("scheduleExpression", "ScheduleExpression", cfn_parse.FromCloudFormation.getString(properties.ScheduleExpression)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_TriggerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("schedule", CfnDataset_SchedulePropertyValidator)(properties.schedule)), errors.collect(cdk.propertyValidator("triggeringDataset", CfnDataset_TriggeringDatasetPropertyValidator)(properties.triggeringDataset)), errors.wrap('supplied properties not correct for "TriggerProperty"');
    }
    function cfnDatasetTriggerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_TriggerPropertyValidator(properties).assertSuccess(), { Schedule: cfnDatasetSchedulePropertyToCloudFormation(properties.schedule), TriggeringDataset: cfnDatasetTriggeringDatasetPropertyToCloudFormation(properties.triggeringDataset) }) : properties;
    }
    function CfnDatasetTriggerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("schedule", "Schedule", properties.Schedule != null ? CfnDatasetSchedulePropertyFromCloudFormation(properties.Schedule) : void 0), ret.addPropertyResult("triggeringDataset", "TriggeringDataset", properties.TriggeringDataset != null ? CfnDatasetTriggeringDatasetPropertyFromCloudFormation(properties.TriggeringDataset) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_TriggeringDatasetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("datasetName", cdk.requiredValidator)(properties.datasetName)), errors.collect(cdk.propertyValidator("datasetName", cdk.validateString)(properties.datasetName)), errors.wrap('supplied properties not correct for "TriggeringDatasetProperty"');
    }
    function cfnDatasetTriggeringDatasetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_TriggeringDatasetPropertyValidator(properties).assertSuccess(), { DatasetName: cdk.stringToCloudFormation(properties.datasetName) }) : properties;
    }
    function CfnDatasetTriggeringDatasetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("datasetName", "DatasetName", cfn_parse.FromCloudFormation.getString(properties.DatasetName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_VariablePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("datasetContentVersionValue", CfnDataset_DatasetContentVersionValuePropertyValidator)(properties.datasetContentVersionValue)), errors.collect(cdk.propertyValidator("doubleValue", cdk.validateNumber)(properties.doubleValue)), errors.collect(cdk.propertyValidator("outputFileUriValue", CfnDataset_OutputFileUriValuePropertyValidator)(properties.outputFileUriValue)), errors.collect(cdk.propertyValidator("stringValue", cdk.validateString)(properties.stringValue)), errors.collect(cdk.propertyValidator("variableName", cdk.requiredValidator)(properties.variableName)), errors.collect(cdk.propertyValidator("variableName", cdk.validateString)(properties.variableName)), errors.wrap('supplied properties not correct for "VariableProperty"');
    }
    function cfnDatasetVariablePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_VariablePropertyValidator(properties).assertSuccess(), { DatasetContentVersionValue: cfnDatasetDatasetContentVersionValuePropertyToCloudFormation(properties.datasetContentVersionValue), DoubleValue: cdk.numberToCloudFormation(properties.doubleValue), OutputFileUriValue: cfnDatasetOutputFileUriValuePropertyToCloudFormation(properties.outputFileUriValue), StringValue: cdk.stringToCloudFormation(properties.stringValue), VariableName: cdk.stringToCloudFormation(properties.variableName) }) : properties;
    }
    function CfnDatasetVariablePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("datasetContentVersionValue", "DatasetContentVersionValue", properties.DatasetContentVersionValue != null ? CfnDatasetDatasetContentVersionValuePropertyFromCloudFormation(properties.DatasetContentVersionValue) : void 0), ret.addPropertyResult("doubleValue", "DoubleValue", properties.DoubleValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.DoubleValue) : void 0), ret.addPropertyResult("outputFileUriValue", "OutputFileUriValue", properties.OutputFileUriValue != null ? CfnDatasetOutputFileUriValuePropertyFromCloudFormation(properties.OutputFileUriValue) : void 0), ret.addPropertyResult("stringValue", "StringValue", properties.StringValue != null ? cfn_parse.FromCloudFormation.getString(properties.StringValue) : void 0), ret.addPropertyResult("variableName", "VariableName", cfn_parse.FromCloudFormation.getString(properties.VariableName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataset_VersioningConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxVersions", cdk.validateNumber)(properties.maxVersions)), errors.collect(cdk.propertyValidator("unlimited", cdk.validateBoolean)(properties.unlimited)), errors.wrap('supplied properties not correct for "VersioningConfigurationProperty"');
    }
    function cfnDatasetVersioningConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_VersioningConfigurationPropertyValidator(properties).assertSuccess(), { MaxVersions: cdk.numberToCloudFormation(properties.maxVersions), Unlimited: cdk.booleanToCloudFormation(properties.unlimited) }) : properties;
    }
    function CfnDatasetVersioningConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxVersions", "MaxVersions", properties.MaxVersions != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxVersions) : void 0), ret.addPropertyResult("unlimited", "Unlimited", properties.Unlimited != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Unlimited) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDatastorePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("datastoreName", cdk.validateString)(properties.datastoreName)), errors.collect(cdk.propertyValidator("datastorePartitions", CfnDatastore_DatastorePartitionsPropertyValidator)(properties.datastorePartitions)), errors.collect(cdk.propertyValidator("datastoreStorage", CfnDatastore_DatastoreStoragePropertyValidator)(properties.datastoreStorage)), errors.collect(cdk.propertyValidator("fileFormatConfiguration", CfnDatastore_FileFormatConfigurationPropertyValidator)(properties.fileFormatConfiguration)), errors.collect(cdk.propertyValidator("retentionPeriod", CfnDatastore_RetentionPeriodPropertyValidator)(properties.retentionPeriod)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDatastoreProps"');
    }
    function cfnDatastorePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDatastorePropsValidator(properties).assertSuccess(), { DatastoreName: cdk.stringToCloudFormation(properties.datastoreName), DatastorePartitions: cfnDatastoreDatastorePartitionsPropertyToCloudFormation(properties.datastorePartitions), DatastoreStorage: cfnDatastoreDatastoreStoragePropertyToCloudFormation(properties.datastoreStorage), FileFormatConfiguration: cfnDatastoreFileFormatConfigurationPropertyToCloudFormation(properties.fileFormatConfiguration), RetentionPeriod: cfnDatastoreRetentionPeriodPropertyToCloudFormation(properties.retentionPeriod), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDatastorePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("datastoreName", "DatastoreName", properties.DatastoreName != null ? cfn_parse.FromCloudFormation.getString(properties.DatastoreName) : void 0), ret.addPropertyResult("datastorePartitions", "DatastorePartitions", properties.DatastorePartitions != null ? CfnDatastoreDatastorePartitionsPropertyFromCloudFormation(properties.DatastorePartitions) : void 0), ret.addPropertyResult("datastoreStorage", "DatastoreStorage", properties.DatastoreStorage != null ? CfnDatastoreDatastoreStoragePropertyFromCloudFormation(properties.DatastoreStorage) : void 0), ret.addPropertyResult("fileFormatConfiguration", "FileFormatConfiguration", properties.FileFormatConfiguration != null ? CfnDatastoreFileFormatConfigurationPropertyFromCloudFormation(properties.FileFormatConfiguration) : void 0), ret.addPropertyResult("retentionPeriod", "RetentionPeriod", properties.RetentionPeriod != null ? CfnDatastoreRetentionPeriodPropertyFromCloudFormation(properties.RetentionPeriod) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDatastore = class _CfnDatastore extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDatastorePropsFromCloudFormation(resourceProperties), ret = new _CfnDatastore(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnDatastore.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotanalytics_CfnDatastoreProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDatastore), error;
        }
        this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.datastoreName = props.datastoreName, this.datastorePartitions = props.datastorePartitions, this.datastoreStorage = props.datastoreStorage, this.fileFormatConfiguration = props.fileFormatConfiguration, this.retentionPeriod = props.retentionPeriod, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTAnalytics::Datastore", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDatastore.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { datastoreName: this.datastoreName, datastorePartitions: this.datastorePartitions, datastoreStorage: this.datastoreStorage, fileFormatConfiguration: this.fileFormatConfiguration, retentionPeriod: this.retentionPeriod, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDatastorePropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnDatastore[_c] = { fqn: "aws-cdk-lib.aws_iotanalytics.CfnDatastore", version: "2.80.0" }, CfnDatastore.CFN_RESOURCE_TYPE_NAME = "AWS::IoTAnalytics::Datastore", exports2.CfnDatastore = CfnDatastore;
    function CfnDatastore_ColumnPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "ColumnProperty"');
    }
    function cfnDatastoreColumnPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDatastore_ColumnPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnDatastoreColumnPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDatastore_CustomerManagedS3PropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.requiredValidator)(properties.bucket)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("keyPrefix", cdk.validateString)(properties.keyPrefix)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "CustomerManagedS3Property"');
    }
    function cfnDatastoreCustomerManagedS3PropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDatastore_CustomerManagedS3PropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), KeyPrefix: cdk.stringToCloudFormation(properties.keyPrefix), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnDatastoreCustomerManagedS3PropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", cfn_parse.FromCloudFormation.getString(properties.Bucket)), ret.addPropertyResult("keyPrefix", "KeyPrefix", properties.KeyPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.KeyPrefix) : void 0), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDatastore_CustomerManagedS3StoragePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.requiredValidator)(properties.bucket)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("keyPrefix", cdk.validateString)(properties.keyPrefix)), errors.wrap('supplied properties not correct for "CustomerManagedS3StorageProperty"');
    }
    function cfnDatastoreCustomerManagedS3StoragePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDatastore_CustomerManagedS3StoragePropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), KeyPrefix: cdk.stringToCloudFormation(properties.keyPrefix) }) : properties;
    }
    function CfnDatastoreCustomerManagedS3StoragePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", cfn_parse.FromCloudFormation.getString(properties.Bucket)), ret.addPropertyResult("keyPrefix", "KeyPrefix", properties.KeyPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.KeyPrefix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDatastore_DatastorePartitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("partition", CfnDatastore_PartitionPropertyValidator)(properties.partition)), errors.collect(cdk.propertyValidator("timestampPartition", CfnDatastore_TimestampPartitionPropertyValidator)(properties.timestampPartition)), errors.wrap('supplied properties not correct for "DatastorePartitionProperty"');
    }
    function cfnDatastoreDatastorePartitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDatastore_DatastorePartitionPropertyValidator(properties).assertSuccess(), { Partition: cfnDatastorePartitionPropertyToCloudFormation(properties.partition), TimestampPartition: cfnDatastoreTimestampPartitionPropertyToCloudFormation(properties.timestampPartition) }) : properties;
    }
    function CfnDatastoreDatastorePartitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("partition", "Partition", properties.Partition != null ? CfnDatastorePartitionPropertyFromCloudFormation(properties.Partition) : void 0), ret.addPropertyResult("timestampPartition", "TimestampPartition", properties.TimestampPartition != null ? CfnDatastoreTimestampPartitionPropertyFromCloudFormation(properties.TimestampPartition) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDatastore_DatastorePartitionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("partitions", cdk.listValidator(CfnDatastore_DatastorePartitionPropertyValidator))(properties.partitions)), errors.wrap('supplied properties not correct for "DatastorePartitionsProperty"');
    }
    function cfnDatastoreDatastorePartitionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDatastore_DatastorePartitionsPropertyValidator(properties).assertSuccess(), { Partitions: cdk.listMapper(cfnDatastoreDatastorePartitionPropertyToCloudFormation)(properties.partitions) }) : properties;
    }
    function CfnDatastoreDatastorePartitionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("partitions", "Partitions", properties.Partitions != null ? cfn_parse.FromCloudFormation.getArray(CfnDatastoreDatastorePartitionPropertyFromCloudFormation)(properties.Partitions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDatastore_DatastoreStoragePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customerManagedS3", CfnDatastore_CustomerManagedS3PropertyValidator)(properties.customerManagedS3)), errors.collect(cdk.propertyValidator("iotSiteWiseMultiLayerStorage", CfnDatastore_IotSiteWiseMultiLayerStoragePropertyValidator)(properties.iotSiteWiseMultiLayerStorage)), errors.collect(cdk.propertyValidator("serviceManagedS3", cdk.validateObject)(properties.serviceManagedS3)), errors.wrap('supplied properties not correct for "DatastoreStorageProperty"');
    }
    function cfnDatastoreDatastoreStoragePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDatastore_DatastoreStoragePropertyValidator(properties).assertSuccess(), { CustomerManagedS3: cfnDatastoreCustomerManagedS3PropertyToCloudFormation(properties.customerManagedS3), IotSiteWiseMultiLayerStorage: cfnDatastoreIotSiteWiseMultiLayerStoragePropertyToCloudFormation(properties.iotSiteWiseMultiLayerStorage), ServiceManagedS3: cdk.objectToCloudFormation(properties.serviceManagedS3) }) : properties;
    }
    function CfnDatastoreDatastoreStoragePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customerManagedS3", "CustomerManagedS3", properties.CustomerManagedS3 != null ? CfnDatastoreCustomerManagedS3PropertyFromCloudFormation(properties.CustomerManagedS3) : void 0), ret.addPropertyResult("iotSiteWiseMultiLayerStorage", "IotSiteWiseMultiLayerStorage", properties.IotSiteWiseMultiLayerStorage != null ? CfnDatastoreIotSiteWiseMultiLayerStoragePropertyFromCloudFormation(properties.IotSiteWiseMultiLayerStorage) : void 0), ret.addPropertyResult("serviceManagedS3", "ServiceManagedS3", properties.ServiceManagedS3 != null ? cfn_parse.FromCloudFormation.getAny(properties.ServiceManagedS3) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDatastore_FileFormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("jsonConfiguration", cdk.validateObject)(properties.jsonConfiguration)), errors.collect(cdk.propertyValidator("parquetConfiguration", CfnDatastore_ParquetConfigurationPropertyValidator)(properties.parquetConfiguration)), errors.wrap('supplied properties not correct for "FileFormatConfigurationProperty"');
    }
    function cfnDatastoreFileFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDatastore_FileFormatConfigurationPropertyValidator(properties).assertSuccess(), { JsonConfiguration: cdk.objectToCloudFormation(properties.jsonConfiguration), ParquetConfiguration: cfnDatastoreParquetConfigurationPropertyToCloudFormation(properties.parquetConfiguration) }) : properties;
    }
    function CfnDatastoreFileFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("jsonConfiguration", "JsonConfiguration", properties.JsonConfiguration != null ? cfn_parse.FromCloudFormation.getAny(properties.JsonConfiguration) : void 0), ret.addPropertyResult("parquetConfiguration", "ParquetConfiguration", properties.ParquetConfiguration != null ? CfnDatastoreParquetConfigurationPropertyFromCloudFormation(properties.ParquetConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDatastore_IotSiteWiseMultiLayerStoragePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customerManagedS3Storage", CfnDatastore_CustomerManagedS3StoragePropertyValidator)(properties.customerManagedS3Storage)), errors.wrap('supplied properties not correct for "IotSiteWiseMultiLayerStorageProperty"');
    }
    function cfnDatastoreIotSiteWiseMultiLayerStoragePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDatastore_IotSiteWiseMultiLayerStoragePropertyValidator(properties).assertSuccess(), { CustomerManagedS3Storage: cfnDatastoreCustomerManagedS3StoragePropertyToCloudFormation(properties.customerManagedS3Storage) }) : properties;
    }
    function CfnDatastoreIotSiteWiseMultiLayerStoragePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customerManagedS3Storage", "CustomerManagedS3Storage", properties.CustomerManagedS3Storage != null ? CfnDatastoreCustomerManagedS3StoragePropertyFromCloudFormation(properties.CustomerManagedS3Storage) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDatastore_ParquetConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("schemaDefinition", CfnDatastore_SchemaDefinitionPropertyValidator)(properties.schemaDefinition)), errors.wrap('supplied properties not correct for "ParquetConfigurationProperty"');
    }
    function cfnDatastoreParquetConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDatastore_ParquetConfigurationPropertyValidator(properties).assertSuccess(), { SchemaDefinition: cfnDatastoreSchemaDefinitionPropertyToCloudFormation(properties.schemaDefinition) }) : properties;
    }
    function CfnDatastoreParquetConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("schemaDefinition", "SchemaDefinition", properties.SchemaDefinition != null ? CfnDatastoreSchemaDefinitionPropertyFromCloudFormation(properties.SchemaDefinition) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDatastore_PartitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributeName", cdk.requiredValidator)(properties.attributeName)), errors.collect(cdk.propertyValidator("attributeName", cdk.validateString)(properties.attributeName)), errors.wrap('supplied properties not correct for "PartitionProperty"');
    }
    function cfnDatastorePartitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDatastore_PartitionPropertyValidator(properties).assertSuccess(), { AttributeName: cdk.stringToCloudFormation(properties.attributeName) }) : properties;
    }
    function CfnDatastorePartitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attributeName", "AttributeName", cfn_parse.FromCloudFormation.getString(properties.AttributeName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDatastore_RetentionPeriodPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("numberOfDays", cdk.validateNumber)(properties.numberOfDays)), errors.collect(cdk.propertyValidator("unlimited", cdk.validateBoolean)(properties.unlimited)), errors.wrap('supplied properties not correct for "RetentionPeriodProperty"');
    }
    function cfnDatastoreRetentionPeriodPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDatastore_RetentionPeriodPropertyValidator(properties).assertSuccess(), { NumberOfDays: cdk.numberToCloudFormation(properties.numberOfDays), Unlimited: cdk.booleanToCloudFormation(properties.unlimited) }) : properties;
    }
    function CfnDatastoreRetentionPeriodPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("numberOfDays", "NumberOfDays", properties.NumberOfDays != null ? cfn_parse.FromCloudFormation.getNumber(properties.NumberOfDays) : void 0), ret.addPropertyResult("unlimited", "Unlimited", properties.Unlimited != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Unlimited) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDatastore_SchemaDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columns", cdk.listValidator(CfnDatastore_ColumnPropertyValidator))(properties.columns)), errors.wrap('supplied properties not correct for "SchemaDefinitionProperty"');
    }
    function cfnDatastoreSchemaDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDatastore_SchemaDefinitionPropertyValidator(properties).assertSuccess(), { Columns: cdk.listMapper(cfnDatastoreColumnPropertyToCloudFormation)(properties.columns) }) : properties;
    }
    function CfnDatastoreSchemaDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columns", "Columns", properties.Columns != null ? cfn_parse.FromCloudFormation.getArray(CfnDatastoreColumnPropertyFromCloudFormation)(properties.Columns) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDatastore_TimestampPartitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributeName", cdk.requiredValidator)(properties.attributeName)), errors.collect(cdk.propertyValidator("attributeName", cdk.validateString)(properties.attributeName)), errors.collect(cdk.propertyValidator("timestampFormat", cdk.validateString)(properties.timestampFormat)), errors.wrap('supplied properties not correct for "TimestampPartitionProperty"');
    }
    function cfnDatastoreTimestampPartitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDatastore_TimestampPartitionPropertyValidator(properties).assertSuccess(), { AttributeName: cdk.stringToCloudFormation(properties.attributeName), TimestampFormat: cdk.stringToCloudFormation(properties.timestampFormat) }) : properties;
    }
    function CfnDatastoreTimestampPartitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attributeName", "AttributeName", cfn_parse.FromCloudFormation.getString(properties.AttributeName)), ret.addPropertyResult("timestampFormat", "TimestampFormat", properties.TimestampFormat != null ? cfn_parse.FromCloudFormation.getString(properties.TimestampFormat) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipelinePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("pipelineActivities", cdk.requiredValidator)(properties.pipelineActivities)), errors.collect(cdk.propertyValidator("pipelineActivities", cdk.listValidator(CfnPipeline_ActivityPropertyValidator))(properties.pipelineActivities)), errors.collect(cdk.propertyValidator("pipelineName", cdk.validateString)(properties.pipelineName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnPipelineProps"');
    }
    function cfnPipelinePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipelinePropsValidator(properties).assertSuccess(), { PipelineActivities: cdk.listMapper(cfnPipelineActivityPropertyToCloudFormation)(properties.pipelineActivities), PipelineName: cdk.stringToCloudFormation(properties.pipelineName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnPipelinePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("pipelineActivities", "PipelineActivities", cfn_parse.FromCloudFormation.getArray(CfnPipelineActivityPropertyFromCloudFormation)(properties.PipelineActivities)), ret.addPropertyResult("pipelineName", "PipelineName", properties.PipelineName != null ? cfn_parse.FromCloudFormation.getString(properties.PipelineName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPipeline = class _CfnPipeline extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPipelinePropsFromCloudFormation(resourceProperties), ret = new _CfnPipeline(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPipeline.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotanalytics_CfnPipelineProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPipeline), error;
        }
        cdk.requireProperty(props, "pipelineActivities", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.pipelineActivities = props.pipelineActivities, this.pipelineName = props.pipelineName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTAnalytics::Pipeline", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPipeline.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { pipelineActivities: this.pipelineActivities, pipelineName: this.pipelineName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnPipelinePropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnPipeline[_d] = { fqn: "aws-cdk-lib.aws_iotanalytics.CfnPipeline", version: "2.80.0" }, CfnPipeline.CFN_RESOURCE_TYPE_NAME = "AWS::IoTAnalytics::Pipeline", exports2.CfnPipeline = CfnPipeline;
    function CfnPipeline_ActivityPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("addAttributes", CfnPipeline_AddAttributesPropertyValidator)(properties.addAttributes)), errors.collect(cdk.propertyValidator("channel", CfnPipeline_ChannelPropertyValidator)(properties.channel)), errors.collect(cdk.propertyValidator("datastore", CfnPipeline_DatastorePropertyValidator)(properties.datastore)), errors.collect(cdk.propertyValidator("deviceRegistryEnrich", CfnPipeline_DeviceRegistryEnrichPropertyValidator)(properties.deviceRegistryEnrich)), errors.collect(cdk.propertyValidator("deviceShadowEnrich", CfnPipeline_DeviceShadowEnrichPropertyValidator)(properties.deviceShadowEnrich)), errors.collect(cdk.propertyValidator("filter", CfnPipeline_FilterPropertyValidator)(properties.filter)), errors.collect(cdk.propertyValidator("lambda", CfnPipeline_LambdaPropertyValidator)(properties.lambda)), errors.collect(cdk.propertyValidator("math", CfnPipeline_MathPropertyValidator)(properties.math)), errors.collect(cdk.propertyValidator("removeAttributes", CfnPipeline_RemoveAttributesPropertyValidator)(properties.removeAttributes)), errors.collect(cdk.propertyValidator("selectAttributes", CfnPipeline_SelectAttributesPropertyValidator)(properties.selectAttributes)), errors.wrap('supplied properties not correct for "ActivityProperty"');
    }
    function cfnPipelineActivityPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipeline_ActivityPropertyValidator(properties).assertSuccess(), { AddAttributes: cfnPipelineAddAttributesPropertyToCloudFormation(properties.addAttributes), Channel: cfnPipelineChannelPropertyToCloudFormation(properties.channel), Datastore: cfnPipelineDatastorePropertyToCloudFormation(properties.datastore), DeviceRegistryEnrich: cfnPipelineDeviceRegistryEnrichPropertyToCloudFormation(properties.deviceRegistryEnrich), DeviceShadowEnrich: cfnPipelineDeviceShadowEnrichPropertyToCloudFormation(properties.deviceShadowEnrich), Filter: cfnPipelineFilterPropertyToCloudFormation(properties.filter), Lambda: cfnPipelineLambdaPropertyToCloudFormation(properties.lambda), Math: cfnPipelineMathPropertyToCloudFormation(properties.math), RemoveAttributes: cfnPipelineRemoveAttributesPropertyToCloudFormation(properties.removeAttributes), SelectAttributes: cfnPipelineSelectAttributesPropertyToCloudFormation(properties.selectAttributes) }) : properties;
    }
    function CfnPipelineActivityPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("addAttributes", "AddAttributes", properties.AddAttributes != null ? CfnPipelineAddAttributesPropertyFromCloudFormation(properties.AddAttributes) : void 0), ret.addPropertyResult("channel", "Channel", properties.Channel != null ? CfnPipelineChannelPropertyFromCloudFormation(properties.Channel) : void 0), ret.addPropertyResult("datastore", "Datastore", properties.Datastore != null ? CfnPipelineDatastorePropertyFromCloudFormation(properties.Datastore) : void 0), ret.addPropertyResult("deviceRegistryEnrich", "DeviceRegistryEnrich", properties.DeviceRegistryEnrich != null ? CfnPipelineDeviceRegistryEnrichPropertyFromCloudFormation(properties.DeviceRegistryEnrich) : void 0), ret.addPropertyResult("deviceShadowEnrich", "DeviceShadowEnrich", properties.DeviceShadowEnrich != null ? CfnPipelineDeviceShadowEnrichPropertyFromCloudFormation(properties.DeviceShadowEnrich) : void 0), ret.addPropertyResult("filter", "Filter", properties.Filter != null ? CfnPipelineFilterPropertyFromCloudFormation(properties.Filter) : void 0), ret.addPropertyResult("lambda", "Lambda", properties.Lambda != null ? CfnPipelineLambdaPropertyFromCloudFormation(properties.Lambda) : void 0), ret.addPropertyResult("math", "Math", properties.Math != null ? CfnPipelineMathPropertyFromCloudFormation(properties.Math) : void 0), ret.addPropertyResult("removeAttributes", "RemoveAttributes", properties.RemoveAttributes != null ? CfnPipelineRemoveAttributesPropertyFromCloudFormation(properties.RemoveAttributes) : void 0), ret.addPropertyResult("selectAttributes", "SelectAttributes", properties.SelectAttributes != null ? CfnPipelineSelectAttributesPropertyFromCloudFormation(properties.SelectAttributes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipeline_AddAttributesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributes", cdk.requiredValidator)(properties.attributes)), errors.collect(cdk.propertyValidator("attributes", cdk.hashValidator(cdk.validateString))(properties.attributes)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("next", cdk.validateString)(properties.next)), errors.wrap('supplied properties not correct for "AddAttributesProperty"');
    }
    function cfnPipelineAddAttributesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipeline_AddAttributesPropertyValidator(properties).assertSuccess(), { Attributes: cdk.hashMapper(cdk.stringToCloudFormation)(properties.attributes), Name: cdk.stringToCloudFormation(properties.name), Next: cdk.stringToCloudFormation(properties.next) }) : properties;
    }
    function CfnPipelineAddAttributesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attributes", "Attributes", cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Attributes)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("next", "Next", properties.Next != null ? cfn_parse.FromCloudFormation.getString(properties.Next) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipeline_ChannelPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("channelName", cdk.requiredValidator)(properties.channelName)), errors.collect(cdk.propertyValidator("channelName", cdk.validateString)(properties.channelName)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("next", cdk.validateString)(properties.next)), errors.wrap('supplied properties not correct for "ChannelProperty"');
    }
    function cfnPipelineChannelPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipeline_ChannelPropertyValidator(properties).assertSuccess(), { ChannelName: cdk.stringToCloudFormation(properties.channelName), Name: cdk.stringToCloudFormation(properties.name), Next: cdk.stringToCloudFormation(properties.next) }) : properties;
    }
    function CfnPipelineChannelPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("channelName", "ChannelName", cfn_parse.FromCloudFormation.getString(properties.ChannelName)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("next", "Next", properties.Next != null ? cfn_parse.FromCloudFormation.getString(properties.Next) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipeline_DatastorePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("datastoreName", cdk.requiredValidator)(properties.datastoreName)), errors.collect(cdk.propertyValidator("datastoreName", cdk.validateString)(properties.datastoreName)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "DatastoreProperty"');
    }
    function cfnPipelineDatastorePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipeline_DatastorePropertyValidator(properties).assertSuccess(), { DatastoreName: cdk.stringToCloudFormation(properties.datastoreName), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnPipelineDatastorePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("datastoreName", "DatastoreName", cfn_parse.FromCloudFormation.getString(properties.DatastoreName)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipeline_DeviceRegistryEnrichPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attribute", cdk.requiredValidator)(properties.attribute)), errors.collect(cdk.propertyValidator("attribute", cdk.validateString)(properties.attribute)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("next", cdk.validateString)(properties.next)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("thingName", cdk.requiredValidator)(properties.thingName)), errors.collect(cdk.propertyValidator("thingName", cdk.validateString)(properties.thingName)), errors.wrap('supplied properties not correct for "DeviceRegistryEnrichProperty"');
    }
    function cfnPipelineDeviceRegistryEnrichPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipeline_DeviceRegistryEnrichPropertyValidator(properties).assertSuccess(), { Attribute: cdk.stringToCloudFormation(properties.attribute), Name: cdk.stringToCloudFormation(properties.name), Next: cdk.stringToCloudFormation(properties.next), RoleArn: cdk.stringToCloudFormation(properties.roleArn), ThingName: cdk.stringToCloudFormation(properties.thingName) }) : properties;
    }
    function CfnPipelineDeviceRegistryEnrichPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attribute", "Attribute", cfn_parse.FromCloudFormation.getString(properties.Attribute)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("next", "Next", properties.Next != null ? cfn_parse.FromCloudFormation.getString(properties.Next) : void 0), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("thingName", "ThingName", cfn_parse.FromCloudFormation.getString(properties.ThingName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipeline_DeviceShadowEnrichPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attribute", cdk.requiredValidator)(properties.attribute)), errors.collect(cdk.propertyValidator("attribute", cdk.validateString)(properties.attribute)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("next", cdk.validateString)(properties.next)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("thingName", cdk.requiredValidator)(properties.thingName)), errors.collect(cdk.propertyValidator("thingName", cdk.validateString)(properties.thingName)), errors.wrap('supplied properties not correct for "DeviceShadowEnrichProperty"');
    }
    function cfnPipelineDeviceShadowEnrichPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipeline_DeviceShadowEnrichPropertyValidator(properties).assertSuccess(), { Attribute: cdk.stringToCloudFormation(properties.attribute), Name: cdk.stringToCloudFormation(properties.name), Next: cdk.stringToCloudFormation(properties.next), RoleArn: cdk.stringToCloudFormation(properties.roleArn), ThingName: cdk.stringToCloudFormation(properties.thingName) }) : properties;
    }
    function CfnPipelineDeviceShadowEnrichPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attribute", "Attribute", cfn_parse.FromCloudFormation.getString(properties.Attribute)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("next", "Next", properties.Next != null ? cfn_parse.FromCloudFormation.getString(properties.Next) : void 0), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("thingName", "ThingName", cfn_parse.FromCloudFormation.getString(properties.ThingName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipeline_FilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("filter", cdk.requiredValidator)(properties.filter)), errors.collect(cdk.propertyValidator("filter", cdk.validateString)(properties.filter)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("next", cdk.validateString)(properties.next)), errors.wrap('supplied properties not correct for "FilterProperty"');
    }
    function cfnPipelineFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipeline_FilterPropertyValidator(properties).assertSuccess(), { Filter: cdk.stringToCloudFormation(properties.filter), Name: cdk.stringToCloudFormation(properties.name), Next: cdk.stringToCloudFormation(properties.next) }) : properties;
    }
    function CfnPipelineFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("filter", "Filter", cfn_parse.FromCloudFormation.getString(properties.Filter)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("next", "Next", properties.Next != null ? cfn_parse.FromCloudFormation.getString(properties.Next) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipeline_LambdaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("batchSize", cdk.requiredValidator)(properties.batchSize)), errors.collect(cdk.propertyValidator("batchSize", cdk.validateNumber)(properties.batchSize)), errors.collect(cdk.propertyValidator("lambdaName", cdk.requiredValidator)(properties.lambdaName)), errors.collect(cdk.propertyValidator("lambdaName", cdk.validateString)(properties.lambdaName)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("next", cdk.validateString)(properties.next)), errors.wrap('supplied properties not correct for "LambdaProperty"');
    }
    function cfnPipelineLambdaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipeline_LambdaPropertyValidator(properties).assertSuccess(), { BatchSize: cdk.numberToCloudFormation(properties.batchSize), LambdaName: cdk.stringToCloudFormation(properties.lambdaName), Name: cdk.stringToCloudFormation(properties.name), Next: cdk.stringToCloudFormation(properties.next) }) : properties;
    }
    function CfnPipelineLambdaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("batchSize", "BatchSize", cfn_parse.FromCloudFormation.getNumber(properties.BatchSize)), ret.addPropertyResult("lambdaName", "LambdaName", cfn_parse.FromCloudFormation.getString(properties.LambdaName)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("next", "Next", properties.Next != null ? cfn_parse.FromCloudFormation.getString(properties.Next) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipeline_MathPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attribute", cdk.requiredValidator)(properties.attribute)), errors.collect(cdk.propertyValidator("attribute", cdk.validateString)(properties.attribute)), errors.collect(cdk.propertyValidator("math", cdk.requiredValidator)(properties.math)), errors.collect(cdk.propertyValidator("math", cdk.validateString)(properties.math)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("next", cdk.validateString)(properties.next)), errors.wrap('supplied properties not correct for "MathProperty"');
    }
    function cfnPipelineMathPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipeline_MathPropertyValidator(properties).assertSuccess(), { Attribute: cdk.stringToCloudFormation(properties.attribute), Math: cdk.stringToCloudFormation(properties.math), Name: cdk.stringToCloudFormation(properties.name), Next: cdk.stringToCloudFormation(properties.next) }) : properties;
    }
    function CfnPipelineMathPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attribute", "Attribute", cfn_parse.FromCloudFormation.getString(properties.Attribute)), ret.addPropertyResult("math", "Math", cfn_parse.FromCloudFormation.getString(properties.Math)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("next", "Next", properties.Next != null ? cfn_parse.FromCloudFormation.getString(properties.Next) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipeline_RemoveAttributesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributes", cdk.requiredValidator)(properties.attributes)), errors.collect(cdk.propertyValidator("attributes", cdk.listValidator(cdk.validateString))(properties.attributes)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("next", cdk.validateString)(properties.next)), errors.wrap('supplied properties not correct for "RemoveAttributesProperty"');
    }
    function cfnPipelineRemoveAttributesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipeline_RemoveAttributesPropertyValidator(properties).assertSuccess(), { Attributes: cdk.listMapper(cdk.stringToCloudFormation)(properties.attributes), Name: cdk.stringToCloudFormation(properties.name), Next: cdk.stringToCloudFormation(properties.next) }) : properties;
    }
    function CfnPipelineRemoveAttributesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attributes", "Attributes", cfn_parse.FromCloudFormation.getStringArray(properties.Attributes)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("next", "Next", properties.Next != null ? cfn_parse.FromCloudFormation.getString(properties.Next) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipeline_SelectAttributesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributes", cdk.requiredValidator)(properties.attributes)), errors.collect(cdk.propertyValidator("attributes", cdk.listValidator(cdk.validateString))(properties.attributes)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("next", cdk.validateString)(properties.next)), errors.wrap('supplied properties not correct for "SelectAttributesProperty"');
    }
    function cfnPipelineSelectAttributesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipeline_SelectAttributesPropertyValidator(properties).assertSuccess(), { Attributes: cdk.listMapper(cdk.stringToCloudFormation)(properties.attributes), Name: cdk.stringToCloudFormation(properties.name), Next: cdk.stringToCloudFormation(properties.next) }) : properties;
    }
    function CfnPipelineSelectAttributesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attributes", "Attributes", cfn_parse.FromCloudFormation.getStringArray(properties.Attributes)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("next", "Next", properties.Next != null ? cfn_parse.FromCloudFormation.getString(properties.Next) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-iotanalytics/lib/index.js
var require_lib151 = __commonJS({
  "node_modules/aws-cdk-lib/aws-iotanalytics/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_iotanalytics_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-iotanalytics/index.js
var require_aws_iotanalytics = __commonJS({
  "node_modules/aws-cdk-lib/aws-iotanalytics/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib151(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-iotcoredeviceadvisor/lib/iotcoredeviceadvisor.generated.js
var require_iotcoredeviceadvisor_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-iotcoredeviceadvisor/lib/iotcoredeviceadvisor.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnSuiteDefinition = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnSuiteDefinitionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("suiteDefinitionConfiguration", cdk.requiredValidator)(properties.suiteDefinitionConfiguration)), errors.collect(cdk.propertyValidator("suiteDefinitionConfiguration", cdk.validateObject)(properties.suiteDefinitionConfiguration)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnSuiteDefinitionProps"');
    }
    function cfnSuiteDefinitionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSuiteDefinitionPropsValidator(properties).assertSuccess(), { SuiteDefinitionConfiguration: cdk.objectToCloudFormation(properties.suiteDefinitionConfiguration), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnSuiteDefinitionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("suiteDefinitionConfiguration", "SuiteDefinitionConfiguration", cfn_parse.FromCloudFormation.getAny(properties.SuiteDefinitionConfiguration)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSuiteDefinition = class _CfnSuiteDefinition extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSuiteDefinitionPropsFromCloudFormation(resourceProperties), ret = new _CfnSuiteDefinition(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSuiteDefinition.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotcoredeviceadvisor_CfnSuiteDefinitionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSuiteDefinition), error;
        }
        cdk.requireProperty(props, "suiteDefinitionConfiguration", this), this.attrSuiteDefinitionArn = cdk.Token.asString(this.getAtt("SuiteDefinitionArn", cdk.ResolutionTypeHint.STRING)), this.attrSuiteDefinitionId = cdk.Token.asString(this.getAtt("SuiteDefinitionId", cdk.ResolutionTypeHint.STRING)), this.attrSuiteDefinitionVersion = cdk.Token.asString(this.getAtt("SuiteDefinitionVersion", cdk.ResolutionTypeHint.STRING)), this.suiteDefinitionConfiguration = props.suiteDefinitionConfiguration, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTCoreDeviceAdvisor::SuiteDefinition", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSuiteDefinition.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { suiteDefinitionConfiguration: this.suiteDefinitionConfiguration, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnSuiteDefinitionPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnSuiteDefinition[_a] = { fqn: "aws-cdk-lib.aws_iotcoredeviceadvisor.CfnSuiteDefinition", version: "2.80.0" }, CfnSuiteDefinition.CFN_RESOURCE_TYPE_NAME = "AWS::IoTCoreDeviceAdvisor::SuiteDefinition", exports2.CfnSuiteDefinition = CfnSuiteDefinition;
  }
});

// node_modules/aws-cdk-lib/aws-iotcoredeviceadvisor/lib/index.js
var require_lib152 = __commonJS({
  "node_modules/aws-cdk-lib/aws-iotcoredeviceadvisor/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_iotcoredeviceadvisor_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-iotcoredeviceadvisor/index.js
var require_aws_iotcoredeviceadvisor = __commonJS({
  "node_modules/aws-cdk-lib/aws-iotcoredeviceadvisor/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib152(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-iotevents/lib/iotevents.generated.js
var require_iotevents_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-iotevents/lib/iotevents.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnInput = exports2.CfnDetectorModel = exports2.CfnAlarmModel = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAlarmModelPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alarmCapabilities", CfnAlarmModel_AlarmCapabilitiesPropertyValidator)(properties.alarmCapabilities)), errors.collect(cdk.propertyValidator("alarmEventActions", CfnAlarmModel_AlarmEventActionsPropertyValidator)(properties.alarmEventActions)), errors.collect(cdk.propertyValidator("alarmModelDescription", cdk.validateString)(properties.alarmModelDescription)), errors.collect(cdk.propertyValidator("alarmModelName", cdk.validateString)(properties.alarmModelName)), errors.collect(cdk.propertyValidator("alarmRule", cdk.requiredValidator)(properties.alarmRule)), errors.collect(cdk.propertyValidator("alarmRule", CfnAlarmModel_AlarmRulePropertyValidator)(properties.alarmRule)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("severity", cdk.validateNumber)(properties.severity)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnAlarmModelProps"');
    }
    function cfnAlarmModelPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlarmModelPropsValidator(properties).assertSuccess(), { AlarmRule: cfnAlarmModelAlarmRulePropertyToCloudFormation(properties.alarmRule), RoleArn: cdk.stringToCloudFormation(properties.roleArn), AlarmCapabilities: cfnAlarmModelAlarmCapabilitiesPropertyToCloudFormation(properties.alarmCapabilities), AlarmEventActions: cfnAlarmModelAlarmEventActionsPropertyToCloudFormation(properties.alarmEventActions), AlarmModelDescription: cdk.stringToCloudFormation(properties.alarmModelDescription), AlarmModelName: cdk.stringToCloudFormation(properties.alarmModelName), Key: cdk.stringToCloudFormation(properties.key), Severity: cdk.numberToCloudFormation(properties.severity), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnAlarmModelPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alarmRule", "AlarmRule", CfnAlarmModelAlarmRulePropertyFromCloudFormation(properties.AlarmRule)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("alarmCapabilities", "AlarmCapabilities", properties.AlarmCapabilities != null ? CfnAlarmModelAlarmCapabilitiesPropertyFromCloudFormation(properties.AlarmCapabilities) : void 0), ret.addPropertyResult("alarmEventActions", "AlarmEventActions", properties.AlarmEventActions != null ? CfnAlarmModelAlarmEventActionsPropertyFromCloudFormation(properties.AlarmEventActions) : void 0), ret.addPropertyResult("alarmModelDescription", "AlarmModelDescription", properties.AlarmModelDescription != null ? cfn_parse.FromCloudFormation.getString(properties.AlarmModelDescription) : void 0), ret.addPropertyResult("alarmModelName", "AlarmModelName", properties.AlarmModelName != null ? cfn_parse.FromCloudFormation.getString(properties.AlarmModelName) : void 0), ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("severity", "Severity", properties.Severity != null ? cfn_parse.FromCloudFormation.getNumber(properties.Severity) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAlarmModel = class _CfnAlarmModel extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAlarmModelPropsFromCloudFormation(resourceProperties), ret = new _CfnAlarmModel(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAlarmModel.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotevents_CfnAlarmModelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAlarmModel), error;
        }
        cdk.requireProperty(props, "alarmRule", this), cdk.requireProperty(props, "roleArn", this), this.alarmRule = props.alarmRule, this.roleArn = props.roleArn, this.alarmCapabilities = props.alarmCapabilities, this.alarmEventActions = props.alarmEventActions, this.alarmModelDescription = props.alarmModelDescription, this.alarmModelName = props.alarmModelName, this.key = props.key, this.severity = props.severity, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTEvents::AlarmModel", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAlarmModel.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { alarmRule: this.alarmRule, roleArn: this.roleArn, alarmCapabilities: this.alarmCapabilities, alarmEventActions: this.alarmEventActions, alarmModelDescription: this.alarmModelDescription, alarmModelName: this.alarmModelName, key: this.key, severity: this.severity, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnAlarmModelPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAlarmModel[_a] = { fqn: "aws-cdk-lib.aws_iotevents.CfnAlarmModel", version: "2.80.0" }, CfnAlarmModel.CFN_RESOURCE_TYPE_NAME = "AWS::IoTEvents::AlarmModel", exports2.CfnAlarmModel = CfnAlarmModel;
    function CfnAlarmModel_AcknowledgeFlowPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "AcknowledgeFlowProperty"');
    }
    function cfnAlarmModelAcknowledgeFlowPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlarmModel_AcknowledgeFlowPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnAlarmModelAcknowledgeFlowPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAlarmModel_AlarmActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dynamoDb", CfnAlarmModel_DynamoDBPropertyValidator)(properties.dynamoDb)), errors.collect(cdk.propertyValidator("dynamoDBv2", CfnAlarmModel_DynamoDBv2PropertyValidator)(properties.dynamoDBv2)), errors.collect(cdk.propertyValidator("firehose", CfnAlarmModel_FirehosePropertyValidator)(properties.firehose)), errors.collect(cdk.propertyValidator("iotEvents", CfnAlarmModel_IotEventsPropertyValidator)(properties.iotEvents)), errors.collect(cdk.propertyValidator("iotSiteWise", CfnAlarmModel_IotSiteWisePropertyValidator)(properties.iotSiteWise)), errors.collect(cdk.propertyValidator("iotTopicPublish", CfnAlarmModel_IotTopicPublishPropertyValidator)(properties.iotTopicPublish)), errors.collect(cdk.propertyValidator("lambda", CfnAlarmModel_LambdaPropertyValidator)(properties.lambda)), errors.collect(cdk.propertyValidator("sns", CfnAlarmModel_SnsPropertyValidator)(properties.sns)), errors.collect(cdk.propertyValidator("sqs", CfnAlarmModel_SqsPropertyValidator)(properties.sqs)), errors.wrap('supplied properties not correct for "AlarmActionProperty"');
    }
    function cfnAlarmModelAlarmActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlarmModel_AlarmActionPropertyValidator(properties).assertSuccess(), { DynamoDB: cfnAlarmModelDynamoDBPropertyToCloudFormation(properties.dynamoDb), DynamoDBv2: cfnAlarmModelDynamoDBv2PropertyToCloudFormation(properties.dynamoDBv2), Firehose: cfnAlarmModelFirehosePropertyToCloudFormation(properties.firehose), IotEvents: cfnAlarmModelIotEventsPropertyToCloudFormation(properties.iotEvents), IotSiteWise: cfnAlarmModelIotSiteWisePropertyToCloudFormation(properties.iotSiteWise), IotTopicPublish: cfnAlarmModelIotTopicPublishPropertyToCloudFormation(properties.iotTopicPublish), Lambda: cfnAlarmModelLambdaPropertyToCloudFormation(properties.lambda), Sns: cfnAlarmModelSnsPropertyToCloudFormation(properties.sns), Sqs: cfnAlarmModelSqsPropertyToCloudFormation(properties.sqs) }) : properties;
    }
    function CfnAlarmModelAlarmActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dynamoDb", "DynamoDB", properties.DynamoDB != null ? CfnAlarmModelDynamoDBPropertyFromCloudFormation(properties.DynamoDB) : void 0), ret.addPropertyResult("dynamoDBv2", "DynamoDBv2", properties.DynamoDBv2 != null ? CfnAlarmModelDynamoDBv2PropertyFromCloudFormation(properties.DynamoDBv2) : void 0), ret.addPropertyResult("firehose", "Firehose", properties.Firehose != null ? CfnAlarmModelFirehosePropertyFromCloudFormation(properties.Firehose) : void 0), ret.addPropertyResult("iotEvents", "IotEvents", properties.IotEvents != null ? CfnAlarmModelIotEventsPropertyFromCloudFormation(properties.IotEvents) : void 0), ret.addPropertyResult("iotSiteWise", "IotSiteWise", properties.IotSiteWise != null ? CfnAlarmModelIotSiteWisePropertyFromCloudFormation(properties.IotSiteWise) : void 0), ret.addPropertyResult("iotTopicPublish", "IotTopicPublish", properties.IotTopicPublish != null ? CfnAlarmModelIotTopicPublishPropertyFromCloudFormation(properties.IotTopicPublish) : void 0), ret.addPropertyResult("lambda", "Lambda", properties.Lambda != null ? CfnAlarmModelLambdaPropertyFromCloudFormation(properties.Lambda) : void 0), ret.addPropertyResult("sns", "Sns", properties.Sns != null ? CfnAlarmModelSnsPropertyFromCloudFormation(properties.Sns) : void 0), ret.addPropertyResult("sqs", "Sqs", properties.Sqs != null ? CfnAlarmModelSqsPropertyFromCloudFormation(properties.Sqs) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAlarmModel_AlarmCapabilitiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acknowledgeFlow", CfnAlarmModel_AcknowledgeFlowPropertyValidator)(properties.acknowledgeFlow)), errors.collect(cdk.propertyValidator("initializationConfiguration", CfnAlarmModel_InitializationConfigurationPropertyValidator)(properties.initializationConfiguration)), errors.wrap('supplied properties not correct for "AlarmCapabilitiesProperty"');
    }
    function cfnAlarmModelAlarmCapabilitiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlarmModel_AlarmCapabilitiesPropertyValidator(properties).assertSuccess(), { AcknowledgeFlow: cfnAlarmModelAcknowledgeFlowPropertyToCloudFormation(properties.acknowledgeFlow), InitializationConfiguration: cfnAlarmModelInitializationConfigurationPropertyToCloudFormation(properties.initializationConfiguration) }) : properties;
    }
    function CfnAlarmModelAlarmCapabilitiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("acknowledgeFlow", "AcknowledgeFlow", properties.AcknowledgeFlow != null ? CfnAlarmModelAcknowledgeFlowPropertyFromCloudFormation(properties.AcknowledgeFlow) : void 0), ret.addPropertyResult("initializationConfiguration", "InitializationConfiguration", properties.InitializationConfiguration != null ? CfnAlarmModelInitializationConfigurationPropertyFromCloudFormation(properties.InitializationConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAlarmModel_AlarmEventActionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alarmActions", cdk.listValidator(CfnAlarmModel_AlarmActionPropertyValidator))(properties.alarmActions)), errors.wrap('supplied properties not correct for "AlarmEventActionsProperty"');
    }
    function cfnAlarmModelAlarmEventActionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlarmModel_AlarmEventActionsPropertyValidator(properties).assertSuccess(), { AlarmActions: cdk.listMapper(cfnAlarmModelAlarmActionPropertyToCloudFormation)(properties.alarmActions) }) : properties;
    }
    function CfnAlarmModelAlarmEventActionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alarmActions", "AlarmActions", properties.AlarmActions != null ? cfn_parse.FromCloudFormation.getArray(CfnAlarmModelAlarmActionPropertyFromCloudFormation)(properties.AlarmActions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAlarmModel_AlarmRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("simpleRule", CfnAlarmModel_SimpleRulePropertyValidator)(properties.simpleRule)), errors.wrap('supplied properties not correct for "AlarmRuleProperty"');
    }
    function cfnAlarmModelAlarmRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlarmModel_AlarmRulePropertyValidator(properties).assertSuccess(), { SimpleRule: cfnAlarmModelSimpleRulePropertyToCloudFormation(properties.simpleRule) }) : properties;
    }
    function CfnAlarmModelAlarmRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("simpleRule", "SimpleRule", properties.SimpleRule != null ? CfnAlarmModelSimpleRulePropertyFromCloudFormation(properties.SimpleRule) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAlarmModel_AssetPropertyTimestampPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("offsetInNanos", cdk.validateString)(properties.offsetInNanos)), errors.collect(cdk.propertyValidator("timeInSeconds", cdk.requiredValidator)(properties.timeInSeconds)), errors.collect(cdk.propertyValidator("timeInSeconds", cdk.validateString)(properties.timeInSeconds)), errors.wrap('supplied properties not correct for "AssetPropertyTimestampProperty"');
    }
    function cfnAlarmModelAssetPropertyTimestampPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlarmModel_AssetPropertyTimestampPropertyValidator(properties).assertSuccess(), { OffsetInNanos: cdk.stringToCloudFormation(properties.offsetInNanos), TimeInSeconds: cdk.stringToCloudFormation(properties.timeInSeconds) }) : properties;
    }
    function CfnAlarmModelAssetPropertyTimestampPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("offsetInNanos", "OffsetInNanos", properties.OffsetInNanos != null ? cfn_parse.FromCloudFormation.getString(properties.OffsetInNanos) : void 0), ret.addPropertyResult("timeInSeconds", "TimeInSeconds", cfn_parse.FromCloudFormation.getString(properties.TimeInSeconds)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAlarmModel_AssetPropertyValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("quality", cdk.validateString)(properties.quality)), errors.collect(cdk.propertyValidator("timestamp", CfnAlarmModel_AssetPropertyTimestampPropertyValidator)(properties.timestamp)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", CfnAlarmModel_AssetPropertyVariantPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "AssetPropertyValueProperty"');
    }
    function cfnAlarmModelAssetPropertyValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlarmModel_AssetPropertyValuePropertyValidator(properties).assertSuccess(), { Quality: cdk.stringToCloudFormation(properties.quality), Timestamp: cfnAlarmModelAssetPropertyTimestampPropertyToCloudFormation(properties.timestamp), Value: cfnAlarmModelAssetPropertyVariantPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnAlarmModelAssetPropertyValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("quality", "Quality", properties.Quality != null ? cfn_parse.FromCloudFormation.getString(properties.Quality) : void 0), ret.addPropertyResult("timestamp", "Timestamp", properties.Timestamp != null ? CfnAlarmModelAssetPropertyTimestampPropertyFromCloudFormation(properties.Timestamp) : void 0), ret.addPropertyResult("value", "Value", CfnAlarmModelAssetPropertyVariantPropertyFromCloudFormation(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAlarmModel_AssetPropertyVariantPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("booleanValue", cdk.validateString)(properties.booleanValue)), errors.collect(cdk.propertyValidator("doubleValue", cdk.validateString)(properties.doubleValue)), errors.collect(cdk.propertyValidator("integerValue", cdk.validateString)(properties.integerValue)), errors.collect(cdk.propertyValidator("stringValue", cdk.validateString)(properties.stringValue)), errors.wrap('supplied properties not correct for "AssetPropertyVariantProperty"');
    }
    function cfnAlarmModelAssetPropertyVariantPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlarmModel_AssetPropertyVariantPropertyValidator(properties).assertSuccess(), { BooleanValue: cdk.stringToCloudFormation(properties.booleanValue), DoubleValue: cdk.stringToCloudFormation(properties.doubleValue), IntegerValue: cdk.stringToCloudFormation(properties.integerValue), StringValue: cdk.stringToCloudFormation(properties.stringValue) }) : properties;
    }
    function CfnAlarmModelAssetPropertyVariantPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("booleanValue", "BooleanValue", properties.BooleanValue != null ? cfn_parse.FromCloudFormation.getString(properties.BooleanValue) : void 0), ret.addPropertyResult("doubleValue", "DoubleValue", properties.DoubleValue != null ? cfn_parse.FromCloudFormation.getString(properties.DoubleValue) : void 0), ret.addPropertyResult("integerValue", "IntegerValue", properties.IntegerValue != null ? cfn_parse.FromCloudFormation.getString(properties.IntegerValue) : void 0), ret.addPropertyResult("stringValue", "StringValue", properties.StringValue != null ? cfn_parse.FromCloudFormation.getString(properties.StringValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAlarmModel_DynamoDBPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("hashKeyField", cdk.requiredValidator)(properties.hashKeyField)), errors.collect(cdk.propertyValidator("hashKeyField", cdk.validateString)(properties.hashKeyField)), errors.collect(cdk.propertyValidator("hashKeyType", cdk.validateString)(properties.hashKeyType)), errors.collect(cdk.propertyValidator("hashKeyValue", cdk.requiredValidator)(properties.hashKeyValue)), errors.collect(cdk.propertyValidator("hashKeyValue", cdk.validateString)(properties.hashKeyValue)), errors.collect(cdk.propertyValidator("operation", cdk.validateString)(properties.operation)), errors.collect(cdk.propertyValidator("payload", CfnAlarmModel_PayloadPropertyValidator)(properties.payload)), errors.collect(cdk.propertyValidator("payloadField", cdk.validateString)(properties.payloadField)), errors.collect(cdk.propertyValidator("rangeKeyField", cdk.validateString)(properties.rangeKeyField)), errors.collect(cdk.propertyValidator("rangeKeyType", cdk.validateString)(properties.rangeKeyType)), errors.collect(cdk.propertyValidator("rangeKeyValue", cdk.validateString)(properties.rangeKeyValue)), errors.collect(cdk.propertyValidator("tableName", cdk.requiredValidator)(properties.tableName)), errors.collect(cdk.propertyValidator("tableName", cdk.validateString)(properties.tableName)), errors.wrap('supplied properties not correct for "DynamoDBProperty"');
    }
    function cfnAlarmModelDynamoDBPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlarmModel_DynamoDBPropertyValidator(properties).assertSuccess(), { HashKeyField: cdk.stringToCloudFormation(properties.hashKeyField), HashKeyType: cdk.stringToCloudFormation(properties.hashKeyType), HashKeyValue: cdk.stringToCloudFormation(properties.hashKeyValue), Operation: cdk.stringToCloudFormation(properties.operation), Payload: cfnAlarmModelPayloadPropertyToCloudFormation(properties.payload), PayloadField: cdk.stringToCloudFormation(properties.payloadField), RangeKeyField: cdk.stringToCloudFormation(properties.rangeKeyField), RangeKeyType: cdk.stringToCloudFormation(properties.rangeKeyType), RangeKeyValue: cdk.stringToCloudFormation(properties.rangeKeyValue), TableName: cdk.stringToCloudFormation(properties.tableName) }) : properties;
    }
    function CfnAlarmModelDynamoDBPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("hashKeyField", "HashKeyField", cfn_parse.FromCloudFormation.getString(properties.HashKeyField)), ret.addPropertyResult("hashKeyType", "HashKeyType", properties.HashKeyType != null ? cfn_parse.FromCloudFormation.getString(properties.HashKeyType) : void 0), ret.addPropertyResult("hashKeyValue", "HashKeyValue", cfn_parse.FromCloudFormation.getString(properties.HashKeyValue)), ret.addPropertyResult("operation", "Operation", properties.Operation != null ? cfn_parse.FromCloudFormation.getString(properties.Operation) : void 0), ret.addPropertyResult("payload", "Payload", properties.Payload != null ? CfnAlarmModelPayloadPropertyFromCloudFormation(properties.Payload) : void 0), ret.addPropertyResult("payloadField", "PayloadField", properties.PayloadField != null ? cfn_parse.FromCloudFormation.getString(properties.PayloadField) : void 0), ret.addPropertyResult("rangeKeyField", "RangeKeyField", properties.RangeKeyField != null ? cfn_parse.FromCloudFormation.getString(properties.RangeKeyField) : void 0), ret.addPropertyResult("rangeKeyType", "RangeKeyType", properties.RangeKeyType != null ? cfn_parse.FromCloudFormation.getString(properties.RangeKeyType) : void 0), ret.addPropertyResult("rangeKeyValue", "RangeKeyValue", properties.RangeKeyValue != null ? cfn_parse.FromCloudFormation.getString(properties.RangeKeyValue) : void 0), ret.addPropertyResult("tableName", "TableName", cfn_parse.FromCloudFormation.getString(properties.TableName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAlarmModel_DynamoDBv2PropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("payload", CfnAlarmModel_PayloadPropertyValidator)(properties.payload)), errors.collect(cdk.propertyValidator("tableName", cdk.requiredValidator)(properties.tableName)), errors.collect(cdk.propertyValidator("tableName", cdk.validateString)(properties.tableName)), errors.wrap('supplied properties not correct for "DynamoDBv2Property"');
    }
    function cfnAlarmModelDynamoDBv2PropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlarmModel_DynamoDBv2PropertyValidator(properties).assertSuccess(), { Payload: cfnAlarmModelPayloadPropertyToCloudFormation(properties.payload), TableName: cdk.stringToCloudFormation(properties.tableName) }) : properties;
    }
    function CfnAlarmModelDynamoDBv2PropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("payload", "Payload", properties.Payload != null ? CfnAlarmModelPayloadPropertyFromCloudFormation(properties.Payload) : void 0), ret.addPropertyResult("tableName", "TableName", cfn_parse.FromCloudFormation.getString(properties.TableName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAlarmModel_FirehosePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deliveryStreamName", cdk.requiredValidator)(properties.deliveryStreamName)), errors.collect(cdk.propertyValidator("deliveryStreamName", cdk.validateString)(properties.deliveryStreamName)), errors.collect(cdk.propertyValidator("payload", CfnAlarmModel_PayloadPropertyValidator)(properties.payload)), errors.collect(cdk.propertyValidator("separator", cdk.validateString)(properties.separator)), errors.wrap('supplied properties not correct for "FirehoseProperty"');
    }
    function cfnAlarmModelFirehosePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlarmModel_FirehosePropertyValidator(properties).assertSuccess(), { DeliveryStreamName: cdk.stringToCloudFormation(properties.deliveryStreamName), Payload: cfnAlarmModelPayloadPropertyToCloudFormation(properties.payload), Separator: cdk.stringToCloudFormation(properties.separator) }) : properties;
    }
    function CfnAlarmModelFirehosePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deliveryStreamName", "DeliveryStreamName", cfn_parse.FromCloudFormation.getString(properties.DeliveryStreamName)), ret.addPropertyResult("payload", "Payload", properties.Payload != null ? CfnAlarmModelPayloadPropertyFromCloudFormation(properties.Payload) : void 0), ret.addPropertyResult("separator", "Separator", properties.Separator != null ? cfn_parse.FromCloudFormation.getString(properties.Separator) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAlarmModel_InitializationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("disabledOnInitialization", cdk.requiredValidator)(properties.disabledOnInitialization)), errors.collect(cdk.propertyValidator("disabledOnInitialization", cdk.validateBoolean)(properties.disabledOnInitialization)), errors.wrap('supplied properties not correct for "InitializationConfigurationProperty"');
    }
    function cfnAlarmModelInitializationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlarmModel_InitializationConfigurationPropertyValidator(properties).assertSuccess(), { DisabledOnInitialization: cdk.booleanToCloudFormation(properties.disabledOnInitialization) }) : properties;
    }
    function CfnAlarmModelInitializationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("disabledOnInitialization", "DisabledOnInitialization", cfn_parse.FromCloudFormation.getBoolean(properties.DisabledOnInitialization)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAlarmModel_IotEventsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("inputName", cdk.requiredValidator)(properties.inputName)), errors.collect(cdk.propertyValidator("inputName", cdk.validateString)(properties.inputName)), errors.collect(cdk.propertyValidator("payload", CfnAlarmModel_PayloadPropertyValidator)(properties.payload)), errors.wrap('supplied properties not correct for "IotEventsProperty"');
    }
    function cfnAlarmModelIotEventsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlarmModel_IotEventsPropertyValidator(properties).assertSuccess(), { InputName: cdk.stringToCloudFormation(properties.inputName), Payload: cfnAlarmModelPayloadPropertyToCloudFormation(properties.payload) }) : properties;
    }
    function CfnAlarmModelIotEventsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("inputName", "InputName", cfn_parse.FromCloudFormation.getString(properties.InputName)), ret.addPropertyResult("payload", "Payload", properties.Payload != null ? CfnAlarmModelPayloadPropertyFromCloudFormation(properties.Payload) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAlarmModel_IotSiteWisePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("assetId", cdk.validateString)(properties.assetId)), errors.collect(cdk.propertyValidator("entryId", cdk.validateString)(properties.entryId)), errors.collect(cdk.propertyValidator("propertyAlias", cdk.validateString)(properties.propertyAlias)), errors.collect(cdk.propertyValidator("propertyId", cdk.validateString)(properties.propertyId)), errors.collect(cdk.propertyValidator("propertyValue", CfnAlarmModel_AssetPropertyValuePropertyValidator)(properties.propertyValue)), errors.wrap('supplied properties not correct for "IotSiteWiseProperty"');
    }
    function cfnAlarmModelIotSiteWisePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlarmModel_IotSiteWisePropertyValidator(properties).assertSuccess(), { AssetId: cdk.stringToCloudFormation(properties.assetId), EntryId: cdk.stringToCloudFormation(properties.entryId), PropertyAlias: cdk.stringToCloudFormation(properties.propertyAlias), PropertyId: cdk.stringToCloudFormation(properties.propertyId), PropertyValue: cfnAlarmModelAssetPropertyValuePropertyToCloudFormation(properties.propertyValue) }) : properties;
    }
    function CfnAlarmModelIotSiteWisePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("assetId", "AssetId", properties.AssetId != null ? cfn_parse.FromCloudFormation.getString(properties.AssetId) : void 0), ret.addPropertyResult("entryId", "EntryId", properties.EntryId != null ? cfn_parse.FromCloudFormation.getString(properties.EntryId) : void 0), ret.addPropertyResult("propertyAlias", "PropertyAlias", properties.PropertyAlias != null ? cfn_parse.FromCloudFormation.getString(properties.PropertyAlias) : void 0), ret.addPropertyResult("propertyId", "PropertyId", properties.PropertyId != null ? cfn_parse.FromCloudFormation.getString(properties.PropertyId) : void 0), ret.addPropertyResult("propertyValue", "PropertyValue", properties.PropertyValue != null ? CfnAlarmModelAssetPropertyValuePropertyFromCloudFormation(properties.PropertyValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAlarmModel_IotTopicPublishPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mqttTopic", cdk.requiredValidator)(properties.mqttTopic)), errors.collect(cdk.propertyValidator("mqttTopic", cdk.validateString)(properties.mqttTopic)), errors.collect(cdk.propertyValidator("payload", CfnAlarmModel_PayloadPropertyValidator)(properties.payload)), errors.wrap('supplied properties not correct for "IotTopicPublishProperty"');
    }
    function cfnAlarmModelIotTopicPublishPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlarmModel_IotTopicPublishPropertyValidator(properties).assertSuccess(), { MqttTopic: cdk.stringToCloudFormation(properties.mqttTopic), Payload: cfnAlarmModelPayloadPropertyToCloudFormation(properties.payload) }) : properties;
    }
    function CfnAlarmModelIotTopicPublishPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mqttTopic", "MqttTopic", cfn_parse.FromCloudFormation.getString(properties.MqttTopic)), ret.addPropertyResult("payload", "Payload", properties.Payload != null ? CfnAlarmModelPayloadPropertyFromCloudFormation(properties.Payload) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAlarmModel_LambdaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("functionArn", cdk.requiredValidator)(properties.functionArn)), errors.collect(cdk.propertyValidator("functionArn", cdk.validateString)(properties.functionArn)), errors.collect(cdk.propertyValidator("payload", CfnAlarmModel_PayloadPropertyValidator)(properties.payload)), errors.wrap('supplied properties not correct for "LambdaProperty"');
    }
    function cfnAlarmModelLambdaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlarmModel_LambdaPropertyValidator(properties).assertSuccess(), { FunctionArn: cdk.stringToCloudFormation(properties.functionArn), Payload: cfnAlarmModelPayloadPropertyToCloudFormation(properties.payload) }) : properties;
    }
    function CfnAlarmModelLambdaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("functionArn", "FunctionArn", cfn_parse.FromCloudFormation.getString(properties.FunctionArn)), ret.addPropertyResult("payload", "Payload", properties.Payload != null ? CfnAlarmModelPayloadPropertyFromCloudFormation(properties.Payload) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAlarmModel_PayloadPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contentExpression", cdk.requiredValidator)(properties.contentExpression)), errors.collect(cdk.propertyValidator("contentExpression", cdk.validateString)(properties.contentExpression)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "PayloadProperty"');
    }
    function cfnAlarmModelPayloadPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlarmModel_PayloadPropertyValidator(properties).assertSuccess(), { ContentExpression: cdk.stringToCloudFormation(properties.contentExpression), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnAlarmModelPayloadPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contentExpression", "ContentExpression", cfn_parse.FromCloudFormation.getString(properties.ContentExpression)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAlarmModel_SimpleRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("comparisonOperator", cdk.requiredValidator)(properties.comparisonOperator)), errors.collect(cdk.propertyValidator("comparisonOperator", cdk.validateString)(properties.comparisonOperator)), errors.collect(cdk.propertyValidator("inputProperty", cdk.requiredValidator)(properties.inputProperty)), errors.collect(cdk.propertyValidator("inputProperty", cdk.validateString)(properties.inputProperty)), errors.collect(cdk.propertyValidator("threshold", cdk.requiredValidator)(properties.threshold)), errors.collect(cdk.propertyValidator("threshold", cdk.validateString)(properties.threshold)), errors.wrap('supplied properties not correct for "SimpleRuleProperty"');
    }
    function cfnAlarmModelSimpleRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlarmModel_SimpleRulePropertyValidator(properties).assertSuccess(), { ComparisonOperator: cdk.stringToCloudFormation(properties.comparisonOperator), InputProperty: cdk.stringToCloudFormation(properties.inputProperty), Threshold: cdk.stringToCloudFormation(properties.threshold) }) : properties;
    }
    function CfnAlarmModelSimpleRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("comparisonOperator", "ComparisonOperator", cfn_parse.FromCloudFormation.getString(properties.ComparisonOperator)), ret.addPropertyResult("inputProperty", "InputProperty", cfn_parse.FromCloudFormation.getString(properties.InputProperty)), ret.addPropertyResult("threshold", "Threshold", cfn_parse.FromCloudFormation.getString(properties.Threshold)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAlarmModel_SnsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("payload", CfnAlarmModel_PayloadPropertyValidator)(properties.payload)), errors.collect(cdk.propertyValidator("targetArn", cdk.requiredValidator)(properties.targetArn)), errors.collect(cdk.propertyValidator("targetArn", cdk.validateString)(properties.targetArn)), errors.wrap('supplied properties not correct for "SnsProperty"');
    }
    function cfnAlarmModelSnsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlarmModel_SnsPropertyValidator(properties).assertSuccess(), { Payload: cfnAlarmModelPayloadPropertyToCloudFormation(properties.payload), TargetArn: cdk.stringToCloudFormation(properties.targetArn) }) : properties;
    }
    function CfnAlarmModelSnsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("payload", "Payload", properties.Payload != null ? CfnAlarmModelPayloadPropertyFromCloudFormation(properties.Payload) : void 0), ret.addPropertyResult("targetArn", "TargetArn", cfn_parse.FromCloudFormation.getString(properties.TargetArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAlarmModel_SqsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("payload", CfnAlarmModel_PayloadPropertyValidator)(properties.payload)), errors.collect(cdk.propertyValidator("queueUrl", cdk.requiredValidator)(properties.queueUrl)), errors.collect(cdk.propertyValidator("queueUrl", cdk.validateString)(properties.queueUrl)), errors.collect(cdk.propertyValidator("useBase64", cdk.validateBoolean)(properties.useBase64)), errors.wrap('supplied properties not correct for "SqsProperty"');
    }
    function cfnAlarmModelSqsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlarmModel_SqsPropertyValidator(properties).assertSuccess(), { Payload: cfnAlarmModelPayloadPropertyToCloudFormation(properties.payload), QueueUrl: cdk.stringToCloudFormation(properties.queueUrl), UseBase64: cdk.booleanToCloudFormation(properties.useBase64) }) : properties;
    }
    function CfnAlarmModelSqsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("payload", "Payload", properties.Payload != null ? CfnAlarmModelPayloadPropertyFromCloudFormation(properties.Payload) : void 0), ret.addPropertyResult("queueUrl", "QueueUrl", cfn_parse.FromCloudFormation.getString(properties.QueueUrl)), ret.addPropertyResult("useBase64", "UseBase64", properties.UseBase64 != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseBase64) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetectorModelPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("detectorModelDefinition", cdk.requiredValidator)(properties.detectorModelDefinition)), errors.collect(cdk.propertyValidator("detectorModelDefinition", CfnDetectorModel_DetectorModelDefinitionPropertyValidator)(properties.detectorModelDefinition)), errors.collect(cdk.propertyValidator("detectorModelDescription", cdk.validateString)(properties.detectorModelDescription)), errors.collect(cdk.propertyValidator("detectorModelName", cdk.validateString)(properties.detectorModelName)), errors.collect(cdk.propertyValidator("evaluationMethod", cdk.validateString)(properties.evaluationMethod)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDetectorModelProps"');
    }
    function cfnDetectorModelPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetectorModelPropsValidator(properties).assertSuccess(), { DetectorModelDefinition: cfnDetectorModelDetectorModelDefinitionPropertyToCloudFormation(properties.detectorModelDefinition), RoleArn: cdk.stringToCloudFormation(properties.roleArn), DetectorModelDescription: cdk.stringToCloudFormation(properties.detectorModelDescription), DetectorModelName: cdk.stringToCloudFormation(properties.detectorModelName), EvaluationMethod: cdk.stringToCloudFormation(properties.evaluationMethod), Key: cdk.stringToCloudFormation(properties.key), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDetectorModelPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("detectorModelDefinition", "DetectorModelDefinition", CfnDetectorModelDetectorModelDefinitionPropertyFromCloudFormation(properties.DetectorModelDefinition)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("detectorModelDescription", "DetectorModelDescription", properties.DetectorModelDescription != null ? cfn_parse.FromCloudFormation.getString(properties.DetectorModelDescription) : void 0), ret.addPropertyResult("detectorModelName", "DetectorModelName", properties.DetectorModelName != null ? cfn_parse.FromCloudFormation.getString(properties.DetectorModelName) : void 0), ret.addPropertyResult("evaluationMethod", "EvaluationMethod", properties.EvaluationMethod != null ? cfn_parse.FromCloudFormation.getString(properties.EvaluationMethod) : void 0), ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDetectorModel = class _CfnDetectorModel extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDetectorModelPropsFromCloudFormation(resourceProperties), ret = new _CfnDetectorModel(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDetectorModel.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotevents_CfnDetectorModelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDetectorModel), error;
        }
        cdk.requireProperty(props, "detectorModelDefinition", this), cdk.requireProperty(props, "roleArn", this), this.detectorModelDefinition = props.detectorModelDefinition, this.roleArn = props.roleArn, this.detectorModelDescription = props.detectorModelDescription, this.detectorModelName = props.detectorModelName, this.evaluationMethod = props.evaluationMethod, this.key = props.key, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTEvents::DetectorModel", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDetectorModel.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { detectorModelDefinition: this.detectorModelDefinition, roleArn: this.roleArn, detectorModelDescription: this.detectorModelDescription, detectorModelName: this.detectorModelName, evaluationMethod: this.evaluationMethod, key: this.key, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDetectorModelPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnDetectorModel[_b] = { fqn: "aws-cdk-lib.aws_iotevents.CfnDetectorModel", version: "2.80.0" }, CfnDetectorModel.CFN_RESOURCE_TYPE_NAME = "AWS::IoTEvents::DetectorModel", exports2.CfnDetectorModel = CfnDetectorModel;
    function CfnDetectorModel_ActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clearTimer", CfnDetectorModel_ClearTimerPropertyValidator)(properties.clearTimer)), errors.collect(cdk.propertyValidator("dynamoDb", CfnDetectorModel_DynamoDBPropertyValidator)(properties.dynamoDb)), errors.collect(cdk.propertyValidator("dynamoDBv2", CfnDetectorModel_DynamoDBv2PropertyValidator)(properties.dynamoDBv2)), errors.collect(cdk.propertyValidator("firehose", CfnDetectorModel_FirehosePropertyValidator)(properties.firehose)), errors.collect(cdk.propertyValidator("iotEvents", CfnDetectorModel_IotEventsPropertyValidator)(properties.iotEvents)), errors.collect(cdk.propertyValidator("iotSiteWise", CfnDetectorModel_IotSiteWisePropertyValidator)(properties.iotSiteWise)), errors.collect(cdk.propertyValidator("iotTopicPublish", CfnDetectorModel_IotTopicPublishPropertyValidator)(properties.iotTopicPublish)), errors.collect(cdk.propertyValidator("lambda", CfnDetectorModel_LambdaPropertyValidator)(properties.lambda)), errors.collect(cdk.propertyValidator("resetTimer", CfnDetectorModel_ResetTimerPropertyValidator)(properties.resetTimer)), errors.collect(cdk.propertyValidator("setTimer", CfnDetectorModel_SetTimerPropertyValidator)(properties.setTimer)), errors.collect(cdk.propertyValidator("setVariable", CfnDetectorModel_SetVariablePropertyValidator)(properties.setVariable)), errors.collect(cdk.propertyValidator("sns", CfnDetectorModel_SnsPropertyValidator)(properties.sns)), errors.collect(cdk.propertyValidator("sqs", CfnDetectorModel_SqsPropertyValidator)(properties.sqs)), errors.wrap('supplied properties not correct for "ActionProperty"');
    }
    function cfnDetectorModelActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetectorModel_ActionPropertyValidator(properties).assertSuccess(), { ClearTimer: cfnDetectorModelClearTimerPropertyToCloudFormation(properties.clearTimer), DynamoDB: cfnDetectorModelDynamoDBPropertyToCloudFormation(properties.dynamoDb), DynamoDBv2: cfnDetectorModelDynamoDBv2PropertyToCloudFormation(properties.dynamoDBv2), Firehose: cfnDetectorModelFirehosePropertyToCloudFormation(properties.firehose), IotEvents: cfnDetectorModelIotEventsPropertyToCloudFormation(properties.iotEvents), IotSiteWise: cfnDetectorModelIotSiteWisePropertyToCloudFormation(properties.iotSiteWise), IotTopicPublish: cfnDetectorModelIotTopicPublishPropertyToCloudFormation(properties.iotTopicPublish), Lambda: cfnDetectorModelLambdaPropertyToCloudFormation(properties.lambda), ResetTimer: cfnDetectorModelResetTimerPropertyToCloudFormation(properties.resetTimer), SetTimer: cfnDetectorModelSetTimerPropertyToCloudFormation(properties.setTimer), SetVariable: cfnDetectorModelSetVariablePropertyToCloudFormation(properties.setVariable), Sns: cfnDetectorModelSnsPropertyToCloudFormation(properties.sns), Sqs: cfnDetectorModelSqsPropertyToCloudFormation(properties.sqs) }) : properties;
    }
    function CfnDetectorModelActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clearTimer", "ClearTimer", properties.ClearTimer != null ? CfnDetectorModelClearTimerPropertyFromCloudFormation(properties.ClearTimer) : void 0), ret.addPropertyResult("dynamoDb", "DynamoDB", properties.DynamoDB != null ? CfnDetectorModelDynamoDBPropertyFromCloudFormation(properties.DynamoDB) : void 0), ret.addPropertyResult("dynamoDBv2", "DynamoDBv2", properties.DynamoDBv2 != null ? CfnDetectorModelDynamoDBv2PropertyFromCloudFormation(properties.DynamoDBv2) : void 0), ret.addPropertyResult("firehose", "Firehose", properties.Firehose != null ? CfnDetectorModelFirehosePropertyFromCloudFormation(properties.Firehose) : void 0), ret.addPropertyResult("iotEvents", "IotEvents", properties.IotEvents != null ? CfnDetectorModelIotEventsPropertyFromCloudFormation(properties.IotEvents) : void 0), ret.addPropertyResult("iotSiteWise", "IotSiteWise", properties.IotSiteWise != null ? CfnDetectorModelIotSiteWisePropertyFromCloudFormation(properties.IotSiteWise) : void 0), ret.addPropertyResult("iotTopicPublish", "IotTopicPublish", properties.IotTopicPublish != null ? CfnDetectorModelIotTopicPublishPropertyFromCloudFormation(properties.IotTopicPublish) : void 0), ret.addPropertyResult("lambda", "Lambda", properties.Lambda != null ? CfnDetectorModelLambdaPropertyFromCloudFormation(properties.Lambda) : void 0), ret.addPropertyResult("resetTimer", "ResetTimer", properties.ResetTimer != null ? CfnDetectorModelResetTimerPropertyFromCloudFormation(properties.ResetTimer) : void 0), ret.addPropertyResult("setTimer", "SetTimer", properties.SetTimer != null ? CfnDetectorModelSetTimerPropertyFromCloudFormation(properties.SetTimer) : void 0), ret.addPropertyResult("setVariable", "SetVariable", properties.SetVariable != null ? CfnDetectorModelSetVariablePropertyFromCloudFormation(properties.SetVariable) : void 0), ret.addPropertyResult("sns", "Sns", properties.Sns != null ? CfnDetectorModelSnsPropertyFromCloudFormation(properties.Sns) : void 0), ret.addPropertyResult("sqs", "Sqs", properties.Sqs != null ? CfnDetectorModelSqsPropertyFromCloudFormation(properties.Sqs) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetectorModel_AssetPropertyTimestampPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("offsetInNanos", cdk.validateString)(properties.offsetInNanos)), errors.collect(cdk.propertyValidator("timeInSeconds", cdk.requiredValidator)(properties.timeInSeconds)), errors.collect(cdk.propertyValidator("timeInSeconds", cdk.validateString)(properties.timeInSeconds)), errors.wrap('supplied properties not correct for "AssetPropertyTimestampProperty"');
    }
    function cfnDetectorModelAssetPropertyTimestampPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetectorModel_AssetPropertyTimestampPropertyValidator(properties).assertSuccess(), { OffsetInNanos: cdk.stringToCloudFormation(properties.offsetInNanos), TimeInSeconds: cdk.stringToCloudFormation(properties.timeInSeconds) }) : properties;
    }
    function CfnDetectorModelAssetPropertyTimestampPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("offsetInNanos", "OffsetInNanos", properties.OffsetInNanos != null ? cfn_parse.FromCloudFormation.getString(properties.OffsetInNanos) : void 0), ret.addPropertyResult("timeInSeconds", "TimeInSeconds", cfn_parse.FromCloudFormation.getString(properties.TimeInSeconds)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetectorModel_AssetPropertyValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("quality", cdk.validateString)(properties.quality)), errors.collect(cdk.propertyValidator("timestamp", CfnDetectorModel_AssetPropertyTimestampPropertyValidator)(properties.timestamp)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", CfnDetectorModel_AssetPropertyVariantPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "AssetPropertyValueProperty"');
    }
    function cfnDetectorModelAssetPropertyValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetectorModel_AssetPropertyValuePropertyValidator(properties).assertSuccess(), { Quality: cdk.stringToCloudFormation(properties.quality), Timestamp: cfnDetectorModelAssetPropertyTimestampPropertyToCloudFormation(properties.timestamp), Value: cfnDetectorModelAssetPropertyVariantPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnDetectorModelAssetPropertyValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("quality", "Quality", properties.Quality != null ? cfn_parse.FromCloudFormation.getString(properties.Quality) : void 0), ret.addPropertyResult("timestamp", "Timestamp", properties.Timestamp != null ? CfnDetectorModelAssetPropertyTimestampPropertyFromCloudFormation(properties.Timestamp) : void 0), ret.addPropertyResult("value", "Value", CfnDetectorModelAssetPropertyVariantPropertyFromCloudFormation(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetectorModel_AssetPropertyVariantPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("booleanValue", cdk.validateString)(properties.booleanValue)), errors.collect(cdk.propertyValidator("doubleValue", cdk.validateString)(properties.doubleValue)), errors.collect(cdk.propertyValidator("integerValue", cdk.validateString)(properties.integerValue)), errors.collect(cdk.propertyValidator("stringValue", cdk.validateString)(properties.stringValue)), errors.wrap('supplied properties not correct for "AssetPropertyVariantProperty"');
    }
    function cfnDetectorModelAssetPropertyVariantPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetectorModel_AssetPropertyVariantPropertyValidator(properties).assertSuccess(), { BooleanValue: cdk.stringToCloudFormation(properties.booleanValue), DoubleValue: cdk.stringToCloudFormation(properties.doubleValue), IntegerValue: cdk.stringToCloudFormation(properties.integerValue), StringValue: cdk.stringToCloudFormation(properties.stringValue) }) : properties;
    }
    function CfnDetectorModelAssetPropertyVariantPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("booleanValue", "BooleanValue", properties.BooleanValue != null ? cfn_parse.FromCloudFormation.getString(properties.BooleanValue) : void 0), ret.addPropertyResult("doubleValue", "DoubleValue", properties.DoubleValue != null ? cfn_parse.FromCloudFormation.getString(properties.DoubleValue) : void 0), ret.addPropertyResult("integerValue", "IntegerValue", properties.IntegerValue != null ? cfn_parse.FromCloudFormation.getString(properties.IntegerValue) : void 0), ret.addPropertyResult("stringValue", "StringValue", properties.StringValue != null ? cfn_parse.FromCloudFormation.getString(properties.StringValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetectorModel_ClearTimerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("timerName", cdk.requiredValidator)(properties.timerName)), errors.collect(cdk.propertyValidator("timerName", cdk.validateString)(properties.timerName)), errors.wrap('supplied properties not correct for "ClearTimerProperty"');
    }
    function cfnDetectorModelClearTimerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetectorModel_ClearTimerPropertyValidator(properties).assertSuccess(), { TimerName: cdk.stringToCloudFormation(properties.timerName) }) : properties;
    }
    function CfnDetectorModelClearTimerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("timerName", "TimerName", cfn_parse.FromCloudFormation.getString(properties.TimerName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetectorModel_DetectorModelDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("initialStateName", cdk.requiredValidator)(properties.initialStateName)), errors.collect(cdk.propertyValidator("initialStateName", cdk.validateString)(properties.initialStateName)), errors.collect(cdk.propertyValidator("states", cdk.requiredValidator)(properties.states)), errors.collect(cdk.propertyValidator("states", cdk.listValidator(CfnDetectorModel_StatePropertyValidator))(properties.states)), errors.wrap('supplied properties not correct for "DetectorModelDefinitionProperty"');
    }
    function cfnDetectorModelDetectorModelDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetectorModel_DetectorModelDefinitionPropertyValidator(properties).assertSuccess(), { InitialStateName: cdk.stringToCloudFormation(properties.initialStateName), States: cdk.listMapper(cfnDetectorModelStatePropertyToCloudFormation)(properties.states) }) : properties;
    }
    function CfnDetectorModelDetectorModelDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("initialStateName", "InitialStateName", cfn_parse.FromCloudFormation.getString(properties.InitialStateName)), ret.addPropertyResult("states", "States", cfn_parse.FromCloudFormation.getArray(CfnDetectorModelStatePropertyFromCloudFormation)(properties.States)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetectorModel_DynamoDBPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("hashKeyField", cdk.requiredValidator)(properties.hashKeyField)), errors.collect(cdk.propertyValidator("hashKeyField", cdk.validateString)(properties.hashKeyField)), errors.collect(cdk.propertyValidator("hashKeyType", cdk.validateString)(properties.hashKeyType)), errors.collect(cdk.propertyValidator("hashKeyValue", cdk.requiredValidator)(properties.hashKeyValue)), errors.collect(cdk.propertyValidator("hashKeyValue", cdk.validateString)(properties.hashKeyValue)), errors.collect(cdk.propertyValidator("operation", cdk.validateString)(properties.operation)), errors.collect(cdk.propertyValidator("payload", CfnDetectorModel_PayloadPropertyValidator)(properties.payload)), errors.collect(cdk.propertyValidator("payloadField", cdk.validateString)(properties.payloadField)), errors.collect(cdk.propertyValidator("rangeKeyField", cdk.validateString)(properties.rangeKeyField)), errors.collect(cdk.propertyValidator("rangeKeyType", cdk.validateString)(properties.rangeKeyType)), errors.collect(cdk.propertyValidator("rangeKeyValue", cdk.validateString)(properties.rangeKeyValue)), errors.collect(cdk.propertyValidator("tableName", cdk.requiredValidator)(properties.tableName)), errors.collect(cdk.propertyValidator("tableName", cdk.validateString)(properties.tableName)), errors.wrap('supplied properties not correct for "DynamoDBProperty"');
    }
    function cfnDetectorModelDynamoDBPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetectorModel_DynamoDBPropertyValidator(properties).assertSuccess(), { HashKeyField: cdk.stringToCloudFormation(properties.hashKeyField), HashKeyType: cdk.stringToCloudFormation(properties.hashKeyType), HashKeyValue: cdk.stringToCloudFormation(properties.hashKeyValue), Operation: cdk.stringToCloudFormation(properties.operation), Payload: cfnDetectorModelPayloadPropertyToCloudFormation(properties.payload), PayloadField: cdk.stringToCloudFormation(properties.payloadField), RangeKeyField: cdk.stringToCloudFormation(properties.rangeKeyField), RangeKeyType: cdk.stringToCloudFormation(properties.rangeKeyType), RangeKeyValue: cdk.stringToCloudFormation(properties.rangeKeyValue), TableName: cdk.stringToCloudFormation(properties.tableName) }) : properties;
    }
    function CfnDetectorModelDynamoDBPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("hashKeyField", "HashKeyField", cfn_parse.FromCloudFormation.getString(properties.HashKeyField)), ret.addPropertyResult("hashKeyType", "HashKeyType", properties.HashKeyType != null ? cfn_parse.FromCloudFormation.getString(properties.HashKeyType) : void 0), ret.addPropertyResult("hashKeyValue", "HashKeyValue", cfn_parse.FromCloudFormation.getString(properties.HashKeyValue)), ret.addPropertyResult("operation", "Operation", properties.Operation != null ? cfn_parse.FromCloudFormation.getString(properties.Operation) : void 0), ret.addPropertyResult("payload", "Payload", properties.Payload != null ? CfnDetectorModelPayloadPropertyFromCloudFormation(properties.Payload) : void 0), ret.addPropertyResult("payloadField", "PayloadField", properties.PayloadField != null ? cfn_parse.FromCloudFormation.getString(properties.PayloadField) : void 0), ret.addPropertyResult("rangeKeyField", "RangeKeyField", properties.RangeKeyField != null ? cfn_parse.FromCloudFormation.getString(properties.RangeKeyField) : void 0), ret.addPropertyResult("rangeKeyType", "RangeKeyType", properties.RangeKeyType != null ? cfn_parse.FromCloudFormation.getString(properties.RangeKeyType) : void 0), ret.addPropertyResult("rangeKeyValue", "RangeKeyValue", properties.RangeKeyValue != null ? cfn_parse.FromCloudFormation.getString(properties.RangeKeyValue) : void 0), ret.addPropertyResult("tableName", "TableName", cfn_parse.FromCloudFormation.getString(properties.TableName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetectorModel_DynamoDBv2PropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("payload", CfnDetectorModel_PayloadPropertyValidator)(properties.payload)), errors.collect(cdk.propertyValidator("tableName", cdk.requiredValidator)(properties.tableName)), errors.collect(cdk.propertyValidator("tableName", cdk.validateString)(properties.tableName)), errors.wrap('supplied properties not correct for "DynamoDBv2Property"');
    }
    function cfnDetectorModelDynamoDBv2PropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetectorModel_DynamoDBv2PropertyValidator(properties).assertSuccess(), { Payload: cfnDetectorModelPayloadPropertyToCloudFormation(properties.payload), TableName: cdk.stringToCloudFormation(properties.tableName) }) : properties;
    }
    function CfnDetectorModelDynamoDBv2PropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("payload", "Payload", properties.Payload != null ? CfnDetectorModelPayloadPropertyFromCloudFormation(properties.Payload) : void 0), ret.addPropertyResult("tableName", "TableName", cfn_parse.FromCloudFormation.getString(properties.TableName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetectorModel_EventPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnDetectorModel_ActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("condition", cdk.validateString)(properties.condition)), errors.collect(cdk.propertyValidator("eventName", cdk.requiredValidator)(properties.eventName)), errors.collect(cdk.propertyValidator("eventName", cdk.validateString)(properties.eventName)), errors.wrap('supplied properties not correct for "EventProperty"');
    }
    function cfnDetectorModelEventPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetectorModel_EventPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnDetectorModelActionPropertyToCloudFormation)(properties.actions), Condition: cdk.stringToCloudFormation(properties.condition), EventName: cdk.stringToCloudFormation(properties.eventName) }) : properties;
    }
    function CfnDetectorModelEventPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnDetectorModelActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("condition", "Condition", properties.Condition != null ? cfn_parse.FromCloudFormation.getString(properties.Condition) : void 0), ret.addPropertyResult("eventName", "EventName", cfn_parse.FromCloudFormation.getString(properties.EventName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetectorModel_FirehosePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deliveryStreamName", cdk.requiredValidator)(properties.deliveryStreamName)), errors.collect(cdk.propertyValidator("deliveryStreamName", cdk.validateString)(properties.deliveryStreamName)), errors.collect(cdk.propertyValidator("payload", CfnDetectorModel_PayloadPropertyValidator)(properties.payload)), errors.collect(cdk.propertyValidator("separator", cdk.validateString)(properties.separator)), errors.wrap('supplied properties not correct for "FirehoseProperty"');
    }
    function cfnDetectorModelFirehosePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetectorModel_FirehosePropertyValidator(properties).assertSuccess(), { DeliveryStreamName: cdk.stringToCloudFormation(properties.deliveryStreamName), Payload: cfnDetectorModelPayloadPropertyToCloudFormation(properties.payload), Separator: cdk.stringToCloudFormation(properties.separator) }) : properties;
    }
    function CfnDetectorModelFirehosePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deliveryStreamName", "DeliveryStreamName", cfn_parse.FromCloudFormation.getString(properties.DeliveryStreamName)), ret.addPropertyResult("payload", "Payload", properties.Payload != null ? CfnDetectorModelPayloadPropertyFromCloudFormation(properties.Payload) : void 0), ret.addPropertyResult("separator", "Separator", properties.Separator != null ? cfn_parse.FromCloudFormation.getString(properties.Separator) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetectorModel_IotEventsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("inputName", cdk.requiredValidator)(properties.inputName)), errors.collect(cdk.propertyValidator("inputName", cdk.validateString)(properties.inputName)), errors.collect(cdk.propertyValidator("payload", CfnDetectorModel_PayloadPropertyValidator)(properties.payload)), errors.wrap('supplied properties not correct for "IotEventsProperty"');
    }
    function cfnDetectorModelIotEventsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetectorModel_IotEventsPropertyValidator(properties).assertSuccess(), { InputName: cdk.stringToCloudFormation(properties.inputName), Payload: cfnDetectorModelPayloadPropertyToCloudFormation(properties.payload) }) : properties;
    }
    function CfnDetectorModelIotEventsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("inputName", "InputName", cfn_parse.FromCloudFormation.getString(properties.InputName)), ret.addPropertyResult("payload", "Payload", properties.Payload != null ? CfnDetectorModelPayloadPropertyFromCloudFormation(properties.Payload) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetectorModel_IotSiteWisePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("assetId", cdk.validateString)(properties.assetId)), errors.collect(cdk.propertyValidator("entryId", cdk.validateString)(properties.entryId)), errors.collect(cdk.propertyValidator("propertyAlias", cdk.validateString)(properties.propertyAlias)), errors.collect(cdk.propertyValidator("propertyId", cdk.validateString)(properties.propertyId)), errors.collect(cdk.propertyValidator("propertyValue", cdk.requiredValidator)(properties.propertyValue)), errors.collect(cdk.propertyValidator("propertyValue", CfnDetectorModel_AssetPropertyValuePropertyValidator)(properties.propertyValue)), errors.wrap('supplied properties not correct for "IotSiteWiseProperty"');
    }
    function cfnDetectorModelIotSiteWisePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetectorModel_IotSiteWisePropertyValidator(properties).assertSuccess(), { AssetId: cdk.stringToCloudFormation(properties.assetId), EntryId: cdk.stringToCloudFormation(properties.entryId), PropertyAlias: cdk.stringToCloudFormation(properties.propertyAlias), PropertyId: cdk.stringToCloudFormation(properties.propertyId), PropertyValue: cfnDetectorModelAssetPropertyValuePropertyToCloudFormation(properties.propertyValue) }) : properties;
    }
    function CfnDetectorModelIotSiteWisePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("assetId", "AssetId", properties.AssetId != null ? cfn_parse.FromCloudFormation.getString(properties.AssetId) : void 0), ret.addPropertyResult("entryId", "EntryId", properties.EntryId != null ? cfn_parse.FromCloudFormation.getString(properties.EntryId) : void 0), ret.addPropertyResult("propertyAlias", "PropertyAlias", properties.PropertyAlias != null ? cfn_parse.FromCloudFormation.getString(properties.PropertyAlias) : void 0), ret.addPropertyResult("propertyId", "PropertyId", properties.PropertyId != null ? cfn_parse.FromCloudFormation.getString(properties.PropertyId) : void 0), ret.addPropertyResult("propertyValue", "PropertyValue", CfnDetectorModelAssetPropertyValuePropertyFromCloudFormation(properties.PropertyValue)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetectorModel_IotTopicPublishPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mqttTopic", cdk.requiredValidator)(properties.mqttTopic)), errors.collect(cdk.propertyValidator("mqttTopic", cdk.validateString)(properties.mqttTopic)), errors.collect(cdk.propertyValidator("payload", CfnDetectorModel_PayloadPropertyValidator)(properties.payload)), errors.wrap('supplied properties not correct for "IotTopicPublishProperty"');
    }
    function cfnDetectorModelIotTopicPublishPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetectorModel_IotTopicPublishPropertyValidator(properties).assertSuccess(), { MqttTopic: cdk.stringToCloudFormation(properties.mqttTopic), Payload: cfnDetectorModelPayloadPropertyToCloudFormation(properties.payload) }) : properties;
    }
    function CfnDetectorModelIotTopicPublishPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mqttTopic", "MqttTopic", cfn_parse.FromCloudFormation.getString(properties.MqttTopic)), ret.addPropertyResult("payload", "Payload", properties.Payload != null ? CfnDetectorModelPayloadPropertyFromCloudFormation(properties.Payload) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetectorModel_LambdaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("functionArn", cdk.requiredValidator)(properties.functionArn)), errors.collect(cdk.propertyValidator("functionArn", cdk.validateString)(properties.functionArn)), errors.collect(cdk.propertyValidator("payload", CfnDetectorModel_PayloadPropertyValidator)(properties.payload)), errors.wrap('supplied properties not correct for "LambdaProperty"');
    }
    function cfnDetectorModelLambdaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetectorModel_LambdaPropertyValidator(properties).assertSuccess(), { FunctionArn: cdk.stringToCloudFormation(properties.functionArn), Payload: cfnDetectorModelPayloadPropertyToCloudFormation(properties.payload) }) : properties;
    }
    function CfnDetectorModelLambdaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("functionArn", "FunctionArn", cfn_parse.FromCloudFormation.getString(properties.FunctionArn)), ret.addPropertyResult("payload", "Payload", properties.Payload != null ? CfnDetectorModelPayloadPropertyFromCloudFormation(properties.Payload) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetectorModel_OnEnterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("events", cdk.listValidator(CfnDetectorModel_EventPropertyValidator))(properties.events)), errors.wrap('supplied properties not correct for "OnEnterProperty"');
    }
    function cfnDetectorModelOnEnterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetectorModel_OnEnterPropertyValidator(properties).assertSuccess(), { Events: cdk.listMapper(cfnDetectorModelEventPropertyToCloudFormation)(properties.events) }) : properties;
    }
    function CfnDetectorModelOnEnterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("events", "Events", properties.Events != null ? cfn_parse.FromCloudFormation.getArray(CfnDetectorModelEventPropertyFromCloudFormation)(properties.Events) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetectorModel_OnExitPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("events", cdk.listValidator(CfnDetectorModel_EventPropertyValidator))(properties.events)), errors.wrap('supplied properties not correct for "OnExitProperty"');
    }
    function cfnDetectorModelOnExitPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetectorModel_OnExitPropertyValidator(properties).assertSuccess(), { Events: cdk.listMapper(cfnDetectorModelEventPropertyToCloudFormation)(properties.events) }) : properties;
    }
    function CfnDetectorModelOnExitPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("events", "Events", properties.Events != null ? cfn_parse.FromCloudFormation.getArray(CfnDetectorModelEventPropertyFromCloudFormation)(properties.Events) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetectorModel_OnInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("events", cdk.listValidator(CfnDetectorModel_EventPropertyValidator))(properties.events)), errors.collect(cdk.propertyValidator("transitionEvents", cdk.listValidator(CfnDetectorModel_TransitionEventPropertyValidator))(properties.transitionEvents)), errors.wrap('supplied properties not correct for "OnInputProperty"');
    }
    function cfnDetectorModelOnInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetectorModel_OnInputPropertyValidator(properties).assertSuccess(), { Events: cdk.listMapper(cfnDetectorModelEventPropertyToCloudFormation)(properties.events), TransitionEvents: cdk.listMapper(cfnDetectorModelTransitionEventPropertyToCloudFormation)(properties.transitionEvents) }) : properties;
    }
    function CfnDetectorModelOnInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("events", "Events", properties.Events != null ? cfn_parse.FromCloudFormation.getArray(CfnDetectorModelEventPropertyFromCloudFormation)(properties.Events) : void 0), ret.addPropertyResult("transitionEvents", "TransitionEvents", properties.TransitionEvents != null ? cfn_parse.FromCloudFormation.getArray(CfnDetectorModelTransitionEventPropertyFromCloudFormation)(properties.TransitionEvents) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetectorModel_PayloadPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contentExpression", cdk.requiredValidator)(properties.contentExpression)), errors.collect(cdk.propertyValidator("contentExpression", cdk.validateString)(properties.contentExpression)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "PayloadProperty"');
    }
    function cfnDetectorModelPayloadPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetectorModel_PayloadPropertyValidator(properties).assertSuccess(), { ContentExpression: cdk.stringToCloudFormation(properties.contentExpression), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnDetectorModelPayloadPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contentExpression", "ContentExpression", cfn_parse.FromCloudFormation.getString(properties.ContentExpression)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetectorModel_ResetTimerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("timerName", cdk.requiredValidator)(properties.timerName)), errors.collect(cdk.propertyValidator("timerName", cdk.validateString)(properties.timerName)), errors.wrap('supplied properties not correct for "ResetTimerProperty"');
    }
    function cfnDetectorModelResetTimerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetectorModel_ResetTimerPropertyValidator(properties).assertSuccess(), { TimerName: cdk.stringToCloudFormation(properties.timerName) }) : properties;
    }
    function CfnDetectorModelResetTimerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("timerName", "TimerName", cfn_parse.FromCloudFormation.getString(properties.TimerName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetectorModel_SetTimerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("durationExpression", cdk.validateString)(properties.durationExpression)), errors.collect(cdk.propertyValidator("seconds", cdk.validateNumber)(properties.seconds)), errors.collect(cdk.propertyValidator("timerName", cdk.requiredValidator)(properties.timerName)), errors.collect(cdk.propertyValidator("timerName", cdk.validateString)(properties.timerName)), errors.wrap('supplied properties not correct for "SetTimerProperty"');
    }
    function cfnDetectorModelSetTimerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetectorModel_SetTimerPropertyValidator(properties).assertSuccess(), { DurationExpression: cdk.stringToCloudFormation(properties.durationExpression), Seconds: cdk.numberToCloudFormation(properties.seconds), TimerName: cdk.stringToCloudFormation(properties.timerName) }) : properties;
    }
    function CfnDetectorModelSetTimerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("durationExpression", "DurationExpression", properties.DurationExpression != null ? cfn_parse.FromCloudFormation.getString(properties.DurationExpression) : void 0), ret.addPropertyResult("seconds", "Seconds", properties.Seconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.Seconds) : void 0), ret.addPropertyResult("timerName", "TimerName", cfn_parse.FromCloudFormation.getString(properties.TimerName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetectorModel_SetVariablePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.collect(cdk.propertyValidator("variableName", cdk.requiredValidator)(properties.variableName)), errors.collect(cdk.propertyValidator("variableName", cdk.validateString)(properties.variableName)), errors.wrap('supplied properties not correct for "SetVariableProperty"');
    }
    function cfnDetectorModelSetVariablePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetectorModel_SetVariablePropertyValidator(properties).assertSuccess(), { Value: cdk.stringToCloudFormation(properties.value), VariableName: cdk.stringToCloudFormation(properties.variableName) }) : properties;
    }
    function CfnDetectorModelSetVariablePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addPropertyResult("variableName", "VariableName", cfn_parse.FromCloudFormation.getString(properties.VariableName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetectorModel_SnsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("payload", CfnDetectorModel_PayloadPropertyValidator)(properties.payload)), errors.collect(cdk.propertyValidator("targetArn", cdk.requiredValidator)(properties.targetArn)), errors.collect(cdk.propertyValidator("targetArn", cdk.validateString)(properties.targetArn)), errors.wrap('supplied properties not correct for "SnsProperty"');
    }
    function cfnDetectorModelSnsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetectorModel_SnsPropertyValidator(properties).assertSuccess(), { Payload: cfnDetectorModelPayloadPropertyToCloudFormation(properties.payload), TargetArn: cdk.stringToCloudFormation(properties.targetArn) }) : properties;
    }
    function CfnDetectorModelSnsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("payload", "Payload", properties.Payload != null ? CfnDetectorModelPayloadPropertyFromCloudFormation(properties.Payload) : void 0), ret.addPropertyResult("targetArn", "TargetArn", cfn_parse.FromCloudFormation.getString(properties.TargetArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetectorModel_SqsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("payload", CfnDetectorModel_PayloadPropertyValidator)(properties.payload)), errors.collect(cdk.propertyValidator("queueUrl", cdk.requiredValidator)(properties.queueUrl)), errors.collect(cdk.propertyValidator("queueUrl", cdk.validateString)(properties.queueUrl)), errors.collect(cdk.propertyValidator("useBase64", cdk.validateBoolean)(properties.useBase64)), errors.wrap('supplied properties not correct for "SqsProperty"');
    }
    function cfnDetectorModelSqsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetectorModel_SqsPropertyValidator(properties).assertSuccess(), { Payload: cfnDetectorModelPayloadPropertyToCloudFormation(properties.payload), QueueUrl: cdk.stringToCloudFormation(properties.queueUrl), UseBase64: cdk.booleanToCloudFormation(properties.useBase64) }) : properties;
    }
    function CfnDetectorModelSqsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("payload", "Payload", properties.Payload != null ? CfnDetectorModelPayloadPropertyFromCloudFormation(properties.Payload) : void 0), ret.addPropertyResult("queueUrl", "QueueUrl", cfn_parse.FromCloudFormation.getString(properties.QueueUrl)), ret.addPropertyResult("useBase64", "UseBase64", properties.UseBase64 != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseBase64) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetectorModel_StatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("onEnter", CfnDetectorModel_OnEnterPropertyValidator)(properties.onEnter)), errors.collect(cdk.propertyValidator("onExit", CfnDetectorModel_OnExitPropertyValidator)(properties.onExit)), errors.collect(cdk.propertyValidator("onInput", CfnDetectorModel_OnInputPropertyValidator)(properties.onInput)), errors.collect(cdk.propertyValidator("stateName", cdk.requiredValidator)(properties.stateName)), errors.collect(cdk.propertyValidator("stateName", cdk.validateString)(properties.stateName)), errors.wrap('supplied properties not correct for "StateProperty"');
    }
    function cfnDetectorModelStatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetectorModel_StatePropertyValidator(properties).assertSuccess(), { OnEnter: cfnDetectorModelOnEnterPropertyToCloudFormation(properties.onEnter), OnExit: cfnDetectorModelOnExitPropertyToCloudFormation(properties.onExit), OnInput: cfnDetectorModelOnInputPropertyToCloudFormation(properties.onInput), StateName: cdk.stringToCloudFormation(properties.stateName) }) : properties;
    }
    function CfnDetectorModelStatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("onEnter", "OnEnter", properties.OnEnter != null ? CfnDetectorModelOnEnterPropertyFromCloudFormation(properties.OnEnter) : void 0), ret.addPropertyResult("onExit", "OnExit", properties.OnExit != null ? CfnDetectorModelOnExitPropertyFromCloudFormation(properties.OnExit) : void 0), ret.addPropertyResult("onInput", "OnInput", properties.OnInput != null ? CfnDetectorModelOnInputPropertyFromCloudFormation(properties.OnInput) : void 0), ret.addPropertyResult("stateName", "StateName", cfn_parse.FromCloudFormation.getString(properties.StateName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDetectorModel_TransitionEventPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnDetectorModel_ActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("condition", cdk.requiredValidator)(properties.condition)), errors.collect(cdk.propertyValidator("condition", cdk.validateString)(properties.condition)), errors.collect(cdk.propertyValidator("eventName", cdk.requiredValidator)(properties.eventName)), errors.collect(cdk.propertyValidator("eventName", cdk.validateString)(properties.eventName)), errors.collect(cdk.propertyValidator("nextState", cdk.requiredValidator)(properties.nextState)), errors.collect(cdk.propertyValidator("nextState", cdk.validateString)(properties.nextState)), errors.wrap('supplied properties not correct for "TransitionEventProperty"');
    }
    function cfnDetectorModelTransitionEventPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDetectorModel_TransitionEventPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnDetectorModelActionPropertyToCloudFormation)(properties.actions), Condition: cdk.stringToCloudFormation(properties.condition), EventName: cdk.stringToCloudFormation(properties.eventName), NextState: cdk.stringToCloudFormation(properties.nextState) }) : properties;
    }
    function CfnDetectorModelTransitionEventPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnDetectorModelActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("condition", "Condition", cfn_parse.FromCloudFormation.getString(properties.Condition)), ret.addPropertyResult("eventName", "EventName", cfn_parse.FromCloudFormation.getString(properties.EventName)), ret.addPropertyResult("nextState", "NextState", cfn_parse.FromCloudFormation.getString(properties.NextState)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInputPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("inputDefinition", cdk.requiredValidator)(properties.inputDefinition)), errors.collect(cdk.propertyValidator("inputDefinition", CfnInput_InputDefinitionPropertyValidator)(properties.inputDefinition)), errors.collect(cdk.propertyValidator("inputDescription", cdk.validateString)(properties.inputDescription)), errors.collect(cdk.propertyValidator("inputName", cdk.validateString)(properties.inputName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnInputProps"');
    }
    function cfnInputPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInputPropsValidator(properties).assertSuccess(), { InputDefinition: cfnInputInputDefinitionPropertyToCloudFormation(properties.inputDefinition), InputDescription: cdk.stringToCloudFormation(properties.inputDescription), InputName: cdk.stringToCloudFormation(properties.inputName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnInputPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("inputDefinition", "InputDefinition", CfnInputInputDefinitionPropertyFromCloudFormation(properties.InputDefinition)), ret.addPropertyResult("inputDescription", "InputDescription", properties.InputDescription != null ? cfn_parse.FromCloudFormation.getString(properties.InputDescription) : void 0), ret.addPropertyResult("inputName", "InputName", properties.InputName != null ? cfn_parse.FromCloudFormation.getString(properties.InputName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnInput = class _CfnInput extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnInputPropsFromCloudFormation(resourceProperties), ret = new _CfnInput(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnInput.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotevents_CfnInputProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnInput), error;
        }
        cdk.requireProperty(props, "inputDefinition", this), this.inputDefinition = props.inputDefinition, this.inputDescription = props.inputDescription, this.inputName = props.inputName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTEvents::Input", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnInput.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { inputDefinition: this.inputDefinition, inputDescription: this.inputDescription, inputName: this.inputName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnInputPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnInput[_c] = { fqn: "aws-cdk-lib.aws_iotevents.CfnInput", version: "2.80.0" }, CfnInput.CFN_RESOURCE_TYPE_NAME = "AWS::IoTEvents::Input", exports2.CfnInput = CfnInput;
    function CfnInput_AttributePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("jsonPath", cdk.requiredValidator)(properties.jsonPath)), errors.collect(cdk.propertyValidator("jsonPath", cdk.validateString)(properties.jsonPath)), errors.wrap('supplied properties not correct for "AttributeProperty"');
    }
    function cfnInputAttributePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInput_AttributePropertyValidator(properties).assertSuccess(), { JsonPath: cdk.stringToCloudFormation(properties.jsonPath) }) : properties;
    }
    function CfnInputAttributePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("jsonPath", "JsonPath", cfn_parse.FromCloudFormation.getString(properties.JsonPath)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInput_InputDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributes", cdk.requiredValidator)(properties.attributes)), errors.collect(cdk.propertyValidator("attributes", cdk.listValidator(CfnInput_AttributePropertyValidator))(properties.attributes)), errors.wrap('supplied properties not correct for "InputDefinitionProperty"');
    }
    function cfnInputInputDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInput_InputDefinitionPropertyValidator(properties).assertSuccess(), { Attributes: cdk.listMapper(cfnInputAttributePropertyToCloudFormation)(properties.attributes) }) : properties;
    }
    function CfnInputInputDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attributes", "Attributes", cfn_parse.FromCloudFormation.getArray(CfnInputAttributePropertyFromCloudFormation)(properties.Attributes)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-iotevents/lib/index.js
var require_lib153 = __commonJS({
  "node_modules/aws-cdk-lib/aws-iotevents/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_iotevents_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-iotevents/index.js
var require_aws_iotevents = __commonJS({
  "node_modules/aws-cdk-lib/aws-iotevents/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib153(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-iotfleethub/lib/iotfleethub.generated.js
var require_iotfleethub_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-iotfleethub/lib/iotfleethub.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnApplication = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnApplicationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationDescription", cdk.validateString)(properties.applicationDescription)), errors.collect(cdk.propertyValidator("applicationName", cdk.requiredValidator)(properties.applicationName)), errors.collect(cdk.propertyValidator("applicationName", cdk.validateString)(properties.applicationName)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnApplicationProps"');
    }
    function cfnApplicationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationPropsValidator(properties).assertSuccess(), { ApplicationName: cdk.stringToCloudFormation(properties.applicationName), RoleArn: cdk.stringToCloudFormation(properties.roleArn), ApplicationDescription: cdk.stringToCloudFormation(properties.applicationDescription), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnApplicationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationName", "ApplicationName", cfn_parse.FromCloudFormation.getString(properties.ApplicationName)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("applicationDescription", "ApplicationDescription", properties.ApplicationDescription != null ? cfn_parse.FromCloudFormation.getString(properties.ApplicationDescription) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApplication = class _CfnApplication extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApplicationPropsFromCloudFormation(resourceProperties), ret = new _CfnApplication(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApplication.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotfleethub_CfnApplicationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApplication), error;
        }
        cdk.requireProperty(props, "applicationName", this), cdk.requireProperty(props, "roleArn", this), this.attrApplicationArn = cdk.Token.asString(this.getAtt("ApplicationArn", cdk.ResolutionTypeHint.STRING)), this.attrApplicationCreationDate = cdk.Token.asNumber(this.getAtt("ApplicationCreationDate", cdk.ResolutionTypeHint.NUMBER)), this.attrApplicationId = cdk.Token.asString(this.getAtt("ApplicationId", cdk.ResolutionTypeHint.STRING)), this.attrApplicationLastUpdateDate = cdk.Token.asNumber(this.getAtt("ApplicationLastUpdateDate", cdk.ResolutionTypeHint.NUMBER)), this.attrApplicationState = cdk.Token.asString(this.getAtt("ApplicationState", cdk.ResolutionTypeHint.STRING)), this.attrApplicationUrl = cdk.Token.asString(this.getAtt("ApplicationUrl", cdk.ResolutionTypeHint.STRING)), this.attrErrorMessage = cdk.Token.asString(this.getAtt("ErrorMessage", cdk.ResolutionTypeHint.STRING)), this.attrSsoClientId = cdk.Token.asString(this.getAtt("SsoClientId", cdk.ResolutionTypeHint.STRING)), this.applicationName = props.applicationName, this.roleArn = props.roleArn, this.applicationDescription = props.applicationDescription, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTFleetHub::Application", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApplication.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationName: this.applicationName, roleArn: this.roleArn, applicationDescription: this.applicationDescription, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnApplicationPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnApplication[_a] = { fqn: "aws-cdk-lib.aws_iotfleethub.CfnApplication", version: "2.80.0" }, CfnApplication.CFN_RESOURCE_TYPE_NAME = "AWS::IoTFleetHub::Application", exports2.CfnApplication = CfnApplication;
  }
});

// node_modules/aws-cdk-lib/aws-iotfleethub/lib/index.js
var require_lib154 = __commonJS({
  "node_modules/aws-cdk-lib/aws-iotfleethub/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_iotfleethub_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-iotfleethub/index.js
var require_aws_iotfleethub = __commonJS({
  "node_modules/aws-cdk-lib/aws-iotfleethub/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib154(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-iotfleetwise/lib/iotfleetwise.generated.js
var require_iotfleetwise_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-iotfleetwise/lib/iotfleetwise.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnVehicle = exports2.CfnSignalCatalog = exports2.CfnModelManifest = exports2.CfnFleet = exports2.CfnDecoderManifest = exports2.CfnCampaign = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnCampaignPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.requiredValidator)(properties.action)), errors.collect(cdk.propertyValidator("action", cdk.validateString)(properties.action)), errors.collect(cdk.propertyValidator("collectionScheme", cdk.requiredValidator)(properties.collectionScheme)), errors.collect(cdk.propertyValidator("collectionScheme", CfnCampaign_CollectionSchemePropertyValidator)(properties.collectionScheme)), errors.collect(cdk.propertyValidator("compression", cdk.validateString)(properties.compression)), errors.collect(cdk.propertyValidator("dataExtraDimensions", cdk.listValidator(cdk.validateString))(properties.dataExtraDimensions)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("diagnosticsMode", cdk.validateString)(properties.diagnosticsMode)), errors.collect(cdk.propertyValidator("expiryTime", cdk.validateString)(properties.expiryTime)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("postTriggerCollectionDuration", cdk.validateNumber)(properties.postTriggerCollectionDuration)), errors.collect(cdk.propertyValidator("priority", cdk.validateNumber)(properties.priority)), errors.collect(cdk.propertyValidator("signalCatalogArn", cdk.requiredValidator)(properties.signalCatalogArn)), errors.collect(cdk.propertyValidator("signalCatalogArn", cdk.validateString)(properties.signalCatalogArn)), errors.collect(cdk.propertyValidator("signalsToCollect", cdk.listValidator(CfnCampaign_SignalInformationPropertyValidator))(properties.signalsToCollect)), errors.collect(cdk.propertyValidator("spoolingMode", cdk.validateString)(properties.spoolingMode)), errors.collect(cdk.propertyValidator("startTime", cdk.validateString)(properties.startTime)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("targetArn", cdk.requiredValidator)(properties.targetArn)), errors.collect(cdk.propertyValidator("targetArn", cdk.validateString)(properties.targetArn)), errors.wrap('supplied properties not correct for "CfnCampaignProps"');
    }
    function cfnCampaignPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaignPropsValidator(properties).assertSuccess(), { Action: cdk.stringToCloudFormation(properties.action), CollectionScheme: cfnCampaignCollectionSchemePropertyToCloudFormation(properties.collectionScheme), Name: cdk.stringToCloudFormation(properties.name), SignalCatalogArn: cdk.stringToCloudFormation(properties.signalCatalogArn), TargetArn: cdk.stringToCloudFormation(properties.targetArn), Compression: cdk.stringToCloudFormation(properties.compression), DataExtraDimensions: cdk.listMapper(cdk.stringToCloudFormation)(properties.dataExtraDimensions), Description: cdk.stringToCloudFormation(properties.description), DiagnosticsMode: cdk.stringToCloudFormation(properties.diagnosticsMode), ExpiryTime: cdk.stringToCloudFormation(properties.expiryTime), PostTriggerCollectionDuration: cdk.numberToCloudFormation(properties.postTriggerCollectionDuration), Priority: cdk.numberToCloudFormation(properties.priority), SignalsToCollect: cdk.listMapper(cfnCampaignSignalInformationPropertyToCloudFormation)(properties.signalsToCollect), SpoolingMode: cdk.stringToCloudFormation(properties.spoolingMode), StartTime: cdk.stringToCloudFormation(properties.startTime), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnCampaignPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", cfn_parse.FromCloudFormation.getString(properties.Action)), ret.addPropertyResult("collectionScheme", "CollectionScheme", CfnCampaignCollectionSchemePropertyFromCloudFormation(properties.CollectionScheme)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("signalCatalogArn", "SignalCatalogArn", cfn_parse.FromCloudFormation.getString(properties.SignalCatalogArn)), ret.addPropertyResult("targetArn", "TargetArn", cfn_parse.FromCloudFormation.getString(properties.TargetArn)), ret.addPropertyResult("compression", "Compression", properties.Compression != null ? cfn_parse.FromCloudFormation.getString(properties.Compression) : void 0), ret.addPropertyResult("dataExtraDimensions", "DataExtraDimensions", properties.DataExtraDimensions != null ? cfn_parse.FromCloudFormation.getStringArray(properties.DataExtraDimensions) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("diagnosticsMode", "DiagnosticsMode", properties.DiagnosticsMode != null ? cfn_parse.FromCloudFormation.getString(properties.DiagnosticsMode) : void 0), ret.addPropertyResult("expiryTime", "ExpiryTime", properties.ExpiryTime != null ? cfn_parse.FromCloudFormation.getString(properties.ExpiryTime) : void 0), ret.addPropertyResult("postTriggerCollectionDuration", "PostTriggerCollectionDuration", properties.PostTriggerCollectionDuration != null ? cfn_parse.FromCloudFormation.getNumber(properties.PostTriggerCollectionDuration) : void 0), ret.addPropertyResult("priority", "Priority", properties.Priority != null ? cfn_parse.FromCloudFormation.getNumber(properties.Priority) : void 0), ret.addPropertyResult("signalsToCollect", "SignalsToCollect", properties.SignalsToCollect != null ? cfn_parse.FromCloudFormation.getArray(CfnCampaignSignalInformationPropertyFromCloudFormation)(properties.SignalsToCollect) : void 0), ret.addPropertyResult("spoolingMode", "SpoolingMode", properties.SpoolingMode != null ? cfn_parse.FromCloudFormation.getString(properties.SpoolingMode) : void 0), ret.addPropertyResult("startTime", "StartTime", properties.StartTime != null ? cfn_parse.FromCloudFormation.getString(properties.StartTime) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCampaign = class _CfnCampaign extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCampaignPropsFromCloudFormation(resourceProperties), ret = new _CfnCampaign(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCampaign.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotfleetwise_CfnCampaignProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCampaign), error;
        }
        cdk.requireProperty(props, "action", this), cdk.requireProperty(props, "collectionScheme", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "signalCatalogArn", this), cdk.requireProperty(props, "targetArn", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrLastModificationTime = cdk.Token.asString(this.getAtt("LastModificationTime", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.action = props.action, this.collectionScheme = props.collectionScheme, this.name = props.name, this.signalCatalogArn = props.signalCatalogArn, this.targetArn = props.targetArn, this.compression = props.compression, this.dataExtraDimensions = props.dataExtraDimensions, this.description = props.description, this.diagnosticsMode = props.diagnosticsMode, this.expiryTime = props.expiryTime, this.postTriggerCollectionDuration = props.postTriggerCollectionDuration, this.priority = props.priority, this.signalsToCollect = props.signalsToCollect, this.spoolingMode = props.spoolingMode, this.startTime = props.startTime, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTFleetWise::Campaign", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCampaign.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { action: this.action, collectionScheme: this.collectionScheme, name: this.name, signalCatalogArn: this.signalCatalogArn, targetArn: this.targetArn, compression: this.compression, dataExtraDimensions: this.dataExtraDimensions, description: this.description, diagnosticsMode: this.diagnosticsMode, expiryTime: this.expiryTime, postTriggerCollectionDuration: this.postTriggerCollectionDuration, priority: this.priority, signalsToCollect: this.signalsToCollect, spoolingMode: this.spoolingMode, startTime: this.startTime, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnCampaignPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnCampaign[_a] = { fqn: "aws-cdk-lib.aws_iotfleetwise.CfnCampaign", version: "2.80.0" }, CfnCampaign.CFN_RESOURCE_TYPE_NAME = "AWS::IoTFleetWise::Campaign", exports2.CfnCampaign = CfnCampaign;
    function CfnCampaign_CollectionSchemePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("conditionBasedCollectionScheme", CfnCampaign_ConditionBasedCollectionSchemePropertyValidator)(properties.conditionBasedCollectionScheme)), errors.collect(cdk.propertyValidator("timeBasedCollectionScheme", CfnCampaign_TimeBasedCollectionSchemePropertyValidator)(properties.timeBasedCollectionScheme)), errors.wrap('supplied properties not correct for "CollectionSchemeProperty"');
    }
    function cfnCampaignCollectionSchemePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_CollectionSchemePropertyValidator(properties).assertSuccess(), { ConditionBasedCollectionScheme: cfnCampaignConditionBasedCollectionSchemePropertyToCloudFormation(properties.conditionBasedCollectionScheme), TimeBasedCollectionScheme: cfnCampaignTimeBasedCollectionSchemePropertyToCloudFormation(properties.timeBasedCollectionScheme) }) : properties;
    }
    function CfnCampaignCollectionSchemePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("conditionBasedCollectionScheme", "ConditionBasedCollectionScheme", properties.ConditionBasedCollectionScheme != null ? CfnCampaignConditionBasedCollectionSchemePropertyFromCloudFormation(properties.ConditionBasedCollectionScheme) : void 0), ret.addPropertyResult("timeBasedCollectionScheme", "TimeBasedCollectionScheme", properties.TimeBasedCollectionScheme != null ? CfnCampaignTimeBasedCollectionSchemePropertyFromCloudFormation(properties.TimeBasedCollectionScheme) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCampaign_ConditionBasedCollectionSchemePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("conditionLanguageVersion", cdk.validateNumber)(properties.conditionLanguageVersion)), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.collect(cdk.propertyValidator("minimumTriggerIntervalMs", cdk.validateNumber)(properties.minimumTriggerIntervalMs)), errors.collect(cdk.propertyValidator("triggerMode", cdk.validateString)(properties.triggerMode)), errors.wrap('supplied properties not correct for "ConditionBasedCollectionSchemeProperty"');
    }
    function cfnCampaignConditionBasedCollectionSchemePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_ConditionBasedCollectionSchemePropertyValidator(properties).assertSuccess(), { ConditionLanguageVersion: cdk.numberToCloudFormation(properties.conditionLanguageVersion), Expression: cdk.stringToCloudFormation(properties.expression), MinimumTriggerIntervalMs: cdk.numberToCloudFormation(properties.minimumTriggerIntervalMs), TriggerMode: cdk.stringToCloudFormation(properties.triggerMode) }) : properties;
    }
    function CfnCampaignConditionBasedCollectionSchemePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("conditionLanguageVersion", "ConditionLanguageVersion", properties.ConditionLanguageVersion != null ? cfn_parse.FromCloudFormation.getNumber(properties.ConditionLanguageVersion) : void 0), ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getString(properties.Expression)), ret.addPropertyResult("minimumTriggerIntervalMs", "MinimumTriggerIntervalMs", properties.MinimumTriggerIntervalMs != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinimumTriggerIntervalMs) : void 0), ret.addPropertyResult("triggerMode", "TriggerMode", properties.TriggerMode != null ? cfn_parse.FromCloudFormation.getString(properties.TriggerMode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCampaign_SignalInformationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxSampleCount", cdk.validateNumber)(properties.maxSampleCount)), errors.collect(cdk.propertyValidator("minimumSamplingIntervalMs", cdk.validateNumber)(properties.minimumSamplingIntervalMs)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "SignalInformationProperty"');
    }
    function cfnCampaignSignalInformationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_SignalInformationPropertyValidator(properties).assertSuccess(), { MaxSampleCount: cdk.numberToCloudFormation(properties.maxSampleCount), MinimumSamplingIntervalMs: cdk.numberToCloudFormation(properties.minimumSamplingIntervalMs), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnCampaignSignalInformationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxSampleCount", "MaxSampleCount", properties.MaxSampleCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxSampleCount) : void 0), ret.addPropertyResult("minimumSamplingIntervalMs", "MinimumSamplingIntervalMs", properties.MinimumSamplingIntervalMs != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinimumSamplingIntervalMs) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCampaign_TimeBasedCollectionSchemePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("periodMs", cdk.requiredValidator)(properties.periodMs)), errors.collect(cdk.propertyValidator("periodMs", cdk.validateNumber)(properties.periodMs)), errors.wrap('supplied properties not correct for "TimeBasedCollectionSchemeProperty"');
    }
    function cfnCampaignTimeBasedCollectionSchemePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_TimeBasedCollectionSchemePropertyValidator(properties).assertSuccess(), { PeriodMs: cdk.numberToCloudFormation(properties.periodMs) }) : properties;
    }
    function CfnCampaignTimeBasedCollectionSchemePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("periodMs", "PeriodMs", cfn_parse.FromCloudFormation.getNumber(properties.PeriodMs)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDecoderManifestPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("modelManifestArn", cdk.requiredValidator)(properties.modelManifestArn)), errors.collect(cdk.propertyValidator("modelManifestArn", cdk.validateString)(properties.modelManifestArn)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("networkInterfaces", cdk.listValidator(CfnDecoderManifest_NetworkInterfacesItemsPropertyValidator))(properties.networkInterfaces)), errors.collect(cdk.propertyValidator("signalDecoders", cdk.listValidator(CfnDecoderManifest_SignalDecodersItemsPropertyValidator))(properties.signalDecoders)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDecoderManifestProps"');
    }
    function cfnDecoderManifestPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDecoderManifestPropsValidator(properties).assertSuccess(), { ModelManifestArn: cdk.stringToCloudFormation(properties.modelManifestArn), Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), NetworkInterfaces: cdk.listMapper(cfnDecoderManifestNetworkInterfacesItemsPropertyToCloudFormation)(properties.networkInterfaces), SignalDecoders: cdk.listMapper(cfnDecoderManifestSignalDecodersItemsPropertyToCloudFormation)(properties.signalDecoders), Status: cdk.stringToCloudFormation(properties.status), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDecoderManifestPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("modelManifestArn", "ModelManifestArn", cfn_parse.FromCloudFormation.getString(properties.ModelManifestArn)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("networkInterfaces", "NetworkInterfaces", properties.NetworkInterfaces != null ? cfn_parse.FromCloudFormation.getArray(CfnDecoderManifestNetworkInterfacesItemsPropertyFromCloudFormation)(properties.NetworkInterfaces) : void 0), ret.addPropertyResult("signalDecoders", "SignalDecoders", properties.SignalDecoders != null ? cfn_parse.FromCloudFormation.getArray(CfnDecoderManifestSignalDecodersItemsPropertyFromCloudFormation)(properties.SignalDecoders) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDecoderManifest = class _CfnDecoderManifest extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDecoderManifestPropsFromCloudFormation(resourceProperties), ret = new _CfnDecoderManifest(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDecoderManifest.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotfleetwise_CfnDecoderManifestProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDecoderManifest), error;
        }
        cdk.requireProperty(props, "modelManifestArn", this), cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrLastModificationTime = cdk.Token.asString(this.getAtt("LastModificationTime", cdk.ResolutionTypeHint.STRING)), this.modelManifestArn = props.modelManifestArn, this.name = props.name, this.description = props.description, this.networkInterfaces = props.networkInterfaces, this.signalDecoders = props.signalDecoders, this.status = props.status, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTFleetWise::DecoderManifest", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDecoderManifest.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { modelManifestArn: this.modelManifestArn, name: this.name, description: this.description, networkInterfaces: this.networkInterfaces, signalDecoders: this.signalDecoders, status: this.status, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDecoderManifestPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnDecoderManifest[_b] = { fqn: "aws-cdk-lib.aws_iotfleetwise.CfnDecoderManifest", version: "2.80.0" }, CfnDecoderManifest.CFN_RESOURCE_TYPE_NAME = "AWS::IoTFleetWise::DecoderManifest", exports2.CfnDecoderManifest = CfnDecoderManifest;
    function CfnDecoderManifest_CanInterfacePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("protocolName", cdk.validateString)(properties.protocolName)), errors.collect(cdk.propertyValidator("protocolVersion", cdk.validateString)(properties.protocolVersion)), errors.wrap('supplied properties not correct for "CanInterfaceProperty"');
    }
    function cfnDecoderManifestCanInterfacePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDecoderManifest_CanInterfacePropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), ProtocolName: cdk.stringToCloudFormation(properties.protocolName), ProtocolVersion: cdk.stringToCloudFormation(properties.protocolVersion) }) : properties;
    }
    function CfnDecoderManifestCanInterfacePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("protocolName", "ProtocolName", properties.ProtocolName != null ? cfn_parse.FromCloudFormation.getString(properties.ProtocolName) : void 0), ret.addPropertyResult("protocolVersion", "ProtocolVersion", properties.ProtocolVersion != null ? cfn_parse.FromCloudFormation.getString(properties.ProtocolVersion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDecoderManifest_CanSignalPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("factor", cdk.requiredValidator)(properties.factor)), errors.collect(cdk.propertyValidator("factor", cdk.validateString)(properties.factor)), errors.collect(cdk.propertyValidator("isBigEndian", cdk.requiredValidator)(properties.isBigEndian)), errors.collect(cdk.propertyValidator("isBigEndian", cdk.validateString)(properties.isBigEndian)), errors.collect(cdk.propertyValidator("isSigned", cdk.requiredValidator)(properties.isSigned)), errors.collect(cdk.propertyValidator("isSigned", cdk.validateString)(properties.isSigned)), errors.collect(cdk.propertyValidator("length", cdk.requiredValidator)(properties.length)), errors.collect(cdk.propertyValidator("length", cdk.validateString)(properties.length)), errors.collect(cdk.propertyValidator("messageId", cdk.requiredValidator)(properties.messageId)), errors.collect(cdk.propertyValidator("messageId", cdk.validateString)(properties.messageId)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("offset", cdk.requiredValidator)(properties.offset)), errors.collect(cdk.propertyValidator("offset", cdk.validateString)(properties.offset)), errors.collect(cdk.propertyValidator("startBit", cdk.requiredValidator)(properties.startBit)), errors.collect(cdk.propertyValidator("startBit", cdk.validateString)(properties.startBit)), errors.wrap('supplied properties not correct for "CanSignalProperty"');
    }
    function cfnDecoderManifestCanSignalPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDecoderManifest_CanSignalPropertyValidator(properties).assertSuccess(), { Factor: cdk.stringToCloudFormation(properties.factor), IsBigEndian: cdk.stringToCloudFormation(properties.isBigEndian), IsSigned: cdk.stringToCloudFormation(properties.isSigned), Length: cdk.stringToCloudFormation(properties.length), MessageId: cdk.stringToCloudFormation(properties.messageId), Name: cdk.stringToCloudFormation(properties.name), Offset: cdk.stringToCloudFormation(properties.offset), StartBit: cdk.stringToCloudFormation(properties.startBit) }) : properties;
    }
    function CfnDecoderManifestCanSignalPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("factor", "Factor", cfn_parse.FromCloudFormation.getString(properties.Factor)), ret.addPropertyResult("isBigEndian", "IsBigEndian", cfn_parse.FromCloudFormation.getString(properties.IsBigEndian)), ret.addPropertyResult("isSigned", "IsSigned", cfn_parse.FromCloudFormation.getString(properties.IsSigned)), ret.addPropertyResult("length", "Length", cfn_parse.FromCloudFormation.getString(properties.Length)), ret.addPropertyResult("messageId", "MessageId", cfn_parse.FromCloudFormation.getString(properties.MessageId)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("offset", "Offset", cfn_parse.FromCloudFormation.getString(properties.Offset)), ret.addPropertyResult("startBit", "StartBit", cfn_parse.FromCloudFormation.getString(properties.StartBit)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDecoderManifest_NetworkInterfacesItemsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("canInterface", CfnDecoderManifest_CanInterfacePropertyValidator)(properties.canInterface)), errors.collect(cdk.propertyValidator("interfaceId", cdk.requiredValidator)(properties.interfaceId)), errors.collect(cdk.propertyValidator("interfaceId", cdk.validateString)(properties.interfaceId)), errors.collect(cdk.propertyValidator("obdInterface", CfnDecoderManifest_ObdInterfacePropertyValidator)(properties.obdInterface)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "NetworkInterfacesItemsProperty"');
    }
    function cfnDecoderManifestNetworkInterfacesItemsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDecoderManifest_NetworkInterfacesItemsPropertyValidator(properties).assertSuccess(), { CanInterface: cfnDecoderManifestCanInterfacePropertyToCloudFormation(properties.canInterface), InterfaceId: cdk.stringToCloudFormation(properties.interfaceId), ObdInterface: cfnDecoderManifestObdInterfacePropertyToCloudFormation(properties.obdInterface), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnDecoderManifestNetworkInterfacesItemsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("canInterface", "CanInterface", properties.CanInterface != null ? CfnDecoderManifestCanInterfacePropertyFromCloudFormation(properties.CanInterface) : void 0), ret.addPropertyResult("interfaceId", "InterfaceId", cfn_parse.FromCloudFormation.getString(properties.InterfaceId)), ret.addPropertyResult("obdInterface", "ObdInterface", properties.ObdInterface != null ? CfnDecoderManifestObdInterfacePropertyFromCloudFormation(properties.ObdInterface) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDecoderManifest_ObdInterfacePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dtcRequestIntervalSeconds", cdk.validateString)(properties.dtcRequestIntervalSeconds)), errors.collect(cdk.propertyValidator("hasTransmissionEcu", cdk.validateString)(properties.hasTransmissionEcu)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("obdStandard", cdk.validateString)(properties.obdStandard)), errors.collect(cdk.propertyValidator("pidRequestIntervalSeconds", cdk.validateString)(properties.pidRequestIntervalSeconds)), errors.collect(cdk.propertyValidator("requestMessageId", cdk.requiredValidator)(properties.requestMessageId)), errors.collect(cdk.propertyValidator("requestMessageId", cdk.validateString)(properties.requestMessageId)), errors.collect(cdk.propertyValidator("useExtendedIds", cdk.validateString)(properties.useExtendedIds)), errors.wrap('supplied properties not correct for "ObdInterfaceProperty"');
    }
    function cfnDecoderManifestObdInterfacePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDecoderManifest_ObdInterfacePropertyValidator(properties).assertSuccess(), { DtcRequestIntervalSeconds: cdk.stringToCloudFormation(properties.dtcRequestIntervalSeconds), HasTransmissionEcu: cdk.stringToCloudFormation(properties.hasTransmissionEcu), Name: cdk.stringToCloudFormation(properties.name), ObdStandard: cdk.stringToCloudFormation(properties.obdStandard), PidRequestIntervalSeconds: cdk.stringToCloudFormation(properties.pidRequestIntervalSeconds), RequestMessageId: cdk.stringToCloudFormation(properties.requestMessageId), UseExtendedIds: cdk.stringToCloudFormation(properties.useExtendedIds) }) : properties;
    }
    function CfnDecoderManifestObdInterfacePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dtcRequestIntervalSeconds", "DtcRequestIntervalSeconds", properties.DtcRequestIntervalSeconds != null ? cfn_parse.FromCloudFormation.getString(properties.DtcRequestIntervalSeconds) : void 0), ret.addPropertyResult("hasTransmissionEcu", "HasTransmissionEcu", properties.HasTransmissionEcu != null ? cfn_parse.FromCloudFormation.getString(properties.HasTransmissionEcu) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("obdStandard", "ObdStandard", properties.ObdStandard != null ? cfn_parse.FromCloudFormation.getString(properties.ObdStandard) : void 0), ret.addPropertyResult("pidRequestIntervalSeconds", "PidRequestIntervalSeconds", properties.PidRequestIntervalSeconds != null ? cfn_parse.FromCloudFormation.getString(properties.PidRequestIntervalSeconds) : void 0), ret.addPropertyResult("requestMessageId", "RequestMessageId", cfn_parse.FromCloudFormation.getString(properties.RequestMessageId)), ret.addPropertyResult("useExtendedIds", "UseExtendedIds", properties.UseExtendedIds != null ? cfn_parse.FromCloudFormation.getString(properties.UseExtendedIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDecoderManifest_ObdSignalPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bitMaskLength", cdk.validateString)(properties.bitMaskLength)), errors.collect(cdk.propertyValidator("bitRightShift", cdk.validateString)(properties.bitRightShift)), errors.collect(cdk.propertyValidator("byteLength", cdk.requiredValidator)(properties.byteLength)), errors.collect(cdk.propertyValidator("byteLength", cdk.validateString)(properties.byteLength)), errors.collect(cdk.propertyValidator("offset", cdk.requiredValidator)(properties.offset)), errors.collect(cdk.propertyValidator("offset", cdk.validateString)(properties.offset)), errors.collect(cdk.propertyValidator("pid", cdk.requiredValidator)(properties.pid)), errors.collect(cdk.propertyValidator("pid", cdk.validateString)(properties.pid)), errors.collect(cdk.propertyValidator("pidResponseLength", cdk.requiredValidator)(properties.pidResponseLength)), errors.collect(cdk.propertyValidator("pidResponseLength", cdk.validateString)(properties.pidResponseLength)), errors.collect(cdk.propertyValidator("scaling", cdk.requiredValidator)(properties.scaling)), errors.collect(cdk.propertyValidator("scaling", cdk.validateString)(properties.scaling)), errors.collect(cdk.propertyValidator("serviceMode", cdk.requiredValidator)(properties.serviceMode)), errors.collect(cdk.propertyValidator("serviceMode", cdk.validateString)(properties.serviceMode)), errors.collect(cdk.propertyValidator("startByte", cdk.requiredValidator)(properties.startByte)), errors.collect(cdk.propertyValidator("startByte", cdk.validateString)(properties.startByte)), errors.wrap('supplied properties not correct for "ObdSignalProperty"');
    }
    function cfnDecoderManifestObdSignalPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDecoderManifest_ObdSignalPropertyValidator(properties).assertSuccess(), { BitMaskLength: cdk.stringToCloudFormation(properties.bitMaskLength), BitRightShift: cdk.stringToCloudFormation(properties.bitRightShift), ByteLength: cdk.stringToCloudFormation(properties.byteLength), Offset: cdk.stringToCloudFormation(properties.offset), Pid: cdk.stringToCloudFormation(properties.pid), PidResponseLength: cdk.stringToCloudFormation(properties.pidResponseLength), Scaling: cdk.stringToCloudFormation(properties.scaling), ServiceMode: cdk.stringToCloudFormation(properties.serviceMode), StartByte: cdk.stringToCloudFormation(properties.startByte) }) : properties;
    }
    function CfnDecoderManifestObdSignalPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bitMaskLength", "BitMaskLength", properties.BitMaskLength != null ? cfn_parse.FromCloudFormation.getString(properties.BitMaskLength) : void 0), ret.addPropertyResult("bitRightShift", "BitRightShift", properties.BitRightShift != null ? cfn_parse.FromCloudFormation.getString(properties.BitRightShift) : void 0), ret.addPropertyResult("byteLength", "ByteLength", cfn_parse.FromCloudFormation.getString(properties.ByteLength)), ret.addPropertyResult("offset", "Offset", cfn_parse.FromCloudFormation.getString(properties.Offset)), ret.addPropertyResult("pid", "Pid", cfn_parse.FromCloudFormation.getString(properties.Pid)), ret.addPropertyResult("pidResponseLength", "PidResponseLength", cfn_parse.FromCloudFormation.getString(properties.PidResponseLength)), ret.addPropertyResult("scaling", "Scaling", cfn_parse.FromCloudFormation.getString(properties.Scaling)), ret.addPropertyResult("serviceMode", "ServiceMode", cfn_parse.FromCloudFormation.getString(properties.ServiceMode)), ret.addPropertyResult("startByte", "StartByte", cfn_parse.FromCloudFormation.getString(properties.StartByte)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDecoderManifest_SignalDecodersItemsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("canSignal", CfnDecoderManifest_CanSignalPropertyValidator)(properties.canSignal)), errors.collect(cdk.propertyValidator("fullyQualifiedName", cdk.requiredValidator)(properties.fullyQualifiedName)), errors.collect(cdk.propertyValidator("fullyQualifiedName", cdk.validateString)(properties.fullyQualifiedName)), errors.collect(cdk.propertyValidator("interfaceId", cdk.requiredValidator)(properties.interfaceId)), errors.collect(cdk.propertyValidator("interfaceId", cdk.validateString)(properties.interfaceId)), errors.collect(cdk.propertyValidator("obdSignal", CfnDecoderManifest_ObdSignalPropertyValidator)(properties.obdSignal)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "SignalDecodersItemsProperty"');
    }
    function cfnDecoderManifestSignalDecodersItemsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDecoderManifest_SignalDecodersItemsPropertyValidator(properties).assertSuccess(), { CanSignal: cfnDecoderManifestCanSignalPropertyToCloudFormation(properties.canSignal), FullyQualifiedName: cdk.stringToCloudFormation(properties.fullyQualifiedName), InterfaceId: cdk.stringToCloudFormation(properties.interfaceId), ObdSignal: cfnDecoderManifestObdSignalPropertyToCloudFormation(properties.obdSignal), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnDecoderManifestSignalDecodersItemsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("canSignal", "CanSignal", properties.CanSignal != null ? CfnDecoderManifestCanSignalPropertyFromCloudFormation(properties.CanSignal) : void 0), ret.addPropertyResult("fullyQualifiedName", "FullyQualifiedName", cfn_parse.FromCloudFormation.getString(properties.FullyQualifiedName)), ret.addPropertyResult("interfaceId", "InterfaceId", cfn_parse.FromCloudFormation.getString(properties.InterfaceId)), ret.addPropertyResult("obdSignal", "ObdSignal", properties.ObdSignal != null ? CfnDecoderManifestObdSignalPropertyFromCloudFormation(properties.ObdSignal) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFleetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("signalCatalogArn", cdk.requiredValidator)(properties.signalCatalogArn)), errors.collect(cdk.propertyValidator("signalCatalogArn", cdk.validateString)(properties.signalCatalogArn)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnFleetProps"');
    }
    function cfnFleetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFleetPropsValidator(properties).assertSuccess(), { Id: cdk.stringToCloudFormation(properties.id), SignalCatalogArn: cdk.stringToCloudFormation(properties.signalCatalogArn), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnFleetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("signalCatalogArn", "SignalCatalogArn", cfn_parse.FromCloudFormation.getString(properties.SignalCatalogArn)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFleet = class _CfnFleet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFleetPropsFromCloudFormation(resourceProperties), ret = new _CfnFleet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFleet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotfleetwise_CfnFleetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFleet), error;
        }
        cdk.requireProperty(props, "id", this), cdk.requireProperty(props, "signalCatalogArn", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrLastModificationTime = cdk.Token.asString(this.getAtt("LastModificationTime", cdk.ResolutionTypeHint.STRING)), this.id = props.id, this.signalCatalogArn = props.signalCatalogArn, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTFleetWise::Fleet", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFleet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { id: this.id, signalCatalogArn: this.signalCatalogArn, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnFleetPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnFleet[_c] = { fqn: "aws-cdk-lib.aws_iotfleetwise.CfnFleet", version: "2.80.0" }, CfnFleet.CFN_RESOURCE_TYPE_NAME = "AWS::IoTFleetWise::Fleet", exports2.CfnFleet = CfnFleet;
    function CfnModelManifestPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("nodes", cdk.listValidator(cdk.validateString))(properties.nodes)), errors.collect(cdk.propertyValidator("signalCatalogArn", cdk.requiredValidator)(properties.signalCatalogArn)), errors.collect(cdk.propertyValidator("signalCatalogArn", cdk.validateString)(properties.signalCatalogArn)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnModelManifestProps"');
    }
    function cfnModelManifestPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelManifestPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), SignalCatalogArn: cdk.stringToCloudFormation(properties.signalCatalogArn), Description: cdk.stringToCloudFormation(properties.description), Nodes: cdk.listMapper(cdk.stringToCloudFormation)(properties.nodes), Status: cdk.stringToCloudFormation(properties.status), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnModelManifestPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("signalCatalogArn", "SignalCatalogArn", cfn_parse.FromCloudFormation.getString(properties.SignalCatalogArn)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("nodes", "Nodes", properties.Nodes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Nodes) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnModelManifest = class _CfnModelManifest extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnModelManifestPropsFromCloudFormation(resourceProperties), ret = new _CfnModelManifest(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnModelManifest.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotfleetwise_CfnModelManifestProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnModelManifest), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "signalCatalogArn", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrLastModificationTime = cdk.Token.asString(this.getAtt("LastModificationTime", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.signalCatalogArn = props.signalCatalogArn, this.description = props.description, this.nodes = props.nodes, this.status = props.status, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTFleetWise::ModelManifest", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnModelManifest.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, signalCatalogArn: this.signalCatalogArn, description: this.description, nodes: this.nodes, status: this.status, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnModelManifestPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnModelManifest[_d] = { fqn: "aws-cdk-lib.aws_iotfleetwise.CfnModelManifest", version: "2.80.0" }, CfnModelManifest.CFN_RESOURCE_TYPE_NAME = "AWS::IoTFleetWise::ModelManifest", exports2.CfnModelManifest = CfnModelManifest;
    function CfnSignalCatalogPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("nodeCounts", CfnSignalCatalog_NodeCountsPropertyValidator)(properties.nodeCounts)), errors.collect(cdk.propertyValidator("nodes", cdk.listValidator(CfnSignalCatalog_NodePropertyValidator))(properties.nodes)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnSignalCatalogProps"');
    }
    function cfnSignalCatalogPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSignalCatalogPropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), Name: cdk.stringToCloudFormation(properties.name), NodeCounts: cfnSignalCatalogNodeCountsPropertyToCloudFormation(properties.nodeCounts), Nodes: cdk.listMapper(cfnSignalCatalogNodePropertyToCloudFormation)(properties.nodes), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnSignalCatalogPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("nodeCounts", "NodeCounts", properties.NodeCounts != null ? CfnSignalCatalogNodeCountsPropertyFromCloudFormation(properties.NodeCounts) : void 0), ret.addPropertyResult("nodes", "Nodes", properties.Nodes != null ? cfn_parse.FromCloudFormation.getArray(CfnSignalCatalogNodePropertyFromCloudFormation)(properties.Nodes) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSignalCatalog = class _CfnSignalCatalog extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSignalCatalogPropsFromCloudFormation(resourceProperties), ret = new _CfnSignalCatalog(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnSignalCatalog.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotfleetwise_CfnSignalCatalogProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSignalCatalog), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrLastModificationTime = cdk.Token.asString(this.getAtt("LastModificationTime", cdk.ResolutionTypeHint.STRING)), this.attrNodeCountsTotalActuators = this.getAtt("NodeCounts.TotalActuators", cdk.ResolutionTypeHint.STRING), this.attrNodeCountsTotalAttributes = this.getAtt("NodeCounts.TotalAttributes", cdk.ResolutionTypeHint.STRING), this.attrNodeCountsTotalBranches = this.getAtt("NodeCounts.TotalBranches", cdk.ResolutionTypeHint.STRING), this.attrNodeCountsTotalNodes = this.getAtt("NodeCounts.TotalNodes", cdk.ResolutionTypeHint.STRING), this.attrNodeCountsTotalSensors = this.getAtt("NodeCounts.TotalSensors", cdk.ResolutionTypeHint.STRING), this.description = props.description, this.name = props.name, this.nodeCounts = props.nodeCounts, this.nodes = props.nodes, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTFleetWise::SignalCatalog", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSignalCatalog.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, name: this.name, nodeCounts: this.nodeCounts, nodes: this.nodes, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnSignalCatalogPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnSignalCatalog[_e] = { fqn: "aws-cdk-lib.aws_iotfleetwise.CfnSignalCatalog", version: "2.80.0" }, CfnSignalCatalog.CFN_RESOURCE_TYPE_NAME = "AWS::IoTFleetWise::SignalCatalog", exports2.CfnSignalCatalog = CfnSignalCatalog;
    function CfnSignalCatalog_ActuatorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowedValues", cdk.listValidator(cdk.validateString))(properties.allowedValues)), errors.collect(cdk.propertyValidator("assignedValue", cdk.validateString)(properties.assignedValue)), errors.collect(cdk.propertyValidator("dataType", cdk.requiredValidator)(properties.dataType)), errors.collect(cdk.propertyValidator("dataType", cdk.validateString)(properties.dataType)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("fullyQualifiedName", cdk.requiredValidator)(properties.fullyQualifiedName)), errors.collect(cdk.propertyValidator("fullyQualifiedName", cdk.validateString)(properties.fullyQualifiedName)), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.collect(cdk.propertyValidator("unit", cdk.validateString)(properties.unit)), errors.wrap('supplied properties not correct for "ActuatorProperty"');
    }
    function cfnSignalCatalogActuatorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSignalCatalog_ActuatorPropertyValidator(properties).assertSuccess(), { AllowedValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowedValues), AssignedValue: cdk.stringToCloudFormation(properties.assignedValue), DataType: cdk.stringToCloudFormation(properties.dataType), Description: cdk.stringToCloudFormation(properties.description), FullyQualifiedName: cdk.stringToCloudFormation(properties.fullyQualifiedName), Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min), Unit: cdk.stringToCloudFormation(properties.unit) }) : properties;
    }
    function CfnSignalCatalogActuatorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowedValues", "AllowedValues", properties.AllowedValues != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AllowedValues) : void 0), ret.addPropertyResult("assignedValue", "AssignedValue", properties.AssignedValue != null ? cfn_parse.FromCloudFormation.getString(properties.AssignedValue) : void 0), ret.addPropertyResult("dataType", "DataType", cfn_parse.FromCloudFormation.getString(properties.DataType)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("fullyQualifiedName", "FullyQualifiedName", cfn_parse.FromCloudFormation.getString(properties.FullyQualifiedName)), ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addPropertyResult("unit", "Unit", properties.Unit != null ? cfn_parse.FromCloudFormation.getString(properties.Unit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSignalCatalog_AttributePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowedValues", cdk.listValidator(cdk.validateString))(properties.allowedValues)), errors.collect(cdk.propertyValidator("assignedValue", cdk.validateString)(properties.assignedValue)), errors.collect(cdk.propertyValidator("dataType", cdk.requiredValidator)(properties.dataType)), errors.collect(cdk.propertyValidator("dataType", cdk.validateString)(properties.dataType)), errors.collect(cdk.propertyValidator("defaultValue", cdk.validateString)(properties.defaultValue)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("fullyQualifiedName", cdk.requiredValidator)(properties.fullyQualifiedName)), errors.collect(cdk.propertyValidator("fullyQualifiedName", cdk.validateString)(properties.fullyQualifiedName)), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.collect(cdk.propertyValidator("unit", cdk.validateString)(properties.unit)), errors.wrap('supplied properties not correct for "AttributeProperty"');
    }
    function cfnSignalCatalogAttributePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSignalCatalog_AttributePropertyValidator(properties).assertSuccess(), { AllowedValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowedValues), AssignedValue: cdk.stringToCloudFormation(properties.assignedValue), DataType: cdk.stringToCloudFormation(properties.dataType), DefaultValue: cdk.stringToCloudFormation(properties.defaultValue), Description: cdk.stringToCloudFormation(properties.description), FullyQualifiedName: cdk.stringToCloudFormation(properties.fullyQualifiedName), Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min), Unit: cdk.stringToCloudFormation(properties.unit) }) : properties;
    }
    function CfnSignalCatalogAttributePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowedValues", "AllowedValues", properties.AllowedValues != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AllowedValues) : void 0), ret.addPropertyResult("assignedValue", "AssignedValue", properties.AssignedValue != null ? cfn_parse.FromCloudFormation.getString(properties.AssignedValue) : void 0), ret.addPropertyResult("dataType", "DataType", cfn_parse.FromCloudFormation.getString(properties.DataType)), ret.addPropertyResult("defaultValue", "DefaultValue", properties.DefaultValue != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultValue) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("fullyQualifiedName", "FullyQualifiedName", cfn_parse.FromCloudFormation.getString(properties.FullyQualifiedName)), ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addPropertyResult("unit", "Unit", properties.Unit != null ? cfn_parse.FromCloudFormation.getString(properties.Unit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSignalCatalog_BranchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("fullyQualifiedName", cdk.requiredValidator)(properties.fullyQualifiedName)), errors.collect(cdk.propertyValidator("fullyQualifiedName", cdk.validateString)(properties.fullyQualifiedName)), errors.wrap('supplied properties not correct for "BranchProperty"');
    }
    function cfnSignalCatalogBranchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSignalCatalog_BranchPropertyValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), FullyQualifiedName: cdk.stringToCloudFormation(properties.fullyQualifiedName) }) : properties;
    }
    function CfnSignalCatalogBranchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("fullyQualifiedName", "FullyQualifiedName", cfn_parse.FromCloudFormation.getString(properties.FullyQualifiedName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSignalCatalog_NodePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actuator", CfnSignalCatalog_ActuatorPropertyValidator)(properties.actuator)), errors.collect(cdk.propertyValidator("attribute", CfnSignalCatalog_AttributePropertyValidator)(properties.attribute)), errors.collect(cdk.propertyValidator("branch", CfnSignalCatalog_BranchPropertyValidator)(properties.branch)), errors.collect(cdk.propertyValidator("sensor", CfnSignalCatalog_SensorPropertyValidator)(properties.sensor)), errors.wrap('supplied properties not correct for "NodeProperty"');
    }
    function cfnSignalCatalogNodePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSignalCatalog_NodePropertyValidator(properties).assertSuccess(), { Actuator: cfnSignalCatalogActuatorPropertyToCloudFormation(properties.actuator), Attribute: cfnSignalCatalogAttributePropertyToCloudFormation(properties.attribute), Branch: cfnSignalCatalogBranchPropertyToCloudFormation(properties.branch), Sensor: cfnSignalCatalogSensorPropertyToCloudFormation(properties.sensor) }) : properties;
    }
    function CfnSignalCatalogNodePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actuator", "Actuator", properties.Actuator != null ? CfnSignalCatalogActuatorPropertyFromCloudFormation(properties.Actuator) : void 0), ret.addPropertyResult("attribute", "Attribute", properties.Attribute != null ? CfnSignalCatalogAttributePropertyFromCloudFormation(properties.Attribute) : void 0), ret.addPropertyResult("branch", "Branch", properties.Branch != null ? CfnSignalCatalogBranchPropertyFromCloudFormation(properties.Branch) : void 0), ret.addPropertyResult("sensor", "Sensor", properties.Sensor != null ? CfnSignalCatalogSensorPropertyFromCloudFormation(properties.Sensor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSignalCatalog_NodeCountsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("totalActuators", cdk.validateNumber)(properties.totalActuators)), errors.collect(cdk.propertyValidator("totalAttributes", cdk.validateNumber)(properties.totalAttributes)), errors.collect(cdk.propertyValidator("totalBranches", cdk.validateNumber)(properties.totalBranches)), errors.collect(cdk.propertyValidator("totalNodes", cdk.validateNumber)(properties.totalNodes)), errors.collect(cdk.propertyValidator("totalSensors", cdk.validateNumber)(properties.totalSensors)), errors.wrap('supplied properties not correct for "NodeCountsProperty"');
    }
    function cfnSignalCatalogNodeCountsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSignalCatalog_NodeCountsPropertyValidator(properties).assertSuccess(), { TotalActuators: cdk.numberToCloudFormation(properties.totalActuators), TotalAttributes: cdk.numberToCloudFormation(properties.totalAttributes), TotalBranches: cdk.numberToCloudFormation(properties.totalBranches), TotalNodes: cdk.numberToCloudFormation(properties.totalNodes), TotalSensors: cdk.numberToCloudFormation(properties.totalSensors) }) : properties;
    }
    function CfnSignalCatalogNodeCountsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("totalActuators", "TotalActuators", properties.TotalActuators != null ? cfn_parse.FromCloudFormation.getNumber(properties.TotalActuators) : void 0), ret.addPropertyResult("totalAttributes", "TotalAttributes", properties.TotalAttributes != null ? cfn_parse.FromCloudFormation.getNumber(properties.TotalAttributes) : void 0), ret.addPropertyResult("totalBranches", "TotalBranches", properties.TotalBranches != null ? cfn_parse.FromCloudFormation.getNumber(properties.TotalBranches) : void 0), ret.addPropertyResult("totalNodes", "TotalNodes", properties.TotalNodes != null ? cfn_parse.FromCloudFormation.getNumber(properties.TotalNodes) : void 0), ret.addPropertyResult("totalSensors", "TotalSensors", properties.TotalSensors != null ? cfn_parse.FromCloudFormation.getNumber(properties.TotalSensors) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSignalCatalog_SensorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowedValues", cdk.listValidator(cdk.validateString))(properties.allowedValues)), errors.collect(cdk.propertyValidator("dataType", cdk.requiredValidator)(properties.dataType)), errors.collect(cdk.propertyValidator("dataType", cdk.validateString)(properties.dataType)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("fullyQualifiedName", cdk.requiredValidator)(properties.fullyQualifiedName)), errors.collect(cdk.propertyValidator("fullyQualifiedName", cdk.validateString)(properties.fullyQualifiedName)), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.collect(cdk.propertyValidator("unit", cdk.validateString)(properties.unit)), errors.wrap('supplied properties not correct for "SensorProperty"');
    }
    function cfnSignalCatalogSensorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSignalCatalog_SensorPropertyValidator(properties).assertSuccess(), { AllowedValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowedValues), DataType: cdk.stringToCloudFormation(properties.dataType), Description: cdk.stringToCloudFormation(properties.description), FullyQualifiedName: cdk.stringToCloudFormation(properties.fullyQualifiedName), Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min), Unit: cdk.stringToCloudFormation(properties.unit) }) : properties;
    }
    function CfnSignalCatalogSensorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowedValues", "AllowedValues", properties.AllowedValues != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AllowedValues) : void 0), ret.addPropertyResult("dataType", "DataType", cfn_parse.FromCloudFormation.getString(properties.DataType)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("fullyQualifiedName", "FullyQualifiedName", cfn_parse.FromCloudFormation.getString(properties.FullyQualifiedName)), ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addPropertyResult("unit", "Unit", properties.Unit != null ? cfn_parse.FromCloudFormation.getString(properties.Unit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVehiclePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("associationBehavior", cdk.validateString)(properties.associationBehavior)), errors.collect(cdk.propertyValidator("attributes", cdk.hashValidator(cdk.validateString))(properties.attributes)), errors.collect(cdk.propertyValidator("decoderManifestArn", cdk.requiredValidator)(properties.decoderManifestArn)), errors.collect(cdk.propertyValidator("decoderManifestArn", cdk.validateString)(properties.decoderManifestArn)), errors.collect(cdk.propertyValidator("modelManifestArn", cdk.requiredValidator)(properties.modelManifestArn)), errors.collect(cdk.propertyValidator("modelManifestArn", cdk.validateString)(properties.modelManifestArn)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnVehicleProps"');
    }
    function cfnVehiclePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVehiclePropsValidator(properties).assertSuccess(), { DecoderManifestArn: cdk.stringToCloudFormation(properties.decoderManifestArn), ModelManifestArn: cdk.stringToCloudFormation(properties.modelManifestArn), Name: cdk.stringToCloudFormation(properties.name), AssociationBehavior: cdk.stringToCloudFormation(properties.associationBehavior), Attributes: cdk.hashMapper(cdk.stringToCloudFormation)(properties.attributes), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnVehiclePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("decoderManifestArn", "DecoderManifestArn", cfn_parse.FromCloudFormation.getString(properties.DecoderManifestArn)), ret.addPropertyResult("modelManifestArn", "ModelManifestArn", cfn_parse.FromCloudFormation.getString(properties.ModelManifestArn)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("associationBehavior", "AssociationBehavior", properties.AssociationBehavior != null ? cfn_parse.FromCloudFormation.getString(properties.AssociationBehavior) : void 0), ret.addPropertyResult("attributes", "Attributes", properties.Attributes != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Attributes) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVehicle = class _CfnVehicle extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVehiclePropsFromCloudFormation(resourceProperties), ret = new _CfnVehicle(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVehicle.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotfleetwise_CfnVehicleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVehicle), error;
        }
        cdk.requireProperty(props, "decoderManifestArn", this), cdk.requireProperty(props, "modelManifestArn", this), cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrLastModificationTime = cdk.Token.asString(this.getAtt("LastModificationTime", cdk.ResolutionTypeHint.STRING)), this.decoderManifestArn = props.decoderManifestArn, this.modelManifestArn = props.modelManifestArn, this.name = props.name, this.associationBehavior = props.associationBehavior, this.attributes = props.attributes, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTFleetWise::Vehicle", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVehicle.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { decoderManifestArn: this.decoderManifestArn, modelManifestArn: this.modelManifestArn, name: this.name, associationBehavior: this.associationBehavior, attributes: this.attributes, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnVehiclePropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnVehicle[_f] = { fqn: "aws-cdk-lib.aws_iotfleetwise.CfnVehicle", version: "2.80.0" }, CfnVehicle.CFN_RESOURCE_TYPE_NAME = "AWS::IoTFleetWise::Vehicle", exports2.CfnVehicle = CfnVehicle;
  }
});

// node_modules/aws-cdk-lib/aws-iotfleetwise/lib/index.js
var require_lib155 = __commonJS({
  "node_modules/aws-cdk-lib/aws-iotfleetwise/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_iotfleetwise_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-iotfleetwise/index.js
var require_aws_iotfleetwise = __commonJS({
  "node_modules/aws-cdk-lib/aws-iotfleetwise/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib155(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-iotsitewise/lib/iotsitewise.generated.js
var require_iotsitewise_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-iotsitewise/lib/iotsitewise.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnProject = exports2.CfnPortal = exports2.CfnGateway = exports2.CfnDashboard = exports2.CfnAssetModel = exports2.CfnAsset = exports2.CfnAccessPolicy = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAccessPolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessPolicyIdentity", cdk.requiredValidator)(properties.accessPolicyIdentity)), errors.collect(cdk.propertyValidator("accessPolicyIdentity", CfnAccessPolicy_AccessPolicyIdentityPropertyValidator)(properties.accessPolicyIdentity)), errors.collect(cdk.propertyValidator("accessPolicyPermission", cdk.requiredValidator)(properties.accessPolicyPermission)), errors.collect(cdk.propertyValidator("accessPolicyPermission", cdk.validateString)(properties.accessPolicyPermission)), errors.collect(cdk.propertyValidator("accessPolicyResource", cdk.requiredValidator)(properties.accessPolicyResource)), errors.collect(cdk.propertyValidator("accessPolicyResource", CfnAccessPolicy_AccessPolicyResourcePropertyValidator)(properties.accessPolicyResource)), errors.wrap('supplied properties not correct for "CfnAccessPolicyProps"');
    }
    function cfnAccessPolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccessPolicyPropsValidator(properties).assertSuccess(), { AccessPolicyIdentity: cfnAccessPolicyAccessPolicyIdentityPropertyToCloudFormation(properties.accessPolicyIdentity), AccessPolicyPermission: cdk.stringToCloudFormation(properties.accessPolicyPermission), AccessPolicyResource: cfnAccessPolicyAccessPolicyResourcePropertyToCloudFormation(properties.accessPolicyResource) }) : properties;
    }
    function CfnAccessPolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessPolicyIdentity", "AccessPolicyIdentity", CfnAccessPolicyAccessPolicyIdentityPropertyFromCloudFormation(properties.AccessPolicyIdentity)), ret.addPropertyResult("accessPolicyPermission", "AccessPolicyPermission", cfn_parse.FromCloudFormation.getString(properties.AccessPolicyPermission)), ret.addPropertyResult("accessPolicyResource", "AccessPolicyResource", CfnAccessPolicyAccessPolicyResourcePropertyFromCloudFormation(properties.AccessPolicyResource)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAccessPolicy = class _CfnAccessPolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAccessPolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnAccessPolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAccessPolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotsitewise_CfnAccessPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAccessPolicy), error;
        }
        cdk.requireProperty(props, "accessPolicyIdentity", this), cdk.requireProperty(props, "accessPolicyPermission", this), cdk.requireProperty(props, "accessPolicyResource", this), this.attrAccessPolicyArn = cdk.Token.asString(this.getAtt("AccessPolicyArn", cdk.ResolutionTypeHint.STRING)), this.attrAccessPolicyId = cdk.Token.asString(this.getAtt("AccessPolicyId", cdk.ResolutionTypeHint.STRING)), this.accessPolicyIdentity = props.accessPolicyIdentity, this.accessPolicyPermission = props.accessPolicyPermission, this.accessPolicyResource = props.accessPolicyResource;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAccessPolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { accessPolicyIdentity: this.accessPolicyIdentity, accessPolicyPermission: this.accessPolicyPermission, accessPolicyResource: this.accessPolicyResource };
      }
      renderProperties(props) {
        return cfnAccessPolicyPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAccessPolicy[_a] = { fqn: "aws-cdk-lib.aws_iotsitewise.CfnAccessPolicy", version: "2.80.0" }, CfnAccessPolicy.CFN_RESOURCE_TYPE_NAME = "AWS::IoTSiteWise::AccessPolicy", exports2.CfnAccessPolicy = CfnAccessPolicy;
    function CfnAccessPolicy_AccessPolicyIdentityPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("iamRole", CfnAccessPolicy_IamRolePropertyValidator)(properties.iamRole)), errors.collect(cdk.propertyValidator("iamUser", CfnAccessPolicy_IamUserPropertyValidator)(properties.iamUser)), errors.collect(cdk.propertyValidator("user", CfnAccessPolicy_UserPropertyValidator)(properties.user)), errors.wrap('supplied properties not correct for "AccessPolicyIdentityProperty"');
    }
    function cfnAccessPolicyAccessPolicyIdentityPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccessPolicy_AccessPolicyIdentityPropertyValidator(properties).assertSuccess(), { IamRole: cfnAccessPolicyIamRolePropertyToCloudFormation(properties.iamRole), IamUser: cfnAccessPolicyIamUserPropertyToCloudFormation(properties.iamUser), User: cfnAccessPolicyUserPropertyToCloudFormation(properties.user) }) : properties;
    }
    function CfnAccessPolicyAccessPolicyIdentityPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("iamRole", "IamRole", properties.IamRole != null ? CfnAccessPolicyIamRolePropertyFromCloudFormation(properties.IamRole) : void 0), ret.addPropertyResult("iamUser", "IamUser", properties.IamUser != null ? CfnAccessPolicyIamUserPropertyFromCloudFormation(properties.IamUser) : void 0), ret.addPropertyResult("user", "User", properties.User != null ? CfnAccessPolicyUserPropertyFromCloudFormation(properties.User) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAccessPolicy_AccessPolicyResourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("portal", CfnAccessPolicy_PortalPropertyValidator)(properties.portal)), errors.collect(cdk.propertyValidator("project", CfnAccessPolicy_ProjectPropertyValidator)(properties.project)), errors.wrap('supplied properties not correct for "AccessPolicyResourceProperty"');
    }
    function cfnAccessPolicyAccessPolicyResourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccessPolicy_AccessPolicyResourcePropertyValidator(properties).assertSuccess(), { Portal: cfnAccessPolicyPortalPropertyToCloudFormation(properties.portal), Project: cfnAccessPolicyProjectPropertyToCloudFormation(properties.project) }) : properties;
    }
    function CfnAccessPolicyAccessPolicyResourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("portal", "Portal", properties.Portal != null ? CfnAccessPolicyPortalPropertyFromCloudFormation(properties.Portal) : void 0), ret.addPropertyResult("project", "Project", properties.Project != null ? CfnAccessPolicyProjectPropertyFromCloudFormation(properties.Project) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAccessPolicy_IamRolePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.wrap('supplied properties not correct for "IamRoleProperty"');
    }
    function cfnAccessPolicyIamRolePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccessPolicy_IamRolePropertyValidator(properties).assertSuccess(), { arn: cdk.stringToCloudFormation(properties.arn) }) : properties;
    }
    function CfnAccessPolicyIamRolePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "arn", properties.arn != null ? cfn_parse.FromCloudFormation.getString(properties.arn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAccessPolicy_IamUserPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.wrap('supplied properties not correct for "IamUserProperty"');
    }
    function cfnAccessPolicyIamUserPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccessPolicy_IamUserPropertyValidator(properties).assertSuccess(), { arn: cdk.stringToCloudFormation(properties.arn) }) : properties;
    }
    function CfnAccessPolicyIamUserPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "arn", properties.arn != null ? cfn_parse.FromCloudFormation.getString(properties.arn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAccessPolicy_PortalPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.wrap('supplied properties not correct for "PortalProperty"');
    }
    function cfnAccessPolicyPortalPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccessPolicy_PortalPropertyValidator(properties).assertSuccess(), { id: cdk.stringToCloudFormation(properties.id) }) : properties;
    }
    function CfnAccessPolicyPortalPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("id", "id", properties.id != null ? cfn_parse.FromCloudFormation.getString(properties.id) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAccessPolicy_ProjectPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.wrap('supplied properties not correct for "ProjectProperty"');
    }
    function cfnAccessPolicyProjectPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccessPolicy_ProjectPropertyValidator(properties).assertSuccess(), { id: cdk.stringToCloudFormation(properties.id) }) : properties;
    }
    function CfnAccessPolicyProjectPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("id", "id", properties.id != null ? cfn_parse.FromCloudFormation.getString(properties.id) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAccessPolicy_UserPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.wrap('supplied properties not correct for "UserProperty"');
    }
    function cfnAccessPolicyUserPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccessPolicy_UserPropertyValidator(properties).assertSuccess(), { id: cdk.stringToCloudFormation(properties.id) }) : properties;
    }
    function CfnAccessPolicyUserPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("id", "id", properties.id != null ? cfn_parse.FromCloudFormation.getString(properties.id) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAssetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("assetDescription", cdk.validateString)(properties.assetDescription)), errors.collect(cdk.propertyValidator("assetHierarchies", cdk.listValidator(CfnAsset_AssetHierarchyPropertyValidator))(properties.assetHierarchies)), errors.collect(cdk.propertyValidator("assetModelId", cdk.requiredValidator)(properties.assetModelId)), errors.collect(cdk.propertyValidator("assetModelId", cdk.validateString)(properties.assetModelId)), errors.collect(cdk.propertyValidator("assetName", cdk.requiredValidator)(properties.assetName)), errors.collect(cdk.propertyValidator("assetName", cdk.validateString)(properties.assetName)), errors.collect(cdk.propertyValidator("assetProperties", cdk.listValidator(CfnAsset_AssetPropertyPropertyValidator))(properties.assetProperties)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnAssetProps"');
    }
    function cfnAssetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssetPropsValidator(properties).assertSuccess(), { AssetModelId: cdk.stringToCloudFormation(properties.assetModelId), AssetName: cdk.stringToCloudFormation(properties.assetName), AssetDescription: cdk.stringToCloudFormation(properties.assetDescription), AssetHierarchies: cdk.listMapper(cfnAssetAssetHierarchyPropertyToCloudFormation)(properties.assetHierarchies), AssetProperties: cdk.listMapper(cfnAssetAssetPropertyPropertyToCloudFormation)(properties.assetProperties), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnAssetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("assetModelId", "AssetModelId", cfn_parse.FromCloudFormation.getString(properties.AssetModelId)), ret.addPropertyResult("assetName", "AssetName", cfn_parse.FromCloudFormation.getString(properties.AssetName)), ret.addPropertyResult("assetDescription", "AssetDescription", properties.AssetDescription != null ? cfn_parse.FromCloudFormation.getString(properties.AssetDescription) : void 0), ret.addPropertyResult("assetHierarchies", "AssetHierarchies", properties.AssetHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnAssetAssetHierarchyPropertyFromCloudFormation)(properties.AssetHierarchies) : void 0), ret.addPropertyResult("assetProperties", "AssetProperties", properties.AssetProperties != null ? cfn_parse.FromCloudFormation.getArray(CfnAssetAssetPropertyPropertyFromCloudFormation)(properties.AssetProperties) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAsset = class _CfnAsset extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAssetPropsFromCloudFormation(resourceProperties), ret = new _CfnAsset(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAsset.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotsitewise_CfnAssetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAsset), error;
        }
        cdk.requireProperty(props, "assetModelId", this), cdk.requireProperty(props, "assetName", this), this.attrAssetArn = cdk.Token.asString(this.getAtt("AssetArn", cdk.ResolutionTypeHint.STRING)), this.attrAssetId = cdk.Token.asString(this.getAtt("AssetId", cdk.ResolutionTypeHint.STRING)), this.assetModelId = props.assetModelId, this.assetName = props.assetName, this.assetDescription = props.assetDescription, this.assetHierarchies = props.assetHierarchies, this.assetProperties = props.assetProperties, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTSiteWise::Asset", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAsset.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { assetModelId: this.assetModelId, assetName: this.assetName, assetDescription: this.assetDescription, assetHierarchies: this.assetHierarchies, assetProperties: this.assetProperties, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnAssetPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnAsset[_b] = { fqn: "aws-cdk-lib.aws_iotsitewise.CfnAsset", version: "2.80.0" }, CfnAsset.CFN_RESOURCE_TYPE_NAME = "AWS::IoTSiteWise::Asset", exports2.CfnAsset = CfnAsset;
    function CfnAsset_AssetHierarchyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("childAssetId", cdk.requiredValidator)(properties.childAssetId)), errors.collect(cdk.propertyValidator("childAssetId", cdk.validateString)(properties.childAssetId)), errors.collect(cdk.propertyValidator("logicalId", cdk.requiredValidator)(properties.logicalId)), errors.collect(cdk.propertyValidator("logicalId", cdk.validateString)(properties.logicalId)), errors.wrap('supplied properties not correct for "AssetHierarchyProperty"');
    }
    function cfnAssetAssetHierarchyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAsset_AssetHierarchyPropertyValidator(properties).assertSuccess(), { ChildAssetId: cdk.stringToCloudFormation(properties.childAssetId), LogicalId: cdk.stringToCloudFormation(properties.logicalId) }) : properties;
    }
    function CfnAssetAssetHierarchyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("childAssetId", "ChildAssetId", cfn_parse.FromCloudFormation.getString(properties.ChildAssetId)), ret.addPropertyResult("logicalId", "LogicalId", cfn_parse.FromCloudFormation.getString(properties.LogicalId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAsset_AssetPropertyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alias", cdk.validateString)(properties.alias)), errors.collect(cdk.propertyValidator("logicalId", cdk.requiredValidator)(properties.logicalId)), errors.collect(cdk.propertyValidator("logicalId", cdk.validateString)(properties.logicalId)), errors.collect(cdk.propertyValidator("notificationState", cdk.validateString)(properties.notificationState)), errors.collect(cdk.propertyValidator("unit", cdk.validateString)(properties.unit)), errors.wrap('supplied properties not correct for "AssetPropertyProperty"');
    }
    function cfnAssetAssetPropertyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAsset_AssetPropertyPropertyValidator(properties).assertSuccess(), { Alias: cdk.stringToCloudFormation(properties.alias), LogicalId: cdk.stringToCloudFormation(properties.logicalId), NotificationState: cdk.stringToCloudFormation(properties.notificationState), Unit: cdk.stringToCloudFormation(properties.unit) }) : properties;
    }
    function CfnAssetAssetPropertyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alias", "Alias", properties.Alias != null ? cfn_parse.FromCloudFormation.getString(properties.Alias) : void 0), ret.addPropertyResult("logicalId", "LogicalId", cfn_parse.FromCloudFormation.getString(properties.LogicalId)), ret.addPropertyResult("notificationState", "NotificationState", properties.NotificationState != null ? cfn_parse.FromCloudFormation.getString(properties.NotificationState) : void 0), ret.addPropertyResult("unit", "Unit", properties.Unit != null ? cfn_parse.FromCloudFormation.getString(properties.Unit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAssetModelPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("assetModelCompositeModels", cdk.listValidator(CfnAssetModel_AssetModelCompositeModelPropertyValidator))(properties.assetModelCompositeModels)), errors.collect(cdk.propertyValidator("assetModelDescription", cdk.validateString)(properties.assetModelDescription)), errors.collect(cdk.propertyValidator("assetModelHierarchies", cdk.listValidator(CfnAssetModel_AssetModelHierarchyPropertyValidator))(properties.assetModelHierarchies)), errors.collect(cdk.propertyValidator("assetModelName", cdk.requiredValidator)(properties.assetModelName)), errors.collect(cdk.propertyValidator("assetModelName", cdk.validateString)(properties.assetModelName)), errors.collect(cdk.propertyValidator("assetModelProperties", cdk.listValidator(CfnAssetModel_AssetModelPropertyPropertyValidator))(properties.assetModelProperties)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnAssetModelProps"');
    }
    function cfnAssetModelPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssetModelPropsValidator(properties).assertSuccess(), { AssetModelName: cdk.stringToCloudFormation(properties.assetModelName), AssetModelCompositeModels: cdk.listMapper(cfnAssetModelAssetModelCompositeModelPropertyToCloudFormation)(properties.assetModelCompositeModels), AssetModelDescription: cdk.stringToCloudFormation(properties.assetModelDescription), AssetModelHierarchies: cdk.listMapper(cfnAssetModelAssetModelHierarchyPropertyToCloudFormation)(properties.assetModelHierarchies), AssetModelProperties: cdk.listMapper(cfnAssetModelAssetModelPropertyPropertyToCloudFormation)(properties.assetModelProperties), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnAssetModelPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("assetModelName", "AssetModelName", cfn_parse.FromCloudFormation.getString(properties.AssetModelName)), ret.addPropertyResult("assetModelCompositeModels", "AssetModelCompositeModels", properties.AssetModelCompositeModels != null ? cfn_parse.FromCloudFormation.getArray(CfnAssetModelAssetModelCompositeModelPropertyFromCloudFormation)(properties.AssetModelCompositeModels) : void 0), ret.addPropertyResult("assetModelDescription", "AssetModelDescription", properties.AssetModelDescription != null ? cfn_parse.FromCloudFormation.getString(properties.AssetModelDescription) : void 0), ret.addPropertyResult("assetModelHierarchies", "AssetModelHierarchies", properties.AssetModelHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnAssetModelAssetModelHierarchyPropertyFromCloudFormation)(properties.AssetModelHierarchies) : void 0), ret.addPropertyResult("assetModelProperties", "AssetModelProperties", properties.AssetModelProperties != null ? cfn_parse.FromCloudFormation.getArray(CfnAssetModelAssetModelPropertyPropertyFromCloudFormation)(properties.AssetModelProperties) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAssetModel = class _CfnAssetModel extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAssetModelPropsFromCloudFormation(resourceProperties), ret = new _CfnAssetModel(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAssetModel.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotsitewise_CfnAssetModelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAssetModel), error;
        }
        cdk.requireProperty(props, "assetModelName", this), this.attrAssetModelArn = cdk.Token.asString(this.getAtt("AssetModelArn", cdk.ResolutionTypeHint.STRING)), this.attrAssetModelId = cdk.Token.asString(this.getAtt("AssetModelId", cdk.ResolutionTypeHint.STRING)), this.assetModelName = props.assetModelName, this.assetModelCompositeModels = props.assetModelCompositeModels, this.assetModelDescription = props.assetModelDescription, this.assetModelHierarchies = props.assetModelHierarchies, this.assetModelProperties = props.assetModelProperties, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTSiteWise::AssetModel", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAssetModel.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { assetModelName: this.assetModelName, assetModelCompositeModels: this.assetModelCompositeModels, assetModelDescription: this.assetModelDescription, assetModelHierarchies: this.assetModelHierarchies, assetModelProperties: this.assetModelProperties, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnAssetModelPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnAssetModel[_c] = { fqn: "aws-cdk-lib.aws_iotsitewise.CfnAssetModel", version: "2.80.0" }, CfnAssetModel.CFN_RESOURCE_TYPE_NAME = "AWS::IoTSiteWise::AssetModel", exports2.CfnAssetModel = CfnAssetModel;
    function CfnAssetModel_AssetModelCompositeModelPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("compositeModelProperties", cdk.listValidator(CfnAssetModel_AssetModelPropertyPropertyValidator))(properties.compositeModelProperties)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "AssetModelCompositeModelProperty"');
    }
    function cfnAssetModelAssetModelCompositeModelPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssetModel_AssetModelCompositeModelPropertyValidator(properties).assertSuccess(), { CompositeModelProperties: cdk.listMapper(cfnAssetModelAssetModelPropertyPropertyToCloudFormation)(properties.compositeModelProperties), Description: cdk.stringToCloudFormation(properties.description), Name: cdk.stringToCloudFormation(properties.name), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnAssetModelAssetModelCompositeModelPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("compositeModelProperties", "CompositeModelProperties", properties.CompositeModelProperties != null ? cfn_parse.FromCloudFormation.getArray(CfnAssetModelAssetModelPropertyPropertyFromCloudFormation)(properties.CompositeModelProperties) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAssetModel_AssetModelHierarchyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("childAssetModelId", cdk.requiredValidator)(properties.childAssetModelId)), errors.collect(cdk.propertyValidator("childAssetModelId", cdk.validateString)(properties.childAssetModelId)), errors.collect(cdk.propertyValidator("logicalId", cdk.requiredValidator)(properties.logicalId)), errors.collect(cdk.propertyValidator("logicalId", cdk.validateString)(properties.logicalId)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "AssetModelHierarchyProperty"');
    }
    function cfnAssetModelAssetModelHierarchyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssetModel_AssetModelHierarchyPropertyValidator(properties).assertSuccess(), { ChildAssetModelId: cdk.stringToCloudFormation(properties.childAssetModelId), LogicalId: cdk.stringToCloudFormation(properties.logicalId), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnAssetModelAssetModelHierarchyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("childAssetModelId", "ChildAssetModelId", cfn_parse.FromCloudFormation.getString(properties.ChildAssetModelId)), ret.addPropertyResult("logicalId", "LogicalId", cfn_parse.FromCloudFormation.getString(properties.LogicalId)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAssetModel_AssetModelPropertyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataType", cdk.requiredValidator)(properties.dataType)), errors.collect(cdk.propertyValidator("dataType", cdk.validateString)(properties.dataType)), errors.collect(cdk.propertyValidator("dataTypeSpec", cdk.validateString)(properties.dataTypeSpec)), errors.collect(cdk.propertyValidator("logicalId", cdk.requiredValidator)(properties.logicalId)), errors.collect(cdk.propertyValidator("logicalId", cdk.validateString)(properties.logicalId)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", CfnAssetModel_PropertyTypePropertyValidator)(properties.type)), errors.collect(cdk.propertyValidator("unit", cdk.validateString)(properties.unit)), errors.wrap('supplied properties not correct for "AssetModelPropertyProperty"');
    }
    function cfnAssetModelAssetModelPropertyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssetModel_AssetModelPropertyPropertyValidator(properties).assertSuccess(), { DataType: cdk.stringToCloudFormation(properties.dataType), DataTypeSpec: cdk.stringToCloudFormation(properties.dataTypeSpec), LogicalId: cdk.stringToCloudFormation(properties.logicalId), Name: cdk.stringToCloudFormation(properties.name), Type: cfnAssetModelPropertyTypePropertyToCloudFormation(properties.type), Unit: cdk.stringToCloudFormation(properties.unit) }) : properties;
    }
    function CfnAssetModelAssetModelPropertyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataType", "DataType", cfn_parse.FromCloudFormation.getString(properties.DataType)), ret.addPropertyResult("dataTypeSpec", "DataTypeSpec", properties.DataTypeSpec != null ? cfn_parse.FromCloudFormation.getString(properties.DataTypeSpec) : void 0), ret.addPropertyResult("logicalId", "LogicalId", cfn_parse.FromCloudFormation.getString(properties.LogicalId)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("type", "Type", CfnAssetModelPropertyTypePropertyFromCloudFormation(properties.Type)), ret.addPropertyResult("unit", "Unit", properties.Unit != null ? cfn_parse.FromCloudFormation.getString(properties.Unit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAssetModel_AttributePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultValue", cdk.validateString)(properties.defaultValue)), errors.wrap('supplied properties not correct for "AttributeProperty"');
    }
    function cfnAssetModelAttributePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssetModel_AttributePropertyValidator(properties).assertSuccess(), { DefaultValue: cdk.stringToCloudFormation(properties.defaultValue) }) : properties;
    }
    function CfnAssetModelAttributePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultValue", "DefaultValue", properties.DefaultValue != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAssetModel_ExpressionVariablePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", CfnAssetModel_VariableValuePropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "ExpressionVariableProperty"');
    }
    function cfnAssetModelExpressionVariablePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssetModel_ExpressionVariablePropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cfnAssetModelVariableValuePropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnAssetModelExpressionVariablePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("value", "Value", CfnAssetModelVariableValuePropertyFromCloudFormation(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAssetModel_MetricPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.collect(cdk.propertyValidator("variables", cdk.requiredValidator)(properties.variables)), errors.collect(cdk.propertyValidator("variables", cdk.listValidator(CfnAssetModel_ExpressionVariablePropertyValidator))(properties.variables)), errors.collect(cdk.propertyValidator("window", cdk.requiredValidator)(properties.window)), errors.collect(cdk.propertyValidator("window", CfnAssetModel_MetricWindowPropertyValidator)(properties.window)), errors.wrap('supplied properties not correct for "MetricProperty"');
    }
    function cfnAssetModelMetricPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssetModel_MetricPropertyValidator(properties).assertSuccess(), { Expression: cdk.stringToCloudFormation(properties.expression), Variables: cdk.listMapper(cfnAssetModelExpressionVariablePropertyToCloudFormation)(properties.variables), Window: cfnAssetModelMetricWindowPropertyToCloudFormation(properties.window) }) : properties;
    }
    function CfnAssetModelMetricPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getString(properties.Expression)), ret.addPropertyResult("variables", "Variables", cfn_parse.FromCloudFormation.getArray(CfnAssetModelExpressionVariablePropertyFromCloudFormation)(properties.Variables)), ret.addPropertyResult("window", "Window", CfnAssetModelMetricWindowPropertyFromCloudFormation(properties.Window)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAssetModel_MetricWindowPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("tumbling", CfnAssetModel_TumblingWindowPropertyValidator)(properties.tumbling)), errors.wrap('supplied properties not correct for "MetricWindowProperty"');
    }
    function cfnAssetModelMetricWindowPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssetModel_MetricWindowPropertyValidator(properties).assertSuccess(), { Tumbling: cfnAssetModelTumblingWindowPropertyToCloudFormation(properties.tumbling) }) : properties;
    }
    function CfnAssetModelMetricWindowPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("tumbling", "Tumbling", properties.Tumbling != null ? CfnAssetModelTumblingWindowPropertyFromCloudFormation(properties.Tumbling) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAssetModel_PropertyTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attribute", CfnAssetModel_AttributePropertyValidator)(properties.attribute)), errors.collect(cdk.propertyValidator("metric", CfnAssetModel_MetricPropertyValidator)(properties.metric)), errors.collect(cdk.propertyValidator("transform", CfnAssetModel_TransformPropertyValidator)(properties.transform)), errors.collect(cdk.propertyValidator("typeName", cdk.requiredValidator)(properties.typeName)), errors.collect(cdk.propertyValidator("typeName", cdk.validateString)(properties.typeName)), errors.wrap('supplied properties not correct for "PropertyTypeProperty"');
    }
    function cfnAssetModelPropertyTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssetModel_PropertyTypePropertyValidator(properties).assertSuccess(), { Attribute: cfnAssetModelAttributePropertyToCloudFormation(properties.attribute), Metric: cfnAssetModelMetricPropertyToCloudFormation(properties.metric), Transform: cfnAssetModelTransformPropertyToCloudFormation(properties.transform), TypeName: cdk.stringToCloudFormation(properties.typeName) }) : properties;
    }
    function CfnAssetModelPropertyTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attribute", "Attribute", properties.Attribute != null ? CfnAssetModelAttributePropertyFromCloudFormation(properties.Attribute) : void 0), ret.addPropertyResult("metric", "Metric", properties.Metric != null ? CfnAssetModelMetricPropertyFromCloudFormation(properties.Metric) : void 0), ret.addPropertyResult("transform", "Transform", properties.Transform != null ? CfnAssetModelTransformPropertyFromCloudFormation(properties.Transform) : void 0), ret.addPropertyResult("typeName", "TypeName", cfn_parse.FromCloudFormation.getString(properties.TypeName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAssetModel_TransformPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.collect(cdk.propertyValidator("variables", cdk.requiredValidator)(properties.variables)), errors.collect(cdk.propertyValidator("variables", cdk.listValidator(CfnAssetModel_ExpressionVariablePropertyValidator))(properties.variables)), errors.wrap('supplied properties not correct for "TransformProperty"');
    }
    function cfnAssetModelTransformPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssetModel_TransformPropertyValidator(properties).assertSuccess(), { Expression: cdk.stringToCloudFormation(properties.expression), Variables: cdk.listMapper(cfnAssetModelExpressionVariablePropertyToCloudFormation)(properties.variables) }) : properties;
    }
    function CfnAssetModelTransformPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getString(properties.Expression)), ret.addPropertyResult("variables", "Variables", cfn_parse.FromCloudFormation.getArray(CfnAssetModelExpressionVariablePropertyFromCloudFormation)(properties.Variables)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAssetModel_TumblingWindowPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("interval", cdk.requiredValidator)(properties.interval)), errors.collect(cdk.propertyValidator("interval", cdk.validateString)(properties.interval)), errors.collect(cdk.propertyValidator("offset", cdk.validateString)(properties.offset)), errors.wrap('supplied properties not correct for "TumblingWindowProperty"');
    }
    function cfnAssetModelTumblingWindowPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssetModel_TumblingWindowPropertyValidator(properties).assertSuccess(), { Interval: cdk.stringToCloudFormation(properties.interval), Offset: cdk.stringToCloudFormation(properties.offset) }) : properties;
    }
    function CfnAssetModelTumblingWindowPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("interval", "Interval", cfn_parse.FromCloudFormation.getString(properties.Interval)), ret.addPropertyResult("offset", "Offset", properties.Offset != null ? cfn_parse.FromCloudFormation.getString(properties.Offset) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAssetModel_VariableValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("hierarchyLogicalId", cdk.validateString)(properties.hierarchyLogicalId)), errors.collect(cdk.propertyValidator("propertyLogicalId", cdk.requiredValidator)(properties.propertyLogicalId)), errors.collect(cdk.propertyValidator("propertyLogicalId", cdk.validateString)(properties.propertyLogicalId)), errors.wrap('supplied properties not correct for "VariableValueProperty"');
    }
    function cfnAssetModelVariableValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssetModel_VariableValuePropertyValidator(properties).assertSuccess(), { HierarchyLogicalId: cdk.stringToCloudFormation(properties.hierarchyLogicalId), PropertyLogicalId: cdk.stringToCloudFormation(properties.propertyLogicalId) }) : properties;
    }
    function CfnAssetModelVariableValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("hierarchyLogicalId", "HierarchyLogicalId", properties.HierarchyLogicalId != null ? cfn_parse.FromCloudFormation.getString(properties.HierarchyLogicalId) : void 0), ret.addPropertyResult("propertyLogicalId", "PropertyLogicalId", cfn_parse.FromCloudFormation.getString(properties.PropertyLogicalId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboardPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dashboardDefinition", cdk.requiredValidator)(properties.dashboardDefinition)), errors.collect(cdk.propertyValidator("dashboardDefinition", cdk.validateString)(properties.dashboardDefinition)), errors.collect(cdk.propertyValidator("dashboardDescription", cdk.requiredValidator)(properties.dashboardDescription)), errors.collect(cdk.propertyValidator("dashboardDescription", cdk.validateString)(properties.dashboardDescription)), errors.collect(cdk.propertyValidator("dashboardName", cdk.requiredValidator)(properties.dashboardName)), errors.collect(cdk.propertyValidator("dashboardName", cdk.validateString)(properties.dashboardName)), errors.collect(cdk.propertyValidator("projectId", cdk.validateString)(properties.projectId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDashboardProps"');
    }
    function cfnDashboardPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboardPropsValidator(properties).assertSuccess(), { DashboardDefinition: cdk.stringToCloudFormation(properties.dashboardDefinition), DashboardDescription: cdk.stringToCloudFormation(properties.dashboardDescription), DashboardName: cdk.stringToCloudFormation(properties.dashboardName), ProjectId: cdk.stringToCloudFormation(properties.projectId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDashboardPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dashboardDefinition", "DashboardDefinition", cfn_parse.FromCloudFormation.getString(properties.DashboardDefinition)), ret.addPropertyResult("dashboardDescription", "DashboardDescription", cfn_parse.FromCloudFormation.getString(properties.DashboardDescription)), ret.addPropertyResult("dashboardName", "DashboardName", cfn_parse.FromCloudFormation.getString(properties.DashboardName)), ret.addPropertyResult("projectId", "ProjectId", properties.ProjectId != null ? cfn_parse.FromCloudFormation.getString(properties.ProjectId) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDashboard = class _CfnDashboard extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDashboardPropsFromCloudFormation(resourceProperties), ret = new _CfnDashboard(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDashboard.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotsitewise_CfnDashboardProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDashboard), error;
        }
        cdk.requireProperty(props, "dashboardDefinition", this), cdk.requireProperty(props, "dashboardDescription", this), cdk.requireProperty(props, "dashboardName", this), this.attrDashboardArn = cdk.Token.asString(this.getAtt("DashboardArn", cdk.ResolutionTypeHint.STRING)), this.attrDashboardId = cdk.Token.asString(this.getAtt("DashboardId", cdk.ResolutionTypeHint.STRING)), this.dashboardDefinition = props.dashboardDefinition, this.dashboardDescription = props.dashboardDescription, this.dashboardName = props.dashboardName, this.projectId = props.projectId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTSiteWise::Dashboard", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDashboard.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { dashboardDefinition: this.dashboardDefinition, dashboardDescription: this.dashboardDescription, dashboardName: this.dashboardName, projectId: this.projectId, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDashboardPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnDashboard[_d] = { fqn: "aws-cdk-lib.aws_iotsitewise.CfnDashboard", version: "2.80.0" }, CfnDashboard.CFN_RESOURCE_TYPE_NAME = "AWS::IoTSiteWise::Dashboard", exports2.CfnDashboard = CfnDashboard;
    function CfnGatewayPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("gatewayCapabilitySummaries", cdk.listValidator(CfnGateway_GatewayCapabilitySummaryPropertyValidator))(properties.gatewayCapabilitySummaries)), errors.collect(cdk.propertyValidator("gatewayName", cdk.requiredValidator)(properties.gatewayName)), errors.collect(cdk.propertyValidator("gatewayName", cdk.validateString)(properties.gatewayName)), errors.collect(cdk.propertyValidator("gatewayPlatform", cdk.requiredValidator)(properties.gatewayPlatform)), errors.collect(cdk.propertyValidator("gatewayPlatform", CfnGateway_GatewayPlatformPropertyValidator)(properties.gatewayPlatform)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnGatewayProps"');
    }
    function cfnGatewayPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGatewayPropsValidator(properties).assertSuccess(), { GatewayName: cdk.stringToCloudFormation(properties.gatewayName), GatewayPlatform: cfnGatewayGatewayPlatformPropertyToCloudFormation(properties.gatewayPlatform), GatewayCapabilitySummaries: cdk.listMapper(cfnGatewayGatewayCapabilitySummaryPropertyToCloudFormation)(properties.gatewayCapabilitySummaries), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnGatewayPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("gatewayName", "GatewayName", cfn_parse.FromCloudFormation.getString(properties.GatewayName)), ret.addPropertyResult("gatewayPlatform", "GatewayPlatform", CfnGatewayGatewayPlatformPropertyFromCloudFormation(properties.GatewayPlatform)), ret.addPropertyResult("gatewayCapabilitySummaries", "GatewayCapabilitySummaries", properties.GatewayCapabilitySummaries != null ? cfn_parse.FromCloudFormation.getArray(CfnGatewayGatewayCapabilitySummaryPropertyFromCloudFormation)(properties.GatewayCapabilitySummaries) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnGateway = class _CfnGateway extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnGatewayPropsFromCloudFormation(resourceProperties), ret = new _CfnGateway(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnGateway.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotsitewise_CfnGatewayProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnGateway), error;
        }
        cdk.requireProperty(props, "gatewayName", this), cdk.requireProperty(props, "gatewayPlatform", this), this.attrGatewayId = cdk.Token.asString(this.getAtt("GatewayId", cdk.ResolutionTypeHint.STRING)), this.gatewayName = props.gatewayName, this.gatewayPlatform = props.gatewayPlatform, this.gatewayCapabilitySummaries = props.gatewayCapabilitySummaries, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTSiteWise::Gateway", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnGateway.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { gatewayName: this.gatewayName, gatewayPlatform: this.gatewayPlatform, gatewayCapabilitySummaries: this.gatewayCapabilitySummaries, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnGatewayPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnGateway[_e] = { fqn: "aws-cdk-lib.aws_iotsitewise.CfnGateway", version: "2.80.0" }, CfnGateway.CFN_RESOURCE_TYPE_NAME = "AWS::IoTSiteWise::Gateway", exports2.CfnGateway = CfnGateway;
    function CfnGateway_GatewayCapabilitySummaryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("capabilityConfiguration", cdk.validateString)(properties.capabilityConfiguration)), errors.collect(cdk.propertyValidator("capabilityNamespace", cdk.requiredValidator)(properties.capabilityNamespace)), errors.collect(cdk.propertyValidator("capabilityNamespace", cdk.validateString)(properties.capabilityNamespace)), errors.wrap('supplied properties not correct for "GatewayCapabilitySummaryProperty"');
    }
    function cfnGatewayGatewayCapabilitySummaryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGateway_GatewayCapabilitySummaryPropertyValidator(properties).assertSuccess(), { CapabilityConfiguration: cdk.stringToCloudFormation(properties.capabilityConfiguration), CapabilityNamespace: cdk.stringToCloudFormation(properties.capabilityNamespace) }) : properties;
    }
    function CfnGatewayGatewayCapabilitySummaryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("capabilityConfiguration", "CapabilityConfiguration", properties.CapabilityConfiguration != null ? cfn_parse.FromCloudFormation.getString(properties.CapabilityConfiguration) : void 0), ret.addPropertyResult("capabilityNamespace", "CapabilityNamespace", cfn_parse.FromCloudFormation.getString(properties.CapabilityNamespace)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGateway_GatewayPlatformPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("greengrass", CfnGateway_GreengrassPropertyValidator)(properties.greengrass)), errors.collect(cdk.propertyValidator("greengrassV2", CfnGateway_GreengrassV2PropertyValidator)(properties.greengrassV2)), errors.wrap('supplied properties not correct for "GatewayPlatformProperty"');
    }
    function cfnGatewayGatewayPlatformPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGateway_GatewayPlatformPropertyValidator(properties).assertSuccess(), { Greengrass: cfnGatewayGreengrassPropertyToCloudFormation(properties.greengrass), GreengrassV2: cfnGatewayGreengrassV2PropertyToCloudFormation(properties.greengrassV2) }) : properties;
    }
    function CfnGatewayGatewayPlatformPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("greengrass", "Greengrass", properties.Greengrass != null ? CfnGatewayGreengrassPropertyFromCloudFormation(properties.Greengrass) : void 0), ret.addPropertyResult("greengrassV2", "GreengrassV2", properties.GreengrassV2 != null ? CfnGatewayGreengrassV2PropertyFromCloudFormation(properties.GreengrassV2) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGateway_GreengrassPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groupArn", cdk.requiredValidator)(properties.groupArn)), errors.collect(cdk.propertyValidator("groupArn", cdk.validateString)(properties.groupArn)), errors.wrap('supplied properties not correct for "GreengrassProperty"');
    }
    function cfnGatewayGreengrassPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGateway_GreengrassPropertyValidator(properties).assertSuccess(), { GroupArn: cdk.stringToCloudFormation(properties.groupArn) }) : properties;
    }
    function CfnGatewayGreengrassPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupArn", "GroupArn", cfn_parse.FromCloudFormation.getString(properties.GroupArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGateway_GreengrassV2PropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("coreDeviceThingName", cdk.requiredValidator)(properties.coreDeviceThingName)), errors.collect(cdk.propertyValidator("coreDeviceThingName", cdk.validateString)(properties.coreDeviceThingName)), errors.wrap('supplied properties not correct for "GreengrassV2Property"');
    }
    function cfnGatewayGreengrassV2PropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGateway_GreengrassV2PropertyValidator(properties).assertSuccess(), { CoreDeviceThingName: cdk.stringToCloudFormation(properties.coreDeviceThingName) }) : properties;
    }
    function CfnGatewayGreengrassV2PropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("coreDeviceThingName", "CoreDeviceThingName", cfn_parse.FromCloudFormation.getString(properties.CoreDeviceThingName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPortalPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alarms", cdk.validateObject)(properties.alarms)), errors.collect(cdk.propertyValidator("notificationSenderEmail", cdk.validateString)(properties.notificationSenderEmail)), errors.collect(cdk.propertyValidator("portalAuthMode", cdk.validateString)(properties.portalAuthMode)), errors.collect(cdk.propertyValidator("portalContactEmail", cdk.requiredValidator)(properties.portalContactEmail)), errors.collect(cdk.propertyValidator("portalContactEmail", cdk.validateString)(properties.portalContactEmail)), errors.collect(cdk.propertyValidator("portalDescription", cdk.validateString)(properties.portalDescription)), errors.collect(cdk.propertyValidator("portalName", cdk.requiredValidator)(properties.portalName)), errors.collect(cdk.propertyValidator("portalName", cdk.validateString)(properties.portalName)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnPortalProps"');
    }
    function cfnPortalPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPortalPropsValidator(properties).assertSuccess(), { PortalContactEmail: cdk.stringToCloudFormation(properties.portalContactEmail), PortalName: cdk.stringToCloudFormation(properties.portalName), RoleArn: cdk.stringToCloudFormation(properties.roleArn), Alarms: cdk.objectToCloudFormation(properties.alarms), NotificationSenderEmail: cdk.stringToCloudFormation(properties.notificationSenderEmail), PortalAuthMode: cdk.stringToCloudFormation(properties.portalAuthMode), PortalDescription: cdk.stringToCloudFormation(properties.portalDescription), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnPortalPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("portalContactEmail", "PortalContactEmail", cfn_parse.FromCloudFormation.getString(properties.PortalContactEmail)), ret.addPropertyResult("portalName", "PortalName", cfn_parse.FromCloudFormation.getString(properties.PortalName)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("alarms", "Alarms", properties.Alarms != null ? cfn_parse.FromCloudFormation.getAny(properties.Alarms) : void 0), ret.addPropertyResult("notificationSenderEmail", "NotificationSenderEmail", properties.NotificationSenderEmail != null ? cfn_parse.FromCloudFormation.getString(properties.NotificationSenderEmail) : void 0), ret.addPropertyResult("portalAuthMode", "PortalAuthMode", properties.PortalAuthMode != null ? cfn_parse.FromCloudFormation.getString(properties.PortalAuthMode) : void 0), ret.addPropertyResult("portalDescription", "PortalDescription", properties.PortalDescription != null ? cfn_parse.FromCloudFormation.getString(properties.PortalDescription) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPortal = class _CfnPortal extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPortalPropsFromCloudFormation(resourceProperties), ret = new _CfnPortal(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPortal.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotsitewise_CfnPortalProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPortal), error;
        }
        cdk.requireProperty(props, "portalContactEmail", this), cdk.requireProperty(props, "portalName", this), cdk.requireProperty(props, "roleArn", this), this.attrPortalArn = cdk.Token.asString(this.getAtt("PortalArn", cdk.ResolutionTypeHint.STRING)), this.attrPortalClientId = cdk.Token.asString(this.getAtt("PortalClientId", cdk.ResolutionTypeHint.STRING)), this.attrPortalId = cdk.Token.asString(this.getAtt("PortalId", cdk.ResolutionTypeHint.STRING)), this.attrPortalStartUrl = cdk.Token.asString(this.getAtt("PortalStartUrl", cdk.ResolutionTypeHint.STRING)), this.portalContactEmail = props.portalContactEmail, this.portalName = props.portalName, this.roleArn = props.roleArn, this.alarms = props.alarms, this.notificationSenderEmail = props.notificationSenderEmail, this.portalAuthMode = props.portalAuthMode, this.portalDescription = props.portalDescription, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTSiteWise::Portal", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPortal.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { portalContactEmail: this.portalContactEmail, portalName: this.portalName, roleArn: this.roleArn, alarms: this.alarms, notificationSenderEmail: this.notificationSenderEmail, portalAuthMode: this.portalAuthMode, portalDescription: this.portalDescription, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnPortalPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnPortal[_f] = { fqn: "aws-cdk-lib.aws_iotsitewise.CfnPortal", version: "2.80.0" }, CfnPortal.CFN_RESOURCE_TYPE_NAME = "AWS::IoTSiteWise::Portal", exports2.CfnPortal = CfnPortal;
    function CfnProjectPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("assetIds", cdk.listValidator(cdk.validateString))(properties.assetIds)), errors.collect(cdk.propertyValidator("portalId", cdk.requiredValidator)(properties.portalId)), errors.collect(cdk.propertyValidator("portalId", cdk.validateString)(properties.portalId)), errors.collect(cdk.propertyValidator("projectDescription", cdk.validateString)(properties.projectDescription)), errors.collect(cdk.propertyValidator("projectName", cdk.requiredValidator)(properties.projectName)), errors.collect(cdk.propertyValidator("projectName", cdk.validateString)(properties.projectName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnProjectProps"');
    }
    function cfnProjectPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProjectPropsValidator(properties).assertSuccess(), { PortalId: cdk.stringToCloudFormation(properties.portalId), ProjectName: cdk.stringToCloudFormation(properties.projectName), AssetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.assetIds), ProjectDescription: cdk.stringToCloudFormation(properties.projectDescription), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnProjectPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("portalId", "PortalId", cfn_parse.FromCloudFormation.getString(properties.PortalId)), ret.addPropertyResult("projectName", "ProjectName", cfn_parse.FromCloudFormation.getString(properties.ProjectName)), ret.addPropertyResult("assetIds", "AssetIds", properties.AssetIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AssetIds) : void 0), ret.addPropertyResult("projectDescription", "ProjectDescription", properties.ProjectDescription != null ? cfn_parse.FromCloudFormation.getString(properties.ProjectDescription) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnProject = class _CfnProject extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnProjectPropsFromCloudFormation(resourceProperties), ret = new _CfnProject(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnProject.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotsitewise_CfnProjectProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnProject), error;
        }
        cdk.requireProperty(props, "portalId", this), cdk.requireProperty(props, "projectName", this), this.attrProjectArn = cdk.Token.asString(this.getAtt("ProjectArn", cdk.ResolutionTypeHint.STRING)), this.attrProjectId = cdk.Token.asString(this.getAtt("ProjectId", cdk.ResolutionTypeHint.STRING)), this.portalId = props.portalId, this.projectName = props.projectName, this.assetIds = props.assetIds, this.projectDescription = props.projectDescription, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTSiteWise::Project", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnProject.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { portalId: this.portalId, projectName: this.projectName, assetIds: this.assetIds, projectDescription: this.projectDescription, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnProjectPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnProject[_g] = { fqn: "aws-cdk-lib.aws_iotsitewise.CfnProject", version: "2.80.0" }, CfnProject.CFN_RESOURCE_TYPE_NAME = "AWS::IoTSiteWise::Project", exports2.CfnProject = CfnProject;
  }
});

// node_modules/aws-cdk-lib/aws-iotsitewise/lib/index.js
var require_lib156 = __commonJS({
  "node_modules/aws-cdk-lib/aws-iotsitewise/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_iotsitewise_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-iotsitewise/index.js
var require_aws_iotsitewise = __commonJS({
  "node_modules/aws-cdk-lib/aws-iotsitewise/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib156(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-iotthingsgraph/lib/iotthingsgraph.generated.js
var require_iotthingsgraph_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-iotthingsgraph/lib/iotthingsgraph.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnFlowTemplate = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnFlowTemplatePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("compatibleNamespaceVersion", cdk.validateNumber)(properties.compatibleNamespaceVersion)), errors.collect(cdk.propertyValidator("definition", cdk.requiredValidator)(properties.definition)), errors.collect(cdk.propertyValidator("definition", CfnFlowTemplate_DefinitionDocumentPropertyValidator)(properties.definition)), errors.wrap('supplied properties not correct for "CfnFlowTemplateProps"');
    }
    function cfnFlowTemplatePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlowTemplatePropsValidator(properties).assertSuccess(), { Definition: cfnFlowTemplateDefinitionDocumentPropertyToCloudFormation(properties.definition), CompatibleNamespaceVersion: cdk.numberToCloudFormation(properties.compatibleNamespaceVersion) }) : properties;
    }
    function CfnFlowTemplatePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("definition", "Definition", CfnFlowTemplateDefinitionDocumentPropertyFromCloudFormation(properties.Definition)), ret.addPropertyResult("compatibleNamespaceVersion", "CompatibleNamespaceVersion", properties.CompatibleNamespaceVersion != null ? cfn_parse.FromCloudFormation.getNumber(properties.CompatibleNamespaceVersion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFlowTemplate = class _CfnFlowTemplate extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFlowTemplatePropsFromCloudFormation(resourceProperties), ret = new _CfnFlowTemplate(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFlowTemplate.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotthingsgraph_CfnFlowTemplateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFlowTemplate), error;
        }
        cdk.requireProperty(props, "definition", this), this.definition = props.definition, this.compatibleNamespaceVersion = props.compatibleNamespaceVersion;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFlowTemplate.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { definition: this.definition, compatibleNamespaceVersion: this.compatibleNamespaceVersion };
      }
      renderProperties(props) {
        return cfnFlowTemplatePropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnFlowTemplate[_a] = { fqn: "aws-cdk-lib.aws_iotthingsgraph.CfnFlowTemplate", version: "2.80.0" }, CfnFlowTemplate.CFN_RESOURCE_TYPE_NAME = "AWS::IoTThingsGraph::FlowTemplate", exports2.CfnFlowTemplate = CfnFlowTemplate;
    function CfnFlowTemplate_DefinitionDocumentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("language", cdk.requiredValidator)(properties.language)), errors.collect(cdk.propertyValidator("language", cdk.validateString)(properties.language)), errors.collect(cdk.propertyValidator("text", cdk.requiredValidator)(properties.text)), errors.collect(cdk.propertyValidator("text", cdk.validateString)(properties.text)), errors.wrap('supplied properties not correct for "DefinitionDocumentProperty"');
    }
    function cfnFlowTemplateDefinitionDocumentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlowTemplate_DefinitionDocumentPropertyValidator(properties).assertSuccess(), { Language: cdk.stringToCloudFormation(properties.language), Text: cdk.stringToCloudFormation(properties.text) }) : properties;
    }
    function CfnFlowTemplateDefinitionDocumentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("language", "Language", cfn_parse.FromCloudFormation.getString(properties.Language)), ret.addPropertyResult("text", "Text", cfn_parse.FromCloudFormation.getString(properties.Text)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-iotthingsgraph/lib/index.js
var require_lib157 = __commonJS({
  "node_modules/aws-cdk-lib/aws-iotthingsgraph/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_iotthingsgraph_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-iotthingsgraph/index.js
var require_aws_iotthingsgraph = __commonJS({
  "node_modules/aws-cdk-lib/aws-iotthingsgraph/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib157(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-iottwinmaker/lib/iottwinmaker.generated.js
var require_iottwinmaker_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-iottwinmaker/lib/iottwinmaker.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnWorkspace = exports2.CfnSyncJob = exports2.CfnScene = exports2.CfnEntity = exports2.CfnComponentType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnComponentTypePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("componentTypeId", cdk.requiredValidator)(properties.componentTypeId)), errors.collect(cdk.propertyValidator("componentTypeId", cdk.validateString)(properties.componentTypeId)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("extendsFrom", cdk.listValidator(cdk.validateString))(properties.extendsFrom)), errors.collect(cdk.propertyValidator("functions", cdk.hashValidator(CfnComponentType_FunctionPropertyValidator))(properties.functions)), errors.collect(cdk.propertyValidator("isSingleton", cdk.validateBoolean)(properties.isSingleton)), errors.collect(cdk.propertyValidator("propertyDefinitions", cdk.hashValidator(CfnComponentType_PropertyDefinitionPropertyValidator))(properties.propertyDefinitions)), errors.collect(cdk.propertyValidator("propertyGroups", cdk.hashValidator(CfnComponentType_PropertyGroupPropertyValidator))(properties.propertyGroups)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.collect(cdk.propertyValidator("workspaceId", cdk.requiredValidator)(properties.workspaceId)), errors.collect(cdk.propertyValidator("workspaceId", cdk.validateString)(properties.workspaceId)), errors.wrap('supplied properties not correct for "CfnComponentTypeProps"');
    }
    function cfnComponentTypePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponentTypePropsValidator(properties).assertSuccess(), { ComponentTypeId: cdk.stringToCloudFormation(properties.componentTypeId), WorkspaceId: cdk.stringToCloudFormation(properties.workspaceId), Description: cdk.stringToCloudFormation(properties.description), ExtendsFrom: cdk.listMapper(cdk.stringToCloudFormation)(properties.extendsFrom), Functions: cdk.hashMapper(cfnComponentTypeFunctionPropertyToCloudFormation)(properties.functions), IsSingleton: cdk.booleanToCloudFormation(properties.isSingleton), PropertyDefinitions: cdk.hashMapper(cfnComponentTypePropertyDefinitionPropertyToCloudFormation)(properties.propertyDefinitions), PropertyGroups: cdk.hashMapper(cfnComponentTypePropertyGroupPropertyToCloudFormation)(properties.propertyGroups), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnComponentTypePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("componentTypeId", "ComponentTypeId", cfn_parse.FromCloudFormation.getString(properties.ComponentTypeId)), ret.addPropertyResult("workspaceId", "WorkspaceId", cfn_parse.FromCloudFormation.getString(properties.WorkspaceId)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("extendsFrom", "ExtendsFrom", properties.ExtendsFrom != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExtendsFrom) : void 0), ret.addPropertyResult("functions", "Functions", properties.Functions != null ? cfn_parse.FromCloudFormation.getMap(CfnComponentTypeFunctionPropertyFromCloudFormation)(properties.Functions) : void 0), ret.addPropertyResult("isSingleton", "IsSingleton", properties.IsSingleton != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsSingleton) : void 0), ret.addPropertyResult("propertyDefinitions", "PropertyDefinitions", properties.PropertyDefinitions != null ? cfn_parse.FromCloudFormation.getMap(CfnComponentTypePropertyDefinitionPropertyFromCloudFormation)(properties.PropertyDefinitions) : void 0), ret.addPropertyResult("propertyGroups", "PropertyGroups", properties.PropertyGroups != null ? cfn_parse.FromCloudFormation.getMap(CfnComponentTypePropertyGroupPropertyFromCloudFormation)(properties.PropertyGroups) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnComponentType = class _CfnComponentType extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnComponentTypePropsFromCloudFormation(resourceProperties), ret = new _CfnComponentType(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnComponentType.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iottwinmaker_CfnComponentTypeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnComponentType), error;
        }
        cdk.requireProperty(props, "componentTypeId", this), cdk.requireProperty(props, "workspaceId", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreationDateTime = cdk.Token.asString(this.getAtt("CreationDateTime", cdk.ResolutionTypeHint.STRING)), this.attrIsAbstract = this.getAtt("IsAbstract", cdk.ResolutionTypeHint.STRING), this.attrIsSchemaInitialized = this.getAtt("IsSchemaInitialized", cdk.ResolutionTypeHint.STRING), this.attrStatusErrorCode = cdk.Token.asString(this.getAtt("Status.Error.Code", cdk.ResolutionTypeHint.STRING)), this.attrStatusErrorMessage = cdk.Token.asString(this.getAtt("Status.Error.Message", cdk.ResolutionTypeHint.STRING)), this.attrStatusState = cdk.Token.asString(this.getAtt("Status.State", cdk.ResolutionTypeHint.STRING)), this.attrUpdateDateTime = cdk.Token.asString(this.getAtt("UpdateDateTime", cdk.ResolutionTypeHint.STRING)), this.componentTypeId = props.componentTypeId, this.workspaceId = props.workspaceId, this.description = props.description, this.extendsFrom = props.extendsFrom, this.functions = props.functions, this.isSingleton = props.isSingleton, this.propertyDefinitions = props.propertyDefinitions, this.propertyGroups = props.propertyGroups, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::IoTTwinMaker::ComponentType", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnComponentType.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { componentTypeId: this.componentTypeId, workspaceId: this.workspaceId, description: this.description, extendsFrom: this.extendsFrom, functions: this.functions, isSingleton: this.isSingleton, propertyDefinitions: this.propertyDefinitions, propertyGroups: this.propertyGroups, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnComponentTypePropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnComponentType[_a] = { fqn: "aws-cdk-lib.aws_iottwinmaker.CfnComponentType", version: "2.80.0" }, CfnComponentType.CFN_RESOURCE_TYPE_NAME = "AWS::IoTTwinMaker::ComponentType", exports2.CfnComponentType = CfnComponentType;
    function CfnComponentType_DataConnectorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("isNative", cdk.validateBoolean)(properties.isNative)), errors.collect(cdk.propertyValidator("lambda", CfnComponentType_LambdaFunctionPropertyValidator)(properties.lambda)), errors.wrap('supplied properties not correct for "DataConnectorProperty"');
    }
    function cfnComponentTypeDataConnectorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponentType_DataConnectorPropertyValidator(properties).assertSuccess(), { IsNative: cdk.booleanToCloudFormation(properties.isNative), Lambda: cfnComponentTypeLambdaFunctionPropertyToCloudFormation(properties.lambda) }) : properties;
    }
    function CfnComponentTypeDataConnectorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("isNative", "IsNative", properties.IsNative != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsNative) : void 0), ret.addPropertyResult("lambda", "Lambda", properties.Lambda != null ? CfnComponentTypeLambdaFunctionPropertyFromCloudFormation(properties.Lambda) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComponentType_DataTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowedValues", cdk.listValidator(CfnComponentType_DataValuePropertyValidator))(properties.allowedValues)), errors.collect(cdk.propertyValidator("nestedType", CfnComponentType_DataTypePropertyValidator)(properties.nestedType)), errors.collect(cdk.propertyValidator("relationship", CfnComponentType_RelationshipPropertyValidator)(properties.relationship)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("unitOfMeasure", cdk.validateString)(properties.unitOfMeasure)), errors.wrap('supplied properties not correct for "DataTypeProperty"');
    }
    function cfnComponentTypeDataTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponentType_DataTypePropertyValidator(properties).assertSuccess(), { AllowedValues: cdk.listMapper(cfnComponentTypeDataValuePropertyToCloudFormation)(properties.allowedValues), NestedType: cfnComponentTypeDataTypePropertyToCloudFormation(properties.nestedType), Relationship: cfnComponentTypeRelationshipPropertyToCloudFormation(properties.relationship), Type: cdk.stringToCloudFormation(properties.type), UnitOfMeasure: cdk.stringToCloudFormation(properties.unitOfMeasure) }) : properties;
    }
    function CfnComponentTypeDataTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowedValues", "AllowedValues", properties.AllowedValues != null ? cfn_parse.FromCloudFormation.getArray(CfnComponentTypeDataValuePropertyFromCloudFormation)(properties.AllowedValues) : void 0), ret.addPropertyResult("nestedType", "NestedType", properties.NestedType != null ? CfnComponentTypeDataTypePropertyFromCloudFormation(properties.NestedType) : void 0), ret.addPropertyResult("relationship", "Relationship", properties.Relationship != null ? CfnComponentTypeRelationshipPropertyFromCloudFormation(properties.Relationship) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("unitOfMeasure", "UnitOfMeasure", properties.UnitOfMeasure != null ? cfn_parse.FromCloudFormation.getString(properties.UnitOfMeasure) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComponentType_DataValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("booleanValue", cdk.validateBoolean)(properties.booleanValue)), errors.collect(cdk.propertyValidator("doubleValue", cdk.validateNumber)(properties.doubleValue)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.collect(cdk.propertyValidator("integerValue", cdk.validateNumber)(properties.integerValue)), errors.collect(cdk.propertyValidator("listValue", cdk.listValidator(CfnComponentType_DataValuePropertyValidator))(properties.listValue)), errors.collect(cdk.propertyValidator("longValue", cdk.validateNumber)(properties.longValue)), errors.collect(cdk.propertyValidator("mapValue", cdk.hashValidator(CfnComponentType_DataValuePropertyValidator))(properties.mapValue)), errors.collect(cdk.propertyValidator("relationshipValue", cdk.validateObject)(properties.relationshipValue)), errors.collect(cdk.propertyValidator("stringValue", cdk.validateString)(properties.stringValue)), errors.wrap('supplied properties not correct for "DataValueProperty"');
    }
    function cfnComponentTypeDataValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponentType_DataValuePropertyValidator(properties).assertSuccess(), { BooleanValue: cdk.booleanToCloudFormation(properties.booleanValue), DoubleValue: cdk.numberToCloudFormation(properties.doubleValue), Expression: cdk.stringToCloudFormation(properties.expression), IntegerValue: cdk.numberToCloudFormation(properties.integerValue), ListValue: cdk.listMapper(cfnComponentTypeDataValuePropertyToCloudFormation)(properties.listValue), LongValue: cdk.numberToCloudFormation(properties.longValue), MapValue: cdk.hashMapper(cfnComponentTypeDataValuePropertyToCloudFormation)(properties.mapValue), RelationshipValue: cdk.objectToCloudFormation(properties.relationshipValue), StringValue: cdk.stringToCloudFormation(properties.stringValue) }) : properties;
    }
    function CfnComponentTypeDataValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("booleanValue", "BooleanValue", properties.BooleanValue != null ? cfn_parse.FromCloudFormation.getBoolean(properties.BooleanValue) : void 0), ret.addPropertyResult("doubleValue", "DoubleValue", properties.DoubleValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.DoubleValue) : void 0), ret.addPropertyResult("expression", "Expression", properties.Expression != null ? cfn_parse.FromCloudFormation.getString(properties.Expression) : void 0), ret.addPropertyResult("integerValue", "IntegerValue", properties.IntegerValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.IntegerValue) : void 0), ret.addPropertyResult("listValue", "ListValue", properties.ListValue != null ? cfn_parse.FromCloudFormation.getArray(CfnComponentTypeDataValuePropertyFromCloudFormation)(properties.ListValue) : void 0), ret.addPropertyResult("longValue", "LongValue", properties.LongValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.LongValue) : void 0), ret.addPropertyResult("mapValue", "MapValue", properties.MapValue != null ? cfn_parse.FromCloudFormation.getMap(CfnComponentTypeDataValuePropertyFromCloudFormation)(properties.MapValue) : void 0), ret.addPropertyResult("relationshipValue", "RelationshipValue", properties.RelationshipValue != null ? cfn_parse.FromCloudFormation.getAny(properties.RelationshipValue) : void 0), ret.addPropertyResult("stringValue", "StringValue", properties.StringValue != null ? cfn_parse.FromCloudFormation.getString(properties.StringValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComponentType_FunctionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("implementedBy", CfnComponentType_DataConnectorPropertyValidator)(properties.implementedBy)), errors.collect(cdk.propertyValidator("requiredProperties", cdk.listValidator(cdk.validateString))(properties.requiredProperties)), errors.collect(cdk.propertyValidator("scope", cdk.validateString)(properties.scope)), errors.wrap('supplied properties not correct for "FunctionProperty"');
    }
    function cfnComponentTypeFunctionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponentType_FunctionPropertyValidator(properties).assertSuccess(), { ImplementedBy: cfnComponentTypeDataConnectorPropertyToCloudFormation(properties.implementedBy), RequiredProperties: cdk.listMapper(cdk.stringToCloudFormation)(properties.requiredProperties), Scope: cdk.stringToCloudFormation(properties.scope) }) : properties;
    }
    function CfnComponentTypeFunctionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("implementedBy", "ImplementedBy", properties.ImplementedBy != null ? CfnComponentTypeDataConnectorPropertyFromCloudFormation(properties.ImplementedBy) : void 0), ret.addPropertyResult("requiredProperties", "RequiredProperties", properties.RequiredProperties != null ? cfn_parse.FromCloudFormation.getStringArray(properties.RequiredProperties) : void 0), ret.addPropertyResult("scope", "Scope", properties.Scope != null ? cfn_parse.FromCloudFormation.getString(properties.Scope) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComponentType_LambdaFunctionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.requiredValidator)(properties.arn)), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.wrap('supplied properties not correct for "LambdaFunctionProperty"');
    }
    function cfnComponentTypeLambdaFunctionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponentType_LambdaFunctionPropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn) }) : properties;
    }
    function CfnComponentTypeLambdaFunctionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", cfn_parse.FromCloudFormation.getString(properties.Arn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComponentType_PropertyDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configurations", cdk.hashValidator(cdk.validateString))(properties.configurations)), errors.collect(cdk.propertyValidator("dataType", CfnComponentType_DataTypePropertyValidator)(properties.dataType)), errors.collect(cdk.propertyValidator("defaultValue", CfnComponentType_DataValuePropertyValidator)(properties.defaultValue)), errors.collect(cdk.propertyValidator("isExternalId", cdk.validateBoolean)(properties.isExternalId)), errors.collect(cdk.propertyValidator("isRequiredInEntity", cdk.validateBoolean)(properties.isRequiredInEntity)), errors.collect(cdk.propertyValidator("isStoredExternally", cdk.validateBoolean)(properties.isStoredExternally)), errors.collect(cdk.propertyValidator("isTimeSeries", cdk.validateBoolean)(properties.isTimeSeries)), errors.wrap('supplied properties not correct for "PropertyDefinitionProperty"');
    }
    function cfnComponentTypePropertyDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponentType_PropertyDefinitionPropertyValidator(properties).assertSuccess(), { Configurations: cdk.hashMapper(cdk.stringToCloudFormation)(properties.configurations), DataType: cfnComponentTypeDataTypePropertyToCloudFormation(properties.dataType), DefaultValue: cfnComponentTypeDataValuePropertyToCloudFormation(properties.defaultValue), IsExternalId: cdk.booleanToCloudFormation(properties.isExternalId), IsRequiredInEntity: cdk.booleanToCloudFormation(properties.isRequiredInEntity), IsStoredExternally: cdk.booleanToCloudFormation(properties.isStoredExternally), IsTimeSeries: cdk.booleanToCloudFormation(properties.isTimeSeries) }) : properties;
    }
    function CfnComponentTypePropertyDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configurations", "Configurations", properties.Configurations != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Configurations) : void 0), ret.addPropertyResult("dataType", "DataType", properties.DataType != null ? CfnComponentTypeDataTypePropertyFromCloudFormation(properties.DataType) : void 0), ret.addPropertyResult("defaultValue", "DefaultValue", properties.DefaultValue != null ? CfnComponentTypeDataValuePropertyFromCloudFormation(properties.DefaultValue) : void 0), ret.addPropertyResult("isExternalId", "IsExternalId", properties.IsExternalId != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsExternalId) : void 0), ret.addPropertyResult("isRequiredInEntity", "IsRequiredInEntity", properties.IsRequiredInEntity != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsRequiredInEntity) : void 0), ret.addPropertyResult("isStoredExternally", "IsStoredExternally", properties.IsStoredExternally != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsStoredExternally) : void 0), ret.addPropertyResult("isTimeSeries", "IsTimeSeries", properties.IsTimeSeries != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsTimeSeries) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComponentType_PropertyGroupPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groupType", cdk.validateString)(properties.groupType)), errors.collect(cdk.propertyValidator("propertyNames", cdk.listValidator(cdk.validateString))(properties.propertyNames)), errors.wrap('supplied properties not correct for "PropertyGroupProperty"');
    }
    function cfnComponentTypePropertyGroupPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponentType_PropertyGroupPropertyValidator(properties).assertSuccess(), { GroupType: cdk.stringToCloudFormation(properties.groupType), PropertyNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.propertyNames) }) : properties;
    }
    function CfnComponentTypePropertyGroupPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupType", "GroupType", properties.GroupType != null ? cfn_parse.FromCloudFormation.getString(properties.GroupType) : void 0), ret.addPropertyResult("propertyNames", "PropertyNames", properties.PropertyNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.PropertyNames) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnComponentType_RelationshipPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("relationshipType", cdk.validateString)(properties.relationshipType)), errors.collect(cdk.propertyValidator("targetComponentTypeId", cdk.validateString)(properties.targetComponentTypeId)), errors.wrap('supplied properties not correct for "RelationshipProperty"');
    }
    function cfnComponentTypeRelationshipPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnComponentType_RelationshipPropertyValidator(properties).assertSuccess(), { RelationshipType: cdk.stringToCloudFormation(properties.relationshipType), TargetComponentTypeId: cdk.stringToCloudFormation(properties.targetComponentTypeId) }) : properties;
    }
    function CfnComponentTypeRelationshipPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("relationshipType", "RelationshipType", properties.RelationshipType != null ? cfn_parse.FromCloudFormation.getString(properties.RelationshipType) : void 0), ret.addPropertyResult("targetComponentTypeId", "TargetComponentTypeId", properties.TargetComponentTypeId != null ? cfn_parse.FromCloudFormation.getString(properties.TargetComponentTypeId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEntityPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("components", cdk.hashValidator(CfnEntity_ComponentPropertyValidator))(properties.components)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("entityId", cdk.validateString)(properties.entityId)), errors.collect(cdk.propertyValidator("entityName", cdk.requiredValidator)(properties.entityName)), errors.collect(cdk.propertyValidator("entityName", cdk.validateString)(properties.entityName)), errors.collect(cdk.propertyValidator("parentEntityId", cdk.validateString)(properties.parentEntityId)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.collect(cdk.propertyValidator("workspaceId", cdk.requiredValidator)(properties.workspaceId)), errors.collect(cdk.propertyValidator("workspaceId", cdk.validateString)(properties.workspaceId)), errors.wrap('supplied properties not correct for "CfnEntityProps"');
    }
    function cfnEntityPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEntityPropsValidator(properties).assertSuccess(), { EntityName: cdk.stringToCloudFormation(properties.entityName), WorkspaceId: cdk.stringToCloudFormation(properties.workspaceId), Components: cdk.hashMapper(cfnEntityComponentPropertyToCloudFormation)(properties.components), Description: cdk.stringToCloudFormation(properties.description), EntityId: cdk.stringToCloudFormation(properties.entityId), ParentEntityId: cdk.stringToCloudFormation(properties.parentEntityId), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnEntityPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("entityName", "EntityName", cfn_parse.FromCloudFormation.getString(properties.EntityName)), ret.addPropertyResult("workspaceId", "WorkspaceId", cfn_parse.FromCloudFormation.getString(properties.WorkspaceId)), ret.addPropertyResult("components", "Components", properties.Components != null ? cfn_parse.FromCloudFormation.getMap(CfnEntityComponentPropertyFromCloudFormation)(properties.Components) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("entityId", "EntityId", properties.EntityId != null ? cfn_parse.FromCloudFormation.getString(properties.EntityId) : void 0), ret.addPropertyResult("parentEntityId", "ParentEntityId", properties.ParentEntityId != null ? cfn_parse.FromCloudFormation.getString(properties.ParentEntityId) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEntity = class _CfnEntity extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEntityPropsFromCloudFormation(resourceProperties), ret = new _CfnEntity(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEntity.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iottwinmaker_CfnEntityProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEntity), error;
        }
        cdk.requireProperty(props, "entityName", this), cdk.requireProperty(props, "workspaceId", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreationDateTime = cdk.Token.asString(this.getAtt("CreationDateTime", cdk.ResolutionTypeHint.STRING)), this.attrHasChildEntities = this.getAtt("HasChildEntities", cdk.ResolutionTypeHint.STRING), this.attrStatusErrorCode = cdk.Token.asString(this.getAtt("Status.Error.Code", cdk.ResolutionTypeHint.STRING)), this.attrStatusErrorMessage = cdk.Token.asString(this.getAtt("Status.Error.Message", cdk.ResolutionTypeHint.STRING)), this.attrStatusState = cdk.Token.asString(this.getAtt("Status.State", cdk.ResolutionTypeHint.STRING)), this.attrUpdateDateTime = cdk.Token.asString(this.getAtt("UpdateDateTime", cdk.ResolutionTypeHint.STRING)), this.entityName = props.entityName, this.workspaceId = props.workspaceId, this.components = props.components, this.description = props.description, this.entityId = props.entityId, this.parentEntityId = props.parentEntityId, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::IoTTwinMaker::Entity", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEntity.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { entityName: this.entityName, workspaceId: this.workspaceId, components: this.components, description: this.description, entityId: this.entityId, parentEntityId: this.parentEntityId, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnEntityPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnEntity[_b] = { fqn: "aws-cdk-lib.aws_iottwinmaker.CfnEntity", version: "2.80.0" }, CfnEntity.CFN_RESOURCE_TYPE_NAME = "AWS::IoTTwinMaker::Entity", exports2.CfnEntity = CfnEntity;
    function CfnEntity_ComponentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("componentName", cdk.validateString)(properties.componentName)), errors.collect(cdk.propertyValidator("componentTypeId", cdk.validateString)(properties.componentTypeId)), errors.collect(cdk.propertyValidator("definedIn", cdk.validateString)(properties.definedIn)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("properties", cdk.hashValidator(CfnEntity_PropertyPropertyValidator))(properties.properties)), errors.collect(cdk.propertyValidator("propertyGroups", cdk.hashValidator(CfnEntity_PropertyGroupPropertyValidator))(properties.propertyGroups)), errors.collect(cdk.propertyValidator("status", CfnEntity_StatusPropertyValidator)(properties.status)), errors.wrap('supplied properties not correct for "ComponentProperty"');
    }
    function cfnEntityComponentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEntity_ComponentPropertyValidator(properties).assertSuccess(), { ComponentName: cdk.stringToCloudFormation(properties.componentName), ComponentTypeId: cdk.stringToCloudFormation(properties.componentTypeId), DefinedIn: cdk.stringToCloudFormation(properties.definedIn), Description: cdk.stringToCloudFormation(properties.description), Properties: cdk.hashMapper(cfnEntityPropertyPropertyToCloudFormation)(properties.properties), PropertyGroups: cdk.hashMapper(cfnEntityPropertyGroupPropertyToCloudFormation)(properties.propertyGroups), Status: cfnEntityStatusPropertyToCloudFormation(properties.status) }) : properties;
    }
    function CfnEntityComponentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("componentName", "ComponentName", properties.ComponentName != null ? cfn_parse.FromCloudFormation.getString(properties.ComponentName) : void 0), ret.addPropertyResult("componentTypeId", "ComponentTypeId", properties.ComponentTypeId != null ? cfn_parse.FromCloudFormation.getString(properties.ComponentTypeId) : void 0), ret.addPropertyResult("definedIn", "DefinedIn", properties.DefinedIn != null ? cfn_parse.FromCloudFormation.getString(properties.DefinedIn) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("properties", "Properties", properties.Properties != null ? cfn_parse.FromCloudFormation.getMap(CfnEntityPropertyPropertyFromCloudFormation)(properties.Properties) : void 0), ret.addPropertyResult("propertyGroups", "PropertyGroups", properties.PropertyGroups != null ? cfn_parse.FromCloudFormation.getMap(CfnEntityPropertyGroupPropertyFromCloudFormation)(properties.PropertyGroups) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? CfnEntityStatusPropertyFromCloudFormation(properties.Status) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEntity_DataValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("booleanValue", cdk.validateBoolean)(properties.booleanValue)), errors.collect(cdk.propertyValidator("doubleValue", cdk.validateNumber)(properties.doubleValue)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.collect(cdk.propertyValidator("integerValue", cdk.validateNumber)(properties.integerValue)), errors.collect(cdk.propertyValidator("listValue", cdk.listValidator(CfnEntity_DataValuePropertyValidator))(properties.listValue)), errors.collect(cdk.propertyValidator("longValue", cdk.validateNumber)(properties.longValue)), errors.collect(cdk.propertyValidator("mapValue", cdk.hashValidator(CfnEntity_DataValuePropertyValidator))(properties.mapValue)), errors.collect(cdk.propertyValidator("relationshipValue", cdk.validateObject)(properties.relationshipValue)), errors.collect(cdk.propertyValidator("stringValue", cdk.validateString)(properties.stringValue)), errors.wrap('supplied properties not correct for "DataValueProperty"');
    }
    function cfnEntityDataValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEntity_DataValuePropertyValidator(properties).assertSuccess(), { BooleanValue: cdk.booleanToCloudFormation(properties.booleanValue), DoubleValue: cdk.numberToCloudFormation(properties.doubleValue), Expression: cdk.stringToCloudFormation(properties.expression), IntegerValue: cdk.numberToCloudFormation(properties.integerValue), ListValue: cdk.listMapper(cfnEntityDataValuePropertyToCloudFormation)(properties.listValue), LongValue: cdk.numberToCloudFormation(properties.longValue), MapValue: cdk.hashMapper(cfnEntityDataValuePropertyToCloudFormation)(properties.mapValue), RelationshipValue: cdk.objectToCloudFormation(properties.relationshipValue), StringValue: cdk.stringToCloudFormation(properties.stringValue) }) : properties;
    }
    function CfnEntityDataValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("booleanValue", "BooleanValue", properties.BooleanValue != null ? cfn_parse.FromCloudFormation.getBoolean(properties.BooleanValue) : void 0), ret.addPropertyResult("doubleValue", "DoubleValue", properties.DoubleValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.DoubleValue) : void 0), ret.addPropertyResult("expression", "Expression", properties.Expression != null ? cfn_parse.FromCloudFormation.getString(properties.Expression) : void 0), ret.addPropertyResult("integerValue", "IntegerValue", properties.IntegerValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.IntegerValue) : void 0), ret.addPropertyResult("listValue", "ListValue", properties.ListValue != null ? cfn_parse.FromCloudFormation.getArray(CfnEntityDataValuePropertyFromCloudFormation)(properties.ListValue) : void 0), ret.addPropertyResult("longValue", "LongValue", properties.LongValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.LongValue) : void 0), ret.addPropertyResult("mapValue", "MapValue", properties.MapValue != null ? cfn_parse.FromCloudFormation.getMap(CfnEntityDataValuePropertyFromCloudFormation)(properties.MapValue) : void 0), ret.addPropertyResult("relationshipValue", "RelationshipValue", properties.RelationshipValue != null ? cfn_parse.FromCloudFormation.getAny(properties.RelationshipValue) : void 0), ret.addPropertyResult("stringValue", "StringValue", properties.StringValue != null ? cfn_parse.FromCloudFormation.getString(properties.StringValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEntity_PropertyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("definition", cdk.validateObject)(properties.definition)), errors.collect(cdk.propertyValidator("value", CfnEntity_DataValuePropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "PropertyProperty"');
    }
    function cfnEntityPropertyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEntity_PropertyPropertyValidator(properties).assertSuccess(), { Definition: cdk.objectToCloudFormation(properties.definition), Value: cfnEntityDataValuePropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnEntityPropertyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("definition", "Definition", properties.Definition != null ? cfn_parse.FromCloudFormation.getAny(properties.Definition) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? CfnEntityDataValuePropertyFromCloudFormation(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEntity_PropertyGroupPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groupType", cdk.validateString)(properties.groupType)), errors.collect(cdk.propertyValidator("propertyNames", cdk.listValidator(cdk.validateString))(properties.propertyNames)), errors.wrap('supplied properties not correct for "PropertyGroupProperty"');
    }
    function cfnEntityPropertyGroupPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEntity_PropertyGroupPropertyValidator(properties).assertSuccess(), { GroupType: cdk.stringToCloudFormation(properties.groupType), PropertyNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.propertyNames) }) : properties;
    }
    function CfnEntityPropertyGroupPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupType", "GroupType", properties.GroupType != null ? cfn_parse.FromCloudFormation.getString(properties.GroupType) : void 0), ret.addPropertyResult("propertyNames", "PropertyNames", properties.PropertyNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.PropertyNames) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEntity_StatusPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("error", cdk.validateObject)(properties.error)), errors.collect(cdk.propertyValidator("state", cdk.validateString)(properties.state)), errors.wrap('supplied properties not correct for "StatusProperty"');
    }
    function cfnEntityStatusPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEntity_StatusPropertyValidator(properties).assertSuccess(), { Error: cdk.objectToCloudFormation(properties.error), State: cdk.stringToCloudFormation(properties.state) }) : properties;
    }
    function CfnEntityStatusPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("error", "Error", properties.Error != null ? cfn_parse.FromCloudFormation.getAny(properties.Error) : void 0), ret.addPropertyResult("state", "State", properties.State != null ? cfn_parse.FromCloudFormation.getString(properties.State) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScenePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("capabilities", cdk.listValidator(cdk.validateString))(properties.capabilities)), errors.collect(cdk.propertyValidator("contentLocation", cdk.requiredValidator)(properties.contentLocation)), errors.collect(cdk.propertyValidator("contentLocation", cdk.validateString)(properties.contentLocation)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("sceneId", cdk.requiredValidator)(properties.sceneId)), errors.collect(cdk.propertyValidator("sceneId", cdk.validateString)(properties.sceneId)), errors.collect(cdk.propertyValidator("sceneMetadata", cdk.hashValidator(cdk.validateString))(properties.sceneMetadata)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.collect(cdk.propertyValidator("workspaceId", cdk.requiredValidator)(properties.workspaceId)), errors.collect(cdk.propertyValidator("workspaceId", cdk.validateString)(properties.workspaceId)), errors.wrap('supplied properties not correct for "CfnSceneProps"');
    }
    function cfnScenePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScenePropsValidator(properties).assertSuccess(), { ContentLocation: cdk.stringToCloudFormation(properties.contentLocation), SceneId: cdk.stringToCloudFormation(properties.sceneId), WorkspaceId: cdk.stringToCloudFormation(properties.workspaceId), Capabilities: cdk.listMapper(cdk.stringToCloudFormation)(properties.capabilities), Description: cdk.stringToCloudFormation(properties.description), SceneMetadata: cdk.hashMapper(cdk.stringToCloudFormation)(properties.sceneMetadata), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnScenePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contentLocation", "ContentLocation", cfn_parse.FromCloudFormation.getString(properties.ContentLocation)), ret.addPropertyResult("sceneId", "SceneId", cfn_parse.FromCloudFormation.getString(properties.SceneId)), ret.addPropertyResult("workspaceId", "WorkspaceId", cfn_parse.FromCloudFormation.getString(properties.WorkspaceId)), ret.addPropertyResult("capabilities", "Capabilities", properties.Capabilities != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Capabilities) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("sceneMetadata", "SceneMetadata", properties.SceneMetadata != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.SceneMetadata) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnScene = class _CfnScene extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnScenePropsFromCloudFormation(resourceProperties), ret = new _CfnScene(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnScene.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iottwinmaker_CfnSceneProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnScene), error;
        }
        cdk.requireProperty(props, "contentLocation", this), cdk.requireProperty(props, "sceneId", this), cdk.requireProperty(props, "workspaceId", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreationDateTime = cdk.Token.asString(this.getAtt("CreationDateTime", cdk.ResolutionTypeHint.STRING)), this.attrGeneratedSceneMetadata = this.getAtt("GeneratedSceneMetadata", cdk.ResolutionTypeHint.STRING), this.attrUpdateDateTime = cdk.Token.asString(this.getAtt("UpdateDateTime", cdk.ResolutionTypeHint.STRING)), this.contentLocation = props.contentLocation, this.sceneId = props.sceneId, this.workspaceId = props.workspaceId, this.capabilities = props.capabilities, this.description = props.description, this.sceneMetadata = props.sceneMetadata, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::IoTTwinMaker::Scene", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnScene.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { contentLocation: this.contentLocation, sceneId: this.sceneId, workspaceId: this.workspaceId, capabilities: this.capabilities, description: this.description, sceneMetadata: this.sceneMetadata, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnScenePropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnScene[_c] = { fqn: "aws-cdk-lib.aws_iottwinmaker.CfnScene", version: "2.80.0" }, CfnScene.CFN_RESOURCE_TYPE_NAME = "AWS::IoTTwinMaker::Scene", exports2.CfnScene = CfnScene;
    function CfnSyncJobPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("syncRole", cdk.requiredValidator)(properties.syncRole)), errors.collect(cdk.propertyValidator("syncRole", cdk.validateString)(properties.syncRole)), errors.collect(cdk.propertyValidator("syncSource", cdk.requiredValidator)(properties.syncSource)), errors.collect(cdk.propertyValidator("syncSource", cdk.validateString)(properties.syncSource)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.collect(cdk.propertyValidator("workspaceId", cdk.requiredValidator)(properties.workspaceId)), errors.collect(cdk.propertyValidator("workspaceId", cdk.validateString)(properties.workspaceId)), errors.wrap('supplied properties not correct for "CfnSyncJobProps"');
    }
    function cfnSyncJobPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSyncJobPropsValidator(properties).assertSuccess(), { SyncRole: cdk.stringToCloudFormation(properties.syncRole), SyncSource: cdk.stringToCloudFormation(properties.syncSource), WorkspaceId: cdk.stringToCloudFormation(properties.workspaceId), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnSyncJobPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("syncRole", "SyncRole", cfn_parse.FromCloudFormation.getString(properties.SyncRole)), ret.addPropertyResult("syncSource", "SyncSource", cfn_parse.FromCloudFormation.getString(properties.SyncSource)), ret.addPropertyResult("workspaceId", "WorkspaceId", cfn_parse.FromCloudFormation.getString(properties.WorkspaceId)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSyncJob = class _CfnSyncJob extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSyncJobPropsFromCloudFormation(resourceProperties), ret = new _CfnSyncJob(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSyncJob.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iottwinmaker_CfnSyncJobProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSyncJob), error;
        }
        cdk.requireProperty(props, "syncRole", this), cdk.requireProperty(props, "syncSource", this), cdk.requireProperty(props, "workspaceId", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreationDateTime = cdk.Token.asString(this.getAtt("CreationDateTime", cdk.ResolutionTypeHint.STRING)), this.attrState = cdk.Token.asString(this.getAtt("State", cdk.ResolutionTypeHint.STRING)), this.attrUpdateDateTime = cdk.Token.asString(this.getAtt("UpdateDateTime", cdk.ResolutionTypeHint.STRING)), this.syncRole = props.syncRole, this.syncSource = props.syncSource, this.workspaceId = props.workspaceId, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::IoTTwinMaker::SyncJob", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSyncJob.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { syncRole: this.syncRole, syncSource: this.syncSource, workspaceId: this.workspaceId, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnSyncJobPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnSyncJob[_d] = { fqn: "aws-cdk-lib.aws_iottwinmaker.CfnSyncJob", version: "2.80.0" }, CfnSyncJob.CFN_RESOURCE_TYPE_NAME = "AWS::IoTTwinMaker::SyncJob", exports2.CfnSyncJob = CfnSyncJob;
    function CfnWorkspacePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("role", cdk.requiredValidator)(properties.role)), errors.collect(cdk.propertyValidator("role", cdk.validateString)(properties.role)), errors.collect(cdk.propertyValidator("s3Location", cdk.requiredValidator)(properties.s3Location)), errors.collect(cdk.propertyValidator("s3Location", cdk.validateString)(properties.s3Location)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.collect(cdk.propertyValidator("workspaceId", cdk.requiredValidator)(properties.workspaceId)), errors.collect(cdk.propertyValidator("workspaceId", cdk.validateString)(properties.workspaceId)), errors.wrap('supplied properties not correct for "CfnWorkspaceProps"');
    }
    function cfnWorkspacePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkspacePropsValidator(properties).assertSuccess(), { Role: cdk.stringToCloudFormation(properties.role), S3Location: cdk.stringToCloudFormation(properties.s3Location), WorkspaceId: cdk.stringToCloudFormation(properties.workspaceId), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnWorkspacePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("role", "Role", cfn_parse.FromCloudFormation.getString(properties.Role)), ret.addPropertyResult("s3Location", "S3Location", cfn_parse.FromCloudFormation.getString(properties.S3Location)), ret.addPropertyResult("workspaceId", "WorkspaceId", cfn_parse.FromCloudFormation.getString(properties.WorkspaceId)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnWorkspace = class _CfnWorkspace extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnWorkspacePropsFromCloudFormation(resourceProperties), ret = new _CfnWorkspace(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnWorkspace.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iottwinmaker_CfnWorkspaceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnWorkspace), error;
        }
        cdk.requireProperty(props, "role", this), cdk.requireProperty(props, "s3Location", this), cdk.requireProperty(props, "workspaceId", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreationDateTime = cdk.Token.asString(this.getAtt("CreationDateTime", cdk.ResolutionTypeHint.STRING)), this.attrUpdateDateTime = cdk.Token.asString(this.getAtt("UpdateDateTime", cdk.ResolutionTypeHint.STRING)), this.role = props.role, this.s3Location = props.s3Location, this.workspaceId = props.workspaceId, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::IoTTwinMaker::Workspace", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnWorkspace.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { role: this.role, s3Location: this.s3Location, workspaceId: this.workspaceId, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnWorkspacePropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnWorkspace[_e] = { fqn: "aws-cdk-lib.aws_iottwinmaker.CfnWorkspace", version: "2.80.0" }, CfnWorkspace.CFN_RESOURCE_TYPE_NAME = "AWS::IoTTwinMaker::Workspace", exports2.CfnWorkspace = CfnWorkspace;
  }
});

// node_modules/aws-cdk-lib/aws-iottwinmaker/lib/index.js
var require_lib158 = __commonJS({
  "node_modules/aws-cdk-lib/aws-iottwinmaker/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_iottwinmaker_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-iottwinmaker/index.js
var require_aws_iottwinmaker = __commonJS({
  "node_modules/aws-cdk-lib/aws-iottwinmaker/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib158(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-iotwireless/lib/iotwireless.generated.js
var require_iotwireless_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-iotwireless/lib/iotwireless.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    var _l;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnWirelessGateway = exports2.CfnWirelessDeviceImportTask = exports2.CfnWirelessDevice = exports2.CfnTaskDefinition = exports2.CfnServiceProfile = exports2.CfnPartnerAccount = exports2.CfnNetworkAnalyzerConfiguration = exports2.CfnMulticastGroup = exports2.CfnFuotaTask = exports2.CfnDeviceProfile = exports2.CfnDestination = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnDestinationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.collect(cdk.propertyValidator("expressionType", cdk.requiredValidator)(properties.expressionType)), errors.collect(cdk.propertyValidator("expressionType", cdk.validateString)(properties.expressionType)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDestinationProps"');
    }
    function cfnDestinationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDestinationPropsValidator(properties).assertSuccess(), { Expression: cdk.stringToCloudFormation(properties.expression), ExpressionType: cdk.stringToCloudFormation(properties.expressionType), Name: cdk.stringToCloudFormation(properties.name), RoleArn: cdk.stringToCloudFormation(properties.roleArn), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDestinationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getString(properties.Expression)), ret.addPropertyResult("expressionType", "ExpressionType", cfn_parse.FromCloudFormation.getString(properties.ExpressionType)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDestination = class _CfnDestination extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDestinationPropsFromCloudFormation(resourceProperties), ret = new _CfnDestination(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDestination.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotwireless_CfnDestinationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDestination), error;
        }
        cdk.requireProperty(props, "expression", this), cdk.requireProperty(props, "expressionType", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "roleArn", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.expression = props.expression, this.expressionType = props.expressionType, this.name = props.name, this.roleArn = props.roleArn, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTWireless::Destination", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDestination.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { expression: this.expression, expressionType: this.expressionType, name: this.name, roleArn: this.roleArn, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDestinationPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnDestination[_a] = { fqn: "aws-cdk-lib.aws_iotwireless.CfnDestination", version: "2.80.0" }, CfnDestination.CFN_RESOURCE_TYPE_NAME = "AWS::IoTWireless::Destination", exports2.CfnDestination = CfnDestination;
    function CfnDeviceProfilePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("loRaWan", CfnDeviceProfile_LoRaWANDeviceProfilePropertyValidator)(properties.loRaWan)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDeviceProfileProps"');
    }
    function cfnDeviceProfilePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeviceProfilePropsValidator(properties).assertSuccess(), { LoRaWAN: cfnDeviceProfileLoRaWANDeviceProfilePropertyToCloudFormation(properties.loRaWan), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDeviceProfilePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("loRaWan", "LoRaWAN", properties.LoRaWAN != null ? CfnDeviceProfileLoRaWANDeviceProfilePropertyFromCloudFormation(properties.LoRaWAN) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDeviceProfile = class _CfnDeviceProfile extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDeviceProfilePropsFromCloudFormation(resourceProperties), ret = new _CfnDeviceProfile(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnDeviceProfile.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotwireless_CfnDeviceProfileProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDeviceProfile), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.loRaWan = props.loRaWan, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTWireless::DeviceProfile", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDeviceProfile.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { loRaWan: this.loRaWan, name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDeviceProfilePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnDeviceProfile[_b] = { fqn: "aws-cdk-lib.aws_iotwireless.CfnDeviceProfile", version: "2.80.0" }, CfnDeviceProfile.CFN_RESOURCE_TYPE_NAME = "AWS::IoTWireless::DeviceProfile", exports2.CfnDeviceProfile = CfnDeviceProfile;
    function CfnDeviceProfile_LoRaWANDeviceProfilePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("classBTimeout", cdk.validateNumber)(properties.classBTimeout)), errors.collect(cdk.propertyValidator("classCTimeout", cdk.validateNumber)(properties.classCTimeout)), errors.collect(cdk.propertyValidator("factoryPresetFreqsList", cdk.listValidator(cdk.validateNumber))(properties.factoryPresetFreqsList)), errors.collect(cdk.propertyValidator("macVersion", cdk.validateString)(properties.macVersion)), errors.collect(cdk.propertyValidator("maxDutyCycle", cdk.validateNumber)(properties.maxDutyCycle)), errors.collect(cdk.propertyValidator("maxEirp", cdk.validateNumber)(properties.maxEirp)), errors.collect(cdk.propertyValidator("pingSlotDr", cdk.validateNumber)(properties.pingSlotDr)), errors.collect(cdk.propertyValidator("pingSlotFreq", cdk.validateNumber)(properties.pingSlotFreq)), errors.collect(cdk.propertyValidator("pingSlotPeriod", cdk.validateNumber)(properties.pingSlotPeriod)), errors.collect(cdk.propertyValidator("regParamsRevision", cdk.validateString)(properties.regParamsRevision)), errors.collect(cdk.propertyValidator("rfRegion", cdk.validateString)(properties.rfRegion)), errors.collect(cdk.propertyValidator("rxDataRate2", cdk.validateNumber)(properties.rxDataRate2)), errors.collect(cdk.propertyValidator("rxDelay1", cdk.validateNumber)(properties.rxDelay1)), errors.collect(cdk.propertyValidator("rxDrOffset1", cdk.validateNumber)(properties.rxDrOffset1)), errors.collect(cdk.propertyValidator("rxFreq2", cdk.validateNumber)(properties.rxFreq2)), errors.collect(cdk.propertyValidator("supports32BitFCnt", cdk.validateBoolean)(properties.supports32BitFCnt)), errors.collect(cdk.propertyValidator("supportsClassB", cdk.validateBoolean)(properties.supportsClassB)), errors.collect(cdk.propertyValidator("supportsClassC", cdk.validateBoolean)(properties.supportsClassC)), errors.collect(cdk.propertyValidator("supportsJoin", cdk.validateBoolean)(properties.supportsJoin)), errors.wrap('supplied properties not correct for "LoRaWANDeviceProfileProperty"');
    }
    function cfnDeviceProfileLoRaWANDeviceProfilePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeviceProfile_LoRaWANDeviceProfilePropertyValidator(properties).assertSuccess(), { ClassBTimeout: cdk.numberToCloudFormation(properties.classBTimeout), ClassCTimeout: cdk.numberToCloudFormation(properties.classCTimeout), FactoryPresetFreqsList: cdk.listMapper(cdk.numberToCloudFormation)(properties.factoryPresetFreqsList), MacVersion: cdk.stringToCloudFormation(properties.macVersion), MaxDutyCycle: cdk.numberToCloudFormation(properties.maxDutyCycle), MaxEirp: cdk.numberToCloudFormation(properties.maxEirp), PingSlotDr: cdk.numberToCloudFormation(properties.pingSlotDr), PingSlotFreq: cdk.numberToCloudFormation(properties.pingSlotFreq), PingSlotPeriod: cdk.numberToCloudFormation(properties.pingSlotPeriod), RegParamsRevision: cdk.stringToCloudFormation(properties.regParamsRevision), RfRegion: cdk.stringToCloudFormation(properties.rfRegion), RxDataRate2: cdk.numberToCloudFormation(properties.rxDataRate2), RxDelay1: cdk.numberToCloudFormation(properties.rxDelay1), RxDrOffset1: cdk.numberToCloudFormation(properties.rxDrOffset1), RxFreq2: cdk.numberToCloudFormation(properties.rxFreq2), Supports32BitFCnt: cdk.booleanToCloudFormation(properties.supports32BitFCnt), SupportsClassB: cdk.booleanToCloudFormation(properties.supportsClassB), SupportsClassC: cdk.booleanToCloudFormation(properties.supportsClassC), SupportsJoin: cdk.booleanToCloudFormation(properties.supportsJoin) }) : properties;
    }
    function CfnDeviceProfileLoRaWANDeviceProfilePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("classBTimeout", "ClassBTimeout", properties.ClassBTimeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.ClassBTimeout) : void 0), ret.addPropertyResult("classCTimeout", "ClassCTimeout", properties.ClassCTimeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.ClassCTimeout) : void 0), ret.addPropertyResult("factoryPresetFreqsList", "FactoryPresetFreqsList", properties.FactoryPresetFreqsList != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getNumber)(properties.FactoryPresetFreqsList) : void 0), ret.addPropertyResult("macVersion", "MacVersion", properties.MacVersion != null ? cfn_parse.FromCloudFormation.getString(properties.MacVersion) : void 0), ret.addPropertyResult("maxDutyCycle", "MaxDutyCycle", properties.MaxDutyCycle != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxDutyCycle) : void 0), ret.addPropertyResult("maxEirp", "MaxEirp", properties.MaxEirp != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxEirp) : void 0), ret.addPropertyResult("pingSlotDr", "PingSlotDr", properties.PingSlotDr != null ? cfn_parse.FromCloudFormation.getNumber(properties.PingSlotDr) : void 0), ret.addPropertyResult("pingSlotFreq", "PingSlotFreq", properties.PingSlotFreq != null ? cfn_parse.FromCloudFormation.getNumber(properties.PingSlotFreq) : void 0), ret.addPropertyResult("pingSlotPeriod", "PingSlotPeriod", properties.PingSlotPeriod != null ? cfn_parse.FromCloudFormation.getNumber(properties.PingSlotPeriod) : void 0), ret.addPropertyResult("regParamsRevision", "RegParamsRevision", properties.RegParamsRevision != null ? cfn_parse.FromCloudFormation.getString(properties.RegParamsRevision) : void 0), ret.addPropertyResult("rfRegion", "RfRegion", properties.RfRegion != null ? cfn_parse.FromCloudFormation.getString(properties.RfRegion) : void 0), ret.addPropertyResult("rxDataRate2", "RxDataRate2", properties.RxDataRate2 != null ? cfn_parse.FromCloudFormation.getNumber(properties.RxDataRate2) : void 0), ret.addPropertyResult("rxDelay1", "RxDelay1", properties.RxDelay1 != null ? cfn_parse.FromCloudFormation.getNumber(properties.RxDelay1) : void 0), ret.addPropertyResult("rxDrOffset1", "RxDrOffset1", properties.RxDrOffset1 != null ? cfn_parse.FromCloudFormation.getNumber(properties.RxDrOffset1) : void 0), ret.addPropertyResult("rxFreq2", "RxFreq2", properties.RxFreq2 != null ? cfn_parse.FromCloudFormation.getNumber(properties.RxFreq2) : void 0), ret.addPropertyResult("supports32BitFCnt", "Supports32BitFCnt", properties.Supports32BitFCnt != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Supports32BitFCnt) : void 0), ret.addPropertyResult("supportsClassB", "SupportsClassB", properties.SupportsClassB != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SupportsClassB) : void 0), ret.addPropertyResult("supportsClassC", "SupportsClassC", properties.SupportsClassC != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SupportsClassC) : void 0), ret.addPropertyResult("supportsJoin", "SupportsJoin", properties.SupportsJoin != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SupportsJoin) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFuotaTaskPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("associateMulticastGroup", cdk.validateString)(properties.associateMulticastGroup)), errors.collect(cdk.propertyValidator("associateWirelessDevice", cdk.validateString)(properties.associateWirelessDevice)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("disassociateMulticastGroup", cdk.validateString)(properties.disassociateMulticastGroup)), errors.collect(cdk.propertyValidator("disassociateWirelessDevice", cdk.validateString)(properties.disassociateWirelessDevice)), errors.collect(cdk.propertyValidator("firmwareUpdateImage", cdk.requiredValidator)(properties.firmwareUpdateImage)), errors.collect(cdk.propertyValidator("firmwareUpdateImage", cdk.validateString)(properties.firmwareUpdateImage)), errors.collect(cdk.propertyValidator("firmwareUpdateRole", cdk.requiredValidator)(properties.firmwareUpdateRole)), errors.collect(cdk.propertyValidator("firmwareUpdateRole", cdk.validateString)(properties.firmwareUpdateRole)), errors.collect(cdk.propertyValidator("loRaWan", cdk.requiredValidator)(properties.loRaWan)), errors.collect(cdk.propertyValidator("loRaWan", CfnFuotaTask_LoRaWANPropertyValidator)(properties.loRaWan)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnFuotaTaskProps"');
    }
    function cfnFuotaTaskPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFuotaTaskPropsValidator(properties).assertSuccess(), { FirmwareUpdateImage: cdk.stringToCloudFormation(properties.firmwareUpdateImage), FirmwareUpdateRole: cdk.stringToCloudFormation(properties.firmwareUpdateRole), LoRaWAN: cfnFuotaTaskLoRaWANPropertyToCloudFormation(properties.loRaWan), AssociateMulticastGroup: cdk.stringToCloudFormation(properties.associateMulticastGroup), AssociateWirelessDevice: cdk.stringToCloudFormation(properties.associateWirelessDevice), Description: cdk.stringToCloudFormation(properties.description), DisassociateMulticastGroup: cdk.stringToCloudFormation(properties.disassociateMulticastGroup), DisassociateWirelessDevice: cdk.stringToCloudFormation(properties.disassociateWirelessDevice), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnFuotaTaskPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("firmwareUpdateImage", "FirmwareUpdateImage", cfn_parse.FromCloudFormation.getString(properties.FirmwareUpdateImage)), ret.addPropertyResult("firmwareUpdateRole", "FirmwareUpdateRole", cfn_parse.FromCloudFormation.getString(properties.FirmwareUpdateRole)), ret.addPropertyResult("loRaWan", "LoRaWAN", CfnFuotaTaskLoRaWANPropertyFromCloudFormation(properties.LoRaWAN)), ret.addPropertyResult("associateMulticastGroup", "AssociateMulticastGroup", properties.AssociateMulticastGroup != null ? cfn_parse.FromCloudFormation.getString(properties.AssociateMulticastGroup) : void 0), ret.addPropertyResult("associateWirelessDevice", "AssociateWirelessDevice", properties.AssociateWirelessDevice != null ? cfn_parse.FromCloudFormation.getString(properties.AssociateWirelessDevice) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("disassociateMulticastGroup", "DisassociateMulticastGroup", properties.DisassociateMulticastGroup != null ? cfn_parse.FromCloudFormation.getString(properties.DisassociateMulticastGroup) : void 0), ret.addPropertyResult("disassociateWirelessDevice", "DisassociateWirelessDevice", properties.DisassociateWirelessDevice != null ? cfn_parse.FromCloudFormation.getString(properties.DisassociateWirelessDevice) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFuotaTask = class _CfnFuotaTask extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFuotaTaskPropsFromCloudFormation(resourceProperties), ret = new _CfnFuotaTask(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFuotaTask.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotwireless_CfnFuotaTaskProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFuotaTask), error;
        }
        cdk.requireProperty(props, "firmwareUpdateImage", this), cdk.requireProperty(props, "firmwareUpdateRole", this), cdk.requireProperty(props, "loRaWan", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrFuotaTaskStatus = cdk.Token.asString(this.getAtt("FuotaTaskStatus", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrLoRaWanStartTime = cdk.Token.asString(this.getAtt("LoRaWAN.StartTime", cdk.ResolutionTypeHint.STRING)), this.firmwareUpdateImage = props.firmwareUpdateImage, this.firmwareUpdateRole = props.firmwareUpdateRole, this.loRaWan = props.loRaWan, this.associateMulticastGroup = props.associateMulticastGroup, this.associateWirelessDevice = props.associateWirelessDevice, this.description = props.description, this.disassociateMulticastGroup = props.disassociateMulticastGroup, this.disassociateWirelessDevice = props.disassociateWirelessDevice, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTWireless::FuotaTask", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFuotaTask.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { firmwareUpdateImage: this.firmwareUpdateImage, firmwareUpdateRole: this.firmwareUpdateRole, loRaWan: this.loRaWan, associateMulticastGroup: this.associateMulticastGroup, associateWirelessDevice: this.associateWirelessDevice, description: this.description, disassociateMulticastGroup: this.disassociateMulticastGroup, disassociateWirelessDevice: this.disassociateWirelessDevice, name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnFuotaTaskPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnFuotaTask[_c] = { fqn: "aws-cdk-lib.aws_iotwireless.CfnFuotaTask", version: "2.80.0" }, CfnFuotaTask.CFN_RESOURCE_TYPE_NAME = "AWS::IoTWireless::FuotaTask", exports2.CfnFuotaTask = CfnFuotaTask;
    function CfnFuotaTask_LoRaWANPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("rfRegion", cdk.requiredValidator)(properties.rfRegion)), errors.collect(cdk.propertyValidator("rfRegion", cdk.validateString)(properties.rfRegion)), errors.collect(cdk.propertyValidator("startTime", cdk.validateString)(properties.startTime)), errors.wrap('supplied properties not correct for "LoRaWANProperty"');
    }
    function cfnFuotaTaskLoRaWANPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFuotaTask_LoRaWANPropertyValidator(properties).assertSuccess(), { RfRegion: cdk.stringToCloudFormation(properties.rfRegion), StartTime: cdk.stringToCloudFormation(properties.startTime) }) : properties;
    }
    function CfnFuotaTaskLoRaWANPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("rfRegion", "RfRegion", cfn_parse.FromCloudFormation.getString(properties.RfRegion)), ret.addPropertyResult("startTime", "StartTime", properties.StartTime != null ? cfn_parse.FromCloudFormation.getString(properties.StartTime) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMulticastGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("associateWirelessDevice", cdk.validateString)(properties.associateWirelessDevice)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("disassociateWirelessDevice", cdk.validateString)(properties.disassociateWirelessDevice)), errors.collect(cdk.propertyValidator("loRaWan", cdk.requiredValidator)(properties.loRaWan)), errors.collect(cdk.propertyValidator("loRaWan", CfnMulticastGroup_LoRaWANPropertyValidator)(properties.loRaWan)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnMulticastGroupProps"');
    }
    function cfnMulticastGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMulticastGroupPropsValidator(properties).assertSuccess(), { LoRaWAN: cfnMulticastGroupLoRaWANPropertyToCloudFormation(properties.loRaWan), AssociateWirelessDevice: cdk.stringToCloudFormation(properties.associateWirelessDevice), Description: cdk.stringToCloudFormation(properties.description), DisassociateWirelessDevice: cdk.stringToCloudFormation(properties.disassociateWirelessDevice), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnMulticastGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("loRaWan", "LoRaWAN", CfnMulticastGroupLoRaWANPropertyFromCloudFormation(properties.LoRaWAN)), ret.addPropertyResult("associateWirelessDevice", "AssociateWirelessDevice", properties.AssociateWirelessDevice != null ? cfn_parse.FromCloudFormation.getString(properties.AssociateWirelessDevice) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("disassociateWirelessDevice", "DisassociateWirelessDevice", properties.DisassociateWirelessDevice != null ? cfn_parse.FromCloudFormation.getString(properties.DisassociateWirelessDevice) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnMulticastGroup = class _CfnMulticastGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnMulticastGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnMulticastGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnMulticastGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotwireless_CfnMulticastGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnMulticastGroup), error;
        }
        cdk.requireProperty(props, "loRaWan", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrLoRaWanNumberOfDevicesInGroup = cdk.Token.asNumber(this.getAtt("LoRaWAN.NumberOfDevicesInGroup", cdk.ResolutionTypeHint.NUMBER)), this.attrLoRaWanNumberOfDevicesRequested = cdk.Token.asNumber(this.getAtt("LoRaWAN.NumberOfDevicesRequested", cdk.ResolutionTypeHint.NUMBER)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.loRaWan = props.loRaWan, this.associateWirelessDevice = props.associateWirelessDevice, this.description = props.description, this.disassociateWirelessDevice = props.disassociateWirelessDevice, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTWireless::MulticastGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnMulticastGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { loRaWan: this.loRaWan, associateWirelessDevice: this.associateWirelessDevice, description: this.description, disassociateWirelessDevice: this.disassociateWirelessDevice, name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnMulticastGroupPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnMulticastGroup[_d] = { fqn: "aws-cdk-lib.aws_iotwireless.CfnMulticastGroup", version: "2.80.0" }, CfnMulticastGroup.CFN_RESOURCE_TYPE_NAME = "AWS::IoTWireless::MulticastGroup", exports2.CfnMulticastGroup = CfnMulticastGroup;
    function CfnMulticastGroup_LoRaWANPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dlClass", cdk.requiredValidator)(properties.dlClass)), errors.collect(cdk.propertyValidator("dlClass", cdk.validateString)(properties.dlClass)), errors.collect(cdk.propertyValidator("numberOfDevicesInGroup", cdk.validateNumber)(properties.numberOfDevicesInGroup)), errors.collect(cdk.propertyValidator("numberOfDevicesRequested", cdk.validateNumber)(properties.numberOfDevicesRequested)), errors.collect(cdk.propertyValidator("rfRegion", cdk.requiredValidator)(properties.rfRegion)), errors.collect(cdk.propertyValidator("rfRegion", cdk.validateString)(properties.rfRegion)), errors.wrap('supplied properties not correct for "LoRaWANProperty"');
    }
    function cfnMulticastGroupLoRaWANPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMulticastGroup_LoRaWANPropertyValidator(properties).assertSuccess(), { DlClass: cdk.stringToCloudFormation(properties.dlClass), NumberOfDevicesInGroup: cdk.numberToCloudFormation(properties.numberOfDevicesInGroup), NumberOfDevicesRequested: cdk.numberToCloudFormation(properties.numberOfDevicesRequested), RfRegion: cdk.stringToCloudFormation(properties.rfRegion) }) : properties;
    }
    function CfnMulticastGroupLoRaWANPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dlClass", "DlClass", cfn_parse.FromCloudFormation.getString(properties.DlClass)), ret.addPropertyResult("numberOfDevicesInGroup", "NumberOfDevicesInGroup", properties.NumberOfDevicesInGroup != null ? cfn_parse.FromCloudFormation.getNumber(properties.NumberOfDevicesInGroup) : void 0), ret.addPropertyResult("numberOfDevicesRequested", "NumberOfDevicesRequested", properties.NumberOfDevicesRequested != null ? cfn_parse.FromCloudFormation.getNumber(properties.NumberOfDevicesRequested) : void 0), ret.addPropertyResult("rfRegion", "RfRegion", cfn_parse.FromCloudFormation.getString(properties.RfRegion)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnNetworkAnalyzerConfigurationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("traceContent", cdk.validateObject)(properties.traceContent)), errors.collect(cdk.propertyValidator("wirelessDevices", cdk.listValidator(cdk.validateString))(properties.wirelessDevices)), errors.collect(cdk.propertyValidator("wirelessGateways", cdk.listValidator(cdk.validateString))(properties.wirelessGateways)), errors.wrap('supplied properties not correct for "CfnNetworkAnalyzerConfigurationProps"');
    }
    function cfnNetworkAnalyzerConfigurationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNetworkAnalyzerConfigurationPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TraceContent: cdk.objectToCloudFormation(properties.traceContent), WirelessDevices: cdk.listMapper(cdk.stringToCloudFormation)(properties.wirelessDevices), WirelessGateways: cdk.listMapper(cdk.stringToCloudFormation)(properties.wirelessGateways) }) : properties;
    }
    function CfnNetworkAnalyzerConfigurationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("traceContent", "TraceContent", properties.TraceContent != null ? cfn_parse.FromCloudFormation.getAny(properties.TraceContent) : void 0), ret.addPropertyResult("wirelessDevices", "WirelessDevices", properties.WirelessDevices != null ? cfn_parse.FromCloudFormation.getStringArray(properties.WirelessDevices) : void 0), ret.addPropertyResult("wirelessGateways", "WirelessGateways", properties.WirelessGateways != null ? cfn_parse.FromCloudFormation.getStringArray(properties.WirelessGateways) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnNetworkAnalyzerConfiguration = class _CfnNetworkAnalyzerConfiguration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnNetworkAnalyzerConfigurationPropsFromCloudFormation(resourceProperties), ret = new _CfnNetworkAnalyzerConfiguration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnNetworkAnalyzerConfiguration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotwireless_CfnNetworkAnalyzerConfigurationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnNetworkAnalyzerConfiguration), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTWireless::NetworkAnalyzerConfiguration", props.tags, { tagPropertyName: "tags" }), this.traceContent = props.traceContent, this.wirelessDevices = props.wirelessDevices, this.wirelessGateways = props.wirelessGateways;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnNetworkAnalyzerConfiguration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, description: this.description, tags: this.tags.renderTags(), traceContent: this.traceContent, wirelessDevices: this.wirelessDevices, wirelessGateways: this.wirelessGateways };
      }
      renderProperties(props) {
        return cfnNetworkAnalyzerConfigurationPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnNetworkAnalyzerConfiguration[_e] = { fqn: "aws-cdk-lib.aws_iotwireless.CfnNetworkAnalyzerConfiguration", version: "2.80.0" }, CfnNetworkAnalyzerConfiguration.CFN_RESOURCE_TYPE_NAME = "AWS::IoTWireless::NetworkAnalyzerConfiguration", exports2.CfnNetworkAnalyzerConfiguration = CfnNetworkAnalyzerConfiguration;
    function CfnPartnerAccountPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accountLinked", cdk.validateBoolean)(properties.accountLinked)), errors.collect(cdk.propertyValidator("partnerAccountId", cdk.validateString)(properties.partnerAccountId)), errors.collect(cdk.propertyValidator("partnerType", cdk.validateString)(properties.partnerType)), errors.collect(cdk.propertyValidator("sidewalk", CfnPartnerAccount_SidewalkAccountInfoPropertyValidator)(properties.sidewalk)), errors.collect(cdk.propertyValidator("sidewalkResponse", CfnPartnerAccount_SidewalkAccountInfoWithFingerprintPropertyValidator)(properties.sidewalkResponse)), errors.collect(cdk.propertyValidator("sidewalkUpdate", CfnPartnerAccount_SidewalkUpdateAccountPropertyValidator)(properties.sidewalkUpdate)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnPartnerAccountProps"');
    }
    function cfnPartnerAccountPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPartnerAccountPropsValidator(properties).assertSuccess(), { AccountLinked: cdk.booleanToCloudFormation(properties.accountLinked), PartnerAccountId: cdk.stringToCloudFormation(properties.partnerAccountId), PartnerType: cdk.stringToCloudFormation(properties.partnerType), Sidewalk: cfnPartnerAccountSidewalkAccountInfoPropertyToCloudFormation(properties.sidewalk), SidewalkResponse: cfnPartnerAccountSidewalkAccountInfoWithFingerprintPropertyToCloudFormation(properties.sidewalkResponse), SidewalkUpdate: cfnPartnerAccountSidewalkUpdateAccountPropertyToCloudFormation(properties.sidewalkUpdate), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnPartnerAccountPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accountLinked", "AccountLinked", properties.AccountLinked != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AccountLinked) : void 0), ret.addPropertyResult("partnerAccountId", "PartnerAccountId", properties.PartnerAccountId != null ? cfn_parse.FromCloudFormation.getString(properties.PartnerAccountId) : void 0), ret.addPropertyResult("partnerType", "PartnerType", properties.PartnerType != null ? cfn_parse.FromCloudFormation.getString(properties.PartnerType) : void 0), ret.addPropertyResult("sidewalk", "Sidewalk", properties.Sidewalk != null ? CfnPartnerAccountSidewalkAccountInfoPropertyFromCloudFormation(properties.Sidewalk) : void 0), ret.addPropertyResult("sidewalkResponse", "SidewalkResponse", properties.SidewalkResponse != null ? CfnPartnerAccountSidewalkAccountInfoWithFingerprintPropertyFromCloudFormation(properties.SidewalkResponse) : void 0), ret.addPropertyResult("sidewalkUpdate", "SidewalkUpdate", properties.SidewalkUpdate != null ? CfnPartnerAccountSidewalkUpdateAccountPropertyFromCloudFormation(properties.SidewalkUpdate) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPartnerAccount = class _CfnPartnerAccount extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPartnerAccountPropsFromCloudFormation(resourceProperties), ret = new _CfnPartnerAccount(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnPartnerAccount.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotwireless_CfnPartnerAccountProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPartnerAccount), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrFingerprint = cdk.Token.asString(this.getAtt("Fingerprint", cdk.ResolutionTypeHint.STRING)), this.accountLinked = props.accountLinked, this.partnerAccountId = props.partnerAccountId, this.partnerType = props.partnerType, this.sidewalk = props.sidewalk, this.sidewalkResponse = props.sidewalkResponse, this.sidewalkUpdate = props.sidewalkUpdate, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTWireless::PartnerAccount", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPartnerAccount.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { accountLinked: this.accountLinked, partnerAccountId: this.partnerAccountId, partnerType: this.partnerType, sidewalk: this.sidewalk, sidewalkResponse: this.sidewalkResponse, sidewalkUpdate: this.sidewalkUpdate, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnPartnerAccountPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnPartnerAccount[_f] = { fqn: "aws-cdk-lib.aws_iotwireless.CfnPartnerAccount", version: "2.80.0" }, CfnPartnerAccount.CFN_RESOURCE_TYPE_NAME = "AWS::IoTWireless::PartnerAccount", exports2.CfnPartnerAccount = CfnPartnerAccount;
    function CfnPartnerAccount_SidewalkAccountInfoPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("appServerPrivateKey", cdk.requiredValidator)(properties.appServerPrivateKey)), errors.collect(cdk.propertyValidator("appServerPrivateKey", cdk.validateString)(properties.appServerPrivateKey)), errors.wrap('supplied properties not correct for "SidewalkAccountInfoProperty"');
    }
    function cfnPartnerAccountSidewalkAccountInfoPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPartnerAccount_SidewalkAccountInfoPropertyValidator(properties).assertSuccess(), { AppServerPrivateKey: cdk.stringToCloudFormation(properties.appServerPrivateKey) }) : properties;
    }
    function CfnPartnerAccountSidewalkAccountInfoPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("appServerPrivateKey", "AppServerPrivateKey", cfn_parse.FromCloudFormation.getString(properties.AppServerPrivateKey)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPartnerAccount_SidewalkAccountInfoWithFingerprintPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("amazonId", cdk.validateString)(properties.amazonId)), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("fingerprint", cdk.validateString)(properties.fingerprint)), errors.wrap('supplied properties not correct for "SidewalkAccountInfoWithFingerprintProperty"');
    }
    function cfnPartnerAccountSidewalkAccountInfoWithFingerprintPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPartnerAccount_SidewalkAccountInfoWithFingerprintPropertyValidator(properties).assertSuccess(), { AmazonId: cdk.stringToCloudFormation(properties.amazonId), Arn: cdk.stringToCloudFormation(properties.arn), Fingerprint: cdk.stringToCloudFormation(properties.fingerprint) }) : properties;
    }
    function CfnPartnerAccountSidewalkAccountInfoWithFingerprintPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("amazonId", "AmazonId", properties.AmazonId != null ? cfn_parse.FromCloudFormation.getString(properties.AmazonId) : void 0), ret.addPropertyResult("arn", "Arn", properties.Arn != null ? cfn_parse.FromCloudFormation.getString(properties.Arn) : void 0), ret.addPropertyResult("fingerprint", "Fingerprint", properties.Fingerprint != null ? cfn_parse.FromCloudFormation.getString(properties.Fingerprint) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPartnerAccount_SidewalkUpdateAccountPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("appServerPrivateKey", cdk.validateString)(properties.appServerPrivateKey)), errors.wrap('supplied properties not correct for "SidewalkUpdateAccountProperty"');
    }
    function cfnPartnerAccountSidewalkUpdateAccountPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPartnerAccount_SidewalkUpdateAccountPropertyValidator(properties).assertSuccess(), { AppServerPrivateKey: cdk.stringToCloudFormation(properties.appServerPrivateKey) }) : properties;
    }
    function CfnPartnerAccountSidewalkUpdateAccountPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("appServerPrivateKey", "AppServerPrivateKey", properties.AppServerPrivateKey != null ? cfn_parse.FromCloudFormation.getString(properties.AppServerPrivateKey) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnServiceProfilePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("loRaWan", CfnServiceProfile_LoRaWANServiceProfilePropertyValidator)(properties.loRaWan)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnServiceProfileProps"');
    }
    function cfnServiceProfilePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnServiceProfilePropsValidator(properties).assertSuccess(), { LoRaWAN: cfnServiceProfileLoRaWANServiceProfilePropertyToCloudFormation(properties.loRaWan), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnServiceProfilePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("loRaWan", "LoRaWAN", properties.LoRaWAN != null ? CfnServiceProfileLoRaWANServiceProfilePropertyFromCloudFormation(properties.LoRaWAN) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnServiceProfile = class _CfnServiceProfile extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnServiceProfilePropsFromCloudFormation(resourceProperties), ret = new _CfnServiceProfile(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnServiceProfile.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotwireless_CfnServiceProfileProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnServiceProfile), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrLoRaWanChannelMask = cdk.Token.asString(this.getAtt("LoRaWAN.ChannelMask", cdk.ResolutionTypeHint.STRING)), this.attrLoRaWanDevStatusReqFreq = cdk.Token.asNumber(this.getAtt("LoRaWAN.DevStatusReqFreq", cdk.ResolutionTypeHint.NUMBER)), this.attrLoRaWanDlBucketSize = cdk.Token.asNumber(this.getAtt("LoRaWAN.DlBucketSize", cdk.ResolutionTypeHint.NUMBER)), this.attrLoRaWanDlRate = cdk.Token.asNumber(this.getAtt("LoRaWAN.DlRate", cdk.ResolutionTypeHint.NUMBER)), this.attrLoRaWanDlRatePolicy = cdk.Token.asString(this.getAtt("LoRaWAN.DlRatePolicy", cdk.ResolutionTypeHint.STRING)), this.attrLoRaWanDrMax = cdk.Token.asNumber(this.getAtt("LoRaWAN.DrMax", cdk.ResolutionTypeHint.NUMBER)), this.attrLoRaWanDrMin = cdk.Token.asNumber(this.getAtt("LoRaWAN.DrMin", cdk.ResolutionTypeHint.NUMBER)), this.attrLoRaWanHrAllowed = this.getAtt("LoRaWAN.HrAllowed", cdk.ResolutionTypeHint.STRING), this.attrLoRaWanMinGwDiversity = cdk.Token.asNumber(this.getAtt("LoRaWAN.MinGwDiversity", cdk.ResolutionTypeHint.NUMBER)), this.attrLoRaWanNwkGeoLoc = this.getAtt("LoRaWAN.NwkGeoLoc", cdk.ResolutionTypeHint.STRING), this.attrLoRaWanPrAllowed = this.getAtt("LoRaWAN.PrAllowed", cdk.ResolutionTypeHint.STRING), this.attrLoRaWanRaAllowed = this.getAtt("LoRaWAN.RaAllowed", cdk.ResolutionTypeHint.STRING), this.attrLoRaWanReportDevStatusBattery = this.getAtt("LoRaWAN.ReportDevStatusBattery", cdk.ResolutionTypeHint.STRING), this.attrLoRaWanReportDevStatusMargin = this.getAtt("LoRaWAN.ReportDevStatusMargin", cdk.ResolutionTypeHint.STRING), this.attrLoRaWanTargetPer = cdk.Token.asNumber(this.getAtt("LoRaWAN.TargetPer", cdk.ResolutionTypeHint.NUMBER)), this.attrLoRaWanUlBucketSize = cdk.Token.asNumber(this.getAtt("LoRaWAN.UlBucketSize", cdk.ResolutionTypeHint.NUMBER)), this.attrLoRaWanUlRate = cdk.Token.asNumber(this.getAtt("LoRaWAN.UlRate", cdk.ResolutionTypeHint.NUMBER)), this.attrLoRaWanUlRatePolicy = cdk.Token.asString(this.getAtt("LoRaWAN.UlRatePolicy", cdk.ResolutionTypeHint.STRING)), this.attrLoRaWanResponse = this.getAtt("LoRaWANResponse", cdk.ResolutionTypeHint.STRING), this.loRaWan = props.loRaWan, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTWireless::ServiceProfile", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnServiceProfile.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { loRaWan: this.loRaWan, name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnServiceProfilePropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnServiceProfile[_g] = { fqn: "aws-cdk-lib.aws_iotwireless.CfnServiceProfile", version: "2.80.0" }, CfnServiceProfile.CFN_RESOURCE_TYPE_NAME = "AWS::IoTWireless::ServiceProfile", exports2.CfnServiceProfile = CfnServiceProfile;
    function CfnServiceProfile_LoRaWANServiceProfilePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("addGwMetadata", cdk.validateBoolean)(properties.addGwMetadata)), errors.collect(cdk.propertyValidator("channelMask", cdk.validateString)(properties.channelMask)), errors.collect(cdk.propertyValidator("devStatusReqFreq", cdk.validateNumber)(properties.devStatusReqFreq)), errors.collect(cdk.propertyValidator("dlBucketSize", cdk.validateNumber)(properties.dlBucketSize)), errors.collect(cdk.propertyValidator("dlRate", cdk.validateNumber)(properties.dlRate)), errors.collect(cdk.propertyValidator("dlRatePolicy", cdk.validateString)(properties.dlRatePolicy)), errors.collect(cdk.propertyValidator("drMax", cdk.validateNumber)(properties.drMax)), errors.collect(cdk.propertyValidator("drMin", cdk.validateNumber)(properties.drMin)), errors.collect(cdk.propertyValidator("hrAllowed", cdk.validateBoolean)(properties.hrAllowed)), errors.collect(cdk.propertyValidator("minGwDiversity", cdk.validateNumber)(properties.minGwDiversity)), errors.collect(cdk.propertyValidator("nwkGeoLoc", cdk.validateBoolean)(properties.nwkGeoLoc)), errors.collect(cdk.propertyValidator("prAllowed", cdk.validateBoolean)(properties.prAllowed)), errors.collect(cdk.propertyValidator("raAllowed", cdk.validateBoolean)(properties.raAllowed)), errors.collect(cdk.propertyValidator("reportDevStatusBattery", cdk.validateBoolean)(properties.reportDevStatusBattery)), errors.collect(cdk.propertyValidator("reportDevStatusMargin", cdk.validateBoolean)(properties.reportDevStatusMargin)), errors.collect(cdk.propertyValidator("targetPer", cdk.validateNumber)(properties.targetPer)), errors.collect(cdk.propertyValidator("ulBucketSize", cdk.validateNumber)(properties.ulBucketSize)), errors.collect(cdk.propertyValidator("ulRate", cdk.validateNumber)(properties.ulRate)), errors.collect(cdk.propertyValidator("ulRatePolicy", cdk.validateString)(properties.ulRatePolicy)), errors.wrap('supplied properties not correct for "LoRaWANServiceProfileProperty"');
    }
    function cfnServiceProfileLoRaWANServiceProfilePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnServiceProfile_LoRaWANServiceProfilePropertyValidator(properties).assertSuccess(), { AddGwMetadata: cdk.booleanToCloudFormation(properties.addGwMetadata), ChannelMask: cdk.stringToCloudFormation(properties.channelMask), DevStatusReqFreq: cdk.numberToCloudFormation(properties.devStatusReqFreq), DlBucketSize: cdk.numberToCloudFormation(properties.dlBucketSize), DlRate: cdk.numberToCloudFormation(properties.dlRate), DlRatePolicy: cdk.stringToCloudFormation(properties.dlRatePolicy), DrMax: cdk.numberToCloudFormation(properties.drMax), DrMin: cdk.numberToCloudFormation(properties.drMin), HrAllowed: cdk.booleanToCloudFormation(properties.hrAllowed), MinGwDiversity: cdk.numberToCloudFormation(properties.minGwDiversity), NwkGeoLoc: cdk.booleanToCloudFormation(properties.nwkGeoLoc), PrAllowed: cdk.booleanToCloudFormation(properties.prAllowed), RaAllowed: cdk.booleanToCloudFormation(properties.raAllowed), ReportDevStatusBattery: cdk.booleanToCloudFormation(properties.reportDevStatusBattery), ReportDevStatusMargin: cdk.booleanToCloudFormation(properties.reportDevStatusMargin), TargetPer: cdk.numberToCloudFormation(properties.targetPer), UlBucketSize: cdk.numberToCloudFormation(properties.ulBucketSize), UlRate: cdk.numberToCloudFormation(properties.ulRate), UlRatePolicy: cdk.stringToCloudFormation(properties.ulRatePolicy) }) : properties;
    }
    function CfnServiceProfileLoRaWANServiceProfilePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("addGwMetadata", "AddGwMetadata", properties.AddGwMetadata != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AddGwMetadata) : void 0), ret.addPropertyResult("channelMask", "ChannelMask", properties.ChannelMask != null ? cfn_parse.FromCloudFormation.getString(properties.ChannelMask) : void 0), ret.addPropertyResult("devStatusReqFreq", "DevStatusReqFreq", properties.DevStatusReqFreq != null ? cfn_parse.FromCloudFormation.getNumber(properties.DevStatusReqFreq) : void 0), ret.addPropertyResult("dlBucketSize", "DlBucketSize", properties.DlBucketSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.DlBucketSize) : void 0), ret.addPropertyResult("dlRate", "DlRate", properties.DlRate != null ? cfn_parse.FromCloudFormation.getNumber(properties.DlRate) : void 0), ret.addPropertyResult("dlRatePolicy", "DlRatePolicy", properties.DlRatePolicy != null ? cfn_parse.FromCloudFormation.getString(properties.DlRatePolicy) : void 0), ret.addPropertyResult("drMax", "DrMax", properties.DrMax != null ? cfn_parse.FromCloudFormation.getNumber(properties.DrMax) : void 0), ret.addPropertyResult("drMin", "DrMin", properties.DrMin != null ? cfn_parse.FromCloudFormation.getNumber(properties.DrMin) : void 0), ret.addPropertyResult("hrAllowed", "HrAllowed", properties.HrAllowed != null ? cfn_parse.FromCloudFormation.getBoolean(properties.HrAllowed) : void 0), ret.addPropertyResult("minGwDiversity", "MinGwDiversity", properties.MinGwDiversity != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinGwDiversity) : void 0), ret.addPropertyResult("nwkGeoLoc", "NwkGeoLoc", properties.NwkGeoLoc != null ? cfn_parse.FromCloudFormation.getBoolean(properties.NwkGeoLoc) : void 0), ret.addPropertyResult("prAllowed", "PrAllowed", properties.PrAllowed != null ? cfn_parse.FromCloudFormation.getBoolean(properties.PrAllowed) : void 0), ret.addPropertyResult("raAllowed", "RaAllowed", properties.RaAllowed != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RaAllowed) : void 0), ret.addPropertyResult("reportDevStatusBattery", "ReportDevStatusBattery", properties.ReportDevStatusBattery != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ReportDevStatusBattery) : void 0), ret.addPropertyResult("reportDevStatusMargin", "ReportDevStatusMargin", properties.ReportDevStatusMargin != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ReportDevStatusMargin) : void 0), ret.addPropertyResult("targetPer", "TargetPer", properties.TargetPer != null ? cfn_parse.FromCloudFormation.getNumber(properties.TargetPer) : void 0), ret.addPropertyResult("ulBucketSize", "UlBucketSize", properties.UlBucketSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.UlBucketSize) : void 0), ret.addPropertyResult("ulRate", "UlRate", properties.UlRate != null ? cfn_parse.FromCloudFormation.getNumber(properties.UlRate) : void 0), ret.addPropertyResult("ulRatePolicy", "UlRatePolicy", properties.UlRatePolicy != null ? cfn_parse.FromCloudFormation.getString(properties.UlRatePolicy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinitionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoCreateTasks", cdk.requiredValidator)(properties.autoCreateTasks)), errors.collect(cdk.propertyValidator("autoCreateTasks", cdk.validateBoolean)(properties.autoCreateTasks)), errors.collect(cdk.propertyValidator("loRaWanUpdateGatewayTaskEntry", CfnTaskDefinition_LoRaWANUpdateGatewayTaskEntryPropertyValidator)(properties.loRaWanUpdateGatewayTaskEntry)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("taskDefinitionType", cdk.validateString)(properties.taskDefinitionType)), errors.collect(cdk.propertyValidator("update", CfnTaskDefinition_UpdateWirelessGatewayTaskCreatePropertyValidator)(properties.update)), errors.wrap('supplied properties not correct for "CfnTaskDefinitionProps"');
    }
    function cfnTaskDefinitionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinitionPropsValidator(properties).assertSuccess(), { AutoCreateTasks: cdk.booleanToCloudFormation(properties.autoCreateTasks), LoRaWANUpdateGatewayTaskEntry: cfnTaskDefinitionLoRaWANUpdateGatewayTaskEntryPropertyToCloudFormation(properties.loRaWanUpdateGatewayTaskEntry), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TaskDefinitionType: cdk.stringToCloudFormation(properties.taskDefinitionType), Update: cfnTaskDefinitionUpdateWirelessGatewayTaskCreatePropertyToCloudFormation(properties.update) }) : properties;
    }
    function CfnTaskDefinitionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("autoCreateTasks", "AutoCreateTasks", cfn_parse.FromCloudFormation.getBoolean(properties.AutoCreateTasks)), ret.addPropertyResult("loRaWanUpdateGatewayTaskEntry", "LoRaWANUpdateGatewayTaskEntry", properties.LoRaWANUpdateGatewayTaskEntry != null ? CfnTaskDefinitionLoRaWANUpdateGatewayTaskEntryPropertyFromCloudFormation(properties.LoRaWANUpdateGatewayTaskEntry) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("taskDefinitionType", "TaskDefinitionType", properties.TaskDefinitionType != null ? cfn_parse.FromCloudFormation.getString(properties.TaskDefinitionType) : void 0), ret.addPropertyResult("update", "Update", properties.Update != null ? CfnTaskDefinitionUpdateWirelessGatewayTaskCreatePropertyFromCloudFormation(properties.Update) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTaskDefinition = class _CfnTaskDefinition extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTaskDefinitionPropsFromCloudFormation(resourceProperties), ret = new _CfnTaskDefinition(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTaskDefinition.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotwireless_CfnTaskDefinitionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTaskDefinition), error;
        }
        cdk.requireProperty(props, "autoCreateTasks", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.autoCreateTasks = props.autoCreateTasks, this.loRaWanUpdateGatewayTaskEntry = props.loRaWanUpdateGatewayTaskEntry, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTWireless::TaskDefinition", props.tags, { tagPropertyName: "tags" }), this.taskDefinitionType = props.taskDefinitionType, this.update = props.update;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTaskDefinition.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { autoCreateTasks: this.autoCreateTasks, loRaWanUpdateGatewayTaskEntry: this.loRaWanUpdateGatewayTaskEntry, name: this.name, tags: this.tags.renderTags(), taskDefinitionType: this.taskDefinitionType, update: this.update };
      }
      renderProperties(props) {
        return cfnTaskDefinitionPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnTaskDefinition[_h] = { fqn: "aws-cdk-lib.aws_iotwireless.CfnTaskDefinition", version: "2.80.0" }, CfnTaskDefinition.CFN_RESOURCE_TYPE_NAME = "AWS::IoTWireless::TaskDefinition", exports2.CfnTaskDefinition = CfnTaskDefinition;
    function CfnTaskDefinition_LoRaWANGatewayVersionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("model", cdk.validateString)(properties.model)), errors.collect(cdk.propertyValidator("packageVersion", cdk.validateString)(properties.packageVersion)), errors.collect(cdk.propertyValidator("station", cdk.validateString)(properties.station)), errors.wrap('supplied properties not correct for "LoRaWANGatewayVersionProperty"');
    }
    function cfnTaskDefinitionLoRaWANGatewayVersionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_LoRaWANGatewayVersionPropertyValidator(properties).assertSuccess(), { Model: cdk.stringToCloudFormation(properties.model), PackageVersion: cdk.stringToCloudFormation(properties.packageVersion), Station: cdk.stringToCloudFormation(properties.station) }) : properties;
    }
    function CfnTaskDefinitionLoRaWANGatewayVersionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("model", "Model", properties.Model != null ? cfn_parse.FromCloudFormation.getString(properties.Model) : void 0), ret.addPropertyResult("packageVersion", "PackageVersion", properties.PackageVersion != null ? cfn_parse.FromCloudFormation.getString(properties.PackageVersion) : void 0), ret.addPropertyResult("station", "Station", properties.Station != null ? cfn_parse.FromCloudFormation.getString(properties.Station) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_LoRaWANUpdateGatewayTaskCreatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("currentVersion", CfnTaskDefinition_LoRaWANGatewayVersionPropertyValidator)(properties.currentVersion)), errors.collect(cdk.propertyValidator("sigKeyCrc", cdk.validateNumber)(properties.sigKeyCrc)), errors.collect(cdk.propertyValidator("updateSignature", cdk.validateString)(properties.updateSignature)), errors.collect(cdk.propertyValidator("updateVersion", CfnTaskDefinition_LoRaWANGatewayVersionPropertyValidator)(properties.updateVersion)), errors.wrap('supplied properties not correct for "LoRaWANUpdateGatewayTaskCreateProperty"');
    }
    function cfnTaskDefinitionLoRaWANUpdateGatewayTaskCreatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_LoRaWANUpdateGatewayTaskCreatePropertyValidator(properties).assertSuccess(), { CurrentVersion: cfnTaskDefinitionLoRaWANGatewayVersionPropertyToCloudFormation(properties.currentVersion), SigKeyCrc: cdk.numberToCloudFormation(properties.sigKeyCrc), UpdateSignature: cdk.stringToCloudFormation(properties.updateSignature), UpdateVersion: cfnTaskDefinitionLoRaWANGatewayVersionPropertyToCloudFormation(properties.updateVersion) }) : properties;
    }
    function CfnTaskDefinitionLoRaWANUpdateGatewayTaskCreatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("currentVersion", "CurrentVersion", properties.CurrentVersion != null ? CfnTaskDefinitionLoRaWANGatewayVersionPropertyFromCloudFormation(properties.CurrentVersion) : void 0), ret.addPropertyResult("sigKeyCrc", "SigKeyCrc", properties.SigKeyCrc != null ? cfn_parse.FromCloudFormation.getNumber(properties.SigKeyCrc) : void 0), ret.addPropertyResult("updateSignature", "UpdateSignature", properties.UpdateSignature != null ? cfn_parse.FromCloudFormation.getString(properties.UpdateSignature) : void 0), ret.addPropertyResult("updateVersion", "UpdateVersion", properties.UpdateVersion != null ? CfnTaskDefinitionLoRaWANGatewayVersionPropertyFromCloudFormation(properties.UpdateVersion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_LoRaWANUpdateGatewayTaskEntryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("currentVersion", CfnTaskDefinition_LoRaWANGatewayVersionPropertyValidator)(properties.currentVersion)), errors.collect(cdk.propertyValidator("updateVersion", CfnTaskDefinition_LoRaWANGatewayVersionPropertyValidator)(properties.updateVersion)), errors.wrap('supplied properties not correct for "LoRaWANUpdateGatewayTaskEntryProperty"');
    }
    function cfnTaskDefinitionLoRaWANUpdateGatewayTaskEntryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_LoRaWANUpdateGatewayTaskEntryPropertyValidator(properties).assertSuccess(), { CurrentVersion: cfnTaskDefinitionLoRaWANGatewayVersionPropertyToCloudFormation(properties.currentVersion), UpdateVersion: cfnTaskDefinitionLoRaWANGatewayVersionPropertyToCloudFormation(properties.updateVersion) }) : properties;
    }
    function CfnTaskDefinitionLoRaWANUpdateGatewayTaskEntryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("currentVersion", "CurrentVersion", properties.CurrentVersion != null ? CfnTaskDefinitionLoRaWANGatewayVersionPropertyFromCloudFormation(properties.CurrentVersion) : void 0), ret.addPropertyResult("updateVersion", "UpdateVersion", properties.UpdateVersion != null ? CfnTaskDefinitionLoRaWANGatewayVersionPropertyFromCloudFormation(properties.UpdateVersion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTaskDefinition_UpdateWirelessGatewayTaskCreatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("loRaWan", CfnTaskDefinition_LoRaWANUpdateGatewayTaskCreatePropertyValidator)(properties.loRaWan)), errors.collect(cdk.propertyValidator("updateDataRole", cdk.validateString)(properties.updateDataRole)), errors.collect(cdk.propertyValidator("updateDataSource", cdk.validateString)(properties.updateDataSource)), errors.wrap('supplied properties not correct for "UpdateWirelessGatewayTaskCreateProperty"');
    }
    function cfnTaskDefinitionUpdateWirelessGatewayTaskCreatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTaskDefinition_UpdateWirelessGatewayTaskCreatePropertyValidator(properties).assertSuccess(), { LoRaWAN: cfnTaskDefinitionLoRaWANUpdateGatewayTaskCreatePropertyToCloudFormation(properties.loRaWan), UpdateDataRole: cdk.stringToCloudFormation(properties.updateDataRole), UpdateDataSource: cdk.stringToCloudFormation(properties.updateDataSource) }) : properties;
    }
    function CfnTaskDefinitionUpdateWirelessGatewayTaskCreatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("loRaWan", "LoRaWAN", properties.LoRaWAN != null ? CfnTaskDefinitionLoRaWANUpdateGatewayTaskCreatePropertyFromCloudFormation(properties.LoRaWAN) : void 0), ret.addPropertyResult("updateDataRole", "UpdateDataRole", properties.UpdateDataRole != null ? cfn_parse.FromCloudFormation.getString(properties.UpdateDataRole) : void 0), ret.addPropertyResult("updateDataSource", "UpdateDataSource", properties.UpdateDataSource != null ? cfn_parse.FromCloudFormation.getString(properties.UpdateDataSource) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWirelessDevicePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("destinationName", cdk.requiredValidator)(properties.destinationName)), errors.collect(cdk.propertyValidator("destinationName", cdk.validateString)(properties.destinationName)), errors.collect(cdk.propertyValidator("lastUplinkReceivedAt", cdk.validateString)(properties.lastUplinkReceivedAt)), errors.collect(cdk.propertyValidator("loRaWan", CfnWirelessDevice_LoRaWANDevicePropertyValidator)(properties.loRaWan)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("thingArn", cdk.validateString)(properties.thingArn)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnWirelessDeviceProps"');
    }
    function cfnWirelessDevicePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWirelessDevicePropsValidator(properties).assertSuccess(), { DestinationName: cdk.stringToCloudFormation(properties.destinationName), Type: cdk.stringToCloudFormation(properties.type), Description: cdk.stringToCloudFormation(properties.description), LastUplinkReceivedAt: cdk.stringToCloudFormation(properties.lastUplinkReceivedAt), LoRaWAN: cfnWirelessDeviceLoRaWANDevicePropertyToCloudFormation(properties.loRaWan), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), ThingArn: cdk.stringToCloudFormation(properties.thingArn) }) : properties;
    }
    function CfnWirelessDevicePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationName", "DestinationName", cfn_parse.FromCloudFormation.getString(properties.DestinationName)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("lastUplinkReceivedAt", "LastUplinkReceivedAt", properties.LastUplinkReceivedAt != null ? cfn_parse.FromCloudFormation.getString(properties.LastUplinkReceivedAt) : void 0), ret.addPropertyResult("loRaWan", "LoRaWAN", properties.LoRaWAN != null ? CfnWirelessDeviceLoRaWANDevicePropertyFromCloudFormation(properties.LoRaWAN) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("thingArn", "ThingArn", properties.ThingArn != null ? cfn_parse.FromCloudFormation.getString(properties.ThingArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnWirelessDevice = class _CfnWirelessDevice extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnWirelessDevicePropsFromCloudFormation(resourceProperties), ret = new _CfnWirelessDevice(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnWirelessDevice.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotwireless_CfnWirelessDeviceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnWirelessDevice), error;
        }
        cdk.requireProperty(props, "destinationName", this), cdk.requireProperty(props, "type", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrThingName = cdk.Token.asString(this.getAtt("ThingName", cdk.ResolutionTypeHint.STRING)), this.destinationName = props.destinationName, this.type = props.type, this.description = props.description, this.lastUplinkReceivedAt = props.lastUplinkReceivedAt, this.loRaWan = props.loRaWan, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTWireless::WirelessDevice", props.tags, { tagPropertyName: "tags" }), this.thingArn = props.thingArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnWirelessDevice.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { destinationName: this.destinationName, type: this.type, description: this.description, lastUplinkReceivedAt: this.lastUplinkReceivedAt, loRaWan: this.loRaWan, name: this.name, tags: this.tags.renderTags(), thingArn: this.thingArn };
      }
      renderProperties(props) {
        return cfnWirelessDevicePropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnWirelessDevice[_j] = { fqn: "aws-cdk-lib.aws_iotwireless.CfnWirelessDevice", version: "2.80.0" }, CfnWirelessDevice.CFN_RESOURCE_TYPE_NAME = "AWS::IoTWireless::WirelessDevice", exports2.CfnWirelessDevice = CfnWirelessDevice;
    function CfnWirelessDevice_AbpV10xPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("devAddr", cdk.requiredValidator)(properties.devAddr)), errors.collect(cdk.propertyValidator("devAddr", cdk.validateString)(properties.devAddr)), errors.collect(cdk.propertyValidator("sessionKeys", cdk.requiredValidator)(properties.sessionKeys)), errors.collect(cdk.propertyValidator("sessionKeys", CfnWirelessDevice_SessionKeysAbpV10xPropertyValidator)(properties.sessionKeys)), errors.wrap('supplied properties not correct for "AbpV10xProperty"');
    }
    function cfnWirelessDeviceAbpV10xPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWirelessDevice_AbpV10xPropertyValidator(properties).assertSuccess(), { DevAddr: cdk.stringToCloudFormation(properties.devAddr), SessionKeys: cfnWirelessDeviceSessionKeysAbpV10xPropertyToCloudFormation(properties.sessionKeys) }) : properties;
    }
    function CfnWirelessDeviceAbpV10xPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("devAddr", "DevAddr", cfn_parse.FromCloudFormation.getString(properties.DevAddr)), ret.addPropertyResult("sessionKeys", "SessionKeys", CfnWirelessDeviceSessionKeysAbpV10xPropertyFromCloudFormation(properties.SessionKeys)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWirelessDevice_AbpV11PropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("devAddr", cdk.requiredValidator)(properties.devAddr)), errors.collect(cdk.propertyValidator("devAddr", cdk.validateString)(properties.devAddr)), errors.collect(cdk.propertyValidator("sessionKeys", cdk.requiredValidator)(properties.sessionKeys)), errors.collect(cdk.propertyValidator("sessionKeys", CfnWirelessDevice_SessionKeysAbpV11PropertyValidator)(properties.sessionKeys)), errors.wrap('supplied properties not correct for "AbpV11Property"');
    }
    function cfnWirelessDeviceAbpV11PropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWirelessDevice_AbpV11PropertyValidator(properties).assertSuccess(), { DevAddr: cdk.stringToCloudFormation(properties.devAddr), SessionKeys: cfnWirelessDeviceSessionKeysAbpV11PropertyToCloudFormation(properties.sessionKeys) }) : properties;
    }
    function CfnWirelessDeviceAbpV11PropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("devAddr", "DevAddr", cfn_parse.FromCloudFormation.getString(properties.DevAddr)), ret.addPropertyResult("sessionKeys", "SessionKeys", CfnWirelessDeviceSessionKeysAbpV11PropertyFromCloudFormation(properties.SessionKeys)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWirelessDevice_LoRaWANDevicePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("abpV10X", CfnWirelessDevice_AbpV10xPropertyValidator)(properties.abpV10X)), errors.collect(cdk.propertyValidator("abpV11", CfnWirelessDevice_AbpV11PropertyValidator)(properties.abpV11)), errors.collect(cdk.propertyValidator("devEui", cdk.validateString)(properties.devEui)), errors.collect(cdk.propertyValidator("deviceProfileId", cdk.validateString)(properties.deviceProfileId)), errors.collect(cdk.propertyValidator("otaaV10X", CfnWirelessDevice_OtaaV10xPropertyValidator)(properties.otaaV10X)), errors.collect(cdk.propertyValidator("otaaV11", CfnWirelessDevice_OtaaV11PropertyValidator)(properties.otaaV11)), errors.collect(cdk.propertyValidator("serviceProfileId", cdk.validateString)(properties.serviceProfileId)), errors.wrap('supplied properties not correct for "LoRaWANDeviceProperty"');
    }
    function cfnWirelessDeviceLoRaWANDevicePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWirelessDevice_LoRaWANDevicePropertyValidator(properties).assertSuccess(), { AbpV10x: cfnWirelessDeviceAbpV10xPropertyToCloudFormation(properties.abpV10X), AbpV11: cfnWirelessDeviceAbpV11PropertyToCloudFormation(properties.abpV11), DevEui: cdk.stringToCloudFormation(properties.devEui), DeviceProfileId: cdk.stringToCloudFormation(properties.deviceProfileId), OtaaV10x: cfnWirelessDeviceOtaaV10xPropertyToCloudFormation(properties.otaaV10X), OtaaV11: cfnWirelessDeviceOtaaV11PropertyToCloudFormation(properties.otaaV11), ServiceProfileId: cdk.stringToCloudFormation(properties.serviceProfileId) }) : properties;
    }
    function CfnWirelessDeviceLoRaWANDevicePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("abpV10X", "AbpV10x", properties.AbpV10x != null ? CfnWirelessDeviceAbpV10xPropertyFromCloudFormation(properties.AbpV10x) : void 0), ret.addPropertyResult("abpV11", "AbpV11", properties.AbpV11 != null ? CfnWirelessDeviceAbpV11PropertyFromCloudFormation(properties.AbpV11) : void 0), ret.addPropertyResult("devEui", "DevEui", properties.DevEui != null ? cfn_parse.FromCloudFormation.getString(properties.DevEui) : void 0), ret.addPropertyResult("deviceProfileId", "DeviceProfileId", properties.DeviceProfileId != null ? cfn_parse.FromCloudFormation.getString(properties.DeviceProfileId) : void 0), ret.addPropertyResult("otaaV10X", "OtaaV10x", properties.OtaaV10x != null ? CfnWirelessDeviceOtaaV10xPropertyFromCloudFormation(properties.OtaaV10x) : void 0), ret.addPropertyResult("otaaV11", "OtaaV11", properties.OtaaV11 != null ? CfnWirelessDeviceOtaaV11PropertyFromCloudFormation(properties.OtaaV11) : void 0), ret.addPropertyResult("serviceProfileId", "ServiceProfileId", properties.ServiceProfileId != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceProfileId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWirelessDevice_OtaaV10xPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("appEui", cdk.requiredValidator)(properties.appEui)), errors.collect(cdk.propertyValidator("appEui", cdk.validateString)(properties.appEui)), errors.collect(cdk.propertyValidator("appKey", cdk.requiredValidator)(properties.appKey)), errors.collect(cdk.propertyValidator("appKey", cdk.validateString)(properties.appKey)), errors.wrap('supplied properties not correct for "OtaaV10xProperty"');
    }
    function cfnWirelessDeviceOtaaV10xPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWirelessDevice_OtaaV10xPropertyValidator(properties).assertSuccess(), { AppEui: cdk.stringToCloudFormation(properties.appEui), AppKey: cdk.stringToCloudFormation(properties.appKey) }) : properties;
    }
    function CfnWirelessDeviceOtaaV10xPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("appEui", "AppEui", cfn_parse.FromCloudFormation.getString(properties.AppEui)), ret.addPropertyResult("appKey", "AppKey", cfn_parse.FromCloudFormation.getString(properties.AppKey)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWirelessDevice_OtaaV11PropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("appKey", cdk.requiredValidator)(properties.appKey)), errors.collect(cdk.propertyValidator("appKey", cdk.validateString)(properties.appKey)), errors.collect(cdk.propertyValidator("joinEui", cdk.requiredValidator)(properties.joinEui)), errors.collect(cdk.propertyValidator("joinEui", cdk.validateString)(properties.joinEui)), errors.collect(cdk.propertyValidator("nwkKey", cdk.requiredValidator)(properties.nwkKey)), errors.collect(cdk.propertyValidator("nwkKey", cdk.validateString)(properties.nwkKey)), errors.wrap('supplied properties not correct for "OtaaV11Property"');
    }
    function cfnWirelessDeviceOtaaV11PropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWirelessDevice_OtaaV11PropertyValidator(properties).assertSuccess(), { AppKey: cdk.stringToCloudFormation(properties.appKey), JoinEui: cdk.stringToCloudFormation(properties.joinEui), NwkKey: cdk.stringToCloudFormation(properties.nwkKey) }) : properties;
    }
    function CfnWirelessDeviceOtaaV11PropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("appKey", "AppKey", cfn_parse.FromCloudFormation.getString(properties.AppKey)), ret.addPropertyResult("joinEui", "JoinEui", cfn_parse.FromCloudFormation.getString(properties.JoinEui)), ret.addPropertyResult("nwkKey", "NwkKey", cfn_parse.FromCloudFormation.getString(properties.NwkKey)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWirelessDevice_SessionKeysAbpV10xPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("appSKey", cdk.requiredValidator)(properties.appSKey)), errors.collect(cdk.propertyValidator("appSKey", cdk.validateString)(properties.appSKey)), errors.collect(cdk.propertyValidator("nwkSKey", cdk.requiredValidator)(properties.nwkSKey)), errors.collect(cdk.propertyValidator("nwkSKey", cdk.validateString)(properties.nwkSKey)), errors.wrap('supplied properties not correct for "SessionKeysAbpV10xProperty"');
    }
    function cfnWirelessDeviceSessionKeysAbpV10xPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWirelessDevice_SessionKeysAbpV10xPropertyValidator(properties).assertSuccess(), { AppSKey: cdk.stringToCloudFormation(properties.appSKey), NwkSKey: cdk.stringToCloudFormation(properties.nwkSKey) }) : properties;
    }
    function CfnWirelessDeviceSessionKeysAbpV10xPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("appSKey", "AppSKey", cfn_parse.FromCloudFormation.getString(properties.AppSKey)), ret.addPropertyResult("nwkSKey", "NwkSKey", cfn_parse.FromCloudFormation.getString(properties.NwkSKey)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWirelessDevice_SessionKeysAbpV11PropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("appSKey", cdk.requiredValidator)(properties.appSKey)), errors.collect(cdk.propertyValidator("appSKey", cdk.validateString)(properties.appSKey)), errors.collect(cdk.propertyValidator("fNwkSIntKey", cdk.requiredValidator)(properties.fNwkSIntKey)), errors.collect(cdk.propertyValidator("fNwkSIntKey", cdk.validateString)(properties.fNwkSIntKey)), errors.collect(cdk.propertyValidator("nwkSEncKey", cdk.requiredValidator)(properties.nwkSEncKey)), errors.collect(cdk.propertyValidator("nwkSEncKey", cdk.validateString)(properties.nwkSEncKey)), errors.collect(cdk.propertyValidator("sNwkSIntKey", cdk.requiredValidator)(properties.sNwkSIntKey)), errors.collect(cdk.propertyValidator("sNwkSIntKey", cdk.validateString)(properties.sNwkSIntKey)), errors.wrap('supplied properties not correct for "SessionKeysAbpV11Property"');
    }
    function cfnWirelessDeviceSessionKeysAbpV11PropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWirelessDevice_SessionKeysAbpV11PropertyValidator(properties).assertSuccess(), { AppSKey: cdk.stringToCloudFormation(properties.appSKey), FNwkSIntKey: cdk.stringToCloudFormation(properties.fNwkSIntKey), NwkSEncKey: cdk.stringToCloudFormation(properties.nwkSEncKey), SNwkSIntKey: cdk.stringToCloudFormation(properties.sNwkSIntKey) }) : properties;
    }
    function CfnWirelessDeviceSessionKeysAbpV11PropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("appSKey", "AppSKey", cfn_parse.FromCloudFormation.getString(properties.AppSKey)), ret.addPropertyResult("fNwkSIntKey", "FNwkSIntKey", cfn_parse.FromCloudFormation.getString(properties.FNwkSIntKey)), ret.addPropertyResult("nwkSEncKey", "NwkSEncKey", cfn_parse.FromCloudFormation.getString(properties.NwkSEncKey)), ret.addPropertyResult("sNwkSIntKey", "SNwkSIntKey", cfn_parse.FromCloudFormation.getString(properties.SNwkSIntKey)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWirelessDeviceImportTaskPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationName", cdk.requiredValidator)(properties.destinationName)), errors.collect(cdk.propertyValidator("destinationName", cdk.validateString)(properties.destinationName)), errors.collect(cdk.propertyValidator("sidewalk", cdk.requiredValidator)(properties.sidewalk)), errors.collect(cdk.propertyValidator("sidewalk", CfnWirelessDeviceImportTask_SidewalkPropertyValidator)(properties.sidewalk)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnWirelessDeviceImportTaskProps"');
    }
    function cfnWirelessDeviceImportTaskPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWirelessDeviceImportTaskPropsValidator(properties).assertSuccess(), { DestinationName: cdk.stringToCloudFormation(properties.destinationName), Sidewalk: cfnWirelessDeviceImportTaskSidewalkPropertyToCloudFormation(properties.sidewalk), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnWirelessDeviceImportTaskPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationName", "DestinationName", cfn_parse.FromCloudFormation.getString(properties.DestinationName)), ret.addPropertyResult("sidewalk", "Sidewalk", CfnWirelessDeviceImportTaskSidewalkPropertyFromCloudFormation(properties.Sidewalk)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnWirelessDeviceImportTask = class _CfnWirelessDeviceImportTask extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnWirelessDeviceImportTaskPropsFromCloudFormation(resourceProperties), ret = new _CfnWirelessDeviceImportTask(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnWirelessDeviceImportTask.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotwireless_CfnWirelessDeviceImportTaskProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnWirelessDeviceImportTask), error;
        }
        cdk.requireProperty(props, "destinationName", this), cdk.requireProperty(props, "sidewalk", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreationDate = cdk.Token.asString(this.getAtt("CreationDate", cdk.ResolutionTypeHint.STRING)), this.attrFailedImportedDevicesCount = cdk.Token.asNumber(this.getAtt("FailedImportedDevicesCount", cdk.ResolutionTypeHint.NUMBER)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrInitializedImportedDevicesCount = cdk.Token.asNumber(this.getAtt("InitializedImportedDevicesCount", cdk.ResolutionTypeHint.NUMBER)), this.attrOnboardedImportedDevicesCount = cdk.Token.asNumber(this.getAtt("OnboardedImportedDevicesCount", cdk.ResolutionTypeHint.NUMBER)), this.attrPendingImportedDevicesCount = cdk.Token.asNumber(this.getAtt("PendingImportedDevicesCount", cdk.ResolutionTypeHint.NUMBER)), this.attrSidewalkDeviceCreationFileList = cdk.Token.asList(this.getAtt("Sidewalk.DeviceCreationFileList", cdk.ResolutionTypeHint.STRING_LIST)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.attrStatusReason = cdk.Token.asString(this.getAtt("StatusReason", cdk.ResolutionTypeHint.STRING)), this.destinationName = props.destinationName, this.sidewalk = props.sidewalk, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTWireless::WirelessDeviceImportTask", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnWirelessDeviceImportTask.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { destinationName: this.destinationName, sidewalk: this.sidewalk, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnWirelessDeviceImportTaskPropsToCloudFormation(props);
      }
    };
    _k = JSII_RTTI_SYMBOL_1, CfnWirelessDeviceImportTask[_k] = { fqn: "aws-cdk-lib.aws_iotwireless.CfnWirelessDeviceImportTask", version: "2.80.0" }, CfnWirelessDeviceImportTask.CFN_RESOURCE_TYPE_NAME = "AWS::IoTWireless::WirelessDeviceImportTask", exports2.CfnWirelessDeviceImportTask = CfnWirelessDeviceImportTask;
    function CfnWirelessDeviceImportTask_SidewalkPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deviceCreationFile", cdk.validateString)(properties.deviceCreationFile)), errors.collect(cdk.propertyValidator("deviceCreationFileList", cdk.listValidator(cdk.validateString))(properties.deviceCreationFileList)), errors.collect(cdk.propertyValidator("role", cdk.validateString)(properties.role)), errors.collect(cdk.propertyValidator("sidewalkManufacturingSn", cdk.validateString)(properties.sidewalkManufacturingSn)), errors.wrap('supplied properties not correct for "SidewalkProperty"');
    }
    function cfnWirelessDeviceImportTaskSidewalkPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWirelessDeviceImportTask_SidewalkPropertyValidator(properties).assertSuccess(), { DeviceCreationFile: cdk.stringToCloudFormation(properties.deviceCreationFile), DeviceCreationFileList: cdk.listMapper(cdk.stringToCloudFormation)(properties.deviceCreationFileList), Role: cdk.stringToCloudFormation(properties.role), SidewalkManufacturingSn: cdk.stringToCloudFormation(properties.sidewalkManufacturingSn) }) : properties;
    }
    function CfnWirelessDeviceImportTaskSidewalkPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deviceCreationFile", "DeviceCreationFile", properties.DeviceCreationFile != null ? cfn_parse.FromCloudFormation.getString(properties.DeviceCreationFile) : void 0), ret.addPropertyResult("deviceCreationFileList", "DeviceCreationFileList", properties.DeviceCreationFileList != null ? cfn_parse.FromCloudFormation.getStringArray(properties.DeviceCreationFileList) : void 0), ret.addPropertyResult("role", "Role", properties.Role != null ? cfn_parse.FromCloudFormation.getString(properties.Role) : void 0), ret.addPropertyResult("sidewalkManufacturingSn", "SidewalkManufacturingSn", properties.SidewalkManufacturingSn != null ? cfn_parse.FromCloudFormation.getString(properties.SidewalkManufacturingSn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWirelessGatewayPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("lastUplinkReceivedAt", cdk.validateString)(properties.lastUplinkReceivedAt)), errors.collect(cdk.propertyValidator("loRaWan", cdk.requiredValidator)(properties.loRaWan)), errors.collect(cdk.propertyValidator("loRaWan", CfnWirelessGateway_LoRaWANGatewayPropertyValidator)(properties.loRaWan)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("thingArn", cdk.validateString)(properties.thingArn)), errors.collect(cdk.propertyValidator("thingName", cdk.validateString)(properties.thingName)), errors.wrap('supplied properties not correct for "CfnWirelessGatewayProps"');
    }
    function cfnWirelessGatewayPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWirelessGatewayPropsValidator(properties).assertSuccess(), { LoRaWAN: cfnWirelessGatewayLoRaWANGatewayPropertyToCloudFormation(properties.loRaWan), Description: cdk.stringToCloudFormation(properties.description), LastUplinkReceivedAt: cdk.stringToCloudFormation(properties.lastUplinkReceivedAt), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), ThingArn: cdk.stringToCloudFormation(properties.thingArn), ThingName: cdk.stringToCloudFormation(properties.thingName) }) : properties;
    }
    function CfnWirelessGatewayPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("loRaWan", "LoRaWAN", CfnWirelessGatewayLoRaWANGatewayPropertyFromCloudFormation(properties.LoRaWAN)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("lastUplinkReceivedAt", "LastUplinkReceivedAt", properties.LastUplinkReceivedAt != null ? cfn_parse.FromCloudFormation.getString(properties.LastUplinkReceivedAt) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("thingArn", "ThingArn", properties.ThingArn != null ? cfn_parse.FromCloudFormation.getString(properties.ThingArn) : void 0), ret.addPropertyResult("thingName", "ThingName", properties.ThingName != null ? cfn_parse.FromCloudFormation.getString(properties.ThingName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnWirelessGateway = class _CfnWirelessGateway extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnWirelessGatewayPropsFromCloudFormation(resourceProperties), ret = new _CfnWirelessGateway(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnWirelessGateway.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iotwireless_CfnWirelessGatewayProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnWirelessGateway), error;
        }
        cdk.requireProperty(props, "loRaWan", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.loRaWan = props.loRaWan, this.description = props.description, this.lastUplinkReceivedAt = props.lastUplinkReceivedAt, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IoTWireless::WirelessGateway", props.tags, { tagPropertyName: "tags" }), this.thingArn = props.thingArn, this.thingName = props.thingName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnWirelessGateway.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { loRaWan: this.loRaWan, description: this.description, lastUplinkReceivedAt: this.lastUplinkReceivedAt, name: this.name, tags: this.tags.renderTags(), thingArn: this.thingArn, thingName: this.thingName };
      }
      renderProperties(props) {
        return cfnWirelessGatewayPropsToCloudFormation(props);
      }
    };
    _l = JSII_RTTI_SYMBOL_1, CfnWirelessGateway[_l] = { fqn: "aws-cdk-lib.aws_iotwireless.CfnWirelessGateway", version: "2.80.0" }, CfnWirelessGateway.CFN_RESOURCE_TYPE_NAME = "AWS::IoTWireless::WirelessGateway", exports2.CfnWirelessGateway = CfnWirelessGateway;
    function CfnWirelessGateway_LoRaWANGatewayPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("gatewayEui", cdk.requiredValidator)(properties.gatewayEui)), errors.collect(cdk.propertyValidator("gatewayEui", cdk.validateString)(properties.gatewayEui)), errors.collect(cdk.propertyValidator("rfRegion", cdk.requiredValidator)(properties.rfRegion)), errors.collect(cdk.propertyValidator("rfRegion", cdk.validateString)(properties.rfRegion)), errors.wrap('supplied properties not correct for "LoRaWANGatewayProperty"');
    }
    function cfnWirelessGatewayLoRaWANGatewayPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWirelessGateway_LoRaWANGatewayPropertyValidator(properties).assertSuccess(), { GatewayEui: cdk.stringToCloudFormation(properties.gatewayEui), RfRegion: cdk.stringToCloudFormation(properties.rfRegion) }) : properties;
    }
    function CfnWirelessGatewayLoRaWANGatewayPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("gatewayEui", "GatewayEui", cfn_parse.FromCloudFormation.getString(properties.GatewayEui)), ret.addPropertyResult("rfRegion", "RfRegion", cfn_parse.FromCloudFormation.getString(properties.RfRegion)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-iotwireless/lib/index.js
var require_lib159 = __commonJS({
  "node_modules/aws-cdk-lib/aws-iotwireless/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_iotwireless_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-iotwireless/index.js
var require_aws_iotwireless = __commonJS({
  "node_modules/aws-cdk-lib/aws-iotwireless/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib159(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-ivs/lib/ivs.generated.js
var require_ivs_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-ivs/lib/ivs.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnStreamKey = exports2.CfnRecordingConfiguration = exports2.CfnPlaybackKeyPair = exports2.CfnChannel = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnChannelPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authorized", cdk.validateBoolean)(properties.authorized)), errors.collect(cdk.propertyValidator("insecureIngest", cdk.validateBoolean)(properties.insecureIngest)), errors.collect(cdk.propertyValidator("latencyMode", cdk.validateString)(properties.latencyMode)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("recordingConfigurationArn", cdk.validateString)(properties.recordingConfigurationArn)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnChannelProps"');
    }
    function cfnChannelPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannelPropsValidator(properties).assertSuccess(), { Authorized: cdk.booleanToCloudFormation(properties.authorized), InsecureIngest: cdk.booleanToCloudFormation(properties.insecureIngest), LatencyMode: cdk.stringToCloudFormation(properties.latencyMode), Name: cdk.stringToCloudFormation(properties.name), RecordingConfigurationArn: cdk.stringToCloudFormation(properties.recordingConfigurationArn), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnChannelPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authorized", "Authorized", properties.Authorized != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Authorized) : void 0), ret.addPropertyResult("insecureIngest", "InsecureIngest", properties.InsecureIngest != null ? cfn_parse.FromCloudFormation.getBoolean(properties.InsecureIngest) : void 0), ret.addPropertyResult("latencyMode", "LatencyMode", properties.LatencyMode != null ? cfn_parse.FromCloudFormation.getString(properties.LatencyMode) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("recordingConfigurationArn", "RecordingConfigurationArn", properties.RecordingConfigurationArn != null ? cfn_parse.FromCloudFormation.getString(properties.RecordingConfigurationArn) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnChannel = class _CfnChannel extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnChannelPropsFromCloudFormation(resourceProperties), ret = new _CfnChannel(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnChannel.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ivs_CfnChannelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnChannel), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrIngestEndpoint = cdk.Token.asString(this.getAtt("IngestEndpoint", cdk.ResolutionTypeHint.STRING)), this.attrPlaybackUrl = cdk.Token.asString(this.getAtt("PlaybackUrl", cdk.ResolutionTypeHint.STRING)), this.authorized = props.authorized, this.insecureIngest = props.insecureIngest, this.latencyMode = props.latencyMode, this.name = props.name, this.recordingConfigurationArn = props.recordingConfigurationArn, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IVS::Channel", props.tags, { tagPropertyName: "tags" }), this.type = props.type;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnChannel.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { authorized: this.authorized, insecureIngest: this.insecureIngest, latencyMode: this.latencyMode, name: this.name, recordingConfigurationArn: this.recordingConfigurationArn, tags: this.tags.renderTags(), type: this.type };
      }
      renderProperties(props) {
        return cfnChannelPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnChannel[_a] = { fqn: "aws-cdk-lib.aws_ivs.CfnChannel", version: "2.80.0" }, CfnChannel.CFN_RESOURCE_TYPE_NAME = "AWS::IVS::Channel", exports2.CfnChannel = CfnChannel;
    function CfnPlaybackKeyPairPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("publicKeyMaterial", cdk.validateString)(properties.publicKeyMaterial)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnPlaybackKeyPairProps"');
    }
    function cfnPlaybackKeyPairPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPlaybackKeyPairPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), PublicKeyMaterial: cdk.stringToCloudFormation(properties.publicKeyMaterial), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnPlaybackKeyPairPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("publicKeyMaterial", "PublicKeyMaterial", properties.PublicKeyMaterial != null ? cfn_parse.FromCloudFormation.getString(properties.PublicKeyMaterial) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPlaybackKeyPair = class _CfnPlaybackKeyPair extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPlaybackKeyPairPropsFromCloudFormation(resourceProperties), ret = new _CfnPlaybackKeyPair(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnPlaybackKeyPair.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ivs_CfnPlaybackKeyPairProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPlaybackKeyPair), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrFingerprint = cdk.Token.asString(this.getAtt("Fingerprint", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.publicKeyMaterial = props.publicKeyMaterial, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IVS::PlaybackKeyPair", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPlaybackKeyPair.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, publicKeyMaterial: this.publicKeyMaterial, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnPlaybackKeyPairPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnPlaybackKeyPair[_b] = { fqn: "aws-cdk-lib.aws_ivs.CfnPlaybackKeyPair", version: "2.80.0" }, CfnPlaybackKeyPair.CFN_RESOURCE_TYPE_NAME = "AWS::IVS::PlaybackKeyPair", exports2.CfnPlaybackKeyPair = CfnPlaybackKeyPair;
    function CfnRecordingConfigurationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationConfiguration", cdk.requiredValidator)(properties.destinationConfiguration)), errors.collect(cdk.propertyValidator("destinationConfiguration", CfnRecordingConfiguration_DestinationConfigurationPropertyValidator)(properties.destinationConfiguration)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("recordingReconnectWindowSeconds", cdk.validateNumber)(properties.recordingReconnectWindowSeconds)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("thumbnailConfiguration", CfnRecordingConfiguration_ThumbnailConfigurationPropertyValidator)(properties.thumbnailConfiguration)), errors.wrap('supplied properties not correct for "CfnRecordingConfigurationProps"');
    }
    function cfnRecordingConfigurationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRecordingConfigurationPropsValidator(properties).assertSuccess(), { DestinationConfiguration: cfnRecordingConfigurationDestinationConfigurationPropertyToCloudFormation(properties.destinationConfiguration), Name: cdk.stringToCloudFormation(properties.name), RecordingReconnectWindowSeconds: cdk.numberToCloudFormation(properties.recordingReconnectWindowSeconds), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), ThumbnailConfiguration: cfnRecordingConfigurationThumbnailConfigurationPropertyToCloudFormation(properties.thumbnailConfiguration) }) : properties;
    }
    function CfnRecordingConfigurationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationConfiguration", "DestinationConfiguration", CfnRecordingConfigurationDestinationConfigurationPropertyFromCloudFormation(properties.DestinationConfiguration)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("recordingReconnectWindowSeconds", "RecordingReconnectWindowSeconds", properties.RecordingReconnectWindowSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.RecordingReconnectWindowSeconds) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("thumbnailConfiguration", "ThumbnailConfiguration", properties.ThumbnailConfiguration != null ? CfnRecordingConfigurationThumbnailConfigurationPropertyFromCloudFormation(properties.ThumbnailConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRecordingConfiguration = class _CfnRecordingConfiguration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRecordingConfigurationPropsFromCloudFormation(resourceProperties), ret = new _CfnRecordingConfiguration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRecordingConfiguration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ivs_CfnRecordingConfigurationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRecordingConfiguration), error;
        }
        cdk.requireProperty(props, "destinationConfiguration", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrState = cdk.Token.asString(this.getAtt("State", cdk.ResolutionTypeHint.STRING)), this.destinationConfiguration = props.destinationConfiguration, this.name = props.name, this.recordingReconnectWindowSeconds = props.recordingReconnectWindowSeconds, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IVS::RecordingConfiguration", props.tags, { tagPropertyName: "tags" }), this.thumbnailConfiguration = props.thumbnailConfiguration;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRecordingConfiguration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { destinationConfiguration: this.destinationConfiguration, name: this.name, recordingReconnectWindowSeconds: this.recordingReconnectWindowSeconds, tags: this.tags.renderTags(), thumbnailConfiguration: this.thumbnailConfiguration };
      }
      renderProperties(props) {
        return cfnRecordingConfigurationPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnRecordingConfiguration[_c] = { fqn: "aws-cdk-lib.aws_ivs.CfnRecordingConfiguration", version: "2.80.0" }, CfnRecordingConfiguration.CFN_RESOURCE_TYPE_NAME = "AWS::IVS::RecordingConfiguration", exports2.CfnRecordingConfiguration = CfnRecordingConfiguration;
    function CfnRecordingConfiguration_DestinationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3", cdk.requiredValidator)(properties.s3)), errors.collect(cdk.propertyValidator("s3", CfnRecordingConfiguration_S3DestinationConfigurationPropertyValidator)(properties.s3)), errors.wrap('supplied properties not correct for "DestinationConfigurationProperty"');
    }
    function cfnRecordingConfigurationDestinationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRecordingConfiguration_DestinationConfigurationPropertyValidator(properties).assertSuccess(), { S3: cfnRecordingConfigurationS3DestinationConfigurationPropertyToCloudFormation(properties.s3) }) : properties;
    }
    function CfnRecordingConfigurationDestinationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3", "S3", CfnRecordingConfigurationS3DestinationConfigurationPropertyFromCloudFormation(properties.S3)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRecordingConfiguration_S3DestinationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketName", cdk.requiredValidator)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.wrap('supplied properties not correct for "S3DestinationConfigurationProperty"');
    }
    function cfnRecordingConfigurationS3DestinationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRecordingConfiguration_S3DestinationConfigurationPropertyValidator(properties).assertSuccess(), { BucketName: cdk.stringToCloudFormation(properties.bucketName) }) : properties;
    }
    function CfnRecordingConfigurationS3DestinationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketName", "BucketName", cfn_parse.FromCloudFormation.getString(properties.BucketName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRecordingConfiguration_ThumbnailConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("recordingMode", cdk.requiredValidator)(properties.recordingMode)), errors.collect(cdk.propertyValidator("recordingMode", cdk.validateString)(properties.recordingMode)), errors.collect(cdk.propertyValidator("targetIntervalSeconds", cdk.validateNumber)(properties.targetIntervalSeconds)), errors.wrap('supplied properties not correct for "ThumbnailConfigurationProperty"');
    }
    function cfnRecordingConfigurationThumbnailConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRecordingConfiguration_ThumbnailConfigurationPropertyValidator(properties).assertSuccess(), { RecordingMode: cdk.stringToCloudFormation(properties.recordingMode), TargetIntervalSeconds: cdk.numberToCloudFormation(properties.targetIntervalSeconds) }) : properties;
    }
    function CfnRecordingConfigurationThumbnailConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("recordingMode", "RecordingMode", cfn_parse.FromCloudFormation.getString(properties.RecordingMode)), ret.addPropertyResult("targetIntervalSeconds", "TargetIntervalSeconds", properties.TargetIntervalSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.TargetIntervalSeconds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStreamKeyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("channelArn", cdk.requiredValidator)(properties.channelArn)), errors.collect(cdk.propertyValidator("channelArn", cdk.validateString)(properties.channelArn)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnStreamKeyProps"');
    }
    function cfnStreamKeyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStreamKeyPropsValidator(properties).assertSuccess(), { ChannelArn: cdk.stringToCloudFormation(properties.channelArn), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnStreamKeyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("channelArn", "ChannelArn", cfn_parse.FromCloudFormation.getString(properties.ChannelArn)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnStreamKey = class _CfnStreamKey extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnStreamKeyPropsFromCloudFormation(resourceProperties), ret = new _CfnStreamKey(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnStreamKey.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ivs_CfnStreamKeyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnStreamKey), error;
        }
        cdk.requireProperty(props, "channelArn", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrValue = cdk.Token.asString(this.getAtt("Value", cdk.ResolutionTypeHint.STRING)), this.channelArn = props.channelArn, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IVS::StreamKey", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStreamKey.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { channelArn: this.channelArn, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnStreamKeyPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnStreamKey[_d] = { fqn: "aws-cdk-lib.aws_ivs.CfnStreamKey", version: "2.80.0" }, CfnStreamKey.CFN_RESOURCE_TYPE_NAME = "AWS::IVS::StreamKey", exports2.CfnStreamKey = CfnStreamKey;
  }
});

// node_modules/aws-cdk-lib/aws-ivs/lib/index.js
var require_lib160 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ivs/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_ivs_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-ivs/index.js
var require_aws_ivs = __commonJS({
  "node_modules/aws-cdk-lib/aws-ivs/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib160(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-ivschat/lib/ivschat.generated.js
var require_ivschat_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-ivschat/lib/ivschat.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnRoom = exports2.CfnLoggingConfiguration = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnLoggingConfigurationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationConfiguration", cdk.requiredValidator)(properties.destinationConfiguration)), errors.collect(cdk.propertyValidator("destinationConfiguration", CfnLoggingConfiguration_DestinationConfigurationPropertyValidator)(properties.destinationConfiguration)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnLoggingConfigurationProps"');
    }
    function cfnLoggingConfigurationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLoggingConfigurationPropsValidator(properties).assertSuccess(), { DestinationConfiguration: cfnLoggingConfigurationDestinationConfigurationPropertyToCloudFormation(properties.destinationConfiguration), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnLoggingConfigurationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationConfiguration", "DestinationConfiguration", CfnLoggingConfigurationDestinationConfigurationPropertyFromCloudFormation(properties.DestinationConfiguration)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLoggingConfiguration = class _CfnLoggingConfiguration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLoggingConfigurationPropsFromCloudFormation(resourceProperties), ret = new _CfnLoggingConfiguration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLoggingConfiguration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ivschat_CfnLoggingConfigurationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLoggingConfiguration), error;
        }
        cdk.requireProperty(props, "destinationConfiguration", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrState = cdk.Token.asString(this.getAtt("State", cdk.ResolutionTypeHint.STRING)), this.destinationConfiguration = props.destinationConfiguration, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IVSChat::LoggingConfiguration", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLoggingConfiguration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { destinationConfiguration: this.destinationConfiguration, name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnLoggingConfigurationPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnLoggingConfiguration[_a] = { fqn: "aws-cdk-lib.aws_ivschat.CfnLoggingConfiguration", version: "2.80.0" }, CfnLoggingConfiguration.CFN_RESOURCE_TYPE_NAME = "AWS::IVSChat::LoggingConfiguration", exports2.CfnLoggingConfiguration = CfnLoggingConfiguration;
    function CfnLoggingConfiguration_CloudWatchLogsDestinationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logGroupName", cdk.requiredValidator)(properties.logGroupName)), errors.collect(cdk.propertyValidator("logGroupName", cdk.validateString)(properties.logGroupName)), errors.wrap('supplied properties not correct for "CloudWatchLogsDestinationConfigurationProperty"');
    }
    function cfnLoggingConfigurationCloudWatchLogsDestinationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLoggingConfiguration_CloudWatchLogsDestinationConfigurationPropertyValidator(properties).assertSuccess(), { LogGroupName: cdk.stringToCloudFormation(properties.logGroupName) }) : properties;
    }
    function CfnLoggingConfigurationCloudWatchLogsDestinationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logGroupName", "LogGroupName", cfn_parse.FromCloudFormation.getString(properties.LogGroupName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLoggingConfiguration_DestinationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchLogs", CfnLoggingConfiguration_CloudWatchLogsDestinationConfigurationPropertyValidator)(properties.cloudWatchLogs)), errors.collect(cdk.propertyValidator("firehose", CfnLoggingConfiguration_FirehoseDestinationConfigurationPropertyValidator)(properties.firehose)), errors.collect(cdk.propertyValidator("s3", CfnLoggingConfiguration_S3DestinationConfigurationPropertyValidator)(properties.s3)), errors.wrap('supplied properties not correct for "DestinationConfigurationProperty"');
    }
    function cfnLoggingConfigurationDestinationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLoggingConfiguration_DestinationConfigurationPropertyValidator(properties).assertSuccess(), { CloudWatchLogs: cfnLoggingConfigurationCloudWatchLogsDestinationConfigurationPropertyToCloudFormation(properties.cloudWatchLogs), Firehose: cfnLoggingConfigurationFirehoseDestinationConfigurationPropertyToCloudFormation(properties.firehose), S3: cfnLoggingConfigurationS3DestinationConfigurationPropertyToCloudFormation(properties.s3) }) : properties;
    }
    function CfnLoggingConfigurationDestinationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchLogs", "CloudWatchLogs", properties.CloudWatchLogs != null ? CfnLoggingConfigurationCloudWatchLogsDestinationConfigurationPropertyFromCloudFormation(properties.CloudWatchLogs) : void 0), ret.addPropertyResult("firehose", "Firehose", properties.Firehose != null ? CfnLoggingConfigurationFirehoseDestinationConfigurationPropertyFromCloudFormation(properties.Firehose) : void 0), ret.addPropertyResult("s3", "S3", properties.S3 != null ? CfnLoggingConfigurationS3DestinationConfigurationPropertyFromCloudFormation(properties.S3) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLoggingConfiguration_FirehoseDestinationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deliveryStreamName", cdk.requiredValidator)(properties.deliveryStreamName)), errors.collect(cdk.propertyValidator("deliveryStreamName", cdk.validateString)(properties.deliveryStreamName)), errors.wrap('supplied properties not correct for "FirehoseDestinationConfigurationProperty"');
    }
    function cfnLoggingConfigurationFirehoseDestinationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLoggingConfiguration_FirehoseDestinationConfigurationPropertyValidator(properties).assertSuccess(), { DeliveryStreamName: cdk.stringToCloudFormation(properties.deliveryStreamName) }) : properties;
    }
    function CfnLoggingConfigurationFirehoseDestinationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deliveryStreamName", "DeliveryStreamName", cfn_parse.FromCloudFormation.getString(properties.DeliveryStreamName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLoggingConfiguration_S3DestinationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketName", cdk.requiredValidator)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.wrap('supplied properties not correct for "S3DestinationConfigurationProperty"');
    }
    function cfnLoggingConfigurationS3DestinationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLoggingConfiguration_S3DestinationConfigurationPropertyValidator(properties).assertSuccess(), { BucketName: cdk.stringToCloudFormation(properties.bucketName) }) : properties;
    }
    function CfnLoggingConfigurationS3DestinationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketName", "BucketName", cfn_parse.FromCloudFormation.getString(properties.BucketName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRoomPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("loggingConfigurationIdentifiers", cdk.listValidator(cdk.validateString))(properties.loggingConfigurationIdentifiers)), errors.collect(cdk.propertyValidator("maximumMessageLength", cdk.validateNumber)(properties.maximumMessageLength)), errors.collect(cdk.propertyValidator("maximumMessageRatePerSecond", cdk.validateNumber)(properties.maximumMessageRatePerSecond)), errors.collect(cdk.propertyValidator("messageReviewHandler", CfnRoom_MessageReviewHandlerPropertyValidator)(properties.messageReviewHandler)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnRoomProps"');
    }
    function cfnRoomPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoomPropsValidator(properties).assertSuccess(), { LoggingConfigurationIdentifiers: cdk.listMapper(cdk.stringToCloudFormation)(properties.loggingConfigurationIdentifiers), MaximumMessageLength: cdk.numberToCloudFormation(properties.maximumMessageLength), MaximumMessageRatePerSecond: cdk.numberToCloudFormation(properties.maximumMessageRatePerSecond), MessageReviewHandler: cfnRoomMessageReviewHandlerPropertyToCloudFormation(properties.messageReviewHandler), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnRoomPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("loggingConfigurationIdentifiers", "LoggingConfigurationIdentifiers", properties.LoggingConfigurationIdentifiers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.LoggingConfigurationIdentifiers) : void 0), ret.addPropertyResult("maximumMessageLength", "MaximumMessageLength", properties.MaximumMessageLength != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumMessageLength) : void 0), ret.addPropertyResult("maximumMessageRatePerSecond", "MaximumMessageRatePerSecond", properties.MaximumMessageRatePerSecond != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumMessageRatePerSecond) : void 0), ret.addPropertyResult("messageReviewHandler", "MessageReviewHandler", properties.MessageReviewHandler != null ? CfnRoomMessageReviewHandlerPropertyFromCloudFormation(properties.MessageReviewHandler) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRoom = class _CfnRoom extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRoomPropsFromCloudFormation(resourceProperties), ret = new _CfnRoom(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnRoom.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ivschat_CfnRoomProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRoom), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.loggingConfigurationIdentifiers = props.loggingConfigurationIdentifiers, this.maximumMessageLength = props.maximumMessageLength, this.maximumMessageRatePerSecond = props.maximumMessageRatePerSecond, this.messageReviewHandler = props.messageReviewHandler, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::IVSChat::Room", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRoom.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { loggingConfigurationIdentifiers: this.loggingConfigurationIdentifiers, maximumMessageLength: this.maximumMessageLength, maximumMessageRatePerSecond: this.maximumMessageRatePerSecond, messageReviewHandler: this.messageReviewHandler, name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnRoomPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnRoom[_b] = { fqn: "aws-cdk-lib.aws_ivschat.CfnRoom", version: "2.80.0" }, CfnRoom.CFN_RESOURCE_TYPE_NAME = "AWS::IVSChat::Room", exports2.CfnRoom = CfnRoom;
    function CfnRoom_MessageReviewHandlerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fallbackResult", cdk.validateString)(properties.fallbackResult)), errors.collect(cdk.propertyValidator("uri", cdk.validateString)(properties.uri)), errors.wrap('supplied properties not correct for "MessageReviewHandlerProperty"');
    }
    function cfnRoomMessageReviewHandlerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoom_MessageReviewHandlerPropertyValidator(properties).assertSuccess(), { FallbackResult: cdk.stringToCloudFormation(properties.fallbackResult), Uri: cdk.stringToCloudFormation(properties.uri) }) : properties;
    }
    function CfnRoomMessageReviewHandlerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fallbackResult", "FallbackResult", properties.FallbackResult != null ? cfn_parse.FromCloudFormation.getString(properties.FallbackResult) : void 0), ret.addPropertyResult("uri", "Uri", properties.Uri != null ? cfn_parse.FromCloudFormation.getString(properties.Uri) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-ivschat/lib/index.js
var require_lib161 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ivschat/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_ivschat_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-ivschat/index.js
var require_aws_ivschat = __commonJS({
  "node_modules/aws-cdk-lib/aws-ivschat/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib161(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-kafkaconnect/lib/kafkaconnect.generated.js
var require_kafkaconnect_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-kafkaconnect/lib/kafkaconnect.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnConnector = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnConnectorPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("capacity", cdk.requiredValidator)(properties.capacity)), errors.collect(cdk.propertyValidator("capacity", CfnConnector_CapacityPropertyValidator)(properties.capacity)), errors.collect(cdk.propertyValidator("connectorConfiguration", cdk.requiredValidator)(properties.connectorConfiguration)), errors.collect(cdk.propertyValidator("connectorConfiguration", cdk.hashValidator(cdk.validateString))(properties.connectorConfiguration)), errors.collect(cdk.propertyValidator("connectorDescription", cdk.validateString)(properties.connectorDescription)), errors.collect(cdk.propertyValidator("connectorName", cdk.requiredValidator)(properties.connectorName)), errors.collect(cdk.propertyValidator("connectorName", cdk.validateString)(properties.connectorName)), errors.collect(cdk.propertyValidator("kafkaCluster", cdk.requiredValidator)(properties.kafkaCluster)), errors.collect(cdk.propertyValidator("kafkaCluster", CfnConnector_KafkaClusterPropertyValidator)(properties.kafkaCluster)), errors.collect(cdk.propertyValidator("kafkaClusterClientAuthentication", cdk.requiredValidator)(properties.kafkaClusterClientAuthentication)), errors.collect(cdk.propertyValidator("kafkaClusterClientAuthentication", CfnConnector_KafkaClusterClientAuthenticationPropertyValidator)(properties.kafkaClusterClientAuthentication)), errors.collect(cdk.propertyValidator("kafkaClusterEncryptionInTransit", cdk.requiredValidator)(properties.kafkaClusterEncryptionInTransit)), errors.collect(cdk.propertyValidator("kafkaClusterEncryptionInTransit", CfnConnector_KafkaClusterEncryptionInTransitPropertyValidator)(properties.kafkaClusterEncryptionInTransit)), errors.collect(cdk.propertyValidator("kafkaConnectVersion", cdk.requiredValidator)(properties.kafkaConnectVersion)), errors.collect(cdk.propertyValidator("kafkaConnectVersion", cdk.validateString)(properties.kafkaConnectVersion)), errors.collect(cdk.propertyValidator("logDelivery", CfnConnector_LogDeliveryPropertyValidator)(properties.logDelivery)), errors.collect(cdk.propertyValidator("plugins", cdk.requiredValidator)(properties.plugins)), errors.collect(cdk.propertyValidator("plugins", cdk.listValidator(CfnConnector_PluginPropertyValidator))(properties.plugins)), errors.collect(cdk.propertyValidator("serviceExecutionRoleArn", cdk.requiredValidator)(properties.serviceExecutionRoleArn)), errors.collect(cdk.propertyValidator("serviceExecutionRoleArn", cdk.validateString)(properties.serviceExecutionRoleArn)), errors.collect(cdk.propertyValidator("workerConfiguration", CfnConnector_WorkerConfigurationPropertyValidator)(properties.workerConfiguration)), errors.wrap('supplied properties not correct for "CfnConnectorProps"');
    }
    function cfnConnectorPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorPropsValidator(properties).assertSuccess(), { Capacity: cfnConnectorCapacityPropertyToCloudFormation(properties.capacity), ConnectorConfiguration: cdk.hashMapper(cdk.stringToCloudFormation)(properties.connectorConfiguration), ConnectorName: cdk.stringToCloudFormation(properties.connectorName), KafkaCluster: cfnConnectorKafkaClusterPropertyToCloudFormation(properties.kafkaCluster), KafkaClusterClientAuthentication: cfnConnectorKafkaClusterClientAuthenticationPropertyToCloudFormation(properties.kafkaClusterClientAuthentication), KafkaClusterEncryptionInTransit: cfnConnectorKafkaClusterEncryptionInTransitPropertyToCloudFormation(properties.kafkaClusterEncryptionInTransit), KafkaConnectVersion: cdk.stringToCloudFormation(properties.kafkaConnectVersion), Plugins: cdk.listMapper(cfnConnectorPluginPropertyToCloudFormation)(properties.plugins), ServiceExecutionRoleArn: cdk.stringToCloudFormation(properties.serviceExecutionRoleArn), ConnectorDescription: cdk.stringToCloudFormation(properties.connectorDescription), LogDelivery: cfnConnectorLogDeliveryPropertyToCloudFormation(properties.logDelivery), WorkerConfiguration: cfnConnectorWorkerConfigurationPropertyToCloudFormation(properties.workerConfiguration) }) : properties;
    }
    function CfnConnectorPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("capacity", "Capacity", CfnConnectorCapacityPropertyFromCloudFormation(properties.Capacity)), ret.addPropertyResult("connectorConfiguration", "ConnectorConfiguration", cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.ConnectorConfiguration)), ret.addPropertyResult("connectorName", "ConnectorName", cfn_parse.FromCloudFormation.getString(properties.ConnectorName)), ret.addPropertyResult("kafkaCluster", "KafkaCluster", CfnConnectorKafkaClusterPropertyFromCloudFormation(properties.KafkaCluster)), ret.addPropertyResult("kafkaClusterClientAuthentication", "KafkaClusterClientAuthentication", CfnConnectorKafkaClusterClientAuthenticationPropertyFromCloudFormation(properties.KafkaClusterClientAuthentication)), ret.addPropertyResult("kafkaClusterEncryptionInTransit", "KafkaClusterEncryptionInTransit", CfnConnectorKafkaClusterEncryptionInTransitPropertyFromCloudFormation(properties.KafkaClusterEncryptionInTransit)), ret.addPropertyResult("kafkaConnectVersion", "KafkaConnectVersion", cfn_parse.FromCloudFormation.getString(properties.KafkaConnectVersion)), ret.addPropertyResult("plugins", "Plugins", cfn_parse.FromCloudFormation.getArray(CfnConnectorPluginPropertyFromCloudFormation)(properties.Plugins)), ret.addPropertyResult("serviceExecutionRoleArn", "ServiceExecutionRoleArn", cfn_parse.FromCloudFormation.getString(properties.ServiceExecutionRoleArn)), ret.addPropertyResult("connectorDescription", "ConnectorDescription", properties.ConnectorDescription != null ? cfn_parse.FromCloudFormation.getString(properties.ConnectorDescription) : void 0), ret.addPropertyResult("logDelivery", "LogDelivery", properties.LogDelivery != null ? CfnConnectorLogDeliveryPropertyFromCloudFormation(properties.LogDelivery) : void 0), ret.addPropertyResult("workerConfiguration", "WorkerConfiguration", properties.WorkerConfiguration != null ? CfnConnectorWorkerConfigurationPropertyFromCloudFormation(properties.WorkerConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnConnector = class _CfnConnector extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnConnectorPropsFromCloudFormation(resourceProperties), ret = new _CfnConnector(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnConnector.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kafkaconnect_CfnConnectorProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnConnector), error;
        }
        cdk.requireProperty(props, "capacity", this), cdk.requireProperty(props, "connectorConfiguration", this), cdk.requireProperty(props, "connectorName", this), cdk.requireProperty(props, "kafkaCluster", this), cdk.requireProperty(props, "kafkaClusterClientAuthentication", this), cdk.requireProperty(props, "kafkaClusterEncryptionInTransit", this), cdk.requireProperty(props, "kafkaConnectVersion", this), cdk.requireProperty(props, "plugins", this), cdk.requireProperty(props, "serviceExecutionRoleArn", this), this.attrConnectorArn = cdk.Token.asString(this.getAtt("ConnectorArn", cdk.ResolutionTypeHint.STRING)), this.capacity = props.capacity, this.connectorConfiguration = props.connectorConfiguration, this.connectorName = props.connectorName, this.kafkaCluster = props.kafkaCluster, this.kafkaClusterClientAuthentication = props.kafkaClusterClientAuthentication, this.kafkaClusterEncryptionInTransit = props.kafkaClusterEncryptionInTransit, this.kafkaConnectVersion = props.kafkaConnectVersion, this.plugins = props.plugins, this.serviceExecutionRoleArn = props.serviceExecutionRoleArn, this.connectorDescription = props.connectorDescription, this.logDelivery = props.logDelivery, this.workerConfiguration = props.workerConfiguration;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnConnector.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { capacity: this.capacity, connectorConfiguration: this.connectorConfiguration, connectorName: this.connectorName, kafkaCluster: this.kafkaCluster, kafkaClusterClientAuthentication: this.kafkaClusterClientAuthentication, kafkaClusterEncryptionInTransit: this.kafkaClusterEncryptionInTransit, kafkaConnectVersion: this.kafkaConnectVersion, plugins: this.plugins, serviceExecutionRoleArn: this.serviceExecutionRoleArn, connectorDescription: this.connectorDescription, logDelivery: this.logDelivery, workerConfiguration: this.workerConfiguration };
      }
      renderProperties(props) {
        return cfnConnectorPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnConnector[_a] = { fqn: "aws-cdk-lib.aws_kafkaconnect.CfnConnector", version: "2.80.0" }, CfnConnector.CFN_RESOURCE_TYPE_NAME = "AWS::KafkaConnect::Connector", exports2.CfnConnector = CfnConnector;
    function CfnConnector_ApacheKafkaClusterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bootstrapServers", cdk.requiredValidator)(properties.bootstrapServers)), errors.collect(cdk.propertyValidator("bootstrapServers", cdk.validateString)(properties.bootstrapServers)), errors.collect(cdk.propertyValidator("vpc", cdk.requiredValidator)(properties.vpc)), errors.collect(cdk.propertyValidator("vpc", CfnConnector_VpcPropertyValidator)(properties.vpc)), errors.wrap('supplied properties not correct for "ApacheKafkaClusterProperty"');
    }
    function cfnConnectorApacheKafkaClusterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnector_ApacheKafkaClusterPropertyValidator(properties).assertSuccess(), { BootstrapServers: cdk.stringToCloudFormation(properties.bootstrapServers), Vpc: cfnConnectorVpcPropertyToCloudFormation(properties.vpc) }) : properties;
    }
    function CfnConnectorApacheKafkaClusterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bootstrapServers", "BootstrapServers", cfn_parse.FromCloudFormation.getString(properties.BootstrapServers)), ret.addPropertyResult("vpc", "Vpc", CfnConnectorVpcPropertyFromCloudFormation(properties.Vpc)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnector_AutoScalingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxWorkerCount", cdk.requiredValidator)(properties.maxWorkerCount)), errors.collect(cdk.propertyValidator("maxWorkerCount", cdk.validateNumber)(properties.maxWorkerCount)), errors.collect(cdk.propertyValidator("mcuCount", cdk.requiredValidator)(properties.mcuCount)), errors.collect(cdk.propertyValidator("mcuCount", cdk.validateNumber)(properties.mcuCount)), errors.collect(cdk.propertyValidator("minWorkerCount", cdk.requiredValidator)(properties.minWorkerCount)), errors.collect(cdk.propertyValidator("minWorkerCount", cdk.validateNumber)(properties.minWorkerCount)), errors.collect(cdk.propertyValidator("scaleInPolicy", cdk.requiredValidator)(properties.scaleInPolicy)), errors.collect(cdk.propertyValidator("scaleInPolicy", CfnConnector_ScaleInPolicyPropertyValidator)(properties.scaleInPolicy)), errors.collect(cdk.propertyValidator("scaleOutPolicy", cdk.requiredValidator)(properties.scaleOutPolicy)), errors.collect(cdk.propertyValidator("scaleOutPolicy", CfnConnector_ScaleOutPolicyPropertyValidator)(properties.scaleOutPolicy)), errors.wrap('supplied properties not correct for "AutoScalingProperty"');
    }
    function cfnConnectorAutoScalingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnector_AutoScalingPropertyValidator(properties).assertSuccess(), { MaxWorkerCount: cdk.numberToCloudFormation(properties.maxWorkerCount), McuCount: cdk.numberToCloudFormation(properties.mcuCount), MinWorkerCount: cdk.numberToCloudFormation(properties.minWorkerCount), ScaleInPolicy: cfnConnectorScaleInPolicyPropertyToCloudFormation(properties.scaleInPolicy), ScaleOutPolicy: cfnConnectorScaleOutPolicyPropertyToCloudFormation(properties.scaleOutPolicy) }) : properties;
    }
    function CfnConnectorAutoScalingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxWorkerCount", "MaxWorkerCount", cfn_parse.FromCloudFormation.getNumber(properties.MaxWorkerCount)), ret.addPropertyResult("mcuCount", "McuCount", cfn_parse.FromCloudFormation.getNumber(properties.McuCount)), ret.addPropertyResult("minWorkerCount", "MinWorkerCount", cfn_parse.FromCloudFormation.getNumber(properties.MinWorkerCount)), ret.addPropertyResult("scaleInPolicy", "ScaleInPolicy", CfnConnectorScaleInPolicyPropertyFromCloudFormation(properties.ScaleInPolicy)), ret.addPropertyResult("scaleOutPolicy", "ScaleOutPolicy", CfnConnectorScaleOutPolicyPropertyFromCloudFormation(properties.ScaleOutPolicy)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnector_CapacityPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoScaling", CfnConnector_AutoScalingPropertyValidator)(properties.autoScaling)), errors.collect(cdk.propertyValidator("provisionedCapacity", CfnConnector_ProvisionedCapacityPropertyValidator)(properties.provisionedCapacity)), errors.wrap('supplied properties not correct for "CapacityProperty"');
    }
    function cfnConnectorCapacityPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnector_CapacityPropertyValidator(properties).assertSuccess(), { AutoScaling: cfnConnectorAutoScalingPropertyToCloudFormation(properties.autoScaling), ProvisionedCapacity: cfnConnectorProvisionedCapacityPropertyToCloudFormation(properties.provisionedCapacity) }) : properties;
    }
    function CfnConnectorCapacityPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("autoScaling", "AutoScaling", properties.AutoScaling != null ? CfnConnectorAutoScalingPropertyFromCloudFormation(properties.AutoScaling) : void 0), ret.addPropertyResult("provisionedCapacity", "ProvisionedCapacity", properties.ProvisionedCapacity != null ? CfnConnectorProvisionedCapacityPropertyFromCloudFormation(properties.ProvisionedCapacity) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnector_CloudWatchLogsLogDeliveryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("logGroup", cdk.validateString)(properties.logGroup)), errors.wrap('supplied properties not correct for "CloudWatchLogsLogDeliveryProperty"');
    }
    function cfnConnectorCloudWatchLogsLogDeliveryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnector_CloudWatchLogsLogDeliveryPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled), LogGroup: cdk.stringToCloudFormation(properties.logGroup) }) : properties;
    }
    function CfnConnectorCloudWatchLogsLogDeliveryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addPropertyResult("logGroup", "LogGroup", properties.LogGroup != null ? cfn_parse.FromCloudFormation.getString(properties.LogGroup) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnector_CustomPluginPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customPluginArn", cdk.requiredValidator)(properties.customPluginArn)), errors.collect(cdk.propertyValidator("customPluginArn", cdk.validateString)(properties.customPluginArn)), errors.collect(cdk.propertyValidator("revision", cdk.requiredValidator)(properties.revision)), errors.collect(cdk.propertyValidator("revision", cdk.validateNumber)(properties.revision)), errors.wrap('supplied properties not correct for "CustomPluginProperty"');
    }
    function cfnConnectorCustomPluginPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnector_CustomPluginPropertyValidator(properties).assertSuccess(), { CustomPluginArn: cdk.stringToCloudFormation(properties.customPluginArn), Revision: cdk.numberToCloudFormation(properties.revision) }) : properties;
    }
    function CfnConnectorCustomPluginPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customPluginArn", "CustomPluginArn", cfn_parse.FromCloudFormation.getString(properties.CustomPluginArn)), ret.addPropertyResult("revision", "Revision", cfn_parse.FromCloudFormation.getNumber(properties.Revision)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnector_FirehoseLogDeliveryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deliveryStream", cdk.validateString)(properties.deliveryStream)), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "FirehoseLogDeliveryProperty"');
    }
    function cfnConnectorFirehoseLogDeliveryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnector_FirehoseLogDeliveryPropertyValidator(properties).assertSuccess(), { DeliveryStream: cdk.stringToCloudFormation(properties.deliveryStream), Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnConnectorFirehoseLogDeliveryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deliveryStream", "DeliveryStream", properties.DeliveryStream != null ? cfn_parse.FromCloudFormation.getString(properties.DeliveryStream) : void 0), ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnector_KafkaClusterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apacheKafkaCluster", cdk.requiredValidator)(properties.apacheKafkaCluster)), errors.collect(cdk.propertyValidator("apacheKafkaCluster", CfnConnector_ApacheKafkaClusterPropertyValidator)(properties.apacheKafkaCluster)), errors.wrap('supplied properties not correct for "KafkaClusterProperty"');
    }
    function cfnConnectorKafkaClusterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnector_KafkaClusterPropertyValidator(properties).assertSuccess(), { ApacheKafkaCluster: cfnConnectorApacheKafkaClusterPropertyToCloudFormation(properties.apacheKafkaCluster) }) : properties;
    }
    function CfnConnectorKafkaClusterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apacheKafkaCluster", "ApacheKafkaCluster", CfnConnectorApacheKafkaClusterPropertyFromCloudFormation(properties.ApacheKafkaCluster)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnector_KafkaClusterClientAuthenticationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authenticationType", cdk.requiredValidator)(properties.authenticationType)), errors.collect(cdk.propertyValidator("authenticationType", cdk.validateString)(properties.authenticationType)), errors.wrap('supplied properties not correct for "KafkaClusterClientAuthenticationProperty"');
    }
    function cfnConnectorKafkaClusterClientAuthenticationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnector_KafkaClusterClientAuthenticationPropertyValidator(properties).assertSuccess(), { AuthenticationType: cdk.stringToCloudFormation(properties.authenticationType) }) : properties;
    }
    function CfnConnectorKafkaClusterClientAuthenticationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authenticationType", "AuthenticationType", cfn_parse.FromCloudFormation.getString(properties.AuthenticationType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnector_KafkaClusterEncryptionInTransitPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("encryptionType", cdk.requiredValidator)(properties.encryptionType)), errors.collect(cdk.propertyValidator("encryptionType", cdk.validateString)(properties.encryptionType)), errors.wrap('supplied properties not correct for "KafkaClusterEncryptionInTransitProperty"');
    }
    function cfnConnectorKafkaClusterEncryptionInTransitPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnector_KafkaClusterEncryptionInTransitPropertyValidator(properties).assertSuccess(), { EncryptionType: cdk.stringToCloudFormation(properties.encryptionType) }) : properties;
    }
    function CfnConnectorKafkaClusterEncryptionInTransitPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("encryptionType", "EncryptionType", cfn_parse.FromCloudFormation.getString(properties.EncryptionType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnector_LogDeliveryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("workerLogDelivery", cdk.requiredValidator)(properties.workerLogDelivery)), errors.collect(cdk.propertyValidator("workerLogDelivery", CfnConnector_WorkerLogDeliveryPropertyValidator)(properties.workerLogDelivery)), errors.wrap('supplied properties not correct for "LogDeliveryProperty"');
    }
    function cfnConnectorLogDeliveryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnector_LogDeliveryPropertyValidator(properties).assertSuccess(), { WorkerLogDelivery: cfnConnectorWorkerLogDeliveryPropertyToCloudFormation(properties.workerLogDelivery) }) : properties;
    }
    function CfnConnectorLogDeliveryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("workerLogDelivery", "WorkerLogDelivery", CfnConnectorWorkerLogDeliveryPropertyFromCloudFormation(properties.WorkerLogDelivery)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnector_PluginPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customPlugin", cdk.requiredValidator)(properties.customPlugin)), errors.collect(cdk.propertyValidator("customPlugin", CfnConnector_CustomPluginPropertyValidator)(properties.customPlugin)), errors.wrap('supplied properties not correct for "PluginProperty"');
    }
    function cfnConnectorPluginPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnector_PluginPropertyValidator(properties).assertSuccess(), { CustomPlugin: cfnConnectorCustomPluginPropertyToCloudFormation(properties.customPlugin) }) : properties;
    }
    function CfnConnectorPluginPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customPlugin", "CustomPlugin", CfnConnectorCustomPluginPropertyFromCloudFormation(properties.CustomPlugin)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnector_ProvisionedCapacityPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mcuCount", cdk.validateNumber)(properties.mcuCount)), errors.collect(cdk.propertyValidator("workerCount", cdk.requiredValidator)(properties.workerCount)), errors.collect(cdk.propertyValidator("workerCount", cdk.validateNumber)(properties.workerCount)), errors.wrap('supplied properties not correct for "ProvisionedCapacityProperty"');
    }
    function cfnConnectorProvisionedCapacityPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnector_ProvisionedCapacityPropertyValidator(properties).assertSuccess(), { McuCount: cdk.numberToCloudFormation(properties.mcuCount), WorkerCount: cdk.numberToCloudFormation(properties.workerCount) }) : properties;
    }
    function CfnConnectorProvisionedCapacityPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mcuCount", "McuCount", properties.McuCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.McuCount) : void 0), ret.addPropertyResult("workerCount", "WorkerCount", cfn_parse.FromCloudFormation.getNumber(properties.WorkerCount)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnector_S3LogDeliveryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.wrap('supplied properties not correct for "S3LogDeliveryProperty"');
    }
    function cfnConnectorS3LogDeliveryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnector_S3LogDeliveryPropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), Enabled: cdk.booleanToCloudFormation(properties.enabled), Prefix: cdk.stringToCloudFormation(properties.prefix) }) : properties;
    }
    function CfnConnectorS3LogDeliveryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", properties.Bucket != null ? cfn_parse.FromCloudFormation.getString(properties.Bucket) : void 0), ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnector_ScaleInPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cpuUtilizationPercentage", cdk.requiredValidator)(properties.cpuUtilizationPercentage)), errors.collect(cdk.propertyValidator("cpuUtilizationPercentage", cdk.validateNumber)(properties.cpuUtilizationPercentage)), errors.wrap('supplied properties not correct for "ScaleInPolicyProperty"');
    }
    function cfnConnectorScaleInPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnector_ScaleInPolicyPropertyValidator(properties).assertSuccess(), { CpuUtilizationPercentage: cdk.numberToCloudFormation(properties.cpuUtilizationPercentage) }) : properties;
    }
    function CfnConnectorScaleInPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cpuUtilizationPercentage", "CpuUtilizationPercentage", cfn_parse.FromCloudFormation.getNumber(properties.CpuUtilizationPercentage)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnector_ScaleOutPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cpuUtilizationPercentage", cdk.requiredValidator)(properties.cpuUtilizationPercentage)), errors.collect(cdk.propertyValidator("cpuUtilizationPercentage", cdk.validateNumber)(properties.cpuUtilizationPercentage)), errors.wrap('supplied properties not correct for "ScaleOutPolicyProperty"');
    }
    function cfnConnectorScaleOutPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnector_ScaleOutPolicyPropertyValidator(properties).assertSuccess(), { CpuUtilizationPercentage: cdk.numberToCloudFormation(properties.cpuUtilizationPercentage) }) : properties;
    }
    function CfnConnectorScaleOutPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cpuUtilizationPercentage", "CpuUtilizationPercentage", cfn_parse.FromCloudFormation.getNumber(properties.CpuUtilizationPercentage)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnector_VpcPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroups", cdk.requiredValidator)(properties.securityGroups)), errors.collect(cdk.propertyValidator("securityGroups", cdk.listValidator(cdk.validateString))(properties.securityGroups)), errors.collect(cdk.propertyValidator("subnets", cdk.requiredValidator)(properties.subnets)), errors.collect(cdk.propertyValidator("subnets", cdk.listValidator(cdk.validateString))(properties.subnets)), errors.wrap('supplied properties not correct for "VpcProperty"');
    }
    function cfnConnectorVpcPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnector_VpcPropertyValidator(properties).assertSuccess(), { SecurityGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroups), Subnets: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnets) }) : properties;
    }
    function CfnConnectorVpcPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroups", "SecurityGroups", cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroups)), ret.addPropertyResult("subnets", "Subnets", cfn_parse.FromCloudFormation.getStringArray(properties.Subnets)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnector_WorkerConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("revision", cdk.requiredValidator)(properties.revision)), errors.collect(cdk.propertyValidator("revision", cdk.validateNumber)(properties.revision)), errors.collect(cdk.propertyValidator("workerConfigurationArn", cdk.requiredValidator)(properties.workerConfigurationArn)), errors.collect(cdk.propertyValidator("workerConfigurationArn", cdk.validateString)(properties.workerConfigurationArn)), errors.wrap('supplied properties not correct for "WorkerConfigurationProperty"');
    }
    function cfnConnectorWorkerConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnector_WorkerConfigurationPropertyValidator(properties).assertSuccess(), { Revision: cdk.numberToCloudFormation(properties.revision), WorkerConfigurationArn: cdk.stringToCloudFormation(properties.workerConfigurationArn) }) : properties;
    }
    function CfnConnectorWorkerConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("revision", "Revision", cfn_parse.FromCloudFormation.getNumber(properties.Revision)), ret.addPropertyResult("workerConfigurationArn", "WorkerConfigurationArn", cfn_parse.FromCloudFormation.getString(properties.WorkerConfigurationArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnector_WorkerLogDeliveryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchLogs", CfnConnector_CloudWatchLogsLogDeliveryPropertyValidator)(properties.cloudWatchLogs)), errors.collect(cdk.propertyValidator("firehose", CfnConnector_FirehoseLogDeliveryPropertyValidator)(properties.firehose)), errors.collect(cdk.propertyValidator("s3", CfnConnector_S3LogDeliveryPropertyValidator)(properties.s3)), errors.wrap('supplied properties not correct for "WorkerLogDeliveryProperty"');
    }
    function cfnConnectorWorkerLogDeliveryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnector_WorkerLogDeliveryPropertyValidator(properties).assertSuccess(), { CloudWatchLogs: cfnConnectorCloudWatchLogsLogDeliveryPropertyToCloudFormation(properties.cloudWatchLogs), Firehose: cfnConnectorFirehoseLogDeliveryPropertyToCloudFormation(properties.firehose), S3: cfnConnectorS3LogDeliveryPropertyToCloudFormation(properties.s3) }) : properties;
    }
    function CfnConnectorWorkerLogDeliveryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchLogs", "CloudWatchLogs", properties.CloudWatchLogs != null ? CfnConnectorCloudWatchLogsLogDeliveryPropertyFromCloudFormation(properties.CloudWatchLogs) : void 0), ret.addPropertyResult("firehose", "Firehose", properties.Firehose != null ? CfnConnectorFirehoseLogDeliveryPropertyFromCloudFormation(properties.Firehose) : void 0), ret.addPropertyResult("s3", "S3", properties.S3 != null ? CfnConnectorS3LogDeliveryPropertyFromCloudFormation(properties.S3) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-kafkaconnect/lib/index.js
var require_lib162 = __commonJS({
  "node_modules/aws-cdk-lib/aws-kafkaconnect/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_kafkaconnect_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-kafkaconnect/index.js
var require_aws_kafkaconnect = __commonJS({
  "node_modules/aws-cdk-lib/aws-kafkaconnect/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib162(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-kendra/lib/kendra.generated.js
var require_kendra_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-kendra/lib/kendra.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnIndex = exports2.CfnFaq = exports2.CfnDataSource = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnDataSourcePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customDocumentEnrichmentConfiguration", CfnDataSource_CustomDocumentEnrichmentConfigurationPropertyValidator)(properties.customDocumentEnrichmentConfiguration)), errors.collect(cdk.propertyValidator("dataSourceConfiguration", CfnDataSource_DataSourceConfigurationPropertyValidator)(properties.dataSourceConfiguration)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("indexId", cdk.requiredValidator)(properties.indexId)), errors.collect(cdk.propertyValidator("indexId", cdk.validateString)(properties.indexId)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("schedule", cdk.validateString)(properties.schedule)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnDataSourceProps"');
    }
    function cfnDataSourcePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSourcePropsValidator(properties).assertSuccess(), { IndexId: cdk.stringToCloudFormation(properties.indexId), Name: cdk.stringToCloudFormation(properties.name), Type: cdk.stringToCloudFormation(properties.type), CustomDocumentEnrichmentConfiguration: cfnDataSourceCustomDocumentEnrichmentConfigurationPropertyToCloudFormation(properties.customDocumentEnrichmentConfiguration), DataSourceConfiguration: cfnDataSourceDataSourceConfigurationPropertyToCloudFormation(properties.dataSourceConfiguration), Description: cdk.stringToCloudFormation(properties.description), RoleArn: cdk.stringToCloudFormation(properties.roleArn), Schedule: cdk.stringToCloudFormation(properties.schedule), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDataSourcePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("indexId", "IndexId", cfn_parse.FromCloudFormation.getString(properties.IndexId)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("customDocumentEnrichmentConfiguration", "CustomDocumentEnrichmentConfiguration", properties.CustomDocumentEnrichmentConfiguration != null ? CfnDataSourceCustomDocumentEnrichmentConfigurationPropertyFromCloudFormation(properties.CustomDocumentEnrichmentConfiguration) : void 0), ret.addPropertyResult("dataSourceConfiguration", "DataSourceConfiguration", properties.DataSourceConfiguration != null ? CfnDataSourceDataSourceConfigurationPropertyFromCloudFormation(properties.DataSourceConfiguration) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addPropertyResult("schedule", "Schedule", properties.Schedule != null ? cfn_parse.FromCloudFormation.getString(properties.Schedule) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDataSource = class _CfnDataSource extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDataSourcePropsFromCloudFormation(resourceProperties), ret = new _CfnDataSource(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDataSource.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kendra_CfnDataSourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDataSource), error;
        }
        cdk.requireProperty(props, "indexId", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "type", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.indexId = props.indexId, this.name = props.name, this.type = props.type, this.customDocumentEnrichmentConfiguration = props.customDocumentEnrichmentConfiguration, this.dataSourceConfiguration = props.dataSourceConfiguration, this.description = props.description, this.roleArn = props.roleArn, this.schedule = props.schedule, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Kendra::DataSource", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDataSource.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { indexId: this.indexId, name: this.name, type: this.type, customDocumentEnrichmentConfiguration: this.customDocumentEnrichmentConfiguration, dataSourceConfiguration: this.dataSourceConfiguration, description: this.description, roleArn: this.roleArn, schedule: this.schedule, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDataSourcePropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnDataSource[_a] = { fqn: "aws-cdk-lib.aws_kendra.CfnDataSource", version: "2.80.0" }, CfnDataSource.CFN_RESOURCE_TYPE_NAME = "AWS::Kendra::DataSource", exports2.CfnDataSource = CfnDataSource;
    function CfnDataSource_AccessControlListConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("keyPath", cdk.validateString)(properties.keyPath)), errors.wrap('supplied properties not correct for "AccessControlListConfigurationProperty"');
    }
    function cfnDataSourceAccessControlListConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_AccessControlListConfigurationPropertyValidator(properties).assertSuccess(), { KeyPath: cdk.stringToCloudFormation(properties.keyPath) }) : properties;
    }
    function CfnDataSourceAccessControlListConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("keyPath", "KeyPath", properties.KeyPath != null ? cfn_parse.FromCloudFormation.getString(properties.KeyPath) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_AclConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowedGroupsColumnName", cdk.requiredValidator)(properties.allowedGroupsColumnName)), errors.collect(cdk.propertyValidator("allowedGroupsColumnName", cdk.validateString)(properties.allowedGroupsColumnName)), errors.wrap('supplied properties not correct for "AclConfigurationProperty"');
    }
    function cfnDataSourceAclConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_AclConfigurationPropertyValidator(properties).assertSuccess(), { AllowedGroupsColumnName: cdk.stringToCloudFormation(properties.allowedGroupsColumnName) }) : properties;
    }
    function CfnDataSourceAclConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowedGroupsColumnName", "AllowedGroupsColumnName", cfn_parse.FromCloudFormation.getString(properties.AllowedGroupsColumnName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_ColumnConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("changeDetectingColumns", cdk.requiredValidator)(properties.changeDetectingColumns)), errors.collect(cdk.propertyValidator("changeDetectingColumns", cdk.listValidator(cdk.validateString))(properties.changeDetectingColumns)), errors.collect(cdk.propertyValidator("documentDataColumnName", cdk.requiredValidator)(properties.documentDataColumnName)), errors.collect(cdk.propertyValidator("documentDataColumnName", cdk.validateString)(properties.documentDataColumnName)), errors.collect(cdk.propertyValidator("documentIdColumnName", cdk.requiredValidator)(properties.documentIdColumnName)), errors.collect(cdk.propertyValidator("documentIdColumnName", cdk.validateString)(properties.documentIdColumnName)), errors.collect(cdk.propertyValidator("documentTitleColumnName", cdk.validateString)(properties.documentTitleColumnName)), errors.collect(cdk.propertyValidator("fieldMappings", cdk.listValidator(CfnDataSource_DataSourceToIndexFieldMappingPropertyValidator))(properties.fieldMappings)), errors.wrap('supplied properties not correct for "ColumnConfigurationProperty"');
    }
    function cfnDataSourceColumnConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_ColumnConfigurationPropertyValidator(properties).assertSuccess(), { ChangeDetectingColumns: cdk.listMapper(cdk.stringToCloudFormation)(properties.changeDetectingColumns), DocumentDataColumnName: cdk.stringToCloudFormation(properties.documentDataColumnName), DocumentIdColumnName: cdk.stringToCloudFormation(properties.documentIdColumnName), DocumentTitleColumnName: cdk.stringToCloudFormation(properties.documentTitleColumnName), FieldMappings: cdk.listMapper(cfnDataSourceDataSourceToIndexFieldMappingPropertyToCloudFormation)(properties.fieldMappings) }) : properties;
    }
    function CfnDataSourceColumnConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("changeDetectingColumns", "ChangeDetectingColumns", cfn_parse.FromCloudFormation.getStringArray(properties.ChangeDetectingColumns)), ret.addPropertyResult("documentDataColumnName", "DocumentDataColumnName", cfn_parse.FromCloudFormation.getString(properties.DocumentDataColumnName)), ret.addPropertyResult("documentIdColumnName", "DocumentIdColumnName", cfn_parse.FromCloudFormation.getString(properties.DocumentIdColumnName)), ret.addPropertyResult("documentTitleColumnName", "DocumentTitleColumnName", properties.DocumentTitleColumnName != null ? cfn_parse.FromCloudFormation.getString(properties.DocumentTitleColumnName) : void 0), ret.addPropertyResult("fieldMappings", "FieldMappings", properties.FieldMappings != null ? cfn_parse.FromCloudFormation.getArray(CfnDataSourceDataSourceToIndexFieldMappingPropertyFromCloudFormation)(properties.FieldMappings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_ConfluenceAttachmentConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attachmentFieldMappings", cdk.listValidator(CfnDataSource_ConfluenceAttachmentToIndexFieldMappingPropertyValidator))(properties.attachmentFieldMappings)), errors.collect(cdk.propertyValidator("crawlAttachments", cdk.validateBoolean)(properties.crawlAttachments)), errors.wrap('supplied properties not correct for "ConfluenceAttachmentConfigurationProperty"');
    }
    function cfnDataSourceConfluenceAttachmentConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_ConfluenceAttachmentConfigurationPropertyValidator(properties).assertSuccess(), { AttachmentFieldMappings: cdk.listMapper(cfnDataSourceConfluenceAttachmentToIndexFieldMappingPropertyToCloudFormation)(properties.attachmentFieldMappings), CrawlAttachments: cdk.booleanToCloudFormation(properties.crawlAttachments) }) : properties;
    }
    function CfnDataSourceConfluenceAttachmentConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attachmentFieldMappings", "AttachmentFieldMappings", properties.AttachmentFieldMappings != null ? cfn_parse.FromCloudFormation.getArray(CfnDataSourceConfluenceAttachmentToIndexFieldMappingPropertyFromCloudFormation)(properties.AttachmentFieldMappings) : void 0), ret.addPropertyResult("crawlAttachments", "CrawlAttachments", properties.CrawlAttachments != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CrawlAttachments) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_ConfluenceAttachmentToIndexFieldMappingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataSourceFieldName", cdk.requiredValidator)(properties.dataSourceFieldName)), errors.collect(cdk.propertyValidator("dataSourceFieldName", cdk.validateString)(properties.dataSourceFieldName)), errors.collect(cdk.propertyValidator("dateFieldFormat", cdk.validateString)(properties.dateFieldFormat)), errors.collect(cdk.propertyValidator("indexFieldName", cdk.requiredValidator)(properties.indexFieldName)), errors.collect(cdk.propertyValidator("indexFieldName", cdk.validateString)(properties.indexFieldName)), errors.wrap('supplied properties not correct for "ConfluenceAttachmentToIndexFieldMappingProperty"');
    }
    function cfnDataSourceConfluenceAttachmentToIndexFieldMappingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_ConfluenceAttachmentToIndexFieldMappingPropertyValidator(properties).assertSuccess(), { DataSourceFieldName: cdk.stringToCloudFormation(properties.dataSourceFieldName), DateFieldFormat: cdk.stringToCloudFormation(properties.dateFieldFormat), IndexFieldName: cdk.stringToCloudFormation(properties.indexFieldName) }) : properties;
    }
    function CfnDataSourceConfluenceAttachmentToIndexFieldMappingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataSourceFieldName", "DataSourceFieldName", cfn_parse.FromCloudFormation.getString(properties.DataSourceFieldName)), ret.addPropertyResult("dateFieldFormat", "DateFieldFormat", properties.DateFieldFormat != null ? cfn_parse.FromCloudFormation.getString(properties.DateFieldFormat) : void 0), ret.addPropertyResult("indexFieldName", "IndexFieldName", cfn_parse.FromCloudFormation.getString(properties.IndexFieldName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_ConfluenceBlogConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("blogFieldMappings", cdk.listValidator(CfnDataSource_ConfluenceBlogToIndexFieldMappingPropertyValidator))(properties.blogFieldMappings)), errors.wrap('supplied properties not correct for "ConfluenceBlogConfigurationProperty"');
    }
    function cfnDataSourceConfluenceBlogConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_ConfluenceBlogConfigurationPropertyValidator(properties).assertSuccess(), { BlogFieldMappings: cdk.listMapper(cfnDataSourceConfluenceBlogToIndexFieldMappingPropertyToCloudFormation)(properties.blogFieldMappings) }) : properties;
    }
    function CfnDataSourceConfluenceBlogConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("blogFieldMappings", "BlogFieldMappings", properties.BlogFieldMappings != null ? cfn_parse.FromCloudFormation.getArray(CfnDataSourceConfluenceBlogToIndexFieldMappingPropertyFromCloudFormation)(properties.BlogFieldMappings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_ConfluenceBlogToIndexFieldMappingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataSourceFieldName", cdk.requiredValidator)(properties.dataSourceFieldName)), errors.collect(cdk.propertyValidator("dataSourceFieldName", cdk.validateString)(properties.dataSourceFieldName)), errors.collect(cdk.propertyValidator("dateFieldFormat", cdk.validateString)(properties.dateFieldFormat)), errors.collect(cdk.propertyValidator("indexFieldName", cdk.requiredValidator)(properties.indexFieldName)), errors.collect(cdk.propertyValidator("indexFieldName", cdk.validateString)(properties.indexFieldName)), errors.wrap('supplied properties not correct for "ConfluenceBlogToIndexFieldMappingProperty"');
    }
    function cfnDataSourceConfluenceBlogToIndexFieldMappingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_ConfluenceBlogToIndexFieldMappingPropertyValidator(properties).assertSuccess(), { DataSourceFieldName: cdk.stringToCloudFormation(properties.dataSourceFieldName), DateFieldFormat: cdk.stringToCloudFormation(properties.dateFieldFormat), IndexFieldName: cdk.stringToCloudFormation(properties.indexFieldName) }) : properties;
    }
    function CfnDataSourceConfluenceBlogToIndexFieldMappingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataSourceFieldName", "DataSourceFieldName", cfn_parse.FromCloudFormation.getString(properties.DataSourceFieldName)), ret.addPropertyResult("dateFieldFormat", "DateFieldFormat", properties.DateFieldFormat != null ? cfn_parse.FromCloudFormation.getString(properties.DateFieldFormat) : void 0), ret.addPropertyResult("indexFieldName", "IndexFieldName", cfn_parse.FromCloudFormation.getString(properties.IndexFieldName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_ConfluenceConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attachmentConfiguration", CfnDataSource_ConfluenceAttachmentConfigurationPropertyValidator)(properties.attachmentConfiguration)), errors.collect(cdk.propertyValidator("blogConfiguration", CfnDataSource_ConfluenceBlogConfigurationPropertyValidator)(properties.blogConfiguration)), errors.collect(cdk.propertyValidator("exclusionPatterns", cdk.listValidator(cdk.validateString))(properties.exclusionPatterns)), errors.collect(cdk.propertyValidator("inclusionPatterns", cdk.listValidator(cdk.validateString))(properties.inclusionPatterns)), errors.collect(cdk.propertyValidator("pageConfiguration", CfnDataSource_ConfluencePageConfigurationPropertyValidator)(properties.pageConfiguration)), errors.collect(cdk.propertyValidator("secretArn", cdk.requiredValidator)(properties.secretArn)), errors.collect(cdk.propertyValidator("secretArn", cdk.validateString)(properties.secretArn)), errors.collect(cdk.propertyValidator("serverUrl", cdk.requiredValidator)(properties.serverUrl)), errors.collect(cdk.propertyValidator("serverUrl", cdk.validateString)(properties.serverUrl)), errors.collect(cdk.propertyValidator("spaceConfiguration", CfnDataSource_ConfluenceSpaceConfigurationPropertyValidator)(properties.spaceConfiguration)), errors.collect(cdk.propertyValidator("version", cdk.requiredValidator)(properties.version)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.collect(cdk.propertyValidator("vpcConfiguration", CfnDataSource_DataSourceVpcConfigurationPropertyValidator)(properties.vpcConfiguration)), errors.wrap('supplied properties not correct for "ConfluenceConfigurationProperty"');
    }
    function cfnDataSourceConfluenceConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_ConfluenceConfigurationPropertyValidator(properties).assertSuccess(), { AttachmentConfiguration: cfnDataSourceConfluenceAttachmentConfigurationPropertyToCloudFormation(properties.attachmentConfiguration), BlogConfiguration: cfnDataSourceConfluenceBlogConfigurationPropertyToCloudFormation(properties.blogConfiguration), ExclusionPatterns: cdk.listMapper(cdk.stringToCloudFormation)(properties.exclusionPatterns), InclusionPatterns: cdk.listMapper(cdk.stringToCloudFormation)(properties.inclusionPatterns), PageConfiguration: cfnDataSourceConfluencePageConfigurationPropertyToCloudFormation(properties.pageConfiguration), SecretArn: cdk.stringToCloudFormation(properties.secretArn), ServerUrl: cdk.stringToCloudFormation(properties.serverUrl), SpaceConfiguration: cfnDataSourceConfluenceSpaceConfigurationPropertyToCloudFormation(properties.spaceConfiguration), Version: cdk.stringToCloudFormation(properties.version), VpcConfiguration: cfnDataSourceDataSourceVpcConfigurationPropertyToCloudFormation(properties.vpcConfiguration) }) : properties;
    }
    function CfnDataSourceConfluenceConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attachmentConfiguration", "AttachmentConfiguration", properties.AttachmentConfiguration != null ? CfnDataSourceConfluenceAttachmentConfigurationPropertyFromCloudFormation(properties.AttachmentConfiguration) : void 0), ret.addPropertyResult("blogConfiguration", "BlogConfiguration", properties.BlogConfiguration != null ? CfnDataSourceConfluenceBlogConfigurationPropertyFromCloudFormation(properties.BlogConfiguration) : void 0), ret.addPropertyResult("exclusionPatterns", "ExclusionPatterns", properties.ExclusionPatterns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExclusionPatterns) : void 0), ret.addPropertyResult("inclusionPatterns", "InclusionPatterns", properties.InclusionPatterns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.InclusionPatterns) : void 0), ret.addPropertyResult("pageConfiguration", "PageConfiguration", properties.PageConfiguration != null ? CfnDataSourceConfluencePageConfigurationPropertyFromCloudFormation(properties.PageConfiguration) : void 0), ret.addPropertyResult("secretArn", "SecretArn", cfn_parse.FromCloudFormation.getString(properties.SecretArn)), ret.addPropertyResult("serverUrl", "ServerUrl", cfn_parse.FromCloudFormation.getString(properties.ServerUrl)), ret.addPropertyResult("spaceConfiguration", "SpaceConfiguration", properties.SpaceConfiguration != null ? CfnDataSourceConfluenceSpaceConfigurationPropertyFromCloudFormation(properties.SpaceConfiguration) : void 0), ret.addPropertyResult("version", "Version", cfn_parse.FromCloudFormation.getString(properties.Version)), ret.addPropertyResult("vpcConfiguration", "VpcConfiguration", properties.VpcConfiguration != null ? CfnDataSourceDataSourceVpcConfigurationPropertyFromCloudFormation(properties.VpcConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_ConfluencePageConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("pageFieldMappings", cdk.listValidator(CfnDataSource_ConfluencePageToIndexFieldMappingPropertyValidator))(properties.pageFieldMappings)), errors.wrap('supplied properties not correct for "ConfluencePageConfigurationProperty"');
    }
    function cfnDataSourceConfluencePageConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_ConfluencePageConfigurationPropertyValidator(properties).assertSuccess(), { PageFieldMappings: cdk.listMapper(cfnDataSourceConfluencePageToIndexFieldMappingPropertyToCloudFormation)(properties.pageFieldMappings) }) : properties;
    }
    function CfnDataSourceConfluencePageConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("pageFieldMappings", "PageFieldMappings", properties.PageFieldMappings != null ? cfn_parse.FromCloudFormation.getArray(CfnDataSourceConfluencePageToIndexFieldMappingPropertyFromCloudFormation)(properties.PageFieldMappings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_ConfluencePageToIndexFieldMappingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataSourceFieldName", cdk.requiredValidator)(properties.dataSourceFieldName)), errors.collect(cdk.propertyValidator("dataSourceFieldName", cdk.validateString)(properties.dataSourceFieldName)), errors.collect(cdk.propertyValidator("dateFieldFormat", cdk.validateString)(properties.dateFieldFormat)), errors.collect(cdk.propertyValidator("indexFieldName", cdk.requiredValidator)(properties.indexFieldName)), errors.collect(cdk.propertyValidator("indexFieldName", cdk.validateString)(properties.indexFieldName)), errors.wrap('supplied properties not correct for "ConfluencePageToIndexFieldMappingProperty"');
    }
    function cfnDataSourceConfluencePageToIndexFieldMappingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_ConfluencePageToIndexFieldMappingPropertyValidator(properties).assertSuccess(), { DataSourceFieldName: cdk.stringToCloudFormation(properties.dataSourceFieldName), DateFieldFormat: cdk.stringToCloudFormation(properties.dateFieldFormat), IndexFieldName: cdk.stringToCloudFormation(properties.indexFieldName) }) : properties;
    }
    function CfnDataSourceConfluencePageToIndexFieldMappingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataSourceFieldName", "DataSourceFieldName", cfn_parse.FromCloudFormation.getString(properties.DataSourceFieldName)), ret.addPropertyResult("dateFieldFormat", "DateFieldFormat", properties.DateFieldFormat != null ? cfn_parse.FromCloudFormation.getString(properties.DateFieldFormat) : void 0), ret.addPropertyResult("indexFieldName", "IndexFieldName", cfn_parse.FromCloudFormation.getString(properties.IndexFieldName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_ConfluenceSpaceConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("crawlArchivedSpaces", cdk.validateBoolean)(properties.crawlArchivedSpaces)), errors.collect(cdk.propertyValidator("crawlPersonalSpaces", cdk.validateBoolean)(properties.crawlPersonalSpaces)), errors.collect(cdk.propertyValidator("excludeSpaces", cdk.listValidator(cdk.validateString))(properties.excludeSpaces)), errors.collect(cdk.propertyValidator("includeSpaces", cdk.listValidator(cdk.validateString))(properties.includeSpaces)), errors.collect(cdk.propertyValidator("spaceFieldMappings", cdk.listValidator(CfnDataSource_ConfluenceSpaceToIndexFieldMappingPropertyValidator))(properties.spaceFieldMappings)), errors.wrap('supplied properties not correct for "ConfluenceSpaceConfigurationProperty"');
    }
    function cfnDataSourceConfluenceSpaceConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_ConfluenceSpaceConfigurationPropertyValidator(properties).assertSuccess(), { CrawlArchivedSpaces: cdk.booleanToCloudFormation(properties.crawlArchivedSpaces), CrawlPersonalSpaces: cdk.booleanToCloudFormation(properties.crawlPersonalSpaces), ExcludeSpaces: cdk.listMapper(cdk.stringToCloudFormation)(properties.excludeSpaces), IncludeSpaces: cdk.listMapper(cdk.stringToCloudFormation)(properties.includeSpaces), SpaceFieldMappings: cdk.listMapper(cfnDataSourceConfluenceSpaceToIndexFieldMappingPropertyToCloudFormation)(properties.spaceFieldMappings) }) : properties;
    }
    function CfnDataSourceConfluenceSpaceConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("crawlArchivedSpaces", "CrawlArchivedSpaces", properties.CrawlArchivedSpaces != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CrawlArchivedSpaces) : void 0), ret.addPropertyResult("crawlPersonalSpaces", "CrawlPersonalSpaces", properties.CrawlPersonalSpaces != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CrawlPersonalSpaces) : void 0), ret.addPropertyResult("excludeSpaces", "ExcludeSpaces", properties.ExcludeSpaces != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExcludeSpaces) : void 0), ret.addPropertyResult("includeSpaces", "IncludeSpaces", properties.IncludeSpaces != null ? cfn_parse.FromCloudFormation.getStringArray(properties.IncludeSpaces) : void 0), ret.addPropertyResult("spaceFieldMappings", "SpaceFieldMappings", properties.SpaceFieldMappings != null ? cfn_parse.FromCloudFormation.getArray(CfnDataSourceConfluenceSpaceToIndexFieldMappingPropertyFromCloudFormation)(properties.SpaceFieldMappings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_ConfluenceSpaceToIndexFieldMappingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataSourceFieldName", cdk.requiredValidator)(properties.dataSourceFieldName)), errors.collect(cdk.propertyValidator("dataSourceFieldName", cdk.validateString)(properties.dataSourceFieldName)), errors.collect(cdk.propertyValidator("dateFieldFormat", cdk.validateString)(properties.dateFieldFormat)), errors.collect(cdk.propertyValidator("indexFieldName", cdk.requiredValidator)(properties.indexFieldName)), errors.collect(cdk.propertyValidator("indexFieldName", cdk.validateString)(properties.indexFieldName)), errors.wrap('supplied properties not correct for "ConfluenceSpaceToIndexFieldMappingProperty"');
    }
    function cfnDataSourceConfluenceSpaceToIndexFieldMappingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_ConfluenceSpaceToIndexFieldMappingPropertyValidator(properties).assertSuccess(), { DataSourceFieldName: cdk.stringToCloudFormation(properties.dataSourceFieldName), DateFieldFormat: cdk.stringToCloudFormation(properties.dateFieldFormat), IndexFieldName: cdk.stringToCloudFormation(properties.indexFieldName) }) : properties;
    }
    function CfnDataSourceConfluenceSpaceToIndexFieldMappingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataSourceFieldName", "DataSourceFieldName", cfn_parse.FromCloudFormation.getString(properties.DataSourceFieldName)), ret.addPropertyResult("dateFieldFormat", "DateFieldFormat", properties.DateFieldFormat != null ? cfn_parse.FromCloudFormation.getString(properties.DateFieldFormat) : void 0), ret.addPropertyResult("indexFieldName", "IndexFieldName", cfn_parse.FromCloudFormation.getString(properties.IndexFieldName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_ConnectionConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("databaseHost", cdk.requiredValidator)(properties.databaseHost)), errors.collect(cdk.propertyValidator("databaseHost", cdk.validateString)(properties.databaseHost)), errors.collect(cdk.propertyValidator("databaseName", cdk.requiredValidator)(properties.databaseName)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("databasePort", cdk.requiredValidator)(properties.databasePort)), errors.collect(cdk.propertyValidator("databasePort", cdk.validateNumber)(properties.databasePort)), errors.collect(cdk.propertyValidator("secretArn", cdk.requiredValidator)(properties.secretArn)), errors.collect(cdk.propertyValidator("secretArn", cdk.validateString)(properties.secretArn)), errors.collect(cdk.propertyValidator("tableName", cdk.requiredValidator)(properties.tableName)), errors.collect(cdk.propertyValidator("tableName", cdk.validateString)(properties.tableName)), errors.wrap('supplied properties not correct for "ConnectionConfigurationProperty"');
    }
    function cfnDataSourceConnectionConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_ConnectionConfigurationPropertyValidator(properties).assertSuccess(), { DatabaseHost: cdk.stringToCloudFormation(properties.databaseHost), DatabaseName: cdk.stringToCloudFormation(properties.databaseName), DatabasePort: cdk.numberToCloudFormation(properties.databasePort), SecretArn: cdk.stringToCloudFormation(properties.secretArn), TableName: cdk.stringToCloudFormation(properties.tableName) }) : properties;
    }
    function CfnDataSourceConnectionConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("databaseHost", "DatabaseHost", cfn_parse.FromCloudFormation.getString(properties.DatabaseHost)), ret.addPropertyResult("databaseName", "DatabaseName", cfn_parse.FromCloudFormation.getString(properties.DatabaseName)), ret.addPropertyResult("databasePort", "DatabasePort", cfn_parse.FromCloudFormation.getNumber(properties.DatabasePort)), ret.addPropertyResult("secretArn", "SecretArn", cfn_parse.FromCloudFormation.getString(properties.SecretArn)), ret.addPropertyResult("tableName", "TableName", cfn_parse.FromCloudFormation.getString(properties.TableName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_CustomDocumentEnrichmentConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("inlineConfigurations", cdk.listValidator(CfnDataSource_InlineCustomDocumentEnrichmentConfigurationPropertyValidator))(properties.inlineConfigurations)), errors.collect(cdk.propertyValidator("postExtractionHookConfiguration", CfnDataSource_HookConfigurationPropertyValidator)(properties.postExtractionHookConfiguration)), errors.collect(cdk.propertyValidator("preExtractionHookConfiguration", CfnDataSource_HookConfigurationPropertyValidator)(properties.preExtractionHookConfiguration)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "CustomDocumentEnrichmentConfigurationProperty"');
    }
    function cfnDataSourceCustomDocumentEnrichmentConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_CustomDocumentEnrichmentConfigurationPropertyValidator(properties).assertSuccess(), { InlineConfigurations: cdk.listMapper(cfnDataSourceInlineCustomDocumentEnrichmentConfigurationPropertyToCloudFormation)(properties.inlineConfigurations), PostExtractionHookConfiguration: cfnDataSourceHookConfigurationPropertyToCloudFormation(properties.postExtractionHookConfiguration), PreExtractionHookConfiguration: cfnDataSourceHookConfigurationPropertyToCloudFormation(properties.preExtractionHookConfiguration), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnDataSourceCustomDocumentEnrichmentConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("inlineConfigurations", "InlineConfigurations", properties.InlineConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnDataSourceInlineCustomDocumentEnrichmentConfigurationPropertyFromCloudFormation)(properties.InlineConfigurations) : void 0), ret.addPropertyResult("postExtractionHookConfiguration", "PostExtractionHookConfiguration", properties.PostExtractionHookConfiguration != null ? CfnDataSourceHookConfigurationPropertyFromCloudFormation(properties.PostExtractionHookConfiguration) : void 0), ret.addPropertyResult("preExtractionHookConfiguration", "PreExtractionHookConfiguration", properties.PreExtractionHookConfiguration != null ? CfnDataSourceHookConfigurationPropertyFromCloudFormation(properties.PreExtractionHookConfiguration) : void 0), ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_DataSourceConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("confluenceConfiguration", CfnDataSource_ConfluenceConfigurationPropertyValidator)(properties.confluenceConfiguration)), errors.collect(cdk.propertyValidator("databaseConfiguration", CfnDataSource_DatabaseConfigurationPropertyValidator)(properties.databaseConfiguration)), errors.collect(cdk.propertyValidator("googleDriveConfiguration", CfnDataSource_GoogleDriveConfigurationPropertyValidator)(properties.googleDriveConfiguration)), errors.collect(cdk.propertyValidator("oneDriveConfiguration", CfnDataSource_OneDriveConfigurationPropertyValidator)(properties.oneDriveConfiguration)), errors.collect(cdk.propertyValidator("s3Configuration", CfnDataSource_S3DataSourceConfigurationPropertyValidator)(properties.s3Configuration)), errors.collect(cdk.propertyValidator("salesforceConfiguration", CfnDataSource_SalesforceConfigurationPropertyValidator)(properties.salesforceConfiguration)), errors.collect(cdk.propertyValidator("serviceNowConfiguration", CfnDataSource_ServiceNowConfigurationPropertyValidator)(properties.serviceNowConfiguration)), errors.collect(cdk.propertyValidator("sharePointConfiguration", CfnDataSource_SharePointConfigurationPropertyValidator)(properties.sharePointConfiguration)), errors.collect(cdk.propertyValidator("webCrawlerConfiguration", CfnDataSource_WebCrawlerConfigurationPropertyValidator)(properties.webCrawlerConfiguration)), errors.collect(cdk.propertyValidator("workDocsConfiguration", CfnDataSource_WorkDocsConfigurationPropertyValidator)(properties.workDocsConfiguration)), errors.wrap('supplied properties not correct for "DataSourceConfigurationProperty"');
    }
    function cfnDataSourceDataSourceConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_DataSourceConfigurationPropertyValidator(properties).assertSuccess(), { ConfluenceConfiguration: cfnDataSourceConfluenceConfigurationPropertyToCloudFormation(properties.confluenceConfiguration), DatabaseConfiguration: cfnDataSourceDatabaseConfigurationPropertyToCloudFormation(properties.databaseConfiguration), GoogleDriveConfiguration: cfnDataSourceGoogleDriveConfigurationPropertyToCloudFormation(properties.googleDriveConfiguration), OneDriveConfiguration: cfnDataSourceOneDriveConfigurationPropertyToCloudFormation(properties.oneDriveConfiguration), S3Configuration: cfnDataSourceS3DataSourceConfigurationPropertyToCloudFormation(properties.s3Configuration), SalesforceConfiguration: cfnDataSourceSalesforceConfigurationPropertyToCloudFormation(properties.salesforceConfiguration), ServiceNowConfiguration: cfnDataSourceServiceNowConfigurationPropertyToCloudFormation(properties.serviceNowConfiguration), SharePointConfiguration: cfnDataSourceSharePointConfigurationPropertyToCloudFormation(properties.sharePointConfiguration), WebCrawlerConfiguration: cfnDataSourceWebCrawlerConfigurationPropertyToCloudFormation(properties.webCrawlerConfiguration), WorkDocsConfiguration: cfnDataSourceWorkDocsConfigurationPropertyToCloudFormation(properties.workDocsConfiguration) }) : properties;
    }
    function CfnDataSourceDataSourceConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("confluenceConfiguration", "ConfluenceConfiguration", properties.ConfluenceConfiguration != null ? CfnDataSourceConfluenceConfigurationPropertyFromCloudFormation(properties.ConfluenceConfiguration) : void 0), ret.addPropertyResult("databaseConfiguration", "DatabaseConfiguration", properties.DatabaseConfiguration != null ? CfnDataSourceDatabaseConfigurationPropertyFromCloudFormation(properties.DatabaseConfiguration) : void 0), ret.addPropertyResult("googleDriveConfiguration", "GoogleDriveConfiguration", properties.GoogleDriveConfiguration != null ? CfnDataSourceGoogleDriveConfigurationPropertyFromCloudFormation(properties.GoogleDriveConfiguration) : void 0), ret.addPropertyResult("oneDriveConfiguration", "OneDriveConfiguration", properties.OneDriveConfiguration != null ? CfnDataSourceOneDriveConfigurationPropertyFromCloudFormation(properties.OneDriveConfiguration) : void 0), ret.addPropertyResult("s3Configuration", "S3Configuration", properties.S3Configuration != null ? CfnDataSourceS3DataSourceConfigurationPropertyFromCloudFormation(properties.S3Configuration) : void 0), ret.addPropertyResult("salesforceConfiguration", "SalesforceConfiguration", properties.SalesforceConfiguration != null ? CfnDataSourceSalesforceConfigurationPropertyFromCloudFormation(properties.SalesforceConfiguration) : void 0), ret.addPropertyResult("serviceNowConfiguration", "ServiceNowConfiguration", properties.ServiceNowConfiguration != null ? CfnDataSourceServiceNowConfigurationPropertyFromCloudFormation(properties.ServiceNowConfiguration) : void 0), ret.addPropertyResult("sharePointConfiguration", "SharePointConfiguration", properties.SharePointConfiguration != null ? CfnDataSourceSharePointConfigurationPropertyFromCloudFormation(properties.SharePointConfiguration) : void 0), ret.addPropertyResult("webCrawlerConfiguration", "WebCrawlerConfiguration", properties.WebCrawlerConfiguration != null ? CfnDataSourceWebCrawlerConfigurationPropertyFromCloudFormation(properties.WebCrawlerConfiguration) : void 0), ret.addPropertyResult("workDocsConfiguration", "WorkDocsConfiguration", properties.WorkDocsConfiguration != null ? CfnDataSourceWorkDocsConfigurationPropertyFromCloudFormation(properties.WorkDocsConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_DataSourceToIndexFieldMappingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataSourceFieldName", cdk.requiredValidator)(properties.dataSourceFieldName)), errors.collect(cdk.propertyValidator("dataSourceFieldName", cdk.validateString)(properties.dataSourceFieldName)), errors.collect(cdk.propertyValidator("dateFieldFormat", cdk.validateString)(properties.dateFieldFormat)), errors.collect(cdk.propertyValidator("indexFieldName", cdk.requiredValidator)(properties.indexFieldName)), errors.collect(cdk.propertyValidator("indexFieldName", cdk.validateString)(properties.indexFieldName)), errors.wrap('supplied properties not correct for "DataSourceToIndexFieldMappingProperty"');
    }
    function cfnDataSourceDataSourceToIndexFieldMappingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_DataSourceToIndexFieldMappingPropertyValidator(properties).assertSuccess(), { DataSourceFieldName: cdk.stringToCloudFormation(properties.dataSourceFieldName), DateFieldFormat: cdk.stringToCloudFormation(properties.dateFieldFormat), IndexFieldName: cdk.stringToCloudFormation(properties.indexFieldName) }) : properties;
    }
    function CfnDataSourceDataSourceToIndexFieldMappingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataSourceFieldName", "DataSourceFieldName", cfn_parse.FromCloudFormation.getString(properties.DataSourceFieldName)), ret.addPropertyResult("dateFieldFormat", "DateFieldFormat", properties.DateFieldFormat != null ? cfn_parse.FromCloudFormation.getString(properties.DateFieldFormat) : void 0), ret.addPropertyResult("indexFieldName", "IndexFieldName", cfn_parse.FromCloudFormation.getString(properties.IndexFieldName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_DataSourceVpcConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.requiredValidator)(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.requiredValidator)(properties.subnetIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.wrap('supplied properties not correct for "DataSourceVpcConfigurationProperty"');
    }
    function cfnDataSourceDataSourceVpcConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_DataSourceVpcConfigurationPropertyValidator(properties).assertSuccess(), { SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds) }) : properties;
    }
    function CfnDataSourceDataSourceVpcConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds)), ret.addPropertyResult("subnetIds", "SubnetIds", cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_DatabaseConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aclConfiguration", CfnDataSource_AclConfigurationPropertyValidator)(properties.aclConfiguration)), errors.collect(cdk.propertyValidator("columnConfiguration", cdk.requiredValidator)(properties.columnConfiguration)), errors.collect(cdk.propertyValidator("columnConfiguration", CfnDataSource_ColumnConfigurationPropertyValidator)(properties.columnConfiguration)), errors.collect(cdk.propertyValidator("connectionConfiguration", cdk.requiredValidator)(properties.connectionConfiguration)), errors.collect(cdk.propertyValidator("connectionConfiguration", CfnDataSource_ConnectionConfigurationPropertyValidator)(properties.connectionConfiguration)), errors.collect(cdk.propertyValidator("databaseEngineType", cdk.requiredValidator)(properties.databaseEngineType)), errors.collect(cdk.propertyValidator("databaseEngineType", cdk.validateString)(properties.databaseEngineType)), errors.collect(cdk.propertyValidator("sqlConfiguration", CfnDataSource_SqlConfigurationPropertyValidator)(properties.sqlConfiguration)), errors.collect(cdk.propertyValidator("vpcConfiguration", CfnDataSource_DataSourceVpcConfigurationPropertyValidator)(properties.vpcConfiguration)), errors.wrap('supplied properties not correct for "DatabaseConfigurationProperty"');
    }
    function cfnDataSourceDatabaseConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_DatabaseConfigurationPropertyValidator(properties).assertSuccess(), { AclConfiguration: cfnDataSourceAclConfigurationPropertyToCloudFormation(properties.aclConfiguration), ColumnConfiguration: cfnDataSourceColumnConfigurationPropertyToCloudFormation(properties.columnConfiguration), ConnectionConfiguration: cfnDataSourceConnectionConfigurationPropertyToCloudFormation(properties.connectionConfiguration), DatabaseEngineType: cdk.stringToCloudFormation(properties.databaseEngineType), SqlConfiguration: cfnDataSourceSqlConfigurationPropertyToCloudFormation(properties.sqlConfiguration), VpcConfiguration: cfnDataSourceDataSourceVpcConfigurationPropertyToCloudFormation(properties.vpcConfiguration) }) : properties;
    }
    function CfnDataSourceDatabaseConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aclConfiguration", "AclConfiguration", properties.AclConfiguration != null ? CfnDataSourceAclConfigurationPropertyFromCloudFormation(properties.AclConfiguration) : void 0), ret.addPropertyResult("columnConfiguration", "ColumnConfiguration", CfnDataSourceColumnConfigurationPropertyFromCloudFormation(properties.ColumnConfiguration)), ret.addPropertyResult("connectionConfiguration", "ConnectionConfiguration", CfnDataSourceConnectionConfigurationPropertyFromCloudFormation(properties.ConnectionConfiguration)), ret.addPropertyResult("databaseEngineType", "DatabaseEngineType", cfn_parse.FromCloudFormation.getString(properties.DatabaseEngineType)), ret.addPropertyResult("sqlConfiguration", "SqlConfiguration", properties.SqlConfiguration != null ? CfnDataSourceSqlConfigurationPropertyFromCloudFormation(properties.SqlConfiguration) : void 0), ret.addPropertyResult("vpcConfiguration", "VpcConfiguration", properties.VpcConfiguration != null ? CfnDataSourceDataSourceVpcConfigurationPropertyFromCloudFormation(properties.VpcConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_DocumentAttributeConditionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("conditionDocumentAttributeKey", cdk.requiredValidator)(properties.conditionDocumentAttributeKey)), errors.collect(cdk.propertyValidator("conditionDocumentAttributeKey", cdk.validateString)(properties.conditionDocumentAttributeKey)), errors.collect(cdk.propertyValidator("conditionOnValue", CfnDataSource_DocumentAttributeValuePropertyValidator)(properties.conditionOnValue)), errors.collect(cdk.propertyValidator("operator", cdk.requiredValidator)(properties.operator)), errors.collect(cdk.propertyValidator("operator", cdk.validateString)(properties.operator)), errors.wrap('supplied properties not correct for "DocumentAttributeConditionProperty"');
    }
    function cfnDataSourceDocumentAttributeConditionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_DocumentAttributeConditionPropertyValidator(properties).assertSuccess(), { ConditionDocumentAttributeKey: cdk.stringToCloudFormation(properties.conditionDocumentAttributeKey), ConditionOnValue: cfnDataSourceDocumentAttributeValuePropertyToCloudFormation(properties.conditionOnValue), Operator: cdk.stringToCloudFormation(properties.operator) }) : properties;
    }
    function CfnDataSourceDocumentAttributeConditionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("conditionDocumentAttributeKey", "ConditionDocumentAttributeKey", cfn_parse.FromCloudFormation.getString(properties.ConditionDocumentAttributeKey)), ret.addPropertyResult("conditionOnValue", "ConditionOnValue", properties.ConditionOnValue != null ? CfnDataSourceDocumentAttributeValuePropertyFromCloudFormation(properties.ConditionOnValue) : void 0), ret.addPropertyResult("operator", "Operator", cfn_parse.FromCloudFormation.getString(properties.Operator)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_DocumentAttributeTargetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("targetDocumentAttributeKey", cdk.requiredValidator)(properties.targetDocumentAttributeKey)), errors.collect(cdk.propertyValidator("targetDocumentAttributeKey", cdk.validateString)(properties.targetDocumentAttributeKey)), errors.collect(cdk.propertyValidator("targetDocumentAttributeValue", CfnDataSource_DocumentAttributeValuePropertyValidator)(properties.targetDocumentAttributeValue)), errors.collect(cdk.propertyValidator("targetDocumentAttributeValueDeletion", cdk.validateBoolean)(properties.targetDocumentAttributeValueDeletion)), errors.wrap('supplied properties not correct for "DocumentAttributeTargetProperty"');
    }
    function cfnDataSourceDocumentAttributeTargetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_DocumentAttributeTargetPropertyValidator(properties).assertSuccess(), { TargetDocumentAttributeKey: cdk.stringToCloudFormation(properties.targetDocumentAttributeKey), TargetDocumentAttributeValue: cfnDataSourceDocumentAttributeValuePropertyToCloudFormation(properties.targetDocumentAttributeValue), TargetDocumentAttributeValueDeletion: cdk.booleanToCloudFormation(properties.targetDocumentAttributeValueDeletion) }) : properties;
    }
    function CfnDataSourceDocumentAttributeTargetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("targetDocumentAttributeKey", "TargetDocumentAttributeKey", cfn_parse.FromCloudFormation.getString(properties.TargetDocumentAttributeKey)), ret.addPropertyResult("targetDocumentAttributeValue", "TargetDocumentAttributeValue", properties.TargetDocumentAttributeValue != null ? CfnDataSourceDocumentAttributeValuePropertyFromCloudFormation(properties.TargetDocumentAttributeValue) : void 0), ret.addPropertyResult("targetDocumentAttributeValueDeletion", "TargetDocumentAttributeValueDeletion", properties.TargetDocumentAttributeValueDeletion != null ? cfn_parse.FromCloudFormation.getBoolean(properties.TargetDocumentAttributeValueDeletion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_DocumentAttributeValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateValue", cdk.validateString)(properties.dateValue)), errors.collect(cdk.propertyValidator("longValue", cdk.validateNumber)(properties.longValue)), errors.collect(cdk.propertyValidator("stringListValue", cdk.listValidator(cdk.validateString))(properties.stringListValue)), errors.collect(cdk.propertyValidator("stringValue", cdk.validateString)(properties.stringValue)), errors.wrap('supplied properties not correct for "DocumentAttributeValueProperty"');
    }
    function cfnDataSourceDocumentAttributeValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_DocumentAttributeValuePropertyValidator(properties).assertSuccess(), { DateValue: cdk.stringToCloudFormation(properties.dateValue), LongValue: cdk.numberToCloudFormation(properties.longValue), StringListValue: cdk.listMapper(cdk.stringToCloudFormation)(properties.stringListValue), StringValue: cdk.stringToCloudFormation(properties.stringValue) }) : properties;
    }
    function CfnDataSourceDocumentAttributeValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateValue", "DateValue", properties.DateValue != null ? cfn_parse.FromCloudFormation.getString(properties.DateValue) : void 0), ret.addPropertyResult("longValue", "LongValue", properties.LongValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.LongValue) : void 0), ret.addPropertyResult("stringListValue", "StringListValue", properties.StringListValue != null ? cfn_parse.FromCloudFormation.getStringArray(properties.StringListValue) : void 0), ret.addPropertyResult("stringValue", "StringValue", properties.StringValue != null ? cfn_parse.FromCloudFormation.getString(properties.StringValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_DocumentsMetadataConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3Prefix", cdk.validateString)(properties.s3Prefix)), errors.wrap('supplied properties not correct for "DocumentsMetadataConfigurationProperty"');
    }
    function cfnDataSourceDocumentsMetadataConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_DocumentsMetadataConfigurationPropertyValidator(properties).assertSuccess(), { S3Prefix: cdk.stringToCloudFormation(properties.s3Prefix) }) : properties;
    }
    function CfnDataSourceDocumentsMetadataConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Prefix", "S3Prefix", properties.S3Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.S3Prefix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_GoogleDriveConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("excludeMimeTypes", cdk.listValidator(cdk.validateString))(properties.excludeMimeTypes)), errors.collect(cdk.propertyValidator("excludeSharedDrives", cdk.listValidator(cdk.validateString))(properties.excludeSharedDrives)), errors.collect(cdk.propertyValidator("excludeUserAccounts", cdk.listValidator(cdk.validateString))(properties.excludeUserAccounts)), errors.collect(cdk.propertyValidator("exclusionPatterns", cdk.listValidator(cdk.validateString))(properties.exclusionPatterns)), errors.collect(cdk.propertyValidator("fieldMappings", cdk.listValidator(CfnDataSource_DataSourceToIndexFieldMappingPropertyValidator))(properties.fieldMappings)), errors.collect(cdk.propertyValidator("inclusionPatterns", cdk.listValidator(cdk.validateString))(properties.inclusionPatterns)), errors.collect(cdk.propertyValidator("secretArn", cdk.requiredValidator)(properties.secretArn)), errors.collect(cdk.propertyValidator("secretArn", cdk.validateString)(properties.secretArn)), errors.wrap('supplied properties not correct for "GoogleDriveConfigurationProperty"');
    }
    function cfnDataSourceGoogleDriveConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_GoogleDriveConfigurationPropertyValidator(properties).assertSuccess(), { ExcludeMimeTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.excludeMimeTypes), ExcludeSharedDrives: cdk.listMapper(cdk.stringToCloudFormation)(properties.excludeSharedDrives), ExcludeUserAccounts: cdk.listMapper(cdk.stringToCloudFormation)(properties.excludeUserAccounts), ExclusionPatterns: cdk.listMapper(cdk.stringToCloudFormation)(properties.exclusionPatterns), FieldMappings: cdk.listMapper(cfnDataSourceDataSourceToIndexFieldMappingPropertyToCloudFormation)(properties.fieldMappings), InclusionPatterns: cdk.listMapper(cdk.stringToCloudFormation)(properties.inclusionPatterns), SecretArn: cdk.stringToCloudFormation(properties.secretArn) }) : properties;
    }
    function CfnDataSourceGoogleDriveConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("excludeMimeTypes", "ExcludeMimeTypes", properties.ExcludeMimeTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExcludeMimeTypes) : void 0), ret.addPropertyResult("excludeSharedDrives", "ExcludeSharedDrives", properties.ExcludeSharedDrives != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExcludeSharedDrives) : void 0), ret.addPropertyResult("excludeUserAccounts", "ExcludeUserAccounts", properties.ExcludeUserAccounts != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExcludeUserAccounts) : void 0), ret.addPropertyResult("exclusionPatterns", "ExclusionPatterns", properties.ExclusionPatterns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExclusionPatterns) : void 0), ret.addPropertyResult("fieldMappings", "FieldMappings", properties.FieldMappings != null ? cfn_parse.FromCloudFormation.getArray(CfnDataSourceDataSourceToIndexFieldMappingPropertyFromCloudFormation)(properties.FieldMappings) : void 0), ret.addPropertyResult("inclusionPatterns", "InclusionPatterns", properties.InclusionPatterns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.InclusionPatterns) : void 0), ret.addPropertyResult("secretArn", "SecretArn", cfn_parse.FromCloudFormation.getString(properties.SecretArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_HookConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("invocationCondition", CfnDataSource_DocumentAttributeConditionPropertyValidator)(properties.invocationCondition)), errors.collect(cdk.propertyValidator("lambdaArn", cdk.requiredValidator)(properties.lambdaArn)), errors.collect(cdk.propertyValidator("lambdaArn", cdk.validateString)(properties.lambdaArn)), errors.collect(cdk.propertyValidator("s3Bucket", cdk.requiredValidator)(properties.s3Bucket)), errors.collect(cdk.propertyValidator("s3Bucket", cdk.validateString)(properties.s3Bucket)), errors.wrap('supplied properties not correct for "HookConfigurationProperty"');
    }
    function cfnDataSourceHookConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_HookConfigurationPropertyValidator(properties).assertSuccess(), { InvocationCondition: cfnDataSourceDocumentAttributeConditionPropertyToCloudFormation(properties.invocationCondition), LambdaArn: cdk.stringToCloudFormation(properties.lambdaArn), S3Bucket: cdk.stringToCloudFormation(properties.s3Bucket) }) : properties;
    }
    function CfnDataSourceHookConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("invocationCondition", "InvocationCondition", properties.InvocationCondition != null ? CfnDataSourceDocumentAttributeConditionPropertyFromCloudFormation(properties.InvocationCondition) : void 0), ret.addPropertyResult("lambdaArn", "LambdaArn", cfn_parse.FromCloudFormation.getString(properties.LambdaArn)), ret.addPropertyResult("s3Bucket", "S3Bucket", cfn_parse.FromCloudFormation.getString(properties.S3Bucket)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_InlineCustomDocumentEnrichmentConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("condition", CfnDataSource_DocumentAttributeConditionPropertyValidator)(properties.condition)), errors.collect(cdk.propertyValidator("documentContentDeletion", cdk.validateBoolean)(properties.documentContentDeletion)), errors.collect(cdk.propertyValidator("target", CfnDataSource_DocumentAttributeTargetPropertyValidator)(properties.target)), errors.wrap('supplied properties not correct for "InlineCustomDocumentEnrichmentConfigurationProperty"');
    }
    function cfnDataSourceInlineCustomDocumentEnrichmentConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_InlineCustomDocumentEnrichmentConfigurationPropertyValidator(properties).assertSuccess(), { Condition: cfnDataSourceDocumentAttributeConditionPropertyToCloudFormation(properties.condition), DocumentContentDeletion: cdk.booleanToCloudFormation(properties.documentContentDeletion), Target: cfnDataSourceDocumentAttributeTargetPropertyToCloudFormation(properties.target) }) : properties;
    }
    function CfnDataSourceInlineCustomDocumentEnrichmentConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("condition", "Condition", properties.Condition != null ? CfnDataSourceDocumentAttributeConditionPropertyFromCloudFormation(properties.Condition) : void 0), ret.addPropertyResult("documentContentDeletion", "DocumentContentDeletion", properties.DocumentContentDeletion != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DocumentContentDeletion) : void 0), ret.addPropertyResult("target", "Target", properties.Target != null ? CfnDataSourceDocumentAttributeTargetPropertyFromCloudFormation(properties.Target) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_OneDriveConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("disableLocalGroups", cdk.validateBoolean)(properties.disableLocalGroups)), errors.collect(cdk.propertyValidator("exclusionPatterns", cdk.listValidator(cdk.validateString))(properties.exclusionPatterns)), errors.collect(cdk.propertyValidator("fieldMappings", cdk.listValidator(CfnDataSource_DataSourceToIndexFieldMappingPropertyValidator))(properties.fieldMappings)), errors.collect(cdk.propertyValidator("inclusionPatterns", cdk.listValidator(cdk.validateString))(properties.inclusionPatterns)), errors.collect(cdk.propertyValidator("oneDriveUsers", cdk.requiredValidator)(properties.oneDriveUsers)), errors.collect(cdk.propertyValidator("oneDriveUsers", CfnDataSource_OneDriveUsersPropertyValidator)(properties.oneDriveUsers)), errors.collect(cdk.propertyValidator("secretArn", cdk.requiredValidator)(properties.secretArn)), errors.collect(cdk.propertyValidator("secretArn", cdk.validateString)(properties.secretArn)), errors.collect(cdk.propertyValidator("tenantDomain", cdk.requiredValidator)(properties.tenantDomain)), errors.collect(cdk.propertyValidator("tenantDomain", cdk.validateString)(properties.tenantDomain)), errors.wrap('supplied properties not correct for "OneDriveConfigurationProperty"');
    }
    function cfnDataSourceOneDriveConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_OneDriveConfigurationPropertyValidator(properties).assertSuccess(), { DisableLocalGroups: cdk.booleanToCloudFormation(properties.disableLocalGroups), ExclusionPatterns: cdk.listMapper(cdk.stringToCloudFormation)(properties.exclusionPatterns), FieldMappings: cdk.listMapper(cfnDataSourceDataSourceToIndexFieldMappingPropertyToCloudFormation)(properties.fieldMappings), InclusionPatterns: cdk.listMapper(cdk.stringToCloudFormation)(properties.inclusionPatterns), OneDriveUsers: cfnDataSourceOneDriveUsersPropertyToCloudFormation(properties.oneDriveUsers), SecretArn: cdk.stringToCloudFormation(properties.secretArn), TenantDomain: cdk.stringToCloudFormation(properties.tenantDomain) }) : properties;
    }
    function CfnDataSourceOneDriveConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("disableLocalGroups", "DisableLocalGroups", properties.DisableLocalGroups != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DisableLocalGroups) : void 0), ret.addPropertyResult("exclusionPatterns", "ExclusionPatterns", properties.ExclusionPatterns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExclusionPatterns) : void 0), ret.addPropertyResult("fieldMappings", "FieldMappings", properties.FieldMappings != null ? cfn_parse.FromCloudFormation.getArray(CfnDataSourceDataSourceToIndexFieldMappingPropertyFromCloudFormation)(properties.FieldMappings) : void 0), ret.addPropertyResult("inclusionPatterns", "InclusionPatterns", properties.InclusionPatterns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.InclusionPatterns) : void 0), ret.addPropertyResult("oneDriveUsers", "OneDriveUsers", CfnDataSourceOneDriveUsersPropertyFromCloudFormation(properties.OneDriveUsers)), ret.addPropertyResult("secretArn", "SecretArn", cfn_parse.FromCloudFormation.getString(properties.SecretArn)), ret.addPropertyResult("tenantDomain", "TenantDomain", cfn_parse.FromCloudFormation.getString(properties.TenantDomain)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_OneDriveUsersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("oneDriveUserList", cdk.listValidator(cdk.validateString))(properties.oneDriveUserList)), errors.collect(cdk.propertyValidator("oneDriveUserS3Path", CfnDataSource_S3PathPropertyValidator)(properties.oneDriveUserS3Path)), errors.wrap('supplied properties not correct for "OneDriveUsersProperty"');
    }
    function cfnDataSourceOneDriveUsersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_OneDriveUsersPropertyValidator(properties).assertSuccess(), { OneDriveUserList: cdk.listMapper(cdk.stringToCloudFormation)(properties.oneDriveUserList), OneDriveUserS3Path: cfnDataSourceS3PathPropertyToCloudFormation(properties.oneDriveUserS3Path) }) : properties;
    }
    function CfnDataSourceOneDriveUsersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("oneDriveUserList", "OneDriveUserList", properties.OneDriveUserList != null ? cfn_parse.FromCloudFormation.getStringArray(properties.OneDriveUserList) : void 0), ret.addPropertyResult("oneDriveUserS3Path", "OneDriveUserS3Path", properties.OneDriveUserS3Path != null ? CfnDataSourceS3PathPropertyFromCloudFormation(properties.OneDriveUserS3Path) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_ProxyConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("credentials", cdk.validateString)(properties.credentials)), errors.collect(cdk.propertyValidator("host", cdk.requiredValidator)(properties.host)), errors.collect(cdk.propertyValidator("host", cdk.validateString)(properties.host)), errors.collect(cdk.propertyValidator("port", cdk.requiredValidator)(properties.port)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.wrap('supplied properties not correct for "ProxyConfigurationProperty"');
    }
    function cfnDataSourceProxyConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_ProxyConfigurationPropertyValidator(properties).assertSuccess(), { Credentials: cdk.stringToCloudFormation(properties.credentials), Host: cdk.stringToCloudFormation(properties.host), Port: cdk.numberToCloudFormation(properties.port) }) : properties;
    }
    function CfnDataSourceProxyConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("credentials", "Credentials", properties.Credentials != null ? cfn_parse.FromCloudFormation.getString(properties.Credentials) : void 0), ret.addPropertyResult("host", "Host", cfn_parse.FromCloudFormation.getString(properties.Host)), ret.addPropertyResult("port", "Port", cfn_parse.FromCloudFormation.getNumber(properties.Port)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_S3DataSourceConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessControlListConfiguration", CfnDataSource_AccessControlListConfigurationPropertyValidator)(properties.accessControlListConfiguration)), errors.collect(cdk.propertyValidator("bucketName", cdk.requiredValidator)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.collect(cdk.propertyValidator("documentsMetadataConfiguration", CfnDataSource_DocumentsMetadataConfigurationPropertyValidator)(properties.documentsMetadataConfiguration)), errors.collect(cdk.propertyValidator("exclusionPatterns", cdk.listValidator(cdk.validateString))(properties.exclusionPatterns)), errors.collect(cdk.propertyValidator("inclusionPatterns", cdk.listValidator(cdk.validateString))(properties.inclusionPatterns)), errors.collect(cdk.propertyValidator("inclusionPrefixes", cdk.listValidator(cdk.validateString))(properties.inclusionPrefixes)), errors.wrap('supplied properties not correct for "S3DataSourceConfigurationProperty"');
    }
    function cfnDataSourceS3DataSourceConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_S3DataSourceConfigurationPropertyValidator(properties).assertSuccess(), { AccessControlListConfiguration: cfnDataSourceAccessControlListConfigurationPropertyToCloudFormation(properties.accessControlListConfiguration), BucketName: cdk.stringToCloudFormation(properties.bucketName), DocumentsMetadataConfiguration: cfnDataSourceDocumentsMetadataConfigurationPropertyToCloudFormation(properties.documentsMetadataConfiguration), ExclusionPatterns: cdk.listMapper(cdk.stringToCloudFormation)(properties.exclusionPatterns), InclusionPatterns: cdk.listMapper(cdk.stringToCloudFormation)(properties.inclusionPatterns), InclusionPrefixes: cdk.listMapper(cdk.stringToCloudFormation)(properties.inclusionPrefixes) }) : properties;
    }
    function CfnDataSourceS3DataSourceConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessControlListConfiguration", "AccessControlListConfiguration", properties.AccessControlListConfiguration != null ? CfnDataSourceAccessControlListConfigurationPropertyFromCloudFormation(properties.AccessControlListConfiguration) : void 0), ret.addPropertyResult("bucketName", "BucketName", cfn_parse.FromCloudFormation.getString(properties.BucketName)), ret.addPropertyResult("documentsMetadataConfiguration", "DocumentsMetadataConfiguration", properties.DocumentsMetadataConfiguration != null ? CfnDataSourceDocumentsMetadataConfigurationPropertyFromCloudFormation(properties.DocumentsMetadataConfiguration) : void 0), ret.addPropertyResult("exclusionPatterns", "ExclusionPatterns", properties.ExclusionPatterns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExclusionPatterns) : void 0), ret.addPropertyResult("inclusionPatterns", "InclusionPatterns", properties.InclusionPatterns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.InclusionPatterns) : void 0), ret.addPropertyResult("inclusionPrefixes", "InclusionPrefixes", properties.InclusionPrefixes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.InclusionPrefixes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_S3PathPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.requiredValidator)(properties.bucket)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.wrap('supplied properties not correct for "S3PathProperty"');
    }
    function cfnDataSourceS3PathPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_S3PathPropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), Key: cdk.stringToCloudFormation(properties.key) }) : properties;
    }
    function CfnDataSourceS3PathPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", cfn_parse.FromCloudFormation.getString(properties.Bucket)), ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_SalesforceChatterFeedConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("documentDataFieldName", cdk.requiredValidator)(properties.documentDataFieldName)), errors.collect(cdk.propertyValidator("documentDataFieldName", cdk.validateString)(properties.documentDataFieldName)), errors.collect(cdk.propertyValidator("documentTitleFieldName", cdk.validateString)(properties.documentTitleFieldName)), errors.collect(cdk.propertyValidator("fieldMappings", cdk.listValidator(CfnDataSource_DataSourceToIndexFieldMappingPropertyValidator))(properties.fieldMappings)), errors.collect(cdk.propertyValidator("includeFilterTypes", cdk.listValidator(cdk.validateString))(properties.includeFilterTypes)), errors.wrap('supplied properties not correct for "SalesforceChatterFeedConfigurationProperty"');
    }
    function cfnDataSourceSalesforceChatterFeedConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_SalesforceChatterFeedConfigurationPropertyValidator(properties).assertSuccess(), { DocumentDataFieldName: cdk.stringToCloudFormation(properties.documentDataFieldName), DocumentTitleFieldName: cdk.stringToCloudFormation(properties.documentTitleFieldName), FieldMappings: cdk.listMapper(cfnDataSourceDataSourceToIndexFieldMappingPropertyToCloudFormation)(properties.fieldMappings), IncludeFilterTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.includeFilterTypes) }) : properties;
    }
    function CfnDataSourceSalesforceChatterFeedConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("documentDataFieldName", "DocumentDataFieldName", cfn_parse.FromCloudFormation.getString(properties.DocumentDataFieldName)), ret.addPropertyResult("documentTitleFieldName", "DocumentTitleFieldName", properties.DocumentTitleFieldName != null ? cfn_parse.FromCloudFormation.getString(properties.DocumentTitleFieldName) : void 0), ret.addPropertyResult("fieldMappings", "FieldMappings", properties.FieldMappings != null ? cfn_parse.FromCloudFormation.getArray(CfnDataSourceDataSourceToIndexFieldMappingPropertyFromCloudFormation)(properties.FieldMappings) : void 0), ret.addPropertyResult("includeFilterTypes", "IncludeFilterTypes", properties.IncludeFilterTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.IncludeFilterTypes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_SalesforceConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("chatterFeedConfiguration", CfnDataSource_SalesforceChatterFeedConfigurationPropertyValidator)(properties.chatterFeedConfiguration)), errors.collect(cdk.propertyValidator("crawlAttachments", cdk.validateBoolean)(properties.crawlAttachments)), errors.collect(cdk.propertyValidator("excludeAttachmentFilePatterns", cdk.listValidator(cdk.validateString))(properties.excludeAttachmentFilePatterns)), errors.collect(cdk.propertyValidator("includeAttachmentFilePatterns", cdk.listValidator(cdk.validateString))(properties.includeAttachmentFilePatterns)), errors.collect(cdk.propertyValidator("knowledgeArticleConfiguration", CfnDataSource_SalesforceKnowledgeArticleConfigurationPropertyValidator)(properties.knowledgeArticleConfiguration)), errors.collect(cdk.propertyValidator("secretArn", cdk.requiredValidator)(properties.secretArn)), errors.collect(cdk.propertyValidator("secretArn", cdk.validateString)(properties.secretArn)), errors.collect(cdk.propertyValidator("serverUrl", cdk.requiredValidator)(properties.serverUrl)), errors.collect(cdk.propertyValidator("serverUrl", cdk.validateString)(properties.serverUrl)), errors.collect(cdk.propertyValidator("standardObjectAttachmentConfiguration", CfnDataSource_SalesforceStandardObjectAttachmentConfigurationPropertyValidator)(properties.standardObjectAttachmentConfiguration)), errors.collect(cdk.propertyValidator("standardObjectConfigurations", cdk.listValidator(CfnDataSource_SalesforceStandardObjectConfigurationPropertyValidator))(properties.standardObjectConfigurations)), errors.wrap('supplied properties not correct for "SalesforceConfigurationProperty"');
    }
    function cfnDataSourceSalesforceConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_SalesforceConfigurationPropertyValidator(properties).assertSuccess(), { ChatterFeedConfiguration: cfnDataSourceSalesforceChatterFeedConfigurationPropertyToCloudFormation(properties.chatterFeedConfiguration), CrawlAttachments: cdk.booleanToCloudFormation(properties.crawlAttachments), ExcludeAttachmentFilePatterns: cdk.listMapper(cdk.stringToCloudFormation)(properties.excludeAttachmentFilePatterns), IncludeAttachmentFilePatterns: cdk.listMapper(cdk.stringToCloudFormation)(properties.includeAttachmentFilePatterns), KnowledgeArticleConfiguration: cfnDataSourceSalesforceKnowledgeArticleConfigurationPropertyToCloudFormation(properties.knowledgeArticleConfiguration), SecretArn: cdk.stringToCloudFormation(properties.secretArn), ServerUrl: cdk.stringToCloudFormation(properties.serverUrl), StandardObjectAttachmentConfiguration: cfnDataSourceSalesforceStandardObjectAttachmentConfigurationPropertyToCloudFormation(properties.standardObjectAttachmentConfiguration), StandardObjectConfigurations: cdk.listMapper(cfnDataSourceSalesforceStandardObjectConfigurationPropertyToCloudFormation)(properties.standardObjectConfigurations) }) : properties;
    }
    function CfnDataSourceSalesforceConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("chatterFeedConfiguration", "ChatterFeedConfiguration", properties.ChatterFeedConfiguration != null ? CfnDataSourceSalesforceChatterFeedConfigurationPropertyFromCloudFormation(properties.ChatterFeedConfiguration) : void 0), ret.addPropertyResult("crawlAttachments", "CrawlAttachments", properties.CrawlAttachments != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CrawlAttachments) : void 0), ret.addPropertyResult("excludeAttachmentFilePatterns", "ExcludeAttachmentFilePatterns", properties.ExcludeAttachmentFilePatterns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExcludeAttachmentFilePatterns) : void 0), ret.addPropertyResult("includeAttachmentFilePatterns", "IncludeAttachmentFilePatterns", properties.IncludeAttachmentFilePatterns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.IncludeAttachmentFilePatterns) : void 0), ret.addPropertyResult("knowledgeArticleConfiguration", "KnowledgeArticleConfiguration", properties.KnowledgeArticleConfiguration != null ? CfnDataSourceSalesforceKnowledgeArticleConfigurationPropertyFromCloudFormation(properties.KnowledgeArticleConfiguration) : void 0), ret.addPropertyResult("secretArn", "SecretArn", cfn_parse.FromCloudFormation.getString(properties.SecretArn)), ret.addPropertyResult("serverUrl", "ServerUrl", cfn_parse.FromCloudFormation.getString(properties.ServerUrl)), ret.addPropertyResult("standardObjectAttachmentConfiguration", "StandardObjectAttachmentConfiguration", properties.StandardObjectAttachmentConfiguration != null ? CfnDataSourceSalesforceStandardObjectAttachmentConfigurationPropertyFromCloudFormation(properties.StandardObjectAttachmentConfiguration) : void 0), ret.addPropertyResult("standardObjectConfigurations", "StandardObjectConfigurations", properties.StandardObjectConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnDataSourceSalesforceStandardObjectConfigurationPropertyFromCloudFormation)(properties.StandardObjectConfigurations) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_SalesforceCustomKnowledgeArticleTypeConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("documentDataFieldName", cdk.requiredValidator)(properties.documentDataFieldName)), errors.collect(cdk.propertyValidator("documentDataFieldName", cdk.validateString)(properties.documentDataFieldName)), errors.collect(cdk.propertyValidator("documentTitleFieldName", cdk.validateString)(properties.documentTitleFieldName)), errors.collect(cdk.propertyValidator("fieldMappings", cdk.listValidator(CfnDataSource_DataSourceToIndexFieldMappingPropertyValidator))(properties.fieldMappings)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "SalesforceCustomKnowledgeArticleTypeConfigurationProperty"');
    }
    function cfnDataSourceSalesforceCustomKnowledgeArticleTypeConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_SalesforceCustomKnowledgeArticleTypeConfigurationPropertyValidator(properties).assertSuccess(), { DocumentDataFieldName: cdk.stringToCloudFormation(properties.documentDataFieldName), DocumentTitleFieldName: cdk.stringToCloudFormation(properties.documentTitleFieldName), FieldMappings: cdk.listMapper(cfnDataSourceDataSourceToIndexFieldMappingPropertyToCloudFormation)(properties.fieldMappings), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnDataSourceSalesforceCustomKnowledgeArticleTypeConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("documentDataFieldName", "DocumentDataFieldName", cfn_parse.FromCloudFormation.getString(properties.DocumentDataFieldName)), ret.addPropertyResult("documentTitleFieldName", "DocumentTitleFieldName", properties.DocumentTitleFieldName != null ? cfn_parse.FromCloudFormation.getString(properties.DocumentTitleFieldName) : void 0), ret.addPropertyResult("fieldMappings", "FieldMappings", properties.FieldMappings != null ? cfn_parse.FromCloudFormation.getArray(CfnDataSourceDataSourceToIndexFieldMappingPropertyFromCloudFormation)(properties.FieldMappings) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_SalesforceKnowledgeArticleConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customKnowledgeArticleTypeConfigurations", cdk.listValidator(CfnDataSource_SalesforceCustomKnowledgeArticleTypeConfigurationPropertyValidator))(properties.customKnowledgeArticleTypeConfigurations)), errors.collect(cdk.propertyValidator("includedStates", cdk.requiredValidator)(properties.includedStates)), errors.collect(cdk.propertyValidator("includedStates", cdk.listValidator(cdk.validateString))(properties.includedStates)), errors.collect(cdk.propertyValidator("standardKnowledgeArticleTypeConfiguration", CfnDataSource_SalesforceStandardKnowledgeArticleTypeConfigurationPropertyValidator)(properties.standardKnowledgeArticleTypeConfiguration)), errors.wrap('supplied properties not correct for "SalesforceKnowledgeArticleConfigurationProperty"');
    }
    function cfnDataSourceSalesforceKnowledgeArticleConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_SalesforceKnowledgeArticleConfigurationPropertyValidator(properties).assertSuccess(), { CustomKnowledgeArticleTypeConfigurations: cdk.listMapper(cfnDataSourceSalesforceCustomKnowledgeArticleTypeConfigurationPropertyToCloudFormation)(properties.customKnowledgeArticleTypeConfigurations), IncludedStates: cdk.listMapper(cdk.stringToCloudFormation)(properties.includedStates), StandardKnowledgeArticleTypeConfiguration: cfnDataSourceSalesforceStandardKnowledgeArticleTypeConfigurationPropertyToCloudFormation(properties.standardKnowledgeArticleTypeConfiguration) }) : properties;
    }
    function CfnDataSourceSalesforceKnowledgeArticleConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customKnowledgeArticleTypeConfigurations", "CustomKnowledgeArticleTypeConfigurations", properties.CustomKnowledgeArticleTypeConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnDataSourceSalesforceCustomKnowledgeArticleTypeConfigurationPropertyFromCloudFormation)(properties.CustomKnowledgeArticleTypeConfigurations) : void 0), ret.addPropertyResult("includedStates", "IncludedStates", cfn_parse.FromCloudFormation.getStringArray(properties.IncludedStates)), ret.addPropertyResult("standardKnowledgeArticleTypeConfiguration", "StandardKnowledgeArticleTypeConfiguration", properties.StandardKnowledgeArticleTypeConfiguration != null ? CfnDataSourceSalesforceStandardKnowledgeArticleTypeConfigurationPropertyFromCloudFormation(properties.StandardKnowledgeArticleTypeConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_SalesforceStandardKnowledgeArticleTypeConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("documentDataFieldName", cdk.requiredValidator)(properties.documentDataFieldName)), errors.collect(cdk.propertyValidator("documentDataFieldName", cdk.validateString)(properties.documentDataFieldName)), errors.collect(cdk.propertyValidator("documentTitleFieldName", cdk.validateString)(properties.documentTitleFieldName)), errors.collect(cdk.propertyValidator("fieldMappings", cdk.listValidator(CfnDataSource_DataSourceToIndexFieldMappingPropertyValidator))(properties.fieldMappings)), errors.wrap('supplied properties not correct for "SalesforceStandardKnowledgeArticleTypeConfigurationProperty"');
    }
    function cfnDataSourceSalesforceStandardKnowledgeArticleTypeConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_SalesforceStandardKnowledgeArticleTypeConfigurationPropertyValidator(properties).assertSuccess(), { DocumentDataFieldName: cdk.stringToCloudFormation(properties.documentDataFieldName), DocumentTitleFieldName: cdk.stringToCloudFormation(properties.documentTitleFieldName), FieldMappings: cdk.listMapper(cfnDataSourceDataSourceToIndexFieldMappingPropertyToCloudFormation)(properties.fieldMappings) }) : properties;
    }
    function CfnDataSourceSalesforceStandardKnowledgeArticleTypeConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("documentDataFieldName", "DocumentDataFieldName", cfn_parse.FromCloudFormation.getString(properties.DocumentDataFieldName)), ret.addPropertyResult("documentTitleFieldName", "DocumentTitleFieldName", properties.DocumentTitleFieldName != null ? cfn_parse.FromCloudFormation.getString(properties.DocumentTitleFieldName) : void 0), ret.addPropertyResult("fieldMappings", "FieldMappings", properties.FieldMappings != null ? cfn_parse.FromCloudFormation.getArray(CfnDataSourceDataSourceToIndexFieldMappingPropertyFromCloudFormation)(properties.FieldMappings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_SalesforceStandardObjectAttachmentConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("documentTitleFieldName", cdk.validateString)(properties.documentTitleFieldName)), errors.collect(cdk.propertyValidator("fieldMappings", cdk.listValidator(CfnDataSource_DataSourceToIndexFieldMappingPropertyValidator))(properties.fieldMappings)), errors.wrap('supplied properties not correct for "SalesforceStandardObjectAttachmentConfigurationProperty"');
    }
    function cfnDataSourceSalesforceStandardObjectAttachmentConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_SalesforceStandardObjectAttachmentConfigurationPropertyValidator(properties).assertSuccess(), { DocumentTitleFieldName: cdk.stringToCloudFormation(properties.documentTitleFieldName), FieldMappings: cdk.listMapper(cfnDataSourceDataSourceToIndexFieldMappingPropertyToCloudFormation)(properties.fieldMappings) }) : properties;
    }
    function CfnDataSourceSalesforceStandardObjectAttachmentConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("documentTitleFieldName", "DocumentTitleFieldName", properties.DocumentTitleFieldName != null ? cfn_parse.FromCloudFormation.getString(properties.DocumentTitleFieldName) : void 0), ret.addPropertyResult("fieldMappings", "FieldMappings", properties.FieldMappings != null ? cfn_parse.FromCloudFormation.getArray(CfnDataSourceDataSourceToIndexFieldMappingPropertyFromCloudFormation)(properties.FieldMappings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_SalesforceStandardObjectConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("documentDataFieldName", cdk.requiredValidator)(properties.documentDataFieldName)), errors.collect(cdk.propertyValidator("documentDataFieldName", cdk.validateString)(properties.documentDataFieldName)), errors.collect(cdk.propertyValidator("documentTitleFieldName", cdk.validateString)(properties.documentTitleFieldName)), errors.collect(cdk.propertyValidator("fieldMappings", cdk.listValidator(CfnDataSource_DataSourceToIndexFieldMappingPropertyValidator))(properties.fieldMappings)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "SalesforceStandardObjectConfigurationProperty"');
    }
    function cfnDataSourceSalesforceStandardObjectConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_SalesforceStandardObjectConfigurationPropertyValidator(properties).assertSuccess(), { DocumentDataFieldName: cdk.stringToCloudFormation(properties.documentDataFieldName), DocumentTitleFieldName: cdk.stringToCloudFormation(properties.documentTitleFieldName), FieldMappings: cdk.listMapper(cfnDataSourceDataSourceToIndexFieldMappingPropertyToCloudFormation)(properties.fieldMappings), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnDataSourceSalesforceStandardObjectConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("documentDataFieldName", "DocumentDataFieldName", cfn_parse.FromCloudFormation.getString(properties.DocumentDataFieldName)), ret.addPropertyResult("documentTitleFieldName", "DocumentTitleFieldName", properties.DocumentTitleFieldName != null ? cfn_parse.FromCloudFormation.getString(properties.DocumentTitleFieldName) : void 0), ret.addPropertyResult("fieldMappings", "FieldMappings", properties.FieldMappings != null ? cfn_parse.FromCloudFormation.getArray(CfnDataSourceDataSourceToIndexFieldMappingPropertyFromCloudFormation)(properties.FieldMappings) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_ServiceNowConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authenticationType", cdk.validateString)(properties.authenticationType)), errors.collect(cdk.propertyValidator("hostUrl", cdk.requiredValidator)(properties.hostUrl)), errors.collect(cdk.propertyValidator("hostUrl", cdk.validateString)(properties.hostUrl)), errors.collect(cdk.propertyValidator("knowledgeArticleConfiguration", CfnDataSource_ServiceNowKnowledgeArticleConfigurationPropertyValidator)(properties.knowledgeArticleConfiguration)), errors.collect(cdk.propertyValidator("secretArn", cdk.requiredValidator)(properties.secretArn)), errors.collect(cdk.propertyValidator("secretArn", cdk.validateString)(properties.secretArn)), errors.collect(cdk.propertyValidator("serviceCatalogConfiguration", CfnDataSource_ServiceNowServiceCatalogConfigurationPropertyValidator)(properties.serviceCatalogConfiguration)), errors.collect(cdk.propertyValidator("serviceNowBuildVersion", cdk.requiredValidator)(properties.serviceNowBuildVersion)), errors.collect(cdk.propertyValidator("serviceNowBuildVersion", cdk.validateString)(properties.serviceNowBuildVersion)), errors.wrap('supplied properties not correct for "ServiceNowConfigurationProperty"');
    }
    function cfnDataSourceServiceNowConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_ServiceNowConfigurationPropertyValidator(properties).assertSuccess(), { AuthenticationType: cdk.stringToCloudFormation(properties.authenticationType), HostUrl: cdk.stringToCloudFormation(properties.hostUrl), KnowledgeArticleConfiguration: cfnDataSourceServiceNowKnowledgeArticleConfigurationPropertyToCloudFormation(properties.knowledgeArticleConfiguration), SecretArn: cdk.stringToCloudFormation(properties.secretArn), ServiceCatalogConfiguration: cfnDataSourceServiceNowServiceCatalogConfigurationPropertyToCloudFormation(properties.serviceCatalogConfiguration), ServiceNowBuildVersion: cdk.stringToCloudFormation(properties.serviceNowBuildVersion) }) : properties;
    }
    function CfnDataSourceServiceNowConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authenticationType", "AuthenticationType", properties.AuthenticationType != null ? cfn_parse.FromCloudFormation.getString(properties.AuthenticationType) : void 0), ret.addPropertyResult("hostUrl", "HostUrl", cfn_parse.FromCloudFormation.getString(properties.HostUrl)), ret.addPropertyResult("knowledgeArticleConfiguration", "KnowledgeArticleConfiguration", properties.KnowledgeArticleConfiguration != null ? CfnDataSourceServiceNowKnowledgeArticleConfigurationPropertyFromCloudFormation(properties.KnowledgeArticleConfiguration) : void 0), ret.addPropertyResult("secretArn", "SecretArn", cfn_parse.FromCloudFormation.getString(properties.SecretArn)), ret.addPropertyResult("serviceCatalogConfiguration", "ServiceCatalogConfiguration", properties.ServiceCatalogConfiguration != null ? CfnDataSourceServiceNowServiceCatalogConfigurationPropertyFromCloudFormation(properties.ServiceCatalogConfiguration) : void 0), ret.addPropertyResult("serviceNowBuildVersion", "ServiceNowBuildVersion", cfn_parse.FromCloudFormation.getString(properties.ServiceNowBuildVersion)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_ServiceNowKnowledgeArticleConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("crawlAttachments", cdk.validateBoolean)(properties.crawlAttachments)), errors.collect(cdk.propertyValidator("documentDataFieldName", cdk.requiredValidator)(properties.documentDataFieldName)), errors.collect(cdk.propertyValidator("documentDataFieldName", cdk.validateString)(properties.documentDataFieldName)), errors.collect(cdk.propertyValidator("documentTitleFieldName", cdk.validateString)(properties.documentTitleFieldName)), errors.collect(cdk.propertyValidator("excludeAttachmentFilePatterns", cdk.listValidator(cdk.validateString))(properties.excludeAttachmentFilePatterns)), errors.collect(cdk.propertyValidator("fieldMappings", cdk.listValidator(CfnDataSource_DataSourceToIndexFieldMappingPropertyValidator))(properties.fieldMappings)), errors.collect(cdk.propertyValidator("filterQuery", cdk.validateString)(properties.filterQuery)), errors.collect(cdk.propertyValidator("includeAttachmentFilePatterns", cdk.listValidator(cdk.validateString))(properties.includeAttachmentFilePatterns)), errors.wrap('supplied properties not correct for "ServiceNowKnowledgeArticleConfigurationProperty"');
    }
    function cfnDataSourceServiceNowKnowledgeArticleConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_ServiceNowKnowledgeArticleConfigurationPropertyValidator(properties).assertSuccess(), { CrawlAttachments: cdk.booleanToCloudFormation(properties.crawlAttachments), DocumentDataFieldName: cdk.stringToCloudFormation(properties.documentDataFieldName), DocumentTitleFieldName: cdk.stringToCloudFormation(properties.documentTitleFieldName), ExcludeAttachmentFilePatterns: cdk.listMapper(cdk.stringToCloudFormation)(properties.excludeAttachmentFilePatterns), FieldMappings: cdk.listMapper(cfnDataSourceDataSourceToIndexFieldMappingPropertyToCloudFormation)(properties.fieldMappings), FilterQuery: cdk.stringToCloudFormation(properties.filterQuery), IncludeAttachmentFilePatterns: cdk.listMapper(cdk.stringToCloudFormation)(properties.includeAttachmentFilePatterns) }) : properties;
    }
    function CfnDataSourceServiceNowKnowledgeArticleConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("crawlAttachments", "CrawlAttachments", properties.CrawlAttachments != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CrawlAttachments) : void 0), ret.addPropertyResult("documentDataFieldName", "DocumentDataFieldName", cfn_parse.FromCloudFormation.getString(properties.DocumentDataFieldName)), ret.addPropertyResult("documentTitleFieldName", "DocumentTitleFieldName", properties.DocumentTitleFieldName != null ? cfn_parse.FromCloudFormation.getString(properties.DocumentTitleFieldName) : void 0), ret.addPropertyResult("excludeAttachmentFilePatterns", "ExcludeAttachmentFilePatterns", properties.ExcludeAttachmentFilePatterns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExcludeAttachmentFilePatterns) : void 0), ret.addPropertyResult("fieldMappings", "FieldMappings", properties.FieldMappings != null ? cfn_parse.FromCloudFormation.getArray(CfnDataSourceDataSourceToIndexFieldMappingPropertyFromCloudFormation)(properties.FieldMappings) : void 0), ret.addPropertyResult("filterQuery", "FilterQuery", properties.FilterQuery != null ? cfn_parse.FromCloudFormation.getString(properties.FilterQuery) : void 0), ret.addPropertyResult("includeAttachmentFilePatterns", "IncludeAttachmentFilePatterns", properties.IncludeAttachmentFilePatterns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.IncludeAttachmentFilePatterns) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_ServiceNowServiceCatalogConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("crawlAttachments", cdk.validateBoolean)(properties.crawlAttachments)), errors.collect(cdk.propertyValidator("documentDataFieldName", cdk.requiredValidator)(properties.documentDataFieldName)), errors.collect(cdk.propertyValidator("documentDataFieldName", cdk.validateString)(properties.documentDataFieldName)), errors.collect(cdk.propertyValidator("documentTitleFieldName", cdk.validateString)(properties.documentTitleFieldName)), errors.collect(cdk.propertyValidator("excludeAttachmentFilePatterns", cdk.listValidator(cdk.validateString))(properties.excludeAttachmentFilePatterns)), errors.collect(cdk.propertyValidator("fieldMappings", cdk.listValidator(CfnDataSource_DataSourceToIndexFieldMappingPropertyValidator))(properties.fieldMappings)), errors.collect(cdk.propertyValidator("includeAttachmentFilePatterns", cdk.listValidator(cdk.validateString))(properties.includeAttachmentFilePatterns)), errors.wrap('supplied properties not correct for "ServiceNowServiceCatalogConfigurationProperty"');
    }
    function cfnDataSourceServiceNowServiceCatalogConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_ServiceNowServiceCatalogConfigurationPropertyValidator(properties).assertSuccess(), { CrawlAttachments: cdk.booleanToCloudFormation(properties.crawlAttachments), DocumentDataFieldName: cdk.stringToCloudFormation(properties.documentDataFieldName), DocumentTitleFieldName: cdk.stringToCloudFormation(properties.documentTitleFieldName), ExcludeAttachmentFilePatterns: cdk.listMapper(cdk.stringToCloudFormation)(properties.excludeAttachmentFilePatterns), FieldMappings: cdk.listMapper(cfnDataSourceDataSourceToIndexFieldMappingPropertyToCloudFormation)(properties.fieldMappings), IncludeAttachmentFilePatterns: cdk.listMapper(cdk.stringToCloudFormation)(properties.includeAttachmentFilePatterns) }) : properties;
    }
    function CfnDataSourceServiceNowServiceCatalogConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("crawlAttachments", "CrawlAttachments", properties.CrawlAttachments != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CrawlAttachments) : void 0), ret.addPropertyResult("documentDataFieldName", "DocumentDataFieldName", cfn_parse.FromCloudFormation.getString(properties.DocumentDataFieldName)), ret.addPropertyResult("documentTitleFieldName", "DocumentTitleFieldName", properties.DocumentTitleFieldName != null ? cfn_parse.FromCloudFormation.getString(properties.DocumentTitleFieldName) : void 0), ret.addPropertyResult("excludeAttachmentFilePatterns", "ExcludeAttachmentFilePatterns", properties.ExcludeAttachmentFilePatterns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExcludeAttachmentFilePatterns) : void 0), ret.addPropertyResult("fieldMappings", "FieldMappings", properties.FieldMappings != null ? cfn_parse.FromCloudFormation.getArray(CfnDataSourceDataSourceToIndexFieldMappingPropertyFromCloudFormation)(properties.FieldMappings) : void 0), ret.addPropertyResult("includeAttachmentFilePatterns", "IncludeAttachmentFilePatterns", properties.IncludeAttachmentFilePatterns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.IncludeAttachmentFilePatterns) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_SharePointConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("crawlAttachments", cdk.validateBoolean)(properties.crawlAttachments)), errors.collect(cdk.propertyValidator("disableLocalGroups", cdk.validateBoolean)(properties.disableLocalGroups)), errors.collect(cdk.propertyValidator("documentTitleFieldName", cdk.validateString)(properties.documentTitleFieldName)), errors.collect(cdk.propertyValidator("exclusionPatterns", cdk.listValidator(cdk.validateString))(properties.exclusionPatterns)), errors.collect(cdk.propertyValidator("fieldMappings", cdk.listValidator(CfnDataSource_DataSourceToIndexFieldMappingPropertyValidator))(properties.fieldMappings)), errors.collect(cdk.propertyValidator("inclusionPatterns", cdk.listValidator(cdk.validateString))(properties.inclusionPatterns)), errors.collect(cdk.propertyValidator("secretArn", cdk.requiredValidator)(properties.secretArn)), errors.collect(cdk.propertyValidator("secretArn", cdk.validateString)(properties.secretArn)), errors.collect(cdk.propertyValidator("sharePointVersion", cdk.requiredValidator)(properties.sharePointVersion)), errors.collect(cdk.propertyValidator("sharePointVersion", cdk.validateString)(properties.sharePointVersion)), errors.collect(cdk.propertyValidator("sslCertificateS3Path", CfnDataSource_S3PathPropertyValidator)(properties.sslCertificateS3Path)), errors.collect(cdk.propertyValidator("urls", cdk.requiredValidator)(properties.urls)), errors.collect(cdk.propertyValidator("urls", cdk.listValidator(cdk.validateString))(properties.urls)), errors.collect(cdk.propertyValidator("useChangeLog", cdk.validateBoolean)(properties.useChangeLog)), errors.collect(cdk.propertyValidator("vpcConfiguration", CfnDataSource_DataSourceVpcConfigurationPropertyValidator)(properties.vpcConfiguration)), errors.wrap('supplied properties not correct for "SharePointConfigurationProperty"');
    }
    function cfnDataSourceSharePointConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_SharePointConfigurationPropertyValidator(properties).assertSuccess(), { CrawlAttachments: cdk.booleanToCloudFormation(properties.crawlAttachments), DisableLocalGroups: cdk.booleanToCloudFormation(properties.disableLocalGroups), DocumentTitleFieldName: cdk.stringToCloudFormation(properties.documentTitleFieldName), ExclusionPatterns: cdk.listMapper(cdk.stringToCloudFormation)(properties.exclusionPatterns), FieldMappings: cdk.listMapper(cfnDataSourceDataSourceToIndexFieldMappingPropertyToCloudFormation)(properties.fieldMappings), InclusionPatterns: cdk.listMapper(cdk.stringToCloudFormation)(properties.inclusionPatterns), SecretArn: cdk.stringToCloudFormation(properties.secretArn), SharePointVersion: cdk.stringToCloudFormation(properties.sharePointVersion), SslCertificateS3Path: cfnDataSourceS3PathPropertyToCloudFormation(properties.sslCertificateS3Path), Urls: cdk.listMapper(cdk.stringToCloudFormation)(properties.urls), UseChangeLog: cdk.booleanToCloudFormation(properties.useChangeLog), VpcConfiguration: cfnDataSourceDataSourceVpcConfigurationPropertyToCloudFormation(properties.vpcConfiguration) }) : properties;
    }
    function CfnDataSourceSharePointConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("crawlAttachments", "CrawlAttachments", properties.CrawlAttachments != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CrawlAttachments) : void 0), ret.addPropertyResult("disableLocalGroups", "DisableLocalGroups", properties.DisableLocalGroups != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DisableLocalGroups) : void 0), ret.addPropertyResult("documentTitleFieldName", "DocumentTitleFieldName", properties.DocumentTitleFieldName != null ? cfn_parse.FromCloudFormation.getString(properties.DocumentTitleFieldName) : void 0), ret.addPropertyResult("exclusionPatterns", "ExclusionPatterns", properties.ExclusionPatterns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExclusionPatterns) : void 0), ret.addPropertyResult("fieldMappings", "FieldMappings", properties.FieldMappings != null ? cfn_parse.FromCloudFormation.getArray(CfnDataSourceDataSourceToIndexFieldMappingPropertyFromCloudFormation)(properties.FieldMappings) : void 0), ret.addPropertyResult("inclusionPatterns", "InclusionPatterns", properties.InclusionPatterns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.InclusionPatterns) : void 0), ret.addPropertyResult("secretArn", "SecretArn", cfn_parse.FromCloudFormation.getString(properties.SecretArn)), ret.addPropertyResult("sharePointVersion", "SharePointVersion", cfn_parse.FromCloudFormation.getString(properties.SharePointVersion)), ret.addPropertyResult("sslCertificateS3Path", "SslCertificateS3Path", properties.SslCertificateS3Path != null ? CfnDataSourceS3PathPropertyFromCloudFormation(properties.SslCertificateS3Path) : void 0), ret.addPropertyResult("urls", "Urls", cfn_parse.FromCloudFormation.getStringArray(properties.Urls)), ret.addPropertyResult("useChangeLog", "UseChangeLog", properties.UseChangeLog != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseChangeLog) : void 0), ret.addPropertyResult("vpcConfiguration", "VpcConfiguration", properties.VpcConfiguration != null ? CfnDataSourceDataSourceVpcConfigurationPropertyFromCloudFormation(properties.VpcConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_SqlConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("queryIdentifiersEnclosingOption", cdk.validateString)(properties.queryIdentifiersEnclosingOption)), errors.wrap('supplied properties not correct for "SqlConfigurationProperty"');
    }
    function cfnDataSourceSqlConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_SqlConfigurationPropertyValidator(properties).assertSuccess(), { QueryIdentifiersEnclosingOption: cdk.stringToCloudFormation(properties.queryIdentifiersEnclosingOption) }) : properties;
    }
    function CfnDataSourceSqlConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("queryIdentifiersEnclosingOption", "QueryIdentifiersEnclosingOption", properties.QueryIdentifiersEnclosingOption != null ? cfn_parse.FromCloudFormation.getString(properties.QueryIdentifiersEnclosingOption) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_WebCrawlerAuthenticationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("basicAuthentication", cdk.listValidator(CfnDataSource_WebCrawlerBasicAuthenticationPropertyValidator))(properties.basicAuthentication)), errors.wrap('supplied properties not correct for "WebCrawlerAuthenticationConfigurationProperty"');
    }
    function cfnDataSourceWebCrawlerAuthenticationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_WebCrawlerAuthenticationConfigurationPropertyValidator(properties).assertSuccess(), { BasicAuthentication: cdk.listMapper(cfnDataSourceWebCrawlerBasicAuthenticationPropertyToCloudFormation)(properties.basicAuthentication) }) : properties;
    }
    function CfnDataSourceWebCrawlerAuthenticationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("basicAuthentication", "BasicAuthentication", properties.BasicAuthentication != null ? cfn_parse.FromCloudFormation.getArray(CfnDataSourceWebCrawlerBasicAuthenticationPropertyFromCloudFormation)(properties.BasicAuthentication) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_WebCrawlerBasicAuthenticationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("credentials", cdk.requiredValidator)(properties.credentials)), errors.collect(cdk.propertyValidator("credentials", cdk.validateString)(properties.credentials)), errors.collect(cdk.propertyValidator("host", cdk.requiredValidator)(properties.host)), errors.collect(cdk.propertyValidator("host", cdk.validateString)(properties.host)), errors.collect(cdk.propertyValidator("port", cdk.requiredValidator)(properties.port)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.wrap('supplied properties not correct for "WebCrawlerBasicAuthenticationProperty"');
    }
    function cfnDataSourceWebCrawlerBasicAuthenticationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_WebCrawlerBasicAuthenticationPropertyValidator(properties).assertSuccess(), { Credentials: cdk.stringToCloudFormation(properties.credentials), Host: cdk.stringToCloudFormation(properties.host), Port: cdk.numberToCloudFormation(properties.port) }) : properties;
    }
    function CfnDataSourceWebCrawlerBasicAuthenticationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("credentials", "Credentials", cfn_parse.FromCloudFormation.getString(properties.Credentials)), ret.addPropertyResult("host", "Host", cfn_parse.FromCloudFormation.getString(properties.Host)), ret.addPropertyResult("port", "Port", cfn_parse.FromCloudFormation.getNumber(properties.Port)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_WebCrawlerConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authenticationConfiguration", CfnDataSource_WebCrawlerAuthenticationConfigurationPropertyValidator)(properties.authenticationConfiguration)), errors.collect(cdk.propertyValidator("crawlDepth", cdk.validateNumber)(properties.crawlDepth)), errors.collect(cdk.propertyValidator("maxContentSizePerPageInMegaBytes", cdk.validateNumber)(properties.maxContentSizePerPageInMegaBytes)), errors.collect(cdk.propertyValidator("maxLinksPerPage", cdk.validateNumber)(properties.maxLinksPerPage)), errors.collect(cdk.propertyValidator("maxUrlsPerMinuteCrawlRate", cdk.validateNumber)(properties.maxUrlsPerMinuteCrawlRate)), errors.collect(cdk.propertyValidator("proxyConfiguration", CfnDataSource_ProxyConfigurationPropertyValidator)(properties.proxyConfiguration)), errors.collect(cdk.propertyValidator("urlExclusionPatterns", cdk.listValidator(cdk.validateString))(properties.urlExclusionPatterns)), errors.collect(cdk.propertyValidator("urlInclusionPatterns", cdk.listValidator(cdk.validateString))(properties.urlInclusionPatterns)), errors.collect(cdk.propertyValidator("urls", cdk.requiredValidator)(properties.urls)), errors.collect(cdk.propertyValidator("urls", CfnDataSource_WebCrawlerUrlsPropertyValidator)(properties.urls)), errors.wrap('supplied properties not correct for "WebCrawlerConfigurationProperty"');
    }
    function cfnDataSourceWebCrawlerConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_WebCrawlerConfigurationPropertyValidator(properties).assertSuccess(), { AuthenticationConfiguration: cfnDataSourceWebCrawlerAuthenticationConfigurationPropertyToCloudFormation(properties.authenticationConfiguration), CrawlDepth: cdk.numberToCloudFormation(properties.crawlDepth), MaxContentSizePerPageInMegaBytes: cdk.numberToCloudFormation(properties.maxContentSizePerPageInMegaBytes), MaxLinksPerPage: cdk.numberToCloudFormation(properties.maxLinksPerPage), MaxUrlsPerMinuteCrawlRate: cdk.numberToCloudFormation(properties.maxUrlsPerMinuteCrawlRate), ProxyConfiguration: cfnDataSourceProxyConfigurationPropertyToCloudFormation(properties.proxyConfiguration), UrlExclusionPatterns: cdk.listMapper(cdk.stringToCloudFormation)(properties.urlExclusionPatterns), UrlInclusionPatterns: cdk.listMapper(cdk.stringToCloudFormation)(properties.urlInclusionPatterns), Urls: cfnDataSourceWebCrawlerUrlsPropertyToCloudFormation(properties.urls) }) : properties;
    }
    function CfnDataSourceWebCrawlerConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authenticationConfiguration", "AuthenticationConfiguration", properties.AuthenticationConfiguration != null ? CfnDataSourceWebCrawlerAuthenticationConfigurationPropertyFromCloudFormation(properties.AuthenticationConfiguration) : void 0), ret.addPropertyResult("crawlDepth", "CrawlDepth", properties.CrawlDepth != null ? cfn_parse.FromCloudFormation.getNumber(properties.CrawlDepth) : void 0), ret.addPropertyResult("maxContentSizePerPageInMegaBytes", "MaxContentSizePerPageInMegaBytes", properties.MaxContentSizePerPageInMegaBytes != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxContentSizePerPageInMegaBytes) : void 0), ret.addPropertyResult("maxLinksPerPage", "MaxLinksPerPage", properties.MaxLinksPerPage != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxLinksPerPage) : void 0), ret.addPropertyResult("maxUrlsPerMinuteCrawlRate", "MaxUrlsPerMinuteCrawlRate", properties.MaxUrlsPerMinuteCrawlRate != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxUrlsPerMinuteCrawlRate) : void 0), ret.addPropertyResult("proxyConfiguration", "ProxyConfiguration", properties.ProxyConfiguration != null ? CfnDataSourceProxyConfigurationPropertyFromCloudFormation(properties.ProxyConfiguration) : void 0), ret.addPropertyResult("urlExclusionPatterns", "UrlExclusionPatterns", properties.UrlExclusionPatterns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.UrlExclusionPatterns) : void 0), ret.addPropertyResult("urlInclusionPatterns", "UrlInclusionPatterns", properties.UrlInclusionPatterns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.UrlInclusionPatterns) : void 0), ret.addPropertyResult("urls", "Urls", CfnDataSourceWebCrawlerUrlsPropertyFromCloudFormation(properties.Urls)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_WebCrawlerSeedUrlConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("seedUrls", cdk.requiredValidator)(properties.seedUrls)), errors.collect(cdk.propertyValidator("seedUrls", cdk.listValidator(cdk.validateString))(properties.seedUrls)), errors.collect(cdk.propertyValidator("webCrawlerMode", cdk.validateString)(properties.webCrawlerMode)), errors.wrap('supplied properties not correct for "WebCrawlerSeedUrlConfigurationProperty"');
    }
    function cfnDataSourceWebCrawlerSeedUrlConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_WebCrawlerSeedUrlConfigurationPropertyValidator(properties).assertSuccess(), { SeedUrls: cdk.listMapper(cdk.stringToCloudFormation)(properties.seedUrls), WebCrawlerMode: cdk.stringToCloudFormation(properties.webCrawlerMode) }) : properties;
    }
    function CfnDataSourceWebCrawlerSeedUrlConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("seedUrls", "SeedUrls", cfn_parse.FromCloudFormation.getStringArray(properties.SeedUrls)), ret.addPropertyResult("webCrawlerMode", "WebCrawlerMode", properties.WebCrawlerMode != null ? cfn_parse.FromCloudFormation.getString(properties.WebCrawlerMode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_WebCrawlerSiteMapsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("siteMaps", cdk.requiredValidator)(properties.siteMaps)), errors.collect(cdk.propertyValidator("siteMaps", cdk.listValidator(cdk.validateString))(properties.siteMaps)), errors.wrap('supplied properties not correct for "WebCrawlerSiteMapsConfigurationProperty"');
    }
    function cfnDataSourceWebCrawlerSiteMapsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_WebCrawlerSiteMapsConfigurationPropertyValidator(properties).assertSuccess(), { SiteMaps: cdk.listMapper(cdk.stringToCloudFormation)(properties.siteMaps) }) : properties;
    }
    function CfnDataSourceWebCrawlerSiteMapsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("siteMaps", "SiteMaps", cfn_parse.FromCloudFormation.getStringArray(properties.SiteMaps)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_WebCrawlerUrlsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("seedUrlConfiguration", CfnDataSource_WebCrawlerSeedUrlConfigurationPropertyValidator)(properties.seedUrlConfiguration)), errors.collect(cdk.propertyValidator("siteMapsConfiguration", CfnDataSource_WebCrawlerSiteMapsConfigurationPropertyValidator)(properties.siteMapsConfiguration)), errors.wrap('supplied properties not correct for "WebCrawlerUrlsProperty"');
    }
    function cfnDataSourceWebCrawlerUrlsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_WebCrawlerUrlsPropertyValidator(properties).assertSuccess(), { SeedUrlConfiguration: cfnDataSourceWebCrawlerSeedUrlConfigurationPropertyToCloudFormation(properties.seedUrlConfiguration), SiteMapsConfiguration: cfnDataSourceWebCrawlerSiteMapsConfigurationPropertyToCloudFormation(properties.siteMapsConfiguration) }) : properties;
    }
    function CfnDataSourceWebCrawlerUrlsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("seedUrlConfiguration", "SeedUrlConfiguration", properties.SeedUrlConfiguration != null ? CfnDataSourceWebCrawlerSeedUrlConfigurationPropertyFromCloudFormation(properties.SeedUrlConfiguration) : void 0), ret.addPropertyResult("siteMapsConfiguration", "SiteMapsConfiguration", properties.SiteMapsConfiguration != null ? CfnDataSourceWebCrawlerSiteMapsConfigurationPropertyFromCloudFormation(properties.SiteMapsConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_WorkDocsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("crawlComments", cdk.validateBoolean)(properties.crawlComments)), errors.collect(cdk.propertyValidator("exclusionPatterns", cdk.listValidator(cdk.validateString))(properties.exclusionPatterns)), errors.collect(cdk.propertyValidator("fieldMappings", cdk.listValidator(CfnDataSource_DataSourceToIndexFieldMappingPropertyValidator))(properties.fieldMappings)), errors.collect(cdk.propertyValidator("inclusionPatterns", cdk.listValidator(cdk.validateString))(properties.inclusionPatterns)), errors.collect(cdk.propertyValidator("organizationId", cdk.requiredValidator)(properties.organizationId)), errors.collect(cdk.propertyValidator("organizationId", cdk.validateString)(properties.organizationId)), errors.collect(cdk.propertyValidator("useChangeLog", cdk.validateBoolean)(properties.useChangeLog)), errors.wrap('supplied properties not correct for "WorkDocsConfigurationProperty"');
    }
    function cfnDataSourceWorkDocsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_WorkDocsConfigurationPropertyValidator(properties).assertSuccess(), { CrawlComments: cdk.booleanToCloudFormation(properties.crawlComments), ExclusionPatterns: cdk.listMapper(cdk.stringToCloudFormation)(properties.exclusionPatterns), FieldMappings: cdk.listMapper(cfnDataSourceDataSourceToIndexFieldMappingPropertyToCloudFormation)(properties.fieldMappings), InclusionPatterns: cdk.listMapper(cdk.stringToCloudFormation)(properties.inclusionPatterns), OrganizationId: cdk.stringToCloudFormation(properties.organizationId), UseChangeLog: cdk.booleanToCloudFormation(properties.useChangeLog) }) : properties;
    }
    function CfnDataSourceWorkDocsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("crawlComments", "CrawlComments", properties.CrawlComments != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CrawlComments) : void 0), ret.addPropertyResult("exclusionPatterns", "ExclusionPatterns", properties.ExclusionPatterns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExclusionPatterns) : void 0), ret.addPropertyResult("fieldMappings", "FieldMappings", properties.FieldMappings != null ? cfn_parse.FromCloudFormation.getArray(CfnDataSourceDataSourceToIndexFieldMappingPropertyFromCloudFormation)(properties.FieldMappings) : void 0), ret.addPropertyResult("inclusionPatterns", "InclusionPatterns", properties.InclusionPatterns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.InclusionPatterns) : void 0), ret.addPropertyResult("organizationId", "OrganizationId", cfn_parse.FromCloudFormation.getString(properties.OrganizationId)), ret.addPropertyResult("useChangeLog", "UseChangeLog", properties.UseChangeLog != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseChangeLog) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFaqPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("fileFormat", cdk.validateString)(properties.fileFormat)), errors.collect(cdk.propertyValidator("indexId", cdk.requiredValidator)(properties.indexId)), errors.collect(cdk.propertyValidator("indexId", cdk.validateString)(properties.indexId)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("s3Path", cdk.requiredValidator)(properties.s3Path)), errors.collect(cdk.propertyValidator("s3Path", CfnFaq_S3PathPropertyValidator)(properties.s3Path)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnFaqProps"');
    }
    function cfnFaqPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFaqPropsValidator(properties).assertSuccess(), { IndexId: cdk.stringToCloudFormation(properties.indexId), Name: cdk.stringToCloudFormation(properties.name), RoleArn: cdk.stringToCloudFormation(properties.roleArn), S3Path: cfnFaqS3PathPropertyToCloudFormation(properties.s3Path), Description: cdk.stringToCloudFormation(properties.description), FileFormat: cdk.stringToCloudFormation(properties.fileFormat), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnFaqPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("indexId", "IndexId", cfn_parse.FromCloudFormation.getString(properties.IndexId)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("s3Path", "S3Path", CfnFaqS3PathPropertyFromCloudFormation(properties.S3Path)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("fileFormat", "FileFormat", properties.FileFormat != null ? cfn_parse.FromCloudFormation.getString(properties.FileFormat) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFaq = class _CfnFaq extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFaqPropsFromCloudFormation(resourceProperties), ret = new _CfnFaq(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFaq.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kendra_CfnFaqProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFaq), error;
        }
        cdk.requireProperty(props, "indexId", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "roleArn", this), cdk.requireProperty(props, "s3Path", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.indexId = props.indexId, this.name = props.name, this.roleArn = props.roleArn, this.s3Path = props.s3Path, this.description = props.description, this.fileFormat = props.fileFormat, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Kendra::Faq", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFaq.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { indexId: this.indexId, name: this.name, roleArn: this.roleArn, s3Path: this.s3Path, description: this.description, fileFormat: this.fileFormat, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnFaqPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnFaq[_b] = { fqn: "aws-cdk-lib.aws_kendra.CfnFaq", version: "2.80.0" }, CfnFaq.CFN_RESOURCE_TYPE_NAME = "AWS::Kendra::Faq", exports2.CfnFaq = CfnFaq;
    function CfnFaq_S3PathPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.requiredValidator)(properties.bucket)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.wrap('supplied properties not correct for "S3PathProperty"');
    }
    function cfnFaqS3PathPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFaq_S3PathPropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), Key: cdk.stringToCloudFormation(properties.key) }) : properties;
    }
    function CfnFaqS3PathPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", cfn_parse.FromCloudFormation.getString(properties.Bucket)), ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIndexPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("capacityUnits", CfnIndex_CapacityUnitsConfigurationPropertyValidator)(properties.capacityUnits)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("documentMetadataConfigurations", cdk.listValidator(CfnIndex_DocumentMetadataConfigurationPropertyValidator))(properties.documentMetadataConfigurations)), errors.collect(cdk.propertyValidator("edition", cdk.requiredValidator)(properties.edition)), errors.collect(cdk.propertyValidator("edition", cdk.validateString)(properties.edition)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("serverSideEncryptionConfiguration", CfnIndex_ServerSideEncryptionConfigurationPropertyValidator)(properties.serverSideEncryptionConfiguration)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("userContextPolicy", cdk.validateString)(properties.userContextPolicy)), errors.collect(cdk.propertyValidator("userTokenConfigurations", cdk.listValidator(CfnIndex_UserTokenConfigurationPropertyValidator))(properties.userTokenConfigurations)), errors.wrap('supplied properties not correct for "CfnIndexProps"');
    }
    function cfnIndexPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIndexPropsValidator(properties).assertSuccess(), { Edition: cdk.stringToCloudFormation(properties.edition), Name: cdk.stringToCloudFormation(properties.name), RoleArn: cdk.stringToCloudFormation(properties.roleArn), CapacityUnits: cfnIndexCapacityUnitsConfigurationPropertyToCloudFormation(properties.capacityUnits), Description: cdk.stringToCloudFormation(properties.description), DocumentMetadataConfigurations: cdk.listMapper(cfnIndexDocumentMetadataConfigurationPropertyToCloudFormation)(properties.documentMetadataConfigurations), ServerSideEncryptionConfiguration: cfnIndexServerSideEncryptionConfigurationPropertyToCloudFormation(properties.serverSideEncryptionConfiguration), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), UserContextPolicy: cdk.stringToCloudFormation(properties.userContextPolicy), UserTokenConfigurations: cdk.listMapper(cfnIndexUserTokenConfigurationPropertyToCloudFormation)(properties.userTokenConfigurations) }) : properties;
    }
    function CfnIndexPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("edition", "Edition", cfn_parse.FromCloudFormation.getString(properties.Edition)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("capacityUnits", "CapacityUnits", properties.CapacityUnits != null ? CfnIndexCapacityUnitsConfigurationPropertyFromCloudFormation(properties.CapacityUnits) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("documentMetadataConfigurations", "DocumentMetadataConfigurations", properties.DocumentMetadataConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnIndexDocumentMetadataConfigurationPropertyFromCloudFormation)(properties.DocumentMetadataConfigurations) : void 0), ret.addPropertyResult("serverSideEncryptionConfiguration", "ServerSideEncryptionConfiguration", properties.ServerSideEncryptionConfiguration != null ? CfnIndexServerSideEncryptionConfigurationPropertyFromCloudFormation(properties.ServerSideEncryptionConfiguration) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("userContextPolicy", "UserContextPolicy", properties.UserContextPolicy != null ? cfn_parse.FromCloudFormation.getString(properties.UserContextPolicy) : void 0), ret.addPropertyResult("userTokenConfigurations", "UserTokenConfigurations", properties.UserTokenConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnIndexUserTokenConfigurationPropertyFromCloudFormation)(properties.UserTokenConfigurations) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnIndex = class _CfnIndex extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnIndexPropsFromCloudFormation(resourceProperties), ret = new _CfnIndex(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnIndex.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kendra_CfnIndexProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnIndex), error;
        }
        cdk.requireProperty(props, "edition", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "roleArn", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.edition = props.edition, this.name = props.name, this.roleArn = props.roleArn, this.capacityUnits = props.capacityUnits, this.description = props.description, this.documentMetadataConfigurations = props.documentMetadataConfigurations, this.serverSideEncryptionConfiguration = props.serverSideEncryptionConfiguration, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Kendra::Index", props.tags, { tagPropertyName: "tags" }), this.userContextPolicy = props.userContextPolicy, this.userTokenConfigurations = props.userTokenConfigurations;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnIndex.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { edition: this.edition, name: this.name, roleArn: this.roleArn, capacityUnits: this.capacityUnits, description: this.description, documentMetadataConfigurations: this.documentMetadataConfigurations, serverSideEncryptionConfiguration: this.serverSideEncryptionConfiguration, tags: this.tags.renderTags(), userContextPolicy: this.userContextPolicy, userTokenConfigurations: this.userTokenConfigurations };
      }
      renderProperties(props) {
        return cfnIndexPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnIndex[_c] = { fqn: "aws-cdk-lib.aws_kendra.CfnIndex", version: "2.80.0" }, CfnIndex.CFN_RESOURCE_TYPE_NAME = "AWS::Kendra::Index", exports2.CfnIndex = CfnIndex;
    function CfnIndex_CapacityUnitsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("queryCapacityUnits", cdk.requiredValidator)(properties.queryCapacityUnits)), errors.collect(cdk.propertyValidator("queryCapacityUnits", cdk.validateNumber)(properties.queryCapacityUnits)), errors.collect(cdk.propertyValidator("storageCapacityUnits", cdk.requiredValidator)(properties.storageCapacityUnits)), errors.collect(cdk.propertyValidator("storageCapacityUnits", cdk.validateNumber)(properties.storageCapacityUnits)), errors.wrap('supplied properties not correct for "CapacityUnitsConfigurationProperty"');
    }
    function cfnIndexCapacityUnitsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIndex_CapacityUnitsConfigurationPropertyValidator(properties).assertSuccess(), { QueryCapacityUnits: cdk.numberToCloudFormation(properties.queryCapacityUnits), StorageCapacityUnits: cdk.numberToCloudFormation(properties.storageCapacityUnits) }) : properties;
    }
    function CfnIndexCapacityUnitsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("queryCapacityUnits", "QueryCapacityUnits", cfn_parse.FromCloudFormation.getNumber(properties.QueryCapacityUnits)), ret.addPropertyResult("storageCapacityUnits", "StorageCapacityUnits", cfn_parse.FromCloudFormation.getNumber(properties.StorageCapacityUnits)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIndex_DocumentMetadataConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("relevance", CfnIndex_RelevancePropertyValidator)(properties.relevance)), errors.collect(cdk.propertyValidator("search", CfnIndex_SearchPropertyValidator)(properties.search)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "DocumentMetadataConfigurationProperty"');
    }
    function cfnIndexDocumentMetadataConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIndex_DocumentMetadataConfigurationPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Relevance: cfnIndexRelevancePropertyToCloudFormation(properties.relevance), Search: cfnIndexSearchPropertyToCloudFormation(properties.search), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnIndexDocumentMetadataConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("relevance", "Relevance", properties.Relevance != null ? CfnIndexRelevancePropertyFromCloudFormation(properties.Relevance) : void 0), ret.addPropertyResult("search", "Search", properties.Search != null ? CfnIndexSearchPropertyFromCloudFormation(properties.Search) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIndex_JsonTokenTypeConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groupAttributeField", cdk.requiredValidator)(properties.groupAttributeField)), errors.collect(cdk.propertyValidator("groupAttributeField", cdk.validateString)(properties.groupAttributeField)), errors.collect(cdk.propertyValidator("userNameAttributeField", cdk.requiredValidator)(properties.userNameAttributeField)), errors.collect(cdk.propertyValidator("userNameAttributeField", cdk.validateString)(properties.userNameAttributeField)), errors.wrap('supplied properties not correct for "JsonTokenTypeConfigurationProperty"');
    }
    function cfnIndexJsonTokenTypeConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIndex_JsonTokenTypeConfigurationPropertyValidator(properties).assertSuccess(), { GroupAttributeField: cdk.stringToCloudFormation(properties.groupAttributeField), UserNameAttributeField: cdk.stringToCloudFormation(properties.userNameAttributeField) }) : properties;
    }
    function CfnIndexJsonTokenTypeConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupAttributeField", "GroupAttributeField", cfn_parse.FromCloudFormation.getString(properties.GroupAttributeField)), ret.addPropertyResult("userNameAttributeField", "UserNameAttributeField", cfn_parse.FromCloudFormation.getString(properties.UserNameAttributeField)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIndex_JwtTokenTypeConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("claimRegex", cdk.validateString)(properties.claimRegex)), errors.collect(cdk.propertyValidator("groupAttributeField", cdk.validateString)(properties.groupAttributeField)), errors.collect(cdk.propertyValidator("issuer", cdk.validateString)(properties.issuer)), errors.collect(cdk.propertyValidator("keyLocation", cdk.requiredValidator)(properties.keyLocation)), errors.collect(cdk.propertyValidator("keyLocation", cdk.validateString)(properties.keyLocation)), errors.collect(cdk.propertyValidator("secretManagerArn", cdk.validateString)(properties.secretManagerArn)), errors.collect(cdk.propertyValidator("url", cdk.validateString)(properties.url)), errors.collect(cdk.propertyValidator("userNameAttributeField", cdk.validateString)(properties.userNameAttributeField)), errors.wrap('supplied properties not correct for "JwtTokenTypeConfigurationProperty"');
    }
    function cfnIndexJwtTokenTypeConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIndex_JwtTokenTypeConfigurationPropertyValidator(properties).assertSuccess(), { ClaimRegex: cdk.stringToCloudFormation(properties.claimRegex), GroupAttributeField: cdk.stringToCloudFormation(properties.groupAttributeField), Issuer: cdk.stringToCloudFormation(properties.issuer), KeyLocation: cdk.stringToCloudFormation(properties.keyLocation), SecretManagerArn: cdk.stringToCloudFormation(properties.secretManagerArn), URL: cdk.stringToCloudFormation(properties.url), UserNameAttributeField: cdk.stringToCloudFormation(properties.userNameAttributeField) }) : properties;
    }
    function CfnIndexJwtTokenTypeConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("claimRegex", "ClaimRegex", properties.ClaimRegex != null ? cfn_parse.FromCloudFormation.getString(properties.ClaimRegex) : void 0), ret.addPropertyResult("groupAttributeField", "GroupAttributeField", properties.GroupAttributeField != null ? cfn_parse.FromCloudFormation.getString(properties.GroupAttributeField) : void 0), ret.addPropertyResult("issuer", "Issuer", properties.Issuer != null ? cfn_parse.FromCloudFormation.getString(properties.Issuer) : void 0), ret.addPropertyResult("keyLocation", "KeyLocation", cfn_parse.FromCloudFormation.getString(properties.KeyLocation)), ret.addPropertyResult("secretManagerArn", "SecretManagerArn", properties.SecretManagerArn != null ? cfn_parse.FromCloudFormation.getString(properties.SecretManagerArn) : void 0), ret.addPropertyResult("url", "URL", properties.URL != null ? cfn_parse.FromCloudFormation.getString(properties.URL) : void 0), ret.addPropertyResult("userNameAttributeField", "UserNameAttributeField", properties.UserNameAttributeField != null ? cfn_parse.FromCloudFormation.getString(properties.UserNameAttributeField) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIndex_RelevancePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("duration", cdk.validateString)(properties.duration)), errors.collect(cdk.propertyValidator("freshness", cdk.validateBoolean)(properties.freshness)), errors.collect(cdk.propertyValidator("importance", cdk.validateNumber)(properties.importance)), errors.collect(cdk.propertyValidator("rankOrder", cdk.validateString)(properties.rankOrder)), errors.collect(cdk.propertyValidator("valueImportanceItems", cdk.listValidator(CfnIndex_ValueImportanceItemPropertyValidator))(properties.valueImportanceItems)), errors.wrap('supplied properties not correct for "RelevanceProperty"');
    }
    function cfnIndexRelevancePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIndex_RelevancePropertyValidator(properties).assertSuccess(), { Duration: cdk.stringToCloudFormation(properties.duration), Freshness: cdk.booleanToCloudFormation(properties.freshness), Importance: cdk.numberToCloudFormation(properties.importance), RankOrder: cdk.stringToCloudFormation(properties.rankOrder), ValueImportanceItems: cdk.listMapper(cfnIndexValueImportanceItemPropertyToCloudFormation)(properties.valueImportanceItems) }) : properties;
    }
    function CfnIndexRelevancePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("duration", "Duration", properties.Duration != null ? cfn_parse.FromCloudFormation.getString(properties.Duration) : void 0), ret.addPropertyResult("freshness", "Freshness", properties.Freshness != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Freshness) : void 0), ret.addPropertyResult("importance", "Importance", properties.Importance != null ? cfn_parse.FromCloudFormation.getNumber(properties.Importance) : void 0), ret.addPropertyResult("rankOrder", "RankOrder", properties.RankOrder != null ? cfn_parse.FromCloudFormation.getString(properties.RankOrder) : void 0), ret.addPropertyResult("valueImportanceItems", "ValueImportanceItems", properties.ValueImportanceItems != null ? cfn_parse.FromCloudFormation.getArray(CfnIndexValueImportanceItemPropertyFromCloudFormation)(properties.ValueImportanceItems) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIndex_SearchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("displayable", cdk.validateBoolean)(properties.displayable)), errors.collect(cdk.propertyValidator("facetable", cdk.validateBoolean)(properties.facetable)), errors.collect(cdk.propertyValidator("searchable", cdk.validateBoolean)(properties.searchable)), errors.collect(cdk.propertyValidator("sortable", cdk.validateBoolean)(properties.sortable)), errors.wrap('supplied properties not correct for "SearchProperty"');
    }
    function cfnIndexSearchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIndex_SearchPropertyValidator(properties).assertSuccess(), { Displayable: cdk.booleanToCloudFormation(properties.displayable), Facetable: cdk.booleanToCloudFormation(properties.facetable), Searchable: cdk.booleanToCloudFormation(properties.searchable), Sortable: cdk.booleanToCloudFormation(properties.sortable) }) : properties;
    }
    function CfnIndexSearchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("displayable", "Displayable", properties.Displayable != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Displayable) : void 0), ret.addPropertyResult("facetable", "Facetable", properties.Facetable != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Facetable) : void 0), ret.addPropertyResult("searchable", "Searchable", properties.Searchable != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Searchable) : void 0), ret.addPropertyResult("sortable", "Sortable", properties.Sortable != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Sortable) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIndex_ServerSideEncryptionConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.wrap('supplied properties not correct for "ServerSideEncryptionConfigurationProperty"');
    }
    function cfnIndexServerSideEncryptionConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIndex_ServerSideEncryptionConfigurationPropertyValidator(properties).assertSuccess(), { KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId) }) : properties;
    }
    function CfnIndexServerSideEncryptionConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIndex_UserTokenConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("jsonTokenTypeConfiguration", CfnIndex_JsonTokenTypeConfigurationPropertyValidator)(properties.jsonTokenTypeConfiguration)), errors.collect(cdk.propertyValidator("jwtTokenTypeConfiguration", CfnIndex_JwtTokenTypeConfigurationPropertyValidator)(properties.jwtTokenTypeConfiguration)), errors.wrap('supplied properties not correct for "UserTokenConfigurationProperty"');
    }
    function cfnIndexUserTokenConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIndex_UserTokenConfigurationPropertyValidator(properties).assertSuccess(), { JsonTokenTypeConfiguration: cfnIndexJsonTokenTypeConfigurationPropertyToCloudFormation(properties.jsonTokenTypeConfiguration), JwtTokenTypeConfiguration: cfnIndexJwtTokenTypeConfigurationPropertyToCloudFormation(properties.jwtTokenTypeConfiguration) }) : properties;
    }
    function CfnIndexUserTokenConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("jsonTokenTypeConfiguration", "JsonTokenTypeConfiguration", properties.JsonTokenTypeConfiguration != null ? CfnIndexJsonTokenTypeConfigurationPropertyFromCloudFormation(properties.JsonTokenTypeConfiguration) : void 0), ret.addPropertyResult("jwtTokenTypeConfiguration", "JwtTokenTypeConfiguration", properties.JwtTokenTypeConfiguration != null ? CfnIndexJwtTokenTypeConfigurationPropertyFromCloudFormation(properties.JwtTokenTypeConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIndex_ValueImportanceItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "ValueImportanceItemProperty"');
    }
    function cfnIndexValueImportanceItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIndex_ValueImportanceItemPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnIndexValueImportanceItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getNumber(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-kendra/lib/index.js
var require_lib163 = __commonJS({
  "node_modules/aws-cdk-lib/aws-kendra/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_kendra_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-kendra/index.js
var require_aws_kendra = __commonJS({
  "node_modules/aws-cdk-lib/aws-kendra/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib163(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-kendraranking/lib/kendraranking.generated.js
var require_kendraranking_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-kendraranking/lib/kendraranking.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnExecutionPlan = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnExecutionPlanPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("capacityUnits", CfnExecutionPlan_CapacityUnitsConfigurationPropertyValidator)(properties.capacityUnits)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnExecutionPlanProps"');
    }
    function cfnExecutionPlanPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnExecutionPlanPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), CapacityUnits: cfnExecutionPlanCapacityUnitsConfigurationPropertyToCloudFormation(properties.capacityUnits), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnExecutionPlanPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("capacityUnits", "CapacityUnits", properties.CapacityUnits != null ? CfnExecutionPlanCapacityUnitsConfigurationPropertyFromCloudFormation(properties.CapacityUnits) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnExecutionPlan = class _CfnExecutionPlan extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnExecutionPlanPropsFromCloudFormation(resourceProperties), ret = new _CfnExecutionPlan(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnExecutionPlan.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kendraranking_CfnExecutionPlanProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnExecutionPlan), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.capacityUnits = props.capacityUnits, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::KendraRanking::ExecutionPlan", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnExecutionPlan.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, capacityUnits: this.capacityUnits, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnExecutionPlanPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnExecutionPlan[_a] = { fqn: "aws-cdk-lib.aws_kendraranking.CfnExecutionPlan", version: "2.80.0" }, CfnExecutionPlan.CFN_RESOURCE_TYPE_NAME = "AWS::KendraRanking::ExecutionPlan", exports2.CfnExecutionPlan = CfnExecutionPlan;
    function CfnExecutionPlan_CapacityUnitsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("rescoreCapacityUnits", cdk.requiredValidator)(properties.rescoreCapacityUnits)), errors.collect(cdk.propertyValidator("rescoreCapacityUnits", cdk.validateNumber)(properties.rescoreCapacityUnits)), errors.wrap('supplied properties not correct for "CapacityUnitsConfigurationProperty"');
    }
    function cfnExecutionPlanCapacityUnitsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnExecutionPlan_CapacityUnitsConfigurationPropertyValidator(properties).assertSuccess(), { RescoreCapacityUnits: cdk.numberToCloudFormation(properties.rescoreCapacityUnits) }) : properties;
    }
    function CfnExecutionPlanCapacityUnitsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("rescoreCapacityUnits", "RescoreCapacityUnits", cfn_parse.FromCloudFormation.getNumber(properties.RescoreCapacityUnits)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-kendraranking/lib/index.js
var require_lib164 = __commonJS({
  "node_modules/aws-cdk-lib/aws-kendraranking/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_kendraranking_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-kendraranking/index.js
var require_aws_kendraranking = __commonJS({
  "node_modules/aws-cdk-lib/aws-kendraranking/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib164(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-kinesis/lib/kinesis-canned-metrics.generated.js
var require_kinesis_canned_metrics_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-kinesis/lib/kinesis-canned-metrics.generated.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.KinesisMetrics = void 0;
    var KinesisMetrics = class {
      static readProvisionedThroughputExceededSum(dimensions) {
        return { namespace: "AWS/Kinesis", metricName: "ReadProvisionedThroughputExceeded", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static writeProvisionedThroughputExceededSum(dimensions) {
        return { namespace: "AWS/Kinesis", metricName: "WriteProvisionedThroughputExceeded", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static getRecordsIteratorAgeMillisecondsMaximum(dimensions) {
        return { namespace: "AWS/Kinesis", metricName: "GetRecords.IteratorAgeMilliseconds", dimensionsMap: dimensions, statistic: "Maximum" };
      }
      static putRecordSuccessSum(dimensions) {
        return { namespace: "AWS/Kinesis", metricName: "PutRecord.Success", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static putRecordsSuccessSum(dimensions) {
        return { namespace: "AWS/Kinesis", metricName: "PutRecords.Success", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static putRecordsBytesSum(dimensions) {
        return { namespace: "AWS/Kinesis", metricName: "PutRecords.Bytes", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static getRecordsSuccessSum(dimensions) {
        return { namespace: "AWS/Kinesis", metricName: "GetRecords.Success", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static getRecordsBytesSum(dimensions) {
        return { namespace: "AWS/Kinesis", metricName: "GetRecords.Bytes", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static getRecordsRecordsSum(dimensions) {
        return { namespace: "AWS/Kinesis", metricName: "GetRecords.Records", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static getRecordsLatencyMaximum(dimensions) {
        return { namespace: "AWS/Kinesis", metricName: "GetRecords.Latency", dimensionsMap: dimensions, statistic: "Maximum" };
      }
      static incomingBytesSum(dimensions) {
        return { namespace: "AWS/Kinesis", metricName: "IncomingBytes", dimensionsMap: dimensions, statistic: "Sum" };
      }
      static incomingRecordsSum(dimensions) {
        return { namespace: "AWS/Kinesis", metricName: "IncomingRecords", dimensionsMap: dimensions, statistic: "Sum" };
      }
    };
    exports2.KinesisMetrics = KinesisMetrics;
  }
});

// node_modules/aws-cdk-lib/aws-kinesis/lib/kinesis-fixed-canned-metrics.js
var require_kinesis_fixed_canned_metrics = __commonJS({
  "node_modules/aws-cdk-lib/aws-kinesis/lib/kinesis-fixed-canned-metrics.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.KinesisMetrics = void 0;
    var kinesis_canned_metrics_generated_1 = require_kinesis_canned_metrics_generated();
    var KinesisMetrics = class {
      static getRecordsBytesAverage(dimensions) {
        return { namespace: "AWS/Kinesis", metricName: "GetRecords.Bytes", dimensionsMap: dimensions, statistic: "Average" };
      }
      static getRecordsSuccessAverage(dimensions) {
        return { namespace: "AWS/Kinesis", metricName: "GetRecords.Success", dimensionsMap: dimensions, statistic: "Average" };
      }
      static getRecordsRecordsAverage(dimensions) {
        return { namespace: "AWS/Kinesis", metricName: "GetRecords.Records", dimensionsMap: dimensions, statistic: "Average" };
      }
      static getRecordsLatencyAverage(dimensions) {
        return { namespace: "AWS/Kinesis", metricName: "GetRecords.Latency", dimensionsMap: dimensions, statistic: "Average" };
      }
      static putRecordBytesAverage(dimensions) {
        return { namespace: "AWS/Kinesis", metricName: "PutRecord.Bytes", dimensionsMap: dimensions, statistic: "Average" };
      }
      static putRecordLatencyAverage(dimensions) {
        return { namespace: "AWS/Kinesis", metricName: "PutRecord.Latency", dimensionsMap: dimensions, statistic: "Average" };
      }
      static getRecordsIteratorAgeMillisecondsMaximum(dimensions) {
        return kinesis_canned_metrics_generated_1.KinesisMetrics.getRecordsIteratorAgeMillisecondsMaximum(dimensions);
      }
      static putRecordSuccessAverage(dimensions) {
        return { ...kinesis_canned_metrics_generated_1.KinesisMetrics.putRecordSuccessSum(dimensions), statistic: "Average" };
      }
      static putRecordsBytesAverage(dimensions) {
        return { ...kinesis_canned_metrics_generated_1.KinesisMetrics.putRecordsBytesSum(dimensions), statistic: "Average" };
      }
      static putRecordsLatencyAverage(dimensions) {
        return { namespace: "AWS/Kinesis", metricName: "PutRecords.Latency", dimensionsMap: dimensions, statistic: "Average" };
      }
      static putRecordsSuccessAverage(dimensions) {
        return { namespace: "AWS/Kinesis", metricName: "PutRecords.Success", dimensionsMap: dimensions, statistic: "Average" };
      }
      static putRecordsTotalRecordsAverage(dimensions) {
        return { namespace: "AWS/Kinesis", metricName: "PutRecords.TotalRecords", dimensionsMap: dimensions, statistic: "Average" };
      }
      static putRecordsSuccessfulRecordsAverage(dimensions) {
        return { namespace: "AWS/Kinesis", metricName: "PutRecords.SuccessfulRecords", dimensionsMap: dimensions, statistic: "Average" };
      }
      static putRecordsFailedRecordsAverage(dimensions) {
        return { namespace: "AWS/Kinesis", metricName: "PutRecords.FailedRecords", dimensionsMap: dimensions, statistic: "Average" };
      }
      static putRecordsThrottledRecordsAverage(dimensions) {
        return { namespace: "AWS/Kinesis", metricName: "PutRecords.ThrottledRecords", dimensionsMap: dimensions, statistic: "Average" };
      }
      static incomingBytesAverage(dimensions) {
        return { ...kinesis_canned_metrics_generated_1.KinesisMetrics.incomingBytesSum(dimensions), statistic: "Average" };
      }
      static incomingRecordsAverage(dimensions) {
        return { ...kinesis_canned_metrics_generated_1.KinesisMetrics.incomingRecordsSum(dimensions), statistic: "Average" };
      }
      static readProvisionedThroughputExceededAverage(dimensions) {
        return { ...kinesis_canned_metrics_generated_1.KinesisMetrics.readProvisionedThroughputExceededSum(dimensions), statistic: "Average" };
      }
      static writeProvisionedThroughputExceededAverage(dimensions) {
        return { ...kinesis_canned_metrics_generated_1.KinesisMetrics.writeProvisionedThroughputExceededSum(dimensions), statistic: "Average" };
      }
    };
    exports2.KinesisMetrics = KinesisMetrics;
  }
});

// node_modules/aws-cdk-lib/aws-kinesis/lib/kinesis.generated.js
var require_kinesis_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-kinesis/lib/kinesis.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnStreamConsumer = exports2.CfnStream = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnStreamPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("retentionPeriodHours", cdk.validateNumber)(properties.retentionPeriodHours)), errors.collect(cdk.propertyValidator("shardCount", cdk.validateNumber)(properties.shardCount)), errors.collect(cdk.propertyValidator("streamEncryption", CfnStream_StreamEncryptionPropertyValidator)(properties.streamEncryption)), errors.collect(cdk.propertyValidator("streamModeDetails", CfnStream_StreamModeDetailsPropertyValidator)(properties.streamModeDetails)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnStreamProps"');
    }
    function cfnStreamPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStreamPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), RetentionPeriodHours: cdk.numberToCloudFormation(properties.retentionPeriodHours), ShardCount: cdk.numberToCloudFormation(properties.shardCount), StreamEncryption: cfnStreamStreamEncryptionPropertyToCloudFormation(properties.streamEncryption), StreamModeDetails: cfnStreamStreamModeDetailsPropertyToCloudFormation(properties.streamModeDetails), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnStreamPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("retentionPeriodHours", "RetentionPeriodHours", properties.RetentionPeriodHours != null ? cfn_parse.FromCloudFormation.getNumber(properties.RetentionPeriodHours) : void 0), ret.addPropertyResult("shardCount", "ShardCount", properties.ShardCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.ShardCount) : void 0), ret.addPropertyResult("streamEncryption", "StreamEncryption", properties.StreamEncryption != null ? CfnStreamStreamEncryptionPropertyFromCloudFormation(properties.StreamEncryption) : void 0), ret.addPropertyResult("streamModeDetails", "StreamModeDetails", properties.StreamModeDetails != null ? CfnStreamStreamModeDetailsPropertyFromCloudFormation(properties.StreamModeDetails) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnStream = class _CfnStream extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnStreamPropsFromCloudFormation(resourceProperties), ret = new _CfnStream(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnStream.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kinesis_CfnStreamProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnStream), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.retentionPeriodHours = props.retentionPeriodHours, this.shardCount = props.shardCount, this.streamEncryption = props.streamEncryption, this.streamModeDetails = props.streamModeDetails, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Kinesis::Stream", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStream.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, retentionPeriodHours: this.retentionPeriodHours, shardCount: this.shardCount, streamEncryption: this.streamEncryption, streamModeDetails: this.streamModeDetails, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnStreamPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnStream[_a] = { fqn: "aws-cdk-lib.aws_kinesis.CfnStream", version: "2.80.0" }, CfnStream.CFN_RESOURCE_TYPE_NAME = "AWS::Kinesis::Stream", exports2.CfnStream = CfnStream;
    function CfnStream_StreamEncryptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("encryptionType", cdk.requiredValidator)(properties.encryptionType)), errors.collect(cdk.propertyValidator("encryptionType", cdk.validateString)(properties.encryptionType)), errors.collect(cdk.propertyValidator("keyId", cdk.requiredValidator)(properties.keyId)), errors.collect(cdk.propertyValidator("keyId", cdk.validateString)(properties.keyId)), errors.wrap('supplied properties not correct for "StreamEncryptionProperty"');
    }
    function cfnStreamStreamEncryptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStream_StreamEncryptionPropertyValidator(properties).assertSuccess(), { EncryptionType: cdk.stringToCloudFormation(properties.encryptionType), KeyId: cdk.stringToCloudFormation(properties.keyId) }) : properties;
    }
    function CfnStreamStreamEncryptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("encryptionType", "EncryptionType", cfn_parse.FromCloudFormation.getString(properties.EncryptionType)), ret.addPropertyResult("keyId", "KeyId", cfn_parse.FromCloudFormation.getString(properties.KeyId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStream_StreamModeDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("streamMode", cdk.requiredValidator)(properties.streamMode)), errors.collect(cdk.propertyValidator("streamMode", cdk.validateString)(properties.streamMode)), errors.wrap('supplied properties not correct for "StreamModeDetailsProperty"');
    }
    function cfnStreamStreamModeDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStream_StreamModeDetailsPropertyValidator(properties).assertSuccess(), { StreamMode: cdk.stringToCloudFormation(properties.streamMode) }) : properties;
    }
    function CfnStreamStreamModeDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("streamMode", "StreamMode", cfn_parse.FromCloudFormation.getString(properties.StreamMode)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStreamConsumerPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("consumerName", cdk.requiredValidator)(properties.consumerName)), errors.collect(cdk.propertyValidator("consumerName", cdk.validateString)(properties.consumerName)), errors.collect(cdk.propertyValidator("streamArn", cdk.requiredValidator)(properties.streamArn)), errors.collect(cdk.propertyValidator("streamArn", cdk.validateString)(properties.streamArn)), errors.wrap('supplied properties not correct for "CfnStreamConsumerProps"');
    }
    function cfnStreamConsumerPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStreamConsumerPropsValidator(properties).assertSuccess(), { ConsumerName: cdk.stringToCloudFormation(properties.consumerName), StreamARN: cdk.stringToCloudFormation(properties.streamArn) }) : properties;
    }
    function CfnStreamConsumerPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("consumerName", "ConsumerName", cfn_parse.FromCloudFormation.getString(properties.ConsumerName)), ret.addPropertyResult("streamArn", "StreamARN", cfn_parse.FromCloudFormation.getString(properties.StreamARN)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnStreamConsumer = class _CfnStreamConsumer extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnStreamConsumerPropsFromCloudFormation(resourceProperties), ret = new _CfnStreamConsumer(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnStreamConsumer.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kinesis_CfnStreamConsumerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnStreamConsumer), error;
        }
        cdk.requireProperty(props, "consumerName", this), cdk.requireProperty(props, "streamArn", this), this.attrConsumerArn = cdk.Token.asString(this.getAtt("ConsumerARN", cdk.ResolutionTypeHint.STRING)), this.attrConsumerCreationTimestamp = cdk.Token.asString(this.getAtt("ConsumerCreationTimestamp", cdk.ResolutionTypeHint.STRING)), this.attrConsumerName = cdk.Token.asString(this.getAtt("ConsumerName", cdk.ResolutionTypeHint.STRING)), this.attrConsumerStatus = cdk.Token.asString(this.getAtt("ConsumerStatus", cdk.ResolutionTypeHint.STRING)), this.attrStreamArn = cdk.Token.asString(this.getAtt("StreamARN", cdk.ResolutionTypeHint.STRING)), this.consumerName = props.consumerName, this.streamArn = props.streamArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStreamConsumer.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { consumerName: this.consumerName, streamArn: this.streamArn };
      }
      renderProperties(props) {
        return cfnStreamConsumerPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnStreamConsumer[_b] = { fqn: "aws-cdk-lib.aws_kinesis.CfnStreamConsumer", version: "2.80.0" }, CfnStreamConsumer.CFN_RESOURCE_TYPE_NAME = "AWS::Kinesis::StreamConsumer", exports2.CfnStreamConsumer = CfnStreamConsumer;
  }
});

// node_modules/aws-cdk-lib/aws-kinesis/lib/stream.js
var require_stream = __commonJS({
  "node_modules/aws-cdk-lib/aws-kinesis/lib/stream.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.StreamMode = exports2.StreamEncryption = exports2.Stream = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var kinesis_fixed_canned_metrics_1 = require_kinesis_fixed_canned_metrics();
    var kinesis_generated_1 = require_kinesis_generated();
    var cloudwatch = require_aws_cloudwatch();
    var iam = require_aws_iam();
    var kms = require_aws_kms();
    var core_1 = require_core2();
    var READ_OPERATIONS = ["kinesis:DescribeStreamSummary", "kinesis:GetRecords", "kinesis:GetShardIterator", "kinesis:ListShards", "kinesis:SubscribeToShard", "kinesis:DescribeStream", "kinesis:ListStreams", "kinesis:DescribeStreamConsumer"];
    var WRITE_OPERATIONS = ["kinesis:ListShards", "kinesis:PutRecord", "kinesis:PutRecords"];
    var StreamBase = class extends core_1.Resource {
      grantRead(grantee) {
        const ret = this.grant(grantee, ...READ_OPERATIONS);
        return this.encryptionKey && this.encryptionKey.grantDecrypt(grantee), ret;
      }
      grantWrite(grantee) {
        const ret = this.grant(grantee, ...WRITE_OPERATIONS);
        return this.encryptionKey?.grantEncrypt(grantee), ret;
      }
      grantReadWrite(grantee) {
        const ret = this.grant(grantee, ...Array.from(/* @__PURE__ */ new Set([...READ_OPERATIONS, ...WRITE_OPERATIONS])));
        return this.encryptionKey?.grantEncryptDecrypt(grantee), ret;
      }
      grant(grantee, ...actions) {
        return iam.Grant.addToPrincipal({ grantee, actions, resourceArns: [this.streamArn], scope: this });
      }
      metric(metricName, props) {
        return new cloudwatch.Metric({ namespace: "AWS/Kinesis", metricName, dimensionsMap: { StreamName: this.streamName }, ...props }).attachTo(this);
      }
      metricGetRecordsBytes(props) {
        return this.metricFromCannedFunction(kinesis_fixed_canned_metrics_1.KinesisMetrics.getRecordsBytesAverage, props);
      }
      metricGetRecordsIteratorAgeMilliseconds(props) {
        return this.metricFromCannedFunction(kinesis_fixed_canned_metrics_1.KinesisMetrics.getRecordsIteratorAgeMillisecondsMaximum, props);
      }
      metricGetRecordsSuccess(props) {
        return this.metricFromCannedFunction(kinesis_fixed_canned_metrics_1.KinesisMetrics.getRecordsSuccessAverage, props);
      }
      metricGetRecords(props) {
        return this.metricFromCannedFunction(kinesis_fixed_canned_metrics_1.KinesisMetrics.getRecordsRecordsAverage, props);
      }
      metricGetRecordsLatency(props) {
        return this.metricFromCannedFunction(kinesis_fixed_canned_metrics_1.KinesisMetrics.getRecordsLatencyAverage, props);
      }
      metricPutRecordBytes(props) {
        return this.metricFromCannedFunction(kinesis_fixed_canned_metrics_1.KinesisMetrics.putRecordBytesAverage, props);
      }
      metricPutRecordLatency(props) {
        return this.metricFromCannedFunction(kinesis_fixed_canned_metrics_1.KinesisMetrics.putRecordLatencyAverage, props);
      }
      metricPutRecordSuccess(props) {
        return this.metricFromCannedFunction(kinesis_fixed_canned_metrics_1.KinesisMetrics.putRecordSuccessAverage, props);
      }
      metricPutRecordsBytes(props) {
        return this.metricFromCannedFunction(kinesis_fixed_canned_metrics_1.KinesisMetrics.putRecordsBytesAverage, props);
      }
      metricPutRecordsLatency(props) {
        return this.metricFromCannedFunction(kinesis_fixed_canned_metrics_1.KinesisMetrics.putRecordsLatencyAverage, props);
      }
      metricPutRecordsSuccess(props) {
        return this.metricFromCannedFunction(kinesis_fixed_canned_metrics_1.KinesisMetrics.putRecordsSuccessAverage, props);
      }
      metricPutRecordsTotalRecords(props) {
        return this.metricFromCannedFunction(kinesis_fixed_canned_metrics_1.KinesisMetrics.putRecordsTotalRecordsAverage, props);
      }
      metricPutRecordsSuccessfulRecords(props) {
        return this.metricFromCannedFunction(kinesis_fixed_canned_metrics_1.KinesisMetrics.putRecordsSuccessfulRecordsAverage, props);
      }
      metricPutRecordsFailedRecords(props) {
        return this.metricFromCannedFunction(kinesis_fixed_canned_metrics_1.KinesisMetrics.putRecordsFailedRecordsAverage, props);
      }
      metricPutRecordsThrottledRecords(props) {
        return this.metricFromCannedFunction(kinesis_fixed_canned_metrics_1.KinesisMetrics.putRecordsThrottledRecordsAverage, props);
      }
      metricIncomingBytes(props) {
        return this.metricFromCannedFunction(kinesis_fixed_canned_metrics_1.KinesisMetrics.incomingBytesAverage, props);
      }
      metricIncomingRecords(props) {
        return this.metricFromCannedFunction(kinesis_fixed_canned_metrics_1.KinesisMetrics.incomingRecordsAverage, props);
      }
      metricReadProvisionedThroughputExceeded(props) {
        return this.metricFromCannedFunction(kinesis_fixed_canned_metrics_1.KinesisMetrics.readProvisionedThroughputExceededAverage, props);
      }
      metricWriteProvisionedThroughputExceeded(props) {
        return this.metricFromCannedFunction(kinesis_fixed_canned_metrics_1.KinesisMetrics.writeProvisionedThroughputExceededAverage, props);
      }
      metricFromCannedFunction(createCannedProps, props) {
        return new cloudwatch.Metric({ ...createCannedProps({ StreamName: this.streamName }), ...props }).attachTo(this);
      }
    };
    var Stream = class _Stream extends StreamBase {
      static fromStreamArn(scope, id, streamArn) {
        return _Stream.fromStreamAttributes(scope, id, { streamArn });
      }
      static fromStreamAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kinesis_StreamAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromStreamAttributes), error;
        }
        class Import extends StreamBase {
          constructor() {
            super(...arguments), this.streamArn = attrs.streamArn, this.streamName = core_1.Stack.of(scope).splitArn(attrs.streamArn, core_1.ArnFormat.SLASH_RESOURCE_NAME).resourceName, this.encryptionKey = attrs.encryptionKey;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.streamName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kinesis_StreamProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Stream), error;
        }
        let shardCount = props.shardCount;
        const streamMode = props.streamMode;
        if (streamMode === StreamMode.ON_DEMAND && shardCount !== void 0)
          throw new Error(`streamMode must be set to ${StreamMode.PROVISIONED} (default) when specifying shardCount`);
        (streamMode === StreamMode.PROVISIONED || streamMode === void 0) && shardCount === void 0 && (shardCount = 1);
        const retentionPeriodHours = props.retentionPeriod?.toHours() ?? 24;
        if (!core_1.Token.isUnresolved(retentionPeriodHours) && (retentionPeriodHours < 24 || retentionPeriodHours > 8760))
          throw new Error(`retentionPeriod must be between 24 and 8760 hours. Received ${retentionPeriodHours}`);
        const { streamEncryption, encryptionKey } = this.parseEncryption(props);
        this.stream = new kinesis_generated_1.CfnStream(this, "Resource", { name: this.physicalName, retentionPeriodHours, shardCount, streamEncryption, ...props.streamMode !== void 0 ? { streamModeDetails: { streamMode: props.streamMode } } : void 0 }), this.streamArn = this.getResourceArnAttribute(this.stream.attrArn, { service: "kinesis", resource: "stream", resourceName: this.physicalName }), this.streamName = this.getResourceNameAttribute(this.stream.ref), this.encryptionKey = encryptionKey;
      }
      parseEncryption(props) {
        if (!props.encryption && !props.encryptionKey) {
          const conditionName = "AwsCdkKinesisEncryptedStreamsUnsupportedRegions";
          return core_1.Stack.of(this).node.tryFindChild(conditionName) || new core_1.CfnCondition(core_1.Stack.of(this), conditionName, { expression: core_1.Fn.conditionOr(core_1.Fn.conditionEquals(core_1.Aws.REGION, "cn-north-1"), core_1.Fn.conditionEquals(core_1.Aws.REGION, "cn-northwest-1")) }), { streamEncryption: core_1.Fn.conditionIf(conditionName, core_1.Aws.NO_VALUE, { EncryptionType: "KMS", KeyId: "alias/aws/kinesis" }) };
        }
        const encryptionType = props.encryption ?? (props.encryptionKey ? StreamEncryption.KMS : StreamEncryption.UNENCRYPTED);
        if (encryptionType !== StreamEncryption.KMS && props.encryptionKey)
          throw new Error(`encryptionKey is specified, so 'encryption' must be set to KMS (value: ${encryptionType})`);
        if (encryptionType === StreamEncryption.UNENCRYPTED)
          return {};
        if (encryptionType === StreamEncryption.MANAGED)
          return { streamEncryption: { encryptionType: "KMS", keyId: "alias/aws/kinesis" } };
        if (encryptionType === StreamEncryption.KMS) {
          const encryptionKey = props.encryptionKey || new kms.Key(this, "Key", { description: `Created by ${this.node.path}` }), streamEncryption = { encryptionType: "KMS", keyId: encryptionKey.keyArn };
          return { encryptionKey, streamEncryption };
        }
        throw new Error(`Unexpected 'encryptionType': ${encryptionType}`);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Stream[_a] = { fqn: "aws-cdk-lib.aws_kinesis.Stream", version: "2.80.0" }, exports2.Stream = Stream;
    var StreamEncryption;
    (function(StreamEncryption2) {
      StreamEncryption2.UNENCRYPTED = "NONE", StreamEncryption2.KMS = "KMS", StreamEncryption2.MANAGED = "MANAGED";
    })(StreamEncryption = exports2.StreamEncryption || (exports2.StreamEncryption = {}));
    var StreamMode;
    (function(StreamMode2) {
      StreamMode2.PROVISIONED = "PROVISIONED", StreamMode2.ON_DEMAND = "ON_DEMAND";
    })(StreamMode = exports2.StreamMode || (exports2.StreamMode = {}));
  }
});

// node_modules/aws-cdk-lib/aws-kinesis/lib/index.js
var require_lib165 = __commonJS({
  "node_modules/aws-cdk-lib/aws-kinesis/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_stream(), exports2), __exportStar(require_kinesis_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-kinesis/index.js
var require_aws_kinesis = __commonJS({
  "node_modules/aws-cdk-lib/aws-kinesis/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib165(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-kinesisanalytics/lib/kinesisanalytics.generated.js
var require_kinesisanalytics_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-kinesisanalytics/lib/kinesisanalytics.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnApplicationReferenceDataSource = exports2.CfnApplicationOutput = exports2.CfnApplication = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnApplicationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationCode", cdk.validateString)(properties.applicationCode)), errors.collect(cdk.propertyValidator("applicationDescription", cdk.validateString)(properties.applicationDescription)), errors.collect(cdk.propertyValidator("applicationName", cdk.validateString)(properties.applicationName)), errors.collect(cdk.propertyValidator("inputs", cdk.requiredValidator)(properties.inputs)), errors.collect(cdk.propertyValidator("inputs", cdk.listValidator(CfnApplication_InputPropertyValidator))(properties.inputs)), errors.wrap('supplied properties not correct for "CfnApplicationProps"');
    }
    function cfnApplicationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationPropsValidator(properties).assertSuccess(), { Inputs: cdk.listMapper(cfnApplicationInputPropertyToCloudFormation)(properties.inputs), ApplicationCode: cdk.stringToCloudFormation(properties.applicationCode), ApplicationDescription: cdk.stringToCloudFormation(properties.applicationDescription), ApplicationName: cdk.stringToCloudFormation(properties.applicationName) }) : properties;
    }
    function CfnApplicationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("inputs", "Inputs", cfn_parse.FromCloudFormation.getArray(CfnApplicationInputPropertyFromCloudFormation)(properties.Inputs)), ret.addPropertyResult("applicationCode", "ApplicationCode", properties.ApplicationCode != null ? cfn_parse.FromCloudFormation.getString(properties.ApplicationCode) : void 0), ret.addPropertyResult("applicationDescription", "ApplicationDescription", properties.ApplicationDescription != null ? cfn_parse.FromCloudFormation.getString(properties.ApplicationDescription) : void 0), ret.addPropertyResult("applicationName", "ApplicationName", properties.ApplicationName != null ? cfn_parse.FromCloudFormation.getString(properties.ApplicationName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApplication = class _CfnApplication extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApplicationPropsFromCloudFormation(resourceProperties), ret = new _CfnApplication(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApplication.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kinesisanalytics_CfnApplicationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApplication), error;
        }
        cdk.requireProperty(props, "inputs", this), this.inputs = props.inputs, this.applicationCode = props.applicationCode, this.applicationDescription = props.applicationDescription, this.applicationName = props.applicationName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApplication.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { inputs: this.inputs, applicationCode: this.applicationCode, applicationDescription: this.applicationDescription, applicationName: this.applicationName };
      }
      renderProperties(props) {
        return cfnApplicationPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnApplication[_a] = { fqn: "aws-cdk-lib.aws_kinesisanalytics.CfnApplication", version: "2.80.0" }, CfnApplication.CFN_RESOURCE_TYPE_NAME = "AWS::KinesisAnalytics::Application", exports2.CfnApplication = CfnApplication;
    function CfnApplication_CSVMappingParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("recordColumnDelimiter", cdk.requiredValidator)(properties.recordColumnDelimiter)), errors.collect(cdk.propertyValidator("recordColumnDelimiter", cdk.validateString)(properties.recordColumnDelimiter)), errors.collect(cdk.propertyValidator("recordRowDelimiter", cdk.requiredValidator)(properties.recordRowDelimiter)), errors.collect(cdk.propertyValidator("recordRowDelimiter", cdk.validateString)(properties.recordRowDelimiter)), errors.wrap('supplied properties not correct for "CSVMappingParametersProperty"');
    }
    function cfnApplicationCSVMappingParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_CSVMappingParametersPropertyValidator(properties).assertSuccess(), { RecordColumnDelimiter: cdk.stringToCloudFormation(properties.recordColumnDelimiter), RecordRowDelimiter: cdk.stringToCloudFormation(properties.recordRowDelimiter) }) : properties;
    }
    function CfnApplicationCSVMappingParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("recordColumnDelimiter", "RecordColumnDelimiter", cfn_parse.FromCloudFormation.getString(properties.RecordColumnDelimiter)), ret.addPropertyResult("recordRowDelimiter", "RecordRowDelimiter", cfn_parse.FromCloudFormation.getString(properties.RecordRowDelimiter)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_InputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("inputParallelism", CfnApplication_InputParallelismPropertyValidator)(properties.inputParallelism)), errors.collect(cdk.propertyValidator("inputProcessingConfiguration", CfnApplication_InputProcessingConfigurationPropertyValidator)(properties.inputProcessingConfiguration)), errors.collect(cdk.propertyValidator("inputSchema", cdk.requiredValidator)(properties.inputSchema)), errors.collect(cdk.propertyValidator("inputSchema", CfnApplication_InputSchemaPropertyValidator)(properties.inputSchema)), errors.collect(cdk.propertyValidator("kinesisFirehoseInput", CfnApplication_KinesisFirehoseInputPropertyValidator)(properties.kinesisFirehoseInput)), errors.collect(cdk.propertyValidator("kinesisStreamsInput", CfnApplication_KinesisStreamsInputPropertyValidator)(properties.kinesisStreamsInput)), errors.collect(cdk.propertyValidator("namePrefix", cdk.requiredValidator)(properties.namePrefix)), errors.collect(cdk.propertyValidator("namePrefix", cdk.validateString)(properties.namePrefix)), errors.wrap('supplied properties not correct for "InputProperty"');
    }
    function cfnApplicationInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_InputPropertyValidator(properties).assertSuccess(), { InputParallelism: cfnApplicationInputParallelismPropertyToCloudFormation(properties.inputParallelism), InputProcessingConfiguration: cfnApplicationInputProcessingConfigurationPropertyToCloudFormation(properties.inputProcessingConfiguration), InputSchema: cfnApplicationInputSchemaPropertyToCloudFormation(properties.inputSchema), KinesisFirehoseInput: cfnApplicationKinesisFirehoseInputPropertyToCloudFormation(properties.kinesisFirehoseInput), KinesisStreamsInput: cfnApplicationKinesisStreamsInputPropertyToCloudFormation(properties.kinesisStreamsInput), NamePrefix: cdk.stringToCloudFormation(properties.namePrefix) }) : properties;
    }
    function CfnApplicationInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("inputParallelism", "InputParallelism", properties.InputParallelism != null ? CfnApplicationInputParallelismPropertyFromCloudFormation(properties.InputParallelism) : void 0), ret.addPropertyResult("inputProcessingConfiguration", "InputProcessingConfiguration", properties.InputProcessingConfiguration != null ? CfnApplicationInputProcessingConfigurationPropertyFromCloudFormation(properties.InputProcessingConfiguration) : void 0), ret.addPropertyResult("inputSchema", "InputSchema", CfnApplicationInputSchemaPropertyFromCloudFormation(properties.InputSchema)), ret.addPropertyResult("kinesisFirehoseInput", "KinesisFirehoseInput", properties.KinesisFirehoseInput != null ? CfnApplicationKinesisFirehoseInputPropertyFromCloudFormation(properties.KinesisFirehoseInput) : void 0), ret.addPropertyResult("kinesisStreamsInput", "KinesisStreamsInput", properties.KinesisStreamsInput != null ? CfnApplicationKinesisStreamsInputPropertyFromCloudFormation(properties.KinesisStreamsInput) : void 0), ret.addPropertyResult("namePrefix", "NamePrefix", cfn_parse.FromCloudFormation.getString(properties.NamePrefix)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_InputLambdaProcessorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceArn", cdk.requiredValidator)(properties.resourceArn)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "InputLambdaProcessorProperty"');
    }
    function cfnApplicationInputLambdaProcessorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_InputLambdaProcessorPropertyValidator(properties).assertSuccess(), { ResourceARN: cdk.stringToCloudFormation(properties.resourceArn), RoleARN: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnApplicationInputLambdaProcessorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceArn", "ResourceARN", cfn_parse.FromCloudFormation.getString(properties.ResourceARN)), ret.addPropertyResult("roleArn", "RoleARN", cfn_parse.FromCloudFormation.getString(properties.RoleARN)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_InputParallelismPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("count", cdk.validateNumber)(properties.count)), errors.wrap('supplied properties not correct for "InputParallelismProperty"');
    }
    function cfnApplicationInputParallelismPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_InputParallelismPropertyValidator(properties).assertSuccess(), { Count: cdk.numberToCloudFormation(properties.count) }) : properties;
    }
    function CfnApplicationInputParallelismPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("count", "Count", properties.Count != null ? cfn_parse.FromCloudFormation.getNumber(properties.Count) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_InputProcessingConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("inputLambdaProcessor", CfnApplication_InputLambdaProcessorPropertyValidator)(properties.inputLambdaProcessor)), errors.wrap('supplied properties not correct for "InputProcessingConfigurationProperty"');
    }
    function cfnApplicationInputProcessingConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_InputProcessingConfigurationPropertyValidator(properties).assertSuccess(), { InputLambdaProcessor: cfnApplicationInputLambdaProcessorPropertyToCloudFormation(properties.inputLambdaProcessor) }) : properties;
    }
    function CfnApplicationInputProcessingConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("inputLambdaProcessor", "InputLambdaProcessor", properties.InputLambdaProcessor != null ? CfnApplicationInputLambdaProcessorPropertyFromCloudFormation(properties.InputLambdaProcessor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_InputSchemaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("recordColumns", cdk.requiredValidator)(properties.recordColumns)), errors.collect(cdk.propertyValidator("recordColumns", cdk.listValidator(CfnApplication_RecordColumnPropertyValidator))(properties.recordColumns)), errors.collect(cdk.propertyValidator("recordEncoding", cdk.validateString)(properties.recordEncoding)), errors.collect(cdk.propertyValidator("recordFormat", cdk.requiredValidator)(properties.recordFormat)), errors.collect(cdk.propertyValidator("recordFormat", CfnApplication_RecordFormatPropertyValidator)(properties.recordFormat)), errors.wrap('supplied properties not correct for "InputSchemaProperty"');
    }
    function cfnApplicationInputSchemaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_InputSchemaPropertyValidator(properties).assertSuccess(), { RecordColumns: cdk.listMapper(cfnApplicationRecordColumnPropertyToCloudFormation)(properties.recordColumns), RecordEncoding: cdk.stringToCloudFormation(properties.recordEncoding), RecordFormat: cfnApplicationRecordFormatPropertyToCloudFormation(properties.recordFormat) }) : properties;
    }
    function CfnApplicationInputSchemaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("recordColumns", "RecordColumns", cfn_parse.FromCloudFormation.getArray(CfnApplicationRecordColumnPropertyFromCloudFormation)(properties.RecordColumns)), ret.addPropertyResult("recordEncoding", "RecordEncoding", properties.RecordEncoding != null ? cfn_parse.FromCloudFormation.getString(properties.RecordEncoding) : void 0), ret.addPropertyResult("recordFormat", "RecordFormat", CfnApplicationRecordFormatPropertyFromCloudFormation(properties.RecordFormat)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_JSONMappingParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("recordRowPath", cdk.requiredValidator)(properties.recordRowPath)), errors.collect(cdk.propertyValidator("recordRowPath", cdk.validateString)(properties.recordRowPath)), errors.wrap('supplied properties not correct for "JSONMappingParametersProperty"');
    }
    function cfnApplicationJSONMappingParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_JSONMappingParametersPropertyValidator(properties).assertSuccess(), { RecordRowPath: cdk.stringToCloudFormation(properties.recordRowPath) }) : properties;
    }
    function CfnApplicationJSONMappingParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("recordRowPath", "RecordRowPath", cfn_parse.FromCloudFormation.getString(properties.RecordRowPath)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_KinesisFirehoseInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceArn", cdk.requiredValidator)(properties.resourceArn)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "KinesisFirehoseInputProperty"');
    }
    function cfnApplicationKinesisFirehoseInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_KinesisFirehoseInputPropertyValidator(properties).assertSuccess(), { ResourceARN: cdk.stringToCloudFormation(properties.resourceArn), RoleARN: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnApplicationKinesisFirehoseInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceArn", "ResourceARN", cfn_parse.FromCloudFormation.getString(properties.ResourceARN)), ret.addPropertyResult("roleArn", "RoleARN", cfn_parse.FromCloudFormation.getString(properties.RoleARN)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_KinesisStreamsInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceArn", cdk.requiredValidator)(properties.resourceArn)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "KinesisStreamsInputProperty"');
    }
    function cfnApplicationKinesisStreamsInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_KinesisStreamsInputPropertyValidator(properties).assertSuccess(), { ResourceARN: cdk.stringToCloudFormation(properties.resourceArn), RoleARN: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnApplicationKinesisStreamsInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceArn", "ResourceARN", cfn_parse.FromCloudFormation.getString(properties.ResourceARN)), ret.addPropertyResult("roleArn", "RoleARN", cfn_parse.FromCloudFormation.getString(properties.RoleARN)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_MappingParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("csvMappingParameters", CfnApplication_CSVMappingParametersPropertyValidator)(properties.csvMappingParameters)), errors.collect(cdk.propertyValidator("jsonMappingParameters", CfnApplication_JSONMappingParametersPropertyValidator)(properties.jsonMappingParameters)), errors.wrap('supplied properties not correct for "MappingParametersProperty"');
    }
    function cfnApplicationMappingParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_MappingParametersPropertyValidator(properties).assertSuccess(), { CSVMappingParameters: cfnApplicationCSVMappingParametersPropertyToCloudFormation(properties.csvMappingParameters), JSONMappingParameters: cfnApplicationJSONMappingParametersPropertyToCloudFormation(properties.jsonMappingParameters) }) : properties;
    }
    function CfnApplicationMappingParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("csvMappingParameters", "CSVMappingParameters", properties.CSVMappingParameters != null ? CfnApplicationCSVMappingParametersPropertyFromCloudFormation(properties.CSVMappingParameters) : void 0), ret.addPropertyResult("jsonMappingParameters", "JSONMappingParameters", properties.JSONMappingParameters != null ? CfnApplicationJSONMappingParametersPropertyFromCloudFormation(properties.JSONMappingParameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_RecordColumnPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mapping", cdk.validateString)(properties.mapping)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("sqlType", cdk.requiredValidator)(properties.sqlType)), errors.collect(cdk.propertyValidator("sqlType", cdk.validateString)(properties.sqlType)), errors.wrap('supplied properties not correct for "RecordColumnProperty"');
    }
    function cfnApplicationRecordColumnPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_RecordColumnPropertyValidator(properties).assertSuccess(), { Mapping: cdk.stringToCloudFormation(properties.mapping), Name: cdk.stringToCloudFormation(properties.name), SqlType: cdk.stringToCloudFormation(properties.sqlType) }) : properties;
    }
    function CfnApplicationRecordColumnPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mapping", "Mapping", properties.Mapping != null ? cfn_parse.FromCloudFormation.getString(properties.Mapping) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("sqlType", "SqlType", cfn_parse.FromCloudFormation.getString(properties.SqlType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_RecordFormatPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mappingParameters", CfnApplication_MappingParametersPropertyValidator)(properties.mappingParameters)), errors.collect(cdk.propertyValidator("recordFormatType", cdk.requiredValidator)(properties.recordFormatType)), errors.collect(cdk.propertyValidator("recordFormatType", cdk.validateString)(properties.recordFormatType)), errors.wrap('supplied properties not correct for "RecordFormatProperty"');
    }
    function cfnApplicationRecordFormatPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_RecordFormatPropertyValidator(properties).assertSuccess(), { MappingParameters: cfnApplicationMappingParametersPropertyToCloudFormation(properties.mappingParameters), RecordFormatType: cdk.stringToCloudFormation(properties.recordFormatType) }) : properties;
    }
    function CfnApplicationRecordFormatPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mappingParameters", "MappingParameters", properties.MappingParameters != null ? CfnApplicationMappingParametersPropertyFromCloudFormation(properties.MappingParameters) : void 0), ret.addPropertyResult("recordFormatType", "RecordFormatType", cfn_parse.FromCloudFormation.getString(properties.RecordFormatType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationOutputPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationName", cdk.requiredValidator)(properties.applicationName)), errors.collect(cdk.propertyValidator("applicationName", cdk.validateString)(properties.applicationName)), errors.collect(cdk.propertyValidator("output", cdk.requiredValidator)(properties.output)), errors.collect(cdk.propertyValidator("output", CfnApplicationOutput_OutputPropertyValidator)(properties.output)), errors.wrap('supplied properties not correct for "CfnApplicationOutputProps"');
    }
    function cfnApplicationOutputPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationOutputPropsValidator(properties).assertSuccess(), { ApplicationName: cdk.stringToCloudFormation(properties.applicationName), Output: cfnApplicationOutputOutputPropertyToCloudFormation(properties.output) }) : properties;
    }
    function CfnApplicationOutputPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationName", "ApplicationName", cfn_parse.FromCloudFormation.getString(properties.ApplicationName)), ret.addPropertyResult("output", "Output", CfnApplicationOutputOutputPropertyFromCloudFormation(properties.Output)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApplicationOutput = class _CfnApplicationOutput extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApplicationOutputPropsFromCloudFormation(resourceProperties), ret = new _CfnApplicationOutput(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApplicationOutput.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kinesisanalytics_CfnApplicationOutputProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApplicationOutput), error;
        }
        cdk.requireProperty(props, "applicationName", this), cdk.requireProperty(props, "output", this), this.applicationName = props.applicationName, this.output = props.output;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApplicationOutput.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationName: this.applicationName, output: this.output };
      }
      renderProperties(props) {
        return cfnApplicationOutputPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnApplicationOutput[_b] = { fqn: "aws-cdk-lib.aws_kinesisanalytics.CfnApplicationOutput", version: "2.80.0" }, CfnApplicationOutput.CFN_RESOURCE_TYPE_NAME = "AWS::KinesisAnalytics::ApplicationOutput", exports2.CfnApplicationOutput = CfnApplicationOutput;
    function CfnApplicationOutput_DestinationSchemaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("recordFormatType", cdk.validateString)(properties.recordFormatType)), errors.wrap('supplied properties not correct for "DestinationSchemaProperty"');
    }
    function cfnApplicationOutputDestinationSchemaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationOutput_DestinationSchemaPropertyValidator(properties).assertSuccess(), { RecordFormatType: cdk.stringToCloudFormation(properties.recordFormatType) }) : properties;
    }
    function CfnApplicationOutputDestinationSchemaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("recordFormatType", "RecordFormatType", properties.RecordFormatType != null ? cfn_parse.FromCloudFormation.getString(properties.RecordFormatType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationOutput_KinesisFirehoseOutputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceArn", cdk.requiredValidator)(properties.resourceArn)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "KinesisFirehoseOutputProperty"');
    }
    function cfnApplicationOutputKinesisFirehoseOutputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationOutput_KinesisFirehoseOutputPropertyValidator(properties).assertSuccess(), { ResourceARN: cdk.stringToCloudFormation(properties.resourceArn), RoleARN: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnApplicationOutputKinesisFirehoseOutputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceArn", "ResourceARN", cfn_parse.FromCloudFormation.getString(properties.ResourceARN)), ret.addPropertyResult("roleArn", "RoleARN", cfn_parse.FromCloudFormation.getString(properties.RoleARN)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationOutput_KinesisStreamsOutputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceArn", cdk.requiredValidator)(properties.resourceArn)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "KinesisStreamsOutputProperty"');
    }
    function cfnApplicationOutputKinesisStreamsOutputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationOutput_KinesisStreamsOutputPropertyValidator(properties).assertSuccess(), { ResourceARN: cdk.stringToCloudFormation(properties.resourceArn), RoleARN: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnApplicationOutputKinesisStreamsOutputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceArn", "ResourceARN", cfn_parse.FromCloudFormation.getString(properties.ResourceARN)), ret.addPropertyResult("roleArn", "RoleARN", cfn_parse.FromCloudFormation.getString(properties.RoleARN)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationOutput_LambdaOutputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceArn", cdk.requiredValidator)(properties.resourceArn)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "LambdaOutputProperty"');
    }
    function cfnApplicationOutputLambdaOutputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationOutput_LambdaOutputPropertyValidator(properties).assertSuccess(), { ResourceARN: cdk.stringToCloudFormation(properties.resourceArn), RoleARN: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnApplicationOutputLambdaOutputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceArn", "ResourceARN", cfn_parse.FromCloudFormation.getString(properties.ResourceARN)), ret.addPropertyResult("roleArn", "RoleARN", cfn_parse.FromCloudFormation.getString(properties.RoleARN)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationOutput_OutputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationSchema", cdk.requiredValidator)(properties.destinationSchema)), errors.collect(cdk.propertyValidator("destinationSchema", CfnApplicationOutput_DestinationSchemaPropertyValidator)(properties.destinationSchema)), errors.collect(cdk.propertyValidator("kinesisFirehoseOutput", CfnApplicationOutput_KinesisFirehoseOutputPropertyValidator)(properties.kinesisFirehoseOutput)), errors.collect(cdk.propertyValidator("kinesisStreamsOutput", CfnApplicationOutput_KinesisStreamsOutputPropertyValidator)(properties.kinesisStreamsOutput)), errors.collect(cdk.propertyValidator("lambdaOutput", CfnApplicationOutput_LambdaOutputPropertyValidator)(properties.lambdaOutput)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "OutputProperty"');
    }
    function cfnApplicationOutputOutputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationOutput_OutputPropertyValidator(properties).assertSuccess(), { DestinationSchema: cfnApplicationOutputDestinationSchemaPropertyToCloudFormation(properties.destinationSchema), KinesisFirehoseOutput: cfnApplicationOutputKinesisFirehoseOutputPropertyToCloudFormation(properties.kinesisFirehoseOutput), KinesisStreamsOutput: cfnApplicationOutputKinesisStreamsOutputPropertyToCloudFormation(properties.kinesisStreamsOutput), LambdaOutput: cfnApplicationOutputLambdaOutputPropertyToCloudFormation(properties.lambdaOutput), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnApplicationOutputOutputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationSchema", "DestinationSchema", CfnApplicationOutputDestinationSchemaPropertyFromCloudFormation(properties.DestinationSchema)), ret.addPropertyResult("kinesisFirehoseOutput", "KinesisFirehoseOutput", properties.KinesisFirehoseOutput != null ? CfnApplicationOutputKinesisFirehoseOutputPropertyFromCloudFormation(properties.KinesisFirehoseOutput) : void 0), ret.addPropertyResult("kinesisStreamsOutput", "KinesisStreamsOutput", properties.KinesisStreamsOutput != null ? CfnApplicationOutputKinesisStreamsOutputPropertyFromCloudFormation(properties.KinesisStreamsOutput) : void 0), ret.addPropertyResult("lambdaOutput", "LambdaOutput", properties.LambdaOutput != null ? CfnApplicationOutputLambdaOutputPropertyFromCloudFormation(properties.LambdaOutput) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationReferenceDataSourcePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationName", cdk.requiredValidator)(properties.applicationName)), errors.collect(cdk.propertyValidator("applicationName", cdk.validateString)(properties.applicationName)), errors.collect(cdk.propertyValidator("referenceDataSource", cdk.requiredValidator)(properties.referenceDataSource)), errors.collect(cdk.propertyValidator("referenceDataSource", CfnApplicationReferenceDataSource_ReferenceDataSourcePropertyValidator)(properties.referenceDataSource)), errors.wrap('supplied properties not correct for "CfnApplicationReferenceDataSourceProps"');
    }
    function cfnApplicationReferenceDataSourcePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationReferenceDataSourcePropsValidator(properties).assertSuccess(), { ApplicationName: cdk.stringToCloudFormation(properties.applicationName), ReferenceDataSource: cfnApplicationReferenceDataSourceReferenceDataSourcePropertyToCloudFormation(properties.referenceDataSource) }) : properties;
    }
    function CfnApplicationReferenceDataSourcePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationName", "ApplicationName", cfn_parse.FromCloudFormation.getString(properties.ApplicationName)), ret.addPropertyResult("referenceDataSource", "ReferenceDataSource", CfnApplicationReferenceDataSourceReferenceDataSourcePropertyFromCloudFormation(properties.ReferenceDataSource)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApplicationReferenceDataSource = class _CfnApplicationReferenceDataSource extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApplicationReferenceDataSourcePropsFromCloudFormation(resourceProperties), ret = new _CfnApplicationReferenceDataSource(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApplicationReferenceDataSource.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApplicationReferenceDataSource), error;
        }
        cdk.requireProperty(props, "applicationName", this), cdk.requireProperty(props, "referenceDataSource", this), this.applicationName = props.applicationName, this.referenceDataSource = props.referenceDataSource;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApplicationReferenceDataSource.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationName: this.applicationName, referenceDataSource: this.referenceDataSource };
      }
      renderProperties(props) {
        return cfnApplicationReferenceDataSourcePropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnApplicationReferenceDataSource[_c] = { fqn: "aws-cdk-lib.aws_kinesisanalytics.CfnApplicationReferenceDataSource", version: "2.80.0" }, CfnApplicationReferenceDataSource.CFN_RESOURCE_TYPE_NAME = "AWS::KinesisAnalytics::ApplicationReferenceDataSource", exports2.CfnApplicationReferenceDataSource = CfnApplicationReferenceDataSource;
    function CfnApplicationReferenceDataSource_CSVMappingParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("recordColumnDelimiter", cdk.requiredValidator)(properties.recordColumnDelimiter)), errors.collect(cdk.propertyValidator("recordColumnDelimiter", cdk.validateString)(properties.recordColumnDelimiter)), errors.collect(cdk.propertyValidator("recordRowDelimiter", cdk.requiredValidator)(properties.recordRowDelimiter)), errors.collect(cdk.propertyValidator("recordRowDelimiter", cdk.validateString)(properties.recordRowDelimiter)), errors.wrap('supplied properties not correct for "CSVMappingParametersProperty"');
    }
    function cfnApplicationReferenceDataSourceCSVMappingParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationReferenceDataSource_CSVMappingParametersPropertyValidator(properties).assertSuccess(), { RecordColumnDelimiter: cdk.stringToCloudFormation(properties.recordColumnDelimiter), RecordRowDelimiter: cdk.stringToCloudFormation(properties.recordRowDelimiter) }) : properties;
    }
    function CfnApplicationReferenceDataSourceCSVMappingParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("recordColumnDelimiter", "RecordColumnDelimiter", cfn_parse.FromCloudFormation.getString(properties.RecordColumnDelimiter)), ret.addPropertyResult("recordRowDelimiter", "RecordRowDelimiter", cfn_parse.FromCloudFormation.getString(properties.RecordRowDelimiter)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationReferenceDataSource_JSONMappingParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("recordRowPath", cdk.requiredValidator)(properties.recordRowPath)), errors.collect(cdk.propertyValidator("recordRowPath", cdk.validateString)(properties.recordRowPath)), errors.wrap('supplied properties not correct for "JSONMappingParametersProperty"');
    }
    function cfnApplicationReferenceDataSourceJSONMappingParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationReferenceDataSource_JSONMappingParametersPropertyValidator(properties).assertSuccess(), { RecordRowPath: cdk.stringToCloudFormation(properties.recordRowPath) }) : properties;
    }
    function CfnApplicationReferenceDataSourceJSONMappingParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("recordRowPath", "RecordRowPath", cfn_parse.FromCloudFormation.getString(properties.RecordRowPath)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationReferenceDataSource_MappingParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("csvMappingParameters", CfnApplicationReferenceDataSource_CSVMappingParametersPropertyValidator)(properties.csvMappingParameters)), errors.collect(cdk.propertyValidator("jsonMappingParameters", CfnApplicationReferenceDataSource_JSONMappingParametersPropertyValidator)(properties.jsonMappingParameters)), errors.wrap('supplied properties not correct for "MappingParametersProperty"');
    }
    function cfnApplicationReferenceDataSourceMappingParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationReferenceDataSource_MappingParametersPropertyValidator(properties).assertSuccess(), { CSVMappingParameters: cfnApplicationReferenceDataSourceCSVMappingParametersPropertyToCloudFormation(properties.csvMappingParameters), JSONMappingParameters: cfnApplicationReferenceDataSourceJSONMappingParametersPropertyToCloudFormation(properties.jsonMappingParameters) }) : properties;
    }
    function CfnApplicationReferenceDataSourceMappingParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("csvMappingParameters", "CSVMappingParameters", properties.CSVMappingParameters != null ? CfnApplicationReferenceDataSourceCSVMappingParametersPropertyFromCloudFormation(properties.CSVMappingParameters) : void 0), ret.addPropertyResult("jsonMappingParameters", "JSONMappingParameters", properties.JSONMappingParameters != null ? CfnApplicationReferenceDataSourceJSONMappingParametersPropertyFromCloudFormation(properties.JSONMappingParameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationReferenceDataSource_RecordColumnPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mapping", cdk.validateString)(properties.mapping)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("sqlType", cdk.requiredValidator)(properties.sqlType)), errors.collect(cdk.propertyValidator("sqlType", cdk.validateString)(properties.sqlType)), errors.wrap('supplied properties not correct for "RecordColumnProperty"');
    }
    function cfnApplicationReferenceDataSourceRecordColumnPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationReferenceDataSource_RecordColumnPropertyValidator(properties).assertSuccess(), { Mapping: cdk.stringToCloudFormation(properties.mapping), Name: cdk.stringToCloudFormation(properties.name), SqlType: cdk.stringToCloudFormation(properties.sqlType) }) : properties;
    }
    function CfnApplicationReferenceDataSourceRecordColumnPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mapping", "Mapping", properties.Mapping != null ? cfn_parse.FromCloudFormation.getString(properties.Mapping) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("sqlType", "SqlType", cfn_parse.FromCloudFormation.getString(properties.SqlType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationReferenceDataSource_RecordFormatPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mappingParameters", CfnApplicationReferenceDataSource_MappingParametersPropertyValidator)(properties.mappingParameters)), errors.collect(cdk.propertyValidator("recordFormatType", cdk.requiredValidator)(properties.recordFormatType)), errors.collect(cdk.propertyValidator("recordFormatType", cdk.validateString)(properties.recordFormatType)), errors.wrap('supplied properties not correct for "RecordFormatProperty"');
    }
    function cfnApplicationReferenceDataSourceRecordFormatPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationReferenceDataSource_RecordFormatPropertyValidator(properties).assertSuccess(), { MappingParameters: cfnApplicationReferenceDataSourceMappingParametersPropertyToCloudFormation(properties.mappingParameters), RecordFormatType: cdk.stringToCloudFormation(properties.recordFormatType) }) : properties;
    }
    function CfnApplicationReferenceDataSourceRecordFormatPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mappingParameters", "MappingParameters", properties.MappingParameters != null ? CfnApplicationReferenceDataSourceMappingParametersPropertyFromCloudFormation(properties.MappingParameters) : void 0), ret.addPropertyResult("recordFormatType", "RecordFormatType", cfn_parse.FromCloudFormation.getString(properties.RecordFormatType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationReferenceDataSource_ReferenceDataSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("referenceSchema", cdk.requiredValidator)(properties.referenceSchema)), errors.collect(cdk.propertyValidator("referenceSchema", CfnApplicationReferenceDataSource_ReferenceSchemaPropertyValidator)(properties.referenceSchema)), errors.collect(cdk.propertyValidator("s3ReferenceDataSource", CfnApplicationReferenceDataSource_S3ReferenceDataSourcePropertyValidator)(properties.s3ReferenceDataSource)), errors.collect(cdk.propertyValidator("tableName", cdk.validateString)(properties.tableName)), errors.wrap('supplied properties not correct for "ReferenceDataSourceProperty"');
    }
    function cfnApplicationReferenceDataSourceReferenceDataSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationReferenceDataSource_ReferenceDataSourcePropertyValidator(properties).assertSuccess(), { ReferenceSchema: cfnApplicationReferenceDataSourceReferenceSchemaPropertyToCloudFormation(properties.referenceSchema), S3ReferenceDataSource: cfnApplicationReferenceDataSourceS3ReferenceDataSourcePropertyToCloudFormation(properties.s3ReferenceDataSource), TableName: cdk.stringToCloudFormation(properties.tableName) }) : properties;
    }
    function CfnApplicationReferenceDataSourceReferenceDataSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("referenceSchema", "ReferenceSchema", CfnApplicationReferenceDataSourceReferenceSchemaPropertyFromCloudFormation(properties.ReferenceSchema)), ret.addPropertyResult("s3ReferenceDataSource", "S3ReferenceDataSource", properties.S3ReferenceDataSource != null ? CfnApplicationReferenceDataSourceS3ReferenceDataSourcePropertyFromCloudFormation(properties.S3ReferenceDataSource) : void 0), ret.addPropertyResult("tableName", "TableName", properties.TableName != null ? cfn_parse.FromCloudFormation.getString(properties.TableName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationReferenceDataSource_ReferenceSchemaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("recordColumns", cdk.requiredValidator)(properties.recordColumns)), errors.collect(cdk.propertyValidator("recordColumns", cdk.listValidator(CfnApplicationReferenceDataSource_RecordColumnPropertyValidator))(properties.recordColumns)), errors.collect(cdk.propertyValidator("recordEncoding", cdk.validateString)(properties.recordEncoding)), errors.collect(cdk.propertyValidator("recordFormat", cdk.requiredValidator)(properties.recordFormat)), errors.collect(cdk.propertyValidator("recordFormat", CfnApplicationReferenceDataSource_RecordFormatPropertyValidator)(properties.recordFormat)), errors.wrap('supplied properties not correct for "ReferenceSchemaProperty"');
    }
    function cfnApplicationReferenceDataSourceReferenceSchemaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationReferenceDataSource_ReferenceSchemaPropertyValidator(properties).assertSuccess(), { RecordColumns: cdk.listMapper(cfnApplicationReferenceDataSourceRecordColumnPropertyToCloudFormation)(properties.recordColumns), RecordEncoding: cdk.stringToCloudFormation(properties.recordEncoding), RecordFormat: cfnApplicationReferenceDataSourceRecordFormatPropertyToCloudFormation(properties.recordFormat) }) : properties;
    }
    function CfnApplicationReferenceDataSourceReferenceSchemaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("recordColumns", "RecordColumns", cfn_parse.FromCloudFormation.getArray(CfnApplicationReferenceDataSourceRecordColumnPropertyFromCloudFormation)(properties.RecordColumns)), ret.addPropertyResult("recordEncoding", "RecordEncoding", properties.RecordEncoding != null ? cfn_parse.FromCloudFormation.getString(properties.RecordEncoding) : void 0), ret.addPropertyResult("recordFormat", "RecordFormat", CfnApplicationReferenceDataSourceRecordFormatPropertyFromCloudFormation(properties.RecordFormat)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationReferenceDataSource_S3ReferenceDataSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketArn", cdk.requiredValidator)(properties.bucketArn)), errors.collect(cdk.propertyValidator("bucketArn", cdk.validateString)(properties.bucketArn)), errors.collect(cdk.propertyValidator("fileKey", cdk.requiredValidator)(properties.fileKey)), errors.collect(cdk.propertyValidator("fileKey", cdk.validateString)(properties.fileKey)), errors.collect(cdk.propertyValidator("referenceRoleArn", cdk.requiredValidator)(properties.referenceRoleArn)), errors.collect(cdk.propertyValidator("referenceRoleArn", cdk.validateString)(properties.referenceRoleArn)), errors.wrap('supplied properties not correct for "S3ReferenceDataSourceProperty"');
    }
    function cfnApplicationReferenceDataSourceS3ReferenceDataSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationReferenceDataSource_S3ReferenceDataSourcePropertyValidator(properties).assertSuccess(), { BucketARN: cdk.stringToCloudFormation(properties.bucketArn), FileKey: cdk.stringToCloudFormation(properties.fileKey), ReferenceRoleARN: cdk.stringToCloudFormation(properties.referenceRoleArn) }) : properties;
    }
    function CfnApplicationReferenceDataSourceS3ReferenceDataSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketArn", "BucketARN", cfn_parse.FromCloudFormation.getString(properties.BucketARN)), ret.addPropertyResult("fileKey", "FileKey", cfn_parse.FromCloudFormation.getString(properties.FileKey)), ret.addPropertyResult("referenceRoleArn", "ReferenceRoleARN", cfn_parse.FromCloudFormation.getString(properties.ReferenceRoleARN)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-kinesisanalytics/lib/kinesisanalyticsv2.generated.js
var require_kinesisanalyticsv2_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-kinesisanalytics/lib/kinesisanalyticsv2.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnApplicationReferenceDataSourceV2 = exports2.CfnApplicationOutputV2 = exports2.CfnApplicationCloudWatchLoggingOptionV2 = exports2.CfnApplicationV2 = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnApplicationV2PropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationConfiguration", CfnApplicationV2_ApplicationConfigurationPropertyValidator)(properties.applicationConfiguration)), errors.collect(cdk.propertyValidator("applicationDescription", cdk.validateString)(properties.applicationDescription)), errors.collect(cdk.propertyValidator("applicationMaintenanceConfiguration", CfnApplicationV2_ApplicationMaintenanceConfigurationPropertyValidator)(properties.applicationMaintenanceConfiguration)), errors.collect(cdk.propertyValidator("applicationMode", cdk.validateString)(properties.applicationMode)), errors.collect(cdk.propertyValidator("applicationName", cdk.validateString)(properties.applicationName)), errors.collect(cdk.propertyValidator("runConfiguration", CfnApplicationV2_RunConfigurationPropertyValidator)(properties.runConfiguration)), errors.collect(cdk.propertyValidator("runtimeEnvironment", cdk.requiredValidator)(properties.runtimeEnvironment)), errors.collect(cdk.propertyValidator("runtimeEnvironment", cdk.validateString)(properties.runtimeEnvironment)), errors.collect(cdk.propertyValidator("serviceExecutionRole", cdk.requiredValidator)(properties.serviceExecutionRole)), errors.collect(cdk.propertyValidator("serviceExecutionRole", cdk.validateString)(properties.serviceExecutionRole)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnApplicationV2Props"');
    }
    function cfnApplicationV2PropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2PropsValidator(properties).assertSuccess(), { RuntimeEnvironment: cdk.stringToCloudFormation(properties.runtimeEnvironment), ServiceExecutionRole: cdk.stringToCloudFormation(properties.serviceExecutionRole), ApplicationConfiguration: cfnApplicationV2ApplicationConfigurationPropertyToCloudFormation(properties.applicationConfiguration), ApplicationDescription: cdk.stringToCloudFormation(properties.applicationDescription), ApplicationMaintenanceConfiguration: cfnApplicationV2ApplicationMaintenanceConfigurationPropertyToCloudFormation(properties.applicationMaintenanceConfiguration), ApplicationMode: cdk.stringToCloudFormation(properties.applicationMode), ApplicationName: cdk.stringToCloudFormation(properties.applicationName), RunConfiguration: cfnApplicationV2RunConfigurationPropertyToCloudFormation(properties.runConfiguration), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnApplicationV2PropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("runtimeEnvironment", "RuntimeEnvironment", cfn_parse.FromCloudFormation.getString(properties.RuntimeEnvironment)), ret.addPropertyResult("serviceExecutionRole", "ServiceExecutionRole", cfn_parse.FromCloudFormation.getString(properties.ServiceExecutionRole)), ret.addPropertyResult("applicationConfiguration", "ApplicationConfiguration", properties.ApplicationConfiguration != null ? CfnApplicationV2ApplicationConfigurationPropertyFromCloudFormation(properties.ApplicationConfiguration) : void 0), ret.addPropertyResult("applicationDescription", "ApplicationDescription", properties.ApplicationDescription != null ? cfn_parse.FromCloudFormation.getString(properties.ApplicationDescription) : void 0), ret.addPropertyResult("applicationMaintenanceConfiguration", "ApplicationMaintenanceConfiguration", properties.ApplicationMaintenanceConfiguration != null ? CfnApplicationV2ApplicationMaintenanceConfigurationPropertyFromCloudFormation(properties.ApplicationMaintenanceConfiguration) : void 0), ret.addPropertyResult("applicationMode", "ApplicationMode", properties.ApplicationMode != null ? cfn_parse.FromCloudFormation.getString(properties.ApplicationMode) : void 0), ret.addPropertyResult("applicationName", "ApplicationName", properties.ApplicationName != null ? cfn_parse.FromCloudFormation.getString(properties.ApplicationName) : void 0), ret.addPropertyResult("runConfiguration", "RunConfiguration", properties.RunConfiguration != null ? CfnApplicationV2RunConfigurationPropertyFromCloudFormation(properties.RunConfiguration) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApplicationV2 = class _CfnApplicationV2 extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApplicationV2PropsFromCloudFormation(resourceProperties), ret = new _CfnApplicationV2(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApplicationV2.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kinesisanalytics_CfnApplicationV2Props(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApplicationV2), error;
        }
        cdk.requireProperty(props, "runtimeEnvironment", this), cdk.requireProperty(props, "serviceExecutionRole", this), this.runtimeEnvironment = props.runtimeEnvironment, this.serviceExecutionRole = props.serviceExecutionRole, this.applicationConfiguration = props.applicationConfiguration, this.applicationDescription = props.applicationDescription, this.applicationMaintenanceConfiguration = props.applicationMaintenanceConfiguration, this.applicationMode = props.applicationMode, this.applicationName = props.applicationName, this.runConfiguration = props.runConfiguration, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::KinesisAnalyticsV2::Application", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApplicationV2.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { runtimeEnvironment: this.runtimeEnvironment, serviceExecutionRole: this.serviceExecutionRole, applicationConfiguration: this.applicationConfiguration, applicationDescription: this.applicationDescription, applicationMaintenanceConfiguration: this.applicationMaintenanceConfiguration, applicationMode: this.applicationMode, applicationName: this.applicationName, runConfiguration: this.runConfiguration, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnApplicationV2PropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnApplicationV2[_a] = { fqn: "aws-cdk-lib.aws_kinesisanalytics.CfnApplicationV2", version: "2.80.0" }, CfnApplicationV2.CFN_RESOURCE_TYPE_NAME = "AWS::KinesisAnalyticsV2::Application", exports2.CfnApplicationV2 = CfnApplicationV2;
    function CfnApplicationV2_ApplicationCodeConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("codeContent", cdk.requiredValidator)(properties.codeContent)), errors.collect(cdk.propertyValidator("codeContent", CfnApplicationV2_CodeContentPropertyValidator)(properties.codeContent)), errors.collect(cdk.propertyValidator("codeContentType", cdk.requiredValidator)(properties.codeContentType)), errors.collect(cdk.propertyValidator("codeContentType", cdk.validateString)(properties.codeContentType)), errors.wrap('supplied properties not correct for "ApplicationCodeConfigurationProperty"');
    }
    function cfnApplicationV2ApplicationCodeConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_ApplicationCodeConfigurationPropertyValidator(properties).assertSuccess(), { CodeContent: cfnApplicationV2CodeContentPropertyToCloudFormation(properties.codeContent), CodeContentType: cdk.stringToCloudFormation(properties.codeContentType) }) : properties;
    }
    function CfnApplicationV2ApplicationCodeConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("codeContent", "CodeContent", CfnApplicationV2CodeContentPropertyFromCloudFormation(properties.CodeContent)), ret.addPropertyResult("codeContentType", "CodeContentType", cfn_parse.FromCloudFormation.getString(properties.CodeContentType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_ApplicationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationCodeConfiguration", CfnApplicationV2_ApplicationCodeConfigurationPropertyValidator)(properties.applicationCodeConfiguration)), errors.collect(cdk.propertyValidator("applicationSnapshotConfiguration", CfnApplicationV2_ApplicationSnapshotConfigurationPropertyValidator)(properties.applicationSnapshotConfiguration)), errors.collect(cdk.propertyValidator("environmentProperties", CfnApplicationV2_EnvironmentPropertiesPropertyValidator)(properties.environmentProperties)), errors.collect(cdk.propertyValidator("flinkApplicationConfiguration", CfnApplicationV2_FlinkApplicationConfigurationPropertyValidator)(properties.flinkApplicationConfiguration)), errors.collect(cdk.propertyValidator("sqlApplicationConfiguration", CfnApplicationV2_SqlApplicationConfigurationPropertyValidator)(properties.sqlApplicationConfiguration)), errors.collect(cdk.propertyValidator("vpcConfigurations", cdk.listValidator(CfnApplicationV2_VpcConfigurationPropertyValidator))(properties.vpcConfigurations)), errors.collect(cdk.propertyValidator("zeppelinApplicationConfiguration", CfnApplicationV2_ZeppelinApplicationConfigurationPropertyValidator)(properties.zeppelinApplicationConfiguration)), errors.wrap('supplied properties not correct for "ApplicationConfigurationProperty"');
    }
    function cfnApplicationV2ApplicationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_ApplicationConfigurationPropertyValidator(properties).assertSuccess(), { ApplicationCodeConfiguration: cfnApplicationV2ApplicationCodeConfigurationPropertyToCloudFormation(properties.applicationCodeConfiguration), ApplicationSnapshotConfiguration: cfnApplicationV2ApplicationSnapshotConfigurationPropertyToCloudFormation(properties.applicationSnapshotConfiguration), EnvironmentProperties: cfnApplicationV2EnvironmentPropertiesPropertyToCloudFormation(properties.environmentProperties), FlinkApplicationConfiguration: cfnApplicationV2FlinkApplicationConfigurationPropertyToCloudFormation(properties.flinkApplicationConfiguration), SqlApplicationConfiguration: cfnApplicationV2SqlApplicationConfigurationPropertyToCloudFormation(properties.sqlApplicationConfiguration), VpcConfigurations: cdk.listMapper(cfnApplicationV2VpcConfigurationPropertyToCloudFormation)(properties.vpcConfigurations), ZeppelinApplicationConfiguration: cfnApplicationV2ZeppelinApplicationConfigurationPropertyToCloudFormation(properties.zeppelinApplicationConfiguration) }) : properties;
    }
    function CfnApplicationV2ApplicationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationCodeConfiguration", "ApplicationCodeConfiguration", properties.ApplicationCodeConfiguration != null ? CfnApplicationV2ApplicationCodeConfigurationPropertyFromCloudFormation(properties.ApplicationCodeConfiguration) : void 0), ret.addPropertyResult("applicationSnapshotConfiguration", "ApplicationSnapshotConfiguration", properties.ApplicationSnapshotConfiguration != null ? CfnApplicationV2ApplicationSnapshotConfigurationPropertyFromCloudFormation(properties.ApplicationSnapshotConfiguration) : void 0), ret.addPropertyResult("environmentProperties", "EnvironmentProperties", properties.EnvironmentProperties != null ? CfnApplicationV2EnvironmentPropertiesPropertyFromCloudFormation(properties.EnvironmentProperties) : void 0), ret.addPropertyResult("flinkApplicationConfiguration", "FlinkApplicationConfiguration", properties.FlinkApplicationConfiguration != null ? CfnApplicationV2FlinkApplicationConfigurationPropertyFromCloudFormation(properties.FlinkApplicationConfiguration) : void 0), ret.addPropertyResult("sqlApplicationConfiguration", "SqlApplicationConfiguration", properties.SqlApplicationConfiguration != null ? CfnApplicationV2SqlApplicationConfigurationPropertyFromCloudFormation(properties.SqlApplicationConfiguration) : void 0), ret.addPropertyResult("vpcConfigurations", "VpcConfigurations", properties.VpcConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnApplicationV2VpcConfigurationPropertyFromCloudFormation)(properties.VpcConfigurations) : void 0), ret.addPropertyResult("zeppelinApplicationConfiguration", "ZeppelinApplicationConfiguration", properties.ZeppelinApplicationConfiguration != null ? CfnApplicationV2ZeppelinApplicationConfigurationPropertyFromCloudFormation(properties.ZeppelinApplicationConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_ApplicationMaintenanceConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationMaintenanceWindowStartTime", cdk.requiredValidator)(properties.applicationMaintenanceWindowStartTime)), errors.collect(cdk.propertyValidator("applicationMaintenanceWindowStartTime", cdk.validateString)(properties.applicationMaintenanceWindowStartTime)), errors.wrap('supplied properties not correct for "ApplicationMaintenanceConfigurationProperty"');
    }
    function cfnApplicationV2ApplicationMaintenanceConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_ApplicationMaintenanceConfigurationPropertyValidator(properties).assertSuccess(), { ApplicationMaintenanceWindowStartTime: cdk.stringToCloudFormation(properties.applicationMaintenanceWindowStartTime) }) : properties;
    }
    function CfnApplicationV2ApplicationMaintenanceConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationMaintenanceWindowStartTime", "ApplicationMaintenanceWindowStartTime", cfn_parse.FromCloudFormation.getString(properties.ApplicationMaintenanceWindowStartTime)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_ApplicationRestoreConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationRestoreType", cdk.requiredValidator)(properties.applicationRestoreType)), errors.collect(cdk.propertyValidator("applicationRestoreType", cdk.validateString)(properties.applicationRestoreType)), errors.collect(cdk.propertyValidator("snapshotName", cdk.validateString)(properties.snapshotName)), errors.wrap('supplied properties not correct for "ApplicationRestoreConfigurationProperty"');
    }
    function cfnApplicationV2ApplicationRestoreConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_ApplicationRestoreConfigurationPropertyValidator(properties).assertSuccess(), { ApplicationRestoreType: cdk.stringToCloudFormation(properties.applicationRestoreType), SnapshotName: cdk.stringToCloudFormation(properties.snapshotName) }) : properties;
    }
    function CfnApplicationV2ApplicationRestoreConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationRestoreType", "ApplicationRestoreType", cfn_parse.FromCloudFormation.getString(properties.ApplicationRestoreType)), ret.addPropertyResult("snapshotName", "SnapshotName", properties.SnapshotName != null ? cfn_parse.FromCloudFormation.getString(properties.SnapshotName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_ApplicationSnapshotConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("snapshotsEnabled", cdk.requiredValidator)(properties.snapshotsEnabled)), errors.collect(cdk.propertyValidator("snapshotsEnabled", cdk.validateBoolean)(properties.snapshotsEnabled)), errors.wrap('supplied properties not correct for "ApplicationSnapshotConfigurationProperty"');
    }
    function cfnApplicationV2ApplicationSnapshotConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_ApplicationSnapshotConfigurationPropertyValidator(properties).assertSuccess(), { SnapshotsEnabled: cdk.booleanToCloudFormation(properties.snapshotsEnabled) }) : properties;
    }
    function CfnApplicationV2ApplicationSnapshotConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("snapshotsEnabled", "SnapshotsEnabled", cfn_parse.FromCloudFormation.getBoolean(properties.SnapshotsEnabled)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_CSVMappingParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("recordColumnDelimiter", cdk.requiredValidator)(properties.recordColumnDelimiter)), errors.collect(cdk.propertyValidator("recordColumnDelimiter", cdk.validateString)(properties.recordColumnDelimiter)), errors.collect(cdk.propertyValidator("recordRowDelimiter", cdk.requiredValidator)(properties.recordRowDelimiter)), errors.collect(cdk.propertyValidator("recordRowDelimiter", cdk.validateString)(properties.recordRowDelimiter)), errors.wrap('supplied properties not correct for "CSVMappingParametersProperty"');
    }
    function cfnApplicationV2CSVMappingParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_CSVMappingParametersPropertyValidator(properties).assertSuccess(), { RecordColumnDelimiter: cdk.stringToCloudFormation(properties.recordColumnDelimiter), RecordRowDelimiter: cdk.stringToCloudFormation(properties.recordRowDelimiter) }) : properties;
    }
    function CfnApplicationV2CSVMappingParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("recordColumnDelimiter", "RecordColumnDelimiter", cfn_parse.FromCloudFormation.getString(properties.RecordColumnDelimiter)), ret.addPropertyResult("recordRowDelimiter", "RecordRowDelimiter", cfn_parse.FromCloudFormation.getString(properties.RecordRowDelimiter)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_CatalogConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("glueDataCatalogConfiguration", CfnApplicationV2_GlueDataCatalogConfigurationPropertyValidator)(properties.glueDataCatalogConfiguration)), errors.wrap('supplied properties not correct for "CatalogConfigurationProperty"');
    }
    function cfnApplicationV2CatalogConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_CatalogConfigurationPropertyValidator(properties).assertSuccess(), { GlueDataCatalogConfiguration: cfnApplicationV2GlueDataCatalogConfigurationPropertyToCloudFormation(properties.glueDataCatalogConfiguration) }) : properties;
    }
    function CfnApplicationV2CatalogConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("glueDataCatalogConfiguration", "GlueDataCatalogConfiguration", properties.GlueDataCatalogConfiguration != null ? CfnApplicationV2GlueDataCatalogConfigurationPropertyFromCloudFormation(properties.GlueDataCatalogConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_CheckpointConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("checkpointInterval", cdk.validateNumber)(properties.checkpointInterval)), errors.collect(cdk.propertyValidator("checkpointingEnabled", cdk.validateBoolean)(properties.checkpointingEnabled)), errors.collect(cdk.propertyValidator("configurationType", cdk.requiredValidator)(properties.configurationType)), errors.collect(cdk.propertyValidator("configurationType", cdk.validateString)(properties.configurationType)), errors.collect(cdk.propertyValidator("minPauseBetweenCheckpoints", cdk.validateNumber)(properties.minPauseBetweenCheckpoints)), errors.wrap('supplied properties not correct for "CheckpointConfigurationProperty"');
    }
    function cfnApplicationV2CheckpointConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_CheckpointConfigurationPropertyValidator(properties).assertSuccess(), { CheckpointInterval: cdk.numberToCloudFormation(properties.checkpointInterval), CheckpointingEnabled: cdk.booleanToCloudFormation(properties.checkpointingEnabled), ConfigurationType: cdk.stringToCloudFormation(properties.configurationType), MinPauseBetweenCheckpoints: cdk.numberToCloudFormation(properties.minPauseBetweenCheckpoints) }) : properties;
    }
    function CfnApplicationV2CheckpointConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("checkpointInterval", "CheckpointInterval", properties.CheckpointInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.CheckpointInterval) : void 0), ret.addPropertyResult("checkpointingEnabled", "CheckpointingEnabled", properties.CheckpointingEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CheckpointingEnabled) : void 0), ret.addPropertyResult("configurationType", "ConfigurationType", cfn_parse.FromCloudFormation.getString(properties.ConfigurationType)), ret.addPropertyResult("minPauseBetweenCheckpoints", "MinPauseBetweenCheckpoints", properties.MinPauseBetweenCheckpoints != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinPauseBetweenCheckpoints) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_CodeContentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3ContentLocation", CfnApplicationV2_S3ContentLocationPropertyValidator)(properties.s3ContentLocation)), errors.collect(cdk.propertyValidator("textContent", cdk.validateString)(properties.textContent)), errors.collect(cdk.propertyValidator("zipFileContent", cdk.validateString)(properties.zipFileContent)), errors.wrap('supplied properties not correct for "CodeContentProperty"');
    }
    function cfnApplicationV2CodeContentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_CodeContentPropertyValidator(properties).assertSuccess(), { S3ContentLocation: cfnApplicationV2S3ContentLocationPropertyToCloudFormation(properties.s3ContentLocation), TextContent: cdk.stringToCloudFormation(properties.textContent), ZipFileContent: cdk.stringToCloudFormation(properties.zipFileContent) }) : properties;
    }
    function CfnApplicationV2CodeContentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3ContentLocation", "S3ContentLocation", properties.S3ContentLocation != null ? CfnApplicationV2S3ContentLocationPropertyFromCloudFormation(properties.S3ContentLocation) : void 0), ret.addPropertyResult("textContent", "TextContent", properties.TextContent != null ? cfn_parse.FromCloudFormation.getString(properties.TextContent) : void 0), ret.addPropertyResult("zipFileContent", "ZipFileContent", properties.ZipFileContent != null ? cfn_parse.FromCloudFormation.getString(properties.ZipFileContent) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_CustomArtifactConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("artifactType", cdk.requiredValidator)(properties.artifactType)), errors.collect(cdk.propertyValidator("artifactType", cdk.validateString)(properties.artifactType)), errors.collect(cdk.propertyValidator("mavenReference", CfnApplicationV2_MavenReferencePropertyValidator)(properties.mavenReference)), errors.collect(cdk.propertyValidator("s3ContentLocation", CfnApplicationV2_S3ContentLocationPropertyValidator)(properties.s3ContentLocation)), errors.wrap('supplied properties not correct for "CustomArtifactConfigurationProperty"');
    }
    function cfnApplicationV2CustomArtifactConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_CustomArtifactConfigurationPropertyValidator(properties).assertSuccess(), { ArtifactType: cdk.stringToCloudFormation(properties.artifactType), MavenReference: cfnApplicationV2MavenReferencePropertyToCloudFormation(properties.mavenReference), S3ContentLocation: cfnApplicationV2S3ContentLocationPropertyToCloudFormation(properties.s3ContentLocation) }) : properties;
    }
    function CfnApplicationV2CustomArtifactConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("artifactType", "ArtifactType", cfn_parse.FromCloudFormation.getString(properties.ArtifactType)), ret.addPropertyResult("mavenReference", "MavenReference", properties.MavenReference != null ? CfnApplicationV2MavenReferencePropertyFromCloudFormation(properties.MavenReference) : void 0), ret.addPropertyResult("s3ContentLocation", "S3ContentLocation", properties.S3ContentLocation != null ? CfnApplicationV2S3ContentLocationPropertyFromCloudFormation(properties.S3ContentLocation) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_DeployAsApplicationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3ContentLocation", cdk.requiredValidator)(properties.s3ContentLocation)), errors.collect(cdk.propertyValidator("s3ContentLocation", CfnApplicationV2_S3ContentBaseLocationPropertyValidator)(properties.s3ContentLocation)), errors.wrap('supplied properties not correct for "DeployAsApplicationConfigurationProperty"');
    }
    function cfnApplicationV2DeployAsApplicationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_DeployAsApplicationConfigurationPropertyValidator(properties).assertSuccess(), { S3ContentLocation: cfnApplicationV2S3ContentBaseLocationPropertyToCloudFormation(properties.s3ContentLocation) }) : properties;
    }
    function CfnApplicationV2DeployAsApplicationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3ContentLocation", "S3ContentLocation", CfnApplicationV2S3ContentBaseLocationPropertyFromCloudFormation(properties.S3ContentLocation)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_EnvironmentPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("propertyGroups", cdk.listValidator(CfnApplicationV2_PropertyGroupPropertyValidator))(properties.propertyGroups)), errors.wrap('supplied properties not correct for "EnvironmentPropertiesProperty"');
    }
    function cfnApplicationV2EnvironmentPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_EnvironmentPropertiesPropertyValidator(properties).assertSuccess(), { PropertyGroups: cdk.listMapper(cfnApplicationV2PropertyGroupPropertyToCloudFormation)(properties.propertyGroups) }) : properties;
    }
    function CfnApplicationV2EnvironmentPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("propertyGroups", "PropertyGroups", properties.PropertyGroups != null ? cfn_parse.FromCloudFormation.getArray(CfnApplicationV2PropertyGroupPropertyFromCloudFormation)(properties.PropertyGroups) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_FlinkApplicationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("checkpointConfiguration", CfnApplicationV2_CheckpointConfigurationPropertyValidator)(properties.checkpointConfiguration)), errors.collect(cdk.propertyValidator("monitoringConfiguration", CfnApplicationV2_MonitoringConfigurationPropertyValidator)(properties.monitoringConfiguration)), errors.collect(cdk.propertyValidator("parallelismConfiguration", CfnApplicationV2_ParallelismConfigurationPropertyValidator)(properties.parallelismConfiguration)), errors.wrap('supplied properties not correct for "FlinkApplicationConfigurationProperty"');
    }
    function cfnApplicationV2FlinkApplicationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_FlinkApplicationConfigurationPropertyValidator(properties).assertSuccess(), { CheckpointConfiguration: cfnApplicationV2CheckpointConfigurationPropertyToCloudFormation(properties.checkpointConfiguration), MonitoringConfiguration: cfnApplicationV2MonitoringConfigurationPropertyToCloudFormation(properties.monitoringConfiguration), ParallelismConfiguration: cfnApplicationV2ParallelismConfigurationPropertyToCloudFormation(properties.parallelismConfiguration) }) : properties;
    }
    function CfnApplicationV2FlinkApplicationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("checkpointConfiguration", "CheckpointConfiguration", properties.CheckpointConfiguration != null ? CfnApplicationV2CheckpointConfigurationPropertyFromCloudFormation(properties.CheckpointConfiguration) : void 0), ret.addPropertyResult("monitoringConfiguration", "MonitoringConfiguration", properties.MonitoringConfiguration != null ? CfnApplicationV2MonitoringConfigurationPropertyFromCloudFormation(properties.MonitoringConfiguration) : void 0), ret.addPropertyResult("parallelismConfiguration", "ParallelismConfiguration", properties.ParallelismConfiguration != null ? CfnApplicationV2ParallelismConfigurationPropertyFromCloudFormation(properties.ParallelismConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_FlinkRunConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowNonRestoredState", cdk.validateBoolean)(properties.allowNonRestoredState)), errors.wrap('supplied properties not correct for "FlinkRunConfigurationProperty"');
    }
    function cfnApplicationV2FlinkRunConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_FlinkRunConfigurationPropertyValidator(properties).assertSuccess(), { AllowNonRestoredState: cdk.booleanToCloudFormation(properties.allowNonRestoredState) }) : properties;
    }
    function CfnApplicationV2FlinkRunConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowNonRestoredState", "AllowNonRestoredState", properties.AllowNonRestoredState != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllowNonRestoredState) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_GlueDataCatalogConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("databaseArn", cdk.validateString)(properties.databaseArn)), errors.wrap('supplied properties not correct for "GlueDataCatalogConfigurationProperty"');
    }
    function cfnApplicationV2GlueDataCatalogConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_GlueDataCatalogConfigurationPropertyValidator(properties).assertSuccess(), { DatabaseARN: cdk.stringToCloudFormation(properties.databaseArn) }) : properties;
    }
    function CfnApplicationV2GlueDataCatalogConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("databaseArn", "DatabaseARN", properties.DatabaseARN != null ? cfn_parse.FromCloudFormation.getString(properties.DatabaseARN) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_InputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("inputParallelism", CfnApplicationV2_InputParallelismPropertyValidator)(properties.inputParallelism)), errors.collect(cdk.propertyValidator("inputProcessingConfiguration", CfnApplicationV2_InputProcessingConfigurationPropertyValidator)(properties.inputProcessingConfiguration)), errors.collect(cdk.propertyValidator("inputSchema", cdk.requiredValidator)(properties.inputSchema)), errors.collect(cdk.propertyValidator("inputSchema", CfnApplicationV2_InputSchemaPropertyValidator)(properties.inputSchema)), errors.collect(cdk.propertyValidator("kinesisFirehoseInput", CfnApplicationV2_KinesisFirehoseInputPropertyValidator)(properties.kinesisFirehoseInput)), errors.collect(cdk.propertyValidator("kinesisStreamsInput", CfnApplicationV2_KinesisStreamsInputPropertyValidator)(properties.kinesisStreamsInput)), errors.collect(cdk.propertyValidator("namePrefix", cdk.requiredValidator)(properties.namePrefix)), errors.collect(cdk.propertyValidator("namePrefix", cdk.validateString)(properties.namePrefix)), errors.wrap('supplied properties not correct for "InputProperty"');
    }
    function cfnApplicationV2InputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_InputPropertyValidator(properties).assertSuccess(), { InputParallelism: cfnApplicationV2InputParallelismPropertyToCloudFormation(properties.inputParallelism), InputProcessingConfiguration: cfnApplicationV2InputProcessingConfigurationPropertyToCloudFormation(properties.inputProcessingConfiguration), InputSchema: cfnApplicationV2InputSchemaPropertyToCloudFormation(properties.inputSchema), KinesisFirehoseInput: cfnApplicationV2KinesisFirehoseInputPropertyToCloudFormation(properties.kinesisFirehoseInput), KinesisStreamsInput: cfnApplicationV2KinesisStreamsInputPropertyToCloudFormation(properties.kinesisStreamsInput), NamePrefix: cdk.stringToCloudFormation(properties.namePrefix) }) : properties;
    }
    function CfnApplicationV2InputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("inputParallelism", "InputParallelism", properties.InputParallelism != null ? CfnApplicationV2InputParallelismPropertyFromCloudFormation(properties.InputParallelism) : void 0), ret.addPropertyResult("inputProcessingConfiguration", "InputProcessingConfiguration", properties.InputProcessingConfiguration != null ? CfnApplicationV2InputProcessingConfigurationPropertyFromCloudFormation(properties.InputProcessingConfiguration) : void 0), ret.addPropertyResult("inputSchema", "InputSchema", CfnApplicationV2InputSchemaPropertyFromCloudFormation(properties.InputSchema)), ret.addPropertyResult("kinesisFirehoseInput", "KinesisFirehoseInput", properties.KinesisFirehoseInput != null ? CfnApplicationV2KinesisFirehoseInputPropertyFromCloudFormation(properties.KinesisFirehoseInput) : void 0), ret.addPropertyResult("kinesisStreamsInput", "KinesisStreamsInput", properties.KinesisStreamsInput != null ? CfnApplicationV2KinesisStreamsInputPropertyFromCloudFormation(properties.KinesisStreamsInput) : void 0), ret.addPropertyResult("namePrefix", "NamePrefix", cfn_parse.FromCloudFormation.getString(properties.NamePrefix)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_InputLambdaProcessorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceArn", cdk.requiredValidator)(properties.resourceArn)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.wrap('supplied properties not correct for "InputLambdaProcessorProperty"');
    }
    function cfnApplicationV2InputLambdaProcessorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_InputLambdaProcessorPropertyValidator(properties).assertSuccess(), { ResourceARN: cdk.stringToCloudFormation(properties.resourceArn) }) : properties;
    }
    function CfnApplicationV2InputLambdaProcessorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceArn", "ResourceARN", cfn_parse.FromCloudFormation.getString(properties.ResourceARN)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_InputParallelismPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("count", cdk.validateNumber)(properties.count)), errors.wrap('supplied properties not correct for "InputParallelismProperty"');
    }
    function cfnApplicationV2InputParallelismPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_InputParallelismPropertyValidator(properties).assertSuccess(), { Count: cdk.numberToCloudFormation(properties.count) }) : properties;
    }
    function CfnApplicationV2InputParallelismPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("count", "Count", properties.Count != null ? cfn_parse.FromCloudFormation.getNumber(properties.Count) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_InputProcessingConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("inputLambdaProcessor", CfnApplicationV2_InputLambdaProcessorPropertyValidator)(properties.inputLambdaProcessor)), errors.wrap('supplied properties not correct for "InputProcessingConfigurationProperty"');
    }
    function cfnApplicationV2InputProcessingConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_InputProcessingConfigurationPropertyValidator(properties).assertSuccess(), { InputLambdaProcessor: cfnApplicationV2InputLambdaProcessorPropertyToCloudFormation(properties.inputLambdaProcessor) }) : properties;
    }
    function CfnApplicationV2InputProcessingConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("inputLambdaProcessor", "InputLambdaProcessor", properties.InputLambdaProcessor != null ? CfnApplicationV2InputLambdaProcessorPropertyFromCloudFormation(properties.InputLambdaProcessor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_InputSchemaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("recordColumns", cdk.requiredValidator)(properties.recordColumns)), errors.collect(cdk.propertyValidator("recordColumns", cdk.listValidator(CfnApplicationV2_RecordColumnPropertyValidator))(properties.recordColumns)), errors.collect(cdk.propertyValidator("recordEncoding", cdk.validateString)(properties.recordEncoding)), errors.collect(cdk.propertyValidator("recordFormat", cdk.requiredValidator)(properties.recordFormat)), errors.collect(cdk.propertyValidator("recordFormat", CfnApplicationV2_RecordFormatPropertyValidator)(properties.recordFormat)), errors.wrap('supplied properties not correct for "InputSchemaProperty"');
    }
    function cfnApplicationV2InputSchemaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_InputSchemaPropertyValidator(properties).assertSuccess(), { RecordColumns: cdk.listMapper(cfnApplicationV2RecordColumnPropertyToCloudFormation)(properties.recordColumns), RecordEncoding: cdk.stringToCloudFormation(properties.recordEncoding), RecordFormat: cfnApplicationV2RecordFormatPropertyToCloudFormation(properties.recordFormat) }) : properties;
    }
    function CfnApplicationV2InputSchemaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("recordColumns", "RecordColumns", cfn_parse.FromCloudFormation.getArray(CfnApplicationV2RecordColumnPropertyFromCloudFormation)(properties.RecordColumns)), ret.addPropertyResult("recordEncoding", "RecordEncoding", properties.RecordEncoding != null ? cfn_parse.FromCloudFormation.getString(properties.RecordEncoding) : void 0), ret.addPropertyResult("recordFormat", "RecordFormat", CfnApplicationV2RecordFormatPropertyFromCloudFormation(properties.RecordFormat)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_JSONMappingParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("recordRowPath", cdk.requiredValidator)(properties.recordRowPath)), errors.collect(cdk.propertyValidator("recordRowPath", cdk.validateString)(properties.recordRowPath)), errors.wrap('supplied properties not correct for "JSONMappingParametersProperty"');
    }
    function cfnApplicationV2JSONMappingParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_JSONMappingParametersPropertyValidator(properties).assertSuccess(), { RecordRowPath: cdk.stringToCloudFormation(properties.recordRowPath) }) : properties;
    }
    function CfnApplicationV2JSONMappingParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("recordRowPath", "RecordRowPath", cfn_parse.FromCloudFormation.getString(properties.RecordRowPath)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_KinesisFirehoseInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceArn", cdk.requiredValidator)(properties.resourceArn)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.wrap('supplied properties not correct for "KinesisFirehoseInputProperty"');
    }
    function cfnApplicationV2KinesisFirehoseInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_KinesisFirehoseInputPropertyValidator(properties).assertSuccess(), { ResourceARN: cdk.stringToCloudFormation(properties.resourceArn) }) : properties;
    }
    function CfnApplicationV2KinesisFirehoseInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceArn", "ResourceARN", cfn_parse.FromCloudFormation.getString(properties.ResourceARN)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_KinesisStreamsInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceArn", cdk.requiredValidator)(properties.resourceArn)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.wrap('supplied properties not correct for "KinesisStreamsInputProperty"');
    }
    function cfnApplicationV2KinesisStreamsInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_KinesisStreamsInputPropertyValidator(properties).assertSuccess(), { ResourceARN: cdk.stringToCloudFormation(properties.resourceArn) }) : properties;
    }
    function CfnApplicationV2KinesisStreamsInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceArn", "ResourceARN", cfn_parse.FromCloudFormation.getString(properties.ResourceARN)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_MappingParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("csvMappingParameters", CfnApplicationV2_CSVMappingParametersPropertyValidator)(properties.csvMappingParameters)), errors.collect(cdk.propertyValidator("jsonMappingParameters", CfnApplicationV2_JSONMappingParametersPropertyValidator)(properties.jsonMappingParameters)), errors.wrap('supplied properties not correct for "MappingParametersProperty"');
    }
    function cfnApplicationV2MappingParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_MappingParametersPropertyValidator(properties).assertSuccess(), { CSVMappingParameters: cfnApplicationV2CSVMappingParametersPropertyToCloudFormation(properties.csvMappingParameters), JSONMappingParameters: cfnApplicationV2JSONMappingParametersPropertyToCloudFormation(properties.jsonMappingParameters) }) : properties;
    }
    function CfnApplicationV2MappingParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("csvMappingParameters", "CSVMappingParameters", properties.CSVMappingParameters != null ? CfnApplicationV2CSVMappingParametersPropertyFromCloudFormation(properties.CSVMappingParameters) : void 0), ret.addPropertyResult("jsonMappingParameters", "JSONMappingParameters", properties.JSONMappingParameters != null ? CfnApplicationV2JSONMappingParametersPropertyFromCloudFormation(properties.JSONMappingParameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_MavenReferencePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("artifactId", cdk.requiredValidator)(properties.artifactId)), errors.collect(cdk.propertyValidator("artifactId", cdk.validateString)(properties.artifactId)), errors.collect(cdk.propertyValidator("groupId", cdk.requiredValidator)(properties.groupId)), errors.collect(cdk.propertyValidator("groupId", cdk.validateString)(properties.groupId)), errors.collect(cdk.propertyValidator("version", cdk.requiredValidator)(properties.version)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "MavenReferenceProperty"');
    }
    function cfnApplicationV2MavenReferencePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_MavenReferencePropertyValidator(properties).assertSuccess(), { ArtifactId: cdk.stringToCloudFormation(properties.artifactId), GroupId: cdk.stringToCloudFormation(properties.groupId), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnApplicationV2MavenReferencePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("artifactId", "ArtifactId", cfn_parse.FromCloudFormation.getString(properties.ArtifactId)), ret.addPropertyResult("groupId", "GroupId", cfn_parse.FromCloudFormation.getString(properties.GroupId)), ret.addPropertyResult("version", "Version", cfn_parse.FromCloudFormation.getString(properties.Version)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_MonitoringConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configurationType", cdk.requiredValidator)(properties.configurationType)), errors.collect(cdk.propertyValidator("configurationType", cdk.validateString)(properties.configurationType)), errors.collect(cdk.propertyValidator("logLevel", cdk.validateString)(properties.logLevel)), errors.collect(cdk.propertyValidator("metricsLevel", cdk.validateString)(properties.metricsLevel)), errors.wrap('supplied properties not correct for "MonitoringConfigurationProperty"');
    }
    function cfnApplicationV2MonitoringConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_MonitoringConfigurationPropertyValidator(properties).assertSuccess(), { ConfigurationType: cdk.stringToCloudFormation(properties.configurationType), LogLevel: cdk.stringToCloudFormation(properties.logLevel), MetricsLevel: cdk.stringToCloudFormation(properties.metricsLevel) }) : properties;
    }
    function CfnApplicationV2MonitoringConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configurationType", "ConfigurationType", cfn_parse.FromCloudFormation.getString(properties.ConfigurationType)), ret.addPropertyResult("logLevel", "LogLevel", properties.LogLevel != null ? cfn_parse.FromCloudFormation.getString(properties.LogLevel) : void 0), ret.addPropertyResult("metricsLevel", "MetricsLevel", properties.MetricsLevel != null ? cfn_parse.FromCloudFormation.getString(properties.MetricsLevel) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_ParallelismConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoScalingEnabled", cdk.validateBoolean)(properties.autoScalingEnabled)), errors.collect(cdk.propertyValidator("configurationType", cdk.requiredValidator)(properties.configurationType)), errors.collect(cdk.propertyValidator("configurationType", cdk.validateString)(properties.configurationType)), errors.collect(cdk.propertyValidator("parallelism", cdk.validateNumber)(properties.parallelism)), errors.collect(cdk.propertyValidator("parallelismPerKpu", cdk.validateNumber)(properties.parallelismPerKpu)), errors.wrap('supplied properties not correct for "ParallelismConfigurationProperty"');
    }
    function cfnApplicationV2ParallelismConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_ParallelismConfigurationPropertyValidator(properties).assertSuccess(), { AutoScalingEnabled: cdk.booleanToCloudFormation(properties.autoScalingEnabled), ConfigurationType: cdk.stringToCloudFormation(properties.configurationType), Parallelism: cdk.numberToCloudFormation(properties.parallelism), ParallelismPerKPU: cdk.numberToCloudFormation(properties.parallelismPerKpu) }) : properties;
    }
    function CfnApplicationV2ParallelismConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("autoScalingEnabled", "AutoScalingEnabled", properties.AutoScalingEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AutoScalingEnabled) : void 0), ret.addPropertyResult("configurationType", "ConfigurationType", cfn_parse.FromCloudFormation.getString(properties.ConfigurationType)), ret.addPropertyResult("parallelism", "Parallelism", properties.Parallelism != null ? cfn_parse.FromCloudFormation.getNumber(properties.Parallelism) : void 0), ret.addPropertyResult("parallelismPerKpu", "ParallelismPerKPU", properties.ParallelismPerKPU != null ? cfn_parse.FromCloudFormation.getNumber(properties.ParallelismPerKPU) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_PropertyGroupPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("propertyGroupId", cdk.validateString)(properties.propertyGroupId)), errors.collect(cdk.propertyValidator("propertyMap", cdk.hashValidator(cdk.validateString))(properties.propertyMap)), errors.wrap('supplied properties not correct for "PropertyGroupProperty"');
    }
    function cfnApplicationV2PropertyGroupPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_PropertyGroupPropertyValidator(properties).assertSuccess(), { PropertyGroupId: cdk.stringToCloudFormation(properties.propertyGroupId), PropertyMap: cdk.hashMapper(cdk.stringToCloudFormation)(properties.propertyMap) }) : properties;
    }
    function CfnApplicationV2PropertyGroupPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("propertyGroupId", "PropertyGroupId", properties.PropertyGroupId != null ? cfn_parse.FromCloudFormation.getString(properties.PropertyGroupId) : void 0), ret.addPropertyResult("propertyMap", "PropertyMap", properties.PropertyMap != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.PropertyMap) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_RecordColumnPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mapping", cdk.validateString)(properties.mapping)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("sqlType", cdk.requiredValidator)(properties.sqlType)), errors.collect(cdk.propertyValidator("sqlType", cdk.validateString)(properties.sqlType)), errors.wrap('supplied properties not correct for "RecordColumnProperty"');
    }
    function cfnApplicationV2RecordColumnPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_RecordColumnPropertyValidator(properties).assertSuccess(), { Mapping: cdk.stringToCloudFormation(properties.mapping), Name: cdk.stringToCloudFormation(properties.name), SqlType: cdk.stringToCloudFormation(properties.sqlType) }) : properties;
    }
    function CfnApplicationV2RecordColumnPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mapping", "Mapping", properties.Mapping != null ? cfn_parse.FromCloudFormation.getString(properties.Mapping) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("sqlType", "SqlType", cfn_parse.FromCloudFormation.getString(properties.SqlType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_RecordFormatPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mappingParameters", CfnApplicationV2_MappingParametersPropertyValidator)(properties.mappingParameters)), errors.collect(cdk.propertyValidator("recordFormatType", cdk.requiredValidator)(properties.recordFormatType)), errors.collect(cdk.propertyValidator("recordFormatType", cdk.validateString)(properties.recordFormatType)), errors.wrap('supplied properties not correct for "RecordFormatProperty"');
    }
    function cfnApplicationV2RecordFormatPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_RecordFormatPropertyValidator(properties).assertSuccess(), { MappingParameters: cfnApplicationV2MappingParametersPropertyToCloudFormation(properties.mappingParameters), RecordFormatType: cdk.stringToCloudFormation(properties.recordFormatType) }) : properties;
    }
    function CfnApplicationV2RecordFormatPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mappingParameters", "MappingParameters", properties.MappingParameters != null ? CfnApplicationV2MappingParametersPropertyFromCloudFormation(properties.MappingParameters) : void 0), ret.addPropertyResult("recordFormatType", "RecordFormatType", cfn_parse.FromCloudFormation.getString(properties.RecordFormatType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_RunConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationRestoreConfiguration", CfnApplicationV2_ApplicationRestoreConfigurationPropertyValidator)(properties.applicationRestoreConfiguration)), errors.collect(cdk.propertyValidator("flinkRunConfiguration", CfnApplicationV2_FlinkRunConfigurationPropertyValidator)(properties.flinkRunConfiguration)), errors.wrap('supplied properties not correct for "RunConfigurationProperty"');
    }
    function cfnApplicationV2RunConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_RunConfigurationPropertyValidator(properties).assertSuccess(), { ApplicationRestoreConfiguration: cfnApplicationV2ApplicationRestoreConfigurationPropertyToCloudFormation(properties.applicationRestoreConfiguration), FlinkRunConfiguration: cfnApplicationV2FlinkRunConfigurationPropertyToCloudFormation(properties.flinkRunConfiguration) }) : properties;
    }
    function CfnApplicationV2RunConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationRestoreConfiguration", "ApplicationRestoreConfiguration", properties.ApplicationRestoreConfiguration != null ? CfnApplicationV2ApplicationRestoreConfigurationPropertyFromCloudFormation(properties.ApplicationRestoreConfiguration) : void 0), ret.addPropertyResult("flinkRunConfiguration", "FlinkRunConfiguration", properties.FlinkRunConfiguration != null ? CfnApplicationV2FlinkRunConfigurationPropertyFromCloudFormation(properties.FlinkRunConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_S3ContentBaseLocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("basePath", cdk.validateString)(properties.basePath)), errors.collect(cdk.propertyValidator("bucketArn", cdk.requiredValidator)(properties.bucketArn)), errors.collect(cdk.propertyValidator("bucketArn", cdk.validateString)(properties.bucketArn)), errors.wrap('supplied properties not correct for "S3ContentBaseLocationProperty"');
    }
    function cfnApplicationV2S3ContentBaseLocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_S3ContentBaseLocationPropertyValidator(properties).assertSuccess(), { BasePath: cdk.stringToCloudFormation(properties.basePath), BucketARN: cdk.stringToCloudFormation(properties.bucketArn) }) : properties;
    }
    function CfnApplicationV2S3ContentBaseLocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("basePath", "BasePath", properties.BasePath != null ? cfn_parse.FromCloudFormation.getString(properties.BasePath) : void 0), ret.addPropertyResult("bucketArn", "BucketARN", cfn_parse.FromCloudFormation.getString(properties.BucketARN)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_S3ContentLocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketArn", cdk.requiredValidator)(properties.bucketArn)), errors.collect(cdk.propertyValidator("bucketArn", cdk.validateString)(properties.bucketArn)), errors.collect(cdk.propertyValidator("fileKey", cdk.requiredValidator)(properties.fileKey)), errors.collect(cdk.propertyValidator("fileKey", cdk.validateString)(properties.fileKey)), errors.collect(cdk.propertyValidator("objectVersion", cdk.validateString)(properties.objectVersion)), errors.wrap('supplied properties not correct for "S3ContentLocationProperty"');
    }
    function cfnApplicationV2S3ContentLocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_S3ContentLocationPropertyValidator(properties).assertSuccess(), { BucketARN: cdk.stringToCloudFormation(properties.bucketArn), FileKey: cdk.stringToCloudFormation(properties.fileKey), ObjectVersion: cdk.stringToCloudFormation(properties.objectVersion) }) : properties;
    }
    function CfnApplicationV2S3ContentLocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketArn", "BucketARN", cfn_parse.FromCloudFormation.getString(properties.BucketARN)), ret.addPropertyResult("fileKey", "FileKey", cfn_parse.FromCloudFormation.getString(properties.FileKey)), ret.addPropertyResult("objectVersion", "ObjectVersion", properties.ObjectVersion != null ? cfn_parse.FromCloudFormation.getString(properties.ObjectVersion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_SqlApplicationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("inputs", cdk.listValidator(CfnApplicationV2_InputPropertyValidator))(properties.inputs)), errors.wrap('supplied properties not correct for "SqlApplicationConfigurationProperty"');
    }
    function cfnApplicationV2SqlApplicationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_SqlApplicationConfigurationPropertyValidator(properties).assertSuccess(), { Inputs: cdk.listMapper(cfnApplicationV2InputPropertyToCloudFormation)(properties.inputs) }) : properties;
    }
    function CfnApplicationV2SqlApplicationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("inputs", "Inputs", properties.Inputs != null ? cfn_parse.FromCloudFormation.getArray(CfnApplicationV2InputPropertyFromCloudFormation)(properties.Inputs) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_VpcConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.requiredValidator)(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.requiredValidator)(properties.subnetIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.wrap('supplied properties not correct for "VpcConfigurationProperty"');
    }
    function cfnApplicationV2VpcConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_VpcConfigurationPropertyValidator(properties).assertSuccess(), { SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds) }) : properties;
    }
    function CfnApplicationV2VpcConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds)), ret.addPropertyResult("subnetIds", "SubnetIds", cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_ZeppelinApplicationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalogConfiguration", CfnApplicationV2_CatalogConfigurationPropertyValidator)(properties.catalogConfiguration)), errors.collect(cdk.propertyValidator("customArtifactsConfiguration", cdk.listValidator(CfnApplicationV2_CustomArtifactConfigurationPropertyValidator))(properties.customArtifactsConfiguration)), errors.collect(cdk.propertyValidator("deployAsApplicationConfiguration", CfnApplicationV2_DeployAsApplicationConfigurationPropertyValidator)(properties.deployAsApplicationConfiguration)), errors.collect(cdk.propertyValidator("monitoringConfiguration", CfnApplicationV2_ZeppelinMonitoringConfigurationPropertyValidator)(properties.monitoringConfiguration)), errors.wrap('supplied properties not correct for "ZeppelinApplicationConfigurationProperty"');
    }
    function cfnApplicationV2ZeppelinApplicationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_ZeppelinApplicationConfigurationPropertyValidator(properties).assertSuccess(), { CatalogConfiguration: cfnApplicationV2CatalogConfigurationPropertyToCloudFormation(properties.catalogConfiguration), CustomArtifactsConfiguration: cdk.listMapper(cfnApplicationV2CustomArtifactConfigurationPropertyToCloudFormation)(properties.customArtifactsConfiguration), DeployAsApplicationConfiguration: cfnApplicationV2DeployAsApplicationConfigurationPropertyToCloudFormation(properties.deployAsApplicationConfiguration), MonitoringConfiguration: cfnApplicationV2ZeppelinMonitoringConfigurationPropertyToCloudFormation(properties.monitoringConfiguration) }) : properties;
    }
    function CfnApplicationV2ZeppelinApplicationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalogConfiguration", "CatalogConfiguration", properties.CatalogConfiguration != null ? CfnApplicationV2CatalogConfigurationPropertyFromCloudFormation(properties.CatalogConfiguration) : void 0), ret.addPropertyResult("customArtifactsConfiguration", "CustomArtifactsConfiguration", properties.CustomArtifactsConfiguration != null ? cfn_parse.FromCloudFormation.getArray(CfnApplicationV2CustomArtifactConfigurationPropertyFromCloudFormation)(properties.CustomArtifactsConfiguration) : void 0), ret.addPropertyResult("deployAsApplicationConfiguration", "DeployAsApplicationConfiguration", properties.DeployAsApplicationConfiguration != null ? CfnApplicationV2DeployAsApplicationConfigurationPropertyFromCloudFormation(properties.DeployAsApplicationConfiguration) : void 0), ret.addPropertyResult("monitoringConfiguration", "MonitoringConfiguration", properties.MonitoringConfiguration != null ? CfnApplicationV2ZeppelinMonitoringConfigurationPropertyFromCloudFormation(properties.MonitoringConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationV2_ZeppelinMonitoringConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logLevel", cdk.validateString)(properties.logLevel)), errors.wrap('supplied properties not correct for "ZeppelinMonitoringConfigurationProperty"');
    }
    function cfnApplicationV2ZeppelinMonitoringConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationV2_ZeppelinMonitoringConfigurationPropertyValidator(properties).assertSuccess(), { LogLevel: cdk.stringToCloudFormation(properties.logLevel) }) : properties;
    }
    function CfnApplicationV2ZeppelinMonitoringConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logLevel", "LogLevel", properties.LogLevel != null ? cfn_parse.FromCloudFormation.getString(properties.LogLevel) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationCloudWatchLoggingOptionV2PropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationName", cdk.requiredValidator)(properties.applicationName)), errors.collect(cdk.propertyValidator("applicationName", cdk.validateString)(properties.applicationName)), errors.collect(cdk.propertyValidator("cloudWatchLoggingOption", cdk.requiredValidator)(properties.cloudWatchLoggingOption)), errors.collect(cdk.propertyValidator("cloudWatchLoggingOption", CfnApplicationCloudWatchLoggingOptionV2_CloudWatchLoggingOptionPropertyValidator)(properties.cloudWatchLoggingOption)), errors.wrap('supplied properties not correct for "CfnApplicationCloudWatchLoggingOptionV2Props"');
    }
    function cfnApplicationCloudWatchLoggingOptionV2PropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationCloudWatchLoggingOptionV2PropsValidator(properties).assertSuccess(), { ApplicationName: cdk.stringToCloudFormation(properties.applicationName), CloudWatchLoggingOption: cfnApplicationCloudWatchLoggingOptionV2CloudWatchLoggingOptionPropertyToCloudFormation(properties.cloudWatchLoggingOption) }) : properties;
    }
    function CfnApplicationCloudWatchLoggingOptionV2PropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationName", "ApplicationName", cfn_parse.FromCloudFormation.getString(properties.ApplicationName)), ret.addPropertyResult("cloudWatchLoggingOption", "CloudWatchLoggingOption", CfnApplicationCloudWatchLoggingOptionV2CloudWatchLoggingOptionPropertyFromCloudFormation(properties.CloudWatchLoggingOption)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApplicationCloudWatchLoggingOptionV2 = class _CfnApplicationCloudWatchLoggingOptionV2 extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApplicationCloudWatchLoggingOptionV2PropsFromCloudFormation(resourceProperties), ret = new _CfnApplicationCloudWatchLoggingOptionV2(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApplicationCloudWatchLoggingOptionV2.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kinesisanalytics_CfnApplicationCloudWatchLoggingOptionV2Props(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApplicationCloudWatchLoggingOptionV2), error;
        }
        cdk.requireProperty(props, "applicationName", this), cdk.requireProperty(props, "cloudWatchLoggingOption", this), this.applicationName = props.applicationName, this.cloudWatchLoggingOption = props.cloudWatchLoggingOption;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApplicationCloudWatchLoggingOptionV2.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationName: this.applicationName, cloudWatchLoggingOption: this.cloudWatchLoggingOption };
      }
      renderProperties(props) {
        return cfnApplicationCloudWatchLoggingOptionV2PropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnApplicationCloudWatchLoggingOptionV2[_b] = { fqn: "aws-cdk-lib.aws_kinesisanalytics.CfnApplicationCloudWatchLoggingOptionV2", version: "2.80.0" }, CfnApplicationCloudWatchLoggingOptionV2.CFN_RESOURCE_TYPE_NAME = "AWS::KinesisAnalyticsV2::ApplicationCloudWatchLoggingOption", exports2.CfnApplicationCloudWatchLoggingOptionV2 = CfnApplicationCloudWatchLoggingOptionV2;
    function CfnApplicationCloudWatchLoggingOptionV2_CloudWatchLoggingOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logStreamArn", cdk.requiredValidator)(properties.logStreamArn)), errors.collect(cdk.propertyValidator("logStreamArn", cdk.validateString)(properties.logStreamArn)), errors.wrap('supplied properties not correct for "CloudWatchLoggingOptionProperty"');
    }
    function cfnApplicationCloudWatchLoggingOptionV2CloudWatchLoggingOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationCloudWatchLoggingOptionV2_CloudWatchLoggingOptionPropertyValidator(properties).assertSuccess(), { LogStreamARN: cdk.stringToCloudFormation(properties.logStreamArn) }) : properties;
    }
    function CfnApplicationCloudWatchLoggingOptionV2CloudWatchLoggingOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logStreamArn", "LogStreamARN", cfn_parse.FromCloudFormation.getString(properties.LogStreamARN)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationOutputV2PropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationName", cdk.requiredValidator)(properties.applicationName)), errors.collect(cdk.propertyValidator("applicationName", cdk.validateString)(properties.applicationName)), errors.collect(cdk.propertyValidator("output", cdk.requiredValidator)(properties.output)), errors.collect(cdk.propertyValidator("output", CfnApplicationOutputV2_OutputPropertyValidator)(properties.output)), errors.wrap('supplied properties not correct for "CfnApplicationOutputV2Props"');
    }
    function cfnApplicationOutputV2PropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationOutputV2PropsValidator(properties).assertSuccess(), { ApplicationName: cdk.stringToCloudFormation(properties.applicationName), Output: cfnApplicationOutputV2OutputPropertyToCloudFormation(properties.output) }) : properties;
    }
    function CfnApplicationOutputV2PropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationName", "ApplicationName", cfn_parse.FromCloudFormation.getString(properties.ApplicationName)), ret.addPropertyResult("output", "Output", CfnApplicationOutputV2OutputPropertyFromCloudFormation(properties.Output)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApplicationOutputV2 = class _CfnApplicationOutputV2 extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApplicationOutputV2PropsFromCloudFormation(resourceProperties), ret = new _CfnApplicationOutputV2(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApplicationOutputV2.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kinesisanalytics_CfnApplicationOutputV2Props(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApplicationOutputV2), error;
        }
        cdk.requireProperty(props, "applicationName", this), cdk.requireProperty(props, "output", this), this.applicationName = props.applicationName, this.output = props.output;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApplicationOutputV2.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationName: this.applicationName, output: this.output };
      }
      renderProperties(props) {
        return cfnApplicationOutputV2PropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnApplicationOutputV2[_c] = { fqn: "aws-cdk-lib.aws_kinesisanalytics.CfnApplicationOutputV2", version: "2.80.0" }, CfnApplicationOutputV2.CFN_RESOURCE_TYPE_NAME = "AWS::KinesisAnalyticsV2::ApplicationOutput", exports2.CfnApplicationOutputV2 = CfnApplicationOutputV2;
    function CfnApplicationOutputV2_DestinationSchemaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("recordFormatType", cdk.validateString)(properties.recordFormatType)), errors.wrap('supplied properties not correct for "DestinationSchemaProperty"');
    }
    function cfnApplicationOutputV2DestinationSchemaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationOutputV2_DestinationSchemaPropertyValidator(properties).assertSuccess(), { RecordFormatType: cdk.stringToCloudFormation(properties.recordFormatType) }) : properties;
    }
    function CfnApplicationOutputV2DestinationSchemaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("recordFormatType", "RecordFormatType", properties.RecordFormatType != null ? cfn_parse.FromCloudFormation.getString(properties.RecordFormatType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationOutputV2_KinesisFirehoseOutputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceArn", cdk.requiredValidator)(properties.resourceArn)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.wrap('supplied properties not correct for "KinesisFirehoseOutputProperty"');
    }
    function cfnApplicationOutputV2KinesisFirehoseOutputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationOutputV2_KinesisFirehoseOutputPropertyValidator(properties).assertSuccess(), { ResourceARN: cdk.stringToCloudFormation(properties.resourceArn) }) : properties;
    }
    function CfnApplicationOutputV2KinesisFirehoseOutputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceArn", "ResourceARN", cfn_parse.FromCloudFormation.getString(properties.ResourceARN)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationOutputV2_KinesisStreamsOutputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceArn", cdk.requiredValidator)(properties.resourceArn)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.wrap('supplied properties not correct for "KinesisStreamsOutputProperty"');
    }
    function cfnApplicationOutputV2KinesisStreamsOutputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationOutputV2_KinesisStreamsOutputPropertyValidator(properties).assertSuccess(), { ResourceARN: cdk.stringToCloudFormation(properties.resourceArn) }) : properties;
    }
    function CfnApplicationOutputV2KinesisStreamsOutputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceArn", "ResourceARN", cfn_parse.FromCloudFormation.getString(properties.ResourceARN)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationOutputV2_LambdaOutputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceArn", cdk.requiredValidator)(properties.resourceArn)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.wrap('supplied properties not correct for "LambdaOutputProperty"');
    }
    function cfnApplicationOutputV2LambdaOutputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationOutputV2_LambdaOutputPropertyValidator(properties).assertSuccess(), { ResourceARN: cdk.stringToCloudFormation(properties.resourceArn) }) : properties;
    }
    function CfnApplicationOutputV2LambdaOutputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceArn", "ResourceARN", cfn_parse.FromCloudFormation.getString(properties.ResourceARN)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationOutputV2_OutputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationSchema", cdk.requiredValidator)(properties.destinationSchema)), errors.collect(cdk.propertyValidator("destinationSchema", CfnApplicationOutputV2_DestinationSchemaPropertyValidator)(properties.destinationSchema)), errors.collect(cdk.propertyValidator("kinesisFirehoseOutput", CfnApplicationOutputV2_KinesisFirehoseOutputPropertyValidator)(properties.kinesisFirehoseOutput)), errors.collect(cdk.propertyValidator("kinesisStreamsOutput", CfnApplicationOutputV2_KinesisStreamsOutputPropertyValidator)(properties.kinesisStreamsOutput)), errors.collect(cdk.propertyValidator("lambdaOutput", CfnApplicationOutputV2_LambdaOutputPropertyValidator)(properties.lambdaOutput)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "OutputProperty"');
    }
    function cfnApplicationOutputV2OutputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationOutputV2_OutputPropertyValidator(properties).assertSuccess(), { DestinationSchema: cfnApplicationOutputV2DestinationSchemaPropertyToCloudFormation(properties.destinationSchema), KinesisFirehoseOutput: cfnApplicationOutputV2KinesisFirehoseOutputPropertyToCloudFormation(properties.kinesisFirehoseOutput), KinesisStreamsOutput: cfnApplicationOutputV2KinesisStreamsOutputPropertyToCloudFormation(properties.kinesisStreamsOutput), LambdaOutput: cfnApplicationOutputV2LambdaOutputPropertyToCloudFormation(properties.lambdaOutput), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnApplicationOutputV2OutputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationSchema", "DestinationSchema", CfnApplicationOutputV2DestinationSchemaPropertyFromCloudFormation(properties.DestinationSchema)), ret.addPropertyResult("kinesisFirehoseOutput", "KinesisFirehoseOutput", properties.KinesisFirehoseOutput != null ? CfnApplicationOutputV2KinesisFirehoseOutputPropertyFromCloudFormation(properties.KinesisFirehoseOutput) : void 0), ret.addPropertyResult("kinesisStreamsOutput", "KinesisStreamsOutput", properties.KinesisStreamsOutput != null ? CfnApplicationOutputV2KinesisStreamsOutputPropertyFromCloudFormation(properties.KinesisStreamsOutput) : void 0), ret.addPropertyResult("lambdaOutput", "LambdaOutput", properties.LambdaOutput != null ? CfnApplicationOutputV2LambdaOutputPropertyFromCloudFormation(properties.LambdaOutput) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationReferenceDataSourceV2PropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationName", cdk.requiredValidator)(properties.applicationName)), errors.collect(cdk.propertyValidator("applicationName", cdk.validateString)(properties.applicationName)), errors.collect(cdk.propertyValidator("referenceDataSource", cdk.requiredValidator)(properties.referenceDataSource)), errors.collect(cdk.propertyValidator("referenceDataSource", CfnApplicationReferenceDataSourceV2_ReferenceDataSourcePropertyValidator)(properties.referenceDataSource)), errors.wrap('supplied properties not correct for "CfnApplicationReferenceDataSourceV2Props"');
    }
    function cfnApplicationReferenceDataSourceV2PropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationReferenceDataSourceV2PropsValidator(properties).assertSuccess(), { ApplicationName: cdk.stringToCloudFormation(properties.applicationName), ReferenceDataSource: cfnApplicationReferenceDataSourceV2ReferenceDataSourcePropertyToCloudFormation(properties.referenceDataSource) }) : properties;
    }
    function CfnApplicationReferenceDataSourceV2PropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationName", "ApplicationName", cfn_parse.FromCloudFormation.getString(properties.ApplicationName)), ret.addPropertyResult("referenceDataSource", "ReferenceDataSource", CfnApplicationReferenceDataSourceV2ReferenceDataSourcePropertyFromCloudFormation(properties.ReferenceDataSource)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApplicationReferenceDataSourceV2 = class _CfnApplicationReferenceDataSourceV2 extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApplicationReferenceDataSourceV2PropsFromCloudFormation(resourceProperties), ret = new _CfnApplicationReferenceDataSourceV2(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApplicationReferenceDataSourceV2.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kinesisanalytics_CfnApplicationReferenceDataSourceV2Props(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApplicationReferenceDataSourceV2), error;
        }
        cdk.requireProperty(props, "applicationName", this), cdk.requireProperty(props, "referenceDataSource", this), this.applicationName = props.applicationName, this.referenceDataSource = props.referenceDataSource;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApplicationReferenceDataSourceV2.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationName: this.applicationName, referenceDataSource: this.referenceDataSource };
      }
      renderProperties(props) {
        return cfnApplicationReferenceDataSourceV2PropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnApplicationReferenceDataSourceV2[_d] = { fqn: "aws-cdk-lib.aws_kinesisanalytics.CfnApplicationReferenceDataSourceV2", version: "2.80.0" }, CfnApplicationReferenceDataSourceV2.CFN_RESOURCE_TYPE_NAME = "AWS::KinesisAnalyticsV2::ApplicationReferenceDataSource", exports2.CfnApplicationReferenceDataSourceV2 = CfnApplicationReferenceDataSourceV2;
    function CfnApplicationReferenceDataSourceV2_CSVMappingParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("recordColumnDelimiter", cdk.requiredValidator)(properties.recordColumnDelimiter)), errors.collect(cdk.propertyValidator("recordColumnDelimiter", cdk.validateString)(properties.recordColumnDelimiter)), errors.collect(cdk.propertyValidator("recordRowDelimiter", cdk.requiredValidator)(properties.recordRowDelimiter)), errors.collect(cdk.propertyValidator("recordRowDelimiter", cdk.validateString)(properties.recordRowDelimiter)), errors.wrap('supplied properties not correct for "CSVMappingParametersProperty"');
    }
    function cfnApplicationReferenceDataSourceV2CSVMappingParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationReferenceDataSourceV2_CSVMappingParametersPropertyValidator(properties).assertSuccess(), { RecordColumnDelimiter: cdk.stringToCloudFormation(properties.recordColumnDelimiter), RecordRowDelimiter: cdk.stringToCloudFormation(properties.recordRowDelimiter) }) : properties;
    }
    function CfnApplicationReferenceDataSourceV2CSVMappingParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("recordColumnDelimiter", "RecordColumnDelimiter", cfn_parse.FromCloudFormation.getString(properties.RecordColumnDelimiter)), ret.addPropertyResult("recordRowDelimiter", "RecordRowDelimiter", cfn_parse.FromCloudFormation.getString(properties.RecordRowDelimiter)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationReferenceDataSourceV2_JSONMappingParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("recordRowPath", cdk.requiredValidator)(properties.recordRowPath)), errors.collect(cdk.propertyValidator("recordRowPath", cdk.validateString)(properties.recordRowPath)), errors.wrap('supplied properties not correct for "JSONMappingParametersProperty"');
    }
    function cfnApplicationReferenceDataSourceV2JSONMappingParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationReferenceDataSourceV2_JSONMappingParametersPropertyValidator(properties).assertSuccess(), { RecordRowPath: cdk.stringToCloudFormation(properties.recordRowPath) }) : properties;
    }
    function CfnApplicationReferenceDataSourceV2JSONMappingParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("recordRowPath", "RecordRowPath", cfn_parse.FromCloudFormation.getString(properties.RecordRowPath)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationReferenceDataSourceV2_MappingParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("csvMappingParameters", CfnApplicationReferenceDataSourceV2_CSVMappingParametersPropertyValidator)(properties.csvMappingParameters)), errors.collect(cdk.propertyValidator("jsonMappingParameters", CfnApplicationReferenceDataSourceV2_JSONMappingParametersPropertyValidator)(properties.jsonMappingParameters)), errors.wrap('supplied properties not correct for "MappingParametersProperty"');
    }
    function cfnApplicationReferenceDataSourceV2MappingParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationReferenceDataSourceV2_MappingParametersPropertyValidator(properties).assertSuccess(), { CSVMappingParameters: cfnApplicationReferenceDataSourceV2CSVMappingParametersPropertyToCloudFormation(properties.csvMappingParameters), JSONMappingParameters: cfnApplicationReferenceDataSourceV2JSONMappingParametersPropertyToCloudFormation(properties.jsonMappingParameters) }) : properties;
    }
    function CfnApplicationReferenceDataSourceV2MappingParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("csvMappingParameters", "CSVMappingParameters", properties.CSVMappingParameters != null ? CfnApplicationReferenceDataSourceV2CSVMappingParametersPropertyFromCloudFormation(properties.CSVMappingParameters) : void 0), ret.addPropertyResult("jsonMappingParameters", "JSONMappingParameters", properties.JSONMappingParameters != null ? CfnApplicationReferenceDataSourceV2JSONMappingParametersPropertyFromCloudFormation(properties.JSONMappingParameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationReferenceDataSourceV2_RecordColumnPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mapping", cdk.validateString)(properties.mapping)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("sqlType", cdk.requiredValidator)(properties.sqlType)), errors.collect(cdk.propertyValidator("sqlType", cdk.validateString)(properties.sqlType)), errors.wrap('supplied properties not correct for "RecordColumnProperty"');
    }
    function cfnApplicationReferenceDataSourceV2RecordColumnPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationReferenceDataSourceV2_RecordColumnPropertyValidator(properties).assertSuccess(), { Mapping: cdk.stringToCloudFormation(properties.mapping), Name: cdk.stringToCloudFormation(properties.name), SqlType: cdk.stringToCloudFormation(properties.sqlType) }) : properties;
    }
    function CfnApplicationReferenceDataSourceV2RecordColumnPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mapping", "Mapping", properties.Mapping != null ? cfn_parse.FromCloudFormation.getString(properties.Mapping) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("sqlType", "SqlType", cfn_parse.FromCloudFormation.getString(properties.SqlType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationReferenceDataSourceV2_RecordFormatPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mappingParameters", CfnApplicationReferenceDataSourceV2_MappingParametersPropertyValidator)(properties.mappingParameters)), errors.collect(cdk.propertyValidator("recordFormatType", cdk.requiredValidator)(properties.recordFormatType)), errors.collect(cdk.propertyValidator("recordFormatType", cdk.validateString)(properties.recordFormatType)), errors.wrap('supplied properties not correct for "RecordFormatProperty"');
    }
    function cfnApplicationReferenceDataSourceV2RecordFormatPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationReferenceDataSourceV2_RecordFormatPropertyValidator(properties).assertSuccess(), { MappingParameters: cfnApplicationReferenceDataSourceV2MappingParametersPropertyToCloudFormation(properties.mappingParameters), RecordFormatType: cdk.stringToCloudFormation(properties.recordFormatType) }) : properties;
    }
    function CfnApplicationReferenceDataSourceV2RecordFormatPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mappingParameters", "MappingParameters", properties.MappingParameters != null ? CfnApplicationReferenceDataSourceV2MappingParametersPropertyFromCloudFormation(properties.MappingParameters) : void 0), ret.addPropertyResult("recordFormatType", "RecordFormatType", cfn_parse.FromCloudFormation.getString(properties.RecordFormatType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationReferenceDataSourceV2_ReferenceDataSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("referenceSchema", cdk.requiredValidator)(properties.referenceSchema)), errors.collect(cdk.propertyValidator("referenceSchema", CfnApplicationReferenceDataSourceV2_ReferenceSchemaPropertyValidator)(properties.referenceSchema)), errors.collect(cdk.propertyValidator("s3ReferenceDataSource", CfnApplicationReferenceDataSourceV2_S3ReferenceDataSourcePropertyValidator)(properties.s3ReferenceDataSource)), errors.collect(cdk.propertyValidator("tableName", cdk.validateString)(properties.tableName)), errors.wrap('supplied properties not correct for "ReferenceDataSourceProperty"');
    }
    function cfnApplicationReferenceDataSourceV2ReferenceDataSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationReferenceDataSourceV2_ReferenceDataSourcePropertyValidator(properties).assertSuccess(), { ReferenceSchema: cfnApplicationReferenceDataSourceV2ReferenceSchemaPropertyToCloudFormation(properties.referenceSchema), S3ReferenceDataSource: cfnApplicationReferenceDataSourceV2S3ReferenceDataSourcePropertyToCloudFormation(properties.s3ReferenceDataSource), TableName: cdk.stringToCloudFormation(properties.tableName) }) : properties;
    }
    function CfnApplicationReferenceDataSourceV2ReferenceDataSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("referenceSchema", "ReferenceSchema", CfnApplicationReferenceDataSourceV2ReferenceSchemaPropertyFromCloudFormation(properties.ReferenceSchema)), ret.addPropertyResult("s3ReferenceDataSource", "S3ReferenceDataSource", properties.S3ReferenceDataSource != null ? CfnApplicationReferenceDataSourceV2S3ReferenceDataSourcePropertyFromCloudFormation(properties.S3ReferenceDataSource) : void 0), ret.addPropertyResult("tableName", "TableName", properties.TableName != null ? cfn_parse.FromCloudFormation.getString(properties.TableName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationReferenceDataSourceV2_ReferenceSchemaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("recordColumns", cdk.requiredValidator)(properties.recordColumns)), errors.collect(cdk.propertyValidator("recordColumns", cdk.listValidator(CfnApplicationReferenceDataSourceV2_RecordColumnPropertyValidator))(properties.recordColumns)), errors.collect(cdk.propertyValidator("recordEncoding", cdk.validateString)(properties.recordEncoding)), errors.collect(cdk.propertyValidator("recordFormat", cdk.requiredValidator)(properties.recordFormat)), errors.collect(cdk.propertyValidator("recordFormat", CfnApplicationReferenceDataSourceV2_RecordFormatPropertyValidator)(properties.recordFormat)), errors.wrap('supplied properties not correct for "ReferenceSchemaProperty"');
    }
    function cfnApplicationReferenceDataSourceV2ReferenceSchemaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationReferenceDataSourceV2_ReferenceSchemaPropertyValidator(properties).assertSuccess(), { RecordColumns: cdk.listMapper(cfnApplicationReferenceDataSourceV2RecordColumnPropertyToCloudFormation)(properties.recordColumns), RecordEncoding: cdk.stringToCloudFormation(properties.recordEncoding), RecordFormat: cfnApplicationReferenceDataSourceV2RecordFormatPropertyToCloudFormation(properties.recordFormat) }) : properties;
    }
    function CfnApplicationReferenceDataSourceV2ReferenceSchemaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("recordColumns", "RecordColumns", cfn_parse.FromCloudFormation.getArray(CfnApplicationReferenceDataSourceV2RecordColumnPropertyFromCloudFormation)(properties.RecordColumns)), ret.addPropertyResult("recordEncoding", "RecordEncoding", properties.RecordEncoding != null ? cfn_parse.FromCloudFormation.getString(properties.RecordEncoding) : void 0), ret.addPropertyResult("recordFormat", "RecordFormat", CfnApplicationReferenceDataSourceV2RecordFormatPropertyFromCloudFormation(properties.RecordFormat)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationReferenceDataSourceV2_S3ReferenceDataSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketArn", cdk.requiredValidator)(properties.bucketArn)), errors.collect(cdk.propertyValidator("bucketArn", cdk.validateString)(properties.bucketArn)), errors.collect(cdk.propertyValidator("fileKey", cdk.requiredValidator)(properties.fileKey)), errors.collect(cdk.propertyValidator("fileKey", cdk.validateString)(properties.fileKey)), errors.wrap('supplied properties not correct for "S3ReferenceDataSourceProperty"');
    }
    function cfnApplicationReferenceDataSourceV2S3ReferenceDataSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationReferenceDataSourceV2_S3ReferenceDataSourcePropertyValidator(properties).assertSuccess(), { BucketARN: cdk.stringToCloudFormation(properties.bucketArn), FileKey: cdk.stringToCloudFormation(properties.fileKey) }) : properties;
    }
    function CfnApplicationReferenceDataSourceV2S3ReferenceDataSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketArn", "BucketARN", cfn_parse.FromCloudFormation.getString(properties.BucketARN)), ret.addPropertyResult("fileKey", "FileKey", cfn_parse.FromCloudFormation.getString(properties.FileKey)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-kinesisanalytics/lib/index.js
var require_lib166 = __commonJS({
  "node_modules/aws-cdk-lib/aws-kinesisanalytics/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_kinesisanalytics_generated(), exports2), __exportStar(require_kinesisanalyticsv2_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-kinesisanalytics/index.js
var require_aws_kinesisanalytics = __commonJS({
  "node_modules/aws-cdk-lib/aws-kinesisanalytics/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib166(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-kinesisanalyticsv2/lib/kinesisanalyticsv2.generated.js
var require_kinesisanalyticsv2_generated2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-kinesisanalyticsv2/lib/kinesisanalyticsv2.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnApplicationReferenceDataSource = exports2.CfnApplicationOutput = exports2.CfnApplicationCloudWatchLoggingOption = exports2.CfnApplication = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnApplicationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationConfiguration", CfnApplication_ApplicationConfigurationPropertyValidator)(properties.applicationConfiguration)), errors.collect(cdk.propertyValidator("applicationDescription", cdk.validateString)(properties.applicationDescription)), errors.collect(cdk.propertyValidator("applicationMaintenanceConfiguration", CfnApplication_ApplicationMaintenanceConfigurationPropertyValidator)(properties.applicationMaintenanceConfiguration)), errors.collect(cdk.propertyValidator("applicationMode", cdk.validateString)(properties.applicationMode)), errors.collect(cdk.propertyValidator("applicationName", cdk.validateString)(properties.applicationName)), errors.collect(cdk.propertyValidator("runConfiguration", CfnApplication_RunConfigurationPropertyValidator)(properties.runConfiguration)), errors.collect(cdk.propertyValidator("runtimeEnvironment", cdk.requiredValidator)(properties.runtimeEnvironment)), errors.collect(cdk.propertyValidator("runtimeEnvironment", cdk.validateString)(properties.runtimeEnvironment)), errors.collect(cdk.propertyValidator("serviceExecutionRole", cdk.requiredValidator)(properties.serviceExecutionRole)), errors.collect(cdk.propertyValidator("serviceExecutionRole", cdk.validateString)(properties.serviceExecutionRole)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnApplicationProps"');
    }
    function cfnApplicationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationPropsValidator(properties).assertSuccess(), { RuntimeEnvironment: cdk.stringToCloudFormation(properties.runtimeEnvironment), ServiceExecutionRole: cdk.stringToCloudFormation(properties.serviceExecutionRole), ApplicationConfiguration: cfnApplicationApplicationConfigurationPropertyToCloudFormation(properties.applicationConfiguration), ApplicationDescription: cdk.stringToCloudFormation(properties.applicationDescription), ApplicationMaintenanceConfiguration: cfnApplicationApplicationMaintenanceConfigurationPropertyToCloudFormation(properties.applicationMaintenanceConfiguration), ApplicationMode: cdk.stringToCloudFormation(properties.applicationMode), ApplicationName: cdk.stringToCloudFormation(properties.applicationName), RunConfiguration: cfnApplicationRunConfigurationPropertyToCloudFormation(properties.runConfiguration), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnApplicationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("runtimeEnvironment", "RuntimeEnvironment", cfn_parse.FromCloudFormation.getString(properties.RuntimeEnvironment)), ret.addPropertyResult("serviceExecutionRole", "ServiceExecutionRole", cfn_parse.FromCloudFormation.getString(properties.ServiceExecutionRole)), ret.addPropertyResult("applicationConfiguration", "ApplicationConfiguration", properties.ApplicationConfiguration != null ? CfnApplicationApplicationConfigurationPropertyFromCloudFormation(properties.ApplicationConfiguration) : void 0), ret.addPropertyResult("applicationDescription", "ApplicationDescription", properties.ApplicationDescription != null ? cfn_parse.FromCloudFormation.getString(properties.ApplicationDescription) : void 0), ret.addPropertyResult("applicationMaintenanceConfiguration", "ApplicationMaintenanceConfiguration", properties.ApplicationMaintenanceConfiguration != null ? CfnApplicationApplicationMaintenanceConfigurationPropertyFromCloudFormation(properties.ApplicationMaintenanceConfiguration) : void 0), ret.addPropertyResult("applicationMode", "ApplicationMode", properties.ApplicationMode != null ? cfn_parse.FromCloudFormation.getString(properties.ApplicationMode) : void 0), ret.addPropertyResult("applicationName", "ApplicationName", properties.ApplicationName != null ? cfn_parse.FromCloudFormation.getString(properties.ApplicationName) : void 0), ret.addPropertyResult("runConfiguration", "RunConfiguration", properties.RunConfiguration != null ? CfnApplicationRunConfigurationPropertyFromCloudFormation(properties.RunConfiguration) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApplication = class _CfnApplication extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApplicationPropsFromCloudFormation(resourceProperties), ret = new _CfnApplication(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApplication.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApplication), error;
        }
        cdk.requireProperty(props, "runtimeEnvironment", this), cdk.requireProperty(props, "serviceExecutionRole", this), this.runtimeEnvironment = props.runtimeEnvironment, this.serviceExecutionRole = props.serviceExecutionRole, this.applicationConfiguration = props.applicationConfiguration, this.applicationDescription = props.applicationDescription, this.applicationMaintenanceConfiguration = props.applicationMaintenanceConfiguration, this.applicationMode = props.applicationMode, this.applicationName = props.applicationName, this.runConfiguration = props.runConfiguration, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::KinesisAnalyticsV2::Application", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApplication.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { runtimeEnvironment: this.runtimeEnvironment, serviceExecutionRole: this.serviceExecutionRole, applicationConfiguration: this.applicationConfiguration, applicationDescription: this.applicationDescription, applicationMaintenanceConfiguration: this.applicationMaintenanceConfiguration, applicationMode: this.applicationMode, applicationName: this.applicationName, runConfiguration: this.runConfiguration, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnApplicationPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnApplication[_a] = { fqn: "aws-cdk-lib.aws_kinesisanalyticsv2.CfnApplication", version: "2.80.0" }, CfnApplication.CFN_RESOURCE_TYPE_NAME = "AWS::KinesisAnalyticsV2::Application", exports2.CfnApplication = CfnApplication;
    function CfnApplication_ApplicationCodeConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("codeContent", cdk.requiredValidator)(properties.codeContent)), errors.collect(cdk.propertyValidator("codeContent", CfnApplication_CodeContentPropertyValidator)(properties.codeContent)), errors.collect(cdk.propertyValidator("codeContentType", cdk.requiredValidator)(properties.codeContentType)), errors.collect(cdk.propertyValidator("codeContentType", cdk.validateString)(properties.codeContentType)), errors.wrap('supplied properties not correct for "ApplicationCodeConfigurationProperty"');
    }
    function cfnApplicationApplicationCodeConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_ApplicationCodeConfigurationPropertyValidator(properties).assertSuccess(), { CodeContent: cfnApplicationCodeContentPropertyToCloudFormation(properties.codeContent), CodeContentType: cdk.stringToCloudFormation(properties.codeContentType) }) : properties;
    }
    function CfnApplicationApplicationCodeConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("codeContent", "CodeContent", CfnApplicationCodeContentPropertyFromCloudFormation(properties.CodeContent)), ret.addPropertyResult("codeContentType", "CodeContentType", cfn_parse.FromCloudFormation.getString(properties.CodeContentType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_ApplicationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationCodeConfiguration", CfnApplication_ApplicationCodeConfigurationPropertyValidator)(properties.applicationCodeConfiguration)), errors.collect(cdk.propertyValidator("applicationSnapshotConfiguration", CfnApplication_ApplicationSnapshotConfigurationPropertyValidator)(properties.applicationSnapshotConfiguration)), errors.collect(cdk.propertyValidator("environmentProperties", CfnApplication_EnvironmentPropertiesPropertyValidator)(properties.environmentProperties)), errors.collect(cdk.propertyValidator("flinkApplicationConfiguration", CfnApplication_FlinkApplicationConfigurationPropertyValidator)(properties.flinkApplicationConfiguration)), errors.collect(cdk.propertyValidator("sqlApplicationConfiguration", CfnApplication_SqlApplicationConfigurationPropertyValidator)(properties.sqlApplicationConfiguration)), errors.collect(cdk.propertyValidator("vpcConfigurations", cdk.listValidator(CfnApplication_VpcConfigurationPropertyValidator))(properties.vpcConfigurations)), errors.collect(cdk.propertyValidator("zeppelinApplicationConfiguration", CfnApplication_ZeppelinApplicationConfigurationPropertyValidator)(properties.zeppelinApplicationConfiguration)), errors.wrap('supplied properties not correct for "ApplicationConfigurationProperty"');
    }
    function cfnApplicationApplicationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_ApplicationConfigurationPropertyValidator(properties).assertSuccess(), { ApplicationCodeConfiguration: cfnApplicationApplicationCodeConfigurationPropertyToCloudFormation(properties.applicationCodeConfiguration), ApplicationSnapshotConfiguration: cfnApplicationApplicationSnapshotConfigurationPropertyToCloudFormation(properties.applicationSnapshotConfiguration), EnvironmentProperties: cfnApplicationEnvironmentPropertiesPropertyToCloudFormation(properties.environmentProperties), FlinkApplicationConfiguration: cfnApplicationFlinkApplicationConfigurationPropertyToCloudFormation(properties.flinkApplicationConfiguration), SqlApplicationConfiguration: cfnApplicationSqlApplicationConfigurationPropertyToCloudFormation(properties.sqlApplicationConfiguration), VpcConfigurations: cdk.listMapper(cfnApplicationVpcConfigurationPropertyToCloudFormation)(properties.vpcConfigurations), ZeppelinApplicationConfiguration: cfnApplicationZeppelinApplicationConfigurationPropertyToCloudFormation(properties.zeppelinApplicationConfiguration) }) : properties;
    }
    function CfnApplicationApplicationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationCodeConfiguration", "ApplicationCodeConfiguration", properties.ApplicationCodeConfiguration != null ? CfnApplicationApplicationCodeConfigurationPropertyFromCloudFormation(properties.ApplicationCodeConfiguration) : void 0), ret.addPropertyResult("applicationSnapshotConfiguration", "ApplicationSnapshotConfiguration", properties.ApplicationSnapshotConfiguration != null ? CfnApplicationApplicationSnapshotConfigurationPropertyFromCloudFormation(properties.ApplicationSnapshotConfiguration) : void 0), ret.addPropertyResult("environmentProperties", "EnvironmentProperties", properties.EnvironmentProperties != null ? CfnApplicationEnvironmentPropertiesPropertyFromCloudFormation(properties.EnvironmentProperties) : void 0), ret.addPropertyResult("flinkApplicationConfiguration", "FlinkApplicationConfiguration", properties.FlinkApplicationConfiguration != null ? CfnApplicationFlinkApplicationConfigurationPropertyFromCloudFormation(properties.FlinkApplicationConfiguration) : void 0), ret.addPropertyResult("sqlApplicationConfiguration", "SqlApplicationConfiguration", properties.SqlApplicationConfiguration != null ? CfnApplicationSqlApplicationConfigurationPropertyFromCloudFormation(properties.SqlApplicationConfiguration) : void 0), ret.addPropertyResult("vpcConfigurations", "VpcConfigurations", properties.VpcConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnApplicationVpcConfigurationPropertyFromCloudFormation)(properties.VpcConfigurations) : void 0), ret.addPropertyResult("zeppelinApplicationConfiguration", "ZeppelinApplicationConfiguration", properties.ZeppelinApplicationConfiguration != null ? CfnApplicationZeppelinApplicationConfigurationPropertyFromCloudFormation(properties.ZeppelinApplicationConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_ApplicationMaintenanceConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationMaintenanceWindowStartTime", cdk.requiredValidator)(properties.applicationMaintenanceWindowStartTime)), errors.collect(cdk.propertyValidator("applicationMaintenanceWindowStartTime", cdk.validateString)(properties.applicationMaintenanceWindowStartTime)), errors.wrap('supplied properties not correct for "ApplicationMaintenanceConfigurationProperty"');
    }
    function cfnApplicationApplicationMaintenanceConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_ApplicationMaintenanceConfigurationPropertyValidator(properties).assertSuccess(), { ApplicationMaintenanceWindowStartTime: cdk.stringToCloudFormation(properties.applicationMaintenanceWindowStartTime) }) : properties;
    }
    function CfnApplicationApplicationMaintenanceConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationMaintenanceWindowStartTime", "ApplicationMaintenanceWindowStartTime", cfn_parse.FromCloudFormation.getString(properties.ApplicationMaintenanceWindowStartTime)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_ApplicationRestoreConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationRestoreType", cdk.requiredValidator)(properties.applicationRestoreType)), errors.collect(cdk.propertyValidator("applicationRestoreType", cdk.validateString)(properties.applicationRestoreType)), errors.collect(cdk.propertyValidator("snapshotName", cdk.validateString)(properties.snapshotName)), errors.wrap('supplied properties not correct for "ApplicationRestoreConfigurationProperty"');
    }
    function cfnApplicationApplicationRestoreConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_ApplicationRestoreConfigurationPropertyValidator(properties).assertSuccess(), { ApplicationRestoreType: cdk.stringToCloudFormation(properties.applicationRestoreType), SnapshotName: cdk.stringToCloudFormation(properties.snapshotName) }) : properties;
    }
    function CfnApplicationApplicationRestoreConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationRestoreType", "ApplicationRestoreType", cfn_parse.FromCloudFormation.getString(properties.ApplicationRestoreType)), ret.addPropertyResult("snapshotName", "SnapshotName", properties.SnapshotName != null ? cfn_parse.FromCloudFormation.getString(properties.SnapshotName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_ApplicationSnapshotConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("snapshotsEnabled", cdk.requiredValidator)(properties.snapshotsEnabled)), errors.collect(cdk.propertyValidator("snapshotsEnabled", cdk.validateBoolean)(properties.snapshotsEnabled)), errors.wrap('supplied properties not correct for "ApplicationSnapshotConfigurationProperty"');
    }
    function cfnApplicationApplicationSnapshotConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_ApplicationSnapshotConfigurationPropertyValidator(properties).assertSuccess(), { SnapshotsEnabled: cdk.booleanToCloudFormation(properties.snapshotsEnabled) }) : properties;
    }
    function CfnApplicationApplicationSnapshotConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("snapshotsEnabled", "SnapshotsEnabled", cfn_parse.FromCloudFormation.getBoolean(properties.SnapshotsEnabled)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_CSVMappingParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("recordColumnDelimiter", cdk.requiredValidator)(properties.recordColumnDelimiter)), errors.collect(cdk.propertyValidator("recordColumnDelimiter", cdk.validateString)(properties.recordColumnDelimiter)), errors.collect(cdk.propertyValidator("recordRowDelimiter", cdk.requiredValidator)(properties.recordRowDelimiter)), errors.collect(cdk.propertyValidator("recordRowDelimiter", cdk.validateString)(properties.recordRowDelimiter)), errors.wrap('supplied properties not correct for "CSVMappingParametersProperty"');
    }
    function cfnApplicationCSVMappingParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_CSVMappingParametersPropertyValidator(properties).assertSuccess(), { RecordColumnDelimiter: cdk.stringToCloudFormation(properties.recordColumnDelimiter), RecordRowDelimiter: cdk.stringToCloudFormation(properties.recordRowDelimiter) }) : properties;
    }
    function CfnApplicationCSVMappingParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("recordColumnDelimiter", "RecordColumnDelimiter", cfn_parse.FromCloudFormation.getString(properties.RecordColumnDelimiter)), ret.addPropertyResult("recordRowDelimiter", "RecordRowDelimiter", cfn_parse.FromCloudFormation.getString(properties.RecordRowDelimiter)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_CatalogConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("glueDataCatalogConfiguration", CfnApplication_GlueDataCatalogConfigurationPropertyValidator)(properties.glueDataCatalogConfiguration)), errors.wrap('supplied properties not correct for "CatalogConfigurationProperty"');
    }
    function cfnApplicationCatalogConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_CatalogConfigurationPropertyValidator(properties).assertSuccess(), { GlueDataCatalogConfiguration: cfnApplicationGlueDataCatalogConfigurationPropertyToCloudFormation(properties.glueDataCatalogConfiguration) }) : properties;
    }
    function CfnApplicationCatalogConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("glueDataCatalogConfiguration", "GlueDataCatalogConfiguration", properties.GlueDataCatalogConfiguration != null ? CfnApplicationGlueDataCatalogConfigurationPropertyFromCloudFormation(properties.GlueDataCatalogConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_CheckpointConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("checkpointInterval", cdk.validateNumber)(properties.checkpointInterval)), errors.collect(cdk.propertyValidator("checkpointingEnabled", cdk.validateBoolean)(properties.checkpointingEnabled)), errors.collect(cdk.propertyValidator("configurationType", cdk.requiredValidator)(properties.configurationType)), errors.collect(cdk.propertyValidator("configurationType", cdk.validateString)(properties.configurationType)), errors.collect(cdk.propertyValidator("minPauseBetweenCheckpoints", cdk.validateNumber)(properties.minPauseBetweenCheckpoints)), errors.wrap('supplied properties not correct for "CheckpointConfigurationProperty"');
    }
    function cfnApplicationCheckpointConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_CheckpointConfigurationPropertyValidator(properties).assertSuccess(), { CheckpointInterval: cdk.numberToCloudFormation(properties.checkpointInterval), CheckpointingEnabled: cdk.booleanToCloudFormation(properties.checkpointingEnabled), ConfigurationType: cdk.stringToCloudFormation(properties.configurationType), MinPauseBetweenCheckpoints: cdk.numberToCloudFormation(properties.minPauseBetweenCheckpoints) }) : properties;
    }
    function CfnApplicationCheckpointConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("checkpointInterval", "CheckpointInterval", properties.CheckpointInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.CheckpointInterval) : void 0), ret.addPropertyResult("checkpointingEnabled", "CheckpointingEnabled", properties.CheckpointingEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CheckpointingEnabled) : void 0), ret.addPropertyResult("configurationType", "ConfigurationType", cfn_parse.FromCloudFormation.getString(properties.ConfigurationType)), ret.addPropertyResult("minPauseBetweenCheckpoints", "MinPauseBetweenCheckpoints", properties.MinPauseBetweenCheckpoints != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinPauseBetweenCheckpoints) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_CodeContentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3ContentLocation", CfnApplication_S3ContentLocationPropertyValidator)(properties.s3ContentLocation)), errors.collect(cdk.propertyValidator("textContent", cdk.validateString)(properties.textContent)), errors.collect(cdk.propertyValidator("zipFileContent", cdk.validateString)(properties.zipFileContent)), errors.wrap('supplied properties not correct for "CodeContentProperty"');
    }
    function cfnApplicationCodeContentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_CodeContentPropertyValidator(properties).assertSuccess(), { S3ContentLocation: cfnApplicationS3ContentLocationPropertyToCloudFormation(properties.s3ContentLocation), TextContent: cdk.stringToCloudFormation(properties.textContent), ZipFileContent: cdk.stringToCloudFormation(properties.zipFileContent) }) : properties;
    }
    function CfnApplicationCodeContentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3ContentLocation", "S3ContentLocation", properties.S3ContentLocation != null ? CfnApplicationS3ContentLocationPropertyFromCloudFormation(properties.S3ContentLocation) : void 0), ret.addPropertyResult("textContent", "TextContent", properties.TextContent != null ? cfn_parse.FromCloudFormation.getString(properties.TextContent) : void 0), ret.addPropertyResult("zipFileContent", "ZipFileContent", properties.ZipFileContent != null ? cfn_parse.FromCloudFormation.getString(properties.ZipFileContent) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_CustomArtifactConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("artifactType", cdk.requiredValidator)(properties.artifactType)), errors.collect(cdk.propertyValidator("artifactType", cdk.validateString)(properties.artifactType)), errors.collect(cdk.propertyValidator("mavenReference", CfnApplication_MavenReferencePropertyValidator)(properties.mavenReference)), errors.collect(cdk.propertyValidator("s3ContentLocation", CfnApplication_S3ContentLocationPropertyValidator)(properties.s3ContentLocation)), errors.wrap('supplied properties not correct for "CustomArtifactConfigurationProperty"');
    }
    function cfnApplicationCustomArtifactConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_CustomArtifactConfigurationPropertyValidator(properties).assertSuccess(), { ArtifactType: cdk.stringToCloudFormation(properties.artifactType), MavenReference: cfnApplicationMavenReferencePropertyToCloudFormation(properties.mavenReference), S3ContentLocation: cfnApplicationS3ContentLocationPropertyToCloudFormation(properties.s3ContentLocation) }) : properties;
    }
    function CfnApplicationCustomArtifactConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("artifactType", "ArtifactType", cfn_parse.FromCloudFormation.getString(properties.ArtifactType)), ret.addPropertyResult("mavenReference", "MavenReference", properties.MavenReference != null ? CfnApplicationMavenReferencePropertyFromCloudFormation(properties.MavenReference) : void 0), ret.addPropertyResult("s3ContentLocation", "S3ContentLocation", properties.S3ContentLocation != null ? CfnApplicationS3ContentLocationPropertyFromCloudFormation(properties.S3ContentLocation) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_DeployAsApplicationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3ContentLocation", cdk.requiredValidator)(properties.s3ContentLocation)), errors.collect(cdk.propertyValidator("s3ContentLocation", CfnApplication_S3ContentBaseLocationPropertyValidator)(properties.s3ContentLocation)), errors.wrap('supplied properties not correct for "DeployAsApplicationConfigurationProperty"');
    }
    function cfnApplicationDeployAsApplicationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_DeployAsApplicationConfigurationPropertyValidator(properties).assertSuccess(), { S3ContentLocation: cfnApplicationS3ContentBaseLocationPropertyToCloudFormation(properties.s3ContentLocation) }) : properties;
    }
    function CfnApplicationDeployAsApplicationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3ContentLocation", "S3ContentLocation", CfnApplicationS3ContentBaseLocationPropertyFromCloudFormation(properties.S3ContentLocation)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_EnvironmentPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("propertyGroups", cdk.listValidator(CfnApplication_PropertyGroupPropertyValidator))(properties.propertyGroups)), errors.wrap('supplied properties not correct for "EnvironmentPropertiesProperty"');
    }
    function cfnApplicationEnvironmentPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_EnvironmentPropertiesPropertyValidator(properties).assertSuccess(), { PropertyGroups: cdk.listMapper(cfnApplicationPropertyGroupPropertyToCloudFormation)(properties.propertyGroups) }) : properties;
    }
    function CfnApplicationEnvironmentPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("propertyGroups", "PropertyGroups", properties.PropertyGroups != null ? cfn_parse.FromCloudFormation.getArray(CfnApplicationPropertyGroupPropertyFromCloudFormation)(properties.PropertyGroups) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_FlinkApplicationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("checkpointConfiguration", CfnApplication_CheckpointConfigurationPropertyValidator)(properties.checkpointConfiguration)), errors.collect(cdk.propertyValidator("monitoringConfiguration", CfnApplication_MonitoringConfigurationPropertyValidator)(properties.monitoringConfiguration)), errors.collect(cdk.propertyValidator("parallelismConfiguration", CfnApplication_ParallelismConfigurationPropertyValidator)(properties.parallelismConfiguration)), errors.wrap('supplied properties not correct for "FlinkApplicationConfigurationProperty"');
    }
    function cfnApplicationFlinkApplicationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_FlinkApplicationConfigurationPropertyValidator(properties).assertSuccess(), { CheckpointConfiguration: cfnApplicationCheckpointConfigurationPropertyToCloudFormation(properties.checkpointConfiguration), MonitoringConfiguration: cfnApplicationMonitoringConfigurationPropertyToCloudFormation(properties.monitoringConfiguration), ParallelismConfiguration: cfnApplicationParallelismConfigurationPropertyToCloudFormation(properties.parallelismConfiguration) }) : properties;
    }
    function CfnApplicationFlinkApplicationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("checkpointConfiguration", "CheckpointConfiguration", properties.CheckpointConfiguration != null ? CfnApplicationCheckpointConfigurationPropertyFromCloudFormation(properties.CheckpointConfiguration) : void 0), ret.addPropertyResult("monitoringConfiguration", "MonitoringConfiguration", properties.MonitoringConfiguration != null ? CfnApplicationMonitoringConfigurationPropertyFromCloudFormation(properties.MonitoringConfiguration) : void 0), ret.addPropertyResult("parallelismConfiguration", "ParallelismConfiguration", properties.ParallelismConfiguration != null ? CfnApplicationParallelismConfigurationPropertyFromCloudFormation(properties.ParallelismConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_FlinkRunConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowNonRestoredState", cdk.validateBoolean)(properties.allowNonRestoredState)), errors.wrap('supplied properties not correct for "FlinkRunConfigurationProperty"');
    }
    function cfnApplicationFlinkRunConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_FlinkRunConfigurationPropertyValidator(properties).assertSuccess(), { AllowNonRestoredState: cdk.booleanToCloudFormation(properties.allowNonRestoredState) }) : properties;
    }
    function CfnApplicationFlinkRunConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowNonRestoredState", "AllowNonRestoredState", properties.AllowNonRestoredState != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllowNonRestoredState) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_GlueDataCatalogConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("databaseArn", cdk.validateString)(properties.databaseArn)), errors.wrap('supplied properties not correct for "GlueDataCatalogConfigurationProperty"');
    }
    function cfnApplicationGlueDataCatalogConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_GlueDataCatalogConfigurationPropertyValidator(properties).assertSuccess(), { DatabaseARN: cdk.stringToCloudFormation(properties.databaseArn) }) : properties;
    }
    function CfnApplicationGlueDataCatalogConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("databaseArn", "DatabaseARN", properties.DatabaseARN != null ? cfn_parse.FromCloudFormation.getString(properties.DatabaseARN) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_InputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("inputParallelism", CfnApplication_InputParallelismPropertyValidator)(properties.inputParallelism)), errors.collect(cdk.propertyValidator("inputProcessingConfiguration", CfnApplication_InputProcessingConfigurationPropertyValidator)(properties.inputProcessingConfiguration)), errors.collect(cdk.propertyValidator("inputSchema", cdk.requiredValidator)(properties.inputSchema)), errors.collect(cdk.propertyValidator("inputSchema", CfnApplication_InputSchemaPropertyValidator)(properties.inputSchema)), errors.collect(cdk.propertyValidator("kinesisFirehoseInput", CfnApplication_KinesisFirehoseInputPropertyValidator)(properties.kinesisFirehoseInput)), errors.collect(cdk.propertyValidator("kinesisStreamsInput", CfnApplication_KinesisStreamsInputPropertyValidator)(properties.kinesisStreamsInput)), errors.collect(cdk.propertyValidator("namePrefix", cdk.requiredValidator)(properties.namePrefix)), errors.collect(cdk.propertyValidator("namePrefix", cdk.validateString)(properties.namePrefix)), errors.wrap('supplied properties not correct for "InputProperty"');
    }
    function cfnApplicationInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_InputPropertyValidator(properties).assertSuccess(), { InputParallelism: cfnApplicationInputParallelismPropertyToCloudFormation(properties.inputParallelism), InputProcessingConfiguration: cfnApplicationInputProcessingConfigurationPropertyToCloudFormation(properties.inputProcessingConfiguration), InputSchema: cfnApplicationInputSchemaPropertyToCloudFormation(properties.inputSchema), KinesisFirehoseInput: cfnApplicationKinesisFirehoseInputPropertyToCloudFormation(properties.kinesisFirehoseInput), KinesisStreamsInput: cfnApplicationKinesisStreamsInputPropertyToCloudFormation(properties.kinesisStreamsInput), NamePrefix: cdk.stringToCloudFormation(properties.namePrefix) }) : properties;
    }
    function CfnApplicationInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("inputParallelism", "InputParallelism", properties.InputParallelism != null ? CfnApplicationInputParallelismPropertyFromCloudFormation(properties.InputParallelism) : void 0), ret.addPropertyResult("inputProcessingConfiguration", "InputProcessingConfiguration", properties.InputProcessingConfiguration != null ? CfnApplicationInputProcessingConfigurationPropertyFromCloudFormation(properties.InputProcessingConfiguration) : void 0), ret.addPropertyResult("inputSchema", "InputSchema", CfnApplicationInputSchemaPropertyFromCloudFormation(properties.InputSchema)), ret.addPropertyResult("kinesisFirehoseInput", "KinesisFirehoseInput", properties.KinesisFirehoseInput != null ? CfnApplicationKinesisFirehoseInputPropertyFromCloudFormation(properties.KinesisFirehoseInput) : void 0), ret.addPropertyResult("kinesisStreamsInput", "KinesisStreamsInput", properties.KinesisStreamsInput != null ? CfnApplicationKinesisStreamsInputPropertyFromCloudFormation(properties.KinesisStreamsInput) : void 0), ret.addPropertyResult("namePrefix", "NamePrefix", cfn_parse.FromCloudFormation.getString(properties.NamePrefix)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_InputLambdaProcessorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceArn", cdk.requiredValidator)(properties.resourceArn)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.wrap('supplied properties not correct for "InputLambdaProcessorProperty"');
    }
    function cfnApplicationInputLambdaProcessorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_InputLambdaProcessorPropertyValidator(properties).assertSuccess(), { ResourceARN: cdk.stringToCloudFormation(properties.resourceArn) }) : properties;
    }
    function CfnApplicationInputLambdaProcessorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceArn", "ResourceARN", cfn_parse.FromCloudFormation.getString(properties.ResourceARN)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_InputParallelismPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("count", cdk.validateNumber)(properties.count)), errors.wrap('supplied properties not correct for "InputParallelismProperty"');
    }
    function cfnApplicationInputParallelismPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_InputParallelismPropertyValidator(properties).assertSuccess(), { Count: cdk.numberToCloudFormation(properties.count) }) : properties;
    }
    function CfnApplicationInputParallelismPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("count", "Count", properties.Count != null ? cfn_parse.FromCloudFormation.getNumber(properties.Count) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_InputProcessingConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("inputLambdaProcessor", CfnApplication_InputLambdaProcessorPropertyValidator)(properties.inputLambdaProcessor)), errors.wrap('supplied properties not correct for "InputProcessingConfigurationProperty"');
    }
    function cfnApplicationInputProcessingConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_InputProcessingConfigurationPropertyValidator(properties).assertSuccess(), { InputLambdaProcessor: cfnApplicationInputLambdaProcessorPropertyToCloudFormation(properties.inputLambdaProcessor) }) : properties;
    }
    function CfnApplicationInputProcessingConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("inputLambdaProcessor", "InputLambdaProcessor", properties.InputLambdaProcessor != null ? CfnApplicationInputLambdaProcessorPropertyFromCloudFormation(properties.InputLambdaProcessor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_InputSchemaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("recordColumns", cdk.requiredValidator)(properties.recordColumns)), errors.collect(cdk.propertyValidator("recordColumns", cdk.listValidator(CfnApplication_RecordColumnPropertyValidator))(properties.recordColumns)), errors.collect(cdk.propertyValidator("recordEncoding", cdk.validateString)(properties.recordEncoding)), errors.collect(cdk.propertyValidator("recordFormat", cdk.requiredValidator)(properties.recordFormat)), errors.collect(cdk.propertyValidator("recordFormat", CfnApplication_RecordFormatPropertyValidator)(properties.recordFormat)), errors.wrap('supplied properties not correct for "InputSchemaProperty"');
    }
    function cfnApplicationInputSchemaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_InputSchemaPropertyValidator(properties).assertSuccess(), { RecordColumns: cdk.listMapper(cfnApplicationRecordColumnPropertyToCloudFormation)(properties.recordColumns), RecordEncoding: cdk.stringToCloudFormation(properties.recordEncoding), RecordFormat: cfnApplicationRecordFormatPropertyToCloudFormation(properties.recordFormat) }) : properties;
    }
    function CfnApplicationInputSchemaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("recordColumns", "RecordColumns", cfn_parse.FromCloudFormation.getArray(CfnApplicationRecordColumnPropertyFromCloudFormation)(properties.RecordColumns)), ret.addPropertyResult("recordEncoding", "RecordEncoding", properties.RecordEncoding != null ? cfn_parse.FromCloudFormation.getString(properties.RecordEncoding) : void 0), ret.addPropertyResult("recordFormat", "RecordFormat", CfnApplicationRecordFormatPropertyFromCloudFormation(properties.RecordFormat)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_JSONMappingParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("recordRowPath", cdk.requiredValidator)(properties.recordRowPath)), errors.collect(cdk.propertyValidator("recordRowPath", cdk.validateString)(properties.recordRowPath)), errors.wrap('supplied properties not correct for "JSONMappingParametersProperty"');
    }
    function cfnApplicationJSONMappingParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_JSONMappingParametersPropertyValidator(properties).assertSuccess(), { RecordRowPath: cdk.stringToCloudFormation(properties.recordRowPath) }) : properties;
    }
    function CfnApplicationJSONMappingParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("recordRowPath", "RecordRowPath", cfn_parse.FromCloudFormation.getString(properties.RecordRowPath)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_KinesisFirehoseInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceArn", cdk.requiredValidator)(properties.resourceArn)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.wrap('supplied properties not correct for "KinesisFirehoseInputProperty"');
    }
    function cfnApplicationKinesisFirehoseInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_KinesisFirehoseInputPropertyValidator(properties).assertSuccess(), { ResourceARN: cdk.stringToCloudFormation(properties.resourceArn) }) : properties;
    }
    function CfnApplicationKinesisFirehoseInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceArn", "ResourceARN", cfn_parse.FromCloudFormation.getString(properties.ResourceARN)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_KinesisStreamsInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceArn", cdk.requiredValidator)(properties.resourceArn)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.wrap('supplied properties not correct for "KinesisStreamsInputProperty"');
    }
    function cfnApplicationKinesisStreamsInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_KinesisStreamsInputPropertyValidator(properties).assertSuccess(), { ResourceARN: cdk.stringToCloudFormation(properties.resourceArn) }) : properties;
    }
    function CfnApplicationKinesisStreamsInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceArn", "ResourceARN", cfn_parse.FromCloudFormation.getString(properties.ResourceARN)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_MappingParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("csvMappingParameters", CfnApplication_CSVMappingParametersPropertyValidator)(properties.csvMappingParameters)), errors.collect(cdk.propertyValidator("jsonMappingParameters", CfnApplication_JSONMappingParametersPropertyValidator)(properties.jsonMappingParameters)), errors.wrap('supplied properties not correct for "MappingParametersProperty"');
    }
    function cfnApplicationMappingParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_MappingParametersPropertyValidator(properties).assertSuccess(), { CSVMappingParameters: cfnApplicationCSVMappingParametersPropertyToCloudFormation(properties.csvMappingParameters), JSONMappingParameters: cfnApplicationJSONMappingParametersPropertyToCloudFormation(properties.jsonMappingParameters) }) : properties;
    }
    function CfnApplicationMappingParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("csvMappingParameters", "CSVMappingParameters", properties.CSVMappingParameters != null ? CfnApplicationCSVMappingParametersPropertyFromCloudFormation(properties.CSVMappingParameters) : void 0), ret.addPropertyResult("jsonMappingParameters", "JSONMappingParameters", properties.JSONMappingParameters != null ? CfnApplicationJSONMappingParametersPropertyFromCloudFormation(properties.JSONMappingParameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_MavenReferencePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("artifactId", cdk.requiredValidator)(properties.artifactId)), errors.collect(cdk.propertyValidator("artifactId", cdk.validateString)(properties.artifactId)), errors.collect(cdk.propertyValidator("groupId", cdk.requiredValidator)(properties.groupId)), errors.collect(cdk.propertyValidator("groupId", cdk.validateString)(properties.groupId)), errors.collect(cdk.propertyValidator("version", cdk.requiredValidator)(properties.version)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "MavenReferenceProperty"');
    }
    function cfnApplicationMavenReferencePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_MavenReferencePropertyValidator(properties).assertSuccess(), { ArtifactId: cdk.stringToCloudFormation(properties.artifactId), GroupId: cdk.stringToCloudFormation(properties.groupId), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnApplicationMavenReferencePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("artifactId", "ArtifactId", cfn_parse.FromCloudFormation.getString(properties.ArtifactId)), ret.addPropertyResult("groupId", "GroupId", cfn_parse.FromCloudFormation.getString(properties.GroupId)), ret.addPropertyResult("version", "Version", cfn_parse.FromCloudFormation.getString(properties.Version)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_MonitoringConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configurationType", cdk.requiredValidator)(properties.configurationType)), errors.collect(cdk.propertyValidator("configurationType", cdk.validateString)(properties.configurationType)), errors.collect(cdk.propertyValidator("logLevel", cdk.validateString)(properties.logLevel)), errors.collect(cdk.propertyValidator("metricsLevel", cdk.validateString)(properties.metricsLevel)), errors.wrap('supplied properties not correct for "MonitoringConfigurationProperty"');
    }
    function cfnApplicationMonitoringConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_MonitoringConfigurationPropertyValidator(properties).assertSuccess(), { ConfigurationType: cdk.stringToCloudFormation(properties.configurationType), LogLevel: cdk.stringToCloudFormation(properties.logLevel), MetricsLevel: cdk.stringToCloudFormation(properties.metricsLevel) }) : properties;
    }
    function CfnApplicationMonitoringConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configurationType", "ConfigurationType", cfn_parse.FromCloudFormation.getString(properties.ConfigurationType)), ret.addPropertyResult("logLevel", "LogLevel", properties.LogLevel != null ? cfn_parse.FromCloudFormation.getString(properties.LogLevel) : void 0), ret.addPropertyResult("metricsLevel", "MetricsLevel", properties.MetricsLevel != null ? cfn_parse.FromCloudFormation.getString(properties.MetricsLevel) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_ParallelismConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoScalingEnabled", cdk.validateBoolean)(properties.autoScalingEnabled)), errors.collect(cdk.propertyValidator("configurationType", cdk.requiredValidator)(properties.configurationType)), errors.collect(cdk.propertyValidator("configurationType", cdk.validateString)(properties.configurationType)), errors.collect(cdk.propertyValidator("parallelism", cdk.validateNumber)(properties.parallelism)), errors.collect(cdk.propertyValidator("parallelismPerKpu", cdk.validateNumber)(properties.parallelismPerKpu)), errors.wrap('supplied properties not correct for "ParallelismConfigurationProperty"');
    }
    function cfnApplicationParallelismConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_ParallelismConfigurationPropertyValidator(properties).assertSuccess(), { AutoScalingEnabled: cdk.booleanToCloudFormation(properties.autoScalingEnabled), ConfigurationType: cdk.stringToCloudFormation(properties.configurationType), Parallelism: cdk.numberToCloudFormation(properties.parallelism), ParallelismPerKPU: cdk.numberToCloudFormation(properties.parallelismPerKpu) }) : properties;
    }
    function CfnApplicationParallelismConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("autoScalingEnabled", "AutoScalingEnabled", properties.AutoScalingEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AutoScalingEnabled) : void 0), ret.addPropertyResult("configurationType", "ConfigurationType", cfn_parse.FromCloudFormation.getString(properties.ConfigurationType)), ret.addPropertyResult("parallelism", "Parallelism", properties.Parallelism != null ? cfn_parse.FromCloudFormation.getNumber(properties.Parallelism) : void 0), ret.addPropertyResult("parallelismPerKpu", "ParallelismPerKPU", properties.ParallelismPerKPU != null ? cfn_parse.FromCloudFormation.getNumber(properties.ParallelismPerKPU) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_PropertyGroupPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("propertyGroupId", cdk.validateString)(properties.propertyGroupId)), errors.collect(cdk.propertyValidator("propertyMap", cdk.hashValidator(cdk.validateString))(properties.propertyMap)), errors.wrap('supplied properties not correct for "PropertyGroupProperty"');
    }
    function cfnApplicationPropertyGroupPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_PropertyGroupPropertyValidator(properties).assertSuccess(), { PropertyGroupId: cdk.stringToCloudFormation(properties.propertyGroupId), PropertyMap: cdk.hashMapper(cdk.stringToCloudFormation)(properties.propertyMap) }) : properties;
    }
    function CfnApplicationPropertyGroupPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("propertyGroupId", "PropertyGroupId", properties.PropertyGroupId != null ? cfn_parse.FromCloudFormation.getString(properties.PropertyGroupId) : void 0), ret.addPropertyResult("propertyMap", "PropertyMap", properties.PropertyMap != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.PropertyMap) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_RecordColumnPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mapping", cdk.validateString)(properties.mapping)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("sqlType", cdk.requiredValidator)(properties.sqlType)), errors.collect(cdk.propertyValidator("sqlType", cdk.validateString)(properties.sqlType)), errors.wrap('supplied properties not correct for "RecordColumnProperty"');
    }
    function cfnApplicationRecordColumnPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_RecordColumnPropertyValidator(properties).assertSuccess(), { Mapping: cdk.stringToCloudFormation(properties.mapping), Name: cdk.stringToCloudFormation(properties.name), SqlType: cdk.stringToCloudFormation(properties.sqlType) }) : properties;
    }
    function CfnApplicationRecordColumnPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mapping", "Mapping", properties.Mapping != null ? cfn_parse.FromCloudFormation.getString(properties.Mapping) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("sqlType", "SqlType", cfn_parse.FromCloudFormation.getString(properties.SqlType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_RecordFormatPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mappingParameters", CfnApplication_MappingParametersPropertyValidator)(properties.mappingParameters)), errors.collect(cdk.propertyValidator("recordFormatType", cdk.requiredValidator)(properties.recordFormatType)), errors.collect(cdk.propertyValidator("recordFormatType", cdk.validateString)(properties.recordFormatType)), errors.wrap('supplied properties not correct for "RecordFormatProperty"');
    }
    function cfnApplicationRecordFormatPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_RecordFormatPropertyValidator(properties).assertSuccess(), { MappingParameters: cfnApplicationMappingParametersPropertyToCloudFormation(properties.mappingParameters), RecordFormatType: cdk.stringToCloudFormation(properties.recordFormatType) }) : properties;
    }
    function CfnApplicationRecordFormatPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mappingParameters", "MappingParameters", properties.MappingParameters != null ? CfnApplicationMappingParametersPropertyFromCloudFormation(properties.MappingParameters) : void 0), ret.addPropertyResult("recordFormatType", "RecordFormatType", cfn_parse.FromCloudFormation.getString(properties.RecordFormatType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_RunConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationRestoreConfiguration", CfnApplication_ApplicationRestoreConfigurationPropertyValidator)(properties.applicationRestoreConfiguration)), errors.collect(cdk.propertyValidator("flinkRunConfiguration", CfnApplication_FlinkRunConfigurationPropertyValidator)(properties.flinkRunConfiguration)), errors.wrap('supplied properties not correct for "RunConfigurationProperty"');
    }
    function cfnApplicationRunConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_RunConfigurationPropertyValidator(properties).assertSuccess(), { ApplicationRestoreConfiguration: cfnApplicationApplicationRestoreConfigurationPropertyToCloudFormation(properties.applicationRestoreConfiguration), FlinkRunConfiguration: cfnApplicationFlinkRunConfigurationPropertyToCloudFormation(properties.flinkRunConfiguration) }) : properties;
    }
    function CfnApplicationRunConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationRestoreConfiguration", "ApplicationRestoreConfiguration", properties.ApplicationRestoreConfiguration != null ? CfnApplicationApplicationRestoreConfigurationPropertyFromCloudFormation(properties.ApplicationRestoreConfiguration) : void 0), ret.addPropertyResult("flinkRunConfiguration", "FlinkRunConfiguration", properties.FlinkRunConfiguration != null ? CfnApplicationFlinkRunConfigurationPropertyFromCloudFormation(properties.FlinkRunConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_S3ContentBaseLocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("basePath", cdk.validateString)(properties.basePath)), errors.collect(cdk.propertyValidator("bucketArn", cdk.requiredValidator)(properties.bucketArn)), errors.collect(cdk.propertyValidator("bucketArn", cdk.validateString)(properties.bucketArn)), errors.wrap('supplied properties not correct for "S3ContentBaseLocationProperty"');
    }
    function cfnApplicationS3ContentBaseLocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_S3ContentBaseLocationPropertyValidator(properties).assertSuccess(), { BasePath: cdk.stringToCloudFormation(properties.basePath), BucketARN: cdk.stringToCloudFormation(properties.bucketArn) }) : properties;
    }
    function CfnApplicationS3ContentBaseLocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("basePath", "BasePath", properties.BasePath != null ? cfn_parse.FromCloudFormation.getString(properties.BasePath) : void 0), ret.addPropertyResult("bucketArn", "BucketARN", cfn_parse.FromCloudFormation.getString(properties.BucketARN)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_S3ContentLocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketArn", cdk.requiredValidator)(properties.bucketArn)), errors.collect(cdk.propertyValidator("bucketArn", cdk.validateString)(properties.bucketArn)), errors.collect(cdk.propertyValidator("fileKey", cdk.requiredValidator)(properties.fileKey)), errors.collect(cdk.propertyValidator("fileKey", cdk.validateString)(properties.fileKey)), errors.collect(cdk.propertyValidator("objectVersion", cdk.validateString)(properties.objectVersion)), errors.wrap('supplied properties not correct for "S3ContentLocationProperty"');
    }
    function cfnApplicationS3ContentLocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_S3ContentLocationPropertyValidator(properties).assertSuccess(), { BucketARN: cdk.stringToCloudFormation(properties.bucketArn), FileKey: cdk.stringToCloudFormation(properties.fileKey), ObjectVersion: cdk.stringToCloudFormation(properties.objectVersion) }) : properties;
    }
    function CfnApplicationS3ContentLocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketArn", "BucketARN", cfn_parse.FromCloudFormation.getString(properties.BucketARN)), ret.addPropertyResult("fileKey", "FileKey", cfn_parse.FromCloudFormation.getString(properties.FileKey)), ret.addPropertyResult("objectVersion", "ObjectVersion", properties.ObjectVersion != null ? cfn_parse.FromCloudFormation.getString(properties.ObjectVersion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_SqlApplicationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("inputs", cdk.listValidator(CfnApplication_InputPropertyValidator))(properties.inputs)), errors.wrap('supplied properties not correct for "SqlApplicationConfigurationProperty"');
    }
    function cfnApplicationSqlApplicationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_SqlApplicationConfigurationPropertyValidator(properties).assertSuccess(), { Inputs: cdk.listMapper(cfnApplicationInputPropertyToCloudFormation)(properties.inputs) }) : properties;
    }
    function CfnApplicationSqlApplicationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("inputs", "Inputs", properties.Inputs != null ? cfn_parse.FromCloudFormation.getArray(CfnApplicationInputPropertyFromCloudFormation)(properties.Inputs) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_VpcConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.requiredValidator)(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.requiredValidator)(properties.subnetIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.wrap('supplied properties not correct for "VpcConfigurationProperty"');
    }
    function cfnApplicationVpcConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_VpcConfigurationPropertyValidator(properties).assertSuccess(), { SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds) }) : properties;
    }
    function CfnApplicationVpcConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds)), ret.addPropertyResult("subnetIds", "SubnetIds", cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_ZeppelinApplicationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalogConfiguration", CfnApplication_CatalogConfigurationPropertyValidator)(properties.catalogConfiguration)), errors.collect(cdk.propertyValidator("customArtifactsConfiguration", cdk.listValidator(CfnApplication_CustomArtifactConfigurationPropertyValidator))(properties.customArtifactsConfiguration)), errors.collect(cdk.propertyValidator("deployAsApplicationConfiguration", CfnApplication_DeployAsApplicationConfigurationPropertyValidator)(properties.deployAsApplicationConfiguration)), errors.collect(cdk.propertyValidator("monitoringConfiguration", CfnApplication_ZeppelinMonitoringConfigurationPropertyValidator)(properties.monitoringConfiguration)), errors.wrap('supplied properties not correct for "ZeppelinApplicationConfigurationProperty"');
    }
    function cfnApplicationZeppelinApplicationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_ZeppelinApplicationConfigurationPropertyValidator(properties).assertSuccess(), { CatalogConfiguration: cfnApplicationCatalogConfigurationPropertyToCloudFormation(properties.catalogConfiguration), CustomArtifactsConfiguration: cdk.listMapper(cfnApplicationCustomArtifactConfigurationPropertyToCloudFormation)(properties.customArtifactsConfiguration), DeployAsApplicationConfiguration: cfnApplicationDeployAsApplicationConfigurationPropertyToCloudFormation(properties.deployAsApplicationConfiguration), MonitoringConfiguration: cfnApplicationZeppelinMonitoringConfigurationPropertyToCloudFormation(properties.monitoringConfiguration) }) : properties;
    }
    function CfnApplicationZeppelinApplicationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalogConfiguration", "CatalogConfiguration", properties.CatalogConfiguration != null ? CfnApplicationCatalogConfigurationPropertyFromCloudFormation(properties.CatalogConfiguration) : void 0), ret.addPropertyResult("customArtifactsConfiguration", "CustomArtifactsConfiguration", properties.CustomArtifactsConfiguration != null ? cfn_parse.FromCloudFormation.getArray(CfnApplicationCustomArtifactConfigurationPropertyFromCloudFormation)(properties.CustomArtifactsConfiguration) : void 0), ret.addPropertyResult("deployAsApplicationConfiguration", "DeployAsApplicationConfiguration", properties.DeployAsApplicationConfiguration != null ? CfnApplicationDeployAsApplicationConfigurationPropertyFromCloudFormation(properties.DeployAsApplicationConfiguration) : void 0), ret.addPropertyResult("monitoringConfiguration", "MonitoringConfiguration", properties.MonitoringConfiguration != null ? CfnApplicationZeppelinMonitoringConfigurationPropertyFromCloudFormation(properties.MonitoringConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplication_ZeppelinMonitoringConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logLevel", cdk.validateString)(properties.logLevel)), errors.wrap('supplied properties not correct for "ZeppelinMonitoringConfigurationProperty"');
    }
    function cfnApplicationZeppelinMonitoringConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_ZeppelinMonitoringConfigurationPropertyValidator(properties).assertSuccess(), { LogLevel: cdk.stringToCloudFormation(properties.logLevel) }) : properties;
    }
    function CfnApplicationZeppelinMonitoringConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logLevel", "LogLevel", properties.LogLevel != null ? cfn_parse.FromCloudFormation.getString(properties.LogLevel) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationCloudWatchLoggingOptionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationName", cdk.requiredValidator)(properties.applicationName)), errors.collect(cdk.propertyValidator("applicationName", cdk.validateString)(properties.applicationName)), errors.collect(cdk.propertyValidator("cloudWatchLoggingOption", cdk.requiredValidator)(properties.cloudWatchLoggingOption)), errors.collect(cdk.propertyValidator("cloudWatchLoggingOption", CfnApplicationCloudWatchLoggingOption_CloudWatchLoggingOptionPropertyValidator)(properties.cloudWatchLoggingOption)), errors.wrap('supplied properties not correct for "CfnApplicationCloudWatchLoggingOptionProps"');
    }
    function cfnApplicationCloudWatchLoggingOptionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationCloudWatchLoggingOptionPropsValidator(properties).assertSuccess(), { ApplicationName: cdk.stringToCloudFormation(properties.applicationName), CloudWatchLoggingOption: cfnApplicationCloudWatchLoggingOptionCloudWatchLoggingOptionPropertyToCloudFormation(properties.cloudWatchLoggingOption) }) : properties;
    }
    function CfnApplicationCloudWatchLoggingOptionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationName", "ApplicationName", cfn_parse.FromCloudFormation.getString(properties.ApplicationName)), ret.addPropertyResult("cloudWatchLoggingOption", "CloudWatchLoggingOption", CfnApplicationCloudWatchLoggingOptionCloudWatchLoggingOptionPropertyFromCloudFormation(properties.CloudWatchLoggingOption)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApplicationCloudWatchLoggingOption = class _CfnApplicationCloudWatchLoggingOption extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApplicationCloudWatchLoggingOptionPropsFromCloudFormation(resourceProperties), ret = new _CfnApplicationCloudWatchLoggingOption(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApplicationCloudWatchLoggingOption.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationCloudWatchLoggingOptionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApplicationCloudWatchLoggingOption), error;
        }
        cdk.requireProperty(props, "applicationName", this), cdk.requireProperty(props, "cloudWatchLoggingOption", this), this.applicationName = props.applicationName, this.cloudWatchLoggingOption = props.cloudWatchLoggingOption;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApplicationCloudWatchLoggingOption.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationName: this.applicationName, cloudWatchLoggingOption: this.cloudWatchLoggingOption };
      }
      renderProperties(props) {
        return cfnApplicationCloudWatchLoggingOptionPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnApplicationCloudWatchLoggingOption[_b] = { fqn: "aws-cdk-lib.aws_kinesisanalyticsv2.CfnApplicationCloudWatchLoggingOption", version: "2.80.0" }, CfnApplicationCloudWatchLoggingOption.CFN_RESOURCE_TYPE_NAME = "AWS::KinesisAnalyticsV2::ApplicationCloudWatchLoggingOption", exports2.CfnApplicationCloudWatchLoggingOption = CfnApplicationCloudWatchLoggingOption;
    function CfnApplicationCloudWatchLoggingOption_CloudWatchLoggingOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logStreamArn", cdk.requiredValidator)(properties.logStreamArn)), errors.collect(cdk.propertyValidator("logStreamArn", cdk.validateString)(properties.logStreamArn)), errors.wrap('supplied properties not correct for "CloudWatchLoggingOptionProperty"');
    }
    function cfnApplicationCloudWatchLoggingOptionCloudWatchLoggingOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationCloudWatchLoggingOption_CloudWatchLoggingOptionPropertyValidator(properties).assertSuccess(), { LogStreamARN: cdk.stringToCloudFormation(properties.logStreamArn) }) : properties;
    }
    function CfnApplicationCloudWatchLoggingOptionCloudWatchLoggingOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logStreamArn", "LogStreamARN", cfn_parse.FromCloudFormation.getString(properties.LogStreamARN)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationOutputPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationName", cdk.requiredValidator)(properties.applicationName)), errors.collect(cdk.propertyValidator("applicationName", cdk.validateString)(properties.applicationName)), errors.collect(cdk.propertyValidator("output", cdk.requiredValidator)(properties.output)), errors.collect(cdk.propertyValidator("output", CfnApplicationOutput_OutputPropertyValidator)(properties.output)), errors.wrap('supplied properties not correct for "CfnApplicationOutputProps"');
    }
    function cfnApplicationOutputPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationOutputPropsValidator(properties).assertSuccess(), { ApplicationName: cdk.stringToCloudFormation(properties.applicationName), Output: cfnApplicationOutputOutputPropertyToCloudFormation(properties.output) }) : properties;
    }
    function CfnApplicationOutputPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationName", "ApplicationName", cfn_parse.FromCloudFormation.getString(properties.ApplicationName)), ret.addPropertyResult("output", "Output", CfnApplicationOutputOutputPropertyFromCloudFormation(properties.Output)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApplicationOutput = class _CfnApplicationOutput extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApplicationOutputPropsFromCloudFormation(resourceProperties), ret = new _CfnApplicationOutput(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApplicationOutput.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationOutputProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApplicationOutput), error;
        }
        cdk.requireProperty(props, "applicationName", this), cdk.requireProperty(props, "output", this), this.applicationName = props.applicationName, this.output = props.output;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApplicationOutput.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationName: this.applicationName, output: this.output };
      }
      renderProperties(props) {
        return cfnApplicationOutputPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnApplicationOutput[_c] = { fqn: "aws-cdk-lib.aws_kinesisanalyticsv2.CfnApplicationOutput", version: "2.80.0" }, CfnApplicationOutput.CFN_RESOURCE_TYPE_NAME = "AWS::KinesisAnalyticsV2::ApplicationOutput", exports2.CfnApplicationOutput = CfnApplicationOutput;
    function CfnApplicationOutput_DestinationSchemaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("recordFormatType", cdk.validateString)(properties.recordFormatType)), errors.wrap('supplied properties not correct for "DestinationSchemaProperty"');
    }
    function cfnApplicationOutputDestinationSchemaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationOutput_DestinationSchemaPropertyValidator(properties).assertSuccess(), { RecordFormatType: cdk.stringToCloudFormation(properties.recordFormatType) }) : properties;
    }
    function CfnApplicationOutputDestinationSchemaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("recordFormatType", "RecordFormatType", properties.RecordFormatType != null ? cfn_parse.FromCloudFormation.getString(properties.RecordFormatType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationOutput_KinesisFirehoseOutputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceArn", cdk.requiredValidator)(properties.resourceArn)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.wrap('supplied properties not correct for "KinesisFirehoseOutputProperty"');
    }
    function cfnApplicationOutputKinesisFirehoseOutputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationOutput_KinesisFirehoseOutputPropertyValidator(properties).assertSuccess(), { ResourceARN: cdk.stringToCloudFormation(properties.resourceArn) }) : properties;
    }
    function CfnApplicationOutputKinesisFirehoseOutputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceArn", "ResourceARN", cfn_parse.FromCloudFormation.getString(properties.ResourceARN)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationOutput_KinesisStreamsOutputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceArn", cdk.requiredValidator)(properties.resourceArn)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.wrap('supplied properties not correct for "KinesisStreamsOutputProperty"');
    }
    function cfnApplicationOutputKinesisStreamsOutputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationOutput_KinesisStreamsOutputPropertyValidator(properties).assertSuccess(), { ResourceARN: cdk.stringToCloudFormation(properties.resourceArn) }) : properties;
    }
    function CfnApplicationOutputKinesisStreamsOutputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceArn", "ResourceARN", cfn_parse.FromCloudFormation.getString(properties.ResourceARN)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationOutput_LambdaOutputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceArn", cdk.requiredValidator)(properties.resourceArn)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.wrap('supplied properties not correct for "LambdaOutputProperty"');
    }
    function cfnApplicationOutputLambdaOutputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationOutput_LambdaOutputPropertyValidator(properties).assertSuccess(), { ResourceARN: cdk.stringToCloudFormation(properties.resourceArn) }) : properties;
    }
    function CfnApplicationOutputLambdaOutputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceArn", "ResourceARN", cfn_parse.FromCloudFormation.getString(properties.ResourceARN)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationOutput_OutputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationSchema", cdk.requiredValidator)(properties.destinationSchema)), errors.collect(cdk.propertyValidator("destinationSchema", CfnApplicationOutput_DestinationSchemaPropertyValidator)(properties.destinationSchema)), errors.collect(cdk.propertyValidator("kinesisFirehoseOutput", CfnApplicationOutput_KinesisFirehoseOutputPropertyValidator)(properties.kinesisFirehoseOutput)), errors.collect(cdk.propertyValidator("kinesisStreamsOutput", CfnApplicationOutput_KinesisStreamsOutputPropertyValidator)(properties.kinesisStreamsOutput)), errors.collect(cdk.propertyValidator("lambdaOutput", CfnApplicationOutput_LambdaOutputPropertyValidator)(properties.lambdaOutput)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "OutputProperty"');
    }
    function cfnApplicationOutputOutputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationOutput_OutputPropertyValidator(properties).assertSuccess(), { DestinationSchema: cfnApplicationOutputDestinationSchemaPropertyToCloudFormation(properties.destinationSchema), KinesisFirehoseOutput: cfnApplicationOutputKinesisFirehoseOutputPropertyToCloudFormation(properties.kinesisFirehoseOutput), KinesisStreamsOutput: cfnApplicationOutputKinesisStreamsOutputPropertyToCloudFormation(properties.kinesisStreamsOutput), LambdaOutput: cfnApplicationOutputLambdaOutputPropertyToCloudFormation(properties.lambdaOutput), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnApplicationOutputOutputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationSchema", "DestinationSchema", CfnApplicationOutputDestinationSchemaPropertyFromCloudFormation(properties.DestinationSchema)), ret.addPropertyResult("kinesisFirehoseOutput", "KinesisFirehoseOutput", properties.KinesisFirehoseOutput != null ? CfnApplicationOutputKinesisFirehoseOutputPropertyFromCloudFormation(properties.KinesisFirehoseOutput) : void 0), ret.addPropertyResult("kinesisStreamsOutput", "KinesisStreamsOutput", properties.KinesisStreamsOutput != null ? CfnApplicationOutputKinesisStreamsOutputPropertyFromCloudFormation(properties.KinesisStreamsOutput) : void 0), ret.addPropertyResult("lambdaOutput", "LambdaOutput", properties.LambdaOutput != null ? CfnApplicationOutputLambdaOutputPropertyFromCloudFormation(properties.LambdaOutput) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationReferenceDataSourcePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationName", cdk.requiredValidator)(properties.applicationName)), errors.collect(cdk.propertyValidator("applicationName", cdk.validateString)(properties.applicationName)), errors.collect(cdk.propertyValidator("referenceDataSource", cdk.requiredValidator)(properties.referenceDataSource)), errors.collect(cdk.propertyValidator("referenceDataSource", CfnApplicationReferenceDataSource_ReferenceDataSourcePropertyValidator)(properties.referenceDataSource)), errors.wrap('supplied properties not correct for "CfnApplicationReferenceDataSourceProps"');
    }
    function cfnApplicationReferenceDataSourcePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationReferenceDataSourcePropsValidator(properties).assertSuccess(), { ApplicationName: cdk.stringToCloudFormation(properties.applicationName), ReferenceDataSource: cfnApplicationReferenceDataSourceReferenceDataSourcePropertyToCloudFormation(properties.referenceDataSource) }) : properties;
    }
    function CfnApplicationReferenceDataSourcePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationName", "ApplicationName", cfn_parse.FromCloudFormation.getString(properties.ApplicationName)), ret.addPropertyResult("referenceDataSource", "ReferenceDataSource", CfnApplicationReferenceDataSourceReferenceDataSourcePropertyFromCloudFormation(properties.ReferenceDataSource)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApplicationReferenceDataSource = class _CfnApplicationReferenceDataSource extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApplicationReferenceDataSourcePropsFromCloudFormation(resourceProperties), ret = new _CfnApplicationReferenceDataSource(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApplicationReferenceDataSource.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kinesisanalyticsv2_CfnApplicationReferenceDataSourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApplicationReferenceDataSource), error;
        }
        cdk.requireProperty(props, "applicationName", this), cdk.requireProperty(props, "referenceDataSource", this), this.applicationName = props.applicationName, this.referenceDataSource = props.referenceDataSource;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApplicationReferenceDataSource.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationName: this.applicationName, referenceDataSource: this.referenceDataSource };
      }
      renderProperties(props) {
        return cfnApplicationReferenceDataSourcePropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnApplicationReferenceDataSource[_d] = { fqn: "aws-cdk-lib.aws_kinesisanalyticsv2.CfnApplicationReferenceDataSource", version: "2.80.0" }, CfnApplicationReferenceDataSource.CFN_RESOURCE_TYPE_NAME = "AWS::KinesisAnalyticsV2::ApplicationReferenceDataSource", exports2.CfnApplicationReferenceDataSource = CfnApplicationReferenceDataSource;
    function CfnApplicationReferenceDataSource_CSVMappingParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("recordColumnDelimiter", cdk.requiredValidator)(properties.recordColumnDelimiter)), errors.collect(cdk.propertyValidator("recordColumnDelimiter", cdk.validateString)(properties.recordColumnDelimiter)), errors.collect(cdk.propertyValidator("recordRowDelimiter", cdk.requiredValidator)(properties.recordRowDelimiter)), errors.collect(cdk.propertyValidator("recordRowDelimiter", cdk.validateString)(properties.recordRowDelimiter)), errors.wrap('supplied properties not correct for "CSVMappingParametersProperty"');
    }
    function cfnApplicationReferenceDataSourceCSVMappingParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationReferenceDataSource_CSVMappingParametersPropertyValidator(properties).assertSuccess(), { RecordColumnDelimiter: cdk.stringToCloudFormation(properties.recordColumnDelimiter), RecordRowDelimiter: cdk.stringToCloudFormation(properties.recordRowDelimiter) }) : properties;
    }
    function CfnApplicationReferenceDataSourceCSVMappingParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("recordColumnDelimiter", "RecordColumnDelimiter", cfn_parse.FromCloudFormation.getString(properties.RecordColumnDelimiter)), ret.addPropertyResult("recordRowDelimiter", "RecordRowDelimiter", cfn_parse.FromCloudFormation.getString(properties.RecordRowDelimiter)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationReferenceDataSource_JSONMappingParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("recordRowPath", cdk.requiredValidator)(properties.recordRowPath)), errors.collect(cdk.propertyValidator("recordRowPath", cdk.validateString)(properties.recordRowPath)), errors.wrap('supplied properties not correct for "JSONMappingParametersProperty"');
    }
    function cfnApplicationReferenceDataSourceJSONMappingParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationReferenceDataSource_JSONMappingParametersPropertyValidator(properties).assertSuccess(), { RecordRowPath: cdk.stringToCloudFormation(properties.recordRowPath) }) : properties;
    }
    function CfnApplicationReferenceDataSourceJSONMappingParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("recordRowPath", "RecordRowPath", cfn_parse.FromCloudFormation.getString(properties.RecordRowPath)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationReferenceDataSource_MappingParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("csvMappingParameters", CfnApplicationReferenceDataSource_CSVMappingParametersPropertyValidator)(properties.csvMappingParameters)), errors.collect(cdk.propertyValidator("jsonMappingParameters", CfnApplicationReferenceDataSource_JSONMappingParametersPropertyValidator)(properties.jsonMappingParameters)), errors.wrap('supplied properties not correct for "MappingParametersProperty"');
    }
    function cfnApplicationReferenceDataSourceMappingParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationReferenceDataSource_MappingParametersPropertyValidator(properties).assertSuccess(), { CSVMappingParameters: cfnApplicationReferenceDataSourceCSVMappingParametersPropertyToCloudFormation(properties.csvMappingParameters), JSONMappingParameters: cfnApplicationReferenceDataSourceJSONMappingParametersPropertyToCloudFormation(properties.jsonMappingParameters) }) : properties;
    }
    function CfnApplicationReferenceDataSourceMappingParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("csvMappingParameters", "CSVMappingParameters", properties.CSVMappingParameters != null ? CfnApplicationReferenceDataSourceCSVMappingParametersPropertyFromCloudFormation(properties.CSVMappingParameters) : void 0), ret.addPropertyResult("jsonMappingParameters", "JSONMappingParameters", properties.JSONMappingParameters != null ? CfnApplicationReferenceDataSourceJSONMappingParametersPropertyFromCloudFormation(properties.JSONMappingParameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationReferenceDataSource_RecordColumnPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mapping", cdk.validateString)(properties.mapping)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("sqlType", cdk.requiredValidator)(properties.sqlType)), errors.collect(cdk.propertyValidator("sqlType", cdk.validateString)(properties.sqlType)), errors.wrap('supplied properties not correct for "RecordColumnProperty"');
    }
    function cfnApplicationReferenceDataSourceRecordColumnPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationReferenceDataSource_RecordColumnPropertyValidator(properties).assertSuccess(), { Mapping: cdk.stringToCloudFormation(properties.mapping), Name: cdk.stringToCloudFormation(properties.name), SqlType: cdk.stringToCloudFormation(properties.sqlType) }) : properties;
    }
    function CfnApplicationReferenceDataSourceRecordColumnPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mapping", "Mapping", properties.Mapping != null ? cfn_parse.FromCloudFormation.getString(properties.Mapping) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("sqlType", "SqlType", cfn_parse.FromCloudFormation.getString(properties.SqlType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationReferenceDataSource_RecordFormatPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mappingParameters", CfnApplicationReferenceDataSource_MappingParametersPropertyValidator)(properties.mappingParameters)), errors.collect(cdk.propertyValidator("recordFormatType", cdk.requiredValidator)(properties.recordFormatType)), errors.collect(cdk.propertyValidator("recordFormatType", cdk.validateString)(properties.recordFormatType)), errors.wrap('supplied properties not correct for "RecordFormatProperty"');
    }
    function cfnApplicationReferenceDataSourceRecordFormatPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationReferenceDataSource_RecordFormatPropertyValidator(properties).assertSuccess(), { MappingParameters: cfnApplicationReferenceDataSourceMappingParametersPropertyToCloudFormation(properties.mappingParameters), RecordFormatType: cdk.stringToCloudFormation(properties.recordFormatType) }) : properties;
    }
    function CfnApplicationReferenceDataSourceRecordFormatPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mappingParameters", "MappingParameters", properties.MappingParameters != null ? CfnApplicationReferenceDataSourceMappingParametersPropertyFromCloudFormation(properties.MappingParameters) : void 0), ret.addPropertyResult("recordFormatType", "RecordFormatType", cfn_parse.FromCloudFormation.getString(properties.RecordFormatType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationReferenceDataSource_ReferenceDataSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("referenceSchema", cdk.requiredValidator)(properties.referenceSchema)), errors.collect(cdk.propertyValidator("referenceSchema", CfnApplicationReferenceDataSource_ReferenceSchemaPropertyValidator)(properties.referenceSchema)), errors.collect(cdk.propertyValidator("s3ReferenceDataSource", CfnApplicationReferenceDataSource_S3ReferenceDataSourcePropertyValidator)(properties.s3ReferenceDataSource)), errors.collect(cdk.propertyValidator("tableName", cdk.validateString)(properties.tableName)), errors.wrap('supplied properties not correct for "ReferenceDataSourceProperty"');
    }
    function cfnApplicationReferenceDataSourceReferenceDataSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationReferenceDataSource_ReferenceDataSourcePropertyValidator(properties).assertSuccess(), { ReferenceSchema: cfnApplicationReferenceDataSourceReferenceSchemaPropertyToCloudFormation(properties.referenceSchema), S3ReferenceDataSource: cfnApplicationReferenceDataSourceS3ReferenceDataSourcePropertyToCloudFormation(properties.s3ReferenceDataSource), TableName: cdk.stringToCloudFormation(properties.tableName) }) : properties;
    }
    function CfnApplicationReferenceDataSourceReferenceDataSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("referenceSchema", "ReferenceSchema", CfnApplicationReferenceDataSourceReferenceSchemaPropertyFromCloudFormation(properties.ReferenceSchema)), ret.addPropertyResult("s3ReferenceDataSource", "S3ReferenceDataSource", properties.S3ReferenceDataSource != null ? CfnApplicationReferenceDataSourceS3ReferenceDataSourcePropertyFromCloudFormation(properties.S3ReferenceDataSource) : void 0), ret.addPropertyResult("tableName", "TableName", properties.TableName != null ? cfn_parse.FromCloudFormation.getString(properties.TableName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationReferenceDataSource_ReferenceSchemaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("recordColumns", cdk.requiredValidator)(properties.recordColumns)), errors.collect(cdk.propertyValidator("recordColumns", cdk.listValidator(CfnApplicationReferenceDataSource_RecordColumnPropertyValidator))(properties.recordColumns)), errors.collect(cdk.propertyValidator("recordEncoding", cdk.validateString)(properties.recordEncoding)), errors.collect(cdk.propertyValidator("recordFormat", cdk.requiredValidator)(properties.recordFormat)), errors.collect(cdk.propertyValidator("recordFormat", CfnApplicationReferenceDataSource_RecordFormatPropertyValidator)(properties.recordFormat)), errors.wrap('supplied properties not correct for "ReferenceSchemaProperty"');
    }
    function cfnApplicationReferenceDataSourceReferenceSchemaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationReferenceDataSource_ReferenceSchemaPropertyValidator(properties).assertSuccess(), { RecordColumns: cdk.listMapper(cfnApplicationReferenceDataSourceRecordColumnPropertyToCloudFormation)(properties.recordColumns), RecordEncoding: cdk.stringToCloudFormation(properties.recordEncoding), RecordFormat: cfnApplicationReferenceDataSourceRecordFormatPropertyToCloudFormation(properties.recordFormat) }) : properties;
    }
    function CfnApplicationReferenceDataSourceReferenceSchemaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("recordColumns", "RecordColumns", cfn_parse.FromCloudFormation.getArray(CfnApplicationReferenceDataSourceRecordColumnPropertyFromCloudFormation)(properties.RecordColumns)), ret.addPropertyResult("recordEncoding", "RecordEncoding", properties.RecordEncoding != null ? cfn_parse.FromCloudFormation.getString(properties.RecordEncoding) : void 0), ret.addPropertyResult("recordFormat", "RecordFormat", CfnApplicationReferenceDataSourceRecordFormatPropertyFromCloudFormation(properties.RecordFormat)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationReferenceDataSource_S3ReferenceDataSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketArn", cdk.requiredValidator)(properties.bucketArn)), errors.collect(cdk.propertyValidator("bucketArn", cdk.validateString)(properties.bucketArn)), errors.collect(cdk.propertyValidator("fileKey", cdk.requiredValidator)(properties.fileKey)), errors.collect(cdk.propertyValidator("fileKey", cdk.validateString)(properties.fileKey)), errors.wrap('supplied properties not correct for "S3ReferenceDataSourceProperty"');
    }
    function cfnApplicationReferenceDataSourceS3ReferenceDataSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationReferenceDataSource_S3ReferenceDataSourcePropertyValidator(properties).assertSuccess(), { BucketARN: cdk.stringToCloudFormation(properties.bucketArn), FileKey: cdk.stringToCloudFormation(properties.fileKey) }) : properties;
    }
    function CfnApplicationReferenceDataSourceS3ReferenceDataSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketArn", "BucketARN", cfn_parse.FromCloudFormation.getString(properties.BucketARN)), ret.addPropertyResult("fileKey", "FileKey", cfn_parse.FromCloudFormation.getString(properties.FileKey)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-kinesisanalyticsv2/lib/index.js
var require_lib167 = __commonJS({
  "node_modules/aws-cdk-lib/aws-kinesisanalyticsv2/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_kinesisanalyticsv2_generated2(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-kinesisanalyticsv2/index.js
var require_aws_kinesisanalyticsv2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-kinesisanalyticsv2/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib167(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-kinesisfirehose/lib/kinesisfirehose.generated.js
var require_kinesisfirehose_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-kinesisfirehose/lib/kinesisfirehose.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnDeliveryStream = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnDeliveryStreamPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("amazonOpenSearchServerlessDestinationConfiguration", CfnDeliveryStream_AmazonOpenSearchServerlessDestinationConfigurationPropertyValidator)(properties.amazonOpenSearchServerlessDestinationConfiguration)), errors.collect(cdk.propertyValidator("amazonopensearchserviceDestinationConfiguration", CfnDeliveryStream_AmazonopensearchserviceDestinationConfigurationPropertyValidator)(properties.amazonopensearchserviceDestinationConfiguration)), errors.collect(cdk.propertyValidator("deliveryStreamEncryptionConfigurationInput", CfnDeliveryStream_DeliveryStreamEncryptionConfigurationInputPropertyValidator)(properties.deliveryStreamEncryptionConfigurationInput)), errors.collect(cdk.propertyValidator("deliveryStreamName", cdk.validateString)(properties.deliveryStreamName)), errors.collect(cdk.propertyValidator("deliveryStreamType", cdk.validateString)(properties.deliveryStreamType)), errors.collect(cdk.propertyValidator("elasticsearchDestinationConfiguration", CfnDeliveryStream_ElasticsearchDestinationConfigurationPropertyValidator)(properties.elasticsearchDestinationConfiguration)), errors.collect(cdk.propertyValidator("extendedS3DestinationConfiguration", CfnDeliveryStream_ExtendedS3DestinationConfigurationPropertyValidator)(properties.extendedS3DestinationConfiguration)), errors.collect(cdk.propertyValidator("httpEndpointDestinationConfiguration", CfnDeliveryStream_HttpEndpointDestinationConfigurationPropertyValidator)(properties.httpEndpointDestinationConfiguration)), errors.collect(cdk.propertyValidator("kinesisStreamSourceConfiguration", CfnDeliveryStream_KinesisStreamSourceConfigurationPropertyValidator)(properties.kinesisStreamSourceConfiguration)), errors.collect(cdk.propertyValidator("redshiftDestinationConfiguration", CfnDeliveryStream_RedshiftDestinationConfigurationPropertyValidator)(properties.redshiftDestinationConfiguration)), errors.collect(cdk.propertyValidator("s3DestinationConfiguration", CfnDeliveryStream_S3DestinationConfigurationPropertyValidator)(properties.s3DestinationConfiguration)), errors.collect(cdk.propertyValidator("splunkDestinationConfiguration", CfnDeliveryStream_SplunkDestinationConfigurationPropertyValidator)(properties.splunkDestinationConfiguration)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDeliveryStreamProps"');
    }
    function cfnDeliveryStreamPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStreamPropsValidator(properties).assertSuccess(), { AmazonOpenSearchServerlessDestinationConfiguration: cfnDeliveryStreamAmazonOpenSearchServerlessDestinationConfigurationPropertyToCloudFormation(properties.amazonOpenSearchServerlessDestinationConfiguration), AmazonopensearchserviceDestinationConfiguration: cfnDeliveryStreamAmazonopensearchserviceDestinationConfigurationPropertyToCloudFormation(properties.amazonopensearchserviceDestinationConfiguration), DeliveryStreamEncryptionConfigurationInput: cfnDeliveryStreamDeliveryStreamEncryptionConfigurationInputPropertyToCloudFormation(properties.deliveryStreamEncryptionConfigurationInput), DeliveryStreamName: cdk.stringToCloudFormation(properties.deliveryStreamName), DeliveryStreamType: cdk.stringToCloudFormation(properties.deliveryStreamType), ElasticsearchDestinationConfiguration: cfnDeliveryStreamElasticsearchDestinationConfigurationPropertyToCloudFormation(properties.elasticsearchDestinationConfiguration), ExtendedS3DestinationConfiguration: cfnDeliveryStreamExtendedS3DestinationConfigurationPropertyToCloudFormation(properties.extendedS3DestinationConfiguration), HttpEndpointDestinationConfiguration: cfnDeliveryStreamHttpEndpointDestinationConfigurationPropertyToCloudFormation(properties.httpEndpointDestinationConfiguration), KinesisStreamSourceConfiguration: cfnDeliveryStreamKinesisStreamSourceConfigurationPropertyToCloudFormation(properties.kinesisStreamSourceConfiguration), RedshiftDestinationConfiguration: cfnDeliveryStreamRedshiftDestinationConfigurationPropertyToCloudFormation(properties.redshiftDestinationConfiguration), S3DestinationConfiguration: cfnDeliveryStreamS3DestinationConfigurationPropertyToCloudFormation(properties.s3DestinationConfiguration), SplunkDestinationConfiguration: cfnDeliveryStreamSplunkDestinationConfigurationPropertyToCloudFormation(properties.splunkDestinationConfiguration), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDeliveryStreamPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("amazonOpenSearchServerlessDestinationConfiguration", "AmazonOpenSearchServerlessDestinationConfiguration", properties.AmazonOpenSearchServerlessDestinationConfiguration != null ? CfnDeliveryStreamAmazonOpenSearchServerlessDestinationConfigurationPropertyFromCloudFormation(properties.AmazonOpenSearchServerlessDestinationConfiguration) : void 0), ret.addPropertyResult("amazonopensearchserviceDestinationConfiguration", "AmazonopensearchserviceDestinationConfiguration", properties.AmazonopensearchserviceDestinationConfiguration != null ? CfnDeliveryStreamAmazonopensearchserviceDestinationConfigurationPropertyFromCloudFormation(properties.AmazonopensearchserviceDestinationConfiguration) : void 0), ret.addPropertyResult("deliveryStreamEncryptionConfigurationInput", "DeliveryStreamEncryptionConfigurationInput", properties.DeliveryStreamEncryptionConfigurationInput != null ? CfnDeliveryStreamDeliveryStreamEncryptionConfigurationInputPropertyFromCloudFormation(properties.DeliveryStreamEncryptionConfigurationInput) : void 0), ret.addPropertyResult("deliveryStreamName", "DeliveryStreamName", properties.DeliveryStreamName != null ? cfn_parse.FromCloudFormation.getString(properties.DeliveryStreamName) : void 0), ret.addPropertyResult("deliveryStreamType", "DeliveryStreamType", properties.DeliveryStreamType != null ? cfn_parse.FromCloudFormation.getString(properties.DeliveryStreamType) : void 0), ret.addPropertyResult("elasticsearchDestinationConfiguration", "ElasticsearchDestinationConfiguration", properties.ElasticsearchDestinationConfiguration != null ? CfnDeliveryStreamElasticsearchDestinationConfigurationPropertyFromCloudFormation(properties.ElasticsearchDestinationConfiguration) : void 0), ret.addPropertyResult("extendedS3DestinationConfiguration", "ExtendedS3DestinationConfiguration", properties.ExtendedS3DestinationConfiguration != null ? CfnDeliveryStreamExtendedS3DestinationConfigurationPropertyFromCloudFormation(properties.ExtendedS3DestinationConfiguration) : void 0), ret.addPropertyResult("httpEndpointDestinationConfiguration", "HttpEndpointDestinationConfiguration", properties.HttpEndpointDestinationConfiguration != null ? CfnDeliveryStreamHttpEndpointDestinationConfigurationPropertyFromCloudFormation(properties.HttpEndpointDestinationConfiguration) : void 0), ret.addPropertyResult("kinesisStreamSourceConfiguration", "KinesisStreamSourceConfiguration", properties.KinesisStreamSourceConfiguration != null ? CfnDeliveryStreamKinesisStreamSourceConfigurationPropertyFromCloudFormation(properties.KinesisStreamSourceConfiguration) : void 0), ret.addPropertyResult("redshiftDestinationConfiguration", "RedshiftDestinationConfiguration", properties.RedshiftDestinationConfiguration != null ? CfnDeliveryStreamRedshiftDestinationConfigurationPropertyFromCloudFormation(properties.RedshiftDestinationConfiguration) : void 0), ret.addPropertyResult("s3DestinationConfiguration", "S3DestinationConfiguration", properties.S3DestinationConfiguration != null ? CfnDeliveryStreamS3DestinationConfigurationPropertyFromCloudFormation(properties.S3DestinationConfiguration) : void 0), ret.addPropertyResult("splunkDestinationConfiguration", "SplunkDestinationConfiguration", properties.SplunkDestinationConfiguration != null ? CfnDeliveryStreamSplunkDestinationConfigurationPropertyFromCloudFormation(properties.SplunkDestinationConfiguration) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDeliveryStream = class _CfnDeliveryStream extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDeliveryStreamPropsFromCloudFormation(resourceProperties), ret = new _CfnDeliveryStream(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnDeliveryStream.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kinesisfirehose_CfnDeliveryStreamProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDeliveryStream), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.amazonOpenSearchServerlessDestinationConfiguration = props.amazonOpenSearchServerlessDestinationConfiguration, this.amazonopensearchserviceDestinationConfiguration = props.amazonopensearchserviceDestinationConfiguration, this.deliveryStreamEncryptionConfigurationInput = props.deliveryStreamEncryptionConfigurationInput, this.deliveryStreamName = props.deliveryStreamName, this.deliveryStreamType = props.deliveryStreamType, this.elasticsearchDestinationConfiguration = props.elasticsearchDestinationConfiguration, this.extendedS3DestinationConfiguration = props.extendedS3DestinationConfiguration, this.httpEndpointDestinationConfiguration = props.httpEndpointDestinationConfiguration, this.kinesisStreamSourceConfiguration = props.kinesisStreamSourceConfiguration, this.redshiftDestinationConfiguration = props.redshiftDestinationConfiguration, this.s3DestinationConfiguration = props.s3DestinationConfiguration, this.splunkDestinationConfiguration = props.splunkDestinationConfiguration, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::KinesisFirehose::DeliveryStream", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDeliveryStream.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { amazonOpenSearchServerlessDestinationConfiguration: this.amazonOpenSearchServerlessDestinationConfiguration, amazonopensearchserviceDestinationConfiguration: this.amazonopensearchserviceDestinationConfiguration, deliveryStreamEncryptionConfigurationInput: this.deliveryStreamEncryptionConfigurationInput, deliveryStreamName: this.deliveryStreamName, deliveryStreamType: this.deliveryStreamType, elasticsearchDestinationConfiguration: this.elasticsearchDestinationConfiguration, extendedS3DestinationConfiguration: this.extendedS3DestinationConfiguration, httpEndpointDestinationConfiguration: this.httpEndpointDestinationConfiguration, kinesisStreamSourceConfiguration: this.kinesisStreamSourceConfiguration, redshiftDestinationConfiguration: this.redshiftDestinationConfiguration, s3DestinationConfiguration: this.s3DestinationConfiguration, splunkDestinationConfiguration: this.splunkDestinationConfiguration, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDeliveryStreamPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnDeliveryStream[_a] = { fqn: "aws-cdk-lib.aws_kinesisfirehose.CfnDeliveryStream", version: "2.80.0" }, CfnDeliveryStream.CFN_RESOURCE_TYPE_NAME = "AWS::KinesisFirehose::DeliveryStream", exports2.CfnDeliveryStream = CfnDeliveryStream;
    function CfnDeliveryStream_AmazonOpenSearchServerlessBufferingHintsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("intervalInSeconds", cdk.validateNumber)(properties.intervalInSeconds)), errors.collect(cdk.propertyValidator("sizeInMBs", cdk.validateNumber)(properties.sizeInMBs)), errors.wrap('supplied properties not correct for "AmazonOpenSearchServerlessBufferingHintsProperty"');
    }
    function cfnDeliveryStreamAmazonOpenSearchServerlessBufferingHintsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_AmazonOpenSearchServerlessBufferingHintsPropertyValidator(properties).assertSuccess(), { IntervalInSeconds: cdk.numberToCloudFormation(properties.intervalInSeconds), SizeInMBs: cdk.numberToCloudFormation(properties.sizeInMBs) }) : properties;
    }
    function CfnDeliveryStreamAmazonOpenSearchServerlessBufferingHintsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("intervalInSeconds", "IntervalInSeconds", properties.IntervalInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.IntervalInSeconds) : void 0), ret.addPropertyResult("sizeInMBs", "SizeInMBs", properties.SizeInMBs != null ? cfn_parse.FromCloudFormation.getNumber(properties.SizeInMBs) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_AmazonOpenSearchServerlessDestinationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bufferingHints", CfnDeliveryStream_AmazonOpenSearchServerlessBufferingHintsPropertyValidator)(properties.bufferingHints)), errors.collect(cdk.propertyValidator("cloudWatchLoggingOptions", CfnDeliveryStream_CloudWatchLoggingOptionsPropertyValidator)(properties.cloudWatchLoggingOptions)), errors.collect(cdk.propertyValidator("collectionEndpoint", cdk.validateString)(properties.collectionEndpoint)), errors.collect(cdk.propertyValidator("indexName", cdk.requiredValidator)(properties.indexName)), errors.collect(cdk.propertyValidator("indexName", cdk.validateString)(properties.indexName)), errors.collect(cdk.propertyValidator("processingConfiguration", CfnDeliveryStream_ProcessingConfigurationPropertyValidator)(properties.processingConfiguration)), errors.collect(cdk.propertyValidator("retryOptions", CfnDeliveryStream_AmazonOpenSearchServerlessRetryOptionsPropertyValidator)(properties.retryOptions)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("s3BackupMode", cdk.validateString)(properties.s3BackupMode)), errors.collect(cdk.propertyValidator("s3Configuration", cdk.requiredValidator)(properties.s3Configuration)), errors.collect(cdk.propertyValidator("s3Configuration", CfnDeliveryStream_S3DestinationConfigurationPropertyValidator)(properties.s3Configuration)), errors.collect(cdk.propertyValidator("vpcConfiguration", CfnDeliveryStream_VpcConfigurationPropertyValidator)(properties.vpcConfiguration)), errors.wrap('supplied properties not correct for "AmazonOpenSearchServerlessDestinationConfigurationProperty"');
    }
    function cfnDeliveryStreamAmazonOpenSearchServerlessDestinationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_AmazonOpenSearchServerlessDestinationConfigurationPropertyValidator(properties).assertSuccess(), { BufferingHints: cfnDeliveryStreamAmazonOpenSearchServerlessBufferingHintsPropertyToCloudFormation(properties.bufferingHints), CloudWatchLoggingOptions: cfnDeliveryStreamCloudWatchLoggingOptionsPropertyToCloudFormation(properties.cloudWatchLoggingOptions), CollectionEndpoint: cdk.stringToCloudFormation(properties.collectionEndpoint), IndexName: cdk.stringToCloudFormation(properties.indexName), ProcessingConfiguration: cfnDeliveryStreamProcessingConfigurationPropertyToCloudFormation(properties.processingConfiguration), RetryOptions: cfnDeliveryStreamAmazonOpenSearchServerlessRetryOptionsPropertyToCloudFormation(properties.retryOptions), RoleARN: cdk.stringToCloudFormation(properties.roleArn), S3BackupMode: cdk.stringToCloudFormation(properties.s3BackupMode), S3Configuration: cfnDeliveryStreamS3DestinationConfigurationPropertyToCloudFormation(properties.s3Configuration), VpcConfiguration: cfnDeliveryStreamVpcConfigurationPropertyToCloudFormation(properties.vpcConfiguration) }) : properties;
    }
    function CfnDeliveryStreamAmazonOpenSearchServerlessDestinationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bufferingHints", "BufferingHints", properties.BufferingHints != null ? CfnDeliveryStreamAmazonOpenSearchServerlessBufferingHintsPropertyFromCloudFormation(properties.BufferingHints) : void 0), ret.addPropertyResult("cloudWatchLoggingOptions", "CloudWatchLoggingOptions", properties.CloudWatchLoggingOptions != null ? CfnDeliveryStreamCloudWatchLoggingOptionsPropertyFromCloudFormation(properties.CloudWatchLoggingOptions) : void 0), ret.addPropertyResult("collectionEndpoint", "CollectionEndpoint", properties.CollectionEndpoint != null ? cfn_parse.FromCloudFormation.getString(properties.CollectionEndpoint) : void 0), ret.addPropertyResult("indexName", "IndexName", cfn_parse.FromCloudFormation.getString(properties.IndexName)), ret.addPropertyResult("processingConfiguration", "ProcessingConfiguration", properties.ProcessingConfiguration != null ? CfnDeliveryStreamProcessingConfigurationPropertyFromCloudFormation(properties.ProcessingConfiguration) : void 0), ret.addPropertyResult("retryOptions", "RetryOptions", properties.RetryOptions != null ? CfnDeliveryStreamAmazonOpenSearchServerlessRetryOptionsPropertyFromCloudFormation(properties.RetryOptions) : void 0), ret.addPropertyResult("roleArn", "RoleARN", cfn_parse.FromCloudFormation.getString(properties.RoleARN)), ret.addPropertyResult("s3BackupMode", "S3BackupMode", properties.S3BackupMode != null ? cfn_parse.FromCloudFormation.getString(properties.S3BackupMode) : void 0), ret.addPropertyResult("s3Configuration", "S3Configuration", CfnDeliveryStreamS3DestinationConfigurationPropertyFromCloudFormation(properties.S3Configuration)), ret.addPropertyResult("vpcConfiguration", "VpcConfiguration", properties.VpcConfiguration != null ? CfnDeliveryStreamVpcConfigurationPropertyFromCloudFormation(properties.VpcConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_AmazonOpenSearchServerlessRetryOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("durationInSeconds", cdk.validateNumber)(properties.durationInSeconds)), errors.wrap('supplied properties not correct for "AmazonOpenSearchServerlessRetryOptionsProperty"');
    }
    function cfnDeliveryStreamAmazonOpenSearchServerlessRetryOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_AmazonOpenSearchServerlessRetryOptionsPropertyValidator(properties).assertSuccess(), { DurationInSeconds: cdk.numberToCloudFormation(properties.durationInSeconds) }) : properties;
    }
    function CfnDeliveryStreamAmazonOpenSearchServerlessRetryOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("durationInSeconds", "DurationInSeconds", properties.DurationInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.DurationInSeconds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_AmazonopensearchserviceBufferingHintsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("intervalInSeconds", cdk.validateNumber)(properties.intervalInSeconds)), errors.collect(cdk.propertyValidator("sizeInMBs", cdk.validateNumber)(properties.sizeInMBs)), errors.wrap('supplied properties not correct for "AmazonopensearchserviceBufferingHintsProperty"');
    }
    function cfnDeliveryStreamAmazonopensearchserviceBufferingHintsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_AmazonopensearchserviceBufferingHintsPropertyValidator(properties).assertSuccess(), { IntervalInSeconds: cdk.numberToCloudFormation(properties.intervalInSeconds), SizeInMBs: cdk.numberToCloudFormation(properties.sizeInMBs) }) : properties;
    }
    function CfnDeliveryStreamAmazonopensearchserviceBufferingHintsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("intervalInSeconds", "IntervalInSeconds", properties.IntervalInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.IntervalInSeconds) : void 0), ret.addPropertyResult("sizeInMBs", "SizeInMBs", properties.SizeInMBs != null ? cfn_parse.FromCloudFormation.getNumber(properties.SizeInMBs) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_AmazonopensearchserviceDestinationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bufferingHints", CfnDeliveryStream_AmazonopensearchserviceBufferingHintsPropertyValidator)(properties.bufferingHints)), errors.collect(cdk.propertyValidator("cloudWatchLoggingOptions", CfnDeliveryStream_CloudWatchLoggingOptionsPropertyValidator)(properties.cloudWatchLoggingOptions)), errors.collect(cdk.propertyValidator("clusterEndpoint", cdk.validateString)(properties.clusterEndpoint)), errors.collect(cdk.propertyValidator("documentIdOptions", CfnDeliveryStream_DocumentIdOptionsPropertyValidator)(properties.documentIdOptions)), errors.collect(cdk.propertyValidator("domainArn", cdk.validateString)(properties.domainArn)), errors.collect(cdk.propertyValidator("indexName", cdk.requiredValidator)(properties.indexName)), errors.collect(cdk.propertyValidator("indexName", cdk.validateString)(properties.indexName)), errors.collect(cdk.propertyValidator("indexRotationPeriod", cdk.validateString)(properties.indexRotationPeriod)), errors.collect(cdk.propertyValidator("processingConfiguration", CfnDeliveryStream_ProcessingConfigurationPropertyValidator)(properties.processingConfiguration)), errors.collect(cdk.propertyValidator("retryOptions", CfnDeliveryStream_AmazonopensearchserviceRetryOptionsPropertyValidator)(properties.retryOptions)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("s3BackupMode", cdk.validateString)(properties.s3BackupMode)), errors.collect(cdk.propertyValidator("s3Configuration", cdk.requiredValidator)(properties.s3Configuration)), errors.collect(cdk.propertyValidator("s3Configuration", CfnDeliveryStream_S3DestinationConfigurationPropertyValidator)(properties.s3Configuration)), errors.collect(cdk.propertyValidator("typeName", cdk.validateString)(properties.typeName)), errors.collect(cdk.propertyValidator("vpcConfiguration", CfnDeliveryStream_VpcConfigurationPropertyValidator)(properties.vpcConfiguration)), errors.wrap('supplied properties not correct for "AmazonopensearchserviceDestinationConfigurationProperty"');
    }
    function cfnDeliveryStreamAmazonopensearchserviceDestinationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_AmazonopensearchserviceDestinationConfigurationPropertyValidator(properties).assertSuccess(), { BufferingHints: cfnDeliveryStreamAmazonopensearchserviceBufferingHintsPropertyToCloudFormation(properties.bufferingHints), CloudWatchLoggingOptions: cfnDeliveryStreamCloudWatchLoggingOptionsPropertyToCloudFormation(properties.cloudWatchLoggingOptions), ClusterEndpoint: cdk.stringToCloudFormation(properties.clusterEndpoint), DocumentIdOptions: cfnDeliveryStreamDocumentIdOptionsPropertyToCloudFormation(properties.documentIdOptions), DomainARN: cdk.stringToCloudFormation(properties.domainArn), IndexName: cdk.stringToCloudFormation(properties.indexName), IndexRotationPeriod: cdk.stringToCloudFormation(properties.indexRotationPeriod), ProcessingConfiguration: cfnDeliveryStreamProcessingConfigurationPropertyToCloudFormation(properties.processingConfiguration), RetryOptions: cfnDeliveryStreamAmazonopensearchserviceRetryOptionsPropertyToCloudFormation(properties.retryOptions), RoleARN: cdk.stringToCloudFormation(properties.roleArn), S3BackupMode: cdk.stringToCloudFormation(properties.s3BackupMode), S3Configuration: cfnDeliveryStreamS3DestinationConfigurationPropertyToCloudFormation(properties.s3Configuration), TypeName: cdk.stringToCloudFormation(properties.typeName), VpcConfiguration: cfnDeliveryStreamVpcConfigurationPropertyToCloudFormation(properties.vpcConfiguration) }) : properties;
    }
    function CfnDeliveryStreamAmazonopensearchserviceDestinationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bufferingHints", "BufferingHints", properties.BufferingHints != null ? CfnDeliveryStreamAmazonopensearchserviceBufferingHintsPropertyFromCloudFormation(properties.BufferingHints) : void 0), ret.addPropertyResult("cloudWatchLoggingOptions", "CloudWatchLoggingOptions", properties.CloudWatchLoggingOptions != null ? CfnDeliveryStreamCloudWatchLoggingOptionsPropertyFromCloudFormation(properties.CloudWatchLoggingOptions) : void 0), ret.addPropertyResult("clusterEndpoint", "ClusterEndpoint", properties.ClusterEndpoint != null ? cfn_parse.FromCloudFormation.getString(properties.ClusterEndpoint) : void 0), ret.addPropertyResult("documentIdOptions", "DocumentIdOptions", properties.DocumentIdOptions != null ? CfnDeliveryStreamDocumentIdOptionsPropertyFromCloudFormation(properties.DocumentIdOptions) : void 0), ret.addPropertyResult("domainArn", "DomainARN", properties.DomainARN != null ? cfn_parse.FromCloudFormation.getString(properties.DomainARN) : void 0), ret.addPropertyResult("indexName", "IndexName", cfn_parse.FromCloudFormation.getString(properties.IndexName)), ret.addPropertyResult("indexRotationPeriod", "IndexRotationPeriod", properties.IndexRotationPeriod != null ? cfn_parse.FromCloudFormation.getString(properties.IndexRotationPeriod) : void 0), ret.addPropertyResult("processingConfiguration", "ProcessingConfiguration", properties.ProcessingConfiguration != null ? CfnDeliveryStreamProcessingConfigurationPropertyFromCloudFormation(properties.ProcessingConfiguration) : void 0), ret.addPropertyResult("retryOptions", "RetryOptions", properties.RetryOptions != null ? CfnDeliveryStreamAmazonopensearchserviceRetryOptionsPropertyFromCloudFormation(properties.RetryOptions) : void 0), ret.addPropertyResult("roleArn", "RoleARN", cfn_parse.FromCloudFormation.getString(properties.RoleARN)), ret.addPropertyResult("s3BackupMode", "S3BackupMode", properties.S3BackupMode != null ? cfn_parse.FromCloudFormation.getString(properties.S3BackupMode) : void 0), ret.addPropertyResult("s3Configuration", "S3Configuration", CfnDeliveryStreamS3DestinationConfigurationPropertyFromCloudFormation(properties.S3Configuration)), ret.addPropertyResult("typeName", "TypeName", properties.TypeName != null ? cfn_parse.FromCloudFormation.getString(properties.TypeName) : void 0), ret.addPropertyResult("vpcConfiguration", "VpcConfiguration", properties.VpcConfiguration != null ? CfnDeliveryStreamVpcConfigurationPropertyFromCloudFormation(properties.VpcConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_AmazonopensearchserviceRetryOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("durationInSeconds", cdk.validateNumber)(properties.durationInSeconds)), errors.wrap('supplied properties not correct for "AmazonopensearchserviceRetryOptionsProperty"');
    }
    function cfnDeliveryStreamAmazonopensearchserviceRetryOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_AmazonopensearchserviceRetryOptionsPropertyValidator(properties).assertSuccess(), { DurationInSeconds: cdk.numberToCloudFormation(properties.durationInSeconds) }) : properties;
    }
    function CfnDeliveryStreamAmazonopensearchserviceRetryOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("durationInSeconds", "DurationInSeconds", properties.DurationInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.DurationInSeconds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_BufferingHintsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("intervalInSeconds", cdk.validateNumber)(properties.intervalInSeconds)), errors.collect(cdk.propertyValidator("sizeInMBs", cdk.validateNumber)(properties.sizeInMBs)), errors.wrap('supplied properties not correct for "BufferingHintsProperty"');
    }
    function cfnDeliveryStreamBufferingHintsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_BufferingHintsPropertyValidator(properties).assertSuccess(), { IntervalInSeconds: cdk.numberToCloudFormation(properties.intervalInSeconds), SizeInMBs: cdk.numberToCloudFormation(properties.sizeInMBs) }) : properties;
    }
    function CfnDeliveryStreamBufferingHintsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("intervalInSeconds", "IntervalInSeconds", properties.IntervalInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.IntervalInSeconds) : void 0), ret.addPropertyResult("sizeInMBs", "SizeInMBs", properties.SizeInMBs != null ? cfn_parse.FromCloudFormation.getNumber(properties.SizeInMBs) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_CloudWatchLoggingOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("logGroupName", cdk.validateString)(properties.logGroupName)), errors.collect(cdk.propertyValidator("logStreamName", cdk.validateString)(properties.logStreamName)), errors.wrap('supplied properties not correct for "CloudWatchLoggingOptionsProperty"');
    }
    function cfnDeliveryStreamCloudWatchLoggingOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_CloudWatchLoggingOptionsPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled), LogGroupName: cdk.stringToCloudFormation(properties.logGroupName), LogStreamName: cdk.stringToCloudFormation(properties.logStreamName) }) : properties;
    }
    function CfnDeliveryStreamCloudWatchLoggingOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("logGroupName", "LogGroupName", properties.LogGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.LogGroupName) : void 0), ret.addPropertyResult("logStreamName", "LogStreamName", properties.LogStreamName != null ? cfn_parse.FromCloudFormation.getString(properties.LogStreamName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_CopyCommandPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("copyOptions", cdk.validateString)(properties.copyOptions)), errors.collect(cdk.propertyValidator("dataTableColumns", cdk.validateString)(properties.dataTableColumns)), errors.collect(cdk.propertyValidator("dataTableName", cdk.requiredValidator)(properties.dataTableName)), errors.collect(cdk.propertyValidator("dataTableName", cdk.validateString)(properties.dataTableName)), errors.wrap('supplied properties not correct for "CopyCommandProperty"');
    }
    function cfnDeliveryStreamCopyCommandPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_CopyCommandPropertyValidator(properties).assertSuccess(), { CopyOptions: cdk.stringToCloudFormation(properties.copyOptions), DataTableColumns: cdk.stringToCloudFormation(properties.dataTableColumns), DataTableName: cdk.stringToCloudFormation(properties.dataTableName) }) : properties;
    }
    function CfnDeliveryStreamCopyCommandPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("copyOptions", "CopyOptions", properties.CopyOptions != null ? cfn_parse.FromCloudFormation.getString(properties.CopyOptions) : void 0), ret.addPropertyResult("dataTableColumns", "DataTableColumns", properties.DataTableColumns != null ? cfn_parse.FromCloudFormation.getString(properties.DataTableColumns) : void 0), ret.addPropertyResult("dataTableName", "DataTableName", cfn_parse.FromCloudFormation.getString(properties.DataTableName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_DataFormatConversionConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("inputFormatConfiguration", CfnDeliveryStream_InputFormatConfigurationPropertyValidator)(properties.inputFormatConfiguration)), errors.collect(cdk.propertyValidator("outputFormatConfiguration", CfnDeliveryStream_OutputFormatConfigurationPropertyValidator)(properties.outputFormatConfiguration)), errors.collect(cdk.propertyValidator("schemaConfiguration", CfnDeliveryStream_SchemaConfigurationPropertyValidator)(properties.schemaConfiguration)), errors.wrap('supplied properties not correct for "DataFormatConversionConfigurationProperty"');
    }
    function cfnDeliveryStreamDataFormatConversionConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_DataFormatConversionConfigurationPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled), InputFormatConfiguration: cfnDeliveryStreamInputFormatConfigurationPropertyToCloudFormation(properties.inputFormatConfiguration), OutputFormatConfiguration: cfnDeliveryStreamOutputFormatConfigurationPropertyToCloudFormation(properties.outputFormatConfiguration), SchemaConfiguration: cfnDeliveryStreamSchemaConfigurationPropertyToCloudFormation(properties.schemaConfiguration) }) : properties;
    }
    function CfnDeliveryStreamDataFormatConversionConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("inputFormatConfiguration", "InputFormatConfiguration", properties.InputFormatConfiguration != null ? CfnDeliveryStreamInputFormatConfigurationPropertyFromCloudFormation(properties.InputFormatConfiguration) : void 0), ret.addPropertyResult("outputFormatConfiguration", "OutputFormatConfiguration", properties.OutputFormatConfiguration != null ? CfnDeliveryStreamOutputFormatConfigurationPropertyFromCloudFormation(properties.OutputFormatConfiguration) : void 0), ret.addPropertyResult("schemaConfiguration", "SchemaConfiguration", properties.SchemaConfiguration != null ? CfnDeliveryStreamSchemaConfigurationPropertyFromCloudFormation(properties.SchemaConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_DeliveryStreamEncryptionConfigurationInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("keyArn", cdk.validateString)(properties.keyArn)), errors.collect(cdk.propertyValidator("keyType", cdk.requiredValidator)(properties.keyType)), errors.collect(cdk.propertyValidator("keyType", cdk.validateString)(properties.keyType)), errors.wrap('supplied properties not correct for "DeliveryStreamEncryptionConfigurationInputProperty"');
    }
    function cfnDeliveryStreamDeliveryStreamEncryptionConfigurationInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_DeliveryStreamEncryptionConfigurationInputPropertyValidator(properties).assertSuccess(), { KeyARN: cdk.stringToCloudFormation(properties.keyArn), KeyType: cdk.stringToCloudFormation(properties.keyType) }) : properties;
    }
    function CfnDeliveryStreamDeliveryStreamEncryptionConfigurationInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("keyArn", "KeyARN", properties.KeyARN != null ? cfn_parse.FromCloudFormation.getString(properties.KeyARN) : void 0), ret.addPropertyResult("keyType", "KeyType", cfn_parse.FromCloudFormation.getString(properties.KeyType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_DeserializerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("hiveJsonSerDe", CfnDeliveryStream_HiveJsonSerDePropertyValidator)(properties.hiveJsonSerDe)), errors.collect(cdk.propertyValidator("openXJsonSerDe", CfnDeliveryStream_OpenXJsonSerDePropertyValidator)(properties.openXJsonSerDe)), errors.wrap('supplied properties not correct for "DeserializerProperty"');
    }
    function cfnDeliveryStreamDeserializerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_DeserializerPropertyValidator(properties).assertSuccess(), { HiveJsonSerDe: cfnDeliveryStreamHiveJsonSerDePropertyToCloudFormation(properties.hiveJsonSerDe), OpenXJsonSerDe: cfnDeliveryStreamOpenXJsonSerDePropertyToCloudFormation(properties.openXJsonSerDe) }) : properties;
    }
    function CfnDeliveryStreamDeserializerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("hiveJsonSerDe", "HiveJsonSerDe", properties.HiveJsonSerDe != null ? CfnDeliveryStreamHiveJsonSerDePropertyFromCloudFormation(properties.HiveJsonSerDe) : void 0), ret.addPropertyResult("openXJsonSerDe", "OpenXJsonSerDe", properties.OpenXJsonSerDe != null ? CfnDeliveryStreamOpenXJsonSerDePropertyFromCloudFormation(properties.OpenXJsonSerDe) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_DocumentIdOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultDocumentIdFormat", cdk.requiredValidator)(properties.defaultDocumentIdFormat)), errors.collect(cdk.propertyValidator("defaultDocumentIdFormat", cdk.validateString)(properties.defaultDocumentIdFormat)), errors.wrap('supplied properties not correct for "DocumentIdOptionsProperty"');
    }
    function cfnDeliveryStreamDocumentIdOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_DocumentIdOptionsPropertyValidator(properties).assertSuccess(), { DefaultDocumentIdFormat: cdk.stringToCloudFormation(properties.defaultDocumentIdFormat) }) : properties;
    }
    function CfnDeliveryStreamDocumentIdOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultDocumentIdFormat", "DefaultDocumentIdFormat", cfn_parse.FromCloudFormation.getString(properties.DefaultDocumentIdFormat)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_DynamicPartitioningConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("retryOptions", CfnDeliveryStream_RetryOptionsPropertyValidator)(properties.retryOptions)), errors.wrap('supplied properties not correct for "DynamicPartitioningConfigurationProperty"');
    }
    function cfnDeliveryStreamDynamicPartitioningConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_DynamicPartitioningConfigurationPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled), RetryOptions: cfnDeliveryStreamRetryOptionsPropertyToCloudFormation(properties.retryOptions) }) : properties;
    }
    function CfnDeliveryStreamDynamicPartitioningConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("retryOptions", "RetryOptions", properties.RetryOptions != null ? CfnDeliveryStreamRetryOptionsPropertyFromCloudFormation(properties.RetryOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_ElasticsearchBufferingHintsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("intervalInSeconds", cdk.validateNumber)(properties.intervalInSeconds)), errors.collect(cdk.propertyValidator("sizeInMBs", cdk.validateNumber)(properties.sizeInMBs)), errors.wrap('supplied properties not correct for "ElasticsearchBufferingHintsProperty"');
    }
    function cfnDeliveryStreamElasticsearchBufferingHintsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_ElasticsearchBufferingHintsPropertyValidator(properties).assertSuccess(), { IntervalInSeconds: cdk.numberToCloudFormation(properties.intervalInSeconds), SizeInMBs: cdk.numberToCloudFormation(properties.sizeInMBs) }) : properties;
    }
    function CfnDeliveryStreamElasticsearchBufferingHintsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("intervalInSeconds", "IntervalInSeconds", properties.IntervalInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.IntervalInSeconds) : void 0), ret.addPropertyResult("sizeInMBs", "SizeInMBs", properties.SizeInMBs != null ? cfn_parse.FromCloudFormation.getNumber(properties.SizeInMBs) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_ElasticsearchDestinationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bufferingHints", CfnDeliveryStream_ElasticsearchBufferingHintsPropertyValidator)(properties.bufferingHints)), errors.collect(cdk.propertyValidator("cloudWatchLoggingOptions", CfnDeliveryStream_CloudWatchLoggingOptionsPropertyValidator)(properties.cloudWatchLoggingOptions)), errors.collect(cdk.propertyValidator("clusterEndpoint", cdk.validateString)(properties.clusterEndpoint)), errors.collect(cdk.propertyValidator("documentIdOptions", CfnDeliveryStream_DocumentIdOptionsPropertyValidator)(properties.documentIdOptions)), errors.collect(cdk.propertyValidator("domainArn", cdk.validateString)(properties.domainArn)), errors.collect(cdk.propertyValidator("indexName", cdk.requiredValidator)(properties.indexName)), errors.collect(cdk.propertyValidator("indexName", cdk.validateString)(properties.indexName)), errors.collect(cdk.propertyValidator("indexRotationPeriod", cdk.validateString)(properties.indexRotationPeriod)), errors.collect(cdk.propertyValidator("processingConfiguration", CfnDeliveryStream_ProcessingConfigurationPropertyValidator)(properties.processingConfiguration)), errors.collect(cdk.propertyValidator("retryOptions", CfnDeliveryStream_ElasticsearchRetryOptionsPropertyValidator)(properties.retryOptions)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("s3BackupMode", cdk.validateString)(properties.s3BackupMode)), errors.collect(cdk.propertyValidator("s3Configuration", cdk.requiredValidator)(properties.s3Configuration)), errors.collect(cdk.propertyValidator("s3Configuration", CfnDeliveryStream_S3DestinationConfigurationPropertyValidator)(properties.s3Configuration)), errors.collect(cdk.propertyValidator("typeName", cdk.validateString)(properties.typeName)), errors.collect(cdk.propertyValidator("vpcConfiguration", CfnDeliveryStream_VpcConfigurationPropertyValidator)(properties.vpcConfiguration)), errors.wrap('supplied properties not correct for "ElasticsearchDestinationConfigurationProperty"');
    }
    function cfnDeliveryStreamElasticsearchDestinationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_ElasticsearchDestinationConfigurationPropertyValidator(properties).assertSuccess(), { BufferingHints: cfnDeliveryStreamElasticsearchBufferingHintsPropertyToCloudFormation(properties.bufferingHints), CloudWatchLoggingOptions: cfnDeliveryStreamCloudWatchLoggingOptionsPropertyToCloudFormation(properties.cloudWatchLoggingOptions), ClusterEndpoint: cdk.stringToCloudFormation(properties.clusterEndpoint), DocumentIdOptions: cfnDeliveryStreamDocumentIdOptionsPropertyToCloudFormation(properties.documentIdOptions), DomainARN: cdk.stringToCloudFormation(properties.domainArn), IndexName: cdk.stringToCloudFormation(properties.indexName), IndexRotationPeriod: cdk.stringToCloudFormation(properties.indexRotationPeriod), ProcessingConfiguration: cfnDeliveryStreamProcessingConfigurationPropertyToCloudFormation(properties.processingConfiguration), RetryOptions: cfnDeliveryStreamElasticsearchRetryOptionsPropertyToCloudFormation(properties.retryOptions), RoleARN: cdk.stringToCloudFormation(properties.roleArn), S3BackupMode: cdk.stringToCloudFormation(properties.s3BackupMode), S3Configuration: cfnDeliveryStreamS3DestinationConfigurationPropertyToCloudFormation(properties.s3Configuration), TypeName: cdk.stringToCloudFormation(properties.typeName), VpcConfiguration: cfnDeliveryStreamVpcConfigurationPropertyToCloudFormation(properties.vpcConfiguration) }) : properties;
    }
    function CfnDeliveryStreamElasticsearchDestinationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bufferingHints", "BufferingHints", properties.BufferingHints != null ? CfnDeliveryStreamElasticsearchBufferingHintsPropertyFromCloudFormation(properties.BufferingHints) : void 0), ret.addPropertyResult("cloudWatchLoggingOptions", "CloudWatchLoggingOptions", properties.CloudWatchLoggingOptions != null ? CfnDeliveryStreamCloudWatchLoggingOptionsPropertyFromCloudFormation(properties.CloudWatchLoggingOptions) : void 0), ret.addPropertyResult("clusterEndpoint", "ClusterEndpoint", properties.ClusterEndpoint != null ? cfn_parse.FromCloudFormation.getString(properties.ClusterEndpoint) : void 0), ret.addPropertyResult("documentIdOptions", "DocumentIdOptions", properties.DocumentIdOptions != null ? CfnDeliveryStreamDocumentIdOptionsPropertyFromCloudFormation(properties.DocumentIdOptions) : void 0), ret.addPropertyResult("domainArn", "DomainARN", properties.DomainARN != null ? cfn_parse.FromCloudFormation.getString(properties.DomainARN) : void 0), ret.addPropertyResult("indexName", "IndexName", cfn_parse.FromCloudFormation.getString(properties.IndexName)), ret.addPropertyResult("indexRotationPeriod", "IndexRotationPeriod", properties.IndexRotationPeriod != null ? cfn_parse.FromCloudFormation.getString(properties.IndexRotationPeriod) : void 0), ret.addPropertyResult("processingConfiguration", "ProcessingConfiguration", properties.ProcessingConfiguration != null ? CfnDeliveryStreamProcessingConfigurationPropertyFromCloudFormation(properties.ProcessingConfiguration) : void 0), ret.addPropertyResult("retryOptions", "RetryOptions", properties.RetryOptions != null ? CfnDeliveryStreamElasticsearchRetryOptionsPropertyFromCloudFormation(properties.RetryOptions) : void 0), ret.addPropertyResult("roleArn", "RoleARN", cfn_parse.FromCloudFormation.getString(properties.RoleARN)), ret.addPropertyResult("s3BackupMode", "S3BackupMode", properties.S3BackupMode != null ? cfn_parse.FromCloudFormation.getString(properties.S3BackupMode) : void 0), ret.addPropertyResult("s3Configuration", "S3Configuration", CfnDeliveryStreamS3DestinationConfigurationPropertyFromCloudFormation(properties.S3Configuration)), ret.addPropertyResult("typeName", "TypeName", properties.TypeName != null ? cfn_parse.FromCloudFormation.getString(properties.TypeName) : void 0), ret.addPropertyResult("vpcConfiguration", "VpcConfiguration", properties.VpcConfiguration != null ? CfnDeliveryStreamVpcConfigurationPropertyFromCloudFormation(properties.VpcConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_ElasticsearchRetryOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("durationInSeconds", cdk.validateNumber)(properties.durationInSeconds)), errors.wrap('supplied properties not correct for "ElasticsearchRetryOptionsProperty"');
    }
    function cfnDeliveryStreamElasticsearchRetryOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_ElasticsearchRetryOptionsPropertyValidator(properties).assertSuccess(), { DurationInSeconds: cdk.numberToCloudFormation(properties.durationInSeconds) }) : properties;
    }
    function CfnDeliveryStreamElasticsearchRetryOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("durationInSeconds", "DurationInSeconds", properties.DurationInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.DurationInSeconds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_EncryptionConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kmsEncryptionConfig", CfnDeliveryStream_KMSEncryptionConfigPropertyValidator)(properties.kmsEncryptionConfig)), errors.collect(cdk.propertyValidator("noEncryptionConfig", cdk.validateString)(properties.noEncryptionConfig)), errors.wrap('supplied properties not correct for "EncryptionConfigurationProperty"');
    }
    function cfnDeliveryStreamEncryptionConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_EncryptionConfigurationPropertyValidator(properties).assertSuccess(), { KMSEncryptionConfig: cfnDeliveryStreamKMSEncryptionConfigPropertyToCloudFormation(properties.kmsEncryptionConfig), NoEncryptionConfig: cdk.stringToCloudFormation(properties.noEncryptionConfig) }) : properties;
    }
    function CfnDeliveryStreamEncryptionConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsEncryptionConfig", "KMSEncryptionConfig", properties.KMSEncryptionConfig != null ? CfnDeliveryStreamKMSEncryptionConfigPropertyFromCloudFormation(properties.KMSEncryptionConfig) : void 0), ret.addPropertyResult("noEncryptionConfig", "NoEncryptionConfig", properties.NoEncryptionConfig != null ? cfn_parse.FromCloudFormation.getString(properties.NoEncryptionConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_ExtendedS3DestinationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketArn", cdk.requiredValidator)(properties.bucketArn)), errors.collect(cdk.propertyValidator("bucketArn", cdk.validateString)(properties.bucketArn)), errors.collect(cdk.propertyValidator("bufferingHints", CfnDeliveryStream_BufferingHintsPropertyValidator)(properties.bufferingHints)), errors.collect(cdk.propertyValidator("cloudWatchLoggingOptions", CfnDeliveryStream_CloudWatchLoggingOptionsPropertyValidator)(properties.cloudWatchLoggingOptions)), errors.collect(cdk.propertyValidator("compressionFormat", cdk.validateString)(properties.compressionFormat)), errors.collect(cdk.propertyValidator("dataFormatConversionConfiguration", CfnDeliveryStream_DataFormatConversionConfigurationPropertyValidator)(properties.dataFormatConversionConfiguration)), errors.collect(cdk.propertyValidator("dynamicPartitioningConfiguration", CfnDeliveryStream_DynamicPartitioningConfigurationPropertyValidator)(properties.dynamicPartitioningConfiguration)), errors.collect(cdk.propertyValidator("encryptionConfiguration", CfnDeliveryStream_EncryptionConfigurationPropertyValidator)(properties.encryptionConfiguration)), errors.collect(cdk.propertyValidator("errorOutputPrefix", cdk.validateString)(properties.errorOutputPrefix)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.collect(cdk.propertyValidator("processingConfiguration", CfnDeliveryStream_ProcessingConfigurationPropertyValidator)(properties.processingConfiguration)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("s3BackupConfiguration", CfnDeliveryStream_S3DestinationConfigurationPropertyValidator)(properties.s3BackupConfiguration)), errors.collect(cdk.propertyValidator("s3BackupMode", cdk.validateString)(properties.s3BackupMode)), errors.wrap('supplied properties not correct for "ExtendedS3DestinationConfigurationProperty"');
    }
    function cfnDeliveryStreamExtendedS3DestinationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_ExtendedS3DestinationConfigurationPropertyValidator(properties).assertSuccess(), { BucketARN: cdk.stringToCloudFormation(properties.bucketArn), BufferingHints: cfnDeliveryStreamBufferingHintsPropertyToCloudFormation(properties.bufferingHints), CloudWatchLoggingOptions: cfnDeliveryStreamCloudWatchLoggingOptionsPropertyToCloudFormation(properties.cloudWatchLoggingOptions), CompressionFormat: cdk.stringToCloudFormation(properties.compressionFormat), DataFormatConversionConfiguration: cfnDeliveryStreamDataFormatConversionConfigurationPropertyToCloudFormation(properties.dataFormatConversionConfiguration), DynamicPartitioningConfiguration: cfnDeliveryStreamDynamicPartitioningConfigurationPropertyToCloudFormation(properties.dynamicPartitioningConfiguration), EncryptionConfiguration: cfnDeliveryStreamEncryptionConfigurationPropertyToCloudFormation(properties.encryptionConfiguration), ErrorOutputPrefix: cdk.stringToCloudFormation(properties.errorOutputPrefix), Prefix: cdk.stringToCloudFormation(properties.prefix), ProcessingConfiguration: cfnDeliveryStreamProcessingConfigurationPropertyToCloudFormation(properties.processingConfiguration), RoleARN: cdk.stringToCloudFormation(properties.roleArn), S3BackupConfiguration: cfnDeliveryStreamS3DestinationConfigurationPropertyToCloudFormation(properties.s3BackupConfiguration), S3BackupMode: cdk.stringToCloudFormation(properties.s3BackupMode) }) : properties;
    }
    function CfnDeliveryStreamExtendedS3DestinationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketArn", "BucketARN", cfn_parse.FromCloudFormation.getString(properties.BucketARN)), ret.addPropertyResult("bufferingHints", "BufferingHints", properties.BufferingHints != null ? CfnDeliveryStreamBufferingHintsPropertyFromCloudFormation(properties.BufferingHints) : void 0), ret.addPropertyResult("cloudWatchLoggingOptions", "CloudWatchLoggingOptions", properties.CloudWatchLoggingOptions != null ? CfnDeliveryStreamCloudWatchLoggingOptionsPropertyFromCloudFormation(properties.CloudWatchLoggingOptions) : void 0), ret.addPropertyResult("compressionFormat", "CompressionFormat", properties.CompressionFormat != null ? cfn_parse.FromCloudFormation.getString(properties.CompressionFormat) : void 0), ret.addPropertyResult("dataFormatConversionConfiguration", "DataFormatConversionConfiguration", properties.DataFormatConversionConfiguration != null ? CfnDeliveryStreamDataFormatConversionConfigurationPropertyFromCloudFormation(properties.DataFormatConversionConfiguration) : void 0), ret.addPropertyResult("dynamicPartitioningConfiguration", "DynamicPartitioningConfiguration", properties.DynamicPartitioningConfiguration != null ? CfnDeliveryStreamDynamicPartitioningConfigurationPropertyFromCloudFormation(properties.DynamicPartitioningConfiguration) : void 0), ret.addPropertyResult("encryptionConfiguration", "EncryptionConfiguration", properties.EncryptionConfiguration != null ? CfnDeliveryStreamEncryptionConfigurationPropertyFromCloudFormation(properties.EncryptionConfiguration) : void 0), ret.addPropertyResult("errorOutputPrefix", "ErrorOutputPrefix", properties.ErrorOutputPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.ErrorOutputPrefix) : void 0), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addPropertyResult("processingConfiguration", "ProcessingConfiguration", properties.ProcessingConfiguration != null ? CfnDeliveryStreamProcessingConfigurationPropertyFromCloudFormation(properties.ProcessingConfiguration) : void 0), ret.addPropertyResult("roleArn", "RoleARN", cfn_parse.FromCloudFormation.getString(properties.RoleARN)), ret.addPropertyResult("s3BackupConfiguration", "S3BackupConfiguration", properties.S3BackupConfiguration != null ? CfnDeliveryStreamS3DestinationConfigurationPropertyFromCloudFormation(properties.S3BackupConfiguration) : void 0), ret.addPropertyResult("s3BackupMode", "S3BackupMode", properties.S3BackupMode != null ? cfn_parse.FromCloudFormation.getString(properties.S3BackupMode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_HiveJsonSerDePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("timestampFormats", cdk.listValidator(cdk.validateString))(properties.timestampFormats)), errors.wrap('supplied properties not correct for "HiveJsonSerDeProperty"');
    }
    function cfnDeliveryStreamHiveJsonSerDePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_HiveJsonSerDePropertyValidator(properties).assertSuccess(), { TimestampFormats: cdk.listMapper(cdk.stringToCloudFormation)(properties.timestampFormats) }) : properties;
    }
    function CfnDeliveryStreamHiveJsonSerDePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("timestampFormats", "TimestampFormats", properties.TimestampFormats != null ? cfn_parse.FromCloudFormation.getStringArray(properties.TimestampFormats) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_HttpEndpointCommonAttributePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributeName", cdk.requiredValidator)(properties.attributeName)), errors.collect(cdk.propertyValidator("attributeName", cdk.validateString)(properties.attributeName)), errors.collect(cdk.propertyValidator("attributeValue", cdk.requiredValidator)(properties.attributeValue)), errors.collect(cdk.propertyValidator("attributeValue", cdk.validateString)(properties.attributeValue)), errors.wrap('supplied properties not correct for "HttpEndpointCommonAttributeProperty"');
    }
    function cfnDeliveryStreamHttpEndpointCommonAttributePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_HttpEndpointCommonAttributePropertyValidator(properties).assertSuccess(), { AttributeName: cdk.stringToCloudFormation(properties.attributeName), AttributeValue: cdk.stringToCloudFormation(properties.attributeValue) }) : properties;
    }
    function CfnDeliveryStreamHttpEndpointCommonAttributePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attributeName", "AttributeName", cfn_parse.FromCloudFormation.getString(properties.AttributeName)), ret.addPropertyResult("attributeValue", "AttributeValue", cfn_parse.FromCloudFormation.getString(properties.AttributeValue)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_HttpEndpointConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessKey", cdk.validateString)(properties.accessKey)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("url", cdk.requiredValidator)(properties.url)), errors.collect(cdk.propertyValidator("url", cdk.validateString)(properties.url)), errors.wrap('supplied properties not correct for "HttpEndpointConfigurationProperty"');
    }
    function cfnDeliveryStreamHttpEndpointConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_HttpEndpointConfigurationPropertyValidator(properties).assertSuccess(), { AccessKey: cdk.stringToCloudFormation(properties.accessKey), Name: cdk.stringToCloudFormation(properties.name), Url: cdk.stringToCloudFormation(properties.url) }) : properties;
    }
    function CfnDeliveryStreamHttpEndpointConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessKey", "AccessKey", properties.AccessKey != null ? cfn_parse.FromCloudFormation.getString(properties.AccessKey) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("url", "Url", cfn_parse.FromCloudFormation.getString(properties.Url)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_HttpEndpointDestinationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bufferingHints", CfnDeliveryStream_BufferingHintsPropertyValidator)(properties.bufferingHints)), errors.collect(cdk.propertyValidator("cloudWatchLoggingOptions", CfnDeliveryStream_CloudWatchLoggingOptionsPropertyValidator)(properties.cloudWatchLoggingOptions)), errors.collect(cdk.propertyValidator("endpointConfiguration", cdk.requiredValidator)(properties.endpointConfiguration)), errors.collect(cdk.propertyValidator("endpointConfiguration", CfnDeliveryStream_HttpEndpointConfigurationPropertyValidator)(properties.endpointConfiguration)), errors.collect(cdk.propertyValidator("processingConfiguration", CfnDeliveryStream_ProcessingConfigurationPropertyValidator)(properties.processingConfiguration)), errors.collect(cdk.propertyValidator("requestConfiguration", CfnDeliveryStream_HttpEndpointRequestConfigurationPropertyValidator)(properties.requestConfiguration)), errors.collect(cdk.propertyValidator("retryOptions", CfnDeliveryStream_RetryOptionsPropertyValidator)(properties.retryOptions)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("s3BackupMode", cdk.validateString)(properties.s3BackupMode)), errors.collect(cdk.propertyValidator("s3Configuration", cdk.requiredValidator)(properties.s3Configuration)), errors.collect(cdk.propertyValidator("s3Configuration", CfnDeliveryStream_S3DestinationConfigurationPropertyValidator)(properties.s3Configuration)), errors.wrap('supplied properties not correct for "HttpEndpointDestinationConfigurationProperty"');
    }
    function cfnDeliveryStreamHttpEndpointDestinationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_HttpEndpointDestinationConfigurationPropertyValidator(properties).assertSuccess(), { BufferingHints: cfnDeliveryStreamBufferingHintsPropertyToCloudFormation(properties.bufferingHints), CloudWatchLoggingOptions: cfnDeliveryStreamCloudWatchLoggingOptionsPropertyToCloudFormation(properties.cloudWatchLoggingOptions), EndpointConfiguration: cfnDeliveryStreamHttpEndpointConfigurationPropertyToCloudFormation(properties.endpointConfiguration), ProcessingConfiguration: cfnDeliveryStreamProcessingConfigurationPropertyToCloudFormation(properties.processingConfiguration), RequestConfiguration: cfnDeliveryStreamHttpEndpointRequestConfigurationPropertyToCloudFormation(properties.requestConfiguration), RetryOptions: cfnDeliveryStreamRetryOptionsPropertyToCloudFormation(properties.retryOptions), RoleARN: cdk.stringToCloudFormation(properties.roleArn), S3BackupMode: cdk.stringToCloudFormation(properties.s3BackupMode), S3Configuration: cfnDeliveryStreamS3DestinationConfigurationPropertyToCloudFormation(properties.s3Configuration) }) : properties;
    }
    function CfnDeliveryStreamHttpEndpointDestinationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bufferingHints", "BufferingHints", properties.BufferingHints != null ? CfnDeliveryStreamBufferingHintsPropertyFromCloudFormation(properties.BufferingHints) : void 0), ret.addPropertyResult("cloudWatchLoggingOptions", "CloudWatchLoggingOptions", properties.CloudWatchLoggingOptions != null ? CfnDeliveryStreamCloudWatchLoggingOptionsPropertyFromCloudFormation(properties.CloudWatchLoggingOptions) : void 0), ret.addPropertyResult("endpointConfiguration", "EndpointConfiguration", CfnDeliveryStreamHttpEndpointConfigurationPropertyFromCloudFormation(properties.EndpointConfiguration)), ret.addPropertyResult("processingConfiguration", "ProcessingConfiguration", properties.ProcessingConfiguration != null ? CfnDeliveryStreamProcessingConfigurationPropertyFromCloudFormation(properties.ProcessingConfiguration) : void 0), ret.addPropertyResult("requestConfiguration", "RequestConfiguration", properties.RequestConfiguration != null ? CfnDeliveryStreamHttpEndpointRequestConfigurationPropertyFromCloudFormation(properties.RequestConfiguration) : void 0), ret.addPropertyResult("retryOptions", "RetryOptions", properties.RetryOptions != null ? CfnDeliveryStreamRetryOptionsPropertyFromCloudFormation(properties.RetryOptions) : void 0), ret.addPropertyResult("roleArn", "RoleARN", properties.RoleARN != null ? cfn_parse.FromCloudFormation.getString(properties.RoleARN) : void 0), ret.addPropertyResult("s3BackupMode", "S3BackupMode", properties.S3BackupMode != null ? cfn_parse.FromCloudFormation.getString(properties.S3BackupMode) : void 0), ret.addPropertyResult("s3Configuration", "S3Configuration", CfnDeliveryStreamS3DestinationConfigurationPropertyFromCloudFormation(properties.S3Configuration)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_HttpEndpointRequestConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("commonAttributes", cdk.listValidator(CfnDeliveryStream_HttpEndpointCommonAttributePropertyValidator))(properties.commonAttributes)), errors.collect(cdk.propertyValidator("contentEncoding", cdk.validateString)(properties.contentEncoding)), errors.wrap('supplied properties not correct for "HttpEndpointRequestConfigurationProperty"');
    }
    function cfnDeliveryStreamHttpEndpointRequestConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_HttpEndpointRequestConfigurationPropertyValidator(properties).assertSuccess(), { CommonAttributes: cdk.listMapper(cfnDeliveryStreamHttpEndpointCommonAttributePropertyToCloudFormation)(properties.commonAttributes), ContentEncoding: cdk.stringToCloudFormation(properties.contentEncoding) }) : properties;
    }
    function CfnDeliveryStreamHttpEndpointRequestConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("commonAttributes", "CommonAttributes", properties.CommonAttributes != null ? cfn_parse.FromCloudFormation.getArray(CfnDeliveryStreamHttpEndpointCommonAttributePropertyFromCloudFormation)(properties.CommonAttributes) : void 0), ret.addPropertyResult("contentEncoding", "ContentEncoding", properties.ContentEncoding != null ? cfn_parse.FromCloudFormation.getString(properties.ContentEncoding) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_InputFormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deserializer", CfnDeliveryStream_DeserializerPropertyValidator)(properties.deserializer)), errors.wrap('supplied properties not correct for "InputFormatConfigurationProperty"');
    }
    function cfnDeliveryStreamInputFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_InputFormatConfigurationPropertyValidator(properties).assertSuccess(), { Deserializer: cfnDeliveryStreamDeserializerPropertyToCloudFormation(properties.deserializer) }) : properties;
    }
    function CfnDeliveryStreamInputFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deserializer", "Deserializer", properties.Deserializer != null ? CfnDeliveryStreamDeserializerPropertyFromCloudFormation(properties.Deserializer) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_KMSEncryptionConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("awskmsKeyArn", cdk.requiredValidator)(properties.awskmsKeyArn)), errors.collect(cdk.propertyValidator("awskmsKeyArn", cdk.validateString)(properties.awskmsKeyArn)), errors.wrap('supplied properties not correct for "KMSEncryptionConfigProperty"');
    }
    function cfnDeliveryStreamKMSEncryptionConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_KMSEncryptionConfigPropertyValidator(properties).assertSuccess(), { AWSKMSKeyARN: cdk.stringToCloudFormation(properties.awskmsKeyArn) }) : properties;
    }
    function CfnDeliveryStreamKMSEncryptionConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("awskmsKeyArn", "AWSKMSKeyARN", cfn_parse.FromCloudFormation.getString(properties.AWSKMSKeyARN)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_KinesisStreamSourceConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kinesisStreamArn", cdk.requiredValidator)(properties.kinesisStreamArn)), errors.collect(cdk.propertyValidator("kinesisStreamArn", cdk.validateString)(properties.kinesisStreamArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "KinesisStreamSourceConfigurationProperty"');
    }
    function cfnDeliveryStreamKinesisStreamSourceConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_KinesisStreamSourceConfigurationPropertyValidator(properties).assertSuccess(), { KinesisStreamARN: cdk.stringToCloudFormation(properties.kinesisStreamArn), RoleARN: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnDeliveryStreamKinesisStreamSourceConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kinesisStreamArn", "KinesisStreamARN", cfn_parse.FromCloudFormation.getString(properties.KinesisStreamARN)), ret.addPropertyResult("roleArn", "RoleARN", cfn_parse.FromCloudFormation.getString(properties.RoleARN)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_OpenXJsonSerDePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("caseInsensitive", cdk.validateBoolean)(properties.caseInsensitive)), errors.collect(cdk.propertyValidator("columnToJsonKeyMappings", cdk.hashValidator(cdk.validateString))(properties.columnToJsonKeyMappings)), errors.collect(cdk.propertyValidator("convertDotsInJsonKeysToUnderscores", cdk.validateBoolean)(properties.convertDotsInJsonKeysToUnderscores)), errors.wrap('supplied properties not correct for "OpenXJsonSerDeProperty"');
    }
    function cfnDeliveryStreamOpenXJsonSerDePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_OpenXJsonSerDePropertyValidator(properties).assertSuccess(), { CaseInsensitive: cdk.booleanToCloudFormation(properties.caseInsensitive), ColumnToJsonKeyMappings: cdk.hashMapper(cdk.stringToCloudFormation)(properties.columnToJsonKeyMappings), ConvertDotsInJsonKeysToUnderscores: cdk.booleanToCloudFormation(properties.convertDotsInJsonKeysToUnderscores) }) : properties;
    }
    function CfnDeliveryStreamOpenXJsonSerDePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("caseInsensitive", "CaseInsensitive", properties.CaseInsensitive != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CaseInsensitive) : void 0), ret.addPropertyResult("columnToJsonKeyMappings", "ColumnToJsonKeyMappings", properties.ColumnToJsonKeyMappings != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.ColumnToJsonKeyMappings) : void 0), ret.addPropertyResult("convertDotsInJsonKeysToUnderscores", "ConvertDotsInJsonKeysToUnderscores", properties.ConvertDotsInJsonKeysToUnderscores != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ConvertDotsInJsonKeysToUnderscores) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_OrcSerDePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("blockSizeBytes", cdk.validateNumber)(properties.blockSizeBytes)), errors.collect(cdk.propertyValidator("bloomFilterColumns", cdk.listValidator(cdk.validateString))(properties.bloomFilterColumns)), errors.collect(cdk.propertyValidator("bloomFilterFalsePositiveProbability", cdk.validateNumber)(properties.bloomFilterFalsePositiveProbability)), errors.collect(cdk.propertyValidator("compression", cdk.validateString)(properties.compression)), errors.collect(cdk.propertyValidator("dictionaryKeyThreshold", cdk.validateNumber)(properties.dictionaryKeyThreshold)), errors.collect(cdk.propertyValidator("enablePadding", cdk.validateBoolean)(properties.enablePadding)), errors.collect(cdk.propertyValidator("formatVersion", cdk.validateString)(properties.formatVersion)), errors.collect(cdk.propertyValidator("paddingTolerance", cdk.validateNumber)(properties.paddingTolerance)), errors.collect(cdk.propertyValidator("rowIndexStride", cdk.validateNumber)(properties.rowIndexStride)), errors.collect(cdk.propertyValidator("stripeSizeBytes", cdk.validateNumber)(properties.stripeSizeBytes)), errors.wrap('supplied properties not correct for "OrcSerDeProperty"');
    }
    function cfnDeliveryStreamOrcSerDePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_OrcSerDePropertyValidator(properties).assertSuccess(), { BlockSizeBytes: cdk.numberToCloudFormation(properties.blockSizeBytes), BloomFilterColumns: cdk.listMapper(cdk.stringToCloudFormation)(properties.bloomFilterColumns), BloomFilterFalsePositiveProbability: cdk.numberToCloudFormation(properties.bloomFilterFalsePositiveProbability), Compression: cdk.stringToCloudFormation(properties.compression), DictionaryKeyThreshold: cdk.numberToCloudFormation(properties.dictionaryKeyThreshold), EnablePadding: cdk.booleanToCloudFormation(properties.enablePadding), FormatVersion: cdk.stringToCloudFormation(properties.formatVersion), PaddingTolerance: cdk.numberToCloudFormation(properties.paddingTolerance), RowIndexStride: cdk.numberToCloudFormation(properties.rowIndexStride), StripeSizeBytes: cdk.numberToCloudFormation(properties.stripeSizeBytes) }) : properties;
    }
    function CfnDeliveryStreamOrcSerDePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("blockSizeBytes", "BlockSizeBytes", properties.BlockSizeBytes != null ? cfn_parse.FromCloudFormation.getNumber(properties.BlockSizeBytes) : void 0), ret.addPropertyResult("bloomFilterColumns", "BloomFilterColumns", properties.BloomFilterColumns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.BloomFilterColumns) : void 0), ret.addPropertyResult("bloomFilterFalsePositiveProbability", "BloomFilterFalsePositiveProbability", properties.BloomFilterFalsePositiveProbability != null ? cfn_parse.FromCloudFormation.getNumber(properties.BloomFilterFalsePositiveProbability) : void 0), ret.addPropertyResult("compression", "Compression", properties.Compression != null ? cfn_parse.FromCloudFormation.getString(properties.Compression) : void 0), ret.addPropertyResult("dictionaryKeyThreshold", "DictionaryKeyThreshold", properties.DictionaryKeyThreshold != null ? cfn_parse.FromCloudFormation.getNumber(properties.DictionaryKeyThreshold) : void 0), ret.addPropertyResult("enablePadding", "EnablePadding", properties.EnablePadding != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnablePadding) : void 0), ret.addPropertyResult("formatVersion", "FormatVersion", properties.FormatVersion != null ? cfn_parse.FromCloudFormation.getString(properties.FormatVersion) : void 0), ret.addPropertyResult("paddingTolerance", "PaddingTolerance", properties.PaddingTolerance != null ? cfn_parse.FromCloudFormation.getNumber(properties.PaddingTolerance) : void 0), ret.addPropertyResult("rowIndexStride", "RowIndexStride", properties.RowIndexStride != null ? cfn_parse.FromCloudFormation.getNumber(properties.RowIndexStride) : void 0), ret.addPropertyResult("stripeSizeBytes", "StripeSizeBytes", properties.StripeSizeBytes != null ? cfn_parse.FromCloudFormation.getNumber(properties.StripeSizeBytes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_OutputFormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("serializer", CfnDeliveryStream_SerializerPropertyValidator)(properties.serializer)), errors.wrap('supplied properties not correct for "OutputFormatConfigurationProperty"');
    }
    function cfnDeliveryStreamOutputFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_OutputFormatConfigurationPropertyValidator(properties).assertSuccess(), { Serializer: cfnDeliveryStreamSerializerPropertyToCloudFormation(properties.serializer) }) : properties;
    }
    function CfnDeliveryStreamOutputFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("serializer", "Serializer", properties.Serializer != null ? CfnDeliveryStreamSerializerPropertyFromCloudFormation(properties.Serializer) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_ParquetSerDePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("blockSizeBytes", cdk.validateNumber)(properties.blockSizeBytes)), errors.collect(cdk.propertyValidator("compression", cdk.validateString)(properties.compression)), errors.collect(cdk.propertyValidator("enableDictionaryCompression", cdk.validateBoolean)(properties.enableDictionaryCompression)), errors.collect(cdk.propertyValidator("maxPaddingBytes", cdk.validateNumber)(properties.maxPaddingBytes)), errors.collect(cdk.propertyValidator("pageSizeBytes", cdk.validateNumber)(properties.pageSizeBytes)), errors.collect(cdk.propertyValidator("writerVersion", cdk.validateString)(properties.writerVersion)), errors.wrap('supplied properties not correct for "ParquetSerDeProperty"');
    }
    function cfnDeliveryStreamParquetSerDePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_ParquetSerDePropertyValidator(properties).assertSuccess(), { BlockSizeBytes: cdk.numberToCloudFormation(properties.blockSizeBytes), Compression: cdk.stringToCloudFormation(properties.compression), EnableDictionaryCompression: cdk.booleanToCloudFormation(properties.enableDictionaryCompression), MaxPaddingBytes: cdk.numberToCloudFormation(properties.maxPaddingBytes), PageSizeBytes: cdk.numberToCloudFormation(properties.pageSizeBytes), WriterVersion: cdk.stringToCloudFormation(properties.writerVersion) }) : properties;
    }
    function CfnDeliveryStreamParquetSerDePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("blockSizeBytes", "BlockSizeBytes", properties.BlockSizeBytes != null ? cfn_parse.FromCloudFormation.getNumber(properties.BlockSizeBytes) : void 0), ret.addPropertyResult("compression", "Compression", properties.Compression != null ? cfn_parse.FromCloudFormation.getString(properties.Compression) : void 0), ret.addPropertyResult("enableDictionaryCompression", "EnableDictionaryCompression", properties.EnableDictionaryCompression != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableDictionaryCompression) : void 0), ret.addPropertyResult("maxPaddingBytes", "MaxPaddingBytes", properties.MaxPaddingBytes != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxPaddingBytes) : void 0), ret.addPropertyResult("pageSizeBytes", "PageSizeBytes", properties.PageSizeBytes != null ? cfn_parse.FromCloudFormation.getNumber(properties.PageSizeBytes) : void 0), ret.addPropertyResult("writerVersion", "WriterVersion", properties.WriterVersion != null ? cfn_parse.FromCloudFormation.getString(properties.WriterVersion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_ProcessingConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("processors", cdk.listValidator(CfnDeliveryStream_ProcessorPropertyValidator))(properties.processors)), errors.wrap('supplied properties not correct for "ProcessingConfigurationProperty"');
    }
    function cfnDeliveryStreamProcessingConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_ProcessingConfigurationPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled), Processors: cdk.listMapper(cfnDeliveryStreamProcessorPropertyToCloudFormation)(properties.processors) }) : properties;
    }
    function CfnDeliveryStreamProcessingConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("processors", "Processors", properties.Processors != null ? cfn_parse.FromCloudFormation.getArray(CfnDeliveryStreamProcessorPropertyFromCloudFormation)(properties.Processors) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_ProcessorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("parameters", cdk.listValidator(CfnDeliveryStream_ProcessorParameterPropertyValidator))(properties.parameters)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "ProcessorProperty"');
    }
    function cfnDeliveryStreamProcessorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_ProcessorPropertyValidator(properties).assertSuccess(), { Parameters: cdk.listMapper(cfnDeliveryStreamProcessorParameterPropertyToCloudFormation)(properties.parameters), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnDeliveryStreamProcessorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getArray(CfnDeliveryStreamProcessorParameterPropertyFromCloudFormation)(properties.Parameters) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_ProcessorParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("parameterName", cdk.requiredValidator)(properties.parameterName)), errors.collect(cdk.propertyValidator("parameterName", cdk.validateString)(properties.parameterName)), errors.collect(cdk.propertyValidator("parameterValue", cdk.requiredValidator)(properties.parameterValue)), errors.collect(cdk.propertyValidator("parameterValue", cdk.validateString)(properties.parameterValue)), errors.wrap('supplied properties not correct for "ProcessorParameterProperty"');
    }
    function cfnDeliveryStreamProcessorParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_ProcessorParameterPropertyValidator(properties).assertSuccess(), { ParameterName: cdk.stringToCloudFormation(properties.parameterName), ParameterValue: cdk.stringToCloudFormation(properties.parameterValue) }) : properties;
    }
    function CfnDeliveryStreamProcessorParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("parameterName", "ParameterName", cfn_parse.FromCloudFormation.getString(properties.ParameterName)), ret.addPropertyResult("parameterValue", "ParameterValue", cfn_parse.FromCloudFormation.getString(properties.ParameterValue)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_RedshiftDestinationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchLoggingOptions", CfnDeliveryStream_CloudWatchLoggingOptionsPropertyValidator)(properties.cloudWatchLoggingOptions)), errors.collect(cdk.propertyValidator("clusterJdbcurl", cdk.requiredValidator)(properties.clusterJdbcurl)), errors.collect(cdk.propertyValidator("clusterJdbcurl", cdk.validateString)(properties.clusterJdbcurl)), errors.collect(cdk.propertyValidator("copyCommand", cdk.requiredValidator)(properties.copyCommand)), errors.collect(cdk.propertyValidator("copyCommand", CfnDeliveryStream_CopyCommandPropertyValidator)(properties.copyCommand)), errors.collect(cdk.propertyValidator("password", cdk.requiredValidator)(properties.password)), errors.collect(cdk.propertyValidator("password", cdk.validateString)(properties.password)), errors.collect(cdk.propertyValidator("processingConfiguration", CfnDeliveryStream_ProcessingConfigurationPropertyValidator)(properties.processingConfiguration)), errors.collect(cdk.propertyValidator("retryOptions", CfnDeliveryStream_RedshiftRetryOptionsPropertyValidator)(properties.retryOptions)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("s3BackupConfiguration", CfnDeliveryStream_S3DestinationConfigurationPropertyValidator)(properties.s3BackupConfiguration)), errors.collect(cdk.propertyValidator("s3BackupMode", cdk.validateString)(properties.s3BackupMode)), errors.collect(cdk.propertyValidator("s3Configuration", cdk.requiredValidator)(properties.s3Configuration)), errors.collect(cdk.propertyValidator("s3Configuration", CfnDeliveryStream_S3DestinationConfigurationPropertyValidator)(properties.s3Configuration)), errors.collect(cdk.propertyValidator("username", cdk.requiredValidator)(properties.username)), errors.collect(cdk.propertyValidator("username", cdk.validateString)(properties.username)), errors.wrap('supplied properties not correct for "RedshiftDestinationConfigurationProperty"');
    }
    function cfnDeliveryStreamRedshiftDestinationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_RedshiftDestinationConfigurationPropertyValidator(properties).assertSuccess(), { CloudWatchLoggingOptions: cfnDeliveryStreamCloudWatchLoggingOptionsPropertyToCloudFormation(properties.cloudWatchLoggingOptions), ClusterJDBCURL: cdk.stringToCloudFormation(properties.clusterJdbcurl), CopyCommand: cfnDeliveryStreamCopyCommandPropertyToCloudFormation(properties.copyCommand), Password: cdk.stringToCloudFormation(properties.password), ProcessingConfiguration: cfnDeliveryStreamProcessingConfigurationPropertyToCloudFormation(properties.processingConfiguration), RetryOptions: cfnDeliveryStreamRedshiftRetryOptionsPropertyToCloudFormation(properties.retryOptions), RoleARN: cdk.stringToCloudFormation(properties.roleArn), S3BackupConfiguration: cfnDeliveryStreamS3DestinationConfigurationPropertyToCloudFormation(properties.s3BackupConfiguration), S3BackupMode: cdk.stringToCloudFormation(properties.s3BackupMode), S3Configuration: cfnDeliveryStreamS3DestinationConfigurationPropertyToCloudFormation(properties.s3Configuration), Username: cdk.stringToCloudFormation(properties.username) }) : properties;
    }
    function CfnDeliveryStreamRedshiftDestinationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchLoggingOptions", "CloudWatchLoggingOptions", properties.CloudWatchLoggingOptions != null ? CfnDeliveryStreamCloudWatchLoggingOptionsPropertyFromCloudFormation(properties.CloudWatchLoggingOptions) : void 0), ret.addPropertyResult("clusterJdbcurl", "ClusterJDBCURL", cfn_parse.FromCloudFormation.getString(properties.ClusterJDBCURL)), ret.addPropertyResult("copyCommand", "CopyCommand", CfnDeliveryStreamCopyCommandPropertyFromCloudFormation(properties.CopyCommand)), ret.addPropertyResult("password", "Password", cfn_parse.FromCloudFormation.getString(properties.Password)), ret.addPropertyResult("processingConfiguration", "ProcessingConfiguration", properties.ProcessingConfiguration != null ? CfnDeliveryStreamProcessingConfigurationPropertyFromCloudFormation(properties.ProcessingConfiguration) : void 0), ret.addPropertyResult("retryOptions", "RetryOptions", properties.RetryOptions != null ? CfnDeliveryStreamRedshiftRetryOptionsPropertyFromCloudFormation(properties.RetryOptions) : void 0), ret.addPropertyResult("roleArn", "RoleARN", cfn_parse.FromCloudFormation.getString(properties.RoleARN)), ret.addPropertyResult("s3BackupConfiguration", "S3BackupConfiguration", properties.S3BackupConfiguration != null ? CfnDeliveryStreamS3DestinationConfigurationPropertyFromCloudFormation(properties.S3BackupConfiguration) : void 0), ret.addPropertyResult("s3BackupMode", "S3BackupMode", properties.S3BackupMode != null ? cfn_parse.FromCloudFormation.getString(properties.S3BackupMode) : void 0), ret.addPropertyResult("s3Configuration", "S3Configuration", CfnDeliveryStreamS3DestinationConfigurationPropertyFromCloudFormation(properties.S3Configuration)), ret.addPropertyResult("username", "Username", cfn_parse.FromCloudFormation.getString(properties.Username)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_RedshiftRetryOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("durationInSeconds", cdk.validateNumber)(properties.durationInSeconds)), errors.wrap('supplied properties not correct for "RedshiftRetryOptionsProperty"');
    }
    function cfnDeliveryStreamRedshiftRetryOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_RedshiftRetryOptionsPropertyValidator(properties).assertSuccess(), { DurationInSeconds: cdk.numberToCloudFormation(properties.durationInSeconds) }) : properties;
    }
    function CfnDeliveryStreamRedshiftRetryOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("durationInSeconds", "DurationInSeconds", properties.DurationInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.DurationInSeconds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_RetryOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("durationInSeconds", cdk.validateNumber)(properties.durationInSeconds)), errors.wrap('supplied properties not correct for "RetryOptionsProperty"');
    }
    function cfnDeliveryStreamRetryOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_RetryOptionsPropertyValidator(properties).assertSuccess(), { DurationInSeconds: cdk.numberToCloudFormation(properties.durationInSeconds) }) : properties;
    }
    function CfnDeliveryStreamRetryOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("durationInSeconds", "DurationInSeconds", properties.DurationInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.DurationInSeconds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_S3DestinationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketArn", cdk.requiredValidator)(properties.bucketArn)), errors.collect(cdk.propertyValidator("bucketArn", cdk.validateString)(properties.bucketArn)), errors.collect(cdk.propertyValidator("bufferingHints", CfnDeliveryStream_BufferingHintsPropertyValidator)(properties.bufferingHints)), errors.collect(cdk.propertyValidator("cloudWatchLoggingOptions", CfnDeliveryStream_CloudWatchLoggingOptionsPropertyValidator)(properties.cloudWatchLoggingOptions)), errors.collect(cdk.propertyValidator("compressionFormat", cdk.validateString)(properties.compressionFormat)), errors.collect(cdk.propertyValidator("encryptionConfiguration", CfnDeliveryStream_EncryptionConfigurationPropertyValidator)(properties.encryptionConfiguration)), errors.collect(cdk.propertyValidator("errorOutputPrefix", cdk.validateString)(properties.errorOutputPrefix)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "S3DestinationConfigurationProperty"');
    }
    function cfnDeliveryStreamS3DestinationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_S3DestinationConfigurationPropertyValidator(properties).assertSuccess(), { BucketARN: cdk.stringToCloudFormation(properties.bucketArn), BufferingHints: cfnDeliveryStreamBufferingHintsPropertyToCloudFormation(properties.bufferingHints), CloudWatchLoggingOptions: cfnDeliveryStreamCloudWatchLoggingOptionsPropertyToCloudFormation(properties.cloudWatchLoggingOptions), CompressionFormat: cdk.stringToCloudFormation(properties.compressionFormat), EncryptionConfiguration: cfnDeliveryStreamEncryptionConfigurationPropertyToCloudFormation(properties.encryptionConfiguration), ErrorOutputPrefix: cdk.stringToCloudFormation(properties.errorOutputPrefix), Prefix: cdk.stringToCloudFormation(properties.prefix), RoleARN: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnDeliveryStreamS3DestinationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketArn", "BucketARN", cfn_parse.FromCloudFormation.getString(properties.BucketARN)), ret.addPropertyResult("bufferingHints", "BufferingHints", properties.BufferingHints != null ? CfnDeliveryStreamBufferingHintsPropertyFromCloudFormation(properties.BufferingHints) : void 0), ret.addPropertyResult("cloudWatchLoggingOptions", "CloudWatchLoggingOptions", properties.CloudWatchLoggingOptions != null ? CfnDeliveryStreamCloudWatchLoggingOptionsPropertyFromCloudFormation(properties.CloudWatchLoggingOptions) : void 0), ret.addPropertyResult("compressionFormat", "CompressionFormat", properties.CompressionFormat != null ? cfn_parse.FromCloudFormation.getString(properties.CompressionFormat) : void 0), ret.addPropertyResult("encryptionConfiguration", "EncryptionConfiguration", properties.EncryptionConfiguration != null ? CfnDeliveryStreamEncryptionConfigurationPropertyFromCloudFormation(properties.EncryptionConfiguration) : void 0), ret.addPropertyResult("errorOutputPrefix", "ErrorOutputPrefix", properties.ErrorOutputPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.ErrorOutputPrefix) : void 0), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addPropertyResult("roleArn", "RoleARN", cfn_parse.FromCloudFormation.getString(properties.RoleARN)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_SchemaConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalogId", cdk.validateString)(properties.catalogId)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("region", cdk.validateString)(properties.region)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("tableName", cdk.validateString)(properties.tableName)), errors.collect(cdk.propertyValidator("versionId", cdk.validateString)(properties.versionId)), errors.wrap('supplied properties not correct for "SchemaConfigurationProperty"');
    }
    function cfnDeliveryStreamSchemaConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_SchemaConfigurationPropertyValidator(properties).assertSuccess(), { CatalogId: cdk.stringToCloudFormation(properties.catalogId), DatabaseName: cdk.stringToCloudFormation(properties.databaseName), Region: cdk.stringToCloudFormation(properties.region), RoleARN: cdk.stringToCloudFormation(properties.roleArn), TableName: cdk.stringToCloudFormation(properties.tableName), VersionId: cdk.stringToCloudFormation(properties.versionId) }) : properties;
    }
    function CfnDeliveryStreamSchemaConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalogId", "CatalogId", properties.CatalogId != null ? cfn_parse.FromCloudFormation.getString(properties.CatalogId) : void 0), ret.addPropertyResult("databaseName", "DatabaseName", properties.DatabaseName != null ? cfn_parse.FromCloudFormation.getString(properties.DatabaseName) : void 0), ret.addPropertyResult("region", "Region", properties.Region != null ? cfn_parse.FromCloudFormation.getString(properties.Region) : void 0), ret.addPropertyResult("roleArn", "RoleARN", properties.RoleARN != null ? cfn_parse.FromCloudFormation.getString(properties.RoleARN) : void 0), ret.addPropertyResult("tableName", "TableName", properties.TableName != null ? cfn_parse.FromCloudFormation.getString(properties.TableName) : void 0), ret.addPropertyResult("versionId", "VersionId", properties.VersionId != null ? cfn_parse.FromCloudFormation.getString(properties.VersionId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_SerializerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("orcSerDe", CfnDeliveryStream_OrcSerDePropertyValidator)(properties.orcSerDe)), errors.collect(cdk.propertyValidator("parquetSerDe", CfnDeliveryStream_ParquetSerDePropertyValidator)(properties.parquetSerDe)), errors.wrap('supplied properties not correct for "SerializerProperty"');
    }
    function cfnDeliveryStreamSerializerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_SerializerPropertyValidator(properties).assertSuccess(), { OrcSerDe: cfnDeliveryStreamOrcSerDePropertyToCloudFormation(properties.orcSerDe), ParquetSerDe: cfnDeliveryStreamParquetSerDePropertyToCloudFormation(properties.parquetSerDe) }) : properties;
    }
    function CfnDeliveryStreamSerializerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("orcSerDe", "OrcSerDe", properties.OrcSerDe != null ? CfnDeliveryStreamOrcSerDePropertyFromCloudFormation(properties.OrcSerDe) : void 0), ret.addPropertyResult("parquetSerDe", "ParquetSerDe", properties.ParquetSerDe != null ? CfnDeliveryStreamParquetSerDePropertyFromCloudFormation(properties.ParquetSerDe) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_SplunkDestinationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchLoggingOptions", CfnDeliveryStream_CloudWatchLoggingOptionsPropertyValidator)(properties.cloudWatchLoggingOptions)), errors.collect(cdk.propertyValidator("hecAcknowledgmentTimeoutInSeconds", cdk.validateNumber)(properties.hecAcknowledgmentTimeoutInSeconds)), errors.collect(cdk.propertyValidator("hecEndpoint", cdk.requiredValidator)(properties.hecEndpoint)), errors.collect(cdk.propertyValidator("hecEndpoint", cdk.validateString)(properties.hecEndpoint)), errors.collect(cdk.propertyValidator("hecEndpointType", cdk.requiredValidator)(properties.hecEndpointType)), errors.collect(cdk.propertyValidator("hecEndpointType", cdk.validateString)(properties.hecEndpointType)), errors.collect(cdk.propertyValidator("hecToken", cdk.requiredValidator)(properties.hecToken)), errors.collect(cdk.propertyValidator("hecToken", cdk.validateString)(properties.hecToken)), errors.collect(cdk.propertyValidator("processingConfiguration", CfnDeliveryStream_ProcessingConfigurationPropertyValidator)(properties.processingConfiguration)), errors.collect(cdk.propertyValidator("retryOptions", CfnDeliveryStream_SplunkRetryOptionsPropertyValidator)(properties.retryOptions)), errors.collect(cdk.propertyValidator("s3BackupMode", cdk.validateString)(properties.s3BackupMode)), errors.collect(cdk.propertyValidator("s3Configuration", cdk.requiredValidator)(properties.s3Configuration)), errors.collect(cdk.propertyValidator("s3Configuration", CfnDeliveryStream_S3DestinationConfigurationPropertyValidator)(properties.s3Configuration)), errors.wrap('supplied properties not correct for "SplunkDestinationConfigurationProperty"');
    }
    function cfnDeliveryStreamSplunkDestinationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_SplunkDestinationConfigurationPropertyValidator(properties).assertSuccess(), { CloudWatchLoggingOptions: cfnDeliveryStreamCloudWatchLoggingOptionsPropertyToCloudFormation(properties.cloudWatchLoggingOptions), HECAcknowledgmentTimeoutInSeconds: cdk.numberToCloudFormation(properties.hecAcknowledgmentTimeoutInSeconds), HECEndpoint: cdk.stringToCloudFormation(properties.hecEndpoint), HECEndpointType: cdk.stringToCloudFormation(properties.hecEndpointType), HECToken: cdk.stringToCloudFormation(properties.hecToken), ProcessingConfiguration: cfnDeliveryStreamProcessingConfigurationPropertyToCloudFormation(properties.processingConfiguration), RetryOptions: cfnDeliveryStreamSplunkRetryOptionsPropertyToCloudFormation(properties.retryOptions), S3BackupMode: cdk.stringToCloudFormation(properties.s3BackupMode), S3Configuration: cfnDeliveryStreamS3DestinationConfigurationPropertyToCloudFormation(properties.s3Configuration) }) : properties;
    }
    function CfnDeliveryStreamSplunkDestinationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchLoggingOptions", "CloudWatchLoggingOptions", properties.CloudWatchLoggingOptions != null ? CfnDeliveryStreamCloudWatchLoggingOptionsPropertyFromCloudFormation(properties.CloudWatchLoggingOptions) : void 0), ret.addPropertyResult("hecAcknowledgmentTimeoutInSeconds", "HECAcknowledgmentTimeoutInSeconds", properties.HECAcknowledgmentTimeoutInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.HECAcknowledgmentTimeoutInSeconds) : void 0), ret.addPropertyResult("hecEndpoint", "HECEndpoint", cfn_parse.FromCloudFormation.getString(properties.HECEndpoint)), ret.addPropertyResult("hecEndpointType", "HECEndpointType", cfn_parse.FromCloudFormation.getString(properties.HECEndpointType)), ret.addPropertyResult("hecToken", "HECToken", cfn_parse.FromCloudFormation.getString(properties.HECToken)), ret.addPropertyResult("processingConfiguration", "ProcessingConfiguration", properties.ProcessingConfiguration != null ? CfnDeliveryStreamProcessingConfigurationPropertyFromCloudFormation(properties.ProcessingConfiguration) : void 0), ret.addPropertyResult("retryOptions", "RetryOptions", properties.RetryOptions != null ? CfnDeliveryStreamSplunkRetryOptionsPropertyFromCloudFormation(properties.RetryOptions) : void 0), ret.addPropertyResult("s3BackupMode", "S3BackupMode", properties.S3BackupMode != null ? cfn_parse.FromCloudFormation.getString(properties.S3BackupMode) : void 0), ret.addPropertyResult("s3Configuration", "S3Configuration", CfnDeliveryStreamS3DestinationConfigurationPropertyFromCloudFormation(properties.S3Configuration)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_SplunkRetryOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("durationInSeconds", cdk.validateNumber)(properties.durationInSeconds)), errors.wrap('supplied properties not correct for "SplunkRetryOptionsProperty"');
    }
    function cfnDeliveryStreamSplunkRetryOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_SplunkRetryOptionsPropertyValidator(properties).assertSuccess(), { DurationInSeconds: cdk.numberToCloudFormation(properties.durationInSeconds) }) : properties;
    }
    function CfnDeliveryStreamSplunkRetryOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("durationInSeconds", "DurationInSeconds", properties.DurationInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.DurationInSeconds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeliveryStream_VpcConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.requiredValidator)(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.requiredValidator)(properties.subnetIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.wrap('supplied properties not correct for "VpcConfigurationProperty"');
    }
    function cfnDeliveryStreamVpcConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeliveryStream_VpcConfigurationPropertyValidator(properties).assertSuccess(), { RoleARN: cdk.stringToCloudFormation(properties.roleArn), SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds) }) : properties;
    }
    function CfnDeliveryStreamVpcConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("roleArn", "RoleARN", cfn_parse.FromCloudFormation.getString(properties.RoleARN)), ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds)), ret.addPropertyResult("subnetIds", "SubnetIds", cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-kinesisfirehose/lib/index.js
var require_lib168 = __commonJS({
  "node_modules/aws-cdk-lib/aws-kinesisfirehose/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_kinesisfirehose_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-kinesisfirehose/index.js
var require_aws_kinesisfirehose = __commonJS({
  "node_modules/aws-cdk-lib/aws-kinesisfirehose/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib168(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-kinesisvideo/lib/kinesisvideo.generated.js
var require_kinesisvideo_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-kinesisvideo/lib/kinesisvideo.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnStream = exports2.CfnSignalingChannel = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnSignalingChannelPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("messageTtlSeconds", cdk.validateNumber)(properties.messageTtlSeconds)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnSignalingChannelProps"');
    }
    function cfnSignalingChannelPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSignalingChannelPropsValidator(properties).assertSuccess(), { MessageTtlSeconds: cdk.numberToCloudFormation(properties.messageTtlSeconds), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnSignalingChannelPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("messageTtlSeconds", "MessageTtlSeconds", properties.MessageTtlSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.MessageTtlSeconds) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSignalingChannel = class _CfnSignalingChannel extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSignalingChannelPropsFromCloudFormation(resourceProperties), ret = new _CfnSignalingChannel(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnSignalingChannel.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kinesisvideo_CfnSignalingChannelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSignalingChannel), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.messageTtlSeconds = props.messageTtlSeconds, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::KinesisVideo::SignalingChannel", props.tags, { tagPropertyName: "tags" }), this.type = props.type;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSignalingChannel.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { messageTtlSeconds: this.messageTtlSeconds, name: this.name, tags: this.tags.renderTags(), type: this.type };
      }
      renderProperties(props) {
        return cfnSignalingChannelPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnSignalingChannel[_a] = { fqn: "aws-cdk-lib.aws_kinesisvideo.CfnSignalingChannel", version: "2.80.0" }, CfnSignalingChannel.CFN_RESOURCE_TYPE_NAME = "AWS::KinesisVideo::SignalingChannel", exports2.CfnSignalingChannel = CfnSignalingChannel;
    function CfnStreamPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataRetentionInHours", cdk.validateNumber)(properties.dataRetentionInHours)), errors.collect(cdk.propertyValidator("deviceName", cdk.validateString)(properties.deviceName)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("mediaType", cdk.validateString)(properties.mediaType)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnStreamProps"');
    }
    function cfnStreamPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStreamPropsValidator(properties).assertSuccess(), { DataRetentionInHours: cdk.numberToCloudFormation(properties.dataRetentionInHours), DeviceName: cdk.stringToCloudFormation(properties.deviceName), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), MediaType: cdk.stringToCloudFormation(properties.mediaType), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnStreamPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataRetentionInHours", "DataRetentionInHours", properties.DataRetentionInHours != null ? cfn_parse.FromCloudFormation.getNumber(properties.DataRetentionInHours) : void 0), ret.addPropertyResult("deviceName", "DeviceName", properties.DeviceName != null ? cfn_parse.FromCloudFormation.getString(properties.DeviceName) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("mediaType", "MediaType", properties.MediaType != null ? cfn_parse.FromCloudFormation.getString(properties.MediaType) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnStream = class _CfnStream extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnStreamPropsFromCloudFormation(resourceProperties), ret = new _CfnStream(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnStream.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kinesisvideo_CfnStreamProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnStream), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.dataRetentionInHours = props.dataRetentionInHours, this.deviceName = props.deviceName, this.kmsKeyId = props.kmsKeyId, this.mediaType = props.mediaType, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::KinesisVideo::Stream", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStream.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { dataRetentionInHours: this.dataRetentionInHours, deviceName: this.deviceName, kmsKeyId: this.kmsKeyId, mediaType: this.mediaType, name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnStreamPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnStream[_b] = { fqn: "aws-cdk-lib.aws_kinesisvideo.CfnStream", version: "2.80.0" }, CfnStream.CFN_RESOURCE_TYPE_NAME = "AWS::KinesisVideo::Stream", exports2.CfnStream = CfnStream;
  }
});

// node_modules/aws-cdk-lib/aws-kinesisvideo/lib/index.js
var require_lib169 = __commonJS({
  "node_modules/aws-cdk-lib/aws-kinesisvideo/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_kinesisvideo_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-kinesisvideo/index.js
var require_aws_kinesisvideo = __commonJS({
  "node_modules/aws-cdk-lib/aws-kinesisvideo/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib169(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-lakeformation/lib/lakeformation.generated.js
var require_lakeformation_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-lakeformation/lib/lakeformation.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnTagAssociation = exports2.CfnTag = exports2.CfnResource = exports2.CfnPrincipalPermissions = exports2.CfnPermissions = exports2.CfnDataLakeSettings = exports2.CfnDataCellsFilter = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnDataCellsFilterPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnNames", cdk.listValidator(cdk.validateString))(properties.columnNames)), errors.collect(cdk.propertyValidator("columnWildcard", CfnDataCellsFilter_ColumnWildcardPropertyValidator)(properties.columnWildcard)), errors.collect(cdk.propertyValidator("databaseName", cdk.requiredValidator)(properties.databaseName)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("rowFilter", CfnDataCellsFilter_RowFilterPropertyValidator)(properties.rowFilter)), errors.collect(cdk.propertyValidator("tableCatalogId", cdk.requiredValidator)(properties.tableCatalogId)), errors.collect(cdk.propertyValidator("tableCatalogId", cdk.validateString)(properties.tableCatalogId)), errors.collect(cdk.propertyValidator("tableName", cdk.requiredValidator)(properties.tableName)), errors.collect(cdk.propertyValidator("tableName", cdk.validateString)(properties.tableName)), errors.wrap('supplied properties not correct for "CfnDataCellsFilterProps"');
    }
    function cfnDataCellsFilterPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataCellsFilterPropsValidator(properties).assertSuccess(), { DatabaseName: cdk.stringToCloudFormation(properties.databaseName), Name: cdk.stringToCloudFormation(properties.name), TableCatalogId: cdk.stringToCloudFormation(properties.tableCatalogId), TableName: cdk.stringToCloudFormation(properties.tableName), ColumnNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.columnNames), ColumnWildcard: cfnDataCellsFilterColumnWildcardPropertyToCloudFormation(properties.columnWildcard), RowFilter: cfnDataCellsFilterRowFilterPropertyToCloudFormation(properties.rowFilter) }) : properties;
    }
    function CfnDataCellsFilterPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("databaseName", "DatabaseName", cfn_parse.FromCloudFormation.getString(properties.DatabaseName)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("tableCatalogId", "TableCatalogId", cfn_parse.FromCloudFormation.getString(properties.TableCatalogId)), ret.addPropertyResult("tableName", "TableName", cfn_parse.FromCloudFormation.getString(properties.TableName)), ret.addPropertyResult("columnNames", "ColumnNames", properties.ColumnNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ColumnNames) : void 0), ret.addPropertyResult("columnWildcard", "ColumnWildcard", properties.ColumnWildcard != null ? CfnDataCellsFilterColumnWildcardPropertyFromCloudFormation(properties.ColumnWildcard) : void 0), ret.addPropertyResult("rowFilter", "RowFilter", properties.RowFilter != null ? CfnDataCellsFilterRowFilterPropertyFromCloudFormation(properties.RowFilter) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDataCellsFilter = class _CfnDataCellsFilter extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDataCellsFilterPropsFromCloudFormation(resourceProperties), ret = new _CfnDataCellsFilter(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDataCellsFilter.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lakeformation_CfnDataCellsFilterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDataCellsFilter), error;
        }
        cdk.requireProperty(props, "databaseName", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "tableCatalogId", this), cdk.requireProperty(props, "tableName", this), this.databaseName = props.databaseName, this.name = props.name, this.tableCatalogId = props.tableCatalogId, this.tableName = props.tableName, this.columnNames = props.columnNames, this.columnWildcard = props.columnWildcard, this.rowFilter = props.rowFilter;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDataCellsFilter.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { databaseName: this.databaseName, name: this.name, tableCatalogId: this.tableCatalogId, tableName: this.tableName, columnNames: this.columnNames, columnWildcard: this.columnWildcard, rowFilter: this.rowFilter };
      }
      renderProperties(props) {
        return cfnDataCellsFilterPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnDataCellsFilter[_a] = { fqn: "aws-cdk-lib.aws_lakeformation.CfnDataCellsFilter", version: "2.80.0" }, CfnDataCellsFilter.CFN_RESOURCE_TYPE_NAME = "AWS::LakeFormation::DataCellsFilter", exports2.CfnDataCellsFilter = CfnDataCellsFilter;
    function CfnDataCellsFilter_ColumnWildcardPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("excludedColumnNames", cdk.listValidator(cdk.validateString))(properties.excludedColumnNames)), errors.wrap('supplied properties not correct for "ColumnWildcardProperty"');
    }
    function cfnDataCellsFilterColumnWildcardPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataCellsFilter_ColumnWildcardPropertyValidator(properties).assertSuccess(), { ExcludedColumnNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.excludedColumnNames) }) : properties;
    }
    function CfnDataCellsFilterColumnWildcardPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("excludedColumnNames", "ExcludedColumnNames", properties.ExcludedColumnNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExcludedColumnNames) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataCellsFilter_RowFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allRowsWildcard", cdk.validateObject)(properties.allRowsWildcard)), errors.collect(cdk.propertyValidator("filterExpression", cdk.validateString)(properties.filterExpression)), errors.wrap('supplied properties not correct for "RowFilterProperty"');
    }
    function cfnDataCellsFilterRowFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataCellsFilter_RowFilterPropertyValidator(properties).assertSuccess(), { AllRowsWildcard: cdk.objectToCloudFormation(properties.allRowsWildcard), FilterExpression: cdk.stringToCloudFormation(properties.filterExpression) }) : properties;
    }
    function CfnDataCellsFilterRowFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allRowsWildcard", "AllRowsWildcard", properties.AllRowsWildcard != null ? cfn_parse.FromCloudFormation.getAny(properties.AllRowsWildcard) : void 0), ret.addPropertyResult("filterExpression", "FilterExpression", properties.FilterExpression != null ? cfn_parse.FromCloudFormation.getString(properties.FilterExpression) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataLakeSettingsPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("admins", cdk.listValidator(CfnDataLakeSettings_DataLakePrincipalPropertyValidator))(properties.admins)), errors.collect(cdk.propertyValidator("allowExternalDataFiltering", cdk.validateBoolean)(properties.allowExternalDataFiltering)), errors.collect(cdk.propertyValidator("authorizedSessionTagValueList", cdk.listValidator(cdk.validateString))(properties.authorizedSessionTagValueList)), errors.collect(cdk.propertyValidator("createDatabaseDefaultPermissions", cdk.listValidator(CfnDataLakeSettings_PrincipalPermissionsPropertyValidator))(properties.createDatabaseDefaultPermissions)), errors.collect(cdk.propertyValidator("createTableDefaultPermissions", cdk.listValidator(CfnDataLakeSettings_PrincipalPermissionsPropertyValidator))(properties.createTableDefaultPermissions)), errors.collect(cdk.propertyValidator("externalDataFilteringAllowList", cdk.listValidator(CfnDataLakeSettings_DataLakePrincipalPropertyValidator))(properties.externalDataFilteringAllowList)), errors.collect(cdk.propertyValidator("parameters", cdk.validateObject)(properties.parameters)), errors.collect(cdk.propertyValidator("trustedResourceOwners", cdk.listValidator(cdk.validateString))(properties.trustedResourceOwners)), errors.wrap('supplied properties not correct for "CfnDataLakeSettingsProps"');
    }
    function cfnDataLakeSettingsPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataLakeSettingsPropsValidator(properties).assertSuccess(), { Admins: cdk.listMapper(cfnDataLakeSettingsDataLakePrincipalPropertyToCloudFormation)(properties.admins), AllowExternalDataFiltering: cdk.booleanToCloudFormation(properties.allowExternalDataFiltering), AuthorizedSessionTagValueList: cdk.listMapper(cdk.stringToCloudFormation)(properties.authorizedSessionTagValueList), CreateDatabaseDefaultPermissions: cdk.listMapper(cfnDataLakeSettingsPrincipalPermissionsPropertyToCloudFormation)(properties.createDatabaseDefaultPermissions), CreateTableDefaultPermissions: cdk.listMapper(cfnDataLakeSettingsPrincipalPermissionsPropertyToCloudFormation)(properties.createTableDefaultPermissions), ExternalDataFilteringAllowList: cdk.listMapper(cfnDataLakeSettingsDataLakePrincipalPropertyToCloudFormation)(properties.externalDataFilteringAllowList), Parameters: cdk.objectToCloudFormation(properties.parameters), TrustedResourceOwners: cdk.listMapper(cdk.stringToCloudFormation)(properties.trustedResourceOwners) }) : properties;
    }
    function CfnDataLakeSettingsPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("admins", "Admins", properties.Admins != null ? cfn_parse.FromCloudFormation.getArray(CfnDataLakeSettingsDataLakePrincipalPropertyFromCloudFormation)(properties.Admins) : void 0), ret.addPropertyResult("allowExternalDataFiltering", "AllowExternalDataFiltering", properties.AllowExternalDataFiltering != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllowExternalDataFiltering) : void 0), ret.addPropertyResult("authorizedSessionTagValueList", "AuthorizedSessionTagValueList", properties.AuthorizedSessionTagValueList != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AuthorizedSessionTagValueList) : void 0), ret.addPropertyResult("createDatabaseDefaultPermissions", "CreateDatabaseDefaultPermissions", properties.CreateDatabaseDefaultPermissions != null ? cfn_parse.FromCloudFormation.getArray(CfnDataLakeSettingsPrincipalPermissionsPropertyFromCloudFormation)(properties.CreateDatabaseDefaultPermissions) : void 0), ret.addPropertyResult("createTableDefaultPermissions", "CreateTableDefaultPermissions", properties.CreateTableDefaultPermissions != null ? cfn_parse.FromCloudFormation.getArray(CfnDataLakeSettingsPrincipalPermissionsPropertyFromCloudFormation)(properties.CreateTableDefaultPermissions) : void 0), ret.addPropertyResult("externalDataFilteringAllowList", "ExternalDataFilteringAllowList", properties.ExternalDataFilteringAllowList != null ? cfn_parse.FromCloudFormation.getArray(CfnDataLakeSettingsDataLakePrincipalPropertyFromCloudFormation)(properties.ExternalDataFilteringAllowList) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getAny(properties.Parameters) : void 0), ret.addPropertyResult("trustedResourceOwners", "TrustedResourceOwners", properties.TrustedResourceOwners != null ? cfn_parse.FromCloudFormation.getStringArray(properties.TrustedResourceOwners) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDataLakeSettings = class _CfnDataLakeSettings extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDataLakeSettingsPropsFromCloudFormation(resourceProperties), ret = new _CfnDataLakeSettings(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnDataLakeSettings.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lakeformation_CfnDataLakeSettingsProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDataLakeSettings), error;
        }
        this.admins = props.admins, this.allowExternalDataFiltering = props.allowExternalDataFiltering, this.authorizedSessionTagValueList = props.authorizedSessionTagValueList, this.createDatabaseDefaultPermissions = props.createDatabaseDefaultPermissions, this.createTableDefaultPermissions = props.createTableDefaultPermissions, this.externalDataFilteringAllowList = props.externalDataFilteringAllowList, this.parameters = props.parameters, this.trustedResourceOwners = props.trustedResourceOwners;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDataLakeSettings.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { admins: this.admins, allowExternalDataFiltering: this.allowExternalDataFiltering, authorizedSessionTagValueList: this.authorizedSessionTagValueList, createDatabaseDefaultPermissions: this.createDatabaseDefaultPermissions, createTableDefaultPermissions: this.createTableDefaultPermissions, externalDataFilteringAllowList: this.externalDataFilteringAllowList, parameters: this.parameters, trustedResourceOwners: this.trustedResourceOwners };
      }
      renderProperties(props) {
        return cfnDataLakeSettingsPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnDataLakeSettings[_b] = { fqn: "aws-cdk-lib.aws_lakeformation.CfnDataLakeSettings", version: "2.80.0" }, CfnDataLakeSettings.CFN_RESOURCE_TYPE_NAME = "AWS::LakeFormation::DataLakeSettings", exports2.CfnDataLakeSettings = CfnDataLakeSettings;
    function CfnDataLakeSettings_DataLakePrincipalPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataLakePrincipalIdentifier", cdk.validateString)(properties.dataLakePrincipalIdentifier)), errors.wrap('supplied properties not correct for "DataLakePrincipalProperty"');
    }
    function cfnDataLakeSettingsDataLakePrincipalPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataLakeSettings_DataLakePrincipalPropertyValidator(properties).assertSuccess(), { DataLakePrincipalIdentifier: cdk.stringToCloudFormation(properties.dataLakePrincipalIdentifier) }) : properties;
    }
    function CfnDataLakeSettingsDataLakePrincipalPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataLakePrincipalIdentifier", "DataLakePrincipalIdentifier", properties.DataLakePrincipalIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.DataLakePrincipalIdentifier) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataLakeSettings_PrincipalPermissionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("permissions", cdk.listValidator(cdk.validateString))(properties.permissions)), errors.collect(cdk.propertyValidator("principal", CfnDataLakeSettings_DataLakePrincipalPropertyValidator)(properties.principal)), errors.wrap('supplied properties not correct for "PrincipalPermissionsProperty"');
    }
    function cfnDataLakeSettingsPrincipalPermissionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataLakeSettings_PrincipalPermissionsPropertyValidator(properties).assertSuccess(), { Permissions: cdk.listMapper(cdk.stringToCloudFormation)(properties.permissions), Principal: cfnDataLakeSettingsDataLakePrincipalPropertyToCloudFormation(properties.principal) }) : properties;
    }
    function CfnDataLakeSettingsPrincipalPermissionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("permissions", "Permissions", properties.Permissions != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Permissions) : void 0), ret.addPropertyResult("principal", "Principal", properties.Principal != null ? CfnDataLakeSettingsDataLakePrincipalPropertyFromCloudFormation(properties.Principal) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPermissionsPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataLakePrincipal", cdk.requiredValidator)(properties.dataLakePrincipal)), errors.collect(cdk.propertyValidator("dataLakePrincipal", CfnPermissions_DataLakePrincipalPropertyValidator)(properties.dataLakePrincipal)), errors.collect(cdk.propertyValidator("permissions", cdk.listValidator(cdk.validateString))(properties.permissions)), errors.collect(cdk.propertyValidator("permissionsWithGrantOption", cdk.listValidator(cdk.validateString))(properties.permissionsWithGrantOption)), errors.collect(cdk.propertyValidator("resource", cdk.requiredValidator)(properties.resource)), errors.collect(cdk.propertyValidator("resource", CfnPermissions_ResourcePropertyValidator)(properties.resource)), errors.wrap('supplied properties not correct for "CfnPermissionsProps"');
    }
    function cfnPermissionsPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPermissionsPropsValidator(properties).assertSuccess(), { DataLakePrincipal: cfnPermissionsDataLakePrincipalPropertyToCloudFormation(properties.dataLakePrincipal), Resource: cfnPermissionsResourcePropertyToCloudFormation(properties.resource), Permissions: cdk.listMapper(cdk.stringToCloudFormation)(properties.permissions), PermissionsWithGrantOption: cdk.listMapper(cdk.stringToCloudFormation)(properties.permissionsWithGrantOption) }) : properties;
    }
    function CfnPermissionsPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataLakePrincipal", "DataLakePrincipal", CfnPermissionsDataLakePrincipalPropertyFromCloudFormation(properties.DataLakePrincipal)), ret.addPropertyResult("resource", "Resource", CfnPermissionsResourcePropertyFromCloudFormation(properties.Resource)), ret.addPropertyResult("permissions", "Permissions", properties.Permissions != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Permissions) : void 0), ret.addPropertyResult("permissionsWithGrantOption", "PermissionsWithGrantOption", properties.PermissionsWithGrantOption != null ? cfn_parse.FromCloudFormation.getStringArray(properties.PermissionsWithGrantOption) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPermissions = class _CfnPermissions extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPermissionsPropsFromCloudFormation(resourceProperties), ret = new _CfnPermissions(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPermissions.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lakeformation_CfnPermissionsProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPermissions), error;
        }
        cdk.requireProperty(props, "dataLakePrincipal", this), cdk.requireProperty(props, "resource", this), this.dataLakePrincipal = props.dataLakePrincipal, this.resource = props.resource, this.permissions = props.permissions, this.permissionsWithGrantOption = props.permissionsWithGrantOption;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPermissions.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { dataLakePrincipal: this.dataLakePrincipal, resource: this.resource, permissions: this.permissions, permissionsWithGrantOption: this.permissionsWithGrantOption };
      }
      renderProperties(props) {
        return cfnPermissionsPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnPermissions[_c] = { fqn: "aws-cdk-lib.aws_lakeformation.CfnPermissions", version: "2.80.0" }, CfnPermissions.CFN_RESOURCE_TYPE_NAME = "AWS::LakeFormation::Permissions", exports2.CfnPermissions = CfnPermissions;
    function CfnPermissions_ColumnWildcardPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("excludedColumnNames", cdk.listValidator(cdk.validateString))(properties.excludedColumnNames)), errors.wrap('supplied properties not correct for "ColumnWildcardProperty"');
    }
    function cfnPermissionsColumnWildcardPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPermissions_ColumnWildcardPropertyValidator(properties).assertSuccess(), { ExcludedColumnNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.excludedColumnNames) }) : properties;
    }
    function CfnPermissionsColumnWildcardPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("excludedColumnNames", "ExcludedColumnNames", properties.ExcludedColumnNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExcludedColumnNames) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPermissions_DataLakePrincipalPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataLakePrincipalIdentifier", cdk.validateString)(properties.dataLakePrincipalIdentifier)), errors.wrap('supplied properties not correct for "DataLakePrincipalProperty"');
    }
    function cfnPermissionsDataLakePrincipalPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPermissions_DataLakePrincipalPropertyValidator(properties).assertSuccess(), { DataLakePrincipalIdentifier: cdk.stringToCloudFormation(properties.dataLakePrincipalIdentifier) }) : properties;
    }
    function CfnPermissionsDataLakePrincipalPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataLakePrincipalIdentifier", "DataLakePrincipalIdentifier", properties.DataLakePrincipalIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.DataLakePrincipalIdentifier) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPermissions_DataLocationResourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalogId", cdk.validateString)(properties.catalogId)), errors.collect(cdk.propertyValidator("s3Resource", cdk.validateString)(properties.s3Resource)), errors.wrap('supplied properties not correct for "DataLocationResourceProperty"');
    }
    function cfnPermissionsDataLocationResourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPermissions_DataLocationResourcePropertyValidator(properties).assertSuccess(), { CatalogId: cdk.stringToCloudFormation(properties.catalogId), S3Resource: cdk.stringToCloudFormation(properties.s3Resource) }) : properties;
    }
    function CfnPermissionsDataLocationResourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalogId", "CatalogId", properties.CatalogId != null ? cfn_parse.FromCloudFormation.getString(properties.CatalogId) : void 0), ret.addPropertyResult("s3Resource", "S3Resource", properties.S3Resource != null ? cfn_parse.FromCloudFormation.getString(properties.S3Resource) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPermissions_DatabaseResourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalogId", cdk.validateString)(properties.catalogId)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "DatabaseResourceProperty"');
    }
    function cfnPermissionsDatabaseResourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPermissions_DatabaseResourcePropertyValidator(properties).assertSuccess(), { CatalogId: cdk.stringToCloudFormation(properties.catalogId), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnPermissionsDatabaseResourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalogId", "CatalogId", properties.CatalogId != null ? cfn_parse.FromCloudFormation.getString(properties.CatalogId) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPermissions_ResourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataLocationResource", CfnPermissions_DataLocationResourcePropertyValidator)(properties.dataLocationResource)), errors.collect(cdk.propertyValidator("databaseResource", CfnPermissions_DatabaseResourcePropertyValidator)(properties.databaseResource)), errors.collect(cdk.propertyValidator("tableResource", CfnPermissions_TableResourcePropertyValidator)(properties.tableResource)), errors.collect(cdk.propertyValidator("tableWithColumnsResource", CfnPermissions_TableWithColumnsResourcePropertyValidator)(properties.tableWithColumnsResource)), errors.wrap('supplied properties not correct for "ResourceProperty"');
    }
    function cfnPermissionsResourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPermissions_ResourcePropertyValidator(properties).assertSuccess(), { DataLocationResource: cfnPermissionsDataLocationResourcePropertyToCloudFormation(properties.dataLocationResource), DatabaseResource: cfnPermissionsDatabaseResourcePropertyToCloudFormation(properties.databaseResource), TableResource: cfnPermissionsTableResourcePropertyToCloudFormation(properties.tableResource), TableWithColumnsResource: cfnPermissionsTableWithColumnsResourcePropertyToCloudFormation(properties.tableWithColumnsResource) }) : properties;
    }
    function CfnPermissionsResourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataLocationResource", "DataLocationResource", properties.DataLocationResource != null ? CfnPermissionsDataLocationResourcePropertyFromCloudFormation(properties.DataLocationResource) : void 0), ret.addPropertyResult("databaseResource", "DatabaseResource", properties.DatabaseResource != null ? CfnPermissionsDatabaseResourcePropertyFromCloudFormation(properties.DatabaseResource) : void 0), ret.addPropertyResult("tableResource", "TableResource", properties.TableResource != null ? CfnPermissionsTableResourcePropertyFromCloudFormation(properties.TableResource) : void 0), ret.addPropertyResult("tableWithColumnsResource", "TableWithColumnsResource", properties.TableWithColumnsResource != null ? CfnPermissionsTableWithColumnsResourcePropertyFromCloudFormation(properties.TableWithColumnsResource) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPermissions_TableResourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalogId", cdk.validateString)(properties.catalogId)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tableWildcard", CfnPermissions_TableWildcardPropertyValidator)(properties.tableWildcard)), errors.wrap('supplied properties not correct for "TableResourceProperty"');
    }
    function cfnPermissionsTableResourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPermissions_TableResourcePropertyValidator(properties).assertSuccess(), { CatalogId: cdk.stringToCloudFormation(properties.catalogId), DatabaseName: cdk.stringToCloudFormation(properties.databaseName), Name: cdk.stringToCloudFormation(properties.name), TableWildcard: cfnPermissionsTableWildcardPropertyToCloudFormation(properties.tableWildcard) }) : properties;
    }
    function CfnPermissionsTableResourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalogId", "CatalogId", properties.CatalogId != null ? cfn_parse.FromCloudFormation.getString(properties.CatalogId) : void 0), ret.addPropertyResult("databaseName", "DatabaseName", properties.DatabaseName != null ? cfn_parse.FromCloudFormation.getString(properties.DatabaseName) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tableWildcard", "TableWildcard", properties.TableWildcard != null ? CfnPermissionsTableWildcardPropertyFromCloudFormation(properties.TableWildcard) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPermissions_TableWildcardPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.wrap('supplied properties not correct for "TableWildcardProperty"');
    }
    function cfnPermissionsTableWildcardPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPermissions_TableWildcardPropertyValidator(properties).assertSuccess(), {}) : properties;
    }
    function CfnPermissionsTableWildcardPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPermissions_TableWithColumnsResourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalogId", cdk.validateString)(properties.catalogId)), errors.collect(cdk.propertyValidator("columnNames", cdk.listValidator(cdk.validateString))(properties.columnNames)), errors.collect(cdk.propertyValidator("columnWildcard", CfnPermissions_ColumnWildcardPropertyValidator)(properties.columnWildcard)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "TableWithColumnsResourceProperty"');
    }
    function cfnPermissionsTableWithColumnsResourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPermissions_TableWithColumnsResourcePropertyValidator(properties).assertSuccess(), { CatalogId: cdk.stringToCloudFormation(properties.catalogId), ColumnNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.columnNames), ColumnWildcard: cfnPermissionsColumnWildcardPropertyToCloudFormation(properties.columnWildcard), DatabaseName: cdk.stringToCloudFormation(properties.databaseName), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnPermissionsTableWithColumnsResourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalogId", "CatalogId", properties.CatalogId != null ? cfn_parse.FromCloudFormation.getString(properties.CatalogId) : void 0), ret.addPropertyResult("columnNames", "ColumnNames", properties.ColumnNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ColumnNames) : void 0), ret.addPropertyResult("columnWildcard", "ColumnWildcard", properties.ColumnWildcard != null ? CfnPermissionsColumnWildcardPropertyFromCloudFormation(properties.ColumnWildcard) : void 0), ret.addPropertyResult("databaseName", "DatabaseName", properties.DatabaseName != null ? cfn_parse.FromCloudFormation.getString(properties.DatabaseName) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPrincipalPermissionsPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalog", cdk.validateString)(properties.catalog)), errors.collect(cdk.propertyValidator("permissions", cdk.requiredValidator)(properties.permissions)), errors.collect(cdk.propertyValidator("permissions", cdk.listValidator(cdk.validateString))(properties.permissions)), errors.collect(cdk.propertyValidator("permissionsWithGrantOption", cdk.requiredValidator)(properties.permissionsWithGrantOption)), errors.collect(cdk.propertyValidator("permissionsWithGrantOption", cdk.listValidator(cdk.validateString))(properties.permissionsWithGrantOption)), errors.collect(cdk.propertyValidator("principal", cdk.requiredValidator)(properties.principal)), errors.collect(cdk.propertyValidator("principal", CfnPrincipalPermissions_DataLakePrincipalPropertyValidator)(properties.principal)), errors.collect(cdk.propertyValidator("resource", cdk.requiredValidator)(properties.resource)), errors.collect(cdk.propertyValidator("resource", CfnPrincipalPermissions_ResourcePropertyValidator)(properties.resource)), errors.wrap('supplied properties not correct for "CfnPrincipalPermissionsProps"');
    }
    function cfnPrincipalPermissionsPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPrincipalPermissionsPropsValidator(properties).assertSuccess(), { Permissions: cdk.listMapper(cdk.stringToCloudFormation)(properties.permissions), PermissionsWithGrantOption: cdk.listMapper(cdk.stringToCloudFormation)(properties.permissionsWithGrantOption), Principal: cfnPrincipalPermissionsDataLakePrincipalPropertyToCloudFormation(properties.principal), Resource: cfnPrincipalPermissionsResourcePropertyToCloudFormation(properties.resource), Catalog: cdk.stringToCloudFormation(properties.catalog) }) : properties;
    }
    function CfnPrincipalPermissionsPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("permissions", "Permissions", cfn_parse.FromCloudFormation.getStringArray(properties.Permissions)), ret.addPropertyResult("permissionsWithGrantOption", "PermissionsWithGrantOption", cfn_parse.FromCloudFormation.getStringArray(properties.PermissionsWithGrantOption)), ret.addPropertyResult("principal", "Principal", CfnPrincipalPermissionsDataLakePrincipalPropertyFromCloudFormation(properties.Principal)), ret.addPropertyResult("resource", "Resource", CfnPrincipalPermissionsResourcePropertyFromCloudFormation(properties.Resource)), ret.addPropertyResult("catalog", "Catalog", properties.Catalog != null ? cfn_parse.FromCloudFormation.getString(properties.Catalog) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPrincipalPermissions = class _CfnPrincipalPermissions extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPrincipalPermissionsPropsFromCloudFormation(resourceProperties), ret = new _CfnPrincipalPermissions(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPrincipalPermissions.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lakeformation_CfnPrincipalPermissionsProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPrincipalPermissions), error;
        }
        cdk.requireProperty(props, "permissions", this), cdk.requireProperty(props, "permissionsWithGrantOption", this), cdk.requireProperty(props, "principal", this), cdk.requireProperty(props, "resource", this), this.attrPrincipalIdentifier = cdk.Token.asString(this.getAtt("PrincipalIdentifier", cdk.ResolutionTypeHint.STRING)), this.attrResourceIdentifier = cdk.Token.asString(this.getAtt("ResourceIdentifier", cdk.ResolutionTypeHint.STRING)), this.permissions = props.permissions, this.permissionsWithGrantOption = props.permissionsWithGrantOption, this.principal = props.principal, this.resource = props.resource, this.catalog = props.catalog;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPrincipalPermissions.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { permissions: this.permissions, permissionsWithGrantOption: this.permissionsWithGrantOption, principal: this.principal, resource: this.resource, catalog: this.catalog };
      }
      renderProperties(props) {
        return cfnPrincipalPermissionsPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnPrincipalPermissions[_d] = { fqn: "aws-cdk-lib.aws_lakeformation.CfnPrincipalPermissions", version: "2.80.0" }, CfnPrincipalPermissions.CFN_RESOURCE_TYPE_NAME = "AWS::LakeFormation::PrincipalPermissions", exports2.CfnPrincipalPermissions = CfnPrincipalPermissions;
    function CfnPrincipalPermissions_ColumnWildcardPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("excludedColumnNames", cdk.listValidator(cdk.validateString))(properties.excludedColumnNames)), errors.wrap('supplied properties not correct for "ColumnWildcardProperty"');
    }
    function cfnPrincipalPermissionsColumnWildcardPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPrincipalPermissions_ColumnWildcardPropertyValidator(properties).assertSuccess(), { ExcludedColumnNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.excludedColumnNames) }) : properties;
    }
    function CfnPrincipalPermissionsColumnWildcardPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("excludedColumnNames", "ExcludedColumnNames", properties.ExcludedColumnNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExcludedColumnNames) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPrincipalPermissions_DataCellsFilterResourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("databaseName", cdk.requiredValidator)(properties.databaseName)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tableCatalogId", cdk.requiredValidator)(properties.tableCatalogId)), errors.collect(cdk.propertyValidator("tableCatalogId", cdk.validateString)(properties.tableCatalogId)), errors.collect(cdk.propertyValidator("tableName", cdk.requiredValidator)(properties.tableName)), errors.collect(cdk.propertyValidator("tableName", cdk.validateString)(properties.tableName)), errors.wrap('supplied properties not correct for "DataCellsFilterResourceProperty"');
    }
    function cfnPrincipalPermissionsDataCellsFilterResourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPrincipalPermissions_DataCellsFilterResourcePropertyValidator(properties).assertSuccess(), { DatabaseName: cdk.stringToCloudFormation(properties.databaseName), Name: cdk.stringToCloudFormation(properties.name), TableCatalogId: cdk.stringToCloudFormation(properties.tableCatalogId), TableName: cdk.stringToCloudFormation(properties.tableName) }) : properties;
    }
    function CfnPrincipalPermissionsDataCellsFilterResourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("databaseName", "DatabaseName", cfn_parse.FromCloudFormation.getString(properties.DatabaseName)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("tableCatalogId", "TableCatalogId", cfn_parse.FromCloudFormation.getString(properties.TableCatalogId)), ret.addPropertyResult("tableName", "TableName", cfn_parse.FromCloudFormation.getString(properties.TableName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPrincipalPermissions_DataLakePrincipalPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataLakePrincipalIdentifier", cdk.validateString)(properties.dataLakePrincipalIdentifier)), errors.wrap('supplied properties not correct for "DataLakePrincipalProperty"');
    }
    function cfnPrincipalPermissionsDataLakePrincipalPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPrincipalPermissions_DataLakePrincipalPropertyValidator(properties).assertSuccess(), { DataLakePrincipalIdentifier: cdk.stringToCloudFormation(properties.dataLakePrincipalIdentifier) }) : properties;
    }
    function CfnPrincipalPermissionsDataLakePrincipalPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataLakePrincipalIdentifier", "DataLakePrincipalIdentifier", properties.DataLakePrincipalIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.DataLakePrincipalIdentifier) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPrincipalPermissions_DataLocationResourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalogId", cdk.requiredValidator)(properties.catalogId)), errors.collect(cdk.propertyValidator("catalogId", cdk.validateString)(properties.catalogId)), errors.collect(cdk.propertyValidator("resourceArn", cdk.requiredValidator)(properties.resourceArn)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.wrap('supplied properties not correct for "DataLocationResourceProperty"');
    }
    function cfnPrincipalPermissionsDataLocationResourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPrincipalPermissions_DataLocationResourcePropertyValidator(properties).assertSuccess(), { CatalogId: cdk.stringToCloudFormation(properties.catalogId), ResourceArn: cdk.stringToCloudFormation(properties.resourceArn) }) : properties;
    }
    function CfnPrincipalPermissionsDataLocationResourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalogId", "CatalogId", cfn_parse.FromCloudFormation.getString(properties.CatalogId)), ret.addPropertyResult("resourceArn", "ResourceArn", cfn_parse.FromCloudFormation.getString(properties.ResourceArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPrincipalPermissions_DatabaseResourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalogId", cdk.requiredValidator)(properties.catalogId)), errors.collect(cdk.propertyValidator("catalogId", cdk.validateString)(properties.catalogId)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "DatabaseResourceProperty"');
    }
    function cfnPrincipalPermissionsDatabaseResourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPrincipalPermissions_DatabaseResourcePropertyValidator(properties).assertSuccess(), { CatalogId: cdk.stringToCloudFormation(properties.catalogId), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnPrincipalPermissionsDatabaseResourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalogId", "CatalogId", cfn_parse.FromCloudFormation.getString(properties.CatalogId)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPrincipalPermissions_LFTagPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("tagKey", cdk.validateString)(properties.tagKey)), errors.collect(cdk.propertyValidator("tagValues", cdk.listValidator(cdk.validateString))(properties.tagValues)), errors.wrap('supplied properties not correct for "LFTagProperty"');
    }
    function cfnPrincipalPermissionsLFTagPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPrincipalPermissions_LFTagPropertyValidator(properties).assertSuccess(), { TagKey: cdk.stringToCloudFormation(properties.tagKey), TagValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.tagValues) }) : properties;
    }
    function CfnPrincipalPermissionsLFTagPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("tagKey", "TagKey", properties.TagKey != null ? cfn_parse.FromCloudFormation.getString(properties.TagKey) : void 0), ret.addPropertyResult("tagValues", "TagValues", properties.TagValues != null ? cfn_parse.FromCloudFormation.getStringArray(properties.TagValues) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPrincipalPermissions_LFTagKeyResourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalogId", cdk.requiredValidator)(properties.catalogId)), errors.collect(cdk.propertyValidator("catalogId", cdk.validateString)(properties.catalogId)), errors.collect(cdk.propertyValidator("tagKey", cdk.requiredValidator)(properties.tagKey)), errors.collect(cdk.propertyValidator("tagKey", cdk.validateString)(properties.tagKey)), errors.collect(cdk.propertyValidator("tagValues", cdk.requiredValidator)(properties.tagValues)), errors.collect(cdk.propertyValidator("tagValues", cdk.listValidator(cdk.validateString))(properties.tagValues)), errors.wrap('supplied properties not correct for "LFTagKeyResourceProperty"');
    }
    function cfnPrincipalPermissionsLFTagKeyResourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPrincipalPermissions_LFTagKeyResourcePropertyValidator(properties).assertSuccess(), { CatalogId: cdk.stringToCloudFormation(properties.catalogId), TagKey: cdk.stringToCloudFormation(properties.tagKey), TagValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.tagValues) }) : properties;
    }
    function CfnPrincipalPermissionsLFTagKeyResourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalogId", "CatalogId", cfn_parse.FromCloudFormation.getString(properties.CatalogId)), ret.addPropertyResult("tagKey", "TagKey", cfn_parse.FromCloudFormation.getString(properties.TagKey)), ret.addPropertyResult("tagValues", "TagValues", cfn_parse.FromCloudFormation.getStringArray(properties.TagValues)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPrincipalPermissions_LFTagPolicyResourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalogId", cdk.requiredValidator)(properties.catalogId)), errors.collect(cdk.propertyValidator("catalogId", cdk.validateString)(properties.catalogId)), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.listValidator(CfnPrincipalPermissions_LFTagPropertyValidator))(properties.expression)), errors.collect(cdk.propertyValidator("resourceType", cdk.requiredValidator)(properties.resourceType)), errors.collect(cdk.propertyValidator("resourceType", cdk.validateString)(properties.resourceType)), errors.wrap('supplied properties not correct for "LFTagPolicyResourceProperty"');
    }
    function cfnPrincipalPermissionsLFTagPolicyResourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPrincipalPermissions_LFTagPolicyResourcePropertyValidator(properties).assertSuccess(), { CatalogId: cdk.stringToCloudFormation(properties.catalogId), Expression: cdk.listMapper(cfnPrincipalPermissionsLFTagPropertyToCloudFormation)(properties.expression), ResourceType: cdk.stringToCloudFormation(properties.resourceType) }) : properties;
    }
    function CfnPrincipalPermissionsLFTagPolicyResourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalogId", "CatalogId", cfn_parse.FromCloudFormation.getString(properties.CatalogId)), ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getArray(CfnPrincipalPermissionsLFTagPropertyFromCloudFormation)(properties.Expression)), ret.addPropertyResult("resourceType", "ResourceType", cfn_parse.FromCloudFormation.getString(properties.ResourceType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPrincipalPermissions_ResourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalog", cdk.validateObject)(properties.catalog)), errors.collect(cdk.propertyValidator("dataCellsFilter", CfnPrincipalPermissions_DataCellsFilterResourcePropertyValidator)(properties.dataCellsFilter)), errors.collect(cdk.propertyValidator("dataLocation", CfnPrincipalPermissions_DataLocationResourcePropertyValidator)(properties.dataLocation)), errors.collect(cdk.propertyValidator("database", CfnPrincipalPermissions_DatabaseResourcePropertyValidator)(properties.database)), errors.collect(cdk.propertyValidator("lfTag", CfnPrincipalPermissions_LFTagKeyResourcePropertyValidator)(properties.lfTag)), errors.collect(cdk.propertyValidator("lfTagPolicy", CfnPrincipalPermissions_LFTagPolicyResourcePropertyValidator)(properties.lfTagPolicy)), errors.collect(cdk.propertyValidator("table", CfnPrincipalPermissions_TableResourcePropertyValidator)(properties.table)), errors.collect(cdk.propertyValidator("tableWithColumns", CfnPrincipalPermissions_TableWithColumnsResourcePropertyValidator)(properties.tableWithColumns)), errors.wrap('supplied properties not correct for "ResourceProperty"');
    }
    function cfnPrincipalPermissionsResourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPrincipalPermissions_ResourcePropertyValidator(properties).assertSuccess(), { Catalog: cdk.objectToCloudFormation(properties.catalog), DataCellsFilter: cfnPrincipalPermissionsDataCellsFilterResourcePropertyToCloudFormation(properties.dataCellsFilter), DataLocation: cfnPrincipalPermissionsDataLocationResourcePropertyToCloudFormation(properties.dataLocation), Database: cfnPrincipalPermissionsDatabaseResourcePropertyToCloudFormation(properties.database), LFTag: cfnPrincipalPermissionsLFTagKeyResourcePropertyToCloudFormation(properties.lfTag), LFTagPolicy: cfnPrincipalPermissionsLFTagPolicyResourcePropertyToCloudFormation(properties.lfTagPolicy), Table: cfnPrincipalPermissionsTableResourcePropertyToCloudFormation(properties.table), TableWithColumns: cfnPrincipalPermissionsTableWithColumnsResourcePropertyToCloudFormation(properties.tableWithColumns) }) : properties;
    }
    function CfnPrincipalPermissionsResourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalog", "Catalog", properties.Catalog != null ? cfn_parse.FromCloudFormation.getAny(properties.Catalog) : void 0), ret.addPropertyResult("dataCellsFilter", "DataCellsFilter", properties.DataCellsFilter != null ? CfnPrincipalPermissionsDataCellsFilterResourcePropertyFromCloudFormation(properties.DataCellsFilter) : void 0), ret.addPropertyResult("dataLocation", "DataLocation", properties.DataLocation != null ? CfnPrincipalPermissionsDataLocationResourcePropertyFromCloudFormation(properties.DataLocation) : void 0), ret.addPropertyResult("database", "Database", properties.Database != null ? CfnPrincipalPermissionsDatabaseResourcePropertyFromCloudFormation(properties.Database) : void 0), ret.addPropertyResult("lfTag", "LFTag", properties.LFTag != null ? CfnPrincipalPermissionsLFTagKeyResourcePropertyFromCloudFormation(properties.LFTag) : void 0), ret.addPropertyResult("lfTagPolicy", "LFTagPolicy", properties.LFTagPolicy != null ? CfnPrincipalPermissionsLFTagPolicyResourcePropertyFromCloudFormation(properties.LFTagPolicy) : void 0), ret.addPropertyResult("table", "Table", properties.Table != null ? CfnPrincipalPermissionsTableResourcePropertyFromCloudFormation(properties.Table) : void 0), ret.addPropertyResult("tableWithColumns", "TableWithColumns", properties.TableWithColumns != null ? CfnPrincipalPermissionsTableWithColumnsResourcePropertyFromCloudFormation(properties.TableWithColumns) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPrincipalPermissions_TableResourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalogId", cdk.requiredValidator)(properties.catalogId)), errors.collect(cdk.propertyValidator("catalogId", cdk.validateString)(properties.catalogId)), errors.collect(cdk.propertyValidator("databaseName", cdk.requiredValidator)(properties.databaseName)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tableWildcard", cdk.validateObject)(properties.tableWildcard)), errors.wrap('supplied properties not correct for "TableResourceProperty"');
    }
    function cfnPrincipalPermissionsTableResourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPrincipalPermissions_TableResourcePropertyValidator(properties).assertSuccess(), { CatalogId: cdk.stringToCloudFormation(properties.catalogId), DatabaseName: cdk.stringToCloudFormation(properties.databaseName), Name: cdk.stringToCloudFormation(properties.name), TableWildcard: cdk.objectToCloudFormation(properties.tableWildcard) }) : properties;
    }
    function CfnPrincipalPermissionsTableResourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalogId", "CatalogId", cfn_parse.FromCloudFormation.getString(properties.CatalogId)), ret.addPropertyResult("databaseName", "DatabaseName", cfn_parse.FromCloudFormation.getString(properties.DatabaseName)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tableWildcard", "TableWildcard", properties.TableWildcard != null ? cfn_parse.FromCloudFormation.getAny(properties.TableWildcard) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPrincipalPermissions_TableWithColumnsResourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalogId", cdk.requiredValidator)(properties.catalogId)), errors.collect(cdk.propertyValidator("catalogId", cdk.validateString)(properties.catalogId)), errors.collect(cdk.propertyValidator("columnNames", cdk.listValidator(cdk.validateString))(properties.columnNames)), errors.collect(cdk.propertyValidator("columnWildcard", CfnPrincipalPermissions_ColumnWildcardPropertyValidator)(properties.columnWildcard)), errors.collect(cdk.propertyValidator("databaseName", cdk.requiredValidator)(properties.databaseName)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "TableWithColumnsResourceProperty"');
    }
    function cfnPrincipalPermissionsTableWithColumnsResourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPrincipalPermissions_TableWithColumnsResourcePropertyValidator(properties).assertSuccess(), { CatalogId: cdk.stringToCloudFormation(properties.catalogId), ColumnNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.columnNames), ColumnWildcard: cfnPrincipalPermissionsColumnWildcardPropertyToCloudFormation(properties.columnWildcard), DatabaseName: cdk.stringToCloudFormation(properties.databaseName), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnPrincipalPermissionsTableWithColumnsResourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalogId", "CatalogId", cfn_parse.FromCloudFormation.getString(properties.CatalogId)), ret.addPropertyResult("columnNames", "ColumnNames", properties.ColumnNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ColumnNames) : void 0), ret.addPropertyResult("columnWildcard", "ColumnWildcard", properties.ColumnWildcard != null ? CfnPrincipalPermissionsColumnWildcardPropertyFromCloudFormation(properties.ColumnWildcard) : void 0), ret.addPropertyResult("databaseName", "DatabaseName", cfn_parse.FromCloudFormation.getString(properties.DatabaseName)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourcePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceArn", cdk.requiredValidator)(properties.resourceArn)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("useServiceLinkedRole", cdk.requiredValidator)(properties.useServiceLinkedRole)), errors.collect(cdk.propertyValidator("useServiceLinkedRole", cdk.validateBoolean)(properties.useServiceLinkedRole)), errors.collect(cdk.propertyValidator("withFederation", cdk.validateBoolean)(properties.withFederation)), errors.wrap('supplied properties not correct for "CfnResourceProps"');
    }
    function cfnResourcePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourcePropsValidator(properties).assertSuccess(), { ResourceArn: cdk.stringToCloudFormation(properties.resourceArn), UseServiceLinkedRole: cdk.booleanToCloudFormation(properties.useServiceLinkedRole), RoleArn: cdk.stringToCloudFormation(properties.roleArn), WithFederation: cdk.booleanToCloudFormation(properties.withFederation) }) : properties;
    }
    function CfnResourcePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceArn", "ResourceArn", cfn_parse.FromCloudFormation.getString(properties.ResourceArn)), ret.addPropertyResult("useServiceLinkedRole", "UseServiceLinkedRole", cfn_parse.FromCloudFormation.getBoolean(properties.UseServiceLinkedRole)), ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addPropertyResult("withFederation", "WithFederation", properties.WithFederation != null ? cfn_parse.FromCloudFormation.getBoolean(properties.WithFederation) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResource = class _CfnResource extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResourcePropsFromCloudFormation(resourceProperties), ret = new _CfnResource(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnResource.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lakeformation_CfnResourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResource), error;
        }
        cdk.requireProperty(props, "resourceArn", this), cdk.requireProperty(props, "useServiceLinkedRole", this), this.resourceArn = props.resourceArn, this.useServiceLinkedRole = props.useServiceLinkedRole, this.roleArn = props.roleArn, this.withFederation = props.withFederation;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResource.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { resourceArn: this.resourceArn, useServiceLinkedRole: this.useServiceLinkedRole, roleArn: this.roleArn, withFederation: this.withFederation };
      }
      renderProperties(props) {
        return cfnResourcePropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnResource[_e] = { fqn: "aws-cdk-lib.aws_lakeformation.CfnResource", version: "2.80.0" }, CfnResource.CFN_RESOURCE_TYPE_NAME = "AWS::LakeFormation::Resource", exports2.CfnResource = CfnResource;
    function CfnTagPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalogId", cdk.validateString)(properties.catalogId)), errors.collect(cdk.propertyValidator("tagKey", cdk.requiredValidator)(properties.tagKey)), errors.collect(cdk.propertyValidator("tagKey", cdk.validateString)(properties.tagKey)), errors.collect(cdk.propertyValidator("tagValues", cdk.requiredValidator)(properties.tagValues)), errors.collect(cdk.propertyValidator("tagValues", cdk.listValidator(cdk.validateString))(properties.tagValues)), errors.wrap('supplied properties not correct for "CfnTagProps"');
    }
    function cfnTagPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTagPropsValidator(properties).assertSuccess(), { TagKey: cdk.stringToCloudFormation(properties.tagKey), TagValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.tagValues), CatalogId: cdk.stringToCloudFormation(properties.catalogId) }) : properties;
    }
    function CfnTagPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("tagKey", "TagKey", cfn_parse.FromCloudFormation.getString(properties.TagKey)), ret.addPropertyResult("tagValues", "TagValues", cfn_parse.FromCloudFormation.getStringArray(properties.TagValues)), ret.addPropertyResult("catalogId", "CatalogId", properties.CatalogId != null ? cfn_parse.FromCloudFormation.getString(properties.CatalogId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTag = class _CfnTag extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTagPropsFromCloudFormation(resourceProperties), ret = new _CfnTag(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTag.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lakeformation_CfnTagProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTag), error;
        }
        cdk.requireProperty(props, "tagKey", this), cdk.requireProperty(props, "tagValues", this), this.tagKey = props.tagKey, this.tagValues = props.tagValues, this.catalogId = props.catalogId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTag.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { tagKey: this.tagKey, tagValues: this.tagValues, catalogId: this.catalogId };
      }
      renderProperties(props) {
        return cfnTagPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnTag[_f] = { fqn: "aws-cdk-lib.aws_lakeformation.CfnTag", version: "2.80.0" }, CfnTag.CFN_RESOURCE_TYPE_NAME = "AWS::LakeFormation::Tag", exports2.CfnTag = CfnTag;
    function CfnTagAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("lfTags", cdk.requiredValidator)(properties.lfTags)), errors.collect(cdk.propertyValidator("lfTags", cdk.listValidator(CfnTagAssociation_LFTagPairPropertyValidator))(properties.lfTags)), errors.collect(cdk.propertyValidator("resource", cdk.requiredValidator)(properties.resource)), errors.collect(cdk.propertyValidator("resource", CfnTagAssociation_ResourcePropertyValidator)(properties.resource)), errors.wrap('supplied properties not correct for "CfnTagAssociationProps"');
    }
    function cfnTagAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTagAssociationPropsValidator(properties).assertSuccess(), { LFTags: cdk.listMapper(cfnTagAssociationLFTagPairPropertyToCloudFormation)(properties.lfTags), Resource: cfnTagAssociationResourcePropertyToCloudFormation(properties.resource) }) : properties;
    }
    function CfnTagAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("lfTags", "LFTags", cfn_parse.FromCloudFormation.getArray(CfnTagAssociationLFTagPairPropertyFromCloudFormation)(properties.LFTags)), ret.addPropertyResult("resource", "Resource", CfnTagAssociationResourcePropertyFromCloudFormation(properties.Resource)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTagAssociation = class _CfnTagAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTagAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnTagAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTagAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lakeformation_CfnTagAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTagAssociation), error;
        }
        cdk.requireProperty(props, "lfTags", this), cdk.requireProperty(props, "resource", this), this.attrResourceIdentifier = cdk.Token.asString(this.getAtt("ResourceIdentifier", cdk.ResolutionTypeHint.STRING)), this.attrTagsIdentifier = cdk.Token.asString(this.getAtt("TagsIdentifier", cdk.ResolutionTypeHint.STRING)), this.lfTags = props.lfTags, this.resource = props.resource;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTagAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { lfTags: this.lfTags, resource: this.resource };
      }
      renderProperties(props) {
        return cfnTagAssociationPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnTagAssociation[_g] = { fqn: "aws-cdk-lib.aws_lakeformation.CfnTagAssociation", version: "2.80.0" }, CfnTagAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::LakeFormation::TagAssociation", exports2.CfnTagAssociation = CfnTagAssociation;
    function CfnTagAssociation_DatabaseResourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalogId", cdk.requiredValidator)(properties.catalogId)), errors.collect(cdk.propertyValidator("catalogId", cdk.validateString)(properties.catalogId)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "DatabaseResourceProperty"');
    }
    function cfnTagAssociationDatabaseResourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTagAssociation_DatabaseResourcePropertyValidator(properties).assertSuccess(), { CatalogId: cdk.stringToCloudFormation(properties.catalogId), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnTagAssociationDatabaseResourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalogId", "CatalogId", cfn_parse.FromCloudFormation.getString(properties.CatalogId)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTagAssociation_LFTagPairPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalogId", cdk.requiredValidator)(properties.catalogId)), errors.collect(cdk.propertyValidator("catalogId", cdk.validateString)(properties.catalogId)), errors.collect(cdk.propertyValidator("tagKey", cdk.requiredValidator)(properties.tagKey)), errors.collect(cdk.propertyValidator("tagKey", cdk.validateString)(properties.tagKey)), errors.collect(cdk.propertyValidator("tagValues", cdk.requiredValidator)(properties.tagValues)), errors.collect(cdk.propertyValidator("tagValues", cdk.listValidator(cdk.validateString))(properties.tagValues)), errors.wrap('supplied properties not correct for "LFTagPairProperty"');
    }
    function cfnTagAssociationLFTagPairPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTagAssociation_LFTagPairPropertyValidator(properties).assertSuccess(), { CatalogId: cdk.stringToCloudFormation(properties.catalogId), TagKey: cdk.stringToCloudFormation(properties.tagKey), TagValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.tagValues) }) : properties;
    }
    function CfnTagAssociationLFTagPairPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalogId", "CatalogId", cfn_parse.FromCloudFormation.getString(properties.CatalogId)), ret.addPropertyResult("tagKey", "TagKey", cfn_parse.FromCloudFormation.getString(properties.TagKey)), ret.addPropertyResult("tagValues", "TagValues", cfn_parse.FromCloudFormation.getStringArray(properties.TagValues)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTagAssociation_ResourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalog", cdk.validateObject)(properties.catalog)), errors.collect(cdk.propertyValidator("database", CfnTagAssociation_DatabaseResourcePropertyValidator)(properties.database)), errors.collect(cdk.propertyValidator("table", CfnTagAssociation_TableResourcePropertyValidator)(properties.table)), errors.collect(cdk.propertyValidator("tableWithColumns", CfnTagAssociation_TableWithColumnsResourcePropertyValidator)(properties.tableWithColumns)), errors.wrap('supplied properties not correct for "ResourceProperty"');
    }
    function cfnTagAssociationResourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTagAssociation_ResourcePropertyValidator(properties).assertSuccess(), { Catalog: cdk.objectToCloudFormation(properties.catalog), Database: cfnTagAssociationDatabaseResourcePropertyToCloudFormation(properties.database), Table: cfnTagAssociationTableResourcePropertyToCloudFormation(properties.table), TableWithColumns: cfnTagAssociationTableWithColumnsResourcePropertyToCloudFormation(properties.tableWithColumns) }) : properties;
    }
    function CfnTagAssociationResourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalog", "Catalog", properties.Catalog != null ? cfn_parse.FromCloudFormation.getAny(properties.Catalog) : void 0), ret.addPropertyResult("database", "Database", properties.Database != null ? CfnTagAssociationDatabaseResourcePropertyFromCloudFormation(properties.Database) : void 0), ret.addPropertyResult("table", "Table", properties.Table != null ? CfnTagAssociationTableResourcePropertyFromCloudFormation(properties.Table) : void 0), ret.addPropertyResult("tableWithColumns", "TableWithColumns", properties.TableWithColumns != null ? CfnTagAssociationTableWithColumnsResourcePropertyFromCloudFormation(properties.TableWithColumns) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTagAssociation_TableResourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalogId", cdk.requiredValidator)(properties.catalogId)), errors.collect(cdk.propertyValidator("catalogId", cdk.validateString)(properties.catalogId)), errors.collect(cdk.propertyValidator("databaseName", cdk.requiredValidator)(properties.databaseName)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tableWildcard", cdk.validateObject)(properties.tableWildcard)), errors.wrap('supplied properties not correct for "TableResourceProperty"');
    }
    function cfnTagAssociationTableResourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTagAssociation_TableResourcePropertyValidator(properties).assertSuccess(), { CatalogId: cdk.stringToCloudFormation(properties.catalogId), DatabaseName: cdk.stringToCloudFormation(properties.databaseName), Name: cdk.stringToCloudFormation(properties.name), TableWildcard: cdk.objectToCloudFormation(properties.tableWildcard) }) : properties;
    }
    function CfnTagAssociationTableResourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalogId", "CatalogId", cfn_parse.FromCloudFormation.getString(properties.CatalogId)), ret.addPropertyResult("databaseName", "DatabaseName", cfn_parse.FromCloudFormation.getString(properties.DatabaseName)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tableWildcard", "TableWildcard", properties.TableWildcard != null ? cfn_parse.FromCloudFormation.getAny(properties.TableWildcard) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTagAssociation_TableWithColumnsResourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalogId", cdk.requiredValidator)(properties.catalogId)), errors.collect(cdk.propertyValidator("catalogId", cdk.validateString)(properties.catalogId)), errors.collect(cdk.propertyValidator("columnNames", cdk.requiredValidator)(properties.columnNames)), errors.collect(cdk.propertyValidator("columnNames", cdk.listValidator(cdk.validateString))(properties.columnNames)), errors.collect(cdk.propertyValidator("databaseName", cdk.requiredValidator)(properties.databaseName)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "TableWithColumnsResourceProperty"');
    }
    function cfnTagAssociationTableWithColumnsResourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTagAssociation_TableWithColumnsResourcePropertyValidator(properties).assertSuccess(), { CatalogId: cdk.stringToCloudFormation(properties.catalogId), ColumnNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.columnNames), DatabaseName: cdk.stringToCloudFormation(properties.databaseName), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnTagAssociationTableWithColumnsResourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalogId", "CatalogId", cfn_parse.FromCloudFormation.getString(properties.CatalogId)), ret.addPropertyResult("columnNames", "ColumnNames", cfn_parse.FromCloudFormation.getStringArray(properties.ColumnNames)), ret.addPropertyResult("databaseName", "DatabaseName", cfn_parse.FromCloudFormation.getString(properties.DatabaseName)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-lakeformation/lib/index.js
var require_lib170 = __commonJS({
  "node_modules/aws-cdk-lib/aws-lakeformation/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lakeformation_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-lakeformation/index.js
var require_aws_lakeformation = __commonJS({
  "node_modules/aws-cdk-lib/aws-lakeformation/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib170(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-lambda-destinations/lib/event-bridge.js
var require_event_bridge = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda-destinations/lib/event-bridge.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EventBridgeDestination = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var events = require_aws_events();
    var core_1 = require_core2();
    var EventBridgeDestination = class _EventBridgeDestination {
      constructor(eventBus) {
        this.eventBus = eventBus;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_events_IEventBus(eventBus);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EventBridgeDestination), error;
        }
      }
      bind(_scope, fn, _options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_IFunction(fn), jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_DestinationOptions(_options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        if (this.eventBus)
          return this.eventBus.grantPutEventsTo(fn), { destination: this.eventBus.eventBusArn };
        let eventBus = _scope.node.tryFindChild("DefaultEventBus") || events.EventBus.fromEventBusArn(_scope, "DefaultEventBus", core_1.Stack.of(fn).formatArn({ service: "events", resource: "event-bus", resourceName: "default" }));
        return eventBus.grantPutEventsTo(fn), { destination: eventBus.eventBusArn };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EventBridgeDestination[_a] = { fqn: "aws-cdk-lib.aws_lambda_destinations.EventBridgeDestination", version: "2.80.0" }, exports2.EventBridgeDestination = EventBridgeDestination;
  }
});

// node_modules/aws-cdk-lib/aws-lambda-destinations/lib/lambda.js
var require_lambda8 = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda-destinations/lib/lambda.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LambdaDestination = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var event_bridge_1 = require_event_bridge();
    var events = require_aws_events();
    var targets = require_aws_events_targets();
    var LambdaDestination = class _LambdaDestination {
      constructor(fn, options = {}) {
        this.fn = fn, this.options = options;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_IFunction(fn), jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_destinations_LambdaDestinationOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _LambdaDestination), error;
        }
      }
      bind(scope, fn, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_IFunction(fn), jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_DestinationOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        if (!this.options.responseOnly)
          return this.fn.grantInvoke(fn), { destination: this.fn.functionArn };
        if (!options)
          throw new Error("Options must be defined when using `responseOnly`.");
        return new events.Rule(scope, options.type, { eventPattern: { detailType: [`Lambda Function Invocation Result - ${options.type}`], resources: [`${fn.functionArn}:$LATEST`], source: ["lambda"] }, targets: [new targets.LambdaFunction(this.fn, { event: events.RuleTargetInput.fromEventPath("$.detail.responsePayload") })] }), new event_bridge_1.EventBridgeDestination().bind(scope, fn);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LambdaDestination[_a] = { fqn: "aws-cdk-lib.aws_lambda_destinations.LambdaDestination", version: "2.80.0" }, exports2.LambdaDestination = LambdaDestination;
  }
});

// node_modules/aws-cdk-lib/aws-lambda-destinations/lib/sns.js
var require_sns4 = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda-destinations/lib/sns.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SnsDestination = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var SnsDestination = class _SnsDestination {
      constructor(topic) {
        this.topic = topic;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sns_ITopic(topic);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SnsDestination), error;
        }
      }
      bind(_scope, fn, _options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_IFunction(fn), jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_DestinationOptions(_options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return this.topic.grantPublish(fn), { destination: this.topic.topicArn };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SnsDestination[_a] = { fqn: "aws-cdk-lib.aws_lambda_destinations.SnsDestination", version: "2.80.0" }, exports2.SnsDestination = SnsDestination;
  }
});

// node_modules/aws-cdk-lib/aws-lambda-destinations/lib/sqs.js
var require_sqs5 = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda-destinations/lib/sqs.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SqsDestination = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var SqsDestination = class _SqsDestination {
      constructor(queue) {
        this.queue = queue;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sqs_IQueue(queue);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SqsDestination), error;
        }
      }
      bind(_scope, fn, _options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_IFunction(fn), jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_DestinationOptions(_options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return this.queue.grantSendMessages(fn), { destination: this.queue.queueArn };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SqsDestination[_a] = { fqn: "aws-cdk-lib.aws_lambda_destinations.SqsDestination", version: "2.80.0" }, exports2.SqsDestination = SqsDestination;
  }
});

// node_modules/aws-cdk-lib/aws-lambda-destinations/lib/index.js
var require_lib171 = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda-destinations/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_event_bridge(), exports2), __exportStar(require_lambda8(), exports2), __exportStar(require_sns4(), exports2), __exportStar(require_sqs5(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-lambda-destinations/index.js
var require_aws_lambda_destinations = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda-destinations/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib171(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-lambda-event-sources/lib/api.js
var require_api4 = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda-event-sources/lib/api.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ApiEventSource = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var apigw = require_aws_apigateway();
    var core_1 = require_core2();
    var ApiEventSource = class _ApiEventSource {
      constructor(method, path, options) {
        this.method = method, this.path = path, this.options = options;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_apigateway_MethodOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ApiEventSource), error;
        }
        if (!path.startsWith("/"))
          throw new Error(`Path must start with "/": ${path}`);
      }
      bind(target) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_IFunction(target);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        const id = `${core_1.Names.nodeUniqueId(target.node)}:ApiEventSourceA7A86A4F`, stack = core_1.Stack.of(target);
        let api = stack.node.tryFindChild(id);
        api || (api = new apigw.RestApi(stack, id, { defaultIntegration: new apigw.LambdaIntegration(target) })), api.root.resourceForPath(this.path).addMethod(this.method, void 0, this.options);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ApiEventSource[_a] = { fqn: "aws-cdk-lib.aws_lambda_event_sources.ApiEventSource", version: "2.80.0" }, exports2.ApiEventSource = ApiEventSource;
  }
});

// node_modules/aws-cdk-lib/aws-lambda-event-sources/lib/stream.js
var require_stream2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda-event-sources/lib/stream.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.StreamEventSource = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var StreamEventSource = class _StreamEventSource {
      constructor(props) {
        this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_event_sources_StreamEventSourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _StreamEventSource), error;
        }
      }
      enrichMappingOptions(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_EventSourceMappingOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.enrichMappingOptions), error;
        }
        return { ...options, batchSize: this.props.batchSize || 100, bisectBatchOnError: this.props.bisectBatchOnError, startingPosition: this.props.startingPosition, reportBatchItemFailures: this.props.reportBatchItemFailures, maxBatchingWindow: this.props.maxBatchingWindow, maxRecordAge: this.props.maxRecordAge, retryAttempts: this.props.retryAttempts, parallelizationFactor: this.props.parallelizationFactor, onFailure: this.props.onFailure, tumblingWindow: this.props.tumblingWindow, enabled: this.props.enabled, filters: this.props.filters };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, StreamEventSource[_a] = { fqn: "aws-cdk-lib.aws_lambda_event_sources.StreamEventSource", version: "2.80.0" }, exports2.StreamEventSource = StreamEventSource;
  }
});

// node_modules/aws-cdk-lib/aws-lambda-event-sources/lib/dynamodb.js
var require_dynamodb3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda-event-sources/lib/dynamodb.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DynamoEventSource = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var stream_1 = require_stream2();
    var core_1 = require_core2();
    var DynamoEventSource = class _DynamoEventSource extends stream_1.StreamEventSource {
      constructor(table, props) {
        super(props), this.table = table, this._eventSourceMappingId = void 0, this._eventSourceMappingArn = void 0;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_dynamodb_ITable(table), jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_event_sources_DynamoEventSourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _DynamoEventSource), error;
        }
        if (this.props.batchSize !== void 0 && !core_1.Token.isUnresolved(this.props.batchSize) && (this.props.batchSize < 1 || this.props.batchSize > 1e4))
          throw new Error(`Maximum batch size must be between 1 and 10000 inclusive (given ${this.props.batchSize})`);
      }
      bind(target) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_IFunction(target);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        if (!this.table.tableStreamArn)
          throw new Error(`DynamoDB Streams must be enabled on the table ${this.table.node.path}`);
        const eventSourceMapping = target.addEventSourceMapping(`DynamoDBEventSource:${core_1.Names.nodeUniqueId(this.table.node)}`, this.enrichMappingOptions({ eventSourceArn: this.table.tableStreamArn }));
        this._eventSourceMappingId = eventSourceMapping.eventSourceMappingId, this._eventSourceMappingArn = eventSourceMapping.eventSourceMappingArn, this.table.grantStreamRead(target);
      }
      get eventSourceMappingId() {
        if (!this._eventSourceMappingId)
          throw new Error("DynamoEventSource is not yet bound to an event source mapping");
        return this._eventSourceMappingId;
      }
      get eventSourceMappingArn() {
        if (!this._eventSourceMappingArn)
          throw new Error("DynamoEventSource is not yet bound to an event source mapping");
        return this._eventSourceMappingArn;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, DynamoEventSource[_a] = { fqn: "aws-cdk-lib.aws_lambda_event_sources.DynamoEventSource", version: "2.80.0" }, exports2.DynamoEventSource = DynamoEventSource;
  }
});

// node_modules/aws-cdk-lib/aws-lambda-event-sources/lib/kafka.js
var require_kafka2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda-event-sources/lib/kafka.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SelfManagedKafkaEventSource = exports2.ManagedKafkaEventSource = exports2.AuthenticationMethod = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var stream_1 = require_stream2();
    var iam = require_aws_iam();
    var lambda2 = require_aws_lambda();
    var core_1 = require_core2();
    var helpers_internal_1 = require_helpers_internal();
    var AuthenticationMethod;
    (function(AuthenticationMethod2) {
      AuthenticationMethod2.SASL_SCRAM_512_AUTH = "SASL_SCRAM_512_AUTH", AuthenticationMethod2.SASL_SCRAM_256_AUTH = "SASL_SCRAM_256_AUTH", AuthenticationMethod2.BASIC_AUTH = "BASIC_AUTH", AuthenticationMethod2.CLIENT_CERTIFICATE_TLS_AUTH = "CLIENT_CERTIFICATE_TLS_AUTH";
    })(AuthenticationMethod = exports2.AuthenticationMethod || (exports2.AuthenticationMethod = {}));
    var ManagedKafkaEventSource = class _ManagedKafkaEventSource extends stream_1.StreamEventSource {
      constructor(props) {
        super(props), this._eventSourceMappingId = void 0, this._eventSourceMappingArn = void 0;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_event_sources_ManagedKafkaEventSourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ManagedKafkaEventSource), error;
        }
        this.innerProps = props;
      }
      bind(target) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_IFunction(target);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        const eventSourceMapping = target.addEventSourceMapping(`KafkaEventSource:${core_1.Names.nodeUniqueId(target.node)}${this.innerProps.topic}`, this.enrichMappingOptions({ eventSourceArn: this.innerProps.clusterArn, startingPosition: this.innerProps.startingPosition, sourceAccessConfigurations: this.sourceAccessConfigurations(), kafkaTopic: this.innerProps.topic, kafkaConsumerGroupId: this.innerProps.consumerGroupId }));
        this._eventSourceMappingId = eventSourceMapping.eventSourceMappingId, this._eventSourceMappingArn = eventSourceMapping.eventSourceMappingArn, this.innerProps.secret !== void 0 && this.innerProps.secret.grantRead(target), target.addToRolePolicy(new iam.PolicyStatement({ actions: ["kafka:DescribeCluster", "kafka:GetBootstrapBrokers", "kafka:ListScramSecrets"], resources: [this.innerProps.clusterArn] })), target.role?.addManagedPolicy(iam.ManagedPolicy.fromAwsManagedPolicyName("service-role/AWSLambdaMSKExecutionRole"));
      }
      sourceAccessConfigurations() {
        const sourceAccessConfigurations = [];
        return this.innerProps.secret !== void 0 && sourceAccessConfigurations.push({ type: lambda2.SourceAccessConfigurationType.SASL_SCRAM_512_AUTH, uri: this.innerProps.secret.secretArn }), sourceAccessConfigurations.length === 0 ? void 0 : sourceAccessConfigurations;
      }
      get eventSourceMappingId() {
        if (!this._eventSourceMappingId)
          throw new Error("KafkaEventSource is not yet bound to an event source mapping");
        return this._eventSourceMappingId;
      }
      get eventSourceMappingArn() {
        if (!this._eventSourceMappingArn)
          throw new Error("KafkaEventSource is not yet bound to an event source mapping");
        return this._eventSourceMappingArn;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ManagedKafkaEventSource[_a] = { fqn: "aws-cdk-lib.aws_lambda_event_sources.ManagedKafkaEventSource", version: "2.80.0" }, exports2.ManagedKafkaEventSource = ManagedKafkaEventSource;
    var SelfManagedKafkaEventSource = class _SelfManagedKafkaEventSource extends stream_1.StreamEventSource {
      constructor(props) {
        super(props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_event_sources_SelfManagedKafkaEventSourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SelfManagedKafkaEventSource), error;
        }
        if (props.vpc) {
          if (!props.securityGroup)
            throw new Error("securityGroup must be set when providing vpc");
          if (!props.vpcSubnets)
            throw new Error("vpcSubnets must be set when providing vpc");
        } else if (!props.secret)
          throw new Error("secret must be set if Kafka brokers accessed over Internet");
        this.innerProps = props;
      }
      bind(target) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_IFunction(target);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        if (!(target instanceof constructs_1.Construct))
          throw new Error("Function is not a construct. Unexpected error.");
        target.addEventSourceMapping(this.mappingId(target), this.enrichMappingOptions({ kafkaBootstrapServers: this.innerProps.bootstrapServers, kafkaTopic: this.innerProps.topic, kafkaConsumerGroupId: this.innerProps.consumerGroupId, startingPosition: this.innerProps.startingPosition, sourceAccessConfigurations: this.sourceAccessConfigurations() })), this.innerProps.secret !== void 0 && this.innerProps.secret.grantRead(target);
      }
      mappingId(target) {
        return `KafkaEventSource:${(0, helpers_internal_1.md5hash)(JSON.stringify(core_1.Stack.of(target).resolve(this.innerProps.bootstrapServers)))}:${this.innerProps.topic}`;
      }
      sourceAccessConfigurations() {
        let authType;
        switch (this.innerProps.authenticationMethod) {
          case AuthenticationMethod.BASIC_AUTH:
            authType = lambda2.SourceAccessConfigurationType.BASIC_AUTH;
            break;
          case AuthenticationMethod.CLIENT_CERTIFICATE_TLS_AUTH:
            authType = lambda2.SourceAccessConfigurationType.CLIENT_CERTIFICATE_TLS_AUTH;
            break;
          case AuthenticationMethod.SASL_SCRAM_256_AUTH:
            authType = lambda2.SourceAccessConfigurationType.SASL_SCRAM_256_AUTH;
            break;
          case AuthenticationMethod.SASL_SCRAM_512_AUTH:
          default:
            authType = lambda2.SourceAccessConfigurationType.SASL_SCRAM_512_AUTH;
            break;
        }
        const sourceAccessConfigurations = [];
        return this.innerProps.secret !== void 0 && sourceAccessConfigurations.push({ type: authType, uri: this.innerProps.secret.secretArn }), this.innerProps.rootCACertificate !== void 0 && sourceAccessConfigurations.push({ type: lambda2.SourceAccessConfigurationType.SERVER_ROOT_CA_CERTIFICATE, uri: this.innerProps.rootCACertificate.secretArn }), this.innerProps.vpcSubnets !== void 0 && this.innerProps.securityGroup !== void 0 && (sourceAccessConfigurations.push({ type: lambda2.SourceAccessConfigurationType.VPC_SECURITY_GROUP, uri: this.innerProps.securityGroup.securityGroupId }), this.innerProps.vpc?.selectSubnets(this.innerProps.vpcSubnets).subnetIds.forEach((id) => {
          sourceAccessConfigurations.push({ type: lambda2.SourceAccessConfigurationType.VPC_SUBNET, uri: id });
        })), sourceAccessConfigurations.length === 0 ? void 0 : sourceAccessConfigurations;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, SelfManagedKafkaEventSource[_b] = { fqn: "aws-cdk-lib.aws_lambda_event_sources.SelfManagedKafkaEventSource", version: "2.80.0" }, exports2.SelfManagedKafkaEventSource = SelfManagedKafkaEventSource;
  }
});

// node_modules/aws-cdk-lib/aws-lambda-event-sources/lib/kinesis.js
var require_kinesis2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda-event-sources/lib/kinesis.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.KinesisEventSource = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var stream_1 = require_stream2();
    var cdk = require_core2();
    var KinesisEventSource = class _KinesisEventSource extends stream_1.StreamEventSource {
      constructor(stream, props) {
        super(props), this.stream = stream, this._eventSourceMappingId = void 0, this._eventSourceMappingArn = void 0;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kinesis_IStream(stream), jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_event_sources_KinesisEventSourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _KinesisEventSource), error;
        }
        this.startingPositionTimestamp = props.startingPositionTimestamp, this.props.batchSize !== void 0 && cdk.withResolved(this.props.batchSize, (batchSize) => {
          if (batchSize < 1 || batchSize > 1e4)
            throw new Error(`Maximum batch size must be between 1 and 10000 inclusive (given ${this.props.batchSize})`);
        });
      }
      bind(target) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_IFunction(target);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        const eventSourceMapping = target.addEventSourceMapping(`KinesisEventSource:${cdk.Names.nodeUniqueId(this.stream.node)}`, this.enrichMappingOptions({ eventSourceArn: this.stream.streamArn, startingPositionTimestamp: this.startingPositionTimestamp }));
        this._eventSourceMappingId = eventSourceMapping.eventSourceMappingId, this._eventSourceMappingArn = eventSourceMapping.eventSourceMappingArn, this.stream.grantRead(target), this.stream.grant(target, "kinesis:DescribeStream");
      }
      get eventSourceMappingId() {
        if (!this._eventSourceMappingId)
          throw new Error("KinesisEventSource is not yet bound to an event source mapping");
        return this._eventSourceMappingId;
      }
      get eventSourceMappingArn() {
        if (!this._eventSourceMappingArn)
          throw new Error("KinesisEventSource is not yet bound to an event source mapping");
        return this._eventSourceMappingArn;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, KinesisEventSource[_a] = { fqn: "aws-cdk-lib.aws_lambda_event_sources.KinesisEventSource", version: "2.80.0" }, exports2.KinesisEventSource = KinesisEventSource;
  }
});

// node_modules/aws-cdk-lib/aws-s3-notifications/lib/sqs.js
var require_sqs6 = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3-notifications/lib/sqs.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SqsDestination = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var s3 = require_aws_s3();
    var core_1 = require_core2();
    var SqsDestination = class _SqsDestination {
      constructor(queue) {
        this.queue = queue;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sqs_IQueue(queue);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SqsDestination), error;
        }
      }
      bind(_scope, bucket) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_IBucket(bucket);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        if (this.queue.grantSendMessages(new iam.ServicePrincipal("s3.amazonaws.com", { conditions: { ArnLike: { "aws:SourceArn": bucket.bucketArn } } })), this.queue.encryptionMasterKey) {
          const statement = new iam.PolicyStatement({ principals: [new iam.ServicePrincipal("s3.amazonaws.com")], actions: ["kms:GenerateDataKey*", "kms:Decrypt"], resources: ["*"] });
          this.queue.encryptionMasterKey.addToResourcePolicy(statement, true).statementAdded || core_1.Annotations.of(this.queue.encryptionMasterKey).addWarning(`Can not change key policy of imported kms key. Ensure that your key policy contains the following permissions: 
${JSON.stringify(statement.toJSON(), null, 2)}`);
        }
        return { arn: this.queue.queueArn, type: s3.BucketNotificationDestinationType.QUEUE, dependencies: [this.queue] };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SqsDestination[_a] = { fqn: "aws-cdk-lib.aws_s3_notifications.SqsDestination", version: "2.80.0" }, exports2.SqsDestination = SqsDestination;
  }
});

// node_modules/aws-cdk-lib/aws-s3-notifications/lib/sns.js
var require_sns5 = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3-notifications/lib/sns.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SnsDestination = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var s3 = require_aws_s3();
    var SnsDestination = class _SnsDestination {
      constructor(topic) {
        this.topic = topic;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sns_ITopic(topic);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SnsDestination), error;
        }
      }
      bind(_scope, bucket) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_IBucket(bucket);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return this.topic.addToResourcePolicy(new iam.PolicyStatement({ principals: [new iam.ServicePrincipal("s3.amazonaws.com")], actions: ["sns:Publish"], resources: [this.topic.topicArn], conditions: { ArnLike: { "aws:SourceArn": bucket.bucketArn } } })), { arn: this.topic.topicArn, type: s3.BucketNotificationDestinationType.TOPIC, dependencies: [this.topic] };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SnsDestination[_a] = { fqn: "aws-cdk-lib.aws_s3_notifications.SnsDestination", version: "2.80.0" }, exports2.SnsDestination = SnsDestination;
  }
});

// node_modules/aws-cdk-lib/aws-s3-notifications/lib/lambda.js
var require_lambda9 = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3-notifications/lib/lambda.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LambdaDestination = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var iam = require_aws_iam();
    var s3 = require_aws_s3();
    var core_1 = require_core2();
    var LambdaDestination = class _LambdaDestination {
      constructor(fn) {
        this.fn = fn;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_IFunction(fn);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _LambdaDestination), error;
        }
      }
      bind(_scope, bucket) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_IBucket(bucket);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        const permissionId = `AllowBucketNotificationsTo${core_1.Names.nodeUniqueId(this.fn.permissionsNode)}`;
        if (!(bucket instanceof constructs_1.Construct))
          throw new Error(`LambdaDestination for function ${core_1.Names.nodeUniqueId(this.fn.permissionsNode)} can only be configured on a
        bucket construct (Bucket ${bucket.bucketName})`);
        bucket.node.tryFindChild(permissionId) === void 0 && this.fn.addPermission(permissionId, { sourceAccount: core_1.Stack.of(bucket).account, principal: new iam.ServicePrincipal("s3.amazonaws.com"), sourceArn: bucket.bucketArn, scope: bucket });
        const permission = bucket.node.tryFindChild(permissionId);
        return { type: s3.BucketNotificationDestinationType.LAMBDA, arn: this.fn.functionArn, dependencies: permission ? [permission] : void 0 };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LambdaDestination[_a] = { fqn: "aws-cdk-lib.aws_s3_notifications.LambdaDestination", version: "2.80.0" }, exports2.LambdaDestination = LambdaDestination;
  }
});

// node_modules/aws-cdk-lib/aws-s3-notifications/lib/index.js
var require_lib172 = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3-notifications/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_sqs6(), exports2), __exportStar(require_sns5(), exports2), __exportStar(require_lambda9(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-s3-notifications/index.js
var require_aws_s3_notifications = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3-notifications/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib172(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-lambda-event-sources/lib/s3.js
var require_s34 = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda-event-sources/lib/s3.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.S3EventSource = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var notifs = require_aws_s3_notifications();
    var S3EventSource = class _S3EventSource {
      constructor(bucket, props) {
        this.bucket = bucket, this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_Bucket(bucket), jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_event_sources_S3EventSourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _S3EventSource), error;
        }
      }
      bind(target) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_IFunction(target);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        const filters = this.props.filters || [];
        for (const event of this.props.events)
          this.bucket.addEventNotification(event, new notifs.LambdaDestination(target), ...filters);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, S3EventSource[_a] = { fqn: "aws-cdk-lib.aws_lambda_event_sources.S3EventSource", version: "2.80.0" }, exports2.S3EventSource = S3EventSource;
  }
});

// node_modules/aws-cdk-lib/aws-lambda-event-sources/lib/sns.js
var require_sns6 = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda-event-sources/lib/sns.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SnsEventSource = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var subs = require_aws_sns_subscriptions();
    var SnsEventSource = class _SnsEventSource {
      constructor(topic, props) {
        this.topic = topic;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sns_ITopic(topic), jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_event_sources_SnsEventSourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SnsEventSource), error;
        }
        this.props = props;
      }
      bind(target) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_IFunction(target);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        this.topic.addSubscription(new subs.LambdaSubscription(target, this.props));
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SnsEventSource[_a] = { fqn: "aws-cdk-lib.aws_lambda_event_sources.SnsEventSource", version: "2.80.0" }, exports2.SnsEventSource = SnsEventSource;
  }
});

// node_modules/aws-cdk-lib/aws-lambda-event-sources/lib/sns-dlq.js
var require_sns_dlq = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda-event-sources/lib/sns-dlq.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SnsDlq = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var SnsDlq = class _SnsDlq {
      constructor(topic) {
        this.topic = topic;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sns_ITopic(topic);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SnsDlq), error;
        }
      }
      bind(_target, targetHandler) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_IEventSourceMapping(_target), jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_IFunction(targetHandler);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return this.topic.grantPublish(targetHandler), { destination: this.topic.topicArn };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SnsDlq[_a] = { fqn: "aws-cdk-lib.aws_lambda_event_sources.SnsDlq", version: "2.80.0" }, exports2.SnsDlq = SnsDlq;
  }
});

// node_modules/aws-cdk-lib/aws-lambda-event-sources/lib/sqs.js
var require_sqs7 = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda-event-sources/lib/sqs.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SqsEventSource = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core_1 = require_core2();
    var SqsEventSource = class _SqsEventSource {
      constructor(queue, props = {}) {
        this.queue = queue, this.props = props, this._eventSourceMappingId = void 0, this._eventSourceMappingArn = void 0;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sqs_IQueue(queue), jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_event_sources_SqsEventSourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SqsEventSource), error;
        }
        if (this.props.maxBatchingWindow !== void 0) {
          if (queue.fifo)
            throw new Error("Batching window is not supported for FIFO queues");
          if (!this.props.maxBatchingWindow.isUnresolved() && this.props.maxBatchingWindow.toSeconds() > 300)
            throw new Error(`Maximum batching window must be 300 seconds or less (given ${this.props.maxBatchingWindow.toHumanString()})`);
        }
        if (this.props.batchSize !== void 0 && !core_1.Token.isUnresolved(this.props.batchSize)) {
          if (this.props.maxBatchingWindow !== void 0 && (this.props.batchSize < 1 || this.props.batchSize > 1e4))
            throw new Error(`Maximum batch size must be between 1 and 10000 inclusive (given ${this.props.batchSize}) when batching window is specified.`);
          if (this.props.maxBatchingWindow === void 0 && (this.props.batchSize < 1 || this.props.batchSize > 10))
            throw new Error(`Maximum batch size must be between 1 and 10 inclusive (given ${this.props.batchSize}) when batching window is not specified.`);
        }
      }
      bind(target) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_IFunction(target);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        const eventSourceMapping = target.addEventSourceMapping(`SqsEventSource:${core_1.Names.nodeUniqueId(this.queue.node)}`, { batchSize: this.props.batchSize, maxBatchingWindow: this.props.maxBatchingWindow, maxConcurrency: this.props.maxConcurrency, reportBatchItemFailures: this.props.reportBatchItemFailures, enabled: this.props.enabled, eventSourceArn: this.queue.queueArn, filters: this.props.filters });
        this._eventSourceMappingId = eventSourceMapping.eventSourceMappingId, this._eventSourceMappingArn = eventSourceMapping.eventSourceMappingArn, target.role ? this.queue.grantConsumeMessages(target) : core_1.Annotations.of(target).addWarning(`Function '${target.node.path}' was imported without an IAM role so it was not granted access to consume messages from '${this.queue.node.path}'`);
      }
      get eventSourceMappingId() {
        if (!this._eventSourceMappingId)
          throw new Error("SqsEventSource is not yet bound to an event source mapping");
        return this._eventSourceMappingId;
      }
      get eventSourceMappingArn() {
        if (!this._eventSourceMappingArn)
          throw new Error("SqsEventSource is not yet bound to an event source mapping");
        return this._eventSourceMappingArn;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SqsEventSource[_a] = { fqn: "aws-cdk-lib.aws_lambda_event_sources.SqsEventSource", version: "2.80.0" }, exports2.SqsEventSource = SqsEventSource;
  }
});

// node_modules/aws-cdk-lib/aws-lambda-event-sources/lib/sqs-dlq.js
var require_sqs_dlq = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda-event-sources/lib/sqs-dlq.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SqsDlq = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var SqsDlq = class _SqsDlq {
      constructor(queue) {
        this.queue = queue;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sqs_IQueue(queue);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SqsDlq), error;
        }
      }
      bind(_target, targetHandler) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_IEventSourceMapping(_target), jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_IFunction(targetHandler);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return this.queue.grantSendMessages(targetHandler), { destination: this.queue.queueArn };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SqsDlq[_a] = { fqn: "aws-cdk-lib.aws_lambda_event_sources.SqsDlq", version: "2.80.0" }, exports2.SqsDlq = SqsDlq;
  }
});

// node_modules/aws-cdk-lib/aws-lambda-event-sources/lib/index.js
var require_lib173 = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda-event-sources/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_api4(), exports2), __exportStar(require_dynamodb3(), exports2), __exportStar(require_kafka2(), exports2), __exportStar(require_kinesis2(), exports2), __exportStar(require_s34(), exports2), __exportStar(require_sns6(), exports2), __exportStar(require_sns_dlq(), exports2), __exportStar(require_stream2(), exports2), __exportStar(require_sqs7(), exports2), __exportStar(require_sqs_dlq(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-lambda-event-sources/index.js
var require_aws_lambda_event_sources = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda-event-sources/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib173(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-lambda-nodejs/lib/util.js
var require_util19 = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda-nodejs/lib/util.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.getTsconfigCompilerOptions = exports2.extractDependencies = exports2.tryGetModuleVersionFromPkg = exports2.tryGetModuleVersionFromRequire = exports2.exec = exports2.findUpMultiple = exports2.findUp = exports2.callsites = void 0;
    var child_process_1 = require("child_process");
    var fs = require("fs");
    var path = require("path");
    function callsites() {
      const _prepareStackTrace = Error.prepareStackTrace;
      Error.prepareStackTrace = (_, stack2) => stack2;
      const stack = new Error().stack?.slice(1);
      return Error.prepareStackTrace = _prepareStackTrace, stack;
    }
    exports2.callsites = callsites;
    function findUp(name, directory = process.cwd()) {
      return findUpMultiple([name], directory)[0];
    }
    exports2.findUp = findUp;
    function findUpMultiple(names, directory = process.cwd()) {
      const absoluteDirectory = path.resolve(directory), files = [];
      for (const name of names) {
        const file = path.join(directory, name);
        fs.existsSync(file) && files.push(file);
      }
      if (files.length > 0)
        return files;
      const { root } = path.parse(absoluteDirectory);
      return absoluteDirectory === root ? [] : findUpMultiple(names, path.dirname(absoluteDirectory));
    }
    exports2.findUpMultiple = findUpMultiple;
    function exec(cmd, args, options) {
      const proc = (0, child_process_1.spawnSync)(cmd, args, options);
      if (proc.error)
        throw proc.error;
      if (proc.status !== 0)
        throw proc.stdout || proc.stderr ? new Error(`[Status ${proc.status}] stdout: ${proc.stdout?.toString().trim()}


stderr: ${proc.stderr?.toString().trim()}`) : new Error(`${cmd} ${args.join(" ")} ${options?.cwd ? `run in directory ${options.cwd}` : ""} exited with status ${proc.status}`);
      return proc;
    }
    exports2.exec = exec;
    function tryGetModuleVersionFromRequire(mod) {
      try {
        return require(`${mod}/package.json`).version;
      } catch {
        return;
      }
    }
    exports2.tryGetModuleVersionFromRequire = tryGetModuleVersionFromRequire;
    function tryGetModuleVersionFromPkg(mod, pkgJson, pkgPath) {
      const dependencies = { ...pkgJson.dependencies ?? {}, ...pkgJson.devDependencies ?? {}, ...pkgJson.peerDependencies ?? {} };
      if (!dependencies[mod])
        return;
      const fileMatch = dependencies[mod].match(/file:(.+)/);
      return fileMatch && !path.isAbsolute(fileMatch[1]) ? `file:${path.join(path.dirname(pkgPath), fileMatch[1])}` : dependencies[mod];
    }
    exports2.tryGetModuleVersionFromPkg = tryGetModuleVersionFromPkg;
    function extractDependencies(pkgPath, modules) {
      const dependencies = {}, pkgJson = require(pkgPath);
      for (const mod of modules) {
        const version = tryGetModuleVersionFromPkg(mod, pkgJson, pkgPath) ?? tryGetModuleVersionFromRequire(mod);
        if (!version)
          throw new Error(`Cannot extract version for module '${mod}'. Check that it's referenced in your package.json or installed.`);
        dependencies[mod] = version;
      }
      return dependencies;
    }
    exports2.extractDependencies = extractDependencies;
    function getTsconfigCompilerOptions(tsconfigPath) {
      const compilerOptions = extractTsConfig(tsconfigPath), excludedCompilerOptions = ["composite", "tsBuildInfoFile"], options = { ...compilerOptions, incremental: false, rootDir: "./", outDir: "./" };
      let compilerOptionsString = "";
      return Object.keys(options).sort().forEach((key) => {
        if (excludedCompilerOptions.includes(key))
          return;
        const value = options[key], option = "--" + key, type = typeof value;
        if (type === "boolean")
          value ? compilerOptionsString += option + " " : compilerOptionsString += option + " false ";
        else if (type === "string")
          compilerOptionsString += option + " " + value + " ";
        else if (type === "object")
          Array.isArray(value) && (compilerOptionsString += option + " " + value.join(",") + " ");
        else
          throw new Error(`Missing support for compilerOption: [${key}]: { ${type}, ${value}} 
`);
      }), compilerOptionsString.trim();
    }
    exports2.getTsconfigCompilerOptions = getTsconfigCompilerOptions;
    function extractTsConfig(tsconfigPath, previousCompilerOptions) {
      const { extends: extendedConfig, compilerOptions } = require(tsconfigPath), updatedCompilerOptions = { ...compilerOptions, ...previousCompilerOptions ?? {} };
      return extendedConfig ? extractTsConfig(path.resolve(tsconfigPath.replace(/[^\/]+$/, ""), extendedConfig), updatedCompilerOptions) : updatedCompilerOptions;
    }
  }
});

// node_modules/aws-cdk-lib/aws-lambda-nodejs/lib/package-installation.js
var require_package_installation = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda-nodejs/lib/package-installation.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PackageInstallation = void 0;
    var child_process_1 = require("child_process");
    var util_1 = require_util19();
    var PackageInstallation = class {
      static detect(module22) {
        try {
          const version = (0, util_1.tryGetModuleVersionFromRequire)(module22);
          if (version)
            return { isLocal: true, version };
          const proc = (0, child_process_1.spawnSync)(module22, ["--version"]);
          return proc.status === 0 && !proc.error ? { isLocal: false, version: proc.stdout.toString().trim() } : void 0;
        } catch {
          return;
        }
      }
    };
    exports2.PackageInstallation = PackageInstallation;
  }
});

// node_modules/aws-cdk-lib/aws-lambda-nodejs/lib/types.js
var require_types8 = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda-nodejs/lib/types.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Charset = exports2.SourceMapMode = exports2.LogLevel = exports2.OutputFormat = void 0;
    var OutputFormat;
    (function(OutputFormat2) {
      OutputFormat2.CJS = "cjs", OutputFormat2.ESM = "esm";
    })(OutputFormat = exports2.OutputFormat || (exports2.OutputFormat = {}));
    var LogLevel;
    (function(LogLevel2) {
      LogLevel2.INFO = "info", LogLevel2.WARNING = "warning", LogLevel2.ERROR = "error", LogLevel2.SILENT = "silent";
    })(LogLevel = exports2.LogLevel || (exports2.LogLevel = {}));
    var SourceMapMode;
    (function(SourceMapMode2) {
      SourceMapMode2.DEFAULT = "default", SourceMapMode2.EXTERNAL = "external", SourceMapMode2.INLINE = "inline", SourceMapMode2.BOTH = "both";
    })(SourceMapMode = exports2.SourceMapMode || (exports2.SourceMapMode = {}));
    var Charset;
    (function(Charset2) {
      Charset2.ASCII = "ascii", Charset2.UTF8 = "utf8";
    })(Charset = exports2.Charset || (exports2.Charset = {}));
  }
});

// node_modules/aws-cdk-lib/aws-lambda-nodejs/lib/package-manager.js
var require_package_manager = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda-nodejs/lib/package-manager.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PackageManager = exports2.LockFile = void 0;
    var os = require("os");
    var path = require("path");
    var types_1 = require_types8();
    var LockFile;
    (function(LockFile2) {
      LockFile2.NPM = "package-lock.json", LockFile2.YARN = "yarn.lock", LockFile2.PNPM = "pnpm-lock.yaml";
    })(LockFile = exports2.LockFile || (exports2.LockFile = {}));
    var PackageManager = class _PackageManager {
      static fromLockFile(lockFilePath, logLevel) {
        switch (path.basename(lockFilePath)) {
          case LockFile.YARN:
            return new _PackageManager({ lockFile: LockFile.YARN, installCommand: logLevel && logLevel !== types_1.LogLevel.INFO ? ["yarn", "install", "--no-immutable", "--silent"] : ["yarn", "install", "--no-immutable"], runCommand: ["yarn", "run"] });
          case LockFile.PNPM:
            return new _PackageManager({ lockFile: LockFile.PNPM, installCommand: logLevel && logLevel !== types_1.LogLevel.INFO ? ["pnpm", "install", "--reporter", "silent", "--config.node-linker=hoisted", "--config.package-import-method=clone-or-copy", "--no-prefer-frozen-lockfile"] : ["pnpm", "install", "--config.node-linker=hoisted", "--config.package-import-method=clone-or-copy", "--no-prefer-frozen-lockfile"], runCommand: ["pnpm", "exec"], argsSeparator: "--" });
          default:
            return new _PackageManager({ lockFile: LockFile.NPM, installCommand: logLevel ? ["npm", "ci", "--loglevel", logLevel] : ["npm", "ci"], runCommand: ["npx", "--no-install"] });
        }
      }
      constructor(props) {
        this.lockFile = props.lockFile, this.installCommand = props.installCommand, this.runCommand = props.runCommand, this.argsSeparator = props.argsSeparator;
      }
      runBinCommand(bin) {
        const [runCommand, ...runArgs] = this.runCommand;
        return [os.platform() === "win32" ? `${runCommand}.cmd` : runCommand, ...runArgs, ...this.argsSeparator ? [this.argsSeparator] : [], bin].join(" ");
      }
    };
    exports2.PackageManager = PackageManager;
  }
});

// node_modules/aws-cdk-lib/aws-lambda-nodejs/lib/bundling.js
var require_bundling2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda-nodejs/lib/bundling.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Bundling = void 0;
    var os = require("os");
    var path = require("path");
    var package_installation_1 = require_package_installation();
    var package_manager_1 = require_package_manager();
    var types_1 = require_types8();
    var util_1 = require_util19();
    var aws_lambda_1 = require_aws_lambda();
    var cdk = require_core2();
    var ESBUILD_MAJOR_VERSION = "0";
    var Bundling = class _Bundling {
      static bundle(options) {
        return aws_lambda_1.Code.fromAsset(options.projectRoot, { assetHash: options.assetHash, assetHashType: options.assetHash ? cdk.AssetHashType.CUSTOM : cdk.AssetHashType.OUTPUT, bundling: new _Bundling(options) });
      }
      static clearEsbuildInstallationCache() {
        this.esbuildInstallation = void 0;
      }
      static clearTscInstallationCache() {
        this.tscInstallation = void 0;
      }
      constructor(props) {
        if (this.props = props, this.packageManager = package_manager_1.PackageManager.fromLockFile(props.depsLockFilePath, props.logLevel), _Bundling.esbuildInstallation = _Bundling.esbuildInstallation ?? package_installation_1.PackageInstallation.detect("esbuild"), _Bundling.tscInstallation = _Bundling.tscInstallation ?? package_installation_1.PackageInstallation.detect("typescript"), this.projectRoot = props.projectRoot, this.relativeEntryPath = path.relative(this.projectRoot, path.resolve(props.entry)), this.relativeDepsLockFilePath = path.relative(this.projectRoot, path.resolve(props.depsLockFilePath)), this.relativeDepsLockFilePath.includes(".."))
          throw new Error(`Expected depsLockFilePath: ${props.depsLockFilePath} to be under projectRoot: ${this.projectRoot} (${this.relativeDepsLockFilePath})`);
        if (props.tsconfig && (this.relativeTsconfigPath = path.relative(this.projectRoot, path.resolve(props.tsconfig))), props.preCompilation && !/\.tsx?$/.test(props.entry))
          throw new Error("preCompilation can only be used with typescript files");
        if (props.runtime && props.format === types_1.OutputFormat.ESM && (props.runtime === aws_lambda_1.Runtime.NODEJS_10_X || props.runtime === aws_lambda_1.Runtime.NODEJS_12_X))
          throw new Error(`ECMAScript module output format is not supported by the ${props.runtime.name} runtime`);
        this.externals = [...props.externalModules ?? (isSdkV2Runtime(props.runtime) ? ["aws-sdk"] : ["@aws-sdk/*"]), ...props.nodeModules ?? []];
        const shouldBuildImage = props.forceDockerBundling || !_Bundling.esbuildInstallation;
        this.image = shouldBuildImage ? props.dockerImage ?? cdk.DockerImage.fromBuild(path.join(__dirname, "../lib"), { buildArgs: { ...props.buildArgs ?? {}, IMAGE: (props.runtime ?? aws_lambda_1.Runtime.NODEJS_14_X).bundlingImage.image, ESBUILD_VERSION: props.esbuildVersion ?? ESBUILD_MAJOR_VERSION }, platform: props.architecture.dockerPlatform }) : cdk.DockerImage.fromRegistry("dummy");
        const bundlingCommand = this.createBundlingCommand({ inputDir: cdk.AssetStaging.BUNDLING_INPUT_DIR, outputDir: cdk.AssetStaging.BUNDLING_OUTPUT_DIR, esbuildRunner: "esbuild", tscRunner: "tsc", osPlatform: "linux" });
        this.command = props.command ?? ["bash", "-c", bundlingCommand], this.environment = props.environment, this.workingDirectory = props.workingDirectory ?? "/", this.entrypoint = props.entrypoint, this.volumes = props.volumes, this.volumesFrom = props.volumesFrom, this.user = props.user, this.securityOpt = props.securityOpt, this.network = props.network, this.bundlingFileAccess = props.bundlingFileAccess, props.forceDockerBundling || (this.local = this.getLocalBundlingProvider());
      }
      createBundlingCommand(options) {
        const pathJoin = osPathJoin(options.osPlatform);
        let relativeEntryPath = pathJoin(options.inputDir, this.relativeEntryPath), tscCommand = "";
        if (this.props.preCompilation) {
          const tsconfig = this.props.tsconfig ?? (0, util_1.findUp)("tsconfig.json", path.dirname(this.props.entry));
          if (!tsconfig)
            throw new Error("Cannot find a `tsconfig.json` but `preCompilation` is set to `true`, please specify it via `tsconfig`");
          const compilerOptions = (0, util_1.getTsconfigCompilerOptions)(tsconfig);
          tscCommand = `${options.tscRunner} "${relativeEntryPath}" ${compilerOptions}`, relativeEntryPath = relativeEntryPath.replace(/\.ts(x?)$/, ".js$1");
        }
        const loaders = Object.entries(this.props.loader ?? {}), defines = Object.entries(this.props.define ?? {});
        if (this.props.sourceMap === false && this.props.sourceMapMode)
          throw new Error("sourceMapMode cannot be used when sourceMap is false");
        const sourceMapEnabled = this.props.sourceMapMode ?? this.props.sourceMap, sourceMapValue = (this.props.sourceMapMode ?? types_1.SourceMapMode.DEFAULT) === types_1.SourceMapMode.DEFAULT ? "" : `=${this.props.sourceMapMode}`, sourcesContent = this.props.sourcesContent ?? true, outFile = this.props.format === types_1.OutputFormat.ESM ? "index.mjs" : "index.js", esbuildCommand = [options.esbuildRunner, "--bundle", `"${relativeEntryPath}"`, `--target=${this.props.target ?? toTarget(this.props.runtime ?? aws_lambda_1.Runtime.NODEJS_14_X)}`, "--platform=node", ...this.props.format ? [`--format=${this.props.format}`] : [], `--outfile="${pathJoin(options.outputDir, outFile)}"`, ...this.props.minify ? ["--minify"] : [], ...sourceMapEnabled ? [`--sourcemap${sourceMapValue}`] : [], ...sourcesContent ? [] : [`--sources-content=${sourcesContent}`], ...this.externals.map((external) => `--external:${external}`), ...loaders.map(([ext, name]) => `--loader:${ext}=${name}`), ...defines.map(([key, value]) => `--define:${key}=${JSON.stringify(value)}`), ...this.props.logLevel ? [`--log-level=${this.props.logLevel}`] : [], ...this.props.keepNames ? ["--keep-names"] : [], ...this.relativeTsconfigPath ? [`--tsconfig=${pathJoin(options.inputDir, this.relativeTsconfigPath)}`] : [], ...this.props.metafile ? [`--metafile=${pathJoin(options.outputDir, "index.meta.json")}`] : [], ...this.props.banner ? [`--banner:js=${JSON.stringify(this.props.banner)}`] : [], ...this.props.footer ? [`--footer:js=${JSON.stringify(this.props.footer)}`] : [], ...this.props.charset ? [`--charset=${this.props.charset}`] : [], ...this.props.mainFields ? [`--main-fields=${this.props.mainFields.join(",")}`] : [], ...this.props.inject ? this.props.inject.map((i) => `--inject:${i}`) : [], ...this.props.esbuildArgs ? [toCliArgs(this.props.esbuildArgs)] : []];
        let depsCommand = "";
        if (this.props.nodeModules) {
          const pkgPath = (0, util_1.findUp)("package.json", path.dirname(this.props.entry));
          if (!pkgPath)
            throw new Error("Cannot find a `package.json` in this project. Using `nodeModules` requires a `package.json`.");
          const dependencies = (0, util_1.extractDependencies)(pkgPath, this.props.nodeModules), osCommand = new OsCommand(options.osPlatform), lockFilePath = pathJoin(options.inputDir, this.relativeDepsLockFilePath ?? this.packageManager.lockFile), isPnpm = this.packageManager.lockFile === package_manager_1.LockFile.PNPM;
          depsCommand = chain([isPnpm ? osCommand.write(pathJoin(options.outputDir, "pnpm-workspace.yaml"), "") : "", osCommand.writeJson(pathJoin(options.outputDir, "package.json"), { dependencies }), osCommand.copy(lockFilePath, pathJoin(options.outputDir, this.packageManager.lockFile)), osCommand.changeDirectory(options.outputDir), this.packageManager.installCommand.join(" "), isPnpm ? osCommand.remove(pathJoin(options.outputDir, "node_modules", ".modules.yaml")) : ""]);
        }
        return chain([...this.props.commandHooks?.beforeBundling(options.inputDir, options.outputDir) ?? [], tscCommand, esbuildCommand.join(" "), ...(this.props.nodeModules && this.props.commandHooks?.beforeInstall(options.inputDir, options.outputDir)) ?? [], depsCommand, ...this.props.commandHooks?.afterBundling(options.inputDir, options.outputDir) ?? []]);
      }
      getLocalBundlingProvider() {
        const osPlatform = os.platform(), createLocalCommand = (outputDir, esbuild, tsc) => this.createBundlingCommand({ inputDir: this.projectRoot, outputDir, esbuildRunner: esbuild.isLocal ? this.packageManager.runBinCommand("esbuild") : "esbuild", tscRunner: tsc && (tsc.isLocal ? this.packageManager.runBinCommand("tsc") : "tsc"), osPlatform }), environment = this.props.environment ?? {}, cwd = this.projectRoot;
        return { tryBundle(outputDir) {
          if (!_Bundling.esbuildInstallation)
            return process.stderr.write(`esbuild cannot run locally. Switching to Docker bundling.
`), false;
          if (!_Bundling.esbuildInstallation.version.startsWith(`${ESBUILD_MAJOR_VERSION}.`))
            throw new Error(`Expected esbuild version ${ESBUILD_MAJOR_VERSION}.x but got ${_Bundling.esbuildInstallation.version}`);
          const localCommand = createLocalCommand(outputDir, _Bundling.esbuildInstallation, _Bundling.tscInstallation);
          return (0, util_1.exec)(osPlatform === "win32" ? "cmd" : "bash", [osPlatform === "win32" ? "/c" : "-c", localCommand], { env: { ...process.env, ...environment }, stdio: ["ignore", process.stderr, "inherit"], cwd, windowsVerbatimArguments: osPlatform === "win32" }), true;
        } };
      }
    };
    exports2.Bundling = Bundling;
    var OsCommand = class {
      constructor(osPlatform) {
        this.osPlatform = osPlatform;
      }
      write(filePath, data) {
        return this.osPlatform === "win32" ? data ? `echo ^${data}^ > "${filePath}"` : `echo. > "${filePath}"` : `echo '${data}' > "${filePath}"`;
      }
      writeJson(filePath, data) {
        const stringifiedData = JSON.stringify(data);
        return this.write(filePath, stringifiedData);
      }
      copy(src, dest) {
        return this.osPlatform === "win32" ? `copy "${src}" "${dest}"` : `cp "${src}" "${dest}"`;
      }
      changeDirectory(dir) {
        return `cd "${dir}"`;
      }
      remove(filePath) {
        return this.osPlatform === "win32" ? `del "${filePath}"` : `rm "${filePath}"`;
      }
    };
    function chain(commands) {
      return commands.filter((c) => !!c).join(" && ");
    }
    function osPathJoin(platform) {
      return function(...paths) {
        const joined = path.join(...paths);
        return os.platform() === "win32" && platform !== "win32" ? joined.replace(/\\/g, "/") : joined;
      };
    }
    function toTarget(runtime) {
      const match = runtime.name.match(/nodejs(\d+)/);
      if (!match)
        throw new Error("Cannot extract version from runtime.");
      return `node${match[1]}`;
    }
    function toCliArgs(esbuildArgs) {
      const args = [];
      for (const [key, value] of Object.entries(esbuildArgs))
        value === true || value === "" ? args.push(key) : value && args.push(`${key}="${value}"`);
      return args.join(" ");
    }
    function isSdkV2Runtime(runtime) {
      const sdkV2RuntimeList = [aws_lambda_1.Runtime.NODEJS, aws_lambda_1.Runtime.NODEJS_4_3, aws_lambda_1.Runtime.NODEJS_6_10, aws_lambda_1.Runtime.NODEJS_8_10, aws_lambda_1.Runtime.NODEJS_10_X, aws_lambda_1.Runtime.NODEJS_12_X, aws_lambda_1.Runtime.NODEJS_14_X, aws_lambda_1.Runtime.NODEJS_16_X];
      return runtime ? sdkV2RuntimeList.some((r) => r.family === runtime.family && r.name === runtime.name) : true;
    }
  }
});

// node_modules/aws-cdk-lib/aws-lambda-nodejs/lib/function.js
var require_function3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda-nodejs/lib/function.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.NodejsFunction = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var fs = require("fs");
    var path = require("path");
    var bundling_1 = require_bundling2();
    var package_manager_1 = require_package_manager();
    var util_1 = require_util19();
    var aws_lambda_1 = require_aws_lambda();
    var lambda2 = require_aws_lambda();
    var custom_resources_1 = require_custom_resources();
    var NodejsFunction = class _NodejsFunction extends lambda2.Function {
      constructor(scope, id, props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_nodejs_NodejsFunctionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _NodejsFunction), error;
        }
        if (props.runtime && props.runtime.family !== lambda2.RuntimeFamily.NODEJS)
          throw new Error("Only `NODEJS` runtimes are supported.");
        const entry = path.resolve(findEntry(id, props.entry)), handler2 = props.handler ?? "handler", architecture = props.architecture ?? aws_lambda_1.Architecture.X86_64, depsLockFilePath = findLockFile(props.depsLockFilePath), projectRoot = props.projectRoot ?? path.dirname(depsLockFilePath);
        super(scope, id, { ...props, runtime: props.runtime ?? (0, custom_resources_1.builtInCustomResourceNodeRuntime)(scope), code: bundling_1.Bundling.bundle({ ...props.bundling ?? {}, entry, runtime: props.runtime, architecture, depsLockFilePath, projectRoot }), handler: handler2.indexOf(".") !== -1 ? `${handler2}` : `index.${handler2}` }), (props.awsSdkConnectionReuse ?? true) && this.addEnvironment("AWS_NODEJS_CONNECTION_REUSE_ENABLED", "1", { removeInEdge: true });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, NodejsFunction[_a] = { fqn: "aws-cdk-lib.aws_lambda_nodejs.NodejsFunction", version: "2.80.0" }, exports2.NodejsFunction = NodejsFunction;
    function findLockFile(depsLockFilePath) {
      if (depsLockFilePath) {
        if (!fs.existsSync(depsLockFilePath))
          throw new Error(`Lock file at ${depsLockFilePath} doesn't exist`);
        if (!fs.statSync(depsLockFilePath).isFile())
          throw new Error("`depsLockFilePath` should point to a file");
        return path.resolve(depsLockFilePath);
      }
      const lockFiles = (0, util_1.findUpMultiple)([package_manager_1.LockFile.PNPM, package_manager_1.LockFile.YARN, package_manager_1.LockFile.NPM]);
      if (lockFiles.length === 0)
        throw new Error("Cannot find a package lock file (`pnpm-lock.yaml`, `yarn.lock` or `package-lock.json`). Please specify it with `depsLockFilePath`.");
      if (lockFiles.length > 1)
        throw new Error(`Multiple package lock files found: ${lockFiles.join(", ")}. Please specify the desired one with \`depsLockFilePath\`.`);
      return lockFiles[0];
    }
    function findEntry(id, entry) {
      if (entry) {
        if (!/\.(jsx?|tsx?|mjs)$/.test(entry))
          throw new Error("Only JavaScript or TypeScript entry files are supported.");
        if (!fs.existsSync(entry))
          throw new Error(`Cannot find entry file at ${entry}`);
        return entry;
      }
      const definingFile = findDefiningFile(), extname = path.extname(definingFile), tsHandlerFile = definingFile.replace(new RegExp(`${extname}$`), `.${id}.ts`);
      if (fs.existsSync(tsHandlerFile))
        return tsHandlerFile;
      const jsHandlerFile = definingFile.replace(new RegExp(`${extname}$`), `.${id}.js`);
      if (fs.existsSync(jsHandlerFile))
        return jsHandlerFile;
      const mjsHandlerFile = definingFile.replace(new RegExp(`${extname}$`), `.${id}.mjs`);
      if (fs.existsSync(mjsHandlerFile))
        return mjsHandlerFile;
      throw new Error(`Cannot find handler file ${tsHandlerFile}, ${jsHandlerFile} or ${mjsHandlerFile}`);
    }
    function findDefiningFile() {
      let definingIndex;
      const sites = (0, util_1.callsites)();
      for (const [index, site] of sites.entries())
        if (site.getFunctionName() === "NodejsFunction") {
          definingIndex = index + 1;
          break;
        }
      if (!definingIndex || !sites[definingIndex])
        throw new Error("Cannot find defining file.");
      return sites[definingIndex].getFileName();
    }
  }
});

// node_modules/aws-cdk-lib/aws-lambda-nodejs/lib/index.js
var require_lib174 = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda-nodejs/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_function3(), exports2), __exportStar(require_types8(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-lambda-nodejs/index.js
var require_aws_lambda_nodejs = __commonJS({
  "node_modules/aws-cdk-lib/aws-lambda-nodejs/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib174(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-lex/lib/lex.generated.js
var require_lex_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-lex/lib/lex.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnResourcePolicy = exports2.CfnBotVersion = exports2.CfnBotAlias = exports2.CfnBot = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnBotPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoBuildBotLocales", cdk.validateBoolean)(properties.autoBuildBotLocales)), errors.collect(cdk.propertyValidator("botFileS3Location", CfnBot_S3LocationPropertyValidator)(properties.botFileS3Location)), errors.collect(cdk.propertyValidator("botLocales", cdk.listValidator(CfnBot_BotLocalePropertyValidator))(properties.botLocales)), errors.collect(cdk.propertyValidator("botTags", cdk.listValidator(cdk.validateCfnTag))(properties.botTags)), errors.collect(cdk.propertyValidator("dataPrivacy", cdk.requiredValidator)(properties.dataPrivacy)), errors.collect(cdk.propertyValidator("dataPrivacy", cdk.validateObject)(properties.dataPrivacy)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("idleSessionTtlInSeconds", cdk.requiredValidator)(properties.idleSessionTtlInSeconds)), errors.collect(cdk.propertyValidator("idleSessionTtlInSeconds", cdk.validateNumber)(properties.idleSessionTtlInSeconds)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("testBotAliasSettings", CfnBot_TestBotAliasSettingsPropertyValidator)(properties.testBotAliasSettings)), errors.collect(cdk.propertyValidator("testBotAliasTags", cdk.listValidator(cdk.validateCfnTag))(properties.testBotAliasTags)), errors.wrap('supplied properties not correct for "CfnBotProps"');
    }
    function cfnBotPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBotPropsValidator(properties).assertSuccess(), { DataPrivacy: cdk.objectToCloudFormation(properties.dataPrivacy), IdleSessionTTLInSeconds: cdk.numberToCloudFormation(properties.idleSessionTtlInSeconds), Name: cdk.stringToCloudFormation(properties.name), RoleArn: cdk.stringToCloudFormation(properties.roleArn), AutoBuildBotLocales: cdk.booleanToCloudFormation(properties.autoBuildBotLocales), BotFileS3Location: cfnBotS3LocationPropertyToCloudFormation(properties.botFileS3Location), BotLocales: cdk.listMapper(cfnBotBotLocalePropertyToCloudFormation)(properties.botLocales), BotTags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.botTags), Description: cdk.stringToCloudFormation(properties.description), TestBotAliasSettings: cfnBotTestBotAliasSettingsPropertyToCloudFormation(properties.testBotAliasSettings), TestBotAliasTags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.testBotAliasTags) }) : properties;
    }
    function CfnBotPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataPrivacy", "DataPrivacy", cfn_parse.FromCloudFormation.getAny(properties.DataPrivacy)), ret.addPropertyResult("idleSessionTtlInSeconds", "IdleSessionTTLInSeconds", cfn_parse.FromCloudFormation.getNumber(properties.IdleSessionTTLInSeconds)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("autoBuildBotLocales", "AutoBuildBotLocales", properties.AutoBuildBotLocales != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AutoBuildBotLocales) : void 0), ret.addPropertyResult("botFileS3Location", "BotFileS3Location", properties.BotFileS3Location != null ? CfnBotS3LocationPropertyFromCloudFormation(properties.BotFileS3Location) : void 0), ret.addPropertyResult("botLocales", "BotLocales", properties.BotLocales != null ? cfn_parse.FromCloudFormation.getArray(CfnBotBotLocalePropertyFromCloudFormation)(properties.BotLocales) : void 0), ret.addPropertyResult("botTags", "BotTags", properties.BotTags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.BotTags) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("testBotAliasSettings", "TestBotAliasSettings", properties.TestBotAliasSettings != null ? CfnBotTestBotAliasSettingsPropertyFromCloudFormation(properties.TestBotAliasSettings) : void 0), ret.addPropertyResult("testBotAliasTags", "TestBotAliasTags", properties.TestBotAliasTags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.TestBotAliasTags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnBot = class _CfnBot extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnBotPropsFromCloudFormation(resourceProperties), ret = new _CfnBot(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnBot.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lex_CfnBotProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnBot), error;
        }
        cdk.requireProperty(props, "dataPrivacy", this), cdk.requireProperty(props, "idleSessionTtlInSeconds", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "roleArn", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.dataPrivacy = props.dataPrivacy, this.idleSessionTtlInSeconds = props.idleSessionTtlInSeconds, this.name = props.name, this.roleArn = props.roleArn, this.autoBuildBotLocales = props.autoBuildBotLocales, this.botFileS3Location = props.botFileS3Location, this.botLocales = props.botLocales, this.botTags = props.botTags, this.description = props.description, this.testBotAliasSettings = props.testBotAliasSettings, this.testBotAliasTags = props.testBotAliasTags;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnBot.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { dataPrivacy: this.dataPrivacy, idleSessionTtlInSeconds: this.idleSessionTtlInSeconds, name: this.name, roleArn: this.roleArn, autoBuildBotLocales: this.autoBuildBotLocales, botFileS3Location: this.botFileS3Location, botLocales: this.botLocales, botTags: this.botTags, description: this.description, testBotAliasSettings: this.testBotAliasSettings, testBotAliasTags: this.testBotAliasTags };
      }
      renderProperties(props) {
        return cfnBotPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnBot[_a] = { fqn: "aws-cdk-lib.aws_lex.CfnBot", version: "2.80.0" }, CfnBot.CFN_RESOURCE_TYPE_NAME = "AWS::Lex::Bot", exports2.CfnBot = CfnBot;
    function CfnBot_AdvancedRecognitionSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("audioRecognitionStrategy", cdk.validateString)(properties.audioRecognitionStrategy)), errors.wrap('supplied properties not correct for "AdvancedRecognitionSettingProperty"');
    }
    function cfnBotAdvancedRecognitionSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_AdvancedRecognitionSettingPropertyValidator(properties).assertSuccess(), { AudioRecognitionStrategy: cdk.stringToCloudFormation(properties.audioRecognitionStrategy) }) : properties;
    }
    function CfnBotAdvancedRecognitionSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("audioRecognitionStrategy", "AudioRecognitionStrategy", properties.AudioRecognitionStrategy != null ? cfn_parse.FromCloudFormation.getString(properties.AudioRecognitionStrategy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_AllowedInputTypesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowAudioInput", cdk.requiredValidator)(properties.allowAudioInput)), errors.collect(cdk.propertyValidator("allowAudioInput", cdk.validateBoolean)(properties.allowAudioInput)), errors.collect(cdk.propertyValidator("allowDtmfInput", cdk.requiredValidator)(properties.allowDtmfInput)), errors.collect(cdk.propertyValidator("allowDtmfInput", cdk.validateBoolean)(properties.allowDtmfInput)), errors.wrap('supplied properties not correct for "AllowedInputTypesProperty"');
    }
    function cfnBotAllowedInputTypesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_AllowedInputTypesPropertyValidator(properties).assertSuccess(), { AllowAudioInput: cdk.booleanToCloudFormation(properties.allowAudioInput), AllowDTMFInput: cdk.booleanToCloudFormation(properties.allowDtmfInput) }) : properties;
    }
    function CfnBotAllowedInputTypesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowAudioInput", "AllowAudioInput", cfn_parse.FromCloudFormation.getBoolean(properties.AllowAudioInput)), ret.addPropertyResult("allowDtmfInput", "AllowDTMFInput", cfn_parse.FromCloudFormation.getBoolean(properties.AllowDTMFInput)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_AudioAndDTMFInputSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("audioSpecification", CfnBot_AudioSpecificationPropertyValidator)(properties.audioSpecification)), errors.collect(cdk.propertyValidator("dtmfSpecification", CfnBot_DTMFSpecificationPropertyValidator)(properties.dtmfSpecification)), errors.collect(cdk.propertyValidator("startTimeoutMs", cdk.requiredValidator)(properties.startTimeoutMs)), errors.collect(cdk.propertyValidator("startTimeoutMs", cdk.validateNumber)(properties.startTimeoutMs)), errors.wrap('supplied properties not correct for "AudioAndDTMFInputSpecificationProperty"');
    }
    function cfnBotAudioAndDTMFInputSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_AudioAndDTMFInputSpecificationPropertyValidator(properties).assertSuccess(), { AudioSpecification: cfnBotAudioSpecificationPropertyToCloudFormation(properties.audioSpecification), DTMFSpecification: cfnBotDTMFSpecificationPropertyToCloudFormation(properties.dtmfSpecification), StartTimeoutMs: cdk.numberToCloudFormation(properties.startTimeoutMs) }) : properties;
    }
    function CfnBotAudioAndDTMFInputSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("audioSpecification", "AudioSpecification", properties.AudioSpecification != null ? CfnBotAudioSpecificationPropertyFromCloudFormation(properties.AudioSpecification) : void 0), ret.addPropertyResult("dtmfSpecification", "DTMFSpecification", properties.DTMFSpecification != null ? CfnBotDTMFSpecificationPropertyFromCloudFormation(properties.DTMFSpecification) : void 0), ret.addPropertyResult("startTimeoutMs", "StartTimeoutMs", cfn_parse.FromCloudFormation.getNumber(properties.StartTimeoutMs)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_AudioLogDestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3Bucket", cdk.requiredValidator)(properties.s3Bucket)), errors.collect(cdk.propertyValidator("s3Bucket", CfnBot_S3BucketLogDestinationPropertyValidator)(properties.s3Bucket)), errors.wrap('supplied properties not correct for "AudioLogDestinationProperty"');
    }
    function cfnBotAudioLogDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_AudioLogDestinationPropertyValidator(properties).assertSuccess(), { S3Bucket: cfnBotS3BucketLogDestinationPropertyToCloudFormation(properties.s3Bucket) }) : properties;
    }
    function CfnBotAudioLogDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Bucket", "S3Bucket", CfnBotS3BucketLogDestinationPropertyFromCloudFormation(properties.S3Bucket)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_AudioLogSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destination", cdk.requiredValidator)(properties.destination)), errors.collect(cdk.propertyValidator("destination", CfnBot_AudioLogDestinationPropertyValidator)(properties.destination)), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "AudioLogSettingProperty"');
    }
    function cfnBotAudioLogSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_AudioLogSettingPropertyValidator(properties).assertSuccess(), { Destination: cfnBotAudioLogDestinationPropertyToCloudFormation(properties.destination), Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnBotAudioLogSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destination", "Destination", CfnBotAudioLogDestinationPropertyFromCloudFormation(properties.Destination)), ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_AudioSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endTimeoutMs", cdk.requiredValidator)(properties.endTimeoutMs)), errors.collect(cdk.propertyValidator("endTimeoutMs", cdk.validateNumber)(properties.endTimeoutMs)), errors.collect(cdk.propertyValidator("maxLengthMs", cdk.requiredValidator)(properties.maxLengthMs)), errors.collect(cdk.propertyValidator("maxLengthMs", cdk.validateNumber)(properties.maxLengthMs)), errors.wrap('supplied properties not correct for "AudioSpecificationProperty"');
    }
    function cfnBotAudioSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_AudioSpecificationPropertyValidator(properties).assertSuccess(), { EndTimeoutMs: cdk.numberToCloudFormation(properties.endTimeoutMs), MaxLengthMs: cdk.numberToCloudFormation(properties.maxLengthMs) }) : properties;
    }
    function CfnBotAudioSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endTimeoutMs", "EndTimeoutMs", cfn_parse.FromCloudFormation.getNumber(properties.EndTimeoutMs)), ret.addPropertyResult("maxLengthMs", "MaxLengthMs", cfn_parse.FromCloudFormation.getNumber(properties.MaxLengthMs)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_BotAliasLocaleSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("codeHookSpecification", CfnBot_CodeHookSpecificationPropertyValidator)(properties.codeHookSpecification)), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "BotAliasLocaleSettingsProperty"');
    }
    function cfnBotBotAliasLocaleSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_BotAliasLocaleSettingsPropertyValidator(properties).assertSuccess(), { CodeHookSpecification: cfnBotCodeHookSpecificationPropertyToCloudFormation(properties.codeHookSpecification), Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnBotBotAliasLocaleSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("codeHookSpecification", "CodeHookSpecification", properties.CodeHookSpecification != null ? CfnBotCodeHookSpecificationPropertyFromCloudFormation(properties.CodeHookSpecification) : void 0), ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_BotAliasLocaleSettingsItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("botAliasLocaleSetting", cdk.requiredValidator)(properties.botAliasLocaleSetting)), errors.collect(cdk.propertyValidator("botAliasLocaleSetting", CfnBot_BotAliasLocaleSettingsPropertyValidator)(properties.botAliasLocaleSetting)), errors.collect(cdk.propertyValidator("localeId", cdk.requiredValidator)(properties.localeId)), errors.collect(cdk.propertyValidator("localeId", cdk.validateString)(properties.localeId)), errors.wrap('supplied properties not correct for "BotAliasLocaleSettingsItemProperty"');
    }
    function cfnBotBotAliasLocaleSettingsItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_BotAliasLocaleSettingsItemPropertyValidator(properties).assertSuccess(), { BotAliasLocaleSetting: cfnBotBotAliasLocaleSettingsPropertyToCloudFormation(properties.botAliasLocaleSetting), LocaleId: cdk.stringToCloudFormation(properties.localeId) }) : properties;
    }
    function CfnBotBotAliasLocaleSettingsItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("botAliasLocaleSetting", "BotAliasLocaleSetting", CfnBotBotAliasLocaleSettingsPropertyFromCloudFormation(properties.BotAliasLocaleSetting)), ret.addPropertyResult("localeId", "LocaleId", cfn_parse.FromCloudFormation.getString(properties.LocaleId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_BotLocalePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customVocabulary", CfnBot_CustomVocabularyPropertyValidator)(properties.customVocabulary)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("intents", cdk.listValidator(CfnBot_IntentPropertyValidator))(properties.intents)), errors.collect(cdk.propertyValidator("localeId", cdk.requiredValidator)(properties.localeId)), errors.collect(cdk.propertyValidator("localeId", cdk.validateString)(properties.localeId)), errors.collect(cdk.propertyValidator("nluConfidenceThreshold", cdk.requiredValidator)(properties.nluConfidenceThreshold)), errors.collect(cdk.propertyValidator("nluConfidenceThreshold", cdk.validateNumber)(properties.nluConfidenceThreshold)), errors.collect(cdk.propertyValidator("slotTypes", cdk.listValidator(CfnBot_SlotTypePropertyValidator))(properties.slotTypes)), errors.collect(cdk.propertyValidator("voiceSettings", CfnBot_VoiceSettingsPropertyValidator)(properties.voiceSettings)), errors.wrap('supplied properties not correct for "BotLocaleProperty"');
    }
    function cfnBotBotLocalePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_BotLocalePropertyValidator(properties).assertSuccess(), { CustomVocabulary: cfnBotCustomVocabularyPropertyToCloudFormation(properties.customVocabulary), Description: cdk.stringToCloudFormation(properties.description), Intents: cdk.listMapper(cfnBotIntentPropertyToCloudFormation)(properties.intents), LocaleId: cdk.stringToCloudFormation(properties.localeId), NluConfidenceThreshold: cdk.numberToCloudFormation(properties.nluConfidenceThreshold), SlotTypes: cdk.listMapper(cfnBotSlotTypePropertyToCloudFormation)(properties.slotTypes), VoiceSettings: cfnBotVoiceSettingsPropertyToCloudFormation(properties.voiceSettings) }) : properties;
    }
    function CfnBotBotLocalePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customVocabulary", "CustomVocabulary", properties.CustomVocabulary != null ? CfnBotCustomVocabularyPropertyFromCloudFormation(properties.CustomVocabulary) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("intents", "Intents", properties.Intents != null ? cfn_parse.FromCloudFormation.getArray(CfnBotIntentPropertyFromCloudFormation)(properties.Intents) : void 0), ret.addPropertyResult("localeId", "LocaleId", cfn_parse.FromCloudFormation.getString(properties.LocaleId)), ret.addPropertyResult("nluConfidenceThreshold", "NluConfidenceThreshold", cfn_parse.FromCloudFormation.getNumber(properties.NluConfidenceThreshold)), ret.addPropertyResult("slotTypes", "SlotTypes", properties.SlotTypes != null ? cfn_parse.FromCloudFormation.getArray(CfnBotSlotTypePropertyFromCloudFormation)(properties.SlotTypes) : void 0), ret.addPropertyResult("voiceSettings", "VoiceSettings", properties.VoiceSettings != null ? CfnBotVoiceSettingsPropertyFromCloudFormation(properties.VoiceSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_ButtonPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("text", cdk.requiredValidator)(properties.text)), errors.collect(cdk.propertyValidator("text", cdk.validateString)(properties.text)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "ButtonProperty"');
    }
    function cfnBotButtonPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_ButtonPropertyValidator(properties).assertSuccess(), { Text: cdk.stringToCloudFormation(properties.text), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnBotButtonPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("text", "Text", cfn_parse.FromCloudFormation.getString(properties.Text)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_CloudWatchLogGroupLogDestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchLogGroupArn", cdk.requiredValidator)(properties.cloudWatchLogGroupArn)), errors.collect(cdk.propertyValidator("cloudWatchLogGroupArn", cdk.validateString)(properties.cloudWatchLogGroupArn)), errors.collect(cdk.propertyValidator("logPrefix", cdk.requiredValidator)(properties.logPrefix)), errors.collect(cdk.propertyValidator("logPrefix", cdk.validateString)(properties.logPrefix)), errors.wrap('supplied properties not correct for "CloudWatchLogGroupLogDestinationProperty"');
    }
    function cfnBotCloudWatchLogGroupLogDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_CloudWatchLogGroupLogDestinationPropertyValidator(properties).assertSuccess(), { CloudWatchLogGroupArn: cdk.stringToCloudFormation(properties.cloudWatchLogGroupArn), LogPrefix: cdk.stringToCloudFormation(properties.logPrefix) }) : properties;
    }
    function CfnBotCloudWatchLogGroupLogDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchLogGroupArn", "CloudWatchLogGroupArn", cfn_parse.FromCloudFormation.getString(properties.CloudWatchLogGroupArn)), ret.addPropertyResult("logPrefix", "LogPrefix", cfn_parse.FromCloudFormation.getString(properties.LogPrefix)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_CodeHookSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("lambdaCodeHook", cdk.requiredValidator)(properties.lambdaCodeHook)), errors.collect(cdk.propertyValidator("lambdaCodeHook", CfnBot_LambdaCodeHookPropertyValidator)(properties.lambdaCodeHook)), errors.wrap('supplied properties not correct for "CodeHookSpecificationProperty"');
    }
    function cfnBotCodeHookSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_CodeHookSpecificationPropertyValidator(properties).assertSuccess(), { LambdaCodeHook: cfnBotLambdaCodeHookPropertyToCloudFormation(properties.lambdaCodeHook) }) : properties;
    }
    function CfnBotCodeHookSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("lambdaCodeHook", "LambdaCodeHook", CfnBotLambdaCodeHookPropertyFromCloudFormation(properties.LambdaCodeHook)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_ConditionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("expressionString", cdk.requiredValidator)(properties.expressionString)), errors.collect(cdk.propertyValidator("expressionString", cdk.validateString)(properties.expressionString)), errors.wrap('supplied properties not correct for "ConditionProperty"');
    }
    function cfnBotConditionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_ConditionPropertyValidator(properties).assertSuccess(), { ExpressionString: cdk.stringToCloudFormation(properties.expressionString) }) : properties;
    }
    function CfnBotConditionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("expressionString", "ExpressionString", cfn_parse.FromCloudFormation.getString(properties.ExpressionString)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_ConditionalBranchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("condition", cdk.requiredValidator)(properties.condition)), errors.collect(cdk.propertyValidator("condition", CfnBot_ConditionPropertyValidator)(properties.condition)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("nextStep", cdk.requiredValidator)(properties.nextStep)), errors.collect(cdk.propertyValidator("nextStep", CfnBot_DialogStatePropertyValidator)(properties.nextStep)), errors.collect(cdk.propertyValidator("response", CfnBot_ResponseSpecificationPropertyValidator)(properties.response)), errors.wrap('supplied properties not correct for "ConditionalBranchProperty"');
    }
    function cfnBotConditionalBranchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_ConditionalBranchPropertyValidator(properties).assertSuccess(), { Condition: cfnBotConditionPropertyToCloudFormation(properties.condition), Name: cdk.stringToCloudFormation(properties.name), NextStep: cfnBotDialogStatePropertyToCloudFormation(properties.nextStep), Response: cfnBotResponseSpecificationPropertyToCloudFormation(properties.response) }) : properties;
    }
    function CfnBotConditionalBranchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("condition", "Condition", CfnBotConditionPropertyFromCloudFormation(properties.Condition)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("nextStep", "NextStep", CfnBotDialogStatePropertyFromCloudFormation(properties.NextStep)), ret.addPropertyResult("response", "Response", properties.Response != null ? CfnBotResponseSpecificationPropertyFromCloudFormation(properties.Response) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_ConditionalSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("conditionalBranches", cdk.requiredValidator)(properties.conditionalBranches)), errors.collect(cdk.propertyValidator("conditionalBranches", cdk.listValidator(CfnBot_ConditionalBranchPropertyValidator))(properties.conditionalBranches)), errors.collect(cdk.propertyValidator("defaultBranch", cdk.requiredValidator)(properties.defaultBranch)), errors.collect(cdk.propertyValidator("defaultBranch", CfnBot_DefaultConditionalBranchPropertyValidator)(properties.defaultBranch)), errors.collect(cdk.propertyValidator("isActive", cdk.requiredValidator)(properties.isActive)), errors.collect(cdk.propertyValidator("isActive", cdk.validateBoolean)(properties.isActive)), errors.wrap('supplied properties not correct for "ConditionalSpecificationProperty"');
    }
    function cfnBotConditionalSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_ConditionalSpecificationPropertyValidator(properties).assertSuccess(), { ConditionalBranches: cdk.listMapper(cfnBotConditionalBranchPropertyToCloudFormation)(properties.conditionalBranches), DefaultBranch: cfnBotDefaultConditionalBranchPropertyToCloudFormation(properties.defaultBranch), IsActive: cdk.booleanToCloudFormation(properties.isActive) }) : properties;
    }
    function CfnBotConditionalSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("conditionalBranches", "ConditionalBranches", cfn_parse.FromCloudFormation.getArray(CfnBotConditionalBranchPropertyFromCloudFormation)(properties.ConditionalBranches)), ret.addPropertyResult("defaultBranch", "DefaultBranch", CfnBotDefaultConditionalBranchPropertyFromCloudFormation(properties.DefaultBranch)), ret.addPropertyResult("isActive", "IsActive", cfn_parse.FromCloudFormation.getBoolean(properties.IsActive)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_ConversationLogSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("audioLogSettings", cdk.listValidator(CfnBot_AudioLogSettingPropertyValidator))(properties.audioLogSettings)), errors.collect(cdk.propertyValidator("textLogSettings", cdk.listValidator(CfnBot_TextLogSettingPropertyValidator))(properties.textLogSettings)), errors.wrap('supplied properties not correct for "ConversationLogSettingsProperty"');
    }
    function cfnBotConversationLogSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_ConversationLogSettingsPropertyValidator(properties).assertSuccess(), { AudioLogSettings: cdk.listMapper(cfnBotAudioLogSettingPropertyToCloudFormation)(properties.audioLogSettings), TextLogSettings: cdk.listMapper(cfnBotTextLogSettingPropertyToCloudFormation)(properties.textLogSettings) }) : properties;
    }
    function CfnBotConversationLogSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("audioLogSettings", "AudioLogSettings", properties.AudioLogSettings != null ? cfn_parse.FromCloudFormation.getArray(CfnBotAudioLogSettingPropertyFromCloudFormation)(properties.AudioLogSettings) : void 0), ret.addPropertyResult("textLogSettings", "TextLogSettings", properties.TextLogSettings != null ? cfn_parse.FromCloudFormation.getArray(CfnBotTextLogSettingPropertyFromCloudFormation)(properties.TextLogSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_CustomPayloadPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "CustomPayloadProperty"');
    }
    function cfnBotCustomPayloadPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_CustomPayloadPropertyValidator(properties).assertSuccess(), { Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnBotCustomPayloadPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_CustomVocabularyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customVocabularyItems", cdk.requiredValidator)(properties.customVocabularyItems)), errors.collect(cdk.propertyValidator("customVocabularyItems", cdk.listValidator(CfnBot_CustomVocabularyItemPropertyValidator))(properties.customVocabularyItems)), errors.wrap('supplied properties not correct for "CustomVocabularyProperty"');
    }
    function cfnBotCustomVocabularyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_CustomVocabularyPropertyValidator(properties).assertSuccess(), { CustomVocabularyItems: cdk.listMapper(cfnBotCustomVocabularyItemPropertyToCloudFormation)(properties.customVocabularyItems) }) : properties;
    }
    function CfnBotCustomVocabularyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customVocabularyItems", "CustomVocabularyItems", cfn_parse.FromCloudFormation.getArray(CfnBotCustomVocabularyItemPropertyFromCloudFormation)(properties.CustomVocabularyItems)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_CustomVocabularyItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("displayAs", cdk.validateString)(properties.displayAs)), errors.collect(cdk.propertyValidator("phrase", cdk.requiredValidator)(properties.phrase)), errors.collect(cdk.propertyValidator("phrase", cdk.validateString)(properties.phrase)), errors.collect(cdk.propertyValidator("weight", cdk.validateNumber)(properties.weight)), errors.wrap('supplied properties not correct for "CustomVocabularyItemProperty"');
    }
    function cfnBotCustomVocabularyItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_CustomVocabularyItemPropertyValidator(properties).assertSuccess(), { DisplayAs: cdk.stringToCloudFormation(properties.displayAs), Phrase: cdk.stringToCloudFormation(properties.phrase), Weight: cdk.numberToCloudFormation(properties.weight) }) : properties;
    }
    function CfnBotCustomVocabularyItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("displayAs", "DisplayAs", properties.DisplayAs != null ? cfn_parse.FromCloudFormation.getString(properties.DisplayAs) : void 0), ret.addPropertyResult("phrase", "Phrase", cfn_parse.FromCloudFormation.getString(properties.Phrase)), ret.addPropertyResult("weight", "Weight", properties.Weight != null ? cfn_parse.FromCloudFormation.getNumber(properties.Weight) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_DTMFSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deletionCharacter", cdk.requiredValidator)(properties.deletionCharacter)), errors.collect(cdk.propertyValidator("deletionCharacter", cdk.validateString)(properties.deletionCharacter)), errors.collect(cdk.propertyValidator("endCharacter", cdk.requiredValidator)(properties.endCharacter)), errors.collect(cdk.propertyValidator("endCharacter", cdk.validateString)(properties.endCharacter)), errors.collect(cdk.propertyValidator("endTimeoutMs", cdk.requiredValidator)(properties.endTimeoutMs)), errors.collect(cdk.propertyValidator("endTimeoutMs", cdk.validateNumber)(properties.endTimeoutMs)), errors.collect(cdk.propertyValidator("maxLength", cdk.requiredValidator)(properties.maxLength)), errors.collect(cdk.propertyValidator("maxLength", cdk.validateNumber)(properties.maxLength)), errors.wrap('supplied properties not correct for "DTMFSpecificationProperty"');
    }
    function cfnBotDTMFSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_DTMFSpecificationPropertyValidator(properties).assertSuccess(), { DeletionCharacter: cdk.stringToCloudFormation(properties.deletionCharacter), EndCharacter: cdk.stringToCloudFormation(properties.endCharacter), EndTimeoutMs: cdk.numberToCloudFormation(properties.endTimeoutMs), MaxLength: cdk.numberToCloudFormation(properties.maxLength) }) : properties;
    }
    function CfnBotDTMFSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deletionCharacter", "DeletionCharacter", cfn_parse.FromCloudFormation.getString(properties.DeletionCharacter)), ret.addPropertyResult("endCharacter", "EndCharacter", cfn_parse.FromCloudFormation.getString(properties.EndCharacter)), ret.addPropertyResult("endTimeoutMs", "EndTimeoutMs", cfn_parse.FromCloudFormation.getNumber(properties.EndTimeoutMs)), ret.addPropertyResult("maxLength", "MaxLength", cfn_parse.FromCloudFormation.getNumber(properties.MaxLength)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_DefaultConditionalBranchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("nextStep", CfnBot_DialogStatePropertyValidator)(properties.nextStep)), errors.collect(cdk.propertyValidator("response", CfnBot_ResponseSpecificationPropertyValidator)(properties.response)), errors.wrap('supplied properties not correct for "DefaultConditionalBranchProperty"');
    }
    function cfnBotDefaultConditionalBranchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_DefaultConditionalBranchPropertyValidator(properties).assertSuccess(), { NextStep: cfnBotDialogStatePropertyToCloudFormation(properties.nextStep), Response: cfnBotResponseSpecificationPropertyToCloudFormation(properties.response) }) : properties;
    }
    function CfnBotDefaultConditionalBranchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("nextStep", "NextStep", properties.NextStep != null ? CfnBotDialogStatePropertyFromCloudFormation(properties.NextStep) : void 0), ret.addPropertyResult("response", "Response", properties.Response != null ? CfnBotResponseSpecificationPropertyFromCloudFormation(properties.Response) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_DialogActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("slotToElicit", cdk.validateString)(properties.slotToElicit)), errors.collect(cdk.propertyValidator("suppressNextMessage", cdk.validateBoolean)(properties.suppressNextMessage)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "DialogActionProperty"');
    }
    function cfnBotDialogActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_DialogActionPropertyValidator(properties).assertSuccess(), { SlotToElicit: cdk.stringToCloudFormation(properties.slotToElicit), SuppressNextMessage: cdk.booleanToCloudFormation(properties.suppressNextMessage), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnBotDialogActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("slotToElicit", "SlotToElicit", properties.SlotToElicit != null ? cfn_parse.FromCloudFormation.getString(properties.SlotToElicit) : void 0), ret.addPropertyResult("suppressNextMessage", "SuppressNextMessage", properties.SuppressNextMessage != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SuppressNextMessage) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_DialogCodeHookInvocationSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enableCodeHookInvocation", cdk.requiredValidator)(properties.enableCodeHookInvocation)), errors.collect(cdk.propertyValidator("enableCodeHookInvocation", cdk.validateBoolean)(properties.enableCodeHookInvocation)), errors.collect(cdk.propertyValidator("invocationLabel", cdk.validateString)(properties.invocationLabel)), errors.collect(cdk.propertyValidator("isActive", cdk.requiredValidator)(properties.isActive)), errors.collect(cdk.propertyValidator("isActive", cdk.validateBoolean)(properties.isActive)), errors.collect(cdk.propertyValidator("postCodeHookSpecification", cdk.requiredValidator)(properties.postCodeHookSpecification)), errors.collect(cdk.propertyValidator("postCodeHookSpecification", CfnBot_PostDialogCodeHookInvocationSpecificationPropertyValidator)(properties.postCodeHookSpecification)), errors.wrap('supplied properties not correct for "DialogCodeHookInvocationSettingProperty"');
    }
    function cfnBotDialogCodeHookInvocationSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_DialogCodeHookInvocationSettingPropertyValidator(properties).assertSuccess(), { EnableCodeHookInvocation: cdk.booleanToCloudFormation(properties.enableCodeHookInvocation), InvocationLabel: cdk.stringToCloudFormation(properties.invocationLabel), IsActive: cdk.booleanToCloudFormation(properties.isActive), PostCodeHookSpecification: cfnBotPostDialogCodeHookInvocationSpecificationPropertyToCloudFormation(properties.postCodeHookSpecification) }) : properties;
    }
    function CfnBotDialogCodeHookInvocationSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enableCodeHookInvocation", "EnableCodeHookInvocation", cfn_parse.FromCloudFormation.getBoolean(properties.EnableCodeHookInvocation)), ret.addPropertyResult("invocationLabel", "InvocationLabel", properties.InvocationLabel != null ? cfn_parse.FromCloudFormation.getString(properties.InvocationLabel) : void 0), ret.addPropertyResult("isActive", "IsActive", cfn_parse.FromCloudFormation.getBoolean(properties.IsActive)), ret.addPropertyResult("postCodeHookSpecification", "PostCodeHookSpecification", CfnBotPostDialogCodeHookInvocationSpecificationPropertyFromCloudFormation(properties.PostCodeHookSpecification)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_DialogCodeHookSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "DialogCodeHookSettingProperty"');
    }
    function cfnBotDialogCodeHookSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_DialogCodeHookSettingPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnBotDialogCodeHookSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_DialogStatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dialogAction", CfnBot_DialogActionPropertyValidator)(properties.dialogAction)), errors.collect(cdk.propertyValidator("intent", CfnBot_IntentOverridePropertyValidator)(properties.intent)), errors.collect(cdk.propertyValidator("sessionAttributes", cdk.listValidator(CfnBot_SessionAttributePropertyValidator))(properties.sessionAttributes)), errors.wrap('supplied properties not correct for "DialogStateProperty"');
    }
    function cfnBotDialogStatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_DialogStatePropertyValidator(properties).assertSuccess(), { DialogAction: cfnBotDialogActionPropertyToCloudFormation(properties.dialogAction), Intent: cfnBotIntentOverridePropertyToCloudFormation(properties.intent), SessionAttributes: cdk.listMapper(cfnBotSessionAttributePropertyToCloudFormation)(properties.sessionAttributes) }) : properties;
    }
    function CfnBotDialogStatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dialogAction", "DialogAction", properties.DialogAction != null ? CfnBotDialogActionPropertyFromCloudFormation(properties.DialogAction) : void 0), ret.addPropertyResult("intent", "Intent", properties.Intent != null ? CfnBotIntentOverridePropertyFromCloudFormation(properties.Intent) : void 0), ret.addPropertyResult("sessionAttributes", "SessionAttributes", properties.SessionAttributes != null ? cfn_parse.FromCloudFormation.getArray(CfnBotSessionAttributePropertyFromCloudFormation)(properties.SessionAttributes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_ElicitationCodeHookInvocationSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enableCodeHookInvocation", cdk.requiredValidator)(properties.enableCodeHookInvocation)), errors.collect(cdk.propertyValidator("enableCodeHookInvocation", cdk.validateBoolean)(properties.enableCodeHookInvocation)), errors.collect(cdk.propertyValidator("invocationLabel", cdk.validateString)(properties.invocationLabel)), errors.wrap('supplied properties not correct for "ElicitationCodeHookInvocationSettingProperty"');
    }
    function cfnBotElicitationCodeHookInvocationSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_ElicitationCodeHookInvocationSettingPropertyValidator(properties).assertSuccess(), { EnableCodeHookInvocation: cdk.booleanToCloudFormation(properties.enableCodeHookInvocation), InvocationLabel: cdk.stringToCloudFormation(properties.invocationLabel) }) : properties;
    }
    function CfnBotElicitationCodeHookInvocationSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enableCodeHookInvocation", "EnableCodeHookInvocation", cfn_parse.FromCloudFormation.getBoolean(properties.EnableCodeHookInvocation)), ret.addPropertyResult("invocationLabel", "InvocationLabel", properties.InvocationLabel != null ? cfn_parse.FromCloudFormation.getString(properties.InvocationLabel) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_ExternalSourceSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("grammarSlotTypeSetting", CfnBot_GrammarSlotTypeSettingPropertyValidator)(properties.grammarSlotTypeSetting)), errors.wrap('supplied properties not correct for "ExternalSourceSettingProperty"');
    }
    function cfnBotExternalSourceSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_ExternalSourceSettingPropertyValidator(properties).assertSuccess(), { GrammarSlotTypeSetting: cfnBotGrammarSlotTypeSettingPropertyToCloudFormation(properties.grammarSlotTypeSetting) }) : properties;
    }
    function CfnBotExternalSourceSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("grammarSlotTypeSetting", "GrammarSlotTypeSetting", properties.GrammarSlotTypeSetting != null ? CfnBotGrammarSlotTypeSettingPropertyFromCloudFormation(properties.GrammarSlotTypeSetting) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_FulfillmentCodeHookSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("fulfillmentUpdatesSpecification", CfnBot_FulfillmentUpdatesSpecificationPropertyValidator)(properties.fulfillmentUpdatesSpecification)), errors.collect(cdk.propertyValidator("isActive", cdk.validateBoolean)(properties.isActive)), errors.collect(cdk.propertyValidator("postFulfillmentStatusSpecification", CfnBot_PostFulfillmentStatusSpecificationPropertyValidator)(properties.postFulfillmentStatusSpecification)), errors.wrap('supplied properties not correct for "FulfillmentCodeHookSettingProperty"');
    }
    function cfnBotFulfillmentCodeHookSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_FulfillmentCodeHookSettingPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled), FulfillmentUpdatesSpecification: cfnBotFulfillmentUpdatesSpecificationPropertyToCloudFormation(properties.fulfillmentUpdatesSpecification), IsActive: cdk.booleanToCloudFormation(properties.isActive), PostFulfillmentStatusSpecification: cfnBotPostFulfillmentStatusSpecificationPropertyToCloudFormation(properties.postFulfillmentStatusSpecification) }) : properties;
    }
    function CfnBotFulfillmentCodeHookSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addPropertyResult("fulfillmentUpdatesSpecification", "FulfillmentUpdatesSpecification", properties.FulfillmentUpdatesSpecification != null ? CfnBotFulfillmentUpdatesSpecificationPropertyFromCloudFormation(properties.FulfillmentUpdatesSpecification) : void 0), ret.addPropertyResult("isActive", "IsActive", properties.IsActive != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsActive) : void 0), ret.addPropertyResult("postFulfillmentStatusSpecification", "PostFulfillmentStatusSpecification", properties.PostFulfillmentStatusSpecification != null ? CfnBotPostFulfillmentStatusSpecificationPropertyFromCloudFormation(properties.PostFulfillmentStatusSpecification) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_FulfillmentStartResponseSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowInterrupt", cdk.validateBoolean)(properties.allowInterrupt)), errors.collect(cdk.propertyValidator("delayInSeconds", cdk.requiredValidator)(properties.delayInSeconds)), errors.collect(cdk.propertyValidator("delayInSeconds", cdk.validateNumber)(properties.delayInSeconds)), errors.collect(cdk.propertyValidator("messageGroups", cdk.requiredValidator)(properties.messageGroups)), errors.collect(cdk.propertyValidator("messageGroups", cdk.listValidator(CfnBot_MessageGroupPropertyValidator))(properties.messageGroups)), errors.wrap('supplied properties not correct for "FulfillmentStartResponseSpecificationProperty"');
    }
    function cfnBotFulfillmentStartResponseSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_FulfillmentStartResponseSpecificationPropertyValidator(properties).assertSuccess(), { AllowInterrupt: cdk.booleanToCloudFormation(properties.allowInterrupt), DelayInSeconds: cdk.numberToCloudFormation(properties.delayInSeconds), MessageGroups: cdk.listMapper(cfnBotMessageGroupPropertyToCloudFormation)(properties.messageGroups) }) : properties;
    }
    function CfnBotFulfillmentStartResponseSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowInterrupt", "AllowInterrupt", properties.AllowInterrupt != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllowInterrupt) : void 0), ret.addPropertyResult("delayInSeconds", "DelayInSeconds", cfn_parse.FromCloudFormation.getNumber(properties.DelayInSeconds)), ret.addPropertyResult("messageGroups", "MessageGroups", cfn_parse.FromCloudFormation.getArray(CfnBotMessageGroupPropertyFromCloudFormation)(properties.MessageGroups)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_FulfillmentUpdateResponseSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowInterrupt", cdk.validateBoolean)(properties.allowInterrupt)), errors.collect(cdk.propertyValidator("frequencyInSeconds", cdk.requiredValidator)(properties.frequencyInSeconds)), errors.collect(cdk.propertyValidator("frequencyInSeconds", cdk.validateNumber)(properties.frequencyInSeconds)), errors.collect(cdk.propertyValidator("messageGroups", cdk.requiredValidator)(properties.messageGroups)), errors.collect(cdk.propertyValidator("messageGroups", cdk.listValidator(CfnBot_MessageGroupPropertyValidator))(properties.messageGroups)), errors.wrap('supplied properties not correct for "FulfillmentUpdateResponseSpecificationProperty"');
    }
    function cfnBotFulfillmentUpdateResponseSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_FulfillmentUpdateResponseSpecificationPropertyValidator(properties).assertSuccess(), { AllowInterrupt: cdk.booleanToCloudFormation(properties.allowInterrupt), FrequencyInSeconds: cdk.numberToCloudFormation(properties.frequencyInSeconds), MessageGroups: cdk.listMapper(cfnBotMessageGroupPropertyToCloudFormation)(properties.messageGroups) }) : properties;
    }
    function CfnBotFulfillmentUpdateResponseSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowInterrupt", "AllowInterrupt", properties.AllowInterrupt != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllowInterrupt) : void 0), ret.addPropertyResult("frequencyInSeconds", "FrequencyInSeconds", cfn_parse.FromCloudFormation.getNumber(properties.FrequencyInSeconds)), ret.addPropertyResult("messageGroups", "MessageGroups", cfn_parse.FromCloudFormation.getArray(CfnBotMessageGroupPropertyFromCloudFormation)(properties.MessageGroups)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_FulfillmentUpdatesSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("active", cdk.requiredValidator)(properties.active)), errors.collect(cdk.propertyValidator("active", cdk.validateBoolean)(properties.active)), errors.collect(cdk.propertyValidator("startResponse", CfnBot_FulfillmentStartResponseSpecificationPropertyValidator)(properties.startResponse)), errors.collect(cdk.propertyValidator("timeoutInSeconds", cdk.validateNumber)(properties.timeoutInSeconds)), errors.collect(cdk.propertyValidator("updateResponse", CfnBot_FulfillmentUpdateResponseSpecificationPropertyValidator)(properties.updateResponse)), errors.wrap('supplied properties not correct for "FulfillmentUpdatesSpecificationProperty"');
    }
    function cfnBotFulfillmentUpdatesSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_FulfillmentUpdatesSpecificationPropertyValidator(properties).assertSuccess(), { Active: cdk.booleanToCloudFormation(properties.active), StartResponse: cfnBotFulfillmentStartResponseSpecificationPropertyToCloudFormation(properties.startResponse), TimeoutInSeconds: cdk.numberToCloudFormation(properties.timeoutInSeconds), UpdateResponse: cfnBotFulfillmentUpdateResponseSpecificationPropertyToCloudFormation(properties.updateResponse) }) : properties;
    }
    function CfnBotFulfillmentUpdatesSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("active", "Active", cfn_parse.FromCloudFormation.getBoolean(properties.Active)), ret.addPropertyResult("startResponse", "StartResponse", properties.StartResponse != null ? CfnBotFulfillmentStartResponseSpecificationPropertyFromCloudFormation(properties.StartResponse) : void 0), ret.addPropertyResult("timeoutInSeconds", "TimeoutInSeconds", properties.TimeoutInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.TimeoutInSeconds) : void 0), ret.addPropertyResult("updateResponse", "UpdateResponse", properties.UpdateResponse != null ? CfnBotFulfillmentUpdateResponseSpecificationPropertyFromCloudFormation(properties.UpdateResponse) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_GrammarSlotTypeSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("source", CfnBot_GrammarSlotTypeSourcePropertyValidator)(properties.source)), errors.wrap('supplied properties not correct for "GrammarSlotTypeSettingProperty"');
    }
    function cfnBotGrammarSlotTypeSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_GrammarSlotTypeSettingPropertyValidator(properties).assertSuccess(), { Source: cfnBotGrammarSlotTypeSourcePropertyToCloudFormation(properties.source) }) : properties;
    }
    function CfnBotGrammarSlotTypeSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("source", "Source", properties.Source != null ? CfnBotGrammarSlotTypeSourcePropertyFromCloudFormation(properties.Source) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_GrammarSlotTypeSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kmsKeyArn", cdk.validateString)(properties.kmsKeyArn)), errors.collect(cdk.propertyValidator("s3BucketName", cdk.requiredValidator)(properties.s3BucketName)), errors.collect(cdk.propertyValidator("s3BucketName", cdk.validateString)(properties.s3BucketName)), errors.collect(cdk.propertyValidator("s3ObjectKey", cdk.requiredValidator)(properties.s3ObjectKey)), errors.collect(cdk.propertyValidator("s3ObjectKey", cdk.validateString)(properties.s3ObjectKey)), errors.wrap('supplied properties not correct for "GrammarSlotTypeSourceProperty"');
    }
    function cfnBotGrammarSlotTypeSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_GrammarSlotTypeSourcePropertyValidator(properties).assertSuccess(), { KmsKeyArn: cdk.stringToCloudFormation(properties.kmsKeyArn), S3BucketName: cdk.stringToCloudFormation(properties.s3BucketName), S3ObjectKey: cdk.stringToCloudFormation(properties.s3ObjectKey) }) : properties;
    }
    function CfnBotGrammarSlotTypeSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsKeyArn", "KmsKeyArn", properties.KmsKeyArn != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyArn) : void 0), ret.addPropertyResult("s3BucketName", "S3BucketName", cfn_parse.FromCloudFormation.getString(properties.S3BucketName)), ret.addPropertyResult("s3ObjectKey", "S3ObjectKey", cfn_parse.FromCloudFormation.getString(properties.S3ObjectKey)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_ImageResponseCardPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("buttons", cdk.listValidator(CfnBot_ButtonPropertyValidator))(properties.buttons)), errors.collect(cdk.propertyValidator("imageUrl", cdk.validateString)(properties.imageUrl)), errors.collect(cdk.propertyValidator("subtitle", cdk.validateString)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.wrap('supplied properties not correct for "ImageResponseCardProperty"');
    }
    function cfnBotImageResponseCardPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_ImageResponseCardPropertyValidator(properties).assertSuccess(), { Buttons: cdk.listMapper(cfnBotButtonPropertyToCloudFormation)(properties.buttons), ImageUrl: cdk.stringToCloudFormation(properties.imageUrl), Subtitle: cdk.stringToCloudFormation(properties.subtitle), Title: cdk.stringToCloudFormation(properties.title) }) : properties;
    }
    function CfnBotImageResponseCardPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("buttons", "Buttons", properties.Buttons != null ? cfn_parse.FromCloudFormation.getArray(CfnBotButtonPropertyFromCloudFormation)(properties.Buttons) : void 0), ret.addPropertyResult("imageUrl", "ImageUrl", properties.ImageUrl != null ? cfn_parse.FromCloudFormation.getString(properties.ImageUrl) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? cfn_parse.FromCloudFormation.getString(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_InitialResponseSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("codeHook", CfnBot_DialogCodeHookInvocationSettingPropertyValidator)(properties.codeHook)), errors.collect(cdk.propertyValidator("conditional", CfnBot_ConditionalSpecificationPropertyValidator)(properties.conditional)), errors.collect(cdk.propertyValidator("initialResponse", CfnBot_ResponseSpecificationPropertyValidator)(properties.initialResponse)), errors.collect(cdk.propertyValidator("nextStep", CfnBot_DialogStatePropertyValidator)(properties.nextStep)), errors.wrap('supplied properties not correct for "InitialResponseSettingProperty"');
    }
    function cfnBotInitialResponseSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_InitialResponseSettingPropertyValidator(properties).assertSuccess(), { CodeHook: cfnBotDialogCodeHookInvocationSettingPropertyToCloudFormation(properties.codeHook), Conditional: cfnBotConditionalSpecificationPropertyToCloudFormation(properties.conditional), InitialResponse: cfnBotResponseSpecificationPropertyToCloudFormation(properties.initialResponse), NextStep: cfnBotDialogStatePropertyToCloudFormation(properties.nextStep) }) : properties;
    }
    function CfnBotInitialResponseSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("codeHook", "CodeHook", properties.CodeHook != null ? CfnBotDialogCodeHookInvocationSettingPropertyFromCloudFormation(properties.CodeHook) : void 0), ret.addPropertyResult("conditional", "Conditional", properties.Conditional != null ? CfnBotConditionalSpecificationPropertyFromCloudFormation(properties.Conditional) : void 0), ret.addPropertyResult("initialResponse", "InitialResponse", properties.InitialResponse != null ? CfnBotResponseSpecificationPropertyFromCloudFormation(properties.InitialResponse) : void 0), ret.addPropertyResult("nextStep", "NextStep", properties.NextStep != null ? CfnBotDialogStatePropertyFromCloudFormation(properties.NextStep) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_InputContextPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "InputContextProperty"');
    }
    function cfnBotInputContextPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_InputContextPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnBotInputContextPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_IntentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("dialogCodeHook", CfnBot_DialogCodeHookSettingPropertyValidator)(properties.dialogCodeHook)), errors.collect(cdk.propertyValidator("fulfillmentCodeHook", CfnBot_FulfillmentCodeHookSettingPropertyValidator)(properties.fulfillmentCodeHook)), errors.collect(cdk.propertyValidator("initialResponseSetting", CfnBot_InitialResponseSettingPropertyValidator)(properties.initialResponseSetting)), errors.collect(cdk.propertyValidator("inputContexts", cdk.listValidator(CfnBot_InputContextPropertyValidator))(properties.inputContexts)), errors.collect(cdk.propertyValidator("intentClosingSetting", CfnBot_IntentClosingSettingPropertyValidator)(properties.intentClosingSetting)), errors.collect(cdk.propertyValidator("intentConfirmationSetting", CfnBot_IntentConfirmationSettingPropertyValidator)(properties.intentConfirmationSetting)), errors.collect(cdk.propertyValidator("kendraConfiguration", CfnBot_KendraConfigurationPropertyValidator)(properties.kendraConfiguration)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("outputContexts", cdk.listValidator(CfnBot_OutputContextPropertyValidator))(properties.outputContexts)), errors.collect(cdk.propertyValidator("parentIntentSignature", cdk.validateString)(properties.parentIntentSignature)), errors.collect(cdk.propertyValidator("sampleUtterances", cdk.listValidator(CfnBot_SampleUtterancePropertyValidator))(properties.sampleUtterances)), errors.collect(cdk.propertyValidator("slotPriorities", cdk.listValidator(CfnBot_SlotPriorityPropertyValidator))(properties.slotPriorities)), errors.collect(cdk.propertyValidator("slots", cdk.listValidator(CfnBot_SlotPropertyValidator))(properties.slots)), errors.wrap('supplied properties not correct for "IntentProperty"');
    }
    function cfnBotIntentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_IntentPropertyValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), DialogCodeHook: cfnBotDialogCodeHookSettingPropertyToCloudFormation(properties.dialogCodeHook), FulfillmentCodeHook: cfnBotFulfillmentCodeHookSettingPropertyToCloudFormation(properties.fulfillmentCodeHook), InitialResponseSetting: cfnBotInitialResponseSettingPropertyToCloudFormation(properties.initialResponseSetting), InputContexts: cdk.listMapper(cfnBotInputContextPropertyToCloudFormation)(properties.inputContexts), IntentClosingSetting: cfnBotIntentClosingSettingPropertyToCloudFormation(properties.intentClosingSetting), IntentConfirmationSetting: cfnBotIntentConfirmationSettingPropertyToCloudFormation(properties.intentConfirmationSetting), KendraConfiguration: cfnBotKendraConfigurationPropertyToCloudFormation(properties.kendraConfiguration), Name: cdk.stringToCloudFormation(properties.name), OutputContexts: cdk.listMapper(cfnBotOutputContextPropertyToCloudFormation)(properties.outputContexts), ParentIntentSignature: cdk.stringToCloudFormation(properties.parentIntentSignature), SampleUtterances: cdk.listMapper(cfnBotSampleUtterancePropertyToCloudFormation)(properties.sampleUtterances), SlotPriorities: cdk.listMapper(cfnBotSlotPriorityPropertyToCloudFormation)(properties.slotPriorities), Slots: cdk.listMapper(cfnBotSlotPropertyToCloudFormation)(properties.slots) }) : properties;
    }
    function CfnBotIntentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("dialogCodeHook", "DialogCodeHook", properties.DialogCodeHook != null ? CfnBotDialogCodeHookSettingPropertyFromCloudFormation(properties.DialogCodeHook) : void 0), ret.addPropertyResult("fulfillmentCodeHook", "FulfillmentCodeHook", properties.FulfillmentCodeHook != null ? CfnBotFulfillmentCodeHookSettingPropertyFromCloudFormation(properties.FulfillmentCodeHook) : void 0), ret.addPropertyResult("initialResponseSetting", "InitialResponseSetting", properties.InitialResponseSetting != null ? CfnBotInitialResponseSettingPropertyFromCloudFormation(properties.InitialResponseSetting) : void 0), ret.addPropertyResult("inputContexts", "InputContexts", properties.InputContexts != null ? cfn_parse.FromCloudFormation.getArray(CfnBotInputContextPropertyFromCloudFormation)(properties.InputContexts) : void 0), ret.addPropertyResult("intentClosingSetting", "IntentClosingSetting", properties.IntentClosingSetting != null ? CfnBotIntentClosingSettingPropertyFromCloudFormation(properties.IntentClosingSetting) : void 0), ret.addPropertyResult("intentConfirmationSetting", "IntentConfirmationSetting", properties.IntentConfirmationSetting != null ? CfnBotIntentConfirmationSettingPropertyFromCloudFormation(properties.IntentConfirmationSetting) : void 0), ret.addPropertyResult("kendraConfiguration", "KendraConfiguration", properties.KendraConfiguration != null ? CfnBotKendraConfigurationPropertyFromCloudFormation(properties.KendraConfiguration) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("outputContexts", "OutputContexts", properties.OutputContexts != null ? cfn_parse.FromCloudFormation.getArray(CfnBotOutputContextPropertyFromCloudFormation)(properties.OutputContexts) : void 0), ret.addPropertyResult("parentIntentSignature", "ParentIntentSignature", properties.ParentIntentSignature != null ? cfn_parse.FromCloudFormation.getString(properties.ParentIntentSignature) : void 0), ret.addPropertyResult("sampleUtterances", "SampleUtterances", properties.SampleUtterances != null ? cfn_parse.FromCloudFormation.getArray(CfnBotSampleUtterancePropertyFromCloudFormation)(properties.SampleUtterances) : void 0), ret.addPropertyResult("slotPriorities", "SlotPriorities", properties.SlotPriorities != null ? cfn_parse.FromCloudFormation.getArray(CfnBotSlotPriorityPropertyFromCloudFormation)(properties.SlotPriorities) : void 0), ret.addPropertyResult("slots", "Slots", properties.Slots != null ? cfn_parse.FromCloudFormation.getArray(CfnBotSlotPropertyFromCloudFormation)(properties.Slots) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_IntentClosingSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("closingResponse", CfnBot_ResponseSpecificationPropertyValidator)(properties.closingResponse)), errors.collect(cdk.propertyValidator("conditional", CfnBot_ConditionalSpecificationPropertyValidator)(properties.conditional)), errors.collect(cdk.propertyValidator("isActive", cdk.validateBoolean)(properties.isActive)), errors.collect(cdk.propertyValidator("nextStep", CfnBot_DialogStatePropertyValidator)(properties.nextStep)), errors.wrap('supplied properties not correct for "IntentClosingSettingProperty"');
    }
    function cfnBotIntentClosingSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_IntentClosingSettingPropertyValidator(properties).assertSuccess(), { ClosingResponse: cfnBotResponseSpecificationPropertyToCloudFormation(properties.closingResponse), Conditional: cfnBotConditionalSpecificationPropertyToCloudFormation(properties.conditional), IsActive: cdk.booleanToCloudFormation(properties.isActive), NextStep: cfnBotDialogStatePropertyToCloudFormation(properties.nextStep) }) : properties;
    }
    function CfnBotIntentClosingSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("closingResponse", "ClosingResponse", properties.ClosingResponse != null ? CfnBotResponseSpecificationPropertyFromCloudFormation(properties.ClosingResponse) : void 0), ret.addPropertyResult("conditional", "Conditional", properties.Conditional != null ? CfnBotConditionalSpecificationPropertyFromCloudFormation(properties.Conditional) : void 0), ret.addPropertyResult("isActive", "IsActive", properties.IsActive != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsActive) : void 0), ret.addPropertyResult("nextStep", "NextStep", properties.NextStep != null ? CfnBotDialogStatePropertyFromCloudFormation(properties.NextStep) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_IntentConfirmationSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("codeHook", CfnBot_DialogCodeHookInvocationSettingPropertyValidator)(properties.codeHook)), errors.collect(cdk.propertyValidator("confirmationConditional", CfnBot_ConditionalSpecificationPropertyValidator)(properties.confirmationConditional)), errors.collect(cdk.propertyValidator("confirmationNextStep", CfnBot_DialogStatePropertyValidator)(properties.confirmationNextStep)), errors.collect(cdk.propertyValidator("confirmationResponse", CfnBot_ResponseSpecificationPropertyValidator)(properties.confirmationResponse)), errors.collect(cdk.propertyValidator("declinationConditional", CfnBot_ConditionalSpecificationPropertyValidator)(properties.declinationConditional)), errors.collect(cdk.propertyValidator("declinationNextStep", CfnBot_DialogStatePropertyValidator)(properties.declinationNextStep)), errors.collect(cdk.propertyValidator("declinationResponse", CfnBot_ResponseSpecificationPropertyValidator)(properties.declinationResponse)), errors.collect(cdk.propertyValidator("elicitationCodeHook", CfnBot_ElicitationCodeHookInvocationSettingPropertyValidator)(properties.elicitationCodeHook)), errors.collect(cdk.propertyValidator("failureConditional", CfnBot_ConditionalSpecificationPropertyValidator)(properties.failureConditional)), errors.collect(cdk.propertyValidator("failureNextStep", CfnBot_DialogStatePropertyValidator)(properties.failureNextStep)), errors.collect(cdk.propertyValidator("failureResponse", CfnBot_ResponseSpecificationPropertyValidator)(properties.failureResponse)), errors.collect(cdk.propertyValidator("isActive", cdk.validateBoolean)(properties.isActive)), errors.collect(cdk.propertyValidator("promptSpecification", cdk.requiredValidator)(properties.promptSpecification)), errors.collect(cdk.propertyValidator("promptSpecification", CfnBot_PromptSpecificationPropertyValidator)(properties.promptSpecification)), errors.wrap('supplied properties not correct for "IntentConfirmationSettingProperty"');
    }
    function cfnBotIntentConfirmationSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_IntentConfirmationSettingPropertyValidator(properties).assertSuccess(), { CodeHook: cfnBotDialogCodeHookInvocationSettingPropertyToCloudFormation(properties.codeHook), ConfirmationConditional: cfnBotConditionalSpecificationPropertyToCloudFormation(properties.confirmationConditional), ConfirmationNextStep: cfnBotDialogStatePropertyToCloudFormation(properties.confirmationNextStep), ConfirmationResponse: cfnBotResponseSpecificationPropertyToCloudFormation(properties.confirmationResponse), DeclinationConditional: cfnBotConditionalSpecificationPropertyToCloudFormation(properties.declinationConditional), DeclinationNextStep: cfnBotDialogStatePropertyToCloudFormation(properties.declinationNextStep), DeclinationResponse: cfnBotResponseSpecificationPropertyToCloudFormation(properties.declinationResponse), ElicitationCodeHook: cfnBotElicitationCodeHookInvocationSettingPropertyToCloudFormation(properties.elicitationCodeHook), FailureConditional: cfnBotConditionalSpecificationPropertyToCloudFormation(properties.failureConditional), FailureNextStep: cfnBotDialogStatePropertyToCloudFormation(properties.failureNextStep), FailureResponse: cfnBotResponseSpecificationPropertyToCloudFormation(properties.failureResponse), IsActive: cdk.booleanToCloudFormation(properties.isActive), PromptSpecification: cfnBotPromptSpecificationPropertyToCloudFormation(properties.promptSpecification) }) : properties;
    }
    function CfnBotIntentConfirmationSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("codeHook", "CodeHook", properties.CodeHook != null ? CfnBotDialogCodeHookInvocationSettingPropertyFromCloudFormation(properties.CodeHook) : void 0), ret.addPropertyResult("confirmationConditional", "ConfirmationConditional", properties.ConfirmationConditional != null ? CfnBotConditionalSpecificationPropertyFromCloudFormation(properties.ConfirmationConditional) : void 0), ret.addPropertyResult("confirmationNextStep", "ConfirmationNextStep", properties.ConfirmationNextStep != null ? CfnBotDialogStatePropertyFromCloudFormation(properties.ConfirmationNextStep) : void 0), ret.addPropertyResult("confirmationResponse", "ConfirmationResponse", properties.ConfirmationResponse != null ? CfnBotResponseSpecificationPropertyFromCloudFormation(properties.ConfirmationResponse) : void 0), ret.addPropertyResult("declinationConditional", "DeclinationConditional", properties.DeclinationConditional != null ? CfnBotConditionalSpecificationPropertyFromCloudFormation(properties.DeclinationConditional) : void 0), ret.addPropertyResult("declinationNextStep", "DeclinationNextStep", properties.DeclinationNextStep != null ? CfnBotDialogStatePropertyFromCloudFormation(properties.DeclinationNextStep) : void 0), ret.addPropertyResult("declinationResponse", "DeclinationResponse", properties.DeclinationResponse != null ? CfnBotResponseSpecificationPropertyFromCloudFormation(properties.DeclinationResponse) : void 0), ret.addPropertyResult("elicitationCodeHook", "ElicitationCodeHook", properties.ElicitationCodeHook != null ? CfnBotElicitationCodeHookInvocationSettingPropertyFromCloudFormation(properties.ElicitationCodeHook) : void 0), ret.addPropertyResult("failureConditional", "FailureConditional", properties.FailureConditional != null ? CfnBotConditionalSpecificationPropertyFromCloudFormation(properties.FailureConditional) : void 0), ret.addPropertyResult("failureNextStep", "FailureNextStep", properties.FailureNextStep != null ? CfnBotDialogStatePropertyFromCloudFormation(properties.FailureNextStep) : void 0), ret.addPropertyResult("failureResponse", "FailureResponse", properties.FailureResponse != null ? CfnBotResponseSpecificationPropertyFromCloudFormation(properties.FailureResponse) : void 0), ret.addPropertyResult("isActive", "IsActive", properties.IsActive != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsActive) : void 0), ret.addPropertyResult("promptSpecification", "PromptSpecification", CfnBotPromptSpecificationPropertyFromCloudFormation(properties.PromptSpecification)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_IntentOverridePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("slots", cdk.listValidator(CfnBot_SlotValueOverrideMapPropertyValidator))(properties.slots)), errors.wrap('supplied properties not correct for "IntentOverrideProperty"');
    }
    function cfnBotIntentOverridePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_IntentOverridePropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Slots: cdk.listMapper(cfnBotSlotValueOverrideMapPropertyToCloudFormation)(properties.slots) }) : properties;
    }
    function CfnBotIntentOverridePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("slots", "Slots", properties.Slots != null ? cfn_parse.FromCloudFormation.getArray(CfnBotSlotValueOverrideMapPropertyFromCloudFormation)(properties.Slots) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_KendraConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kendraIndex", cdk.requiredValidator)(properties.kendraIndex)), errors.collect(cdk.propertyValidator("kendraIndex", cdk.validateString)(properties.kendraIndex)), errors.collect(cdk.propertyValidator("queryFilterString", cdk.validateString)(properties.queryFilterString)), errors.collect(cdk.propertyValidator("queryFilterStringEnabled", cdk.validateBoolean)(properties.queryFilterStringEnabled)), errors.wrap('supplied properties not correct for "KendraConfigurationProperty"');
    }
    function cfnBotKendraConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_KendraConfigurationPropertyValidator(properties).assertSuccess(), { KendraIndex: cdk.stringToCloudFormation(properties.kendraIndex), QueryFilterString: cdk.stringToCloudFormation(properties.queryFilterString), QueryFilterStringEnabled: cdk.booleanToCloudFormation(properties.queryFilterStringEnabled) }) : properties;
    }
    function CfnBotKendraConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kendraIndex", "KendraIndex", cfn_parse.FromCloudFormation.getString(properties.KendraIndex)), ret.addPropertyResult("queryFilterString", "QueryFilterString", properties.QueryFilterString != null ? cfn_parse.FromCloudFormation.getString(properties.QueryFilterString) : void 0), ret.addPropertyResult("queryFilterStringEnabled", "QueryFilterStringEnabled", properties.QueryFilterStringEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.QueryFilterStringEnabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_LambdaCodeHookPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("codeHookInterfaceVersion", cdk.requiredValidator)(properties.codeHookInterfaceVersion)), errors.collect(cdk.propertyValidator("codeHookInterfaceVersion", cdk.validateString)(properties.codeHookInterfaceVersion)), errors.collect(cdk.propertyValidator("lambdaArn", cdk.requiredValidator)(properties.lambdaArn)), errors.collect(cdk.propertyValidator("lambdaArn", cdk.validateString)(properties.lambdaArn)), errors.wrap('supplied properties not correct for "LambdaCodeHookProperty"');
    }
    function cfnBotLambdaCodeHookPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_LambdaCodeHookPropertyValidator(properties).assertSuccess(), { CodeHookInterfaceVersion: cdk.stringToCloudFormation(properties.codeHookInterfaceVersion), LambdaArn: cdk.stringToCloudFormation(properties.lambdaArn) }) : properties;
    }
    function CfnBotLambdaCodeHookPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("codeHookInterfaceVersion", "CodeHookInterfaceVersion", cfn_parse.FromCloudFormation.getString(properties.CodeHookInterfaceVersion)), ret.addPropertyResult("lambdaArn", "LambdaArn", cfn_parse.FromCloudFormation.getString(properties.LambdaArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_MessagePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customPayload", CfnBot_CustomPayloadPropertyValidator)(properties.customPayload)), errors.collect(cdk.propertyValidator("imageResponseCard", CfnBot_ImageResponseCardPropertyValidator)(properties.imageResponseCard)), errors.collect(cdk.propertyValidator("plainTextMessage", CfnBot_PlainTextMessagePropertyValidator)(properties.plainTextMessage)), errors.collect(cdk.propertyValidator("ssmlMessage", CfnBot_SSMLMessagePropertyValidator)(properties.ssmlMessage)), errors.wrap('supplied properties not correct for "MessageProperty"');
    }
    function cfnBotMessagePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_MessagePropertyValidator(properties).assertSuccess(), { CustomPayload: cfnBotCustomPayloadPropertyToCloudFormation(properties.customPayload), ImageResponseCard: cfnBotImageResponseCardPropertyToCloudFormation(properties.imageResponseCard), PlainTextMessage: cfnBotPlainTextMessagePropertyToCloudFormation(properties.plainTextMessage), SSMLMessage: cfnBotSSMLMessagePropertyToCloudFormation(properties.ssmlMessage) }) : properties;
    }
    function CfnBotMessagePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customPayload", "CustomPayload", properties.CustomPayload != null ? CfnBotCustomPayloadPropertyFromCloudFormation(properties.CustomPayload) : void 0), ret.addPropertyResult("imageResponseCard", "ImageResponseCard", properties.ImageResponseCard != null ? CfnBotImageResponseCardPropertyFromCloudFormation(properties.ImageResponseCard) : void 0), ret.addPropertyResult("plainTextMessage", "PlainTextMessage", properties.PlainTextMessage != null ? CfnBotPlainTextMessagePropertyFromCloudFormation(properties.PlainTextMessage) : void 0), ret.addPropertyResult("ssmlMessage", "SSMLMessage", properties.SSMLMessage != null ? CfnBotSSMLMessagePropertyFromCloudFormation(properties.SSMLMessage) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_MessageGroupPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("message", cdk.requiredValidator)(properties.message)), errors.collect(cdk.propertyValidator("message", CfnBot_MessagePropertyValidator)(properties.message)), errors.collect(cdk.propertyValidator("variations", cdk.listValidator(CfnBot_MessagePropertyValidator))(properties.variations)), errors.wrap('supplied properties not correct for "MessageGroupProperty"');
    }
    function cfnBotMessageGroupPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_MessageGroupPropertyValidator(properties).assertSuccess(), { Message: cfnBotMessagePropertyToCloudFormation(properties.message), Variations: cdk.listMapper(cfnBotMessagePropertyToCloudFormation)(properties.variations) }) : properties;
    }
    function CfnBotMessageGroupPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("message", "Message", CfnBotMessagePropertyFromCloudFormation(properties.Message)), ret.addPropertyResult("variations", "Variations", properties.Variations != null ? cfn_parse.FromCloudFormation.getArray(CfnBotMessagePropertyFromCloudFormation)(properties.Variations) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_MultipleValuesSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowMultipleValues", cdk.validateBoolean)(properties.allowMultipleValues)), errors.wrap('supplied properties not correct for "MultipleValuesSettingProperty"');
    }
    function cfnBotMultipleValuesSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_MultipleValuesSettingPropertyValidator(properties).assertSuccess(), { AllowMultipleValues: cdk.booleanToCloudFormation(properties.allowMultipleValues) }) : properties;
    }
    function CfnBotMultipleValuesSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowMultipleValues", "AllowMultipleValues", properties.AllowMultipleValues != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllowMultipleValues) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_ObfuscationSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("obfuscationSettingType", cdk.requiredValidator)(properties.obfuscationSettingType)), errors.collect(cdk.propertyValidator("obfuscationSettingType", cdk.validateString)(properties.obfuscationSettingType)), errors.wrap('supplied properties not correct for "ObfuscationSettingProperty"');
    }
    function cfnBotObfuscationSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_ObfuscationSettingPropertyValidator(properties).assertSuccess(), { ObfuscationSettingType: cdk.stringToCloudFormation(properties.obfuscationSettingType) }) : properties;
    }
    function CfnBotObfuscationSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("obfuscationSettingType", "ObfuscationSettingType", cfn_parse.FromCloudFormation.getString(properties.ObfuscationSettingType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_OutputContextPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("timeToLiveInSeconds", cdk.requiredValidator)(properties.timeToLiveInSeconds)), errors.collect(cdk.propertyValidator("timeToLiveInSeconds", cdk.validateNumber)(properties.timeToLiveInSeconds)), errors.collect(cdk.propertyValidator("turnsToLive", cdk.requiredValidator)(properties.turnsToLive)), errors.collect(cdk.propertyValidator("turnsToLive", cdk.validateNumber)(properties.turnsToLive)), errors.wrap('supplied properties not correct for "OutputContextProperty"');
    }
    function cfnBotOutputContextPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_OutputContextPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), TimeToLiveInSeconds: cdk.numberToCloudFormation(properties.timeToLiveInSeconds), TurnsToLive: cdk.numberToCloudFormation(properties.turnsToLive) }) : properties;
    }
    function CfnBotOutputContextPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("timeToLiveInSeconds", "TimeToLiveInSeconds", cfn_parse.FromCloudFormation.getNumber(properties.TimeToLiveInSeconds)), ret.addPropertyResult("turnsToLive", "TurnsToLive", cfn_parse.FromCloudFormation.getNumber(properties.TurnsToLive)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_PlainTextMessagePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "PlainTextMessageProperty"');
    }
    function cfnBotPlainTextMessagePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_PlainTextMessagePropertyValidator(properties).assertSuccess(), { Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnBotPlainTextMessagePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_PostDialogCodeHookInvocationSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("failureConditional", CfnBot_ConditionalSpecificationPropertyValidator)(properties.failureConditional)), errors.collect(cdk.propertyValidator("failureNextStep", CfnBot_DialogStatePropertyValidator)(properties.failureNextStep)), errors.collect(cdk.propertyValidator("failureResponse", CfnBot_ResponseSpecificationPropertyValidator)(properties.failureResponse)), errors.collect(cdk.propertyValidator("successConditional", CfnBot_ConditionalSpecificationPropertyValidator)(properties.successConditional)), errors.collect(cdk.propertyValidator("successNextStep", CfnBot_DialogStatePropertyValidator)(properties.successNextStep)), errors.collect(cdk.propertyValidator("successResponse", CfnBot_ResponseSpecificationPropertyValidator)(properties.successResponse)), errors.collect(cdk.propertyValidator("timeoutConditional", CfnBot_ConditionalSpecificationPropertyValidator)(properties.timeoutConditional)), errors.collect(cdk.propertyValidator("timeoutNextStep", CfnBot_DialogStatePropertyValidator)(properties.timeoutNextStep)), errors.collect(cdk.propertyValidator("timeoutResponse", CfnBot_ResponseSpecificationPropertyValidator)(properties.timeoutResponse)), errors.wrap('supplied properties not correct for "PostDialogCodeHookInvocationSpecificationProperty"');
    }
    function cfnBotPostDialogCodeHookInvocationSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_PostDialogCodeHookInvocationSpecificationPropertyValidator(properties).assertSuccess(), { FailureConditional: cfnBotConditionalSpecificationPropertyToCloudFormation(properties.failureConditional), FailureNextStep: cfnBotDialogStatePropertyToCloudFormation(properties.failureNextStep), FailureResponse: cfnBotResponseSpecificationPropertyToCloudFormation(properties.failureResponse), SuccessConditional: cfnBotConditionalSpecificationPropertyToCloudFormation(properties.successConditional), SuccessNextStep: cfnBotDialogStatePropertyToCloudFormation(properties.successNextStep), SuccessResponse: cfnBotResponseSpecificationPropertyToCloudFormation(properties.successResponse), TimeoutConditional: cfnBotConditionalSpecificationPropertyToCloudFormation(properties.timeoutConditional), TimeoutNextStep: cfnBotDialogStatePropertyToCloudFormation(properties.timeoutNextStep), TimeoutResponse: cfnBotResponseSpecificationPropertyToCloudFormation(properties.timeoutResponse) }) : properties;
    }
    function CfnBotPostDialogCodeHookInvocationSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("failureConditional", "FailureConditional", properties.FailureConditional != null ? CfnBotConditionalSpecificationPropertyFromCloudFormation(properties.FailureConditional) : void 0), ret.addPropertyResult("failureNextStep", "FailureNextStep", properties.FailureNextStep != null ? CfnBotDialogStatePropertyFromCloudFormation(properties.FailureNextStep) : void 0), ret.addPropertyResult("failureResponse", "FailureResponse", properties.FailureResponse != null ? CfnBotResponseSpecificationPropertyFromCloudFormation(properties.FailureResponse) : void 0), ret.addPropertyResult("successConditional", "SuccessConditional", properties.SuccessConditional != null ? CfnBotConditionalSpecificationPropertyFromCloudFormation(properties.SuccessConditional) : void 0), ret.addPropertyResult("successNextStep", "SuccessNextStep", properties.SuccessNextStep != null ? CfnBotDialogStatePropertyFromCloudFormation(properties.SuccessNextStep) : void 0), ret.addPropertyResult("successResponse", "SuccessResponse", properties.SuccessResponse != null ? CfnBotResponseSpecificationPropertyFromCloudFormation(properties.SuccessResponse) : void 0), ret.addPropertyResult("timeoutConditional", "TimeoutConditional", properties.TimeoutConditional != null ? CfnBotConditionalSpecificationPropertyFromCloudFormation(properties.TimeoutConditional) : void 0), ret.addPropertyResult("timeoutNextStep", "TimeoutNextStep", properties.TimeoutNextStep != null ? CfnBotDialogStatePropertyFromCloudFormation(properties.TimeoutNextStep) : void 0), ret.addPropertyResult("timeoutResponse", "TimeoutResponse", properties.TimeoutResponse != null ? CfnBotResponseSpecificationPropertyFromCloudFormation(properties.TimeoutResponse) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_PostFulfillmentStatusSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("failureConditional", CfnBot_ConditionalSpecificationPropertyValidator)(properties.failureConditional)), errors.collect(cdk.propertyValidator("failureNextStep", CfnBot_DialogStatePropertyValidator)(properties.failureNextStep)), errors.collect(cdk.propertyValidator("failureResponse", CfnBot_ResponseSpecificationPropertyValidator)(properties.failureResponse)), errors.collect(cdk.propertyValidator("successConditional", CfnBot_ConditionalSpecificationPropertyValidator)(properties.successConditional)), errors.collect(cdk.propertyValidator("successNextStep", CfnBot_DialogStatePropertyValidator)(properties.successNextStep)), errors.collect(cdk.propertyValidator("successResponse", CfnBot_ResponseSpecificationPropertyValidator)(properties.successResponse)), errors.collect(cdk.propertyValidator("timeoutConditional", CfnBot_ConditionalSpecificationPropertyValidator)(properties.timeoutConditional)), errors.collect(cdk.propertyValidator("timeoutNextStep", CfnBot_DialogStatePropertyValidator)(properties.timeoutNextStep)), errors.collect(cdk.propertyValidator("timeoutResponse", CfnBot_ResponseSpecificationPropertyValidator)(properties.timeoutResponse)), errors.wrap('supplied properties not correct for "PostFulfillmentStatusSpecificationProperty"');
    }
    function cfnBotPostFulfillmentStatusSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_PostFulfillmentStatusSpecificationPropertyValidator(properties).assertSuccess(), { FailureConditional: cfnBotConditionalSpecificationPropertyToCloudFormation(properties.failureConditional), FailureNextStep: cfnBotDialogStatePropertyToCloudFormation(properties.failureNextStep), FailureResponse: cfnBotResponseSpecificationPropertyToCloudFormation(properties.failureResponse), SuccessConditional: cfnBotConditionalSpecificationPropertyToCloudFormation(properties.successConditional), SuccessNextStep: cfnBotDialogStatePropertyToCloudFormation(properties.successNextStep), SuccessResponse: cfnBotResponseSpecificationPropertyToCloudFormation(properties.successResponse), TimeoutConditional: cfnBotConditionalSpecificationPropertyToCloudFormation(properties.timeoutConditional), TimeoutNextStep: cfnBotDialogStatePropertyToCloudFormation(properties.timeoutNextStep), TimeoutResponse: cfnBotResponseSpecificationPropertyToCloudFormation(properties.timeoutResponse) }) : properties;
    }
    function CfnBotPostFulfillmentStatusSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("failureConditional", "FailureConditional", properties.FailureConditional != null ? CfnBotConditionalSpecificationPropertyFromCloudFormation(properties.FailureConditional) : void 0), ret.addPropertyResult("failureNextStep", "FailureNextStep", properties.FailureNextStep != null ? CfnBotDialogStatePropertyFromCloudFormation(properties.FailureNextStep) : void 0), ret.addPropertyResult("failureResponse", "FailureResponse", properties.FailureResponse != null ? CfnBotResponseSpecificationPropertyFromCloudFormation(properties.FailureResponse) : void 0), ret.addPropertyResult("successConditional", "SuccessConditional", properties.SuccessConditional != null ? CfnBotConditionalSpecificationPropertyFromCloudFormation(properties.SuccessConditional) : void 0), ret.addPropertyResult("successNextStep", "SuccessNextStep", properties.SuccessNextStep != null ? CfnBotDialogStatePropertyFromCloudFormation(properties.SuccessNextStep) : void 0), ret.addPropertyResult("successResponse", "SuccessResponse", properties.SuccessResponse != null ? CfnBotResponseSpecificationPropertyFromCloudFormation(properties.SuccessResponse) : void 0), ret.addPropertyResult("timeoutConditional", "TimeoutConditional", properties.TimeoutConditional != null ? CfnBotConditionalSpecificationPropertyFromCloudFormation(properties.TimeoutConditional) : void 0), ret.addPropertyResult("timeoutNextStep", "TimeoutNextStep", properties.TimeoutNextStep != null ? CfnBotDialogStatePropertyFromCloudFormation(properties.TimeoutNextStep) : void 0), ret.addPropertyResult("timeoutResponse", "TimeoutResponse", properties.TimeoutResponse != null ? CfnBotResponseSpecificationPropertyFromCloudFormation(properties.TimeoutResponse) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_PromptAttemptSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowInterrupt", cdk.validateBoolean)(properties.allowInterrupt)), errors.collect(cdk.propertyValidator("allowedInputTypes", cdk.requiredValidator)(properties.allowedInputTypes)), errors.collect(cdk.propertyValidator("allowedInputTypes", CfnBot_AllowedInputTypesPropertyValidator)(properties.allowedInputTypes)), errors.collect(cdk.propertyValidator("audioAndDtmfInputSpecification", CfnBot_AudioAndDTMFInputSpecificationPropertyValidator)(properties.audioAndDtmfInputSpecification)), errors.collect(cdk.propertyValidator("textInputSpecification", CfnBot_TextInputSpecificationPropertyValidator)(properties.textInputSpecification)), errors.wrap('supplied properties not correct for "PromptAttemptSpecificationProperty"');
    }
    function cfnBotPromptAttemptSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_PromptAttemptSpecificationPropertyValidator(properties).assertSuccess(), { AllowInterrupt: cdk.booleanToCloudFormation(properties.allowInterrupt), AllowedInputTypes: cfnBotAllowedInputTypesPropertyToCloudFormation(properties.allowedInputTypes), AudioAndDTMFInputSpecification: cfnBotAudioAndDTMFInputSpecificationPropertyToCloudFormation(properties.audioAndDtmfInputSpecification), TextInputSpecification: cfnBotTextInputSpecificationPropertyToCloudFormation(properties.textInputSpecification) }) : properties;
    }
    function CfnBotPromptAttemptSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowInterrupt", "AllowInterrupt", properties.AllowInterrupt != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllowInterrupt) : void 0), ret.addPropertyResult("allowedInputTypes", "AllowedInputTypes", CfnBotAllowedInputTypesPropertyFromCloudFormation(properties.AllowedInputTypes)), ret.addPropertyResult("audioAndDtmfInputSpecification", "AudioAndDTMFInputSpecification", properties.AudioAndDTMFInputSpecification != null ? CfnBotAudioAndDTMFInputSpecificationPropertyFromCloudFormation(properties.AudioAndDTMFInputSpecification) : void 0), ret.addPropertyResult("textInputSpecification", "TextInputSpecification", properties.TextInputSpecification != null ? CfnBotTextInputSpecificationPropertyFromCloudFormation(properties.TextInputSpecification) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_PromptSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowInterrupt", cdk.validateBoolean)(properties.allowInterrupt)), errors.collect(cdk.propertyValidator("maxRetries", cdk.requiredValidator)(properties.maxRetries)), errors.collect(cdk.propertyValidator("maxRetries", cdk.validateNumber)(properties.maxRetries)), errors.collect(cdk.propertyValidator("messageGroupsList", cdk.requiredValidator)(properties.messageGroupsList)), errors.collect(cdk.propertyValidator("messageGroupsList", cdk.listValidator(CfnBot_MessageGroupPropertyValidator))(properties.messageGroupsList)), errors.collect(cdk.propertyValidator("messageSelectionStrategy", cdk.validateString)(properties.messageSelectionStrategy)), errors.collect(cdk.propertyValidator("promptAttemptsSpecification", cdk.hashValidator(CfnBot_PromptAttemptSpecificationPropertyValidator))(properties.promptAttemptsSpecification)), errors.wrap('supplied properties not correct for "PromptSpecificationProperty"');
    }
    function cfnBotPromptSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_PromptSpecificationPropertyValidator(properties).assertSuccess(), { AllowInterrupt: cdk.booleanToCloudFormation(properties.allowInterrupt), MaxRetries: cdk.numberToCloudFormation(properties.maxRetries), MessageGroupsList: cdk.listMapper(cfnBotMessageGroupPropertyToCloudFormation)(properties.messageGroupsList), MessageSelectionStrategy: cdk.stringToCloudFormation(properties.messageSelectionStrategy), PromptAttemptsSpecification: cdk.hashMapper(cfnBotPromptAttemptSpecificationPropertyToCloudFormation)(properties.promptAttemptsSpecification) }) : properties;
    }
    function CfnBotPromptSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowInterrupt", "AllowInterrupt", properties.AllowInterrupt != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllowInterrupt) : void 0), ret.addPropertyResult("maxRetries", "MaxRetries", cfn_parse.FromCloudFormation.getNumber(properties.MaxRetries)), ret.addPropertyResult("messageGroupsList", "MessageGroupsList", cfn_parse.FromCloudFormation.getArray(CfnBotMessageGroupPropertyFromCloudFormation)(properties.MessageGroupsList)), ret.addPropertyResult("messageSelectionStrategy", "MessageSelectionStrategy", properties.MessageSelectionStrategy != null ? cfn_parse.FromCloudFormation.getString(properties.MessageSelectionStrategy) : void 0), ret.addPropertyResult("promptAttemptsSpecification", "PromptAttemptsSpecification", properties.PromptAttemptsSpecification != null ? cfn_parse.FromCloudFormation.getMap(CfnBotPromptAttemptSpecificationPropertyFromCloudFormation)(properties.PromptAttemptsSpecification) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_ResponseSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowInterrupt", cdk.validateBoolean)(properties.allowInterrupt)), errors.collect(cdk.propertyValidator("messageGroupsList", cdk.requiredValidator)(properties.messageGroupsList)), errors.collect(cdk.propertyValidator("messageGroupsList", cdk.listValidator(CfnBot_MessageGroupPropertyValidator))(properties.messageGroupsList)), errors.wrap('supplied properties not correct for "ResponseSpecificationProperty"');
    }
    function cfnBotResponseSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_ResponseSpecificationPropertyValidator(properties).assertSuccess(), { AllowInterrupt: cdk.booleanToCloudFormation(properties.allowInterrupt), MessageGroupsList: cdk.listMapper(cfnBotMessageGroupPropertyToCloudFormation)(properties.messageGroupsList) }) : properties;
    }
    function CfnBotResponseSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowInterrupt", "AllowInterrupt", properties.AllowInterrupt != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllowInterrupt) : void 0), ret.addPropertyResult("messageGroupsList", "MessageGroupsList", cfn_parse.FromCloudFormation.getArray(CfnBotMessageGroupPropertyFromCloudFormation)(properties.MessageGroupsList)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_S3BucketLogDestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kmsKeyArn", cdk.validateString)(properties.kmsKeyArn)), errors.collect(cdk.propertyValidator("logPrefix", cdk.requiredValidator)(properties.logPrefix)), errors.collect(cdk.propertyValidator("logPrefix", cdk.validateString)(properties.logPrefix)), errors.collect(cdk.propertyValidator("s3BucketArn", cdk.requiredValidator)(properties.s3BucketArn)), errors.collect(cdk.propertyValidator("s3BucketArn", cdk.validateString)(properties.s3BucketArn)), errors.wrap('supplied properties not correct for "S3BucketLogDestinationProperty"');
    }
    function cfnBotS3BucketLogDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_S3BucketLogDestinationPropertyValidator(properties).assertSuccess(), { KmsKeyArn: cdk.stringToCloudFormation(properties.kmsKeyArn), LogPrefix: cdk.stringToCloudFormation(properties.logPrefix), S3BucketArn: cdk.stringToCloudFormation(properties.s3BucketArn) }) : properties;
    }
    function CfnBotS3BucketLogDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsKeyArn", "KmsKeyArn", properties.KmsKeyArn != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyArn) : void 0), ret.addPropertyResult("logPrefix", "LogPrefix", cfn_parse.FromCloudFormation.getString(properties.LogPrefix)), ret.addPropertyResult("s3BucketArn", "S3BucketArn", cfn_parse.FromCloudFormation.getString(properties.S3BucketArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_S3LocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3Bucket", cdk.requiredValidator)(properties.s3Bucket)), errors.collect(cdk.propertyValidator("s3Bucket", cdk.validateString)(properties.s3Bucket)), errors.collect(cdk.propertyValidator("s3ObjectKey", cdk.requiredValidator)(properties.s3ObjectKey)), errors.collect(cdk.propertyValidator("s3ObjectKey", cdk.validateString)(properties.s3ObjectKey)), errors.collect(cdk.propertyValidator("s3ObjectVersion", cdk.validateString)(properties.s3ObjectVersion)), errors.wrap('supplied properties not correct for "S3LocationProperty"');
    }
    function cfnBotS3LocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_S3LocationPropertyValidator(properties).assertSuccess(), { S3Bucket: cdk.stringToCloudFormation(properties.s3Bucket), S3ObjectKey: cdk.stringToCloudFormation(properties.s3ObjectKey), S3ObjectVersion: cdk.stringToCloudFormation(properties.s3ObjectVersion) }) : properties;
    }
    function CfnBotS3LocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Bucket", "S3Bucket", cfn_parse.FromCloudFormation.getString(properties.S3Bucket)), ret.addPropertyResult("s3ObjectKey", "S3ObjectKey", cfn_parse.FromCloudFormation.getString(properties.S3ObjectKey)), ret.addPropertyResult("s3ObjectVersion", "S3ObjectVersion", properties.S3ObjectVersion != null ? cfn_parse.FromCloudFormation.getString(properties.S3ObjectVersion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_SSMLMessagePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "SSMLMessageProperty"');
    }
    function cfnBotSSMLMessagePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_SSMLMessagePropertyValidator(properties).assertSuccess(), { Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnBotSSMLMessagePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_SampleUtterancePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("utterance", cdk.requiredValidator)(properties.utterance)), errors.collect(cdk.propertyValidator("utterance", cdk.validateString)(properties.utterance)), errors.wrap('supplied properties not correct for "SampleUtteranceProperty"');
    }
    function cfnBotSampleUtterancePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_SampleUtterancePropertyValidator(properties).assertSuccess(), { Utterance: cdk.stringToCloudFormation(properties.utterance) }) : properties;
    }
    function CfnBotSampleUtterancePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("utterance", "Utterance", cfn_parse.FromCloudFormation.getString(properties.Utterance)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_SampleValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "SampleValueProperty"');
    }
    function cfnBotSampleValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_SampleValuePropertyValidator(properties).assertSuccess(), { Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnBotSampleValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_SessionAttributePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "SessionAttributeProperty"');
    }
    function cfnBotSessionAttributePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_SessionAttributePropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnBotSessionAttributePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_SlotPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("multipleValuesSetting", CfnBot_MultipleValuesSettingPropertyValidator)(properties.multipleValuesSetting)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("obfuscationSetting", CfnBot_ObfuscationSettingPropertyValidator)(properties.obfuscationSetting)), errors.collect(cdk.propertyValidator("slotTypeName", cdk.requiredValidator)(properties.slotTypeName)), errors.collect(cdk.propertyValidator("slotTypeName", cdk.validateString)(properties.slotTypeName)), errors.collect(cdk.propertyValidator("valueElicitationSetting", cdk.requiredValidator)(properties.valueElicitationSetting)), errors.collect(cdk.propertyValidator("valueElicitationSetting", CfnBot_SlotValueElicitationSettingPropertyValidator)(properties.valueElicitationSetting)), errors.wrap('supplied properties not correct for "SlotProperty"');
    }
    function cfnBotSlotPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_SlotPropertyValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), MultipleValuesSetting: cfnBotMultipleValuesSettingPropertyToCloudFormation(properties.multipleValuesSetting), Name: cdk.stringToCloudFormation(properties.name), ObfuscationSetting: cfnBotObfuscationSettingPropertyToCloudFormation(properties.obfuscationSetting), SlotTypeName: cdk.stringToCloudFormation(properties.slotTypeName), ValueElicitationSetting: cfnBotSlotValueElicitationSettingPropertyToCloudFormation(properties.valueElicitationSetting) }) : properties;
    }
    function CfnBotSlotPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("multipleValuesSetting", "MultipleValuesSetting", properties.MultipleValuesSetting != null ? CfnBotMultipleValuesSettingPropertyFromCloudFormation(properties.MultipleValuesSetting) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("obfuscationSetting", "ObfuscationSetting", properties.ObfuscationSetting != null ? CfnBotObfuscationSettingPropertyFromCloudFormation(properties.ObfuscationSetting) : void 0), ret.addPropertyResult("slotTypeName", "SlotTypeName", cfn_parse.FromCloudFormation.getString(properties.SlotTypeName)), ret.addPropertyResult("valueElicitationSetting", "ValueElicitationSetting", CfnBotSlotValueElicitationSettingPropertyFromCloudFormation(properties.ValueElicitationSetting)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_SlotCaptureSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("captureConditional", CfnBot_ConditionalSpecificationPropertyValidator)(properties.captureConditional)), errors.collect(cdk.propertyValidator("captureNextStep", CfnBot_DialogStatePropertyValidator)(properties.captureNextStep)), errors.collect(cdk.propertyValidator("captureResponse", CfnBot_ResponseSpecificationPropertyValidator)(properties.captureResponse)), errors.collect(cdk.propertyValidator("codeHook", CfnBot_DialogCodeHookInvocationSettingPropertyValidator)(properties.codeHook)), errors.collect(cdk.propertyValidator("elicitationCodeHook", CfnBot_ElicitationCodeHookInvocationSettingPropertyValidator)(properties.elicitationCodeHook)), errors.collect(cdk.propertyValidator("failureConditional", CfnBot_ConditionalSpecificationPropertyValidator)(properties.failureConditional)), errors.collect(cdk.propertyValidator("failureNextStep", CfnBot_DialogStatePropertyValidator)(properties.failureNextStep)), errors.collect(cdk.propertyValidator("failureResponse", CfnBot_ResponseSpecificationPropertyValidator)(properties.failureResponse)), errors.wrap('supplied properties not correct for "SlotCaptureSettingProperty"');
    }
    function cfnBotSlotCaptureSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_SlotCaptureSettingPropertyValidator(properties).assertSuccess(), { CaptureConditional: cfnBotConditionalSpecificationPropertyToCloudFormation(properties.captureConditional), CaptureNextStep: cfnBotDialogStatePropertyToCloudFormation(properties.captureNextStep), CaptureResponse: cfnBotResponseSpecificationPropertyToCloudFormation(properties.captureResponse), CodeHook: cfnBotDialogCodeHookInvocationSettingPropertyToCloudFormation(properties.codeHook), ElicitationCodeHook: cfnBotElicitationCodeHookInvocationSettingPropertyToCloudFormation(properties.elicitationCodeHook), FailureConditional: cfnBotConditionalSpecificationPropertyToCloudFormation(properties.failureConditional), FailureNextStep: cfnBotDialogStatePropertyToCloudFormation(properties.failureNextStep), FailureResponse: cfnBotResponseSpecificationPropertyToCloudFormation(properties.failureResponse) }) : properties;
    }
    function CfnBotSlotCaptureSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("captureConditional", "CaptureConditional", properties.CaptureConditional != null ? CfnBotConditionalSpecificationPropertyFromCloudFormation(properties.CaptureConditional) : void 0), ret.addPropertyResult("captureNextStep", "CaptureNextStep", properties.CaptureNextStep != null ? CfnBotDialogStatePropertyFromCloudFormation(properties.CaptureNextStep) : void 0), ret.addPropertyResult("captureResponse", "CaptureResponse", properties.CaptureResponse != null ? CfnBotResponseSpecificationPropertyFromCloudFormation(properties.CaptureResponse) : void 0), ret.addPropertyResult("codeHook", "CodeHook", properties.CodeHook != null ? CfnBotDialogCodeHookInvocationSettingPropertyFromCloudFormation(properties.CodeHook) : void 0), ret.addPropertyResult("elicitationCodeHook", "ElicitationCodeHook", properties.ElicitationCodeHook != null ? CfnBotElicitationCodeHookInvocationSettingPropertyFromCloudFormation(properties.ElicitationCodeHook) : void 0), ret.addPropertyResult("failureConditional", "FailureConditional", properties.FailureConditional != null ? CfnBotConditionalSpecificationPropertyFromCloudFormation(properties.FailureConditional) : void 0), ret.addPropertyResult("failureNextStep", "FailureNextStep", properties.FailureNextStep != null ? CfnBotDialogStatePropertyFromCloudFormation(properties.FailureNextStep) : void 0), ret.addPropertyResult("failureResponse", "FailureResponse", properties.FailureResponse != null ? CfnBotResponseSpecificationPropertyFromCloudFormation(properties.FailureResponse) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_SlotDefaultValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultValue", cdk.requiredValidator)(properties.defaultValue)), errors.collect(cdk.propertyValidator("defaultValue", cdk.validateString)(properties.defaultValue)), errors.wrap('supplied properties not correct for "SlotDefaultValueProperty"');
    }
    function cfnBotSlotDefaultValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_SlotDefaultValuePropertyValidator(properties).assertSuccess(), { DefaultValue: cdk.stringToCloudFormation(properties.defaultValue) }) : properties;
    }
    function CfnBotSlotDefaultValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultValue", "DefaultValue", cfn_parse.FromCloudFormation.getString(properties.DefaultValue)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_SlotDefaultValueSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultValueList", cdk.requiredValidator)(properties.defaultValueList)), errors.collect(cdk.propertyValidator("defaultValueList", cdk.listValidator(CfnBot_SlotDefaultValuePropertyValidator))(properties.defaultValueList)), errors.wrap('supplied properties not correct for "SlotDefaultValueSpecificationProperty"');
    }
    function cfnBotSlotDefaultValueSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_SlotDefaultValueSpecificationPropertyValidator(properties).assertSuccess(), { DefaultValueList: cdk.listMapper(cfnBotSlotDefaultValuePropertyToCloudFormation)(properties.defaultValueList) }) : properties;
    }
    function CfnBotSlotDefaultValueSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultValueList", "DefaultValueList", cfn_parse.FromCloudFormation.getArray(CfnBotSlotDefaultValuePropertyFromCloudFormation)(properties.DefaultValueList)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_SlotPriorityPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("priority", cdk.requiredValidator)(properties.priority)), errors.collect(cdk.propertyValidator("priority", cdk.validateNumber)(properties.priority)), errors.collect(cdk.propertyValidator("slotName", cdk.requiredValidator)(properties.slotName)), errors.collect(cdk.propertyValidator("slotName", cdk.validateString)(properties.slotName)), errors.wrap('supplied properties not correct for "SlotPriorityProperty"');
    }
    function cfnBotSlotPriorityPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_SlotPriorityPropertyValidator(properties).assertSuccess(), { Priority: cdk.numberToCloudFormation(properties.priority), SlotName: cdk.stringToCloudFormation(properties.slotName) }) : properties;
    }
    function CfnBotSlotPriorityPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("priority", "Priority", cfn_parse.FromCloudFormation.getNumber(properties.Priority)), ret.addPropertyResult("slotName", "SlotName", cfn_parse.FromCloudFormation.getString(properties.SlotName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_SlotTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("externalSourceSetting", CfnBot_ExternalSourceSettingPropertyValidator)(properties.externalSourceSetting)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("parentSlotTypeSignature", cdk.validateString)(properties.parentSlotTypeSignature)), errors.collect(cdk.propertyValidator("slotTypeValues", cdk.listValidator(CfnBot_SlotTypeValuePropertyValidator))(properties.slotTypeValues)), errors.collect(cdk.propertyValidator("valueSelectionSetting", CfnBot_SlotValueSelectionSettingPropertyValidator)(properties.valueSelectionSetting)), errors.wrap('supplied properties not correct for "SlotTypeProperty"');
    }
    function cfnBotSlotTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_SlotTypePropertyValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), ExternalSourceSetting: cfnBotExternalSourceSettingPropertyToCloudFormation(properties.externalSourceSetting), Name: cdk.stringToCloudFormation(properties.name), ParentSlotTypeSignature: cdk.stringToCloudFormation(properties.parentSlotTypeSignature), SlotTypeValues: cdk.listMapper(cfnBotSlotTypeValuePropertyToCloudFormation)(properties.slotTypeValues), ValueSelectionSetting: cfnBotSlotValueSelectionSettingPropertyToCloudFormation(properties.valueSelectionSetting) }) : properties;
    }
    function CfnBotSlotTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("externalSourceSetting", "ExternalSourceSetting", properties.ExternalSourceSetting != null ? CfnBotExternalSourceSettingPropertyFromCloudFormation(properties.ExternalSourceSetting) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("parentSlotTypeSignature", "ParentSlotTypeSignature", properties.ParentSlotTypeSignature != null ? cfn_parse.FromCloudFormation.getString(properties.ParentSlotTypeSignature) : void 0), ret.addPropertyResult("slotTypeValues", "SlotTypeValues", properties.SlotTypeValues != null ? cfn_parse.FromCloudFormation.getArray(CfnBotSlotTypeValuePropertyFromCloudFormation)(properties.SlotTypeValues) : void 0), ret.addPropertyResult("valueSelectionSetting", "ValueSelectionSetting", properties.ValueSelectionSetting != null ? CfnBotSlotValueSelectionSettingPropertyFromCloudFormation(properties.ValueSelectionSetting) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_SlotTypeValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sampleValue", cdk.requiredValidator)(properties.sampleValue)), errors.collect(cdk.propertyValidator("sampleValue", CfnBot_SampleValuePropertyValidator)(properties.sampleValue)), errors.collect(cdk.propertyValidator("synonyms", cdk.listValidator(CfnBot_SampleValuePropertyValidator))(properties.synonyms)), errors.wrap('supplied properties not correct for "SlotTypeValueProperty"');
    }
    function cfnBotSlotTypeValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_SlotTypeValuePropertyValidator(properties).assertSuccess(), { SampleValue: cfnBotSampleValuePropertyToCloudFormation(properties.sampleValue), Synonyms: cdk.listMapper(cfnBotSampleValuePropertyToCloudFormation)(properties.synonyms) }) : properties;
    }
    function CfnBotSlotTypeValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sampleValue", "SampleValue", CfnBotSampleValuePropertyFromCloudFormation(properties.SampleValue)), ret.addPropertyResult("synonyms", "Synonyms", properties.Synonyms != null ? cfn_parse.FromCloudFormation.getArray(CfnBotSampleValuePropertyFromCloudFormation)(properties.Synonyms) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_SlotValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("interpretedValue", cdk.validateString)(properties.interpretedValue)), errors.wrap('supplied properties not correct for "SlotValueProperty"');
    }
    function cfnBotSlotValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_SlotValuePropertyValidator(properties).assertSuccess(), { InterpretedValue: cdk.stringToCloudFormation(properties.interpretedValue) }) : properties;
    }
    function CfnBotSlotValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("interpretedValue", "InterpretedValue", properties.InterpretedValue != null ? cfn_parse.FromCloudFormation.getString(properties.InterpretedValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_SlotValueElicitationSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultValueSpecification", CfnBot_SlotDefaultValueSpecificationPropertyValidator)(properties.defaultValueSpecification)), errors.collect(cdk.propertyValidator("promptSpecification", CfnBot_PromptSpecificationPropertyValidator)(properties.promptSpecification)), errors.collect(cdk.propertyValidator("sampleUtterances", cdk.listValidator(CfnBot_SampleUtterancePropertyValidator))(properties.sampleUtterances)), errors.collect(cdk.propertyValidator("slotCaptureSetting", CfnBot_SlotCaptureSettingPropertyValidator)(properties.slotCaptureSetting)), errors.collect(cdk.propertyValidator("slotConstraint", cdk.requiredValidator)(properties.slotConstraint)), errors.collect(cdk.propertyValidator("slotConstraint", cdk.validateString)(properties.slotConstraint)), errors.collect(cdk.propertyValidator("waitAndContinueSpecification", CfnBot_WaitAndContinueSpecificationPropertyValidator)(properties.waitAndContinueSpecification)), errors.wrap('supplied properties not correct for "SlotValueElicitationSettingProperty"');
    }
    function cfnBotSlotValueElicitationSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_SlotValueElicitationSettingPropertyValidator(properties).assertSuccess(), { DefaultValueSpecification: cfnBotSlotDefaultValueSpecificationPropertyToCloudFormation(properties.defaultValueSpecification), PromptSpecification: cfnBotPromptSpecificationPropertyToCloudFormation(properties.promptSpecification), SampleUtterances: cdk.listMapper(cfnBotSampleUtterancePropertyToCloudFormation)(properties.sampleUtterances), SlotCaptureSetting: cfnBotSlotCaptureSettingPropertyToCloudFormation(properties.slotCaptureSetting), SlotConstraint: cdk.stringToCloudFormation(properties.slotConstraint), WaitAndContinueSpecification: cfnBotWaitAndContinueSpecificationPropertyToCloudFormation(properties.waitAndContinueSpecification) }) : properties;
    }
    function CfnBotSlotValueElicitationSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultValueSpecification", "DefaultValueSpecification", properties.DefaultValueSpecification != null ? CfnBotSlotDefaultValueSpecificationPropertyFromCloudFormation(properties.DefaultValueSpecification) : void 0), ret.addPropertyResult("promptSpecification", "PromptSpecification", properties.PromptSpecification != null ? CfnBotPromptSpecificationPropertyFromCloudFormation(properties.PromptSpecification) : void 0), ret.addPropertyResult("sampleUtterances", "SampleUtterances", properties.SampleUtterances != null ? cfn_parse.FromCloudFormation.getArray(CfnBotSampleUtterancePropertyFromCloudFormation)(properties.SampleUtterances) : void 0), ret.addPropertyResult("slotCaptureSetting", "SlotCaptureSetting", properties.SlotCaptureSetting != null ? CfnBotSlotCaptureSettingPropertyFromCloudFormation(properties.SlotCaptureSetting) : void 0), ret.addPropertyResult("slotConstraint", "SlotConstraint", cfn_parse.FromCloudFormation.getString(properties.SlotConstraint)), ret.addPropertyResult("waitAndContinueSpecification", "WaitAndContinueSpecification", properties.WaitAndContinueSpecification != null ? CfnBotWaitAndContinueSpecificationPropertyFromCloudFormation(properties.WaitAndContinueSpecification) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_SlotValueOverridePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("shape", cdk.validateString)(properties.shape)), errors.collect(cdk.propertyValidator("value", CfnBot_SlotValuePropertyValidator)(properties.value)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnBot_SlotValueOverridePropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "SlotValueOverrideProperty"');
    }
    function cfnBotSlotValueOverridePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_SlotValueOverridePropertyValidator(properties).assertSuccess(), { Shape: cdk.stringToCloudFormation(properties.shape), Value: cfnBotSlotValuePropertyToCloudFormation(properties.value), Values: cdk.listMapper(cfnBotSlotValueOverridePropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnBotSlotValueOverridePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("shape", "Shape", properties.Shape != null ? cfn_parse.FromCloudFormation.getString(properties.Shape) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? CfnBotSlotValuePropertyFromCloudFormation(properties.Value) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnBotSlotValueOverridePropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_SlotValueOverrideMapPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("slotName", cdk.validateString)(properties.slotName)), errors.collect(cdk.propertyValidator("slotValueOverride", CfnBot_SlotValueOverridePropertyValidator)(properties.slotValueOverride)), errors.wrap('supplied properties not correct for "SlotValueOverrideMapProperty"');
    }
    function cfnBotSlotValueOverrideMapPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_SlotValueOverrideMapPropertyValidator(properties).assertSuccess(), { SlotName: cdk.stringToCloudFormation(properties.slotName), SlotValueOverride: cfnBotSlotValueOverridePropertyToCloudFormation(properties.slotValueOverride) }) : properties;
    }
    function CfnBotSlotValueOverrideMapPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("slotName", "SlotName", properties.SlotName != null ? cfn_parse.FromCloudFormation.getString(properties.SlotName) : void 0), ret.addPropertyResult("slotValueOverride", "SlotValueOverride", properties.SlotValueOverride != null ? CfnBotSlotValueOverridePropertyFromCloudFormation(properties.SlotValueOverride) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_SlotValueRegexFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("pattern", cdk.requiredValidator)(properties.pattern)), errors.collect(cdk.propertyValidator("pattern", cdk.validateString)(properties.pattern)), errors.wrap('supplied properties not correct for "SlotValueRegexFilterProperty"');
    }
    function cfnBotSlotValueRegexFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_SlotValueRegexFilterPropertyValidator(properties).assertSuccess(), { Pattern: cdk.stringToCloudFormation(properties.pattern) }) : properties;
    }
    function CfnBotSlotValueRegexFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("pattern", "Pattern", cfn_parse.FromCloudFormation.getString(properties.Pattern)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_SlotValueSelectionSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("advancedRecognitionSetting", CfnBot_AdvancedRecognitionSettingPropertyValidator)(properties.advancedRecognitionSetting)), errors.collect(cdk.propertyValidator("regexFilter", CfnBot_SlotValueRegexFilterPropertyValidator)(properties.regexFilter)), errors.collect(cdk.propertyValidator("resolutionStrategy", cdk.requiredValidator)(properties.resolutionStrategy)), errors.collect(cdk.propertyValidator("resolutionStrategy", cdk.validateString)(properties.resolutionStrategy)), errors.wrap('supplied properties not correct for "SlotValueSelectionSettingProperty"');
    }
    function cfnBotSlotValueSelectionSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_SlotValueSelectionSettingPropertyValidator(properties).assertSuccess(), { AdvancedRecognitionSetting: cfnBotAdvancedRecognitionSettingPropertyToCloudFormation(properties.advancedRecognitionSetting), RegexFilter: cfnBotSlotValueRegexFilterPropertyToCloudFormation(properties.regexFilter), ResolutionStrategy: cdk.stringToCloudFormation(properties.resolutionStrategy) }) : properties;
    }
    function CfnBotSlotValueSelectionSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("advancedRecognitionSetting", "AdvancedRecognitionSetting", properties.AdvancedRecognitionSetting != null ? CfnBotAdvancedRecognitionSettingPropertyFromCloudFormation(properties.AdvancedRecognitionSetting) : void 0), ret.addPropertyResult("regexFilter", "RegexFilter", properties.RegexFilter != null ? CfnBotSlotValueRegexFilterPropertyFromCloudFormation(properties.RegexFilter) : void 0), ret.addPropertyResult("resolutionStrategy", "ResolutionStrategy", cfn_parse.FromCloudFormation.getString(properties.ResolutionStrategy)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_StillWaitingResponseSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowInterrupt", cdk.validateBoolean)(properties.allowInterrupt)), errors.collect(cdk.propertyValidator("frequencyInSeconds", cdk.requiredValidator)(properties.frequencyInSeconds)), errors.collect(cdk.propertyValidator("frequencyInSeconds", cdk.validateNumber)(properties.frequencyInSeconds)), errors.collect(cdk.propertyValidator("messageGroupsList", cdk.requiredValidator)(properties.messageGroupsList)), errors.collect(cdk.propertyValidator("messageGroupsList", cdk.listValidator(CfnBot_MessageGroupPropertyValidator))(properties.messageGroupsList)), errors.collect(cdk.propertyValidator("timeoutInSeconds", cdk.requiredValidator)(properties.timeoutInSeconds)), errors.collect(cdk.propertyValidator("timeoutInSeconds", cdk.validateNumber)(properties.timeoutInSeconds)), errors.wrap('supplied properties not correct for "StillWaitingResponseSpecificationProperty"');
    }
    function cfnBotStillWaitingResponseSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_StillWaitingResponseSpecificationPropertyValidator(properties).assertSuccess(), { AllowInterrupt: cdk.booleanToCloudFormation(properties.allowInterrupt), FrequencyInSeconds: cdk.numberToCloudFormation(properties.frequencyInSeconds), MessageGroupsList: cdk.listMapper(cfnBotMessageGroupPropertyToCloudFormation)(properties.messageGroupsList), TimeoutInSeconds: cdk.numberToCloudFormation(properties.timeoutInSeconds) }) : properties;
    }
    function CfnBotStillWaitingResponseSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowInterrupt", "AllowInterrupt", properties.AllowInterrupt != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllowInterrupt) : void 0), ret.addPropertyResult("frequencyInSeconds", "FrequencyInSeconds", cfn_parse.FromCloudFormation.getNumber(properties.FrequencyInSeconds)), ret.addPropertyResult("messageGroupsList", "MessageGroupsList", cfn_parse.FromCloudFormation.getArray(CfnBotMessageGroupPropertyFromCloudFormation)(properties.MessageGroupsList)), ret.addPropertyResult("timeoutInSeconds", "TimeoutInSeconds", cfn_parse.FromCloudFormation.getNumber(properties.TimeoutInSeconds)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_TestBotAliasSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("botAliasLocaleSettings", cdk.listValidator(CfnBot_BotAliasLocaleSettingsItemPropertyValidator))(properties.botAliasLocaleSettings)), errors.collect(cdk.propertyValidator("conversationLogSettings", CfnBot_ConversationLogSettingsPropertyValidator)(properties.conversationLogSettings)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("sentimentAnalysisSettings", cdk.validateObject)(properties.sentimentAnalysisSettings)), errors.wrap('supplied properties not correct for "TestBotAliasSettingsProperty"');
    }
    function cfnBotTestBotAliasSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_TestBotAliasSettingsPropertyValidator(properties).assertSuccess(), { BotAliasLocaleSettings: cdk.listMapper(cfnBotBotAliasLocaleSettingsItemPropertyToCloudFormation)(properties.botAliasLocaleSettings), ConversationLogSettings: cfnBotConversationLogSettingsPropertyToCloudFormation(properties.conversationLogSettings), Description: cdk.stringToCloudFormation(properties.description), SentimentAnalysisSettings: cdk.objectToCloudFormation(properties.sentimentAnalysisSettings) }) : properties;
    }
    function CfnBotTestBotAliasSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("botAliasLocaleSettings", "BotAliasLocaleSettings", properties.BotAliasLocaleSettings != null ? cfn_parse.FromCloudFormation.getArray(CfnBotBotAliasLocaleSettingsItemPropertyFromCloudFormation)(properties.BotAliasLocaleSettings) : void 0), ret.addPropertyResult("conversationLogSettings", "ConversationLogSettings", properties.ConversationLogSettings != null ? CfnBotConversationLogSettingsPropertyFromCloudFormation(properties.ConversationLogSettings) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("sentimentAnalysisSettings", "SentimentAnalysisSettings", properties.SentimentAnalysisSettings != null ? cfn_parse.FromCloudFormation.getAny(properties.SentimentAnalysisSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_TextInputSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("startTimeoutMs", cdk.requiredValidator)(properties.startTimeoutMs)), errors.collect(cdk.propertyValidator("startTimeoutMs", cdk.validateNumber)(properties.startTimeoutMs)), errors.wrap('supplied properties not correct for "TextInputSpecificationProperty"');
    }
    function cfnBotTextInputSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_TextInputSpecificationPropertyValidator(properties).assertSuccess(), { StartTimeoutMs: cdk.numberToCloudFormation(properties.startTimeoutMs) }) : properties;
    }
    function CfnBotTextInputSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("startTimeoutMs", "StartTimeoutMs", cfn_parse.FromCloudFormation.getNumber(properties.StartTimeoutMs)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_TextLogDestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatch", cdk.requiredValidator)(properties.cloudWatch)), errors.collect(cdk.propertyValidator("cloudWatch", CfnBot_CloudWatchLogGroupLogDestinationPropertyValidator)(properties.cloudWatch)), errors.wrap('supplied properties not correct for "TextLogDestinationProperty"');
    }
    function cfnBotTextLogDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_TextLogDestinationPropertyValidator(properties).assertSuccess(), { CloudWatch: cfnBotCloudWatchLogGroupLogDestinationPropertyToCloudFormation(properties.cloudWatch) }) : properties;
    }
    function CfnBotTextLogDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatch", "CloudWatch", CfnBotCloudWatchLogGroupLogDestinationPropertyFromCloudFormation(properties.CloudWatch)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_TextLogSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destination", cdk.requiredValidator)(properties.destination)), errors.collect(cdk.propertyValidator("destination", CfnBot_TextLogDestinationPropertyValidator)(properties.destination)), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "TextLogSettingProperty"');
    }
    function cfnBotTextLogSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_TextLogSettingPropertyValidator(properties).assertSuccess(), { Destination: cfnBotTextLogDestinationPropertyToCloudFormation(properties.destination), Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnBotTextLogSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destination", "Destination", CfnBotTextLogDestinationPropertyFromCloudFormation(properties.Destination)), ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_VoiceSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("engine", cdk.validateString)(properties.engine)), errors.collect(cdk.propertyValidator("voiceId", cdk.requiredValidator)(properties.voiceId)), errors.collect(cdk.propertyValidator("voiceId", cdk.validateString)(properties.voiceId)), errors.wrap('supplied properties not correct for "VoiceSettingsProperty"');
    }
    function cfnBotVoiceSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_VoiceSettingsPropertyValidator(properties).assertSuccess(), { Engine: cdk.stringToCloudFormation(properties.engine), VoiceId: cdk.stringToCloudFormation(properties.voiceId) }) : properties;
    }
    function CfnBotVoiceSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("engine", "Engine", properties.Engine != null ? cfn_parse.FromCloudFormation.getString(properties.Engine) : void 0), ret.addPropertyResult("voiceId", "VoiceId", cfn_parse.FromCloudFormation.getString(properties.VoiceId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBot_WaitAndContinueSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("continueResponse", cdk.requiredValidator)(properties.continueResponse)), errors.collect(cdk.propertyValidator("continueResponse", CfnBot_ResponseSpecificationPropertyValidator)(properties.continueResponse)), errors.collect(cdk.propertyValidator("isActive", cdk.validateBoolean)(properties.isActive)), errors.collect(cdk.propertyValidator("stillWaitingResponse", CfnBot_StillWaitingResponseSpecificationPropertyValidator)(properties.stillWaitingResponse)), errors.collect(cdk.propertyValidator("waitingResponse", cdk.requiredValidator)(properties.waitingResponse)), errors.collect(cdk.propertyValidator("waitingResponse", CfnBot_ResponseSpecificationPropertyValidator)(properties.waitingResponse)), errors.wrap('supplied properties not correct for "WaitAndContinueSpecificationProperty"');
    }
    function cfnBotWaitAndContinueSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBot_WaitAndContinueSpecificationPropertyValidator(properties).assertSuccess(), { ContinueResponse: cfnBotResponseSpecificationPropertyToCloudFormation(properties.continueResponse), IsActive: cdk.booleanToCloudFormation(properties.isActive), StillWaitingResponse: cfnBotStillWaitingResponseSpecificationPropertyToCloudFormation(properties.stillWaitingResponse), WaitingResponse: cfnBotResponseSpecificationPropertyToCloudFormation(properties.waitingResponse) }) : properties;
    }
    function CfnBotWaitAndContinueSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("continueResponse", "ContinueResponse", CfnBotResponseSpecificationPropertyFromCloudFormation(properties.ContinueResponse)), ret.addPropertyResult("isActive", "IsActive", properties.IsActive != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsActive) : void 0), ret.addPropertyResult("stillWaitingResponse", "StillWaitingResponse", properties.StillWaitingResponse != null ? CfnBotStillWaitingResponseSpecificationPropertyFromCloudFormation(properties.StillWaitingResponse) : void 0), ret.addPropertyResult("waitingResponse", "WaitingResponse", CfnBotResponseSpecificationPropertyFromCloudFormation(properties.WaitingResponse)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBotAliasPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("botAliasLocaleSettings", cdk.listValidator(CfnBotAlias_BotAliasLocaleSettingsItemPropertyValidator))(properties.botAliasLocaleSettings)), errors.collect(cdk.propertyValidator("botAliasName", cdk.requiredValidator)(properties.botAliasName)), errors.collect(cdk.propertyValidator("botAliasName", cdk.validateString)(properties.botAliasName)), errors.collect(cdk.propertyValidator("botAliasTags", cdk.listValidator(cdk.validateCfnTag))(properties.botAliasTags)), errors.collect(cdk.propertyValidator("botId", cdk.requiredValidator)(properties.botId)), errors.collect(cdk.propertyValidator("botId", cdk.validateString)(properties.botId)), errors.collect(cdk.propertyValidator("botVersion", cdk.validateString)(properties.botVersion)), errors.collect(cdk.propertyValidator("conversationLogSettings", CfnBotAlias_ConversationLogSettingsPropertyValidator)(properties.conversationLogSettings)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("sentimentAnalysisSettings", cdk.validateObject)(properties.sentimentAnalysisSettings)), errors.wrap('supplied properties not correct for "CfnBotAliasProps"');
    }
    function cfnBotAliasPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBotAliasPropsValidator(properties).assertSuccess(), { BotAliasName: cdk.stringToCloudFormation(properties.botAliasName), BotId: cdk.stringToCloudFormation(properties.botId), BotAliasLocaleSettings: cdk.listMapper(cfnBotAliasBotAliasLocaleSettingsItemPropertyToCloudFormation)(properties.botAliasLocaleSettings), BotAliasTags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.botAliasTags), BotVersion: cdk.stringToCloudFormation(properties.botVersion), ConversationLogSettings: cfnBotAliasConversationLogSettingsPropertyToCloudFormation(properties.conversationLogSettings), Description: cdk.stringToCloudFormation(properties.description), SentimentAnalysisSettings: cdk.objectToCloudFormation(properties.sentimentAnalysisSettings) }) : properties;
    }
    function CfnBotAliasPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("botAliasName", "BotAliasName", cfn_parse.FromCloudFormation.getString(properties.BotAliasName)), ret.addPropertyResult("botId", "BotId", cfn_parse.FromCloudFormation.getString(properties.BotId)), ret.addPropertyResult("botAliasLocaleSettings", "BotAliasLocaleSettings", properties.BotAliasLocaleSettings != null ? cfn_parse.FromCloudFormation.getArray(CfnBotAliasBotAliasLocaleSettingsItemPropertyFromCloudFormation)(properties.BotAliasLocaleSettings) : void 0), ret.addPropertyResult("botAliasTags", "BotAliasTags", properties.BotAliasTags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.BotAliasTags) : void 0), ret.addPropertyResult("botVersion", "BotVersion", properties.BotVersion != null ? cfn_parse.FromCloudFormation.getString(properties.BotVersion) : void 0), ret.addPropertyResult("conversationLogSettings", "ConversationLogSettings", properties.ConversationLogSettings != null ? CfnBotAliasConversationLogSettingsPropertyFromCloudFormation(properties.ConversationLogSettings) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("sentimentAnalysisSettings", "SentimentAnalysisSettings", properties.SentimentAnalysisSettings != null ? cfn_parse.FromCloudFormation.getAny(properties.SentimentAnalysisSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnBotAlias = class _CfnBotAlias extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnBotAliasPropsFromCloudFormation(resourceProperties), ret = new _CfnBotAlias(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnBotAlias.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lex_CfnBotAliasProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnBotAlias), error;
        }
        cdk.requireProperty(props, "botAliasName", this), cdk.requireProperty(props, "botId", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrBotAliasId = cdk.Token.asString(this.getAtt("BotAliasId", cdk.ResolutionTypeHint.STRING)), this.attrBotAliasStatus = cdk.Token.asString(this.getAtt("BotAliasStatus", cdk.ResolutionTypeHint.STRING)), this.botAliasName = props.botAliasName, this.botId = props.botId, this.botAliasLocaleSettings = props.botAliasLocaleSettings, this.botAliasTags = props.botAliasTags, this.botVersion = props.botVersion, this.conversationLogSettings = props.conversationLogSettings, this.description = props.description, this.sentimentAnalysisSettings = props.sentimentAnalysisSettings;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnBotAlias.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { botAliasName: this.botAliasName, botId: this.botId, botAliasLocaleSettings: this.botAliasLocaleSettings, botAliasTags: this.botAliasTags, botVersion: this.botVersion, conversationLogSettings: this.conversationLogSettings, description: this.description, sentimentAnalysisSettings: this.sentimentAnalysisSettings };
      }
      renderProperties(props) {
        return cfnBotAliasPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnBotAlias[_b] = { fqn: "aws-cdk-lib.aws_lex.CfnBotAlias", version: "2.80.0" }, CfnBotAlias.CFN_RESOURCE_TYPE_NAME = "AWS::Lex::BotAlias", exports2.CfnBotAlias = CfnBotAlias;
    function CfnBotAlias_AudioLogDestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3Bucket", cdk.requiredValidator)(properties.s3Bucket)), errors.collect(cdk.propertyValidator("s3Bucket", CfnBotAlias_S3BucketLogDestinationPropertyValidator)(properties.s3Bucket)), errors.wrap('supplied properties not correct for "AudioLogDestinationProperty"');
    }
    function cfnBotAliasAudioLogDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBotAlias_AudioLogDestinationPropertyValidator(properties).assertSuccess(), { S3Bucket: cfnBotAliasS3BucketLogDestinationPropertyToCloudFormation(properties.s3Bucket) }) : properties;
    }
    function CfnBotAliasAudioLogDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Bucket", "S3Bucket", CfnBotAliasS3BucketLogDestinationPropertyFromCloudFormation(properties.S3Bucket)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBotAlias_AudioLogSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destination", cdk.requiredValidator)(properties.destination)), errors.collect(cdk.propertyValidator("destination", CfnBotAlias_AudioLogDestinationPropertyValidator)(properties.destination)), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "AudioLogSettingProperty"');
    }
    function cfnBotAliasAudioLogSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBotAlias_AudioLogSettingPropertyValidator(properties).assertSuccess(), { Destination: cfnBotAliasAudioLogDestinationPropertyToCloudFormation(properties.destination), Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnBotAliasAudioLogSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destination", "Destination", CfnBotAliasAudioLogDestinationPropertyFromCloudFormation(properties.Destination)), ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBotAlias_BotAliasLocaleSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("codeHookSpecification", CfnBotAlias_CodeHookSpecificationPropertyValidator)(properties.codeHookSpecification)), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "BotAliasLocaleSettingsProperty"');
    }
    function cfnBotAliasBotAliasLocaleSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBotAlias_BotAliasLocaleSettingsPropertyValidator(properties).assertSuccess(), { CodeHookSpecification: cfnBotAliasCodeHookSpecificationPropertyToCloudFormation(properties.codeHookSpecification), Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnBotAliasBotAliasLocaleSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("codeHookSpecification", "CodeHookSpecification", properties.CodeHookSpecification != null ? CfnBotAliasCodeHookSpecificationPropertyFromCloudFormation(properties.CodeHookSpecification) : void 0), ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBotAlias_BotAliasLocaleSettingsItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("botAliasLocaleSetting", cdk.requiredValidator)(properties.botAliasLocaleSetting)), errors.collect(cdk.propertyValidator("botAliasLocaleSetting", CfnBotAlias_BotAliasLocaleSettingsPropertyValidator)(properties.botAliasLocaleSetting)), errors.collect(cdk.propertyValidator("localeId", cdk.requiredValidator)(properties.localeId)), errors.collect(cdk.propertyValidator("localeId", cdk.validateString)(properties.localeId)), errors.wrap('supplied properties not correct for "BotAliasLocaleSettingsItemProperty"');
    }
    function cfnBotAliasBotAliasLocaleSettingsItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBotAlias_BotAliasLocaleSettingsItemPropertyValidator(properties).assertSuccess(), { BotAliasLocaleSetting: cfnBotAliasBotAliasLocaleSettingsPropertyToCloudFormation(properties.botAliasLocaleSetting), LocaleId: cdk.stringToCloudFormation(properties.localeId) }) : properties;
    }
    function CfnBotAliasBotAliasLocaleSettingsItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("botAliasLocaleSetting", "BotAliasLocaleSetting", CfnBotAliasBotAliasLocaleSettingsPropertyFromCloudFormation(properties.BotAliasLocaleSetting)), ret.addPropertyResult("localeId", "LocaleId", cfn_parse.FromCloudFormation.getString(properties.LocaleId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBotAlias_CloudWatchLogGroupLogDestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchLogGroupArn", cdk.requiredValidator)(properties.cloudWatchLogGroupArn)), errors.collect(cdk.propertyValidator("cloudWatchLogGroupArn", cdk.validateString)(properties.cloudWatchLogGroupArn)), errors.collect(cdk.propertyValidator("logPrefix", cdk.requiredValidator)(properties.logPrefix)), errors.collect(cdk.propertyValidator("logPrefix", cdk.validateString)(properties.logPrefix)), errors.wrap('supplied properties not correct for "CloudWatchLogGroupLogDestinationProperty"');
    }
    function cfnBotAliasCloudWatchLogGroupLogDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBotAlias_CloudWatchLogGroupLogDestinationPropertyValidator(properties).assertSuccess(), { CloudWatchLogGroupArn: cdk.stringToCloudFormation(properties.cloudWatchLogGroupArn), LogPrefix: cdk.stringToCloudFormation(properties.logPrefix) }) : properties;
    }
    function CfnBotAliasCloudWatchLogGroupLogDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchLogGroupArn", "CloudWatchLogGroupArn", cfn_parse.FromCloudFormation.getString(properties.CloudWatchLogGroupArn)), ret.addPropertyResult("logPrefix", "LogPrefix", cfn_parse.FromCloudFormation.getString(properties.LogPrefix)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBotAlias_CodeHookSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("lambdaCodeHook", cdk.requiredValidator)(properties.lambdaCodeHook)), errors.collect(cdk.propertyValidator("lambdaCodeHook", CfnBotAlias_LambdaCodeHookPropertyValidator)(properties.lambdaCodeHook)), errors.wrap('supplied properties not correct for "CodeHookSpecificationProperty"');
    }
    function cfnBotAliasCodeHookSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBotAlias_CodeHookSpecificationPropertyValidator(properties).assertSuccess(), { LambdaCodeHook: cfnBotAliasLambdaCodeHookPropertyToCloudFormation(properties.lambdaCodeHook) }) : properties;
    }
    function CfnBotAliasCodeHookSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("lambdaCodeHook", "LambdaCodeHook", CfnBotAliasLambdaCodeHookPropertyFromCloudFormation(properties.LambdaCodeHook)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBotAlias_ConversationLogSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("audioLogSettings", cdk.listValidator(CfnBotAlias_AudioLogSettingPropertyValidator))(properties.audioLogSettings)), errors.collect(cdk.propertyValidator("textLogSettings", cdk.listValidator(CfnBotAlias_TextLogSettingPropertyValidator))(properties.textLogSettings)), errors.wrap('supplied properties not correct for "ConversationLogSettingsProperty"');
    }
    function cfnBotAliasConversationLogSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBotAlias_ConversationLogSettingsPropertyValidator(properties).assertSuccess(), { AudioLogSettings: cdk.listMapper(cfnBotAliasAudioLogSettingPropertyToCloudFormation)(properties.audioLogSettings), TextLogSettings: cdk.listMapper(cfnBotAliasTextLogSettingPropertyToCloudFormation)(properties.textLogSettings) }) : properties;
    }
    function CfnBotAliasConversationLogSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("audioLogSettings", "AudioLogSettings", properties.AudioLogSettings != null ? cfn_parse.FromCloudFormation.getArray(CfnBotAliasAudioLogSettingPropertyFromCloudFormation)(properties.AudioLogSettings) : void 0), ret.addPropertyResult("textLogSettings", "TextLogSettings", properties.TextLogSettings != null ? cfn_parse.FromCloudFormation.getArray(CfnBotAliasTextLogSettingPropertyFromCloudFormation)(properties.TextLogSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBotAlias_LambdaCodeHookPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("codeHookInterfaceVersion", cdk.requiredValidator)(properties.codeHookInterfaceVersion)), errors.collect(cdk.propertyValidator("codeHookInterfaceVersion", cdk.validateString)(properties.codeHookInterfaceVersion)), errors.collect(cdk.propertyValidator("lambdaArn", cdk.requiredValidator)(properties.lambdaArn)), errors.collect(cdk.propertyValidator("lambdaArn", cdk.validateString)(properties.lambdaArn)), errors.wrap('supplied properties not correct for "LambdaCodeHookProperty"');
    }
    function cfnBotAliasLambdaCodeHookPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBotAlias_LambdaCodeHookPropertyValidator(properties).assertSuccess(), { CodeHookInterfaceVersion: cdk.stringToCloudFormation(properties.codeHookInterfaceVersion), LambdaArn: cdk.stringToCloudFormation(properties.lambdaArn) }) : properties;
    }
    function CfnBotAliasLambdaCodeHookPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("codeHookInterfaceVersion", "CodeHookInterfaceVersion", cfn_parse.FromCloudFormation.getString(properties.CodeHookInterfaceVersion)), ret.addPropertyResult("lambdaArn", "LambdaArn", cfn_parse.FromCloudFormation.getString(properties.LambdaArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBotAlias_S3BucketLogDestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kmsKeyArn", cdk.validateString)(properties.kmsKeyArn)), errors.collect(cdk.propertyValidator("logPrefix", cdk.requiredValidator)(properties.logPrefix)), errors.collect(cdk.propertyValidator("logPrefix", cdk.validateString)(properties.logPrefix)), errors.collect(cdk.propertyValidator("s3BucketArn", cdk.requiredValidator)(properties.s3BucketArn)), errors.collect(cdk.propertyValidator("s3BucketArn", cdk.validateString)(properties.s3BucketArn)), errors.wrap('supplied properties not correct for "S3BucketLogDestinationProperty"');
    }
    function cfnBotAliasS3BucketLogDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBotAlias_S3BucketLogDestinationPropertyValidator(properties).assertSuccess(), { KmsKeyArn: cdk.stringToCloudFormation(properties.kmsKeyArn), LogPrefix: cdk.stringToCloudFormation(properties.logPrefix), S3BucketArn: cdk.stringToCloudFormation(properties.s3BucketArn) }) : properties;
    }
    function CfnBotAliasS3BucketLogDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsKeyArn", "KmsKeyArn", properties.KmsKeyArn != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyArn) : void 0), ret.addPropertyResult("logPrefix", "LogPrefix", cfn_parse.FromCloudFormation.getString(properties.LogPrefix)), ret.addPropertyResult("s3BucketArn", "S3BucketArn", cfn_parse.FromCloudFormation.getString(properties.S3BucketArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBotAlias_TextLogDestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatch", cdk.requiredValidator)(properties.cloudWatch)), errors.collect(cdk.propertyValidator("cloudWatch", CfnBotAlias_CloudWatchLogGroupLogDestinationPropertyValidator)(properties.cloudWatch)), errors.wrap('supplied properties not correct for "TextLogDestinationProperty"');
    }
    function cfnBotAliasTextLogDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBotAlias_TextLogDestinationPropertyValidator(properties).assertSuccess(), { CloudWatch: cfnBotAliasCloudWatchLogGroupLogDestinationPropertyToCloudFormation(properties.cloudWatch) }) : properties;
    }
    function CfnBotAliasTextLogDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatch", "CloudWatch", CfnBotAliasCloudWatchLogGroupLogDestinationPropertyFromCloudFormation(properties.CloudWatch)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBotAlias_TextLogSettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destination", cdk.requiredValidator)(properties.destination)), errors.collect(cdk.propertyValidator("destination", CfnBotAlias_TextLogDestinationPropertyValidator)(properties.destination)), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "TextLogSettingProperty"');
    }
    function cfnBotAliasTextLogSettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBotAlias_TextLogSettingPropertyValidator(properties).assertSuccess(), { Destination: cfnBotAliasTextLogDestinationPropertyToCloudFormation(properties.destination), Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnBotAliasTextLogSettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destination", "Destination", CfnBotAliasTextLogDestinationPropertyFromCloudFormation(properties.Destination)), ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBotVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("botId", cdk.requiredValidator)(properties.botId)), errors.collect(cdk.propertyValidator("botId", cdk.validateString)(properties.botId)), errors.collect(cdk.propertyValidator("botVersionLocaleSpecification", cdk.requiredValidator)(properties.botVersionLocaleSpecification)), errors.collect(cdk.propertyValidator("botVersionLocaleSpecification", cdk.listValidator(CfnBotVersion_BotVersionLocaleSpecificationPropertyValidator))(properties.botVersionLocaleSpecification)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.wrap('supplied properties not correct for "CfnBotVersionProps"');
    }
    function cfnBotVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBotVersionPropsValidator(properties).assertSuccess(), { BotId: cdk.stringToCloudFormation(properties.botId), BotVersionLocaleSpecification: cdk.listMapper(cfnBotVersionBotVersionLocaleSpecificationPropertyToCloudFormation)(properties.botVersionLocaleSpecification), Description: cdk.stringToCloudFormation(properties.description) }) : properties;
    }
    function CfnBotVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("botId", "BotId", cfn_parse.FromCloudFormation.getString(properties.BotId)), ret.addPropertyResult("botVersionLocaleSpecification", "BotVersionLocaleSpecification", cfn_parse.FromCloudFormation.getArray(CfnBotVersionBotVersionLocaleSpecificationPropertyFromCloudFormation)(properties.BotVersionLocaleSpecification)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnBotVersion = class _CfnBotVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnBotVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnBotVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnBotVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lex_CfnBotVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnBotVersion), error;
        }
        cdk.requireProperty(props, "botId", this), cdk.requireProperty(props, "botVersionLocaleSpecification", this), this.attrBotVersion = cdk.Token.asString(this.getAtt("BotVersion", cdk.ResolutionTypeHint.STRING)), this.botId = props.botId, this.botVersionLocaleSpecification = props.botVersionLocaleSpecification, this.description = props.description;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnBotVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { botId: this.botId, botVersionLocaleSpecification: this.botVersionLocaleSpecification, description: this.description };
      }
      renderProperties(props) {
        return cfnBotVersionPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnBotVersion[_c] = { fqn: "aws-cdk-lib.aws_lex.CfnBotVersion", version: "2.80.0" }, CfnBotVersion.CFN_RESOURCE_TYPE_NAME = "AWS::Lex::BotVersion", exports2.CfnBotVersion = CfnBotVersion;
    function CfnBotVersion_BotVersionLocaleDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sourceBotVersion", cdk.requiredValidator)(properties.sourceBotVersion)), errors.collect(cdk.propertyValidator("sourceBotVersion", cdk.validateString)(properties.sourceBotVersion)), errors.wrap('supplied properties not correct for "BotVersionLocaleDetailsProperty"');
    }
    function cfnBotVersionBotVersionLocaleDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBotVersion_BotVersionLocaleDetailsPropertyValidator(properties).assertSuccess(), { SourceBotVersion: cdk.stringToCloudFormation(properties.sourceBotVersion) }) : properties;
    }
    function CfnBotVersionBotVersionLocaleDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sourceBotVersion", "SourceBotVersion", cfn_parse.FromCloudFormation.getString(properties.SourceBotVersion)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBotVersion_BotVersionLocaleSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("botVersionLocaleDetails", cdk.requiredValidator)(properties.botVersionLocaleDetails)), errors.collect(cdk.propertyValidator("botVersionLocaleDetails", CfnBotVersion_BotVersionLocaleDetailsPropertyValidator)(properties.botVersionLocaleDetails)), errors.collect(cdk.propertyValidator("localeId", cdk.requiredValidator)(properties.localeId)), errors.collect(cdk.propertyValidator("localeId", cdk.validateString)(properties.localeId)), errors.wrap('supplied properties not correct for "BotVersionLocaleSpecificationProperty"');
    }
    function cfnBotVersionBotVersionLocaleSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBotVersion_BotVersionLocaleSpecificationPropertyValidator(properties).assertSuccess(), { BotVersionLocaleDetails: cfnBotVersionBotVersionLocaleDetailsPropertyToCloudFormation(properties.botVersionLocaleDetails), LocaleId: cdk.stringToCloudFormation(properties.localeId) }) : properties;
    }
    function CfnBotVersionBotVersionLocaleSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("botVersionLocaleDetails", "BotVersionLocaleDetails", CfnBotVersionBotVersionLocaleDetailsPropertyFromCloudFormation(properties.BotVersionLocaleDetails)), ret.addPropertyResult("localeId", "LocaleId", cfn_parse.FromCloudFormation.getString(properties.LocaleId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourcePolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("policy", cdk.requiredValidator)(properties.policy)), errors.collect(cdk.propertyValidator("policy", cdk.validateObject)(properties.policy)), errors.collect(cdk.propertyValidator("resourceArn", cdk.requiredValidator)(properties.resourceArn)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.wrap('supplied properties not correct for "CfnResourcePolicyProps"');
    }
    function cfnResourcePolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourcePolicyPropsValidator(properties).assertSuccess(), { Policy: cdk.objectToCloudFormation(properties.policy), ResourceArn: cdk.stringToCloudFormation(properties.resourceArn) }) : properties;
    }
    function CfnResourcePolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("policy", "Policy", cfn_parse.FromCloudFormation.getAny(properties.Policy)), ret.addPropertyResult("resourceArn", "ResourceArn", cfn_parse.FromCloudFormation.getString(properties.ResourceArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResourcePolicy = class _CfnResourcePolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResourcePolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnResourcePolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnResourcePolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lex_CfnResourcePolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResourcePolicy), error;
        }
        cdk.requireProperty(props, "policy", this), cdk.requireProperty(props, "resourceArn", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrRevisionId = cdk.Token.asString(this.getAtt("RevisionId", cdk.ResolutionTypeHint.STRING)), this.policy = props.policy, this.resourceArn = props.resourceArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResourcePolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { policy: this.policy, resourceArn: this.resourceArn };
      }
      renderProperties(props) {
        return cfnResourcePolicyPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnResourcePolicy[_d] = { fqn: "aws-cdk-lib.aws_lex.CfnResourcePolicy", version: "2.80.0" }, CfnResourcePolicy.CFN_RESOURCE_TYPE_NAME = "AWS::Lex::ResourcePolicy", exports2.CfnResourcePolicy = CfnResourcePolicy;
  }
});

// node_modules/aws-cdk-lib/aws-lex/lib/index.js
var require_lib175 = __commonJS({
  "node_modules/aws-cdk-lib/aws-lex/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lex_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-lex/index.js
var require_aws_lex = __commonJS({
  "node_modules/aws-cdk-lib/aws-lex/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib175(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-licensemanager/lib/licensemanager.generated.js
var require_licensemanager_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-licensemanager/lib/licensemanager.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnLicense = exports2.CfnGrant = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnGrantPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowedOperations", cdk.listValidator(cdk.validateString))(properties.allowedOperations)), errors.collect(cdk.propertyValidator("grantName", cdk.validateString)(properties.grantName)), errors.collect(cdk.propertyValidator("homeRegion", cdk.validateString)(properties.homeRegion)), errors.collect(cdk.propertyValidator("licenseArn", cdk.validateString)(properties.licenseArn)), errors.collect(cdk.propertyValidator("principals", cdk.listValidator(cdk.validateString))(properties.principals)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "CfnGrantProps"');
    }
    function cfnGrantPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGrantPropsValidator(properties).assertSuccess(), { AllowedOperations: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowedOperations), GrantName: cdk.stringToCloudFormation(properties.grantName), HomeRegion: cdk.stringToCloudFormation(properties.homeRegion), LicenseArn: cdk.stringToCloudFormation(properties.licenseArn), Principals: cdk.listMapper(cdk.stringToCloudFormation)(properties.principals), Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnGrantPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowedOperations", "AllowedOperations", properties.AllowedOperations != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AllowedOperations) : void 0), ret.addPropertyResult("grantName", "GrantName", properties.GrantName != null ? cfn_parse.FromCloudFormation.getString(properties.GrantName) : void 0), ret.addPropertyResult("homeRegion", "HomeRegion", properties.HomeRegion != null ? cfn_parse.FromCloudFormation.getString(properties.HomeRegion) : void 0), ret.addPropertyResult("licenseArn", "LicenseArn", properties.LicenseArn != null ? cfn_parse.FromCloudFormation.getString(properties.LicenseArn) : void 0), ret.addPropertyResult("principals", "Principals", properties.Principals != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Principals) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnGrant = class _CfnGrant extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnGrantPropsFromCloudFormation(resourceProperties), ret = new _CfnGrant(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnGrant.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_licensemanager_CfnGrantProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnGrant), error;
        }
        this.attrGrantArn = cdk.Token.asString(this.getAtt("GrantArn", cdk.ResolutionTypeHint.STRING)), this.attrVersion = cdk.Token.asString(this.getAtt("Version", cdk.ResolutionTypeHint.STRING)), this.allowedOperations = props.allowedOperations, this.grantName = props.grantName, this.homeRegion = props.homeRegion, this.licenseArn = props.licenseArn, this.principals = props.principals, this.status = props.status;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnGrant.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { allowedOperations: this.allowedOperations, grantName: this.grantName, homeRegion: this.homeRegion, licenseArn: this.licenseArn, principals: this.principals, status: this.status };
      }
      renderProperties(props) {
        return cfnGrantPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnGrant[_a] = { fqn: "aws-cdk-lib.aws_licensemanager.CfnGrant", version: "2.80.0" }, CfnGrant.CFN_RESOURCE_TYPE_NAME = "AWS::LicenseManager::Grant", exports2.CfnGrant = CfnGrant;
    function CfnLicensePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("beneficiary", cdk.validateString)(properties.beneficiary)), errors.collect(cdk.propertyValidator("consumptionConfiguration", cdk.requiredValidator)(properties.consumptionConfiguration)), errors.collect(cdk.propertyValidator("consumptionConfiguration", CfnLicense_ConsumptionConfigurationPropertyValidator)(properties.consumptionConfiguration)), errors.collect(cdk.propertyValidator("entitlements", cdk.requiredValidator)(properties.entitlements)), errors.collect(cdk.propertyValidator("entitlements", cdk.listValidator(CfnLicense_EntitlementPropertyValidator))(properties.entitlements)), errors.collect(cdk.propertyValidator("homeRegion", cdk.requiredValidator)(properties.homeRegion)), errors.collect(cdk.propertyValidator("homeRegion", cdk.validateString)(properties.homeRegion)), errors.collect(cdk.propertyValidator("issuer", cdk.requiredValidator)(properties.issuer)), errors.collect(cdk.propertyValidator("issuer", CfnLicense_IssuerDataPropertyValidator)(properties.issuer)), errors.collect(cdk.propertyValidator("licenseMetadata", cdk.listValidator(CfnLicense_MetadataPropertyValidator))(properties.licenseMetadata)), errors.collect(cdk.propertyValidator("licenseName", cdk.requiredValidator)(properties.licenseName)), errors.collect(cdk.propertyValidator("licenseName", cdk.validateString)(properties.licenseName)), errors.collect(cdk.propertyValidator("productName", cdk.requiredValidator)(properties.productName)), errors.collect(cdk.propertyValidator("productName", cdk.validateString)(properties.productName)), errors.collect(cdk.propertyValidator("productSku", cdk.validateString)(properties.productSku)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.collect(cdk.propertyValidator("validity", cdk.requiredValidator)(properties.validity)), errors.collect(cdk.propertyValidator("validity", CfnLicense_ValidityDateFormatPropertyValidator)(properties.validity)), errors.wrap('supplied properties not correct for "CfnLicenseProps"');
    }
    function cfnLicensePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLicensePropsValidator(properties).assertSuccess(), { ConsumptionConfiguration: cfnLicenseConsumptionConfigurationPropertyToCloudFormation(properties.consumptionConfiguration), Entitlements: cdk.listMapper(cfnLicenseEntitlementPropertyToCloudFormation)(properties.entitlements), HomeRegion: cdk.stringToCloudFormation(properties.homeRegion), Issuer: cfnLicenseIssuerDataPropertyToCloudFormation(properties.issuer), LicenseName: cdk.stringToCloudFormation(properties.licenseName), ProductName: cdk.stringToCloudFormation(properties.productName), Validity: cfnLicenseValidityDateFormatPropertyToCloudFormation(properties.validity), Beneficiary: cdk.stringToCloudFormation(properties.beneficiary), LicenseMetadata: cdk.listMapper(cfnLicenseMetadataPropertyToCloudFormation)(properties.licenseMetadata), ProductSKU: cdk.stringToCloudFormation(properties.productSku), Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnLicensePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("consumptionConfiguration", "ConsumptionConfiguration", CfnLicenseConsumptionConfigurationPropertyFromCloudFormation(properties.ConsumptionConfiguration)), ret.addPropertyResult("entitlements", "Entitlements", cfn_parse.FromCloudFormation.getArray(CfnLicenseEntitlementPropertyFromCloudFormation)(properties.Entitlements)), ret.addPropertyResult("homeRegion", "HomeRegion", cfn_parse.FromCloudFormation.getString(properties.HomeRegion)), ret.addPropertyResult("issuer", "Issuer", CfnLicenseIssuerDataPropertyFromCloudFormation(properties.Issuer)), ret.addPropertyResult("licenseName", "LicenseName", cfn_parse.FromCloudFormation.getString(properties.LicenseName)), ret.addPropertyResult("productName", "ProductName", cfn_parse.FromCloudFormation.getString(properties.ProductName)), ret.addPropertyResult("validity", "Validity", CfnLicenseValidityDateFormatPropertyFromCloudFormation(properties.Validity)), ret.addPropertyResult("beneficiary", "Beneficiary", properties.Beneficiary != null ? cfn_parse.FromCloudFormation.getString(properties.Beneficiary) : void 0), ret.addPropertyResult("licenseMetadata", "LicenseMetadata", properties.LicenseMetadata != null ? cfn_parse.FromCloudFormation.getArray(CfnLicenseMetadataPropertyFromCloudFormation)(properties.LicenseMetadata) : void 0), ret.addPropertyResult("productSku", "ProductSKU", properties.ProductSKU != null ? cfn_parse.FromCloudFormation.getString(properties.ProductSKU) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLicense = class _CfnLicense extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLicensePropsFromCloudFormation(resourceProperties), ret = new _CfnLicense(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLicense.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_licensemanager_CfnLicenseProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLicense), error;
        }
        cdk.requireProperty(props, "consumptionConfiguration", this), cdk.requireProperty(props, "entitlements", this), cdk.requireProperty(props, "homeRegion", this), cdk.requireProperty(props, "issuer", this), cdk.requireProperty(props, "licenseName", this), cdk.requireProperty(props, "productName", this), cdk.requireProperty(props, "validity", this), this.attrLicenseArn = cdk.Token.asString(this.getAtt("LicenseArn", cdk.ResolutionTypeHint.STRING)), this.attrVersion = cdk.Token.asString(this.getAtt("Version", cdk.ResolutionTypeHint.STRING)), this.consumptionConfiguration = props.consumptionConfiguration, this.entitlements = props.entitlements, this.homeRegion = props.homeRegion, this.issuer = props.issuer, this.licenseName = props.licenseName, this.productName = props.productName, this.validity = props.validity, this.beneficiary = props.beneficiary, this.licenseMetadata = props.licenseMetadata, this.productSku = props.productSku, this.status = props.status;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLicense.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { consumptionConfiguration: this.consumptionConfiguration, entitlements: this.entitlements, homeRegion: this.homeRegion, issuer: this.issuer, licenseName: this.licenseName, productName: this.productName, validity: this.validity, beneficiary: this.beneficiary, licenseMetadata: this.licenseMetadata, productSku: this.productSku, status: this.status };
      }
      renderProperties(props) {
        return cfnLicensePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnLicense[_b] = { fqn: "aws-cdk-lib.aws_licensemanager.CfnLicense", version: "2.80.0" }, CfnLicense.CFN_RESOURCE_TYPE_NAME = "AWS::LicenseManager::License", exports2.CfnLicense = CfnLicense;
    function CfnLicense_BorrowConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowEarlyCheckIn", cdk.requiredValidator)(properties.allowEarlyCheckIn)), errors.collect(cdk.propertyValidator("allowEarlyCheckIn", cdk.validateBoolean)(properties.allowEarlyCheckIn)), errors.collect(cdk.propertyValidator("maxTimeToLiveInMinutes", cdk.requiredValidator)(properties.maxTimeToLiveInMinutes)), errors.collect(cdk.propertyValidator("maxTimeToLiveInMinutes", cdk.validateNumber)(properties.maxTimeToLiveInMinutes)), errors.wrap('supplied properties not correct for "BorrowConfigurationProperty"');
    }
    function cfnLicenseBorrowConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLicense_BorrowConfigurationPropertyValidator(properties).assertSuccess(), { AllowEarlyCheckIn: cdk.booleanToCloudFormation(properties.allowEarlyCheckIn), MaxTimeToLiveInMinutes: cdk.numberToCloudFormation(properties.maxTimeToLiveInMinutes) }) : properties;
    }
    function CfnLicenseBorrowConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowEarlyCheckIn", "AllowEarlyCheckIn", cfn_parse.FromCloudFormation.getBoolean(properties.AllowEarlyCheckIn)), ret.addPropertyResult("maxTimeToLiveInMinutes", "MaxTimeToLiveInMinutes", cfn_parse.FromCloudFormation.getNumber(properties.MaxTimeToLiveInMinutes)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLicense_ConsumptionConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("borrowConfiguration", CfnLicense_BorrowConfigurationPropertyValidator)(properties.borrowConfiguration)), errors.collect(cdk.propertyValidator("provisionalConfiguration", CfnLicense_ProvisionalConfigurationPropertyValidator)(properties.provisionalConfiguration)), errors.collect(cdk.propertyValidator("renewType", cdk.validateString)(properties.renewType)), errors.wrap('supplied properties not correct for "ConsumptionConfigurationProperty"');
    }
    function cfnLicenseConsumptionConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLicense_ConsumptionConfigurationPropertyValidator(properties).assertSuccess(), { BorrowConfiguration: cfnLicenseBorrowConfigurationPropertyToCloudFormation(properties.borrowConfiguration), ProvisionalConfiguration: cfnLicenseProvisionalConfigurationPropertyToCloudFormation(properties.provisionalConfiguration), RenewType: cdk.stringToCloudFormation(properties.renewType) }) : properties;
    }
    function CfnLicenseConsumptionConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("borrowConfiguration", "BorrowConfiguration", properties.BorrowConfiguration != null ? CfnLicenseBorrowConfigurationPropertyFromCloudFormation(properties.BorrowConfiguration) : void 0), ret.addPropertyResult("provisionalConfiguration", "ProvisionalConfiguration", properties.ProvisionalConfiguration != null ? CfnLicenseProvisionalConfigurationPropertyFromCloudFormation(properties.ProvisionalConfiguration) : void 0), ret.addPropertyResult("renewType", "RenewType", properties.RenewType != null ? cfn_parse.FromCloudFormation.getString(properties.RenewType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLicense_EntitlementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowCheckIn", cdk.validateBoolean)(properties.allowCheckIn)), errors.collect(cdk.propertyValidator("maxCount", cdk.validateNumber)(properties.maxCount)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("overage", cdk.validateBoolean)(properties.overage)), errors.collect(cdk.propertyValidator("unit", cdk.requiredValidator)(properties.unit)), errors.collect(cdk.propertyValidator("unit", cdk.validateString)(properties.unit)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "EntitlementProperty"');
    }
    function cfnLicenseEntitlementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLicense_EntitlementPropertyValidator(properties).assertSuccess(), { AllowCheckIn: cdk.booleanToCloudFormation(properties.allowCheckIn), MaxCount: cdk.numberToCloudFormation(properties.maxCount), Name: cdk.stringToCloudFormation(properties.name), Overage: cdk.booleanToCloudFormation(properties.overage), Unit: cdk.stringToCloudFormation(properties.unit), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnLicenseEntitlementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowCheckIn", "AllowCheckIn", properties.AllowCheckIn != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllowCheckIn) : void 0), ret.addPropertyResult("maxCount", "MaxCount", properties.MaxCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxCount) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("overage", "Overage", properties.Overage != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Overage) : void 0), ret.addPropertyResult("unit", "Unit", cfn_parse.FromCloudFormation.getString(properties.Unit)), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLicense_IssuerDataPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("signKey", cdk.validateString)(properties.signKey)), errors.wrap('supplied properties not correct for "IssuerDataProperty"');
    }
    function cfnLicenseIssuerDataPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLicense_IssuerDataPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), SignKey: cdk.stringToCloudFormation(properties.signKey) }) : properties;
    }
    function CfnLicenseIssuerDataPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("signKey", "SignKey", properties.SignKey != null ? cfn_parse.FromCloudFormation.getString(properties.SignKey) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLicense_MetadataPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "MetadataProperty"');
    }
    function cfnLicenseMetadataPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLicense_MetadataPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnLicenseMetadataPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLicense_ProvisionalConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxTimeToLiveInMinutes", cdk.requiredValidator)(properties.maxTimeToLiveInMinutes)), errors.collect(cdk.propertyValidator("maxTimeToLiveInMinutes", cdk.validateNumber)(properties.maxTimeToLiveInMinutes)), errors.wrap('supplied properties not correct for "ProvisionalConfigurationProperty"');
    }
    function cfnLicenseProvisionalConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLicense_ProvisionalConfigurationPropertyValidator(properties).assertSuccess(), { MaxTimeToLiveInMinutes: cdk.numberToCloudFormation(properties.maxTimeToLiveInMinutes) }) : properties;
    }
    function CfnLicenseProvisionalConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxTimeToLiveInMinutes", "MaxTimeToLiveInMinutes", cfn_parse.FromCloudFormation.getNumber(properties.MaxTimeToLiveInMinutes)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLicense_ValidityDateFormatPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("begin", cdk.requiredValidator)(properties.begin)), errors.collect(cdk.propertyValidator("begin", cdk.validateString)(properties.begin)), errors.collect(cdk.propertyValidator("end", cdk.requiredValidator)(properties.end)), errors.collect(cdk.propertyValidator("end", cdk.validateString)(properties.end)), errors.wrap('supplied properties not correct for "ValidityDateFormatProperty"');
    }
    function cfnLicenseValidityDateFormatPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLicense_ValidityDateFormatPropertyValidator(properties).assertSuccess(), { Begin: cdk.stringToCloudFormation(properties.begin), End: cdk.stringToCloudFormation(properties.end) }) : properties;
    }
    function CfnLicenseValidityDateFormatPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("begin", "Begin", cfn_parse.FromCloudFormation.getString(properties.Begin)), ret.addPropertyResult("end", "End", cfn_parse.FromCloudFormation.getString(properties.End)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-licensemanager/lib/index.js
var require_lib176 = __commonJS({
  "node_modules/aws-cdk-lib/aws-licensemanager/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_licensemanager_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-licensemanager/index.js
var require_aws_licensemanager = __commonJS({
  "node_modules/aws-cdk-lib/aws-licensemanager/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib176(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-lightsail/lib/lightsail.generated.js
var require_lightsail_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-lightsail/lib/lightsail.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    var _l;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnStaticIp = exports2.CfnLoadBalancerTlsCertificate = exports2.CfnLoadBalancer = exports2.CfnInstance = exports2.CfnDistribution = exports2.CfnDisk = exports2.CfnDatabase = exports2.CfnContainer = exports2.CfnCertificate = exports2.CfnBucket = exports2.CfnAlarm = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAlarmPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alarmName", cdk.requiredValidator)(properties.alarmName)), errors.collect(cdk.propertyValidator("alarmName", cdk.validateString)(properties.alarmName)), errors.collect(cdk.propertyValidator("comparisonOperator", cdk.requiredValidator)(properties.comparisonOperator)), errors.collect(cdk.propertyValidator("comparisonOperator", cdk.validateString)(properties.comparisonOperator)), errors.collect(cdk.propertyValidator("contactProtocols", cdk.listValidator(cdk.validateString))(properties.contactProtocols)), errors.collect(cdk.propertyValidator("datapointsToAlarm", cdk.validateNumber)(properties.datapointsToAlarm)), errors.collect(cdk.propertyValidator("evaluationPeriods", cdk.requiredValidator)(properties.evaluationPeriods)), errors.collect(cdk.propertyValidator("evaluationPeriods", cdk.validateNumber)(properties.evaluationPeriods)), errors.collect(cdk.propertyValidator("metricName", cdk.requiredValidator)(properties.metricName)), errors.collect(cdk.propertyValidator("metricName", cdk.validateString)(properties.metricName)), errors.collect(cdk.propertyValidator("monitoredResourceName", cdk.requiredValidator)(properties.monitoredResourceName)), errors.collect(cdk.propertyValidator("monitoredResourceName", cdk.validateString)(properties.monitoredResourceName)), errors.collect(cdk.propertyValidator("notificationEnabled", cdk.validateBoolean)(properties.notificationEnabled)), errors.collect(cdk.propertyValidator("notificationTriggers", cdk.listValidator(cdk.validateString))(properties.notificationTriggers)), errors.collect(cdk.propertyValidator("threshold", cdk.requiredValidator)(properties.threshold)), errors.collect(cdk.propertyValidator("threshold", cdk.validateNumber)(properties.threshold)), errors.collect(cdk.propertyValidator("treatMissingData", cdk.validateString)(properties.treatMissingData)), errors.wrap('supplied properties not correct for "CfnAlarmProps"');
    }
    function cfnAlarmPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlarmPropsValidator(properties).assertSuccess(), { AlarmName: cdk.stringToCloudFormation(properties.alarmName), ComparisonOperator: cdk.stringToCloudFormation(properties.comparisonOperator), EvaluationPeriods: cdk.numberToCloudFormation(properties.evaluationPeriods), MetricName: cdk.stringToCloudFormation(properties.metricName), MonitoredResourceName: cdk.stringToCloudFormation(properties.monitoredResourceName), Threshold: cdk.numberToCloudFormation(properties.threshold), ContactProtocols: cdk.listMapper(cdk.stringToCloudFormation)(properties.contactProtocols), DatapointsToAlarm: cdk.numberToCloudFormation(properties.datapointsToAlarm), NotificationEnabled: cdk.booleanToCloudFormation(properties.notificationEnabled), NotificationTriggers: cdk.listMapper(cdk.stringToCloudFormation)(properties.notificationTriggers), TreatMissingData: cdk.stringToCloudFormation(properties.treatMissingData) }) : properties;
    }
    function CfnAlarmPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alarmName", "AlarmName", cfn_parse.FromCloudFormation.getString(properties.AlarmName)), ret.addPropertyResult("comparisonOperator", "ComparisonOperator", cfn_parse.FromCloudFormation.getString(properties.ComparisonOperator)), ret.addPropertyResult("evaluationPeriods", "EvaluationPeriods", cfn_parse.FromCloudFormation.getNumber(properties.EvaluationPeriods)), ret.addPropertyResult("metricName", "MetricName", cfn_parse.FromCloudFormation.getString(properties.MetricName)), ret.addPropertyResult("monitoredResourceName", "MonitoredResourceName", cfn_parse.FromCloudFormation.getString(properties.MonitoredResourceName)), ret.addPropertyResult("threshold", "Threshold", cfn_parse.FromCloudFormation.getNumber(properties.Threshold)), ret.addPropertyResult("contactProtocols", "ContactProtocols", properties.ContactProtocols != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ContactProtocols) : void 0), ret.addPropertyResult("datapointsToAlarm", "DatapointsToAlarm", properties.DatapointsToAlarm != null ? cfn_parse.FromCloudFormation.getNumber(properties.DatapointsToAlarm) : void 0), ret.addPropertyResult("notificationEnabled", "NotificationEnabled", properties.NotificationEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.NotificationEnabled) : void 0), ret.addPropertyResult("notificationTriggers", "NotificationTriggers", properties.NotificationTriggers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.NotificationTriggers) : void 0), ret.addPropertyResult("treatMissingData", "TreatMissingData", properties.TreatMissingData != null ? cfn_parse.FromCloudFormation.getString(properties.TreatMissingData) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAlarm = class _CfnAlarm extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAlarmPropsFromCloudFormation(resourceProperties), ret = new _CfnAlarm(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAlarm.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lightsail_CfnAlarmProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAlarm), error;
        }
        cdk.requireProperty(props, "alarmName", this), cdk.requireProperty(props, "comparisonOperator", this), cdk.requireProperty(props, "evaluationPeriods", this), cdk.requireProperty(props, "metricName", this), cdk.requireProperty(props, "monitoredResourceName", this), cdk.requireProperty(props, "threshold", this), this.attrAlarmArn = cdk.Token.asString(this.getAtt("AlarmArn", cdk.ResolutionTypeHint.STRING)), this.attrState = cdk.Token.asString(this.getAtt("State", cdk.ResolutionTypeHint.STRING)), this.alarmName = props.alarmName, this.comparisonOperator = props.comparisonOperator, this.evaluationPeriods = props.evaluationPeriods, this.metricName = props.metricName, this.monitoredResourceName = props.monitoredResourceName, this.threshold = props.threshold, this.contactProtocols = props.contactProtocols, this.datapointsToAlarm = props.datapointsToAlarm, this.notificationEnabled = props.notificationEnabled, this.notificationTriggers = props.notificationTriggers, this.treatMissingData = props.treatMissingData;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAlarm.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { alarmName: this.alarmName, comparisonOperator: this.comparisonOperator, evaluationPeriods: this.evaluationPeriods, metricName: this.metricName, monitoredResourceName: this.monitoredResourceName, threshold: this.threshold, contactProtocols: this.contactProtocols, datapointsToAlarm: this.datapointsToAlarm, notificationEnabled: this.notificationEnabled, notificationTriggers: this.notificationTriggers, treatMissingData: this.treatMissingData };
      }
      renderProperties(props) {
        return cfnAlarmPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAlarm[_a] = { fqn: "aws-cdk-lib.aws_lightsail.CfnAlarm", version: "2.80.0" }, CfnAlarm.CFN_RESOURCE_TYPE_NAME = "AWS::Lightsail::Alarm", exports2.CfnAlarm = CfnAlarm;
    function CfnBucketPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessRules", CfnBucket_AccessRulesPropertyValidator)(properties.accessRules)), errors.collect(cdk.propertyValidator("bucketName", cdk.requiredValidator)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.collect(cdk.propertyValidator("bundleId", cdk.requiredValidator)(properties.bundleId)), errors.collect(cdk.propertyValidator("bundleId", cdk.validateString)(properties.bundleId)), errors.collect(cdk.propertyValidator("objectVersioning", cdk.validateBoolean)(properties.objectVersioning)), errors.collect(cdk.propertyValidator("readOnlyAccessAccounts", cdk.listValidator(cdk.validateString))(properties.readOnlyAccessAccounts)), errors.collect(cdk.propertyValidator("resourcesReceivingAccess", cdk.listValidator(cdk.validateString))(properties.resourcesReceivingAccess)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnBucketProps"');
    }
    function cfnBucketPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucketPropsValidator(properties).assertSuccess(), { BucketName: cdk.stringToCloudFormation(properties.bucketName), BundleId: cdk.stringToCloudFormation(properties.bundleId), AccessRules: cfnBucketAccessRulesPropertyToCloudFormation(properties.accessRules), ObjectVersioning: cdk.booleanToCloudFormation(properties.objectVersioning), ReadOnlyAccessAccounts: cdk.listMapper(cdk.stringToCloudFormation)(properties.readOnlyAccessAccounts), ResourcesReceivingAccess: cdk.listMapper(cdk.stringToCloudFormation)(properties.resourcesReceivingAccess), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnBucketPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketName", "BucketName", cfn_parse.FromCloudFormation.getString(properties.BucketName)), ret.addPropertyResult("bundleId", "BundleId", cfn_parse.FromCloudFormation.getString(properties.BundleId)), ret.addPropertyResult("accessRules", "AccessRules", properties.AccessRules != null ? CfnBucketAccessRulesPropertyFromCloudFormation(properties.AccessRules) : void 0), ret.addPropertyResult("objectVersioning", "ObjectVersioning", properties.ObjectVersioning != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ObjectVersioning) : void 0), ret.addPropertyResult("readOnlyAccessAccounts", "ReadOnlyAccessAccounts", properties.ReadOnlyAccessAccounts != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ReadOnlyAccessAccounts) : void 0), ret.addPropertyResult("resourcesReceivingAccess", "ResourcesReceivingAccess", properties.ResourcesReceivingAccess != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ResourcesReceivingAccess) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnBucket = class _CfnBucket extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnBucketPropsFromCloudFormation(resourceProperties), ret = new _CfnBucket(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnBucket.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lightsail_CfnBucketProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnBucket), error;
        }
        cdk.requireProperty(props, "bucketName", this), cdk.requireProperty(props, "bundleId", this), this.attrAbleToUpdateBundle = this.getAtt("AbleToUpdateBundle", cdk.ResolutionTypeHint.STRING), this.attrBucketArn = cdk.Token.asString(this.getAtt("BucketArn", cdk.ResolutionTypeHint.STRING)), this.attrUrl = cdk.Token.asString(this.getAtt("Url", cdk.ResolutionTypeHint.STRING)), this.bucketName = props.bucketName, this.bundleId = props.bundleId, this.accessRules = props.accessRules, this.objectVersioning = props.objectVersioning, this.readOnlyAccessAccounts = props.readOnlyAccessAccounts, this.resourcesReceivingAccess = props.resourcesReceivingAccess, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Lightsail::Bucket", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnBucket.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { bucketName: this.bucketName, bundleId: this.bundleId, accessRules: this.accessRules, objectVersioning: this.objectVersioning, readOnlyAccessAccounts: this.readOnlyAccessAccounts, resourcesReceivingAccess: this.resourcesReceivingAccess, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnBucketPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnBucket[_b] = { fqn: "aws-cdk-lib.aws_lightsail.CfnBucket", version: "2.80.0" }, CfnBucket.CFN_RESOURCE_TYPE_NAME = "AWS::Lightsail::Bucket", exports2.CfnBucket = CfnBucket;
    function CfnBucket_AccessRulesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowPublicOverrides", cdk.validateBoolean)(properties.allowPublicOverrides)), errors.collect(cdk.propertyValidator("objectAccess", cdk.validateString)(properties.objectAccess)), errors.wrap('supplied properties not correct for "AccessRulesProperty"');
    }
    function cfnBucketAccessRulesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_AccessRulesPropertyValidator(properties).assertSuccess(), { AllowPublicOverrides: cdk.booleanToCloudFormation(properties.allowPublicOverrides), GetObject: cdk.stringToCloudFormation(properties.objectAccess) }) : properties;
    }
    function CfnBucketAccessRulesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowPublicOverrides", "AllowPublicOverrides", properties.AllowPublicOverrides != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllowPublicOverrides) : void 0), ret.addPropertyResult("objectAccess", "GetObject", properties.GetObject != null ? cfn_parse.FromCloudFormation.getString(properties.GetObject) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCertificatePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateName", cdk.requiredValidator)(properties.certificateName)), errors.collect(cdk.propertyValidator("certificateName", cdk.validateString)(properties.certificateName)), errors.collect(cdk.propertyValidator("domainName", cdk.requiredValidator)(properties.domainName)), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.collect(cdk.propertyValidator("subjectAlternativeNames", cdk.listValidator(cdk.validateString))(properties.subjectAlternativeNames)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnCertificateProps"');
    }
    function cfnCertificatePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificatePropsValidator(properties).assertSuccess(), { CertificateName: cdk.stringToCloudFormation(properties.certificateName), DomainName: cdk.stringToCloudFormation(properties.domainName), SubjectAlternativeNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.subjectAlternativeNames), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnCertificatePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificateName", "CertificateName", cfn_parse.FromCloudFormation.getString(properties.CertificateName)), ret.addPropertyResult("domainName", "DomainName", cfn_parse.FromCloudFormation.getString(properties.DomainName)), ret.addPropertyResult("subjectAlternativeNames", "SubjectAlternativeNames", properties.SubjectAlternativeNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SubjectAlternativeNames) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCertificate = class _CfnCertificate extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCertificatePropsFromCloudFormation(resourceProperties), ret = new _CfnCertificate(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCertificate.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lightsail_CfnCertificateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCertificate), error;
        }
        cdk.requireProperty(props, "certificateName", this), cdk.requireProperty(props, "domainName", this), this.attrCertificateArn = cdk.Token.asString(this.getAtt("CertificateArn", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.certificateName = props.certificateName, this.domainName = props.domainName, this.subjectAlternativeNames = props.subjectAlternativeNames, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Lightsail::Certificate", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCertificate.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { certificateName: this.certificateName, domainName: this.domainName, subjectAlternativeNames: this.subjectAlternativeNames, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnCertificatePropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnCertificate[_c] = { fqn: "aws-cdk-lib.aws_lightsail.CfnCertificate", version: "2.80.0" }, CfnCertificate.CFN_RESOURCE_TYPE_NAME = "AWS::Lightsail::Certificate", exports2.CfnCertificate = CfnCertificate;
    function CfnContainerPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containerServiceDeployment", CfnContainer_ContainerServiceDeploymentPropertyValidator)(properties.containerServiceDeployment)), errors.collect(cdk.propertyValidator("isDisabled", cdk.validateBoolean)(properties.isDisabled)), errors.collect(cdk.propertyValidator("power", cdk.requiredValidator)(properties.power)), errors.collect(cdk.propertyValidator("power", cdk.validateString)(properties.power)), errors.collect(cdk.propertyValidator("publicDomainNames", cdk.listValidator(CfnContainer_PublicDomainNamePropertyValidator))(properties.publicDomainNames)), errors.collect(cdk.propertyValidator("scale", cdk.requiredValidator)(properties.scale)), errors.collect(cdk.propertyValidator("scale", cdk.validateNumber)(properties.scale)), errors.collect(cdk.propertyValidator("serviceName", cdk.requiredValidator)(properties.serviceName)), errors.collect(cdk.propertyValidator("serviceName", cdk.validateString)(properties.serviceName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnContainerProps"');
    }
    function cfnContainerPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContainerPropsValidator(properties).assertSuccess(), { Power: cdk.stringToCloudFormation(properties.power), Scale: cdk.numberToCloudFormation(properties.scale), ServiceName: cdk.stringToCloudFormation(properties.serviceName), ContainerServiceDeployment: cfnContainerContainerServiceDeploymentPropertyToCloudFormation(properties.containerServiceDeployment), IsDisabled: cdk.booleanToCloudFormation(properties.isDisabled), PublicDomainNames: cdk.listMapper(cfnContainerPublicDomainNamePropertyToCloudFormation)(properties.publicDomainNames), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnContainerPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("power", "Power", cfn_parse.FromCloudFormation.getString(properties.Power)), ret.addPropertyResult("scale", "Scale", cfn_parse.FromCloudFormation.getNumber(properties.Scale)), ret.addPropertyResult("serviceName", "ServiceName", cfn_parse.FromCloudFormation.getString(properties.ServiceName)), ret.addPropertyResult("containerServiceDeployment", "ContainerServiceDeployment", properties.ContainerServiceDeployment != null ? CfnContainerContainerServiceDeploymentPropertyFromCloudFormation(properties.ContainerServiceDeployment) : void 0), ret.addPropertyResult("isDisabled", "IsDisabled", properties.IsDisabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsDisabled) : void 0), ret.addPropertyResult("publicDomainNames", "PublicDomainNames", properties.PublicDomainNames != null ? cfn_parse.FromCloudFormation.getArray(CfnContainerPublicDomainNamePropertyFromCloudFormation)(properties.PublicDomainNames) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnContainer = class _CfnContainer extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnContainerPropsFromCloudFormation(resourceProperties), ret = new _CfnContainer(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnContainer.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lightsail_CfnContainerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnContainer), error;
        }
        cdk.requireProperty(props, "power", this), cdk.requireProperty(props, "scale", this), cdk.requireProperty(props, "serviceName", this), this.attrContainerArn = cdk.Token.asString(this.getAtt("ContainerArn", cdk.ResolutionTypeHint.STRING)), this.attrUrl = cdk.Token.asString(this.getAtt("Url", cdk.ResolutionTypeHint.STRING)), this.power = props.power, this.scale = props.scale, this.serviceName = props.serviceName, this.containerServiceDeployment = props.containerServiceDeployment, this.isDisabled = props.isDisabled, this.publicDomainNames = props.publicDomainNames, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Lightsail::Container", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnContainer.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { power: this.power, scale: this.scale, serviceName: this.serviceName, containerServiceDeployment: this.containerServiceDeployment, isDisabled: this.isDisabled, publicDomainNames: this.publicDomainNames, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnContainerPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnContainer[_d] = { fqn: "aws-cdk-lib.aws_lightsail.CfnContainer", version: "2.80.0" }, CfnContainer.CFN_RESOURCE_TYPE_NAME = "AWS::Lightsail::Container", exports2.CfnContainer = CfnContainer;
    function CfnContainer_ContainerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("command", cdk.listValidator(cdk.validateString))(properties.command)), errors.collect(cdk.propertyValidator("containerName", cdk.validateString)(properties.containerName)), errors.collect(cdk.propertyValidator("environment", cdk.listValidator(CfnContainer_EnvironmentVariablePropertyValidator))(properties.environment)), errors.collect(cdk.propertyValidator("image", cdk.validateString)(properties.image)), errors.collect(cdk.propertyValidator("ports", cdk.listValidator(CfnContainer_PortInfoPropertyValidator))(properties.ports)), errors.wrap('supplied properties not correct for "ContainerProperty"');
    }
    function cfnContainerContainerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContainer_ContainerPropertyValidator(properties).assertSuccess(), { Command: cdk.listMapper(cdk.stringToCloudFormation)(properties.command), ContainerName: cdk.stringToCloudFormation(properties.containerName), Environment: cdk.listMapper(cfnContainerEnvironmentVariablePropertyToCloudFormation)(properties.environment), Image: cdk.stringToCloudFormation(properties.image), Ports: cdk.listMapper(cfnContainerPortInfoPropertyToCloudFormation)(properties.ports) }) : properties;
    }
    function CfnContainerContainerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("command", "Command", properties.Command != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Command) : void 0), ret.addPropertyResult("containerName", "ContainerName", properties.ContainerName != null ? cfn_parse.FromCloudFormation.getString(properties.ContainerName) : void 0), ret.addPropertyResult("environment", "Environment", properties.Environment != null ? cfn_parse.FromCloudFormation.getArray(CfnContainerEnvironmentVariablePropertyFromCloudFormation)(properties.Environment) : void 0), ret.addPropertyResult("image", "Image", properties.Image != null ? cfn_parse.FromCloudFormation.getString(properties.Image) : void 0), ret.addPropertyResult("ports", "Ports", properties.Ports != null ? cfn_parse.FromCloudFormation.getArray(CfnContainerPortInfoPropertyFromCloudFormation)(properties.Ports) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnContainer_ContainerServiceDeploymentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containers", cdk.listValidator(CfnContainer_ContainerPropertyValidator))(properties.containers)), errors.collect(cdk.propertyValidator("publicEndpoint", CfnContainer_PublicEndpointPropertyValidator)(properties.publicEndpoint)), errors.wrap('supplied properties not correct for "ContainerServiceDeploymentProperty"');
    }
    function cfnContainerContainerServiceDeploymentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContainer_ContainerServiceDeploymentPropertyValidator(properties).assertSuccess(), { Containers: cdk.listMapper(cfnContainerContainerPropertyToCloudFormation)(properties.containers), PublicEndpoint: cfnContainerPublicEndpointPropertyToCloudFormation(properties.publicEndpoint) }) : properties;
    }
    function CfnContainerContainerServiceDeploymentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containers", "Containers", properties.Containers != null ? cfn_parse.FromCloudFormation.getArray(CfnContainerContainerPropertyFromCloudFormation)(properties.Containers) : void 0), ret.addPropertyResult("publicEndpoint", "PublicEndpoint", properties.PublicEndpoint != null ? CfnContainerPublicEndpointPropertyFromCloudFormation(properties.PublicEndpoint) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnContainer_EnvironmentVariablePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.collect(cdk.propertyValidator("variable", cdk.validateString)(properties.variable)), errors.wrap('supplied properties not correct for "EnvironmentVariableProperty"');
    }
    function cfnContainerEnvironmentVariablePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContainer_EnvironmentVariablePropertyValidator(properties).assertSuccess(), { Value: cdk.stringToCloudFormation(properties.value), Variable: cdk.stringToCloudFormation(properties.variable) }) : properties;
    }
    function CfnContainerEnvironmentVariablePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addPropertyResult("variable", "Variable", properties.Variable != null ? cfn_parse.FromCloudFormation.getString(properties.Variable) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnContainer_HealthCheckConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("healthyThreshold", cdk.validateNumber)(properties.healthyThreshold)), errors.collect(cdk.propertyValidator("intervalSeconds", cdk.validateNumber)(properties.intervalSeconds)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.collect(cdk.propertyValidator("successCodes", cdk.validateString)(properties.successCodes)), errors.collect(cdk.propertyValidator("timeoutSeconds", cdk.validateNumber)(properties.timeoutSeconds)), errors.collect(cdk.propertyValidator("unhealthyThreshold", cdk.validateNumber)(properties.unhealthyThreshold)), errors.wrap('supplied properties not correct for "HealthCheckConfigProperty"');
    }
    function cfnContainerHealthCheckConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContainer_HealthCheckConfigPropertyValidator(properties).assertSuccess(), { HealthyThreshold: cdk.numberToCloudFormation(properties.healthyThreshold), IntervalSeconds: cdk.numberToCloudFormation(properties.intervalSeconds), Path: cdk.stringToCloudFormation(properties.path), SuccessCodes: cdk.stringToCloudFormation(properties.successCodes), TimeoutSeconds: cdk.numberToCloudFormation(properties.timeoutSeconds), UnhealthyThreshold: cdk.numberToCloudFormation(properties.unhealthyThreshold) }) : properties;
    }
    function CfnContainerHealthCheckConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("healthyThreshold", "HealthyThreshold", properties.HealthyThreshold != null ? cfn_parse.FromCloudFormation.getNumber(properties.HealthyThreshold) : void 0), ret.addPropertyResult("intervalSeconds", "IntervalSeconds", properties.IntervalSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.IntervalSeconds) : void 0), ret.addPropertyResult("path", "Path", properties.Path != null ? cfn_parse.FromCloudFormation.getString(properties.Path) : void 0), ret.addPropertyResult("successCodes", "SuccessCodes", properties.SuccessCodes != null ? cfn_parse.FromCloudFormation.getString(properties.SuccessCodes) : void 0), ret.addPropertyResult("timeoutSeconds", "TimeoutSeconds", properties.TimeoutSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.TimeoutSeconds) : void 0), ret.addPropertyResult("unhealthyThreshold", "UnhealthyThreshold", properties.UnhealthyThreshold != null ? cfn_parse.FromCloudFormation.getNumber(properties.UnhealthyThreshold) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnContainer_PortInfoPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("port", cdk.validateString)(properties.port)), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.wrap('supplied properties not correct for "PortInfoProperty"');
    }
    function cfnContainerPortInfoPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContainer_PortInfoPropertyValidator(properties).assertSuccess(), { Port: cdk.stringToCloudFormation(properties.port), Protocol: cdk.stringToCloudFormation(properties.protocol) }) : properties;
    }
    function CfnContainerPortInfoPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getString(properties.Port) : void 0), ret.addPropertyResult("protocol", "Protocol", properties.Protocol != null ? cfn_parse.FromCloudFormation.getString(properties.Protocol) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnContainer_PublicDomainNamePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateName", cdk.validateString)(properties.certificateName)), errors.collect(cdk.propertyValidator("domainNames", cdk.listValidator(cdk.validateString))(properties.domainNames)), errors.wrap('supplied properties not correct for "PublicDomainNameProperty"');
    }
    function cfnContainerPublicDomainNamePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContainer_PublicDomainNamePropertyValidator(properties).assertSuccess(), { CertificateName: cdk.stringToCloudFormation(properties.certificateName), DomainNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.domainNames) }) : properties;
    }
    function CfnContainerPublicDomainNamePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificateName", "CertificateName", properties.CertificateName != null ? cfn_parse.FromCloudFormation.getString(properties.CertificateName) : void 0), ret.addPropertyResult("domainNames", "DomainNames", properties.DomainNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.DomainNames) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnContainer_PublicEndpointPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containerName", cdk.validateString)(properties.containerName)), errors.collect(cdk.propertyValidator("containerPort", cdk.validateNumber)(properties.containerPort)), errors.collect(cdk.propertyValidator("healthCheckConfig", CfnContainer_HealthCheckConfigPropertyValidator)(properties.healthCheckConfig)), errors.wrap('supplied properties not correct for "PublicEndpointProperty"');
    }
    function cfnContainerPublicEndpointPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContainer_PublicEndpointPropertyValidator(properties).assertSuccess(), { ContainerName: cdk.stringToCloudFormation(properties.containerName), ContainerPort: cdk.numberToCloudFormation(properties.containerPort), HealthCheckConfig: cfnContainerHealthCheckConfigPropertyToCloudFormation(properties.healthCheckConfig) }) : properties;
    }
    function CfnContainerPublicEndpointPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containerName", "ContainerName", properties.ContainerName != null ? cfn_parse.FromCloudFormation.getString(properties.ContainerName) : void 0), ret.addPropertyResult("containerPort", "ContainerPort", properties.ContainerPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.ContainerPort) : void 0), ret.addPropertyResult("healthCheckConfig", "HealthCheckConfig", properties.HealthCheckConfig != null ? CfnContainerHealthCheckConfigPropertyFromCloudFormation(properties.HealthCheckConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDatabasePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availabilityZone", cdk.validateString)(properties.availabilityZone)), errors.collect(cdk.propertyValidator("backupRetention", cdk.validateBoolean)(properties.backupRetention)), errors.collect(cdk.propertyValidator("caCertificateIdentifier", cdk.validateString)(properties.caCertificateIdentifier)), errors.collect(cdk.propertyValidator("masterDatabaseName", cdk.requiredValidator)(properties.masterDatabaseName)), errors.collect(cdk.propertyValidator("masterDatabaseName", cdk.validateString)(properties.masterDatabaseName)), errors.collect(cdk.propertyValidator("masterUserPassword", cdk.validateString)(properties.masterUserPassword)), errors.collect(cdk.propertyValidator("masterUsername", cdk.requiredValidator)(properties.masterUsername)), errors.collect(cdk.propertyValidator("masterUsername", cdk.validateString)(properties.masterUsername)), errors.collect(cdk.propertyValidator("preferredBackupWindow", cdk.validateString)(properties.preferredBackupWindow)), errors.collect(cdk.propertyValidator("preferredMaintenanceWindow", cdk.validateString)(properties.preferredMaintenanceWindow)), errors.collect(cdk.propertyValidator("publiclyAccessible", cdk.validateBoolean)(properties.publiclyAccessible)), errors.collect(cdk.propertyValidator("relationalDatabaseBlueprintId", cdk.requiredValidator)(properties.relationalDatabaseBlueprintId)), errors.collect(cdk.propertyValidator("relationalDatabaseBlueprintId", cdk.validateString)(properties.relationalDatabaseBlueprintId)), errors.collect(cdk.propertyValidator("relationalDatabaseBundleId", cdk.requiredValidator)(properties.relationalDatabaseBundleId)), errors.collect(cdk.propertyValidator("relationalDatabaseBundleId", cdk.validateString)(properties.relationalDatabaseBundleId)), errors.collect(cdk.propertyValidator("relationalDatabaseName", cdk.requiredValidator)(properties.relationalDatabaseName)), errors.collect(cdk.propertyValidator("relationalDatabaseName", cdk.validateString)(properties.relationalDatabaseName)), errors.collect(cdk.propertyValidator("relationalDatabaseParameters", cdk.listValidator(CfnDatabase_RelationalDatabaseParameterPropertyValidator))(properties.relationalDatabaseParameters)), errors.collect(cdk.propertyValidator("rotateMasterUserPassword", cdk.validateBoolean)(properties.rotateMasterUserPassword)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDatabaseProps"');
    }
    function cfnDatabasePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDatabasePropsValidator(properties).assertSuccess(), { MasterDatabaseName: cdk.stringToCloudFormation(properties.masterDatabaseName), MasterUsername: cdk.stringToCloudFormation(properties.masterUsername), RelationalDatabaseBlueprintId: cdk.stringToCloudFormation(properties.relationalDatabaseBlueprintId), RelationalDatabaseBundleId: cdk.stringToCloudFormation(properties.relationalDatabaseBundleId), RelationalDatabaseName: cdk.stringToCloudFormation(properties.relationalDatabaseName), AvailabilityZone: cdk.stringToCloudFormation(properties.availabilityZone), BackupRetention: cdk.booleanToCloudFormation(properties.backupRetention), CaCertificateIdentifier: cdk.stringToCloudFormation(properties.caCertificateIdentifier), MasterUserPassword: cdk.stringToCloudFormation(properties.masterUserPassword), PreferredBackupWindow: cdk.stringToCloudFormation(properties.preferredBackupWindow), PreferredMaintenanceWindow: cdk.stringToCloudFormation(properties.preferredMaintenanceWindow), PubliclyAccessible: cdk.booleanToCloudFormation(properties.publiclyAccessible), RelationalDatabaseParameters: cdk.listMapper(cfnDatabaseRelationalDatabaseParameterPropertyToCloudFormation)(properties.relationalDatabaseParameters), RotateMasterUserPassword: cdk.booleanToCloudFormation(properties.rotateMasterUserPassword), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDatabasePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("masterDatabaseName", "MasterDatabaseName", cfn_parse.FromCloudFormation.getString(properties.MasterDatabaseName)), ret.addPropertyResult("masterUsername", "MasterUsername", cfn_parse.FromCloudFormation.getString(properties.MasterUsername)), ret.addPropertyResult("relationalDatabaseBlueprintId", "RelationalDatabaseBlueprintId", cfn_parse.FromCloudFormation.getString(properties.RelationalDatabaseBlueprintId)), ret.addPropertyResult("relationalDatabaseBundleId", "RelationalDatabaseBundleId", cfn_parse.FromCloudFormation.getString(properties.RelationalDatabaseBundleId)), ret.addPropertyResult("relationalDatabaseName", "RelationalDatabaseName", cfn_parse.FromCloudFormation.getString(properties.RelationalDatabaseName)), ret.addPropertyResult("availabilityZone", "AvailabilityZone", properties.AvailabilityZone != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityZone) : void 0), ret.addPropertyResult("backupRetention", "BackupRetention", properties.BackupRetention != null ? cfn_parse.FromCloudFormation.getBoolean(properties.BackupRetention) : void 0), ret.addPropertyResult("caCertificateIdentifier", "CaCertificateIdentifier", properties.CaCertificateIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.CaCertificateIdentifier) : void 0), ret.addPropertyResult("masterUserPassword", "MasterUserPassword", properties.MasterUserPassword != null ? cfn_parse.FromCloudFormation.getString(properties.MasterUserPassword) : void 0), ret.addPropertyResult("preferredBackupWindow", "PreferredBackupWindow", properties.PreferredBackupWindow != null ? cfn_parse.FromCloudFormation.getString(properties.PreferredBackupWindow) : void 0), ret.addPropertyResult("preferredMaintenanceWindow", "PreferredMaintenanceWindow", properties.PreferredMaintenanceWindow != null ? cfn_parse.FromCloudFormation.getString(properties.PreferredMaintenanceWindow) : void 0), ret.addPropertyResult("publiclyAccessible", "PubliclyAccessible", properties.PubliclyAccessible != null ? cfn_parse.FromCloudFormation.getBoolean(properties.PubliclyAccessible) : void 0), ret.addPropertyResult("relationalDatabaseParameters", "RelationalDatabaseParameters", properties.RelationalDatabaseParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnDatabaseRelationalDatabaseParameterPropertyFromCloudFormation)(properties.RelationalDatabaseParameters) : void 0), ret.addPropertyResult("rotateMasterUserPassword", "RotateMasterUserPassword", properties.RotateMasterUserPassword != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RotateMasterUserPassword) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDatabase = class _CfnDatabase extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDatabasePropsFromCloudFormation(resourceProperties), ret = new _CfnDatabase(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDatabase.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lightsail_CfnDatabaseProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDatabase), error;
        }
        cdk.requireProperty(props, "masterDatabaseName", this), cdk.requireProperty(props, "masterUsername", this), cdk.requireProperty(props, "relationalDatabaseBlueprintId", this), cdk.requireProperty(props, "relationalDatabaseBundleId", this), cdk.requireProperty(props, "relationalDatabaseName", this), this.attrDatabaseArn = cdk.Token.asString(this.getAtt("DatabaseArn", cdk.ResolutionTypeHint.STRING)), this.masterDatabaseName = props.masterDatabaseName, this.masterUsername = props.masterUsername, this.relationalDatabaseBlueprintId = props.relationalDatabaseBlueprintId, this.relationalDatabaseBundleId = props.relationalDatabaseBundleId, this.relationalDatabaseName = props.relationalDatabaseName, this.availabilityZone = props.availabilityZone, this.backupRetention = props.backupRetention, this.caCertificateIdentifier = props.caCertificateIdentifier, this.masterUserPassword = props.masterUserPassword, this.preferredBackupWindow = props.preferredBackupWindow, this.preferredMaintenanceWindow = props.preferredMaintenanceWindow, this.publiclyAccessible = props.publiclyAccessible, this.relationalDatabaseParameters = props.relationalDatabaseParameters, this.rotateMasterUserPassword = props.rotateMasterUserPassword, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Lightsail::Database", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDatabase.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { masterDatabaseName: this.masterDatabaseName, masterUsername: this.masterUsername, relationalDatabaseBlueprintId: this.relationalDatabaseBlueprintId, relationalDatabaseBundleId: this.relationalDatabaseBundleId, relationalDatabaseName: this.relationalDatabaseName, availabilityZone: this.availabilityZone, backupRetention: this.backupRetention, caCertificateIdentifier: this.caCertificateIdentifier, masterUserPassword: this.masterUserPassword, preferredBackupWindow: this.preferredBackupWindow, preferredMaintenanceWindow: this.preferredMaintenanceWindow, publiclyAccessible: this.publiclyAccessible, relationalDatabaseParameters: this.relationalDatabaseParameters, rotateMasterUserPassword: this.rotateMasterUserPassword, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDatabasePropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnDatabase[_e] = { fqn: "aws-cdk-lib.aws_lightsail.CfnDatabase", version: "2.80.0" }, CfnDatabase.CFN_RESOURCE_TYPE_NAME = "AWS::Lightsail::Database", exports2.CfnDatabase = CfnDatabase;
    function CfnDatabase_RelationalDatabaseParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowedValues", cdk.validateString)(properties.allowedValues)), errors.collect(cdk.propertyValidator("applyMethod", cdk.validateString)(properties.applyMethod)), errors.collect(cdk.propertyValidator("applyType", cdk.validateString)(properties.applyType)), errors.collect(cdk.propertyValidator("dataType", cdk.validateString)(properties.dataType)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("isModifiable", cdk.validateBoolean)(properties.isModifiable)), errors.collect(cdk.propertyValidator("parameterName", cdk.validateString)(properties.parameterName)), errors.collect(cdk.propertyValidator("parameterValue", cdk.validateString)(properties.parameterValue)), errors.wrap('supplied properties not correct for "RelationalDatabaseParameterProperty"');
    }
    function cfnDatabaseRelationalDatabaseParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDatabase_RelationalDatabaseParameterPropertyValidator(properties).assertSuccess(), { AllowedValues: cdk.stringToCloudFormation(properties.allowedValues), ApplyMethod: cdk.stringToCloudFormation(properties.applyMethod), ApplyType: cdk.stringToCloudFormation(properties.applyType), DataType: cdk.stringToCloudFormation(properties.dataType), Description: cdk.stringToCloudFormation(properties.description), IsModifiable: cdk.booleanToCloudFormation(properties.isModifiable), ParameterName: cdk.stringToCloudFormation(properties.parameterName), ParameterValue: cdk.stringToCloudFormation(properties.parameterValue) }) : properties;
    }
    function CfnDatabaseRelationalDatabaseParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowedValues", "AllowedValues", properties.AllowedValues != null ? cfn_parse.FromCloudFormation.getString(properties.AllowedValues) : void 0), ret.addPropertyResult("applyMethod", "ApplyMethod", properties.ApplyMethod != null ? cfn_parse.FromCloudFormation.getString(properties.ApplyMethod) : void 0), ret.addPropertyResult("applyType", "ApplyType", properties.ApplyType != null ? cfn_parse.FromCloudFormation.getString(properties.ApplyType) : void 0), ret.addPropertyResult("dataType", "DataType", properties.DataType != null ? cfn_parse.FromCloudFormation.getString(properties.DataType) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("isModifiable", "IsModifiable", properties.IsModifiable != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsModifiable) : void 0), ret.addPropertyResult("parameterName", "ParameterName", properties.ParameterName != null ? cfn_parse.FromCloudFormation.getString(properties.ParameterName) : void 0), ret.addPropertyResult("parameterValue", "ParameterValue", properties.ParameterValue != null ? cfn_parse.FromCloudFormation.getString(properties.ParameterValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDiskPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("addOns", cdk.listValidator(CfnDisk_AddOnPropertyValidator))(properties.addOns)), errors.collect(cdk.propertyValidator("availabilityZone", cdk.validateString)(properties.availabilityZone)), errors.collect(cdk.propertyValidator("diskName", cdk.requiredValidator)(properties.diskName)), errors.collect(cdk.propertyValidator("diskName", cdk.validateString)(properties.diskName)), errors.collect(cdk.propertyValidator("location", CfnDisk_LocationPropertyValidator)(properties.location)), errors.collect(cdk.propertyValidator("sizeInGb", cdk.requiredValidator)(properties.sizeInGb)), errors.collect(cdk.propertyValidator("sizeInGb", cdk.validateNumber)(properties.sizeInGb)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDiskProps"');
    }
    function cfnDiskPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDiskPropsValidator(properties).assertSuccess(), { DiskName: cdk.stringToCloudFormation(properties.diskName), SizeInGb: cdk.numberToCloudFormation(properties.sizeInGb), AddOns: cdk.listMapper(cfnDiskAddOnPropertyToCloudFormation)(properties.addOns), AvailabilityZone: cdk.stringToCloudFormation(properties.availabilityZone), Location: cfnDiskLocationPropertyToCloudFormation(properties.location), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDiskPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("diskName", "DiskName", cfn_parse.FromCloudFormation.getString(properties.DiskName)), ret.addPropertyResult("sizeInGb", "SizeInGb", cfn_parse.FromCloudFormation.getNumber(properties.SizeInGb)), ret.addPropertyResult("addOns", "AddOns", properties.AddOns != null ? cfn_parse.FromCloudFormation.getArray(CfnDiskAddOnPropertyFromCloudFormation)(properties.AddOns) : void 0), ret.addPropertyResult("availabilityZone", "AvailabilityZone", properties.AvailabilityZone != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityZone) : void 0), ret.addPropertyResult("location", "Location", properties.Location != null ? CfnDiskLocationPropertyFromCloudFormation(properties.Location) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDisk = class _CfnDisk extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDiskPropsFromCloudFormation(resourceProperties), ret = new _CfnDisk(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDisk.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lightsail_CfnDiskProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDisk), error;
        }
        cdk.requireProperty(props, "diskName", this), cdk.requireProperty(props, "sizeInGb", this), this.attrAttachedTo = cdk.Token.asString(this.getAtt("AttachedTo", cdk.ResolutionTypeHint.STRING)), this.attrAttachmentState = cdk.Token.asString(this.getAtt("AttachmentState", cdk.ResolutionTypeHint.STRING)), this.attrDiskArn = cdk.Token.asString(this.getAtt("DiskArn", cdk.ResolutionTypeHint.STRING)), this.attrIops = cdk.Token.asNumber(this.getAtt("Iops", cdk.ResolutionTypeHint.NUMBER)), this.attrIsAttached = this.getAtt("IsAttached", cdk.ResolutionTypeHint.STRING), this.attrLocationAvailabilityZone = cdk.Token.asString(this.getAtt("Location.AvailabilityZone", cdk.ResolutionTypeHint.STRING)), this.attrLocationRegionName = cdk.Token.asString(this.getAtt("Location.RegionName", cdk.ResolutionTypeHint.STRING)), this.attrPath = cdk.Token.asString(this.getAtt("Path", cdk.ResolutionTypeHint.STRING)), this.attrResourceType = cdk.Token.asString(this.getAtt("ResourceType", cdk.ResolutionTypeHint.STRING)), this.attrState = cdk.Token.asString(this.getAtt("State", cdk.ResolutionTypeHint.STRING)), this.attrSupportCode = cdk.Token.asString(this.getAtt("SupportCode", cdk.ResolutionTypeHint.STRING)), this.diskName = props.diskName, this.sizeInGb = props.sizeInGb, this.addOns = props.addOns, this.availabilityZone = props.availabilityZone, this.location = props.location, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Lightsail::Disk", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDisk.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { diskName: this.diskName, sizeInGb: this.sizeInGb, addOns: this.addOns, availabilityZone: this.availabilityZone, location: this.location, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDiskPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnDisk[_f] = { fqn: "aws-cdk-lib.aws_lightsail.CfnDisk", version: "2.80.0" }, CfnDisk.CFN_RESOURCE_TYPE_NAME = "AWS::Lightsail::Disk", exports2.CfnDisk = CfnDisk;
    function CfnDisk_AddOnPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("addOnType", cdk.requiredValidator)(properties.addOnType)), errors.collect(cdk.propertyValidator("addOnType", cdk.validateString)(properties.addOnType)), errors.collect(cdk.propertyValidator("autoSnapshotAddOnRequest", CfnDisk_AutoSnapshotAddOnPropertyValidator)(properties.autoSnapshotAddOnRequest)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "AddOnProperty"');
    }
    function cfnDiskAddOnPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDisk_AddOnPropertyValidator(properties).assertSuccess(), { AddOnType: cdk.stringToCloudFormation(properties.addOnType), AutoSnapshotAddOnRequest: cfnDiskAutoSnapshotAddOnPropertyToCloudFormation(properties.autoSnapshotAddOnRequest), Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnDiskAddOnPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("addOnType", "AddOnType", cfn_parse.FromCloudFormation.getString(properties.AddOnType)), ret.addPropertyResult("autoSnapshotAddOnRequest", "AutoSnapshotAddOnRequest", properties.AutoSnapshotAddOnRequest != null ? CfnDiskAutoSnapshotAddOnPropertyFromCloudFormation(properties.AutoSnapshotAddOnRequest) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDisk_AutoSnapshotAddOnPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("snapshotTimeOfDay", cdk.validateString)(properties.snapshotTimeOfDay)), errors.wrap('supplied properties not correct for "AutoSnapshotAddOnProperty"');
    }
    function cfnDiskAutoSnapshotAddOnPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDisk_AutoSnapshotAddOnPropertyValidator(properties).assertSuccess(), { SnapshotTimeOfDay: cdk.stringToCloudFormation(properties.snapshotTimeOfDay) }) : properties;
    }
    function CfnDiskAutoSnapshotAddOnPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("snapshotTimeOfDay", "SnapshotTimeOfDay", properties.SnapshotTimeOfDay != null ? cfn_parse.FromCloudFormation.getString(properties.SnapshotTimeOfDay) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDisk_LocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availabilityZone", cdk.validateString)(properties.availabilityZone)), errors.collect(cdk.propertyValidator("regionName", cdk.validateString)(properties.regionName)), errors.wrap('supplied properties not correct for "LocationProperty"');
    }
    function cfnDiskLocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDisk_LocationPropertyValidator(properties).assertSuccess(), { AvailabilityZone: cdk.stringToCloudFormation(properties.availabilityZone), RegionName: cdk.stringToCloudFormation(properties.regionName) }) : properties;
    }
    function CfnDiskLocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("availabilityZone", "AvailabilityZone", properties.AvailabilityZone != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityZone) : void 0), ret.addPropertyResult("regionName", "RegionName", properties.RegionName != null ? cfn_parse.FromCloudFormation.getString(properties.RegionName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistributionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bundleId", cdk.requiredValidator)(properties.bundleId)), errors.collect(cdk.propertyValidator("bundleId", cdk.validateString)(properties.bundleId)), errors.collect(cdk.propertyValidator("cacheBehaviorSettings", CfnDistribution_CacheSettingsPropertyValidator)(properties.cacheBehaviorSettings)), errors.collect(cdk.propertyValidator("cacheBehaviors", cdk.listValidator(CfnDistribution_CacheBehaviorPerPathPropertyValidator))(properties.cacheBehaviors)), errors.collect(cdk.propertyValidator("certificateName", cdk.validateString)(properties.certificateName)), errors.collect(cdk.propertyValidator("defaultCacheBehavior", cdk.requiredValidator)(properties.defaultCacheBehavior)), errors.collect(cdk.propertyValidator("defaultCacheBehavior", CfnDistribution_CacheBehaviorPropertyValidator)(properties.defaultCacheBehavior)), errors.collect(cdk.propertyValidator("distributionName", cdk.requiredValidator)(properties.distributionName)), errors.collect(cdk.propertyValidator("distributionName", cdk.validateString)(properties.distributionName)), errors.collect(cdk.propertyValidator("ipAddressType", cdk.validateString)(properties.ipAddressType)), errors.collect(cdk.propertyValidator("isEnabled", cdk.validateBoolean)(properties.isEnabled)), errors.collect(cdk.propertyValidator("origin", cdk.requiredValidator)(properties.origin)), errors.collect(cdk.propertyValidator("origin", CfnDistribution_InputOriginPropertyValidator)(properties.origin)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDistributionProps"');
    }
    function cfnDistributionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistributionPropsValidator(properties).assertSuccess(), { BundleId: cdk.stringToCloudFormation(properties.bundleId), DefaultCacheBehavior: cfnDistributionCacheBehaviorPropertyToCloudFormation(properties.defaultCacheBehavior), DistributionName: cdk.stringToCloudFormation(properties.distributionName), Origin: cfnDistributionInputOriginPropertyToCloudFormation(properties.origin), CacheBehaviors: cdk.listMapper(cfnDistributionCacheBehaviorPerPathPropertyToCloudFormation)(properties.cacheBehaviors), CacheBehaviorSettings: cfnDistributionCacheSettingsPropertyToCloudFormation(properties.cacheBehaviorSettings), CertificateName: cdk.stringToCloudFormation(properties.certificateName), IpAddressType: cdk.stringToCloudFormation(properties.ipAddressType), IsEnabled: cdk.booleanToCloudFormation(properties.isEnabled), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDistributionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bundleId", "BundleId", cfn_parse.FromCloudFormation.getString(properties.BundleId)), ret.addPropertyResult("defaultCacheBehavior", "DefaultCacheBehavior", CfnDistributionCacheBehaviorPropertyFromCloudFormation(properties.DefaultCacheBehavior)), ret.addPropertyResult("distributionName", "DistributionName", cfn_parse.FromCloudFormation.getString(properties.DistributionName)), ret.addPropertyResult("origin", "Origin", CfnDistributionInputOriginPropertyFromCloudFormation(properties.Origin)), ret.addPropertyResult("cacheBehaviors", "CacheBehaviors", properties.CacheBehaviors != null ? cfn_parse.FromCloudFormation.getArray(CfnDistributionCacheBehaviorPerPathPropertyFromCloudFormation)(properties.CacheBehaviors) : void 0), ret.addPropertyResult("cacheBehaviorSettings", "CacheBehaviorSettings", properties.CacheBehaviorSettings != null ? CfnDistributionCacheSettingsPropertyFromCloudFormation(properties.CacheBehaviorSettings) : void 0), ret.addPropertyResult("certificateName", "CertificateName", properties.CertificateName != null ? cfn_parse.FromCloudFormation.getString(properties.CertificateName) : void 0), ret.addPropertyResult("ipAddressType", "IpAddressType", properties.IpAddressType != null ? cfn_parse.FromCloudFormation.getString(properties.IpAddressType) : void 0), ret.addPropertyResult("isEnabled", "IsEnabled", properties.IsEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsEnabled) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDistribution = class _CfnDistribution extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDistributionPropsFromCloudFormation(resourceProperties), ret = new _CfnDistribution(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDistribution.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lightsail_CfnDistributionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDistribution), error;
        }
        cdk.requireProperty(props, "bundleId", this), cdk.requireProperty(props, "defaultCacheBehavior", this), cdk.requireProperty(props, "distributionName", this), cdk.requireProperty(props, "origin", this), this.attrAbleToUpdateBundle = this.getAtt("AbleToUpdateBundle", cdk.ResolutionTypeHint.STRING), this.attrDistributionArn = cdk.Token.asString(this.getAtt("DistributionArn", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.bundleId = props.bundleId, this.defaultCacheBehavior = props.defaultCacheBehavior, this.distributionName = props.distributionName, this.origin = props.origin, this.cacheBehaviors = props.cacheBehaviors, this.cacheBehaviorSettings = props.cacheBehaviorSettings, this.certificateName = props.certificateName, this.ipAddressType = props.ipAddressType, this.isEnabled = props.isEnabled, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Lightsail::Distribution", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDistribution.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { bundleId: this.bundleId, defaultCacheBehavior: this.defaultCacheBehavior, distributionName: this.distributionName, origin: this.origin, cacheBehaviors: this.cacheBehaviors, cacheBehaviorSettings: this.cacheBehaviorSettings, certificateName: this.certificateName, ipAddressType: this.ipAddressType, isEnabled: this.isEnabled, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDistributionPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnDistribution[_g] = { fqn: "aws-cdk-lib.aws_lightsail.CfnDistribution", version: "2.80.0" }, CfnDistribution.CFN_RESOURCE_TYPE_NAME = "AWS::Lightsail::Distribution", exports2.CfnDistribution = CfnDistribution;
    function CfnDistribution_CacheBehaviorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("behavior", cdk.validateString)(properties.behavior)), errors.wrap('supplied properties not correct for "CacheBehaviorProperty"');
    }
    function cfnDistributionCacheBehaviorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_CacheBehaviorPropertyValidator(properties).assertSuccess(), { Behavior: cdk.stringToCloudFormation(properties.behavior) }) : properties;
    }
    function CfnDistributionCacheBehaviorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("behavior", "Behavior", properties.Behavior != null ? cfn_parse.FromCloudFormation.getString(properties.Behavior) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistribution_CacheBehaviorPerPathPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("behavior", cdk.validateString)(properties.behavior)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.wrap('supplied properties not correct for "CacheBehaviorPerPathProperty"');
    }
    function cfnDistributionCacheBehaviorPerPathPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_CacheBehaviorPerPathPropertyValidator(properties).assertSuccess(), { Behavior: cdk.stringToCloudFormation(properties.behavior), Path: cdk.stringToCloudFormation(properties.path) }) : properties;
    }
    function CfnDistributionCacheBehaviorPerPathPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("behavior", "Behavior", properties.Behavior != null ? cfn_parse.FromCloudFormation.getString(properties.Behavior) : void 0), ret.addPropertyResult("path", "Path", properties.Path != null ? cfn_parse.FromCloudFormation.getString(properties.Path) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistribution_CacheSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowedHttpMethods", cdk.validateString)(properties.allowedHttpMethods)), errors.collect(cdk.propertyValidator("cachedHttpMethods", cdk.validateString)(properties.cachedHttpMethods)), errors.collect(cdk.propertyValidator("defaultTtl", cdk.validateNumber)(properties.defaultTtl)), errors.collect(cdk.propertyValidator("forwardedCookies", CfnDistribution_CookieObjectPropertyValidator)(properties.forwardedCookies)), errors.collect(cdk.propertyValidator("forwardedHeaders", CfnDistribution_HeaderObjectPropertyValidator)(properties.forwardedHeaders)), errors.collect(cdk.propertyValidator("forwardedQueryStrings", CfnDistribution_QueryStringObjectPropertyValidator)(properties.forwardedQueryStrings)), errors.collect(cdk.propertyValidator("maximumTtl", cdk.validateNumber)(properties.maximumTtl)), errors.collect(cdk.propertyValidator("minimumTtl", cdk.validateNumber)(properties.minimumTtl)), errors.wrap('supplied properties not correct for "CacheSettingsProperty"');
    }
    function cfnDistributionCacheSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_CacheSettingsPropertyValidator(properties).assertSuccess(), { AllowedHTTPMethods: cdk.stringToCloudFormation(properties.allowedHttpMethods), CachedHTTPMethods: cdk.stringToCloudFormation(properties.cachedHttpMethods), DefaultTTL: cdk.numberToCloudFormation(properties.defaultTtl), ForwardedCookies: cfnDistributionCookieObjectPropertyToCloudFormation(properties.forwardedCookies), ForwardedHeaders: cfnDistributionHeaderObjectPropertyToCloudFormation(properties.forwardedHeaders), ForwardedQueryStrings: cfnDistributionQueryStringObjectPropertyToCloudFormation(properties.forwardedQueryStrings), MaximumTTL: cdk.numberToCloudFormation(properties.maximumTtl), MinimumTTL: cdk.numberToCloudFormation(properties.minimumTtl) }) : properties;
    }
    function CfnDistributionCacheSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowedHttpMethods", "AllowedHTTPMethods", properties.AllowedHTTPMethods != null ? cfn_parse.FromCloudFormation.getString(properties.AllowedHTTPMethods) : void 0), ret.addPropertyResult("cachedHttpMethods", "CachedHTTPMethods", properties.CachedHTTPMethods != null ? cfn_parse.FromCloudFormation.getString(properties.CachedHTTPMethods) : void 0), ret.addPropertyResult("defaultTtl", "DefaultTTL", properties.DefaultTTL != null ? cfn_parse.FromCloudFormation.getNumber(properties.DefaultTTL) : void 0), ret.addPropertyResult("forwardedCookies", "ForwardedCookies", properties.ForwardedCookies != null ? CfnDistributionCookieObjectPropertyFromCloudFormation(properties.ForwardedCookies) : void 0), ret.addPropertyResult("forwardedHeaders", "ForwardedHeaders", properties.ForwardedHeaders != null ? CfnDistributionHeaderObjectPropertyFromCloudFormation(properties.ForwardedHeaders) : void 0), ret.addPropertyResult("forwardedQueryStrings", "ForwardedQueryStrings", properties.ForwardedQueryStrings != null ? CfnDistributionQueryStringObjectPropertyFromCloudFormation(properties.ForwardedQueryStrings) : void 0), ret.addPropertyResult("maximumTtl", "MaximumTTL", properties.MaximumTTL != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumTTL) : void 0), ret.addPropertyResult("minimumTtl", "MinimumTTL", properties.MinimumTTL != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinimumTTL) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistribution_CookieObjectPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cookiesAllowList", cdk.listValidator(cdk.validateString))(properties.cookiesAllowList)), errors.collect(cdk.propertyValidator("option", cdk.validateString)(properties.option)), errors.wrap('supplied properties not correct for "CookieObjectProperty"');
    }
    function cfnDistributionCookieObjectPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_CookieObjectPropertyValidator(properties).assertSuccess(), { CookiesAllowList: cdk.listMapper(cdk.stringToCloudFormation)(properties.cookiesAllowList), Option: cdk.stringToCloudFormation(properties.option) }) : properties;
    }
    function CfnDistributionCookieObjectPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cookiesAllowList", "CookiesAllowList", properties.CookiesAllowList != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CookiesAllowList) : void 0), ret.addPropertyResult("option", "Option", properties.Option != null ? cfn_parse.FromCloudFormation.getString(properties.Option) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistribution_HeaderObjectPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("headersAllowList", cdk.listValidator(cdk.validateString))(properties.headersAllowList)), errors.collect(cdk.propertyValidator("option", cdk.validateString)(properties.option)), errors.wrap('supplied properties not correct for "HeaderObjectProperty"');
    }
    function cfnDistributionHeaderObjectPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_HeaderObjectPropertyValidator(properties).assertSuccess(), { HeadersAllowList: cdk.listMapper(cdk.stringToCloudFormation)(properties.headersAllowList), Option: cdk.stringToCloudFormation(properties.option) }) : properties;
    }
    function CfnDistributionHeaderObjectPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("headersAllowList", "HeadersAllowList", properties.HeadersAllowList != null ? cfn_parse.FromCloudFormation.getStringArray(properties.HeadersAllowList) : void 0), ret.addPropertyResult("option", "Option", properties.Option != null ? cfn_parse.FromCloudFormation.getString(properties.Option) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistribution_InputOriginPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("protocolPolicy", cdk.validateString)(properties.protocolPolicy)), errors.collect(cdk.propertyValidator("regionName", cdk.validateString)(properties.regionName)), errors.wrap('supplied properties not correct for "InputOriginProperty"');
    }
    function cfnDistributionInputOriginPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_InputOriginPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), ProtocolPolicy: cdk.stringToCloudFormation(properties.protocolPolicy), RegionName: cdk.stringToCloudFormation(properties.regionName) }) : properties;
    }
    function CfnDistributionInputOriginPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("protocolPolicy", "ProtocolPolicy", properties.ProtocolPolicy != null ? cfn_parse.FromCloudFormation.getString(properties.ProtocolPolicy) : void 0), ret.addPropertyResult("regionName", "RegionName", properties.RegionName != null ? cfn_parse.FromCloudFormation.getString(properties.RegionName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDistribution_QueryStringObjectPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("option", cdk.validateBoolean)(properties.option)), errors.collect(cdk.propertyValidator("queryStringsAllowList", cdk.listValidator(cdk.validateString))(properties.queryStringsAllowList)), errors.wrap('supplied properties not correct for "QueryStringObjectProperty"');
    }
    function cfnDistributionQueryStringObjectPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDistribution_QueryStringObjectPropertyValidator(properties).assertSuccess(), { Option: cdk.booleanToCloudFormation(properties.option), QueryStringsAllowList: cdk.listMapper(cdk.stringToCloudFormation)(properties.queryStringsAllowList) }) : properties;
    }
    function CfnDistributionQueryStringObjectPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("option", "Option", properties.Option != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Option) : void 0), ret.addPropertyResult("queryStringsAllowList", "QueryStringsAllowList", properties.QueryStringsAllowList != null ? cfn_parse.FromCloudFormation.getStringArray(properties.QueryStringsAllowList) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstancePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("addOns", cdk.listValidator(CfnInstance_AddOnPropertyValidator))(properties.addOns)), errors.collect(cdk.propertyValidator("availabilityZone", cdk.validateString)(properties.availabilityZone)), errors.collect(cdk.propertyValidator("blueprintId", cdk.requiredValidator)(properties.blueprintId)), errors.collect(cdk.propertyValidator("blueprintId", cdk.validateString)(properties.blueprintId)), errors.collect(cdk.propertyValidator("bundleId", cdk.requiredValidator)(properties.bundleId)), errors.collect(cdk.propertyValidator("bundleId", cdk.validateString)(properties.bundleId)), errors.collect(cdk.propertyValidator("hardware", CfnInstance_HardwarePropertyValidator)(properties.hardware)), errors.collect(cdk.propertyValidator("instanceName", cdk.requiredValidator)(properties.instanceName)), errors.collect(cdk.propertyValidator("instanceName", cdk.validateString)(properties.instanceName)), errors.collect(cdk.propertyValidator("keyPairName", cdk.validateString)(properties.keyPairName)), errors.collect(cdk.propertyValidator("location", CfnInstance_LocationPropertyValidator)(properties.location)), errors.collect(cdk.propertyValidator("networking", CfnInstance_NetworkingPropertyValidator)(properties.networking)), errors.collect(cdk.propertyValidator("state", CfnInstance_StatePropertyValidator)(properties.state)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("userData", cdk.validateString)(properties.userData)), errors.wrap('supplied properties not correct for "CfnInstanceProps"');
    }
    function cfnInstancePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstancePropsValidator(properties).assertSuccess(), { BlueprintId: cdk.stringToCloudFormation(properties.blueprintId), BundleId: cdk.stringToCloudFormation(properties.bundleId), InstanceName: cdk.stringToCloudFormation(properties.instanceName), AddOns: cdk.listMapper(cfnInstanceAddOnPropertyToCloudFormation)(properties.addOns), AvailabilityZone: cdk.stringToCloudFormation(properties.availabilityZone), Hardware: cfnInstanceHardwarePropertyToCloudFormation(properties.hardware), KeyPairName: cdk.stringToCloudFormation(properties.keyPairName), Location: cfnInstanceLocationPropertyToCloudFormation(properties.location), Networking: cfnInstanceNetworkingPropertyToCloudFormation(properties.networking), State: cfnInstanceStatePropertyToCloudFormation(properties.state), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), UserData: cdk.stringToCloudFormation(properties.userData) }) : properties;
    }
    function CfnInstancePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("blueprintId", "BlueprintId", cfn_parse.FromCloudFormation.getString(properties.BlueprintId)), ret.addPropertyResult("bundleId", "BundleId", cfn_parse.FromCloudFormation.getString(properties.BundleId)), ret.addPropertyResult("instanceName", "InstanceName", cfn_parse.FromCloudFormation.getString(properties.InstanceName)), ret.addPropertyResult("addOns", "AddOns", properties.AddOns != null ? cfn_parse.FromCloudFormation.getArray(CfnInstanceAddOnPropertyFromCloudFormation)(properties.AddOns) : void 0), ret.addPropertyResult("availabilityZone", "AvailabilityZone", properties.AvailabilityZone != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityZone) : void 0), ret.addPropertyResult("hardware", "Hardware", properties.Hardware != null ? CfnInstanceHardwarePropertyFromCloudFormation(properties.Hardware) : void 0), ret.addPropertyResult("keyPairName", "KeyPairName", properties.KeyPairName != null ? cfn_parse.FromCloudFormation.getString(properties.KeyPairName) : void 0), ret.addPropertyResult("location", "Location", properties.Location != null ? CfnInstanceLocationPropertyFromCloudFormation(properties.Location) : void 0), ret.addPropertyResult("networking", "Networking", properties.Networking != null ? CfnInstanceNetworkingPropertyFromCloudFormation(properties.Networking) : void 0), ret.addPropertyResult("state", "State", properties.State != null ? CfnInstanceStatePropertyFromCloudFormation(properties.State) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("userData", "UserData", properties.UserData != null ? cfn_parse.FromCloudFormation.getString(properties.UserData) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnInstance = class _CfnInstance extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnInstancePropsFromCloudFormation(resourceProperties), ret = new _CfnInstance(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnInstance.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lightsail_CfnInstanceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnInstance), error;
        }
        cdk.requireProperty(props, "blueprintId", this), cdk.requireProperty(props, "bundleId", this), cdk.requireProperty(props, "instanceName", this), this.attrHardwareCpuCount = cdk.Token.asNumber(this.getAtt("Hardware.CpuCount", cdk.ResolutionTypeHint.NUMBER)), this.attrHardwareRamSizeInGb = cdk.Token.asNumber(this.getAtt("Hardware.RamSizeInGb", cdk.ResolutionTypeHint.NUMBER)), this.attrInstanceArn = cdk.Token.asString(this.getAtt("InstanceArn", cdk.ResolutionTypeHint.STRING)), this.attrIsStaticIp = this.getAtt("IsStaticIp", cdk.ResolutionTypeHint.STRING), this.attrLocationAvailabilityZone = cdk.Token.asString(this.getAtt("Location.AvailabilityZone", cdk.ResolutionTypeHint.STRING)), this.attrLocationRegionName = cdk.Token.asString(this.getAtt("Location.RegionName", cdk.ResolutionTypeHint.STRING)), this.attrNetworkingMonthlyTransferGbPerMonthAllocated = cdk.Token.asString(this.getAtt("Networking.MonthlyTransfer.GbPerMonthAllocated", cdk.ResolutionTypeHint.STRING)), this.attrPrivateIpAddress = cdk.Token.asString(this.getAtt("PrivateIpAddress", cdk.ResolutionTypeHint.STRING)), this.attrPublicIpAddress = cdk.Token.asString(this.getAtt("PublicIpAddress", cdk.ResolutionTypeHint.STRING)), this.attrResourceType = cdk.Token.asString(this.getAtt("ResourceType", cdk.ResolutionTypeHint.STRING)), this.attrSshKeyName = cdk.Token.asString(this.getAtt("SshKeyName", cdk.ResolutionTypeHint.STRING)), this.attrStateCode = cdk.Token.asNumber(this.getAtt("State.Code", cdk.ResolutionTypeHint.NUMBER)), this.attrStateName = cdk.Token.asString(this.getAtt("State.Name", cdk.ResolutionTypeHint.STRING)), this.attrSupportCode = cdk.Token.asString(this.getAtt("SupportCode", cdk.ResolutionTypeHint.STRING)), this.attrUserName = cdk.Token.asString(this.getAtt("UserName", cdk.ResolutionTypeHint.STRING)), this.blueprintId = props.blueprintId, this.bundleId = props.bundleId, this.instanceName = props.instanceName, this.addOns = props.addOns, this.availabilityZone = props.availabilityZone, this.hardware = props.hardware, this.keyPairName = props.keyPairName, this.location = props.location, this.networking = props.networking, this.state = props.state, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Lightsail::Instance", props.tags, { tagPropertyName: "tags" }), this.userData = props.userData;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnInstance.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { blueprintId: this.blueprintId, bundleId: this.bundleId, instanceName: this.instanceName, addOns: this.addOns, availabilityZone: this.availabilityZone, hardware: this.hardware, keyPairName: this.keyPairName, location: this.location, networking: this.networking, state: this.state, tags: this.tags.renderTags(), userData: this.userData };
      }
      renderProperties(props) {
        return cfnInstancePropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnInstance[_h] = { fqn: "aws-cdk-lib.aws_lightsail.CfnInstance", version: "2.80.0" }, CfnInstance.CFN_RESOURCE_TYPE_NAME = "AWS::Lightsail::Instance", exports2.CfnInstance = CfnInstance;
    function CfnInstance_AddOnPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("addOnType", cdk.requiredValidator)(properties.addOnType)), errors.collect(cdk.propertyValidator("addOnType", cdk.validateString)(properties.addOnType)), errors.collect(cdk.propertyValidator("autoSnapshotAddOnRequest", CfnInstance_AutoSnapshotAddOnPropertyValidator)(properties.autoSnapshotAddOnRequest)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "AddOnProperty"');
    }
    function cfnInstanceAddOnPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstance_AddOnPropertyValidator(properties).assertSuccess(), { AddOnType: cdk.stringToCloudFormation(properties.addOnType), AutoSnapshotAddOnRequest: cfnInstanceAutoSnapshotAddOnPropertyToCloudFormation(properties.autoSnapshotAddOnRequest), Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnInstanceAddOnPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("addOnType", "AddOnType", cfn_parse.FromCloudFormation.getString(properties.AddOnType)), ret.addPropertyResult("autoSnapshotAddOnRequest", "AutoSnapshotAddOnRequest", properties.AutoSnapshotAddOnRequest != null ? CfnInstanceAutoSnapshotAddOnPropertyFromCloudFormation(properties.AutoSnapshotAddOnRequest) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstance_AutoSnapshotAddOnPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("snapshotTimeOfDay", cdk.validateString)(properties.snapshotTimeOfDay)), errors.wrap('supplied properties not correct for "AutoSnapshotAddOnProperty"');
    }
    function cfnInstanceAutoSnapshotAddOnPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstance_AutoSnapshotAddOnPropertyValidator(properties).assertSuccess(), { SnapshotTimeOfDay: cdk.stringToCloudFormation(properties.snapshotTimeOfDay) }) : properties;
    }
    function CfnInstanceAutoSnapshotAddOnPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("snapshotTimeOfDay", "SnapshotTimeOfDay", properties.SnapshotTimeOfDay != null ? cfn_parse.FromCloudFormation.getString(properties.SnapshotTimeOfDay) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstance_DiskPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attachedTo", cdk.validateString)(properties.attachedTo)), errors.collect(cdk.propertyValidator("attachmentState", cdk.validateString)(properties.attachmentState)), errors.collect(cdk.propertyValidator("diskName", cdk.requiredValidator)(properties.diskName)), errors.collect(cdk.propertyValidator("diskName", cdk.validateString)(properties.diskName)), errors.collect(cdk.propertyValidator("iops", cdk.validateNumber)(properties.iops)), errors.collect(cdk.propertyValidator("isSystemDisk", cdk.validateBoolean)(properties.isSystemDisk)), errors.collect(cdk.propertyValidator("path", cdk.requiredValidator)(properties.path)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.collect(cdk.propertyValidator("sizeInGb", cdk.validateString)(properties.sizeInGb)), errors.wrap('supplied properties not correct for "DiskProperty"');
    }
    function cfnInstanceDiskPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstance_DiskPropertyValidator(properties).assertSuccess(), { AttachedTo: cdk.stringToCloudFormation(properties.attachedTo), AttachmentState: cdk.stringToCloudFormation(properties.attachmentState), DiskName: cdk.stringToCloudFormation(properties.diskName), IOPS: cdk.numberToCloudFormation(properties.iops), IsSystemDisk: cdk.booleanToCloudFormation(properties.isSystemDisk), Path: cdk.stringToCloudFormation(properties.path), SizeInGb: cdk.stringToCloudFormation(properties.sizeInGb) }) : properties;
    }
    function CfnInstanceDiskPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attachedTo", "AttachedTo", properties.AttachedTo != null ? cfn_parse.FromCloudFormation.getString(properties.AttachedTo) : void 0), ret.addPropertyResult("attachmentState", "AttachmentState", properties.AttachmentState != null ? cfn_parse.FromCloudFormation.getString(properties.AttachmentState) : void 0), ret.addPropertyResult("diskName", "DiskName", cfn_parse.FromCloudFormation.getString(properties.DiskName)), ret.addPropertyResult("iops", "IOPS", properties.IOPS != null ? cfn_parse.FromCloudFormation.getNumber(properties.IOPS) : void 0), ret.addPropertyResult("isSystemDisk", "IsSystemDisk", properties.IsSystemDisk != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsSystemDisk) : void 0), ret.addPropertyResult("path", "Path", cfn_parse.FromCloudFormation.getString(properties.Path)), ret.addPropertyResult("sizeInGb", "SizeInGb", properties.SizeInGb != null ? cfn_parse.FromCloudFormation.getString(properties.SizeInGb) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstance_HardwarePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cpuCount", cdk.validateNumber)(properties.cpuCount)), errors.collect(cdk.propertyValidator("disks", cdk.listValidator(CfnInstance_DiskPropertyValidator))(properties.disks)), errors.collect(cdk.propertyValidator("ramSizeInGb", cdk.validateNumber)(properties.ramSizeInGb)), errors.wrap('supplied properties not correct for "HardwareProperty"');
    }
    function cfnInstanceHardwarePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstance_HardwarePropertyValidator(properties).assertSuccess(), { CpuCount: cdk.numberToCloudFormation(properties.cpuCount), Disks: cdk.listMapper(cfnInstanceDiskPropertyToCloudFormation)(properties.disks), RamSizeInGb: cdk.numberToCloudFormation(properties.ramSizeInGb) }) : properties;
    }
    function CfnInstanceHardwarePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cpuCount", "CpuCount", properties.CpuCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.CpuCount) : void 0), ret.addPropertyResult("disks", "Disks", properties.Disks != null ? cfn_parse.FromCloudFormation.getArray(CfnInstanceDiskPropertyFromCloudFormation)(properties.Disks) : void 0), ret.addPropertyResult("ramSizeInGb", "RamSizeInGb", properties.RamSizeInGb != null ? cfn_parse.FromCloudFormation.getNumber(properties.RamSizeInGb) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstance_LocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availabilityZone", cdk.validateString)(properties.availabilityZone)), errors.collect(cdk.propertyValidator("regionName", cdk.validateString)(properties.regionName)), errors.wrap('supplied properties not correct for "LocationProperty"');
    }
    function cfnInstanceLocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstance_LocationPropertyValidator(properties).assertSuccess(), { AvailabilityZone: cdk.stringToCloudFormation(properties.availabilityZone), RegionName: cdk.stringToCloudFormation(properties.regionName) }) : properties;
    }
    function CfnInstanceLocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("availabilityZone", "AvailabilityZone", properties.AvailabilityZone != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityZone) : void 0), ret.addPropertyResult("regionName", "RegionName", properties.RegionName != null ? cfn_parse.FromCloudFormation.getString(properties.RegionName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstance_NetworkingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("monthlyTransfer", cdk.validateNumber)(properties.monthlyTransfer)), errors.collect(cdk.propertyValidator("ports", cdk.requiredValidator)(properties.ports)), errors.collect(cdk.propertyValidator("ports", cdk.listValidator(CfnInstance_PortPropertyValidator))(properties.ports)), errors.wrap('supplied properties not correct for "NetworkingProperty"');
    }
    function cfnInstanceNetworkingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstance_NetworkingPropertyValidator(properties).assertSuccess(), { MonthlyTransfer: cdk.numberToCloudFormation(properties.monthlyTransfer), Ports: cdk.listMapper(cfnInstancePortPropertyToCloudFormation)(properties.ports) }) : properties;
    }
    function CfnInstanceNetworkingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("monthlyTransfer", "MonthlyTransfer", properties.MonthlyTransfer != null ? cfn_parse.FromCloudFormation.getNumber(properties.MonthlyTransfer) : void 0), ret.addPropertyResult("ports", "Ports", cfn_parse.FromCloudFormation.getArray(CfnInstancePortPropertyFromCloudFormation)(properties.Ports)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstance_PortPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessDirection", cdk.validateString)(properties.accessDirection)), errors.collect(cdk.propertyValidator("accessFrom", cdk.validateString)(properties.accessFrom)), errors.collect(cdk.propertyValidator("accessType", cdk.validateString)(properties.accessType)), errors.collect(cdk.propertyValidator("cidrListAliases", cdk.listValidator(cdk.validateString))(properties.cidrListAliases)), errors.collect(cdk.propertyValidator("cidrs", cdk.listValidator(cdk.validateString))(properties.cidrs)), errors.collect(cdk.propertyValidator("commonName", cdk.validateString)(properties.commonName)), errors.collect(cdk.propertyValidator("fromPort", cdk.validateNumber)(properties.fromPort)), errors.collect(cdk.propertyValidator("ipv6Cidrs", cdk.listValidator(cdk.validateString))(properties.ipv6Cidrs)), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.collect(cdk.propertyValidator("toPort", cdk.validateNumber)(properties.toPort)), errors.wrap('supplied properties not correct for "PortProperty"');
    }
    function cfnInstancePortPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstance_PortPropertyValidator(properties).assertSuccess(), { AccessDirection: cdk.stringToCloudFormation(properties.accessDirection), AccessFrom: cdk.stringToCloudFormation(properties.accessFrom), AccessType: cdk.stringToCloudFormation(properties.accessType), CidrListAliases: cdk.listMapper(cdk.stringToCloudFormation)(properties.cidrListAliases), Cidrs: cdk.listMapper(cdk.stringToCloudFormation)(properties.cidrs), CommonName: cdk.stringToCloudFormation(properties.commonName), FromPort: cdk.numberToCloudFormation(properties.fromPort), Ipv6Cidrs: cdk.listMapper(cdk.stringToCloudFormation)(properties.ipv6Cidrs), Protocol: cdk.stringToCloudFormation(properties.protocol), ToPort: cdk.numberToCloudFormation(properties.toPort) }) : properties;
    }
    function CfnInstancePortPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessDirection", "AccessDirection", properties.AccessDirection != null ? cfn_parse.FromCloudFormation.getString(properties.AccessDirection) : void 0), ret.addPropertyResult("accessFrom", "AccessFrom", properties.AccessFrom != null ? cfn_parse.FromCloudFormation.getString(properties.AccessFrom) : void 0), ret.addPropertyResult("accessType", "AccessType", properties.AccessType != null ? cfn_parse.FromCloudFormation.getString(properties.AccessType) : void 0), ret.addPropertyResult("cidrListAliases", "CidrListAliases", properties.CidrListAliases != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CidrListAliases) : void 0), ret.addPropertyResult("cidrs", "Cidrs", properties.Cidrs != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Cidrs) : void 0), ret.addPropertyResult("commonName", "CommonName", properties.CommonName != null ? cfn_parse.FromCloudFormation.getString(properties.CommonName) : void 0), ret.addPropertyResult("fromPort", "FromPort", properties.FromPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.FromPort) : void 0), ret.addPropertyResult("ipv6Cidrs", "Ipv6Cidrs", properties.Ipv6Cidrs != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Ipv6Cidrs) : void 0), ret.addPropertyResult("protocol", "Protocol", properties.Protocol != null ? cfn_parse.FromCloudFormation.getString(properties.Protocol) : void 0), ret.addPropertyResult("toPort", "ToPort", properties.ToPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.ToPort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstance_StatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("code", cdk.validateNumber)(properties.code)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "StateProperty"');
    }
    function cfnInstanceStatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstance_StatePropertyValidator(properties).assertSuccess(), { Code: cdk.numberToCloudFormation(properties.code), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnInstanceStatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("code", "Code", properties.Code != null ? cfn_parse.FromCloudFormation.getNumber(properties.Code) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLoadBalancerPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attachedInstances", cdk.listValidator(cdk.validateString))(properties.attachedInstances)), errors.collect(cdk.propertyValidator("healthCheckPath", cdk.validateString)(properties.healthCheckPath)), errors.collect(cdk.propertyValidator("instancePort", cdk.requiredValidator)(properties.instancePort)), errors.collect(cdk.propertyValidator("instancePort", cdk.validateNumber)(properties.instancePort)), errors.collect(cdk.propertyValidator("ipAddressType", cdk.validateString)(properties.ipAddressType)), errors.collect(cdk.propertyValidator("loadBalancerName", cdk.requiredValidator)(properties.loadBalancerName)), errors.collect(cdk.propertyValidator("loadBalancerName", cdk.validateString)(properties.loadBalancerName)), errors.collect(cdk.propertyValidator("sessionStickinessEnabled", cdk.validateBoolean)(properties.sessionStickinessEnabled)), errors.collect(cdk.propertyValidator("sessionStickinessLbCookieDurationSeconds", cdk.validateString)(properties.sessionStickinessLbCookieDurationSeconds)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("tlsPolicyName", cdk.validateString)(properties.tlsPolicyName)), errors.wrap('supplied properties not correct for "CfnLoadBalancerProps"');
    }
    function cfnLoadBalancerPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLoadBalancerPropsValidator(properties).assertSuccess(), { InstancePort: cdk.numberToCloudFormation(properties.instancePort), LoadBalancerName: cdk.stringToCloudFormation(properties.loadBalancerName), AttachedInstances: cdk.listMapper(cdk.stringToCloudFormation)(properties.attachedInstances), HealthCheckPath: cdk.stringToCloudFormation(properties.healthCheckPath), IpAddressType: cdk.stringToCloudFormation(properties.ipAddressType), SessionStickinessEnabled: cdk.booleanToCloudFormation(properties.sessionStickinessEnabled), SessionStickinessLBCookieDurationSeconds: cdk.stringToCloudFormation(properties.sessionStickinessLbCookieDurationSeconds), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TlsPolicyName: cdk.stringToCloudFormation(properties.tlsPolicyName) }) : properties;
    }
    function CfnLoadBalancerPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instancePort", "InstancePort", cfn_parse.FromCloudFormation.getNumber(properties.InstancePort)), ret.addPropertyResult("loadBalancerName", "LoadBalancerName", cfn_parse.FromCloudFormation.getString(properties.LoadBalancerName)), ret.addPropertyResult("attachedInstances", "AttachedInstances", properties.AttachedInstances != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AttachedInstances) : void 0), ret.addPropertyResult("healthCheckPath", "HealthCheckPath", properties.HealthCheckPath != null ? cfn_parse.FromCloudFormation.getString(properties.HealthCheckPath) : void 0), ret.addPropertyResult("ipAddressType", "IpAddressType", properties.IpAddressType != null ? cfn_parse.FromCloudFormation.getString(properties.IpAddressType) : void 0), ret.addPropertyResult("sessionStickinessEnabled", "SessionStickinessEnabled", properties.SessionStickinessEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SessionStickinessEnabled) : void 0), ret.addPropertyResult("sessionStickinessLbCookieDurationSeconds", "SessionStickinessLBCookieDurationSeconds", properties.SessionStickinessLBCookieDurationSeconds != null ? cfn_parse.FromCloudFormation.getString(properties.SessionStickinessLBCookieDurationSeconds) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("tlsPolicyName", "TlsPolicyName", properties.TlsPolicyName != null ? cfn_parse.FromCloudFormation.getString(properties.TlsPolicyName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLoadBalancer = class _CfnLoadBalancer extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLoadBalancerPropsFromCloudFormation(resourceProperties), ret = new _CfnLoadBalancer(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLoadBalancer.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lightsail_CfnLoadBalancerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLoadBalancer), error;
        }
        cdk.requireProperty(props, "instancePort", this), cdk.requireProperty(props, "loadBalancerName", this), this.attrLoadBalancerArn = cdk.Token.asString(this.getAtt("LoadBalancerArn", cdk.ResolutionTypeHint.STRING)), this.instancePort = props.instancePort, this.loadBalancerName = props.loadBalancerName, this.attachedInstances = props.attachedInstances, this.healthCheckPath = props.healthCheckPath, this.ipAddressType = props.ipAddressType, this.sessionStickinessEnabled = props.sessionStickinessEnabled, this.sessionStickinessLbCookieDurationSeconds = props.sessionStickinessLbCookieDurationSeconds, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Lightsail::LoadBalancer", props.tags, { tagPropertyName: "tags" }), this.tlsPolicyName = props.tlsPolicyName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLoadBalancer.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { instancePort: this.instancePort, loadBalancerName: this.loadBalancerName, attachedInstances: this.attachedInstances, healthCheckPath: this.healthCheckPath, ipAddressType: this.ipAddressType, sessionStickinessEnabled: this.sessionStickinessEnabled, sessionStickinessLbCookieDurationSeconds: this.sessionStickinessLbCookieDurationSeconds, tags: this.tags.renderTags(), tlsPolicyName: this.tlsPolicyName };
      }
      renderProperties(props) {
        return cfnLoadBalancerPropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnLoadBalancer[_j] = { fqn: "aws-cdk-lib.aws_lightsail.CfnLoadBalancer", version: "2.80.0" }, CfnLoadBalancer.CFN_RESOURCE_TYPE_NAME = "AWS::Lightsail::LoadBalancer", exports2.CfnLoadBalancer = CfnLoadBalancer;
    function CfnLoadBalancerTlsCertificatePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateAlternativeNames", cdk.listValidator(cdk.validateString))(properties.certificateAlternativeNames)), errors.collect(cdk.propertyValidator("certificateDomainName", cdk.requiredValidator)(properties.certificateDomainName)), errors.collect(cdk.propertyValidator("certificateDomainName", cdk.validateString)(properties.certificateDomainName)), errors.collect(cdk.propertyValidator("certificateName", cdk.requiredValidator)(properties.certificateName)), errors.collect(cdk.propertyValidator("certificateName", cdk.validateString)(properties.certificateName)), errors.collect(cdk.propertyValidator("httpsRedirectionEnabled", cdk.validateBoolean)(properties.httpsRedirectionEnabled)), errors.collect(cdk.propertyValidator("isAttached", cdk.validateBoolean)(properties.isAttached)), errors.collect(cdk.propertyValidator("loadBalancerName", cdk.requiredValidator)(properties.loadBalancerName)), errors.collect(cdk.propertyValidator("loadBalancerName", cdk.validateString)(properties.loadBalancerName)), errors.wrap('supplied properties not correct for "CfnLoadBalancerTlsCertificateProps"');
    }
    function cfnLoadBalancerTlsCertificatePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLoadBalancerTlsCertificatePropsValidator(properties).assertSuccess(), { CertificateDomainName: cdk.stringToCloudFormation(properties.certificateDomainName), CertificateName: cdk.stringToCloudFormation(properties.certificateName), LoadBalancerName: cdk.stringToCloudFormation(properties.loadBalancerName), CertificateAlternativeNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.certificateAlternativeNames), HttpsRedirectionEnabled: cdk.booleanToCloudFormation(properties.httpsRedirectionEnabled), IsAttached: cdk.booleanToCloudFormation(properties.isAttached) }) : properties;
    }
    function CfnLoadBalancerTlsCertificatePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificateDomainName", "CertificateDomainName", cfn_parse.FromCloudFormation.getString(properties.CertificateDomainName)), ret.addPropertyResult("certificateName", "CertificateName", cfn_parse.FromCloudFormation.getString(properties.CertificateName)), ret.addPropertyResult("loadBalancerName", "LoadBalancerName", cfn_parse.FromCloudFormation.getString(properties.LoadBalancerName)), ret.addPropertyResult("certificateAlternativeNames", "CertificateAlternativeNames", properties.CertificateAlternativeNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CertificateAlternativeNames) : void 0), ret.addPropertyResult("httpsRedirectionEnabled", "HttpsRedirectionEnabled", properties.HttpsRedirectionEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.HttpsRedirectionEnabled) : void 0), ret.addPropertyResult("isAttached", "IsAttached", properties.IsAttached != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsAttached) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLoadBalancerTlsCertificate = class _CfnLoadBalancerTlsCertificate extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLoadBalancerTlsCertificatePropsFromCloudFormation(resourceProperties), ret = new _CfnLoadBalancerTlsCertificate(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLoadBalancerTlsCertificate.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lightsail_CfnLoadBalancerTlsCertificateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLoadBalancerTlsCertificate), error;
        }
        cdk.requireProperty(props, "certificateDomainName", this), cdk.requireProperty(props, "certificateName", this), cdk.requireProperty(props, "loadBalancerName", this), this.attrLoadBalancerTlsCertificateArn = cdk.Token.asString(this.getAtt("LoadBalancerTlsCertificateArn", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.certificateDomainName = props.certificateDomainName, this.certificateName = props.certificateName, this.loadBalancerName = props.loadBalancerName, this.certificateAlternativeNames = props.certificateAlternativeNames, this.httpsRedirectionEnabled = props.httpsRedirectionEnabled, this.isAttached = props.isAttached;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLoadBalancerTlsCertificate.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { certificateDomainName: this.certificateDomainName, certificateName: this.certificateName, loadBalancerName: this.loadBalancerName, certificateAlternativeNames: this.certificateAlternativeNames, httpsRedirectionEnabled: this.httpsRedirectionEnabled, isAttached: this.isAttached };
      }
      renderProperties(props) {
        return cfnLoadBalancerTlsCertificatePropsToCloudFormation(props);
      }
    };
    _k = JSII_RTTI_SYMBOL_1, CfnLoadBalancerTlsCertificate[_k] = { fqn: "aws-cdk-lib.aws_lightsail.CfnLoadBalancerTlsCertificate", version: "2.80.0" }, CfnLoadBalancerTlsCertificate.CFN_RESOURCE_TYPE_NAME = "AWS::Lightsail::LoadBalancerTlsCertificate", exports2.CfnLoadBalancerTlsCertificate = CfnLoadBalancerTlsCertificate;
    function CfnStaticIpPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attachedTo", cdk.validateString)(properties.attachedTo)), errors.collect(cdk.propertyValidator("staticIpName", cdk.requiredValidator)(properties.staticIpName)), errors.collect(cdk.propertyValidator("staticIpName", cdk.validateString)(properties.staticIpName)), errors.wrap('supplied properties not correct for "CfnStaticIpProps"');
    }
    function cfnStaticIpPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStaticIpPropsValidator(properties).assertSuccess(), { StaticIpName: cdk.stringToCloudFormation(properties.staticIpName), AttachedTo: cdk.stringToCloudFormation(properties.attachedTo) }) : properties;
    }
    function CfnStaticIpPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("staticIpName", "StaticIpName", cfn_parse.FromCloudFormation.getString(properties.StaticIpName)), ret.addPropertyResult("attachedTo", "AttachedTo", properties.AttachedTo != null ? cfn_parse.FromCloudFormation.getString(properties.AttachedTo) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnStaticIp = class _CfnStaticIp extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnStaticIpPropsFromCloudFormation(resourceProperties), ret = new _CfnStaticIp(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnStaticIp.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lightsail_CfnStaticIpProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnStaticIp), error;
        }
        cdk.requireProperty(props, "staticIpName", this), this.attrIpAddress = cdk.Token.asString(this.getAtt("IpAddress", cdk.ResolutionTypeHint.STRING)), this.attrIsAttached = this.getAtt("IsAttached", cdk.ResolutionTypeHint.STRING), this.attrStaticIpArn = cdk.Token.asString(this.getAtt("StaticIpArn", cdk.ResolutionTypeHint.STRING)), this.staticIpName = props.staticIpName, this.attachedTo = props.attachedTo;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStaticIp.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { staticIpName: this.staticIpName, attachedTo: this.attachedTo };
      }
      renderProperties(props) {
        return cfnStaticIpPropsToCloudFormation(props);
      }
    };
    _l = JSII_RTTI_SYMBOL_1, CfnStaticIp[_l] = { fqn: "aws-cdk-lib.aws_lightsail.CfnStaticIp", version: "2.80.0" }, CfnStaticIp.CFN_RESOURCE_TYPE_NAME = "AWS::Lightsail::StaticIp", exports2.CfnStaticIp = CfnStaticIp;
  }
});

// node_modules/aws-cdk-lib/aws-lightsail/lib/index.js
var require_lib177 = __commonJS({
  "node_modules/aws-cdk-lib/aws-lightsail/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lightsail_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-lightsail/index.js
var require_aws_lightsail = __commonJS({
  "node_modules/aws-cdk-lib/aws-lightsail/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib177(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-location/lib/location.generated.js
var require_location_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-location/lib/location.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnTrackerConsumer = exports2.CfnTracker = exports2.CfnRouteCalculator = exports2.CfnPlaceIndex = exports2.CfnMap = exports2.CfnGeofenceCollection = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnGeofenceCollectionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("collectionName", cdk.requiredValidator)(properties.collectionName)), errors.collect(cdk.propertyValidator("collectionName", cdk.validateString)(properties.collectionName)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.wrap('supplied properties not correct for "CfnGeofenceCollectionProps"');
    }
    function cfnGeofenceCollectionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGeofenceCollectionPropsValidator(properties).assertSuccess(), { CollectionName: cdk.stringToCloudFormation(properties.collectionName), Description: cdk.stringToCloudFormation(properties.description), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId) }) : properties;
    }
    function CfnGeofenceCollectionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("collectionName", "CollectionName", cfn_parse.FromCloudFormation.getString(properties.CollectionName)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnGeofenceCollection = class _CfnGeofenceCollection extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnGeofenceCollectionPropsFromCloudFormation(resourceProperties), ret = new _CfnGeofenceCollection(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnGeofenceCollection.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_location_CfnGeofenceCollectionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnGeofenceCollection), error;
        }
        cdk.requireProperty(props, "collectionName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCollectionArn = cdk.Token.asString(this.getAtt("CollectionArn", cdk.ResolutionTypeHint.STRING)), this.attrCreateTime = cdk.Token.asString(this.getAtt("CreateTime", cdk.ResolutionTypeHint.STRING)), this.attrUpdateTime = cdk.Token.asString(this.getAtt("UpdateTime", cdk.ResolutionTypeHint.STRING)), this.collectionName = props.collectionName, this.description = props.description, this.kmsKeyId = props.kmsKeyId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnGeofenceCollection.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { collectionName: this.collectionName, description: this.description, kmsKeyId: this.kmsKeyId };
      }
      renderProperties(props) {
        return cfnGeofenceCollectionPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnGeofenceCollection[_a] = { fqn: "aws-cdk-lib.aws_location.CfnGeofenceCollection", version: "2.80.0" }, CfnGeofenceCollection.CFN_RESOURCE_TYPE_NAME = "AWS::Location::GeofenceCollection", exports2.CfnGeofenceCollection = CfnGeofenceCollection;
    function CfnMapPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configuration", cdk.requiredValidator)(properties.configuration)), errors.collect(cdk.propertyValidator("configuration", CfnMap_MapConfigurationPropertyValidator)(properties.configuration)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("mapName", cdk.requiredValidator)(properties.mapName)), errors.collect(cdk.propertyValidator("mapName", cdk.validateString)(properties.mapName)), errors.collect(cdk.propertyValidator("pricingPlan", cdk.validateString)(properties.pricingPlan)), errors.wrap('supplied properties not correct for "CfnMapProps"');
    }
    function cfnMapPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMapPropsValidator(properties).assertSuccess(), { Configuration: cfnMapMapConfigurationPropertyToCloudFormation(properties.configuration), MapName: cdk.stringToCloudFormation(properties.mapName), Description: cdk.stringToCloudFormation(properties.description), PricingPlan: cdk.stringToCloudFormation(properties.pricingPlan) }) : properties;
    }
    function CfnMapPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configuration", "Configuration", CfnMapMapConfigurationPropertyFromCloudFormation(properties.Configuration)), ret.addPropertyResult("mapName", "MapName", cfn_parse.FromCloudFormation.getString(properties.MapName)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("pricingPlan", "PricingPlan", properties.PricingPlan != null ? cfn_parse.FromCloudFormation.getString(properties.PricingPlan) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnMap = class _CfnMap extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnMapPropsFromCloudFormation(resourceProperties), ret = new _CfnMap(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnMap.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_location_CfnMapProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnMap), error;
        }
        cdk.requireProperty(props, "configuration", this), cdk.requireProperty(props, "mapName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreateTime = cdk.Token.asString(this.getAtt("CreateTime", cdk.ResolutionTypeHint.STRING)), this.attrDataSource = cdk.Token.asString(this.getAtt("DataSource", cdk.ResolutionTypeHint.STRING)), this.attrMapArn = cdk.Token.asString(this.getAtt("MapArn", cdk.ResolutionTypeHint.STRING)), this.attrUpdateTime = cdk.Token.asString(this.getAtt("UpdateTime", cdk.ResolutionTypeHint.STRING)), this.configuration = props.configuration, this.mapName = props.mapName, this.description = props.description, this.pricingPlan = props.pricingPlan;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnMap.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { configuration: this.configuration, mapName: this.mapName, description: this.description, pricingPlan: this.pricingPlan };
      }
      renderProperties(props) {
        return cfnMapPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnMap[_b] = { fqn: "aws-cdk-lib.aws_location.CfnMap", version: "2.80.0" }, CfnMap.CFN_RESOURCE_TYPE_NAME = "AWS::Location::Map", exports2.CfnMap = CfnMap;
    function CfnMap_MapConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("style", cdk.requiredValidator)(properties.style)), errors.collect(cdk.propertyValidator("style", cdk.validateString)(properties.style)), errors.wrap('supplied properties not correct for "MapConfigurationProperty"');
    }
    function cfnMapMapConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMap_MapConfigurationPropertyValidator(properties).assertSuccess(), { Style: cdk.stringToCloudFormation(properties.style) }) : properties;
    }
    function CfnMapMapConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("style", "Style", cfn_parse.FromCloudFormation.getString(properties.Style)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPlaceIndexPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataSource", cdk.requiredValidator)(properties.dataSource)), errors.collect(cdk.propertyValidator("dataSource", cdk.validateString)(properties.dataSource)), errors.collect(cdk.propertyValidator("dataSourceConfiguration", CfnPlaceIndex_DataSourceConfigurationPropertyValidator)(properties.dataSourceConfiguration)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("indexName", cdk.requiredValidator)(properties.indexName)), errors.collect(cdk.propertyValidator("indexName", cdk.validateString)(properties.indexName)), errors.collect(cdk.propertyValidator("pricingPlan", cdk.validateString)(properties.pricingPlan)), errors.wrap('supplied properties not correct for "CfnPlaceIndexProps"');
    }
    function cfnPlaceIndexPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPlaceIndexPropsValidator(properties).assertSuccess(), { DataSource: cdk.stringToCloudFormation(properties.dataSource), IndexName: cdk.stringToCloudFormation(properties.indexName), DataSourceConfiguration: cfnPlaceIndexDataSourceConfigurationPropertyToCloudFormation(properties.dataSourceConfiguration), Description: cdk.stringToCloudFormation(properties.description), PricingPlan: cdk.stringToCloudFormation(properties.pricingPlan) }) : properties;
    }
    function CfnPlaceIndexPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataSource", "DataSource", cfn_parse.FromCloudFormation.getString(properties.DataSource)), ret.addPropertyResult("indexName", "IndexName", cfn_parse.FromCloudFormation.getString(properties.IndexName)), ret.addPropertyResult("dataSourceConfiguration", "DataSourceConfiguration", properties.DataSourceConfiguration != null ? CfnPlaceIndexDataSourceConfigurationPropertyFromCloudFormation(properties.DataSourceConfiguration) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("pricingPlan", "PricingPlan", properties.PricingPlan != null ? cfn_parse.FromCloudFormation.getString(properties.PricingPlan) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPlaceIndex = class _CfnPlaceIndex extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPlaceIndexPropsFromCloudFormation(resourceProperties), ret = new _CfnPlaceIndex(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPlaceIndex.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_location_CfnPlaceIndexProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPlaceIndex), error;
        }
        cdk.requireProperty(props, "dataSource", this), cdk.requireProperty(props, "indexName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreateTime = cdk.Token.asString(this.getAtt("CreateTime", cdk.ResolutionTypeHint.STRING)), this.attrIndexArn = cdk.Token.asString(this.getAtt("IndexArn", cdk.ResolutionTypeHint.STRING)), this.attrUpdateTime = cdk.Token.asString(this.getAtt("UpdateTime", cdk.ResolutionTypeHint.STRING)), this.dataSource = props.dataSource, this.indexName = props.indexName, this.dataSourceConfiguration = props.dataSourceConfiguration, this.description = props.description, this.pricingPlan = props.pricingPlan;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPlaceIndex.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { dataSource: this.dataSource, indexName: this.indexName, dataSourceConfiguration: this.dataSourceConfiguration, description: this.description, pricingPlan: this.pricingPlan };
      }
      renderProperties(props) {
        return cfnPlaceIndexPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnPlaceIndex[_c] = { fqn: "aws-cdk-lib.aws_location.CfnPlaceIndex", version: "2.80.0" }, CfnPlaceIndex.CFN_RESOURCE_TYPE_NAME = "AWS::Location::PlaceIndex", exports2.CfnPlaceIndex = CfnPlaceIndex;
    function CfnPlaceIndex_DataSourceConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("intendedUse", cdk.validateString)(properties.intendedUse)), errors.wrap('supplied properties not correct for "DataSourceConfigurationProperty"');
    }
    function cfnPlaceIndexDataSourceConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPlaceIndex_DataSourceConfigurationPropertyValidator(properties).assertSuccess(), { IntendedUse: cdk.stringToCloudFormation(properties.intendedUse) }) : properties;
    }
    function CfnPlaceIndexDataSourceConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("intendedUse", "IntendedUse", properties.IntendedUse != null ? cfn_parse.FromCloudFormation.getString(properties.IntendedUse) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRouteCalculatorPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("calculatorName", cdk.requiredValidator)(properties.calculatorName)), errors.collect(cdk.propertyValidator("calculatorName", cdk.validateString)(properties.calculatorName)), errors.collect(cdk.propertyValidator("dataSource", cdk.requiredValidator)(properties.dataSource)), errors.collect(cdk.propertyValidator("dataSource", cdk.validateString)(properties.dataSource)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("pricingPlan", cdk.validateString)(properties.pricingPlan)), errors.wrap('supplied properties not correct for "CfnRouteCalculatorProps"');
    }
    function cfnRouteCalculatorPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRouteCalculatorPropsValidator(properties).assertSuccess(), { CalculatorName: cdk.stringToCloudFormation(properties.calculatorName), DataSource: cdk.stringToCloudFormation(properties.dataSource), Description: cdk.stringToCloudFormation(properties.description), PricingPlan: cdk.stringToCloudFormation(properties.pricingPlan) }) : properties;
    }
    function CfnRouteCalculatorPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("calculatorName", "CalculatorName", cfn_parse.FromCloudFormation.getString(properties.CalculatorName)), ret.addPropertyResult("dataSource", "DataSource", cfn_parse.FromCloudFormation.getString(properties.DataSource)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("pricingPlan", "PricingPlan", properties.PricingPlan != null ? cfn_parse.FromCloudFormation.getString(properties.PricingPlan) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRouteCalculator = class _CfnRouteCalculator extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRouteCalculatorPropsFromCloudFormation(resourceProperties), ret = new _CfnRouteCalculator(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRouteCalculator.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_location_CfnRouteCalculatorProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRouteCalculator), error;
        }
        cdk.requireProperty(props, "calculatorName", this), cdk.requireProperty(props, "dataSource", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCalculatorArn = cdk.Token.asString(this.getAtt("CalculatorArn", cdk.ResolutionTypeHint.STRING)), this.attrCreateTime = cdk.Token.asString(this.getAtt("CreateTime", cdk.ResolutionTypeHint.STRING)), this.attrUpdateTime = cdk.Token.asString(this.getAtt("UpdateTime", cdk.ResolutionTypeHint.STRING)), this.calculatorName = props.calculatorName, this.dataSource = props.dataSource, this.description = props.description, this.pricingPlan = props.pricingPlan;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRouteCalculator.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { calculatorName: this.calculatorName, dataSource: this.dataSource, description: this.description, pricingPlan: this.pricingPlan };
      }
      renderProperties(props) {
        return cfnRouteCalculatorPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnRouteCalculator[_d] = { fqn: "aws-cdk-lib.aws_location.CfnRouteCalculator", version: "2.80.0" }, CfnRouteCalculator.CFN_RESOURCE_TYPE_NAME = "AWS::Location::RouteCalculator", exports2.CfnRouteCalculator = CfnRouteCalculator;
    function CfnTrackerPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("positionFiltering", cdk.validateString)(properties.positionFiltering)), errors.collect(cdk.propertyValidator("trackerName", cdk.requiredValidator)(properties.trackerName)), errors.collect(cdk.propertyValidator("trackerName", cdk.validateString)(properties.trackerName)), errors.wrap('supplied properties not correct for "CfnTrackerProps"');
    }
    function cfnTrackerPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTrackerPropsValidator(properties).assertSuccess(), { TrackerName: cdk.stringToCloudFormation(properties.trackerName), Description: cdk.stringToCloudFormation(properties.description), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), PositionFiltering: cdk.stringToCloudFormation(properties.positionFiltering) }) : properties;
    }
    function CfnTrackerPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("trackerName", "TrackerName", cfn_parse.FromCloudFormation.getString(properties.TrackerName)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("positionFiltering", "PositionFiltering", properties.PositionFiltering != null ? cfn_parse.FromCloudFormation.getString(properties.PositionFiltering) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTracker = class _CfnTracker extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTrackerPropsFromCloudFormation(resourceProperties), ret = new _CfnTracker(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTracker.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_location_CfnTrackerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTracker), error;
        }
        cdk.requireProperty(props, "trackerName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreateTime = cdk.Token.asString(this.getAtt("CreateTime", cdk.ResolutionTypeHint.STRING)), this.attrTrackerArn = cdk.Token.asString(this.getAtt("TrackerArn", cdk.ResolutionTypeHint.STRING)), this.attrUpdateTime = cdk.Token.asString(this.getAtt("UpdateTime", cdk.ResolutionTypeHint.STRING)), this.trackerName = props.trackerName, this.description = props.description, this.kmsKeyId = props.kmsKeyId, this.positionFiltering = props.positionFiltering;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTracker.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { trackerName: this.trackerName, description: this.description, kmsKeyId: this.kmsKeyId, positionFiltering: this.positionFiltering };
      }
      renderProperties(props) {
        return cfnTrackerPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnTracker[_e] = { fqn: "aws-cdk-lib.aws_location.CfnTracker", version: "2.80.0" }, CfnTracker.CFN_RESOURCE_TYPE_NAME = "AWS::Location::Tracker", exports2.CfnTracker = CfnTracker;
    function CfnTrackerConsumerPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("consumerArn", cdk.requiredValidator)(properties.consumerArn)), errors.collect(cdk.propertyValidator("consumerArn", cdk.validateString)(properties.consumerArn)), errors.collect(cdk.propertyValidator("trackerName", cdk.requiredValidator)(properties.trackerName)), errors.collect(cdk.propertyValidator("trackerName", cdk.validateString)(properties.trackerName)), errors.wrap('supplied properties not correct for "CfnTrackerConsumerProps"');
    }
    function cfnTrackerConsumerPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTrackerConsumerPropsValidator(properties).assertSuccess(), { ConsumerArn: cdk.stringToCloudFormation(properties.consumerArn), TrackerName: cdk.stringToCloudFormation(properties.trackerName) }) : properties;
    }
    function CfnTrackerConsumerPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("consumerArn", "ConsumerArn", cfn_parse.FromCloudFormation.getString(properties.ConsumerArn)), ret.addPropertyResult("trackerName", "TrackerName", cfn_parse.FromCloudFormation.getString(properties.TrackerName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTrackerConsumer = class _CfnTrackerConsumer extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTrackerConsumerPropsFromCloudFormation(resourceProperties), ret = new _CfnTrackerConsumer(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTrackerConsumer.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_location_CfnTrackerConsumerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTrackerConsumer), error;
        }
        cdk.requireProperty(props, "consumerArn", this), cdk.requireProperty(props, "trackerName", this), this.consumerArn = props.consumerArn, this.trackerName = props.trackerName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTrackerConsumer.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { consumerArn: this.consumerArn, trackerName: this.trackerName };
      }
      renderProperties(props) {
        return cfnTrackerConsumerPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnTrackerConsumer[_f] = { fqn: "aws-cdk-lib.aws_location.CfnTrackerConsumer", version: "2.80.0" }, CfnTrackerConsumer.CFN_RESOURCE_TYPE_NAME = "AWS::Location::TrackerConsumer", exports2.CfnTrackerConsumer = CfnTrackerConsumer;
  }
});

// node_modules/aws-cdk-lib/aws-location/lib/index.js
var require_lib178 = __commonJS({
  "node_modules/aws-cdk-lib/aws-location/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_location_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-location/index.js
var require_aws_location = __commonJS({
  "node_modules/aws-cdk-lib/aws-location/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib178(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-logs-destinations/lib/lambda.js
var require_lambda10 = __commonJS({
  "node_modules/aws-cdk-lib/aws-logs-destinations/lib/lambda.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LambdaDestination = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var LambdaDestination = class _LambdaDestination {
      constructor(fn, options = {}) {
        this.fn = fn, this.options = options;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lambda_IFunction(fn), jsiiDeprecationWarnings.aws_cdk_lib_aws_logs_destinations_LambdaDestinationOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _LambdaDestination), error;
        }
      }
      bind(scope, logGroup) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_logs_ILogGroup(logGroup);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        const arn = logGroup.logGroupArn;
        if (this.options.addPermissions !== false) {
          const permissionId = "CanInvokeLambda";
          this.fn.addPermission(permissionId, { principal: new iam.ServicePrincipal("logs.amazonaws.com"), sourceArn: arn, scope });
          const cfnPermission = scope.node.tryFindChild(permissionId);
          cfnPermission && scope.node.addDependency(cfnPermission);
        }
        return { arn: this.fn.functionArn };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LambdaDestination[_a] = { fqn: "aws-cdk-lib.aws_logs_destinations.LambdaDestination", version: "2.80.0" }, exports2.LambdaDestination = LambdaDestination;
  }
});

// node_modules/aws-cdk-lib/aws-logs-destinations/lib/kinesis.js
var require_kinesis3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-logs-destinations/lib/kinesis.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.KinesisDestination = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var KinesisDestination = class _KinesisDestination {
      constructor(stream, props = {}) {
        this.stream = stream, this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_kinesis_IStream(stream), jsiiDeprecationWarnings.aws_cdk_lib_aws_logs_destinations_KinesisDestinationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _KinesisDestination), error;
        }
      }
      bind(scope, _sourceLogGroup) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_logs_ILogGroup(_sourceLogGroup);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        const id = "CloudWatchLogsCanPutRecords", role = this.props.role ?? scope.node.tryFindChild(id) ?? new iam.Role(scope, id, { assumedBy: new iam.ServicePrincipal("logs.amazonaws.com") });
        this.stream.grantWrite(role), role.grantPassRole(role);
        const policy = role.node.tryFindChild("DefaultPolicy");
        return policy && (role.node.defaultChild.addOverride("DependsOn", void 0), scope.node.addDependency(policy)), { arn: this.stream.streamArn, role };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, KinesisDestination[_a] = { fqn: "aws-cdk-lib.aws_logs_destinations.KinesisDestination", version: "2.80.0" }, exports2.KinesisDestination = KinesisDestination;
  }
});

// node_modules/aws-cdk-lib/aws-logs-destinations/lib/index.js
var require_lib179 = __commonJS({
  "node_modules/aws-cdk-lib/aws-logs-destinations/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lambda10(), exports2), __exportStar(require_kinesis3(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-logs-destinations/index.js
var require_aws_logs_destinations = __commonJS({
  "node_modules/aws-cdk-lib/aws-logs-destinations/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib179(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-lookoutequipment/lib/lookoutequipment.generated.js
var require_lookoutequipment_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-lookoutequipment/lib/lookoutequipment.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnInferenceScheduler = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnInferenceSchedulerPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataDelayOffsetInMinutes", cdk.validateNumber)(properties.dataDelayOffsetInMinutes)), errors.collect(cdk.propertyValidator("dataInputConfiguration", cdk.requiredValidator)(properties.dataInputConfiguration)), errors.collect(cdk.propertyValidator("dataInputConfiguration", cdk.validateObject)(properties.dataInputConfiguration)), errors.collect(cdk.propertyValidator("dataOutputConfiguration", cdk.requiredValidator)(properties.dataOutputConfiguration)), errors.collect(cdk.propertyValidator("dataOutputConfiguration", cdk.validateObject)(properties.dataOutputConfiguration)), errors.collect(cdk.propertyValidator("dataUploadFrequency", cdk.requiredValidator)(properties.dataUploadFrequency)), errors.collect(cdk.propertyValidator("dataUploadFrequency", cdk.validateString)(properties.dataUploadFrequency)), errors.collect(cdk.propertyValidator("inferenceSchedulerName", cdk.validateString)(properties.inferenceSchedulerName)), errors.collect(cdk.propertyValidator("modelName", cdk.requiredValidator)(properties.modelName)), errors.collect(cdk.propertyValidator("modelName", cdk.validateString)(properties.modelName)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("serverSideKmsKeyId", cdk.validateString)(properties.serverSideKmsKeyId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnInferenceSchedulerProps"');
    }
    function cfnInferenceSchedulerPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInferenceSchedulerPropsValidator(properties).assertSuccess(), { DataInputConfiguration: cdk.objectToCloudFormation(properties.dataInputConfiguration), DataOutputConfiguration: cdk.objectToCloudFormation(properties.dataOutputConfiguration), DataUploadFrequency: cdk.stringToCloudFormation(properties.dataUploadFrequency), ModelName: cdk.stringToCloudFormation(properties.modelName), RoleArn: cdk.stringToCloudFormation(properties.roleArn), DataDelayOffsetInMinutes: cdk.numberToCloudFormation(properties.dataDelayOffsetInMinutes), InferenceSchedulerName: cdk.stringToCloudFormation(properties.inferenceSchedulerName), ServerSideKmsKeyId: cdk.stringToCloudFormation(properties.serverSideKmsKeyId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnInferenceSchedulerPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataInputConfiguration", "DataInputConfiguration", cfn_parse.FromCloudFormation.getAny(properties.DataInputConfiguration)), ret.addPropertyResult("dataOutputConfiguration", "DataOutputConfiguration", cfn_parse.FromCloudFormation.getAny(properties.DataOutputConfiguration)), ret.addPropertyResult("dataUploadFrequency", "DataUploadFrequency", cfn_parse.FromCloudFormation.getString(properties.DataUploadFrequency)), ret.addPropertyResult("modelName", "ModelName", cfn_parse.FromCloudFormation.getString(properties.ModelName)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("dataDelayOffsetInMinutes", "DataDelayOffsetInMinutes", properties.DataDelayOffsetInMinutes != null ? cfn_parse.FromCloudFormation.getNumber(properties.DataDelayOffsetInMinutes) : void 0), ret.addPropertyResult("inferenceSchedulerName", "InferenceSchedulerName", properties.InferenceSchedulerName != null ? cfn_parse.FromCloudFormation.getString(properties.InferenceSchedulerName) : void 0), ret.addPropertyResult("serverSideKmsKeyId", "ServerSideKmsKeyId", properties.ServerSideKmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.ServerSideKmsKeyId) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnInferenceScheduler = class _CfnInferenceScheduler extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnInferenceSchedulerPropsFromCloudFormation(resourceProperties), ret = new _CfnInferenceScheduler(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnInferenceScheduler.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lookoutequipment_CfnInferenceSchedulerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnInferenceScheduler), error;
        }
        cdk.requireProperty(props, "dataInputConfiguration", this), cdk.requireProperty(props, "dataOutputConfiguration", this), cdk.requireProperty(props, "dataUploadFrequency", this), cdk.requireProperty(props, "modelName", this), cdk.requireProperty(props, "roleArn", this), this.attrInferenceSchedulerArn = cdk.Token.asString(this.getAtt("InferenceSchedulerArn", cdk.ResolutionTypeHint.STRING)), this.dataInputConfiguration = props.dataInputConfiguration, this.dataOutputConfiguration = props.dataOutputConfiguration, this.dataUploadFrequency = props.dataUploadFrequency, this.modelName = props.modelName, this.roleArn = props.roleArn, this.dataDelayOffsetInMinutes = props.dataDelayOffsetInMinutes, this.inferenceSchedulerName = props.inferenceSchedulerName, this.serverSideKmsKeyId = props.serverSideKmsKeyId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::LookoutEquipment::InferenceScheduler", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnInferenceScheduler.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { dataInputConfiguration: this.dataInputConfiguration, dataOutputConfiguration: this.dataOutputConfiguration, dataUploadFrequency: this.dataUploadFrequency, modelName: this.modelName, roleArn: this.roleArn, dataDelayOffsetInMinutes: this.dataDelayOffsetInMinutes, inferenceSchedulerName: this.inferenceSchedulerName, serverSideKmsKeyId: this.serverSideKmsKeyId, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnInferenceSchedulerPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnInferenceScheduler[_a] = { fqn: "aws-cdk-lib.aws_lookoutequipment.CfnInferenceScheduler", version: "2.80.0" }, CfnInferenceScheduler.CFN_RESOURCE_TYPE_NAME = "AWS::LookoutEquipment::InferenceScheduler", exports2.CfnInferenceScheduler = CfnInferenceScheduler;
  }
});

// node_modules/aws-cdk-lib/aws-lookoutequipment/lib/index.js
var require_lib180 = __commonJS({
  "node_modules/aws-cdk-lib/aws-lookoutequipment/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lookoutequipment_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-lookoutequipment/index.js
var require_aws_lookoutequipment = __commonJS({
  "node_modules/aws-cdk-lib/aws-lookoutequipment/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib180(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-lookoutmetrics/lib/lookoutmetrics.generated.js
var require_lookoutmetrics_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-lookoutmetrics/lib/lookoutmetrics.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnAnomalyDetector = exports2.CfnAlert = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAlertPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.requiredValidator)(properties.action)), errors.collect(cdk.propertyValidator("action", CfnAlert_ActionPropertyValidator)(properties.action)), errors.collect(cdk.propertyValidator("alertDescription", cdk.validateString)(properties.alertDescription)), errors.collect(cdk.propertyValidator("alertName", cdk.validateString)(properties.alertName)), errors.collect(cdk.propertyValidator("alertSensitivityThreshold", cdk.requiredValidator)(properties.alertSensitivityThreshold)), errors.collect(cdk.propertyValidator("alertSensitivityThreshold", cdk.validateNumber)(properties.alertSensitivityThreshold)), errors.collect(cdk.propertyValidator("anomalyDetectorArn", cdk.requiredValidator)(properties.anomalyDetectorArn)), errors.collect(cdk.propertyValidator("anomalyDetectorArn", cdk.validateString)(properties.anomalyDetectorArn)), errors.wrap('supplied properties not correct for "CfnAlertProps"');
    }
    function cfnAlertPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlertPropsValidator(properties).assertSuccess(), { Action: cfnAlertActionPropertyToCloudFormation(properties.action), AlertSensitivityThreshold: cdk.numberToCloudFormation(properties.alertSensitivityThreshold), AnomalyDetectorArn: cdk.stringToCloudFormation(properties.anomalyDetectorArn), AlertDescription: cdk.stringToCloudFormation(properties.alertDescription), AlertName: cdk.stringToCloudFormation(properties.alertName) }) : properties;
    }
    function CfnAlertPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", CfnAlertActionPropertyFromCloudFormation(properties.Action)), ret.addPropertyResult("alertSensitivityThreshold", "AlertSensitivityThreshold", cfn_parse.FromCloudFormation.getNumber(properties.AlertSensitivityThreshold)), ret.addPropertyResult("anomalyDetectorArn", "AnomalyDetectorArn", cfn_parse.FromCloudFormation.getString(properties.AnomalyDetectorArn)), ret.addPropertyResult("alertDescription", "AlertDescription", properties.AlertDescription != null ? cfn_parse.FromCloudFormation.getString(properties.AlertDescription) : void 0), ret.addPropertyResult("alertName", "AlertName", properties.AlertName != null ? cfn_parse.FromCloudFormation.getString(properties.AlertName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAlert = class _CfnAlert extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAlertPropsFromCloudFormation(resourceProperties), ret = new _CfnAlert(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAlert.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lookoutmetrics_CfnAlertProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAlert), error;
        }
        cdk.requireProperty(props, "action", this), cdk.requireProperty(props, "alertSensitivityThreshold", this), cdk.requireProperty(props, "anomalyDetectorArn", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.action = props.action, this.alertSensitivityThreshold = props.alertSensitivityThreshold, this.anomalyDetectorArn = props.anomalyDetectorArn, this.alertDescription = props.alertDescription, this.alertName = props.alertName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAlert.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { action: this.action, alertSensitivityThreshold: this.alertSensitivityThreshold, anomalyDetectorArn: this.anomalyDetectorArn, alertDescription: this.alertDescription, alertName: this.alertName };
      }
      renderProperties(props) {
        return cfnAlertPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAlert[_a] = { fqn: "aws-cdk-lib.aws_lookoutmetrics.CfnAlert", version: "2.80.0" }, CfnAlert.CFN_RESOURCE_TYPE_NAME = "AWS::LookoutMetrics::Alert", exports2.CfnAlert = CfnAlert;
    function CfnAlert_ActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("lambdaConfiguration", CfnAlert_LambdaConfigurationPropertyValidator)(properties.lambdaConfiguration)), errors.collect(cdk.propertyValidator("snsConfiguration", CfnAlert_SNSConfigurationPropertyValidator)(properties.snsConfiguration)), errors.wrap('supplied properties not correct for "ActionProperty"');
    }
    function cfnAlertActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlert_ActionPropertyValidator(properties).assertSuccess(), { LambdaConfiguration: cfnAlertLambdaConfigurationPropertyToCloudFormation(properties.lambdaConfiguration), SNSConfiguration: cfnAlertSNSConfigurationPropertyToCloudFormation(properties.snsConfiguration) }) : properties;
    }
    function CfnAlertActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("lambdaConfiguration", "LambdaConfiguration", properties.LambdaConfiguration != null ? CfnAlertLambdaConfigurationPropertyFromCloudFormation(properties.LambdaConfiguration) : void 0), ret.addPropertyResult("snsConfiguration", "SNSConfiguration", properties.SNSConfiguration != null ? CfnAlertSNSConfigurationPropertyFromCloudFormation(properties.SNSConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAlert_LambdaConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("lambdaArn", cdk.requiredValidator)(properties.lambdaArn)), errors.collect(cdk.propertyValidator("lambdaArn", cdk.validateString)(properties.lambdaArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "LambdaConfigurationProperty"');
    }
    function cfnAlertLambdaConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlert_LambdaConfigurationPropertyValidator(properties).assertSuccess(), { LambdaArn: cdk.stringToCloudFormation(properties.lambdaArn), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnAlertLambdaConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("lambdaArn", "LambdaArn", cfn_parse.FromCloudFormation.getString(properties.LambdaArn)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAlert_SNSConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("snsTopicArn", cdk.requiredValidator)(properties.snsTopicArn)), errors.collect(cdk.propertyValidator("snsTopicArn", cdk.validateString)(properties.snsTopicArn)), errors.wrap('supplied properties not correct for "SNSConfigurationProperty"');
    }
    function cfnAlertSNSConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAlert_SNSConfigurationPropertyValidator(properties).assertSuccess(), { RoleArn: cdk.stringToCloudFormation(properties.roleArn), SnsTopicArn: cdk.stringToCloudFormation(properties.snsTopicArn) }) : properties;
    }
    function CfnAlertSNSConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("snsTopicArn", "SnsTopicArn", cfn_parse.FromCloudFormation.getString(properties.SnsTopicArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnomalyDetectorPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("anomalyDetectorConfig", cdk.requiredValidator)(properties.anomalyDetectorConfig)), errors.collect(cdk.propertyValidator("anomalyDetectorConfig", CfnAnomalyDetector_AnomalyDetectorConfigPropertyValidator)(properties.anomalyDetectorConfig)), errors.collect(cdk.propertyValidator("anomalyDetectorDescription", cdk.validateString)(properties.anomalyDetectorDescription)), errors.collect(cdk.propertyValidator("anomalyDetectorName", cdk.validateString)(properties.anomalyDetectorName)), errors.collect(cdk.propertyValidator("kmsKeyArn", cdk.validateString)(properties.kmsKeyArn)), errors.collect(cdk.propertyValidator("metricSetList", cdk.requiredValidator)(properties.metricSetList)), errors.collect(cdk.propertyValidator("metricSetList", cdk.listValidator(CfnAnomalyDetector_MetricSetPropertyValidator))(properties.metricSetList)), errors.wrap('supplied properties not correct for "CfnAnomalyDetectorProps"');
    }
    function cfnAnomalyDetectorPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnomalyDetectorPropsValidator(properties).assertSuccess(), { AnomalyDetectorConfig: cfnAnomalyDetectorAnomalyDetectorConfigPropertyToCloudFormation(properties.anomalyDetectorConfig), MetricSetList: cdk.listMapper(cfnAnomalyDetectorMetricSetPropertyToCloudFormation)(properties.metricSetList), AnomalyDetectorDescription: cdk.stringToCloudFormation(properties.anomalyDetectorDescription), AnomalyDetectorName: cdk.stringToCloudFormation(properties.anomalyDetectorName), KmsKeyArn: cdk.stringToCloudFormation(properties.kmsKeyArn) }) : properties;
    }
    function CfnAnomalyDetectorPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("anomalyDetectorConfig", "AnomalyDetectorConfig", CfnAnomalyDetectorAnomalyDetectorConfigPropertyFromCloudFormation(properties.AnomalyDetectorConfig)), ret.addPropertyResult("metricSetList", "MetricSetList", cfn_parse.FromCloudFormation.getArray(CfnAnomalyDetectorMetricSetPropertyFromCloudFormation)(properties.MetricSetList)), ret.addPropertyResult("anomalyDetectorDescription", "AnomalyDetectorDescription", properties.AnomalyDetectorDescription != null ? cfn_parse.FromCloudFormation.getString(properties.AnomalyDetectorDescription) : void 0), ret.addPropertyResult("anomalyDetectorName", "AnomalyDetectorName", properties.AnomalyDetectorName != null ? cfn_parse.FromCloudFormation.getString(properties.AnomalyDetectorName) : void 0), ret.addPropertyResult("kmsKeyArn", "KmsKeyArn", properties.KmsKeyArn != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAnomalyDetector = class _CfnAnomalyDetector extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAnomalyDetectorPropsFromCloudFormation(resourceProperties), ret = new _CfnAnomalyDetector(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAnomalyDetector.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lookoutmetrics_CfnAnomalyDetectorProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAnomalyDetector), error;
        }
        cdk.requireProperty(props, "anomalyDetectorConfig", this), cdk.requireProperty(props, "metricSetList", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.anomalyDetectorConfig = props.anomalyDetectorConfig, this.metricSetList = props.metricSetList, this.anomalyDetectorDescription = props.anomalyDetectorDescription, this.anomalyDetectorName = props.anomalyDetectorName, this.kmsKeyArn = props.kmsKeyArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAnomalyDetector.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { anomalyDetectorConfig: this.anomalyDetectorConfig, metricSetList: this.metricSetList, anomalyDetectorDescription: this.anomalyDetectorDescription, anomalyDetectorName: this.anomalyDetectorName, kmsKeyArn: this.kmsKeyArn };
      }
      renderProperties(props) {
        return cfnAnomalyDetectorPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnAnomalyDetector[_b] = { fqn: "aws-cdk-lib.aws_lookoutmetrics.CfnAnomalyDetector", version: "2.80.0" }, CfnAnomalyDetector.CFN_RESOURCE_TYPE_NAME = "AWS::LookoutMetrics::AnomalyDetector", exports2.CfnAnomalyDetector = CfnAnomalyDetector;
    function CfnAnomalyDetector_AnomalyDetectorConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("anomalyDetectorFrequency", cdk.requiredValidator)(properties.anomalyDetectorFrequency)), errors.collect(cdk.propertyValidator("anomalyDetectorFrequency", cdk.validateString)(properties.anomalyDetectorFrequency)), errors.wrap('supplied properties not correct for "AnomalyDetectorConfigProperty"');
    }
    function cfnAnomalyDetectorAnomalyDetectorConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnomalyDetector_AnomalyDetectorConfigPropertyValidator(properties).assertSuccess(), { AnomalyDetectorFrequency: cdk.stringToCloudFormation(properties.anomalyDetectorFrequency) }) : properties;
    }
    function CfnAnomalyDetectorAnomalyDetectorConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("anomalyDetectorFrequency", "AnomalyDetectorFrequency", cfn_parse.FromCloudFormation.getString(properties.AnomalyDetectorFrequency)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnomalyDetector_AppFlowConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("flowName", cdk.requiredValidator)(properties.flowName)), errors.collect(cdk.propertyValidator("flowName", cdk.validateString)(properties.flowName)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "AppFlowConfigProperty"');
    }
    function cfnAnomalyDetectorAppFlowConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnomalyDetector_AppFlowConfigPropertyValidator(properties).assertSuccess(), { FlowName: cdk.stringToCloudFormation(properties.flowName), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnAnomalyDetectorAppFlowConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("flowName", "FlowName", cfn_parse.FromCloudFormation.getString(properties.FlowName)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnomalyDetector_CloudwatchConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "CloudwatchConfigProperty"');
    }
    function cfnAnomalyDetectorCloudwatchConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnomalyDetector_CloudwatchConfigPropertyValidator(properties).assertSuccess(), { RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnAnomalyDetectorCloudwatchConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnomalyDetector_CsvFormatDescriptorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("charset", cdk.validateString)(properties.charset)), errors.collect(cdk.propertyValidator("containsHeader", cdk.validateBoolean)(properties.containsHeader)), errors.collect(cdk.propertyValidator("delimiter", cdk.validateString)(properties.delimiter)), errors.collect(cdk.propertyValidator("fileCompression", cdk.validateString)(properties.fileCompression)), errors.collect(cdk.propertyValidator("headerList", cdk.listValidator(cdk.validateString))(properties.headerList)), errors.collect(cdk.propertyValidator("quoteSymbol", cdk.validateString)(properties.quoteSymbol)), errors.wrap('supplied properties not correct for "CsvFormatDescriptorProperty"');
    }
    function cfnAnomalyDetectorCsvFormatDescriptorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnomalyDetector_CsvFormatDescriptorPropertyValidator(properties).assertSuccess(), { Charset: cdk.stringToCloudFormation(properties.charset), ContainsHeader: cdk.booleanToCloudFormation(properties.containsHeader), Delimiter: cdk.stringToCloudFormation(properties.delimiter), FileCompression: cdk.stringToCloudFormation(properties.fileCompression), HeaderList: cdk.listMapper(cdk.stringToCloudFormation)(properties.headerList), QuoteSymbol: cdk.stringToCloudFormation(properties.quoteSymbol) }) : properties;
    }
    function CfnAnomalyDetectorCsvFormatDescriptorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("charset", "Charset", properties.Charset != null ? cfn_parse.FromCloudFormation.getString(properties.Charset) : void 0), ret.addPropertyResult("containsHeader", "ContainsHeader", properties.ContainsHeader != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ContainsHeader) : void 0), ret.addPropertyResult("delimiter", "Delimiter", properties.Delimiter != null ? cfn_parse.FromCloudFormation.getString(properties.Delimiter) : void 0), ret.addPropertyResult("fileCompression", "FileCompression", properties.FileCompression != null ? cfn_parse.FromCloudFormation.getString(properties.FileCompression) : void 0), ret.addPropertyResult("headerList", "HeaderList", properties.HeaderList != null ? cfn_parse.FromCloudFormation.getStringArray(properties.HeaderList) : void 0), ret.addPropertyResult("quoteSymbol", "QuoteSymbol", properties.QuoteSymbol != null ? cfn_parse.FromCloudFormation.getString(properties.QuoteSymbol) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnomalyDetector_FileFormatDescriptorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("csvFormatDescriptor", CfnAnomalyDetector_CsvFormatDescriptorPropertyValidator)(properties.csvFormatDescriptor)), errors.collect(cdk.propertyValidator("jsonFormatDescriptor", CfnAnomalyDetector_JsonFormatDescriptorPropertyValidator)(properties.jsonFormatDescriptor)), errors.wrap('supplied properties not correct for "FileFormatDescriptorProperty"');
    }
    function cfnAnomalyDetectorFileFormatDescriptorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnomalyDetector_FileFormatDescriptorPropertyValidator(properties).assertSuccess(), { CsvFormatDescriptor: cfnAnomalyDetectorCsvFormatDescriptorPropertyToCloudFormation(properties.csvFormatDescriptor), JsonFormatDescriptor: cfnAnomalyDetectorJsonFormatDescriptorPropertyToCloudFormation(properties.jsonFormatDescriptor) }) : properties;
    }
    function CfnAnomalyDetectorFileFormatDescriptorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("csvFormatDescriptor", "CsvFormatDescriptor", properties.CsvFormatDescriptor != null ? CfnAnomalyDetectorCsvFormatDescriptorPropertyFromCloudFormation(properties.CsvFormatDescriptor) : void 0), ret.addPropertyResult("jsonFormatDescriptor", "JsonFormatDescriptor", properties.JsonFormatDescriptor != null ? CfnAnomalyDetectorJsonFormatDescriptorPropertyFromCloudFormation(properties.JsonFormatDescriptor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnomalyDetector_JsonFormatDescriptorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("charset", cdk.validateString)(properties.charset)), errors.collect(cdk.propertyValidator("fileCompression", cdk.validateString)(properties.fileCompression)), errors.wrap('supplied properties not correct for "JsonFormatDescriptorProperty"');
    }
    function cfnAnomalyDetectorJsonFormatDescriptorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnomalyDetector_JsonFormatDescriptorPropertyValidator(properties).assertSuccess(), { Charset: cdk.stringToCloudFormation(properties.charset), FileCompression: cdk.stringToCloudFormation(properties.fileCompression) }) : properties;
    }
    function CfnAnomalyDetectorJsonFormatDescriptorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("charset", "Charset", properties.Charset != null ? cfn_parse.FromCloudFormation.getString(properties.Charset) : void 0), ret.addPropertyResult("fileCompression", "FileCompression", properties.FileCompression != null ? cfn_parse.FromCloudFormation.getString(properties.FileCompression) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnomalyDetector_MetricPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationFunction", cdk.requiredValidator)(properties.aggregationFunction)), errors.collect(cdk.propertyValidator("aggregationFunction", cdk.validateString)(properties.aggregationFunction)), errors.collect(cdk.propertyValidator("metricName", cdk.requiredValidator)(properties.metricName)), errors.collect(cdk.propertyValidator("metricName", cdk.validateString)(properties.metricName)), errors.collect(cdk.propertyValidator("namespace", cdk.validateString)(properties.namespace)), errors.wrap('supplied properties not correct for "MetricProperty"');
    }
    function cfnAnomalyDetectorMetricPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnomalyDetector_MetricPropertyValidator(properties).assertSuccess(), { AggregationFunction: cdk.stringToCloudFormation(properties.aggregationFunction), MetricName: cdk.stringToCloudFormation(properties.metricName), Namespace: cdk.stringToCloudFormation(properties.namespace) }) : properties;
    }
    function CfnAnomalyDetectorMetricPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationFunction", "AggregationFunction", cfn_parse.FromCloudFormation.getString(properties.AggregationFunction)), ret.addPropertyResult("metricName", "MetricName", cfn_parse.FromCloudFormation.getString(properties.MetricName)), ret.addPropertyResult("namespace", "Namespace", properties.Namespace != null ? cfn_parse.FromCloudFormation.getString(properties.Namespace) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnomalyDetector_MetricSetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dimensionList", cdk.listValidator(cdk.validateString))(properties.dimensionList)), errors.collect(cdk.propertyValidator("metricList", cdk.requiredValidator)(properties.metricList)), errors.collect(cdk.propertyValidator("metricList", cdk.listValidator(CfnAnomalyDetector_MetricPropertyValidator))(properties.metricList)), errors.collect(cdk.propertyValidator("metricSetDescription", cdk.validateString)(properties.metricSetDescription)), errors.collect(cdk.propertyValidator("metricSetFrequency", cdk.validateString)(properties.metricSetFrequency)), errors.collect(cdk.propertyValidator("metricSetName", cdk.requiredValidator)(properties.metricSetName)), errors.collect(cdk.propertyValidator("metricSetName", cdk.validateString)(properties.metricSetName)), errors.collect(cdk.propertyValidator("metricSource", cdk.requiredValidator)(properties.metricSource)), errors.collect(cdk.propertyValidator("metricSource", CfnAnomalyDetector_MetricSourcePropertyValidator)(properties.metricSource)), errors.collect(cdk.propertyValidator("offset", cdk.validateNumber)(properties.offset)), errors.collect(cdk.propertyValidator("timestampColumn", CfnAnomalyDetector_TimestampColumnPropertyValidator)(properties.timestampColumn)), errors.collect(cdk.propertyValidator("timezone", cdk.validateString)(properties.timezone)), errors.wrap('supplied properties not correct for "MetricSetProperty"');
    }
    function cfnAnomalyDetectorMetricSetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnomalyDetector_MetricSetPropertyValidator(properties).assertSuccess(), { DimensionList: cdk.listMapper(cdk.stringToCloudFormation)(properties.dimensionList), MetricList: cdk.listMapper(cfnAnomalyDetectorMetricPropertyToCloudFormation)(properties.metricList), MetricSetDescription: cdk.stringToCloudFormation(properties.metricSetDescription), MetricSetFrequency: cdk.stringToCloudFormation(properties.metricSetFrequency), MetricSetName: cdk.stringToCloudFormation(properties.metricSetName), MetricSource: cfnAnomalyDetectorMetricSourcePropertyToCloudFormation(properties.metricSource), Offset: cdk.numberToCloudFormation(properties.offset), TimestampColumn: cfnAnomalyDetectorTimestampColumnPropertyToCloudFormation(properties.timestampColumn), Timezone: cdk.stringToCloudFormation(properties.timezone) }) : properties;
    }
    function CfnAnomalyDetectorMetricSetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dimensionList", "DimensionList", properties.DimensionList != null ? cfn_parse.FromCloudFormation.getStringArray(properties.DimensionList) : void 0), ret.addPropertyResult("metricList", "MetricList", cfn_parse.FromCloudFormation.getArray(CfnAnomalyDetectorMetricPropertyFromCloudFormation)(properties.MetricList)), ret.addPropertyResult("metricSetDescription", "MetricSetDescription", properties.MetricSetDescription != null ? cfn_parse.FromCloudFormation.getString(properties.MetricSetDescription) : void 0), ret.addPropertyResult("metricSetFrequency", "MetricSetFrequency", properties.MetricSetFrequency != null ? cfn_parse.FromCloudFormation.getString(properties.MetricSetFrequency) : void 0), ret.addPropertyResult("metricSetName", "MetricSetName", cfn_parse.FromCloudFormation.getString(properties.MetricSetName)), ret.addPropertyResult("metricSource", "MetricSource", CfnAnomalyDetectorMetricSourcePropertyFromCloudFormation(properties.MetricSource)), ret.addPropertyResult("offset", "Offset", properties.Offset != null ? cfn_parse.FromCloudFormation.getNumber(properties.Offset) : void 0), ret.addPropertyResult("timestampColumn", "TimestampColumn", properties.TimestampColumn != null ? CfnAnomalyDetectorTimestampColumnPropertyFromCloudFormation(properties.TimestampColumn) : void 0), ret.addPropertyResult("timezone", "Timezone", properties.Timezone != null ? cfn_parse.FromCloudFormation.getString(properties.Timezone) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnomalyDetector_MetricSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("appFlowConfig", CfnAnomalyDetector_AppFlowConfigPropertyValidator)(properties.appFlowConfig)), errors.collect(cdk.propertyValidator("cloudwatchConfig", CfnAnomalyDetector_CloudwatchConfigPropertyValidator)(properties.cloudwatchConfig)), errors.collect(cdk.propertyValidator("rdsSourceConfig", CfnAnomalyDetector_RDSSourceConfigPropertyValidator)(properties.rdsSourceConfig)), errors.collect(cdk.propertyValidator("redshiftSourceConfig", CfnAnomalyDetector_RedshiftSourceConfigPropertyValidator)(properties.redshiftSourceConfig)), errors.collect(cdk.propertyValidator("s3SourceConfig", CfnAnomalyDetector_S3SourceConfigPropertyValidator)(properties.s3SourceConfig)), errors.wrap('supplied properties not correct for "MetricSourceProperty"');
    }
    function cfnAnomalyDetectorMetricSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnomalyDetector_MetricSourcePropertyValidator(properties).assertSuccess(), { AppFlowConfig: cfnAnomalyDetectorAppFlowConfigPropertyToCloudFormation(properties.appFlowConfig), CloudwatchConfig: cfnAnomalyDetectorCloudwatchConfigPropertyToCloudFormation(properties.cloudwatchConfig), RDSSourceConfig: cfnAnomalyDetectorRDSSourceConfigPropertyToCloudFormation(properties.rdsSourceConfig), RedshiftSourceConfig: cfnAnomalyDetectorRedshiftSourceConfigPropertyToCloudFormation(properties.redshiftSourceConfig), S3SourceConfig: cfnAnomalyDetectorS3SourceConfigPropertyToCloudFormation(properties.s3SourceConfig) }) : properties;
    }
    function CfnAnomalyDetectorMetricSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("appFlowConfig", "AppFlowConfig", properties.AppFlowConfig != null ? CfnAnomalyDetectorAppFlowConfigPropertyFromCloudFormation(properties.AppFlowConfig) : void 0), ret.addPropertyResult("cloudwatchConfig", "CloudwatchConfig", properties.CloudwatchConfig != null ? CfnAnomalyDetectorCloudwatchConfigPropertyFromCloudFormation(properties.CloudwatchConfig) : void 0), ret.addPropertyResult("rdsSourceConfig", "RDSSourceConfig", properties.RDSSourceConfig != null ? CfnAnomalyDetectorRDSSourceConfigPropertyFromCloudFormation(properties.RDSSourceConfig) : void 0), ret.addPropertyResult("redshiftSourceConfig", "RedshiftSourceConfig", properties.RedshiftSourceConfig != null ? CfnAnomalyDetectorRedshiftSourceConfigPropertyFromCloudFormation(properties.RedshiftSourceConfig) : void 0), ret.addPropertyResult("s3SourceConfig", "S3SourceConfig", properties.S3SourceConfig != null ? CfnAnomalyDetectorS3SourceConfigPropertyFromCloudFormation(properties.S3SourceConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnomalyDetector_RDSSourceConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dbInstanceIdentifier", cdk.requiredValidator)(properties.dbInstanceIdentifier)), errors.collect(cdk.propertyValidator("dbInstanceIdentifier", cdk.validateString)(properties.dbInstanceIdentifier)), errors.collect(cdk.propertyValidator("databaseHost", cdk.requiredValidator)(properties.databaseHost)), errors.collect(cdk.propertyValidator("databaseHost", cdk.validateString)(properties.databaseHost)), errors.collect(cdk.propertyValidator("databaseName", cdk.requiredValidator)(properties.databaseName)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("databasePort", cdk.requiredValidator)(properties.databasePort)), errors.collect(cdk.propertyValidator("databasePort", cdk.validateNumber)(properties.databasePort)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("secretManagerArn", cdk.requiredValidator)(properties.secretManagerArn)), errors.collect(cdk.propertyValidator("secretManagerArn", cdk.validateString)(properties.secretManagerArn)), errors.collect(cdk.propertyValidator("tableName", cdk.requiredValidator)(properties.tableName)), errors.collect(cdk.propertyValidator("tableName", cdk.validateString)(properties.tableName)), errors.collect(cdk.propertyValidator("vpcConfiguration", cdk.requiredValidator)(properties.vpcConfiguration)), errors.collect(cdk.propertyValidator("vpcConfiguration", CfnAnomalyDetector_VpcConfigurationPropertyValidator)(properties.vpcConfiguration)), errors.wrap('supplied properties not correct for "RDSSourceConfigProperty"');
    }
    function cfnAnomalyDetectorRDSSourceConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnomalyDetector_RDSSourceConfigPropertyValidator(properties).assertSuccess(), { DBInstanceIdentifier: cdk.stringToCloudFormation(properties.dbInstanceIdentifier), DatabaseHost: cdk.stringToCloudFormation(properties.databaseHost), DatabaseName: cdk.stringToCloudFormation(properties.databaseName), DatabasePort: cdk.numberToCloudFormation(properties.databasePort), RoleArn: cdk.stringToCloudFormation(properties.roleArn), SecretManagerArn: cdk.stringToCloudFormation(properties.secretManagerArn), TableName: cdk.stringToCloudFormation(properties.tableName), VpcConfiguration: cfnAnomalyDetectorVpcConfigurationPropertyToCloudFormation(properties.vpcConfiguration) }) : properties;
    }
    function CfnAnomalyDetectorRDSSourceConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dbInstanceIdentifier", "DBInstanceIdentifier", cfn_parse.FromCloudFormation.getString(properties.DBInstanceIdentifier)), ret.addPropertyResult("databaseHost", "DatabaseHost", cfn_parse.FromCloudFormation.getString(properties.DatabaseHost)), ret.addPropertyResult("databaseName", "DatabaseName", cfn_parse.FromCloudFormation.getString(properties.DatabaseName)), ret.addPropertyResult("databasePort", "DatabasePort", cfn_parse.FromCloudFormation.getNumber(properties.DatabasePort)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("secretManagerArn", "SecretManagerArn", cfn_parse.FromCloudFormation.getString(properties.SecretManagerArn)), ret.addPropertyResult("tableName", "TableName", cfn_parse.FromCloudFormation.getString(properties.TableName)), ret.addPropertyResult("vpcConfiguration", "VpcConfiguration", CfnAnomalyDetectorVpcConfigurationPropertyFromCloudFormation(properties.VpcConfiguration)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnomalyDetector_RedshiftSourceConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clusterIdentifier", cdk.requiredValidator)(properties.clusterIdentifier)), errors.collect(cdk.propertyValidator("clusterIdentifier", cdk.validateString)(properties.clusterIdentifier)), errors.collect(cdk.propertyValidator("databaseHost", cdk.requiredValidator)(properties.databaseHost)), errors.collect(cdk.propertyValidator("databaseHost", cdk.validateString)(properties.databaseHost)), errors.collect(cdk.propertyValidator("databaseName", cdk.requiredValidator)(properties.databaseName)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("databasePort", cdk.requiredValidator)(properties.databasePort)), errors.collect(cdk.propertyValidator("databasePort", cdk.validateNumber)(properties.databasePort)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("secretManagerArn", cdk.requiredValidator)(properties.secretManagerArn)), errors.collect(cdk.propertyValidator("secretManagerArn", cdk.validateString)(properties.secretManagerArn)), errors.collect(cdk.propertyValidator("tableName", cdk.requiredValidator)(properties.tableName)), errors.collect(cdk.propertyValidator("tableName", cdk.validateString)(properties.tableName)), errors.collect(cdk.propertyValidator("vpcConfiguration", cdk.requiredValidator)(properties.vpcConfiguration)), errors.collect(cdk.propertyValidator("vpcConfiguration", CfnAnomalyDetector_VpcConfigurationPropertyValidator)(properties.vpcConfiguration)), errors.wrap('supplied properties not correct for "RedshiftSourceConfigProperty"');
    }
    function cfnAnomalyDetectorRedshiftSourceConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnomalyDetector_RedshiftSourceConfigPropertyValidator(properties).assertSuccess(), { ClusterIdentifier: cdk.stringToCloudFormation(properties.clusterIdentifier), DatabaseHost: cdk.stringToCloudFormation(properties.databaseHost), DatabaseName: cdk.stringToCloudFormation(properties.databaseName), DatabasePort: cdk.numberToCloudFormation(properties.databasePort), RoleArn: cdk.stringToCloudFormation(properties.roleArn), SecretManagerArn: cdk.stringToCloudFormation(properties.secretManagerArn), TableName: cdk.stringToCloudFormation(properties.tableName), VpcConfiguration: cfnAnomalyDetectorVpcConfigurationPropertyToCloudFormation(properties.vpcConfiguration) }) : properties;
    }
    function CfnAnomalyDetectorRedshiftSourceConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clusterIdentifier", "ClusterIdentifier", cfn_parse.FromCloudFormation.getString(properties.ClusterIdentifier)), ret.addPropertyResult("databaseHost", "DatabaseHost", cfn_parse.FromCloudFormation.getString(properties.DatabaseHost)), ret.addPropertyResult("databaseName", "DatabaseName", cfn_parse.FromCloudFormation.getString(properties.DatabaseName)), ret.addPropertyResult("databasePort", "DatabasePort", cfn_parse.FromCloudFormation.getNumber(properties.DatabasePort)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("secretManagerArn", "SecretManagerArn", cfn_parse.FromCloudFormation.getString(properties.SecretManagerArn)), ret.addPropertyResult("tableName", "TableName", cfn_parse.FromCloudFormation.getString(properties.TableName)), ret.addPropertyResult("vpcConfiguration", "VpcConfiguration", CfnAnomalyDetectorVpcConfigurationPropertyFromCloudFormation(properties.VpcConfiguration)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnomalyDetector_S3SourceConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fileFormatDescriptor", cdk.requiredValidator)(properties.fileFormatDescriptor)), errors.collect(cdk.propertyValidator("fileFormatDescriptor", CfnAnomalyDetector_FileFormatDescriptorPropertyValidator)(properties.fileFormatDescriptor)), errors.collect(cdk.propertyValidator("historicalDataPathList", cdk.listValidator(cdk.validateString))(properties.historicalDataPathList)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("templatedPathList", cdk.listValidator(cdk.validateString))(properties.templatedPathList)), errors.wrap('supplied properties not correct for "S3SourceConfigProperty"');
    }
    function cfnAnomalyDetectorS3SourceConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnomalyDetector_S3SourceConfigPropertyValidator(properties).assertSuccess(), { FileFormatDescriptor: cfnAnomalyDetectorFileFormatDescriptorPropertyToCloudFormation(properties.fileFormatDescriptor), HistoricalDataPathList: cdk.listMapper(cdk.stringToCloudFormation)(properties.historicalDataPathList), RoleArn: cdk.stringToCloudFormation(properties.roleArn), TemplatedPathList: cdk.listMapper(cdk.stringToCloudFormation)(properties.templatedPathList) }) : properties;
    }
    function CfnAnomalyDetectorS3SourceConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fileFormatDescriptor", "FileFormatDescriptor", CfnAnomalyDetectorFileFormatDescriptorPropertyFromCloudFormation(properties.FileFormatDescriptor)), ret.addPropertyResult("historicalDataPathList", "HistoricalDataPathList", properties.HistoricalDataPathList != null ? cfn_parse.FromCloudFormation.getStringArray(properties.HistoricalDataPathList) : void 0), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("templatedPathList", "TemplatedPathList", properties.TemplatedPathList != null ? cfn_parse.FromCloudFormation.getStringArray(properties.TemplatedPathList) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnomalyDetector_TimestampColumnPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnFormat", cdk.validateString)(properties.columnFormat)), errors.collect(cdk.propertyValidator("columnName", cdk.validateString)(properties.columnName)), errors.wrap('supplied properties not correct for "TimestampColumnProperty"');
    }
    function cfnAnomalyDetectorTimestampColumnPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnomalyDetector_TimestampColumnPropertyValidator(properties).assertSuccess(), { ColumnFormat: cdk.stringToCloudFormation(properties.columnFormat), ColumnName: cdk.stringToCloudFormation(properties.columnName) }) : properties;
    }
    function CfnAnomalyDetectorTimestampColumnPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columnFormat", "ColumnFormat", properties.ColumnFormat != null ? cfn_parse.FromCloudFormation.getString(properties.ColumnFormat) : void 0), ret.addPropertyResult("columnName", "ColumnName", properties.ColumnName != null ? cfn_parse.FromCloudFormation.getString(properties.ColumnName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnomalyDetector_VpcConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroupIdList", cdk.requiredValidator)(properties.securityGroupIdList)), errors.collect(cdk.propertyValidator("securityGroupIdList", cdk.listValidator(cdk.validateString))(properties.securityGroupIdList)), errors.collect(cdk.propertyValidator("subnetIdList", cdk.requiredValidator)(properties.subnetIdList)), errors.collect(cdk.propertyValidator("subnetIdList", cdk.listValidator(cdk.validateString))(properties.subnetIdList)), errors.wrap('supplied properties not correct for "VpcConfigurationProperty"');
    }
    function cfnAnomalyDetectorVpcConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnomalyDetector_VpcConfigurationPropertyValidator(properties).assertSuccess(), { SecurityGroupIdList: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIdList), SubnetIdList: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIdList) }) : properties;
    }
    function CfnAnomalyDetectorVpcConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroupIdList", "SecurityGroupIdList", cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIdList)), ret.addPropertyResult("subnetIdList", "SubnetIdList", cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIdList)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-lookoutmetrics/lib/index.js
var require_lib181 = __commonJS({
  "node_modules/aws-cdk-lib/aws-lookoutmetrics/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lookoutmetrics_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-lookoutmetrics/index.js
var require_aws_lookoutmetrics = __commonJS({
  "node_modules/aws-cdk-lib/aws-lookoutmetrics/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib181(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-lookoutvision/lib/lookoutvision.generated.js
var require_lookoutvision_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-lookoutvision/lib/lookoutvision.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnProject = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnProjectPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("projectName", cdk.requiredValidator)(properties.projectName)), errors.collect(cdk.propertyValidator("projectName", cdk.validateString)(properties.projectName)), errors.wrap('supplied properties not correct for "CfnProjectProps"');
    }
    function cfnProjectPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProjectPropsValidator(properties).assertSuccess(), { ProjectName: cdk.stringToCloudFormation(properties.projectName) }) : properties;
    }
    function CfnProjectPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("projectName", "ProjectName", cfn_parse.FromCloudFormation.getString(properties.ProjectName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnProject = class _CfnProject extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnProjectPropsFromCloudFormation(resourceProperties), ret = new _CfnProject(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnProject.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_lookoutvision_CfnProjectProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnProject), error;
        }
        cdk.requireProperty(props, "projectName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.projectName = props.projectName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnProject.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { projectName: this.projectName };
      }
      renderProperties(props) {
        return cfnProjectPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnProject[_a] = { fqn: "aws-cdk-lib.aws_lookoutvision.CfnProject", version: "2.80.0" }, CfnProject.CFN_RESOURCE_TYPE_NAME = "AWS::LookoutVision::Project", exports2.CfnProject = CfnProject;
  }
});

// node_modules/aws-cdk-lib/aws-lookoutvision/lib/index.js
var require_lib182 = __commonJS({
  "node_modules/aws-cdk-lib/aws-lookoutvision/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lookoutvision_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-lookoutvision/index.js
var require_aws_lookoutvision = __commonJS({
  "node_modules/aws-cdk-lib/aws-lookoutvision/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib182(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-m2/lib/m2.generated.js
var require_m2_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-m2/lib/m2.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnEnvironment = exports2.CfnApplication = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnApplicationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("definition", cdk.requiredValidator)(properties.definition)), errors.collect(cdk.propertyValidator("definition", CfnApplication_DefinitionPropertyValidator)(properties.definition)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("engineType", cdk.requiredValidator)(properties.engineType)), errors.collect(cdk.propertyValidator("engineType", cdk.validateString)(properties.engineType)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.wrap('supplied properties not correct for "CfnApplicationProps"');
    }
    function cfnApplicationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationPropsValidator(properties).assertSuccess(), { Definition: cfnApplicationDefinitionPropertyToCloudFormation(properties.definition), EngineType: cdk.stringToCloudFormation(properties.engineType), Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnApplicationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("definition", "Definition", CfnApplicationDefinitionPropertyFromCloudFormation(properties.Definition)), ret.addPropertyResult("engineType", "EngineType", cfn_parse.FromCloudFormation.getString(properties.EngineType)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApplication = class _CfnApplication extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApplicationPropsFromCloudFormation(resourceProperties), ret = new _CfnApplication(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApplication.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_m2_CfnApplicationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApplication), error;
        }
        cdk.requireProperty(props, "definition", this), cdk.requireProperty(props, "engineType", this), cdk.requireProperty(props, "name", this), this.attrApplicationArn = cdk.Token.asString(this.getAtt("ApplicationArn", cdk.ResolutionTypeHint.STRING)), this.attrApplicationId = cdk.Token.asString(this.getAtt("ApplicationId", cdk.ResolutionTypeHint.STRING)), this.definition = props.definition, this.engineType = props.engineType, this.name = props.name, this.description = props.description, this.kmsKeyId = props.kmsKeyId, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::M2::Application", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApplication.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { definition: this.definition, engineType: this.engineType, name: this.name, description: this.description, kmsKeyId: this.kmsKeyId, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnApplicationPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnApplication[_a] = { fqn: "aws-cdk-lib.aws_m2.CfnApplication", version: "2.80.0" }, CfnApplication.CFN_RESOURCE_TYPE_NAME = "AWS::M2::Application", exports2.CfnApplication = CfnApplication;
    function CfnApplication_DefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("content", cdk.validateString)(properties.content)), errors.collect(cdk.propertyValidator("s3Location", cdk.validateString)(properties.s3Location)), errors.wrap('supplied properties not correct for "DefinitionProperty"');
    }
    function cfnApplicationDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_DefinitionPropertyValidator(properties).assertSuccess(), { Content: cdk.stringToCloudFormation(properties.content), S3Location: cdk.stringToCloudFormation(properties.s3Location) }) : properties;
    }
    function CfnApplicationDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("content", "Content", properties.Content != null ? cfn_parse.FromCloudFormation.getString(properties.Content) : void 0), ret.addPropertyResult("s3Location", "S3Location", properties.S3Location != null ? cfn_parse.FromCloudFormation.getString(properties.S3Location) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEnvironmentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("engineType", cdk.requiredValidator)(properties.engineType)), errors.collect(cdk.propertyValidator("engineType", cdk.validateString)(properties.engineType)), errors.collect(cdk.propertyValidator("engineVersion", cdk.validateString)(properties.engineVersion)), errors.collect(cdk.propertyValidator("highAvailabilityConfig", CfnEnvironment_HighAvailabilityConfigPropertyValidator)(properties.highAvailabilityConfig)), errors.collect(cdk.propertyValidator("instanceType", cdk.requiredValidator)(properties.instanceType)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("preferredMaintenanceWindow", cdk.validateString)(properties.preferredMaintenanceWindow)), errors.collect(cdk.propertyValidator("publiclyAccessible", cdk.validateBoolean)(properties.publiclyAccessible)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("storageConfigurations", cdk.listValidator(CfnEnvironment_StorageConfigurationPropertyValidator))(properties.storageConfigurations)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.wrap('supplied properties not correct for "CfnEnvironmentProps"');
    }
    function cfnEnvironmentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEnvironmentPropsValidator(properties).assertSuccess(), { EngineType: cdk.stringToCloudFormation(properties.engineType), InstanceType: cdk.stringToCloudFormation(properties.instanceType), Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), EngineVersion: cdk.stringToCloudFormation(properties.engineVersion), HighAvailabilityConfig: cfnEnvironmentHighAvailabilityConfigPropertyToCloudFormation(properties.highAvailabilityConfig), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), PreferredMaintenanceWindow: cdk.stringToCloudFormation(properties.preferredMaintenanceWindow), PubliclyAccessible: cdk.booleanToCloudFormation(properties.publiclyAccessible), SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), StorageConfigurations: cdk.listMapper(cfnEnvironmentStorageConfigurationPropertyToCloudFormation)(properties.storageConfigurations), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnEnvironmentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("engineType", "EngineType", cfn_parse.FromCloudFormation.getString(properties.EngineType)), ret.addPropertyResult("instanceType", "InstanceType", cfn_parse.FromCloudFormation.getString(properties.InstanceType)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("engineVersion", "EngineVersion", properties.EngineVersion != null ? cfn_parse.FromCloudFormation.getString(properties.EngineVersion) : void 0), ret.addPropertyResult("highAvailabilityConfig", "HighAvailabilityConfig", properties.HighAvailabilityConfig != null ? CfnEnvironmentHighAvailabilityConfigPropertyFromCloudFormation(properties.HighAvailabilityConfig) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("preferredMaintenanceWindow", "PreferredMaintenanceWindow", properties.PreferredMaintenanceWindow != null ? cfn_parse.FromCloudFormation.getString(properties.PreferredMaintenanceWindow) : void 0), ret.addPropertyResult("publiclyAccessible", "PubliclyAccessible", properties.PubliclyAccessible != null ? cfn_parse.FromCloudFormation.getBoolean(properties.PubliclyAccessible) : void 0), ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("storageConfigurations", "StorageConfigurations", properties.StorageConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnEnvironmentStorageConfigurationPropertyFromCloudFormation)(properties.StorageConfigurations) : void 0), ret.addPropertyResult("subnetIds", "SubnetIds", properties.SubnetIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEnvironment = class _CfnEnvironment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEnvironmentPropsFromCloudFormation(resourceProperties), ret = new _CfnEnvironment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEnvironment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_m2_CfnEnvironmentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEnvironment), error;
        }
        cdk.requireProperty(props, "engineType", this), cdk.requireProperty(props, "instanceType", this), cdk.requireProperty(props, "name", this), this.attrEnvironmentArn = cdk.Token.asString(this.getAtt("EnvironmentArn", cdk.ResolutionTypeHint.STRING)), this.attrEnvironmentId = cdk.Token.asString(this.getAtt("EnvironmentId", cdk.ResolutionTypeHint.STRING)), this.engineType = props.engineType, this.instanceType = props.instanceType, this.name = props.name, this.description = props.description, this.engineVersion = props.engineVersion, this.highAvailabilityConfig = props.highAvailabilityConfig, this.kmsKeyId = props.kmsKeyId, this.preferredMaintenanceWindow = props.preferredMaintenanceWindow, this.publiclyAccessible = props.publiclyAccessible, this.securityGroupIds = props.securityGroupIds, this.storageConfigurations = props.storageConfigurations, this.subnetIds = props.subnetIds, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::M2::Environment", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEnvironment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { engineType: this.engineType, instanceType: this.instanceType, name: this.name, description: this.description, engineVersion: this.engineVersion, highAvailabilityConfig: this.highAvailabilityConfig, kmsKeyId: this.kmsKeyId, preferredMaintenanceWindow: this.preferredMaintenanceWindow, publiclyAccessible: this.publiclyAccessible, securityGroupIds: this.securityGroupIds, storageConfigurations: this.storageConfigurations, subnetIds: this.subnetIds, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnEnvironmentPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnEnvironment[_b] = { fqn: "aws-cdk-lib.aws_m2.CfnEnvironment", version: "2.80.0" }, CfnEnvironment.CFN_RESOURCE_TYPE_NAME = "AWS::M2::Environment", exports2.CfnEnvironment = CfnEnvironment;
    function CfnEnvironment_EfsStorageConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fileSystemId", cdk.requiredValidator)(properties.fileSystemId)), errors.collect(cdk.propertyValidator("fileSystemId", cdk.validateString)(properties.fileSystemId)), errors.collect(cdk.propertyValidator("mountPoint", cdk.requiredValidator)(properties.mountPoint)), errors.collect(cdk.propertyValidator("mountPoint", cdk.validateString)(properties.mountPoint)), errors.wrap('supplied properties not correct for "EfsStorageConfigurationProperty"');
    }
    function cfnEnvironmentEfsStorageConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEnvironment_EfsStorageConfigurationPropertyValidator(properties).assertSuccess(), { FileSystemId: cdk.stringToCloudFormation(properties.fileSystemId), MountPoint: cdk.stringToCloudFormation(properties.mountPoint) }) : properties;
    }
    function CfnEnvironmentEfsStorageConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fileSystemId", "FileSystemId", cfn_parse.FromCloudFormation.getString(properties.FileSystemId)), ret.addPropertyResult("mountPoint", "MountPoint", cfn_parse.FromCloudFormation.getString(properties.MountPoint)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEnvironment_FsxStorageConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fileSystemId", cdk.requiredValidator)(properties.fileSystemId)), errors.collect(cdk.propertyValidator("fileSystemId", cdk.validateString)(properties.fileSystemId)), errors.collect(cdk.propertyValidator("mountPoint", cdk.requiredValidator)(properties.mountPoint)), errors.collect(cdk.propertyValidator("mountPoint", cdk.validateString)(properties.mountPoint)), errors.wrap('supplied properties not correct for "FsxStorageConfigurationProperty"');
    }
    function cfnEnvironmentFsxStorageConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEnvironment_FsxStorageConfigurationPropertyValidator(properties).assertSuccess(), { FileSystemId: cdk.stringToCloudFormation(properties.fileSystemId), MountPoint: cdk.stringToCloudFormation(properties.mountPoint) }) : properties;
    }
    function CfnEnvironmentFsxStorageConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fileSystemId", "FileSystemId", cfn_parse.FromCloudFormation.getString(properties.FileSystemId)), ret.addPropertyResult("mountPoint", "MountPoint", cfn_parse.FromCloudFormation.getString(properties.MountPoint)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEnvironment_HighAvailabilityConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("desiredCapacity", cdk.requiredValidator)(properties.desiredCapacity)), errors.collect(cdk.propertyValidator("desiredCapacity", cdk.validateNumber)(properties.desiredCapacity)), errors.wrap('supplied properties not correct for "HighAvailabilityConfigProperty"');
    }
    function cfnEnvironmentHighAvailabilityConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEnvironment_HighAvailabilityConfigPropertyValidator(properties).assertSuccess(), { DesiredCapacity: cdk.numberToCloudFormation(properties.desiredCapacity) }) : properties;
    }
    function CfnEnvironmentHighAvailabilityConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("desiredCapacity", "DesiredCapacity", cfn_parse.FromCloudFormation.getNumber(properties.DesiredCapacity)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEnvironment_StorageConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("efs", CfnEnvironment_EfsStorageConfigurationPropertyValidator)(properties.efs)), errors.collect(cdk.propertyValidator("fsx", CfnEnvironment_FsxStorageConfigurationPropertyValidator)(properties.fsx)), errors.wrap('supplied properties not correct for "StorageConfigurationProperty"');
    }
    function cfnEnvironmentStorageConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEnvironment_StorageConfigurationPropertyValidator(properties).assertSuccess(), { Efs: cfnEnvironmentEfsStorageConfigurationPropertyToCloudFormation(properties.efs), Fsx: cfnEnvironmentFsxStorageConfigurationPropertyToCloudFormation(properties.fsx) }) : properties;
    }
    function CfnEnvironmentStorageConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("efs", "Efs", properties.Efs != null ? CfnEnvironmentEfsStorageConfigurationPropertyFromCloudFormation(properties.Efs) : void 0), ret.addPropertyResult("fsx", "Fsx", properties.Fsx != null ? CfnEnvironmentFsxStorageConfigurationPropertyFromCloudFormation(properties.Fsx) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-m2/lib/index.js
var require_lib183 = __commonJS({
  "node_modules/aws-cdk-lib/aws-m2/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_m2_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-m2/index.js
var require_aws_m2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-m2/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib183(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-macie/lib/macie.generated.js
var require_macie_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-macie/lib/macie.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnSession = exports2.CfnFindingsFilter = exports2.CfnCustomDataIdentifier = exports2.CfnAllowList = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAllowListPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("criteria", cdk.requiredValidator)(properties.criteria)), errors.collect(cdk.propertyValidator("criteria", CfnAllowList_CriteriaPropertyValidator)(properties.criteria)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnAllowListProps"');
    }
    function cfnAllowListPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAllowListPropsValidator(properties).assertSuccess(), { Criteria: cfnAllowListCriteriaPropertyToCloudFormation(properties.criteria), Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnAllowListPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("criteria", "Criteria", CfnAllowListCriteriaPropertyFromCloudFormation(properties.Criteria)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAllowList = class _CfnAllowList extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAllowListPropsFromCloudFormation(resourceProperties), ret = new _CfnAllowList(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAllowList.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_macie_CfnAllowListProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAllowList), error;
        }
        cdk.requireProperty(props, "criteria", this), cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.criteria = props.criteria, this.name = props.name, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Macie::AllowList", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAllowList.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { criteria: this.criteria, name: this.name, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnAllowListPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAllowList[_a] = { fqn: "aws-cdk-lib.aws_macie.CfnAllowList", version: "2.80.0" }, CfnAllowList.CFN_RESOURCE_TYPE_NAME = "AWS::Macie::AllowList", exports2.CfnAllowList = CfnAllowList;
    function CfnAllowList_CriteriaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("regex", cdk.validateString)(properties.regex)), errors.collect(cdk.propertyValidator("s3WordsList", CfnAllowList_S3WordsListPropertyValidator)(properties.s3WordsList)), errors.wrap('supplied properties not correct for "CriteriaProperty"');
    }
    function cfnAllowListCriteriaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAllowList_CriteriaPropertyValidator(properties).assertSuccess(), { Regex: cdk.stringToCloudFormation(properties.regex), S3WordsList: cfnAllowListS3WordsListPropertyToCloudFormation(properties.s3WordsList) }) : properties;
    }
    function CfnAllowListCriteriaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("regex", "Regex", properties.Regex != null ? cfn_parse.FromCloudFormation.getString(properties.Regex) : void 0), ret.addPropertyResult("s3WordsList", "S3WordsList", properties.S3WordsList != null ? CfnAllowListS3WordsListPropertyFromCloudFormation(properties.S3WordsList) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAllowList_S3WordsListPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketName", cdk.requiredValidator)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.collect(cdk.propertyValidator("objectKey", cdk.requiredValidator)(properties.objectKey)), errors.collect(cdk.propertyValidator("objectKey", cdk.validateString)(properties.objectKey)), errors.wrap('supplied properties not correct for "S3WordsListProperty"');
    }
    function cfnAllowListS3WordsListPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAllowList_S3WordsListPropertyValidator(properties).assertSuccess(), { BucketName: cdk.stringToCloudFormation(properties.bucketName), ObjectKey: cdk.stringToCloudFormation(properties.objectKey) }) : properties;
    }
    function CfnAllowListS3WordsListPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketName", "BucketName", cfn_parse.FromCloudFormation.getString(properties.BucketName)), ret.addPropertyResult("objectKey", "ObjectKey", cfn_parse.FromCloudFormation.getString(properties.ObjectKey)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCustomDataIdentifierPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("ignoreWords", cdk.listValidator(cdk.validateString))(properties.ignoreWords)), errors.collect(cdk.propertyValidator("keywords", cdk.listValidator(cdk.validateString))(properties.keywords)), errors.collect(cdk.propertyValidator("maximumMatchDistance", cdk.validateNumber)(properties.maximumMatchDistance)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("regex", cdk.requiredValidator)(properties.regex)), errors.collect(cdk.propertyValidator("regex", cdk.validateString)(properties.regex)), errors.wrap('supplied properties not correct for "CfnCustomDataIdentifierProps"');
    }
    function cfnCustomDataIdentifierPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCustomDataIdentifierPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Regex: cdk.stringToCloudFormation(properties.regex), Description: cdk.stringToCloudFormation(properties.description), IgnoreWords: cdk.listMapper(cdk.stringToCloudFormation)(properties.ignoreWords), Keywords: cdk.listMapper(cdk.stringToCloudFormation)(properties.keywords), MaximumMatchDistance: cdk.numberToCloudFormation(properties.maximumMatchDistance) }) : properties;
    }
    function CfnCustomDataIdentifierPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("regex", "Regex", cfn_parse.FromCloudFormation.getString(properties.Regex)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("ignoreWords", "IgnoreWords", properties.IgnoreWords != null ? cfn_parse.FromCloudFormation.getStringArray(properties.IgnoreWords) : void 0), ret.addPropertyResult("keywords", "Keywords", properties.Keywords != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Keywords) : void 0), ret.addPropertyResult("maximumMatchDistance", "MaximumMatchDistance", properties.MaximumMatchDistance != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumMatchDistance) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCustomDataIdentifier = class _CfnCustomDataIdentifier extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCustomDataIdentifierPropsFromCloudFormation(resourceProperties), ret = new _CfnCustomDataIdentifier(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCustomDataIdentifier.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_macie_CfnCustomDataIdentifierProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCustomDataIdentifier), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "regex", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.regex = props.regex, this.description = props.description, this.ignoreWords = props.ignoreWords, this.keywords = props.keywords, this.maximumMatchDistance = props.maximumMatchDistance;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCustomDataIdentifier.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, regex: this.regex, description: this.description, ignoreWords: this.ignoreWords, keywords: this.keywords, maximumMatchDistance: this.maximumMatchDistance };
      }
      renderProperties(props) {
        return cfnCustomDataIdentifierPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnCustomDataIdentifier[_b] = { fqn: "aws-cdk-lib.aws_macie.CfnCustomDataIdentifier", version: "2.80.0" }, CfnCustomDataIdentifier.CFN_RESOURCE_TYPE_NAME = "AWS::Macie::CustomDataIdentifier", exports2.CfnCustomDataIdentifier = CfnCustomDataIdentifier;
    function CfnFindingsFilterPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.validateString)(properties.action)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("findingCriteria", cdk.requiredValidator)(properties.findingCriteria)), errors.collect(cdk.propertyValidator("findingCriteria", CfnFindingsFilter_FindingCriteriaPropertyValidator)(properties.findingCriteria)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("position", cdk.validateNumber)(properties.position)), errors.wrap('supplied properties not correct for "CfnFindingsFilterProps"');
    }
    function cfnFindingsFilterPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFindingsFilterPropsValidator(properties).assertSuccess(), { FindingCriteria: cfnFindingsFilterFindingCriteriaPropertyToCloudFormation(properties.findingCriteria), Name: cdk.stringToCloudFormation(properties.name), Action: cdk.stringToCloudFormation(properties.action), Description: cdk.stringToCloudFormation(properties.description), Position: cdk.numberToCloudFormation(properties.position) }) : properties;
    }
    function CfnFindingsFilterPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("findingCriteria", "FindingCriteria", CfnFindingsFilterFindingCriteriaPropertyFromCloudFormation(properties.FindingCriteria)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("action", "Action", properties.Action != null ? cfn_parse.FromCloudFormation.getString(properties.Action) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("position", "Position", properties.Position != null ? cfn_parse.FromCloudFormation.getNumber(properties.Position) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFindingsFilter = class _CfnFindingsFilter extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFindingsFilterPropsFromCloudFormation(resourceProperties), ret = new _CfnFindingsFilter(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFindingsFilter.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_macie_CfnFindingsFilterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFindingsFilter), error;
        }
        cdk.requireProperty(props, "findingCriteria", this), cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrFindingsFilterListItems = this.getAtt("FindingsFilterListItems", cdk.ResolutionTypeHint.STRING), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.findingCriteria = props.findingCriteria, this.name = props.name, this.action = props.action, this.description = props.description, this.position = props.position;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFindingsFilter.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { findingCriteria: this.findingCriteria, name: this.name, action: this.action, description: this.description, position: this.position };
      }
      renderProperties(props) {
        return cfnFindingsFilterPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnFindingsFilter[_c] = { fqn: "aws-cdk-lib.aws_macie.CfnFindingsFilter", version: "2.80.0" }, CfnFindingsFilter.CFN_RESOURCE_TYPE_NAME = "AWS::Macie::FindingsFilter", exports2.CfnFindingsFilter = CfnFindingsFilter;
    function CfnFindingsFilter_CriterionAdditionalPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("eq", cdk.listValidator(cdk.validateString))(properties.eq)), errors.collect(cdk.propertyValidator("gt", cdk.validateNumber)(properties.gt)), errors.collect(cdk.propertyValidator("gte", cdk.validateNumber)(properties.gte)), errors.collect(cdk.propertyValidator("lt", cdk.validateNumber)(properties.lt)), errors.collect(cdk.propertyValidator("lte", cdk.validateNumber)(properties.lte)), errors.collect(cdk.propertyValidator("neq", cdk.listValidator(cdk.validateString))(properties.neq)), errors.wrap('supplied properties not correct for "CriterionAdditionalPropertiesProperty"');
    }
    function cfnFindingsFilterCriterionAdditionalPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFindingsFilter_CriterionAdditionalPropertiesPropertyValidator(properties).assertSuccess(), { eq: cdk.listMapper(cdk.stringToCloudFormation)(properties.eq), gt: cdk.numberToCloudFormation(properties.gt), gte: cdk.numberToCloudFormation(properties.gte), lt: cdk.numberToCloudFormation(properties.lt), lte: cdk.numberToCloudFormation(properties.lte), neq: cdk.listMapper(cdk.stringToCloudFormation)(properties.neq) }) : properties;
    }
    function CfnFindingsFilterCriterionAdditionalPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("eq", "eq", properties.eq != null ? cfn_parse.FromCloudFormation.getStringArray(properties.eq) : void 0), ret.addPropertyResult("gt", "gt", properties.gt != null ? cfn_parse.FromCloudFormation.getNumber(properties.gt) : void 0), ret.addPropertyResult("gte", "gte", properties.gte != null ? cfn_parse.FromCloudFormation.getNumber(properties.gte) : void 0), ret.addPropertyResult("lt", "lt", properties.lt != null ? cfn_parse.FromCloudFormation.getNumber(properties.lt) : void 0), ret.addPropertyResult("lte", "lte", properties.lte != null ? cfn_parse.FromCloudFormation.getNumber(properties.lte) : void 0), ret.addPropertyResult("neq", "neq", properties.neq != null ? cfn_parse.FromCloudFormation.getStringArray(properties.neq) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFindingsFilter_FindingCriteriaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("criterion", cdk.hashValidator(CfnFindingsFilter_CriterionAdditionalPropertiesPropertyValidator))(properties.criterion)), errors.wrap('supplied properties not correct for "FindingCriteriaProperty"');
    }
    function cfnFindingsFilterFindingCriteriaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFindingsFilter_FindingCriteriaPropertyValidator(properties).assertSuccess(), { Criterion: cdk.hashMapper(cfnFindingsFilterCriterionAdditionalPropertiesPropertyToCloudFormation)(properties.criterion) }) : properties;
    }
    function CfnFindingsFilterFindingCriteriaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("criterion", "Criterion", properties.Criterion != null ? cfn_parse.FromCloudFormation.getMap(CfnFindingsFilterCriterionAdditionalPropertiesPropertyFromCloudFormation)(properties.Criterion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSessionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("findingPublishingFrequency", cdk.validateString)(properties.findingPublishingFrequency)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "CfnSessionProps"');
    }
    function cfnSessionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSessionPropsValidator(properties).assertSuccess(), { FindingPublishingFrequency: cdk.stringToCloudFormation(properties.findingPublishingFrequency), Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnSessionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("findingPublishingFrequency", "FindingPublishingFrequency", properties.FindingPublishingFrequency != null ? cfn_parse.FromCloudFormation.getString(properties.FindingPublishingFrequency) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSession = class _CfnSession extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSessionPropsFromCloudFormation(resourceProperties), ret = new _CfnSession(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnSession.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_macie_CfnSessionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSession), error;
        }
        this.attrAwsAccountId = cdk.Token.asString(this.getAtt("AwsAccountId", cdk.ResolutionTypeHint.STRING)), this.attrServiceRole = cdk.Token.asString(this.getAtt("ServiceRole", cdk.ResolutionTypeHint.STRING)), this.findingPublishingFrequency = props.findingPublishingFrequency, this.status = props.status;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSession.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { findingPublishingFrequency: this.findingPublishingFrequency, status: this.status };
      }
      renderProperties(props) {
        return cfnSessionPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnSession[_d] = { fqn: "aws-cdk-lib.aws_macie.CfnSession", version: "2.80.0" }, CfnSession.CFN_RESOURCE_TYPE_NAME = "AWS::Macie::Session", exports2.CfnSession = CfnSession;
  }
});

// node_modules/aws-cdk-lib/aws-macie/lib/index.js
var require_lib184 = __commonJS({
  "node_modules/aws-cdk-lib/aws-macie/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_macie_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-macie/index.js
var require_aws_macie = __commonJS({
  "node_modules/aws-cdk-lib/aws-macie/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib184(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-managedblockchain/lib/managedblockchain.generated.js
var require_managedblockchain_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-managedblockchain/lib/managedblockchain.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnNode = exports2.CfnMember = exports2.CfnAccessor = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAccessorPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessorType", cdk.requiredValidator)(properties.accessorType)), errors.collect(cdk.propertyValidator("accessorType", cdk.validateString)(properties.accessorType)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnAccessorProps"');
    }
    function cfnAccessorPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccessorPropsValidator(properties).assertSuccess(), { AccessorType: cdk.stringToCloudFormation(properties.accessorType), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnAccessorPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessorType", "AccessorType", cfn_parse.FromCloudFormation.getString(properties.AccessorType)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAccessor = class _CfnAccessor extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAccessorPropsFromCloudFormation(resourceProperties), ret = new _CfnAccessor(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAccessor.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_managedblockchain_CfnAccessorProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAccessor), error;
        }
        cdk.requireProperty(props, "accessorType", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrBillingToken = cdk.Token.asString(this.getAtt("BillingToken", cdk.ResolutionTypeHint.STRING)), this.attrCreationDate = cdk.Token.asString(this.getAtt("CreationDate", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.accessorType = props.accessorType, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ManagedBlockchain::Accessor", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAccessor.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { accessorType: this.accessorType, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnAccessorPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAccessor[_a] = { fqn: "aws-cdk-lib.aws_managedblockchain.CfnAccessor", version: "2.80.0" }, CfnAccessor.CFN_RESOURCE_TYPE_NAME = "AWS::ManagedBlockchain::Accessor", exports2.CfnAccessor = CfnAccessor;
    function CfnMemberPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("invitationId", cdk.validateString)(properties.invitationId)), errors.collect(cdk.propertyValidator("memberConfiguration", cdk.requiredValidator)(properties.memberConfiguration)), errors.collect(cdk.propertyValidator("memberConfiguration", CfnMember_MemberConfigurationPropertyValidator)(properties.memberConfiguration)), errors.collect(cdk.propertyValidator("networkConfiguration", CfnMember_NetworkConfigurationPropertyValidator)(properties.networkConfiguration)), errors.collect(cdk.propertyValidator("networkId", cdk.validateString)(properties.networkId)), errors.wrap('supplied properties not correct for "CfnMemberProps"');
    }
    function cfnMemberPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMemberPropsValidator(properties).assertSuccess(), { MemberConfiguration: cfnMemberMemberConfigurationPropertyToCloudFormation(properties.memberConfiguration), InvitationId: cdk.stringToCloudFormation(properties.invitationId), NetworkConfiguration: cfnMemberNetworkConfigurationPropertyToCloudFormation(properties.networkConfiguration), NetworkId: cdk.stringToCloudFormation(properties.networkId) }) : properties;
    }
    function CfnMemberPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("memberConfiguration", "MemberConfiguration", CfnMemberMemberConfigurationPropertyFromCloudFormation(properties.MemberConfiguration)), ret.addPropertyResult("invitationId", "InvitationId", properties.InvitationId != null ? cfn_parse.FromCloudFormation.getString(properties.InvitationId) : void 0), ret.addPropertyResult("networkConfiguration", "NetworkConfiguration", properties.NetworkConfiguration != null ? CfnMemberNetworkConfigurationPropertyFromCloudFormation(properties.NetworkConfiguration) : void 0), ret.addPropertyResult("networkId", "NetworkId", properties.NetworkId != null ? cfn_parse.FromCloudFormation.getString(properties.NetworkId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnMember = class _CfnMember extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnMemberPropsFromCloudFormation(resourceProperties), ret = new _CfnMember(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnMember.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_managedblockchain_CfnMemberProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnMember), error;
        }
        cdk.requireProperty(props, "memberConfiguration", this), this.attrMemberId = cdk.Token.asString(this.getAtt("MemberId", cdk.ResolutionTypeHint.STRING)), this.attrNetworkId = cdk.Token.asString(this.getAtt("NetworkId", cdk.ResolutionTypeHint.STRING)), this.memberConfiguration = props.memberConfiguration, this.invitationId = props.invitationId, this.networkConfiguration = props.networkConfiguration, this.networkId = props.networkId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnMember.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { memberConfiguration: this.memberConfiguration, invitationId: this.invitationId, networkConfiguration: this.networkConfiguration, networkId: this.networkId };
      }
      renderProperties(props) {
        return cfnMemberPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnMember[_b] = { fqn: "aws-cdk-lib.aws_managedblockchain.CfnMember", version: "2.80.0" }, CfnMember.CFN_RESOURCE_TYPE_NAME = "AWS::ManagedBlockchain::Member", exports2.CfnMember = CfnMember;
    function CfnMember_ApprovalThresholdPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("proposalDurationInHours", cdk.validateNumber)(properties.proposalDurationInHours)), errors.collect(cdk.propertyValidator("thresholdComparator", cdk.validateString)(properties.thresholdComparator)), errors.collect(cdk.propertyValidator("thresholdPercentage", cdk.validateNumber)(properties.thresholdPercentage)), errors.wrap('supplied properties not correct for "ApprovalThresholdPolicyProperty"');
    }
    function cfnMemberApprovalThresholdPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMember_ApprovalThresholdPolicyPropertyValidator(properties).assertSuccess(), { ProposalDurationInHours: cdk.numberToCloudFormation(properties.proposalDurationInHours), ThresholdComparator: cdk.stringToCloudFormation(properties.thresholdComparator), ThresholdPercentage: cdk.numberToCloudFormation(properties.thresholdPercentage) }) : properties;
    }
    function CfnMemberApprovalThresholdPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("proposalDurationInHours", "ProposalDurationInHours", properties.ProposalDurationInHours != null ? cfn_parse.FromCloudFormation.getNumber(properties.ProposalDurationInHours) : void 0), ret.addPropertyResult("thresholdComparator", "ThresholdComparator", properties.ThresholdComparator != null ? cfn_parse.FromCloudFormation.getString(properties.ThresholdComparator) : void 0), ret.addPropertyResult("thresholdPercentage", "ThresholdPercentage", properties.ThresholdPercentage != null ? cfn_parse.FromCloudFormation.getNumber(properties.ThresholdPercentage) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMember_MemberConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("memberFrameworkConfiguration", CfnMember_MemberFrameworkConfigurationPropertyValidator)(properties.memberFrameworkConfiguration)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "MemberConfigurationProperty"');
    }
    function cfnMemberMemberConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMember_MemberConfigurationPropertyValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), MemberFrameworkConfiguration: cfnMemberMemberFrameworkConfigurationPropertyToCloudFormation(properties.memberFrameworkConfiguration), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnMemberMemberConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("memberFrameworkConfiguration", "MemberFrameworkConfiguration", properties.MemberFrameworkConfiguration != null ? CfnMemberMemberFrameworkConfigurationPropertyFromCloudFormation(properties.MemberFrameworkConfiguration) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMember_MemberFabricConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("adminPassword", cdk.requiredValidator)(properties.adminPassword)), errors.collect(cdk.propertyValidator("adminPassword", cdk.validateString)(properties.adminPassword)), errors.collect(cdk.propertyValidator("adminUsername", cdk.requiredValidator)(properties.adminUsername)), errors.collect(cdk.propertyValidator("adminUsername", cdk.validateString)(properties.adminUsername)), errors.wrap('supplied properties not correct for "MemberFabricConfigurationProperty"');
    }
    function cfnMemberMemberFabricConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMember_MemberFabricConfigurationPropertyValidator(properties).assertSuccess(), { AdminPassword: cdk.stringToCloudFormation(properties.adminPassword), AdminUsername: cdk.stringToCloudFormation(properties.adminUsername) }) : properties;
    }
    function CfnMemberMemberFabricConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("adminPassword", "AdminPassword", cfn_parse.FromCloudFormation.getString(properties.AdminPassword)), ret.addPropertyResult("adminUsername", "AdminUsername", cfn_parse.FromCloudFormation.getString(properties.AdminUsername)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMember_MemberFrameworkConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("memberFabricConfiguration", CfnMember_MemberFabricConfigurationPropertyValidator)(properties.memberFabricConfiguration)), errors.wrap('supplied properties not correct for "MemberFrameworkConfigurationProperty"');
    }
    function cfnMemberMemberFrameworkConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMember_MemberFrameworkConfigurationPropertyValidator(properties).assertSuccess(), { MemberFabricConfiguration: cfnMemberMemberFabricConfigurationPropertyToCloudFormation(properties.memberFabricConfiguration) }) : properties;
    }
    function CfnMemberMemberFrameworkConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("memberFabricConfiguration", "MemberFabricConfiguration", properties.MemberFabricConfiguration != null ? CfnMemberMemberFabricConfigurationPropertyFromCloudFormation(properties.MemberFabricConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMember_NetworkConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("framework", cdk.requiredValidator)(properties.framework)), errors.collect(cdk.propertyValidator("framework", cdk.validateString)(properties.framework)), errors.collect(cdk.propertyValidator("frameworkVersion", cdk.requiredValidator)(properties.frameworkVersion)), errors.collect(cdk.propertyValidator("frameworkVersion", cdk.validateString)(properties.frameworkVersion)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("networkFrameworkConfiguration", CfnMember_NetworkFrameworkConfigurationPropertyValidator)(properties.networkFrameworkConfiguration)), errors.collect(cdk.propertyValidator("votingPolicy", cdk.requiredValidator)(properties.votingPolicy)), errors.collect(cdk.propertyValidator("votingPolicy", CfnMember_VotingPolicyPropertyValidator)(properties.votingPolicy)), errors.wrap('supplied properties not correct for "NetworkConfigurationProperty"');
    }
    function cfnMemberNetworkConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMember_NetworkConfigurationPropertyValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), Framework: cdk.stringToCloudFormation(properties.framework), FrameworkVersion: cdk.stringToCloudFormation(properties.frameworkVersion), Name: cdk.stringToCloudFormation(properties.name), NetworkFrameworkConfiguration: cfnMemberNetworkFrameworkConfigurationPropertyToCloudFormation(properties.networkFrameworkConfiguration), VotingPolicy: cfnMemberVotingPolicyPropertyToCloudFormation(properties.votingPolicy) }) : properties;
    }
    function CfnMemberNetworkConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("framework", "Framework", cfn_parse.FromCloudFormation.getString(properties.Framework)), ret.addPropertyResult("frameworkVersion", "FrameworkVersion", cfn_parse.FromCloudFormation.getString(properties.FrameworkVersion)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("networkFrameworkConfiguration", "NetworkFrameworkConfiguration", properties.NetworkFrameworkConfiguration != null ? CfnMemberNetworkFrameworkConfigurationPropertyFromCloudFormation(properties.NetworkFrameworkConfiguration) : void 0), ret.addPropertyResult("votingPolicy", "VotingPolicy", CfnMemberVotingPolicyPropertyFromCloudFormation(properties.VotingPolicy)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMember_NetworkFabricConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("edition", cdk.requiredValidator)(properties.edition)), errors.collect(cdk.propertyValidator("edition", cdk.validateString)(properties.edition)), errors.wrap('supplied properties not correct for "NetworkFabricConfigurationProperty"');
    }
    function cfnMemberNetworkFabricConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMember_NetworkFabricConfigurationPropertyValidator(properties).assertSuccess(), { Edition: cdk.stringToCloudFormation(properties.edition) }) : properties;
    }
    function CfnMemberNetworkFabricConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("edition", "Edition", cfn_parse.FromCloudFormation.getString(properties.Edition)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMember_NetworkFrameworkConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("networkFabricConfiguration", CfnMember_NetworkFabricConfigurationPropertyValidator)(properties.networkFabricConfiguration)), errors.wrap('supplied properties not correct for "NetworkFrameworkConfigurationProperty"');
    }
    function cfnMemberNetworkFrameworkConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMember_NetworkFrameworkConfigurationPropertyValidator(properties).assertSuccess(), { NetworkFabricConfiguration: cfnMemberNetworkFabricConfigurationPropertyToCloudFormation(properties.networkFabricConfiguration) }) : properties;
    }
    function CfnMemberNetworkFrameworkConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("networkFabricConfiguration", "NetworkFabricConfiguration", properties.NetworkFabricConfiguration != null ? CfnMemberNetworkFabricConfigurationPropertyFromCloudFormation(properties.NetworkFabricConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMember_VotingPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("approvalThresholdPolicy", CfnMember_ApprovalThresholdPolicyPropertyValidator)(properties.approvalThresholdPolicy)), errors.wrap('supplied properties not correct for "VotingPolicyProperty"');
    }
    function cfnMemberVotingPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMember_VotingPolicyPropertyValidator(properties).assertSuccess(), { ApprovalThresholdPolicy: cfnMemberApprovalThresholdPolicyPropertyToCloudFormation(properties.approvalThresholdPolicy) }) : properties;
    }
    function CfnMemberVotingPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("approvalThresholdPolicy", "ApprovalThresholdPolicy", properties.ApprovalThresholdPolicy != null ? CfnMemberApprovalThresholdPolicyPropertyFromCloudFormation(properties.ApprovalThresholdPolicy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnNodePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("memberId", cdk.validateString)(properties.memberId)), errors.collect(cdk.propertyValidator("networkId", cdk.requiredValidator)(properties.networkId)), errors.collect(cdk.propertyValidator("networkId", cdk.validateString)(properties.networkId)), errors.collect(cdk.propertyValidator("nodeConfiguration", cdk.requiredValidator)(properties.nodeConfiguration)), errors.collect(cdk.propertyValidator("nodeConfiguration", CfnNode_NodeConfigurationPropertyValidator)(properties.nodeConfiguration)), errors.wrap('supplied properties not correct for "CfnNodeProps"');
    }
    function cfnNodePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNodePropsValidator(properties).assertSuccess(), { NetworkId: cdk.stringToCloudFormation(properties.networkId), NodeConfiguration: cfnNodeNodeConfigurationPropertyToCloudFormation(properties.nodeConfiguration), MemberId: cdk.stringToCloudFormation(properties.memberId) }) : properties;
    }
    function CfnNodePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("networkId", "NetworkId", cfn_parse.FromCloudFormation.getString(properties.NetworkId)), ret.addPropertyResult("nodeConfiguration", "NodeConfiguration", CfnNodeNodeConfigurationPropertyFromCloudFormation(properties.NodeConfiguration)), ret.addPropertyResult("memberId", "MemberId", properties.MemberId != null ? cfn_parse.FromCloudFormation.getString(properties.MemberId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnNode = class _CfnNode extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnNodePropsFromCloudFormation(resourceProperties), ret = new _CfnNode(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnNode.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_managedblockchain_CfnNodeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnNode), error;
        }
        cdk.requireProperty(props, "networkId", this), cdk.requireProperty(props, "nodeConfiguration", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrMemberId = cdk.Token.asString(this.getAtt("MemberId", cdk.ResolutionTypeHint.STRING)), this.attrNetworkId = cdk.Token.asString(this.getAtt("NetworkId", cdk.ResolutionTypeHint.STRING)), this.attrNodeId = cdk.Token.asString(this.getAtt("NodeId", cdk.ResolutionTypeHint.STRING)), this.networkId = props.networkId, this.nodeConfiguration = props.nodeConfiguration, this.memberId = props.memberId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnNode.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { networkId: this.networkId, nodeConfiguration: this.nodeConfiguration, memberId: this.memberId };
      }
      renderProperties(props) {
        return cfnNodePropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnNode[_c] = { fqn: "aws-cdk-lib.aws_managedblockchain.CfnNode", version: "2.80.0" }, CfnNode.CFN_RESOURCE_TYPE_NAME = "AWS::ManagedBlockchain::Node", exports2.CfnNode = CfnNode;
    function CfnNode_NodeConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availabilityZone", cdk.requiredValidator)(properties.availabilityZone)), errors.collect(cdk.propertyValidator("availabilityZone", cdk.validateString)(properties.availabilityZone)), errors.collect(cdk.propertyValidator("instanceType", cdk.requiredValidator)(properties.instanceType)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.wrap('supplied properties not correct for "NodeConfigurationProperty"');
    }
    function cfnNodeNodeConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNode_NodeConfigurationPropertyValidator(properties).assertSuccess(), { AvailabilityZone: cdk.stringToCloudFormation(properties.availabilityZone), InstanceType: cdk.stringToCloudFormation(properties.instanceType) }) : properties;
    }
    function CfnNodeNodeConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("availabilityZone", "AvailabilityZone", cfn_parse.FromCloudFormation.getString(properties.AvailabilityZone)), ret.addPropertyResult("instanceType", "InstanceType", cfn_parse.FromCloudFormation.getString(properties.InstanceType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-managedblockchain/lib/index.js
var require_lib185 = __commonJS({
  "node_modules/aws-cdk-lib/aws-managedblockchain/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_managedblockchain_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-managedblockchain/index.js
var require_aws_managedblockchain = __commonJS({
  "node_modules/aws-cdk-lib/aws-managedblockchain/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib185(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-mediaconnect/lib/mediaconnect.generated.js
var require_mediaconnect_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-mediaconnect/lib/mediaconnect.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnFlowVpcInterface = exports2.CfnFlowSource = exports2.CfnFlowOutput = exports2.CfnFlowEntitlement = exports2.CfnFlow = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnFlowPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availabilityZone", cdk.validateString)(properties.availabilityZone)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("source", cdk.requiredValidator)(properties.source)), errors.collect(cdk.propertyValidator("source", CfnFlow_SourcePropertyValidator)(properties.source)), errors.collect(cdk.propertyValidator("sourceFailoverConfig", CfnFlow_FailoverConfigPropertyValidator)(properties.sourceFailoverConfig)), errors.wrap('supplied properties not correct for "CfnFlowProps"');
    }
    function cfnFlowPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlowPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Source: cfnFlowSourcePropertyToCloudFormation(properties.source), AvailabilityZone: cdk.stringToCloudFormation(properties.availabilityZone), SourceFailoverConfig: cfnFlowFailoverConfigPropertyToCloudFormation(properties.sourceFailoverConfig) }) : properties;
    }
    function CfnFlowPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("source", "Source", CfnFlowSourcePropertyFromCloudFormation(properties.Source)), ret.addPropertyResult("availabilityZone", "AvailabilityZone", properties.AvailabilityZone != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityZone) : void 0), ret.addPropertyResult("sourceFailoverConfig", "SourceFailoverConfig", properties.SourceFailoverConfig != null ? CfnFlowFailoverConfigPropertyFromCloudFormation(properties.SourceFailoverConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFlow = class _CfnFlow extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFlowPropsFromCloudFormation(resourceProperties), ret = new _CfnFlow(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFlow.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_mediaconnect_CfnFlowProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFlow), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "source", this), this.attrFlowArn = cdk.Token.asString(this.getAtt("FlowArn", cdk.ResolutionTypeHint.STRING)), this.attrFlowAvailabilityZone = cdk.Token.asString(this.getAtt("FlowAvailabilityZone", cdk.ResolutionTypeHint.STRING)), this.attrSourceIngestIp = cdk.Token.asString(this.getAtt("Source.IngestIp", cdk.ResolutionTypeHint.STRING)), this.attrSourceSourceArn = cdk.Token.asString(this.getAtt("Source.SourceArn", cdk.ResolutionTypeHint.STRING)), this.attrSourceSourceIngestPort = cdk.Token.asString(this.getAtt("Source.SourceIngestPort", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.source = props.source, this.availabilityZone = props.availabilityZone, this.sourceFailoverConfig = props.sourceFailoverConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFlow.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, source: this.source, availabilityZone: this.availabilityZone, sourceFailoverConfig: this.sourceFailoverConfig };
      }
      renderProperties(props) {
        return cfnFlowPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnFlow[_a] = { fqn: "aws-cdk-lib.aws_mediaconnect.CfnFlow", version: "2.80.0" }, CfnFlow.CFN_RESOURCE_TYPE_NAME = "AWS::MediaConnect::Flow", exports2.CfnFlow = CfnFlow;
    function CfnFlow_EncryptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("algorithm", cdk.validateString)(properties.algorithm)), errors.collect(cdk.propertyValidator("constantInitializationVector", cdk.validateString)(properties.constantInitializationVector)), errors.collect(cdk.propertyValidator("deviceId", cdk.validateString)(properties.deviceId)), errors.collect(cdk.propertyValidator("keyType", cdk.validateString)(properties.keyType)), errors.collect(cdk.propertyValidator("region", cdk.validateString)(properties.region)), errors.collect(cdk.propertyValidator("resourceId", cdk.validateString)(properties.resourceId)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("secretArn", cdk.validateString)(properties.secretArn)), errors.collect(cdk.propertyValidator("url", cdk.validateString)(properties.url)), errors.wrap('supplied properties not correct for "EncryptionProperty"');
    }
    function cfnFlowEncryptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_EncryptionPropertyValidator(properties).assertSuccess(), { Algorithm: cdk.stringToCloudFormation(properties.algorithm), ConstantInitializationVector: cdk.stringToCloudFormation(properties.constantInitializationVector), DeviceId: cdk.stringToCloudFormation(properties.deviceId), KeyType: cdk.stringToCloudFormation(properties.keyType), Region: cdk.stringToCloudFormation(properties.region), ResourceId: cdk.stringToCloudFormation(properties.resourceId), RoleArn: cdk.stringToCloudFormation(properties.roleArn), SecretArn: cdk.stringToCloudFormation(properties.secretArn), Url: cdk.stringToCloudFormation(properties.url) }) : properties;
    }
    function CfnFlowEncryptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("algorithm", "Algorithm", properties.Algorithm != null ? cfn_parse.FromCloudFormation.getString(properties.Algorithm) : void 0), ret.addPropertyResult("constantInitializationVector", "ConstantInitializationVector", properties.ConstantInitializationVector != null ? cfn_parse.FromCloudFormation.getString(properties.ConstantInitializationVector) : void 0), ret.addPropertyResult("deviceId", "DeviceId", properties.DeviceId != null ? cfn_parse.FromCloudFormation.getString(properties.DeviceId) : void 0), ret.addPropertyResult("keyType", "KeyType", properties.KeyType != null ? cfn_parse.FromCloudFormation.getString(properties.KeyType) : void 0), ret.addPropertyResult("region", "Region", properties.Region != null ? cfn_parse.FromCloudFormation.getString(properties.Region) : void 0), ret.addPropertyResult("resourceId", "ResourceId", properties.ResourceId != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceId) : void 0), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("secretArn", "SecretArn", properties.SecretArn != null ? cfn_parse.FromCloudFormation.getString(properties.SecretArn) : void 0), ret.addPropertyResult("url", "Url", properties.Url != null ? cfn_parse.FromCloudFormation.getString(properties.Url) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_FailoverConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("failoverMode", cdk.validateString)(properties.failoverMode)), errors.collect(cdk.propertyValidator("recoveryWindow", cdk.validateNumber)(properties.recoveryWindow)), errors.collect(cdk.propertyValidator("sourcePriority", CfnFlow_SourcePriorityPropertyValidator)(properties.sourcePriority)), errors.collect(cdk.propertyValidator("state", cdk.validateString)(properties.state)), errors.wrap('supplied properties not correct for "FailoverConfigProperty"');
    }
    function cfnFlowFailoverConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_FailoverConfigPropertyValidator(properties).assertSuccess(), { FailoverMode: cdk.stringToCloudFormation(properties.failoverMode), RecoveryWindow: cdk.numberToCloudFormation(properties.recoveryWindow), SourcePriority: cfnFlowSourcePriorityPropertyToCloudFormation(properties.sourcePriority), State: cdk.stringToCloudFormation(properties.state) }) : properties;
    }
    function CfnFlowFailoverConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("failoverMode", "FailoverMode", properties.FailoverMode != null ? cfn_parse.FromCloudFormation.getString(properties.FailoverMode) : void 0), ret.addPropertyResult("recoveryWindow", "RecoveryWindow", properties.RecoveryWindow != null ? cfn_parse.FromCloudFormation.getNumber(properties.RecoveryWindow) : void 0), ret.addPropertyResult("sourcePriority", "SourcePriority", properties.SourcePriority != null ? CfnFlowSourcePriorityPropertyFromCloudFormation(properties.SourcePriority) : void 0), ret.addPropertyResult("state", "State", properties.State != null ? cfn_parse.FromCloudFormation.getString(properties.State) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_SourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("decryption", CfnFlow_EncryptionPropertyValidator)(properties.decryption)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("entitlementArn", cdk.validateString)(properties.entitlementArn)), errors.collect(cdk.propertyValidator("ingestIp", cdk.validateString)(properties.ingestIp)), errors.collect(cdk.propertyValidator("ingestPort", cdk.validateNumber)(properties.ingestPort)), errors.collect(cdk.propertyValidator("maxBitrate", cdk.validateNumber)(properties.maxBitrate)), errors.collect(cdk.propertyValidator("maxLatency", cdk.validateNumber)(properties.maxLatency)), errors.collect(cdk.propertyValidator("minLatency", cdk.validateNumber)(properties.minLatency)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.collect(cdk.propertyValidator("senderControlPort", cdk.validateNumber)(properties.senderControlPort)), errors.collect(cdk.propertyValidator("senderIpAddress", cdk.validateString)(properties.senderIpAddress)), errors.collect(cdk.propertyValidator("sourceArn", cdk.validateString)(properties.sourceArn)), errors.collect(cdk.propertyValidator("sourceIngestPort", cdk.validateString)(properties.sourceIngestPort)), errors.collect(cdk.propertyValidator("sourceListenerAddress", cdk.validateString)(properties.sourceListenerAddress)), errors.collect(cdk.propertyValidator("sourceListenerPort", cdk.validateNumber)(properties.sourceListenerPort)), errors.collect(cdk.propertyValidator("streamId", cdk.validateString)(properties.streamId)), errors.collect(cdk.propertyValidator("vpcInterfaceName", cdk.validateString)(properties.vpcInterfaceName)), errors.collect(cdk.propertyValidator("whitelistCidr", cdk.validateString)(properties.whitelistCidr)), errors.wrap('supplied properties not correct for "SourceProperty"');
    }
    function cfnFlowSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_SourcePropertyValidator(properties).assertSuccess(), { Decryption: cfnFlowEncryptionPropertyToCloudFormation(properties.decryption), Description: cdk.stringToCloudFormation(properties.description), EntitlementArn: cdk.stringToCloudFormation(properties.entitlementArn), IngestIp: cdk.stringToCloudFormation(properties.ingestIp), IngestPort: cdk.numberToCloudFormation(properties.ingestPort), MaxBitrate: cdk.numberToCloudFormation(properties.maxBitrate), MaxLatency: cdk.numberToCloudFormation(properties.maxLatency), MinLatency: cdk.numberToCloudFormation(properties.minLatency), Name: cdk.stringToCloudFormation(properties.name), Protocol: cdk.stringToCloudFormation(properties.protocol), SenderControlPort: cdk.numberToCloudFormation(properties.senderControlPort), SenderIpAddress: cdk.stringToCloudFormation(properties.senderIpAddress), SourceArn: cdk.stringToCloudFormation(properties.sourceArn), SourceIngestPort: cdk.stringToCloudFormation(properties.sourceIngestPort), SourceListenerAddress: cdk.stringToCloudFormation(properties.sourceListenerAddress), SourceListenerPort: cdk.numberToCloudFormation(properties.sourceListenerPort), StreamId: cdk.stringToCloudFormation(properties.streamId), VpcInterfaceName: cdk.stringToCloudFormation(properties.vpcInterfaceName), WhitelistCidr: cdk.stringToCloudFormation(properties.whitelistCidr) }) : properties;
    }
    function CfnFlowSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("decryption", "Decryption", properties.Decryption != null ? CfnFlowEncryptionPropertyFromCloudFormation(properties.Decryption) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("entitlementArn", "EntitlementArn", properties.EntitlementArn != null ? cfn_parse.FromCloudFormation.getString(properties.EntitlementArn) : void 0), ret.addPropertyResult("ingestIp", "IngestIp", properties.IngestIp != null ? cfn_parse.FromCloudFormation.getString(properties.IngestIp) : void 0), ret.addPropertyResult("ingestPort", "IngestPort", properties.IngestPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.IngestPort) : void 0), ret.addPropertyResult("maxBitrate", "MaxBitrate", properties.MaxBitrate != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxBitrate) : void 0), ret.addPropertyResult("maxLatency", "MaxLatency", properties.MaxLatency != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxLatency) : void 0), ret.addPropertyResult("minLatency", "MinLatency", properties.MinLatency != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinLatency) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("protocol", "Protocol", properties.Protocol != null ? cfn_parse.FromCloudFormation.getString(properties.Protocol) : void 0), ret.addPropertyResult("senderControlPort", "SenderControlPort", properties.SenderControlPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.SenderControlPort) : void 0), ret.addPropertyResult("senderIpAddress", "SenderIpAddress", properties.SenderIpAddress != null ? cfn_parse.FromCloudFormation.getString(properties.SenderIpAddress) : void 0), ret.addPropertyResult("sourceArn", "SourceArn", properties.SourceArn != null ? cfn_parse.FromCloudFormation.getString(properties.SourceArn) : void 0), ret.addPropertyResult("sourceIngestPort", "SourceIngestPort", properties.SourceIngestPort != null ? cfn_parse.FromCloudFormation.getString(properties.SourceIngestPort) : void 0), ret.addPropertyResult("sourceListenerAddress", "SourceListenerAddress", properties.SourceListenerAddress != null ? cfn_parse.FromCloudFormation.getString(properties.SourceListenerAddress) : void 0), ret.addPropertyResult("sourceListenerPort", "SourceListenerPort", properties.SourceListenerPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.SourceListenerPort) : void 0), ret.addPropertyResult("streamId", "StreamId", properties.StreamId != null ? cfn_parse.FromCloudFormation.getString(properties.StreamId) : void 0), ret.addPropertyResult("vpcInterfaceName", "VpcInterfaceName", properties.VpcInterfaceName != null ? cfn_parse.FromCloudFormation.getString(properties.VpcInterfaceName) : void 0), ret.addPropertyResult("whitelistCidr", "WhitelistCidr", properties.WhitelistCidr != null ? cfn_parse.FromCloudFormation.getString(properties.WhitelistCidr) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlow_SourcePriorityPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("primarySource", cdk.requiredValidator)(properties.primarySource)), errors.collect(cdk.propertyValidator("primarySource", cdk.validateString)(properties.primarySource)), errors.wrap('supplied properties not correct for "SourcePriorityProperty"');
    }
    function cfnFlowSourcePriorityPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlow_SourcePriorityPropertyValidator(properties).assertSuccess(), { PrimarySource: cdk.stringToCloudFormation(properties.primarySource) }) : properties;
    }
    function CfnFlowSourcePriorityPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("primarySource", "PrimarySource", cfn_parse.FromCloudFormation.getString(properties.PrimarySource)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlowEntitlementPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataTransferSubscriberFeePercent", cdk.validateNumber)(properties.dataTransferSubscriberFeePercent)), errors.collect(cdk.propertyValidator("description", cdk.requiredValidator)(properties.description)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("encryption", CfnFlowEntitlement_EncryptionPropertyValidator)(properties.encryption)), errors.collect(cdk.propertyValidator("entitlementStatus", cdk.validateString)(properties.entitlementStatus)), errors.collect(cdk.propertyValidator("flowArn", cdk.requiredValidator)(properties.flowArn)), errors.collect(cdk.propertyValidator("flowArn", cdk.validateString)(properties.flowArn)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("subscribers", cdk.requiredValidator)(properties.subscribers)), errors.collect(cdk.propertyValidator("subscribers", cdk.listValidator(cdk.validateString))(properties.subscribers)), errors.wrap('supplied properties not correct for "CfnFlowEntitlementProps"');
    }
    function cfnFlowEntitlementPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlowEntitlementPropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), FlowArn: cdk.stringToCloudFormation(properties.flowArn), Name: cdk.stringToCloudFormation(properties.name), Subscribers: cdk.listMapper(cdk.stringToCloudFormation)(properties.subscribers), DataTransferSubscriberFeePercent: cdk.numberToCloudFormation(properties.dataTransferSubscriberFeePercent), Encryption: cfnFlowEntitlementEncryptionPropertyToCloudFormation(properties.encryption), EntitlementStatus: cdk.stringToCloudFormation(properties.entitlementStatus) }) : properties;
    }
    function CfnFlowEntitlementPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", cfn_parse.FromCloudFormation.getString(properties.Description)), ret.addPropertyResult("flowArn", "FlowArn", cfn_parse.FromCloudFormation.getString(properties.FlowArn)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("subscribers", "Subscribers", cfn_parse.FromCloudFormation.getStringArray(properties.Subscribers)), ret.addPropertyResult("dataTransferSubscriberFeePercent", "DataTransferSubscriberFeePercent", properties.DataTransferSubscriberFeePercent != null ? cfn_parse.FromCloudFormation.getNumber(properties.DataTransferSubscriberFeePercent) : void 0), ret.addPropertyResult("encryption", "Encryption", properties.Encryption != null ? CfnFlowEntitlementEncryptionPropertyFromCloudFormation(properties.Encryption) : void 0), ret.addPropertyResult("entitlementStatus", "EntitlementStatus", properties.EntitlementStatus != null ? cfn_parse.FromCloudFormation.getString(properties.EntitlementStatus) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFlowEntitlement = class _CfnFlowEntitlement extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFlowEntitlementPropsFromCloudFormation(resourceProperties), ret = new _CfnFlowEntitlement(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFlowEntitlement.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_mediaconnect_CfnFlowEntitlementProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFlowEntitlement), error;
        }
        cdk.requireProperty(props, "description", this), cdk.requireProperty(props, "flowArn", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "subscribers", this), this.attrEntitlementArn = cdk.Token.asString(this.getAtt("EntitlementArn", cdk.ResolutionTypeHint.STRING)), this.description = props.description, this.flowArn = props.flowArn, this.name = props.name, this.subscribers = props.subscribers, this.dataTransferSubscriberFeePercent = props.dataTransferSubscriberFeePercent, this.encryption = props.encryption, this.entitlementStatus = props.entitlementStatus;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFlowEntitlement.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, flowArn: this.flowArn, name: this.name, subscribers: this.subscribers, dataTransferSubscriberFeePercent: this.dataTransferSubscriberFeePercent, encryption: this.encryption, entitlementStatus: this.entitlementStatus };
      }
      renderProperties(props) {
        return cfnFlowEntitlementPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnFlowEntitlement[_b] = { fqn: "aws-cdk-lib.aws_mediaconnect.CfnFlowEntitlement", version: "2.80.0" }, CfnFlowEntitlement.CFN_RESOURCE_TYPE_NAME = "AWS::MediaConnect::FlowEntitlement", exports2.CfnFlowEntitlement = CfnFlowEntitlement;
    function CfnFlowEntitlement_EncryptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("algorithm", cdk.requiredValidator)(properties.algorithm)), errors.collect(cdk.propertyValidator("algorithm", cdk.validateString)(properties.algorithm)), errors.collect(cdk.propertyValidator("constantInitializationVector", cdk.validateString)(properties.constantInitializationVector)), errors.collect(cdk.propertyValidator("deviceId", cdk.validateString)(properties.deviceId)), errors.collect(cdk.propertyValidator("keyType", cdk.validateString)(properties.keyType)), errors.collect(cdk.propertyValidator("region", cdk.validateString)(properties.region)), errors.collect(cdk.propertyValidator("resourceId", cdk.validateString)(properties.resourceId)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("secretArn", cdk.validateString)(properties.secretArn)), errors.collect(cdk.propertyValidator("url", cdk.validateString)(properties.url)), errors.wrap('supplied properties not correct for "EncryptionProperty"');
    }
    function cfnFlowEntitlementEncryptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlowEntitlement_EncryptionPropertyValidator(properties).assertSuccess(), { Algorithm: cdk.stringToCloudFormation(properties.algorithm), ConstantInitializationVector: cdk.stringToCloudFormation(properties.constantInitializationVector), DeviceId: cdk.stringToCloudFormation(properties.deviceId), KeyType: cdk.stringToCloudFormation(properties.keyType), Region: cdk.stringToCloudFormation(properties.region), ResourceId: cdk.stringToCloudFormation(properties.resourceId), RoleArn: cdk.stringToCloudFormation(properties.roleArn), SecretArn: cdk.stringToCloudFormation(properties.secretArn), Url: cdk.stringToCloudFormation(properties.url) }) : properties;
    }
    function CfnFlowEntitlementEncryptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("algorithm", "Algorithm", cfn_parse.FromCloudFormation.getString(properties.Algorithm)), ret.addPropertyResult("constantInitializationVector", "ConstantInitializationVector", properties.ConstantInitializationVector != null ? cfn_parse.FromCloudFormation.getString(properties.ConstantInitializationVector) : void 0), ret.addPropertyResult("deviceId", "DeviceId", properties.DeviceId != null ? cfn_parse.FromCloudFormation.getString(properties.DeviceId) : void 0), ret.addPropertyResult("keyType", "KeyType", properties.KeyType != null ? cfn_parse.FromCloudFormation.getString(properties.KeyType) : void 0), ret.addPropertyResult("region", "Region", properties.Region != null ? cfn_parse.FromCloudFormation.getString(properties.Region) : void 0), ret.addPropertyResult("resourceId", "ResourceId", properties.ResourceId != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceId) : void 0), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("secretArn", "SecretArn", properties.SecretArn != null ? cfn_parse.FromCloudFormation.getString(properties.SecretArn) : void 0), ret.addPropertyResult("url", "Url", properties.Url != null ? cfn_parse.FromCloudFormation.getString(properties.Url) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlowOutputPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cidrAllowList", cdk.listValidator(cdk.validateString))(properties.cidrAllowList)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("destination", cdk.validateString)(properties.destination)), errors.collect(cdk.propertyValidator("encryption", CfnFlowOutput_EncryptionPropertyValidator)(properties.encryption)), errors.collect(cdk.propertyValidator("flowArn", cdk.requiredValidator)(properties.flowArn)), errors.collect(cdk.propertyValidator("flowArn", cdk.validateString)(properties.flowArn)), errors.collect(cdk.propertyValidator("maxLatency", cdk.validateNumber)(properties.maxLatency)), errors.collect(cdk.propertyValidator("minLatency", cdk.validateNumber)(properties.minLatency)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("protocol", cdk.requiredValidator)(properties.protocol)), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.collect(cdk.propertyValidator("remoteId", cdk.validateString)(properties.remoteId)), errors.collect(cdk.propertyValidator("smoothingLatency", cdk.validateNumber)(properties.smoothingLatency)), errors.collect(cdk.propertyValidator("streamId", cdk.validateString)(properties.streamId)), errors.collect(cdk.propertyValidator("vpcInterfaceAttachment", CfnFlowOutput_VpcInterfaceAttachmentPropertyValidator)(properties.vpcInterfaceAttachment)), errors.wrap('supplied properties not correct for "CfnFlowOutputProps"');
    }
    function cfnFlowOutputPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlowOutputPropsValidator(properties).assertSuccess(), { FlowArn: cdk.stringToCloudFormation(properties.flowArn), Protocol: cdk.stringToCloudFormation(properties.protocol), CidrAllowList: cdk.listMapper(cdk.stringToCloudFormation)(properties.cidrAllowList), Description: cdk.stringToCloudFormation(properties.description), Destination: cdk.stringToCloudFormation(properties.destination), Encryption: cfnFlowOutputEncryptionPropertyToCloudFormation(properties.encryption), MaxLatency: cdk.numberToCloudFormation(properties.maxLatency), MinLatency: cdk.numberToCloudFormation(properties.minLatency), Name: cdk.stringToCloudFormation(properties.name), Port: cdk.numberToCloudFormation(properties.port), RemoteId: cdk.stringToCloudFormation(properties.remoteId), SmoothingLatency: cdk.numberToCloudFormation(properties.smoothingLatency), StreamId: cdk.stringToCloudFormation(properties.streamId), VpcInterfaceAttachment: cfnFlowOutputVpcInterfaceAttachmentPropertyToCloudFormation(properties.vpcInterfaceAttachment) }) : properties;
    }
    function CfnFlowOutputPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("flowArn", "FlowArn", cfn_parse.FromCloudFormation.getString(properties.FlowArn)), ret.addPropertyResult("protocol", "Protocol", cfn_parse.FromCloudFormation.getString(properties.Protocol)), ret.addPropertyResult("cidrAllowList", "CidrAllowList", properties.CidrAllowList != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CidrAllowList) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("destination", "Destination", properties.Destination != null ? cfn_parse.FromCloudFormation.getString(properties.Destination) : void 0), ret.addPropertyResult("encryption", "Encryption", properties.Encryption != null ? CfnFlowOutputEncryptionPropertyFromCloudFormation(properties.Encryption) : void 0), ret.addPropertyResult("maxLatency", "MaxLatency", properties.MaxLatency != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxLatency) : void 0), ret.addPropertyResult("minLatency", "MinLatency", properties.MinLatency != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinLatency) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addPropertyResult("remoteId", "RemoteId", properties.RemoteId != null ? cfn_parse.FromCloudFormation.getString(properties.RemoteId) : void 0), ret.addPropertyResult("smoothingLatency", "SmoothingLatency", properties.SmoothingLatency != null ? cfn_parse.FromCloudFormation.getNumber(properties.SmoothingLatency) : void 0), ret.addPropertyResult("streamId", "StreamId", properties.StreamId != null ? cfn_parse.FromCloudFormation.getString(properties.StreamId) : void 0), ret.addPropertyResult("vpcInterfaceAttachment", "VpcInterfaceAttachment", properties.VpcInterfaceAttachment != null ? CfnFlowOutputVpcInterfaceAttachmentPropertyFromCloudFormation(properties.VpcInterfaceAttachment) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFlowOutput = class _CfnFlowOutput extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFlowOutputPropsFromCloudFormation(resourceProperties), ret = new _CfnFlowOutput(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFlowOutput.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_mediaconnect_CfnFlowOutputProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFlowOutput), error;
        }
        cdk.requireProperty(props, "flowArn", this), cdk.requireProperty(props, "protocol", this), this.attrOutputArn = cdk.Token.asString(this.getAtt("OutputArn", cdk.ResolutionTypeHint.STRING)), this.flowArn = props.flowArn, this.protocol = props.protocol, this.cidrAllowList = props.cidrAllowList, this.description = props.description, this.destination = props.destination, this.encryption = props.encryption, this.maxLatency = props.maxLatency, this.minLatency = props.minLatency, this.name = props.name, this.port = props.port, this.remoteId = props.remoteId, this.smoothingLatency = props.smoothingLatency, this.streamId = props.streamId, this.vpcInterfaceAttachment = props.vpcInterfaceAttachment;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFlowOutput.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { flowArn: this.flowArn, protocol: this.protocol, cidrAllowList: this.cidrAllowList, description: this.description, destination: this.destination, encryption: this.encryption, maxLatency: this.maxLatency, minLatency: this.minLatency, name: this.name, port: this.port, remoteId: this.remoteId, smoothingLatency: this.smoothingLatency, streamId: this.streamId, vpcInterfaceAttachment: this.vpcInterfaceAttachment };
      }
      renderProperties(props) {
        return cfnFlowOutputPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnFlowOutput[_c] = { fqn: "aws-cdk-lib.aws_mediaconnect.CfnFlowOutput", version: "2.80.0" }, CfnFlowOutput.CFN_RESOURCE_TYPE_NAME = "AWS::MediaConnect::FlowOutput", exports2.CfnFlowOutput = CfnFlowOutput;
    function CfnFlowOutput_EncryptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("algorithm", cdk.validateString)(properties.algorithm)), errors.collect(cdk.propertyValidator("keyType", cdk.validateString)(properties.keyType)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("secretArn", cdk.requiredValidator)(properties.secretArn)), errors.collect(cdk.propertyValidator("secretArn", cdk.validateString)(properties.secretArn)), errors.wrap('supplied properties not correct for "EncryptionProperty"');
    }
    function cfnFlowOutputEncryptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlowOutput_EncryptionPropertyValidator(properties).assertSuccess(), { Algorithm: cdk.stringToCloudFormation(properties.algorithm), KeyType: cdk.stringToCloudFormation(properties.keyType), RoleArn: cdk.stringToCloudFormation(properties.roleArn), SecretArn: cdk.stringToCloudFormation(properties.secretArn) }) : properties;
    }
    function CfnFlowOutputEncryptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("algorithm", "Algorithm", properties.Algorithm != null ? cfn_parse.FromCloudFormation.getString(properties.Algorithm) : void 0), ret.addPropertyResult("keyType", "KeyType", properties.KeyType != null ? cfn_parse.FromCloudFormation.getString(properties.KeyType) : void 0), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("secretArn", "SecretArn", cfn_parse.FromCloudFormation.getString(properties.SecretArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlowOutput_VpcInterfaceAttachmentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("vpcInterfaceName", cdk.validateString)(properties.vpcInterfaceName)), errors.wrap('supplied properties not correct for "VpcInterfaceAttachmentProperty"');
    }
    function cfnFlowOutputVpcInterfaceAttachmentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlowOutput_VpcInterfaceAttachmentPropertyValidator(properties).assertSuccess(), { VpcInterfaceName: cdk.stringToCloudFormation(properties.vpcInterfaceName) }) : properties;
    }
    function CfnFlowOutputVpcInterfaceAttachmentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("vpcInterfaceName", "VpcInterfaceName", properties.VpcInterfaceName != null ? cfn_parse.FromCloudFormation.getString(properties.VpcInterfaceName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlowSourcePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("decryption", CfnFlowSource_EncryptionPropertyValidator)(properties.decryption)), errors.collect(cdk.propertyValidator("description", cdk.requiredValidator)(properties.description)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("entitlementArn", cdk.validateString)(properties.entitlementArn)), errors.collect(cdk.propertyValidator("flowArn", cdk.validateString)(properties.flowArn)), errors.collect(cdk.propertyValidator("ingestPort", cdk.validateNumber)(properties.ingestPort)), errors.collect(cdk.propertyValidator("maxBitrate", cdk.validateNumber)(properties.maxBitrate)), errors.collect(cdk.propertyValidator("maxLatency", cdk.validateNumber)(properties.maxLatency)), errors.collect(cdk.propertyValidator("minLatency", cdk.validateNumber)(properties.minLatency)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.collect(cdk.propertyValidator("senderControlPort", cdk.validateNumber)(properties.senderControlPort)), errors.collect(cdk.propertyValidator("senderIpAddress", cdk.validateString)(properties.senderIpAddress)), errors.collect(cdk.propertyValidator("sourceListenerAddress", cdk.validateString)(properties.sourceListenerAddress)), errors.collect(cdk.propertyValidator("sourceListenerPort", cdk.validateNumber)(properties.sourceListenerPort)), errors.collect(cdk.propertyValidator("streamId", cdk.validateString)(properties.streamId)), errors.collect(cdk.propertyValidator("vpcInterfaceName", cdk.validateString)(properties.vpcInterfaceName)), errors.collect(cdk.propertyValidator("whitelistCidr", cdk.validateString)(properties.whitelistCidr)), errors.wrap('supplied properties not correct for "CfnFlowSourceProps"');
    }
    function cfnFlowSourcePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlowSourcePropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), Name: cdk.stringToCloudFormation(properties.name), Decryption: cfnFlowSourceEncryptionPropertyToCloudFormation(properties.decryption), EntitlementArn: cdk.stringToCloudFormation(properties.entitlementArn), FlowArn: cdk.stringToCloudFormation(properties.flowArn), IngestPort: cdk.numberToCloudFormation(properties.ingestPort), MaxBitrate: cdk.numberToCloudFormation(properties.maxBitrate), MaxLatency: cdk.numberToCloudFormation(properties.maxLatency), MinLatency: cdk.numberToCloudFormation(properties.minLatency), Protocol: cdk.stringToCloudFormation(properties.protocol), SenderControlPort: cdk.numberToCloudFormation(properties.senderControlPort), SenderIpAddress: cdk.stringToCloudFormation(properties.senderIpAddress), SourceListenerAddress: cdk.stringToCloudFormation(properties.sourceListenerAddress), SourceListenerPort: cdk.numberToCloudFormation(properties.sourceListenerPort), StreamId: cdk.stringToCloudFormation(properties.streamId), VpcInterfaceName: cdk.stringToCloudFormation(properties.vpcInterfaceName), WhitelistCidr: cdk.stringToCloudFormation(properties.whitelistCidr) }) : properties;
    }
    function CfnFlowSourcePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", cfn_parse.FromCloudFormation.getString(properties.Description)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("decryption", "Decryption", properties.Decryption != null ? CfnFlowSourceEncryptionPropertyFromCloudFormation(properties.Decryption) : void 0), ret.addPropertyResult("entitlementArn", "EntitlementArn", properties.EntitlementArn != null ? cfn_parse.FromCloudFormation.getString(properties.EntitlementArn) : void 0), ret.addPropertyResult("flowArn", "FlowArn", properties.FlowArn != null ? cfn_parse.FromCloudFormation.getString(properties.FlowArn) : void 0), ret.addPropertyResult("ingestPort", "IngestPort", properties.IngestPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.IngestPort) : void 0), ret.addPropertyResult("maxBitrate", "MaxBitrate", properties.MaxBitrate != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxBitrate) : void 0), ret.addPropertyResult("maxLatency", "MaxLatency", properties.MaxLatency != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxLatency) : void 0), ret.addPropertyResult("minLatency", "MinLatency", properties.MinLatency != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinLatency) : void 0), ret.addPropertyResult("protocol", "Protocol", properties.Protocol != null ? cfn_parse.FromCloudFormation.getString(properties.Protocol) : void 0), ret.addPropertyResult("senderControlPort", "SenderControlPort", properties.SenderControlPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.SenderControlPort) : void 0), ret.addPropertyResult("senderIpAddress", "SenderIpAddress", properties.SenderIpAddress != null ? cfn_parse.FromCloudFormation.getString(properties.SenderIpAddress) : void 0), ret.addPropertyResult("sourceListenerAddress", "SourceListenerAddress", properties.SourceListenerAddress != null ? cfn_parse.FromCloudFormation.getString(properties.SourceListenerAddress) : void 0), ret.addPropertyResult("sourceListenerPort", "SourceListenerPort", properties.SourceListenerPort != null ? cfn_parse.FromCloudFormation.getNumber(properties.SourceListenerPort) : void 0), ret.addPropertyResult("streamId", "StreamId", properties.StreamId != null ? cfn_parse.FromCloudFormation.getString(properties.StreamId) : void 0), ret.addPropertyResult("vpcInterfaceName", "VpcInterfaceName", properties.VpcInterfaceName != null ? cfn_parse.FromCloudFormation.getString(properties.VpcInterfaceName) : void 0), ret.addPropertyResult("whitelistCidr", "WhitelistCidr", properties.WhitelistCidr != null ? cfn_parse.FromCloudFormation.getString(properties.WhitelistCidr) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFlowSource = class _CfnFlowSource extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFlowSourcePropsFromCloudFormation(resourceProperties), ret = new _CfnFlowSource(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFlowSource.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_mediaconnect_CfnFlowSourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFlowSource), error;
        }
        cdk.requireProperty(props, "description", this), cdk.requireProperty(props, "name", this), this.attrIngestIp = cdk.Token.asString(this.getAtt("IngestIp", cdk.ResolutionTypeHint.STRING)), this.attrSourceArn = cdk.Token.asString(this.getAtt("SourceArn", cdk.ResolutionTypeHint.STRING)), this.attrSourceIngestPort = cdk.Token.asString(this.getAtt("SourceIngestPort", cdk.ResolutionTypeHint.STRING)), this.description = props.description, this.name = props.name, this.decryption = props.decryption, this.entitlementArn = props.entitlementArn, this.flowArn = props.flowArn, this.ingestPort = props.ingestPort, this.maxBitrate = props.maxBitrate, this.maxLatency = props.maxLatency, this.minLatency = props.minLatency, this.protocol = props.protocol, this.senderControlPort = props.senderControlPort, this.senderIpAddress = props.senderIpAddress, this.sourceListenerAddress = props.sourceListenerAddress, this.sourceListenerPort = props.sourceListenerPort, this.streamId = props.streamId, this.vpcInterfaceName = props.vpcInterfaceName, this.whitelistCidr = props.whitelistCidr;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFlowSource.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, name: this.name, decryption: this.decryption, entitlementArn: this.entitlementArn, flowArn: this.flowArn, ingestPort: this.ingestPort, maxBitrate: this.maxBitrate, maxLatency: this.maxLatency, minLatency: this.minLatency, protocol: this.protocol, senderControlPort: this.senderControlPort, senderIpAddress: this.senderIpAddress, sourceListenerAddress: this.sourceListenerAddress, sourceListenerPort: this.sourceListenerPort, streamId: this.streamId, vpcInterfaceName: this.vpcInterfaceName, whitelistCidr: this.whitelistCidr };
      }
      renderProperties(props) {
        return cfnFlowSourcePropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnFlowSource[_d] = { fqn: "aws-cdk-lib.aws_mediaconnect.CfnFlowSource", version: "2.80.0" }, CfnFlowSource.CFN_RESOURCE_TYPE_NAME = "AWS::MediaConnect::FlowSource", exports2.CfnFlowSource = CfnFlowSource;
    function CfnFlowSource_EncryptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("algorithm", cdk.validateString)(properties.algorithm)), errors.collect(cdk.propertyValidator("constantInitializationVector", cdk.validateString)(properties.constantInitializationVector)), errors.collect(cdk.propertyValidator("deviceId", cdk.validateString)(properties.deviceId)), errors.collect(cdk.propertyValidator("keyType", cdk.validateString)(properties.keyType)), errors.collect(cdk.propertyValidator("region", cdk.validateString)(properties.region)), errors.collect(cdk.propertyValidator("resourceId", cdk.validateString)(properties.resourceId)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("secretArn", cdk.validateString)(properties.secretArn)), errors.collect(cdk.propertyValidator("url", cdk.validateString)(properties.url)), errors.wrap('supplied properties not correct for "EncryptionProperty"');
    }
    function cfnFlowSourceEncryptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlowSource_EncryptionPropertyValidator(properties).assertSuccess(), { Algorithm: cdk.stringToCloudFormation(properties.algorithm), ConstantInitializationVector: cdk.stringToCloudFormation(properties.constantInitializationVector), DeviceId: cdk.stringToCloudFormation(properties.deviceId), KeyType: cdk.stringToCloudFormation(properties.keyType), Region: cdk.stringToCloudFormation(properties.region), ResourceId: cdk.stringToCloudFormation(properties.resourceId), RoleArn: cdk.stringToCloudFormation(properties.roleArn), SecretArn: cdk.stringToCloudFormation(properties.secretArn), Url: cdk.stringToCloudFormation(properties.url) }) : properties;
    }
    function CfnFlowSourceEncryptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("algorithm", "Algorithm", properties.Algorithm != null ? cfn_parse.FromCloudFormation.getString(properties.Algorithm) : void 0), ret.addPropertyResult("constantInitializationVector", "ConstantInitializationVector", properties.ConstantInitializationVector != null ? cfn_parse.FromCloudFormation.getString(properties.ConstantInitializationVector) : void 0), ret.addPropertyResult("deviceId", "DeviceId", properties.DeviceId != null ? cfn_parse.FromCloudFormation.getString(properties.DeviceId) : void 0), ret.addPropertyResult("keyType", "KeyType", properties.KeyType != null ? cfn_parse.FromCloudFormation.getString(properties.KeyType) : void 0), ret.addPropertyResult("region", "Region", properties.Region != null ? cfn_parse.FromCloudFormation.getString(properties.Region) : void 0), ret.addPropertyResult("resourceId", "ResourceId", properties.ResourceId != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceId) : void 0), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("secretArn", "SecretArn", properties.SecretArn != null ? cfn_parse.FromCloudFormation.getString(properties.SecretArn) : void 0), ret.addPropertyResult("url", "Url", properties.Url != null ? cfn_parse.FromCloudFormation.getString(properties.Url) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFlowVpcInterfacePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("flowArn", cdk.requiredValidator)(properties.flowArn)), errors.collect(cdk.propertyValidator("flowArn", cdk.validateString)(properties.flowArn)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.requiredValidator)(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnetId", cdk.requiredValidator)(properties.subnetId)), errors.collect(cdk.propertyValidator("subnetId", cdk.validateString)(properties.subnetId)), errors.wrap('supplied properties not correct for "CfnFlowVpcInterfaceProps"');
    }
    function cfnFlowVpcInterfacePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFlowVpcInterfacePropsValidator(properties).assertSuccess(), { FlowArn: cdk.stringToCloudFormation(properties.flowArn), Name: cdk.stringToCloudFormation(properties.name), RoleArn: cdk.stringToCloudFormation(properties.roleArn), SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SubnetId: cdk.stringToCloudFormation(properties.subnetId) }) : properties;
    }
    function CfnFlowVpcInterfacePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("flowArn", "FlowArn", cfn_parse.FromCloudFormation.getString(properties.FlowArn)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds)), ret.addPropertyResult("subnetId", "SubnetId", cfn_parse.FromCloudFormation.getString(properties.SubnetId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFlowVpcInterface = class _CfnFlowVpcInterface extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFlowVpcInterfacePropsFromCloudFormation(resourceProperties), ret = new _CfnFlowVpcInterface(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFlowVpcInterface.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_mediaconnect_CfnFlowVpcInterfaceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFlowVpcInterface), error;
        }
        cdk.requireProperty(props, "flowArn", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "roleArn", this), cdk.requireProperty(props, "securityGroupIds", this), cdk.requireProperty(props, "subnetId", this), this.attrNetworkInterfaceIds = cdk.Token.asList(this.getAtt("NetworkInterfaceIds", cdk.ResolutionTypeHint.STRING_LIST)), this.flowArn = props.flowArn, this.name = props.name, this.roleArn = props.roleArn, this.securityGroupIds = props.securityGroupIds, this.subnetId = props.subnetId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFlowVpcInterface.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { flowArn: this.flowArn, name: this.name, roleArn: this.roleArn, securityGroupIds: this.securityGroupIds, subnetId: this.subnetId };
      }
      renderProperties(props) {
        return cfnFlowVpcInterfacePropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnFlowVpcInterface[_e] = { fqn: "aws-cdk-lib.aws_mediaconnect.CfnFlowVpcInterface", version: "2.80.0" }, CfnFlowVpcInterface.CFN_RESOURCE_TYPE_NAME = "AWS::MediaConnect::FlowVpcInterface", exports2.CfnFlowVpcInterface = CfnFlowVpcInterface;
  }
});

// node_modules/aws-cdk-lib/aws-mediaconnect/lib/index.js
var require_lib186 = __commonJS({
  "node_modules/aws-cdk-lib/aws-mediaconnect/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_mediaconnect_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-mediaconnect/index.js
var require_aws_mediaconnect = __commonJS({
  "node_modules/aws-cdk-lib/aws-mediaconnect/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib186(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-mediaconvert/lib/mediaconvert.generated.js
var require_mediaconvert_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-mediaconvert/lib/mediaconvert.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnQueue = exports2.CfnPreset = exports2.CfnJobTemplate = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnJobTemplatePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accelerationSettings", CfnJobTemplate_AccelerationSettingsPropertyValidator)(properties.accelerationSettings)), errors.collect(cdk.propertyValidator("category", cdk.validateString)(properties.category)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("hopDestinations", cdk.listValidator(CfnJobTemplate_HopDestinationPropertyValidator))(properties.hopDestinations)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("priority", cdk.validateNumber)(properties.priority)), errors.collect(cdk.propertyValidator("queue", cdk.validateString)(properties.queue)), errors.collect(cdk.propertyValidator("settingsJson", cdk.requiredValidator)(properties.settingsJson)), errors.collect(cdk.propertyValidator("settingsJson", cdk.validateObject)(properties.settingsJson)), errors.collect(cdk.propertyValidator("statusUpdateInterval", cdk.validateString)(properties.statusUpdateInterval)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.wrap('supplied properties not correct for "CfnJobTemplateProps"');
    }
    function cfnJobTemplatePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobTemplatePropsValidator(properties).assertSuccess(), { SettingsJson: cdk.objectToCloudFormation(properties.settingsJson), AccelerationSettings: cfnJobTemplateAccelerationSettingsPropertyToCloudFormation(properties.accelerationSettings), Category: cdk.stringToCloudFormation(properties.category), Description: cdk.stringToCloudFormation(properties.description), HopDestinations: cdk.listMapper(cfnJobTemplateHopDestinationPropertyToCloudFormation)(properties.hopDestinations), Name: cdk.stringToCloudFormation(properties.name), Priority: cdk.numberToCloudFormation(properties.priority), Queue: cdk.stringToCloudFormation(properties.queue), StatusUpdateInterval: cdk.stringToCloudFormation(properties.statusUpdateInterval), Tags: cdk.objectToCloudFormation(properties.tags) }) : properties;
    }
    function CfnJobTemplatePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("settingsJson", "SettingsJson", cfn_parse.FromCloudFormation.getAny(properties.SettingsJson)), ret.addPropertyResult("accelerationSettings", "AccelerationSettings", properties.AccelerationSettings != null ? CfnJobTemplateAccelerationSettingsPropertyFromCloudFormation(properties.AccelerationSettings) : void 0), ret.addPropertyResult("category", "Category", properties.Category != null ? cfn_parse.FromCloudFormation.getString(properties.Category) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("hopDestinations", "HopDestinations", properties.HopDestinations != null ? cfn_parse.FromCloudFormation.getArray(CfnJobTemplateHopDestinationPropertyFromCloudFormation)(properties.HopDestinations) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("priority", "Priority", properties.Priority != null ? cfn_parse.FromCloudFormation.getNumber(properties.Priority) : void 0), ret.addPropertyResult("queue", "Queue", properties.Queue != null ? cfn_parse.FromCloudFormation.getString(properties.Queue) : void 0), ret.addPropertyResult("statusUpdateInterval", "StatusUpdateInterval", properties.StatusUpdateInterval != null ? cfn_parse.FromCloudFormation.getString(properties.StatusUpdateInterval) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnJobTemplate = class _CfnJobTemplate extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnJobTemplatePropsFromCloudFormation(resourceProperties), ret = new _CfnJobTemplate(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnJobTemplate.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_mediaconvert_CfnJobTemplateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnJobTemplate), error;
        }
        cdk.requireProperty(props, "settingsJson", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.settingsJson = props.settingsJson, this.accelerationSettings = props.accelerationSettings, this.category = props.category, this.description = props.description, this.hopDestinations = props.hopDestinations, this.name = props.name, this.priority = props.priority, this.queue = props.queue, this.statusUpdateInterval = props.statusUpdateInterval, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::MediaConvert::JobTemplate", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnJobTemplate.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { settingsJson: this.settingsJson, accelerationSettings: this.accelerationSettings, category: this.category, description: this.description, hopDestinations: this.hopDestinations, name: this.name, priority: this.priority, queue: this.queue, statusUpdateInterval: this.statusUpdateInterval, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnJobTemplatePropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnJobTemplate[_a] = { fqn: "aws-cdk-lib.aws_mediaconvert.CfnJobTemplate", version: "2.80.0" }, CfnJobTemplate.CFN_RESOURCE_TYPE_NAME = "AWS::MediaConvert::JobTemplate", exports2.CfnJobTemplate = CfnJobTemplate;
    function CfnJobTemplate_AccelerationSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mode", cdk.requiredValidator)(properties.mode)), errors.collect(cdk.propertyValidator("mode", cdk.validateString)(properties.mode)), errors.wrap('supplied properties not correct for "AccelerationSettingsProperty"');
    }
    function cfnJobTemplateAccelerationSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobTemplate_AccelerationSettingsPropertyValidator(properties).assertSuccess(), { Mode: cdk.stringToCloudFormation(properties.mode) }) : properties;
    }
    function CfnJobTemplateAccelerationSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mode", "Mode", cfn_parse.FromCloudFormation.getString(properties.Mode)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnJobTemplate_HopDestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("priority", cdk.validateNumber)(properties.priority)), errors.collect(cdk.propertyValidator("queue", cdk.validateString)(properties.queue)), errors.collect(cdk.propertyValidator("waitMinutes", cdk.validateNumber)(properties.waitMinutes)), errors.wrap('supplied properties not correct for "HopDestinationProperty"');
    }
    function cfnJobTemplateHopDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnJobTemplate_HopDestinationPropertyValidator(properties).assertSuccess(), { Priority: cdk.numberToCloudFormation(properties.priority), Queue: cdk.stringToCloudFormation(properties.queue), WaitMinutes: cdk.numberToCloudFormation(properties.waitMinutes) }) : properties;
    }
    function CfnJobTemplateHopDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("priority", "Priority", properties.Priority != null ? cfn_parse.FromCloudFormation.getNumber(properties.Priority) : void 0), ret.addPropertyResult("queue", "Queue", properties.Queue != null ? cfn_parse.FromCloudFormation.getString(properties.Queue) : void 0), ret.addPropertyResult("waitMinutes", "WaitMinutes", properties.WaitMinutes != null ? cfn_parse.FromCloudFormation.getNumber(properties.WaitMinutes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPresetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("category", cdk.validateString)(properties.category)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("settingsJson", cdk.requiredValidator)(properties.settingsJson)), errors.collect(cdk.propertyValidator("settingsJson", cdk.validateObject)(properties.settingsJson)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.wrap('supplied properties not correct for "CfnPresetProps"');
    }
    function cfnPresetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPresetPropsValidator(properties).assertSuccess(), { SettingsJson: cdk.objectToCloudFormation(properties.settingsJson), Category: cdk.stringToCloudFormation(properties.category), Description: cdk.stringToCloudFormation(properties.description), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.objectToCloudFormation(properties.tags) }) : properties;
    }
    function CfnPresetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("settingsJson", "SettingsJson", cfn_parse.FromCloudFormation.getAny(properties.SettingsJson)), ret.addPropertyResult("category", "Category", properties.Category != null ? cfn_parse.FromCloudFormation.getString(properties.Category) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPreset = class _CfnPreset extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPresetPropsFromCloudFormation(resourceProperties), ret = new _CfnPreset(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPreset.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_mediaconvert_CfnPresetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPreset), error;
        }
        cdk.requireProperty(props, "settingsJson", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.settingsJson = props.settingsJson, this.category = props.category, this.description = props.description, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::MediaConvert::Preset", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPreset.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { settingsJson: this.settingsJson, category: this.category, description: this.description, name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnPresetPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnPreset[_b] = { fqn: "aws-cdk-lib.aws_mediaconvert.CfnPreset", version: "2.80.0" }, CfnPreset.CFN_RESOURCE_TYPE_NAME = "AWS::MediaConvert::Preset", exports2.CfnPreset = CfnPreset;
    function CfnQueuePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("pricingPlan", cdk.validateString)(properties.pricingPlan)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.wrap('supplied properties not correct for "CfnQueueProps"');
    }
    function cfnQueuePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnQueuePropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), Name: cdk.stringToCloudFormation(properties.name), PricingPlan: cdk.stringToCloudFormation(properties.pricingPlan), Status: cdk.stringToCloudFormation(properties.status), Tags: cdk.objectToCloudFormation(properties.tags) }) : properties;
    }
    function CfnQueuePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("pricingPlan", "PricingPlan", properties.PricingPlan != null ? cfn_parse.FromCloudFormation.getString(properties.PricingPlan) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnQueue = class _CfnQueue extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnQueuePropsFromCloudFormation(resourceProperties), ret = new _CfnQueue(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnQueue.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_mediaconvert_CfnQueueProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnQueue), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.description = props.description, this.name = props.name, this.pricingPlan = props.pricingPlan, this.status = props.status, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::MediaConvert::Queue", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnQueue.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, name: this.name, pricingPlan: this.pricingPlan, status: this.status, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnQueuePropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnQueue[_c] = { fqn: "aws-cdk-lib.aws_mediaconvert.CfnQueue", version: "2.80.0" }, CfnQueue.CFN_RESOURCE_TYPE_NAME = "AWS::MediaConvert::Queue", exports2.CfnQueue = CfnQueue;
  }
});

// node_modules/aws-cdk-lib/aws-mediaconvert/lib/index.js
var require_lib187 = __commonJS({
  "node_modules/aws-cdk-lib/aws-mediaconvert/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_mediaconvert_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-mediaconvert/index.js
var require_aws_mediaconvert = __commonJS({
  "node_modules/aws-cdk-lib/aws-mediaconvert/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib187(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-medialive/lib/medialive.generated.js
var require_medialive_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-medialive/lib/medialive.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnInputSecurityGroup = exports2.CfnInput = exports2.CfnChannel = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnChannelPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cdiInputSpecification", CfnChannel_CdiInputSpecificationPropertyValidator)(properties.cdiInputSpecification)), errors.collect(cdk.propertyValidator("channelClass", cdk.validateString)(properties.channelClass)), errors.collect(cdk.propertyValidator("destinations", cdk.listValidator(CfnChannel_OutputDestinationPropertyValidator))(properties.destinations)), errors.collect(cdk.propertyValidator("encoderSettings", CfnChannel_EncoderSettingsPropertyValidator)(properties.encoderSettings)), errors.collect(cdk.propertyValidator("inputAttachments", cdk.listValidator(CfnChannel_InputAttachmentPropertyValidator))(properties.inputAttachments)), errors.collect(cdk.propertyValidator("inputSpecification", CfnChannel_InputSpecificationPropertyValidator)(properties.inputSpecification)), errors.collect(cdk.propertyValidator("logLevel", cdk.validateString)(properties.logLevel)), errors.collect(cdk.propertyValidator("maintenance", CfnChannel_MaintenanceCreateSettingsPropertyValidator)(properties.maintenance)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.collect(cdk.propertyValidator("vpc", CfnChannel_VpcOutputSettingsPropertyValidator)(properties.vpc)), errors.wrap('supplied properties not correct for "CfnChannelProps"');
    }
    function cfnChannelPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannelPropsValidator(properties).assertSuccess(), { CdiInputSpecification: cfnChannelCdiInputSpecificationPropertyToCloudFormation(properties.cdiInputSpecification), ChannelClass: cdk.stringToCloudFormation(properties.channelClass), Destinations: cdk.listMapper(cfnChannelOutputDestinationPropertyToCloudFormation)(properties.destinations), EncoderSettings: cfnChannelEncoderSettingsPropertyToCloudFormation(properties.encoderSettings), InputAttachments: cdk.listMapper(cfnChannelInputAttachmentPropertyToCloudFormation)(properties.inputAttachments), InputSpecification: cfnChannelInputSpecificationPropertyToCloudFormation(properties.inputSpecification), LogLevel: cdk.stringToCloudFormation(properties.logLevel), Maintenance: cfnChannelMaintenanceCreateSettingsPropertyToCloudFormation(properties.maintenance), Name: cdk.stringToCloudFormation(properties.name), RoleArn: cdk.stringToCloudFormation(properties.roleArn), Tags: cdk.objectToCloudFormation(properties.tags), Vpc: cfnChannelVpcOutputSettingsPropertyToCloudFormation(properties.vpc) }) : properties;
    }
    function CfnChannelPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cdiInputSpecification", "CdiInputSpecification", properties.CdiInputSpecification != null ? CfnChannelCdiInputSpecificationPropertyFromCloudFormation(properties.CdiInputSpecification) : void 0), ret.addPropertyResult("channelClass", "ChannelClass", properties.ChannelClass != null ? cfn_parse.FromCloudFormation.getString(properties.ChannelClass) : void 0), ret.addPropertyResult("destinations", "Destinations", properties.Destinations != null ? cfn_parse.FromCloudFormation.getArray(CfnChannelOutputDestinationPropertyFromCloudFormation)(properties.Destinations) : void 0), ret.addPropertyResult("encoderSettings", "EncoderSettings", properties.EncoderSettings != null ? CfnChannelEncoderSettingsPropertyFromCloudFormation(properties.EncoderSettings) : void 0), ret.addPropertyResult("inputAttachments", "InputAttachments", properties.InputAttachments != null ? cfn_parse.FromCloudFormation.getArray(CfnChannelInputAttachmentPropertyFromCloudFormation)(properties.InputAttachments) : void 0), ret.addPropertyResult("inputSpecification", "InputSpecification", properties.InputSpecification != null ? CfnChannelInputSpecificationPropertyFromCloudFormation(properties.InputSpecification) : void 0), ret.addPropertyResult("logLevel", "LogLevel", properties.LogLevel != null ? cfn_parse.FromCloudFormation.getString(properties.LogLevel) : void 0), ret.addPropertyResult("maintenance", "Maintenance", properties.Maintenance != null ? CfnChannelMaintenanceCreateSettingsPropertyFromCloudFormation(properties.Maintenance) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addPropertyResult("vpc", "Vpc", properties.Vpc != null ? CfnChannelVpcOutputSettingsPropertyFromCloudFormation(properties.Vpc) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnChannel = class _CfnChannel extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnChannelPropsFromCloudFormation(resourceProperties), ret = new _CfnChannel(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnChannel.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_medialive_CfnChannelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnChannel), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrInputs = cdk.Token.asList(this.getAtt("Inputs", cdk.ResolutionTypeHint.STRING_LIST)), this.cdiInputSpecification = props.cdiInputSpecification, this.channelClass = props.channelClass, this.destinations = props.destinations, this.encoderSettings = props.encoderSettings, this.inputAttachments = props.inputAttachments, this.inputSpecification = props.inputSpecification, this.logLevel = props.logLevel, this.maintenance = props.maintenance, this.name = props.name, this.roleArn = props.roleArn, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::MediaLive::Channel", props.tags, { tagPropertyName: "tags" }), this.vpc = props.vpc;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnChannel.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { cdiInputSpecification: this.cdiInputSpecification, channelClass: this.channelClass, destinations: this.destinations, encoderSettings: this.encoderSettings, inputAttachments: this.inputAttachments, inputSpecification: this.inputSpecification, logLevel: this.logLevel, maintenance: this.maintenance, name: this.name, roleArn: this.roleArn, tags: this.tags.renderTags(), vpc: this.vpc };
      }
      renderProperties(props) {
        return cfnChannelPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnChannel[_a] = { fqn: "aws-cdk-lib.aws_medialive.CfnChannel", version: "2.80.0" }, CfnChannel.CFN_RESOURCE_TYPE_NAME = "AWS::MediaLive::Channel", exports2.CfnChannel = CfnChannel;
    function CfnChannel_AacSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bitrate", cdk.validateNumber)(properties.bitrate)), errors.collect(cdk.propertyValidator("codingMode", cdk.validateString)(properties.codingMode)), errors.collect(cdk.propertyValidator("inputType", cdk.validateString)(properties.inputType)), errors.collect(cdk.propertyValidator("profile", cdk.validateString)(properties.profile)), errors.collect(cdk.propertyValidator("rateControlMode", cdk.validateString)(properties.rateControlMode)), errors.collect(cdk.propertyValidator("rawFormat", cdk.validateString)(properties.rawFormat)), errors.collect(cdk.propertyValidator("sampleRate", cdk.validateNumber)(properties.sampleRate)), errors.collect(cdk.propertyValidator("spec", cdk.validateString)(properties.spec)), errors.collect(cdk.propertyValidator("vbrQuality", cdk.validateString)(properties.vbrQuality)), errors.wrap('supplied properties not correct for "AacSettingsProperty"');
    }
    function cfnChannelAacSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_AacSettingsPropertyValidator(properties).assertSuccess(), { Bitrate: cdk.numberToCloudFormation(properties.bitrate), CodingMode: cdk.stringToCloudFormation(properties.codingMode), InputType: cdk.stringToCloudFormation(properties.inputType), Profile: cdk.stringToCloudFormation(properties.profile), RateControlMode: cdk.stringToCloudFormation(properties.rateControlMode), RawFormat: cdk.stringToCloudFormation(properties.rawFormat), SampleRate: cdk.numberToCloudFormation(properties.sampleRate), Spec: cdk.stringToCloudFormation(properties.spec), VbrQuality: cdk.stringToCloudFormation(properties.vbrQuality) }) : properties;
    }
    function CfnChannelAacSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bitrate", "Bitrate", properties.Bitrate != null ? cfn_parse.FromCloudFormation.getNumber(properties.Bitrate) : void 0), ret.addPropertyResult("codingMode", "CodingMode", properties.CodingMode != null ? cfn_parse.FromCloudFormation.getString(properties.CodingMode) : void 0), ret.addPropertyResult("inputType", "InputType", properties.InputType != null ? cfn_parse.FromCloudFormation.getString(properties.InputType) : void 0), ret.addPropertyResult("profile", "Profile", properties.Profile != null ? cfn_parse.FromCloudFormation.getString(properties.Profile) : void 0), ret.addPropertyResult("rateControlMode", "RateControlMode", properties.RateControlMode != null ? cfn_parse.FromCloudFormation.getString(properties.RateControlMode) : void 0), ret.addPropertyResult("rawFormat", "RawFormat", properties.RawFormat != null ? cfn_parse.FromCloudFormation.getString(properties.RawFormat) : void 0), ret.addPropertyResult("sampleRate", "SampleRate", properties.SampleRate != null ? cfn_parse.FromCloudFormation.getNumber(properties.SampleRate) : void 0), ret.addPropertyResult("spec", "Spec", properties.Spec != null ? cfn_parse.FromCloudFormation.getString(properties.Spec) : void 0), ret.addPropertyResult("vbrQuality", "VbrQuality", properties.VbrQuality != null ? cfn_parse.FromCloudFormation.getString(properties.VbrQuality) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_Ac3SettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bitrate", cdk.validateNumber)(properties.bitrate)), errors.collect(cdk.propertyValidator("bitstreamMode", cdk.validateString)(properties.bitstreamMode)), errors.collect(cdk.propertyValidator("codingMode", cdk.validateString)(properties.codingMode)), errors.collect(cdk.propertyValidator("dialnorm", cdk.validateNumber)(properties.dialnorm)), errors.collect(cdk.propertyValidator("drcProfile", cdk.validateString)(properties.drcProfile)), errors.collect(cdk.propertyValidator("lfeFilter", cdk.validateString)(properties.lfeFilter)), errors.collect(cdk.propertyValidator("metadataControl", cdk.validateString)(properties.metadataControl)), errors.wrap('supplied properties not correct for "Ac3SettingsProperty"');
    }
    function cfnChannelAc3SettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_Ac3SettingsPropertyValidator(properties).assertSuccess(), { Bitrate: cdk.numberToCloudFormation(properties.bitrate), BitstreamMode: cdk.stringToCloudFormation(properties.bitstreamMode), CodingMode: cdk.stringToCloudFormation(properties.codingMode), Dialnorm: cdk.numberToCloudFormation(properties.dialnorm), DrcProfile: cdk.stringToCloudFormation(properties.drcProfile), LfeFilter: cdk.stringToCloudFormation(properties.lfeFilter), MetadataControl: cdk.stringToCloudFormation(properties.metadataControl) }) : properties;
    }
    function CfnChannelAc3SettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bitrate", "Bitrate", properties.Bitrate != null ? cfn_parse.FromCloudFormation.getNumber(properties.Bitrate) : void 0), ret.addPropertyResult("bitstreamMode", "BitstreamMode", properties.BitstreamMode != null ? cfn_parse.FromCloudFormation.getString(properties.BitstreamMode) : void 0), ret.addPropertyResult("codingMode", "CodingMode", properties.CodingMode != null ? cfn_parse.FromCloudFormation.getString(properties.CodingMode) : void 0), ret.addPropertyResult("dialnorm", "Dialnorm", properties.Dialnorm != null ? cfn_parse.FromCloudFormation.getNumber(properties.Dialnorm) : void 0), ret.addPropertyResult("drcProfile", "DrcProfile", properties.DrcProfile != null ? cfn_parse.FromCloudFormation.getString(properties.DrcProfile) : void 0), ret.addPropertyResult("lfeFilter", "LfeFilter", properties.LfeFilter != null ? cfn_parse.FromCloudFormation.getString(properties.LfeFilter) : void 0), ret.addPropertyResult("metadataControl", "MetadataControl", properties.MetadataControl != null ? cfn_parse.FromCloudFormation.getString(properties.MetadataControl) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_AncillarySourceSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sourceAncillaryChannelNumber", cdk.validateNumber)(properties.sourceAncillaryChannelNumber)), errors.wrap('supplied properties not correct for "AncillarySourceSettingsProperty"');
    }
    function cfnChannelAncillarySourceSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_AncillarySourceSettingsPropertyValidator(properties).assertSuccess(), { SourceAncillaryChannelNumber: cdk.numberToCloudFormation(properties.sourceAncillaryChannelNumber) }) : properties;
    }
    function CfnChannelAncillarySourceSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sourceAncillaryChannelNumber", "SourceAncillaryChannelNumber", properties.SourceAncillaryChannelNumber != null ? cfn_parse.FromCloudFormation.getNumber(properties.SourceAncillaryChannelNumber) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_ArchiveCdnSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("archiveS3Settings", CfnChannel_ArchiveS3SettingsPropertyValidator)(properties.archiveS3Settings)), errors.wrap('supplied properties not correct for "ArchiveCdnSettingsProperty"');
    }
    function cfnChannelArchiveCdnSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_ArchiveCdnSettingsPropertyValidator(properties).assertSuccess(), { ArchiveS3Settings: cfnChannelArchiveS3SettingsPropertyToCloudFormation(properties.archiveS3Settings) }) : properties;
    }
    function CfnChannelArchiveCdnSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("archiveS3Settings", "ArchiveS3Settings", properties.ArchiveS3Settings != null ? CfnChannelArchiveS3SettingsPropertyFromCloudFormation(properties.ArchiveS3Settings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_ArchiveContainerSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("m2TsSettings", CfnChannel_M2tsSettingsPropertyValidator)(properties.m2TsSettings)), errors.collect(cdk.propertyValidator("rawSettings", CfnChannel_RawSettingsPropertyValidator)(properties.rawSettings)), errors.wrap('supplied properties not correct for "ArchiveContainerSettingsProperty"');
    }
    function cfnChannelArchiveContainerSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_ArchiveContainerSettingsPropertyValidator(properties).assertSuccess(), { M2tsSettings: cfnChannelM2tsSettingsPropertyToCloudFormation(properties.m2TsSettings), RawSettings: cfnChannelRawSettingsPropertyToCloudFormation(properties.rawSettings) }) : properties;
    }
    function CfnChannelArchiveContainerSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("m2TsSettings", "M2tsSettings", properties.M2tsSettings != null ? CfnChannelM2tsSettingsPropertyFromCloudFormation(properties.M2tsSettings) : void 0), ret.addPropertyResult("rawSettings", "RawSettings", properties.RawSettings != null ? CfnChannelRawSettingsPropertyFromCloudFormation(properties.RawSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_ArchiveGroupSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("archiveCdnSettings", CfnChannel_ArchiveCdnSettingsPropertyValidator)(properties.archiveCdnSettings)), errors.collect(cdk.propertyValidator("destination", CfnChannel_OutputLocationRefPropertyValidator)(properties.destination)), errors.collect(cdk.propertyValidator("rolloverInterval", cdk.validateNumber)(properties.rolloverInterval)), errors.wrap('supplied properties not correct for "ArchiveGroupSettingsProperty"');
    }
    function cfnChannelArchiveGroupSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_ArchiveGroupSettingsPropertyValidator(properties).assertSuccess(), { ArchiveCdnSettings: cfnChannelArchiveCdnSettingsPropertyToCloudFormation(properties.archiveCdnSettings), Destination: cfnChannelOutputLocationRefPropertyToCloudFormation(properties.destination), RolloverInterval: cdk.numberToCloudFormation(properties.rolloverInterval) }) : properties;
    }
    function CfnChannelArchiveGroupSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("archiveCdnSettings", "ArchiveCdnSettings", properties.ArchiveCdnSettings != null ? CfnChannelArchiveCdnSettingsPropertyFromCloudFormation(properties.ArchiveCdnSettings) : void 0), ret.addPropertyResult("destination", "Destination", properties.Destination != null ? CfnChannelOutputLocationRefPropertyFromCloudFormation(properties.Destination) : void 0), ret.addPropertyResult("rolloverInterval", "RolloverInterval", properties.RolloverInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.RolloverInterval) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_ArchiveOutputSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containerSettings", CfnChannel_ArchiveContainerSettingsPropertyValidator)(properties.containerSettings)), errors.collect(cdk.propertyValidator("extension", cdk.validateString)(properties.extension)), errors.collect(cdk.propertyValidator("nameModifier", cdk.validateString)(properties.nameModifier)), errors.wrap('supplied properties not correct for "ArchiveOutputSettingsProperty"');
    }
    function cfnChannelArchiveOutputSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_ArchiveOutputSettingsPropertyValidator(properties).assertSuccess(), { ContainerSettings: cfnChannelArchiveContainerSettingsPropertyToCloudFormation(properties.containerSettings), Extension: cdk.stringToCloudFormation(properties.extension), NameModifier: cdk.stringToCloudFormation(properties.nameModifier) }) : properties;
    }
    function CfnChannelArchiveOutputSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containerSettings", "ContainerSettings", properties.ContainerSettings != null ? CfnChannelArchiveContainerSettingsPropertyFromCloudFormation(properties.ContainerSettings) : void 0), ret.addPropertyResult("extension", "Extension", properties.Extension != null ? cfn_parse.FromCloudFormation.getString(properties.Extension) : void 0), ret.addPropertyResult("nameModifier", "NameModifier", properties.NameModifier != null ? cfn_parse.FromCloudFormation.getString(properties.NameModifier) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_ArchiveS3SettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cannedAcl", cdk.validateString)(properties.cannedAcl)), errors.wrap('supplied properties not correct for "ArchiveS3SettingsProperty"');
    }
    function cfnChannelArchiveS3SettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_ArchiveS3SettingsPropertyValidator(properties).assertSuccess(), { CannedAcl: cdk.stringToCloudFormation(properties.cannedAcl) }) : properties;
    }
    function CfnChannelArchiveS3SettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cannedAcl", "CannedAcl", properties.CannedAcl != null ? cfn_parse.FromCloudFormation.getString(properties.CannedAcl) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_AribDestinationSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.wrap('supplied properties not correct for "AribDestinationSettingsProperty"');
    }
    function cfnChannelAribDestinationSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_AribDestinationSettingsPropertyValidator(properties).assertSuccess(), {}) : properties;
    }
    function CfnChannelAribDestinationSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_AribSourceSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.wrap('supplied properties not correct for "AribSourceSettingsProperty"');
    }
    function cfnChannelAribSourceSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_AribSourceSettingsPropertyValidator(properties).assertSuccess(), {}) : properties;
    }
    function CfnChannelAribSourceSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_AudioChannelMappingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("inputChannelLevels", cdk.listValidator(CfnChannel_InputChannelLevelPropertyValidator))(properties.inputChannelLevels)), errors.collect(cdk.propertyValidator("outputChannel", cdk.validateNumber)(properties.outputChannel)), errors.wrap('supplied properties not correct for "AudioChannelMappingProperty"');
    }
    function cfnChannelAudioChannelMappingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_AudioChannelMappingPropertyValidator(properties).assertSuccess(), { InputChannelLevels: cdk.listMapper(cfnChannelInputChannelLevelPropertyToCloudFormation)(properties.inputChannelLevels), OutputChannel: cdk.numberToCloudFormation(properties.outputChannel) }) : properties;
    }
    function CfnChannelAudioChannelMappingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("inputChannelLevels", "InputChannelLevels", properties.InputChannelLevels != null ? cfn_parse.FromCloudFormation.getArray(CfnChannelInputChannelLevelPropertyFromCloudFormation)(properties.InputChannelLevels) : void 0), ret.addPropertyResult("outputChannel", "OutputChannel", properties.OutputChannel != null ? cfn_parse.FromCloudFormation.getNumber(properties.OutputChannel) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_AudioCodecSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aacSettings", CfnChannel_AacSettingsPropertyValidator)(properties.aacSettings)), errors.collect(cdk.propertyValidator("ac3Settings", CfnChannel_Ac3SettingsPropertyValidator)(properties.ac3Settings)), errors.collect(cdk.propertyValidator("eac3AtmosSettings", CfnChannel_Eac3AtmosSettingsPropertyValidator)(properties.eac3AtmosSettings)), errors.collect(cdk.propertyValidator("eac3Settings", CfnChannel_Eac3SettingsPropertyValidator)(properties.eac3Settings)), errors.collect(cdk.propertyValidator("mp2Settings", CfnChannel_Mp2SettingsPropertyValidator)(properties.mp2Settings)), errors.collect(cdk.propertyValidator("passThroughSettings", CfnChannel_PassThroughSettingsPropertyValidator)(properties.passThroughSettings)), errors.collect(cdk.propertyValidator("wavSettings", CfnChannel_WavSettingsPropertyValidator)(properties.wavSettings)), errors.wrap('supplied properties not correct for "AudioCodecSettingsProperty"');
    }
    function cfnChannelAudioCodecSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_AudioCodecSettingsPropertyValidator(properties).assertSuccess(), { AacSettings: cfnChannelAacSettingsPropertyToCloudFormation(properties.aacSettings), Ac3Settings: cfnChannelAc3SettingsPropertyToCloudFormation(properties.ac3Settings), Eac3AtmosSettings: cfnChannelEac3AtmosSettingsPropertyToCloudFormation(properties.eac3AtmosSettings), Eac3Settings: cfnChannelEac3SettingsPropertyToCloudFormation(properties.eac3Settings), Mp2Settings: cfnChannelMp2SettingsPropertyToCloudFormation(properties.mp2Settings), PassThroughSettings: cfnChannelPassThroughSettingsPropertyToCloudFormation(properties.passThroughSettings), WavSettings: cfnChannelWavSettingsPropertyToCloudFormation(properties.wavSettings) }) : properties;
    }
    function CfnChannelAudioCodecSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aacSettings", "AacSettings", properties.AacSettings != null ? CfnChannelAacSettingsPropertyFromCloudFormation(properties.AacSettings) : void 0), ret.addPropertyResult("ac3Settings", "Ac3Settings", properties.Ac3Settings != null ? CfnChannelAc3SettingsPropertyFromCloudFormation(properties.Ac3Settings) : void 0), ret.addPropertyResult("eac3AtmosSettings", "Eac3AtmosSettings", properties.Eac3AtmosSettings != null ? CfnChannelEac3AtmosSettingsPropertyFromCloudFormation(properties.Eac3AtmosSettings) : void 0), ret.addPropertyResult("eac3Settings", "Eac3Settings", properties.Eac3Settings != null ? CfnChannelEac3SettingsPropertyFromCloudFormation(properties.Eac3Settings) : void 0), ret.addPropertyResult("mp2Settings", "Mp2Settings", properties.Mp2Settings != null ? CfnChannelMp2SettingsPropertyFromCloudFormation(properties.Mp2Settings) : void 0), ret.addPropertyResult("passThroughSettings", "PassThroughSettings", properties.PassThroughSettings != null ? CfnChannelPassThroughSettingsPropertyFromCloudFormation(properties.PassThroughSettings) : void 0), ret.addPropertyResult("wavSettings", "WavSettings", properties.WavSettings != null ? CfnChannelWavSettingsPropertyFromCloudFormation(properties.WavSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_AudioDescriptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("audioNormalizationSettings", CfnChannel_AudioNormalizationSettingsPropertyValidator)(properties.audioNormalizationSettings)), errors.collect(cdk.propertyValidator("audioSelectorName", cdk.validateString)(properties.audioSelectorName)), errors.collect(cdk.propertyValidator("audioType", cdk.validateString)(properties.audioType)), errors.collect(cdk.propertyValidator("audioTypeControl", cdk.validateString)(properties.audioTypeControl)), errors.collect(cdk.propertyValidator("audioWatermarkingSettings", CfnChannel_AudioWatermarkSettingsPropertyValidator)(properties.audioWatermarkingSettings)), errors.collect(cdk.propertyValidator("codecSettings", CfnChannel_AudioCodecSettingsPropertyValidator)(properties.codecSettings)), errors.collect(cdk.propertyValidator("languageCode", cdk.validateString)(properties.languageCode)), errors.collect(cdk.propertyValidator("languageCodeControl", cdk.validateString)(properties.languageCodeControl)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("remixSettings", CfnChannel_RemixSettingsPropertyValidator)(properties.remixSettings)), errors.collect(cdk.propertyValidator("streamName", cdk.validateString)(properties.streamName)), errors.wrap('supplied properties not correct for "AudioDescriptionProperty"');
    }
    function cfnChannelAudioDescriptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_AudioDescriptionPropertyValidator(properties).assertSuccess(), { AudioNormalizationSettings: cfnChannelAudioNormalizationSettingsPropertyToCloudFormation(properties.audioNormalizationSettings), AudioSelectorName: cdk.stringToCloudFormation(properties.audioSelectorName), AudioType: cdk.stringToCloudFormation(properties.audioType), AudioTypeControl: cdk.stringToCloudFormation(properties.audioTypeControl), AudioWatermarkingSettings: cfnChannelAudioWatermarkSettingsPropertyToCloudFormation(properties.audioWatermarkingSettings), CodecSettings: cfnChannelAudioCodecSettingsPropertyToCloudFormation(properties.codecSettings), LanguageCode: cdk.stringToCloudFormation(properties.languageCode), LanguageCodeControl: cdk.stringToCloudFormation(properties.languageCodeControl), Name: cdk.stringToCloudFormation(properties.name), RemixSettings: cfnChannelRemixSettingsPropertyToCloudFormation(properties.remixSettings), StreamName: cdk.stringToCloudFormation(properties.streamName) }) : properties;
    }
    function CfnChannelAudioDescriptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("audioNormalizationSettings", "AudioNormalizationSettings", properties.AudioNormalizationSettings != null ? CfnChannelAudioNormalizationSettingsPropertyFromCloudFormation(properties.AudioNormalizationSettings) : void 0), ret.addPropertyResult("audioSelectorName", "AudioSelectorName", properties.AudioSelectorName != null ? cfn_parse.FromCloudFormation.getString(properties.AudioSelectorName) : void 0), ret.addPropertyResult("audioType", "AudioType", properties.AudioType != null ? cfn_parse.FromCloudFormation.getString(properties.AudioType) : void 0), ret.addPropertyResult("audioTypeControl", "AudioTypeControl", properties.AudioTypeControl != null ? cfn_parse.FromCloudFormation.getString(properties.AudioTypeControl) : void 0), ret.addPropertyResult("audioWatermarkingSettings", "AudioWatermarkingSettings", properties.AudioWatermarkingSettings != null ? CfnChannelAudioWatermarkSettingsPropertyFromCloudFormation(properties.AudioWatermarkingSettings) : void 0), ret.addPropertyResult("codecSettings", "CodecSettings", properties.CodecSettings != null ? CfnChannelAudioCodecSettingsPropertyFromCloudFormation(properties.CodecSettings) : void 0), ret.addPropertyResult("languageCode", "LanguageCode", properties.LanguageCode != null ? cfn_parse.FromCloudFormation.getString(properties.LanguageCode) : void 0), ret.addPropertyResult("languageCodeControl", "LanguageCodeControl", properties.LanguageCodeControl != null ? cfn_parse.FromCloudFormation.getString(properties.LanguageCodeControl) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("remixSettings", "RemixSettings", properties.RemixSettings != null ? CfnChannelRemixSettingsPropertyFromCloudFormation(properties.RemixSettings) : void 0), ret.addPropertyResult("streamName", "StreamName", properties.StreamName != null ? cfn_parse.FromCloudFormation.getString(properties.StreamName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_AudioDolbyEDecodePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("programSelection", cdk.validateString)(properties.programSelection)), errors.wrap('supplied properties not correct for "AudioDolbyEDecodeProperty"');
    }
    function cfnChannelAudioDolbyEDecodePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_AudioDolbyEDecodePropertyValidator(properties).assertSuccess(), { ProgramSelection: cdk.stringToCloudFormation(properties.programSelection) }) : properties;
    }
    function CfnChannelAudioDolbyEDecodePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("programSelection", "ProgramSelection", properties.ProgramSelection != null ? cfn_parse.FromCloudFormation.getString(properties.ProgramSelection) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_AudioHlsRenditionSelectionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groupId", cdk.validateString)(properties.groupId)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "AudioHlsRenditionSelectionProperty"');
    }
    function cfnChannelAudioHlsRenditionSelectionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_AudioHlsRenditionSelectionPropertyValidator(properties).assertSuccess(), { GroupId: cdk.stringToCloudFormation(properties.groupId), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnChannelAudioHlsRenditionSelectionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupId", "GroupId", properties.GroupId != null ? cfn_parse.FromCloudFormation.getString(properties.GroupId) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_AudioLanguageSelectionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("languageCode", cdk.validateString)(properties.languageCode)), errors.collect(cdk.propertyValidator("languageSelectionPolicy", cdk.validateString)(properties.languageSelectionPolicy)), errors.wrap('supplied properties not correct for "AudioLanguageSelectionProperty"');
    }
    function cfnChannelAudioLanguageSelectionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_AudioLanguageSelectionPropertyValidator(properties).assertSuccess(), { LanguageCode: cdk.stringToCloudFormation(properties.languageCode), LanguageSelectionPolicy: cdk.stringToCloudFormation(properties.languageSelectionPolicy) }) : properties;
    }
    function CfnChannelAudioLanguageSelectionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("languageCode", "LanguageCode", properties.LanguageCode != null ? cfn_parse.FromCloudFormation.getString(properties.LanguageCode) : void 0), ret.addPropertyResult("languageSelectionPolicy", "LanguageSelectionPolicy", properties.LanguageSelectionPolicy != null ? cfn_parse.FromCloudFormation.getString(properties.LanguageSelectionPolicy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_AudioNormalizationSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("algorithm", cdk.validateString)(properties.algorithm)), errors.collect(cdk.propertyValidator("algorithmControl", cdk.validateString)(properties.algorithmControl)), errors.collect(cdk.propertyValidator("targetLkfs", cdk.validateNumber)(properties.targetLkfs)), errors.wrap('supplied properties not correct for "AudioNormalizationSettingsProperty"');
    }
    function cfnChannelAudioNormalizationSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_AudioNormalizationSettingsPropertyValidator(properties).assertSuccess(), { Algorithm: cdk.stringToCloudFormation(properties.algorithm), AlgorithmControl: cdk.stringToCloudFormation(properties.algorithmControl), TargetLkfs: cdk.numberToCloudFormation(properties.targetLkfs) }) : properties;
    }
    function CfnChannelAudioNormalizationSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("algorithm", "Algorithm", properties.Algorithm != null ? cfn_parse.FromCloudFormation.getString(properties.Algorithm) : void 0), ret.addPropertyResult("algorithmControl", "AlgorithmControl", properties.AlgorithmControl != null ? cfn_parse.FromCloudFormation.getString(properties.AlgorithmControl) : void 0), ret.addPropertyResult("targetLkfs", "TargetLkfs", properties.TargetLkfs != null ? cfn_parse.FromCloudFormation.getNumber(properties.TargetLkfs) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_AudioOnlyHlsSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("audioGroupId", cdk.validateString)(properties.audioGroupId)), errors.collect(cdk.propertyValidator("audioOnlyImage", CfnChannel_InputLocationPropertyValidator)(properties.audioOnlyImage)), errors.collect(cdk.propertyValidator("audioTrackType", cdk.validateString)(properties.audioTrackType)), errors.collect(cdk.propertyValidator("segmentType", cdk.validateString)(properties.segmentType)), errors.wrap('supplied properties not correct for "AudioOnlyHlsSettingsProperty"');
    }
    function cfnChannelAudioOnlyHlsSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_AudioOnlyHlsSettingsPropertyValidator(properties).assertSuccess(), { AudioGroupId: cdk.stringToCloudFormation(properties.audioGroupId), AudioOnlyImage: cfnChannelInputLocationPropertyToCloudFormation(properties.audioOnlyImage), AudioTrackType: cdk.stringToCloudFormation(properties.audioTrackType), SegmentType: cdk.stringToCloudFormation(properties.segmentType) }) : properties;
    }
    function CfnChannelAudioOnlyHlsSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("audioGroupId", "AudioGroupId", properties.AudioGroupId != null ? cfn_parse.FromCloudFormation.getString(properties.AudioGroupId) : void 0), ret.addPropertyResult("audioOnlyImage", "AudioOnlyImage", properties.AudioOnlyImage != null ? CfnChannelInputLocationPropertyFromCloudFormation(properties.AudioOnlyImage) : void 0), ret.addPropertyResult("audioTrackType", "AudioTrackType", properties.AudioTrackType != null ? cfn_parse.FromCloudFormation.getString(properties.AudioTrackType) : void 0), ret.addPropertyResult("segmentType", "SegmentType", properties.SegmentType != null ? cfn_parse.FromCloudFormation.getString(properties.SegmentType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_AudioPidSelectionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("pid", cdk.validateNumber)(properties.pid)), errors.wrap('supplied properties not correct for "AudioPidSelectionProperty"');
    }
    function cfnChannelAudioPidSelectionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_AudioPidSelectionPropertyValidator(properties).assertSuccess(), { Pid: cdk.numberToCloudFormation(properties.pid) }) : properties;
    }
    function CfnChannelAudioPidSelectionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("pid", "Pid", properties.Pid != null ? cfn_parse.FromCloudFormation.getNumber(properties.Pid) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_AudioSelectorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("selectorSettings", CfnChannel_AudioSelectorSettingsPropertyValidator)(properties.selectorSettings)), errors.wrap('supplied properties not correct for "AudioSelectorProperty"');
    }
    function cfnChannelAudioSelectorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_AudioSelectorPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), SelectorSettings: cfnChannelAudioSelectorSettingsPropertyToCloudFormation(properties.selectorSettings) }) : properties;
    }
    function CfnChannelAudioSelectorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("selectorSettings", "SelectorSettings", properties.SelectorSettings != null ? CfnChannelAudioSelectorSettingsPropertyFromCloudFormation(properties.SelectorSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_AudioSelectorSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("audioHlsRenditionSelection", CfnChannel_AudioHlsRenditionSelectionPropertyValidator)(properties.audioHlsRenditionSelection)), errors.collect(cdk.propertyValidator("audioLanguageSelection", CfnChannel_AudioLanguageSelectionPropertyValidator)(properties.audioLanguageSelection)), errors.collect(cdk.propertyValidator("audioPidSelection", CfnChannel_AudioPidSelectionPropertyValidator)(properties.audioPidSelection)), errors.collect(cdk.propertyValidator("audioTrackSelection", CfnChannel_AudioTrackSelectionPropertyValidator)(properties.audioTrackSelection)), errors.wrap('supplied properties not correct for "AudioSelectorSettingsProperty"');
    }
    function cfnChannelAudioSelectorSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_AudioSelectorSettingsPropertyValidator(properties).assertSuccess(), { AudioHlsRenditionSelection: cfnChannelAudioHlsRenditionSelectionPropertyToCloudFormation(properties.audioHlsRenditionSelection), AudioLanguageSelection: cfnChannelAudioLanguageSelectionPropertyToCloudFormation(properties.audioLanguageSelection), AudioPidSelection: cfnChannelAudioPidSelectionPropertyToCloudFormation(properties.audioPidSelection), AudioTrackSelection: cfnChannelAudioTrackSelectionPropertyToCloudFormation(properties.audioTrackSelection) }) : properties;
    }
    function CfnChannelAudioSelectorSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("audioHlsRenditionSelection", "AudioHlsRenditionSelection", properties.AudioHlsRenditionSelection != null ? CfnChannelAudioHlsRenditionSelectionPropertyFromCloudFormation(properties.AudioHlsRenditionSelection) : void 0), ret.addPropertyResult("audioLanguageSelection", "AudioLanguageSelection", properties.AudioLanguageSelection != null ? CfnChannelAudioLanguageSelectionPropertyFromCloudFormation(properties.AudioLanguageSelection) : void 0), ret.addPropertyResult("audioPidSelection", "AudioPidSelection", properties.AudioPidSelection != null ? CfnChannelAudioPidSelectionPropertyFromCloudFormation(properties.AudioPidSelection) : void 0), ret.addPropertyResult("audioTrackSelection", "AudioTrackSelection", properties.AudioTrackSelection != null ? CfnChannelAudioTrackSelectionPropertyFromCloudFormation(properties.AudioTrackSelection) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_AudioSilenceFailoverSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("audioSelectorName", cdk.validateString)(properties.audioSelectorName)), errors.collect(cdk.propertyValidator("audioSilenceThresholdMsec", cdk.validateNumber)(properties.audioSilenceThresholdMsec)), errors.wrap('supplied properties not correct for "AudioSilenceFailoverSettingsProperty"');
    }
    function cfnChannelAudioSilenceFailoverSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_AudioSilenceFailoverSettingsPropertyValidator(properties).assertSuccess(), { AudioSelectorName: cdk.stringToCloudFormation(properties.audioSelectorName), AudioSilenceThresholdMsec: cdk.numberToCloudFormation(properties.audioSilenceThresholdMsec) }) : properties;
    }
    function CfnChannelAudioSilenceFailoverSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("audioSelectorName", "AudioSelectorName", properties.AudioSelectorName != null ? cfn_parse.FromCloudFormation.getString(properties.AudioSelectorName) : void 0), ret.addPropertyResult("audioSilenceThresholdMsec", "AudioSilenceThresholdMsec", properties.AudioSilenceThresholdMsec != null ? cfn_parse.FromCloudFormation.getNumber(properties.AudioSilenceThresholdMsec) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_AudioTrackPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("track", cdk.validateNumber)(properties.track)), errors.wrap('supplied properties not correct for "AudioTrackProperty"');
    }
    function cfnChannelAudioTrackPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_AudioTrackPropertyValidator(properties).assertSuccess(), { Track: cdk.numberToCloudFormation(properties.track) }) : properties;
    }
    function CfnChannelAudioTrackPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("track", "Track", properties.Track != null ? cfn_parse.FromCloudFormation.getNumber(properties.Track) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_AudioTrackSelectionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dolbyEDecode", CfnChannel_AudioDolbyEDecodePropertyValidator)(properties.dolbyEDecode)), errors.collect(cdk.propertyValidator("tracks", cdk.listValidator(CfnChannel_AudioTrackPropertyValidator))(properties.tracks)), errors.wrap('supplied properties not correct for "AudioTrackSelectionProperty"');
    }
    function cfnChannelAudioTrackSelectionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_AudioTrackSelectionPropertyValidator(properties).assertSuccess(), { DolbyEDecode: cfnChannelAudioDolbyEDecodePropertyToCloudFormation(properties.dolbyEDecode), Tracks: cdk.listMapper(cfnChannelAudioTrackPropertyToCloudFormation)(properties.tracks) }) : properties;
    }
    function CfnChannelAudioTrackSelectionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dolbyEDecode", "DolbyEDecode", properties.DolbyEDecode != null ? CfnChannelAudioDolbyEDecodePropertyFromCloudFormation(properties.DolbyEDecode) : void 0), ret.addPropertyResult("tracks", "Tracks", properties.Tracks != null ? cfn_parse.FromCloudFormation.getArray(CfnChannelAudioTrackPropertyFromCloudFormation)(properties.Tracks) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_AudioWatermarkSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("nielsenWatermarksSettings", CfnChannel_NielsenWatermarksSettingsPropertyValidator)(properties.nielsenWatermarksSettings)), errors.wrap('supplied properties not correct for "AudioWatermarkSettingsProperty"');
    }
    function cfnChannelAudioWatermarkSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_AudioWatermarkSettingsPropertyValidator(properties).assertSuccess(), { NielsenWatermarksSettings: cfnChannelNielsenWatermarksSettingsPropertyToCloudFormation(properties.nielsenWatermarksSettings) }) : properties;
    }
    function CfnChannelAudioWatermarkSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("nielsenWatermarksSettings", "NielsenWatermarksSettings", properties.NielsenWatermarksSettings != null ? CfnChannelNielsenWatermarksSettingsPropertyFromCloudFormation(properties.NielsenWatermarksSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_AutomaticInputFailoverSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("errorClearTimeMsec", cdk.validateNumber)(properties.errorClearTimeMsec)), errors.collect(cdk.propertyValidator("failoverConditions", cdk.listValidator(CfnChannel_FailoverConditionPropertyValidator))(properties.failoverConditions)), errors.collect(cdk.propertyValidator("inputPreference", cdk.validateString)(properties.inputPreference)), errors.collect(cdk.propertyValidator("secondaryInputId", cdk.validateString)(properties.secondaryInputId)), errors.wrap('supplied properties not correct for "AutomaticInputFailoverSettingsProperty"');
    }
    function cfnChannelAutomaticInputFailoverSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_AutomaticInputFailoverSettingsPropertyValidator(properties).assertSuccess(), { ErrorClearTimeMsec: cdk.numberToCloudFormation(properties.errorClearTimeMsec), FailoverConditions: cdk.listMapper(cfnChannelFailoverConditionPropertyToCloudFormation)(properties.failoverConditions), InputPreference: cdk.stringToCloudFormation(properties.inputPreference), SecondaryInputId: cdk.stringToCloudFormation(properties.secondaryInputId) }) : properties;
    }
    function CfnChannelAutomaticInputFailoverSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("errorClearTimeMsec", "ErrorClearTimeMsec", properties.ErrorClearTimeMsec != null ? cfn_parse.FromCloudFormation.getNumber(properties.ErrorClearTimeMsec) : void 0), ret.addPropertyResult("failoverConditions", "FailoverConditions", properties.FailoverConditions != null ? cfn_parse.FromCloudFormation.getArray(CfnChannelFailoverConditionPropertyFromCloudFormation)(properties.FailoverConditions) : void 0), ret.addPropertyResult("inputPreference", "InputPreference", properties.InputPreference != null ? cfn_parse.FromCloudFormation.getString(properties.InputPreference) : void 0), ret.addPropertyResult("secondaryInputId", "SecondaryInputId", properties.SecondaryInputId != null ? cfn_parse.FromCloudFormation.getString(properties.SecondaryInputId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_AvailBlankingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availBlankingImage", CfnChannel_InputLocationPropertyValidator)(properties.availBlankingImage)), errors.collect(cdk.propertyValidator("state", cdk.validateString)(properties.state)), errors.wrap('supplied properties not correct for "AvailBlankingProperty"');
    }
    function cfnChannelAvailBlankingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_AvailBlankingPropertyValidator(properties).assertSuccess(), { AvailBlankingImage: cfnChannelInputLocationPropertyToCloudFormation(properties.availBlankingImage), State: cdk.stringToCloudFormation(properties.state) }) : properties;
    }
    function CfnChannelAvailBlankingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("availBlankingImage", "AvailBlankingImage", properties.AvailBlankingImage != null ? CfnChannelInputLocationPropertyFromCloudFormation(properties.AvailBlankingImage) : void 0), ret.addPropertyResult("state", "State", properties.State != null ? cfn_parse.FromCloudFormation.getString(properties.State) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_AvailConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availSettings", CfnChannel_AvailSettingsPropertyValidator)(properties.availSettings)), errors.wrap('supplied properties not correct for "AvailConfigurationProperty"');
    }
    function cfnChannelAvailConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_AvailConfigurationPropertyValidator(properties).assertSuccess(), { AvailSettings: cfnChannelAvailSettingsPropertyToCloudFormation(properties.availSettings) }) : properties;
    }
    function CfnChannelAvailConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("availSettings", "AvailSettings", properties.AvailSettings != null ? CfnChannelAvailSettingsPropertyFromCloudFormation(properties.AvailSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_AvailSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("esam", CfnChannel_EsamPropertyValidator)(properties.esam)), errors.collect(cdk.propertyValidator("scte35SpliceInsert", CfnChannel_Scte35SpliceInsertPropertyValidator)(properties.scte35SpliceInsert)), errors.collect(cdk.propertyValidator("scte35TimeSignalApos", CfnChannel_Scte35TimeSignalAposPropertyValidator)(properties.scte35TimeSignalApos)), errors.wrap('supplied properties not correct for "AvailSettingsProperty"');
    }
    function cfnChannelAvailSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_AvailSettingsPropertyValidator(properties).assertSuccess(), { Esam: cfnChannelEsamPropertyToCloudFormation(properties.esam), Scte35SpliceInsert: cfnChannelScte35SpliceInsertPropertyToCloudFormation(properties.scte35SpliceInsert), Scte35TimeSignalApos: cfnChannelScte35TimeSignalAposPropertyToCloudFormation(properties.scte35TimeSignalApos) }) : properties;
    }
    function CfnChannelAvailSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("esam", "Esam", properties.Esam != null ? CfnChannelEsamPropertyFromCloudFormation(properties.Esam) : void 0), ret.addPropertyResult("scte35SpliceInsert", "Scte35SpliceInsert", properties.Scte35SpliceInsert != null ? CfnChannelScte35SpliceInsertPropertyFromCloudFormation(properties.Scte35SpliceInsert) : void 0), ret.addPropertyResult("scte35TimeSignalApos", "Scte35TimeSignalApos", properties.Scte35TimeSignalApos != null ? CfnChannelScte35TimeSignalAposPropertyFromCloudFormation(properties.Scte35TimeSignalApos) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_BlackoutSlatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("blackoutSlateImage", CfnChannel_InputLocationPropertyValidator)(properties.blackoutSlateImage)), errors.collect(cdk.propertyValidator("networkEndBlackout", cdk.validateString)(properties.networkEndBlackout)), errors.collect(cdk.propertyValidator("networkEndBlackoutImage", CfnChannel_InputLocationPropertyValidator)(properties.networkEndBlackoutImage)), errors.collect(cdk.propertyValidator("networkId", cdk.validateString)(properties.networkId)), errors.collect(cdk.propertyValidator("state", cdk.validateString)(properties.state)), errors.wrap('supplied properties not correct for "BlackoutSlateProperty"');
    }
    function cfnChannelBlackoutSlatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_BlackoutSlatePropertyValidator(properties).assertSuccess(), { BlackoutSlateImage: cfnChannelInputLocationPropertyToCloudFormation(properties.blackoutSlateImage), NetworkEndBlackout: cdk.stringToCloudFormation(properties.networkEndBlackout), NetworkEndBlackoutImage: cfnChannelInputLocationPropertyToCloudFormation(properties.networkEndBlackoutImage), NetworkId: cdk.stringToCloudFormation(properties.networkId), State: cdk.stringToCloudFormation(properties.state) }) : properties;
    }
    function CfnChannelBlackoutSlatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("blackoutSlateImage", "BlackoutSlateImage", properties.BlackoutSlateImage != null ? CfnChannelInputLocationPropertyFromCloudFormation(properties.BlackoutSlateImage) : void 0), ret.addPropertyResult("networkEndBlackout", "NetworkEndBlackout", properties.NetworkEndBlackout != null ? cfn_parse.FromCloudFormation.getString(properties.NetworkEndBlackout) : void 0), ret.addPropertyResult("networkEndBlackoutImage", "NetworkEndBlackoutImage", properties.NetworkEndBlackoutImage != null ? CfnChannelInputLocationPropertyFromCloudFormation(properties.NetworkEndBlackoutImage) : void 0), ret.addPropertyResult("networkId", "NetworkId", properties.NetworkId != null ? cfn_parse.FromCloudFormation.getString(properties.NetworkId) : void 0), ret.addPropertyResult("state", "State", properties.State != null ? cfn_parse.FromCloudFormation.getString(properties.State) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_BurnInDestinationSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alignment", cdk.validateString)(properties.alignment)), errors.collect(cdk.propertyValidator("backgroundColor", cdk.validateString)(properties.backgroundColor)), errors.collect(cdk.propertyValidator("backgroundOpacity", cdk.validateNumber)(properties.backgroundOpacity)), errors.collect(cdk.propertyValidator("font", CfnChannel_InputLocationPropertyValidator)(properties.font)), errors.collect(cdk.propertyValidator("fontColor", cdk.validateString)(properties.fontColor)), errors.collect(cdk.propertyValidator("fontOpacity", cdk.validateNumber)(properties.fontOpacity)), errors.collect(cdk.propertyValidator("fontResolution", cdk.validateNumber)(properties.fontResolution)), errors.collect(cdk.propertyValidator("fontSize", cdk.validateString)(properties.fontSize)), errors.collect(cdk.propertyValidator("outlineColor", cdk.validateString)(properties.outlineColor)), errors.collect(cdk.propertyValidator("outlineSize", cdk.validateNumber)(properties.outlineSize)), errors.collect(cdk.propertyValidator("shadowColor", cdk.validateString)(properties.shadowColor)), errors.collect(cdk.propertyValidator("shadowOpacity", cdk.validateNumber)(properties.shadowOpacity)), errors.collect(cdk.propertyValidator("shadowXOffset", cdk.validateNumber)(properties.shadowXOffset)), errors.collect(cdk.propertyValidator("shadowYOffset", cdk.validateNumber)(properties.shadowYOffset)), errors.collect(cdk.propertyValidator("teletextGridControl", cdk.validateString)(properties.teletextGridControl)), errors.collect(cdk.propertyValidator("xPosition", cdk.validateNumber)(properties.xPosition)), errors.collect(cdk.propertyValidator("yPosition", cdk.validateNumber)(properties.yPosition)), errors.wrap('supplied properties not correct for "BurnInDestinationSettingsProperty"');
    }
    function cfnChannelBurnInDestinationSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_BurnInDestinationSettingsPropertyValidator(properties).assertSuccess(), { Alignment: cdk.stringToCloudFormation(properties.alignment), BackgroundColor: cdk.stringToCloudFormation(properties.backgroundColor), BackgroundOpacity: cdk.numberToCloudFormation(properties.backgroundOpacity), Font: cfnChannelInputLocationPropertyToCloudFormation(properties.font), FontColor: cdk.stringToCloudFormation(properties.fontColor), FontOpacity: cdk.numberToCloudFormation(properties.fontOpacity), FontResolution: cdk.numberToCloudFormation(properties.fontResolution), FontSize: cdk.stringToCloudFormation(properties.fontSize), OutlineColor: cdk.stringToCloudFormation(properties.outlineColor), OutlineSize: cdk.numberToCloudFormation(properties.outlineSize), ShadowColor: cdk.stringToCloudFormation(properties.shadowColor), ShadowOpacity: cdk.numberToCloudFormation(properties.shadowOpacity), ShadowXOffset: cdk.numberToCloudFormation(properties.shadowXOffset), ShadowYOffset: cdk.numberToCloudFormation(properties.shadowYOffset), TeletextGridControl: cdk.stringToCloudFormation(properties.teletextGridControl), XPosition: cdk.numberToCloudFormation(properties.xPosition), YPosition: cdk.numberToCloudFormation(properties.yPosition) }) : properties;
    }
    function CfnChannelBurnInDestinationSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alignment", "Alignment", properties.Alignment != null ? cfn_parse.FromCloudFormation.getString(properties.Alignment) : void 0), ret.addPropertyResult("backgroundColor", "BackgroundColor", properties.BackgroundColor != null ? cfn_parse.FromCloudFormation.getString(properties.BackgroundColor) : void 0), ret.addPropertyResult("backgroundOpacity", "BackgroundOpacity", properties.BackgroundOpacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.BackgroundOpacity) : void 0), ret.addPropertyResult("font", "Font", properties.Font != null ? CfnChannelInputLocationPropertyFromCloudFormation(properties.Font) : void 0), ret.addPropertyResult("fontColor", "FontColor", properties.FontColor != null ? cfn_parse.FromCloudFormation.getString(properties.FontColor) : void 0), ret.addPropertyResult("fontOpacity", "FontOpacity", properties.FontOpacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.FontOpacity) : void 0), ret.addPropertyResult("fontResolution", "FontResolution", properties.FontResolution != null ? cfn_parse.FromCloudFormation.getNumber(properties.FontResolution) : void 0), ret.addPropertyResult("fontSize", "FontSize", properties.FontSize != null ? cfn_parse.FromCloudFormation.getString(properties.FontSize) : void 0), ret.addPropertyResult("outlineColor", "OutlineColor", properties.OutlineColor != null ? cfn_parse.FromCloudFormation.getString(properties.OutlineColor) : void 0), ret.addPropertyResult("outlineSize", "OutlineSize", properties.OutlineSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.OutlineSize) : void 0), ret.addPropertyResult("shadowColor", "ShadowColor", properties.ShadowColor != null ? cfn_parse.FromCloudFormation.getString(properties.ShadowColor) : void 0), ret.addPropertyResult("shadowOpacity", "ShadowOpacity", properties.ShadowOpacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.ShadowOpacity) : void 0), ret.addPropertyResult("shadowXOffset", "ShadowXOffset", properties.ShadowXOffset != null ? cfn_parse.FromCloudFormation.getNumber(properties.ShadowXOffset) : void 0), ret.addPropertyResult("shadowYOffset", "ShadowYOffset", properties.ShadowYOffset != null ? cfn_parse.FromCloudFormation.getNumber(properties.ShadowYOffset) : void 0), ret.addPropertyResult("teletextGridControl", "TeletextGridControl", properties.TeletextGridControl != null ? cfn_parse.FromCloudFormation.getString(properties.TeletextGridControl) : void 0), ret.addPropertyResult("xPosition", "XPosition", properties.XPosition != null ? cfn_parse.FromCloudFormation.getNumber(properties.XPosition) : void 0), ret.addPropertyResult("yPosition", "YPosition", properties.YPosition != null ? cfn_parse.FromCloudFormation.getNumber(properties.YPosition) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_CaptionDescriptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessibility", cdk.validateString)(properties.accessibility)), errors.collect(cdk.propertyValidator("captionSelectorName", cdk.validateString)(properties.captionSelectorName)), errors.collect(cdk.propertyValidator("destinationSettings", CfnChannel_CaptionDestinationSettingsPropertyValidator)(properties.destinationSettings)), errors.collect(cdk.propertyValidator("languageCode", cdk.validateString)(properties.languageCode)), errors.collect(cdk.propertyValidator("languageDescription", cdk.validateString)(properties.languageDescription)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "CaptionDescriptionProperty"');
    }
    function cfnChannelCaptionDescriptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_CaptionDescriptionPropertyValidator(properties).assertSuccess(), { Accessibility: cdk.stringToCloudFormation(properties.accessibility), CaptionSelectorName: cdk.stringToCloudFormation(properties.captionSelectorName), DestinationSettings: cfnChannelCaptionDestinationSettingsPropertyToCloudFormation(properties.destinationSettings), LanguageCode: cdk.stringToCloudFormation(properties.languageCode), LanguageDescription: cdk.stringToCloudFormation(properties.languageDescription), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnChannelCaptionDescriptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessibility", "Accessibility", properties.Accessibility != null ? cfn_parse.FromCloudFormation.getString(properties.Accessibility) : void 0), ret.addPropertyResult("captionSelectorName", "CaptionSelectorName", properties.CaptionSelectorName != null ? cfn_parse.FromCloudFormation.getString(properties.CaptionSelectorName) : void 0), ret.addPropertyResult("destinationSettings", "DestinationSettings", properties.DestinationSettings != null ? CfnChannelCaptionDestinationSettingsPropertyFromCloudFormation(properties.DestinationSettings) : void 0), ret.addPropertyResult("languageCode", "LanguageCode", properties.LanguageCode != null ? cfn_parse.FromCloudFormation.getString(properties.LanguageCode) : void 0), ret.addPropertyResult("languageDescription", "LanguageDescription", properties.LanguageDescription != null ? cfn_parse.FromCloudFormation.getString(properties.LanguageDescription) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_CaptionDestinationSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aribDestinationSettings", CfnChannel_AribDestinationSettingsPropertyValidator)(properties.aribDestinationSettings)), errors.collect(cdk.propertyValidator("burnInDestinationSettings", CfnChannel_BurnInDestinationSettingsPropertyValidator)(properties.burnInDestinationSettings)), errors.collect(cdk.propertyValidator("dvbSubDestinationSettings", CfnChannel_DvbSubDestinationSettingsPropertyValidator)(properties.dvbSubDestinationSettings)), errors.collect(cdk.propertyValidator("ebuTtDDestinationSettings", CfnChannel_EbuTtDDestinationSettingsPropertyValidator)(properties.ebuTtDDestinationSettings)), errors.collect(cdk.propertyValidator("embeddedDestinationSettings", CfnChannel_EmbeddedDestinationSettingsPropertyValidator)(properties.embeddedDestinationSettings)), errors.collect(cdk.propertyValidator("embeddedPlusScte20DestinationSettings", CfnChannel_EmbeddedPlusScte20DestinationSettingsPropertyValidator)(properties.embeddedPlusScte20DestinationSettings)), errors.collect(cdk.propertyValidator("rtmpCaptionInfoDestinationSettings", CfnChannel_RtmpCaptionInfoDestinationSettingsPropertyValidator)(properties.rtmpCaptionInfoDestinationSettings)), errors.collect(cdk.propertyValidator("scte20PlusEmbeddedDestinationSettings", CfnChannel_Scte20PlusEmbeddedDestinationSettingsPropertyValidator)(properties.scte20PlusEmbeddedDestinationSettings)), errors.collect(cdk.propertyValidator("scte27DestinationSettings", CfnChannel_Scte27DestinationSettingsPropertyValidator)(properties.scte27DestinationSettings)), errors.collect(cdk.propertyValidator("smpteTtDestinationSettings", CfnChannel_SmpteTtDestinationSettingsPropertyValidator)(properties.smpteTtDestinationSettings)), errors.collect(cdk.propertyValidator("teletextDestinationSettings", CfnChannel_TeletextDestinationSettingsPropertyValidator)(properties.teletextDestinationSettings)), errors.collect(cdk.propertyValidator("ttmlDestinationSettings", CfnChannel_TtmlDestinationSettingsPropertyValidator)(properties.ttmlDestinationSettings)), errors.collect(cdk.propertyValidator("webvttDestinationSettings", CfnChannel_WebvttDestinationSettingsPropertyValidator)(properties.webvttDestinationSettings)), errors.wrap('supplied properties not correct for "CaptionDestinationSettingsProperty"');
    }
    function cfnChannelCaptionDestinationSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_CaptionDestinationSettingsPropertyValidator(properties).assertSuccess(), { AribDestinationSettings: cfnChannelAribDestinationSettingsPropertyToCloudFormation(properties.aribDestinationSettings), BurnInDestinationSettings: cfnChannelBurnInDestinationSettingsPropertyToCloudFormation(properties.burnInDestinationSettings), DvbSubDestinationSettings: cfnChannelDvbSubDestinationSettingsPropertyToCloudFormation(properties.dvbSubDestinationSettings), EbuTtDDestinationSettings: cfnChannelEbuTtDDestinationSettingsPropertyToCloudFormation(properties.ebuTtDDestinationSettings), EmbeddedDestinationSettings: cfnChannelEmbeddedDestinationSettingsPropertyToCloudFormation(properties.embeddedDestinationSettings), EmbeddedPlusScte20DestinationSettings: cfnChannelEmbeddedPlusScte20DestinationSettingsPropertyToCloudFormation(properties.embeddedPlusScte20DestinationSettings), RtmpCaptionInfoDestinationSettings: cfnChannelRtmpCaptionInfoDestinationSettingsPropertyToCloudFormation(properties.rtmpCaptionInfoDestinationSettings), Scte20PlusEmbeddedDestinationSettings: cfnChannelScte20PlusEmbeddedDestinationSettingsPropertyToCloudFormation(properties.scte20PlusEmbeddedDestinationSettings), Scte27DestinationSettings: cfnChannelScte27DestinationSettingsPropertyToCloudFormation(properties.scte27DestinationSettings), SmpteTtDestinationSettings: cfnChannelSmpteTtDestinationSettingsPropertyToCloudFormation(properties.smpteTtDestinationSettings), TeletextDestinationSettings: cfnChannelTeletextDestinationSettingsPropertyToCloudFormation(properties.teletextDestinationSettings), TtmlDestinationSettings: cfnChannelTtmlDestinationSettingsPropertyToCloudFormation(properties.ttmlDestinationSettings), WebvttDestinationSettings: cfnChannelWebvttDestinationSettingsPropertyToCloudFormation(properties.webvttDestinationSettings) }) : properties;
    }
    function CfnChannelCaptionDestinationSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aribDestinationSettings", "AribDestinationSettings", properties.AribDestinationSettings != null ? CfnChannelAribDestinationSettingsPropertyFromCloudFormation(properties.AribDestinationSettings) : void 0), ret.addPropertyResult("burnInDestinationSettings", "BurnInDestinationSettings", properties.BurnInDestinationSettings != null ? CfnChannelBurnInDestinationSettingsPropertyFromCloudFormation(properties.BurnInDestinationSettings) : void 0), ret.addPropertyResult("dvbSubDestinationSettings", "DvbSubDestinationSettings", properties.DvbSubDestinationSettings != null ? CfnChannelDvbSubDestinationSettingsPropertyFromCloudFormation(properties.DvbSubDestinationSettings) : void 0), ret.addPropertyResult("ebuTtDDestinationSettings", "EbuTtDDestinationSettings", properties.EbuTtDDestinationSettings != null ? CfnChannelEbuTtDDestinationSettingsPropertyFromCloudFormation(properties.EbuTtDDestinationSettings) : void 0), ret.addPropertyResult("embeddedDestinationSettings", "EmbeddedDestinationSettings", properties.EmbeddedDestinationSettings != null ? CfnChannelEmbeddedDestinationSettingsPropertyFromCloudFormation(properties.EmbeddedDestinationSettings) : void 0), ret.addPropertyResult("embeddedPlusScte20DestinationSettings", "EmbeddedPlusScte20DestinationSettings", properties.EmbeddedPlusScte20DestinationSettings != null ? CfnChannelEmbeddedPlusScte20DestinationSettingsPropertyFromCloudFormation(properties.EmbeddedPlusScte20DestinationSettings) : void 0), ret.addPropertyResult("rtmpCaptionInfoDestinationSettings", "RtmpCaptionInfoDestinationSettings", properties.RtmpCaptionInfoDestinationSettings != null ? CfnChannelRtmpCaptionInfoDestinationSettingsPropertyFromCloudFormation(properties.RtmpCaptionInfoDestinationSettings) : void 0), ret.addPropertyResult("scte20PlusEmbeddedDestinationSettings", "Scte20PlusEmbeddedDestinationSettings", properties.Scte20PlusEmbeddedDestinationSettings != null ? CfnChannelScte20PlusEmbeddedDestinationSettingsPropertyFromCloudFormation(properties.Scte20PlusEmbeddedDestinationSettings) : void 0), ret.addPropertyResult("scte27DestinationSettings", "Scte27DestinationSettings", properties.Scte27DestinationSettings != null ? CfnChannelScte27DestinationSettingsPropertyFromCloudFormation(properties.Scte27DestinationSettings) : void 0), ret.addPropertyResult("smpteTtDestinationSettings", "SmpteTtDestinationSettings", properties.SmpteTtDestinationSettings != null ? CfnChannelSmpteTtDestinationSettingsPropertyFromCloudFormation(properties.SmpteTtDestinationSettings) : void 0), ret.addPropertyResult("teletextDestinationSettings", "TeletextDestinationSettings", properties.TeletextDestinationSettings != null ? CfnChannelTeletextDestinationSettingsPropertyFromCloudFormation(properties.TeletextDestinationSettings) : void 0), ret.addPropertyResult("ttmlDestinationSettings", "TtmlDestinationSettings", properties.TtmlDestinationSettings != null ? CfnChannelTtmlDestinationSettingsPropertyFromCloudFormation(properties.TtmlDestinationSettings) : void 0), ret.addPropertyResult("webvttDestinationSettings", "WebvttDestinationSettings", properties.WebvttDestinationSettings != null ? CfnChannelWebvttDestinationSettingsPropertyFromCloudFormation(properties.WebvttDestinationSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_CaptionLanguageMappingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("captionChannel", cdk.validateNumber)(properties.captionChannel)), errors.collect(cdk.propertyValidator("languageCode", cdk.validateString)(properties.languageCode)), errors.collect(cdk.propertyValidator("languageDescription", cdk.validateString)(properties.languageDescription)), errors.wrap('supplied properties not correct for "CaptionLanguageMappingProperty"');
    }
    function cfnChannelCaptionLanguageMappingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_CaptionLanguageMappingPropertyValidator(properties).assertSuccess(), { CaptionChannel: cdk.numberToCloudFormation(properties.captionChannel), LanguageCode: cdk.stringToCloudFormation(properties.languageCode), LanguageDescription: cdk.stringToCloudFormation(properties.languageDescription) }) : properties;
    }
    function CfnChannelCaptionLanguageMappingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("captionChannel", "CaptionChannel", properties.CaptionChannel != null ? cfn_parse.FromCloudFormation.getNumber(properties.CaptionChannel) : void 0), ret.addPropertyResult("languageCode", "LanguageCode", properties.LanguageCode != null ? cfn_parse.FromCloudFormation.getString(properties.LanguageCode) : void 0), ret.addPropertyResult("languageDescription", "LanguageDescription", properties.LanguageDescription != null ? cfn_parse.FromCloudFormation.getString(properties.LanguageDescription) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_CaptionRectanglePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("height", cdk.validateNumber)(properties.height)), errors.collect(cdk.propertyValidator("leftOffset", cdk.validateNumber)(properties.leftOffset)), errors.collect(cdk.propertyValidator("topOffset", cdk.validateNumber)(properties.topOffset)), errors.collect(cdk.propertyValidator("width", cdk.validateNumber)(properties.width)), errors.wrap('supplied properties not correct for "CaptionRectangleProperty"');
    }
    function cfnChannelCaptionRectanglePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_CaptionRectanglePropertyValidator(properties).assertSuccess(), { Height: cdk.numberToCloudFormation(properties.height), LeftOffset: cdk.numberToCloudFormation(properties.leftOffset), TopOffset: cdk.numberToCloudFormation(properties.topOffset), Width: cdk.numberToCloudFormation(properties.width) }) : properties;
    }
    function CfnChannelCaptionRectanglePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("height", "Height", properties.Height != null ? cfn_parse.FromCloudFormation.getNumber(properties.Height) : void 0), ret.addPropertyResult("leftOffset", "LeftOffset", properties.LeftOffset != null ? cfn_parse.FromCloudFormation.getNumber(properties.LeftOffset) : void 0), ret.addPropertyResult("topOffset", "TopOffset", properties.TopOffset != null ? cfn_parse.FromCloudFormation.getNumber(properties.TopOffset) : void 0), ret.addPropertyResult("width", "Width", properties.Width != null ? cfn_parse.FromCloudFormation.getNumber(properties.Width) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_CaptionSelectorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("languageCode", cdk.validateString)(properties.languageCode)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("selectorSettings", CfnChannel_CaptionSelectorSettingsPropertyValidator)(properties.selectorSettings)), errors.wrap('supplied properties not correct for "CaptionSelectorProperty"');
    }
    function cfnChannelCaptionSelectorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_CaptionSelectorPropertyValidator(properties).assertSuccess(), { LanguageCode: cdk.stringToCloudFormation(properties.languageCode), Name: cdk.stringToCloudFormation(properties.name), SelectorSettings: cfnChannelCaptionSelectorSettingsPropertyToCloudFormation(properties.selectorSettings) }) : properties;
    }
    function CfnChannelCaptionSelectorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("languageCode", "LanguageCode", properties.LanguageCode != null ? cfn_parse.FromCloudFormation.getString(properties.LanguageCode) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("selectorSettings", "SelectorSettings", properties.SelectorSettings != null ? CfnChannelCaptionSelectorSettingsPropertyFromCloudFormation(properties.SelectorSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_CaptionSelectorSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ancillarySourceSettings", CfnChannel_AncillarySourceSettingsPropertyValidator)(properties.ancillarySourceSettings)), errors.collect(cdk.propertyValidator("aribSourceSettings", CfnChannel_AribSourceSettingsPropertyValidator)(properties.aribSourceSettings)), errors.collect(cdk.propertyValidator("dvbSubSourceSettings", CfnChannel_DvbSubSourceSettingsPropertyValidator)(properties.dvbSubSourceSettings)), errors.collect(cdk.propertyValidator("embeddedSourceSettings", CfnChannel_EmbeddedSourceSettingsPropertyValidator)(properties.embeddedSourceSettings)), errors.collect(cdk.propertyValidator("scte20SourceSettings", CfnChannel_Scte20SourceSettingsPropertyValidator)(properties.scte20SourceSettings)), errors.collect(cdk.propertyValidator("scte27SourceSettings", CfnChannel_Scte27SourceSettingsPropertyValidator)(properties.scte27SourceSettings)), errors.collect(cdk.propertyValidator("teletextSourceSettings", CfnChannel_TeletextSourceSettingsPropertyValidator)(properties.teletextSourceSettings)), errors.wrap('supplied properties not correct for "CaptionSelectorSettingsProperty"');
    }
    function cfnChannelCaptionSelectorSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_CaptionSelectorSettingsPropertyValidator(properties).assertSuccess(), { AncillarySourceSettings: cfnChannelAncillarySourceSettingsPropertyToCloudFormation(properties.ancillarySourceSettings), AribSourceSettings: cfnChannelAribSourceSettingsPropertyToCloudFormation(properties.aribSourceSettings), DvbSubSourceSettings: cfnChannelDvbSubSourceSettingsPropertyToCloudFormation(properties.dvbSubSourceSettings), EmbeddedSourceSettings: cfnChannelEmbeddedSourceSettingsPropertyToCloudFormation(properties.embeddedSourceSettings), Scte20SourceSettings: cfnChannelScte20SourceSettingsPropertyToCloudFormation(properties.scte20SourceSettings), Scte27SourceSettings: cfnChannelScte27SourceSettingsPropertyToCloudFormation(properties.scte27SourceSettings), TeletextSourceSettings: cfnChannelTeletextSourceSettingsPropertyToCloudFormation(properties.teletextSourceSettings) }) : properties;
    }
    function CfnChannelCaptionSelectorSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ancillarySourceSettings", "AncillarySourceSettings", properties.AncillarySourceSettings != null ? CfnChannelAncillarySourceSettingsPropertyFromCloudFormation(properties.AncillarySourceSettings) : void 0), ret.addPropertyResult("aribSourceSettings", "AribSourceSettings", properties.AribSourceSettings != null ? CfnChannelAribSourceSettingsPropertyFromCloudFormation(properties.AribSourceSettings) : void 0), ret.addPropertyResult("dvbSubSourceSettings", "DvbSubSourceSettings", properties.DvbSubSourceSettings != null ? CfnChannelDvbSubSourceSettingsPropertyFromCloudFormation(properties.DvbSubSourceSettings) : void 0), ret.addPropertyResult("embeddedSourceSettings", "EmbeddedSourceSettings", properties.EmbeddedSourceSettings != null ? CfnChannelEmbeddedSourceSettingsPropertyFromCloudFormation(properties.EmbeddedSourceSettings) : void 0), ret.addPropertyResult("scte20SourceSettings", "Scte20SourceSettings", properties.Scte20SourceSettings != null ? CfnChannelScte20SourceSettingsPropertyFromCloudFormation(properties.Scte20SourceSettings) : void 0), ret.addPropertyResult("scte27SourceSettings", "Scte27SourceSettings", properties.Scte27SourceSettings != null ? CfnChannelScte27SourceSettingsPropertyFromCloudFormation(properties.Scte27SourceSettings) : void 0), ret.addPropertyResult("teletextSourceSettings", "TeletextSourceSettings", properties.TeletextSourceSettings != null ? CfnChannelTeletextSourceSettingsPropertyFromCloudFormation(properties.TeletextSourceSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_CdiInputSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resolution", cdk.validateString)(properties.resolution)), errors.wrap('supplied properties not correct for "CdiInputSpecificationProperty"');
    }
    function cfnChannelCdiInputSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_CdiInputSpecificationPropertyValidator(properties).assertSuccess(), { Resolution: cdk.stringToCloudFormation(properties.resolution) }) : properties;
    }
    function CfnChannelCdiInputSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resolution", "Resolution", properties.Resolution != null ? cfn_parse.FromCloudFormation.getString(properties.Resolution) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_ColorSpacePassthroughSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.wrap('supplied properties not correct for "ColorSpacePassthroughSettingsProperty"');
    }
    function cfnChannelColorSpacePassthroughSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_ColorSpacePassthroughSettingsPropertyValidator(properties).assertSuccess(), {}) : properties;
    }
    function CfnChannelColorSpacePassthroughSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_DolbyVision81SettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.wrap('supplied properties not correct for "DolbyVision81SettingsProperty"');
    }
    function cfnChannelDolbyVision81SettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_DolbyVision81SettingsPropertyValidator(properties).assertSuccess(), {}) : properties;
    }
    function CfnChannelDolbyVision81SettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_DvbNitSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("networkId", cdk.validateNumber)(properties.networkId)), errors.collect(cdk.propertyValidator("networkName", cdk.validateString)(properties.networkName)), errors.collect(cdk.propertyValidator("repInterval", cdk.validateNumber)(properties.repInterval)), errors.wrap('supplied properties not correct for "DvbNitSettingsProperty"');
    }
    function cfnChannelDvbNitSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_DvbNitSettingsPropertyValidator(properties).assertSuccess(), { NetworkId: cdk.numberToCloudFormation(properties.networkId), NetworkName: cdk.stringToCloudFormation(properties.networkName), RepInterval: cdk.numberToCloudFormation(properties.repInterval) }) : properties;
    }
    function CfnChannelDvbNitSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("networkId", "NetworkId", properties.NetworkId != null ? cfn_parse.FromCloudFormation.getNumber(properties.NetworkId) : void 0), ret.addPropertyResult("networkName", "NetworkName", properties.NetworkName != null ? cfn_parse.FromCloudFormation.getString(properties.NetworkName) : void 0), ret.addPropertyResult("repInterval", "RepInterval", properties.RepInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.RepInterval) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_DvbSdtSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("outputSdt", cdk.validateString)(properties.outputSdt)), errors.collect(cdk.propertyValidator("repInterval", cdk.validateNumber)(properties.repInterval)), errors.collect(cdk.propertyValidator("serviceName", cdk.validateString)(properties.serviceName)), errors.collect(cdk.propertyValidator("serviceProviderName", cdk.validateString)(properties.serviceProviderName)), errors.wrap('supplied properties not correct for "DvbSdtSettingsProperty"');
    }
    function cfnChannelDvbSdtSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_DvbSdtSettingsPropertyValidator(properties).assertSuccess(), { OutputSdt: cdk.stringToCloudFormation(properties.outputSdt), RepInterval: cdk.numberToCloudFormation(properties.repInterval), ServiceName: cdk.stringToCloudFormation(properties.serviceName), ServiceProviderName: cdk.stringToCloudFormation(properties.serviceProviderName) }) : properties;
    }
    function CfnChannelDvbSdtSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("outputSdt", "OutputSdt", properties.OutputSdt != null ? cfn_parse.FromCloudFormation.getString(properties.OutputSdt) : void 0), ret.addPropertyResult("repInterval", "RepInterval", properties.RepInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.RepInterval) : void 0), ret.addPropertyResult("serviceName", "ServiceName", properties.ServiceName != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceName) : void 0), ret.addPropertyResult("serviceProviderName", "ServiceProviderName", properties.ServiceProviderName != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceProviderName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_DvbSubDestinationSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alignment", cdk.validateString)(properties.alignment)), errors.collect(cdk.propertyValidator("backgroundColor", cdk.validateString)(properties.backgroundColor)), errors.collect(cdk.propertyValidator("backgroundOpacity", cdk.validateNumber)(properties.backgroundOpacity)), errors.collect(cdk.propertyValidator("font", CfnChannel_InputLocationPropertyValidator)(properties.font)), errors.collect(cdk.propertyValidator("fontColor", cdk.validateString)(properties.fontColor)), errors.collect(cdk.propertyValidator("fontOpacity", cdk.validateNumber)(properties.fontOpacity)), errors.collect(cdk.propertyValidator("fontResolution", cdk.validateNumber)(properties.fontResolution)), errors.collect(cdk.propertyValidator("fontSize", cdk.validateString)(properties.fontSize)), errors.collect(cdk.propertyValidator("outlineColor", cdk.validateString)(properties.outlineColor)), errors.collect(cdk.propertyValidator("outlineSize", cdk.validateNumber)(properties.outlineSize)), errors.collect(cdk.propertyValidator("shadowColor", cdk.validateString)(properties.shadowColor)), errors.collect(cdk.propertyValidator("shadowOpacity", cdk.validateNumber)(properties.shadowOpacity)), errors.collect(cdk.propertyValidator("shadowXOffset", cdk.validateNumber)(properties.shadowXOffset)), errors.collect(cdk.propertyValidator("shadowYOffset", cdk.validateNumber)(properties.shadowYOffset)), errors.collect(cdk.propertyValidator("teletextGridControl", cdk.validateString)(properties.teletextGridControl)), errors.collect(cdk.propertyValidator("xPosition", cdk.validateNumber)(properties.xPosition)), errors.collect(cdk.propertyValidator("yPosition", cdk.validateNumber)(properties.yPosition)), errors.wrap('supplied properties not correct for "DvbSubDestinationSettingsProperty"');
    }
    function cfnChannelDvbSubDestinationSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_DvbSubDestinationSettingsPropertyValidator(properties).assertSuccess(), { Alignment: cdk.stringToCloudFormation(properties.alignment), BackgroundColor: cdk.stringToCloudFormation(properties.backgroundColor), BackgroundOpacity: cdk.numberToCloudFormation(properties.backgroundOpacity), Font: cfnChannelInputLocationPropertyToCloudFormation(properties.font), FontColor: cdk.stringToCloudFormation(properties.fontColor), FontOpacity: cdk.numberToCloudFormation(properties.fontOpacity), FontResolution: cdk.numberToCloudFormation(properties.fontResolution), FontSize: cdk.stringToCloudFormation(properties.fontSize), OutlineColor: cdk.stringToCloudFormation(properties.outlineColor), OutlineSize: cdk.numberToCloudFormation(properties.outlineSize), ShadowColor: cdk.stringToCloudFormation(properties.shadowColor), ShadowOpacity: cdk.numberToCloudFormation(properties.shadowOpacity), ShadowXOffset: cdk.numberToCloudFormation(properties.shadowXOffset), ShadowYOffset: cdk.numberToCloudFormation(properties.shadowYOffset), TeletextGridControl: cdk.stringToCloudFormation(properties.teletextGridControl), XPosition: cdk.numberToCloudFormation(properties.xPosition), YPosition: cdk.numberToCloudFormation(properties.yPosition) }) : properties;
    }
    function CfnChannelDvbSubDestinationSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alignment", "Alignment", properties.Alignment != null ? cfn_parse.FromCloudFormation.getString(properties.Alignment) : void 0), ret.addPropertyResult("backgroundColor", "BackgroundColor", properties.BackgroundColor != null ? cfn_parse.FromCloudFormation.getString(properties.BackgroundColor) : void 0), ret.addPropertyResult("backgroundOpacity", "BackgroundOpacity", properties.BackgroundOpacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.BackgroundOpacity) : void 0), ret.addPropertyResult("font", "Font", properties.Font != null ? CfnChannelInputLocationPropertyFromCloudFormation(properties.Font) : void 0), ret.addPropertyResult("fontColor", "FontColor", properties.FontColor != null ? cfn_parse.FromCloudFormation.getString(properties.FontColor) : void 0), ret.addPropertyResult("fontOpacity", "FontOpacity", properties.FontOpacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.FontOpacity) : void 0), ret.addPropertyResult("fontResolution", "FontResolution", properties.FontResolution != null ? cfn_parse.FromCloudFormation.getNumber(properties.FontResolution) : void 0), ret.addPropertyResult("fontSize", "FontSize", properties.FontSize != null ? cfn_parse.FromCloudFormation.getString(properties.FontSize) : void 0), ret.addPropertyResult("outlineColor", "OutlineColor", properties.OutlineColor != null ? cfn_parse.FromCloudFormation.getString(properties.OutlineColor) : void 0), ret.addPropertyResult("outlineSize", "OutlineSize", properties.OutlineSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.OutlineSize) : void 0), ret.addPropertyResult("shadowColor", "ShadowColor", properties.ShadowColor != null ? cfn_parse.FromCloudFormation.getString(properties.ShadowColor) : void 0), ret.addPropertyResult("shadowOpacity", "ShadowOpacity", properties.ShadowOpacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.ShadowOpacity) : void 0), ret.addPropertyResult("shadowXOffset", "ShadowXOffset", properties.ShadowXOffset != null ? cfn_parse.FromCloudFormation.getNumber(properties.ShadowXOffset) : void 0), ret.addPropertyResult("shadowYOffset", "ShadowYOffset", properties.ShadowYOffset != null ? cfn_parse.FromCloudFormation.getNumber(properties.ShadowYOffset) : void 0), ret.addPropertyResult("teletextGridControl", "TeletextGridControl", properties.TeletextGridControl != null ? cfn_parse.FromCloudFormation.getString(properties.TeletextGridControl) : void 0), ret.addPropertyResult("xPosition", "XPosition", properties.XPosition != null ? cfn_parse.FromCloudFormation.getNumber(properties.XPosition) : void 0), ret.addPropertyResult("yPosition", "YPosition", properties.YPosition != null ? cfn_parse.FromCloudFormation.getNumber(properties.YPosition) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_DvbSubSourceSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ocrLanguage", cdk.validateString)(properties.ocrLanguage)), errors.collect(cdk.propertyValidator("pid", cdk.validateNumber)(properties.pid)), errors.wrap('supplied properties not correct for "DvbSubSourceSettingsProperty"');
    }
    function cfnChannelDvbSubSourceSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_DvbSubSourceSettingsPropertyValidator(properties).assertSuccess(), { OcrLanguage: cdk.stringToCloudFormation(properties.ocrLanguage), Pid: cdk.numberToCloudFormation(properties.pid) }) : properties;
    }
    function CfnChannelDvbSubSourceSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ocrLanguage", "OcrLanguage", properties.OcrLanguage != null ? cfn_parse.FromCloudFormation.getString(properties.OcrLanguage) : void 0), ret.addPropertyResult("pid", "Pid", properties.Pid != null ? cfn_parse.FromCloudFormation.getNumber(properties.Pid) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_DvbTdtSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("repInterval", cdk.validateNumber)(properties.repInterval)), errors.wrap('supplied properties not correct for "DvbTdtSettingsProperty"');
    }
    function cfnChannelDvbTdtSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_DvbTdtSettingsPropertyValidator(properties).assertSuccess(), { RepInterval: cdk.numberToCloudFormation(properties.repInterval) }) : properties;
    }
    function CfnChannelDvbTdtSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("repInterval", "RepInterval", properties.RepInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.RepInterval) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_Eac3AtmosSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bitrate", cdk.validateNumber)(properties.bitrate)), errors.collect(cdk.propertyValidator("codingMode", cdk.validateString)(properties.codingMode)), errors.collect(cdk.propertyValidator("dialnorm", cdk.validateNumber)(properties.dialnorm)), errors.collect(cdk.propertyValidator("drcLine", cdk.validateString)(properties.drcLine)), errors.collect(cdk.propertyValidator("drcRf", cdk.validateString)(properties.drcRf)), errors.collect(cdk.propertyValidator("heightTrim", cdk.validateNumber)(properties.heightTrim)), errors.collect(cdk.propertyValidator("surroundTrim", cdk.validateNumber)(properties.surroundTrim)), errors.wrap('supplied properties not correct for "Eac3AtmosSettingsProperty"');
    }
    function cfnChannelEac3AtmosSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_Eac3AtmosSettingsPropertyValidator(properties).assertSuccess(), { Bitrate: cdk.numberToCloudFormation(properties.bitrate), CodingMode: cdk.stringToCloudFormation(properties.codingMode), Dialnorm: cdk.numberToCloudFormation(properties.dialnorm), DrcLine: cdk.stringToCloudFormation(properties.drcLine), DrcRf: cdk.stringToCloudFormation(properties.drcRf), HeightTrim: cdk.numberToCloudFormation(properties.heightTrim), SurroundTrim: cdk.numberToCloudFormation(properties.surroundTrim) }) : properties;
    }
    function CfnChannelEac3AtmosSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bitrate", "Bitrate", properties.Bitrate != null ? cfn_parse.FromCloudFormation.getNumber(properties.Bitrate) : void 0), ret.addPropertyResult("codingMode", "CodingMode", properties.CodingMode != null ? cfn_parse.FromCloudFormation.getString(properties.CodingMode) : void 0), ret.addPropertyResult("dialnorm", "Dialnorm", properties.Dialnorm != null ? cfn_parse.FromCloudFormation.getNumber(properties.Dialnorm) : void 0), ret.addPropertyResult("drcLine", "DrcLine", properties.DrcLine != null ? cfn_parse.FromCloudFormation.getString(properties.DrcLine) : void 0), ret.addPropertyResult("drcRf", "DrcRf", properties.DrcRf != null ? cfn_parse.FromCloudFormation.getString(properties.DrcRf) : void 0), ret.addPropertyResult("heightTrim", "HeightTrim", properties.HeightTrim != null ? cfn_parse.FromCloudFormation.getNumber(properties.HeightTrim) : void 0), ret.addPropertyResult("surroundTrim", "SurroundTrim", properties.SurroundTrim != null ? cfn_parse.FromCloudFormation.getNumber(properties.SurroundTrim) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_Eac3SettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attenuationControl", cdk.validateString)(properties.attenuationControl)), errors.collect(cdk.propertyValidator("bitrate", cdk.validateNumber)(properties.bitrate)), errors.collect(cdk.propertyValidator("bitstreamMode", cdk.validateString)(properties.bitstreamMode)), errors.collect(cdk.propertyValidator("codingMode", cdk.validateString)(properties.codingMode)), errors.collect(cdk.propertyValidator("dcFilter", cdk.validateString)(properties.dcFilter)), errors.collect(cdk.propertyValidator("dialnorm", cdk.validateNumber)(properties.dialnorm)), errors.collect(cdk.propertyValidator("drcLine", cdk.validateString)(properties.drcLine)), errors.collect(cdk.propertyValidator("drcRf", cdk.validateString)(properties.drcRf)), errors.collect(cdk.propertyValidator("lfeControl", cdk.validateString)(properties.lfeControl)), errors.collect(cdk.propertyValidator("lfeFilter", cdk.validateString)(properties.lfeFilter)), errors.collect(cdk.propertyValidator("loRoCenterMixLevel", cdk.validateNumber)(properties.loRoCenterMixLevel)), errors.collect(cdk.propertyValidator("loRoSurroundMixLevel", cdk.validateNumber)(properties.loRoSurroundMixLevel)), errors.collect(cdk.propertyValidator("ltRtCenterMixLevel", cdk.validateNumber)(properties.ltRtCenterMixLevel)), errors.collect(cdk.propertyValidator("ltRtSurroundMixLevel", cdk.validateNumber)(properties.ltRtSurroundMixLevel)), errors.collect(cdk.propertyValidator("metadataControl", cdk.validateString)(properties.metadataControl)), errors.collect(cdk.propertyValidator("passthroughControl", cdk.validateString)(properties.passthroughControl)), errors.collect(cdk.propertyValidator("phaseControl", cdk.validateString)(properties.phaseControl)), errors.collect(cdk.propertyValidator("stereoDownmix", cdk.validateString)(properties.stereoDownmix)), errors.collect(cdk.propertyValidator("surroundExMode", cdk.validateString)(properties.surroundExMode)), errors.collect(cdk.propertyValidator("surroundMode", cdk.validateString)(properties.surroundMode)), errors.wrap('supplied properties not correct for "Eac3SettingsProperty"');
    }
    function cfnChannelEac3SettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_Eac3SettingsPropertyValidator(properties).assertSuccess(), { AttenuationControl: cdk.stringToCloudFormation(properties.attenuationControl), Bitrate: cdk.numberToCloudFormation(properties.bitrate), BitstreamMode: cdk.stringToCloudFormation(properties.bitstreamMode), CodingMode: cdk.stringToCloudFormation(properties.codingMode), DcFilter: cdk.stringToCloudFormation(properties.dcFilter), Dialnorm: cdk.numberToCloudFormation(properties.dialnorm), DrcLine: cdk.stringToCloudFormation(properties.drcLine), DrcRf: cdk.stringToCloudFormation(properties.drcRf), LfeControl: cdk.stringToCloudFormation(properties.lfeControl), LfeFilter: cdk.stringToCloudFormation(properties.lfeFilter), LoRoCenterMixLevel: cdk.numberToCloudFormation(properties.loRoCenterMixLevel), LoRoSurroundMixLevel: cdk.numberToCloudFormation(properties.loRoSurroundMixLevel), LtRtCenterMixLevel: cdk.numberToCloudFormation(properties.ltRtCenterMixLevel), LtRtSurroundMixLevel: cdk.numberToCloudFormation(properties.ltRtSurroundMixLevel), MetadataControl: cdk.stringToCloudFormation(properties.metadataControl), PassthroughControl: cdk.stringToCloudFormation(properties.passthroughControl), PhaseControl: cdk.stringToCloudFormation(properties.phaseControl), StereoDownmix: cdk.stringToCloudFormation(properties.stereoDownmix), SurroundExMode: cdk.stringToCloudFormation(properties.surroundExMode), SurroundMode: cdk.stringToCloudFormation(properties.surroundMode) }) : properties;
    }
    function CfnChannelEac3SettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attenuationControl", "AttenuationControl", properties.AttenuationControl != null ? cfn_parse.FromCloudFormation.getString(properties.AttenuationControl) : void 0), ret.addPropertyResult("bitrate", "Bitrate", properties.Bitrate != null ? cfn_parse.FromCloudFormation.getNumber(properties.Bitrate) : void 0), ret.addPropertyResult("bitstreamMode", "BitstreamMode", properties.BitstreamMode != null ? cfn_parse.FromCloudFormation.getString(properties.BitstreamMode) : void 0), ret.addPropertyResult("codingMode", "CodingMode", properties.CodingMode != null ? cfn_parse.FromCloudFormation.getString(properties.CodingMode) : void 0), ret.addPropertyResult("dcFilter", "DcFilter", properties.DcFilter != null ? cfn_parse.FromCloudFormation.getString(properties.DcFilter) : void 0), ret.addPropertyResult("dialnorm", "Dialnorm", properties.Dialnorm != null ? cfn_parse.FromCloudFormation.getNumber(properties.Dialnorm) : void 0), ret.addPropertyResult("drcLine", "DrcLine", properties.DrcLine != null ? cfn_parse.FromCloudFormation.getString(properties.DrcLine) : void 0), ret.addPropertyResult("drcRf", "DrcRf", properties.DrcRf != null ? cfn_parse.FromCloudFormation.getString(properties.DrcRf) : void 0), ret.addPropertyResult("lfeControl", "LfeControl", properties.LfeControl != null ? cfn_parse.FromCloudFormation.getString(properties.LfeControl) : void 0), ret.addPropertyResult("lfeFilter", "LfeFilter", properties.LfeFilter != null ? cfn_parse.FromCloudFormation.getString(properties.LfeFilter) : void 0), ret.addPropertyResult("loRoCenterMixLevel", "LoRoCenterMixLevel", properties.LoRoCenterMixLevel != null ? cfn_parse.FromCloudFormation.getNumber(properties.LoRoCenterMixLevel) : void 0), ret.addPropertyResult("loRoSurroundMixLevel", "LoRoSurroundMixLevel", properties.LoRoSurroundMixLevel != null ? cfn_parse.FromCloudFormation.getNumber(properties.LoRoSurroundMixLevel) : void 0), ret.addPropertyResult("ltRtCenterMixLevel", "LtRtCenterMixLevel", properties.LtRtCenterMixLevel != null ? cfn_parse.FromCloudFormation.getNumber(properties.LtRtCenterMixLevel) : void 0), ret.addPropertyResult("ltRtSurroundMixLevel", "LtRtSurroundMixLevel", properties.LtRtSurroundMixLevel != null ? cfn_parse.FromCloudFormation.getNumber(properties.LtRtSurroundMixLevel) : void 0), ret.addPropertyResult("metadataControl", "MetadataControl", properties.MetadataControl != null ? cfn_parse.FromCloudFormation.getString(properties.MetadataControl) : void 0), ret.addPropertyResult("passthroughControl", "PassthroughControl", properties.PassthroughControl != null ? cfn_parse.FromCloudFormation.getString(properties.PassthroughControl) : void 0), ret.addPropertyResult("phaseControl", "PhaseControl", properties.PhaseControl != null ? cfn_parse.FromCloudFormation.getString(properties.PhaseControl) : void 0), ret.addPropertyResult("stereoDownmix", "StereoDownmix", properties.StereoDownmix != null ? cfn_parse.FromCloudFormation.getString(properties.StereoDownmix) : void 0), ret.addPropertyResult("surroundExMode", "SurroundExMode", properties.SurroundExMode != null ? cfn_parse.FromCloudFormation.getString(properties.SurroundExMode) : void 0), ret.addPropertyResult("surroundMode", "SurroundMode", properties.SurroundMode != null ? cfn_parse.FromCloudFormation.getString(properties.SurroundMode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_EbuTtDDestinationSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("copyrightHolder", cdk.validateString)(properties.copyrightHolder)), errors.collect(cdk.propertyValidator("fillLineGap", cdk.validateString)(properties.fillLineGap)), errors.collect(cdk.propertyValidator("fontFamily", cdk.validateString)(properties.fontFamily)), errors.collect(cdk.propertyValidator("styleControl", cdk.validateString)(properties.styleControl)), errors.wrap('supplied properties not correct for "EbuTtDDestinationSettingsProperty"');
    }
    function cfnChannelEbuTtDDestinationSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_EbuTtDDestinationSettingsPropertyValidator(properties).assertSuccess(), { CopyrightHolder: cdk.stringToCloudFormation(properties.copyrightHolder), FillLineGap: cdk.stringToCloudFormation(properties.fillLineGap), FontFamily: cdk.stringToCloudFormation(properties.fontFamily), StyleControl: cdk.stringToCloudFormation(properties.styleControl) }) : properties;
    }
    function CfnChannelEbuTtDDestinationSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("copyrightHolder", "CopyrightHolder", properties.CopyrightHolder != null ? cfn_parse.FromCloudFormation.getString(properties.CopyrightHolder) : void 0), ret.addPropertyResult("fillLineGap", "FillLineGap", properties.FillLineGap != null ? cfn_parse.FromCloudFormation.getString(properties.FillLineGap) : void 0), ret.addPropertyResult("fontFamily", "FontFamily", properties.FontFamily != null ? cfn_parse.FromCloudFormation.getString(properties.FontFamily) : void 0), ret.addPropertyResult("styleControl", "StyleControl", properties.StyleControl != null ? cfn_parse.FromCloudFormation.getString(properties.StyleControl) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_EmbeddedDestinationSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.wrap('supplied properties not correct for "EmbeddedDestinationSettingsProperty"');
    }
    function cfnChannelEmbeddedDestinationSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_EmbeddedDestinationSettingsPropertyValidator(properties).assertSuccess(), {}) : properties;
    }
    function CfnChannelEmbeddedDestinationSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_EmbeddedPlusScte20DestinationSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.wrap('supplied properties not correct for "EmbeddedPlusScte20DestinationSettingsProperty"');
    }
    function cfnChannelEmbeddedPlusScte20DestinationSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_EmbeddedPlusScte20DestinationSettingsPropertyValidator(properties).assertSuccess(), {}) : properties;
    }
    function CfnChannelEmbeddedPlusScte20DestinationSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_EmbeddedSourceSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("convert608To708", cdk.validateString)(properties.convert608To708)), errors.collect(cdk.propertyValidator("scte20Detection", cdk.validateString)(properties.scte20Detection)), errors.collect(cdk.propertyValidator("source608ChannelNumber", cdk.validateNumber)(properties.source608ChannelNumber)), errors.collect(cdk.propertyValidator("source608TrackNumber", cdk.validateNumber)(properties.source608TrackNumber)), errors.wrap('supplied properties not correct for "EmbeddedSourceSettingsProperty"');
    }
    function cfnChannelEmbeddedSourceSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_EmbeddedSourceSettingsPropertyValidator(properties).assertSuccess(), { Convert608To708: cdk.stringToCloudFormation(properties.convert608To708), Scte20Detection: cdk.stringToCloudFormation(properties.scte20Detection), Source608ChannelNumber: cdk.numberToCloudFormation(properties.source608ChannelNumber), Source608TrackNumber: cdk.numberToCloudFormation(properties.source608TrackNumber) }) : properties;
    }
    function CfnChannelEmbeddedSourceSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("convert608To708", "Convert608To708", properties.Convert608To708 != null ? cfn_parse.FromCloudFormation.getString(properties.Convert608To708) : void 0), ret.addPropertyResult("scte20Detection", "Scte20Detection", properties.Scte20Detection != null ? cfn_parse.FromCloudFormation.getString(properties.Scte20Detection) : void 0), ret.addPropertyResult("source608ChannelNumber", "Source608ChannelNumber", properties.Source608ChannelNumber != null ? cfn_parse.FromCloudFormation.getNumber(properties.Source608ChannelNumber) : void 0), ret.addPropertyResult("source608TrackNumber", "Source608TrackNumber", properties.Source608TrackNumber != null ? cfn_parse.FromCloudFormation.getNumber(properties.Source608TrackNumber) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_EncoderSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("audioDescriptions", cdk.listValidator(CfnChannel_AudioDescriptionPropertyValidator))(properties.audioDescriptions)), errors.collect(cdk.propertyValidator("availBlanking", CfnChannel_AvailBlankingPropertyValidator)(properties.availBlanking)), errors.collect(cdk.propertyValidator("availConfiguration", CfnChannel_AvailConfigurationPropertyValidator)(properties.availConfiguration)), errors.collect(cdk.propertyValidator("blackoutSlate", CfnChannel_BlackoutSlatePropertyValidator)(properties.blackoutSlate)), errors.collect(cdk.propertyValidator("captionDescriptions", cdk.listValidator(CfnChannel_CaptionDescriptionPropertyValidator))(properties.captionDescriptions)), errors.collect(cdk.propertyValidator("featureActivations", CfnChannel_FeatureActivationsPropertyValidator)(properties.featureActivations)), errors.collect(cdk.propertyValidator("globalConfiguration", CfnChannel_GlobalConfigurationPropertyValidator)(properties.globalConfiguration)), errors.collect(cdk.propertyValidator("motionGraphicsConfiguration", CfnChannel_MotionGraphicsConfigurationPropertyValidator)(properties.motionGraphicsConfiguration)), errors.collect(cdk.propertyValidator("nielsenConfiguration", CfnChannel_NielsenConfigurationPropertyValidator)(properties.nielsenConfiguration)), errors.collect(cdk.propertyValidator("outputGroups", cdk.listValidator(CfnChannel_OutputGroupPropertyValidator))(properties.outputGroups)), errors.collect(cdk.propertyValidator("timecodeConfig", CfnChannel_TimecodeConfigPropertyValidator)(properties.timecodeConfig)), errors.collect(cdk.propertyValidator("videoDescriptions", cdk.listValidator(CfnChannel_VideoDescriptionPropertyValidator))(properties.videoDescriptions)), errors.wrap('supplied properties not correct for "EncoderSettingsProperty"');
    }
    function cfnChannelEncoderSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_EncoderSettingsPropertyValidator(properties).assertSuccess(), { AudioDescriptions: cdk.listMapper(cfnChannelAudioDescriptionPropertyToCloudFormation)(properties.audioDescriptions), AvailBlanking: cfnChannelAvailBlankingPropertyToCloudFormation(properties.availBlanking), AvailConfiguration: cfnChannelAvailConfigurationPropertyToCloudFormation(properties.availConfiguration), BlackoutSlate: cfnChannelBlackoutSlatePropertyToCloudFormation(properties.blackoutSlate), CaptionDescriptions: cdk.listMapper(cfnChannelCaptionDescriptionPropertyToCloudFormation)(properties.captionDescriptions), FeatureActivations: cfnChannelFeatureActivationsPropertyToCloudFormation(properties.featureActivations), GlobalConfiguration: cfnChannelGlobalConfigurationPropertyToCloudFormation(properties.globalConfiguration), MotionGraphicsConfiguration: cfnChannelMotionGraphicsConfigurationPropertyToCloudFormation(properties.motionGraphicsConfiguration), NielsenConfiguration: cfnChannelNielsenConfigurationPropertyToCloudFormation(properties.nielsenConfiguration), OutputGroups: cdk.listMapper(cfnChannelOutputGroupPropertyToCloudFormation)(properties.outputGroups), TimecodeConfig: cfnChannelTimecodeConfigPropertyToCloudFormation(properties.timecodeConfig), VideoDescriptions: cdk.listMapper(cfnChannelVideoDescriptionPropertyToCloudFormation)(properties.videoDescriptions) }) : properties;
    }
    function CfnChannelEncoderSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("audioDescriptions", "AudioDescriptions", properties.AudioDescriptions != null ? cfn_parse.FromCloudFormation.getArray(CfnChannelAudioDescriptionPropertyFromCloudFormation)(properties.AudioDescriptions) : void 0), ret.addPropertyResult("availBlanking", "AvailBlanking", properties.AvailBlanking != null ? CfnChannelAvailBlankingPropertyFromCloudFormation(properties.AvailBlanking) : void 0), ret.addPropertyResult("availConfiguration", "AvailConfiguration", properties.AvailConfiguration != null ? CfnChannelAvailConfigurationPropertyFromCloudFormation(properties.AvailConfiguration) : void 0), ret.addPropertyResult("blackoutSlate", "BlackoutSlate", properties.BlackoutSlate != null ? CfnChannelBlackoutSlatePropertyFromCloudFormation(properties.BlackoutSlate) : void 0), ret.addPropertyResult("captionDescriptions", "CaptionDescriptions", properties.CaptionDescriptions != null ? cfn_parse.FromCloudFormation.getArray(CfnChannelCaptionDescriptionPropertyFromCloudFormation)(properties.CaptionDescriptions) : void 0), ret.addPropertyResult("featureActivations", "FeatureActivations", properties.FeatureActivations != null ? CfnChannelFeatureActivationsPropertyFromCloudFormation(properties.FeatureActivations) : void 0), ret.addPropertyResult("globalConfiguration", "GlobalConfiguration", properties.GlobalConfiguration != null ? CfnChannelGlobalConfigurationPropertyFromCloudFormation(properties.GlobalConfiguration) : void 0), ret.addPropertyResult("motionGraphicsConfiguration", "MotionGraphicsConfiguration", properties.MotionGraphicsConfiguration != null ? CfnChannelMotionGraphicsConfigurationPropertyFromCloudFormation(properties.MotionGraphicsConfiguration) : void 0), ret.addPropertyResult("nielsenConfiguration", "NielsenConfiguration", properties.NielsenConfiguration != null ? CfnChannelNielsenConfigurationPropertyFromCloudFormation(properties.NielsenConfiguration) : void 0), ret.addPropertyResult("outputGroups", "OutputGroups", properties.OutputGroups != null ? cfn_parse.FromCloudFormation.getArray(CfnChannelOutputGroupPropertyFromCloudFormation)(properties.OutputGroups) : void 0), ret.addPropertyResult("timecodeConfig", "TimecodeConfig", properties.TimecodeConfig != null ? CfnChannelTimecodeConfigPropertyFromCloudFormation(properties.TimecodeConfig) : void 0), ret.addPropertyResult("videoDescriptions", "VideoDescriptions", properties.VideoDescriptions != null ? cfn_parse.FromCloudFormation.getArray(CfnChannelVideoDescriptionPropertyFromCloudFormation)(properties.VideoDescriptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_EsamPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acquisitionPointId", cdk.validateString)(properties.acquisitionPointId)), errors.collect(cdk.propertyValidator("adAvailOffset", cdk.validateNumber)(properties.adAvailOffset)), errors.collect(cdk.propertyValidator("passwordParam", cdk.validateString)(properties.passwordParam)), errors.collect(cdk.propertyValidator("poisEndpoint", cdk.validateString)(properties.poisEndpoint)), errors.collect(cdk.propertyValidator("username", cdk.validateString)(properties.username)), errors.collect(cdk.propertyValidator("zoneIdentity", cdk.validateString)(properties.zoneIdentity)), errors.wrap('supplied properties not correct for "EsamProperty"');
    }
    function cfnChannelEsamPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_EsamPropertyValidator(properties).assertSuccess(), { AcquisitionPointId: cdk.stringToCloudFormation(properties.acquisitionPointId), AdAvailOffset: cdk.numberToCloudFormation(properties.adAvailOffset), PasswordParam: cdk.stringToCloudFormation(properties.passwordParam), PoisEndpoint: cdk.stringToCloudFormation(properties.poisEndpoint), Username: cdk.stringToCloudFormation(properties.username), ZoneIdentity: cdk.stringToCloudFormation(properties.zoneIdentity) }) : properties;
    }
    function CfnChannelEsamPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("acquisitionPointId", "AcquisitionPointId", properties.AcquisitionPointId != null ? cfn_parse.FromCloudFormation.getString(properties.AcquisitionPointId) : void 0), ret.addPropertyResult("adAvailOffset", "AdAvailOffset", properties.AdAvailOffset != null ? cfn_parse.FromCloudFormation.getNumber(properties.AdAvailOffset) : void 0), ret.addPropertyResult("passwordParam", "PasswordParam", properties.PasswordParam != null ? cfn_parse.FromCloudFormation.getString(properties.PasswordParam) : void 0), ret.addPropertyResult("poisEndpoint", "PoisEndpoint", properties.PoisEndpoint != null ? cfn_parse.FromCloudFormation.getString(properties.PoisEndpoint) : void 0), ret.addPropertyResult("username", "Username", properties.Username != null ? cfn_parse.FromCloudFormation.getString(properties.Username) : void 0), ret.addPropertyResult("zoneIdentity", "ZoneIdentity", properties.ZoneIdentity != null ? cfn_parse.FromCloudFormation.getString(properties.ZoneIdentity) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_FailoverConditionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("failoverConditionSettings", CfnChannel_FailoverConditionSettingsPropertyValidator)(properties.failoverConditionSettings)), errors.wrap('supplied properties not correct for "FailoverConditionProperty"');
    }
    function cfnChannelFailoverConditionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_FailoverConditionPropertyValidator(properties).assertSuccess(), { FailoverConditionSettings: cfnChannelFailoverConditionSettingsPropertyToCloudFormation(properties.failoverConditionSettings) }) : properties;
    }
    function CfnChannelFailoverConditionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("failoverConditionSettings", "FailoverConditionSettings", properties.FailoverConditionSettings != null ? CfnChannelFailoverConditionSettingsPropertyFromCloudFormation(properties.FailoverConditionSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_FailoverConditionSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("audioSilenceSettings", CfnChannel_AudioSilenceFailoverSettingsPropertyValidator)(properties.audioSilenceSettings)), errors.collect(cdk.propertyValidator("inputLossSettings", CfnChannel_InputLossFailoverSettingsPropertyValidator)(properties.inputLossSettings)), errors.collect(cdk.propertyValidator("videoBlackSettings", CfnChannel_VideoBlackFailoverSettingsPropertyValidator)(properties.videoBlackSettings)), errors.wrap('supplied properties not correct for "FailoverConditionSettingsProperty"');
    }
    function cfnChannelFailoverConditionSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_FailoverConditionSettingsPropertyValidator(properties).assertSuccess(), { AudioSilenceSettings: cfnChannelAudioSilenceFailoverSettingsPropertyToCloudFormation(properties.audioSilenceSettings), InputLossSettings: cfnChannelInputLossFailoverSettingsPropertyToCloudFormation(properties.inputLossSettings), VideoBlackSettings: cfnChannelVideoBlackFailoverSettingsPropertyToCloudFormation(properties.videoBlackSettings) }) : properties;
    }
    function CfnChannelFailoverConditionSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("audioSilenceSettings", "AudioSilenceSettings", properties.AudioSilenceSettings != null ? CfnChannelAudioSilenceFailoverSettingsPropertyFromCloudFormation(properties.AudioSilenceSettings) : void 0), ret.addPropertyResult("inputLossSettings", "InputLossSettings", properties.InputLossSettings != null ? CfnChannelInputLossFailoverSettingsPropertyFromCloudFormation(properties.InputLossSettings) : void 0), ret.addPropertyResult("videoBlackSettings", "VideoBlackSettings", properties.VideoBlackSettings != null ? CfnChannelVideoBlackFailoverSettingsPropertyFromCloudFormation(properties.VideoBlackSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_FeatureActivationsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("inputPrepareScheduleActions", cdk.validateString)(properties.inputPrepareScheduleActions)), errors.wrap('supplied properties not correct for "FeatureActivationsProperty"');
    }
    function cfnChannelFeatureActivationsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_FeatureActivationsPropertyValidator(properties).assertSuccess(), { InputPrepareScheduleActions: cdk.stringToCloudFormation(properties.inputPrepareScheduleActions) }) : properties;
    }
    function CfnChannelFeatureActivationsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("inputPrepareScheduleActions", "InputPrepareScheduleActions", properties.InputPrepareScheduleActions != null ? cfn_parse.FromCloudFormation.getString(properties.InputPrepareScheduleActions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_FecOutputSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnDepth", cdk.validateNumber)(properties.columnDepth)), errors.collect(cdk.propertyValidator("includeFec", cdk.validateString)(properties.includeFec)), errors.collect(cdk.propertyValidator("rowLength", cdk.validateNumber)(properties.rowLength)), errors.wrap('supplied properties not correct for "FecOutputSettingsProperty"');
    }
    function cfnChannelFecOutputSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_FecOutputSettingsPropertyValidator(properties).assertSuccess(), { ColumnDepth: cdk.numberToCloudFormation(properties.columnDepth), IncludeFec: cdk.stringToCloudFormation(properties.includeFec), RowLength: cdk.numberToCloudFormation(properties.rowLength) }) : properties;
    }
    function CfnChannelFecOutputSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columnDepth", "ColumnDepth", properties.ColumnDepth != null ? cfn_parse.FromCloudFormation.getNumber(properties.ColumnDepth) : void 0), ret.addPropertyResult("includeFec", "IncludeFec", properties.IncludeFec != null ? cfn_parse.FromCloudFormation.getString(properties.IncludeFec) : void 0), ret.addPropertyResult("rowLength", "RowLength", properties.RowLength != null ? cfn_parse.FromCloudFormation.getNumber(properties.RowLength) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_Fmp4HlsSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("audioRenditionSets", cdk.validateString)(properties.audioRenditionSets)), errors.collect(cdk.propertyValidator("nielsenId3Behavior", cdk.validateString)(properties.nielsenId3Behavior)), errors.collect(cdk.propertyValidator("timedMetadataBehavior", cdk.validateString)(properties.timedMetadataBehavior)), errors.wrap('supplied properties not correct for "Fmp4HlsSettingsProperty"');
    }
    function cfnChannelFmp4HlsSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_Fmp4HlsSettingsPropertyValidator(properties).assertSuccess(), { AudioRenditionSets: cdk.stringToCloudFormation(properties.audioRenditionSets), NielsenId3Behavior: cdk.stringToCloudFormation(properties.nielsenId3Behavior), TimedMetadataBehavior: cdk.stringToCloudFormation(properties.timedMetadataBehavior) }) : properties;
    }
    function CfnChannelFmp4HlsSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("audioRenditionSets", "AudioRenditionSets", properties.AudioRenditionSets != null ? cfn_parse.FromCloudFormation.getString(properties.AudioRenditionSets) : void 0), ret.addPropertyResult("nielsenId3Behavior", "NielsenId3Behavior", properties.NielsenId3Behavior != null ? cfn_parse.FromCloudFormation.getString(properties.NielsenId3Behavior) : void 0), ret.addPropertyResult("timedMetadataBehavior", "TimedMetadataBehavior", properties.TimedMetadataBehavior != null ? cfn_parse.FromCloudFormation.getString(properties.TimedMetadataBehavior) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_FrameCaptureCdnSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("frameCaptureS3Settings", CfnChannel_FrameCaptureS3SettingsPropertyValidator)(properties.frameCaptureS3Settings)), errors.wrap('supplied properties not correct for "FrameCaptureCdnSettingsProperty"');
    }
    function cfnChannelFrameCaptureCdnSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_FrameCaptureCdnSettingsPropertyValidator(properties).assertSuccess(), { FrameCaptureS3Settings: cfnChannelFrameCaptureS3SettingsPropertyToCloudFormation(properties.frameCaptureS3Settings) }) : properties;
    }
    function CfnChannelFrameCaptureCdnSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("frameCaptureS3Settings", "FrameCaptureS3Settings", properties.FrameCaptureS3Settings != null ? CfnChannelFrameCaptureS3SettingsPropertyFromCloudFormation(properties.FrameCaptureS3Settings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_FrameCaptureGroupSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destination", CfnChannel_OutputLocationRefPropertyValidator)(properties.destination)), errors.collect(cdk.propertyValidator("frameCaptureCdnSettings", CfnChannel_FrameCaptureCdnSettingsPropertyValidator)(properties.frameCaptureCdnSettings)), errors.wrap('supplied properties not correct for "FrameCaptureGroupSettingsProperty"');
    }
    function cfnChannelFrameCaptureGroupSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_FrameCaptureGroupSettingsPropertyValidator(properties).assertSuccess(), { Destination: cfnChannelOutputLocationRefPropertyToCloudFormation(properties.destination), FrameCaptureCdnSettings: cfnChannelFrameCaptureCdnSettingsPropertyToCloudFormation(properties.frameCaptureCdnSettings) }) : properties;
    }
    function CfnChannelFrameCaptureGroupSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destination", "Destination", properties.Destination != null ? CfnChannelOutputLocationRefPropertyFromCloudFormation(properties.Destination) : void 0), ret.addPropertyResult("frameCaptureCdnSettings", "FrameCaptureCdnSettings", properties.FrameCaptureCdnSettings != null ? CfnChannelFrameCaptureCdnSettingsPropertyFromCloudFormation(properties.FrameCaptureCdnSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_FrameCaptureHlsSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.wrap('supplied properties not correct for "FrameCaptureHlsSettingsProperty"');
    }
    function cfnChannelFrameCaptureHlsSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_FrameCaptureHlsSettingsPropertyValidator(properties).assertSuccess(), {}) : properties;
    }
    function CfnChannelFrameCaptureHlsSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_FrameCaptureOutputSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("nameModifier", cdk.validateString)(properties.nameModifier)), errors.wrap('supplied properties not correct for "FrameCaptureOutputSettingsProperty"');
    }
    function cfnChannelFrameCaptureOutputSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_FrameCaptureOutputSettingsPropertyValidator(properties).assertSuccess(), { NameModifier: cdk.stringToCloudFormation(properties.nameModifier) }) : properties;
    }
    function CfnChannelFrameCaptureOutputSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("nameModifier", "NameModifier", properties.NameModifier != null ? cfn_parse.FromCloudFormation.getString(properties.NameModifier) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_FrameCaptureS3SettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cannedAcl", cdk.validateString)(properties.cannedAcl)), errors.wrap('supplied properties not correct for "FrameCaptureS3SettingsProperty"');
    }
    function cfnChannelFrameCaptureS3SettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_FrameCaptureS3SettingsPropertyValidator(properties).assertSuccess(), { CannedAcl: cdk.stringToCloudFormation(properties.cannedAcl) }) : properties;
    }
    function CfnChannelFrameCaptureS3SettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cannedAcl", "CannedAcl", properties.CannedAcl != null ? cfn_parse.FromCloudFormation.getString(properties.CannedAcl) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_FrameCaptureSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("captureInterval", cdk.validateNumber)(properties.captureInterval)), errors.collect(cdk.propertyValidator("captureIntervalUnits", cdk.validateString)(properties.captureIntervalUnits)), errors.collect(cdk.propertyValidator("timecodeBurninSettings", CfnChannel_TimecodeBurninSettingsPropertyValidator)(properties.timecodeBurninSettings)), errors.wrap('supplied properties not correct for "FrameCaptureSettingsProperty"');
    }
    function cfnChannelFrameCaptureSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_FrameCaptureSettingsPropertyValidator(properties).assertSuccess(), { CaptureInterval: cdk.numberToCloudFormation(properties.captureInterval), CaptureIntervalUnits: cdk.stringToCloudFormation(properties.captureIntervalUnits), TimecodeBurninSettings: cfnChannelTimecodeBurninSettingsPropertyToCloudFormation(properties.timecodeBurninSettings) }) : properties;
    }
    function CfnChannelFrameCaptureSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("captureInterval", "CaptureInterval", properties.CaptureInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.CaptureInterval) : void 0), ret.addPropertyResult("captureIntervalUnits", "CaptureIntervalUnits", properties.CaptureIntervalUnits != null ? cfn_parse.FromCloudFormation.getString(properties.CaptureIntervalUnits) : void 0), ret.addPropertyResult("timecodeBurninSettings", "TimecodeBurninSettings", properties.TimecodeBurninSettings != null ? CfnChannelTimecodeBurninSettingsPropertyFromCloudFormation(properties.TimecodeBurninSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_GlobalConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("initialAudioGain", cdk.validateNumber)(properties.initialAudioGain)), errors.collect(cdk.propertyValidator("inputEndAction", cdk.validateString)(properties.inputEndAction)), errors.collect(cdk.propertyValidator("inputLossBehavior", CfnChannel_InputLossBehaviorPropertyValidator)(properties.inputLossBehavior)), errors.collect(cdk.propertyValidator("outputLockingMode", cdk.validateString)(properties.outputLockingMode)), errors.collect(cdk.propertyValidator("outputTimingSource", cdk.validateString)(properties.outputTimingSource)), errors.collect(cdk.propertyValidator("supportLowFramerateInputs", cdk.validateString)(properties.supportLowFramerateInputs)), errors.wrap('supplied properties not correct for "GlobalConfigurationProperty"');
    }
    function cfnChannelGlobalConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_GlobalConfigurationPropertyValidator(properties).assertSuccess(), { InitialAudioGain: cdk.numberToCloudFormation(properties.initialAudioGain), InputEndAction: cdk.stringToCloudFormation(properties.inputEndAction), InputLossBehavior: cfnChannelInputLossBehaviorPropertyToCloudFormation(properties.inputLossBehavior), OutputLockingMode: cdk.stringToCloudFormation(properties.outputLockingMode), OutputTimingSource: cdk.stringToCloudFormation(properties.outputTimingSource), SupportLowFramerateInputs: cdk.stringToCloudFormation(properties.supportLowFramerateInputs) }) : properties;
    }
    function CfnChannelGlobalConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("initialAudioGain", "InitialAudioGain", properties.InitialAudioGain != null ? cfn_parse.FromCloudFormation.getNumber(properties.InitialAudioGain) : void 0), ret.addPropertyResult("inputEndAction", "InputEndAction", properties.InputEndAction != null ? cfn_parse.FromCloudFormation.getString(properties.InputEndAction) : void 0), ret.addPropertyResult("inputLossBehavior", "InputLossBehavior", properties.InputLossBehavior != null ? CfnChannelInputLossBehaviorPropertyFromCloudFormation(properties.InputLossBehavior) : void 0), ret.addPropertyResult("outputLockingMode", "OutputLockingMode", properties.OutputLockingMode != null ? cfn_parse.FromCloudFormation.getString(properties.OutputLockingMode) : void 0), ret.addPropertyResult("outputTimingSource", "OutputTimingSource", properties.OutputTimingSource != null ? cfn_parse.FromCloudFormation.getString(properties.OutputTimingSource) : void 0), ret.addPropertyResult("supportLowFramerateInputs", "SupportLowFramerateInputs", properties.SupportLowFramerateInputs != null ? cfn_parse.FromCloudFormation.getString(properties.SupportLowFramerateInputs) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_H264ColorSpaceSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("colorSpacePassthroughSettings", CfnChannel_ColorSpacePassthroughSettingsPropertyValidator)(properties.colorSpacePassthroughSettings)), errors.collect(cdk.propertyValidator("rec601Settings", CfnChannel_Rec601SettingsPropertyValidator)(properties.rec601Settings)), errors.collect(cdk.propertyValidator("rec709Settings", CfnChannel_Rec709SettingsPropertyValidator)(properties.rec709Settings)), errors.wrap('supplied properties not correct for "H264ColorSpaceSettingsProperty"');
    }
    function cfnChannelH264ColorSpaceSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_H264ColorSpaceSettingsPropertyValidator(properties).assertSuccess(), { ColorSpacePassthroughSettings: cfnChannelColorSpacePassthroughSettingsPropertyToCloudFormation(properties.colorSpacePassthroughSettings), Rec601Settings: cfnChannelRec601SettingsPropertyToCloudFormation(properties.rec601Settings), Rec709Settings: cfnChannelRec709SettingsPropertyToCloudFormation(properties.rec709Settings) }) : properties;
    }
    function CfnChannelH264ColorSpaceSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("colorSpacePassthroughSettings", "ColorSpacePassthroughSettings", properties.ColorSpacePassthroughSettings != null ? CfnChannelColorSpacePassthroughSettingsPropertyFromCloudFormation(properties.ColorSpacePassthroughSettings) : void 0), ret.addPropertyResult("rec601Settings", "Rec601Settings", properties.Rec601Settings != null ? CfnChannelRec601SettingsPropertyFromCloudFormation(properties.Rec601Settings) : void 0), ret.addPropertyResult("rec709Settings", "Rec709Settings", properties.Rec709Settings != null ? CfnChannelRec709SettingsPropertyFromCloudFormation(properties.Rec709Settings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_H264FilterSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("temporalFilterSettings", CfnChannel_TemporalFilterSettingsPropertyValidator)(properties.temporalFilterSettings)), errors.wrap('supplied properties not correct for "H264FilterSettingsProperty"');
    }
    function cfnChannelH264FilterSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_H264FilterSettingsPropertyValidator(properties).assertSuccess(), { TemporalFilterSettings: cfnChannelTemporalFilterSettingsPropertyToCloudFormation(properties.temporalFilterSettings) }) : properties;
    }
    function CfnChannelH264FilterSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("temporalFilterSettings", "TemporalFilterSettings", properties.TemporalFilterSettings != null ? CfnChannelTemporalFilterSettingsPropertyFromCloudFormation(properties.TemporalFilterSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_H264SettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("adaptiveQuantization", cdk.validateString)(properties.adaptiveQuantization)), errors.collect(cdk.propertyValidator("afdSignaling", cdk.validateString)(properties.afdSignaling)), errors.collect(cdk.propertyValidator("bitrate", cdk.validateNumber)(properties.bitrate)), errors.collect(cdk.propertyValidator("bufFillPct", cdk.validateNumber)(properties.bufFillPct)), errors.collect(cdk.propertyValidator("bufSize", cdk.validateNumber)(properties.bufSize)), errors.collect(cdk.propertyValidator("colorMetadata", cdk.validateString)(properties.colorMetadata)), errors.collect(cdk.propertyValidator("colorSpaceSettings", CfnChannel_H264ColorSpaceSettingsPropertyValidator)(properties.colorSpaceSettings)), errors.collect(cdk.propertyValidator("entropyEncoding", cdk.validateString)(properties.entropyEncoding)), errors.collect(cdk.propertyValidator("filterSettings", CfnChannel_H264FilterSettingsPropertyValidator)(properties.filterSettings)), errors.collect(cdk.propertyValidator("fixedAfd", cdk.validateString)(properties.fixedAfd)), errors.collect(cdk.propertyValidator("flickerAq", cdk.validateString)(properties.flickerAq)), errors.collect(cdk.propertyValidator("forceFieldPictures", cdk.validateString)(properties.forceFieldPictures)), errors.collect(cdk.propertyValidator("framerateControl", cdk.validateString)(properties.framerateControl)), errors.collect(cdk.propertyValidator("framerateDenominator", cdk.validateNumber)(properties.framerateDenominator)), errors.collect(cdk.propertyValidator("framerateNumerator", cdk.validateNumber)(properties.framerateNumerator)), errors.collect(cdk.propertyValidator("gopBReference", cdk.validateString)(properties.gopBReference)), errors.collect(cdk.propertyValidator("gopClosedCadence", cdk.validateNumber)(properties.gopClosedCadence)), errors.collect(cdk.propertyValidator("gopNumBFrames", cdk.validateNumber)(properties.gopNumBFrames)), errors.collect(cdk.propertyValidator("gopSize", cdk.validateNumber)(properties.gopSize)), errors.collect(cdk.propertyValidator("gopSizeUnits", cdk.validateString)(properties.gopSizeUnits)), errors.collect(cdk.propertyValidator("level", cdk.validateString)(properties.level)), errors.collect(cdk.propertyValidator("lookAheadRateControl", cdk.validateString)(properties.lookAheadRateControl)), errors.collect(cdk.propertyValidator("maxBitrate", cdk.validateNumber)(properties.maxBitrate)), errors.collect(cdk.propertyValidator("minIInterval", cdk.validateNumber)(properties.minIInterval)), errors.collect(cdk.propertyValidator("numRefFrames", cdk.validateNumber)(properties.numRefFrames)), errors.collect(cdk.propertyValidator("parControl", cdk.validateString)(properties.parControl)), errors.collect(cdk.propertyValidator("parDenominator", cdk.validateNumber)(properties.parDenominator)), errors.collect(cdk.propertyValidator("parNumerator", cdk.validateNumber)(properties.parNumerator)), errors.collect(cdk.propertyValidator("profile", cdk.validateString)(properties.profile)), errors.collect(cdk.propertyValidator("qualityLevel", cdk.validateString)(properties.qualityLevel)), errors.collect(cdk.propertyValidator("qvbrQualityLevel", cdk.validateNumber)(properties.qvbrQualityLevel)), errors.collect(cdk.propertyValidator("rateControlMode", cdk.validateString)(properties.rateControlMode)), errors.collect(cdk.propertyValidator("scanType", cdk.validateString)(properties.scanType)), errors.collect(cdk.propertyValidator("sceneChangeDetect", cdk.validateString)(properties.sceneChangeDetect)), errors.collect(cdk.propertyValidator("slices", cdk.validateNumber)(properties.slices)), errors.collect(cdk.propertyValidator("softness", cdk.validateNumber)(properties.softness)), errors.collect(cdk.propertyValidator("spatialAq", cdk.validateString)(properties.spatialAq)), errors.collect(cdk.propertyValidator("subgopLength", cdk.validateString)(properties.subgopLength)), errors.collect(cdk.propertyValidator("syntax", cdk.validateString)(properties.syntax)), errors.collect(cdk.propertyValidator("temporalAq", cdk.validateString)(properties.temporalAq)), errors.collect(cdk.propertyValidator("timecodeBurninSettings", CfnChannel_TimecodeBurninSettingsPropertyValidator)(properties.timecodeBurninSettings)), errors.collect(cdk.propertyValidator("timecodeInsertion", cdk.validateString)(properties.timecodeInsertion)), errors.wrap('supplied properties not correct for "H264SettingsProperty"');
    }
    function cfnChannelH264SettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_H264SettingsPropertyValidator(properties).assertSuccess(), { AdaptiveQuantization: cdk.stringToCloudFormation(properties.adaptiveQuantization), AfdSignaling: cdk.stringToCloudFormation(properties.afdSignaling), Bitrate: cdk.numberToCloudFormation(properties.bitrate), BufFillPct: cdk.numberToCloudFormation(properties.bufFillPct), BufSize: cdk.numberToCloudFormation(properties.bufSize), ColorMetadata: cdk.stringToCloudFormation(properties.colorMetadata), ColorSpaceSettings: cfnChannelH264ColorSpaceSettingsPropertyToCloudFormation(properties.colorSpaceSettings), EntropyEncoding: cdk.stringToCloudFormation(properties.entropyEncoding), FilterSettings: cfnChannelH264FilterSettingsPropertyToCloudFormation(properties.filterSettings), FixedAfd: cdk.stringToCloudFormation(properties.fixedAfd), FlickerAq: cdk.stringToCloudFormation(properties.flickerAq), ForceFieldPictures: cdk.stringToCloudFormation(properties.forceFieldPictures), FramerateControl: cdk.stringToCloudFormation(properties.framerateControl), FramerateDenominator: cdk.numberToCloudFormation(properties.framerateDenominator), FramerateNumerator: cdk.numberToCloudFormation(properties.framerateNumerator), GopBReference: cdk.stringToCloudFormation(properties.gopBReference), GopClosedCadence: cdk.numberToCloudFormation(properties.gopClosedCadence), GopNumBFrames: cdk.numberToCloudFormation(properties.gopNumBFrames), GopSize: cdk.numberToCloudFormation(properties.gopSize), GopSizeUnits: cdk.stringToCloudFormation(properties.gopSizeUnits), Level: cdk.stringToCloudFormation(properties.level), LookAheadRateControl: cdk.stringToCloudFormation(properties.lookAheadRateControl), MaxBitrate: cdk.numberToCloudFormation(properties.maxBitrate), MinIInterval: cdk.numberToCloudFormation(properties.minIInterval), NumRefFrames: cdk.numberToCloudFormation(properties.numRefFrames), ParControl: cdk.stringToCloudFormation(properties.parControl), ParDenominator: cdk.numberToCloudFormation(properties.parDenominator), ParNumerator: cdk.numberToCloudFormation(properties.parNumerator), Profile: cdk.stringToCloudFormation(properties.profile), QualityLevel: cdk.stringToCloudFormation(properties.qualityLevel), QvbrQualityLevel: cdk.numberToCloudFormation(properties.qvbrQualityLevel), RateControlMode: cdk.stringToCloudFormation(properties.rateControlMode), ScanType: cdk.stringToCloudFormation(properties.scanType), SceneChangeDetect: cdk.stringToCloudFormation(properties.sceneChangeDetect), Slices: cdk.numberToCloudFormation(properties.slices), Softness: cdk.numberToCloudFormation(properties.softness), SpatialAq: cdk.stringToCloudFormation(properties.spatialAq), SubgopLength: cdk.stringToCloudFormation(properties.subgopLength), Syntax: cdk.stringToCloudFormation(properties.syntax), TemporalAq: cdk.stringToCloudFormation(properties.temporalAq), TimecodeBurninSettings: cfnChannelTimecodeBurninSettingsPropertyToCloudFormation(properties.timecodeBurninSettings), TimecodeInsertion: cdk.stringToCloudFormation(properties.timecodeInsertion) }) : properties;
    }
    function CfnChannelH264SettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("adaptiveQuantization", "AdaptiveQuantization", properties.AdaptiveQuantization != null ? cfn_parse.FromCloudFormation.getString(properties.AdaptiveQuantization) : void 0), ret.addPropertyResult("afdSignaling", "AfdSignaling", properties.AfdSignaling != null ? cfn_parse.FromCloudFormation.getString(properties.AfdSignaling) : void 0), ret.addPropertyResult("bitrate", "Bitrate", properties.Bitrate != null ? cfn_parse.FromCloudFormation.getNumber(properties.Bitrate) : void 0), ret.addPropertyResult("bufFillPct", "BufFillPct", properties.BufFillPct != null ? cfn_parse.FromCloudFormation.getNumber(properties.BufFillPct) : void 0), ret.addPropertyResult("bufSize", "BufSize", properties.BufSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.BufSize) : void 0), ret.addPropertyResult("colorMetadata", "ColorMetadata", properties.ColorMetadata != null ? cfn_parse.FromCloudFormation.getString(properties.ColorMetadata) : void 0), ret.addPropertyResult("colorSpaceSettings", "ColorSpaceSettings", properties.ColorSpaceSettings != null ? CfnChannelH264ColorSpaceSettingsPropertyFromCloudFormation(properties.ColorSpaceSettings) : void 0), ret.addPropertyResult("entropyEncoding", "EntropyEncoding", properties.EntropyEncoding != null ? cfn_parse.FromCloudFormation.getString(properties.EntropyEncoding) : void 0), ret.addPropertyResult("filterSettings", "FilterSettings", properties.FilterSettings != null ? CfnChannelH264FilterSettingsPropertyFromCloudFormation(properties.FilterSettings) : void 0), ret.addPropertyResult("fixedAfd", "FixedAfd", properties.FixedAfd != null ? cfn_parse.FromCloudFormation.getString(properties.FixedAfd) : void 0), ret.addPropertyResult("flickerAq", "FlickerAq", properties.FlickerAq != null ? cfn_parse.FromCloudFormation.getString(properties.FlickerAq) : void 0), ret.addPropertyResult("forceFieldPictures", "ForceFieldPictures", properties.ForceFieldPictures != null ? cfn_parse.FromCloudFormation.getString(properties.ForceFieldPictures) : void 0), ret.addPropertyResult("framerateControl", "FramerateControl", properties.FramerateControl != null ? cfn_parse.FromCloudFormation.getString(properties.FramerateControl) : void 0), ret.addPropertyResult("framerateDenominator", "FramerateDenominator", properties.FramerateDenominator != null ? cfn_parse.FromCloudFormation.getNumber(properties.FramerateDenominator) : void 0), ret.addPropertyResult("framerateNumerator", "FramerateNumerator", properties.FramerateNumerator != null ? cfn_parse.FromCloudFormation.getNumber(properties.FramerateNumerator) : void 0), ret.addPropertyResult("gopBReference", "GopBReference", properties.GopBReference != null ? cfn_parse.FromCloudFormation.getString(properties.GopBReference) : void 0), ret.addPropertyResult("gopClosedCadence", "GopClosedCadence", properties.GopClosedCadence != null ? cfn_parse.FromCloudFormation.getNumber(properties.GopClosedCadence) : void 0), ret.addPropertyResult("gopNumBFrames", "GopNumBFrames", properties.GopNumBFrames != null ? cfn_parse.FromCloudFormation.getNumber(properties.GopNumBFrames) : void 0), ret.addPropertyResult("gopSize", "GopSize", properties.GopSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.GopSize) : void 0), ret.addPropertyResult("gopSizeUnits", "GopSizeUnits", properties.GopSizeUnits != null ? cfn_parse.FromCloudFormation.getString(properties.GopSizeUnits) : void 0), ret.addPropertyResult("level", "Level", properties.Level != null ? cfn_parse.FromCloudFormation.getString(properties.Level) : void 0), ret.addPropertyResult("lookAheadRateControl", "LookAheadRateControl", properties.LookAheadRateControl != null ? cfn_parse.FromCloudFormation.getString(properties.LookAheadRateControl) : void 0), ret.addPropertyResult("maxBitrate", "MaxBitrate", properties.MaxBitrate != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxBitrate) : void 0), ret.addPropertyResult("minIInterval", "MinIInterval", properties.MinIInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinIInterval) : void 0), ret.addPropertyResult("numRefFrames", "NumRefFrames", properties.NumRefFrames != null ? cfn_parse.FromCloudFormation.getNumber(properties.NumRefFrames) : void 0), ret.addPropertyResult("parControl", "ParControl", properties.ParControl != null ? cfn_parse.FromCloudFormation.getString(properties.ParControl) : void 0), ret.addPropertyResult("parDenominator", "ParDenominator", properties.ParDenominator != null ? cfn_parse.FromCloudFormation.getNumber(properties.ParDenominator) : void 0), ret.addPropertyResult("parNumerator", "ParNumerator", properties.ParNumerator != null ? cfn_parse.FromCloudFormation.getNumber(properties.ParNumerator) : void 0), ret.addPropertyResult("profile", "Profile", properties.Profile != null ? cfn_parse.FromCloudFormation.getString(properties.Profile) : void 0), ret.addPropertyResult("qualityLevel", "QualityLevel", properties.QualityLevel != null ? cfn_parse.FromCloudFormation.getString(properties.QualityLevel) : void 0), ret.addPropertyResult("qvbrQualityLevel", "QvbrQualityLevel", properties.QvbrQualityLevel != null ? cfn_parse.FromCloudFormation.getNumber(properties.QvbrQualityLevel) : void 0), ret.addPropertyResult("rateControlMode", "RateControlMode", properties.RateControlMode != null ? cfn_parse.FromCloudFormation.getString(properties.RateControlMode) : void 0), ret.addPropertyResult("scanType", "ScanType", properties.ScanType != null ? cfn_parse.FromCloudFormation.getString(properties.ScanType) : void 0), ret.addPropertyResult("sceneChangeDetect", "SceneChangeDetect", properties.SceneChangeDetect != null ? cfn_parse.FromCloudFormation.getString(properties.SceneChangeDetect) : void 0), ret.addPropertyResult("slices", "Slices", properties.Slices != null ? cfn_parse.FromCloudFormation.getNumber(properties.Slices) : void 0), ret.addPropertyResult("softness", "Softness", properties.Softness != null ? cfn_parse.FromCloudFormation.getNumber(properties.Softness) : void 0), ret.addPropertyResult("spatialAq", "SpatialAq", properties.SpatialAq != null ? cfn_parse.FromCloudFormation.getString(properties.SpatialAq) : void 0), ret.addPropertyResult("subgopLength", "SubgopLength", properties.SubgopLength != null ? cfn_parse.FromCloudFormation.getString(properties.SubgopLength) : void 0), ret.addPropertyResult("syntax", "Syntax", properties.Syntax != null ? cfn_parse.FromCloudFormation.getString(properties.Syntax) : void 0), ret.addPropertyResult("temporalAq", "TemporalAq", properties.TemporalAq != null ? cfn_parse.FromCloudFormation.getString(properties.TemporalAq) : void 0), ret.addPropertyResult("timecodeBurninSettings", "TimecodeBurninSettings", properties.TimecodeBurninSettings != null ? CfnChannelTimecodeBurninSettingsPropertyFromCloudFormation(properties.TimecodeBurninSettings) : void 0), ret.addPropertyResult("timecodeInsertion", "TimecodeInsertion", properties.TimecodeInsertion != null ? cfn_parse.FromCloudFormation.getString(properties.TimecodeInsertion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_H265ColorSpaceSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("colorSpacePassthroughSettings", CfnChannel_ColorSpacePassthroughSettingsPropertyValidator)(properties.colorSpacePassthroughSettings)), errors.collect(cdk.propertyValidator("dolbyVision81Settings", CfnChannel_DolbyVision81SettingsPropertyValidator)(properties.dolbyVision81Settings)), errors.collect(cdk.propertyValidator("hdr10Settings", CfnChannel_Hdr10SettingsPropertyValidator)(properties.hdr10Settings)), errors.collect(cdk.propertyValidator("rec601Settings", CfnChannel_Rec601SettingsPropertyValidator)(properties.rec601Settings)), errors.collect(cdk.propertyValidator("rec709Settings", CfnChannel_Rec709SettingsPropertyValidator)(properties.rec709Settings)), errors.wrap('supplied properties not correct for "H265ColorSpaceSettingsProperty"');
    }
    function cfnChannelH265ColorSpaceSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_H265ColorSpaceSettingsPropertyValidator(properties).assertSuccess(), { ColorSpacePassthroughSettings: cfnChannelColorSpacePassthroughSettingsPropertyToCloudFormation(properties.colorSpacePassthroughSettings), DolbyVision81Settings: cfnChannelDolbyVision81SettingsPropertyToCloudFormation(properties.dolbyVision81Settings), Hdr10Settings: cfnChannelHdr10SettingsPropertyToCloudFormation(properties.hdr10Settings), Rec601Settings: cfnChannelRec601SettingsPropertyToCloudFormation(properties.rec601Settings), Rec709Settings: cfnChannelRec709SettingsPropertyToCloudFormation(properties.rec709Settings) }) : properties;
    }
    function CfnChannelH265ColorSpaceSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("colorSpacePassthroughSettings", "ColorSpacePassthroughSettings", properties.ColorSpacePassthroughSettings != null ? CfnChannelColorSpacePassthroughSettingsPropertyFromCloudFormation(properties.ColorSpacePassthroughSettings) : void 0), ret.addPropertyResult("dolbyVision81Settings", "DolbyVision81Settings", properties.DolbyVision81Settings != null ? CfnChannelDolbyVision81SettingsPropertyFromCloudFormation(properties.DolbyVision81Settings) : void 0), ret.addPropertyResult("hdr10Settings", "Hdr10Settings", properties.Hdr10Settings != null ? CfnChannelHdr10SettingsPropertyFromCloudFormation(properties.Hdr10Settings) : void 0), ret.addPropertyResult("rec601Settings", "Rec601Settings", properties.Rec601Settings != null ? CfnChannelRec601SettingsPropertyFromCloudFormation(properties.Rec601Settings) : void 0), ret.addPropertyResult("rec709Settings", "Rec709Settings", properties.Rec709Settings != null ? CfnChannelRec709SettingsPropertyFromCloudFormation(properties.Rec709Settings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_H265FilterSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("temporalFilterSettings", CfnChannel_TemporalFilterSettingsPropertyValidator)(properties.temporalFilterSettings)), errors.wrap('supplied properties not correct for "H265FilterSettingsProperty"');
    }
    function cfnChannelH265FilterSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_H265FilterSettingsPropertyValidator(properties).assertSuccess(), { TemporalFilterSettings: cfnChannelTemporalFilterSettingsPropertyToCloudFormation(properties.temporalFilterSettings) }) : properties;
    }
    function CfnChannelH265FilterSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("temporalFilterSettings", "TemporalFilterSettings", properties.TemporalFilterSettings != null ? CfnChannelTemporalFilterSettingsPropertyFromCloudFormation(properties.TemporalFilterSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_H265SettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("adaptiveQuantization", cdk.validateString)(properties.adaptiveQuantization)), errors.collect(cdk.propertyValidator("afdSignaling", cdk.validateString)(properties.afdSignaling)), errors.collect(cdk.propertyValidator("alternativeTransferFunction", cdk.validateString)(properties.alternativeTransferFunction)), errors.collect(cdk.propertyValidator("bitrate", cdk.validateNumber)(properties.bitrate)), errors.collect(cdk.propertyValidator("bufSize", cdk.validateNumber)(properties.bufSize)), errors.collect(cdk.propertyValidator("colorMetadata", cdk.validateString)(properties.colorMetadata)), errors.collect(cdk.propertyValidator("colorSpaceSettings", CfnChannel_H265ColorSpaceSettingsPropertyValidator)(properties.colorSpaceSettings)), errors.collect(cdk.propertyValidator("filterSettings", CfnChannel_H265FilterSettingsPropertyValidator)(properties.filterSettings)), errors.collect(cdk.propertyValidator("fixedAfd", cdk.validateString)(properties.fixedAfd)), errors.collect(cdk.propertyValidator("flickerAq", cdk.validateString)(properties.flickerAq)), errors.collect(cdk.propertyValidator("framerateDenominator", cdk.validateNumber)(properties.framerateDenominator)), errors.collect(cdk.propertyValidator("framerateNumerator", cdk.validateNumber)(properties.framerateNumerator)), errors.collect(cdk.propertyValidator("gopClosedCadence", cdk.validateNumber)(properties.gopClosedCadence)), errors.collect(cdk.propertyValidator("gopSize", cdk.validateNumber)(properties.gopSize)), errors.collect(cdk.propertyValidator("gopSizeUnits", cdk.validateString)(properties.gopSizeUnits)), errors.collect(cdk.propertyValidator("level", cdk.validateString)(properties.level)), errors.collect(cdk.propertyValidator("lookAheadRateControl", cdk.validateString)(properties.lookAheadRateControl)), errors.collect(cdk.propertyValidator("maxBitrate", cdk.validateNumber)(properties.maxBitrate)), errors.collect(cdk.propertyValidator("minIInterval", cdk.validateNumber)(properties.minIInterval)), errors.collect(cdk.propertyValidator("parDenominator", cdk.validateNumber)(properties.parDenominator)), errors.collect(cdk.propertyValidator("parNumerator", cdk.validateNumber)(properties.parNumerator)), errors.collect(cdk.propertyValidator("profile", cdk.validateString)(properties.profile)), errors.collect(cdk.propertyValidator("qvbrQualityLevel", cdk.validateNumber)(properties.qvbrQualityLevel)), errors.collect(cdk.propertyValidator("rateControlMode", cdk.validateString)(properties.rateControlMode)), errors.collect(cdk.propertyValidator("scanType", cdk.validateString)(properties.scanType)), errors.collect(cdk.propertyValidator("sceneChangeDetect", cdk.validateString)(properties.sceneChangeDetect)), errors.collect(cdk.propertyValidator("slices", cdk.validateNumber)(properties.slices)), errors.collect(cdk.propertyValidator("tier", cdk.validateString)(properties.tier)), errors.collect(cdk.propertyValidator("timecodeBurninSettings", CfnChannel_TimecodeBurninSettingsPropertyValidator)(properties.timecodeBurninSettings)), errors.collect(cdk.propertyValidator("timecodeInsertion", cdk.validateString)(properties.timecodeInsertion)), errors.wrap('supplied properties not correct for "H265SettingsProperty"');
    }
    function cfnChannelH265SettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_H265SettingsPropertyValidator(properties).assertSuccess(), { AdaptiveQuantization: cdk.stringToCloudFormation(properties.adaptiveQuantization), AfdSignaling: cdk.stringToCloudFormation(properties.afdSignaling), AlternativeTransferFunction: cdk.stringToCloudFormation(properties.alternativeTransferFunction), Bitrate: cdk.numberToCloudFormation(properties.bitrate), BufSize: cdk.numberToCloudFormation(properties.bufSize), ColorMetadata: cdk.stringToCloudFormation(properties.colorMetadata), ColorSpaceSettings: cfnChannelH265ColorSpaceSettingsPropertyToCloudFormation(properties.colorSpaceSettings), FilterSettings: cfnChannelH265FilterSettingsPropertyToCloudFormation(properties.filterSettings), FixedAfd: cdk.stringToCloudFormation(properties.fixedAfd), FlickerAq: cdk.stringToCloudFormation(properties.flickerAq), FramerateDenominator: cdk.numberToCloudFormation(properties.framerateDenominator), FramerateNumerator: cdk.numberToCloudFormation(properties.framerateNumerator), GopClosedCadence: cdk.numberToCloudFormation(properties.gopClosedCadence), GopSize: cdk.numberToCloudFormation(properties.gopSize), GopSizeUnits: cdk.stringToCloudFormation(properties.gopSizeUnits), Level: cdk.stringToCloudFormation(properties.level), LookAheadRateControl: cdk.stringToCloudFormation(properties.lookAheadRateControl), MaxBitrate: cdk.numberToCloudFormation(properties.maxBitrate), MinIInterval: cdk.numberToCloudFormation(properties.minIInterval), ParDenominator: cdk.numberToCloudFormation(properties.parDenominator), ParNumerator: cdk.numberToCloudFormation(properties.parNumerator), Profile: cdk.stringToCloudFormation(properties.profile), QvbrQualityLevel: cdk.numberToCloudFormation(properties.qvbrQualityLevel), RateControlMode: cdk.stringToCloudFormation(properties.rateControlMode), ScanType: cdk.stringToCloudFormation(properties.scanType), SceneChangeDetect: cdk.stringToCloudFormation(properties.sceneChangeDetect), Slices: cdk.numberToCloudFormation(properties.slices), Tier: cdk.stringToCloudFormation(properties.tier), TimecodeBurninSettings: cfnChannelTimecodeBurninSettingsPropertyToCloudFormation(properties.timecodeBurninSettings), TimecodeInsertion: cdk.stringToCloudFormation(properties.timecodeInsertion) }) : properties;
    }
    function CfnChannelH265SettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("adaptiveQuantization", "AdaptiveQuantization", properties.AdaptiveQuantization != null ? cfn_parse.FromCloudFormation.getString(properties.AdaptiveQuantization) : void 0), ret.addPropertyResult("afdSignaling", "AfdSignaling", properties.AfdSignaling != null ? cfn_parse.FromCloudFormation.getString(properties.AfdSignaling) : void 0), ret.addPropertyResult("alternativeTransferFunction", "AlternativeTransferFunction", properties.AlternativeTransferFunction != null ? cfn_parse.FromCloudFormation.getString(properties.AlternativeTransferFunction) : void 0), ret.addPropertyResult("bitrate", "Bitrate", properties.Bitrate != null ? cfn_parse.FromCloudFormation.getNumber(properties.Bitrate) : void 0), ret.addPropertyResult("bufSize", "BufSize", properties.BufSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.BufSize) : void 0), ret.addPropertyResult("colorMetadata", "ColorMetadata", properties.ColorMetadata != null ? cfn_parse.FromCloudFormation.getString(properties.ColorMetadata) : void 0), ret.addPropertyResult("colorSpaceSettings", "ColorSpaceSettings", properties.ColorSpaceSettings != null ? CfnChannelH265ColorSpaceSettingsPropertyFromCloudFormation(properties.ColorSpaceSettings) : void 0), ret.addPropertyResult("filterSettings", "FilterSettings", properties.FilterSettings != null ? CfnChannelH265FilterSettingsPropertyFromCloudFormation(properties.FilterSettings) : void 0), ret.addPropertyResult("fixedAfd", "FixedAfd", properties.FixedAfd != null ? cfn_parse.FromCloudFormation.getString(properties.FixedAfd) : void 0), ret.addPropertyResult("flickerAq", "FlickerAq", properties.FlickerAq != null ? cfn_parse.FromCloudFormation.getString(properties.FlickerAq) : void 0), ret.addPropertyResult("framerateDenominator", "FramerateDenominator", properties.FramerateDenominator != null ? cfn_parse.FromCloudFormation.getNumber(properties.FramerateDenominator) : void 0), ret.addPropertyResult("framerateNumerator", "FramerateNumerator", properties.FramerateNumerator != null ? cfn_parse.FromCloudFormation.getNumber(properties.FramerateNumerator) : void 0), ret.addPropertyResult("gopClosedCadence", "GopClosedCadence", properties.GopClosedCadence != null ? cfn_parse.FromCloudFormation.getNumber(properties.GopClosedCadence) : void 0), ret.addPropertyResult("gopSize", "GopSize", properties.GopSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.GopSize) : void 0), ret.addPropertyResult("gopSizeUnits", "GopSizeUnits", properties.GopSizeUnits != null ? cfn_parse.FromCloudFormation.getString(properties.GopSizeUnits) : void 0), ret.addPropertyResult("level", "Level", properties.Level != null ? cfn_parse.FromCloudFormation.getString(properties.Level) : void 0), ret.addPropertyResult("lookAheadRateControl", "LookAheadRateControl", properties.LookAheadRateControl != null ? cfn_parse.FromCloudFormation.getString(properties.LookAheadRateControl) : void 0), ret.addPropertyResult("maxBitrate", "MaxBitrate", properties.MaxBitrate != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxBitrate) : void 0), ret.addPropertyResult("minIInterval", "MinIInterval", properties.MinIInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinIInterval) : void 0), ret.addPropertyResult("parDenominator", "ParDenominator", properties.ParDenominator != null ? cfn_parse.FromCloudFormation.getNumber(properties.ParDenominator) : void 0), ret.addPropertyResult("parNumerator", "ParNumerator", properties.ParNumerator != null ? cfn_parse.FromCloudFormation.getNumber(properties.ParNumerator) : void 0), ret.addPropertyResult("profile", "Profile", properties.Profile != null ? cfn_parse.FromCloudFormation.getString(properties.Profile) : void 0), ret.addPropertyResult("qvbrQualityLevel", "QvbrQualityLevel", properties.QvbrQualityLevel != null ? cfn_parse.FromCloudFormation.getNumber(properties.QvbrQualityLevel) : void 0), ret.addPropertyResult("rateControlMode", "RateControlMode", properties.RateControlMode != null ? cfn_parse.FromCloudFormation.getString(properties.RateControlMode) : void 0), ret.addPropertyResult("scanType", "ScanType", properties.ScanType != null ? cfn_parse.FromCloudFormation.getString(properties.ScanType) : void 0), ret.addPropertyResult("sceneChangeDetect", "SceneChangeDetect", properties.SceneChangeDetect != null ? cfn_parse.FromCloudFormation.getString(properties.SceneChangeDetect) : void 0), ret.addPropertyResult("slices", "Slices", properties.Slices != null ? cfn_parse.FromCloudFormation.getNumber(properties.Slices) : void 0), ret.addPropertyResult("tier", "Tier", properties.Tier != null ? cfn_parse.FromCloudFormation.getString(properties.Tier) : void 0), ret.addPropertyResult("timecodeBurninSettings", "TimecodeBurninSettings", properties.TimecodeBurninSettings != null ? CfnChannelTimecodeBurninSettingsPropertyFromCloudFormation(properties.TimecodeBurninSettings) : void 0), ret.addPropertyResult("timecodeInsertion", "TimecodeInsertion", properties.TimecodeInsertion != null ? cfn_parse.FromCloudFormation.getString(properties.TimecodeInsertion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_Hdr10SettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxCll", cdk.validateNumber)(properties.maxCll)), errors.collect(cdk.propertyValidator("maxFall", cdk.validateNumber)(properties.maxFall)), errors.wrap('supplied properties not correct for "Hdr10SettingsProperty"');
    }
    function cfnChannelHdr10SettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_Hdr10SettingsPropertyValidator(properties).assertSuccess(), { MaxCll: cdk.numberToCloudFormation(properties.maxCll), MaxFall: cdk.numberToCloudFormation(properties.maxFall) }) : properties;
    }
    function CfnChannelHdr10SettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxCll", "MaxCll", properties.MaxCll != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxCll) : void 0), ret.addPropertyResult("maxFall", "MaxFall", properties.MaxFall != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxFall) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_HlsAkamaiSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectionRetryInterval", cdk.validateNumber)(properties.connectionRetryInterval)), errors.collect(cdk.propertyValidator("filecacheDuration", cdk.validateNumber)(properties.filecacheDuration)), errors.collect(cdk.propertyValidator("httpTransferMode", cdk.validateString)(properties.httpTransferMode)), errors.collect(cdk.propertyValidator("numRetries", cdk.validateNumber)(properties.numRetries)), errors.collect(cdk.propertyValidator("restartDelay", cdk.validateNumber)(properties.restartDelay)), errors.collect(cdk.propertyValidator("salt", cdk.validateString)(properties.salt)), errors.collect(cdk.propertyValidator("token", cdk.validateString)(properties.token)), errors.wrap('supplied properties not correct for "HlsAkamaiSettingsProperty"');
    }
    function cfnChannelHlsAkamaiSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_HlsAkamaiSettingsPropertyValidator(properties).assertSuccess(), { ConnectionRetryInterval: cdk.numberToCloudFormation(properties.connectionRetryInterval), FilecacheDuration: cdk.numberToCloudFormation(properties.filecacheDuration), HttpTransferMode: cdk.stringToCloudFormation(properties.httpTransferMode), NumRetries: cdk.numberToCloudFormation(properties.numRetries), RestartDelay: cdk.numberToCloudFormation(properties.restartDelay), Salt: cdk.stringToCloudFormation(properties.salt), Token: cdk.stringToCloudFormation(properties.token) }) : properties;
    }
    function CfnChannelHlsAkamaiSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectionRetryInterval", "ConnectionRetryInterval", properties.ConnectionRetryInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.ConnectionRetryInterval) : void 0), ret.addPropertyResult("filecacheDuration", "FilecacheDuration", properties.FilecacheDuration != null ? cfn_parse.FromCloudFormation.getNumber(properties.FilecacheDuration) : void 0), ret.addPropertyResult("httpTransferMode", "HttpTransferMode", properties.HttpTransferMode != null ? cfn_parse.FromCloudFormation.getString(properties.HttpTransferMode) : void 0), ret.addPropertyResult("numRetries", "NumRetries", properties.NumRetries != null ? cfn_parse.FromCloudFormation.getNumber(properties.NumRetries) : void 0), ret.addPropertyResult("restartDelay", "RestartDelay", properties.RestartDelay != null ? cfn_parse.FromCloudFormation.getNumber(properties.RestartDelay) : void 0), ret.addPropertyResult("salt", "Salt", properties.Salt != null ? cfn_parse.FromCloudFormation.getString(properties.Salt) : void 0), ret.addPropertyResult("token", "Token", properties.Token != null ? cfn_parse.FromCloudFormation.getString(properties.Token) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_HlsBasicPutSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectionRetryInterval", cdk.validateNumber)(properties.connectionRetryInterval)), errors.collect(cdk.propertyValidator("filecacheDuration", cdk.validateNumber)(properties.filecacheDuration)), errors.collect(cdk.propertyValidator("numRetries", cdk.validateNumber)(properties.numRetries)), errors.collect(cdk.propertyValidator("restartDelay", cdk.validateNumber)(properties.restartDelay)), errors.wrap('supplied properties not correct for "HlsBasicPutSettingsProperty"');
    }
    function cfnChannelHlsBasicPutSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_HlsBasicPutSettingsPropertyValidator(properties).assertSuccess(), { ConnectionRetryInterval: cdk.numberToCloudFormation(properties.connectionRetryInterval), FilecacheDuration: cdk.numberToCloudFormation(properties.filecacheDuration), NumRetries: cdk.numberToCloudFormation(properties.numRetries), RestartDelay: cdk.numberToCloudFormation(properties.restartDelay) }) : properties;
    }
    function CfnChannelHlsBasicPutSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectionRetryInterval", "ConnectionRetryInterval", properties.ConnectionRetryInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.ConnectionRetryInterval) : void 0), ret.addPropertyResult("filecacheDuration", "FilecacheDuration", properties.FilecacheDuration != null ? cfn_parse.FromCloudFormation.getNumber(properties.FilecacheDuration) : void 0), ret.addPropertyResult("numRetries", "NumRetries", properties.NumRetries != null ? cfn_parse.FromCloudFormation.getNumber(properties.NumRetries) : void 0), ret.addPropertyResult("restartDelay", "RestartDelay", properties.RestartDelay != null ? cfn_parse.FromCloudFormation.getNumber(properties.RestartDelay) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_HlsCdnSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("hlsAkamaiSettings", CfnChannel_HlsAkamaiSettingsPropertyValidator)(properties.hlsAkamaiSettings)), errors.collect(cdk.propertyValidator("hlsBasicPutSettings", CfnChannel_HlsBasicPutSettingsPropertyValidator)(properties.hlsBasicPutSettings)), errors.collect(cdk.propertyValidator("hlsMediaStoreSettings", CfnChannel_HlsMediaStoreSettingsPropertyValidator)(properties.hlsMediaStoreSettings)), errors.collect(cdk.propertyValidator("hlsS3Settings", CfnChannel_HlsS3SettingsPropertyValidator)(properties.hlsS3Settings)), errors.collect(cdk.propertyValidator("hlsWebdavSettings", CfnChannel_HlsWebdavSettingsPropertyValidator)(properties.hlsWebdavSettings)), errors.wrap('supplied properties not correct for "HlsCdnSettingsProperty"');
    }
    function cfnChannelHlsCdnSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_HlsCdnSettingsPropertyValidator(properties).assertSuccess(), { HlsAkamaiSettings: cfnChannelHlsAkamaiSettingsPropertyToCloudFormation(properties.hlsAkamaiSettings), HlsBasicPutSettings: cfnChannelHlsBasicPutSettingsPropertyToCloudFormation(properties.hlsBasicPutSettings), HlsMediaStoreSettings: cfnChannelHlsMediaStoreSettingsPropertyToCloudFormation(properties.hlsMediaStoreSettings), HlsS3Settings: cfnChannelHlsS3SettingsPropertyToCloudFormation(properties.hlsS3Settings), HlsWebdavSettings: cfnChannelHlsWebdavSettingsPropertyToCloudFormation(properties.hlsWebdavSettings) }) : properties;
    }
    function CfnChannelHlsCdnSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("hlsAkamaiSettings", "HlsAkamaiSettings", properties.HlsAkamaiSettings != null ? CfnChannelHlsAkamaiSettingsPropertyFromCloudFormation(properties.HlsAkamaiSettings) : void 0), ret.addPropertyResult("hlsBasicPutSettings", "HlsBasicPutSettings", properties.HlsBasicPutSettings != null ? CfnChannelHlsBasicPutSettingsPropertyFromCloudFormation(properties.HlsBasicPutSettings) : void 0), ret.addPropertyResult("hlsMediaStoreSettings", "HlsMediaStoreSettings", properties.HlsMediaStoreSettings != null ? CfnChannelHlsMediaStoreSettingsPropertyFromCloudFormation(properties.HlsMediaStoreSettings) : void 0), ret.addPropertyResult("hlsS3Settings", "HlsS3Settings", properties.HlsS3Settings != null ? CfnChannelHlsS3SettingsPropertyFromCloudFormation(properties.HlsS3Settings) : void 0), ret.addPropertyResult("hlsWebdavSettings", "HlsWebdavSettings", properties.HlsWebdavSettings != null ? CfnChannelHlsWebdavSettingsPropertyFromCloudFormation(properties.HlsWebdavSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_HlsGroupSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("adMarkers", cdk.listValidator(cdk.validateString))(properties.adMarkers)), errors.collect(cdk.propertyValidator("baseUrlContent", cdk.validateString)(properties.baseUrlContent)), errors.collect(cdk.propertyValidator("baseUrlContent1", cdk.validateString)(properties.baseUrlContent1)), errors.collect(cdk.propertyValidator("baseUrlManifest", cdk.validateString)(properties.baseUrlManifest)), errors.collect(cdk.propertyValidator("baseUrlManifest1", cdk.validateString)(properties.baseUrlManifest1)), errors.collect(cdk.propertyValidator("captionLanguageMappings", cdk.listValidator(CfnChannel_CaptionLanguageMappingPropertyValidator))(properties.captionLanguageMappings)), errors.collect(cdk.propertyValidator("captionLanguageSetting", cdk.validateString)(properties.captionLanguageSetting)), errors.collect(cdk.propertyValidator("clientCache", cdk.validateString)(properties.clientCache)), errors.collect(cdk.propertyValidator("codecSpecification", cdk.validateString)(properties.codecSpecification)), errors.collect(cdk.propertyValidator("constantIv", cdk.validateString)(properties.constantIv)), errors.collect(cdk.propertyValidator("destination", CfnChannel_OutputLocationRefPropertyValidator)(properties.destination)), errors.collect(cdk.propertyValidator("directoryStructure", cdk.validateString)(properties.directoryStructure)), errors.collect(cdk.propertyValidator("discontinuityTags", cdk.validateString)(properties.discontinuityTags)), errors.collect(cdk.propertyValidator("encryptionType", cdk.validateString)(properties.encryptionType)), errors.collect(cdk.propertyValidator("hlsCdnSettings", CfnChannel_HlsCdnSettingsPropertyValidator)(properties.hlsCdnSettings)), errors.collect(cdk.propertyValidator("hlsId3SegmentTagging", cdk.validateString)(properties.hlsId3SegmentTagging)), errors.collect(cdk.propertyValidator("iFrameOnlyPlaylists", cdk.validateString)(properties.iFrameOnlyPlaylists)), errors.collect(cdk.propertyValidator("incompleteSegmentBehavior", cdk.validateString)(properties.incompleteSegmentBehavior)), errors.collect(cdk.propertyValidator("indexNSegments", cdk.validateNumber)(properties.indexNSegments)), errors.collect(cdk.propertyValidator("inputLossAction", cdk.validateString)(properties.inputLossAction)), errors.collect(cdk.propertyValidator("ivInManifest", cdk.validateString)(properties.ivInManifest)), errors.collect(cdk.propertyValidator("ivSource", cdk.validateString)(properties.ivSource)), errors.collect(cdk.propertyValidator("keepSegments", cdk.validateNumber)(properties.keepSegments)), errors.collect(cdk.propertyValidator("keyFormat", cdk.validateString)(properties.keyFormat)), errors.collect(cdk.propertyValidator("keyFormatVersions", cdk.validateString)(properties.keyFormatVersions)), errors.collect(cdk.propertyValidator("keyProviderSettings", CfnChannel_KeyProviderSettingsPropertyValidator)(properties.keyProviderSettings)), errors.collect(cdk.propertyValidator("manifestCompression", cdk.validateString)(properties.manifestCompression)), errors.collect(cdk.propertyValidator("manifestDurationFormat", cdk.validateString)(properties.manifestDurationFormat)), errors.collect(cdk.propertyValidator("minSegmentLength", cdk.validateNumber)(properties.minSegmentLength)), errors.collect(cdk.propertyValidator("mode", cdk.validateString)(properties.mode)), errors.collect(cdk.propertyValidator("outputSelection", cdk.validateString)(properties.outputSelection)), errors.collect(cdk.propertyValidator("programDateTime", cdk.validateString)(properties.programDateTime)), errors.collect(cdk.propertyValidator("programDateTimeClock", cdk.validateString)(properties.programDateTimeClock)), errors.collect(cdk.propertyValidator("programDateTimePeriod", cdk.validateNumber)(properties.programDateTimePeriod)), errors.collect(cdk.propertyValidator("redundantManifest", cdk.validateString)(properties.redundantManifest)), errors.collect(cdk.propertyValidator("segmentLength", cdk.validateNumber)(properties.segmentLength)), errors.collect(cdk.propertyValidator("segmentationMode", cdk.validateString)(properties.segmentationMode)), errors.collect(cdk.propertyValidator("segmentsPerSubdirectory", cdk.validateNumber)(properties.segmentsPerSubdirectory)), errors.collect(cdk.propertyValidator("streamInfResolution", cdk.validateString)(properties.streamInfResolution)), errors.collect(cdk.propertyValidator("timedMetadataId3Frame", cdk.validateString)(properties.timedMetadataId3Frame)), errors.collect(cdk.propertyValidator("timedMetadataId3Period", cdk.validateNumber)(properties.timedMetadataId3Period)), errors.collect(cdk.propertyValidator("timestampDeltaMilliseconds", cdk.validateNumber)(properties.timestampDeltaMilliseconds)), errors.collect(cdk.propertyValidator("tsFileMode", cdk.validateString)(properties.tsFileMode)), errors.wrap('supplied properties not correct for "HlsGroupSettingsProperty"');
    }
    function cfnChannelHlsGroupSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_HlsGroupSettingsPropertyValidator(properties).assertSuccess(), { AdMarkers: cdk.listMapper(cdk.stringToCloudFormation)(properties.adMarkers), BaseUrlContent: cdk.stringToCloudFormation(properties.baseUrlContent), BaseUrlContent1: cdk.stringToCloudFormation(properties.baseUrlContent1), BaseUrlManifest: cdk.stringToCloudFormation(properties.baseUrlManifest), BaseUrlManifest1: cdk.stringToCloudFormation(properties.baseUrlManifest1), CaptionLanguageMappings: cdk.listMapper(cfnChannelCaptionLanguageMappingPropertyToCloudFormation)(properties.captionLanguageMappings), CaptionLanguageSetting: cdk.stringToCloudFormation(properties.captionLanguageSetting), ClientCache: cdk.stringToCloudFormation(properties.clientCache), CodecSpecification: cdk.stringToCloudFormation(properties.codecSpecification), ConstantIv: cdk.stringToCloudFormation(properties.constantIv), Destination: cfnChannelOutputLocationRefPropertyToCloudFormation(properties.destination), DirectoryStructure: cdk.stringToCloudFormation(properties.directoryStructure), DiscontinuityTags: cdk.stringToCloudFormation(properties.discontinuityTags), EncryptionType: cdk.stringToCloudFormation(properties.encryptionType), HlsCdnSettings: cfnChannelHlsCdnSettingsPropertyToCloudFormation(properties.hlsCdnSettings), HlsId3SegmentTagging: cdk.stringToCloudFormation(properties.hlsId3SegmentTagging), IFrameOnlyPlaylists: cdk.stringToCloudFormation(properties.iFrameOnlyPlaylists), IncompleteSegmentBehavior: cdk.stringToCloudFormation(properties.incompleteSegmentBehavior), IndexNSegments: cdk.numberToCloudFormation(properties.indexNSegments), InputLossAction: cdk.stringToCloudFormation(properties.inputLossAction), IvInManifest: cdk.stringToCloudFormation(properties.ivInManifest), IvSource: cdk.stringToCloudFormation(properties.ivSource), KeepSegments: cdk.numberToCloudFormation(properties.keepSegments), KeyFormat: cdk.stringToCloudFormation(properties.keyFormat), KeyFormatVersions: cdk.stringToCloudFormation(properties.keyFormatVersions), KeyProviderSettings: cfnChannelKeyProviderSettingsPropertyToCloudFormation(properties.keyProviderSettings), ManifestCompression: cdk.stringToCloudFormation(properties.manifestCompression), ManifestDurationFormat: cdk.stringToCloudFormation(properties.manifestDurationFormat), MinSegmentLength: cdk.numberToCloudFormation(properties.minSegmentLength), Mode: cdk.stringToCloudFormation(properties.mode), OutputSelection: cdk.stringToCloudFormation(properties.outputSelection), ProgramDateTime: cdk.stringToCloudFormation(properties.programDateTime), ProgramDateTimeClock: cdk.stringToCloudFormation(properties.programDateTimeClock), ProgramDateTimePeriod: cdk.numberToCloudFormation(properties.programDateTimePeriod), RedundantManifest: cdk.stringToCloudFormation(properties.redundantManifest), SegmentLength: cdk.numberToCloudFormation(properties.segmentLength), SegmentationMode: cdk.stringToCloudFormation(properties.segmentationMode), SegmentsPerSubdirectory: cdk.numberToCloudFormation(properties.segmentsPerSubdirectory), StreamInfResolution: cdk.stringToCloudFormation(properties.streamInfResolution), TimedMetadataId3Frame: cdk.stringToCloudFormation(properties.timedMetadataId3Frame), TimedMetadataId3Period: cdk.numberToCloudFormation(properties.timedMetadataId3Period), TimestampDeltaMilliseconds: cdk.numberToCloudFormation(properties.timestampDeltaMilliseconds), TsFileMode: cdk.stringToCloudFormation(properties.tsFileMode) }) : properties;
    }
    function CfnChannelHlsGroupSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("adMarkers", "AdMarkers", properties.AdMarkers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AdMarkers) : void 0), ret.addPropertyResult("baseUrlContent", "BaseUrlContent", properties.BaseUrlContent != null ? cfn_parse.FromCloudFormation.getString(properties.BaseUrlContent) : void 0), ret.addPropertyResult("baseUrlContent1", "BaseUrlContent1", properties.BaseUrlContent1 != null ? cfn_parse.FromCloudFormation.getString(properties.BaseUrlContent1) : void 0), ret.addPropertyResult("baseUrlManifest", "BaseUrlManifest", properties.BaseUrlManifest != null ? cfn_parse.FromCloudFormation.getString(properties.BaseUrlManifest) : void 0), ret.addPropertyResult("baseUrlManifest1", "BaseUrlManifest1", properties.BaseUrlManifest1 != null ? cfn_parse.FromCloudFormation.getString(properties.BaseUrlManifest1) : void 0), ret.addPropertyResult("captionLanguageMappings", "CaptionLanguageMappings", properties.CaptionLanguageMappings != null ? cfn_parse.FromCloudFormation.getArray(CfnChannelCaptionLanguageMappingPropertyFromCloudFormation)(properties.CaptionLanguageMappings) : void 0), ret.addPropertyResult("captionLanguageSetting", "CaptionLanguageSetting", properties.CaptionLanguageSetting != null ? cfn_parse.FromCloudFormation.getString(properties.CaptionLanguageSetting) : void 0), ret.addPropertyResult("clientCache", "ClientCache", properties.ClientCache != null ? cfn_parse.FromCloudFormation.getString(properties.ClientCache) : void 0), ret.addPropertyResult("codecSpecification", "CodecSpecification", properties.CodecSpecification != null ? cfn_parse.FromCloudFormation.getString(properties.CodecSpecification) : void 0), ret.addPropertyResult("constantIv", "ConstantIv", properties.ConstantIv != null ? cfn_parse.FromCloudFormation.getString(properties.ConstantIv) : void 0), ret.addPropertyResult("destination", "Destination", properties.Destination != null ? CfnChannelOutputLocationRefPropertyFromCloudFormation(properties.Destination) : void 0), ret.addPropertyResult("directoryStructure", "DirectoryStructure", properties.DirectoryStructure != null ? cfn_parse.FromCloudFormation.getString(properties.DirectoryStructure) : void 0), ret.addPropertyResult("discontinuityTags", "DiscontinuityTags", properties.DiscontinuityTags != null ? cfn_parse.FromCloudFormation.getString(properties.DiscontinuityTags) : void 0), ret.addPropertyResult("encryptionType", "EncryptionType", properties.EncryptionType != null ? cfn_parse.FromCloudFormation.getString(properties.EncryptionType) : void 0), ret.addPropertyResult("hlsCdnSettings", "HlsCdnSettings", properties.HlsCdnSettings != null ? CfnChannelHlsCdnSettingsPropertyFromCloudFormation(properties.HlsCdnSettings) : void 0), ret.addPropertyResult("hlsId3SegmentTagging", "HlsId3SegmentTagging", properties.HlsId3SegmentTagging != null ? cfn_parse.FromCloudFormation.getString(properties.HlsId3SegmentTagging) : void 0), ret.addPropertyResult("iFrameOnlyPlaylists", "IFrameOnlyPlaylists", properties.IFrameOnlyPlaylists != null ? cfn_parse.FromCloudFormation.getString(properties.IFrameOnlyPlaylists) : void 0), ret.addPropertyResult("incompleteSegmentBehavior", "IncompleteSegmentBehavior", properties.IncompleteSegmentBehavior != null ? cfn_parse.FromCloudFormation.getString(properties.IncompleteSegmentBehavior) : void 0), ret.addPropertyResult("indexNSegments", "IndexNSegments", properties.IndexNSegments != null ? cfn_parse.FromCloudFormation.getNumber(properties.IndexNSegments) : void 0), ret.addPropertyResult("inputLossAction", "InputLossAction", properties.InputLossAction != null ? cfn_parse.FromCloudFormation.getString(properties.InputLossAction) : void 0), ret.addPropertyResult("ivInManifest", "IvInManifest", properties.IvInManifest != null ? cfn_parse.FromCloudFormation.getString(properties.IvInManifest) : void 0), ret.addPropertyResult("ivSource", "IvSource", properties.IvSource != null ? cfn_parse.FromCloudFormation.getString(properties.IvSource) : void 0), ret.addPropertyResult("keepSegments", "KeepSegments", properties.KeepSegments != null ? cfn_parse.FromCloudFormation.getNumber(properties.KeepSegments) : void 0), ret.addPropertyResult("keyFormat", "KeyFormat", properties.KeyFormat != null ? cfn_parse.FromCloudFormation.getString(properties.KeyFormat) : void 0), ret.addPropertyResult("keyFormatVersions", "KeyFormatVersions", properties.KeyFormatVersions != null ? cfn_parse.FromCloudFormation.getString(properties.KeyFormatVersions) : void 0), ret.addPropertyResult("keyProviderSettings", "KeyProviderSettings", properties.KeyProviderSettings != null ? CfnChannelKeyProviderSettingsPropertyFromCloudFormation(properties.KeyProviderSettings) : void 0), ret.addPropertyResult("manifestCompression", "ManifestCompression", properties.ManifestCompression != null ? cfn_parse.FromCloudFormation.getString(properties.ManifestCompression) : void 0), ret.addPropertyResult("manifestDurationFormat", "ManifestDurationFormat", properties.ManifestDurationFormat != null ? cfn_parse.FromCloudFormation.getString(properties.ManifestDurationFormat) : void 0), ret.addPropertyResult("minSegmentLength", "MinSegmentLength", properties.MinSegmentLength != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinSegmentLength) : void 0), ret.addPropertyResult("mode", "Mode", properties.Mode != null ? cfn_parse.FromCloudFormation.getString(properties.Mode) : void 0), ret.addPropertyResult("outputSelection", "OutputSelection", properties.OutputSelection != null ? cfn_parse.FromCloudFormation.getString(properties.OutputSelection) : void 0), ret.addPropertyResult("programDateTime", "ProgramDateTime", properties.ProgramDateTime != null ? cfn_parse.FromCloudFormation.getString(properties.ProgramDateTime) : void 0), ret.addPropertyResult("programDateTimeClock", "ProgramDateTimeClock", properties.ProgramDateTimeClock != null ? cfn_parse.FromCloudFormation.getString(properties.ProgramDateTimeClock) : void 0), ret.addPropertyResult("programDateTimePeriod", "ProgramDateTimePeriod", properties.ProgramDateTimePeriod != null ? cfn_parse.FromCloudFormation.getNumber(properties.ProgramDateTimePeriod) : void 0), ret.addPropertyResult("redundantManifest", "RedundantManifest", properties.RedundantManifest != null ? cfn_parse.FromCloudFormation.getString(properties.RedundantManifest) : void 0), ret.addPropertyResult("segmentLength", "SegmentLength", properties.SegmentLength != null ? cfn_parse.FromCloudFormation.getNumber(properties.SegmentLength) : void 0), ret.addPropertyResult("segmentationMode", "SegmentationMode", properties.SegmentationMode != null ? cfn_parse.FromCloudFormation.getString(properties.SegmentationMode) : void 0), ret.addPropertyResult("segmentsPerSubdirectory", "SegmentsPerSubdirectory", properties.SegmentsPerSubdirectory != null ? cfn_parse.FromCloudFormation.getNumber(properties.SegmentsPerSubdirectory) : void 0), ret.addPropertyResult("streamInfResolution", "StreamInfResolution", properties.StreamInfResolution != null ? cfn_parse.FromCloudFormation.getString(properties.StreamInfResolution) : void 0), ret.addPropertyResult("timedMetadataId3Frame", "TimedMetadataId3Frame", properties.TimedMetadataId3Frame != null ? cfn_parse.FromCloudFormation.getString(properties.TimedMetadataId3Frame) : void 0), ret.addPropertyResult("timedMetadataId3Period", "TimedMetadataId3Period", properties.TimedMetadataId3Period != null ? cfn_parse.FromCloudFormation.getNumber(properties.TimedMetadataId3Period) : void 0), ret.addPropertyResult("timestampDeltaMilliseconds", "TimestampDeltaMilliseconds", properties.TimestampDeltaMilliseconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.TimestampDeltaMilliseconds) : void 0), ret.addPropertyResult("tsFileMode", "TsFileMode", properties.TsFileMode != null ? cfn_parse.FromCloudFormation.getString(properties.TsFileMode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_HlsInputSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bandwidth", cdk.validateNumber)(properties.bandwidth)), errors.collect(cdk.propertyValidator("bufferSegments", cdk.validateNumber)(properties.bufferSegments)), errors.collect(cdk.propertyValidator("retries", cdk.validateNumber)(properties.retries)), errors.collect(cdk.propertyValidator("retryInterval", cdk.validateNumber)(properties.retryInterval)), errors.collect(cdk.propertyValidator("scte35Source", cdk.validateString)(properties.scte35Source)), errors.wrap('supplied properties not correct for "HlsInputSettingsProperty"');
    }
    function cfnChannelHlsInputSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_HlsInputSettingsPropertyValidator(properties).assertSuccess(), { Bandwidth: cdk.numberToCloudFormation(properties.bandwidth), BufferSegments: cdk.numberToCloudFormation(properties.bufferSegments), Retries: cdk.numberToCloudFormation(properties.retries), RetryInterval: cdk.numberToCloudFormation(properties.retryInterval), Scte35Source: cdk.stringToCloudFormation(properties.scte35Source) }) : properties;
    }
    function CfnChannelHlsInputSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bandwidth", "Bandwidth", properties.Bandwidth != null ? cfn_parse.FromCloudFormation.getNumber(properties.Bandwidth) : void 0), ret.addPropertyResult("bufferSegments", "BufferSegments", properties.BufferSegments != null ? cfn_parse.FromCloudFormation.getNumber(properties.BufferSegments) : void 0), ret.addPropertyResult("retries", "Retries", properties.Retries != null ? cfn_parse.FromCloudFormation.getNumber(properties.Retries) : void 0), ret.addPropertyResult("retryInterval", "RetryInterval", properties.RetryInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.RetryInterval) : void 0), ret.addPropertyResult("scte35Source", "Scte35Source", properties.Scte35Source != null ? cfn_parse.FromCloudFormation.getString(properties.Scte35Source) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_HlsMediaStoreSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectionRetryInterval", cdk.validateNumber)(properties.connectionRetryInterval)), errors.collect(cdk.propertyValidator("filecacheDuration", cdk.validateNumber)(properties.filecacheDuration)), errors.collect(cdk.propertyValidator("mediaStoreStorageClass", cdk.validateString)(properties.mediaStoreStorageClass)), errors.collect(cdk.propertyValidator("numRetries", cdk.validateNumber)(properties.numRetries)), errors.collect(cdk.propertyValidator("restartDelay", cdk.validateNumber)(properties.restartDelay)), errors.wrap('supplied properties not correct for "HlsMediaStoreSettingsProperty"');
    }
    function cfnChannelHlsMediaStoreSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_HlsMediaStoreSettingsPropertyValidator(properties).assertSuccess(), { ConnectionRetryInterval: cdk.numberToCloudFormation(properties.connectionRetryInterval), FilecacheDuration: cdk.numberToCloudFormation(properties.filecacheDuration), MediaStoreStorageClass: cdk.stringToCloudFormation(properties.mediaStoreStorageClass), NumRetries: cdk.numberToCloudFormation(properties.numRetries), RestartDelay: cdk.numberToCloudFormation(properties.restartDelay) }) : properties;
    }
    function CfnChannelHlsMediaStoreSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectionRetryInterval", "ConnectionRetryInterval", properties.ConnectionRetryInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.ConnectionRetryInterval) : void 0), ret.addPropertyResult("filecacheDuration", "FilecacheDuration", properties.FilecacheDuration != null ? cfn_parse.FromCloudFormation.getNumber(properties.FilecacheDuration) : void 0), ret.addPropertyResult("mediaStoreStorageClass", "MediaStoreStorageClass", properties.MediaStoreStorageClass != null ? cfn_parse.FromCloudFormation.getString(properties.MediaStoreStorageClass) : void 0), ret.addPropertyResult("numRetries", "NumRetries", properties.NumRetries != null ? cfn_parse.FromCloudFormation.getNumber(properties.NumRetries) : void 0), ret.addPropertyResult("restartDelay", "RestartDelay", properties.RestartDelay != null ? cfn_parse.FromCloudFormation.getNumber(properties.RestartDelay) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_HlsOutputSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("h265PackagingType", cdk.validateString)(properties.h265PackagingType)), errors.collect(cdk.propertyValidator("hlsSettings", CfnChannel_HlsSettingsPropertyValidator)(properties.hlsSettings)), errors.collect(cdk.propertyValidator("nameModifier", cdk.validateString)(properties.nameModifier)), errors.collect(cdk.propertyValidator("segmentModifier", cdk.validateString)(properties.segmentModifier)), errors.wrap('supplied properties not correct for "HlsOutputSettingsProperty"');
    }
    function cfnChannelHlsOutputSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_HlsOutputSettingsPropertyValidator(properties).assertSuccess(), { H265PackagingType: cdk.stringToCloudFormation(properties.h265PackagingType), HlsSettings: cfnChannelHlsSettingsPropertyToCloudFormation(properties.hlsSettings), NameModifier: cdk.stringToCloudFormation(properties.nameModifier), SegmentModifier: cdk.stringToCloudFormation(properties.segmentModifier) }) : properties;
    }
    function CfnChannelHlsOutputSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("h265PackagingType", "H265PackagingType", properties.H265PackagingType != null ? cfn_parse.FromCloudFormation.getString(properties.H265PackagingType) : void 0), ret.addPropertyResult("hlsSettings", "HlsSettings", properties.HlsSettings != null ? CfnChannelHlsSettingsPropertyFromCloudFormation(properties.HlsSettings) : void 0), ret.addPropertyResult("nameModifier", "NameModifier", properties.NameModifier != null ? cfn_parse.FromCloudFormation.getString(properties.NameModifier) : void 0), ret.addPropertyResult("segmentModifier", "SegmentModifier", properties.SegmentModifier != null ? cfn_parse.FromCloudFormation.getString(properties.SegmentModifier) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_HlsS3SettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cannedAcl", cdk.validateString)(properties.cannedAcl)), errors.wrap('supplied properties not correct for "HlsS3SettingsProperty"');
    }
    function cfnChannelHlsS3SettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_HlsS3SettingsPropertyValidator(properties).assertSuccess(), { CannedAcl: cdk.stringToCloudFormation(properties.cannedAcl) }) : properties;
    }
    function CfnChannelHlsS3SettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cannedAcl", "CannedAcl", properties.CannedAcl != null ? cfn_parse.FromCloudFormation.getString(properties.CannedAcl) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_HlsSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("audioOnlyHlsSettings", CfnChannel_AudioOnlyHlsSettingsPropertyValidator)(properties.audioOnlyHlsSettings)), errors.collect(cdk.propertyValidator("fmp4HlsSettings", CfnChannel_Fmp4HlsSettingsPropertyValidator)(properties.fmp4HlsSettings)), errors.collect(cdk.propertyValidator("frameCaptureHlsSettings", CfnChannel_FrameCaptureHlsSettingsPropertyValidator)(properties.frameCaptureHlsSettings)), errors.collect(cdk.propertyValidator("standardHlsSettings", CfnChannel_StandardHlsSettingsPropertyValidator)(properties.standardHlsSettings)), errors.wrap('supplied properties not correct for "HlsSettingsProperty"');
    }
    function cfnChannelHlsSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_HlsSettingsPropertyValidator(properties).assertSuccess(), { AudioOnlyHlsSettings: cfnChannelAudioOnlyHlsSettingsPropertyToCloudFormation(properties.audioOnlyHlsSettings), Fmp4HlsSettings: cfnChannelFmp4HlsSettingsPropertyToCloudFormation(properties.fmp4HlsSettings), FrameCaptureHlsSettings: cfnChannelFrameCaptureHlsSettingsPropertyToCloudFormation(properties.frameCaptureHlsSettings), StandardHlsSettings: cfnChannelStandardHlsSettingsPropertyToCloudFormation(properties.standardHlsSettings) }) : properties;
    }
    function CfnChannelHlsSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("audioOnlyHlsSettings", "AudioOnlyHlsSettings", properties.AudioOnlyHlsSettings != null ? CfnChannelAudioOnlyHlsSettingsPropertyFromCloudFormation(properties.AudioOnlyHlsSettings) : void 0), ret.addPropertyResult("fmp4HlsSettings", "Fmp4HlsSettings", properties.Fmp4HlsSettings != null ? CfnChannelFmp4HlsSettingsPropertyFromCloudFormation(properties.Fmp4HlsSettings) : void 0), ret.addPropertyResult("frameCaptureHlsSettings", "FrameCaptureHlsSettings", properties.FrameCaptureHlsSettings != null ? CfnChannelFrameCaptureHlsSettingsPropertyFromCloudFormation(properties.FrameCaptureHlsSettings) : void 0), ret.addPropertyResult("standardHlsSettings", "StandardHlsSettings", properties.StandardHlsSettings != null ? CfnChannelStandardHlsSettingsPropertyFromCloudFormation(properties.StandardHlsSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_HlsWebdavSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectionRetryInterval", cdk.validateNumber)(properties.connectionRetryInterval)), errors.collect(cdk.propertyValidator("filecacheDuration", cdk.validateNumber)(properties.filecacheDuration)), errors.collect(cdk.propertyValidator("httpTransferMode", cdk.validateString)(properties.httpTransferMode)), errors.collect(cdk.propertyValidator("numRetries", cdk.validateNumber)(properties.numRetries)), errors.collect(cdk.propertyValidator("restartDelay", cdk.validateNumber)(properties.restartDelay)), errors.wrap('supplied properties not correct for "HlsWebdavSettingsProperty"');
    }
    function cfnChannelHlsWebdavSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_HlsWebdavSettingsPropertyValidator(properties).assertSuccess(), { ConnectionRetryInterval: cdk.numberToCloudFormation(properties.connectionRetryInterval), FilecacheDuration: cdk.numberToCloudFormation(properties.filecacheDuration), HttpTransferMode: cdk.stringToCloudFormation(properties.httpTransferMode), NumRetries: cdk.numberToCloudFormation(properties.numRetries), RestartDelay: cdk.numberToCloudFormation(properties.restartDelay) }) : properties;
    }
    function CfnChannelHlsWebdavSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectionRetryInterval", "ConnectionRetryInterval", properties.ConnectionRetryInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.ConnectionRetryInterval) : void 0), ret.addPropertyResult("filecacheDuration", "FilecacheDuration", properties.FilecacheDuration != null ? cfn_parse.FromCloudFormation.getNumber(properties.FilecacheDuration) : void 0), ret.addPropertyResult("httpTransferMode", "HttpTransferMode", properties.HttpTransferMode != null ? cfn_parse.FromCloudFormation.getString(properties.HttpTransferMode) : void 0), ret.addPropertyResult("numRetries", "NumRetries", properties.NumRetries != null ? cfn_parse.FromCloudFormation.getNumber(properties.NumRetries) : void 0), ret.addPropertyResult("restartDelay", "RestartDelay", properties.RestartDelay != null ? cfn_parse.FromCloudFormation.getNumber(properties.RestartDelay) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_HtmlMotionGraphicsSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.wrap('supplied properties not correct for "HtmlMotionGraphicsSettingsProperty"');
    }
    function cfnChannelHtmlMotionGraphicsSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_HtmlMotionGraphicsSettingsPropertyValidator(properties).assertSuccess(), {}) : properties;
    }
    function CfnChannelHtmlMotionGraphicsSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_InputAttachmentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("automaticInputFailoverSettings", CfnChannel_AutomaticInputFailoverSettingsPropertyValidator)(properties.automaticInputFailoverSettings)), errors.collect(cdk.propertyValidator("inputAttachmentName", cdk.validateString)(properties.inputAttachmentName)), errors.collect(cdk.propertyValidator("inputId", cdk.validateString)(properties.inputId)), errors.collect(cdk.propertyValidator("inputSettings", CfnChannel_InputSettingsPropertyValidator)(properties.inputSettings)), errors.wrap('supplied properties not correct for "InputAttachmentProperty"');
    }
    function cfnChannelInputAttachmentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_InputAttachmentPropertyValidator(properties).assertSuccess(), { AutomaticInputFailoverSettings: cfnChannelAutomaticInputFailoverSettingsPropertyToCloudFormation(properties.automaticInputFailoverSettings), InputAttachmentName: cdk.stringToCloudFormation(properties.inputAttachmentName), InputId: cdk.stringToCloudFormation(properties.inputId), InputSettings: cfnChannelInputSettingsPropertyToCloudFormation(properties.inputSettings) }) : properties;
    }
    function CfnChannelInputAttachmentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("automaticInputFailoverSettings", "AutomaticInputFailoverSettings", properties.AutomaticInputFailoverSettings != null ? CfnChannelAutomaticInputFailoverSettingsPropertyFromCloudFormation(properties.AutomaticInputFailoverSettings) : void 0), ret.addPropertyResult("inputAttachmentName", "InputAttachmentName", properties.InputAttachmentName != null ? cfn_parse.FromCloudFormation.getString(properties.InputAttachmentName) : void 0), ret.addPropertyResult("inputId", "InputId", properties.InputId != null ? cfn_parse.FromCloudFormation.getString(properties.InputId) : void 0), ret.addPropertyResult("inputSettings", "InputSettings", properties.InputSettings != null ? CfnChannelInputSettingsPropertyFromCloudFormation(properties.InputSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_InputChannelLevelPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("gain", cdk.validateNumber)(properties.gain)), errors.collect(cdk.propertyValidator("inputChannel", cdk.validateNumber)(properties.inputChannel)), errors.wrap('supplied properties not correct for "InputChannelLevelProperty"');
    }
    function cfnChannelInputChannelLevelPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_InputChannelLevelPropertyValidator(properties).assertSuccess(), { Gain: cdk.numberToCloudFormation(properties.gain), InputChannel: cdk.numberToCloudFormation(properties.inputChannel) }) : properties;
    }
    function CfnChannelInputChannelLevelPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("gain", "Gain", properties.Gain != null ? cfn_parse.FromCloudFormation.getNumber(properties.Gain) : void 0), ret.addPropertyResult("inputChannel", "InputChannel", properties.InputChannel != null ? cfn_parse.FromCloudFormation.getNumber(properties.InputChannel) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_InputLocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("passwordParam", cdk.validateString)(properties.passwordParam)), errors.collect(cdk.propertyValidator("uri", cdk.validateString)(properties.uri)), errors.collect(cdk.propertyValidator("username", cdk.validateString)(properties.username)), errors.wrap('supplied properties not correct for "InputLocationProperty"');
    }
    function cfnChannelInputLocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_InputLocationPropertyValidator(properties).assertSuccess(), { PasswordParam: cdk.stringToCloudFormation(properties.passwordParam), Uri: cdk.stringToCloudFormation(properties.uri), Username: cdk.stringToCloudFormation(properties.username) }) : properties;
    }
    function CfnChannelInputLocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("passwordParam", "PasswordParam", properties.PasswordParam != null ? cfn_parse.FromCloudFormation.getString(properties.PasswordParam) : void 0), ret.addPropertyResult("uri", "Uri", properties.Uri != null ? cfn_parse.FromCloudFormation.getString(properties.Uri) : void 0), ret.addPropertyResult("username", "Username", properties.Username != null ? cfn_parse.FromCloudFormation.getString(properties.Username) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_InputLossBehaviorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("blackFrameMsec", cdk.validateNumber)(properties.blackFrameMsec)), errors.collect(cdk.propertyValidator("inputLossImageColor", cdk.validateString)(properties.inputLossImageColor)), errors.collect(cdk.propertyValidator("inputLossImageSlate", CfnChannel_InputLocationPropertyValidator)(properties.inputLossImageSlate)), errors.collect(cdk.propertyValidator("inputLossImageType", cdk.validateString)(properties.inputLossImageType)), errors.collect(cdk.propertyValidator("repeatFrameMsec", cdk.validateNumber)(properties.repeatFrameMsec)), errors.wrap('supplied properties not correct for "InputLossBehaviorProperty"');
    }
    function cfnChannelInputLossBehaviorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_InputLossBehaviorPropertyValidator(properties).assertSuccess(), { BlackFrameMsec: cdk.numberToCloudFormation(properties.blackFrameMsec), InputLossImageColor: cdk.stringToCloudFormation(properties.inputLossImageColor), InputLossImageSlate: cfnChannelInputLocationPropertyToCloudFormation(properties.inputLossImageSlate), InputLossImageType: cdk.stringToCloudFormation(properties.inputLossImageType), RepeatFrameMsec: cdk.numberToCloudFormation(properties.repeatFrameMsec) }) : properties;
    }
    function CfnChannelInputLossBehaviorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("blackFrameMsec", "BlackFrameMsec", properties.BlackFrameMsec != null ? cfn_parse.FromCloudFormation.getNumber(properties.BlackFrameMsec) : void 0), ret.addPropertyResult("inputLossImageColor", "InputLossImageColor", properties.InputLossImageColor != null ? cfn_parse.FromCloudFormation.getString(properties.InputLossImageColor) : void 0), ret.addPropertyResult("inputLossImageSlate", "InputLossImageSlate", properties.InputLossImageSlate != null ? CfnChannelInputLocationPropertyFromCloudFormation(properties.InputLossImageSlate) : void 0), ret.addPropertyResult("inputLossImageType", "InputLossImageType", properties.InputLossImageType != null ? cfn_parse.FromCloudFormation.getString(properties.InputLossImageType) : void 0), ret.addPropertyResult("repeatFrameMsec", "RepeatFrameMsec", properties.RepeatFrameMsec != null ? cfn_parse.FromCloudFormation.getNumber(properties.RepeatFrameMsec) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_InputLossFailoverSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("inputLossThresholdMsec", cdk.validateNumber)(properties.inputLossThresholdMsec)), errors.wrap('supplied properties not correct for "InputLossFailoverSettingsProperty"');
    }
    function cfnChannelInputLossFailoverSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_InputLossFailoverSettingsPropertyValidator(properties).assertSuccess(), { InputLossThresholdMsec: cdk.numberToCloudFormation(properties.inputLossThresholdMsec) }) : properties;
    }
    function CfnChannelInputLossFailoverSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("inputLossThresholdMsec", "InputLossThresholdMsec", properties.InputLossThresholdMsec != null ? cfn_parse.FromCloudFormation.getNumber(properties.InputLossThresholdMsec) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_InputSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("audioSelectors", cdk.listValidator(CfnChannel_AudioSelectorPropertyValidator))(properties.audioSelectors)), errors.collect(cdk.propertyValidator("captionSelectors", cdk.listValidator(CfnChannel_CaptionSelectorPropertyValidator))(properties.captionSelectors)), errors.collect(cdk.propertyValidator("deblockFilter", cdk.validateString)(properties.deblockFilter)), errors.collect(cdk.propertyValidator("denoiseFilter", cdk.validateString)(properties.denoiseFilter)), errors.collect(cdk.propertyValidator("filterStrength", cdk.validateNumber)(properties.filterStrength)), errors.collect(cdk.propertyValidator("inputFilter", cdk.validateString)(properties.inputFilter)), errors.collect(cdk.propertyValidator("networkInputSettings", CfnChannel_NetworkInputSettingsPropertyValidator)(properties.networkInputSettings)), errors.collect(cdk.propertyValidator("scte35Pid", cdk.validateNumber)(properties.scte35Pid)), errors.collect(cdk.propertyValidator("smpte2038DataPreference", cdk.validateString)(properties.smpte2038DataPreference)), errors.collect(cdk.propertyValidator("sourceEndBehavior", cdk.validateString)(properties.sourceEndBehavior)), errors.collect(cdk.propertyValidator("videoSelector", CfnChannel_VideoSelectorPropertyValidator)(properties.videoSelector)), errors.wrap('supplied properties not correct for "InputSettingsProperty"');
    }
    function cfnChannelInputSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_InputSettingsPropertyValidator(properties).assertSuccess(), { AudioSelectors: cdk.listMapper(cfnChannelAudioSelectorPropertyToCloudFormation)(properties.audioSelectors), CaptionSelectors: cdk.listMapper(cfnChannelCaptionSelectorPropertyToCloudFormation)(properties.captionSelectors), DeblockFilter: cdk.stringToCloudFormation(properties.deblockFilter), DenoiseFilter: cdk.stringToCloudFormation(properties.denoiseFilter), FilterStrength: cdk.numberToCloudFormation(properties.filterStrength), InputFilter: cdk.stringToCloudFormation(properties.inputFilter), NetworkInputSettings: cfnChannelNetworkInputSettingsPropertyToCloudFormation(properties.networkInputSettings), Scte35Pid: cdk.numberToCloudFormation(properties.scte35Pid), Smpte2038DataPreference: cdk.stringToCloudFormation(properties.smpte2038DataPreference), SourceEndBehavior: cdk.stringToCloudFormation(properties.sourceEndBehavior), VideoSelector: cfnChannelVideoSelectorPropertyToCloudFormation(properties.videoSelector) }) : properties;
    }
    function CfnChannelInputSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("audioSelectors", "AudioSelectors", properties.AudioSelectors != null ? cfn_parse.FromCloudFormation.getArray(CfnChannelAudioSelectorPropertyFromCloudFormation)(properties.AudioSelectors) : void 0), ret.addPropertyResult("captionSelectors", "CaptionSelectors", properties.CaptionSelectors != null ? cfn_parse.FromCloudFormation.getArray(CfnChannelCaptionSelectorPropertyFromCloudFormation)(properties.CaptionSelectors) : void 0), ret.addPropertyResult("deblockFilter", "DeblockFilter", properties.DeblockFilter != null ? cfn_parse.FromCloudFormation.getString(properties.DeblockFilter) : void 0), ret.addPropertyResult("denoiseFilter", "DenoiseFilter", properties.DenoiseFilter != null ? cfn_parse.FromCloudFormation.getString(properties.DenoiseFilter) : void 0), ret.addPropertyResult("filterStrength", "FilterStrength", properties.FilterStrength != null ? cfn_parse.FromCloudFormation.getNumber(properties.FilterStrength) : void 0), ret.addPropertyResult("inputFilter", "InputFilter", properties.InputFilter != null ? cfn_parse.FromCloudFormation.getString(properties.InputFilter) : void 0), ret.addPropertyResult("networkInputSettings", "NetworkInputSettings", properties.NetworkInputSettings != null ? CfnChannelNetworkInputSettingsPropertyFromCloudFormation(properties.NetworkInputSettings) : void 0), ret.addPropertyResult("scte35Pid", "Scte35Pid", properties.Scte35Pid != null ? cfn_parse.FromCloudFormation.getNumber(properties.Scte35Pid) : void 0), ret.addPropertyResult("smpte2038DataPreference", "Smpte2038DataPreference", properties.Smpte2038DataPreference != null ? cfn_parse.FromCloudFormation.getString(properties.Smpte2038DataPreference) : void 0), ret.addPropertyResult("sourceEndBehavior", "SourceEndBehavior", properties.SourceEndBehavior != null ? cfn_parse.FromCloudFormation.getString(properties.SourceEndBehavior) : void 0), ret.addPropertyResult("videoSelector", "VideoSelector", properties.VideoSelector != null ? CfnChannelVideoSelectorPropertyFromCloudFormation(properties.VideoSelector) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_InputSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("codec", cdk.validateString)(properties.codec)), errors.collect(cdk.propertyValidator("maximumBitrate", cdk.validateString)(properties.maximumBitrate)), errors.collect(cdk.propertyValidator("resolution", cdk.validateString)(properties.resolution)), errors.wrap('supplied properties not correct for "InputSpecificationProperty"');
    }
    function cfnChannelInputSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_InputSpecificationPropertyValidator(properties).assertSuccess(), { Codec: cdk.stringToCloudFormation(properties.codec), MaximumBitrate: cdk.stringToCloudFormation(properties.maximumBitrate), Resolution: cdk.stringToCloudFormation(properties.resolution) }) : properties;
    }
    function CfnChannelInputSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("codec", "Codec", properties.Codec != null ? cfn_parse.FromCloudFormation.getString(properties.Codec) : void 0), ret.addPropertyResult("maximumBitrate", "MaximumBitrate", properties.MaximumBitrate != null ? cfn_parse.FromCloudFormation.getString(properties.MaximumBitrate) : void 0), ret.addPropertyResult("resolution", "Resolution", properties.Resolution != null ? cfn_parse.FromCloudFormation.getString(properties.Resolution) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_KeyProviderSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("staticKeySettings", CfnChannel_StaticKeySettingsPropertyValidator)(properties.staticKeySettings)), errors.wrap('supplied properties not correct for "KeyProviderSettingsProperty"');
    }
    function cfnChannelKeyProviderSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_KeyProviderSettingsPropertyValidator(properties).assertSuccess(), { StaticKeySettings: cfnChannelStaticKeySettingsPropertyToCloudFormation(properties.staticKeySettings) }) : properties;
    }
    function CfnChannelKeyProviderSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("staticKeySettings", "StaticKeySettings", properties.StaticKeySettings != null ? CfnChannelStaticKeySettingsPropertyFromCloudFormation(properties.StaticKeySettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_M2tsSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("absentInputAudioBehavior", cdk.validateString)(properties.absentInputAudioBehavior)), errors.collect(cdk.propertyValidator("arib", cdk.validateString)(properties.arib)), errors.collect(cdk.propertyValidator("aribCaptionsPid", cdk.validateString)(properties.aribCaptionsPid)), errors.collect(cdk.propertyValidator("aribCaptionsPidControl", cdk.validateString)(properties.aribCaptionsPidControl)), errors.collect(cdk.propertyValidator("audioBufferModel", cdk.validateString)(properties.audioBufferModel)), errors.collect(cdk.propertyValidator("audioFramesPerPes", cdk.validateNumber)(properties.audioFramesPerPes)), errors.collect(cdk.propertyValidator("audioPids", cdk.validateString)(properties.audioPids)), errors.collect(cdk.propertyValidator("audioStreamType", cdk.validateString)(properties.audioStreamType)), errors.collect(cdk.propertyValidator("bitrate", cdk.validateNumber)(properties.bitrate)), errors.collect(cdk.propertyValidator("bufferModel", cdk.validateString)(properties.bufferModel)), errors.collect(cdk.propertyValidator("ccDescriptor", cdk.validateString)(properties.ccDescriptor)), errors.collect(cdk.propertyValidator("dvbNitSettings", CfnChannel_DvbNitSettingsPropertyValidator)(properties.dvbNitSettings)), errors.collect(cdk.propertyValidator("dvbSdtSettings", CfnChannel_DvbSdtSettingsPropertyValidator)(properties.dvbSdtSettings)), errors.collect(cdk.propertyValidator("dvbSubPids", cdk.validateString)(properties.dvbSubPids)), errors.collect(cdk.propertyValidator("dvbTdtSettings", CfnChannel_DvbTdtSettingsPropertyValidator)(properties.dvbTdtSettings)), errors.collect(cdk.propertyValidator("dvbTeletextPid", cdk.validateString)(properties.dvbTeletextPid)), errors.collect(cdk.propertyValidator("ebif", cdk.validateString)(properties.ebif)), errors.collect(cdk.propertyValidator("ebpAudioInterval", cdk.validateString)(properties.ebpAudioInterval)), errors.collect(cdk.propertyValidator("ebpLookaheadMs", cdk.validateNumber)(properties.ebpLookaheadMs)), errors.collect(cdk.propertyValidator("ebpPlacement", cdk.validateString)(properties.ebpPlacement)), errors.collect(cdk.propertyValidator("ecmPid", cdk.validateString)(properties.ecmPid)), errors.collect(cdk.propertyValidator("esRateInPes", cdk.validateString)(properties.esRateInPes)), errors.collect(cdk.propertyValidator("etvPlatformPid", cdk.validateString)(properties.etvPlatformPid)), errors.collect(cdk.propertyValidator("etvSignalPid", cdk.validateString)(properties.etvSignalPid)), errors.collect(cdk.propertyValidator("fragmentTime", cdk.validateNumber)(properties.fragmentTime)), errors.collect(cdk.propertyValidator("klv", cdk.validateString)(properties.klv)), errors.collect(cdk.propertyValidator("klvDataPids", cdk.validateString)(properties.klvDataPids)), errors.collect(cdk.propertyValidator("nielsenId3Behavior", cdk.validateString)(properties.nielsenId3Behavior)), errors.collect(cdk.propertyValidator("nullPacketBitrate", cdk.validateNumber)(properties.nullPacketBitrate)), errors.collect(cdk.propertyValidator("patInterval", cdk.validateNumber)(properties.patInterval)), errors.collect(cdk.propertyValidator("pcrControl", cdk.validateString)(properties.pcrControl)), errors.collect(cdk.propertyValidator("pcrPeriod", cdk.validateNumber)(properties.pcrPeriod)), errors.collect(cdk.propertyValidator("pcrPid", cdk.validateString)(properties.pcrPid)), errors.collect(cdk.propertyValidator("pmtInterval", cdk.validateNumber)(properties.pmtInterval)), errors.collect(cdk.propertyValidator("pmtPid", cdk.validateString)(properties.pmtPid)), errors.collect(cdk.propertyValidator("programNum", cdk.validateNumber)(properties.programNum)), errors.collect(cdk.propertyValidator("rateMode", cdk.validateString)(properties.rateMode)), errors.collect(cdk.propertyValidator("scte27Pids", cdk.validateString)(properties.scte27Pids)), errors.collect(cdk.propertyValidator("scte35Control", cdk.validateString)(properties.scte35Control)), errors.collect(cdk.propertyValidator("scte35Pid", cdk.validateString)(properties.scte35Pid)), errors.collect(cdk.propertyValidator("scte35PrerollPullupMilliseconds", cdk.validateNumber)(properties.scte35PrerollPullupMilliseconds)), errors.collect(cdk.propertyValidator("segmentationMarkers", cdk.validateString)(properties.segmentationMarkers)), errors.collect(cdk.propertyValidator("segmentationStyle", cdk.validateString)(properties.segmentationStyle)), errors.collect(cdk.propertyValidator("segmentationTime", cdk.validateNumber)(properties.segmentationTime)), errors.collect(cdk.propertyValidator("timedMetadataBehavior", cdk.validateString)(properties.timedMetadataBehavior)), errors.collect(cdk.propertyValidator("timedMetadataPid", cdk.validateString)(properties.timedMetadataPid)), errors.collect(cdk.propertyValidator("transportStreamId", cdk.validateNumber)(properties.transportStreamId)), errors.collect(cdk.propertyValidator("videoPid", cdk.validateString)(properties.videoPid)), errors.wrap('supplied properties not correct for "M2tsSettingsProperty"');
    }
    function cfnChannelM2tsSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_M2tsSettingsPropertyValidator(properties).assertSuccess(), { AbsentInputAudioBehavior: cdk.stringToCloudFormation(properties.absentInputAudioBehavior), Arib: cdk.stringToCloudFormation(properties.arib), AribCaptionsPid: cdk.stringToCloudFormation(properties.aribCaptionsPid), AribCaptionsPidControl: cdk.stringToCloudFormation(properties.aribCaptionsPidControl), AudioBufferModel: cdk.stringToCloudFormation(properties.audioBufferModel), AudioFramesPerPes: cdk.numberToCloudFormation(properties.audioFramesPerPes), AudioPids: cdk.stringToCloudFormation(properties.audioPids), AudioStreamType: cdk.stringToCloudFormation(properties.audioStreamType), Bitrate: cdk.numberToCloudFormation(properties.bitrate), BufferModel: cdk.stringToCloudFormation(properties.bufferModel), CcDescriptor: cdk.stringToCloudFormation(properties.ccDescriptor), DvbNitSettings: cfnChannelDvbNitSettingsPropertyToCloudFormation(properties.dvbNitSettings), DvbSdtSettings: cfnChannelDvbSdtSettingsPropertyToCloudFormation(properties.dvbSdtSettings), DvbSubPids: cdk.stringToCloudFormation(properties.dvbSubPids), DvbTdtSettings: cfnChannelDvbTdtSettingsPropertyToCloudFormation(properties.dvbTdtSettings), DvbTeletextPid: cdk.stringToCloudFormation(properties.dvbTeletextPid), Ebif: cdk.stringToCloudFormation(properties.ebif), EbpAudioInterval: cdk.stringToCloudFormation(properties.ebpAudioInterval), EbpLookaheadMs: cdk.numberToCloudFormation(properties.ebpLookaheadMs), EbpPlacement: cdk.stringToCloudFormation(properties.ebpPlacement), EcmPid: cdk.stringToCloudFormation(properties.ecmPid), EsRateInPes: cdk.stringToCloudFormation(properties.esRateInPes), EtvPlatformPid: cdk.stringToCloudFormation(properties.etvPlatformPid), EtvSignalPid: cdk.stringToCloudFormation(properties.etvSignalPid), FragmentTime: cdk.numberToCloudFormation(properties.fragmentTime), Klv: cdk.stringToCloudFormation(properties.klv), KlvDataPids: cdk.stringToCloudFormation(properties.klvDataPids), NielsenId3Behavior: cdk.stringToCloudFormation(properties.nielsenId3Behavior), NullPacketBitrate: cdk.numberToCloudFormation(properties.nullPacketBitrate), PatInterval: cdk.numberToCloudFormation(properties.patInterval), PcrControl: cdk.stringToCloudFormation(properties.pcrControl), PcrPeriod: cdk.numberToCloudFormation(properties.pcrPeriod), PcrPid: cdk.stringToCloudFormation(properties.pcrPid), PmtInterval: cdk.numberToCloudFormation(properties.pmtInterval), PmtPid: cdk.stringToCloudFormation(properties.pmtPid), ProgramNum: cdk.numberToCloudFormation(properties.programNum), RateMode: cdk.stringToCloudFormation(properties.rateMode), Scte27Pids: cdk.stringToCloudFormation(properties.scte27Pids), Scte35Control: cdk.stringToCloudFormation(properties.scte35Control), Scte35Pid: cdk.stringToCloudFormation(properties.scte35Pid), Scte35PrerollPullupMilliseconds: cdk.numberToCloudFormation(properties.scte35PrerollPullupMilliseconds), SegmentationMarkers: cdk.stringToCloudFormation(properties.segmentationMarkers), SegmentationStyle: cdk.stringToCloudFormation(properties.segmentationStyle), SegmentationTime: cdk.numberToCloudFormation(properties.segmentationTime), TimedMetadataBehavior: cdk.stringToCloudFormation(properties.timedMetadataBehavior), TimedMetadataPid: cdk.stringToCloudFormation(properties.timedMetadataPid), TransportStreamId: cdk.numberToCloudFormation(properties.transportStreamId), VideoPid: cdk.stringToCloudFormation(properties.videoPid) }) : properties;
    }
    function CfnChannelM2tsSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("absentInputAudioBehavior", "AbsentInputAudioBehavior", properties.AbsentInputAudioBehavior != null ? cfn_parse.FromCloudFormation.getString(properties.AbsentInputAudioBehavior) : void 0), ret.addPropertyResult("arib", "Arib", properties.Arib != null ? cfn_parse.FromCloudFormation.getString(properties.Arib) : void 0), ret.addPropertyResult("aribCaptionsPid", "AribCaptionsPid", properties.AribCaptionsPid != null ? cfn_parse.FromCloudFormation.getString(properties.AribCaptionsPid) : void 0), ret.addPropertyResult("aribCaptionsPidControl", "AribCaptionsPidControl", properties.AribCaptionsPidControl != null ? cfn_parse.FromCloudFormation.getString(properties.AribCaptionsPidControl) : void 0), ret.addPropertyResult("audioBufferModel", "AudioBufferModel", properties.AudioBufferModel != null ? cfn_parse.FromCloudFormation.getString(properties.AudioBufferModel) : void 0), ret.addPropertyResult("audioFramesPerPes", "AudioFramesPerPes", properties.AudioFramesPerPes != null ? cfn_parse.FromCloudFormation.getNumber(properties.AudioFramesPerPes) : void 0), ret.addPropertyResult("audioPids", "AudioPids", properties.AudioPids != null ? cfn_parse.FromCloudFormation.getString(properties.AudioPids) : void 0), ret.addPropertyResult("audioStreamType", "AudioStreamType", properties.AudioStreamType != null ? cfn_parse.FromCloudFormation.getString(properties.AudioStreamType) : void 0), ret.addPropertyResult("bitrate", "Bitrate", properties.Bitrate != null ? cfn_parse.FromCloudFormation.getNumber(properties.Bitrate) : void 0), ret.addPropertyResult("bufferModel", "BufferModel", properties.BufferModel != null ? cfn_parse.FromCloudFormation.getString(properties.BufferModel) : void 0), ret.addPropertyResult("ccDescriptor", "CcDescriptor", properties.CcDescriptor != null ? cfn_parse.FromCloudFormation.getString(properties.CcDescriptor) : void 0), ret.addPropertyResult("dvbNitSettings", "DvbNitSettings", properties.DvbNitSettings != null ? CfnChannelDvbNitSettingsPropertyFromCloudFormation(properties.DvbNitSettings) : void 0), ret.addPropertyResult("dvbSdtSettings", "DvbSdtSettings", properties.DvbSdtSettings != null ? CfnChannelDvbSdtSettingsPropertyFromCloudFormation(properties.DvbSdtSettings) : void 0), ret.addPropertyResult("dvbSubPids", "DvbSubPids", properties.DvbSubPids != null ? cfn_parse.FromCloudFormation.getString(properties.DvbSubPids) : void 0), ret.addPropertyResult("dvbTdtSettings", "DvbTdtSettings", properties.DvbTdtSettings != null ? CfnChannelDvbTdtSettingsPropertyFromCloudFormation(properties.DvbTdtSettings) : void 0), ret.addPropertyResult("dvbTeletextPid", "DvbTeletextPid", properties.DvbTeletextPid != null ? cfn_parse.FromCloudFormation.getString(properties.DvbTeletextPid) : void 0), ret.addPropertyResult("ebif", "Ebif", properties.Ebif != null ? cfn_parse.FromCloudFormation.getString(properties.Ebif) : void 0), ret.addPropertyResult("ebpAudioInterval", "EbpAudioInterval", properties.EbpAudioInterval != null ? cfn_parse.FromCloudFormation.getString(properties.EbpAudioInterval) : void 0), ret.addPropertyResult("ebpLookaheadMs", "EbpLookaheadMs", properties.EbpLookaheadMs != null ? cfn_parse.FromCloudFormation.getNumber(properties.EbpLookaheadMs) : void 0), ret.addPropertyResult("ebpPlacement", "EbpPlacement", properties.EbpPlacement != null ? cfn_parse.FromCloudFormation.getString(properties.EbpPlacement) : void 0), ret.addPropertyResult("ecmPid", "EcmPid", properties.EcmPid != null ? cfn_parse.FromCloudFormation.getString(properties.EcmPid) : void 0), ret.addPropertyResult("esRateInPes", "EsRateInPes", properties.EsRateInPes != null ? cfn_parse.FromCloudFormation.getString(properties.EsRateInPes) : void 0), ret.addPropertyResult("etvPlatformPid", "EtvPlatformPid", properties.EtvPlatformPid != null ? cfn_parse.FromCloudFormation.getString(properties.EtvPlatformPid) : void 0), ret.addPropertyResult("etvSignalPid", "EtvSignalPid", properties.EtvSignalPid != null ? cfn_parse.FromCloudFormation.getString(properties.EtvSignalPid) : void 0), ret.addPropertyResult("fragmentTime", "FragmentTime", properties.FragmentTime != null ? cfn_parse.FromCloudFormation.getNumber(properties.FragmentTime) : void 0), ret.addPropertyResult("klv", "Klv", properties.Klv != null ? cfn_parse.FromCloudFormation.getString(properties.Klv) : void 0), ret.addPropertyResult("klvDataPids", "KlvDataPids", properties.KlvDataPids != null ? cfn_parse.FromCloudFormation.getString(properties.KlvDataPids) : void 0), ret.addPropertyResult("nielsenId3Behavior", "NielsenId3Behavior", properties.NielsenId3Behavior != null ? cfn_parse.FromCloudFormation.getString(properties.NielsenId3Behavior) : void 0), ret.addPropertyResult("nullPacketBitrate", "NullPacketBitrate", properties.NullPacketBitrate != null ? cfn_parse.FromCloudFormation.getNumber(properties.NullPacketBitrate) : void 0), ret.addPropertyResult("patInterval", "PatInterval", properties.PatInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.PatInterval) : void 0), ret.addPropertyResult("pcrControl", "PcrControl", properties.PcrControl != null ? cfn_parse.FromCloudFormation.getString(properties.PcrControl) : void 0), ret.addPropertyResult("pcrPeriod", "PcrPeriod", properties.PcrPeriod != null ? cfn_parse.FromCloudFormation.getNumber(properties.PcrPeriod) : void 0), ret.addPropertyResult("pcrPid", "PcrPid", properties.PcrPid != null ? cfn_parse.FromCloudFormation.getString(properties.PcrPid) : void 0), ret.addPropertyResult("pmtInterval", "PmtInterval", properties.PmtInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.PmtInterval) : void 0), ret.addPropertyResult("pmtPid", "PmtPid", properties.PmtPid != null ? cfn_parse.FromCloudFormation.getString(properties.PmtPid) : void 0), ret.addPropertyResult("programNum", "ProgramNum", properties.ProgramNum != null ? cfn_parse.FromCloudFormation.getNumber(properties.ProgramNum) : void 0), ret.addPropertyResult("rateMode", "RateMode", properties.RateMode != null ? cfn_parse.FromCloudFormation.getString(properties.RateMode) : void 0), ret.addPropertyResult("scte27Pids", "Scte27Pids", properties.Scte27Pids != null ? cfn_parse.FromCloudFormation.getString(properties.Scte27Pids) : void 0), ret.addPropertyResult("scte35Control", "Scte35Control", properties.Scte35Control != null ? cfn_parse.FromCloudFormation.getString(properties.Scte35Control) : void 0), ret.addPropertyResult("scte35Pid", "Scte35Pid", properties.Scte35Pid != null ? cfn_parse.FromCloudFormation.getString(properties.Scte35Pid) : void 0), ret.addPropertyResult("scte35PrerollPullupMilliseconds", "Scte35PrerollPullupMilliseconds", properties.Scte35PrerollPullupMilliseconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.Scte35PrerollPullupMilliseconds) : void 0), ret.addPropertyResult("segmentationMarkers", "SegmentationMarkers", properties.SegmentationMarkers != null ? cfn_parse.FromCloudFormation.getString(properties.SegmentationMarkers) : void 0), ret.addPropertyResult("segmentationStyle", "SegmentationStyle", properties.SegmentationStyle != null ? cfn_parse.FromCloudFormation.getString(properties.SegmentationStyle) : void 0), ret.addPropertyResult("segmentationTime", "SegmentationTime", properties.SegmentationTime != null ? cfn_parse.FromCloudFormation.getNumber(properties.SegmentationTime) : void 0), ret.addPropertyResult("timedMetadataBehavior", "TimedMetadataBehavior", properties.TimedMetadataBehavior != null ? cfn_parse.FromCloudFormation.getString(properties.TimedMetadataBehavior) : void 0), ret.addPropertyResult("timedMetadataPid", "TimedMetadataPid", properties.TimedMetadataPid != null ? cfn_parse.FromCloudFormation.getString(properties.TimedMetadataPid) : void 0), ret.addPropertyResult("transportStreamId", "TransportStreamId", properties.TransportStreamId != null ? cfn_parse.FromCloudFormation.getNumber(properties.TransportStreamId) : void 0), ret.addPropertyResult("videoPid", "VideoPid", properties.VideoPid != null ? cfn_parse.FromCloudFormation.getString(properties.VideoPid) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_M3u8SettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("audioFramesPerPes", cdk.validateNumber)(properties.audioFramesPerPes)), errors.collect(cdk.propertyValidator("audioPids", cdk.validateString)(properties.audioPids)), errors.collect(cdk.propertyValidator("ecmPid", cdk.validateString)(properties.ecmPid)), errors.collect(cdk.propertyValidator("nielsenId3Behavior", cdk.validateString)(properties.nielsenId3Behavior)), errors.collect(cdk.propertyValidator("patInterval", cdk.validateNumber)(properties.patInterval)), errors.collect(cdk.propertyValidator("pcrControl", cdk.validateString)(properties.pcrControl)), errors.collect(cdk.propertyValidator("pcrPeriod", cdk.validateNumber)(properties.pcrPeriod)), errors.collect(cdk.propertyValidator("pcrPid", cdk.validateString)(properties.pcrPid)), errors.collect(cdk.propertyValidator("pmtInterval", cdk.validateNumber)(properties.pmtInterval)), errors.collect(cdk.propertyValidator("pmtPid", cdk.validateString)(properties.pmtPid)), errors.collect(cdk.propertyValidator("programNum", cdk.validateNumber)(properties.programNum)), errors.collect(cdk.propertyValidator("scte35Behavior", cdk.validateString)(properties.scte35Behavior)), errors.collect(cdk.propertyValidator("scte35Pid", cdk.validateString)(properties.scte35Pid)), errors.collect(cdk.propertyValidator("timedMetadataBehavior", cdk.validateString)(properties.timedMetadataBehavior)), errors.collect(cdk.propertyValidator("timedMetadataPid", cdk.validateString)(properties.timedMetadataPid)), errors.collect(cdk.propertyValidator("transportStreamId", cdk.validateNumber)(properties.transportStreamId)), errors.collect(cdk.propertyValidator("videoPid", cdk.validateString)(properties.videoPid)), errors.wrap('supplied properties not correct for "M3u8SettingsProperty"');
    }
    function cfnChannelM3u8SettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_M3u8SettingsPropertyValidator(properties).assertSuccess(), { AudioFramesPerPes: cdk.numberToCloudFormation(properties.audioFramesPerPes), AudioPids: cdk.stringToCloudFormation(properties.audioPids), EcmPid: cdk.stringToCloudFormation(properties.ecmPid), NielsenId3Behavior: cdk.stringToCloudFormation(properties.nielsenId3Behavior), PatInterval: cdk.numberToCloudFormation(properties.patInterval), PcrControl: cdk.stringToCloudFormation(properties.pcrControl), PcrPeriod: cdk.numberToCloudFormation(properties.pcrPeriod), PcrPid: cdk.stringToCloudFormation(properties.pcrPid), PmtInterval: cdk.numberToCloudFormation(properties.pmtInterval), PmtPid: cdk.stringToCloudFormation(properties.pmtPid), ProgramNum: cdk.numberToCloudFormation(properties.programNum), Scte35Behavior: cdk.stringToCloudFormation(properties.scte35Behavior), Scte35Pid: cdk.stringToCloudFormation(properties.scte35Pid), TimedMetadataBehavior: cdk.stringToCloudFormation(properties.timedMetadataBehavior), TimedMetadataPid: cdk.stringToCloudFormation(properties.timedMetadataPid), TransportStreamId: cdk.numberToCloudFormation(properties.transportStreamId), VideoPid: cdk.stringToCloudFormation(properties.videoPid) }) : properties;
    }
    function CfnChannelM3u8SettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("audioFramesPerPes", "AudioFramesPerPes", properties.AudioFramesPerPes != null ? cfn_parse.FromCloudFormation.getNumber(properties.AudioFramesPerPes) : void 0), ret.addPropertyResult("audioPids", "AudioPids", properties.AudioPids != null ? cfn_parse.FromCloudFormation.getString(properties.AudioPids) : void 0), ret.addPropertyResult("ecmPid", "EcmPid", properties.EcmPid != null ? cfn_parse.FromCloudFormation.getString(properties.EcmPid) : void 0), ret.addPropertyResult("nielsenId3Behavior", "NielsenId3Behavior", properties.NielsenId3Behavior != null ? cfn_parse.FromCloudFormation.getString(properties.NielsenId3Behavior) : void 0), ret.addPropertyResult("patInterval", "PatInterval", properties.PatInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.PatInterval) : void 0), ret.addPropertyResult("pcrControl", "PcrControl", properties.PcrControl != null ? cfn_parse.FromCloudFormation.getString(properties.PcrControl) : void 0), ret.addPropertyResult("pcrPeriod", "PcrPeriod", properties.PcrPeriod != null ? cfn_parse.FromCloudFormation.getNumber(properties.PcrPeriod) : void 0), ret.addPropertyResult("pcrPid", "PcrPid", properties.PcrPid != null ? cfn_parse.FromCloudFormation.getString(properties.PcrPid) : void 0), ret.addPropertyResult("pmtInterval", "PmtInterval", properties.PmtInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.PmtInterval) : void 0), ret.addPropertyResult("pmtPid", "PmtPid", properties.PmtPid != null ? cfn_parse.FromCloudFormation.getString(properties.PmtPid) : void 0), ret.addPropertyResult("programNum", "ProgramNum", properties.ProgramNum != null ? cfn_parse.FromCloudFormation.getNumber(properties.ProgramNum) : void 0), ret.addPropertyResult("scte35Behavior", "Scte35Behavior", properties.Scte35Behavior != null ? cfn_parse.FromCloudFormation.getString(properties.Scte35Behavior) : void 0), ret.addPropertyResult("scte35Pid", "Scte35Pid", properties.Scte35Pid != null ? cfn_parse.FromCloudFormation.getString(properties.Scte35Pid) : void 0), ret.addPropertyResult("timedMetadataBehavior", "TimedMetadataBehavior", properties.TimedMetadataBehavior != null ? cfn_parse.FromCloudFormation.getString(properties.TimedMetadataBehavior) : void 0), ret.addPropertyResult("timedMetadataPid", "TimedMetadataPid", properties.TimedMetadataPid != null ? cfn_parse.FromCloudFormation.getString(properties.TimedMetadataPid) : void 0), ret.addPropertyResult("transportStreamId", "TransportStreamId", properties.TransportStreamId != null ? cfn_parse.FromCloudFormation.getNumber(properties.TransportStreamId) : void 0), ret.addPropertyResult("videoPid", "VideoPid", properties.VideoPid != null ? cfn_parse.FromCloudFormation.getString(properties.VideoPid) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_MaintenanceCreateSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maintenanceDay", cdk.validateString)(properties.maintenanceDay)), errors.collect(cdk.propertyValidator("maintenanceStartTime", cdk.validateString)(properties.maintenanceStartTime)), errors.wrap('supplied properties not correct for "MaintenanceCreateSettingsProperty"');
    }
    function cfnChannelMaintenanceCreateSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_MaintenanceCreateSettingsPropertyValidator(properties).assertSuccess(), { MaintenanceDay: cdk.stringToCloudFormation(properties.maintenanceDay), MaintenanceStartTime: cdk.stringToCloudFormation(properties.maintenanceStartTime) }) : properties;
    }
    function CfnChannelMaintenanceCreateSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maintenanceDay", "MaintenanceDay", properties.MaintenanceDay != null ? cfn_parse.FromCloudFormation.getString(properties.MaintenanceDay) : void 0), ret.addPropertyResult("maintenanceStartTime", "MaintenanceStartTime", properties.MaintenanceStartTime != null ? cfn_parse.FromCloudFormation.getString(properties.MaintenanceStartTime) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_MediaPackageGroupSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destination", CfnChannel_OutputLocationRefPropertyValidator)(properties.destination)), errors.wrap('supplied properties not correct for "MediaPackageGroupSettingsProperty"');
    }
    function cfnChannelMediaPackageGroupSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_MediaPackageGroupSettingsPropertyValidator(properties).assertSuccess(), { Destination: cfnChannelOutputLocationRefPropertyToCloudFormation(properties.destination) }) : properties;
    }
    function CfnChannelMediaPackageGroupSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destination", "Destination", properties.Destination != null ? CfnChannelOutputLocationRefPropertyFromCloudFormation(properties.Destination) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_MediaPackageOutputDestinationSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("channelId", cdk.validateString)(properties.channelId)), errors.wrap('supplied properties not correct for "MediaPackageOutputDestinationSettingsProperty"');
    }
    function cfnChannelMediaPackageOutputDestinationSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_MediaPackageOutputDestinationSettingsPropertyValidator(properties).assertSuccess(), { ChannelId: cdk.stringToCloudFormation(properties.channelId) }) : properties;
    }
    function CfnChannelMediaPackageOutputDestinationSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("channelId", "ChannelId", properties.ChannelId != null ? cfn_parse.FromCloudFormation.getString(properties.ChannelId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_MediaPackageOutputSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.wrap('supplied properties not correct for "MediaPackageOutputSettingsProperty"');
    }
    function cfnChannelMediaPackageOutputSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_MediaPackageOutputSettingsPropertyValidator(properties).assertSuccess(), {}) : properties;
    }
    function CfnChannelMediaPackageOutputSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_MotionGraphicsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("motionGraphicsInsertion", cdk.validateString)(properties.motionGraphicsInsertion)), errors.collect(cdk.propertyValidator("motionGraphicsSettings", CfnChannel_MotionGraphicsSettingsPropertyValidator)(properties.motionGraphicsSettings)), errors.wrap('supplied properties not correct for "MotionGraphicsConfigurationProperty"');
    }
    function cfnChannelMotionGraphicsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_MotionGraphicsConfigurationPropertyValidator(properties).assertSuccess(), { MotionGraphicsInsertion: cdk.stringToCloudFormation(properties.motionGraphicsInsertion), MotionGraphicsSettings: cfnChannelMotionGraphicsSettingsPropertyToCloudFormation(properties.motionGraphicsSettings) }) : properties;
    }
    function CfnChannelMotionGraphicsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("motionGraphicsInsertion", "MotionGraphicsInsertion", properties.MotionGraphicsInsertion != null ? cfn_parse.FromCloudFormation.getString(properties.MotionGraphicsInsertion) : void 0), ret.addPropertyResult("motionGraphicsSettings", "MotionGraphicsSettings", properties.MotionGraphicsSettings != null ? CfnChannelMotionGraphicsSettingsPropertyFromCloudFormation(properties.MotionGraphicsSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_MotionGraphicsSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("htmlMotionGraphicsSettings", CfnChannel_HtmlMotionGraphicsSettingsPropertyValidator)(properties.htmlMotionGraphicsSettings)), errors.wrap('supplied properties not correct for "MotionGraphicsSettingsProperty"');
    }
    function cfnChannelMotionGraphicsSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_MotionGraphicsSettingsPropertyValidator(properties).assertSuccess(), { HtmlMotionGraphicsSettings: cfnChannelHtmlMotionGraphicsSettingsPropertyToCloudFormation(properties.htmlMotionGraphicsSettings) }) : properties;
    }
    function CfnChannelMotionGraphicsSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("htmlMotionGraphicsSettings", "HtmlMotionGraphicsSettings", properties.HtmlMotionGraphicsSettings != null ? CfnChannelHtmlMotionGraphicsSettingsPropertyFromCloudFormation(properties.HtmlMotionGraphicsSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_Mp2SettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bitrate", cdk.validateNumber)(properties.bitrate)), errors.collect(cdk.propertyValidator("codingMode", cdk.validateString)(properties.codingMode)), errors.collect(cdk.propertyValidator("sampleRate", cdk.validateNumber)(properties.sampleRate)), errors.wrap('supplied properties not correct for "Mp2SettingsProperty"');
    }
    function cfnChannelMp2SettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_Mp2SettingsPropertyValidator(properties).assertSuccess(), { Bitrate: cdk.numberToCloudFormation(properties.bitrate), CodingMode: cdk.stringToCloudFormation(properties.codingMode), SampleRate: cdk.numberToCloudFormation(properties.sampleRate) }) : properties;
    }
    function CfnChannelMp2SettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bitrate", "Bitrate", properties.Bitrate != null ? cfn_parse.FromCloudFormation.getNumber(properties.Bitrate) : void 0), ret.addPropertyResult("codingMode", "CodingMode", properties.CodingMode != null ? cfn_parse.FromCloudFormation.getString(properties.CodingMode) : void 0), ret.addPropertyResult("sampleRate", "SampleRate", properties.SampleRate != null ? cfn_parse.FromCloudFormation.getNumber(properties.SampleRate) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_Mpeg2FilterSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("temporalFilterSettings", CfnChannel_TemporalFilterSettingsPropertyValidator)(properties.temporalFilterSettings)), errors.wrap('supplied properties not correct for "Mpeg2FilterSettingsProperty"');
    }
    function cfnChannelMpeg2FilterSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_Mpeg2FilterSettingsPropertyValidator(properties).assertSuccess(), { TemporalFilterSettings: cfnChannelTemporalFilterSettingsPropertyToCloudFormation(properties.temporalFilterSettings) }) : properties;
    }
    function CfnChannelMpeg2FilterSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("temporalFilterSettings", "TemporalFilterSettings", properties.TemporalFilterSettings != null ? CfnChannelTemporalFilterSettingsPropertyFromCloudFormation(properties.TemporalFilterSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_Mpeg2SettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("adaptiveQuantization", cdk.validateString)(properties.adaptiveQuantization)), errors.collect(cdk.propertyValidator("afdSignaling", cdk.validateString)(properties.afdSignaling)), errors.collect(cdk.propertyValidator("colorMetadata", cdk.validateString)(properties.colorMetadata)), errors.collect(cdk.propertyValidator("colorSpace", cdk.validateString)(properties.colorSpace)), errors.collect(cdk.propertyValidator("displayAspectRatio", cdk.validateString)(properties.displayAspectRatio)), errors.collect(cdk.propertyValidator("filterSettings", CfnChannel_Mpeg2FilterSettingsPropertyValidator)(properties.filterSettings)), errors.collect(cdk.propertyValidator("fixedAfd", cdk.validateString)(properties.fixedAfd)), errors.collect(cdk.propertyValidator("framerateDenominator", cdk.validateNumber)(properties.framerateDenominator)), errors.collect(cdk.propertyValidator("framerateNumerator", cdk.validateNumber)(properties.framerateNumerator)), errors.collect(cdk.propertyValidator("gopClosedCadence", cdk.validateNumber)(properties.gopClosedCadence)), errors.collect(cdk.propertyValidator("gopNumBFrames", cdk.validateNumber)(properties.gopNumBFrames)), errors.collect(cdk.propertyValidator("gopSize", cdk.validateNumber)(properties.gopSize)), errors.collect(cdk.propertyValidator("gopSizeUnits", cdk.validateString)(properties.gopSizeUnits)), errors.collect(cdk.propertyValidator("scanType", cdk.validateString)(properties.scanType)), errors.collect(cdk.propertyValidator("subgopLength", cdk.validateString)(properties.subgopLength)), errors.collect(cdk.propertyValidator("timecodeBurninSettings", CfnChannel_TimecodeBurninSettingsPropertyValidator)(properties.timecodeBurninSettings)), errors.collect(cdk.propertyValidator("timecodeInsertion", cdk.validateString)(properties.timecodeInsertion)), errors.wrap('supplied properties not correct for "Mpeg2SettingsProperty"');
    }
    function cfnChannelMpeg2SettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_Mpeg2SettingsPropertyValidator(properties).assertSuccess(), { AdaptiveQuantization: cdk.stringToCloudFormation(properties.adaptiveQuantization), AfdSignaling: cdk.stringToCloudFormation(properties.afdSignaling), ColorMetadata: cdk.stringToCloudFormation(properties.colorMetadata), ColorSpace: cdk.stringToCloudFormation(properties.colorSpace), DisplayAspectRatio: cdk.stringToCloudFormation(properties.displayAspectRatio), FilterSettings: cfnChannelMpeg2FilterSettingsPropertyToCloudFormation(properties.filterSettings), FixedAfd: cdk.stringToCloudFormation(properties.fixedAfd), FramerateDenominator: cdk.numberToCloudFormation(properties.framerateDenominator), FramerateNumerator: cdk.numberToCloudFormation(properties.framerateNumerator), GopClosedCadence: cdk.numberToCloudFormation(properties.gopClosedCadence), GopNumBFrames: cdk.numberToCloudFormation(properties.gopNumBFrames), GopSize: cdk.numberToCloudFormation(properties.gopSize), GopSizeUnits: cdk.stringToCloudFormation(properties.gopSizeUnits), ScanType: cdk.stringToCloudFormation(properties.scanType), SubgopLength: cdk.stringToCloudFormation(properties.subgopLength), TimecodeBurninSettings: cfnChannelTimecodeBurninSettingsPropertyToCloudFormation(properties.timecodeBurninSettings), TimecodeInsertion: cdk.stringToCloudFormation(properties.timecodeInsertion) }) : properties;
    }
    function CfnChannelMpeg2SettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("adaptiveQuantization", "AdaptiveQuantization", properties.AdaptiveQuantization != null ? cfn_parse.FromCloudFormation.getString(properties.AdaptiveQuantization) : void 0), ret.addPropertyResult("afdSignaling", "AfdSignaling", properties.AfdSignaling != null ? cfn_parse.FromCloudFormation.getString(properties.AfdSignaling) : void 0), ret.addPropertyResult("colorMetadata", "ColorMetadata", properties.ColorMetadata != null ? cfn_parse.FromCloudFormation.getString(properties.ColorMetadata) : void 0), ret.addPropertyResult("colorSpace", "ColorSpace", properties.ColorSpace != null ? cfn_parse.FromCloudFormation.getString(properties.ColorSpace) : void 0), ret.addPropertyResult("displayAspectRatio", "DisplayAspectRatio", properties.DisplayAspectRatio != null ? cfn_parse.FromCloudFormation.getString(properties.DisplayAspectRatio) : void 0), ret.addPropertyResult("filterSettings", "FilterSettings", properties.FilterSettings != null ? CfnChannelMpeg2FilterSettingsPropertyFromCloudFormation(properties.FilterSettings) : void 0), ret.addPropertyResult("fixedAfd", "FixedAfd", properties.FixedAfd != null ? cfn_parse.FromCloudFormation.getString(properties.FixedAfd) : void 0), ret.addPropertyResult("framerateDenominator", "FramerateDenominator", properties.FramerateDenominator != null ? cfn_parse.FromCloudFormation.getNumber(properties.FramerateDenominator) : void 0), ret.addPropertyResult("framerateNumerator", "FramerateNumerator", properties.FramerateNumerator != null ? cfn_parse.FromCloudFormation.getNumber(properties.FramerateNumerator) : void 0), ret.addPropertyResult("gopClosedCadence", "GopClosedCadence", properties.GopClosedCadence != null ? cfn_parse.FromCloudFormation.getNumber(properties.GopClosedCadence) : void 0), ret.addPropertyResult("gopNumBFrames", "GopNumBFrames", properties.GopNumBFrames != null ? cfn_parse.FromCloudFormation.getNumber(properties.GopNumBFrames) : void 0), ret.addPropertyResult("gopSize", "GopSize", properties.GopSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.GopSize) : void 0), ret.addPropertyResult("gopSizeUnits", "GopSizeUnits", properties.GopSizeUnits != null ? cfn_parse.FromCloudFormation.getString(properties.GopSizeUnits) : void 0), ret.addPropertyResult("scanType", "ScanType", properties.ScanType != null ? cfn_parse.FromCloudFormation.getString(properties.ScanType) : void 0), ret.addPropertyResult("subgopLength", "SubgopLength", properties.SubgopLength != null ? cfn_parse.FromCloudFormation.getString(properties.SubgopLength) : void 0), ret.addPropertyResult("timecodeBurninSettings", "TimecodeBurninSettings", properties.TimecodeBurninSettings != null ? CfnChannelTimecodeBurninSettingsPropertyFromCloudFormation(properties.TimecodeBurninSettings) : void 0), ret.addPropertyResult("timecodeInsertion", "TimecodeInsertion", properties.TimecodeInsertion != null ? cfn_parse.FromCloudFormation.getString(properties.TimecodeInsertion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_MsSmoothGroupSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acquisitionPointId", cdk.validateString)(properties.acquisitionPointId)), errors.collect(cdk.propertyValidator("audioOnlyTimecodeControl", cdk.validateString)(properties.audioOnlyTimecodeControl)), errors.collect(cdk.propertyValidator("certificateMode", cdk.validateString)(properties.certificateMode)), errors.collect(cdk.propertyValidator("connectionRetryInterval", cdk.validateNumber)(properties.connectionRetryInterval)), errors.collect(cdk.propertyValidator("destination", CfnChannel_OutputLocationRefPropertyValidator)(properties.destination)), errors.collect(cdk.propertyValidator("eventId", cdk.validateString)(properties.eventId)), errors.collect(cdk.propertyValidator("eventIdMode", cdk.validateString)(properties.eventIdMode)), errors.collect(cdk.propertyValidator("eventStopBehavior", cdk.validateString)(properties.eventStopBehavior)), errors.collect(cdk.propertyValidator("filecacheDuration", cdk.validateNumber)(properties.filecacheDuration)), errors.collect(cdk.propertyValidator("fragmentLength", cdk.validateNumber)(properties.fragmentLength)), errors.collect(cdk.propertyValidator("inputLossAction", cdk.validateString)(properties.inputLossAction)), errors.collect(cdk.propertyValidator("numRetries", cdk.validateNumber)(properties.numRetries)), errors.collect(cdk.propertyValidator("restartDelay", cdk.validateNumber)(properties.restartDelay)), errors.collect(cdk.propertyValidator("segmentationMode", cdk.validateString)(properties.segmentationMode)), errors.collect(cdk.propertyValidator("sendDelayMs", cdk.validateNumber)(properties.sendDelayMs)), errors.collect(cdk.propertyValidator("sparseTrackType", cdk.validateString)(properties.sparseTrackType)), errors.collect(cdk.propertyValidator("streamManifestBehavior", cdk.validateString)(properties.streamManifestBehavior)), errors.collect(cdk.propertyValidator("timestampOffset", cdk.validateString)(properties.timestampOffset)), errors.collect(cdk.propertyValidator("timestampOffsetMode", cdk.validateString)(properties.timestampOffsetMode)), errors.wrap('supplied properties not correct for "MsSmoothGroupSettingsProperty"');
    }
    function cfnChannelMsSmoothGroupSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_MsSmoothGroupSettingsPropertyValidator(properties).assertSuccess(), { AcquisitionPointId: cdk.stringToCloudFormation(properties.acquisitionPointId), AudioOnlyTimecodeControl: cdk.stringToCloudFormation(properties.audioOnlyTimecodeControl), CertificateMode: cdk.stringToCloudFormation(properties.certificateMode), ConnectionRetryInterval: cdk.numberToCloudFormation(properties.connectionRetryInterval), Destination: cfnChannelOutputLocationRefPropertyToCloudFormation(properties.destination), EventId: cdk.stringToCloudFormation(properties.eventId), EventIdMode: cdk.stringToCloudFormation(properties.eventIdMode), EventStopBehavior: cdk.stringToCloudFormation(properties.eventStopBehavior), FilecacheDuration: cdk.numberToCloudFormation(properties.filecacheDuration), FragmentLength: cdk.numberToCloudFormation(properties.fragmentLength), InputLossAction: cdk.stringToCloudFormation(properties.inputLossAction), NumRetries: cdk.numberToCloudFormation(properties.numRetries), RestartDelay: cdk.numberToCloudFormation(properties.restartDelay), SegmentationMode: cdk.stringToCloudFormation(properties.segmentationMode), SendDelayMs: cdk.numberToCloudFormation(properties.sendDelayMs), SparseTrackType: cdk.stringToCloudFormation(properties.sparseTrackType), StreamManifestBehavior: cdk.stringToCloudFormation(properties.streamManifestBehavior), TimestampOffset: cdk.stringToCloudFormation(properties.timestampOffset), TimestampOffsetMode: cdk.stringToCloudFormation(properties.timestampOffsetMode) }) : properties;
    }
    function CfnChannelMsSmoothGroupSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("acquisitionPointId", "AcquisitionPointId", properties.AcquisitionPointId != null ? cfn_parse.FromCloudFormation.getString(properties.AcquisitionPointId) : void 0), ret.addPropertyResult("audioOnlyTimecodeControl", "AudioOnlyTimecodeControl", properties.AudioOnlyTimecodeControl != null ? cfn_parse.FromCloudFormation.getString(properties.AudioOnlyTimecodeControl) : void 0), ret.addPropertyResult("certificateMode", "CertificateMode", properties.CertificateMode != null ? cfn_parse.FromCloudFormation.getString(properties.CertificateMode) : void 0), ret.addPropertyResult("connectionRetryInterval", "ConnectionRetryInterval", properties.ConnectionRetryInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.ConnectionRetryInterval) : void 0), ret.addPropertyResult("destination", "Destination", properties.Destination != null ? CfnChannelOutputLocationRefPropertyFromCloudFormation(properties.Destination) : void 0), ret.addPropertyResult("eventId", "EventId", properties.EventId != null ? cfn_parse.FromCloudFormation.getString(properties.EventId) : void 0), ret.addPropertyResult("eventIdMode", "EventIdMode", properties.EventIdMode != null ? cfn_parse.FromCloudFormation.getString(properties.EventIdMode) : void 0), ret.addPropertyResult("eventStopBehavior", "EventStopBehavior", properties.EventStopBehavior != null ? cfn_parse.FromCloudFormation.getString(properties.EventStopBehavior) : void 0), ret.addPropertyResult("filecacheDuration", "FilecacheDuration", properties.FilecacheDuration != null ? cfn_parse.FromCloudFormation.getNumber(properties.FilecacheDuration) : void 0), ret.addPropertyResult("fragmentLength", "FragmentLength", properties.FragmentLength != null ? cfn_parse.FromCloudFormation.getNumber(properties.FragmentLength) : void 0), ret.addPropertyResult("inputLossAction", "InputLossAction", properties.InputLossAction != null ? cfn_parse.FromCloudFormation.getString(properties.InputLossAction) : void 0), ret.addPropertyResult("numRetries", "NumRetries", properties.NumRetries != null ? cfn_parse.FromCloudFormation.getNumber(properties.NumRetries) : void 0), ret.addPropertyResult("restartDelay", "RestartDelay", properties.RestartDelay != null ? cfn_parse.FromCloudFormation.getNumber(properties.RestartDelay) : void 0), ret.addPropertyResult("segmentationMode", "SegmentationMode", properties.SegmentationMode != null ? cfn_parse.FromCloudFormation.getString(properties.SegmentationMode) : void 0), ret.addPropertyResult("sendDelayMs", "SendDelayMs", properties.SendDelayMs != null ? cfn_parse.FromCloudFormation.getNumber(properties.SendDelayMs) : void 0), ret.addPropertyResult("sparseTrackType", "SparseTrackType", properties.SparseTrackType != null ? cfn_parse.FromCloudFormation.getString(properties.SparseTrackType) : void 0), ret.addPropertyResult("streamManifestBehavior", "StreamManifestBehavior", properties.StreamManifestBehavior != null ? cfn_parse.FromCloudFormation.getString(properties.StreamManifestBehavior) : void 0), ret.addPropertyResult("timestampOffset", "TimestampOffset", properties.TimestampOffset != null ? cfn_parse.FromCloudFormation.getString(properties.TimestampOffset) : void 0), ret.addPropertyResult("timestampOffsetMode", "TimestampOffsetMode", properties.TimestampOffsetMode != null ? cfn_parse.FromCloudFormation.getString(properties.TimestampOffsetMode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_MsSmoothOutputSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("h265PackagingType", cdk.validateString)(properties.h265PackagingType)), errors.collect(cdk.propertyValidator("nameModifier", cdk.validateString)(properties.nameModifier)), errors.wrap('supplied properties not correct for "MsSmoothOutputSettingsProperty"');
    }
    function cfnChannelMsSmoothOutputSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_MsSmoothOutputSettingsPropertyValidator(properties).assertSuccess(), { H265PackagingType: cdk.stringToCloudFormation(properties.h265PackagingType), NameModifier: cdk.stringToCloudFormation(properties.nameModifier) }) : properties;
    }
    function CfnChannelMsSmoothOutputSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("h265PackagingType", "H265PackagingType", properties.H265PackagingType != null ? cfn_parse.FromCloudFormation.getString(properties.H265PackagingType) : void 0), ret.addPropertyResult("nameModifier", "NameModifier", properties.NameModifier != null ? cfn_parse.FromCloudFormation.getString(properties.NameModifier) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_MultiplexGroupSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.wrap('supplied properties not correct for "MultiplexGroupSettingsProperty"');
    }
    function cfnChannelMultiplexGroupSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_MultiplexGroupSettingsPropertyValidator(properties).assertSuccess(), {}) : properties;
    }
    function CfnChannelMultiplexGroupSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_MultiplexOutputSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destination", CfnChannel_OutputLocationRefPropertyValidator)(properties.destination)), errors.wrap('supplied properties not correct for "MultiplexOutputSettingsProperty"');
    }
    function cfnChannelMultiplexOutputSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_MultiplexOutputSettingsPropertyValidator(properties).assertSuccess(), { Destination: cfnChannelOutputLocationRefPropertyToCloudFormation(properties.destination) }) : properties;
    }
    function CfnChannelMultiplexOutputSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destination", "Destination", properties.Destination != null ? CfnChannelOutputLocationRefPropertyFromCloudFormation(properties.Destination) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_MultiplexProgramChannelDestinationSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("multiplexId", cdk.validateString)(properties.multiplexId)), errors.collect(cdk.propertyValidator("programName", cdk.validateString)(properties.programName)), errors.wrap('supplied properties not correct for "MultiplexProgramChannelDestinationSettingsProperty"');
    }
    function cfnChannelMultiplexProgramChannelDestinationSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_MultiplexProgramChannelDestinationSettingsPropertyValidator(properties).assertSuccess(), { MultiplexId: cdk.stringToCloudFormation(properties.multiplexId), ProgramName: cdk.stringToCloudFormation(properties.programName) }) : properties;
    }
    function CfnChannelMultiplexProgramChannelDestinationSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("multiplexId", "MultiplexId", properties.MultiplexId != null ? cfn_parse.FromCloudFormation.getString(properties.MultiplexId) : void 0), ret.addPropertyResult("programName", "ProgramName", properties.ProgramName != null ? cfn_parse.FromCloudFormation.getString(properties.ProgramName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_NetworkInputSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("hlsInputSettings", CfnChannel_HlsInputSettingsPropertyValidator)(properties.hlsInputSettings)), errors.collect(cdk.propertyValidator("serverValidation", cdk.validateString)(properties.serverValidation)), errors.wrap('supplied properties not correct for "NetworkInputSettingsProperty"');
    }
    function cfnChannelNetworkInputSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_NetworkInputSettingsPropertyValidator(properties).assertSuccess(), { HlsInputSettings: cfnChannelHlsInputSettingsPropertyToCloudFormation(properties.hlsInputSettings), ServerValidation: cdk.stringToCloudFormation(properties.serverValidation) }) : properties;
    }
    function CfnChannelNetworkInputSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("hlsInputSettings", "HlsInputSettings", properties.HlsInputSettings != null ? CfnChannelHlsInputSettingsPropertyFromCloudFormation(properties.HlsInputSettings) : void 0), ret.addPropertyResult("serverValidation", "ServerValidation", properties.ServerValidation != null ? cfn_parse.FromCloudFormation.getString(properties.ServerValidation) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_NielsenCBETPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cbetCheckDigitString", cdk.validateString)(properties.cbetCheckDigitString)), errors.collect(cdk.propertyValidator("cbetStepaside", cdk.validateString)(properties.cbetStepaside)), errors.collect(cdk.propertyValidator("csid", cdk.validateString)(properties.csid)), errors.wrap('supplied properties not correct for "NielsenCBETProperty"');
    }
    function cfnChannelNielsenCBETPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_NielsenCBETPropertyValidator(properties).assertSuccess(), { CbetCheckDigitString: cdk.stringToCloudFormation(properties.cbetCheckDigitString), CbetStepaside: cdk.stringToCloudFormation(properties.cbetStepaside), Csid: cdk.stringToCloudFormation(properties.csid) }) : properties;
    }
    function CfnChannelNielsenCBETPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cbetCheckDigitString", "CbetCheckDigitString", properties.CbetCheckDigitString != null ? cfn_parse.FromCloudFormation.getString(properties.CbetCheckDigitString) : void 0), ret.addPropertyResult("cbetStepaside", "CbetStepaside", properties.CbetStepaside != null ? cfn_parse.FromCloudFormation.getString(properties.CbetStepaside) : void 0), ret.addPropertyResult("csid", "Csid", properties.Csid != null ? cfn_parse.FromCloudFormation.getString(properties.Csid) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_NielsenConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("distributorId", cdk.validateString)(properties.distributorId)), errors.collect(cdk.propertyValidator("nielsenPcmToId3Tagging", cdk.validateString)(properties.nielsenPcmToId3Tagging)), errors.wrap('supplied properties not correct for "NielsenConfigurationProperty"');
    }
    function cfnChannelNielsenConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_NielsenConfigurationPropertyValidator(properties).assertSuccess(), { DistributorId: cdk.stringToCloudFormation(properties.distributorId), NielsenPcmToId3Tagging: cdk.stringToCloudFormation(properties.nielsenPcmToId3Tagging) }) : properties;
    }
    function CfnChannelNielsenConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("distributorId", "DistributorId", properties.DistributorId != null ? cfn_parse.FromCloudFormation.getString(properties.DistributorId) : void 0), ret.addPropertyResult("nielsenPcmToId3Tagging", "NielsenPcmToId3Tagging", properties.NielsenPcmToId3Tagging != null ? cfn_parse.FromCloudFormation.getString(properties.NielsenPcmToId3Tagging) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_NielsenNaesIiNwPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("checkDigitString", cdk.validateString)(properties.checkDigitString)), errors.collect(cdk.propertyValidator("sid", cdk.validateNumber)(properties.sid)), errors.collect(cdk.propertyValidator("timezone", cdk.validateString)(properties.timezone)), errors.wrap('supplied properties not correct for "NielsenNaesIiNwProperty"');
    }
    function cfnChannelNielsenNaesIiNwPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_NielsenNaesIiNwPropertyValidator(properties).assertSuccess(), { CheckDigitString: cdk.stringToCloudFormation(properties.checkDigitString), Sid: cdk.numberToCloudFormation(properties.sid), Timezone: cdk.stringToCloudFormation(properties.timezone) }) : properties;
    }
    function CfnChannelNielsenNaesIiNwPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("checkDigitString", "CheckDigitString", properties.CheckDigitString != null ? cfn_parse.FromCloudFormation.getString(properties.CheckDigitString) : void 0), ret.addPropertyResult("sid", "Sid", properties.Sid != null ? cfn_parse.FromCloudFormation.getNumber(properties.Sid) : void 0), ret.addPropertyResult("timezone", "Timezone", properties.Timezone != null ? cfn_parse.FromCloudFormation.getString(properties.Timezone) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_NielsenWatermarksSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("nielsenCbetSettings", CfnChannel_NielsenCBETPropertyValidator)(properties.nielsenCbetSettings)), errors.collect(cdk.propertyValidator("nielsenDistributionType", cdk.validateString)(properties.nielsenDistributionType)), errors.collect(cdk.propertyValidator("nielsenNaesIiNwSettings", CfnChannel_NielsenNaesIiNwPropertyValidator)(properties.nielsenNaesIiNwSettings)), errors.wrap('supplied properties not correct for "NielsenWatermarksSettingsProperty"');
    }
    function cfnChannelNielsenWatermarksSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_NielsenWatermarksSettingsPropertyValidator(properties).assertSuccess(), { NielsenCbetSettings: cfnChannelNielsenCBETPropertyToCloudFormation(properties.nielsenCbetSettings), NielsenDistributionType: cdk.stringToCloudFormation(properties.nielsenDistributionType), NielsenNaesIiNwSettings: cfnChannelNielsenNaesIiNwPropertyToCloudFormation(properties.nielsenNaesIiNwSettings) }) : properties;
    }
    function CfnChannelNielsenWatermarksSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("nielsenCbetSettings", "NielsenCbetSettings", properties.NielsenCbetSettings != null ? CfnChannelNielsenCBETPropertyFromCloudFormation(properties.NielsenCbetSettings) : void 0), ret.addPropertyResult("nielsenDistributionType", "NielsenDistributionType", properties.NielsenDistributionType != null ? cfn_parse.FromCloudFormation.getString(properties.NielsenDistributionType) : void 0), ret.addPropertyResult("nielsenNaesIiNwSettings", "NielsenNaesIiNwSettings", properties.NielsenNaesIiNwSettings != null ? CfnChannelNielsenNaesIiNwPropertyFromCloudFormation(properties.NielsenNaesIiNwSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_OutputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("audioDescriptionNames", cdk.listValidator(cdk.validateString))(properties.audioDescriptionNames)), errors.collect(cdk.propertyValidator("captionDescriptionNames", cdk.listValidator(cdk.validateString))(properties.captionDescriptionNames)), errors.collect(cdk.propertyValidator("outputName", cdk.validateString)(properties.outputName)), errors.collect(cdk.propertyValidator("outputSettings", CfnChannel_OutputSettingsPropertyValidator)(properties.outputSettings)), errors.collect(cdk.propertyValidator("videoDescriptionName", cdk.validateString)(properties.videoDescriptionName)), errors.wrap('supplied properties not correct for "OutputProperty"');
    }
    function cfnChannelOutputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_OutputPropertyValidator(properties).assertSuccess(), { AudioDescriptionNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.audioDescriptionNames), CaptionDescriptionNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.captionDescriptionNames), OutputName: cdk.stringToCloudFormation(properties.outputName), OutputSettings: cfnChannelOutputSettingsPropertyToCloudFormation(properties.outputSettings), VideoDescriptionName: cdk.stringToCloudFormation(properties.videoDescriptionName) }) : properties;
    }
    function CfnChannelOutputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("audioDescriptionNames", "AudioDescriptionNames", properties.AudioDescriptionNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AudioDescriptionNames) : void 0), ret.addPropertyResult("captionDescriptionNames", "CaptionDescriptionNames", properties.CaptionDescriptionNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CaptionDescriptionNames) : void 0), ret.addPropertyResult("outputName", "OutputName", properties.OutputName != null ? cfn_parse.FromCloudFormation.getString(properties.OutputName) : void 0), ret.addPropertyResult("outputSettings", "OutputSettings", properties.OutputSettings != null ? CfnChannelOutputSettingsPropertyFromCloudFormation(properties.OutputSettings) : void 0), ret.addPropertyResult("videoDescriptionName", "VideoDescriptionName", properties.VideoDescriptionName != null ? cfn_parse.FromCloudFormation.getString(properties.VideoDescriptionName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_OutputDestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("mediaPackageSettings", cdk.listValidator(CfnChannel_MediaPackageOutputDestinationSettingsPropertyValidator))(properties.mediaPackageSettings)), errors.collect(cdk.propertyValidator("multiplexSettings", CfnChannel_MultiplexProgramChannelDestinationSettingsPropertyValidator)(properties.multiplexSettings)), errors.collect(cdk.propertyValidator("settings", cdk.listValidator(CfnChannel_OutputDestinationSettingsPropertyValidator))(properties.settings)), errors.wrap('supplied properties not correct for "OutputDestinationProperty"');
    }
    function cfnChannelOutputDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_OutputDestinationPropertyValidator(properties).assertSuccess(), { Id: cdk.stringToCloudFormation(properties.id), MediaPackageSettings: cdk.listMapper(cfnChannelMediaPackageOutputDestinationSettingsPropertyToCloudFormation)(properties.mediaPackageSettings), MultiplexSettings: cfnChannelMultiplexProgramChannelDestinationSettingsPropertyToCloudFormation(properties.multiplexSettings), Settings: cdk.listMapper(cfnChannelOutputDestinationSettingsPropertyToCloudFormation)(properties.settings) }) : properties;
    }
    function CfnChannelOutputDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("id", "Id", properties.Id != null ? cfn_parse.FromCloudFormation.getString(properties.Id) : void 0), ret.addPropertyResult("mediaPackageSettings", "MediaPackageSettings", properties.MediaPackageSettings != null ? cfn_parse.FromCloudFormation.getArray(CfnChannelMediaPackageOutputDestinationSettingsPropertyFromCloudFormation)(properties.MediaPackageSettings) : void 0), ret.addPropertyResult("multiplexSettings", "MultiplexSettings", properties.MultiplexSettings != null ? CfnChannelMultiplexProgramChannelDestinationSettingsPropertyFromCloudFormation(properties.MultiplexSettings) : void 0), ret.addPropertyResult("settings", "Settings", properties.Settings != null ? cfn_parse.FromCloudFormation.getArray(CfnChannelOutputDestinationSettingsPropertyFromCloudFormation)(properties.Settings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_OutputDestinationSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("passwordParam", cdk.validateString)(properties.passwordParam)), errors.collect(cdk.propertyValidator("streamName", cdk.validateString)(properties.streamName)), errors.collect(cdk.propertyValidator("url", cdk.validateString)(properties.url)), errors.collect(cdk.propertyValidator("username", cdk.validateString)(properties.username)), errors.wrap('supplied properties not correct for "OutputDestinationSettingsProperty"');
    }
    function cfnChannelOutputDestinationSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_OutputDestinationSettingsPropertyValidator(properties).assertSuccess(), { PasswordParam: cdk.stringToCloudFormation(properties.passwordParam), StreamName: cdk.stringToCloudFormation(properties.streamName), Url: cdk.stringToCloudFormation(properties.url), Username: cdk.stringToCloudFormation(properties.username) }) : properties;
    }
    function CfnChannelOutputDestinationSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("passwordParam", "PasswordParam", properties.PasswordParam != null ? cfn_parse.FromCloudFormation.getString(properties.PasswordParam) : void 0), ret.addPropertyResult("streamName", "StreamName", properties.StreamName != null ? cfn_parse.FromCloudFormation.getString(properties.StreamName) : void 0), ret.addPropertyResult("url", "Url", properties.Url != null ? cfn_parse.FromCloudFormation.getString(properties.Url) : void 0), ret.addPropertyResult("username", "Username", properties.Username != null ? cfn_parse.FromCloudFormation.getString(properties.Username) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_OutputGroupPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("outputGroupSettings", CfnChannel_OutputGroupSettingsPropertyValidator)(properties.outputGroupSettings)), errors.collect(cdk.propertyValidator("outputs", cdk.listValidator(CfnChannel_OutputPropertyValidator))(properties.outputs)), errors.wrap('supplied properties not correct for "OutputGroupProperty"');
    }
    function cfnChannelOutputGroupPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_OutputGroupPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), OutputGroupSettings: cfnChannelOutputGroupSettingsPropertyToCloudFormation(properties.outputGroupSettings), Outputs: cdk.listMapper(cfnChannelOutputPropertyToCloudFormation)(properties.outputs) }) : properties;
    }
    function CfnChannelOutputGroupPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("outputGroupSettings", "OutputGroupSettings", properties.OutputGroupSettings != null ? CfnChannelOutputGroupSettingsPropertyFromCloudFormation(properties.OutputGroupSettings) : void 0), ret.addPropertyResult("outputs", "Outputs", properties.Outputs != null ? cfn_parse.FromCloudFormation.getArray(CfnChannelOutputPropertyFromCloudFormation)(properties.Outputs) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_OutputGroupSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("archiveGroupSettings", CfnChannel_ArchiveGroupSettingsPropertyValidator)(properties.archiveGroupSettings)), errors.collect(cdk.propertyValidator("frameCaptureGroupSettings", CfnChannel_FrameCaptureGroupSettingsPropertyValidator)(properties.frameCaptureGroupSettings)), errors.collect(cdk.propertyValidator("hlsGroupSettings", CfnChannel_HlsGroupSettingsPropertyValidator)(properties.hlsGroupSettings)), errors.collect(cdk.propertyValidator("mediaPackageGroupSettings", CfnChannel_MediaPackageGroupSettingsPropertyValidator)(properties.mediaPackageGroupSettings)), errors.collect(cdk.propertyValidator("msSmoothGroupSettings", CfnChannel_MsSmoothGroupSettingsPropertyValidator)(properties.msSmoothGroupSettings)), errors.collect(cdk.propertyValidator("multiplexGroupSettings", CfnChannel_MultiplexGroupSettingsPropertyValidator)(properties.multiplexGroupSettings)), errors.collect(cdk.propertyValidator("rtmpGroupSettings", CfnChannel_RtmpGroupSettingsPropertyValidator)(properties.rtmpGroupSettings)), errors.collect(cdk.propertyValidator("udpGroupSettings", CfnChannel_UdpGroupSettingsPropertyValidator)(properties.udpGroupSettings)), errors.wrap('supplied properties not correct for "OutputGroupSettingsProperty"');
    }
    function cfnChannelOutputGroupSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_OutputGroupSettingsPropertyValidator(properties).assertSuccess(), { ArchiveGroupSettings: cfnChannelArchiveGroupSettingsPropertyToCloudFormation(properties.archiveGroupSettings), FrameCaptureGroupSettings: cfnChannelFrameCaptureGroupSettingsPropertyToCloudFormation(properties.frameCaptureGroupSettings), HlsGroupSettings: cfnChannelHlsGroupSettingsPropertyToCloudFormation(properties.hlsGroupSettings), MediaPackageGroupSettings: cfnChannelMediaPackageGroupSettingsPropertyToCloudFormation(properties.mediaPackageGroupSettings), MsSmoothGroupSettings: cfnChannelMsSmoothGroupSettingsPropertyToCloudFormation(properties.msSmoothGroupSettings), MultiplexGroupSettings: cfnChannelMultiplexGroupSettingsPropertyToCloudFormation(properties.multiplexGroupSettings), RtmpGroupSettings: cfnChannelRtmpGroupSettingsPropertyToCloudFormation(properties.rtmpGroupSettings), UdpGroupSettings: cfnChannelUdpGroupSettingsPropertyToCloudFormation(properties.udpGroupSettings) }) : properties;
    }
    function CfnChannelOutputGroupSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("archiveGroupSettings", "ArchiveGroupSettings", properties.ArchiveGroupSettings != null ? CfnChannelArchiveGroupSettingsPropertyFromCloudFormation(properties.ArchiveGroupSettings) : void 0), ret.addPropertyResult("frameCaptureGroupSettings", "FrameCaptureGroupSettings", properties.FrameCaptureGroupSettings != null ? CfnChannelFrameCaptureGroupSettingsPropertyFromCloudFormation(properties.FrameCaptureGroupSettings) : void 0), ret.addPropertyResult("hlsGroupSettings", "HlsGroupSettings", properties.HlsGroupSettings != null ? CfnChannelHlsGroupSettingsPropertyFromCloudFormation(properties.HlsGroupSettings) : void 0), ret.addPropertyResult("mediaPackageGroupSettings", "MediaPackageGroupSettings", properties.MediaPackageGroupSettings != null ? CfnChannelMediaPackageGroupSettingsPropertyFromCloudFormation(properties.MediaPackageGroupSettings) : void 0), ret.addPropertyResult("msSmoothGroupSettings", "MsSmoothGroupSettings", properties.MsSmoothGroupSettings != null ? CfnChannelMsSmoothGroupSettingsPropertyFromCloudFormation(properties.MsSmoothGroupSettings) : void 0), ret.addPropertyResult("multiplexGroupSettings", "MultiplexGroupSettings", properties.MultiplexGroupSettings != null ? CfnChannelMultiplexGroupSettingsPropertyFromCloudFormation(properties.MultiplexGroupSettings) : void 0), ret.addPropertyResult("rtmpGroupSettings", "RtmpGroupSettings", properties.RtmpGroupSettings != null ? CfnChannelRtmpGroupSettingsPropertyFromCloudFormation(properties.RtmpGroupSettings) : void 0), ret.addPropertyResult("udpGroupSettings", "UdpGroupSettings", properties.UdpGroupSettings != null ? CfnChannelUdpGroupSettingsPropertyFromCloudFormation(properties.UdpGroupSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_OutputLocationRefPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationRefId", cdk.validateString)(properties.destinationRefId)), errors.wrap('supplied properties not correct for "OutputLocationRefProperty"');
    }
    function cfnChannelOutputLocationRefPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_OutputLocationRefPropertyValidator(properties).assertSuccess(), { DestinationRefId: cdk.stringToCloudFormation(properties.destinationRefId) }) : properties;
    }
    function CfnChannelOutputLocationRefPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationRefId", "DestinationRefId", properties.DestinationRefId != null ? cfn_parse.FromCloudFormation.getString(properties.DestinationRefId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_OutputSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("archiveOutputSettings", CfnChannel_ArchiveOutputSettingsPropertyValidator)(properties.archiveOutputSettings)), errors.collect(cdk.propertyValidator("frameCaptureOutputSettings", CfnChannel_FrameCaptureOutputSettingsPropertyValidator)(properties.frameCaptureOutputSettings)), errors.collect(cdk.propertyValidator("hlsOutputSettings", CfnChannel_HlsOutputSettingsPropertyValidator)(properties.hlsOutputSettings)), errors.collect(cdk.propertyValidator("mediaPackageOutputSettings", CfnChannel_MediaPackageOutputSettingsPropertyValidator)(properties.mediaPackageOutputSettings)), errors.collect(cdk.propertyValidator("msSmoothOutputSettings", CfnChannel_MsSmoothOutputSettingsPropertyValidator)(properties.msSmoothOutputSettings)), errors.collect(cdk.propertyValidator("multiplexOutputSettings", CfnChannel_MultiplexOutputSettingsPropertyValidator)(properties.multiplexOutputSettings)), errors.collect(cdk.propertyValidator("rtmpOutputSettings", CfnChannel_RtmpOutputSettingsPropertyValidator)(properties.rtmpOutputSettings)), errors.collect(cdk.propertyValidator("udpOutputSettings", CfnChannel_UdpOutputSettingsPropertyValidator)(properties.udpOutputSettings)), errors.wrap('supplied properties not correct for "OutputSettingsProperty"');
    }
    function cfnChannelOutputSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_OutputSettingsPropertyValidator(properties).assertSuccess(), { ArchiveOutputSettings: cfnChannelArchiveOutputSettingsPropertyToCloudFormation(properties.archiveOutputSettings), FrameCaptureOutputSettings: cfnChannelFrameCaptureOutputSettingsPropertyToCloudFormation(properties.frameCaptureOutputSettings), HlsOutputSettings: cfnChannelHlsOutputSettingsPropertyToCloudFormation(properties.hlsOutputSettings), MediaPackageOutputSettings: cfnChannelMediaPackageOutputSettingsPropertyToCloudFormation(properties.mediaPackageOutputSettings), MsSmoothOutputSettings: cfnChannelMsSmoothOutputSettingsPropertyToCloudFormation(properties.msSmoothOutputSettings), MultiplexOutputSettings: cfnChannelMultiplexOutputSettingsPropertyToCloudFormation(properties.multiplexOutputSettings), RtmpOutputSettings: cfnChannelRtmpOutputSettingsPropertyToCloudFormation(properties.rtmpOutputSettings), UdpOutputSettings: cfnChannelUdpOutputSettingsPropertyToCloudFormation(properties.udpOutputSettings) }) : properties;
    }
    function CfnChannelOutputSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("archiveOutputSettings", "ArchiveOutputSettings", properties.ArchiveOutputSettings != null ? CfnChannelArchiveOutputSettingsPropertyFromCloudFormation(properties.ArchiveOutputSettings) : void 0), ret.addPropertyResult("frameCaptureOutputSettings", "FrameCaptureOutputSettings", properties.FrameCaptureOutputSettings != null ? CfnChannelFrameCaptureOutputSettingsPropertyFromCloudFormation(properties.FrameCaptureOutputSettings) : void 0), ret.addPropertyResult("hlsOutputSettings", "HlsOutputSettings", properties.HlsOutputSettings != null ? CfnChannelHlsOutputSettingsPropertyFromCloudFormation(properties.HlsOutputSettings) : void 0), ret.addPropertyResult("mediaPackageOutputSettings", "MediaPackageOutputSettings", properties.MediaPackageOutputSettings != null ? CfnChannelMediaPackageOutputSettingsPropertyFromCloudFormation(properties.MediaPackageOutputSettings) : void 0), ret.addPropertyResult("msSmoothOutputSettings", "MsSmoothOutputSettings", properties.MsSmoothOutputSettings != null ? CfnChannelMsSmoothOutputSettingsPropertyFromCloudFormation(properties.MsSmoothOutputSettings) : void 0), ret.addPropertyResult("multiplexOutputSettings", "MultiplexOutputSettings", properties.MultiplexOutputSettings != null ? CfnChannelMultiplexOutputSettingsPropertyFromCloudFormation(properties.MultiplexOutputSettings) : void 0), ret.addPropertyResult("rtmpOutputSettings", "RtmpOutputSettings", properties.RtmpOutputSettings != null ? CfnChannelRtmpOutputSettingsPropertyFromCloudFormation(properties.RtmpOutputSettings) : void 0), ret.addPropertyResult("udpOutputSettings", "UdpOutputSettings", properties.UdpOutputSettings != null ? CfnChannelUdpOutputSettingsPropertyFromCloudFormation(properties.UdpOutputSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_PassThroughSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.wrap('supplied properties not correct for "PassThroughSettingsProperty"');
    }
    function cfnChannelPassThroughSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_PassThroughSettingsPropertyValidator(properties).assertSuccess(), {}) : properties;
    }
    function CfnChannelPassThroughSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_RawSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.wrap('supplied properties not correct for "RawSettingsProperty"');
    }
    function cfnChannelRawSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_RawSettingsPropertyValidator(properties).assertSuccess(), {}) : properties;
    }
    function CfnChannelRawSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_Rec601SettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.wrap('supplied properties not correct for "Rec601SettingsProperty"');
    }
    function cfnChannelRec601SettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_Rec601SettingsPropertyValidator(properties).assertSuccess(), {}) : properties;
    }
    function CfnChannelRec601SettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_Rec709SettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.wrap('supplied properties not correct for "Rec709SettingsProperty"');
    }
    function cfnChannelRec709SettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_Rec709SettingsPropertyValidator(properties).assertSuccess(), {}) : properties;
    }
    function CfnChannelRec709SettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_RemixSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("channelMappings", cdk.listValidator(CfnChannel_AudioChannelMappingPropertyValidator))(properties.channelMappings)), errors.collect(cdk.propertyValidator("channelsIn", cdk.validateNumber)(properties.channelsIn)), errors.collect(cdk.propertyValidator("channelsOut", cdk.validateNumber)(properties.channelsOut)), errors.wrap('supplied properties not correct for "RemixSettingsProperty"');
    }
    function cfnChannelRemixSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_RemixSettingsPropertyValidator(properties).assertSuccess(), { ChannelMappings: cdk.listMapper(cfnChannelAudioChannelMappingPropertyToCloudFormation)(properties.channelMappings), ChannelsIn: cdk.numberToCloudFormation(properties.channelsIn), ChannelsOut: cdk.numberToCloudFormation(properties.channelsOut) }) : properties;
    }
    function CfnChannelRemixSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("channelMappings", "ChannelMappings", properties.ChannelMappings != null ? cfn_parse.FromCloudFormation.getArray(CfnChannelAudioChannelMappingPropertyFromCloudFormation)(properties.ChannelMappings) : void 0), ret.addPropertyResult("channelsIn", "ChannelsIn", properties.ChannelsIn != null ? cfn_parse.FromCloudFormation.getNumber(properties.ChannelsIn) : void 0), ret.addPropertyResult("channelsOut", "ChannelsOut", properties.ChannelsOut != null ? cfn_parse.FromCloudFormation.getNumber(properties.ChannelsOut) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_RtmpCaptionInfoDestinationSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.wrap('supplied properties not correct for "RtmpCaptionInfoDestinationSettingsProperty"');
    }
    function cfnChannelRtmpCaptionInfoDestinationSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_RtmpCaptionInfoDestinationSettingsPropertyValidator(properties).assertSuccess(), {}) : properties;
    }
    function CfnChannelRtmpCaptionInfoDestinationSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_RtmpGroupSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("adMarkers", cdk.listValidator(cdk.validateString))(properties.adMarkers)), errors.collect(cdk.propertyValidator("authenticationScheme", cdk.validateString)(properties.authenticationScheme)), errors.collect(cdk.propertyValidator("cacheFullBehavior", cdk.validateString)(properties.cacheFullBehavior)), errors.collect(cdk.propertyValidator("cacheLength", cdk.validateNumber)(properties.cacheLength)), errors.collect(cdk.propertyValidator("captionData", cdk.validateString)(properties.captionData)), errors.collect(cdk.propertyValidator("inputLossAction", cdk.validateString)(properties.inputLossAction)), errors.collect(cdk.propertyValidator("restartDelay", cdk.validateNumber)(properties.restartDelay)), errors.wrap('supplied properties not correct for "RtmpGroupSettingsProperty"');
    }
    function cfnChannelRtmpGroupSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_RtmpGroupSettingsPropertyValidator(properties).assertSuccess(), { AdMarkers: cdk.listMapper(cdk.stringToCloudFormation)(properties.adMarkers), AuthenticationScheme: cdk.stringToCloudFormation(properties.authenticationScheme), CacheFullBehavior: cdk.stringToCloudFormation(properties.cacheFullBehavior), CacheLength: cdk.numberToCloudFormation(properties.cacheLength), CaptionData: cdk.stringToCloudFormation(properties.captionData), InputLossAction: cdk.stringToCloudFormation(properties.inputLossAction), RestartDelay: cdk.numberToCloudFormation(properties.restartDelay) }) : properties;
    }
    function CfnChannelRtmpGroupSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("adMarkers", "AdMarkers", properties.AdMarkers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AdMarkers) : void 0), ret.addPropertyResult("authenticationScheme", "AuthenticationScheme", properties.AuthenticationScheme != null ? cfn_parse.FromCloudFormation.getString(properties.AuthenticationScheme) : void 0), ret.addPropertyResult("cacheFullBehavior", "CacheFullBehavior", properties.CacheFullBehavior != null ? cfn_parse.FromCloudFormation.getString(properties.CacheFullBehavior) : void 0), ret.addPropertyResult("cacheLength", "CacheLength", properties.CacheLength != null ? cfn_parse.FromCloudFormation.getNumber(properties.CacheLength) : void 0), ret.addPropertyResult("captionData", "CaptionData", properties.CaptionData != null ? cfn_parse.FromCloudFormation.getString(properties.CaptionData) : void 0), ret.addPropertyResult("inputLossAction", "InputLossAction", properties.InputLossAction != null ? cfn_parse.FromCloudFormation.getString(properties.InputLossAction) : void 0), ret.addPropertyResult("restartDelay", "RestartDelay", properties.RestartDelay != null ? cfn_parse.FromCloudFormation.getNumber(properties.RestartDelay) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_RtmpOutputSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateMode", cdk.validateString)(properties.certificateMode)), errors.collect(cdk.propertyValidator("connectionRetryInterval", cdk.validateNumber)(properties.connectionRetryInterval)), errors.collect(cdk.propertyValidator("destination", CfnChannel_OutputLocationRefPropertyValidator)(properties.destination)), errors.collect(cdk.propertyValidator("numRetries", cdk.validateNumber)(properties.numRetries)), errors.wrap('supplied properties not correct for "RtmpOutputSettingsProperty"');
    }
    function cfnChannelRtmpOutputSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_RtmpOutputSettingsPropertyValidator(properties).assertSuccess(), { CertificateMode: cdk.stringToCloudFormation(properties.certificateMode), ConnectionRetryInterval: cdk.numberToCloudFormation(properties.connectionRetryInterval), Destination: cfnChannelOutputLocationRefPropertyToCloudFormation(properties.destination), NumRetries: cdk.numberToCloudFormation(properties.numRetries) }) : properties;
    }
    function CfnChannelRtmpOutputSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificateMode", "CertificateMode", properties.CertificateMode != null ? cfn_parse.FromCloudFormation.getString(properties.CertificateMode) : void 0), ret.addPropertyResult("connectionRetryInterval", "ConnectionRetryInterval", properties.ConnectionRetryInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.ConnectionRetryInterval) : void 0), ret.addPropertyResult("destination", "Destination", properties.Destination != null ? CfnChannelOutputLocationRefPropertyFromCloudFormation(properties.Destination) : void 0), ret.addPropertyResult("numRetries", "NumRetries", properties.NumRetries != null ? cfn_parse.FromCloudFormation.getNumber(properties.NumRetries) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_Scte20PlusEmbeddedDestinationSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.wrap('supplied properties not correct for "Scte20PlusEmbeddedDestinationSettingsProperty"');
    }
    function cfnChannelScte20PlusEmbeddedDestinationSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_Scte20PlusEmbeddedDestinationSettingsPropertyValidator(properties).assertSuccess(), {}) : properties;
    }
    function CfnChannelScte20PlusEmbeddedDestinationSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_Scte20SourceSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("convert608To708", cdk.validateString)(properties.convert608To708)), errors.collect(cdk.propertyValidator("source608ChannelNumber", cdk.validateNumber)(properties.source608ChannelNumber)), errors.wrap('supplied properties not correct for "Scte20SourceSettingsProperty"');
    }
    function cfnChannelScte20SourceSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_Scte20SourceSettingsPropertyValidator(properties).assertSuccess(), { Convert608To708: cdk.stringToCloudFormation(properties.convert608To708), Source608ChannelNumber: cdk.numberToCloudFormation(properties.source608ChannelNumber) }) : properties;
    }
    function CfnChannelScte20SourceSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("convert608To708", "Convert608To708", properties.Convert608To708 != null ? cfn_parse.FromCloudFormation.getString(properties.Convert608To708) : void 0), ret.addPropertyResult("source608ChannelNumber", "Source608ChannelNumber", properties.Source608ChannelNumber != null ? cfn_parse.FromCloudFormation.getNumber(properties.Source608ChannelNumber) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_Scte27DestinationSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.wrap('supplied properties not correct for "Scte27DestinationSettingsProperty"');
    }
    function cfnChannelScte27DestinationSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_Scte27DestinationSettingsPropertyValidator(properties).assertSuccess(), {}) : properties;
    }
    function CfnChannelScte27DestinationSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_Scte27SourceSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ocrLanguage", cdk.validateString)(properties.ocrLanguage)), errors.collect(cdk.propertyValidator("pid", cdk.validateNumber)(properties.pid)), errors.wrap('supplied properties not correct for "Scte27SourceSettingsProperty"');
    }
    function cfnChannelScte27SourceSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_Scte27SourceSettingsPropertyValidator(properties).assertSuccess(), { OcrLanguage: cdk.stringToCloudFormation(properties.ocrLanguage), Pid: cdk.numberToCloudFormation(properties.pid) }) : properties;
    }
    function CfnChannelScte27SourceSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ocrLanguage", "OcrLanguage", properties.OcrLanguage != null ? cfn_parse.FromCloudFormation.getString(properties.OcrLanguage) : void 0), ret.addPropertyResult("pid", "Pid", properties.Pid != null ? cfn_parse.FromCloudFormation.getNumber(properties.Pid) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_Scte35SpliceInsertPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("adAvailOffset", cdk.validateNumber)(properties.adAvailOffset)), errors.collect(cdk.propertyValidator("noRegionalBlackoutFlag", cdk.validateString)(properties.noRegionalBlackoutFlag)), errors.collect(cdk.propertyValidator("webDeliveryAllowedFlag", cdk.validateString)(properties.webDeliveryAllowedFlag)), errors.wrap('supplied properties not correct for "Scte35SpliceInsertProperty"');
    }
    function cfnChannelScte35SpliceInsertPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_Scte35SpliceInsertPropertyValidator(properties).assertSuccess(), { AdAvailOffset: cdk.numberToCloudFormation(properties.adAvailOffset), NoRegionalBlackoutFlag: cdk.stringToCloudFormation(properties.noRegionalBlackoutFlag), WebDeliveryAllowedFlag: cdk.stringToCloudFormation(properties.webDeliveryAllowedFlag) }) : properties;
    }
    function CfnChannelScte35SpliceInsertPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("adAvailOffset", "AdAvailOffset", properties.AdAvailOffset != null ? cfn_parse.FromCloudFormation.getNumber(properties.AdAvailOffset) : void 0), ret.addPropertyResult("noRegionalBlackoutFlag", "NoRegionalBlackoutFlag", properties.NoRegionalBlackoutFlag != null ? cfn_parse.FromCloudFormation.getString(properties.NoRegionalBlackoutFlag) : void 0), ret.addPropertyResult("webDeliveryAllowedFlag", "WebDeliveryAllowedFlag", properties.WebDeliveryAllowedFlag != null ? cfn_parse.FromCloudFormation.getString(properties.WebDeliveryAllowedFlag) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_Scte35TimeSignalAposPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("adAvailOffset", cdk.validateNumber)(properties.adAvailOffset)), errors.collect(cdk.propertyValidator("noRegionalBlackoutFlag", cdk.validateString)(properties.noRegionalBlackoutFlag)), errors.collect(cdk.propertyValidator("webDeliveryAllowedFlag", cdk.validateString)(properties.webDeliveryAllowedFlag)), errors.wrap('supplied properties not correct for "Scte35TimeSignalAposProperty"');
    }
    function cfnChannelScte35TimeSignalAposPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_Scte35TimeSignalAposPropertyValidator(properties).assertSuccess(), { AdAvailOffset: cdk.numberToCloudFormation(properties.adAvailOffset), NoRegionalBlackoutFlag: cdk.stringToCloudFormation(properties.noRegionalBlackoutFlag), WebDeliveryAllowedFlag: cdk.stringToCloudFormation(properties.webDeliveryAllowedFlag) }) : properties;
    }
    function CfnChannelScte35TimeSignalAposPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("adAvailOffset", "AdAvailOffset", properties.AdAvailOffset != null ? cfn_parse.FromCloudFormation.getNumber(properties.AdAvailOffset) : void 0), ret.addPropertyResult("noRegionalBlackoutFlag", "NoRegionalBlackoutFlag", properties.NoRegionalBlackoutFlag != null ? cfn_parse.FromCloudFormation.getString(properties.NoRegionalBlackoutFlag) : void 0), ret.addPropertyResult("webDeliveryAllowedFlag", "WebDeliveryAllowedFlag", properties.WebDeliveryAllowedFlag != null ? cfn_parse.FromCloudFormation.getString(properties.WebDeliveryAllowedFlag) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_SmpteTtDestinationSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.wrap('supplied properties not correct for "SmpteTtDestinationSettingsProperty"');
    }
    function cfnChannelSmpteTtDestinationSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_SmpteTtDestinationSettingsPropertyValidator(properties).assertSuccess(), {}) : properties;
    }
    function CfnChannelSmpteTtDestinationSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_StandardHlsSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("audioRenditionSets", cdk.validateString)(properties.audioRenditionSets)), errors.collect(cdk.propertyValidator("m3U8Settings", CfnChannel_M3u8SettingsPropertyValidator)(properties.m3U8Settings)), errors.wrap('supplied properties not correct for "StandardHlsSettingsProperty"');
    }
    function cfnChannelStandardHlsSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_StandardHlsSettingsPropertyValidator(properties).assertSuccess(), { AudioRenditionSets: cdk.stringToCloudFormation(properties.audioRenditionSets), M3u8Settings: cfnChannelM3u8SettingsPropertyToCloudFormation(properties.m3U8Settings) }) : properties;
    }
    function CfnChannelStandardHlsSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("audioRenditionSets", "AudioRenditionSets", properties.AudioRenditionSets != null ? cfn_parse.FromCloudFormation.getString(properties.AudioRenditionSets) : void 0), ret.addPropertyResult("m3U8Settings", "M3u8Settings", properties.M3u8Settings != null ? CfnChannelM3u8SettingsPropertyFromCloudFormation(properties.M3u8Settings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_StaticKeySettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("keyProviderServer", CfnChannel_InputLocationPropertyValidator)(properties.keyProviderServer)), errors.collect(cdk.propertyValidator("staticKeyValue", cdk.validateString)(properties.staticKeyValue)), errors.wrap('supplied properties not correct for "StaticKeySettingsProperty"');
    }
    function cfnChannelStaticKeySettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_StaticKeySettingsPropertyValidator(properties).assertSuccess(), { KeyProviderServer: cfnChannelInputLocationPropertyToCloudFormation(properties.keyProviderServer), StaticKeyValue: cdk.stringToCloudFormation(properties.staticKeyValue) }) : properties;
    }
    function CfnChannelStaticKeySettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("keyProviderServer", "KeyProviderServer", properties.KeyProviderServer != null ? CfnChannelInputLocationPropertyFromCloudFormation(properties.KeyProviderServer) : void 0), ret.addPropertyResult("staticKeyValue", "StaticKeyValue", properties.StaticKeyValue != null ? cfn_parse.FromCloudFormation.getString(properties.StaticKeyValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_TeletextDestinationSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.wrap('supplied properties not correct for "TeletextDestinationSettingsProperty"');
    }
    function cfnChannelTeletextDestinationSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_TeletextDestinationSettingsPropertyValidator(properties).assertSuccess(), {}) : properties;
    }
    function CfnChannelTeletextDestinationSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_TeletextSourceSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("outputRectangle", CfnChannel_CaptionRectanglePropertyValidator)(properties.outputRectangle)), errors.collect(cdk.propertyValidator("pageNumber", cdk.validateString)(properties.pageNumber)), errors.wrap('supplied properties not correct for "TeletextSourceSettingsProperty"');
    }
    function cfnChannelTeletextSourceSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_TeletextSourceSettingsPropertyValidator(properties).assertSuccess(), { OutputRectangle: cfnChannelCaptionRectanglePropertyToCloudFormation(properties.outputRectangle), PageNumber: cdk.stringToCloudFormation(properties.pageNumber) }) : properties;
    }
    function CfnChannelTeletextSourceSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("outputRectangle", "OutputRectangle", properties.OutputRectangle != null ? CfnChannelCaptionRectanglePropertyFromCloudFormation(properties.OutputRectangle) : void 0), ret.addPropertyResult("pageNumber", "PageNumber", properties.PageNumber != null ? cfn_parse.FromCloudFormation.getString(properties.PageNumber) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_TemporalFilterSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("postFilterSharpening", cdk.validateString)(properties.postFilterSharpening)), errors.collect(cdk.propertyValidator("strength", cdk.validateString)(properties.strength)), errors.wrap('supplied properties not correct for "TemporalFilterSettingsProperty"');
    }
    function cfnChannelTemporalFilterSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_TemporalFilterSettingsPropertyValidator(properties).assertSuccess(), { PostFilterSharpening: cdk.stringToCloudFormation(properties.postFilterSharpening), Strength: cdk.stringToCloudFormation(properties.strength) }) : properties;
    }
    function CfnChannelTemporalFilterSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("postFilterSharpening", "PostFilterSharpening", properties.PostFilterSharpening != null ? cfn_parse.FromCloudFormation.getString(properties.PostFilterSharpening) : void 0), ret.addPropertyResult("strength", "Strength", properties.Strength != null ? cfn_parse.FromCloudFormation.getString(properties.Strength) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_TimecodeBurninSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fontSize", cdk.validateString)(properties.fontSize)), errors.collect(cdk.propertyValidator("position", cdk.validateString)(properties.position)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.wrap('supplied properties not correct for "TimecodeBurninSettingsProperty"');
    }
    function cfnChannelTimecodeBurninSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_TimecodeBurninSettingsPropertyValidator(properties).assertSuccess(), { FontSize: cdk.stringToCloudFormation(properties.fontSize), Position: cdk.stringToCloudFormation(properties.position), Prefix: cdk.stringToCloudFormation(properties.prefix) }) : properties;
    }
    function CfnChannelTimecodeBurninSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fontSize", "FontSize", properties.FontSize != null ? cfn_parse.FromCloudFormation.getString(properties.FontSize) : void 0), ret.addPropertyResult("position", "Position", properties.Position != null ? cfn_parse.FromCloudFormation.getString(properties.Position) : void 0), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_TimecodeConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("source", cdk.validateString)(properties.source)), errors.collect(cdk.propertyValidator("syncThreshold", cdk.validateNumber)(properties.syncThreshold)), errors.wrap('supplied properties not correct for "TimecodeConfigProperty"');
    }
    function cfnChannelTimecodeConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_TimecodeConfigPropertyValidator(properties).assertSuccess(), { Source: cdk.stringToCloudFormation(properties.source), SyncThreshold: cdk.numberToCloudFormation(properties.syncThreshold) }) : properties;
    }
    function CfnChannelTimecodeConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("source", "Source", properties.Source != null ? cfn_parse.FromCloudFormation.getString(properties.Source) : void 0), ret.addPropertyResult("syncThreshold", "SyncThreshold", properties.SyncThreshold != null ? cfn_parse.FromCloudFormation.getNumber(properties.SyncThreshold) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_TtmlDestinationSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("styleControl", cdk.validateString)(properties.styleControl)), errors.wrap('supplied properties not correct for "TtmlDestinationSettingsProperty"');
    }
    function cfnChannelTtmlDestinationSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_TtmlDestinationSettingsPropertyValidator(properties).assertSuccess(), { StyleControl: cdk.stringToCloudFormation(properties.styleControl) }) : properties;
    }
    function CfnChannelTtmlDestinationSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("styleControl", "StyleControl", properties.StyleControl != null ? cfn_parse.FromCloudFormation.getString(properties.StyleControl) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_UdpContainerSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("m2TsSettings", CfnChannel_M2tsSettingsPropertyValidator)(properties.m2TsSettings)), errors.wrap('supplied properties not correct for "UdpContainerSettingsProperty"');
    }
    function cfnChannelUdpContainerSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_UdpContainerSettingsPropertyValidator(properties).assertSuccess(), { M2tsSettings: cfnChannelM2tsSettingsPropertyToCloudFormation(properties.m2TsSettings) }) : properties;
    }
    function CfnChannelUdpContainerSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("m2TsSettings", "M2tsSettings", properties.M2tsSettings != null ? CfnChannelM2tsSettingsPropertyFromCloudFormation(properties.M2tsSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_UdpGroupSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("inputLossAction", cdk.validateString)(properties.inputLossAction)), errors.collect(cdk.propertyValidator("timedMetadataId3Frame", cdk.validateString)(properties.timedMetadataId3Frame)), errors.collect(cdk.propertyValidator("timedMetadataId3Period", cdk.validateNumber)(properties.timedMetadataId3Period)), errors.wrap('supplied properties not correct for "UdpGroupSettingsProperty"');
    }
    function cfnChannelUdpGroupSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_UdpGroupSettingsPropertyValidator(properties).assertSuccess(), { InputLossAction: cdk.stringToCloudFormation(properties.inputLossAction), TimedMetadataId3Frame: cdk.stringToCloudFormation(properties.timedMetadataId3Frame), TimedMetadataId3Period: cdk.numberToCloudFormation(properties.timedMetadataId3Period) }) : properties;
    }
    function CfnChannelUdpGroupSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("inputLossAction", "InputLossAction", properties.InputLossAction != null ? cfn_parse.FromCloudFormation.getString(properties.InputLossAction) : void 0), ret.addPropertyResult("timedMetadataId3Frame", "TimedMetadataId3Frame", properties.TimedMetadataId3Frame != null ? cfn_parse.FromCloudFormation.getString(properties.TimedMetadataId3Frame) : void 0), ret.addPropertyResult("timedMetadataId3Period", "TimedMetadataId3Period", properties.TimedMetadataId3Period != null ? cfn_parse.FromCloudFormation.getNumber(properties.TimedMetadataId3Period) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_UdpOutputSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bufferMsec", cdk.validateNumber)(properties.bufferMsec)), errors.collect(cdk.propertyValidator("containerSettings", CfnChannel_UdpContainerSettingsPropertyValidator)(properties.containerSettings)), errors.collect(cdk.propertyValidator("destination", CfnChannel_OutputLocationRefPropertyValidator)(properties.destination)), errors.collect(cdk.propertyValidator("fecOutputSettings", CfnChannel_FecOutputSettingsPropertyValidator)(properties.fecOutputSettings)), errors.wrap('supplied properties not correct for "UdpOutputSettingsProperty"');
    }
    function cfnChannelUdpOutputSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_UdpOutputSettingsPropertyValidator(properties).assertSuccess(), { BufferMsec: cdk.numberToCloudFormation(properties.bufferMsec), ContainerSettings: cfnChannelUdpContainerSettingsPropertyToCloudFormation(properties.containerSettings), Destination: cfnChannelOutputLocationRefPropertyToCloudFormation(properties.destination), FecOutputSettings: cfnChannelFecOutputSettingsPropertyToCloudFormation(properties.fecOutputSettings) }) : properties;
    }
    function CfnChannelUdpOutputSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bufferMsec", "BufferMsec", properties.BufferMsec != null ? cfn_parse.FromCloudFormation.getNumber(properties.BufferMsec) : void 0), ret.addPropertyResult("containerSettings", "ContainerSettings", properties.ContainerSettings != null ? CfnChannelUdpContainerSettingsPropertyFromCloudFormation(properties.ContainerSettings) : void 0), ret.addPropertyResult("destination", "Destination", properties.Destination != null ? CfnChannelOutputLocationRefPropertyFromCloudFormation(properties.Destination) : void 0), ret.addPropertyResult("fecOutputSettings", "FecOutputSettings", properties.FecOutputSettings != null ? CfnChannelFecOutputSettingsPropertyFromCloudFormation(properties.FecOutputSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_VideoBlackFailoverSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("blackDetectThreshold", cdk.validateNumber)(properties.blackDetectThreshold)), errors.collect(cdk.propertyValidator("videoBlackThresholdMsec", cdk.validateNumber)(properties.videoBlackThresholdMsec)), errors.wrap('supplied properties not correct for "VideoBlackFailoverSettingsProperty"');
    }
    function cfnChannelVideoBlackFailoverSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_VideoBlackFailoverSettingsPropertyValidator(properties).assertSuccess(), { BlackDetectThreshold: cdk.numberToCloudFormation(properties.blackDetectThreshold), VideoBlackThresholdMsec: cdk.numberToCloudFormation(properties.videoBlackThresholdMsec) }) : properties;
    }
    function CfnChannelVideoBlackFailoverSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("blackDetectThreshold", "BlackDetectThreshold", properties.BlackDetectThreshold != null ? cfn_parse.FromCloudFormation.getNumber(properties.BlackDetectThreshold) : void 0), ret.addPropertyResult("videoBlackThresholdMsec", "VideoBlackThresholdMsec", properties.VideoBlackThresholdMsec != null ? cfn_parse.FromCloudFormation.getNumber(properties.VideoBlackThresholdMsec) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_VideoCodecSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("frameCaptureSettings", CfnChannel_FrameCaptureSettingsPropertyValidator)(properties.frameCaptureSettings)), errors.collect(cdk.propertyValidator("h264Settings", CfnChannel_H264SettingsPropertyValidator)(properties.h264Settings)), errors.collect(cdk.propertyValidator("h265Settings", CfnChannel_H265SettingsPropertyValidator)(properties.h265Settings)), errors.collect(cdk.propertyValidator("mpeg2Settings", CfnChannel_Mpeg2SettingsPropertyValidator)(properties.mpeg2Settings)), errors.wrap('supplied properties not correct for "VideoCodecSettingsProperty"');
    }
    function cfnChannelVideoCodecSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_VideoCodecSettingsPropertyValidator(properties).assertSuccess(), { FrameCaptureSettings: cfnChannelFrameCaptureSettingsPropertyToCloudFormation(properties.frameCaptureSettings), H264Settings: cfnChannelH264SettingsPropertyToCloudFormation(properties.h264Settings), H265Settings: cfnChannelH265SettingsPropertyToCloudFormation(properties.h265Settings), Mpeg2Settings: cfnChannelMpeg2SettingsPropertyToCloudFormation(properties.mpeg2Settings) }) : properties;
    }
    function CfnChannelVideoCodecSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("frameCaptureSettings", "FrameCaptureSettings", properties.FrameCaptureSettings != null ? CfnChannelFrameCaptureSettingsPropertyFromCloudFormation(properties.FrameCaptureSettings) : void 0), ret.addPropertyResult("h264Settings", "H264Settings", properties.H264Settings != null ? CfnChannelH264SettingsPropertyFromCloudFormation(properties.H264Settings) : void 0), ret.addPropertyResult("h265Settings", "H265Settings", properties.H265Settings != null ? CfnChannelH265SettingsPropertyFromCloudFormation(properties.H265Settings) : void 0), ret.addPropertyResult("mpeg2Settings", "Mpeg2Settings", properties.Mpeg2Settings != null ? CfnChannelMpeg2SettingsPropertyFromCloudFormation(properties.Mpeg2Settings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_VideoDescriptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("codecSettings", CfnChannel_VideoCodecSettingsPropertyValidator)(properties.codecSettings)), errors.collect(cdk.propertyValidator("height", cdk.validateNumber)(properties.height)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("respondToAfd", cdk.validateString)(properties.respondToAfd)), errors.collect(cdk.propertyValidator("scalingBehavior", cdk.validateString)(properties.scalingBehavior)), errors.collect(cdk.propertyValidator("sharpness", cdk.validateNumber)(properties.sharpness)), errors.collect(cdk.propertyValidator("width", cdk.validateNumber)(properties.width)), errors.wrap('supplied properties not correct for "VideoDescriptionProperty"');
    }
    function cfnChannelVideoDescriptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_VideoDescriptionPropertyValidator(properties).assertSuccess(), { CodecSettings: cfnChannelVideoCodecSettingsPropertyToCloudFormation(properties.codecSettings), Height: cdk.numberToCloudFormation(properties.height), Name: cdk.stringToCloudFormation(properties.name), RespondToAfd: cdk.stringToCloudFormation(properties.respondToAfd), ScalingBehavior: cdk.stringToCloudFormation(properties.scalingBehavior), Sharpness: cdk.numberToCloudFormation(properties.sharpness), Width: cdk.numberToCloudFormation(properties.width) }) : properties;
    }
    function CfnChannelVideoDescriptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("codecSettings", "CodecSettings", properties.CodecSettings != null ? CfnChannelVideoCodecSettingsPropertyFromCloudFormation(properties.CodecSettings) : void 0), ret.addPropertyResult("height", "Height", properties.Height != null ? cfn_parse.FromCloudFormation.getNumber(properties.Height) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("respondToAfd", "RespondToAfd", properties.RespondToAfd != null ? cfn_parse.FromCloudFormation.getString(properties.RespondToAfd) : void 0), ret.addPropertyResult("scalingBehavior", "ScalingBehavior", properties.ScalingBehavior != null ? cfn_parse.FromCloudFormation.getString(properties.ScalingBehavior) : void 0), ret.addPropertyResult("sharpness", "Sharpness", properties.Sharpness != null ? cfn_parse.FromCloudFormation.getNumber(properties.Sharpness) : void 0), ret.addPropertyResult("width", "Width", properties.Width != null ? cfn_parse.FromCloudFormation.getNumber(properties.Width) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_VideoSelectorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("colorSpace", cdk.validateString)(properties.colorSpace)), errors.collect(cdk.propertyValidator("colorSpaceSettings", CfnChannel_VideoSelectorColorSpaceSettingsPropertyValidator)(properties.colorSpaceSettings)), errors.collect(cdk.propertyValidator("colorSpaceUsage", cdk.validateString)(properties.colorSpaceUsage)), errors.collect(cdk.propertyValidator("selectorSettings", CfnChannel_VideoSelectorSettingsPropertyValidator)(properties.selectorSettings)), errors.wrap('supplied properties not correct for "VideoSelectorProperty"');
    }
    function cfnChannelVideoSelectorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_VideoSelectorPropertyValidator(properties).assertSuccess(), { ColorSpace: cdk.stringToCloudFormation(properties.colorSpace), ColorSpaceSettings: cfnChannelVideoSelectorColorSpaceSettingsPropertyToCloudFormation(properties.colorSpaceSettings), ColorSpaceUsage: cdk.stringToCloudFormation(properties.colorSpaceUsage), SelectorSettings: cfnChannelVideoSelectorSettingsPropertyToCloudFormation(properties.selectorSettings) }) : properties;
    }
    function CfnChannelVideoSelectorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("colorSpace", "ColorSpace", properties.ColorSpace != null ? cfn_parse.FromCloudFormation.getString(properties.ColorSpace) : void 0), ret.addPropertyResult("colorSpaceSettings", "ColorSpaceSettings", properties.ColorSpaceSettings != null ? CfnChannelVideoSelectorColorSpaceSettingsPropertyFromCloudFormation(properties.ColorSpaceSettings) : void 0), ret.addPropertyResult("colorSpaceUsage", "ColorSpaceUsage", properties.ColorSpaceUsage != null ? cfn_parse.FromCloudFormation.getString(properties.ColorSpaceUsage) : void 0), ret.addPropertyResult("selectorSettings", "SelectorSettings", properties.SelectorSettings != null ? CfnChannelVideoSelectorSettingsPropertyFromCloudFormation(properties.SelectorSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_VideoSelectorColorSpaceSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("hdr10Settings", CfnChannel_Hdr10SettingsPropertyValidator)(properties.hdr10Settings)), errors.wrap('supplied properties not correct for "VideoSelectorColorSpaceSettingsProperty"');
    }
    function cfnChannelVideoSelectorColorSpaceSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_VideoSelectorColorSpaceSettingsPropertyValidator(properties).assertSuccess(), { Hdr10Settings: cfnChannelHdr10SettingsPropertyToCloudFormation(properties.hdr10Settings) }) : properties;
    }
    function CfnChannelVideoSelectorColorSpaceSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("hdr10Settings", "Hdr10Settings", properties.Hdr10Settings != null ? CfnChannelHdr10SettingsPropertyFromCloudFormation(properties.Hdr10Settings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_VideoSelectorPidPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("pid", cdk.validateNumber)(properties.pid)), errors.wrap('supplied properties not correct for "VideoSelectorPidProperty"');
    }
    function cfnChannelVideoSelectorPidPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_VideoSelectorPidPropertyValidator(properties).assertSuccess(), { Pid: cdk.numberToCloudFormation(properties.pid) }) : properties;
    }
    function CfnChannelVideoSelectorPidPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("pid", "Pid", properties.Pid != null ? cfn_parse.FromCloudFormation.getNumber(properties.Pid) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_VideoSelectorProgramIdPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("programId", cdk.validateNumber)(properties.programId)), errors.wrap('supplied properties not correct for "VideoSelectorProgramIdProperty"');
    }
    function cfnChannelVideoSelectorProgramIdPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_VideoSelectorProgramIdPropertyValidator(properties).assertSuccess(), { ProgramId: cdk.numberToCloudFormation(properties.programId) }) : properties;
    }
    function CfnChannelVideoSelectorProgramIdPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("programId", "ProgramId", properties.ProgramId != null ? cfn_parse.FromCloudFormation.getNumber(properties.ProgramId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_VideoSelectorSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("videoSelectorPid", CfnChannel_VideoSelectorPidPropertyValidator)(properties.videoSelectorPid)), errors.collect(cdk.propertyValidator("videoSelectorProgramId", CfnChannel_VideoSelectorProgramIdPropertyValidator)(properties.videoSelectorProgramId)), errors.wrap('supplied properties not correct for "VideoSelectorSettingsProperty"');
    }
    function cfnChannelVideoSelectorSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_VideoSelectorSettingsPropertyValidator(properties).assertSuccess(), { VideoSelectorPid: cfnChannelVideoSelectorPidPropertyToCloudFormation(properties.videoSelectorPid), VideoSelectorProgramId: cfnChannelVideoSelectorProgramIdPropertyToCloudFormation(properties.videoSelectorProgramId) }) : properties;
    }
    function CfnChannelVideoSelectorSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("videoSelectorPid", "VideoSelectorPid", properties.VideoSelectorPid != null ? CfnChannelVideoSelectorPidPropertyFromCloudFormation(properties.VideoSelectorPid) : void 0), ret.addPropertyResult("videoSelectorProgramId", "VideoSelectorProgramId", properties.VideoSelectorProgramId != null ? CfnChannelVideoSelectorProgramIdPropertyFromCloudFormation(properties.VideoSelectorProgramId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_VpcOutputSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("publicAddressAllocationIds", cdk.listValidator(cdk.validateString))(properties.publicAddressAllocationIds)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.wrap('supplied properties not correct for "VpcOutputSettingsProperty"');
    }
    function cfnChannelVpcOutputSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_VpcOutputSettingsPropertyValidator(properties).assertSuccess(), { PublicAddressAllocationIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.publicAddressAllocationIds), SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds) }) : properties;
    }
    function CfnChannelVpcOutputSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("publicAddressAllocationIds", "PublicAddressAllocationIds", properties.PublicAddressAllocationIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.PublicAddressAllocationIds) : void 0), ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("subnetIds", "SubnetIds", properties.SubnetIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_WavSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bitDepth", cdk.validateNumber)(properties.bitDepth)), errors.collect(cdk.propertyValidator("codingMode", cdk.validateString)(properties.codingMode)), errors.collect(cdk.propertyValidator("sampleRate", cdk.validateNumber)(properties.sampleRate)), errors.wrap('supplied properties not correct for "WavSettingsProperty"');
    }
    function cfnChannelWavSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_WavSettingsPropertyValidator(properties).assertSuccess(), { BitDepth: cdk.numberToCloudFormation(properties.bitDepth), CodingMode: cdk.stringToCloudFormation(properties.codingMode), SampleRate: cdk.numberToCloudFormation(properties.sampleRate) }) : properties;
    }
    function CfnChannelWavSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bitDepth", "BitDepth", properties.BitDepth != null ? cfn_parse.FromCloudFormation.getNumber(properties.BitDepth) : void 0), ret.addPropertyResult("codingMode", "CodingMode", properties.CodingMode != null ? cfn_parse.FromCloudFormation.getString(properties.CodingMode) : void 0), ret.addPropertyResult("sampleRate", "SampleRate", properties.SampleRate != null ? cfn_parse.FromCloudFormation.getNumber(properties.SampleRate) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_WebvttDestinationSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("styleControl", cdk.validateString)(properties.styleControl)), errors.wrap('supplied properties not correct for "WebvttDestinationSettingsProperty"');
    }
    function cfnChannelWebvttDestinationSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_WebvttDestinationSettingsPropertyValidator(properties).assertSuccess(), { StyleControl: cdk.stringToCloudFormation(properties.styleControl) }) : properties;
    }
    function CfnChannelWebvttDestinationSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("styleControl", "StyleControl", properties.StyleControl != null ? cfn_parse.FromCloudFormation.getString(properties.StyleControl) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInputPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinations", cdk.listValidator(CfnInput_InputDestinationRequestPropertyValidator))(properties.destinations)), errors.collect(cdk.propertyValidator("inputDevices", cdk.listValidator(CfnInput_InputDeviceSettingsPropertyValidator))(properties.inputDevices)), errors.collect(cdk.propertyValidator("inputSecurityGroups", cdk.listValidator(cdk.validateString))(properties.inputSecurityGroups)), errors.collect(cdk.propertyValidator("mediaConnectFlows", cdk.listValidator(CfnInput_MediaConnectFlowRequestPropertyValidator))(properties.mediaConnectFlows)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("sources", cdk.listValidator(CfnInput_InputSourceRequestPropertyValidator))(properties.sources)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("vpc", CfnInput_InputVpcRequestPropertyValidator)(properties.vpc)), errors.wrap('supplied properties not correct for "CfnInputProps"');
    }
    function cfnInputPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInputPropsValidator(properties).assertSuccess(), { Destinations: cdk.listMapper(cfnInputInputDestinationRequestPropertyToCloudFormation)(properties.destinations), InputDevices: cdk.listMapper(cfnInputInputDeviceSettingsPropertyToCloudFormation)(properties.inputDevices), InputSecurityGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.inputSecurityGroups), MediaConnectFlows: cdk.listMapper(cfnInputMediaConnectFlowRequestPropertyToCloudFormation)(properties.mediaConnectFlows), Name: cdk.stringToCloudFormation(properties.name), RoleArn: cdk.stringToCloudFormation(properties.roleArn), Sources: cdk.listMapper(cfnInputInputSourceRequestPropertyToCloudFormation)(properties.sources), Tags: cdk.objectToCloudFormation(properties.tags), Type: cdk.stringToCloudFormation(properties.type), Vpc: cfnInputInputVpcRequestPropertyToCloudFormation(properties.vpc) }) : properties;
    }
    function CfnInputPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinations", "Destinations", properties.Destinations != null ? cfn_parse.FromCloudFormation.getArray(CfnInputInputDestinationRequestPropertyFromCloudFormation)(properties.Destinations) : void 0), ret.addPropertyResult("inputDevices", "InputDevices", properties.InputDevices != null ? cfn_parse.FromCloudFormation.getArray(CfnInputInputDeviceSettingsPropertyFromCloudFormation)(properties.InputDevices) : void 0), ret.addPropertyResult("inputSecurityGroups", "InputSecurityGroups", properties.InputSecurityGroups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.InputSecurityGroups) : void 0), ret.addPropertyResult("mediaConnectFlows", "MediaConnectFlows", properties.MediaConnectFlows != null ? cfn_parse.FromCloudFormation.getArray(CfnInputMediaConnectFlowRequestPropertyFromCloudFormation)(properties.MediaConnectFlows) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addPropertyResult("sources", "Sources", properties.Sources != null ? cfn_parse.FromCloudFormation.getArray(CfnInputInputSourceRequestPropertyFromCloudFormation)(properties.Sources) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addPropertyResult("vpc", "Vpc", properties.Vpc != null ? CfnInputInputVpcRequestPropertyFromCloudFormation(properties.Vpc) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnInput = class _CfnInput extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnInputPropsFromCloudFormation(resourceProperties), ret = new _CfnInput(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnInput.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_medialive_CfnInputProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnInput), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrDestinations = cdk.Token.asList(this.getAtt("Destinations", cdk.ResolutionTypeHint.STRING_LIST)), this.attrSources = cdk.Token.asList(this.getAtt("Sources", cdk.ResolutionTypeHint.STRING_LIST)), this.destinations = props.destinations, this.inputDevices = props.inputDevices, this.inputSecurityGroups = props.inputSecurityGroups, this.mediaConnectFlows = props.mediaConnectFlows, this.name = props.name, this.roleArn = props.roleArn, this.sources = props.sources, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::MediaLive::Input", props.tags, { tagPropertyName: "tags" }), this.type = props.type, this.vpc = props.vpc;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnInput.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { destinations: this.destinations, inputDevices: this.inputDevices, inputSecurityGroups: this.inputSecurityGroups, mediaConnectFlows: this.mediaConnectFlows, name: this.name, roleArn: this.roleArn, sources: this.sources, tags: this.tags.renderTags(), type: this.type, vpc: this.vpc };
      }
      renderProperties(props) {
        return cfnInputPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnInput[_b] = { fqn: "aws-cdk-lib.aws_medialive.CfnInput", version: "2.80.0" }, CfnInput.CFN_RESOURCE_TYPE_NAME = "AWS::MediaLive::Input", exports2.CfnInput = CfnInput;
    function CfnInput_InputDestinationRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("streamName", cdk.validateString)(properties.streamName)), errors.wrap('supplied properties not correct for "InputDestinationRequestProperty"');
    }
    function cfnInputInputDestinationRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInput_InputDestinationRequestPropertyValidator(properties).assertSuccess(), { StreamName: cdk.stringToCloudFormation(properties.streamName) }) : properties;
    }
    function CfnInputInputDestinationRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("streamName", "StreamName", properties.StreamName != null ? cfn_parse.FromCloudFormation.getString(properties.StreamName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInput_InputDeviceSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.wrap('supplied properties not correct for "InputDeviceSettingsProperty"');
    }
    function cfnInputInputDeviceSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInput_InputDeviceSettingsPropertyValidator(properties).assertSuccess(), { Id: cdk.stringToCloudFormation(properties.id) }) : properties;
    }
    function CfnInputInputDeviceSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("id", "Id", properties.Id != null ? cfn_parse.FromCloudFormation.getString(properties.Id) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInput_InputSourceRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("passwordParam", cdk.validateString)(properties.passwordParam)), errors.collect(cdk.propertyValidator("url", cdk.validateString)(properties.url)), errors.collect(cdk.propertyValidator("username", cdk.validateString)(properties.username)), errors.wrap('supplied properties not correct for "InputSourceRequestProperty"');
    }
    function cfnInputInputSourceRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInput_InputSourceRequestPropertyValidator(properties).assertSuccess(), { PasswordParam: cdk.stringToCloudFormation(properties.passwordParam), Url: cdk.stringToCloudFormation(properties.url), Username: cdk.stringToCloudFormation(properties.username) }) : properties;
    }
    function CfnInputInputSourceRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("passwordParam", "PasswordParam", properties.PasswordParam != null ? cfn_parse.FromCloudFormation.getString(properties.PasswordParam) : void 0), ret.addPropertyResult("url", "Url", properties.Url != null ? cfn_parse.FromCloudFormation.getString(properties.Url) : void 0), ret.addPropertyResult("username", "Username", properties.Username != null ? cfn_parse.FromCloudFormation.getString(properties.Username) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInput_InputVpcRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.wrap('supplied properties not correct for "InputVpcRequestProperty"');
    }
    function cfnInputInputVpcRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInput_InputVpcRequestPropertyValidator(properties).assertSuccess(), { SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds) }) : properties;
    }
    function CfnInputInputVpcRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("subnetIds", "SubnetIds", properties.SubnetIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInput_MediaConnectFlowRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("flowArn", cdk.validateString)(properties.flowArn)), errors.wrap('supplied properties not correct for "MediaConnectFlowRequestProperty"');
    }
    function cfnInputMediaConnectFlowRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInput_MediaConnectFlowRequestPropertyValidator(properties).assertSuccess(), { FlowArn: cdk.stringToCloudFormation(properties.flowArn) }) : properties;
    }
    function CfnInputMediaConnectFlowRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("flowArn", "FlowArn", properties.FlowArn != null ? cfn_parse.FromCloudFormation.getString(properties.FlowArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInputSecurityGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.collect(cdk.propertyValidator("whitelistRules", cdk.listValidator(CfnInputSecurityGroup_InputWhitelistRuleCidrPropertyValidator))(properties.whitelistRules)), errors.wrap('supplied properties not correct for "CfnInputSecurityGroupProps"');
    }
    function cfnInputSecurityGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInputSecurityGroupPropsValidator(properties).assertSuccess(), { Tags: cdk.objectToCloudFormation(properties.tags), WhitelistRules: cdk.listMapper(cfnInputSecurityGroupInputWhitelistRuleCidrPropertyToCloudFormation)(properties.whitelistRules) }) : properties;
    }
    function CfnInputSecurityGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addPropertyResult("whitelistRules", "WhitelistRules", properties.WhitelistRules != null ? cfn_parse.FromCloudFormation.getArray(CfnInputSecurityGroupInputWhitelistRuleCidrPropertyFromCloudFormation)(properties.WhitelistRules) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnInputSecurityGroup = class _CfnInputSecurityGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnInputSecurityGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnInputSecurityGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnInputSecurityGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_medialive_CfnInputSecurityGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnInputSecurityGroup), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::MediaLive::InputSecurityGroup", props.tags, { tagPropertyName: "tags" }), this.whitelistRules = props.whitelistRules;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnInputSecurityGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { tags: this.tags.renderTags(), whitelistRules: this.whitelistRules };
      }
      renderProperties(props) {
        return cfnInputSecurityGroupPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnInputSecurityGroup[_c] = { fqn: "aws-cdk-lib.aws_medialive.CfnInputSecurityGroup", version: "2.80.0" }, CfnInputSecurityGroup.CFN_RESOURCE_TYPE_NAME = "AWS::MediaLive::InputSecurityGroup", exports2.CfnInputSecurityGroup = CfnInputSecurityGroup;
    function CfnInputSecurityGroup_InputWhitelistRuleCidrPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cidr", cdk.validateString)(properties.cidr)), errors.wrap('supplied properties not correct for "InputWhitelistRuleCidrProperty"');
    }
    function cfnInputSecurityGroupInputWhitelistRuleCidrPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInputSecurityGroup_InputWhitelistRuleCidrPropertyValidator(properties).assertSuccess(), { Cidr: cdk.stringToCloudFormation(properties.cidr) }) : properties;
    }
    function CfnInputSecurityGroupInputWhitelistRuleCidrPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cidr", "Cidr", properties.Cidr != null ? cfn_parse.FromCloudFormation.getString(properties.Cidr) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-medialive/lib/index.js
var require_lib188 = __commonJS({
  "node_modules/aws-cdk-lib/aws-medialive/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_medialive_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-medialive/index.js
var require_aws_medialive = __commonJS({
  "node_modules/aws-cdk-lib/aws-medialive/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib188(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-mediapackage/lib/mediapackage.generated.js
var require_mediapackage_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-mediapackage/lib/mediapackage.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnPackagingGroup = exports2.CfnPackagingConfiguration = exports2.CfnOriginEndpoint = exports2.CfnChannel = exports2.CfnAsset = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAssetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("egressEndpoints", cdk.listValidator(CfnAsset_EgressEndpointPropertyValidator))(properties.egressEndpoints)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("packagingGroupId", cdk.requiredValidator)(properties.packagingGroupId)), errors.collect(cdk.propertyValidator("packagingGroupId", cdk.validateString)(properties.packagingGroupId)), errors.collect(cdk.propertyValidator("resourceId", cdk.validateString)(properties.resourceId)), errors.collect(cdk.propertyValidator("sourceArn", cdk.requiredValidator)(properties.sourceArn)), errors.collect(cdk.propertyValidator("sourceArn", cdk.validateString)(properties.sourceArn)), errors.collect(cdk.propertyValidator("sourceRoleArn", cdk.requiredValidator)(properties.sourceRoleArn)), errors.collect(cdk.propertyValidator("sourceRoleArn", cdk.validateString)(properties.sourceRoleArn)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnAssetProps"');
    }
    function cfnAssetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssetPropsValidator(properties).assertSuccess(), { Id: cdk.stringToCloudFormation(properties.id), PackagingGroupId: cdk.stringToCloudFormation(properties.packagingGroupId), SourceArn: cdk.stringToCloudFormation(properties.sourceArn), SourceRoleArn: cdk.stringToCloudFormation(properties.sourceRoleArn), EgressEndpoints: cdk.listMapper(cfnAssetEgressEndpointPropertyToCloudFormation)(properties.egressEndpoints), ResourceId: cdk.stringToCloudFormation(properties.resourceId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnAssetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("packagingGroupId", "PackagingGroupId", cfn_parse.FromCloudFormation.getString(properties.PackagingGroupId)), ret.addPropertyResult("sourceArn", "SourceArn", cfn_parse.FromCloudFormation.getString(properties.SourceArn)), ret.addPropertyResult("sourceRoleArn", "SourceRoleArn", cfn_parse.FromCloudFormation.getString(properties.SourceRoleArn)), ret.addPropertyResult("egressEndpoints", "EgressEndpoints", properties.EgressEndpoints != null ? cfn_parse.FromCloudFormation.getArray(CfnAssetEgressEndpointPropertyFromCloudFormation)(properties.EgressEndpoints) : void 0), ret.addPropertyResult("resourceId", "ResourceId", properties.ResourceId != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceId) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAsset = class _CfnAsset extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAssetPropsFromCloudFormation(resourceProperties), ret = new _CfnAsset(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAsset.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_mediapackage_CfnAssetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAsset), error;
        }
        cdk.requireProperty(props, "id", this), cdk.requireProperty(props, "packagingGroupId", this), cdk.requireProperty(props, "sourceArn", this), cdk.requireProperty(props, "sourceRoleArn", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreatedAt = cdk.Token.asString(this.getAtt("CreatedAt", cdk.ResolutionTypeHint.STRING)), this.id = props.id, this.packagingGroupId = props.packagingGroupId, this.sourceArn = props.sourceArn, this.sourceRoleArn = props.sourceRoleArn, this.egressEndpoints = props.egressEndpoints, this.resourceId = props.resourceId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::MediaPackage::Asset", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAsset.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { id: this.id, packagingGroupId: this.packagingGroupId, sourceArn: this.sourceArn, sourceRoleArn: this.sourceRoleArn, egressEndpoints: this.egressEndpoints, resourceId: this.resourceId, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnAssetPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAsset[_a] = { fqn: "aws-cdk-lib.aws_mediapackage.CfnAsset", version: "2.80.0" }, CfnAsset.CFN_RESOURCE_TYPE_NAME = "AWS::MediaPackage::Asset", exports2.CfnAsset = CfnAsset;
    function CfnAsset_EgressEndpointPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("packagingConfigurationId", cdk.requiredValidator)(properties.packagingConfigurationId)), errors.collect(cdk.propertyValidator("packagingConfigurationId", cdk.validateString)(properties.packagingConfigurationId)), errors.collect(cdk.propertyValidator("url", cdk.requiredValidator)(properties.url)), errors.collect(cdk.propertyValidator("url", cdk.validateString)(properties.url)), errors.wrap('supplied properties not correct for "EgressEndpointProperty"');
    }
    function cfnAssetEgressEndpointPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAsset_EgressEndpointPropertyValidator(properties).assertSuccess(), { PackagingConfigurationId: cdk.stringToCloudFormation(properties.packagingConfigurationId), Url: cdk.stringToCloudFormation(properties.url) }) : properties;
    }
    function CfnAssetEgressEndpointPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("packagingConfigurationId", "PackagingConfigurationId", cfn_parse.FromCloudFormation.getString(properties.PackagingConfigurationId)), ret.addPropertyResult("url", "Url", cfn_parse.FromCloudFormation.getString(properties.Url)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannelPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("egressAccessLogs", CfnChannel_LogConfigurationPropertyValidator)(properties.egressAccessLogs)), errors.collect(cdk.propertyValidator("hlsIngest", CfnChannel_HlsIngestPropertyValidator)(properties.hlsIngest)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("ingressAccessLogs", CfnChannel_LogConfigurationPropertyValidator)(properties.ingressAccessLogs)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnChannelProps"');
    }
    function cfnChannelPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannelPropsValidator(properties).assertSuccess(), { Id: cdk.stringToCloudFormation(properties.id), Description: cdk.stringToCloudFormation(properties.description), EgressAccessLogs: cfnChannelLogConfigurationPropertyToCloudFormation(properties.egressAccessLogs), HlsIngest: cfnChannelHlsIngestPropertyToCloudFormation(properties.hlsIngest), IngressAccessLogs: cfnChannelLogConfigurationPropertyToCloudFormation(properties.ingressAccessLogs), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnChannelPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("egressAccessLogs", "EgressAccessLogs", properties.EgressAccessLogs != null ? CfnChannelLogConfigurationPropertyFromCloudFormation(properties.EgressAccessLogs) : void 0), ret.addPropertyResult("hlsIngest", "HlsIngest", properties.HlsIngest != null ? CfnChannelHlsIngestPropertyFromCloudFormation(properties.HlsIngest) : void 0), ret.addPropertyResult("ingressAccessLogs", "IngressAccessLogs", properties.IngressAccessLogs != null ? CfnChannelLogConfigurationPropertyFromCloudFormation(properties.IngressAccessLogs) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnChannel = class _CfnChannel extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnChannelPropsFromCloudFormation(resourceProperties), ret = new _CfnChannel(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnChannel.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_mediapackage_CfnChannelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnChannel), error;
        }
        cdk.requireProperty(props, "id", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.id = props.id, this.description = props.description, this.egressAccessLogs = props.egressAccessLogs, this.hlsIngest = props.hlsIngest, this.ingressAccessLogs = props.ingressAccessLogs, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::MediaPackage::Channel", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnChannel.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { id: this.id, description: this.description, egressAccessLogs: this.egressAccessLogs, hlsIngest: this.hlsIngest, ingressAccessLogs: this.ingressAccessLogs, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnChannelPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnChannel[_b] = { fqn: "aws-cdk-lib.aws_mediapackage.CfnChannel", version: "2.80.0" }, CfnChannel.CFN_RESOURCE_TYPE_NAME = "AWS::MediaPackage::Channel", exports2.CfnChannel = CfnChannel;
    function CfnChannel_HlsIngestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ingestEndpoints", cdk.listValidator(CfnChannel_IngestEndpointPropertyValidator))(properties.ingestEndpoints)), errors.wrap('supplied properties not correct for "HlsIngestProperty"');
    }
    function cfnChannelHlsIngestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_HlsIngestPropertyValidator(properties).assertSuccess(), { ingestEndpoints: cdk.listMapper(cfnChannelIngestEndpointPropertyToCloudFormation)(properties.ingestEndpoints) }) : properties;
    }
    function CfnChannelHlsIngestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ingestEndpoints", "ingestEndpoints", properties.ingestEndpoints != null ? cfn_parse.FromCloudFormation.getArray(CfnChannelIngestEndpointPropertyFromCloudFormation)(properties.ingestEndpoints) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_IngestEndpointPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("password", cdk.requiredValidator)(properties.password)), errors.collect(cdk.propertyValidator("password", cdk.validateString)(properties.password)), errors.collect(cdk.propertyValidator("url", cdk.requiredValidator)(properties.url)), errors.collect(cdk.propertyValidator("url", cdk.validateString)(properties.url)), errors.collect(cdk.propertyValidator("username", cdk.requiredValidator)(properties.username)), errors.collect(cdk.propertyValidator("username", cdk.validateString)(properties.username)), errors.wrap('supplied properties not correct for "IngestEndpointProperty"');
    }
    function cfnChannelIngestEndpointPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_IngestEndpointPropertyValidator(properties).assertSuccess(), { Id: cdk.stringToCloudFormation(properties.id), Password: cdk.stringToCloudFormation(properties.password), Url: cdk.stringToCloudFormation(properties.url), Username: cdk.stringToCloudFormation(properties.username) }) : properties;
    }
    function CfnChannelIngestEndpointPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("password", "Password", cfn_parse.FromCloudFormation.getString(properties.Password)), ret.addPropertyResult("url", "Url", cfn_parse.FromCloudFormation.getString(properties.Url)), ret.addPropertyResult("username", "Username", cfn_parse.FromCloudFormation.getString(properties.Username)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnChannel_LogConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logGroupName", cdk.validateString)(properties.logGroupName)), errors.wrap('supplied properties not correct for "LogConfigurationProperty"');
    }
    function cfnChannelLogConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnChannel_LogConfigurationPropertyValidator(properties).assertSuccess(), { LogGroupName: cdk.stringToCloudFormation(properties.logGroupName) }) : properties;
    }
    function CfnChannelLogConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logGroupName", "LogGroupName", properties.LogGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.LogGroupName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnOriginEndpointPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authorization", CfnOriginEndpoint_AuthorizationPropertyValidator)(properties.authorization)), errors.collect(cdk.propertyValidator("channelId", cdk.requiredValidator)(properties.channelId)), errors.collect(cdk.propertyValidator("channelId", cdk.validateString)(properties.channelId)), errors.collect(cdk.propertyValidator("cmafPackage", CfnOriginEndpoint_CmafPackagePropertyValidator)(properties.cmafPackage)), errors.collect(cdk.propertyValidator("dashPackage", CfnOriginEndpoint_DashPackagePropertyValidator)(properties.dashPackage)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("hlsPackage", CfnOriginEndpoint_HlsPackagePropertyValidator)(properties.hlsPackage)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("manifestName", cdk.validateString)(properties.manifestName)), errors.collect(cdk.propertyValidator("mssPackage", CfnOriginEndpoint_MssPackagePropertyValidator)(properties.mssPackage)), errors.collect(cdk.propertyValidator("origination", cdk.validateString)(properties.origination)), errors.collect(cdk.propertyValidator("startoverWindowSeconds", cdk.validateNumber)(properties.startoverWindowSeconds)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("timeDelaySeconds", cdk.validateNumber)(properties.timeDelaySeconds)), errors.collect(cdk.propertyValidator("whitelist", cdk.listValidator(cdk.validateString))(properties.whitelist)), errors.wrap('supplied properties not correct for "CfnOriginEndpointProps"');
    }
    function cfnOriginEndpointPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOriginEndpointPropsValidator(properties).assertSuccess(), { ChannelId: cdk.stringToCloudFormation(properties.channelId), Id: cdk.stringToCloudFormation(properties.id), Authorization: cfnOriginEndpointAuthorizationPropertyToCloudFormation(properties.authorization), CmafPackage: cfnOriginEndpointCmafPackagePropertyToCloudFormation(properties.cmafPackage), DashPackage: cfnOriginEndpointDashPackagePropertyToCloudFormation(properties.dashPackage), Description: cdk.stringToCloudFormation(properties.description), HlsPackage: cfnOriginEndpointHlsPackagePropertyToCloudFormation(properties.hlsPackage), ManifestName: cdk.stringToCloudFormation(properties.manifestName), MssPackage: cfnOriginEndpointMssPackagePropertyToCloudFormation(properties.mssPackage), Origination: cdk.stringToCloudFormation(properties.origination), StartoverWindowSeconds: cdk.numberToCloudFormation(properties.startoverWindowSeconds), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TimeDelaySeconds: cdk.numberToCloudFormation(properties.timeDelaySeconds), Whitelist: cdk.listMapper(cdk.stringToCloudFormation)(properties.whitelist) }) : properties;
    }
    function CfnOriginEndpointPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("channelId", "ChannelId", cfn_parse.FromCloudFormation.getString(properties.ChannelId)), ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("authorization", "Authorization", properties.Authorization != null ? CfnOriginEndpointAuthorizationPropertyFromCloudFormation(properties.Authorization) : void 0), ret.addPropertyResult("cmafPackage", "CmafPackage", properties.CmafPackage != null ? CfnOriginEndpointCmafPackagePropertyFromCloudFormation(properties.CmafPackage) : void 0), ret.addPropertyResult("dashPackage", "DashPackage", properties.DashPackage != null ? CfnOriginEndpointDashPackagePropertyFromCloudFormation(properties.DashPackage) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("hlsPackage", "HlsPackage", properties.HlsPackage != null ? CfnOriginEndpointHlsPackagePropertyFromCloudFormation(properties.HlsPackage) : void 0), ret.addPropertyResult("manifestName", "ManifestName", properties.ManifestName != null ? cfn_parse.FromCloudFormation.getString(properties.ManifestName) : void 0), ret.addPropertyResult("mssPackage", "MssPackage", properties.MssPackage != null ? CfnOriginEndpointMssPackagePropertyFromCloudFormation(properties.MssPackage) : void 0), ret.addPropertyResult("origination", "Origination", properties.Origination != null ? cfn_parse.FromCloudFormation.getString(properties.Origination) : void 0), ret.addPropertyResult("startoverWindowSeconds", "StartoverWindowSeconds", properties.StartoverWindowSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.StartoverWindowSeconds) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("timeDelaySeconds", "TimeDelaySeconds", properties.TimeDelaySeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.TimeDelaySeconds) : void 0), ret.addPropertyResult("whitelist", "Whitelist", properties.Whitelist != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Whitelist) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnOriginEndpoint = class _CfnOriginEndpoint extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnOriginEndpointPropsFromCloudFormation(resourceProperties), ret = new _CfnOriginEndpoint(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnOriginEndpoint.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_mediapackage_CfnOriginEndpointProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnOriginEndpoint), error;
        }
        cdk.requireProperty(props, "channelId", this), cdk.requireProperty(props, "id", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrUrl = cdk.Token.asString(this.getAtt("Url", cdk.ResolutionTypeHint.STRING)), this.channelId = props.channelId, this.id = props.id, this.authorization = props.authorization, this.cmafPackage = props.cmafPackage, this.dashPackage = props.dashPackage, this.description = props.description, this.hlsPackage = props.hlsPackage, this.manifestName = props.manifestName, this.mssPackage = props.mssPackage, this.origination = props.origination, this.startoverWindowSeconds = props.startoverWindowSeconds, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::MediaPackage::OriginEndpoint", props.tags, { tagPropertyName: "tags" }), this.timeDelaySeconds = props.timeDelaySeconds, this.whitelist = props.whitelist;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnOriginEndpoint.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { channelId: this.channelId, id: this.id, authorization: this.authorization, cmafPackage: this.cmafPackage, dashPackage: this.dashPackage, description: this.description, hlsPackage: this.hlsPackage, manifestName: this.manifestName, mssPackage: this.mssPackage, origination: this.origination, startoverWindowSeconds: this.startoverWindowSeconds, tags: this.tags.renderTags(), timeDelaySeconds: this.timeDelaySeconds, whitelist: this.whitelist };
      }
      renderProperties(props) {
        return cfnOriginEndpointPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnOriginEndpoint[_c] = { fqn: "aws-cdk-lib.aws_mediapackage.CfnOriginEndpoint", version: "2.80.0" }, CfnOriginEndpoint.CFN_RESOURCE_TYPE_NAME = "AWS::MediaPackage::OriginEndpoint", exports2.CfnOriginEndpoint = CfnOriginEndpoint;
    function CfnOriginEndpoint_AuthorizationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cdnIdentifierSecret", cdk.requiredValidator)(properties.cdnIdentifierSecret)), errors.collect(cdk.propertyValidator("cdnIdentifierSecret", cdk.validateString)(properties.cdnIdentifierSecret)), errors.collect(cdk.propertyValidator("secretsRoleArn", cdk.requiredValidator)(properties.secretsRoleArn)), errors.collect(cdk.propertyValidator("secretsRoleArn", cdk.validateString)(properties.secretsRoleArn)), errors.wrap('supplied properties not correct for "AuthorizationProperty"');
    }
    function cfnOriginEndpointAuthorizationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOriginEndpoint_AuthorizationPropertyValidator(properties).assertSuccess(), { CdnIdentifierSecret: cdk.stringToCloudFormation(properties.cdnIdentifierSecret), SecretsRoleArn: cdk.stringToCloudFormation(properties.secretsRoleArn) }) : properties;
    }
    function CfnOriginEndpointAuthorizationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cdnIdentifierSecret", "CdnIdentifierSecret", cfn_parse.FromCloudFormation.getString(properties.CdnIdentifierSecret)), ret.addPropertyResult("secretsRoleArn", "SecretsRoleArn", cfn_parse.FromCloudFormation.getString(properties.SecretsRoleArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnOriginEndpoint_CmafEncryptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("constantInitializationVector", cdk.validateString)(properties.constantInitializationVector)), errors.collect(cdk.propertyValidator("encryptionMethod", cdk.validateString)(properties.encryptionMethod)), errors.collect(cdk.propertyValidator("keyRotationIntervalSeconds", cdk.validateNumber)(properties.keyRotationIntervalSeconds)), errors.collect(cdk.propertyValidator("spekeKeyProvider", cdk.requiredValidator)(properties.spekeKeyProvider)), errors.collect(cdk.propertyValidator("spekeKeyProvider", CfnOriginEndpoint_SpekeKeyProviderPropertyValidator)(properties.spekeKeyProvider)), errors.wrap('supplied properties not correct for "CmafEncryptionProperty"');
    }
    function cfnOriginEndpointCmafEncryptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOriginEndpoint_CmafEncryptionPropertyValidator(properties).assertSuccess(), { ConstantInitializationVector: cdk.stringToCloudFormation(properties.constantInitializationVector), EncryptionMethod: cdk.stringToCloudFormation(properties.encryptionMethod), KeyRotationIntervalSeconds: cdk.numberToCloudFormation(properties.keyRotationIntervalSeconds), SpekeKeyProvider: cfnOriginEndpointSpekeKeyProviderPropertyToCloudFormation(properties.spekeKeyProvider) }) : properties;
    }
    function CfnOriginEndpointCmafEncryptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("constantInitializationVector", "ConstantInitializationVector", properties.ConstantInitializationVector != null ? cfn_parse.FromCloudFormation.getString(properties.ConstantInitializationVector) : void 0), ret.addPropertyResult("encryptionMethod", "EncryptionMethod", properties.EncryptionMethod != null ? cfn_parse.FromCloudFormation.getString(properties.EncryptionMethod) : void 0), ret.addPropertyResult("keyRotationIntervalSeconds", "KeyRotationIntervalSeconds", properties.KeyRotationIntervalSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.KeyRotationIntervalSeconds) : void 0), ret.addPropertyResult("spekeKeyProvider", "SpekeKeyProvider", CfnOriginEndpointSpekeKeyProviderPropertyFromCloudFormation(properties.SpekeKeyProvider)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnOriginEndpoint_CmafPackagePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("encryption", CfnOriginEndpoint_CmafEncryptionPropertyValidator)(properties.encryption)), errors.collect(cdk.propertyValidator("hlsManifests", cdk.listValidator(CfnOriginEndpoint_HlsManifestPropertyValidator))(properties.hlsManifests)), errors.collect(cdk.propertyValidator("segmentDurationSeconds", cdk.validateNumber)(properties.segmentDurationSeconds)), errors.collect(cdk.propertyValidator("segmentPrefix", cdk.validateString)(properties.segmentPrefix)), errors.collect(cdk.propertyValidator("streamSelection", CfnOriginEndpoint_StreamSelectionPropertyValidator)(properties.streamSelection)), errors.wrap('supplied properties not correct for "CmafPackageProperty"');
    }
    function cfnOriginEndpointCmafPackagePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOriginEndpoint_CmafPackagePropertyValidator(properties).assertSuccess(), { Encryption: cfnOriginEndpointCmafEncryptionPropertyToCloudFormation(properties.encryption), HlsManifests: cdk.listMapper(cfnOriginEndpointHlsManifestPropertyToCloudFormation)(properties.hlsManifests), SegmentDurationSeconds: cdk.numberToCloudFormation(properties.segmentDurationSeconds), SegmentPrefix: cdk.stringToCloudFormation(properties.segmentPrefix), StreamSelection: cfnOriginEndpointStreamSelectionPropertyToCloudFormation(properties.streamSelection) }) : properties;
    }
    function CfnOriginEndpointCmafPackagePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("encryption", "Encryption", properties.Encryption != null ? CfnOriginEndpointCmafEncryptionPropertyFromCloudFormation(properties.Encryption) : void 0), ret.addPropertyResult("hlsManifests", "HlsManifests", properties.HlsManifests != null ? cfn_parse.FromCloudFormation.getArray(CfnOriginEndpointHlsManifestPropertyFromCloudFormation)(properties.HlsManifests) : void 0), ret.addPropertyResult("segmentDurationSeconds", "SegmentDurationSeconds", properties.SegmentDurationSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.SegmentDurationSeconds) : void 0), ret.addPropertyResult("segmentPrefix", "SegmentPrefix", properties.SegmentPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.SegmentPrefix) : void 0), ret.addPropertyResult("streamSelection", "StreamSelection", properties.StreamSelection != null ? CfnOriginEndpointStreamSelectionPropertyFromCloudFormation(properties.StreamSelection) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnOriginEndpoint_DashEncryptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("keyRotationIntervalSeconds", cdk.validateNumber)(properties.keyRotationIntervalSeconds)), errors.collect(cdk.propertyValidator("spekeKeyProvider", cdk.requiredValidator)(properties.spekeKeyProvider)), errors.collect(cdk.propertyValidator("spekeKeyProvider", CfnOriginEndpoint_SpekeKeyProviderPropertyValidator)(properties.spekeKeyProvider)), errors.wrap('supplied properties not correct for "DashEncryptionProperty"');
    }
    function cfnOriginEndpointDashEncryptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOriginEndpoint_DashEncryptionPropertyValidator(properties).assertSuccess(), { KeyRotationIntervalSeconds: cdk.numberToCloudFormation(properties.keyRotationIntervalSeconds), SpekeKeyProvider: cfnOriginEndpointSpekeKeyProviderPropertyToCloudFormation(properties.spekeKeyProvider) }) : properties;
    }
    function CfnOriginEndpointDashEncryptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("keyRotationIntervalSeconds", "KeyRotationIntervalSeconds", properties.KeyRotationIntervalSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.KeyRotationIntervalSeconds) : void 0), ret.addPropertyResult("spekeKeyProvider", "SpekeKeyProvider", CfnOriginEndpointSpekeKeyProviderPropertyFromCloudFormation(properties.SpekeKeyProvider)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnOriginEndpoint_DashPackagePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("adTriggers", cdk.listValidator(cdk.validateString))(properties.adTriggers)), errors.collect(cdk.propertyValidator("adsOnDeliveryRestrictions", cdk.validateString)(properties.adsOnDeliveryRestrictions)), errors.collect(cdk.propertyValidator("encryption", CfnOriginEndpoint_DashEncryptionPropertyValidator)(properties.encryption)), errors.collect(cdk.propertyValidator("includeIframeOnlyStream", cdk.validateBoolean)(properties.includeIframeOnlyStream)), errors.collect(cdk.propertyValidator("manifestLayout", cdk.validateString)(properties.manifestLayout)), errors.collect(cdk.propertyValidator("manifestWindowSeconds", cdk.validateNumber)(properties.manifestWindowSeconds)), errors.collect(cdk.propertyValidator("minBufferTimeSeconds", cdk.validateNumber)(properties.minBufferTimeSeconds)), errors.collect(cdk.propertyValidator("minUpdatePeriodSeconds", cdk.validateNumber)(properties.minUpdatePeriodSeconds)), errors.collect(cdk.propertyValidator("periodTriggers", cdk.listValidator(cdk.validateString))(properties.periodTriggers)), errors.collect(cdk.propertyValidator("profile", cdk.validateString)(properties.profile)), errors.collect(cdk.propertyValidator("segmentDurationSeconds", cdk.validateNumber)(properties.segmentDurationSeconds)), errors.collect(cdk.propertyValidator("segmentTemplateFormat", cdk.validateString)(properties.segmentTemplateFormat)), errors.collect(cdk.propertyValidator("streamSelection", CfnOriginEndpoint_StreamSelectionPropertyValidator)(properties.streamSelection)), errors.collect(cdk.propertyValidator("suggestedPresentationDelaySeconds", cdk.validateNumber)(properties.suggestedPresentationDelaySeconds)), errors.collect(cdk.propertyValidator("utcTiming", cdk.validateString)(properties.utcTiming)), errors.collect(cdk.propertyValidator("utcTimingUri", cdk.validateString)(properties.utcTimingUri)), errors.wrap('supplied properties not correct for "DashPackageProperty"');
    }
    function cfnOriginEndpointDashPackagePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOriginEndpoint_DashPackagePropertyValidator(properties).assertSuccess(), { AdTriggers: cdk.listMapper(cdk.stringToCloudFormation)(properties.adTriggers), AdsOnDeliveryRestrictions: cdk.stringToCloudFormation(properties.adsOnDeliveryRestrictions), Encryption: cfnOriginEndpointDashEncryptionPropertyToCloudFormation(properties.encryption), IncludeIframeOnlyStream: cdk.booleanToCloudFormation(properties.includeIframeOnlyStream), ManifestLayout: cdk.stringToCloudFormation(properties.manifestLayout), ManifestWindowSeconds: cdk.numberToCloudFormation(properties.manifestWindowSeconds), MinBufferTimeSeconds: cdk.numberToCloudFormation(properties.minBufferTimeSeconds), MinUpdatePeriodSeconds: cdk.numberToCloudFormation(properties.minUpdatePeriodSeconds), PeriodTriggers: cdk.listMapper(cdk.stringToCloudFormation)(properties.periodTriggers), Profile: cdk.stringToCloudFormation(properties.profile), SegmentDurationSeconds: cdk.numberToCloudFormation(properties.segmentDurationSeconds), SegmentTemplateFormat: cdk.stringToCloudFormation(properties.segmentTemplateFormat), StreamSelection: cfnOriginEndpointStreamSelectionPropertyToCloudFormation(properties.streamSelection), SuggestedPresentationDelaySeconds: cdk.numberToCloudFormation(properties.suggestedPresentationDelaySeconds), UtcTiming: cdk.stringToCloudFormation(properties.utcTiming), UtcTimingUri: cdk.stringToCloudFormation(properties.utcTimingUri) }) : properties;
    }
    function CfnOriginEndpointDashPackagePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("adTriggers", "AdTriggers", properties.AdTriggers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AdTriggers) : void 0), ret.addPropertyResult("adsOnDeliveryRestrictions", "AdsOnDeliveryRestrictions", properties.AdsOnDeliveryRestrictions != null ? cfn_parse.FromCloudFormation.getString(properties.AdsOnDeliveryRestrictions) : void 0), ret.addPropertyResult("encryption", "Encryption", properties.Encryption != null ? CfnOriginEndpointDashEncryptionPropertyFromCloudFormation(properties.Encryption) : void 0), ret.addPropertyResult("includeIframeOnlyStream", "IncludeIframeOnlyStream", properties.IncludeIframeOnlyStream != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeIframeOnlyStream) : void 0), ret.addPropertyResult("manifestLayout", "ManifestLayout", properties.ManifestLayout != null ? cfn_parse.FromCloudFormation.getString(properties.ManifestLayout) : void 0), ret.addPropertyResult("manifestWindowSeconds", "ManifestWindowSeconds", properties.ManifestWindowSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.ManifestWindowSeconds) : void 0), ret.addPropertyResult("minBufferTimeSeconds", "MinBufferTimeSeconds", properties.MinBufferTimeSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinBufferTimeSeconds) : void 0), ret.addPropertyResult("minUpdatePeriodSeconds", "MinUpdatePeriodSeconds", properties.MinUpdatePeriodSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinUpdatePeriodSeconds) : void 0), ret.addPropertyResult("periodTriggers", "PeriodTriggers", properties.PeriodTriggers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.PeriodTriggers) : void 0), ret.addPropertyResult("profile", "Profile", properties.Profile != null ? cfn_parse.FromCloudFormation.getString(properties.Profile) : void 0), ret.addPropertyResult("segmentDurationSeconds", "SegmentDurationSeconds", properties.SegmentDurationSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.SegmentDurationSeconds) : void 0), ret.addPropertyResult("segmentTemplateFormat", "SegmentTemplateFormat", properties.SegmentTemplateFormat != null ? cfn_parse.FromCloudFormation.getString(properties.SegmentTemplateFormat) : void 0), ret.addPropertyResult("streamSelection", "StreamSelection", properties.StreamSelection != null ? CfnOriginEndpointStreamSelectionPropertyFromCloudFormation(properties.StreamSelection) : void 0), ret.addPropertyResult("suggestedPresentationDelaySeconds", "SuggestedPresentationDelaySeconds", properties.SuggestedPresentationDelaySeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.SuggestedPresentationDelaySeconds) : void 0), ret.addPropertyResult("utcTiming", "UtcTiming", properties.UtcTiming != null ? cfn_parse.FromCloudFormation.getString(properties.UtcTiming) : void 0), ret.addPropertyResult("utcTimingUri", "UtcTimingUri", properties.UtcTimingUri != null ? cfn_parse.FromCloudFormation.getString(properties.UtcTimingUri) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnOriginEndpoint_EncryptionContractConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.wrap('supplied properties not correct for "EncryptionContractConfigurationProperty"');
    }
    function cfnOriginEndpointEncryptionContractConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOriginEndpoint_EncryptionContractConfigurationPropertyValidator(properties).assertSuccess(), {}) : properties;
    }
    function CfnOriginEndpointEncryptionContractConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnOriginEndpoint_HlsEncryptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("constantInitializationVector", cdk.validateString)(properties.constantInitializationVector)), errors.collect(cdk.propertyValidator("encryptionMethod", cdk.validateString)(properties.encryptionMethod)), errors.collect(cdk.propertyValidator("keyRotationIntervalSeconds", cdk.validateNumber)(properties.keyRotationIntervalSeconds)), errors.collect(cdk.propertyValidator("repeatExtXKey", cdk.validateBoolean)(properties.repeatExtXKey)), errors.collect(cdk.propertyValidator("spekeKeyProvider", cdk.requiredValidator)(properties.spekeKeyProvider)), errors.collect(cdk.propertyValidator("spekeKeyProvider", CfnOriginEndpoint_SpekeKeyProviderPropertyValidator)(properties.spekeKeyProvider)), errors.wrap('supplied properties not correct for "HlsEncryptionProperty"');
    }
    function cfnOriginEndpointHlsEncryptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOriginEndpoint_HlsEncryptionPropertyValidator(properties).assertSuccess(), { ConstantInitializationVector: cdk.stringToCloudFormation(properties.constantInitializationVector), EncryptionMethod: cdk.stringToCloudFormation(properties.encryptionMethod), KeyRotationIntervalSeconds: cdk.numberToCloudFormation(properties.keyRotationIntervalSeconds), RepeatExtXKey: cdk.booleanToCloudFormation(properties.repeatExtXKey), SpekeKeyProvider: cfnOriginEndpointSpekeKeyProviderPropertyToCloudFormation(properties.spekeKeyProvider) }) : properties;
    }
    function CfnOriginEndpointHlsEncryptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("constantInitializationVector", "ConstantInitializationVector", properties.ConstantInitializationVector != null ? cfn_parse.FromCloudFormation.getString(properties.ConstantInitializationVector) : void 0), ret.addPropertyResult("encryptionMethod", "EncryptionMethod", properties.EncryptionMethod != null ? cfn_parse.FromCloudFormation.getString(properties.EncryptionMethod) : void 0), ret.addPropertyResult("keyRotationIntervalSeconds", "KeyRotationIntervalSeconds", properties.KeyRotationIntervalSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.KeyRotationIntervalSeconds) : void 0), ret.addPropertyResult("repeatExtXKey", "RepeatExtXKey", properties.RepeatExtXKey != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RepeatExtXKey) : void 0), ret.addPropertyResult("spekeKeyProvider", "SpekeKeyProvider", CfnOriginEndpointSpekeKeyProviderPropertyFromCloudFormation(properties.SpekeKeyProvider)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnOriginEndpoint_HlsManifestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("adMarkers", cdk.validateString)(properties.adMarkers)), errors.collect(cdk.propertyValidator("adTriggers", cdk.listValidator(cdk.validateString))(properties.adTriggers)), errors.collect(cdk.propertyValidator("adsOnDeliveryRestrictions", cdk.validateString)(properties.adsOnDeliveryRestrictions)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("includeIframeOnlyStream", cdk.validateBoolean)(properties.includeIframeOnlyStream)), errors.collect(cdk.propertyValidator("manifestName", cdk.validateString)(properties.manifestName)), errors.collect(cdk.propertyValidator("playlistType", cdk.validateString)(properties.playlistType)), errors.collect(cdk.propertyValidator("playlistWindowSeconds", cdk.validateNumber)(properties.playlistWindowSeconds)), errors.collect(cdk.propertyValidator("programDateTimeIntervalSeconds", cdk.validateNumber)(properties.programDateTimeIntervalSeconds)), errors.collect(cdk.propertyValidator("url", cdk.validateString)(properties.url)), errors.wrap('supplied properties not correct for "HlsManifestProperty"');
    }
    function cfnOriginEndpointHlsManifestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOriginEndpoint_HlsManifestPropertyValidator(properties).assertSuccess(), { AdMarkers: cdk.stringToCloudFormation(properties.adMarkers), AdTriggers: cdk.listMapper(cdk.stringToCloudFormation)(properties.adTriggers), AdsOnDeliveryRestrictions: cdk.stringToCloudFormation(properties.adsOnDeliveryRestrictions), Id: cdk.stringToCloudFormation(properties.id), IncludeIframeOnlyStream: cdk.booleanToCloudFormation(properties.includeIframeOnlyStream), ManifestName: cdk.stringToCloudFormation(properties.manifestName), PlaylistType: cdk.stringToCloudFormation(properties.playlistType), PlaylistWindowSeconds: cdk.numberToCloudFormation(properties.playlistWindowSeconds), ProgramDateTimeIntervalSeconds: cdk.numberToCloudFormation(properties.programDateTimeIntervalSeconds), Url: cdk.stringToCloudFormation(properties.url) }) : properties;
    }
    function CfnOriginEndpointHlsManifestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("adMarkers", "AdMarkers", properties.AdMarkers != null ? cfn_parse.FromCloudFormation.getString(properties.AdMarkers) : void 0), ret.addPropertyResult("adTriggers", "AdTriggers", properties.AdTriggers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AdTriggers) : void 0), ret.addPropertyResult("adsOnDeliveryRestrictions", "AdsOnDeliveryRestrictions", properties.AdsOnDeliveryRestrictions != null ? cfn_parse.FromCloudFormation.getString(properties.AdsOnDeliveryRestrictions) : void 0), ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("includeIframeOnlyStream", "IncludeIframeOnlyStream", properties.IncludeIframeOnlyStream != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeIframeOnlyStream) : void 0), ret.addPropertyResult("manifestName", "ManifestName", properties.ManifestName != null ? cfn_parse.FromCloudFormation.getString(properties.ManifestName) : void 0), ret.addPropertyResult("playlistType", "PlaylistType", properties.PlaylistType != null ? cfn_parse.FromCloudFormation.getString(properties.PlaylistType) : void 0), ret.addPropertyResult("playlistWindowSeconds", "PlaylistWindowSeconds", properties.PlaylistWindowSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.PlaylistWindowSeconds) : void 0), ret.addPropertyResult("programDateTimeIntervalSeconds", "ProgramDateTimeIntervalSeconds", properties.ProgramDateTimeIntervalSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.ProgramDateTimeIntervalSeconds) : void 0), ret.addPropertyResult("url", "Url", properties.Url != null ? cfn_parse.FromCloudFormation.getString(properties.Url) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnOriginEndpoint_HlsPackagePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("adMarkers", cdk.validateString)(properties.adMarkers)), errors.collect(cdk.propertyValidator("adTriggers", cdk.listValidator(cdk.validateString))(properties.adTriggers)), errors.collect(cdk.propertyValidator("adsOnDeliveryRestrictions", cdk.validateString)(properties.adsOnDeliveryRestrictions)), errors.collect(cdk.propertyValidator("encryption", CfnOriginEndpoint_HlsEncryptionPropertyValidator)(properties.encryption)), errors.collect(cdk.propertyValidator("includeDvbSubtitles", cdk.validateBoolean)(properties.includeDvbSubtitles)), errors.collect(cdk.propertyValidator("includeIframeOnlyStream", cdk.validateBoolean)(properties.includeIframeOnlyStream)), errors.collect(cdk.propertyValidator("playlistType", cdk.validateString)(properties.playlistType)), errors.collect(cdk.propertyValidator("playlistWindowSeconds", cdk.validateNumber)(properties.playlistWindowSeconds)), errors.collect(cdk.propertyValidator("programDateTimeIntervalSeconds", cdk.validateNumber)(properties.programDateTimeIntervalSeconds)), errors.collect(cdk.propertyValidator("segmentDurationSeconds", cdk.validateNumber)(properties.segmentDurationSeconds)), errors.collect(cdk.propertyValidator("streamSelection", CfnOriginEndpoint_StreamSelectionPropertyValidator)(properties.streamSelection)), errors.collect(cdk.propertyValidator("useAudioRenditionGroup", cdk.validateBoolean)(properties.useAudioRenditionGroup)), errors.wrap('supplied properties not correct for "HlsPackageProperty"');
    }
    function cfnOriginEndpointHlsPackagePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOriginEndpoint_HlsPackagePropertyValidator(properties).assertSuccess(), { AdMarkers: cdk.stringToCloudFormation(properties.adMarkers), AdTriggers: cdk.listMapper(cdk.stringToCloudFormation)(properties.adTriggers), AdsOnDeliveryRestrictions: cdk.stringToCloudFormation(properties.adsOnDeliveryRestrictions), Encryption: cfnOriginEndpointHlsEncryptionPropertyToCloudFormation(properties.encryption), IncludeDvbSubtitles: cdk.booleanToCloudFormation(properties.includeDvbSubtitles), IncludeIframeOnlyStream: cdk.booleanToCloudFormation(properties.includeIframeOnlyStream), PlaylistType: cdk.stringToCloudFormation(properties.playlistType), PlaylistWindowSeconds: cdk.numberToCloudFormation(properties.playlistWindowSeconds), ProgramDateTimeIntervalSeconds: cdk.numberToCloudFormation(properties.programDateTimeIntervalSeconds), SegmentDurationSeconds: cdk.numberToCloudFormation(properties.segmentDurationSeconds), StreamSelection: cfnOriginEndpointStreamSelectionPropertyToCloudFormation(properties.streamSelection), UseAudioRenditionGroup: cdk.booleanToCloudFormation(properties.useAudioRenditionGroup) }) : properties;
    }
    function CfnOriginEndpointHlsPackagePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("adMarkers", "AdMarkers", properties.AdMarkers != null ? cfn_parse.FromCloudFormation.getString(properties.AdMarkers) : void 0), ret.addPropertyResult("adTriggers", "AdTriggers", properties.AdTriggers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AdTriggers) : void 0), ret.addPropertyResult("adsOnDeliveryRestrictions", "AdsOnDeliveryRestrictions", properties.AdsOnDeliveryRestrictions != null ? cfn_parse.FromCloudFormation.getString(properties.AdsOnDeliveryRestrictions) : void 0), ret.addPropertyResult("encryption", "Encryption", properties.Encryption != null ? CfnOriginEndpointHlsEncryptionPropertyFromCloudFormation(properties.Encryption) : void 0), ret.addPropertyResult("includeDvbSubtitles", "IncludeDvbSubtitles", properties.IncludeDvbSubtitles != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeDvbSubtitles) : void 0), ret.addPropertyResult("includeIframeOnlyStream", "IncludeIframeOnlyStream", properties.IncludeIframeOnlyStream != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeIframeOnlyStream) : void 0), ret.addPropertyResult("playlistType", "PlaylistType", properties.PlaylistType != null ? cfn_parse.FromCloudFormation.getString(properties.PlaylistType) : void 0), ret.addPropertyResult("playlistWindowSeconds", "PlaylistWindowSeconds", properties.PlaylistWindowSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.PlaylistWindowSeconds) : void 0), ret.addPropertyResult("programDateTimeIntervalSeconds", "ProgramDateTimeIntervalSeconds", properties.ProgramDateTimeIntervalSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.ProgramDateTimeIntervalSeconds) : void 0), ret.addPropertyResult("segmentDurationSeconds", "SegmentDurationSeconds", properties.SegmentDurationSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.SegmentDurationSeconds) : void 0), ret.addPropertyResult("streamSelection", "StreamSelection", properties.StreamSelection != null ? CfnOriginEndpointStreamSelectionPropertyFromCloudFormation(properties.StreamSelection) : void 0), ret.addPropertyResult("useAudioRenditionGroup", "UseAudioRenditionGroup", properties.UseAudioRenditionGroup != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseAudioRenditionGroup) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnOriginEndpoint_MssEncryptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("spekeKeyProvider", cdk.requiredValidator)(properties.spekeKeyProvider)), errors.collect(cdk.propertyValidator("spekeKeyProvider", CfnOriginEndpoint_SpekeKeyProviderPropertyValidator)(properties.spekeKeyProvider)), errors.wrap('supplied properties not correct for "MssEncryptionProperty"');
    }
    function cfnOriginEndpointMssEncryptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOriginEndpoint_MssEncryptionPropertyValidator(properties).assertSuccess(), { SpekeKeyProvider: cfnOriginEndpointSpekeKeyProviderPropertyToCloudFormation(properties.spekeKeyProvider) }) : properties;
    }
    function CfnOriginEndpointMssEncryptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("spekeKeyProvider", "SpekeKeyProvider", CfnOriginEndpointSpekeKeyProviderPropertyFromCloudFormation(properties.SpekeKeyProvider)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnOriginEndpoint_MssPackagePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("encryption", CfnOriginEndpoint_MssEncryptionPropertyValidator)(properties.encryption)), errors.collect(cdk.propertyValidator("manifestWindowSeconds", cdk.validateNumber)(properties.manifestWindowSeconds)), errors.collect(cdk.propertyValidator("segmentDurationSeconds", cdk.validateNumber)(properties.segmentDurationSeconds)), errors.collect(cdk.propertyValidator("streamSelection", CfnOriginEndpoint_StreamSelectionPropertyValidator)(properties.streamSelection)), errors.wrap('supplied properties not correct for "MssPackageProperty"');
    }
    function cfnOriginEndpointMssPackagePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOriginEndpoint_MssPackagePropertyValidator(properties).assertSuccess(), { Encryption: cfnOriginEndpointMssEncryptionPropertyToCloudFormation(properties.encryption), ManifestWindowSeconds: cdk.numberToCloudFormation(properties.manifestWindowSeconds), SegmentDurationSeconds: cdk.numberToCloudFormation(properties.segmentDurationSeconds), StreamSelection: cfnOriginEndpointStreamSelectionPropertyToCloudFormation(properties.streamSelection) }) : properties;
    }
    function CfnOriginEndpointMssPackagePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("encryption", "Encryption", properties.Encryption != null ? CfnOriginEndpointMssEncryptionPropertyFromCloudFormation(properties.Encryption) : void 0), ret.addPropertyResult("manifestWindowSeconds", "ManifestWindowSeconds", properties.ManifestWindowSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.ManifestWindowSeconds) : void 0), ret.addPropertyResult("segmentDurationSeconds", "SegmentDurationSeconds", properties.SegmentDurationSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.SegmentDurationSeconds) : void 0), ret.addPropertyResult("streamSelection", "StreamSelection", properties.StreamSelection != null ? CfnOriginEndpointStreamSelectionPropertyFromCloudFormation(properties.StreamSelection) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnOriginEndpoint_SpekeKeyProviderPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateArn", cdk.validateString)(properties.certificateArn)), errors.collect(cdk.propertyValidator("encryptionContractConfiguration", CfnOriginEndpoint_EncryptionContractConfigurationPropertyValidator)(properties.encryptionContractConfiguration)), errors.collect(cdk.propertyValidator("resourceId", cdk.requiredValidator)(properties.resourceId)), errors.collect(cdk.propertyValidator("resourceId", cdk.validateString)(properties.resourceId)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("systemIds", cdk.requiredValidator)(properties.systemIds)), errors.collect(cdk.propertyValidator("systemIds", cdk.listValidator(cdk.validateString))(properties.systemIds)), errors.collect(cdk.propertyValidator("url", cdk.requiredValidator)(properties.url)), errors.collect(cdk.propertyValidator("url", cdk.validateString)(properties.url)), errors.wrap('supplied properties not correct for "SpekeKeyProviderProperty"');
    }
    function cfnOriginEndpointSpekeKeyProviderPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOriginEndpoint_SpekeKeyProviderPropertyValidator(properties).assertSuccess(), { CertificateArn: cdk.stringToCloudFormation(properties.certificateArn), EncryptionContractConfiguration: cfnOriginEndpointEncryptionContractConfigurationPropertyToCloudFormation(properties.encryptionContractConfiguration), ResourceId: cdk.stringToCloudFormation(properties.resourceId), RoleArn: cdk.stringToCloudFormation(properties.roleArn), SystemIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.systemIds), Url: cdk.stringToCloudFormation(properties.url) }) : properties;
    }
    function CfnOriginEndpointSpekeKeyProviderPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificateArn", "CertificateArn", properties.CertificateArn != null ? cfn_parse.FromCloudFormation.getString(properties.CertificateArn) : void 0), ret.addPropertyResult("encryptionContractConfiguration", "EncryptionContractConfiguration", properties.EncryptionContractConfiguration != null ? CfnOriginEndpointEncryptionContractConfigurationPropertyFromCloudFormation(properties.EncryptionContractConfiguration) : void 0), ret.addPropertyResult("resourceId", "ResourceId", cfn_parse.FromCloudFormation.getString(properties.ResourceId)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("systemIds", "SystemIds", cfn_parse.FromCloudFormation.getStringArray(properties.SystemIds)), ret.addPropertyResult("url", "Url", cfn_parse.FromCloudFormation.getString(properties.Url)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnOriginEndpoint_StreamSelectionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxVideoBitsPerSecond", cdk.validateNumber)(properties.maxVideoBitsPerSecond)), errors.collect(cdk.propertyValidator("minVideoBitsPerSecond", cdk.validateNumber)(properties.minVideoBitsPerSecond)), errors.collect(cdk.propertyValidator("streamOrder", cdk.validateString)(properties.streamOrder)), errors.wrap('supplied properties not correct for "StreamSelectionProperty"');
    }
    function cfnOriginEndpointStreamSelectionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOriginEndpoint_StreamSelectionPropertyValidator(properties).assertSuccess(), { MaxVideoBitsPerSecond: cdk.numberToCloudFormation(properties.maxVideoBitsPerSecond), MinVideoBitsPerSecond: cdk.numberToCloudFormation(properties.minVideoBitsPerSecond), StreamOrder: cdk.stringToCloudFormation(properties.streamOrder) }) : properties;
    }
    function CfnOriginEndpointStreamSelectionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxVideoBitsPerSecond", "MaxVideoBitsPerSecond", properties.MaxVideoBitsPerSecond != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxVideoBitsPerSecond) : void 0), ret.addPropertyResult("minVideoBitsPerSecond", "MinVideoBitsPerSecond", properties.MinVideoBitsPerSecond != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinVideoBitsPerSecond) : void 0), ret.addPropertyResult("streamOrder", "StreamOrder", properties.StreamOrder != null ? cfn_parse.FromCloudFormation.getString(properties.StreamOrder) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPackagingConfigurationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cmafPackage", CfnPackagingConfiguration_CmafPackagePropertyValidator)(properties.cmafPackage)), errors.collect(cdk.propertyValidator("dashPackage", CfnPackagingConfiguration_DashPackagePropertyValidator)(properties.dashPackage)), errors.collect(cdk.propertyValidator("hlsPackage", CfnPackagingConfiguration_HlsPackagePropertyValidator)(properties.hlsPackage)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("mssPackage", CfnPackagingConfiguration_MssPackagePropertyValidator)(properties.mssPackage)), errors.collect(cdk.propertyValidator("packagingGroupId", cdk.requiredValidator)(properties.packagingGroupId)), errors.collect(cdk.propertyValidator("packagingGroupId", cdk.validateString)(properties.packagingGroupId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnPackagingConfigurationProps"');
    }
    function cfnPackagingConfigurationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPackagingConfigurationPropsValidator(properties).assertSuccess(), { Id: cdk.stringToCloudFormation(properties.id), PackagingGroupId: cdk.stringToCloudFormation(properties.packagingGroupId), CmafPackage: cfnPackagingConfigurationCmafPackagePropertyToCloudFormation(properties.cmafPackage), DashPackage: cfnPackagingConfigurationDashPackagePropertyToCloudFormation(properties.dashPackage), HlsPackage: cfnPackagingConfigurationHlsPackagePropertyToCloudFormation(properties.hlsPackage), MssPackage: cfnPackagingConfigurationMssPackagePropertyToCloudFormation(properties.mssPackage), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnPackagingConfigurationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("packagingGroupId", "PackagingGroupId", cfn_parse.FromCloudFormation.getString(properties.PackagingGroupId)), ret.addPropertyResult("cmafPackage", "CmafPackage", properties.CmafPackage != null ? CfnPackagingConfigurationCmafPackagePropertyFromCloudFormation(properties.CmafPackage) : void 0), ret.addPropertyResult("dashPackage", "DashPackage", properties.DashPackage != null ? CfnPackagingConfigurationDashPackagePropertyFromCloudFormation(properties.DashPackage) : void 0), ret.addPropertyResult("hlsPackage", "HlsPackage", properties.HlsPackage != null ? CfnPackagingConfigurationHlsPackagePropertyFromCloudFormation(properties.HlsPackage) : void 0), ret.addPropertyResult("mssPackage", "MssPackage", properties.MssPackage != null ? CfnPackagingConfigurationMssPackagePropertyFromCloudFormation(properties.MssPackage) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPackagingConfiguration = class _CfnPackagingConfiguration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPackagingConfigurationPropsFromCloudFormation(resourceProperties), ret = new _CfnPackagingConfiguration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPackagingConfiguration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_mediapackage_CfnPackagingConfigurationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPackagingConfiguration), error;
        }
        cdk.requireProperty(props, "id", this), cdk.requireProperty(props, "packagingGroupId", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.id = props.id, this.packagingGroupId = props.packagingGroupId, this.cmafPackage = props.cmafPackage, this.dashPackage = props.dashPackage, this.hlsPackage = props.hlsPackage, this.mssPackage = props.mssPackage, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::MediaPackage::PackagingConfiguration", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPackagingConfiguration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { id: this.id, packagingGroupId: this.packagingGroupId, cmafPackage: this.cmafPackage, dashPackage: this.dashPackage, hlsPackage: this.hlsPackage, mssPackage: this.mssPackage, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnPackagingConfigurationPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnPackagingConfiguration[_d] = { fqn: "aws-cdk-lib.aws_mediapackage.CfnPackagingConfiguration", version: "2.80.0" }, CfnPackagingConfiguration.CFN_RESOURCE_TYPE_NAME = "AWS::MediaPackage::PackagingConfiguration", exports2.CfnPackagingConfiguration = CfnPackagingConfiguration;
    function CfnPackagingConfiguration_CmafEncryptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("spekeKeyProvider", cdk.requiredValidator)(properties.spekeKeyProvider)), errors.collect(cdk.propertyValidator("spekeKeyProvider", CfnPackagingConfiguration_SpekeKeyProviderPropertyValidator)(properties.spekeKeyProvider)), errors.wrap('supplied properties not correct for "CmafEncryptionProperty"');
    }
    function cfnPackagingConfigurationCmafEncryptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPackagingConfiguration_CmafEncryptionPropertyValidator(properties).assertSuccess(), { SpekeKeyProvider: cfnPackagingConfigurationSpekeKeyProviderPropertyToCloudFormation(properties.spekeKeyProvider) }) : properties;
    }
    function CfnPackagingConfigurationCmafEncryptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("spekeKeyProvider", "SpekeKeyProvider", CfnPackagingConfigurationSpekeKeyProviderPropertyFromCloudFormation(properties.SpekeKeyProvider)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPackagingConfiguration_CmafPackagePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("encryption", CfnPackagingConfiguration_CmafEncryptionPropertyValidator)(properties.encryption)), errors.collect(cdk.propertyValidator("hlsManifests", cdk.requiredValidator)(properties.hlsManifests)), errors.collect(cdk.propertyValidator("hlsManifests", cdk.listValidator(CfnPackagingConfiguration_HlsManifestPropertyValidator))(properties.hlsManifests)), errors.collect(cdk.propertyValidator("includeEncoderConfigurationInSegments", cdk.validateBoolean)(properties.includeEncoderConfigurationInSegments)), errors.collect(cdk.propertyValidator("segmentDurationSeconds", cdk.validateNumber)(properties.segmentDurationSeconds)), errors.wrap('supplied properties not correct for "CmafPackageProperty"');
    }
    function cfnPackagingConfigurationCmafPackagePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPackagingConfiguration_CmafPackagePropertyValidator(properties).assertSuccess(), { Encryption: cfnPackagingConfigurationCmafEncryptionPropertyToCloudFormation(properties.encryption), HlsManifests: cdk.listMapper(cfnPackagingConfigurationHlsManifestPropertyToCloudFormation)(properties.hlsManifests), IncludeEncoderConfigurationInSegments: cdk.booleanToCloudFormation(properties.includeEncoderConfigurationInSegments), SegmentDurationSeconds: cdk.numberToCloudFormation(properties.segmentDurationSeconds) }) : properties;
    }
    function CfnPackagingConfigurationCmafPackagePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("encryption", "Encryption", properties.Encryption != null ? CfnPackagingConfigurationCmafEncryptionPropertyFromCloudFormation(properties.Encryption) : void 0), ret.addPropertyResult("hlsManifests", "HlsManifests", cfn_parse.FromCloudFormation.getArray(CfnPackagingConfigurationHlsManifestPropertyFromCloudFormation)(properties.HlsManifests)), ret.addPropertyResult("includeEncoderConfigurationInSegments", "IncludeEncoderConfigurationInSegments", properties.IncludeEncoderConfigurationInSegments != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeEncoderConfigurationInSegments) : void 0), ret.addPropertyResult("segmentDurationSeconds", "SegmentDurationSeconds", properties.SegmentDurationSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.SegmentDurationSeconds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPackagingConfiguration_DashEncryptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("spekeKeyProvider", cdk.requiredValidator)(properties.spekeKeyProvider)), errors.collect(cdk.propertyValidator("spekeKeyProvider", CfnPackagingConfiguration_SpekeKeyProviderPropertyValidator)(properties.spekeKeyProvider)), errors.wrap('supplied properties not correct for "DashEncryptionProperty"');
    }
    function cfnPackagingConfigurationDashEncryptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPackagingConfiguration_DashEncryptionPropertyValidator(properties).assertSuccess(), { SpekeKeyProvider: cfnPackagingConfigurationSpekeKeyProviderPropertyToCloudFormation(properties.spekeKeyProvider) }) : properties;
    }
    function CfnPackagingConfigurationDashEncryptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("spekeKeyProvider", "SpekeKeyProvider", CfnPackagingConfigurationSpekeKeyProviderPropertyFromCloudFormation(properties.SpekeKeyProvider)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPackagingConfiguration_DashManifestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("manifestLayout", cdk.validateString)(properties.manifestLayout)), errors.collect(cdk.propertyValidator("manifestName", cdk.validateString)(properties.manifestName)), errors.collect(cdk.propertyValidator("minBufferTimeSeconds", cdk.validateNumber)(properties.minBufferTimeSeconds)), errors.collect(cdk.propertyValidator("profile", cdk.validateString)(properties.profile)), errors.collect(cdk.propertyValidator("scteMarkersSource", cdk.validateString)(properties.scteMarkersSource)), errors.collect(cdk.propertyValidator("streamSelection", CfnPackagingConfiguration_StreamSelectionPropertyValidator)(properties.streamSelection)), errors.wrap('supplied properties not correct for "DashManifestProperty"');
    }
    function cfnPackagingConfigurationDashManifestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPackagingConfiguration_DashManifestPropertyValidator(properties).assertSuccess(), { ManifestLayout: cdk.stringToCloudFormation(properties.manifestLayout), ManifestName: cdk.stringToCloudFormation(properties.manifestName), MinBufferTimeSeconds: cdk.numberToCloudFormation(properties.minBufferTimeSeconds), Profile: cdk.stringToCloudFormation(properties.profile), ScteMarkersSource: cdk.stringToCloudFormation(properties.scteMarkersSource), StreamSelection: cfnPackagingConfigurationStreamSelectionPropertyToCloudFormation(properties.streamSelection) }) : properties;
    }
    function CfnPackagingConfigurationDashManifestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("manifestLayout", "ManifestLayout", properties.ManifestLayout != null ? cfn_parse.FromCloudFormation.getString(properties.ManifestLayout) : void 0), ret.addPropertyResult("manifestName", "ManifestName", properties.ManifestName != null ? cfn_parse.FromCloudFormation.getString(properties.ManifestName) : void 0), ret.addPropertyResult("minBufferTimeSeconds", "MinBufferTimeSeconds", properties.MinBufferTimeSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinBufferTimeSeconds) : void 0), ret.addPropertyResult("profile", "Profile", properties.Profile != null ? cfn_parse.FromCloudFormation.getString(properties.Profile) : void 0), ret.addPropertyResult("scteMarkersSource", "ScteMarkersSource", properties.ScteMarkersSource != null ? cfn_parse.FromCloudFormation.getString(properties.ScteMarkersSource) : void 0), ret.addPropertyResult("streamSelection", "StreamSelection", properties.StreamSelection != null ? CfnPackagingConfigurationStreamSelectionPropertyFromCloudFormation(properties.StreamSelection) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPackagingConfiguration_DashPackagePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dashManifests", cdk.requiredValidator)(properties.dashManifests)), errors.collect(cdk.propertyValidator("dashManifests", cdk.listValidator(CfnPackagingConfiguration_DashManifestPropertyValidator))(properties.dashManifests)), errors.collect(cdk.propertyValidator("encryption", CfnPackagingConfiguration_DashEncryptionPropertyValidator)(properties.encryption)), errors.collect(cdk.propertyValidator("includeEncoderConfigurationInSegments", cdk.validateBoolean)(properties.includeEncoderConfigurationInSegments)), errors.collect(cdk.propertyValidator("includeIframeOnlyStream", cdk.validateBoolean)(properties.includeIframeOnlyStream)), errors.collect(cdk.propertyValidator("periodTriggers", cdk.listValidator(cdk.validateString))(properties.periodTriggers)), errors.collect(cdk.propertyValidator("segmentDurationSeconds", cdk.validateNumber)(properties.segmentDurationSeconds)), errors.collect(cdk.propertyValidator("segmentTemplateFormat", cdk.validateString)(properties.segmentTemplateFormat)), errors.wrap('supplied properties not correct for "DashPackageProperty"');
    }
    function cfnPackagingConfigurationDashPackagePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPackagingConfiguration_DashPackagePropertyValidator(properties).assertSuccess(), { DashManifests: cdk.listMapper(cfnPackagingConfigurationDashManifestPropertyToCloudFormation)(properties.dashManifests), Encryption: cfnPackagingConfigurationDashEncryptionPropertyToCloudFormation(properties.encryption), IncludeEncoderConfigurationInSegments: cdk.booleanToCloudFormation(properties.includeEncoderConfigurationInSegments), IncludeIframeOnlyStream: cdk.booleanToCloudFormation(properties.includeIframeOnlyStream), PeriodTriggers: cdk.listMapper(cdk.stringToCloudFormation)(properties.periodTriggers), SegmentDurationSeconds: cdk.numberToCloudFormation(properties.segmentDurationSeconds), SegmentTemplateFormat: cdk.stringToCloudFormation(properties.segmentTemplateFormat) }) : properties;
    }
    function CfnPackagingConfigurationDashPackagePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dashManifests", "DashManifests", cfn_parse.FromCloudFormation.getArray(CfnPackagingConfigurationDashManifestPropertyFromCloudFormation)(properties.DashManifests)), ret.addPropertyResult("encryption", "Encryption", properties.Encryption != null ? CfnPackagingConfigurationDashEncryptionPropertyFromCloudFormation(properties.Encryption) : void 0), ret.addPropertyResult("includeEncoderConfigurationInSegments", "IncludeEncoderConfigurationInSegments", properties.IncludeEncoderConfigurationInSegments != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeEncoderConfigurationInSegments) : void 0), ret.addPropertyResult("includeIframeOnlyStream", "IncludeIframeOnlyStream", properties.IncludeIframeOnlyStream != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeIframeOnlyStream) : void 0), ret.addPropertyResult("periodTriggers", "PeriodTriggers", properties.PeriodTriggers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.PeriodTriggers) : void 0), ret.addPropertyResult("segmentDurationSeconds", "SegmentDurationSeconds", properties.SegmentDurationSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.SegmentDurationSeconds) : void 0), ret.addPropertyResult("segmentTemplateFormat", "SegmentTemplateFormat", properties.SegmentTemplateFormat != null ? cfn_parse.FromCloudFormation.getString(properties.SegmentTemplateFormat) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPackagingConfiguration_EncryptionContractConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.wrap('supplied properties not correct for "EncryptionContractConfigurationProperty"');
    }
    function cfnPackagingConfigurationEncryptionContractConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPackagingConfiguration_EncryptionContractConfigurationPropertyValidator(properties).assertSuccess(), {}) : properties;
    }
    function CfnPackagingConfigurationEncryptionContractConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPackagingConfiguration_HlsEncryptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("constantInitializationVector", cdk.validateString)(properties.constantInitializationVector)), errors.collect(cdk.propertyValidator("encryptionMethod", cdk.validateString)(properties.encryptionMethod)), errors.collect(cdk.propertyValidator("spekeKeyProvider", cdk.requiredValidator)(properties.spekeKeyProvider)), errors.collect(cdk.propertyValidator("spekeKeyProvider", CfnPackagingConfiguration_SpekeKeyProviderPropertyValidator)(properties.spekeKeyProvider)), errors.wrap('supplied properties not correct for "HlsEncryptionProperty"');
    }
    function cfnPackagingConfigurationHlsEncryptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPackagingConfiguration_HlsEncryptionPropertyValidator(properties).assertSuccess(), { ConstantInitializationVector: cdk.stringToCloudFormation(properties.constantInitializationVector), EncryptionMethod: cdk.stringToCloudFormation(properties.encryptionMethod), SpekeKeyProvider: cfnPackagingConfigurationSpekeKeyProviderPropertyToCloudFormation(properties.spekeKeyProvider) }) : properties;
    }
    function CfnPackagingConfigurationHlsEncryptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("constantInitializationVector", "ConstantInitializationVector", properties.ConstantInitializationVector != null ? cfn_parse.FromCloudFormation.getString(properties.ConstantInitializationVector) : void 0), ret.addPropertyResult("encryptionMethod", "EncryptionMethod", properties.EncryptionMethod != null ? cfn_parse.FromCloudFormation.getString(properties.EncryptionMethod) : void 0), ret.addPropertyResult("spekeKeyProvider", "SpekeKeyProvider", CfnPackagingConfigurationSpekeKeyProviderPropertyFromCloudFormation(properties.SpekeKeyProvider)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPackagingConfiguration_HlsManifestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("adMarkers", cdk.validateString)(properties.adMarkers)), errors.collect(cdk.propertyValidator("includeIframeOnlyStream", cdk.validateBoolean)(properties.includeIframeOnlyStream)), errors.collect(cdk.propertyValidator("manifestName", cdk.validateString)(properties.manifestName)), errors.collect(cdk.propertyValidator("programDateTimeIntervalSeconds", cdk.validateNumber)(properties.programDateTimeIntervalSeconds)), errors.collect(cdk.propertyValidator("repeatExtXKey", cdk.validateBoolean)(properties.repeatExtXKey)), errors.collect(cdk.propertyValidator("streamSelection", CfnPackagingConfiguration_StreamSelectionPropertyValidator)(properties.streamSelection)), errors.wrap('supplied properties not correct for "HlsManifestProperty"');
    }
    function cfnPackagingConfigurationHlsManifestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPackagingConfiguration_HlsManifestPropertyValidator(properties).assertSuccess(), { AdMarkers: cdk.stringToCloudFormation(properties.adMarkers), IncludeIframeOnlyStream: cdk.booleanToCloudFormation(properties.includeIframeOnlyStream), ManifestName: cdk.stringToCloudFormation(properties.manifestName), ProgramDateTimeIntervalSeconds: cdk.numberToCloudFormation(properties.programDateTimeIntervalSeconds), RepeatExtXKey: cdk.booleanToCloudFormation(properties.repeatExtXKey), StreamSelection: cfnPackagingConfigurationStreamSelectionPropertyToCloudFormation(properties.streamSelection) }) : properties;
    }
    function CfnPackagingConfigurationHlsManifestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("adMarkers", "AdMarkers", properties.AdMarkers != null ? cfn_parse.FromCloudFormation.getString(properties.AdMarkers) : void 0), ret.addPropertyResult("includeIframeOnlyStream", "IncludeIframeOnlyStream", properties.IncludeIframeOnlyStream != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeIframeOnlyStream) : void 0), ret.addPropertyResult("manifestName", "ManifestName", properties.ManifestName != null ? cfn_parse.FromCloudFormation.getString(properties.ManifestName) : void 0), ret.addPropertyResult("programDateTimeIntervalSeconds", "ProgramDateTimeIntervalSeconds", properties.ProgramDateTimeIntervalSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.ProgramDateTimeIntervalSeconds) : void 0), ret.addPropertyResult("repeatExtXKey", "RepeatExtXKey", properties.RepeatExtXKey != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RepeatExtXKey) : void 0), ret.addPropertyResult("streamSelection", "StreamSelection", properties.StreamSelection != null ? CfnPackagingConfigurationStreamSelectionPropertyFromCloudFormation(properties.StreamSelection) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPackagingConfiguration_HlsPackagePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("encryption", CfnPackagingConfiguration_HlsEncryptionPropertyValidator)(properties.encryption)), errors.collect(cdk.propertyValidator("hlsManifests", cdk.requiredValidator)(properties.hlsManifests)), errors.collect(cdk.propertyValidator("hlsManifests", cdk.listValidator(CfnPackagingConfiguration_HlsManifestPropertyValidator))(properties.hlsManifests)), errors.collect(cdk.propertyValidator("includeDvbSubtitles", cdk.validateBoolean)(properties.includeDvbSubtitles)), errors.collect(cdk.propertyValidator("segmentDurationSeconds", cdk.validateNumber)(properties.segmentDurationSeconds)), errors.collect(cdk.propertyValidator("useAudioRenditionGroup", cdk.validateBoolean)(properties.useAudioRenditionGroup)), errors.wrap('supplied properties not correct for "HlsPackageProperty"');
    }
    function cfnPackagingConfigurationHlsPackagePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPackagingConfiguration_HlsPackagePropertyValidator(properties).assertSuccess(), { Encryption: cfnPackagingConfigurationHlsEncryptionPropertyToCloudFormation(properties.encryption), HlsManifests: cdk.listMapper(cfnPackagingConfigurationHlsManifestPropertyToCloudFormation)(properties.hlsManifests), IncludeDvbSubtitles: cdk.booleanToCloudFormation(properties.includeDvbSubtitles), SegmentDurationSeconds: cdk.numberToCloudFormation(properties.segmentDurationSeconds), UseAudioRenditionGroup: cdk.booleanToCloudFormation(properties.useAudioRenditionGroup) }) : properties;
    }
    function CfnPackagingConfigurationHlsPackagePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("encryption", "Encryption", properties.Encryption != null ? CfnPackagingConfigurationHlsEncryptionPropertyFromCloudFormation(properties.Encryption) : void 0), ret.addPropertyResult("hlsManifests", "HlsManifests", cfn_parse.FromCloudFormation.getArray(CfnPackagingConfigurationHlsManifestPropertyFromCloudFormation)(properties.HlsManifests)), ret.addPropertyResult("includeDvbSubtitles", "IncludeDvbSubtitles", properties.IncludeDvbSubtitles != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeDvbSubtitles) : void 0), ret.addPropertyResult("segmentDurationSeconds", "SegmentDurationSeconds", properties.SegmentDurationSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.SegmentDurationSeconds) : void 0), ret.addPropertyResult("useAudioRenditionGroup", "UseAudioRenditionGroup", properties.UseAudioRenditionGroup != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseAudioRenditionGroup) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPackagingConfiguration_MssEncryptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("spekeKeyProvider", cdk.requiredValidator)(properties.spekeKeyProvider)), errors.collect(cdk.propertyValidator("spekeKeyProvider", CfnPackagingConfiguration_SpekeKeyProviderPropertyValidator)(properties.spekeKeyProvider)), errors.wrap('supplied properties not correct for "MssEncryptionProperty"');
    }
    function cfnPackagingConfigurationMssEncryptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPackagingConfiguration_MssEncryptionPropertyValidator(properties).assertSuccess(), { SpekeKeyProvider: cfnPackagingConfigurationSpekeKeyProviderPropertyToCloudFormation(properties.spekeKeyProvider) }) : properties;
    }
    function CfnPackagingConfigurationMssEncryptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("spekeKeyProvider", "SpekeKeyProvider", CfnPackagingConfigurationSpekeKeyProviderPropertyFromCloudFormation(properties.SpekeKeyProvider)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPackagingConfiguration_MssManifestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("manifestName", cdk.validateString)(properties.manifestName)), errors.collect(cdk.propertyValidator("streamSelection", CfnPackagingConfiguration_StreamSelectionPropertyValidator)(properties.streamSelection)), errors.wrap('supplied properties not correct for "MssManifestProperty"');
    }
    function cfnPackagingConfigurationMssManifestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPackagingConfiguration_MssManifestPropertyValidator(properties).assertSuccess(), { ManifestName: cdk.stringToCloudFormation(properties.manifestName), StreamSelection: cfnPackagingConfigurationStreamSelectionPropertyToCloudFormation(properties.streamSelection) }) : properties;
    }
    function CfnPackagingConfigurationMssManifestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("manifestName", "ManifestName", properties.ManifestName != null ? cfn_parse.FromCloudFormation.getString(properties.ManifestName) : void 0), ret.addPropertyResult("streamSelection", "StreamSelection", properties.StreamSelection != null ? CfnPackagingConfigurationStreamSelectionPropertyFromCloudFormation(properties.StreamSelection) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPackagingConfiguration_MssPackagePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("encryption", CfnPackagingConfiguration_MssEncryptionPropertyValidator)(properties.encryption)), errors.collect(cdk.propertyValidator("mssManifests", cdk.requiredValidator)(properties.mssManifests)), errors.collect(cdk.propertyValidator("mssManifests", cdk.listValidator(CfnPackagingConfiguration_MssManifestPropertyValidator))(properties.mssManifests)), errors.collect(cdk.propertyValidator("segmentDurationSeconds", cdk.validateNumber)(properties.segmentDurationSeconds)), errors.wrap('supplied properties not correct for "MssPackageProperty"');
    }
    function cfnPackagingConfigurationMssPackagePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPackagingConfiguration_MssPackagePropertyValidator(properties).assertSuccess(), { Encryption: cfnPackagingConfigurationMssEncryptionPropertyToCloudFormation(properties.encryption), MssManifests: cdk.listMapper(cfnPackagingConfigurationMssManifestPropertyToCloudFormation)(properties.mssManifests), SegmentDurationSeconds: cdk.numberToCloudFormation(properties.segmentDurationSeconds) }) : properties;
    }
    function CfnPackagingConfigurationMssPackagePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("encryption", "Encryption", properties.Encryption != null ? CfnPackagingConfigurationMssEncryptionPropertyFromCloudFormation(properties.Encryption) : void 0), ret.addPropertyResult("mssManifests", "MssManifests", cfn_parse.FromCloudFormation.getArray(CfnPackagingConfigurationMssManifestPropertyFromCloudFormation)(properties.MssManifests)), ret.addPropertyResult("segmentDurationSeconds", "SegmentDurationSeconds", properties.SegmentDurationSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.SegmentDurationSeconds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPackagingConfiguration_SpekeKeyProviderPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("encryptionContractConfiguration", CfnPackagingConfiguration_EncryptionContractConfigurationPropertyValidator)(properties.encryptionContractConfiguration)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("systemIds", cdk.requiredValidator)(properties.systemIds)), errors.collect(cdk.propertyValidator("systemIds", cdk.listValidator(cdk.validateString))(properties.systemIds)), errors.collect(cdk.propertyValidator("url", cdk.requiredValidator)(properties.url)), errors.collect(cdk.propertyValidator("url", cdk.validateString)(properties.url)), errors.wrap('supplied properties not correct for "SpekeKeyProviderProperty"');
    }
    function cfnPackagingConfigurationSpekeKeyProviderPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPackagingConfiguration_SpekeKeyProviderPropertyValidator(properties).assertSuccess(), { EncryptionContractConfiguration: cfnPackagingConfigurationEncryptionContractConfigurationPropertyToCloudFormation(properties.encryptionContractConfiguration), RoleArn: cdk.stringToCloudFormation(properties.roleArn), SystemIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.systemIds), Url: cdk.stringToCloudFormation(properties.url) }) : properties;
    }
    function CfnPackagingConfigurationSpekeKeyProviderPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("encryptionContractConfiguration", "EncryptionContractConfiguration", properties.EncryptionContractConfiguration != null ? CfnPackagingConfigurationEncryptionContractConfigurationPropertyFromCloudFormation(properties.EncryptionContractConfiguration) : void 0), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("systemIds", "SystemIds", cfn_parse.FromCloudFormation.getStringArray(properties.SystemIds)), ret.addPropertyResult("url", "Url", cfn_parse.FromCloudFormation.getString(properties.Url)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPackagingConfiguration_StreamSelectionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxVideoBitsPerSecond", cdk.validateNumber)(properties.maxVideoBitsPerSecond)), errors.collect(cdk.propertyValidator("minVideoBitsPerSecond", cdk.validateNumber)(properties.minVideoBitsPerSecond)), errors.collect(cdk.propertyValidator("streamOrder", cdk.validateString)(properties.streamOrder)), errors.wrap('supplied properties not correct for "StreamSelectionProperty"');
    }
    function cfnPackagingConfigurationStreamSelectionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPackagingConfiguration_StreamSelectionPropertyValidator(properties).assertSuccess(), { MaxVideoBitsPerSecond: cdk.numberToCloudFormation(properties.maxVideoBitsPerSecond), MinVideoBitsPerSecond: cdk.numberToCloudFormation(properties.minVideoBitsPerSecond), StreamOrder: cdk.stringToCloudFormation(properties.streamOrder) }) : properties;
    }
    function CfnPackagingConfigurationStreamSelectionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxVideoBitsPerSecond", "MaxVideoBitsPerSecond", properties.MaxVideoBitsPerSecond != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxVideoBitsPerSecond) : void 0), ret.addPropertyResult("minVideoBitsPerSecond", "MinVideoBitsPerSecond", properties.MinVideoBitsPerSecond != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinVideoBitsPerSecond) : void 0), ret.addPropertyResult("streamOrder", "StreamOrder", properties.StreamOrder != null ? cfn_parse.FromCloudFormation.getString(properties.StreamOrder) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPackagingGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authorization", CfnPackagingGroup_AuthorizationPropertyValidator)(properties.authorization)), errors.collect(cdk.propertyValidator("egressAccessLogs", CfnPackagingGroup_LogConfigurationPropertyValidator)(properties.egressAccessLogs)), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnPackagingGroupProps"');
    }
    function cfnPackagingGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPackagingGroupPropsValidator(properties).assertSuccess(), { Id: cdk.stringToCloudFormation(properties.id), Authorization: cfnPackagingGroupAuthorizationPropertyToCloudFormation(properties.authorization), EgressAccessLogs: cfnPackagingGroupLogConfigurationPropertyToCloudFormation(properties.egressAccessLogs), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnPackagingGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("authorization", "Authorization", properties.Authorization != null ? CfnPackagingGroupAuthorizationPropertyFromCloudFormation(properties.Authorization) : void 0), ret.addPropertyResult("egressAccessLogs", "EgressAccessLogs", properties.EgressAccessLogs != null ? CfnPackagingGroupLogConfigurationPropertyFromCloudFormation(properties.EgressAccessLogs) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPackagingGroup = class _CfnPackagingGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPackagingGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnPackagingGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPackagingGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_mediapackage_CfnPackagingGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPackagingGroup), error;
        }
        cdk.requireProperty(props, "id", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrDomainName = cdk.Token.asString(this.getAtt("DomainName", cdk.ResolutionTypeHint.STRING)), this.id = props.id, this.authorization = props.authorization, this.egressAccessLogs = props.egressAccessLogs, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::MediaPackage::PackagingGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPackagingGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { id: this.id, authorization: this.authorization, egressAccessLogs: this.egressAccessLogs, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnPackagingGroupPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnPackagingGroup[_e] = { fqn: "aws-cdk-lib.aws_mediapackage.CfnPackagingGroup", version: "2.80.0" }, CfnPackagingGroup.CFN_RESOURCE_TYPE_NAME = "AWS::MediaPackage::PackagingGroup", exports2.CfnPackagingGroup = CfnPackagingGroup;
    function CfnPackagingGroup_AuthorizationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cdnIdentifierSecret", cdk.requiredValidator)(properties.cdnIdentifierSecret)), errors.collect(cdk.propertyValidator("cdnIdentifierSecret", cdk.validateString)(properties.cdnIdentifierSecret)), errors.collect(cdk.propertyValidator("secretsRoleArn", cdk.requiredValidator)(properties.secretsRoleArn)), errors.collect(cdk.propertyValidator("secretsRoleArn", cdk.validateString)(properties.secretsRoleArn)), errors.wrap('supplied properties not correct for "AuthorizationProperty"');
    }
    function cfnPackagingGroupAuthorizationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPackagingGroup_AuthorizationPropertyValidator(properties).assertSuccess(), { CdnIdentifierSecret: cdk.stringToCloudFormation(properties.cdnIdentifierSecret), SecretsRoleArn: cdk.stringToCloudFormation(properties.secretsRoleArn) }) : properties;
    }
    function CfnPackagingGroupAuthorizationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cdnIdentifierSecret", "CdnIdentifierSecret", cfn_parse.FromCloudFormation.getString(properties.CdnIdentifierSecret)), ret.addPropertyResult("secretsRoleArn", "SecretsRoleArn", cfn_parse.FromCloudFormation.getString(properties.SecretsRoleArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPackagingGroup_LogConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logGroupName", cdk.validateString)(properties.logGroupName)), errors.wrap('supplied properties not correct for "LogConfigurationProperty"');
    }
    function cfnPackagingGroupLogConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPackagingGroup_LogConfigurationPropertyValidator(properties).assertSuccess(), { LogGroupName: cdk.stringToCloudFormation(properties.logGroupName) }) : properties;
    }
    function CfnPackagingGroupLogConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logGroupName", "LogGroupName", properties.LogGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.LogGroupName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-mediapackage/lib/index.js
var require_lib189 = __commonJS({
  "node_modules/aws-cdk-lib/aws-mediapackage/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_mediapackage_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-mediapackage/index.js
var require_aws_mediapackage = __commonJS({
  "node_modules/aws-cdk-lib/aws-mediapackage/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib189(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-mediastore/lib/mediastore.generated.js
var require_mediastore_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-mediastore/lib/mediastore.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnContainer = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnContainerPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessLoggingEnabled", cdk.validateBoolean)(properties.accessLoggingEnabled)), errors.collect(cdk.propertyValidator("containerName", cdk.requiredValidator)(properties.containerName)), errors.collect(cdk.propertyValidator("containerName", cdk.validateString)(properties.containerName)), errors.collect(cdk.propertyValidator("corsPolicy", cdk.listValidator(CfnContainer_CorsRulePropertyValidator))(properties.corsPolicy)), errors.collect(cdk.propertyValidator("lifecyclePolicy", cdk.validateString)(properties.lifecyclePolicy)), errors.collect(cdk.propertyValidator("metricPolicy", CfnContainer_MetricPolicyPropertyValidator)(properties.metricPolicy)), errors.collect(cdk.propertyValidator("policy", cdk.validateString)(properties.policy)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnContainerProps"');
    }
    function cfnContainerPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContainerPropsValidator(properties).assertSuccess(), { ContainerName: cdk.stringToCloudFormation(properties.containerName), AccessLoggingEnabled: cdk.booleanToCloudFormation(properties.accessLoggingEnabled), CorsPolicy: cdk.listMapper(cfnContainerCorsRulePropertyToCloudFormation)(properties.corsPolicy), LifecyclePolicy: cdk.stringToCloudFormation(properties.lifecyclePolicy), MetricPolicy: cfnContainerMetricPolicyPropertyToCloudFormation(properties.metricPolicy), Policy: cdk.stringToCloudFormation(properties.policy), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnContainerPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containerName", "ContainerName", cfn_parse.FromCloudFormation.getString(properties.ContainerName)), ret.addPropertyResult("accessLoggingEnabled", "AccessLoggingEnabled", properties.AccessLoggingEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AccessLoggingEnabled) : void 0), ret.addPropertyResult("corsPolicy", "CorsPolicy", properties.CorsPolicy != null ? cfn_parse.FromCloudFormation.getArray(CfnContainerCorsRulePropertyFromCloudFormation)(properties.CorsPolicy) : void 0), ret.addPropertyResult("lifecyclePolicy", "LifecyclePolicy", properties.LifecyclePolicy != null ? cfn_parse.FromCloudFormation.getString(properties.LifecyclePolicy) : void 0), ret.addPropertyResult("metricPolicy", "MetricPolicy", properties.MetricPolicy != null ? CfnContainerMetricPolicyPropertyFromCloudFormation(properties.MetricPolicy) : void 0), ret.addPropertyResult("policy", "Policy", properties.Policy != null ? cfn_parse.FromCloudFormation.getString(properties.Policy) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnContainer = class _CfnContainer extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnContainerPropsFromCloudFormation(resourceProperties), ret = new _CfnContainer(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnContainer.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_mediastore_CfnContainerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnContainer), error;
        }
        cdk.requireProperty(props, "containerName", this), this.attrEndpoint = cdk.Token.asString(this.getAtt("Endpoint", cdk.ResolutionTypeHint.STRING)), this.containerName = props.containerName, this.accessLoggingEnabled = props.accessLoggingEnabled, this.corsPolicy = props.corsPolicy, this.lifecyclePolicy = props.lifecyclePolicy, this.metricPolicy = props.metricPolicy, this.policy = props.policy, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::MediaStore::Container", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnContainer.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { containerName: this.containerName, accessLoggingEnabled: this.accessLoggingEnabled, corsPolicy: this.corsPolicy, lifecyclePolicy: this.lifecyclePolicy, metricPolicy: this.metricPolicy, policy: this.policy, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnContainerPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnContainer[_a] = { fqn: "aws-cdk-lib.aws_mediastore.CfnContainer", version: "2.80.0" }, CfnContainer.CFN_RESOURCE_TYPE_NAME = "AWS::MediaStore::Container", exports2.CfnContainer = CfnContainer;
    function CfnContainer_CorsRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowedHeaders", cdk.listValidator(cdk.validateString))(properties.allowedHeaders)), errors.collect(cdk.propertyValidator("allowedMethods", cdk.listValidator(cdk.validateString))(properties.allowedMethods)), errors.collect(cdk.propertyValidator("allowedOrigins", cdk.listValidator(cdk.validateString))(properties.allowedOrigins)), errors.collect(cdk.propertyValidator("exposeHeaders", cdk.listValidator(cdk.validateString))(properties.exposeHeaders)), errors.collect(cdk.propertyValidator("maxAgeSeconds", cdk.validateNumber)(properties.maxAgeSeconds)), errors.wrap('supplied properties not correct for "CorsRuleProperty"');
    }
    function cfnContainerCorsRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContainer_CorsRulePropertyValidator(properties).assertSuccess(), { AllowedHeaders: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowedHeaders), AllowedMethods: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowedMethods), AllowedOrigins: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowedOrigins), ExposeHeaders: cdk.listMapper(cdk.stringToCloudFormation)(properties.exposeHeaders), MaxAgeSeconds: cdk.numberToCloudFormation(properties.maxAgeSeconds) }) : properties;
    }
    function CfnContainerCorsRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowedHeaders", "AllowedHeaders", properties.AllowedHeaders != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AllowedHeaders) : void 0), ret.addPropertyResult("allowedMethods", "AllowedMethods", properties.AllowedMethods != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AllowedMethods) : void 0), ret.addPropertyResult("allowedOrigins", "AllowedOrigins", properties.AllowedOrigins != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AllowedOrigins) : void 0), ret.addPropertyResult("exposeHeaders", "ExposeHeaders", properties.ExposeHeaders != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExposeHeaders) : void 0), ret.addPropertyResult("maxAgeSeconds", "MaxAgeSeconds", properties.MaxAgeSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxAgeSeconds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnContainer_MetricPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containerLevelMetrics", cdk.requiredValidator)(properties.containerLevelMetrics)), errors.collect(cdk.propertyValidator("containerLevelMetrics", cdk.validateString)(properties.containerLevelMetrics)), errors.collect(cdk.propertyValidator("metricPolicyRules", cdk.listValidator(CfnContainer_MetricPolicyRulePropertyValidator))(properties.metricPolicyRules)), errors.wrap('supplied properties not correct for "MetricPolicyProperty"');
    }
    function cfnContainerMetricPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContainer_MetricPolicyPropertyValidator(properties).assertSuccess(), { ContainerLevelMetrics: cdk.stringToCloudFormation(properties.containerLevelMetrics), MetricPolicyRules: cdk.listMapper(cfnContainerMetricPolicyRulePropertyToCloudFormation)(properties.metricPolicyRules) }) : properties;
    }
    function CfnContainerMetricPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containerLevelMetrics", "ContainerLevelMetrics", cfn_parse.FromCloudFormation.getString(properties.ContainerLevelMetrics)), ret.addPropertyResult("metricPolicyRules", "MetricPolicyRules", properties.MetricPolicyRules != null ? cfn_parse.FromCloudFormation.getArray(CfnContainerMetricPolicyRulePropertyFromCloudFormation)(properties.MetricPolicyRules) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnContainer_MetricPolicyRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("objectGroup", cdk.requiredValidator)(properties.objectGroup)), errors.collect(cdk.propertyValidator("objectGroup", cdk.validateString)(properties.objectGroup)), errors.collect(cdk.propertyValidator("objectGroupName", cdk.requiredValidator)(properties.objectGroupName)), errors.collect(cdk.propertyValidator("objectGroupName", cdk.validateString)(properties.objectGroupName)), errors.wrap('supplied properties not correct for "MetricPolicyRuleProperty"');
    }
    function cfnContainerMetricPolicyRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContainer_MetricPolicyRulePropertyValidator(properties).assertSuccess(), { ObjectGroup: cdk.stringToCloudFormation(properties.objectGroup), ObjectGroupName: cdk.stringToCloudFormation(properties.objectGroupName) }) : properties;
    }
    function CfnContainerMetricPolicyRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("objectGroup", "ObjectGroup", cfn_parse.FromCloudFormation.getString(properties.ObjectGroup)), ret.addPropertyResult("objectGroupName", "ObjectGroupName", cfn_parse.FromCloudFormation.getString(properties.ObjectGroupName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-mediastore/lib/index.js
var require_lib190 = __commonJS({
  "node_modules/aws-cdk-lib/aws-mediastore/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_mediastore_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-mediastore/index.js
var require_aws_mediastore = __commonJS({
  "node_modules/aws-cdk-lib/aws-mediastore/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib190(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-mediatailor/lib/mediatailor.generated.js
var require_mediatailor_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-mediatailor/lib/mediatailor.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnPlaybackConfiguration = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnPlaybackConfigurationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("adDecisionServerUrl", cdk.requiredValidator)(properties.adDecisionServerUrl)), errors.collect(cdk.propertyValidator("adDecisionServerUrl", cdk.validateString)(properties.adDecisionServerUrl)), errors.collect(cdk.propertyValidator("availSuppression", CfnPlaybackConfiguration_AvailSuppressionPropertyValidator)(properties.availSuppression)), errors.collect(cdk.propertyValidator("bumper", CfnPlaybackConfiguration_BumperPropertyValidator)(properties.bumper)), errors.collect(cdk.propertyValidator("cdnConfiguration", CfnPlaybackConfiguration_CdnConfigurationPropertyValidator)(properties.cdnConfiguration)), errors.collect(cdk.propertyValidator("configurationAliases", cdk.hashValidator(cdk.validateObject))(properties.configurationAliases)), errors.collect(cdk.propertyValidator("dashConfiguration", CfnPlaybackConfiguration_DashConfigurationPropertyValidator)(properties.dashConfiguration)), errors.collect(cdk.propertyValidator("hlsConfiguration", CfnPlaybackConfiguration_HlsConfigurationPropertyValidator)(properties.hlsConfiguration)), errors.collect(cdk.propertyValidator("livePreRollConfiguration", CfnPlaybackConfiguration_LivePreRollConfigurationPropertyValidator)(properties.livePreRollConfiguration)), errors.collect(cdk.propertyValidator("manifestProcessingRules", CfnPlaybackConfiguration_ManifestProcessingRulesPropertyValidator)(properties.manifestProcessingRules)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("personalizationThresholdSeconds", cdk.validateNumber)(properties.personalizationThresholdSeconds)), errors.collect(cdk.propertyValidator("slateAdUrl", cdk.validateString)(properties.slateAdUrl)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("transcodeProfileName", cdk.validateString)(properties.transcodeProfileName)), errors.collect(cdk.propertyValidator("videoContentSourceUrl", cdk.requiredValidator)(properties.videoContentSourceUrl)), errors.collect(cdk.propertyValidator("videoContentSourceUrl", cdk.validateString)(properties.videoContentSourceUrl)), errors.wrap('supplied properties not correct for "CfnPlaybackConfigurationProps"');
    }
    function cfnPlaybackConfigurationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPlaybackConfigurationPropsValidator(properties).assertSuccess(), { AdDecisionServerUrl: cdk.stringToCloudFormation(properties.adDecisionServerUrl), Name: cdk.stringToCloudFormation(properties.name), VideoContentSourceUrl: cdk.stringToCloudFormation(properties.videoContentSourceUrl), AvailSuppression: cfnPlaybackConfigurationAvailSuppressionPropertyToCloudFormation(properties.availSuppression), Bumper: cfnPlaybackConfigurationBumperPropertyToCloudFormation(properties.bumper), CdnConfiguration: cfnPlaybackConfigurationCdnConfigurationPropertyToCloudFormation(properties.cdnConfiguration), ConfigurationAliases: cdk.hashMapper(cdk.objectToCloudFormation)(properties.configurationAliases), DashConfiguration: cfnPlaybackConfigurationDashConfigurationPropertyToCloudFormation(properties.dashConfiguration), HlsConfiguration: cfnPlaybackConfigurationHlsConfigurationPropertyToCloudFormation(properties.hlsConfiguration), LivePreRollConfiguration: cfnPlaybackConfigurationLivePreRollConfigurationPropertyToCloudFormation(properties.livePreRollConfiguration), ManifestProcessingRules: cfnPlaybackConfigurationManifestProcessingRulesPropertyToCloudFormation(properties.manifestProcessingRules), PersonalizationThresholdSeconds: cdk.numberToCloudFormation(properties.personalizationThresholdSeconds), SlateAdUrl: cdk.stringToCloudFormation(properties.slateAdUrl), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TranscodeProfileName: cdk.stringToCloudFormation(properties.transcodeProfileName) }) : properties;
    }
    function CfnPlaybackConfigurationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("adDecisionServerUrl", "AdDecisionServerUrl", cfn_parse.FromCloudFormation.getString(properties.AdDecisionServerUrl)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("videoContentSourceUrl", "VideoContentSourceUrl", cfn_parse.FromCloudFormation.getString(properties.VideoContentSourceUrl)), ret.addPropertyResult("availSuppression", "AvailSuppression", properties.AvailSuppression != null ? CfnPlaybackConfigurationAvailSuppressionPropertyFromCloudFormation(properties.AvailSuppression) : void 0), ret.addPropertyResult("bumper", "Bumper", properties.Bumper != null ? CfnPlaybackConfigurationBumperPropertyFromCloudFormation(properties.Bumper) : void 0), ret.addPropertyResult("cdnConfiguration", "CdnConfiguration", properties.CdnConfiguration != null ? CfnPlaybackConfigurationCdnConfigurationPropertyFromCloudFormation(properties.CdnConfiguration) : void 0), ret.addPropertyResult("configurationAliases", "ConfigurationAliases", properties.ConfigurationAliases != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getAny)(properties.ConfigurationAliases) : void 0), ret.addPropertyResult("dashConfiguration", "DashConfiguration", properties.DashConfiguration != null ? CfnPlaybackConfigurationDashConfigurationPropertyFromCloudFormation(properties.DashConfiguration) : void 0), ret.addPropertyResult("hlsConfiguration", "HlsConfiguration", properties.HlsConfiguration != null ? CfnPlaybackConfigurationHlsConfigurationPropertyFromCloudFormation(properties.HlsConfiguration) : void 0), ret.addPropertyResult("livePreRollConfiguration", "LivePreRollConfiguration", properties.LivePreRollConfiguration != null ? CfnPlaybackConfigurationLivePreRollConfigurationPropertyFromCloudFormation(properties.LivePreRollConfiguration) : void 0), ret.addPropertyResult("manifestProcessingRules", "ManifestProcessingRules", properties.ManifestProcessingRules != null ? CfnPlaybackConfigurationManifestProcessingRulesPropertyFromCloudFormation(properties.ManifestProcessingRules) : void 0), ret.addPropertyResult("personalizationThresholdSeconds", "PersonalizationThresholdSeconds", properties.PersonalizationThresholdSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.PersonalizationThresholdSeconds) : void 0), ret.addPropertyResult("slateAdUrl", "SlateAdUrl", properties.SlateAdUrl != null ? cfn_parse.FromCloudFormation.getString(properties.SlateAdUrl) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("transcodeProfileName", "TranscodeProfileName", properties.TranscodeProfileName != null ? cfn_parse.FromCloudFormation.getString(properties.TranscodeProfileName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPlaybackConfiguration = class _CfnPlaybackConfiguration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPlaybackConfigurationPropsFromCloudFormation(resourceProperties), ret = new _CfnPlaybackConfiguration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPlaybackConfiguration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_mediatailor_CfnPlaybackConfigurationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPlaybackConfiguration), error;
        }
        cdk.requireProperty(props, "adDecisionServerUrl", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "videoContentSourceUrl", this), this.attrDashConfigurationManifestEndpointPrefix = cdk.Token.asString(this.getAtt("DashConfiguration.ManifestEndpointPrefix", cdk.ResolutionTypeHint.STRING)), this.attrHlsConfigurationManifestEndpointPrefix = cdk.Token.asString(this.getAtt("HlsConfiguration.ManifestEndpointPrefix", cdk.ResolutionTypeHint.STRING)), this.attrPlaybackConfigurationArn = cdk.Token.asString(this.getAtt("PlaybackConfigurationArn", cdk.ResolutionTypeHint.STRING)), this.attrPlaybackEndpointPrefix = cdk.Token.asString(this.getAtt("PlaybackEndpointPrefix", cdk.ResolutionTypeHint.STRING)), this.attrSessionInitializationEndpointPrefix = cdk.Token.asString(this.getAtt("SessionInitializationEndpointPrefix", cdk.ResolutionTypeHint.STRING)), this.adDecisionServerUrl = props.adDecisionServerUrl, this.name = props.name, this.videoContentSourceUrl = props.videoContentSourceUrl, this.availSuppression = props.availSuppression, this.bumper = props.bumper, this.cdnConfiguration = props.cdnConfiguration, this.configurationAliases = props.configurationAliases, this.dashConfiguration = props.dashConfiguration, this.hlsConfiguration = props.hlsConfiguration, this.livePreRollConfiguration = props.livePreRollConfiguration, this.manifestProcessingRules = props.manifestProcessingRules, this.personalizationThresholdSeconds = props.personalizationThresholdSeconds, this.slateAdUrl = props.slateAdUrl, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::MediaTailor::PlaybackConfiguration", props.tags, { tagPropertyName: "tags" }), this.transcodeProfileName = props.transcodeProfileName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPlaybackConfiguration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { adDecisionServerUrl: this.adDecisionServerUrl, name: this.name, videoContentSourceUrl: this.videoContentSourceUrl, availSuppression: this.availSuppression, bumper: this.bumper, cdnConfiguration: this.cdnConfiguration, configurationAliases: this.configurationAliases, dashConfiguration: this.dashConfiguration, hlsConfiguration: this.hlsConfiguration, livePreRollConfiguration: this.livePreRollConfiguration, manifestProcessingRules: this.manifestProcessingRules, personalizationThresholdSeconds: this.personalizationThresholdSeconds, slateAdUrl: this.slateAdUrl, tags: this.tags.renderTags(), transcodeProfileName: this.transcodeProfileName };
      }
      renderProperties(props) {
        return cfnPlaybackConfigurationPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnPlaybackConfiguration[_a] = { fqn: "aws-cdk-lib.aws_mediatailor.CfnPlaybackConfiguration", version: "2.80.0" }, CfnPlaybackConfiguration.CFN_RESOURCE_TYPE_NAME = "AWS::MediaTailor::PlaybackConfiguration", exports2.CfnPlaybackConfiguration = CfnPlaybackConfiguration;
    function CfnPlaybackConfiguration_AdMarkerPassthroughPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "AdMarkerPassthroughProperty"');
    }
    function cfnPlaybackConfigurationAdMarkerPassthroughPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPlaybackConfiguration_AdMarkerPassthroughPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnPlaybackConfigurationAdMarkerPassthroughPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPlaybackConfiguration_AvailSuppressionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mode", cdk.validateString)(properties.mode)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "AvailSuppressionProperty"');
    }
    function cfnPlaybackConfigurationAvailSuppressionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPlaybackConfiguration_AvailSuppressionPropertyValidator(properties).assertSuccess(), { Mode: cdk.stringToCloudFormation(properties.mode), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnPlaybackConfigurationAvailSuppressionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mode", "Mode", properties.Mode != null ? cfn_parse.FromCloudFormation.getString(properties.Mode) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPlaybackConfiguration_BumperPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endUrl", cdk.validateString)(properties.endUrl)), errors.collect(cdk.propertyValidator("startUrl", cdk.validateString)(properties.startUrl)), errors.wrap('supplied properties not correct for "BumperProperty"');
    }
    function cfnPlaybackConfigurationBumperPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPlaybackConfiguration_BumperPropertyValidator(properties).assertSuccess(), { EndUrl: cdk.stringToCloudFormation(properties.endUrl), StartUrl: cdk.stringToCloudFormation(properties.startUrl) }) : properties;
    }
    function CfnPlaybackConfigurationBumperPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endUrl", "EndUrl", properties.EndUrl != null ? cfn_parse.FromCloudFormation.getString(properties.EndUrl) : void 0), ret.addPropertyResult("startUrl", "StartUrl", properties.StartUrl != null ? cfn_parse.FromCloudFormation.getString(properties.StartUrl) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPlaybackConfiguration_CdnConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("adSegmentUrlPrefix", cdk.validateString)(properties.adSegmentUrlPrefix)), errors.collect(cdk.propertyValidator("contentSegmentUrlPrefix", cdk.validateString)(properties.contentSegmentUrlPrefix)), errors.wrap('supplied properties not correct for "CdnConfigurationProperty"');
    }
    function cfnPlaybackConfigurationCdnConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPlaybackConfiguration_CdnConfigurationPropertyValidator(properties).assertSuccess(), { AdSegmentUrlPrefix: cdk.stringToCloudFormation(properties.adSegmentUrlPrefix), ContentSegmentUrlPrefix: cdk.stringToCloudFormation(properties.contentSegmentUrlPrefix) }) : properties;
    }
    function CfnPlaybackConfigurationCdnConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("adSegmentUrlPrefix", "AdSegmentUrlPrefix", properties.AdSegmentUrlPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.AdSegmentUrlPrefix) : void 0), ret.addPropertyResult("contentSegmentUrlPrefix", "ContentSegmentUrlPrefix", properties.ContentSegmentUrlPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.ContentSegmentUrlPrefix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPlaybackConfiguration_DashConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("manifestEndpointPrefix", cdk.validateString)(properties.manifestEndpointPrefix)), errors.collect(cdk.propertyValidator("mpdLocation", cdk.validateString)(properties.mpdLocation)), errors.collect(cdk.propertyValidator("originManifestType", cdk.validateString)(properties.originManifestType)), errors.wrap('supplied properties not correct for "DashConfigurationProperty"');
    }
    function cfnPlaybackConfigurationDashConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPlaybackConfiguration_DashConfigurationPropertyValidator(properties).assertSuccess(), { ManifestEndpointPrefix: cdk.stringToCloudFormation(properties.manifestEndpointPrefix), MpdLocation: cdk.stringToCloudFormation(properties.mpdLocation), OriginManifestType: cdk.stringToCloudFormation(properties.originManifestType) }) : properties;
    }
    function CfnPlaybackConfigurationDashConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("manifestEndpointPrefix", "ManifestEndpointPrefix", properties.ManifestEndpointPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.ManifestEndpointPrefix) : void 0), ret.addPropertyResult("mpdLocation", "MpdLocation", properties.MpdLocation != null ? cfn_parse.FromCloudFormation.getString(properties.MpdLocation) : void 0), ret.addPropertyResult("originManifestType", "OriginManifestType", properties.OriginManifestType != null ? cfn_parse.FromCloudFormation.getString(properties.OriginManifestType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPlaybackConfiguration_HlsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("manifestEndpointPrefix", cdk.validateString)(properties.manifestEndpointPrefix)), errors.wrap('supplied properties not correct for "HlsConfigurationProperty"');
    }
    function cfnPlaybackConfigurationHlsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPlaybackConfiguration_HlsConfigurationPropertyValidator(properties).assertSuccess(), { ManifestEndpointPrefix: cdk.stringToCloudFormation(properties.manifestEndpointPrefix) }) : properties;
    }
    function CfnPlaybackConfigurationHlsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("manifestEndpointPrefix", "ManifestEndpointPrefix", properties.ManifestEndpointPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.ManifestEndpointPrefix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPlaybackConfiguration_LivePreRollConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("adDecisionServerUrl", cdk.validateString)(properties.adDecisionServerUrl)), errors.collect(cdk.propertyValidator("maxDurationSeconds", cdk.validateNumber)(properties.maxDurationSeconds)), errors.wrap('supplied properties not correct for "LivePreRollConfigurationProperty"');
    }
    function cfnPlaybackConfigurationLivePreRollConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPlaybackConfiguration_LivePreRollConfigurationPropertyValidator(properties).assertSuccess(), { AdDecisionServerUrl: cdk.stringToCloudFormation(properties.adDecisionServerUrl), MaxDurationSeconds: cdk.numberToCloudFormation(properties.maxDurationSeconds) }) : properties;
    }
    function CfnPlaybackConfigurationLivePreRollConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("adDecisionServerUrl", "AdDecisionServerUrl", properties.AdDecisionServerUrl != null ? cfn_parse.FromCloudFormation.getString(properties.AdDecisionServerUrl) : void 0), ret.addPropertyResult("maxDurationSeconds", "MaxDurationSeconds", properties.MaxDurationSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxDurationSeconds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPlaybackConfiguration_ManifestProcessingRulesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("adMarkerPassthrough", CfnPlaybackConfiguration_AdMarkerPassthroughPropertyValidator)(properties.adMarkerPassthrough)), errors.wrap('supplied properties not correct for "ManifestProcessingRulesProperty"');
    }
    function cfnPlaybackConfigurationManifestProcessingRulesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPlaybackConfiguration_ManifestProcessingRulesPropertyValidator(properties).assertSuccess(), { AdMarkerPassthrough: cfnPlaybackConfigurationAdMarkerPassthroughPropertyToCloudFormation(properties.adMarkerPassthrough) }) : properties;
    }
    function CfnPlaybackConfigurationManifestProcessingRulesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("adMarkerPassthrough", "AdMarkerPassthrough", properties.AdMarkerPassthrough != null ? CfnPlaybackConfigurationAdMarkerPassthroughPropertyFromCloudFormation(properties.AdMarkerPassthrough) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-mediatailor/lib/index.js
var require_lib191 = __commonJS({
  "node_modules/aws-cdk-lib/aws-mediatailor/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_mediatailor_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-mediatailor/index.js
var require_aws_mediatailor = __commonJS({
  "node_modules/aws-cdk-lib/aws-mediatailor/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib191(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-memorydb/lib/memorydb.generated.js
var require_memorydb_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-memorydb/lib/memorydb.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnUser = exports2.CfnSubnetGroup = exports2.CfnParameterGroup = exports2.CfnCluster = exports2.CfnACL = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnACLPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aclName", cdk.requiredValidator)(properties.aclName)), errors.collect(cdk.propertyValidator("aclName", cdk.validateString)(properties.aclName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("userNames", cdk.listValidator(cdk.validateString))(properties.userNames)), errors.wrap('supplied properties not correct for "CfnACLProps"');
    }
    function cfnACLPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnACLPropsValidator(properties).assertSuccess(), { ACLName: cdk.stringToCloudFormation(properties.aclName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), UserNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.userNames) }) : properties;
    }
    function CfnACLPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aclName", "ACLName", cfn_parse.FromCloudFormation.getString(properties.ACLName)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("userNames", "UserNames", properties.UserNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.UserNames) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnACL = class _CfnACL extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnACLPropsFromCloudFormation(resourceProperties), ret = new _CfnACL(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnACL.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_memorydb_CfnACLProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnACL), error;
        }
        cdk.requireProperty(props, "aclName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.aclName = props.aclName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::MemoryDB::ACL", props.tags, { tagPropertyName: "tags" }), this.userNames = props.userNames;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnACL.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { aclName: this.aclName, tags: this.tags.renderTags(), userNames: this.userNames };
      }
      renderProperties(props) {
        return cfnACLPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnACL[_a] = { fqn: "aws-cdk-lib.aws_memorydb.CfnACL", version: "2.80.0" }, CfnACL.CFN_RESOURCE_TYPE_NAME = "AWS::MemoryDB::ACL", exports2.CfnACL = CfnACL;
    function CfnClusterPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aclName", cdk.requiredValidator)(properties.aclName)), errors.collect(cdk.propertyValidator("aclName", cdk.validateString)(properties.aclName)), errors.collect(cdk.propertyValidator("autoMinorVersionUpgrade", cdk.validateBoolean)(properties.autoMinorVersionUpgrade)), errors.collect(cdk.propertyValidator("clusterEndpoint", CfnCluster_EndpointPropertyValidator)(properties.clusterEndpoint)), errors.collect(cdk.propertyValidator("clusterName", cdk.requiredValidator)(properties.clusterName)), errors.collect(cdk.propertyValidator("clusterName", cdk.validateString)(properties.clusterName)), errors.collect(cdk.propertyValidator("dataTiering", cdk.validateString)(properties.dataTiering)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("engineVersion", cdk.validateString)(properties.engineVersion)), errors.collect(cdk.propertyValidator("finalSnapshotName", cdk.validateString)(properties.finalSnapshotName)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("maintenanceWindow", cdk.validateString)(properties.maintenanceWindow)), errors.collect(cdk.propertyValidator("nodeType", cdk.requiredValidator)(properties.nodeType)), errors.collect(cdk.propertyValidator("nodeType", cdk.validateString)(properties.nodeType)), errors.collect(cdk.propertyValidator("numReplicasPerShard", cdk.validateNumber)(properties.numReplicasPerShard)), errors.collect(cdk.propertyValidator("numShards", cdk.validateNumber)(properties.numShards)), errors.collect(cdk.propertyValidator("parameterGroupName", cdk.validateString)(properties.parameterGroupName)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("snapshotArns", cdk.listValidator(cdk.validateString))(properties.snapshotArns)), errors.collect(cdk.propertyValidator("snapshotName", cdk.validateString)(properties.snapshotName)), errors.collect(cdk.propertyValidator("snapshotRetentionLimit", cdk.validateNumber)(properties.snapshotRetentionLimit)), errors.collect(cdk.propertyValidator("snapshotWindow", cdk.validateString)(properties.snapshotWindow)), errors.collect(cdk.propertyValidator("snsTopicArn", cdk.validateString)(properties.snsTopicArn)), errors.collect(cdk.propertyValidator("snsTopicStatus", cdk.validateString)(properties.snsTopicStatus)), errors.collect(cdk.propertyValidator("subnetGroupName", cdk.validateString)(properties.subnetGroupName)), errors.collect(cdk.propertyValidator("tlsEnabled", cdk.validateBoolean)(properties.tlsEnabled)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnClusterProps"');
    }
    function cfnClusterPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClusterPropsValidator(properties).assertSuccess(), { ACLName: cdk.stringToCloudFormation(properties.aclName), ClusterName: cdk.stringToCloudFormation(properties.clusterName), NodeType: cdk.stringToCloudFormation(properties.nodeType), AutoMinorVersionUpgrade: cdk.booleanToCloudFormation(properties.autoMinorVersionUpgrade), ClusterEndpoint: cfnClusterEndpointPropertyToCloudFormation(properties.clusterEndpoint), DataTiering: cdk.stringToCloudFormation(properties.dataTiering), Description: cdk.stringToCloudFormation(properties.description), EngineVersion: cdk.stringToCloudFormation(properties.engineVersion), FinalSnapshotName: cdk.stringToCloudFormation(properties.finalSnapshotName), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), MaintenanceWindow: cdk.stringToCloudFormation(properties.maintenanceWindow), NumReplicasPerShard: cdk.numberToCloudFormation(properties.numReplicasPerShard), NumShards: cdk.numberToCloudFormation(properties.numShards), ParameterGroupName: cdk.stringToCloudFormation(properties.parameterGroupName), Port: cdk.numberToCloudFormation(properties.port), SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SnapshotArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.snapshotArns), SnapshotName: cdk.stringToCloudFormation(properties.snapshotName), SnapshotRetentionLimit: cdk.numberToCloudFormation(properties.snapshotRetentionLimit), SnapshotWindow: cdk.stringToCloudFormation(properties.snapshotWindow), SnsTopicArn: cdk.stringToCloudFormation(properties.snsTopicArn), SnsTopicStatus: cdk.stringToCloudFormation(properties.snsTopicStatus), SubnetGroupName: cdk.stringToCloudFormation(properties.subnetGroupName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TLSEnabled: cdk.booleanToCloudFormation(properties.tlsEnabled) }) : properties;
    }
    function CfnClusterPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aclName", "ACLName", cfn_parse.FromCloudFormation.getString(properties.ACLName)), ret.addPropertyResult("clusterName", "ClusterName", cfn_parse.FromCloudFormation.getString(properties.ClusterName)), ret.addPropertyResult("nodeType", "NodeType", cfn_parse.FromCloudFormation.getString(properties.NodeType)), ret.addPropertyResult("autoMinorVersionUpgrade", "AutoMinorVersionUpgrade", properties.AutoMinorVersionUpgrade != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AutoMinorVersionUpgrade) : void 0), ret.addPropertyResult("clusterEndpoint", "ClusterEndpoint", properties.ClusterEndpoint != null ? CfnClusterEndpointPropertyFromCloudFormation(properties.ClusterEndpoint) : void 0), ret.addPropertyResult("dataTiering", "DataTiering", properties.DataTiering != null ? cfn_parse.FromCloudFormation.getString(properties.DataTiering) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("engineVersion", "EngineVersion", properties.EngineVersion != null ? cfn_parse.FromCloudFormation.getString(properties.EngineVersion) : void 0), ret.addPropertyResult("finalSnapshotName", "FinalSnapshotName", properties.FinalSnapshotName != null ? cfn_parse.FromCloudFormation.getString(properties.FinalSnapshotName) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("maintenanceWindow", "MaintenanceWindow", properties.MaintenanceWindow != null ? cfn_parse.FromCloudFormation.getString(properties.MaintenanceWindow) : void 0), ret.addPropertyResult("numReplicasPerShard", "NumReplicasPerShard", properties.NumReplicasPerShard != null ? cfn_parse.FromCloudFormation.getNumber(properties.NumReplicasPerShard) : void 0), ret.addPropertyResult("numShards", "NumShards", properties.NumShards != null ? cfn_parse.FromCloudFormation.getNumber(properties.NumShards) : void 0), ret.addPropertyResult("parameterGroupName", "ParameterGroupName", properties.ParameterGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.ParameterGroupName) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("snapshotArns", "SnapshotArns", properties.SnapshotArns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SnapshotArns) : void 0), ret.addPropertyResult("snapshotName", "SnapshotName", properties.SnapshotName != null ? cfn_parse.FromCloudFormation.getString(properties.SnapshotName) : void 0), ret.addPropertyResult("snapshotRetentionLimit", "SnapshotRetentionLimit", properties.SnapshotRetentionLimit != null ? cfn_parse.FromCloudFormation.getNumber(properties.SnapshotRetentionLimit) : void 0), ret.addPropertyResult("snapshotWindow", "SnapshotWindow", properties.SnapshotWindow != null ? cfn_parse.FromCloudFormation.getString(properties.SnapshotWindow) : void 0), ret.addPropertyResult("snsTopicArn", "SnsTopicArn", properties.SnsTopicArn != null ? cfn_parse.FromCloudFormation.getString(properties.SnsTopicArn) : void 0), ret.addPropertyResult("snsTopicStatus", "SnsTopicStatus", properties.SnsTopicStatus != null ? cfn_parse.FromCloudFormation.getString(properties.SnsTopicStatus) : void 0), ret.addPropertyResult("subnetGroupName", "SubnetGroupName", properties.SubnetGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.SubnetGroupName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("tlsEnabled", "TLSEnabled", properties.TLSEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.TLSEnabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCluster = class _CfnCluster extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnClusterPropsFromCloudFormation(resourceProperties), ret = new _CfnCluster(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCluster.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_memorydb_CfnClusterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCluster), error;
        }
        cdk.requireProperty(props, "aclName", this), cdk.requireProperty(props, "clusterName", this), cdk.requireProperty(props, "nodeType", this), this.attrArn = cdk.Token.asString(this.getAtt("ARN", cdk.ResolutionTypeHint.STRING)), this.attrClusterEndpointAddress = cdk.Token.asString(this.getAtt("ClusterEndpoint.Address", cdk.ResolutionTypeHint.STRING)), this.attrClusterEndpointPort = cdk.Token.asNumber(this.getAtt("ClusterEndpoint.Port", cdk.ResolutionTypeHint.NUMBER)), this.attrParameterGroupStatus = cdk.Token.asString(this.getAtt("ParameterGroupStatus", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.aclName = props.aclName, this.clusterName = props.clusterName, this.nodeType = props.nodeType, this.autoMinorVersionUpgrade = props.autoMinorVersionUpgrade, this.clusterEndpoint = props.clusterEndpoint, this.dataTiering = props.dataTiering, this.description = props.description, this.engineVersion = props.engineVersion, this.finalSnapshotName = props.finalSnapshotName, this.kmsKeyId = props.kmsKeyId, this.maintenanceWindow = props.maintenanceWindow, this.numReplicasPerShard = props.numReplicasPerShard, this.numShards = props.numShards, this.parameterGroupName = props.parameterGroupName, this.port = props.port, this.securityGroupIds = props.securityGroupIds, this.snapshotArns = props.snapshotArns, this.snapshotName = props.snapshotName, this.snapshotRetentionLimit = props.snapshotRetentionLimit, this.snapshotWindow = props.snapshotWindow, this.snsTopicArn = props.snsTopicArn, this.snsTopicStatus = props.snsTopicStatus, this.subnetGroupName = props.subnetGroupName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::MemoryDB::Cluster", props.tags, { tagPropertyName: "tags" }), this.tlsEnabled = props.tlsEnabled;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCluster.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { aclName: this.aclName, clusterName: this.clusterName, nodeType: this.nodeType, autoMinorVersionUpgrade: this.autoMinorVersionUpgrade, clusterEndpoint: this.clusterEndpoint, dataTiering: this.dataTiering, description: this.description, engineVersion: this.engineVersion, finalSnapshotName: this.finalSnapshotName, kmsKeyId: this.kmsKeyId, maintenanceWindow: this.maintenanceWindow, numReplicasPerShard: this.numReplicasPerShard, numShards: this.numShards, parameterGroupName: this.parameterGroupName, port: this.port, securityGroupIds: this.securityGroupIds, snapshotArns: this.snapshotArns, snapshotName: this.snapshotName, snapshotRetentionLimit: this.snapshotRetentionLimit, snapshotWindow: this.snapshotWindow, snsTopicArn: this.snsTopicArn, snsTopicStatus: this.snsTopicStatus, subnetGroupName: this.subnetGroupName, tags: this.tags.renderTags(), tlsEnabled: this.tlsEnabled };
      }
      renderProperties(props) {
        return cfnClusterPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnCluster[_b] = { fqn: "aws-cdk-lib.aws_memorydb.CfnCluster", version: "2.80.0" }, CfnCluster.CFN_RESOURCE_TYPE_NAME = "AWS::MemoryDB::Cluster", exports2.CfnCluster = CfnCluster;
    function CfnCluster_EndpointPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("address", cdk.validateString)(properties.address)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.wrap('supplied properties not correct for "EndpointProperty"');
    }
    function cfnClusterEndpointPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_EndpointPropertyValidator(properties).assertSuccess(), { Address: cdk.stringToCloudFormation(properties.address), Port: cdk.numberToCloudFormation(properties.port) }) : properties;
    }
    function CfnClusterEndpointPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("address", "Address", properties.Address != null ? cfn_parse.FromCloudFormation.getString(properties.Address) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnParameterGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("family", cdk.requiredValidator)(properties.family)), errors.collect(cdk.propertyValidator("family", cdk.validateString)(properties.family)), errors.collect(cdk.propertyValidator("parameterGroupName", cdk.requiredValidator)(properties.parameterGroupName)), errors.collect(cdk.propertyValidator("parameterGroupName", cdk.validateString)(properties.parameterGroupName)), errors.collect(cdk.propertyValidator("parameters", cdk.validateObject)(properties.parameters)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnParameterGroupProps"');
    }
    function cfnParameterGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnParameterGroupPropsValidator(properties).assertSuccess(), { Family: cdk.stringToCloudFormation(properties.family), ParameterGroupName: cdk.stringToCloudFormation(properties.parameterGroupName), Description: cdk.stringToCloudFormation(properties.description), Parameters: cdk.objectToCloudFormation(properties.parameters), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnParameterGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("family", "Family", cfn_parse.FromCloudFormation.getString(properties.Family)), ret.addPropertyResult("parameterGroupName", "ParameterGroupName", cfn_parse.FromCloudFormation.getString(properties.ParameterGroupName)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getAny(properties.Parameters) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnParameterGroup = class _CfnParameterGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnParameterGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnParameterGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnParameterGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_memorydb_CfnParameterGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnParameterGroup), error;
        }
        cdk.requireProperty(props, "family", this), cdk.requireProperty(props, "parameterGroupName", this), this.attrArn = cdk.Token.asString(this.getAtt("ARN", cdk.ResolutionTypeHint.STRING)), this.family = props.family, this.parameterGroupName = props.parameterGroupName, this.description = props.description, this.parameters = props.parameters, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::MemoryDB::ParameterGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnParameterGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { family: this.family, parameterGroupName: this.parameterGroupName, description: this.description, parameters: this.parameters, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnParameterGroupPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnParameterGroup[_c] = { fqn: "aws-cdk-lib.aws_memorydb.CfnParameterGroup", version: "2.80.0" }, CfnParameterGroup.CFN_RESOURCE_TYPE_NAME = "AWS::MemoryDB::ParameterGroup", exports2.CfnParameterGroup = CfnParameterGroup;
    function CfnSubnetGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("subnetGroupName", cdk.requiredValidator)(properties.subnetGroupName)), errors.collect(cdk.propertyValidator("subnetGroupName", cdk.validateString)(properties.subnetGroupName)), errors.collect(cdk.propertyValidator("subnetIds", cdk.requiredValidator)(properties.subnetIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnSubnetGroupProps"');
    }
    function cfnSubnetGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSubnetGroupPropsValidator(properties).assertSuccess(), { SubnetGroupName: cdk.stringToCloudFormation(properties.subnetGroupName), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnSubnetGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("subnetGroupName", "SubnetGroupName", cfn_parse.FromCloudFormation.getString(properties.SubnetGroupName)), ret.addPropertyResult("subnetIds", "SubnetIds", cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSubnetGroup = class _CfnSubnetGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSubnetGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnSubnetGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSubnetGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_memorydb_CfnSubnetGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSubnetGroup), error;
        }
        cdk.requireProperty(props, "subnetGroupName", this), cdk.requireProperty(props, "subnetIds", this), this.attrArn = cdk.Token.asString(this.getAtt("ARN", cdk.ResolutionTypeHint.STRING)), this.subnetGroupName = props.subnetGroupName, this.subnetIds = props.subnetIds, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::MemoryDB::SubnetGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSubnetGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { subnetGroupName: this.subnetGroupName, subnetIds: this.subnetIds, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnSubnetGroupPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnSubnetGroup[_d] = { fqn: "aws-cdk-lib.aws_memorydb.CfnSubnetGroup", version: "2.80.0" }, CfnSubnetGroup.CFN_RESOURCE_TYPE_NAME = "AWS::MemoryDB::SubnetGroup", exports2.CfnSubnetGroup = CfnSubnetGroup;
    function CfnUserPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessString", cdk.validateString)(properties.accessString)), errors.collect(cdk.propertyValidator("authenticationMode", cdk.validateObject)(properties.authenticationMode)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("userName", cdk.requiredValidator)(properties.userName)), errors.collect(cdk.propertyValidator("userName", cdk.validateString)(properties.userName)), errors.wrap('supplied properties not correct for "CfnUserProps"');
    }
    function cfnUserPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPropsValidator(properties).assertSuccess(), { UserName: cdk.stringToCloudFormation(properties.userName), AccessString: cdk.stringToCloudFormation(properties.accessString), AuthenticationMode: cdk.objectToCloudFormation(properties.authenticationMode), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnUserPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("userName", "UserName", cfn_parse.FromCloudFormation.getString(properties.UserName)), ret.addPropertyResult("accessString", "AccessString", properties.AccessString != null ? cfn_parse.FromCloudFormation.getString(properties.AccessString) : void 0), ret.addPropertyResult("authenticationMode", "AuthenticationMode", properties.AuthenticationMode != null ? cfn_parse.FromCloudFormation.getAny(properties.AuthenticationMode) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnUser = class _CfnUser extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnUserPropsFromCloudFormation(resourceProperties), ret = new _CfnUser(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnUser.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_memorydb_CfnUserProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnUser), error;
        }
        cdk.requireProperty(props, "userName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.userName = props.userName, this.accessString = props.accessString, this.authenticationMode = props.authenticationMode, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::MemoryDB::User", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnUser.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { userName: this.userName, accessString: this.accessString, authenticationMode: this.authenticationMode, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnUserPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnUser[_e] = { fqn: "aws-cdk-lib.aws_memorydb.CfnUser", version: "2.80.0" }, CfnUser.CFN_RESOURCE_TYPE_NAME = "AWS::MemoryDB::User", exports2.CfnUser = CfnUser;
  }
});

// node_modules/aws-cdk-lib/aws-memorydb/lib/index.js
var require_lib192 = __commonJS({
  "node_modules/aws-cdk-lib/aws-memorydb/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_memorydb_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-memorydb/index.js
var require_aws_memorydb = __commonJS({
  "node_modules/aws-cdk-lib/aws-memorydb/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib192(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-msk/lib/msk.generated.js
var require_msk_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-msk/lib/msk.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnVpcConnection = exports2.CfnServerlessCluster = exports2.CfnConfiguration = exports2.CfnClusterPolicy = exports2.CfnCluster = exports2.CfnBatchScramSecret = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnBatchScramSecretPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clusterArn", cdk.requiredValidator)(properties.clusterArn)), errors.collect(cdk.propertyValidator("clusterArn", cdk.validateString)(properties.clusterArn)), errors.collect(cdk.propertyValidator("secretArnList", cdk.listValidator(cdk.validateString))(properties.secretArnList)), errors.wrap('supplied properties not correct for "CfnBatchScramSecretProps"');
    }
    function cfnBatchScramSecretPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBatchScramSecretPropsValidator(properties).assertSuccess(), { ClusterArn: cdk.stringToCloudFormation(properties.clusterArn), SecretArnList: cdk.listMapper(cdk.stringToCloudFormation)(properties.secretArnList) }) : properties;
    }
    function CfnBatchScramSecretPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clusterArn", "ClusterArn", cfn_parse.FromCloudFormation.getString(properties.ClusterArn)), ret.addPropertyResult("secretArnList", "SecretArnList", properties.SecretArnList != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecretArnList) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnBatchScramSecret = class _CfnBatchScramSecret extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnBatchScramSecretPropsFromCloudFormation(resourceProperties), ret = new _CfnBatchScramSecret(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnBatchScramSecret.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_msk_CfnBatchScramSecretProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnBatchScramSecret), error;
        }
        cdk.requireProperty(props, "clusterArn", this), this.clusterArn = props.clusterArn, this.secretArnList = props.secretArnList;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnBatchScramSecret.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { clusterArn: this.clusterArn, secretArnList: this.secretArnList };
      }
      renderProperties(props) {
        return cfnBatchScramSecretPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnBatchScramSecret[_a] = { fqn: "aws-cdk-lib.aws_msk.CfnBatchScramSecret", version: "2.80.0" }, CfnBatchScramSecret.CFN_RESOURCE_TYPE_NAME = "AWS::MSK::BatchScramSecret", exports2.CfnBatchScramSecret = CfnBatchScramSecret;
    function CfnClusterPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("brokerNodeGroupInfo", cdk.requiredValidator)(properties.brokerNodeGroupInfo)), errors.collect(cdk.propertyValidator("brokerNodeGroupInfo", CfnCluster_BrokerNodeGroupInfoPropertyValidator)(properties.brokerNodeGroupInfo)), errors.collect(cdk.propertyValidator("clientAuthentication", CfnCluster_ClientAuthenticationPropertyValidator)(properties.clientAuthentication)), errors.collect(cdk.propertyValidator("clusterName", cdk.requiredValidator)(properties.clusterName)), errors.collect(cdk.propertyValidator("clusterName", cdk.validateString)(properties.clusterName)), errors.collect(cdk.propertyValidator("configurationInfo", CfnCluster_ConfigurationInfoPropertyValidator)(properties.configurationInfo)), errors.collect(cdk.propertyValidator("currentVersion", cdk.validateString)(properties.currentVersion)), errors.collect(cdk.propertyValidator("encryptionInfo", CfnCluster_EncryptionInfoPropertyValidator)(properties.encryptionInfo)), errors.collect(cdk.propertyValidator("enhancedMonitoring", cdk.validateString)(properties.enhancedMonitoring)), errors.collect(cdk.propertyValidator("kafkaVersion", cdk.requiredValidator)(properties.kafkaVersion)), errors.collect(cdk.propertyValidator("kafkaVersion", cdk.validateString)(properties.kafkaVersion)), errors.collect(cdk.propertyValidator("loggingInfo", CfnCluster_LoggingInfoPropertyValidator)(properties.loggingInfo)), errors.collect(cdk.propertyValidator("numberOfBrokerNodes", cdk.requiredValidator)(properties.numberOfBrokerNodes)), errors.collect(cdk.propertyValidator("numberOfBrokerNodes", cdk.validateNumber)(properties.numberOfBrokerNodes)), errors.collect(cdk.propertyValidator("openMonitoring", CfnCluster_OpenMonitoringPropertyValidator)(properties.openMonitoring)), errors.collect(cdk.propertyValidator("storageMode", cdk.validateString)(properties.storageMode)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.wrap('supplied properties not correct for "CfnClusterProps"');
    }
    function cfnClusterPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClusterPropsValidator(properties).assertSuccess(), { BrokerNodeGroupInfo: cfnClusterBrokerNodeGroupInfoPropertyToCloudFormation(properties.brokerNodeGroupInfo), ClusterName: cdk.stringToCloudFormation(properties.clusterName), KafkaVersion: cdk.stringToCloudFormation(properties.kafkaVersion), NumberOfBrokerNodes: cdk.numberToCloudFormation(properties.numberOfBrokerNodes), ClientAuthentication: cfnClusterClientAuthenticationPropertyToCloudFormation(properties.clientAuthentication), ConfigurationInfo: cfnClusterConfigurationInfoPropertyToCloudFormation(properties.configurationInfo), CurrentVersion: cdk.stringToCloudFormation(properties.currentVersion), EncryptionInfo: cfnClusterEncryptionInfoPropertyToCloudFormation(properties.encryptionInfo), EnhancedMonitoring: cdk.stringToCloudFormation(properties.enhancedMonitoring), LoggingInfo: cfnClusterLoggingInfoPropertyToCloudFormation(properties.loggingInfo), OpenMonitoring: cfnClusterOpenMonitoringPropertyToCloudFormation(properties.openMonitoring), StorageMode: cdk.stringToCloudFormation(properties.storageMode), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnClusterPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("brokerNodeGroupInfo", "BrokerNodeGroupInfo", CfnClusterBrokerNodeGroupInfoPropertyFromCloudFormation(properties.BrokerNodeGroupInfo)), ret.addPropertyResult("clusterName", "ClusterName", cfn_parse.FromCloudFormation.getString(properties.ClusterName)), ret.addPropertyResult("kafkaVersion", "KafkaVersion", cfn_parse.FromCloudFormation.getString(properties.KafkaVersion)), ret.addPropertyResult("numberOfBrokerNodes", "NumberOfBrokerNodes", cfn_parse.FromCloudFormation.getNumber(properties.NumberOfBrokerNodes)), ret.addPropertyResult("clientAuthentication", "ClientAuthentication", properties.ClientAuthentication != null ? CfnClusterClientAuthenticationPropertyFromCloudFormation(properties.ClientAuthentication) : void 0), ret.addPropertyResult("configurationInfo", "ConfigurationInfo", properties.ConfigurationInfo != null ? CfnClusterConfigurationInfoPropertyFromCloudFormation(properties.ConfigurationInfo) : void 0), ret.addPropertyResult("currentVersion", "CurrentVersion", properties.CurrentVersion != null ? cfn_parse.FromCloudFormation.getString(properties.CurrentVersion) : void 0), ret.addPropertyResult("encryptionInfo", "EncryptionInfo", properties.EncryptionInfo != null ? CfnClusterEncryptionInfoPropertyFromCloudFormation(properties.EncryptionInfo) : void 0), ret.addPropertyResult("enhancedMonitoring", "EnhancedMonitoring", properties.EnhancedMonitoring != null ? cfn_parse.FromCloudFormation.getString(properties.EnhancedMonitoring) : void 0), ret.addPropertyResult("loggingInfo", "LoggingInfo", properties.LoggingInfo != null ? CfnClusterLoggingInfoPropertyFromCloudFormation(properties.LoggingInfo) : void 0), ret.addPropertyResult("openMonitoring", "OpenMonitoring", properties.OpenMonitoring != null ? CfnClusterOpenMonitoringPropertyFromCloudFormation(properties.OpenMonitoring) : void 0), ret.addPropertyResult("storageMode", "StorageMode", properties.StorageMode != null ? cfn_parse.FromCloudFormation.getString(properties.StorageMode) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCluster = class _CfnCluster extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnClusterPropsFromCloudFormation(resourceProperties), ret = new _CfnCluster(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCluster.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_msk_CfnClusterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCluster), error;
        }
        cdk.requireProperty(props, "brokerNodeGroupInfo", this), cdk.requireProperty(props, "clusterName", this), cdk.requireProperty(props, "kafkaVersion", this), cdk.requireProperty(props, "numberOfBrokerNodes", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.brokerNodeGroupInfo = props.brokerNodeGroupInfo, this.clusterName = props.clusterName, this.kafkaVersion = props.kafkaVersion, this.numberOfBrokerNodes = props.numberOfBrokerNodes, this.clientAuthentication = props.clientAuthentication, this.configurationInfo = props.configurationInfo, this.currentVersion = props.currentVersion, this.encryptionInfo = props.encryptionInfo, this.enhancedMonitoring = props.enhancedMonitoring, this.loggingInfo = props.loggingInfo, this.openMonitoring = props.openMonitoring, this.storageMode = props.storageMode, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::MSK::Cluster", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCluster.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { brokerNodeGroupInfo: this.brokerNodeGroupInfo, clusterName: this.clusterName, kafkaVersion: this.kafkaVersion, numberOfBrokerNodes: this.numberOfBrokerNodes, clientAuthentication: this.clientAuthentication, configurationInfo: this.configurationInfo, currentVersion: this.currentVersion, encryptionInfo: this.encryptionInfo, enhancedMonitoring: this.enhancedMonitoring, loggingInfo: this.loggingInfo, openMonitoring: this.openMonitoring, storageMode: this.storageMode, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnClusterPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnCluster[_b] = { fqn: "aws-cdk-lib.aws_msk.CfnCluster", version: "2.80.0" }, CfnCluster.CFN_RESOURCE_TYPE_NAME = "AWS::MSK::Cluster", exports2.CfnCluster = CfnCluster;
    function CfnCluster_BrokerLogsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchLogs", CfnCluster_CloudWatchLogsPropertyValidator)(properties.cloudWatchLogs)), errors.collect(cdk.propertyValidator("firehose", CfnCluster_FirehosePropertyValidator)(properties.firehose)), errors.collect(cdk.propertyValidator("s3", CfnCluster_S3PropertyValidator)(properties.s3)), errors.wrap('supplied properties not correct for "BrokerLogsProperty"');
    }
    function cfnClusterBrokerLogsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_BrokerLogsPropertyValidator(properties).assertSuccess(), { CloudWatchLogs: cfnClusterCloudWatchLogsPropertyToCloudFormation(properties.cloudWatchLogs), Firehose: cfnClusterFirehosePropertyToCloudFormation(properties.firehose), S3: cfnClusterS3PropertyToCloudFormation(properties.s3) }) : properties;
    }
    function CfnClusterBrokerLogsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchLogs", "CloudWatchLogs", properties.CloudWatchLogs != null ? CfnClusterCloudWatchLogsPropertyFromCloudFormation(properties.CloudWatchLogs) : void 0), ret.addPropertyResult("firehose", "Firehose", properties.Firehose != null ? CfnClusterFirehosePropertyFromCloudFormation(properties.Firehose) : void 0), ret.addPropertyResult("s3", "S3", properties.S3 != null ? CfnClusterS3PropertyFromCloudFormation(properties.S3) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_BrokerNodeGroupInfoPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("brokerAzDistribution", cdk.validateString)(properties.brokerAzDistribution)), errors.collect(cdk.propertyValidator("clientSubnets", cdk.requiredValidator)(properties.clientSubnets)), errors.collect(cdk.propertyValidator("clientSubnets", cdk.listValidator(cdk.validateString))(properties.clientSubnets)), errors.collect(cdk.propertyValidator("connectivityInfo", CfnCluster_ConnectivityInfoPropertyValidator)(properties.connectivityInfo)), errors.collect(cdk.propertyValidator("instanceType", cdk.requiredValidator)(properties.instanceType)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("securityGroups", cdk.listValidator(cdk.validateString))(properties.securityGroups)), errors.collect(cdk.propertyValidator("storageInfo", CfnCluster_StorageInfoPropertyValidator)(properties.storageInfo)), errors.wrap('supplied properties not correct for "BrokerNodeGroupInfoProperty"');
    }
    function cfnClusterBrokerNodeGroupInfoPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_BrokerNodeGroupInfoPropertyValidator(properties).assertSuccess(), { BrokerAZDistribution: cdk.stringToCloudFormation(properties.brokerAzDistribution), ClientSubnets: cdk.listMapper(cdk.stringToCloudFormation)(properties.clientSubnets), ConnectivityInfo: cfnClusterConnectivityInfoPropertyToCloudFormation(properties.connectivityInfo), InstanceType: cdk.stringToCloudFormation(properties.instanceType), SecurityGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroups), StorageInfo: cfnClusterStorageInfoPropertyToCloudFormation(properties.storageInfo) }) : properties;
    }
    function CfnClusterBrokerNodeGroupInfoPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("brokerAzDistribution", "BrokerAZDistribution", properties.BrokerAZDistribution != null ? cfn_parse.FromCloudFormation.getString(properties.BrokerAZDistribution) : void 0), ret.addPropertyResult("clientSubnets", "ClientSubnets", cfn_parse.FromCloudFormation.getStringArray(properties.ClientSubnets)), ret.addPropertyResult("connectivityInfo", "ConnectivityInfo", properties.ConnectivityInfo != null ? CfnClusterConnectivityInfoPropertyFromCloudFormation(properties.ConnectivityInfo) : void 0), ret.addPropertyResult("instanceType", "InstanceType", cfn_parse.FromCloudFormation.getString(properties.InstanceType)), ret.addPropertyResult("securityGroups", "SecurityGroups", properties.SecurityGroups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroups) : void 0), ret.addPropertyResult("storageInfo", "StorageInfo", properties.StorageInfo != null ? CfnClusterStorageInfoPropertyFromCloudFormation(properties.StorageInfo) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_ClientAuthenticationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sasl", CfnCluster_SaslPropertyValidator)(properties.sasl)), errors.collect(cdk.propertyValidator("tls", CfnCluster_TlsPropertyValidator)(properties.tls)), errors.collect(cdk.propertyValidator("unauthenticated", CfnCluster_UnauthenticatedPropertyValidator)(properties.unauthenticated)), errors.wrap('supplied properties not correct for "ClientAuthenticationProperty"');
    }
    function cfnClusterClientAuthenticationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_ClientAuthenticationPropertyValidator(properties).assertSuccess(), { Sasl: cfnClusterSaslPropertyToCloudFormation(properties.sasl), Tls: cfnClusterTlsPropertyToCloudFormation(properties.tls), Unauthenticated: cfnClusterUnauthenticatedPropertyToCloudFormation(properties.unauthenticated) }) : properties;
    }
    function CfnClusterClientAuthenticationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sasl", "Sasl", properties.Sasl != null ? CfnClusterSaslPropertyFromCloudFormation(properties.Sasl) : void 0), ret.addPropertyResult("tls", "Tls", properties.Tls != null ? CfnClusterTlsPropertyFromCloudFormation(properties.Tls) : void 0), ret.addPropertyResult("unauthenticated", "Unauthenticated", properties.Unauthenticated != null ? CfnClusterUnauthenticatedPropertyFromCloudFormation(properties.Unauthenticated) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_CloudWatchLogsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("logGroup", cdk.validateString)(properties.logGroup)), errors.wrap('supplied properties not correct for "CloudWatchLogsProperty"');
    }
    function cfnClusterCloudWatchLogsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_CloudWatchLogsPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled), LogGroup: cdk.stringToCloudFormation(properties.logGroup) }) : properties;
    }
    function CfnClusterCloudWatchLogsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addPropertyResult("logGroup", "LogGroup", properties.LogGroup != null ? cfn_parse.FromCloudFormation.getString(properties.LogGroup) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_ConfigurationInfoPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.requiredValidator)(properties.arn)), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("revision", cdk.requiredValidator)(properties.revision)), errors.collect(cdk.propertyValidator("revision", cdk.validateNumber)(properties.revision)), errors.wrap('supplied properties not correct for "ConfigurationInfoProperty"');
    }
    function cfnClusterConfigurationInfoPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_ConfigurationInfoPropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn), Revision: cdk.numberToCloudFormation(properties.revision) }) : properties;
    }
    function CfnClusterConfigurationInfoPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", cfn_parse.FromCloudFormation.getString(properties.Arn)), ret.addPropertyResult("revision", "Revision", cfn_parse.FromCloudFormation.getNumber(properties.Revision)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_ConnectivityInfoPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("publicAccess", CfnCluster_PublicAccessPropertyValidator)(properties.publicAccess)), errors.collect(cdk.propertyValidator("vpcConnectivity", CfnCluster_VpcConnectivityPropertyValidator)(properties.vpcConnectivity)), errors.wrap('supplied properties not correct for "ConnectivityInfoProperty"');
    }
    function cfnClusterConnectivityInfoPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_ConnectivityInfoPropertyValidator(properties).assertSuccess(), { PublicAccess: cfnClusterPublicAccessPropertyToCloudFormation(properties.publicAccess), VpcConnectivity: cfnClusterVpcConnectivityPropertyToCloudFormation(properties.vpcConnectivity) }) : properties;
    }
    function CfnClusterConnectivityInfoPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("publicAccess", "PublicAccess", properties.PublicAccess != null ? CfnClusterPublicAccessPropertyFromCloudFormation(properties.PublicAccess) : void 0), ret.addPropertyResult("vpcConnectivity", "VpcConnectivity", properties.VpcConnectivity != null ? CfnClusterVpcConnectivityPropertyFromCloudFormation(properties.VpcConnectivity) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_EBSStorageInfoPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("provisionedThroughput", CfnCluster_ProvisionedThroughputPropertyValidator)(properties.provisionedThroughput)), errors.collect(cdk.propertyValidator("volumeSize", cdk.validateNumber)(properties.volumeSize)), errors.wrap('supplied properties not correct for "EBSStorageInfoProperty"');
    }
    function cfnClusterEBSStorageInfoPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_EBSStorageInfoPropertyValidator(properties).assertSuccess(), { ProvisionedThroughput: cfnClusterProvisionedThroughputPropertyToCloudFormation(properties.provisionedThroughput), VolumeSize: cdk.numberToCloudFormation(properties.volumeSize) }) : properties;
    }
    function CfnClusterEBSStorageInfoPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("provisionedThroughput", "ProvisionedThroughput", properties.ProvisionedThroughput != null ? CfnClusterProvisionedThroughputPropertyFromCloudFormation(properties.ProvisionedThroughput) : void 0), ret.addPropertyResult("volumeSize", "VolumeSize", properties.VolumeSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.VolumeSize) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_EncryptionAtRestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataVolumeKmsKeyId", cdk.requiredValidator)(properties.dataVolumeKmsKeyId)), errors.collect(cdk.propertyValidator("dataVolumeKmsKeyId", cdk.validateString)(properties.dataVolumeKmsKeyId)), errors.wrap('supplied properties not correct for "EncryptionAtRestProperty"');
    }
    function cfnClusterEncryptionAtRestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_EncryptionAtRestPropertyValidator(properties).assertSuccess(), { DataVolumeKMSKeyId: cdk.stringToCloudFormation(properties.dataVolumeKmsKeyId) }) : properties;
    }
    function CfnClusterEncryptionAtRestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataVolumeKmsKeyId", "DataVolumeKMSKeyId", cfn_parse.FromCloudFormation.getString(properties.DataVolumeKMSKeyId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_EncryptionInTransitPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clientBroker", cdk.validateString)(properties.clientBroker)), errors.collect(cdk.propertyValidator("inCluster", cdk.validateBoolean)(properties.inCluster)), errors.wrap('supplied properties not correct for "EncryptionInTransitProperty"');
    }
    function cfnClusterEncryptionInTransitPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_EncryptionInTransitPropertyValidator(properties).assertSuccess(), { ClientBroker: cdk.stringToCloudFormation(properties.clientBroker), InCluster: cdk.booleanToCloudFormation(properties.inCluster) }) : properties;
    }
    function CfnClusterEncryptionInTransitPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clientBroker", "ClientBroker", properties.ClientBroker != null ? cfn_parse.FromCloudFormation.getString(properties.ClientBroker) : void 0), ret.addPropertyResult("inCluster", "InCluster", properties.InCluster != null ? cfn_parse.FromCloudFormation.getBoolean(properties.InCluster) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_EncryptionInfoPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("encryptionAtRest", CfnCluster_EncryptionAtRestPropertyValidator)(properties.encryptionAtRest)), errors.collect(cdk.propertyValidator("encryptionInTransit", CfnCluster_EncryptionInTransitPropertyValidator)(properties.encryptionInTransit)), errors.wrap('supplied properties not correct for "EncryptionInfoProperty"');
    }
    function cfnClusterEncryptionInfoPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_EncryptionInfoPropertyValidator(properties).assertSuccess(), { EncryptionAtRest: cfnClusterEncryptionAtRestPropertyToCloudFormation(properties.encryptionAtRest), EncryptionInTransit: cfnClusterEncryptionInTransitPropertyToCloudFormation(properties.encryptionInTransit) }) : properties;
    }
    function CfnClusterEncryptionInfoPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("encryptionAtRest", "EncryptionAtRest", properties.EncryptionAtRest != null ? CfnClusterEncryptionAtRestPropertyFromCloudFormation(properties.EncryptionAtRest) : void 0), ret.addPropertyResult("encryptionInTransit", "EncryptionInTransit", properties.EncryptionInTransit != null ? CfnClusterEncryptionInTransitPropertyFromCloudFormation(properties.EncryptionInTransit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_FirehosePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deliveryStream", cdk.validateString)(properties.deliveryStream)), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "FirehoseProperty"');
    }
    function cfnClusterFirehosePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_FirehosePropertyValidator(properties).assertSuccess(), { DeliveryStream: cdk.stringToCloudFormation(properties.deliveryStream), Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnClusterFirehosePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deliveryStream", "DeliveryStream", properties.DeliveryStream != null ? cfn_parse.FromCloudFormation.getString(properties.DeliveryStream) : void 0), ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_IamPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "IamProperty"');
    }
    function cfnClusterIamPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_IamPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnClusterIamPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_JmxExporterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabledInBroker", cdk.requiredValidator)(properties.enabledInBroker)), errors.collect(cdk.propertyValidator("enabledInBroker", cdk.validateBoolean)(properties.enabledInBroker)), errors.wrap('supplied properties not correct for "JmxExporterProperty"');
    }
    function cfnClusterJmxExporterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_JmxExporterPropertyValidator(properties).assertSuccess(), { EnabledInBroker: cdk.booleanToCloudFormation(properties.enabledInBroker) }) : properties;
    }
    function CfnClusterJmxExporterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabledInBroker", "EnabledInBroker", cfn_parse.FromCloudFormation.getBoolean(properties.EnabledInBroker)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_LoggingInfoPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("brokerLogs", cdk.requiredValidator)(properties.brokerLogs)), errors.collect(cdk.propertyValidator("brokerLogs", CfnCluster_BrokerLogsPropertyValidator)(properties.brokerLogs)), errors.wrap('supplied properties not correct for "LoggingInfoProperty"');
    }
    function cfnClusterLoggingInfoPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_LoggingInfoPropertyValidator(properties).assertSuccess(), { BrokerLogs: cfnClusterBrokerLogsPropertyToCloudFormation(properties.brokerLogs) }) : properties;
    }
    function CfnClusterLoggingInfoPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("brokerLogs", "BrokerLogs", CfnClusterBrokerLogsPropertyFromCloudFormation(properties.BrokerLogs)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_NodeExporterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabledInBroker", cdk.requiredValidator)(properties.enabledInBroker)), errors.collect(cdk.propertyValidator("enabledInBroker", cdk.validateBoolean)(properties.enabledInBroker)), errors.wrap('supplied properties not correct for "NodeExporterProperty"');
    }
    function cfnClusterNodeExporterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_NodeExporterPropertyValidator(properties).assertSuccess(), { EnabledInBroker: cdk.booleanToCloudFormation(properties.enabledInBroker) }) : properties;
    }
    function CfnClusterNodeExporterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabledInBroker", "EnabledInBroker", cfn_parse.FromCloudFormation.getBoolean(properties.EnabledInBroker)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_OpenMonitoringPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("prometheus", cdk.requiredValidator)(properties.prometheus)), errors.collect(cdk.propertyValidator("prometheus", CfnCluster_PrometheusPropertyValidator)(properties.prometheus)), errors.wrap('supplied properties not correct for "OpenMonitoringProperty"');
    }
    function cfnClusterOpenMonitoringPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_OpenMonitoringPropertyValidator(properties).assertSuccess(), { Prometheus: cfnClusterPrometheusPropertyToCloudFormation(properties.prometheus) }) : properties;
    }
    function CfnClusterOpenMonitoringPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("prometheus", "Prometheus", CfnClusterPrometheusPropertyFromCloudFormation(properties.Prometheus)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_PrometheusPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("jmxExporter", CfnCluster_JmxExporterPropertyValidator)(properties.jmxExporter)), errors.collect(cdk.propertyValidator("nodeExporter", CfnCluster_NodeExporterPropertyValidator)(properties.nodeExporter)), errors.wrap('supplied properties not correct for "PrometheusProperty"');
    }
    function cfnClusterPrometheusPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_PrometheusPropertyValidator(properties).assertSuccess(), { JmxExporter: cfnClusterJmxExporterPropertyToCloudFormation(properties.jmxExporter), NodeExporter: cfnClusterNodeExporterPropertyToCloudFormation(properties.nodeExporter) }) : properties;
    }
    function CfnClusterPrometheusPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("jmxExporter", "JmxExporter", properties.JmxExporter != null ? CfnClusterJmxExporterPropertyFromCloudFormation(properties.JmxExporter) : void 0), ret.addPropertyResult("nodeExporter", "NodeExporter", properties.NodeExporter != null ? CfnClusterNodeExporterPropertyFromCloudFormation(properties.NodeExporter) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_ProvisionedThroughputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("volumeThroughput", cdk.validateNumber)(properties.volumeThroughput)), errors.wrap('supplied properties not correct for "ProvisionedThroughputProperty"');
    }
    function cfnClusterProvisionedThroughputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_ProvisionedThroughputPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled), VolumeThroughput: cdk.numberToCloudFormation(properties.volumeThroughput) }) : properties;
    }
    function CfnClusterProvisionedThroughputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("volumeThroughput", "VolumeThroughput", properties.VolumeThroughput != null ? cfn_parse.FromCloudFormation.getNumber(properties.VolumeThroughput) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_PublicAccessPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "PublicAccessProperty"');
    }
    function cfnClusterPublicAccessPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_PublicAccessPropertyValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnClusterPublicAccessPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_S3PropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.wrap('supplied properties not correct for "S3Property"');
    }
    function cfnClusterS3PropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_S3PropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), Enabled: cdk.booleanToCloudFormation(properties.enabled), Prefix: cdk.stringToCloudFormation(properties.prefix) }) : properties;
    }
    function CfnClusterS3PropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", properties.Bucket != null ? cfn_parse.FromCloudFormation.getString(properties.Bucket) : void 0), ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_SaslPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("iam", CfnCluster_IamPropertyValidator)(properties.iam)), errors.collect(cdk.propertyValidator("scram", CfnCluster_ScramPropertyValidator)(properties.scram)), errors.wrap('supplied properties not correct for "SaslProperty"');
    }
    function cfnClusterSaslPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_SaslPropertyValidator(properties).assertSuccess(), { Iam: cfnClusterIamPropertyToCloudFormation(properties.iam), Scram: cfnClusterScramPropertyToCloudFormation(properties.scram) }) : properties;
    }
    function CfnClusterSaslPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("iam", "Iam", properties.Iam != null ? CfnClusterIamPropertyFromCloudFormation(properties.Iam) : void 0), ret.addPropertyResult("scram", "Scram", properties.Scram != null ? CfnClusterScramPropertyFromCloudFormation(properties.Scram) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_ScramPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "ScramProperty"');
    }
    function cfnClusterScramPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_ScramPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnClusterScramPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_StorageInfoPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ebsStorageInfo", CfnCluster_EBSStorageInfoPropertyValidator)(properties.ebsStorageInfo)), errors.wrap('supplied properties not correct for "StorageInfoProperty"');
    }
    function cfnClusterStorageInfoPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_StorageInfoPropertyValidator(properties).assertSuccess(), { EBSStorageInfo: cfnClusterEBSStorageInfoPropertyToCloudFormation(properties.ebsStorageInfo) }) : properties;
    }
    function CfnClusterStorageInfoPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ebsStorageInfo", "EBSStorageInfo", properties.EBSStorageInfo != null ? CfnClusterEBSStorageInfoPropertyFromCloudFormation(properties.EBSStorageInfo) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_TlsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificateAuthorityArnList", cdk.listValidator(cdk.validateString))(properties.certificateAuthorityArnList)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "TlsProperty"');
    }
    function cfnClusterTlsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_TlsPropertyValidator(properties).assertSuccess(), { CertificateAuthorityArnList: cdk.listMapper(cdk.stringToCloudFormation)(properties.certificateAuthorityArnList), Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnClusterTlsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificateAuthorityArnList", "CertificateAuthorityArnList", properties.CertificateAuthorityArnList != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CertificateAuthorityArnList) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_UnauthenticatedPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "UnauthenticatedProperty"');
    }
    function cfnClusterUnauthenticatedPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_UnauthenticatedPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnClusterUnauthenticatedPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_VpcConnectivityPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clientAuthentication", CfnCluster_VpcConnectivityClientAuthenticationPropertyValidator)(properties.clientAuthentication)), errors.wrap('supplied properties not correct for "VpcConnectivityProperty"');
    }
    function cfnClusterVpcConnectivityPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_VpcConnectivityPropertyValidator(properties).assertSuccess(), { ClientAuthentication: cfnClusterVpcConnectivityClientAuthenticationPropertyToCloudFormation(properties.clientAuthentication) }) : properties;
    }
    function CfnClusterVpcConnectivityPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clientAuthentication", "ClientAuthentication", properties.ClientAuthentication != null ? CfnClusterVpcConnectivityClientAuthenticationPropertyFromCloudFormation(properties.ClientAuthentication) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_VpcConnectivityClientAuthenticationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sasl", CfnCluster_VpcConnectivitySaslPropertyValidator)(properties.sasl)), errors.collect(cdk.propertyValidator("tls", CfnCluster_VpcConnectivityTlsPropertyValidator)(properties.tls)), errors.wrap('supplied properties not correct for "VpcConnectivityClientAuthenticationProperty"');
    }
    function cfnClusterVpcConnectivityClientAuthenticationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_VpcConnectivityClientAuthenticationPropertyValidator(properties).assertSuccess(), { Sasl: cfnClusterVpcConnectivitySaslPropertyToCloudFormation(properties.sasl), Tls: cfnClusterVpcConnectivityTlsPropertyToCloudFormation(properties.tls) }) : properties;
    }
    function CfnClusterVpcConnectivityClientAuthenticationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sasl", "Sasl", properties.Sasl != null ? CfnClusterVpcConnectivitySaslPropertyFromCloudFormation(properties.Sasl) : void 0), ret.addPropertyResult("tls", "Tls", properties.Tls != null ? CfnClusterVpcConnectivityTlsPropertyFromCloudFormation(properties.Tls) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_VpcConnectivityIamPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "VpcConnectivityIamProperty"');
    }
    function cfnClusterVpcConnectivityIamPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_VpcConnectivityIamPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnClusterVpcConnectivityIamPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_VpcConnectivitySaslPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("iam", CfnCluster_VpcConnectivityIamPropertyValidator)(properties.iam)), errors.collect(cdk.propertyValidator("scram", CfnCluster_VpcConnectivityScramPropertyValidator)(properties.scram)), errors.wrap('supplied properties not correct for "VpcConnectivitySaslProperty"');
    }
    function cfnClusterVpcConnectivitySaslPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_VpcConnectivitySaslPropertyValidator(properties).assertSuccess(), { Iam: cfnClusterVpcConnectivityIamPropertyToCloudFormation(properties.iam), Scram: cfnClusterVpcConnectivityScramPropertyToCloudFormation(properties.scram) }) : properties;
    }
    function CfnClusterVpcConnectivitySaslPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("iam", "Iam", properties.Iam != null ? CfnClusterVpcConnectivityIamPropertyFromCloudFormation(properties.Iam) : void 0), ret.addPropertyResult("scram", "Scram", properties.Scram != null ? CfnClusterVpcConnectivityScramPropertyFromCloudFormation(properties.Scram) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_VpcConnectivityScramPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "VpcConnectivityScramProperty"');
    }
    function cfnClusterVpcConnectivityScramPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_VpcConnectivityScramPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnClusterVpcConnectivityScramPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_VpcConnectivityTlsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "VpcConnectivityTlsProperty"');
    }
    function cfnClusterVpcConnectivityTlsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_VpcConnectivityTlsPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnClusterVpcConnectivityTlsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnClusterPolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clusterArn", cdk.requiredValidator)(properties.clusterArn)), errors.collect(cdk.propertyValidator("clusterArn", cdk.validateString)(properties.clusterArn)), errors.collect(cdk.propertyValidator("policy", cdk.requiredValidator)(properties.policy)), errors.collect(cdk.propertyValidator("policy", cdk.validateObject)(properties.policy)), errors.wrap('supplied properties not correct for "CfnClusterPolicyProps"');
    }
    function cfnClusterPolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClusterPolicyPropsValidator(properties).assertSuccess(), { ClusterArn: cdk.stringToCloudFormation(properties.clusterArn), Policy: cdk.objectToCloudFormation(properties.policy) }) : properties;
    }
    function CfnClusterPolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clusterArn", "ClusterArn", cfn_parse.FromCloudFormation.getString(properties.ClusterArn)), ret.addPropertyResult("policy", "Policy", cfn_parse.FromCloudFormation.getAny(properties.Policy)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnClusterPolicy = class _CfnClusterPolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnClusterPolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnClusterPolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnClusterPolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_msk_CfnClusterPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnClusterPolicy), error;
        }
        cdk.requireProperty(props, "clusterArn", this), cdk.requireProperty(props, "policy", this), this.attrCurrentVersion = cdk.Token.asString(this.getAtt("CurrentVersion", cdk.ResolutionTypeHint.STRING)), this.clusterArn = props.clusterArn, this.policy = props.policy;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnClusterPolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { clusterArn: this.clusterArn, policy: this.policy };
      }
      renderProperties(props) {
        return cfnClusterPolicyPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnClusterPolicy[_c] = { fqn: "aws-cdk-lib.aws_msk.CfnClusterPolicy", version: "2.80.0" }, CfnClusterPolicy.CFN_RESOURCE_TYPE_NAME = "AWS::MSK::ClusterPolicy", exports2.CfnClusterPolicy = CfnClusterPolicy;
    function CfnConfigurationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("kafkaVersionsList", cdk.listValidator(cdk.validateString))(properties.kafkaVersionsList)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("serverProperties", cdk.requiredValidator)(properties.serverProperties)), errors.collect(cdk.propertyValidator("serverProperties", cdk.validateString)(properties.serverProperties)), errors.wrap('supplied properties not correct for "CfnConfigurationProps"');
    }
    function cfnConfigurationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), ServerProperties: cdk.stringToCloudFormation(properties.serverProperties), Description: cdk.stringToCloudFormation(properties.description), KafkaVersionsList: cdk.listMapper(cdk.stringToCloudFormation)(properties.kafkaVersionsList) }) : properties;
    }
    function CfnConfigurationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("serverProperties", "ServerProperties", cfn_parse.FromCloudFormation.getString(properties.ServerProperties)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("kafkaVersionsList", "KafkaVersionsList", properties.KafkaVersionsList != null ? cfn_parse.FromCloudFormation.getStringArray(properties.KafkaVersionsList) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnConfiguration = class _CfnConfiguration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnConfigurationPropsFromCloudFormation(resourceProperties), ret = new _CfnConfiguration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnConfiguration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_msk_CfnConfigurationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnConfiguration), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "serverProperties", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.serverProperties = props.serverProperties, this.description = props.description, this.kafkaVersionsList = props.kafkaVersionsList;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnConfiguration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, serverProperties: this.serverProperties, description: this.description, kafkaVersionsList: this.kafkaVersionsList };
      }
      renderProperties(props) {
        return cfnConfigurationPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnConfiguration[_d] = { fqn: "aws-cdk-lib.aws_msk.CfnConfiguration", version: "2.80.0" }, CfnConfiguration.CFN_RESOURCE_TYPE_NAME = "AWS::MSK::Configuration", exports2.CfnConfiguration = CfnConfiguration;
    function CfnServerlessClusterPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clientAuthentication", cdk.requiredValidator)(properties.clientAuthentication)), errors.collect(cdk.propertyValidator("clientAuthentication", CfnServerlessCluster_ClientAuthenticationPropertyValidator)(properties.clientAuthentication)), errors.collect(cdk.propertyValidator("clusterName", cdk.requiredValidator)(properties.clusterName)), errors.collect(cdk.propertyValidator("clusterName", cdk.validateString)(properties.clusterName)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.collect(cdk.propertyValidator("vpcConfigs", cdk.requiredValidator)(properties.vpcConfigs)), errors.collect(cdk.propertyValidator("vpcConfigs", cdk.listValidator(CfnServerlessCluster_VpcConfigPropertyValidator))(properties.vpcConfigs)), errors.wrap('supplied properties not correct for "CfnServerlessClusterProps"');
    }
    function cfnServerlessClusterPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnServerlessClusterPropsValidator(properties).assertSuccess(), { ClientAuthentication: cfnServerlessClusterClientAuthenticationPropertyToCloudFormation(properties.clientAuthentication), ClusterName: cdk.stringToCloudFormation(properties.clusterName), VpcConfigs: cdk.listMapper(cfnServerlessClusterVpcConfigPropertyToCloudFormation)(properties.vpcConfigs), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnServerlessClusterPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clientAuthentication", "ClientAuthentication", CfnServerlessClusterClientAuthenticationPropertyFromCloudFormation(properties.ClientAuthentication)), ret.addPropertyResult("clusterName", "ClusterName", cfn_parse.FromCloudFormation.getString(properties.ClusterName)), ret.addPropertyResult("vpcConfigs", "VpcConfigs", cfn_parse.FromCloudFormation.getArray(CfnServerlessClusterVpcConfigPropertyFromCloudFormation)(properties.VpcConfigs)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnServerlessCluster = class _CfnServerlessCluster extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnServerlessClusterPropsFromCloudFormation(resourceProperties), ret = new _CfnServerlessCluster(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnServerlessCluster.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_msk_CfnServerlessClusterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnServerlessCluster), error;
        }
        cdk.requireProperty(props, "clientAuthentication", this), cdk.requireProperty(props, "clusterName", this), cdk.requireProperty(props, "vpcConfigs", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.clientAuthentication = props.clientAuthentication, this.clusterName = props.clusterName, this.vpcConfigs = props.vpcConfigs, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::MSK::ServerlessCluster", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnServerlessCluster.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { clientAuthentication: this.clientAuthentication, clusterName: this.clusterName, vpcConfigs: this.vpcConfigs, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnServerlessClusterPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnServerlessCluster[_e] = { fqn: "aws-cdk-lib.aws_msk.CfnServerlessCluster", version: "2.80.0" }, CfnServerlessCluster.CFN_RESOURCE_TYPE_NAME = "AWS::MSK::ServerlessCluster", exports2.CfnServerlessCluster = CfnServerlessCluster;
    function CfnServerlessCluster_ClientAuthenticationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sasl", cdk.requiredValidator)(properties.sasl)), errors.collect(cdk.propertyValidator("sasl", CfnServerlessCluster_SaslPropertyValidator)(properties.sasl)), errors.wrap('supplied properties not correct for "ClientAuthenticationProperty"');
    }
    function cfnServerlessClusterClientAuthenticationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnServerlessCluster_ClientAuthenticationPropertyValidator(properties).assertSuccess(), { Sasl: cfnServerlessClusterSaslPropertyToCloudFormation(properties.sasl) }) : properties;
    }
    function CfnServerlessClusterClientAuthenticationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sasl", "Sasl", CfnServerlessClusterSaslPropertyFromCloudFormation(properties.Sasl)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnServerlessCluster_IamPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.requiredValidator)(properties.enabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "IamProperty"');
    }
    function cfnServerlessClusterIamPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnServerlessCluster_IamPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnServerlessClusterIamPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", cfn_parse.FromCloudFormation.getBoolean(properties.Enabled)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnServerlessCluster_SaslPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("iam", cdk.requiredValidator)(properties.iam)), errors.collect(cdk.propertyValidator("iam", CfnServerlessCluster_IamPropertyValidator)(properties.iam)), errors.wrap('supplied properties not correct for "SaslProperty"');
    }
    function cfnServerlessClusterSaslPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnServerlessCluster_SaslPropertyValidator(properties).assertSuccess(), { Iam: cfnServerlessClusterIamPropertyToCloudFormation(properties.iam) }) : properties;
    }
    function CfnServerlessClusterSaslPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("iam", "Iam", CfnServerlessClusterIamPropertyFromCloudFormation(properties.Iam)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnServerlessCluster_VpcConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroups", cdk.listValidator(cdk.validateString))(properties.securityGroups)), errors.collect(cdk.propertyValidator("subnetIds", cdk.requiredValidator)(properties.subnetIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.wrap('supplied properties not correct for "VpcConfigProperty"');
    }
    function cfnServerlessClusterVpcConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnServerlessCluster_VpcConfigPropertyValidator(properties).assertSuccess(), { SecurityGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroups), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds) }) : properties;
    }
    function CfnServerlessClusterVpcConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroups", "SecurityGroups", properties.SecurityGroups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroups) : void 0), ret.addPropertyResult("subnetIds", "SubnetIds", cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVpcConnectionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authentication", cdk.requiredValidator)(properties.authentication)), errors.collect(cdk.propertyValidator("authentication", cdk.validateString)(properties.authentication)), errors.collect(cdk.propertyValidator("clientSubnets", cdk.requiredValidator)(properties.clientSubnets)), errors.collect(cdk.propertyValidator("clientSubnets", cdk.listValidator(cdk.validateString))(properties.clientSubnets)), errors.collect(cdk.propertyValidator("securityGroups", cdk.requiredValidator)(properties.securityGroups)), errors.collect(cdk.propertyValidator("securityGroups", cdk.listValidator(cdk.validateString))(properties.securityGroups)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.collect(cdk.propertyValidator("targetClusterArn", cdk.requiredValidator)(properties.targetClusterArn)), errors.collect(cdk.propertyValidator("targetClusterArn", cdk.validateString)(properties.targetClusterArn)), errors.collect(cdk.propertyValidator("vpcId", cdk.requiredValidator)(properties.vpcId)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "CfnVpcConnectionProps"');
    }
    function cfnVpcConnectionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVpcConnectionPropsValidator(properties).assertSuccess(), { Authentication: cdk.stringToCloudFormation(properties.authentication), ClientSubnets: cdk.listMapper(cdk.stringToCloudFormation)(properties.clientSubnets), SecurityGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroups), TargetClusterArn: cdk.stringToCloudFormation(properties.targetClusterArn), VpcId: cdk.stringToCloudFormation(properties.vpcId), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnVpcConnectionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authentication", "Authentication", cfn_parse.FromCloudFormation.getString(properties.Authentication)), ret.addPropertyResult("clientSubnets", "ClientSubnets", cfn_parse.FromCloudFormation.getStringArray(properties.ClientSubnets)), ret.addPropertyResult("securityGroups", "SecurityGroups", cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroups)), ret.addPropertyResult("targetClusterArn", "TargetClusterArn", cfn_parse.FromCloudFormation.getString(properties.TargetClusterArn)), ret.addPropertyResult("vpcId", "VpcId", cfn_parse.FromCloudFormation.getString(properties.VpcId)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVpcConnection = class _CfnVpcConnection extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVpcConnectionPropsFromCloudFormation(resourceProperties), ret = new _CfnVpcConnection(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVpcConnection.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_msk_CfnVpcConnectionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVpcConnection), error;
        }
        cdk.requireProperty(props, "authentication", this), cdk.requireProperty(props, "clientSubnets", this), cdk.requireProperty(props, "securityGroups", this), cdk.requireProperty(props, "targetClusterArn", this), cdk.requireProperty(props, "vpcId", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.authentication = props.authentication, this.clientSubnets = props.clientSubnets, this.securityGroups = props.securityGroups, this.targetClusterArn = props.targetClusterArn, this.vpcId = props.vpcId, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::MSK::VpcConnection", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVpcConnection.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { authentication: this.authentication, clientSubnets: this.clientSubnets, securityGroups: this.securityGroups, targetClusterArn: this.targetClusterArn, vpcId: this.vpcId, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnVpcConnectionPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnVpcConnection[_f] = { fqn: "aws-cdk-lib.aws_msk.CfnVpcConnection", version: "2.80.0" }, CfnVpcConnection.CFN_RESOURCE_TYPE_NAME = "AWS::MSK::VpcConnection", exports2.CfnVpcConnection = CfnVpcConnection;
  }
});

// node_modules/aws-cdk-lib/aws-msk/lib/index.js
var require_lib193 = __commonJS({
  "node_modules/aws-cdk-lib/aws-msk/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_msk_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-msk/index.js
var require_aws_msk = __commonJS({
  "node_modules/aws-cdk-lib/aws-msk/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib193(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-mwaa/lib/mwaa.generated.js
var require_mwaa_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-mwaa/lib/mwaa.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnEnvironment = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnEnvironmentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("airflowConfigurationOptions", cdk.validateObject)(properties.airflowConfigurationOptions)), errors.collect(cdk.propertyValidator("airflowVersion", cdk.validateString)(properties.airflowVersion)), errors.collect(cdk.propertyValidator("dagS3Path", cdk.validateString)(properties.dagS3Path)), errors.collect(cdk.propertyValidator("environmentClass", cdk.validateString)(properties.environmentClass)), errors.collect(cdk.propertyValidator("executionRoleArn", cdk.validateString)(properties.executionRoleArn)), errors.collect(cdk.propertyValidator("kmsKey", cdk.validateString)(properties.kmsKey)), errors.collect(cdk.propertyValidator("loggingConfiguration", CfnEnvironment_LoggingConfigurationPropertyValidator)(properties.loggingConfiguration)), errors.collect(cdk.propertyValidator("maxWorkers", cdk.validateNumber)(properties.maxWorkers)), errors.collect(cdk.propertyValidator("minWorkers", cdk.validateNumber)(properties.minWorkers)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("networkConfiguration", CfnEnvironment_NetworkConfigurationPropertyValidator)(properties.networkConfiguration)), errors.collect(cdk.propertyValidator("pluginsS3ObjectVersion", cdk.validateString)(properties.pluginsS3ObjectVersion)), errors.collect(cdk.propertyValidator("pluginsS3Path", cdk.validateString)(properties.pluginsS3Path)), errors.collect(cdk.propertyValidator("requirementsS3ObjectVersion", cdk.validateString)(properties.requirementsS3ObjectVersion)), errors.collect(cdk.propertyValidator("requirementsS3Path", cdk.validateString)(properties.requirementsS3Path)), errors.collect(cdk.propertyValidator("schedulers", cdk.validateNumber)(properties.schedulers)), errors.collect(cdk.propertyValidator("sourceBucketArn", cdk.validateString)(properties.sourceBucketArn)), errors.collect(cdk.propertyValidator("startupScriptS3ObjectVersion", cdk.validateString)(properties.startupScriptS3ObjectVersion)), errors.collect(cdk.propertyValidator("startupScriptS3Path", cdk.validateString)(properties.startupScriptS3Path)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.collect(cdk.propertyValidator("webserverAccessMode", cdk.validateString)(properties.webserverAccessMode)), errors.collect(cdk.propertyValidator("weeklyMaintenanceWindowStart", cdk.validateString)(properties.weeklyMaintenanceWindowStart)), errors.wrap('supplied properties not correct for "CfnEnvironmentProps"');
    }
    function cfnEnvironmentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEnvironmentPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), AirflowConfigurationOptions: cdk.objectToCloudFormation(properties.airflowConfigurationOptions), AirflowVersion: cdk.stringToCloudFormation(properties.airflowVersion), DagS3Path: cdk.stringToCloudFormation(properties.dagS3Path), EnvironmentClass: cdk.stringToCloudFormation(properties.environmentClass), ExecutionRoleArn: cdk.stringToCloudFormation(properties.executionRoleArn), KmsKey: cdk.stringToCloudFormation(properties.kmsKey), LoggingConfiguration: cfnEnvironmentLoggingConfigurationPropertyToCloudFormation(properties.loggingConfiguration), MaxWorkers: cdk.numberToCloudFormation(properties.maxWorkers), MinWorkers: cdk.numberToCloudFormation(properties.minWorkers), NetworkConfiguration: cfnEnvironmentNetworkConfigurationPropertyToCloudFormation(properties.networkConfiguration), PluginsS3ObjectVersion: cdk.stringToCloudFormation(properties.pluginsS3ObjectVersion), PluginsS3Path: cdk.stringToCloudFormation(properties.pluginsS3Path), RequirementsS3ObjectVersion: cdk.stringToCloudFormation(properties.requirementsS3ObjectVersion), RequirementsS3Path: cdk.stringToCloudFormation(properties.requirementsS3Path), Schedulers: cdk.numberToCloudFormation(properties.schedulers), SourceBucketArn: cdk.stringToCloudFormation(properties.sourceBucketArn), StartupScriptS3ObjectVersion: cdk.stringToCloudFormation(properties.startupScriptS3ObjectVersion), StartupScriptS3Path: cdk.stringToCloudFormation(properties.startupScriptS3Path), Tags: cdk.objectToCloudFormation(properties.tags), WebserverAccessMode: cdk.stringToCloudFormation(properties.webserverAccessMode), WeeklyMaintenanceWindowStart: cdk.stringToCloudFormation(properties.weeklyMaintenanceWindowStart) }) : properties;
    }
    function CfnEnvironmentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("airflowConfigurationOptions", "AirflowConfigurationOptions", properties.AirflowConfigurationOptions != null ? cfn_parse.FromCloudFormation.getAny(properties.AirflowConfigurationOptions) : void 0), ret.addPropertyResult("airflowVersion", "AirflowVersion", properties.AirflowVersion != null ? cfn_parse.FromCloudFormation.getString(properties.AirflowVersion) : void 0), ret.addPropertyResult("dagS3Path", "DagS3Path", properties.DagS3Path != null ? cfn_parse.FromCloudFormation.getString(properties.DagS3Path) : void 0), ret.addPropertyResult("environmentClass", "EnvironmentClass", properties.EnvironmentClass != null ? cfn_parse.FromCloudFormation.getString(properties.EnvironmentClass) : void 0), ret.addPropertyResult("executionRoleArn", "ExecutionRoleArn", properties.ExecutionRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.ExecutionRoleArn) : void 0), ret.addPropertyResult("kmsKey", "KmsKey", properties.KmsKey != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKey) : void 0), ret.addPropertyResult("loggingConfiguration", "LoggingConfiguration", properties.LoggingConfiguration != null ? CfnEnvironmentLoggingConfigurationPropertyFromCloudFormation(properties.LoggingConfiguration) : void 0), ret.addPropertyResult("maxWorkers", "MaxWorkers", properties.MaxWorkers != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxWorkers) : void 0), ret.addPropertyResult("minWorkers", "MinWorkers", properties.MinWorkers != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinWorkers) : void 0), ret.addPropertyResult("networkConfiguration", "NetworkConfiguration", properties.NetworkConfiguration != null ? CfnEnvironmentNetworkConfigurationPropertyFromCloudFormation(properties.NetworkConfiguration) : void 0), ret.addPropertyResult("pluginsS3ObjectVersion", "PluginsS3ObjectVersion", properties.PluginsS3ObjectVersion != null ? cfn_parse.FromCloudFormation.getString(properties.PluginsS3ObjectVersion) : void 0), ret.addPropertyResult("pluginsS3Path", "PluginsS3Path", properties.PluginsS3Path != null ? cfn_parse.FromCloudFormation.getString(properties.PluginsS3Path) : void 0), ret.addPropertyResult("requirementsS3ObjectVersion", "RequirementsS3ObjectVersion", properties.RequirementsS3ObjectVersion != null ? cfn_parse.FromCloudFormation.getString(properties.RequirementsS3ObjectVersion) : void 0), ret.addPropertyResult("requirementsS3Path", "RequirementsS3Path", properties.RequirementsS3Path != null ? cfn_parse.FromCloudFormation.getString(properties.RequirementsS3Path) : void 0), ret.addPropertyResult("schedulers", "Schedulers", properties.Schedulers != null ? cfn_parse.FromCloudFormation.getNumber(properties.Schedulers) : void 0), ret.addPropertyResult("sourceBucketArn", "SourceBucketArn", properties.SourceBucketArn != null ? cfn_parse.FromCloudFormation.getString(properties.SourceBucketArn) : void 0), ret.addPropertyResult("startupScriptS3ObjectVersion", "StartupScriptS3ObjectVersion", properties.StartupScriptS3ObjectVersion != null ? cfn_parse.FromCloudFormation.getString(properties.StartupScriptS3ObjectVersion) : void 0), ret.addPropertyResult("startupScriptS3Path", "StartupScriptS3Path", properties.StartupScriptS3Path != null ? cfn_parse.FromCloudFormation.getString(properties.StartupScriptS3Path) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addPropertyResult("webserverAccessMode", "WebserverAccessMode", properties.WebserverAccessMode != null ? cfn_parse.FromCloudFormation.getString(properties.WebserverAccessMode) : void 0), ret.addPropertyResult("weeklyMaintenanceWindowStart", "WeeklyMaintenanceWindowStart", properties.WeeklyMaintenanceWindowStart != null ? cfn_parse.FromCloudFormation.getString(properties.WeeklyMaintenanceWindowStart) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEnvironment = class _CfnEnvironment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEnvironmentPropsFromCloudFormation(resourceProperties), ret = new _CfnEnvironment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEnvironment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_mwaa_CfnEnvironmentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEnvironment), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrLoggingConfigurationDagProcessingLogsCloudWatchLogGroupArn = cdk.Token.asString(this.getAtt("LoggingConfiguration.DagProcessingLogs.CloudWatchLogGroupArn", cdk.ResolutionTypeHint.STRING)), this.attrLoggingConfigurationSchedulerLogsCloudWatchLogGroupArn = cdk.Token.asString(this.getAtt("LoggingConfiguration.SchedulerLogs.CloudWatchLogGroupArn", cdk.ResolutionTypeHint.STRING)), this.attrLoggingConfigurationTaskLogsCloudWatchLogGroupArn = cdk.Token.asString(this.getAtt("LoggingConfiguration.TaskLogs.CloudWatchLogGroupArn", cdk.ResolutionTypeHint.STRING)), this.attrLoggingConfigurationWebserverLogsCloudWatchLogGroupArn = cdk.Token.asString(this.getAtt("LoggingConfiguration.WebserverLogs.CloudWatchLogGroupArn", cdk.ResolutionTypeHint.STRING)), this.attrLoggingConfigurationWorkerLogsCloudWatchLogGroupArn = cdk.Token.asString(this.getAtt("LoggingConfiguration.WorkerLogs.CloudWatchLogGroupArn", cdk.ResolutionTypeHint.STRING)), this.attrWebserverUrl = cdk.Token.asString(this.getAtt("WebserverUrl", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.airflowConfigurationOptions = props.airflowConfigurationOptions, this.airflowVersion = props.airflowVersion, this.dagS3Path = props.dagS3Path, this.environmentClass = props.environmentClass, this.executionRoleArn = props.executionRoleArn, this.kmsKey = props.kmsKey, this.loggingConfiguration = props.loggingConfiguration, this.maxWorkers = props.maxWorkers, this.minWorkers = props.minWorkers, this.networkConfiguration = props.networkConfiguration, this.pluginsS3ObjectVersion = props.pluginsS3ObjectVersion, this.pluginsS3Path = props.pluginsS3Path, this.requirementsS3ObjectVersion = props.requirementsS3ObjectVersion, this.requirementsS3Path = props.requirementsS3Path, this.schedulers = props.schedulers, this.sourceBucketArn = props.sourceBucketArn, this.startupScriptS3ObjectVersion = props.startupScriptS3ObjectVersion, this.startupScriptS3Path = props.startupScriptS3Path, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::MWAA::Environment", props.tags, { tagPropertyName: "tags" }), this.webserverAccessMode = props.webserverAccessMode, this.weeklyMaintenanceWindowStart = props.weeklyMaintenanceWindowStart;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEnvironment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, airflowConfigurationOptions: this.airflowConfigurationOptions, airflowVersion: this.airflowVersion, dagS3Path: this.dagS3Path, environmentClass: this.environmentClass, executionRoleArn: this.executionRoleArn, kmsKey: this.kmsKey, loggingConfiguration: this.loggingConfiguration, maxWorkers: this.maxWorkers, minWorkers: this.minWorkers, networkConfiguration: this.networkConfiguration, pluginsS3ObjectVersion: this.pluginsS3ObjectVersion, pluginsS3Path: this.pluginsS3Path, requirementsS3ObjectVersion: this.requirementsS3ObjectVersion, requirementsS3Path: this.requirementsS3Path, schedulers: this.schedulers, sourceBucketArn: this.sourceBucketArn, startupScriptS3ObjectVersion: this.startupScriptS3ObjectVersion, startupScriptS3Path: this.startupScriptS3Path, tags: this.tags.renderTags(), webserverAccessMode: this.webserverAccessMode, weeklyMaintenanceWindowStart: this.weeklyMaintenanceWindowStart };
      }
      renderProperties(props) {
        return cfnEnvironmentPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnEnvironment[_a] = { fqn: "aws-cdk-lib.aws_mwaa.CfnEnvironment", version: "2.80.0" }, CfnEnvironment.CFN_RESOURCE_TYPE_NAME = "AWS::MWAA::Environment", exports2.CfnEnvironment = CfnEnvironment;
    function CfnEnvironment_LoggingConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dagProcessingLogs", CfnEnvironment_ModuleLoggingConfigurationPropertyValidator)(properties.dagProcessingLogs)), errors.collect(cdk.propertyValidator("schedulerLogs", CfnEnvironment_ModuleLoggingConfigurationPropertyValidator)(properties.schedulerLogs)), errors.collect(cdk.propertyValidator("taskLogs", CfnEnvironment_ModuleLoggingConfigurationPropertyValidator)(properties.taskLogs)), errors.collect(cdk.propertyValidator("webserverLogs", CfnEnvironment_ModuleLoggingConfigurationPropertyValidator)(properties.webserverLogs)), errors.collect(cdk.propertyValidator("workerLogs", CfnEnvironment_ModuleLoggingConfigurationPropertyValidator)(properties.workerLogs)), errors.wrap('supplied properties not correct for "LoggingConfigurationProperty"');
    }
    function cfnEnvironmentLoggingConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEnvironment_LoggingConfigurationPropertyValidator(properties).assertSuccess(), { DagProcessingLogs: cfnEnvironmentModuleLoggingConfigurationPropertyToCloudFormation(properties.dagProcessingLogs), SchedulerLogs: cfnEnvironmentModuleLoggingConfigurationPropertyToCloudFormation(properties.schedulerLogs), TaskLogs: cfnEnvironmentModuleLoggingConfigurationPropertyToCloudFormation(properties.taskLogs), WebserverLogs: cfnEnvironmentModuleLoggingConfigurationPropertyToCloudFormation(properties.webserverLogs), WorkerLogs: cfnEnvironmentModuleLoggingConfigurationPropertyToCloudFormation(properties.workerLogs) }) : properties;
    }
    function CfnEnvironmentLoggingConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dagProcessingLogs", "DagProcessingLogs", properties.DagProcessingLogs != null ? CfnEnvironmentModuleLoggingConfigurationPropertyFromCloudFormation(properties.DagProcessingLogs) : void 0), ret.addPropertyResult("schedulerLogs", "SchedulerLogs", properties.SchedulerLogs != null ? CfnEnvironmentModuleLoggingConfigurationPropertyFromCloudFormation(properties.SchedulerLogs) : void 0), ret.addPropertyResult("taskLogs", "TaskLogs", properties.TaskLogs != null ? CfnEnvironmentModuleLoggingConfigurationPropertyFromCloudFormation(properties.TaskLogs) : void 0), ret.addPropertyResult("webserverLogs", "WebserverLogs", properties.WebserverLogs != null ? CfnEnvironmentModuleLoggingConfigurationPropertyFromCloudFormation(properties.WebserverLogs) : void 0), ret.addPropertyResult("workerLogs", "WorkerLogs", properties.WorkerLogs != null ? CfnEnvironmentModuleLoggingConfigurationPropertyFromCloudFormation(properties.WorkerLogs) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEnvironment_ModuleLoggingConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchLogGroupArn", cdk.validateString)(properties.cloudWatchLogGroupArn)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("logLevel", cdk.validateString)(properties.logLevel)), errors.wrap('supplied properties not correct for "ModuleLoggingConfigurationProperty"');
    }
    function cfnEnvironmentModuleLoggingConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEnvironment_ModuleLoggingConfigurationPropertyValidator(properties).assertSuccess(), { CloudWatchLogGroupArn: cdk.stringToCloudFormation(properties.cloudWatchLogGroupArn), Enabled: cdk.booleanToCloudFormation(properties.enabled), LogLevel: cdk.stringToCloudFormation(properties.logLevel) }) : properties;
    }
    function CfnEnvironmentModuleLoggingConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchLogGroupArn", "CloudWatchLogGroupArn", properties.CloudWatchLogGroupArn != null ? cfn_parse.FromCloudFormation.getString(properties.CloudWatchLogGroupArn) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("logLevel", "LogLevel", properties.LogLevel != null ? cfn_parse.FromCloudFormation.getString(properties.LogLevel) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEnvironment_NetworkConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.wrap('supplied properties not correct for "NetworkConfigurationProperty"');
    }
    function cfnEnvironmentNetworkConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEnvironment_NetworkConfigurationPropertyValidator(properties).assertSuccess(), { SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds) }) : properties;
    }
    function CfnEnvironmentNetworkConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("subnetIds", "SubnetIds", properties.SubnetIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-mwaa/lib/index.js
var require_lib194 = __commonJS({
  "node_modules/aws-cdk-lib/aws-mwaa/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_mwaa_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-mwaa/index.js
var require_aws_mwaa = __commonJS({
  "node_modules/aws-cdk-lib/aws-mwaa/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib194(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-neptune/lib/neptune.generated.js
var require_neptune_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-neptune/lib/neptune.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnDBSubnetGroup = exports2.CfnDBParameterGroup = exports2.CfnDBInstance = exports2.CfnDBClusterParameterGroup = exports2.CfnDBCluster = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnDBClusterPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("associatedRoles", cdk.listValidator(CfnDBCluster_DBClusterRolePropertyValidator))(properties.associatedRoles)), errors.collect(cdk.propertyValidator("availabilityZones", cdk.listValidator(cdk.validateString))(properties.availabilityZones)), errors.collect(cdk.propertyValidator("backupRetentionPeriod", cdk.validateNumber)(properties.backupRetentionPeriod)), errors.collect(cdk.propertyValidator("dbClusterIdentifier", cdk.validateString)(properties.dbClusterIdentifier)), errors.collect(cdk.propertyValidator("dbClusterParameterGroupName", cdk.validateString)(properties.dbClusterParameterGroupName)), errors.collect(cdk.propertyValidator("dbSubnetGroupName", cdk.validateString)(properties.dbSubnetGroupName)), errors.collect(cdk.propertyValidator("deletionProtection", cdk.validateBoolean)(properties.deletionProtection)), errors.collect(cdk.propertyValidator("enableCloudwatchLogsExports", cdk.listValidator(cdk.validateString))(properties.enableCloudwatchLogsExports)), errors.collect(cdk.propertyValidator("engineVersion", cdk.validateString)(properties.engineVersion)), errors.collect(cdk.propertyValidator("iamAuthEnabled", cdk.validateBoolean)(properties.iamAuthEnabled)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("preferredBackupWindow", cdk.validateString)(properties.preferredBackupWindow)), errors.collect(cdk.propertyValidator("preferredMaintenanceWindow", cdk.validateString)(properties.preferredMaintenanceWindow)), errors.collect(cdk.propertyValidator("restoreToTime", cdk.validateString)(properties.restoreToTime)), errors.collect(cdk.propertyValidator("restoreType", cdk.validateString)(properties.restoreType)), errors.collect(cdk.propertyValidator("snapshotIdentifier", cdk.validateString)(properties.snapshotIdentifier)), errors.collect(cdk.propertyValidator("sourceDbClusterIdentifier", cdk.validateString)(properties.sourceDbClusterIdentifier)), errors.collect(cdk.propertyValidator("storageEncrypted", cdk.validateBoolean)(properties.storageEncrypted)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("useLatestRestorableTime", cdk.validateBoolean)(properties.useLatestRestorableTime)), errors.collect(cdk.propertyValidator("vpcSecurityGroupIds", cdk.listValidator(cdk.validateString))(properties.vpcSecurityGroupIds)), errors.wrap('supplied properties not correct for "CfnDBClusterProps"');
    }
    function cfnDBClusterPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBClusterPropsValidator(properties).assertSuccess(), { AssociatedRoles: cdk.listMapper(cfnDBClusterDBClusterRolePropertyToCloudFormation)(properties.associatedRoles), AvailabilityZones: cdk.listMapper(cdk.stringToCloudFormation)(properties.availabilityZones), BackupRetentionPeriod: cdk.numberToCloudFormation(properties.backupRetentionPeriod), DBClusterIdentifier: cdk.stringToCloudFormation(properties.dbClusterIdentifier), DBClusterParameterGroupName: cdk.stringToCloudFormation(properties.dbClusterParameterGroupName), DBSubnetGroupName: cdk.stringToCloudFormation(properties.dbSubnetGroupName), DeletionProtection: cdk.booleanToCloudFormation(properties.deletionProtection), EnableCloudwatchLogsExports: cdk.listMapper(cdk.stringToCloudFormation)(properties.enableCloudwatchLogsExports), EngineVersion: cdk.stringToCloudFormation(properties.engineVersion), IamAuthEnabled: cdk.booleanToCloudFormation(properties.iamAuthEnabled), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), Port: cdk.numberToCloudFormation(properties.port), PreferredBackupWindow: cdk.stringToCloudFormation(properties.preferredBackupWindow), PreferredMaintenanceWindow: cdk.stringToCloudFormation(properties.preferredMaintenanceWindow), RestoreToTime: cdk.stringToCloudFormation(properties.restoreToTime), RestoreType: cdk.stringToCloudFormation(properties.restoreType), SnapshotIdentifier: cdk.stringToCloudFormation(properties.snapshotIdentifier), SourceDBClusterIdentifier: cdk.stringToCloudFormation(properties.sourceDbClusterIdentifier), StorageEncrypted: cdk.booleanToCloudFormation(properties.storageEncrypted), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), UseLatestRestorableTime: cdk.booleanToCloudFormation(properties.useLatestRestorableTime), VpcSecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.vpcSecurityGroupIds) }) : properties;
    }
    function CfnDBClusterPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("associatedRoles", "AssociatedRoles", properties.AssociatedRoles != null ? cfn_parse.FromCloudFormation.getArray(CfnDBClusterDBClusterRolePropertyFromCloudFormation)(properties.AssociatedRoles) : void 0), ret.addPropertyResult("availabilityZones", "AvailabilityZones", properties.AvailabilityZones != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AvailabilityZones) : void 0), ret.addPropertyResult("backupRetentionPeriod", "BackupRetentionPeriod", properties.BackupRetentionPeriod != null ? cfn_parse.FromCloudFormation.getNumber(properties.BackupRetentionPeriod) : void 0), ret.addPropertyResult("dbClusterIdentifier", "DBClusterIdentifier", properties.DBClusterIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.DBClusterIdentifier) : void 0), ret.addPropertyResult("dbClusterParameterGroupName", "DBClusterParameterGroupName", properties.DBClusterParameterGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.DBClusterParameterGroupName) : void 0), ret.addPropertyResult("dbSubnetGroupName", "DBSubnetGroupName", properties.DBSubnetGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.DBSubnetGroupName) : void 0), ret.addPropertyResult("deletionProtection", "DeletionProtection", properties.DeletionProtection != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeletionProtection) : void 0), ret.addPropertyResult("enableCloudwatchLogsExports", "EnableCloudwatchLogsExports", properties.EnableCloudwatchLogsExports != null ? cfn_parse.FromCloudFormation.getStringArray(properties.EnableCloudwatchLogsExports) : void 0), ret.addPropertyResult("engineVersion", "EngineVersion", properties.EngineVersion != null ? cfn_parse.FromCloudFormation.getString(properties.EngineVersion) : void 0), ret.addPropertyResult("iamAuthEnabled", "IamAuthEnabled", properties.IamAuthEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IamAuthEnabled) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addPropertyResult("preferredBackupWindow", "PreferredBackupWindow", properties.PreferredBackupWindow != null ? cfn_parse.FromCloudFormation.getString(properties.PreferredBackupWindow) : void 0), ret.addPropertyResult("preferredMaintenanceWindow", "PreferredMaintenanceWindow", properties.PreferredMaintenanceWindow != null ? cfn_parse.FromCloudFormation.getString(properties.PreferredMaintenanceWindow) : void 0), ret.addPropertyResult("restoreToTime", "RestoreToTime", properties.RestoreToTime != null ? cfn_parse.FromCloudFormation.getString(properties.RestoreToTime) : void 0), ret.addPropertyResult("restoreType", "RestoreType", properties.RestoreType != null ? cfn_parse.FromCloudFormation.getString(properties.RestoreType) : void 0), ret.addPropertyResult("snapshotIdentifier", "SnapshotIdentifier", properties.SnapshotIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.SnapshotIdentifier) : void 0), ret.addPropertyResult("sourceDbClusterIdentifier", "SourceDBClusterIdentifier", properties.SourceDBClusterIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.SourceDBClusterIdentifier) : void 0), ret.addPropertyResult("storageEncrypted", "StorageEncrypted", properties.StorageEncrypted != null ? cfn_parse.FromCloudFormation.getBoolean(properties.StorageEncrypted) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("useLatestRestorableTime", "UseLatestRestorableTime", properties.UseLatestRestorableTime != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseLatestRestorableTime) : void 0), ret.addPropertyResult("vpcSecurityGroupIds", "VpcSecurityGroupIds", properties.VpcSecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.VpcSecurityGroupIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDBCluster = class _CfnDBCluster extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDBClusterPropsFromCloudFormation(resourceProperties), ret = new _CfnDBCluster(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnDBCluster.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_neptune_CfnDBClusterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDBCluster), error;
        }
        this.attrClusterResourceId = cdk.Token.asString(this.getAtt("ClusterResourceId", cdk.ResolutionTypeHint.STRING)), this.attrEndpoint = cdk.Token.asString(this.getAtt("Endpoint", cdk.ResolutionTypeHint.STRING)), this.attrPort = cdk.Token.asString(this.getAtt("Port", cdk.ResolutionTypeHint.STRING)), this.attrReadEndpoint = cdk.Token.asString(this.getAtt("ReadEndpoint", cdk.ResolutionTypeHint.STRING)), this.associatedRoles = props.associatedRoles, this.availabilityZones = props.availabilityZones, this.backupRetentionPeriod = props.backupRetentionPeriod, this.dbClusterIdentifier = props.dbClusterIdentifier, this.dbClusterParameterGroupName = props.dbClusterParameterGroupName, this.dbSubnetGroupName = props.dbSubnetGroupName, this.deletionProtection = props.deletionProtection, this.enableCloudwatchLogsExports = props.enableCloudwatchLogsExports, this.engineVersion = props.engineVersion, this.iamAuthEnabled = props.iamAuthEnabled, this.kmsKeyId = props.kmsKeyId, this.port = props.port, this.preferredBackupWindow = props.preferredBackupWindow, this.preferredMaintenanceWindow = props.preferredMaintenanceWindow, this.restoreToTime = props.restoreToTime, this.restoreType = props.restoreType, this.snapshotIdentifier = props.snapshotIdentifier, this.sourceDbClusterIdentifier = props.sourceDbClusterIdentifier, this.storageEncrypted = props.storageEncrypted, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Neptune::DBCluster", props.tags, { tagPropertyName: "tags" }), this.useLatestRestorableTime = props.useLatestRestorableTime, this.vpcSecurityGroupIds = props.vpcSecurityGroupIds, this.node.scope && cdk.Resource.isResource(this.node.scope) && this.node.addValidation({ validate: () => this.cfnOptions.deletionPolicy === void 0 ? ["'AWS::Neptune::DBCluster' is a stateful resource type, and you must specify a Removal Policy for it. Call 'resource.applyRemovalPolicy()'."] : [] });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDBCluster.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { associatedRoles: this.associatedRoles, availabilityZones: this.availabilityZones, backupRetentionPeriod: this.backupRetentionPeriod, dbClusterIdentifier: this.dbClusterIdentifier, dbClusterParameterGroupName: this.dbClusterParameterGroupName, dbSubnetGroupName: this.dbSubnetGroupName, deletionProtection: this.deletionProtection, enableCloudwatchLogsExports: this.enableCloudwatchLogsExports, engineVersion: this.engineVersion, iamAuthEnabled: this.iamAuthEnabled, kmsKeyId: this.kmsKeyId, port: this.port, preferredBackupWindow: this.preferredBackupWindow, preferredMaintenanceWindow: this.preferredMaintenanceWindow, restoreToTime: this.restoreToTime, restoreType: this.restoreType, snapshotIdentifier: this.snapshotIdentifier, sourceDbClusterIdentifier: this.sourceDbClusterIdentifier, storageEncrypted: this.storageEncrypted, tags: this.tags.renderTags(), useLatestRestorableTime: this.useLatestRestorableTime, vpcSecurityGroupIds: this.vpcSecurityGroupIds };
      }
      renderProperties(props) {
        return cfnDBClusterPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnDBCluster[_a] = { fqn: "aws-cdk-lib.aws_neptune.CfnDBCluster", version: "2.80.0" }, CfnDBCluster.CFN_RESOURCE_TYPE_NAME = "AWS::Neptune::DBCluster", exports2.CfnDBCluster = CfnDBCluster;
    function CfnDBCluster_DBClusterRolePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("featureName", cdk.validateString)(properties.featureName)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "DBClusterRoleProperty"');
    }
    function cfnDBClusterDBClusterRolePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBCluster_DBClusterRolePropertyValidator(properties).assertSuccess(), { FeatureName: cdk.stringToCloudFormation(properties.featureName), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnDBClusterDBClusterRolePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("featureName", "FeatureName", properties.FeatureName != null ? cfn_parse.FromCloudFormation.getString(properties.FeatureName) : void 0), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDBClusterParameterGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.requiredValidator)(properties.description)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("family", cdk.requiredValidator)(properties.family)), errors.collect(cdk.propertyValidator("family", cdk.validateString)(properties.family)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("parameters", cdk.requiredValidator)(properties.parameters)), errors.collect(cdk.propertyValidator("parameters", cdk.validateObject)(properties.parameters)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDBClusterParameterGroupProps"');
    }
    function cfnDBClusterParameterGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBClusterParameterGroupPropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), Family: cdk.stringToCloudFormation(properties.family), Parameters: cdk.objectToCloudFormation(properties.parameters), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDBClusterParameterGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", cfn_parse.FromCloudFormation.getString(properties.Description)), ret.addPropertyResult("family", "Family", cfn_parse.FromCloudFormation.getString(properties.Family)), ret.addPropertyResult("parameters", "Parameters", cfn_parse.FromCloudFormation.getAny(properties.Parameters)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDBClusterParameterGroup = class _CfnDBClusterParameterGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDBClusterParameterGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnDBClusterParameterGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDBClusterParameterGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_neptune_CfnDBClusterParameterGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDBClusterParameterGroup), error;
        }
        cdk.requireProperty(props, "description", this), cdk.requireProperty(props, "family", this), cdk.requireProperty(props, "parameters", this), this.description = props.description, this.family = props.family, this.parameters = props.parameters, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Neptune::DBClusterParameterGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDBClusterParameterGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, family: this.family, parameters: this.parameters, name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDBClusterParameterGroupPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnDBClusterParameterGroup[_b] = { fqn: "aws-cdk-lib.aws_neptune.CfnDBClusterParameterGroup", version: "2.80.0" }, CfnDBClusterParameterGroup.CFN_RESOURCE_TYPE_NAME = "AWS::Neptune::DBClusterParameterGroup", exports2.CfnDBClusterParameterGroup = CfnDBClusterParameterGroup;
    function CfnDBInstancePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowMajorVersionUpgrade", cdk.validateBoolean)(properties.allowMajorVersionUpgrade)), errors.collect(cdk.propertyValidator("autoMinorVersionUpgrade", cdk.validateBoolean)(properties.autoMinorVersionUpgrade)), errors.collect(cdk.propertyValidator("availabilityZone", cdk.validateString)(properties.availabilityZone)), errors.collect(cdk.propertyValidator("dbClusterIdentifier", cdk.validateString)(properties.dbClusterIdentifier)), errors.collect(cdk.propertyValidator("dbInstanceClass", cdk.requiredValidator)(properties.dbInstanceClass)), errors.collect(cdk.propertyValidator("dbInstanceClass", cdk.validateString)(properties.dbInstanceClass)), errors.collect(cdk.propertyValidator("dbInstanceIdentifier", cdk.validateString)(properties.dbInstanceIdentifier)), errors.collect(cdk.propertyValidator("dbParameterGroupName", cdk.validateString)(properties.dbParameterGroupName)), errors.collect(cdk.propertyValidator("dbSnapshotIdentifier", cdk.validateString)(properties.dbSnapshotIdentifier)), errors.collect(cdk.propertyValidator("dbSubnetGroupName", cdk.validateString)(properties.dbSubnetGroupName)), errors.collect(cdk.propertyValidator("preferredMaintenanceWindow", cdk.validateString)(properties.preferredMaintenanceWindow)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDBInstanceProps"');
    }
    function cfnDBInstancePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBInstancePropsValidator(properties).assertSuccess(), { DBInstanceClass: cdk.stringToCloudFormation(properties.dbInstanceClass), AllowMajorVersionUpgrade: cdk.booleanToCloudFormation(properties.allowMajorVersionUpgrade), AutoMinorVersionUpgrade: cdk.booleanToCloudFormation(properties.autoMinorVersionUpgrade), AvailabilityZone: cdk.stringToCloudFormation(properties.availabilityZone), DBClusterIdentifier: cdk.stringToCloudFormation(properties.dbClusterIdentifier), DBInstanceIdentifier: cdk.stringToCloudFormation(properties.dbInstanceIdentifier), DBParameterGroupName: cdk.stringToCloudFormation(properties.dbParameterGroupName), DBSnapshotIdentifier: cdk.stringToCloudFormation(properties.dbSnapshotIdentifier), DBSubnetGroupName: cdk.stringToCloudFormation(properties.dbSubnetGroupName), PreferredMaintenanceWindow: cdk.stringToCloudFormation(properties.preferredMaintenanceWindow), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDBInstancePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dbInstanceClass", "DBInstanceClass", cfn_parse.FromCloudFormation.getString(properties.DBInstanceClass)), ret.addPropertyResult("allowMajorVersionUpgrade", "AllowMajorVersionUpgrade", properties.AllowMajorVersionUpgrade != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllowMajorVersionUpgrade) : void 0), ret.addPropertyResult("autoMinorVersionUpgrade", "AutoMinorVersionUpgrade", properties.AutoMinorVersionUpgrade != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AutoMinorVersionUpgrade) : void 0), ret.addPropertyResult("availabilityZone", "AvailabilityZone", properties.AvailabilityZone != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityZone) : void 0), ret.addPropertyResult("dbClusterIdentifier", "DBClusterIdentifier", properties.DBClusterIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.DBClusterIdentifier) : void 0), ret.addPropertyResult("dbInstanceIdentifier", "DBInstanceIdentifier", properties.DBInstanceIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.DBInstanceIdentifier) : void 0), ret.addPropertyResult("dbParameterGroupName", "DBParameterGroupName", properties.DBParameterGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.DBParameterGroupName) : void 0), ret.addPropertyResult("dbSnapshotIdentifier", "DBSnapshotIdentifier", properties.DBSnapshotIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.DBSnapshotIdentifier) : void 0), ret.addPropertyResult("dbSubnetGroupName", "DBSubnetGroupName", properties.DBSubnetGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.DBSubnetGroupName) : void 0), ret.addPropertyResult("preferredMaintenanceWindow", "PreferredMaintenanceWindow", properties.PreferredMaintenanceWindow != null ? cfn_parse.FromCloudFormation.getString(properties.PreferredMaintenanceWindow) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDBInstance = class _CfnDBInstance extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDBInstancePropsFromCloudFormation(resourceProperties), ret = new _CfnDBInstance(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDBInstance.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_neptune_CfnDBInstanceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDBInstance), error;
        }
        cdk.requireProperty(props, "dbInstanceClass", this), this.attrEndpoint = cdk.Token.asString(this.getAtt("Endpoint", cdk.ResolutionTypeHint.STRING)), this.attrPort = cdk.Token.asString(this.getAtt("Port", cdk.ResolutionTypeHint.STRING)), this.dbInstanceClass = props.dbInstanceClass, this.allowMajorVersionUpgrade = props.allowMajorVersionUpgrade, this.autoMinorVersionUpgrade = props.autoMinorVersionUpgrade, this.availabilityZone = props.availabilityZone, this.dbClusterIdentifier = props.dbClusterIdentifier, this.dbInstanceIdentifier = props.dbInstanceIdentifier, this.dbParameterGroupName = props.dbParameterGroupName, this.dbSnapshotIdentifier = props.dbSnapshotIdentifier, this.dbSubnetGroupName = props.dbSubnetGroupName, this.preferredMaintenanceWindow = props.preferredMaintenanceWindow, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Neptune::DBInstance", props.tags, { tagPropertyName: "tags" }), this.node.scope && cdk.Resource.isResource(this.node.scope) && this.node.addValidation({ validate: () => this.cfnOptions.deletionPolicy === void 0 ? ["'AWS::Neptune::DBInstance' is a stateful resource type, and you must specify a Removal Policy for it. Call 'resource.applyRemovalPolicy()'."] : [] });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDBInstance.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { dbInstanceClass: this.dbInstanceClass, allowMajorVersionUpgrade: this.allowMajorVersionUpgrade, autoMinorVersionUpgrade: this.autoMinorVersionUpgrade, availabilityZone: this.availabilityZone, dbClusterIdentifier: this.dbClusterIdentifier, dbInstanceIdentifier: this.dbInstanceIdentifier, dbParameterGroupName: this.dbParameterGroupName, dbSnapshotIdentifier: this.dbSnapshotIdentifier, dbSubnetGroupName: this.dbSubnetGroupName, preferredMaintenanceWindow: this.preferredMaintenanceWindow, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDBInstancePropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnDBInstance[_c] = { fqn: "aws-cdk-lib.aws_neptune.CfnDBInstance", version: "2.80.0" }, CfnDBInstance.CFN_RESOURCE_TYPE_NAME = "AWS::Neptune::DBInstance", exports2.CfnDBInstance = CfnDBInstance;
    function CfnDBParameterGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.requiredValidator)(properties.description)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("family", cdk.requiredValidator)(properties.family)), errors.collect(cdk.propertyValidator("family", cdk.validateString)(properties.family)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("parameters", cdk.requiredValidator)(properties.parameters)), errors.collect(cdk.propertyValidator("parameters", cdk.validateObject)(properties.parameters)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDBParameterGroupProps"');
    }
    function cfnDBParameterGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBParameterGroupPropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), Family: cdk.stringToCloudFormation(properties.family), Parameters: cdk.objectToCloudFormation(properties.parameters), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDBParameterGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", cfn_parse.FromCloudFormation.getString(properties.Description)), ret.addPropertyResult("family", "Family", cfn_parse.FromCloudFormation.getString(properties.Family)), ret.addPropertyResult("parameters", "Parameters", cfn_parse.FromCloudFormation.getAny(properties.Parameters)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDBParameterGroup = class _CfnDBParameterGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDBParameterGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnDBParameterGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDBParameterGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_neptune_CfnDBParameterGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDBParameterGroup), error;
        }
        cdk.requireProperty(props, "description", this), cdk.requireProperty(props, "family", this), cdk.requireProperty(props, "parameters", this), this.description = props.description, this.family = props.family, this.parameters = props.parameters, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Neptune::DBParameterGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDBParameterGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, family: this.family, parameters: this.parameters, name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDBParameterGroupPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnDBParameterGroup[_d] = { fqn: "aws-cdk-lib.aws_neptune.CfnDBParameterGroup", version: "2.80.0" }, CfnDBParameterGroup.CFN_RESOURCE_TYPE_NAME = "AWS::Neptune::DBParameterGroup", exports2.CfnDBParameterGroup = CfnDBParameterGroup;
    function CfnDBSubnetGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dbSubnetGroupDescription", cdk.requiredValidator)(properties.dbSubnetGroupDescription)), errors.collect(cdk.propertyValidator("dbSubnetGroupDescription", cdk.validateString)(properties.dbSubnetGroupDescription)), errors.collect(cdk.propertyValidator("dbSubnetGroupName", cdk.validateString)(properties.dbSubnetGroupName)), errors.collect(cdk.propertyValidator("subnetIds", cdk.requiredValidator)(properties.subnetIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDBSubnetGroupProps"');
    }
    function cfnDBSubnetGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDBSubnetGroupPropsValidator(properties).assertSuccess(), { DBSubnetGroupDescription: cdk.stringToCloudFormation(properties.dbSubnetGroupDescription), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds), DBSubnetGroupName: cdk.stringToCloudFormation(properties.dbSubnetGroupName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDBSubnetGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dbSubnetGroupDescription", "DBSubnetGroupDescription", cfn_parse.FromCloudFormation.getString(properties.DBSubnetGroupDescription)), ret.addPropertyResult("subnetIds", "SubnetIds", cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds)), ret.addPropertyResult("dbSubnetGroupName", "DBSubnetGroupName", properties.DBSubnetGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.DBSubnetGroupName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDBSubnetGroup = class _CfnDBSubnetGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDBSubnetGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnDBSubnetGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDBSubnetGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_neptune_CfnDBSubnetGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDBSubnetGroup), error;
        }
        cdk.requireProperty(props, "dbSubnetGroupDescription", this), cdk.requireProperty(props, "subnetIds", this), this.dbSubnetGroupDescription = props.dbSubnetGroupDescription, this.subnetIds = props.subnetIds, this.dbSubnetGroupName = props.dbSubnetGroupName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Neptune::DBSubnetGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDBSubnetGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { dbSubnetGroupDescription: this.dbSubnetGroupDescription, subnetIds: this.subnetIds, dbSubnetGroupName: this.dbSubnetGroupName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDBSubnetGroupPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnDBSubnetGroup[_e] = { fqn: "aws-cdk-lib.aws_neptune.CfnDBSubnetGroup", version: "2.80.0" }, CfnDBSubnetGroup.CFN_RESOURCE_TYPE_NAME = "AWS::Neptune::DBSubnetGroup", exports2.CfnDBSubnetGroup = CfnDBSubnetGroup;
  }
});

// node_modules/aws-cdk-lib/aws-neptune/lib/index.js
var require_lib195 = __commonJS({
  "node_modules/aws-cdk-lib/aws-neptune/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_neptune_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-neptune/index.js
var require_aws_neptune = __commonJS({
  "node_modules/aws-cdk-lib/aws-neptune/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib195(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-networkfirewall/lib/networkfirewall.generated.js
var require_networkfirewall_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-networkfirewall/lib/networkfirewall.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnRuleGroup = exports2.CfnLoggingConfiguration = exports2.CfnFirewallPolicy = exports2.CfnFirewall = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnFirewallPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deleteProtection", cdk.validateBoolean)(properties.deleteProtection)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("firewallName", cdk.requiredValidator)(properties.firewallName)), errors.collect(cdk.propertyValidator("firewallName", cdk.validateString)(properties.firewallName)), errors.collect(cdk.propertyValidator("firewallPolicyArn", cdk.requiredValidator)(properties.firewallPolicyArn)), errors.collect(cdk.propertyValidator("firewallPolicyArn", cdk.validateString)(properties.firewallPolicyArn)), errors.collect(cdk.propertyValidator("firewallPolicyChangeProtection", cdk.validateBoolean)(properties.firewallPolicyChangeProtection)), errors.collect(cdk.propertyValidator("subnetChangeProtection", cdk.validateBoolean)(properties.subnetChangeProtection)), errors.collect(cdk.propertyValidator("subnetMappings", cdk.requiredValidator)(properties.subnetMappings)), errors.collect(cdk.propertyValidator("subnetMappings", cdk.listValidator(CfnFirewall_SubnetMappingPropertyValidator))(properties.subnetMappings)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpcId", cdk.requiredValidator)(properties.vpcId)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "CfnFirewallProps"');
    }
    function cfnFirewallPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFirewallPropsValidator(properties).assertSuccess(), { FirewallName: cdk.stringToCloudFormation(properties.firewallName), FirewallPolicyArn: cdk.stringToCloudFormation(properties.firewallPolicyArn), SubnetMappings: cdk.listMapper(cfnFirewallSubnetMappingPropertyToCloudFormation)(properties.subnetMappings), VpcId: cdk.stringToCloudFormation(properties.vpcId), DeleteProtection: cdk.booleanToCloudFormation(properties.deleteProtection), Description: cdk.stringToCloudFormation(properties.description), FirewallPolicyChangeProtection: cdk.booleanToCloudFormation(properties.firewallPolicyChangeProtection), SubnetChangeProtection: cdk.booleanToCloudFormation(properties.subnetChangeProtection), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnFirewallPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("firewallName", "FirewallName", cfn_parse.FromCloudFormation.getString(properties.FirewallName)), ret.addPropertyResult("firewallPolicyArn", "FirewallPolicyArn", cfn_parse.FromCloudFormation.getString(properties.FirewallPolicyArn)), ret.addPropertyResult("subnetMappings", "SubnetMappings", cfn_parse.FromCloudFormation.getArray(CfnFirewallSubnetMappingPropertyFromCloudFormation)(properties.SubnetMappings)), ret.addPropertyResult("vpcId", "VpcId", cfn_parse.FromCloudFormation.getString(properties.VpcId)), ret.addPropertyResult("deleteProtection", "DeleteProtection", properties.DeleteProtection != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeleteProtection) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("firewallPolicyChangeProtection", "FirewallPolicyChangeProtection", properties.FirewallPolicyChangeProtection != null ? cfn_parse.FromCloudFormation.getBoolean(properties.FirewallPolicyChangeProtection) : void 0), ret.addPropertyResult("subnetChangeProtection", "SubnetChangeProtection", properties.SubnetChangeProtection != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SubnetChangeProtection) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFirewall = class _CfnFirewall extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFirewallPropsFromCloudFormation(resourceProperties), ret = new _CfnFirewall(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFirewall.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_networkfirewall_CfnFirewallProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFirewall), error;
        }
        cdk.requireProperty(props, "firewallName", this), cdk.requireProperty(props, "firewallPolicyArn", this), cdk.requireProperty(props, "subnetMappings", this), cdk.requireProperty(props, "vpcId", this), this.attrEndpointIds = cdk.Token.asList(this.getAtt("EndpointIds", cdk.ResolutionTypeHint.STRING_LIST)), this.attrFirewallArn = cdk.Token.asString(this.getAtt("FirewallArn", cdk.ResolutionTypeHint.STRING)), this.attrFirewallId = cdk.Token.asString(this.getAtt("FirewallId", cdk.ResolutionTypeHint.STRING)), this.firewallName = props.firewallName, this.firewallPolicyArn = props.firewallPolicyArn, this.subnetMappings = props.subnetMappings, this.vpcId = props.vpcId, this.deleteProtection = props.deleteProtection, this.description = props.description, this.firewallPolicyChangeProtection = props.firewallPolicyChangeProtection, this.subnetChangeProtection = props.subnetChangeProtection, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::NetworkFirewall::Firewall", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFirewall.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { firewallName: this.firewallName, firewallPolicyArn: this.firewallPolicyArn, subnetMappings: this.subnetMappings, vpcId: this.vpcId, deleteProtection: this.deleteProtection, description: this.description, firewallPolicyChangeProtection: this.firewallPolicyChangeProtection, subnetChangeProtection: this.subnetChangeProtection, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnFirewallPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnFirewall[_a] = { fqn: "aws-cdk-lib.aws_networkfirewall.CfnFirewall", version: "2.80.0" }, CfnFirewall.CFN_RESOURCE_TYPE_NAME = "AWS::NetworkFirewall::Firewall", exports2.CfnFirewall = CfnFirewall;
    function CfnFirewall_SubnetMappingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ipAddressType", cdk.validateString)(properties.ipAddressType)), errors.collect(cdk.propertyValidator("subnetId", cdk.requiredValidator)(properties.subnetId)), errors.collect(cdk.propertyValidator("subnetId", cdk.validateString)(properties.subnetId)), errors.wrap('supplied properties not correct for "SubnetMappingProperty"');
    }
    function cfnFirewallSubnetMappingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFirewall_SubnetMappingPropertyValidator(properties).assertSuccess(), { IPAddressType: cdk.stringToCloudFormation(properties.ipAddressType), SubnetId: cdk.stringToCloudFormation(properties.subnetId) }) : properties;
    }
    function CfnFirewallSubnetMappingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ipAddressType", "IPAddressType", properties.IPAddressType != null ? cfn_parse.FromCloudFormation.getString(properties.IPAddressType) : void 0), ret.addPropertyResult("subnetId", "SubnetId", cfn_parse.FromCloudFormation.getString(properties.SubnetId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFirewallPolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("firewallPolicy", cdk.requiredValidator)(properties.firewallPolicy)), errors.collect(cdk.propertyValidator("firewallPolicy", CfnFirewallPolicy_FirewallPolicyPropertyValidator)(properties.firewallPolicy)), errors.collect(cdk.propertyValidator("firewallPolicyName", cdk.requiredValidator)(properties.firewallPolicyName)), errors.collect(cdk.propertyValidator("firewallPolicyName", cdk.validateString)(properties.firewallPolicyName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnFirewallPolicyProps"');
    }
    function cfnFirewallPolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFirewallPolicyPropsValidator(properties).assertSuccess(), { FirewallPolicy: cfnFirewallPolicyFirewallPolicyPropertyToCloudFormation(properties.firewallPolicy), FirewallPolicyName: cdk.stringToCloudFormation(properties.firewallPolicyName), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnFirewallPolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("firewallPolicy", "FirewallPolicy", CfnFirewallPolicyFirewallPolicyPropertyFromCloudFormation(properties.FirewallPolicy)), ret.addPropertyResult("firewallPolicyName", "FirewallPolicyName", cfn_parse.FromCloudFormation.getString(properties.FirewallPolicyName)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFirewallPolicy = class _CfnFirewallPolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFirewallPolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnFirewallPolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFirewallPolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_networkfirewall_CfnFirewallPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFirewallPolicy), error;
        }
        cdk.requireProperty(props, "firewallPolicy", this), cdk.requireProperty(props, "firewallPolicyName", this), this.attrFirewallPolicyArn = cdk.Token.asString(this.getAtt("FirewallPolicyArn", cdk.ResolutionTypeHint.STRING)), this.attrFirewallPolicyId = cdk.Token.asString(this.getAtt("FirewallPolicyId", cdk.ResolutionTypeHint.STRING)), this.firewallPolicy = props.firewallPolicy, this.firewallPolicyName = props.firewallPolicyName, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::NetworkFirewall::FirewallPolicy", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFirewallPolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { firewallPolicy: this.firewallPolicy, firewallPolicyName: this.firewallPolicyName, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnFirewallPolicyPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnFirewallPolicy[_b] = { fqn: "aws-cdk-lib.aws_networkfirewall.CfnFirewallPolicy", version: "2.80.0" }, CfnFirewallPolicy.CFN_RESOURCE_TYPE_NAME = "AWS::NetworkFirewall::FirewallPolicy", exports2.CfnFirewallPolicy = CfnFirewallPolicy;
    function CfnFirewallPolicy_ActionDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("publishMetricAction", CfnFirewallPolicy_PublishMetricActionPropertyValidator)(properties.publishMetricAction)), errors.wrap('supplied properties not correct for "ActionDefinitionProperty"');
    }
    function cfnFirewallPolicyActionDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFirewallPolicy_ActionDefinitionPropertyValidator(properties).assertSuccess(), { PublishMetricAction: cfnFirewallPolicyPublishMetricActionPropertyToCloudFormation(properties.publishMetricAction) }) : properties;
    }
    function CfnFirewallPolicyActionDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("publishMetricAction", "PublishMetricAction", properties.PublishMetricAction != null ? CfnFirewallPolicyPublishMetricActionPropertyFromCloudFormation(properties.PublishMetricAction) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFirewallPolicy_CustomActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actionDefinition", cdk.requiredValidator)(properties.actionDefinition)), errors.collect(cdk.propertyValidator("actionDefinition", CfnFirewallPolicy_ActionDefinitionPropertyValidator)(properties.actionDefinition)), errors.collect(cdk.propertyValidator("actionName", cdk.requiredValidator)(properties.actionName)), errors.collect(cdk.propertyValidator("actionName", cdk.validateString)(properties.actionName)), errors.wrap('supplied properties not correct for "CustomActionProperty"');
    }
    function cfnFirewallPolicyCustomActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFirewallPolicy_CustomActionPropertyValidator(properties).assertSuccess(), { ActionDefinition: cfnFirewallPolicyActionDefinitionPropertyToCloudFormation(properties.actionDefinition), ActionName: cdk.stringToCloudFormation(properties.actionName) }) : properties;
    }
    function CfnFirewallPolicyCustomActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actionDefinition", "ActionDefinition", CfnFirewallPolicyActionDefinitionPropertyFromCloudFormation(properties.ActionDefinition)), ret.addPropertyResult("actionName", "ActionName", cfn_parse.FromCloudFormation.getString(properties.ActionName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFirewallPolicy_DimensionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "DimensionProperty"');
    }
    function cfnFirewallPolicyDimensionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFirewallPolicy_DimensionPropertyValidator(properties).assertSuccess(), { Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnFirewallPolicyDimensionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFirewallPolicy_FirewallPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("policyVariables", CfnFirewallPolicy_PolicyVariablesPropertyValidator)(properties.policyVariables)), errors.collect(cdk.propertyValidator("statefulDefaultActions", cdk.listValidator(cdk.validateString))(properties.statefulDefaultActions)), errors.collect(cdk.propertyValidator("statefulEngineOptions", CfnFirewallPolicy_StatefulEngineOptionsPropertyValidator)(properties.statefulEngineOptions)), errors.collect(cdk.propertyValidator("statefulRuleGroupReferences", cdk.listValidator(CfnFirewallPolicy_StatefulRuleGroupReferencePropertyValidator))(properties.statefulRuleGroupReferences)), errors.collect(cdk.propertyValidator("statelessCustomActions", cdk.listValidator(CfnFirewallPolicy_CustomActionPropertyValidator))(properties.statelessCustomActions)), errors.collect(cdk.propertyValidator("statelessDefaultActions", cdk.requiredValidator)(properties.statelessDefaultActions)), errors.collect(cdk.propertyValidator("statelessDefaultActions", cdk.listValidator(cdk.validateString))(properties.statelessDefaultActions)), errors.collect(cdk.propertyValidator("statelessFragmentDefaultActions", cdk.requiredValidator)(properties.statelessFragmentDefaultActions)), errors.collect(cdk.propertyValidator("statelessFragmentDefaultActions", cdk.listValidator(cdk.validateString))(properties.statelessFragmentDefaultActions)), errors.collect(cdk.propertyValidator("statelessRuleGroupReferences", cdk.listValidator(CfnFirewallPolicy_StatelessRuleGroupReferencePropertyValidator))(properties.statelessRuleGroupReferences)), errors.wrap('supplied properties not correct for "FirewallPolicyProperty"');
    }
    function cfnFirewallPolicyFirewallPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFirewallPolicy_FirewallPolicyPropertyValidator(properties).assertSuccess(), { PolicyVariables: cfnFirewallPolicyPolicyVariablesPropertyToCloudFormation(properties.policyVariables), StatefulDefaultActions: cdk.listMapper(cdk.stringToCloudFormation)(properties.statefulDefaultActions), StatefulEngineOptions: cfnFirewallPolicyStatefulEngineOptionsPropertyToCloudFormation(properties.statefulEngineOptions), StatefulRuleGroupReferences: cdk.listMapper(cfnFirewallPolicyStatefulRuleGroupReferencePropertyToCloudFormation)(properties.statefulRuleGroupReferences), StatelessCustomActions: cdk.listMapper(cfnFirewallPolicyCustomActionPropertyToCloudFormation)(properties.statelessCustomActions), StatelessDefaultActions: cdk.listMapper(cdk.stringToCloudFormation)(properties.statelessDefaultActions), StatelessFragmentDefaultActions: cdk.listMapper(cdk.stringToCloudFormation)(properties.statelessFragmentDefaultActions), StatelessRuleGroupReferences: cdk.listMapper(cfnFirewallPolicyStatelessRuleGroupReferencePropertyToCloudFormation)(properties.statelessRuleGroupReferences) }) : properties;
    }
    function CfnFirewallPolicyFirewallPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("policyVariables", "PolicyVariables", properties.PolicyVariables != null ? CfnFirewallPolicyPolicyVariablesPropertyFromCloudFormation(properties.PolicyVariables) : void 0), ret.addPropertyResult("statefulDefaultActions", "StatefulDefaultActions", properties.StatefulDefaultActions != null ? cfn_parse.FromCloudFormation.getStringArray(properties.StatefulDefaultActions) : void 0), ret.addPropertyResult("statefulEngineOptions", "StatefulEngineOptions", properties.StatefulEngineOptions != null ? CfnFirewallPolicyStatefulEngineOptionsPropertyFromCloudFormation(properties.StatefulEngineOptions) : void 0), ret.addPropertyResult("statefulRuleGroupReferences", "StatefulRuleGroupReferences", properties.StatefulRuleGroupReferences != null ? cfn_parse.FromCloudFormation.getArray(CfnFirewallPolicyStatefulRuleGroupReferencePropertyFromCloudFormation)(properties.StatefulRuleGroupReferences) : void 0), ret.addPropertyResult("statelessCustomActions", "StatelessCustomActions", properties.StatelessCustomActions != null ? cfn_parse.FromCloudFormation.getArray(CfnFirewallPolicyCustomActionPropertyFromCloudFormation)(properties.StatelessCustomActions) : void 0), ret.addPropertyResult("statelessDefaultActions", "StatelessDefaultActions", cfn_parse.FromCloudFormation.getStringArray(properties.StatelessDefaultActions)), ret.addPropertyResult("statelessFragmentDefaultActions", "StatelessFragmentDefaultActions", cfn_parse.FromCloudFormation.getStringArray(properties.StatelessFragmentDefaultActions)), ret.addPropertyResult("statelessRuleGroupReferences", "StatelessRuleGroupReferences", properties.StatelessRuleGroupReferences != null ? cfn_parse.FromCloudFormation.getArray(CfnFirewallPolicyStatelessRuleGroupReferencePropertyFromCloudFormation)(properties.StatelessRuleGroupReferences) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFirewallPolicy_IPSetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("definition", cdk.listValidator(cdk.validateString))(properties.definition)), errors.wrap('supplied properties not correct for "IPSetProperty"');
    }
    function cfnFirewallPolicyIPSetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFirewallPolicy_IPSetPropertyValidator(properties).assertSuccess(), { Definition: cdk.listMapper(cdk.stringToCloudFormation)(properties.definition) }) : properties;
    }
    function CfnFirewallPolicyIPSetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("definition", "Definition", properties.Definition != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Definition) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFirewallPolicy_PolicyVariablesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ruleVariables", cdk.hashValidator(CfnFirewallPolicy_IPSetPropertyValidator))(properties.ruleVariables)), errors.wrap('supplied properties not correct for "PolicyVariablesProperty"');
    }
    function cfnFirewallPolicyPolicyVariablesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFirewallPolicy_PolicyVariablesPropertyValidator(properties).assertSuccess(), { RuleVariables: cdk.hashMapper(cfnFirewallPolicyIPSetPropertyToCloudFormation)(properties.ruleVariables) }) : properties;
    }
    function CfnFirewallPolicyPolicyVariablesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ruleVariables", "RuleVariables", properties.RuleVariables != null ? cfn_parse.FromCloudFormation.getMap(CfnFirewallPolicyIPSetPropertyFromCloudFormation)(properties.RuleVariables) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFirewallPolicy_PublishMetricActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dimensions", cdk.requiredValidator)(properties.dimensions)), errors.collect(cdk.propertyValidator("dimensions", cdk.listValidator(CfnFirewallPolicy_DimensionPropertyValidator))(properties.dimensions)), errors.wrap('supplied properties not correct for "PublishMetricActionProperty"');
    }
    function cfnFirewallPolicyPublishMetricActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFirewallPolicy_PublishMetricActionPropertyValidator(properties).assertSuccess(), { Dimensions: cdk.listMapper(cfnFirewallPolicyDimensionPropertyToCloudFormation)(properties.dimensions) }) : properties;
    }
    function CfnFirewallPolicyPublishMetricActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dimensions", "Dimensions", cfn_parse.FromCloudFormation.getArray(CfnFirewallPolicyDimensionPropertyFromCloudFormation)(properties.Dimensions)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFirewallPolicy_StatefulEngineOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ruleOrder", cdk.validateString)(properties.ruleOrder)), errors.collect(cdk.propertyValidator("streamExceptionPolicy", cdk.validateString)(properties.streamExceptionPolicy)), errors.wrap('supplied properties not correct for "StatefulEngineOptionsProperty"');
    }
    function cfnFirewallPolicyStatefulEngineOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFirewallPolicy_StatefulEngineOptionsPropertyValidator(properties).assertSuccess(), { RuleOrder: cdk.stringToCloudFormation(properties.ruleOrder), StreamExceptionPolicy: cdk.stringToCloudFormation(properties.streamExceptionPolicy) }) : properties;
    }
    function CfnFirewallPolicyStatefulEngineOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ruleOrder", "RuleOrder", properties.RuleOrder != null ? cfn_parse.FromCloudFormation.getString(properties.RuleOrder) : void 0), ret.addPropertyResult("streamExceptionPolicy", "StreamExceptionPolicy", properties.StreamExceptionPolicy != null ? cfn_parse.FromCloudFormation.getString(properties.StreamExceptionPolicy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFirewallPolicy_StatefulRuleGroupOverridePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.validateString)(properties.action)), errors.wrap('supplied properties not correct for "StatefulRuleGroupOverrideProperty"');
    }
    function cfnFirewallPolicyStatefulRuleGroupOverridePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFirewallPolicy_StatefulRuleGroupOverridePropertyValidator(properties).assertSuccess(), { Action: cdk.stringToCloudFormation(properties.action) }) : properties;
    }
    function CfnFirewallPolicyStatefulRuleGroupOverridePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", properties.Action != null ? cfn_parse.FromCloudFormation.getString(properties.Action) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFirewallPolicy_StatefulRuleGroupReferencePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("override", CfnFirewallPolicy_StatefulRuleGroupOverridePropertyValidator)(properties.override)), errors.collect(cdk.propertyValidator("priority", cdk.validateNumber)(properties.priority)), errors.collect(cdk.propertyValidator("resourceArn", cdk.requiredValidator)(properties.resourceArn)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.wrap('supplied properties not correct for "StatefulRuleGroupReferenceProperty"');
    }
    function cfnFirewallPolicyStatefulRuleGroupReferencePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFirewallPolicy_StatefulRuleGroupReferencePropertyValidator(properties).assertSuccess(), { Override: cfnFirewallPolicyStatefulRuleGroupOverridePropertyToCloudFormation(properties.override), Priority: cdk.numberToCloudFormation(properties.priority), ResourceArn: cdk.stringToCloudFormation(properties.resourceArn) }) : properties;
    }
    function CfnFirewallPolicyStatefulRuleGroupReferencePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("override", "Override", properties.Override != null ? CfnFirewallPolicyStatefulRuleGroupOverridePropertyFromCloudFormation(properties.Override) : void 0), ret.addPropertyResult("priority", "Priority", properties.Priority != null ? cfn_parse.FromCloudFormation.getNumber(properties.Priority) : void 0), ret.addPropertyResult("resourceArn", "ResourceArn", cfn_parse.FromCloudFormation.getString(properties.ResourceArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFirewallPolicy_StatelessRuleGroupReferencePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("priority", cdk.requiredValidator)(properties.priority)), errors.collect(cdk.propertyValidator("priority", cdk.validateNumber)(properties.priority)), errors.collect(cdk.propertyValidator("resourceArn", cdk.requiredValidator)(properties.resourceArn)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.wrap('supplied properties not correct for "StatelessRuleGroupReferenceProperty"');
    }
    function cfnFirewallPolicyStatelessRuleGroupReferencePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFirewallPolicy_StatelessRuleGroupReferencePropertyValidator(properties).assertSuccess(), { Priority: cdk.numberToCloudFormation(properties.priority), ResourceArn: cdk.stringToCloudFormation(properties.resourceArn) }) : properties;
    }
    function CfnFirewallPolicyStatelessRuleGroupReferencePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("priority", "Priority", cfn_parse.FromCloudFormation.getNumber(properties.Priority)), ret.addPropertyResult("resourceArn", "ResourceArn", cfn_parse.FromCloudFormation.getString(properties.ResourceArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLoggingConfigurationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("firewallArn", cdk.requiredValidator)(properties.firewallArn)), errors.collect(cdk.propertyValidator("firewallArn", cdk.validateString)(properties.firewallArn)), errors.collect(cdk.propertyValidator("firewallName", cdk.validateString)(properties.firewallName)), errors.collect(cdk.propertyValidator("loggingConfiguration", cdk.requiredValidator)(properties.loggingConfiguration)), errors.collect(cdk.propertyValidator("loggingConfiguration", CfnLoggingConfiguration_LoggingConfigurationPropertyValidator)(properties.loggingConfiguration)), errors.wrap('supplied properties not correct for "CfnLoggingConfigurationProps"');
    }
    function cfnLoggingConfigurationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLoggingConfigurationPropsValidator(properties).assertSuccess(), { FirewallArn: cdk.stringToCloudFormation(properties.firewallArn), LoggingConfiguration: cfnLoggingConfigurationLoggingConfigurationPropertyToCloudFormation(properties.loggingConfiguration), FirewallName: cdk.stringToCloudFormation(properties.firewallName) }) : properties;
    }
    function CfnLoggingConfigurationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("firewallArn", "FirewallArn", cfn_parse.FromCloudFormation.getString(properties.FirewallArn)), ret.addPropertyResult("loggingConfiguration", "LoggingConfiguration", CfnLoggingConfigurationLoggingConfigurationPropertyFromCloudFormation(properties.LoggingConfiguration)), ret.addPropertyResult("firewallName", "FirewallName", properties.FirewallName != null ? cfn_parse.FromCloudFormation.getString(properties.FirewallName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLoggingConfiguration = class _CfnLoggingConfiguration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLoggingConfigurationPropsFromCloudFormation(resourceProperties), ret = new _CfnLoggingConfiguration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLoggingConfiguration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_networkfirewall_CfnLoggingConfigurationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLoggingConfiguration), error;
        }
        cdk.requireProperty(props, "firewallArn", this), cdk.requireProperty(props, "loggingConfiguration", this), this.firewallArn = props.firewallArn, this.loggingConfiguration = props.loggingConfiguration, this.firewallName = props.firewallName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLoggingConfiguration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { firewallArn: this.firewallArn, loggingConfiguration: this.loggingConfiguration, firewallName: this.firewallName };
      }
      renderProperties(props) {
        return cfnLoggingConfigurationPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnLoggingConfiguration[_c] = { fqn: "aws-cdk-lib.aws_networkfirewall.CfnLoggingConfiguration", version: "2.80.0" }, CfnLoggingConfiguration.CFN_RESOURCE_TYPE_NAME = "AWS::NetworkFirewall::LoggingConfiguration", exports2.CfnLoggingConfiguration = CfnLoggingConfiguration;
    function CfnLoggingConfiguration_LogDestinationConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logDestination", cdk.requiredValidator)(properties.logDestination)), errors.collect(cdk.propertyValidator("logDestination", cdk.hashValidator(cdk.validateString))(properties.logDestination)), errors.collect(cdk.propertyValidator("logDestinationType", cdk.requiredValidator)(properties.logDestinationType)), errors.collect(cdk.propertyValidator("logDestinationType", cdk.validateString)(properties.logDestinationType)), errors.collect(cdk.propertyValidator("logType", cdk.requiredValidator)(properties.logType)), errors.collect(cdk.propertyValidator("logType", cdk.validateString)(properties.logType)), errors.wrap('supplied properties not correct for "LogDestinationConfigProperty"');
    }
    function cfnLoggingConfigurationLogDestinationConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLoggingConfiguration_LogDestinationConfigPropertyValidator(properties).assertSuccess(), { LogDestination: cdk.hashMapper(cdk.stringToCloudFormation)(properties.logDestination), LogDestinationType: cdk.stringToCloudFormation(properties.logDestinationType), LogType: cdk.stringToCloudFormation(properties.logType) }) : properties;
    }
    function CfnLoggingConfigurationLogDestinationConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logDestination", "LogDestination", cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.LogDestination)), ret.addPropertyResult("logDestinationType", "LogDestinationType", cfn_parse.FromCloudFormation.getString(properties.LogDestinationType)), ret.addPropertyResult("logType", "LogType", cfn_parse.FromCloudFormation.getString(properties.LogType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLoggingConfiguration_LoggingConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logDestinationConfigs", cdk.requiredValidator)(properties.logDestinationConfigs)), errors.collect(cdk.propertyValidator("logDestinationConfigs", cdk.listValidator(CfnLoggingConfiguration_LogDestinationConfigPropertyValidator))(properties.logDestinationConfigs)), errors.wrap('supplied properties not correct for "LoggingConfigurationProperty"');
    }
    function cfnLoggingConfigurationLoggingConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLoggingConfiguration_LoggingConfigurationPropertyValidator(properties).assertSuccess(), { LogDestinationConfigs: cdk.listMapper(cfnLoggingConfigurationLogDestinationConfigPropertyToCloudFormation)(properties.logDestinationConfigs) }) : properties;
    }
    function CfnLoggingConfigurationLoggingConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logDestinationConfigs", "LogDestinationConfigs", cfn_parse.FromCloudFormation.getArray(CfnLoggingConfigurationLogDestinationConfigPropertyFromCloudFormation)(properties.LogDestinationConfigs)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("capacity", cdk.requiredValidator)(properties.capacity)), errors.collect(cdk.propertyValidator("capacity", cdk.validateNumber)(properties.capacity)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("ruleGroup", CfnRuleGroup_RuleGroupPropertyValidator)(properties.ruleGroup)), errors.collect(cdk.propertyValidator("ruleGroupName", cdk.requiredValidator)(properties.ruleGroupName)), errors.collect(cdk.propertyValidator("ruleGroupName", cdk.validateString)(properties.ruleGroupName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnRuleGroupProps"');
    }
    function cfnRuleGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroupPropsValidator(properties).assertSuccess(), { Capacity: cdk.numberToCloudFormation(properties.capacity), RuleGroupName: cdk.stringToCloudFormation(properties.ruleGroupName), Type: cdk.stringToCloudFormation(properties.type), Description: cdk.stringToCloudFormation(properties.description), RuleGroup: cfnRuleGroupRuleGroupPropertyToCloudFormation(properties.ruleGroup), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnRuleGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("capacity", "Capacity", cfn_parse.FromCloudFormation.getNumber(properties.Capacity)), ret.addPropertyResult("ruleGroupName", "RuleGroupName", cfn_parse.FromCloudFormation.getString(properties.RuleGroupName)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("ruleGroup", "RuleGroup", properties.RuleGroup != null ? CfnRuleGroupRuleGroupPropertyFromCloudFormation(properties.RuleGroup) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRuleGroup = class _CfnRuleGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRuleGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnRuleGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRuleGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_networkfirewall_CfnRuleGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRuleGroup), error;
        }
        cdk.requireProperty(props, "capacity", this), cdk.requireProperty(props, "ruleGroupName", this), cdk.requireProperty(props, "type", this), this.attrRuleGroupArn = cdk.Token.asString(this.getAtt("RuleGroupArn", cdk.ResolutionTypeHint.STRING)), this.attrRuleGroupId = cdk.Token.asString(this.getAtt("RuleGroupId", cdk.ResolutionTypeHint.STRING)), this.capacity = props.capacity, this.ruleGroupName = props.ruleGroupName, this.type = props.type, this.description = props.description, this.ruleGroup = props.ruleGroup, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::NetworkFirewall::RuleGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRuleGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { capacity: this.capacity, ruleGroupName: this.ruleGroupName, type: this.type, description: this.description, ruleGroup: this.ruleGroup, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnRuleGroupPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnRuleGroup[_d] = { fqn: "aws-cdk-lib.aws_networkfirewall.CfnRuleGroup", version: "2.80.0" }, CfnRuleGroup.CFN_RESOURCE_TYPE_NAME = "AWS::NetworkFirewall::RuleGroup", exports2.CfnRuleGroup = CfnRuleGroup;
    function CfnRuleGroup_ActionDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("publishMetricAction", CfnRuleGroup_PublishMetricActionPropertyValidator)(properties.publishMetricAction)), errors.wrap('supplied properties not correct for "ActionDefinitionProperty"');
    }
    function cfnRuleGroupActionDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_ActionDefinitionPropertyValidator(properties).assertSuccess(), { PublishMetricAction: cfnRuleGroupPublishMetricActionPropertyToCloudFormation(properties.publishMetricAction) }) : properties;
    }
    function CfnRuleGroupActionDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("publishMetricAction", "PublishMetricAction", properties.PublishMetricAction != null ? CfnRuleGroupPublishMetricActionPropertyFromCloudFormation(properties.PublishMetricAction) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_AddressPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("addressDefinition", cdk.requiredValidator)(properties.addressDefinition)), errors.collect(cdk.propertyValidator("addressDefinition", cdk.validateString)(properties.addressDefinition)), errors.wrap('supplied properties not correct for "AddressProperty"');
    }
    function cfnRuleGroupAddressPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_AddressPropertyValidator(properties).assertSuccess(), { AddressDefinition: cdk.stringToCloudFormation(properties.addressDefinition) }) : properties;
    }
    function CfnRuleGroupAddressPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("addressDefinition", "AddressDefinition", cfn_parse.FromCloudFormation.getString(properties.AddressDefinition)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_CustomActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actionDefinition", cdk.requiredValidator)(properties.actionDefinition)), errors.collect(cdk.propertyValidator("actionDefinition", CfnRuleGroup_ActionDefinitionPropertyValidator)(properties.actionDefinition)), errors.collect(cdk.propertyValidator("actionName", cdk.requiredValidator)(properties.actionName)), errors.collect(cdk.propertyValidator("actionName", cdk.validateString)(properties.actionName)), errors.wrap('supplied properties not correct for "CustomActionProperty"');
    }
    function cfnRuleGroupCustomActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_CustomActionPropertyValidator(properties).assertSuccess(), { ActionDefinition: cfnRuleGroupActionDefinitionPropertyToCloudFormation(properties.actionDefinition), ActionName: cdk.stringToCloudFormation(properties.actionName) }) : properties;
    }
    function CfnRuleGroupCustomActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actionDefinition", "ActionDefinition", CfnRuleGroupActionDefinitionPropertyFromCloudFormation(properties.ActionDefinition)), ret.addPropertyResult("actionName", "ActionName", cfn_parse.FromCloudFormation.getString(properties.ActionName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_DimensionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "DimensionProperty"');
    }
    function cfnRuleGroupDimensionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_DimensionPropertyValidator(properties).assertSuccess(), { Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnRuleGroupDimensionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_HeaderPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destination", cdk.requiredValidator)(properties.destination)), errors.collect(cdk.propertyValidator("destination", cdk.validateString)(properties.destination)), errors.collect(cdk.propertyValidator("destinationPort", cdk.requiredValidator)(properties.destinationPort)), errors.collect(cdk.propertyValidator("destinationPort", cdk.validateString)(properties.destinationPort)), errors.collect(cdk.propertyValidator("direction", cdk.requiredValidator)(properties.direction)), errors.collect(cdk.propertyValidator("direction", cdk.validateString)(properties.direction)), errors.collect(cdk.propertyValidator("protocol", cdk.requiredValidator)(properties.protocol)), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.collect(cdk.propertyValidator("source", cdk.requiredValidator)(properties.source)), errors.collect(cdk.propertyValidator("source", cdk.validateString)(properties.source)), errors.collect(cdk.propertyValidator("sourcePort", cdk.requiredValidator)(properties.sourcePort)), errors.collect(cdk.propertyValidator("sourcePort", cdk.validateString)(properties.sourcePort)), errors.wrap('supplied properties not correct for "HeaderProperty"');
    }
    function cfnRuleGroupHeaderPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_HeaderPropertyValidator(properties).assertSuccess(), { Destination: cdk.stringToCloudFormation(properties.destination), DestinationPort: cdk.stringToCloudFormation(properties.destinationPort), Direction: cdk.stringToCloudFormation(properties.direction), Protocol: cdk.stringToCloudFormation(properties.protocol), Source: cdk.stringToCloudFormation(properties.source), SourcePort: cdk.stringToCloudFormation(properties.sourcePort) }) : properties;
    }
    function CfnRuleGroupHeaderPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destination", "Destination", cfn_parse.FromCloudFormation.getString(properties.Destination)), ret.addPropertyResult("destinationPort", "DestinationPort", cfn_parse.FromCloudFormation.getString(properties.DestinationPort)), ret.addPropertyResult("direction", "Direction", cfn_parse.FromCloudFormation.getString(properties.Direction)), ret.addPropertyResult("protocol", "Protocol", cfn_parse.FromCloudFormation.getString(properties.Protocol)), ret.addPropertyResult("source", "Source", cfn_parse.FromCloudFormation.getString(properties.Source)), ret.addPropertyResult("sourcePort", "SourcePort", cfn_parse.FromCloudFormation.getString(properties.SourcePort)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_IPSetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("definition", cdk.listValidator(cdk.validateString))(properties.definition)), errors.wrap('supplied properties not correct for "IPSetProperty"');
    }
    function cfnRuleGroupIPSetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_IPSetPropertyValidator(properties).assertSuccess(), { Definition: cdk.listMapper(cdk.stringToCloudFormation)(properties.definition) }) : properties;
    }
    function CfnRuleGroupIPSetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("definition", "Definition", properties.Definition != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Definition) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_IPSetReferencePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("referenceArn", cdk.validateString)(properties.referenceArn)), errors.wrap('supplied properties not correct for "IPSetReferenceProperty"');
    }
    function cfnRuleGroupIPSetReferencePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_IPSetReferencePropertyValidator(properties).assertSuccess(), { ReferenceArn: cdk.stringToCloudFormation(properties.referenceArn) }) : properties;
    }
    function CfnRuleGroupIPSetReferencePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("referenceArn", "ReferenceArn", properties.ReferenceArn != null ? cfn_parse.FromCloudFormation.getString(properties.ReferenceArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_MatchAttributesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationPorts", cdk.listValidator(CfnRuleGroup_PortRangePropertyValidator))(properties.destinationPorts)), errors.collect(cdk.propertyValidator("destinations", cdk.listValidator(CfnRuleGroup_AddressPropertyValidator))(properties.destinations)), errors.collect(cdk.propertyValidator("protocols", cdk.listValidator(cdk.validateNumber))(properties.protocols)), errors.collect(cdk.propertyValidator("sourcePorts", cdk.listValidator(CfnRuleGroup_PortRangePropertyValidator))(properties.sourcePorts)), errors.collect(cdk.propertyValidator("sources", cdk.listValidator(CfnRuleGroup_AddressPropertyValidator))(properties.sources)), errors.collect(cdk.propertyValidator("tcpFlags", cdk.listValidator(CfnRuleGroup_TCPFlagFieldPropertyValidator))(properties.tcpFlags)), errors.wrap('supplied properties not correct for "MatchAttributesProperty"');
    }
    function cfnRuleGroupMatchAttributesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_MatchAttributesPropertyValidator(properties).assertSuccess(), { DestinationPorts: cdk.listMapper(cfnRuleGroupPortRangePropertyToCloudFormation)(properties.destinationPorts), Destinations: cdk.listMapper(cfnRuleGroupAddressPropertyToCloudFormation)(properties.destinations), Protocols: cdk.listMapper(cdk.numberToCloudFormation)(properties.protocols), SourcePorts: cdk.listMapper(cfnRuleGroupPortRangePropertyToCloudFormation)(properties.sourcePorts), Sources: cdk.listMapper(cfnRuleGroupAddressPropertyToCloudFormation)(properties.sources), TCPFlags: cdk.listMapper(cfnRuleGroupTCPFlagFieldPropertyToCloudFormation)(properties.tcpFlags) }) : properties;
    }
    function CfnRuleGroupMatchAttributesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationPorts", "DestinationPorts", properties.DestinationPorts != null ? cfn_parse.FromCloudFormation.getArray(CfnRuleGroupPortRangePropertyFromCloudFormation)(properties.DestinationPorts) : void 0), ret.addPropertyResult("destinations", "Destinations", properties.Destinations != null ? cfn_parse.FromCloudFormation.getArray(CfnRuleGroupAddressPropertyFromCloudFormation)(properties.Destinations) : void 0), ret.addPropertyResult("protocols", "Protocols", properties.Protocols != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getNumber)(properties.Protocols) : void 0), ret.addPropertyResult("sourcePorts", "SourcePorts", properties.SourcePorts != null ? cfn_parse.FromCloudFormation.getArray(CfnRuleGroupPortRangePropertyFromCloudFormation)(properties.SourcePorts) : void 0), ret.addPropertyResult("sources", "Sources", properties.Sources != null ? cfn_parse.FromCloudFormation.getArray(CfnRuleGroupAddressPropertyFromCloudFormation)(properties.Sources) : void 0), ret.addPropertyResult("tcpFlags", "TCPFlags", properties.TCPFlags != null ? cfn_parse.FromCloudFormation.getArray(CfnRuleGroupTCPFlagFieldPropertyFromCloudFormation)(properties.TCPFlags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_PortRangePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fromPort", cdk.requiredValidator)(properties.fromPort)), errors.collect(cdk.propertyValidator("fromPort", cdk.validateNumber)(properties.fromPort)), errors.collect(cdk.propertyValidator("toPort", cdk.requiredValidator)(properties.toPort)), errors.collect(cdk.propertyValidator("toPort", cdk.validateNumber)(properties.toPort)), errors.wrap('supplied properties not correct for "PortRangeProperty"');
    }
    function cfnRuleGroupPortRangePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_PortRangePropertyValidator(properties).assertSuccess(), { FromPort: cdk.numberToCloudFormation(properties.fromPort), ToPort: cdk.numberToCloudFormation(properties.toPort) }) : properties;
    }
    function CfnRuleGroupPortRangePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fromPort", "FromPort", cfn_parse.FromCloudFormation.getNumber(properties.FromPort)), ret.addPropertyResult("toPort", "ToPort", cfn_parse.FromCloudFormation.getNumber(properties.ToPort)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_PortSetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("definition", cdk.listValidator(cdk.validateString))(properties.definition)), errors.wrap('supplied properties not correct for "PortSetProperty"');
    }
    function cfnRuleGroupPortSetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_PortSetPropertyValidator(properties).assertSuccess(), { Definition: cdk.listMapper(cdk.stringToCloudFormation)(properties.definition) }) : properties;
    }
    function CfnRuleGroupPortSetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("definition", "Definition", properties.Definition != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Definition) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_PublishMetricActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dimensions", cdk.requiredValidator)(properties.dimensions)), errors.collect(cdk.propertyValidator("dimensions", cdk.listValidator(CfnRuleGroup_DimensionPropertyValidator))(properties.dimensions)), errors.wrap('supplied properties not correct for "PublishMetricActionProperty"');
    }
    function cfnRuleGroupPublishMetricActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_PublishMetricActionPropertyValidator(properties).assertSuccess(), { Dimensions: cdk.listMapper(cfnRuleGroupDimensionPropertyToCloudFormation)(properties.dimensions) }) : properties;
    }
    function CfnRuleGroupPublishMetricActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dimensions", "Dimensions", cfn_parse.FromCloudFormation.getArray(CfnRuleGroupDimensionPropertyFromCloudFormation)(properties.Dimensions)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_ReferenceSetsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ipSetReferences", cdk.hashValidator(CfnRuleGroup_IPSetReferencePropertyValidator))(properties.ipSetReferences)), errors.wrap('supplied properties not correct for "ReferenceSetsProperty"');
    }
    function cfnRuleGroupReferenceSetsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_ReferenceSetsPropertyValidator(properties).assertSuccess(), { IPSetReferences: cdk.hashMapper(cfnRuleGroupIPSetReferencePropertyToCloudFormation)(properties.ipSetReferences) }) : properties;
    }
    function CfnRuleGroupReferenceSetsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ipSetReferences", "IPSetReferences", properties.IPSetReferences != null ? cfn_parse.FromCloudFormation.getMap(CfnRuleGroupIPSetReferencePropertyFromCloudFormation)(properties.IPSetReferences) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_RuleDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.requiredValidator)(properties.actions)), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(cdk.validateString))(properties.actions)), errors.collect(cdk.propertyValidator("matchAttributes", cdk.requiredValidator)(properties.matchAttributes)), errors.collect(cdk.propertyValidator("matchAttributes", CfnRuleGroup_MatchAttributesPropertyValidator)(properties.matchAttributes)), errors.wrap('supplied properties not correct for "RuleDefinitionProperty"');
    }
    function cfnRuleGroupRuleDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_RuleDefinitionPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cdk.stringToCloudFormation)(properties.actions), MatchAttributes: cfnRuleGroupMatchAttributesPropertyToCloudFormation(properties.matchAttributes) }) : properties;
    }
    function CfnRuleGroupRuleDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", cfn_parse.FromCloudFormation.getStringArray(properties.Actions)), ret.addPropertyResult("matchAttributes", "MatchAttributes", CfnRuleGroupMatchAttributesPropertyFromCloudFormation(properties.MatchAttributes)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_RuleGroupPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("referenceSets", CfnRuleGroup_ReferenceSetsPropertyValidator)(properties.referenceSets)), errors.collect(cdk.propertyValidator("ruleVariables", CfnRuleGroup_RuleVariablesPropertyValidator)(properties.ruleVariables)), errors.collect(cdk.propertyValidator("rulesSource", cdk.requiredValidator)(properties.rulesSource)), errors.collect(cdk.propertyValidator("rulesSource", CfnRuleGroup_RulesSourcePropertyValidator)(properties.rulesSource)), errors.collect(cdk.propertyValidator("statefulRuleOptions", CfnRuleGroup_StatefulRuleOptionsPropertyValidator)(properties.statefulRuleOptions)), errors.wrap('supplied properties not correct for "RuleGroupProperty"');
    }
    function cfnRuleGroupRuleGroupPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_RuleGroupPropertyValidator(properties).assertSuccess(), { ReferenceSets: cfnRuleGroupReferenceSetsPropertyToCloudFormation(properties.referenceSets), RuleVariables: cfnRuleGroupRuleVariablesPropertyToCloudFormation(properties.ruleVariables), RulesSource: cfnRuleGroupRulesSourcePropertyToCloudFormation(properties.rulesSource), StatefulRuleOptions: cfnRuleGroupStatefulRuleOptionsPropertyToCloudFormation(properties.statefulRuleOptions) }) : properties;
    }
    function CfnRuleGroupRuleGroupPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("referenceSets", "ReferenceSets", properties.ReferenceSets != null ? CfnRuleGroupReferenceSetsPropertyFromCloudFormation(properties.ReferenceSets) : void 0), ret.addPropertyResult("ruleVariables", "RuleVariables", properties.RuleVariables != null ? CfnRuleGroupRuleVariablesPropertyFromCloudFormation(properties.RuleVariables) : void 0), ret.addPropertyResult("rulesSource", "RulesSource", CfnRuleGroupRulesSourcePropertyFromCloudFormation(properties.RulesSource)), ret.addPropertyResult("statefulRuleOptions", "StatefulRuleOptions", properties.StatefulRuleOptions != null ? CfnRuleGroupStatefulRuleOptionsPropertyFromCloudFormation(properties.StatefulRuleOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_RuleOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("keyword", cdk.requiredValidator)(properties.keyword)), errors.collect(cdk.propertyValidator("keyword", cdk.validateString)(properties.keyword)), errors.collect(cdk.propertyValidator("settings", cdk.listValidator(cdk.validateString))(properties.settings)), errors.wrap('supplied properties not correct for "RuleOptionProperty"');
    }
    function cfnRuleGroupRuleOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_RuleOptionPropertyValidator(properties).assertSuccess(), { Keyword: cdk.stringToCloudFormation(properties.keyword), Settings: cdk.listMapper(cdk.stringToCloudFormation)(properties.settings) }) : properties;
    }
    function CfnRuleGroupRuleOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("keyword", "Keyword", cfn_parse.FromCloudFormation.getString(properties.Keyword)), ret.addPropertyResult("settings", "Settings", properties.Settings != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Settings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_RuleVariablesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ipSets", cdk.hashValidator(CfnRuleGroup_IPSetPropertyValidator))(properties.ipSets)), errors.collect(cdk.propertyValidator("portSets", cdk.hashValidator(CfnRuleGroup_PortSetPropertyValidator))(properties.portSets)), errors.wrap('supplied properties not correct for "RuleVariablesProperty"');
    }
    function cfnRuleGroupRuleVariablesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_RuleVariablesPropertyValidator(properties).assertSuccess(), { IPSets: cdk.hashMapper(cfnRuleGroupIPSetPropertyToCloudFormation)(properties.ipSets), PortSets: cdk.hashMapper(cfnRuleGroupPortSetPropertyToCloudFormation)(properties.portSets) }) : properties;
    }
    function CfnRuleGroupRuleVariablesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ipSets", "IPSets", properties.IPSets != null ? cfn_parse.FromCloudFormation.getMap(CfnRuleGroupIPSetPropertyFromCloudFormation)(properties.IPSets) : void 0), ret.addPropertyResult("portSets", "PortSets", properties.PortSets != null ? cfn_parse.FromCloudFormation.getMap(CfnRuleGroupPortSetPropertyFromCloudFormation)(properties.PortSets) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_RulesSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("rulesSourceList", CfnRuleGroup_RulesSourceListPropertyValidator)(properties.rulesSourceList)), errors.collect(cdk.propertyValidator("rulesString", cdk.validateString)(properties.rulesString)), errors.collect(cdk.propertyValidator("statefulRules", cdk.listValidator(CfnRuleGroup_StatefulRulePropertyValidator))(properties.statefulRules)), errors.collect(cdk.propertyValidator("statelessRulesAndCustomActions", CfnRuleGroup_StatelessRulesAndCustomActionsPropertyValidator)(properties.statelessRulesAndCustomActions)), errors.wrap('supplied properties not correct for "RulesSourceProperty"');
    }
    function cfnRuleGroupRulesSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_RulesSourcePropertyValidator(properties).assertSuccess(), { RulesSourceList: cfnRuleGroupRulesSourceListPropertyToCloudFormation(properties.rulesSourceList), RulesString: cdk.stringToCloudFormation(properties.rulesString), StatefulRules: cdk.listMapper(cfnRuleGroupStatefulRulePropertyToCloudFormation)(properties.statefulRules), StatelessRulesAndCustomActions: cfnRuleGroupStatelessRulesAndCustomActionsPropertyToCloudFormation(properties.statelessRulesAndCustomActions) }) : properties;
    }
    function CfnRuleGroupRulesSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("rulesSourceList", "RulesSourceList", properties.RulesSourceList != null ? CfnRuleGroupRulesSourceListPropertyFromCloudFormation(properties.RulesSourceList) : void 0), ret.addPropertyResult("rulesString", "RulesString", properties.RulesString != null ? cfn_parse.FromCloudFormation.getString(properties.RulesString) : void 0), ret.addPropertyResult("statefulRules", "StatefulRules", properties.StatefulRules != null ? cfn_parse.FromCloudFormation.getArray(CfnRuleGroupStatefulRulePropertyFromCloudFormation)(properties.StatefulRules) : void 0), ret.addPropertyResult("statelessRulesAndCustomActions", "StatelessRulesAndCustomActions", properties.StatelessRulesAndCustomActions != null ? CfnRuleGroupStatelessRulesAndCustomActionsPropertyFromCloudFormation(properties.StatelessRulesAndCustomActions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_RulesSourceListPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("generatedRulesType", cdk.requiredValidator)(properties.generatedRulesType)), errors.collect(cdk.propertyValidator("generatedRulesType", cdk.validateString)(properties.generatedRulesType)), errors.collect(cdk.propertyValidator("targetTypes", cdk.requiredValidator)(properties.targetTypes)), errors.collect(cdk.propertyValidator("targetTypes", cdk.listValidator(cdk.validateString))(properties.targetTypes)), errors.collect(cdk.propertyValidator("targets", cdk.requiredValidator)(properties.targets)), errors.collect(cdk.propertyValidator("targets", cdk.listValidator(cdk.validateString))(properties.targets)), errors.wrap('supplied properties not correct for "RulesSourceListProperty"');
    }
    function cfnRuleGroupRulesSourceListPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_RulesSourceListPropertyValidator(properties).assertSuccess(), { GeneratedRulesType: cdk.stringToCloudFormation(properties.generatedRulesType), TargetTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.targetTypes), Targets: cdk.listMapper(cdk.stringToCloudFormation)(properties.targets) }) : properties;
    }
    function CfnRuleGroupRulesSourceListPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("generatedRulesType", "GeneratedRulesType", cfn_parse.FromCloudFormation.getString(properties.GeneratedRulesType)), ret.addPropertyResult("targetTypes", "TargetTypes", cfn_parse.FromCloudFormation.getStringArray(properties.TargetTypes)), ret.addPropertyResult("targets", "Targets", cfn_parse.FromCloudFormation.getStringArray(properties.Targets)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_StatefulRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.requiredValidator)(properties.action)), errors.collect(cdk.propertyValidator("action", cdk.validateString)(properties.action)), errors.collect(cdk.propertyValidator("header", cdk.requiredValidator)(properties.header)), errors.collect(cdk.propertyValidator("header", CfnRuleGroup_HeaderPropertyValidator)(properties.header)), errors.collect(cdk.propertyValidator("ruleOptions", cdk.requiredValidator)(properties.ruleOptions)), errors.collect(cdk.propertyValidator("ruleOptions", cdk.listValidator(CfnRuleGroup_RuleOptionPropertyValidator))(properties.ruleOptions)), errors.wrap('supplied properties not correct for "StatefulRuleProperty"');
    }
    function cfnRuleGroupStatefulRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_StatefulRulePropertyValidator(properties).assertSuccess(), { Action: cdk.stringToCloudFormation(properties.action), Header: cfnRuleGroupHeaderPropertyToCloudFormation(properties.header), RuleOptions: cdk.listMapper(cfnRuleGroupRuleOptionPropertyToCloudFormation)(properties.ruleOptions) }) : properties;
    }
    function CfnRuleGroupStatefulRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", cfn_parse.FromCloudFormation.getString(properties.Action)), ret.addPropertyResult("header", "Header", CfnRuleGroupHeaderPropertyFromCloudFormation(properties.Header)), ret.addPropertyResult("ruleOptions", "RuleOptions", cfn_parse.FromCloudFormation.getArray(CfnRuleGroupRuleOptionPropertyFromCloudFormation)(properties.RuleOptions)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_StatefulRuleOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ruleOrder", cdk.validateString)(properties.ruleOrder)), errors.wrap('supplied properties not correct for "StatefulRuleOptionsProperty"');
    }
    function cfnRuleGroupStatefulRuleOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_StatefulRuleOptionsPropertyValidator(properties).assertSuccess(), { RuleOrder: cdk.stringToCloudFormation(properties.ruleOrder) }) : properties;
    }
    function CfnRuleGroupStatefulRuleOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ruleOrder", "RuleOrder", properties.RuleOrder != null ? cfn_parse.FromCloudFormation.getString(properties.RuleOrder) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_StatelessRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("priority", cdk.requiredValidator)(properties.priority)), errors.collect(cdk.propertyValidator("priority", cdk.validateNumber)(properties.priority)), errors.collect(cdk.propertyValidator("ruleDefinition", cdk.requiredValidator)(properties.ruleDefinition)), errors.collect(cdk.propertyValidator("ruleDefinition", CfnRuleGroup_RuleDefinitionPropertyValidator)(properties.ruleDefinition)), errors.wrap('supplied properties not correct for "StatelessRuleProperty"');
    }
    function cfnRuleGroupStatelessRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_StatelessRulePropertyValidator(properties).assertSuccess(), { Priority: cdk.numberToCloudFormation(properties.priority), RuleDefinition: cfnRuleGroupRuleDefinitionPropertyToCloudFormation(properties.ruleDefinition) }) : properties;
    }
    function CfnRuleGroupStatelessRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("priority", "Priority", cfn_parse.FromCloudFormation.getNumber(properties.Priority)), ret.addPropertyResult("ruleDefinition", "RuleDefinition", CfnRuleGroupRuleDefinitionPropertyFromCloudFormation(properties.RuleDefinition)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_StatelessRulesAndCustomActionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customActions", cdk.listValidator(CfnRuleGroup_CustomActionPropertyValidator))(properties.customActions)), errors.collect(cdk.propertyValidator("statelessRules", cdk.requiredValidator)(properties.statelessRules)), errors.collect(cdk.propertyValidator("statelessRules", cdk.listValidator(CfnRuleGroup_StatelessRulePropertyValidator))(properties.statelessRules)), errors.wrap('supplied properties not correct for "StatelessRulesAndCustomActionsProperty"');
    }
    function cfnRuleGroupStatelessRulesAndCustomActionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_StatelessRulesAndCustomActionsPropertyValidator(properties).assertSuccess(), { CustomActions: cdk.listMapper(cfnRuleGroupCustomActionPropertyToCloudFormation)(properties.customActions), StatelessRules: cdk.listMapper(cfnRuleGroupStatelessRulePropertyToCloudFormation)(properties.statelessRules) }) : properties;
    }
    function CfnRuleGroupStatelessRulesAndCustomActionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customActions", "CustomActions", properties.CustomActions != null ? cfn_parse.FromCloudFormation.getArray(CfnRuleGroupCustomActionPropertyFromCloudFormation)(properties.CustomActions) : void 0), ret.addPropertyResult("statelessRules", "StatelessRules", cfn_parse.FromCloudFormation.getArray(CfnRuleGroupStatelessRulePropertyFromCloudFormation)(properties.StatelessRules)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_TCPFlagFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("flags", cdk.requiredValidator)(properties.flags)), errors.collect(cdk.propertyValidator("flags", cdk.listValidator(cdk.validateString))(properties.flags)), errors.collect(cdk.propertyValidator("masks", cdk.listValidator(cdk.validateString))(properties.masks)), errors.wrap('supplied properties not correct for "TCPFlagFieldProperty"');
    }
    function cfnRuleGroupTCPFlagFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_TCPFlagFieldPropertyValidator(properties).assertSuccess(), { Flags: cdk.listMapper(cdk.stringToCloudFormation)(properties.flags), Masks: cdk.listMapper(cdk.stringToCloudFormation)(properties.masks) }) : properties;
    }
    function CfnRuleGroupTCPFlagFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("flags", "Flags", cfn_parse.FromCloudFormation.getStringArray(properties.Flags)), ret.addPropertyResult("masks", "Masks", properties.Masks != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Masks) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-networkfirewall/lib/index.js
var require_lib196 = __commonJS({
  "node_modules/aws-cdk-lib/aws-networkfirewall/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_networkfirewall_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-networkfirewall/index.js
var require_aws_networkfirewall = __commonJS({
  "node_modules/aws-cdk-lib/aws-networkfirewall/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib196(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-networkmanager/lib/networkmanager.generated.js
var require_networkmanager_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-networkmanager/lib/networkmanager.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    var _l;
    var _m;
    var _o;
    var _p;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnVpcAttachment = exports2.CfnTransitGatewayRouteTableAttachment = exports2.CfnTransitGatewayRegistration = exports2.CfnTransitGatewayPeering = exports2.CfnSiteToSiteVpnAttachment = exports2.CfnSite = exports2.CfnLinkAssociation = exports2.CfnLink = exports2.CfnGlobalNetwork = exports2.CfnDevice = exports2.CfnCustomerGatewayAssociation = exports2.CfnCoreNetwork = exports2.CfnConnectPeer = exports2.CfnConnectAttachment = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnConnectAttachmentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("coreNetworkId", cdk.requiredValidator)(properties.coreNetworkId)), errors.collect(cdk.propertyValidator("coreNetworkId", cdk.validateString)(properties.coreNetworkId)), errors.collect(cdk.propertyValidator("edgeLocation", cdk.requiredValidator)(properties.edgeLocation)), errors.collect(cdk.propertyValidator("edgeLocation", cdk.validateString)(properties.edgeLocation)), errors.collect(cdk.propertyValidator("options", cdk.requiredValidator)(properties.options)), errors.collect(cdk.propertyValidator("options", CfnConnectAttachment_ConnectAttachmentOptionsPropertyValidator)(properties.options)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("transportAttachmentId", cdk.requiredValidator)(properties.transportAttachmentId)), errors.collect(cdk.propertyValidator("transportAttachmentId", cdk.validateString)(properties.transportAttachmentId)), errors.wrap('supplied properties not correct for "CfnConnectAttachmentProps"');
    }
    function cfnConnectAttachmentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectAttachmentPropsValidator(properties).assertSuccess(), { CoreNetworkId: cdk.stringToCloudFormation(properties.coreNetworkId), EdgeLocation: cdk.stringToCloudFormation(properties.edgeLocation), Options: cfnConnectAttachmentConnectAttachmentOptionsPropertyToCloudFormation(properties.options), TransportAttachmentId: cdk.stringToCloudFormation(properties.transportAttachmentId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnConnectAttachmentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("coreNetworkId", "CoreNetworkId", cfn_parse.FromCloudFormation.getString(properties.CoreNetworkId)), ret.addPropertyResult("edgeLocation", "EdgeLocation", cfn_parse.FromCloudFormation.getString(properties.EdgeLocation)), ret.addPropertyResult("options", "Options", CfnConnectAttachmentConnectAttachmentOptionsPropertyFromCloudFormation(properties.Options)), ret.addPropertyResult("transportAttachmentId", "TransportAttachmentId", cfn_parse.FromCloudFormation.getString(properties.TransportAttachmentId)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnConnectAttachment = class _CfnConnectAttachment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnConnectAttachmentPropsFromCloudFormation(resourceProperties), ret = new _CfnConnectAttachment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnConnectAttachment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_networkmanager_CfnConnectAttachmentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnConnectAttachment), error;
        }
        cdk.requireProperty(props, "coreNetworkId", this), cdk.requireProperty(props, "edgeLocation", this), cdk.requireProperty(props, "options", this), cdk.requireProperty(props, "transportAttachmentId", this), this.attrAttachmentId = cdk.Token.asString(this.getAtt("AttachmentId", cdk.ResolutionTypeHint.STRING)), this.attrAttachmentPolicyRuleNumber = cdk.Token.asNumber(this.getAtt("AttachmentPolicyRuleNumber", cdk.ResolutionTypeHint.NUMBER)), this.attrAttachmentType = cdk.Token.asString(this.getAtt("AttachmentType", cdk.ResolutionTypeHint.STRING)), this.attrCoreNetworkArn = cdk.Token.asString(this.getAtt("CoreNetworkArn", cdk.ResolutionTypeHint.STRING)), this.attrCreatedAt = cdk.Token.asString(this.getAtt("CreatedAt", cdk.ResolutionTypeHint.STRING)), this.attrOwnerAccountId = cdk.Token.asString(this.getAtt("OwnerAccountId", cdk.ResolutionTypeHint.STRING)), this.attrProposedSegmentChangeAttachmentPolicyRuleNumber = cdk.Token.asNumber(this.getAtt("ProposedSegmentChange.AttachmentPolicyRuleNumber", cdk.ResolutionTypeHint.NUMBER)), this.attrProposedSegmentChangeSegmentName = cdk.Token.asString(this.getAtt("ProposedSegmentChange.SegmentName", cdk.ResolutionTypeHint.STRING)), this.attrProposedSegmentChangeTags = this.getAtt("ProposedSegmentChange.Tags", cdk.ResolutionTypeHint.STRING), this.attrResourceArn = cdk.Token.asString(this.getAtt("ResourceArn", cdk.ResolutionTypeHint.STRING)), this.attrSegmentName = cdk.Token.asString(this.getAtt("SegmentName", cdk.ResolutionTypeHint.STRING)), this.attrState = cdk.Token.asString(this.getAtt("State", cdk.ResolutionTypeHint.STRING)), this.attrUpdatedAt = cdk.Token.asString(this.getAtt("UpdatedAt", cdk.ResolutionTypeHint.STRING)), this.coreNetworkId = props.coreNetworkId, this.edgeLocation = props.edgeLocation, this.options = props.options, this.transportAttachmentId = props.transportAttachmentId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::NetworkManager::ConnectAttachment", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnConnectAttachment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { coreNetworkId: this.coreNetworkId, edgeLocation: this.edgeLocation, options: this.options, transportAttachmentId: this.transportAttachmentId, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnConnectAttachmentPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnConnectAttachment[_a] = { fqn: "aws-cdk-lib.aws_networkmanager.CfnConnectAttachment", version: "2.80.0" }, CfnConnectAttachment.CFN_RESOURCE_TYPE_NAME = "AWS::NetworkManager::ConnectAttachment", exports2.CfnConnectAttachment = CfnConnectAttachment;
    function CfnConnectAttachment_ConnectAttachmentOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.wrap('supplied properties not correct for "ConnectAttachmentOptionsProperty"');
    }
    function cfnConnectAttachmentConnectAttachmentOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectAttachment_ConnectAttachmentOptionsPropertyValidator(properties).assertSuccess(), { Protocol: cdk.stringToCloudFormation(properties.protocol) }) : properties;
    }
    function CfnConnectAttachmentConnectAttachmentOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("protocol", "Protocol", properties.Protocol != null ? cfn_parse.FromCloudFormation.getString(properties.Protocol) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConnectPeerPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bgpOptions", CfnConnectPeer_BgpOptionsPropertyValidator)(properties.bgpOptions)), errors.collect(cdk.propertyValidator("connectAttachmentId", cdk.requiredValidator)(properties.connectAttachmentId)), errors.collect(cdk.propertyValidator("connectAttachmentId", cdk.validateString)(properties.connectAttachmentId)), errors.collect(cdk.propertyValidator("coreNetworkAddress", cdk.validateString)(properties.coreNetworkAddress)), errors.collect(cdk.propertyValidator("insideCidrBlocks", cdk.requiredValidator)(properties.insideCidrBlocks)), errors.collect(cdk.propertyValidator("insideCidrBlocks", cdk.listValidator(cdk.validateString))(properties.insideCidrBlocks)), errors.collect(cdk.propertyValidator("peerAddress", cdk.requiredValidator)(properties.peerAddress)), errors.collect(cdk.propertyValidator("peerAddress", cdk.validateString)(properties.peerAddress)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnConnectPeerProps"');
    }
    function cfnConnectPeerPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectPeerPropsValidator(properties).assertSuccess(), { ConnectAttachmentId: cdk.stringToCloudFormation(properties.connectAttachmentId), InsideCidrBlocks: cdk.listMapper(cdk.stringToCloudFormation)(properties.insideCidrBlocks), PeerAddress: cdk.stringToCloudFormation(properties.peerAddress), BgpOptions: cfnConnectPeerBgpOptionsPropertyToCloudFormation(properties.bgpOptions), CoreNetworkAddress: cdk.stringToCloudFormation(properties.coreNetworkAddress), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnConnectPeerPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectAttachmentId", "ConnectAttachmentId", cfn_parse.FromCloudFormation.getString(properties.ConnectAttachmentId)), ret.addPropertyResult("insideCidrBlocks", "InsideCidrBlocks", cfn_parse.FromCloudFormation.getStringArray(properties.InsideCidrBlocks)), ret.addPropertyResult("peerAddress", "PeerAddress", cfn_parse.FromCloudFormation.getString(properties.PeerAddress)), ret.addPropertyResult("bgpOptions", "BgpOptions", properties.BgpOptions != null ? CfnConnectPeerBgpOptionsPropertyFromCloudFormation(properties.BgpOptions) : void 0), ret.addPropertyResult("coreNetworkAddress", "CoreNetworkAddress", properties.CoreNetworkAddress != null ? cfn_parse.FromCloudFormation.getString(properties.CoreNetworkAddress) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnConnectPeer = class _CfnConnectPeer extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnConnectPeerPropsFromCloudFormation(resourceProperties), ret = new _CfnConnectPeer(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnConnectPeer.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_networkmanager_CfnConnectPeerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnConnectPeer), error;
        }
        cdk.requireProperty(props, "connectAttachmentId", this), cdk.requireProperty(props, "insideCidrBlocks", this), cdk.requireProperty(props, "peerAddress", this), this.attrConfigurationBgpConfigurations = this.getAtt("Configuration.BgpConfigurations", cdk.ResolutionTypeHint.STRING), this.attrConfigurationCoreNetworkAddress = cdk.Token.asString(this.getAtt("Configuration.CoreNetworkAddress", cdk.ResolutionTypeHint.STRING)), this.attrConfigurationInsideCidrBlocks = cdk.Token.asList(this.getAtt("Configuration.InsideCidrBlocks", cdk.ResolutionTypeHint.STRING_LIST)), this.attrConfigurationPeerAddress = cdk.Token.asString(this.getAtt("Configuration.PeerAddress", cdk.ResolutionTypeHint.STRING)), this.attrConfigurationProtocol = cdk.Token.asString(this.getAtt("Configuration.Protocol", cdk.ResolutionTypeHint.STRING)), this.attrConnectPeerId = cdk.Token.asString(this.getAtt("ConnectPeerId", cdk.ResolutionTypeHint.STRING)), this.attrCoreNetworkId = cdk.Token.asString(this.getAtt("CoreNetworkId", cdk.ResolutionTypeHint.STRING)), this.attrCreatedAt = cdk.Token.asString(this.getAtt("CreatedAt", cdk.ResolutionTypeHint.STRING)), this.attrEdgeLocation = cdk.Token.asString(this.getAtt("EdgeLocation", cdk.ResolutionTypeHint.STRING)), this.attrState = cdk.Token.asString(this.getAtt("State", cdk.ResolutionTypeHint.STRING)), this.connectAttachmentId = props.connectAttachmentId, this.insideCidrBlocks = props.insideCidrBlocks, this.peerAddress = props.peerAddress, this.bgpOptions = props.bgpOptions, this.coreNetworkAddress = props.coreNetworkAddress, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::NetworkManager::ConnectPeer", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnConnectPeer.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { connectAttachmentId: this.connectAttachmentId, insideCidrBlocks: this.insideCidrBlocks, peerAddress: this.peerAddress, bgpOptions: this.bgpOptions, coreNetworkAddress: this.coreNetworkAddress, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnConnectPeerPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnConnectPeer[_b] = { fqn: "aws-cdk-lib.aws_networkmanager.CfnConnectPeer", version: "2.80.0" }, CfnConnectPeer.CFN_RESOURCE_TYPE_NAME = "AWS::NetworkManager::ConnectPeer", exports2.CfnConnectPeer = CfnConnectPeer;
    function CfnConnectPeer_BgpOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("peerAsn", cdk.validateNumber)(properties.peerAsn)), errors.wrap('supplied properties not correct for "BgpOptionsProperty"');
    }
    function cfnConnectPeerBgpOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectPeer_BgpOptionsPropertyValidator(properties).assertSuccess(), { PeerAsn: cdk.numberToCloudFormation(properties.peerAsn) }) : properties;
    }
    function CfnConnectPeerBgpOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("peerAsn", "PeerAsn", properties.PeerAsn != null ? cfn_parse.FromCloudFormation.getNumber(properties.PeerAsn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCoreNetworkPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("globalNetworkId", cdk.requiredValidator)(properties.globalNetworkId)), errors.collect(cdk.propertyValidator("globalNetworkId", cdk.validateString)(properties.globalNetworkId)), errors.collect(cdk.propertyValidator("policyDocument", cdk.validateObject)(properties.policyDocument)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnCoreNetworkProps"');
    }
    function cfnCoreNetworkPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCoreNetworkPropsValidator(properties).assertSuccess(), { GlobalNetworkId: cdk.stringToCloudFormation(properties.globalNetworkId), Description: cdk.stringToCloudFormation(properties.description), PolicyDocument: cdk.objectToCloudFormation(properties.policyDocument), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnCoreNetworkPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("globalNetworkId", "GlobalNetworkId", cfn_parse.FromCloudFormation.getString(properties.GlobalNetworkId)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("policyDocument", "PolicyDocument", properties.PolicyDocument != null ? cfn_parse.FromCloudFormation.getAny(properties.PolicyDocument) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCoreNetwork = class _CfnCoreNetwork extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCoreNetworkPropsFromCloudFormation(resourceProperties), ret = new _CfnCoreNetwork(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCoreNetwork.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_networkmanager_CfnCoreNetworkProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCoreNetwork), error;
        }
        cdk.requireProperty(props, "globalNetworkId", this), this.attrCoreNetworkArn = cdk.Token.asString(this.getAtt("CoreNetworkArn", cdk.ResolutionTypeHint.STRING)), this.attrCoreNetworkId = cdk.Token.asString(this.getAtt("CoreNetworkId", cdk.ResolutionTypeHint.STRING)), this.attrCreatedAt = cdk.Token.asString(this.getAtt("CreatedAt", cdk.ResolutionTypeHint.STRING)), this.attrEdges = this.getAtt("Edges", cdk.ResolutionTypeHint.STRING), this.attrOwnerAccount = cdk.Token.asString(this.getAtt("OwnerAccount", cdk.ResolutionTypeHint.STRING)), this.attrSegments = this.getAtt("Segments", cdk.ResolutionTypeHint.STRING), this.attrState = cdk.Token.asString(this.getAtt("State", cdk.ResolutionTypeHint.STRING)), this.globalNetworkId = props.globalNetworkId, this.description = props.description, this.policyDocument = props.policyDocument, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::NetworkManager::CoreNetwork", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCoreNetwork.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { globalNetworkId: this.globalNetworkId, description: this.description, policyDocument: this.policyDocument, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnCoreNetworkPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnCoreNetwork[_c] = { fqn: "aws-cdk-lib.aws_networkmanager.CfnCoreNetwork", version: "2.80.0" }, CfnCoreNetwork.CFN_RESOURCE_TYPE_NAME = "AWS::NetworkManager::CoreNetwork", exports2.CfnCoreNetwork = CfnCoreNetwork;
    function CfnCustomerGatewayAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customerGatewayArn", cdk.requiredValidator)(properties.customerGatewayArn)), errors.collect(cdk.propertyValidator("customerGatewayArn", cdk.validateString)(properties.customerGatewayArn)), errors.collect(cdk.propertyValidator("deviceId", cdk.requiredValidator)(properties.deviceId)), errors.collect(cdk.propertyValidator("deviceId", cdk.validateString)(properties.deviceId)), errors.collect(cdk.propertyValidator("globalNetworkId", cdk.requiredValidator)(properties.globalNetworkId)), errors.collect(cdk.propertyValidator("globalNetworkId", cdk.validateString)(properties.globalNetworkId)), errors.collect(cdk.propertyValidator("linkId", cdk.validateString)(properties.linkId)), errors.wrap('supplied properties not correct for "CfnCustomerGatewayAssociationProps"');
    }
    function cfnCustomerGatewayAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCustomerGatewayAssociationPropsValidator(properties).assertSuccess(), { CustomerGatewayArn: cdk.stringToCloudFormation(properties.customerGatewayArn), DeviceId: cdk.stringToCloudFormation(properties.deviceId), GlobalNetworkId: cdk.stringToCloudFormation(properties.globalNetworkId), LinkId: cdk.stringToCloudFormation(properties.linkId) }) : properties;
    }
    function CfnCustomerGatewayAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customerGatewayArn", "CustomerGatewayArn", cfn_parse.FromCloudFormation.getString(properties.CustomerGatewayArn)), ret.addPropertyResult("deviceId", "DeviceId", cfn_parse.FromCloudFormation.getString(properties.DeviceId)), ret.addPropertyResult("globalNetworkId", "GlobalNetworkId", cfn_parse.FromCloudFormation.getString(properties.GlobalNetworkId)), ret.addPropertyResult("linkId", "LinkId", properties.LinkId != null ? cfn_parse.FromCloudFormation.getString(properties.LinkId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCustomerGatewayAssociation = class _CfnCustomerGatewayAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCustomerGatewayAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnCustomerGatewayAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCustomerGatewayAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_networkmanager_CfnCustomerGatewayAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCustomerGatewayAssociation), error;
        }
        cdk.requireProperty(props, "customerGatewayArn", this), cdk.requireProperty(props, "deviceId", this), cdk.requireProperty(props, "globalNetworkId", this), this.customerGatewayArn = props.customerGatewayArn, this.deviceId = props.deviceId, this.globalNetworkId = props.globalNetworkId, this.linkId = props.linkId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCustomerGatewayAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { customerGatewayArn: this.customerGatewayArn, deviceId: this.deviceId, globalNetworkId: this.globalNetworkId, linkId: this.linkId };
      }
      renderProperties(props) {
        return cfnCustomerGatewayAssociationPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnCustomerGatewayAssociation[_d] = { fqn: "aws-cdk-lib.aws_networkmanager.CfnCustomerGatewayAssociation", version: "2.80.0" }, CfnCustomerGatewayAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::NetworkManager::CustomerGatewayAssociation", exports2.CfnCustomerGatewayAssociation = CfnCustomerGatewayAssociation;
    function CfnDevicePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("globalNetworkId", cdk.requiredValidator)(properties.globalNetworkId)), errors.collect(cdk.propertyValidator("globalNetworkId", cdk.validateString)(properties.globalNetworkId)), errors.collect(cdk.propertyValidator("location", CfnDevice_LocationPropertyValidator)(properties.location)), errors.collect(cdk.propertyValidator("model", cdk.validateString)(properties.model)), errors.collect(cdk.propertyValidator("serialNumber", cdk.validateString)(properties.serialNumber)), errors.collect(cdk.propertyValidator("siteId", cdk.validateString)(properties.siteId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("vendor", cdk.validateString)(properties.vendor)), errors.wrap('supplied properties not correct for "CfnDeviceProps"');
    }
    function cfnDevicePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDevicePropsValidator(properties).assertSuccess(), { GlobalNetworkId: cdk.stringToCloudFormation(properties.globalNetworkId), Description: cdk.stringToCloudFormation(properties.description), Location: cfnDeviceLocationPropertyToCloudFormation(properties.location), Model: cdk.stringToCloudFormation(properties.model), SerialNumber: cdk.stringToCloudFormation(properties.serialNumber), SiteId: cdk.stringToCloudFormation(properties.siteId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), Type: cdk.stringToCloudFormation(properties.type), Vendor: cdk.stringToCloudFormation(properties.vendor) }) : properties;
    }
    function CfnDevicePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("globalNetworkId", "GlobalNetworkId", cfn_parse.FromCloudFormation.getString(properties.GlobalNetworkId)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("location", "Location", properties.Location != null ? CfnDeviceLocationPropertyFromCloudFormation(properties.Location) : void 0), ret.addPropertyResult("model", "Model", properties.Model != null ? cfn_parse.FromCloudFormation.getString(properties.Model) : void 0), ret.addPropertyResult("serialNumber", "SerialNumber", properties.SerialNumber != null ? cfn_parse.FromCloudFormation.getString(properties.SerialNumber) : void 0), ret.addPropertyResult("siteId", "SiteId", properties.SiteId != null ? cfn_parse.FromCloudFormation.getString(properties.SiteId) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addPropertyResult("vendor", "Vendor", properties.Vendor != null ? cfn_parse.FromCloudFormation.getString(properties.Vendor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDevice = class _CfnDevice extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDevicePropsFromCloudFormation(resourceProperties), ret = new _CfnDevice(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDevice.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_networkmanager_CfnDeviceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDevice), error;
        }
        cdk.requireProperty(props, "globalNetworkId", this), this.attrDeviceArn = cdk.Token.asString(this.getAtt("DeviceArn", cdk.ResolutionTypeHint.STRING)), this.attrDeviceId = cdk.Token.asString(this.getAtt("DeviceId", cdk.ResolutionTypeHint.STRING)), this.globalNetworkId = props.globalNetworkId, this.description = props.description, this.location = props.location, this.model = props.model, this.serialNumber = props.serialNumber, this.siteId = props.siteId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::NetworkManager::Device", props.tags, { tagPropertyName: "tags" }), this.type = props.type, this.vendor = props.vendor;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDevice.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { globalNetworkId: this.globalNetworkId, description: this.description, location: this.location, model: this.model, serialNumber: this.serialNumber, siteId: this.siteId, tags: this.tags.renderTags(), type: this.type, vendor: this.vendor };
      }
      renderProperties(props) {
        return cfnDevicePropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnDevice[_e] = { fqn: "aws-cdk-lib.aws_networkmanager.CfnDevice", version: "2.80.0" }, CfnDevice.CFN_RESOURCE_TYPE_NAME = "AWS::NetworkManager::Device", exports2.CfnDevice = CfnDevice;
    function CfnDevice_LocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("address", cdk.validateString)(properties.address)), errors.collect(cdk.propertyValidator("latitude", cdk.validateString)(properties.latitude)), errors.collect(cdk.propertyValidator("longitude", cdk.validateString)(properties.longitude)), errors.wrap('supplied properties not correct for "LocationProperty"');
    }
    function cfnDeviceLocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDevice_LocationPropertyValidator(properties).assertSuccess(), { Address: cdk.stringToCloudFormation(properties.address), Latitude: cdk.stringToCloudFormation(properties.latitude), Longitude: cdk.stringToCloudFormation(properties.longitude) }) : properties;
    }
    function CfnDeviceLocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("address", "Address", properties.Address != null ? cfn_parse.FromCloudFormation.getString(properties.Address) : void 0), ret.addPropertyResult("latitude", "Latitude", properties.Latitude != null ? cfn_parse.FromCloudFormation.getString(properties.Latitude) : void 0), ret.addPropertyResult("longitude", "Longitude", properties.Longitude != null ? cfn_parse.FromCloudFormation.getString(properties.Longitude) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGlobalNetworkPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnGlobalNetworkProps"');
    }
    function cfnGlobalNetworkPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGlobalNetworkPropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnGlobalNetworkPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnGlobalNetwork = class _CfnGlobalNetwork extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnGlobalNetworkPropsFromCloudFormation(resourceProperties), ret = new _CfnGlobalNetwork(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnGlobalNetwork.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_networkmanager_CfnGlobalNetworkProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnGlobalNetwork), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::NetworkManager::GlobalNetwork", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnGlobalNetwork.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnGlobalNetworkPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnGlobalNetwork[_f] = { fqn: "aws-cdk-lib.aws_networkmanager.CfnGlobalNetwork", version: "2.80.0" }, CfnGlobalNetwork.CFN_RESOURCE_TYPE_NAME = "AWS::NetworkManager::GlobalNetwork", exports2.CfnGlobalNetwork = CfnGlobalNetwork;
    function CfnLinkPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bandwidth", cdk.requiredValidator)(properties.bandwidth)), errors.collect(cdk.propertyValidator("bandwidth", CfnLink_BandwidthPropertyValidator)(properties.bandwidth)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("globalNetworkId", cdk.requiredValidator)(properties.globalNetworkId)), errors.collect(cdk.propertyValidator("globalNetworkId", cdk.validateString)(properties.globalNetworkId)), errors.collect(cdk.propertyValidator("provider", cdk.validateString)(properties.provider)), errors.collect(cdk.propertyValidator("siteId", cdk.requiredValidator)(properties.siteId)), errors.collect(cdk.propertyValidator("siteId", cdk.validateString)(properties.siteId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnLinkProps"');
    }
    function cfnLinkPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLinkPropsValidator(properties).assertSuccess(), { Bandwidth: cfnLinkBandwidthPropertyToCloudFormation(properties.bandwidth), GlobalNetworkId: cdk.stringToCloudFormation(properties.globalNetworkId), SiteId: cdk.stringToCloudFormation(properties.siteId), Description: cdk.stringToCloudFormation(properties.description), Provider: cdk.stringToCloudFormation(properties.provider), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnLinkPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bandwidth", "Bandwidth", CfnLinkBandwidthPropertyFromCloudFormation(properties.Bandwidth)), ret.addPropertyResult("globalNetworkId", "GlobalNetworkId", cfn_parse.FromCloudFormation.getString(properties.GlobalNetworkId)), ret.addPropertyResult("siteId", "SiteId", cfn_parse.FromCloudFormation.getString(properties.SiteId)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("provider", "Provider", properties.Provider != null ? cfn_parse.FromCloudFormation.getString(properties.Provider) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLink = class _CfnLink extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLinkPropsFromCloudFormation(resourceProperties), ret = new _CfnLink(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLink.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_networkmanager_CfnLinkProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLink), error;
        }
        cdk.requireProperty(props, "bandwidth", this), cdk.requireProperty(props, "globalNetworkId", this), cdk.requireProperty(props, "siteId", this), this.attrLinkArn = cdk.Token.asString(this.getAtt("LinkArn", cdk.ResolutionTypeHint.STRING)), this.attrLinkId = cdk.Token.asString(this.getAtt("LinkId", cdk.ResolutionTypeHint.STRING)), this.bandwidth = props.bandwidth, this.globalNetworkId = props.globalNetworkId, this.siteId = props.siteId, this.description = props.description, this.provider = props.provider, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::NetworkManager::Link", props.tags, { tagPropertyName: "tags" }), this.type = props.type;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLink.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { bandwidth: this.bandwidth, globalNetworkId: this.globalNetworkId, siteId: this.siteId, description: this.description, provider: this.provider, tags: this.tags.renderTags(), type: this.type };
      }
      renderProperties(props) {
        return cfnLinkPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnLink[_g] = { fqn: "aws-cdk-lib.aws_networkmanager.CfnLink", version: "2.80.0" }, CfnLink.CFN_RESOURCE_TYPE_NAME = "AWS::NetworkManager::Link", exports2.CfnLink = CfnLink;
    function CfnLink_BandwidthPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("downloadSpeed", cdk.validateNumber)(properties.downloadSpeed)), errors.collect(cdk.propertyValidator("uploadSpeed", cdk.validateNumber)(properties.uploadSpeed)), errors.wrap('supplied properties not correct for "BandwidthProperty"');
    }
    function cfnLinkBandwidthPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLink_BandwidthPropertyValidator(properties).assertSuccess(), { DownloadSpeed: cdk.numberToCloudFormation(properties.downloadSpeed), UploadSpeed: cdk.numberToCloudFormation(properties.uploadSpeed) }) : properties;
    }
    function CfnLinkBandwidthPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("downloadSpeed", "DownloadSpeed", properties.DownloadSpeed != null ? cfn_parse.FromCloudFormation.getNumber(properties.DownloadSpeed) : void 0), ret.addPropertyResult("uploadSpeed", "UploadSpeed", properties.UploadSpeed != null ? cfn_parse.FromCloudFormation.getNumber(properties.UploadSpeed) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLinkAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deviceId", cdk.requiredValidator)(properties.deviceId)), errors.collect(cdk.propertyValidator("deviceId", cdk.validateString)(properties.deviceId)), errors.collect(cdk.propertyValidator("globalNetworkId", cdk.requiredValidator)(properties.globalNetworkId)), errors.collect(cdk.propertyValidator("globalNetworkId", cdk.validateString)(properties.globalNetworkId)), errors.collect(cdk.propertyValidator("linkId", cdk.requiredValidator)(properties.linkId)), errors.collect(cdk.propertyValidator("linkId", cdk.validateString)(properties.linkId)), errors.wrap('supplied properties not correct for "CfnLinkAssociationProps"');
    }
    function cfnLinkAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLinkAssociationPropsValidator(properties).assertSuccess(), { DeviceId: cdk.stringToCloudFormation(properties.deviceId), GlobalNetworkId: cdk.stringToCloudFormation(properties.globalNetworkId), LinkId: cdk.stringToCloudFormation(properties.linkId) }) : properties;
    }
    function CfnLinkAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deviceId", "DeviceId", cfn_parse.FromCloudFormation.getString(properties.DeviceId)), ret.addPropertyResult("globalNetworkId", "GlobalNetworkId", cfn_parse.FromCloudFormation.getString(properties.GlobalNetworkId)), ret.addPropertyResult("linkId", "LinkId", cfn_parse.FromCloudFormation.getString(properties.LinkId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLinkAssociation = class _CfnLinkAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLinkAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnLinkAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLinkAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_networkmanager_CfnLinkAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLinkAssociation), error;
        }
        cdk.requireProperty(props, "deviceId", this), cdk.requireProperty(props, "globalNetworkId", this), cdk.requireProperty(props, "linkId", this), this.deviceId = props.deviceId, this.globalNetworkId = props.globalNetworkId, this.linkId = props.linkId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLinkAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { deviceId: this.deviceId, globalNetworkId: this.globalNetworkId, linkId: this.linkId };
      }
      renderProperties(props) {
        return cfnLinkAssociationPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnLinkAssociation[_h] = { fqn: "aws-cdk-lib.aws_networkmanager.CfnLinkAssociation", version: "2.80.0" }, CfnLinkAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::NetworkManager::LinkAssociation", exports2.CfnLinkAssociation = CfnLinkAssociation;
    function CfnSitePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("globalNetworkId", cdk.requiredValidator)(properties.globalNetworkId)), errors.collect(cdk.propertyValidator("globalNetworkId", cdk.validateString)(properties.globalNetworkId)), errors.collect(cdk.propertyValidator("location", CfnSite_LocationPropertyValidator)(properties.location)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnSiteProps"');
    }
    function cfnSitePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSitePropsValidator(properties).assertSuccess(), { GlobalNetworkId: cdk.stringToCloudFormation(properties.globalNetworkId), Description: cdk.stringToCloudFormation(properties.description), Location: cfnSiteLocationPropertyToCloudFormation(properties.location), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnSitePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("globalNetworkId", "GlobalNetworkId", cfn_parse.FromCloudFormation.getString(properties.GlobalNetworkId)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("location", "Location", properties.Location != null ? CfnSiteLocationPropertyFromCloudFormation(properties.Location) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSite = class _CfnSite extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSitePropsFromCloudFormation(resourceProperties), ret = new _CfnSite(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSite.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_networkmanager_CfnSiteProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSite), error;
        }
        cdk.requireProperty(props, "globalNetworkId", this), this.attrSiteArn = cdk.Token.asString(this.getAtt("SiteArn", cdk.ResolutionTypeHint.STRING)), this.attrSiteId = cdk.Token.asString(this.getAtt("SiteId", cdk.ResolutionTypeHint.STRING)), this.globalNetworkId = props.globalNetworkId, this.description = props.description, this.location = props.location, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::NetworkManager::Site", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSite.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { globalNetworkId: this.globalNetworkId, description: this.description, location: this.location, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnSitePropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnSite[_j] = { fqn: "aws-cdk-lib.aws_networkmanager.CfnSite", version: "2.80.0" }, CfnSite.CFN_RESOURCE_TYPE_NAME = "AWS::NetworkManager::Site", exports2.CfnSite = CfnSite;
    function CfnSite_LocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("address", cdk.validateString)(properties.address)), errors.collect(cdk.propertyValidator("latitude", cdk.validateString)(properties.latitude)), errors.collect(cdk.propertyValidator("longitude", cdk.validateString)(properties.longitude)), errors.wrap('supplied properties not correct for "LocationProperty"');
    }
    function cfnSiteLocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSite_LocationPropertyValidator(properties).assertSuccess(), { Address: cdk.stringToCloudFormation(properties.address), Latitude: cdk.stringToCloudFormation(properties.latitude), Longitude: cdk.stringToCloudFormation(properties.longitude) }) : properties;
    }
    function CfnSiteLocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("address", "Address", properties.Address != null ? cfn_parse.FromCloudFormation.getString(properties.Address) : void 0), ret.addPropertyResult("latitude", "Latitude", properties.Latitude != null ? cfn_parse.FromCloudFormation.getString(properties.Latitude) : void 0), ret.addPropertyResult("longitude", "Longitude", properties.Longitude != null ? cfn_parse.FromCloudFormation.getString(properties.Longitude) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSiteToSiteVpnAttachmentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("coreNetworkId", cdk.requiredValidator)(properties.coreNetworkId)), errors.collect(cdk.propertyValidator("coreNetworkId", cdk.validateString)(properties.coreNetworkId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpnConnectionArn", cdk.requiredValidator)(properties.vpnConnectionArn)), errors.collect(cdk.propertyValidator("vpnConnectionArn", cdk.validateString)(properties.vpnConnectionArn)), errors.wrap('supplied properties not correct for "CfnSiteToSiteVpnAttachmentProps"');
    }
    function cfnSiteToSiteVpnAttachmentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSiteToSiteVpnAttachmentPropsValidator(properties).assertSuccess(), { CoreNetworkId: cdk.stringToCloudFormation(properties.coreNetworkId), VpnConnectionArn: cdk.stringToCloudFormation(properties.vpnConnectionArn), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnSiteToSiteVpnAttachmentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("coreNetworkId", "CoreNetworkId", cfn_parse.FromCloudFormation.getString(properties.CoreNetworkId)), ret.addPropertyResult("vpnConnectionArn", "VpnConnectionArn", cfn_parse.FromCloudFormation.getString(properties.VpnConnectionArn)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSiteToSiteVpnAttachment = class _CfnSiteToSiteVpnAttachment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSiteToSiteVpnAttachmentPropsFromCloudFormation(resourceProperties), ret = new _CfnSiteToSiteVpnAttachment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSiteToSiteVpnAttachment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_networkmanager_CfnSiteToSiteVpnAttachmentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSiteToSiteVpnAttachment), error;
        }
        cdk.requireProperty(props, "coreNetworkId", this), cdk.requireProperty(props, "vpnConnectionArn", this), this.attrAttachmentId = cdk.Token.asString(this.getAtt("AttachmentId", cdk.ResolutionTypeHint.STRING)), this.attrAttachmentPolicyRuleNumber = cdk.Token.asNumber(this.getAtt("AttachmentPolicyRuleNumber", cdk.ResolutionTypeHint.NUMBER)), this.attrAttachmentType = cdk.Token.asString(this.getAtt("AttachmentType", cdk.ResolutionTypeHint.STRING)), this.attrCoreNetworkArn = cdk.Token.asString(this.getAtt("CoreNetworkArn", cdk.ResolutionTypeHint.STRING)), this.attrCreatedAt = cdk.Token.asString(this.getAtt("CreatedAt", cdk.ResolutionTypeHint.STRING)), this.attrEdgeLocation = cdk.Token.asString(this.getAtt("EdgeLocation", cdk.ResolutionTypeHint.STRING)), this.attrOwnerAccountId = cdk.Token.asString(this.getAtt("OwnerAccountId", cdk.ResolutionTypeHint.STRING)), this.attrProposedSegmentChangeAttachmentPolicyRuleNumber = cdk.Token.asNumber(this.getAtt("ProposedSegmentChange.AttachmentPolicyRuleNumber", cdk.ResolutionTypeHint.NUMBER)), this.attrProposedSegmentChangeSegmentName = cdk.Token.asString(this.getAtt("ProposedSegmentChange.SegmentName", cdk.ResolutionTypeHint.STRING)), this.attrProposedSegmentChangeTags = this.getAtt("ProposedSegmentChange.Tags", cdk.ResolutionTypeHint.STRING), this.attrResourceArn = cdk.Token.asString(this.getAtt("ResourceArn", cdk.ResolutionTypeHint.STRING)), this.attrSegmentName = cdk.Token.asString(this.getAtt("SegmentName", cdk.ResolutionTypeHint.STRING)), this.attrState = cdk.Token.asString(this.getAtt("State", cdk.ResolutionTypeHint.STRING)), this.attrUpdatedAt = cdk.Token.asString(this.getAtt("UpdatedAt", cdk.ResolutionTypeHint.STRING)), this.coreNetworkId = props.coreNetworkId, this.vpnConnectionArn = props.vpnConnectionArn, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::NetworkManager::SiteToSiteVpnAttachment", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSiteToSiteVpnAttachment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { coreNetworkId: this.coreNetworkId, vpnConnectionArn: this.vpnConnectionArn, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnSiteToSiteVpnAttachmentPropsToCloudFormation(props);
      }
    };
    _k = JSII_RTTI_SYMBOL_1, CfnSiteToSiteVpnAttachment[_k] = { fqn: "aws-cdk-lib.aws_networkmanager.CfnSiteToSiteVpnAttachment", version: "2.80.0" }, CfnSiteToSiteVpnAttachment.CFN_RESOURCE_TYPE_NAME = "AWS::NetworkManager::SiteToSiteVpnAttachment", exports2.CfnSiteToSiteVpnAttachment = CfnSiteToSiteVpnAttachment;
    function CfnTransitGatewayPeeringPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("coreNetworkId", cdk.requiredValidator)(properties.coreNetworkId)), errors.collect(cdk.propertyValidator("coreNetworkId", cdk.validateString)(properties.coreNetworkId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("transitGatewayArn", cdk.requiredValidator)(properties.transitGatewayArn)), errors.collect(cdk.propertyValidator("transitGatewayArn", cdk.validateString)(properties.transitGatewayArn)), errors.wrap('supplied properties not correct for "CfnTransitGatewayPeeringProps"');
    }
    function cfnTransitGatewayPeeringPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTransitGatewayPeeringPropsValidator(properties).assertSuccess(), { CoreNetworkId: cdk.stringToCloudFormation(properties.coreNetworkId), TransitGatewayArn: cdk.stringToCloudFormation(properties.transitGatewayArn), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnTransitGatewayPeeringPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("coreNetworkId", "CoreNetworkId", cfn_parse.FromCloudFormation.getString(properties.CoreNetworkId)), ret.addPropertyResult("transitGatewayArn", "TransitGatewayArn", cfn_parse.FromCloudFormation.getString(properties.TransitGatewayArn)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTransitGatewayPeering = class _CfnTransitGatewayPeering extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTransitGatewayPeeringPropsFromCloudFormation(resourceProperties), ret = new _CfnTransitGatewayPeering(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTransitGatewayPeering.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_networkmanager_CfnTransitGatewayPeeringProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTransitGatewayPeering), error;
        }
        cdk.requireProperty(props, "coreNetworkId", this), cdk.requireProperty(props, "transitGatewayArn", this), this.attrCoreNetworkArn = cdk.Token.asString(this.getAtt("CoreNetworkArn", cdk.ResolutionTypeHint.STRING)), this.attrCreatedAt = cdk.Token.asString(this.getAtt("CreatedAt", cdk.ResolutionTypeHint.STRING)), this.attrEdgeLocation = cdk.Token.asString(this.getAtt("EdgeLocation", cdk.ResolutionTypeHint.STRING)), this.attrOwnerAccountId = cdk.Token.asString(this.getAtt("OwnerAccountId", cdk.ResolutionTypeHint.STRING)), this.attrPeeringId = cdk.Token.asString(this.getAtt("PeeringId", cdk.ResolutionTypeHint.STRING)), this.attrPeeringType = cdk.Token.asString(this.getAtt("PeeringType", cdk.ResolutionTypeHint.STRING)), this.attrResourceArn = cdk.Token.asString(this.getAtt("ResourceArn", cdk.ResolutionTypeHint.STRING)), this.attrState = cdk.Token.asString(this.getAtt("State", cdk.ResolutionTypeHint.STRING)), this.attrTransitGatewayPeeringAttachmentId = cdk.Token.asString(this.getAtt("TransitGatewayPeeringAttachmentId", cdk.ResolutionTypeHint.STRING)), this.coreNetworkId = props.coreNetworkId, this.transitGatewayArn = props.transitGatewayArn, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::NetworkManager::TransitGatewayPeering", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTransitGatewayPeering.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { coreNetworkId: this.coreNetworkId, transitGatewayArn: this.transitGatewayArn, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnTransitGatewayPeeringPropsToCloudFormation(props);
      }
    };
    _l = JSII_RTTI_SYMBOL_1, CfnTransitGatewayPeering[_l] = { fqn: "aws-cdk-lib.aws_networkmanager.CfnTransitGatewayPeering", version: "2.80.0" }, CfnTransitGatewayPeering.CFN_RESOURCE_TYPE_NAME = "AWS::NetworkManager::TransitGatewayPeering", exports2.CfnTransitGatewayPeering = CfnTransitGatewayPeering;
    function CfnTransitGatewayRegistrationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("globalNetworkId", cdk.requiredValidator)(properties.globalNetworkId)), errors.collect(cdk.propertyValidator("globalNetworkId", cdk.validateString)(properties.globalNetworkId)), errors.collect(cdk.propertyValidator("transitGatewayArn", cdk.requiredValidator)(properties.transitGatewayArn)), errors.collect(cdk.propertyValidator("transitGatewayArn", cdk.validateString)(properties.transitGatewayArn)), errors.wrap('supplied properties not correct for "CfnTransitGatewayRegistrationProps"');
    }
    function cfnTransitGatewayRegistrationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTransitGatewayRegistrationPropsValidator(properties).assertSuccess(), { GlobalNetworkId: cdk.stringToCloudFormation(properties.globalNetworkId), TransitGatewayArn: cdk.stringToCloudFormation(properties.transitGatewayArn) }) : properties;
    }
    function CfnTransitGatewayRegistrationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("globalNetworkId", "GlobalNetworkId", cfn_parse.FromCloudFormation.getString(properties.GlobalNetworkId)), ret.addPropertyResult("transitGatewayArn", "TransitGatewayArn", cfn_parse.FromCloudFormation.getString(properties.TransitGatewayArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTransitGatewayRegistration = class _CfnTransitGatewayRegistration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTransitGatewayRegistrationPropsFromCloudFormation(resourceProperties), ret = new _CfnTransitGatewayRegistration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTransitGatewayRegistration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_networkmanager_CfnTransitGatewayRegistrationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTransitGatewayRegistration), error;
        }
        cdk.requireProperty(props, "globalNetworkId", this), cdk.requireProperty(props, "transitGatewayArn", this), this.globalNetworkId = props.globalNetworkId, this.transitGatewayArn = props.transitGatewayArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTransitGatewayRegistration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { globalNetworkId: this.globalNetworkId, transitGatewayArn: this.transitGatewayArn };
      }
      renderProperties(props) {
        return cfnTransitGatewayRegistrationPropsToCloudFormation(props);
      }
    };
    _m = JSII_RTTI_SYMBOL_1, CfnTransitGatewayRegistration[_m] = { fqn: "aws-cdk-lib.aws_networkmanager.CfnTransitGatewayRegistration", version: "2.80.0" }, CfnTransitGatewayRegistration.CFN_RESOURCE_TYPE_NAME = "AWS::NetworkManager::TransitGatewayRegistration", exports2.CfnTransitGatewayRegistration = CfnTransitGatewayRegistration;
    function CfnTransitGatewayRouteTableAttachmentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("peeringId", cdk.requiredValidator)(properties.peeringId)), errors.collect(cdk.propertyValidator("peeringId", cdk.validateString)(properties.peeringId)), errors.collect(cdk.propertyValidator("proposedSegmentChange", CfnTransitGatewayRouteTableAttachment_ProposedSegmentChangePropertyValidator)(properties.proposedSegmentChange)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("transitGatewayRouteTableArn", cdk.requiredValidator)(properties.transitGatewayRouteTableArn)), errors.collect(cdk.propertyValidator("transitGatewayRouteTableArn", cdk.validateString)(properties.transitGatewayRouteTableArn)), errors.wrap('supplied properties not correct for "CfnTransitGatewayRouteTableAttachmentProps"');
    }
    function cfnTransitGatewayRouteTableAttachmentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTransitGatewayRouteTableAttachmentPropsValidator(properties).assertSuccess(), { PeeringId: cdk.stringToCloudFormation(properties.peeringId), TransitGatewayRouteTableArn: cdk.stringToCloudFormation(properties.transitGatewayRouteTableArn), ProposedSegmentChange: cfnTransitGatewayRouteTableAttachmentProposedSegmentChangePropertyToCloudFormation(properties.proposedSegmentChange), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnTransitGatewayRouteTableAttachmentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("peeringId", "PeeringId", cfn_parse.FromCloudFormation.getString(properties.PeeringId)), ret.addPropertyResult("transitGatewayRouteTableArn", "TransitGatewayRouteTableArn", cfn_parse.FromCloudFormation.getString(properties.TransitGatewayRouteTableArn)), ret.addPropertyResult("proposedSegmentChange", "ProposedSegmentChange", properties.ProposedSegmentChange != null ? CfnTransitGatewayRouteTableAttachmentProposedSegmentChangePropertyFromCloudFormation(properties.ProposedSegmentChange) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTransitGatewayRouteTableAttachment = class _CfnTransitGatewayRouteTableAttachment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTransitGatewayRouteTableAttachmentPropsFromCloudFormation(resourceProperties), ret = new _CfnTransitGatewayRouteTableAttachment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTransitGatewayRouteTableAttachment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_networkmanager_CfnTransitGatewayRouteTableAttachmentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTransitGatewayRouteTableAttachment), error;
        }
        cdk.requireProperty(props, "peeringId", this), cdk.requireProperty(props, "transitGatewayRouteTableArn", this), this.attrAttachmentId = cdk.Token.asString(this.getAtt("AttachmentId", cdk.ResolutionTypeHint.STRING)), this.attrAttachmentPolicyRuleNumber = cdk.Token.asNumber(this.getAtt("AttachmentPolicyRuleNumber", cdk.ResolutionTypeHint.NUMBER)), this.attrAttachmentType = cdk.Token.asString(this.getAtt("AttachmentType", cdk.ResolutionTypeHint.STRING)), this.attrCoreNetworkArn = cdk.Token.asString(this.getAtt("CoreNetworkArn", cdk.ResolutionTypeHint.STRING)), this.attrCoreNetworkId = cdk.Token.asString(this.getAtt("CoreNetworkId", cdk.ResolutionTypeHint.STRING)), this.attrCreatedAt = cdk.Token.asString(this.getAtt("CreatedAt", cdk.ResolutionTypeHint.STRING)), this.attrEdgeLocation = cdk.Token.asString(this.getAtt("EdgeLocation", cdk.ResolutionTypeHint.STRING)), this.attrOwnerAccountId = cdk.Token.asString(this.getAtt("OwnerAccountId", cdk.ResolutionTypeHint.STRING)), this.attrResourceArn = cdk.Token.asString(this.getAtt("ResourceArn", cdk.ResolutionTypeHint.STRING)), this.attrSegmentName = cdk.Token.asString(this.getAtt("SegmentName", cdk.ResolutionTypeHint.STRING)), this.attrState = cdk.Token.asString(this.getAtt("State", cdk.ResolutionTypeHint.STRING)), this.attrUpdatedAt = cdk.Token.asString(this.getAtt("UpdatedAt", cdk.ResolutionTypeHint.STRING)), this.peeringId = props.peeringId, this.transitGatewayRouteTableArn = props.transitGatewayRouteTableArn, this.proposedSegmentChange = props.proposedSegmentChange, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::NetworkManager::TransitGatewayRouteTableAttachment", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTransitGatewayRouteTableAttachment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { peeringId: this.peeringId, transitGatewayRouteTableArn: this.transitGatewayRouteTableArn, proposedSegmentChange: this.proposedSegmentChange, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnTransitGatewayRouteTableAttachmentPropsToCloudFormation(props);
      }
    };
    _o = JSII_RTTI_SYMBOL_1, CfnTransitGatewayRouteTableAttachment[_o] = { fqn: "aws-cdk-lib.aws_networkmanager.CfnTransitGatewayRouteTableAttachment", version: "2.80.0" }, CfnTransitGatewayRouteTableAttachment.CFN_RESOURCE_TYPE_NAME = "AWS::NetworkManager::TransitGatewayRouteTableAttachment", exports2.CfnTransitGatewayRouteTableAttachment = CfnTransitGatewayRouteTableAttachment;
    function CfnTransitGatewayRouteTableAttachment_ProposedSegmentChangePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attachmentPolicyRuleNumber", cdk.validateNumber)(properties.attachmentPolicyRuleNumber)), errors.collect(cdk.propertyValidator("segmentName", cdk.validateString)(properties.segmentName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "ProposedSegmentChangeProperty"');
    }
    function cfnTransitGatewayRouteTableAttachmentProposedSegmentChangePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTransitGatewayRouteTableAttachment_ProposedSegmentChangePropertyValidator(properties).assertSuccess(), { AttachmentPolicyRuleNumber: cdk.numberToCloudFormation(properties.attachmentPolicyRuleNumber), SegmentName: cdk.stringToCloudFormation(properties.segmentName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnTransitGatewayRouteTableAttachmentProposedSegmentChangePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attachmentPolicyRuleNumber", "AttachmentPolicyRuleNumber", properties.AttachmentPolicyRuleNumber != null ? cfn_parse.FromCloudFormation.getNumber(properties.AttachmentPolicyRuleNumber) : void 0), ret.addPropertyResult("segmentName", "SegmentName", properties.SegmentName != null ? cfn_parse.FromCloudFormation.getString(properties.SegmentName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVpcAttachmentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("coreNetworkId", cdk.requiredValidator)(properties.coreNetworkId)), errors.collect(cdk.propertyValidator("coreNetworkId", cdk.validateString)(properties.coreNetworkId)), errors.collect(cdk.propertyValidator("options", CfnVpcAttachment_VpcOptionsPropertyValidator)(properties.options)), errors.collect(cdk.propertyValidator("subnetArns", cdk.requiredValidator)(properties.subnetArns)), errors.collect(cdk.propertyValidator("subnetArns", cdk.listValidator(cdk.validateString))(properties.subnetArns)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpcArn", cdk.requiredValidator)(properties.vpcArn)), errors.collect(cdk.propertyValidator("vpcArn", cdk.validateString)(properties.vpcArn)), errors.wrap('supplied properties not correct for "CfnVpcAttachmentProps"');
    }
    function cfnVpcAttachmentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVpcAttachmentPropsValidator(properties).assertSuccess(), { CoreNetworkId: cdk.stringToCloudFormation(properties.coreNetworkId), SubnetArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetArns), VpcArn: cdk.stringToCloudFormation(properties.vpcArn), Options: cfnVpcAttachmentVpcOptionsPropertyToCloudFormation(properties.options), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnVpcAttachmentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("coreNetworkId", "CoreNetworkId", cfn_parse.FromCloudFormation.getString(properties.CoreNetworkId)), ret.addPropertyResult("subnetArns", "SubnetArns", cfn_parse.FromCloudFormation.getStringArray(properties.SubnetArns)), ret.addPropertyResult("vpcArn", "VpcArn", cfn_parse.FromCloudFormation.getString(properties.VpcArn)), ret.addPropertyResult("options", "Options", properties.Options != null ? CfnVpcAttachmentVpcOptionsPropertyFromCloudFormation(properties.Options) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVpcAttachment = class _CfnVpcAttachment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVpcAttachmentPropsFromCloudFormation(resourceProperties), ret = new _CfnVpcAttachment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVpcAttachment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_networkmanager_CfnVpcAttachmentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVpcAttachment), error;
        }
        cdk.requireProperty(props, "coreNetworkId", this), cdk.requireProperty(props, "subnetArns", this), cdk.requireProperty(props, "vpcArn", this), this.attrAttachmentId = cdk.Token.asString(this.getAtt("AttachmentId", cdk.ResolutionTypeHint.STRING)), this.attrAttachmentPolicyRuleNumber = cdk.Token.asNumber(this.getAtt("AttachmentPolicyRuleNumber", cdk.ResolutionTypeHint.NUMBER)), this.attrAttachmentType = cdk.Token.asString(this.getAtt("AttachmentType", cdk.ResolutionTypeHint.STRING)), this.attrCoreNetworkArn = cdk.Token.asString(this.getAtt("CoreNetworkArn", cdk.ResolutionTypeHint.STRING)), this.attrCreatedAt = cdk.Token.asString(this.getAtt("CreatedAt", cdk.ResolutionTypeHint.STRING)), this.attrEdgeLocation = cdk.Token.asString(this.getAtt("EdgeLocation", cdk.ResolutionTypeHint.STRING)), this.attrOwnerAccountId = cdk.Token.asString(this.getAtt("OwnerAccountId", cdk.ResolutionTypeHint.STRING)), this.attrProposedSegmentChangeAttachmentPolicyRuleNumber = cdk.Token.asNumber(this.getAtt("ProposedSegmentChange.AttachmentPolicyRuleNumber", cdk.ResolutionTypeHint.NUMBER)), this.attrProposedSegmentChangeSegmentName = cdk.Token.asString(this.getAtt("ProposedSegmentChange.SegmentName", cdk.ResolutionTypeHint.STRING)), this.attrProposedSegmentChangeTags = this.getAtt("ProposedSegmentChange.Tags", cdk.ResolutionTypeHint.STRING), this.attrResourceArn = cdk.Token.asString(this.getAtt("ResourceArn", cdk.ResolutionTypeHint.STRING)), this.attrSegmentName = cdk.Token.asString(this.getAtt("SegmentName", cdk.ResolutionTypeHint.STRING)), this.attrState = cdk.Token.asString(this.getAtt("State", cdk.ResolutionTypeHint.STRING)), this.attrUpdatedAt = cdk.Token.asString(this.getAtt("UpdatedAt", cdk.ResolutionTypeHint.STRING)), this.coreNetworkId = props.coreNetworkId, this.subnetArns = props.subnetArns, this.vpcArn = props.vpcArn, this.options = props.options, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::NetworkManager::VpcAttachment", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVpcAttachment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { coreNetworkId: this.coreNetworkId, subnetArns: this.subnetArns, vpcArn: this.vpcArn, options: this.options, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnVpcAttachmentPropsToCloudFormation(props);
      }
    };
    _p = JSII_RTTI_SYMBOL_1, CfnVpcAttachment[_p] = { fqn: "aws-cdk-lib.aws_networkmanager.CfnVpcAttachment", version: "2.80.0" }, CfnVpcAttachment.CFN_RESOURCE_TYPE_NAME = "AWS::NetworkManager::VpcAttachment", exports2.CfnVpcAttachment = CfnVpcAttachment;
    function CfnVpcAttachment_VpcOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applianceModeSupport", cdk.validateBoolean)(properties.applianceModeSupport)), errors.collect(cdk.propertyValidator("ipv6Support", cdk.validateBoolean)(properties.ipv6Support)), errors.wrap('supplied properties not correct for "VpcOptionsProperty"');
    }
    function cfnVpcAttachmentVpcOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVpcAttachment_VpcOptionsPropertyValidator(properties).assertSuccess(), { ApplianceModeSupport: cdk.booleanToCloudFormation(properties.applianceModeSupport), Ipv6Support: cdk.booleanToCloudFormation(properties.ipv6Support) }) : properties;
    }
    function CfnVpcAttachmentVpcOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applianceModeSupport", "ApplianceModeSupport", properties.ApplianceModeSupport != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ApplianceModeSupport) : void 0), ret.addPropertyResult("ipv6Support", "Ipv6Support", properties.Ipv6Support != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Ipv6Support) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-networkmanager/lib/index.js
var require_lib197 = __commonJS({
  "node_modules/aws-cdk-lib/aws-networkmanager/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_networkmanager_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-networkmanager/index.js
var require_aws_networkmanager = __commonJS({
  "node_modules/aws-cdk-lib/aws-networkmanager/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib197(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-nimblestudio/lib/nimblestudio.generated.js
var require_nimblestudio_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-nimblestudio/lib/nimblestudio.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnStudioComponent = exports2.CfnStudio = exports2.CfnStreamingImage = exports2.CfnLaunchProfile = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnLaunchProfilePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("ec2SubnetIds", cdk.requiredValidator)(properties.ec2SubnetIds)), errors.collect(cdk.propertyValidator("ec2SubnetIds", cdk.listValidator(cdk.validateString))(properties.ec2SubnetIds)), errors.collect(cdk.propertyValidator("launchProfileProtocolVersions", cdk.requiredValidator)(properties.launchProfileProtocolVersions)), errors.collect(cdk.propertyValidator("launchProfileProtocolVersions", cdk.listValidator(cdk.validateString))(properties.launchProfileProtocolVersions)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("streamConfiguration", cdk.requiredValidator)(properties.streamConfiguration)), errors.collect(cdk.propertyValidator("streamConfiguration", CfnLaunchProfile_StreamConfigurationPropertyValidator)(properties.streamConfiguration)), errors.collect(cdk.propertyValidator("studioComponentIds", cdk.requiredValidator)(properties.studioComponentIds)), errors.collect(cdk.propertyValidator("studioComponentIds", cdk.listValidator(cdk.validateString))(properties.studioComponentIds)), errors.collect(cdk.propertyValidator("studioId", cdk.requiredValidator)(properties.studioId)), errors.collect(cdk.propertyValidator("studioId", cdk.validateString)(properties.studioId)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.wrap('supplied properties not correct for "CfnLaunchProfileProps"');
    }
    function cfnLaunchProfilePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchProfilePropsValidator(properties).assertSuccess(), { Ec2SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.ec2SubnetIds), LaunchProfileProtocolVersions: cdk.listMapper(cdk.stringToCloudFormation)(properties.launchProfileProtocolVersions), Name: cdk.stringToCloudFormation(properties.name), StreamConfiguration: cfnLaunchProfileStreamConfigurationPropertyToCloudFormation(properties.streamConfiguration), StudioComponentIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.studioComponentIds), StudioId: cdk.stringToCloudFormation(properties.studioId), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnLaunchProfilePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ec2SubnetIds", "Ec2SubnetIds", cfn_parse.FromCloudFormation.getStringArray(properties.Ec2SubnetIds)), ret.addPropertyResult("launchProfileProtocolVersions", "LaunchProfileProtocolVersions", cfn_parse.FromCloudFormation.getStringArray(properties.LaunchProfileProtocolVersions)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("streamConfiguration", "StreamConfiguration", CfnLaunchProfileStreamConfigurationPropertyFromCloudFormation(properties.StreamConfiguration)), ret.addPropertyResult("studioComponentIds", "StudioComponentIds", cfn_parse.FromCloudFormation.getStringArray(properties.StudioComponentIds)), ret.addPropertyResult("studioId", "StudioId", cfn_parse.FromCloudFormation.getString(properties.StudioId)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLaunchProfile = class _CfnLaunchProfile extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLaunchProfilePropsFromCloudFormation(resourceProperties), ret = new _CfnLaunchProfile(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLaunchProfile.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_nimblestudio_CfnLaunchProfileProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLaunchProfile), error;
        }
        cdk.requireProperty(props, "ec2SubnetIds", this), cdk.requireProperty(props, "launchProfileProtocolVersions", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "streamConfiguration", this), cdk.requireProperty(props, "studioComponentIds", this), cdk.requireProperty(props, "studioId", this), this.attrLaunchProfileId = cdk.Token.asString(this.getAtt("LaunchProfileId", cdk.ResolutionTypeHint.STRING)), this.ec2SubnetIds = props.ec2SubnetIds, this.launchProfileProtocolVersions = props.launchProfileProtocolVersions, this.name = props.name, this.streamConfiguration = props.streamConfiguration, this.studioComponentIds = props.studioComponentIds, this.studioId = props.studioId, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::NimbleStudio::LaunchProfile", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLaunchProfile.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { ec2SubnetIds: this.ec2SubnetIds, launchProfileProtocolVersions: this.launchProfileProtocolVersions, name: this.name, streamConfiguration: this.streamConfiguration, studioComponentIds: this.studioComponentIds, studioId: this.studioId, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnLaunchProfilePropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnLaunchProfile[_a] = { fqn: "aws-cdk-lib.aws_nimblestudio.CfnLaunchProfile", version: "2.80.0" }, CfnLaunchProfile.CFN_RESOURCE_TYPE_NAME = "AWS::NimbleStudio::LaunchProfile", exports2.CfnLaunchProfile = CfnLaunchProfile;
    function CfnLaunchProfile_StreamConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("automaticTerminationMode", cdk.validateString)(properties.automaticTerminationMode)), errors.collect(cdk.propertyValidator("clipboardMode", cdk.requiredValidator)(properties.clipboardMode)), errors.collect(cdk.propertyValidator("clipboardMode", cdk.validateString)(properties.clipboardMode)), errors.collect(cdk.propertyValidator("ec2InstanceTypes", cdk.requiredValidator)(properties.ec2InstanceTypes)), errors.collect(cdk.propertyValidator("ec2InstanceTypes", cdk.listValidator(cdk.validateString))(properties.ec2InstanceTypes)), errors.collect(cdk.propertyValidator("maxSessionLengthInMinutes", cdk.validateNumber)(properties.maxSessionLengthInMinutes)), errors.collect(cdk.propertyValidator("maxStoppedSessionLengthInMinutes", cdk.validateNumber)(properties.maxStoppedSessionLengthInMinutes)), errors.collect(cdk.propertyValidator("sessionBackup", CfnLaunchProfile_StreamConfigurationSessionBackupPropertyValidator)(properties.sessionBackup)), errors.collect(cdk.propertyValidator("sessionPersistenceMode", cdk.validateString)(properties.sessionPersistenceMode)), errors.collect(cdk.propertyValidator("sessionStorage", CfnLaunchProfile_StreamConfigurationSessionStoragePropertyValidator)(properties.sessionStorage)), errors.collect(cdk.propertyValidator("streamingImageIds", cdk.requiredValidator)(properties.streamingImageIds)), errors.collect(cdk.propertyValidator("streamingImageIds", cdk.listValidator(cdk.validateString))(properties.streamingImageIds)), errors.collect(cdk.propertyValidator("volumeConfiguration", CfnLaunchProfile_VolumeConfigurationPropertyValidator)(properties.volumeConfiguration)), errors.wrap('supplied properties not correct for "StreamConfigurationProperty"');
    }
    function cfnLaunchProfileStreamConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchProfile_StreamConfigurationPropertyValidator(properties).assertSuccess(), { AutomaticTerminationMode: cdk.stringToCloudFormation(properties.automaticTerminationMode), ClipboardMode: cdk.stringToCloudFormation(properties.clipboardMode), Ec2InstanceTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.ec2InstanceTypes), MaxSessionLengthInMinutes: cdk.numberToCloudFormation(properties.maxSessionLengthInMinutes), MaxStoppedSessionLengthInMinutes: cdk.numberToCloudFormation(properties.maxStoppedSessionLengthInMinutes), SessionBackup: cfnLaunchProfileStreamConfigurationSessionBackupPropertyToCloudFormation(properties.sessionBackup), SessionPersistenceMode: cdk.stringToCloudFormation(properties.sessionPersistenceMode), SessionStorage: cfnLaunchProfileStreamConfigurationSessionStoragePropertyToCloudFormation(properties.sessionStorage), StreamingImageIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.streamingImageIds), VolumeConfiguration: cfnLaunchProfileVolumeConfigurationPropertyToCloudFormation(properties.volumeConfiguration) }) : properties;
    }
    function CfnLaunchProfileStreamConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("automaticTerminationMode", "AutomaticTerminationMode", properties.AutomaticTerminationMode != null ? cfn_parse.FromCloudFormation.getString(properties.AutomaticTerminationMode) : void 0), ret.addPropertyResult("clipboardMode", "ClipboardMode", cfn_parse.FromCloudFormation.getString(properties.ClipboardMode)), ret.addPropertyResult("ec2InstanceTypes", "Ec2InstanceTypes", cfn_parse.FromCloudFormation.getStringArray(properties.Ec2InstanceTypes)), ret.addPropertyResult("maxSessionLengthInMinutes", "MaxSessionLengthInMinutes", properties.MaxSessionLengthInMinutes != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxSessionLengthInMinutes) : void 0), ret.addPropertyResult("maxStoppedSessionLengthInMinutes", "MaxStoppedSessionLengthInMinutes", properties.MaxStoppedSessionLengthInMinutes != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxStoppedSessionLengthInMinutes) : void 0), ret.addPropertyResult("sessionBackup", "SessionBackup", properties.SessionBackup != null ? CfnLaunchProfileStreamConfigurationSessionBackupPropertyFromCloudFormation(properties.SessionBackup) : void 0), ret.addPropertyResult("sessionPersistenceMode", "SessionPersistenceMode", properties.SessionPersistenceMode != null ? cfn_parse.FromCloudFormation.getString(properties.SessionPersistenceMode) : void 0), ret.addPropertyResult("sessionStorage", "SessionStorage", properties.SessionStorage != null ? CfnLaunchProfileStreamConfigurationSessionStoragePropertyFromCloudFormation(properties.SessionStorage) : void 0), ret.addPropertyResult("streamingImageIds", "StreamingImageIds", cfn_parse.FromCloudFormation.getStringArray(properties.StreamingImageIds)), ret.addPropertyResult("volumeConfiguration", "VolumeConfiguration", properties.VolumeConfiguration != null ? CfnLaunchProfileVolumeConfigurationPropertyFromCloudFormation(properties.VolumeConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchProfile_StreamConfigurationSessionBackupPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxBackupsToRetain", cdk.validateNumber)(properties.maxBackupsToRetain)), errors.collect(cdk.propertyValidator("mode", cdk.validateString)(properties.mode)), errors.wrap('supplied properties not correct for "StreamConfigurationSessionBackupProperty"');
    }
    function cfnLaunchProfileStreamConfigurationSessionBackupPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchProfile_StreamConfigurationSessionBackupPropertyValidator(properties).assertSuccess(), { MaxBackupsToRetain: cdk.numberToCloudFormation(properties.maxBackupsToRetain), Mode: cdk.stringToCloudFormation(properties.mode) }) : properties;
    }
    function CfnLaunchProfileStreamConfigurationSessionBackupPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxBackupsToRetain", "MaxBackupsToRetain", properties.MaxBackupsToRetain != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxBackupsToRetain) : void 0), ret.addPropertyResult("mode", "Mode", properties.Mode != null ? cfn_parse.FromCloudFormation.getString(properties.Mode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchProfile_StreamConfigurationSessionStoragePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mode", cdk.requiredValidator)(properties.mode)), errors.collect(cdk.propertyValidator("mode", cdk.listValidator(cdk.validateString))(properties.mode)), errors.collect(cdk.propertyValidator("root", CfnLaunchProfile_StreamingSessionStorageRootPropertyValidator)(properties.root)), errors.wrap('supplied properties not correct for "StreamConfigurationSessionStorageProperty"');
    }
    function cfnLaunchProfileStreamConfigurationSessionStoragePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchProfile_StreamConfigurationSessionStoragePropertyValidator(properties).assertSuccess(), { Mode: cdk.listMapper(cdk.stringToCloudFormation)(properties.mode), Root: cfnLaunchProfileStreamingSessionStorageRootPropertyToCloudFormation(properties.root) }) : properties;
    }
    function CfnLaunchProfileStreamConfigurationSessionStoragePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mode", "Mode", cfn_parse.FromCloudFormation.getStringArray(properties.Mode)), ret.addPropertyResult("root", "Root", properties.Root != null ? CfnLaunchProfileStreamingSessionStorageRootPropertyFromCloudFormation(properties.Root) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchProfile_StreamingSessionStorageRootPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("linux", cdk.validateString)(properties.linux)), errors.collect(cdk.propertyValidator("windows", cdk.validateString)(properties.windows)), errors.wrap('supplied properties not correct for "StreamingSessionStorageRootProperty"');
    }
    function cfnLaunchProfileStreamingSessionStorageRootPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchProfile_StreamingSessionStorageRootPropertyValidator(properties).assertSuccess(), { Linux: cdk.stringToCloudFormation(properties.linux), Windows: cdk.stringToCloudFormation(properties.windows) }) : properties;
    }
    function CfnLaunchProfileStreamingSessionStorageRootPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("linux", "Linux", properties.Linux != null ? cfn_parse.FromCloudFormation.getString(properties.Linux) : void 0), ret.addPropertyResult("windows", "Windows", properties.Windows != null ? cfn_parse.FromCloudFormation.getString(properties.Windows) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchProfile_VolumeConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("iops", cdk.validateNumber)(properties.iops)), errors.collect(cdk.propertyValidator("size", cdk.validateNumber)(properties.size)), errors.collect(cdk.propertyValidator("throughput", cdk.validateNumber)(properties.throughput)), errors.wrap('supplied properties not correct for "VolumeConfigurationProperty"');
    }
    function cfnLaunchProfileVolumeConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchProfile_VolumeConfigurationPropertyValidator(properties).assertSuccess(), { Iops: cdk.numberToCloudFormation(properties.iops), Size: cdk.numberToCloudFormation(properties.size), Throughput: cdk.numberToCloudFormation(properties.throughput) }) : properties;
    }
    function CfnLaunchProfileVolumeConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("iops", "Iops", properties.Iops != null ? cfn_parse.FromCloudFormation.getNumber(properties.Iops) : void 0), ret.addPropertyResult("size", "Size", properties.Size != null ? cfn_parse.FromCloudFormation.getNumber(properties.Size) : void 0), ret.addPropertyResult("throughput", "Throughput", properties.Throughput != null ? cfn_parse.FromCloudFormation.getNumber(properties.Throughput) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStreamingImagePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("ec2ImageId", cdk.requiredValidator)(properties.ec2ImageId)), errors.collect(cdk.propertyValidator("ec2ImageId", cdk.validateString)(properties.ec2ImageId)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("studioId", cdk.requiredValidator)(properties.studioId)), errors.collect(cdk.propertyValidator("studioId", cdk.validateString)(properties.studioId)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.wrap('supplied properties not correct for "CfnStreamingImageProps"');
    }
    function cfnStreamingImagePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStreamingImagePropsValidator(properties).assertSuccess(), { Ec2ImageId: cdk.stringToCloudFormation(properties.ec2ImageId), Name: cdk.stringToCloudFormation(properties.name), StudioId: cdk.stringToCloudFormation(properties.studioId), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnStreamingImagePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ec2ImageId", "Ec2ImageId", cfn_parse.FromCloudFormation.getString(properties.Ec2ImageId)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("studioId", "StudioId", cfn_parse.FromCloudFormation.getString(properties.StudioId)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnStreamingImage = class _CfnStreamingImage extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnStreamingImagePropsFromCloudFormation(resourceProperties), ret = new _CfnStreamingImage(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnStreamingImage.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_nimblestudio_CfnStreamingImageProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnStreamingImage), error;
        }
        cdk.requireProperty(props, "ec2ImageId", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "studioId", this), this.attrEncryptionConfigurationKeyArn = cdk.Token.asString(this.getAtt("EncryptionConfiguration.KeyArn", cdk.ResolutionTypeHint.STRING)), this.attrEncryptionConfigurationKeyType = cdk.Token.asString(this.getAtt("EncryptionConfiguration.KeyType", cdk.ResolutionTypeHint.STRING)), this.attrEulaIds = cdk.Token.asList(this.getAtt("EulaIds", cdk.ResolutionTypeHint.STRING_LIST)), this.attrOwner = cdk.Token.asString(this.getAtt("Owner", cdk.ResolutionTypeHint.STRING)), this.attrPlatform = cdk.Token.asString(this.getAtt("Platform", cdk.ResolutionTypeHint.STRING)), this.attrStreamingImageId = cdk.Token.asString(this.getAtt("StreamingImageId", cdk.ResolutionTypeHint.STRING)), this.ec2ImageId = props.ec2ImageId, this.name = props.name, this.studioId = props.studioId, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::NimbleStudio::StreamingImage", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStreamingImage.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { ec2ImageId: this.ec2ImageId, name: this.name, studioId: this.studioId, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnStreamingImagePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnStreamingImage[_b] = { fqn: "aws-cdk-lib.aws_nimblestudio.CfnStreamingImage", version: "2.80.0" }, CfnStreamingImage.CFN_RESOURCE_TYPE_NAME = "AWS::NimbleStudio::StreamingImage", exports2.CfnStreamingImage = CfnStreamingImage;
    function CfnStudioPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("adminRoleArn", cdk.requiredValidator)(properties.adminRoleArn)), errors.collect(cdk.propertyValidator("adminRoleArn", cdk.validateString)(properties.adminRoleArn)), errors.collect(cdk.propertyValidator("displayName", cdk.requiredValidator)(properties.displayName)), errors.collect(cdk.propertyValidator("displayName", cdk.validateString)(properties.displayName)), errors.collect(cdk.propertyValidator("studioEncryptionConfiguration", CfnStudio_StudioEncryptionConfigurationPropertyValidator)(properties.studioEncryptionConfiguration)), errors.collect(cdk.propertyValidator("studioName", cdk.requiredValidator)(properties.studioName)), errors.collect(cdk.propertyValidator("studioName", cdk.validateString)(properties.studioName)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.collect(cdk.propertyValidator("userRoleArn", cdk.requiredValidator)(properties.userRoleArn)), errors.collect(cdk.propertyValidator("userRoleArn", cdk.validateString)(properties.userRoleArn)), errors.wrap('supplied properties not correct for "CfnStudioProps"');
    }
    function cfnStudioPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStudioPropsValidator(properties).assertSuccess(), { AdminRoleArn: cdk.stringToCloudFormation(properties.adminRoleArn), DisplayName: cdk.stringToCloudFormation(properties.displayName), StudioName: cdk.stringToCloudFormation(properties.studioName), UserRoleArn: cdk.stringToCloudFormation(properties.userRoleArn), StudioEncryptionConfiguration: cfnStudioStudioEncryptionConfigurationPropertyToCloudFormation(properties.studioEncryptionConfiguration), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnStudioPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("adminRoleArn", "AdminRoleArn", cfn_parse.FromCloudFormation.getString(properties.AdminRoleArn)), ret.addPropertyResult("displayName", "DisplayName", cfn_parse.FromCloudFormation.getString(properties.DisplayName)), ret.addPropertyResult("studioName", "StudioName", cfn_parse.FromCloudFormation.getString(properties.StudioName)), ret.addPropertyResult("userRoleArn", "UserRoleArn", cfn_parse.FromCloudFormation.getString(properties.UserRoleArn)), ret.addPropertyResult("studioEncryptionConfiguration", "StudioEncryptionConfiguration", properties.StudioEncryptionConfiguration != null ? CfnStudioStudioEncryptionConfigurationPropertyFromCloudFormation(properties.StudioEncryptionConfiguration) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnStudio = class _CfnStudio extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnStudioPropsFromCloudFormation(resourceProperties), ret = new _CfnStudio(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnStudio.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_nimblestudio_CfnStudioProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnStudio), error;
        }
        cdk.requireProperty(props, "adminRoleArn", this), cdk.requireProperty(props, "displayName", this), cdk.requireProperty(props, "studioName", this), cdk.requireProperty(props, "userRoleArn", this), this.attrHomeRegion = cdk.Token.asString(this.getAtt("HomeRegion", cdk.ResolutionTypeHint.STRING)), this.attrSsoClientId = cdk.Token.asString(this.getAtt("SsoClientId", cdk.ResolutionTypeHint.STRING)), this.attrStudioId = cdk.Token.asString(this.getAtt("StudioId", cdk.ResolutionTypeHint.STRING)), this.attrStudioUrl = cdk.Token.asString(this.getAtt("StudioUrl", cdk.ResolutionTypeHint.STRING)), this.adminRoleArn = props.adminRoleArn, this.displayName = props.displayName, this.studioName = props.studioName, this.userRoleArn = props.userRoleArn, this.studioEncryptionConfiguration = props.studioEncryptionConfiguration, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::NimbleStudio::Studio", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStudio.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { adminRoleArn: this.adminRoleArn, displayName: this.displayName, studioName: this.studioName, userRoleArn: this.userRoleArn, studioEncryptionConfiguration: this.studioEncryptionConfiguration, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnStudioPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnStudio[_c] = { fqn: "aws-cdk-lib.aws_nimblestudio.CfnStudio", version: "2.80.0" }, CfnStudio.CFN_RESOURCE_TYPE_NAME = "AWS::NimbleStudio::Studio", exports2.CfnStudio = CfnStudio;
    function CfnStudio_StudioEncryptionConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("keyArn", cdk.validateString)(properties.keyArn)), errors.collect(cdk.propertyValidator("keyType", cdk.requiredValidator)(properties.keyType)), errors.collect(cdk.propertyValidator("keyType", cdk.validateString)(properties.keyType)), errors.wrap('supplied properties not correct for "StudioEncryptionConfigurationProperty"');
    }
    function cfnStudioStudioEncryptionConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStudio_StudioEncryptionConfigurationPropertyValidator(properties).assertSuccess(), { KeyArn: cdk.stringToCloudFormation(properties.keyArn), KeyType: cdk.stringToCloudFormation(properties.keyType) }) : properties;
    }
    function CfnStudioStudioEncryptionConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("keyArn", "KeyArn", properties.KeyArn != null ? cfn_parse.FromCloudFormation.getString(properties.KeyArn) : void 0), ret.addPropertyResult("keyType", "KeyType", cfn_parse.FromCloudFormation.getString(properties.KeyType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStudioComponentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configuration", CfnStudioComponent_StudioComponentConfigurationPropertyValidator)(properties.configuration)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("ec2SecurityGroupIds", cdk.listValidator(cdk.validateString))(properties.ec2SecurityGroupIds)), errors.collect(cdk.propertyValidator("initializationScripts", cdk.listValidator(CfnStudioComponent_StudioComponentInitializationScriptPropertyValidator))(properties.initializationScripts)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("scriptParameters", cdk.listValidator(CfnStudioComponent_ScriptParameterKeyValuePropertyValidator))(properties.scriptParameters)), errors.collect(cdk.propertyValidator("studioId", cdk.requiredValidator)(properties.studioId)), errors.collect(cdk.propertyValidator("studioId", cdk.validateString)(properties.studioId)), errors.collect(cdk.propertyValidator("subtype", cdk.validateString)(properties.subtype)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnStudioComponentProps"');
    }
    function cfnStudioComponentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStudioComponentPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), StudioId: cdk.stringToCloudFormation(properties.studioId), Type: cdk.stringToCloudFormation(properties.type), Configuration: cfnStudioComponentStudioComponentConfigurationPropertyToCloudFormation(properties.configuration), Description: cdk.stringToCloudFormation(properties.description), Ec2SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.ec2SecurityGroupIds), InitializationScripts: cdk.listMapper(cfnStudioComponentStudioComponentInitializationScriptPropertyToCloudFormation)(properties.initializationScripts), ScriptParameters: cdk.listMapper(cfnStudioComponentScriptParameterKeyValuePropertyToCloudFormation)(properties.scriptParameters), Subtype: cdk.stringToCloudFormation(properties.subtype), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnStudioComponentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("studioId", "StudioId", cfn_parse.FromCloudFormation.getString(properties.StudioId)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("configuration", "Configuration", properties.Configuration != null ? CfnStudioComponentStudioComponentConfigurationPropertyFromCloudFormation(properties.Configuration) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("ec2SecurityGroupIds", "Ec2SecurityGroupIds", properties.Ec2SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Ec2SecurityGroupIds) : void 0), ret.addPropertyResult("initializationScripts", "InitializationScripts", properties.InitializationScripts != null ? cfn_parse.FromCloudFormation.getArray(CfnStudioComponentStudioComponentInitializationScriptPropertyFromCloudFormation)(properties.InitializationScripts) : void 0), ret.addPropertyResult("scriptParameters", "ScriptParameters", properties.ScriptParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnStudioComponentScriptParameterKeyValuePropertyFromCloudFormation)(properties.ScriptParameters) : void 0), ret.addPropertyResult("subtype", "Subtype", properties.Subtype != null ? cfn_parse.FromCloudFormation.getString(properties.Subtype) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnStudioComponent = class _CfnStudioComponent extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnStudioComponentPropsFromCloudFormation(resourceProperties), ret = new _CfnStudioComponent(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnStudioComponent.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_nimblestudio_CfnStudioComponentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnStudioComponent), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "studioId", this), cdk.requireProperty(props, "type", this), this.attrStudioComponentId = cdk.Token.asString(this.getAtt("StudioComponentId", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.studioId = props.studioId, this.type = props.type, this.configuration = props.configuration, this.description = props.description, this.ec2SecurityGroupIds = props.ec2SecurityGroupIds, this.initializationScripts = props.initializationScripts, this.scriptParameters = props.scriptParameters, this.subtype = props.subtype, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::NimbleStudio::StudioComponent", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStudioComponent.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, studioId: this.studioId, type: this.type, configuration: this.configuration, description: this.description, ec2SecurityGroupIds: this.ec2SecurityGroupIds, initializationScripts: this.initializationScripts, scriptParameters: this.scriptParameters, subtype: this.subtype, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnStudioComponentPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnStudioComponent[_d] = { fqn: "aws-cdk-lib.aws_nimblestudio.CfnStudioComponent", version: "2.80.0" }, CfnStudioComponent.CFN_RESOURCE_TYPE_NAME = "AWS::NimbleStudio::StudioComponent", exports2.CfnStudioComponent = CfnStudioComponent;
    function CfnStudioComponent_ActiveDirectoryComputerAttributePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "ActiveDirectoryComputerAttributeProperty"');
    }
    function cfnStudioComponentActiveDirectoryComputerAttributePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStudioComponent_ActiveDirectoryComputerAttributePropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnStudioComponentActiveDirectoryComputerAttributePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStudioComponent_ActiveDirectoryConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computerAttributes", cdk.listValidator(CfnStudioComponent_ActiveDirectoryComputerAttributePropertyValidator))(properties.computerAttributes)), errors.collect(cdk.propertyValidator("directoryId", cdk.validateString)(properties.directoryId)), errors.collect(cdk.propertyValidator("organizationalUnitDistinguishedName", cdk.validateString)(properties.organizationalUnitDistinguishedName)), errors.wrap('supplied properties not correct for "ActiveDirectoryConfigurationProperty"');
    }
    function cfnStudioComponentActiveDirectoryConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStudioComponent_ActiveDirectoryConfigurationPropertyValidator(properties).assertSuccess(), { ComputerAttributes: cdk.listMapper(cfnStudioComponentActiveDirectoryComputerAttributePropertyToCloudFormation)(properties.computerAttributes), DirectoryId: cdk.stringToCloudFormation(properties.directoryId), OrganizationalUnitDistinguishedName: cdk.stringToCloudFormation(properties.organizationalUnitDistinguishedName) }) : properties;
    }
    function CfnStudioComponentActiveDirectoryConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computerAttributes", "ComputerAttributes", properties.ComputerAttributes != null ? cfn_parse.FromCloudFormation.getArray(CfnStudioComponentActiveDirectoryComputerAttributePropertyFromCloudFormation)(properties.ComputerAttributes) : void 0), ret.addPropertyResult("directoryId", "DirectoryId", properties.DirectoryId != null ? cfn_parse.FromCloudFormation.getString(properties.DirectoryId) : void 0), ret.addPropertyResult("organizationalUnitDistinguishedName", "OrganizationalUnitDistinguishedName", properties.OrganizationalUnitDistinguishedName != null ? cfn_parse.FromCloudFormation.getString(properties.OrganizationalUnitDistinguishedName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStudioComponent_ComputeFarmConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("activeDirectoryUser", cdk.validateString)(properties.activeDirectoryUser)), errors.collect(cdk.propertyValidator("endpoint", cdk.validateString)(properties.endpoint)), errors.wrap('supplied properties not correct for "ComputeFarmConfigurationProperty"');
    }
    function cfnStudioComponentComputeFarmConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStudioComponent_ComputeFarmConfigurationPropertyValidator(properties).assertSuccess(), { ActiveDirectoryUser: cdk.stringToCloudFormation(properties.activeDirectoryUser), Endpoint: cdk.stringToCloudFormation(properties.endpoint) }) : properties;
    }
    function CfnStudioComponentComputeFarmConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("activeDirectoryUser", "ActiveDirectoryUser", properties.ActiveDirectoryUser != null ? cfn_parse.FromCloudFormation.getString(properties.ActiveDirectoryUser) : void 0), ret.addPropertyResult("endpoint", "Endpoint", properties.Endpoint != null ? cfn_parse.FromCloudFormation.getString(properties.Endpoint) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStudioComponent_LicenseServiceConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endpoint", cdk.validateString)(properties.endpoint)), errors.wrap('supplied properties not correct for "LicenseServiceConfigurationProperty"');
    }
    function cfnStudioComponentLicenseServiceConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStudioComponent_LicenseServiceConfigurationPropertyValidator(properties).assertSuccess(), { Endpoint: cdk.stringToCloudFormation(properties.endpoint) }) : properties;
    }
    function CfnStudioComponentLicenseServiceConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endpoint", "Endpoint", properties.Endpoint != null ? cfn_parse.FromCloudFormation.getString(properties.Endpoint) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStudioComponent_ScriptParameterKeyValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "ScriptParameterKeyValueProperty"');
    }
    function cfnStudioComponentScriptParameterKeyValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStudioComponent_ScriptParameterKeyValuePropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnStudioComponentScriptParameterKeyValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStudioComponent_SharedFileSystemConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endpoint", cdk.validateString)(properties.endpoint)), errors.collect(cdk.propertyValidator("fileSystemId", cdk.validateString)(properties.fileSystemId)), errors.collect(cdk.propertyValidator("linuxMountPoint", cdk.validateString)(properties.linuxMountPoint)), errors.collect(cdk.propertyValidator("shareName", cdk.validateString)(properties.shareName)), errors.collect(cdk.propertyValidator("windowsMountDrive", cdk.validateString)(properties.windowsMountDrive)), errors.wrap('supplied properties not correct for "SharedFileSystemConfigurationProperty"');
    }
    function cfnStudioComponentSharedFileSystemConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStudioComponent_SharedFileSystemConfigurationPropertyValidator(properties).assertSuccess(), { Endpoint: cdk.stringToCloudFormation(properties.endpoint), FileSystemId: cdk.stringToCloudFormation(properties.fileSystemId), LinuxMountPoint: cdk.stringToCloudFormation(properties.linuxMountPoint), ShareName: cdk.stringToCloudFormation(properties.shareName), WindowsMountDrive: cdk.stringToCloudFormation(properties.windowsMountDrive) }) : properties;
    }
    function CfnStudioComponentSharedFileSystemConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endpoint", "Endpoint", properties.Endpoint != null ? cfn_parse.FromCloudFormation.getString(properties.Endpoint) : void 0), ret.addPropertyResult("fileSystemId", "FileSystemId", properties.FileSystemId != null ? cfn_parse.FromCloudFormation.getString(properties.FileSystemId) : void 0), ret.addPropertyResult("linuxMountPoint", "LinuxMountPoint", properties.LinuxMountPoint != null ? cfn_parse.FromCloudFormation.getString(properties.LinuxMountPoint) : void 0), ret.addPropertyResult("shareName", "ShareName", properties.ShareName != null ? cfn_parse.FromCloudFormation.getString(properties.ShareName) : void 0), ret.addPropertyResult("windowsMountDrive", "WindowsMountDrive", properties.WindowsMountDrive != null ? cfn_parse.FromCloudFormation.getString(properties.WindowsMountDrive) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStudioComponent_StudioComponentConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("activeDirectoryConfiguration", CfnStudioComponent_ActiveDirectoryConfigurationPropertyValidator)(properties.activeDirectoryConfiguration)), errors.collect(cdk.propertyValidator("computeFarmConfiguration", CfnStudioComponent_ComputeFarmConfigurationPropertyValidator)(properties.computeFarmConfiguration)), errors.collect(cdk.propertyValidator("licenseServiceConfiguration", CfnStudioComponent_LicenseServiceConfigurationPropertyValidator)(properties.licenseServiceConfiguration)), errors.collect(cdk.propertyValidator("sharedFileSystemConfiguration", CfnStudioComponent_SharedFileSystemConfigurationPropertyValidator)(properties.sharedFileSystemConfiguration)), errors.wrap('supplied properties not correct for "StudioComponentConfigurationProperty"');
    }
    function cfnStudioComponentStudioComponentConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStudioComponent_StudioComponentConfigurationPropertyValidator(properties).assertSuccess(), { ActiveDirectoryConfiguration: cfnStudioComponentActiveDirectoryConfigurationPropertyToCloudFormation(properties.activeDirectoryConfiguration), ComputeFarmConfiguration: cfnStudioComponentComputeFarmConfigurationPropertyToCloudFormation(properties.computeFarmConfiguration), LicenseServiceConfiguration: cfnStudioComponentLicenseServiceConfigurationPropertyToCloudFormation(properties.licenseServiceConfiguration), SharedFileSystemConfiguration: cfnStudioComponentSharedFileSystemConfigurationPropertyToCloudFormation(properties.sharedFileSystemConfiguration) }) : properties;
    }
    function CfnStudioComponentStudioComponentConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("activeDirectoryConfiguration", "ActiveDirectoryConfiguration", properties.ActiveDirectoryConfiguration != null ? CfnStudioComponentActiveDirectoryConfigurationPropertyFromCloudFormation(properties.ActiveDirectoryConfiguration) : void 0), ret.addPropertyResult("computeFarmConfiguration", "ComputeFarmConfiguration", properties.ComputeFarmConfiguration != null ? CfnStudioComponentComputeFarmConfigurationPropertyFromCloudFormation(properties.ComputeFarmConfiguration) : void 0), ret.addPropertyResult("licenseServiceConfiguration", "LicenseServiceConfiguration", properties.LicenseServiceConfiguration != null ? CfnStudioComponentLicenseServiceConfigurationPropertyFromCloudFormation(properties.LicenseServiceConfiguration) : void 0), ret.addPropertyResult("sharedFileSystemConfiguration", "SharedFileSystemConfiguration", properties.SharedFileSystemConfiguration != null ? CfnStudioComponentSharedFileSystemConfigurationPropertyFromCloudFormation(properties.SharedFileSystemConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStudioComponent_StudioComponentInitializationScriptPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("launchProfileProtocolVersion", cdk.validateString)(properties.launchProfileProtocolVersion)), errors.collect(cdk.propertyValidator("platform", cdk.validateString)(properties.platform)), errors.collect(cdk.propertyValidator("runContext", cdk.validateString)(properties.runContext)), errors.collect(cdk.propertyValidator("script", cdk.validateString)(properties.script)), errors.wrap('supplied properties not correct for "StudioComponentInitializationScriptProperty"');
    }
    function cfnStudioComponentStudioComponentInitializationScriptPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStudioComponent_StudioComponentInitializationScriptPropertyValidator(properties).assertSuccess(), { LaunchProfileProtocolVersion: cdk.stringToCloudFormation(properties.launchProfileProtocolVersion), Platform: cdk.stringToCloudFormation(properties.platform), RunContext: cdk.stringToCloudFormation(properties.runContext), Script: cdk.stringToCloudFormation(properties.script) }) : properties;
    }
    function CfnStudioComponentStudioComponentInitializationScriptPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("launchProfileProtocolVersion", "LaunchProfileProtocolVersion", properties.LaunchProfileProtocolVersion != null ? cfn_parse.FromCloudFormation.getString(properties.LaunchProfileProtocolVersion) : void 0), ret.addPropertyResult("platform", "Platform", properties.Platform != null ? cfn_parse.FromCloudFormation.getString(properties.Platform) : void 0), ret.addPropertyResult("runContext", "RunContext", properties.RunContext != null ? cfn_parse.FromCloudFormation.getString(properties.RunContext) : void 0), ret.addPropertyResult("script", "Script", properties.Script != null ? cfn_parse.FromCloudFormation.getString(properties.Script) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-nimblestudio/lib/index.js
var require_lib198 = __commonJS({
  "node_modules/aws-cdk-lib/aws-nimblestudio/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_nimblestudio_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-nimblestudio/index.js
var require_aws_nimblestudio = __commonJS({
  "node_modules/aws-cdk-lib/aws-nimblestudio/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib198(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-oam/lib/oam.generated.js
var require_oam_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-oam/lib/oam.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnSink = exports2.CfnLink = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnLinkPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("labelTemplate", cdk.validateString)(properties.labelTemplate)), errors.collect(cdk.propertyValidator("resourceTypes", cdk.requiredValidator)(properties.resourceTypes)), errors.collect(cdk.propertyValidator("resourceTypes", cdk.listValidator(cdk.validateString))(properties.resourceTypes)), errors.collect(cdk.propertyValidator("sinkIdentifier", cdk.requiredValidator)(properties.sinkIdentifier)), errors.collect(cdk.propertyValidator("sinkIdentifier", cdk.validateString)(properties.sinkIdentifier)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.wrap('supplied properties not correct for "CfnLinkProps"');
    }
    function cfnLinkPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLinkPropsValidator(properties).assertSuccess(), { ResourceTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.resourceTypes), SinkIdentifier: cdk.stringToCloudFormation(properties.sinkIdentifier), LabelTemplate: cdk.stringToCloudFormation(properties.labelTemplate), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnLinkPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceTypes", "ResourceTypes", cfn_parse.FromCloudFormation.getStringArray(properties.ResourceTypes)), ret.addPropertyResult("sinkIdentifier", "SinkIdentifier", cfn_parse.FromCloudFormation.getString(properties.SinkIdentifier)), ret.addPropertyResult("labelTemplate", "LabelTemplate", properties.LabelTemplate != null ? cfn_parse.FromCloudFormation.getString(properties.LabelTemplate) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLink = class _CfnLink extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLinkPropsFromCloudFormation(resourceProperties), ret = new _CfnLink(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLink.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_oam_CfnLinkProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLink), error;
        }
        cdk.requireProperty(props, "resourceTypes", this), cdk.requireProperty(props, "sinkIdentifier", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrLabel = cdk.Token.asString(this.getAtt("Label", cdk.ResolutionTypeHint.STRING)), this.resourceTypes = props.resourceTypes, this.sinkIdentifier = props.sinkIdentifier, this.labelTemplate = props.labelTemplate, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Oam::Link", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLink.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { resourceTypes: this.resourceTypes, sinkIdentifier: this.sinkIdentifier, labelTemplate: this.labelTemplate, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnLinkPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnLink[_a] = { fqn: "aws-cdk-lib.aws_oam.CfnLink", version: "2.80.0" }, CfnLink.CFN_RESOURCE_TYPE_NAME = "AWS::Oam::Link", exports2.CfnLink = CfnLink;
    function CfnSinkPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("policy", cdk.validateObject)(properties.policy)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.wrap('supplied properties not correct for "CfnSinkProps"');
    }
    function cfnSinkPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSinkPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Policy: cdk.objectToCloudFormation(properties.policy), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnSinkPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("policy", "Policy", properties.Policy != null ? cfn_parse.FromCloudFormation.getAny(properties.Policy) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSink = class _CfnSink extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSinkPropsFromCloudFormation(resourceProperties), ret = new _CfnSink(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSink.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_oam_CfnSinkProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSink), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.policy = props.policy, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Oam::Sink", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSink.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, policy: this.policy, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnSinkPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnSink[_b] = { fqn: "aws-cdk-lib.aws_oam.CfnSink", version: "2.80.0" }, CfnSink.CFN_RESOURCE_TYPE_NAME = "AWS::Oam::Sink", exports2.CfnSink = CfnSink;
  }
});

// node_modules/aws-cdk-lib/aws-oam/lib/index.js
var require_lib199 = __commonJS({
  "node_modules/aws-cdk-lib/aws-oam/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_oam_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-oam/index.js
var require_aws_oam = __commonJS({
  "node_modules/aws-cdk-lib/aws-oam/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib199(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-omics/lib/omics.generated.js
var require_omics_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-omics/lib/omics.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnWorkflow = exports2.CfnVariantStore = exports2.CfnSequenceStore = exports2.CfnRunGroup = exports2.CfnReferenceStore = exports2.CfnAnnotationStore = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAnnotationStorePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("reference", CfnAnnotationStore_ReferenceItemPropertyValidator)(properties.reference)), errors.collect(cdk.propertyValidator("sseConfig", CfnAnnotationStore_SseConfigPropertyValidator)(properties.sseConfig)), errors.collect(cdk.propertyValidator("storeFormat", cdk.requiredValidator)(properties.storeFormat)), errors.collect(cdk.propertyValidator("storeFormat", cdk.validateString)(properties.storeFormat)), errors.collect(cdk.propertyValidator("storeOptions", CfnAnnotationStore_StoreOptionsPropertyValidator)(properties.storeOptions)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.wrap('supplied properties not correct for "CfnAnnotationStoreProps"');
    }
    function cfnAnnotationStorePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnnotationStorePropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), StoreFormat: cdk.stringToCloudFormation(properties.storeFormat), Description: cdk.stringToCloudFormation(properties.description), Reference: cfnAnnotationStoreReferenceItemPropertyToCloudFormation(properties.reference), SseConfig: cfnAnnotationStoreSseConfigPropertyToCloudFormation(properties.sseConfig), StoreOptions: cfnAnnotationStoreStoreOptionsPropertyToCloudFormation(properties.storeOptions), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnAnnotationStorePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("storeFormat", "StoreFormat", cfn_parse.FromCloudFormation.getString(properties.StoreFormat)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("reference", "Reference", properties.Reference != null ? CfnAnnotationStoreReferenceItemPropertyFromCloudFormation(properties.Reference) : void 0), ret.addPropertyResult("sseConfig", "SseConfig", properties.SseConfig != null ? CfnAnnotationStoreSseConfigPropertyFromCloudFormation(properties.SseConfig) : void 0), ret.addPropertyResult("storeOptions", "StoreOptions", properties.StoreOptions != null ? CfnAnnotationStoreStoreOptionsPropertyFromCloudFormation(properties.StoreOptions) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAnnotationStore = class _CfnAnnotationStore extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAnnotationStorePropsFromCloudFormation(resourceProperties), ret = new _CfnAnnotationStore(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAnnotationStore.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_omics_CfnAnnotationStoreProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAnnotationStore), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "storeFormat", this), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.attrStatusMessage = cdk.Token.asString(this.getAtt("StatusMessage", cdk.ResolutionTypeHint.STRING)), this.attrStoreArn = cdk.Token.asString(this.getAtt("StoreArn", cdk.ResolutionTypeHint.STRING)), this.attrStoreSizeBytes = this.getAtt("StoreSizeBytes", cdk.ResolutionTypeHint.STRING), this.attrUpdateTime = cdk.Token.asString(this.getAtt("UpdateTime", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.storeFormat = props.storeFormat, this.description = props.description, this.reference = props.reference, this.sseConfig = props.sseConfig, this.storeOptions = props.storeOptions, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Omics::AnnotationStore", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAnnotationStore.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, storeFormat: this.storeFormat, description: this.description, reference: this.reference, sseConfig: this.sseConfig, storeOptions: this.storeOptions, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnAnnotationStorePropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAnnotationStore[_a] = { fqn: "aws-cdk-lib.aws_omics.CfnAnnotationStore", version: "2.80.0" }, CfnAnnotationStore.CFN_RESOURCE_TYPE_NAME = "AWS::Omics::AnnotationStore", exports2.CfnAnnotationStore = CfnAnnotationStore;
    function CfnAnnotationStore_ReferenceItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("referenceArn", cdk.requiredValidator)(properties.referenceArn)), errors.collect(cdk.propertyValidator("referenceArn", cdk.validateString)(properties.referenceArn)), errors.wrap('supplied properties not correct for "ReferenceItemProperty"');
    }
    function cfnAnnotationStoreReferenceItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnnotationStore_ReferenceItemPropertyValidator(properties).assertSuccess(), { ReferenceArn: cdk.stringToCloudFormation(properties.referenceArn) }) : properties;
    }
    function CfnAnnotationStoreReferenceItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("referenceArn", "ReferenceArn", cfn_parse.FromCloudFormation.getString(properties.ReferenceArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnnotationStore_SseConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("keyArn", cdk.validateString)(properties.keyArn)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "SseConfigProperty"');
    }
    function cfnAnnotationStoreSseConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnnotationStore_SseConfigPropertyValidator(properties).assertSuccess(), { KeyArn: cdk.stringToCloudFormation(properties.keyArn), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnAnnotationStoreSseConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("keyArn", "KeyArn", properties.KeyArn != null ? cfn_parse.FromCloudFormation.getString(properties.KeyArn) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnnotationStore_StoreOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("tsvStoreOptions", cdk.requiredValidator)(properties.tsvStoreOptions)), errors.collect(cdk.propertyValidator("tsvStoreOptions", CfnAnnotationStore_TsvStoreOptionsPropertyValidator)(properties.tsvStoreOptions)), errors.wrap('supplied properties not correct for "StoreOptionsProperty"');
    }
    function cfnAnnotationStoreStoreOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnnotationStore_StoreOptionsPropertyValidator(properties).assertSuccess(), { TsvStoreOptions: cfnAnnotationStoreTsvStoreOptionsPropertyToCloudFormation(properties.tsvStoreOptions) }) : properties;
    }
    function CfnAnnotationStoreStoreOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("tsvStoreOptions", "TsvStoreOptions", CfnAnnotationStoreTsvStoreOptionsPropertyFromCloudFormation(properties.TsvStoreOptions)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnnotationStore_TsvStoreOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("annotationType", cdk.validateString)(properties.annotationType)), errors.collect(cdk.propertyValidator("formatToHeader", cdk.hashValidator(cdk.validateString))(properties.formatToHeader)), errors.collect(cdk.propertyValidator("schema", cdk.validateObject)(properties.schema)), errors.wrap('supplied properties not correct for "TsvStoreOptionsProperty"');
    }
    function cfnAnnotationStoreTsvStoreOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnnotationStore_TsvStoreOptionsPropertyValidator(properties).assertSuccess(), { AnnotationType: cdk.stringToCloudFormation(properties.annotationType), FormatToHeader: cdk.hashMapper(cdk.stringToCloudFormation)(properties.formatToHeader), Schema: cdk.objectToCloudFormation(properties.schema) }) : properties;
    }
    function CfnAnnotationStoreTsvStoreOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("annotationType", "AnnotationType", properties.AnnotationType != null ? cfn_parse.FromCloudFormation.getString(properties.AnnotationType) : void 0), ret.addPropertyResult("formatToHeader", "FormatToHeader", properties.FormatToHeader != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.FormatToHeader) : void 0), ret.addPropertyResult("schema", "Schema", properties.Schema != null ? cfn_parse.FromCloudFormation.getAny(properties.Schema) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnReferenceStorePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("sseConfig", CfnReferenceStore_SseConfigPropertyValidator)(properties.sseConfig)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.wrap('supplied properties not correct for "CfnReferenceStoreProps"');
    }
    function cfnReferenceStorePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReferenceStorePropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), SseConfig: cfnReferenceStoreSseConfigPropertyToCloudFormation(properties.sseConfig), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnReferenceStorePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("sseConfig", "SseConfig", properties.SseConfig != null ? CfnReferenceStoreSseConfigPropertyFromCloudFormation(properties.SseConfig) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnReferenceStore = class _CfnReferenceStore extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnReferenceStorePropsFromCloudFormation(resourceProperties), ret = new _CfnReferenceStore(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnReferenceStore.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_omics_CfnReferenceStoreProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnReferenceStore), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrReferenceStoreId = cdk.Token.asString(this.getAtt("ReferenceStoreId", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.description = props.description, this.sseConfig = props.sseConfig, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Omics::ReferenceStore", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnReferenceStore.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, description: this.description, sseConfig: this.sseConfig, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnReferenceStorePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnReferenceStore[_b] = { fqn: "aws-cdk-lib.aws_omics.CfnReferenceStore", version: "2.80.0" }, CfnReferenceStore.CFN_RESOURCE_TYPE_NAME = "AWS::Omics::ReferenceStore", exports2.CfnReferenceStore = CfnReferenceStore;
    function CfnReferenceStore_SseConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("keyArn", cdk.validateString)(properties.keyArn)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "SseConfigProperty"');
    }
    function cfnReferenceStoreSseConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReferenceStore_SseConfigPropertyValidator(properties).assertSuccess(), { KeyArn: cdk.stringToCloudFormation(properties.keyArn), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnReferenceStoreSseConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("keyArn", "KeyArn", properties.KeyArn != null ? cfn_parse.FromCloudFormation.getString(properties.KeyArn) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRunGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxCpus", cdk.validateNumber)(properties.maxCpus)), errors.collect(cdk.propertyValidator("maxDuration", cdk.validateNumber)(properties.maxDuration)), errors.collect(cdk.propertyValidator("maxRuns", cdk.validateNumber)(properties.maxRuns)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.wrap('supplied properties not correct for "CfnRunGroupProps"');
    }
    function cfnRunGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRunGroupPropsValidator(properties).assertSuccess(), { MaxCpus: cdk.numberToCloudFormation(properties.maxCpus), MaxDuration: cdk.numberToCloudFormation(properties.maxDuration), MaxRuns: cdk.numberToCloudFormation(properties.maxRuns), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnRunGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxCpus", "MaxCpus", properties.MaxCpus != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxCpus) : void 0), ret.addPropertyResult("maxDuration", "MaxDuration", properties.MaxDuration != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxDuration) : void 0), ret.addPropertyResult("maxRuns", "MaxRuns", properties.MaxRuns != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxRuns) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRunGroup = class _CfnRunGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRunGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnRunGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnRunGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_omics_CfnRunGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRunGroup), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.maxCpus = props.maxCpus, this.maxDuration = props.maxDuration, this.maxRuns = props.maxRuns, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Omics::RunGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRunGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { maxCpus: this.maxCpus, maxDuration: this.maxDuration, maxRuns: this.maxRuns, name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnRunGroupPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnRunGroup[_c] = { fqn: "aws-cdk-lib.aws_omics.CfnRunGroup", version: "2.80.0" }, CfnRunGroup.CFN_RESOURCE_TYPE_NAME = "AWS::Omics::RunGroup", exports2.CfnRunGroup = CfnRunGroup;
    function CfnSequenceStorePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("sseConfig", CfnSequenceStore_SseConfigPropertyValidator)(properties.sseConfig)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.wrap('supplied properties not correct for "CfnSequenceStoreProps"');
    }
    function cfnSequenceStorePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSequenceStorePropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), SseConfig: cfnSequenceStoreSseConfigPropertyToCloudFormation(properties.sseConfig), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnSequenceStorePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("sseConfig", "SseConfig", properties.SseConfig != null ? CfnSequenceStoreSseConfigPropertyFromCloudFormation(properties.SseConfig) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSequenceStore = class _CfnSequenceStore extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSequenceStorePropsFromCloudFormation(resourceProperties), ret = new _CfnSequenceStore(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSequenceStore.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_omics_CfnSequenceStoreProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSequenceStore), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrSequenceStoreId = cdk.Token.asString(this.getAtt("SequenceStoreId", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.description = props.description, this.sseConfig = props.sseConfig, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Omics::SequenceStore", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSequenceStore.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, description: this.description, sseConfig: this.sseConfig, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnSequenceStorePropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnSequenceStore[_d] = { fqn: "aws-cdk-lib.aws_omics.CfnSequenceStore", version: "2.80.0" }, CfnSequenceStore.CFN_RESOURCE_TYPE_NAME = "AWS::Omics::SequenceStore", exports2.CfnSequenceStore = CfnSequenceStore;
    function CfnSequenceStore_SseConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("keyArn", cdk.validateString)(properties.keyArn)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "SseConfigProperty"');
    }
    function cfnSequenceStoreSseConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSequenceStore_SseConfigPropertyValidator(properties).assertSuccess(), { KeyArn: cdk.stringToCloudFormation(properties.keyArn), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnSequenceStoreSseConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("keyArn", "KeyArn", properties.KeyArn != null ? cfn_parse.FromCloudFormation.getString(properties.KeyArn) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVariantStorePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("reference", cdk.requiredValidator)(properties.reference)), errors.collect(cdk.propertyValidator("reference", CfnVariantStore_ReferenceItemPropertyValidator)(properties.reference)), errors.collect(cdk.propertyValidator("sseConfig", CfnVariantStore_SseConfigPropertyValidator)(properties.sseConfig)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.wrap('supplied properties not correct for "CfnVariantStoreProps"');
    }
    function cfnVariantStorePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVariantStorePropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Reference: cfnVariantStoreReferenceItemPropertyToCloudFormation(properties.reference), Description: cdk.stringToCloudFormation(properties.description), SseConfig: cfnVariantStoreSseConfigPropertyToCloudFormation(properties.sseConfig), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnVariantStorePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("reference", "Reference", CfnVariantStoreReferenceItemPropertyFromCloudFormation(properties.Reference)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("sseConfig", "SseConfig", properties.SseConfig != null ? CfnVariantStoreSseConfigPropertyFromCloudFormation(properties.SseConfig) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVariantStore = class _CfnVariantStore extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVariantStorePropsFromCloudFormation(resourceProperties), ret = new _CfnVariantStore(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVariantStore.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_omics_CfnVariantStoreProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVariantStore), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "reference", this), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.attrStatusMessage = cdk.Token.asString(this.getAtt("StatusMessage", cdk.ResolutionTypeHint.STRING)), this.attrStoreArn = cdk.Token.asString(this.getAtt("StoreArn", cdk.ResolutionTypeHint.STRING)), this.attrStoreSizeBytes = this.getAtt("StoreSizeBytes", cdk.ResolutionTypeHint.STRING), this.attrUpdateTime = cdk.Token.asString(this.getAtt("UpdateTime", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.reference = props.reference, this.description = props.description, this.sseConfig = props.sseConfig, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Omics::VariantStore", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVariantStore.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, reference: this.reference, description: this.description, sseConfig: this.sseConfig, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnVariantStorePropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnVariantStore[_e] = { fqn: "aws-cdk-lib.aws_omics.CfnVariantStore", version: "2.80.0" }, CfnVariantStore.CFN_RESOURCE_TYPE_NAME = "AWS::Omics::VariantStore", exports2.CfnVariantStore = CfnVariantStore;
    function CfnVariantStore_ReferenceItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("referenceArn", cdk.requiredValidator)(properties.referenceArn)), errors.collect(cdk.propertyValidator("referenceArn", cdk.validateString)(properties.referenceArn)), errors.wrap('supplied properties not correct for "ReferenceItemProperty"');
    }
    function cfnVariantStoreReferenceItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVariantStore_ReferenceItemPropertyValidator(properties).assertSuccess(), { ReferenceArn: cdk.stringToCloudFormation(properties.referenceArn) }) : properties;
    }
    function CfnVariantStoreReferenceItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("referenceArn", "ReferenceArn", cfn_parse.FromCloudFormation.getString(properties.ReferenceArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVariantStore_SseConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("keyArn", cdk.validateString)(properties.keyArn)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "SseConfigProperty"');
    }
    function cfnVariantStoreSseConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVariantStore_SseConfigPropertyValidator(properties).assertSuccess(), { KeyArn: cdk.stringToCloudFormation(properties.keyArn), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnVariantStoreSseConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("keyArn", "KeyArn", properties.KeyArn != null ? cfn_parse.FromCloudFormation.getString(properties.KeyArn) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWorkflowPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("definitionUri", cdk.validateString)(properties.definitionUri)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("engine", cdk.validateString)(properties.engine)), errors.collect(cdk.propertyValidator("main", cdk.validateString)(properties.main)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("parameterTemplate", cdk.hashValidator(CfnWorkflow_WorkflowParameterPropertyValidator))(properties.parameterTemplate)), errors.collect(cdk.propertyValidator("storageCapacity", cdk.validateNumber)(properties.storageCapacity)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.wrap('supplied properties not correct for "CfnWorkflowProps"');
    }
    function cfnWorkflowPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkflowPropsValidator(properties).assertSuccess(), { DefinitionUri: cdk.stringToCloudFormation(properties.definitionUri), Description: cdk.stringToCloudFormation(properties.description), Engine: cdk.stringToCloudFormation(properties.engine), Main: cdk.stringToCloudFormation(properties.main), Name: cdk.stringToCloudFormation(properties.name), ParameterTemplate: cdk.hashMapper(cfnWorkflowWorkflowParameterPropertyToCloudFormation)(properties.parameterTemplate), StorageCapacity: cdk.numberToCloudFormation(properties.storageCapacity), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnWorkflowPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("definitionUri", "DefinitionUri", properties.DefinitionUri != null ? cfn_parse.FromCloudFormation.getString(properties.DefinitionUri) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("engine", "Engine", properties.Engine != null ? cfn_parse.FromCloudFormation.getString(properties.Engine) : void 0), ret.addPropertyResult("main", "Main", properties.Main != null ? cfn_parse.FromCloudFormation.getString(properties.Main) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("parameterTemplate", "ParameterTemplate", properties.ParameterTemplate != null ? cfn_parse.FromCloudFormation.getMap(CfnWorkflowWorkflowParameterPropertyFromCloudFormation)(properties.ParameterTemplate) : void 0), ret.addPropertyResult("storageCapacity", "StorageCapacity", properties.StorageCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.StorageCapacity) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnWorkflow = class _CfnWorkflow extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnWorkflowPropsFromCloudFormation(resourceProperties), ret = new _CfnWorkflow(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnWorkflow.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_omics_CfnWorkflowProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnWorkflow), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.attrType = cdk.Token.asString(this.getAtt("Type", cdk.ResolutionTypeHint.STRING)), this.definitionUri = props.definitionUri, this.description = props.description, this.engine = props.engine, this.main = props.main, this.name = props.name, this.parameterTemplate = props.parameterTemplate, this.storageCapacity = props.storageCapacity, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Omics::Workflow", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnWorkflow.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { definitionUri: this.definitionUri, description: this.description, engine: this.engine, main: this.main, name: this.name, parameterTemplate: this.parameterTemplate, storageCapacity: this.storageCapacity, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnWorkflowPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnWorkflow[_f] = { fqn: "aws-cdk-lib.aws_omics.CfnWorkflow", version: "2.80.0" }, CfnWorkflow.CFN_RESOURCE_TYPE_NAME = "AWS::Omics::Workflow", exports2.CfnWorkflow = CfnWorkflow;
    function CfnWorkflow_WorkflowParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("optional", cdk.validateBoolean)(properties.optional)), errors.wrap('supplied properties not correct for "WorkflowParameterProperty"');
    }
    function cfnWorkflowWorkflowParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkflow_WorkflowParameterPropertyValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), Optional: cdk.booleanToCloudFormation(properties.optional) }) : properties;
    }
    function CfnWorkflowWorkflowParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("optional", "Optional", properties.Optional != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Optional) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-omics/lib/index.js
var require_lib200 = __commonJS({
  "node_modules/aws-cdk-lib/aws-omics/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_omics_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-omics/index.js
var require_aws_omics = __commonJS({
  "node_modules/aws-cdk-lib/aws-omics/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib200(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-opensearchserverless/lib/opensearchserverless.generated.js
var require_opensearchserverless_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-opensearchserverless/lib/opensearchserverless.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnVpcEndpoint = exports2.CfnSecurityPolicy = exports2.CfnSecurityConfig = exports2.CfnCollection = exports2.CfnAccessPolicy = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAccessPolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("policy", cdk.requiredValidator)(properties.policy)), errors.collect(cdk.propertyValidator("policy", cdk.validateString)(properties.policy)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnAccessPolicyProps"');
    }
    function cfnAccessPolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccessPolicyPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Policy: cdk.stringToCloudFormation(properties.policy), Type: cdk.stringToCloudFormation(properties.type), Description: cdk.stringToCloudFormation(properties.description) }) : properties;
    }
    function CfnAccessPolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("policy", "Policy", cfn_parse.FromCloudFormation.getString(properties.Policy)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAccessPolicy = class _CfnAccessPolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAccessPolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnAccessPolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAccessPolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_opensearchserverless_CfnAccessPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAccessPolicy), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "policy", this), cdk.requireProperty(props, "type", this), this.name = props.name, this.policy = props.policy, this.type = props.type, this.description = props.description;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAccessPolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, policy: this.policy, type: this.type, description: this.description };
      }
      renderProperties(props) {
        return cfnAccessPolicyPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAccessPolicy[_a] = { fqn: "aws-cdk-lib.aws_opensearchserverless.CfnAccessPolicy", version: "2.80.0" }, CfnAccessPolicy.CFN_RESOURCE_TYPE_NAME = "AWS::OpenSearchServerless::AccessPolicy", exports2.CfnAccessPolicy = CfnAccessPolicy;
    function CfnCollectionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnCollectionProps"');
    }
    function cfnCollectionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCollectionPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnCollectionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCollection = class _CfnCollection extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCollectionPropsFromCloudFormation(resourceProperties), ret = new _CfnCollection(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCollection.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_opensearchserverless_CfnCollectionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCollection), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCollectionEndpoint = cdk.Token.asString(this.getAtt("CollectionEndpoint", cdk.ResolutionTypeHint.STRING)), this.attrDashboardEndpoint = cdk.Token.asString(this.getAtt("DashboardEndpoint", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::OpenSearchServerless::Collection", props.tags, { tagPropertyName: "tags" }), this.type = props.type;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCollection.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, description: this.description, tags: this.tags.renderTags(), type: this.type };
      }
      renderProperties(props) {
        return cfnCollectionPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnCollection[_b] = { fqn: "aws-cdk-lib.aws_opensearchserverless.CfnCollection", version: "2.80.0" }, CfnCollection.CFN_RESOURCE_TYPE_NAME = "AWS::OpenSearchServerless::Collection", exports2.CfnCollection = CfnCollection;
    function CfnSecurityConfigPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("samlOptions", CfnSecurityConfig_SamlConfigOptionsPropertyValidator)(properties.samlOptions)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnSecurityConfigProps"');
    }
    function cfnSecurityConfigPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSecurityConfigPropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), Name: cdk.stringToCloudFormation(properties.name), SamlOptions: cfnSecurityConfigSamlConfigOptionsPropertyToCloudFormation(properties.samlOptions), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnSecurityConfigPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("samlOptions", "SamlOptions", properties.SamlOptions != null ? CfnSecurityConfigSamlConfigOptionsPropertyFromCloudFormation(properties.SamlOptions) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSecurityConfig = class _CfnSecurityConfig extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSecurityConfigPropsFromCloudFormation(resourceProperties), ret = new _CfnSecurityConfig(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnSecurityConfig.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_opensearchserverless_CfnSecurityConfigProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSecurityConfig), error;
        }
        this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.description = props.description, this.name = props.name, this.samlOptions = props.samlOptions, this.type = props.type;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSecurityConfig.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, name: this.name, samlOptions: this.samlOptions, type: this.type };
      }
      renderProperties(props) {
        return cfnSecurityConfigPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnSecurityConfig[_c] = { fqn: "aws-cdk-lib.aws_opensearchserverless.CfnSecurityConfig", version: "2.80.0" }, CfnSecurityConfig.CFN_RESOURCE_TYPE_NAME = "AWS::OpenSearchServerless::SecurityConfig", exports2.CfnSecurityConfig = CfnSecurityConfig;
    function CfnSecurityConfig_SamlConfigOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groupAttribute", cdk.validateString)(properties.groupAttribute)), errors.collect(cdk.propertyValidator("metadata", cdk.requiredValidator)(properties.metadata)), errors.collect(cdk.propertyValidator("metadata", cdk.validateString)(properties.metadata)), errors.collect(cdk.propertyValidator("sessionTimeout", cdk.validateNumber)(properties.sessionTimeout)), errors.collect(cdk.propertyValidator("userAttribute", cdk.validateString)(properties.userAttribute)), errors.wrap('supplied properties not correct for "SamlConfigOptionsProperty"');
    }
    function cfnSecurityConfigSamlConfigOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSecurityConfig_SamlConfigOptionsPropertyValidator(properties).assertSuccess(), { GroupAttribute: cdk.stringToCloudFormation(properties.groupAttribute), Metadata: cdk.stringToCloudFormation(properties.metadata), SessionTimeout: cdk.numberToCloudFormation(properties.sessionTimeout), UserAttribute: cdk.stringToCloudFormation(properties.userAttribute) }) : properties;
    }
    function CfnSecurityConfigSamlConfigOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupAttribute", "GroupAttribute", properties.GroupAttribute != null ? cfn_parse.FromCloudFormation.getString(properties.GroupAttribute) : void 0), ret.addPropertyResult("metadata", "Metadata", cfn_parse.FromCloudFormation.getString(properties.Metadata)), ret.addPropertyResult("sessionTimeout", "SessionTimeout", properties.SessionTimeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.SessionTimeout) : void 0), ret.addPropertyResult("userAttribute", "UserAttribute", properties.UserAttribute != null ? cfn_parse.FromCloudFormation.getString(properties.UserAttribute) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSecurityPolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("policy", cdk.requiredValidator)(properties.policy)), errors.collect(cdk.propertyValidator("policy", cdk.validateString)(properties.policy)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnSecurityPolicyProps"');
    }
    function cfnSecurityPolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSecurityPolicyPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Policy: cdk.stringToCloudFormation(properties.policy), Type: cdk.stringToCloudFormation(properties.type), Description: cdk.stringToCloudFormation(properties.description) }) : properties;
    }
    function CfnSecurityPolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("policy", "Policy", cfn_parse.FromCloudFormation.getString(properties.Policy)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSecurityPolicy = class _CfnSecurityPolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSecurityPolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnSecurityPolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSecurityPolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_opensearchserverless_CfnSecurityPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSecurityPolicy), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "policy", this), cdk.requireProperty(props, "type", this), this.name = props.name, this.policy = props.policy, this.type = props.type, this.description = props.description;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSecurityPolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, policy: this.policy, type: this.type, description: this.description };
      }
      renderProperties(props) {
        return cfnSecurityPolicyPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnSecurityPolicy[_d] = { fqn: "aws-cdk-lib.aws_opensearchserverless.CfnSecurityPolicy", version: "2.80.0" }, CfnSecurityPolicy.CFN_RESOURCE_TYPE_NAME = "AWS::OpenSearchServerless::SecurityPolicy", exports2.CfnSecurityPolicy = CfnSecurityPolicy;
    function CfnVpcEndpointPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.requiredValidator)(properties.subnetIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.collect(cdk.propertyValidator("vpcId", cdk.requiredValidator)(properties.vpcId)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "CfnVpcEndpointProps"');
    }
    function cfnVpcEndpointPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVpcEndpointPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds), VpcId: cdk.stringToCloudFormation(properties.vpcId), SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds) }) : properties;
    }
    function CfnVpcEndpointPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("subnetIds", "SubnetIds", cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds)), ret.addPropertyResult("vpcId", "VpcId", cfn_parse.FromCloudFormation.getString(properties.VpcId)), ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVpcEndpoint = class _CfnVpcEndpoint extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVpcEndpointPropsFromCloudFormation(resourceProperties), ret = new _CfnVpcEndpoint(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVpcEndpoint.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_opensearchserverless_CfnVpcEndpointProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVpcEndpoint), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "subnetIds", this), cdk.requireProperty(props, "vpcId", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.subnetIds = props.subnetIds, this.vpcId = props.vpcId, this.securityGroupIds = props.securityGroupIds;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVpcEndpoint.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, subnetIds: this.subnetIds, vpcId: this.vpcId, securityGroupIds: this.securityGroupIds };
      }
      renderProperties(props) {
        return cfnVpcEndpointPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnVpcEndpoint[_e] = { fqn: "aws-cdk-lib.aws_opensearchserverless.CfnVpcEndpoint", version: "2.80.0" }, CfnVpcEndpoint.CFN_RESOURCE_TYPE_NAME = "AWS::OpenSearchServerless::VpcEndpoint", exports2.CfnVpcEndpoint = CfnVpcEndpoint;
  }
});

// node_modules/aws-cdk-lib/aws-opensearchserverless/lib/index.js
var require_lib201 = __commonJS({
  "node_modules/aws-cdk-lib/aws-opensearchserverless/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_opensearchserverless_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-opensearchserverless/index.js
var require_aws_opensearchserverless = __commonJS({
  "node_modules/aws-cdk-lib/aws-opensearchserverless/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib201(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-opensearchservice/lib/log-group-resource-policy.js
var require_log_group_resource_policy3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-opensearchservice/lib/log-group-resource-policy.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LogGroupResourcePolicy = void 0;
    var iam = require_aws_iam();
    var cr = require_custom_resources();
    var LogGroupResourcePolicy = class extends cr.AwsCustomResource {
      constructor(scope, id, props) {
        const policyDocument = new iam.PolicyDocument({ statements: props.policyStatements });
        super(scope, id, { resourceType: "Custom::CloudwatchLogResourcePolicy", onUpdate: { service: "CloudWatchLogs", action: "putResourcePolicy", parameters: { policyName: props.policyName, policyDocument: JSON.stringify(policyDocument) }, physicalResourceId: cr.PhysicalResourceId.of(id) }, onDelete: { service: "CloudWatchLogs", action: "deleteResourcePolicy", parameters: { policyName: props.policyName }, ignoreErrorCodesMatching: "ResourceNotFoundException" }, policy: cr.AwsCustomResourcePolicy.fromSdkCalls({ resources: ["*"] }) });
      }
    };
    exports2.LogGroupResourcePolicy = LogGroupResourcePolicy;
  }
});

// node_modules/aws-cdk-lib/aws-opensearchservice/lib/opensearch-access-policy.js
var require_opensearch_access_policy = __commonJS({
  "node_modules/aws-cdk-lib/aws-opensearchservice/lib/opensearch-access-policy.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.OpenSearchAccessPolicy = void 0;
    var iam = require_aws_iam();
    var cdk = require_core2();
    var cr = require_custom_resources();
    var OpenSearchAccessPolicy = class extends cr.AwsCustomResource {
      constructor(scope, id, props) {
        super(scope, id, { resourceType: "Custom::OpenSearchAccessPolicy", onUpdate: { action: "updateDomainConfig", service: "OpenSearch", parameters: { DomainName: props.domainName, AccessPolicies: cdk.Lazy.string({ produce: () => JSON.stringify(new iam.PolicyDocument({ statements: this.accessPolicyStatements }).toJSON()) }) }, outputPaths: ["DomainConfig.AccessPolicies"], physicalResourceId: cr.PhysicalResourceId.of(`${props.domainName}AccessPolicy`) }, policy: cr.AwsCustomResourcePolicy.fromStatements([new iam.PolicyStatement({ actions: ["es:UpdateDomainConfig"], resources: [props.domainArn] })]) }), this.accessPolicyStatements = [], this.addAccessPolicies(...props.accessPolicies);
      }
      addAccessPolicies(...accessPolicyStatements) {
        this.accessPolicyStatements.push(...accessPolicyStatements);
      }
    };
    exports2.OpenSearchAccessPolicy = OpenSearchAccessPolicy;
  }
});

// node_modules/aws-cdk-lib/aws-opensearchservice/lib/opensearchservice.generated.js
var require_opensearchservice_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-opensearchservice/lib/opensearchservice.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnDomain = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnDomainPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessPolicies", cdk.validateObject)(properties.accessPolicies)), errors.collect(cdk.propertyValidator("advancedOptions", cdk.hashValidator(cdk.validateString))(properties.advancedOptions)), errors.collect(cdk.propertyValidator("advancedSecurityOptions", CfnDomain_AdvancedSecurityOptionsInputPropertyValidator)(properties.advancedSecurityOptions)), errors.collect(cdk.propertyValidator("clusterConfig", CfnDomain_ClusterConfigPropertyValidator)(properties.clusterConfig)), errors.collect(cdk.propertyValidator("cognitoOptions", CfnDomain_CognitoOptionsPropertyValidator)(properties.cognitoOptions)), errors.collect(cdk.propertyValidator("domainEndpointOptions", CfnDomain_DomainEndpointOptionsPropertyValidator)(properties.domainEndpointOptions)), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.collect(cdk.propertyValidator("ebsOptions", CfnDomain_EBSOptionsPropertyValidator)(properties.ebsOptions)), errors.collect(cdk.propertyValidator("encryptionAtRestOptions", CfnDomain_EncryptionAtRestOptionsPropertyValidator)(properties.encryptionAtRestOptions)), errors.collect(cdk.propertyValidator("engineVersion", cdk.validateString)(properties.engineVersion)), errors.collect(cdk.propertyValidator("logPublishingOptions", cdk.hashValidator(CfnDomain_LogPublishingOptionPropertyValidator))(properties.logPublishingOptions)), errors.collect(cdk.propertyValidator("nodeToNodeEncryptionOptions", CfnDomain_NodeToNodeEncryptionOptionsPropertyValidator)(properties.nodeToNodeEncryptionOptions)), errors.collect(cdk.propertyValidator("offPeakWindowOptions", CfnDomain_OffPeakWindowOptionsPropertyValidator)(properties.offPeakWindowOptions)), errors.collect(cdk.propertyValidator("snapshotOptions", CfnDomain_SnapshotOptionsPropertyValidator)(properties.snapshotOptions)), errors.collect(cdk.propertyValidator("softwareUpdateOptions", CfnDomain_SoftwareUpdateOptionsPropertyValidator)(properties.softwareUpdateOptions)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpcOptions", CfnDomain_VPCOptionsPropertyValidator)(properties.vpcOptions)), errors.wrap('supplied properties not correct for "CfnDomainProps"');
    }
    function cfnDomainPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomainPropsValidator(properties).assertSuccess(), { AccessPolicies: cdk.objectToCloudFormation(properties.accessPolicies), AdvancedOptions: cdk.hashMapper(cdk.stringToCloudFormation)(properties.advancedOptions), AdvancedSecurityOptions: cfnDomainAdvancedSecurityOptionsInputPropertyToCloudFormation(properties.advancedSecurityOptions), ClusterConfig: cfnDomainClusterConfigPropertyToCloudFormation(properties.clusterConfig), CognitoOptions: cfnDomainCognitoOptionsPropertyToCloudFormation(properties.cognitoOptions), DomainEndpointOptions: cfnDomainDomainEndpointOptionsPropertyToCloudFormation(properties.domainEndpointOptions), DomainName: cdk.stringToCloudFormation(properties.domainName), EBSOptions: cfnDomainEBSOptionsPropertyToCloudFormation(properties.ebsOptions), EncryptionAtRestOptions: cfnDomainEncryptionAtRestOptionsPropertyToCloudFormation(properties.encryptionAtRestOptions), EngineVersion: cdk.stringToCloudFormation(properties.engineVersion), LogPublishingOptions: cdk.hashMapper(cfnDomainLogPublishingOptionPropertyToCloudFormation)(properties.logPublishingOptions), NodeToNodeEncryptionOptions: cfnDomainNodeToNodeEncryptionOptionsPropertyToCloudFormation(properties.nodeToNodeEncryptionOptions), OffPeakWindowOptions: cfnDomainOffPeakWindowOptionsPropertyToCloudFormation(properties.offPeakWindowOptions), SnapshotOptions: cfnDomainSnapshotOptionsPropertyToCloudFormation(properties.snapshotOptions), SoftwareUpdateOptions: cfnDomainSoftwareUpdateOptionsPropertyToCloudFormation(properties.softwareUpdateOptions), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VPCOptions: cfnDomainVPCOptionsPropertyToCloudFormation(properties.vpcOptions) }) : properties;
    }
    function CfnDomainPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessPolicies", "AccessPolicies", properties.AccessPolicies != null ? cfn_parse.FromCloudFormation.getAny(properties.AccessPolicies) : void 0), ret.addPropertyResult("advancedOptions", "AdvancedOptions", properties.AdvancedOptions != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.AdvancedOptions) : void 0), ret.addPropertyResult("advancedSecurityOptions", "AdvancedSecurityOptions", properties.AdvancedSecurityOptions != null ? CfnDomainAdvancedSecurityOptionsInputPropertyFromCloudFormation(properties.AdvancedSecurityOptions) : void 0), ret.addPropertyResult("clusterConfig", "ClusterConfig", properties.ClusterConfig != null ? CfnDomainClusterConfigPropertyFromCloudFormation(properties.ClusterConfig) : void 0), ret.addPropertyResult("cognitoOptions", "CognitoOptions", properties.CognitoOptions != null ? CfnDomainCognitoOptionsPropertyFromCloudFormation(properties.CognitoOptions) : void 0), ret.addPropertyResult("domainEndpointOptions", "DomainEndpointOptions", properties.DomainEndpointOptions != null ? CfnDomainDomainEndpointOptionsPropertyFromCloudFormation(properties.DomainEndpointOptions) : void 0), ret.addPropertyResult("domainName", "DomainName", properties.DomainName != null ? cfn_parse.FromCloudFormation.getString(properties.DomainName) : void 0), ret.addPropertyResult("ebsOptions", "EBSOptions", properties.EBSOptions != null ? CfnDomainEBSOptionsPropertyFromCloudFormation(properties.EBSOptions) : void 0), ret.addPropertyResult("encryptionAtRestOptions", "EncryptionAtRestOptions", properties.EncryptionAtRestOptions != null ? CfnDomainEncryptionAtRestOptionsPropertyFromCloudFormation(properties.EncryptionAtRestOptions) : void 0), ret.addPropertyResult("engineVersion", "EngineVersion", properties.EngineVersion != null ? cfn_parse.FromCloudFormation.getString(properties.EngineVersion) : void 0), ret.addPropertyResult("logPublishingOptions", "LogPublishingOptions", properties.LogPublishingOptions != null ? cfn_parse.FromCloudFormation.getMap(CfnDomainLogPublishingOptionPropertyFromCloudFormation)(properties.LogPublishingOptions) : void 0), ret.addPropertyResult("nodeToNodeEncryptionOptions", "NodeToNodeEncryptionOptions", properties.NodeToNodeEncryptionOptions != null ? CfnDomainNodeToNodeEncryptionOptionsPropertyFromCloudFormation(properties.NodeToNodeEncryptionOptions) : void 0), ret.addPropertyResult("offPeakWindowOptions", "OffPeakWindowOptions", properties.OffPeakWindowOptions != null ? CfnDomainOffPeakWindowOptionsPropertyFromCloudFormation(properties.OffPeakWindowOptions) : void 0), ret.addPropertyResult("snapshotOptions", "SnapshotOptions", properties.SnapshotOptions != null ? CfnDomainSnapshotOptionsPropertyFromCloudFormation(properties.SnapshotOptions) : void 0), ret.addPropertyResult("softwareUpdateOptions", "SoftwareUpdateOptions", properties.SoftwareUpdateOptions != null ? CfnDomainSoftwareUpdateOptionsPropertyFromCloudFormation(properties.SoftwareUpdateOptions) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("vpcOptions", "VPCOptions", properties.VPCOptions != null ? CfnDomainVPCOptionsPropertyFromCloudFormation(properties.VPCOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDomain = class _CfnDomain extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDomainPropsFromCloudFormation(resourceProperties), ret = new _CfnDomain(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnDomain.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_opensearchservice_CfnDomainProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDomain), error;
        }
        this.attrAdvancedSecurityOptionsAnonymousAuthDisableDate = cdk.Token.asString(this.getAtt("AdvancedSecurityOptions.AnonymousAuthDisableDate", cdk.ResolutionTypeHint.STRING)), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrDomainEndpoint = cdk.Token.asString(this.getAtt("DomainEndpoint", cdk.ResolutionTypeHint.STRING)), this.attrDomainEndpoints = this.getAtt("DomainEndpoints", cdk.ResolutionTypeHint.STRING), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrServiceSoftwareOptionsAutomatedUpdateDate = cdk.Token.asString(this.getAtt("ServiceSoftwareOptions.AutomatedUpdateDate", cdk.ResolutionTypeHint.STRING)), this.attrServiceSoftwareOptionsCancellable = this.getAtt("ServiceSoftwareOptions.Cancellable", cdk.ResolutionTypeHint.STRING), this.attrServiceSoftwareOptionsCurrentVersion = cdk.Token.asString(this.getAtt("ServiceSoftwareOptions.CurrentVersion", cdk.ResolutionTypeHint.STRING)), this.attrServiceSoftwareOptionsDescription = cdk.Token.asString(this.getAtt("ServiceSoftwareOptions.Description", cdk.ResolutionTypeHint.STRING)), this.attrServiceSoftwareOptionsNewVersion = cdk.Token.asString(this.getAtt("ServiceSoftwareOptions.NewVersion", cdk.ResolutionTypeHint.STRING)), this.attrServiceSoftwareOptionsOptionalDeployment = this.getAtt("ServiceSoftwareOptions.OptionalDeployment", cdk.ResolutionTypeHint.STRING), this.attrServiceSoftwareOptionsUpdateAvailable = this.getAtt("ServiceSoftwareOptions.UpdateAvailable", cdk.ResolutionTypeHint.STRING), this.attrServiceSoftwareOptionsUpdateStatus = cdk.Token.asString(this.getAtt("ServiceSoftwareOptions.UpdateStatus", cdk.ResolutionTypeHint.STRING)), this.accessPolicies = props.accessPolicies, this.advancedOptions = props.advancedOptions, this.advancedSecurityOptions = props.advancedSecurityOptions, this.clusterConfig = props.clusterConfig, this.cognitoOptions = props.cognitoOptions, this.domainEndpointOptions = props.domainEndpointOptions, this.domainName = props.domainName, this.ebsOptions = props.ebsOptions, this.encryptionAtRestOptions = props.encryptionAtRestOptions, this.engineVersion = props.engineVersion, this.logPublishingOptions = props.logPublishingOptions, this.nodeToNodeEncryptionOptions = props.nodeToNodeEncryptionOptions, this.offPeakWindowOptions = props.offPeakWindowOptions, this.snapshotOptions = props.snapshotOptions, this.softwareUpdateOptions = props.softwareUpdateOptions, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::OpenSearchService::Domain", props.tags, { tagPropertyName: "tags" }), this.vpcOptions = props.vpcOptions, this.node.scope && cdk.Resource.isResource(this.node.scope) && this.node.addValidation({ validate: () => this.cfnOptions.deletionPolicy === void 0 ? ["'AWS::OpenSearchService::Domain' is a stateful resource type, and you must specify a Removal Policy for it. Call 'resource.applyRemovalPolicy()'."] : [] });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDomain.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { accessPolicies: this.accessPolicies, advancedOptions: this.advancedOptions, advancedSecurityOptions: this.advancedSecurityOptions, clusterConfig: this.clusterConfig, cognitoOptions: this.cognitoOptions, domainEndpointOptions: this.domainEndpointOptions, domainName: this.domainName, ebsOptions: this.ebsOptions, encryptionAtRestOptions: this.encryptionAtRestOptions, engineVersion: this.engineVersion, logPublishingOptions: this.logPublishingOptions, nodeToNodeEncryptionOptions: this.nodeToNodeEncryptionOptions, offPeakWindowOptions: this.offPeakWindowOptions, snapshotOptions: this.snapshotOptions, softwareUpdateOptions: this.softwareUpdateOptions, tags: this.tags.renderTags(), vpcOptions: this.vpcOptions };
      }
      renderProperties(props) {
        return cfnDomainPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnDomain[_a] = { fqn: "aws-cdk-lib.aws_opensearchservice.CfnDomain", version: "2.80.0" }, CfnDomain.CFN_RESOURCE_TYPE_NAME = "AWS::OpenSearchService::Domain", exports2.CfnDomain = CfnDomain;
    function CfnDomain_AdvancedSecurityOptionsInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("anonymousAuthDisableDate", cdk.validateString)(properties.anonymousAuthDisableDate)), errors.collect(cdk.propertyValidator("anonymousAuthEnabled", cdk.validateBoolean)(properties.anonymousAuthEnabled)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("internalUserDatabaseEnabled", cdk.validateBoolean)(properties.internalUserDatabaseEnabled)), errors.collect(cdk.propertyValidator("masterUserOptions", CfnDomain_MasterUserOptionsPropertyValidator)(properties.masterUserOptions)), errors.collect(cdk.propertyValidator("samlOptions", CfnDomain_SAMLOptionsPropertyValidator)(properties.samlOptions)), errors.wrap('supplied properties not correct for "AdvancedSecurityOptionsInputProperty"');
    }
    function cfnDomainAdvancedSecurityOptionsInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_AdvancedSecurityOptionsInputPropertyValidator(properties).assertSuccess(), { AnonymousAuthDisableDate: cdk.stringToCloudFormation(properties.anonymousAuthDisableDate), AnonymousAuthEnabled: cdk.booleanToCloudFormation(properties.anonymousAuthEnabled), Enabled: cdk.booleanToCloudFormation(properties.enabled), InternalUserDatabaseEnabled: cdk.booleanToCloudFormation(properties.internalUserDatabaseEnabled), MasterUserOptions: cfnDomainMasterUserOptionsPropertyToCloudFormation(properties.masterUserOptions), SAMLOptions: cfnDomainSAMLOptionsPropertyToCloudFormation(properties.samlOptions) }) : properties;
    }
    function CfnDomainAdvancedSecurityOptionsInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("anonymousAuthDisableDate", "AnonymousAuthDisableDate", properties.AnonymousAuthDisableDate != null ? cfn_parse.FromCloudFormation.getString(properties.AnonymousAuthDisableDate) : void 0), ret.addPropertyResult("anonymousAuthEnabled", "AnonymousAuthEnabled", properties.AnonymousAuthEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AnonymousAuthEnabled) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("internalUserDatabaseEnabled", "InternalUserDatabaseEnabled", properties.InternalUserDatabaseEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.InternalUserDatabaseEnabled) : void 0), ret.addPropertyResult("masterUserOptions", "MasterUserOptions", properties.MasterUserOptions != null ? CfnDomainMasterUserOptionsPropertyFromCloudFormation(properties.MasterUserOptions) : void 0), ret.addPropertyResult("samlOptions", "SAMLOptions", properties.SAMLOptions != null ? CfnDomainSAMLOptionsPropertyFromCloudFormation(properties.SAMLOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_ClusterConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dedicatedMasterCount", cdk.validateNumber)(properties.dedicatedMasterCount)), errors.collect(cdk.propertyValidator("dedicatedMasterEnabled", cdk.validateBoolean)(properties.dedicatedMasterEnabled)), errors.collect(cdk.propertyValidator("dedicatedMasterType", cdk.validateString)(properties.dedicatedMasterType)), errors.collect(cdk.propertyValidator("instanceCount", cdk.validateNumber)(properties.instanceCount)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("warmCount", cdk.validateNumber)(properties.warmCount)), errors.collect(cdk.propertyValidator("warmEnabled", cdk.validateBoolean)(properties.warmEnabled)), errors.collect(cdk.propertyValidator("warmType", cdk.validateString)(properties.warmType)), errors.collect(cdk.propertyValidator("zoneAwarenessConfig", CfnDomain_ZoneAwarenessConfigPropertyValidator)(properties.zoneAwarenessConfig)), errors.collect(cdk.propertyValidator("zoneAwarenessEnabled", cdk.validateBoolean)(properties.zoneAwarenessEnabled)), errors.wrap('supplied properties not correct for "ClusterConfigProperty"');
    }
    function cfnDomainClusterConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_ClusterConfigPropertyValidator(properties).assertSuccess(), { DedicatedMasterCount: cdk.numberToCloudFormation(properties.dedicatedMasterCount), DedicatedMasterEnabled: cdk.booleanToCloudFormation(properties.dedicatedMasterEnabled), DedicatedMasterType: cdk.stringToCloudFormation(properties.dedicatedMasterType), InstanceCount: cdk.numberToCloudFormation(properties.instanceCount), InstanceType: cdk.stringToCloudFormation(properties.instanceType), WarmCount: cdk.numberToCloudFormation(properties.warmCount), WarmEnabled: cdk.booleanToCloudFormation(properties.warmEnabled), WarmType: cdk.stringToCloudFormation(properties.warmType), ZoneAwarenessConfig: cfnDomainZoneAwarenessConfigPropertyToCloudFormation(properties.zoneAwarenessConfig), ZoneAwarenessEnabled: cdk.booleanToCloudFormation(properties.zoneAwarenessEnabled) }) : properties;
    }
    function CfnDomainClusterConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dedicatedMasterCount", "DedicatedMasterCount", properties.DedicatedMasterCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.DedicatedMasterCount) : void 0), ret.addPropertyResult("dedicatedMasterEnabled", "DedicatedMasterEnabled", properties.DedicatedMasterEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DedicatedMasterEnabled) : void 0), ret.addPropertyResult("dedicatedMasterType", "DedicatedMasterType", properties.DedicatedMasterType != null ? cfn_parse.FromCloudFormation.getString(properties.DedicatedMasterType) : void 0), ret.addPropertyResult("instanceCount", "InstanceCount", properties.InstanceCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.InstanceCount) : void 0), ret.addPropertyResult("instanceType", "InstanceType", properties.InstanceType != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceType) : void 0), ret.addPropertyResult("warmCount", "WarmCount", properties.WarmCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.WarmCount) : void 0), ret.addPropertyResult("warmEnabled", "WarmEnabled", properties.WarmEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.WarmEnabled) : void 0), ret.addPropertyResult("warmType", "WarmType", properties.WarmType != null ? cfn_parse.FromCloudFormation.getString(properties.WarmType) : void 0), ret.addPropertyResult("zoneAwarenessConfig", "ZoneAwarenessConfig", properties.ZoneAwarenessConfig != null ? CfnDomainZoneAwarenessConfigPropertyFromCloudFormation(properties.ZoneAwarenessConfig) : void 0), ret.addPropertyResult("zoneAwarenessEnabled", "ZoneAwarenessEnabled", properties.ZoneAwarenessEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ZoneAwarenessEnabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_CognitoOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("identityPoolId", cdk.validateString)(properties.identityPoolId)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("userPoolId", cdk.validateString)(properties.userPoolId)), errors.wrap('supplied properties not correct for "CognitoOptionsProperty"');
    }
    function cfnDomainCognitoOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_CognitoOptionsPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled), IdentityPoolId: cdk.stringToCloudFormation(properties.identityPoolId), RoleArn: cdk.stringToCloudFormation(properties.roleArn), UserPoolId: cdk.stringToCloudFormation(properties.userPoolId) }) : properties;
    }
    function CfnDomainCognitoOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("identityPoolId", "IdentityPoolId", properties.IdentityPoolId != null ? cfn_parse.FromCloudFormation.getString(properties.IdentityPoolId) : void 0), ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addPropertyResult("userPoolId", "UserPoolId", properties.UserPoolId != null ? cfn_parse.FromCloudFormation.getString(properties.UserPoolId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_DomainEndpointOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customEndpoint", cdk.validateString)(properties.customEndpoint)), errors.collect(cdk.propertyValidator("customEndpointCertificateArn", cdk.validateString)(properties.customEndpointCertificateArn)), errors.collect(cdk.propertyValidator("customEndpointEnabled", cdk.validateBoolean)(properties.customEndpointEnabled)), errors.collect(cdk.propertyValidator("enforceHttps", cdk.validateBoolean)(properties.enforceHttps)), errors.collect(cdk.propertyValidator("tlsSecurityPolicy", cdk.validateString)(properties.tlsSecurityPolicy)), errors.wrap('supplied properties not correct for "DomainEndpointOptionsProperty"');
    }
    function cfnDomainDomainEndpointOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_DomainEndpointOptionsPropertyValidator(properties).assertSuccess(), { CustomEndpoint: cdk.stringToCloudFormation(properties.customEndpoint), CustomEndpointCertificateArn: cdk.stringToCloudFormation(properties.customEndpointCertificateArn), CustomEndpointEnabled: cdk.booleanToCloudFormation(properties.customEndpointEnabled), EnforceHTTPS: cdk.booleanToCloudFormation(properties.enforceHttps), TLSSecurityPolicy: cdk.stringToCloudFormation(properties.tlsSecurityPolicy) }) : properties;
    }
    function CfnDomainDomainEndpointOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customEndpoint", "CustomEndpoint", properties.CustomEndpoint != null ? cfn_parse.FromCloudFormation.getString(properties.CustomEndpoint) : void 0), ret.addPropertyResult("customEndpointCertificateArn", "CustomEndpointCertificateArn", properties.CustomEndpointCertificateArn != null ? cfn_parse.FromCloudFormation.getString(properties.CustomEndpointCertificateArn) : void 0), ret.addPropertyResult("customEndpointEnabled", "CustomEndpointEnabled", properties.CustomEndpointEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CustomEndpointEnabled) : void 0), ret.addPropertyResult("enforceHttps", "EnforceHTTPS", properties.EnforceHTTPS != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnforceHTTPS) : void 0), ret.addPropertyResult("tlsSecurityPolicy", "TLSSecurityPolicy", properties.TLSSecurityPolicy != null ? cfn_parse.FromCloudFormation.getString(properties.TLSSecurityPolicy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_EBSOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ebsEnabled", cdk.validateBoolean)(properties.ebsEnabled)), errors.collect(cdk.propertyValidator("iops", cdk.validateNumber)(properties.iops)), errors.collect(cdk.propertyValidator("throughput", cdk.validateNumber)(properties.throughput)), errors.collect(cdk.propertyValidator("volumeSize", cdk.validateNumber)(properties.volumeSize)), errors.collect(cdk.propertyValidator("volumeType", cdk.validateString)(properties.volumeType)), errors.wrap('supplied properties not correct for "EBSOptionsProperty"');
    }
    function cfnDomainEBSOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_EBSOptionsPropertyValidator(properties).assertSuccess(), { EBSEnabled: cdk.booleanToCloudFormation(properties.ebsEnabled), Iops: cdk.numberToCloudFormation(properties.iops), Throughput: cdk.numberToCloudFormation(properties.throughput), VolumeSize: cdk.numberToCloudFormation(properties.volumeSize), VolumeType: cdk.stringToCloudFormation(properties.volumeType) }) : properties;
    }
    function CfnDomainEBSOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ebsEnabled", "EBSEnabled", properties.EBSEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EBSEnabled) : void 0), ret.addPropertyResult("iops", "Iops", properties.Iops != null ? cfn_parse.FromCloudFormation.getNumber(properties.Iops) : void 0), ret.addPropertyResult("throughput", "Throughput", properties.Throughput != null ? cfn_parse.FromCloudFormation.getNumber(properties.Throughput) : void 0), ret.addPropertyResult("volumeSize", "VolumeSize", properties.VolumeSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.VolumeSize) : void 0), ret.addPropertyResult("volumeType", "VolumeType", properties.VolumeType != null ? cfn_parse.FromCloudFormation.getString(properties.VolumeType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_EncryptionAtRestOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.wrap('supplied properties not correct for "EncryptionAtRestOptionsProperty"');
    }
    function cfnDomainEncryptionAtRestOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_EncryptionAtRestOptionsPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId) }) : properties;
    }
    function CfnDomainEncryptionAtRestOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_IdpPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("entityId", cdk.requiredValidator)(properties.entityId)), errors.collect(cdk.propertyValidator("entityId", cdk.validateString)(properties.entityId)), errors.collect(cdk.propertyValidator("metadataContent", cdk.requiredValidator)(properties.metadataContent)), errors.collect(cdk.propertyValidator("metadataContent", cdk.validateString)(properties.metadataContent)), errors.wrap('supplied properties not correct for "IdpProperty"');
    }
    function cfnDomainIdpPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_IdpPropertyValidator(properties).assertSuccess(), { EntityId: cdk.stringToCloudFormation(properties.entityId), MetadataContent: cdk.stringToCloudFormation(properties.metadataContent) }) : properties;
    }
    function CfnDomainIdpPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("entityId", "EntityId", cfn_parse.FromCloudFormation.getString(properties.EntityId)), ret.addPropertyResult("metadataContent", "MetadataContent", cfn_parse.FromCloudFormation.getString(properties.MetadataContent)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_LogPublishingOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchLogsLogGroupArn", cdk.validateString)(properties.cloudWatchLogsLogGroupArn)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "LogPublishingOptionProperty"');
    }
    function cfnDomainLogPublishingOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_LogPublishingOptionPropertyValidator(properties).assertSuccess(), { CloudWatchLogsLogGroupArn: cdk.stringToCloudFormation(properties.cloudWatchLogsLogGroupArn), Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnDomainLogPublishingOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchLogsLogGroupArn", "CloudWatchLogsLogGroupArn", properties.CloudWatchLogsLogGroupArn != null ? cfn_parse.FromCloudFormation.getString(properties.CloudWatchLogsLogGroupArn) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_MasterUserOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("masterUserArn", cdk.validateString)(properties.masterUserArn)), errors.collect(cdk.propertyValidator("masterUserName", cdk.validateString)(properties.masterUserName)), errors.collect(cdk.propertyValidator("masterUserPassword", cdk.validateString)(properties.masterUserPassword)), errors.wrap('supplied properties not correct for "MasterUserOptionsProperty"');
    }
    function cfnDomainMasterUserOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_MasterUserOptionsPropertyValidator(properties).assertSuccess(), { MasterUserARN: cdk.stringToCloudFormation(properties.masterUserArn), MasterUserName: cdk.stringToCloudFormation(properties.masterUserName), MasterUserPassword: cdk.stringToCloudFormation(properties.masterUserPassword) }) : properties;
    }
    function CfnDomainMasterUserOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("masterUserArn", "MasterUserARN", properties.MasterUserARN != null ? cfn_parse.FromCloudFormation.getString(properties.MasterUserARN) : void 0), ret.addPropertyResult("masterUserName", "MasterUserName", properties.MasterUserName != null ? cfn_parse.FromCloudFormation.getString(properties.MasterUserName) : void 0), ret.addPropertyResult("masterUserPassword", "MasterUserPassword", properties.MasterUserPassword != null ? cfn_parse.FromCloudFormation.getString(properties.MasterUserPassword) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_NodeToNodeEncryptionOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "NodeToNodeEncryptionOptionsProperty"');
    }
    function cfnDomainNodeToNodeEncryptionOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_NodeToNodeEncryptionOptionsPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnDomainNodeToNodeEncryptionOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_OffPeakWindowPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("windowStartTime", CfnDomain_WindowStartTimePropertyValidator)(properties.windowStartTime)), errors.wrap('supplied properties not correct for "OffPeakWindowProperty"');
    }
    function cfnDomainOffPeakWindowPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_OffPeakWindowPropertyValidator(properties).assertSuccess(), { WindowStartTime: cfnDomainWindowStartTimePropertyToCloudFormation(properties.windowStartTime) }) : properties;
    }
    function CfnDomainOffPeakWindowPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("windowStartTime", "WindowStartTime", properties.WindowStartTime != null ? CfnDomainWindowStartTimePropertyFromCloudFormation(properties.WindowStartTime) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_OffPeakWindowOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("offPeakWindow", CfnDomain_OffPeakWindowPropertyValidator)(properties.offPeakWindow)), errors.wrap('supplied properties not correct for "OffPeakWindowOptionsProperty"');
    }
    function cfnDomainOffPeakWindowOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_OffPeakWindowOptionsPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled), OffPeakWindow: cfnDomainOffPeakWindowPropertyToCloudFormation(properties.offPeakWindow) }) : properties;
    }
    function CfnDomainOffPeakWindowOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("offPeakWindow", "OffPeakWindow", properties.OffPeakWindow != null ? CfnDomainOffPeakWindowPropertyFromCloudFormation(properties.OffPeakWindow) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_SAMLOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("idp", CfnDomain_IdpPropertyValidator)(properties.idp)), errors.collect(cdk.propertyValidator("masterBackendRole", cdk.validateString)(properties.masterBackendRole)), errors.collect(cdk.propertyValidator("masterUserName", cdk.validateString)(properties.masterUserName)), errors.collect(cdk.propertyValidator("rolesKey", cdk.validateString)(properties.rolesKey)), errors.collect(cdk.propertyValidator("sessionTimeoutMinutes", cdk.validateNumber)(properties.sessionTimeoutMinutes)), errors.collect(cdk.propertyValidator("subjectKey", cdk.validateString)(properties.subjectKey)), errors.wrap('supplied properties not correct for "SAMLOptionsProperty"');
    }
    function cfnDomainSAMLOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_SAMLOptionsPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled), Idp: cfnDomainIdpPropertyToCloudFormation(properties.idp), MasterBackendRole: cdk.stringToCloudFormation(properties.masterBackendRole), MasterUserName: cdk.stringToCloudFormation(properties.masterUserName), RolesKey: cdk.stringToCloudFormation(properties.rolesKey), SessionTimeoutMinutes: cdk.numberToCloudFormation(properties.sessionTimeoutMinutes), SubjectKey: cdk.stringToCloudFormation(properties.subjectKey) }) : properties;
    }
    function CfnDomainSAMLOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("idp", "Idp", properties.Idp != null ? CfnDomainIdpPropertyFromCloudFormation(properties.Idp) : void 0), ret.addPropertyResult("masterBackendRole", "MasterBackendRole", properties.MasterBackendRole != null ? cfn_parse.FromCloudFormation.getString(properties.MasterBackendRole) : void 0), ret.addPropertyResult("masterUserName", "MasterUserName", properties.MasterUserName != null ? cfn_parse.FromCloudFormation.getString(properties.MasterUserName) : void 0), ret.addPropertyResult("rolesKey", "RolesKey", properties.RolesKey != null ? cfn_parse.FromCloudFormation.getString(properties.RolesKey) : void 0), ret.addPropertyResult("sessionTimeoutMinutes", "SessionTimeoutMinutes", properties.SessionTimeoutMinutes != null ? cfn_parse.FromCloudFormation.getNumber(properties.SessionTimeoutMinutes) : void 0), ret.addPropertyResult("subjectKey", "SubjectKey", properties.SubjectKey != null ? cfn_parse.FromCloudFormation.getString(properties.SubjectKey) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_SnapshotOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("automatedSnapshotStartHour", cdk.validateNumber)(properties.automatedSnapshotStartHour)), errors.wrap('supplied properties not correct for "SnapshotOptionsProperty"');
    }
    function cfnDomainSnapshotOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_SnapshotOptionsPropertyValidator(properties).assertSuccess(), { AutomatedSnapshotStartHour: cdk.numberToCloudFormation(properties.automatedSnapshotStartHour) }) : properties;
    }
    function CfnDomainSnapshotOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("automatedSnapshotStartHour", "AutomatedSnapshotStartHour", properties.AutomatedSnapshotStartHour != null ? cfn_parse.FromCloudFormation.getNumber(properties.AutomatedSnapshotStartHour) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_SoftwareUpdateOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoSoftwareUpdateEnabled", cdk.validateBoolean)(properties.autoSoftwareUpdateEnabled)), errors.wrap('supplied properties not correct for "SoftwareUpdateOptionsProperty"');
    }
    function cfnDomainSoftwareUpdateOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_SoftwareUpdateOptionsPropertyValidator(properties).assertSuccess(), { AutoSoftwareUpdateEnabled: cdk.booleanToCloudFormation(properties.autoSoftwareUpdateEnabled) }) : properties;
    }
    function CfnDomainSoftwareUpdateOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("autoSoftwareUpdateEnabled", "AutoSoftwareUpdateEnabled", properties.AutoSoftwareUpdateEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AutoSoftwareUpdateEnabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_VPCOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.wrap('supplied properties not correct for "VPCOptionsProperty"');
    }
    function cfnDomainVPCOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_VPCOptionsPropertyValidator(properties).assertSuccess(), { SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds) }) : properties;
    }
    function CfnDomainVPCOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("subnetIds", "SubnetIds", properties.SubnetIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_WindowStartTimePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("hours", cdk.requiredValidator)(properties.hours)), errors.collect(cdk.propertyValidator("hours", cdk.validateNumber)(properties.hours)), errors.collect(cdk.propertyValidator("minutes", cdk.requiredValidator)(properties.minutes)), errors.collect(cdk.propertyValidator("minutes", cdk.validateNumber)(properties.minutes)), errors.wrap('supplied properties not correct for "WindowStartTimeProperty"');
    }
    function cfnDomainWindowStartTimePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_WindowStartTimePropertyValidator(properties).assertSuccess(), { Hours: cdk.numberToCloudFormation(properties.hours), Minutes: cdk.numberToCloudFormation(properties.minutes) }) : properties;
    }
    function CfnDomainWindowStartTimePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("hours", "Hours", cfn_parse.FromCloudFormation.getNumber(properties.Hours)), ret.addPropertyResult("minutes", "Minutes", cfn_parse.FromCloudFormation.getNumber(properties.Minutes)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_ZoneAwarenessConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availabilityZoneCount", cdk.validateNumber)(properties.availabilityZoneCount)), errors.wrap('supplied properties not correct for "ZoneAwarenessConfigProperty"');
    }
    function cfnDomainZoneAwarenessConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_ZoneAwarenessConfigPropertyValidator(properties).assertSuccess(), { AvailabilityZoneCount: cdk.numberToCloudFormation(properties.availabilityZoneCount) }) : properties;
    }
    function CfnDomainZoneAwarenessConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("availabilityZoneCount", "AvailabilityZoneCount", properties.AvailabilityZoneCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.AvailabilityZoneCount) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-opensearchservice/lib/perms.js
var require_perms6 = __commonJS({
  "node_modules/aws-cdk-lib/aws-opensearchservice/lib/perms.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ES_READ_WRITE_ACTIONS = exports2.ES_WRITE_ACTIONS = exports2.ES_READ_ACTIONS = void 0, exports2.ES_READ_ACTIONS = ["es:ESHttpGet", "es:ESHttpHead"], exports2.ES_WRITE_ACTIONS = ["es:ESHttpDelete", "es:ESHttpPost", "es:ESHttpPut", "es:ESHttpPatch"], exports2.ES_READ_WRITE_ACTIONS = [...exports2.ES_READ_ACTIONS, ...exports2.ES_WRITE_ACTIONS];
  }
});

// node_modules/aws-cdk-lib/aws-opensearchservice/lib/domain.js
var require_domain2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-opensearchservice/lib/domain.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Domain = exports2.TLSSecurityPolicy = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var url_1 = require("url");
    var log_group_resource_policy_1 = require_log_group_resource_policy3();
    var opensearch_access_policy_1 = require_opensearch_access_policy();
    var opensearchservice_generated_1 = require_opensearchservice_generated();
    var perms = require_perms6();
    var acm = require_aws_certificatemanager();
    var aws_cloudwatch_1 = require_aws_cloudwatch();
    var ec2 = require_aws_ec2();
    var iam = require_aws_iam();
    var logs = require_aws_logs();
    var route53 = require_aws_route53();
    var secretsmanager = require_aws_secretsmanager();
    var cdk = require_core2();
    var TLSSecurityPolicy;
    (function(TLSSecurityPolicy2) {
      TLSSecurityPolicy2.TLS_1_0 = "Policy-Min-TLS-1-0-2019-07", TLSSecurityPolicy2.TLS_1_2 = "Policy-Min-TLS-1-2-2019-07";
    })(TLSSecurityPolicy = exports2.TLSSecurityPolicy || (exports2.TLSSecurityPolicy = {}));
    var DomainBase = class extends cdk.Resource {
      grantRead(identity) {
        return this.grant(identity, perms.ES_READ_ACTIONS, this.domainArn, `${this.domainArn}/*`);
      }
      grantWrite(identity) {
        return this.grant(identity, perms.ES_WRITE_ACTIONS, this.domainArn, `${this.domainArn}/*`);
      }
      grantReadWrite(identity) {
        return this.grant(identity, perms.ES_READ_WRITE_ACTIONS, this.domainArn, `${this.domainArn}/*`);
      }
      grantIndexRead(index, identity) {
        return this.grant(identity, perms.ES_READ_ACTIONS, `${this.domainArn}/${index}`, `${this.domainArn}/${index}/*`);
      }
      grantIndexWrite(index, identity) {
        return this.grant(identity, perms.ES_WRITE_ACTIONS, `${this.domainArn}/${index}`, `${this.domainArn}/${index}/*`);
      }
      grantIndexReadWrite(index, identity) {
        return this.grant(identity, perms.ES_READ_WRITE_ACTIONS, `${this.domainArn}/${index}`, `${this.domainArn}/${index}/*`);
      }
      grantPathRead(path, identity) {
        return this.grant(identity, perms.ES_READ_ACTIONS, `${this.domainArn}/${path}`);
      }
      grantPathWrite(path, identity) {
        return this.grant(identity, perms.ES_WRITE_ACTIONS, `${this.domainArn}/${path}`);
      }
      grantPathReadWrite(path, identity) {
        return this.grant(identity, perms.ES_READ_WRITE_ACTIONS, `${this.domainArn}/${path}`);
      }
      metric(metricName, props) {
        return new aws_cloudwatch_1.Metric({ namespace: "AWS/ES", metricName, dimensionsMap: { DomainName: this.domainName, ClientId: this.env.account }, ...props }).attachTo(this);
      }
      metricClusterStatusRed(props) {
        return this.metric("ClusterStatus.red", { statistic: aws_cloudwatch_1.Statistic.MAXIMUM, ...props });
      }
      metricClusterStatusYellow(props) {
        return this.metric("ClusterStatus.yellow", { statistic: aws_cloudwatch_1.Statistic.MAXIMUM, ...props });
      }
      metricFreeStorageSpace(props) {
        return this.metric("FreeStorageSpace", { statistic: aws_cloudwatch_1.Statistic.MINIMUM, ...props });
      }
      metricClusterIndexWritesBlocked(props) {
        return this.metric("ClusterIndexWritesBlocked", { statistic: aws_cloudwatch_1.Statistic.MAXIMUM, period: cdk.Duration.minutes(1), ...props });
      }
      metricNodes(props) {
        return this.metric("Nodes", { statistic: aws_cloudwatch_1.Statistic.MINIMUM, period: cdk.Duration.hours(1), ...props });
      }
      metricAutomatedSnapshotFailure(props) {
        return this.metric("AutomatedSnapshotFailure", { statistic: aws_cloudwatch_1.Statistic.MAXIMUM, ...props });
      }
      metricCPUUtilization(props) {
        return this.metric("CPUUtilization", { statistic: aws_cloudwatch_1.Statistic.MAXIMUM, ...props });
      }
      metricJVMMemoryPressure(props) {
        return this.metric("JVMMemoryPressure", { statistic: aws_cloudwatch_1.Statistic.MAXIMUM, ...props });
      }
      metricMasterCPUUtilization(props) {
        return this.metric("MasterCPUUtilization", { statistic: aws_cloudwatch_1.Statistic.MAXIMUM, ...props });
      }
      metricMasterJVMMemoryPressure(props) {
        return this.metric("MasterJVMMemoryPressure", { statistic: aws_cloudwatch_1.Statistic.MAXIMUM, ...props });
      }
      metricKMSKeyError(props) {
        return this.metric("KMSKeyError", { statistic: aws_cloudwatch_1.Statistic.MAXIMUM, ...props });
      }
      metricKMSKeyInaccessible(props) {
        return this.metric("KMSKeyInaccessible", { statistic: aws_cloudwatch_1.Statistic.MAXIMUM, ...props });
      }
      metricSearchableDocuments(props) {
        return this.metric("SearchableDocuments", { statistic: aws_cloudwatch_1.Statistic.MAXIMUM, ...props });
      }
      metricSearchLatency(props) {
        return this.metric("SearchLatency", { statistic: "p99", ...props });
      }
      metricIndexingLatency(props) {
        return this.metric("IndexingLatency", { statistic: "p99", ...props });
      }
      grant(grantee, domainActions, resourceArn, ...otherResourceArns) {
        const resourceArns = [resourceArn, ...otherResourceArns];
        return iam.Grant.addToPrincipal({ grantee, actions: domainActions, resourceArns, scope: this });
      }
    };
    var Domain = class _Domain extends DomainBase {
      static fromDomainEndpoint(scope, id, domainEndpoint) {
        const stack = cdk.Stack.of(scope), domainName = extractNameFromEndpoint(domainEndpoint), domainArn = stack.formatArn({ service: "es", resource: "domain", resourceName: domainName });
        return _Domain.fromDomainAttributes(scope, id, { domainArn, domainEndpoint });
      }
      static fromDomainAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_opensearchservice_DomainAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromDomainAttributes), error;
        }
        const { domainArn, domainEndpoint } = attrs, domainName = cdk.Stack.of(scope).splitArn(domainArn, cdk.ArnFormat.SLASH_RESOURCE_NAME).resourceName ?? extractNameFromEndpoint(domainEndpoint);
        return new class extends DomainBase {
          constructor() {
            super(scope, id), this.domainArn = domainArn, this.domainName = domainName, this.domainId = domainName, this.domainEndpoint = domainEndpoint.replace(/^https?:\/\//, "");
          }
        }();
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.domainName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_opensearchservice_DomainProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Domain), error;
        }
        const defaultInstanceType = "r5.large.search", warmDefaultInstanceType = "ultrawarm1.medium.search", dedicatedMasterType = initializeInstanceType(defaultInstanceType, props.capacity?.masterNodeInstanceType), dedicatedMasterCount = props.capacity?.masterNodes ?? 0, dedicatedMasterEnabled = cdk.Token.isUnresolved(dedicatedMasterCount) ? true : dedicatedMasterCount > 0, instanceType = initializeInstanceType(defaultInstanceType, props.capacity?.dataNodeInstanceType), instanceCount = props.capacity?.dataNodes ?? 1, warmType = initializeInstanceType(warmDefaultInstanceType, props.capacity?.warmInstanceType), warmCount = props.capacity?.warmNodes ?? 0, warmEnabled = cdk.Token.isUnresolved(warmCount) ? true : warmCount > 0, availabilityZoneCount = props.zoneAwareness?.availabilityZoneCount ?? 2;
        if (![2, 3].includes(availabilityZoneCount))
          throw new Error("Invalid zone awareness configuration; availabilityZoneCount must be 2 or 3");
        const zoneAwarenessEnabled = props.zoneAwareness?.enabled ?? props.zoneAwareness?.availabilityZoneCount != null;
        let securityGroups, subnets, skipZoneAwarenessCheck = false;
        if (props.vpc) {
          const subnetSelections = props.vpcSubnets ?? [{ subnetType: ec2.SubnetType.PRIVATE_WITH_EGRESS }];
          subnets = selectSubnets(props.vpc, subnetSelections), skipZoneAwarenessCheck = zoneAwarenessCheckShouldBeSkipped(props.vpc, subnetSelections), securityGroups = props.securityGroups ?? [new ec2.SecurityGroup(this, "SecurityGroup", { vpc: props.vpc, description: `Security group for domain ${this.node.id}` })], props.enforceHttps ? this._connections = new ec2.Connections({ securityGroups, defaultPort: ec2.Port.tcp(443) }) : this._connections = new ec2.Connections({ securityGroups });
        }
        if (subnets && zoneAwarenessEnabled && !skipZoneAwarenessCheck && new Set(subnets.map((subnet) => subnet.availabilityZone)).size < availabilityZoneCount)
          throw new Error("When providing vpc options you need to provide a subnet for each AZ you are using");
        if ([dedicatedMasterType, instanceType, warmType].some((t) => !cdk.Token.isUnresolved(t) && !t.endsWith(".search")))
          throw new Error('Master, data and UltraWarm node instance types must end with ".search".');
        if (!cdk.Token.isUnresolved(warmType) && !warmType.startsWith("ultrawarm"))
          throw new Error('UltraWarm node instance type must start with "ultrawarm".');
        const unsignedBasicAuthEnabled = props.useUnsignedBasicAuth ?? false;
        if (unsignedBasicAuthEnabled) {
          if (props.enforceHttps == false)
            throw new Error("You cannot disable HTTPS and use unsigned basic auth");
          if (props.nodeToNodeEncryption == false)
            throw new Error("You cannot disable node to node encryption and use unsigned basic auth");
          if (props.encryptionAtRest?.enabled == false)
            throw new Error("You cannot disable encryption at rest and use unsigned basic auth");
        }
        const unsignedAccessPolicy = new iam.PolicyStatement({ effect: iam.Effect.ALLOW, actions: ["es:ESHttp*"], principals: [new iam.AnyPrincipal()], resources: [cdk.Lazy.string({ produce: () => `${this.domainArn}/*` })] }), masterUserArn = props.fineGrainedAccessControl?.masterUserArn, masterUserNameProps = props.fineGrainedAccessControl?.masterUserName, masterUserName = unsignedBasicAuthEnabled ? masterUserArn == null ? masterUserNameProps ?? "admin" : void 0 : masterUserNameProps;
        if (masterUserArn != null && masterUserName != null)
          throw new Error("Invalid fine grained access control settings. Only provide one of master user ARN or master user name. Not both.");
        const advancedSecurityEnabled = (masterUserArn ?? masterUserName) != null, internalUserDatabaseEnabled = masterUserName != null, masterUserPasswordProp = props.fineGrainedAccessControl?.masterUserPassword, createMasterUserPassword = () => new secretsmanager.Secret(this, "MasterUser", { generateSecretString: { secretStringTemplate: JSON.stringify({ username: masterUserName }), generateStringKey: "password", excludeCharacters: "{}'\\*[]()`" } }).secretValueFromJson("password");
        this.masterUserPassword = internalUserDatabaseEnabled ? masterUserPasswordProp ?? createMasterUserPassword() : void 0;
        const encryptionAtRestEnabled = props.encryptionAtRest?.enabled ?? (props.encryptionAtRest?.kmsKey != null || unsignedBasicAuthEnabled), nodeToNodeEncryptionEnabled = props.nodeToNodeEncryption ?? unsignedBasicAuthEnabled, volumeSize = props.ebs?.volumeSize ?? 10, volumeType = props.ebs?.volumeType ?? ec2.EbsDeviceVolumeType.GENERAL_PURPOSE_SSD, ebsEnabled = props.ebs?.enabled ?? true, enforceHttps = props.enforceHttps ?? unsignedBasicAuthEnabled;
        function isInstanceType(t) {
          return dedicatedMasterType.startsWith(t) || instanceType.startsWith(t);
        }
        function isSomeInstanceType(...instanceTypes) {
          return instanceTypes.some(isInstanceType);
        }
        function isEveryDatanodeInstanceType(...instanceTypes) {
          return instanceTypes.some((t) => instanceType.startsWith(t));
        }
        const { versionNum, isElasticsearchVersion } = parseVersion(props.version);
        if (isElasticsearchVersion) {
          if (versionNum <= 7.7 && ![1.5, 2.3, 5.1, 5.3, 5.5, 5.6, 6, 6.2, 6.3, 6.4, 6.5, 6.7, 6.8, 7.1, 7.4, 7.7].includes(versionNum))
            throw new Error(`Unknown Elasticsearch version: ${versionNum}`);
          if (versionNum < 5.1) {
            if (props.logging?.appLogEnabled)
              throw new Error("Error logs publishing requires Elasticsearch version 5.1 or later or OpenSearch version 1.0 or later.");
            if (props.encryptionAtRest?.enabled)
              throw new Error("Encryption of data at rest requires Elasticsearch version 5.1 or later or OpenSearch version 1.0 or later.");
            if (props.cognitoDashboardsAuth != null)
              throw new Error("Cognito authentication for OpenSearch Dashboards requires Elasticsearch version 5.1 or later or OpenSearch version 1.0 or later.");
            if (isSomeInstanceType("c5", "i3", "m5", "r5"))
              throw new Error("C5, I3, M5, and R5 instance types require Elasticsearch version 5.1 or later or OpenSearch version 1.0 or later.");
          }
          if (versionNum < 6 && props.nodeToNodeEncryption)
            throw new Error("Node-to-node encryption requires Elasticsearch version 6.0 or later or OpenSearch version 1.0 or later.");
          if (versionNum < 6.7) {
            if (unsignedBasicAuthEnabled)
              throw new Error("Using unsigned basic auth requires Elasticsearch version 6.7 or later or OpenSearch version 1.0 or later.");
            if (advancedSecurityEnabled)
              throw new Error("Fine-grained access control requires Elasticsearch version 6.7 or later or OpenSearch version 1.0 or later.");
          }
          if (versionNum < 6.8 && warmEnabled)
            throw new Error("UltraWarm requires Elasticsearch version 6.8 or later or OpenSearch version 1.0 or later.");
        }
        if (isSomeInstanceType("i3", "r6gd") && ebsEnabled)
          throw new Error("I3 and R6GD instance types do not support EBS storage volumes.");
        if (isSomeInstanceType("m3", "r3", "t2") && encryptionAtRestEnabled)
          throw new Error("M3, R3, and T2 instance types do not support encryption of data at rest.");
        if (isInstanceType("t2.micro") && !(isElasticsearchVersion && versionNum <= 2.3))
          throw new Error("The t2.micro.search instance type supports only Elasticsearch versions 1.5 and 2.3.");
        if (isSomeInstanceType("t2", "t3") && warmEnabled)
          throw new Error("T2 and T3 instance types do not support UltraWarm storage.");
        if (!ebsEnabled && !isEveryDatanodeInstanceType("r3", "i3", "r6gd"))
          throw new Error("EBS volumes are required when using instance types other than r3, i3 or r6gd.");
        if (advancedSecurityEnabled) {
          if (!nodeToNodeEncryptionEnabled)
            throw new Error("Node-to-node encryption is required when fine-grained access control is enabled.");
          if (!encryptionAtRestEnabled)
            throw new Error("Encryption-at-rest is required when fine-grained access control is enabled.");
          if (!enforceHttps)
            throw new Error("Enforce HTTPS is required when fine-grained access control is enabled.");
        }
        if (props.logging?.auditLogEnabled && !advancedSecurityEnabled)
          throw new Error("Fine-grained access control is required when audit logs publishing is enabled.");
        if (warmEnabled && !dedicatedMasterEnabled)
          throw new Error("Dedicated master node is required when UltraWarm storage is enabled.");
        let cfnVpcOptions;
        securityGroups && subnets && (cfnVpcOptions = { securityGroupIds: securityGroups.map((sg) => sg.securityGroupId), subnetIds: subnets.map((subnet) => subnet.subnetId) });
        const logGroups = [];
        props.logging?.slowSearchLogEnabled && (this.slowSearchLogGroup = props.logging.slowSearchLogGroup ?? new logs.LogGroup(this, "SlowSearchLogs", { retention: logs.RetentionDays.ONE_MONTH }), logGroups.push(this.slowSearchLogGroup)), props.logging?.slowIndexLogEnabled && (this.slowIndexLogGroup = props.logging.slowIndexLogGroup ?? new logs.LogGroup(this, "SlowIndexLogs", { retention: logs.RetentionDays.ONE_MONTH }), logGroups.push(this.slowIndexLogGroup)), props.logging?.appLogEnabled && (this.appLogGroup = props.logging.appLogGroup ?? new logs.LogGroup(this, "AppLogs", { retention: logs.RetentionDays.ONE_MONTH }), logGroups.push(this.appLogGroup)), props.logging?.auditLogEnabled && (this.auditLogGroup = props.logging.auditLogGroup ?? new logs.LogGroup(this, "AuditLogs", { retention: logs.RetentionDays.ONE_MONTH }), logGroups.push(this.auditLogGroup));
        let logGroupResourcePolicy = null;
        if (logGroups.length > 0) {
          const logPolicyStatement = new iam.PolicyStatement({ effect: iam.Effect.ALLOW, actions: ["logs:PutLogEvents", "logs:CreateLogStream"], resources: logGroups.map((lg) => lg.logGroupArn), principals: [new iam.ServicePrincipal("es.amazonaws.com")] });
          logGroupResourcePolicy = new log_group_resource_policy_1.LogGroupResourcePolicy(this, `ESLogGroupPolicy${this.node.addr}`, { policyName: `ESLogPolicy${this.node.addr}`, policyStatements: [logPolicyStatement] });
        }
        const logPublishing = {};
        this.appLogGroup && (logPublishing.ES_APPLICATION_LOGS = { enabled: true, cloudWatchLogsLogGroupArn: this.appLogGroup.logGroupArn }), this.slowSearchLogGroup && (logPublishing.SEARCH_SLOW_LOGS = { enabled: true, cloudWatchLogsLogGroupArn: this.slowSearchLogGroup.logGroupArn }), this.slowIndexLogGroup && (logPublishing.INDEX_SLOW_LOGS = { enabled: true, cloudWatchLogsLogGroupArn: this.slowIndexLogGroup.logGroupArn }), this.auditLogGroup && (logPublishing.AUDIT_LOGS = { enabled: this.auditLogGroup != null, cloudWatchLogsLogGroupArn: this.auditLogGroup?.logGroupArn });
        let customEndpointCertificate;
        if (props.customEndpoint && (props.customEndpoint.certificate ? customEndpointCertificate = props.customEndpoint.certificate : customEndpointCertificate = new acm.Certificate(this, "CustomEndpointCertificate", { domainName: props.customEndpoint.domainName, validation: props.customEndpoint.hostedZone ? acm.CertificateValidation.fromDns(props.customEndpoint.hostedZone) : void 0 })), this.domain = new opensearchservice_generated_1.CfnDomain(this, "Resource", { domainName: this.physicalName, engineVersion: props.version.version, clusterConfig: { dedicatedMasterEnabled, dedicatedMasterCount: dedicatedMasterEnabled ? dedicatedMasterCount : void 0, dedicatedMasterType: dedicatedMasterEnabled ? dedicatedMasterType : void 0, instanceCount, instanceType, warmEnabled: warmEnabled || void 0, warmCount: warmEnabled ? warmCount : void 0, warmType: warmEnabled ? warmType : void 0, zoneAwarenessEnabled, zoneAwarenessConfig: zoneAwarenessEnabled ? { availabilityZoneCount } : void 0 }, ebsOptions: { ebsEnabled, volumeSize: ebsEnabled ? volumeSize : void 0, volumeType: ebsEnabled ? volumeType : void 0, iops: ebsEnabled ? props.ebs?.iops : void 0 }, encryptionAtRestOptions: { enabled: encryptionAtRestEnabled, kmsKeyId: encryptionAtRestEnabled ? props.encryptionAtRest?.kmsKey?.keyId : void 0 }, nodeToNodeEncryptionOptions: { enabled: nodeToNodeEncryptionEnabled }, logPublishingOptions: logPublishing, cognitoOptions: props.cognitoDashboardsAuth ? { enabled: true, identityPoolId: props.cognitoDashboardsAuth?.identityPoolId, roleArn: props.cognitoDashboardsAuth?.role.roleArn, userPoolId: props.cognitoDashboardsAuth?.userPoolId } : void 0, vpcOptions: cfnVpcOptions, snapshotOptions: props.automatedSnapshotStartHour ? { automatedSnapshotStartHour: props.automatedSnapshotStartHour } : void 0, domainEndpointOptions: { enforceHttps, tlsSecurityPolicy: props.tlsSecurityPolicy ?? TLSSecurityPolicy.TLS_1_0, ...props.customEndpoint && { customEndpointEnabled: true, customEndpoint: props.customEndpoint.domainName, customEndpointCertificateArn: customEndpointCertificate.certificateArn } }, advancedSecurityOptions: advancedSecurityEnabled ? { enabled: true, internalUserDatabaseEnabled, masterUserOptions: { masterUserArn, masterUserName, masterUserPassword: this.masterUserPassword?.unsafeUnwrap() } } : void 0, advancedOptions: props.advancedOptions }), this.domain.applyRemovalPolicy(props.removalPolicy), props.enableVersionUpgrade && (this.domain.cfnOptions.updatePolicy = { ...this.domain.cfnOptions.updatePolicy, enableVersionUpgrade: props.enableVersionUpgrade }), logGroupResourcePolicy && this.domain.node.addDependency(logGroupResourcePolicy), props.domainName) {
          if (!cdk.Token.isUnresolved(props.domainName)) {
            if (!props.domainName.match(/^[a-z0-9\-]+$/))
              throw new Error(`Invalid domainName '${props.domainName}'. Valid characters are a-z (lowercase only), 0-9, and \u2013 (hyphen).`);
            if (props.domainName.length < 3 || props.domainName.length > 28)
              throw new Error(`Invalid domainName '${props.domainName}'. It must be between 3 and 28 characters`);
            if (props.domainName[0] < "a" || props.domainName[0] > "z")
              throw new Error(`Invalid domainName '${props.domainName}'. It must start with a lowercase letter`);
          }
          this.node.addMetadata("aws:cdk:hasPhysicalName", props.domainName);
        }
        this.domainName = this.getResourceNameAttribute(this.domain.ref), this.domainId = this.domain.getAtt("Id").toString(), this.domainEndpoint = this.domain.getAtt("DomainEndpoint").toString(), this.domainArn = this.getResourceArnAttribute(this.domain.attrArn, { service: "es", resource: "domain", resourceName: this.physicalName }), props.customEndpoint?.hostedZone && new route53.CnameRecord(this, "CnameRecord", { recordName: props.customEndpoint.domainName, zone: props.customEndpoint.hostedZone, domainName: this.domainEndpoint }), this.encryptionAtRestOptions = props.encryptionAtRest, props.accessPolicies && this.addAccessPolicies(...props.accessPolicies), unsignedBasicAuthEnabled && this.addAccessPolicies(unsignedAccessPolicy);
      }
      get connections() {
        if (!this._connections)
          throw new Error("Connections are only available on VPC enabled domains. Use the 'vpc' property to place a domain inside a VPC");
        return this._connections;
      }
      addAccessPolicies(...accessPolicyStatements) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_iam_PolicyStatement(accessPolicyStatements);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addAccessPolicies), error;
        }
        accessPolicyStatements.length > 0 && (this.accessPolicy ? this.accessPolicy.addAccessPolicies(...accessPolicyStatements) : (this.accessPolicy = new opensearch_access_policy_1.OpenSearchAccessPolicy(this, "AccessPolicy", { domainName: this.domainName, domainArn: this.domainArn, accessPolicies: accessPolicyStatements }), this.encryptionAtRestOptions?.kmsKey && this.accessPolicy.grantPrincipal.addToPrincipalPolicy(new iam.PolicyStatement({ actions: ["kms:List*", "kms:Describe*", "kms:CreateGrant"], resources: [this.encryptionAtRestOptions.kmsKey.keyArn], effect: iam.Effect.ALLOW }))));
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Domain[_a] = { fqn: "aws-cdk-lib.aws_opensearchservice.Domain", version: "2.80.0" }, exports2.Domain = Domain;
    function extractNameFromEndpoint(domainEndpoint) {
      const { hostname } = new url_1.URL(domainEndpoint), domain = hostname.split(".")[0], suffix = "-" + domain.split("-").slice(-1)[0];
      return domain.split(suffix)[0];
    }
    function parseVersion(version) {
      const elasticsearchPrefix = "Elasticsearch_", openSearchPrefix = "OpenSearch_", isElasticsearchVersion = version.version.startsWith(elasticsearchPrefix), versionStr = isElasticsearchVersion ? version.version.substring(elasticsearchPrefix.length) : version.version.substring(openSearchPrefix.length), firstDot = versionStr.indexOf(".");
      if (firstDot < 1)
        throw new Error(`Invalid engine version: ${versionStr}. Version string needs to start with major and minor version (x.y).`);
      const secondDot = versionStr.indexOf(".", firstDot + 1);
      try {
        return secondDot == -1 ? { versionNum: parseFloat(versionStr), isElasticsearchVersion } : { versionNum: parseFloat(versionStr.substring(0, secondDot)), isElasticsearchVersion };
      } catch {
        throw new Error(`Invalid engine version: ${versionStr}. Version string needs to start with major and minor version (x.y).`);
      }
    }
    function selectSubnets(vpc, vpcSubnets) {
      const selected = [];
      for (const selection of vpcSubnets)
        selected.push(...vpc.selectSubnets(selection).subnets);
      return selected;
    }
    function zoneAwarenessCheckShouldBeSkipped(vpc, vpcSubnets) {
      for (const selection of vpcSubnets)
        if (vpc.selectSubnets(selection).isPendingLookup)
          return true;
      return false;
    }
    function initializeInstanceType(defaultInstanceType, instanceType) {
      return instanceType ? cdk.Token.isUnresolved(instanceType) ? instanceType : instanceType.toLowerCase() : defaultInstanceType;
    }
  }
});

// node_modules/aws-cdk-lib/aws-opensearchservice/lib/version.js
var require_version = __commonJS({
  "node_modules/aws-cdk-lib/aws-opensearchservice/lib/version.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EngineVersion = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var EngineVersion = class _EngineVersion {
      static elasticsearch(version) {
        return new _EngineVersion(`Elasticsearch_${version}`);
      }
      static openSearch(version) {
        return new _EngineVersion(`OpenSearch_${version}`);
      }
      constructor(version) {
        this.version = version;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EngineVersion[_a] = { fqn: "aws-cdk-lib.aws_opensearchservice.EngineVersion", version: "2.80.0" }, EngineVersion.ELASTICSEARCH_1_5 = EngineVersion.elasticsearch("1.5"), EngineVersion.ELASTICSEARCH_2_3 = EngineVersion.elasticsearch("2.3"), EngineVersion.ELASTICSEARCH_5_1 = EngineVersion.elasticsearch("5.1"), EngineVersion.ELASTICSEARCH_5_3 = EngineVersion.elasticsearch("5.3"), EngineVersion.ELASTICSEARCH_5_5 = EngineVersion.elasticsearch("5.5"), EngineVersion.ELASTICSEARCH_5_6 = EngineVersion.elasticsearch("5.6"), EngineVersion.ELASTICSEARCH_6_0 = EngineVersion.elasticsearch("6.0"), EngineVersion.ELASTICSEARCH_6_2 = EngineVersion.elasticsearch("6.2"), EngineVersion.ELASTICSEARCH_6_3 = EngineVersion.elasticsearch("6.3"), EngineVersion.ELASTICSEARCH_6_4 = EngineVersion.elasticsearch("6.4"), EngineVersion.ELASTICSEARCH_6_5 = EngineVersion.elasticsearch("6.5"), EngineVersion.ELASTICSEARCH_6_7 = EngineVersion.elasticsearch("6.7"), EngineVersion.ELASTICSEARCH_6_8 = EngineVersion.elasticsearch("6.8"), EngineVersion.ELASTICSEARCH_7_1 = EngineVersion.elasticsearch("7.1"), EngineVersion.ELASTICSEARCH_7_4 = EngineVersion.elasticsearch("7.4"), EngineVersion.ELASTICSEARCH_7_7 = EngineVersion.elasticsearch("7.7"), EngineVersion.ELASTICSEARCH_7_8 = EngineVersion.elasticsearch("7.8"), EngineVersion.ELASTICSEARCH_7_9 = EngineVersion.elasticsearch("7.9"), EngineVersion.ELASTICSEARCH_7_10 = EngineVersion.elasticsearch("7.10"), EngineVersion.OPENSEARCH_1_0 = EngineVersion.openSearch("1.0"), EngineVersion.OPENSEARCH_1_1 = EngineVersion.openSearch("1.1"), EngineVersion.OPENSEARCH_1_2 = EngineVersion.openSearch("1.2"), EngineVersion.OPENSEARCH_1_3 = EngineVersion.openSearch("1.3"), EngineVersion.OPENSEARCH_2_3 = EngineVersion.openSearch("2.3"), EngineVersion.OPENSEARCH_2_5 = EngineVersion.openSearch("2.5"), exports2.EngineVersion = EngineVersion;
  }
});

// node_modules/aws-cdk-lib/aws-opensearchservice/lib/index.js
var require_lib202 = __commonJS({
  "node_modules/aws-cdk-lib/aws-opensearchservice/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_domain2(), exports2), __exportStar(require_version(), exports2), __exportStar(require_opensearchservice_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-opensearchservice/index.js
var require_aws_opensearchservice = __commonJS({
  "node_modules/aws-cdk-lib/aws-opensearchservice/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib202(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-opsworks/lib/opsworks.generated.js
var require_opsworks_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-opsworks/lib/opsworks.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnVolume = exports2.CfnUserProfile = exports2.CfnStack = exports2.CfnLayer = exports2.CfnInstance = exports2.CfnElasticLoadBalancerAttachment = exports2.CfnApp = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAppPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("appSource", CfnApp_SourcePropertyValidator)(properties.appSource)), errors.collect(cdk.propertyValidator("attributes", cdk.hashValidator(cdk.validateString))(properties.attributes)), errors.collect(cdk.propertyValidator("dataSources", cdk.listValidator(CfnApp_DataSourcePropertyValidator))(properties.dataSources)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("domains", cdk.listValidator(cdk.validateString))(properties.domains)), errors.collect(cdk.propertyValidator("enableSsl", cdk.validateBoolean)(properties.enableSsl)), errors.collect(cdk.propertyValidator("environment", cdk.listValidator(CfnApp_EnvironmentVariablePropertyValidator))(properties.environment)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("shortname", cdk.validateString)(properties.shortname)), errors.collect(cdk.propertyValidator("sslConfiguration", CfnApp_SslConfigurationPropertyValidator)(properties.sslConfiguration)), errors.collect(cdk.propertyValidator("stackId", cdk.requiredValidator)(properties.stackId)), errors.collect(cdk.propertyValidator("stackId", cdk.validateString)(properties.stackId)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnAppProps"');
    }
    function cfnAppPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAppPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), StackId: cdk.stringToCloudFormation(properties.stackId), Type: cdk.stringToCloudFormation(properties.type), AppSource: cfnAppSourcePropertyToCloudFormation(properties.appSource), Attributes: cdk.hashMapper(cdk.stringToCloudFormation)(properties.attributes), DataSources: cdk.listMapper(cfnAppDataSourcePropertyToCloudFormation)(properties.dataSources), Description: cdk.stringToCloudFormation(properties.description), Domains: cdk.listMapper(cdk.stringToCloudFormation)(properties.domains), EnableSsl: cdk.booleanToCloudFormation(properties.enableSsl), Environment: cdk.listMapper(cfnAppEnvironmentVariablePropertyToCloudFormation)(properties.environment), Shortname: cdk.stringToCloudFormation(properties.shortname), SslConfiguration: cfnAppSslConfigurationPropertyToCloudFormation(properties.sslConfiguration) }) : properties;
    }
    function CfnAppPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("stackId", "StackId", cfn_parse.FromCloudFormation.getString(properties.StackId)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("appSource", "AppSource", properties.AppSource != null ? CfnAppSourcePropertyFromCloudFormation(properties.AppSource) : void 0), ret.addPropertyResult("attributes", "Attributes", properties.Attributes != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Attributes) : void 0), ret.addPropertyResult("dataSources", "DataSources", properties.DataSources != null ? cfn_parse.FromCloudFormation.getArray(CfnAppDataSourcePropertyFromCloudFormation)(properties.DataSources) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("domains", "Domains", properties.Domains != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Domains) : void 0), ret.addPropertyResult("enableSsl", "EnableSsl", properties.EnableSsl != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableSsl) : void 0), ret.addPropertyResult("environment", "Environment", properties.Environment != null ? cfn_parse.FromCloudFormation.getArray(CfnAppEnvironmentVariablePropertyFromCloudFormation)(properties.Environment) : void 0), ret.addPropertyResult("shortname", "Shortname", properties.Shortname != null ? cfn_parse.FromCloudFormation.getString(properties.Shortname) : void 0), ret.addPropertyResult("sslConfiguration", "SslConfiguration", properties.SslConfiguration != null ? CfnAppSslConfigurationPropertyFromCloudFormation(properties.SslConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApp = class _CfnApp extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAppPropsFromCloudFormation(resourceProperties), ret = new _CfnApp(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApp.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_opsworks_CfnAppProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApp), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "stackId", this), cdk.requireProperty(props, "type", this), this.name = props.name, this.stackId = props.stackId, this.type = props.type, this.appSource = props.appSource, this.attributes = props.attributes, this.dataSources = props.dataSources, this.description = props.description, this.domains = props.domains, this.enableSsl = props.enableSsl, this.environment = props.environment, this.shortname = props.shortname, this.sslConfiguration = props.sslConfiguration;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApp.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, stackId: this.stackId, type: this.type, appSource: this.appSource, attributes: this.attributes, dataSources: this.dataSources, description: this.description, domains: this.domains, enableSsl: this.enableSsl, environment: this.environment, shortname: this.shortname, sslConfiguration: this.sslConfiguration };
      }
      renderProperties(props) {
        return cfnAppPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnApp[_a] = { fqn: "aws-cdk-lib.aws_opsworks.CfnApp", version: "2.80.0" }, CfnApp.CFN_RESOURCE_TYPE_NAME = "AWS::OpsWorks::App", exports2.CfnApp = CfnApp;
    function CfnApp_DataSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "DataSourceProperty"');
    }
    function cfnAppDataSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApp_DataSourcePropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn), DatabaseName: cdk.stringToCloudFormation(properties.databaseName), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnAppDataSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", properties.Arn != null ? cfn_parse.FromCloudFormation.getString(properties.Arn) : void 0), ret.addPropertyResult("databaseName", "DatabaseName", properties.DatabaseName != null ? cfn_parse.FromCloudFormation.getString(properties.DatabaseName) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApp_EnvironmentVariablePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("secure", cdk.validateBoolean)(properties.secure)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "EnvironmentVariableProperty"');
    }
    function cfnAppEnvironmentVariablePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApp_EnvironmentVariablePropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Secure: cdk.booleanToCloudFormation(properties.secure), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnAppEnvironmentVariablePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("secure", "Secure", properties.Secure != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Secure) : void 0), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApp_SourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("password", cdk.validateString)(properties.password)), errors.collect(cdk.propertyValidator("revision", cdk.validateString)(properties.revision)), errors.collect(cdk.propertyValidator("sshKey", cdk.validateString)(properties.sshKey)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("url", cdk.validateString)(properties.url)), errors.collect(cdk.propertyValidator("username", cdk.validateString)(properties.username)), errors.wrap('supplied properties not correct for "SourceProperty"');
    }
    function cfnAppSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApp_SourcePropertyValidator(properties).assertSuccess(), { Password: cdk.stringToCloudFormation(properties.password), Revision: cdk.stringToCloudFormation(properties.revision), SshKey: cdk.stringToCloudFormation(properties.sshKey), Type: cdk.stringToCloudFormation(properties.type), Url: cdk.stringToCloudFormation(properties.url), Username: cdk.stringToCloudFormation(properties.username) }) : properties;
    }
    function CfnAppSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("password", "Password", properties.Password != null ? cfn_parse.FromCloudFormation.getString(properties.Password) : void 0), ret.addPropertyResult("revision", "Revision", properties.Revision != null ? cfn_parse.FromCloudFormation.getString(properties.Revision) : void 0), ret.addPropertyResult("sshKey", "SshKey", properties.SshKey != null ? cfn_parse.FromCloudFormation.getString(properties.SshKey) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addPropertyResult("url", "Url", properties.Url != null ? cfn_parse.FromCloudFormation.getString(properties.Url) : void 0), ret.addPropertyResult("username", "Username", properties.Username != null ? cfn_parse.FromCloudFormation.getString(properties.Username) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApp_SslConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificate", cdk.validateString)(properties.certificate)), errors.collect(cdk.propertyValidator("chain", cdk.validateString)(properties.chain)), errors.collect(cdk.propertyValidator("privateKey", cdk.validateString)(properties.privateKey)), errors.wrap('supplied properties not correct for "SslConfigurationProperty"');
    }
    function cfnAppSslConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApp_SslConfigurationPropertyValidator(properties).assertSuccess(), { Certificate: cdk.stringToCloudFormation(properties.certificate), Chain: cdk.stringToCloudFormation(properties.chain), PrivateKey: cdk.stringToCloudFormation(properties.privateKey) }) : properties;
    }
    function CfnAppSslConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificate", "Certificate", properties.Certificate != null ? cfn_parse.FromCloudFormation.getString(properties.Certificate) : void 0), ret.addPropertyResult("chain", "Chain", properties.Chain != null ? cfn_parse.FromCloudFormation.getString(properties.Chain) : void 0), ret.addPropertyResult("privateKey", "PrivateKey", properties.PrivateKey != null ? cfn_parse.FromCloudFormation.getString(properties.PrivateKey) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnElasticLoadBalancerAttachmentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("elasticLoadBalancerName", cdk.requiredValidator)(properties.elasticLoadBalancerName)), errors.collect(cdk.propertyValidator("elasticLoadBalancerName", cdk.validateString)(properties.elasticLoadBalancerName)), errors.collect(cdk.propertyValidator("layerId", cdk.requiredValidator)(properties.layerId)), errors.collect(cdk.propertyValidator("layerId", cdk.validateString)(properties.layerId)), errors.wrap('supplied properties not correct for "CfnElasticLoadBalancerAttachmentProps"');
    }
    function cfnElasticLoadBalancerAttachmentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnElasticLoadBalancerAttachmentPropsValidator(properties).assertSuccess(), { ElasticLoadBalancerName: cdk.stringToCloudFormation(properties.elasticLoadBalancerName), LayerId: cdk.stringToCloudFormation(properties.layerId) }) : properties;
    }
    function CfnElasticLoadBalancerAttachmentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("elasticLoadBalancerName", "ElasticLoadBalancerName", cfn_parse.FromCloudFormation.getString(properties.ElasticLoadBalancerName)), ret.addPropertyResult("layerId", "LayerId", cfn_parse.FromCloudFormation.getString(properties.LayerId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnElasticLoadBalancerAttachment = class _CfnElasticLoadBalancerAttachment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnElasticLoadBalancerAttachmentPropsFromCloudFormation(resourceProperties), ret = new _CfnElasticLoadBalancerAttachment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnElasticLoadBalancerAttachment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_opsworks_CfnElasticLoadBalancerAttachmentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnElasticLoadBalancerAttachment), error;
        }
        cdk.requireProperty(props, "elasticLoadBalancerName", this), cdk.requireProperty(props, "layerId", this), this.elasticLoadBalancerName = props.elasticLoadBalancerName, this.layerId = props.layerId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnElasticLoadBalancerAttachment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { elasticLoadBalancerName: this.elasticLoadBalancerName, layerId: this.layerId };
      }
      renderProperties(props) {
        return cfnElasticLoadBalancerAttachmentPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnElasticLoadBalancerAttachment[_b] = { fqn: "aws-cdk-lib.aws_opsworks.CfnElasticLoadBalancerAttachment", version: "2.80.0" }, CfnElasticLoadBalancerAttachment.CFN_RESOURCE_TYPE_NAME = "AWS::OpsWorks::ElasticLoadBalancerAttachment", exports2.CfnElasticLoadBalancerAttachment = CfnElasticLoadBalancerAttachment;
    function CfnInstancePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("agentVersion", cdk.validateString)(properties.agentVersion)), errors.collect(cdk.propertyValidator("amiId", cdk.validateString)(properties.amiId)), errors.collect(cdk.propertyValidator("architecture", cdk.validateString)(properties.architecture)), errors.collect(cdk.propertyValidator("autoScalingType", cdk.validateString)(properties.autoScalingType)), errors.collect(cdk.propertyValidator("availabilityZone", cdk.validateString)(properties.availabilityZone)), errors.collect(cdk.propertyValidator("blockDeviceMappings", cdk.listValidator(CfnInstance_BlockDeviceMappingPropertyValidator))(properties.blockDeviceMappings)), errors.collect(cdk.propertyValidator("ebsOptimized", cdk.validateBoolean)(properties.ebsOptimized)), errors.collect(cdk.propertyValidator("elasticIps", cdk.listValidator(cdk.validateString))(properties.elasticIps)), errors.collect(cdk.propertyValidator("hostname", cdk.validateString)(properties.hostname)), errors.collect(cdk.propertyValidator("installUpdatesOnBoot", cdk.validateBoolean)(properties.installUpdatesOnBoot)), errors.collect(cdk.propertyValidator("instanceType", cdk.requiredValidator)(properties.instanceType)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("layerIds", cdk.requiredValidator)(properties.layerIds)), errors.collect(cdk.propertyValidator("layerIds", cdk.listValidator(cdk.validateString))(properties.layerIds)), errors.collect(cdk.propertyValidator("os", cdk.validateString)(properties.os)), errors.collect(cdk.propertyValidator("rootDeviceType", cdk.validateString)(properties.rootDeviceType)), errors.collect(cdk.propertyValidator("sshKeyName", cdk.validateString)(properties.sshKeyName)), errors.collect(cdk.propertyValidator("stackId", cdk.requiredValidator)(properties.stackId)), errors.collect(cdk.propertyValidator("stackId", cdk.validateString)(properties.stackId)), errors.collect(cdk.propertyValidator("subnetId", cdk.validateString)(properties.subnetId)), errors.collect(cdk.propertyValidator("tenancy", cdk.validateString)(properties.tenancy)), errors.collect(cdk.propertyValidator("timeBasedAutoScaling", CfnInstance_TimeBasedAutoScalingPropertyValidator)(properties.timeBasedAutoScaling)), errors.collect(cdk.propertyValidator("virtualizationType", cdk.validateString)(properties.virtualizationType)), errors.collect(cdk.propertyValidator("volumes", cdk.listValidator(cdk.validateString))(properties.volumes)), errors.wrap('supplied properties not correct for "CfnInstanceProps"');
    }
    function cfnInstancePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstancePropsValidator(properties).assertSuccess(), { InstanceType: cdk.stringToCloudFormation(properties.instanceType), LayerIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.layerIds), StackId: cdk.stringToCloudFormation(properties.stackId), AgentVersion: cdk.stringToCloudFormation(properties.agentVersion), AmiId: cdk.stringToCloudFormation(properties.amiId), Architecture: cdk.stringToCloudFormation(properties.architecture), AutoScalingType: cdk.stringToCloudFormation(properties.autoScalingType), AvailabilityZone: cdk.stringToCloudFormation(properties.availabilityZone), BlockDeviceMappings: cdk.listMapper(cfnInstanceBlockDeviceMappingPropertyToCloudFormation)(properties.blockDeviceMappings), EbsOptimized: cdk.booleanToCloudFormation(properties.ebsOptimized), ElasticIps: cdk.listMapper(cdk.stringToCloudFormation)(properties.elasticIps), Hostname: cdk.stringToCloudFormation(properties.hostname), InstallUpdatesOnBoot: cdk.booleanToCloudFormation(properties.installUpdatesOnBoot), Os: cdk.stringToCloudFormation(properties.os), RootDeviceType: cdk.stringToCloudFormation(properties.rootDeviceType), SshKeyName: cdk.stringToCloudFormation(properties.sshKeyName), SubnetId: cdk.stringToCloudFormation(properties.subnetId), Tenancy: cdk.stringToCloudFormation(properties.tenancy), TimeBasedAutoScaling: cfnInstanceTimeBasedAutoScalingPropertyToCloudFormation(properties.timeBasedAutoScaling), VirtualizationType: cdk.stringToCloudFormation(properties.virtualizationType), Volumes: cdk.listMapper(cdk.stringToCloudFormation)(properties.volumes) }) : properties;
    }
    function CfnInstancePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceType", "InstanceType", cfn_parse.FromCloudFormation.getString(properties.InstanceType)), ret.addPropertyResult("layerIds", "LayerIds", cfn_parse.FromCloudFormation.getStringArray(properties.LayerIds)), ret.addPropertyResult("stackId", "StackId", cfn_parse.FromCloudFormation.getString(properties.StackId)), ret.addPropertyResult("agentVersion", "AgentVersion", properties.AgentVersion != null ? cfn_parse.FromCloudFormation.getString(properties.AgentVersion) : void 0), ret.addPropertyResult("amiId", "AmiId", properties.AmiId != null ? cfn_parse.FromCloudFormation.getString(properties.AmiId) : void 0), ret.addPropertyResult("architecture", "Architecture", properties.Architecture != null ? cfn_parse.FromCloudFormation.getString(properties.Architecture) : void 0), ret.addPropertyResult("autoScalingType", "AutoScalingType", properties.AutoScalingType != null ? cfn_parse.FromCloudFormation.getString(properties.AutoScalingType) : void 0), ret.addPropertyResult("availabilityZone", "AvailabilityZone", properties.AvailabilityZone != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityZone) : void 0), ret.addPropertyResult("blockDeviceMappings", "BlockDeviceMappings", properties.BlockDeviceMappings != null ? cfn_parse.FromCloudFormation.getArray(CfnInstanceBlockDeviceMappingPropertyFromCloudFormation)(properties.BlockDeviceMappings) : void 0), ret.addPropertyResult("ebsOptimized", "EbsOptimized", properties.EbsOptimized != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EbsOptimized) : void 0), ret.addPropertyResult("elasticIps", "ElasticIps", properties.ElasticIps != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ElasticIps) : void 0), ret.addPropertyResult("hostname", "Hostname", properties.Hostname != null ? cfn_parse.FromCloudFormation.getString(properties.Hostname) : void 0), ret.addPropertyResult("installUpdatesOnBoot", "InstallUpdatesOnBoot", properties.InstallUpdatesOnBoot != null ? cfn_parse.FromCloudFormation.getBoolean(properties.InstallUpdatesOnBoot) : void 0), ret.addPropertyResult("os", "Os", properties.Os != null ? cfn_parse.FromCloudFormation.getString(properties.Os) : void 0), ret.addPropertyResult("rootDeviceType", "RootDeviceType", properties.RootDeviceType != null ? cfn_parse.FromCloudFormation.getString(properties.RootDeviceType) : void 0), ret.addPropertyResult("sshKeyName", "SshKeyName", properties.SshKeyName != null ? cfn_parse.FromCloudFormation.getString(properties.SshKeyName) : void 0), ret.addPropertyResult("subnetId", "SubnetId", properties.SubnetId != null ? cfn_parse.FromCloudFormation.getString(properties.SubnetId) : void 0), ret.addPropertyResult("tenancy", "Tenancy", properties.Tenancy != null ? cfn_parse.FromCloudFormation.getString(properties.Tenancy) : void 0), ret.addPropertyResult("timeBasedAutoScaling", "TimeBasedAutoScaling", properties.TimeBasedAutoScaling != null ? CfnInstanceTimeBasedAutoScalingPropertyFromCloudFormation(properties.TimeBasedAutoScaling) : void 0), ret.addPropertyResult("virtualizationType", "VirtualizationType", properties.VirtualizationType != null ? cfn_parse.FromCloudFormation.getString(properties.VirtualizationType) : void 0), ret.addPropertyResult("volumes", "Volumes", properties.Volumes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Volumes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnInstance = class _CfnInstance extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnInstancePropsFromCloudFormation(resourceProperties), ret = new _CfnInstance(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnInstance.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_opsworks_CfnInstanceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnInstance), error;
        }
        cdk.requireProperty(props, "instanceType", this), cdk.requireProperty(props, "layerIds", this), cdk.requireProperty(props, "stackId", this), this.attrAvailabilityZone = cdk.Token.asString(this.getAtt("AvailabilityZone", cdk.ResolutionTypeHint.STRING)), this.attrPrivateDnsName = cdk.Token.asString(this.getAtt("PrivateDnsName", cdk.ResolutionTypeHint.STRING)), this.attrPrivateIp = cdk.Token.asString(this.getAtt("PrivateIp", cdk.ResolutionTypeHint.STRING)), this.attrPublicDnsName = cdk.Token.asString(this.getAtt("PublicDnsName", cdk.ResolutionTypeHint.STRING)), this.attrPublicIp = cdk.Token.asString(this.getAtt("PublicIp", cdk.ResolutionTypeHint.STRING)), this.instanceType = props.instanceType, this.layerIds = props.layerIds, this.stackId = props.stackId, this.agentVersion = props.agentVersion, this.amiId = props.amiId, this.architecture = props.architecture, this.autoScalingType = props.autoScalingType, this.availabilityZone = props.availabilityZone, this.blockDeviceMappings = props.blockDeviceMappings, this.ebsOptimized = props.ebsOptimized, this.elasticIps = props.elasticIps, this.hostname = props.hostname, this.installUpdatesOnBoot = props.installUpdatesOnBoot, this.os = props.os, this.rootDeviceType = props.rootDeviceType, this.sshKeyName = props.sshKeyName, this.subnetId = props.subnetId, this.tenancy = props.tenancy, this.timeBasedAutoScaling = props.timeBasedAutoScaling, this.virtualizationType = props.virtualizationType, this.volumes = props.volumes;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnInstance.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { instanceType: this.instanceType, layerIds: this.layerIds, stackId: this.stackId, agentVersion: this.agentVersion, amiId: this.amiId, architecture: this.architecture, autoScalingType: this.autoScalingType, availabilityZone: this.availabilityZone, blockDeviceMappings: this.blockDeviceMappings, ebsOptimized: this.ebsOptimized, elasticIps: this.elasticIps, hostname: this.hostname, installUpdatesOnBoot: this.installUpdatesOnBoot, os: this.os, rootDeviceType: this.rootDeviceType, sshKeyName: this.sshKeyName, subnetId: this.subnetId, tenancy: this.tenancy, timeBasedAutoScaling: this.timeBasedAutoScaling, virtualizationType: this.virtualizationType, volumes: this.volumes };
      }
      renderProperties(props) {
        return cfnInstancePropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnInstance[_c] = { fqn: "aws-cdk-lib.aws_opsworks.CfnInstance", version: "2.80.0" }, CfnInstance.CFN_RESOURCE_TYPE_NAME = "AWS::OpsWorks::Instance", exports2.CfnInstance = CfnInstance;
    function CfnInstance_BlockDeviceMappingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deviceName", cdk.validateString)(properties.deviceName)), errors.collect(cdk.propertyValidator("ebs", CfnInstance_EbsBlockDevicePropertyValidator)(properties.ebs)), errors.collect(cdk.propertyValidator("noDevice", cdk.validateString)(properties.noDevice)), errors.collect(cdk.propertyValidator("virtualName", cdk.validateString)(properties.virtualName)), errors.wrap('supplied properties not correct for "BlockDeviceMappingProperty"');
    }
    function cfnInstanceBlockDeviceMappingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstance_BlockDeviceMappingPropertyValidator(properties).assertSuccess(), { DeviceName: cdk.stringToCloudFormation(properties.deviceName), Ebs: cfnInstanceEbsBlockDevicePropertyToCloudFormation(properties.ebs), NoDevice: cdk.stringToCloudFormation(properties.noDevice), VirtualName: cdk.stringToCloudFormation(properties.virtualName) }) : properties;
    }
    function CfnInstanceBlockDeviceMappingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deviceName", "DeviceName", properties.DeviceName != null ? cfn_parse.FromCloudFormation.getString(properties.DeviceName) : void 0), ret.addPropertyResult("ebs", "Ebs", properties.Ebs != null ? CfnInstanceEbsBlockDevicePropertyFromCloudFormation(properties.Ebs) : void 0), ret.addPropertyResult("noDevice", "NoDevice", properties.NoDevice != null ? cfn_parse.FromCloudFormation.getString(properties.NoDevice) : void 0), ret.addPropertyResult("virtualName", "VirtualName", properties.VirtualName != null ? cfn_parse.FromCloudFormation.getString(properties.VirtualName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstance_EbsBlockDevicePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deleteOnTermination", cdk.validateBoolean)(properties.deleteOnTermination)), errors.collect(cdk.propertyValidator("iops", cdk.validateNumber)(properties.iops)), errors.collect(cdk.propertyValidator("snapshotId", cdk.validateString)(properties.snapshotId)), errors.collect(cdk.propertyValidator("volumeSize", cdk.validateNumber)(properties.volumeSize)), errors.collect(cdk.propertyValidator("volumeType", cdk.validateString)(properties.volumeType)), errors.wrap('supplied properties not correct for "EbsBlockDeviceProperty"');
    }
    function cfnInstanceEbsBlockDevicePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstance_EbsBlockDevicePropertyValidator(properties).assertSuccess(), { DeleteOnTermination: cdk.booleanToCloudFormation(properties.deleteOnTermination), Iops: cdk.numberToCloudFormation(properties.iops), SnapshotId: cdk.stringToCloudFormation(properties.snapshotId), VolumeSize: cdk.numberToCloudFormation(properties.volumeSize), VolumeType: cdk.stringToCloudFormation(properties.volumeType) }) : properties;
    }
    function CfnInstanceEbsBlockDevicePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deleteOnTermination", "DeleteOnTermination", properties.DeleteOnTermination != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeleteOnTermination) : void 0), ret.addPropertyResult("iops", "Iops", properties.Iops != null ? cfn_parse.FromCloudFormation.getNumber(properties.Iops) : void 0), ret.addPropertyResult("snapshotId", "SnapshotId", properties.SnapshotId != null ? cfn_parse.FromCloudFormation.getString(properties.SnapshotId) : void 0), ret.addPropertyResult("volumeSize", "VolumeSize", properties.VolumeSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.VolumeSize) : void 0), ret.addPropertyResult("volumeType", "VolumeType", properties.VolumeType != null ? cfn_parse.FromCloudFormation.getString(properties.VolumeType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstance_TimeBasedAutoScalingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("friday", cdk.hashValidator(cdk.validateString))(properties.friday)), errors.collect(cdk.propertyValidator("monday", cdk.hashValidator(cdk.validateString))(properties.monday)), errors.collect(cdk.propertyValidator("saturday", cdk.hashValidator(cdk.validateString))(properties.saturday)), errors.collect(cdk.propertyValidator("sunday", cdk.hashValidator(cdk.validateString))(properties.sunday)), errors.collect(cdk.propertyValidator("thursday", cdk.hashValidator(cdk.validateString))(properties.thursday)), errors.collect(cdk.propertyValidator("tuesday", cdk.hashValidator(cdk.validateString))(properties.tuesday)), errors.collect(cdk.propertyValidator("wednesday", cdk.hashValidator(cdk.validateString))(properties.wednesday)), errors.wrap('supplied properties not correct for "TimeBasedAutoScalingProperty"');
    }
    function cfnInstanceTimeBasedAutoScalingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstance_TimeBasedAutoScalingPropertyValidator(properties).assertSuccess(), { Friday: cdk.hashMapper(cdk.stringToCloudFormation)(properties.friday), Monday: cdk.hashMapper(cdk.stringToCloudFormation)(properties.monday), Saturday: cdk.hashMapper(cdk.stringToCloudFormation)(properties.saturday), Sunday: cdk.hashMapper(cdk.stringToCloudFormation)(properties.sunday), Thursday: cdk.hashMapper(cdk.stringToCloudFormation)(properties.thursday), Tuesday: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tuesday), Wednesday: cdk.hashMapper(cdk.stringToCloudFormation)(properties.wednesday) }) : properties;
    }
    function CfnInstanceTimeBasedAutoScalingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("friday", "Friday", properties.Friday != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Friday) : void 0), ret.addPropertyResult("monday", "Monday", properties.Monday != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Monday) : void 0), ret.addPropertyResult("saturday", "Saturday", properties.Saturday != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Saturday) : void 0), ret.addPropertyResult("sunday", "Sunday", properties.Sunday != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Sunday) : void 0), ret.addPropertyResult("thursday", "Thursday", properties.Thursday != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Thursday) : void 0), ret.addPropertyResult("tuesday", "Tuesday", properties.Tuesday != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tuesday) : void 0), ret.addPropertyResult("wednesday", "Wednesday", properties.Wednesday != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Wednesday) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLayerPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributes", cdk.hashValidator(cdk.validateString))(properties.attributes)), errors.collect(cdk.propertyValidator("autoAssignElasticIps", cdk.requiredValidator)(properties.autoAssignElasticIps)), errors.collect(cdk.propertyValidator("autoAssignElasticIps", cdk.validateBoolean)(properties.autoAssignElasticIps)), errors.collect(cdk.propertyValidator("autoAssignPublicIps", cdk.requiredValidator)(properties.autoAssignPublicIps)), errors.collect(cdk.propertyValidator("autoAssignPublicIps", cdk.validateBoolean)(properties.autoAssignPublicIps)), errors.collect(cdk.propertyValidator("customInstanceProfileArn", cdk.validateString)(properties.customInstanceProfileArn)), errors.collect(cdk.propertyValidator("customJson", cdk.validateObject)(properties.customJson)), errors.collect(cdk.propertyValidator("customRecipes", CfnLayer_RecipesPropertyValidator)(properties.customRecipes)), errors.collect(cdk.propertyValidator("customSecurityGroupIds", cdk.listValidator(cdk.validateString))(properties.customSecurityGroupIds)), errors.collect(cdk.propertyValidator("enableAutoHealing", cdk.requiredValidator)(properties.enableAutoHealing)), errors.collect(cdk.propertyValidator("enableAutoHealing", cdk.validateBoolean)(properties.enableAutoHealing)), errors.collect(cdk.propertyValidator("installUpdatesOnBoot", cdk.validateBoolean)(properties.installUpdatesOnBoot)), errors.collect(cdk.propertyValidator("lifecycleEventConfiguration", CfnLayer_LifecycleEventConfigurationPropertyValidator)(properties.lifecycleEventConfiguration)), errors.collect(cdk.propertyValidator("loadBasedAutoScaling", CfnLayer_LoadBasedAutoScalingPropertyValidator)(properties.loadBasedAutoScaling)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("packages", cdk.listValidator(cdk.validateString))(properties.packages)), errors.collect(cdk.propertyValidator("shortname", cdk.requiredValidator)(properties.shortname)), errors.collect(cdk.propertyValidator("shortname", cdk.validateString)(properties.shortname)), errors.collect(cdk.propertyValidator("stackId", cdk.requiredValidator)(properties.stackId)), errors.collect(cdk.propertyValidator("stackId", cdk.validateString)(properties.stackId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("useEbsOptimizedInstances", cdk.validateBoolean)(properties.useEbsOptimizedInstances)), errors.collect(cdk.propertyValidator("volumeConfigurations", cdk.listValidator(CfnLayer_VolumeConfigurationPropertyValidator))(properties.volumeConfigurations)), errors.wrap('supplied properties not correct for "CfnLayerProps"');
    }
    function cfnLayerPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLayerPropsValidator(properties).assertSuccess(), { AutoAssignElasticIps: cdk.booleanToCloudFormation(properties.autoAssignElasticIps), AutoAssignPublicIps: cdk.booleanToCloudFormation(properties.autoAssignPublicIps), EnableAutoHealing: cdk.booleanToCloudFormation(properties.enableAutoHealing), Name: cdk.stringToCloudFormation(properties.name), Shortname: cdk.stringToCloudFormation(properties.shortname), StackId: cdk.stringToCloudFormation(properties.stackId), Type: cdk.stringToCloudFormation(properties.type), Attributes: cdk.hashMapper(cdk.stringToCloudFormation)(properties.attributes), CustomInstanceProfileArn: cdk.stringToCloudFormation(properties.customInstanceProfileArn), CustomJson: cdk.objectToCloudFormation(properties.customJson), CustomRecipes: cfnLayerRecipesPropertyToCloudFormation(properties.customRecipes), CustomSecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.customSecurityGroupIds), InstallUpdatesOnBoot: cdk.booleanToCloudFormation(properties.installUpdatesOnBoot), LifecycleEventConfiguration: cfnLayerLifecycleEventConfigurationPropertyToCloudFormation(properties.lifecycleEventConfiguration), LoadBasedAutoScaling: cfnLayerLoadBasedAutoScalingPropertyToCloudFormation(properties.loadBasedAutoScaling), Packages: cdk.listMapper(cdk.stringToCloudFormation)(properties.packages), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), UseEbsOptimizedInstances: cdk.booleanToCloudFormation(properties.useEbsOptimizedInstances), VolumeConfigurations: cdk.listMapper(cfnLayerVolumeConfigurationPropertyToCloudFormation)(properties.volumeConfigurations) }) : properties;
    }
    function CfnLayerPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("autoAssignElasticIps", "AutoAssignElasticIps", cfn_parse.FromCloudFormation.getBoolean(properties.AutoAssignElasticIps)), ret.addPropertyResult("autoAssignPublicIps", "AutoAssignPublicIps", cfn_parse.FromCloudFormation.getBoolean(properties.AutoAssignPublicIps)), ret.addPropertyResult("enableAutoHealing", "EnableAutoHealing", cfn_parse.FromCloudFormation.getBoolean(properties.EnableAutoHealing)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("shortname", "Shortname", cfn_parse.FromCloudFormation.getString(properties.Shortname)), ret.addPropertyResult("stackId", "StackId", cfn_parse.FromCloudFormation.getString(properties.StackId)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("attributes", "Attributes", properties.Attributes != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Attributes) : void 0), ret.addPropertyResult("customInstanceProfileArn", "CustomInstanceProfileArn", properties.CustomInstanceProfileArn != null ? cfn_parse.FromCloudFormation.getString(properties.CustomInstanceProfileArn) : void 0), ret.addPropertyResult("customJson", "CustomJson", properties.CustomJson != null ? cfn_parse.FromCloudFormation.getAny(properties.CustomJson) : void 0), ret.addPropertyResult("customRecipes", "CustomRecipes", properties.CustomRecipes != null ? CfnLayerRecipesPropertyFromCloudFormation(properties.CustomRecipes) : void 0), ret.addPropertyResult("customSecurityGroupIds", "CustomSecurityGroupIds", properties.CustomSecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CustomSecurityGroupIds) : void 0), ret.addPropertyResult("installUpdatesOnBoot", "InstallUpdatesOnBoot", properties.InstallUpdatesOnBoot != null ? cfn_parse.FromCloudFormation.getBoolean(properties.InstallUpdatesOnBoot) : void 0), ret.addPropertyResult("lifecycleEventConfiguration", "LifecycleEventConfiguration", properties.LifecycleEventConfiguration != null ? CfnLayerLifecycleEventConfigurationPropertyFromCloudFormation(properties.LifecycleEventConfiguration) : void 0), ret.addPropertyResult("loadBasedAutoScaling", "LoadBasedAutoScaling", properties.LoadBasedAutoScaling != null ? CfnLayerLoadBasedAutoScalingPropertyFromCloudFormation(properties.LoadBasedAutoScaling) : void 0), ret.addPropertyResult("packages", "Packages", properties.Packages != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Packages) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("useEbsOptimizedInstances", "UseEbsOptimizedInstances", properties.UseEbsOptimizedInstances != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseEbsOptimizedInstances) : void 0), ret.addPropertyResult("volumeConfigurations", "VolumeConfigurations", properties.VolumeConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnLayerVolumeConfigurationPropertyFromCloudFormation)(properties.VolumeConfigurations) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLayer = class _CfnLayer extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLayerPropsFromCloudFormation(resourceProperties), ret = new _CfnLayer(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLayer.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_opsworks_CfnLayerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLayer), error;
        }
        cdk.requireProperty(props, "autoAssignElasticIps", this), cdk.requireProperty(props, "autoAssignPublicIps", this), cdk.requireProperty(props, "enableAutoHealing", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "shortname", this), cdk.requireProperty(props, "stackId", this), cdk.requireProperty(props, "type", this), this.autoAssignElasticIps = props.autoAssignElasticIps, this.autoAssignPublicIps = props.autoAssignPublicIps, this.enableAutoHealing = props.enableAutoHealing, this.name = props.name, this.shortname = props.shortname, this.stackId = props.stackId, this.type = props.type, this.attributes = props.attributes, this.customInstanceProfileArn = props.customInstanceProfileArn, this.customJson = props.customJson, this.customRecipes = props.customRecipes, this.customSecurityGroupIds = props.customSecurityGroupIds, this.installUpdatesOnBoot = props.installUpdatesOnBoot, this.lifecycleEventConfiguration = props.lifecycleEventConfiguration, this.loadBasedAutoScaling = props.loadBasedAutoScaling, this.packages = props.packages, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::OpsWorks::Layer", props.tags, { tagPropertyName: "tags" }), this.useEbsOptimizedInstances = props.useEbsOptimizedInstances, this.volumeConfigurations = props.volumeConfigurations;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLayer.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { autoAssignElasticIps: this.autoAssignElasticIps, autoAssignPublicIps: this.autoAssignPublicIps, enableAutoHealing: this.enableAutoHealing, name: this.name, shortname: this.shortname, stackId: this.stackId, type: this.type, attributes: this.attributes, customInstanceProfileArn: this.customInstanceProfileArn, customJson: this.customJson, customRecipes: this.customRecipes, customSecurityGroupIds: this.customSecurityGroupIds, installUpdatesOnBoot: this.installUpdatesOnBoot, lifecycleEventConfiguration: this.lifecycleEventConfiguration, loadBasedAutoScaling: this.loadBasedAutoScaling, packages: this.packages, tags: this.tags.renderTags(), useEbsOptimizedInstances: this.useEbsOptimizedInstances, volumeConfigurations: this.volumeConfigurations };
      }
      renderProperties(props) {
        return cfnLayerPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnLayer[_d] = { fqn: "aws-cdk-lib.aws_opsworks.CfnLayer", version: "2.80.0" }, CfnLayer.CFN_RESOURCE_TYPE_NAME = "AWS::OpsWorks::Layer", exports2.CfnLayer = CfnLayer;
    function CfnLayer_AutoScalingThresholdsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cpuThreshold", cdk.validateNumber)(properties.cpuThreshold)), errors.collect(cdk.propertyValidator("ignoreMetricsTime", cdk.validateNumber)(properties.ignoreMetricsTime)), errors.collect(cdk.propertyValidator("instanceCount", cdk.validateNumber)(properties.instanceCount)), errors.collect(cdk.propertyValidator("loadThreshold", cdk.validateNumber)(properties.loadThreshold)), errors.collect(cdk.propertyValidator("memoryThreshold", cdk.validateNumber)(properties.memoryThreshold)), errors.collect(cdk.propertyValidator("thresholdsWaitTime", cdk.validateNumber)(properties.thresholdsWaitTime)), errors.wrap('supplied properties not correct for "AutoScalingThresholdsProperty"');
    }
    function cfnLayerAutoScalingThresholdsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLayer_AutoScalingThresholdsPropertyValidator(properties).assertSuccess(), { CpuThreshold: cdk.numberToCloudFormation(properties.cpuThreshold), IgnoreMetricsTime: cdk.numberToCloudFormation(properties.ignoreMetricsTime), InstanceCount: cdk.numberToCloudFormation(properties.instanceCount), LoadThreshold: cdk.numberToCloudFormation(properties.loadThreshold), MemoryThreshold: cdk.numberToCloudFormation(properties.memoryThreshold), ThresholdsWaitTime: cdk.numberToCloudFormation(properties.thresholdsWaitTime) }) : properties;
    }
    function CfnLayerAutoScalingThresholdsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cpuThreshold", "CpuThreshold", properties.CpuThreshold != null ? cfn_parse.FromCloudFormation.getNumber(properties.CpuThreshold) : void 0), ret.addPropertyResult("ignoreMetricsTime", "IgnoreMetricsTime", properties.IgnoreMetricsTime != null ? cfn_parse.FromCloudFormation.getNumber(properties.IgnoreMetricsTime) : void 0), ret.addPropertyResult("instanceCount", "InstanceCount", properties.InstanceCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.InstanceCount) : void 0), ret.addPropertyResult("loadThreshold", "LoadThreshold", properties.LoadThreshold != null ? cfn_parse.FromCloudFormation.getNumber(properties.LoadThreshold) : void 0), ret.addPropertyResult("memoryThreshold", "MemoryThreshold", properties.MemoryThreshold != null ? cfn_parse.FromCloudFormation.getNumber(properties.MemoryThreshold) : void 0), ret.addPropertyResult("thresholdsWaitTime", "ThresholdsWaitTime", properties.ThresholdsWaitTime != null ? cfn_parse.FromCloudFormation.getNumber(properties.ThresholdsWaitTime) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLayer_LifecycleEventConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("shutdownEventConfiguration", CfnLayer_ShutdownEventConfigurationPropertyValidator)(properties.shutdownEventConfiguration)), errors.wrap('supplied properties not correct for "LifecycleEventConfigurationProperty"');
    }
    function cfnLayerLifecycleEventConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLayer_LifecycleEventConfigurationPropertyValidator(properties).assertSuccess(), { ShutdownEventConfiguration: cfnLayerShutdownEventConfigurationPropertyToCloudFormation(properties.shutdownEventConfiguration) }) : properties;
    }
    function CfnLayerLifecycleEventConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("shutdownEventConfiguration", "ShutdownEventConfiguration", properties.ShutdownEventConfiguration != null ? CfnLayerShutdownEventConfigurationPropertyFromCloudFormation(properties.ShutdownEventConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLayer_LoadBasedAutoScalingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("downScaling", CfnLayer_AutoScalingThresholdsPropertyValidator)(properties.downScaling)), errors.collect(cdk.propertyValidator("enable", cdk.validateBoolean)(properties.enable)), errors.collect(cdk.propertyValidator("upScaling", CfnLayer_AutoScalingThresholdsPropertyValidator)(properties.upScaling)), errors.wrap('supplied properties not correct for "LoadBasedAutoScalingProperty"');
    }
    function cfnLayerLoadBasedAutoScalingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLayer_LoadBasedAutoScalingPropertyValidator(properties).assertSuccess(), { DownScaling: cfnLayerAutoScalingThresholdsPropertyToCloudFormation(properties.downScaling), Enable: cdk.booleanToCloudFormation(properties.enable), UpScaling: cfnLayerAutoScalingThresholdsPropertyToCloudFormation(properties.upScaling) }) : properties;
    }
    function CfnLayerLoadBasedAutoScalingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("downScaling", "DownScaling", properties.DownScaling != null ? CfnLayerAutoScalingThresholdsPropertyFromCloudFormation(properties.DownScaling) : void 0), ret.addPropertyResult("enable", "Enable", properties.Enable != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enable) : void 0), ret.addPropertyResult("upScaling", "UpScaling", properties.UpScaling != null ? CfnLayerAutoScalingThresholdsPropertyFromCloudFormation(properties.UpScaling) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLayer_RecipesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configure", cdk.listValidator(cdk.validateString))(properties.configure)), errors.collect(cdk.propertyValidator("deploy", cdk.listValidator(cdk.validateString))(properties.deploy)), errors.collect(cdk.propertyValidator("setup", cdk.listValidator(cdk.validateString))(properties.setup)), errors.collect(cdk.propertyValidator("shutdown", cdk.listValidator(cdk.validateString))(properties.shutdown)), errors.collect(cdk.propertyValidator("undeploy", cdk.listValidator(cdk.validateString))(properties.undeploy)), errors.wrap('supplied properties not correct for "RecipesProperty"');
    }
    function cfnLayerRecipesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLayer_RecipesPropertyValidator(properties).assertSuccess(), { Configure: cdk.listMapper(cdk.stringToCloudFormation)(properties.configure), Deploy: cdk.listMapper(cdk.stringToCloudFormation)(properties.deploy), Setup: cdk.listMapper(cdk.stringToCloudFormation)(properties.setup), Shutdown: cdk.listMapper(cdk.stringToCloudFormation)(properties.shutdown), Undeploy: cdk.listMapper(cdk.stringToCloudFormation)(properties.undeploy) }) : properties;
    }
    function CfnLayerRecipesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configure", "Configure", properties.Configure != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Configure) : void 0), ret.addPropertyResult("deploy", "Deploy", properties.Deploy != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Deploy) : void 0), ret.addPropertyResult("setup", "Setup", properties.Setup != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Setup) : void 0), ret.addPropertyResult("shutdown", "Shutdown", properties.Shutdown != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Shutdown) : void 0), ret.addPropertyResult("undeploy", "Undeploy", properties.Undeploy != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Undeploy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLayer_ShutdownEventConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("delayUntilElbConnectionsDrained", cdk.validateBoolean)(properties.delayUntilElbConnectionsDrained)), errors.collect(cdk.propertyValidator("executionTimeout", cdk.validateNumber)(properties.executionTimeout)), errors.wrap('supplied properties not correct for "ShutdownEventConfigurationProperty"');
    }
    function cfnLayerShutdownEventConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLayer_ShutdownEventConfigurationPropertyValidator(properties).assertSuccess(), { DelayUntilElbConnectionsDrained: cdk.booleanToCloudFormation(properties.delayUntilElbConnectionsDrained), ExecutionTimeout: cdk.numberToCloudFormation(properties.executionTimeout) }) : properties;
    }
    function CfnLayerShutdownEventConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("delayUntilElbConnectionsDrained", "DelayUntilElbConnectionsDrained", properties.DelayUntilElbConnectionsDrained != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DelayUntilElbConnectionsDrained) : void 0), ret.addPropertyResult("executionTimeout", "ExecutionTimeout", properties.ExecutionTimeout != null ? cfn_parse.FromCloudFormation.getNumber(properties.ExecutionTimeout) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLayer_VolumeConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("encrypted", cdk.validateBoolean)(properties.encrypted)), errors.collect(cdk.propertyValidator("iops", cdk.validateNumber)(properties.iops)), errors.collect(cdk.propertyValidator("mountPoint", cdk.validateString)(properties.mountPoint)), errors.collect(cdk.propertyValidator("numberOfDisks", cdk.validateNumber)(properties.numberOfDisks)), errors.collect(cdk.propertyValidator("raidLevel", cdk.validateNumber)(properties.raidLevel)), errors.collect(cdk.propertyValidator("size", cdk.validateNumber)(properties.size)), errors.collect(cdk.propertyValidator("volumeType", cdk.validateString)(properties.volumeType)), errors.wrap('supplied properties not correct for "VolumeConfigurationProperty"');
    }
    function cfnLayerVolumeConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLayer_VolumeConfigurationPropertyValidator(properties).assertSuccess(), { Encrypted: cdk.booleanToCloudFormation(properties.encrypted), Iops: cdk.numberToCloudFormation(properties.iops), MountPoint: cdk.stringToCloudFormation(properties.mountPoint), NumberOfDisks: cdk.numberToCloudFormation(properties.numberOfDisks), RaidLevel: cdk.numberToCloudFormation(properties.raidLevel), Size: cdk.numberToCloudFormation(properties.size), VolumeType: cdk.stringToCloudFormation(properties.volumeType) }) : properties;
    }
    function CfnLayerVolumeConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("encrypted", "Encrypted", properties.Encrypted != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Encrypted) : void 0), ret.addPropertyResult("iops", "Iops", properties.Iops != null ? cfn_parse.FromCloudFormation.getNumber(properties.Iops) : void 0), ret.addPropertyResult("mountPoint", "MountPoint", properties.MountPoint != null ? cfn_parse.FromCloudFormation.getString(properties.MountPoint) : void 0), ret.addPropertyResult("numberOfDisks", "NumberOfDisks", properties.NumberOfDisks != null ? cfn_parse.FromCloudFormation.getNumber(properties.NumberOfDisks) : void 0), ret.addPropertyResult("raidLevel", "RaidLevel", properties.RaidLevel != null ? cfn_parse.FromCloudFormation.getNumber(properties.RaidLevel) : void 0), ret.addPropertyResult("size", "Size", properties.Size != null ? cfn_parse.FromCloudFormation.getNumber(properties.Size) : void 0), ret.addPropertyResult("volumeType", "VolumeType", properties.VolumeType != null ? cfn_parse.FromCloudFormation.getString(properties.VolumeType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStackPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("agentVersion", cdk.validateString)(properties.agentVersion)), errors.collect(cdk.propertyValidator("attributes", cdk.hashValidator(cdk.validateString))(properties.attributes)), errors.collect(cdk.propertyValidator("chefConfiguration", CfnStack_ChefConfigurationPropertyValidator)(properties.chefConfiguration)), errors.collect(cdk.propertyValidator("cloneAppIds", cdk.listValidator(cdk.validateString))(properties.cloneAppIds)), errors.collect(cdk.propertyValidator("clonePermissions", cdk.validateBoolean)(properties.clonePermissions)), errors.collect(cdk.propertyValidator("configurationManager", CfnStack_StackConfigurationManagerPropertyValidator)(properties.configurationManager)), errors.collect(cdk.propertyValidator("customCookbooksSource", CfnStack_SourcePropertyValidator)(properties.customCookbooksSource)), errors.collect(cdk.propertyValidator("customJson", cdk.validateObject)(properties.customJson)), errors.collect(cdk.propertyValidator("defaultAvailabilityZone", cdk.validateString)(properties.defaultAvailabilityZone)), errors.collect(cdk.propertyValidator("defaultInstanceProfileArn", cdk.requiredValidator)(properties.defaultInstanceProfileArn)), errors.collect(cdk.propertyValidator("defaultInstanceProfileArn", cdk.validateString)(properties.defaultInstanceProfileArn)), errors.collect(cdk.propertyValidator("defaultOs", cdk.validateString)(properties.defaultOs)), errors.collect(cdk.propertyValidator("defaultRootDeviceType", cdk.validateString)(properties.defaultRootDeviceType)), errors.collect(cdk.propertyValidator("defaultSshKeyName", cdk.validateString)(properties.defaultSshKeyName)), errors.collect(cdk.propertyValidator("defaultSubnetId", cdk.validateString)(properties.defaultSubnetId)), errors.collect(cdk.propertyValidator("ecsClusterArn", cdk.validateString)(properties.ecsClusterArn)), errors.collect(cdk.propertyValidator("elasticIps", cdk.listValidator(CfnStack_ElasticIpPropertyValidator))(properties.elasticIps)), errors.collect(cdk.propertyValidator("hostnameTheme", cdk.validateString)(properties.hostnameTheme)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("rdsDbInstances", cdk.listValidator(CfnStack_RdsDbInstancePropertyValidator))(properties.rdsDbInstances)), errors.collect(cdk.propertyValidator("serviceRoleArn", cdk.requiredValidator)(properties.serviceRoleArn)), errors.collect(cdk.propertyValidator("serviceRoleArn", cdk.validateString)(properties.serviceRoleArn)), errors.collect(cdk.propertyValidator("sourceStackId", cdk.validateString)(properties.sourceStackId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("useCustomCookbooks", cdk.validateBoolean)(properties.useCustomCookbooks)), errors.collect(cdk.propertyValidator("useOpsworksSecurityGroups", cdk.validateBoolean)(properties.useOpsworksSecurityGroups)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "CfnStackProps"');
    }
    function cfnStackPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStackPropsValidator(properties).assertSuccess(), { DefaultInstanceProfileArn: cdk.stringToCloudFormation(properties.defaultInstanceProfileArn), Name: cdk.stringToCloudFormation(properties.name), ServiceRoleArn: cdk.stringToCloudFormation(properties.serviceRoleArn), AgentVersion: cdk.stringToCloudFormation(properties.agentVersion), Attributes: cdk.hashMapper(cdk.stringToCloudFormation)(properties.attributes), ChefConfiguration: cfnStackChefConfigurationPropertyToCloudFormation(properties.chefConfiguration), CloneAppIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.cloneAppIds), ClonePermissions: cdk.booleanToCloudFormation(properties.clonePermissions), ConfigurationManager: cfnStackStackConfigurationManagerPropertyToCloudFormation(properties.configurationManager), CustomCookbooksSource: cfnStackSourcePropertyToCloudFormation(properties.customCookbooksSource), CustomJson: cdk.objectToCloudFormation(properties.customJson), DefaultAvailabilityZone: cdk.stringToCloudFormation(properties.defaultAvailabilityZone), DefaultOs: cdk.stringToCloudFormation(properties.defaultOs), DefaultRootDeviceType: cdk.stringToCloudFormation(properties.defaultRootDeviceType), DefaultSshKeyName: cdk.stringToCloudFormation(properties.defaultSshKeyName), DefaultSubnetId: cdk.stringToCloudFormation(properties.defaultSubnetId), EcsClusterArn: cdk.stringToCloudFormation(properties.ecsClusterArn), ElasticIps: cdk.listMapper(cfnStackElasticIpPropertyToCloudFormation)(properties.elasticIps), HostnameTheme: cdk.stringToCloudFormation(properties.hostnameTheme), RdsDbInstances: cdk.listMapper(cfnStackRdsDbInstancePropertyToCloudFormation)(properties.rdsDbInstances), SourceStackId: cdk.stringToCloudFormation(properties.sourceStackId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), UseCustomCookbooks: cdk.booleanToCloudFormation(properties.useCustomCookbooks), UseOpsworksSecurityGroups: cdk.booleanToCloudFormation(properties.useOpsworksSecurityGroups), VpcId: cdk.stringToCloudFormation(properties.vpcId) }) : properties;
    }
    function CfnStackPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultInstanceProfileArn", "DefaultInstanceProfileArn", cfn_parse.FromCloudFormation.getString(properties.DefaultInstanceProfileArn)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("serviceRoleArn", "ServiceRoleArn", cfn_parse.FromCloudFormation.getString(properties.ServiceRoleArn)), ret.addPropertyResult("agentVersion", "AgentVersion", properties.AgentVersion != null ? cfn_parse.FromCloudFormation.getString(properties.AgentVersion) : void 0), ret.addPropertyResult("attributes", "Attributes", properties.Attributes != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Attributes) : void 0), ret.addPropertyResult("chefConfiguration", "ChefConfiguration", properties.ChefConfiguration != null ? CfnStackChefConfigurationPropertyFromCloudFormation(properties.ChefConfiguration) : void 0), ret.addPropertyResult("cloneAppIds", "CloneAppIds", properties.CloneAppIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CloneAppIds) : void 0), ret.addPropertyResult("clonePermissions", "ClonePermissions", properties.ClonePermissions != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ClonePermissions) : void 0), ret.addPropertyResult("configurationManager", "ConfigurationManager", properties.ConfigurationManager != null ? CfnStackStackConfigurationManagerPropertyFromCloudFormation(properties.ConfigurationManager) : void 0), ret.addPropertyResult("customCookbooksSource", "CustomCookbooksSource", properties.CustomCookbooksSource != null ? CfnStackSourcePropertyFromCloudFormation(properties.CustomCookbooksSource) : void 0), ret.addPropertyResult("customJson", "CustomJson", properties.CustomJson != null ? cfn_parse.FromCloudFormation.getAny(properties.CustomJson) : void 0), ret.addPropertyResult("defaultAvailabilityZone", "DefaultAvailabilityZone", properties.DefaultAvailabilityZone != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultAvailabilityZone) : void 0), ret.addPropertyResult("defaultOs", "DefaultOs", properties.DefaultOs != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultOs) : void 0), ret.addPropertyResult("defaultRootDeviceType", "DefaultRootDeviceType", properties.DefaultRootDeviceType != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultRootDeviceType) : void 0), ret.addPropertyResult("defaultSshKeyName", "DefaultSshKeyName", properties.DefaultSshKeyName != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultSshKeyName) : void 0), ret.addPropertyResult("defaultSubnetId", "DefaultSubnetId", properties.DefaultSubnetId != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultSubnetId) : void 0), ret.addPropertyResult("ecsClusterArn", "EcsClusterArn", properties.EcsClusterArn != null ? cfn_parse.FromCloudFormation.getString(properties.EcsClusterArn) : void 0), ret.addPropertyResult("elasticIps", "ElasticIps", properties.ElasticIps != null ? cfn_parse.FromCloudFormation.getArray(CfnStackElasticIpPropertyFromCloudFormation)(properties.ElasticIps) : void 0), ret.addPropertyResult("hostnameTheme", "HostnameTheme", properties.HostnameTheme != null ? cfn_parse.FromCloudFormation.getString(properties.HostnameTheme) : void 0), ret.addPropertyResult("rdsDbInstances", "RdsDbInstances", properties.RdsDbInstances != null ? cfn_parse.FromCloudFormation.getArray(CfnStackRdsDbInstancePropertyFromCloudFormation)(properties.RdsDbInstances) : void 0), ret.addPropertyResult("sourceStackId", "SourceStackId", properties.SourceStackId != null ? cfn_parse.FromCloudFormation.getString(properties.SourceStackId) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("useCustomCookbooks", "UseCustomCookbooks", properties.UseCustomCookbooks != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseCustomCookbooks) : void 0), ret.addPropertyResult("useOpsworksSecurityGroups", "UseOpsworksSecurityGroups", properties.UseOpsworksSecurityGroups != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseOpsworksSecurityGroups) : void 0), ret.addPropertyResult("vpcId", "VpcId", properties.VpcId != null ? cfn_parse.FromCloudFormation.getString(properties.VpcId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnStack = class _CfnStack extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnStackPropsFromCloudFormation(resourceProperties), ret = new _CfnStack(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnStack.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_opsworks_CfnStackProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnStack), error;
        }
        cdk.requireProperty(props, "defaultInstanceProfileArn", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "serviceRoleArn", this), this.defaultInstanceProfileArn = props.defaultInstanceProfileArn, this.name = props.name, this.serviceRoleArn = props.serviceRoleArn, this.agentVersion = props.agentVersion, this.attributes = props.attributes, this.chefConfiguration = props.chefConfiguration, this.cloneAppIds = props.cloneAppIds, this.clonePermissions = props.clonePermissions, this.configurationManager = props.configurationManager, this.customCookbooksSource = props.customCookbooksSource, this.customJson = props.customJson, this.defaultAvailabilityZone = props.defaultAvailabilityZone, this.defaultOs = props.defaultOs, this.defaultRootDeviceType = props.defaultRootDeviceType, this.defaultSshKeyName = props.defaultSshKeyName, this.defaultSubnetId = props.defaultSubnetId, this.ecsClusterArn = props.ecsClusterArn, this.elasticIps = props.elasticIps, this.hostnameTheme = props.hostnameTheme, this.rdsDbInstances = props.rdsDbInstances, this.sourceStackId = props.sourceStackId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::OpsWorks::Stack", props.tags, { tagPropertyName: "tags" }), this.useCustomCookbooks = props.useCustomCookbooks, this.useOpsworksSecurityGroups = props.useOpsworksSecurityGroups, this.vpcId = props.vpcId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStack.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { defaultInstanceProfileArn: this.defaultInstanceProfileArn, name: this.name, serviceRoleArn: this.serviceRoleArn, agentVersion: this.agentVersion, attributes: this.attributes, chefConfiguration: this.chefConfiguration, cloneAppIds: this.cloneAppIds, clonePermissions: this.clonePermissions, configurationManager: this.configurationManager, customCookbooksSource: this.customCookbooksSource, customJson: this.customJson, defaultAvailabilityZone: this.defaultAvailabilityZone, defaultOs: this.defaultOs, defaultRootDeviceType: this.defaultRootDeviceType, defaultSshKeyName: this.defaultSshKeyName, defaultSubnetId: this.defaultSubnetId, ecsClusterArn: this.ecsClusterArn, elasticIps: this.elasticIps, hostnameTheme: this.hostnameTheme, rdsDbInstances: this.rdsDbInstances, sourceStackId: this.sourceStackId, tags: this.tags.renderTags(), useCustomCookbooks: this.useCustomCookbooks, useOpsworksSecurityGroups: this.useOpsworksSecurityGroups, vpcId: this.vpcId };
      }
      renderProperties(props) {
        return cfnStackPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnStack[_e] = { fqn: "aws-cdk-lib.aws_opsworks.CfnStack", version: "2.80.0" }, CfnStack.CFN_RESOURCE_TYPE_NAME = "AWS::OpsWorks::Stack", exports2.CfnStack = CfnStack;
    function CfnStack_ChefConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("berkshelfVersion", cdk.validateString)(properties.berkshelfVersion)), errors.collect(cdk.propertyValidator("manageBerkshelf", cdk.validateBoolean)(properties.manageBerkshelf)), errors.wrap('supplied properties not correct for "ChefConfigurationProperty"');
    }
    function cfnStackChefConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStack_ChefConfigurationPropertyValidator(properties).assertSuccess(), { BerkshelfVersion: cdk.stringToCloudFormation(properties.berkshelfVersion), ManageBerkshelf: cdk.booleanToCloudFormation(properties.manageBerkshelf) }) : properties;
    }
    function CfnStackChefConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("berkshelfVersion", "BerkshelfVersion", properties.BerkshelfVersion != null ? cfn_parse.FromCloudFormation.getString(properties.BerkshelfVersion) : void 0), ret.addPropertyResult("manageBerkshelf", "ManageBerkshelf", properties.ManageBerkshelf != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ManageBerkshelf) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStack_ElasticIpPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ip", cdk.requiredValidator)(properties.ip)), errors.collect(cdk.propertyValidator("ip", cdk.validateString)(properties.ip)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "ElasticIpProperty"');
    }
    function cfnStackElasticIpPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStack_ElasticIpPropertyValidator(properties).assertSuccess(), { Ip: cdk.stringToCloudFormation(properties.ip), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnStackElasticIpPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ip", "Ip", cfn_parse.FromCloudFormation.getString(properties.Ip)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStack_RdsDbInstancePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dbPassword", cdk.requiredValidator)(properties.dbPassword)), errors.collect(cdk.propertyValidator("dbPassword", cdk.validateString)(properties.dbPassword)), errors.collect(cdk.propertyValidator("dbUser", cdk.requiredValidator)(properties.dbUser)), errors.collect(cdk.propertyValidator("dbUser", cdk.validateString)(properties.dbUser)), errors.collect(cdk.propertyValidator("rdsDbInstanceArn", cdk.requiredValidator)(properties.rdsDbInstanceArn)), errors.collect(cdk.propertyValidator("rdsDbInstanceArn", cdk.validateString)(properties.rdsDbInstanceArn)), errors.wrap('supplied properties not correct for "RdsDbInstanceProperty"');
    }
    function cfnStackRdsDbInstancePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStack_RdsDbInstancePropertyValidator(properties).assertSuccess(), { DbPassword: cdk.stringToCloudFormation(properties.dbPassword), DbUser: cdk.stringToCloudFormation(properties.dbUser), RdsDbInstanceArn: cdk.stringToCloudFormation(properties.rdsDbInstanceArn) }) : properties;
    }
    function CfnStackRdsDbInstancePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dbPassword", "DbPassword", cfn_parse.FromCloudFormation.getString(properties.DbPassword)), ret.addPropertyResult("dbUser", "DbUser", cfn_parse.FromCloudFormation.getString(properties.DbUser)), ret.addPropertyResult("rdsDbInstanceArn", "RdsDbInstanceArn", cfn_parse.FromCloudFormation.getString(properties.RdsDbInstanceArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStack_SourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("password", cdk.validateString)(properties.password)), errors.collect(cdk.propertyValidator("revision", cdk.validateString)(properties.revision)), errors.collect(cdk.propertyValidator("sshKey", cdk.validateString)(properties.sshKey)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("url", cdk.validateString)(properties.url)), errors.collect(cdk.propertyValidator("username", cdk.validateString)(properties.username)), errors.wrap('supplied properties not correct for "SourceProperty"');
    }
    function cfnStackSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStack_SourcePropertyValidator(properties).assertSuccess(), { Password: cdk.stringToCloudFormation(properties.password), Revision: cdk.stringToCloudFormation(properties.revision), SshKey: cdk.stringToCloudFormation(properties.sshKey), Type: cdk.stringToCloudFormation(properties.type), Url: cdk.stringToCloudFormation(properties.url), Username: cdk.stringToCloudFormation(properties.username) }) : properties;
    }
    function CfnStackSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("password", "Password", properties.Password != null ? cfn_parse.FromCloudFormation.getString(properties.Password) : void 0), ret.addPropertyResult("revision", "Revision", properties.Revision != null ? cfn_parse.FromCloudFormation.getString(properties.Revision) : void 0), ret.addPropertyResult("sshKey", "SshKey", properties.SshKey != null ? cfn_parse.FromCloudFormation.getString(properties.SshKey) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addPropertyResult("url", "Url", properties.Url != null ? cfn_parse.FromCloudFormation.getString(properties.Url) : void 0), ret.addPropertyResult("username", "Username", properties.Username != null ? cfn_parse.FromCloudFormation.getString(properties.Username) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStack_StackConfigurationManagerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "StackConfigurationManagerProperty"');
    }
    function cfnStackStackConfigurationManagerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStack_StackConfigurationManagerPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnStackStackConfigurationManagerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getString(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserProfilePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowSelfManagement", cdk.validateBoolean)(properties.allowSelfManagement)), errors.collect(cdk.propertyValidator("iamUserArn", cdk.requiredValidator)(properties.iamUserArn)), errors.collect(cdk.propertyValidator("iamUserArn", cdk.validateString)(properties.iamUserArn)), errors.collect(cdk.propertyValidator("sshPublicKey", cdk.validateString)(properties.sshPublicKey)), errors.collect(cdk.propertyValidator("sshUsername", cdk.validateString)(properties.sshUsername)), errors.wrap('supplied properties not correct for "CfnUserProfileProps"');
    }
    function cfnUserProfilePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserProfilePropsValidator(properties).assertSuccess(), { IamUserArn: cdk.stringToCloudFormation(properties.iamUserArn), AllowSelfManagement: cdk.booleanToCloudFormation(properties.allowSelfManagement), SshPublicKey: cdk.stringToCloudFormation(properties.sshPublicKey), SshUsername: cdk.stringToCloudFormation(properties.sshUsername) }) : properties;
    }
    function CfnUserProfilePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("iamUserArn", "IamUserArn", cfn_parse.FromCloudFormation.getString(properties.IamUserArn)), ret.addPropertyResult("allowSelfManagement", "AllowSelfManagement", properties.AllowSelfManagement != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllowSelfManagement) : void 0), ret.addPropertyResult("sshPublicKey", "SshPublicKey", properties.SshPublicKey != null ? cfn_parse.FromCloudFormation.getString(properties.SshPublicKey) : void 0), ret.addPropertyResult("sshUsername", "SshUsername", properties.SshUsername != null ? cfn_parse.FromCloudFormation.getString(properties.SshUsername) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnUserProfile = class _CfnUserProfile extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnUserProfilePropsFromCloudFormation(resourceProperties), ret = new _CfnUserProfile(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnUserProfile.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_opsworks_CfnUserProfileProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnUserProfile), error;
        }
        cdk.requireProperty(props, "iamUserArn", this), this.attrSshUsername = cdk.Token.asString(this.getAtt("SshUsername", cdk.ResolutionTypeHint.STRING)), this.iamUserArn = props.iamUserArn, this.allowSelfManagement = props.allowSelfManagement, this.sshPublicKey = props.sshPublicKey, this.sshUsername = props.sshUsername;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnUserProfile.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { iamUserArn: this.iamUserArn, allowSelfManagement: this.allowSelfManagement, sshPublicKey: this.sshPublicKey, sshUsername: this.sshUsername };
      }
      renderProperties(props) {
        return cfnUserProfilePropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnUserProfile[_f] = { fqn: "aws-cdk-lib.aws_opsworks.CfnUserProfile", version: "2.80.0" }, CfnUserProfile.CFN_RESOURCE_TYPE_NAME = "AWS::OpsWorks::UserProfile", exports2.CfnUserProfile = CfnUserProfile;
    function CfnVolumePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ec2VolumeId", cdk.requiredValidator)(properties.ec2VolumeId)), errors.collect(cdk.propertyValidator("ec2VolumeId", cdk.validateString)(properties.ec2VolumeId)), errors.collect(cdk.propertyValidator("mountPoint", cdk.validateString)(properties.mountPoint)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("stackId", cdk.requiredValidator)(properties.stackId)), errors.collect(cdk.propertyValidator("stackId", cdk.validateString)(properties.stackId)), errors.wrap('supplied properties not correct for "CfnVolumeProps"');
    }
    function cfnVolumePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVolumePropsValidator(properties).assertSuccess(), { Ec2VolumeId: cdk.stringToCloudFormation(properties.ec2VolumeId), StackId: cdk.stringToCloudFormation(properties.stackId), MountPoint: cdk.stringToCloudFormation(properties.mountPoint), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnVolumePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ec2VolumeId", "Ec2VolumeId", cfn_parse.FromCloudFormation.getString(properties.Ec2VolumeId)), ret.addPropertyResult("stackId", "StackId", cfn_parse.FromCloudFormation.getString(properties.StackId)), ret.addPropertyResult("mountPoint", "MountPoint", properties.MountPoint != null ? cfn_parse.FromCloudFormation.getString(properties.MountPoint) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVolume = class _CfnVolume extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVolumePropsFromCloudFormation(resourceProperties), ret = new _CfnVolume(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVolume.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_opsworks_CfnVolumeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVolume), error;
        }
        cdk.requireProperty(props, "ec2VolumeId", this), cdk.requireProperty(props, "stackId", this), this.ec2VolumeId = props.ec2VolumeId, this.stackId = props.stackId, this.mountPoint = props.mountPoint, this.name = props.name;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVolume.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { ec2VolumeId: this.ec2VolumeId, stackId: this.stackId, mountPoint: this.mountPoint, name: this.name };
      }
      renderProperties(props) {
        return cfnVolumePropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnVolume[_g] = { fqn: "aws-cdk-lib.aws_opsworks.CfnVolume", version: "2.80.0" }, CfnVolume.CFN_RESOURCE_TYPE_NAME = "AWS::OpsWorks::Volume", exports2.CfnVolume = CfnVolume;
  }
});

// node_modules/aws-cdk-lib/aws-opsworks/lib/index.js
var require_lib203 = __commonJS({
  "node_modules/aws-cdk-lib/aws-opsworks/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_opsworks_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-opsworks/index.js
var require_aws_opsworks = __commonJS({
  "node_modules/aws-cdk-lib/aws-opsworks/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib203(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-opsworkscm/lib/opsworkscm.generated.js
var require_opsworkscm_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-opsworkscm/lib/opsworkscm.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnServer = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnServerPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("associatePublicIpAddress", cdk.validateBoolean)(properties.associatePublicIpAddress)), errors.collect(cdk.propertyValidator("backupId", cdk.validateString)(properties.backupId)), errors.collect(cdk.propertyValidator("backupRetentionCount", cdk.validateNumber)(properties.backupRetentionCount)), errors.collect(cdk.propertyValidator("customCertificate", cdk.validateString)(properties.customCertificate)), errors.collect(cdk.propertyValidator("customDomain", cdk.validateString)(properties.customDomain)), errors.collect(cdk.propertyValidator("customPrivateKey", cdk.validateString)(properties.customPrivateKey)), errors.collect(cdk.propertyValidator("disableAutomatedBackup", cdk.validateBoolean)(properties.disableAutomatedBackup)), errors.collect(cdk.propertyValidator("engine", cdk.validateString)(properties.engine)), errors.collect(cdk.propertyValidator("engineAttributes", cdk.listValidator(CfnServer_EngineAttributePropertyValidator))(properties.engineAttributes)), errors.collect(cdk.propertyValidator("engineModel", cdk.validateString)(properties.engineModel)), errors.collect(cdk.propertyValidator("engineVersion", cdk.validateString)(properties.engineVersion)), errors.collect(cdk.propertyValidator("instanceProfileArn", cdk.requiredValidator)(properties.instanceProfileArn)), errors.collect(cdk.propertyValidator("instanceProfileArn", cdk.validateString)(properties.instanceProfileArn)), errors.collect(cdk.propertyValidator("instanceType", cdk.requiredValidator)(properties.instanceType)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("keyPair", cdk.validateString)(properties.keyPair)), errors.collect(cdk.propertyValidator("preferredBackupWindow", cdk.validateString)(properties.preferredBackupWindow)), errors.collect(cdk.propertyValidator("preferredMaintenanceWindow", cdk.validateString)(properties.preferredMaintenanceWindow)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("serviceRoleArn", cdk.requiredValidator)(properties.serviceRoleArn)), errors.collect(cdk.propertyValidator("serviceRoleArn", cdk.validateString)(properties.serviceRoleArn)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnServerProps"');
    }
    function cfnServerPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnServerPropsValidator(properties).assertSuccess(), { InstanceProfileArn: cdk.stringToCloudFormation(properties.instanceProfileArn), InstanceType: cdk.stringToCloudFormation(properties.instanceType), ServiceRoleArn: cdk.stringToCloudFormation(properties.serviceRoleArn), AssociatePublicIpAddress: cdk.booleanToCloudFormation(properties.associatePublicIpAddress), BackupId: cdk.stringToCloudFormation(properties.backupId), BackupRetentionCount: cdk.numberToCloudFormation(properties.backupRetentionCount), CustomCertificate: cdk.stringToCloudFormation(properties.customCertificate), CustomDomain: cdk.stringToCloudFormation(properties.customDomain), CustomPrivateKey: cdk.stringToCloudFormation(properties.customPrivateKey), DisableAutomatedBackup: cdk.booleanToCloudFormation(properties.disableAutomatedBackup), Engine: cdk.stringToCloudFormation(properties.engine), EngineAttributes: cdk.listMapper(cfnServerEngineAttributePropertyToCloudFormation)(properties.engineAttributes), EngineModel: cdk.stringToCloudFormation(properties.engineModel), EngineVersion: cdk.stringToCloudFormation(properties.engineVersion), KeyPair: cdk.stringToCloudFormation(properties.keyPair), PreferredBackupWindow: cdk.stringToCloudFormation(properties.preferredBackupWindow), PreferredMaintenanceWindow: cdk.stringToCloudFormation(properties.preferredMaintenanceWindow), SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnServerPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceProfileArn", "InstanceProfileArn", cfn_parse.FromCloudFormation.getString(properties.InstanceProfileArn)), ret.addPropertyResult("instanceType", "InstanceType", cfn_parse.FromCloudFormation.getString(properties.InstanceType)), ret.addPropertyResult("serviceRoleArn", "ServiceRoleArn", cfn_parse.FromCloudFormation.getString(properties.ServiceRoleArn)), ret.addPropertyResult("associatePublicIpAddress", "AssociatePublicIpAddress", properties.AssociatePublicIpAddress != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AssociatePublicIpAddress) : void 0), ret.addPropertyResult("backupId", "BackupId", properties.BackupId != null ? cfn_parse.FromCloudFormation.getString(properties.BackupId) : void 0), ret.addPropertyResult("backupRetentionCount", "BackupRetentionCount", properties.BackupRetentionCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.BackupRetentionCount) : void 0), ret.addPropertyResult("customCertificate", "CustomCertificate", properties.CustomCertificate != null ? cfn_parse.FromCloudFormation.getString(properties.CustomCertificate) : void 0), ret.addPropertyResult("customDomain", "CustomDomain", properties.CustomDomain != null ? cfn_parse.FromCloudFormation.getString(properties.CustomDomain) : void 0), ret.addPropertyResult("customPrivateKey", "CustomPrivateKey", properties.CustomPrivateKey != null ? cfn_parse.FromCloudFormation.getString(properties.CustomPrivateKey) : void 0), ret.addPropertyResult("disableAutomatedBackup", "DisableAutomatedBackup", properties.DisableAutomatedBackup != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DisableAutomatedBackup) : void 0), ret.addPropertyResult("engine", "Engine", properties.Engine != null ? cfn_parse.FromCloudFormation.getString(properties.Engine) : void 0), ret.addPropertyResult("engineAttributes", "EngineAttributes", properties.EngineAttributes != null ? cfn_parse.FromCloudFormation.getArray(CfnServerEngineAttributePropertyFromCloudFormation)(properties.EngineAttributes) : void 0), ret.addPropertyResult("engineModel", "EngineModel", properties.EngineModel != null ? cfn_parse.FromCloudFormation.getString(properties.EngineModel) : void 0), ret.addPropertyResult("engineVersion", "EngineVersion", properties.EngineVersion != null ? cfn_parse.FromCloudFormation.getString(properties.EngineVersion) : void 0), ret.addPropertyResult("keyPair", "KeyPair", properties.KeyPair != null ? cfn_parse.FromCloudFormation.getString(properties.KeyPair) : void 0), ret.addPropertyResult("preferredBackupWindow", "PreferredBackupWindow", properties.PreferredBackupWindow != null ? cfn_parse.FromCloudFormation.getString(properties.PreferredBackupWindow) : void 0), ret.addPropertyResult("preferredMaintenanceWindow", "PreferredMaintenanceWindow", properties.PreferredMaintenanceWindow != null ? cfn_parse.FromCloudFormation.getString(properties.PreferredMaintenanceWindow) : void 0), ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("subnetIds", "SubnetIds", properties.SubnetIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnServer = class _CfnServer extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnServerPropsFromCloudFormation(resourceProperties), ret = new _CfnServer(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnServer.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_opsworkscm_CfnServerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnServer), error;
        }
        cdk.requireProperty(props, "instanceProfileArn", this), cdk.requireProperty(props, "instanceType", this), cdk.requireProperty(props, "serviceRoleArn", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrEndpoint = cdk.Token.asString(this.getAtt("Endpoint", cdk.ResolutionTypeHint.STRING)), this.attrServerName = cdk.Token.asString(this.getAtt("ServerName", cdk.ResolutionTypeHint.STRING)), this.instanceProfileArn = props.instanceProfileArn, this.instanceType = props.instanceType, this.serviceRoleArn = props.serviceRoleArn, this.associatePublicIpAddress = props.associatePublicIpAddress, this.backupId = props.backupId, this.backupRetentionCount = props.backupRetentionCount, this.customCertificate = props.customCertificate, this.customDomain = props.customDomain, this.customPrivateKey = props.customPrivateKey, this.disableAutomatedBackup = props.disableAutomatedBackup, this.engine = props.engine, this.engineAttributes = props.engineAttributes, this.engineModel = props.engineModel, this.engineVersion = props.engineVersion, this.keyPair = props.keyPair, this.preferredBackupWindow = props.preferredBackupWindow, this.preferredMaintenanceWindow = props.preferredMaintenanceWindow, this.securityGroupIds = props.securityGroupIds, this.subnetIds = props.subnetIds, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::OpsWorksCM::Server", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnServer.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { instanceProfileArn: this.instanceProfileArn, instanceType: this.instanceType, serviceRoleArn: this.serviceRoleArn, associatePublicIpAddress: this.associatePublicIpAddress, backupId: this.backupId, backupRetentionCount: this.backupRetentionCount, customCertificate: this.customCertificate, customDomain: this.customDomain, customPrivateKey: this.customPrivateKey, disableAutomatedBackup: this.disableAutomatedBackup, engine: this.engine, engineAttributes: this.engineAttributes, engineModel: this.engineModel, engineVersion: this.engineVersion, keyPair: this.keyPair, preferredBackupWindow: this.preferredBackupWindow, preferredMaintenanceWindow: this.preferredMaintenanceWindow, securityGroupIds: this.securityGroupIds, subnetIds: this.subnetIds, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnServerPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnServer[_a] = { fqn: "aws-cdk-lib.aws_opsworkscm.CfnServer", version: "2.80.0" }, CfnServer.CFN_RESOURCE_TYPE_NAME = "AWS::OpsWorksCM::Server", exports2.CfnServer = CfnServer;
    function CfnServer_EngineAttributePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "EngineAttributeProperty"');
    }
    function cfnServerEngineAttributePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnServer_EngineAttributePropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnServerEngineAttributePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-opsworkscm/lib/index.js
var require_lib204 = __commonJS({
  "node_modules/aws-cdk-lib/aws-opsworkscm/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_opsworkscm_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-opsworkscm/index.js
var require_aws_opsworkscm = __commonJS({
  "node_modules/aws-cdk-lib/aws-opsworkscm/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib204(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-organizations/lib/organizations.generated.js
var require_organizations_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-organizations/lib/organizations.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnResourcePolicy = exports2.CfnPolicy = exports2.CfnOrganizationalUnit = exports2.CfnAccount = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAccountPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accountName", cdk.requiredValidator)(properties.accountName)), errors.collect(cdk.propertyValidator("accountName", cdk.validateString)(properties.accountName)), errors.collect(cdk.propertyValidator("email", cdk.requiredValidator)(properties.email)), errors.collect(cdk.propertyValidator("email", cdk.validateString)(properties.email)), errors.collect(cdk.propertyValidator("parentIds", cdk.listValidator(cdk.validateString))(properties.parentIds)), errors.collect(cdk.propertyValidator("roleName", cdk.validateString)(properties.roleName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnAccountProps"');
    }
    function cfnAccountPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccountPropsValidator(properties).assertSuccess(), { AccountName: cdk.stringToCloudFormation(properties.accountName), Email: cdk.stringToCloudFormation(properties.email), ParentIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.parentIds), RoleName: cdk.stringToCloudFormation(properties.roleName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnAccountPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accountName", "AccountName", cfn_parse.FromCloudFormation.getString(properties.AccountName)), ret.addPropertyResult("email", "Email", cfn_parse.FromCloudFormation.getString(properties.Email)), ret.addPropertyResult("parentIds", "ParentIds", properties.ParentIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ParentIds) : void 0), ret.addPropertyResult("roleName", "RoleName", properties.RoleName != null ? cfn_parse.FromCloudFormation.getString(properties.RoleName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAccount = class _CfnAccount extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAccountPropsFromCloudFormation(resourceProperties), ret = new _CfnAccount(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAccount.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_organizations_CfnAccountProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAccount), error;
        }
        cdk.requireProperty(props, "accountName", this), cdk.requireProperty(props, "email", this), this.attrAccountId = cdk.Token.asString(this.getAtt("AccountId", cdk.ResolutionTypeHint.STRING)), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrJoinedMethod = cdk.Token.asString(this.getAtt("JoinedMethod", cdk.ResolutionTypeHint.STRING)), this.attrJoinedTimestamp = cdk.Token.asString(this.getAtt("JoinedTimestamp", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.accountName = props.accountName, this.email = props.email, this.parentIds = props.parentIds, this.roleName = props.roleName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Organizations::Account", props.tags, { tagPropertyName: "tags" }), this.node.scope && cdk.Resource.isResource(this.node.scope) && this.node.addValidation({ validate: () => this.cfnOptions.deletionPolicy === void 0 ? ["'AWS::Organizations::Account' is a stateful resource type, and you must specify a Removal Policy for it. Call 'resource.applyRemovalPolicy()'."] : [] });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAccount.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { accountName: this.accountName, email: this.email, parentIds: this.parentIds, roleName: this.roleName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnAccountPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAccount[_a] = { fqn: "aws-cdk-lib.aws_organizations.CfnAccount", version: "2.80.0" }, CfnAccount.CFN_RESOURCE_TYPE_NAME = "AWS::Organizations::Account", exports2.CfnAccount = CfnAccount;
    function CfnOrganizationalUnitPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("parentId", cdk.requiredValidator)(properties.parentId)), errors.collect(cdk.propertyValidator("parentId", cdk.validateString)(properties.parentId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnOrganizationalUnitProps"');
    }
    function cfnOrganizationalUnitPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnOrganizationalUnitPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), ParentId: cdk.stringToCloudFormation(properties.parentId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnOrganizationalUnitPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("parentId", "ParentId", cfn_parse.FromCloudFormation.getString(properties.ParentId)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnOrganizationalUnit = class _CfnOrganizationalUnit extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnOrganizationalUnitPropsFromCloudFormation(resourceProperties), ret = new _CfnOrganizationalUnit(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnOrganizationalUnit.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_organizations_CfnOrganizationalUnitProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnOrganizationalUnit), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "parentId", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.parentId = props.parentId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Organizations::OrganizationalUnit", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnOrganizationalUnit.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, parentId: this.parentId, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnOrganizationalUnitPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnOrganizationalUnit[_b] = { fqn: "aws-cdk-lib.aws_organizations.CfnOrganizationalUnit", version: "2.80.0" }, CfnOrganizationalUnit.CFN_RESOURCE_TYPE_NAME = "AWS::Organizations::OrganizationalUnit", exports2.CfnOrganizationalUnit = CfnOrganizationalUnit;
    function CfnPolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("content", cdk.requiredValidator)(properties.content)), errors.collect(cdk.propertyValidator("content", cdk.validateObject)(properties.content)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("targetIds", cdk.listValidator(cdk.validateString))(properties.targetIds)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnPolicyProps"');
    }
    function cfnPolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPolicyPropsValidator(properties).assertSuccess(), { Content: cdk.objectToCloudFormation(properties.content), Name: cdk.stringToCloudFormation(properties.name), Type: cdk.stringToCloudFormation(properties.type), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TargetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.targetIds) }) : properties;
    }
    function CfnPolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("content", "Content", cfn_parse.FromCloudFormation.getAny(properties.Content)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("targetIds", "TargetIds", properties.TargetIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.TargetIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPolicy = class _CfnPolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnPolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_organizations_CfnPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPolicy), error;
        }
        cdk.requireProperty(props, "content", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "type", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrAwsManaged = this.getAtt("AwsManaged", cdk.ResolutionTypeHint.STRING), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.content = props.content, this.name = props.name, this.type = props.type, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Organizations::Policy", props.tags, { tagPropertyName: "tags" }), this.targetIds = props.targetIds;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { content: this.content, name: this.name, type: this.type, description: this.description, tags: this.tags.renderTags(), targetIds: this.targetIds };
      }
      renderProperties(props) {
        return cfnPolicyPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnPolicy[_c] = { fqn: "aws-cdk-lib.aws_organizations.CfnPolicy", version: "2.80.0" }, CfnPolicy.CFN_RESOURCE_TYPE_NAME = "AWS::Organizations::Policy", exports2.CfnPolicy = CfnPolicy;
    function CfnResourcePolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("content", cdk.requiredValidator)(properties.content)), errors.collect(cdk.propertyValidator("content", cdk.validateObject)(properties.content)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnResourcePolicyProps"');
    }
    function cfnResourcePolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourcePolicyPropsValidator(properties).assertSuccess(), { Content: cdk.objectToCloudFormation(properties.content), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnResourcePolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("content", "Content", cfn_parse.FromCloudFormation.getAny(properties.Content)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResourcePolicy = class _CfnResourcePolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResourcePolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnResourcePolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnResourcePolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_organizations_CfnResourcePolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResourcePolicy), error;
        }
        cdk.requireProperty(props, "content", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.content = props.content, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Organizations::ResourcePolicy", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResourcePolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { content: this.content, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnResourcePolicyPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnResourcePolicy[_d] = { fqn: "aws-cdk-lib.aws_organizations.CfnResourcePolicy", version: "2.80.0" }, CfnResourcePolicy.CFN_RESOURCE_TYPE_NAME = "AWS::Organizations::ResourcePolicy", exports2.CfnResourcePolicy = CfnResourcePolicy;
  }
});

// node_modules/aws-cdk-lib/aws-organizations/lib/index.js
var require_lib205 = __commonJS({
  "node_modules/aws-cdk-lib/aws-organizations/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_organizations_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-organizations/index.js
var require_aws_organizations = __commonJS({
  "node_modules/aws-cdk-lib/aws-organizations/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib205(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-osis/lib/osis.generated.js
var require_osis_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-osis/lib/osis.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnPipeline = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnPipelinePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logPublishingOptions", CfnPipeline_LogPublishingOptionsPropertyValidator)(properties.logPublishingOptions)), errors.collect(cdk.propertyValidator("maxUnits", cdk.requiredValidator)(properties.maxUnits)), errors.collect(cdk.propertyValidator("maxUnits", cdk.validateNumber)(properties.maxUnits)), errors.collect(cdk.propertyValidator("minUnits", cdk.requiredValidator)(properties.minUnits)), errors.collect(cdk.propertyValidator("minUnits", cdk.validateNumber)(properties.minUnits)), errors.collect(cdk.propertyValidator("pipelineConfigurationBody", cdk.requiredValidator)(properties.pipelineConfigurationBody)), errors.collect(cdk.propertyValidator("pipelineConfigurationBody", cdk.validateString)(properties.pipelineConfigurationBody)), errors.collect(cdk.propertyValidator("pipelineName", cdk.requiredValidator)(properties.pipelineName)), errors.collect(cdk.propertyValidator("pipelineName", cdk.validateString)(properties.pipelineName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpcOptions", CfnPipeline_VpcOptionsPropertyValidator)(properties.vpcOptions)), errors.wrap('supplied properties not correct for "CfnPipelineProps"');
    }
    function cfnPipelinePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipelinePropsValidator(properties).assertSuccess(), { MaxUnits: cdk.numberToCloudFormation(properties.maxUnits), MinUnits: cdk.numberToCloudFormation(properties.minUnits), PipelineConfigurationBody: cdk.stringToCloudFormation(properties.pipelineConfigurationBody), PipelineName: cdk.stringToCloudFormation(properties.pipelineName), LogPublishingOptions: cfnPipelineLogPublishingOptionsPropertyToCloudFormation(properties.logPublishingOptions), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VpcOptions: cfnPipelineVpcOptionsPropertyToCloudFormation(properties.vpcOptions) }) : properties;
    }
    function CfnPipelinePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxUnits", "MaxUnits", cfn_parse.FromCloudFormation.getNumber(properties.MaxUnits)), ret.addPropertyResult("minUnits", "MinUnits", cfn_parse.FromCloudFormation.getNumber(properties.MinUnits)), ret.addPropertyResult("pipelineConfigurationBody", "PipelineConfigurationBody", cfn_parse.FromCloudFormation.getString(properties.PipelineConfigurationBody)), ret.addPropertyResult("pipelineName", "PipelineName", cfn_parse.FromCloudFormation.getString(properties.PipelineName)), ret.addPropertyResult("logPublishingOptions", "LogPublishingOptions", properties.LogPublishingOptions != null ? CfnPipelineLogPublishingOptionsPropertyFromCloudFormation(properties.LogPublishingOptions) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("vpcOptions", "VpcOptions", properties.VpcOptions != null ? CfnPipelineVpcOptionsPropertyFromCloudFormation(properties.VpcOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPipeline = class _CfnPipeline extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPipelinePropsFromCloudFormation(resourceProperties), ret = new _CfnPipeline(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPipeline.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_osis_CfnPipelineProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPipeline), error;
        }
        cdk.requireProperty(props, "maxUnits", this), cdk.requireProperty(props, "minUnits", this), cdk.requireProperty(props, "pipelineConfigurationBody", this), cdk.requireProperty(props, "pipelineName", this), this.attrIngestEndpointUrls = cdk.Token.asList(this.getAtt("IngestEndpointUrls", cdk.ResolutionTypeHint.STRING_LIST)), this.attrPipelineArn = cdk.Token.asString(this.getAtt("PipelineArn", cdk.ResolutionTypeHint.STRING)), this.attrVpcEndpoints = this.getAtt("VpcEndpoints", cdk.ResolutionTypeHint.STRING), this.maxUnits = props.maxUnits, this.minUnits = props.minUnits, this.pipelineConfigurationBody = props.pipelineConfigurationBody, this.pipelineName = props.pipelineName, this.logPublishingOptions = props.logPublishingOptions, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::OSIS::Pipeline", props.tags, { tagPropertyName: "tags" }), this.vpcOptions = props.vpcOptions;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPipeline.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { maxUnits: this.maxUnits, minUnits: this.minUnits, pipelineConfigurationBody: this.pipelineConfigurationBody, pipelineName: this.pipelineName, logPublishingOptions: this.logPublishingOptions, tags: this.tags.renderTags(), vpcOptions: this.vpcOptions };
      }
      renderProperties(props) {
        return cfnPipelinePropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnPipeline[_a] = { fqn: "aws-cdk-lib.aws_osis.CfnPipeline", version: "2.80.0" }, CfnPipeline.CFN_RESOURCE_TYPE_NAME = "AWS::OSIS::Pipeline", exports2.CfnPipeline = CfnPipeline;
    function CfnPipeline_CloudWatchLogDestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logGroup", cdk.validateString)(properties.logGroup)), errors.wrap('supplied properties not correct for "CloudWatchLogDestinationProperty"');
    }
    function cfnPipelineCloudWatchLogDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipeline_CloudWatchLogDestinationPropertyValidator(properties).assertSuccess(), { LogGroup: cdk.stringToCloudFormation(properties.logGroup) }) : properties;
    }
    function CfnPipelineCloudWatchLogDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logGroup", "LogGroup", properties.LogGroup != null ? cfn_parse.FromCloudFormation.getString(properties.LogGroup) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipeline_LogPublishingOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchLogDestination", CfnPipeline_CloudWatchLogDestinationPropertyValidator)(properties.cloudWatchLogDestination)), errors.collect(cdk.propertyValidator("isLoggingEnabled", cdk.validateBoolean)(properties.isLoggingEnabled)), errors.wrap('supplied properties not correct for "LogPublishingOptionsProperty"');
    }
    function cfnPipelineLogPublishingOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipeline_LogPublishingOptionsPropertyValidator(properties).assertSuccess(), { CloudWatchLogDestination: cfnPipelineCloudWatchLogDestinationPropertyToCloudFormation(properties.cloudWatchLogDestination), IsLoggingEnabled: cdk.booleanToCloudFormation(properties.isLoggingEnabled) }) : properties;
    }
    function CfnPipelineLogPublishingOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchLogDestination", "CloudWatchLogDestination", properties.CloudWatchLogDestination != null ? CfnPipelineCloudWatchLogDestinationPropertyFromCloudFormation(properties.CloudWatchLogDestination) : void 0), ret.addPropertyResult("isLoggingEnabled", "IsLoggingEnabled", properties.IsLoggingEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsLoggingEnabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipeline_VpcOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.wrap('supplied properties not correct for "VpcOptionsProperty"');
    }
    function cfnPipelineVpcOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipeline_VpcOptionsPropertyValidator(properties).assertSuccess(), { SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds) }) : properties;
    }
    function CfnPipelineVpcOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("subnetIds", "SubnetIds", properties.SubnetIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-osis/lib/index.js
var require_lib206 = __commonJS({
  "node_modules/aws-cdk-lib/aws-osis/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_osis_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-osis/index.js
var require_aws_osis = __commonJS({
  "node_modules/aws-cdk-lib/aws-osis/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib206(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-panorama/lib/panorama.generated.js
var require_panorama_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-panorama/lib/panorama.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnPackageVersion = exports2.CfnPackage = exports2.CfnApplicationInstance = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnApplicationInstancePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationInstanceIdToReplace", cdk.validateString)(properties.applicationInstanceIdToReplace)), errors.collect(cdk.propertyValidator("defaultRuntimeContextDevice", cdk.requiredValidator)(properties.defaultRuntimeContextDevice)), errors.collect(cdk.propertyValidator("defaultRuntimeContextDevice", cdk.validateString)(properties.defaultRuntimeContextDevice)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("deviceId", cdk.validateString)(properties.deviceId)), errors.collect(cdk.propertyValidator("manifestOverridesPayload", CfnApplicationInstance_ManifestOverridesPayloadPropertyValidator)(properties.manifestOverridesPayload)), errors.collect(cdk.propertyValidator("manifestPayload", cdk.requiredValidator)(properties.manifestPayload)), errors.collect(cdk.propertyValidator("manifestPayload", CfnApplicationInstance_ManifestPayloadPropertyValidator)(properties.manifestPayload)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("runtimeRoleArn", cdk.validateString)(properties.runtimeRoleArn)), errors.collect(cdk.propertyValidator("statusFilter", cdk.validateString)(properties.statusFilter)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnApplicationInstanceProps"');
    }
    function cfnApplicationInstancePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationInstancePropsValidator(properties).assertSuccess(), { DefaultRuntimeContextDevice: cdk.stringToCloudFormation(properties.defaultRuntimeContextDevice), ManifestPayload: cfnApplicationInstanceManifestPayloadPropertyToCloudFormation(properties.manifestPayload), ApplicationInstanceIdToReplace: cdk.stringToCloudFormation(properties.applicationInstanceIdToReplace), Description: cdk.stringToCloudFormation(properties.description), DeviceId: cdk.stringToCloudFormation(properties.deviceId), ManifestOverridesPayload: cfnApplicationInstanceManifestOverridesPayloadPropertyToCloudFormation(properties.manifestOverridesPayload), Name: cdk.stringToCloudFormation(properties.name), RuntimeRoleArn: cdk.stringToCloudFormation(properties.runtimeRoleArn), StatusFilter: cdk.stringToCloudFormation(properties.statusFilter), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnApplicationInstancePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultRuntimeContextDevice", "DefaultRuntimeContextDevice", cfn_parse.FromCloudFormation.getString(properties.DefaultRuntimeContextDevice)), ret.addPropertyResult("manifestPayload", "ManifestPayload", CfnApplicationInstanceManifestPayloadPropertyFromCloudFormation(properties.ManifestPayload)), ret.addPropertyResult("applicationInstanceIdToReplace", "ApplicationInstanceIdToReplace", properties.ApplicationInstanceIdToReplace != null ? cfn_parse.FromCloudFormation.getString(properties.ApplicationInstanceIdToReplace) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("deviceId", "DeviceId", properties.DeviceId != null ? cfn_parse.FromCloudFormation.getString(properties.DeviceId) : void 0), ret.addPropertyResult("manifestOverridesPayload", "ManifestOverridesPayload", properties.ManifestOverridesPayload != null ? CfnApplicationInstanceManifestOverridesPayloadPropertyFromCloudFormation(properties.ManifestOverridesPayload) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("runtimeRoleArn", "RuntimeRoleArn", properties.RuntimeRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RuntimeRoleArn) : void 0), ret.addPropertyResult("statusFilter", "StatusFilter", properties.StatusFilter != null ? cfn_parse.FromCloudFormation.getString(properties.StatusFilter) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApplicationInstance = class _CfnApplicationInstance extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApplicationInstancePropsFromCloudFormation(resourceProperties), ret = new _CfnApplicationInstance(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApplicationInstance.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_panorama_CfnApplicationInstanceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApplicationInstance), error;
        }
        cdk.requireProperty(props, "defaultRuntimeContextDevice", this), cdk.requireProperty(props, "manifestPayload", this), this.attrApplicationInstanceId = cdk.Token.asString(this.getAtt("ApplicationInstanceId", cdk.ResolutionTypeHint.STRING)), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreatedTime = cdk.Token.asNumber(this.getAtt("CreatedTime", cdk.ResolutionTypeHint.NUMBER)), this.attrDefaultRuntimeContextDeviceName = cdk.Token.asString(this.getAtt("DefaultRuntimeContextDeviceName", cdk.ResolutionTypeHint.STRING)), this.attrHealthStatus = cdk.Token.asString(this.getAtt("HealthStatus", cdk.ResolutionTypeHint.STRING)), this.attrLastUpdatedTime = cdk.Token.asNumber(this.getAtt("LastUpdatedTime", cdk.ResolutionTypeHint.NUMBER)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.attrStatusDescription = cdk.Token.asString(this.getAtt("StatusDescription", cdk.ResolutionTypeHint.STRING)), this.defaultRuntimeContextDevice = props.defaultRuntimeContextDevice, this.manifestPayload = props.manifestPayload, this.applicationInstanceIdToReplace = props.applicationInstanceIdToReplace, this.description = props.description, this.deviceId = props.deviceId, this.manifestOverridesPayload = props.manifestOverridesPayload, this.name = props.name, this.runtimeRoleArn = props.runtimeRoleArn, this.statusFilter = props.statusFilter, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Panorama::ApplicationInstance", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApplicationInstance.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { defaultRuntimeContextDevice: this.defaultRuntimeContextDevice, manifestPayload: this.manifestPayload, applicationInstanceIdToReplace: this.applicationInstanceIdToReplace, description: this.description, deviceId: this.deviceId, manifestOverridesPayload: this.manifestOverridesPayload, name: this.name, runtimeRoleArn: this.runtimeRoleArn, statusFilter: this.statusFilter, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnApplicationInstancePropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnApplicationInstance[_a] = { fqn: "aws-cdk-lib.aws_panorama.CfnApplicationInstance", version: "2.80.0" }, CfnApplicationInstance.CFN_RESOURCE_TYPE_NAME = "AWS::Panorama::ApplicationInstance", exports2.CfnApplicationInstance = CfnApplicationInstance;
    function CfnApplicationInstance_ManifestOverridesPayloadPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("payloadData", cdk.validateString)(properties.payloadData)), errors.wrap('supplied properties not correct for "ManifestOverridesPayloadProperty"');
    }
    function cfnApplicationInstanceManifestOverridesPayloadPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationInstance_ManifestOverridesPayloadPropertyValidator(properties).assertSuccess(), { PayloadData: cdk.stringToCloudFormation(properties.payloadData) }) : properties;
    }
    function CfnApplicationInstanceManifestOverridesPayloadPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("payloadData", "PayloadData", properties.PayloadData != null ? cfn_parse.FromCloudFormation.getString(properties.PayloadData) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationInstance_ManifestPayloadPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("payloadData", cdk.validateString)(properties.payloadData)), errors.wrap('supplied properties not correct for "ManifestPayloadProperty"');
    }
    function cfnApplicationInstanceManifestPayloadPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationInstance_ManifestPayloadPropertyValidator(properties).assertSuccess(), { PayloadData: cdk.stringToCloudFormation(properties.payloadData) }) : properties;
    }
    function CfnApplicationInstanceManifestPayloadPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("payloadData", "PayloadData", properties.PayloadData != null ? cfn_parse.FromCloudFormation.getString(properties.PayloadData) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPackagePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("packageName", cdk.requiredValidator)(properties.packageName)), errors.collect(cdk.propertyValidator("packageName", cdk.validateString)(properties.packageName)), errors.collect(cdk.propertyValidator("storageLocation", CfnPackage_StorageLocationPropertyValidator)(properties.storageLocation)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnPackageProps"');
    }
    function cfnPackagePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPackagePropsValidator(properties).assertSuccess(), { PackageName: cdk.stringToCloudFormation(properties.packageName), StorageLocation: cfnPackageStorageLocationPropertyToCloudFormation(properties.storageLocation), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnPackagePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("packageName", "PackageName", cfn_parse.FromCloudFormation.getString(properties.PackageName)), ret.addPropertyResult("storageLocation", "StorageLocation", properties.StorageLocation != null ? CfnPackageStorageLocationPropertyFromCloudFormation(properties.StorageLocation) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPackage = class _CfnPackage extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPackagePropsFromCloudFormation(resourceProperties), ret = new _CfnPackage(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPackage.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_panorama_CfnPackageProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPackage), error;
        }
        cdk.requireProperty(props, "packageName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreatedTime = cdk.Token.asNumber(this.getAtt("CreatedTime", cdk.ResolutionTypeHint.NUMBER)), this.attrPackageId = cdk.Token.asString(this.getAtt("PackageId", cdk.ResolutionTypeHint.STRING)), this.attrStorageLocationBinaryPrefixLocation = cdk.Token.asString(this.getAtt("StorageLocation.BinaryPrefixLocation", cdk.ResolutionTypeHint.STRING)), this.attrStorageLocationBucket = cdk.Token.asString(this.getAtt("StorageLocation.Bucket", cdk.ResolutionTypeHint.STRING)), this.attrStorageLocationGeneratedPrefixLocation = cdk.Token.asString(this.getAtt("StorageLocation.GeneratedPrefixLocation", cdk.ResolutionTypeHint.STRING)), this.attrStorageLocationManifestPrefixLocation = cdk.Token.asString(this.getAtt("StorageLocation.ManifestPrefixLocation", cdk.ResolutionTypeHint.STRING)), this.attrStorageLocationRepoPrefixLocation = cdk.Token.asString(this.getAtt("StorageLocation.RepoPrefixLocation", cdk.ResolutionTypeHint.STRING)), this.packageName = props.packageName, this.storageLocation = props.storageLocation, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Panorama::Package", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPackage.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { packageName: this.packageName, storageLocation: this.storageLocation, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnPackagePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnPackage[_b] = { fqn: "aws-cdk-lib.aws_panorama.CfnPackage", version: "2.80.0" }, CfnPackage.CFN_RESOURCE_TYPE_NAME = "AWS::Panorama::Package", exports2.CfnPackage = CfnPackage;
    function CfnPackage_StorageLocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("binaryPrefixLocation", cdk.validateString)(properties.binaryPrefixLocation)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("generatedPrefixLocation", cdk.validateString)(properties.generatedPrefixLocation)), errors.collect(cdk.propertyValidator("manifestPrefixLocation", cdk.validateString)(properties.manifestPrefixLocation)), errors.collect(cdk.propertyValidator("repoPrefixLocation", cdk.validateString)(properties.repoPrefixLocation)), errors.wrap('supplied properties not correct for "StorageLocationProperty"');
    }
    function cfnPackageStorageLocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPackage_StorageLocationPropertyValidator(properties).assertSuccess(), { BinaryPrefixLocation: cdk.stringToCloudFormation(properties.binaryPrefixLocation), Bucket: cdk.stringToCloudFormation(properties.bucket), GeneratedPrefixLocation: cdk.stringToCloudFormation(properties.generatedPrefixLocation), ManifestPrefixLocation: cdk.stringToCloudFormation(properties.manifestPrefixLocation), RepoPrefixLocation: cdk.stringToCloudFormation(properties.repoPrefixLocation) }) : properties;
    }
    function CfnPackageStorageLocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("binaryPrefixLocation", "BinaryPrefixLocation", properties.BinaryPrefixLocation != null ? cfn_parse.FromCloudFormation.getString(properties.BinaryPrefixLocation) : void 0), ret.addPropertyResult("bucket", "Bucket", properties.Bucket != null ? cfn_parse.FromCloudFormation.getString(properties.Bucket) : void 0), ret.addPropertyResult("generatedPrefixLocation", "GeneratedPrefixLocation", properties.GeneratedPrefixLocation != null ? cfn_parse.FromCloudFormation.getString(properties.GeneratedPrefixLocation) : void 0), ret.addPropertyResult("manifestPrefixLocation", "ManifestPrefixLocation", properties.ManifestPrefixLocation != null ? cfn_parse.FromCloudFormation.getString(properties.ManifestPrefixLocation) : void 0), ret.addPropertyResult("repoPrefixLocation", "RepoPrefixLocation", properties.RepoPrefixLocation != null ? cfn_parse.FromCloudFormation.getString(properties.RepoPrefixLocation) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPackageVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("markLatest", cdk.validateBoolean)(properties.markLatest)), errors.collect(cdk.propertyValidator("ownerAccount", cdk.validateString)(properties.ownerAccount)), errors.collect(cdk.propertyValidator("packageId", cdk.requiredValidator)(properties.packageId)), errors.collect(cdk.propertyValidator("packageId", cdk.validateString)(properties.packageId)), errors.collect(cdk.propertyValidator("packageVersion", cdk.requiredValidator)(properties.packageVersion)), errors.collect(cdk.propertyValidator("packageVersion", cdk.validateString)(properties.packageVersion)), errors.collect(cdk.propertyValidator("patchVersion", cdk.requiredValidator)(properties.patchVersion)), errors.collect(cdk.propertyValidator("patchVersion", cdk.validateString)(properties.patchVersion)), errors.collect(cdk.propertyValidator("updatedLatestPatchVersion", cdk.validateString)(properties.updatedLatestPatchVersion)), errors.wrap('supplied properties not correct for "CfnPackageVersionProps"');
    }
    function cfnPackageVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPackageVersionPropsValidator(properties).assertSuccess(), { PackageId: cdk.stringToCloudFormation(properties.packageId), PackageVersion: cdk.stringToCloudFormation(properties.packageVersion), PatchVersion: cdk.stringToCloudFormation(properties.patchVersion), MarkLatest: cdk.booleanToCloudFormation(properties.markLatest), OwnerAccount: cdk.stringToCloudFormation(properties.ownerAccount), UpdatedLatestPatchVersion: cdk.stringToCloudFormation(properties.updatedLatestPatchVersion) }) : properties;
    }
    function CfnPackageVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("packageId", "PackageId", cfn_parse.FromCloudFormation.getString(properties.PackageId)), ret.addPropertyResult("packageVersion", "PackageVersion", cfn_parse.FromCloudFormation.getString(properties.PackageVersion)), ret.addPropertyResult("patchVersion", "PatchVersion", cfn_parse.FromCloudFormation.getString(properties.PatchVersion)), ret.addPropertyResult("markLatest", "MarkLatest", properties.MarkLatest != null ? cfn_parse.FromCloudFormation.getBoolean(properties.MarkLatest) : void 0), ret.addPropertyResult("ownerAccount", "OwnerAccount", properties.OwnerAccount != null ? cfn_parse.FromCloudFormation.getString(properties.OwnerAccount) : void 0), ret.addPropertyResult("updatedLatestPatchVersion", "UpdatedLatestPatchVersion", properties.UpdatedLatestPatchVersion != null ? cfn_parse.FromCloudFormation.getString(properties.UpdatedLatestPatchVersion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPackageVersion = class _CfnPackageVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPackageVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnPackageVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPackageVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_panorama_CfnPackageVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPackageVersion), error;
        }
        cdk.requireProperty(props, "packageId", this), cdk.requireProperty(props, "packageVersion", this), cdk.requireProperty(props, "patchVersion", this), this.attrIsLatestPatch = this.getAtt("IsLatestPatch", cdk.ResolutionTypeHint.STRING), this.attrPackageArn = cdk.Token.asString(this.getAtt("PackageArn", cdk.ResolutionTypeHint.STRING)), this.attrPackageName = cdk.Token.asString(this.getAtt("PackageName", cdk.ResolutionTypeHint.STRING)), this.attrRegisteredTime = cdk.Token.asNumber(this.getAtt("RegisteredTime", cdk.ResolutionTypeHint.NUMBER)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.attrStatusDescription = cdk.Token.asString(this.getAtt("StatusDescription", cdk.ResolutionTypeHint.STRING)), this.packageId = props.packageId, this.packageVersion = props.packageVersion, this.patchVersion = props.patchVersion, this.markLatest = props.markLatest, this.ownerAccount = props.ownerAccount, this.updatedLatestPatchVersion = props.updatedLatestPatchVersion;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPackageVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { packageId: this.packageId, packageVersion: this.packageVersion, patchVersion: this.patchVersion, markLatest: this.markLatest, ownerAccount: this.ownerAccount, updatedLatestPatchVersion: this.updatedLatestPatchVersion };
      }
      renderProperties(props) {
        return cfnPackageVersionPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnPackageVersion[_c] = { fqn: "aws-cdk-lib.aws_panorama.CfnPackageVersion", version: "2.80.0" }, CfnPackageVersion.CFN_RESOURCE_TYPE_NAME = "AWS::Panorama::PackageVersion", exports2.CfnPackageVersion = CfnPackageVersion;
  }
});

// node_modules/aws-cdk-lib/aws-panorama/lib/index.js
var require_lib207 = __commonJS({
  "node_modules/aws-cdk-lib/aws-panorama/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_panorama_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-panorama/index.js
var require_aws_panorama = __commonJS({
  "node_modules/aws-cdk-lib/aws-panorama/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib207(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-personalize/lib/personalize.generated.js
var require_personalize_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-personalize/lib/personalize.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnSolution = exports2.CfnSchema = exports2.CfnDatasetGroup = exports2.CfnDataset = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnDatasetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("datasetGroupArn", cdk.requiredValidator)(properties.datasetGroupArn)), errors.collect(cdk.propertyValidator("datasetGroupArn", cdk.validateString)(properties.datasetGroupArn)), errors.collect(cdk.propertyValidator("datasetImportJob", CfnDataset_DatasetImportJobPropertyValidator)(properties.datasetImportJob)), errors.collect(cdk.propertyValidator("datasetType", cdk.requiredValidator)(properties.datasetType)), errors.collect(cdk.propertyValidator("datasetType", cdk.validateString)(properties.datasetType)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("schemaArn", cdk.requiredValidator)(properties.schemaArn)), errors.collect(cdk.propertyValidator("schemaArn", cdk.validateString)(properties.schemaArn)), errors.wrap('supplied properties not correct for "CfnDatasetProps"');
    }
    function cfnDatasetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDatasetPropsValidator(properties).assertSuccess(), { DatasetGroupArn: cdk.stringToCloudFormation(properties.datasetGroupArn), DatasetType: cdk.stringToCloudFormation(properties.datasetType), Name: cdk.stringToCloudFormation(properties.name), SchemaArn: cdk.stringToCloudFormation(properties.schemaArn), DatasetImportJob: cfnDatasetDatasetImportJobPropertyToCloudFormation(properties.datasetImportJob) }) : properties;
    }
    function CfnDatasetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("datasetGroupArn", "DatasetGroupArn", cfn_parse.FromCloudFormation.getString(properties.DatasetGroupArn)), ret.addPropertyResult("datasetType", "DatasetType", cfn_parse.FromCloudFormation.getString(properties.DatasetType)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("schemaArn", "SchemaArn", cfn_parse.FromCloudFormation.getString(properties.SchemaArn)), ret.addPropertyResult("datasetImportJob", "DatasetImportJob", properties.DatasetImportJob != null ? CfnDatasetDatasetImportJobPropertyFromCloudFormation(properties.DatasetImportJob) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDataset = class _CfnDataset extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDatasetPropsFromCloudFormation(resourceProperties), ret = new _CfnDataset(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDataset.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_personalize_CfnDatasetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDataset), error;
        }
        cdk.requireProperty(props, "datasetGroupArn", this), cdk.requireProperty(props, "datasetType", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "schemaArn", this), this.attrDatasetArn = cdk.Token.asString(this.getAtt("DatasetArn", cdk.ResolutionTypeHint.STRING)), this.datasetGroupArn = props.datasetGroupArn, this.datasetType = props.datasetType, this.name = props.name, this.schemaArn = props.schemaArn, this.datasetImportJob = props.datasetImportJob;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDataset.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { datasetGroupArn: this.datasetGroupArn, datasetType: this.datasetType, name: this.name, schemaArn: this.schemaArn, datasetImportJob: this.datasetImportJob };
      }
      renderProperties(props) {
        return cfnDatasetPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnDataset[_a] = { fqn: "aws-cdk-lib.aws_personalize.CfnDataset", version: "2.80.0" }, CfnDataset.CFN_RESOURCE_TYPE_NAME = "AWS::Personalize::Dataset", exports2.CfnDataset = CfnDataset;
    function CfnDataset_DatasetImportJobPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataSource", cdk.validateObject)(properties.dataSource)), errors.collect(cdk.propertyValidator("datasetArn", cdk.validateString)(properties.datasetArn)), errors.collect(cdk.propertyValidator("datasetImportJobArn", cdk.validateString)(properties.datasetImportJobArn)), errors.collect(cdk.propertyValidator("jobName", cdk.validateString)(properties.jobName)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "DatasetImportJobProperty"');
    }
    function cfnDatasetDatasetImportJobPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataset_DatasetImportJobPropertyValidator(properties).assertSuccess(), { DataSource: cdk.objectToCloudFormation(properties.dataSource), DatasetArn: cdk.stringToCloudFormation(properties.datasetArn), DatasetImportJobArn: cdk.stringToCloudFormation(properties.datasetImportJobArn), JobName: cdk.stringToCloudFormation(properties.jobName), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnDatasetDatasetImportJobPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataSource", "DataSource", properties.DataSource != null ? cfn_parse.FromCloudFormation.getAny(properties.DataSource) : void 0), ret.addPropertyResult("datasetArn", "DatasetArn", properties.DatasetArn != null ? cfn_parse.FromCloudFormation.getString(properties.DatasetArn) : void 0), ret.addPropertyResult("datasetImportJobArn", "DatasetImportJobArn", properties.DatasetImportJobArn != null ? cfn_parse.FromCloudFormation.getString(properties.DatasetImportJobArn) : void 0), ret.addPropertyResult("jobName", "JobName", properties.JobName != null ? cfn_parse.FromCloudFormation.getString(properties.JobName) : void 0), ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDatasetGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("domain", cdk.validateString)(properties.domain)), errors.collect(cdk.propertyValidator("kmsKeyArn", cdk.validateString)(properties.kmsKeyArn)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "CfnDatasetGroupProps"');
    }
    function cfnDatasetGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDatasetGroupPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Domain: cdk.stringToCloudFormation(properties.domain), KmsKeyArn: cdk.stringToCloudFormation(properties.kmsKeyArn), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnDatasetGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("domain", "Domain", properties.Domain != null ? cfn_parse.FromCloudFormation.getString(properties.Domain) : void 0), ret.addPropertyResult("kmsKeyArn", "KmsKeyArn", properties.KmsKeyArn != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyArn) : void 0), ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDatasetGroup = class _CfnDatasetGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDatasetGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnDatasetGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDatasetGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_personalize_CfnDatasetGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDatasetGroup), error;
        }
        cdk.requireProperty(props, "name", this), this.attrDatasetGroupArn = cdk.Token.asString(this.getAtt("DatasetGroupArn", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.domain = props.domain, this.kmsKeyArn = props.kmsKeyArn, this.roleArn = props.roleArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDatasetGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, domain: this.domain, kmsKeyArn: this.kmsKeyArn, roleArn: this.roleArn };
      }
      renderProperties(props) {
        return cfnDatasetGroupPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnDatasetGroup[_b] = { fqn: "aws-cdk-lib.aws_personalize.CfnDatasetGroup", version: "2.80.0" }, CfnDatasetGroup.CFN_RESOURCE_TYPE_NAME = "AWS::Personalize::DatasetGroup", exports2.CfnDatasetGroup = CfnDatasetGroup;
    function CfnSchemaPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("domain", cdk.validateString)(properties.domain)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("schema", cdk.requiredValidator)(properties.schema)), errors.collect(cdk.propertyValidator("schema", cdk.validateString)(properties.schema)), errors.wrap('supplied properties not correct for "CfnSchemaProps"');
    }
    function cfnSchemaPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSchemaPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Schema: cdk.stringToCloudFormation(properties.schema), Domain: cdk.stringToCloudFormation(properties.domain) }) : properties;
    }
    function CfnSchemaPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("schema", "Schema", cfn_parse.FromCloudFormation.getString(properties.Schema)), ret.addPropertyResult("domain", "Domain", properties.Domain != null ? cfn_parse.FromCloudFormation.getString(properties.Domain) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSchema = class _CfnSchema extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSchemaPropsFromCloudFormation(resourceProperties), ret = new _CfnSchema(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSchema.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_personalize_CfnSchemaProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSchema), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "schema", this), this.attrSchemaArn = cdk.Token.asString(this.getAtt("SchemaArn", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.schema = props.schema, this.domain = props.domain;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSchema.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, schema: this.schema, domain: this.domain };
      }
      renderProperties(props) {
        return cfnSchemaPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnSchema[_c] = { fqn: "aws-cdk-lib.aws_personalize.CfnSchema", version: "2.80.0" }, CfnSchema.CFN_RESOURCE_TYPE_NAME = "AWS::Personalize::Schema", exports2.CfnSchema = CfnSchema;
    function CfnSolutionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("datasetGroupArn", cdk.requiredValidator)(properties.datasetGroupArn)), errors.collect(cdk.propertyValidator("datasetGroupArn", cdk.validateString)(properties.datasetGroupArn)), errors.collect(cdk.propertyValidator("eventType", cdk.validateString)(properties.eventType)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("performAutoMl", cdk.validateBoolean)(properties.performAutoMl)), errors.collect(cdk.propertyValidator("performHpo", cdk.validateBoolean)(properties.performHpo)), errors.collect(cdk.propertyValidator("recipeArn", cdk.validateString)(properties.recipeArn)), errors.collect(cdk.propertyValidator("solutionConfig", CfnSolution_SolutionConfigPropertyValidator)(properties.solutionConfig)), errors.wrap('supplied properties not correct for "CfnSolutionProps"');
    }
    function cfnSolutionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSolutionPropsValidator(properties).assertSuccess(), { DatasetGroupArn: cdk.stringToCloudFormation(properties.datasetGroupArn), Name: cdk.stringToCloudFormation(properties.name), EventType: cdk.stringToCloudFormation(properties.eventType), PerformAutoML: cdk.booleanToCloudFormation(properties.performAutoMl), PerformHPO: cdk.booleanToCloudFormation(properties.performHpo), RecipeArn: cdk.stringToCloudFormation(properties.recipeArn), SolutionConfig: cfnSolutionSolutionConfigPropertyToCloudFormation(properties.solutionConfig) }) : properties;
    }
    function CfnSolutionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("datasetGroupArn", "DatasetGroupArn", cfn_parse.FromCloudFormation.getString(properties.DatasetGroupArn)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("eventType", "EventType", properties.EventType != null ? cfn_parse.FromCloudFormation.getString(properties.EventType) : void 0), ret.addPropertyResult("performAutoMl", "PerformAutoML", properties.PerformAutoML != null ? cfn_parse.FromCloudFormation.getBoolean(properties.PerformAutoML) : void 0), ret.addPropertyResult("performHpo", "PerformHPO", properties.PerformHPO != null ? cfn_parse.FromCloudFormation.getBoolean(properties.PerformHPO) : void 0), ret.addPropertyResult("recipeArn", "RecipeArn", properties.RecipeArn != null ? cfn_parse.FromCloudFormation.getString(properties.RecipeArn) : void 0), ret.addPropertyResult("solutionConfig", "SolutionConfig", properties.SolutionConfig != null ? CfnSolutionSolutionConfigPropertyFromCloudFormation(properties.SolutionConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSolution = class _CfnSolution extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSolutionPropsFromCloudFormation(resourceProperties), ret = new _CfnSolution(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSolution.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_personalize_CfnSolutionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSolution), error;
        }
        cdk.requireProperty(props, "datasetGroupArn", this), cdk.requireProperty(props, "name", this), this.attrSolutionArn = cdk.Token.asString(this.getAtt("SolutionArn", cdk.ResolutionTypeHint.STRING)), this.datasetGroupArn = props.datasetGroupArn, this.name = props.name, this.eventType = props.eventType, this.performAutoMl = props.performAutoMl, this.performHpo = props.performHpo, this.recipeArn = props.recipeArn, this.solutionConfig = props.solutionConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSolution.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { datasetGroupArn: this.datasetGroupArn, name: this.name, eventType: this.eventType, performAutoMl: this.performAutoMl, performHpo: this.performHpo, recipeArn: this.recipeArn, solutionConfig: this.solutionConfig };
      }
      renderProperties(props) {
        return cfnSolutionPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnSolution[_d] = { fqn: "aws-cdk-lib.aws_personalize.CfnSolution", version: "2.80.0" }, CfnSolution.CFN_RESOURCE_TYPE_NAME = "AWS::Personalize::Solution", exports2.CfnSolution = CfnSolution;
    function CfnSolution_SolutionConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("algorithmHyperParameters", cdk.hashValidator(cdk.validateString))(properties.algorithmHyperParameters)), errors.collect(cdk.propertyValidator("autoMlConfig", cdk.validateObject)(properties.autoMlConfig)), errors.collect(cdk.propertyValidator("eventValueThreshold", cdk.validateString)(properties.eventValueThreshold)), errors.collect(cdk.propertyValidator("featureTransformationParameters", cdk.hashValidator(cdk.validateString))(properties.featureTransformationParameters)), errors.collect(cdk.propertyValidator("hpoConfig", cdk.validateObject)(properties.hpoConfig)), errors.wrap('supplied properties not correct for "SolutionConfigProperty"');
    }
    function cfnSolutionSolutionConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSolution_SolutionConfigPropertyValidator(properties).assertSuccess(), { AlgorithmHyperParameters: cdk.hashMapper(cdk.stringToCloudFormation)(properties.algorithmHyperParameters), AutoMLConfig: cdk.objectToCloudFormation(properties.autoMlConfig), EventValueThreshold: cdk.stringToCloudFormation(properties.eventValueThreshold), FeatureTransformationParameters: cdk.hashMapper(cdk.stringToCloudFormation)(properties.featureTransformationParameters), HpoConfig: cdk.objectToCloudFormation(properties.hpoConfig) }) : properties;
    }
    function CfnSolutionSolutionConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("algorithmHyperParameters", "AlgorithmHyperParameters", properties.AlgorithmHyperParameters != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.AlgorithmHyperParameters) : void 0), ret.addPropertyResult("autoMlConfig", "AutoMLConfig", properties.AutoMLConfig != null ? cfn_parse.FromCloudFormation.getAny(properties.AutoMLConfig) : void 0), ret.addPropertyResult("eventValueThreshold", "EventValueThreshold", properties.EventValueThreshold != null ? cfn_parse.FromCloudFormation.getString(properties.EventValueThreshold) : void 0), ret.addPropertyResult("featureTransformationParameters", "FeatureTransformationParameters", properties.FeatureTransformationParameters != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.FeatureTransformationParameters) : void 0), ret.addPropertyResult("hpoConfig", "HpoConfig", properties.HpoConfig != null ? cfn_parse.FromCloudFormation.getAny(properties.HpoConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-personalize/lib/index.js
var require_lib208 = __commonJS({
  "node_modules/aws-cdk-lib/aws-personalize/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_personalize_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-personalize/index.js
var require_aws_personalize = __commonJS({
  "node_modules/aws-cdk-lib/aws-personalize/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib208(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-pinpoint/lib/pinpoint.generated.js
var require_pinpoint_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-pinpoint/lib/pinpoint.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    var _l;
    var _m;
    var _o;
    var _p;
    var _q;
    var _r;
    var _s;
    var _t;
    var _u;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnVoiceChannel = exports2.CfnSmsTemplate = exports2.CfnSegment = exports2.CfnSMSChannel = exports2.CfnPushTemplate = exports2.CfnInAppTemplate = exports2.CfnGCMChannel = exports2.CfnEventStream = exports2.CfnEmailTemplate = exports2.CfnEmailChannel = exports2.CfnCampaign = exports2.CfnBaiduChannel = exports2.CfnApplicationSettings = exports2.CfnApp = exports2.CfnAPNSVoipSandboxChannel = exports2.CfnAPNSVoipChannel = exports2.CfnAPNSSandboxChannel = exports2.CfnAPNSChannel = exports2.CfnADMChannel = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnADMChannelPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationId", cdk.requiredValidator)(properties.applicationId)), errors.collect(cdk.propertyValidator("applicationId", cdk.validateString)(properties.applicationId)), errors.collect(cdk.propertyValidator("clientId", cdk.requiredValidator)(properties.clientId)), errors.collect(cdk.propertyValidator("clientId", cdk.validateString)(properties.clientId)), errors.collect(cdk.propertyValidator("clientSecret", cdk.requiredValidator)(properties.clientSecret)), errors.collect(cdk.propertyValidator("clientSecret", cdk.validateString)(properties.clientSecret)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "CfnADMChannelProps"');
    }
    function cfnADMChannelPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnADMChannelPropsValidator(properties).assertSuccess(), { ApplicationId: cdk.stringToCloudFormation(properties.applicationId), ClientId: cdk.stringToCloudFormation(properties.clientId), ClientSecret: cdk.stringToCloudFormation(properties.clientSecret), Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnADMChannelPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationId", "ApplicationId", cfn_parse.FromCloudFormation.getString(properties.ApplicationId)), ret.addPropertyResult("clientId", "ClientId", cfn_parse.FromCloudFormation.getString(properties.ClientId)), ret.addPropertyResult("clientSecret", "ClientSecret", cfn_parse.FromCloudFormation.getString(properties.ClientSecret)), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnADMChannel = class _CfnADMChannel extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnADMChannelPropsFromCloudFormation(resourceProperties), ret = new _CfnADMChannel(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnADMChannel.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_pinpoint_CfnADMChannelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnADMChannel), error;
        }
        cdk.requireProperty(props, "applicationId", this), cdk.requireProperty(props, "clientId", this), cdk.requireProperty(props, "clientSecret", this), this.applicationId = props.applicationId, this.clientId = props.clientId, this.clientSecret = props.clientSecret, this.enabled = props.enabled;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnADMChannel.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationId: this.applicationId, clientId: this.clientId, clientSecret: this.clientSecret, enabled: this.enabled };
      }
      renderProperties(props) {
        return cfnADMChannelPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnADMChannel[_a] = { fqn: "aws-cdk-lib.aws_pinpoint.CfnADMChannel", version: "2.80.0" }, CfnADMChannel.CFN_RESOURCE_TYPE_NAME = "AWS::Pinpoint::ADMChannel", exports2.CfnADMChannel = CfnADMChannel;
    function CfnAPNSChannelPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationId", cdk.requiredValidator)(properties.applicationId)), errors.collect(cdk.propertyValidator("applicationId", cdk.validateString)(properties.applicationId)), errors.collect(cdk.propertyValidator("bundleId", cdk.validateString)(properties.bundleId)), errors.collect(cdk.propertyValidator("certificate", cdk.validateString)(properties.certificate)), errors.collect(cdk.propertyValidator("defaultAuthenticationMethod", cdk.validateString)(properties.defaultAuthenticationMethod)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("privateKey", cdk.validateString)(properties.privateKey)), errors.collect(cdk.propertyValidator("teamId", cdk.validateString)(properties.teamId)), errors.collect(cdk.propertyValidator("tokenKey", cdk.validateString)(properties.tokenKey)), errors.collect(cdk.propertyValidator("tokenKeyId", cdk.validateString)(properties.tokenKeyId)), errors.wrap('supplied properties not correct for "CfnAPNSChannelProps"');
    }
    function cfnAPNSChannelPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAPNSChannelPropsValidator(properties).assertSuccess(), { ApplicationId: cdk.stringToCloudFormation(properties.applicationId), BundleId: cdk.stringToCloudFormation(properties.bundleId), Certificate: cdk.stringToCloudFormation(properties.certificate), DefaultAuthenticationMethod: cdk.stringToCloudFormation(properties.defaultAuthenticationMethod), Enabled: cdk.booleanToCloudFormation(properties.enabled), PrivateKey: cdk.stringToCloudFormation(properties.privateKey), TeamId: cdk.stringToCloudFormation(properties.teamId), TokenKey: cdk.stringToCloudFormation(properties.tokenKey), TokenKeyId: cdk.stringToCloudFormation(properties.tokenKeyId) }) : properties;
    }
    function CfnAPNSChannelPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationId", "ApplicationId", cfn_parse.FromCloudFormation.getString(properties.ApplicationId)), ret.addPropertyResult("bundleId", "BundleId", properties.BundleId != null ? cfn_parse.FromCloudFormation.getString(properties.BundleId) : void 0), ret.addPropertyResult("certificate", "Certificate", properties.Certificate != null ? cfn_parse.FromCloudFormation.getString(properties.Certificate) : void 0), ret.addPropertyResult("defaultAuthenticationMethod", "DefaultAuthenticationMethod", properties.DefaultAuthenticationMethod != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultAuthenticationMethod) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("privateKey", "PrivateKey", properties.PrivateKey != null ? cfn_parse.FromCloudFormation.getString(properties.PrivateKey) : void 0), ret.addPropertyResult("teamId", "TeamId", properties.TeamId != null ? cfn_parse.FromCloudFormation.getString(properties.TeamId) : void 0), ret.addPropertyResult("tokenKey", "TokenKey", properties.TokenKey != null ? cfn_parse.FromCloudFormation.getString(properties.TokenKey) : void 0), ret.addPropertyResult("tokenKeyId", "TokenKeyId", properties.TokenKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.TokenKeyId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAPNSChannel = class _CfnAPNSChannel extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAPNSChannelPropsFromCloudFormation(resourceProperties), ret = new _CfnAPNSChannel(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAPNSChannel.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_pinpoint_CfnAPNSChannelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAPNSChannel), error;
        }
        cdk.requireProperty(props, "applicationId", this), this.applicationId = props.applicationId, this.bundleId = props.bundleId, this.certificate = props.certificate, this.defaultAuthenticationMethod = props.defaultAuthenticationMethod, this.enabled = props.enabled, this.privateKey = props.privateKey, this.teamId = props.teamId, this.tokenKey = props.tokenKey, this.tokenKeyId = props.tokenKeyId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAPNSChannel.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationId: this.applicationId, bundleId: this.bundleId, certificate: this.certificate, defaultAuthenticationMethod: this.defaultAuthenticationMethod, enabled: this.enabled, privateKey: this.privateKey, teamId: this.teamId, tokenKey: this.tokenKey, tokenKeyId: this.tokenKeyId };
      }
      renderProperties(props) {
        return cfnAPNSChannelPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnAPNSChannel[_b] = { fqn: "aws-cdk-lib.aws_pinpoint.CfnAPNSChannel", version: "2.80.0" }, CfnAPNSChannel.CFN_RESOURCE_TYPE_NAME = "AWS::Pinpoint::APNSChannel", exports2.CfnAPNSChannel = CfnAPNSChannel;
    function CfnAPNSSandboxChannelPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationId", cdk.requiredValidator)(properties.applicationId)), errors.collect(cdk.propertyValidator("applicationId", cdk.validateString)(properties.applicationId)), errors.collect(cdk.propertyValidator("bundleId", cdk.validateString)(properties.bundleId)), errors.collect(cdk.propertyValidator("certificate", cdk.validateString)(properties.certificate)), errors.collect(cdk.propertyValidator("defaultAuthenticationMethod", cdk.validateString)(properties.defaultAuthenticationMethod)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("privateKey", cdk.validateString)(properties.privateKey)), errors.collect(cdk.propertyValidator("teamId", cdk.validateString)(properties.teamId)), errors.collect(cdk.propertyValidator("tokenKey", cdk.validateString)(properties.tokenKey)), errors.collect(cdk.propertyValidator("tokenKeyId", cdk.validateString)(properties.tokenKeyId)), errors.wrap('supplied properties not correct for "CfnAPNSSandboxChannelProps"');
    }
    function cfnAPNSSandboxChannelPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAPNSSandboxChannelPropsValidator(properties).assertSuccess(), { ApplicationId: cdk.stringToCloudFormation(properties.applicationId), BundleId: cdk.stringToCloudFormation(properties.bundleId), Certificate: cdk.stringToCloudFormation(properties.certificate), DefaultAuthenticationMethod: cdk.stringToCloudFormation(properties.defaultAuthenticationMethod), Enabled: cdk.booleanToCloudFormation(properties.enabled), PrivateKey: cdk.stringToCloudFormation(properties.privateKey), TeamId: cdk.stringToCloudFormation(properties.teamId), TokenKey: cdk.stringToCloudFormation(properties.tokenKey), TokenKeyId: cdk.stringToCloudFormation(properties.tokenKeyId) }) : properties;
    }
    function CfnAPNSSandboxChannelPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationId", "ApplicationId", cfn_parse.FromCloudFormation.getString(properties.ApplicationId)), ret.addPropertyResult("bundleId", "BundleId", properties.BundleId != null ? cfn_parse.FromCloudFormation.getString(properties.BundleId) : void 0), ret.addPropertyResult("certificate", "Certificate", properties.Certificate != null ? cfn_parse.FromCloudFormation.getString(properties.Certificate) : void 0), ret.addPropertyResult("defaultAuthenticationMethod", "DefaultAuthenticationMethod", properties.DefaultAuthenticationMethod != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultAuthenticationMethod) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("privateKey", "PrivateKey", properties.PrivateKey != null ? cfn_parse.FromCloudFormation.getString(properties.PrivateKey) : void 0), ret.addPropertyResult("teamId", "TeamId", properties.TeamId != null ? cfn_parse.FromCloudFormation.getString(properties.TeamId) : void 0), ret.addPropertyResult("tokenKey", "TokenKey", properties.TokenKey != null ? cfn_parse.FromCloudFormation.getString(properties.TokenKey) : void 0), ret.addPropertyResult("tokenKeyId", "TokenKeyId", properties.TokenKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.TokenKeyId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAPNSSandboxChannel = class _CfnAPNSSandboxChannel extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAPNSSandboxChannelPropsFromCloudFormation(resourceProperties), ret = new _CfnAPNSSandboxChannel(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAPNSSandboxChannel.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_pinpoint_CfnAPNSSandboxChannelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAPNSSandboxChannel), error;
        }
        cdk.requireProperty(props, "applicationId", this), this.applicationId = props.applicationId, this.bundleId = props.bundleId, this.certificate = props.certificate, this.defaultAuthenticationMethod = props.defaultAuthenticationMethod, this.enabled = props.enabled, this.privateKey = props.privateKey, this.teamId = props.teamId, this.tokenKey = props.tokenKey, this.tokenKeyId = props.tokenKeyId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAPNSSandboxChannel.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationId: this.applicationId, bundleId: this.bundleId, certificate: this.certificate, defaultAuthenticationMethod: this.defaultAuthenticationMethod, enabled: this.enabled, privateKey: this.privateKey, teamId: this.teamId, tokenKey: this.tokenKey, tokenKeyId: this.tokenKeyId };
      }
      renderProperties(props) {
        return cfnAPNSSandboxChannelPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnAPNSSandboxChannel[_c] = { fqn: "aws-cdk-lib.aws_pinpoint.CfnAPNSSandboxChannel", version: "2.80.0" }, CfnAPNSSandboxChannel.CFN_RESOURCE_TYPE_NAME = "AWS::Pinpoint::APNSSandboxChannel", exports2.CfnAPNSSandboxChannel = CfnAPNSSandboxChannel;
    function CfnAPNSVoipChannelPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationId", cdk.requiredValidator)(properties.applicationId)), errors.collect(cdk.propertyValidator("applicationId", cdk.validateString)(properties.applicationId)), errors.collect(cdk.propertyValidator("bundleId", cdk.validateString)(properties.bundleId)), errors.collect(cdk.propertyValidator("certificate", cdk.validateString)(properties.certificate)), errors.collect(cdk.propertyValidator("defaultAuthenticationMethod", cdk.validateString)(properties.defaultAuthenticationMethod)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("privateKey", cdk.validateString)(properties.privateKey)), errors.collect(cdk.propertyValidator("teamId", cdk.validateString)(properties.teamId)), errors.collect(cdk.propertyValidator("tokenKey", cdk.validateString)(properties.tokenKey)), errors.collect(cdk.propertyValidator("tokenKeyId", cdk.validateString)(properties.tokenKeyId)), errors.wrap('supplied properties not correct for "CfnAPNSVoipChannelProps"');
    }
    function cfnAPNSVoipChannelPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAPNSVoipChannelPropsValidator(properties).assertSuccess(), { ApplicationId: cdk.stringToCloudFormation(properties.applicationId), BundleId: cdk.stringToCloudFormation(properties.bundleId), Certificate: cdk.stringToCloudFormation(properties.certificate), DefaultAuthenticationMethod: cdk.stringToCloudFormation(properties.defaultAuthenticationMethod), Enabled: cdk.booleanToCloudFormation(properties.enabled), PrivateKey: cdk.stringToCloudFormation(properties.privateKey), TeamId: cdk.stringToCloudFormation(properties.teamId), TokenKey: cdk.stringToCloudFormation(properties.tokenKey), TokenKeyId: cdk.stringToCloudFormation(properties.tokenKeyId) }) : properties;
    }
    function CfnAPNSVoipChannelPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationId", "ApplicationId", cfn_parse.FromCloudFormation.getString(properties.ApplicationId)), ret.addPropertyResult("bundleId", "BundleId", properties.BundleId != null ? cfn_parse.FromCloudFormation.getString(properties.BundleId) : void 0), ret.addPropertyResult("certificate", "Certificate", properties.Certificate != null ? cfn_parse.FromCloudFormation.getString(properties.Certificate) : void 0), ret.addPropertyResult("defaultAuthenticationMethod", "DefaultAuthenticationMethod", properties.DefaultAuthenticationMethod != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultAuthenticationMethod) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("privateKey", "PrivateKey", properties.PrivateKey != null ? cfn_parse.FromCloudFormation.getString(properties.PrivateKey) : void 0), ret.addPropertyResult("teamId", "TeamId", properties.TeamId != null ? cfn_parse.FromCloudFormation.getString(properties.TeamId) : void 0), ret.addPropertyResult("tokenKey", "TokenKey", properties.TokenKey != null ? cfn_parse.FromCloudFormation.getString(properties.TokenKey) : void 0), ret.addPropertyResult("tokenKeyId", "TokenKeyId", properties.TokenKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.TokenKeyId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAPNSVoipChannel = class _CfnAPNSVoipChannel extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAPNSVoipChannelPropsFromCloudFormation(resourceProperties), ret = new _CfnAPNSVoipChannel(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAPNSVoipChannel.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_pinpoint_CfnAPNSVoipChannelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAPNSVoipChannel), error;
        }
        cdk.requireProperty(props, "applicationId", this), this.applicationId = props.applicationId, this.bundleId = props.bundleId, this.certificate = props.certificate, this.defaultAuthenticationMethod = props.defaultAuthenticationMethod, this.enabled = props.enabled, this.privateKey = props.privateKey, this.teamId = props.teamId, this.tokenKey = props.tokenKey, this.tokenKeyId = props.tokenKeyId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAPNSVoipChannel.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationId: this.applicationId, bundleId: this.bundleId, certificate: this.certificate, defaultAuthenticationMethod: this.defaultAuthenticationMethod, enabled: this.enabled, privateKey: this.privateKey, teamId: this.teamId, tokenKey: this.tokenKey, tokenKeyId: this.tokenKeyId };
      }
      renderProperties(props) {
        return cfnAPNSVoipChannelPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnAPNSVoipChannel[_d] = { fqn: "aws-cdk-lib.aws_pinpoint.CfnAPNSVoipChannel", version: "2.80.0" }, CfnAPNSVoipChannel.CFN_RESOURCE_TYPE_NAME = "AWS::Pinpoint::APNSVoipChannel", exports2.CfnAPNSVoipChannel = CfnAPNSVoipChannel;
    function CfnAPNSVoipSandboxChannelPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationId", cdk.requiredValidator)(properties.applicationId)), errors.collect(cdk.propertyValidator("applicationId", cdk.validateString)(properties.applicationId)), errors.collect(cdk.propertyValidator("bundleId", cdk.validateString)(properties.bundleId)), errors.collect(cdk.propertyValidator("certificate", cdk.validateString)(properties.certificate)), errors.collect(cdk.propertyValidator("defaultAuthenticationMethod", cdk.validateString)(properties.defaultAuthenticationMethod)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("privateKey", cdk.validateString)(properties.privateKey)), errors.collect(cdk.propertyValidator("teamId", cdk.validateString)(properties.teamId)), errors.collect(cdk.propertyValidator("tokenKey", cdk.validateString)(properties.tokenKey)), errors.collect(cdk.propertyValidator("tokenKeyId", cdk.validateString)(properties.tokenKeyId)), errors.wrap('supplied properties not correct for "CfnAPNSVoipSandboxChannelProps"');
    }
    function cfnAPNSVoipSandboxChannelPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAPNSVoipSandboxChannelPropsValidator(properties).assertSuccess(), { ApplicationId: cdk.stringToCloudFormation(properties.applicationId), BundleId: cdk.stringToCloudFormation(properties.bundleId), Certificate: cdk.stringToCloudFormation(properties.certificate), DefaultAuthenticationMethod: cdk.stringToCloudFormation(properties.defaultAuthenticationMethod), Enabled: cdk.booleanToCloudFormation(properties.enabled), PrivateKey: cdk.stringToCloudFormation(properties.privateKey), TeamId: cdk.stringToCloudFormation(properties.teamId), TokenKey: cdk.stringToCloudFormation(properties.tokenKey), TokenKeyId: cdk.stringToCloudFormation(properties.tokenKeyId) }) : properties;
    }
    function CfnAPNSVoipSandboxChannelPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationId", "ApplicationId", cfn_parse.FromCloudFormation.getString(properties.ApplicationId)), ret.addPropertyResult("bundleId", "BundleId", properties.BundleId != null ? cfn_parse.FromCloudFormation.getString(properties.BundleId) : void 0), ret.addPropertyResult("certificate", "Certificate", properties.Certificate != null ? cfn_parse.FromCloudFormation.getString(properties.Certificate) : void 0), ret.addPropertyResult("defaultAuthenticationMethod", "DefaultAuthenticationMethod", properties.DefaultAuthenticationMethod != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultAuthenticationMethod) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("privateKey", "PrivateKey", properties.PrivateKey != null ? cfn_parse.FromCloudFormation.getString(properties.PrivateKey) : void 0), ret.addPropertyResult("teamId", "TeamId", properties.TeamId != null ? cfn_parse.FromCloudFormation.getString(properties.TeamId) : void 0), ret.addPropertyResult("tokenKey", "TokenKey", properties.TokenKey != null ? cfn_parse.FromCloudFormation.getString(properties.TokenKey) : void 0), ret.addPropertyResult("tokenKeyId", "TokenKeyId", properties.TokenKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.TokenKeyId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAPNSVoipSandboxChannel = class _CfnAPNSVoipSandboxChannel extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAPNSVoipSandboxChannelPropsFromCloudFormation(resourceProperties), ret = new _CfnAPNSVoipSandboxChannel(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAPNSVoipSandboxChannel.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_pinpoint_CfnAPNSVoipSandboxChannelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAPNSVoipSandboxChannel), error;
        }
        cdk.requireProperty(props, "applicationId", this), this.applicationId = props.applicationId, this.bundleId = props.bundleId, this.certificate = props.certificate, this.defaultAuthenticationMethod = props.defaultAuthenticationMethod, this.enabled = props.enabled, this.privateKey = props.privateKey, this.teamId = props.teamId, this.tokenKey = props.tokenKey, this.tokenKeyId = props.tokenKeyId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAPNSVoipSandboxChannel.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationId: this.applicationId, bundleId: this.bundleId, certificate: this.certificate, defaultAuthenticationMethod: this.defaultAuthenticationMethod, enabled: this.enabled, privateKey: this.privateKey, teamId: this.teamId, tokenKey: this.tokenKey, tokenKeyId: this.tokenKeyId };
      }
      renderProperties(props) {
        return cfnAPNSVoipSandboxChannelPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnAPNSVoipSandboxChannel[_e] = { fqn: "aws-cdk-lib.aws_pinpoint.CfnAPNSVoipSandboxChannel", version: "2.80.0" }, CfnAPNSVoipSandboxChannel.CFN_RESOURCE_TYPE_NAME = "AWS::Pinpoint::APNSVoipSandboxChannel", exports2.CfnAPNSVoipSandboxChannel = CfnAPNSVoipSandboxChannel;
    function CfnAppPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.wrap('supplied properties not correct for "CfnAppProps"');
    }
    function cfnAppPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAppPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.objectToCloudFormation(properties.tags) }) : properties;
    }
    function CfnAppPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApp = class _CfnApp extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAppPropsFromCloudFormation(resourceProperties), ret = new _CfnApp(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApp.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_pinpoint_CfnAppProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApp), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Pinpoint::App", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApp.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnAppPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnApp[_f] = { fqn: "aws-cdk-lib.aws_pinpoint.CfnApp", version: "2.80.0" }, CfnApp.CFN_RESOURCE_TYPE_NAME = "AWS::Pinpoint::App", exports2.CfnApp = CfnApp;
    function CfnApplicationSettingsPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationId", cdk.requiredValidator)(properties.applicationId)), errors.collect(cdk.propertyValidator("applicationId", cdk.validateString)(properties.applicationId)), errors.collect(cdk.propertyValidator("campaignHook", CfnApplicationSettings_CampaignHookPropertyValidator)(properties.campaignHook)), errors.collect(cdk.propertyValidator("cloudWatchMetricsEnabled", cdk.validateBoolean)(properties.cloudWatchMetricsEnabled)), errors.collect(cdk.propertyValidator("limits", CfnApplicationSettings_LimitsPropertyValidator)(properties.limits)), errors.collect(cdk.propertyValidator("quietTime", CfnApplicationSettings_QuietTimePropertyValidator)(properties.quietTime)), errors.wrap('supplied properties not correct for "CfnApplicationSettingsProps"');
    }
    function cfnApplicationSettingsPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationSettingsPropsValidator(properties).assertSuccess(), { ApplicationId: cdk.stringToCloudFormation(properties.applicationId), CampaignHook: cfnApplicationSettingsCampaignHookPropertyToCloudFormation(properties.campaignHook), CloudWatchMetricsEnabled: cdk.booleanToCloudFormation(properties.cloudWatchMetricsEnabled), Limits: cfnApplicationSettingsLimitsPropertyToCloudFormation(properties.limits), QuietTime: cfnApplicationSettingsQuietTimePropertyToCloudFormation(properties.quietTime) }) : properties;
    }
    function CfnApplicationSettingsPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationId", "ApplicationId", cfn_parse.FromCloudFormation.getString(properties.ApplicationId)), ret.addPropertyResult("campaignHook", "CampaignHook", properties.CampaignHook != null ? CfnApplicationSettingsCampaignHookPropertyFromCloudFormation(properties.CampaignHook) : void 0), ret.addPropertyResult("cloudWatchMetricsEnabled", "CloudWatchMetricsEnabled", properties.CloudWatchMetricsEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CloudWatchMetricsEnabled) : void 0), ret.addPropertyResult("limits", "Limits", properties.Limits != null ? CfnApplicationSettingsLimitsPropertyFromCloudFormation(properties.Limits) : void 0), ret.addPropertyResult("quietTime", "QuietTime", properties.QuietTime != null ? CfnApplicationSettingsQuietTimePropertyFromCloudFormation(properties.QuietTime) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApplicationSettings = class _CfnApplicationSettings extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApplicationSettingsPropsFromCloudFormation(resourceProperties), ret = new _CfnApplicationSettings(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApplicationSettings.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_pinpoint_CfnApplicationSettingsProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApplicationSettings), error;
        }
        cdk.requireProperty(props, "applicationId", this), this.applicationId = props.applicationId, this.campaignHook = props.campaignHook, this.cloudWatchMetricsEnabled = props.cloudWatchMetricsEnabled, this.limits = props.limits, this.quietTime = props.quietTime;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApplicationSettings.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationId: this.applicationId, campaignHook: this.campaignHook, cloudWatchMetricsEnabled: this.cloudWatchMetricsEnabled, limits: this.limits, quietTime: this.quietTime };
      }
      renderProperties(props) {
        return cfnApplicationSettingsPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnApplicationSettings[_g] = { fqn: "aws-cdk-lib.aws_pinpoint.CfnApplicationSettings", version: "2.80.0" }, CfnApplicationSettings.CFN_RESOURCE_TYPE_NAME = "AWS::Pinpoint::ApplicationSettings", exports2.CfnApplicationSettings = CfnApplicationSettings;
    function CfnApplicationSettings_CampaignHookPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("lambdaFunctionName", cdk.validateString)(properties.lambdaFunctionName)), errors.collect(cdk.propertyValidator("mode", cdk.validateString)(properties.mode)), errors.collect(cdk.propertyValidator("webUrl", cdk.validateString)(properties.webUrl)), errors.wrap('supplied properties not correct for "CampaignHookProperty"');
    }
    function cfnApplicationSettingsCampaignHookPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationSettings_CampaignHookPropertyValidator(properties).assertSuccess(), { LambdaFunctionName: cdk.stringToCloudFormation(properties.lambdaFunctionName), Mode: cdk.stringToCloudFormation(properties.mode), WebUrl: cdk.stringToCloudFormation(properties.webUrl) }) : properties;
    }
    function CfnApplicationSettingsCampaignHookPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("lambdaFunctionName", "LambdaFunctionName", properties.LambdaFunctionName != null ? cfn_parse.FromCloudFormation.getString(properties.LambdaFunctionName) : void 0), ret.addPropertyResult("mode", "Mode", properties.Mode != null ? cfn_parse.FromCloudFormation.getString(properties.Mode) : void 0), ret.addPropertyResult("webUrl", "WebUrl", properties.WebUrl != null ? cfn_parse.FromCloudFormation.getString(properties.WebUrl) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationSettings_LimitsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("daily", cdk.validateNumber)(properties.daily)), errors.collect(cdk.propertyValidator("maximumDuration", cdk.validateNumber)(properties.maximumDuration)), errors.collect(cdk.propertyValidator("messagesPerSecond", cdk.validateNumber)(properties.messagesPerSecond)), errors.collect(cdk.propertyValidator("total", cdk.validateNumber)(properties.total)), errors.wrap('supplied properties not correct for "LimitsProperty"');
    }
    function cfnApplicationSettingsLimitsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationSettings_LimitsPropertyValidator(properties).assertSuccess(), { Daily: cdk.numberToCloudFormation(properties.daily), MaximumDuration: cdk.numberToCloudFormation(properties.maximumDuration), MessagesPerSecond: cdk.numberToCloudFormation(properties.messagesPerSecond), Total: cdk.numberToCloudFormation(properties.total) }) : properties;
    }
    function CfnApplicationSettingsLimitsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("daily", "Daily", properties.Daily != null ? cfn_parse.FromCloudFormation.getNumber(properties.Daily) : void 0), ret.addPropertyResult("maximumDuration", "MaximumDuration", properties.MaximumDuration != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumDuration) : void 0), ret.addPropertyResult("messagesPerSecond", "MessagesPerSecond", properties.MessagesPerSecond != null ? cfn_parse.FromCloudFormation.getNumber(properties.MessagesPerSecond) : void 0), ret.addPropertyResult("total", "Total", properties.Total != null ? cfn_parse.FromCloudFormation.getNumber(properties.Total) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApplicationSettings_QuietTimePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("end", cdk.requiredValidator)(properties.end)), errors.collect(cdk.propertyValidator("end", cdk.validateString)(properties.end)), errors.collect(cdk.propertyValidator("start", cdk.requiredValidator)(properties.start)), errors.collect(cdk.propertyValidator("start", cdk.validateString)(properties.start)), errors.wrap('supplied properties not correct for "QuietTimeProperty"');
    }
    function cfnApplicationSettingsQuietTimePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationSettings_QuietTimePropertyValidator(properties).assertSuccess(), { End: cdk.stringToCloudFormation(properties.end), Start: cdk.stringToCloudFormation(properties.start) }) : properties;
    }
    function CfnApplicationSettingsQuietTimePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("end", "End", cfn_parse.FromCloudFormation.getString(properties.End)), ret.addPropertyResult("start", "Start", cfn_parse.FromCloudFormation.getString(properties.Start)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBaiduChannelPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiKey", cdk.requiredValidator)(properties.apiKey)), errors.collect(cdk.propertyValidator("apiKey", cdk.validateString)(properties.apiKey)), errors.collect(cdk.propertyValidator("applicationId", cdk.requiredValidator)(properties.applicationId)), errors.collect(cdk.propertyValidator("applicationId", cdk.validateString)(properties.applicationId)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("secretKey", cdk.requiredValidator)(properties.secretKey)), errors.collect(cdk.propertyValidator("secretKey", cdk.validateString)(properties.secretKey)), errors.wrap('supplied properties not correct for "CfnBaiduChannelProps"');
    }
    function cfnBaiduChannelPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBaiduChannelPropsValidator(properties).assertSuccess(), { ApiKey: cdk.stringToCloudFormation(properties.apiKey), ApplicationId: cdk.stringToCloudFormation(properties.applicationId), SecretKey: cdk.stringToCloudFormation(properties.secretKey), Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnBaiduChannelPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiKey", "ApiKey", cfn_parse.FromCloudFormation.getString(properties.ApiKey)), ret.addPropertyResult("applicationId", "ApplicationId", cfn_parse.FromCloudFormation.getString(properties.ApplicationId)), ret.addPropertyResult("secretKey", "SecretKey", cfn_parse.FromCloudFormation.getString(properties.SecretKey)), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnBaiduChannel = class _CfnBaiduChannel extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnBaiduChannelPropsFromCloudFormation(resourceProperties), ret = new _CfnBaiduChannel(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnBaiduChannel.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_pinpoint_CfnBaiduChannelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnBaiduChannel), error;
        }
        cdk.requireProperty(props, "apiKey", this), cdk.requireProperty(props, "applicationId", this), cdk.requireProperty(props, "secretKey", this), this.apiKey = props.apiKey, this.applicationId = props.applicationId, this.secretKey = props.secretKey, this.enabled = props.enabled;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnBaiduChannel.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiKey: this.apiKey, applicationId: this.applicationId, secretKey: this.secretKey, enabled: this.enabled };
      }
      renderProperties(props) {
        return cfnBaiduChannelPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnBaiduChannel[_h] = { fqn: "aws-cdk-lib.aws_pinpoint.CfnBaiduChannel", version: "2.80.0" }, CfnBaiduChannel.CFN_RESOURCE_TYPE_NAME = "AWS::Pinpoint::BaiduChannel", exports2.CfnBaiduChannel = CfnBaiduChannel;
    function CfnCampaignPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("additionalTreatments", cdk.listValidator(CfnCampaign_WriteTreatmentResourcePropertyValidator))(properties.additionalTreatments)), errors.collect(cdk.propertyValidator("applicationId", cdk.requiredValidator)(properties.applicationId)), errors.collect(cdk.propertyValidator("applicationId", cdk.validateString)(properties.applicationId)), errors.collect(cdk.propertyValidator("campaignHook", CfnCampaign_CampaignHookPropertyValidator)(properties.campaignHook)), errors.collect(cdk.propertyValidator("customDeliveryConfiguration", CfnCampaign_CustomDeliveryConfigurationPropertyValidator)(properties.customDeliveryConfiguration)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("holdoutPercent", cdk.validateNumber)(properties.holdoutPercent)), errors.collect(cdk.propertyValidator("isPaused", cdk.validateBoolean)(properties.isPaused)), errors.collect(cdk.propertyValidator("limits", CfnCampaign_LimitsPropertyValidator)(properties.limits)), errors.collect(cdk.propertyValidator("messageConfiguration", CfnCampaign_MessageConfigurationPropertyValidator)(properties.messageConfiguration)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("priority", cdk.validateNumber)(properties.priority)), errors.collect(cdk.propertyValidator("schedule", cdk.requiredValidator)(properties.schedule)), errors.collect(cdk.propertyValidator("schedule", CfnCampaign_SchedulePropertyValidator)(properties.schedule)), errors.collect(cdk.propertyValidator("segmentId", cdk.requiredValidator)(properties.segmentId)), errors.collect(cdk.propertyValidator("segmentId", cdk.validateString)(properties.segmentId)), errors.collect(cdk.propertyValidator("segmentVersion", cdk.validateNumber)(properties.segmentVersion)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.collect(cdk.propertyValidator("templateConfiguration", CfnCampaign_TemplateConfigurationPropertyValidator)(properties.templateConfiguration)), errors.collect(cdk.propertyValidator("treatmentDescription", cdk.validateString)(properties.treatmentDescription)), errors.collect(cdk.propertyValidator("treatmentName", cdk.validateString)(properties.treatmentName)), errors.wrap('supplied properties not correct for "CfnCampaignProps"');
    }
    function cfnCampaignPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaignPropsValidator(properties).assertSuccess(), { ApplicationId: cdk.stringToCloudFormation(properties.applicationId), Name: cdk.stringToCloudFormation(properties.name), Schedule: cfnCampaignSchedulePropertyToCloudFormation(properties.schedule), SegmentId: cdk.stringToCloudFormation(properties.segmentId), AdditionalTreatments: cdk.listMapper(cfnCampaignWriteTreatmentResourcePropertyToCloudFormation)(properties.additionalTreatments), CampaignHook: cfnCampaignCampaignHookPropertyToCloudFormation(properties.campaignHook), CustomDeliveryConfiguration: cfnCampaignCustomDeliveryConfigurationPropertyToCloudFormation(properties.customDeliveryConfiguration), Description: cdk.stringToCloudFormation(properties.description), HoldoutPercent: cdk.numberToCloudFormation(properties.holdoutPercent), IsPaused: cdk.booleanToCloudFormation(properties.isPaused), Limits: cfnCampaignLimitsPropertyToCloudFormation(properties.limits), MessageConfiguration: cfnCampaignMessageConfigurationPropertyToCloudFormation(properties.messageConfiguration), Priority: cdk.numberToCloudFormation(properties.priority), SegmentVersion: cdk.numberToCloudFormation(properties.segmentVersion), Tags: cdk.objectToCloudFormation(properties.tags), TemplateConfiguration: cfnCampaignTemplateConfigurationPropertyToCloudFormation(properties.templateConfiguration), TreatmentDescription: cdk.stringToCloudFormation(properties.treatmentDescription), TreatmentName: cdk.stringToCloudFormation(properties.treatmentName) }) : properties;
    }
    function CfnCampaignPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationId", "ApplicationId", cfn_parse.FromCloudFormation.getString(properties.ApplicationId)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("schedule", "Schedule", CfnCampaignSchedulePropertyFromCloudFormation(properties.Schedule)), ret.addPropertyResult("segmentId", "SegmentId", cfn_parse.FromCloudFormation.getString(properties.SegmentId)), ret.addPropertyResult("additionalTreatments", "AdditionalTreatments", properties.AdditionalTreatments != null ? cfn_parse.FromCloudFormation.getArray(CfnCampaignWriteTreatmentResourcePropertyFromCloudFormation)(properties.AdditionalTreatments) : void 0), ret.addPropertyResult("campaignHook", "CampaignHook", properties.CampaignHook != null ? CfnCampaignCampaignHookPropertyFromCloudFormation(properties.CampaignHook) : void 0), ret.addPropertyResult("customDeliveryConfiguration", "CustomDeliveryConfiguration", properties.CustomDeliveryConfiguration != null ? CfnCampaignCustomDeliveryConfigurationPropertyFromCloudFormation(properties.CustomDeliveryConfiguration) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("holdoutPercent", "HoldoutPercent", properties.HoldoutPercent != null ? cfn_parse.FromCloudFormation.getNumber(properties.HoldoutPercent) : void 0), ret.addPropertyResult("isPaused", "IsPaused", properties.IsPaused != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsPaused) : void 0), ret.addPropertyResult("limits", "Limits", properties.Limits != null ? CfnCampaignLimitsPropertyFromCloudFormation(properties.Limits) : void 0), ret.addPropertyResult("messageConfiguration", "MessageConfiguration", properties.MessageConfiguration != null ? CfnCampaignMessageConfigurationPropertyFromCloudFormation(properties.MessageConfiguration) : void 0), ret.addPropertyResult("priority", "Priority", properties.Priority != null ? cfn_parse.FromCloudFormation.getNumber(properties.Priority) : void 0), ret.addPropertyResult("segmentVersion", "SegmentVersion", properties.SegmentVersion != null ? cfn_parse.FromCloudFormation.getNumber(properties.SegmentVersion) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addPropertyResult("templateConfiguration", "TemplateConfiguration", properties.TemplateConfiguration != null ? CfnCampaignTemplateConfigurationPropertyFromCloudFormation(properties.TemplateConfiguration) : void 0), ret.addPropertyResult("treatmentDescription", "TreatmentDescription", properties.TreatmentDescription != null ? cfn_parse.FromCloudFormation.getString(properties.TreatmentDescription) : void 0), ret.addPropertyResult("treatmentName", "TreatmentName", properties.TreatmentName != null ? cfn_parse.FromCloudFormation.getString(properties.TreatmentName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCampaign = class _CfnCampaign extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCampaignPropsFromCloudFormation(resourceProperties), ret = new _CfnCampaign(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCampaign.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_pinpoint_CfnCampaignProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCampaign), error;
        }
        cdk.requireProperty(props, "applicationId", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "schedule", this), cdk.requireProperty(props, "segmentId", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCampaignId = cdk.Token.asString(this.getAtt("CampaignId", cdk.ResolutionTypeHint.STRING)), this.applicationId = props.applicationId, this.name = props.name, this.schedule = props.schedule, this.segmentId = props.segmentId, this.additionalTreatments = props.additionalTreatments, this.campaignHook = props.campaignHook, this.customDeliveryConfiguration = props.customDeliveryConfiguration, this.description = props.description, this.holdoutPercent = props.holdoutPercent, this.isPaused = props.isPaused, this.limits = props.limits, this.messageConfiguration = props.messageConfiguration, this.priority = props.priority, this.segmentVersion = props.segmentVersion, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Pinpoint::Campaign", props.tags, { tagPropertyName: "tags" }), this.templateConfiguration = props.templateConfiguration, this.treatmentDescription = props.treatmentDescription, this.treatmentName = props.treatmentName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCampaign.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationId: this.applicationId, name: this.name, schedule: this.schedule, segmentId: this.segmentId, additionalTreatments: this.additionalTreatments, campaignHook: this.campaignHook, customDeliveryConfiguration: this.customDeliveryConfiguration, description: this.description, holdoutPercent: this.holdoutPercent, isPaused: this.isPaused, limits: this.limits, messageConfiguration: this.messageConfiguration, priority: this.priority, segmentVersion: this.segmentVersion, tags: this.tags.renderTags(), templateConfiguration: this.templateConfiguration, treatmentDescription: this.treatmentDescription, treatmentName: this.treatmentName };
      }
      renderProperties(props) {
        return cfnCampaignPropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnCampaign[_j] = { fqn: "aws-cdk-lib.aws_pinpoint.CfnCampaign", version: "2.80.0" }, CfnCampaign.CFN_RESOURCE_TYPE_NAME = "AWS::Pinpoint::Campaign", exports2.CfnCampaign = CfnCampaign;
    function CfnCampaign_CampaignCustomMessagePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("data", cdk.validateString)(properties.data)), errors.wrap('supplied properties not correct for "CampaignCustomMessageProperty"');
    }
    function cfnCampaignCampaignCustomMessagePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_CampaignCustomMessagePropertyValidator(properties).assertSuccess(), { Data: cdk.stringToCloudFormation(properties.data) }) : properties;
    }
    function CfnCampaignCampaignCustomMessagePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("data", "Data", properties.Data != null ? cfn_parse.FromCloudFormation.getString(properties.Data) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCampaign_CampaignEmailMessagePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("body", cdk.validateString)(properties.body)), errors.collect(cdk.propertyValidator("fromAddress", cdk.validateString)(properties.fromAddress)), errors.collect(cdk.propertyValidator("htmlBody", cdk.validateString)(properties.htmlBody)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.wrap('supplied properties not correct for "CampaignEmailMessageProperty"');
    }
    function cfnCampaignCampaignEmailMessagePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_CampaignEmailMessagePropertyValidator(properties).assertSuccess(), { Body: cdk.stringToCloudFormation(properties.body), FromAddress: cdk.stringToCloudFormation(properties.fromAddress), HtmlBody: cdk.stringToCloudFormation(properties.htmlBody), Title: cdk.stringToCloudFormation(properties.title) }) : properties;
    }
    function CfnCampaignCampaignEmailMessagePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("body", "Body", properties.Body != null ? cfn_parse.FromCloudFormation.getString(properties.Body) : void 0), ret.addPropertyResult("fromAddress", "FromAddress", properties.FromAddress != null ? cfn_parse.FromCloudFormation.getString(properties.FromAddress) : void 0), ret.addPropertyResult("htmlBody", "HtmlBody", properties.HtmlBody != null ? cfn_parse.FromCloudFormation.getString(properties.HtmlBody) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? cfn_parse.FromCloudFormation.getString(properties.Title) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCampaign_CampaignEventFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dimensions", CfnCampaign_EventDimensionsPropertyValidator)(properties.dimensions)), errors.collect(cdk.propertyValidator("filterType", cdk.validateString)(properties.filterType)), errors.wrap('supplied properties not correct for "CampaignEventFilterProperty"');
    }
    function cfnCampaignCampaignEventFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_CampaignEventFilterPropertyValidator(properties).assertSuccess(), { Dimensions: cfnCampaignEventDimensionsPropertyToCloudFormation(properties.dimensions), FilterType: cdk.stringToCloudFormation(properties.filterType) }) : properties;
    }
    function CfnCampaignCampaignEventFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dimensions", "Dimensions", properties.Dimensions != null ? CfnCampaignEventDimensionsPropertyFromCloudFormation(properties.Dimensions) : void 0), ret.addPropertyResult("filterType", "FilterType", properties.FilterType != null ? cfn_parse.FromCloudFormation.getString(properties.FilterType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCampaign_CampaignHookPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("lambdaFunctionName", cdk.validateString)(properties.lambdaFunctionName)), errors.collect(cdk.propertyValidator("mode", cdk.validateString)(properties.mode)), errors.collect(cdk.propertyValidator("webUrl", cdk.validateString)(properties.webUrl)), errors.wrap('supplied properties not correct for "CampaignHookProperty"');
    }
    function cfnCampaignCampaignHookPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_CampaignHookPropertyValidator(properties).assertSuccess(), { LambdaFunctionName: cdk.stringToCloudFormation(properties.lambdaFunctionName), Mode: cdk.stringToCloudFormation(properties.mode), WebUrl: cdk.stringToCloudFormation(properties.webUrl) }) : properties;
    }
    function CfnCampaignCampaignHookPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("lambdaFunctionName", "LambdaFunctionName", properties.LambdaFunctionName != null ? cfn_parse.FromCloudFormation.getString(properties.LambdaFunctionName) : void 0), ret.addPropertyResult("mode", "Mode", properties.Mode != null ? cfn_parse.FromCloudFormation.getString(properties.Mode) : void 0), ret.addPropertyResult("webUrl", "WebUrl", properties.WebUrl != null ? cfn_parse.FromCloudFormation.getString(properties.WebUrl) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCampaign_CampaignInAppMessagePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("content", cdk.listValidator(CfnCampaign_InAppMessageContentPropertyValidator))(properties.content)), errors.collect(cdk.propertyValidator("customConfig", cdk.validateObject)(properties.customConfig)), errors.collect(cdk.propertyValidator("layout", cdk.validateString)(properties.layout)), errors.wrap('supplied properties not correct for "CampaignInAppMessageProperty"');
    }
    function cfnCampaignCampaignInAppMessagePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_CampaignInAppMessagePropertyValidator(properties).assertSuccess(), { Content: cdk.listMapper(cfnCampaignInAppMessageContentPropertyToCloudFormation)(properties.content), CustomConfig: cdk.objectToCloudFormation(properties.customConfig), Layout: cdk.stringToCloudFormation(properties.layout) }) : properties;
    }
    function CfnCampaignCampaignInAppMessagePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("content", "Content", properties.Content != null ? cfn_parse.FromCloudFormation.getArray(CfnCampaignInAppMessageContentPropertyFromCloudFormation)(properties.Content) : void 0), ret.addPropertyResult("customConfig", "CustomConfig", properties.CustomConfig != null ? cfn_parse.FromCloudFormation.getAny(properties.CustomConfig) : void 0), ret.addPropertyResult("layout", "Layout", properties.Layout != null ? cfn_parse.FromCloudFormation.getString(properties.Layout) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCampaign_CampaignSmsMessagePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("body", cdk.validateString)(properties.body)), errors.collect(cdk.propertyValidator("entityId", cdk.validateString)(properties.entityId)), errors.collect(cdk.propertyValidator("messageType", cdk.validateString)(properties.messageType)), errors.collect(cdk.propertyValidator("originationNumber", cdk.validateString)(properties.originationNumber)), errors.collect(cdk.propertyValidator("senderId", cdk.validateString)(properties.senderId)), errors.collect(cdk.propertyValidator("templateId", cdk.validateString)(properties.templateId)), errors.wrap('supplied properties not correct for "CampaignSmsMessageProperty"');
    }
    function cfnCampaignCampaignSmsMessagePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_CampaignSmsMessagePropertyValidator(properties).assertSuccess(), { Body: cdk.stringToCloudFormation(properties.body), EntityId: cdk.stringToCloudFormation(properties.entityId), MessageType: cdk.stringToCloudFormation(properties.messageType), OriginationNumber: cdk.stringToCloudFormation(properties.originationNumber), SenderId: cdk.stringToCloudFormation(properties.senderId), TemplateId: cdk.stringToCloudFormation(properties.templateId) }) : properties;
    }
    function CfnCampaignCampaignSmsMessagePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("body", "Body", properties.Body != null ? cfn_parse.FromCloudFormation.getString(properties.Body) : void 0), ret.addPropertyResult("entityId", "EntityId", properties.EntityId != null ? cfn_parse.FromCloudFormation.getString(properties.EntityId) : void 0), ret.addPropertyResult("messageType", "MessageType", properties.MessageType != null ? cfn_parse.FromCloudFormation.getString(properties.MessageType) : void 0), ret.addPropertyResult("originationNumber", "OriginationNumber", properties.OriginationNumber != null ? cfn_parse.FromCloudFormation.getString(properties.OriginationNumber) : void 0), ret.addPropertyResult("senderId", "SenderId", properties.SenderId != null ? cfn_parse.FromCloudFormation.getString(properties.SenderId) : void 0), ret.addPropertyResult("templateId", "TemplateId", properties.TemplateId != null ? cfn_parse.FromCloudFormation.getString(properties.TemplateId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCampaign_CustomDeliveryConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deliveryUri", cdk.validateString)(properties.deliveryUri)), errors.collect(cdk.propertyValidator("endpointTypes", cdk.listValidator(cdk.validateString))(properties.endpointTypes)), errors.wrap('supplied properties not correct for "CustomDeliveryConfigurationProperty"');
    }
    function cfnCampaignCustomDeliveryConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_CustomDeliveryConfigurationPropertyValidator(properties).assertSuccess(), { DeliveryUri: cdk.stringToCloudFormation(properties.deliveryUri), EndpointTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.endpointTypes) }) : properties;
    }
    function CfnCampaignCustomDeliveryConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deliveryUri", "DeliveryUri", properties.DeliveryUri != null ? cfn_parse.FromCloudFormation.getString(properties.DeliveryUri) : void 0), ret.addPropertyResult("endpointTypes", "EndpointTypes", properties.EndpointTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.EndpointTypes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCampaign_DefaultButtonConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("backgroundColor", cdk.validateString)(properties.backgroundColor)), errors.collect(cdk.propertyValidator("borderRadius", cdk.validateNumber)(properties.borderRadius)), errors.collect(cdk.propertyValidator("buttonAction", cdk.validateString)(properties.buttonAction)), errors.collect(cdk.propertyValidator("link", cdk.validateString)(properties.link)), errors.collect(cdk.propertyValidator("text", cdk.validateString)(properties.text)), errors.collect(cdk.propertyValidator("textColor", cdk.validateString)(properties.textColor)), errors.wrap('supplied properties not correct for "DefaultButtonConfigurationProperty"');
    }
    function cfnCampaignDefaultButtonConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_DefaultButtonConfigurationPropertyValidator(properties).assertSuccess(), { BackgroundColor: cdk.stringToCloudFormation(properties.backgroundColor), BorderRadius: cdk.numberToCloudFormation(properties.borderRadius), ButtonAction: cdk.stringToCloudFormation(properties.buttonAction), Link: cdk.stringToCloudFormation(properties.link), Text: cdk.stringToCloudFormation(properties.text), TextColor: cdk.stringToCloudFormation(properties.textColor) }) : properties;
    }
    function CfnCampaignDefaultButtonConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("backgroundColor", "BackgroundColor", properties.BackgroundColor != null ? cfn_parse.FromCloudFormation.getString(properties.BackgroundColor) : void 0), ret.addPropertyResult("borderRadius", "BorderRadius", properties.BorderRadius != null ? cfn_parse.FromCloudFormation.getNumber(properties.BorderRadius) : void 0), ret.addPropertyResult("buttonAction", "ButtonAction", properties.ButtonAction != null ? cfn_parse.FromCloudFormation.getString(properties.ButtonAction) : void 0), ret.addPropertyResult("link", "Link", properties.Link != null ? cfn_parse.FromCloudFormation.getString(properties.Link) : void 0), ret.addPropertyResult("text", "Text", properties.Text != null ? cfn_parse.FromCloudFormation.getString(properties.Text) : void 0), ret.addPropertyResult("textColor", "TextColor", properties.TextColor != null ? cfn_parse.FromCloudFormation.getString(properties.TextColor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCampaign_EventDimensionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributes", cdk.validateObject)(properties.attributes)), errors.collect(cdk.propertyValidator("eventType", CfnCampaign_SetDimensionPropertyValidator)(properties.eventType)), errors.collect(cdk.propertyValidator("metrics", cdk.validateObject)(properties.metrics)), errors.wrap('supplied properties not correct for "EventDimensionsProperty"');
    }
    function cfnCampaignEventDimensionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_EventDimensionsPropertyValidator(properties).assertSuccess(), { Attributes: cdk.objectToCloudFormation(properties.attributes), EventType: cfnCampaignSetDimensionPropertyToCloudFormation(properties.eventType), Metrics: cdk.objectToCloudFormation(properties.metrics) }) : properties;
    }
    function CfnCampaignEventDimensionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attributes", "Attributes", properties.Attributes != null ? cfn_parse.FromCloudFormation.getAny(properties.Attributes) : void 0), ret.addPropertyResult("eventType", "EventType", properties.EventType != null ? CfnCampaignSetDimensionPropertyFromCloudFormation(properties.EventType) : void 0), ret.addPropertyResult("metrics", "Metrics", properties.Metrics != null ? cfn_parse.FromCloudFormation.getAny(properties.Metrics) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCampaign_InAppMessageBodyConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alignment", cdk.validateString)(properties.alignment)), errors.collect(cdk.propertyValidator("body", cdk.validateString)(properties.body)), errors.collect(cdk.propertyValidator("textColor", cdk.validateString)(properties.textColor)), errors.wrap('supplied properties not correct for "InAppMessageBodyConfigProperty"');
    }
    function cfnCampaignInAppMessageBodyConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_InAppMessageBodyConfigPropertyValidator(properties).assertSuccess(), { Alignment: cdk.stringToCloudFormation(properties.alignment), Body: cdk.stringToCloudFormation(properties.body), TextColor: cdk.stringToCloudFormation(properties.textColor) }) : properties;
    }
    function CfnCampaignInAppMessageBodyConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alignment", "Alignment", properties.Alignment != null ? cfn_parse.FromCloudFormation.getString(properties.Alignment) : void 0), ret.addPropertyResult("body", "Body", properties.Body != null ? cfn_parse.FromCloudFormation.getString(properties.Body) : void 0), ret.addPropertyResult("textColor", "TextColor", properties.TextColor != null ? cfn_parse.FromCloudFormation.getString(properties.TextColor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCampaign_InAppMessageButtonPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("android", CfnCampaign_OverrideButtonConfigurationPropertyValidator)(properties.android)), errors.collect(cdk.propertyValidator("defaultConfig", CfnCampaign_DefaultButtonConfigurationPropertyValidator)(properties.defaultConfig)), errors.collect(cdk.propertyValidator("ios", CfnCampaign_OverrideButtonConfigurationPropertyValidator)(properties.ios)), errors.collect(cdk.propertyValidator("web", CfnCampaign_OverrideButtonConfigurationPropertyValidator)(properties.web)), errors.wrap('supplied properties not correct for "InAppMessageButtonProperty"');
    }
    function cfnCampaignInAppMessageButtonPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_InAppMessageButtonPropertyValidator(properties).assertSuccess(), { Android: cfnCampaignOverrideButtonConfigurationPropertyToCloudFormation(properties.android), DefaultConfig: cfnCampaignDefaultButtonConfigurationPropertyToCloudFormation(properties.defaultConfig), IOS: cfnCampaignOverrideButtonConfigurationPropertyToCloudFormation(properties.ios), Web: cfnCampaignOverrideButtonConfigurationPropertyToCloudFormation(properties.web) }) : properties;
    }
    function CfnCampaignInAppMessageButtonPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("android", "Android", properties.Android != null ? CfnCampaignOverrideButtonConfigurationPropertyFromCloudFormation(properties.Android) : void 0), ret.addPropertyResult("defaultConfig", "DefaultConfig", properties.DefaultConfig != null ? CfnCampaignDefaultButtonConfigurationPropertyFromCloudFormation(properties.DefaultConfig) : void 0), ret.addPropertyResult("ios", "IOS", properties.IOS != null ? CfnCampaignOverrideButtonConfigurationPropertyFromCloudFormation(properties.IOS) : void 0), ret.addPropertyResult("web", "Web", properties.Web != null ? CfnCampaignOverrideButtonConfigurationPropertyFromCloudFormation(properties.Web) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCampaign_InAppMessageContentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("backgroundColor", cdk.validateString)(properties.backgroundColor)), errors.collect(cdk.propertyValidator("bodyConfig", CfnCampaign_InAppMessageBodyConfigPropertyValidator)(properties.bodyConfig)), errors.collect(cdk.propertyValidator("headerConfig", CfnCampaign_InAppMessageHeaderConfigPropertyValidator)(properties.headerConfig)), errors.collect(cdk.propertyValidator("imageUrl", cdk.validateString)(properties.imageUrl)), errors.collect(cdk.propertyValidator("primaryBtn", CfnCampaign_InAppMessageButtonPropertyValidator)(properties.primaryBtn)), errors.collect(cdk.propertyValidator("secondaryBtn", CfnCampaign_InAppMessageButtonPropertyValidator)(properties.secondaryBtn)), errors.wrap('supplied properties not correct for "InAppMessageContentProperty"');
    }
    function cfnCampaignInAppMessageContentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_InAppMessageContentPropertyValidator(properties).assertSuccess(), { BackgroundColor: cdk.stringToCloudFormation(properties.backgroundColor), BodyConfig: cfnCampaignInAppMessageBodyConfigPropertyToCloudFormation(properties.bodyConfig), HeaderConfig: cfnCampaignInAppMessageHeaderConfigPropertyToCloudFormation(properties.headerConfig), ImageUrl: cdk.stringToCloudFormation(properties.imageUrl), PrimaryBtn: cfnCampaignInAppMessageButtonPropertyToCloudFormation(properties.primaryBtn), SecondaryBtn: cfnCampaignInAppMessageButtonPropertyToCloudFormation(properties.secondaryBtn) }) : properties;
    }
    function CfnCampaignInAppMessageContentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("backgroundColor", "BackgroundColor", properties.BackgroundColor != null ? cfn_parse.FromCloudFormation.getString(properties.BackgroundColor) : void 0), ret.addPropertyResult("bodyConfig", "BodyConfig", properties.BodyConfig != null ? CfnCampaignInAppMessageBodyConfigPropertyFromCloudFormation(properties.BodyConfig) : void 0), ret.addPropertyResult("headerConfig", "HeaderConfig", properties.HeaderConfig != null ? CfnCampaignInAppMessageHeaderConfigPropertyFromCloudFormation(properties.HeaderConfig) : void 0), ret.addPropertyResult("imageUrl", "ImageUrl", properties.ImageUrl != null ? cfn_parse.FromCloudFormation.getString(properties.ImageUrl) : void 0), ret.addPropertyResult("primaryBtn", "PrimaryBtn", properties.PrimaryBtn != null ? CfnCampaignInAppMessageButtonPropertyFromCloudFormation(properties.PrimaryBtn) : void 0), ret.addPropertyResult("secondaryBtn", "SecondaryBtn", properties.SecondaryBtn != null ? CfnCampaignInAppMessageButtonPropertyFromCloudFormation(properties.SecondaryBtn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCampaign_InAppMessageHeaderConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alignment", cdk.validateString)(properties.alignment)), errors.collect(cdk.propertyValidator("header", cdk.validateString)(properties.header)), errors.collect(cdk.propertyValidator("textColor", cdk.validateString)(properties.textColor)), errors.wrap('supplied properties not correct for "InAppMessageHeaderConfigProperty"');
    }
    function cfnCampaignInAppMessageHeaderConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_InAppMessageHeaderConfigPropertyValidator(properties).assertSuccess(), { Alignment: cdk.stringToCloudFormation(properties.alignment), Header: cdk.stringToCloudFormation(properties.header), TextColor: cdk.stringToCloudFormation(properties.textColor) }) : properties;
    }
    function CfnCampaignInAppMessageHeaderConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alignment", "Alignment", properties.Alignment != null ? cfn_parse.FromCloudFormation.getString(properties.Alignment) : void 0), ret.addPropertyResult("header", "Header", properties.Header != null ? cfn_parse.FromCloudFormation.getString(properties.Header) : void 0), ret.addPropertyResult("textColor", "TextColor", properties.TextColor != null ? cfn_parse.FromCloudFormation.getString(properties.TextColor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCampaign_LimitsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("daily", cdk.validateNumber)(properties.daily)), errors.collect(cdk.propertyValidator("maximumDuration", cdk.validateNumber)(properties.maximumDuration)), errors.collect(cdk.propertyValidator("messagesPerSecond", cdk.validateNumber)(properties.messagesPerSecond)), errors.collect(cdk.propertyValidator("session", cdk.validateNumber)(properties.session)), errors.collect(cdk.propertyValidator("total", cdk.validateNumber)(properties.total)), errors.wrap('supplied properties not correct for "LimitsProperty"');
    }
    function cfnCampaignLimitsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_LimitsPropertyValidator(properties).assertSuccess(), { Daily: cdk.numberToCloudFormation(properties.daily), MaximumDuration: cdk.numberToCloudFormation(properties.maximumDuration), MessagesPerSecond: cdk.numberToCloudFormation(properties.messagesPerSecond), Session: cdk.numberToCloudFormation(properties.session), Total: cdk.numberToCloudFormation(properties.total) }) : properties;
    }
    function CfnCampaignLimitsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("daily", "Daily", properties.Daily != null ? cfn_parse.FromCloudFormation.getNumber(properties.Daily) : void 0), ret.addPropertyResult("maximumDuration", "MaximumDuration", properties.MaximumDuration != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumDuration) : void 0), ret.addPropertyResult("messagesPerSecond", "MessagesPerSecond", properties.MessagesPerSecond != null ? cfn_parse.FromCloudFormation.getNumber(properties.MessagesPerSecond) : void 0), ret.addPropertyResult("session", "Session", properties.Session != null ? cfn_parse.FromCloudFormation.getNumber(properties.Session) : void 0), ret.addPropertyResult("total", "Total", properties.Total != null ? cfn_parse.FromCloudFormation.getNumber(properties.Total) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCampaign_MessagePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.validateString)(properties.action)), errors.collect(cdk.propertyValidator("body", cdk.validateString)(properties.body)), errors.collect(cdk.propertyValidator("imageIconUrl", cdk.validateString)(properties.imageIconUrl)), errors.collect(cdk.propertyValidator("imageSmallIconUrl", cdk.validateString)(properties.imageSmallIconUrl)), errors.collect(cdk.propertyValidator("imageUrl", cdk.validateString)(properties.imageUrl)), errors.collect(cdk.propertyValidator("jsonBody", cdk.validateString)(properties.jsonBody)), errors.collect(cdk.propertyValidator("mediaUrl", cdk.validateString)(properties.mediaUrl)), errors.collect(cdk.propertyValidator("rawContent", cdk.validateString)(properties.rawContent)), errors.collect(cdk.propertyValidator("silentPush", cdk.validateBoolean)(properties.silentPush)), errors.collect(cdk.propertyValidator("timeToLive", cdk.validateNumber)(properties.timeToLive)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.collect(cdk.propertyValidator("url", cdk.validateString)(properties.url)), errors.wrap('supplied properties not correct for "MessageProperty"');
    }
    function cfnCampaignMessagePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_MessagePropertyValidator(properties).assertSuccess(), { Action: cdk.stringToCloudFormation(properties.action), Body: cdk.stringToCloudFormation(properties.body), ImageIconUrl: cdk.stringToCloudFormation(properties.imageIconUrl), ImageSmallIconUrl: cdk.stringToCloudFormation(properties.imageSmallIconUrl), ImageUrl: cdk.stringToCloudFormation(properties.imageUrl), JsonBody: cdk.stringToCloudFormation(properties.jsonBody), MediaUrl: cdk.stringToCloudFormation(properties.mediaUrl), RawContent: cdk.stringToCloudFormation(properties.rawContent), SilentPush: cdk.booleanToCloudFormation(properties.silentPush), TimeToLive: cdk.numberToCloudFormation(properties.timeToLive), Title: cdk.stringToCloudFormation(properties.title), Url: cdk.stringToCloudFormation(properties.url) }) : properties;
    }
    function CfnCampaignMessagePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", properties.Action != null ? cfn_parse.FromCloudFormation.getString(properties.Action) : void 0), ret.addPropertyResult("body", "Body", properties.Body != null ? cfn_parse.FromCloudFormation.getString(properties.Body) : void 0), ret.addPropertyResult("imageIconUrl", "ImageIconUrl", properties.ImageIconUrl != null ? cfn_parse.FromCloudFormation.getString(properties.ImageIconUrl) : void 0), ret.addPropertyResult("imageSmallIconUrl", "ImageSmallIconUrl", properties.ImageSmallIconUrl != null ? cfn_parse.FromCloudFormation.getString(properties.ImageSmallIconUrl) : void 0), ret.addPropertyResult("imageUrl", "ImageUrl", properties.ImageUrl != null ? cfn_parse.FromCloudFormation.getString(properties.ImageUrl) : void 0), ret.addPropertyResult("jsonBody", "JsonBody", properties.JsonBody != null ? cfn_parse.FromCloudFormation.getString(properties.JsonBody) : void 0), ret.addPropertyResult("mediaUrl", "MediaUrl", properties.MediaUrl != null ? cfn_parse.FromCloudFormation.getString(properties.MediaUrl) : void 0), ret.addPropertyResult("rawContent", "RawContent", properties.RawContent != null ? cfn_parse.FromCloudFormation.getString(properties.RawContent) : void 0), ret.addPropertyResult("silentPush", "SilentPush", properties.SilentPush != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SilentPush) : void 0), ret.addPropertyResult("timeToLive", "TimeToLive", properties.TimeToLive != null ? cfn_parse.FromCloudFormation.getNumber(properties.TimeToLive) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? cfn_parse.FromCloudFormation.getString(properties.Title) : void 0), ret.addPropertyResult("url", "Url", properties.Url != null ? cfn_parse.FromCloudFormation.getString(properties.Url) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCampaign_MessageConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("admMessage", CfnCampaign_MessagePropertyValidator)(properties.admMessage)), errors.collect(cdk.propertyValidator("apnsMessage", CfnCampaign_MessagePropertyValidator)(properties.apnsMessage)), errors.collect(cdk.propertyValidator("baiduMessage", CfnCampaign_MessagePropertyValidator)(properties.baiduMessage)), errors.collect(cdk.propertyValidator("customMessage", CfnCampaign_CampaignCustomMessagePropertyValidator)(properties.customMessage)), errors.collect(cdk.propertyValidator("defaultMessage", CfnCampaign_MessagePropertyValidator)(properties.defaultMessage)), errors.collect(cdk.propertyValidator("emailMessage", CfnCampaign_CampaignEmailMessagePropertyValidator)(properties.emailMessage)), errors.collect(cdk.propertyValidator("gcmMessage", CfnCampaign_MessagePropertyValidator)(properties.gcmMessage)), errors.collect(cdk.propertyValidator("inAppMessage", CfnCampaign_CampaignInAppMessagePropertyValidator)(properties.inAppMessage)), errors.collect(cdk.propertyValidator("smsMessage", CfnCampaign_CampaignSmsMessagePropertyValidator)(properties.smsMessage)), errors.wrap('supplied properties not correct for "MessageConfigurationProperty"');
    }
    function cfnCampaignMessageConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_MessageConfigurationPropertyValidator(properties).assertSuccess(), { ADMMessage: cfnCampaignMessagePropertyToCloudFormation(properties.admMessage), APNSMessage: cfnCampaignMessagePropertyToCloudFormation(properties.apnsMessage), BaiduMessage: cfnCampaignMessagePropertyToCloudFormation(properties.baiduMessage), CustomMessage: cfnCampaignCampaignCustomMessagePropertyToCloudFormation(properties.customMessage), DefaultMessage: cfnCampaignMessagePropertyToCloudFormation(properties.defaultMessage), EmailMessage: cfnCampaignCampaignEmailMessagePropertyToCloudFormation(properties.emailMessage), GCMMessage: cfnCampaignMessagePropertyToCloudFormation(properties.gcmMessage), InAppMessage: cfnCampaignCampaignInAppMessagePropertyToCloudFormation(properties.inAppMessage), SMSMessage: cfnCampaignCampaignSmsMessagePropertyToCloudFormation(properties.smsMessage) }) : properties;
    }
    function CfnCampaignMessageConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("admMessage", "ADMMessage", properties.ADMMessage != null ? CfnCampaignMessagePropertyFromCloudFormation(properties.ADMMessage) : void 0), ret.addPropertyResult("apnsMessage", "APNSMessage", properties.APNSMessage != null ? CfnCampaignMessagePropertyFromCloudFormation(properties.APNSMessage) : void 0), ret.addPropertyResult("baiduMessage", "BaiduMessage", properties.BaiduMessage != null ? CfnCampaignMessagePropertyFromCloudFormation(properties.BaiduMessage) : void 0), ret.addPropertyResult("customMessage", "CustomMessage", properties.CustomMessage != null ? CfnCampaignCampaignCustomMessagePropertyFromCloudFormation(properties.CustomMessage) : void 0), ret.addPropertyResult("defaultMessage", "DefaultMessage", properties.DefaultMessage != null ? CfnCampaignMessagePropertyFromCloudFormation(properties.DefaultMessage) : void 0), ret.addPropertyResult("emailMessage", "EmailMessage", properties.EmailMessage != null ? CfnCampaignCampaignEmailMessagePropertyFromCloudFormation(properties.EmailMessage) : void 0), ret.addPropertyResult("gcmMessage", "GCMMessage", properties.GCMMessage != null ? CfnCampaignMessagePropertyFromCloudFormation(properties.GCMMessage) : void 0), ret.addPropertyResult("inAppMessage", "InAppMessage", properties.InAppMessage != null ? CfnCampaignCampaignInAppMessagePropertyFromCloudFormation(properties.InAppMessage) : void 0), ret.addPropertyResult("smsMessage", "SMSMessage", properties.SMSMessage != null ? CfnCampaignCampaignSmsMessagePropertyFromCloudFormation(properties.SMSMessage) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCampaign_OverrideButtonConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("buttonAction", cdk.validateString)(properties.buttonAction)), errors.collect(cdk.propertyValidator("link", cdk.validateString)(properties.link)), errors.wrap('supplied properties not correct for "OverrideButtonConfigurationProperty"');
    }
    function cfnCampaignOverrideButtonConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_OverrideButtonConfigurationPropertyValidator(properties).assertSuccess(), { ButtonAction: cdk.stringToCloudFormation(properties.buttonAction), Link: cdk.stringToCloudFormation(properties.link) }) : properties;
    }
    function CfnCampaignOverrideButtonConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("buttonAction", "ButtonAction", properties.ButtonAction != null ? cfn_parse.FromCloudFormation.getString(properties.ButtonAction) : void 0), ret.addPropertyResult("link", "Link", properties.Link != null ? cfn_parse.FromCloudFormation.getString(properties.Link) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCampaign_QuietTimePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("end", cdk.requiredValidator)(properties.end)), errors.collect(cdk.propertyValidator("end", cdk.validateString)(properties.end)), errors.collect(cdk.propertyValidator("start", cdk.requiredValidator)(properties.start)), errors.collect(cdk.propertyValidator("start", cdk.validateString)(properties.start)), errors.wrap('supplied properties not correct for "QuietTimeProperty"');
    }
    function cfnCampaignQuietTimePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_QuietTimePropertyValidator(properties).assertSuccess(), { End: cdk.stringToCloudFormation(properties.end), Start: cdk.stringToCloudFormation(properties.start) }) : properties;
    }
    function CfnCampaignQuietTimePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("end", "End", cfn_parse.FromCloudFormation.getString(properties.End)), ret.addPropertyResult("start", "Start", cfn_parse.FromCloudFormation.getString(properties.Start)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCampaign_SchedulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endTime", cdk.validateString)(properties.endTime)), errors.collect(cdk.propertyValidator("eventFilter", CfnCampaign_CampaignEventFilterPropertyValidator)(properties.eventFilter)), errors.collect(cdk.propertyValidator("frequency", cdk.validateString)(properties.frequency)), errors.collect(cdk.propertyValidator("isLocalTime", cdk.validateBoolean)(properties.isLocalTime)), errors.collect(cdk.propertyValidator("quietTime", CfnCampaign_QuietTimePropertyValidator)(properties.quietTime)), errors.collect(cdk.propertyValidator("startTime", cdk.validateString)(properties.startTime)), errors.collect(cdk.propertyValidator("timeZone", cdk.validateString)(properties.timeZone)), errors.wrap('supplied properties not correct for "ScheduleProperty"');
    }
    function cfnCampaignSchedulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_SchedulePropertyValidator(properties).assertSuccess(), { EndTime: cdk.stringToCloudFormation(properties.endTime), EventFilter: cfnCampaignCampaignEventFilterPropertyToCloudFormation(properties.eventFilter), Frequency: cdk.stringToCloudFormation(properties.frequency), IsLocalTime: cdk.booleanToCloudFormation(properties.isLocalTime), QuietTime: cfnCampaignQuietTimePropertyToCloudFormation(properties.quietTime), StartTime: cdk.stringToCloudFormation(properties.startTime), TimeZone: cdk.stringToCloudFormation(properties.timeZone) }) : properties;
    }
    function CfnCampaignSchedulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endTime", "EndTime", properties.EndTime != null ? cfn_parse.FromCloudFormation.getString(properties.EndTime) : void 0), ret.addPropertyResult("eventFilter", "EventFilter", properties.EventFilter != null ? CfnCampaignCampaignEventFilterPropertyFromCloudFormation(properties.EventFilter) : void 0), ret.addPropertyResult("frequency", "Frequency", properties.Frequency != null ? cfn_parse.FromCloudFormation.getString(properties.Frequency) : void 0), ret.addPropertyResult("isLocalTime", "IsLocalTime", properties.IsLocalTime != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IsLocalTime) : void 0), ret.addPropertyResult("quietTime", "QuietTime", properties.QuietTime != null ? CfnCampaignQuietTimePropertyFromCloudFormation(properties.QuietTime) : void 0), ret.addPropertyResult("startTime", "StartTime", properties.StartTime != null ? cfn_parse.FromCloudFormation.getString(properties.StartTime) : void 0), ret.addPropertyResult("timeZone", "TimeZone", properties.TimeZone != null ? cfn_parse.FromCloudFormation.getString(properties.TimeZone) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCampaign_SetDimensionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dimensionType", cdk.validateString)(properties.dimensionType)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "SetDimensionProperty"');
    }
    function cfnCampaignSetDimensionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_SetDimensionPropertyValidator(properties).assertSuccess(), { DimensionType: cdk.stringToCloudFormation(properties.dimensionType), Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnCampaignSetDimensionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dimensionType", "DimensionType", properties.DimensionType != null ? cfn_parse.FromCloudFormation.getString(properties.DimensionType) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCampaign_TemplatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "TemplateProperty"');
    }
    function cfnCampaignTemplatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_TemplatePropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnCampaignTemplatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getString(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCampaign_TemplateConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("emailTemplate", CfnCampaign_TemplatePropertyValidator)(properties.emailTemplate)), errors.collect(cdk.propertyValidator("pushTemplate", CfnCampaign_TemplatePropertyValidator)(properties.pushTemplate)), errors.collect(cdk.propertyValidator("smsTemplate", CfnCampaign_TemplatePropertyValidator)(properties.smsTemplate)), errors.collect(cdk.propertyValidator("voiceTemplate", CfnCampaign_TemplatePropertyValidator)(properties.voiceTemplate)), errors.wrap('supplied properties not correct for "TemplateConfigurationProperty"');
    }
    function cfnCampaignTemplateConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_TemplateConfigurationPropertyValidator(properties).assertSuccess(), { EmailTemplate: cfnCampaignTemplatePropertyToCloudFormation(properties.emailTemplate), PushTemplate: cfnCampaignTemplatePropertyToCloudFormation(properties.pushTemplate), SMSTemplate: cfnCampaignTemplatePropertyToCloudFormation(properties.smsTemplate), VoiceTemplate: cfnCampaignTemplatePropertyToCloudFormation(properties.voiceTemplate) }) : properties;
    }
    function CfnCampaignTemplateConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("emailTemplate", "EmailTemplate", properties.EmailTemplate != null ? CfnCampaignTemplatePropertyFromCloudFormation(properties.EmailTemplate) : void 0), ret.addPropertyResult("pushTemplate", "PushTemplate", properties.PushTemplate != null ? CfnCampaignTemplatePropertyFromCloudFormation(properties.PushTemplate) : void 0), ret.addPropertyResult("smsTemplate", "SMSTemplate", properties.SMSTemplate != null ? CfnCampaignTemplatePropertyFromCloudFormation(properties.SMSTemplate) : void 0), ret.addPropertyResult("voiceTemplate", "VoiceTemplate", properties.VoiceTemplate != null ? CfnCampaignTemplatePropertyFromCloudFormation(properties.VoiceTemplate) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCampaign_WriteTreatmentResourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customDeliveryConfiguration", CfnCampaign_CustomDeliveryConfigurationPropertyValidator)(properties.customDeliveryConfiguration)), errors.collect(cdk.propertyValidator("messageConfiguration", CfnCampaign_MessageConfigurationPropertyValidator)(properties.messageConfiguration)), errors.collect(cdk.propertyValidator("schedule", CfnCampaign_SchedulePropertyValidator)(properties.schedule)), errors.collect(cdk.propertyValidator("sizePercent", cdk.validateNumber)(properties.sizePercent)), errors.collect(cdk.propertyValidator("templateConfiguration", CfnCampaign_TemplateConfigurationPropertyValidator)(properties.templateConfiguration)), errors.collect(cdk.propertyValidator("treatmentDescription", cdk.validateString)(properties.treatmentDescription)), errors.collect(cdk.propertyValidator("treatmentName", cdk.validateString)(properties.treatmentName)), errors.wrap('supplied properties not correct for "WriteTreatmentResourceProperty"');
    }
    function cfnCampaignWriteTreatmentResourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCampaign_WriteTreatmentResourcePropertyValidator(properties).assertSuccess(), { CustomDeliveryConfiguration: cfnCampaignCustomDeliveryConfigurationPropertyToCloudFormation(properties.customDeliveryConfiguration), MessageConfiguration: cfnCampaignMessageConfigurationPropertyToCloudFormation(properties.messageConfiguration), Schedule: cfnCampaignSchedulePropertyToCloudFormation(properties.schedule), SizePercent: cdk.numberToCloudFormation(properties.sizePercent), TemplateConfiguration: cfnCampaignTemplateConfigurationPropertyToCloudFormation(properties.templateConfiguration), TreatmentDescription: cdk.stringToCloudFormation(properties.treatmentDescription), TreatmentName: cdk.stringToCloudFormation(properties.treatmentName) }) : properties;
    }
    function CfnCampaignWriteTreatmentResourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customDeliveryConfiguration", "CustomDeliveryConfiguration", properties.CustomDeliveryConfiguration != null ? CfnCampaignCustomDeliveryConfigurationPropertyFromCloudFormation(properties.CustomDeliveryConfiguration) : void 0), ret.addPropertyResult("messageConfiguration", "MessageConfiguration", properties.MessageConfiguration != null ? CfnCampaignMessageConfigurationPropertyFromCloudFormation(properties.MessageConfiguration) : void 0), ret.addPropertyResult("schedule", "Schedule", properties.Schedule != null ? CfnCampaignSchedulePropertyFromCloudFormation(properties.Schedule) : void 0), ret.addPropertyResult("sizePercent", "SizePercent", properties.SizePercent != null ? cfn_parse.FromCloudFormation.getNumber(properties.SizePercent) : void 0), ret.addPropertyResult("templateConfiguration", "TemplateConfiguration", properties.TemplateConfiguration != null ? CfnCampaignTemplateConfigurationPropertyFromCloudFormation(properties.TemplateConfiguration) : void 0), ret.addPropertyResult("treatmentDescription", "TreatmentDescription", properties.TreatmentDescription != null ? cfn_parse.FromCloudFormation.getString(properties.TreatmentDescription) : void 0), ret.addPropertyResult("treatmentName", "TreatmentName", properties.TreatmentName != null ? cfn_parse.FromCloudFormation.getString(properties.TreatmentName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEmailChannelPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationId", cdk.requiredValidator)(properties.applicationId)), errors.collect(cdk.propertyValidator("applicationId", cdk.validateString)(properties.applicationId)), errors.collect(cdk.propertyValidator("configurationSet", cdk.validateString)(properties.configurationSet)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("fromAddress", cdk.requiredValidator)(properties.fromAddress)), errors.collect(cdk.propertyValidator("fromAddress", cdk.validateString)(properties.fromAddress)), errors.collect(cdk.propertyValidator("identity", cdk.requiredValidator)(properties.identity)), errors.collect(cdk.propertyValidator("identity", cdk.validateString)(properties.identity)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "CfnEmailChannelProps"');
    }
    function cfnEmailChannelPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEmailChannelPropsValidator(properties).assertSuccess(), { ApplicationId: cdk.stringToCloudFormation(properties.applicationId), FromAddress: cdk.stringToCloudFormation(properties.fromAddress), Identity: cdk.stringToCloudFormation(properties.identity), ConfigurationSet: cdk.stringToCloudFormation(properties.configurationSet), Enabled: cdk.booleanToCloudFormation(properties.enabled), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnEmailChannelPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationId", "ApplicationId", cfn_parse.FromCloudFormation.getString(properties.ApplicationId)), ret.addPropertyResult("fromAddress", "FromAddress", cfn_parse.FromCloudFormation.getString(properties.FromAddress)), ret.addPropertyResult("identity", "Identity", cfn_parse.FromCloudFormation.getString(properties.Identity)), ret.addPropertyResult("configurationSet", "ConfigurationSet", properties.ConfigurationSet != null ? cfn_parse.FromCloudFormation.getString(properties.ConfigurationSet) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEmailChannel = class _CfnEmailChannel extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEmailChannelPropsFromCloudFormation(resourceProperties), ret = new _CfnEmailChannel(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEmailChannel.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_pinpoint_CfnEmailChannelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEmailChannel), error;
        }
        cdk.requireProperty(props, "applicationId", this), cdk.requireProperty(props, "fromAddress", this), cdk.requireProperty(props, "identity", this), this.applicationId = props.applicationId, this.fromAddress = props.fromAddress, this.identity = props.identity, this.configurationSet = props.configurationSet, this.enabled = props.enabled, this.roleArn = props.roleArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEmailChannel.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationId: this.applicationId, fromAddress: this.fromAddress, identity: this.identity, configurationSet: this.configurationSet, enabled: this.enabled, roleArn: this.roleArn };
      }
      renderProperties(props) {
        return cfnEmailChannelPropsToCloudFormation(props);
      }
    };
    _k = JSII_RTTI_SYMBOL_1, CfnEmailChannel[_k] = { fqn: "aws-cdk-lib.aws_pinpoint.CfnEmailChannel", version: "2.80.0" }, CfnEmailChannel.CFN_RESOURCE_TYPE_NAME = "AWS::Pinpoint::EmailChannel", exports2.CfnEmailChannel = CfnEmailChannel;
    function CfnEmailTemplatePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultSubstitutions", cdk.validateString)(properties.defaultSubstitutions)), errors.collect(cdk.propertyValidator("htmlPart", cdk.validateString)(properties.htmlPart)), errors.collect(cdk.propertyValidator("subject", cdk.requiredValidator)(properties.subject)), errors.collect(cdk.propertyValidator("subject", cdk.validateString)(properties.subject)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.collect(cdk.propertyValidator("templateDescription", cdk.validateString)(properties.templateDescription)), errors.collect(cdk.propertyValidator("templateName", cdk.requiredValidator)(properties.templateName)), errors.collect(cdk.propertyValidator("templateName", cdk.validateString)(properties.templateName)), errors.collect(cdk.propertyValidator("textPart", cdk.validateString)(properties.textPart)), errors.wrap('supplied properties not correct for "CfnEmailTemplateProps"');
    }
    function cfnEmailTemplatePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEmailTemplatePropsValidator(properties).assertSuccess(), { Subject: cdk.stringToCloudFormation(properties.subject), TemplateName: cdk.stringToCloudFormation(properties.templateName), DefaultSubstitutions: cdk.stringToCloudFormation(properties.defaultSubstitutions), HtmlPart: cdk.stringToCloudFormation(properties.htmlPart), Tags: cdk.objectToCloudFormation(properties.tags), TemplateDescription: cdk.stringToCloudFormation(properties.templateDescription), TextPart: cdk.stringToCloudFormation(properties.textPart) }) : properties;
    }
    function CfnEmailTemplatePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("subject", "Subject", cfn_parse.FromCloudFormation.getString(properties.Subject)), ret.addPropertyResult("templateName", "TemplateName", cfn_parse.FromCloudFormation.getString(properties.TemplateName)), ret.addPropertyResult("defaultSubstitutions", "DefaultSubstitutions", properties.DefaultSubstitutions != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultSubstitutions) : void 0), ret.addPropertyResult("htmlPart", "HtmlPart", properties.HtmlPart != null ? cfn_parse.FromCloudFormation.getString(properties.HtmlPart) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addPropertyResult("templateDescription", "TemplateDescription", properties.TemplateDescription != null ? cfn_parse.FromCloudFormation.getString(properties.TemplateDescription) : void 0), ret.addPropertyResult("textPart", "TextPart", properties.TextPart != null ? cfn_parse.FromCloudFormation.getString(properties.TextPart) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEmailTemplate = class _CfnEmailTemplate extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEmailTemplatePropsFromCloudFormation(resourceProperties), ret = new _CfnEmailTemplate(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEmailTemplate.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_pinpoint_CfnEmailTemplateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEmailTemplate), error;
        }
        cdk.requireProperty(props, "subject", this), cdk.requireProperty(props, "templateName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.subject = props.subject, this.templateName = props.templateName, this.defaultSubstitutions = props.defaultSubstitutions, this.htmlPart = props.htmlPart, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Pinpoint::EmailTemplate", props.tags, { tagPropertyName: "tags" }), this.templateDescription = props.templateDescription, this.textPart = props.textPart;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEmailTemplate.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { subject: this.subject, templateName: this.templateName, defaultSubstitutions: this.defaultSubstitutions, htmlPart: this.htmlPart, tags: this.tags.renderTags(), templateDescription: this.templateDescription, textPart: this.textPart };
      }
      renderProperties(props) {
        return cfnEmailTemplatePropsToCloudFormation(props);
      }
    };
    _l = JSII_RTTI_SYMBOL_1, CfnEmailTemplate[_l] = { fqn: "aws-cdk-lib.aws_pinpoint.CfnEmailTemplate", version: "2.80.0" }, CfnEmailTemplate.CFN_RESOURCE_TYPE_NAME = "AWS::Pinpoint::EmailTemplate", exports2.CfnEmailTemplate = CfnEmailTemplate;
    function CfnEventStreamPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationId", cdk.requiredValidator)(properties.applicationId)), errors.collect(cdk.propertyValidator("applicationId", cdk.validateString)(properties.applicationId)), errors.collect(cdk.propertyValidator("destinationStreamArn", cdk.requiredValidator)(properties.destinationStreamArn)), errors.collect(cdk.propertyValidator("destinationStreamArn", cdk.validateString)(properties.destinationStreamArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "CfnEventStreamProps"');
    }
    function cfnEventStreamPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventStreamPropsValidator(properties).assertSuccess(), { ApplicationId: cdk.stringToCloudFormation(properties.applicationId), DestinationStreamArn: cdk.stringToCloudFormation(properties.destinationStreamArn), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnEventStreamPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationId", "ApplicationId", cfn_parse.FromCloudFormation.getString(properties.ApplicationId)), ret.addPropertyResult("destinationStreamArn", "DestinationStreamArn", cfn_parse.FromCloudFormation.getString(properties.DestinationStreamArn)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEventStream = class _CfnEventStream extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEventStreamPropsFromCloudFormation(resourceProperties), ret = new _CfnEventStream(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEventStream.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_pinpoint_CfnEventStreamProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEventStream), error;
        }
        cdk.requireProperty(props, "applicationId", this), cdk.requireProperty(props, "destinationStreamArn", this), cdk.requireProperty(props, "roleArn", this), this.applicationId = props.applicationId, this.destinationStreamArn = props.destinationStreamArn, this.roleArn = props.roleArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEventStream.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationId: this.applicationId, destinationStreamArn: this.destinationStreamArn, roleArn: this.roleArn };
      }
      renderProperties(props) {
        return cfnEventStreamPropsToCloudFormation(props);
      }
    };
    _m = JSII_RTTI_SYMBOL_1, CfnEventStream[_m] = { fqn: "aws-cdk-lib.aws_pinpoint.CfnEventStream", version: "2.80.0" }, CfnEventStream.CFN_RESOURCE_TYPE_NAME = "AWS::Pinpoint::EventStream", exports2.CfnEventStream = CfnEventStream;
    function CfnGCMChannelPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiKey", cdk.requiredValidator)(properties.apiKey)), errors.collect(cdk.propertyValidator("apiKey", cdk.validateString)(properties.apiKey)), errors.collect(cdk.propertyValidator("applicationId", cdk.requiredValidator)(properties.applicationId)), errors.collect(cdk.propertyValidator("applicationId", cdk.validateString)(properties.applicationId)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "CfnGCMChannelProps"');
    }
    function cfnGCMChannelPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGCMChannelPropsValidator(properties).assertSuccess(), { ApiKey: cdk.stringToCloudFormation(properties.apiKey), ApplicationId: cdk.stringToCloudFormation(properties.applicationId), Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnGCMChannelPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("apiKey", "ApiKey", cfn_parse.FromCloudFormation.getString(properties.ApiKey)), ret.addPropertyResult("applicationId", "ApplicationId", cfn_parse.FromCloudFormation.getString(properties.ApplicationId)), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnGCMChannel = class _CfnGCMChannel extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnGCMChannelPropsFromCloudFormation(resourceProperties), ret = new _CfnGCMChannel(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnGCMChannel.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_pinpoint_CfnGCMChannelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnGCMChannel), error;
        }
        cdk.requireProperty(props, "apiKey", this), cdk.requireProperty(props, "applicationId", this), this.apiKey = props.apiKey, this.applicationId = props.applicationId, this.enabled = props.enabled;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnGCMChannel.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { apiKey: this.apiKey, applicationId: this.applicationId, enabled: this.enabled };
      }
      renderProperties(props) {
        return cfnGCMChannelPropsToCloudFormation(props);
      }
    };
    _o = JSII_RTTI_SYMBOL_1, CfnGCMChannel[_o] = { fqn: "aws-cdk-lib.aws_pinpoint.CfnGCMChannel", version: "2.80.0" }, CfnGCMChannel.CFN_RESOURCE_TYPE_NAME = "AWS::Pinpoint::GCMChannel", exports2.CfnGCMChannel = CfnGCMChannel;
    function CfnInAppTemplatePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("content", cdk.listValidator(CfnInAppTemplate_InAppMessageContentPropertyValidator))(properties.content)), errors.collect(cdk.propertyValidator("customConfig", cdk.validateObject)(properties.customConfig)), errors.collect(cdk.propertyValidator("layout", cdk.validateString)(properties.layout)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.collect(cdk.propertyValidator("templateDescription", cdk.validateString)(properties.templateDescription)), errors.collect(cdk.propertyValidator("templateName", cdk.requiredValidator)(properties.templateName)), errors.collect(cdk.propertyValidator("templateName", cdk.validateString)(properties.templateName)), errors.wrap('supplied properties not correct for "CfnInAppTemplateProps"');
    }
    function cfnInAppTemplatePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInAppTemplatePropsValidator(properties).assertSuccess(), { TemplateName: cdk.stringToCloudFormation(properties.templateName), Content: cdk.listMapper(cfnInAppTemplateInAppMessageContentPropertyToCloudFormation)(properties.content), CustomConfig: cdk.objectToCloudFormation(properties.customConfig), Layout: cdk.stringToCloudFormation(properties.layout), Tags: cdk.objectToCloudFormation(properties.tags), TemplateDescription: cdk.stringToCloudFormation(properties.templateDescription) }) : properties;
    }
    function CfnInAppTemplatePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("templateName", "TemplateName", cfn_parse.FromCloudFormation.getString(properties.TemplateName)), ret.addPropertyResult("content", "Content", properties.Content != null ? cfn_parse.FromCloudFormation.getArray(CfnInAppTemplateInAppMessageContentPropertyFromCloudFormation)(properties.Content) : void 0), ret.addPropertyResult("customConfig", "CustomConfig", properties.CustomConfig != null ? cfn_parse.FromCloudFormation.getAny(properties.CustomConfig) : void 0), ret.addPropertyResult("layout", "Layout", properties.Layout != null ? cfn_parse.FromCloudFormation.getString(properties.Layout) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addPropertyResult("templateDescription", "TemplateDescription", properties.TemplateDescription != null ? cfn_parse.FromCloudFormation.getString(properties.TemplateDescription) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnInAppTemplate = class _CfnInAppTemplate extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnInAppTemplatePropsFromCloudFormation(resourceProperties), ret = new _CfnInAppTemplate(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnInAppTemplate.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_pinpoint_CfnInAppTemplateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnInAppTemplate), error;
        }
        cdk.requireProperty(props, "templateName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.templateName = props.templateName, this.content = props.content, this.customConfig = props.customConfig, this.layout = props.layout, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Pinpoint::InAppTemplate", props.tags, { tagPropertyName: "tags" }), this.templateDescription = props.templateDescription;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnInAppTemplate.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { templateName: this.templateName, content: this.content, customConfig: this.customConfig, layout: this.layout, tags: this.tags.renderTags(), templateDescription: this.templateDescription };
      }
      renderProperties(props) {
        return cfnInAppTemplatePropsToCloudFormation(props);
      }
    };
    _p = JSII_RTTI_SYMBOL_1, CfnInAppTemplate[_p] = { fqn: "aws-cdk-lib.aws_pinpoint.CfnInAppTemplate", version: "2.80.0" }, CfnInAppTemplate.CFN_RESOURCE_TYPE_NAME = "AWS::Pinpoint::InAppTemplate", exports2.CfnInAppTemplate = CfnInAppTemplate;
    function CfnInAppTemplate_BodyConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alignment", cdk.validateString)(properties.alignment)), errors.collect(cdk.propertyValidator("body", cdk.validateString)(properties.body)), errors.collect(cdk.propertyValidator("textColor", cdk.validateString)(properties.textColor)), errors.wrap('supplied properties not correct for "BodyConfigProperty"');
    }
    function cfnInAppTemplateBodyConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInAppTemplate_BodyConfigPropertyValidator(properties).assertSuccess(), { Alignment: cdk.stringToCloudFormation(properties.alignment), Body: cdk.stringToCloudFormation(properties.body), TextColor: cdk.stringToCloudFormation(properties.textColor) }) : properties;
    }
    function CfnInAppTemplateBodyConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alignment", "Alignment", properties.Alignment != null ? cfn_parse.FromCloudFormation.getString(properties.Alignment) : void 0), ret.addPropertyResult("body", "Body", properties.Body != null ? cfn_parse.FromCloudFormation.getString(properties.Body) : void 0), ret.addPropertyResult("textColor", "TextColor", properties.TextColor != null ? cfn_parse.FromCloudFormation.getString(properties.TextColor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInAppTemplate_ButtonConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("android", CfnInAppTemplate_OverrideButtonConfigurationPropertyValidator)(properties.android)), errors.collect(cdk.propertyValidator("defaultConfig", CfnInAppTemplate_DefaultButtonConfigurationPropertyValidator)(properties.defaultConfig)), errors.collect(cdk.propertyValidator("ios", CfnInAppTemplate_OverrideButtonConfigurationPropertyValidator)(properties.ios)), errors.collect(cdk.propertyValidator("web", CfnInAppTemplate_OverrideButtonConfigurationPropertyValidator)(properties.web)), errors.wrap('supplied properties not correct for "ButtonConfigProperty"');
    }
    function cfnInAppTemplateButtonConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInAppTemplate_ButtonConfigPropertyValidator(properties).assertSuccess(), { Android: cfnInAppTemplateOverrideButtonConfigurationPropertyToCloudFormation(properties.android), DefaultConfig: cfnInAppTemplateDefaultButtonConfigurationPropertyToCloudFormation(properties.defaultConfig), IOS: cfnInAppTemplateOverrideButtonConfigurationPropertyToCloudFormation(properties.ios), Web: cfnInAppTemplateOverrideButtonConfigurationPropertyToCloudFormation(properties.web) }) : properties;
    }
    function CfnInAppTemplateButtonConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("android", "Android", properties.Android != null ? CfnInAppTemplateOverrideButtonConfigurationPropertyFromCloudFormation(properties.Android) : void 0), ret.addPropertyResult("defaultConfig", "DefaultConfig", properties.DefaultConfig != null ? CfnInAppTemplateDefaultButtonConfigurationPropertyFromCloudFormation(properties.DefaultConfig) : void 0), ret.addPropertyResult("ios", "IOS", properties.IOS != null ? CfnInAppTemplateOverrideButtonConfigurationPropertyFromCloudFormation(properties.IOS) : void 0), ret.addPropertyResult("web", "Web", properties.Web != null ? CfnInAppTemplateOverrideButtonConfigurationPropertyFromCloudFormation(properties.Web) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInAppTemplate_DefaultButtonConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("backgroundColor", cdk.validateString)(properties.backgroundColor)), errors.collect(cdk.propertyValidator("borderRadius", cdk.validateNumber)(properties.borderRadius)), errors.collect(cdk.propertyValidator("buttonAction", cdk.validateString)(properties.buttonAction)), errors.collect(cdk.propertyValidator("link", cdk.validateString)(properties.link)), errors.collect(cdk.propertyValidator("text", cdk.validateString)(properties.text)), errors.collect(cdk.propertyValidator("textColor", cdk.validateString)(properties.textColor)), errors.wrap('supplied properties not correct for "DefaultButtonConfigurationProperty"');
    }
    function cfnInAppTemplateDefaultButtonConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInAppTemplate_DefaultButtonConfigurationPropertyValidator(properties).assertSuccess(), { BackgroundColor: cdk.stringToCloudFormation(properties.backgroundColor), BorderRadius: cdk.numberToCloudFormation(properties.borderRadius), ButtonAction: cdk.stringToCloudFormation(properties.buttonAction), Link: cdk.stringToCloudFormation(properties.link), Text: cdk.stringToCloudFormation(properties.text), TextColor: cdk.stringToCloudFormation(properties.textColor) }) : properties;
    }
    function CfnInAppTemplateDefaultButtonConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("backgroundColor", "BackgroundColor", properties.BackgroundColor != null ? cfn_parse.FromCloudFormation.getString(properties.BackgroundColor) : void 0), ret.addPropertyResult("borderRadius", "BorderRadius", properties.BorderRadius != null ? cfn_parse.FromCloudFormation.getNumber(properties.BorderRadius) : void 0), ret.addPropertyResult("buttonAction", "ButtonAction", properties.ButtonAction != null ? cfn_parse.FromCloudFormation.getString(properties.ButtonAction) : void 0), ret.addPropertyResult("link", "Link", properties.Link != null ? cfn_parse.FromCloudFormation.getString(properties.Link) : void 0), ret.addPropertyResult("text", "Text", properties.Text != null ? cfn_parse.FromCloudFormation.getString(properties.Text) : void 0), ret.addPropertyResult("textColor", "TextColor", properties.TextColor != null ? cfn_parse.FromCloudFormation.getString(properties.TextColor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInAppTemplate_HeaderConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alignment", cdk.validateString)(properties.alignment)), errors.collect(cdk.propertyValidator("header", cdk.validateString)(properties.header)), errors.collect(cdk.propertyValidator("textColor", cdk.validateString)(properties.textColor)), errors.wrap('supplied properties not correct for "HeaderConfigProperty"');
    }
    function cfnInAppTemplateHeaderConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInAppTemplate_HeaderConfigPropertyValidator(properties).assertSuccess(), { Alignment: cdk.stringToCloudFormation(properties.alignment), Header: cdk.stringToCloudFormation(properties.header), TextColor: cdk.stringToCloudFormation(properties.textColor) }) : properties;
    }
    function CfnInAppTemplateHeaderConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alignment", "Alignment", properties.Alignment != null ? cfn_parse.FromCloudFormation.getString(properties.Alignment) : void 0), ret.addPropertyResult("header", "Header", properties.Header != null ? cfn_parse.FromCloudFormation.getString(properties.Header) : void 0), ret.addPropertyResult("textColor", "TextColor", properties.TextColor != null ? cfn_parse.FromCloudFormation.getString(properties.TextColor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInAppTemplate_InAppMessageContentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("backgroundColor", cdk.validateString)(properties.backgroundColor)), errors.collect(cdk.propertyValidator("bodyConfig", CfnInAppTemplate_BodyConfigPropertyValidator)(properties.bodyConfig)), errors.collect(cdk.propertyValidator("headerConfig", CfnInAppTemplate_HeaderConfigPropertyValidator)(properties.headerConfig)), errors.collect(cdk.propertyValidator("imageUrl", cdk.validateString)(properties.imageUrl)), errors.collect(cdk.propertyValidator("primaryBtn", CfnInAppTemplate_ButtonConfigPropertyValidator)(properties.primaryBtn)), errors.collect(cdk.propertyValidator("secondaryBtn", CfnInAppTemplate_ButtonConfigPropertyValidator)(properties.secondaryBtn)), errors.wrap('supplied properties not correct for "InAppMessageContentProperty"');
    }
    function cfnInAppTemplateInAppMessageContentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInAppTemplate_InAppMessageContentPropertyValidator(properties).assertSuccess(), { BackgroundColor: cdk.stringToCloudFormation(properties.backgroundColor), BodyConfig: cfnInAppTemplateBodyConfigPropertyToCloudFormation(properties.bodyConfig), HeaderConfig: cfnInAppTemplateHeaderConfigPropertyToCloudFormation(properties.headerConfig), ImageUrl: cdk.stringToCloudFormation(properties.imageUrl), PrimaryBtn: cfnInAppTemplateButtonConfigPropertyToCloudFormation(properties.primaryBtn), SecondaryBtn: cfnInAppTemplateButtonConfigPropertyToCloudFormation(properties.secondaryBtn) }) : properties;
    }
    function CfnInAppTemplateInAppMessageContentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("backgroundColor", "BackgroundColor", properties.BackgroundColor != null ? cfn_parse.FromCloudFormation.getString(properties.BackgroundColor) : void 0), ret.addPropertyResult("bodyConfig", "BodyConfig", properties.BodyConfig != null ? CfnInAppTemplateBodyConfigPropertyFromCloudFormation(properties.BodyConfig) : void 0), ret.addPropertyResult("headerConfig", "HeaderConfig", properties.HeaderConfig != null ? CfnInAppTemplateHeaderConfigPropertyFromCloudFormation(properties.HeaderConfig) : void 0), ret.addPropertyResult("imageUrl", "ImageUrl", properties.ImageUrl != null ? cfn_parse.FromCloudFormation.getString(properties.ImageUrl) : void 0), ret.addPropertyResult("primaryBtn", "PrimaryBtn", properties.PrimaryBtn != null ? CfnInAppTemplateButtonConfigPropertyFromCloudFormation(properties.PrimaryBtn) : void 0), ret.addPropertyResult("secondaryBtn", "SecondaryBtn", properties.SecondaryBtn != null ? CfnInAppTemplateButtonConfigPropertyFromCloudFormation(properties.SecondaryBtn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInAppTemplate_OverrideButtonConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("buttonAction", cdk.validateString)(properties.buttonAction)), errors.collect(cdk.propertyValidator("link", cdk.validateString)(properties.link)), errors.wrap('supplied properties not correct for "OverrideButtonConfigurationProperty"');
    }
    function cfnInAppTemplateOverrideButtonConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInAppTemplate_OverrideButtonConfigurationPropertyValidator(properties).assertSuccess(), { ButtonAction: cdk.stringToCloudFormation(properties.buttonAction), Link: cdk.stringToCloudFormation(properties.link) }) : properties;
    }
    function CfnInAppTemplateOverrideButtonConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("buttonAction", "ButtonAction", properties.ButtonAction != null ? cfn_parse.FromCloudFormation.getString(properties.ButtonAction) : void 0), ret.addPropertyResult("link", "Link", properties.Link != null ? cfn_parse.FromCloudFormation.getString(properties.Link) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPushTemplatePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("adm", CfnPushTemplate_AndroidPushNotificationTemplatePropertyValidator)(properties.adm)), errors.collect(cdk.propertyValidator("apns", CfnPushTemplate_APNSPushNotificationTemplatePropertyValidator)(properties.apns)), errors.collect(cdk.propertyValidator("baidu", CfnPushTemplate_AndroidPushNotificationTemplatePropertyValidator)(properties.baidu)), errors.collect(cdk.propertyValidator("default", CfnPushTemplate_DefaultPushNotificationTemplatePropertyValidator)(properties.default)), errors.collect(cdk.propertyValidator("defaultSubstitutions", cdk.validateString)(properties.defaultSubstitutions)), errors.collect(cdk.propertyValidator("gcm", CfnPushTemplate_AndroidPushNotificationTemplatePropertyValidator)(properties.gcm)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.collect(cdk.propertyValidator("templateDescription", cdk.validateString)(properties.templateDescription)), errors.collect(cdk.propertyValidator("templateName", cdk.requiredValidator)(properties.templateName)), errors.collect(cdk.propertyValidator("templateName", cdk.validateString)(properties.templateName)), errors.wrap('supplied properties not correct for "CfnPushTemplateProps"');
    }
    function cfnPushTemplatePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPushTemplatePropsValidator(properties).assertSuccess(), { TemplateName: cdk.stringToCloudFormation(properties.templateName), ADM: cfnPushTemplateAndroidPushNotificationTemplatePropertyToCloudFormation(properties.adm), APNS: cfnPushTemplateAPNSPushNotificationTemplatePropertyToCloudFormation(properties.apns), Baidu: cfnPushTemplateAndroidPushNotificationTemplatePropertyToCloudFormation(properties.baidu), Default: cfnPushTemplateDefaultPushNotificationTemplatePropertyToCloudFormation(properties.default), DefaultSubstitutions: cdk.stringToCloudFormation(properties.defaultSubstitutions), GCM: cfnPushTemplateAndroidPushNotificationTemplatePropertyToCloudFormation(properties.gcm), Tags: cdk.objectToCloudFormation(properties.tags), TemplateDescription: cdk.stringToCloudFormation(properties.templateDescription) }) : properties;
    }
    function CfnPushTemplatePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("templateName", "TemplateName", cfn_parse.FromCloudFormation.getString(properties.TemplateName)), ret.addPropertyResult("adm", "ADM", properties.ADM != null ? CfnPushTemplateAndroidPushNotificationTemplatePropertyFromCloudFormation(properties.ADM) : void 0), ret.addPropertyResult("apns", "APNS", properties.APNS != null ? CfnPushTemplateAPNSPushNotificationTemplatePropertyFromCloudFormation(properties.APNS) : void 0), ret.addPropertyResult("baidu", "Baidu", properties.Baidu != null ? CfnPushTemplateAndroidPushNotificationTemplatePropertyFromCloudFormation(properties.Baidu) : void 0), ret.addPropertyResult("default", "Default", properties.Default != null ? CfnPushTemplateDefaultPushNotificationTemplatePropertyFromCloudFormation(properties.Default) : void 0), ret.addPropertyResult("defaultSubstitutions", "DefaultSubstitutions", properties.DefaultSubstitutions != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultSubstitutions) : void 0), ret.addPropertyResult("gcm", "GCM", properties.GCM != null ? CfnPushTemplateAndroidPushNotificationTemplatePropertyFromCloudFormation(properties.GCM) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addPropertyResult("templateDescription", "TemplateDescription", properties.TemplateDescription != null ? cfn_parse.FromCloudFormation.getString(properties.TemplateDescription) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPushTemplate = class _CfnPushTemplate extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPushTemplatePropsFromCloudFormation(resourceProperties), ret = new _CfnPushTemplate(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPushTemplate.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_pinpoint_CfnPushTemplateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPushTemplate), error;
        }
        cdk.requireProperty(props, "templateName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.templateName = props.templateName, this.adm = props.adm, this.apns = props.apns, this.baidu = props.baidu, this.default = props.default, this.defaultSubstitutions = props.defaultSubstitutions, this.gcm = props.gcm, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Pinpoint::PushTemplate", props.tags, { tagPropertyName: "tags" }), this.templateDescription = props.templateDescription;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPushTemplate.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { templateName: this.templateName, adm: this.adm, apns: this.apns, baidu: this.baidu, default: this.default, defaultSubstitutions: this.defaultSubstitutions, gcm: this.gcm, tags: this.tags.renderTags(), templateDescription: this.templateDescription };
      }
      renderProperties(props) {
        return cfnPushTemplatePropsToCloudFormation(props);
      }
    };
    _q = JSII_RTTI_SYMBOL_1, CfnPushTemplate[_q] = { fqn: "aws-cdk-lib.aws_pinpoint.CfnPushTemplate", version: "2.80.0" }, CfnPushTemplate.CFN_RESOURCE_TYPE_NAME = "AWS::Pinpoint::PushTemplate", exports2.CfnPushTemplate = CfnPushTemplate;
    function CfnPushTemplate_APNSPushNotificationTemplatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.validateString)(properties.action)), errors.collect(cdk.propertyValidator("body", cdk.validateString)(properties.body)), errors.collect(cdk.propertyValidator("mediaUrl", cdk.validateString)(properties.mediaUrl)), errors.collect(cdk.propertyValidator("sound", cdk.validateString)(properties.sound)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.collect(cdk.propertyValidator("url", cdk.validateString)(properties.url)), errors.wrap('supplied properties not correct for "APNSPushNotificationTemplateProperty"');
    }
    function cfnPushTemplateAPNSPushNotificationTemplatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPushTemplate_APNSPushNotificationTemplatePropertyValidator(properties).assertSuccess(), { Action: cdk.stringToCloudFormation(properties.action), Body: cdk.stringToCloudFormation(properties.body), MediaUrl: cdk.stringToCloudFormation(properties.mediaUrl), Sound: cdk.stringToCloudFormation(properties.sound), Title: cdk.stringToCloudFormation(properties.title), Url: cdk.stringToCloudFormation(properties.url) }) : properties;
    }
    function CfnPushTemplateAPNSPushNotificationTemplatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", properties.Action != null ? cfn_parse.FromCloudFormation.getString(properties.Action) : void 0), ret.addPropertyResult("body", "Body", properties.Body != null ? cfn_parse.FromCloudFormation.getString(properties.Body) : void 0), ret.addPropertyResult("mediaUrl", "MediaUrl", properties.MediaUrl != null ? cfn_parse.FromCloudFormation.getString(properties.MediaUrl) : void 0), ret.addPropertyResult("sound", "Sound", properties.Sound != null ? cfn_parse.FromCloudFormation.getString(properties.Sound) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? cfn_parse.FromCloudFormation.getString(properties.Title) : void 0), ret.addPropertyResult("url", "Url", properties.Url != null ? cfn_parse.FromCloudFormation.getString(properties.Url) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPushTemplate_AndroidPushNotificationTemplatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.validateString)(properties.action)), errors.collect(cdk.propertyValidator("body", cdk.validateString)(properties.body)), errors.collect(cdk.propertyValidator("imageIconUrl", cdk.validateString)(properties.imageIconUrl)), errors.collect(cdk.propertyValidator("imageUrl", cdk.validateString)(properties.imageUrl)), errors.collect(cdk.propertyValidator("smallImageIconUrl", cdk.validateString)(properties.smallImageIconUrl)), errors.collect(cdk.propertyValidator("sound", cdk.validateString)(properties.sound)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.collect(cdk.propertyValidator("url", cdk.validateString)(properties.url)), errors.wrap('supplied properties not correct for "AndroidPushNotificationTemplateProperty"');
    }
    function cfnPushTemplateAndroidPushNotificationTemplatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPushTemplate_AndroidPushNotificationTemplatePropertyValidator(properties).assertSuccess(), { Action: cdk.stringToCloudFormation(properties.action), Body: cdk.stringToCloudFormation(properties.body), ImageIconUrl: cdk.stringToCloudFormation(properties.imageIconUrl), ImageUrl: cdk.stringToCloudFormation(properties.imageUrl), SmallImageIconUrl: cdk.stringToCloudFormation(properties.smallImageIconUrl), Sound: cdk.stringToCloudFormation(properties.sound), Title: cdk.stringToCloudFormation(properties.title), Url: cdk.stringToCloudFormation(properties.url) }) : properties;
    }
    function CfnPushTemplateAndroidPushNotificationTemplatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", properties.Action != null ? cfn_parse.FromCloudFormation.getString(properties.Action) : void 0), ret.addPropertyResult("body", "Body", properties.Body != null ? cfn_parse.FromCloudFormation.getString(properties.Body) : void 0), ret.addPropertyResult("imageIconUrl", "ImageIconUrl", properties.ImageIconUrl != null ? cfn_parse.FromCloudFormation.getString(properties.ImageIconUrl) : void 0), ret.addPropertyResult("imageUrl", "ImageUrl", properties.ImageUrl != null ? cfn_parse.FromCloudFormation.getString(properties.ImageUrl) : void 0), ret.addPropertyResult("smallImageIconUrl", "SmallImageIconUrl", properties.SmallImageIconUrl != null ? cfn_parse.FromCloudFormation.getString(properties.SmallImageIconUrl) : void 0), ret.addPropertyResult("sound", "Sound", properties.Sound != null ? cfn_parse.FromCloudFormation.getString(properties.Sound) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? cfn_parse.FromCloudFormation.getString(properties.Title) : void 0), ret.addPropertyResult("url", "Url", properties.Url != null ? cfn_parse.FromCloudFormation.getString(properties.Url) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPushTemplate_DefaultPushNotificationTemplatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.validateString)(properties.action)), errors.collect(cdk.propertyValidator("body", cdk.validateString)(properties.body)), errors.collect(cdk.propertyValidator("sound", cdk.validateString)(properties.sound)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.collect(cdk.propertyValidator("url", cdk.validateString)(properties.url)), errors.wrap('supplied properties not correct for "DefaultPushNotificationTemplateProperty"');
    }
    function cfnPushTemplateDefaultPushNotificationTemplatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPushTemplate_DefaultPushNotificationTemplatePropertyValidator(properties).assertSuccess(), { Action: cdk.stringToCloudFormation(properties.action), Body: cdk.stringToCloudFormation(properties.body), Sound: cdk.stringToCloudFormation(properties.sound), Title: cdk.stringToCloudFormation(properties.title), Url: cdk.stringToCloudFormation(properties.url) }) : properties;
    }
    function CfnPushTemplateDefaultPushNotificationTemplatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", properties.Action != null ? cfn_parse.FromCloudFormation.getString(properties.Action) : void 0), ret.addPropertyResult("body", "Body", properties.Body != null ? cfn_parse.FromCloudFormation.getString(properties.Body) : void 0), ret.addPropertyResult("sound", "Sound", properties.Sound != null ? cfn_parse.FromCloudFormation.getString(properties.Sound) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? cfn_parse.FromCloudFormation.getString(properties.Title) : void 0), ret.addPropertyResult("url", "Url", properties.Url != null ? cfn_parse.FromCloudFormation.getString(properties.Url) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSMSChannelPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationId", cdk.requiredValidator)(properties.applicationId)), errors.collect(cdk.propertyValidator("applicationId", cdk.validateString)(properties.applicationId)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("senderId", cdk.validateString)(properties.senderId)), errors.collect(cdk.propertyValidator("shortCode", cdk.validateString)(properties.shortCode)), errors.wrap('supplied properties not correct for "CfnSMSChannelProps"');
    }
    function cfnSMSChannelPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSMSChannelPropsValidator(properties).assertSuccess(), { ApplicationId: cdk.stringToCloudFormation(properties.applicationId), Enabled: cdk.booleanToCloudFormation(properties.enabled), SenderId: cdk.stringToCloudFormation(properties.senderId), ShortCode: cdk.stringToCloudFormation(properties.shortCode) }) : properties;
    }
    function CfnSMSChannelPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationId", "ApplicationId", cfn_parse.FromCloudFormation.getString(properties.ApplicationId)), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("senderId", "SenderId", properties.SenderId != null ? cfn_parse.FromCloudFormation.getString(properties.SenderId) : void 0), ret.addPropertyResult("shortCode", "ShortCode", properties.ShortCode != null ? cfn_parse.FromCloudFormation.getString(properties.ShortCode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSMSChannel = class _CfnSMSChannel extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSMSChannelPropsFromCloudFormation(resourceProperties), ret = new _CfnSMSChannel(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSMSChannel.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_pinpoint_CfnSMSChannelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSMSChannel), error;
        }
        cdk.requireProperty(props, "applicationId", this), this.applicationId = props.applicationId, this.enabled = props.enabled, this.senderId = props.senderId, this.shortCode = props.shortCode;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSMSChannel.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationId: this.applicationId, enabled: this.enabled, senderId: this.senderId, shortCode: this.shortCode };
      }
      renderProperties(props) {
        return cfnSMSChannelPropsToCloudFormation(props);
      }
    };
    _r = JSII_RTTI_SYMBOL_1, CfnSMSChannel[_r] = { fqn: "aws-cdk-lib.aws_pinpoint.CfnSMSChannel", version: "2.80.0" }, CfnSMSChannel.CFN_RESOURCE_TYPE_NAME = "AWS::Pinpoint::SMSChannel", exports2.CfnSMSChannel = CfnSMSChannel;
    function CfnSegmentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationId", cdk.requiredValidator)(properties.applicationId)), errors.collect(cdk.propertyValidator("applicationId", cdk.validateString)(properties.applicationId)), errors.collect(cdk.propertyValidator("dimensions", CfnSegment_SegmentDimensionsPropertyValidator)(properties.dimensions)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("segmentGroups", CfnSegment_SegmentGroupsPropertyValidator)(properties.segmentGroups)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.wrap('supplied properties not correct for "CfnSegmentProps"');
    }
    function cfnSegmentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSegmentPropsValidator(properties).assertSuccess(), { ApplicationId: cdk.stringToCloudFormation(properties.applicationId), Name: cdk.stringToCloudFormation(properties.name), Dimensions: cfnSegmentSegmentDimensionsPropertyToCloudFormation(properties.dimensions), SegmentGroups: cfnSegmentSegmentGroupsPropertyToCloudFormation(properties.segmentGroups), Tags: cdk.objectToCloudFormation(properties.tags) }) : properties;
    }
    function CfnSegmentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationId", "ApplicationId", cfn_parse.FromCloudFormation.getString(properties.ApplicationId)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("dimensions", "Dimensions", properties.Dimensions != null ? CfnSegmentSegmentDimensionsPropertyFromCloudFormation(properties.Dimensions) : void 0), ret.addPropertyResult("segmentGroups", "SegmentGroups", properties.SegmentGroups != null ? CfnSegmentSegmentGroupsPropertyFromCloudFormation(properties.SegmentGroups) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSegment = class _CfnSegment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSegmentPropsFromCloudFormation(resourceProperties), ret = new _CfnSegment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSegment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_pinpoint_CfnSegmentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSegment), error;
        }
        cdk.requireProperty(props, "applicationId", this), cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrSegmentId = cdk.Token.asString(this.getAtt("SegmentId", cdk.ResolutionTypeHint.STRING)), this.applicationId = props.applicationId, this.name = props.name, this.dimensions = props.dimensions, this.segmentGroups = props.segmentGroups, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Pinpoint::Segment", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSegment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationId: this.applicationId, name: this.name, dimensions: this.dimensions, segmentGroups: this.segmentGroups, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnSegmentPropsToCloudFormation(props);
      }
    };
    _s = JSII_RTTI_SYMBOL_1, CfnSegment[_s] = { fqn: "aws-cdk-lib.aws_pinpoint.CfnSegment", version: "2.80.0" }, CfnSegment.CFN_RESOURCE_TYPE_NAME = "AWS::Pinpoint::Segment", exports2.CfnSegment = CfnSegment;
    function CfnSegment_BehaviorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("recency", CfnSegment_RecencyPropertyValidator)(properties.recency)), errors.wrap('supplied properties not correct for "BehaviorProperty"');
    }
    function cfnSegmentBehaviorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSegment_BehaviorPropertyValidator(properties).assertSuccess(), { Recency: cfnSegmentRecencyPropertyToCloudFormation(properties.recency) }) : properties;
    }
    function CfnSegmentBehaviorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("recency", "Recency", properties.Recency != null ? CfnSegmentRecencyPropertyFromCloudFormation(properties.Recency) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSegment_CoordinatesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("latitude", cdk.requiredValidator)(properties.latitude)), errors.collect(cdk.propertyValidator("latitude", cdk.validateNumber)(properties.latitude)), errors.collect(cdk.propertyValidator("longitude", cdk.requiredValidator)(properties.longitude)), errors.collect(cdk.propertyValidator("longitude", cdk.validateNumber)(properties.longitude)), errors.wrap('supplied properties not correct for "CoordinatesProperty"');
    }
    function cfnSegmentCoordinatesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSegment_CoordinatesPropertyValidator(properties).assertSuccess(), { Latitude: cdk.numberToCloudFormation(properties.latitude), Longitude: cdk.numberToCloudFormation(properties.longitude) }) : properties;
    }
    function CfnSegmentCoordinatesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("latitude", "Latitude", cfn_parse.FromCloudFormation.getNumber(properties.Latitude)), ret.addPropertyResult("longitude", "Longitude", cfn_parse.FromCloudFormation.getNumber(properties.Longitude)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSegment_DemographicPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("appVersion", CfnSegment_SetDimensionPropertyValidator)(properties.appVersion)), errors.collect(cdk.propertyValidator("channel", CfnSegment_SetDimensionPropertyValidator)(properties.channel)), errors.collect(cdk.propertyValidator("deviceType", CfnSegment_SetDimensionPropertyValidator)(properties.deviceType)), errors.collect(cdk.propertyValidator("make", CfnSegment_SetDimensionPropertyValidator)(properties.make)), errors.collect(cdk.propertyValidator("model", CfnSegment_SetDimensionPropertyValidator)(properties.model)), errors.collect(cdk.propertyValidator("platform", CfnSegment_SetDimensionPropertyValidator)(properties.platform)), errors.wrap('supplied properties not correct for "DemographicProperty"');
    }
    function cfnSegmentDemographicPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSegment_DemographicPropertyValidator(properties).assertSuccess(), { AppVersion: cfnSegmentSetDimensionPropertyToCloudFormation(properties.appVersion), Channel: cfnSegmentSetDimensionPropertyToCloudFormation(properties.channel), DeviceType: cfnSegmentSetDimensionPropertyToCloudFormation(properties.deviceType), Make: cfnSegmentSetDimensionPropertyToCloudFormation(properties.make), Model: cfnSegmentSetDimensionPropertyToCloudFormation(properties.model), Platform: cfnSegmentSetDimensionPropertyToCloudFormation(properties.platform) }) : properties;
    }
    function CfnSegmentDemographicPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("appVersion", "AppVersion", properties.AppVersion != null ? CfnSegmentSetDimensionPropertyFromCloudFormation(properties.AppVersion) : void 0), ret.addPropertyResult("channel", "Channel", properties.Channel != null ? CfnSegmentSetDimensionPropertyFromCloudFormation(properties.Channel) : void 0), ret.addPropertyResult("deviceType", "DeviceType", properties.DeviceType != null ? CfnSegmentSetDimensionPropertyFromCloudFormation(properties.DeviceType) : void 0), ret.addPropertyResult("make", "Make", properties.Make != null ? CfnSegmentSetDimensionPropertyFromCloudFormation(properties.Make) : void 0), ret.addPropertyResult("model", "Model", properties.Model != null ? CfnSegmentSetDimensionPropertyFromCloudFormation(properties.Model) : void 0), ret.addPropertyResult("platform", "Platform", properties.Platform != null ? CfnSegmentSetDimensionPropertyFromCloudFormation(properties.Platform) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSegment_GPSPointPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("coordinates", cdk.requiredValidator)(properties.coordinates)), errors.collect(cdk.propertyValidator("coordinates", CfnSegment_CoordinatesPropertyValidator)(properties.coordinates)), errors.collect(cdk.propertyValidator("rangeInKilometers", cdk.requiredValidator)(properties.rangeInKilometers)), errors.collect(cdk.propertyValidator("rangeInKilometers", cdk.validateNumber)(properties.rangeInKilometers)), errors.wrap('supplied properties not correct for "GPSPointProperty"');
    }
    function cfnSegmentGPSPointPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSegment_GPSPointPropertyValidator(properties).assertSuccess(), { Coordinates: cfnSegmentCoordinatesPropertyToCloudFormation(properties.coordinates), RangeInKilometers: cdk.numberToCloudFormation(properties.rangeInKilometers) }) : properties;
    }
    function CfnSegmentGPSPointPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("coordinates", "Coordinates", CfnSegmentCoordinatesPropertyFromCloudFormation(properties.Coordinates)), ret.addPropertyResult("rangeInKilometers", "RangeInKilometers", cfn_parse.FromCloudFormation.getNumber(properties.RangeInKilometers)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSegment_GroupsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dimensions", cdk.listValidator(CfnSegment_SegmentDimensionsPropertyValidator))(properties.dimensions)), errors.collect(cdk.propertyValidator("sourceSegments", cdk.listValidator(CfnSegment_SourceSegmentsPropertyValidator))(properties.sourceSegments)), errors.collect(cdk.propertyValidator("sourceType", cdk.validateString)(properties.sourceType)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "GroupsProperty"');
    }
    function cfnSegmentGroupsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSegment_GroupsPropertyValidator(properties).assertSuccess(), { Dimensions: cdk.listMapper(cfnSegmentSegmentDimensionsPropertyToCloudFormation)(properties.dimensions), SourceSegments: cdk.listMapper(cfnSegmentSourceSegmentsPropertyToCloudFormation)(properties.sourceSegments), SourceType: cdk.stringToCloudFormation(properties.sourceType), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnSegmentGroupsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dimensions", "Dimensions", properties.Dimensions != null ? cfn_parse.FromCloudFormation.getArray(CfnSegmentSegmentDimensionsPropertyFromCloudFormation)(properties.Dimensions) : void 0), ret.addPropertyResult("sourceSegments", "SourceSegments", properties.SourceSegments != null ? cfn_parse.FromCloudFormation.getArray(CfnSegmentSourceSegmentsPropertyFromCloudFormation)(properties.SourceSegments) : void 0), ret.addPropertyResult("sourceType", "SourceType", properties.SourceType != null ? cfn_parse.FromCloudFormation.getString(properties.SourceType) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSegment_LocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("country", CfnSegment_SetDimensionPropertyValidator)(properties.country)), errors.collect(cdk.propertyValidator("gpsPoint", CfnSegment_GPSPointPropertyValidator)(properties.gpsPoint)), errors.wrap('supplied properties not correct for "LocationProperty"');
    }
    function cfnSegmentLocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSegment_LocationPropertyValidator(properties).assertSuccess(), { Country: cfnSegmentSetDimensionPropertyToCloudFormation(properties.country), GPSPoint: cfnSegmentGPSPointPropertyToCloudFormation(properties.gpsPoint) }) : properties;
    }
    function CfnSegmentLocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("country", "Country", properties.Country != null ? CfnSegmentSetDimensionPropertyFromCloudFormation(properties.Country) : void 0), ret.addPropertyResult("gpsPoint", "GPSPoint", properties.GPSPoint != null ? CfnSegmentGPSPointPropertyFromCloudFormation(properties.GPSPoint) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSegment_RecencyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("duration", cdk.requiredValidator)(properties.duration)), errors.collect(cdk.propertyValidator("duration", cdk.validateString)(properties.duration)), errors.collect(cdk.propertyValidator("recencyType", cdk.requiredValidator)(properties.recencyType)), errors.collect(cdk.propertyValidator("recencyType", cdk.validateString)(properties.recencyType)), errors.wrap('supplied properties not correct for "RecencyProperty"');
    }
    function cfnSegmentRecencyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSegment_RecencyPropertyValidator(properties).assertSuccess(), { Duration: cdk.stringToCloudFormation(properties.duration), RecencyType: cdk.stringToCloudFormation(properties.recencyType) }) : properties;
    }
    function CfnSegmentRecencyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("duration", "Duration", cfn_parse.FromCloudFormation.getString(properties.Duration)), ret.addPropertyResult("recencyType", "RecencyType", cfn_parse.FromCloudFormation.getString(properties.RecencyType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSegment_SegmentDimensionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributes", cdk.validateObject)(properties.attributes)), errors.collect(cdk.propertyValidator("behavior", CfnSegment_BehaviorPropertyValidator)(properties.behavior)), errors.collect(cdk.propertyValidator("demographic", CfnSegment_DemographicPropertyValidator)(properties.demographic)), errors.collect(cdk.propertyValidator("location", CfnSegment_LocationPropertyValidator)(properties.location)), errors.collect(cdk.propertyValidator("metrics", cdk.validateObject)(properties.metrics)), errors.collect(cdk.propertyValidator("userAttributes", cdk.validateObject)(properties.userAttributes)), errors.wrap('supplied properties not correct for "SegmentDimensionsProperty"');
    }
    function cfnSegmentSegmentDimensionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSegment_SegmentDimensionsPropertyValidator(properties).assertSuccess(), { Attributes: cdk.objectToCloudFormation(properties.attributes), Behavior: cfnSegmentBehaviorPropertyToCloudFormation(properties.behavior), Demographic: cfnSegmentDemographicPropertyToCloudFormation(properties.demographic), Location: cfnSegmentLocationPropertyToCloudFormation(properties.location), Metrics: cdk.objectToCloudFormation(properties.metrics), UserAttributes: cdk.objectToCloudFormation(properties.userAttributes) }) : properties;
    }
    function CfnSegmentSegmentDimensionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attributes", "Attributes", properties.Attributes != null ? cfn_parse.FromCloudFormation.getAny(properties.Attributes) : void 0), ret.addPropertyResult("behavior", "Behavior", properties.Behavior != null ? CfnSegmentBehaviorPropertyFromCloudFormation(properties.Behavior) : void 0), ret.addPropertyResult("demographic", "Demographic", properties.Demographic != null ? CfnSegmentDemographicPropertyFromCloudFormation(properties.Demographic) : void 0), ret.addPropertyResult("location", "Location", properties.Location != null ? CfnSegmentLocationPropertyFromCloudFormation(properties.Location) : void 0), ret.addPropertyResult("metrics", "Metrics", properties.Metrics != null ? cfn_parse.FromCloudFormation.getAny(properties.Metrics) : void 0), ret.addPropertyResult("userAttributes", "UserAttributes", properties.UserAttributes != null ? cfn_parse.FromCloudFormation.getAny(properties.UserAttributes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSegment_SegmentGroupsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groups", cdk.listValidator(CfnSegment_GroupsPropertyValidator))(properties.groups)), errors.collect(cdk.propertyValidator("include", cdk.validateString)(properties.include)), errors.wrap('supplied properties not correct for "SegmentGroupsProperty"');
    }
    function cfnSegmentSegmentGroupsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSegment_SegmentGroupsPropertyValidator(properties).assertSuccess(), { Groups: cdk.listMapper(cfnSegmentGroupsPropertyToCloudFormation)(properties.groups), Include: cdk.stringToCloudFormation(properties.include) }) : properties;
    }
    function CfnSegmentSegmentGroupsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groups", "Groups", properties.Groups != null ? cfn_parse.FromCloudFormation.getArray(CfnSegmentGroupsPropertyFromCloudFormation)(properties.Groups) : void 0), ret.addPropertyResult("include", "Include", properties.Include != null ? cfn_parse.FromCloudFormation.getString(properties.Include) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSegment_SetDimensionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dimensionType", cdk.validateString)(properties.dimensionType)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "SetDimensionProperty"');
    }
    function cfnSegmentSetDimensionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSegment_SetDimensionPropertyValidator(properties).assertSuccess(), { DimensionType: cdk.stringToCloudFormation(properties.dimensionType), Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnSegmentSetDimensionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dimensionType", "DimensionType", properties.DimensionType != null ? cfn_parse.FromCloudFormation.getString(properties.DimensionType) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSegment_SourceSegmentsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("version", cdk.validateNumber)(properties.version)), errors.wrap('supplied properties not correct for "SourceSegmentsProperty"');
    }
    function cfnSegmentSourceSegmentsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSegment_SourceSegmentsPropertyValidator(properties).assertSuccess(), { Id: cdk.stringToCloudFormation(properties.id), Version: cdk.numberToCloudFormation(properties.version) }) : properties;
    }
    function CfnSegmentSourceSegmentsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getNumber(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSmsTemplatePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("body", cdk.requiredValidator)(properties.body)), errors.collect(cdk.propertyValidator("body", cdk.validateString)(properties.body)), errors.collect(cdk.propertyValidator("defaultSubstitutions", cdk.validateString)(properties.defaultSubstitutions)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.collect(cdk.propertyValidator("templateDescription", cdk.validateString)(properties.templateDescription)), errors.collect(cdk.propertyValidator("templateName", cdk.requiredValidator)(properties.templateName)), errors.collect(cdk.propertyValidator("templateName", cdk.validateString)(properties.templateName)), errors.wrap('supplied properties not correct for "CfnSmsTemplateProps"');
    }
    function cfnSmsTemplatePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSmsTemplatePropsValidator(properties).assertSuccess(), { Body: cdk.stringToCloudFormation(properties.body), TemplateName: cdk.stringToCloudFormation(properties.templateName), DefaultSubstitutions: cdk.stringToCloudFormation(properties.defaultSubstitutions), Tags: cdk.objectToCloudFormation(properties.tags), TemplateDescription: cdk.stringToCloudFormation(properties.templateDescription) }) : properties;
    }
    function CfnSmsTemplatePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("body", "Body", cfn_parse.FromCloudFormation.getString(properties.Body)), ret.addPropertyResult("templateName", "TemplateName", cfn_parse.FromCloudFormation.getString(properties.TemplateName)), ret.addPropertyResult("defaultSubstitutions", "DefaultSubstitutions", properties.DefaultSubstitutions != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultSubstitutions) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addPropertyResult("templateDescription", "TemplateDescription", properties.TemplateDescription != null ? cfn_parse.FromCloudFormation.getString(properties.TemplateDescription) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSmsTemplate = class _CfnSmsTemplate extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSmsTemplatePropsFromCloudFormation(resourceProperties), ret = new _CfnSmsTemplate(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSmsTemplate.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_pinpoint_CfnSmsTemplateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSmsTemplate), error;
        }
        cdk.requireProperty(props, "body", this), cdk.requireProperty(props, "templateName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.body = props.body, this.templateName = props.templateName, this.defaultSubstitutions = props.defaultSubstitutions, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Pinpoint::SmsTemplate", props.tags, { tagPropertyName: "tags" }), this.templateDescription = props.templateDescription;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSmsTemplate.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { body: this.body, templateName: this.templateName, defaultSubstitutions: this.defaultSubstitutions, tags: this.tags.renderTags(), templateDescription: this.templateDescription };
      }
      renderProperties(props) {
        return cfnSmsTemplatePropsToCloudFormation(props);
      }
    };
    _t = JSII_RTTI_SYMBOL_1, CfnSmsTemplate[_t] = { fqn: "aws-cdk-lib.aws_pinpoint.CfnSmsTemplate", version: "2.80.0" }, CfnSmsTemplate.CFN_RESOURCE_TYPE_NAME = "AWS::Pinpoint::SmsTemplate", exports2.CfnSmsTemplate = CfnSmsTemplate;
    function CfnVoiceChannelPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationId", cdk.requiredValidator)(properties.applicationId)), errors.collect(cdk.propertyValidator("applicationId", cdk.validateString)(properties.applicationId)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.wrap('supplied properties not correct for "CfnVoiceChannelProps"');
    }
    function cfnVoiceChannelPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVoiceChannelPropsValidator(properties).assertSuccess(), { ApplicationId: cdk.stringToCloudFormation(properties.applicationId), Enabled: cdk.booleanToCloudFormation(properties.enabled) }) : properties;
    }
    function CfnVoiceChannelPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationId", "ApplicationId", cfn_parse.FromCloudFormation.getString(properties.ApplicationId)), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVoiceChannel = class _CfnVoiceChannel extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVoiceChannelPropsFromCloudFormation(resourceProperties), ret = new _CfnVoiceChannel(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnVoiceChannel.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_pinpoint_CfnVoiceChannelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVoiceChannel), error;
        }
        cdk.requireProperty(props, "applicationId", this), this.applicationId = props.applicationId, this.enabled = props.enabled;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVoiceChannel.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationId: this.applicationId, enabled: this.enabled };
      }
      renderProperties(props) {
        return cfnVoiceChannelPropsToCloudFormation(props);
      }
    };
    _u = JSII_RTTI_SYMBOL_1, CfnVoiceChannel[_u] = { fqn: "aws-cdk-lib.aws_pinpoint.CfnVoiceChannel", version: "2.80.0" }, CfnVoiceChannel.CFN_RESOURCE_TYPE_NAME = "AWS::Pinpoint::VoiceChannel", exports2.CfnVoiceChannel = CfnVoiceChannel;
  }
});

// node_modules/aws-cdk-lib/aws-pinpoint/lib/index.js
var require_lib209 = __commonJS({
  "node_modules/aws-cdk-lib/aws-pinpoint/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_pinpoint_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-pinpoint/index.js
var require_aws_pinpoint = __commonJS({
  "node_modules/aws-cdk-lib/aws-pinpoint/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib209(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-pinpointemail/lib/pinpointemail.generated.js
var require_pinpointemail_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-pinpointemail/lib/pinpointemail.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnIdentity = exports2.CfnDedicatedIpPool = exports2.CfnConfigurationSetEventDestination = exports2.CfnConfigurationSet = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnConfigurationSetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deliveryOptions", CfnConfigurationSet_DeliveryOptionsPropertyValidator)(properties.deliveryOptions)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("reputationOptions", CfnConfigurationSet_ReputationOptionsPropertyValidator)(properties.reputationOptions)), errors.collect(cdk.propertyValidator("sendingOptions", CfnConfigurationSet_SendingOptionsPropertyValidator)(properties.sendingOptions)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(CfnConfigurationSet_TagsPropertyValidator))(properties.tags)), errors.collect(cdk.propertyValidator("trackingOptions", CfnConfigurationSet_TrackingOptionsPropertyValidator)(properties.trackingOptions)), errors.wrap('supplied properties not correct for "CfnConfigurationSetProps"');
    }
    function cfnConfigurationSetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationSetPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), DeliveryOptions: cfnConfigurationSetDeliveryOptionsPropertyToCloudFormation(properties.deliveryOptions), ReputationOptions: cfnConfigurationSetReputationOptionsPropertyToCloudFormation(properties.reputationOptions), SendingOptions: cfnConfigurationSetSendingOptionsPropertyToCloudFormation(properties.sendingOptions), Tags: cdk.listMapper(cfnConfigurationSetTagsPropertyToCloudFormation)(properties.tags), TrackingOptions: cfnConfigurationSetTrackingOptionsPropertyToCloudFormation(properties.trackingOptions) }) : properties;
    }
    function CfnConfigurationSetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("deliveryOptions", "DeliveryOptions", properties.DeliveryOptions != null ? CfnConfigurationSetDeliveryOptionsPropertyFromCloudFormation(properties.DeliveryOptions) : void 0), ret.addPropertyResult("reputationOptions", "ReputationOptions", properties.ReputationOptions != null ? CfnConfigurationSetReputationOptionsPropertyFromCloudFormation(properties.ReputationOptions) : void 0), ret.addPropertyResult("sendingOptions", "SendingOptions", properties.SendingOptions != null ? CfnConfigurationSetSendingOptionsPropertyFromCloudFormation(properties.SendingOptions) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(CfnConfigurationSetTagsPropertyFromCloudFormation)(properties.Tags) : void 0), ret.addPropertyResult("trackingOptions", "TrackingOptions", properties.TrackingOptions != null ? CfnConfigurationSetTrackingOptionsPropertyFromCloudFormation(properties.TrackingOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnConfigurationSet = class _CfnConfigurationSet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnConfigurationSetPropsFromCloudFormation(resourceProperties), ret = new _CfnConfigurationSet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnConfigurationSet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_pinpointemail_CfnConfigurationSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnConfigurationSet), error;
        }
        cdk.requireProperty(props, "name", this), this.name = props.name, this.deliveryOptions = props.deliveryOptions, this.reputationOptions = props.reputationOptions, this.sendingOptions = props.sendingOptions, this.tags = props.tags, this.trackingOptions = props.trackingOptions;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnConfigurationSet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, deliveryOptions: this.deliveryOptions, reputationOptions: this.reputationOptions, sendingOptions: this.sendingOptions, tags: this.tags, trackingOptions: this.trackingOptions };
      }
      renderProperties(props) {
        return cfnConfigurationSetPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnConfigurationSet[_a] = { fqn: "aws-cdk-lib.aws_pinpointemail.CfnConfigurationSet", version: "2.80.0" }, CfnConfigurationSet.CFN_RESOURCE_TYPE_NAME = "AWS::PinpointEmail::ConfigurationSet", exports2.CfnConfigurationSet = CfnConfigurationSet;
    function CfnConfigurationSet_DeliveryOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sendingPoolName", cdk.validateString)(properties.sendingPoolName)), errors.wrap('supplied properties not correct for "DeliveryOptionsProperty"');
    }
    function cfnConfigurationSetDeliveryOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationSet_DeliveryOptionsPropertyValidator(properties).assertSuccess(), { SendingPoolName: cdk.stringToCloudFormation(properties.sendingPoolName) }) : properties;
    }
    function CfnConfigurationSetDeliveryOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sendingPoolName", "SendingPoolName", properties.SendingPoolName != null ? cfn_parse.FromCloudFormation.getString(properties.SendingPoolName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigurationSet_ReputationOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("reputationMetricsEnabled", cdk.validateBoolean)(properties.reputationMetricsEnabled)), errors.wrap('supplied properties not correct for "ReputationOptionsProperty"');
    }
    function cfnConfigurationSetReputationOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationSet_ReputationOptionsPropertyValidator(properties).assertSuccess(), { ReputationMetricsEnabled: cdk.booleanToCloudFormation(properties.reputationMetricsEnabled) }) : properties;
    }
    function CfnConfigurationSetReputationOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("reputationMetricsEnabled", "ReputationMetricsEnabled", properties.ReputationMetricsEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ReputationMetricsEnabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigurationSet_SendingOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sendingEnabled", cdk.validateBoolean)(properties.sendingEnabled)), errors.wrap('supplied properties not correct for "SendingOptionsProperty"');
    }
    function cfnConfigurationSetSendingOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationSet_SendingOptionsPropertyValidator(properties).assertSuccess(), { SendingEnabled: cdk.booleanToCloudFormation(properties.sendingEnabled) }) : properties;
    }
    function CfnConfigurationSetSendingOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sendingEnabled", "SendingEnabled", properties.SendingEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SendingEnabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigurationSet_TagsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TagsProperty"');
    }
    function cfnConfigurationSetTagsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationSet_TagsPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnConfigurationSetTagsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigurationSet_TrackingOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customRedirectDomain", cdk.validateString)(properties.customRedirectDomain)), errors.wrap('supplied properties not correct for "TrackingOptionsProperty"');
    }
    function cfnConfigurationSetTrackingOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationSet_TrackingOptionsPropertyValidator(properties).assertSuccess(), { CustomRedirectDomain: cdk.stringToCloudFormation(properties.customRedirectDomain) }) : properties;
    }
    function CfnConfigurationSetTrackingOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customRedirectDomain", "CustomRedirectDomain", properties.CustomRedirectDomain != null ? cfn_parse.FromCloudFormation.getString(properties.CustomRedirectDomain) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigurationSetEventDestinationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configurationSetName", cdk.requiredValidator)(properties.configurationSetName)), errors.collect(cdk.propertyValidator("configurationSetName", cdk.validateString)(properties.configurationSetName)), errors.collect(cdk.propertyValidator("eventDestination", CfnConfigurationSetEventDestination_EventDestinationPropertyValidator)(properties.eventDestination)), errors.collect(cdk.propertyValidator("eventDestinationName", cdk.requiredValidator)(properties.eventDestinationName)), errors.collect(cdk.propertyValidator("eventDestinationName", cdk.validateString)(properties.eventDestinationName)), errors.wrap('supplied properties not correct for "CfnConfigurationSetEventDestinationProps"');
    }
    function cfnConfigurationSetEventDestinationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationSetEventDestinationPropsValidator(properties).assertSuccess(), { ConfigurationSetName: cdk.stringToCloudFormation(properties.configurationSetName), EventDestinationName: cdk.stringToCloudFormation(properties.eventDestinationName), EventDestination: cfnConfigurationSetEventDestinationEventDestinationPropertyToCloudFormation(properties.eventDestination) }) : properties;
    }
    function CfnConfigurationSetEventDestinationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configurationSetName", "ConfigurationSetName", cfn_parse.FromCloudFormation.getString(properties.ConfigurationSetName)), ret.addPropertyResult("eventDestinationName", "EventDestinationName", cfn_parse.FromCloudFormation.getString(properties.EventDestinationName)), ret.addPropertyResult("eventDestination", "EventDestination", properties.EventDestination != null ? CfnConfigurationSetEventDestinationEventDestinationPropertyFromCloudFormation(properties.EventDestination) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnConfigurationSetEventDestination = class _CfnConfigurationSetEventDestination extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnConfigurationSetEventDestinationPropsFromCloudFormation(resourceProperties), ret = new _CfnConfigurationSetEventDestination(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnConfigurationSetEventDestination.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_pinpointemail_CfnConfigurationSetEventDestinationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnConfigurationSetEventDestination), error;
        }
        cdk.requireProperty(props, "configurationSetName", this), cdk.requireProperty(props, "eventDestinationName", this), this.configurationSetName = props.configurationSetName, this.eventDestinationName = props.eventDestinationName, this.eventDestination = props.eventDestination;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnConfigurationSetEventDestination.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { configurationSetName: this.configurationSetName, eventDestinationName: this.eventDestinationName, eventDestination: this.eventDestination };
      }
      renderProperties(props) {
        return cfnConfigurationSetEventDestinationPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnConfigurationSetEventDestination[_b] = { fqn: "aws-cdk-lib.aws_pinpointemail.CfnConfigurationSetEventDestination", version: "2.80.0" }, CfnConfigurationSetEventDestination.CFN_RESOURCE_TYPE_NAME = "AWS::PinpointEmail::ConfigurationSetEventDestination", exports2.CfnConfigurationSetEventDestination = CfnConfigurationSetEventDestination;
    function CfnConfigurationSetEventDestination_CloudWatchDestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dimensionConfigurations", cdk.listValidator(CfnConfigurationSetEventDestination_DimensionConfigurationPropertyValidator))(properties.dimensionConfigurations)), errors.wrap('supplied properties not correct for "CloudWatchDestinationProperty"');
    }
    function cfnConfigurationSetEventDestinationCloudWatchDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationSetEventDestination_CloudWatchDestinationPropertyValidator(properties).assertSuccess(), { DimensionConfigurations: cdk.listMapper(cfnConfigurationSetEventDestinationDimensionConfigurationPropertyToCloudFormation)(properties.dimensionConfigurations) }) : properties;
    }
    function CfnConfigurationSetEventDestinationCloudWatchDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dimensionConfigurations", "DimensionConfigurations", properties.DimensionConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnConfigurationSetEventDestinationDimensionConfigurationPropertyFromCloudFormation)(properties.DimensionConfigurations) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigurationSetEventDestination_DimensionConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultDimensionValue", cdk.requiredValidator)(properties.defaultDimensionValue)), errors.collect(cdk.propertyValidator("defaultDimensionValue", cdk.validateString)(properties.defaultDimensionValue)), errors.collect(cdk.propertyValidator("dimensionName", cdk.requiredValidator)(properties.dimensionName)), errors.collect(cdk.propertyValidator("dimensionName", cdk.validateString)(properties.dimensionName)), errors.collect(cdk.propertyValidator("dimensionValueSource", cdk.requiredValidator)(properties.dimensionValueSource)), errors.collect(cdk.propertyValidator("dimensionValueSource", cdk.validateString)(properties.dimensionValueSource)), errors.wrap('supplied properties not correct for "DimensionConfigurationProperty"');
    }
    function cfnConfigurationSetEventDestinationDimensionConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationSetEventDestination_DimensionConfigurationPropertyValidator(properties).assertSuccess(), { DefaultDimensionValue: cdk.stringToCloudFormation(properties.defaultDimensionValue), DimensionName: cdk.stringToCloudFormation(properties.dimensionName), DimensionValueSource: cdk.stringToCloudFormation(properties.dimensionValueSource) }) : properties;
    }
    function CfnConfigurationSetEventDestinationDimensionConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultDimensionValue", "DefaultDimensionValue", cfn_parse.FromCloudFormation.getString(properties.DefaultDimensionValue)), ret.addPropertyResult("dimensionName", "DimensionName", cfn_parse.FromCloudFormation.getString(properties.DimensionName)), ret.addPropertyResult("dimensionValueSource", "DimensionValueSource", cfn_parse.FromCloudFormation.getString(properties.DimensionValueSource)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigurationSetEventDestination_EventDestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchDestination", CfnConfigurationSetEventDestination_CloudWatchDestinationPropertyValidator)(properties.cloudWatchDestination)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("kinesisFirehoseDestination", CfnConfigurationSetEventDestination_KinesisFirehoseDestinationPropertyValidator)(properties.kinesisFirehoseDestination)), errors.collect(cdk.propertyValidator("matchingEventTypes", cdk.requiredValidator)(properties.matchingEventTypes)), errors.collect(cdk.propertyValidator("matchingEventTypes", cdk.listValidator(cdk.validateString))(properties.matchingEventTypes)), errors.collect(cdk.propertyValidator("pinpointDestination", CfnConfigurationSetEventDestination_PinpointDestinationPropertyValidator)(properties.pinpointDestination)), errors.collect(cdk.propertyValidator("snsDestination", CfnConfigurationSetEventDestination_SnsDestinationPropertyValidator)(properties.snsDestination)), errors.wrap('supplied properties not correct for "EventDestinationProperty"');
    }
    function cfnConfigurationSetEventDestinationEventDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationSetEventDestination_EventDestinationPropertyValidator(properties).assertSuccess(), { CloudWatchDestination: cfnConfigurationSetEventDestinationCloudWatchDestinationPropertyToCloudFormation(properties.cloudWatchDestination), Enabled: cdk.booleanToCloudFormation(properties.enabled), KinesisFirehoseDestination: cfnConfigurationSetEventDestinationKinesisFirehoseDestinationPropertyToCloudFormation(properties.kinesisFirehoseDestination), MatchingEventTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.matchingEventTypes), PinpointDestination: cfnConfigurationSetEventDestinationPinpointDestinationPropertyToCloudFormation(properties.pinpointDestination), SnsDestination: cfnConfigurationSetEventDestinationSnsDestinationPropertyToCloudFormation(properties.snsDestination) }) : properties;
    }
    function CfnConfigurationSetEventDestinationEventDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchDestination", "CloudWatchDestination", properties.CloudWatchDestination != null ? CfnConfigurationSetEventDestinationCloudWatchDestinationPropertyFromCloudFormation(properties.CloudWatchDestination) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("kinesisFirehoseDestination", "KinesisFirehoseDestination", properties.KinesisFirehoseDestination != null ? CfnConfigurationSetEventDestinationKinesisFirehoseDestinationPropertyFromCloudFormation(properties.KinesisFirehoseDestination) : void 0), ret.addPropertyResult("matchingEventTypes", "MatchingEventTypes", cfn_parse.FromCloudFormation.getStringArray(properties.MatchingEventTypes)), ret.addPropertyResult("pinpointDestination", "PinpointDestination", properties.PinpointDestination != null ? CfnConfigurationSetEventDestinationPinpointDestinationPropertyFromCloudFormation(properties.PinpointDestination) : void 0), ret.addPropertyResult("snsDestination", "SnsDestination", properties.SnsDestination != null ? CfnConfigurationSetEventDestinationSnsDestinationPropertyFromCloudFormation(properties.SnsDestination) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigurationSetEventDestination_KinesisFirehoseDestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deliveryStreamArn", cdk.requiredValidator)(properties.deliveryStreamArn)), errors.collect(cdk.propertyValidator("deliveryStreamArn", cdk.validateString)(properties.deliveryStreamArn)), errors.collect(cdk.propertyValidator("iamRoleArn", cdk.requiredValidator)(properties.iamRoleArn)), errors.collect(cdk.propertyValidator("iamRoleArn", cdk.validateString)(properties.iamRoleArn)), errors.wrap('supplied properties not correct for "KinesisFirehoseDestinationProperty"');
    }
    function cfnConfigurationSetEventDestinationKinesisFirehoseDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationSetEventDestination_KinesisFirehoseDestinationPropertyValidator(properties).assertSuccess(), { DeliveryStreamArn: cdk.stringToCloudFormation(properties.deliveryStreamArn), IamRoleArn: cdk.stringToCloudFormation(properties.iamRoleArn) }) : properties;
    }
    function CfnConfigurationSetEventDestinationKinesisFirehoseDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deliveryStreamArn", "DeliveryStreamArn", cfn_parse.FromCloudFormation.getString(properties.DeliveryStreamArn)), ret.addPropertyResult("iamRoleArn", "IamRoleArn", cfn_parse.FromCloudFormation.getString(properties.IamRoleArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigurationSetEventDestination_PinpointDestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationArn", cdk.validateString)(properties.applicationArn)), errors.wrap('supplied properties not correct for "PinpointDestinationProperty"');
    }
    function cfnConfigurationSetEventDestinationPinpointDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationSetEventDestination_PinpointDestinationPropertyValidator(properties).assertSuccess(), { ApplicationArn: cdk.stringToCloudFormation(properties.applicationArn) }) : properties;
    }
    function CfnConfigurationSetEventDestinationPinpointDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationArn", "ApplicationArn", properties.ApplicationArn != null ? cfn_parse.FromCloudFormation.getString(properties.ApplicationArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigurationSetEventDestination_SnsDestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("topicArn", cdk.requiredValidator)(properties.topicArn)), errors.collect(cdk.propertyValidator("topicArn", cdk.validateString)(properties.topicArn)), errors.wrap('supplied properties not correct for "SnsDestinationProperty"');
    }
    function cfnConfigurationSetEventDestinationSnsDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationSetEventDestination_SnsDestinationPropertyValidator(properties).assertSuccess(), { TopicArn: cdk.stringToCloudFormation(properties.topicArn) }) : properties;
    }
    function CfnConfigurationSetEventDestinationSnsDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("topicArn", "TopicArn", cfn_parse.FromCloudFormation.getString(properties.TopicArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDedicatedIpPoolPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("poolName", cdk.validateString)(properties.poolName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(CfnDedicatedIpPool_TagsPropertyValidator))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDedicatedIpPoolProps"');
    }
    function cfnDedicatedIpPoolPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDedicatedIpPoolPropsValidator(properties).assertSuccess(), { PoolName: cdk.stringToCloudFormation(properties.poolName), Tags: cdk.listMapper(cfnDedicatedIpPoolTagsPropertyToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDedicatedIpPoolPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("poolName", "PoolName", properties.PoolName != null ? cfn_parse.FromCloudFormation.getString(properties.PoolName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(CfnDedicatedIpPoolTagsPropertyFromCloudFormation)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDedicatedIpPool = class _CfnDedicatedIpPool extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDedicatedIpPoolPropsFromCloudFormation(resourceProperties), ret = new _CfnDedicatedIpPool(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnDedicatedIpPool.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_pinpointemail_CfnDedicatedIpPoolProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDedicatedIpPool), error;
        }
        this.poolName = props.poolName, this.tags = props.tags;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDedicatedIpPool.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { poolName: this.poolName, tags: this.tags };
      }
      renderProperties(props) {
        return cfnDedicatedIpPoolPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnDedicatedIpPool[_c] = { fqn: "aws-cdk-lib.aws_pinpointemail.CfnDedicatedIpPool", version: "2.80.0" }, CfnDedicatedIpPool.CFN_RESOURCE_TYPE_NAME = "AWS::PinpointEmail::DedicatedIpPool", exports2.CfnDedicatedIpPool = CfnDedicatedIpPool;
    function CfnDedicatedIpPool_TagsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TagsProperty"');
    }
    function cfnDedicatedIpPoolTagsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDedicatedIpPool_TagsPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnDedicatedIpPoolTagsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIdentityPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dkimSigningEnabled", cdk.validateBoolean)(properties.dkimSigningEnabled)), errors.collect(cdk.propertyValidator("feedbackForwardingEnabled", cdk.validateBoolean)(properties.feedbackForwardingEnabled)), errors.collect(cdk.propertyValidator("mailFromAttributes", CfnIdentity_MailFromAttributesPropertyValidator)(properties.mailFromAttributes)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(CfnIdentity_TagsPropertyValidator))(properties.tags)), errors.wrap('supplied properties not correct for "CfnIdentityProps"');
    }
    function cfnIdentityPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIdentityPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), DkimSigningEnabled: cdk.booleanToCloudFormation(properties.dkimSigningEnabled), FeedbackForwardingEnabled: cdk.booleanToCloudFormation(properties.feedbackForwardingEnabled), MailFromAttributes: cfnIdentityMailFromAttributesPropertyToCloudFormation(properties.mailFromAttributes), Tags: cdk.listMapper(cfnIdentityTagsPropertyToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnIdentityPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("dkimSigningEnabled", "DkimSigningEnabled", properties.DkimSigningEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DkimSigningEnabled) : void 0), ret.addPropertyResult("feedbackForwardingEnabled", "FeedbackForwardingEnabled", properties.FeedbackForwardingEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.FeedbackForwardingEnabled) : void 0), ret.addPropertyResult("mailFromAttributes", "MailFromAttributes", properties.MailFromAttributes != null ? CfnIdentityMailFromAttributesPropertyFromCloudFormation(properties.MailFromAttributes) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(CfnIdentityTagsPropertyFromCloudFormation)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnIdentity = class _CfnIdentity extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnIdentityPropsFromCloudFormation(resourceProperties), ret = new _CfnIdentity(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnIdentity.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_pinpointemail_CfnIdentityProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnIdentity), error;
        }
        cdk.requireProperty(props, "name", this), this.attrIdentityDnsRecordName1 = cdk.Token.asString(this.getAtt("IdentityDNSRecordName1", cdk.ResolutionTypeHint.STRING)), this.attrIdentityDnsRecordName2 = cdk.Token.asString(this.getAtt("IdentityDNSRecordName2", cdk.ResolutionTypeHint.STRING)), this.attrIdentityDnsRecordName3 = cdk.Token.asString(this.getAtt("IdentityDNSRecordName3", cdk.ResolutionTypeHint.STRING)), this.attrIdentityDnsRecordValue1 = cdk.Token.asString(this.getAtt("IdentityDNSRecordValue1", cdk.ResolutionTypeHint.STRING)), this.attrIdentityDnsRecordValue2 = cdk.Token.asString(this.getAtt("IdentityDNSRecordValue2", cdk.ResolutionTypeHint.STRING)), this.attrIdentityDnsRecordValue3 = cdk.Token.asString(this.getAtt("IdentityDNSRecordValue3", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.dkimSigningEnabled = props.dkimSigningEnabled, this.feedbackForwardingEnabled = props.feedbackForwardingEnabled, this.mailFromAttributes = props.mailFromAttributes, this.tags = props.tags;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnIdentity.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, dkimSigningEnabled: this.dkimSigningEnabled, feedbackForwardingEnabled: this.feedbackForwardingEnabled, mailFromAttributes: this.mailFromAttributes, tags: this.tags };
      }
      renderProperties(props) {
        return cfnIdentityPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnIdentity[_d] = { fqn: "aws-cdk-lib.aws_pinpointemail.CfnIdentity", version: "2.80.0" }, CfnIdentity.CFN_RESOURCE_TYPE_NAME = "AWS::PinpointEmail::Identity", exports2.CfnIdentity = CfnIdentity;
    function CfnIdentity_MailFromAttributesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("behaviorOnMxFailure", cdk.validateString)(properties.behaviorOnMxFailure)), errors.collect(cdk.propertyValidator("mailFromDomain", cdk.validateString)(properties.mailFromDomain)), errors.wrap('supplied properties not correct for "MailFromAttributesProperty"');
    }
    function cfnIdentityMailFromAttributesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIdentity_MailFromAttributesPropertyValidator(properties).assertSuccess(), { BehaviorOnMxFailure: cdk.stringToCloudFormation(properties.behaviorOnMxFailure), MailFromDomain: cdk.stringToCloudFormation(properties.mailFromDomain) }) : properties;
    }
    function CfnIdentityMailFromAttributesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("behaviorOnMxFailure", "BehaviorOnMxFailure", properties.BehaviorOnMxFailure != null ? cfn_parse.FromCloudFormation.getString(properties.BehaviorOnMxFailure) : void 0), ret.addPropertyResult("mailFromDomain", "MailFromDomain", properties.MailFromDomain != null ? cfn_parse.FromCloudFormation.getString(properties.MailFromDomain) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIdentity_TagsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TagsProperty"');
    }
    function cfnIdentityTagsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIdentity_TagsPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnIdentityTagsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-pinpointemail/lib/index.js
var require_lib210 = __commonJS({
  "node_modules/aws-cdk-lib/aws-pinpointemail/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_pinpointemail_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-pinpointemail/index.js
var require_aws_pinpointemail = __commonJS({
  "node_modules/aws-cdk-lib/aws-pinpointemail/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib210(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-pipes/lib/pipes.generated.js
var require_pipes_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-pipes/lib/pipes.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnPipe = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnPipePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("desiredState", cdk.validateString)(properties.desiredState)), errors.collect(cdk.propertyValidator("enrichment", cdk.validateString)(properties.enrichment)), errors.collect(cdk.propertyValidator("enrichmentParameters", CfnPipe_PipeEnrichmentParametersPropertyValidator)(properties.enrichmentParameters)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("source", cdk.requiredValidator)(properties.source)), errors.collect(cdk.propertyValidator("source", cdk.validateString)(properties.source)), errors.collect(cdk.propertyValidator("sourceParameters", CfnPipe_PipeSourceParametersPropertyValidator)(properties.sourceParameters)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.collect(cdk.propertyValidator("target", cdk.requiredValidator)(properties.target)), errors.collect(cdk.propertyValidator("target", cdk.validateString)(properties.target)), errors.collect(cdk.propertyValidator("targetParameters", CfnPipe_PipeTargetParametersPropertyValidator)(properties.targetParameters)), errors.wrap('supplied properties not correct for "CfnPipeProps"');
    }
    function cfnPipePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipePropsValidator(properties).assertSuccess(), { RoleArn: cdk.stringToCloudFormation(properties.roleArn), Source: cdk.stringToCloudFormation(properties.source), Target: cdk.stringToCloudFormation(properties.target), Description: cdk.stringToCloudFormation(properties.description), DesiredState: cdk.stringToCloudFormation(properties.desiredState), Enrichment: cdk.stringToCloudFormation(properties.enrichment), EnrichmentParameters: cfnPipePipeEnrichmentParametersPropertyToCloudFormation(properties.enrichmentParameters), Name: cdk.stringToCloudFormation(properties.name), SourceParameters: cfnPipePipeSourceParametersPropertyToCloudFormation(properties.sourceParameters), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags), TargetParameters: cfnPipePipeTargetParametersPropertyToCloudFormation(properties.targetParameters) }) : properties;
    }
    function CfnPipePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("source", "Source", cfn_parse.FromCloudFormation.getString(properties.Source)), ret.addPropertyResult("target", "Target", cfn_parse.FromCloudFormation.getString(properties.Target)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("desiredState", "DesiredState", properties.DesiredState != null ? cfn_parse.FromCloudFormation.getString(properties.DesiredState) : void 0), ret.addPropertyResult("enrichment", "Enrichment", properties.Enrichment != null ? cfn_parse.FromCloudFormation.getString(properties.Enrichment) : void 0), ret.addPropertyResult("enrichmentParameters", "EnrichmentParameters", properties.EnrichmentParameters != null ? CfnPipePipeEnrichmentParametersPropertyFromCloudFormation(properties.EnrichmentParameters) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("sourceParameters", "SourceParameters", properties.SourceParameters != null ? CfnPipePipeSourceParametersPropertyFromCloudFormation(properties.SourceParameters) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addPropertyResult("targetParameters", "TargetParameters", properties.TargetParameters != null ? CfnPipePipeTargetParametersPropertyFromCloudFormation(properties.TargetParameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPipe = class _CfnPipe extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPipePropsFromCloudFormation(resourceProperties), ret = new _CfnPipe(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPipe.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_pipes_CfnPipeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPipe), error;
        }
        cdk.requireProperty(props, "roleArn", this), cdk.requireProperty(props, "source", this), cdk.requireProperty(props, "target", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrCurrentState = cdk.Token.asString(this.getAtt("CurrentState", cdk.ResolutionTypeHint.STRING)), this.attrLastModifiedTime = cdk.Token.asString(this.getAtt("LastModifiedTime", cdk.ResolutionTypeHint.STRING)), this.attrStateReason = cdk.Token.asString(this.getAtt("StateReason", cdk.ResolutionTypeHint.STRING)), this.roleArn = props.roleArn, this.source = props.source, this.target = props.target, this.description = props.description, this.desiredState = props.desiredState, this.enrichment = props.enrichment, this.enrichmentParameters = props.enrichmentParameters, this.name = props.name, this.sourceParameters = props.sourceParameters, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::Pipes::Pipe", props.tags, { tagPropertyName: "tags" }), this.targetParameters = props.targetParameters;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPipe.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { roleArn: this.roleArn, source: this.source, target: this.target, description: this.description, desiredState: this.desiredState, enrichment: this.enrichment, enrichmentParameters: this.enrichmentParameters, name: this.name, sourceParameters: this.sourceParameters, tags: this.tags.renderTags(), targetParameters: this.targetParameters };
      }
      renderProperties(props) {
        return cfnPipePropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnPipe[_a] = { fqn: "aws-cdk-lib.aws_pipes.CfnPipe", version: "2.80.0" }, CfnPipe.CFN_RESOURCE_TYPE_NAME = "AWS::Pipes::Pipe", exports2.CfnPipe = CfnPipe;
    function CfnPipe_AwsVpcConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("assignPublicIp", cdk.validateString)(properties.assignPublicIp)), errors.collect(cdk.propertyValidator("securityGroups", cdk.listValidator(cdk.validateString))(properties.securityGroups)), errors.collect(cdk.propertyValidator("subnets", cdk.requiredValidator)(properties.subnets)), errors.collect(cdk.propertyValidator("subnets", cdk.listValidator(cdk.validateString))(properties.subnets)), errors.wrap('supplied properties not correct for "AwsVpcConfigurationProperty"');
    }
    function cfnPipeAwsVpcConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_AwsVpcConfigurationPropertyValidator(properties).assertSuccess(), { AssignPublicIp: cdk.stringToCloudFormation(properties.assignPublicIp), SecurityGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroups), Subnets: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnets) }) : properties;
    }
    function CfnPipeAwsVpcConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("assignPublicIp", "AssignPublicIp", properties.AssignPublicIp != null ? cfn_parse.FromCloudFormation.getString(properties.AssignPublicIp) : void 0), ret.addPropertyResult("securityGroups", "SecurityGroups", properties.SecurityGroups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroups) : void 0), ret.addPropertyResult("subnets", "Subnets", cfn_parse.FromCloudFormation.getStringArray(properties.Subnets)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_BatchArrayPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("size", cdk.validateNumber)(properties.size)), errors.wrap('supplied properties not correct for "BatchArrayPropertiesProperty"');
    }
    function cfnPipeBatchArrayPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_BatchArrayPropertiesPropertyValidator(properties).assertSuccess(), { Size: cdk.numberToCloudFormation(properties.size) }) : properties;
    }
    function CfnPipeBatchArrayPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("size", "Size", properties.Size != null ? cfn_parse.FromCloudFormation.getNumber(properties.Size) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_BatchContainerOverridesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("command", cdk.listValidator(cdk.validateString))(properties.command)), errors.collect(cdk.propertyValidator("environment", cdk.listValidator(CfnPipe_BatchEnvironmentVariablePropertyValidator))(properties.environment)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("resourceRequirements", cdk.listValidator(CfnPipe_BatchResourceRequirementPropertyValidator))(properties.resourceRequirements)), errors.wrap('supplied properties not correct for "BatchContainerOverridesProperty"');
    }
    function cfnPipeBatchContainerOverridesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_BatchContainerOverridesPropertyValidator(properties).assertSuccess(), { Command: cdk.listMapper(cdk.stringToCloudFormation)(properties.command), Environment: cdk.listMapper(cfnPipeBatchEnvironmentVariablePropertyToCloudFormation)(properties.environment), InstanceType: cdk.stringToCloudFormation(properties.instanceType), ResourceRequirements: cdk.listMapper(cfnPipeBatchResourceRequirementPropertyToCloudFormation)(properties.resourceRequirements) }) : properties;
    }
    function CfnPipeBatchContainerOverridesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("command", "Command", properties.Command != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Command) : void 0), ret.addPropertyResult("environment", "Environment", properties.Environment != null ? cfn_parse.FromCloudFormation.getArray(CfnPipeBatchEnvironmentVariablePropertyFromCloudFormation)(properties.Environment) : void 0), ret.addPropertyResult("instanceType", "InstanceType", properties.InstanceType != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceType) : void 0), ret.addPropertyResult("resourceRequirements", "ResourceRequirements", properties.ResourceRequirements != null ? cfn_parse.FromCloudFormation.getArray(CfnPipeBatchResourceRequirementPropertyFromCloudFormation)(properties.ResourceRequirements) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_BatchEnvironmentVariablePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "BatchEnvironmentVariableProperty"');
    }
    function cfnPipeBatchEnvironmentVariablePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_BatchEnvironmentVariablePropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnPipeBatchEnvironmentVariablePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_BatchJobDependencyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("jobId", cdk.validateString)(properties.jobId)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "BatchJobDependencyProperty"');
    }
    function cfnPipeBatchJobDependencyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_BatchJobDependencyPropertyValidator(properties).assertSuccess(), { JobId: cdk.stringToCloudFormation(properties.jobId), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnPipeBatchJobDependencyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("jobId", "JobId", properties.JobId != null ? cfn_parse.FromCloudFormation.getString(properties.JobId) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_BatchResourceRequirementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "BatchResourceRequirementProperty"');
    }
    function cfnPipeBatchResourceRequirementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_BatchResourceRequirementPropertyValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnPipeBatchResourceRequirementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_BatchRetryStrategyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attempts", cdk.validateNumber)(properties.attempts)), errors.wrap('supplied properties not correct for "BatchRetryStrategyProperty"');
    }
    function cfnPipeBatchRetryStrategyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_BatchRetryStrategyPropertyValidator(properties).assertSuccess(), { Attempts: cdk.numberToCloudFormation(properties.attempts) }) : properties;
    }
    function CfnPipeBatchRetryStrategyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attempts", "Attempts", properties.Attempts != null ? cfn_parse.FromCloudFormation.getNumber(properties.Attempts) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_CapacityProviderStrategyItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("base", cdk.validateNumber)(properties.base)), errors.collect(cdk.propertyValidator("capacityProvider", cdk.requiredValidator)(properties.capacityProvider)), errors.collect(cdk.propertyValidator("capacityProvider", cdk.validateString)(properties.capacityProvider)), errors.collect(cdk.propertyValidator("weight", cdk.validateNumber)(properties.weight)), errors.wrap('supplied properties not correct for "CapacityProviderStrategyItemProperty"');
    }
    function cfnPipeCapacityProviderStrategyItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_CapacityProviderStrategyItemPropertyValidator(properties).assertSuccess(), { Base: cdk.numberToCloudFormation(properties.base), CapacityProvider: cdk.stringToCloudFormation(properties.capacityProvider), Weight: cdk.numberToCloudFormation(properties.weight) }) : properties;
    }
    function CfnPipeCapacityProviderStrategyItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("base", "Base", properties.Base != null ? cfn_parse.FromCloudFormation.getNumber(properties.Base) : void 0), ret.addPropertyResult("capacityProvider", "CapacityProvider", cfn_parse.FromCloudFormation.getString(properties.CapacityProvider)), ret.addPropertyResult("weight", "Weight", properties.Weight != null ? cfn_parse.FromCloudFormation.getNumber(properties.Weight) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_DeadLetterConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.wrap('supplied properties not correct for "DeadLetterConfigProperty"');
    }
    function cfnPipeDeadLetterConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_DeadLetterConfigPropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn) }) : properties;
    }
    function CfnPipeDeadLetterConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", properties.Arn != null ? cfn_parse.FromCloudFormation.getString(properties.Arn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_EcsContainerOverridePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("command", cdk.listValidator(cdk.validateString))(properties.command)), errors.collect(cdk.propertyValidator("cpu", cdk.validateNumber)(properties.cpu)), errors.collect(cdk.propertyValidator("environment", cdk.listValidator(CfnPipe_EcsEnvironmentVariablePropertyValidator))(properties.environment)), errors.collect(cdk.propertyValidator("environmentFiles", cdk.listValidator(CfnPipe_EcsEnvironmentFilePropertyValidator))(properties.environmentFiles)), errors.collect(cdk.propertyValidator("memory", cdk.validateNumber)(properties.memory)), errors.collect(cdk.propertyValidator("memoryReservation", cdk.validateNumber)(properties.memoryReservation)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("resourceRequirements", cdk.listValidator(CfnPipe_EcsResourceRequirementPropertyValidator))(properties.resourceRequirements)), errors.wrap('supplied properties not correct for "EcsContainerOverrideProperty"');
    }
    function cfnPipeEcsContainerOverridePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_EcsContainerOverridePropertyValidator(properties).assertSuccess(), { Command: cdk.listMapper(cdk.stringToCloudFormation)(properties.command), Cpu: cdk.numberToCloudFormation(properties.cpu), Environment: cdk.listMapper(cfnPipeEcsEnvironmentVariablePropertyToCloudFormation)(properties.environment), EnvironmentFiles: cdk.listMapper(cfnPipeEcsEnvironmentFilePropertyToCloudFormation)(properties.environmentFiles), Memory: cdk.numberToCloudFormation(properties.memory), MemoryReservation: cdk.numberToCloudFormation(properties.memoryReservation), Name: cdk.stringToCloudFormation(properties.name), ResourceRequirements: cdk.listMapper(cfnPipeEcsResourceRequirementPropertyToCloudFormation)(properties.resourceRequirements) }) : properties;
    }
    function CfnPipeEcsContainerOverridePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("command", "Command", properties.Command != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Command) : void 0), ret.addPropertyResult("cpu", "Cpu", properties.Cpu != null ? cfn_parse.FromCloudFormation.getNumber(properties.Cpu) : void 0), ret.addPropertyResult("environment", "Environment", properties.Environment != null ? cfn_parse.FromCloudFormation.getArray(CfnPipeEcsEnvironmentVariablePropertyFromCloudFormation)(properties.Environment) : void 0), ret.addPropertyResult("environmentFiles", "EnvironmentFiles", properties.EnvironmentFiles != null ? cfn_parse.FromCloudFormation.getArray(CfnPipeEcsEnvironmentFilePropertyFromCloudFormation)(properties.EnvironmentFiles) : void 0), ret.addPropertyResult("memory", "Memory", properties.Memory != null ? cfn_parse.FromCloudFormation.getNumber(properties.Memory) : void 0), ret.addPropertyResult("memoryReservation", "MemoryReservation", properties.MemoryReservation != null ? cfn_parse.FromCloudFormation.getNumber(properties.MemoryReservation) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("resourceRequirements", "ResourceRequirements", properties.ResourceRequirements != null ? cfn_parse.FromCloudFormation.getArray(CfnPipeEcsResourceRequirementPropertyFromCloudFormation)(properties.ResourceRequirements) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_EcsEnvironmentFilePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "EcsEnvironmentFileProperty"');
    }
    function cfnPipeEcsEnvironmentFilePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_EcsEnvironmentFilePropertyValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnPipeEcsEnvironmentFilePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_EcsEnvironmentVariablePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "EcsEnvironmentVariableProperty"');
    }
    function cfnPipeEcsEnvironmentVariablePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_EcsEnvironmentVariablePropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnPipeEcsEnvironmentVariablePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_EcsEphemeralStoragePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sizeInGiB", cdk.requiredValidator)(properties.sizeInGiB)), errors.collect(cdk.propertyValidator("sizeInGiB", cdk.validateNumber)(properties.sizeInGiB)), errors.wrap('supplied properties not correct for "EcsEphemeralStorageProperty"');
    }
    function cfnPipeEcsEphemeralStoragePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_EcsEphemeralStoragePropertyValidator(properties).assertSuccess(), { SizeInGiB: cdk.numberToCloudFormation(properties.sizeInGiB) }) : properties;
    }
    function CfnPipeEcsEphemeralStoragePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sizeInGiB", "SizeInGiB", cfn_parse.FromCloudFormation.getNumber(properties.SizeInGiB)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_EcsInferenceAcceleratorOverridePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deviceName", cdk.validateString)(properties.deviceName)), errors.collect(cdk.propertyValidator("deviceType", cdk.validateString)(properties.deviceType)), errors.wrap('supplied properties not correct for "EcsInferenceAcceleratorOverrideProperty"');
    }
    function cfnPipeEcsInferenceAcceleratorOverridePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_EcsInferenceAcceleratorOverridePropertyValidator(properties).assertSuccess(), { DeviceName: cdk.stringToCloudFormation(properties.deviceName), DeviceType: cdk.stringToCloudFormation(properties.deviceType) }) : properties;
    }
    function CfnPipeEcsInferenceAcceleratorOverridePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deviceName", "DeviceName", properties.DeviceName != null ? cfn_parse.FromCloudFormation.getString(properties.DeviceName) : void 0), ret.addPropertyResult("deviceType", "DeviceType", properties.DeviceType != null ? cfn_parse.FromCloudFormation.getString(properties.DeviceType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_EcsResourceRequirementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "EcsResourceRequirementProperty"');
    }
    function cfnPipeEcsResourceRequirementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_EcsResourceRequirementPropertyValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnPipeEcsResourceRequirementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_EcsTaskOverridePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containerOverrides", cdk.listValidator(CfnPipe_EcsContainerOverridePropertyValidator))(properties.containerOverrides)), errors.collect(cdk.propertyValidator("cpu", cdk.validateString)(properties.cpu)), errors.collect(cdk.propertyValidator("ephemeralStorage", CfnPipe_EcsEphemeralStoragePropertyValidator)(properties.ephemeralStorage)), errors.collect(cdk.propertyValidator("executionRoleArn", cdk.validateString)(properties.executionRoleArn)), errors.collect(cdk.propertyValidator("inferenceAcceleratorOverrides", cdk.listValidator(CfnPipe_EcsInferenceAcceleratorOverridePropertyValidator))(properties.inferenceAcceleratorOverrides)), errors.collect(cdk.propertyValidator("memory", cdk.validateString)(properties.memory)), errors.collect(cdk.propertyValidator("taskRoleArn", cdk.validateString)(properties.taskRoleArn)), errors.wrap('supplied properties not correct for "EcsTaskOverrideProperty"');
    }
    function cfnPipeEcsTaskOverridePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_EcsTaskOverridePropertyValidator(properties).assertSuccess(), { ContainerOverrides: cdk.listMapper(cfnPipeEcsContainerOverridePropertyToCloudFormation)(properties.containerOverrides), Cpu: cdk.stringToCloudFormation(properties.cpu), EphemeralStorage: cfnPipeEcsEphemeralStoragePropertyToCloudFormation(properties.ephemeralStorage), ExecutionRoleArn: cdk.stringToCloudFormation(properties.executionRoleArn), InferenceAcceleratorOverrides: cdk.listMapper(cfnPipeEcsInferenceAcceleratorOverridePropertyToCloudFormation)(properties.inferenceAcceleratorOverrides), Memory: cdk.stringToCloudFormation(properties.memory), TaskRoleArn: cdk.stringToCloudFormation(properties.taskRoleArn) }) : properties;
    }
    function CfnPipeEcsTaskOverridePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containerOverrides", "ContainerOverrides", properties.ContainerOverrides != null ? cfn_parse.FromCloudFormation.getArray(CfnPipeEcsContainerOverridePropertyFromCloudFormation)(properties.ContainerOverrides) : void 0), ret.addPropertyResult("cpu", "Cpu", properties.Cpu != null ? cfn_parse.FromCloudFormation.getString(properties.Cpu) : void 0), ret.addPropertyResult("ephemeralStorage", "EphemeralStorage", properties.EphemeralStorage != null ? CfnPipeEcsEphemeralStoragePropertyFromCloudFormation(properties.EphemeralStorage) : void 0), ret.addPropertyResult("executionRoleArn", "ExecutionRoleArn", properties.ExecutionRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.ExecutionRoleArn) : void 0), ret.addPropertyResult("inferenceAcceleratorOverrides", "InferenceAcceleratorOverrides", properties.InferenceAcceleratorOverrides != null ? cfn_parse.FromCloudFormation.getArray(CfnPipeEcsInferenceAcceleratorOverridePropertyFromCloudFormation)(properties.InferenceAcceleratorOverrides) : void 0), ret.addPropertyResult("memory", "Memory", properties.Memory != null ? cfn_parse.FromCloudFormation.getString(properties.Memory) : void 0), ret.addPropertyResult("taskRoleArn", "TaskRoleArn", properties.TaskRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.TaskRoleArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_FilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("pattern", cdk.validateString)(properties.pattern)), errors.wrap('supplied properties not correct for "FilterProperty"');
    }
    function cfnPipeFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_FilterPropertyValidator(properties).assertSuccess(), { Pattern: cdk.stringToCloudFormation(properties.pattern) }) : properties;
    }
    function CfnPipeFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("pattern", "Pattern", properties.Pattern != null ? cfn_parse.FromCloudFormation.getString(properties.Pattern) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_FilterCriteriaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("filters", cdk.listValidator(CfnPipe_FilterPropertyValidator))(properties.filters)), errors.wrap('supplied properties not correct for "FilterCriteriaProperty"');
    }
    function cfnPipeFilterCriteriaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_FilterCriteriaPropertyValidator(properties).assertSuccess(), { Filters: cdk.listMapper(cfnPipeFilterPropertyToCloudFormation)(properties.filters) }) : properties;
    }
    function CfnPipeFilterCriteriaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("filters", "Filters", properties.Filters != null ? cfn_parse.FromCloudFormation.getArray(CfnPipeFilterPropertyFromCloudFormation)(properties.Filters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_MQBrokerAccessCredentialsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("basicAuth", cdk.requiredValidator)(properties.basicAuth)), errors.collect(cdk.propertyValidator("basicAuth", cdk.validateString)(properties.basicAuth)), errors.wrap('supplied properties not correct for "MQBrokerAccessCredentialsProperty"');
    }
    function cfnPipeMQBrokerAccessCredentialsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_MQBrokerAccessCredentialsPropertyValidator(properties).assertSuccess(), { BasicAuth: cdk.stringToCloudFormation(properties.basicAuth) }) : properties;
    }
    function CfnPipeMQBrokerAccessCredentialsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("basicAuth", "BasicAuth", cfn_parse.FromCloudFormation.getString(properties.BasicAuth)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_MSKAccessCredentialsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clientCertificateTlsAuth", cdk.validateString)(properties.clientCertificateTlsAuth)), errors.collect(cdk.propertyValidator("saslScram512Auth", cdk.validateString)(properties.saslScram512Auth)), errors.wrap('supplied properties not correct for "MSKAccessCredentialsProperty"');
    }
    function cfnPipeMSKAccessCredentialsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_MSKAccessCredentialsPropertyValidator(properties).assertSuccess(), { ClientCertificateTlsAuth: cdk.stringToCloudFormation(properties.clientCertificateTlsAuth), SaslScram512Auth: cdk.stringToCloudFormation(properties.saslScram512Auth) }) : properties;
    }
    function CfnPipeMSKAccessCredentialsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clientCertificateTlsAuth", "ClientCertificateTlsAuth", properties.ClientCertificateTlsAuth != null ? cfn_parse.FromCloudFormation.getString(properties.ClientCertificateTlsAuth) : void 0), ret.addPropertyResult("saslScram512Auth", "SaslScram512Auth", properties.SaslScram512Auth != null ? cfn_parse.FromCloudFormation.getString(properties.SaslScram512Auth) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_NetworkConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("awsvpcConfiguration", CfnPipe_AwsVpcConfigurationPropertyValidator)(properties.awsvpcConfiguration)), errors.wrap('supplied properties not correct for "NetworkConfigurationProperty"');
    }
    function cfnPipeNetworkConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_NetworkConfigurationPropertyValidator(properties).assertSuccess(), { AwsvpcConfiguration: cfnPipeAwsVpcConfigurationPropertyToCloudFormation(properties.awsvpcConfiguration) }) : properties;
    }
    function CfnPipeNetworkConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("awsvpcConfiguration", "AwsvpcConfiguration", properties.AwsvpcConfiguration != null ? CfnPipeAwsVpcConfigurationPropertyFromCloudFormation(properties.AwsvpcConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_PipeEnrichmentHttpParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("headerParameters", cdk.hashValidator(cdk.validateString))(properties.headerParameters)), errors.collect(cdk.propertyValidator("pathParameterValues", cdk.listValidator(cdk.validateString))(properties.pathParameterValues)), errors.collect(cdk.propertyValidator("queryStringParameters", cdk.hashValidator(cdk.validateString))(properties.queryStringParameters)), errors.wrap('supplied properties not correct for "PipeEnrichmentHttpParametersProperty"');
    }
    function cfnPipePipeEnrichmentHttpParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_PipeEnrichmentHttpParametersPropertyValidator(properties).assertSuccess(), { HeaderParameters: cdk.hashMapper(cdk.stringToCloudFormation)(properties.headerParameters), PathParameterValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.pathParameterValues), QueryStringParameters: cdk.hashMapper(cdk.stringToCloudFormation)(properties.queryStringParameters) }) : properties;
    }
    function CfnPipePipeEnrichmentHttpParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("headerParameters", "HeaderParameters", properties.HeaderParameters != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.HeaderParameters) : void 0), ret.addPropertyResult("pathParameterValues", "PathParameterValues", properties.PathParameterValues != null ? cfn_parse.FromCloudFormation.getStringArray(properties.PathParameterValues) : void 0), ret.addPropertyResult("queryStringParameters", "QueryStringParameters", properties.QueryStringParameters != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.QueryStringParameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_PipeEnrichmentParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("httpParameters", CfnPipe_PipeEnrichmentHttpParametersPropertyValidator)(properties.httpParameters)), errors.collect(cdk.propertyValidator("inputTemplate", cdk.validateString)(properties.inputTemplate)), errors.wrap('supplied properties not correct for "PipeEnrichmentParametersProperty"');
    }
    function cfnPipePipeEnrichmentParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_PipeEnrichmentParametersPropertyValidator(properties).assertSuccess(), { HttpParameters: cfnPipePipeEnrichmentHttpParametersPropertyToCloudFormation(properties.httpParameters), InputTemplate: cdk.stringToCloudFormation(properties.inputTemplate) }) : properties;
    }
    function CfnPipePipeEnrichmentParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("httpParameters", "HttpParameters", properties.HttpParameters != null ? CfnPipePipeEnrichmentHttpParametersPropertyFromCloudFormation(properties.HttpParameters) : void 0), ret.addPropertyResult("inputTemplate", "InputTemplate", properties.InputTemplate != null ? cfn_parse.FromCloudFormation.getString(properties.InputTemplate) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_PipeSourceActiveMQBrokerParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("batchSize", cdk.validateNumber)(properties.batchSize)), errors.collect(cdk.propertyValidator("credentials", cdk.requiredValidator)(properties.credentials)), errors.collect(cdk.propertyValidator("credentials", CfnPipe_MQBrokerAccessCredentialsPropertyValidator)(properties.credentials)), errors.collect(cdk.propertyValidator("maximumBatchingWindowInSeconds", cdk.validateNumber)(properties.maximumBatchingWindowInSeconds)), errors.collect(cdk.propertyValidator("queueName", cdk.requiredValidator)(properties.queueName)), errors.collect(cdk.propertyValidator("queueName", cdk.validateString)(properties.queueName)), errors.wrap('supplied properties not correct for "PipeSourceActiveMQBrokerParametersProperty"');
    }
    function cfnPipePipeSourceActiveMQBrokerParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_PipeSourceActiveMQBrokerParametersPropertyValidator(properties).assertSuccess(), { BatchSize: cdk.numberToCloudFormation(properties.batchSize), Credentials: cfnPipeMQBrokerAccessCredentialsPropertyToCloudFormation(properties.credentials), MaximumBatchingWindowInSeconds: cdk.numberToCloudFormation(properties.maximumBatchingWindowInSeconds), QueueName: cdk.stringToCloudFormation(properties.queueName) }) : properties;
    }
    function CfnPipePipeSourceActiveMQBrokerParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("batchSize", "BatchSize", properties.BatchSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.BatchSize) : void 0), ret.addPropertyResult("credentials", "Credentials", CfnPipeMQBrokerAccessCredentialsPropertyFromCloudFormation(properties.Credentials)), ret.addPropertyResult("maximumBatchingWindowInSeconds", "MaximumBatchingWindowInSeconds", properties.MaximumBatchingWindowInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumBatchingWindowInSeconds) : void 0), ret.addPropertyResult("queueName", "QueueName", cfn_parse.FromCloudFormation.getString(properties.QueueName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_PipeSourceDynamoDBStreamParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("batchSize", cdk.validateNumber)(properties.batchSize)), errors.collect(cdk.propertyValidator("deadLetterConfig", CfnPipe_DeadLetterConfigPropertyValidator)(properties.deadLetterConfig)), errors.collect(cdk.propertyValidator("maximumBatchingWindowInSeconds", cdk.validateNumber)(properties.maximumBatchingWindowInSeconds)), errors.collect(cdk.propertyValidator("maximumRecordAgeInSeconds", cdk.validateNumber)(properties.maximumRecordAgeInSeconds)), errors.collect(cdk.propertyValidator("maximumRetryAttempts", cdk.validateNumber)(properties.maximumRetryAttempts)), errors.collect(cdk.propertyValidator("onPartialBatchItemFailure", cdk.validateString)(properties.onPartialBatchItemFailure)), errors.collect(cdk.propertyValidator("parallelizationFactor", cdk.validateNumber)(properties.parallelizationFactor)), errors.collect(cdk.propertyValidator("startingPosition", cdk.requiredValidator)(properties.startingPosition)), errors.collect(cdk.propertyValidator("startingPosition", cdk.validateString)(properties.startingPosition)), errors.wrap('supplied properties not correct for "PipeSourceDynamoDBStreamParametersProperty"');
    }
    function cfnPipePipeSourceDynamoDBStreamParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_PipeSourceDynamoDBStreamParametersPropertyValidator(properties).assertSuccess(), { BatchSize: cdk.numberToCloudFormation(properties.batchSize), DeadLetterConfig: cfnPipeDeadLetterConfigPropertyToCloudFormation(properties.deadLetterConfig), MaximumBatchingWindowInSeconds: cdk.numberToCloudFormation(properties.maximumBatchingWindowInSeconds), MaximumRecordAgeInSeconds: cdk.numberToCloudFormation(properties.maximumRecordAgeInSeconds), MaximumRetryAttempts: cdk.numberToCloudFormation(properties.maximumRetryAttempts), OnPartialBatchItemFailure: cdk.stringToCloudFormation(properties.onPartialBatchItemFailure), ParallelizationFactor: cdk.numberToCloudFormation(properties.parallelizationFactor), StartingPosition: cdk.stringToCloudFormation(properties.startingPosition) }) : properties;
    }
    function CfnPipePipeSourceDynamoDBStreamParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("batchSize", "BatchSize", properties.BatchSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.BatchSize) : void 0), ret.addPropertyResult("deadLetterConfig", "DeadLetterConfig", properties.DeadLetterConfig != null ? CfnPipeDeadLetterConfigPropertyFromCloudFormation(properties.DeadLetterConfig) : void 0), ret.addPropertyResult("maximumBatchingWindowInSeconds", "MaximumBatchingWindowInSeconds", properties.MaximumBatchingWindowInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumBatchingWindowInSeconds) : void 0), ret.addPropertyResult("maximumRecordAgeInSeconds", "MaximumRecordAgeInSeconds", properties.MaximumRecordAgeInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumRecordAgeInSeconds) : void 0), ret.addPropertyResult("maximumRetryAttempts", "MaximumRetryAttempts", properties.MaximumRetryAttempts != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumRetryAttempts) : void 0), ret.addPropertyResult("onPartialBatchItemFailure", "OnPartialBatchItemFailure", properties.OnPartialBatchItemFailure != null ? cfn_parse.FromCloudFormation.getString(properties.OnPartialBatchItemFailure) : void 0), ret.addPropertyResult("parallelizationFactor", "ParallelizationFactor", properties.ParallelizationFactor != null ? cfn_parse.FromCloudFormation.getNumber(properties.ParallelizationFactor) : void 0), ret.addPropertyResult("startingPosition", "StartingPosition", cfn_parse.FromCloudFormation.getString(properties.StartingPosition)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_PipeSourceKinesisStreamParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("batchSize", cdk.validateNumber)(properties.batchSize)), errors.collect(cdk.propertyValidator("deadLetterConfig", CfnPipe_DeadLetterConfigPropertyValidator)(properties.deadLetterConfig)), errors.collect(cdk.propertyValidator("maximumBatchingWindowInSeconds", cdk.validateNumber)(properties.maximumBatchingWindowInSeconds)), errors.collect(cdk.propertyValidator("maximumRecordAgeInSeconds", cdk.validateNumber)(properties.maximumRecordAgeInSeconds)), errors.collect(cdk.propertyValidator("maximumRetryAttempts", cdk.validateNumber)(properties.maximumRetryAttempts)), errors.collect(cdk.propertyValidator("onPartialBatchItemFailure", cdk.validateString)(properties.onPartialBatchItemFailure)), errors.collect(cdk.propertyValidator("parallelizationFactor", cdk.validateNumber)(properties.parallelizationFactor)), errors.collect(cdk.propertyValidator("startingPosition", cdk.requiredValidator)(properties.startingPosition)), errors.collect(cdk.propertyValidator("startingPosition", cdk.validateString)(properties.startingPosition)), errors.collect(cdk.propertyValidator("startingPositionTimestamp", cdk.validateString)(properties.startingPositionTimestamp)), errors.wrap('supplied properties not correct for "PipeSourceKinesisStreamParametersProperty"');
    }
    function cfnPipePipeSourceKinesisStreamParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_PipeSourceKinesisStreamParametersPropertyValidator(properties).assertSuccess(), { BatchSize: cdk.numberToCloudFormation(properties.batchSize), DeadLetterConfig: cfnPipeDeadLetterConfigPropertyToCloudFormation(properties.deadLetterConfig), MaximumBatchingWindowInSeconds: cdk.numberToCloudFormation(properties.maximumBatchingWindowInSeconds), MaximumRecordAgeInSeconds: cdk.numberToCloudFormation(properties.maximumRecordAgeInSeconds), MaximumRetryAttempts: cdk.numberToCloudFormation(properties.maximumRetryAttempts), OnPartialBatchItemFailure: cdk.stringToCloudFormation(properties.onPartialBatchItemFailure), ParallelizationFactor: cdk.numberToCloudFormation(properties.parallelizationFactor), StartingPosition: cdk.stringToCloudFormation(properties.startingPosition), StartingPositionTimestamp: cdk.stringToCloudFormation(properties.startingPositionTimestamp) }) : properties;
    }
    function CfnPipePipeSourceKinesisStreamParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("batchSize", "BatchSize", properties.BatchSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.BatchSize) : void 0), ret.addPropertyResult("deadLetterConfig", "DeadLetterConfig", properties.DeadLetterConfig != null ? CfnPipeDeadLetterConfigPropertyFromCloudFormation(properties.DeadLetterConfig) : void 0), ret.addPropertyResult("maximumBatchingWindowInSeconds", "MaximumBatchingWindowInSeconds", properties.MaximumBatchingWindowInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumBatchingWindowInSeconds) : void 0), ret.addPropertyResult("maximumRecordAgeInSeconds", "MaximumRecordAgeInSeconds", properties.MaximumRecordAgeInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumRecordAgeInSeconds) : void 0), ret.addPropertyResult("maximumRetryAttempts", "MaximumRetryAttempts", properties.MaximumRetryAttempts != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumRetryAttempts) : void 0), ret.addPropertyResult("onPartialBatchItemFailure", "OnPartialBatchItemFailure", properties.OnPartialBatchItemFailure != null ? cfn_parse.FromCloudFormation.getString(properties.OnPartialBatchItemFailure) : void 0), ret.addPropertyResult("parallelizationFactor", "ParallelizationFactor", properties.ParallelizationFactor != null ? cfn_parse.FromCloudFormation.getNumber(properties.ParallelizationFactor) : void 0), ret.addPropertyResult("startingPosition", "StartingPosition", cfn_parse.FromCloudFormation.getString(properties.StartingPosition)), ret.addPropertyResult("startingPositionTimestamp", "StartingPositionTimestamp", properties.StartingPositionTimestamp != null ? cfn_parse.FromCloudFormation.getString(properties.StartingPositionTimestamp) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_PipeSourceManagedStreamingKafkaParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("batchSize", cdk.validateNumber)(properties.batchSize)), errors.collect(cdk.propertyValidator("consumerGroupId", cdk.validateString)(properties.consumerGroupId)), errors.collect(cdk.propertyValidator("credentials", CfnPipe_MSKAccessCredentialsPropertyValidator)(properties.credentials)), errors.collect(cdk.propertyValidator("maximumBatchingWindowInSeconds", cdk.validateNumber)(properties.maximumBatchingWindowInSeconds)), errors.collect(cdk.propertyValidator("startingPosition", cdk.validateString)(properties.startingPosition)), errors.collect(cdk.propertyValidator("topicName", cdk.requiredValidator)(properties.topicName)), errors.collect(cdk.propertyValidator("topicName", cdk.validateString)(properties.topicName)), errors.wrap('supplied properties not correct for "PipeSourceManagedStreamingKafkaParametersProperty"');
    }
    function cfnPipePipeSourceManagedStreamingKafkaParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_PipeSourceManagedStreamingKafkaParametersPropertyValidator(properties).assertSuccess(), { BatchSize: cdk.numberToCloudFormation(properties.batchSize), ConsumerGroupID: cdk.stringToCloudFormation(properties.consumerGroupId), Credentials: cfnPipeMSKAccessCredentialsPropertyToCloudFormation(properties.credentials), MaximumBatchingWindowInSeconds: cdk.numberToCloudFormation(properties.maximumBatchingWindowInSeconds), StartingPosition: cdk.stringToCloudFormation(properties.startingPosition), TopicName: cdk.stringToCloudFormation(properties.topicName) }) : properties;
    }
    function CfnPipePipeSourceManagedStreamingKafkaParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("batchSize", "BatchSize", properties.BatchSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.BatchSize) : void 0), ret.addPropertyResult("consumerGroupId", "ConsumerGroupID", properties.ConsumerGroupID != null ? cfn_parse.FromCloudFormation.getString(properties.ConsumerGroupID) : void 0), ret.addPropertyResult("credentials", "Credentials", properties.Credentials != null ? CfnPipeMSKAccessCredentialsPropertyFromCloudFormation(properties.Credentials) : void 0), ret.addPropertyResult("maximumBatchingWindowInSeconds", "MaximumBatchingWindowInSeconds", properties.MaximumBatchingWindowInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumBatchingWindowInSeconds) : void 0), ret.addPropertyResult("startingPosition", "StartingPosition", properties.StartingPosition != null ? cfn_parse.FromCloudFormation.getString(properties.StartingPosition) : void 0), ret.addPropertyResult("topicName", "TopicName", cfn_parse.FromCloudFormation.getString(properties.TopicName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_PipeSourceParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("activeMqBrokerParameters", CfnPipe_PipeSourceActiveMQBrokerParametersPropertyValidator)(properties.activeMqBrokerParameters)), errors.collect(cdk.propertyValidator("dynamoDbStreamParameters", CfnPipe_PipeSourceDynamoDBStreamParametersPropertyValidator)(properties.dynamoDbStreamParameters)), errors.collect(cdk.propertyValidator("filterCriteria", CfnPipe_FilterCriteriaPropertyValidator)(properties.filterCriteria)), errors.collect(cdk.propertyValidator("kinesisStreamParameters", CfnPipe_PipeSourceKinesisStreamParametersPropertyValidator)(properties.kinesisStreamParameters)), errors.collect(cdk.propertyValidator("managedStreamingKafkaParameters", CfnPipe_PipeSourceManagedStreamingKafkaParametersPropertyValidator)(properties.managedStreamingKafkaParameters)), errors.collect(cdk.propertyValidator("rabbitMqBrokerParameters", CfnPipe_PipeSourceRabbitMQBrokerParametersPropertyValidator)(properties.rabbitMqBrokerParameters)), errors.collect(cdk.propertyValidator("selfManagedKafkaParameters", CfnPipe_PipeSourceSelfManagedKafkaParametersPropertyValidator)(properties.selfManagedKafkaParameters)), errors.collect(cdk.propertyValidator("sqsQueueParameters", CfnPipe_PipeSourceSqsQueueParametersPropertyValidator)(properties.sqsQueueParameters)), errors.wrap('supplied properties not correct for "PipeSourceParametersProperty"');
    }
    function cfnPipePipeSourceParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_PipeSourceParametersPropertyValidator(properties).assertSuccess(), { ActiveMQBrokerParameters: cfnPipePipeSourceActiveMQBrokerParametersPropertyToCloudFormation(properties.activeMqBrokerParameters), DynamoDBStreamParameters: cfnPipePipeSourceDynamoDBStreamParametersPropertyToCloudFormation(properties.dynamoDbStreamParameters), FilterCriteria: cfnPipeFilterCriteriaPropertyToCloudFormation(properties.filterCriteria), KinesisStreamParameters: cfnPipePipeSourceKinesisStreamParametersPropertyToCloudFormation(properties.kinesisStreamParameters), ManagedStreamingKafkaParameters: cfnPipePipeSourceManagedStreamingKafkaParametersPropertyToCloudFormation(properties.managedStreamingKafkaParameters), RabbitMQBrokerParameters: cfnPipePipeSourceRabbitMQBrokerParametersPropertyToCloudFormation(properties.rabbitMqBrokerParameters), SelfManagedKafkaParameters: cfnPipePipeSourceSelfManagedKafkaParametersPropertyToCloudFormation(properties.selfManagedKafkaParameters), SqsQueueParameters: cfnPipePipeSourceSqsQueueParametersPropertyToCloudFormation(properties.sqsQueueParameters) }) : properties;
    }
    function CfnPipePipeSourceParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("activeMqBrokerParameters", "ActiveMQBrokerParameters", properties.ActiveMQBrokerParameters != null ? CfnPipePipeSourceActiveMQBrokerParametersPropertyFromCloudFormation(properties.ActiveMQBrokerParameters) : void 0), ret.addPropertyResult("dynamoDbStreamParameters", "DynamoDBStreamParameters", properties.DynamoDBStreamParameters != null ? CfnPipePipeSourceDynamoDBStreamParametersPropertyFromCloudFormation(properties.DynamoDBStreamParameters) : void 0), ret.addPropertyResult("filterCriteria", "FilterCriteria", properties.FilterCriteria != null ? CfnPipeFilterCriteriaPropertyFromCloudFormation(properties.FilterCriteria) : void 0), ret.addPropertyResult("kinesisStreamParameters", "KinesisStreamParameters", properties.KinesisStreamParameters != null ? CfnPipePipeSourceKinesisStreamParametersPropertyFromCloudFormation(properties.KinesisStreamParameters) : void 0), ret.addPropertyResult("managedStreamingKafkaParameters", "ManagedStreamingKafkaParameters", properties.ManagedStreamingKafkaParameters != null ? CfnPipePipeSourceManagedStreamingKafkaParametersPropertyFromCloudFormation(properties.ManagedStreamingKafkaParameters) : void 0), ret.addPropertyResult("rabbitMqBrokerParameters", "RabbitMQBrokerParameters", properties.RabbitMQBrokerParameters != null ? CfnPipePipeSourceRabbitMQBrokerParametersPropertyFromCloudFormation(properties.RabbitMQBrokerParameters) : void 0), ret.addPropertyResult("selfManagedKafkaParameters", "SelfManagedKafkaParameters", properties.SelfManagedKafkaParameters != null ? CfnPipePipeSourceSelfManagedKafkaParametersPropertyFromCloudFormation(properties.SelfManagedKafkaParameters) : void 0), ret.addPropertyResult("sqsQueueParameters", "SqsQueueParameters", properties.SqsQueueParameters != null ? CfnPipePipeSourceSqsQueueParametersPropertyFromCloudFormation(properties.SqsQueueParameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_PipeSourceRabbitMQBrokerParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("batchSize", cdk.validateNumber)(properties.batchSize)), errors.collect(cdk.propertyValidator("credentials", cdk.requiredValidator)(properties.credentials)), errors.collect(cdk.propertyValidator("credentials", CfnPipe_MQBrokerAccessCredentialsPropertyValidator)(properties.credentials)), errors.collect(cdk.propertyValidator("maximumBatchingWindowInSeconds", cdk.validateNumber)(properties.maximumBatchingWindowInSeconds)), errors.collect(cdk.propertyValidator("queueName", cdk.requiredValidator)(properties.queueName)), errors.collect(cdk.propertyValidator("queueName", cdk.validateString)(properties.queueName)), errors.collect(cdk.propertyValidator("virtualHost", cdk.validateString)(properties.virtualHost)), errors.wrap('supplied properties not correct for "PipeSourceRabbitMQBrokerParametersProperty"');
    }
    function cfnPipePipeSourceRabbitMQBrokerParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_PipeSourceRabbitMQBrokerParametersPropertyValidator(properties).assertSuccess(), { BatchSize: cdk.numberToCloudFormation(properties.batchSize), Credentials: cfnPipeMQBrokerAccessCredentialsPropertyToCloudFormation(properties.credentials), MaximumBatchingWindowInSeconds: cdk.numberToCloudFormation(properties.maximumBatchingWindowInSeconds), QueueName: cdk.stringToCloudFormation(properties.queueName), VirtualHost: cdk.stringToCloudFormation(properties.virtualHost) }) : properties;
    }
    function CfnPipePipeSourceRabbitMQBrokerParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("batchSize", "BatchSize", properties.BatchSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.BatchSize) : void 0), ret.addPropertyResult("credentials", "Credentials", CfnPipeMQBrokerAccessCredentialsPropertyFromCloudFormation(properties.Credentials)), ret.addPropertyResult("maximumBatchingWindowInSeconds", "MaximumBatchingWindowInSeconds", properties.MaximumBatchingWindowInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumBatchingWindowInSeconds) : void 0), ret.addPropertyResult("queueName", "QueueName", cfn_parse.FromCloudFormation.getString(properties.QueueName)), ret.addPropertyResult("virtualHost", "VirtualHost", properties.VirtualHost != null ? cfn_parse.FromCloudFormation.getString(properties.VirtualHost) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_PipeSourceSelfManagedKafkaParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("additionalBootstrapServers", cdk.listValidator(cdk.validateString))(properties.additionalBootstrapServers)), errors.collect(cdk.propertyValidator("batchSize", cdk.validateNumber)(properties.batchSize)), errors.collect(cdk.propertyValidator("consumerGroupId", cdk.validateString)(properties.consumerGroupId)), errors.collect(cdk.propertyValidator("credentials", CfnPipe_SelfManagedKafkaAccessConfigurationCredentialsPropertyValidator)(properties.credentials)), errors.collect(cdk.propertyValidator("maximumBatchingWindowInSeconds", cdk.validateNumber)(properties.maximumBatchingWindowInSeconds)), errors.collect(cdk.propertyValidator("serverRootCaCertificate", cdk.validateString)(properties.serverRootCaCertificate)), errors.collect(cdk.propertyValidator("startingPosition", cdk.validateString)(properties.startingPosition)), errors.collect(cdk.propertyValidator("topicName", cdk.requiredValidator)(properties.topicName)), errors.collect(cdk.propertyValidator("topicName", cdk.validateString)(properties.topicName)), errors.collect(cdk.propertyValidator("vpc", CfnPipe_SelfManagedKafkaAccessConfigurationVpcPropertyValidator)(properties.vpc)), errors.wrap('supplied properties not correct for "PipeSourceSelfManagedKafkaParametersProperty"');
    }
    function cfnPipePipeSourceSelfManagedKafkaParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_PipeSourceSelfManagedKafkaParametersPropertyValidator(properties).assertSuccess(), { AdditionalBootstrapServers: cdk.listMapper(cdk.stringToCloudFormation)(properties.additionalBootstrapServers), BatchSize: cdk.numberToCloudFormation(properties.batchSize), ConsumerGroupID: cdk.stringToCloudFormation(properties.consumerGroupId), Credentials: cfnPipeSelfManagedKafkaAccessConfigurationCredentialsPropertyToCloudFormation(properties.credentials), MaximumBatchingWindowInSeconds: cdk.numberToCloudFormation(properties.maximumBatchingWindowInSeconds), ServerRootCaCertificate: cdk.stringToCloudFormation(properties.serverRootCaCertificate), StartingPosition: cdk.stringToCloudFormation(properties.startingPosition), TopicName: cdk.stringToCloudFormation(properties.topicName), Vpc: cfnPipeSelfManagedKafkaAccessConfigurationVpcPropertyToCloudFormation(properties.vpc) }) : properties;
    }
    function CfnPipePipeSourceSelfManagedKafkaParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("additionalBootstrapServers", "AdditionalBootstrapServers", properties.AdditionalBootstrapServers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AdditionalBootstrapServers) : void 0), ret.addPropertyResult("batchSize", "BatchSize", properties.BatchSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.BatchSize) : void 0), ret.addPropertyResult("consumerGroupId", "ConsumerGroupID", properties.ConsumerGroupID != null ? cfn_parse.FromCloudFormation.getString(properties.ConsumerGroupID) : void 0), ret.addPropertyResult("credentials", "Credentials", properties.Credentials != null ? CfnPipeSelfManagedKafkaAccessConfigurationCredentialsPropertyFromCloudFormation(properties.Credentials) : void 0), ret.addPropertyResult("maximumBatchingWindowInSeconds", "MaximumBatchingWindowInSeconds", properties.MaximumBatchingWindowInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumBatchingWindowInSeconds) : void 0), ret.addPropertyResult("serverRootCaCertificate", "ServerRootCaCertificate", properties.ServerRootCaCertificate != null ? cfn_parse.FromCloudFormation.getString(properties.ServerRootCaCertificate) : void 0), ret.addPropertyResult("startingPosition", "StartingPosition", properties.StartingPosition != null ? cfn_parse.FromCloudFormation.getString(properties.StartingPosition) : void 0), ret.addPropertyResult("topicName", "TopicName", cfn_parse.FromCloudFormation.getString(properties.TopicName)), ret.addPropertyResult("vpc", "Vpc", properties.Vpc != null ? CfnPipeSelfManagedKafkaAccessConfigurationVpcPropertyFromCloudFormation(properties.Vpc) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_PipeSourceSqsQueueParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("batchSize", cdk.validateNumber)(properties.batchSize)), errors.collect(cdk.propertyValidator("maximumBatchingWindowInSeconds", cdk.validateNumber)(properties.maximumBatchingWindowInSeconds)), errors.wrap('supplied properties not correct for "PipeSourceSqsQueueParametersProperty"');
    }
    function cfnPipePipeSourceSqsQueueParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_PipeSourceSqsQueueParametersPropertyValidator(properties).assertSuccess(), { BatchSize: cdk.numberToCloudFormation(properties.batchSize), MaximumBatchingWindowInSeconds: cdk.numberToCloudFormation(properties.maximumBatchingWindowInSeconds) }) : properties;
    }
    function CfnPipePipeSourceSqsQueueParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("batchSize", "BatchSize", properties.BatchSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.BatchSize) : void 0), ret.addPropertyResult("maximumBatchingWindowInSeconds", "MaximumBatchingWindowInSeconds", properties.MaximumBatchingWindowInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumBatchingWindowInSeconds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_PipeTargetBatchJobParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arrayProperties", CfnPipe_BatchArrayPropertiesPropertyValidator)(properties.arrayProperties)), errors.collect(cdk.propertyValidator("containerOverrides", CfnPipe_BatchContainerOverridesPropertyValidator)(properties.containerOverrides)), errors.collect(cdk.propertyValidator("dependsOn", cdk.listValidator(CfnPipe_BatchJobDependencyPropertyValidator))(properties.dependsOn)), errors.collect(cdk.propertyValidator("jobDefinition", cdk.requiredValidator)(properties.jobDefinition)), errors.collect(cdk.propertyValidator("jobDefinition", cdk.validateString)(properties.jobDefinition)), errors.collect(cdk.propertyValidator("jobName", cdk.requiredValidator)(properties.jobName)), errors.collect(cdk.propertyValidator("jobName", cdk.validateString)(properties.jobName)), errors.collect(cdk.propertyValidator("parameters", cdk.hashValidator(cdk.validateString))(properties.parameters)), errors.collect(cdk.propertyValidator("retryStrategy", CfnPipe_BatchRetryStrategyPropertyValidator)(properties.retryStrategy)), errors.wrap('supplied properties not correct for "PipeTargetBatchJobParametersProperty"');
    }
    function cfnPipePipeTargetBatchJobParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_PipeTargetBatchJobParametersPropertyValidator(properties).assertSuccess(), { ArrayProperties: cfnPipeBatchArrayPropertiesPropertyToCloudFormation(properties.arrayProperties), ContainerOverrides: cfnPipeBatchContainerOverridesPropertyToCloudFormation(properties.containerOverrides), DependsOn: cdk.listMapper(cfnPipeBatchJobDependencyPropertyToCloudFormation)(properties.dependsOn), JobDefinition: cdk.stringToCloudFormation(properties.jobDefinition), JobName: cdk.stringToCloudFormation(properties.jobName), Parameters: cdk.hashMapper(cdk.stringToCloudFormation)(properties.parameters), RetryStrategy: cfnPipeBatchRetryStrategyPropertyToCloudFormation(properties.retryStrategy) }) : properties;
    }
    function CfnPipePipeTargetBatchJobParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arrayProperties", "ArrayProperties", properties.ArrayProperties != null ? CfnPipeBatchArrayPropertiesPropertyFromCloudFormation(properties.ArrayProperties) : void 0), ret.addPropertyResult("containerOverrides", "ContainerOverrides", properties.ContainerOverrides != null ? CfnPipeBatchContainerOverridesPropertyFromCloudFormation(properties.ContainerOverrides) : void 0), ret.addPropertyResult("dependsOn", "DependsOn", properties.DependsOn != null ? cfn_parse.FromCloudFormation.getArray(CfnPipeBatchJobDependencyPropertyFromCloudFormation)(properties.DependsOn) : void 0), ret.addPropertyResult("jobDefinition", "JobDefinition", cfn_parse.FromCloudFormation.getString(properties.JobDefinition)), ret.addPropertyResult("jobName", "JobName", cfn_parse.FromCloudFormation.getString(properties.JobName)), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Parameters) : void 0), ret.addPropertyResult("retryStrategy", "RetryStrategy", properties.RetryStrategy != null ? CfnPipeBatchRetryStrategyPropertyFromCloudFormation(properties.RetryStrategy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_PipeTargetCloudWatchLogsParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logStreamName", cdk.validateString)(properties.logStreamName)), errors.collect(cdk.propertyValidator("timestamp", cdk.validateString)(properties.timestamp)), errors.wrap('supplied properties not correct for "PipeTargetCloudWatchLogsParametersProperty"');
    }
    function cfnPipePipeTargetCloudWatchLogsParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_PipeTargetCloudWatchLogsParametersPropertyValidator(properties).assertSuccess(), { LogStreamName: cdk.stringToCloudFormation(properties.logStreamName), Timestamp: cdk.stringToCloudFormation(properties.timestamp) }) : properties;
    }
    function CfnPipePipeTargetCloudWatchLogsParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logStreamName", "LogStreamName", properties.LogStreamName != null ? cfn_parse.FromCloudFormation.getString(properties.LogStreamName) : void 0), ret.addPropertyResult("timestamp", "Timestamp", properties.Timestamp != null ? cfn_parse.FromCloudFormation.getString(properties.Timestamp) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_PipeTargetEcsTaskParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("capacityProviderStrategy", cdk.listValidator(CfnPipe_CapacityProviderStrategyItemPropertyValidator))(properties.capacityProviderStrategy)), errors.collect(cdk.propertyValidator("enableEcsManagedTags", cdk.validateBoolean)(properties.enableEcsManagedTags)), errors.collect(cdk.propertyValidator("enableExecuteCommand", cdk.validateBoolean)(properties.enableExecuteCommand)), errors.collect(cdk.propertyValidator("group", cdk.validateString)(properties.group)), errors.collect(cdk.propertyValidator("launchType", cdk.validateString)(properties.launchType)), errors.collect(cdk.propertyValidator("networkConfiguration", CfnPipe_NetworkConfigurationPropertyValidator)(properties.networkConfiguration)), errors.collect(cdk.propertyValidator("overrides", CfnPipe_EcsTaskOverridePropertyValidator)(properties.overrides)), errors.collect(cdk.propertyValidator("placementConstraints", cdk.listValidator(CfnPipe_PlacementConstraintPropertyValidator))(properties.placementConstraints)), errors.collect(cdk.propertyValidator("placementStrategy", cdk.listValidator(CfnPipe_PlacementStrategyPropertyValidator))(properties.placementStrategy)), errors.collect(cdk.propertyValidator("platformVersion", cdk.validateString)(properties.platformVersion)), errors.collect(cdk.propertyValidator("propagateTags", cdk.validateString)(properties.propagateTags)), errors.collect(cdk.propertyValidator("referenceId", cdk.validateString)(properties.referenceId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("taskCount", cdk.validateNumber)(properties.taskCount)), errors.collect(cdk.propertyValidator("taskDefinitionArn", cdk.requiredValidator)(properties.taskDefinitionArn)), errors.collect(cdk.propertyValidator("taskDefinitionArn", cdk.validateString)(properties.taskDefinitionArn)), errors.wrap('supplied properties not correct for "PipeTargetEcsTaskParametersProperty"');
    }
    function cfnPipePipeTargetEcsTaskParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_PipeTargetEcsTaskParametersPropertyValidator(properties).assertSuccess(), { CapacityProviderStrategy: cdk.listMapper(cfnPipeCapacityProviderStrategyItemPropertyToCloudFormation)(properties.capacityProviderStrategy), EnableECSManagedTags: cdk.booleanToCloudFormation(properties.enableEcsManagedTags), EnableExecuteCommand: cdk.booleanToCloudFormation(properties.enableExecuteCommand), Group: cdk.stringToCloudFormation(properties.group), LaunchType: cdk.stringToCloudFormation(properties.launchType), NetworkConfiguration: cfnPipeNetworkConfigurationPropertyToCloudFormation(properties.networkConfiguration), Overrides: cfnPipeEcsTaskOverridePropertyToCloudFormation(properties.overrides), PlacementConstraints: cdk.listMapper(cfnPipePlacementConstraintPropertyToCloudFormation)(properties.placementConstraints), PlacementStrategy: cdk.listMapper(cfnPipePlacementStrategyPropertyToCloudFormation)(properties.placementStrategy), PlatformVersion: cdk.stringToCloudFormation(properties.platformVersion), PropagateTags: cdk.stringToCloudFormation(properties.propagateTags), ReferenceId: cdk.stringToCloudFormation(properties.referenceId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TaskCount: cdk.numberToCloudFormation(properties.taskCount), TaskDefinitionArn: cdk.stringToCloudFormation(properties.taskDefinitionArn) }) : properties;
    }
    function CfnPipePipeTargetEcsTaskParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("capacityProviderStrategy", "CapacityProviderStrategy", properties.CapacityProviderStrategy != null ? cfn_parse.FromCloudFormation.getArray(CfnPipeCapacityProviderStrategyItemPropertyFromCloudFormation)(properties.CapacityProviderStrategy) : void 0), ret.addPropertyResult("enableEcsManagedTags", "EnableECSManagedTags", properties.EnableECSManagedTags != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableECSManagedTags) : void 0), ret.addPropertyResult("enableExecuteCommand", "EnableExecuteCommand", properties.EnableExecuteCommand != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableExecuteCommand) : void 0), ret.addPropertyResult("group", "Group", properties.Group != null ? cfn_parse.FromCloudFormation.getString(properties.Group) : void 0), ret.addPropertyResult("launchType", "LaunchType", properties.LaunchType != null ? cfn_parse.FromCloudFormation.getString(properties.LaunchType) : void 0), ret.addPropertyResult("networkConfiguration", "NetworkConfiguration", properties.NetworkConfiguration != null ? CfnPipeNetworkConfigurationPropertyFromCloudFormation(properties.NetworkConfiguration) : void 0), ret.addPropertyResult("overrides", "Overrides", properties.Overrides != null ? CfnPipeEcsTaskOverridePropertyFromCloudFormation(properties.Overrides) : void 0), ret.addPropertyResult("placementConstraints", "PlacementConstraints", properties.PlacementConstraints != null ? cfn_parse.FromCloudFormation.getArray(CfnPipePlacementConstraintPropertyFromCloudFormation)(properties.PlacementConstraints) : void 0), ret.addPropertyResult("placementStrategy", "PlacementStrategy", properties.PlacementStrategy != null ? cfn_parse.FromCloudFormation.getArray(CfnPipePlacementStrategyPropertyFromCloudFormation)(properties.PlacementStrategy) : void 0), ret.addPropertyResult("platformVersion", "PlatformVersion", properties.PlatformVersion != null ? cfn_parse.FromCloudFormation.getString(properties.PlatformVersion) : void 0), ret.addPropertyResult("propagateTags", "PropagateTags", properties.PropagateTags != null ? cfn_parse.FromCloudFormation.getString(properties.PropagateTags) : void 0), ret.addPropertyResult("referenceId", "ReferenceId", properties.ReferenceId != null ? cfn_parse.FromCloudFormation.getString(properties.ReferenceId) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("taskCount", "TaskCount", properties.TaskCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.TaskCount) : void 0), ret.addPropertyResult("taskDefinitionArn", "TaskDefinitionArn", cfn_parse.FromCloudFormation.getString(properties.TaskDefinitionArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_PipeTargetEventBridgeEventBusParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("detailType", cdk.validateString)(properties.detailType)), errors.collect(cdk.propertyValidator("endpointId", cdk.validateString)(properties.endpointId)), errors.collect(cdk.propertyValidator("resources", cdk.listValidator(cdk.validateString))(properties.resources)), errors.collect(cdk.propertyValidator("source", cdk.validateString)(properties.source)), errors.collect(cdk.propertyValidator("time", cdk.validateString)(properties.time)), errors.wrap('supplied properties not correct for "PipeTargetEventBridgeEventBusParametersProperty"');
    }
    function cfnPipePipeTargetEventBridgeEventBusParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_PipeTargetEventBridgeEventBusParametersPropertyValidator(properties).assertSuccess(), { DetailType: cdk.stringToCloudFormation(properties.detailType), EndpointId: cdk.stringToCloudFormation(properties.endpointId), Resources: cdk.listMapper(cdk.stringToCloudFormation)(properties.resources), Source: cdk.stringToCloudFormation(properties.source), Time: cdk.stringToCloudFormation(properties.time) }) : properties;
    }
    function CfnPipePipeTargetEventBridgeEventBusParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("detailType", "DetailType", properties.DetailType != null ? cfn_parse.FromCloudFormation.getString(properties.DetailType) : void 0), ret.addPropertyResult("endpointId", "EndpointId", properties.EndpointId != null ? cfn_parse.FromCloudFormation.getString(properties.EndpointId) : void 0), ret.addPropertyResult("resources", "Resources", properties.Resources != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Resources) : void 0), ret.addPropertyResult("source", "Source", properties.Source != null ? cfn_parse.FromCloudFormation.getString(properties.Source) : void 0), ret.addPropertyResult("time", "Time", properties.Time != null ? cfn_parse.FromCloudFormation.getString(properties.Time) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_PipeTargetHttpParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("headerParameters", cdk.hashValidator(cdk.validateString))(properties.headerParameters)), errors.collect(cdk.propertyValidator("pathParameterValues", cdk.listValidator(cdk.validateString))(properties.pathParameterValues)), errors.collect(cdk.propertyValidator("queryStringParameters", cdk.hashValidator(cdk.validateString))(properties.queryStringParameters)), errors.wrap('supplied properties not correct for "PipeTargetHttpParametersProperty"');
    }
    function cfnPipePipeTargetHttpParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_PipeTargetHttpParametersPropertyValidator(properties).assertSuccess(), { HeaderParameters: cdk.hashMapper(cdk.stringToCloudFormation)(properties.headerParameters), PathParameterValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.pathParameterValues), QueryStringParameters: cdk.hashMapper(cdk.stringToCloudFormation)(properties.queryStringParameters) }) : properties;
    }
    function CfnPipePipeTargetHttpParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("headerParameters", "HeaderParameters", properties.HeaderParameters != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.HeaderParameters) : void 0), ret.addPropertyResult("pathParameterValues", "PathParameterValues", properties.PathParameterValues != null ? cfn_parse.FromCloudFormation.getStringArray(properties.PathParameterValues) : void 0), ret.addPropertyResult("queryStringParameters", "QueryStringParameters", properties.QueryStringParameters != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.QueryStringParameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_PipeTargetKinesisStreamParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("partitionKey", cdk.requiredValidator)(properties.partitionKey)), errors.collect(cdk.propertyValidator("partitionKey", cdk.validateString)(properties.partitionKey)), errors.wrap('supplied properties not correct for "PipeTargetKinesisStreamParametersProperty"');
    }
    function cfnPipePipeTargetKinesisStreamParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_PipeTargetKinesisStreamParametersPropertyValidator(properties).assertSuccess(), { PartitionKey: cdk.stringToCloudFormation(properties.partitionKey) }) : properties;
    }
    function CfnPipePipeTargetKinesisStreamParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("partitionKey", "PartitionKey", cfn_parse.FromCloudFormation.getString(properties.PartitionKey)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_PipeTargetLambdaFunctionParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("invocationType", cdk.validateString)(properties.invocationType)), errors.wrap('supplied properties not correct for "PipeTargetLambdaFunctionParametersProperty"');
    }
    function cfnPipePipeTargetLambdaFunctionParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_PipeTargetLambdaFunctionParametersPropertyValidator(properties).assertSuccess(), { InvocationType: cdk.stringToCloudFormation(properties.invocationType) }) : properties;
    }
    function CfnPipePipeTargetLambdaFunctionParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("invocationType", "InvocationType", properties.InvocationType != null ? cfn_parse.FromCloudFormation.getString(properties.InvocationType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_PipeTargetParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("batchJobParameters", CfnPipe_PipeTargetBatchJobParametersPropertyValidator)(properties.batchJobParameters)), errors.collect(cdk.propertyValidator("cloudWatchLogsParameters", CfnPipe_PipeTargetCloudWatchLogsParametersPropertyValidator)(properties.cloudWatchLogsParameters)), errors.collect(cdk.propertyValidator("ecsTaskParameters", CfnPipe_PipeTargetEcsTaskParametersPropertyValidator)(properties.ecsTaskParameters)), errors.collect(cdk.propertyValidator("eventBridgeEventBusParameters", CfnPipe_PipeTargetEventBridgeEventBusParametersPropertyValidator)(properties.eventBridgeEventBusParameters)), errors.collect(cdk.propertyValidator("httpParameters", CfnPipe_PipeTargetHttpParametersPropertyValidator)(properties.httpParameters)), errors.collect(cdk.propertyValidator("inputTemplate", cdk.validateString)(properties.inputTemplate)), errors.collect(cdk.propertyValidator("kinesisStreamParameters", CfnPipe_PipeTargetKinesisStreamParametersPropertyValidator)(properties.kinesisStreamParameters)), errors.collect(cdk.propertyValidator("lambdaFunctionParameters", CfnPipe_PipeTargetLambdaFunctionParametersPropertyValidator)(properties.lambdaFunctionParameters)), errors.collect(cdk.propertyValidator("redshiftDataParameters", CfnPipe_PipeTargetRedshiftDataParametersPropertyValidator)(properties.redshiftDataParameters)), errors.collect(cdk.propertyValidator("sageMakerPipelineParameters", CfnPipe_PipeTargetSageMakerPipelineParametersPropertyValidator)(properties.sageMakerPipelineParameters)), errors.collect(cdk.propertyValidator("sqsQueueParameters", CfnPipe_PipeTargetSqsQueueParametersPropertyValidator)(properties.sqsQueueParameters)), errors.collect(cdk.propertyValidator("stepFunctionStateMachineParameters", CfnPipe_PipeTargetStateMachineParametersPropertyValidator)(properties.stepFunctionStateMachineParameters)), errors.wrap('supplied properties not correct for "PipeTargetParametersProperty"');
    }
    function cfnPipePipeTargetParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_PipeTargetParametersPropertyValidator(properties).assertSuccess(), { BatchJobParameters: cfnPipePipeTargetBatchJobParametersPropertyToCloudFormation(properties.batchJobParameters), CloudWatchLogsParameters: cfnPipePipeTargetCloudWatchLogsParametersPropertyToCloudFormation(properties.cloudWatchLogsParameters), EcsTaskParameters: cfnPipePipeTargetEcsTaskParametersPropertyToCloudFormation(properties.ecsTaskParameters), EventBridgeEventBusParameters: cfnPipePipeTargetEventBridgeEventBusParametersPropertyToCloudFormation(properties.eventBridgeEventBusParameters), HttpParameters: cfnPipePipeTargetHttpParametersPropertyToCloudFormation(properties.httpParameters), InputTemplate: cdk.stringToCloudFormation(properties.inputTemplate), KinesisStreamParameters: cfnPipePipeTargetKinesisStreamParametersPropertyToCloudFormation(properties.kinesisStreamParameters), LambdaFunctionParameters: cfnPipePipeTargetLambdaFunctionParametersPropertyToCloudFormation(properties.lambdaFunctionParameters), RedshiftDataParameters: cfnPipePipeTargetRedshiftDataParametersPropertyToCloudFormation(properties.redshiftDataParameters), SageMakerPipelineParameters: cfnPipePipeTargetSageMakerPipelineParametersPropertyToCloudFormation(properties.sageMakerPipelineParameters), SqsQueueParameters: cfnPipePipeTargetSqsQueueParametersPropertyToCloudFormation(properties.sqsQueueParameters), StepFunctionStateMachineParameters: cfnPipePipeTargetStateMachineParametersPropertyToCloudFormation(properties.stepFunctionStateMachineParameters) }) : properties;
    }
    function CfnPipePipeTargetParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("batchJobParameters", "BatchJobParameters", properties.BatchJobParameters != null ? CfnPipePipeTargetBatchJobParametersPropertyFromCloudFormation(properties.BatchJobParameters) : void 0), ret.addPropertyResult("cloudWatchLogsParameters", "CloudWatchLogsParameters", properties.CloudWatchLogsParameters != null ? CfnPipePipeTargetCloudWatchLogsParametersPropertyFromCloudFormation(properties.CloudWatchLogsParameters) : void 0), ret.addPropertyResult("ecsTaskParameters", "EcsTaskParameters", properties.EcsTaskParameters != null ? CfnPipePipeTargetEcsTaskParametersPropertyFromCloudFormation(properties.EcsTaskParameters) : void 0), ret.addPropertyResult("eventBridgeEventBusParameters", "EventBridgeEventBusParameters", properties.EventBridgeEventBusParameters != null ? CfnPipePipeTargetEventBridgeEventBusParametersPropertyFromCloudFormation(properties.EventBridgeEventBusParameters) : void 0), ret.addPropertyResult("httpParameters", "HttpParameters", properties.HttpParameters != null ? CfnPipePipeTargetHttpParametersPropertyFromCloudFormation(properties.HttpParameters) : void 0), ret.addPropertyResult("inputTemplate", "InputTemplate", properties.InputTemplate != null ? cfn_parse.FromCloudFormation.getString(properties.InputTemplate) : void 0), ret.addPropertyResult("kinesisStreamParameters", "KinesisStreamParameters", properties.KinesisStreamParameters != null ? CfnPipePipeTargetKinesisStreamParametersPropertyFromCloudFormation(properties.KinesisStreamParameters) : void 0), ret.addPropertyResult("lambdaFunctionParameters", "LambdaFunctionParameters", properties.LambdaFunctionParameters != null ? CfnPipePipeTargetLambdaFunctionParametersPropertyFromCloudFormation(properties.LambdaFunctionParameters) : void 0), ret.addPropertyResult("redshiftDataParameters", "RedshiftDataParameters", properties.RedshiftDataParameters != null ? CfnPipePipeTargetRedshiftDataParametersPropertyFromCloudFormation(properties.RedshiftDataParameters) : void 0), ret.addPropertyResult("sageMakerPipelineParameters", "SageMakerPipelineParameters", properties.SageMakerPipelineParameters != null ? CfnPipePipeTargetSageMakerPipelineParametersPropertyFromCloudFormation(properties.SageMakerPipelineParameters) : void 0), ret.addPropertyResult("sqsQueueParameters", "SqsQueueParameters", properties.SqsQueueParameters != null ? CfnPipePipeTargetSqsQueueParametersPropertyFromCloudFormation(properties.SqsQueueParameters) : void 0), ret.addPropertyResult("stepFunctionStateMachineParameters", "StepFunctionStateMachineParameters", properties.StepFunctionStateMachineParameters != null ? CfnPipePipeTargetStateMachineParametersPropertyFromCloudFormation(properties.StepFunctionStateMachineParameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_PipeTargetRedshiftDataParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("database", cdk.requiredValidator)(properties.database)), errors.collect(cdk.propertyValidator("database", cdk.validateString)(properties.database)), errors.collect(cdk.propertyValidator("dbUser", cdk.validateString)(properties.dbUser)), errors.collect(cdk.propertyValidator("secretManagerArn", cdk.validateString)(properties.secretManagerArn)), errors.collect(cdk.propertyValidator("sqls", cdk.requiredValidator)(properties.sqls)), errors.collect(cdk.propertyValidator("sqls", cdk.listValidator(cdk.validateString))(properties.sqls)), errors.collect(cdk.propertyValidator("statementName", cdk.validateString)(properties.statementName)), errors.collect(cdk.propertyValidator("withEvent", cdk.validateBoolean)(properties.withEvent)), errors.wrap('supplied properties not correct for "PipeTargetRedshiftDataParametersProperty"');
    }
    function cfnPipePipeTargetRedshiftDataParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_PipeTargetRedshiftDataParametersPropertyValidator(properties).assertSuccess(), { Database: cdk.stringToCloudFormation(properties.database), DbUser: cdk.stringToCloudFormation(properties.dbUser), SecretManagerArn: cdk.stringToCloudFormation(properties.secretManagerArn), Sqls: cdk.listMapper(cdk.stringToCloudFormation)(properties.sqls), StatementName: cdk.stringToCloudFormation(properties.statementName), WithEvent: cdk.booleanToCloudFormation(properties.withEvent) }) : properties;
    }
    function CfnPipePipeTargetRedshiftDataParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("database", "Database", cfn_parse.FromCloudFormation.getString(properties.Database)), ret.addPropertyResult("dbUser", "DbUser", properties.DbUser != null ? cfn_parse.FromCloudFormation.getString(properties.DbUser) : void 0), ret.addPropertyResult("secretManagerArn", "SecretManagerArn", properties.SecretManagerArn != null ? cfn_parse.FromCloudFormation.getString(properties.SecretManagerArn) : void 0), ret.addPropertyResult("sqls", "Sqls", cfn_parse.FromCloudFormation.getStringArray(properties.Sqls)), ret.addPropertyResult("statementName", "StatementName", properties.StatementName != null ? cfn_parse.FromCloudFormation.getString(properties.StatementName) : void 0), ret.addPropertyResult("withEvent", "WithEvent", properties.WithEvent != null ? cfn_parse.FromCloudFormation.getBoolean(properties.WithEvent) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_PipeTargetSageMakerPipelineParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("pipelineParameterList", cdk.listValidator(CfnPipe_SageMakerPipelineParameterPropertyValidator))(properties.pipelineParameterList)), errors.wrap('supplied properties not correct for "PipeTargetSageMakerPipelineParametersProperty"');
    }
    function cfnPipePipeTargetSageMakerPipelineParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_PipeTargetSageMakerPipelineParametersPropertyValidator(properties).assertSuccess(), { PipelineParameterList: cdk.listMapper(cfnPipeSageMakerPipelineParameterPropertyToCloudFormation)(properties.pipelineParameterList) }) : properties;
    }
    function CfnPipePipeTargetSageMakerPipelineParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("pipelineParameterList", "PipelineParameterList", properties.PipelineParameterList != null ? cfn_parse.FromCloudFormation.getArray(CfnPipeSageMakerPipelineParameterPropertyFromCloudFormation)(properties.PipelineParameterList) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_PipeTargetSqsQueueParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("messageDeduplicationId", cdk.validateString)(properties.messageDeduplicationId)), errors.collect(cdk.propertyValidator("messageGroupId", cdk.validateString)(properties.messageGroupId)), errors.wrap('supplied properties not correct for "PipeTargetSqsQueueParametersProperty"');
    }
    function cfnPipePipeTargetSqsQueueParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_PipeTargetSqsQueueParametersPropertyValidator(properties).assertSuccess(), { MessageDeduplicationId: cdk.stringToCloudFormation(properties.messageDeduplicationId), MessageGroupId: cdk.stringToCloudFormation(properties.messageGroupId) }) : properties;
    }
    function CfnPipePipeTargetSqsQueueParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("messageDeduplicationId", "MessageDeduplicationId", properties.MessageDeduplicationId != null ? cfn_parse.FromCloudFormation.getString(properties.MessageDeduplicationId) : void 0), ret.addPropertyResult("messageGroupId", "MessageGroupId", properties.MessageGroupId != null ? cfn_parse.FromCloudFormation.getString(properties.MessageGroupId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_PipeTargetStateMachineParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("invocationType", cdk.validateString)(properties.invocationType)), errors.wrap('supplied properties not correct for "PipeTargetStateMachineParametersProperty"');
    }
    function cfnPipePipeTargetStateMachineParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_PipeTargetStateMachineParametersPropertyValidator(properties).assertSuccess(), { InvocationType: cdk.stringToCloudFormation(properties.invocationType) }) : properties;
    }
    function CfnPipePipeTargetStateMachineParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("invocationType", "InvocationType", properties.InvocationType != null ? cfn_parse.FromCloudFormation.getString(properties.InvocationType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_PlacementConstraintPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "PlacementConstraintProperty"');
    }
    function cfnPipePlacementConstraintPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_PlacementConstraintPropertyValidator(properties).assertSuccess(), { Expression: cdk.stringToCloudFormation(properties.expression), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnPipePlacementConstraintPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("expression", "Expression", properties.Expression != null ? cfn_parse.FromCloudFormation.getString(properties.Expression) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_PlacementStrategyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("field", cdk.validateString)(properties.field)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "PlacementStrategyProperty"');
    }
    function cfnPipePlacementStrategyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_PlacementStrategyPropertyValidator(properties).assertSuccess(), { Field: cdk.stringToCloudFormation(properties.field), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnPipePlacementStrategyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("field", "Field", properties.Field != null ? cfn_parse.FromCloudFormation.getString(properties.Field) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_SageMakerPipelineParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "SageMakerPipelineParameterProperty"');
    }
    function cfnPipeSageMakerPipelineParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_SageMakerPipelineParameterPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnPipeSageMakerPipelineParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_SelfManagedKafkaAccessConfigurationCredentialsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("basicAuth", cdk.validateString)(properties.basicAuth)), errors.collect(cdk.propertyValidator("clientCertificateTlsAuth", cdk.validateString)(properties.clientCertificateTlsAuth)), errors.collect(cdk.propertyValidator("saslScram256Auth", cdk.validateString)(properties.saslScram256Auth)), errors.collect(cdk.propertyValidator("saslScram512Auth", cdk.validateString)(properties.saslScram512Auth)), errors.wrap('supplied properties not correct for "SelfManagedKafkaAccessConfigurationCredentialsProperty"');
    }
    function cfnPipeSelfManagedKafkaAccessConfigurationCredentialsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_SelfManagedKafkaAccessConfigurationCredentialsPropertyValidator(properties).assertSuccess(), { BasicAuth: cdk.stringToCloudFormation(properties.basicAuth), ClientCertificateTlsAuth: cdk.stringToCloudFormation(properties.clientCertificateTlsAuth), SaslScram256Auth: cdk.stringToCloudFormation(properties.saslScram256Auth), SaslScram512Auth: cdk.stringToCloudFormation(properties.saslScram512Auth) }) : properties;
    }
    function CfnPipeSelfManagedKafkaAccessConfigurationCredentialsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("basicAuth", "BasicAuth", properties.BasicAuth != null ? cfn_parse.FromCloudFormation.getString(properties.BasicAuth) : void 0), ret.addPropertyResult("clientCertificateTlsAuth", "ClientCertificateTlsAuth", properties.ClientCertificateTlsAuth != null ? cfn_parse.FromCloudFormation.getString(properties.ClientCertificateTlsAuth) : void 0), ret.addPropertyResult("saslScram256Auth", "SaslScram256Auth", properties.SaslScram256Auth != null ? cfn_parse.FromCloudFormation.getString(properties.SaslScram256Auth) : void 0), ret.addPropertyResult("saslScram512Auth", "SaslScram512Auth", properties.SaslScram512Auth != null ? cfn_parse.FromCloudFormation.getString(properties.SaslScram512Auth) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipe_SelfManagedKafkaAccessConfigurationVpcPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroup", cdk.listValidator(cdk.validateString))(properties.securityGroup)), errors.collect(cdk.propertyValidator("subnets", cdk.listValidator(cdk.validateString))(properties.subnets)), errors.wrap('supplied properties not correct for "SelfManagedKafkaAccessConfigurationVpcProperty"');
    }
    function cfnPipeSelfManagedKafkaAccessConfigurationVpcPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipe_SelfManagedKafkaAccessConfigurationVpcPropertyValidator(properties).assertSuccess(), { SecurityGroup: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroup), Subnets: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnets) }) : properties;
    }
    function CfnPipeSelfManagedKafkaAccessConfigurationVpcPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroup", "SecurityGroup", properties.SecurityGroup != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroup) : void 0), ret.addPropertyResult("subnets", "Subnets", properties.Subnets != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Subnets) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-pipes/lib/index.js
var require_lib211 = __commonJS({
  "node_modules/aws-cdk-lib/aws-pipes/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_pipes_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-pipes/index.js
var require_aws_pipes = __commonJS({
  "node_modules/aws-cdk-lib/aws-pipes/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib211(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-proton/lib/proton.generated.js
var require_proton_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-proton/lib/proton.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnServiceTemplate = exports2.CfnEnvironmentTemplate = exports2.CfnEnvironmentAccountConnection = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnEnvironmentAccountConnectionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("codebuildRoleArn", cdk.validateString)(properties.codebuildRoleArn)), errors.collect(cdk.propertyValidator("componentRoleArn", cdk.validateString)(properties.componentRoleArn)), errors.collect(cdk.propertyValidator("environmentAccountId", cdk.validateString)(properties.environmentAccountId)), errors.collect(cdk.propertyValidator("environmentName", cdk.validateString)(properties.environmentName)), errors.collect(cdk.propertyValidator("managementAccountId", cdk.validateString)(properties.managementAccountId)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnEnvironmentAccountConnectionProps"');
    }
    function cfnEnvironmentAccountConnectionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEnvironmentAccountConnectionPropsValidator(properties).assertSuccess(), { CodebuildRoleArn: cdk.stringToCloudFormation(properties.codebuildRoleArn), ComponentRoleArn: cdk.stringToCloudFormation(properties.componentRoleArn), EnvironmentAccountId: cdk.stringToCloudFormation(properties.environmentAccountId), EnvironmentName: cdk.stringToCloudFormation(properties.environmentName), ManagementAccountId: cdk.stringToCloudFormation(properties.managementAccountId), RoleArn: cdk.stringToCloudFormation(properties.roleArn), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnEnvironmentAccountConnectionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("codebuildRoleArn", "CodebuildRoleArn", properties.CodebuildRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.CodebuildRoleArn) : void 0), ret.addPropertyResult("componentRoleArn", "ComponentRoleArn", properties.ComponentRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.ComponentRoleArn) : void 0), ret.addPropertyResult("environmentAccountId", "EnvironmentAccountId", properties.EnvironmentAccountId != null ? cfn_parse.FromCloudFormation.getString(properties.EnvironmentAccountId) : void 0), ret.addPropertyResult("environmentName", "EnvironmentName", properties.EnvironmentName != null ? cfn_parse.FromCloudFormation.getString(properties.EnvironmentName) : void 0), ret.addPropertyResult("managementAccountId", "ManagementAccountId", properties.ManagementAccountId != null ? cfn_parse.FromCloudFormation.getString(properties.ManagementAccountId) : void 0), ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEnvironmentAccountConnection = class _CfnEnvironmentAccountConnection extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEnvironmentAccountConnectionPropsFromCloudFormation(resourceProperties), ret = new _CfnEnvironmentAccountConnection(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnEnvironmentAccountConnection.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_proton_CfnEnvironmentAccountConnectionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEnvironmentAccountConnection), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.codebuildRoleArn = props.codebuildRoleArn, this.componentRoleArn = props.componentRoleArn, this.environmentAccountId = props.environmentAccountId, this.environmentName = props.environmentName, this.managementAccountId = props.managementAccountId, this.roleArn = props.roleArn, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Proton::EnvironmentAccountConnection", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEnvironmentAccountConnection.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { codebuildRoleArn: this.codebuildRoleArn, componentRoleArn: this.componentRoleArn, environmentAccountId: this.environmentAccountId, environmentName: this.environmentName, managementAccountId: this.managementAccountId, roleArn: this.roleArn, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnEnvironmentAccountConnectionPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnEnvironmentAccountConnection[_a] = { fqn: "aws-cdk-lib.aws_proton.CfnEnvironmentAccountConnection", version: "2.80.0" }, CfnEnvironmentAccountConnection.CFN_RESOURCE_TYPE_NAME = "AWS::Proton::EnvironmentAccountConnection", exports2.CfnEnvironmentAccountConnection = CfnEnvironmentAccountConnection;
    function CfnEnvironmentTemplatePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("displayName", cdk.validateString)(properties.displayName)), errors.collect(cdk.propertyValidator("encryptionKey", cdk.validateString)(properties.encryptionKey)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("provisioning", cdk.validateString)(properties.provisioning)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnEnvironmentTemplateProps"');
    }
    function cfnEnvironmentTemplatePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEnvironmentTemplatePropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), DisplayName: cdk.stringToCloudFormation(properties.displayName), EncryptionKey: cdk.stringToCloudFormation(properties.encryptionKey), Name: cdk.stringToCloudFormation(properties.name), Provisioning: cdk.stringToCloudFormation(properties.provisioning), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnEnvironmentTemplatePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("displayName", "DisplayName", properties.DisplayName != null ? cfn_parse.FromCloudFormation.getString(properties.DisplayName) : void 0), ret.addPropertyResult("encryptionKey", "EncryptionKey", properties.EncryptionKey != null ? cfn_parse.FromCloudFormation.getString(properties.EncryptionKey) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("provisioning", "Provisioning", properties.Provisioning != null ? cfn_parse.FromCloudFormation.getString(properties.Provisioning) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEnvironmentTemplate = class _CfnEnvironmentTemplate extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEnvironmentTemplatePropsFromCloudFormation(resourceProperties), ret = new _CfnEnvironmentTemplate(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnEnvironmentTemplate.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_proton_CfnEnvironmentTemplateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEnvironmentTemplate), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.description = props.description, this.displayName = props.displayName, this.encryptionKey = props.encryptionKey, this.name = props.name, this.provisioning = props.provisioning, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Proton::EnvironmentTemplate", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEnvironmentTemplate.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, displayName: this.displayName, encryptionKey: this.encryptionKey, name: this.name, provisioning: this.provisioning, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnEnvironmentTemplatePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnEnvironmentTemplate[_b] = { fqn: "aws-cdk-lib.aws_proton.CfnEnvironmentTemplate", version: "2.80.0" }, CfnEnvironmentTemplate.CFN_RESOURCE_TYPE_NAME = "AWS::Proton::EnvironmentTemplate", exports2.CfnEnvironmentTemplate = CfnEnvironmentTemplate;
    function CfnServiceTemplatePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("displayName", cdk.validateString)(properties.displayName)), errors.collect(cdk.propertyValidator("encryptionKey", cdk.validateString)(properties.encryptionKey)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("pipelineProvisioning", cdk.validateString)(properties.pipelineProvisioning)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnServiceTemplateProps"');
    }
    function cfnServiceTemplatePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnServiceTemplatePropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), DisplayName: cdk.stringToCloudFormation(properties.displayName), EncryptionKey: cdk.stringToCloudFormation(properties.encryptionKey), Name: cdk.stringToCloudFormation(properties.name), PipelineProvisioning: cdk.stringToCloudFormation(properties.pipelineProvisioning), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnServiceTemplatePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("displayName", "DisplayName", properties.DisplayName != null ? cfn_parse.FromCloudFormation.getString(properties.DisplayName) : void 0), ret.addPropertyResult("encryptionKey", "EncryptionKey", properties.EncryptionKey != null ? cfn_parse.FromCloudFormation.getString(properties.EncryptionKey) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("pipelineProvisioning", "PipelineProvisioning", properties.PipelineProvisioning != null ? cfn_parse.FromCloudFormation.getString(properties.PipelineProvisioning) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnServiceTemplate = class _CfnServiceTemplate extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnServiceTemplatePropsFromCloudFormation(resourceProperties), ret = new _CfnServiceTemplate(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnServiceTemplate.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_proton_CfnServiceTemplateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnServiceTemplate), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.description = props.description, this.displayName = props.displayName, this.encryptionKey = props.encryptionKey, this.name = props.name, this.pipelineProvisioning = props.pipelineProvisioning, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Proton::ServiceTemplate", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnServiceTemplate.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, displayName: this.displayName, encryptionKey: this.encryptionKey, name: this.name, pipelineProvisioning: this.pipelineProvisioning, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnServiceTemplatePropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnServiceTemplate[_c] = { fqn: "aws-cdk-lib.aws_proton.CfnServiceTemplate", version: "2.80.0" }, CfnServiceTemplate.CFN_RESOURCE_TYPE_NAME = "AWS::Proton::ServiceTemplate", exports2.CfnServiceTemplate = CfnServiceTemplate;
  }
});

// node_modules/aws-cdk-lib/aws-proton/lib/index.js
var require_lib212 = __commonJS({
  "node_modules/aws-cdk-lib/aws-proton/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_proton_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-proton/index.js
var require_aws_proton = __commonJS({
  "node_modules/aws-cdk-lib/aws-proton/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib212(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-qldb/lib/qldb.generated.js
var require_qldb_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-qldb/lib/qldb.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnStream = exports2.CfnLedger = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnLedgerPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deletionProtection", cdk.validateBoolean)(properties.deletionProtection)), errors.collect(cdk.propertyValidator("kmsKey", cdk.validateString)(properties.kmsKey)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("permissionsMode", cdk.requiredValidator)(properties.permissionsMode)), errors.collect(cdk.propertyValidator("permissionsMode", cdk.validateString)(properties.permissionsMode)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnLedgerProps"');
    }
    function cfnLedgerPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLedgerPropsValidator(properties).assertSuccess(), { PermissionsMode: cdk.stringToCloudFormation(properties.permissionsMode), DeletionProtection: cdk.booleanToCloudFormation(properties.deletionProtection), KmsKey: cdk.stringToCloudFormation(properties.kmsKey), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnLedgerPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("permissionsMode", "PermissionsMode", cfn_parse.FromCloudFormation.getString(properties.PermissionsMode)), ret.addPropertyResult("deletionProtection", "DeletionProtection", properties.DeletionProtection != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeletionProtection) : void 0), ret.addPropertyResult("kmsKey", "KmsKey", properties.KmsKey != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKey) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLedger = class _CfnLedger extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLedgerPropsFromCloudFormation(resourceProperties), ret = new _CfnLedger(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLedger.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_qldb_CfnLedgerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLedger), error;
        }
        cdk.requireProperty(props, "permissionsMode", this), this.permissionsMode = props.permissionsMode, this.deletionProtection = props.deletionProtection, this.kmsKey = props.kmsKey, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::QLDB::Ledger", props.tags, { tagPropertyName: "tags" }), this.node.scope && cdk.Resource.isResource(this.node.scope) && this.node.addValidation({ validate: () => this.cfnOptions.deletionPolicy === void 0 ? ["'AWS::QLDB::Ledger' is a stateful resource type, and you must specify a Removal Policy for it. Call 'resource.applyRemovalPolicy()'."] : [] });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLedger.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { permissionsMode: this.permissionsMode, deletionProtection: this.deletionProtection, kmsKey: this.kmsKey, name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnLedgerPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnLedger[_a] = { fqn: "aws-cdk-lib.aws_qldb.CfnLedger", version: "2.80.0" }, CfnLedger.CFN_RESOURCE_TYPE_NAME = "AWS::QLDB::Ledger", exports2.CfnLedger = CfnLedger;
    function CfnStreamPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("exclusiveEndTime", cdk.validateString)(properties.exclusiveEndTime)), errors.collect(cdk.propertyValidator("inclusiveStartTime", cdk.requiredValidator)(properties.inclusiveStartTime)), errors.collect(cdk.propertyValidator("inclusiveStartTime", cdk.validateString)(properties.inclusiveStartTime)), errors.collect(cdk.propertyValidator("kinesisConfiguration", cdk.requiredValidator)(properties.kinesisConfiguration)), errors.collect(cdk.propertyValidator("kinesisConfiguration", CfnStream_KinesisConfigurationPropertyValidator)(properties.kinesisConfiguration)), errors.collect(cdk.propertyValidator("ledgerName", cdk.requiredValidator)(properties.ledgerName)), errors.collect(cdk.propertyValidator("ledgerName", cdk.validateString)(properties.ledgerName)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("streamName", cdk.requiredValidator)(properties.streamName)), errors.collect(cdk.propertyValidator("streamName", cdk.validateString)(properties.streamName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnStreamProps"');
    }
    function cfnStreamPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStreamPropsValidator(properties).assertSuccess(), { InclusiveStartTime: cdk.stringToCloudFormation(properties.inclusiveStartTime), KinesisConfiguration: cfnStreamKinesisConfigurationPropertyToCloudFormation(properties.kinesisConfiguration), LedgerName: cdk.stringToCloudFormation(properties.ledgerName), RoleArn: cdk.stringToCloudFormation(properties.roleArn), StreamName: cdk.stringToCloudFormation(properties.streamName), ExclusiveEndTime: cdk.stringToCloudFormation(properties.exclusiveEndTime), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnStreamPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("inclusiveStartTime", "InclusiveStartTime", cfn_parse.FromCloudFormation.getString(properties.InclusiveStartTime)), ret.addPropertyResult("kinesisConfiguration", "KinesisConfiguration", CfnStreamKinesisConfigurationPropertyFromCloudFormation(properties.KinesisConfiguration)), ret.addPropertyResult("ledgerName", "LedgerName", cfn_parse.FromCloudFormation.getString(properties.LedgerName)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("streamName", "StreamName", cfn_parse.FromCloudFormation.getString(properties.StreamName)), ret.addPropertyResult("exclusiveEndTime", "ExclusiveEndTime", properties.ExclusiveEndTime != null ? cfn_parse.FromCloudFormation.getString(properties.ExclusiveEndTime) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnStream = class _CfnStream extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnStreamPropsFromCloudFormation(resourceProperties), ret = new _CfnStream(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnStream.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_qldb_CfnStreamProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnStream), error;
        }
        cdk.requireProperty(props, "inclusiveStartTime", this), cdk.requireProperty(props, "kinesisConfiguration", this), cdk.requireProperty(props, "ledgerName", this), cdk.requireProperty(props, "roleArn", this), cdk.requireProperty(props, "streamName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.inclusiveStartTime = props.inclusiveStartTime, this.kinesisConfiguration = props.kinesisConfiguration, this.ledgerName = props.ledgerName, this.roleArn = props.roleArn, this.streamName = props.streamName, this.exclusiveEndTime = props.exclusiveEndTime, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::QLDB::Stream", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStream.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { inclusiveStartTime: this.inclusiveStartTime, kinesisConfiguration: this.kinesisConfiguration, ledgerName: this.ledgerName, roleArn: this.roleArn, streamName: this.streamName, exclusiveEndTime: this.exclusiveEndTime, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnStreamPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnStream[_b] = { fqn: "aws-cdk-lib.aws_qldb.CfnStream", version: "2.80.0" }, CfnStream.CFN_RESOURCE_TYPE_NAME = "AWS::QLDB::Stream", exports2.CfnStream = CfnStream;
    function CfnStream_KinesisConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationEnabled", cdk.validateBoolean)(properties.aggregationEnabled)), errors.collect(cdk.propertyValidator("streamArn", cdk.validateString)(properties.streamArn)), errors.wrap('supplied properties not correct for "KinesisConfigurationProperty"');
    }
    function cfnStreamKinesisConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStream_KinesisConfigurationPropertyValidator(properties).assertSuccess(), { AggregationEnabled: cdk.booleanToCloudFormation(properties.aggregationEnabled), StreamArn: cdk.stringToCloudFormation(properties.streamArn) }) : properties;
    }
    function CfnStreamKinesisConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationEnabled", "AggregationEnabled", properties.AggregationEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AggregationEnabled) : void 0), ret.addPropertyResult("streamArn", "StreamArn", properties.StreamArn != null ? cfn_parse.FromCloudFormation.getString(properties.StreamArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-qldb/lib/index.js
var require_lib213 = __commonJS({
  "node_modules/aws-cdk-lib/aws-qldb/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_qldb_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-qldb/index.js
var require_aws_qldb = __commonJS({
  "node_modules/aws-cdk-lib/aws-qldb/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib213(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-quicksight/lib/quicksight.generated.js
var require_quicksight_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-quicksight/lib/quicksight.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnVPCConnection = exports2.CfnTheme = exports2.CfnTemplate = exports2.CfnRefreshSchedule = exports2.CfnDataSource = exports2.CfnDataSet = exports2.CfnDashboard = exports2.CfnAnalysis = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAnalysisPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("analysisId", cdk.requiredValidator)(properties.analysisId)), errors.collect(cdk.propertyValidator("analysisId", cdk.validateString)(properties.analysisId)), errors.collect(cdk.propertyValidator("awsAccountId", cdk.requiredValidator)(properties.awsAccountId)), errors.collect(cdk.propertyValidator("awsAccountId", cdk.validateString)(properties.awsAccountId)), errors.collect(cdk.propertyValidator("definition", CfnAnalysis_AnalysisDefinitionPropertyValidator)(properties.definition)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("parameters", CfnAnalysis_ParametersPropertyValidator)(properties.parameters)), errors.collect(cdk.propertyValidator("permissions", cdk.listValidator(CfnAnalysis_ResourcePermissionPropertyValidator))(properties.permissions)), errors.collect(cdk.propertyValidator("sourceEntity", CfnAnalysis_AnalysisSourceEntityPropertyValidator)(properties.sourceEntity)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("themeArn", cdk.validateString)(properties.themeArn)), errors.wrap('supplied properties not correct for "CfnAnalysisProps"');
    }
    function cfnAnalysisPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysisPropsValidator(properties).assertSuccess(), { AnalysisId: cdk.stringToCloudFormation(properties.analysisId), AwsAccountId: cdk.stringToCloudFormation(properties.awsAccountId), Name: cdk.stringToCloudFormation(properties.name), Definition: cfnAnalysisAnalysisDefinitionPropertyToCloudFormation(properties.definition), Parameters: cfnAnalysisParametersPropertyToCloudFormation(properties.parameters), Permissions: cdk.listMapper(cfnAnalysisResourcePermissionPropertyToCloudFormation)(properties.permissions), SourceEntity: cfnAnalysisAnalysisSourceEntityPropertyToCloudFormation(properties.sourceEntity), Status: cdk.stringToCloudFormation(properties.status), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), ThemeArn: cdk.stringToCloudFormation(properties.themeArn) }) : properties;
    }
    function CfnAnalysisPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("analysisId", "AnalysisId", cfn_parse.FromCloudFormation.getString(properties.AnalysisId)), ret.addPropertyResult("awsAccountId", "AwsAccountId", cfn_parse.FromCloudFormation.getString(properties.AwsAccountId)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("definition", "Definition", properties.Definition != null ? CfnAnalysisAnalysisDefinitionPropertyFromCloudFormation(properties.Definition) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? CfnAnalysisParametersPropertyFromCloudFormation(properties.Parameters) : void 0), ret.addPropertyResult("permissions", "Permissions", properties.Permissions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisResourcePermissionPropertyFromCloudFormation)(properties.Permissions) : void 0), ret.addPropertyResult("sourceEntity", "SourceEntity", properties.SourceEntity != null ? CfnAnalysisAnalysisSourceEntityPropertyFromCloudFormation(properties.SourceEntity) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("themeArn", "ThemeArn", properties.ThemeArn != null ? cfn_parse.FromCloudFormation.getString(properties.ThemeArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAnalysis = class _CfnAnalysis extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAnalysisPropsFromCloudFormation(resourceProperties), ret = new _CfnAnalysis(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAnalysis.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_quicksight_CfnAnalysisProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAnalysis), error;
        }
        cdk.requireProperty(props, "analysisId", this), cdk.requireProperty(props, "awsAccountId", this), cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreatedTime = cdk.Token.asString(this.getAtt("CreatedTime", cdk.ResolutionTypeHint.STRING)), this.attrDataSetArns = cdk.Token.asList(this.getAtt("DataSetArns", cdk.ResolutionTypeHint.STRING_LIST)), this.attrErrors = this.getAtt("Errors", cdk.ResolutionTypeHint.STRING), this.attrLastUpdatedTime = cdk.Token.asString(this.getAtt("LastUpdatedTime", cdk.ResolutionTypeHint.STRING)), this.attrSheets = this.getAtt("Sheets", cdk.ResolutionTypeHint.STRING), this.analysisId = props.analysisId, this.awsAccountId = props.awsAccountId, this.name = props.name, this.definition = props.definition, this.parameters = props.parameters, this.permissions = props.permissions, this.sourceEntity = props.sourceEntity, this.status = props.status, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::QuickSight::Analysis", props.tags, { tagPropertyName: "tags" }), this.themeArn = props.themeArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAnalysis.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { analysisId: this.analysisId, awsAccountId: this.awsAccountId, name: this.name, definition: this.definition, parameters: this.parameters, permissions: this.permissions, sourceEntity: this.sourceEntity, status: this.status, tags: this.tags.renderTags(), themeArn: this.themeArn };
      }
      renderProperties(props) {
        return cfnAnalysisPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAnalysis[_a] = { fqn: "aws-cdk-lib.aws_quicksight.CfnAnalysis", version: "2.80.0" }, CfnAnalysis.CFN_RESOURCE_TYPE_NAME = "AWS::QuickSight::Analysis", exports2.CfnAnalysis = CfnAnalysis;
    function CfnAnalysis_AggregationFunctionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoricalAggregationFunction", cdk.validateString)(properties.categoricalAggregationFunction)), errors.collect(cdk.propertyValidator("dateAggregationFunction", cdk.validateString)(properties.dateAggregationFunction)), errors.collect(cdk.propertyValidator("numericalAggregationFunction", CfnAnalysis_NumericalAggregationFunctionPropertyValidator)(properties.numericalAggregationFunction)), errors.wrap('supplied properties not correct for "AggregationFunctionProperty"');
    }
    function cfnAnalysisAggregationFunctionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_AggregationFunctionPropertyValidator(properties).assertSuccess(), { CategoricalAggregationFunction: cdk.stringToCloudFormation(properties.categoricalAggregationFunction), DateAggregationFunction: cdk.stringToCloudFormation(properties.dateAggregationFunction), NumericalAggregationFunction: cfnAnalysisNumericalAggregationFunctionPropertyToCloudFormation(properties.numericalAggregationFunction) }) : properties;
    }
    function CfnAnalysisAggregationFunctionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoricalAggregationFunction", "CategoricalAggregationFunction", properties.CategoricalAggregationFunction != null ? cfn_parse.FromCloudFormation.getString(properties.CategoricalAggregationFunction) : void 0), ret.addPropertyResult("dateAggregationFunction", "DateAggregationFunction", properties.DateAggregationFunction != null ? cfn_parse.FromCloudFormation.getString(properties.DateAggregationFunction) : void 0), ret.addPropertyResult("numericalAggregationFunction", "NumericalAggregationFunction", properties.NumericalAggregationFunction != null ? CfnAnalysisNumericalAggregationFunctionPropertyFromCloudFormation(properties.NumericalAggregationFunction) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_AggregationSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationFunction", cdk.requiredValidator)(properties.aggregationFunction)), errors.collect(cdk.propertyValidator("aggregationFunction", CfnAnalysis_AggregationFunctionPropertyValidator)(properties.aggregationFunction)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnAnalysis_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("sortDirection", cdk.requiredValidator)(properties.sortDirection)), errors.collect(cdk.propertyValidator("sortDirection", cdk.validateString)(properties.sortDirection)), errors.wrap('supplied properties not correct for "AggregationSortConfigurationProperty"');
    }
    function cfnAnalysisAggregationSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_AggregationSortConfigurationPropertyValidator(properties).assertSuccess(), { AggregationFunction: cfnAnalysisAggregationFunctionPropertyToCloudFormation(properties.aggregationFunction), Column: cfnAnalysisColumnIdentifierPropertyToCloudFormation(properties.column), SortDirection: cdk.stringToCloudFormation(properties.sortDirection) }) : properties;
    }
    function CfnAnalysisAggregationSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationFunction", "AggregationFunction", CfnAnalysisAggregationFunctionPropertyFromCloudFormation(properties.AggregationFunction)), ret.addPropertyResult("column", "Column", CfnAnalysisColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("sortDirection", "SortDirection", cfn_parse.FromCloudFormation.getString(properties.SortDirection)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_AnalysisDefaultsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultNewSheetConfiguration", cdk.requiredValidator)(properties.defaultNewSheetConfiguration)), errors.collect(cdk.propertyValidator("defaultNewSheetConfiguration", CfnAnalysis_DefaultNewSheetConfigurationPropertyValidator)(properties.defaultNewSheetConfiguration)), errors.wrap('supplied properties not correct for "AnalysisDefaultsProperty"');
    }
    function cfnAnalysisAnalysisDefaultsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_AnalysisDefaultsPropertyValidator(properties).assertSuccess(), { DefaultNewSheetConfiguration: cfnAnalysisDefaultNewSheetConfigurationPropertyToCloudFormation(properties.defaultNewSheetConfiguration) }) : properties;
    }
    function CfnAnalysisAnalysisDefaultsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultNewSheetConfiguration", "DefaultNewSheetConfiguration", CfnAnalysisDefaultNewSheetConfigurationPropertyFromCloudFormation(properties.DefaultNewSheetConfiguration)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_AnalysisDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("analysisDefaults", CfnAnalysis_AnalysisDefaultsPropertyValidator)(properties.analysisDefaults)), errors.collect(cdk.propertyValidator("calculatedFields", cdk.listValidator(CfnAnalysis_CalculatedFieldPropertyValidator))(properties.calculatedFields)), errors.collect(cdk.propertyValidator("columnConfigurations", cdk.listValidator(CfnAnalysis_ColumnConfigurationPropertyValidator))(properties.columnConfigurations)), errors.collect(cdk.propertyValidator("dataSetIdentifierDeclarations", cdk.requiredValidator)(properties.dataSetIdentifierDeclarations)), errors.collect(cdk.propertyValidator("dataSetIdentifierDeclarations", cdk.listValidator(CfnAnalysis_DataSetIdentifierDeclarationPropertyValidator))(properties.dataSetIdentifierDeclarations)), errors.collect(cdk.propertyValidator("filterGroups", cdk.listValidator(CfnAnalysis_FilterGroupPropertyValidator))(properties.filterGroups)), errors.collect(cdk.propertyValidator("parameterDeclarations", cdk.listValidator(CfnAnalysis_ParameterDeclarationPropertyValidator))(properties.parameterDeclarations)), errors.collect(cdk.propertyValidator("sheets", cdk.listValidator(CfnAnalysis_SheetDefinitionPropertyValidator))(properties.sheets)), errors.wrap('supplied properties not correct for "AnalysisDefinitionProperty"');
    }
    function cfnAnalysisAnalysisDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_AnalysisDefinitionPropertyValidator(properties).assertSuccess(), { AnalysisDefaults: cfnAnalysisAnalysisDefaultsPropertyToCloudFormation(properties.analysisDefaults), CalculatedFields: cdk.listMapper(cfnAnalysisCalculatedFieldPropertyToCloudFormation)(properties.calculatedFields), ColumnConfigurations: cdk.listMapper(cfnAnalysisColumnConfigurationPropertyToCloudFormation)(properties.columnConfigurations), DataSetIdentifierDeclarations: cdk.listMapper(cfnAnalysisDataSetIdentifierDeclarationPropertyToCloudFormation)(properties.dataSetIdentifierDeclarations), FilterGroups: cdk.listMapper(cfnAnalysisFilterGroupPropertyToCloudFormation)(properties.filterGroups), ParameterDeclarations: cdk.listMapper(cfnAnalysisParameterDeclarationPropertyToCloudFormation)(properties.parameterDeclarations), Sheets: cdk.listMapper(cfnAnalysisSheetDefinitionPropertyToCloudFormation)(properties.sheets) }) : properties;
    }
    function CfnAnalysisAnalysisDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("analysisDefaults", "AnalysisDefaults", properties.AnalysisDefaults != null ? CfnAnalysisAnalysisDefaultsPropertyFromCloudFormation(properties.AnalysisDefaults) : void 0), ret.addPropertyResult("calculatedFields", "CalculatedFields", properties.CalculatedFields != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisCalculatedFieldPropertyFromCloudFormation)(properties.CalculatedFields) : void 0), ret.addPropertyResult("columnConfigurations", "ColumnConfigurations", properties.ColumnConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisColumnConfigurationPropertyFromCloudFormation)(properties.ColumnConfigurations) : void 0), ret.addPropertyResult("dataSetIdentifierDeclarations", "DataSetIdentifierDeclarations", cfn_parse.FromCloudFormation.getArray(CfnAnalysisDataSetIdentifierDeclarationPropertyFromCloudFormation)(properties.DataSetIdentifierDeclarations)), ret.addPropertyResult("filterGroups", "FilterGroups", properties.FilterGroups != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisFilterGroupPropertyFromCloudFormation)(properties.FilterGroups) : void 0), ret.addPropertyResult("parameterDeclarations", "ParameterDeclarations", properties.ParameterDeclarations != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisParameterDeclarationPropertyFromCloudFormation)(properties.ParameterDeclarations) : void 0), ret.addPropertyResult("sheets", "Sheets", properties.Sheets != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisSheetDefinitionPropertyFromCloudFormation)(properties.Sheets) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_AnalysisSourceEntityPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sourceTemplate", CfnAnalysis_AnalysisSourceTemplatePropertyValidator)(properties.sourceTemplate)), errors.wrap('supplied properties not correct for "AnalysisSourceEntityProperty"');
    }
    function cfnAnalysisAnalysisSourceEntityPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_AnalysisSourceEntityPropertyValidator(properties).assertSuccess(), { SourceTemplate: cfnAnalysisAnalysisSourceTemplatePropertyToCloudFormation(properties.sourceTemplate) }) : properties;
    }
    function CfnAnalysisAnalysisSourceEntityPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sourceTemplate", "SourceTemplate", properties.SourceTemplate != null ? CfnAnalysisAnalysisSourceTemplatePropertyFromCloudFormation(properties.SourceTemplate) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_AnalysisSourceTemplatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.requiredValidator)(properties.arn)), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("dataSetReferences", cdk.requiredValidator)(properties.dataSetReferences)), errors.collect(cdk.propertyValidator("dataSetReferences", cdk.listValidator(CfnAnalysis_DataSetReferencePropertyValidator))(properties.dataSetReferences)), errors.wrap('supplied properties not correct for "AnalysisSourceTemplateProperty"');
    }
    function cfnAnalysisAnalysisSourceTemplatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_AnalysisSourceTemplatePropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn), DataSetReferences: cdk.listMapper(cfnAnalysisDataSetReferencePropertyToCloudFormation)(properties.dataSetReferences) }) : properties;
    }
    function CfnAnalysisAnalysisSourceTemplatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", cfn_parse.FromCloudFormation.getString(properties.Arn)), ret.addPropertyResult("dataSetReferences", "DataSetReferences", cfn_parse.FromCloudFormation.getArray(CfnAnalysisDataSetReferencePropertyFromCloudFormation)(properties.DataSetReferences)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_AnchorDateConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("anchorOption", cdk.validateString)(properties.anchorOption)), errors.collect(cdk.propertyValidator("parameterName", cdk.validateString)(properties.parameterName)), errors.wrap('supplied properties not correct for "AnchorDateConfigurationProperty"');
    }
    function cfnAnalysisAnchorDateConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_AnchorDateConfigurationPropertyValidator(properties).assertSuccess(), { AnchorOption: cdk.stringToCloudFormation(properties.anchorOption), ParameterName: cdk.stringToCloudFormation(properties.parameterName) }) : properties;
    }
    function CfnAnalysisAnchorDateConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("anchorOption", "AnchorOption", properties.AnchorOption != null ? cfn_parse.FromCloudFormation.getString(properties.AnchorOption) : void 0), ret.addPropertyResult("parameterName", "ParameterName", properties.ParameterName != null ? cfn_parse.FromCloudFormation.getString(properties.ParameterName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ArcAxisConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("range", CfnAnalysis_ArcAxisDisplayRangePropertyValidator)(properties.range)), errors.collect(cdk.propertyValidator("reserveRange", cdk.validateNumber)(properties.reserveRange)), errors.wrap('supplied properties not correct for "ArcAxisConfigurationProperty"');
    }
    function cfnAnalysisArcAxisConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ArcAxisConfigurationPropertyValidator(properties).assertSuccess(), { Range: cfnAnalysisArcAxisDisplayRangePropertyToCloudFormation(properties.range), ReserveRange: cdk.numberToCloudFormation(properties.reserveRange) }) : properties;
    }
    function CfnAnalysisArcAxisConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("range", "Range", properties.Range != null ? CfnAnalysisArcAxisDisplayRangePropertyFromCloudFormation(properties.Range) : void 0), ret.addPropertyResult("reserveRange", "ReserveRange", properties.ReserveRange != null ? cfn_parse.FromCloudFormation.getNumber(properties.ReserveRange) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ArcAxisDisplayRangePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "ArcAxisDisplayRangeProperty"');
    }
    function cfnAnalysisArcAxisDisplayRangePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ArcAxisDisplayRangePropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnAnalysisArcAxisDisplayRangePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ArcConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arcAngle", cdk.validateNumber)(properties.arcAngle)), errors.collect(cdk.propertyValidator("arcThickness", cdk.validateString)(properties.arcThickness)), errors.wrap('supplied properties not correct for "ArcConfigurationProperty"');
    }
    function cfnAnalysisArcConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ArcConfigurationPropertyValidator(properties).assertSuccess(), { ArcAngle: cdk.numberToCloudFormation(properties.arcAngle), ArcThickness: cdk.stringToCloudFormation(properties.arcThickness) }) : properties;
    }
    function CfnAnalysisArcConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arcAngle", "ArcAngle", properties.ArcAngle != null ? cfn_parse.FromCloudFormation.getNumber(properties.ArcAngle) : void 0), ret.addPropertyResult("arcThickness", "ArcThickness", properties.ArcThickness != null ? cfn_parse.FromCloudFormation.getString(properties.ArcThickness) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ArcOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arcThickness", cdk.validateString)(properties.arcThickness)), errors.wrap('supplied properties not correct for "ArcOptionsProperty"');
    }
    function cfnAnalysisArcOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ArcOptionsPropertyValidator(properties).assertSuccess(), { ArcThickness: cdk.stringToCloudFormation(properties.arcThickness) }) : properties;
    }
    function CfnAnalysisArcOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arcThickness", "ArcThickness", properties.ArcThickness != null ? cfn_parse.FromCloudFormation.getString(properties.ArcThickness) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_AxisDataOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateAxisOptions", CfnAnalysis_DateAxisOptionsPropertyValidator)(properties.dateAxisOptions)), errors.collect(cdk.propertyValidator("numericAxisOptions", CfnAnalysis_NumericAxisOptionsPropertyValidator)(properties.numericAxisOptions)), errors.wrap('supplied properties not correct for "AxisDataOptionsProperty"');
    }
    function cfnAnalysisAxisDataOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_AxisDataOptionsPropertyValidator(properties).assertSuccess(), { DateAxisOptions: cfnAnalysisDateAxisOptionsPropertyToCloudFormation(properties.dateAxisOptions), NumericAxisOptions: cfnAnalysisNumericAxisOptionsPropertyToCloudFormation(properties.numericAxisOptions) }) : properties;
    }
    function CfnAnalysisAxisDataOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateAxisOptions", "DateAxisOptions", properties.DateAxisOptions != null ? CfnAnalysisDateAxisOptionsPropertyFromCloudFormation(properties.DateAxisOptions) : void 0), ret.addPropertyResult("numericAxisOptions", "NumericAxisOptions", properties.NumericAxisOptions != null ? CfnAnalysisNumericAxisOptionsPropertyFromCloudFormation(properties.NumericAxisOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_AxisDisplayMinMaxRangePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maximum", cdk.validateNumber)(properties.maximum)), errors.collect(cdk.propertyValidator("minimum", cdk.validateNumber)(properties.minimum)), errors.wrap('supplied properties not correct for "AxisDisplayMinMaxRangeProperty"');
    }
    function cfnAnalysisAxisDisplayMinMaxRangePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_AxisDisplayMinMaxRangePropertyValidator(properties).assertSuccess(), { Maximum: cdk.numberToCloudFormation(properties.maximum), Minimum: cdk.numberToCloudFormation(properties.minimum) }) : properties;
    }
    function CfnAnalysisAxisDisplayMinMaxRangePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maximum", "Maximum", properties.Maximum != null ? cfn_parse.FromCloudFormation.getNumber(properties.Maximum) : void 0), ret.addPropertyResult("minimum", "Minimum", properties.Minimum != null ? cfn_parse.FromCloudFormation.getNumber(properties.Minimum) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_AxisDisplayOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("axisLineVisibility", cdk.validateString)(properties.axisLineVisibility)), errors.collect(cdk.propertyValidator("axisOffset", cdk.validateString)(properties.axisOffset)), errors.collect(cdk.propertyValidator("dataOptions", CfnAnalysis_AxisDataOptionsPropertyValidator)(properties.dataOptions)), errors.collect(cdk.propertyValidator("gridLineVisibility", cdk.validateString)(properties.gridLineVisibility)), errors.collect(cdk.propertyValidator("scrollbarOptions", CfnAnalysis_ScrollBarOptionsPropertyValidator)(properties.scrollbarOptions)), errors.collect(cdk.propertyValidator("tickLabelOptions", CfnAnalysis_AxisTickLabelOptionsPropertyValidator)(properties.tickLabelOptions)), errors.wrap('supplied properties not correct for "AxisDisplayOptionsProperty"');
    }
    function cfnAnalysisAxisDisplayOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_AxisDisplayOptionsPropertyValidator(properties).assertSuccess(), { AxisLineVisibility: cdk.stringToCloudFormation(properties.axisLineVisibility), AxisOffset: cdk.stringToCloudFormation(properties.axisOffset), DataOptions: cfnAnalysisAxisDataOptionsPropertyToCloudFormation(properties.dataOptions), GridLineVisibility: cdk.stringToCloudFormation(properties.gridLineVisibility), ScrollbarOptions: cfnAnalysisScrollBarOptionsPropertyToCloudFormation(properties.scrollbarOptions), TickLabelOptions: cfnAnalysisAxisTickLabelOptionsPropertyToCloudFormation(properties.tickLabelOptions) }) : properties;
    }
    function CfnAnalysisAxisDisplayOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("axisLineVisibility", "AxisLineVisibility", properties.AxisLineVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.AxisLineVisibility) : void 0), ret.addPropertyResult("axisOffset", "AxisOffset", properties.AxisOffset != null ? cfn_parse.FromCloudFormation.getString(properties.AxisOffset) : void 0), ret.addPropertyResult("dataOptions", "DataOptions", properties.DataOptions != null ? CfnAnalysisAxisDataOptionsPropertyFromCloudFormation(properties.DataOptions) : void 0), ret.addPropertyResult("gridLineVisibility", "GridLineVisibility", properties.GridLineVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.GridLineVisibility) : void 0), ret.addPropertyResult("scrollbarOptions", "ScrollbarOptions", properties.ScrollbarOptions != null ? CfnAnalysisScrollBarOptionsPropertyFromCloudFormation(properties.ScrollbarOptions) : void 0), ret.addPropertyResult("tickLabelOptions", "TickLabelOptions", properties.TickLabelOptions != null ? CfnAnalysisAxisTickLabelOptionsPropertyFromCloudFormation(properties.TickLabelOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_AxisDisplayRangePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataDriven", cdk.validateObject)(properties.dataDriven)), errors.collect(cdk.propertyValidator("minMax", CfnAnalysis_AxisDisplayMinMaxRangePropertyValidator)(properties.minMax)), errors.wrap('supplied properties not correct for "AxisDisplayRangeProperty"');
    }
    function cfnAnalysisAxisDisplayRangePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_AxisDisplayRangePropertyValidator(properties).assertSuccess(), { DataDriven: cdk.objectToCloudFormation(properties.dataDriven), MinMax: cfnAnalysisAxisDisplayMinMaxRangePropertyToCloudFormation(properties.minMax) }) : properties;
    }
    function CfnAnalysisAxisDisplayRangePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataDriven", "DataDriven", properties.DataDriven != null ? cfn_parse.FromCloudFormation.getAny(properties.DataDriven) : void 0), ret.addPropertyResult("minMax", "MinMax", properties.MinMax != null ? CfnAnalysisAxisDisplayMinMaxRangePropertyFromCloudFormation(properties.MinMax) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_AxisLabelOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applyTo", CfnAnalysis_AxisLabelReferenceOptionsPropertyValidator)(properties.applyTo)), errors.collect(cdk.propertyValidator("customLabel", cdk.validateString)(properties.customLabel)), errors.collect(cdk.propertyValidator("fontConfiguration", CfnAnalysis_FontConfigurationPropertyValidator)(properties.fontConfiguration)), errors.wrap('supplied properties not correct for "AxisLabelOptionsProperty"');
    }
    function cfnAnalysisAxisLabelOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_AxisLabelOptionsPropertyValidator(properties).assertSuccess(), { ApplyTo: cfnAnalysisAxisLabelReferenceOptionsPropertyToCloudFormation(properties.applyTo), CustomLabel: cdk.stringToCloudFormation(properties.customLabel), FontConfiguration: cfnAnalysisFontConfigurationPropertyToCloudFormation(properties.fontConfiguration) }) : properties;
    }
    function CfnAnalysisAxisLabelOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applyTo", "ApplyTo", properties.ApplyTo != null ? CfnAnalysisAxisLabelReferenceOptionsPropertyFromCloudFormation(properties.ApplyTo) : void 0), ret.addPropertyResult("customLabel", "CustomLabel", properties.CustomLabel != null ? cfn_parse.FromCloudFormation.getString(properties.CustomLabel) : void 0), ret.addPropertyResult("fontConfiguration", "FontConfiguration", properties.FontConfiguration != null ? CfnAnalysisFontConfigurationPropertyFromCloudFormation(properties.FontConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_AxisLabelReferenceOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnAnalysis_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.wrap('supplied properties not correct for "AxisLabelReferenceOptionsProperty"');
    }
    function cfnAnalysisAxisLabelReferenceOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_AxisLabelReferenceOptionsPropertyValidator(properties).assertSuccess(), { Column: cfnAnalysisColumnIdentifierPropertyToCloudFormation(properties.column), FieldId: cdk.stringToCloudFormation(properties.fieldId) }) : properties;
    }
    function CfnAnalysisAxisLabelReferenceOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", CfnAnalysisColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_AxisLinearScalePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("stepCount", cdk.validateNumber)(properties.stepCount)), errors.collect(cdk.propertyValidator("stepSize", cdk.validateNumber)(properties.stepSize)), errors.wrap('supplied properties not correct for "AxisLinearScaleProperty"');
    }
    function cfnAnalysisAxisLinearScalePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_AxisLinearScalePropertyValidator(properties).assertSuccess(), { StepCount: cdk.numberToCloudFormation(properties.stepCount), StepSize: cdk.numberToCloudFormation(properties.stepSize) }) : properties;
    }
    function CfnAnalysisAxisLinearScalePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("stepCount", "StepCount", properties.StepCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.StepCount) : void 0), ret.addPropertyResult("stepSize", "StepSize", properties.StepSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.StepSize) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_AxisLogarithmicScalePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("base", cdk.validateNumber)(properties.base)), errors.wrap('supplied properties not correct for "AxisLogarithmicScaleProperty"');
    }
    function cfnAnalysisAxisLogarithmicScalePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_AxisLogarithmicScalePropertyValidator(properties).assertSuccess(), { Base: cdk.numberToCloudFormation(properties.base) }) : properties;
    }
    function CfnAnalysisAxisLogarithmicScalePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("base", "Base", properties.Base != null ? cfn_parse.FromCloudFormation.getNumber(properties.Base) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_AxisScalePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("linear", CfnAnalysis_AxisLinearScalePropertyValidator)(properties.linear)), errors.collect(cdk.propertyValidator("logarithmic", CfnAnalysis_AxisLogarithmicScalePropertyValidator)(properties.logarithmic)), errors.wrap('supplied properties not correct for "AxisScaleProperty"');
    }
    function cfnAnalysisAxisScalePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_AxisScalePropertyValidator(properties).assertSuccess(), { Linear: cfnAnalysisAxisLinearScalePropertyToCloudFormation(properties.linear), Logarithmic: cfnAnalysisAxisLogarithmicScalePropertyToCloudFormation(properties.logarithmic) }) : properties;
    }
    function CfnAnalysisAxisScalePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("linear", "Linear", properties.Linear != null ? CfnAnalysisAxisLinearScalePropertyFromCloudFormation(properties.Linear) : void 0), ret.addPropertyResult("logarithmic", "Logarithmic", properties.Logarithmic != null ? CfnAnalysisAxisLogarithmicScalePropertyFromCloudFormation(properties.Logarithmic) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_AxisTickLabelOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("labelOptions", CfnAnalysis_LabelOptionsPropertyValidator)(properties.labelOptions)), errors.collect(cdk.propertyValidator("rotationAngle", cdk.validateNumber)(properties.rotationAngle)), errors.wrap('supplied properties not correct for "AxisTickLabelOptionsProperty"');
    }
    function cfnAnalysisAxisTickLabelOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_AxisTickLabelOptionsPropertyValidator(properties).assertSuccess(), { LabelOptions: cfnAnalysisLabelOptionsPropertyToCloudFormation(properties.labelOptions), RotationAngle: cdk.numberToCloudFormation(properties.rotationAngle) }) : properties;
    }
    function CfnAnalysisAxisTickLabelOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("labelOptions", "LabelOptions", properties.LabelOptions != null ? CfnAnalysisLabelOptionsPropertyFromCloudFormation(properties.LabelOptions) : void 0), ret.addPropertyResult("rotationAngle", "RotationAngle", properties.RotationAngle != null ? cfn_parse.FromCloudFormation.getNumber(properties.RotationAngle) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_BarChartAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("category", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.category)), errors.collect(cdk.propertyValidator("colors", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.colors)), errors.collect(cdk.propertyValidator("smallMultiples", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.smallMultiples)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnAnalysis_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "BarChartAggregatedFieldWellsProperty"');
    }
    function cfnAnalysisBarChartAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_BarChartAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Category: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.category), Colors: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.colors), SmallMultiples: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.smallMultiples), Values: cdk.listMapper(cfnAnalysisMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnAnalysisBarChartAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("category", "Category", properties.Category != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.Category) : void 0), ret.addPropertyResult("colors", "Colors", properties.Colors != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.Colors) : void 0), ret.addPropertyResult("smallMultiples", "SmallMultiples", properties.SmallMultiples != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.SmallMultiples) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_BarChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("barsArrangement", cdk.validateString)(properties.barsArrangement)), errors.collect(cdk.propertyValidator("categoryAxis", CfnAnalysis_AxisDisplayOptionsPropertyValidator)(properties.categoryAxis)), errors.collect(cdk.propertyValidator("categoryLabelOptions", CfnAnalysis_ChartAxisLabelOptionsPropertyValidator)(properties.categoryLabelOptions)), errors.collect(cdk.propertyValidator("colorLabelOptions", CfnAnalysis_ChartAxisLabelOptionsPropertyValidator)(properties.colorLabelOptions)), errors.collect(cdk.propertyValidator("contributionAnalysisDefaults", cdk.listValidator(CfnAnalysis_ContributionAnalysisDefaultPropertyValidator))(properties.contributionAnalysisDefaults)), errors.collect(cdk.propertyValidator("dataLabels", CfnAnalysis_DataLabelOptionsPropertyValidator)(properties.dataLabels)), errors.collect(cdk.propertyValidator("fieldWells", CfnAnalysis_BarChartFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("legend", CfnAnalysis_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("orientation", cdk.validateString)(properties.orientation)), errors.collect(cdk.propertyValidator("referenceLines", cdk.listValidator(CfnAnalysis_ReferenceLinePropertyValidator))(properties.referenceLines)), errors.collect(cdk.propertyValidator("smallMultiplesOptions", CfnAnalysis_SmallMultiplesOptionsPropertyValidator)(properties.smallMultiplesOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnAnalysis_BarChartSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tooltip", CfnAnalysis_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.collect(cdk.propertyValidator("valueAxis", CfnAnalysis_AxisDisplayOptionsPropertyValidator)(properties.valueAxis)), errors.collect(cdk.propertyValidator("valueLabelOptions", CfnAnalysis_ChartAxisLabelOptionsPropertyValidator)(properties.valueLabelOptions)), errors.collect(cdk.propertyValidator("visualPalette", CfnAnalysis_VisualPalettePropertyValidator)(properties.visualPalette)), errors.wrap('supplied properties not correct for "BarChartConfigurationProperty"');
    }
    function cfnAnalysisBarChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_BarChartConfigurationPropertyValidator(properties).assertSuccess(), { BarsArrangement: cdk.stringToCloudFormation(properties.barsArrangement), CategoryAxis: cfnAnalysisAxisDisplayOptionsPropertyToCloudFormation(properties.categoryAxis), CategoryLabelOptions: cfnAnalysisChartAxisLabelOptionsPropertyToCloudFormation(properties.categoryLabelOptions), ColorLabelOptions: cfnAnalysisChartAxisLabelOptionsPropertyToCloudFormation(properties.colorLabelOptions), ContributionAnalysisDefaults: cdk.listMapper(cfnAnalysisContributionAnalysisDefaultPropertyToCloudFormation)(properties.contributionAnalysisDefaults), DataLabels: cfnAnalysisDataLabelOptionsPropertyToCloudFormation(properties.dataLabels), FieldWells: cfnAnalysisBarChartFieldWellsPropertyToCloudFormation(properties.fieldWells), Legend: cfnAnalysisLegendOptionsPropertyToCloudFormation(properties.legend), Orientation: cdk.stringToCloudFormation(properties.orientation), ReferenceLines: cdk.listMapper(cfnAnalysisReferenceLinePropertyToCloudFormation)(properties.referenceLines), SmallMultiplesOptions: cfnAnalysisSmallMultiplesOptionsPropertyToCloudFormation(properties.smallMultiplesOptions), SortConfiguration: cfnAnalysisBarChartSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), Tooltip: cfnAnalysisTooltipOptionsPropertyToCloudFormation(properties.tooltip), ValueAxis: cfnAnalysisAxisDisplayOptionsPropertyToCloudFormation(properties.valueAxis), ValueLabelOptions: cfnAnalysisChartAxisLabelOptionsPropertyToCloudFormation(properties.valueLabelOptions), VisualPalette: cfnAnalysisVisualPalettePropertyToCloudFormation(properties.visualPalette) }) : properties;
    }
    function CfnAnalysisBarChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("barsArrangement", "BarsArrangement", properties.BarsArrangement != null ? cfn_parse.FromCloudFormation.getString(properties.BarsArrangement) : void 0), ret.addPropertyResult("categoryAxis", "CategoryAxis", properties.CategoryAxis != null ? CfnAnalysisAxisDisplayOptionsPropertyFromCloudFormation(properties.CategoryAxis) : void 0), ret.addPropertyResult("categoryLabelOptions", "CategoryLabelOptions", properties.CategoryLabelOptions != null ? CfnAnalysisChartAxisLabelOptionsPropertyFromCloudFormation(properties.CategoryLabelOptions) : void 0), ret.addPropertyResult("colorLabelOptions", "ColorLabelOptions", properties.ColorLabelOptions != null ? CfnAnalysisChartAxisLabelOptionsPropertyFromCloudFormation(properties.ColorLabelOptions) : void 0), ret.addPropertyResult("contributionAnalysisDefaults", "ContributionAnalysisDefaults", properties.ContributionAnalysisDefaults != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisContributionAnalysisDefaultPropertyFromCloudFormation)(properties.ContributionAnalysisDefaults) : void 0), ret.addPropertyResult("dataLabels", "DataLabels", properties.DataLabels != null ? CfnAnalysisDataLabelOptionsPropertyFromCloudFormation(properties.DataLabels) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnAnalysisBarChartFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnAnalysisLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("orientation", "Orientation", properties.Orientation != null ? cfn_parse.FromCloudFormation.getString(properties.Orientation) : void 0), ret.addPropertyResult("referenceLines", "ReferenceLines", properties.ReferenceLines != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisReferenceLinePropertyFromCloudFormation)(properties.ReferenceLines) : void 0), ret.addPropertyResult("smallMultiplesOptions", "SmallMultiplesOptions", properties.SmallMultiplesOptions != null ? CfnAnalysisSmallMultiplesOptionsPropertyFromCloudFormation(properties.SmallMultiplesOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnAnalysisBarChartSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnAnalysisTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addPropertyResult("valueAxis", "ValueAxis", properties.ValueAxis != null ? CfnAnalysisAxisDisplayOptionsPropertyFromCloudFormation(properties.ValueAxis) : void 0), ret.addPropertyResult("valueLabelOptions", "ValueLabelOptions", properties.ValueLabelOptions != null ? CfnAnalysisChartAxisLabelOptionsPropertyFromCloudFormation(properties.ValueLabelOptions) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnAnalysisVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_BarChartFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("barChartAggregatedFieldWells", CfnAnalysis_BarChartAggregatedFieldWellsPropertyValidator)(properties.barChartAggregatedFieldWells)), errors.wrap('supplied properties not correct for "BarChartFieldWellsProperty"');
    }
    function cfnAnalysisBarChartFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_BarChartFieldWellsPropertyValidator(properties).assertSuccess(), { BarChartAggregatedFieldWells: cfnAnalysisBarChartAggregatedFieldWellsPropertyToCloudFormation(properties.barChartAggregatedFieldWells) }) : properties;
    }
    function CfnAnalysisBarChartFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("barChartAggregatedFieldWells", "BarChartAggregatedFieldWells", properties.BarChartAggregatedFieldWells != null ? CfnAnalysisBarChartAggregatedFieldWellsPropertyFromCloudFormation(properties.BarChartAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_BarChartSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryItemsLimit", CfnAnalysis_ItemsLimitConfigurationPropertyValidator)(properties.categoryItemsLimit)), errors.collect(cdk.propertyValidator("categorySort", cdk.listValidator(CfnAnalysis_FieldSortOptionsPropertyValidator))(properties.categorySort)), errors.collect(cdk.propertyValidator("colorItemsLimit", CfnAnalysis_ItemsLimitConfigurationPropertyValidator)(properties.colorItemsLimit)), errors.collect(cdk.propertyValidator("colorSort", cdk.listValidator(CfnAnalysis_FieldSortOptionsPropertyValidator))(properties.colorSort)), errors.collect(cdk.propertyValidator("smallMultiplesLimitConfiguration", CfnAnalysis_ItemsLimitConfigurationPropertyValidator)(properties.smallMultiplesLimitConfiguration)), errors.collect(cdk.propertyValidator("smallMultiplesSort", cdk.listValidator(CfnAnalysis_FieldSortOptionsPropertyValidator))(properties.smallMultiplesSort)), errors.wrap('supplied properties not correct for "BarChartSortConfigurationProperty"');
    }
    function cfnAnalysisBarChartSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_BarChartSortConfigurationPropertyValidator(properties).assertSuccess(), { CategoryItemsLimit: cfnAnalysisItemsLimitConfigurationPropertyToCloudFormation(properties.categoryItemsLimit), CategorySort: cdk.listMapper(cfnAnalysisFieldSortOptionsPropertyToCloudFormation)(properties.categorySort), ColorItemsLimit: cfnAnalysisItemsLimitConfigurationPropertyToCloudFormation(properties.colorItemsLimit), ColorSort: cdk.listMapper(cfnAnalysisFieldSortOptionsPropertyToCloudFormation)(properties.colorSort), SmallMultiplesLimitConfiguration: cfnAnalysisItemsLimitConfigurationPropertyToCloudFormation(properties.smallMultiplesLimitConfiguration), SmallMultiplesSort: cdk.listMapper(cfnAnalysisFieldSortOptionsPropertyToCloudFormation)(properties.smallMultiplesSort) }) : properties;
    }
    function CfnAnalysisBarChartSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryItemsLimit", "CategoryItemsLimit", properties.CategoryItemsLimit != null ? CfnAnalysisItemsLimitConfigurationPropertyFromCloudFormation(properties.CategoryItemsLimit) : void 0), ret.addPropertyResult("categorySort", "CategorySort", properties.CategorySort != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisFieldSortOptionsPropertyFromCloudFormation)(properties.CategorySort) : void 0), ret.addPropertyResult("colorItemsLimit", "ColorItemsLimit", properties.ColorItemsLimit != null ? CfnAnalysisItemsLimitConfigurationPropertyFromCloudFormation(properties.ColorItemsLimit) : void 0), ret.addPropertyResult("colorSort", "ColorSort", properties.ColorSort != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisFieldSortOptionsPropertyFromCloudFormation)(properties.ColorSort) : void 0), ret.addPropertyResult("smallMultiplesLimitConfiguration", "SmallMultiplesLimitConfiguration", properties.SmallMultiplesLimitConfiguration != null ? CfnAnalysisItemsLimitConfigurationPropertyFromCloudFormation(properties.SmallMultiplesLimitConfiguration) : void 0), ret.addPropertyResult("smallMultiplesSort", "SmallMultiplesSort", properties.SmallMultiplesSort != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisFieldSortOptionsPropertyFromCloudFormation)(properties.SmallMultiplesSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_BarChartVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnAnalysis_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnAnalysis_BarChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnAnalysis_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnAnalysis_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnAnalysis_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "BarChartVisualProperty"');
    }
    function cfnAnalysisBarChartVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_BarChartVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnAnalysisVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnAnalysisBarChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnAnalysisColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnAnalysisVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnAnalysisVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnAnalysisBarChartVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnAnalysisBarChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnAnalysisVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnAnalysisVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_BinCountOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "BinCountOptionsProperty"');
    }
    function cfnAnalysisBinCountOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_BinCountOptionsPropertyValidator(properties).assertSuccess(), { Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnAnalysisBinCountOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getNumber(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_BinWidthOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("binCountLimit", cdk.validateNumber)(properties.binCountLimit)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "BinWidthOptionsProperty"');
    }
    function cfnAnalysisBinWidthOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_BinWidthOptionsPropertyValidator(properties).assertSuccess(), { BinCountLimit: cdk.numberToCloudFormation(properties.binCountLimit), Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnAnalysisBinWidthOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("binCountLimit", "BinCountLimit", properties.BinCountLimit != null ? cfn_parse.FromCloudFormation.getNumber(properties.BinCountLimit) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getNumber(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_BodySectionConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("content", cdk.requiredValidator)(properties.content)), errors.collect(cdk.propertyValidator("content", CfnAnalysis_BodySectionContentPropertyValidator)(properties.content)), errors.collect(cdk.propertyValidator("pageBreakConfiguration", CfnAnalysis_SectionPageBreakConfigurationPropertyValidator)(properties.pageBreakConfiguration)), errors.collect(cdk.propertyValidator("sectionId", cdk.requiredValidator)(properties.sectionId)), errors.collect(cdk.propertyValidator("sectionId", cdk.validateString)(properties.sectionId)), errors.collect(cdk.propertyValidator("style", CfnAnalysis_SectionStylePropertyValidator)(properties.style)), errors.wrap('supplied properties not correct for "BodySectionConfigurationProperty"');
    }
    function cfnAnalysisBodySectionConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_BodySectionConfigurationPropertyValidator(properties).assertSuccess(), { Content: cfnAnalysisBodySectionContentPropertyToCloudFormation(properties.content), PageBreakConfiguration: cfnAnalysisSectionPageBreakConfigurationPropertyToCloudFormation(properties.pageBreakConfiguration), SectionId: cdk.stringToCloudFormation(properties.sectionId), Style: cfnAnalysisSectionStylePropertyToCloudFormation(properties.style) }) : properties;
    }
    function CfnAnalysisBodySectionConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("content", "Content", CfnAnalysisBodySectionContentPropertyFromCloudFormation(properties.Content)), ret.addPropertyResult("pageBreakConfiguration", "PageBreakConfiguration", properties.PageBreakConfiguration != null ? CfnAnalysisSectionPageBreakConfigurationPropertyFromCloudFormation(properties.PageBreakConfiguration) : void 0), ret.addPropertyResult("sectionId", "SectionId", cfn_parse.FromCloudFormation.getString(properties.SectionId)), ret.addPropertyResult("style", "Style", properties.Style != null ? CfnAnalysisSectionStylePropertyFromCloudFormation(properties.Style) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_BodySectionContentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("layout", CfnAnalysis_SectionLayoutConfigurationPropertyValidator)(properties.layout)), errors.wrap('supplied properties not correct for "BodySectionContentProperty"');
    }
    function cfnAnalysisBodySectionContentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_BodySectionContentPropertyValidator(properties).assertSuccess(), { Layout: cfnAnalysisSectionLayoutConfigurationPropertyToCloudFormation(properties.layout) }) : properties;
    }
    function CfnAnalysisBodySectionContentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("layout", "Layout", properties.Layout != null ? CfnAnalysisSectionLayoutConfigurationPropertyFromCloudFormation(properties.Layout) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_BoxPlotAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groupBy", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.groupBy)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnAnalysis_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "BoxPlotAggregatedFieldWellsProperty"');
    }
    function cfnAnalysisBoxPlotAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_BoxPlotAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { GroupBy: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.groupBy), Values: cdk.listMapper(cfnAnalysisMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnAnalysisBoxPlotAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupBy", "GroupBy", properties.GroupBy != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.GroupBy) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_BoxPlotChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("boxPlotOptions", CfnAnalysis_BoxPlotOptionsPropertyValidator)(properties.boxPlotOptions)), errors.collect(cdk.propertyValidator("categoryAxis", CfnAnalysis_AxisDisplayOptionsPropertyValidator)(properties.categoryAxis)), errors.collect(cdk.propertyValidator("categoryLabelOptions", CfnAnalysis_ChartAxisLabelOptionsPropertyValidator)(properties.categoryLabelOptions)), errors.collect(cdk.propertyValidator("fieldWells", CfnAnalysis_BoxPlotFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("legend", CfnAnalysis_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("primaryYAxisDisplayOptions", CfnAnalysis_AxisDisplayOptionsPropertyValidator)(properties.primaryYAxisDisplayOptions)), errors.collect(cdk.propertyValidator("primaryYAxisLabelOptions", CfnAnalysis_ChartAxisLabelOptionsPropertyValidator)(properties.primaryYAxisLabelOptions)), errors.collect(cdk.propertyValidator("referenceLines", cdk.listValidator(CfnAnalysis_ReferenceLinePropertyValidator))(properties.referenceLines)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnAnalysis_BoxPlotSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tooltip", CfnAnalysis_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.collect(cdk.propertyValidator("visualPalette", CfnAnalysis_VisualPalettePropertyValidator)(properties.visualPalette)), errors.wrap('supplied properties not correct for "BoxPlotChartConfigurationProperty"');
    }
    function cfnAnalysisBoxPlotChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_BoxPlotChartConfigurationPropertyValidator(properties).assertSuccess(), { BoxPlotOptions: cfnAnalysisBoxPlotOptionsPropertyToCloudFormation(properties.boxPlotOptions), CategoryAxis: cfnAnalysisAxisDisplayOptionsPropertyToCloudFormation(properties.categoryAxis), CategoryLabelOptions: cfnAnalysisChartAxisLabelOptionsPropertyToCloudFormation(properties.categoryLabelOptions), FieldWells: cfnAnalysisBoxPlotFieldWellsPropertyToCloudFormation(properties.fieldWells), Legend: cfnAnalysisLegendOptionsPropertyToCloudFormation(properties.legend), PrimaryYAxisDisplayOptions: cfnAnalysisAxisDisplayOptionsPropertyToCloudFormation(properties.primaryYAxisDisplayOptions), PrimaryYAxisLabelOptions: cfnAnalysisChartAxisLabelOptionsPropertyToCloudFormation(properties.primaryYAxisLabelOptions), ReferenceLines: cdk.listMapper(cfnAnalysisReferenceLinePropertyToCloudFormation)(properties.referenceLines), SortConfiguration: cfnAnalysisBoxPlotSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), Tooltip: cfnAnalysisTooltipOptionsPropertyToCloudFormation(properties.tooltip), VisualPalette: cfnAnalysisVisualPalettePropertyToCloudFormation(properties.visualPalette) }) : properties;
    }
    function CfnAnalysisBoxPlotChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("boxPlotOptions", "BoxPlotOptions", properties.BoxPlotOptions != null ? CfnAnalysisBoxPlotOptionsPropertyFromCloudFormation(properties.BoxPlotOptions) : void 0), ret.addPropertyResult("categoryAxis", "CategoryAxis", properties.CategoryAxis != null ? CfnAnalysisAxisDisplayOptionsPropertyFromCloudFormation(properties.CategoryAxis) : void 0), ret.addPropertyResult("categoryLabelOptions", "CategoryLabelOptions", properties.CategoryLabelOptions != null ? CfnAnalysisChartAxisLabelOptionsPropertyFromCloudFormation(properties.CategoryLabelOptions) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnAnalysisBoxPlotFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnAnalysisLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("primaryYAxisDisplayOptions", "PrimaryYAxisDisplayOptions", properties.PrimaryYAxisDisplayOptions != null ? CfnAnalysisAxisDisplayOptionsPropertyFromCloudFormation(properties.PrimaryYAxisDisplayOptions) : void 0), ret.addPropertyResult("primaryYAxisLabelOptions", "PrimaryYAxisLabelOptions", properties.PrimaryYAxisLabelOptions != null ? CfnAnalysisChartAxisLabelOptionsPropertyFromCloudFormation(properties.PrimaryYAxisLabelOptions) : void 0), ret.addPropertyResult("referenceLines", "ReferenceLines", properties.ReferenceLines != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisReferenceLinePropertyFromCloudFormation)(properties.ReferenceLines) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnAnalysisBoxPlotSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnAnalysisTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnAnalysisVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_BoxPlotFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("boxPlotAggregatedFieldWells", CfnAnalysis_BoxPlotAggregatedFieldWellsPropertyValidator)(properties.boxPlotAggregatedFieldWells)), errors.wrap('supplied properties not correct for "BoxPlotFieldWellsProperty"');
    }
    function cfnAnalysisBoxPlotFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_BoxPlotFieldWellsPropertyValidator(properties).assertSuccess(), { BoxPlotAggregatedFieldWells: cfnAnalysisBoxPlotAggregatedFieldWellsPropertyToCloudFormation(properties.boxPlotAggregatedFieldWells) }) : properties;
    }
    function CfnAnalysisBoxPlotFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("boxPlotAggregatedFieldWells", "BoxPlotAggregatedFieldWells", properties.BoxPlotAggregatedFieldWells != null ? CfnAnalysisBoxPlotAggregatedFieldWellsPropertyFromCloudFormation(properties.BoxPlotAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_BoxPlotOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allDataPointsVisibility", cdk.validateString)(properties.allDataPointsVisibility)), errors.collect(cdk.propertyValidator("outlierVisibility", cdk.validateString)(properties.outlierVisibility)), errors.collect(cdk.propertyValidator("styleOptions", CfnAnalysis_BoxPlotStyleOptionsPropertyValidator)(properties.styleOptions)), errors.wrap('supplied properties not correct for "BoxPlotOptionsProperty"');
    }
    function cfnAnalysisBoxPlotOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_BoxPlotOptionsPropertyValidator(properties).assertSuccess(), { AllDataPointsVisibility: cdk.stringToCloudFormation(properties.allDataPointsVisibility), OutlierVisibility: cdk.stringToCloudFormation(properties.outlierVisibility), StyleOptions: cfnAnalysisBoxPlotStyleOptionsPropertyToCloudFormation(properties.styleOptions) }) : properties;
    }
    function CfnAnalysisBoxPlotOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allDataPointsVisibility", "AllDataPointsVisibility", properties.AllDataPointsVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.AllDataPointsVisibility) : void 0), ret.addPropertyResult("outlierVisibility", "OutlierVisibility", properties.OutlierVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.OutlierVisibility) : void 0), ret.addPropertyResult("styleOptions", "StyleOptions", properties.StyleOptions != null ? CfnAnalysisBoxPlotStyleOptionsPropertyFromCloudFormation(properties.StyleOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_BoxPlotSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categorySort", cdk.listValidator(CfnAnalysis_FieldSortOptionsPropertyValidator))(properties.categorySort)), errors.collect(cdk.propertyValidator("paginationConfiguration", CfnAnalysis_PaginationConfigurationPropertyValidator)(properties.paginationConfiguration)), errors.wrap('supplied properties not correct for "BoxPlotSortConfigurationProperty"');
    }
    function cfnAnalysisBoxPlotSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_BoxPlotSortConfigurationPropertyValidator(properties).assertSuccess(), { CategorySort: cdk.listMapper(cfnAnalysisFieldSortOptionsPropertyToCloudFormation)(properties.categorySort), PaginationConfiguration: cfnAnalysisPaginationConfigurationPropertyToCloudFormation(properties.paginationConfiguration) }) : properties;
    }
    function CfnAnalysisBoxPlotSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categorySort", "CategorySort", properties.CategorySort != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisFieldSortOptionsPropertyFromCloudFormation)(properties.CategorySort) : void 0), ret.addPropertyResult("paginationConfiguration", "PaginationConfiguration", properties.PaginationConfiguration != null ? CfnAnalysisPaginationConfigurationPropertyFromCloudFormation(properties.PaginationConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_BoxPlotStyleOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fillStyle", cdk.validateString)(properties.fillStyle)), errors.wrap('supplied properties not correct for "BoxPlotStyleOptionsProperty"');
    }
    function cfnAnalysisBoxPlotStyleOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_BoxPlotStyleOptionsPropertyValidator(properties).assertSuccess(), { FillStyle: cdk.stringToCloudFormation(properties.fillStyle) }) : properties;
    }
    function CfnAnalysisBoxPlotStyleOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fillStyle", "FillStyle", properties.FillStyle != null ? cfn_parse.FromCloudFormation.getString(properties.FillStyle) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_BoxPlotVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnAnalysis_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnAnalysis_BoxPlotChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnAnalysis_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnAnalysis_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnAnalysis_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "BoxPlotVisualProperty"');
    }
    function cfnAnalysisBoxPlotVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_BoxPlotVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnAnalysisVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnAnalysisBoxPlotChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnAnalysisColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnAnalysisVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnAnalysisVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnAnalysisBoxPlotVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnAnalysisBoxPlotChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnAnalysisVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnAnalysisVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_CalculatedFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.requiredValidator)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.validateString)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "CalculatedFieldProperty"');
    }
    function cfnAnalysisCalculatedFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_CalculatedFieldPropertyValidator(properties).assertSuccess(), { DataSetIdentifier: cdk.stringToCloudFormation(properties.dataSetIdentifier), Expression: cdk.stringToCloudFormation(properties.expression), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnAnalysisCalculatedFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataSetIdentifier", "DataSetIdentifier", cfn_parse.FromCloudFormation.getString(properties.DataSetIdentifier)), ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getString(properties.Expression)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_CalculatedMeasureFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.wrap('supplied properties not correct for "CalculatedMeasureFieldProperty"');
    }
    function cfnAnalysisCalculatedMeasureFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_CalculatedMeasureFieldPropertyValidator(properties).assertSuccess(), { Expression: cdk.stringToCloudFormation(properties.expression), FieldId: cdk.stringToCloudFormation(properties.fieldId) }) : properties;
    }
    function CfnAnalysisCalculatedMeasureFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getString(properties.Expression)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_CascadingControlConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sourceControls", cdk.listValidator(CfnAnalysis_CascadingControlSourcePropertyValidator))(properties.sourceControls)), errors.wrap('supplied properties not correct for "CascadingControlConfigurationProperty"');
    }
    function cfnAnalysisCascadingControlConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_CascadingControlConfigurationPropertyValidator(properties).assertSuccess(), { SourceControls: cdk.listMapper(cfnAnalysisCascadingControlSourcePropertyToCloudFormation)(properties.sourceControls) }) : properties;
    }
    function CfnAnalysisCascadingControlConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sourceControls", "SourceControls", properties.SourceControls != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisCascadingControlSourcePropertyFromCloudFormation)(properties.SourceControls) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_CascadingControlSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnToMatch", CfnAnalysis_ColumnIdentifierPropertyValidator)(properties.columnToMatch)), errors.collect(cdk.propertyValidator("sourceSheetControlId", cdk.validateString)(properties.sourceSheetControlId)), errors.wrap('supplied properties not correct for "CascadingControlSourceProperty"');
    }
    function cfnAnalysisCascadingControlSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_CascadingControlSourcePropertyValidator(properties).assertSuccess(), { ColumnToMatch: cfnAnalysisColumnIdentifierPropertyToCloudFormation(properties.columnToMatch), SourceSheetControlId: cdk.stringToCloudFormation(properties.sourceSheetControlId) }) : properties;
    }
    function CfnAnalysisCascadingControlSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columnToMatch", "ColumnToMatch", properties.ColumnToMatch != null ? CfnAnalysisColumnIdentifierPropertyFromCloudFormation(properties.ColumnToMatch) : void 0), ret.addPropertyResult("sourceSheetControlId", "SourceSheetControlId", properties.SourceSheetControlId != null ? cfn_parse.FromCloudFormation.getString(properties.SourceSheetControlId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_CategoricalDimensionFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnAnalysis_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("formatConfiguration", CfnAnalysis_StringFormatConfigurationPropertyValidator)(properties.formatConfiguration)), errors.collect(cdk.propertyValidator("hierarchyId", cdk.validateString)(properties.hierarchyId)), errors.wrap('supplied properties not correct for "CategoricalDimensionFieldProperty"');
    }
    function cfnAnalysisCategoricalDimensionFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_CategoricalDimensionFieldPropertyValidator(properties).assertSuccess(), { Column: cfnAnalysisColumnIdentifierPropertyToCloudFormation(properties.column), FieldId: cdk.stringToCloudFormation(properties.fieldId), FormatConfiguration: cfnAnalysisStringFormatConfigurationPropertyToCloudFormation(properties.formatConfiguration), HierarchyId: cdk.stringToCloudFormation(properties.hierarchyId) }) : properties;
    }
    function CfnAnalysisCategoricalDimensionFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", CfnAnalysisColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("formatConfiguration", "FormatConfiguration", properties.FormatConfiguration != null ? CfnAnalysisStringFormatConfigurationPropertyFromCloudFormation(properties.FormatConfiguration) : void 0), ret.addPropertyResult("hierarchyId", "HierarchyId", properties.HierarchyId != null ? cfn_parse.FromCloudFormation.getString(properties.HierarchyId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_CategoricalMeasureFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationFunction", cdk.validateString)(properties.aggregationFunction)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnAnalysis_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("formatConfiguration", CfnAnalysis_StringFormatConfigurationPropertyValidator)(properties.formatConfiguration)), errors.wrap('supplied properties not correct for "CategoricalMeasureFieldProperty"');
    }
    function cfnAnalysisCategoricalMeasureFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_CategoricalMeasureFieldPropertyValidator(properties).assertSuccess(), { AggregationFunction: cdk.stringToCloudFormation(properties.aggregationFunction), Column: cfnAnalysisColumnIdentifierPropertyToCloudFormation(properties.column), FieldId: cdk.stringToCloudFormation(properties.fieldId), FormatConfiguration: cfnAnalysisStringFormatConfigurationPropertyToCloudFormation(properties.formatConfiguration) }) : properties;
    }
    function CfnAnalysisCategoricalMeasureFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationFunction", "AggregationFunction", properties.AggregationFunction != null ? cfn_parse.FromCloudFormation.getString(properties.AggregationFunction) : void 0), ret.addPropertyResult("column", "Column", CfnAnalysisColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("formatConfiguration", "FormatConfiguration", properties.FormatConfiguration != null ? CfnAnalysisStringFormatConfigurationPropertyFromCloudFormation(properties.FormatConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_CategoryDrillDownFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryValues", cdk.requiredValidator)(properties.categoryValues)), errors.collect(cdk.propertyValidator("categoryValues", cdk.listValidator(cdk.validateString))(properties.categoryValues)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnAnalysis_ColumnIdentifierPropertyValidator)(properties.column)), errors.wrap('supplied properties not correct for "CategoryDrillDownFilterProperty"');
    }
    function cfnAnalysisCategoryDrillDownFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_CategoryDrillDownFilterPropertyValidator(properties).assertSuccess(), { CategoryValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.categoryValues), Column: cfnAnalysisColumnIdentifierPropertyToCloudFormation(properties.column) }) : properties;
    }
    function CfnAnalysisCategoryDrillDownFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryValues", "CategoryValues", cfn_parse.FromCloudFormation.getStringArray(properties.CategoryValues)), ret.addPropertyResult("column", "Column", CfnAnalysisColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_CategoryFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnAnalysis_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("configuration", cdk.requiredValidator)(properties.configuration)), errors.collect(cdk.propertyValidator("configuration", CfnAnalysis_CategoryFilterConfigurationPropertyValidator)(properties.configuration)), errors.collect(cdk.propertyValidator("filterId", cdk.requiredValidator)(properties.filterId)), errors.collect(cdk.propertyValidator("filterId", cdk.validateString)(properties.filterId)), errors.wrap('supplied properties not correct for "CategoryFilterProperty"');
    }
    function cfnAnalysisCategoryFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_CategoryFilterPropertyValidator(properties).assertSuccess(), { Column: cfnAnalysisColumnIdentifierPropertyToCloudFormation(properties.column), Configuration: cfnAnalysisCategoryFilterConfigurationPropertyToCloudFormation(properties.configuration), FilterId: cdk.stringToCloudFormation(properties.filterId) }) : properties;
    }
    function CfnAnalysisCategoryFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", CfnAnalysisColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("configuration", "Configuration", CfnAnalysisCategoryFilterConfigurationPropertyFromCloudFormation(properties.Configuration)), ret.addPropertyResult("filterId", "FilterId", cfn_parse.FromCloudFormation.getString(properties.FilterId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_CategoryFilterConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customFilterConfiguration", CfnAnalysis_CustomFilterConfigurationPropertyValidator)(properties.customFilterConfiguration)), errors.collect(cdk.propertyValidator("customFilterListConfiguration", CfnAnalysis_CustomFilterListConfigurationPropertyValidator)(properties.customFilterListConfiguration)), errors.collect(cdk.propertyValidator("filterListConfiguration", CfnAnalysis_FilterListConfigurationPropertyValidator)(properties.filterListConfiguration)), errors.wrap('supplied properties not correct for "CategoryFilterConfigurationProperty"');
    }
    function cfnAnalysisCategoryFilterConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_CategoryFilterConfigurationPropertyValidator(properties).assertSuccess(), { CustomFilterConfiguration: cfnAnalysisCustomFilterConfigurationPropertyToCloudFormation(properties.customFilterConfiguration), CustomFilterListConfiguration: cfnAnalysisCustomFilterListConfigurationPropertyToCloudFormation(properties.customFilterListConfiguration), FilterListConfiguration: cfnAnalysisFilterListConfigurationPropertyToCloudFormation(properties.filterListConfiguration) }) : properties;
    }
    function CfnAnalysisCategoryFilterConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customFilterConfiguration", "CustomFilterConfiguration", properties.CustomFilterConfiguration != null ? CfnAnalysisCustomFilterConfigurationPropertyFromCloudFormation(properties.CustomFilterConfiguration) : void 0), ret.addPropertyResult("customFilterListConfiguration", "CustomFilterListConfiguration", properties.CustomFilterListConfiguration != null ? CfnAnalysisCustomFilterListConfigurationPropertyFromCloudFormation(properties.CustomFilterListConfiguration) : void 0), ret.addPropertyResult("filterListConfiguration", "FilterListConfiguration", properties.FilterListConfiguration != null ? CfnAnalysisFilterListConfigurationPropertyFromCloudFormation(properties.FilterListConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ChartAxisLabelOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("axisLabelOptions", cdk.listValidator(CfnAnalysis_AxisLabelOptionsPropertyValidator))(properties.axisLabelOptions)), errors.collect(cdk.propertyValidator("sortIconVisibility", cdk.validateString)(properties.sortIconVisibility)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "ChartAxisLabelOptionsProperty"');
    }
    function cfnAnalysisChartAxisLabelOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ChartAxisLabelOptionsPropertyValidator(properties).assertSuccess(), { AxisLabelOptions: cdk.listMapper(cfnAnalysisAxisLabelOptionsPropertyToCloudFormation)(properties.axisLabelOptions), SortIconVisibility: cdk.stringToCloudFormation(properties.sortIconVisibility), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnAnalysisChartAxisLabelOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("axisLabelOptions", "AxisLabelOptions", properties.AxisLabelOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisAxisLabelOptionsPropertyFromCloudFormation)(properties.AxisLabelOptions) : void 0), ret.addPropertyResult("sortIconVisibility", "SortIconVisibility", properties.SortIconVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.SortIconVisibility) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ClusterMarkerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("simpleClusterMarker", CfnAnalysis_SimpleClusterMarkerPropertyValidator)(properties.simpleClusterMarker)), errors.wrap('supplied properties not correct for "ClusterMarkerProperty"');
    }
    function cfnAnalysisClusterMarkerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ClusterMarkerPropertyValidator(properties).assertSuccess(), { SimpleClusterMarker: cfnAnalysisSimpleClusterMarkerPropertyToCloudFormation(properties.simpleClusterMarker) }) : properties;
    }
    function CfnAnalysisClusterMarkerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("simpleClusterMarker", "SimpleClusterMarker", properties.SimpleClusterMarker != null ? CfnAnalysisSimpleClusterMarkerPropertyFromCloudFormation(properties.SimpleClusterMarker) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ClusterMarkerConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clusterMarker", CfnAnalysis_ClusterMarkerPropertyValidator)(properties.clusterMarker)), errors.wrap('supplied properties not correct for "ClusterMarkerConfigurationProperty"');
    }
    function cfnAnalysisClusterMarkerConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ClusterMarkerConfigurationPropertyValidator(properties).assertSuccess(), { ClusterMarker: cfnAnalysisClusterMarkerPropertyToCloudFormation(properties.clusterMarker) }) : properties;
    }
    function CfnAnalysisClusterMarkerConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clusterMarker", "ClusterMarker", properties.ClusterMarker != null ? CfnAnalysisClusterMarkerPropertyFromCloudFormation(properties.ClusterMarker) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ColorScalePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("colorFillType", cdk.requiredValidator)(properties.colorFillType)), errors.collect(cdk.propertyValidator("colorFillType", cdk.validateString)(properties.colorFillType)), errors.collect(cdk.propertyValidator("colors", cdk.requiredValidator)(properties.colors)), errors.collect(cdk.propertyValidator("colors", cdk.listValidator(CfnAnalysis_DataColorPropertyValidator))(properties.colors)), errors.collect(cdk.propertyValidator("nullValueColor", CfnAnalysis_DataColorPropertyValidator)(properties.nullValueColor)), errors.wrap('supplied properties not correct for "ColorScaleProperty"');
    }
    function cfnAnalysisColorScalePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ColorScalePropertyValidator(properties).assertSuccess(), { ColorFillType: cdk.stringToCloudFormation(properties.colorFillType), Colors: cdk.listMapper(cfnAnalysisDataColorPropertyToCloudFormation)(properties.colors), NullValueColor: cfnAnalysisDataColorPropertyToCloudFormation(properties.nullValueColor) }) : properties;
    }
    function CfnAnalysisColorScalePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("colorFillType", "ColorFillType", cfn_parse.FromCloudFormation.getString(properties.ColorFillType)), ret.addPropertyResult("colors", "Colors", cfn_parse.FromCloudFormation.getArray(CfnAnalysisDataColorPropertyFromCloudFormation)(properties.Colors)), ret.addPropertyResult("nullValueColor", "NullValueColor", properties.NullValueColor != null ? CfnAnalysisDataColorPropertyFromCloudFormation(properties.NullValueColor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ColorsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customColors", cdk.listValidator(CfnAnalysis_CustomColorPropertyValidator))(properties.customColors)), errors.wrap('supplied properties not correct for "ColorsConfigurationProperty"');
    }
    function cfnAnalysisColorsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ColorsConfigurationPropertyValidator(properties).assertSuccess(), { CustomColors: cdk.listMapper(cfnAnalysisCustomColorPropertyToCloudFormation)(properties.customColors) }) : properties;
    }
    function CfnAnalysisColorsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customColors", "CustomColors", properties.CustomColors != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisCustomColorPropertyFromCloudFormation)(properties.CustomColors) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ColumnConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("colorsConfiguration", CfnAnalysis_ColorsConfigurationPropertyValidator)(properties.colorsConfiguration)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnAnalysis_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("formatConfiguration", CfnAnalysis_FormatConfigurationPropertyValidator)(properties.formatConfiguration)), errors.collect(cdk.propertyValidator("role", cdk.validateString)(properties.role)), errors.wrap('supplied properties not correct for "ColumnConfigurationProperty"');
    }
    function cfnAnalysisColumnConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ColumnConfigurationPropertyValidator(properties).assertSuccess(), { ColorsConfiguration: cfnAnalysisColorsConfigurationPropertyToCloudFormation(properties.colorsConfiguration), Column: cfnAnalysisColumnIdentifierPropertyToCloudFormation(properties.column), FormatConfiguration: cfnAnalysisFormatConfigurationPropertyToCloudFormation(properties.formatConfiguration), Role: cdk.stringToCloudFormation(properties.role) }) : properties;
    }
    function CfnAnalysisColumnConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("colorsConfiguration", "ColorsConfiguration", properties.ColorsConfiguration != null ? CfnAnalysisColorsConfigurationPropertyFromCloudFormation(properties.ColorsConfiguration) : void 0), ret.addPropertyResult("column", "Column", CfnAnalysisColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("formatConfiguration", "FormatConfiguration", properties.FormatConfiguration != null ? CfnAnalysisFormatConfigurationPropertyFromCloudFormation(properties.FormatConfiguration) : void 0), ret.addPropertyResult("role", "Role", properties.Role != null ? cfn_parse.FromCloudFormation.getString(properties.Role) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ColumnHierarchyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateTimeHierarchy", CfnAnalysis_DateTimeHierarchyPropertyValidator)(properties.dateTimeHierarchy)), errors.collect(cdk.propertyValidator("explicitHierarchy", CfnAnalysis_ExplicitHierarchyPropertyValidator)(properties.explicitHierarchy)), errors.collect(cdk.propertyValidator("predefinedHierarchy", CfnAnalysis_PredefinedHierarchyPropertyValidator)(properties.predefinedHierarchy)), errors.wrap('supplied properties not correct for "ColumnHierarchyProperty"');
    }
    function cfnAnalysisColumnHierarchyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ColumnHierarchyPropertyValidator(properties).assertSuccess(), { DateTimeHierarchy: cfnAnalysisDateTimeHierarchyPropertyToCloudFormation(properties.dateTimeHierarchy), ExplicitHierarchy: cfnAnalysisExplicitHierarchyPropertyToCloudFormation(properties.explicitHierarchy), PredefinedHierarchy: cfnAnalysisPredefinedHierarchyPropertyToCloudFormation(properties.predefinedHierarchy) }) : properties;
    }
    function CfnAnalysisColumnHierarchyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateTimeHierarchy", "DateTimeHierarchy", properties.DateTimeHierarchy != null ? CfnAnalysisDateTimeHierarchyPropertyFromCloudFormation(properties.DateTimeHierarchy) : void 0), ret.addPropertyResult("explicitHierarchy", "ExplicitHierarchy", properties.ExplicitHierarchy != null ? CfnAnalysisExplicitHierarchyPropertyFromCloudFormation(properties.ExplicitHierarchy) : void 0), ret.addPropertyResult("predefinedHierarchy", "PredefinedHierarchy", properties.PredefinedHierarchy != null ? CfnAnalysisPredefinedHierarchyPropertyFromCloudFormation(properties.PredefinedHierarchy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ColumnIdentifierPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnName", cdk.requiredValidator)(properties.columnName)), errors.collect(cdk.propertyValidator("columnName", cdk.validateString)(properties.columnName)), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.requiredValidator)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.validateString)(properties.dataSetIdentifier)), errors.wrap('supplied properties not correct for "ColumnIdentifierProperty"');
    }
    function cfnAnalysisColumnIdentifierPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ColumnIdentifierPropertyValidator(properties).assertSuccess(), { ColumnName: cdk.stringToCloudFormation(properties.columnName), DataSetIdentifier: cdk.stringToCloudFormation(properties.dataSetIdentifier) }) : properties;
    }
    function CfnAnalysisColumnIdentifierPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columnName", "ColumnName", cfn_parse.FromCloudFormation.getString(properties.ColumnName)), ret.addPropertyResult("dataSetIdentifier", "DataSetIdentifier", cfn_parse.FromCloudFormation.getString(properties.DataSetIdentifier)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ColumnSortPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationFunction", CfnAnalysis_AggregationFunctionPropertyValidator)(properties.aggregationFunction)), errors.collect(cdk.propertyValidator("direction", cdk.requiredValidator)(properties.direction)), errors.collect(cdk.propertyValidator("direction", cdk.validateString)(properties.direction)), errors.collect(cdk.propertyValidator("sortBy", cdk.requiredValidator)(properties.sortBy)), errors.collect(cdk.propertyValidator("sortBy", CfnAnalysis_ColumnIdentifierPropertyValidator)(properties.sortBy)), errors.wrap('supplied properties not correct for "ColumnSortProperty"');
    }
    function cfnAnalysisColumnSortPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ColumnSortPropertyValidator(properties).assertSuccess(), { AggregationFunction: cfnAnalysisAggregationFunctionPropertyToCloudFormation(properties.aggregationFunction), Direction: cdk.stringToCloudFormation(properties.direction), SortBy: cfnAnalysisColumnIdentifierPropertyToCloudFormation(properties.sortBy) }) : properties;
    }
    function CfnAnalysisColumnSortPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationFunction", "AggregationFunction", properties.AggregationFunction != null ? CfnAnalysisAggregationFunctionPropertyFromCloudFormation(properties.AggregationFunction) : void 0), ret.addPropertyResult("direction", "Direction", cfn_parse.FromCloudFormation.getString(properties.Direction)), ret.addPropertyResult("sortBy", "SortBy", CfnAnalysisColumnIdentifierPropertyFromCloudFormation(properties.SortBy)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ColumnTooltipItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregation", CfnAnalysis_AggregationFunctionPropertyValidator)(properties.aggregation)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnAnalysis_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("label", cdk.validateString)(properties.label)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "ColumnTooltipItemProperty"');
    }
    function cfnAnalysisColumnTooltipItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ColumnTooltipItemPropertyValidator(properties).assertSuccess(), { Aggregation: cfnAnalysisAggregationFunctionPropertyToCloudFormation(properties.aggregation), Column: cfnAnalysisColumnIdentifierPropertyToCloudFormation(properties.column), Label: cdk.stringToCloudFormation(properties.label), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnAnalysisColumnTooltipItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregation", "Aggregation", properties.Aggregation != null ? CfnAnalysisAggregationFunctionPropertyFromCloudFormation(properties.Aggregation) : void 0), ret.addPropertyResult("column", "Column", CfnAnalysisColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("label", "Label", properties.Label != null ? cfn_parse.FromCloudFormation.getString(properties.Label) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ComboChartAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("barValues", cdk.listValidator(CfnAnalysis_MeasureFieldPropertyValidator))(properties.barValues)), errors.collect(cdk.propertyValidator("category", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.category)), errors.collect(cdk.propertyValidator("colors", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.colors)), errors.collect(cdk.propertyValidator("lineValues", cdk.listValidator(CfnAnalysis_MeasureFieldPropertyValidator))(properties.lineValues)), errors.wrap('supplied properties not correct for "ComboChartAggregatedFieldWellsProperty"');
    }
    function cfnAnalysisComboChartAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ComboChartAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { BarValues: cdk.listMapper(cfnAnalysisMeasureFieldPropertyToCloudFormation)(properties.barValues), Category: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.category), Colors: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.colors), LineValues: cdk.listMapper(cfnAnalysisMeasureFieldPropertyToCloudFormation)(properties.lineValues) }) : properties;
    }
    function CfnAnalysisComboChartAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("barValues", "BarValues", properties.BarValues != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMeasureFieldPropertyFromCloudFormation)(properties.BarValues) : void 0), ret.addPropertyResult("category", "Category", properties.Category != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.Category) : void 0), ret.addPropertyResult("colors", "Colors", properties.Colors != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.Colors) : void 0), ret.addPropertyResult("lineValues", "LineValues", properties.LineValues != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMeasureFieldPropertyFromCloudFormation)(properties.LineValues) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ComboChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("barDataLabels", CfnAnalysis_DataLabelOptionsPropertyValidator)(properties.barDataLabels)), errors.collect(cdk.propertyValidator("barsArrangement", cdk.validateString)(properties.barsArrangement)), errors.collect(cdk.propertyValidator("categoryAxis", CfnAnalysis_AxisDisplayOptionsPropertyValidator)(properties.categoryAxis)), errors.collect(cdk.propertyValidator("categoryLabelOptions", CfnAnalysis_ChartAxisLabelOptionsPropertyValidator)(properties.categoryLabelOptions)), errors.collect(cdk.propertyValidator("colorLabelOptions", CfnAnalysis_ChartAxisLabelOptionsPropertyValidator)(properties.colorLabelOptions)), errors.collect(cdk.propertyValidator("fieldWells", CfnAnalysis_ComboChartFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("legend", CfnAnalysis_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("lineDataLabels", CfnAnalysis_DataLabelOptionsPropertyValidator)(properties.lineDataLabels)), errors.collect(cdk.propertyValidator("primaryYAxisDisplayOptions", CfnAnalysis_AxisDisplayOptionsPropertyValidator)(properties.primaryYAxisDisplayOptions)), errors.collect(cdk.propertyValidator("primaryYAxisLabelOptions", CfnAnalysis_ChartAxisLabelOptionsPropertyValidator)(properties.primaryYAxisLabelOptions)), errors.collect(cdk.propertyValidator("referenceLines", cdk.listValidator(CfnAnalysis_ReferenceLinePropertyValidator))(properties.referenceLines)), errors.collect(cdk.propertyValidator("secondaryYAxisDisplayOptions", CfnAnalysis_AxisDisplayOptionsPropertyValidator)(properties.secondaryYAxisDisplayOptions)), errors.collect(cdk.propertyValidator("secondaryYAxisLabelOptions", CfnAnalysis_ChartAxisLabelOptionsPropertyValidator)(properties.secondaryYAxisLabelOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnAnalysis_ComboChartSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tooltip", CfnAnalysis_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.collect(cdk.propertyValidator("visualPalette", CfnAnalysis_VisualPalettePropertyValidator)(properties.visualPalette)), errors.wrap('supplied properties not correct for "ComboChartConfigurationProperty"');
    }
    function cfnAnalysisComboChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ComboChartConfigurationPropertyValidator(properties).assertSuccess(), { BarDataLabels: cfnAnalysisDataLabelOptionsPropertyToCloudFormation(properties.barDataLabels), BarsArrangement: cdk.stringToCloudFormation(properties.barsArrangement), CategoryAxis: cfnAnalysisAxisDisplayOptionsPropertyToCloudFormation(properties.categoryAxis), CategoryLabelOptions: cfnAnalysisChartAxisLabelOptionsPropertyToCloudFormation(properties.categoryLabelOptions), ColorLabelOptions: cfnAnalysisChartAxisLabelOptionsPropertyToCloudFormation(properties.colorLabelOptions), FieldWells: cfnAnalysisComboChartFieldWellsPropertyToCloudFormation(properties.fieldWells), Legend: cfnAnalysisLegendOptionsPropertyToCloudFormation(properties.legend), LineDataLabels: cfnAnalysisDataLabelOptionsPropertyToCloudFormation(properties.lineDataLabels), PrimaryYAxisDisplayOptions: cfnAnalysisAxisDisplayOptionsPropertyToCloudFormation(properties.primaryYAxisDisplayOptions), PrimaryYAxisLabelOptions: cfnAnalysisChartAxisLabelOptionsPropertyToCloudFormation(properties.primaryYAxisLabelOptions), ReferenceLines: cdk.listMapper(cfnAnalysisReferenceLinePropertyToCloudFormation)(properties.referenceLines), SecondaryYAxisDisplayOptions: cfnAnalysisAxisDisplayOptionsPropertyToCloudFormation(properties.secondaryYAxisDisplayOptions), SecondaryYAxisLabelOptions: cfnAnalysisChartAxisLabelOptionsPropertyToCloudFormation(properties.secondaryYAxisLabelOptions), SortConfiguration: cfnAnalysisComboChartSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), Tooltip: cfnAnalysisTooltipOptionsPropertyToCloudFormation(properties.tooltip), VisualPalette: cfnAnalysisVisualPalettePropertyToCloudFormation(properties.visualPalette) }) : properties;
    }
    function CfnAnalysisComboChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("barDataLabels", "BarDataLabels", properties.BarDataLabels != null ? CfnAnalysisDataLabelOptionsPropertyFromCloudFormation(properties.BarDataLabels) : void 0), ret.addPropertyResult("barsArrangement", "BarsArrangement", properties.BarsArrangement != null ? cfn_parse.FromCloudFormation.getString(properties.BarsArrangement) : void 0), ret.addPropertyResult("categoryAxis", "CategoryAxis", properties.CategoryAxis != null ? CfnAnalysisAxisDisplayOptionsPropertyFromCloudFormation(properties.CategoryAxis) : void 0), ret.addPropertyResult("categoryLabelOptions", "CategoryLabelOptions", properties.CategoryLabelOptions != null ? CfnAnalysisChartAxisLabelOptionsPropertyFromCloudFormation(properties.CategoryLabelOptions) : void 0), ret.addPropertyResult("colorLabelOptions", "ColorLabelOptions", properties.ColorLabelOptions != null ? CfnAnalysisChartAxisLabelOptionsPropertyFromCloudFormation(properties.ColorLabelOptions) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnAnalysisComboChartFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnAnalysisLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("lineDataLabels", "LineDataLabels", properties.LineDataLabels != null ? CfnAnalysisDataLabelOptionsPropertyFromCloudFormation(properties.LineDataLabels) : void 0), ret.addPropertyResult("primaryYAxisDisplayOptions", "PrimaryYAxisDisplayOptions", properties.PrimaryYAxisDisplayOptions != null ? CfnAnalysisAxisDisplayOptionsPropertyFromCloudFormation(properties.PrimaryYAxisDisplayOptions) : void 0), ret.addPropertyResult("primaryYAxisLabelOptions", "PrimaryYAxisLabelOptions", properties.PrimaryYAxisLabelOptions != null ? CfnAnalysisChartAxisLabelOptionsPropertyFromCloudFormation(properties.PrimaryYAxisLabelOptions) : void 0), ret.addPropertyResult("referenceLines", "ReferenceLines", properties.ReferenceLines != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisReferenceLinePropertyFromCloudFormation)(properties.ReferenceLines) : void 0), ret.addPropertyResult("secondaryYAxisDisplayOptions", "SecondaryYAxisDisplayOptions", properties.SecondaryYAxisDisplayOptions != null ? CfnAnalysisAxisDisplayOptionsPropertyFromCloudFormation(properties.SecondaryYAxisDisplayOptions) : void 0), ret.addPropertyResult("secondaryYAxisLabelOptions", "SecondaryYAxisLabelOptions", properties.SecondaryYAxisLabelOptions != null ? CfnAnalysisChartAxisLabelOptionsPropertyFromCloudFormation(properties.SecondaryYAxisLabelOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnAnalysisComboChartSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnAnalysisTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnAnalysisVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ComboChartFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("comboChartAggregatedFieldWells", CfnAnalysis_ComboChartAggregatedFieldWellsPropertyValidator)(properties.comboChartAggregatedFieldWells)), errors.wrap('supplied properties not correct for "ComboChartFieldWellsProperty"');
    }
    function cfnAnalysisComboChartFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ComboChartFieldWellsPropertyValidator(properties).assertSuccess(), { ComboChartAggregatedFieldWells: cfnAnalysisComboChartAggregatedFieldWellsPropertyToCloudFormation(properties.comboChartAggregatedFieldWells) }) : properties;
    }
    function CfnAnalysisComboChartFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("comboChartAggregatedFieldWells", "ComboChartAggregatedFieldWells", properties.ComboChartAggregatedFieldWells != null ? CfnAnalysisComboChartAggregatedFieldWellsPropertyFromCloudFormation(properties.ComboChartAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ComboChartSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryItemsLimit", CfnAnalysis_ItemsLimitConfigurationPropertyValidator)(properties.categoryItemsLimit)), errors.collect(cdk.propertyValidator("categorySort", cdk.listValidator(CfnAnalysis_FieldSortOptionsPropertyValidator))(properties.categorySort)), errors.collect(cdk.propertyValidator("colorItemsLimit", CfnAnalysis_ItemsLimitConfigurationPropertyValidator)(properties.colorItemsLimit)), errors.collect(cdk.propertyValidator("colorSort", cdk.listValidator(CfnAnalysis_FieldSortOptionsPropertyValidator))(properties.colorSort)), errors.wrap('supplied properties not correct for "ComboChartSortConfigurationProperty"');
    }
    function cfnAnalysisComboChartSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ComboChartSortConfigurationPropertyValidator(properties).assertSuccess(), { CategoryItemsLimit: cfnAnalysisItemsLimitConfigurationPropertyToCloudFormation(properties.categoryItemsLimit), CategorySort: cdk.listMapper(cfnAnalysisFieldSortOptionsPropertyToCloudFormation)(properties.categorySort), ColorItemsLimit: cfnAnalysisItemsLimitConfigurationPropertyToCloudFormation(properties.colorItemsLimit), ColorSort: cdk.listMapper(cfnAnalysisFieldSortOptionsPropertyToCloudFormation)(properties.colorSort) }) : properties;
    }
    function CfnAnalysisComboChartSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryItemsLimit", "CategoryItemsLimit", properties.CategoryItemsLimit != null ? CfnAnalysisItemsLimitConfigurationPropertyFromCloudFormation(properties.CategoryItemsLimit) : void 0), ret.addPropertyResult("categorySort", "CategorySort", properties.CategorySort != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisFieldSortOptionsPropertyFromCloudFormation)(properties.CategorySort) : void 0), ret.addPropertyResult("colorItemsLimit", "ColorItemsLimit", properties.ColorItemsLimit != null ? CfnAnalysisItemsLimitConfigurationPropertyFromCloudFormation(properties.ColorItemsLimit) : void 0), ret.addPropertyResult("colorSort", "ColorSort", properties.ColorSort != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisFieldSortOptionsPropertyFromCloudFormation)(properties.ColorSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ComboChartVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnAnalysis_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnAnalysis_ComboChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnAnalysis_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnAnalysis_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnAnalysis_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "ComboChartVisualProperty"');
    }
    function cfnAnalysisComboChartVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ComboChartVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnAnalysisVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnAnalysisComboChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnAnalysisColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnAnalysisVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnAnalysisVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnAnalysisComboChartVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnAnalysisComboChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnAnalysisVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnAnalysisVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ComparisonConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("comparisonFormat", CfnAnalysis_ComparisonFormatConfigurationPropertyValidator)(properties.comparisonFormat)), errors.collect(cdk.propertyValidator("comparisonMethod", cdk.validateString)(properties.comparisonMethod)), errors.wrap('supplied properties not correct for "ComparisonConfigurationProperty"');
    }
    function cfnAnalysisComparisonConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ComparisonConfigurationPropertyValidator(properties).assertSuccess(), { ComparisonFormat: cfnAnalysisComparisonFormatConfigurationPropertyToCloudFormation(properties.comparisonFormat), ComparisonMethod: cdk.stringToCloudFormation(properties.comparisonMethod) }) : properties;
    }
    function CfnAnalysisComparisonConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("comparisonFormat", "ComparisonFormat", properties.ComparisonFormat != null ? CfnAnalysisComparisonFormatConfigurationPropertyFromCloudFormation(properties.ComparisonFormat) : void 0), ret.addPropertyResult("comparisonMethod", "ComparisonMethod", properties.ComparisonMethod != null ? cfn_parse.FromCloudFormation.getString(properties.ComparisonMethod) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ComparisonFormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("numberDisplayFormatConfiguration", CfnAnalysis_NumberDisplayFormatConfigurationPropertyValidator)(properties.numberDisplayFormatConfiguration)), errors.collect(cdk.propertyValidator("percentageDisplayFormatConfiguration", CfnAnalysis_PercentageDisplayFormatConfigurationPropertyValidator)(properties.percentageDisplayFormatConfiguration)), errors.wrap('supplied properties not correct for "ComparisonFormatConfigurationProperty"');
    }
    function cfnAnalysisComparisonFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ComparisonFormatConfigurationPropertyValidator(properties).assertSuccess(), { NumberDisplayFormatConfiguration: cfnAnalysisNumberDisplayFormatConfigurationPropertyToCloudFormation(properties.numberDisplayFormatConfiguration), PercentageDisplayFormatConfiguration: cfnAnalysisPercentageDisplayFormatConfigurationPropertyToCloudFormation(properties.percentageDisplayFormatConfiguration) }) : properties;
    }
    function CfnAnalysisComparisonFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("numberDisplayFormatConfiguration", "NumberDisplayFormatConfiguration", properties.NumberDisplayFormatConfiguration != null ? CfnAnalysisNumberDisplayFormatConfigurationPropertyFromCloudFormation(properties.NumberDisplayFormatConfiguration) : void 0), ret.addPropertyResult("percentageDisplayFormatConfiguration", "PercentageDisplayFormatConfiguration", properties.PercentageDisplayFormatConfiguration != null ? CfnAnalysisPercentageDisplayFormatConfigurationPropertyFromCloudFormation(properties.PercentageDisplayFormatConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("forecast", CfnAnalysis_ForecastComputationPropertyValidator)(properties.forecast)), errors.collect(cdk.propertyValidator("growthRate", CfnAnalysis_GrowthRateComputationPropertyValidator)(properties.growthRate)), errors.collect(cdk.propertyValidator("maximumMinimum", CfnAnalysis_MaximumMinimumComputationPropertyValidator)(properties.maximumMinimum)), errors.collect(cdk.propertyValidator("metricComparison", CfnAnalysis_MetricComparisonComputationPropertyValidator)(properties.metricComparison)), errors.collect(cdk.propertyValidator("periodOverPeriod", CfnAnalysis_PeriodOverPeriodComputationPropertyValidator)(properties.periodOverPeriod)), errors.collect(cdk.propertyValidator("periodToDate", CfnAnalysis_PeriodToDateComputationPropertyValidator)(properties.periodToDate)), errors.collect(cdk.propertyValidator("topBottomMovers", CfnAnalysis_TopBottomMoversComputationPropertyValidator)(properties.topBottomMovers)), errors.collect(cdk.propertyValidator("topBottomRanked", CfnAnalysis_TopBottomRankedComputationPropertyValidator)(properties.topBottomRanked)), errors.collect(cdk.propertyValidator("totalAggregation", CfnAnalysis_TotalAggregationComputationPropertyValidator)(properties.totalAggregation)), errors.collect(cdk.propertyValidator("uniqueValues", CfnAnalysis_UniqueValuesComputationPropertyValidator)(properties.uniqueValues)), errors.wrap('supplied properties not correct for "ComputationProperty"');
    }
    function cfnAnalysisComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ComputationPropertyValidator(properties).assertSuccess(), { Forecast: cfnAnalysisForecastComputationPropertyToCloudFormation(properties.forecast), GrowthRate: cfnAnalysisGrowthRateComputationPropertyToCloudFormation(properties.growthRate), MaximumMinimum: cfnAnalysisMaximumMinimumComputationPropertyToCloudFormation(properties.maximumMinimum), MetricComparison: cfnAnalysisMetricComparisonComputationPropertyToCloudFormation(properties.metricComparison), PeriodOverPeriod: cfnAnalysisPeriodOverPeriodComputationPropertyToCloudFormation(properties.periodOverPeriod), PeriodToDate: cfnAnalysisPeriodToDateComputationPropertyToCloudFormation(properties.periodToDate), TopBottomMovers: cfnAnalysisTopBottomMoversComputationPropertyToCloudFormation(properties.topBottomMovers), TopBottomRanked: cfnAnalysisTopBottomRankedComputationPropertyToCloudFormation(properties.topBottomRanked), TotalAggregation: cfnAnalysisTotalAggregationComputationPropertyToCloudFormation(properties.totalAggregation), UniqueValues: cfnAnalysisUniqueValuesComputationPropertyToCloudFormation(properties.uniqueValues) }) : properties;
    }
    function CfnAnalysisComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("forecast", "Forecast", properties.Forecast != null ? CfnAnalysisForecastComputationPropertyFromCloudFormation(properties.Forecast) : void 0), ret.addPropertyResult("growthRate", "GrowthRate", properties.GrowthRate != null ? CfnAnalysisGrowthRateComputationPropertyFromCloudFormation(properties.GrowthRate) : void 0), ret.addPropertyResult("maximumMinimum", "MaximumMinimum", properties.MaximumMinimum != null ? CfnAnalysisMaximumMinimumComputationPropertyFromCloudFormation(properties.MaximumMinimum) : void 0), ret.addPropertyResult("metricComparison", "MetricComparison", properties.MetricComparison != null ? CfnAnalysisMetricComparisonComputationPropertyFromCloudFormation(properties.MetricComparison) : void 0), ret.addPropertyResult("periodOverPeriod", "PeriodOverPeriod", properties.PeriodOverPeriod != null ? CfnAnalysisPeriodOverPeriodComputationPropertyFromCloudFormation(properties.PeriodOverPeriod) : void 0), ret.addPropertyResult("periodToDate", "PeriodToDate", properties.PeriodToDate != null ? CfnAnalysisPeriodToDateComputationPropertyFromCloudFormation(properties.PeriodToDate) : void 0), ret.addPropertyResult("topBottomMovers", "TopBottomMovers", properties.TopBottomMovers != null ? CfnAnalysisTopBottomMoversComputationPropertyFromCloudFormation(properties.TopBottomMovers) : void 0), ret.addPropertyResult("topBottomRanked", "TopBottomRanked", properties.TopBottomRanked != null ? CfnAnalysisTopBottomRankedComputationPropertyFromCloudFormation(properties.TopBottomRanked) : void 0), ret.addPropertyResult("totalAggregation", "TotalAggregation", properties.TotalAggregation != null ? CfnAnalysisTotalAggregationComputationPropertyFromCloudFormation(properties.TotalAggregation) : void 0), ret.addPropertyResult("uniqueValues", "UniqueValues", properties.UniqueValues != null ? CfnAnalysisUniqueValuesComputationPropertyFromCloudFormation(properties.UniqueValues) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ConditionalFormattingColorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("gradient", CfnAnalysis_ConditionalFormattingGradientColorPropertyValidator)(properties.gradient)), errors.collect(cdk.propertyValidator("solid", CfnAnalysis_ConditionalFormattingSolidColorPropertyValidator)(properties.solid)), errors.wrap('supplied properties not correct for "ConditionalFormattingColorProperty"');
    }
    function cfnAnalysisConditionalFormattingColorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ConditionalFormattingColorPropertyValidator(properties).assertSuccess(), { Gradient: cfnAnalysisConditionalFormattingGradientColorPropertyToCloudFormation(properties.gradient), Solid: cfnAnalysisConditionalFormattingSolidColorPropertyToCloudFormation(properties.solid) }) : properties;
    }
    function CfnAnalysisConditionalFormattingColorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("gradient", "Gradient", properties.Gradient != null ? CfnAnalysisConditionalFormattingGradientColorPropertyFromCloudFormation(properties.Gradient) : void 0), ret.addPropertyResult("solid", "Solid", properties.Solid != null ? CfnAnalysisConditionalFormattingSolidColorPropertyFromCloudFormation(properties.Solid) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ConditionalFormattingCustomIconConditionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.collect(cdk.propertyValidator("displayConfiguration", CfnAnalysis_ConditionalFormattingIconDisplayConfigurationPropertyValidator)(properties.displayConfiguration)), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.collect(cdk.propertyValidator("iconOptions", cdk.requiredValidator)(properties.iconOptions)), errors.collect(cdk.propertyValidator("iconOptions", CfnAnalysis_ConditionalFormattingCustomIconOptionsPropertyValidator)(properties.iconOptions)), errors.wrap('supplied properties not correct for "ConditionalFormattingCustomIconConditionProperty"');
    }
    function cfnAnalysisConditionalFormattingCustomIconConditionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ConditionalFormattingCustomIconConditionPropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color), DisplayConfiguration: cfnAnalysisConditionalFormattingIconDisplayConfigurationPropertyToCloudFormation(properties.displayConfiguration), Expression: cdk.stringToCloudFormation(properties.expression), IconOptions: cfnAnalysisConditionalFormattingCustomIconOptionsPropertyToCloudFormation(properties.iconOptions) }) : properties;
    }
    function CfnAnalysisConditionalFormattingCustomIconConditionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", properties.Color != null ? cfn_parse.FromCloudFormation.getString(properties.Color) : void 0), ret.addPropertyResult("displayConfiguration", "DisplayConfiguration", properties.DisplayConfiguration != null ? CfnAnalysisConditionalFormattingIconDisplayConfigurationPropertyFromCloudFormation(properties.DisplayConfiguration) : void 0), ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getString(properties.Expression)), ret.addPropertyResult("iconOptions", "IconOptions", CfnAnalysisConditionalFormattingCustomIconOptionsPropertyFromCloudFormation(properties.IconOptions)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ConditionalFormattingCustomIconOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("icon", cdk.validateString)(properties.icon)), errors.collect(cdk.propertyValidator("unicodeIcon", cdk.validateString)(properties.unicodeIcon)), errors.wrap('supplied properties not correct for "ConditionalFormattingCustomIconOptionsProperty"');
    }
    function cfnAnalysisConditionalFormattingCustomIconOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ConditionalFormattingCustomIconOptionsPropertyValidator(properties).assertSuccess(), { Icon: cdk.stringToCloudFormation(properties.icon), UnicodeIcon: cdk.stringToCloudFormation(properties.unicodeIcon) }) : properties;
    }
    function CfnAnalysisConditionalFormattingCustomIconOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("icon", "Icon", properties.Icon != null ? cfn_parse.FromCloudFormation.getString(properties.Icon) : void 0), ret.addPropertyResult("unicodeIcon", "UnicodeIcon", properties.UnicodeIcon != null ? cfn_parse.FromCloudFormation.getString(properties.UnicodeIcon) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ConditionalFormattingGradientColorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.requiredValidator)(properties.color)), errors.collect(cdk.propertyValidator("color", CfnAnalysis_GradientColorPropertyValidator)(properties.color)), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.wrap('supplied properties not correct for "ConditionalFormattingGradientColorProperty"');
    }
    function cfnAnalysisConditionalFormattingGradientColorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ConditionalFormattingGradientColorPropertyValidator(properties).assertSuccess(), { Color: cfnAnalysisGradientColorPropertyToCloudFormation(properties.color), Expression: cdk.stringToCloudFormation(properties.expression) }) : properties;
    }
    function CfnAnalysisConditionalFormattingGradientColorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", CfnAnalysisGradientColorPropertyFromCloudFormation(properties.Color)), ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getString(properties.Expression)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ConditionalFormattingIconPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customCondition", CfnAnalysis_ConditionalFormattingCustomIconConditionPropertyValidator)(properties.customCondition)), errors.collect(cdk.propertyValidator("iconSet", CfnAnalysis_ConditionalFormattingIconSetPropertyValidator)(properties.iconSet)), errors.wrap('supplied properties not correct for "ConditionalFormattingIconProperty"');
    }
    function cfnAnalysisConditionalFormattingIconPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ConditionalFormattingIconPropertyValidator(properties).assertSuccess(), { CustomCondition: cfnAnalysisConditionalFormattingCustomIconConditionPropertyToCloudFormation(properties.customCondition), IconSet: cfnAnalysisConditionalFormattingIconSetPropertyToCloudFormation(properties.iconSet) }) : properties;
    }
    function CfnAnalysisConditionalFormattingIconPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customCondition", "CustomCondition", properties.CustomCondition != null ? CfnAnalysisConditionalFormattingCustomIconConditionPropertyFromCloudFormation(properties.CustomCondition) : void 0), ret.addPropertyResult("iconSet", "IconSet", properties.IconSet != null ? CfnAnalysisConditionalFormattingIconSetPropertyFromCloudFormation(properties.IconSet) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ConditionalFormattingIconDisplayConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("iconDisplayOption", cdk.validateString)(properties.iconDisplayOption)), errors.wrap('supplied properties not correct for "ConditionalFormattingIconDisplayConfigurationProperty"');
    }
    function cfnAnalysisConditionalFormattingIconDisplayConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ConditionalFormattingIconDisplayConfigurationPropertyValidator(properties).assertSuccess(), { IconDisplayOption: cdk.stringToCloudFormation(properties.iconDisplayOption) }) : properties;
    }
    function CfnAnalysisConditionalFormattingIconDisplayConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("iconDisplayOption", "IconDisplayOption", properties.IconDisplayOption != null ? cfn_parse.FromCloudFormation.getString(properties.IconDisplayOption) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ConditionalFormattingIconSetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.collect(cdk.propertyValidator("iconSetType", cdk.validateString)(properties.iconSetType)), errors.wrap('supplied properties not correct for "ConditionalFormattingIconSetProperty"');
    }
    function cfnAnalysisConditionalFormattingIconSetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ConditionalFormattingIconSetPropertyValidator(properties).assertSuccess(), { Expression: cdk.stringToCloudFormation(properties.expression), IconSetType: cdk.stringToCloudFormation(properties.iconSetType) }) : properties;
    }
    function CfnAnalysisConditionalFormattingIconSetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getString(properties.Expression)), ret.addPropertyResult("iconSetType", "IconSetType", properties.IconSetType != null ? cfn_parse.FromCloudFormation.getString(properties.IconSetType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ConditionalFormattingSolidColorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.wrap('supplied properties not correct for "ConditionalFormattingSolidColorProperty"');
    }
    function cfnAnalysisConditionalFormattingSolidColorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ConditionalFormattingSolidColorPropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color), Expression: cdk.stringToCloudFormation(properties.expression) }) : properties;
    }
    function CfnAnalysisConditionalFormattingSolidColorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", properties.Color != null ? cfn_parse.FromCloudFormation.getString(properties.Color) : void 0), ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getString(properties.Expression)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ContributionAnalysisDefaultPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contributorDimensions", cdk.requiredValidator)(properties.contributorDimensions)), errors.collect(cdk.propertyValidator("contributorDimensions", cdk.listValidator(CfnAnalysis_ColumnIdentifierPropertyValidator))(properties.contributorDimensions)), errors.collect(cdk.propertyValidator("measureFieldId", cdk.requiredValidator)(properties.measureFieldId)), errors.collect(cdk.propertyValidator("measureFieldId", cdk.validateString)(properties.measureFieldId)), errors.wrap('supplied properties not correct for "ContributionAnalysisDefaultProperty"');
    }
    function cfnAnalysisContributionAnalysisDefaultPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ContributionAnalysisDefaultPropertyValidator(properties).assertSuccess(), { ContributorDimensions: cdk.listMapper(cfnAnalysisColumnIdentifierPropertyToCloudFormation)(properties.contributorDimensions), MeasureFieldId: cdk.stringToCloudFormation(properties.measureFieldId) }) : properties;
    }
    function CfnAnalysisContributionAnalysisDefaultPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contributorDimensions", "ContributorDimensions", cfn_parse.FromCloudFormation.getArray(CfnAnalysisColumnIdentifierPropertyFromCloudFormation)(properties.ContributorDimensions)), ret.addPropertyResult("measureFieldId", "MeasureFieldId", cfn_parse.FromCloudFormation.getString(properties.MeasureFieldId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_CurrencyDisplayFormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("decimalPlacesConfiguration", CfnAnalysis_DecimalPlacesConfigurationPropertyValidator)(properties.decimalPlacesConfiguration)), errors.collect(cdk.propertyValidator("negativeValueConfiguration", CfnAnalysis_NegativeValueConfigurationPropertyValidator)(properties.negativeValueConfiguration)), errors.collect(cdk.propertyValidator("nullValueFormatConfiguration", CfnAnalysis_NullValueFormatConfigurationPropertyValidator)(properties.nullValueFormatConfiguration)), errors.collect(cdk.propertyValidator("numberScale", cdk.validateString)(properties.numberScale)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.collect(cdk.propertyValidator("separatorConfiguration", CfnAnalysis_NumericSeparatorConfigurationPropertyValidator)(properties.separatorConfiguration)), errors.collect(cdk.propertyValidator("suffix", cdk.validateString)(properties.suffix)), errors.collect(cdk.propertyValidator("symbol", cdk.validateString)(properties.symbol)), errors.wrap('supplied properties not correct for "CurrencyDisplayFormatConfigurationProperty"');
    }
    function cfnAnalysisCurrencyDisplayFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_CurrencyDisplayFormatConfigurationPropertyValidator(properties).assertSuccess(), { DecimalPlacesConfiguration: cfnAnalysisDecimalPlacesConfigurationPropertyToCloudFormation(properties.decimalPlacesConfiguration), NegativeValueConfiguration: cfnAnalysisNegativeValueConfigurationPropertyToCloudFormation(properties.negativeValueConfiguration), NullValueFormatConfiguration: cfnAnalysisNullValueFormatConfigurationPropertyToCloudFormation(properties.nullValueFormatConfiguration), NumberScale: cdk.stringToCloudFormation(properties.numberScale), Prefix: cdk.stringToCloudFormation(properties.prefix), SeparatorConfiguration: cfnAnalysisNumericSeparatorConfigurationPropertyToCloudFormation(properties.separatorConfiguration), Suffix: cdk.stringToCloudFormation(properties.suffix), Symbol: cdk.stringToCloudFormation(properties.symbol) }) : properties;
    }
    function CfnAnalysisCurrencyDisplayFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("decimalPlacesConfiguration", "DecimalPlacesConfiguration", properties.DecimalPlacesConfiguration != null ? CfnAnalysisDecimalPlacesConfigurationPropertyFromCloudFormation(properties.DecimalPlacesConfiguration) : void 0), ret.addPropertyResult("negativeValueConfiguration", "NegativeValueConfiguration", properties.NegativeValueConfiguration != null ? CfnAnalysisNegativeValueConfigurationPropertyFromCloudFormation(properties.NegativeValueConfiguration) : void 0), ret.addPropertyResult("nullValueFormatConfiguration", "NullValueFormatConfiguration", properties.NullValueFormatConfiguration != null ? CfnAnalysisNullValueFormatConfigurationPropertyFromCloudFormation(properties.NullValueFormatConfiguration) : void 0), ret.addPropertyResult("numberScale", "NumberScale", properties.NumberScale != null ? cfn_parse.FromCloudFormation.getString(properties.NumberScale) : void 0), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addPropertyResult("separatorConfiguration", "SeparatorConfiguration", properties.SeparatorConfiguration != null ? CfnAnalysisNumericSeparatorConfigurationPropertyFromCloudFormation(properties.SeparatorConfiguration) : void 0), ret.addPropertyResult("suffix", "Suffix", properties.Suffix != null ? cfn_parse.FromCloudFormation.getString(properties.Suffix) : void 0), ret.addPropertyResult("symbol", "Symbol", properties.Symbol != null ? cfn_parse.FromCloudFormation.getString(properties.Symbol) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_CustomActionFilterOperationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("selectedFieldsConfiguration", cdk.requiredValidator)(properties.selectedFieldsConfiguration)), errors.collect(cdk.propertyValidator("selectedFieldsConfiguration", CfnAnalysis_FilterOperationSelectedFieldsConfigurationPropertyValidator)(properties.selectedFieldsConfiguration)), errors.collect(cdk.propertyValidator("targetVisualsConfiguration", cdk.requiredValidator)(properties.targetVisualsConfiguration)), errors.collect(cdk.propertyValidator("targetVisualsConfiguration", CfnAnalysis_FilterOperationTargetVisualsConfigurationPropertyValidator)(properties.targetVisualsConfiguration)), errors.wrap('supplied properties not correct for "CustomActionFilterOperationProperty"');
    }
    function cfnAnalysisCustomActionFilterOperationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_CustomActionFilterOperationPropertyValidator(properties).assertSuccess(), { SelectedFieldsConfiguration: cfnAnalysisFilterOperationSelectedFieldsConfigurationPropertyToCloudFormation(properties.selectedFieldsConfiguration), TargetVisualsConfiguration: cfnAnalysisFilterOperationTargetVisualsConfigurationPropertyToCloudFormation(properties.targetVisualsConfiguration) }) : properties;
    }
    function CfnAnalysisCustomActionFilterOperationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("selectedFieldsConfiguration", "SelectedFieldsConfiguration", CfnAnalysisFilterOperationSelectedFieldsConfigurationPropertyFromCloudFormation(properties.SelectedFieldsConfiguration)), ret.addPropertyResult("targetVisualsConfiguration", "TargetVisualsConfiguration", CfnAnalysisFilterOperationTargetVisualsConfigurationPropertyFromCloudFormation(properties.TargetVisualsConfiguration)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_CustomActionNavigationOperationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("localNavigationConfiguration", CfnAnalysis_LocalNavigationConfigurationPropertyValidator)(properties.localNavigationConfiguration)), errors.wrap('supplied properties not correct for "CustomActionNavigationOperationProperty"');
    }
    function cfnAnalysisCustomActionNavigationOperationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_CustomActionNavigationOperationPropertyValidator(properties).assertSuccess(), { LocalNavigationConfiguration: cfnAnalysisLocalNavigationConfigurationPropertyToCloudFormation(properties.localNavigationConfiguration) }) : properties;
    }
    function CfnAnalysisCustomActionNavigationOperationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("localNavigationConfiguration", "LocalNavigationConfiguration", properties.LocalNavigationConfiguration != null ? CfnAnalysisLocalNavigationConfigurationPropertyFromCloudFormation(properties.LocalNavigationConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_CustomActionSetParametersOperationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("parameterValueConfigurations", cdk.requiredValidator)(properties.parameterValueConfigurations)), errors.collect(cdk.propertyValidator("parameterValueConfigurations", cdk.listValidator(CfnAnalysis_SetParameterValueConfigurationPropertyValidator))(properties.parameterValueConfigurations)), errors.wrap('supplied properties not correct for "CustomActionSetParametersOperationProperty"');
    }
    function cfnAnalysisCustomActionSetParametersOperationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_CustomActionSetParametersOperationPropertyValidator(properties).assertSuccess(), { ParameterValueConfigurations: cdk.listMapper(cfnAnalysisSetParameterValueConfigurationPropertyToCloudFormation)(properties.parameterValueConfigurations) }) : properties;
    }
    function CfnAnalysisCustomActionSetParametersOperationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("parameterValueConfigurations", "ParameterValueConfigurations", cfn_parse.FromCloudFormation.getArray(CfnAnalysisSetParameterValueConfigurationPropertyFromCloudFormation)(properties.ParameterValueConfigurations)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_CustomActionURLOperationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("urlTarget", cdk.requiredValidator)(properties.urlTarget)), errors.collect(cdk.propertyValidator("urlTarget", cdk.validateString)(properties.urlTarget)), errors.collect(cdk.propertyValidator("urlTemplate", cdk.requiredValidator)(properties.urlTemplate)), errors.collect(cdk.propertyValidator("urlTemplate", cdk.validateString)(properties.urlTemplate)), errors.wrap('supplied properties not correct for "CustomActionURLOperationProperty"');
    }
    function cfnAnalysisCustomActionURLOperationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_CustomActionURLOperationPropertyValidator(properties).assertSuccess(), { URLTarget: cdk.stringToCloudFormation(properties.urlTarget), URLTemplate: cdk.stringToCloudFormation(properties.urlTemplate) }) : properties;
    }
    function CfnAnalysisCustomActionURLOperationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("urlTarget", "URLTarget", cfn_parse.FromCloudFormation.getString(properties.URLTarget)), ret.addPropertyResult("urlTemplate", "URLTemplate", cfn_parse.FromCloudFormation.getString(properties.URLTemplate)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_CustomColorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.requiredValidator)(properties.color)), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.collect(cdk.propertyValidator("fieldValue", cdk.validateString)(properties.fieldValue)), errors.collect(cdk.propertyValidator("specialValue", cdk.validateString)(properties.specialValue)), errors.wrap('supplied properties not correct for "CustomColorProperty"');
    }
    function cfnAnalysisCustomColorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_CustomColorPropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color), FieldValue: cdk.stringToCloudFormation(properties.fieldValue), SpecialValue: cdk.stringToCloudFormation(properties.specialValue) }) : properties;
    }
    function CfnAnalysisCustomColorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", cfn_parse.FromCloudFormation.getString(properties.Color)), ret.addPropertyResult("fieldValue", "FieldValue", properties.FieldValue != null ? cfn_parse.FromCloudFormation.getString(properties.FieldValue) : void 0), ret.addPropertyResult("specialValue", "SpecialValue", properties.SpecialValue != null ? cfn_parse.FromCloudFormation.getString(properties.SpecialValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_CustomContentConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contentType", cdk.validateString)(properties.contentType)), errors.collect(cdk.propertyValidator("contentUrl", cdk.validateString)(properties.contentUrl)), errors.collect(cdk.propertyValidator("imageScaling", cdk.validateString)(properties.imageScaling)), errors.wrap('supplied properties not correct for "CustomContentConfigurationProperty"');
    }
    function cfnAnalysisCustomContentConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_CustomContentConfigurationPropertyValidator(properties).assertSuccess(), { ContentType: cdk.stringToCloudFormation(properties.contentType), ContentUrl: cdk.stringToCloudFormation(properties.contentUrl), ImageScaling: cdk.stringToCloudFormation(properties.imageScaling) }) : properties;
    }
    function CfnAnalysisCustomContentConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contentType", "ContentType", properties.ContentType != null ? cfn_parse.FromCloudFormation.getString(properties.ContentType) : void 0), ret.addPropertyResult("contentUrl", "ContentUrl", properties.ContentUrl != null ? cfn_parse.FromCloudFormation.getString(properties.ContentUrl) : void 0), ret.addPropertyResult("imageScaling", "ImageScaling", properties.ImageScaling != null ? cfn_parse.FromCloudFormation.getString(properties.ImageScaling) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_CustomContentVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnAnalysis_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnAnalysis_CustomContentConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.requiredValidator)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.validateString)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("subtitle", CfnAnalysis_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnAnalysis_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "CustomContentVisualProperty"');
    }
    function cfnAnalysisCustomContentVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_CustomContentVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnAnalysisVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnAnalysisCustomContentConfigurationPropertyToCloudFormation(properties.chartConfiguration), DataSetIdentifier: cdk.stringToCloudFormation(properties.dataSetIdentifier), Subtitle: cfnAnalysisVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnAnalysisVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnAnalysisCustomContentVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnAnalysisCustomContentConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("dataSetIdentifier", "DataSetIdentifier", cfn_parse.FromCloudFormation.getString(properties.DataSetIdentifier)), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnAnalysisVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnAnalysisVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_CustomFilterConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryValue", cdk.validateString)(properties.categoryValue)), errors.collect(cdk.propertyValidator("matchOperator", cdk.requiredValidator)(properties.matchOperator)), errors.collect(cdk.propertyValidator("matchOperator", cdk.validateString)(properties.matchOperator)), errors.collect(cdk.propertyValidator("nullOption", cdk.requiredValidator)(properties.nullOption)), errors.collect(cdk.propertyValidator("nullOption", cdk.validateString)(properties.nullOption)), errors.collect(cdk.propertyValidator("parameterName", cdk.validateString)(properties.parameterName)), errors.collect(cdk.propertyValidator("selectAllOptions", cdk.validateString)(properties.selectAllOptions)), errors.wrap('supplied properties not correct for "CustomFilterConfigurationProperty"');
    }
    function cfnAnalysisCustomFilterConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_CustomFilterConfigurationPropertyValidator(properties).assertSuccess(), { CategoryValue: cdk.stringToCloudFormation(properties.categoryValue), MatchOperator: cdk.stringToCloudFormation(properties.matchOperator), NullOption: cdk.stringToCloudFormation(properties.nullOption), ParameterName: cdk.stringToCloudFormation(properties.parameterName), SelectAllOptions: cdk.stringToCloudFormation(properties.selectAllOptions) }) : properties;
    }
    function CfnAnalysisCustomFilterConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryValue", "CategoryValue", properties.CategoryValue != null ? cfn_parse.FromCloudFormation.getString(properties.CategoryValue) : void 0), ret.addPropertyResult("matchOperator", "MatchOperator", cfn_parse.FromCloudFormation.getString(properties.MatchOperator)), ret.addPropertyResult("nullOption", "NullOption", cfn_parse.FromCloudFormation.getString(properties.NullOption)), ret.addPropertyResult("parameterName", "ParameterName", properties.ParameterName != null ? cfn_parse.FromCloudFormation.getString(properties.ParameterName) : void 0), ret.addPropertyResult("selectAllOptions", "SelectAllOptions", properties.SelectAllOptions != null ? cfn_parse.FromCloudFormation.getString(properties.SelectAllOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_CustomFilterListConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryValues", cdk.listValidator(cdk.validateString))(properties.categoryValues)), errors.collect(cdk.propertyValidator("matchOperator", cdk.requiredValidator)(properties.matchOperator)), errors.collect(cdk.propertyValidator("matchOperator", cdk.validateString)(properties.matchOperator)), errors.collect(cdk.propertyValidator("nullOption", cdk.requiredValidator)(properties.nullOption)), errors.collect(cdk.propertyValidator("nullOption", cdk.validateString)(properties.nullOption)), errors.collect(cdk.propertyValidator("selectAllOptions", cdk.validateString)(properties.selectAllOptions)), errors.wrap('supplied properties not correct for "CustomFilterListConfigurationProperty"');
    }
    function cfnAnalysisCustomFilterListConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_CustomFilterListConfigurationPropertyValidator(properties).assertSuccess(), { CategoryValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.categoryValues), MatchOperator: cdk.stringToCloudFormation(properties.matchOperator), NullOption: cdk.stringToCloudFormation(properties.nullOption), SelectAllOptions: cdk.stringToCloudFormation(properties.selectAllOptions) }) : properties;
    }
    function CfnAnalysisCustomFilterListConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryValues", "CategoryValues", properties.CategoryValues != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CategoryValues) : void 0), ret.addPropertyResult("matchOperator", "MatchOperator", cfn_parse.FromCloudFormation.getString(properties.MatchOperator)), ret.addPropertyResult("nullOption", "NullOption", cfn_parse.FromCloudFormation.getString(properties.NullOption)), ret.addPropertyResult("selectAllOptions", "SelectAllOptions", properties.SelectAllOptions != null ? cfn_parse.FromCloudFormation.getString(properties.SelectAllOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_CustomNarrativeOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("narrative", cdk.requiredValidator)(properties.narrative)), errors.collect(cdk.propertyValidator("narrative", cdk.validateString)(properties.narrative)), errors.wrap('supplied properties not correct for "CustomNarrativeOptionsProperty"');
    }
    function cfnAnalysisCustomNarrativeOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_CustomNarrativeOptionsPropertyValidator(properties).assertSuccess(), { Narrative: cdk.stringToCloudFormation(properties.narrative) }) : properties;
    }
    function CfnAnalysisCustomNarrativeOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("narrative", "Narrative", cfn_parse.FromCloudFormation.getString(properties.Narrative)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_CustomParameterValuesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateTimeValues", cdk.listValidator(cdk.validateString))(properties.dateTimeValues)), errors.collect(cdk.propertyValidator("decimalValues", cdk.listValidator(cdk.validateNumber))(properties.decimalValues)), errors.collect(cdk.propertyValidator("integerValues", cdk.listValidator(cdk.validateNumber))(properties.integerValues)), errors.collect(cdk.propertyValidator("stringValues", cdk.listValidator(cdk.validateString))(properties.stringValues)), errors.wrap('supplied properties not correct for "CustomParameterValuesProperty"');
    }
    function cfnAnalysisCustomParameterValuesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_CustomParameterValuesPropertyValidator(properties).assertSuccess(), { DateTimeValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.dateTimeValues), DecimalValues: cdk.listMapper(cdk.numberToCloudFormation)(properties.decimalValues), IntegerValues: cdk.listMapper(cdk.numberToCloudFormation)(properties.integerValues), StringValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.stringValues) }) : properties;
    }
    function CfnAnalysisCustomParameterValuesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateTimeValues", "DateTimeValues", properties.DateTimeValues != null ? cfn_parse.FromCloudFormation.getStringArray(properties.DateTimeValues) : void 0), ret.addPropertyResult("decimalValues", "DecimalValues", properties.DecimalValues != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getNumber)(properties.DecimalValues) : void 0), ret.addPropertyResult("integerValues", "IntegerValues", properties.IntegerValues != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getNumber)(properties.IntegerValues) : void 0), ret.addPropertyResult("stringValues", "StringValues", properties.StringValues != null ? cfn_parse.FromCloudFormation.getStringArray(properties.StringValues) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_CustomValuesConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customValues", cdk.requiredValidator)(properties.customValues)), errors.collect(cdk.propertyValidator("customValues", CfnAnalysis_CustomParameterValuesPropertyValidator)(properties.customValues)), errors.collect(cdk.propertyValidator("includeNullValue", cdk.validateBoolean)(properties.includeNullValue)), errors.wrap('supplied properties not correct for "CustomValuesConfigurationProperty"');
    }
    function cfnAnalysisCustomValuesConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_CustomValuesConfigurationPropertyValidator(properties).assertSuccess(), { CustomValues: cfnAnalysisCustomParameterValuesPropertyToCloudFormation(properties.customValues), IncludeNullValue: cdk.booleanToCloudFormation(properties.includeNullValue) }) : properties;
    }
    function CfnAnalysisCustomValuesConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customValues", "CustomValues", CfnAnalysisCustomParameterValuesPropertyFromCloudFormation(properties.CustomValues)), ret.addPropertyResult("includeNullValue", "IncludeNullValue", properties.IncludeNullValue != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeNullValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DataBarsOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("negativeColor", cdk.validateString)(properties.negativeColor)), errors.collect(cdk.propertyValidator("positiveColor", cdk.validateString)(properties.positiveColor)), errors.wrap('supplied properties not correct for "DataBarsOptionsProperty"');
    }
    function cfnAnalysisDataBarsOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DataBarsOptionsPropertyValidator(properties).assertSuccess(), { FieldId: cdk.stringToCloudFormation(properties.fieldId), NegativeColor: cdk.stringToCloudFormation(properties.negativeColor), PositiveColor: cdk.stringToCloudFormation(properties.positiveColor) }) : properties;
    }
    function CfnAnalysisDataBarsOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("negativeColor", "NegativeColor", properties.NegativeColor != null ? cfn_parse.FromCloudFormation.getString(properties.NegativeColor) : void 0), ret.addPropertyResult("positiveColor", "PositiveColor", properties.PositiveColor != null ? cfn_parse.FromCloudFormation.getString(properties.PositiveColor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DataColorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.collect(cdk.propertyValidator("dataValue", cdk.validateNumber)(properties.dataValue)), errors.wrap('supplied properties not correct for "DataColorProperty"');
    }
    function cfnAnalysisDataColorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DataColorPropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color), DataValue: cdk.numberToCloudFormation(properties.dataValue) }) : properties;
    }
    function CfnAnalysisDataColorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", properties.Color != null ? cfn_parse.FromCloudFormation.getString(properties.Color) : void 0), ret.addPropertyResult("dataValue", "DataValue", properties.DataValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.DataValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DataFieldSeriesItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("axisBinding", cdk.requiredValidator)(properties.axisBinding)), errors.collect(cdk.propertyValidator("axisBinding", cdk.validateString)(properties.axisBinding)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldValue", cdk.validateString)(properties.fieldValue)), errors.collect(cdk.propertyValidator("settings", CfnAnalysis_LineChartSeriesSettingsPropertyValidator)(properties.settings)), errors.wrap('supplied properties not correct for "DataFieldSeriesItemProperty"');
    }
    function cfnAnalysisDataFieldSeriesItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DataFieldSeriesItemPropertyValidator(properties).assertSuccess(), { AxisBinding: cdk.stringToCloudFormation(properties.axisBinding), FieldId: cdk.stringToCloudFormation(properties.fieldId), FieldValue: cdk.stringToCloudFormation(properties.fieldValue), Settings: cfnAnalysisLineChartSeriesSettingsPropertyToCloudFormation(properties.settings) }) : properties;
    }
    function CfnAnalysisDataFieldSeriesItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("axisBinding", "AxisBinding", cfn_parse.FromCloudFormation.getString(properties.AxisBinding)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("fieldValue", "FieldValue", properties.FieldValue != null ? cfn_parse.FromCloudFormation.getString(properties.FieldValue) : void 0), ret.addPropertyResult("settings", "Settings", properties.Settings != null ? CfnAnalysisLineChartSeriesSettingsPropertyFromCloudFormation(properties.Settings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DataLabelOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryLabelVisibility", cdk.validateString)(properties.categoryLabelVisibility)), errors.collect(cdk.propertyValidator("dataLabelTypes", cdk.listValidator(CfnAnalysis_DataLabelTypePropertyValidator))(properties.dataLabelTypes)), errors.collect(cdk.propertyValidator("labelColor", cdk.validateString)(properties.labelColor)), errors.collect(cdk.propertyValidator("labelContent", cdk.validateString)(properties.labelContent)), errors.collect(cdk.propertyValidator("labelFontConfiguration", CfnAnalysis_FontConfigurationPropertyValidator)(properties.labelFontConfiguration)), errors.collect(cdk.propertyValidator("measureLabelVisibility", cdk.validateString)(properties.measureLabelVisibility)), errors.collect(cdk.propertyValidator("overlap", cdk.validateString)(properties.overlap)), errors.collect(cdk.propertyValidator("position", cdk.validateString)(properties.position)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "DataLabelOptionsProperty"');
    }
    function cfnAnalysisDataLabelOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DataLabelOptionsPropertyValidator(properties).assertSuccess(), { CategoryLabelVisibility: cdk.stringToCloudFormation(properties.categoryLabelVisibility), DataLabelTypes: cdk.listMapper(cfnAnalysisDataLabelTypePropertyToCloudFormation)(properties.dataLabelTypes), LabelColor: cdk.stringToCloudFormation(properties.labelColor), LabelContent: cdk.stringToCloudFormation(properties.labelContent), LabelFontConfiguration: cfnAnalysisFontConfigurationPropertyToCloudFormation(properties.labelFontConfiguration), MeasureLabelVisibility: cdk.stringToCloudFormation(properties.measureLabelVisibility), Overlap: cdk.stringToCloudFormation(properties.overlap), Position: cdk.stringToCloudFormation(properties.position), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnAnalysisDataLabelOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryLabelVisibility", "CategoryLabelVisibility", properties.CategoryLabelVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.CategoryLabelVisibility) : void 0), ret.addPropertyResult("dataLabelTypes", "DataLabelTypes", properties.DataLabelTypes != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDataLabelTypePropertyFromCloudFormation)(properties.DataLabelTypes) : void 0), ret.addPropertyResult("labelColor", "LabelColor", properties.LabelColor != null ? cfn_parse.FromCloudFormation.getString(properties.LabelColor) : void 0), ret.addPropertyResult("labelContent", "LabelContent", properties.LabelContent != null ? cfn_parse.FromCloudFormation.getString(properties.LabelContent) : void 0), ret.addPropertyResult("labelFontConfiguration", "LabelFontConfiguration", properties.LabelFontConfiguration != null ? CfnAnalysisFontConfigurationPropertyFromCloudFormation(properties.LabelFontConfiguration) : void 0), ret.addPropertyResult("measureLabelVisibility", "MeasureLabelVisibility", properties.MeasureLabelVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.MeasureLabelVisibility) : void 0), ret.addPropertyResult("overlap", "Overlap", properties.Overlap != null ? cfn_parse.FromCloudFormation.getString(properties.Overlap) : void 0), ret.addPropertyResult("position", "Position", properties.Position != null ? cfn_parse.FromCloudFormation.getString(properties.Position) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DataLabelTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataPathLabelType", CfnAnalysis_DataPathLabelTypePropertyValidator)(properties.dataPathLabelType)), errors.collect(cdk.propertyValidator("fieldLabelType", CfnAnalysis_FieldLabelTypePropertyValidator)(properties.fieldLabelType)), errors.collect(cdk.propertyValidator("maximumLabelType", CfnAnalysis_MaximumLabelTypePropertyValidator)(properties.maximumLabelType)), errors.collect(cdk.propertyValidator("minimumLabelType", CfnAnalysis_MinimumLabelTypePropertyValidator)(properties.minimumLabelType)), errors.collect(cdk.propertyValidator("rangeEndsLabelType", CfnAnalysis_RangeEndsLabelTypePropertyValidator)(properties.rangeEndsLabelType)), errors.wrap('supplied properties not correct for "DataLabelTypeProperty"');
    }
    function cfnAnalysisDataLabelTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DataLabelTypePropertyValidator(properties).assertSuccess(), { DataPathLabelType: cfnAnalysisDataPathLabelTypePropertyToCloudFormation(properties.dataPathLabelType), FieldLabelType: cfnAnalysisFieldLabelTypePropertyToCloudFormation(properties.fieldLabelType), MaximumLabelType: cfnAnalysisMaximumLabelTypePropertyToCloudFormation(properties.maximumLabelType), MinimumLabelType: cfnAnalysisMinimumLabelTypePropertyToCloudFormation(properties.minimumLabelType), RangeEndsLabelType: cfnAnalysisRangeEndsLabelTypePropertyToCloudFormation(properties.rangeEndsLabelType) }) : properties;
    }
    function CfnAnalysisDataLabelTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataPathLabelType", "DataPathLabelType", properties.DataPathLabelType != null ? CfnAnalysisDataPathLabelTypePropertyFromCloudFormation(properties.DataPathLabelType) : void 0), ret.addPropertyResult("fieldLabelType", "FieldLabelType", properties.FieldLabelType != null ? CfnAnalysisFieldLabelTypePropertyFromCloudFormation(properties.FieldLabelType) : void 0), ret.addPropertyResult("maximumLabelType", "MaximumLabelType", properties.MaximumLabelType != null ? CfnAnalysisMaximumLabelTypePropertyFromCloudFormation(properties.MaximumLabelType) : void 0), ret.addPropertyResult("minimumLabelType", "MinimumLabelType", properties.MinimumLabelType != null ? CfnAnalysisMinimumLabelTypePropertyFromCloudFormation(properties.MinimumLabelType) : void 0), ret.addPropertyResult("rangeEndsLabelType", "RangeEndsLabelType", properties.RangeEndsLabelType != null ? CfnAnalysisRangeEndsLabelTypePropertyFromCloudFormation(properties.RangeEndsLabelType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DataPathColorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.requiredValidator)(properties.color)), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.collect(cdk.propertyValidator("element", cdk.requiredValidator)(properties.element)), errors.collect(cdk.propertyValidator("element", CfnAnalysis_DataPathValuePropertyValidator)(properties.element)), errors.collect(cdk.propertyValidator("timeGranularity", cdk.validateString)(properties.timeGranularity)), errors.wrap('supplied properties not correct for "DataPathColorProperty"');
    }
    function cfnAnalysisDataPathColorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DataPathColorPropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color), Element: cfnAnalysisDataPathValuePropertyToCloudFormation(properties.element), TimeGranularity: cdk.stringToCloudFormation(properties.timeGranularity) }) : properties;
    }
    function CfnAnalysisDataPathColorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", cfn_parse.FromCloudFormation.getString(properties.Color)), ret.addPropertyResult("element", "Element", CfnAnalysisDataPathValuePropertyFromCloudFormation(properties.Element)), ret.addPropertyResult("timeGranularity", "TimeGranularity", properties.TimeGranularity != null ? cfn_parse.FromCloudFormation.getString(properties.TimeGranularity) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DataPathLabelTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldValue", cdk.validateString)(properties.fieldValue)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "DataPathLabelTypeProperty"');
    }
    function cfnAnalysisDataPathLabelTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DataPathLabelTypePropertyValidator(properties).assertSuccess(), { FieldId: cdk.stringToCloudFormation(properties.fieldId), FieldValue: cdk.stringToCloudFormation(properties.fieldValue), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnAnalysisDataPathLabelTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldId", "FieldId", properties.FieldId != null ? cfn_parse.FromCloudFormation.getString(properties.FieldId) : void 0), ret.addPropertyResult("fieldValue", "FieldValue", properties.FieldValue != null ? cfn_parse.FromCloudFormation.getString(properties.FieldValue) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DataPathSortPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("direction", cdk.requiredValidator)(properties.direction)), errors.collect(cdk.propertyValidator("direction", cdk.validateString)(properties.direction)), errors.collect(cdk.propertyValidator("sortPaths", cdk.requiredValidator)(properties.sortPaths)), errors.collect(cdk.propertyValidator("sortPaths", cdk.listValidator(CfnAnalysis_DataPathValuePropertyValidator))(properties.sortPaths)), errors.wrap('supplied properties not correct for "DataPathSortProperty"');
    }
    function cfnAnalysisDataPathSortPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DataPathSortPropertyValidator(properties).assertSuccess(), { Direction: cdk.stringToCloudFormation(properties.direction), SortPaths: cdk.listMapper(cfnAnalysisDataPathValuePropertyToCloudFormation)(properties.sortPaths) }) : properties;
    }
    function CfnAnalysisDataPathSortPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("direction", "Direction", cfn_parse.FromCloudFormation.getString(properties.Direction)), ret.addPropertyResult("sortPaths", "SortPaths", cfn_parse.FromCloudFormation.getArray(CfnAnalysisDataPathValuePropertyFromCloudFormation)(properties.SortPaths)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DataPathValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldValue", cdk.requiredValidator)(properties.fieldValue)), errors.collect(cdk.propertyValidator("fieldValue", cdk.validateString)(properties.fieldValue)), errors.wrap('supplied properties not correct for "DataPathValueProperty"');
    }
    function cfnAnalysisDataPathValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DataPathValuePropertyValidator(properties).assertSuccess(), { FieldId: cdk.stringToCloudFormation(properties.fieldId), FieldValue: cdk.stringToCloudFormation(properties.fieldValue) }) : properties;
    }
    function CfnAnalysisDataPathValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("fieldValue", "FieldValue", cfn_parse.FromCloudFormation.getString(properties.FieldValue)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DataSetIdentifierDeclarationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataSetArn", cdk.requiredValidator)(properties.dataSetArn)), errors.collect(cdk.propertyValidator("dataSetArn", cdk.validateString)(properties.dataSetArn)), errors.collect(cdk.propertyValidator("identifier", cdk.requiredValidator)(properties.identifier)), errors.collect(cdk.propertyValidator("identifier", cdk.validateString)(properties.identifier)), errors.wrap('supplied properties not correct for "DataSetIdentifierDeclarationProperty"');
    }
    function cfnAnalysisDataSetIdentifierDeclarationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DataSetIdentifierDeclarationPropertyValidator(properties).assertSuccess(), { DataSetArn: cdk.stringToCloudFormation(properties.dataSetArn), Identifier: cdk.stringToCloudFormation(properties.identifier) }) : properties;
    }
    function CfnAnalysisDataSetIdentifierDeclarationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataSetArn", "DataSetArn", cfn_parse.FromCloudFormation.getString(properties.DataSetArn)), ret.addPropertyResult("identifier", "Identifier", cfn_parse.FromCloudFormation.getString(properties.Identifier)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DataSetReferencePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataSetArn", cdk.requiredValidator)(properties.dataSetArn)), errors.collect(cdk.propertyValidator("dataSetArn", cdk.validateString)(properties.dataSetArn)), errors.collect(cdk.propertyValidator("dataSetPlaceholder", cdk.requiredValidator)(properties.dataSetPlaceholder)), errors.collect(cdk.propertyValidator("dataSetPlaceholder", cdk.validateString)(properties.dataSetPlaceholder)), errors.wrap('supplied properties not correct for "DataSetReferenceProperty"');
    }
    function cfnAnalysisDataSetReferencePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DataSetReferencePropertyValidator(properties).assertSuccess(), { DataSetArn: cdk.stringToCloudFormation(properties.dataSetArn), DataSetPlaceholder: cdk.stringToCloudFormation(properties.dataSetPlaceholder) }) : properties;
    }
    function CfnAnalysisDataSetReferencePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataSetArn", "DataSetArn", cfn_parse.FromCloudFormation.getString(properties.DataSetArn)), ret.addPropertyResult("dataSetPlaceholder", "DataSetPlaceholder", cfn_parse.FromCloudFormation.getString(properties.DataSetPlaceholder)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DateAxisOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("missingDateVisibility", cdk.validateString)(properties.missingDateVisibility)), errors.wrap('supplied properties not correct for "DateAxisOptionsProperty"');
    }
    function cfnAnalysisDateAxisOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DateAxisOptionsPropertyValidator(properties).assertSuccess(), { MissingDateVisibility: cdk.stringToCloudFormation(properties.missingDateVisibility) }) : properties;
    }
    function CfnAnalysisDateAxisOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("missingDateVisibility", "MissingDateVisibility", properties.MissingDateVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.MissingDateVisibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DateDimensionFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnAnalysis_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("dateGranularity", cdk.validateString)(properties.dateGranularity)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("formatConfiguration", CfnAnalysis_DateTimeFormatConfigurationPropertyValidator)(properties.formatConfiguration)), errors.collect(cdk.propertyValidator("hierarchyId", cdk.validateString)(properties.hierarchyId)), errors.wrap('supplied properties not correct for "DateDimensionFieldProperty"');
    }
    function cfnAnalysisDateDimensionFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DateDimensionFieldPropertyValidator(properties).assertSuccess(), { Column: cfnAnalysisColumnIdentifierPropertyToCloudFormation(properties.column), DateGranularity: cdk.stringToCloudFormation(properties.dateGranularity), FieldId: cdk.stringToCloudFormation(properties.fieldId), FormatConfiguration: cfnAnalysisDateTimeFormatConfigurationPropertyToCloudFormation(properties.formatConfiguration), HierarchyId: cdk.stringToCloudFormation(properties.hierarchyId) }) : properties;
    }
    function CfnAnalysisDateDimensionFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", CfnAnalysisColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("dateGranularity", "DateGranularity", properties.DateGranularity != null ? cfn_parse.FromCloudFormation.getString(properties.DateGranularity) : void 0), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("formatConfiguration", "FormatConfiguration", properties.FormatConfiguration != null ? CfnAnalysisDateTimeFormatConfigurationPropertyFromCloudFormation(properties.FormatConfiguration) : void 0), ret.addPropertyResult("hierarchyId", "HierarchyId", properties.HierarchyId != null ? cfn_parse.FromCloudFormation.getString(properties.HierarchyId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DateMeasureFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationFunction", cdk.validateString)(properties.aggregationFunction)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnAnalysis_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("formatConfiguration", CfnAnalysis_DateTimeFormatConfigurationPropertyValidator)(properties.formatConfiguration)), errors.wrap('supplied properties not correct for "DateMeasureFieldProperty"');
    }
    function cfnAnalysisDateMeasureFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DateMeasureFieldPropertyValidator(properties).assertSuccess(), { AggregationFunction: cdk.stringToCloudFormation(properties.aggregationFunction), Column: cfnAnalysisColumnIdentifierPropertyToCloudFormation(properties.column), FieldId: cdk.stringToCloudFormation(properties.fieldId), FormatConfiguration: cfnAnalysisDateTimeFormatConfigurationPropertyToCloudFormation(properties.formatConfiguration) }) : properties;
    }
    function CfnAnalysisDateMeasureFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationFunction", "AggregationFunction", properties.AggregationFunction != null ? cfn_parse.FromCloudFormation.getString(properties.AggregationFunction) : void 0), ret.addPropertyResult("column", "Column", CfnAnalysisColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("formatConfiguration", "FormatConfiguration", properties.FormatConfiguration != null ? CfnAnalysisDateTimeFormatConfigurationPropertyFromCloudFormation(properties.FormatConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DateTimeDefaultValuesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dynamicValue", CfnAnalysis_DynamicDefaultValuePropertyValidator)(properties.dynamicValue)), errors.collect(cdk.propertyValidator("rollingDate", CfnAnalysis_RollingDateConfigurationPropertyValidator)(properties.rollingDate)), errors.collect(cdk.propertyValidator("staticValues", cdk.listValidator(cdk.validateString))(properties.staticValues)), errors.wrap('supplied properties not correct for "DateTimeDefaultValuesProperty"');
    }
    function cfnAnalysisDateTimeDefaultValuesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DateTimeDefaultValuesPropertyValidator(properties).assertSuccess(), { DynamicValue: cfnAnalysisDynamicDefaultValuePropertyToCloudFormation(properties.dynamicValue), RollingDate: cfnAnalysisRollingDateConfigurationPropertyToCloudFormation(properties.rollingDate), StaticValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.staticValues) }) : properties;
    }
    function CfnAnalysisDateTimeDefaultValuesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dynamicValue", "DynamicValue", properties.DynamicValue != null ? CfnAnalysisDynamicDefaultValuePropertyFromCloudFormation(properties.DynamicValue) : void 0), ret.addPropertyResult("rollingDate", "RollingDate", properties.RollingDate != null ? CfnAnalysisRollingDateConfigurationPropertyFromCloudFormation(properties.RollingDate) : void 0), ret.addPropertyResult("staticValues", "StaticValues", properties.StaticValues != null ? cfn_parse.FromCloudFormation.getStringArray(properties.StaticValues) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DateTimeFormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateTimeFormat", cdk.validateString)(properties.dateTimeFormat)), errors.collect(cdk.propertyValidator("nullValueFormatConfiguration", CfnAnalysis_NullValueFormatConfigurationPropertyValidator)(properties.nullValueFormatConfiguration)), errors.collect(cdk.propertyValidator("numericFormatConfiguration", CfnAnalysis_NumericFormatConfigurationPropertyValidator)(properties.numericFormatConfiguration)), errors.wrap('supplied properties not correct for "DateTimeFormatConfigurationProperty"');
    }
    function cfnAnalysisDateTimeFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DateTimeFormatConfigurationPropertyValidator(properties).assertSuccess(), { DateTimeFormat: cdk.stringToCloudFormation(properties.dateTimeFormat), NullValueFormatConfiguration: cfnAnalysisNullValueFormatConfigurationPropertyToCloudFormation(properties.nullValueFormatConfiguration), NumericFormatConfiguration: cfnAnalysisNumericFormatConfigurationPropertyToCloudFormation(properties.numericFormatConfiguration) }) : properties;
    }
    function CfnAnalysisDateTimeFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateTimeFormat", "DateTimeFormat", properties.DateTimeFormat != null ? cfn_parse.FromCloudFormation.getString(properties.DateTimeFormat) : void 0), ret.addPropertyResult("nullValueFormatConfiguration", "NullValueFormatConfiguration", properties.NullValueFormatConfiguration != null ? CfnAnalysisNullValueFormatConfigurationPropertyFromCloudFormation(properties.NullValueFormatConfiguration) : void 0), ret.addPropertyResult("numericFormatConfiguration", "NumericFormatConfiguration", properties.NumericFormatConfiguration != null ? CfnAnalysisNumericFormatConfigurationPropertyFromCloudFormation(properties.NumericFormatConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DateTimeHierarchyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("drillDownFilters", cdk.listValidator(CfnAnalysis_DrillDownFilterPropertyValidator))(properties.drillDownFilters)), errors.collect(cdk.propertyValidator("hierarchyId", cdk.requiredValidator)(properties.hierarchyId)), errors.collect(cdk.propertyValidator("hierarchyId", cdk.validateString)(properties.hierarchyId)), errors.wrap('supplied properties not correct for "DateTimeHierarchyProperty"');
    }
    function cfnAnalysisDateTimeHierarchyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DateTimeHierarchyPropertyValidator(properties).assertSuccess(), { DrillDownFilters: cdk.listMapper(cfnAnalysisDrillDownFilterPropertyToCloudFormation)(properties.drillDownFilters), HierarchyId: cdk.stringToCloudFormation(properties.hierarchyId) }) : properties;
    }
    function CfnAnalysisDateTimeHierarchyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("drillDownFilters", "DrillDownFilters", properties.DrillDownFilters != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDrillDownFilterPropertyFromCloudFormation)(properties.DrillDownFilters) : void 0), ret.addPropertyResult("hierarchyId", "HierarchyId", cfn_parse.FromCloudFormation.getString(properties.HierarchyId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DateTimeParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("values", cdk.requiredValidator)(properties.values)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "DateTimeParameterProperty"');
    }
    function cfnAnalysisDateTimeParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DateTimeParameterPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnAnalysisDateTimeParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("values", "Values", cfn_parse.FromCloudFormation.getStringArray(properties.Values)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DateTimeParameterDeclarationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultValues", CfnAnalysis_DateTimeDefaultValuesPropertyValidator)(properties.defaultValues)), errors.collect(cdk.propertyValidator("mappedDataSetParameters", cdk.listValidator(CfnAnalysis_MappedDataSetParameterPropertyValidator))(properties.mappedDataSetParameters)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("timeGranularity", cdk.validateString)(properties.timeGranularity)), errors.collect(cdk.propertyValidator("valueWhenUnset", CfnAnalysis_DateTimeValueWhenUnsetConfigurationPropertyValidator)(properties.valueWhenUnset)), errors.wrap('supplied properties not correct for "DateTimeParameterDeclarationProperty"');
    }
    function cfnAnalysisDateTimeParameterDeclarationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DateTimeParameterDeclarationPropertyValidator(properties).assertSuccess(), { DefaultValues: cfnAnalysisDateTimeDefaultValuesPropertyToCloudFormation(properties.defaultValues), MappedDataSetParameters: cdk.listMapper(cfnAnalysisMappedDataSetParameterPropertyToCloudFormation)(properties.mappedDataSetParameters), Name: cdk.stringToCloudFormation(properties.name), TimeGranularity: cdk.stringToCloudFormation(properties.timeGranularity), ValueWhenUnset: cfnAnalysisDateTimeValueWhenUnsetConfigurationPropertyToCloudFormation(properties.valueWhenUnset) }) : properties;
    }
    function CfnAnalysisDateTimeParameterDeclarationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultValues", "DefaultValues", properties.DefaultValues != null ? CfnAnalysisDateTimeDefaultValuesPropertyFromCloudFormation(properties.DefaultValues) : void 0), ret.addPropertyResult("mappedDataSetParameters", "MappedDataSetParameters", properties.MappedDataSetParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMappedDataSetParameterPropertyFromCloudFormation)(properties.MappedDataSetParameters) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("timeGranularity", "TimeGranularity", properties.TimeGranularity != null ? cfn_parse.FromCloudFormation.getString(properties.TimeGranularity) : void 0), ret.addPropertyResult("valueWhenUnset", "ValueWhenUnset", properties.ValueWhenUnset != null ? CfnAnalysisDateTimeValueWhenUnsetConfigurationPropertyFromCloudFormation(properties.ValueWhenUnset) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DateTimePickerControlDisplayOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateTimeFormat", cdk.validateString)(properties.dateTimeFormat)), errors.collect(cdk.propertyValidator("titleOptions", CfnAnalysis_LabelOptionsPropertyValidator)(properties.titleOptions)), errors.wrap('supplied properties not correct for "DateTimePickerControlDisplayOptionsProperty"');
    }
    function cfnAnalysisDateTimePickerControlDisplayOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DateTimePickerControlDisplayOptionsPropertyValidator(properties).assertSuccess(), { DateTimeFormat: cdk.stringToCloudFormation(properties.dateTimeFormat), TitleOptions: cfnAnalysisLabelOptionsPropertyToCloudFormation(properties.titleOptions) }) : properties;
    }
    function CfnAnalysisDateTimePickerControlDisplayOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateTimeFormat", "DateTimeFormat", properties.DateTimeFormat != null ? cfn_parse.FromCloudFormation.getString(properties.DateTimeFormat) : void 0), ret.addPropertyResult("titleOptions", "TitleOptions", properties.TitleOptions != null ? CfnAnalysisLabelOptionsPropertyFromCloudFormation(properties.TitleOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DateTimeValueWhenUnsetConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customValue", cdk.validateString)(properties.customValue)), errors.collect(cdk.propertyValidator("valueWhenUnsetOption", cdk.validateString)(properties.valueWhenUnsetOption)), errors.wrap('supplied properties not correct for "DateTimeValueWhenUnsetConfigurationProperty"');
    }
    function cfnAnalysisDateTimeValueWhenUnsetConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DateTimeValueWhenUnsetConfigurationPropertyValidator(properties).assertSuccess(), { CustomValue: cdk.stringToCloudFormation(properties.customValue), ValueWhenUnsetOption: cdk.stringToCloudFormation(properties.valueWhenUnsetOption) }) : properties;
    }
    function CfnAnalysisDateTimeValueWhenUnsetConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customValue", "CustomValue", properties.CustomValue != null ? cfn_parse.FromCloudFormation.getString(properties.CustomValue) : void 0), ret.addPropertyResult("valueWhenUnsetOption", "ValueWhenUnsetOption", properties.ValueWhenUnsetOption != null ? cfn_parse.FromCloudFormation.getString(properties.ValueWhenUnsetOption) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DecimalDefaultValuesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dynamicValue", CfnAnalysis_DynamicDefaultValuePropertyValidator)(properties.dynamicValue)), errors.collect(cdk.propertyValidator("staticValues", cdk.listValidator(cdk.validateNumber))(properties.staticValues)), errors.wrap('supplied properties not correct for "DecimalDefaultValuesProperty"');
    }
    function cfnAnalysisDecimalDefaultValuesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DecimalDefaultValuesPropertyValidator(properties).assertSuccess(), { DynamicValue: cfnAnalysisDynamicDefaultValuePropertyToCloudFormation(properties.dynamicValue), StaticValues: cdk.listMapper(cdk.numberToCloudFormation)(properties.staticValues) }) : properties;
    }
    function CfnAnalysisDecimalDefaultValuesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dynamicValue", "DynamicValue", properties.DynamicValue != null ? CfnAnalysisDynamicDefaultValuePropertyFromCloudFormation(properties.DynamicValue) : void 0), ret.addPropertyResult("staticValues", "StaticValues", properties.StaticValues != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getNumber)(properties.StaticValues) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DecimalParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("values", cdk.requiredValidator)(properties.values)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateNumber))(properties.values)), errors.wrap('supplied properties not correct for "DecimalParameterProperty"');
    }
    function cfnAnalysisDecimalParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DecimalParameterPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Values: cdk.listMapper(cdk.numberToCloudFormation)(properties.values) }) : properties;
    }
    function CfnAnalysisDecimalParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("values", "Values", cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getNumber)(properties.Values)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DecimalParameterDeclarationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultValues", CfnAnalysis_DecimalDefaultValuesPropertyValidator)(properties.defaultValues)), errors.collect(cdk.propertyValidator("mappedDataSetParameters", cdk.listValidator(CfnAnalysis_MappedDataSetParameterPropertyValidator))(properties.mappedDataSetParameters)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("parameterValueType", cdk.requiredValidator)(properties.parameterValueType)), errors.collect(cdk.propertyValidator("parameterValueType", cdk.validateString)(properties.parameterValueType)), errors.collect(cdk.propertyValidator("valueWhenUnset", CfnAnalysis_DecimalValueWhenUnsetConfigurationPropertyValidator)(properties.valueWhenUnset)), errors.wrap('supplied properties not correct for "DecimalParameterDeclarationProperty"');
    }
    function cfnAnalysisDecimalParameterDeclarationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DecimalParameterDeclarationPropertyValidator(properties).assertSuccess(), { DefaultValues: cfnAnalysisDecimalDefaultValuesPropertyToCloudFormation(properties.defaultValues), MappedDataSetParameters: cdk.listMapper(cfnAnalysisMappedDataSetParameterPropertyToCloudFormation)(properties.mappedDataSetParameters), Name: cdk.stringToCloudFormation(properties.name), ParameterValueType: cdk.stringToCloudFormation(properties.parameterValueType), ValueWhenUnset: cfnAnalysisDecimalValueWhenUnsetConfigurationPropertyToCloudFormation(properties.valueWhenUnset) }) : properties;
    }
    function CfnAnalysisDecimalParameterDeclarationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultValues", "DefaultValues", properties.DefaultValues != null ? CfnAnalysisDecimalDefaultValuesPropertyFromCloudFormation(properties.DefaultValues) : void 0), ret.addPropertyResult("mappedDataSetParameters", "MappedDataSetParameters", properties.MappedDataSetParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMappedDataSetParameterPropertyFromCloudFormation)(properties.MappedDataSetParameters) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("parameterValueType", "ParameterValueType", cfn_parse.FromCloudFormation.getString(properties.ParameterValueType)), ret.addPropertyResult("valueWhenUnset", "ValueWhenUnset", properties.ValueWhenUnset != null ? CfnAnalysisDecimalValueWhenUnsetConfigurationPropertyFromCloudFormation(properties.ValueWhenUnset) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DecimalPlacesConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("decimalPlaces", cdk.requiredValidator)(properties.decimalPlaces)), errors.collect(cdk.propertyValidator("decimalPlaces", cdk.validateNumber)(properties.decimalPlaces)), errors.wrap('supplied properties not correct for "DecimalPlacesConfigurationProperty"');
    }
    function cfnAnalysisDecimalPlacesConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DecimalPlacesConfigurationPropertyValidator(properties).assertSuccess(), { DecimalPlaces: cdk.numberToCloudFormation(properties.decimalPlaces) }) : properties;
    }
    function CfnAnalysisDecimalPlacesConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("decimalPlaces", "DecimalPlaces", cfn_parse.FromCloudFormation.getNumber(properties.DecimalPlaces)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DecimalValueWhenUnsetConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customValue", cdk.validateNumber)(properties.customValue)), errors.collect(cdk.propertyValidator("valueWhenUnsetOption", cdk.validateString)(properties.valueWhenUnsetOption)), errors.wrap('supplied properties not correct for "DecimalValueWhenUnsetConfigurationProperty"');
    }
    function cfnAnalysisDecimalValueWhenUnsetConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DecimalValueWhenUnsetConfigurationPropertyValidator(properties).assertSuccess(), { CustomValue: cdk.numberToCloudFormation(properties.customValue), ValueWhenUnsetOption: cdk.stringToCloudFormation(properties.valueWhenUnsetOption) }) : properties;
    }
    function CfnAnalysisDecimalValueWhenUnsetConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customValue", "CustomValue", properties.CustomValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.CustomValue) : void 0), ret.addPropertyResult("valueWhenUnsetOption", "ValueWhenUnsetOption", properties.ValueWhenUnsetOption != null ? cfn_parse.FromCloudFormation.getString(properties.ValueWhenUnsetOption) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DefaultFreeFormLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("canvasSizeOptions", cdk.requiredValidator)(properties.canvasSizeOptions)), errors.collect(cdk.propertyValidator("canvasSizeOptions", CfnAnalysis_FreeFormLayoutCanvasSizeOptionsPropertyValidator)(properties.canvasSizeOptions)), errors.wrap('supplied properties not correct for "DefaultFreeFormLayoutConfigurationProperty"');
    }
    function cfnAnalysisDefaultFreeFormLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DefaultFreeFormLayoutConfigurationPropertyValidator(properties).assertSuccess(), { CanvasSizeOptions: cfnAnalysisFreeFormLayoutCanvasSizeOptionsPropertyToCloudFormation(properties.canvasSizeOptions) }) : properties;
    }
    function CfnAnalysisDefaultFreeFormLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("canvasSizeOptions", "CanvasSizeOptions", CfnAnalysisFreeFormLayoutCanvasSizeOptionsPropertyFromCloudFormation(properties.CanvasSizeOptions)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DefaultGridLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("canvasSizeOptions", cdk.requiredValidator)(properties.canvasSizeOptions)), errors.collect(cdk.propertyValidator("canvasSizeOptions", CfnAnalysis_GridLayoutCanvasSizeOptionsPropertyValidator)(properties.canvasSizeOptions)), errors.wrap('supplied properties not correct for "DefaultGridLayoutConfigurationProperty"');
    }
    function cfnAnalysisDefaultGridLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DefaultGridLayoutConfigurationPropertyValidator(properties).assertSuccess(), { CanvasSizeOptions: cfnAnalysisGridLayoutCanvasSizeOptionsPropertyToCloudFormation(properties.canvasSizeOptions) }) : properties;
    }
    function CfnAnalysisDefaultGridLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("canvasSizeOptions", "CanvasSizeOptions", CfnAnalysisGridLayoutCanvasSizeOptionsPropertyFromCloudFormation(properties.CanvasSizeOptions)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DefaultInteractiveLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("freeForm", CfnAnalysis_DefaultFreeFormLayoutConfigurationPropertyValidator)(properties.freeForm)), errors.collect(cdk.propertyValidator("grid", CfnAnalysis_DefaultGridLayoutConfigurationPropertyValidator)(properties.grid)), errors.wrap('supplied properties not correct for "DefaultInteractiveLayoutConfigurationProperty"');
    }
    function cfnAnalysisDefaultInteractiveLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DefaultInteractiveLayoutConfigurationPropertyValidator(properties).assertSuccess(), { FreeForm: cfnAnalysisDefaultFreeFormLayoutConfigurationPropertyToCloudFormation(properties.freeForm), Grid: cfnAnalysisDefaultGridLayoutConfigurationPropertyToCloudFormation(properties.grid) }) : properties;
    }
    function CfnAnalysisDefaultInteractiveLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("freeForm", "FreeForm", properties.FreeForm != null ? CfnAnalysisDefaultFreeFormLayoutConfigurationPropertyFromCloudFormation(properties.FreeForm) : void 0), ret.addPropertyResult("grid", "Grid", properties.Grid != null ? CfnAnalysisDefaultGridLayoutConfigurationPropertyFromCloudFormation(properties.Grid) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DefaultNewSheetConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("interactiveLayoutConfiguration", CfnAnalysis_DefaultInteractiveLayoutConfigurationPropertyValidator)(properties.interactiveLayoutConfiguration)), errors.collect(cdk.propertyValidator("paginatedLayoutConfiguration", CfnAnalysis_DefaultPaginatedLayoutConfigurationPropertyValidator)(properties.paginatedLayoutConfiguration)), errors.collect(cdk.propertyValidator("sheetContentType", cdk.validateString)(properties.sheetContentType)), errors.wrap('supplied properties not correct for "DefaultNewSheetConfigurationProperty"');
    }
    function cfnAnalysisDefaultNewSheetConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DefaultNewSheetConfigurationPropertyValidator(properties).assertSuccess(), { InteractiveLayoutConfiguration: cfnAnalysisDefaultInteractiveLayoutConfigurationPropertyToCloudFormation(properties.interactiveLayoutConfiguration), PaginatedLayoutConfiguration: cfnAnalysisDefaultPaginatedLayoutConfigurationPropertyToCloudFormation(properties.paginatedLayoutConfiguration), SheetContentType: cdk.stringToCloudFormation(properties.sheetContentType) }) : properties;
    }
    function CfnAnalysisDefaultNewSheetConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("interactiveLayoutConfiguration", "InteractiveLayoutConfiguration", properties.InteractiveLayoutConfiguration != null ? CfnAnalysisDefaultInteractiveLayoutConfigurationPropertyFromCloudFormation(properties.InteractiveLayoutConfiguration) : void 0), ret.addPropertyResult("paginatedLayoutConfiguration", "PaginatedLayoutConfiguration", properties.PaginatedLayoutConfiguration != null ? CfnAnalysisDefaultPaginatedLayoutConfigurationPropertyFromCloudFormation(properties.PaginatedLayoutConfiguration) : void 0), ret.addPropertyResult("sheetContentType", "SheetContentType", properties.SheetContentType != null ? cfn_parse.FromCloudFormation.getString(properties.SheetContentType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DefaultPaginatedLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sectionBased", CfnAnalysis_DefaultSectionBasedLayoutConfigurationPropertyValidator)(properties.sectionBased)), errors.wrap('supplied properties not correct for "DefaultPaginatedLayoutConfigurationProperty"');
    }
    function cfnAnalysisDefaultPaginatedLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DefaultPaginatedLayoutConfigurationPropertyValidator(properties).assertSuccess(), { SectionBased: cfnAnalysisDefaultSectionBasedLayoutConfigurationPropertyToCloudFormation(properties.sectionBased) }) : properties;
    }
    function CfnAnalysisDefaultPaginatedLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sectionBased", "SectionBased", properties.SectionBased != null ? CfnAnalysisDefaultSectionBasedLayoutConfigurationPropertyFromCloudFormation(properties.SectionBased) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DefaultSectionBasedLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("canvasSizeOptions", cdk.requiredValidator)(properties.canvasSizeOptions)), errors.collect(cdk.propertyValidator("canvasSizeOptions", CfnAnalysis_SectionBasedLayoutCanvasSizeOptionsPropertyValidator)(properties.canvasSizeOptions)), errors.wrap('supplied properties not correct for "DefaultSectionBasedLayoutConfigurationProperty"');
    }
    function cfnAnalysisDefaultSectionBasedLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DefaultSectionBasedLayoutConfigurationPropertyValidator(properties).assertSuccess(), { CanvasSizeOptions: cfnAnalysisSectionBasedLayoutCanvasSizeOptionsPropertyToCloudFormation(properties.canvasSizeOptions) }) : properties;
    }
    function CfnAnalysisDefaultSectionBasedLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("canvasSizeOptions", "CanvasSizeOptions", CfnAnalysisSectionBasedLayoutCanvasSizeOptionsPropertyFromCloudFormation(properties.CanvasSizeOptions)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DestinationParameterValueConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customValuesConfiguration", CfnAnalysis_CustomValuesConfigurationPropertyValidator)(properties.customValuesConfiguration)), errors.collect(cdk.propertyValidator("selectAllValueOptions", cdk.validateString)(properties.selectAllValueOptions)), errors.collect(cdk.propertyValidator("sourceField", cdk.validateString)(properties.sourceField)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.validateString)(properties.sourceParameterName)), errors.wrap('supplied properties not correct for "DestinationParameterValueConfigurationProperty"');
    }
    function cfnAnalysisDestinationParameterValueConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DestinationParameterValueConfigurationPropertyValidator(properties).assertSuccess(), { CustomValuesConfiguration: cfnAnalysisCustomValuesConfigurationPropertyToCloudFormation(properties.customValuesConfiguration), SelectAllValueOptions: cdk.stringToCloudFormation(properties.selectAllValueOptions), SourceField: cdk.stringToCloudFormation(properties.sourceField), SourceParameterName: cdk.stringToCloudFormation(properties.sourceParameterName) }) : properties;
    }
    function CfnAnalysisDestinationParameterValueConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customValuesConfiguration", "CustomValuesConfiguration", properties.CustomValuesConfiguration != null ? CfnAnalysisCustomValuesConfigurationPropertyFromCloudFormation(properties.CustomValuesConfiguration) : void 0), ret.addPropertyResult("selectAllValueOptions", "SelectAllValueOptions", properties.SelectAllValueOptions != null ? cfn_parse.FromCloudFormation.getString(properties.SelectAllValueOptions) : void 0), ret.addPropertyResult("sourceField", "SourceField", properties.SourceField != null ? cfn_parse.FromCloudFormation.getString(properties.SourceField) : void 0), ret.addPropertyResult("sourceParameterName", "SourceParameterName", properties.SourceParameterName != null ? cfn_parse.FromCloudFormation.getString(properties.SourceParameterName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DimensionFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoricalDimensionField", CfnAnalysis_CategoricalDimensionFieldPropertyValidator)(properties.categoricalDimensionField)), errors.collect(cdk.propertyValidator("dateDimensionField", CfnAnalysis_DateDimensionFieldPropertyValidator)(properties.dateDimensionField)), errors.collect(cdk.propertyValidator("numericalDimensionField", CfnAnalysis_NumericalDimensionFieldPropertyValidator)(properties.numericalDimensionField)), errors.wrap('supplied properties not correct for "DimensionFieldProperty"');
    }
    function cfnAnalysisDimensionFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DimensionFieldPropertyValidator(properties).assertSuccess(), { CategoricalDimensionField: cfnAnalysisCategoricalDimensionFieldPropertyToCloudFormation(properties.categoricalDimensionField), DateDimensionField: cfnAnalysisDateDimensionFieldPropertyToCloudFormation(properties.dateDimensionField), NumericalDimensionField: cfnAnalysisNumericalDimensionFieldPropertyToCloudFormation(properties.numericalDimensionField) }) : properties;
    }
    function CfnAnalysisDimensionFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoricalDimensionField", "CategoricalDimensionField", properties.CategoricalDimensionField != null ? CfnAnalysisCategoricalDimensionFieldPropertyFromCloudFormation(properties.CategoricalDimensionField) : void 0), ret.addPropertyResult("dateDimensionField", "DateDimensionField", properties.DateDimensionField != null ? CfnAnalysisDateDimensionFieldPropertyFromCloudFormation(properties.DateDimensionField) : void 0), ret.addPropertyResult("numericalDimensionField", "NumericalDimensionField", properties.NumericalDimensionField != null ? CfnAnalysisNumericalDimensionFieldPropertyFromCloudFormation(properties.NumericalDimensionField) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DonutCenterOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("labelVisibility", cdk.validateString)(properties.labelVisibility)), errors.wrap('supplied properties not correct for "DonutCenterOptionsProperty"');
    }
    function cfnAnalysisDonutCenterOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DonutCenterOptionsPropertyValidator(properties).assertSuccess(), { LabelVisibility: cdk.stringToCloudFormation(properties.labelVisibility) }) : properties;
    }
    function CfnAnalysisDonutCenterOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("labelVisibility", "LabelVisibility", properties.LabelVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.LabelVisibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DonutOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arcOptions", CfnAnalysis_ArcOptionsPropertyValidator)(properties.arcOptions)), errors.collect(cdk.propertyValidator("donutCenterOptions", CfnAnalysis_DonutCenterOptionsPropertyValidator)(properties.donutCenterOptions)), errors.wrap('supplied properties not correct for "DonutOptionsProperty"');
    }
    function cfnAnalysisDonutOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DonutOptionsPropertyValidator(properties).assertSuccess(), { ArcOptions: cfnAnalysisArcOptionsPropertyToCloudFormation(properties.arcOptions), DonutCenterOptions: cfnAnalysisDonutCenterOptionsPropertyToCloudFormation(properties.donutCenterOptions) }) : properties;
    }
    function CfnAnalysisDonutOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arcOptions", "ArcOptions", properties.ArcOptions != null ? CfnAnalysisArcOptionsPropertyFromCloudFormation(properties.ArcOptions) : void 0), ret.addPropertyResult("donutCenterOptions", "DonutCenterOptions", properties.DonutCenterOptions != null ? CfnAnalysisDonutCenterOptionsPropertyFromCloudFormation(properties.DonutCenterOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DrillDownFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryFilter", CfnAnalysis_CategoryDrillDownFilterPropertyValidator)(properties.categoryFilter)), errors.collect(cdk.propertyValidator("numericEqualityFilter", CfnAnalysis_NumericEqualityDrillDownFilterPropertyValidator)(properties.numericEqualityFilter)), errors.collect(cdk.propertyValidator("timeRangeFilter", CfnAnalysis_TimeRangeDrillDownFilterPropertyValidator)(properties.timeRangeFilter)), errors.wrap('supplied properties not correct for "DrillDownFilterProperty"');
    }
    function cfnAnalysisDrillDownFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DrillDownFilterPropertyValidator(properties).assertSuccess(), { CategoryFilter: cfnAnalysisCategoryDrillDownFilterPropertyToCloudFormation(properties.categoryFilter), NumericEqualityFilter: cfnAnalysisNumericEqualityDrillDownFilterPropertyToCloudFormation(properties.numericEqualityFilter), TimeRangeFilter: cfnAnalysisTimeRangeDrillDownFilterPropertyToCloudFormation(properties.timeRangeFilter) }) : properties;
    }
    function CfnAnalysisDrillDownFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryFilter", "CategoryFilter", properties.CategoryFilter != null ? CfnAnalysisCategoryDrillDownFilterPropertyFromCloudFormation(properties.CategoryFilter) : void 0), ret.addPropertyResult("numericEqualityFilter", "NumericEqualityFilter", properties.NumericEqualityFilter != null ? CfnAnalysisNumericEqualityDrillDownFilterPropertyFromCloudFormation(properties.NumericEqualityFilter) : void 0), ret.addPropertyResult("timeRangeFilter", "TimeRangeFilter", properties.TimeRangeFilter != null ? CfnAnalysisTimeRangeDrillDownFilterPropertyFromCloudFormation(properties.TimeRangeFilter) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DropDownControlDisplayOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("selectAllOptions", CfnAnalysis_ListControlSelectAllOptionsPropertyValidator)(properties.selectAllOptions)), errors.collect(cdk.propertyValidator("titleOptions", CfnAnalysis_LabelOptionsPropertyValidator)(properties.titleOptions)), errors.wrap('supplied properties not correct for "DropDownControlDisplayOptionsProperty"');
    }
    function cfnAnalysisDropDownControlDisplayOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DropDownControlDisplayOptionsPropertyValidator(properties).assertSuccess(), { SelectAllOptions: cfnAnalysisListControlSelectAllOptionsPropertyToCloudFormation(properties.selectAllOptions), TitleOptions: cfnAnalysisLabelOptionsPropertyToCloudFormation(properties.titleOptions) }) : properties;
    }
    function CfnAnalysisDropDownControlDisplayOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("selectAllOptions", "SelectAllOptions", properties.SelectAllOptions != null ? CfnAnalysisListControlSelectAllOptionsPropertyFromCloudFormation(properties.SelectAllOptions) : void 0), ret.addPropertyResult("titleOptions", "TitleOptions", properties.TitleOptions != null ? CfnAnalysisLabelOptionsPropertyFromCloudFormation(properties.TitleOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_DynamicDefaultValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultValueColumn", cdk.requiredValidator)(properties.defaultValueColumn)), errors.collect(cdk.propertyValidator("defaultValueColumn", CfnAnalysis_ColumnIdentifierPropertyValidator)(properties.defaultValueColumn)), errors.collect(cdk.propertyValidator("groupNameColumn", CfnAnalysis_ColumnIdentifierPropertyValidator)(properties.groupNameColumn)), errors.collect(cdk.propertyValidator("userNameColumn", CfnAnalysis_ColumnIdentifierPropertyValidator)(properties.userNameColumn)), errors.wrap('supplied properties not correct for "DynamicDefaultValueProperty"');
    }
    function cfnAnalysisDynamicDefaultValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_DynamicDefaultValuePropertyValidator(properties).assertSuccess(), { DefaultValueColumn: cfnAnalysisColumnIdentifierPropertyToCloudFormation(properties.defaultValueColumn), GroupNameColumn: cfnAnalysisColumnIdentifierPropertyToCloudFormation(properties.groupNameColumn), UserNameColumn: cfnAnalysisColumnIdentifierPropertyToCloudFormation(properties.userNameColumn) }) : properties;
    }
    function CfnAnalysisDynamicDefaultValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultValueColumn", "DefaultValueColumn", CfnAnalysisColumnIdentifierPropertyFromCloudFormation(properties.DefaultValueColumn)), ret.addPropertyResult("groupNameColumn", "GroupNameColumn", properties.GroupNameColumn != null ? CfnAnalysisColumnIdentifierPropertyFromCloudFormation(properties.GroupNameColumn) : void 0), ret.addPropertyResult("userNameColumn", "UserNameColumn", properties.UserNameColumn != null ? CfnAnalysisColumnIdentifierPropertyFromCloudFormation(properties.UserNameColumn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_EmptyVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnAnalysis_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.requiredValidator)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.validateString)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "EmptyVisualProperty"');
    }
    function cfnAnalysisEmptyVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_EmptyVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnAnalysisVisualCustomActionPropertyToCloudFormation)(properties.actions), DataSetIdentifier: cdk.stringToCloudFormation(properties.dataSetIdentifier), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnAnalysisEmptyVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("dataSetIdentifier", "DataSetIdentifier", cfn_parse.FromCloudFormation.getString(properties.DataSetIdentifier)), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ExcludePeriodConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("amount", cdk.requiredValidator)(properties.amount)), errors.collect(cdk.propertyValidator("amount", cdk.validateNumber)(properties.amount)), errors.collect(cdk.propertyValidator("granularity", cdk.requiredValidator)(properties.granularity)), errors.collect(cdk.propertyValidator("granularity", cdk.validateString)(properties.granularity)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "ExcludePeriodConfigurationProperty"');
    }
    function cfnAnalysisExcludePeriodConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ExcludePeriodConfigurationPropertyValidator(properties).assertSuccess(), { Amount: cdk.numberToCloudFormation(properties.amount), Granularity: cdk.stringToCloudFormation(properties.granularity), Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnAnalysisExcludePeriodConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("amount", "Amount", cfn_parse.FromCloudFormation.getNumber(properties.Amount)), ret.addPropertyResult("granularity", "Granularity", cfn_parse.FromCloudFormation.getString(properties.Granularity)), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ExplicitHierarchyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columns", cdk.requiredValidator)(properties.columns)), errors.collect(cdk.propertyValidator("columns", cdk.listValidator(CfnAnalysis_ColumnIdentifierPropertyValidator))(properties.columns)), errors.collect(cdk.propertyValidator("drillDownFilters", cdk.listValidator(CfnAnalysis_DrillDownFilterPropertyValidator))(properties.drillDownFilters)), errors.collect(cdk.propertyValidator("hierarchyId", cdk.requiredValidator)(properties.hierarchyId)), errors.collect(cdk.propertyValidator("hierarchyId", cdk.validateString)(properties.hierarchyId)), errors.wrap('supplied properties not correct for "ExplicitHierarchyProperty"');
    }
    function cfnAnalysisExplicitHierarchyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ExplicitHierarchyPropertyValidator(properties).assertSuccess(), { Columns: cdk.listMapper(cfnAnalysisColumnIdentifierPropertyToCloudFormation)(properties.columns), DrillDownFilters: cdk.listMapper(cfnAnalysisDrillDownFilterPropertyToCloudFormation)(properties.drillDownFilters), HierarchyId: cdk.stringToCloudFormation(properties.hierarchyId) }) : properties;
    }
    function CfnAnalysisExplicitHierarchyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columns", "Columns", cfn_parse.FromCloudFormation.getArray(CfnAnalysisColumnIdentifierPropertyFromCloudFormation)(properties.Columns)), ret.addPropertyResult("drillDownFilters", "DrillDownFilters", properties.DrillDownFilters != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDrillDownFilterPropertyFromCloudFormation)(properties.DrillDownFilters) : void 0), ret.addPropertyResult("hierarchyId", "HierarchyId", cfn_parse.FromCloudFormation.getString(properties.HierarchyId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FieldBasedTooltipPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationVisibility", cdk.validateString)(properties.aggregationVisibility)), errors.collect(cdk.propertyValidator("tooltipFields", cdk.listValidator(CfnAnalysis_TooltipItemPropertyValidator))(properties.tooltipFields)), errors.collect(cdk.propertyValidator("tooltipTitleType", cdk.validateString)(properties.tooltipTitleType)), errors.wrap('supplied properties not correct for "FieldBasedTooltipProperty"');
    }
    function cfnAnalysisFieldBasedTooltipPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FieldBasedTooltipPropertyValidator(properties).assertSuccess(), { AggregationVisibility: cdk.stringToCloudFormation(properties.aggregationVisibility), TooltipFields: cdk.listMapper(cfnAnalysisTooltipItemPropertyToCloudFormation)(properties.tooltipFields), TooltipTitleType: cdk.stringToCloudFormation(properties.tooltipTitleType) }) : properties;
    }
    function CfnAnalysisFieldBasedTooltipPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationVisibility", "AggregationVisibility", properties.AggregationVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.AggregationVisibility) : void 0), ret.addPropertyResult("tooltipFields", "TooltipFields", properties.TooltipFields != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisTooltipItemPropertyFromCloudFormation)(properties.TooltipFields) : void 0), ret.addPropertyResult("tooltipTitleType", "TooltipTitleType", properties.TooltipTitleType != null ? cfn_parse.FromCloudFormation.getString(properties.TooltipTitleType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FieldLabelTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "FieldLabelTypeProperty"');
    }
    function cfnAnalysisFieldLabelTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FieldLabelTypePropertyValidator(properties).assertSuccess(), { FieldId: cdk.stringToCloudFormation(properties.fieldId), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnAnalysisFieldLabelTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldId", "FieldId", properties.FieldId != null ? cfn_parse.FromCloudFormation.getString(properties.FieldId) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FieldSeriesItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("axisBinding", cdk.requiredValidator)(properties.axisBinding)), errors.collect(cdk.propertyValidator("axisBinding", cdk.validateString)(properties.axisBinding)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("settings", CfnAnalysis_LineChartSeriesSettingsPropertyValidator)(properties.settings)), errors.wrap('supplied properties not correct for "FieldSeriesItemProperty"');
    }
    function cfnAnalysisFieldSeriesItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FieldSeriesItemPropertyValidator(properties).assertSuccess(), { AxisBinding: cdk.stringToCloudFormation(properties.axisBinding), FieldId: cdk.stringToCloudFormation(properties.fieldId), Settings: cfnAnalysisLineChartSeriesSettingsPropertyToCloudFormation(properties.settings) }) : properties;
    }
    function CfnAnalysisFieldSeriesItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("axisBinding", "AxisBinding", cfn_parse.FromCloudFormation.getString(properties.AxisBinding)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("settings", "Settings", properties.Settings != null ? CfnAnalysisLineChartSeriesSettingsPropertyFromCloudFormation(properties.Settings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FieldSortPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("direction", cdk.requiredValidator)(properties.direction)), errors.collect(cdk.propertyValidator("direction", cdk.validateString)(properties.direction)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.wrap('supplied properties not correct for "FieldSortProperty"');
    }
    function cfnAnalysisFieldSortPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FieldSortPropertyValidator(properties).assertSuccess(), { Direction: cdk.stringToCloudFormation(properties.direction), FieldId: cdk.stringToCloudFormation(properties.fieldId) }) : properties;
    }
    function CfnAnalysisFieldSortPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("direction", "Direction", cfn_parse.FromCloudFormation.getString(properties.Direction)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FieldSortOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnSort", CfnAnalysis_ColumnSortPropertyValidator)(properties.columnSort)), errors.collect(cdk.propertyValidator("fieldSort", CfnAnalysis_FieldSortPropertyValidator)(properties.fieldSort)), errors.wrap('supplied properties not correct for "FieldSortOptionsProperty"');
    }
    function cfnAnalysisFieldSortOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FieldSortOptionsPropertyValidator(properties).assertSuccess(), { ColumnSort: cfnAnalysisColumnSortPropertyToCloudFormation(properties.columnSort), FieldSort: cfnAnalysisFieldSortPropertyToCloudFormation(properties.fieldSort) }) : properties;
    }
    function CfnAnalysisFieldSortOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columnSort", "ColumnSort", properties.ColumnSort != null ? CfnAnalysisColumnSortPropertyFromCloudFormation(properties.ColumnSort) : void 0), ret.addPropertyResult("fieldSort", "FieldSort", properties.FieldSort != null ? CfnAnalysisFieldSortPropertyFromCloudFormation(properties.FieldSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FieldTooltipItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("label", cdk.validateString)(properties.label)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "FieldTooltipItemProperty"');
    }
    function cfnAnalysisFieldTooltipItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FieldTooltipItemPropertyValidator(properties).assertSuccess(), { FieldId: cdk.stringToCloudFormation(properties.fieldId), Label: cdk.stringToCloudFormation(properties.label), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnAnalysisFieldTooltipItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("label", "Label", properties.Label != null ? cfn_parse.FromCloudFormation.getString(properties.Label) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FilledMapAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("geospatial", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.geospatial)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnAnalysis_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "FilledMapAggregatedFieldWellsProperty"');
    }
    function cfnAnalysisFilledMapAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FilledMapAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Geospatial: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.geospatial), Values: cdk.listMapper(cfnAnalysisMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnAnalysisFilledMapAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("geospatial", "Geospatial", properties.Geospatial != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.Geospatial) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FilledMapConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("conditionalFormattingOptions", cdk.requiredValidator)(properties.conditionalFormattingOptions)), errors.collect(cdk.propertyValidator("conditionalFormattingOptions", cdk.listValidator(CfnAnalysis_FilledMapConditionalFormattingOptionPropertyValidator))(properties.conditionalFormattingOptions)), errors.wrap('supplied properties not correct for "FilledMapConditionalFormattingProperty"');
    }
    function cfnAnalysisFilledMapConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FilledMapConditionalFormattingPropertyValidator(properties).assertSuccess(), { ConditionalFormattingOptions: cdk.listMapper(cfnAnalysisFilledMapConditionalFormattingOptionPropertyToCloudFormation)(properties.conditionalFormattingOptions) }) : properties;
    }
    function CfnAnalysisFilledMapConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("conditionalFormattingOptions", "ConditionalFormattingOptions", cfn_parse.FromCloudFormation.getArray(CfnAnalysisFilledMapConditionalFormattingOptionPropertyFromCloudFormation)(properties.ConditionalFormattingOptions)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FilledMapConditionalFormattingOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("shape", cdk.requiredValidator)(properties.shape)), errors.collect(cdk.propertyValidator("shape", CfnAnalysis_FilledMapShapeConditionalFormattingPropertyValidator)(properties.shape)), errors.wrap('supplied properties not correct for "FilledMapConditionalFormattingOptionProperty"');
    }
    function cfnAnalysisFilledMapConditionalFormattingOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FilledMapConditionalFormattingOptionPropertyValidator(properties).assertSuccess(), { Shape: cfnAnalysisFilledMapShapeConditionalFormattingPropertyToCloudFormation(properties.shape) }) : properties;
    }
    function CfnAnalysisFilledMapConditionalFormattingOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("shape", "Shape", CfnAnalysisFilledMapShapeConditionalFormattingPropertyFromCloudFormation(properties.Shape)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FilledMapConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldWells", CfnAnalysis_FilledMapFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("legend", CfnAnalysis_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("mapStyleOptions", CfnAnalysis_GeospatialMapStyleOptionsPropertyValidator)(properties.mapStyleOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnAnalysis_FilledMapSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tooltip", CfnAnalysis_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.collect(cdk.propertyValidator("windowOptions", CfnAnalysis_GeospatialWindowOptionsPropertyValidator)(properties.windowOptions)), errors.wrap('supplied properties not correct for "FilledMapConfigurationProperty"');
    }
    function cfnAnalysisFilledMapConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FilledMapConfigurationPropertyValidator(properties).assertSuccess(), { FieldWells: cfnAnalysisFilledMapFieldWellsPropertyToCloudFormation(properties.fieldWells), Legend: cfnAnalysisLegendOptionsPropertyToCloudFormation(properties.legend), MapStyleOptions: cfnAnalysisGeospatialMapStyleOptionsPropertyToCloudFormation(properties.mapStyleOptions), SortConfiguration: cfnAnalysisFilledMapSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), Tooltip: cfnAnalysisTooltipOptionsPropertyToCloudFormation(properties.tooltip), WindowOptions: cfnAnalysisGeospatialWindowOptionsPropertyToCloudFormation(properties.windowOptions) }) : properties;
    }
    function CfnAnalysisFilledMapConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnAnalysisFilledMapFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnAnalysisLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("mapStyleOptions", "MapStyleOptions", properties.MapStyleOptions != null ? CfnAnalysisGeospatialMapStyleOptionsPropertyFromCloudFormation(properties.MapStyleOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnAnalysisFilledMapSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnAnalysisTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addPropertyResult("windowOptions", "WindowOptions", properties.WindowOptions != null ? CfnAnalysisGeospatialWindowOptionsPropertyFromCloudFormation(properties.WindowOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FilledMapFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("filledMapAggregatedFieldWells", CfnAnalysis_FilledMapAggregatedFieldWellsPropertyValidator)(properties.filledMapAggregatedFieldWells)), errors.wrap('supplied properties not correct for "FilledMapFieldWellsProperty"');
    }
    function cfnAnalysisFilledMapFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FilledMapFieldWellsPropertyValidator(properties).assertSuccess(), { FilledMapAggregatedFieldWells: cfnAnalysisFilledMapAggregatedFieldWellsPropertyToCloudFormation(properties.filledMapAggregatedFieldWells) }) : properties;
    }
    function CfnAnalysisFilledMapFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("filledMapAggregatedFieldWells", "FilledMapAggregatedFieldWells", properties.FilledMapAggregatedFieldWells != null ? CfnAnalysisFilledMapAggregatedFieldWellsPropertyFromCloudFormation(properties.FilledMapAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FilledMapShapeConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("format", CfnAnalysis_ShapeConditionalFormatPropertyValidator)(properties.format)), errors.wrap('supplied properties not correct for "FilledMapShapeConditionalFormattingProperty"');
    }
    function cfnAnalysisFilledMapShapeConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FilledMapShapeConditionalFormattingPropertyValidator(properties).assertSuccess(), { FieldId: cdk.stringToCloudFormation(properties.fieldId), Format: cfnAnalysisShapeConditionalFormatPropertyToCloudFormation(properties.format) }) : properties;
    }
    function CfnAnalysisFilledMapShapeConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("format", "Format", properties.Format != null ? CfnAnalysisShapeConditionalFormatPropertyFromCloudFormation(properties.Format) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FilledMapSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categorySort", cdk.listValidator(CfnAnalysis_FieldSortOptionsPropertyValidator))(properties.categorySort)), errors.wrap('supplied properties not correct for "FilledMapSortConfigurationProperty"');
    }
    function cfnAnalysisFilledMapSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FilledMapSortConfigurationPropertyValidator(properties).assertSuccess(), { CategorySort: cdk.listMapper(cfnAnalysisFieldSortOptionsPropertyToCloudFormation)(properties.categorySort) }) : properties;
    }
    function CfnAnalysisFilledMapSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categorySort", "CategorySort", properties.CategorySort != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisFieldSortOptionsPropertyFromCloudFormation)(properties.CategorySort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FilledMapVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnAnalysis_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnAnalysis_FilledMapConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnAnalysis_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("conditionalFormatting", CfnAnalysis_FilledMapConditionalFormattingPropertyValidator)(properties.conditionalFormatting)), errors.collect(cdk.propertyValidator("subtitle", CfnAnalysis_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnAnalysis_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "FilledMapVisualProperty"');
    }
    function cfnAnalysisFilledMapVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FilledMapVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnAnalysisVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnAnalysisFilledMapConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnAnalysisColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), ConditionalFormatting: cfnAnalysisFilledMapConditionalFormattingPropertyToCloudFormation(properties.conditionalFormatting), Subtitle: cfnAnalysisVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnAnalysisVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnAnalysisFilledMapVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnAnalysisFilledMapConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("conditionalFormatting", "ConditionalFormatting", properties.ConditionalFormatting != null ? CfnAnalysisFilledMapConditionalFormattingPropertyFromCloudFormation(properties.ConditionalFormatting) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnAnalysisVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnAnalysisVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryFilter", CfnAnalysis_CategoryFilterPropertyValidator)(properties.categoryFilter)), errors.collect(cdk.propertyValidator("numericEqualityFilter", CfnAnalysis_NumericEqualityFilterPropertyValidator)(properties.numericEqualityFilter)), errors.collect(cdk.propertyValidator("numericRangeFilter", CfnAnalysis_NumericRangeFilterPropertyValidator)(properties.numericRangeFilter)), errors.collect(cdk.propertyValidator("relativeDatesFilter", CfnAnalysis_RelativeDatesFilterPropertyValidator)(properties.relativeDatesFilter)), errors.collect(cdk.propertyValidator("timeEqualityFilter", CfnAnalysis_TimeEqualityFilterPropertyValidator)(properties.timeEqualityFilter)), errors.collect(cdk.propertyValidator("timeRangeFilter", CfnAnalysis_TimeRangeFilterPropertyValidator)(properties.timeRangeFilter)), errors.collect(cdk.propertyValidator("topBottomFilter", CfnAnalysis_TopBottomFilterPropertyValidator)(properties.topBottomFilter)), errors.wrap('supplied properties not correct for "FilterProperty"');
    }
    function cfnAnalysisFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FilterPropertyValidator(properties).assertSuccess(), { CategoryFilter: cfnAnalysisCategoryFilterPropertyToCloudFormation(properties.categoryFilter), NumericEqualityFilter: cfnAnalysisNumericEqualityFilterPropertyToCloudFormation(properties.numericEqualityFilter), NumericRangeFilter: cfnAnalysisNumericRangeFilterPropertyToCloudFormation(properties.numericRangeFilter), RelativeDatesFilter: cfnAnalysisRelativeDatesFilterPropertyToCloudFormation(properties.relativeDatesFilter), TimeEqualityFilter: cfnAnalysisTimeEqualityFilterPropertyToCloudFormation(properties.timeEqualityFilter), TimeRangeFilter: cfnAnalysisTimeRangeFilterPropertyToCloudFormation(properties.timeRangeFilter), TopBottomFilter: cfnAnalysisTopBottomFilterPropertyToCloudFormation(properties.topBottomFilter) }) : properties;
    }
    function CfnAnalysisFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryFilter", "CategoryFilter", properties.CategoryFilter != null ? CfnAnalysisCategoryFilterPropertyFromCloudFormation(properties.CategoryFilter) : void 0), ret.addPropertyResult("numericEqualityFilter", "NumericEqualityFilter", properties.NumericEqualityFilter != null ? CfnAnalysisNumericEqualityFilterPropertyFromCloudFormation(properties.NumericEqualityFilter) : void 0), ret.addPropertyResult("numericRangeFilter", "NumericRangeFilter", properties.NumericRangeFilter != null ? CfnAnalysisNumericRangeFilterPropertyFromCloudFormation(properties.NumericRangeFilter) : void 0), ret.addPropertyResult("relativeDatesFilter", "RelativeDatesFilter", properties.RelativeDatesFilter != null ? CfnAnalysisRelativeDatesFilterPropertyFromCloudFormation(properties.RelativeDatesFilter) : void 0), ret.addPropertyResult("timeEqualityFilter", "TimeEqualityFilter", properties.TimeEqualityFilter != null ? CfnAnalysisTimeEqualityFilterPropertyFromCloudFormation(properties.TimeEqualityFilter) : void 0), ret.addPropertyResult("timeRangeFilter", "TimeRangeFilter", properties.TimeRangeFilter != null ? CfnAnalysisTimeRangeFilterPropertyFromCloudFormation(properties.TimeRangeFilter) : void 0), ret.addPropertyResult("topBottomFilter", "TopBottomFilter", properties.TopBottomFilter != null ? CfnAnalysisTopBottomFilterPropertyFromCloudFormation(properties.TopBottomFilter) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FilterControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateTimePicker", CfnAnalysis_FilterDateTimePickerControlPropertyValidator)(properties.dateTimePicker)), errors.collect(cdk.propertyValidator("dropdown", CfnAnalysis_FilterDropDownControlPropertyValidator)(properties.dropdown)), errors.collect(cdk.propertyValidator("list", CfnAnalysis_FilterListControlPropertyValidator)(properties.list)), errors.collect(cdk.propertyValidator("relativeDateTime", CfnAnalysis_FilterRelativeDateTimeControlPropertyValidator)(properties.relativeDateTime)), errors.collect(cdk.propertyValidator("slider", CfnAnalysis_FilterSliderControlPropertyValidator)(properties.slider)), errors.collect(cdk.propertyValidator("textArea", CfnAnalysis_FilterTextAreaControlPropertyValidator)(properties.textArea)), errors.collect(cdk.propertyValidator("textField", CfnAnalysis_FilterTextFieldControlPropertyValidator)(properties.textField)), errors.wrap('supplied properties not correct for "FilterControlProperty"');
    }
    function cfnAnalysisFilterControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FilterControlPropertyValidator(properties).assertSuccess(), { DateTimePicker: cfnAnalysisFilterDateTimePickerControlPropertyToCloudFormation(properties.dateTimePicker), Dropdown: cfnAnalysisFilterDropDownControlPropertyToCloudFormation(properties.dropdown), List: cfnAnalysisFilterListControlPropertyToCloudFormation(properties.list), RelativeDateTime: cfnAnalysisFilterRelativeDateTimeControlPropertyToCloudFormation(properties.relativeDateTime), Slider: cfnAnalysisFilterSliderControlPropertyToCloudFormation(properties.slider), TextArea: cfnAnalysisFilterTextAreaControlPropertyToCloudFormation(properties.textArea), TextField: cfnAnalysisFilterTextFieldControlPropertyToCloudFormation(properties.textField) }) : properties;
    }
    function CfnAnalysisFilterControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateTimePicker", "DateTimePicker", properties.DateTimePicker != null ? CfnAnalysisFilterDateTimePickerControlPropertyFromCloudFormation(properties.DateTimePicker) : void 0), ret.addPropertyResult("dropdown", "Dropdown", properties.Dropdown != null ? CfnAnalysisFilterDropDownControlPropertyFromCloudFormation(properties.Dropdown) : void 0), ret.addPropertyResult("list", "List", properties.List != null ? CfnAnalysisFilterListControlPropertyFromCloudFormation(properties.List) : void 0), ret.addPropertyResult("relativeDateTime", "RelativeDateTime", properties.RelativeDateTime != null ? CfnAnalysisFilterRelativeDateTimeControlPropertyFromCloudFormation(properties.RelativeDateTime) : void 0), ret.addPropertyResult("slider", "Slider", properties.Slider != null ? CfnAnalysisFilterSliderControlPropertyFromCloudFormation(properties.Slider) : void 0), ret.addPropertyResult("textArea", "TextArea", properties.TextArea != null ? CfnAnalysisFilterTextAreaControlPropertyFromCloudFormation(properties.TextArea) : void 0), ret.addPropertyResult("textField", "TextField", properties.TextField != null ? CfnAnalysisFilterTextFieldControlPropertyFromCloudFormation(properties.TextField) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FilterDateTimePickerControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("displayOptions", CfnAnalysis_DateTimePickerControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("filterControlId", cdk.requiredValidator)(properties.filterControlId)), errors.collect(cdk.propertyValidator("filterControlId", cdk.validateString)(properties.filterControlId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.requiredValidator)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.validateString)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "FilterDateTimePickerControlProperty"');
    }
    function cfnAnalysisFilterDateTimePickerControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FilterDateTimePickerControlPropertyValidator(properties).assertSuccess(), { DisplayOptions: cfnAnalysisDateTimePickerControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), FilterControlId: cdk.stringToCloudFormation(properties.filterControlId), SourceFilterId: cdk.stringToCloudFormation(properties.sourceFilterId), Title: cdk.stringToCloudFormation(properties.title), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnAnalysisFilterDateTimePickerControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnAnalysisDateTimePickerControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("filterControlId", "FilterControlId", cfn_parse.FromCloudFormation.getString(properties.FilterControlId)), ret.addPropertyResult("sourceFilterId", "SourceFilterId", cfn_parse.FromCloudFormation.getString(properties.SourceFilterId)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FilterDropDownControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cascadingControlConfiguration", CfnAnalysis_CascadingControlConfigurationPropertyValidator)(properties.cascadingControlConfiguration)), errors.collect(cdk.propertyValidator("displayOptions", CfnAnalysis_DropDownControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("filterControlId", cdk.requiredValidator)(properties.filterControlId)), errors.collect(cdk.propertyValidator("filterControlId", cdk.validateString)(properties.filterControlId)), errors.collect(cdk.propertyValidator("selectableValues", CfnAnalysis_FilterSelectableValuesPropertyValidator)(properties.selectableValues)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.requiredValidator)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.validateString)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "FilterDropDownControlProperty"');
    }
    function cfnAnalysisFilterDropDownControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FilterDropDownControlPropertyValidator(properties).assertSuccess(), { CascadingControlConfiguration: cfnAnalysisCascadingControlConfigurationPropertyToCloudFormation(properties.cascadingControlConfiguration), DisplayOptions: cfnAnalysisDropDownControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), FilterControlId: cdk.stringToCloudFormation(properties.filterControlId), SelectableValues: cfnAnalysisFilterSelectableValuesPropertyToCloudFormation(properties.selectableValues), SourceFilterId: cdk.stringToCloudFormation(properties.sourceFilterId), Title: cdk.stringToCloudFormation(properties.title), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnAnalysisFilterDropDownControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cascadingControlConfiguration", "CascadingControlConfiguration", properties.CascadingControlConfiguration != null ? CfnAnalysisCascadingControlConfigurationPropertyFromCloudFormation(properties.CascadingControlConfiguration) : void 0), ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnAnalysisDropDownControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("filterControlId", "FilterControlId", cfn_parse.FromCloudFormation.getString(properties.FilterControlId)), ret.addPropertyResult("selectableValues", "SelectableValues", properties.SelectableValues != null ? CfnAnalysisFilterSelectableValuesPropertyFromCloudFormation(properties.SelectableValues) : void 0), ret.addPropertyResult("sourceFilterId", "SourceFilterId", cfn_parse.FromCloudFormation.getString(properties.SourceFilterId)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FilterGroupPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("crossDataset", cdk.requiredValidator)(properties.crossDataset)), errors.collect(cdk.propertyValidator("crossDataset", cdk.validateString)(properties.crossDataset)), errors.collect(cdk.propertyValidator("filterGroupId", cdk.requiredValidator)(properties.filterGroupId)), errors.collect(cdk.propertyValidator("filterGroupId", cdk.validateString)(properties.filterGroupId)), errors.collect(cdk.propertyValidator("filters", cdk.requiredValidator)(properties.filters)), errors.collect(cdk.propertyValidator("filters", cdk.listValidator(CfnAnalysis_FilterPropertyValidator))(properties.filters)), errors.collect(cdk.propertyValidator("scopeConfiguration", cdk.requiredValidator)(properties.scopeConfiguration)), errors.collect(cdk.propertyValidator("scopeConfiguration", CfnAnalysis_FilterScopeConfigurationPropertyValidator)(properties.scopeConfiguration)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "FilterGroupProperty"');
    }
    function cfnAnalysisFilterGroupPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FilterGroupPropertyValidator(properties).assertSuccess(), { CrossDataset: cdk.stringToCloudFormation(properties.crossDataset), FilterGroupId: cdk.stringToCloudFormation(properties.filterGroupId), Filters: cdk.listMapper(cfnAnalysisFilterPropertyToCloudFormation)(properties.filters), ScopeConfiguration: cfnAnalysisFilterScopeConfigurationPropertyToCloudFormation(properties.scopeConfiguration), Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnAnalysisFilterGroupPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("crossDataset", "CrossDataset", cfn_parse.FromCloudFormation.getString(properties.CrossDataset)), ret.addPropertyResult("filterGroupId", "FilterGroupId", cfn_parse.FromCloudFormation.getString(properties.FilterGroupId)), ret.addPropertyResult("filters", "Filters", cfn_parse.FromCloudFormation.getArray(CfnAnalysisFilterPropertyFromCloudFormation)(properties.Filters)), ret.addPropertyResult("scopeConfiguration", "ScopeConfiguration", CfnAnalysisFilterScopeConfigurationPropertyFromCloudFormation(properties.ScopeConfiguration)), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FilterListConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryValues", cdk.listValidator(cdk.validateString))(properties.categoryValues)), errors.collect(cdk.propertyValidator("matchOperator", cdk.requiredValidator)(properties.matchOperator)), errors.collect(cdk.propertyValidator("matchOperator", cdk.validateString)(properties.matchOperator)), errors.collect(cdk.propertyValidator("selectAllOptions", cdk.validateString)(properties.selectAllOptions)), errors.wrap('supplied properties not correct for "FilterListConfigurationProperty"');
    }
    function cfnAnalysisFilterListConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FilterListConfigurationPropertyValidator(properties).assertSuccess(), { CategoryValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.categoryValues), MatchOperator: cdk.stringToCloudFormation(properties.matchOperator), SelectAllOptions: cdk.stringToCloudFormation(properties.selectAllOptions) }) : properties;
    }
    function CfnAnalysisFilterListConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryValues", "CategoryValues", properties.CategoryValues != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CategoryValues) : void 0), ret.addPropertyResult("matchOperator", "MatchOperator", cfn_parse.FromCloudFormation.getString(properties.MatchOperator)), ret.addPropertyResult("selectAllOptions", "SelectAllOptions", properties.SelectAllOptions != null ? cfn_parse.FromCloudFormation.getString(properties.SelectAllOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FilterListControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cascadingControlConfiguration", CfnAnalysis_CascadingControlConfigurationPropertyValidator)(properties.cascadingControlConfiguration)), errors.collect(cdk.propertyValidator("displayOptions", CfnAnalysis_ListControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("filterControlId", cdk.requiredValidator)(properties.filterControlId)), errors.collect(cdk.propertyValidator("filterControlId", cdk.validateString)(properties.filterControlId)), errors.collect(cdk.propertyValidator("selectableValues", CfnAnalysis_FilterSelectableValuesPropertyValidator)(properties.selectableValues)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.requiredValidator)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.validateString)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "FilterListControlProperty"');
    }
    function cfnAnalysisFilterListControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FilterListControlPropertyValidator(properties).assertSuccess(), { CascadingControlConfiguration: cfnAnalysisCascadingControlConfigurationPropertyToCloudFormation(properties.cascadingControlConfiguration), DisplayOptions: cfnAnalysisListControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), FilterControlId: cdk.stringToCloudFormation(properties.filterControlId), SelectableValues: cfnAnalysisFilterSelectableValuesPropertyToCloudFormation(properties.selectableValues), SourceFilterId: cdk.stringToCloudFormation(properties.sourceFilterId), Title: cdk.stringToCloudFormation(properties.title), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnAnalysisFilterListControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cascadingControlConfiguration", "CascadingControlConfiguration", properties.CascadingControlConfiguration != null ? CfnAnalysisCascadingControlConfigurationPropertyFromCloudFormation(properties.CascadingControlConfiguration) : void 0), ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnAnalysisListControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("filterControlId", "FilterControlId", cfn_parse.FromCloudFormation.getString(properties.FilterControlId)), ret.addPropertyResult("selectableValues", "SelectableValues", properties.SelectableValues != null ? CfnAnalysisFilterSelectableValuesPropertyFromCloudFormation(properties.SelectableValues) : void 0), ret.addPropertyResult("sourceFilterId", "SourceFilterId", cfn_parse.FromCloudFormation.getString(properties.SourceFilterId)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FilterOperationSelectedFieldsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("selectedFieldOptions", cdk.validateString)(properties.selectedFieldOptions)), errors.collect(cdk.propertyValidator("selectedFields", cdk.listValidator(cdk.validateString))(properties.selectedFields)), errors.wrap('supplied properties not correct for "FilterOperationSelectedFieldsConfigurationProperty"');
    }
    function cfnAnalysisFilterOperationSelectedFieldsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FilterOperationSelectedFieldsConfigurationPropertyValidator(properties).assertSuccess(), { SelectedFieldOptions: cdk.stringToCloudFormation(properties.selectedFieldOptions), SelectedFields: cdk.listMapper(cdk.stringToCloudFormation)(properties.selectedFields) }) : properties;
    }
    function CfnAnalysisFilterOperationSelectedFieldsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("selectedFieldOptions", "SelectedFieldOptions", properties.SelectedFieldOptions != null ? cfn_parse.FromCloudFormation.getString(properties.SelectedFieldOptions) : void 0), ret.addPropertyResult("selectedFields", "SelectedFields", properties.SelectedFields != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SelectedFields) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FilterOperationTargetVisualsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sameSheetTargetVisualConfiguration", CfnAnalysis_SameSheetTargetVisualConfigurationPropertyValidator)(properties.sameSheetTargetVisualConfiguration)), errors.wrap('supplied properties not correct for "FilterOperationTargetVisualsConfigurationProperty"');
    }
    function cfnAnalysisFilterOperationTargetVisualsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FilterOperationTargetVisualsConfigurationPropertyValidator(properties).assertSuccess(), { SameSheetTargetVisualConfiguration: cfnAnalysisSameSheetTargetVisualConfigurationPropertyToCloudFormation(properties.sameSheetTargetVisualConfiguration) }) : properties;
    }
    function CfnAnalysisFilterOperationTargetVisualsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sameSheetTargetVisualConfiguration", "SameSheetTargetVisualConfiguration", properties.SameSheetTargetVisualConfiguration != null ? CfnAnalysisSameSheetTargetVisualConfigurationPropertyFromCloudFormation(properties.SameSheetTargetVisualConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FilterRelativeDateTimeControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("displayOptions", CfnAnalysis_RelativeDateTimeControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("filterControlId", cdk.requiredValidator)(properties.filterControlId)), errors.collect(cdk.propertyValidator("filterControlId", cdk.validateString)(properties.filterControlId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.requiredValidator)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.validateString)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.wrap('supplied properties not correct for "FilterRelativeDateTimeControlProperty"');
    }
    function cfnAnalysisFilterRelativeDateTimeControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FilterRelativeDateTimeControlPropertyValidator(properties).assertSuccess(), { DisplayOptions: cfnAnalysisRelativeDateTimeControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), FilterControlId: cdk.stringToCloudFormation(properties.filterControlId), SourceFilterId: cdk.stringToCloudFormation(properties.sourceFilterId), Title: cdk.stringToCloudFormation(properties.title) }) : properties;
    }
    function CfnAnalysisFilterRelativeDateTimeControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnAnalysisRelativeDateTimeControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("filterControlId", "FilterControlId", cfn_parse.FromCloudFormation.getString(properties.FilterControlId)), ret.addPropertyResult("sourceFilterId", "SourceFilterId", cfn_parse.FromCloudFormation.getString(properties.SourceFilterId)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FilterScopeConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("selectedSheets", CfnAnalysis_SelectedSheetsFilterScopeConfigurationPropertyValidator)(properties.selectedSheets)), errors.wrap('supplied properties not correct for "FilterScopeConfigurationProperty"');
    }
    function cfnAnalysisFilterScopeConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FilterScopeConfigurationPropertyValidator(properties).assertSuccess(), { SelectedSheets: cfnAnalysisSelectedSheetsFilterScopeConfigurationPropertyToCloudFormation(properties.selectedSheets) }) : properties;
    }
    function CfnAnalysisFilterScopeConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("selectedSheets", "SelectedSheets", properties.SelectedSheets != null ? CfnAnalysisSelectedSheetsFilterScopeConfigurationPropertyFromCloudFormation(properties.SelectedSheets) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FilterSelectableValuesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "FilterSelectableValuesProperty"');
    }
    function cfnAnalysisFilterSelectableValuesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FilterSelectableValuesPropertyValidator(properties).assertSuccess(), { Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnAnalysisFilterSelectableValuesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FilterSliderControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("displayOptions", CfnAnalysis_SliderControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("filterControlId", cdk.requiredValidator)(properties.filterControlId)), errors.collect(cdk.propertyValidator("filterControlId", cdk.validateString)(properties.filterControlId)), errors.collect(cdk.propertyValidator("maximumValue", cdk.requiredValidator)(properties.maximumValue)), errors.collect(cdk.propertyValidator("maximumValue", cdk.validateNumber)(properties.maximumValue)), errors.collect(cdk.propertyValidator("minimumValue", cdk.requiredValidator)(properties.minimumValue)), errors.collect(cdk.propertyValidator("minimumValue", cdk.validateNumber)(properties.minimumValue)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.requiredValidator)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.validateString)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("stepSize", cdk.requiredValidator)(properties.stepSize)), errors.collect(cdk.propertyValidator("stepSize", cdk.validateNumber)(properties.stepSize)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "FilterSliderControlProperty"');
    }
    function cfnAnalysisFilterSliderControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FilterSliderControlPropertyValidator(properties).assertSuccess(), { DisplayOptions: cfnAnalysisSliderControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), FilterControlId: cdk.stringToCloudFormation(properties.filterControlId), MaximumValue: cdk.numberToCloudFormation(properties.maximumValue), MinimumValue: cdk.numberToCloudFormation(properties.minimumValue), SourceFilterId: cdk.stringToCloudFormation(properties.sourceFilterId), StepSize: cdk.numberToCloudFormation(properties.stepSize), Title: cdk.stringToCloudFormation(properties.title), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnAnalysisFilterSliderControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnAnalysisSliderControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("filterControlId", "FilterControlId", cfn_parse.FromCloudFormation.getString(properties.FilterControlId)), ret.addPropertyResult("maximumValue", "MaximumValue", cfn_parse.FromCloudFormation.getNumber(properties.MaximumValue)), ret.addPropertyResult("minimumValue", "MinimumValue", cfn_parse.FromCloudFormation.getNumber(properties.MinimumValue)), ret.addPropertyResult("sourceFilterId", "SourceFilterId", cfn_parse.FromCloudFormation.getString(properties.SourceFilterId)), ret.addPropertyResult("stepSize", "StepSize", cfn_parse.FromCloudFormation.getNumber(properties.StepSize)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FilterTextAreaControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("delimiter", cdk.validateString)(properties.delimiter)), errors.collect(cdk.propertyValidator("displayOptions", CfnAnalysis_TextAreaControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("filterControlId", cdk.requiredValidator)(properties.filterControlId)), errors.collect(cdk.propertyValidator("filterControlId", cdk.validateString)(properties.filterControlId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.requiredValidator)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.validateString)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.wrap('supplied properties not correct for "FilterTextAreaControlProperty"');
    }
    function cfnAnalysisFilterTextAreaControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FilterTextAreaControlPropertyValidator(properties).assertSuccess(), { Delimiter: cdk.stringToCloudFormation(properties.delimiter), DisplayOptions: cfnAnalysisTextAreaControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), FilterControlId: cdk.stringToCloudFormation(properties.filterControlId), SourceFilterId: cdk.stringToCloudFormation(properties.sourceFilterId), Title: cdk.stringToCloudFormation(properties.title) }) : properties;
    }
    function CfnAnalysisFilterTextAreaControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("delimiter", "Delimiter", properties.Delimiter != null ? cfn_parse.FromCloudFormation.getString(properties.Delimiter) : void 0), ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnAnalysisTextAreaControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("filterControlId", "FilterControlId", cfn_parse.FromCloudFormation.getString(properties.FilterControlId)), ret.addPropertyResult("sourceFilterId", "SourceFilterId", cfn_parse.FromCloudFormation.getString(properties.SourceFilterId)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FilterTextFieldControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("displayOptions", CfnAnalysis_TextFieldControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("filterControlId", cdk.requiredValidator)(properties.filterControlId)), errors.collect(cdk.propertyValidator("filterControlId", cdk.validateString)(properties.filterControlId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.requiredValidator)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.validateString)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.wrap('supplied properties not correct for "FilterTextFieldControlProperty"');
    }
    function cfnAnalysisFilterTextFieldControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FilterTextFieldControlPropertyValidator(properties).assertSuccess(), { DisplayOptions: cfnAnalysisTextFieldControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), FilterControlId: cdk.stringToCloudFormation(properties.filterControlId), SourceFilterId: cdk.stringToCloudFormation(properties.sourceFilterId), Title: cdk.stringToCloudFormation(properties.title) }) : properties;
    }
    function CfnAnalysisFilterTextFieldControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnAnalysisTextFieldControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("filterControlId", "FilterControlId", cfn_parse.FromCloudFormation.getString(properties.FilterControlId)), ret.addPropertyResult("sourceFilterId", "SourceFilterId", cfn_parse.FromCloudFormation.getString(properties.SourceFilterId)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FontConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fontColor", cdk.validateString)(properties.fontColor)), errors.collect(cdk.propertyValidator("fontDecoration", cdk.validateString)(properties.fontDecoration)), errors.collect(cdk.propertyValidator("fontSize", CfnAnalysis_FontSizePropertyValidator)(properties.fontSize)), errors.collect(cdk.propertyValidator("fontStyle", cdk.validateString)(properties.fontStyle)), errors.collect(cdk.propertyValidator("fontWeight", CfnAnalysis_FontWeightPropertyValidator)(properties.fontWeight)), errors.wrap('supplied properties not correct for "FontConfigurationProperty"');
    }
    function cfnAnalysisFontConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FontConfigurationPropertyValidator(properties).assertSuccess(), { FontColor: cdk.stringToCloudFormation(properties.fontColor), FontDecoration: cdk.stringToCloudFormation(properties.fontDecoration), FontSize: cfnAnalysisFontSizePropertyToCloudFormation(properties.fontSize), FontStyle: cdk.stringToCloudFormation(properties.fontStyle), FontWeight: cfnAnalysisFontWeightPropertyToCloudFormation(properties.fontWeight) }) : properties;
    }
    function CfnAnalysisFontConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fontColor", "FontColor", properties.FontColor != null ? cfn_parse.FromCloudFormation.getString(properties.FontColor) : void 0), ret.addPropertyResult("fontDecoration", "FontDecoration", properties.FontDecoration != null ? cfn_parse.FromCloudFormation.getString(properties.FontDecoration) : void 0), ret.addPropertyResult("fontSize", "FontSize", properties.FontSize != null ? CfnAnalysisFontSizePropertyFromCloudFormation(properties.FontSize) : void 0), ret.addPropertyResult("fontStyle", "FontStyle", properties.FontStyle != null ? cfn_parse.FromCloudFormation.getString(properties.FontStyle) : void 0), ret.addPropertyResult("fontWeight", "FontWeight", properties.FontWeight != null ? CfnAnalysisFontWeightPropertyFromCloudFormation(properties.FontWeight) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FontSizePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("relative", cdk.validateString)(properties.relative)), errors.wrap('supplied properties not correct for "FontSizeProperty"');
    }
    function cfnAnalysisFontSizePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FontSizePropertyValidator(properties).assertSuccess(), { Relative: cdk.stringToCloudFormation(properties.relative) }) : properties;
    }
    function CfnAnalysisFontSizePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("relative", "Relative", properties.Relative != null ? cfn_parse.FromCloudFormation.getString(properties.Relative) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FontWeightPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "FontWeightProperty"');
    }
    function cfnAnalysisFontWeightPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FontWeightPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnAnalysisFontWeightPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ForecastComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computationId", cdk.requiredValidator)(properties.computationId)), errors.collect(cdk.propertyValidator("computationId", cdk.validateString)(properties.computationId)), errors.collect(cdk.propertyValidator("customSeasonalityValue", cdk.validateNumber)(properties.customSeasonalityValue)), errors.collect(cdk.propertyValidator("lowerBoundary", cdk.validateNumber)(properties.lowerBoundary)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("periodsBackward", cdk.validateNumber)(properties.periodsBackward)), errors.collect(cdk.propertyValidator("periodsForward", cdk.validateNumber)(properties.periodsForward)), errors.collect(cdk.propertyValidator("predictionInterval", cdk.validateNumber)(properties.predictionInterval)), errors.collect(cdk.propertyValidator("seasonality", cdk.validateString)(properties.seasonality)), errors.collect(cdk.propertyValidator("time", cdk.requiredValidator)(properties.time)), errors.collect(cdk.propertyValidator("time", CfnAnalysis_DimensionFieldPropertyValidator)(properties.time)), errors.collect(cdk.propertyValidator("upperBoundary", cdk.validateNumber)(properties.upperBoundary)), errors.collect(cdk.propertyValidator("value", CfnAnalysis_MeasureFieldPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "ForecastComputationProperty"');
    }
    function cfnAnalysisForecastComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ForecastComputationPropertyValidator(properties).assertSuccess(), { ComputationId: cdk.stringToCloudFormation(properties.computationId), CustomSeasonalityValue: cdk.numberToCloudFormation(properties.customSeasonalityValue), LowerBoundary: cdk.numberToCloudFormation(properties.lowerBoundary), Name: cdk.stringToCloudFormation(properties.name), PeriodsBackward: cdk.numberToCloudFormation(properties.periodsBackward), PeriodsForward: cdk.numberToCloudFormation(properties.periodsForward), PredictionInterval: cdk.numberToCloudFormation(properties.predictionInterval), Seasonality: cdk.stringToCloudFormation(properties.seasonality), Time: cfnAnalysisDimensionFieldPropertyToCloudFormation(properties.time), UpperBoundary: cdk.numberToCloudFormation(properties.upperBoundary), Value: cfnAnalysisMeasureFieldPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnAnalysisForecastComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computationId", "ComputationId", cfn_parse.FromCloudFormation.getString(properties.ComputationId)), ret.addPropertyResult("customSeasonalityValue", "CustomSeasonalityValue", properties.CustomSeasonalityValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.CustomSeasonalityValue) : void 0), ret.addPropertyResult("lowerBoundary", "LowerBoundary", properties.LowerBoundary != null ? cfn_parse.FromCloudFormation.getNumber(properties.LowerBoundary) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("periodsBackward", "PeriodsBackward", properties.PeriodsBackward != null ? cfn_parse.FromCloudFormation.getNumber(properties.PeriodsBackward) : void 0), ret.addPropertyResult("periodsForward", "PeriodsForward", properties.PeriodsForward != null ? cfn_parse.FromCloudFormation.getNumber(properties.PeriodsForward) : void 0), ret.addPropertyResult("predictionInterval", "PredictionInterval", properties.PredictionInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.PredictionInterval) : void 0), ret.addPropertyResult("seasonality", "Seasonality", properties.Seasonality != null ? cfn_parse.FromCloudFormation.getString(properties.Seasonality) : void 0), ret.addPropertyResult("time", "Time", CfnAnalysisDimensionFieldPropertyFromCloudFormation(properties.Time)), ret.addPropertyResult("upperBoundary", "UpperBoundary", properties.UpperBoundary != null ? cfn_parse.FromCloudFormation.getNumber(properties.UpperBoundary) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? CfnAnalysisMeasureFieldPropertyFromCloudFormation(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ForecastConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("forecastProperties", CfnAnalysis_TimeBasedForecastPropertiesPropertyValidator)(properties.forecastProperties)), errors.collect(cdk.propertyValidator("scenario", CfnAnalysis_ForecastScenarioPropertyValidator)(properties.scenario)), errors.wrap('supplied properties not correct for "ForecastConfigurationProperty"');
    }
    function cfnAnalysisForecastConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ForecastConfigurationPropertyValidator(properties).assertSuccess(), { ForecastProperties: cfnAnalysisTimeBasedForecastPropertiesPropertyToCloudFormation(properties.forecastProperties), Scenario: cfnAnalysisForecastScenarioPropertyToCloudFormation(properties.scenario) }) : properties;
    }
    function CfnAnalysisForecastConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("forecastProperties", "ForecastProperties", properties.ForecastProperties != null ? CfnAnalysisTimeBasedForecastPropertiesPropertyFromCloudFormation(properties.ForecastProperties) : void 0), ret.addPropertyResult("scenario", "Scenario", properties.Scenario != null ? CfnAnalysisForecastScenarioPropertyFromCloudFormation(properties.Scenario) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ForecastScenarioPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("whatIfPointScenario", CfnAnalysis_WhatIfPointScenarioPropertyValidator)(properties.whatIfPointScenario)), errors.collect(cdk.propertyValidator("whatIfRangeScenario", CfnAnalysis_WhatIfRangeScenarioPropertyValidator)(properties.whatIfRangeScenario)), errors.wrap('supplied properties not correct for "ForecastScenarioProperty"');
    }
    function cfnAnalysisForecastScenarioPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ForecastScenarioPropertyValidator(properties).assertSuccess(), { WhatIfPointScenario: cfnAnalysisWhatIfPointScenarioPropertyToCloudFormation(properties.whatIfPointScenario), WhatIfRangeScenario: cfnAnalysisWhatIfRangeScenarioPropertyToCloudFormation(properties.whatIfRangeScenario) }) : properties;
    }
    function CfnAnalysisForecastScenarioPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("whatIfPointScenario", "WhatIfPointScenario", properties.WhatIfPointScenario != null ? CfnAnalysisWhatIfPointScenarioPropertyFromCloudFormation(properties.WhatIfPointScenario) : void 0), ret.addPropertyResult("whatIfRangeScenario", "WhatIfRangeScenario", properties.WhatIfRangeScenario != null ? CfnAnalysisWhatIfRangeScenarioPropertyFromCloudFormation(properties.WhatIfRangeScenario) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateTimeFormatConfiguration", CfnAnalysis_DateTimeFormatConfigurationPropertyValidator)(properties.dateTimeFormatConfiguration)), errors.collect(cdk.propertyValidator("numberFormatConfiguration", CfnAnalysis_NumberFormatConfigurationPropertyValidator)(properties.numberFormatConfiguration)), errors.collect(cdk.propertyValidator("stringFormatConfiguration", CfnAnalysis_StringFormatConfigurationPropertyValidator)(properties.stringFormatConfiguration)), errors.wrap('supplied properties not correct for "FormatConfigurationProperty"');
    }
    function cfnAnalysisFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FormatConfigurationPropertyValidator(properties).assertSuccess(), { DateTimeFormatConfiguration: cfnAnalysisDateTimeFormatConfigurationPropertyToCloudFormation(properties.dateTimeFormatConfiguration), NumberFormatConfiguration: cfnAnalysisNumberFormatConfigurationPropertyToCloudFormation(properties.numberFormatConfiguration), StringFormatConfiguration: cfnAnalysisStringFormatConfigurationPropertyToCloudFormation(properties.stringFormatConfiguration) }) : properties;
    }
    function CfnAnalysisFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateTimeFormatConfiguration", "DateTimeFormatConfiguration", properties.DateTimeFormatConfiguration != null ? CfnAnalysisDateTimeFormatConfigurationPropertyFromCloudFormation(properties.DateTimeFormatConfiguration) : void 0), ret.addPropertyResult("numberFormatConfiguration", "NumberFormatConfiguration", properties.NumberFormatConfiguration != null ? CfnAnalysisNumberFormatConfigurationPropertyFromCloudFormation(properties.NumberFormatConfiguration) : void 0), ret.addPropertyResult("stringFormatConfiguration", "StringFormatConfiguration", properties.StringFormatConfiguration != null ? CfnAnalysisStringFormatConfigurationPropertyFromCloudFormation(properties.StringFormatConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FreeFormLayoutCanvasSizeOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("screenCanvasSizeOptions", CfnAnalysis_FreeFormLayoutScreenCanvasSizeOptionsPropertyValidator)(properties.screenCanvasSizeOptions)), errors.wrap('supplied properties not correct for "FreeFormLayoutCanvasSizeOptionsProperty"');
    }
    function cfnAnalysisFreeFormLayoutCanvasSizeOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FreeFormLayoutCanvasSizeOptionsPropertyValidator(properties).assertSuccess(), { ScreenCanvasSizeOptions: cfnAnalysisFreeFormLayoutScreenCanvasSizeOptionsPropertyToCloudFormation(properties.screenCanvasSizeOptions) }) : properties;
    }
    function CfnAnalysisFreeFormLayoutCanvasSizeOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("screenCanvasSizeOptions", "ScreenCanvasSizeOptions", properties.ScreenCanvasSizeOptions != null ? CfnAnalysisFreeFormLayoutScreenCanvasSizeOptionsPropertyFromCloudFormation(properties.ScreenCanvasSizeOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FreeFormLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("canvasSizeOptions", CfnAnalysis_FreeFormLayoutCanvasSizeOptionsPropertyValidator)(properties.canvasSizeOptions)), errors.collect(cdk.propertyValidator("elements", cdk.requiredValidator)(properties.elements)), errors.collect(cdk.propertyValidator("elements", cdk.listValidator(CfnAnalysis_FreeFormLayoutElementPropertyValidator))(properties.elements)), errors.wrap('supplied properties not correct for "FreeFormLayoutConfigurationProperty"');
    }
    function cfnAnalysisFreeFormLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FreeFormLayoutConfigurationPropertyValidator(properties).assertSuccess(), { CanvasSizeOptions: cfnAnalysisFreeFormLayoutCanvasSizeOptionsPropertyToCloudFormation(properties.canvasSizeOptions), Elements: cdk.listMapper(cfnAnalysisFreeFormLayoutElementPropertyToCloudFormation)(properties.elements) }) : properties;
    }
    function CfnAnalysisFreeFormLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("canvasSizeOptions", "CanvasSizeOptions", properties.CanvasSizeOptions != null ? CfnAnalysisFreeFormLayoutCanvasSizeOptionsPropertyFromCloudFormation(properties.CanvasSizeOptions) : void 0), ret.addPropertyResult("elements", "Elements", cfn_parse.FromCloudFormation.getArray(CfnAnalysisFreeFormLayoutElementPropertyFromCloudFormation)(properties.Elements)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FreeFormLayoutElementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("backgroundStyle", CfnAnalysis_FreeFormLayoutElementBackgroundStylePropertyValidator)(properties.backgroundStyle)), errors.collect(cdk.propertyValidator("borderStyle", CfnAnalysis_FreeFormLayoutElementBorderStylePropertyValidator)(properties.borderStyle)), errors.collect(cdk.propertyValidator("elementId", cdk.requiredValidator)(properties.elementId)), errors.collect(cdk.propertyValidator("elementId", cdk.validateString)(properties.elementId)), errors.collect(cdk.propertyValidator("elementType", cdk.requiredValidator)(properties.elementType)), errors.collect(cdk.propertyValidator("elementType", cdk.validateString)(properties.elementType)), errors.collect(cdk.propertyValidator("height", cdk.requiredValidator)(properties.height)), errors.collect(cdk.propertyValidator("height", cdk.validateString)(properties.height)), errors.collect(cdk.propertyValidator("loadingAnimation", CfnAnalysis_LoadingAnimationPropertyValidator)(properties.loadingAnimation)), errors.collect(cdk.propertyValidator("renderingRules", cdk.listValidator(CfnAnalysis_SheetElementRenderingRulePropertyValidator))(properties.renderingRules)), errors.collect(cdk.propertyValidator("selectedBorderStyle", CfnAnalysis_FreeFormLayoutElementBorderStylePropertyValidator)(properties.selectedBorderStyle)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.collect(cdk.propertyValidator("width", cdk.requiredValidator)(properties.width)), errors.collect(cdk.propertyValidator("width", cdk.validateString)(properties.width)), errors.collect(cdk.propertyValidator("xAxisLocation", cdk.requiredValidator)(properties.xAxisLocation)), errors.collect(cdk.propertyValidator("xAxisLocation", cdk.validateString)(properties.xAxisLocation)), errors.collect(cdk.propertyValidator("yAxisLocation", cdk.requiredValidator)(properties.yAxisLocation)), errors.collect(cdk.propertyValidator("yAxisLocation", cdk.validateString)(properties.yAxisLocation)), errors.wrap('supplied properties not correct for "FreeFormLayoutElementProperty"');
    }
    function cfnAnalysisFreeFormLayoutElementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FreeFormLayoutElementPropertyValidator(properties).assertSuccess(), { BackgroundStyle: cfnAnalysisFreeFormLayoutElementBackgroundStylePropertyToCloudFormation(properties.backgroundStyle), BorderStyle: cfnAnalysisFreeFormLayoutElementBorderStylePropertyToCloudFormation(properties.borderStyle), ElementId: cdk.stringToCloudFormation(properties.elementId), ElementType: cdk.stringToCloudFormation(properties.elementType), Height: cdk.stringToCloudFormation(properties.height), LoadingAnimation: cfnAnalysisLoadingAnimationPropertyToCloudFormation(properties.loadingAnimation), RenderingRules: cdk.listMapper(cfnAnalysisSheetElementRenderingRulePropertyToCloudFormation)(properties.renderingRules), SelectedBorderStyle: cfnAnalysisFreeFormLayoutElementBorderStylePropertyToCloudFormation(properties.selectedBorderStyle), Visibility: cdk.stringToCloudFormation(properties.visibility), Width: cdk.stringToCloudFormation(properties.width), XAxisLocation: cdk.stringToCloudFormation(properties.xAxisLocation), YAxisLocation: cdk.stringToCloudFormation(properties.yAxisLocation) }) : properties;
    }
    function CfnAnalysisFreeFormLayoutElementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("backgroundStyle", "BackgroundStyle", properties.BackgroundStyle != null ? CfnAnalysisFreeFormLayoutElementBackgroundStylePropertyFromCloudFormation(properties.BackgroundStyle) : void 0), ret.addPropertyResult("borderStyle", "BorderStyle", properties.BorderStyle != null ? CfnAnalysisFreeFormLayoutElementBorderStylePropertyFromCloudFormation(properties.BorderStyle) : void 0), ret.addPropertyResult("elementId", "ElementId", cfn_parse.FromCloudFormation.getString(properties.ElementId)), ret.addPropertyResult("elementType", "ElementType", cfn_parse.FromCloudFormation.getString(properties.ElementType)), ret.addPropertyResult("height", "Height", cfn_parse.FromCloudFormation.getString(properties.Height)), ret.addPropertyResult("loadingAnimation", "LoadingAnimation", properties.LoadingAnimation != null ? CfnAnalysisLoadingAnimationPropertyFromCloudFormation(properties.LoadingAnimation) : void 0), ret.addPropertyResult("renderingRules", "RenderingRules", properties.RenderingRules != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisSheetElementRenderingRulePropertyFromCloudFormation)(properties.RenderingRules) : void 0), ret.addPropertyResult("selectedBorderStyle", "SelectedBorderStyle", properties.SelectedBorderStyle != null ? CfnAnalysisFreeFormLayoutElementBorderStylePropertyFromCloudFormation(properties.SelectedBorderStyle) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addPropertyResult("width", "Width", cfn_parse.FromCloudFormation.getString(properties.Width)), ret.addPropertyResult("xAxisLocation", "XAxisLocation", cfn_parse.FromCloudFormation.getString(properties.XAxisLocation)), ret.addPropertyResult("yAxisLocation", "YAxisLocation", cfn_parse.FromCloudFormation.getString(properties.YAxisLocation)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FreeFormLayoutElementBackgroundStylePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "FreeFormLayoutElementBackgroundStyleProperty"');
    }
    function cfnAnalysisFreeFormLayoutElementBackgroundStylePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FreeFormLayoutElementBackgroundStylePropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnAnalysisFreeFormLayoutElementBackgroundStylePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", properties.Color != null ? cfn_parse.FromCloudFormation.getString(properties.Color) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FreeFormLayoutElementBorderStylePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "FreeFormLayoutElementBorderStyleProperty"');
    }
    function cfnAnalysisFreeFormLayoutElementBorderStylePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FreeFormLayoutElementBorderStylePropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnAnalysisFreeFormLayoutElementBorderStylePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", properties.Color != null ? cfn_parse.FromCloudFormation.getString(properties.Color) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FreeFormLayoutScreenCanvasSizeOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("optimizedViewPortWidth", cdk.requiredValidator)(properties.optimizedViewPortWidth)), errors.collect(cdk.propertyValidator("optimizedViewPortWidth", cdk.validateString)(properties.optimizedViewPortWidth)), errors.wrap('supplied properties not correct for "FreeFormLayoutScreenCanvasSizeOptionsProperty"');
    }
    function cfnAnalysisFreeFormLayoutScreenCanvasSizeOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FreeFormLayoutScreenCanvasSizeOptionsPropertyValidator(properties).assertSuccess(), { OptimizedViewPortWidth: cdk.stringToCloudFormation(properties.optimizedViewPortWidth) }) : properties;
    }
    function CfnAnalysisFreeFormLayoutScreenCanvasSizeOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("optimizedViewPortWidth", "OptimizedViewPortWidth", cfn_parse.FromCloudFormation.getString(properties.OptimizedViewPortWidth)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FreeFormSectionLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("elements", cdk.requiredValidator)(properties.elements)), errors.collect(cdk.propertyValidator("elements", cdk.listValidator(CfnAnalysis_FreeFormLayoutElementPropertyValidator))(properties.elements)), errors.wrap('supplied properties not correct for "FreeFormSectionLayoutConfigurationProperty"');
    }
    function cfnAnalysisFreeFormSectionLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FreeFormSectionLayoutConfigurationPropertyValidator(properties).assertSuccess(), { Elements: cdk.listMapper(cfnAnalysisFreeFormLayoutElementPropertyToCloudFormation)(properties.elements) }) : properties;
    }
    function CfnAnalysisFreeFormSectionLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("elements", "Elements", cfn_parse.FromCloudFormation.getArray(CfnAnalysisFreeFormLayoutElementPropertyFromCloudFormation)(properties.Elements)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FunnelChartAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("category", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.category)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnAnalysis_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "FunnelChartAggregatedFieldWellsProperty"');
    }
    function cfnAnalysisFunnelChartAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FunnelChartAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Category: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.category), Values: cdk.listMapper(cfnAnalysisMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnAnalysisFunnelChartAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("category", "Category", properties.Category != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.Category) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FunnelChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryLabelOptions", CfnAnalysis_ChartAxisLabelOptionsPropertyValidator)(properties.categoryLabelOptions)), errors.collect(cdk.propertyValidator("dataLabelOptions", CfnAnalysis_FunnelChartDataLabelOptionsPropertyValidator)(properties.dataLabelOptions)), errors.collect(cdk.propertyValidator("fieldWells", CfnAnalysis_FunnelChartFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnAnalysis_FunnelChartSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tooltip", CfnAnalysis_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.collect(cdk.propertyValidator("valueLabelOptions", CfnAnalysis_ChartAxisLabelOptionsPropertyValidator)(properties.valueLabelOptions)), errors.collect(cdk.propertyValidator("visualPalette", CfnAnalysis_VisualPalettePropertyValidator)(properties.visualPalette)), errors.wrap('supplied properties not correct for "FunnelChartConfigurationProperty"');
    }
    function cfnAnalysisFunnelChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FunnelChartConfigurationPropertyValidator(properties).assertSuccess(), { CategoryLabelOptions: cfnAnalysisChartAxisLabelOptionsPropertyToCloudFormation(properties.categoryLabelOptions), DataLabelOptions: cfnAnalysisFunnelChartDataLabelOptionsPropertyToCloudFormation(properties.dataLabelOptions), FieldWells: cfnAnalysisFunnelChartFieldWellsPropertyToCloudFormation(properties.fieldWells), SortConfiguration: cfnAnalysisFunnelChartSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), Tooltip: cfnAnalysisTooltipOptionsPropertyToCloudFormation(properties.tooltip), ValueLabelOptions: cfnAnalysisChartAxisLabelOptionsPropertyToCloudFormation(properties.valueLabelOptions), VisualPalette: cfnAnalysisVisualPalettePropertyToCloudFormation(properties.visualPalette) }) : properties;
    }
    function CfnAnalysisFunnelChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryLabelOptions", "CategoryLabelOptions", properties.CategoryLabelOptions != null ? CfnAnalysisChartAxisLabelOptionsPropertyFromCloudFormation(properties.CategoryLabelOptions) : void 0), ret.addPropertyResult("dataLabelOptions", "DataLabelOptions", properties.DataLabelOptions != null ? CfnAnalysisFunnelChartDataLabelOptionsPropertyFromCloudFormation(properties.DataLabelOptions) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnAnalysisFunnelChartFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnAnalysisFunnelChartSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnAnalysisTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addPropertyResult("valueLabelOptions", "ValueLabelOptions", properties.ValueLabelOptions != null ? CfnAnalysisChartAxisLabelOptionsPropertyFromCloudFormation(properties.ValueLabelOptions) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnAnalysisVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FunnelChartDataLabelOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryLabelVisibility", cdk.validateString)(properties.categoryLabelVisibility)), errors.collect(cdk.propertyValidator("labelColor", cdk.validateString)(properties.labelColor)), errors.collect(cdk.propertyValidator("labelFontConfiguration", CfnAnalysis_FontConfigurationPropertyValidator)(properties.labelFontConfiguration)), errors.collect(cdk.propertyValidator("measureDataLabelStyle", cdk.validateString)(properties.measureDataLabelStyle)), errors.collect(cdk.propertyValidator("measureLabelVisibility", cdk.validateString)(properties.measureLabelVisibility)), errors.collect(cdk.propertyValidator("position", cdk.validateString)(properties.position)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "FunnelChartDataLabelOptionsProperty"');
    }
    function cfnAnalysisFunnelChartDataLabelOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FunnelChartDataLabelOptionsPropertyValidator(properties).assertSuccess(), { CategoryLabelVisibility: cdk.stringToCloudFormation(properties.categoryLabelVisibility), LabelColor: cdk.stringToCloudFormation(properties.labelColor), LabelFontConfiguration: cfnAnalysisFontConfigurationPropertyToCloudFormation(properties.labelFontConfiguration), MeasureDataLabelStyle: cdk.stringToCloudFormation(properties.measureDataLabelStyle), MeasureLabelVisibility: cdk.stringToCloudFormation(properties.measureLabelVisibility), Position: cdk.stringToCloudFormation(properties.position), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnAnalysisFunnelChartDataLabelOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryLabelVisibility", "CategoryLabelVisibility", properties.CategoryLabelVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.CategoryLabelVisibility) : void 0), ret.addPropertyResult("labelColor", "LabelColor", properties.LabelColor != null ? cfn_parse.FromCloudFormation.getString(properties.LabelColor) : void 0), ret.addPropertyResult("labelFontConfiguration", "LabelFontConfiguration", properties.LabelFontConfiguration != null ? CfnAnalysisFontConfigurationPropertyFromCloudFormation(properties.LabelFontConfiguration) : void 0), ret.addPropertyResult("measureDataLabelStyle", "MeasureDataLabelStyle", properties.MeasureDataLabelStyle != null ? cfn_parse.FromCloudFormation.getString(properties.MeasureDataLabelStyle) : void 0), ret.addPropertyResult("measureLabelVisibility", "MeasureLabelVisibility", properties.MeasureLabelVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.MeasureLabelVisibility) : void 0), ret.addPropertyResult("position", "Position", properties.Position != null ? cfn_parse.FromCloudFormation.getString(properties.Position) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FunnelChartFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("funnelChartAggregatedFieldWells", CfnAnalysis_FunnelChartAggregatedFieldWellsPropertyValidator)(properties.funnelChartAggregatedFieldWells)), errors.wrap('supplied properties not correct for "FunnelChartFieldWellsProperty"');
    }
    function cfnAnalysisFunnelChartFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FunnelChartFieldWellsPropertyValidator(properties).assertSuccess(), { FunnelChartAggregatedFieldWells: cfnAnalysisFunnelChartAggregatedFieldWellsPropertyToCloudFormation(properties.funnelChartAggregatedFieldWells) }) : properties;
    }
    function CfnAnalysisFunnelChartFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("funnelChartAggregatedFieldWells", "FunnelChartAggregatedFieldWells", properties.FunnelChartAggregatedFieldWells != null ? CfnAnalysisFunnelChartAggregatedFieldWellsPropertyFromCloudFormation(properties.FunnelChartAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FunnelChartSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryItemsLimit", CfnAnalysis_ItemsLimitConfigurationPropertyValidator)(properties.categoryItemsLimit)), errors.collect(cdk.propertyValidator("categorySort", cdk.listValidator(CfnAnalysis_FieldSortOptionsPropertyValidator))(properties.categorySort)), errors.wrap('supplied properties not correct for "FunnelChartSortConfigurationProperty"');
    }
    function cfnAnalysisFunnelChartSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FunnelChartSortConfigurationPropertyValidator(properties).assertSuccess(), { CategoryItemsLimit: cfnAnalysisItemsLimitConfigurationPropertyToCloudFormation(properties.categoryItemsLimit), CategorySort: cdk.listMapper(cfnAnalysisFieldSortOptionsPropertyToCloudFormation)(properties.categorySort) }) : properties;
    }
    function CfnAnalysisFunnelChartSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryItemsLimit", "CategoryItemsLimit", properties.CategoryItemsLimit != null ? CfnAnalysisItemsLimitConfigurationPropertyFromCloudFormation(properties.CategoryItemsLimit) : void 0), ret.addPropertyResult("categorySort", "CategorySort", properties.CategorySort != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisFieldSortOptionsPropertyFromCloudFormation)(properties.CategorySort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_FunnelChartVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnAnalysis_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnAnalysis_FunnelChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnAnalysis_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnAnalysis_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnAnalysis_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "FunnelChartVisualProperty"');
    }
    function cfnAnalysisFunnelChartVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_FunnelChartVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnAnalysisVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnAnalysisFunnelChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnAnalysisColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnAnalysisVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnAnalysisVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnAnalysisFunnelChartVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnAnalysisFunnelChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnAnalysisVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnAnalysisVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_GaugeChartArcConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("foregroundColor", CfnAnalysis_ConditionalFormattingColorPropertyValidator)(properties.foregroundColor)), errors.wrap('supplied properties not correct for "GaugeChartArcConditionalFormattingProperty"');
    }
    function cfnAnalysisGaugeChartArcConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_GaugeChartArcConditionalFormattingPropertyValidator(properties).assertSuccess(), { ForegroundColor: cfnAnalysisConditionalFormattingColorPropertyToCloudFormation(properties.foregroundColor) }) : properties;
    }
    function CfnAnalysisGaugeChartArcConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("foregroundColor", "ForegroundColor", properties.ForegroundColor != null ? CfnAnalysisConditionalFormattingColorPropertyFromCloudFormation(properties.ForegroundColor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_GaugeChartConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("conditionalFormattingOptions", cdk.listValidator(CfnAnalysis_GaugeChartConditionalFormattingOptionPropertyValidator))(properties.conditionalFormattingOptions)), errors.wrap('supplied properties not correct for "GaugeChartConditionalFormattingProperty"');
    }
    function cfnAnalysisGaugeChartConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_GaugeChartConditionalFormattingPropertyValidator(properties).assertSuccess(), { ConditionalFormattingOptions: cdk.listMapper(cfnAnalysisGaugeChartConditionalFormattingOptionPropertyToCloudFormation)(properties.conditionalFormattingOptions) }) : properties;
    }
    function CfnAnalysisGaugeChartConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("conditionalFormattingOptions", "ConditionalFormattingOptions", properties.ConditionalFormattingOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisGaugeChartConditionalFormattingOptionPropertyFromCloudFormation)(properties.ConditionalFormattingOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_GaugeChartConditionalFormattingOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arc", CfnAnalysis_GaugeChartArcConditionalFormattingPropertyValidator)(properties.arc)), errors.collect(cdk.propertyValidator("primaryValue", CfnAnalysis_GaugeChartPrimaryValueConditionalFormattingPropertyValidator)(properties.primaryValue)), errors.wrap('supplied properties not correct for "GaugeChartConditionalFormattingOptionProperty"');
    }
    function cfnAnalysisGaugeChartConditionalFormattingOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_GaugeChartConditionalFormattingOptionPropertyValidator(properties).assertSuccess(), { Arc: cfnAnalysisGaugeChartArcConditionalFormattingPropertyToCloudFormation(properties.arc), PrimaryValue: cfnAnalysisGaugeChartPrimaryValueConditionalFormattingPropertyToCloudFormation(properties.primaryValue) }) : properties;
    }
    function CfnAnalysisGaugeChartConditionalFormattingOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arc", "Arc", properties.Arc != null ? CfnAnalysisGaugeChartArcConditionalFormattingPropertyFromCloudFormation(properties.Arc) : void 0), ret.addPropertyResult("primaryValue", "PrimaryValue", properties.PrimaryValue != null ? CfnAnalysisGaugeChartPrimaryValueConditionalFormattingPropertyFromCloudFormation(properties.PrimaryValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_GaugeChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataLabels", CfnAnalysis_DataLabelOptionsPropertyValidator)(properties.dataLabels)), errors.collect(cdk.propertyValidator("fieldWells", CfnAnalysis_GaugeChartFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("gaugeChartOptions", CfnAnalysis_GaugeChartOptionsPropertyValidator)(properties.gaugeChartOptions)), errors.collect(cdk.propertyValidator("tooltipOptions", CfnAnalysis_TooltipOptionsPropertyValidator)(properties.tooltipOptions)), errors.collect(cdk.propertyValidator("visualPalette", CfnAnalysis_VisualPalettePropertyValidator)(properties.visualPalette)), errors.wrap('supplied properties not correct for "GaugeChartConfigurationProperty"');
    }
    function cfnAnalysisGaugeChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_GaugeChartConfigurationPropertyValidator(properties).assertSuccess(), { DataLabels: cfnAnalysisDataLabelOptionsPropertyToCloudFormation(properties.dataLabels), FieldWells: cfnAnalysisGaugeChartFieldWellsPropertyToCloudFormation(properties.fieldWells), GaugeChartOptions: cfnAnalysisGaugeChartOptionsPropertyToCloudFormation(properties.gaugeChartOptions), TooltipOptions: cfnAnalysisTooltipOptionsPropertyToCloudFormation(properties.tooltipOptions), VisualPalette: cfnAnalysisVisualPalettePropertyToCloudFormation(properties.visualPalette) }) : properties;
    }
    function CfnAnalysisGaugeChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataLabels", "DataLabels", properties.DataLabels != null ? CfnAnalysisDataLabelOptionsPropertyFromCloudFormation(properties.DataLabels) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnAnalysisGaugeChartFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("gaugeChartOptions", "GaugeChartOptions", properties.GaugeChartOptions != null ? CfnAnalysisGaugeChartOptionsPropertyFromCloudFormation(properties.GaugeChartOptions) : void 0), ret.addPropertyResult("tooltipOptions", "TooltipOptions", properties.TooltipOptions != null ? CfnAnalysisTooltipOptionsPropertyFromCloudFormation(properties.TooltipOptions) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnAnalysisVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_GaugeChartFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("targetValues", cdk.listValidator(CfnAnalysis_MeasureFieldPropertyValidator))(properties.targetValues)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnAnalysis_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "GaugeChartFieldWellsProperty"');
    }
    function cfnAnalysisGaugeChartFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_GaugeChartFieldWellsPropertyValidator(properties).assertSuccess(), { TargetValues: cdk.listMapper(cfnAnalysisMeasureFieldPropertyToCloudFormation)(properties.targetValues), Values: cdk.listMapper(cfnAnalysisMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnAnalysisGaugeChartFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("targetValues", "TargetValues", properties.TargetValues != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMeasureFieldPropertyFromCloudFormation)(properties.TargetValues) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_GaugeChartOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arc", CfnAnalysis_ArcConfigurationPropertyValidator)(properties.arc)), errors.collect(cdk.propertyValidator("arcAxis", CfnAnalysis_ArcAxisConfigurationPropertyValidator)(properties.arcAxis)), errors.collect(cdk.propertyValidator("comparison", CfnAnalysis_ComparisonConfigurationPropertyValidator)(properties.comparison)), errors.collect(cdk.propertyValidator("primaryValueDisplayType", cdk.validateString)(properties.primaryValueDisplayType)), errors.collect(cdk.propertyValidator("primaryValueFontConfiguration", CfnAnalysis_FontConfigurationPropertyValidator)(properties.primaryValueFontConfiguration)), errors.wrap('supplied properties not correct for "GaugeChartOptionsProperty"');
    }
    function cfnAnalysisGaugeChartOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_GaugeChartOptionsPropertyValidator(properties).assertSuccess(), { Arc: cfnAnalysisArcConfigurationPropertyToCloudFormation(properties.arc), ArcAxis: cfnAnalysisArcAxisConfigurationPropertyToCloudFormation(properties.arcAxis), Comparison: cfnAnalysisComparisonConfigurationPropertyToCloudFormation(properties.comparison), PrimaryValueDisplayType: cdk.stringToCloudFormation(properties.primaryValueDisplayType), PrimaryValueFontConfiguration: cfnAnalysisFontConfigurationPropertyToCloudFormation(properties.primaryValueFontConfiguration) }) : properties;
    }
    function CfnAnalysisGaugeChartOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arc", "Arc", properties.Arc != null ? CfnAnalysisArcConfigurationPropertyFromCloudFormation(properties.Arc) : void 0), ret.addPropertyResult("arcAxis", "ArcAxis", properties.ArcAxis != null ? CfnAnalysisArcAxisConfigurationPropertyFromCloudFormation(properties.ArcAxis) : void 0), ret.addPropertyResult("comparison", "Comparison", properties.Comparison != null ? CfnAnalysisComparisonConfigurationPropertyFromCloudFormation(properties.Comparison) : void 0), ret.addPropertyResult("primaryValueDisplayType", "PrimaryValueDisplayType", properties.PrimaryValueDisplayType != null ? cfn_parse.FromCloudFormation.getString(properties.PrimaryValueDisplayType) : void 0), ret.addPropertyResult("primaryValueFontConfiguration", "PrimaryValueFontConfiguration", properties.PrimaryValueFontConfiguration != null ? CfnAnalysisFontConfigurationPropertyFromCloudFormation(properties.PrimaryValueFontConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_GaugeChartPrimaryValueConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("icon", CfnAnalysis_ConditionalFormattingIconPropertyValidator)(properties.icon)), errors.collect(cdk.propertyValidator("textColor", CfnAnalysis_ConditionalFormattingColorPropertyValidator)(properties.textColor)), errors.wrap('supplied properties not correct for "GaugeChartPrimaryValueConditionalFormattingProperty"');
    }
    function cfnAnalysisGaugeChartPrimaryValueConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_GaugeChartPrimaryValueConditionalFormattingPropertyValidator(properties).assertSuccess(), { Icon: cfnAnalysisConditionalFormattingIconPropertyToCloudFormation(properties.icon), TextColor: cfnAnalysisConditionalFormattingColorPropertyToCloudFormation(properties.textColor) }) : properties;
    }
    function CfnAnalysisGaugeChartPrimaryValueConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("icon", "Icon", properties.Icon != null ? CfnAnalysisConditionalFormattingIconPropertyFromCloudFormation(properties.Icon) : void 0), ret.addPropertyResult("textColor", "TextColor", properties.TextColor != null ? CfnAnalysisConditionalFormattingColorPropertyFromCloudFormation(properties.TextColor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_GaugeChartVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnAnalysis_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnAnalysis_GaugeChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("conditionalFormatting", CfnAnalysis_GaugeChartConditionalFormattingPropertyValidator)(properties.conditionalFormatting)), errors.collect(cdk.propertyValidator("subtitle", CfnAnalysis_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnAnalysis_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "GaugeChartVisualProperty"');
    }
    function cfnAnalysisGaugeChartVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_GaugeChartVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnAnalysisVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnAnalysisGaugeChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), ConditionalFormatting: cfnAnalysisGaugeChartConditionalFormattingPropertyToCloudFormation(properties.conditionalFormatting), Subtitle: cfnAnalysisVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnAnalysisVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnAnalysisGaugeChartVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnAnalysisGaugeChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("conditionalFormatting", "ConditionalFormatting", properties.ConditionalFormatting != null ? CfnAnalysisGaugeChartConditionalFormattingPropertyFromCloudFormation(properties.ConditionalFormatting) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnAnalysisVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnAnalysisVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_GeospatialCoordinateBoundsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("east", cdk.requiredValidator)(properties.east)), errors.collect(cdk.propertyValidator("east", cdk.validateNumber)(properties.east)), errors.collect(cdk.propertyValidator("north", cdk.requiredValidator)(properties.north)), errors.collect(cdk.propertyValidator("north", cdk.validateNumber)(properties.north)), errors.collect(cdk.propertyValidator("south", cdk.requiredValidator)(properties.south)), errors.collect(cdk.propertyValidator("south", cdk.validateNumber)(properties.south)), errors.collect(cdk.propertyValidator("west", cdk.requiredValidator)(properties.west)), errors.collect(cdk.propertyValidator("west", cdk.validateNumber)(properties.west)), errors.wrap('supplied properties not correct for "GeospatialCoordinateBoundsProperty"');
    }
    function cfnAnalysisGeospatialCoordinateBoundsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_GeospatialCoordinateBoundsPropertyValidator(properties).assertSuccess(), { East: cdk.numberToCloudFormation(properties.east), North: cdk.numberToCloudFormation(properties.north), South: cdk.numberToCloudFormation(properties.south), West: cdk.numberToCloudFormation(properties.west) }) : properties;
    }
    function CfnAnalysisGeospatialCoordinateBoundsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("east", "East", cfn_parse.FromCloudFormation.getNumber(properties.East)), ret.addPropertyResult("north", "North", cfn_parse.FromCloudFormation.getNumber(properties.North)), ret.addPropertyResult("south", "South", cfn_parse.FromCloudFormation.getNumber(properties.South)), ret.addPropertyResult("west", "West", cfn_parse.FromCloudFormation.getNumber(properties.West)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_GeospatialMapAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("colors", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.colors)), errors.collect(cdk.propertyValidator("geospatial", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.geospatial)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnAnalysis_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "GeospatialMapAggregatedFieldWellsProperty"');
    }
    function cfnAnalysisGeospatialMapAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_GeospatialMapAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Colors: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.colors), Geospatial: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.geospatial), Values: cdk.listMapper(cfnAnalysisMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnAnalysisGeospatialMapAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("colors", "Colors", properties.Colors != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.Colors) : void 0), ret.addPropertyResult("geospatial", "Geospatial", properties.Geospatial != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.Geospatial) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_GeospatialMapConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldWells", CfnAnalysis_GeospatialMapFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("legend", CfnAnalysis_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("mapStyleOptions", CfnAnalysis_GeospatialMapStyleOptionsPropertyValidator)(properties.mapStyleOptions)), errors.collect(cdk.propertyValidator("pointStyleOptions", CfnAnalysis_GeospatialPointStyleOptionsPropertyValidator)(properties.pointStyleOptions)), errors.collect(cdk.propertyValidator("tooltip", CfnAnalysis_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.collect(cdk.propertyValidator("visualPalette", CfnAnalysis_VisualPalettePropertyValidator)(properties.visualPalette)), errors.collect(cdk.propertyValidator("windowOptions", CfnAnalysis_GeospatialWindowOptionsPropertyValidator)(properties.windowOptions)), errors.wrap('supplied properties not correct for "GeospatialMapConfigurationProperty"');
    }
    function cfnAnalysisGeospatialMapConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_GeospatialMapConfigurationPropertyValidator(properties).assertSuccess(), { FieldWells: cfnAnalysisGeospatialMapFieldWellsPropertyToCloudFormation(properties.fieldWells), Legend: cfnAnalysisLegendOptionsPropertyToCloudFormation(properties.legend), MapStyleOptions: cfnAnalysisGeospatialMapStyleOptionsPropertyToCloudFormation(properties.mapStyleOptions), PointStyleOptions: cfnAnalysisGeospatialPointStyleOptionsPropertyToCloudFormation(properties.pointStyleOptions), Tooltip: cfnAnalysisTooltipOptionsPropertyToCloudFormation(properties.tooltip), VisualPalette: cfnAnalysisVisualPalettePropertyToCloudFormation(properties.visualPalette), WindowOptions: cfnAnalysisGeospatialWindowOptionsPropertyToCloudFormation(properties.windowOptions) }) : properties;
    }
    function CfnAnalysisGeospatialMapConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnAnalysisGeospatialMapFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnAnalysisLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("mapStyleOptions", "MapStyleOptions", properties.MapStyleOptions != null ? CfnAnalysisGeospatialMapStyleOptionsPropertyFromCloudFormation(properties.MapStyleOptions) : void 0), ret.addPropertyResult("pointStyleOptions", "PointStyleOptions", properties.PointStyleOptions != null ? CfnAnalysisGeospatialPointStyleOptionsPropertyFromCloudFormation(properties.PointStyleOptions) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnAnalysisTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnAnalysisVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addPropertyResult("windowOptions", "WindowOptions", properties.WindowOptions != null ? CfnAnalysisGeospatialWindowOptionsPropertyFromCloudFormation(properties.WindowOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_GeospatialMapFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("geospatialMapAggregatedFieldWells", CfnAnalysis_GeospatialMapAggregatedFieldWellsPropertyValidator)(properties.geospatialMapAggregatedFieldWells)), errors.wrap('supplied properties not correct for "GeospatialMapFieldWellsProperty"');
    }
    function cfnAnalysisGeospatialMapFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_GeospatialMapFieldWellsPropertyValidator(properties).assertSuccess(), { GeospatialMapAggregatedFieldWells: cfnAnalysisGeospatialMapAggregatedFieldWellsPropertyToCloudFormation(properties.geospatialMapAggregatedFieldWells) }) : properties;
    }
    function CfnAnalysisGeospatialMapFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("geospatialMapAggregatedFieldWells", "GeospatialMapAggregatedFieldWells", properties.GeospatialMapAggregatedFieldWells != null ? CfnAnalysisGeospatialMapAggregatedFieldWellsPropertyFromCloudFormation(properties.GeospatialMapAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_GeospatialMapStyleOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("baseMapStyle", cdk.validateString)(properties.baseMapStyle)), errors.wrap('supplied properties not correct for "GeospatialMapStyleOptionsProperty"');
    }
    function cfnAnalysisGeospatialMapStyleOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_GeospatialMapStyleOptionsPropertyValidator(properties).assertSuccess(), { BaseMapStyle: cdk.stringToCloudFormation(properties.baseMapStyle) }) : properties;
    }
    function CfnAnalysisGeospatialMapStyleOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("baseMapStyle", "BaseMapStyle", properties.BaseMapStyle != null ? cfn_parse.FromCloudFormation.getString(properties.BaseMapStyle) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_GeospatialMapVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnAnalysis_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnAnalysis_GeospatialMapConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnAnalysis_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnAnalysis_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnAnalysis_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "GeospatialMapVisualProperty"');
    }
    function cfnAnalysisGeospatialMapVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_GeospatialMapVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnAnalysisVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnAnalysisGeospatialMapConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnAnalysisColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnAnalysisVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnAnalysisVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnAnalysisGeospatialMapVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnAnalysisGeospatialMapConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnAnalysisVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnAnalysisVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_GeospatialPointStyleOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clusterMarkerConfiguration", CfnAnalysis_ClusterMarkerConfigurationPropertyValidator)(properties.clusterMarkerConfiguration)), errors.collect(cdk.propertyValidator("selectedPointStyle", cdk.validateString)(properties.selectedPointStyle)), errors.wrap('supplied properties not correct for "GeospatialPointStyleOptionsProperty"');
    }
    function cfnAnalysisGeospatialPointStyleOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_GeospatialPointStyleOptionsPropertyValidator(properties).assertSuccess(), { ClusterMarkerConfiguration: cfnAnalysisClusterMarkerConfigurationPropertyToCloudFormation(properties.clusterMarkerConfiguration), SelectedPointStyle: cdk.stringToCloudFormation(properties.selectedPointStyle) }) : properties;
    }
    function CfnAnalysisGeospatialPointStyleOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clusterMarkerConfiguration", "ClusterMarkerConfiguration", properties.ClusterMarkerConfiguration != null ? CfnAnalysisClusterMarkerConfigurationPropertyFromCloudFormation(properties.ClusterMarkerConfiguration) : void 0), ret.addPropertyResult("selectedPointStyle", "SelectedPointStyle", properties.SelectedPointStyle != null ? cfn_parse.FromCloudFormation.getString(properties.SelectedPointStyle) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_GeospatialWindowOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bounds", CfnAnalysis_GeospatialCoordinateBoundsPropertyValidator)(properties.bounds)), errors.collect(cdk.propertyValidator("mapZoomMode", cdk.validateString)(properties.mapZoomMode)), errors.wrap('supplied properties not correct for "GeospatialWindowOptionsProperty"');
    }
    function cfnAnalysisGeospatialWindowOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_GeospatialWindowOptionsPropertyValidator(properties).assertSuccess(), { Bounds: cfnAnalysisGeospatialCoordinateBoundsPropertyToCloudFormation(properties.bounds), MapZoomMode: cdk.stringToCloudFormation(properties.mapZoomMode) }) : properties;
    }
    function CfnAnalysisGeospatialWindowOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bounds", "Bounds", properties.Bounds != null ? CfnAnalysisGeospatialCoordinateBoundsPropertyFromCloudFormation(properties.Bounds) : void 0), ret.addPropertyResult("mapZoomMode", "MapZoomMode", properties.MapZoomMode != null ? cfn_parse.FromCloudFormation.getString(properties.MapZoomMode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_GlobalTableBorderOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sideSpecificBorder", CfnAnalysis_TableSideBorderOptionsPropertyValidator)(properties.sideSpecificBorder)), errors.collect(cdk.propertyValidator("uniformBorder", CfnAnalysis_TableBorderOptionsPropertyValidator)(properties.uniformBorder)), errors.wrap('supplied properties not correct for "GlobalTableBorderOptionsProperty"');
    }
    function cfnAnalysisGlobalTableBorderOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_GlobalTableBorderOptionsPropertyValidator(properties).assertSuccess(), { SideSpecificBorder: cfnAnalysisTableSideBorderOptionsPropertyToCloudFormation(properties.sideSpecificBorder), UniformBorder: cfnAnalysisTableBorderOptionsPropertyToCloudFormation(properties.uniformBorder) }) : properties;
    }
    function CfnAnalysisGlobalTableBorderOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sideSpecificBorder", "SideSpecificBorder", properties.SideSpecificBorder != null ? CfnAnalysisTableSideBorderOptionsPropertyFromCloudFormation(properties.SideSpecificBorder) : void 0), ret.addPropertyResult("uniformBorder", "UniformBorder", properties.UniformBorder != null ? CfnAnalysisTableBorderOptionsPropertyFromCloudFormation(properties.UniformBorder) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_GradientColorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("stops", cdk.listValidator(CfnAnalysis_GradientStopPropertyValidator))(properties.stops)), errors.wrap('supplied properties not correct for "GradientColorProperty"');
    }
    function cfnAnalysisGradientColorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_GradientColorPropertyValidator(properties).assertSuccess(), { Stops: cdk.listMapper(cfnAnalysisGradientStopPropertyToCloudFormation)(properties.stops) }) : properties;
    }
    function CfnAnalysisGradientColorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("stops", "Stops", properties.Stops != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisGradientStopPropertyFromCloudFormation)(properties.Stops) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_GradientStopPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.collect(cdk.propertyValidator("dataValue", cdk.validateNumber)(properties.dataValue)), errors.collect(cdk.propertyValidator("gradientOffset", cdk.requiredValidator)(properties.gradientOffset)), errors.collect(cdk.propertyValidator("gradientOffset", cdk.validateNumber)(properties.gradientOffset)), errors.wrap('supplied properties not correct for "GradientStopProperty"');
    }
    function cfnAnalysisGradientStopPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_GradientStopPropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color), DataValue: cdk.numberToCloudFormation(properties.dataValue), GradientOffset: cdk.numberToCloudFormation(properties.gradientOffset) }) : properties;
    }
    function CfnAnalysisGradientStopPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", properties.Color != null ? cfn_parse.FromCloudFormation.getString(properties.Color) : void 0), ret.addPropertyResult("dataValue", "DataValue", properties.DataValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.DataValue) : void 0), ret.addPropertyResult("gradientOffset", "GradientOffset", cfn_parse.FromCloudFormation.getNumber(properties.GradientOffset)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_GridLayoutCanvasSizeOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("screenCanvasSizeOptions", CfnAnalysis_GridLayoutScreenCanvasSizeOptionsPropertyValidator)(properties.screenCanvasSizeOptions)), errors.wrap('supplied properties not correct for "GridLayoutCanvasSizeOptionsProperty"');
    }
    function cfnAnalysisGridLayoutCanvasSizeOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_GridLayoutCanvasSizeOptionsPropertyValidator(properties).assertSuccess(), { ScreenCanvasSizeOptions: cfnAnalysisGridLayoutScreenCanvasSizeOptionsPropertyToCloudFormation(properties.screenCanvasSizeOptions) }) : properties;
    }
    function CfnAnalysisGridLayoutCanvasSizeOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("screenCanvasSizeOptions", "ScreenCanvasSizeOptions", properties.ScreenCanvasSizeOptions != null ? CfnAnalysisGridLayoutScreenCanvasSizeOptionsPropertyFromCloudFormation(properties.ScreenCanvasSizeOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_GridLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("canvasSizeOptions", CfnAnalysis_GridLayoutCanvasSizeOptionsPropertyValidator)(properties.canvasSizeOptions)), errors.collect(cdk.propertyValidator("elements", cdk.requiredValidator)(properties.elements)), errors.collect(cdk.propertyValidator("elements", cdk.listValidator(CfnAnalysis_GridLayoutElementPropertyValidator))(properties.elements)), errors.wrap('supplied properties not correct for "GridLayoutConfigurationProperty"');
    }
    function cfnAnalysisGridLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_GridLayoutConfigurationPropertyValidator(properties).assertSuccess(), { CanvasSizeOptions: cfnAnalysisGridLayoutCanvasSizeOptionsPropertyToCloudFormation(properties.canvasSizeOptions), Elements: cdk.listMapper(cfnAnalysisGridLayoutElementPropertyToCloudFormation)(properties.elements) }) : properties;
    }
    function CfnAnalysisGridLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("canvasSizeOptions", "CanvasSizeOptions", properties.CanvasSizeOptions != null ? CfnAnalysisGridLayoutCanvasSizeOptionsPropertyFromCloudFormation(properties.CanvasSizeOptions) : void 0), ret.addPropertyResult("elements", "Elements", cfn_parse.FromCloudFormation.getArray(CfnAnalysisGridLayoutElementPropertyFromCloudFormation)(properties.Elements)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_GridLayoutElementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnIndex", cdk.validateNumber)(properties.columnIndex)), errors.collect(cdk.propertyValidator("columnSpan", cdk.requiredValidator)(properties.columnSpan)), errors.collect(cdk.propertyValidator("columnSpan", cdk.validateNumber)(properties.columnSpan)), errors.collect(cdk.propertyValidator("elementId", cdk.requiredValidator)(properties.elementId)), errors.collect(cdk.propertyValidator("elementId", cdk.validateString)(properties.elementId)), errors.collect(cdk.propertyValidator("elementType", cdk.requiredValidator)(properties.elementType)), errors.collect(cdk.propertyValidator("elementType", cdk.validateString)(properties.elementType)), errors.collect(cdk.propertyValidator("rowIndex", cdk.validateNumber)(properties.rowIndex)), errors.collect(cdk.propertyValidator("rowSpan", cdk.requiredValidator)(properties.rowSpan)), errors.collect(cdk.propertyValidator("rowSpan", cdk.validateNumber)(properties.rowSpan)), errors.wrap('supplied properties not correct for "GridLayoutElementProperty"');
    }
    function cfnAnalysisGridLayoutElementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_GridLayoutElementPropertyValidator(properties).assertSuccess(), { ColumnIndex: cdk.numberToCloudFormation(properties.columnIndex), ColumnSpan: cdk.numberToCloudFormation(properties.columnSpan), ElementId: cdk.stringToCloudFormation(properties.elementId), ElementType: cdk.stringToCloudFormation(properties.elementType), RowIndex: cdk.numberToCloudFormation(properties.rowIndex), RowSpan: cdk.numberToCloudFormation(properties.rowSpan) }) : properties;
    }
    function CfnAnalysisGridLayoutElementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columnIndex", "ColumnIndex", properties.ColumnIndex != null ? cfn_parse.FromCloudFormation.getNumber(properties.ColumnIndex) : void 0), ret.addPropertyResult("columnSpan", "ColumnSpan", cfn_parse.FromCloudFormation.getNumber(properties.ColumnSpan)), ret.addPropertyResult("elementId", "ElementId", cfn_parse.FromCloudFormation.getString(properties.ElementId)), ret.addPropertyResult("elementType", "ElementType", cfn_parse.FromCloudFormation.getString(properties.ElementType)), ret.addPropertyResult("rowIndex", "RowIndex", properties.RowIndex != null ? cfn_parse.FromCloudFormation.getNumber(properties.RowIndex) : void 0), ret.addPropertyResult("rowSpan", "RowSpan", cfn_parse.FromCloudFormation.getNumber(properties.RowSpan)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_GridLayoutScreenCanvasSizeOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("optimizedViewPortWidth", cdk.validateString)(properties.optimizedViewPortWidth)), errors.collect(cdk.propertyValidator("resizeOption", cdk.requiredValidator)(properties.resizeOption)), errors.collect(cdk.propertyValidator("resizeOption", cdk.validateString)(properties.resizeOption)), errors.wrap('supplied properties not correct for "GridLayoutScreenCanvasSizeOptionsProperty"');
    }
    function cfnAnalysisGridLayoutScreenCanvasSizeOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_GridLayoutScreenCanvasSizeOptionsPropertyValidator(properties).assertSuccess(), { OptimizedViewPortWidth: cdk.stringToCloudFormation(properties.optimizedViewPortWidth), ResizeOption: cdk.stringToCloudFormation(properties.resizeOption) }) : properties;
    }
    function CfnAnalysisGridLayoutScreenCanvasSizeOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("optimizedViewPortWidth", "OptimizedViewPortWidth", properties.OptimizedViewPortWidth != null ? cfn_parse.FromCloudFormation.getString(properties.OptimizedViewPortWidth) : void 0), ret.addPropertyResult("resizeOption", "ResizeOption", cfn_parse.FromCloudFormation.getString(properties.ResizeOption)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_GrowthRateComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computationId", cdk.requiredValidator)(properties.computationId)), errors.collect(cdk.propertyValidator("computationId", cdk.validateString)(properties.computationId)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("periodSize", cdk.validateNumber)(properties.periodSize)), errors.collect(cdk.propertyValidator("time", cdk.requiredValidator)(properties.time)), errors.collect(cdk.propertyValidator("time", CfnAnalysis_DimensionFieldPropertyValidator)(properties.time)), errors.collect(cdk.propertyValidator("value", CfnAnalysis_MeasureFieldPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "GrowthRateComputationProperty"');
    }
    function cfnAnalysisGrowthRateComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_GrowthRateComputationPropertyValidator(properties).assertSuccess(), { ComputationId: cdk.stringToCloudFormation(properties.computationId), Name: cdk.stringToCloudFormation(properties.name), PeriodSize: cdk.numberToCloudFormation(properties.periodSize), Time: cfnAnalysisDimensionFieldPropertyToCloudFormation(properties.time), Value: cfnAnalysisMeasureFieldPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnAnalysisGrowthRateComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computationId", "ComputationId", cfn_parse.FromCloudFormation.getString(properties.ComputationId)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("periodSize", "PeriodSize", properties.PeriodSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.PeriodSize) : void 0), ret.addPropertyResult("time", "Time", CfnAnalysisDimensionFieldPropertyFromCloudFormation(properties.Time)), ret.addPropertyResult("value", "Value", properties.Value != null ? CfnAnalysisMeasureFieldPropertyFromCloudFormation(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_HeaderFooterSectionConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("layout", cdk.requiredValidator)(properties.layout)), errors.collect(cdk.propertyValidator("layout", CfnAnalysis_SectionLayoutConfigurationPropertyValidator)(properties.layout)), errors.collect(cdk.propertyValidator("sectionId", cdk.requiredValidator)(properties.sectionId)), errors.collect(cdk.propertyValidator("sectionId", cdk.validateString)(properties.sectionId)), errors.collect(cdk.propertyValidator("style", CfnAnalysis_SectionStylePropertyValidator)(properties.style)), errors.wrap('supplied properties not correct for "HeaderFooterSectionConfigurationProperty"');
    }
    function cfnAnalysisHeaderFooterSectionConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_HeaderFooterSectionConfigurationPropertyValidator(properties).assertSuccess(), { Layout: cfnAnalysisSectionLayoutConfigurationPropertyToCloudFormation(properties.layout), SectionId: cdk.stringToCloudFormation(properties.sectionId), Style: cfnAnalysisSectionStylePropertyToCloudFormation(properties.style) }) : properties;
    }
    function CfnAnalysisHeaderFooterSectionConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("layout", "Layout", CfnAnalysisSectionLayoutConfigurationPropertyFromCloudFormation(properties.Layout)), ret.addPropertyResult("sectionId", "SectionId", cfn_parse.FromCloudFormation.getString(properties.SectionId)), ret.addPropertyResult("style", "Style", properties.Style != null ? CfnAnalysisSectionStylePropertyFromCloudFormation(properties.Style) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_HeatMapAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columns", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.columns)), errors.collect(cdk.propertyValidator("rows", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.rows)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnAnalysis_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "HeatMapAggregatedFieldWellsProperty"');
    }
    function cfnAnalysisHeatMapAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_HeatMapAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Columns: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.columns), Rows: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.rows), Values: cdk.listMapper(cfnAnalysisMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnAnalysisHeatMapAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columns", "Columns", properties.Columns != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.Columns) : void 0), ret.addPropertyResult("rows", "Rows", properties.Rows != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.Rows) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_HeatMapConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("colorScale", CfnAnalysis_ColorScalePropertyValidator)(properties.colorScale)), errors.collect(cdk.propertyValidator("columnLabelOptions", CfnAnalysis_ChartAxisLabelOptionsPropertyValidator)(properties.columnLabelOptions)), errors.collect(cdk.propertyValidator("dataLabels", CfnAnalysis_DataLabelOptionsPropertyValidator)(properties.dataLabels)), errors.collect(cdk.propertyValidator("fieldWells", CfnAnalysis_HeatMapFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("legend", CfnAnalysis_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("rowLabelOptions", CfnAnalysis_ChartAxisLabelOptionsPropertyValidator)(properties.rowLabelOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnAnalysis_HeatMapSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tooltip", CfnAnalysis_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.wrap('supplied properties not correct for "HeatMapConfigurationProperty"');
    }
    function cfnAnalysisHeatMapConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_HeatMapConfigurationPropertyValidator(properties).assertSuccess(), { ColorScale: cfnAnalysisColorScalePropertyToCloudFormation(properties.colorScale), ColumnLabelOptions: cfnAnalysisChartAxisLabelOptionsPropertyToCloudFormation(properties.columnLabelOptions), DataLabels: cfnAnalysisDataLabelOptionsPropertyToCloudFormation(properties.dataLabels), FieldWells: cfnAnalysisHeatMapFieldWellsPropertyToCloudFormation(properties.fieldWells), Legend: cfnAnalysisLegendOptionsPropertyToCloudFormation(properties.legend), RowLabelOptions: cfnAnalysisChartAxisLabelOptionsPropertyToCloudFormation(properties.rowLabelOptions), SortConfiguration: cfnAnalysisHeatMapSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), Tooltip: cfnAnalysisTooltipOptionsPropertyToCloudFormation(properties.tooltip) }) : properties;
    }
    function CfnAnalysisHeatMapConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("colorScale", "ColorScale", properties.ColorScale != null ? CfnAnalysisColorScalePropertyFromCloudFormation(properties.ColorScale) : void 0), ret.addPropertyResult("columnLabelOptions", "ColumnLabelOptions", properties.ColumnLabelOptions != null ? CfnAnalysisChartAxisLabelOptionsPropertyFromCloudFormation(properties.ColumnLabelOptions) : void 0), ret.addPropertyResult("dataLabels", "DataLabels", properties.DataLabels != null ? CfnAnalysisDataLabelOptionsPropertyFromCloudFormation(properties.DataLabels) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnAnalysisHeatMapFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnAnalysisLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("rowLabelOptions", "RowLabelOptions", properties.RowLabelOptions != null ? CfnAnalysisChartAxisLabelOptionsPropertyFromCloudFormation(properties.RowLabelOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnAnalysisHeatMapSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnAnalysisTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_HeatMapFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("heatMapAggregatedFieldWells", CfnAnalysis_HeatMapAggregatedFieldWellsPropertyValidator)(properties.heatMapAggregatedFieldWells)), errors.wrap('supplied properties not correct for "HeatMapFieldWellsProperty"');
    }
    function cfnAnalysisHeatMapFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_HeatMapFieldWellsPropertyValidator(properties).assertSuccess(), { HeatMapAggregatedFieldWells: cfnAnalysisHeatMapAggregatedFieldWellsPropertyToCloudFormation(properties.heatMapAggregatedFieldWells) }) : properties;
    }
    function CfnAnalysisHeatMapFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("heatMapAggregatedFieldWells", "HeatMapAggregatedFieldWells", properties.HeatMapAggregatedFieldWells != null ? CfnAnalysisHeatMapAggregatedFieldWellsPropertyFromCloudFormation(properties.HeatMapAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_HeatMapSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("heatMapColumnItemsLimitConfiguration", CfnAnalysis_ItemsLimitConfigurationPropertyValidator)(properties.heatMapColumnItemsLimitConfiguration)), errors.collect(cdk.propertyValidator("heatMapColumnSort", cdk.listValidator(CfnAnalysis_FieldSortOptionsPropertyValidator))(properties.heatMapColumnSort)), errors.collect(cdk.propertyValidator("heatMapRowItemsLimitConfiguration", CfnAnalysis_ItemsLimitConfigurationPropertyValidator)(properties.heatMapRowItemsLimitConfiguration)), errors.collect(cdk.propertyValidator("heatMapRowSort", cdk.listValidator(CfnAnalysis_FieldSortOptionsPropertyValidator))(properties.heatMapRowSort)), errors.wrap('supplied properties not correct for "HeatMapSortConfigurationProperty"');
    }
    function cfnAnalysisHeatMapSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_HeatMapSortConfigurationPropertyValidator(properties).assertSuccess(), { HeatMapColumnItemsLimitConfiguration: cfnAnalysisItemsLimitConfigurationPropertyToCloudFormation(properties.heatMapColumnItemsLimitConfiguration), HeatMapColumnSort: cdk.listMapper(cfnAnalysisFieldSortOptionsPropertyToCloudFormation)(properties.heatMapColumnSort), HeatMapRowItemsLimitConfiguration: cfnAnalysisItemsLimitConfigurationPropertyToCloudFormation(properties.heatMapRowItemsLimitConfiguration), HeatMapRowSort: cdk.listMapper(cfnAnalysisFieldSortOptionsPropertyToCloudFormation)(properties.heatMapRowSort) }) : properties;
    }
    function CfnAnalysisHeatMapSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("heatMapColumnItemsLimitConfiguration", "HeatMapColumnItemsLimitConfiguration", properties.HeatMapColumnItemsLimitConfiguration != null ? CfnAnalysisItemsLimitConfigurationPropertyFromCloudFormation(properties.HeatMapColumnItemsLimitConfiguration) : void 0), ret.addPropertyResult("heatMapColumnSort", "HeatMapColumnSort", properties.HeatMapColumnSort != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisFieldSortOptionsPropertyFromCloudFormation)(properties.HeatMapColumnSort) : void 0), ret.addPropertyResult("heatMapRowItemsLimitConfiguration", "HeatMapRowItemsLimitConfiguration", properties.HeatMapRowItemsLimitConfiguration != null ? CfnAnalysisItemsLimitConfigurationPropertyFromCloudFormation(properties.HeatMapRowItemsLimitConfiguration) : void 0), ret.addPropertyResult("heatMapRowSort", "HeatMapRowSort", properties.HeatMapRowSort != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisFieldSortOptionsPropertyFromCloudFormation)(properties.HeatMapRowSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_HeatMapVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnAnalysis_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnAnalysis_HeatMapConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnAnalysis_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnAnalysis_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnAnalysis_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "HeatMapVisualProperty"');
    }
    function cfnAnalysisHeatMapVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_HeatMapVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnAnalysisVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnAnalysisHeatMapConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnAnalysisColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnAnalysisVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnAnalysisVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnAnalysisHeatMapVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnAnalysisHeatMapConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnAnalysisVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnAnalysisVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_HistogramAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnAnalysis_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "HistogramAggregatedFieldWellsProperty"');
    }
    function cfnAnalysisHistogramAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_HistogramAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Values: cdk.listMapper(cfnAnalysisMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnAnalysisHistogramAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_HistogramBinOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("binCount", CfnAnalysis_BinCountOptionsPropertyValidator)(properties.binCount)), errors.collect(cdk.propertyValidator("binWidth", CfnAnalysis_BinWidthOptionsPropertyValidator)(properties.binWidth)), errors.collect(cdk.propertyValidator("selectedBinType", cdk.validateString)(properties.selectedBinType)), errors.collect(cdk.propertyValidator("startValue", cdk.validateNumber)(properties.startValue)), errors.wrap('supplied properties not correct for "HistogramBinOptionsProperty"');
    }
    function cfnAnalysisHistogramBinOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_HistogramBinOptionsPropertyValidator(properties).assertSuccess(), { BinCount: cfnAnalysisBinCountOptionsPropertyToCloudFormation(properties.binCount), BinWidth: cfnAnalysisBinWidthOptionsPropertyToCloudFormation(properties.binWidth), SelectedBinType: cdk.stringToCloudFormation(properties.selectedBinType), StartValue: cdk.numberToCloudFormation(properties.startValue) }) : properties;
    }
    function CfnAnalysisHistogramBinOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("binCount", "BinCount", properties.BinCount != null ? CfnAnalysisBinCountOptionsPropertyFromCloudFormation(properties.BinCount) : void 0), ret.addPropertyResult("binWidth", "BinWidth", properties.BinWidth != null ? CfnAnalysisBinWidthOptionsPropertyFromCloudFormation(properties.BinWidth) : void 0), ret.addPropertyResult("selectedBinType", "SelectedBinType", properties.SelectedBinType != null ? cfn_parse.FromCloudFormation.getString(properties.SelectedBinType) : void 0), ret.addPropertyResult("startValue", "StartValue", properties.StartValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.StartValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_HistogramConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("binOptions", CfnAnalysis_HistogramBinOptionsPropertyValidator)(properties.binOptions)), errors.collect(cdk.propertyValidator("dataLabels", CfnAnalysis_DataLabelOptionsPropertyValidator)(properties.dataLabels)), errors.collect(cdk.propertyValidator("fieldWells", CfnAnalysis_HistogramFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("tooltip", CfnAnalysis_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.collect(cdk.propertyValidator("visualPalette", CfnAnalysis_VisualPalettePropertyValidator)(properties.visualPalette)), errors.collect(cdk.propertyValidator("xAxisDisplayOptions", CfnAnalysis_AxisDisplayOptionsPropertyValidator)(properties.xAxisDisplayOptions)), errors.collect(cdk.propertyValidator("xAxisLabelOptions", CfnAnalysis_ChartAxisLabelOptionsPropertyValidator)(properties.xAxisLabelOptions)), errors.collect(cdk.propertyValidator("yAxisDisplayOptions", CfnAnalysis_AxisDisplayOptionsPropertyValidator)(properties.yAxisDisplayOptions)), errors.wrap('supplied properties not correct for "HistogramConfigurationProperty"');
    }
    function cfnAnalysisHistogramConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_HistogramConfigurationPropertyValidator(properties).assertSuccess(), { BinOptions: cfnAnalysisHistogramBinOptionsPropertyToCloudFormation(properties.binOptions), DataLabels: cfnAnalysisDataLabelOptionsPropertyToCloudFormation(properties.dataLabels), FieldWells: cfnAnalysisHistogramFieldWellsPropertyToCloudFormation(properties.fieldWells), Tooltip: cfnAnalysisTooltipOptionsPropertyToCloudFormation(properties.tooltip), VisualPalette: cfnAnalysisVisualPalettePropertyToCloudFormation(properties.visualPalette), XAxisDisplayOptions: cfnAnalysisAxisDisplayOptionsPropertyToCloudFormation(properties.xAxisDisplayOptions), XAxisLabelOptions: cfnAnalysisChartAxisLabelOptionsPropertyToCloudFormation(properties.xAxisLabelOptions), YAxisDisplayOptions: cfnAnalysisAxisDisplayOptionsPropertyToCloudFormation(properties.yAxisDisplayOptions) }) : properties;
    }
    function CfnAnalysisHistogramConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("binOptions", "BinOptions", properties.BinOptions != null ? CfnAnalysisHistogramBinOptionsPropertyFromCloudFormation(properties.BinOptions) : void 0), ret.addPropertyResult("dataLabels", "DataLabels", properties.DataLabels != null ? CfnAnalysisDataLabelOptionsPropertyFromCloudFormation(properties.DataLabels) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnAnalysisHistogramFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnAnalysisTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnAnalysisVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addPropertyResult("xAxisDisplayOptions", "XAxisDisplayOptions", properties.XAxisDisplayOptions != null ? CfnAnalysisAxisDisplayOptionsPropertyFromCloudFormation(properties.XAxisDisplayOptions) : void 0), ret.addPropertyResult("xAxisLabelOptions", "XAxisLabelOptions", properties.XAxisLabelOptions != null ? CfnAnalysisChartAxisLabelOptionsPropertyFromCloudFormation(properties.XAxisLabelOptions) : void 0), ret.addPropertyResult("yAxisDisplayOptions", "YAxisDisplayOptions", properties.YAxisDisplayOptions != null ? CfnAnalysisAxisDisplayOptionsPropertyFromCloudFormation(properties.YAxisDisplayOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_HistogramFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("histogramAggregatedFieldWells", CfnAnalysis_HistogramAggregatedFieldWellsPropertyValidator)(properties.histogramAggregatedFieldWells)), errors.wrap('supplied properties not correct for "HistogramFieldWellsProperty"');
    }
    function cfnAnalysisHistogramFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_HistogramFieldWellsPropertyValidator(properties).assertSuccess(), { HistogramAggregatedFieldWells: cfnAnalysisHistogramAggregatedFieldWellsPropertyToCloudFormation(properties.histogramAggregatedFieldWells) }) : properties;
    }
    function CfnAnalysisHistogramFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("histogramAggregatedFieldWells", "HistogramAggregatedFieldWells", properties.HistogramAggregatedFieldWells != null ? CfnAnalysisHistogramAggregatedFieldWellsPropertyFromCloudFormation(properties.HistogramAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_HistogramVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnAnalysis_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnAnalysis_HistogramConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("subtitle", CfnAnalysis_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnAnalysis_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "HistogramVisualProperty"');
    }
    function cfnAnalysisHistogramVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_HistogramVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnAnalysisVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnAnalysisHistogramConfigurationPropertyToCloudFormation(properties.chartConfiguration), Subtitle: cfnAnalysisVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnAnalysisVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnAnalysisHistogramVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnAnalysisHistogramConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnAnalysisVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnAnalysisVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_InsightConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computations", cdk.listValidator(CfnAnalysis_ComputationPropertyValidator))(properties.computations)), errors.collect(cdk.propertyValidator("customNarrative", CfnAnalysis_CustomNarrativeOptionsPropertyValidator)(properties.customNarrative)), errors.wrap('supplied properties not correct for "InsightConfigurationProperty"');
    }
    function cfnAnalysisInsightConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_InsightConfigurationPropertyValidator(properties).assertSuccess(), { Computations: cdk.listMapper(cfnAnalysisComputationPropertyToCloudFormation)(properties.computations), CustomNarrative: cfnAnalysisCustomNarrativeOptionsPropertyToCloudFormation(properties.customNarrative) }) : properties;
    }
    function CfnAnalysisInsightConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computations", "Computations", properties.Computations != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisComputationPropertyFromCloudFormation)(properties.Computations) : void 0), ret.addPropertyResult("customNarrative", "CustomNarrative", properties.CustomNarrative != null ? CfnAnalysisCustomNarrativeOptionsPropertyFromCloudFormation(properties.CustomNarrative) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_InsightVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnAnalysis_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.requiredValidator)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.validateString)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("insightConfiguration", CfnAnalysis_InsightConfigurationPropertyValidator)(properties.insightConfiguration)), errors.collect(cdk.propertyValidator("subtitle", CfnAnalysis_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnAnalysis_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "InsightVisualProperty"');
    }
    function cfnAnalysisInsightVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_InsightVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnAnalysisVisualCustomActionPropertyToCloudFormation)(properties.actions), DataSetIdentifier: cdk.stringToCloudFormation(properties.dataSetIdentifier), InsightConfiguration: cfnAnalysisInsightConfigurationPropertyToCloudFormation(properties.insightConfiguration), Subtitle: cfnAnalysisVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnAnalysisVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnAnalysisInsightVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("dataSetIdentifier", "DataSetIdentifier", cfn_parse.FromCloudFormation.getString(properties.DataSetIdentifier)), ret.addPropertyResult("insightConfiguration", "InsightConfiguration", properties.InsightConfiguration != null ? CfnAnalysisInsightConfigurationPropertyFromCloudFormation(properties.InsightConfiguration) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnAnalysisVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnAnalysisVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_IntegerDefaultValuesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dynamicValue", CfnAnalysis_DynamicDefaultValuePropertyValidator)(properties.dynamicValue)), errors.collect(cdk.propertyValidator("staticValues", cdk.listValidator(cdk.validateNumber))(properties.staticValues)), errors.wrap('supplied properties not correct for "IntegerDefaultValuesProperty"');
    }
    function cfnAnalysisIntegerDefaultValuesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_IntegerDefaultValuesPropertyValidator(properties).assertSuccess(), { DynamicValue: cfnAnalysisDynamicDefaultValuePropertyToCloudFormation(properties.dynamicValue), StaticValues: cdk.listMapper(cdk.numberToCloudFormation)(properties.staticValues) }) : properties;
    }
    function CfnAnalysisIntegerDefaultValuesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dynamicValue", "DynamicValue", properties.DynamicValue != null ? CfnAnalysisDynamicDefaultValuePropertyFromCloudFormation(properties.DynamicValue) : void 0), ret.addPropertyResult("staticValues", "StaticValues", properties.StaticValues != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getNumber)(properties.StaticValues) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_IntegerParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("values", cdk.requiredValidator)(properties.values)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateNumber))(properties.values)), errors.wrap('supplied properties not correct for "IntegerParameterProperty"');
    }
    function cfnAnalysisIntegerParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_IntegerParameterPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Values: cdk.listMapper(cdk.numberToCloudFormation)(properties.values) }) : properties;
    }
    function CfnAnalysisIntegerParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("values", "Values", cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getNumber)(properties.Values)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_IntegerParameterDeclarationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultValues", CfnAnalysis_IntegerDefaultValuesPropertyValidator)(properties.defaultValues)), errors.collect(cdk.propertyValidator("mappedDataSetParameters", cdk.listValidator(CfnAnalysis_MappedDataSetParameterPropertyValidator))(properties.mappedDataSetParameters)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("parameterValueType", cdk.requiredValidator)(properties.parameterValueType)), errors.collect(cdk.propertyValidator("parameterValueType", cdk.validateString)(properties.parameterValueType)), errors.collect(cdk.propertyValidator("valueWhenUnset", CfnAnalysis_IntegerValueWhenUnsetConfigurationPropertyValidator)(properties.valueWhenUnset)), errors.wrap('supplied properties not correct for "IntegerParameterDeclarationProperty"');
    }
    function cfnAnalysisIntegerParameterDeclarationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_IntegerParameterDeclarationPropertyValidator(properties).assertSuccess(), { DefaultValues: cfnAnalysisIntegerDefaultValuesPropertyToCloudFormation(properties.defaultValues), MappedDataSetParameters: cdk.listMapper(cfnAnalysisMappedDataSetParameterPropertyToCloudFormation)(properties.mappedDataSetParameters), Name: cdk.stringToCloudFormation(properties.name), ParameterValueType: cdk.stringToCloudFormation(properties.parameterValueType), ValueWhenUnset: cfnAnalysisIntegerValueWhenUnsetConfigurationPropertyToCloudFormation(properties.valueWhenUnset) }) : properties;
    }
    function CfnAnalysisIntegerParameterDeclarationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultValues", "DefaultValues", properties.DefaultValues != null ? CfnAnalysisIntegerDefaultValuesPropertyFromCloudFormation(properties.DefaultValues) : void 0), ret.addPropertyResult("mappedDataSetParameters", "MappedDataSetParameters", properties.MappedDataSetParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMappedDataSetParameterPropertyFromCloudFormation)(properties.MappedDataSetParameters) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("parameterValueType", "ParameterValueType", cfn_parse.FromCloudFormation.getString(properties.ParameterValueType)), ret.addPropertyResult("valueWhenUnset", "ValueWhenUnset", properties.ValueWhenUnset != null ? CfnAnalysisIntegerValueWhenUnsetConfigurationPropertyFromCloudFormation(properties.ValueWhenUnset) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_IntegerValueWhenUnsetConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customValue", cdk.validateNumber)(properties.customValue)), errors.collect(cdk.propertyValidator("valueWhenUnsetOption", cdk.validateString)(properties.valueWhenUnsetOption)), errors.wrap('supplied properties not correct for "IntegerValueWhenUnsetConfigurationProperty"');
    }
    function cfnAnalysisIntegerValueWhenUnsetConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_IntegerValueWhenUnsetConfigurationPropertyValidator(properties).assertSuccess(), { CustomValue: cdk.numberToCloudFormation(properties.customValue), ValueWhenUnsetOption: cdk.stringToCloudFormation(properties.valueWhenUnsetOption) }) : properties;
    }
    function CfnAnalysisIntegerValueWhenUnsetConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customValue", "CustomValue", properties.CustomValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.CustomValue) : void 0), ret.addPropertyResult("valueWhenUnsetOption", "ValueWhenUnsetOption", properties.ValueWhenUnsetOption != null ? cfn_parse.FromCloudFormation.getString(properties.ValueWhenUnsetOption) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ItemsLimitConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("itemsLimit", cdk.validateNumber)(properties.itemsLimit)), errors.collect(cdk.propertyValidator("otherCategories", cdk.validateString)(properties.otherCategories)), errors.wrap('supplied properties not correct for "ItemsLimitConfigurationProperty"');
    }
    function cfnAnalysisItemsLimitConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ItemsLimitConfigurationPropertyValidator(properties).assertSuccess(), { ItemsLimit: cdk.numberToCloudFormation(properties.itemsLimit), OtherCategories: cdk.stringToCloudFormation(properties.otherCategories) }) : properties;
    }
    function CfnAnalysisItemsLimitConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("itemsLimit", "ItemsLimit", properties.ItemsLimit != null ? cfn_parse.FromCloudFormation.getNumber(properties.ItemsLimit) : void 0), ret.addPropertyResult("otherCategories", "OtherCategories", properties.OtherCategories != null ? cfn_parse.FromCloudFormation.getString(properties.OtherCategories) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_KPIConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("conditionalFormattingOptions", cdk.listValidator(CfnAnalysis_KPIConditionalFormattingOptionPropertyValidator))(properties.conditionalFormattingOptions)), errors.wrap('supplied properties not correct for "KPIConditionalFormattingProperty"');
    }
    function cfnAnalysisKPIConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_KPIConditionalFormattingPropertyValidator(properties).assertSuccess(), { ConditionalFormattingOptions: cdk.listMapper(cfnAnalysisKPIConditionalFormattingOptionPropertyToCloudFormation)(properties.conditionalFormattingOptions) }) : properties;
    }
    function CfnAnalysisKPIConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("conditionalFormattingOptions", "ConditionalFormattingOptions", properties.ConditionalFormattingOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisKPIConditionalFormattingOptionPropertyFromCloudFormation)(properties.ConditionalFormattingOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_KPIConditionalFormattingOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("primaryValue", CfnAnalysis_KPIPrimaryValueConditionalFormattingPropertyValidator)(properties.primaryValue)), errors.collect(cdk.propertyValidator("progressBar", CfnAnalysis_KPIProgressBarConditionalFormattingPropertyValidator)(properties.progressBar)), errors.wrap('supplied properties not correct for "KPIConditionalFormattingOptionProperty"');
    }
    function cfnAnalysisKPIConditionalFormattingOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_KPIConditionalFormattingOptionPropertyValidator(properties).assertSuccess(), { PrimaryValue: cfnAnalysisKPIPrimaryValueConditionalFormattingPropertyToCloudFormation(properties.primaryValue), ProgressBar: cfnAnalysisKPIProgressBarConditionalFormattingPropertyToCloudFormation(properties.progressBar) }) : properties;
    }
    function CfnAnalysisKPIConditionalFormattingOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("primaryValue", "PrimaryValue", properties.PrimaryValue != null ? CfnAnalysisKPIPrimaryValueConditionalFormattingPropertyFromCloudFormation(properties.PrimaryValue) : void 0), ret.addPropertyResult("progressBar", "ProgressBar", properties.ProgressBar != null ? CfnAnalysisKPIProgressBarConditionalFormattingPropertyFromCloudFormation(properties.ProgressBar) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_KPIConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldWells", CfnAnalysis_KPIFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("kpiOptions", CfnAnalysis_KPIOptionsPropertyValidator)(properties.kpiOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnAnalysis_KPISortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.wrap('supplied properties not correct for "KPIConfigurationProperty"');
    }
    function cfnAnalysisKPIConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_KPIConfigurationPropertyValidator(properties).assertSuccess(), { FieldWells: cfnAnalysisKPIFieldWellsPropertyToCloudFormation(properties.fieldWells), KPIOptions: cfnAnalysisKPIOptionsPropertyToCloudFormation(properties.kpiOptions), SortConfiguration: cfnAnalysisKPISortConfigurationPropertyToCloudFormation(properties.sortConfiguration) }) : properties;
    }
    function CfnAnalysisKPIConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnAnalysisKPIFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("kpiOptions", "KPIOptions", properties.KPIOptions != null ? CfnAnalysisKPIOptionsPropertyFromCloudFormation(properties.KPIOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnAnalysisKPISortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_KPIFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("targetValues", cdk.listValidator(CfnAnalysis_MeasureFieldPropertyValidator))(properties.targetValues)), errors.collect(cdk.propertyValidator("trendGroups", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.trendGroups)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnAnalysis_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "KPIFieldWellsProperty"');
    }
    function cfnAnalysisKPIFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_KPIFieldWellsPropertyValidator(properties).assertSuccess(), { TargetValues: cdk.listMapper(cfnAnalysisMeasureFieldPropertyToCloudFormation)(properties.targetValues), TrendGroups: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.trendGroups), Values: cdk.listMapper(cfnAnalysisMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnAnalysisKPIFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("targetValues", "TargetValues", properties.TargetValues != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMeasureFieldPropertyFromCloudFormation)(properties.TargetValues) : void 0), ret.addPropertyResult("trendGroups", "TrendGroups", properties.TrendGroups != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.TrendGroups) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_KPIOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("comparison", CfnAnalysis_ComparisonConfigurationPropertyValidator)(properties.comparison)), errors.collect(cdk.propertyValidator("primaryValueDisplayType", cdk.validateString)(properties.primaryValueDisplayType)), errors.collect(cdk.propertyValidator("primaryValueFontConfiguration", CfnAnalysis_FontConfigurationPropertyValidator)(properties.primaryValueFontConfiguration)), errors.collect(cdk.propertyValidator("progressBar", CfnAnalysis_ProgressBarOptionsPropertyValidator)(properties.progressBar)), errors.collect(cdk.propertyValidator("secondaryValue", CfnAnalysis_SecondaryValueOptionsPropertyValidator)(properties.secondaryValue)), errors.collect(cdk.propertyValidator("secondaryValueFontConfiguration", CfnAnalysis_FontConfigurationPropertyValidator)(properties.secondaryValueFontConfiguration)), errors.collect(cdk.propertyValidator("trendArrows", CfnAnalysis_TrendArrowOptionsPropertyValidator)(properties.trendArrows)), errors.wrap('supplied properties not correct for "KPIOptionsProperty"');
    }
    function cfnAnalysisKPIOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_KPIOptionsPropertyValidator(properties).assertSuccess(), { Comparison: cfnAnalysisComparisonConfigurationPropertyToCloudFormation(properties.comparison), PrimaryValueDisplayType: cdk.stringToCloudFormation(properties.primaryValueDisplayType), PrimaryValueFontConfiguration: cfnAnalysisFontConfigurationPropertyToCloudFormation(properties.primaryValueFontConfiguration), ProgressBar: cfnAnalysisProgressBarOptionsPropertyToCloudFormation(properties.progressBar), SecondaryValue: cfnAnalysisSecondaryValueOptionsPropertyToCloudFormation(properties.secondaryValue), SecondaryValueFontConfiguration: cfnAnalysisFontConfigurationPropertyToCloudFormation(properties.secondaryValueFontConfiguration), TrendArrows: cfnAnalysisTrendArrowOptionsPropertyToCloudFormation(properties.trendArrows) }) : properties;
    }
    function CfnAnalysisKPIOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("comparison", "Comparison", properties.Comparison != null ? CfnAnalysisComparisonConfigurationPropertyFromCloudFormation(properties.Comparison) : void 0), ret.addPropertyResult("primaryValueDisplayType", "PrimaryValueDisplayType", properties.PrimaryValueDisplayType != null ? cfn_parse.FromCloudFormation.getString(properties.PrimaryValueDisplayType) : void 0), ret.addPropertyResult("primaryValueFontConfiguration", "PrimaryValueFontConfiguration", properties.PrimaryValueFontConfiguration != null ? CfnAnalysisFontConfigurationPropertyFromCloudFormation(properties.PrimaryValueFontConfiguration) : void 0), ret.addPropertyResult("progressBar", "ProgressBar", properties.ProgressBar != null ? CfnAnalysisProgressBarOptionsPropertyFromCloudFormation(properties.ProgressBar) : void 0), ret.addPropertyResult("secondaryValue", "SecondaryValue", properties.SecondaryValue != null ? CfnAnalysisSecondaryValueOptionsPropertyFromCloudFormation(properties.SecondaryValue) : void 0), ret.addPropertyResult("secondaryValueFontConfiguration", "SecondaryValueFontConfiguration", properties.SecondaryValueFontConfiguration != null ? CfnAnalysisFontConfigurationPropertyFromCloudFormation(properties.SecondaryValueFontConfiguration) : void 0), ret.addPropertyResult("trendArrows", "TrendArrows", properties.TrendArrows != null ? CfnAnalysisTrendArrowOptionsPropertyFromCloudFormation(properties.TrendArrows) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_KPIPrimaryValueConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("icon", CfnAnalysis_ConditionalFormattingIconPropertyValidator)(properties.icon)), errors.collect(cdk.propertyValidator("textColor", CfnAnalysis_ConditionalFormattingColorPropertyValidator)(properties.textColor)), errors.wrap('supplied properties not correct for "KPIPrimaryValueConditionalFormattingProperty"');
    }
    function cfnAnalysisKPIPrimaryValueConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_KPIPrimaryValueConditionalFormattingPropertyValidator(properties).assertSuccess(), { Icon: cfnAnalysisConditionalFormattingIconPropertyToCloudFormation(properties.icon), TextColor: cfnAnalysisConditionalFormattingColorPropertyToCloudFormation(properties.textColor) }) : properties;
    }
    function CfnAnalysisKPIPrimaryValueConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("icon", "Icon", properties.Icon != null ? CfnAnalysisConditionalFormattingIconPropertyFromCloudFormation(properties.Icon) : void 0), ret.addPropertyResult("textColor", "TextColor", properties.TextColor != null ? CfnAnalysisConditionalFormattingColorPropertyFromCloudFormation(properties.TextColor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_KPIProgressBarConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("foregroundColor", CfnAnalysis_ConditionalFormattingColorPropertyValidator)(properties.foregroundColor)), errors.wrap('supplied properties not correct for "KPIProgressBarConditionalFormattingProperty"');
    }
    function cfnAnalysisKPIProgressBarConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_KPIProgressBarConditionalFormattingPropertyValidator(properties).assertSuccess(), { ForegroundColor: cfnAnalysisConditionalFormattingColorPropertyToCloudFormation(properties.foregroundColor) }) : properties;
    }
    function CfnAnalysisKPIProgressBarConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("foregroundColor", "ForegroundColor", properties.ForegroundColor != null ? CfnAnalysisConditionalFormattingColorPropertyFromCloudFormation(properties.ForegroundColor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_KPISortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("trendGroupSort", cdk.listValidator(CfnAnalysis_FieldSortOptionsPropertyValidator))(properties.trendGroupSort)), errors.wrap('supplied properties not correct for "KPISortConfigurationProperty"');
    }
    function cfnAnalysisKPISortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_KPISortConfigurationPropertyValidator(properties).assertSuccess(), { TrendGroupSort: cdk.listMapper(cfnAnalysisFieldSortOptionsPropertyToCloudFormation)(properties.trendGroupSort) }) : properties;
    }
    function CfnAnalysisKPISortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("trendGroupSort", "TrendGroupSort", properties.TrendGroupSort != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisFieldSortOptionsPropertyFromCloudFormation)(properties.TrendGroupSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_KPIVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnAnalysis_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnAnalysis_KPIConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnAnalysis_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("conditionalFormatting", CfnAnalysis_KPIConditionalFormattingPropertyValidator)(properties.conditionalFormatting)), errors.collect(cdk.propertyValidator("subtitle", CfnAnalysis_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnAnalysis_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "KPIVisualProperty"');
    }
    function cfnAnalysisKPIVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_KPIVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnAnalysisVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnAnalysisKPIConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnAnalysisColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), ConditionalFormatting: cfnAnalysisKPIConditionalFormattingPropertyToCloudFormation(properties.conditionalFormatting), Subtitle: cfnAnalysisVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnAnalysisVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnAnalysisKPIVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnAnalysisKPIConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("conditionalFormatting", "ConditionalFormatting", properties.ConditionalFormatting != null ? CfnAnalysisKPIConditionalFormattingPropertyFromCloudFormation(properties.ConditionalFormatting) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnAnalysisVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnAnalysisVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_LabelOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customLabel", cdk.validateString)(properties.customLabel)), errors.collect(cdk.propertyValidator("fontConfiguration", CfnAnalysis_FontConfigurationPropertyValidator)(properties.fontConfiguration)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "LabelOptionsProperty"');
    }
    function cfnAnalysisLabelOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_LabelOptionsPropertyValidator(properties).assertSuccess(), { CustomLabel: cdk.stringToCloudFormation(properties.customLabel), FontConfiguration: cfnAnalysisFontConfigurationPropertyToCloudFormation(properties.fontConfiguration), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnAnalysisLabelOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customLabel", "CustomLabel", properties.CustomLabel != null ? cfn_parse.FromCloudFormation.getString(properties.CustomLabel) : void 0), ret.addPropertyResult("fontConfiguration", "FontConfiguration", properties.FontConfiguration != null ? CfnAnalysisFontConfigurationPropertyFromCloudFormation(properties.FontConfiguration) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_LayoutPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configuration", cdk.requiredValidator)(properties.configuration)), errors.collect(cdk.propertyValidator("configuration", CfnAnalysis_LayoutConfigurationPropertyValidator)(properties.configuration)), errors.wrap('supplied properties not correct for "LayoutProperty"');
    }
    function cfnAnalysisLayoutPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_LayoutPropertyValidator(properties).assertSuccess(), { Configuration: cfnAnalysisLayoutConfigurationPropertyToCloudFormation(properties.configuration) }) : properties;
    }
    function CfnAnalysisLayoutPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configuration", "Configuration", CfnAnalysisLayoutConfigurationPropertyFromCloudFormation(properties.Configuration)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_LayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("freeFormLayout", CfnAnalysis_FreeFormLayoutConfigurationPropertyValidator)(properties.freeFormLayout)), errors.collect(cdk.propertyValidator("gridLayout", CfnAnalysis_GridLayoutConfigurationPropertyValidator)(properties.gridLayout)), errors.collect(cdk.propertyValidator("sectionBasedLayout", CfnAnalysis_SectionBasedLayoutConfigurationPropertyValidator)(properties.sectionBasedLayout)), errors.wrap('supplied properties not correct for "LayoutConfigurationProperty"');
    }
    function cfnAnalysisLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_LayoutConfigurationPropertyValidator(properties).assertSuccess(), { FreeFormLayout: cfnAnalysisFreeFormLayoutConfigurationPropertyToCloudFormation(properties.freeFormLayout), GridLayout: cfnAnalysisGridLayoutConfigurationPropertyToCloudFormation(properties.gridLayout), SectionBasedLayout: cfnAnalysisSectionBasedLayoutConfigurationPropertyToCloudFormation(properties.sectionBasedLayout) }) : properties;
    }
    function CfnAnalysisLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("freeFormLayout", "FreeFormLayout", properties.FreeFormLayout != null ? CfnAnalysisFreeFormLayoutConfigurationPropertyFromCloudFormation(properties.FreeFormLayout) : void 0), ret.addPropertyResult("gridLayout", "GridLayout", properties.GridLayout != null ? CfnAnalysisGridLayoutConfigurationPropertyFromCloudFormation(properties.GridLayout) : void 0), ret.addPropertyResult("sectionBasedLayout", "SectionBasedLayout", properties.SectionBasedLayout != null ? CfnAnalysisSectionBasedLayoutConfigurationPropertyFromCloudFormation(properties.SectionBasedLayout) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_LegendOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("height", cdk.validateString)(properties.height)), errors.collect(cdk.propertyValidator("position", cdk.validateString)(properties.position)), errors.collect(cdk.propertyValidator("title", CfnAnalysis_LabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.collect(cdk.propertyValidator("width", cdk.validateString)(properties.width)), errors.wrap('supplied properties not correct for "LegendOptionsProperty"');
    }
    function cfnAnalysisLegendOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_LegendOptionsPropertyValidator(properties).assertSuccess(), { Height: cdk.stringToCloudFormation(properties.height), Position: cdk.stringToCloudFormation(properties.position), Title: cfnAnalysisLabelOptionsPropertyToCloudFormation(properties.title), Visibility: cdk.stringToCloudFormation(properties.visibility), Width: cdk.stringToCloudFormation(properties.width) }) : properties;
    }
    function CfnAnalysisLegendOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("height", "Height", properties.Height != null ? cfn_parse.FromCloudFormation.getString(properties.Height) : void 0), ret.addPropertyResult("position", "Position", properties.Position != null ? cfn_parse.FromCloudFormation.getString(properties.Position) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnAnalysisLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addPropertyResult("width", "Width", properties.Width != null ? cfn_parse.FromCloudFormation.getString(properties.Width) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_LineChartAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("category", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.category)), errors.collect(cdk.propertyValidator("colors", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.colors)), errors.collect(cdk.propertyValidator("smallMultiples", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.smallMultiples)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnAnalysis_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "LineChartAggregatedFieldWellsProperty"');
    }
    function cfnAnalysisLineChartAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_LineChartAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Category: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.category), Colors: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.colors), SmallMultiples: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.smallMultiples), Values: cdk.listMapper(cfnAnalysisMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnAnalysisLineChartAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("category", "Category", properties.Category != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.Category) : void 0), ret.addPropertyResult("colors", "Colors", properties.Colors != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.Colors) : void 0), ret.addPropertyResult("smallMultiples", "SmallMultiples", properties.SmallMultiples != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.SmallMultiples) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_LineChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contributionAnalysisDefaults", cdk.listValidator(CfnAnalysis_ContributionAnalysisDefaultPropertyValidator))(properties.contributionAnalysisDefaults)), errors.collect(cdk.propertyValidator("dataLabels", CfnAnalysis_DataLabelOptionsPropertyValidator)(properties.dataLabels)), errors.collect(cdk.propertyValidator("defaultSeriesSettings", CfnAnalysis_LineChartDefaultSeriesSettingsPropertyValidator)(properties.defaultSeriesSettings)), errors.collect(cdk.propertyValidator("fieldWells", CfnAnalysis_LineChartFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("forecastConfigurations", cdk.listValidator(CfnAnalysis_ForecastConfigurationPropertyValidator))(properties.forecastConfigurations)), errors.collect(cdk.propertyValidator("legend", CfnAnalysis_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("primaryYAxisDisplayOptions", CfnAnalysis_LineSeriesAxisDisplayOptionsPropertyValidator)(properties.primaryYAxisDisplayOptions)), errors.collect(cdk.propertyValidator("primaryYAxisLabelOptions", CfnAnalysis_ChartAxisLabelOptionsPropertyValidator)(properties.primaryYAxisLabelOptions)), errors.collect(cdk.propertyValidator("referenceLines", cdk.listValidator(CfnAnalysis_ReferenceLinePropertyValidator))(properties.referenceLines)), errors.collect(cdk.propertyValidator("secondaryYAxisDisplayOptions", CfnAnalysis_LineSeriesAxisDisplayOptionsPropertyValidator)(properties.secondaryYAxisDisplayOptions)), errors.collect(cdk.propertyValidator("secondaryYAxisLabelOptions", CfnAnalysis_ChartAxisLabelOptionsPropertyValidator)(properties.secondaryYAxisLabelOptions)), errors.collect(cdk.propertyValidator("series", cdk.listValidator(CfnAnalysis_SeriesItemPropertyValidator))(properties.series)), errors.collect(cdk.propertyValidator("smallMultiplesOptions", CfnAnalysis_SmallMultiplesOptionsPropertyValidator)(properties.smallMultiplesOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnAnalysis_LineChartSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tooltip", CfnAnalysis_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("visualPalette", CfnAnalysis_VisualPalettePropertyValidator)(properties.visualPalette)), errors.collect(cdk.propertyValidator("xAxisDisplayOptions", CfnAnalysis_AxisDisplayOptionsPropertyValidator)(properties.xAxisDisplayOptions)), errors.collect(cdk.propertyValidator("xAxisLabelOptions", CfnAnalysis_ChartAxisLabelOptionsPropertyValidator)(properties.xAxisLabelOptions)), errors.wrap('supplied properties not correct for "LineChartConfigurationProperty"');
    }
    function cfnAnalysisLineChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_LineChartConfigurationPropertyValidator(properties).assertSuccess(), { ContributionAnalysisDefaults: cdk.listMapper(cfnAnalysisContributionAnalysisDefaultPropertyToCloudFormation)(properties.contributionAnalysisDefaults), DataLabels: cfnAnalysisDataLabelOptionsPropertyToCloudFormation(properties.dataLabels), DefaultSeriesSettings: cfnAnalysisLineChartDefaultSeriesSettingsPropertyToCloudFormation(properties.defaultSeriesSettings), FieldWells: cfnAnalysisLineChartFieldWellsPropertyToCloudFormation(properties.fieldWells), ForecastConfigurations: cdk.listMapper(cfnAnalysisForecastConfigurationPropertyToCloudFormation)(properties.forecastConfigurations), Legend: cfnAnalysisLegendOptionsPropertyToCloudFormation(properties.legend), PrimaryYAxisDisplayOptions: cfnAnalysisLineSeriesAxisDisplayOptionsPropertyToCloudFormation(properties.primaryYAxisDisplayOptions), PrimaryYAxisLabelOptions: cfnAnalysisChartAxisLabelOptionsPropertyToCloudFormation(properties.primaryYAxisLabelOptions), ReferenceLines: cdk.listMapper(cfnAnalysisReferenceLinePropertyToCloudFormation)(properties.referenceLines), SecondaryYAxisDisplayOptions: cfnAnalysisLineSeriesAxisDisplayOptionsPropertyToCloudFormation(properties.secondaryYAxisDisplayOptions), SecondaryYAxisLabelOptions: cfnAnalysisChartAxisLabelOptionsPropertyToCloudFormation(properties.secondaryYAxisLabelOptions), Series: cdk.listMapper(cfnAnalysisSeriesItemPropertyToCloudFormation)(properties.series), SmallMultiplesOptions: cfnAnalysisSmallMultiplesOptionsPropertyToCloudFormation(properties.smallMultiplesOptions), SortConfiguration: cfnAnalysisLineChartSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), Tooltip: cfnAnalysisTooltipOptionsPropertyToCloudFormation(properties.tooltip), Type: cdk.stringToCloudFormation(properties.type), VisualPalette: cfnAnalysisVisualPalettePropertyToCloudFormation(properties.visualPalette), XAxisDisplayOptions: cfnAnalysisAxisDisplayOptionsPropertyToCloudFormation(properties.xAxisDisplayOptions), XAxisLabelOptions: cfnAnalysisChartAxisLabelOptionsPropertyToCloudFormation(properties.xAxisLabelOptions) }) : properties;
    }
    function CfnAnalysisLineChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contributionAnalysisDefaults", "ContributionAnalysisDefaults", properties.ContributionAnalysisDefaults != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisContributionAnalysisDefaultPropertyFromCloudFormation)(properties.ContributionAnalysisDefaults) : void 0), ret.addPropertyResult("dataLabels", "DataLabels", properties.DataLabels != null ? CfnAnalysisDataLabelOptionsPropertyFromCloudFormation(properties.DataLabels) : void 0), ret.addPropertyResult("defaultSeriesSettings", "DefaultSeriesSettings", properties.DefaultSeriesSettings != null ? CfnAnalysisLineChartDefaultSeriesSettingsPropertyFromCloudFormation(properties.DefaultSeriesSettings) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnAnalysisLineChartFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("forecastConfigurations", "ForecastConfigurations", properties.ForecastConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisForecastConfigurationPropertyFromCloudFormation)(properties.ForecastConfigurations) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnAnalysisLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("primaryYAxisDisplayOptions", "PrimaryYAxisDisplayOptions", properties.PrimaryYAxisDisplayOptions != null ? CfnAnalysisLineSeriesAxisDisplayOptionsPropertyFromCloudFormation(properties.PrimaryYAxisDisplayOptions) : void 0), ret.addPropertyResult("primaryYAxisLabelOptions", "PrimaryYAxisLabelOptions", properties.PrimaryYAxisLabelOptions != null ? CfnAnalysisChartAxisLabelOptionsPropertyFromCloudFormation(properties.PrimaryYAxisLabelOptions) : void 0), ret.addPropertyResult("referenceLines", "ReferenceLines", properties.ReferenceLines != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisReferenceLinePropertyFromCloudFormation)(properties.ReferenceLines) : void 0), ret.addPropertyResult("secondaryYAxisDisplayOptions", "SecondaryYAxisDisplayOptions", properties.SecondaryYAxisDisplayOptions != null ? CfnAnalysisLineSeriesAxisDisplayOptionsPropertyFromCloudFormation(properties.SecondaryYAxisDisplayOptions) : void 0), ret.addPropertyResult("secondaryYAxisLabelOptions", "SecondaryYAxisLabelOptions", properties.SecondaryYAxisLabelOptions != null ? CfnAnalysisChartAxisLabelOptionsPropertyFromCloudFormation(properties.SecondaryYAxisLabelOptions) : void 0), ret.addPropertyResult("series", "Series", properties.Series != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisSeriesItemPropertyFromCloudFormation)(properties.Series) : void 0), ret.addPropertyResult("smallMultiplesOptions", "SmallMultiplesOptions", properties.SmallMultiplesOptions != null ? CfnAnalysisSmallMultiplesOptionsPropertyFromCloudFormation(properties.SmallMultiplesOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnAnalysisLineChartSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnAnalysisTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnAnalysisVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addPropertyResult("xAxisDisplayOptions", "XAxisDisplayOptions", properties.XAxisDisplayOptions != null ? CfnAnalysisAxisDisplayOptionsPropertyFromCloudFormation(properties.XAxisDisplayOptions) : void 0), ret.addPropertyResult("xAxisLabelOptions", "XAxisLabelOptions", properties.XAxisLabelOptions != null ? CfnAnalysisChartAxisLabelOptionsPropertyFromCloudFormation(properties.XAxisLabelOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_LineChartDefaultSeriesSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("axisBinding", cdk.validateString)(properties.axisBinding)), errors.collect(cdk.propertyValidator("lineStyleSettings", CfnAnalysis_LineChartLineStyleSettingsPropertyValidator)(properties.lineStyleSettings)), errors.collect(cdk.propertyValidator("markerStyleSettings", CfnAnalysis_LineChartMarkerStyleSettingsPropertyValidator)(properties.markerStyleSettings)), errors.wrap('supplied properties not correct for "LineChartDefaultSeriesSettingsProperty"');
    }
    function cfnAnalysisLineChartDefaultSeriesSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_LineChartDefaultSeriesSettingsPropertyValidator(properties).assertSuccess(), { AxisBinding: cdk.stringToCloudFormation(properties.axisBinding), LineStyleSettings: cfnAnalysisLineChartLineStyleSettingsPropertyToCloudFormation(properties.lineStyleSettings), MarkerStyleSettings: cfnAnalysisLineChartMarkerStyleSettingsPropertyToCloudFormation(properties.markerStyleSettings) }) : properties;
    }
    function CfnAnalysisLineChartDefaultSeriesSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("axisBinding", "AxisBinding", properties.AxisBinding != null ? cfn_parse.FromCloudFormation.getString(properties.AxisBinding) : void 0), ret.addPropertyResult("lineStyleSettings", "LineStyleSettings", properties.LineStyleSettings != null ? CfnAnalysisLineChartLineStyleSettingsPropertyFromCloudFormation(properties.LineStyleSettings) : void 0), ret.addPropertyResult("markerStyleSettings", "MarkerStyleSettings", properties.MarkerStyleSettings != null ? CfnAnalysisLineChartMarkerStyleSettingsPropertyFromCloudFormation(properties.MarkerStyleSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_LineChartFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("lineChartAggregatedFieldWells", CfnAnalysis_LineChartAggregatedFieldWellsPropertyValidator)(properties.lineChartAggregatedFieldWells)), errors.wrap('supplied properties not correct for "LineChartFieldWellsProperty"');
    }
    function cfnAnalysisLineChartFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_LineChartFieldWellsPropertyValidator(properties).assertSuccess(), { LineChartAggregatedFieldWells: cfnAnalysisLineChartAggregatedFieldWellsPropertyToCloudFormation(properties.lineChartAggregatedFieldWells) }) : properties;
    }
    function CfnAnalysisLineChartFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("lineChartAggregatedFieldWells", "LineChartAggregatedFieldWells", properties.LineChartAggregatedFieldWells != null ? CfnAnalysisLineChartAggregatedFieldWellsPropertyFromCloudFormation(properties.LineChartAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_LineChartLineStyleSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("lineInterpolation", cdk.validateString)(properties.lineInterpolation)), errors.collect(cdk.propertyValidator("lineStyle", cdk.validateString)(properties.lineStyle)), errors.collect(cdk.propertyValidator("lineVisibility", cdk.validateString)(properties.lineVisibility)), errors.collect(cdk.propertyValidator("lineWidth", cdk.validateString)(properties.lineWidth)), errors.wrap('supplied properties not correct for "LineChartLineStyleSettingsProperty"');
    }
    function cfnAnalysisLineChartLineStyleSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_LineChartLineStyleSettingsPropertyValidator(properties).assertSuccess(), { LineInterpolation: cdk.stringToCloudFormation(properties.lineInterpolation), LineStyle: cdk.stringToCloudFormation(properties.lineStyle), LineVisibility: cdk.stringToCloudFormation(properties.lineVisibility), LineWidth: cdk.stringToCloudFormation(properties.lineWidth) }) : properties;
    }
    function CfnAnalysisLineChartLineStyleSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("lineInterpolation", "LineInterpolation", properties.LineInterpolation != null ? cfn_parse.FromCloudFormation.getString(properties.LineInterpolation) : void 0), ret.addPropertyResult("lineStyle", "LineStyle", properties.LineStyle != null ? cfn_parse.FromCloudFormation.getString(properties.LineStyle) : void 0), ret.addPropertyResult("lineVisibility", "LineVisibility", properties.LineVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.LineVisibility) : void 0), ret.addPropertyResult("lineWidth", "LineWidth", properties.LineWidth != null ? cfn_parse.FromCloudFormation.getString(properties.LineWidth) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_LineChartMarkerStyleSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("markerColor", cdk.validateString)(properties.markerColor)), errors.collect(cdk.propertyValidator("markerShape", cdk.validateString)(properties.markerShape)), errors.collect(cdk.propertyValidator("markerSize", cdk.validateString)(properties.markerSize)), errors.collect(cdk.propertyValidator("markerVisibility", cdk.validateString)(properties.markerVisibility)), errors.wrap('supplied properties not correct for "LineChartMarkerStyleSettingsProperty"');
    }
    function cfnAnalysisLineChartMarkerStyleSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_LineChartMarkerStyleSettingsPropertyValidator(properties).assertSuccess(), { MarkerColor: cdk.stringToCloudFormation(properties.markerColor), MarkerShape: cdk.stringToCloudFormation(properties.markerShape), MarkerSize: cdk.stringToCloudFormation(properties.markerSize), MarkerVisibility: cdk.stringToCloudFormation(properties.markerVisibility) }) : properties;
    }
    function CfnAnalysisLineChartMarkerStyleSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("markerColor", "MarkerColor", properties.MarkerColor != null ? cfn_parse.FromCloudFormation.getString(properties.MarkerColor) : void 0), ret.addPropertyResult("markerShape", "MarkerShape", properties.MarkerShape != null ? cfn_parse.FromCloudFormation.getString(properties.MarkerShape) : void 0), ret.addPropertyResult("markerSize", "MarkerSize", properties.MarkerSize != null ? cfn_parse.FromCloudFormation.getString(properties.MarkerSize) : void 0), ret.addPropertyResult("markerVisibility", "MarkerVisibility", properties.MarkerVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.MarkerVisibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_LineChartSeriesSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("lineStyleSettings", CfnAnalysis_LineChartLineStyleSettingsPropertyValidator)(properties.lineStyleSettings)), errors.collect(cdk.propertyValidator("markerStyleSettings", CfnAnalysis_LineChartMarkerStyleSettingsPropertyValidator)(properties.markerStyleSettings)), errors.wrap('supplied properties not correct for "LineChartSeriesSettingsProperty"');
    }
    function cfnAnalysisLineChartSeriesSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_LineChartSeriesSettingsPropertyValidator(properties).assertSuccess(), { LineStyleSettings: cfnAnalysisLineChartLineStyleSettingsPropertyToCloudFormation(properties.lineStyleSettings), MarkerStyleSettings: cfnAnalysisLineChartMarkerStyleSettingsPropertyToCloudFormation(properties.markerStyleSettings) }) : properties;
    }
    function CfnAnalysisLineChartSeriesSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("lineStyleSettings", "LineStyleSettings", properties.LineStyleSettings != null ? CfnAnalysisLineChartLineStyleSettingsPropertyFromCloudFormation(properties.LineStyleSettings) : void 0), ret.addPropertyResult("markerStyleSettings", "MarkerStyleSettings", properties.MarkerStyleSettings != null ? CfnAnalysisLineChartMarkerStyleSettingsPropertyFromCloudFormation(properties.MarkerStyleSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_LineChartSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryItemsLimitConfiguration", CfnAnalysis_ItemsLimitConfigurationPropertyValidator)(properties.categoryItemsLimitConfiguration)), errors.collect(cdk.propertyValidator("categorySort", cdk.listValidator(CfnAnalysis_FieldSortOptionsPropertyValidator))(properties.categorySort)), errors.collect(cdk.propertyValidator("colorItemsLimitConfiguration", CfnAnalysis_ItemsLimitConfigurationPropertyValidator)(properties.colorItemsLimitConfiguration)), errors.collect(cdk.propertyValidator("smallMultiplesLimitConfiguration", CfnAnalysis_ItemsLimitConfigurationPropertyValidator)(properties.smallMultiplesLimitConfiguration)), errors.collect(cdk.propertyValidator("smallMultiplesSort", cdk.listValidator(CfnAnalysis_FieldSortOptionsPropertyValidator))(properties.smallMultiplesSort)), errors.wrap('supplied properties not correct for "LineChartSortConfigurationProperty"');
    }
    function cfnAnalysisLineChartSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_LineChartSortConfigurationPropertyValidator(properties).assertSuccess(), { CategoryItemsLimitConfiguration: cfnAnalysisItemsLimitConfigurationPropertyToCloudFormation(properties.categoryItemsLimitConfiguration), CategorySort: cdk.listMapper(cfnAnalysisFieldSortOptionsPropertyToCloudFormation)(properties.categorySort), ColorItemsLimitConfiguration: cfnAnalysisItemsLimitConfigurationPropertyToCloudFormation(properties.colorItemsLimitConfiguration), SmallMultiplesLimitConfiguration: cfnAnalysisItemsLimitConfigurationPropertyToCloudFormation(properties.smallMultiplesLimitConfiguration), SmallMultiplesSort: cdk.listMapper(cfnAnalysisFieldSortOptionsPropertyToCloudFormation)(properties.smallMultiplesSort) }) : properties;
    }
    function CfnAnalysisLineChartSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryItemsLimitConfiguration", "CategoryItemsLimitConfiguration", properties.CategoryItemsLimitConfiguration != null ? CfnAnalysisItemsLimitConfigurationPropertyFromCloudFormation(properties.CategoryItemsLimitConfiguration) : void 0), ret.addPropertyResult("categorySort", "CategorySort", properties.CategorySort != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisFieldSortOptionsPropertyFromCloudFormation)(properties.CategorySort) : void 0), ret.addPropertyResult("colorItemsLimitConfiguration", "ColorItemsLimitConfiguration", properties.ColorItemsLimitConfiguration != null ? CfnAnalysisItemsLimitConfigurationPropertyFromCloudFormation(properties.ColorItemsLimitConfiguration) : void 0), ret.addPropertyResult("smallMultiplesLimitConfiguration", "SmallMultiplesLimitConfiguration", properties.SmallMultiplesLimitConfiguration != null ? CfnAnalysisItemsLimitConfigurationPropertyFromCloudFormation(properties.SmallMultiplesLimitConfiguration) : void 0), ret.addPropertyResult("smallMultiplesSort", "SmallMultiplesSort", properties.SmallMultiplesSort != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisFieldSortOptionsPropertyFromCloudFormation)(properties.SmallMultiplesSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_LineChartVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnAnalysis_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnAnalysis_LineChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnAnalysis_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnAnalysis_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnAnalysis_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "LineChartVisualProperty"');
    }
    function cfnAnalysisLineChartVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_LineChartVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnAnalysisVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnAnalysisLineChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnAnalysisColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnAnalysisVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnAnalysisVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnAnalysisLineChartVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnAnalysisLineChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnAnalysisVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnAnalysisVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_LineSeriesAxisDisplayOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("axisOptions", CfnAnalysis_AxisDisplayOptionsPropertyValidator)(properties.axisOptions)), errors.collect(cdk.propertyValidator("missingDataConfigurations", cdk.listValidator(CfnAnalysis_MissingDataConfigurationPropertyValidator))(properties.missingDataConfigurations)), errors.wrap('supplied properties not correct for "LineSeriesAxisDisplayOptionsProperty"');
    }
    function cfnAnalysisLineSeriesAxisDisplayOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_LineSeriesAxisDisplayOptionsPropertyValidator(properties).assertSuccess(), { AxisOptions: cfnAnalysisAxisDisplayOptionsPropertyToCloudFormation(properties.axisOptions), MissingDataConfigurations: cdk.listMapper(cfnAnalysisMissingDataConfigurationPropertyToCloudFormation)(properties.missingDataConfigurations) }) : properties;
    }
    function CfnAnalysisLineSeriesAxisDisplayOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("axisOptions", "AxisOptions", properties.AxisOptions != null ? CfnAnalysisAxisDisplayOptionsPropertyFromCloudFormation(properties.AxisOptions) : void 0), ret.addPropertyResult("missingDataConfigurations", "MissingDataConfigurations", properties.MissingDataConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMissingDataConfigurationPropertyFromCloudFormation)(properties.MissingDataConfigurations) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ListControlDisplayOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("searchOptions", CfnAnalysis_ListControlSearchOptionsPropertyValidator)(properties.searchOptions)), errors.collect(cdk.propertyValidator("selectAllOptions", CfnAnalysis_ListControlSelectAllOptionsPropertyValidator)(properties.selectAllOptions)), errors.collect(cdk.propertyValidator("titleOptions", CfnAnalysis_LabelOptionsPropertyValidator)(properties.titleOptions)), errors.wrap('supplied properties not correct for "ListControlDisplayOptionsProperty"');
    }
    function cfnAnalysisListControlDisplayOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ListControlDisplayOptionsPropertyValidator(properties).assertSuccess(), { SearchOptions: cfnAnalysisListControlSearchOptionsPropertyToCloudFormation(properties.searchOptions), SelectAllOptions: cfnAnalysisListControlSelectAllOptionsPropertyToCloudFormation(properties.selectAllOptions), TitleOptions: cfnAnalysisLabelOptionsPropertyToCloudFormation(properties.titleOptions) }) : properties;
    }
    function CfnAnalysisListControlDisplayOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("searchOptions", "SearchOptions", properties.SearchOptions != null ? CfnAnalysisListControlSearchOptionsPropertyFromCloudFormation(properties.SearchOptions) : void 0), ret.addPropertyResult("selectAllOptions", "SelectAllOptions", properties.SelectAllOptions != null ? CfnAnalysisListControlSelectAllOptionsPropertyFromCloudFormation(properties.SelectAllOptions) : void 0), ret.addPropertyResult("titleOptions", "TitleOptions", properties.TitleOptions != null ? CfnAnalysisLabelOptionsPropertyFromCloudFormation(properties.TitleOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ListControlSearchOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "ListControlSearchOptionsProperty"');
    }
    function cfnAnalysisListControlSearchOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ListControlSearchOptionsPropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnAnalysisListControlSearchOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ListControlSelectAllOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "ListControlSelectAllOptionsProperty"');
    }
    function cfnAnalysisListControlSelectAllOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ListControlSelectAllOptionsPropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnAnalysisListControlSelectAllOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_LoadingAnimationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "LoadingAnimationProperty"');
    }
    function cfnAnalysisLoadingAnimationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_LoadingAnimationPropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnAnalysisLoadingAnimationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_LocalNavigationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("targetSheetId", cdk.requiredValidator)(properties.targetSheetId)), errors.collect(cdk.propertyValidator("targetSheetId", cdk.validateString)(properties.targetSheetId)), errors.wrap('supplied properties not correct for "LocalNavigationConfigurationProperty"');
    }
    function cfnAnalysisLocalNavigationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_LocalNavigationConfigurationPropertyValidator(properties).assertSuccess(), { TargetSheetId: cdk.stringToCloudFormation(properties.targetSheetId) }) : properties;
    }
    function CfnAnalysisLocalNavigationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("targetSheetId", "TargetSheetId", cfn_parse.FromCloudFormation.getString(properties.TargetSheetId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_LongFormatTextPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("plainText", cdk.validateString)(properties.plainText)), errors.collect(cdk.propertyValidator("richText", cdk.validateString)(properties.richText)), errors.wrap('supplied properties not correct for "LongFormatTextProperty"');
    }
    function cfnAnalysisLongFormatTextPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_LongFormatTextPropertyValidator(properties).assertSuccess(), { PlainText: cdk.stringToCloudFormation(properties.plainText), RichText: cdk.stringToCloudFormation(properties.richText) }) : properties;
    }
    function CfnAnalysisLongFormatTextPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("plainText", "PlainText", properties.PlainText != null ? cfn_parse.FromCloudFormation.getString(properties.PlainText) : void 0), ret.addPropertyResult("richText", "RichText", properties.RichText != null ? cfn_parse.FromCloudFormation.getString(properties.RichText) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_MappedDataSetParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.requiredValidator)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.validateString)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("dataSetParameterName", cdk.requiredValidator)(properties.dataSetParameterName)), errors.collect(cdk.propertyValidator("dataSetParameterName", cdk.validateString)(properties.dataSetParameterName)), errors.wrap('supplied properties not correct for "MappedDataSetParameterProperty"');
    }
    function cfnAnalysisMappedDataSetParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_MappedDataSetParameterPropertyValidator(properties).assertSuccess(), { DataSetIdentifier: cdk.stringToCloudFormation(properties.dataSetIdentifier), DataSetParameterName: cdk.stringToCloudFormation(properties.dataSetParameterName) }) : properties;
    }
    function CfnAnalysisMappedDataSetParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataSetIdentifier", "DataSetIdentifier", cfn_parse.FromCloudFormation.getString(properties.DataSetIdentifier)), ret.addPropertyResult("dataSetParameterName", "DataSetParameterName", cfn_parse.FromCloudFormation.getString(properties.DataSetParameterName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_MaximumLabelTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "MaximumLabelTypeProperty"');
    }
    function cfnAnalysisMaximumLabelTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_MaximumLabelTypePropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnAnalysisMaximumLabelTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_MaximumMinimumComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computationId", cdk.requiredValidator)(properties.computationId)), errors.collect(cdk.propertyValidator("computationId", cdk.validateString)(properties.computationId)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("time", cdk.requiredValidator)(properties.time)), errors.collect(cdk.propertyValidator("time", CfnAnalysis_DimensionFieldPropertyValidator)(properties.time)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", CfnAnalysis_MeasureFieldPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "MaximumMinimumComputationProperty"');
    }
    function cfnAnalysisMaximumMinimumComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_MaximumMinimumComputationPropertyValidator(properties).assertSuccess(), { ComputationId: cdk.stringToCloudFormation(properties.computationId), Name: cdk.stringToCloudFormation(properties.name), Time: cfnAnalysisDimensionFieldPropertyToCloudFormation(properties.time), Type: cdk.stringToCloudFormation(properties.type), Value: cfnAnalysisMeasureFieldPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnAnalysisMaximumMinimumComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computationId", "ComputationId", cfn_parse.FromCloudFormation.getString(properties.ComputationId)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("time", "Time", CfnAnalysisDimensionFieldPropertyFromCloudFormation(properties.Time)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("value", "Value", properties.Value != null ? CfnAnalysisMeasureFieldPropertyFromCloudFormation(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_MeasureFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("calculatedMeasureField", CfnAnalysis_CalculatedMeasureFieldPropertyValidator)(properties.calculatedMeasureField)), errors.collect(cdk.propertyValidator("categoricalMeasureField", CfnAnalysis_CategoricalMeasureFieldPropertyValidator)(properties.categoricalMeasureField)), errors.collect(cdk.propertyValidator("dateMeasureField", CfnAnalysis_DateMeasureFieldPropertyValidator)(properties.dateMeasureField)), errors.collect(cdk.propertyValidator("numericalMeasureField", CfnAnalysis_NumericalMeasureFieldPropertyValidator)(properties.numericalMeasureField)), errors.wrap('supplied properties not correct for "MeasureFieldProperty"');
    }
    function cfnAnalysisMeasureFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_MeasureFieldPropertyValidator(properties).assertSuccess(), { CalculatedMeasureField: cfnAnalysisCalculatedMeasureFieldPropertyToCloudFormation(properties.calculatedMeasureField), CategoricalMeasureField: cfnAnalysisCategoricalMeasureFieldPropertyToCloudFormation(properties.categoricalMeasureField), DateMeasureField: cfnAnalysisDateMeasureFieldPropertyToCloudFormation(properties.dateMeasureField), NumericalMeasureField: cfnAnalysisNumericalMeasureFieldPropertyToCloudFormation(properties.numericalMeasureField) }) : properties;
    }
    function CfnAnalysisMeasureFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("calculatedMeasureField", "CalculatedMeasureField", properties.CalculatedMeasureField != null ? CfnAnalysisCalculatedMeasureFieldPropertyFromCloudFormation(properties.CalculatedMeasureField) : void 0), ret.addPropertyResult("categoricalMeasureField", "CategoricalMeasureField", properties.CategoricalMeasureField != null ? CfnAnalysisCategoricalMeasureFieldPropertyFromCloudFormation(properties.CategoricalMeasureField) : void 0), ret.addPropertyResult("dateMeasureField", "DateMeasureField", properties.DateMeasureField != null ? CfnAnalysisDateMeasureFieldPropertyFromCloudFormation(properties.DateMeasureField) : void 0), ret.addPropertyResult("numericalMeasureField", "NumericalMeasureField", properties.NumericalMeasureField != null ? CfnAnalysisNumericalMeasureFieldPropertyFromCloudFormation(properties.NumericalMeasureField) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_MetricComparisonComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computationId", cdk.requiredValidator)(properties.computationId)), errors.collect(cdk.propertyValidator("computationId", cdk.validateString)(properties.computationId)), errors.collect(cdk.propertyValidator("fromValue", cdk.requiredValidator)(properties.fromValue)), errors.collect(cdk.propertyValidator("fromValue", CfnAnalysis_MeasureFieldPropertyValidator)(properties.fromValue)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("targetValue", cdk.requiredValidator)(properties.targetValue)), errors.collect(cdk.propertyValidator("targetValue", CfnAnalysis_MeasureFieldPropertyValidator)(properties.targetValue)), errors.collect(cdk.propertyValidator("time", cdk.requiredValidator)(properties.time)), errors.collect(cdk.propertyValidator("time", CfnAnalysis_DimensionFieldPropertyValidator)(properties.time)), errors.wrap('supplied properties not correct for "MetricComparisonComputationProperty"');
    }
    function cfnAnalysisMetricComparisonComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_MetricComparisonComputationPropertyValidator(properties).assertSuccess(), { ComputationId: cdk.stringToCloudFormation(properties.computationId), FromValue: cfnAnalysisMeasureFieldPropertyToCloudFormation(properties.fromValue), Name: cdk.stringToCloudFormation(properties.name), TargetValue: cfnAnalysisMeasureFieldPropertyToCloudFormation(properties.targetValue), Time: cfnAnalysisDimensionFieldPropertyToCloudFormation(properties.time) }) : properties;
    }
    function CfnAnalysisMetricComparisonComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computationId", "ComputationId", cfn_parse.FromCloudFormation.getString(properties.ComputationId)), ret.addPropertyResult("fromValue", "FromValue", CfnAnalysisMeasureFieldPropertyFromCloudFormation(properties.FromValue)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("targetValue", "TargetValue", CfnAnalysisMeasureFieldPropertyFromCloudFormation(properties.TargetValue)), ret.addPropertyResult("time", "Time", CfnAnalysisDimensionFieldPropertyFromCloudFormation(properties.Time)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_MinimumLabelTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "MinimumLabelTypeProperty"');
    }
    function cfnAnalysisMinimumLabelTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_MinimumLabelTypePropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnAnalysisMinimumLabelTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_MissingDataConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("treatmentOption", cdk.validateString)(properties.treatmentOption)), errors.wrap('supplied properties not correct for "MissingDataConfigurationProperty"');
    }
    function cfnAnalysisMissingDataConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_MissingDataConfigurationPropertyValidator(properties).assertSuccess(), { TreatmentOption: cdk.stringToCloudFormation(properties.treatmentOption) }) : properties;
    }
    function CfnAnalysisMissingDataConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("treatmentOption", "TreatmentOption", properties.TreatmentOption != null ? cfn_parse.FromCloudFormation.getString(properties.TreatmentOption) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_NegativeValueConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("displayMode", cdk.requiredValidator)(properties.displayMode)), errors.collect(cdk.propertyValidator("displayMode", cdk.validateString)(properties.displayMode)), errors.wrap('supplied properties not correct for "NegativeValueConfigurationProperty"');
    }
    function cfnAnalysisNegativeValueConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_NegativeValueConfigurationPropertyValidator(properties).assertSuccess(), { DisplayMode: cdk.stringToCloudFormation(properties.displayMode) }) : properties;
    }
    function CfnAnalysisNegativeValueConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("displayMode", "DisplayMode", cfn_parse.FromCloudFormation.getString(properties.DisplayMode)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_NullValueFormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("nullString", cdk.requiredValidator)(properties.nullString)), errors.collect(cdk.propertyValidator("nullString", cdk.validateString)(properties.nullString)), errors.wrap('supplied properties not correct for "NullValueFormatConfigurationProperty"');
    }
    function cfnAnalysisNullValueFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_NullValueFormatConfigurationPropertyValidator(properties).assertSuccess(), { NullString: cdk.stringToCloudFormation(properties.nullString) }) : properties;
    }
    function CfnAnalysisNullValueFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("nullString", "NullString", cfn_parse.FromCloudFormation.getString(properties.NullString)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_NumberDisplayFormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("decimalPlacesConfiguration", CfnAnalysis_DecimalPlacesConfigurationPropertyValidator)(properties.decimalPlacesConfiguration)), errors.collect(cdk.propertyValidator("negativeValueConfiguration", CfnAnalysis_NegativeValueConfigurationPropertyValidator)(properties.negativeValueConfiguration)), errors.collect(cdk.propertyValidator("nullValueFormatConfiguration", CfnAnalysis_NullValueFormatConfigurationPropertyValidator)(properties.nullValueFormatConfiguration)), errors.collect(cdk.propertyValidator("numberScale", cdk.validateString)(properties.numberScale)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.collect(cdk.propertyValidator("separatorConfiguration", CfnAnalysis_NumericSeparatorConfigurationPropertyValidator)(properties.separatorConfiguration)), errors.collect(cdk.propertyValidator("suffix", cdk.validateString)(properties.suffix)), errors.wrap('supplied properties not correct for "NumberDisplayFormatConfigurationProperty"');
    }
    function cfnAnalysisNumberDisplayFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_NumberDisplayFormatConfigurationPropertyValidator(properties).assertSuccess(), { DecimalPlacesConfiguration: cfnAnalysisDecimalPlacesConfigurationPropertyToCloudFormation(properties.decimalPlacesConfiguration), NegativeValueConfiguration: cfnAnalysisNegativeValueConfigurationPropertyToCloudFormation(properties.negativeValueConfiguration), NullValueFormatConfiguration: cfnAnalysisNullValueFormatConfigurationPropertyToCloudFormation(properties.nullValueFormatConfiguration), NumberScale: cdk.stringToCloudFormation(properties.numberScale), Prefix: cdk.stringToCloudFormation(properties.prefix), SeparatorConfiguration: cfnAnalysisNumericSeparatorConfigurationPropertyToCloudFormation(properties.separatorConfiguration), Suffix: cdk.stringToCloudFormation(properties.suffix) }) : properties;
    }
    function CfnAnalysisNumberDisplayFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("decimalPlacesConfiguration", "DecimalPlacesConfiguration", properties.DecimalPlacesConfiguration != null ? CfnAnalysisDecimalPlacesConfigurationPropertyFromCloudFormation(properties.DecimalPlacesConfiguration) : void 0), ret.addPropertyResult("negativeValueConfiguration", "NegativeValueConfiguration", properties.NegativeValueConfiguration != null ? CfnAnalysisNegativeValueConfigurationPropertyFromCloudFormation(properties.NegativeValueConfiguration) : void 0), ret.addPropertyResult("nullValueFormatConfiguration", "NullValueFormatConfiguration", properties.NullValueFormatConfiguration != null ? CfnAnalysisNullValueFormatConfigurationPropertyFromCloudFormation(properties.NullValueFormatConfiguration) : void 0), ret.addPropertyResult("numberScale", "NumberScale", properties.NumberScale != null ? cfn_parse.FromCloudFormation.getString(properties.NumberScale) : void 0), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addPropertyResult("separatorConfiguration", "SeparatorConfiguration", properties.SeparatorConfiguration != null ? CfnAnalysisNumericSeparatorConfigurationPropertyFromCloudFormation(properties.SeparatorConfiguration) : void 0), ret.addPropertyResult("suffix", "Suffix", properties.Suffix != null ? cfn_parse.FromCloudFormation.getString(properties.Suffix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_NumberFormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("formatConfiguration", CfnAnalysis_NumericFormatConfigurationPropertyValidator)(properties.formatConfiguration)), errors.wrap('supplied properties not correct for "NumberFormatConfigurationProperty"');
    }
    function cfnAnalysisNumberFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_NumberFormatConfigurationPropertyValidator(properties).assertSuccess(), { FormatConfiguration: cfnAnalysisNumericFormatConfigurationPropertyToCloudFormation(properties.formatConfiguration) }) : properties;
    }
    function CfnAnalysisNumberFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("formatConfiguration", "FormatConfiguration", properties.FormatConfiguration != null ? CfnAnalysisNumericFormatConfigurationPropertyFromCloudFormation(properties.FormatConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_NumericAxisOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("range", CfnAnalysis_AxisDisplayRangePropertyValidator)(properties.range)), errors.collect(cdk.propertyValidator("scale", CfnAnalysis_AxisScalePropertyValidator)(properties.scale)), errors.wrap('supplied properties not correct for "NumericAxisOptionsProperty"');
    }
    function cfnAnalysisNumericAxisOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_NumericAxisOptionsPropertyValidator(properties).assertSuccess(), { Range: cfnAnalysisAxisDisplayRangePropertyToCloudFormation(properties.range), Scale: cfnAnalysisAxisScalePropertyToCloudFormation(properties.scale) }) : properties;
    }
    function CfnAnalysisNumericAxisOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("range", "Range", properties.Range != null ? CfnAnalysisAxisDisplayRangePropertyFromCloudFormation(properties.Range) : void 0), ret.addPropertyResult("scale", "Scale", properties.Scale != null ? CfnAnalysisAxisScalePropertyFromCloudFormation(properties.Scale) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_NumericEqualityDrillDownFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnAnalysis_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "NumericEqualityDrillDownFilterProperty"');
    }
    function cfnAnalysisNumericEqualityDrillDownFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_NumericEqualityDrillDownFilterPropertyValidator(properties).assertSuccess(), { Column: cfnAnalysisColumnIdentifierPropertyToCloudFormation(properties.column), Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnAnalysisNumericEqualityDrillDownFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", CfnAnalysisColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getNumber(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_NumericEqualityFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationFunction", CfnAnalysis_AggregationFunctionPropertyValidator)(properties.aggregationFunction)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnAnalysis_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("filterId", cdk.requiredValidator)(properties.filterId)), errors.collect(cdk.propertyValidator("filterId", cdk.validateString)(properties.filterId)), errors.collect(cdk.propertyValidator("matchOperator", cdk.requiredValidator)(properties.matchOperator)), errors.collect(cdk.propertyValidator("matchOperator", cdk.validateString)(properties.matchOperator)), errors.collect(cdk.propertyValidator("nullOption", cdk.requiredValidator)(properties.nullOption)), errors.collect(cdk.propertyValidator("nullOption", cdk.validateString)(properties.nullOption)), errors.collect(cdk.propertyValidator("parameterName", cdk.validateString)(properties.parameterName)), errors.collect(cdk.propertyValidator("selectAllOptions", cdk.validateString)(properties.selectAllOptions)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "NumericEqualityFilterProperty"');
    }
    function cfnAnalysisNumericEqualityFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_NumericEqualityFilterPropertyValidator(properties).assertSuccess(), { AggregationFunction: cfnAnalysisAggregationFunctionPropertyToCloudFormation(properties.aggregationFunction), Column: cfnAnalysisColumnIdentifierPropertyToCloudFormation(properties.column), FilterId: cdk.stringToCloudFormation(properties.filterId), MatchOperator: cdk.stringToCloudFormation(properties.matchOperator), NullOption: cdk.stringToCloudFormation(properties.nullOption), ParameterName: cdk.stringToCloudFormation(properties.parameterName), SelectAllOptions: cdk.stringToCloudFormation(properties.selectAllOptions), Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnAnalysisNumericEqualityFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationFunction", "AggregationFunction", properties.AggregationFunction != null ? CfnAnalysisAggregationFunctionPropertyFromCloudFormation(properties.AggregationFunction) : void 0), ret.addPropertyResult("column", "Column", CfnAnalysisColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("filterId", "FilterId", cfn_parse.FromCloudFormation.getString(properties.FilterId)), ret.addPropertyResult("matchOperator", "MatchOperator", cfn_parse.FromCloudFormation.getString(properties.MatchOperator)), ret.addPropertyResult("nullOption", "NullOption", cfn_parse.FromCloudFormation.getString(properties.NullOption)), ret.addPropertyResult("parameterName", "ParameterName", properties.ParameterName != null ? cfn_parse.FromCloudFormation.getString(properties.ParameterName) : void 0), ret.addPropertyResult("selectAllOptions", "SelectAllOptions", properties.SelectAllOptions != null ? cfn_parse.FromCloudFormation.getString(properties.SelectAllOptions) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getNumber(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_NumericFormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("currencyDisplayFormatConfiguration", CfnAnalysis_CurrencyDisplayFormatConfigurationPropertyValidator)(properties.currencyDisplayFormatConfiguration)), errors.collect(cdk.propertyValidator("numberDisplayFormatConfiguration", CfnAnalysis_NumberDisplayFormatConfigurationPropertyValidator)(properties.numberDisplayFormatConfiguration)), errors.collect(cdk.propertyValidator("percentageDisplayFormatConfiguration", CfnAnalysis_PercentageDisplayFormatConfigurationPropertyValidator)(properties.percentageDisplayFormatConfiguration)), errors.wrap('supplied properties not correct for "NumericFormatConfigurationProperty"');
    }
    function cfnAnalysisNumericFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_NumericFormatConfigurationPropertyValidator(properties).assertSuccess(), { CurrencyDisplayFormatConfiguration: cfnAnalysisCurrencyDisplayFormatConfigurationPropertyToCloudFormation(properties.currencyDisplayFormatConfiguration), NumberDisplayFormatConfiguration: cfnAnalysisNumberDisplayFormatConfigurationPropertyToCloudFormation(properties.numberDisplayFormatConfiguration), PercentageDisplayFormatConfiguration: cfnAnalysisPercentageDisplayFormatConfigurationPropertyToCloudFormation(properties.percentageDisplayFormatConfiguration) }) : properties;
    }
    function CfnAnalysisNumericFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("currencyDisplayFormatConfiguration", "CurrencyDisplayFormatConfiguration", properties.CurrencyDisplayFormatConfiguration != null ? CfnAnalysisCurrencyDisplayFormatConfigurationPropertyFromCloudFormation(properties.CurrencyDisplayFormatConfiguration) : void 0), ret.addPropertyResult("numberDisplayFormatConfiguration", "NumberDisplayFormatConfiguration", properties.NumberDisplayFormatConfiguration != null ? CfnAnalysisNumberDisplayFormatConfigurationPropertyFromCloudFormation(properties.NumberDisplayFormatConfiguration) : void 0), ret.addPropertyResult("percentageDisplayFormatConfiguration", "PercentageDisplayFormatConfiguration", properties.PercentageDisplayFormatConfiguration != null ? CfnAnalysisPercentageDisplayFormatConfigurationPropertyFromCloudFormation(properties.PercentageDisplayFormatConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_NumericRangeFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationFunction", CfnAnalysis_AggregationFunctionPropertyValidator)(properties.aggregationFunction)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnAnalysis_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("filterId", cdk.requiredValidator)(properties.filterId)), errors.collect(cdk.propertyValidator("filterId", cdk.validateString)(properties.filterId)), errors.collect(cdk.propertyValidator("includeMaximum", cdk.validateBoolean)(properties.includeMaximum)), errors.collect(cdk.propertyValidator("includeMinimum", cdk.validateBoolean)(properties.includeMinimum)), errors.collect(cdk.propertyValidator("nullOption", cdk.requiredValidator)(properties.nullOption)), errors.collect(cdk.propertyValidator("nullOption", cdk.validateString)(properties.nullOption)), errors.collect(cdk.propertyValidator("rangeMaximum", CfnAnalysis_NumericRangeFilterValuePropertyValidator)(properties.rangeMaximum)), errors.collect(cdk.propertyValidator("rangeMinimum", CfnAnalysis_NumericRangeFilterValuePropertyValidator)(properties.rangeMinimum)), errors.collect(cdk.propertyValidator("selectAllOptions", cdk.validateString)(properties.selectAllOptions)), errors.wrap('supplied properties not correct for "NumericRangeFilterProperty"');
    }
    function cfnAnalysisNumericRangeFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_NumericRangeFilterPropertyValidator(properties).assertSuccess(), { AggregationFunction: cfnAnalysisAggregationFunctionPropertyToCloudFormation(properties.aggregationFunction), Column: cfnAnalysisColumnIdentifierPropertyToCloudFormation(properties.column), FilterId: cdk.stringToCloudFormation(properties.filterId), IncludeMaximum: cdk.booleanToCloudFormation(properties.includeMaximum), IncludeMinimum: cdk.booleanToCloudFormation(properties.includeMinimum), NullOption: cdk.stringToCloudFormation(properties.nullOption), RangeMaximum: cfnAnalysisNumericRangeFilterValuePropertyToCloudFormation(properties.rangeMaximum), RangeMinimum: cfnAnalysisNumericRangeFilterValuePropertyToCloudFormation(properties.rangeMinimum), SelectAllOptions: cdk.stringToCloudFormation(properties.selectAllOptions) }) : properties;
    }
    function CfnAnalysisNumericRangeFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationFunction", "AggregationFunction", properties.AggregationFunction != null ? CfnAnalysisAggregationFunctionPropertyFromCloudFormation(properties.AggregationFunction) : void 0), ret.addPropertyResult("column", "Column", CfnAnalysisColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("filterId", "FilterId", cfn_parse.FromCloudFormation.getString(properties.FilterId)), ret.addPropertyResult("includeMaximum", "IncludeMaximum", properties.IncludeMaximum != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeMaximum) : void 0), ret.addPropertyResult("includeMinimum", "IncludeMinimum", properties.IncludeMinimum != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeMinimum) : void 0), ret.addPropertyResult("nullOption", "NullOption", cfn_parse.FromCloudFormation.getString(properties.NullOption)), ret.addPropertyResult("rangeMaximum", "RangeMaximum", properties.RangeMaximum != null ? CfnAnalysisNumericRangeFilterValuePropertyFromCloudFormation(properties.RangeMaximum) : void 0), ret.addPropertyResult("rangeMinimum", "RangeMinimum", properties.RangeMinimum != null ? CfnAnalysisNumericRangeFilterValuePropertyFromCloudFormation(properties.RangeMinimum) : void 0), ret.addPropertyResult("selectAllOptions", "SelectAllOptions", properties.SelectAllOptions != null ? cfn_parse.FromCloudFormation.getString(properties.SelectAllOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_NumericRangeFilterValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("parameter", cdk.validateString)(properties.parameter)), errors.collect(cdk.propertyValidator("staticValue", cdk.validateNumber)(properties.staticValue)), errors.wrap('supplied properties not correct for "NumericRangeFilterValueProperty"');
    }
    function cfnAnalysisNumericRangeFilterValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_NumericRangeFilterValuePropertyValidator(properties).assertSuccess(), { Parameter: cdk.stringToCloudFormation(properties.parameter), StaticValue: cdk.numberToCloudFormation(properties.staticValue) }) : properties;
    }
    function CfnAnalysisNumericRangeFilterValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("parameter", "Parameter", properties.Parameter != null ? cfn_parse.FromCloudFormation.getString(properties.Parameter) : void 0), ret.addPropertyResult("staticValue", "StaticValue", properties.StaticValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.StaticValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_NumericSeparatorConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("decimalSeparator", cdk.validateString)(properties.decimalSeparator)), errors.collect(cdk.propertyValidator("thousandsSeparator", CfnAnalysis_ThousandSeparatorOptionsPropertyValidator)(properties.thousandsSeparator)), errors.wrap('supplied properties not correct for "NumericSeparatorConfigurationProperty"');
    }
    function cfnAnalysisNumericSeparatorConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_NumericSeparatorConfigurationPropertyValidator(properties).assertSuccess(), { DecimalSeparator: cdk.stringToCloudFormation(properties.decimalSeparator), ThousandsSeparator: cfnAnalysisThousandSeparatorOptionsPropertyToCloudFormation(properties.thousandsSeparator) }) : properties;
    }
    function CfnAnalysisNumericSeparatorConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("decimalSeparator", "DecimalSeparator", properties.DecimalSeparator != null ? cfn_parse.FromCloudFormation.getString(properties.DecimalSeparator) : void 0), ret.addPropertyResult("thousandsSeparator", "ThousandsSeparator", properties.ThousandsSeparator != null ? CfnAnalysisThousandSeparatorOptionsPropertyFromCloudFormation(properties.ThousandsSeparator) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_NumericalAggregationFunctionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("percentileAggregation", CfnAnalysis_PercentileAggregationPropertyValidator)(properties.percentileAggregation)), errors.collect(cdk.propertyValidator("simpleNumericalAggregation", cdk.validateString)(properties.simpleNumericalAggregation)), errors.wrap('supplied properties not correct for "NumericalAggregationFunctionProperty"');
    }
    function cfnAnalysisNumericalAggregationFunctionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_NumericalAggregationFunctionPropertyValidator(properties).assertSuccess(), { PercentileAggregation: cfnAnalysisPercentileAggregationPropertyToCloudFormation(properties.percentileAggregation), SimpleNumericalAggregation: cdk.stringToCloudFormation(properties.simpleNumericalAggregation) }) : properties;
    }
    function CfnAnalysisNumericalAggregationFunctionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("percentileAggregation", "PercentileAggregation", properties.PercentileAggregation != null ? CfnAnalysisPercentileAggregationPropertyFromCloudFormation(properties.PercentileAggregation) : void 0), ret.addPropertyResult("simpleNumericalAggregation", "SimpleNumericalAggregation", properties.SimpleNumericalAggregation != null ? cfn_parse.FromCloudFormation.getString(properties.SimpleNumericalAggregation) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_NumericalDimensionFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnAnalysis_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("formatConfiguration", CfnAnalysis_NumberFormatConfigurationPropertyValidator)(properties.formatConfiguration)), errors.collect(cdk.propertyValidator("hierarchyId", cdk.validateString)(properties.hierarchyId)), errors.wrap('supplied properties not correct for "NumericalDimensionFieldProperty"');
    }
    function cfnAnalysisNumericalDimensionFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_NumericalDimensionFieldPropertyValidator(properties).assertSuccess(), { Column: cfnAnalysisColumnIdentifierPropertyToCloudFormation(properties.column), FieldId: cdk.stringToCloudFormation(properties.fieldId), FormatConfiguration: cfnAnalysisNumberFormatConfigurationPropertyToCloudFormation(properties.formatConfiguration), HierarchyId: cdk.stringToCloudFormation(properties.hierarchyId) }) : properties;
    }
    function CfnAnalysisNumericalDimensionFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", CfnAnalysisColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("formatConfiguration", "FormatConfiguration", properties.FormatConfiguration != null ? CfnAnalysisNumberFormatConfigurationPropertyFromCloudFormation(properties.FormatConfiguration) : void 0), ret.addPropertyResult("hierarchyId", "HierarchyId", properties.HierarchyId != null ? cfn_parse.FromCloudFormation.getString(properties.HierarchyId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_NumericalMeasureFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationFunction", CfnAnalysis_NumericalAggregationFunctionPropertyValidator)(properties.aggregationFunction)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnAnalysis_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("formatConfiguration", CfnAnalysis_NumberFormatConfigurationPropertyValidator)(properties.formatConfiguration)), errors.wrap('supplied properties not correct for "NumericalMeasureFieldProperty"');
    }
    function cfnAnalysisNumericalMeasureFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_NumericalMeasureFieldPropertyValidator(properties).assertSuccess(), { AggregationFunction: cfnAnalysisNumericalAggregationFunctionPropertyToCloudFormation(properties.aggregationFunction), Column: cfnAnalysisColumnIdentifierPropertyToCloudFormation(properties.column), FieldId: cdk.stringToCloudFormation(properties.fieldId), FormatConfiguration: cfnAnalysisNumberFormatConfigurationPropertyToCloudFormation(properties.formatConfiguration) }) : properties;
    }
    function CfnAnalysisNumericalMeasureFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationFunction", "AggregationFunction", properties.AggregationFunction != null ? CfnAnalysisNumericalAggregationFunctionPropertyFromCloudFormation(properties.AggregationFunction) : void 0), ret.addPropertyResult("column", "Column", CfnAnalysisColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("formatConfiguration", "FormatConfiguration", properties.FormatConfiguration != null ? CfnAnalysisNumberFormatConfigurationPropertyFromCloudFormation(properties.FormatConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PaginationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("pageNumber", cdk.requiredValidator)(properties.pageNumber)), errors.collect(cdk.propertyValidator("pageNumber", cdk.validateNumber)(properties.pageNumber)), errors.collect(cdk.propertyValidator("pageSize", cdk.requiredValidator)(properties.pageSize)), errors.collect(cdk.propertyValidator("pageSize", cdk.validateNumber)(properties.pageSize)), errors.wrap('supplied properties not correct for "PaginationConfigurationProperty"');
    }
    function cfnAnalysisPaginationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PaginationConfigurationPropertyValidator(properties).assertSuccess(), { PageNumber: cdk.numberToCloudFormation(properties.pageNumber), PageSize: cdk.numberToCloudFormation(properties.pageSize) }) : properties;
    }
    function CfnAnalysisPaginationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("pageNumber", "PageNumber", cfn_parse.FromCloudFormation.getNumber(properties.PageNumber)), ret.addPropertyResult("pageSize", "PageSize", cfn_parse.FromCloudFormation.getNumber(properties.PageSize)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PanelConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("backgroundColor", cdk.validateString)(properties.backgroundColor)), errors.collect(cdk.propertyValidator("backgroundVisibility", cdk.validateString)(properties.backgroundVisibility)), errors.collect(cdk.propertyValidator("borderColor", cdk.validateString)(properties.borderColor)), errors.collect(cdk.propertyValidator("borderStyle", cdk.validateString)(properties.borderStyle)), errors.collect(cdk.propertyValidator("borderThickness", cdk.validateString)(properties.borderThickness)), errors.collect(cdk.propertyValidator("borderVisibility", cdk.validateString)(properties.borderVisibility)), errors.collect(cdk.propertyValidator("gutterSpacing", cdk.validateString)(properties.gutterSpacing)), errors.collect(cdk.propertyValidator("gutterVisibility", cdk.validateString)(properties.gutterVisibility)), errors.collect(cdk.propertyValidator("title", CfnAnalysis_PanelTitleOptionsPropertyValidator)(properties.title)), errors.wrap('supplied properties not correct for "PanelConfigurationProperty"');
    }
    function cfnAnalysisPanelConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PanelConfigurationPropertyValidator(properties).assertSuccess(), { BackgroundColor: cdk.stringToCloudFormation(properties.backgroundColor), BackgroundVisibility: cdk.stringToCloudFormation(properties.backgroundVisibility), BorderColor: cdk.stringToCloudFormation(properties.borderColor), BorderStyle: cdk.stringToCloudFormation(properties.borderStyle), BorderThickness: cdk.stringToCloudFormation(properties.borderThickness), BorderVisibility: cdk.stringToCloudFormation(properties.borderVisibility), GutterSpacing: cdk.stringToCloudFormation(properties.gutterSpacing), GutterVisibility: cdk.stringToCloudFormation(properties.gutterVisibility), Title: cfnAnalysisPanelTitleOptionsPropertyToCloudFormation(properties.title) }) : properties;
    }
    function CfnAnalysisPanelConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("backgroundColor", "BackgroundColor", properties.BackgroundColor != null ? cfn_parse.FromCloudFormation.getString(properties.BackgroundColor) : void 0), ret.addPropertyResult("backgroundVisibility", "BackgroundVisibility", properties.BackgroundVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.BackgroundVisibility) : void 0), ret.addPropertyResult("borderColor", "BorderColor", properties.BorderColor != null ? cfn_parse.FromCloudFormation.getString(properties.BorderColor) : void 0), ret.addPropertyResult("borderStyle", "BorderStyle", properties.BorderStyle != null ? cfn_parse.FromCloudFormation.getString(properties.BorderStyle) : void 0), ret.addPropertyResult("borderThickness", "BorderThickness", properties.BorderThickness != null ? cfn_parse.FromCloudFormation.getString(properties.BorderThickness) : void 0), ret.addPropertyResult("borderVisibility", "BorderVisibility", properties.BorderVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.BorderVisibility) : void 0), ret.addPropertyResult("gutterSpacing", "GutterSpacing", properties.GutterSpacing != null ? cfn_parse.FromCloudFormation.getString(properties.GutterSpacing) : void 0), ret.addPropertyResult("gutterVisibility", "GutterVisibility", properties.GutterVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.GutterVisibility) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnAnalysisPanelTitleOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PanelTitleOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fontConfiguration", CfnAnalysis_FontConfigurationPropertyValidator)(properties.fontConfiguration)), errors.collect(cdk.propertyValidator("horizontalTextAlignment", cdk.validateString)(properties.horizontalTextAlignment)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "PanelTitleOptionsProperty"');
    }
    function cfnAnalysisPanelTitleOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PanelTitleOptionsPropertyValidator(properties).assertSuccess(), { FontConfiguration: cfnAnalysisFontConfigurationPropertyToCloudFormation(properties.fontConfiguration), HorizontalTextAlignment: cdk.stringToCloudFormation(properties.horizontalTextAlignment), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnAnalysisPanelTitleOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fontConfiguration", "FontConfiguration", properties.FontConfiguration != null ? CfnAnalysisFontConfigurationPropertyFromCloudFormation(properties.FontConfiguration) : void 0), ret.addPropertyResult("horizontalTextAlignment", "HorizontalTextAlignment", properties.HorizontalTextAlignment != null ? cfn_parse.FromCloudFormation.getString(properties.HorizontalTextAlignment) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ParameterControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateTimePicker", CfnAnalysis_ParameterDateTimePickerControlPropertyValidator)(properties.dateTimePicker)), errors.collect(cdk.propertyValidator("dropdown", CfnAnalysis_ParameterDropDownControlPropertyValidator)(properties.dropdown)), errors.collect(cdk.propertyValidator("list", CfnAnalysis_ParameterListControlPropertyValidator)(properties.list)), errors.collect(cdk.propertyValidator("slider", CfnAnalysis_ParameterSliderControlPropertyValidator)(properties.slider)), errors.collect(cdk.propertyValidator("textArea", CfnAnalysis_ParameterTextAreaControlPropertyValidator)(properties.textArea)), errors.collect(cdk.propertyValidator("textField", CfnAnalysis_ParameterTextFieldControlPropertyValidator)(properties.textField)), errors.wrap('supplied properties not correct for "ParameterControlProperty"');
    }
    function cfnAnalysisParameterControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ParameterControlPropertyValidator(properties).assertSuccess(), { DateTimePicker: cfnAnalysisParameterDateTimePickerControlPropertyToCloudFormation(properties.dateTimePicker), Dropdown: cfnAnalysisParameterDropDownControlPropertyToCloudFormation(properties.dropdown), List: cfnAnalysisParameterListControlPropertyToCloudFormation(properties.list), Slider: cfnAnalysisParameterSliderControlPropertyToCloudFormation(properties.slider), TextArea: cfnAnalysisParameterTextAreaControlPropertyToCloudFormation(properties.textArea), TextField: cfnAnalysisParameterTextFieldControlPropertyToCloudFormation(properties.textField) }) : properties;
    }
    function CfnAnalysisParameterControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateTimePicker", "DateTimePicker", properties.DateTimePicker != null ? CfnAnalysisParameterDateTimePickerControlPropertyFromCloudFormation(properties.DateTimePicker) : void 0), ret.addPropertyResult("dropdown", "Dropdown", properties.Dropdown != null ? CfnAnalysisParameterDropDownControlPropertyFromCloudFormation(properties.Dropdown) : void 0), ret.addPropertyResult("list", "List", properties.List != null ? CfnAnalysisParameterListControlPropertyFromCloudFormation(properties.List) : void 0), ret.addPropertyResult("slider", "Slider", properties.Slider != null ? CfnAnalysisParameterSliderControlPropertyFromCloudFormation(properties.Slider) : void 0), ret.addPropertyResult("textArea", "TextArea", properties.TextArea != null ? CfnAnalysisParameterTextAreaControlPropertyFromCloudFormation(properties.TextArea) : void 0), ret.addPropertyResult("textField", "TextField", properties.TextField != null ? CfnAnalysisParameterTextFieldControlPropertyFromCloudFormation(properties.TextField) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ParameterDateTimePickerControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("displayOptions", CfnAnalysis_DateTimePickerControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.requiredValidator)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.validateString)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.requiredValidator)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.validateString)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.wrap('supplied properties not correct for "ParameterDateTimePickerControlProperty"');
    }
    function cfnAnalysisParameterDateTimePickerControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ParameterDateTimePickerControlPropertyValidator(properties).assertSuccess(), { DisplayOptions: cfnAnalysisDateTimePickerControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), ParameterControlId: cdk.stringToCloudFormation(properties.parameterControlId), SourceParameterName: cdk.stringToCloudFormation(properties.sourceParameterName), Title: cdk.stringToCloudFormation(properties.title) }) : properties;
    }
    function CfnAnalysisParameterDateTimePickerControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnAnalysisDateTimePickerControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("parameterControlId", "ParameterControlId", cfn_parse.FromCloudFormation.getString(properties.ParameterControlId)), ret.addPropertyResult("sourceParameterName", "SourceParameterName", cfn_parse.FromCloudFormation.getString(properties.SourceParameterName)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ParameterDeclarationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateTimeParameterDeclaration", CfnAnalysis_DateTimeParameterDeclarationPropertyValidator)(properties.dateTimeParameterDeclaration)), errors.collect(cdk.propertyValidator("decimalParameterDeclaration", CfnAnalysis_DecimalParameterDeclarationPropertyValidator)(properties.decimalParameterDeclaration)), errors.collect(cdk.propertyValidator("integerParameterDeclaration", CfnAnalysis_IntegerParameterDeclarationPropertyValidator)(properties.integerParameterDeclaration)), errors.collect(cdk.propertyValidator("stringParameterDeclaration", CfnAnalysis_StringParameterDeclarationPropertyValidator)(properties.stringParameterDeclaration)), errors.wrap('supplied properties not correct for "ParameterDeclarationProperty"');
    }
    function cfnAnalysisParameterDeclarationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ParameterDeclarationPropertyValidator(properties).assertSuccess(), { DateTimeParameterDeclaration: cfnAnalysisDateTimeParameterDeclarationPropertyToCloudFormation(properties.dateTimeParameterDeclaration), DecimalParameterDeclaration: cfnAnalysisDecimalParameterDeclarationPropertyToCloudFormation(properties.decimalParameterDeclaration), IntegerParameterDeclaration: cfnAnalysisIntegerParameterDeclarationPropertyToCloudFormation(properties.integerParameterDeclaration), StringParameterDeclaration: cfnAnalysisStringParameterDeclarationPropertyToCloudFormation(properties.stringParameterDeclaration) }) : properties;
    }
    function CfnAnalysisParameterDeclarationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateTimeParameterDeclaration", "DateTimeParameterDeclaration", properties.DateTimeParameterDeclaration != null ? CfnAnalysisDateTimeParameterDeclarationPropertyFromCloudFormation(properties.DateTimeParameterDeclaration) : void 0), ret.addPropertyResult("decimalParameterDeclaration", "DecimalParameterDeclaration", properties.DecimalParameterDeclaration != null ? CfnAnalysisDecimalParameterDeclarationPropertyFromCloudFormation(properties.DecimalParameterDeclaration) : void 0), ret.addPropertyResult("integerParameterDeclaration", "IntegerParameterDeclaration", properties.IntegerParameterDeclaration != null ? CfnAnalysisIntegerParameterDeclarationPropertyFromCloudFormation(properties.IntegerParameterDeclaration) : void 0), ret.addPropertyResult("stringParameterDeclaration", "StringParameterDeclaration", properties.StringParameterDeclaration != null ? CfnAnalysisStringParameterDeclarationPropertyFromCloudFormation(properties.StringParameterDeclaration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ParameterDropDownControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cascadingControlConfiguration", CfnAnalysis_CascadingControlConfigurationPropertyValidator)(properties.cascadingControlConfiguration)), errors.collect(cdk.propertyValidator("displayOptions", CfnAnalysis_DropDownControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.requiredValidator)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.validateString)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("selectableValues", CfnAnalysis_ParameterSelectableValuesPropertyValidator)(properties.selectableValues)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.requiredValidator)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.validateString)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "ParameterDropDownControlProperty"');
    }
    function cfnAnalysisParameterDropDownControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ParameterDropDownControlPropertyValidator(properties).assertSuccess(), { CascadingControlConfiguration: cfnAnalysisCascadingControlConfigurationPropertyToCloudFormation(properties.cascadingControlConfiguration), DisplayOptions: cfnAnalysisDropDownControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), ParameterControlId: cdk.stringToCloudFormation(properties.parameterControlId), SelectableValues: cfnAnalysisParameterSelectableValuesPropertyToCloudFormation(properties.selectableValues), SourceParameterName: cdk.stringToCloudFormation(properties.sourceParameterName), Title: cdk.stringToCloudFormation(properties.title), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnAnalysisParameterDropDownControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cascadingControlConfiguration", "CascadingControlConfiguration", properties.CascadingControlConfiguration != null ? CfnAnalysisCascadingControlConfigurationPropertyFromCloudFormation(properties.CascadingControlConfiguration) : void 0), ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnAnalysisDropDownControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("parameterControlId", "ParameterControlId", cfn_parse.FromCloudFormation.getString(properties.ParameterControlId)), ret.addPropertyResult("selectableValues", "SelectableValues", properties.SelectableValues != null ? CfnAnalysisParameterSelectableValuesPropertyFromCloudFormation(properties.SelectableValues) : void 0), ret.addPropertyResult("sourceParameterName", "SourceParameterName", cfn_parse.FromCloudFormation.getString(properties.SourceParameterName)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ParameterListControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cascadingControlConfiguration", CfnAnalysis_CascadingControlConfigurationPropertyValidator)(properties.cascadingControlConfiguration)), errors.collect(cdk.propertyValidator("displayOptions", CfnAnalysis_ListControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.requiredValidator)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.validateString)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("selectableValues", CfnAnalysis_ParameterSelectableValuesPropertyValidator)(properties.selectableValues)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.requiredValidator)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.validateString)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "ParameterListControlProperty"');
    }
    function cfnAnalysisParameterListControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ParameterListControlPropertyValidator(properties).assertSuccess(), { CascadingControlConfiguration: cfnAnalysisCascadingControlConfigurationPropertyToCloudFormation(properties.cascadingControlConfiguration), DisplayOptions: cfnAnalysisListControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), ParameterControlId: cdk.stringToCloudFormation(properties.parameterControlId), SelectableValues: cfnAnalysisParameterSelectableValuesPropertyToCloudFormation(properties.selectableValues), SourceParameterName: cdk.stringToCloudFormation(properties.sourceParameterName), Title: cdk.stringToCloudFormation(properties.title), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnAnalysisParameterListControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cascadingControlConfiguration", "CascadingControlConfiguration", properties.CascadingControlConfiguration != null ? CfnAnalysisCascadingControlConfigurationPropertyFromCloudFormation(properties.CascadingControlConfiguration) : void 0), ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnAnalysisListControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("parameterControlId", "ParameterControlId", cfn_parse.FromCloudFormation.getString(properties.ParameterControlId)), ret.addPropertyResult("selectableValues", "SelectableValues", properties.SelectableValues != null ? CfnAnalysisParameterSelectableValuesPropertyFromCloudFormation(properties.SelectableValues) : void 0), ret.addPropertyResult("sourceParameterName", "SourceParameterName", cfn_parse.FromCloudFormation.getString(properties.SourceParameterName)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ParameterSelectableValuesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("linkToDataSetColumn", CfnAnalysis_ColumnIdentifierPropertyValidator)(properties.linkToDataSetColumn)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "ParameterSelectableValuesProperty"');
    }
    function cfnAnalysisParameterSelectableValuesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ParameterSelectableValuesPropertyValidator(properties).assertSuccess(), { LinkToDataSetColumn: cfnAnalysisColumnIdentifierPropertyToCloudFormation(properties.linkToDataSetColumn), Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnAnalysisParameterSelectableValuesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("linkToDataSetColumn", "LinkToDataSetColumn", properties.LinkToDataSetColumn != null ? CfnAnalysisColumnIdentifierPropertyFromCloudFormation(properties.LinkToDataSetColumn) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ParameterSliderControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("displayOptions", CfnAnalysis_SliderControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("maximumValue", cdk.requiredValidator)(properties.maximumValue)), errors.collect(cdk.propertyValidator("maximumValue", cdk.validateNumber)(properties.maximumValue)), errors.collect(cdk.propertyValidator("minimumValue", cdk.requiredValidator)(properties.minimumValue)), errors.collect(cdk.propertyValidator("minimumValue", cdk.validateNumber)(properties.minimumValue)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.requiredValidator)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.validateString)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.requiredValidator)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.validateString)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("stepSize", cdk.requiredValidator)(properties.stepSize)), errors.collect(cdk.propertyValidator("stepSize", cdk.validateNumber)(properties.stepSize)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.wrap('supplied properties not correct for "ParameterSliderControlProperty"');
    }
    function cfnAnalysisParameterSliderControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ParameterSliderControlPropertyValidator(properties).assertSuccess(), { DisplayOptions: cfnAnalysisSliderControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), MaximumValue: cdk.numberToCloudFormation(properties.maximumValue), MinimumValue: cdk.numberToCloudFormation(properties.minimumValue), ParameterControlId: cdk.stringToCloudFormation(properties.parameterControlId), SourceParameterName: cdk.stringToCloudFormation(properties.sourceParameterName), StepSize: cdk.numberToCloudFormation(properties.stepSize), Title: cdk.stringToCloudFormation(properties.title) }) : properties;
    }
    function CfnAnalysisParameterSliderControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnAnalysisSliderControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("maximumValue", "MaximumValue", cfn_parse.FromCloudFormation.getNumber(properties.MaximumValue)), ret.addPropertyResult("minimumValue", "MinimumValue", cfn_parse.FromCloudFormation.getNumber(properties.MinimumValue)), ret.addPropertyResult("parameterControlId", "ParameterControlId", cfn_parse.FromCloudFormation.getString(properties.ParameterControlId)), ret.addPropertyResult("sourceParameterName", "SourceParameterName", cfn_parse.FromCloudFormation.getString(properties.SourceParameterName)), ret.addPropertyResult("stepSize", "StepSize", cfn_parse.FromCloudFormation.getNumber(properties.StepSize)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ParameterTextAreaControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("delimiter", cdk.validateString)(properties.delimiter)), errors.collect(cdk.propertyValidator("displayOptions", CfnAnalysis_TextAreaControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.requiredValidator)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.validateString)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.requiredValidator)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.validateString)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.wrap('supplied properties not correct for "ParameterTextAreaControlProperty"');
    }
    function cfnAnalysisParameterTextAreaControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ParameterTextAreaControlPropertyValidator(properties).assertSuccess(), { Delimiter: cdk.stringToCloudFormation(properties.delimiter), DisplayOptions: cfnAnalysisTextAreaControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), ParameterControlId: cdk.stringToCloudFormation(properties.parameterControlId), SourceParameterName: cdk.stringToCloudFormation(properties.sourceParameterName), Title: cdk.stringToCloudFormation(properties.title) }) : properties;
    }
    function CfnAnalysisParameterTextAreaControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("delimiter", "Delimiter", properties.Delimiter != null ? cfn_parse.FromCloudFormation.getString(properties.Delimiter) : void 0), ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnAnalysisTextAreaControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("parameterControlId", "ParameterControlId", cfn_parse.FromCloudFormation.getString(properties.ParameterControlId)), ret.addPropertyResult("sourceParameterName", "SourceParameterName", cfn_parse.FromCloudFormation.getString(properties.SourceParameterName)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ParameterTextFieldControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("displayOptions", CfnAnalysis_TextFieldControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.requiredValidator)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.validateString)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.requiredValidator)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.validateString)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.wrap('supplied properties not correct for "ParameterTextFieldControlProperty"');
    }
    function cfnAnalysisParameterTextFieldControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ParameterTextFieldControlPropertyValidator(properties).assertSuccess(), { DisplayOptions: cfnAnalysisTextFieldControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), ParameterControlId: cdk.stringToCloudFormation(properties.parameterControlId), SourceParameterName: cdk.stringToCloudFormation(properties.sourceParameterName), Title: cdk.stringToCloudFormation(properties.title) }) : properties;
    }
    function CfnAnalysisParameterTextFieldControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnAnalysisTextFieldControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("parameterControlId", "ParameterControlId", cfn_parse.FromCloudFormation.getString(properties.ParameterControlId)), ret.addPropertyResult("sourceParameterName", "SourceParameterName", cfn_parse.FromCloudFormation.getString(properties.SourceParameterName)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateTimeParameters", cdk.listValidator(CfnAnalysis_DateTimeParameterPropertyValidator))(properties.dateTimeParameters)), errors.collect(cdk.propertyValidator("decimalParameters", cdk.listValidator(CfnAnalysis_DecimalParameterPropertyValidator))(properties.decimalParameters)), errors.collect(cdk.propertyValidator("integerParameters", cdk.listValidator(CfnAnalysis_IntegerParameterPropertyValidator))(properties.integerParameters)), errors.collect(cdk.propertyValidator("stringParameters", cdk.listValidator(CfnAnalysis_StringParameterPropertyValidator))(properties.stringParameters)), errors.wrap('supplied properties not correct for "ParametersProperty"');
    }
    function cfnAnalysisParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ParametersPropertyValidator(properties).assertSuccess(), { DateTimeParameters: cdk.listMapper(cfnAnalysisDateTimeParameterPropertyToCloudFormation)(properties.dateTimeParameters), DecimalParameters: cdk.listMapper(cfnAnalysisDecimalParameterPropertyToCloudFormation)(properties.decimalParameters), IntegerParameters: cdk.listMapper(cfnAnalysisIntegerParameterPropertyToCloudFormation)(properties.integerParameters), StringParameters: cdk.listMapper(cfnAnalysisStringParameterPropertyToCloudFormation)(properties.stringParameters) }) : properties;
    }
    function CfnAnalysisParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateTimeParameters", "DateTimeParameters", properties.DateTimeParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDateTimeParameterPropertyFromCloudFormation)(properties.DateTimeParameters) : void 0), ret.addPropertyResult("decimalParameters", "DecimalParameters", properties.DecimalParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDecimalParameterPropertyFromCloudFormation)(properties.DecimalParameters) : void 0), ret.addPropertyResult("integerParameters", "IntegerParameters", properties.IntegerParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisIntegerParameterPropertyFromCloudFormation)(properties.IntegerParameters) : void 0), ret.addPropertyResult("stringParameters", "StringParameters", properties.StringParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisStringParameterPropertyFromCloudFormation)(properties.StringParameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PercentVisibleRangePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("from", cdk.validateNumber)(properties.from)), errors.collect(cdk.propertyValidator("to", cdk.validateNumber)(properties.to)), errors.wrap('supplied properties not correct for "PercentVisibleRangeProperty"');
    }
    function cfnAnalysisPercentVisibleRangePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PercentVisibleRangePropertyValidator(properties).assertSuccess(), { From: cdk.numberToCloudFormation(properties.from), To: cdk.numberToCloudFormation(properties.to) }) : properties;
    }
    function CfnAnalysisPercentVisibleRangePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("from", "From", properties.From != null ? cfn_parse.FromCloudFormation.getNumber(properties.From) : void 0), ret.addPropertyResult("to", "To", properties.To != null ? cfn_parse.FromCloudFormation.getNumber(properties.To) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PercentageDisplayFormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("decimalPlacesConfiguration", CfnAnalysis_DecimalPlacesConfigurationPropertyValidator)(properties.decimalPlacesConfiguration)), errors.collect(cdk.propertyValidator("negativeValueConfiguration", CfnAnalysis_NegativeValueConfigurationPropertyValidator)(properties.negativeValueConfiguration)), errors.collect(cdk.propertyValidator("nullValueFormatConfiguration", CfnAnalysis_NullValueFormatConfigurationPropertyValidator)(properties.nullValueFormatConfiguration)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.collect(cdk.propertyValidator("separatorConfiguration", CfnAnalysis_NumericSeparatorConfigurationPropertyValidator)(properties.separatorConfiguration)), errors.collect(cdk.propertyValidator("suffix", cdk.validateString)(properties.suffix)), errors.wrap('supplied properties not correct for "PercentageDisplayFormatConfigurationProperty"');
    }
    function cfnAnalysisPercentageDisplayFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PercentageDisplayFormatConfigurationPropertyValidator(properties).assertSuccess(), { DecimalPlacesConfiguration: cfnAnalysisDecimalPlacesConfigurationPropertyToCloudFormation(properties.decimalPlacesConfiguration), NegativeValueConfiguration: cfnAnalysisNegativeValueConfigurationPropertyToCloudFormation(properties.negativeValueConfiguration), NullValueFormatConfiguration: cfnAnalysisNullValueFormatConfigurationPropertyToCloudFormation(properties.nullValueFormatConfiguration), Prefix: cdk.stringToCloudFormation(properties.prefix), SeparatorConfiguration: cfnAnalysisNumericSeparatorConfigurationPropertyToCloudFormation(properties.separatorConfiguration), Suffix: cdk.stringToCloudFormation(properties.suffix) }) : properties;
    }
    function CfnAnalysisPercentageDisplayFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("decimalPlacesConfiguration", "DecimalPlacesConfiguration", properties.DecimalPlacesConfiguration != null ? CfnAnalysisDecimalPlacesConfigurationPropertyFromCloudFormation(properties.DecimalPlacesConfiguration) : void 0), ret.addPropertyResult("negativeValueConfiguration", "NegativeValueConfiguration", properties.NegativeValueConfiguration != null ? CfnAnalysisNegativeValueConfigurationPropertyFromCloudFormation(properties.NegativeValueConfiguration) : void 0), ret.addPropertyResult("nullValueFormatConfiguration", "NullValueFormatConfiguration", properties.NullValueFormatConfiguration != null ? CfnAnalysisNullValueFormatConfigurationPropertyFromCloudFormation(properties.NullValueFormatConfiguration) : void 0), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addPropertyResult("separatorConfiguration", "SeparatorConfiguration", properties.SeparatorConfiguration != null ? CfnAnalysisNumericSeparatorConfigurationPropertyFromCloudFormation(properties.SeparatorConfiguration) : void 0), ret.addPropertyResult("suffix", "Suffix", properties.Suffix != null ? cfn_parse.FromCloudFormation.getString(properties.Suffix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PercentileAggregationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("percentileValue", cdk.validateNumber)(properties.percentileValue)), errors.wrap('supplied properties not correct for "PercentileAggregationProperty"');
    }
    function cfnAnalysisPercentileAggregationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PercentileAggregationPropertyValidator(properties).assertSuccess(), { PercentileValue: cdk.numberToCloudFormation(properties.percentileValue) }) : properties;
    }
    function CfnAnalysisPercentileAggregationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("percentileValue", "PercentileValue", properties.PercentileValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.PercentileValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PeriodOverPeriodComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computationId", cdk.requiredValidator)(properties.computationId)), errors.collect(cdk.propertyValidator("computationId", cdk.validateString)(properties.computationId)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("time", cdk.requiredValidator)(properties.time)), errors.collect(cdk.propertyValidator("time", CfnAnalysis_DimensionFieldPropertyValidator)(properties.time)), errors.collect(cdk.propertyValidator("value", CfnAnalysis_MeasureFieldPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "PeriodOverPeriodComputationProperty"');
    }
    function cfnAnalysisPeriodOverPeriodComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PeriodOverPeriodComputationPropertyValidator(properties).assertSuccess(), { ComputationId: cdk.stringToCloudFormation(properties.computationId), Name: cdk.stringToCloudFormation(properties.name), Time: cfnAnalysisDimensionFieldPropertyToCloudFormation(properties.time), Value: cfnAnalysisMeasureFieldPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnAnalysisPeriodOverPeriodComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computationId", "ComputationId", cfn_parse.FromCloudFormation.getString(properties.ComputationId)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("time", "Time", CfnAnalysisDimensionFieldPropertyFromCloudFormation(properties.Time)), ret.addPropertyResult("value", "Value", properties.Value != null ? CfnAnalysisMeasureFieldPropertyFromCloudFormation(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PeriodToDateComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computationId", cdk.requiredValidator)(properties.computationId)), errors.collect(cdk.propertyValidator("computationId", cdk.validateString)(properties.computationId)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("periodTimeGranularity", cdk.validateString)(properties.periodTimeGranularity)), errors.collect(cdk.propertyValidator("time", cdk.requiredValidator)(properties.time)), errors.collect(cdk.propertyValidator("time", CfnAnalysis_DimensionFieldPropertyValidator)(properties.time)), errors.collect(cdk.propertyValidator("value", CfnAnalysis_MeasureFieldPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "PeriodToDateComputationProperty"');
    }
    function cfnAnalysisPeriodToDateComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PeriodToDateComputationPropertyValidator(properties).assertSuccess(), { ComputationId: cdk.stringToCloudFormation(properties.computationId), Name: cdk.stringToCloudFormation(properties.name), PeriodTimeGranularity: cdk.stringToCloudFormation(properties.periodTimeGranularity), Time: cfnAnalysisDimensionFieldPropertyToCloudFormation(properties.time), Value: cfnAnalysisMeasureFieldPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnAnalysisPeriodToDateComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computationId", "ComputationId", cfn_parse.FromCloudFormation.getString(properties.ComputationId)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("periodTimeGranularity", "PeriodTimeGranularity", properties.PeriodTimeGranularity != null ? cfn_parse.FromCloudFormation.getString(properties.PeriodTimeGranularity) : void 0), ret.addPropertyResult("time", "Time", CfnAnalysisDimensionFieldPropertyFromCloudFormation(properties.Time)), ret.addPropertyResult("value", "Value", properties.Value != null ? CfnAnalysisMeasureFieldPropertyFromCloudFormation(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PieChartAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("category", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.category)), errors.collect(cdk.propertyValidator("smallMultiples", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.smallMultiples)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnAnalysis_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "PieChartAggregatedFieldWellsProperty"');
    }
    function cfnAnalysisPieChartAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PieChartAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Category: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.category), SmallMultiples: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.smallMultiples), Values: cdk.listMapper(cfnAnalysisMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnAnalysisPieChartAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("category", "Category", properties.Category != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.Category) : void 0), ret.addPropertyResult("smallMultiples", "SmallMultiples", properties.SmallMultiples != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.SmallMultiples) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PieChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryLabelOptions", CfnAnalysis_ChartAxisLabelOptionsPropertyValidator)(properties.categoryLabelOptions)), errors.collect(cdk.propertyValidator("contributionAnalysisDefaults", cdk.listValidator(CfnAnalysis_ContributionAnalysisDefaultPropertyValidator))(properties.contributionAnalysisDefaults)), errors.collect(cdk.propertyValidator("dataLabels", CfnAnalysis_DataLabelOptionsPropertyValidator)(properties.dataLabels)), errors.collect(cdk.propertyValidator("donutOptions", CfnAnalysis_DonutOptionsPropertyValidator)(properties.donutOptions)), errors.collect(cdk.propertyValidator("fieldWells", CfnAnalysis_PieChartFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("legend", CfnAnalysis_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("smallMultiplesOptions", CfnAnalysis_SmallMultiplesOptionsPropertyValidator)(properties.smallMultiplesOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnAnalysis_PieChartSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tooltip", CfnAnalysis_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.collect(cdk.propertyValidator("valueLabelOptions", CfnAnalysis_ChartAxisLabelOptionsPropertyValidator)(properties.valueLabelOptions)), errors.collect(cdk.propertyValidator("visualPalette", CfnAnalysis_VisualPalettePropertyValidator)(properties.visualPalette)), errors.wrap('supplied properties not correct for "PieChartConfigurationProperty"');
    }
    function cfnAnalysisPieChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PieChartConfigurationPropertyValidator(properties).assertSuccess(), { CategoryLabelOptions: cfnAnalysisChartAxisLabelOptionsPropertyToCloudFormation(properties.categoryLabelOptions), ContributionAnalysisDefaults: cdk.listMapper(cfnAnalysisContributionAnalysisDefaultPropertyToCloudFormation)(properties.contributionAnalysisDefaults), DataLabels: cfnAnalysisDataLabelOptionsPropertyToCloudFormation(properties.dataLabels), DonutOptions: cfnAnalysisDonutOptionsPropertyToCloudFormation(properties.donutOptions), FieldWells: cfnAnalysisPieChartFieldWellsPropertyToCloudFormation(properties.fieldWells), Legend: cfnAnalysisLegendOptionsPropertyToCloudFormation(properties.legend), SmallMultiplesOptions: cfnAnalysisSmallMultiplesOptionsPropertyToCloudFormation(properties.smallMultiplesOptions), SortConfiguration: cfnAnalysisPieChartSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), Tooltip: cfnAnalysisTooltipOptionsPropertyToCloudFormation(properties.tooltip), ValueLabelOptions: cfnAnalysisChartAxisLabelOptionsPropertyToCloudFormation(properties.valueLabelOptions), VisualPalette: cfnAnalysisVisualPalettePropertyToCloudFormation(properties.visualPalette) }) : properties;
    }
    function CfnAnalysisPieChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryLabelOptions", "CategoryLabelOptions", properties.CategoryLabelOptions != null ? CfnAnalysisChartAxisLabelOptionsPropertyFromCloudFormation(properties.CategoryLabelOptions) : void 0), ret.addPropertyResult("contributionAnalysisDefaults", "ContributionAnalysisDefaults", properties.ContributionAnalysisDefaults != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisContributionAnalysisDefaultPropertyFromCloudFormation)(properties.ContributionAnalysisDefaults) : void 0), ret.addPropertyResult("dataLabels", "DataLabels", properties.DataLabels != null ? CfnAnalysisDataLabelOptionsPropertyFromCloudFormation(properties.DataLabels) : void 0), ret.addPropertyResult("donutOptions", "DonutOptions", properties.DonutOptions != null ? CfnAnalysisDonutOptionsPropertyFromCloudFormation(properties.DonutOptions) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnAnalysisPieChartFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnAnalysisLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("smallMultiplesOptions", "SmallMultiplesOptions", properties.SmallMultiplesOptions != null ? CfnAnalysisSmallMultiplesOptionsPropertyFromCloudFormation(properties.SmallMultiplesOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnAnalysisPieChartSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnAnalysisTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addPropertyResult("valueLabelOptions", "ValueLabelOptions", properties.ValueLabelOptions != null ? CfnAnalysisChartAxisLabelOptionsPropertyFromCloudFormation(properties.ValueLabelOptions) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnAnalysisVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PieChartFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("pieChartAggregatedFieldWells", CfnAnalysis_PieChartAggregatedFieldWellsPropertyValidator)(properties.pieChartAggregatedFieldWells)), errors.wrap('supplied properties not correct for "PieChartFieldWellsProperty"');
    }
    function cfnAnalysisPieChartFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PieChartFieldWellsPropertyValidator(properties).assertSuccess(), { PieChartAggregatedFieldWells: cfnAnalysisPieChartAggregatedFieldWellsPropertyToCloudFormation(properties.pieChartAggregatedFieldWells) }) : properties;
    }
    function CfnAnalysisPieChartFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("pieChartAggregatedFieldWells", "PieChartAggregatedFieldWells", properties.PieChartAggregatedFieldWells != null ? CfnAnalysisPieChartAggregatedFieldWellsPropertyFromCloudFormation(properties.PieChartAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PieChartSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryItemsLimit", CfnAnalysis_ItemsLimitConfigurationPropertyValidator)(properties.categoryItemsLimit)), errors.collect(cdk.propertyValidator("categorySort", cdk.listValidator(CfnAnalysis_FieldSortOptionsPropertyValidator))(properties.categorySort)), errors.collect(cdk.propertyValidator("smallMultiplesLimitConfiguration", CfnAnalysis_ItemsLimitConfigurationPropertyValidator)(properties.smallMultiplesLimitConfiguration)), errors.collect(cdk.propertyValidator("smallMultiplesSort", cdk.listValidator(CfnAnalysis_FieldSortOptionsPropertyValidator))(properties.smallMultiplesSort)), errors.wrap('supplied properties not correct for "PieChartSortConfigurationProperty"');
    }
    function cfnAnalysisPieChartSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PieChartSortConfigurationPropertyValidator(properties).assertSuccess(), { CategoryItemsLimit: cfnAnalysisItemsLimitConfigurationPropertyToCloudFormation(properties.categoryItemsLimit), CategorySort: cdk.listMapper(cfnAnalysisFieldSortOptionsPropertyToCloudFormation)(properties.categorySort), SmallMultiplesLimitConfiguration: cfnAnalysisItemsLimitConfigurationPropertyToCloudFormation(properties.smallMultiplesLimitConfiguration), SmallMultiplesSort: cdk.listMapper(cfnAnalysisFieldSortOptionsPropertyToCloudFormation)(properties.smallMultiplesSort) }) : properties;
    }
    function CfnAnalysisPieChartSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryItemsLimit", "CategoryItemsLimit", properties.CategoryItemsLimit != null ? CfnAnalysisItemsLimitConfigurationPropertyFromCloudFormation(properties.CategoryItemsLimit) : void 0), ret.addPropertyResult("categorySort", "CategorySort", properties.CategorySort != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisFieldSortOptionsPropertyFromCloudFormation)(properties.CategorySort) : void 0), ret.addPropertyResult("smallMultiplesLimitConfiguration", "SmallMultiplesLimitConfiguration", properties.SmallMultiplesLimitConfiguration != null ? CfnAnalysisItemsLimitConfigurationPropertyFromCloudFormation(properties.SmallMultiplesLimitConfiguration) : void 0), ret.addPropertyResult("smallMultiplesSort", "SmallMultiplesSort", properties.SmallMultiplesSort != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisFieldSortOptionsPropertyFromCloudFormation)(properties.SmallMultiplesSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PieChartVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnAnalysis_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnAnalysis_PieChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnAnalysis_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnAnalysis_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnAnalysis_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "PieChartVisualProperty"');
    }
    function cfnAnalysisPieChartVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PieChartVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnAnalysisVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnAnalysisPieChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnAnalysisColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnAnalysisVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnAnalysisVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnAnalysisPieChartVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnAnalysisPieChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnAnalysisVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnAnalysisVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PivotFieldSortOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("sortBy", cdk.requiredValidator)(properties.sortBy)), errors.collect(cdk.propertyValidator("sortBy", CfnAnalysis_PivotTableSortByPropertyValidator)(properties.sortBy)), errors.wrap('supplied properties not correct for "PivotFieldSortOptionsProperty"');
    }
    function cfnAnalysisPivotFieldSortOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PivotFieldSortOptionsPropertyValidator(properties).assertSuccess(), { FieldId: cdk.stringToCloudFormation(properties.fieldId), SortBy: cfnAnalysisPivotTableSortByPropertyToCloudFormation(properties.sortBy) }) : properties;
    }
    function CfnAnalysisPivotFieldSortOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("sortBy", "SortBy", CfnAnalysisPivotTableSortByPropertyFromCloudFormation(properties.SortBy)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PivotTableAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columns", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.columns)), errors.collect(cdk.propertyValidator("rows", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.rows)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnAnalysis_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "PivotTableAggregatedFieldWellsProperty"');
    }
    function cfnAnalysisPivotTableAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PivotTableAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Columns: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.columns), Rows: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.rows), Values: cdk.listMapper(cfnAnalysisMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnAnalysisPivotTableAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columns", "Columns", properties.Columns != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.Columns) : void 0), ret.addPropertyResult("rows", "Rows", properties.Rows != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.Rows) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PivotTableCellConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("scope", CfnAnalysis_PivotTableConditionalFormattingScopePropertyValidator)(properties.scope)), errors.collect(cdk.propertyValidator("textFormat", CfnAnalysis_TextConditionalFormatPropertyValidator)(properties.textFormat)), errors.wrap('supplied properties not correct for "PivotTableCellConditionalFormattingProperty"');
    }
    function cfnAnalysisPivotTableCellConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PivotTableCellConditionalFormattingPropertyValidator(properties).assertSuccess(), { FieldId: cdk.stringToCloudFormation(properties.fieldId), Scope: cfnAnalysisPivotTableConditionalFormattingScopePropertyToCloudFormation(properties.scope), TextFormat: cfnAnalysisTextConditionalFormatPropertyToCloudFormation(properties.textFormat) }) : properties;
    }
    function CfnAnalysisPivotTableCellConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("scope", "Scope", properties.Scope != null ? CfnAnalysisPivotTableConditionalFormattingScopePropertyFromCloudFormation(properties.Scope) : void 0), ret.addPropertyResult("textFormat", "TextFormat", properties.TextFormat != null ? CfnAnalysisTextConditionalFormatPropertyFromCloudFormation(properties.TextFormat) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PivotTableConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("conditionalFormattingOptions", cdk.listValidator(CfnAnalysis_PivotTableConditionalFormattingOptionPropertyValidator))(properties.conditionalFormattingOptions)), errors.wrap('supplied properties not correct for "PivotTableConditionalFormattingProperty"');
    }
    function cfnAnalysisPivotTableConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PivotTableConditionalFormattingPropertyValidator(properties).assertSuccess(), { ConditionalFormattingOptions: cdk.listMapper(cfnAnalysisPivotTableConditionalFormattingOptionPropertyToCloudFormation)(properties.conditionalFormattingOptions) }) : properties;
    }
    function CfnAnalysisPivotTableConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("conditionalFormattingOptions", "ConditionalFormattingOptions", properties.ConditionalFormattingOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisPivotTableConditionalFormattingOptionPropertyFromCloudFormation)(properties.ConditionalFormattingOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PivotTableConditionalFormattingOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cell", CfnAnalysis_PivotTableCellConditionalFormattingPropertyValidator)(properties.cell)), errors.wrap('supplied properties not correct for "PivotTableConditionalFormattingOptionProperty"');
    }
    function cfnAnalysisPivotTableConditionalFormattingOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PivotTableConditionalFormattingOptionPropertyValidator(properties).assertSuccess(), { Cell: cfnAnalysisPivotTableCellConditionalFormattingPropertyToCloudFormation(properties.cell) }) : properties;
    }
    function CfnAnalysisPivotTableConditionalFormattingOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cell", "Cell", properties.Cell != null ? CfnAnalysisPivotTableCellConditionalFormattingPropertyFromCloudFormation(properties.Cell) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PivotTableConditionalFormattingScopePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("role", cdk.validateString)(properties.role)), errors.wrap('supplied properties not correct for "PivotTableConditionalFormattingScopeProperty"');
    }
    function cfnAnalysisPivotTableConditionalFormattingScopePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PivotTableConditionalFormattingScopePropertyValidator(properties).assertSuccess(), { Role: cdk.stringToCloudFormation(properties.role) }) : properties;
    }
    function CfnAnalysisPivotTableConditionalFormattingScopePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("role", "Role", properties.Role != null ? cfn_parse.FromCloudFormation.getString(properties.Role) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PivotTableConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldOptions", CfnAnalysis_PivotTableFieldOptionsPropertyValidator)(properties.fieldOptions)), errors.collect(cdk.propertyValidator("fieldWells", CfnAnalysis_PivotTableFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("paginatedReportOptions", CfnAnalysis_PivotTablePaginatedReportOptionsPropertyValidator)(properties.paginatedReportOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnAnalysis_PivotTableSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tableOptions", CfnAnalysis_PivotTableOptionsPropertyValidator)(properties.tableOptions)), errors.collect(cdk.propertyValidator("totalOptions", CfnAnalysis_PivotTableTotalOptionsPropertyValidator)(properties.totalOptions)), errors.wrap('supplied properties not correct for "PivotTableConfigurationProperty"');
    }
    function cfnAnalysisPivotTableConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PivotTableConfigurationPropertyValidator(properties).assertSuccess(), { FieldOptions: cfnAnalysisPivotTableFieldOptionsPropertyToCloudFormation(properties.fieldOptions), FieldWells: cfnAnalysisPivotTableFieldWellsPropertyToCloudFormation(properties.fieldWells), PaginatedReportOptions: cfnAnalysisPivotTablePaginatedReportOptionsPropertyToCloudFormation(properties.paginatedReportOptions), SortConfiguration: cfnAnalysisPivotTableSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), TableOptions: cfnAnalysisPivotTableOptionsPropertyToCloudFormation(properties.tableOptions), TotalOptions: cfnAnalysisPivotTableTotalOptionsPropertyToCloudFormation(properties.totalOptions) }) : properties;
    }
    function CfnAnalysisPivotTableConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldOptions", "FieldOptions", properties.FieldOptions != null ? CfnAnalysisPivotTableFieldOptionsPropertyFromCloudFormation(properties.FieldOptions) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnAnalysisPivotTableFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("paginatedReportOptions", "PaginatedReportOptions", properties.PaginatedReportOptions != null ? CfnAnalysisPivotTablePaginatedReportOptionsPropertyFromCloudFormation(properties.PaginatedReportOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnAnalysisPivotTableSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tableOptions", "TableOptions", properties.TableOptions != null ? CfnAnalysisPivotTableOptionsPropertyFromCloudFormation(properties.TableOptions) : void 0), ret.addPropertyResult("totalOptions", "TotalOptions", properties.TotalOptions != null ? CfnAnalysisPivotTableTotalOptionsPropertyFromCloudFormation(properties.TotalOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PivotTableDataPathOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataPathList", cdk.requiredValidator)(properties.dataPathList)), errors.collect(cdk.propertyValidator("dataPathList", cdk.listValidator(CfnAnalysis_DataPathValuePropertyValidator))(properties.dataPathList)), errors.collect(cdk.propertyValidator("width", cdk.validateString)(properties.width)), errors.wrap('supplied properties not correct for "PivotTableDataPathOptionProperty"');
    }
    function cfnAnalysisPivotTableDataPathOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PivotTableDataPathOptionPropertyValidator(properties).assertSuccess(), { DataPathList: cdk.listMapper(cfnAnalysisDataPathValuePropertyToCloudFormation)(properties.dataPathList), Width: cdk.stringToCloudFormation(properties.width) }) : properties;
    }
    function CfnAnalysisPivotTableDataPathOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataPathList", "DataPathList", cfn_parse.FromCloudFormation.getArray(CfnAnalysisDataPathValuePropertyFromCloudFormation)(properties.DataPathList)), ret.addPropertyResult("width", "Width", properties.Width != null ? cfn_parse.FromCloudFormation.getString(properties.Width) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PivotTableFieldOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customLabel", cdk.validateString)(properties.customLabel)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "PivotTableFieldOptionProperty"');
    }
    function cfnAnalysisPivotTableFieldOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PivotTableFieldOptionPropertyValidator(properties).assertSuccess(), { CustomLabel: cdk.stringToCloudFormation(properties.customLabel), FieldId: cdk.stringToCloudFormation(properties.fieldId), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnAnalysisPivotTableFieldOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customLabel", "CustomLabel", properties.CustomLabel != null ? cfn_parse.FromCloudFormation.getString(properties.CustomLabel) : void 0), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PivotTableFieldOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataPathOptions", cdk.listValidator(CfnAnalysis_PivotTableDataPathOptionPropertyValidator))(properties.dataPathOptions)), errors.collect(cdk.propertyValidator("selectedFieldOptions", cdk.listValidator(CfnAnalysis_PivotTableFieldOptionPropertyValidator))(properties.selectedFieldOptions)), errors.wrap('supplied properties not correct for "PivotTableFieldOptionsProperty"');
    }
    function cfnAnalysisPivotTableFieldOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PivotTableFieldOptionsPropertyValidator(properties).assertSuccess(), { DataPathOptions: cdk.listMapper(cfnAnalysisPivotTableDataPathOptionPropertyToCloudFormation)(properties.dataPathOptions), SelectedFieldOptions: cdk.listMapper(cfnAnalysisPivotTableFieldOptionPropertyToCloudFormation)(properties.selectedFieldOptions) }) : properties;
    }
    function CfnAnalysisPivotTableFieldOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataPathOptions", "DataPathOptions", properties.DataPathOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisPivotTableDataPathOptionPropertyFromCloudFormation)(properties.DataPathOptions) : void 0), ret.addPropertyResult("selectedFieldOptions", "SelectedFieldOptions", properties.SelectedFieldOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisPivotTableFieldOptionPropertyFromCloudFormation)(properties.SelectedFieldOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PivotTableFieldSubtotalOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.wrap('supplied properties not correct for "PivotTableFieldSubtotalOptionsProperty"');
    }
    function cfnAnalysisPivotTableFieldSubtotalOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PivotTableFieldSubtotalOptionsPropertyValidator(properties).assertSuccess(), { FieldId: cdk.stringToCloudFormation(properties.fieldId) }) : properties;
    }
    function CfnAnalysisPivotTableFieldSubtotalOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldId", "FieldId", properties.FieldId != null ? cfn_parse.FromCloudFormation.getString(properties.FieldId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PivotTableFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("pivotTableAggregatedFieldWells", CfnAnalysis_PivotTableAggregatedFieldWellsPropertyValidator)(properties.pivotTableAggregatedFieldWells)), errors.wrap('supplied properties not correct for "PivotTableFieldWellsProperty"');
    }
    function cfnAnalysisPivotTableFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PivotTableFieldWellsPropertyValidator(properties).assertSuccess(), { PivotTableAggregatedFieldWells: cfnAnalysisPivotTableAggregatedFieldWellsPropertyToCloudFormation(properties.pivotTableAggregatedFieldWells) }) : properties;
    }
    function CfnAnalysisPivotTableFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("pivotTableAggregatedFieldWells", "PivotTableAggregatedFieldWells", properties.PivotTableAggregatedFieldWells != null ? CfnAnalysisPivotTableAggregatedFieldWellsPropertyFromCloudFormation(properties.PivotTableAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PivotTableOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cellStyle", CfnAnalysis_TableCellStylePropertyValidator)(properties.cellStyle)), errors.collect(cdk.propertyValidator("columnHeaderStyle", CfnAnalysis_TableCellStylePropertyValidator)(properties.columnHeaderStyle)), errors.collect(cdk.propertyValidator("columnNamesVisibility", cdk.validateString)(properties.columnNamesVisibility)), errors.collect(cdk.propertyValidator("metricPlacement", cdk.validateString)(properties.metricPlacement)), errors.collect(cdk.propertyValidator("rowAlternateColorOptions", CfnAnalysis_RowAlternateColorOptionsPropertyValidator)(properties.rowAlternateColorOptions)), errors.collect(cdk.propertyValidator("rowFieldNamesStyle", CfnAnalysis_TableCellStylePropertyValidator)(properties.rowFieldNamesStyle)), errors.collect(cdk.propertyValidator("rowHeaderStyle", CfnAnalysis_TableCellStylePropertyValidator)(properties.rowHeaderStyle)), errors.collect(cdk.propertyValidator("singleMetricVisibility", cdk.validateString)(properties.singleMetricVisibility)), errors.collect(cdk.propertyValidator("toggleButtonsVisibility", cdk.validateString)(properties.toggleButtonsVisibility)), errors.wrap('supplied properties not correct for "PivotTableOptionsProperty"');
    }
    function cfnAnalysisPivotTableOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PivotTableOptionsPropertyValidator(properties).assertSuccess(), { CellStyle: cfnAnalysisTableCellStylePropertyToCloudFormation(properties.cellStyle), ColumnHeaderStyle: cfnAnalysisTableCellStylePropertyToCloudFormation(properties.columnHeaderStyle), ColumnNamesVisibility: cdk.stringToCloudFormation(properties.columnNamesVisibility), MetricPlacement: cdk.stringToCloudFormation(properties.metricPlacement), RowAlternateColorOptions: cfnAnalysisRowAlternateColorOptionsPropertyToCloudFormation(properties.rowAlternateColorOptions), RowFieldNamesStyle: cfnAnalysisTableCellStylePropertyToCloudFormation(properties.rowFieldNamesStyle), RowHeaderStyle: cfnAnalysisTableCellStylePropertyToCloudFormation(properties.rowHeaderStyle), SingleMetricVisibility: cdk.stringToCloudFormation(properties.singleMetricVisibility), ToggleButtonsVisibility: cdk.stringToCloudFormation(properties.toggleButtonsVisibility) }) : properties;
    }
    function CfnAnalysisPivotTableOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cellStyle", "CellStyle", properties.CellStyle != null ? CfnAnalysisTableCellStylePropertyFromCloudFormation(properties.CellStyle) : void 0), ret.addPropertyResult("columnHeaderStyle", "ColumnHeaderStyle", properties.ColumnHeaderStyle != null ? CfnAnalysisTableCellStylePropertyFromCloudFormation(properties.ColumnHeaderStyle) : void 0), ret.addPropertyResult("columnNamesVisibility", "ColumnNamesVisibility", properties.ColumnNamesVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.ColumnNamesVisibility) : void 0), ret.addPropertyResult("metricPlacement", "MetricPlacement", properties.MetricPlacement != null ? cfn_parse.FromCloudFormation.getString(properties.MetricPlacement) : void 0), ret.addPropertyResult("rowAlternateColorOptions", "RowAlternateColorOptions", properties.RowAlternateColorOptions != null ? CfnAnalysisRowAlternateColorOptionsPropertyFromCloudFormation(properties.RowAlternateColorOptions) : void 0), ret.addPropertyResult("rowFieldNamesStyle", "RowFieldNamesStyle", properties.RowFieldNamesStyle != null ? CfnAnalysisTableCellStylePropertyFromCloudFormation(properties.RowFieldNamesStyle) : void 0), ret.addPropertyResult("rowHeaderStyle", "RowHeaderStyle", properties.RowHeaderStyle != null ? CfnAnalysisTableCellStylePropertyFromCloudFormation(properties.RowHeaderStyle) : void 0), ret.addPropertyResult("singleMetricVisibility", "SingleMetricVisibility", properties.SingleMetricVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.SingleMetricVisibility) : void 0), ret.addPropertyResult("toggleButtonsVisibility", "ToggleButtonsVisibility", properties.ToggleButtonsVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.ToggleButtonsVisibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PivotTablePaginatedReportOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("overflowColumnHeaderVisibility", cdk.validateString)(properties.overflowColumnHeaderVisibility)), errors.collect(cdk.propertyValidator("verticalOverflowVisibility", cdk.validateString)(properties.verticalOverflowVisibility)), errors.wrap('supplied properties not correct for "PivotTablePaginatedReportOptionsProperty"');
    }
    function cfnAnalysisPivotTablePaginatedReportOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PivotTablePaginatedReportOptionsPropertyValidator(properties).assertSuccess(), { OverflowColumnHeaderVisibility: cdk.stringToCloudFormation(properties.overflowColumnHeaderVisibility), VerticalOverflowVisibility: cdk.stringToCloudFormation(properties.verticalOverflowVisibility) }) : properties;
    }
    function CfnAnalysisPivotTablePaginatedReportOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("overflowColumnHeaderVisibility", "OverflowColumnHeaderVisibility", properties.OverflowColumnHeaderVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.OverflowColumnHeaderVisibility) : void 0), ret.addPropertyResult("verticalOverflowVisibility", "VerticalOverflowVisibility", properties.VerticalOverflowVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.VerticalOverflowVisibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PivotTableSortByPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", CfnAnalysis_ColumnSortPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("dataPath", CfnAnalysis_DataPathSortPropertyValidator)(properties.dataPath)), errors.collect(cdk.propertyValidator("field", CfnAnalysis_FieldSortPropertyValidator)(properties.field)), errors.wrap('supplied properties not correct for "PivotTableSortByProperty"');
    }
    function cfnAnalysisPivotTableSortByPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PivotTableSortByPropertyValidator(properties).assertSuccess(), { Column: cfnAnalysisColumnSortPropertyToCloudFormation(properties.column), DataPath: cfnAnalysisDataPathSortPropertyToCloudFormation(properties.dataPath), Field: cfnAnalysisFieldSortPropertyToCloudFormation(properties.field) }) : properties;
    }
    function CfnAnalysisPivotTableSortByPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", properties.Column != null ? CfnAnalysisColumnSortPropertyFromCloudFormation(properties.Column) : void 0), ret.addPropertyResult("dataPath", "DataPath", properties.DataPath != null ? CfnAnalysisDataPathSortPropertyFromCloudFormation(properties.DataPath) : void 0), ret.addPropertyResult("field", "Field", properties.Field != null ? CfnAnalysisFieldSortPropertyFromCloudFormation(properties.Field) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PivotTableSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldSortOptions", cdk.listValidator(CfnAnalysis_PivotFieldSortOptionsPropertyValidator))(properties.fieldSortOptions)), errors.wrap('supplied properties not correct for "PivotTableSortConfigurationProperty"');
    }
    function cfnAnalysisPivotTableSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PivotTableSortConfigurationPropertyValidator(properties).assertSuccess(), { FieldSortOptions: cdk.listMapper(cfnAnalysisPivotFieldSortOptionsPropertyToCloudFormation)(properties.fieldSortOptions) }) : properties;
    }
    function CfnAnalysisPivotTableSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldSortOptions", "FieldSortOptions", properties.FieldSortOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisPivotFieldSortOptionsPropertyFromCloudFormation)(properties.FieldSortOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PivotTableTotalOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnSubtotalOptions", CfnAnalysis_SubtotalOptionsPropertyValidator)(properties.columnSubtotalOptions)), errors.collect(cdk.propertyValidator("columnTotalOptions", CfnAnalysis_PivotTotalOptionsPropertyValidator)(properties.columnTotalOptions)), errors.collect(cdk.propertyValidator("rowSubtotalOptions", CfnAnalysis_SubtotalOptionsPropertyValidator)(properties.rowSubtotalOptions)), errors.collect(cdk.propertyValidator("rowTotalOptions", CfnAnalysis_PivotTotalOptionsPropertyValidator)(properties.rowTotalOptions)), errors.wrap('supplied properties not correct for "PivotTableTotalOptionsProperty"');
    }
    function cfnAnalysisPivotTableTotalOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PivotTableTotalOptionsPropertyValidator(properties).assertSuccess(), { ColumnSubtotalOptions: cfnAnalysisSubtotalOptionsPropertyToCloudFormation(properties.columnSubtotalOptions), ColumnTotalOptions: cfnAnalysisPivotTotalOptionsPropertyToCloudFormation(properties.columnTotalOptions), RowSubtotalOptions: cfnAnalysisSubtotalOptionsPropertyToCloudFormation(properties.rowSubtotalOptions), RowTotalOptions: cfnAnalysisPivotTotalOptionsPropertyToCloudFormation(properties.rowTotalOptions) }) : properties;
    }
    function CfnAnalysisPivotTableTotalOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columnSubtotalOptions", "ColumnSubtotalOptions", properties.ColumnSubtotalOptions != null ? CfnAnalysisSubtotalOptionsPropertyFromCloudFormation(properties.ColumnSubtotalOptions) : void 0), ret.addPropertyResult("columnTotalOptions", "ColumnTotalOptions", properties.ColumnTotalOptions != null ? CfnAnalysisPivotTotalOptionsPropertyFromCloudFormation(properties.ColumnTotalOptions) : void 0), ret.addPropertyResult("rowSubtotalOptions", "RowSubtotalOptions", properties.RowSubtotalOptions != null ? CfnAnalysisSubtotalOptionsPropertyFromCloudFormation(properties.RowSubtotalOptions) : void 0), ret.addPropertyResult("rowTotalOptions", "RowTotalOptions", properties.RowTotalOptions != null ? CfnAnalysisPivotTotalOptionsPropertyFromCloudFormation(properties.RowTotalOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PivotTableVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnAnalysis_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnAnalysis_PivotTableConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("conditionalFormatting", CfnAnalysis_PivotTableConditionalFormattingPropertyValidator)(properties.conditionalFormatting)), errors.collect(cdk.propertyValidator("subtitle", CfnAnalysis_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnAnalysis_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "PivotTableVisualProperty"');
    }
    function cfnAnalysisPivotTableVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PivotTableVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnAnalysisVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnAnalysisPivotTableConfigurationPropertyToCloudFormation(properties.chartConfiguration), ConditionalFormatting: cfnAnalysisPivotTableConditionalFormattingPropertyToCloudFormation(properties.conditionalFormatting), Subtitle: cfnAnalysisVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnAnalysisVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnAnalysisPivotTableVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnAnalysisPivotTableConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("conditionalFormatting", "ConditionalFormatting", properties.ConditionalFormatting != null ? CfnAnalysisPivotTableConditionalFormattingPropertyFromCloudFormation(properties.ConditionalFormatting) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnAnalysisVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnAnalysisVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PivotTotalOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customLabel", cdk.validateString)(properties.customLabel)), errors.collect(cdk.propertyValidator("metricHeaderCellStyle", CfnAnalysis_TableCellStylePropertyValidator)(properties.metricHeaderCellStyle)), errors.collect(cdk.propertyValidator("placement", cdk.validateString)(properties.placement)), errors.collect(cdk.propertyValidator("scrollStatus", cdk.validateString)(properties.scrollStatus)), errors.collect(cdk.propertyValidator("totalCellStyle", CfnAnalysis_TableCellStylePropertyValidator)(properties.totalCellStyle)), errors.collect(cdk.propertyValidator("totalsVisibility", cdk.validateString)(properties.totalsVisibility)), errors.collect(cdk.propertyValidator("valueCellStyle", CfnAnalysis_TableCellStylePropertyValidator)(properties.valueCellStyle)), errors.wrap('supplied properties not correct for "PivotTotalOptionsProperty"');
    }
    function cfnAnalysisPivotTotalOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PivotTotalOptionsPropertyValidator(properties).assertSuccess(), { CustomLabel: cdk.stringToCloudFormation(properties.customLabel), MetricHeaderCellStyle: cfnAnalysisTableCellStylePropertyToCloudFormation(properties.metricHeaderCellStyle), Placement: cdk.stringToCloudFormation(properties.placement), ScrollStatus: cdk.stringToCloudFormation(properties.scrollStatus), TotalCellStyle: cfnAnalysisTableCellStylePropertyToCloudFormation(properties.totalCellStyle), TotalsVisibility: cdk.stringToCloudFormation(properties.totalsVisibility), ValueCellStyle: cfnAnalysisTableCellStylePropertyToCloudFormation(properties.valueCellStyle) }) : properties;
    }
    function CfnAnalysisPivotTotalOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customLabel", "CustomLabel", properties.CustomLabel != null ? cfn_parse.FromCloudFormation.getString(properties.CustomLabel) : void 0), ret.addPropertyResult("metricHeaderCellStyle", "MetricHeaderCellStyle", properties.MetricHeaderCellStyle != null ? CfnAnalysisTableCellStylePropertyFromCloudFormation(properties.MetricHeaderCellStyle) : void 0), ret.addPropertyResult("placement", "Placement", properties.Placement != null ? cfn_parse.FromCloudFormation.getString(properties.Placement) : void 0), ret.addPropertyResult("scrollStatus", "ScrollStatus", properties.ScrollStatus != null ? cfn_parse.FromCloudFormation.getString(properties.ScrollStatus) : void 0), ret.addPropertyResult("totalCellStyle", "TotalCellStyle", properties.TotalCellStyle != null ? CfnAnalysisTableCellStylePropertyFromCloudFormation(properties.TotalCellStyle) : void 0), ret.addPropertyResult("totalsVisibility", "TotalsVisibility", properties.TotalsVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.TotalsVisibility) : void 0), ret.addPropertyResult("valueCellStyle", "ValueCellStyle", properties.ValueCellStyle != null ? CfnAnalysisTableCellStylePropertyFromCloudFormation(properties.ValueCellStyle) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_PredefinedHierarchyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columns", cdk.requiredValidator)(properties.columns)), errors.collect(cdk.propertyValidator("columns", cdk.listValidator(CfnAnalysis_ColumnIdentifierPropertyValidator))(properties.columns)), errors.collect(cdk.propertyValidator("drillDownFilters", cdk.listValidator(CfnAnalysis_DrillDownFilterPropertyValidator))(properties.drillDownFilters)), errors.collect(cdk.propertyValidator("hierarchyId", cdk.requiredValidator)(properties.hierarchyId)), errors.collect(cdk.propertyValidator("hierarchyId", cdk.validateString)(properties.hierarchyId)), errors.wrap('supplied properties not correct for "PredefinedHierarchyProperty"');
    }
    function cfnAnalysisPredefinedHierarchyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_PredefinedHierarchyPropertyValidator(properties).assertSuccess(), { Columns: cdk.listMapper(cfnAnalysisColumnIdentifierPropertyToCloudFormation)(properties.columns), DrillDownFilters: cdk.listMapper(cfnAnalysisDrillDownFilterPropertyToCloudFormation)(properties.drillDownFilters), HierarchyId: cdk.stringToCloudFormation(properties.hierarchyId) }) : properties;
    }
    function CfnAnalysisPredefinedHierarchyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columns", "Columns", cfn_parse.FromCloudFormation.getArray(CfnAnalysisColumnIdentifierPropertyFromCloudFormation)(properties.Columns)), ret.addPropertyResult("drillDownFilters", "DrillDownFilters", properties.DrillDownFilters != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDrillDownFilterPropertyFromCloudFormation)(properties.DrillDownFilters) : void 0), ret.addPropertyResult("hierarchyId", "HierarchyId", cfn_parse.FromCloudFormation.getString(properties.HierarchyId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ProgressBarOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "ProgressBarOptionsProperty"');
    }
    function cfnAnalysisProgressBarOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ProgressBarOptionsPropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnAnalysisProgressBarOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_RadarChartAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("category", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.category)), errors.collect(cdk.propertyValidator("color", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.color)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnAnalysis_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "RadarChartAggregatedFieldWellsProperty"');
    }
    function cfnAnalysisRadarChartAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_RadarChartAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Category: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.category), Color: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.color), Values: cdk.listMapper(cfnAnalysisMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnAnalysisRadarChartAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("category", "Category", properties.Category != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.Category) : void 0), ret.addPropertyResult("color", "Color", properties.Color != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.Color) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_RadarChartAreaStyleSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "RadarChartAreaStyleSettingsProperty"');
    }
    function cfnAnalysisRadarChartAreaStyleSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_RadarChartAreaStyleSettingsPropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnAnalysisRadarChartAreaStyleSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_RadarChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alternateBandColorsVisibility", cdk.validateString)(properties.alternateBandColorsVisibility)), errors.collect(cdk.propertyValidator("alternateBandEvenColor", cdk.validateString)(properties.alternateBandEvenColor)), errors.collect(cdk.propertyValidator("alternateBandOddColor", cdk.validateString)(properties.alternateBandOddColor)), errors.collect(cdk.propertyValidator("baseSeriesSettings", CfnAnalysis_RadarChartSeriesSettingsPropertyValidator)(properties.baseSeriesSettings)), errors.collect(cdk.propertyValidator("categoryAxis", CfnAnalysis_AxisDisplayOptionsPropertyValidator)(properties.categoryAxis)), errors.collect(cdk.propertyValidator("categoryLabelOptions", CfnAnalysis_ChartAxisLabelOptionsPropertyValidator)(properties.categoryLabelOptions)), errors.collect(cdk.propertyValidator("colorAxis", CfnAnalysis_AxisDisplayOptionsPropertyValidator)(properties.colorAxis)), errors.collect(cdk.propertyValidator("colorLabelOptions", CfnAnalysis_ChartAxisLabelOptionsPropertyValidator)(properties.colorLabelOptions)), errors.collect(cdk.propertyValidator("fieldWells", CfnAnalysis_RadarChartFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("legend", CfnAnalysis_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("shape", cdk.validateString)(properties.shape)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnAnalysis_RadarChartSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("startAngle", cdk.validateNumber)(properties.startAngle)), errors.collect(cdk.propertyValidator("visualPalette", CfnAnalysis_VisualPalettePropertyValidator)(properties.visualPalette)), errors.wrap('supplied properties not correct for "RadarChartConfigurationProperty"');
    }
    function cfnAnalysisRadarChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_RadarChartConfigurationPropertyValidator(properties).assertSuccess(), { AlternateBandColorsVisibility: cdk.stringToCloudFormation(properties.alternateBandColorsVisibility), AlternateBandEvenColor: cdk.stringToCloudFormation(properties.alternateBandEvenColor), AlternateBandOddColor: cdk.stringToCloudFormation(properties.alternateBandOddColor), BaseSeriesSettings: cfnAnalysisRadarChartSeriesSettingsPropertyToCloudFormation(properties.baseSeriesSettings), CategoryAxis: cfnAnalysisAxisDisplayOptionsPropertyToCloudFormation(properties.categoryAxis), CategoryLabelOptions: cfnAnalysisChartAxisLabelOptionsPropertyToCloudFormation(properties.categoryLabelOptions), ColorAxis: cfnAnalysisAxisDisplayOptionsPropertyToCloudFormation(properties.colorAxis), ColorLabelOptions: cfnAnalysisChartAxisLabelOptionsPropertyToCloudFormation(properties.colorLabelOptions), FieldWells: cfnAnalysisRadarChartFieldWellsPropertyToCloudFormation(properties.fieldWells), Legend: cfnAnalysisLegendOptionsPropertyToCloudFormation(properties.legend), Shape: cdk.stringToCloudFormation(properties.shape), SortConfiguration: cfnAnalysisRadarChartSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), StartAngle: cdk.numberToCloudFormation(properties.startAngle), VisualPalette: cfnAnalysisVisualPalettePropertyToCloudFormation(properties.visualPalette) }) : properties;
    }
    function CfnAnalysisRadarChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alternateBandColorsVisibility", "AlternateBandColorsVisibility", properties.AlternateBandColorsVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.AlternateBandColorsVisibility) : void 0), ret.addPropertyResult("alternateBandEvenColor", "AlternateBandEvenColor", properties.AlternateBandEvenColor != null ? cfn_parse.FromCloudFormation.getString(properties.AlternateBandEvenColor) : void 0), ret.addPropertyResult("alternateBandOddColor", "AlternateBandOddColor", properties.AlternateBandOddColor != null ? cfn_parse.FromCloudFormation.getString(properties.AlternateBandOddColor) : void 0), ret.addPropertyResult("baseSeriesSettings", "BaseSeriesSettings", properties.BaseSeriesSettings != null ? CfnAnalysisRadarChartSeriesSettingsPropertyFromCloudFormation(properties.BaseSeriesSettings) : void 0), ret.addPropertyResult("categoryAxis", "CategoryAxis", properties.CategoryAxis != null ? CfnAnalysisAxisDisplayOptionsPropertyFromCloudFormation(properties.CategoryAxis) : void 0), ret.addPropertyResult("categoryLabelOptions", "CategoryLabelOptions", properties.CategoryLabelOptions != null ? CfnAnalysisChartAxisLabelOptionsPropertyFromCloudFormation(properties.CategoryLabelOptions) : void 0), ret.addPropertyResult("colorAxis", "ColorAxis", properties.ColorAxis != null ? CfnAnalysisAxisDisplayOptionsPropertyFromCloudFormation(properties.ColorAxis) : void 0), ret.addPropertyResult("colorLabelOptions", "ColorLabelOptions", properties.ColorLabelOptions != null ? CfnAnalysisChartAxisLabelOptionsPropertyFromCloudFormation(properties.ColorLabelOptions) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnAnalysisRadarChartFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnAnalysisLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("shape", "Shape", properties.Shape != null ? cfn_parse.FromCloudFormation.getString(properties.Shape) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnAnalysisRadarChartSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("startAngle", "StartAngle", properties.StartAngle != null ? cfn_parse.FromCloudFormation.getNumber(properties.StartAngle) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnAnalysisVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_RadarChartFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("radarChartAggregatedFieldWells", CfnAnalysis_RadarChartAggregatedFieldWellsPropertyValidator)(properties.radarChartAggregatedFieldWells)), errors.wrap('supplied properties not correct for "RadarChartFieldWellsProperty"');
    }
    function cfnAnalysisRadarChartFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_RadarChartFieldWellsPropertyValidator(properties).assertSuccess(), { RadarChartAggregatedFieldWells: cfnAnalysisRadarChartAggregatedFieldWellsPropertyToCloudFormation(properties.radarChartAggregatedFieldWells) }) : properties;
    }
    function CfnAnalysisRadarChartFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("radarChartAggregatedFieldWells", "RadarChartAggregatedFieldWells", properties.RadarChartAggregatedFieldWells != null ? CfnAnalysisRadarChartAggregatedFieldWellsPropertyFromCloudFormation(properties.RadarChartAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_RadarChartSeriesSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("areaStyleSettings", CfnAnalysis_RadarChartAreaStyleSettingsPropertyValidator)(properties.areaStyleSettings)), errors.wrap('supplied properties not correct for "RadarChartSeriesSettingsProperty"');
    }
    function cfnAnalysisRadarChartSeriesSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_RadarChartSeriesSettingsPropertyValidator(properties).assertSuccess(), { AreaStyleSettings: cfnAnalysisRadarChartAreaStyleSettingsPropertyToCloudFormation(properties.areaStyleSettings) }) : properties;
    }
    function CfnAnalysisRadarChartSeriesSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("areaStyleSettings", "AreaStyleSettings", properties.AreaStyleSettings != null ? CfnAnalysisRadarChartAreaStyleSettingsPropertyFromCloudFormation(properties.AreaStyleSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_RadarChartSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryItemsLimit", CfnAnalysis_ItemsLimitConfigurationPropertyValidator)(properties.categoryItemsLimit)), errors.collect(cdk.propertyValidator("categorySort", cdk.listValidator(CfnAnalysis_FieldSortOptionsPropertyValidator))(properties.categorySort)), errors.collect(cdk.propertyValidator("colorItemsLimit", CfnAnalysis_ItemsLimitConfigurationPropertyValidator)(properties.colorItemsLimit)), errors.collect(cdk.propertyValidator("colorSort", cdk.listValidator(CfnAnalysis_FieldSortOptionsPropertyValidator))(properties.colorSort)), errors.wrap('supplied properties not correct for "RadarChartSortConfigurationProperty"');
    }
    function cfnAnalysisRadarChartSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_RadarChartSortConfigurationPropertyValidator(properties).assertSuccess(), { CategoryItemsLimit: cfnAnalysisItemsLimitConfigurationPropertyToCloudFormation(properties.categoryItemsLimit), CategorySort: cdk.listMapper(cfnAnalysisFieldSortOptionsPropertyToCloudFormation)(properties.categorySort), ColorItemsLimit: cfnAnalysisItemsLimitConfigurationPropertyToCloudFormation(properties.colorItemsLimit), ColorSort: cdk.listMapper(cfnAnalysisFieldSortOptionsPropertyToCloudFormation)(properties.colorSort) }) : properties;
    }
    function CfnAnalysisRadarChartSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryItemsLimit", "CategoryItemsLimit", properties.CategoryItemsLimit != null ? CfnAnalysisItemsLimitConfigurationPropertyFromCloudFormation(properties.CategoryItemsLimit) : void 0), ret.addPropertyResult("categorySort", "CategorySort", properties.CategorySort != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisFieldSortOptionsPropertyFromCloudFormation)(properties.CategorySort) : void 0), ret.addPropertyResult("colorItemsLimit", "ColorItemsLimit", properties.ColorItemsLimit != null ? CfnAnalysisItemsLimitConfigurationPropertyFromCloudFormation(properties.ColorItemsLimit) : void 0), ret.addPropertyResult("colorSort", "ColorSort", properties.ColorSort != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisFieldSortOptionsPropertyFromCloudFormation)(properties.ColorSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_RadarChartVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnAnalysis_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnAnalysis_RadarChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnAnalysis_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnAnalysis_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnAnalysis_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "RadarChartVisualProperty"');
    }
    function cfnAnalysisRadarChartVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_RadarChartVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnAnalysisVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnAnalysisRadarChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnAnalysisColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnAnalysisVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnAnalysisVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnAnalysisRadarChartVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnAnalysisRadarChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnAnalysisVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnAnalysisVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_RangeEndsLabelTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "RangeEndsLabelTypeProperty"');
    }
    function cfnAnalysisRangeEndsLabelTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_RangeEndsLabelTypePropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnAnalysisRangeEndsLabelTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ReferenceLinePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataConfiguration", cdk.requiredValidator)(properties.dataConfiguration)), errors.collect(cdk.propertyValidator("dataConfiguration", CfnAnalysis_ReferenceLineDataConfigurationPropertyValidator)(properties.dataConfiguration)), errors.collect(cdk.propertyValidator("labelConfiguration", CfnAnalysis_ReferenceLineLabelConfigurationPropertyValidator)(properties.labelConfiguration)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.collect(cdk.propertyValidator("styleConfiguration", CfnAnalysis_ReferenceLineStyleConfigurationPropertyValidator)(properties.styleConfiguration)), errors.wrap('supplied properties not correct for "ReferenceLineProperty"');
    }
    function cfnAnalysisReferenceLinePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ReferenceLinePropertyValidator(properties).assertSuccess(), { DataConfiguration: cfnAnalysisReferenceLineDataConfigurationPropertyToCloudFormation(properties.dataConfiguration), LabelConfiguration: cfnAnalysisReferenceLineLabelConfigurationPropertyToCloudFormation(properties.labelConfiguration), Status: cdk.stringToCloudFormation(properties.status), StyleConfiguration: cfnAnalysisReferenceLineStyleConfigurationPropertyToCloudFormation(properties.styleConfiguration) }) : properties;
    }
    function CfnAnalysisReferenceLinePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataConfiguration", "DataConfiguration", CfnAnalysisReferenceLineDataConfigurationPropertyFromCloudFormation(properties.DataConfiguration)), ret.addPropertyResult("labelConfiguration", "LabelConfiguration", properties.LabelConfiguration != null ? CfnAnalysisReferenceLineLabelConfigurationPropertyFromCloudFormation(properties.LabelConfiguration) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addPropertyResult("styleConfiguration", "StyleConfiguration", properties.StyleConfiguration != null ? CfnAnalysisReferenceLineStyleConfigurationPropertyFromCloudFormation(properties.StyleConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ReferenceLineCustomLabelConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customLabel", cdk.requiredValidator)(properties.customLabel)), errors.collect(cdk.propertyValidator("customLabel", cdk.validateString)(properties.customLabel)), errors.wrap('supplied properties not correct for "ReferenceLineCustomLabelConfigurationProperty"');
    }
    function cfnAnalysisReferenceLineCustomLabelConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ReferenceLineCustomLabelConfigurationPropertyValidator(properties).assertSuccess(), { CustomLabel: cdk.stringToCloudFormation(properties.customLabel) }) : properties;
    }
    function CfnAnalysisReferenceLineCustomLabelConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customLabel", "CustomLabel", cfn_parse.FromCloudFormation.getString(properties.CustomLabel)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ReferenceLineDataConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("axisBinding", cdk.validateString)(properties.axisBinding)), errors.collect(cdk.propertyValidator("dynamicConfiguration", CfnAnalysis_ReferenceLineDynamicDataConfigurationPropertyValidator)(properties.dynamicConfiguration)), errors.collect(cdk.propertyValidator("staticConfiguration", CfnAnalysis_ReferenceLineStaticDataConfigurationPropertyValidator)(properties.staticConfiguration)), errors.wrap('supplied properties not correct for "ReferenceLineDataConfigurationProperty"');
    }
    function cfnAnalysisReferenceLineDataConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ReferenceLineDataConfigurationPropertyValidator(properties).assertSuccess(), { AxisBinding: cdk.stringToCloudFormation(properties.axisBinding), DynamicConfiguration: cfnAnalysisReferenceLineDynamicDataConfigurationPropertyToCloudFormation(properties.dynamicConfiguration), StaticConfiguration: cfnAnalysisReferenceLineStaticDataConfigurationPropertyToCloudFormation(properties.staticConfiguration) }) : properties;
    }
    function CfnAnalysisReferenceLineDataConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("axisBinding", "AxisBinding", properties.AxisBinding != null ? cfn_parse.FromCloudFormation.getString(properties.AxisBinding) : void 0), ret.addPropertyResult("dynamicConfiguration", "DynamicConfiguration", properties.DynamicConfiguration != null ? CfnAnalysisReferenceLineDynamicDataConfigurationPropertyFromCloudFormation(properties.DynamicConfiguration) : void 0), ret.addPropertyResult("staticConfiguration", "StaticConfiguration", properties.StaticConfiguration != null ? CfnAnalysisReferenceLineStaticDataConfigurationPropertyFromCloudFormation(properties.StaticConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ReferenceLineDynamicDataConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("calculation", cdk.requiredValidator)(properties.calculation)), errors.collect(cdk.propertyValidator("calculation", CfnAnalysis_NumericalAggregationFunctionPropertyValidator)(properties.calculation)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnAnalysis_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("measureAggregationFunction", cdk.requiredValidator)(properties.measureAggregationFunction)), errors.collect(cdk.propertyValidator("measureAggregationFunction", CfnAnalysis_AggregationFunctionPropertyValidator)(properties.measureAggregationFunction)), errors.wrap('supplied properties not correct for "ReferenceLineDynamicDataConfigurationProperty"');
    }
    function cfnAnalysisReferenceLineDynamicDataConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ReferenceLineDynamicDataConfigurationPropertyValidator(properties).assertSuccess(), { Calculation: cfnAnalysisNumericalAggregationFunctionPropertyToCloudFormation(properties.calculation), Column: cfnAnalysisColumnIdentifierPropertyToCloudFormation(properties.column), MeasureAggregationFunction: cfnAnalysisAggregationFunctionPropertyToCloudFormation(properties.measureAggregationFunction) }) : properties;
    }
    function CfnAnalysisReferenceLineDynamicDataConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("calculation", "Calculation", CfnAnalysisNumericalAggregationFunctionPropertyFromCloudFormation(properties.Calculation)), ret.addPropertyResult("column", "Column", CfnAnalysisColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("measureAggregationFunction", "MeasureAggregationFunction", CfnAnalysisAggregationFunctionPropertyFromCloudFormation(properties.MeasureAggregationFunction)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ReferenceLineLabelConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customLabelConfiguration", CfnAnalysis_ReferenceLineCustomLabelConfigurationPropertyValidator)(properties.customLabelConfiguration)), errors.collect(cdk.propertyValidator("fontColor", cdk.validateString)(properties.fontColor)), errors.collect(cdk.propertyValidator("fontConfiguration", CfnAnalysis_FontConfigurationPropertyValidator)(properties.fontConfiguration)), errors.collect(cdk.propertyValidator("horizontalPosition", cdk.validateString)(properties.horizontalPosition)), errors.collect(cdk.propertyValidator("valueLabelConfiguration", CfnAnalysis_ReferenceLineValueLabelConfigurationPropertyValidator)(properties.valueLabelConfiguration)), errors.collect(cdk.propertyValidator("verticalPosition", cdk.validateString)(properties.verticalPosition)), errors.wrap('supplied properties not correct for "ReferenceLineLabelConfigurationProperty"');
    }
    function cfnAnalysisReferenceLineLabelConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ReferenceLineLabelConfigurationPropertyValidator(properties).assertSuccess(), { CustomLabelConfiguration: cfnAnalysisReferenceLineCustomLabelConfigurationPropertyToCloudFormation(properties.customLabelConfiguration), FontColor: cdk.stringToCloudFormation(properties.fontColor), FontConfiguration: cfnAnalysisFontConfigurationPropertyToCloudFormation(properties.fontConfiguration), HorizontalPosition: cdk.stringToCloudFormation(properties.horizontalPosition), ValueLabelConfiguration: cfnAnalysisReferenceLineValueLabelConfigurationPropertyToCloudFormation(properties.valueLabelConfiguration), VerticalPosition: cdk.stringToCloudFormation(properties.verticalPosition) }) : properties;
    }
    function CfnAnalysisReferenceLineLabelConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customLabelConfiguration", "CustomLabelConfiguration", properties.CustomLabelConfiguration != null ? CfnAnalysisReferenceLineCustomLabelConfigurationPropertyFromCloudFormation(properties.CustomLabelConfiguration) : void 0), ret.addPropertyResult("fontColor", "FontColor", properties.FontColor != null ? cfn_parse.FromCloudFormation.getString(properties.FontColor) : void 0), ret.addPropertyResult("fontConfiguration", "FontConfiguration", properties.FontConfiguration != null ? CfnAnalysisFontConfigurationPropertyFromCloudFormation(properties.FontConfiguration) : void 0), ret.addPropertyResult("horizontalPosition", "HorizontalPosition", properties.HorizontalPosition != null ? cfn_parse.FromCloudFormation.getString(properties.HorizontalPosition) : void 0), ret.addPropertyResult("valueLabelConfiguration", "ValueLabelConfiguration", properties.ValueLabelConfiguration != null ? CfnAnalysisReferenceLineValueLabelConfigurationPropertyFromCloudFormation(properties.ValueLabelConfiguration) : void 0), ret.addPropertyResult("verticalPosition", "VerticalPosition", properties.VerticalPosition != null ? cfn_parse.FromCloudFormation.getString(properties.VerticalPosition) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ReferenceLineStaticDataConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "ReferenceLineStaticDataConfigurationProperty"');
    }
    function cfnAnalysisReferenceLineStaticDataConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ReferenceLineStaticDataConfigurationPropertyValidator(properties).assertSuccess(), { Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnAnalysisReferenceLineStaticDataConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getNumber(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ReferenceLineStyleConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.collect(cdk.propertyValidator("pattern", cdk.validateString)(properties.pattern)), errors.wrap('supplied properties not correct for "ReferenceLineStyleConfigurationProperty"');
    }
    function cfnAnalysisReferenceLineStyleConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ReferenceLineStyleConfigurationPropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color), Pattern: cdk.stringToCloudFormation(properties.pattern) }) : properties;
    }
    function CfnAnalysisReferenceLineStyleConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", properties.Color != null ? cfn_parse.FromCloudFormation.getString(properties.Color) : void 0), ret.addPropertyResult("pattern", "Pattern", properties.Pattern != null ? cfn_parse.FromCloudFormation.getString(properties.Pattern) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ReferenceLineValueLabelConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("formatConfiguration", CfnAnalysis_NumericFormatConfigurationPropertyValidator)(properties.formatConfiguration)), errors.collect(cdk.propertyValidator("relativePosition", cdk.validateString)(properties.relativePosition)), errors.wrap('supplied properties not correct for "ReferenceLineValueLabelConfigurationProperty"');
    }
    function cfnAnalysisReferenceLineValueLabelConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ReferenceLineValueLabelConfigurationPropertyValidator(properties).assertSuccess(), { FormatConfiguration: cfnAnalysisNumericFormatConfigurationPropertyToCloudFormation(properties.formatConfiguration), RelativePosition: cdk.stringToCloudFormation(properties.relativePosition) }) : properties;
    }
    function CfnAnalysisReferenceLineValueLabelConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("formatConfiguration", "FormatConfiguration", properties.FormatConfiguration != null ? CfnAnalysisNumericFormatConfigurationPropertyFromCloudFormation(properties.FormatConfiguration) : void 0), ret.addPropertyResult("relativePosition", "RelativePosition", properties.RelativePosition != null ? cfn_parse.FromCloudFormation.getString(properties.RelativePosition) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_RelativeDateTimeControlDisplayOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateTimeFormat", cdk.validateString)(properties.dateTimeFormat)), errors.collect(cdk.propertyValidator("titleOptions", CfnAnalysis_LabelOptionsPropertyValidator)(properties.titleOptions)), errors.wrap('supplied properties not correct for "RelativeDateTimeControlDisplayOptionsProperty"');
    }
    function cfnAnalysisRelativeDateTimeControlDisplayOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_RelativeDateTimeControlDisplayOptionsPropertyValidator(properties).assertSuccess(), { DateTimeFormat: cdk.stringToCloudFormation(properties.dateTimeFormat), TitleOptions: cfnAnalysisLabelOptionsPropertyToCloudFormation(properties.titleOptions) }) : properties;
    }
    function CfnAnalysisRelativeDateTimeControlDisplayOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateTimeFormat", "DateTimeFormat", properties.DateTimeFormat != null ? cfn_parse.FromCloudFormation.getString(properties.DateTimeFormat) : void 0), ret.addPropertyResult("titleOptions", "TitleOptions", properties.TitleOptions != null ? CfnAnalysisLabelOptionsPropertyFromCloudFormation(properties.TitleOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_RelativeDatesFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("anchorDateConfiguration", cdk.requiredValidator)(properties.anchorDateConfiguration)), errors.collect(cdk.propertyValidator("anchorDateConfiguration", CfnAnalysis_AnchorDateConfigurationPropertyValidator)(properties.anchorDateConfiguration)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnAnalysis_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("excludePeriodConfiguration", CfnAnalysis_ExcludePeriodConfigurationPropertyValidator)(properties.excludePeriodConfiguration)), errors.collect(cdk.propertyValidator("filterId", cdk.requiredValidator)(properties.filterId)), errors.collect(cdk.propertyValidator("filterId", cdk.validateString)(properties.filterId)), errors.collect(cdk.propertyValidator("minimumGranularity", cdk.validateString)(properties.minimumGranularity)), errors.collect(cdk.propertyValidator("nullOption", cdk.requiredValidator)(properties.nullOption)), errors.collect(cdk.propertyValidator("nullOption", cdk.validateString)(properties.nullOption)), errors.collect(cdk.propertyValidator("parameterName", cdk.validateString)(properties.parameterName)), errors.collect(cdk.propertyValidator("relativeDateType", cdk.requiredValidator)(properties.relativeDateType)), errors.collect(cdk.propertyValidator("relativeDateType", cdk.validateString)(properties.relativeDateType)), errors.collect(cdk.propertyValidator("relativeDateValue", cdk.validateNumber)(properties.relativeDateValue)), errors.collect(cdk.propertyValidator("timeGranularity", cdk.requiredValidator)(properties.timeGranularity)), errors.collect(cdk.propertyValidator("timeGranularity", cdk.validateString)(properties.timeGranularity)), errors.wrap('supplied properties not correct for "RelativeDatesFilterProperty"');
    }
    function cfnAnalysisRelativeDatesFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_RelativeDatesFilterPropertyValidator(properties).assertSuccess(), { AnchorDateConfiguration: cfnAnalysisAnchorDateConfigurationPropertyToCloudFormation(properties.anchorDateConfiguration), Column: cfnAnalysisColumnIdentifierPropertyToCloudFormation(properties.column), ExcludePeriodConfiguration: cfnAnalysisExcludePeriodConfigurationPropertyToCloudFormation(properties.excludePeriodConfiguration), FilterId: cdk.stringToCloudFormation(properties.filterId), MinimumGranularity: cdk.stringToCloudFormation(properties.minimumGranularity), NullOption: cdk.stringToCloudFormation(properties.nullOption), ParameterName: cdk.stringToCloudFormation(properties.parameterName), RelativeDateType: cdk.stringToCloudFormation(properties.relativeDateType), RelativeDateValue: cdk.numberToCloudFormation(properties.relativeDateValue), TimeGranularity: cdk.stringToCloudFormation(properties.timeGranularity) }) : properties;
    }
    function CfnAnalysisRelativeDatesFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("anchorDateConfiguration", "AnchorDateConfiguration", CfnAnalysisAnchorDateConfigurationPropertyFromCloudFormation(properties.AnchorDateConfiguration)), ret.addPropertyResult("column", "Column", CfnAnalysisColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("excludePeriodConfiguration", "ExcludePeriodConfiguration", properties.ExcludePeriodConfiguration != null ? CfnAnalysisExcludePeriodConfigurationPropertyFromCloudFormation(properties.ExcludePeriodConfiguration) : void 0), ret.addPropertyResult("filterId", "FilterId", cfn_parse.FromCloudFormation.getString(properties.FilterId)), ret.addPropertyResult("minimumGranularity", "MinimumGranularity", properties.MinimumGranularity != null ? cfn_parse.FromCloudFormation.getString(properties.MinimumGranularity) : void 0), ret.addPropertyResult("nullOption", "NullOption", cfn_parse.FromCloudFormation.getString(properties.NullOption)), ret.addPropertyResult("parameterName", "ParameterName", properties.ParameterName != null ? cfn_parse.FromCloudFormation.getString(properties.ParameterName) : void 0), ret.addPropertyResult("relativeDateType", "RelativeDateType", cfn_parse.FromCloudFormation.getString(properties.RelativeDateType)), ret.addPropertyResult("relativeDateValue", "RelativeDateValue", properties.RelativeDateValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.RelativeDateValue) : void 0), ret.addPropertyResult("timeGranularity", "TimeGranularity", cfn_parse.FromCloudFormation.getString(properties.TimeGranularity)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ResourcePermissionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.requiredValidator)(properties.actions)), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(cdk.validateString))(properties.actions)), errors.collect(cdk.propertyValidator("principal", cdk.requiredValidator)(properties.principal)), errors.collect(cdk.propertyValidator("principal", cdk.validateString)(properties.principal)), errors.collect(cdk.propertyValidator("resource", cdk.validateString)(properties.resource)), errors.wrap('supplied properties not correct for "ResourcePermissionProperty"');
    }
    function cfnAnalysisResourcePermissionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ResourcePermissionPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cdk.stringToCloudFormation)(properties.actions), Principal: cdk.stringToCloudFormation(properties.principal), Resource: cdk.stringToCloudFormation(properties.resource) }) : properties;
    }
    function CfnAnalysisResourcePermissionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", cfn_parse.FromCloudFormation.getStringArray(properties.Actions)), ret.addPropertyResult("principal", "Principal", cfn_parse.FromCloudFormation.getString(properties.Principal)), ret.addPropertyResult("resource", "Resource", properties.Resource != null ? cfn_parse.FromCloudFormation.getString(properties.Resource) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_RollingDateConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.validateString)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.wrap('supplied properties not correct for "RollingDateConfigurationProperty"');
    }
    function cfnAnalysisRollingDateConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_RollingDateConfigurationPropertyValidator(properties).assertSuccess(), { DataSetIdentifier: cdk.stringToCloudFormation(properties.dataSetIdentifier), Expression: cdk.stringToCloudFormation(properties.expression) }) : properties;
    }
    function CfnAnalysisRollingDateConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataSetIdentifier", "DataSetIdentifier", properties.DataSetIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.DataSetIdentifier) : void 0), ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getString(properties.Expression)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_RowAlternateColorOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("rowAlternateColors", cdk.listValidator(cdk.validateString))(properties.rowAlternateColors)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "RowAlternateColorOptionsProperty"');
    }
    function cfnAnalysisRowAlternateColorOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_RowAlternateColorOptionsPropertyValidator(properties).assertSuccess(), { RowAlternateColors: cdk.listMapper(cdk.stringToCloudFormation)(properties.rowAlternateColors), Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnAnalysisRowAlternateColorOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("rowAlternateColors", "RowAlternateColors", properties.RowAlternateColors != null ? cfn_parse.FromCloudFormation.getStringArray(properties.RowAlternateColors) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_SameSheetTargetVisualConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("targetVisualOptions", cdk.validateString)(properties.targetVisualOptions)), errors.collect(cdk.propertyValidator("targetVisuals", cdk.listValidator(cdk.validateString))(properties.targetVisuals)), errors.wrap('supplied properties not correct for "SameSheetTargetVisualConfigurationProperty"');
    }
    function cfnAnalysisSameSheetTargetVisualConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_SameSheetTargetVisualConfigurationPropertyValidator(properties).assertSuccess(), { TargetVisualOptions: cdk.stringToCloudFormation(properties.targetVisualOptions), TargetVisuals: cdk.listMapper(cdk.stringToCloudFormation)(properties.targetVisuals) }) : properties;
    }
    function CfnAnalysisSameSheetTargetVisualConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("targetVisualOptions", "TargetVisualOptions", properties.TargetVisualOptions != null ? cfn_parse.FromCloudFormation.getString(properties.TargetVisualOptions) : void 0), ret.addPropertyResult("targetVisuals", "TargetVisuals", properties.TargetVisuals != null ? cfn_parse.FromCloudFormation.getStringArray(properties.TargetVisuals) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_SankeyDiagramAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destination", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.destination)), errors.collect(cdk.propertyValidator("source", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.source)), errors.collect(cdk.propertyValidator("weight", cdk.listValidator(CfnAnalysis_MeasureFieldPropertyValidator))(properties.weight)), errors.wrap('supplied properties not correct for "SankeyDiagramAggregatedFieldWellsProperty"');
    }
    function cfnAnalysisSankeyDiagramAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_SankeyDiagramAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Destination: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.destination), Source: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.source), Weight: cdk.listMapper(cfnAnalysisMeasureFieldPropertyToCloudFormation)(properties.weight) }) : properties;
    }
    function CfnAnalysisSankeyDiagramAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destination", "Destination", properties.Destination != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.Destination) : void 0), ret.addPropertyResult("source", "Source", properties.Source != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.Source) : void 0), ret.addPropertyResult("weight", "Weight", properties.Weight != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMeasureFieldPropertyFromCloudFormation)(properties.Weight) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_SankeyDiagramChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataLabels", CfnAnalysis_DataLabelOptionsPropertyValidator)(properties.dataLabels)), errors.collect(cdk.propertyValidator("fieldWells", CfnAnalysis_SankeyDiagramFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnAnalysis_SankeyDiagramSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.wrap('supplied properties not correct for "SankeyDiagramChartConfigurationProperty"');
    }
    function cfnAnalysisSankeyDiagramChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_SankeyDiagramChartConfigurationPropertyValidator(properties).assertSuccess(), { DataLabels: cfnAnalysisDataLabelOptionsPropertyToCloudFormation(properties.dataLabels), FieldWells: cfnAnalysisSankeyDiagramFieldWellsPropertyToCloudFormation(properties.fieldWells), SortConfiguration: cfnAnalysisSankeyDiagramSortConfigurationPropertyToCloudFormation(properties.sortConfiguration) }) : properties;
    }
    function CfnAnalysisSankeyDiagramChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataLabels", "DataLabels", properties.DataLabels != null ? CfnAnalysisDataLabelOptionsPropertyFromCloudFormation(properties.DataLabels) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnAnalysisSankeyDiagramFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnAnalysisSankeyDiagramSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_SankeyDiagramFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sankeyDiagramAggregatedFieldWells", CfnAnalysis_SankeyDiagramAggregatedFieldWellsPropertyValidator)(properties.sankeyDiagramAggregatedFieldWells)), errors.wrap('supplied properties not correct for "SankeyDiagramFieldWellsProperty"');
    }
    function cfnAnalysisSankeyDiagramFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_SankeyDiagramFieldWellsPropertyValidator(properties).assertSuccess(), { SankeyDiagramAggregatedFieldWells: cfnAnalysisSankeyDiagramAggregatedFieldWellsPropertyToCloudFormation(properties.sankeyDiagramAggregatedFieldWells) }) : properties;
    }
    function CfnAnalysisSankeyDiagramFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sankeyDiagramAggregatedFieldWells", "SankeyDiagramAggregatedFieldWells", properties.SankeyDiagramAggregatedFieldWells != null ? CfnAnalysisSankeyDiagramAggregatedFieldWellsPropertyFromCloudFormation(properties.SankeyDiagramAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_SankeyDiagramSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationItemsLimit", CfnAnalysis_ItemsLimitConfigurationPropertyValidator)(properties.destinationItemsLimit)), errors.collect(cdk.propertyValidator("sourceItemsLimit", CfnAnalysis_ItemsLimitConfigurationPropertyValidator)(properties.sourceItemsLimit)), errors.collect(cdk.propertyValidator("weightSort", cdk.listValidator(CfnAnalysis_FieldSortOptionsPropertyValidator))(properties.weightSort)), errors.wrap('supplied properties not correct for "SankeyDiagramSortConfigurationProperty"');
    }
    function cfnAnalysisSankeyDiagramSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_SankeyDiagramSortConfigurationPropertyValidator(properties).assertSuccess(), { DestinationItemsLimit: cfnAnalysisItemsLimitConfigurationPropertyToCloudFormation(properties.destinationItemsLimit), SourceItemsLimit: cfnAnalysisItemsLimitConfigurationPropertyToCloudFormation(properties.sourceItemsLimit), WeightSort: cdk.listMapper(cfnAnalysisFieldSortOptionsPropertyToCloudFormation)(properties.weightSort) }) : properties;
    }
    function CfnAnalysisSankeyDiagramSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationItemsLimit", "DestinationItemsLimit", properties.DestinationItemsLimit != null ? CfnAnalysisItemsLimitConfigurationPropertyFromCloudFormation(properties.DestinationItemsLimit) : void 0), ret.addPropertyResult("sourceItemsLimit", "SourceItemsLimit", properties.SourceItemsLimit != null ? CfnAnalysisItemsLimitConfigurationPropertyFromCloudFormation(properties.SourceItemsLimit) : void 0), ret.addPropertyResult("weightSort", "WeightSort", properties.WeightSort != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisFieldSortOptionsPropertyFromCloudFormation)(properties.WeightSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_SankeyDiagramVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnAnalysis_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnAnalysis_SankeyDiagramChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("subtitle", CfnAnalysis_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnAnalysis_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "SankeyDiagramVisualProperty"');
    }
    function cfnAnalysisSankeyDiagramVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_SankeyDiagramVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnAnalysisVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnAnalysisSankeyDiagramChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), Subtitle: cfnAnalysisVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnAnalysisVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnAnalysisSankeyDiagramVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnAnalysisSankeyDiagramChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnAnalysisVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnAnalysisVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ScatterPlotCategoricallyAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("category", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.category)), errors.collect(cdk.propertyValidator("size", cdk.listValidator(CfnAnalysis_MeasureFieldPropertyValidator))(properties.size)), errors.collect(cdk.propertyValidator("xAxis", cdk.listValidator(CfnAnalysis_MeasureFieldPropertyValidator))(properties.xAxis)), errors.collect(cdk.propertyValidator("yAxis", cdk.listValidator(CfnAnalysis_MeasureFieldPropertyValidator))(properties.yAxis)), errors.wrap('supplied properties not correct for "ScatterPlotCategoricallyAggregatedFieldWellsProperty"');
    }
    function cfnAnalysisScatterPlotCategoricallyAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ScatterPlotCategoricallyAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Category: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.category), Size: cdk.listMapper(cfnAnalysisMeasureFieldPropertyToCloudFormation)(properties.size), XAxis: cdk.listMapper(cfnAnalysisMeasureFieldPropertyToCloudFormation)(properties.xAxis), YAxis: cdk.listMapper(cfnAnalysisMeasureFieldPropertyToCloudFormation)(properties.yAxis) }) : properties;
    }
    function CfnAnalysisScatterPlotCategoricallyAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("category", "Category", properties.Category != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.Category) : void 0), ret.addPropertyResult("size", "Size", properties.Size != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMeasureFieldPropertyFromCloudFormation)(properties.Size) : void 0), ret.addPropertyResult("xAxis", "XAxis", properties.XAxis != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMeasureFieldPropertyFromCloudFormation)(properties.XAxis) : void 0), ret.addPropertyResult("yAxis", "YAxis", properties.YAxis != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMeasureFieldPropertyFromCloudFormation)(properties.YAxis) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ScatterPlotConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataLabels", CfnAnalysis_DataLabelOptionsPropertyValidator)(properties.dataLabels)), errors.collect(cdk.propertyValidator("fieldWells", CfnAnalysis_ScatterPlotFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("legend", CfnAnalysis_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("tooltip", CfnAnalysis_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.collect(cdk.propertyValidator("visualPalette", CfnAnalysis_VisualPalettePropertyValidator)(properties.visualPalette)), errors.collect(cdk.propertyValidator("xAxisDisplayOptions", CfnAnalysis_AxisDisplayOptionsPropertyValidator)(properties.xAxisDisplayOptions)), errors.collect(cdk.propertyValidator("xAxisLabelOptions", CfnAnalysis_ChartAxisLabelOptionsPropertyValidator)(properties.xAxisLabelOptions)), errors.collect(cdk.propertyValidator("yAxisDisplayOptions", CfnAnalysis_AxisDisplayOptionsPropertyValidator)(properties.yAxisDisplayOptions)), errors.collect(cdk.propertyValidator("yAxisLabelOptions", CfnAnalysis_ChartAxisLabelOptionsPropertyValidator)(properties.yAxisLabelOptions)), errors.wrap('supplied properties not correct for "ScatterPlotConfigurationProperty"');
    }
    function cfnAnalysisScatterPlotConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ScatterPlotConfigurationPropertyValidator(properties).assertSuccess(), { DataLabels: cfnAnalysisDataLabelOptionsPropertyToCloudFormation(properties.dataLabels), FieldWells: cfnAnalysisScatterPlotFieldWellsPropertyToCloudFormation(properties.fieldWells), Legend: cfnAnalysisLegendOptionsPropertyToCloudFormation(properties.legend), Tooltip: cfnAnalysisTooltipOptionsPropertyToCloudFormation(properties.tooltip), VisualPalette: cfnAnalysisVisualPalettePropertyToCloudFormation(properties.visualPalette), XAxisDisplayOptions: cfnAnalysisAxisDisplayOptionsPropertyToCloudFormation(properties.xAxisDisplayOptions), XAxisLabelOptions: cfnAnalysisChartAxisLabelOptionsPropertyToCloudFormation(properties.xAxisLabelOptions), YAxisDisplayOptions: cfnAnalysisAxisDisplayOptionsPropertyToCloudFormation(properties.yAxisDisplayOptions), YAxisLabelOptions: cfnAnalysisChartAxisLabelOptionsPropertyToCloudFormation(properties.yAxisLabelOptions) }) : properties;
    }
    function CfnAnalysisScatterPlotConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataLabels", "DataLabels", properties.DataLabels != null ? CfnAnalysisDataLabelOptionsPropertyFromCloudFormation(properties.DataLabels) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnAnalysisScatterPlotFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnAnalysisLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnAnalysisTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnAnalysisVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addPropertyResult("xAxisDisplayOptions", "XAxisDisplayOptions", properties.XAxisDisplayOptions != null ? CfnAnalysisAxisDisplayOptionsPropertyFromCloudFormation(properties.XAxisDisplayOptions) : void 0), ret.addPropertyResult("xAxisLabelOptions", "XAxisLabelOptions", properties.XAxisLabelOptions != null ? CfnAnalysisChartAxisLabelOptionsPropertyFromCloudFormation(properties.XAxisLabelOptions) : void 0), ret.addPropertyResult("yAxisDisplayOptions", "YAxisDisplayOptions", properties.YAxisDisplayOptions != null ? CfnAnalysisAxisDisplayOptionsPropertyFromCloudFormation(properties.YAxisDisplayOptions) : void 0), ret.addPropertyResult("yAxisLabelOptions", "YAxisLabelOptions", properties.YAxisLabelOptions != null ? CfnAnalysisChartAxisLabelOptionsPropertyFromCloudFormation(properties.YAxisLabelOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ScatterPlotFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("scatterPlotCategoricallyAggregatedFieldWells", CfnAnalysis_ScatterPlotCategoricallyAggregatedFieldWellsPropertyValidator)(properties.scatterPlotCategoricallyAggregatedFieldWells)), errors.collect(cdk.propertyValidator("scatterPlotUnaggregatedFieldWells", CfnAnalysis_ScatterPlotUnaggregatedFieldWellsPropertyValidator)(properties.scatterPlotUnaggregatedFieldWells)), errors.wrap('supplied properties not correct for "ScatterPlotFieldWellsProperty"');
    }
    function cfnAnalysisScatterPlotFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ScatterPlotFieldWellsPropertyValidator(properties).assertSuccess(), { ScatterPlotCategoricallyAggregatedFieldWells: cfnAnalysisScatterPlotCategoricallyAggregatedFieldWellsPropertyToCloudFormation(properties.scatterPlotCategoricallyAggregatedFieldWells), ScatterPlotUnaggregatedFieldWells: cfnAnalysisScatterPlotUnaggregatedFieldWellsPropertyToCloudFormation(properties.scatterPlotUnaggregatedFieldWells) }) : properties;
    }
    function CfnAnalysisScatterPlotFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("scatterPlotCategoricallyAggregatedFieldWells", "ScatterPlotCategoricallyAggregatedFieldWells", properties.ScatterPlotCategoricallyAggregatedFieldWells != null ? CfnAnalysisScatterPlotCategoricallyAggregatedFieldWellsPropertyFromCloudFormation(properties.ScatterPlotCategoricallyAggregatedFieldWells) : void 0), ret.addPropertyResult("scatterPlotUnaggregatedFieldWells", "ScatterPlotUnaggregatedFieldWells", properties.ScatterPlotUnaggregatedFieldWells != null ? CfnAnalysisScatterPlotUnaggregatedFieldWellsPropertyFromCloudFormation(properties.ScatterPlotUnaggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ScatterPlotUnaggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("size", cdk.listValidator(CfnAnalysis_MeasureFieldPropertyValidator))(properties.size)), errors.collect(cdk.propertyValidator("xAxis", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.xAxis)), errors.collect(cdk.propertyValidator("yAxis", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.yAxis)), errors.wrap('supplied properties not correct for "ScatterPlotUnaggregatedFieldWellsProperty"');
    }
    function cfnAnalysisScatterPlotUnaggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ScatterPlotUnaggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Size: cdk.listMapper(cfnAnalysisMeasureFieldPropertyToCloudFormation)(properties.size), XAxis: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.xAxis), YAxis: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.yAxis) }) : properties;
    }
    function CfnAnalysisScatterPlotUnaggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("size", "Size", properties.Size != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMeasureFieldPropertyFromCloudFormation)(properties.Size) : void 0), ret.addPropertyResult("xAxis", "XAxis", properties.XAxis != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.XAxis) : void 0), ret.addPropertyResult("yAxis", "YAxis", properties.YAxis != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.YAxis) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ScatterPlotVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnAnalysis_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnAnalysis_ScatterPlotConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnAnalysis_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnAnalysis_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnAnalysis_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "ScatterPlotVisualProperty"');
    }
    function cfnAnalysisScatterPlotVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ScatterPlotVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnAnalysisVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnAnalysisScatterPlotConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnAnalysisColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnAnalysisVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnAnalysisVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnAnalysisScatterPlotVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnAnalysisScatterPlotConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnAnalysisVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnAnalysisVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ScrollBarOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.collect(cdk.propertyValidator("visibleRange", CfnAnalysis_VisibleRangeOptionsPropertyValidator)(properties.visibleRange)), errors.wrap('supplied properties not correct for "ScrollBarOptionsProperty"');
    }
    function cfnAnalysisScrollBarOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ScrollBarOptionsPropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility), VisibleRange: cfnAnalysisVisibleRangeOptionsPropertyToCloudFormation(properties.visibleRange) }) : properties;
    }
    function CfnAnalysisScrollBarOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addPropertyResult("visibleRange", "VisibleRange", properties.VisibleRange != null ? CfnAnalysisVisibleRangeOptionsPropertyFromCloudFormation(properties.VisibleRange) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_SecondaryValueOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "SecondaryValueOptionsProperty"');
    }
    function cfnAnalysisSecondaryValueOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_SecondaryValueOptionsPropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnAnalysisSecondaryValueOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_SectionAfterPageBreakPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "SectionAfterPageBreakProperty"');
    }
    function cfnAnalysisSectionAfterPageBreakPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_SectionAfterPageBreakPropertyValidator(properties).assertSuccess(), { Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnAnalysisSectionAfterPageBreakPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_SectionBasedLayoutCanvasSizeOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("paperCanvasSizeOptions", CfnAnalysis_SectionBasedLayoutPaperCanvasSizeOptionsPropertyValidator)(properties.paperCanvasSizeOptions)), errors.wrap('supplied properties not correct for "SectionBasedLayoutCanvasSizeOptionsProperty"');
    }
    function cfnAnalysisSectionBasedLayoutCanvasSizeOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_SectionBasedLayoutCanvasSizeOptionsPropertyValidator(properties).assertSuccess(), { PaperCanvasSizeOptions: cfnAnalysisSectionBasedLayoutPaperCanvasSizeOptionsPropertyToCloudFormation(properties.paperCanvasSizeOptions) }) : properties;
    }
    function CfnAnalysisSectionBasedLayoutCanvasSizeOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("paperCanvasSizeOptions", "PaperCanvasSizeOptions", properties.PaperCanvasSizeOptions != null ? CfnAnalysisSectionBasedLayoutPaperCanvasSizeOptionsPropertyFromCloudFormation(properties.PaperCanvasSizeOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_SectionBasedLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bodySections", cdk.requiredValidator)(properties.bodySections)), errors.collect(cdk.propertyValidator("bodySections", cdk.listValidator(CfnAnalysis_BodySectionConfigurationPropertyValidator))(properties.bodySections)), errors.collect(cdk.propertyValidator("canvasSizeOptions", cdk.requiredValidator)(properties.canvasSizeOptions)), errors.collect(cdk.propertyValidator("canvasSizeOptions", CfnAnalysis_SectionBasedLayoutCanvasSizeOptionsPropertyValidator)(properties.canvasSizeOptions)), errors.collect(cdk.propertyValidator("footerSections", cdk.requiredValidator)(properties.footerSections)), errors.collect(cdk.propertyValidator("footerSections", cdk.listValidator(CfnAnalysis_HeaderFooterSectionConfigurationPropertyValidator))(properties.footerSections)), errors.collect(cdk.propertyValidator("headerSections", cdk.requiredValidator)(properties.headerSections)), errors.collect(cdk.propertyValidator("headerSections", cdk.listValidator(CfnAnalysis_HeaderFooterSectionConfigurationPropertyValidator))(properties.headerSections)), errors.wrap('supplied properties not correct for "SectionBasedLayoutConfigurationProperty"');
    }
    function cfnAnalysisSectionBasedLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_SectionBasedLayoutConfigurationPropertyValidator(properties).assertSuccess(), { BodySections: cdk.listMapper(cfnAnalysisBodySectionConfigurationPropertyToCloudFormation)(properties.bodySections), CanvasSizeOptions: cfnAnalysisSectionBasedLayoutCanvasSizeOptionsPropertyToCloudFormation(properties.canvasSizeOptions), FooterSections: cdk.listMapper(cfnAnalysisHeaderFooterSectionConfigurationPropertyToCloudFormation)(properties.footerSections), HeaderSections: cdk.listMapper(cfnAnalysisHeaderFooterSectionConfigurationPropertyToCloudFormation)(properties.headerSections) }) : properties;
    }
    function CfnAnalysisSectionBasedLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bodySections", "BodySections", cfn_parse.FromCloudFormation.getArray(CfnAnalysisBodySectionConfigurationPropertyFromCloudFormation)(properties.BodySections)), ret.addPropertyResult("canvasSizeOptions", "CanvasSizeOptions", CfnAnalysisSectionBasedLayoutCanvasSizeOptionsPropertyFromCloudFormation(properties.CanvasSizeOptions)), ret.addPropertyResult("footerSections", "FooterSections", cfn_parse.FromCloudFormation.getArray(CfnAnalysisHeaderFooterSectionConfigurationPropertyFromCloudFormation)(properties.FooterSections)), ret.addPropertyResult("headerSections", "HeaderSections", cfn_parse.FromCloudFormation.getArray(CfnAnalysisHeaderFooterSectionConfigurationPropertyFromCloudFormation)(properties.HeaderSections)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_SectionBasedLayoutPaperCanvasSizeOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("paperMargin", CfnAnalysis_SpacingPropertyValidator)(properties.paperMargin)), errors.collect(cdk.propertyValidator("paperOrientation", cdk.validateString)(properties.paperOrientation)), errors.collect(cdk.propertyValidator("paperSize", cdk.validateString)(properties.paperSize)), errors.wrap('supplied properties not correct for "SectionBasedLayoutPaperCanvasSizeOptionsProperty"');
    }
    function cfnAnalysisSectionBasedLayoutPaperCanvasSizeOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_SectionBasedLayoutPaperCanvasSizeOptionsPropertyValidator(properties).assertSuccess(), { PaperMargin: cfnAnalysisSpacingPropertyToCloudFormation(properties.paperMargin), PaperOrientation: cdk.stringToCloudFormation(properties.paperOrientation), PaperSize: cdk.stringToCloudFormation(properties.paperSize) }) : properties;
    }
    function CfnAnalysisSectionBasedLayoutPaperCanvasSizeOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("paperMargin", "PaperMargin", properties.PaperMargin != null ? CfnAnalysisSpacingPropertyFromCloudFormation(properties.PaperMargin) : void 0), ret.addPropertyResult("paperOrientation", "PaperOrientation", properties.PaperOrientation != null ? cfn_parse.FromCloudFormation.getString(properties.PaperOrientation) : void 0), ret.addPropertyResult("paperSize", "PaperSize", properties.PaperSize != null ? cfn_parse.FromCloudFormation.getString(properties.PaperSize) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_SectionLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("freeFormLayout", cdk.requiredValidator)(properties.freeFormLayout)), errors.collect(cdk.propertyValidator("freeFormLayout", CfnAnalysis_FreeFormSectionLayoutConfigurationPropertyValidator)(properties.freeFormLayout)), errors.wrap('supplied properties not correct for "SectionLayoutConfigurationProperty"');
    }
    function cfnAnalysisSectionLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_SectionLayoutConfigurationPropertyValidator(properties).assertSuccess(), { FreeFormLayout: cfnAnalysisFreeFormSectionLayoutConfigurationPropertyToCloudFormation(properties.freeFormLayout) }) : properties;
    }
    function CfnAnalysisSectionLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("freeFormLayout", "FreeFormLayout", CfnAnalysisFreeFormSectionLayoutConfigurationPropertyFromCloudFormation(properties.FreeFormLayout)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_SectionPageBreakConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("after", CfnAnalysis_SectionAfterPageBreakPropertyValidator)(properties.after)), errors.wrap('supplied properties not correct for "SectionPageBreakConfigurationProperty"');
    }
    function cfnAnalysisSectionPageBreakConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_SectionPageBreakConfigurationPropertyValidator(properties).assertSuccess(), { After: cfnAnalysisSectionAfterPageBreakPropertyToCloudFormation(properties.after) }) : properties;
    }
    function CfnAnalysisSectionPageBreakConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("after", "After", properties.After != null ? CfnAnalysisSectionAfterPageBreakPropertyFromCloudFormation(properties.After) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_SectionStylePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("height", cdk.validateString)(properties.height)), errors.collect(cdk.propertyValidator("padding", CfnAnalysis_SpacingPropertyValidator)(properties.padding)), errors.wrap('supplied properties not correct for "SectionStyleProperty"');
    }
    function cfnAnalysisSectionStylePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_SectionStylePropertyValidator(properties).assertSuccess(), { Height: cdk.stringToCloudFormation(properties.height), Padding: cfnAnalysisSpacingPropertyToCloudFormation(properties.padding) }) : properties;
    }
    function CfnAnalysisSectionStylePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("height", "Height", properties.Height != null ? cfn_parse.FromCloudFormation.getString(properties.Height) : void 0), ret.addPropertyResult("padding", "Padding", properties.Padding != null ? CfnAnalysisSpacingPropertyFromCloudFormation(properties.Padding) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_SelectedSheetsFilterScopeConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sheetVisualScopingConfigurations", cdk.listValidator(CfnAnalysis_SheetVisualScopingConfigurationPropertyValidator))(properties.sheetVisualScopingConfigurations)), errors.wrap('supplied properties not correct for "SelectedSheetsFilterScopeConfigurationProperty"');
    }
    function cfnAnalysisSelectedSheetsFilterScopeConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_SelectedSheetsFilterScopeConfigurationPropertyValidator(properties).assertSuccess(), { SheetVisualScopingConfigurations: cdk.listMapper(cfnAnalysisSheetVisualScopingConfigurationPropertyToCloudFormation)(properties.sheetVisualScopingConfigurations) }) : properties;
    }
    function CfnAnalysisSelectedSheetsFilterScopeConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sheetVisualScopingConfigurations", "SheetVisualScopingConfigurations", properties.SheetVisualScopingConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisSheetVisualScopingConfigurationPropertyFromCloudFormation)(properties.SheetVisualScopingConfigurations) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_SeriesItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataFieldSeriesItem", CfnAnalysis_DataFieldSeriesItemPropertyValidator)(properties.dataFieldSeriesItem)), errors.collect(cdk.propertyValidator("fieldSeriesItem", CfnAnalysis_FieldSeriesItemPropertyValidator)(properties.fieldSeriesItem)), errors.wrap('supplied properties not correct for "SeriesItemProperty"');
    }
    function cfnAnalysisSeriesItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_SeriesItemPropertyValidator(properties).assertSuccess(), { DataFieldSeriesItem: cfnAnalysisDataFieldSeriesItemPropertyToCloudFormation(properties.dataFieldSeriesItem), FieldSeriesItem: cfnAnalysisFieldSeriesItemPropertyToCloudFormation(properties.fieldSeriesItem) }) : properties;
    }
    function CfnAnalysisSeriesItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataFieldSeriesItem", "DataFieldSeriesItem", properties.DataFieldSeriesItem != null ? CfnAnalysisDataFieldSeriesItemPropertyFromCloudFormation(properties.DataFieldSeriesItem) : void 0), ret.addPropertyResult("fieldSeriesItem", "FieldSeriesItem", properties.FieldSeriesItem != null ? CfnAnalysisFieldSeriesItemPropertyFromCloudFormation(properties.FieldSeriesItem) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_SetParameterValueConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationParameterName", cdk.requiredValidator)(properties.destinationParameterName)), errors.collect(cdk.propertyValidator("destinationParameterName", cdk.validateString)(properties.destinationParameterName)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", CfnAnalysis_DestinationParameterValueConfigurationPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "SetParameterValueConfigurationProperty"');
    }
    function cfnAnalysisSetParameterValueConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_SetParameterValueConfigurationPropertyValidator(properties).assertSuccess(), { DestinationParameterName: cdk.stringToCloudFormation(properties.destinationParameterName), Value: cfnAnalysisDestinationParameterValueConfigurationPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnAnalysisSetParameterValueConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationParameterName", "DestinationParameterName", cfn_parse.FromCloudFormation.getString(properties.DestinationParameterName)), ret.addPropertyResult("value", "Value", CfnAnalysisDestinationParameterValueConfigurationPropertyFromCloudFormation(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ShapeConditionalFormatPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("backgroundColor", cdk.requiredValidator)(properties.backgroundColor)), errors.collect(cdk.propertyValidator("backgroundColor", CfnAnalysis_ConditionalFormattingColorPropertyValidator)(properties.backgroundColor)), errors.wrap('supplied properties not correct for "ShapeConditionalFormatProperty"');
    }
    function cfnAnalysisShapeConditionalFormatPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ShapeConditionalFormatPropertyValidator(properties).assertSuccess(), { BackgroundColor: cfnAnalysisConditionalFormattingColorPropertyToCloudFormation(properties.backgroundColor) }) : properties;
    }
    function CfnAnalysisShapeConditionalFormatPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("backgroundColor", "BackgroundColor", CfnAnalysisConditionalFormattingColorPropertyFromCloudFormation(properties.BackgroundColor)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_SheetControlLayoutPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configuration", cdk.requiredValidator)(properties.configuration)), errors.collect(cdk.propertyValidator("configuration", CfnAnalysis_SheetControlLayoutConfigurationPropertyValidator)(properties.configuration)), errors.wrap('supplied properties not correct for "SheetControlLayoutProperty"');
    }
    function cfnAnalysisSheetControlLayoutPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_SheetControlLayoutPropertyValidator(properties).assertSuccess(), { Configuration: cfnAnalysisSheetControlLayoutConfigurationPropertyToCloudFormation(properties.configuration) }) : properties;
    }
    function CfnAnalysisSheetControlLayoutPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configuration", "Configuration", CfnAnalysisSheetControlLayoutConfigurationPropertyFromCloudFormation(properties.Configuration)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_SheetControlLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("gridLayout", CfnAnalysis_GridLayoutConfigurationPropertyValidator)(properties.gridLayout)), errors.wrap('supplied properties not correct for "SheetControlLayoutConfigurationProperty"');
    }
    function cfnAnalysisSheetControlLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_SheetControlLayoutConfigurationPropertyValidator(properties).assertSuccess(), { GridLayout: cfnAnalysisGridLayoutConfigurationPropertyToCloudFormation(properties.gridLayout) }) : properties;
    }
    function CfnAnalysisSheetControlLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("gridLayout", "GridLayout", properties.GridLayout != null ? CfnAnalysisGridLayoutConfigurationPropertyFromCloudFormation(properties.GridLayout) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_SheetDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contentType", cdk.validateString)(properties.contentType)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("filterControls", cdk.listValidator(CfnAnalysis_FilterControlPropertyValidator))(properties.filterControls)), errors.collect(cdk.propertyValidator("layouts", cdk.listValidator(CfnAnalysis_LayoutPropertyValidator))(properties.layouts)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("parameterControls", cdk.listValidator(CfnAnalysis_ParameterControlPropertyValidator))(properties.parameterControls)), errors.collect(cdk.propertyValidator("sheetControlLayouts", cdk.listValidator(CfnAnalysis_SheetControlLayoutPropertyValidator))(properties.sheetControlLayouts)), errors.collect(cdk.propertyValidator("sheetId", cdk.requiredValidator)(properties.sheetId)), errors.collect(cdk.propertyValidator("sheetId", cdk.validateString)(properties.sheetId)), errors.collect(cdk.propertyValidator("textBoxes", cdk.listValidator(CfnAnalysis_SheetTextBoxPropertyValidator))(properties.textBoxes)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.collect(cdk.propertyValidator("visuals", cdk.listValidator(CfnAnalysis_VisualPropertyValidator))(properties.visuals)), errors.wrap('supplied properties not correct for "SheetDefinitionProperty"');
    }
    function cfnAnalysisSheetDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_SheetDefinitionPropertyValidator(properties).assertSuccess(), { ContentType: cdk.stringToCloudFormation(properties.contentType), Description: cdk.stringToCloudFormation(properties.description), FilterControls: cdk.listMapper(cfnAnalysisFilterControlPropertyToCloudFormation)(properties.filterControls), Layouts: cdk.listMapper(cfnAnalysisLayoutPropertyToCloudFormation)(properties.layouts), Name: cdk.stringToCloudFormation(properties.name), ParameterControls: cdk.listMapper(cfnAnalysisParameterControlPropertyToCloudFormation)(properties.parameterControls), SheetControlLayouts: cdk.listMapper(cfnAnalysisSheetControlLayoutPropertyToCloudFormation)(properties.sheetControlLayouts), SheetId: cdk.stringToCloudFormation(properties.sheetId), TextBoxes: cdk.listMapper(cfnAnalysisSheetTextBoxPropertyToCloudFormation)(properties.textBoxes), Title: cdk.stringToCloudFormation(properties.title), Visuals: cdk.listMapper(cfnAnalysisVisualPropertyToCloudFormation)(properties.visuals) }) : properties;
    }
    function CfnAnalysisSheetDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contentType", "ContentType", properties.ContentType != null ? cfn_parse.FromCloudFormation.getString(properties.ContentType) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("filterControls", "FilterControls", properties.FilterControls != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisFilterControlPropertyFromCloudFormation)(properties.FilterControls) : void 0), ret.addPropertyResult("layouts", "Layouts", properties.Layouts != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisLayoutPropertyFromCloudFormation)(properties.Layouts) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("parameterControls", "ParameterControls", properties.ParameterControls != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisParameterControlPropertyFromCloudFormation)(properties.ParameterControls) : void 0), ret.addPropertyResult("sheetControlLayouts", "SheetControlLayouts", properties.SheetControlLayouts != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisSheetControlLayoutPropertyFromCloudFormation)(properties.SheetControlLayouts) : void 0), ret.addPropertyResult("sheetId", "SheetId", cfn_parse.FromCloudFormation.getString(properties.SheetId)), ret.addPropertyResult("textBoxes", "TextBoxes", properties.TextBoxes != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisSheetTextBoxPropertyFromCloudFormation)(properties.TextBoxes) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? cfn_parse.FromCloudFormation.getString(properties.Title) : void 0), ret.addPropertyResult("visuals", "Visuals", properties.Visuals != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisVisualPropertyFromCloudFormation)(properties.Visuals) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_SheetElementConfigurationOverridesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "SheetElementConfigurationOverridesProperty"');
    }
    function cfnAnalysisSheetElementConfigurationOverridesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_SheetElementConfigurationOverridesPropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnAnalysisSheetElementConfigurationOverridesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_SheetElementRenderingRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configurationOverrides", cdk.requiredValidator)(properties.configurationOverrides)), errors.collect(cdk.propertyValidator("configurationOverrides", CfnAnalysis_SheetElementConfigurationOverridesPropertyValidator)(properties.configurationOverrides)), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.wrap('supplied properties not correct for "SheetElementRenderingRuleProperty"');
    }
    function cfnAnalysisSheetElementRenderingRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_SheetElementRenderingRulePropertyValidator(properties).assertSuccess(), { ConfigurationOverrides: cfnAnalysisSheetElementConfigurationOverridesPropertyToCloudFormation(properties.configurationOverrides), Expression: cdk.stringToCloudFormation(properties.expression) }) : properties;
    }
    function CfnAnalysisSheetElementRenderingRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configurationOverrides", "ConfigurationOverrides", CfnAnalysisSheetElementConfigurationOverridesPropertyFromCloudFormation(properties.ConfigurationOverrides)), ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getString(properties.Expression)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_SheetTextBoxPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("content", cdk.validateString)(properties.content)), errors.collect(cdk.propertyValidator("sheetTextBoxId", cdk.requiredValidator)(properties.sheetTextBoxId)), errors.collect(cdk.propertyValidator("sheetTextBoxId", cdk.validateString)(properties.sheetTextBoxId)), errors.wrap('supplied properties not correct for "SheetTextBoxProperty"');
    }
    function cfnAnalysisSheetTextBoxPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_SheetTextBoxPropertyValidator(properties).assertSuccess(), { Content: cdk.stringToCloudFormation(properties.content), SheetTextBoxId: cdk.stringToCloudFormation(properties.sheetTextBoxId) }) : properties;
    }
    function CfnAnalysisSheetTextBoxPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("content", "Content", properties.Content != null ? cfn_parse.FromCloudFormation.getString(properties.Content) : void 0), ret.addPropertyResult("sheetTextBoxId", "SheetTextBoxId", cfn_parse.FromCloudFormation.getString(properties.SheetTextBoxId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_SheetVisualScopingConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("scope", cdk.requiredValidator)(properties.scope)), errors.collect(cdk.propertyValidator("scope", cdk.validateString)(properties.scope)), errors.collect(cdk.propertyValidator("sheetId", cdk.requiredValidator)(properties.sheetId)), errors.collect(cdk.propertyValidator("sheetId", cdk.validateString)(properties.sheetId)), errors.collect(cdk.propertyValidator("visualIds", cdk.listValidator(cdk.validateString))(properties.visualIds)), errors.wrap('supplied properties not correct for "SheetVisualScopingConfigurationProperty"');
    }
    function cfnAnalysisSheetVisualScopingConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_SheetVisualScopingConfigurationPropertyValidator(properties).assertSuccess(), { Scope: cdk.stringToCloudFormation(properties.scope), SheetId: cdk.stringToCloudFormation(properties.sheetId), VisualIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.visualIds) }) : properties;
    }
    function CfnAnalysisSheetVisualScopingConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("scope", "Scope", cfn_parse.FromCloudFormation.getString(properties.Scope)), ret.addPropertyResult("sheetId", "SheetId", cfn_parse.FromCloudFormation.getString(properties.SheetId)), ret.addPropertyResult("visualIds", "VisualIds", properties.VisualIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.VisualIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ShortFormatTextPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("plainText", cdk.validateString)(properties.plainText)), errors.collect(cdk.propertyValidator("richText", cdk.validateString)(properties.richText)), errors.wrap('supplied properties not correct for "ShortFormatTextProperty"');
    }
    function cfnAnalysisShortFormatTextPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ShortFormatTextPropertyValidator(properties).assertSuccess(), { PlainText: cdk.stringToCloudFormation(properties.plainText), RichText: cdk.stringToCloudFormation(properties.richText) }) : properties;
    }
    function CfnAnalysisShortFormatTextPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("plainText", "PlainText", properties.PlainText != null ? cfn_parse.FromCloudFormation.getString(properties.PlainText) : void 0), ret.addPropertyResult("richText", "RichText", properties.RichText != null ? cfn_parse.FromCloudFormation.getString(properties.RichText) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_SimpleClusterMarkerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.wrap('supplied properties not correct for "SimpleClusterMarkerProperty"');
    }
    function cfnAnalysisSimpleClusterMarkerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_SimpleClusterMarkerPropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color) }) : properties;
    }
    function CfnAnalysisSimpleClusterMarkerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", properties.Color != null ? cfn_parse.FromCloudFormation.getString(properties.Color) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_SliderControlDisplayOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("titleOptions", CfnAnalysis_LabelOptionsPropertyValidator)(properties.titleOptions)), errors.wrap('supplied properties not correct for "SliderControlDisplayOptionsProperty"');
    }
    function cfnAnalysisSliderControlDisplayOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_SliderControlDisplayOptionsPropertyValidator(properties).assertSuccess(), { TitleOptions: cfnAnalysisLabelOptionsPropertyToCloudFormation(properties.titleOptions) }) : properties;
    }
    function CfnAnalysisSliderControlDisplayOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("titleOptions", "TitleOptions", properties.TitleOptions != null ? CfnAnalysisLabelOptionsPropertyFromCloudFormation(properties.TitleOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_SmallMultiplesOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxVisibleColumns", cdk.validateNumber)(properties.maxVisibleColumns)), errors.collect(cdk.propertyValidator("maxVisibleRows", cdk.validateNumber)(properties.maxVisibleRows)), errors.collect(cdk.propertyValidator("panelConfiguration", CfnAnalysis_PanelConfigurationPropertyValidator)(properties.panelConfiguration)), errors.wrap('supplied properties not correct for "SmallMultiplesOptionsProperty"');
    }
    function cfnAnalysisSmallMultiplesOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_SmallMultiplesOptionsPropertyValidator(properties).assertSuccess(), { MaxVisibleColumns: cdk.numberToCloudFormation(properties.maxVisibleColumns), MaxVisibleRows: cdk.numberToCloudFormation(properties.maxVisibleRows), PanelConfiguration: cfnAnalysisPanelConfigurationPropertyToCloudFormation(properties.panelConfiguration) }) : properties;
    }
    function CfnAnalysisSmallMultiplesOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxVisibleColumns", "MaxVisibleColumns", properties.MaxVisibleColumns != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxVisibleColumns) : void 0), ret.addPropertyResult("maxVisibleRows", "MaxVisibleRows", properties.MaxVisibleRows != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxVisibleRows) : void 0), ret.addPropertyResult("panelConfiguration", "PanelConfiguration", properties.PanelConfiguration != null ? CfnAnalysisPanelConfigurationPropertyFromCloudFormation(properties.PanelConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_SpacingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bottom", cdk.validateString)(properties.bottom)), errors.collect(cdk.propertyValidator("left", cdk.validateString)(properties.left)), errors.collect(cdk.propertyValidator("right", cdk.validateString)(properties.right)), errors.collect(cdk.propertyValidator("top", cdk.validateString)(properties.top)), errors.wrap('supplied properties not correct for "SpacingProperty"');
    }
    function cfnAnalysisSpacingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_SpacingPropertyValidator(properties).assertSuccess(), { Bottom: cdk.stringToCloudFormation(properties.bottom), Left: cdk.stringToCloudFormation(properties.left), Right: cdk.stringToCloudFormation(properties.right), Top: cdk.stringToCloudFormation(properties.top) }) : properties;
    }
    function CfnAnalysisSpacingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bottom", "Bottom", properties.Bottom != null ? cfn_parse.FromCloudFormation.getString(properties.Bottom) : void 0), ret.addPropertyResult("left", "Left", properties.Left != null ? cfn_parse.FromCloudFormation.getString(properties.Left) : void 0), ret.addPropertyResult("right", "Right", properties.Right != null ? cfn_parse.FromCloudFormation.getString(properties.Right) : void 0), ret.addPropertyResult("top", "Top", properties.Top != null ? cfn_parse.FromCloudFormation.getString(properties.Top) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_StringDefaultValuesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dynamicValue", CfnAnalysis_DynamicDefaultValuePropertyValidator)(properties.dynamicValue)), errors.collect(cdk.propertyValidator("staticValues", cdk.listValidator(cdk.validateString))(properties.staticValues)), errors.wrap('supplied properties not correct for "StringDefaultValuesProperty"');
    }
    function cfnAnalysisStringDefaultValuesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_StringDefaultValuesPropertyValidator(properties).assertSuccess(), { DynamicValue: cfnAnalysisDynamicDefaultValuePropertyToCloudFormation(properties.dynamicValue), StaticValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.staticValues) }) : properties;
    }
    function CfnAnalysisStringDefaultValuesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dynamicValue", "DynamicValue", properties.DynamicValue != null ? CfnAnalysisDynamicDefaultValuePropertyFromCloudFormation(properties.DynamicValue) : void 0), ret.addPropertyResult("staticValues", "StaticValues", properties.StaticValues != null ? cfn_parse.FromCloudFormation.getStringArray(properties.StaticValues) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_StringFormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("nullValueFormatConfiguration", CfnAnalysis_NullValueFormatConfigurationPropertyValidator)(properties.nullValueFormatConfiguration)), errors.collect(cdk.propertyValidator("numericFormatConfiguration", CfnAnalysis_NumericFormatConfigurationPropertyValidator)(properties.numericFormatConfiguration)), errors.wrap('supplied properties not correct for "StringFormatConfigurationProperty"');
    }
    function cfnAnalysisStringFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_StringFormatConfigurationPropertyValidator(properties).assertSuccess(), { NullValueFormatConfiguration: cfnAnalysisNullValueFormatConfigurationPropertyToCloudFormation(properties.nullValueFormatConfiguration), NumericFormatConfiguration: cfnAnalysisNumericFormatConfigurationPropertyToCloudFormation(properties.numericFormatConfiguration) }) : properties;
    }
    function CfnAnalysisStringFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("nullValueFormatConfiguration", "NullValueFormatConfiguration", properties.NullValueFormatConfiguration != null ? CfnAnalysisNullValueFormatConfigurationPropertyFromCloudFormation(properties.NullValueFormatConfiguration) : void 0), ret.addPropertyResult("numericFormatConfiguration", "NumericFormatConfiguration", properties.NumericFormatConfiguration != null ? CfnAnalysisNumericFormatConfigurationPropertyFromCloudFormation(properties.NumericFormatConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_StringParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("values", cdk.requiredValidator)(properties.values)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "StringParameterProperty"');
    }
    function cfnAnalysisStringParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_StringParameterPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnAnalysisStringParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("values", "Values", cfn_parse.FromCloudFormation.getStringArray(properties.Values)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_StringParameterDeclarationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultValues", CfnAnalysis_StringDefaultValuesPropertyValidator)(properties.defaultValues)), errors.collect(cdk.propertyValidator("mappedDataSetParameters", cdk.listValidator(CfnAnalysis_MappedDataSetParameterPropertyValidator))(properties.mappedDataSetParameters)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("parameterValueType", cdk.requiredValidator)(properties.parameterValueType)), errors.collect(cdk.propertyValidator("parameterValueType", cdk.validateString)(properties.parameterValueType)), errors.collect(cdk.propertyValidator("valueWhenUnset", CfnAnalysis_StringValueWhenUnsetConfigurationPropertyValidator)(properties.valueWhenUnset)), errors.wrap('supplied properties not correct for "StringParameterDeclarationProperty"');
    }
    function cfnAnalysisStringParameterDeclarationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_StringParameterDeclarationPropertyValidator(properties).assertSuccess(), { DefaultValues: cfnAnalysisStringDefaultValuesPropertyToCloudFormation(properties.defaultValues), MappedDataSetParameters: cdk.listMapper(cfnAnalysisMappedDataSetParameterPropertyToCloudFormation)(properties.mappedDataSetParameters), Name: cdk.stringToCloudFormation(properties.name), ParameterValueType: cdk.stringToCloudFormation(properties.parameterValueType), ValueWhenUnset: cfnAnalysisStringValueWhenUnsetConfigurationPropertyToCloudFormation(properties.valueWhenUnset) }) : properties;
    }
    function CfnAnalysisStringParameterDeclarationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultValues", "DefaultValues", properties.DefaultValues != null ? CfnAnalysisStringDefaultValuesPropertyFromCloudFormation(properties.DefaultValues) : void 0), ret.addPropertyResult("mappedDataSetParameters", "MappedDataSetParameters", properties.MappedDataSetParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMappedDataSetParameterPropertyFromCloudFormation)(properties.MappedDataSetParameters) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("parameterValueType", "ParameterValueType", cfn_parse.FromCloudFormation.getString(properties.ParameterValueType)), ret.addPropertyResult("valueWhenUnset", "ValueWhenUnset", properties.ValueWhenUnset != null ? CfnAnalysisStringValueWhenUnsetConfigurationPropertyFromCloudFormation(properties.ValueWhenUnset) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_StringValueWhenUnsetConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customValue", cdk.validateString)(properties.customValue)), errors.collect(cdk.propertyValidator("valueWhenUnsetOption", cdk.validateString)(properties.valueWhenUnsetOption)), errors.wrap('supplied properties not correct for "StringValueWhenUnsetConfigurationProperty"');
    }
    function cfnAnalysisStringValueWhenUnsetConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_StringValueWhenUnsetConfigurationPropertyValidator(properties).assertSuccess(), { CustomValue: cdk.stringToCloudFormation(properties.customValue), ValueWhenUnsetOption: cdk.stringToCloudFormation(properties.valueWhenUnsetOption) }) : properties;
    }
    function CfnAnalysisStringValueWhenUnsetConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customValue", "CustomValue", properties.CustomValue != null ? cfn_parse.FromCloudFormation.getString(properties.CustomValue) : void 0), ret.addPropertyResult("valueWhenUnsetOption", "ValueWhenUnsetOption", properties.ValueWhenUnsetOption != null ? cfn_parse.FromCloudFormation.getString(properties.ValueWhenUnsetOption) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_SubtotalOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customLabel", cdk.validateString)(properties.customLabel)), errors.collect(cdk.propertyValidator("fieldLevel", cdk.validateString)(properties.fieldLevel)), errors.collect(cdk.propertyValidator("fieldLevelOptions", cdk.listValidator(CfnAnalysis_PivotTableFieldSubtotalOptionsPropertyValidator))(properties.fieldLevelOptions)), errors.collect(cdk.propertyValidator("metricHeaderCellStyle", CfnAnalysis_TableCellStylePropertyValidator)(properties.metricHeaderCellStyle)), errors.collect(cdk.propertyValidator("totalCellStyle", CfnAnalysis_TableCellStylePropertyValidator)(properties.totalCellStyle)), errors.collect(cdk.propertyValidator("totalsVisibility", cdk.validateString)(properties.totalsVisibility)), errors.collect(cdk.propertyValidator("valueCellStyle", CfnAnalysis_TableCellStylePropertyValidator)(properties.valueCellStyle)), errors.wrap('supplied properties not correct for "SubtotalOptionsProperty"');
    }
    function cfnAnalysisSubtotalOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_SubtotalOptionsPropertyValidator(properties).assertSuccess(), { CustomLabel: cdk.stringToCloudFormation(properties.customLabel), FieldLevel: cdk.stringToCloudFormation(properties.fieldLevel), FieldLevelOptions: cdk.listMapper(cfnAnalysisPivotTableFieldSubtotalOptionsPropertyToCloudFormation)(properties.fieldLevelOptions), MetricHeaderCellStyle: cfnAnalysisTableCellStylePropertyToCloudFormation(properties.metricHeaderCellStyle), TotalCellStyle: cfnAnalysisTableCellStylePropertyToCloudFormation(properties.totalCellStyle), TotalsVisibility: cdk.stringToCloudFormation(properties.totalsVisibility), ValueCellStyle: cfnAnalysisTableCellStylePropertyToCloudFormation(properties.valueCellStyle) }) : properties;
    }
    function CfnAnalysisSubtotalOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customLabel", "CustomLabel", properties.CustomLabel != null ? cfn_parse.FromCloudFormation.getString(properties.CustomLabel) : void 0), ret.addPropertyResult("fieldLevel", "FieldLevel", properties.FieldLevel != null ? cfn_parse.FromCloudFormation.getString(properties.FieldLevel) : void 0), ret.addPropertyResult("fieldLevelOptions", "FieldLevelOptions", properties.FieldLevelOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisPivotTableFieldSubtotalOptionsPropertyFromCloudFormation)(properties.FieldLevelOptions) : void 0), ret.addPropertyResult("metricHeaderCellStyle", "MetricHeaderCellStyle", properties.MetricHeaderCellStyle != null ? CfnAnalysisTableCellStylePropertyFromCloudFormation(properties.MetricHeaderCellStyle) : void 0), ret.addPropertyResult("totalCellStyle", "TotalCellStyle", properties.TotalCellStyle != null ? CfnAnalysisTableCellStylePropertyFromCloudFormation(properties.TotalCellStyle) : void 0), ret.addPropertyResult("totalsVisibility", "TotalsVisibility", properties.TotalsVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.TotalsVisibility) : void 0), ret.addPropertyResult("valueCellStyle", "ValueCellStyle", properties.ValueCellStyle != null ? CfnAnalysisTableCellStylePropertyFromCloudFormation(properties.ValueCellStyle) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TableAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groupBy", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.groupBy)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnAnalysis_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "TableAggregatedFieldWellsProperty"');
    }
    function cfnAnalysisTableAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TableAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { GroupBy: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.groupBy), Values: cdk.listMapper(cfnAnalysisMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnAnalysisTableAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupBy", "GroupBy", properties.GroupBy != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.GroupBy) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TableBorderOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.collect(cdk.propertyValidator("style", cdk.validateString)(properties.style)), errors.collect(cdk.propertyValidator("thickness", cdk.validateNumber)(properties.thickness)), errors.wrap('supplied properties not correct for "TableBorderOptionsProperty"');
    }
    function cfnAnalysisTableBorderOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TableBorderOptionsPropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color), Style: cdk.stringToCloudFormation(properties.style), Thickness: cdk.numberToCloudFormation(properties.thickness) }) : properties;
    }
    function CfnAnalysisTableBorderOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", properties.Color != null ? cfn_parse.FromCloudFormation.getString(properties.Color) : void 0), ret.addPropertyResult("style", "Style", properties.Style != null ? cfn_parse.FromCloudFormation.getString(properties.Style) : void 0), ret.addPropertyResult("thickness", "Thickness", properties.Thickness != null ? cfn_parse.FromCloudFormation.getNumber(properties.Thickness) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TableCellConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("textFormat", CfnAnalysis_TextConditionalFormatPropertyValidator)(properties.textFormat)), errors.wrap('supplied properties not correct for "TableCellConditionalFormattingProperty"');
    }
    function cfnAnalysisTableCellConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TableCellConditionalFormattingPropertyValidator(properties).assertSuccess(), { FieldId: cdk.stringToCloudFormation(properties.fieldId), TextFormat: cfnAnalysisTextConditionalFormatPropertyToCloudFormation(properties.textFormat) }) : properties;
    }
    function CfnAnalysisTableCellConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("textFormat", "TextFormat", properties.TextFormat != null ? CfnAnalysisTextConditionalFormatPropertyFromCloudFormation(properties.TextFormat) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TableCellImageSizingConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("tableCellImageScalingConfiguration", cdk.validateString)(properties.tableCellImageScalingConfiguration)), errors.wrap('supplied properties not correct for "TableCellImageSizingConfigurationProperty"');
    }
    function cfnAnalysisTableCellImageSizingConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TableCellImageSizingConfigurationPropertyValidator(properties).assertSuccess(), { TableCellImageScalingConfiguration: cdk.stringToCloudFormation(properties.tableCellImageScalingConfiguration) }) : properties;
    }
    function CfnAnalysisTableCellImageSizingConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("tableCellImageScalingConfiguration", "TableCellImageScalingConfiguration", properties.TableCellImageScalingConfiguration != null ? cfn_parse.FromCloudFormation.getString(properties.TableCellImageScalingConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TableCellStylePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("backgroundColor", cdk.validateString)(properties.backgroundColor)), errors.collect(cdk.propertyValidator("border", CfnAnalysis_GlobalTableBorderOptionsPropertyValidator)(properties.border)), errors.collect(cdk.propertyValidator("fontConfiguration", CfnAnalysis_FontConfigurationPropertyValidator)(properties.fontConfiguration)), errors.collect(cdk.propertyValidator("height", cdk.validateNumber)(properties.height)), errors.collect(cdk.propertyValidator("horizontalTextAlignment", cdk.validateString)(properties.horizontalTextAlignment)), errors.collect(cdk.propertyValidator("textWrap", cdk.validateString)(properties.textWrap)), errors.collect(cdk.propertyValidator("verticalTextAlignment", cdk.validateString)(properties.verticalTextAlignment)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "TableCellStyleProperty"');
    }
    function cfnAnalysisTableCellStylePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TableCellStylePropertyValidator(properties).assertSuccess(), { BackgroundColor: cdk.stringToCloudFormation(properties.backgroundColor), Border: cfnAnalysisGlobalTableBorderOptionsPropertyToCloudFormation(properties.border), FontConfiguration: cfnAnalysisFontConfigurationPropertyToCloudFormation(properties.fontConfiguration), Height: cdk.numberToCloudFormation(properties.height), HorizontalTextAlignment: cdk.stringToCloudFormation(properties.horizontalTextAlignment), TextWrap: cdk.stringToCloudFormation(properties.textWrap), VerticalTextAlignment: cdk.stringToCloudFormation(properties.verticalTextAlignment), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnAnalysisTableCellStylePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("backgroundColor", "BackgroundColor", properties.BackgroundColor != null ? cfn_parse.FromCloudFormation.getString(properties.BackgroundColor) : void 0), ret.addPropertyResult("border", "Border", properties.Border != null ? CfnAnalysisGlobalTableBorderOptionsPropertyFromCloudFormation(properties.Border) : void 0), ret.addPropertyResult("fontConfiguration", "FontConfiguration", properties.FontConfiguration != null ? CfnAnalysisFontConfigurationPropertyFromCloudFormation(properties.FontConfiguration) : void 0), ret.addPropertyResult("height", "Height", properties.Height != null ? cfn_parse.FromCloudFormation.getNumber(properties.Height) : void 0), ret.addPropertyResult("horizontalTextAlignment", "HorizontalTextAlignment", properties.HorizontalTextAlignment != null ? cfn_parse.FromCloudFormation.getString(properties.HorizontalTextAlignment) : void 0), ret.addPropertyResult("textWrap", "TextWrap", properties.TextWrap != null ? cfn_parse.FromCloudFormation.getString(properties.TextWrap) : void 0), ret.addPropertyResult("verticalTextAlignment", "VerticalTextAlignment", properties.VerticalTextAlignment != null ? cfn_parse.FromCloudFormation.getString(properties.VerticalTextAlignment) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TableConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("conditionalFormattingOptions", cdk.listValidator(CfnAnalysis_TableConditionalFormattingOptionPropertyValidator))(properties.conditionalFormattingOptions)), errors.wrap('supplied properties not correct for "TableConditionalFormattingProperty"');
    }
    function cfnAnalysisTableConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TableConditionalFormattingPropertyValidator(properties).assertSuccess(), { ConditionalFormattingOptions: cdk.listMapper(cfnAnalysisTableConditionalFormattingOptionPropertyToCloudFormation)(properties.conditionalFormattingOptions) }) : properties;
    }
    function CfnAnalysisTableConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("conditionalFormattingOptions", "ConditionalFormattingOptions", properties.ConditionalFormattingOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisTableConditionalFormattingOptionPropertyFromCloudFormation)(properties.ConditionalFormattingOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TableConditionalFormattingOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cell", CfnAnalysis_TableCellConditionalFormattingPropertyValidator)(properties.cell)), errors.collect(cdk.propertyValidator("row", CfnAnalysis_TableRowConditionalFormattingPropertyValidator)(properties.row)), errors.wrap('supplied properties not correct for "TableConditionalFormattingOptionProperty"');
    }
    function cfnAnalysisTableConditionalFormattingOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TableConditionalFormattingOptionPropertyValidator(properties).assertSuccess(), { Cell: cfnAnalysisTableCellConditionalFormattingPropertyToCloudFormation(properties.cell), Row: cfnAnalysisTableRowConditionalFormattingPropertyToCloudFormation(properties.row) }) : properties;
    }
    function CfnAnalysisTableConditionalFormattingOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cell", "Cell", properties.Cell != null ? CfnAnalysisTableCellConditionalFormattingPropertyFromCloudFormation(properties.Cell) : void 0), ret.addPropertyResult("row", "Row", properties.Row != null ? CfnAnalysisTableRowConditionalFormattingPropertyFromCloudFormation(properties.Row) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TableConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldOptions", CfnAnalysis_TableFieldOptionsPropertyValidator)(properties.fieldOptions)), errors.collect(cdk.propertyValidator("fieldWells", CfnAnalysis_TableFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("paginatedReportOptions", CfnAnalysis_TablePaginatedReportOptionsPropertyValidator)(properties.paginatedReportOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnAnalysis_TableSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tableInlineVisualizations", cdk.listValidator(CfnAnalysis_TableInlineVisualizationPropertyValidator))(properties.tableInlineVisualizations)), errors.collect(cdk.propertyValidator("tableOptions", CfnAnalysis_TableOptionsPropertyValidator)(properties.tableOptions)), errors.collect(cdk.propertyValidator("totalOptions", CfnAnalysis_TotalOptionsPropertyValidator)(properties.totalOptions)), errors.wrap('supplied properties not correct for "TableConfigurationProperty"');
    }
    function cfnAnalysisTableConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TableConfigurationPropertyValidator(properties).assertSuccess(), { FieldOptions: cfnAnalysisTableFieldOptionsPropertyToCloudFormation(properties.fieldOptions), FieldWells: cfnAnalysisTableFieldWellsPropertyToCloudFormation(properties.fieldWells), PaginatedReportOptions: cfnAnalysisTablePaginatedReportOptionsPropertyToCloudFormation(properties.paginatedReportOptions), SortConfiguration: cfnAnalysisTableSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), TableInlineVisualizations: cdk.listMapper(cfnAnalysisTableInlineVisualizationPropertyToCloudFormation)(properties.tableInlineVisualizations), TableOptions: cfnAnalysisTableOptionsPropertyToCloudFormation(properties.tableOptions), TotalOptions: cfnAnalysisTotalOptionsPropertyToCloudFormation(properties.totalOptions) }) : properties;
    }
    function CfnAnalysisTableConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldOptions", "FieldOptions", properties.FieldOptions != null ? CfnAnalysisTableFieldOptionsPropertyFromCloudFormation(properties.FieldOptions) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnAnalysisTableFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("paginatedReportOptions", "PaginatedReportOptions", properties.PaginatedReportOptions != null ? CfnAnalysisTablePaginatedReportOptionsPropertyFromCloudFormation(properties.PaginatedReportOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnAnalysisTableSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tableInlineVisualizations", "TableInlineVisualizations", properties.TableInlineVisualizations != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisTableInlineVisualizationPropertyFromCloudFormation)(properties.TableInlineVisualizations) : void 0), ret.addPropertyResult("tableOptions", "TableOptions", properties.TableOptions != null ? CfnAnalysisTableOptionsPropertyFromCloudFormation(properties.TableOptions) : void 0), ret.addPropertyResult("totalOptions", "TotalOptions", properties.TotalOptions != null ? CfnAnalysisTotalOptionsPropertyFromCloudFormation(properties.TotalOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TableFieldCustomIconContentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("icon", cdk.validateString)(properties.icon)), errors.wrap('supplied properties not correct for "TableFieldCustomIconContentProperty"');
    }
    function cfnAnalysisTableFieldCustomIconContentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TableFieldCustomIconContentPropertyValidator(properties).assertSuccess(), { Icon: cdk.stringToCloudFormation(properties.icon) }) : properties;
    }
    function CfnAnalysisTableFieldCustomIconContentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("icon", "Icon", properties.Icon != null ? cfn_parse.FromCloudFormation.getString(properties.Icon) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TableFieldCustomTextContentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fontConfiguration", cdk.requiredValidator)(properties.fontConfiguration)), errors.collect(cdk.propertyValidator("fontConfiguration", CfnAnalysis_FontConfigurationPropertyValidator)(properties.fontConfiguration)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TableFieldCustomTextContentProperty"');
    }
    function cfnAnalysisTableFieldCustomTextContentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TableFieldCustomTextContentPropertyValidator(properties).assertSuccess(), { FontConfiguration: cfnAnalysisFontConfigurationPropertyToCloudFormation(properties.fontConfiguration), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnAnalysisTableFieldCustomTextContentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fontConfiguration", "FontConfiguration", CfnAnalysisFontConfigurationPropertyFromCloudFormation(properties.FontConfiguration)), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TableFieldImageConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sizingOptions", CfnAnalysis_TableCellImageSizingConfigurationPropertyValidator)(properties.sizingOptions)), errors.wrap('supplied properties not correct for "TableFieldImageConfigurationProperty"');
    }
    function cfnAnalysisTableFieldImageConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TableFieldImageConfigurationPropertyValidator(properties).assertSuccess(), { SizingOptions: cfnAnalysisTableCellImageSizingConfigurationPropertyToCloudFormation(properties.sizingOptions) }) : properties;
    }
    function CfnAnalysisTableFieldImageConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sizingOptions", "SizingOptions", properties.SizingOptions != null ? CfnAnalysisTableCellImageSizingConfigurationPropertyFromCloudFormation(properties.SizingOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TableFieldLinkConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("content", cdk.requiredValidator)(properties.content)), errors.collect(cdk.propertyValidator("content", CfnAnalysis_TableFieldLinkContentConfigurationPropertyValidator)(properties.content)), errors.collect(cdk.propertyValidator("target", cdk.requiredValidator)(properties.target)), errors.collect(cdk.propertyValidator("target", cdk.validateString)(properties.target)), errors.wrap('supplied properties not correct for "TableFieldLinkConfigurationProperty"');
    }
    function cfnAnalysisTableFieldLinkConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TableFieldLinkConfigurationPropertyValidator(properties).assertSuccess(), { Content: cfnAnalysisTableFieldLinkContentConfigurationPropertyToCloudFormation(properties.content), Target: cdk.stringToCloudFormation(properties.target) }) : properties;
    }
    function CfnAnalysisTableFieldLinkConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("content", "Content", CfnAnalysisTableFieldLinkContentConfigurationPropertyFromCloudFormation(properties.Content)), ret.addPropertyResult("target", "Target", cfn_parse.FromCloudFormation.getString(properties.Target)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TableFieldLinkContentConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customIconContent", CfnAnalysis_TableFieldCustomIconContentPropertyValidator)(properties.customIconContent)), errors.collect(cdk.propertyValidator("customTextContent", CfnAnalysis_TableFieldCustomTextContentPropertyValidator)(properties.customTextContent)), errors.wrap('supplied properties not correct for "TableFieldLinkContentConfigurationProperty"');
    }
    function cfnAnalysisTableFieldLinkContentConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TableFieldLinkContentConfigurationPropertyValidator(properties).assertSuccess(), { CustomIconContent: cfnAnalysisTableFieldCustomIconContentPropertyToCloudFormation(properties.customIconContent), CustomTextContent: cfnAnalysisTableFieldCustomTextContentPropertyToCloudFormation(properties.customTextContent) }) : properties;
    }
    function CfnAnalysisTableFieldLinkContentConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customIconContent", "CustomIconContent", properties.CustomIconContent != null ? CfnAnalysisTableFieldCustomIconContentPropertyFromCloudFormation(properties.CustomIconContent) : void 0), ret.addPropertyResult("customTextContent", "CustomTextContent", properties.CustomTextContent != null ? CfnAnalysisTableFieldCustomTextContentPropertyFromCloudFormation(properties.CustomTextContent) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TableFieldOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customLabel", cdk.validateString)(properties.customLabel)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("urlStyling", CfnAnalysis_TableFieldURLConfigurationPropertyValidator)(properties.urlStyling)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.collect(cdk.propertyValidator("width", cdk.validateString)(properties.width)), errors.wrap('supplied properties not correct for "TableFieldOptionProperty"');
    }
    function cfnAnalysisTableFieldOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TableFieldOptionPropertyValidator(properties).assertSuccess(), { CustomLabel: cdk.stringToCloudFormation(properties.customLabel), FieldId: cdk.stringToCloudFormation(properties.fieldId), URLStyling: cfnAnalysisTableFieldURLConfigurationPropertyToCloudFormation(properties.urlStyling), Visibility: cdk.stringToCloudFormation(properties.visibility), Width: cdk.stringToCloudFormation(properties.width) }) : properties;
    }
    function CfnAnalysisTableFieldOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customLabel", "CustomLabel", properties.CustomLabel != null ? cfn_parse.FromCloudFormation.getString(properties.CustomLabel) : void 0), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("urlStyling", "URLStyling", properties.URLStyling != null ? CfnAnalysisTableFieldURLConfigurationPropertyFromCloudFormation(properties.URLStyling) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addPropertyResult("width", "Width", properties.Width != null ? cfn_parse.FromCloudFormation.getString(properties.Width) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TableFieldOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("order", cdk.listValidator(cdk.validateString))(properties.order)), errors.collect(cdk.propertyValidator("selectedFieldOptions", cdk.listValidator(CfnAnalysis_TableFieldOptionPropertyValidator))(properties.selectedFieldOptions)), errors.wrap('supplied properties not correct for "TableFieldOptionsProperty"');
    }
    function cfnAnalysisTableFieldOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TableFieldOptionsPropertyValidator(properties).assertSuccess(), { Order: cdk.listMapper(cdk.stringToCloudFormation)(properties.order), SelectedFieldOptions: cdk.listMapper(cfnAnalysisTableFieldOptionPropertyToCloudFormation)(properties.selectedFieldOptions) }) : properties;
    }
    function CfnAnalysisTableFieldOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("order", "Order", properties.Order != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Order) : void 0), ret.addPropertyResult("selectedFieldOptions", "SelectedFieldOptions", properties.SelectedFieldOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisTableFieldOptionPropertyFromCloudFormation)(properties.SelectedFieldOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TableFieldURLConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("imageConfiguration", CfnAnalysis_TableFieldImageConfigurationPropertyValidator)(properties.imageConfiguration)), errors.collect(cdk.propertyValidator("linkConfiguration", CfnAnalysis_TableFieldLinkConfigurationPropertyValidator)(properties.linkConfiguration)), errors.wrap('supplied properties not correct for "TableFieldURLConfigurationProperty"');
    }
    function cfnAnalysisTableFieldURLConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TableFieldURLConfigurationPropertyValidator(properties).assertSuccess(), { ImageConfiguration: cfnAnalysisTableFieldImageConfigurationPropertyToCloudFormation(properties.imageConfiguration), LinkConfiguration: cfnAnalysisTableFieldLinkConfigurationPropertyToCloudFormation(properties.linkConfiguration) }) : properties;
    }
    function CfnAnalysisTableFieldURLConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("imageConfiguration", "ImageConfiguration", properties.ImageConfiguration != null ? CfnAnalysisTableFieldImageConfigurationPropertyFromCloudFormation(properties.ImageConfiguration) : void 0), ret.addPropertyResult("linkConfiguration", "LinkConfiguration", properties.LinkConfiguration != null ? CfnAnalysisTableFieldLinkConfigurationPropertyFromCloudFormation(properties.LinkConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TableFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("tableAggregatedFieldWells", CfnAnalysis_TableAggregatedFieldWellsPropertyValidator)(properties.tableAggregatedFieldWells)), errors.collect(cdk.propertyValidator("tableUnaggregatedFieldWells", CfnAnalysis_TableUnaggregatedFieldWellsPropertyValidator)(properties.tableUnaggregatedFieldWells)), errors.wrap('supplied properties not correct for "TableFieldWellsProperty"');
    }
    function cfnAnalysisTableFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TableFieldWellsPropertyValidator(properties).assertSuccess(), { TableAggregatedFieldWells: cfnAnalysisTableAggregatedFieldWellsPropertyToCloudFormation(properties.tableAggregatedFieldWells), TableUnaggregatedFieldWells: cfnAnalysisTableUnaggregatedFieldWellsPropertyToCloudFormation(properties.tableUnaggregatedFieldWells) }) : properties;
    }
    function CfnAnalysisTableFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("tableAggregatedFieldWells", "TableAggregatedFieldWells", properties.TableAggregatedFieldWells != null ? CfnAnalysisTableAggregatedFieldWellsPropertyFromCloudFormation(properties.TableAggregatedFieldWells) : void 0), ret.addPropertyResult("tableUnaggregatedFieldWells", "TableUnaggregatedFieldWells", properties.TableUnaggregatedFieldWells != null ? CfnAnalysisTableUnaggregatedFieldWellsPropertyFromCloudFormation(properties.TableUnaggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TableInlineVisualizationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataBars", CfnAnalysis_DataBarsOptionsPropertyValidator)(properties.dataBars)), errors.wrap('supplied properties not correct for "TableInlineVisualizationProperty"');
    }
    function cfnAnalysisTableInlineVisualizationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TableInlineVisualizationPropertyValidator(properties).assertSuccess(), { DataBars: cfnAnalysisDataBarsOptionsPropertyToCloudFormation(properties.dataBars) }) : properties;
    }
    function CfnAnalysisTableInlineVisualizationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataBars", "DataBars", properties.DataBars != null ? CfnAnalysisDataBarsOptionsPropertyFromCloudFormation(properties.DataBars) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TableOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cellStyle", CfnAnalysis_TableCellStylePropertyValidator)(properties.cellStyle)), errors.collect(cdk.propertyValidator("headerStyle", CfnAnalysis_TableCellStylePropertyValidator)(properties.headerStyle)), errors.collect(cdk.propertyValidator("orientation", cdk.validateString)(properties.orientation)), errors.collect(cdk.propertyValidator("rowAlternateColorOptions", CfnAnalysis_RowAlternateColorOptionsPropertyValidator)(properties.rowAlternateColorOptions)), errors.wrap('supplied properties not correct for "TableOptionsProperty"');
    }
    function cfnAnalysisTableOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TableOptionsPropertyValidator(properties).assertSuccess(), { CellStyle: cfnAnalysisTableCellStylePropertyToCloudFormation(properties.cellStyle), HeaderStyle: cfnAnalysisTableCellStylePropertyToCloudFormation(properties.headerStyle), Orientation: cdk.stringToCloudFormation(properties.orientation), RowAlternateColorOptions: cfnAnalysisRowAlternateColorOptionsPropertyToCloudFormation(properties.rowAlternateColorOptions) }) : properties;
    }
    function CfnAnalysisTableOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cellStyle", "CellStyle", properties.CellStyle != null ? CfnAnalysisTableCellStylePropertyFromCloudFormation(properties.CellStyle) : void 0), ret.addPropertyResult("headerStyle", "HeaderStyle", properties.HeaderStyle != null ? CfnAnalysisTableCellStylePropertyFromCloudFormation(properties.HeaderStyle) : void 0), ret.addPropertyResult("orientation", "Orientation", properties.Orientation != null ? cfn_parse.FromCloudFormation.getString(properties.Orientation) : void 0), ret.addPropertyResult("rowAlternateColorOptions", "RowAlternateColorOptions", properties.RowAlternateColorOptions != null ? CfnAnalysisRowAlternateColorOptionsPropertyFromCloudFormation(properties.RowAlternateColorOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TablePaginatedReportOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("overflowColumnHeaderVisibility", cdk.validateString)(properties.overflowColumnHeaderVisibility)), errors.collect(cdk.propertyValidator("verticalOverflowVisibility", cdk.validateString)(properties.verticalOverflowVisibility)), errors.wrap('supplied properties not correct for "TablePaginatedReportOptionsProperty"');
    }
    function cfnAnalysisTablePaginatedReportOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TablePaginatedReportOptionsPropertyValidator(properties).assertSuccess(), { OverflowColumnHeaderVisibility: cdk.stringToCloudFormation(properties.overflowColumnHeaderVisibility), VerticalOverflowVisibility: cdk.stringToCloudFormation(properties.verticalOverflowVisibility) }) : properties;
    }
    function CfnAnalysisTablePaginatedReportOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("overflowColumnHeaderVisibility", "OverflowColumnHeaderVisibility", properties.OverflowColumnHeaderVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.OverflowColumnHeaderVisibility) : void 0), ret.addPropertyResult("verticalOverflowVisibility", "VerticalOverflowVisibility", properties.VerticalOverflowVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.VerticalOverflowVisibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TableRowConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("backgroundColor", CfnAnalysis_ConditionalFormattingColorPropertyValidator)(properties.backgroundColor)), errors.collect(cdk.propertyValidator("textColor", CfnAnalysis_ConditionalFormattingColorPropertyValidator)(properties.textColor)), errors.wrap('supplied properties not correct for "TableRowConditionalFormattingProperty"');
    }
    function cfnAnalysisTableRowConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TableRowConditionalFormattingPropertyValidator(properties).assertSuccess(), { BackgroundColor: cfnAnalysisConditionalFormattingColorPropertyToCloudFormation(properties.backgroundColor), TextColor: cfnAnalysisConditionalFormattingColorPropertyToCloudFormation(properties.textColor) }) : properties;
    }
    function CfnAnalysisTableRowConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("backgroundColor", "BackgroundColor", properties.BackgroundColor != null ? CfnAnalysisConditionalFormattingColorPropertyFromCloudFormation(properties.BackgroundColor) : void 0), ret.addPropertyResult("textColor", "TextColor", properties.TextColor != null ? CfnAnalysisConditionalFormattingColorPropertyFromCloudFormation(properties.TextColor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TableSideBorderOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bottom", CfnAnalysis_TableBorderOptionsPropertyValidator)(properties.bottom)), errors.collect(cdk.propertyValidator("innerHorizontal", CfnAnalysis_TableBorderOptionsPropertyValidator)(properties.innerHorizontal)), errors.collect(cdk.propertyValidator("innerVertical", CfnAnalysis_TableBorderOptionsPropertyValidator)(properties.innerVertical)), errors.collect(cdk.propertyValidator("left", CfnAnalysis_TableBorderOptionsPropertyValidator)(properties.left)), errors.collect(cdk.propertyValidator("right", CfnAnalysis_TableBorderOptionsPropertyValidator)(properties.right)), errors.collect(cdk.propertyValidator("top", CfnAnalysis_TableBorderOptionsPropertyValidator)(properties.top)), errors.wrap('supplied properties not correct for "TableSideBorderOptionsProperty"');
    }
    function cfnAnalysisTableSideBorderOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TableSideBorderOptionsPropertyValidator(properties).assertSuccess(), { Bottom: cfnAnalysisTableBorderOptionsPropertyToCloudFormation(properties.bottom), InnerHorizontal: cfnAnalysisTableBorderOptionsPropertyToCloudFormation(properties.innerHorizontal), InnerVertical: cfnAnalysisTableBorderOptionsPropertyToCloudFormation(properties.innerVertical), Left: cfnAnalysisTableBorderOptionsPropertyToCloudFormation(properties.left), Right: cfnAnalysisTableBorderOptionsPropertyToCloudFormation(properties.right), Top: cfnAnalysisTableBorderOptionsPropertyToCloudFormation(properties.top) }) : properties;
    }
    function CfnAnalysisTableSideBorderOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bottom", "Bottom", properties.Bottom != null ? CfnAnalysisTableBorderOptionsPropertyFromCloudFormation(properties.Bottom) : void 0), ret.addPropertyResult("innerHorizontal", "InnerHorizontal", properties.InnerHorizontal != null ? CfnAnalysisTableBorderOptionsPropertyFromCloudFormation(properties.InnerHorizontal) : void 0), ret.addPropertyResult("innerVertical", "InnerVertical", properties.InnerVertical != null ? CfnAnalysisTableBorderOptionsPropertyFromCloudFormation(properties.InnerVertical) : void 0), ret.addPropertyResult("left", "Left", properties.Left != null ? CfnAnalysisTableBorderOptionsPropertyFromCloudFormation(properties.Left) : void 0), ret.addPropertyResult("right", "Right", properties.Right != null ? CfnAnalysisTableBorderOptionsPropertyFromCloudFormation(properties.Right) : void 0), ret.addPropertyResult("top", "Top", properties.Top != null ? CfnAnalysisTableBorderOptionsPropertyFromCloudFormation(properties.Top) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TableSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("paginationConfiguration", CfnAnalysis_PaginationConfigurationPropertyValidator)(properties.paginationConfiguration)), errors.collect(cdk.propertyValidator("rowSort", cdk.listValidator(CfnAnalysis_FieldSortOptionsPropertyValidator))(properties.rowSort)), errors.wrap('supplied properties not correct for "TableSortConfigurationProperty"');
    }
    function cfnAnalysisTableSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TableSortConfigurationPropertyValidator(properties).assertSuccess(), { PaginationConfiguration: cfnAnalysisPaginationConfigurationPropertyToCloudFormation(properties.paginationConfiguration), RowSort: cdk.listMapper(cfnAnalysisFieldSortOptionsPropertyToCloudFormation)(properties.rowSort) }) : properties;
    }
    function CfnAnalysisTableSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("paginationConfiguration", "PaginationConfiguration", properties.PaginationConfiguration != null ? CfnAnalysisPaginationConfigurationPropertyFromCloudFormation(properties.PaginationConfiguration) : void 0), ret.addPropertyResult("rowSort", "RowSort", properties.RowSort != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisFieldSortOptionsPropertyFromCloudFormation)(properties.RowSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TableUnaggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnAnalysis_UnaggregatedFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "TableUnaggregatedFieldWellsProperty"');
    }
    function cfnAnalysisTableUnaggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TableUnaggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Values: cdk.listMapper(cfnAnalysisUnaggregatedFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnAnalysisTableUnaggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisUnaggregatedFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TableVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnAnalysis_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnAnalysis_TableConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("conditionalFormatting", CfnAnalysis_TableConditionalFormattingPropertyValidator)(properties.conditionalFormatting)), errors.collect(cdk.propertyValidator("subtitle", CfnAnalysis_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnAnalysis_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "TableVisualProperty"');
    }
    function cfnAnalysisTableVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TableVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnAnalysisVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnAnalysisTableConfigurationPropertyToCloudFormation(properties.chartConfiguration), ConditionalFormatting: cfnAnalysisTableConditionalFormattingPropertyToCloudFormation(properties.conditionalFormatting), Subtitle: cfnAnalysisVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnAnalysisVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnAnalysisTableVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnAnalysisTableConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("conditionalFormatting", "ConditionalFormatting", properties.ConditionalFormatting != null ? CfnAnalysisTableConditionalFormattingPropertyFromCloudFormation(properties.ConditionalFormatting) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnAnalysisVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnAnalysisVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TextAreaControlDisplayOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("placeholderOptions", CfnAnalysis_TextControlPlaceholderOptionsPropertyValidator)(properties.placeholderOptions)), errors.collect(cdk.propertyValidator("titleOptions", CfnAnalysis_LabelOptionsPropertyValidator)(properties.titleOptions)), errors.wrap('supplied properties not correct for "TextAreaControlDisplayOptionsProperty"');
    }
    function cfnAnalysisTextAreaControlDisplayOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TextAreaControlDisplayOptionsPropertyValidator(properties).assertSuccess(), { PlaceholderOptions: cfnAnalysisTextControlPlaceholderOptionsPropertyToCloudFormation(properties.placeholderOptions), TitleOptions: cfnAnalysisLabelOptionsPropertyToCloudFormation(properties.titleOptions) }) : properties;
    }
    function CfnAnalysisTextAreaControlDisplayOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("placeholderOptions", "PlaceholderOptions", properties.PlaceholderOptions != null ? CfnAnalysisTextControlPlaceholderOptionsPropertyFromCloudFormation(properties.PlaceholderOptions) : void 0), ret.addPropertyResult("titleOptions", "TitleOptions", properties.TitleOptions != null ? CfnAnalysisLabelOptionsPropertyFromCloudFormation(properties.TitleOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TextConditionalFormatPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("backgroundColor", CfnAnalysis_ConditionalFormattingColorPropertyValidator)(properties.backgroundColor)), errors.collect(cdk.propertyValidator("icon", CfnAnalysis_ConditionalFormattingIconPropertyValidator)(properties.icon)), errors.collect(cdk.propertyValidator("textColor", CfnAnalysis_ConditionalFormattingColorPropertyValidator)(properties.textColor)), errors.wrap('supplied properties not correct for "TextConditionalFormatProperty"');
    }
    function cfnAnalysisTextConditionalFormatPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TextConditionalFormatPropertyValidator(properties).assertSuccess(), { BackgroundColor: cfnAnalysisConditionalFormattingColorPropertyToCloudFormation(properties.backgroundColor), Icon: cfnAnalysisConditionalFormattingIconPropertyToCloudFormation(properties.icon), TextColor: cfnAnalysisConditionalFormattingColorPropertyToCloudFormation(properties.textColor) }) : properties;
    }
    function CfnAnalysisTextConditionalFormatPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("backgroundColor", "BackgroundColor", properties.BackgroundColor != null ? CfnAnalysisConditionalFormattingColorPropertyFromCloudFormation(properties.BackgroundColor) : void 0), ret.addPropertyResult("icon", "Icon", properties.Icon != null ? CfnAnalysisConditionalFormattingIconPropertyFromCloudFormation(properties.Icon) : void 0), ret.addPropertyResult("textColor", "TextColor", properties.TextColor != null ? CfnAnalysisConditionalFormattingColorPropertyFromCloudFormation(properties.TextColor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TextControlPlaceholderOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "TextControlPlaceholderOptionsProperty"');
    }
    function cfnAnalysisTextControlPlaceholderOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TextControlPlaceholderOptionsPropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnAnalysisTextControlPlaceholderOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TextFieldControlDisplayOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("placeholderOptions", CfnAnalysis_TextControlPlaceholderOptionsPropertyValidator)(properties.placeholderOptions)), errors.collect(cdk.propertyValidator("titleOptions", CfnAnalysis_LabelOptionsPropertyValidator)(properties.titleOptions)), errors.wrap('supplied properties not correct for "TextFieldControlDisplayOptionsProperty"');
    }
    function cfnAnalysisTextFieldControlDisplayOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TextFieldControlDisplayOptionsPropertyValidator(properties).assertSuccess(), { PlaceholderOptions: cfnAnalysisTextControlPlaceholderOptionsPropertyToCloudFormation(properties.placeholderOptions), TitleOptions: cfnAnalysisLabelOptionsPropertyToCloudFormation(properties.titleOptions) }) : properties;
    }
    function CfnAnalysisTextFieldControlDisplayOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("placeholderOptions", "PlaceholderOptions", properties.PlaceholderOptions != null ? CfnAnalysisTextControlPlaceholderOptionsPropertyFromCloudFormation(properties.PlaceholderOptions) : void 0), ret.addPropertyResult("titleOptions", "TitleOptions", properties.TitleOptions != null ? CfnAnalysisLabelOptionsPropertyFromCloudFormation(properties.TitleOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_ThousandSeparatorOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("symbol", cdk.validateString)(properties.symbol)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "ThousandSeparatorOptionsProperty"');
    }
    function cfnAnalysisThousandSeparatorOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_ThousandSeparatorOptionsPropertyValidator(properties).assertSuccess(), { Symbol: cdk.stringToCloudFormation(properties.symbol), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnAnalysisThousandSeparatorOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("symbol", "Symbol", properties.Symbol != null ? cfn_parse.FromCloudFormation.getString(properties.Symbol) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TimeBasedForecastPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("lowerBoundary", cdk.validateNumber)(properties.lowerBoundary)), errors.collect(cdk.propertyValidator("periodsBackward", cdk.validateNumber)(properties.periodsBackward)), errors.collect(cdk.propertyValidator("periodsForward", cdk.validateNumber)(properties.periodsForward)), errors.collect(cdk.propertyValidator("predictionInterval", cdk.validateNumber)(properties.predictionInterval)), errors.collect(cdk.propertyValidator("seasonality", cdk.validateNumber)(properties.seasonality)), errors.collect(cdk.propertyValidator("upperBoundary", cdk.validateNumber)(properties.upperBoundary)), errors.wrap('supplied properties not correct for "TimeBasedForecastPropertiesProperty"');
    }
    function cfnAnalysisTimeBasedForecastPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TimeBasedForecastPropertiesPropertyValidator(properties).assertSuccess(), { LowerBoundary: cdk.numberToCloudFormation(properties.lowerBoundary), PeriodsBackward: cdk.numberToCloudFormation(properties.periodsBackward), PeriodsForward: cdk.numberToCloudFormation(properties.periodsForward), PredictionInterval: cdk.numberToCloudFormation(properties.predictionInterval), Seasonality: cdk.numberToCloudFormation(properties.seasonality), UpperBoundary: cdk.numberToCloudFormation(properties.upperBoundary) }) : properties;
    }
    function CfnAnalysisTimeBasedForecastPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("lowerBoundary", "LowerBoundary", properties.LowerBoundary != null ? cfn_parse.FromCloudFormation.getNumber(properties.LowerBoundary) : void 0), ret.addPropertyResult("periodsBackward", "PeriodsBackward", properties.PeriodsBackward != null ? cfn_parse.FromCloudFormation.getNumber(properties.PeriodsBackward) : void 0), ret.addPropertyResult("periodsForward", "PeriodsForward", properties.PeriodsForward != null ? cfn_parse.FromCloudFormation.getNumber(properties.PeriodsForward) : void 0), ret.addPropertyResult("predictionInterval", "PredictionInterval", properties.PredictionInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.PredictionInterval) : void 0), ret.addPropertyResult("seasonality", "Seasonality", properties.Seasonality != null ? cfn_parse.FromCloudFormation.getNumber(properties.Seasonality) : void 0), ret.addPropertyResult("upperBoundary", "UpperBoundary", properties.UpperBoundary != null ? cfn_parse.FromCloudFormation.getNumber(properties.UpperBoundary) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TimeEqualityFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnAnalysis_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("filterId", cdk.requiredValidator)(properties.filterId)), errors.collect(cdk.propertyValidator("filterId", cdk.validateString)(properties.filterId)), errors.collect(cdk.propertyValidator("parameterName", cdk.validateString)(properties.parameterName)), errors.collect(cdk.propertyValidator("timeGranularity", cdk.validateString)(properties.timeGranularity)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TimeEqualityFilterProperty"');
    }
    function cfnAnalysisTimeEqualityFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TimeEqualityFilterPropertyValidator(properties).assertSuccess(), { Column: cfnAnalysisColumnIdentifierPropertyToCloudFormation(properties.column), FilterId: cdk.stringToCloudFormation(properties.filterId), ParameterName: cdk.stringToCloudFormation(properties.parameterName), TimeGranularity: cdk.stringToCloudFormation(properties.timeGranularity), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnAnalysisTimeEqualityFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", CfnAnalysisColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("filterId", "FilterId", cfn_parse.FromCloudFormation.getString(properties.FilterId)), ret.addPropertyResult("parameterName", "ParameterName", properties.ParameterName != null ? cfn_parse.FromCloudFormation.getString(properties.ParameterName) : void 0), ret.addPropertyResult("timeGranularity", "TimeGranularity", properties.TimeGranularity != null ? cfn_parse.FromCloudFormation.getString(properties.TimeGranularity) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TimeRangeDrillDownFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnAnalysis_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("rangeMaximum", cdk.requiredValidator)(properties.rangeMaximum)), errors.collect(cdk.propertyValidator("rangeMaximum", cdk.validateString)(properties.rangeMaximum)), errors.collect(cdk.propertyValidator("rangeMinimum", cdk.requiredValidator)(properties.rangeMinimum)), errors.collect(cdk.propertyValidator("rangeMinimum", cdk.validateString)(properties.rangeMinimum)), errors.collect(cdk.propertyValidator("timeGranularity", cdk.requiredValidator)(properties.timeGranularity)), errors.collect(cdk.propertyValidator("timeGranularity", cdk.validateString)(properties.timeGranularity)), errors.wrap('supplied properties not correct for "TimeRangeDrillDownFilterProperty"');
    }
    function cfnAnalysisTimeRangeDrillDownFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TimeRangeDrillDownFilterPropertyValidator(properties).assertSuccess(), { Column: cfnAnalysisColumnIdentifierPropertyToCloudFormation(properties.column), RangeMaximum: cdk.stringToCloudFormation(properties.rangeMaximum), RangeMinimum: cdk.stringToCloudFormation(properties.rangeMinimum), TimeGranularity: cdk.stringToCloudFormation(properties.timeGranularity) }) : properties;
    }
    function CfnAnalysisTimeRangeDrillDownFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", CfnAnalysisColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("rangeMaximum", "RangeMaximum", cfn_parse.FromCloudFormation.getString(properties.RangeMaximum)), ret.addPropertyResult("rangeMinimum", "RangeMinimum", cfn_parse.FromCloudFormation.getString(properties.RangeMinimum)), ret.addPropertyResult("timeGranularity", "TimeGranularity", cfn_parse.FromCloudFormation.getString(properties.TimeGranularity)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TimeRangeFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnAnalysis_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("excludePeriodConfiguration", CfnAnalysis_ExcludePeriodConfigurationPropertyValidator)(properties.excludePeriodConfiguration)), errors.collect(cdk.propertyValidator("filterId", cdk.requiredValidator)(properties.filterId)), errors.collect(cdk.propertyValidator("filterId", cdk.validateString)(properties.filterId)), errors.collect(cdk.propertyValidator("includeMaximum", cdk.validateBoolean)(properties.includeMaximum)), errors.collect(cdk.propertyValidator("includeMinimum", cdk.validateBoolean)(properties.includeMinimum)), errors.collect(cdk.propertyValidator("nullOption", cdk.requiredValidator)(properties.nullOption)), errors.collect(cdk.propertyValidator("nullOption", cdk.validateString)(properties.nullOption)), errors.collect(cdk.propertyValidator("rangeMaximumValue", CfnAnalysis_TimeRangeFilterValuePropertyValidator)(properties.rangeMaximumValue)), errors.collect(cdk.propertyValidator("rangeMinimumValue", CfnAnalysis_TimeRangeFilterValuePropertyValidator)(properties.rangeMinimumValue)), errors.collect(cdk.propertyValidator("timeGranularity", cdk.validateString)(properties.timeGranularity)), errors.wrap('supplied properties not correct for "TimeRangeFilterProperty"');
    }
    function cfnAnalysisTimeRangeFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TimeRangeFilterPropertyValidator(properties).assertSuccess(), { Column: cfnAnalysisColumnIdentifierPropertyToCloudFormation(properties.column), ExcludePeriodConfiguration: cfnAnalysisExcludePeriodConfigurationPropertyToCloudFormation(properties.excludePeriodConfiguration), FilterId: cdk.stringToCloudFormation(properties.filterId), IncludeMaximum: cdk.booleanToCloudFormation(properties.includeMaximum), IncludeMinimum: cdk.booleanToCloudFormation(properties.includeMinimum), NullOption: cdk.stringToCloudFormation(properties.nullOption), RangeMaximumValue: cfnAnalysisTimeRangeFilterValuePropertyToCloudFormation(properties.rangeMaximumValue), RangeMinimumValue: cfnAnalysisTimeRangeFilterValuePropertyToCloudFormation(properties.rangeMinimumValue), TimeGranularity: cdk.stringToCloudFormation(properties.timeGranularity) }) : properties;
    }
    function CfnAnalysisTimeRangeFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", CfnAnalysisColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("excludePeriodConfiguration", "ExcludePeriodConfiguration", properties.ExcludePeriodConfiguration != null ? CfnAnalysisExcludePeriodConfigurationPropertyFromCloudFormation(properties.ExcludePeriodConfiguration) : void 0), ret.addPropertyResult("filterId", "FilterId", cfn_parse.FromCloudFormation.getString(properties.FilterId)), ret.addPropertyResult("includeMaximum", "IncludeMaximum", properties.IncludeMaximum != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeMaximum) : void 0), ret.addPropertyResult("includeMinimum", "IncludeMinimum", properties.IncludeMinimum != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeMinimum) : void 0), ret.addPropertyResult("nullOption", "NullOption", cfn_parse.FromCloudFormation.getString(properties.NullOption)), ret.addPropertyResult("rangeMaximumValue", "RangeMaximumValue", properties.RangeMaximumValue != null ? CfnAnalysisTimeRangeFilterValuePropertyFromCloudFormation(properties.RangeMaximumValue) : void 0), ret.addPropertyResult("rangeMinimumValue", "RangeMinimumValue", properties.RangeMinimumValue != null ? CfnAnalysisTimeRangeFilterValuePropertyFromCloudFormation(properties.RangeMinimumValue) : void 0), ret.addPropertyResult("timeGranularity", "TimeGranularity", properties.TimeGranularity != null ? cfn_parse.FromCloudFormation.getString(properties.TimeGranularity) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TimeRangeFilterValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("parameter", cdk.validateString)(properties.parameter)), errors.collect(cdk.propertyValidator("rollingDate", CfnAnalysis_RollingDateConfigurationPropertyValidator)(properties.rollingDate)), errors.collect(cdk.propertyValidator("staticValue", cdk.validateString)(properties.staticValue)), errors.wrap('supplied properties not correct for "TimeRangeFilterValueProperty"');
    }
    function cfnAnalysisTimeRangeFilterValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TimeRangeFilterValuePropertyValidator(properties).assertSuccess(), { Parameter: cdk.stringToCloudFormation(properties.parameter), RollingDate: cfnAnalysisRollingDateConfigurationPropertyToCloudFormation(properties.rollingDate), StaticValue: cdk.stringToCloudFormation(properties.staticValue) }) : properties;
    }
    function CfnAnalysisTimeRangeFilterValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("parameter", "Parameter", properties.Parameter != null ? cfn_parse.FromCloudFormation.getString(properties.Parameter) : void 0), ret.addPropertyResult("rollingDate", "RollingDate", properties.RollingDate != null ? CfnAnalysisRollingDateConfigurationPropertyFromCloudFormation(properties.RollingDate) : void 0), ret.addPropertyResult("staticValue", "StaticValue", properties.StaticValue != null ? cfn_parse.FromCloudFormation.getString(properties.StaticValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TooltipItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnTooltipItem", CfnAnalysis_ColumnTooltipItemPropertyValidator)(properties.columnTooltipItem)), errors.collect(cdk.propertyValidator("fieldTooltipItem", CfnAnalysis_FieldTooltipItemPropertyValidator)(properties.fieldTooltipItem)), errors.wrap('supplied properties not correct for "TooltipItemProperty"');
    }
    function cfnAnalysisTooltipItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TooltipItemPropertyValidator(properties).assertSuccess(), { ColumnTooltipItem: cfnAnalysisColumnTooltipItemPropertyToCloudFormation(properties.columnTooltipItem), FieldTooltipItem: cfnAnalysisFieldTooltipItemPropertyToCloudFormation(properties.fieldTooltipItem) }) : properties;
    }
    function CfnAnalysisTooltipItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columnTooltipItem", "ColumnTooltipItem", properties.ColumnTooltipItem != null ? CfnAnalysisColumnTooltipItemPropertyFromCloudFormation(properties.ColumnTooltipItem) : void 0), ret.addPropertyResult("fieldTooltipItem", "FieldTooltipItem", properties.FieldTooltipItem != null ? CfnAnalysisFieldTooltipItemPropertyFromCloudFormation(properties.FieldTooltipItem) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TooltipOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldBasedTooltip", CfnAnalysis_FieldBasedTooltipPropertyValidator)(properties.fieldBasedTooltip)), errors.collect(cdk.propertyValidator("selectedTooltipType", cdk.validateString)(properties.selectedTooltipType)), errors.collect(cdk.propertyValidator("tooltipVisibility", cdk.validateString)(properties.tooltipVisibility)), errors.wrap('supplied properties not correct for "TooltipOptionsProperty"');
    }
    function cfnAnalysisTooltipOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TooltipOptionsPropertyValidator(properties).assertSuccess(), { FieldBasedTooltip: cfnAnalysisFieldBasedTooltipPropertyToCloudFormation(properties.fieldBasedTooltip), SelectedTooltipType: cdk.stringToCloudFormation(properties.selectedTooltipType), TooltipVisibility: cdk.stringToCloudFormation(properties.tooltipVisibility) }) : properties;
    }
    function CfnAnalysisTooltipOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldBasedTooltip", "FieldBasedTooltip", properties.FieldBasedTooltip != null ? CfnAnalysisFieldBasedTooltipPropertyFromCloudFormation(properties.FieldBasedTooltip) : void 0), ret.addPropertyResult("selectedTooltipType", "SelectedTooltipType", properties.SelectedTooltipType != null ? cfn_parse.FromCloudFormation.getString(properties.SelectedTooltipType) : void 0), ret.addPropertyResult("tooltipVisibility", "TooltipVisibility", properties.TooltipVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.TooltipVisibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TopBottomFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationSortConfigurations", cdk.requiredValidator)(properties.aggregationSortConfigurations)), errors.collect(cdk.propertyValidator("aggregationSortConfigurations", cdk.listValidator(CfnAnalysis_AggregationSortConfigurationPropertyValidator))(properties.aggregationSortConfigurations)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnAnalysis_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("filterId", cdk.requiredValidator)(properties.filterId)), errors.collect(cdk.propertyValidator("filterId", cdk.validateString)(properties.filterId)), errors.collect(cdk.propertyValidator("limit", cdk.validateNumber)(properties.limit)), errors.collect(cdk.propertyValidator("parameterName", cdk.validateString)(properties.parameterName)), errors.collect(cdk.propertyValidator("timeGranularity", cdk.validateString)(properties.timeGranularity)), errors.wrap('supplied properties not correct for "TopBottomFilterProperty"');
    }
    function cfnAnalysisTopBottomFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TopBottomFilterPropertyValidator(properties).assertSuccess(), { AggregationSortConfigurations: cdk.listMapper(cfnAnalysisAggregationSortConfigurationPropertyToCloudFormation)(properties.aggregationSortConfigurations), Column: cfnAnalysisColumnIdentifierPropertyToCloudFormation(properties.column), FilterId: cdk.stringToCloudFormation(properties.filterId), Limit: cdk.numberToCloudFormation(properties.limit), ParameterName: cdk.stringToCloudFormation(properties.parameterName), TimeGranularity: cdk.stringToCloudFormation(properties.timeGranularity) }) : properties;
    }
    function CfnAnalysisTopBottomFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationSortConfigurations", "AggregationSortConfigurations", cfn_parse.FromCloudFormation.getArray(CfnAnalysisAggregationSortConfigurationPropertyFromCloudFormation)(properties.AggregationSortConfigurations)), ret.addPropertyResult("column", "Column", CfnAnalysisColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("filterId", "FilterId", cfn_parse.FromCloudFormation.getString(properties.FilterId)), ret.addPropertyResult("limit", "Limit", properties.Limit != null ? cfn_parse.FromCloudFormation.getNumber(properties.Limit) : void 0), ret.addPropertyResult("parameterName", "ParameterName", properties.ParameterName != null ? cfn_parse.FromCloudFormation.getString(properties.ParameterName) : void 0), ret.addPropertyResult("timeGranularity", "TimeGranularity", properties.TimeGranularity != null ? cfn_parse.FromCloudFormation.getString(properties.TimeGranularity) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TopBottomMoversComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("category", cdk.requiredValidator)(properties.category)), errors.collect(cdk.propertyValidator("category", CfnAnalysis_DimensionFieldPropertyValidator)(properties.category)), errors.collect(cdk.propertyValidator("computationId", cdk.requiredValidator)(properties.computationId)), errors.collect(cdk.propertyValidator("computationId", cdk.validateString)(properties.computationId)), errors.collect(cdk.propertyValidator("moverSize", cdk.validateNumber)(properties.moverSize)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("sortOrder", cdk.validateString)(properties.sortOrder)), errors.collect(cdk.propertyValidator("time", cdk.requiredValidator)(properties.time)), errors.collect(cdk.propertyValidator("time", CfnAnalysis_DimensionFieldPropertyValidator)(properties.time)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", CfnAnalysis_MeasureFieldPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "TopBottomMoversComputationProperty"');
    }
    function cfnAnalysisTopBottomMoversComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TopBottomMoversComputationPropertyValidator(properties).assertSuccess(), { Category: cfnAnalysisDimensionFieldPropertyToCloudFormation(properties.category), ComputationId: cdk.stringToCloudFormation(properties.computationId), MoverSize: cdk.numberToCloudFormation(properties.moverSize), Name: cdk.stringToCloudFormation(properties.name), SortOrder: cdk.stringToCloudFormation(properties.sortOrder), Time: cfnAnalysisDimensionFieldPropertyToCloudFormation(properties.time), Type: cdk.stringToCloudFormation(properties.type), Value: cfnAnalysisMeasureFieldPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnAnalysisTopBottomMoversComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("category", "Category", CfnAnalysisDimensionFieldPropertyFromCloudFormation(properties.Category)), ret.addPropertyResult("computationId", "ComputationId", cfn_parse.FromCloudFormation.getString(properties.ComputationId)), ret.addPropertyResult("moverSize", "MoverSize", properties.MoverSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.MoverSize) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("sortOrder", "SortOrder", properties.SortOrder != null ? cfn_parse.FromCloudFormation.getString(properties.SortOrder) : void 0), ret.addPropertyResult("time", "Time", CfnAnalysisDimensionFieldPropertyFromCloudFormation(properties.Time)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("value", "Value", properties.Value != null ? CfnAnalysisMeasureFieldPropertyFromCloudFormation(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TopBottomRankedComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("category", cdk.requiredValidator)(properties.category)), errors.collect(cdk.propertyValidator("category", CfnAnalysis_DimensionFieldPropertyValidator)(properties.category)), errors.collect(cdk.propertyValidator("computationId", cdk.requiredValidator)(properties.computationId)), errors.collect(cdk.propertyValidator("computationId", cdk.validateString)(properties.computationId)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("resultSize", cdk.validateNumber)(properties.resultSize)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", CfnAnalysis_MeasureFieldPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "TopBottomRankedComputationProperty"');
    }
    function cfnAnalysisTopBottomRankedComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TopBottomRankedComputationPropertyValidator(properties).assertSuccess(), { Category: cfnAnalysisDimensionFieldPropertyToCloudFormation(properties.category), ComputationId: cdk.stringToCloudFormation(properties.computationId), Name: cdk.stringToCloudFormation(properties.name), ResultSize: cdk.numberToCloudFormation(properties.resultSize), Type: cdk.stringToCloudFormation(properties.type), Value: cfnAnalysisMeasureFieldPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnAnalysisTopBottomRankedComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("category", "Category", CfnAnalysisDimensionFieldPropertyFromCloudFormation(properties.Category)), ret.addPropertyResult("computationId", "ComputationId", cfn_parse.FromCloudFormation.getString(properties.ComputationId)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("resultSize", "ResultSize", properties.ResultSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.ResultSize) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("value", "Value", properties.Value != null ? CfnAnalysisMeasureFieldPropertyFromCloudFormation(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TotalAggregationComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computationId", cdk.requiredValidator)(properties.computationId)), errors.collect(cdk.propertyValidator("computationId", cdk.validateString)(properties.computationId)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", CfnAnalysis_MeasureFieldPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "TotalAggregationComputationProperty"');
    }
    function cfnAnalysisTotalAggregationComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TotalAggregationComputationPropertyValidator(properties).assertSuccess(), { ComputationId: cdk.stringToCloudFormation(properties.computationId), Name: cdk.stringToCloudFormation(properties.name), Value: cfnAnalysisMeasureFieldPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnAnalysisTotalAggregationComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computationId", "ComputationId", cfn_parse.FromCloudFormation.getString(properties.ComputationId)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("value", "Value", CfnAnalysisMeasureFieldPropertyFromCloudFormation(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TotalOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customLabel", cdk.validateString)(properties.customLabel)), errors.collect(cdk.propertyValidator("placement", cdk.validateString)(properties.placement)), errors.collect(cdk.propertyValidator("scrollStatus", cdk.validateString)(properties.scrollStatus)), errors.collect(cdk.propertyValidator("totalCellStyle", CfnAnalysis_TableCellStylePropertyValidator)(properties.totalCellStyle)), errors.collect(cdk.propertyValidator("totalsVisibility", cdk.validateString)(properties.totalsVisibility)), errors.wrap('supplied properties not correct for "TotalOptionsProperty"');
    }
    function cfnAnalysisTotalOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TotalOptionsPropertyValidator(properties).assertSuccess(), { CustomLabel: cdk.stringToCloudFormation(properties.customLabel), Placement: cdk.stringToCloudFormation(properties.placement), ScrollStatus: cdk.stringToCloudFormation(properties.scrollStatus), TotalCellStyle: cfnAnalysisTableCellStylePropertyToCloudFormation(properties.totalCellStyle), TotalsVisibility: cdk.stringToCloudFormation(properties.totalsVisibility) }) : properties;
    }
    function CfnAnalysisTotalOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customLabel", "CustomLabel", properties.CustomLabel != null ? cfn_parse.FromCloudFormation.getString(properties.CustomLabel) : void 0), ret.addPropertyResult("placement", "Placement", properties.Placement != null ? cfn_parse.FromCloudFormation.getString(properties.Placement) : void 0), ret.addPropertyResult("scrollStatus", "ScrollStatus", properties.ScrollStatus != null ? cfn_parse.FromCloudFormation.getString(properties.ScrollStatus) : void 0), ret.addPropertyResult("totalCellStyle", "TotalCellStyle", properties.TotalCellStyle != null ? CfnAnalysisTableCellStylePropertyFromCloudFormation(properties.TotalCellStyle) : void 0), ret.addPropertyResult("totalsVisibility", "TotalsVisibility", properties.TotalsVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.TotalsVisibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TreeMapAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("colors", cdk.listValidator(CfnAnalysis_MeasureFieldPropertyValidator))(properties.colors)), errors.collect(cdk.propertyValidator("groups", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.groups)), errors.collect(cdk.propertyValidator("sizes", cdk.listValidator(CfnAnalysis_MeasureFieldPropertyValidator))(properties.sizes)), errors.wrap('supplied properties not correct for "TreeMapAggregatedFieldWellsProperty"');
    }
    function cfnAnalysisTreeMapAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TreeMapAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Colors: cdk.listMapper(cfnAnalysisMeasureFieldPropertyToCloudFormation)(properties.colors), Groups: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.groups), Sizes: cdk.listMapper(cfnAnalysisMeasureFieldPropertyToCloudFormation)(properties.sizes) }) : properties;
    }
    function CfnAnalysisTreeMapAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("colors", "Colors", properties.Colors != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMeasureFieldPropertyFromCloudFormation)(properties.Colors) : void 0), ret.addPropertyResult("groups", "Groups", properties.Groups != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.Groups) : void 0), ret.addPropertyResult("sizes", "Sizes", properties.Sizes != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMeasureFieldPropertyFromCloudFormation)(properties.Sizes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TreeMapConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("colorLabelOptions", CfnAnalysis_ChartAxisLabelOptionsPropertyValidator)(properties.colorLabelOptions)), errors.collect(cdk.propertyValidator("colorScale", CfnAnalysis_ColorScalePropertyValidator)(properties.colorScale)), errors.collect(cdk.propertyValidator("dataLabels", CfnAnalysis_DataLabelOptionsPropertyValidator)(properties.dataLabels)), errors.collect(cdk.propertyValidator("fieldWells", CfnAnalysis_TreeMapFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("groupLabelOptions", CfnAnalysis_ChartAxisLabelOptionsPropertyValidator)(properties.groupLabelOptions)), errors.collect(cdk.propertyValidator("legend", CfnAnalysis_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("sizeLabelOptions", CfnAnalysis_ChartAxisLabelOptionsPropertyValidator)(properties.sizeLabelOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnAnalysis_TreeMapSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tooltip", CfnAnalysis_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.wrap('supplied properties not correct for "TreeMapConfigurationProperty"');
    }
    function cfnAnalysisTreeMapConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TreeMapConfigurationPropertyValidator(properties).assertSuccess(), { ColorLabelOptions: cfnAnalysisChartAxisLabelOptionsPropertyToCloudFormation(properties.colorLabelOptions), ColorScale: cfnAnalysisColorScalePropertyToCloudFormation(properties.colorScale), DataLabels: cfnAnalysisDataLabelOptionsPropertyToCloudFormation(properties.dataLabels), FieldWells: cfnAnalysisTreeMapFieldWellsPropertyToCloudFormation(properties.fieldWells), GroupLabelOptions: cfnAnalysisChartAxisLabelOptionsPropertyToCloudFormation(properties.groupLabelOptions), Legend: cfnAnalysisLegendOptionsPropertyToCloudFormation(properties.legend), SizeLabelOptions: cfnAnalysisChartAxisLabelOptionsPropertyToCloudFormation(properties.sizeLabelOptions), SortConfiguration: cfnAnalysisTreeMapSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), Tooltip: cfnAnalysisTooltipOptionsPropertyToCloudFormation(properties.tooltip) }) : properties;
    }
    function CfnAnalysisTreeMapConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("colorLabelOptions", "ColorLabelOptions", properties.ColorLabelOptions != null ? CfnAnalysisChartAxisLabelOptionsPropertyFromCloudFormation(properties.ColorLabelOptions) : void 0), ret.addPropertyResult("colorScale", "ColorScale", properties.ColorScale != null ? CfnAnalysisColorScalePropertyFromCloudFormation(properties.ColorScale) : void 0), ret.addPropertyResult("dataLabels", "DataLabels", properties.DataLabels != null ? CfnAnalysisDataLabelOptionsPropertyFromCloudFormation(properties.DataLabels) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnAnalysisTreeMapFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("groupLabelOptions", "GroupLabelOptions", properties.GroupLabelOptions != null ? CfnAnalysisChartAxisLabelOptionsPropertyFromCloudFormation(properties.GroupLabelOptions) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnAnalysisLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("sizeLabelOptions", "SizeLabelOptions", properties.SizeLabelOptions != null ? CfnAnalysisChartAxisLabelOptionsPropertyFromCloudFormation(properties.SizeLabelOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnAnalysisTreeMapSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnAnalysisTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TreeMapFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("treeMapAggregatedFieldWells", CfnAnalysis_TreeMapAggregatedFieldWellsPropertyValidator)(properties.treeMapAggregatedFieldWells)), errors.wrap('supplied properties not correct for "TreeMapFieldWellsProperty"');
    }
    function cfnAnalysisTreeMapFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TreeMapFieldWellsPropertyValidator(properties).assertSuccess(), { TreeMapAggregatedFieldWells: cfnAnalysisTreeMapAggregatedFieldWellsPropertyToCloudFormation(properties.treeMapAggregatedFieldWells) }) : properties;
    }
    function CfnAnalysisTreeMapFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("treeMapAggregatedFieldWells", "TreeMapAggregatedFieldWells", properties.TreeMapAggregatedFieldWells != null ? CfnAnalysisTreeMapAggregatedFieldWellsPropertyFromCloudFormation(properties.TreeMapAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TreeMapSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("treeMapGroupItemsLimitConfiguration", CfnAnalysis_ItemsLimitConfigurationPropertyValidator)(properties.treeMapGroupItemsLimitConfiguration)), errors.collect(cdk.propertyValidator("treeMapSort", cdk.listValidator(CfnAnalysis_FieldSortOptionsPropertyValidator))(properties.treeMapSort)), errors.wrap('supplied properties not correct for "TreeMapSortConfigurationProperty"');
    }
    function cfnAnalysisTreeMapSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TreeMapSortConfigurationPropertyValidator(properties).assertSuccess(), { TreeMapGroupItemsLimitConfiguration: cfnAnalysisItemsLimitConfigurationPropertyToCloudFormation(properties.treeMapGroupItemsLimitConfiguration), TreeMapSort: cdk.listMapper(cfnAnalysisFieldSortOptionsPropertyToCloudFormation)(properties.treeMapSort) }) : properties;
    }
    function CfnAnalysisTreeMapSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("treeMapGroupItemsLimitConfiguration", "TreeMapGroupItemsLimitConfiguration", properties.TreeMapGroupItemsLimitConfiguration != null ? CfnAnalysisItemsLimitConfigurationPropertyFromCloudFormation(properties.TreeMapGroupItemsLimitConfiguration) : void 0), ret.addPropertyResult("treeMapSort", "TreeMapSort", properties.TreeMapSort != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisFieldSortOptionsPropertyFromCloudFormation)(properties.TreeMapSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TreeMapVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnAnalysis_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnAnalysis_TreeMapConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnAnalysis_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnAnalysis_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnAnalysis_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "TreeMapVisualProperty"');
    }
    function cfnAnalysisTreeMapVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TreeMapVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnAnalysisVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnAnalysisTreeMapConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnAnalysisColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnAnalysisVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnAnalysisVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnAnalysisTreeMapVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnAnalysisTreeMapConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnAnalysisVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnAnalysisVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_TrendArrowOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "TrendArrowOptionsProperty"');
    }
    function cfnAnalysisTrendArrowOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_TrendArrowOptionsPropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnAnalysisTrendArrowOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_UnaggregatedFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnAnalysis_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("formatConfiguration", CfnAnalysis_FormatConfigurationPropertyValidator)(properties.formatConfiguration)), errors.wrap('supplied properties not correct for "UnaggregatedFieldProperty"');
    }
    function cfnAnalysisUnaggregatedFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_UnaggregatedFieldPropertyValidator(properties).assertSuccess(), { Column: cfnAnalysisColumnIdentifierPropertyToCloudFormation(properties.column), FieldId: cdk.stringToCloudFormation(properties.fieldId), FormatConfiguration: cfnAnalysisFormatConfigurationPropertyToCloudFormation(properties.formatConfiguration) }) : properties;
    }
    function CfnAnalysisUnaggregatedFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", CfnAnalysisColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("formatConfiguration", "FormatConfiguration", properties.FormatConfiguration != null ? CfnAnalysisFormatConfigurationPropertyFromCloudFormation(properties.FormatConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_UniqueValuesComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("category", cdk.requiredValidator)(properties.category)), errors.collect(cdk.propertyValidator("category", CfnAnalysis_DimensionFieldPropertyValidator)(properties.category)), errors.collect(cdk.propertyValidator("computationId", cdk.requiredValidator)(properties.computationId)), errors.collect(cdk.propertyValidator("computationId", cdk.validateString)(properties.computationId)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "UniqueValuesComputationProperty"');
    }
    function cfnAnalysisUniqueValuesComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_UniqueValuesComputationPropertyValidator(properties).assertSuccess(), { Category: cfnAnalysisDimensionFieldPropertyToCloudFormation(properties.category), ComputationId: cdk.stringToCloudFormation(properties.computationId), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnAnalysisUniqueValuesComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("category", "Category", CfnAnalysisDimensionFieldPropertyFromCloudFormation(properties.Category)), ret.addPropertyResult("computationId", "ComputationId", cfn_parse.FromCloudFormation.getString(properties.ComputationId)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_VisibleRangeOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("percentRange", CfnAnalysis_PercentVisibleRangePropertyValidator)(properties.percentRange)), errors.wrap('supplied properties not correct for "VisibleRangeOptionsProperty"');
    }
    function cfnAnalysisVisibleRangeOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_VisibleRangeOptionsPropertyValidator(properties).assertSuccess(), { PercentRange: cfnAnalysisPercentVisibleRangePropertyToCloudFormation(properties.percentRange) }) : properties;
    }
    function CfnAnalysisVisibleRangeOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("percentRange", "PercentRange", properties.PercentRange != null ? CfnAnalysisPercentVisibleRangePropertyFromCloudFormation(properties.PercentRange) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_VisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("barChartVisual", CfnAnalysis_BarChartVisualPropertyValidator)(properties.barChartVisual)), errors.collect(cdk.propertyValidator("boxPlotVisual", CfnAnalysis_BoxPlotVisualPropertyValidator)(properties.boxPlotVisual)), errors.collect(cdk.propertyValidator("comboChartVisual", CfnAnalysis_ComboChartVisualPropertyValidator)(properties.comboChartVisual)), errors.collect(cdk.propertyValidator("customContentVisual", CfnAnalysis_CustomContentVisualPropertyValidator)(properties.customContentVisual)), errors.collect(cdk.propertyValidator("emptyVisual", CfnAnalysis_EmptyVisualPropertyValidator)(properties.emptyVisual)), errors.collect(cdk.propertyValidator("filledMapVisual", CfnAnalysis_FilledMapVisualPropertyValidator)(properties.filledMapVisual)), errors.collect(cdk.propertyValidator("funnelChartVisual", CfnAnalysis_FunnelChartVisualPropertyValidator)(properties.funnelChartVisual)), errors.collect(cdk.propertyValidator("gaugeChartVisual", CfnAnalysis_GaugeChartVisualPropertyValidator)(properties.gaugeChartVisual)), errors.collect(cdk.propertyValidator("geospatialMapVisual", CfnAnalysis_GeospatialMapVisualPropertyValidator)(properties.geospatialMapVisual)), errors.collect(cdk.propertyValidator("heatMapVisual", CfnAnalysis_HeatMapVisualPropertyValidator)(properties.heatMapVisual)), errors.collect(cdk.propertyValidator("histogramVisual", CfnAnalysis_HistogramVisualPropertyValidator)(properties.histogramVisual)), errors.collect(cdk.propertyValidator("insightVisual", CfnAnalysis_InsightVisualPropertyValidator)(properties.insightVisual)), errors.collect(cdk.propertyValidator("kpiVisual", CfnAnalysis_KPIVisualPropertyValidator)(properties.kpiVisual)), errors.collect(cdk.propertyValidator("lineChartVisual", CfnAnalysis_LineChartVisualPropertyValidator)(properties.lineChartVisual)), errors.collect(cdk.propertyValidator("pieChartVisual", CfnAnalysis_PieChartVisualPropertyValidator)(properties.pieChartVisual)), errors.collect(cdk.propertyValidator("pivotTableVisual", CfnAnalysis_PivotTableVisualPropertyValidator)(properties.pivotTableVisual)), errors.collect(cdk.propertyValidator("radarChartVisual", CfnAnalysis_RadarChartVisualPropertyValidator)(properties.radarChartVisual)), errors.collect(cdk.propertyValidator("sankeyDiagramVisual", CfnAnalysis_SankeyDiagramVisualPropertyValidator)(properties.sankeyDiagramVisual)), errors.collect(cdk.propertyValidator("scatterPlotVisual", CfnAnalysis_ScatterPlotVisualPropertyValidator)(properties.scatterPlotVisual)), errors.collect(cdk.propertyValidator("tableVisual", CfnAnalysis_TableVisualPropertyValidator)(properties.tableVisual)), errors.collect(cdk.propertyValidator("treeMapVisual", CfnAnalysis_TreeMapVisualPropertyValidator)(properties.treeMapVisual)), errors.collect(cdk.propertyValidator("waterfallVisual", CfnAnalysis_WaterfallVisualPropertyValidator)(properties.waterfallVisual)), errors.collect(cdk.propertyValidator("wordCloudVisual", CfnAnalysis_WordCloudVisualPropertyValidator)(properties.wordCloudVisual)), errors.wrap('supplied properties not correct for "VisualProperty"');
    }
    function cfnAnalysisVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_VisualPropertyValidator(properties).assertSuccess(), { BarChartVisual: cfnAnalysisBarChartVisualPropertyToCloudFormation(properties.barChartVisual), BoxPlotVisual: cfnAnalysisBoxPlotVisualPropertyToCloudFormation(properties.boxPlotVisual), ComboChartVisual: cfnAnalysisComboChartVisualPropertyToCloudFormation(properties.comboChartVisual), CustomContentVisual: cfnAnalysisCustomContentVisualPropertyToCloudFormation(properties.customContentVisual), EmptyVisual: cfnAnalysisEmptyVisualPropertyToCloudFormation(properties.emptyVisual), FilledMapVisual: cfnAnalysisFilledMapVisualPropertyToCloudFormation(properties.filledMapVisual), FunnelChartVisual: cfnAnalysisFunnelChartVisualPropertyToCloudFormation(properties.funnelChartVisual), GaugeChartVisual: cfnAnalysisGaugeChartVisualPropertyToCloudFormation(properties.gaugeChartVisual), GeospatialMapVisual: cfnAnalysisGeospatialMapVisualPropertyToCloudFormation(properties.geospatialMapVisual), HeatMapVisual: cfnAnalysisHeatMapVisualPropertyToCloudFormation(properties.heatMapVisual), HistogramVisual: cfnAnalysisHistogramVisualPropertyToCloudFormation(properties.histogramVisual), InsightVisual: cfnAnalysisInsightVisualPropertyToCloudFormation(properties.insightVisual), KPIVisual: cfnAnalysisKPIVisualPropertyToCloudFormation(properties.kpiVisual), LineChartVisual: cfnAnalysisLineChartVisualPropertyToCloudFormation(properties.lineChartVisual), PieChartVisual: cfnAnalysisPieChartVisualPropertyToCloudFormation(properties.pieChartVisual), PivotTableVisual: cfnAnalysisPivotTableVisualPropertyToCloudFormation(properties.pivotTableVisual), RadarChartVisual: cfnAnalysisRadarChartVisualPropertyToCloudFormation(properties.radarChartVisual), SankeyDiagramVisual: cfnAnalysisSankeyDiagramVisualPropertyToCloudFormation(properties.sankeyDiagramVisual), ScatterPlotVisual: cfnAnalysisScatterPlotVisualPropertyToCloudFormation(properties.scatterPlotVisual), TableVisual: cfnAnalysisTableVisualPropertyToCloudFormation(properties.tableVisual), TreeMapVisual: cfnAnalysisTreeMapVisualPropertyToCloudFormation(properties.treeMapVisual), WaterfallVisual: cfnAnalysisWaterfallVisualPropertyToCloudFormation(properties.waterfallVisual), WordCloudVisual: cfnAnalysisWordCloudVisualPropertyToCloudFormation(properties.wordCloudVisual) }) : properties;
    }
    function CfnAnalysisVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("barChartVisual", "BarChartVisual", properties.BarChartVisual != null ? CfnAnalysisBarChartVisualPropertyFromCloudFormation(properties.BarChartVisual) : void 0), ret.addPropertyResult("boxPlotVisual", "BoxPlotVisual", properties.BoxPlotVisual != null ? CfnAnalysisBoxPlotVisualPropertyFromCloudFormation(properties.BoxPlotVisual) : void 0), ret.addPropertyResult("comboChartVisual", "ComboChartVisual", properties.ComboChartVisual != null ? CfnAnalysisComboChartVisualPropertyFromCloudFormation(properties.ComboChartVisual) : void 0), ret.addPropertyResult("customContentVisual", "CustomContentVisual", properties.CustomContentVisual != null ? CfnAnalysisCustomContentVisualPropertyFromCloudFormation(properties.CustomContentVisual) : void 0), ret.addPropertyResult("emptyVisual", "EmptyVisual", properties.EmptyVisual != null ? CfnAnalysisEmptyVisualPropertyFromCloudFormation(properties.EmptyVisual) : void 0), ret.addPropertyResult("filledMapVisual", "FilledMapVisual", properties.FilledMapVisual != null ? CfnAnalysisFilledMapVisualPropertyFromCloudFormation(properties.FilledMapVisual) : void 0), ret.addPropertyResult("funnelChartVisual", "FunnelChartVisual", properties.FunnelChartVisual != null ? CfnAnalysisFunnelChartVisualPropertyFromCloudFormation(properties.FunnelChartVisual) : void 0), ret.addPropertyResult("gaugeChartVisual", "GaugeChartVisual", properties.GaugeChartVisual != null ? CfnAnalysisGaugeChartVisualPropertyFromCloudFormation(properties.GaugeChartVisual) : void 0), ret.addPropertyResult("geospatialMapVisual", "GeospatialMapVisual", properties.GeospatialMapVisual != null ? CfnAnalysisGeospatialMapVisualPropertyFromCloudFormation(properties.GeospatialMapVisual) : void 0), ret.addPropertyResult("heatMapVisual", "HeatMapVisual", properties.HeatMapVisual != null ? CfnAnalysisHeatMapVisualPropertyFromCloudFormation(properties.HeatMapVisual) : void 0), ret.addPropertyResult("histogramVisual", "HistogramVisual", properties.HistogramVisual != null ? CfnAnalysisHistogramVisualPropertyFromCloudFormation(properties.HistogramVisual) : void 0), ret.addPropertyResult("insightVisual", "InsightVisual", properties.InsightVisual != null ? CfnAnalysisInsightVisualPropertyFromCloudFormation(properties.InsightVisual) : void 0), ret.addPropertyResult("kpiVisual", "KPIVisual", properties.KPIVisual != null ? CfnAnalysisKPIVisualPropertyFromCloudFormation(properties.KPIVisual) : void 0), ret.addPropertyResult("lineChartVisual", "LineChartVisual", properties.LineChartVisual != null ? CfnAnalysisLineChartVisualPropertyFromCloudFormation(properties.LineChartVisual) : void 0), ret.addPropertyResult("pieChartVisual", "PieChartVisual", properties.PieChartVisual != null ? CfnAnalysisPieChartVisualPropertyFromCloudFormation(properties.PieChartVisual) : void 0), ret.addPropertyResult("pivotTableVisual", "PivotTableVisual", properties.PivotTableVisual != null ? CfnAnalysisPivotTableVisualPropertyFromCloudFormation(properties.PivotTableVisual) : void 0), ret.addPropertyResult("radarChartVisual", "RadarChartVisual", properties.RadarChartVisual != null ? CfnAnalysisRadarChartVisualPropertyFromCloudFormation(properties.RadarChartVisual) : void 0), ret.addPropertyResult("sankeyDiagramVisual", "SankeyDiagramVisual", properties.SankeyDiagramVisual != null ? CfnAnalysisSankeyDiagramVisualPropertyFromCloudFormation(properties.SankeyDiagramVisual) : void 0), ret.addPropertyResult("scatterPlotVisual", "ScatterPlotVisual", properties.ScatterPlotVisual != null ? CfnAnalysisScatterPlotVisualPropertyFromCloudFormation(properties.ScatterPlotVisual) : void 0), ret.addPropertyResult("tableVisual", "TableVisual", properties.TableVisual != null ? CfnAnalysisTableVisualPropertyFromCloudFormation(properties.TableVisual) : void 0), ret.addPropertyResult("treeMapVisual", "TreeMapVisual", properties.TreeMapVisual != null ? CfnAnalysisTreeMapVisualPropertyFromCloudFormation(properties.TreeMapVisual) : void 0), ret.addPropertyResult("waterfallVisual", "WaterfallVisual", properties.WaterfallVisual != null ? CfnAnalysisWaterfallVisualPropertyFromCloudFormation(properties.WaterfallVisual) : void 0), ret.addPropertyResult("wordCloudVisual", "WordCloudVisual", properties.WordCloudVisual != null ? CfnAnalysisWordCloudVisualPropertyFromCloudFormation(properties.WordCloudVisual) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_VisualCustomActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actionOperations", cdk.requiredValidator)(properties.actionOperations)), errors.collect(cdk.propertyValidator("actionOperations", cdk.listValidator(CfnAnalysis_VisualCustomActionOperationPropertyValidator))(properties.actionOperations)), errors.collect(cdk.propertyValidator("customActionId", cdk.requiredValidator)(properties.customActionId)), errors.collect(cdk.propertyValidator("customActionId", cdk.validateString)(properties.customActionId)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.collect(cdk.propertyValidator("trigger", cdk.requiredValidator)(properties.trigger)), errors.collect(cdk.propertyValidator("trigger", cdk.validateString)(properties.trigger)), errors.wrap('supplied properties not correct for "VisualCustomActionProperty"');
    }
    function cfnAnalysisVisualCustomActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_VisualCustomActionPropertyValidator(properties).assertSuccess(), { ActionOperations: cdk.listMapper(cfnAnalysisVisualCustomActionOperationPropertyToCloudFormation)(properties.actionOperations), CustomActionId: cdk.stringToCloudFormation(properties.customActionId), Name: cdk.stringToCloudFormation(properties.name), Status: cdk.stringToCloudFormation(properties.status), Trigger: cdk.stringToCloudFormation(properties.trigger) }) : properties;
    }
    function CfnAnalysisVisualCustomActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actionOperations", "ActionOperations", cfn_parse.FromCloudFormation.getArray(CfnAnalysisVisualCustomActionOperationPropertyFromCloudFormation)(properties.ActionOperations)), ret.addPropertyResult("customActionId", "CustomActionId", cfn_parse.FromCloudFormation.getString(properties.CustomActionId)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addPropertyResult("trigger", "Trigger", cfn_parse.FromCloudFormation.getString(properties.Trigger)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_VisualCustomActionOperationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("filterOperation", CfnAnalysis_CustomActionFilterOperationPropertyValidator)(properties.filterOperation)), errors.collect(cdk.propertyValidator("navigationOperation", CfnAnalysis_CustomActionNavigationOperationPropertyValidator)(properties.navigationOperation)), errors.collect(cdk.propertyValidator("setParametersOperation", CfnAnalysis_CustomActionSetParametersOperationPropertyValidator)(properties.setParametersOperation)), errors.collect(cdk.propertyValidator("urlOperation", CfnAnalysis_CustomActionURLOperationPropertyValidator)(properties.urlOperation)), errors.wrap('supplied properties not correct for "VisualCustomActionOperationProperty"');
    }
    function cfnAnalysisVisualCustomActionOperationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_VisualCustomActionOperationPropertyValidator(properties).assertSuccess(), { FilterOperation: cfnAnalysisCustomActionFilterOperationPropertyToCloudFormation(properties.filterOperation), NavigationOperation: cfnAnalysisCustomActionNavigationOperationPropertyToCloudFormation(properties.navigationOperation), SetParametersOperation: cfnAnalysisCustomActionSetParametersOperationPropertyToCloudFormation(properties.setParametersOperation), URLOperation: cfnAnalysisCustomActionURLOperationPropertyToCloudFormation(properties.urlOperation) }) : properties;
    }
    function CfnAnalysisVisualCustomActionOperationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("filterOperation", "FilterOperation", properties.FilterOperation != null ? CfnAnalysisCustomActionFilterOperationPropertyFromCloudFormation(properties.FilterOperation) : void 0), ret.addPropertyResult("navigationOperation", "NavigationOperation", properties.NavigationOperation != null ? CfnAnalysisCustomActionNavigationOperationPropertyFromCloudFormation(properties.NavigationOperation) : void 0), ret.addPropertyResult("setParametersOperation", "SetParametersOperation", properties.SetParametersOperation != null ? CfnAnalysisCustomActionSetParametersOperationPropertyFromCloudFormation(properties.SetParametersOperation) : void 0), ret.addPropertyResult("urlOperation", "URLOperation", properties.URLOperation != null ? CfnAnalysisCustomActionURLOperationPropertyFromCloudFormation(properties.URLOperation) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_VisualPalettePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("chartColor", cdk.validateString)(properties.chartColor)), errors.collect(cdk.propertyValidator("colorMap", cdk.listValidator(CfnAnalysis_DataPathColorPropertyValidator))(properties.colorMap)), errors.wrap('supplied properties not correct for "VisualPaletteProperty"');
    }
    function cfnAnalysisVisualPalettePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_VisualPalettePropertyValidator(properties).assertSuccess(), { ChartColor: cdk.stringToCloudFormation(properties.chartColor), ColorMap: cdk.listMapper(cfnAnalysisDataPathColorPropertyToCloudFormation)(properties.colorMap) }) : properties;
    }
    function CfnAnalysisVisualPalettePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("chartColor", "ChartColor", properties.ChartColor != null ? cfn_parse.FromCloudFormation.getString(properties.ChartColor) : void 0), ret.addPropertyResult("colorMap", "ColorMap", properties.ColorMap != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDataPathColorPropertyFromCloudFormation)(properties.ColorMap) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_VisualSubtitleLabelOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("formatText", CfnAnalysis_LongFormatTextPropertyValidator)(properties.formatText)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "VisualSubtitleLabelOptionsProperty"');
    }
    function cfnAnalysisVisualSubtitleLabelOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_VisualSubtitleLabelOptionsPropertyValidator(properties).assertSuccess(), { FormatText: cfnAnalysisLongFormatTextPropertyToCloudFormation(properties.formatText), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnAnalysisVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("formatText", "FormatText", properties.FormatText != null ? CfnAnalysisLongFormatTextPropertyFromCloudFormation(properties.FormatText) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_VisualTitleLabelOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("formatText", CfnAnalysis_ShortFormatTextPropertyValidator)(properties.formatText)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "VisualTitleLabelOptionsProperty"');
    }
    function cfnAnalysisVisualTitleLabelOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_VisualTitleLabelOptionsPropertyValidator(properties).assertSuccess(), { FormatText: cfnAnalysisShortFormatTextPropertyToCloudFormation(properties.formatText), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnAnalysisVisualTitleLabelOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("formatText", "FormatText", properties.FormatText != null ? CfnAnalysisShortFormatTextPropertyFromCloudFormation(properties.FormatText) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_WaterfallChartAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("breakdowns", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.breakdowns)), errors.collect(cdk.propertyValidator("categories", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.categories)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnAnalysis_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "WaterfallChartAggregatedFieldWellsProperty"');
    }
    function cfnAnalysisWaterfallChartAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_WaterfallChartAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Breakdowns: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.breakdowns), Categories: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.categories), Values: cdk.listMapper(cfnAnalysisMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnAnalysisWaterfallChartAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("breakdowns", "Breakdowns", properties.Breakdowns != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.Breakdowns) : void 0), ret.addPropertyResult("categories", "Categories", properties.Categories != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.Categories) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_WaterfallChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryAxisDisplayOptions", CfnAnalysis_AxisDisplayOptionsPropertyValidator)(properties.categoryAxisDisplayOptions)), errors.collect(cdk.propertyValidator("categoryAxisLabelOptions", CfnAnalysis_ChartAxisLabelOptionsPropertyValidator)(properties.categoryAxisLabelOptions)), errors.collect(cdk.propertyValidator("dataLabels", CfnAnalysis_DataLabelOptionsPropertyValidator)(properties.dataLabels)), errors.collect(cdk.propertyValidator("fieldWells", CfnAnalysis_WaterfallChartFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("legend", CfnAnalysis_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("primaryYAxisDisplayOptions", CfnAnalysis_AxisDisplayOptionsPropertyValidator)(properties.primaryYAxisDisplayOptions)), errors.collect(cdk.propertyValidator("primaryYAxisLabelOptions", CfnAnalysis_ChartAxisLabelOptionsPropertyValidator)(properties.primaryYAxisLabelOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnAnalysis_WaterfallChartSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("visualPalette", CfnAnalysis_VisualPalettePropertyValidator)(properties.visualPalette)), errors.collect(cdk.propertyValidator("waterfallChartOptions", CfnAnalysis_WaterfallChartOptionsPropertyValidator)(properties.waterfallChartOptions)), errors.wrap('supplied properties not correct for "WaterfallChartConfigurationProperty"');
    }
    function cfnAnalysisWaterfallChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_WaterfallChartConfigurationPropertyValidator(properties).assertSuccess(), { CategoryAxisDisplayOptions: cfnAnalysisAxisDisplayOptionsPropertyToCloudFormation(properties.categoryAxisDisplayOptions), CategoryAxisLabelOptions: cfnAnalysisChartAxisLabelOptionsPropertyToCloudFormation(properties.categoryAxisLabelOptions), DataLabels: cfnAnalysisDataLabelOptionsPropertyToCloudFormation(properties.dataLabels), FieldWells: cfnAnalysisWaterfallChartFieldWellsPropertyToCloudFormation(properties.fieldWells), Legend: cfnAnalysisLegendOptionsPropertyToCloudFormation(properties.legend), PrimaryYAxisDisplayOptions: cfnAnalysisAxisDisplayOptionsPropertyToCloudFormation(properties.primaryYAxisDisplayOptions), PrimaryYAxisLabelOptions: cfnAnalysisChartAxisLabelOptionsPropertyToCloudFormation(properties.primaryYAxisLabelOptions), SortConfiguration: cfnAnalysisWaterfallChartSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), VisualPalette: cfnAnalysisVisualPalettePropertyToCloudFormation(properties.visualPalette), WaterfallChartOptions: cfnAnalysisWaterfallChartOptionsPropertyToCloudFormation(properties.waterfallChartOptions) }) : properties;
    }
    function CfnAnalysisWaterfallChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryAxisDisplayOptions", "CategoryAxisDisplayOptions", properties.CategoryAxisDisplayOptions != null ? CfnAnalysisAxisDisplayOptionsPropertyFromCloudFormation(properties.CategoryAxisDisplayOptions) : void 0), ret.addPropertyResult("categoryAxisLabelOptions", "CategoryAxisLabelOptions", properties.CategoryAxisLabelOptions != null ? CfnAnalysisChartAxisLabelOptionsPropertyFromCloudFormation(properties.CategoryAxisLabelOptions) : void 0), ret.addPropertyResult("dataLabels", "DataLabels", properties.DataLabels != null ? CfnAnalysisDataLabelOptionsPropertyFromCloudFormation(properties.DataLabels) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnAnalysisWaterfallChartFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnAnalysisLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("primaryYAxisDisplayOptions", "PrimaryYAxisDisplayOptions", properties.PrimaryYAxisDisplayOptions != null ? CfnAnalysisAxisDisplayOptionsPropertyFromCloudFormation(properties.PrimaryYAxisDisplayOptions) : void 0), ret.addPropertyResult("primaryYAxisLabelOptions", "PrimaryYAxisLabelOptions", properties.PrimaryYAxisLabelOptions != null ? CfnAnalysisChartAxisLabelOptionsPropertyFromCloudFormation(properties.PrimaryYAxisLabelOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnAnalysisWaterfallChartSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnAnalysisVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addPropertyResult("waterfallChartOptions", "WaterfallChartOptions", properties.WaterfallChartOptions != null ? CfnAnalysisWaterfallChartOptionsPropertyFromCloudFormation(properties.WaterfallChartOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_WaterfallChartFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("waterfallChartAggregatedFieldWells", CfnAnalysis_WaterfallChartAggregatedFieldWellsPropertyValidator)(properties.waterfallChartAggregatedFieldWells)), errors.wrap('supplied properties not correct for "WaterfallChartFieldWellsProperty"');
    }
    function cfnAnalysisWaterfallChartFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_WaterfallChartFieldWellsPropertyValidator(properties).assertSuccess(), { WaterfallChartAggregatedFieldWells: cfnAnalysisWaterfallChartAggregatedFieldWellsPropertyToCloudFormation(properties.waterfallChartAggregatedFieldWells) }) : properties;
    }
    function CfnAnalysisWaterfallChartFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("waterfallChartAggregatedFieldWells", "WaterfallChartAggregatedFieldWells", properties.WaterfallChartAggregatedFieldWells != null ? CfnAnalysisWaterfallChartAggregatedFieldWellsPropertyFromCloudFormation(properties.WaterfallChartAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_WaterfallChartOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("totalBarLabel", cdk.validateString)(properties.totalBarLabel)), errors.wrap('supplied properties not correct for "WaterfallChartOptionsProperty"');
    }
    function cfnAnalysisWaterfallChartOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_WaterfallChartOptionsPropertyValidator(properties).assertSuccess(), { TotalBarLabel: cdk.stringToCloudFormation(properties.totalBarLabel) }) : properties;
    }
    function CfnAnalysisWaterfallChartOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("totalBarLabel", "TotalBarLabel", properties.TotalBarLabel != null ? cfn_parse.FromCloudFormation.getString(properties.TotalBarLabel) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_WaterfallChartSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("breakdownItemsLimit", CfnAnalysis_ItemsLimitConfigurationPropertyValidator)(properties.breakdownItemsLimit)), errors.collect(cdk.propertyValidator("categorySort", cdk.listValidator(CfnAnalysis_FieldSortOptionsPropertyValidator))(properties.categorySort)), errors.wrap('supplied properties not correct for "WaterfallChartSortConfigurationProperty"');
    }
    function cfnAnalysisWaterfallChartSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_WaterfallChartSortConfigurationPropertyValidator(properties).assertSuccess(), { BreakdownItemsLimit: cfnAnalysisItemsLimitConfigurationPropertyToCloudFormation(properties.breakdownItemsLimit), CategorySort: cdk.listMapper(cfnAnalysisFieldSortOptionsPropertyToCloudFormation)(properties.categorySort) }) : properties;
    }
    function CfnAnalysisWaterfallChartSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("breakdownItemsLimit", "BreakdownItemsLimit", properties.BreakdownItemsLimit != null ? CfnAnalysisItemsLimitConfigurationPropertyFromCloudFormation(properties.BreakdownItemsLimit) : void 0), ret.addPropertyResult("categorySort", "CategorySort", properties.CategorySort != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisFieldSortOptionsPropertyFromCloudFormation)(properties.CategorySort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_WaterfallVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnAnalysis_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnAnalysis_WaterfallChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnAnalysis_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnAnalysis_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnAnalysis_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "WaterfallVisualProperty"');
    }
    function cfnAnalysisWaterfallVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_WaterfallVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnAnalysisVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnAnalysisWaterfallChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnAnalysisColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnAnalysisVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnAnalysisVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnAnalysisWaterfallVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnAnalysisWaterfallChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnAnalysisVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnAnalysisVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_WhatIfPointScenarioPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("date", cdk.requiredValidator)(properties.date)), errors.collect(cdk.propertyValidator("date", cdk.validateString)(properties.date)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "WhatIfPointScenarioProperty"');
    }
    function cfnAnalysisWhatIfPointScenarioPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_WhatIfPointScenarioPropertyValidator(properties).assertSuccess(), { Date: cdk.stringToCloudFormation(properties.date), Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnAnalysisWhatIfPointScenarioPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("date", "Date", cfn_parse.FromCloudFormation.getString(properties.Date)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getNumber(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_WhatIfRangeScenarioPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endDate", cdk.requiredValidator)(properties.endDate)), errors.collect(cdk.propertyValidator("endDate", cdk.validateString)(properties.endDate)), errors.collect(cdk.propertyValidator("startDate", cdk.requiredValidator)(properties.startDate)), errors.collect(cdk.propertyValidator("startDate", cdk.validateString)(properties.startDate)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "WhatIfRangeScenarioProperty"');
    }
    function cfnAnalysisWhatIfRangeScenarioPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_WhatIfRangeScenarioPropertyValidator(properties).assertSuccess(), { EndDate: cdk.stringToCloudFormation(properties.endDate), StartDate: cdk.stringToCloudFormation(properties.startDate), Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnAnalysisWhatIfRangeScenarioPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endDate", "EndDate", cfn_parse.FromCloudFormation.getString(properties.EndDate)), ret.addPropertyResult("startDate", "StartDate", cfn_parse.FromCloudFormation.getString(properties.StartDate)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getNumber(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_WordCloudAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groupBy", cdk.listValidator(CfnAnalysis_DimensionFieldPropertyValidator))(properties.groupBy)), errors.collect(cdk.propertyValidator("size", cdk.listValidator(CfnAnalysis_MeasureFieldPropertyValidator))(properties.size)), errors.wrap('supplied properties not correct for "WordCloudAggregatedFieldWellsProperty"');
    }
    function cfnAnalysisWordCloudAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_WordCloudAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { GroupBy: cdk.listMapper(cfnAnalysisDimensionFieldPropertyToCloudFormation)(properties.groupBy), Size: cdk.listMapper(cfnAnalysisMeasureFieldPropertyToCloudFormation)(properties.size) }) : properties;
    }
    function CfnAnalysisWordCloudAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupBy", "GroupBy", properties.GroupBy != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisDimensionFieldPropertyFromCloudFormation)(properties.GroupBy) : void 0), ret.addPropertyResult("size", "Size", properties.Size != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisMeasureFieldPropertyFromCloudFormation)(properties.Size) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_WordCloudChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryLabelOptions", CfnAnalysis_ChartAxisLabelOptionsPropertyValidator)(properties.categoryLabelOptions)), errors.collect(cdk.propertyValidator("fieldWells", CfnAnalysis_WordCloudFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnAnalysis_WordCloudSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("wordCloudOptions", CfnAnalysis_WordCloudOptionsPropertyValidator)(properties.wordCloudOptions)), errors.wrap('supplied properties not correct for "WordCloudChartConfigurationProperty"');
    }
    function cfnAnalysisWordCloudChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_WordCloudChartConfigurationPropertyValidator(properties).assertSuccess(), { CategoryLabelOptions: cfnAnalysisChartAxisLabelOptionsPropertyToCloudFormation(properties.categoryLabelOptions), FieldWells: cfnAnalysisWordCloudFieldWellsPropertyToCloudFormation(properties.fieldWells), SortConfiguration: cfnAnalysisWordCloudSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), WordCloudOptions: cfnAnalysisWordCloudOptionsPropertyToCloudFormation(properties.wordCloudOptions) }) : properties;
    }
    function CfnAnalysisWordCloudChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryLabelOptions", "CategoryLabelOptions", properties.CategoryLabelOptions != null ? CfnAnalysisChartAxisLabelOptionsPropertyFromCloudFormation(properties.CategoryLabelOptions) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnAnalysisWordCloudFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnAnalysisWordCloudSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("wordCloudOptions", "WordCloudOptions", properties.WordCloudOptions != null ? CfnAnalysisWordCloudOptionsPropertyFromCloudFormation(properties.WordCloudOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_WordCloudFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("wordCloudAggregatedFieldWells", CfnAnalysis_WordCloudAggregatedFieldWellsPropertyValidator)(properties.wordCloudAggregatedFieldWells)), errors.wrap('supplied properties not correct for "WordCloudFieldWellsProperty"');
    }
    function cfnAnalysisWordCloudFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_WordCloudFieldWellsPropertyValidator(properties).assertSuccess(), { WordCloudAggregatedFieldWells: cfnAnalysisWordCloudAggregatedFieldWellsPropertyToCloudFormation(properties.wordCloudAggregatedFieldWells) }) : properties;
    }
    function CfnAnalysisWordCloudFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("wordCloudAggregatedFieldWells", "WordCloudAggregatedFieldWells", properties.WordCloudAggregatedFieldWells != null ? CfnAnalysisWordCloudAggregatedFieldWellsPropertyFromCloudFormation(properties.WordCloudAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_WordCloudOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudLayout", cdk.validateString)(properties.cloudLayout)), errors.collect(cdk.propertyValidator("maximumStringLength", cdk.validateNumber)(properties.maximumStringLength)), errors.collect(cdk.propertyValidator("wordCasing", cdk.validateString)(properties.wordCasing)), errors.collect(cdk.propertyValidator("wordOrientation", cdk.validateString)(properties.wordOrientation)), errors.collect(cdk.propertyValidator("wordPadding", cdk.validateString)(properties.wordPadding)), errors.collect(cdk.propertyValidator("wordScaling", cdk.validateString)(properties.wordScaling)), errors.wrap('supplied properties not correct for "WordCloudOptionsProperty"');
    }
    function cfnAnalysisWordCloudOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_WordCloudOptionsPropertyValidator(properties).assertSuccess(), { CloudLayout: cdk.stringToCloudFormation(properties.cloudLayout), MaximumStringLength: cdk.numberToCloudFormation(properties.maximumStringLength), WordCasing: cdk.stringToCloudFormation(properties.wordCasing), WordOrientation: cdk.stringToCloudFormation(properties.wordOrientation), WordPadding: cdk.stringToCloudFormation(properties.wordPadding), WordScaling: cdk.stringToCloudFormation(properties.wordScaling) }) : properties;
    }
    function CfnAnalysisWordCloudOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudLayout", "CloudLayout", properties.CloudLayout != null ? cfn_parse.FromCloudFormation.getString(properties.CloudLayout) : void 0), ret.addPropertyResult("maximumStringLength", "MaximumStringLength", properties.MaximumStringLength != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumStringLength) : void 0), ret.addPropertyResult("wordCasing", "WordCasing", properties.WordCasing != null ? cfn_parse.FromCloudFormation.getString(properties.WordCasing) : void 0), ret.addPropertyResult("wordOrientation", "WordOrientation", properties.WordOrientation != null ? cfn_parse.FromCloudFormation.getString(properties.WordOrientation) : void 0), ret.addPropertyResult("wordPadding", "WordPadding", properties.WordPadding != null ? cfn_parse.FromCloudFormation.getString(properties.WordPadding) : void 0), ret.addPropertyResult("wordScaling", "WordScaling", properties.WordScaling != null ? cfn_parse.FromCloudFormation.getString(properties.WordScaling) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_WordCloudSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryItemsLimit", CfnAnalysis_ItemsLimitConfigurationPropertyValidator)(properties.categoryItemsLimit)), errors.collect(cdk.propertyValidator("categorySort", cdk.listValidator(CfnAnalysis_FieldSortOptionsPropertyValidator))(properties.categorySort)), errors.wrap('supplied properties not correct for "WordCloudSortConfigurationProperty"');
    }
    function cfnAnalysisWordCloudSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_WordCloudSortConfigurationPropertyValidator(properties).assertSuccess(), { CategoryItemsLimit: cfnAnalysisItemsLimitConfigurationPropertyToCloudFormation(properties.categoryItemsLimit), CategorySort: cdk.listMapper(cfnAnalysisFieldSortOptionsPropertyToCloudFormation)(properties.categorySort) }) : properties;
    }
    function CfnAnalysisWordCloudSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryItemsLimit", "CategoryItemsLimit", properties.CategoryItemsLimit != null ? CfnAnalysisItemsLimitConfigurationPropertyFromCloudFormation(properties.CategoryItemsLimit) : void 0), ret.addPropertyResult("categorySort", "CategorySort", properties.CategorySort != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisFieldSortOptionsPropertyFromCloudFormation)(properties.CategorySort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAnalysis_WordCloudVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnAnalysis_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnAnalysis_WordCloudChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnAnalysis_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnAnalysis_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnAnalysis_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "WordCloudVisualProperty"');
    }
    function cfnAnalysisWordCloudVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAnalysis_WordCloudVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnAnalysisVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnAnalysisWordCloudChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnAnalysisColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnAnalysisVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnAnalysisVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnAnalysisWordCloudVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnAnalysisWordCloudChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnAnalysisColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnAnalysisVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnAnalysisVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboardPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("awsAccountId", cdk.requiredValidator)(properties.awsAccountId)), errors.collect(cdk.propertyValidator("awsAccountId", cdk.validateString)(properties.awsAccountId)), errors.collect(cdk.propertyValidator("dashboardId", cdk.requiredValidator)(properties.dashboardId)), errors.collect(cdk.propertyValidator("dashboardId", cdk.validateString)(properties.dashboardId)), errors.collect(cdk.propertyValidator("dashboardPublishOptions", CfnDashboard_DashboardPublishOptionsPropertyValidator)(properties.dashboardPublishOptions)), errors.collect(cdk.propertyValidator("definition", CfnDashboard_DashboardVersionDefinitionPropertyValidator)(properties.definition)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("parameters", CfnDashboard_ParametersPropertyValidator)(properties.parameters)), errors.collect(cdk.propertyValidator("permissions", cdk.listValidator(CfnDashboard_ResourcePermissionPropertyValidator))(properties.permissions)), errors.collect(cdk.propertyValidator("sourceEntity", CfnDashboard_DashboardSourceEntityPropertyValidator)(properties.sourceEntity)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("themeArn", cdk.validateString)(properties.themeArn)), errors.collect(cdk.propertyValidator("versionDescription", cdk.validateString)(properties.versionDescription)), errors.wrap('supplied properties not correct for "CfnDashboardProps"');
    }
    function cfnDashboardPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboardPropsValidator(properties).assertSuccess(), { AwsAccountId: cdk.stringToCloudFormation(properties.awsAccountId), DashboardId: cdk.stringToCloudFormation(properties.dashboardId), Name: cdk.stringToCloudFormation(properties.name), DashboardPublishOptions: cfnDashboardDashboardPublishOptionsPropertyToCloudFormation(properties.dashboardPublishOptions), Definition: cfnDashboardDashboardVersionDefinitionPropertyToCloudFormation(properties.definition), Parameters: cfnDashboardParametersPropertyToCloudFormation(properties.parameters), Permissions: cdk.listMapper(cfnDashboardResourcePermissionPropertyToCloudFormation)(properties.permissions), SourceEntity: cfnDashboardDashboardSourceEntityPropertyToCloudFormation(properties.sourceEntity), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), ThemeArn: cdk.stringToCloudFormation(properties.themeArn), VersionDescription: cdk.stringToCloudFormation(properties.versionDescription) }) : properties;
    }
    function CfnDashboardPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("awsAccountId", "AwsAccountId", cfn_parse.FromCloudFormation.getString(properties.AwsAccountId)), ret.addPropertyResult("dashboardId", "DashboardId", cfn_parse.FromCloudFormation.getString(properties.DashboardId)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("dashboardPublishOptions", "DashboardPublishOptions", properties.DashboardPublishOptions != null ? CfnDashboardDashboardPublishOptionsPropertyFromCloudFormation(properties.DashboardPublishOptions) : void 0), ret.addPropertyResult("definition", "Definition", properties.Definition != null ? CfnDashboardDashboardVersionDefinitionPropertyFromCloudFormation(properties.Definition) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? CfnDashboardParametersPropertyFromCloudFormation(properties.Parameters) : void 0), ret.addPropertyResult("permissions", "Permissions", properties.Permissions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardResourcePermissionPropertyFromCloudFormation)(properties.Permissions) : void 0), ret.addPropertyResult("sourceEntity", "SourceEntity", properties.SourceEntity != null ? CfnDashboardDashboardSourceEntityPropertyFromCloudFormation(properties.SourceEntity) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("themeArn", "ThemeArn", properties.ThemeArn != null ? cfn_parse.FromCloudFormation.getString(properties.ThemeArn) : void 0), ret.addPropertyResult("versionDescription", "VersionDescription", properties.VersionDescription != null ? cfn_parse.FromCloudFormation.getString(properties.VersionDescription) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDashboard = class _CfnDashboard extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDashboardPropsFromCloudFormation(resourceProperties), ret = new _CfnDashboard(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDashboard.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_quicksight_CfnDashboardProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDashboard), error;
        }
        cdk.requireProperty(props, "awsAccountId", this), cdk.requireProperty(props, "dashboardId", this), cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreatedTime = cdk.Token.asString(this.getAtt("CreatedTime", cdk.ResolutionTypeHint.STRING)), this.attrLastPublishedTime = cdk.Token.asString(this.getAtt("LastPublishedTime", cdk.ResolutionTypeHint.STRING)), this.attrLastUpdatedTime = cdk.Token.asString(this.getAtt("LastUpdatedTime", cdk.ResolutionTypeHint.STRING)), this.attrVersionArn = cdk.Token.asString(this.getAtt("Version.Arn", cdk.ResolutionTypeHint.STRING)), this.attrVersionCreatedTime = cdk.Token.asString(this.getAtt("Version.CreatedTime", cdk.ResolutionTypeHint.STRING)), this.attrVersionDataSetArns = cdk.Token.asList(this.getAtt("Version.DataSetArns", cdk.ResolutionTypeHint.STRING_LIST)), this.attrVersionDescription = cdk.Token.asString(this.getAtt("Version.Description", cdk.ResolutionTypeHint.STRING)), this.attrVersionErrors = this.getAtt("Version.Errors", cdk.ResolutionTypeHint.STRING), this.attrVersionSheets = this.getAtt("Version.Sheets", cdk.ResolutionTypeHint.STRING), this.attrVersionSourceEntityArn = cdk.Token.asString(this.getAtt("Version.SourceEntityArn", cdk.ResolutionTypeHint.STRING)), this.attrVersionStatus = cdk.Token.asString(this.getAtt("Version.Status", cdk.ResolutionTypeHint.STRING)), this.attrVersionThemeArn = cdk.Token.asString(this.getAtt("Version.ThemeArn", cdk.ResolutionTypeHint.STRING)), this.attrVersionVersionNumber = this.getAtt("Version.VersionNumber", cdk.ResolutionTypeHint.STRING), this.awsAccountId = props.awsAccountId, this.dashboardId = props.dashboardId, this.name = props.name, this.dashboardPublishOptions = props.dashboardPublishOptions, this.definition = props.definition, this.parameters = props.parameters, this.permissions = props.permissions, this.sourceEntity = props.sourceEntity, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::QuickSight::Dashboard", props.tags, { tagPropertyName: "tags" }), this.themeArn = props.themeArn, this.versionDescription = props.versionDescription;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDashboard.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { awsAccountId: this.awsAccountId, dashboardId: this.dashboardId, name: this.name, dashboardPublishOptions: this.dashboardPublishOptions, definition: this.definition, parameters: this.parameters, permissions: this.permissions, sourceEntity: this.sourceEntity, tags: this.tags.renderTags(), themeArn: this.themeArn, versionDescription: this.versionDescription };
      }
      renderProperties(props) {
        return cfnDashboardPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnDashboard[_b] = { fqn: "aws-cdk-lib.aws_quicksight.CfnDashboard", version: "2.80.0" }, CfnDashboard.CFN_RESOURCE_TYPE_NAME = "AWS::QuickSight::Dashboard", exports2.CfnDashboard = CfnDashboard;
    function CfnDashboard_AdHocFilteringOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availabilityStatus", cdk.validateString)(properties.availabilityStatus)), errors.wrap('supplied properties not correct for "AdHocFilteringOptionProperty"');
    }
    function cfnDashboardAdHocFilteringOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_AdHocFilteringOptionPropertyValidator(properties).assertSuccess(), { AvailabilityStatus: cdk.stringToCloudFormation(properties.availabilityStatus) }) : properties;
    }
    function CfnDashboardAdHocFilteringOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("availabilityStatus", "AvailabilityStatus", properties.AvailabilityStatus != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityStatus) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_AggregationFunctionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoricalAggregationFunction", cdk.validateString)(properties.categoricalAggregationFunction)), errors.collect(cdk.propertyValidator("dateAggregationFunction", cdk.validateString)(properties.dateAggregationFunction)), errors.collect(cdk.propertyValidator("numericalAggregationFunction", CfnDashboard_NumericalAggregationFunctionPropertyValidator)(properties.numericalAggregationFunction)), errors.wrap('supplied properties not correct for "AggregationFunctionProperty"');
    }
    function cfnDashboardAggregationFunctionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_AggregationFunctionPropertyValidator(properties).assertSuccess(), { CategoricalAggregationFunction: cdk.stringToCloudFormation(properties.categoricalAggregationFunction), DateAggregationFunction: cdk.stringToCloudFormation(properties.dateAggregationFunction), NumericalAggregationFunction: cfnDashboardNumericalAggregationFunctionPropertyToCloudFormation(properties.numericalAggregationFunction) }) : properties;
    }
    function CfnDashboardAggregationFunctionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoricalAggregationFunction", "CategoricalAggregationFunction", properties.CategoricalAggregationFunction != null ? cfn_parse.FromCloudFormation.getString(properties.CategoricalAggregationFunction) : void 0), ret.addPropertyResult("dateAggregationFunction", "DateAggregationFunction", properties.DateAggregationFunction != null ? cfn_parse.FromCloudFormation.getString(properties.DateAggregationFunction) : void 0), ret.addPropertyResult("numericalAggregationFunction", "NumericalAggregationFunction", properties.NumericalAggregationFunction != null ? CfnDashboardNumericalAggregationFunctionPropertyFromCloudFormation(properties.NumericalAggregationFunction) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_AggregationSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationFunction", cdk.requiredValidator)(properties.aggregationFunction)), errors.collect(cdk.propertyValidator("aggregationFunction", CfnDashboard_AggregationFunctionPropertyValidator)(properties.aggregationFunction)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnDashboard_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("sortDirection", cdk.requiredValidator)(properties.sortDirection)), errors.collect(cdk.propertyValidator("sortDirection", cdk.validateString)(properties.sortDirection)), errors.wrap('supplied properties not correct for "AggregationSortConfigurationProperty"');
    }
    function cfnDashboardAggregationSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_AggregationSortConfigurationPropertyValidator(properties).assertSuccess(), { AggregationFunction: cfnDashboardAggregationFunctionPropertyToCloudFormation(properties.aggregationFunction), Column: cfnDashboardColumnIdentifierPropertyToCloudFormation(properties.column), SortDirection: cdk.stringToCloudFormation(properties.sortDirection) }) : properties;
    }
    function CfnDashboardAggregationSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationFunction", "AggregationFunction", CfnDashboardAggregationFunctionPropertyFromCloudFormation(properties.AggregationFunction)), ret.addPropertyResult("column", "Column", CfnDashboardColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("sortDirection", "SortDirection", cfn_parse.FromCloudFormation.getString(properties.SortDirection)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_AnalysisDefaultsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultNewSheetConfiguration", cdk.requiredValidator)(properties.defaultNewSheetConfiguration)), errors.collect(cdk.propertyValidator("defaultNewSheetConfiguration", CfnDashboard_DefaultNewSheetConfigurationPropertyValidator)(properties.defaultNewSheetConfiguration)), errors.wrap('supplied properties not correct for "AnalysisDefaultsProperty"');
    }
    function cfnDashboardAnalysisDefaultsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_AnalysisDefaultsPropertyValidator(properties).assertSuccess(), { DefaultNewSheetConfiguration: cfnDashboardDefaultNewSheetConfigurationPropertyToCloudFormation(properties.defaultNewSheetConfiguration) }) : properties;
    }
    function CfnDashboardAnalysisDefaultsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultNewSheetConfiguration", "DefaultNewSheetConfiguration", CfnDashboardDefaultNewSheetConfigurationPropertyFromCloudFormation(properties.DefaultNewSheetConfiguration)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_AnchorDateConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("anchorOption", cdk.validateString)(properties.anchorOption)), errors.collect(cdk.propertyValidator("parameterName", cdk.validateString)(properties.parameterName)), errors.wrap('supplied properties not correct for "AnchorDateConfigurationProperty"');
    }
    function cfnDashboardAnchorDateConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_AnchorDateConfigurationPropertyValidator(properties).assertSuccess(), { AnchorOption: cdk.stringToCloudFormation(properties.anchorOption), ParameterName: cdk.stringToCloudFormation(properties.parameterName) }) : properties;
    }
    function CfnDashboardAnchorDateConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("anchorOption", "AnchorOption", properties.AnchorOption != null ? cfn_parse.FromCloudFormation.getString(properties.AnchorOption) : void 0), ret.addPropertyResult("parameterName", "ParameterName", properties.ParameterName != null ? cfn_parse.FromCloudFormation.getString(properties.ParameterName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ArcAxisConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("range", CfnDashboard_ArcAxisDisplayRangePropertyValidator)(properties.range)), errors.collect(cdk.propertyValidator("reserveRange", cdk.validateNumber)(properties.reserveRange)), errors.wrap('supplied properties not correct for "ArcAxisConfigurationProperty"');
    }
    function cfnDashboardArcAxisConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ArcAxisConfigurationPropertyValidator(properties).assertSuccess(), { Range: cfnDashboardArcAxisDisplayRangePropertyToCloudFormation(properties.range), ReserveRange: cdk.numberToCloudFormation(properties.reserveRange) }) : properties;
    }
    function CfnDashboardArcAxisConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("range", "Range", properties.Range != null ? CfnDashboardArcAxisDisplayRangePropertyFromCloudFormation(properties.Range) : void 0), ret.addPropertyResult("reserveRange", "ReserveRange", properties.ReserveRange != null ? cfn_parse.FromCloudFormation.getNumber(properties.ReserveRange) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ArcAxisDisplayRangePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "ArcAxisDisplayRangeProperty"');
    }
    function cfnDashboardArcAxisDisplayRangePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ArcAxisDisplayRangePropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnDashboardArcAxisDisplayRangePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ArcConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arcAngle", cdk.validateNumber)(properties.arcAngle)), errors.collect(cdk.propertyValidator("arcThickness", cdk.validateString)(properties.arcThickness)), errors.wrap('supplied properties not correct for "ArcConfigurationProperty"');
    }
    function cfnDashboardArcConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ArcConfigurationPropertyValidator(properties).assertSuccess(), { ArcAngle: cdk.numberToCloudFormation(properties.arcAngle), ArcThickness: cdk.stringToCloudFormation(properties.arcThickness) }) : properties;
    }
    function CfnDashboardArcConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arcAngle", "ArcAngle", properties.ArcAngle != null ? cfn_parse.FromCloudFormation.getNumber(properties.ArcAngle) : void 0), ret.addPropertyResult("arcThickness", "ArcThickness", properties.ArcThickness != null ? cfn_parse.FromCloudFormation.getString(properties.ArcThickness) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ArcOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arcThickness", cdk.validateString)(properties.arcThickness)), errors.wrap('supplied properties not correct for "ArcOptionsProperty"');
    }
    function cfnDashboardArcOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ArcOptionsPropertyValidator(properties).assertSuccess(), { ArcThickness: cdk.stringToCloudFormation(properties.arcThickness) }) : properties;
    }
    function CfnDashboardArcOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arcThickness", "ArcThickness", properties.ArcThickness != null ? cfn_parse.FromCloudFormation.getString(properties.ArcThickness) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_AxisDataOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateAxisOptions", CfnDashboard_DateAxisOptionsPropertyValidator)(properties.dateAxisOptions)), errors.collect(cdk.propertyValidator("numericAxisOptions", CfnDashboard_NumericAxisOptionsPropertyValidator)(properties.numericAxisOptions)), errors.wrap('supplied properties not correct for "AxisDataOptionsProperty"');
    }
    function cfnDashboardAxisDataOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_AxisDataOptionsPropertyValidator(properties).assertSuccess(), { DateAxisOptions: cfnDashboardDateAxisOptionsPropertyToCloudFormation(properties.dateAxisOptions), NumericAxisOptions: cfnDashboardNumericAxisOptionsPropertyToCloudFormation(properties.numericAxisOptions) }) : properties;
    }
    function CfnDashboardAxisDataOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateAxisOptions", "DateAxisOptions", properties.DateAxisOptions != null ? CfnDashboardDateAxisOptionsPropertyFromCloudFormation(properties.DateAxisOptions) : void 0), ret.addPropertyResult("numericAxisOptions", "NumericAxisOptions", properties.NumericAxisOptions != null ? CfnDashboardNumericAxisOptionsPropertyFromCloudFormation(properties.NumericAxisOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_AxisDisplayMinMaxRangePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maximum", cdk.validateNumber)(properties.maximum)), errors.collect(cdk.propertyValidator("minimum", cdk.validateNumber)(properties.minimum)), errors.wrap('supplied properties not correct for "AxisDisplayMinMaxRangeProperty"');
    }
    function cfnDashboardAxisDisplayMinMaxRangePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_AxisDisplayMinMaxRangePropertyValidator(properties).assertSuccess(), { Maximum: cdk.numberToCloudFormation(properties.maximum), Minimum: cdk.numberToCloudFormation(properties.minimum) }) : properties;
    }
    function CfnDashboardAxisDisplayMinMaxRangePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maximum", "Maximum", properties.Maximum != null ? cfn_parse.FromCloudFormation.getNumber(properties.Maximum) : void 0), ret.addPropertyResult("minimum", "Minimum", properties.Minimum != null ? cfn_parse.FromCloudFormation.getNumber(properties.Minimum) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_AxisDisplayOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("axisLineVisibility", cdk.validateString)(properties.axisLineVisibility)), errors.collect(cdk.propertyValidator("axisOffset", cdk.validateString)(properties.axisOffset)), errors.collect(cdk.propertyValidator("dataOptions", CfnDashboard_AxisDataOptionsPropertyValidator)(properties.dataOptions)), errors.collect(cdk.propertyValidator("gridLineVisibility", cdk.validateString)(properties.gridLineVisibility)), errors.collect(cdk.propertyValidator("scrollbarOptions", CfnDashboard_ScrollBarOptionsPropertyValidator)(properties.scrollbarOptions)), errors.collect(cdk.propertyValidator("tickLabelOptions", CfnDashboard_AxisTickLabelOptionsPropertyValidator)(properties.tickLabelOptions)), errors.wrap('supplied properties not correct for "AxisDisplayOptionsProperty"');
    }
    function cfnDashboardAxisDisplayOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_AxisDisplayOptionsPropertyValidator(properties).assertSuccess(), { AxisLineVisibility: cdk.stringToCloudFormation(properties.axisLineVisibility), AxisOffset: cdk.stringToCloudFormation(properties.axisOffset), DataOptions: cfnDashboardAxisDataOptionsPropertyToCloudFormation(properties.dataOptions), GridLineVisibility: cdk.stringToCloudFormation(properties.gridLineVisibility), ScrollbarOptions: cfnDashboardScrollBarOptionsPropertyToCloudFormation(properties.scrollbarOptions), TickLabelOptions: cfnDashboardAxisTickLabelOptionsPropertyToCloudFormation(properties.tickLabelOptions) }) : properties;
    }
    function CfnDashboardAxisDisplayOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("axisLineVisibility", "AxisLineVisibility", properties.AxisLineVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.AxisLineVisibility) : void 0), ret.addPropertyResult("axisOffset", "AxisOffset", properties.AxisOffset != null ? cfn_parse.FromCloudFormation.getString(properties.AxisOffset) : void 0), ret.addPropertyResult("dataOptions", "DataOptions", properties.DataOptions != null ? CfnDashboardAxisDataOptionsPropertyFromCloudFormation(properties.DataOptions) : void 0), ret.addPropertyResult("gridLineVisibility", "GridLineVisibility", properties.GridLineVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.GridLineVisibility) : void 0), ret.addPropertyResult("scrollbarOptions", "ScrollbarOptions", properties.ScrollbarOptions != null ? CfnDashboardScrollBarOptionsPropertyFromCloudFormation(properties.ScrollbarOptions) : void 0), ret.addPropertyResult("tickLabelOptions", "TickLabelOptions", properties.TickLabelOptions != null ? CfnDashboardAxisTickLabelOptionsPropertyFromCloudFormation(properties.TickLabelOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_AxisDisplayRangePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataDriven", cdk.validateObject)(properties.dataDriven)), errors.collect(cdk.propertyValidator("minMax", CfnDashboard_AxisDisplayMinMaxRangePropertyValidator)(properties.minMax)), errors.wrap('supplied properties not correct for "AxisDisplayRangeProperty"');
    }
    function cfnDashboardAxisDisplayRangePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_AxisDisplayRangePropertyValidator(properties).assertSuccess(), { DataDriven: cdk.objectToCloudFormation(properties.dataDriven), MinMax: cfnDashboardAxisDisplayMinMaxRangePropertyToCloudFormation(properties.minMax) }) : properties;
    }
    function CfnDashboardAxisDisplayRangePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataDriven", "DataDriven", properties.DataDriven != null ? cfn_parse.FromCloudFormation.getAny(properties.DataDriven) : void 0), ret.addPropertyResult("minMax", "MinMax", properties.MinMax != null ? CfnDashboardAxisDisplayMinMaxRangePropertyFromCloudFormation(properties.MinMax) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_AxisLabelOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applyTo", CfnDashboard_AxisLabelReferenceOptionsPropertyValidator)(properties.applyTo)), errors.collect(cdk.propertyValidator("customLabel", cdk.validateString)(properties.customLabel)), errors.collect(cdk.propertyValidator("fontConfiguration", CfnDashboard_FontConfigurationPropertyValidator)(properties.fontConfiguration)), errors.wrap('supplied properties not correct for "AxisLabelOptionsProperty"');
    }
    function cfnDashboardAxisLabelOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_AxisLabelOptionsPropertyValidator(properties).assertSuccess(), { ApplyTo: cfnDashboardAxisLabelReferenceOptionsPropertyToCloudFormation(properties.applyTo), CustomLabel: cdk.stringToCloudFormation(properties.customLabel), FontConfiguration: cfnDashboardFontConfigurationPropertyToCloudFormation(properties.fontConfiguration) }) : properties;
    }
    function CfnDashboardAxisLabelOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applyTo", "ApplyTo", properties.ApplyTo != null ? CfnDashboardAxisLabelReferenceOptionsPropertyFromCloudFormation(properties.ApplyTo) : void 0), ret.addPropertyResult("customLabel", "CustomLabel", properties.CustomLabel != null ? cfn_parse.FromCloudFormation.getString(properties.CustomLabel) : void 0), ret.addPropertyResult("fontConfiguration", "FontConfiguration", properties.FontConfiguration != null ? CfnDashboardFontConfigurationPropertyFromCloudFormation(properties.FontConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_AxisLabelReferenceOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnDashboard_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.wrap('supplied properties not correct for "AxisLabelReferenceOptionsProperty"');
    }
    function cfnDashboardAxisLabelReferenceOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_AxisLabelReferenceOptionsPropertyValidator(properties).assertSuccess(), { Column: cfnDashboardColumnIdentifierPropertyToCloudFormation(properties.column), FieldId: cdk.stringToCloudFormation(properties.fieldId) }) : properties;
    }
    function CfnDashboardAxisLabelReferenceOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", CfnDashboardColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_AxisLinearScalePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("stepCount", cdk.validateNumber)(properties.stepCount)), errors.collect(cdk.propertyValidator("stepSize", cdk.validateNumber)(properties.stepSize)), errors.wrap('supplied properties not correct for "AxisLinearScaleProperty"');
    }
    function cfnDashboardAxisLinearScalePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_AxisLinearScalePropertyValidator(properties).assertSuccess(), { StepCount: cdk.numberToCloudFormation(properties.stepCount), StepSize: cdk.numberToCloudFormation(properties.stepSize) }) : properties;
    }
    function CfnDashboardAxisLinearScalePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("stepCount", "StepCount", properties.StepCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.StepCount) : void 0), ret.addPropertyResult("stepSize", "StepSize", properties.StepSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.StepSize) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_AxisLogarithmicScalePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("base", cdk.validateNumber)(properties.base)), errors.wrap('supplied properties not correct for "AxisLogarithmicScaleProperty"');
    }
    function cfnDashboardAxisLogarithmicScalePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_AxisLogarithmicScalePropertyValidator(properties).assertSuccess(), { Base: cdk.numberToCloudFormation(properties.base) }) : properties;
    }
    function CfnDashboardAxisLogarithmicScalePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("base", "Base", properties.Base != null ? cfn_parse.FromCloudFormation.getNumber(properties.Base) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_AxisScalePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("linear", CfnDashboard_AxisLinearScalePropertyValidator)(properties.linear)), errors.collect(cdk.propertyValidator("logarithmic", CfnDashboard_AxisLogarithmicScalePropertyValidator)(properties.logarithmic)), errors.wrap('supplied properties not correct for "AxisScaleProperty"');
    }
    function cfnDashboardAxisScalePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_AxisScalePropertyValidator(properties).assertSuccess(), { Linear: cfnDashboardAxisLinearScalePropertyToCloudFormation(properties.linear), Logarithmic: cfnDashboardAxisLogarithmicScalePropertyToCloudFormation(properties.logarithmic) }) : properties;
    }
    function CfnDashboardAxisScalePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("linear", "Linear", properties.Linear != null ? CfnDashboardAxisLinearScalePropertyFromCloudFormation(properties.Linear) : void 0), ret.addPropertyResult("logarithmic", "Logarithmic", properties.Logarithmic != null ? CfnDashboardAxisLogarithmicScalePropertyFromCloudFormation(properties.Logarithmic) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_AxisTickLabelOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("labelOptions", CfnDashboard_LabelOptionsPropertyValidator)(properties.labelOptions)), errors.collect(cdk.propertyValidator("rotationAngle", cdk.validateNumber)(properties.rotationAngle)), errors.wrap('supplied properties not correct for "AxisTickLabelOptionsProperty"');
    }
    function cfnDashboardAxisTickLabelOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_AxisTickLabelOptionsPropertyValidator(properties).assertSuccess(), { LabelOptions: cfnDashboardLabelOptionsPropertyToCloudFormation(properties.labelOptions), RotationAngle: cdk.numberToCloudFormation(properties.rotationAngle) }) : properties;
    }
    function CfnDashboardAxisTickLabelOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("labelOptions", "LabelOptions", properties.LabelOptions != null ? CfnDashboardLabelOptionsPropertyFromCloudFormation(properties.LabelOptions) : void 0), ret.addPropertyResult("rotationAngle", "RotationAngle", properties.RotationAngle != null ? cfn_parse.FromCloudFormation.getNumber(properties.RotationAngle) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_BarChartAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("category", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.category)), errors.collect(cdk.propertyValidator("colors", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.colors)), errors.collect(cdk.propertyValidator("smallMultiples", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.smallMultiples)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnDashboard_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "BarChartAggregatedFieldWellsProperty"');
    }
    function cfnDashboardBarChartAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_BarChartAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Category: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.category), Colors: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.colors), SmallMultiples: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.smallMultiples), Values: cdk.listMapper(cfnDashboardMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnDashboardBarChartAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("category", "Category", properties.Category != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.Category) : void 0), ret.addPropertyResult("colors", "Colors", properties.Colors != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.Colors) : void 0), ret.addPropertyResult("smallMultiples", "SmallMultiples", properties.SmallMultiples != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.SmallMultiples) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_BarChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("barsArrangement", cdk.validateString)(properties.barsArrangement)), errors.collect(cdk.propertyValidator("categoryAxis", CfnDashboard_AxisDisplayOptionsPropertyValidator)(properties.categoryAxis)), errors.collect(cdk.propertyValidator("categoryLabelOptions", CfnDashboard_ChartAxisLabelOptionsPropertyValidator)(properties.categoryLabelOptions)), errors.collect(cdk.propertyValidator("colorLabelOptions", CfnDashboard_ChartAxisLabelOptionsPropertyValidator)(properties.colorLabelOptions)), errors.collect(cdk.propertyValidator("contributionAnalysisDefaults", cdk.listValidator(CfnDashboard_ContributionAnalysisDefaultPropertyValidator))(properties.contributionAnalysisDefaults)), errors.collect(cdk.propertyValidator("dataLabels", CfnDashboard_DataLabelOptionsPropertyValidator)(properties.dataLabels)), errors.collect(cdk.propertyValidator("fieldWells", CfnDashboard_BarChartFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("legend", CfnDashboard_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("orientation", cdk.validateString)(properties.orientation)), errors.collect(cdk.propertyValidator("referenceLines", cdk.listValidator(CfnDashboard_ReferenceLinePropertyValidator))(properties.referenceLines)), errors.collect(cdk.propertyValidator("smallMultiplesOptions", CfnDashboard_SmallMultiplesOptionsPropertyValidator)(properties.smallMultiplesOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnDashboard_BarChartSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tooltip", CfnDashboard_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.collect(cdk.propertyValidator("valueAxis", CfnDashboard_AxisDisplayOptionsPropertyValidator)(properties.valueAxis)), errors.collect(cdk.propertyValidator("valueLabelOptions", CfnDashboard_ChartAxisLabelOptionsPropertyValidator)(properties.valueLabelOptions)), errors.collect(cdk.propertyValidator("visualPalette", CfnDashboard_VisualPalettePropertyValidator)(properties.visualPalette)), errors.wrap('supplied properties not correct for "BarChartConfigurationProperty"');
    }
    function cfnDashboardBarChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_BarChartConfigurationPropertyValidator(properties).assertSuccess(), { BarsArrangement: cdk.stringToCloudFormation(properties.barsArrangement), CategoryAxis: cfnDashboardAxisDisplayOptionsPropertyToCloudFormation(properties.categoryAxis), CategoryLabelOptions: cfnDashboardChartAxisLabelOptionsPropertyToCloudFormation(properties.categoryLabelOptions), ColorLabelOptions: cfnDashboardChartAxisLabelOptionsPropertyToCloudFormation(properties.colorLabelOptions), ContributionAnalysisDefaults: cdk.listMapper(cfnDashboardContributionAnalysisDefaultPropertyToCloudFormation)(properties.contributionAnalysisDefaults), DataLabels: cfnDashboardDataLabelOptionsPropertyToCloudFormation(properties.dataLabels), FieldWells: cfnDashboardBarChartFieldWellsPropertyToCloudFormation(properties.fieldWells), Legend: cfnDashboardLegendOptionsPropertyToCloudFormation(properties.legend), Orientation: cdk.stringToCloudFormation(properties.orientation), ReferenceLines: cdk.listMapper(cfnDashboardReferenceLinePropertyToCloudFormation)(properties.referenceLines), SmallMultiplesOptions: cfnDashboardSmallMultiplesOptionsPropertyToCloudFormation(properties.smallMultiplesOptions), SortConfiguration: cfnDashboardBarChartSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), Tooltip: cfnDashboardTooltipOptionsPropertyToCloudFormation(properties.tooltip), ValueAxis: cfnDashboardAxisDisplayOptionsPropertyToCloudFormation(properties.valueAxis), ValueLabelOptions: cfnDashboardChartAxisLabelOptionsPropertyToCloudFormation(properties.valueLabelOptions), VisualPalette: cfnDashboardVisualPalettePropertyToCloudFormation(properties.visualPalette) }) : properties;
    }
    function CfnDashboardBarChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("barsArrangement", "BarsArrangement", properties.BarsArrangement != null ? cfn_parse.FromCloudFormation.getString(properties.BarsArrangement) : void 0), ret.addPropertyResult("categoryAxis", "CategoryAxis", properties.CategoryAxis != null ? CfnDashboardAxisDisplayOptionsPropertyFromCloudFormation(properties.CategoryAxis) : void 0), ret.addPropertyResult("categoryLabelOptions", "CategoryLabelOptions", properties.CategoryLabelOptions != null ? CfnDashboardChartAxisLabelOptionsPropertyFromCloudFormation(properties.CategoryLabelOptions) : void 0), ret.addPropertyResult("colorLabelOptions", "ColorLabelOptions", properties.ColorLabelOptions != null ? CfnDashboardChartAxisLabelOptionsPropertyFromCloudFormation(properties.ColorLabelOptions) : void 0), ret.addPropertyResult("contributionAnalysisDefaults", "ContributionAnalysisDefaults", properties.ContributionAnalysisDefaults != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardContributionAnalysisDefaultPropertyFromCloudFormation)(properties.ContributionAnalysisDefaults) : void 0), ret.addPropertyResult("dataLabels", "DataLabels", properties.DataLabels != null ? CfnDashboardDataLabelOptionsPropertyFromCloudFormation(properties.DataLabels) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnDashboardBarChartFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnDashboardLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("orientation", "Orientation", properties.Orientation != null ? cfn_parse.FromCloudFormation.getString(properties.Orientation) : void 0), ret.addPropertyResult("referenceLines", "ReferenceLines", properties.ReferenceLines != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardReferenceLinePropertyFromCloudFormation)(properties.ReferenceLines) : void 0), ret.addPropertyResult("smallMultiplesOptions", "SmallMultiplesOptions", properties.SmallMultiplesOptions != null ? CfnDashboardSmallMultiplesOptionsPropertyFromCloudFormation(properties.SmallMultiplesOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnDashboardBarChartSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnDashboardTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addPropertyResult("valueAxis", "ValueAxis", properties.ValueAxis != null ? CfnDashboardAxisDisplayOptionsPropertyFromCloudFormation(properties.ValueAxis) : void 0), ret.addPropertyResult("valueLabelOptions", "ValueLabelOptions", properties.ValueLabelOptions != null ? CfnDashboardChartAxisLabelOptionsPropertyFromCloudFormation(properties.ValueLabelOptions) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnDashboardVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_BarChartFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("barChartAggregatedFieldWells", CfnDashboard_BarChartAggregatedFieldWellsPropertyValidator)(properties.barChartAggregatedFieldWells)), errors.wrap('supplied properties not correct for "BarChartFieldWellsProperty"');
    }
    function cfnDashboardBarChartFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_BarChartFieldWellsPropertyValidator(properties).assertSuccess(), { BarChartAggregatedFieldWells: cfnDashboardBarChartAggregatedFieldWellsPropertyToCloudFormation(properties.barChartAggregatedFieldWells) }) : properties;
    }
    function CfnDashboardBarChartFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("barChartAggregatedFieldWells", "BarChartAggregatedFieldWells", properties.BarChartAggregatedFieldWells != null ? CfnDashboardBarChartAggregatedFieldWellsPropertyFromCloudFormation(properties.BarChartAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_BarChartSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryItemsLimit", CfnDashboard_ItemsLimitConfigurationPropertyValidator)(properties.categoryItemsLimit)), errors.collect(cdk.propertyValidator("categorySort", cdk.listValidator(CfnDashboard_FieldSortOptionsPropertyValidator))(properties.categorySort)), errors.collect(cdk.propertyValidator("colorItemsLimit", CfnDashboard_ItemsLimitConfigurationPropertyValidator)(properties.colorItemsLimit)), errors.collect(cdk.propertyValidator("colorSort", cdk.listValidator(CfnDashboard_FieldSortOptionsPropertyValidator))(properties.colorSort)), errors.collect(cdk.propertyValidator("smallMultiplesLimitConfiguration", CfnDashboard_ItemsLimitConfigurationPropertyValidator)(properties.smallMultiplesLimitConfiguration)), errors.collect(cdk.propertyValidator("smallMultiplesSort", cdk.listValidator(CfnDashboard_FieldSortOptionsPropertyValidator))(properties.smallMultiplesSort)), errors.wrap('supplied properties not correct for "BarChartSortConfigurationProperty"');
    }
    function cfnDashboardBarChartSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_BarChartSortConfigurationPropertyValidator(properties).assertSuccess(), { CategoryItemsLimit: cfnDashboardItemsLimitConfigurationPropertyToCloudFormation(properties.categoryItemsLimit), CategorySort: cdk.listMapper(cfnDashboardFieldSortOptionsPropertyToCloudFormation)(properties.categorySort), ColorItemsLimit: cfnDashboardItemsLimitConfigurationPropertyToCloudFormation(properties.colorItemsLimit), ColorSort: cdk.listMapper(cfnDashboardFieldSortOptionsPropertyToCloudFormation)(properties.colorSort), SmallMultiplesLimitConfiguration: cfnDashboardItemsLimitConfigurationPropertyToCloudFormation(properties.smallMultiplesLimitConfiguration), SmallMultiplesSort: cdk.listMapper(cfnDashboardFieldSortOptionsPropertyToCloudFormation)(properties.smallMultiplesSort) }) : properties;
    }
    function CfnDashboardBarChartSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryItemsLimit", "CategoryItemsLimit", properties.CategoryItemsLimit != null ? CfnDashboardItemsLimitConfigurationPropertyFromCloudFormation(properties.CategoryItemsLimit) : void 0), ret.addPropertyResult("categorySort", "CategorySort", properties.CategorySort != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardFieldSortOptionsPropertyFromCloudFormation)(properties.CategorySort) : void 0), ret.addPropertyResult("colorItemsLimit", "ColorItemsLimit", properties.ColorItemsLimit != null ? CfnDashboardItemsLimitConfigurationPropertyFromCloudFormation(properties.ColorItemsLimit) : void 0), ret.addPropertyResult("colorSort", "ColorSort", properties.ColorSort != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardFieldSortOptionsPropertyFromCloudFormation)(properties.ColorSort) : void 0), ret.addPropertyResult("smallMultiplesLimitConfiguration", "SmallMultiplesLimitConfiguration", properties.SmallMultiplesLimitConfiguration != null ? CfnDashboardItemsLimitConfigurationPropertyFromCloudFormation(properties.SmallMultiplesLimitConfiguration) : void 0), ret.addPropertyResult("smallMultiplesSort", "SmallMultiplesSort", properties.SmallMultiplesSort != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardFieldSortOptionsPropertyFromCloudFormation)(properties.SmallMultiplesSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_BarChartVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnDashboard_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnDashboard_BarChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnDashboard_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnDashboard_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnDashboard_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "BarChartVisualProperty"');
    }
    function cfnDashboardBarChartVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_BarChartVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnDashboardVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnDashboardBarChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnDashboardColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnDashboardVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnDashboardVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnDashboardBarChartVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnDashboardBarChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnDashboardVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnDashboardVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_BinCountOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "BinCountOptionsProperty"');
    }
    function cfnDashboardBinCountOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_BinCountOptionsPropertyValidator(properties).assertSuccess(), { Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnDashboardBinCountOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getNumber(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_BinWidthOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("binCountLimit", cdk.validateNumber)(properties.binCountLimit)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "BinWidthOptionsProperty"');
    }
    function cfnDashboardBinWidthOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_BinWidthOptionsPropertyValidator(properties).assertSuccess(), { BinCountLimit: cdk.numberToCloudFormation(properties.binCountLimit), Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnDashboardBinWidthOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("binCountLimit", "BinCountLimit", properties.BinCountLimit != null ? cfn_parse.FromCloudFormation.getNumber(properties.BinCountLimit) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getNumber(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_BodySectionConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("content", cdk.requiredValidator)(properties.content)), errors.collect(cdk.propertyValidator("content", CfnDashboard_BodySectionContentPropertyValidator)(properties.content)), errors.collect(cdk.propertyValidator("pageBreakConfiguration", CfnDashboard_SectionPageBreakConfigurationPropertyValidator)(properties.pageBreakConfiguration)), errors.collect(cdk.propertyValidator("sectionId", cdk.requiredValidator)(properties.sectionId)), errors.collect(cdk.propertyValidator("sectionId", cdk.validateString)(properties.sectionId)), errors.collect(cdk.propertyValidator("style", CfnDashboard_SectionStylePropertyValidator)(properties.style)), errors.wrap('supplied properties not correct for "BodySectionConfigurationProperty"');
    }
    function cfnDashboardBodySectionConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_BodySectionConfigurationPropertyValidator(properties).assertSuccess(), { Content: cfnDashboardBodySectionContentPropertyToCloudFormation(properties.content), PageBreakConfiguration: cfnDashboardSectionPageBreakConfigurationPropertyToCloudFormation(properties.pageBreakConfiguration), SectionId: cdk.stringToCloudFormation(properties.sectionId), Style: cfnDashboardSectionStylePropertyToCloudFormation(properties.style) }) : properties;
    }
    function CfnDashboardBodySectionConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("content", "Content", CfnDashboardBodySectionContentPropertyFromCloudFormation(properties.Content)), ret.addPropertyResult("pageBreakConfiguration", "PageBreakConfiguration", properties.PageBreakConfiguration != null ? CfnDashboardSectionPageBreakConfigurationPropertyFromCloudFormation(properties.PageBreakConfiguration) : void 0), ret.addPropertyResult("sectionId", "SectionId", cfn_parse.FromCloudFormation.getString(properties.SectionId)), ret.addPropertyResult("style", "Style", properties.Style != null ? CfnDashboardSectionStylePropertyFromCloudFormation(properties.Style) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_BodySectionContentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("layout", CfnDashboard_SectionLayoutConfigurationPropertyValidator)(properties.layout)), errors.wrap('supplied properties not correct for "BodySectionContentProperty"');
    }
    function cfnDashboardBodySectionContentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_BodySectionContentPropertyValidator(properties).assertSuccess(), { Layout: cfnDashboardSectionLayoutConfigurationPropertyToCloudFormation(properties.layout) }) : properties;
    }
    function CfnDashboardBodySectionContentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("layout", "Layout", properties.Layout != null ? CfnDashboardSectionLayoutConfigurationPropertyFromCloudFormation(properties.Layout) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_BoxPlotAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groupBy", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.groupBy)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnDashboard_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "BoxPlotAggregatedFieldWellsProperty"');
    }
    function cfnDashboardBoxPlotAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_BoxPlotAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { GroupBy: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.groupBy), Values: cdk.listMapper(cfnDashboardMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnDashboardBoxPlotAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupBy", "GroupBy", properties.GroupBy != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.GroupBy) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_BoxPlotChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("boxPlotOptions", CfnDashboard_BoxPlotOptionsPropertyValidator)(properties.boxPlotOptions)), errors.collect(cdk.propertyValidator("categoryAxis", CfnDashboard_AxisDisplayOptionsPropertyValidator)(properties.categoryAxis)), errors.collect(cdk.propertyValidator("categoryLabelOptions", CfnDashboard_ChartAxisLabelOptionsPropertyValidator)(properties.categoryLabelOptions)), errors.collect(cdk.propertyValidator("fieldWells", CfnDashboard_BoxPlotFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("legend", CfnDashboard_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("primaryYAxisDisplayOptions", CfnDashboard_AxisDisplayOptionsPropertyValidator)(properties.primaryYAxisDisplayOptions)), errors.collect(cdk.propertyValidator("primaryYAxisLabelOptions", CfnDashboard_ChartAxisLabelOptionsPropertyValidator)(properties.primaryYAxisLabelOptions)), errors.collect(cdk.propertyValidator("referenceLines", cdk.listValidator(CfnDashboard_ReferenceLinePropertyValidator))(properties.referenceLines)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnDashboard_BoxPlotSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tooltip", CfnDashboard_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.collect(cdk.propertyValidator("visualPalette", CfnDashboard_VisualPalettePropertyValidator)(properties.visualPalette)), errors.wrap('supplied properties not correct for "BoxPlotChartConfigurationProperty"');
    }
    function cfnDashboardBoxPlotChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_BoxPlotChartConfigurationPropertyValidator(properties).assertSuccess(), { BoxPlotOptions: cfnDashboardBoxPlotOptionsPropertyToCloudFormation(properties.boxPlotOptions), CategoryAxis: cfnDashboardAxisDisplayOptionsPropertyToCloudFormation(properties.categoryAxis), CategoryLabelOptions: cfnDashboardChartAxisLabelOptionsPropertyToCloudFormation(properties.categoryLabelOptions), FieldWells: cfnDashboardBoxPlotFieldWellsPropertyToCloudFormation(properties.fieldWells), Legend: cfnDashboardLegendOptionsPropertyToCloudFormation(properties.legend), PrimaryYAxisDisplayOptions: cfnDashboardAxisDisplayOptionsPropertyToCloudFormation(properties.primaryYAxisDisplayOptions), PrimaryYAxisLabelOptions: cfnDashboardChartAxisLabelOptionsPropertyToCloudFormation(properties.primaryYAxisLabelOptions), ReferenceLines: cdk.listMapper(cfnDashboardReferenceLinePropertyToCloudFormation)(properties.referenceLines), SortConfiguration: cfnDashboardBoxPlotSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), Tooltip: cfnDashboardTooltipOptionsPropertyToCloudFormation(properties.tooltip), VisualPalette: cfnDashboardVisualPalettePropertyToCloudFormation(properties.visualPalette) }) : properties;
    }
    function CfnDashboardBoxPlotChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("boxPlotOptions", "BoxPlotOptions", properties.BoxPlotOptions != null ? CfnDashboardBoxPlotOptionsPropertyFromCloudFormation(properties.BoxPlotOptions) : void 0), ret.addPropertyResult("categoryAxis", "CategoryAxis", properties.CategoryAxis != null ? CfnDashboardAxisDisplayOptionsPropertyFromCloudFormation(properties.CategoryAxis) : void 0), ret.addPropertyResult("categoryLabelOptions", "CategoryLabelOptions", properties.CategoryLabelOptions != null ? CfnDashboardChartAxisLabelOptionsPropertyFromCloudFormation(properties.CategoryLabelOptions) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnDashboardBoxPlotFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnDashboardLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("primaryYAxisDisplayOptions", "PrimaryYAxisDisplayOptions", properties.PrimaryYAxisDisplayOptions != null ? CfnDashboardAxisDisplayOptionsPropertyFromCloudFormation(properties.PrimaryYAxisDisplayOptions) : void 0), ret.addPropertyResult("primaryYAxisLabelOptions", "PrimaryYAxisLabelOptions", properties.PrimaryYAxisLabelOptions != null ? CfnDashboardChartAxisLabelOptionsPropertyFromCloudFormation(properties.PrimaryYAxisLabelOptions) : void 0), ret.addPropertyResult("referenceLines", "ReferenceLines", properties.ReferenceLines != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardReferenceLinePropertyFromCloudFormation)(properties.ReferenceLines) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnDashboardBoxPlotSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnDashboardTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnDashboardVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_BoxPlotFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("boxPlotAggregatedFieldWells", CfnDashboard_BoxPlotAggregatedFieldWellsPropertyValidator)(properties.boxPlotAggregatedFieldWells)), errors.wrap('supplied properties not correct for "BoxPlotFieldWellsProperty"');
    }
    function cfnDashboardBoxPlotFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_BoxPlotFieldWellsPropertyValidator(properties).assertSuccess(), { BoxPlotAggregatedFieldWells: cfnDashboardBoxPlotAggregatedFieldWellsPropertyToCloudFormation(properties.boxPlotAggregatedFieldWells) }) : properties;
    }
    function CfnDashboardBoxPlotFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("boxPlotAggregatedFieldWells", "BoxPlotAggregatedFieldWells", properties.BoxPlotAggregatedFieldWells != null ? CfnDashboardBoxPlotAggregatedFieldWellsPropertyFromCloudFormation(properties.BoxPlotAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_BoxPlotOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allDataPointsVisibility", cdk.validateString)(properties.allDataPointsVisibility)), errors.collect(cdk.propertyValidator("outlierVisibility", cdk.validateString)(properties.outlierVisibility)), errors.collect(cdk.propertyValidator("styleOptions", CfnDashboard_BoxPlotStyleOptionsPropertyValidator)(properties.styleOptions)), errors.wrap('supplied properties not correct for "BoxPlotOptionsProperty"');
    }
    function cfnDashboardBoxPlotOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_BoxPlotOptionsPropertyValidator(properties).assertSuccess(), { AllDataPointsVisibility: cdk.stringToCloudFormation(properties.allDataPointsVisibility), OutlierVisibility: cdk.stringToCloudFormation(properties.outlierVisibility), StyleOptions: cfnDashboardBoxPlotStyleOptionsPropertyToCloudFormation(properties.styleOptions) }) : properties;
    }
    function CfnDashboardBoxPlotOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allDataPointsVisibility", "AllDataPointsVisibility", properties.AllDataPointsVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.AllDataPointsVisibility) : void 0), ret.addPropertyResult("outlierVisibility", "OutlierVisibility", properties.OutlierVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.OutlierVisibility) : void 0), ret.addPropertyResult("styleOptions", "StyleOptions", properties.StyleOptions != null ? CfnDashboardBoxPlotStyleOptionsPropertyFromCloudFormation(properties.StyleOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_BoxPlotSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categorySort", cdk.listValidator(CfnDashboard_FieldSortOptionsPropertyValidator))(properties.categorySort)), errors.collect(cdk.propertyValidator("paginationConfiguration", CfnDashboard_PaginationConfigurationPropertyValidator)(properties.paginationConfiguration)), errors.wrap('supplied properties not correct for "BoxPlotSortConfigurationProperty"');
    }
    function cfnDashboardBoxPlotSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_BoxPlotSortConfigurationPropertyValidator(properties).assertSuccess(), { CategorySort: cdk.listMapper(cfnDashboardFieldSortOptionsPropertyToCloudFormation)(properties.categorySort), PaginationConfiguration: cfnDashboardPaginationConfigurationPropertyToCloudFormation(properties.paginationConfiguration) }) : properties;
    }
    function CfnDashboardBoxPlotSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categorySort", "CategorySort", properties.CategorySort != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardFieldSortOptionsPropertyFromCloudFormation)(properties.CategorySort) : void 0), ret.addPropertyResult("paginationConfiguration", "PaginationConfiguration", properties.PaginationConfiguration != null ? CfnDashboardPaginationConfigurationPropertyFromCloudFormation(properties.PaginationConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_BoxPlotStyleOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fillStyle", cdk.validateString)(properties.fillStyle)), errors.wrap('supplied properties not correct for "BoxPlotStyleOptionsProperty"');
    }
    function cfnDashboardBoxPlotStyleOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_BoxPlotStyleOptionsPropertyValidator(properties).assertSuccess(), { FillStyle: cdk.stringToCloudFormation(properties.fillStyle) }) : properties;
    }
    function CfnDashboardBoxPlotStyleOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fillStyle", "FillStyle", properties.FillStyle != null ? cfn_parse.FromCloudFormation.getString(properties.FillStyle) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_BoxPlotVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnDashboard_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnDashboard_BoxPlotChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnDashboard_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnDashboard_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnDashboard_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "BoxPlotVisualProperty"');
    }
    function cfnDashboardBoxPlotVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_BoxPlotVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnDashboardVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnDashboardBoxPlotChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnDashboardColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnDashboardVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnDashboardVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnDashboardBoxPlotVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnDashboardBoxPlotChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnDashboardVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnDashboardVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_CalculatedFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.requiredValidator)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.validateString)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "CalculatedFieldProperty"');
    }
    function cfnDashboardCalculatedFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_CalculatedFieldPropertyValidator(properties).assertSuccess(), { DataSetIdentifier: cdk.stringToCloudFormation(properties.dataSetIdentifier), Expression: cdk.stringToCloudFormation(properties.expression), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnDashboardCalculatedFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataSetIdentifier", "DataSetIdentifier", cfn_parse.FromCloudFormation.getString(properties.DataSetIdentifier)), ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getString(properties.Expression)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_CalculatedMeasureFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.wrap('supplied properties not correct for "CalculatedMeasureFieldProperty"');
    }
    function cfnDashboardCalculatedMeasureFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_CalculatedMeasureFieldPropertyValidator(properties).assertSuccess(), { Expression: cdk.stringToCloudFormation(properties.expression), FieldId: cdk.stringToCloudFormation(properties.fieldId) }) : properties;
    }
    function CfnDashboardCalculatedMeasureFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getString(properties.Expression)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_CascadingControlConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sourceControls", cdk.listValidator(CfnDashboard_CascadingControlSourcePropertyValidator))(properties.sourceControls)), errors.wrap('supplied properties not correct for "CascadingControlConfigurationProperty"');
    }
    function cfnDashboardCascadingControlConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_CascadingControlConfigurationPropertyValidator(properties).assertSuccess(), { SourceControls: cdk.listMapper(cfnDashboardCascadingControlSourcePropertyToCloudFormation)(properties.sourceControls) }) : properties;
    }
    function CfnDashboardCascadingControlConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sourceControls", "SourceControls", properties.SourceControls != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardCascadingControlSourcePropertyFromCloudFormation)(properties.SourceControls) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_CascadingControlSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnToMatch", CfnDashboard_ColumnIdentifierPropertyValidator)(properties.columnToMatch)), errors.collect(cdk.propertyValidator("sourceSheetControlId", cdk.validateString)(properties.sourceSheetControlId)), errors.wrap('supplied properties not correct for "CascadingControlSourceProperty"');
    }
    function cfnDashboardCascadingControlSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_CascadingControlSourcePropertyValidator(properties).assertSuccess(), { ColumnToMatch: cfnDashboardColumnIdentifierPropertyToCloudFormation(properties.columnToMatch), SourceSheetControlId: cdk.stringToCloudFormation(properties.sourceSheetControlId) }) : properties;
    }
    function CfnDashboardCascadingControlSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columnToMatch", "ColumnToMatch", properties.ColumnToMatch != null ? CfnDashboardColumnIdentifierPropertyFromCloudFormation(properties.ColumnToMatch) : void 0), ret.addPropertyResult("sourceSheetControlId", "SourceSheetControlId", properties.SourceSheetControlId != null ? cfn_parse.FromCloudFormation.getString(properties.SourceSheetControlId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_CategoricalDimensionFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnDashboard_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("formatConfiguration", CfnDashboard_StringFormatConfigurationPropertyValidator)(properties.formatConfiguration)), errors.collect(cdk.propertyValidator("hierarchyId", cdk.validateString)(properties.hierarchyId)), errors.wrap('supplied properties not correct for "CategoricalDimensionFieldProperty"');
    }
    function cfnDashboardCategoricalDimensionFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_CategoricalDimensionFieldPropertyValidator(properties).assertSuccess(), { Column: cfnDashboardColumnIdentifierPropertyToCloudFormation(properties.column), FieldId: cdk.stringToCloudFormation(properties.fieldId), FormatConfiguration: cfnDashboardStringFormatConfigurationPropertyToCloudFormation(properties.formatConfiguration), HierarchyId: cdk.stringToCloudFormation(properties.hierarchyId) }) : properties;
    }
    function CfnDashboardCategoricalDimensionFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", CfnDashboardColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("formatConfiguration", "FormatConfiguration", properties.FormatConfiguration != null ? CfnDashboardStringFormatConfigurationPropertyFromCloudFormation(properties.FormatConfiguration) : void 0), ret.addPropertyResult("hierarchyId", "HierarchyId", properties.HierarchyId != null ? cfn_parse.FromCloudFormation.getString(properties.HierarchyId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_CategoricalMeasureFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationFunction", cdk.validateString)(properties.aggregationFunction)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnDashboard_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("formatConfiguration", CfnDashboard_StringFormatConfigurationPropertyValidator)(properties.formatConfiguration)), errors.wrap('supplied properties not correct for "CategoricalMeasureFieldProperty"');
    }
    function cfnDashboardCategoricalMeasureFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_CategoricalMeasureFieldPropertyValidator(properties).assertSuccess(), { AggregationFunction: cdk.stringToCloudFormation(properties.aggregationFunction), Column: cfnDashboardColumnIdentifierPropertyToCloudFormation(properties.column), FieldId: cdk.stringToCloudFormation(properties.fieldId), FormatConfiguration: cfnDashboardStringFormatConfigurationPropertyToCloudFormation(properties.formatConfiguration) }) : properties;
    }
    function CfnDashboardCategoricalMeasureFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationFunction", "AggregationFunction", properties.AggregationFunction != null ? cfn_parse.FromCloudFormation.getString(properties.AggregationFunction) : void 0), ret.addPropertyResult("column", "Column", CfnDashboardColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("formatConfiguration", "FormatConfiguration", properties.FormatConfiguration != null ? CfnDashboardStringFormatConfigurationPropertyFromCloudFormation(properties.FormatConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_CategoryDrillDownFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryValues", cdk.requiredValidator)(properties.categoryValues)), errors.collect(cdk.propertyValidator("categoryValues", cdk.listValidator(cdk.validateString))(properties.categoryValues)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnDashboard_ColumnIdentifierPropertyValidator)(properties.column)), errors.wrap('supplied properties not correct for "CategoryDrillDownFilterProperty"');
    }
    function cfnDashboardCategoryDrillDownFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_CategoryDrillDownFilterPropertyValidator(properties).assertSuccess(), { CategoryValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.categoryValues), Column: cfnDashboardColumnIdentifierPropertyToCloudFormation(properties.column) }) : properties;
    }
    function CfnDashboardCategoryDrillDownFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryValues", "CategoryValues", cfn_parse.FromCloudFormation.getStringArray(properties.CategoryValues)), ret.addPropertyResult("column", "Column", CfnDashboardColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_CategoryFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnDashboard_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("configuration", cdk.requiredValidator)(properties.configuration)), errors.collect(cdk.propertyValidator("configuration", CfnDashboard_CategoryFilterConfigurationPropertyValidator)(properties.configuration)), errors.collect(cdk.propertyValidator("filterId", cdk.requiredValidator)(properties.filterId)), errors.collect(cdk.propertyValidator("filterId", cdk.validateString)(properties.filterId)), errors.wrap('supplied properties not correct for "CategoryFilterProperty"');
    }
    function cfnDashboardCategoryFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_CategoryFilterPropertyValidator(properties).assertSuccess(), { Column: cfnDashboardColumnIdentifierPropertyToCloudFormation(properties.column), Configuration: cfnDashboardCategoryFilterConfigurationPropertyToCloudFormation(properties.configuration), FilterId: cdk.stringToCloudFormation(properties.filterId) }) : properties;
    }
    function CfnDashboardCategoryFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", CfnDashboardColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("configuration", "Configuration", CfnDashboardCategoryFilterConfigurationPropertyFromCloudFormation(properties.Configuration)), ret.addPropertyResult("filterId", "FilterId", cfn_parse.FromCloudFormation.getString(properties.FilterId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_CategoryFilterConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customFilterConfiguration", CfnDashboard_CustomFilterConfigurationPropertyValidator)(properties.customFilterConfiguration)), errors.collect(cdk.propertyValidator("customFilterListConfiguration", CfnDashboard_CustomFilterListConfigurationPropertyValidator)(properties.customFilterListConfiguration)), errors.collect(cdk.propertyValidator("filterListConfiguration", CfnDashboard_FilterListConfigurationPropertyValidator)(properties.filterListConfiguration)), errors.wrap('supplied properties not correct for "CategoryFilterConfigurationProperty"');
    }
    function cfnDashboardCategoryFilterConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_CategoryFilterConfigurationPropertyValidator(properties).assertSuccess(), { CustomFilterConfiguration: cfnDashboardCustomFilterConfigurationPropertyToCloudFormation(properties.customFilterConfiguration), CustomFilterListConfiguration: cfnDashboardCustomFilterListConfigurationPropertyToCloudFormation(properties.customFilterListConfiguration), FilterListConfiguration: cfnDashboardFilterListConfigurationPropertyToCloudFormation(properties.filterListConfiguration) }) : properties;
    }
    function CfnDashboardCategoryFilterConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customFilterConfiguration", "CustomFilterConfiguration", properties.CustomFilterConfiguration != null ? CfnDashboardCustomFilterConfigurationPropertyFromCloudFormation(properties.CustomFilterConfiguration) : void 0), ret.addPropertyResult("customFilterListConfiguration", "CustomFilterListConfiguration", properties.CustomFilterListConfiguration != null ? CfnDashboardCustomFilterListConfigurationPropertyFromCloudFormation(properties.CustomFilterListConfiguration) : void 0), ret.addPropertyResult("filterListConfiguration", "FilterListConfiguration", properties.FilterListConfiguration != null ? CfnDashboardFilterListConfigurationPropertyFromCloudFormation(properties.FilterListConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ChartAxisLabelOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("axisLabelOptions", cdk.listValidator(CfnDashboard_AxisLabelOptionsPropertyValidator))(properties.axisLabelOptions)), errors.collect(cdk.propertyValidator("sortIconVisibility", cdk.validateString)(properties.sortIconVisibility)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "ChartAxisLabelOptionsProperty"');
    }
    function cfnDashboardChartAxisLabelOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ChartAxisLabelOptionsPropertyValidator(properties).assertSuccess(), { AxisLabelOptions: cdk.listMapper(cfnDashboardAxisLabelOptionsPropertyToCloudFormation)(properties.axisLabelOptions), SortIconVisibility: cdk.stringToCloudFormation(properties.sortIconVisibility), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnDashboardChartAxisLabelOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("axisLabelOptions", "AxisLabelOptions", properties.AxisLabelOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardAxisLabelOptionsPropertyFromCloudFormation)(properties.AxisLabelOptions) : void 0), ret.addPropertyResult("sortIconVisibility", "SortIconVisibility", properties.SortIconVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.SortIconVisibility) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ClusterMarkerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("simpleClusterMarker", CfnDashboard_SimpleClusterMarkerPropertyValidator)(properties.simpleClusterMarker)), errors.wrap('supplied properties not correct for "ClusterMarkerProperty"');
    }
    function cfnDashboardClusterMarkerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ClusterMarkerPropertyValidator(properties).assertSuccess(), { SimpleClusterMarker: cfnDashboardSimpleClusterMarkerPropertyToCloudFormation(properties.simpleClusterMarker) }) : properties;
    }
    function CfnDashboardClusterMarkerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("simpleClusterMarker", "SimpleClusterMarker", properties.SimpleClusterMarker != null ? CfnDashboardSimpleClusterMarkerPropertyFromCloudFormation(properties.SimpleClusterMarker) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ClusterMarkerConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clusterMarker", CfnDashboard_ClusterMarkerPropertyValidator)(properties.clusterMarker)), errors.wrap('supplied properties not correct for "ClusterMarkerConfigurationProperty"');
    }
    function cfnDashboardClusterMarkerConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ClusterMarkerConfigurationPropertyValidator(properties).assertSuccess(), { ClusterMarker: cfnDashboardClusterMarkerPropertyToCloudFormation(properties.clusterMarker) }) : properties;
    }
    function CfnDashboardClusterMarkerConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clusterMarker", "ClusterMarker", properties.ClusterMarker != null ? CfnDashboardClusterMarkerPropertyFromCloudFormation(properties.ClusterMarker) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ColorScalePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("colorFillType", cdk.requiredValidator)(properties.colorFillType)), errors.collect(cdk.propertyValidator("colorFillType", cdk.validateString)(properties.colorFillType)), errors.collect(cdk.propertyValidator("colors", cdk.requiredValidator)(properties.colors)), errors.collect(cdk.propertyValidator("colors", cdk.listValidator(CfnDashboard_DataColorPropertyValidator))(properties.colors)), errors.collect(cdk.propertyValidator("nullValueColor", CfnDashboard_DataColorPropertyValidator)(properties.nullValueColor)), errors.wrap('supplied properties not correct for "ColorScaleProperty"');
    }
    function cfnDashboardColorScalePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ColorScalePropertyValidator(properties).assertSuccess(), { ColorFillType: cdk.stringToCloudFormation(properties.colorFillType), Colors: cdk.listMapper(cfnDashboardDataColorPropertyToCloudFormation)(properties.colors), NullValueColor: cfnDashboardDataColorPropertyToCloudFormation(properties.nullValueColor) }) : properties;
    }
    function CfnDashboardColorScalePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("colorFillType", "ColorFillType", cfn_parse.FromCloudFormation.getString(properties.ColorFillType)), ret.addPropertyResult("colors", "Colors", cfn_parse.FromCloudFormation.getArray(CfnDashboardDataColorPropertyFromCloudFormation)(properties.Colors)), ret.addPropertyResult("nullValueColor", "NullValueColor", properties.NullValueColor != null ? CfnDashboardDataColorPropertyFromCloudFormation(properties.NullValueColor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ColorsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customColors", cdk.listValidator(CfnDashboard_CustomColorPropertyValidator))(properties.customColors)), errors.wrap('supplied properties not correct for "ColorsConfigurationProperty"');
    }
    function cfnDashboardColorsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ColorsConfigurationPropertyValidator(properties).assertSuccess(), { CustomColors: cdk.listMapper(cfnDashboardCustomColorPropertyToCloudFormation)(properties.customColors) }) : properties;
    }
    function CfnDashboardColorsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customColors", "CustomColors", properties.CustomColors != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardCustomColorPropertyFromCloudFormation)(properties.CustomColors) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ColumnConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("colorsConfiguration", CfnDashboard_ColorsConfigurationPropertyValidator)(properties.colorsConfiguration)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnDashboard_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("formatConfiguration", CfnDashboard_FormatConfigurationPropertyValidator)(properties.formatConfiguration)), errors.collect(cdk.propertyValidator("role", cdk.validateString)(properties.role)), errors.wrap('supplied properties not correct for "ColumnConfigurationProperty"');
    }
    function cfnDashboardColumnConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ColumnConfigurationPropertyValidator(properties).assertSuccess(), { ColorsConfiguration: cfnDashboardColorsConfigurationPropertyToCloudFormation(properties.colorsConfiguration), Column: cfnDashboardColumnIdentifierPropertyToCloudFormation(properties.column), FormatConfiguration: cfnDashboardFormatConfigurationPropertyToCloudFormation(properties.formatConfiguration), Role: cdk.stringToCloudFormation(properties.role) }) : properties;
    }
    function CfnDashboardColumnConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("colorsConfiguration", "ColorsConfiguration", properties.ColorsConfiguration != null ? CfnDashboardColorsConfigurationPropertyFromCloudFormation(properties.ColorsConfiguration) : void 0), ret.addPropertyResult("column", "Column", CfnDashboardColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("formatConfiguration", "FormatConfiguration", properties.FormatConfiguration != null ? CfnDashboardFormatConfigurationPropertyFromCloudFormation(properties.FormatConfiguration) : void 0), ret.addPropertyResult("role", "Role", properties.Role != null ? cfn_parse.FromCloudFormation.getString(properties.Role) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ColumnHierarchyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateTimeHierarchy", CfnDashboard_DateTimeHierarchyPropertyValidator)(properties.dateTimeHierarchy)), errors.collect(cdk.propertyValidator("explicitHierarchy", CfnDashboard_ExplicitHierarchyPropertyValidator)(properties.explicitHierarchy)), errors.collect(cdk.propertyValidator("predefinedHierarchy", CfnDashboard_PredefinedHierarchyPropertyValidator)(properties.predefinedHierarchy)), errors.wrap('supplied properties not correct for "ColumnHierarchyProperty"');
    }
    function cfnDashboardColumnHierarchyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ColumnHierarchyPropertyValidator(properties).assertSuccess(), { DateTimeHierarchy: cfnDashboardDateTimeHierarchyPropertyToCloudFormation(properties.dateTimeHierarchy), ExplicitHierarchy: cfnDashboardExplicitHierarchyPropertyToCloudFormation(properties.explicitHierarchy), PredefinedHierarchy: cfnDashboardPredefinedHierarchyPropertyToCloudFormation(properties.predefinedHierarchy) }) : properties;
    }
    function CfnDashboardColumnHierarchyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateTimeHierarchy", "DateTimeHierarchy", properties.DateTimeHierarchy != null ? CfnDashboardDateTimeHierarchyPropertyFromCloudFormation(properties.DateTimeHierarchy) : void 0), ret.addPropertyResult("explicitHierarchy", "ExplicitHierarchy", properties.ExplicitHierarchy != null ? CfnDashboardExplicitHierarchyPropertyFromCloudFormation(properties.ExplicitHierarchy) : void 0), ret.addPropertyResult("predefinedHierarchy", "PredefinedHierarchy", properties.PredefinedHierarchy != null ? CfnDashboardPredefinedHierarchyPropertyFromCloudFormation(properties.PredefinedHierarchy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ColumnIdentifierPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnName", cdk.requiredValidator)(properties.columnName)), errors.collect(cdk.propertyValidator("columnName", cdk.validateString)(properties.columnName)), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.requiredValidator)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.validateString)(properties.dataSetIdentifier)), errors.wrap('supplied properties not correct for "ColumnIdentifierProperty"');
    }
    function cfnDashboardColumnIdentifierPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ColumnIdentifierPropertyValidator(properties).assertSuccess(), { ColumnName: cdk.stringToCloudFormation(properties.columnName), DataSetIdentifier: cdk.stringToCloudFormation(properties.dataSetIdentifier) }) : properties;
    }
    function CfnDashboardColumnIdentifierPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columnName", "ColumnName", cfn_parse.FromCloudFormation.getString(properties.ColumnName)), ret.addPropertyResult("dataSetIdentifier", "DataSetIdentifier", cfn_parse.FromCloudFormation.getString(properties.DataSetIdentifier)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ColumnSortPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationFunction", CfnDashboard_AggregationFunctionPropertyValidator)(properties.aggregationFunction)), errors.collect(cdk.propertyValidator("direction", cdk.requiredValidator)(properties.direction)), errors.collect(cdk.propertyValidator("direction", cdk.validateString)(properties.direction)), errors.collect(cdk.propertyValidator("sortBy", cdk.requiredValidator)(properties.sortBy)), errors.collect(cdk.propertyValidator("sortBy", CfnDashboard_ColumnIdentifierPropertyValidator)(properties.sortBy)), errors.wrap('supplied properties not correct for "ColumnSortProperty"');
    }
    function cfnDashboardColumnSortPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ColumnSortPropertyValidator(properties).assertSuccess(), { AggregationFunction: cfnDashboardAggregationFunctionPropertyToCloudFormation(properties.aggregationFunction), Direction: cdk.stringToCloudFormation(properties.direction), SortBy: cfnDashboardColumnIdentifierPropertyToCloudFormation(properties.sortBy) }) : properties;
    }
    function CfnDashboardColumnSortPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationFunction", "AggregationFunction", properties.AggregationFunction != null ? CfnDashboardAggregationFunctionPropertyFromCloudFormation(properties.AggregationFunction) : void 0), ret.addPropertyResult("direction", "Direction", cfn_parse.FromCloudFormation.getString(properties.Direction)), ret.addPropertyResult("sortBy", "SortBy", CfnDashboardColumnIdentifierPropertyFromCloudFormation(properties.SortBy)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ColumnTooltipItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregation", CfnDashboard_AggregationFunctionPropertyValidator)(properties.aggregation)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnDashboard_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("label", cdk.validateString)(properties.label)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "ColumnTooltipItemProperty"');
    }
    function cfnDashboardColumnTooltipItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ColumnTooltipItemPropertyValidator(properties).assertSuccess(), { Aggregation: cfnDashboardAggregationFunctionPropertyToCloudFormation(properties.aggregation), Column: cfnDashboardColumnIdentifierPropertyToCloudFormation(properties.column), Label: cdk.stringToCloudFormation(properties.label), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnDashboardColumnTooltipItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregation", "Aggregation", properties.Aggregation != null ? CfnDashboardAggregationFunctionPropertyFromCloudFormation(properties.Aggregation) : void 0), ret.addPropertyResult("column", "Column", CfnDashboardColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("label", "Label", properties.Label != null ? cfn_parse.FromCloudFormation.getString(properties.Label) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ComboChartAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("barValues", cdk.listValidator(CfnDashboard_MeasureFieldPropertyValidator))(properties.barValues)), errors.collect(cdk.propertyValidator("category", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.category)), errors.collect(cdk.propertyValidator("colors", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.colors)), errors.collect(cdk.propertyValidator("lineValues", cdk.listValidator(CfnDashboard_MeasureFieldPropertyValidator))(properties.lineValues)), errors.wrap('supplied properties not correct for "ComboChartAggregatedFieldWellsProperty"');
    }
    function cfnDashboardComboChartAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ComboChartAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { BarValues: cdk.listMapper(cfnDashboardMeasureFieldPropertyToCloudFormation)(properties.barValues), Category: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.category), Colors: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.colors), LineValues: cdk.listMapper(cfnDashboardMeasureFieldPropertyToCloudFormation)(properties.lineValues) }) : properties;
    }
    function CfnDashboardComboChartAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("barValues", "BarValues", properties.BarValues != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMeasureFieldPropertyFromCloudFormation)(properties.BarValues) : void 0), ret.addPropertyResult("category", "Category", properties.Category != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.Category) : void 0), ret.addPropertyResult("colors", "Colors", properties.Colors != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.Colors) : void 0), ret.addPropertyResult("lineValues", "LineValues", properties.LineValues != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMeasureFieldPropertyFromCloudFormation)(properties.LineValues) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ComboChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("barDataLabels", CfnDashboard_DataLabelOptionsPropertyValidator)(properties.barDataLabels)), errors.collect(cdk.propertyValidator("barsArrangement", cdk.validateString)(properties.barsArrangement)), errors.collect(cdk.propertyValidator("categoryAxis", CfnDashboard_AxisDisplayOptionsPropertyValidator)(properties.categoryAxis)), errors.collect(cdk.propertyValidator("categoryLabelOptions", CfnDashboard_ChartAxisLabelOptionsPropertyValidator)(properties.categoryLabelOptions)), errors.collect(cdk.propertyValidator("colorLabelOptions", CfnDashboard_ChartAxisLabelOptionsPropertyValidator)(properties.colorLabelOptions)), errors.collect(cdk.propertyValidator("fieldWells", CfnDashboard_ComboChartFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("legend", CfnDashboard_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("lineDataLabels", CfnDashboard_DataLabelOptionsPropertyValidator)(properties.lineDataLabels)), errors.collect(cdk.propertyValidator("primaryYAxisDisplayOptions", CfnDashboard_AxisDisplayOptionsPropertyValidator)(properties.primaryYAxisDisplayOptions)), errors.collect(cdk.propertyValidator("primaryYAxisLabelOptions", CfnDashboard_ChartAxisLabelOptionsPropertyValidator)(properties.primaryYAxisLabelOptions)), errors.collect(cdk.propertyValidator("referenceLines", cdk.listValidator(CfnDashboard_ReferenceLinePropertyValidator))(properties.referenceLines)), errors.collect(cdk.propertyValidator("secondaryYAxisDisplayOptions", CfnDashboard_AxisDisplayOptionsPropertyValidator)(properties.secondaryYAxisDisplayOptions)), errors.collect(cdk.propertyValidator("secondaryYAxisLabelOptions", CfnDashboard_ChartAxisLabelOptionsPropertyValidator)(properties.secondaryYAxisLabelOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnDashboard_ComboChartSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tooltip", CfnDashboard_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.collect(cdk.propertyValidator("visualPalette", CfnDashboard_VisualPalettePropertyValidator)(properties.visualPalette)), errors.wrap('supplied properties not correct for "ComboChartConfigurationProperty"');
    }
    function cfnDashboardComboChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ComboChartConfigurationPropertyValidator(properties).assertSuccess(), { BarDataLabels: cfnDashboardDataLabelOptionsPropertyToCloudFormation(properties.barDataLabels), BarsArrangement: cdk.stringToCloudFormation(properties.barsArrangement), CategoryAxis: cfnDashboardAxisDisplayOptionsPropertyToCloudFormation(properties.categoryAxis), CategoryLabelOptions: cfnDashboardChartAxisLabelOptionsPropertyToCloudFormation(properties.categoryLabelOptions), ColorLabelOptions: cfnDashboardChartAxisLabelOptionsPropertyToCloudFormation(properties.colorLabelOptions), FieldWells: cfnDashboardComboChartFieldWellsPropertyToCloudFormation(properties.fieldWells), Legend: cfnDashboardLegendOptionsPropertyToCloudFormation(properties.legend), LineDataLabels: cfnDashboardDataLabelOptionsPropertyToCloudFormation(properties.lineDataLabels), PrimaryYAxisDisplayOptions: cfnDashboardAxisDisplayOptionsPropertyToCloudFormation(properties.primaryYAxisDisplayOptions), PrimaryYAxisLabelOptions: cfnDashboardChartAxisLabelOptionsPropertyToCloudFormation(properties.primaryYAxisLabelOptions), ReferenceLines: cdk.listMapper(cfnDashboardReferenceLinePropertyToCloudFormation)(properties.referenceLines), SecondaryYAxisDisplayOptions: cfnDashboardAxisDisplayOptionsPropertyToCloudFormation(properties.secondaryYAxisDisplayOptions), SecondaryYAxisLabelOptions: cfnDashboardChartAxisLabelOptionsPropertyToCloudFormation(properties.secondaryYAxisLabelOptions), SortConfiguration: cfnDashboardComboChartSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), Tooltip: cfnDashboardTooltipOptionsPropertyToCloudFormation(properties.tooltip), VisualPalette: cfnDashboardVisualPalettePropertyToCloudFormation(properties.visualPalette) }) : properties;
    }
    function CfnDashboardComboChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("barDataLabels", "BarDataLabels", properties.BarDataLabels != null ? CfnDashboardDataLabelOptionsPropertyFromCloudFormation(properties.BarDataLabels) : void 0), ret.addPropertyResult("barsArrangement", "BarsArrangement", properties.BarsArrangement != null ? cfn_parse.FromCloudFormation.getString(properties.BarsArrangement) : void 0), ret.addPropertyResult("categoryAxis", "CategoryAxis", properties.CategoryAxis != null ? CfnDashboardAxisDisplayOptionsPropertyFromCloudFormation(properties.CategoryAxis) : void 0), ret.addPropertyResult("categoryLabelOptions", "CategoryLabelOptions", properties.CategoryLabelOptions != null ? CfnDashboardChartAxisLabelOptionsPropertyFromCloudFormation(properties.CategoryLabelOptions) : void 0), ret.addPropertyResult("colorLabelOptions", "ColorLabelOptions", properties.ColorLabelOptions != null ? CfnDashboardChartAxisLabelOptionsPropertyFromCloudFormation(properties.ColorLabelOptions) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnDashboardComboChartFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnDashboardLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("lineDataLabels", "LineDataLabels", properties.LineDataLabels != null ? CfnDashboardDataLabelOptionsPropertyFromCloudFormation(properties.LineDataLabels) : void 0), ret.addPropertyResult("primaryYAxisDisplayOptions", "PrimaryYAxisDisplayOptions", properties.PrimaryYAxisDisplayOptions != null ? CfnDashboardAxisDisplayOptionsPropertyFromCloudFormation(properties.PrimaryYAxisDisplayOptions) : void 0), ret.addPropertyResult("primaryYAxisLabelOptions", "PrimaryYAxisLabelOptions", properties.PrimaryYAxisLabelOptions != null ? CfnDashboardChartAxisLabelOptionsPropertyFromCloudFormation(properties.PrimaryYAxisLabelOptions) : void 0), ret.addPropertyResult("referenceLines", "ReferenceLines", properties.ReferenceLines != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardReferenceLinePropertyFromCloudFormation)(properties.ReferenceLines) : void 0), ret.addPropertyResult("secondaryYAxisDisplayOptions", "SecondaryYAxisDisplayOptions", properties.SecondaryYAxisDisplayOptions != null ? CfnDashboardAxisDisplayOptionsPropertyFromCloudFormation(properties.SecondaryYAxisDisplayOptions) : void 0), ret.addPropertyResult("secondaryYAxisLabelOptions", "SecondaryYAxisLabelOptions", properties.SecondaryYAxisLabelOptions != null ? CfnDashboardChartAxisLabelOptionsPropertyFromCloudFormation(properties.SecondaryYAxisLabelOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnDashboardComboChartSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnDashboardTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnDashboardVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ComboChartFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("comboChartAggregatedFieldWells", CfnDashboard_ComboChartAggregatedFieldWellsPropertyValidator)(properties.comboChartAggregatedFieldWells)), errors.wrap('supplied properties not correct for "ComboChartFieldWellsProperty"');
    }
    function cfnDashboardComboChartFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ComboChartFieldWellsPropertyValidator(properties).assertSuccess(), { ComboChartAggregatedFieldWells: cfnDashboardComboChartAggregatedFieldWellsPropertyToCloudFormation(properties.comboChartAggregatedFieldWells) }) : properties;
    }
    function CfnDashboardComboChartFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("comboChartAggregatedFieldWells", "ComboChartAggregatedFieldWells", properties.ComboChartAggregatedFieldWells != null ? CfnDashboardComboChartAggregatedFieldWellsPropertyFromCloudFormation(properties.ComboChartAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ComboChartSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryItemsLimit", CfnDashboard_ItemsLimitConfigurationPropertyValidator)(properties.categoryItemsLimit)), errors.collect(cdk.propertyValidator("categorySort", cdk.listValidator(CfnDashboard_FieldSortOptionsPropertyValidator))(properties.categorySort)), errors.collect(cdk.propertyValidator("colorItemsLimit", CfnDashboard_ItemsLimitConfigurationPropertyValidator)(properties.colorItemsLimit)), errors.collect(cdk.propertyValidator("colorSort", cdk.listValidator(CfnDashboard_FieldSortOptionsPropertyValidator))(properties.colorSort)), errors.wrap('supplied properties not correct for "ComboChartSortConfigurationProperty"');
    }
    function cfnDashboardComboChartSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ComboChartSortConfigurationPropertyValidator(properties).assertSuccess(), { CategoryItemsLimit: cfnDashboardItemsLimitConfigurationPropertyToCloudFormation(properties.categoryItemsLimit), CategorySort: cdk.listMapper(cfnDashboardFieldSortOptionsPropertyToCloudFormation)(properties.categorySort), ColorItemsLimit: cfnDashboardItemsLimitConfigurationPropertyToCloudFormation(properties.colorItemsLimit), ColorSort: cdk.listMapper(cfnDashboardFieldSortOptionsPropertyToCloudFormation)(properties.colorSort) }) : properties;
    }
    function CfnDashboardComboChartSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryItemsLimit", "CategoryItemsLimit", properties.CategoryItemsLimit != null ? CfnDashboardItemsLimitConfigurationPropertyFromCloudFormation(properties.CategoryItemsLimit) : void 0), ret.addPropertyResult("categorySort", "CategorySort", properties.CategorySort != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardFieldSortOptionsPropertyFromCloudFormation)(properties.CategorySort) : void 0), ret.addPropertyResult("colorItemsLimit", "ColorItemsLimit", properties.ColorItemsLimit != null ? CfnDashboardItemsLimitConfigurationPropertyFromCloudFormation(properties.ColorItemsLimit) : void 0), ret.addPropertyResult("colorSort", "ColorSort", properties.ColorSort != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardFieldSortOptionsPropertyFromCloudFormation)(properties.ColorSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ComboChartVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnDashboard_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnDashboard_ComboChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnDashboard_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnDashboard_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnDashboard_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "ComboChartVisualProperty"');
    }
    function cfnDashboardComboChartVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ComboChartVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnDashboardVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnDashboardComboChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnDashboardColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnDashboardVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnDashboardVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnDashboardComboChartVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnDashboardComboChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnDashboardVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnDashboardVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ComparisonConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("comparisonFormat", CfnDashboard_ComparisonFormatConfigurationPropertyValidator)(properties.comparisonFormat)), errors.collect(cdk.propertyValidator("comparisonMethod", cdk.validateString)(properties.comparisonMethod)), errors.wrap('supplied properties not correct for "ComparisonConfigurationProperty"');
    }
    function cfnDashboardComparisonConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ComparisonConfigurationPropertyValidator(properties).assertSuccess(), { ComparisonFormat: cfnDashboardComparisonFormatConfigurationPropertyToCloudFormation(properties.comparisonFormat), ComparisonMethod: cdk.stringToCloudFormation(properties.comparisonMethod) }) : properties;
    }
    function CfnDashboardComparisonConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("comparisonFormat", "ComparisonFormat", properties.ComparisonFormat != null ? CfnDashboardComparisonFormatConfigurationPropertyFromCloudFormation(properties.ComparisonFormat) : void 0), ret.addPropertyResult("comparisonMethod", "ComparisonMethod", properties.ComparisonMethod != null ? cfn_parse.FromCloudFormation.getString(properties.ComparisonMethod) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ComparisonFormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("numberDisplayFormatConfiguration", CfnDashboard_NumberDisplayFormatConfigurationPropertyValidator)(properties.numberDisplayFormatConfiguration)), errors.collect(cdk.propertyValidator("percentageDisplayFormatConfiguration", CfnDashboard_PercentageDisplayFormatConfigurationPropertyValidator)(properties.percentageDisplayFormatConfiguration)), errors.wrap('supplied properties not correct for "ComparisonFormatConfigurationProperty"');
    }
    function cfnDashboardComparisonFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ComparisonFormatConfigurationPropertyValidator(properties).assertSuccess(), { NumberDisplayFormatConfiguration: cfnDashboardNumberDisplayFormatConfigurationPropertyToCloudFormation(properties.numberDisplayFormatConfiguration), PercentageDisplayFormatConfiguration: cfnDashboardPercentageDisplayFormatConfigurationPropertyToCloudFormation(properties.percentageDisplayFormatConfiguration) }) : properties;
    }
    function CfnDashboardComparisonFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("numberDisplayFormatConfiguration", "NumberDisplayFormatConfiguration", properties.NumberDisplayFormatConfiguration != null ? CfnDashboardNumberDisplayFormatConfigurationPropertyFromCloudFormation(properties.NumberDisplayFormatConfiguration) : void 0), ret.addPropertyResult("percentageDisplayFormatConfiguration", "PercentageDisplayFormatConfiguration", properties.PercentageDisplayFormatConfiguration != null ? CfnDashboardPercentageDisplayFormatConfigurationPropertyFromCloudFormation(properties.PercentageDisplayFormatConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("forecast", CfnDashboard_ForecastComputationPropertyValidator)(properties.forecast)), errors.collect(cdk.propertyValidator("growthRate", CfnDashboard_GrowthRateComputationPropertyValidator)(properties.growthRate)), errors.collect(cdk.propertyValidator("maximumMinimum", CfnDashboard_MaximumMinimumComputationPropertyValidator)(properties.maximumMinimum)), errors.collect(cdk.propertyValidator("metricComparison", CfnDashboard_MetricComparisonComputationPropertyValidator)(properties.metricComparison)), errors.collect(cdk.propertyValidator("periodOverPeriod", CfnDashboard_PeriodOverPeriodComputationPropertyValidator)(properties.periodOverPeriod)), errors.collect(cdk.propertyValidator("periodToDate", CfnDashboard_PeriodToDateComputationPropertyValidator)(properties.periodToDate)), errors.collect(cdk.propertyValidator("topBottomMovers", CfnDashboard_TopBottomMoversComputationPropertyValidator)(properties.topBottomMovers)), errors.collect(cdk.propertyValidator("topBottomRanked", CfnDashboard_TopBottomRankedComputationPropertyValidator)(properties.topBottomRanked)), errors.collect(cdk.propertyValidator("totalAggregation", CfnDashboard_TotalAggregationComputationPropertyValidator)(properties.totalAggregation)), errors.collect(cdk.propertyValidator("uniqueValues", CfnDashboard_UniqueValuesComputationPropertyValidator)(properties.uniqueValues)), errors.wrap('supplied properties not correct for "ComputationProperty"');
    }
    function cfnDashboardComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ComputationPropertyValidator(properties).assertSuccess(), { Forecast: cfnDashboardForecastComputationPropertyToCloudFormation(properties.forecast), GrowthRate: cfnDashboardGrowthRateComputationPropertyToCloudFormation(properties.growthRate), MaximumMinimum: cfnDashboardMaximumMinimumComputationPropertyToCloudFormation(properties.maximumMinimum), MetricComparison: cfnDashboardMetricComparisonComputationPropertyToCloudFormation(properties.metricComparison), PeriodOverPeriod: cfnDashboardPeriodOverPeriodComputationPropertyToCloudFormation(properties.periodOverPeriod), PeriodToDate: cfnDashboardPeriodToDateComputationPropertyToCloudFormation(properties.periodToDate), TopBottomMovers: cfnDashboardTopBottomMoversComputationPropertyToCloudFormation(properties.topBottomMovers), TopBottomRanked: cfnDashboardTopBottomRankedComputationPropertyToCloudFormation(properties.topBottomRanked), TotalAggregation: cfnDashboardTotalAggregationComputationPropertyToCloudFormation(properties.totalAggregation), UniqueValues: cfnDashboardUniqueValuesComputationPropertyToCloudFormation(properties.uniqueValues) }) : properties;
    }
    function CfnDashboardComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("forecast", "Forecast", properties.Forecast != null ? CfnDashboardForecastComputationPropertyFromCloudFormation(properties.Forecast) : void 0), ret.addPropertyResult("growthRate", "GrowthRate", properties.GrowthRate != null ? CfnDashboardGrowthRateComputationPropertyFromCloudFormation(properties.GrowthRate) : void 0), ret.addPropertyResult("maximumMinimum", "MaximumMinimum", properties.MaximumMinimum != null ? CfnDashboardMaximumMinimumComputationPropertyFromCloudFormation(properties.MaximumMinimum) : void 0), ret.addPropertyResult("metricComparison", "MetricComparison", properties.MetricComparison != null ? CfnDashboardMetricComparisonComputationPropertyFromCloudFormation(properties.MetricComparison) : void 0), ret.addPropertyResult("periodOverPeriod", "PeriodOverPeriod", properties.PeriodOverPeriod != null ? CfnDashboardPeriodOverPeriodComputationPropertyFromCloudFormation(properties.PeriodOverPeriod) : void 0), ret.addPropertyResult("periodToDate", "PeriodToDate", properties.PeriodToDate != null ? CfnDashboardPeriodToDateComputationPropertyFromCloudFormation(properties.PeriodToDate) : void 0), ret.addPropertyResult("topBottomMovers", "TopBottomMovers", properties.TopBottomMovers != null ? CfnDashboardTopBottomMoversComputationPropertyFromCloudFormation(properties.TopBottomMovers) : void 0), ret.addPropertyResult("topBottomRanked", "TopBottomRanked", properties.TopBottomRanked != null ? CfnDashboardTopBottomRankedComputationPropertyFromCloudFormation(properties.TopBottomRanked) : void 0), ret.addPropertyResult("totalAggregation", "TotalAggregation", properties.TotalAggregation != null ? CfnDashboardTotalAggregationComputationPropertyFromCloudFormation(properties.TotalAggregation) : void 0), ret.addPropertyResult("uniqueValues", "UniqueValues", properties.UniqueValues != null ? CfnDashboardUniqueValuesComputationPropertyFromCloudFormation(properties.UniqueValues) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ConditionalFormattingColorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("gradient", CfnDashboard_ConditionalFormattingGradientColorPropertyValidator)(properties.gradient)), errors.collect(cdk.propertyValidator("solid", CfnDashboard_ConditionalFormattingSolidColorPropertyValidator)(properties.solid)), errors.wrap('supplied properties not correct for "ConditionalFormattingColorProperty"');
    }
    function cfnDashboardConditionalFormattingColorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ConditionalFormattingColorPropertyValidator(properties).assertSuccess(), { Gradient: cfnDashboardConditionalFormattingGradientColorPropertyToCloudFormation(properties.gradient), Solid: cfnDashboardConditionalFormattingSolidColorPropertyToCloudFormation(properties.solid) }) : properties;
    }
    function CfnDashboardConditionalFormattingColorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("gradient", "Gradient", properties.Gradient != null ? CfnDashboardConditionalFormattingGradientColorPropertyFromCloudFormation(properties.Gradient) : void 0), ret.addPropertyResult("solid", "Solid", properties.Solid != null ? CfnDashboardConditionalFormattingSolidColorPropertyFromCloudFormation(properties.Solid) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ConditionalFormattingCustomIconConditionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.collect(cdk.propertyValidator("displayConfiguration", CfnDashboard_ConditionalFormattingIconDisplayConfigurationPropertyValidator)(properties.displayConfiguration)), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.collect(cdk.propertyValidator("iconOptions", cdk.requiredValidator)(properties.iconOptions)), errors.collect(cdk.propertyValidator("iconOptions", CfnDashboard_ConditionalFormattingCustomIconOptionsPropertyValidator)(properties.iconOptions)), errors.wrap('supplied properties not correct for "ConditionalFormattingCustomIconConditionProperty"');
    }
    function cfnDashboardConditionalFormattingCustomIconConditionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ConditionalFormattingCustomIconConditionPropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color), DisplayConfiguration: cfnDashboardConditionalFormattingIconDisplayConfigurationPropertyToCloudFormation(properties.displayConfiguration), Expression: cdk.stringToCloudFormation(properties.expression), IconOptions: cfnDashboardConditionalFormattingCustomIconOptionsPropertyToCloudFormation(properties.iconOptions) }) : properties;
    }
    function CfnDashboardConditionalFormattingCustomIconConditionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", properties.Color != null ? cfn_parse.FromCloudFormation.getString(properties.Color) : void 0), ret.addPropertyResult("displayConfiguration", "DisplayConfiguration", properties.DisplayConfiguration != null ? CfnDashboardConditionalFormattingIconDisplayConfigurationPropertyFromCloudFormation(properties.DisplayConfiguration) : void 0), ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getString(properties.Expression)), ret.addPropertyResult("iconOptions", "IconOptions", CfnDashboardConditionalFormattingCustomIconOptionsPropertyFromCloudFormation(properties.IconOptions)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ConditionalFormattingCustomIconOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("icon", cdk.validateString)(properties.icon)), errors.collect(cdk.propertyValidator("unicodeIcon", cdk.validateString)(properties.unicodeIcon)), errors.wrap('supplied properties not correct for "ConditionalFormattingCustomIconOptionsProperty"');
    }
    function cfnDashboardConditionalFormattingCustomIconOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ConditionalFormattingCustomIconOptionsPropertyValidator(properties).assertSuccess(), { Icon: cdk.stringToCloudFormation(properties.icon), UnicodeIcon: cdk.stringToCloudFormation(properties.unicodeIcon) }) : properties;
    }
    function CfnDashboardConditionalFormattingCustomIconOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("icon", "Icon", properties.Icon != null ? cfn_parse.FromCloudFormation.getString(properties.Icon) : void 0), ret.addPropertyResult("unicodeIcon", "UnicodeIcon", properties.UnicodeIcon != null ? cfn_parse.FromCloudFormation.getString(properties.UnicodeIcon) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ConditionalFormattingGradientColorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.requiredValidator)(properties.color)), errors.collect(cdk.propertyValidator("color", CfnDashboard_GradientColorPropertyValidator)(properties.color)), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.wrap('supplied properties not correct for "ConditionalFormattingGradientColorProperty"');
    }
    function cfnDashboardConditionalFormattingGradientColorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ConditionalFormattingGradientColorPropertyValidator(properties).assertSuccess(), { Color: cfnDashboardGradientColorPropertyToCloudFormation(properties.color), Expression: cdk.stringToCloudFormation(properties.expression) }) : properties;
    }
    function CfnDashboardConditionalFormattingGradientColorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", CfnDashboardGradientColorPropertyFromCloudFormation(properties.Color)), ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getString(properties.Expression)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ConditionalFormattingIconPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customCondition", CfnDashboard_ConditionalFormattingCustomIconConditionPropertyValidator)(properties.customCondition)), errors.collect(cdk.propertyValidator("iconSet", CfnDashboard_ConditionalFormattingIconSetPropertyValidator)(properties.iconSet)), errors.wrap('supplied properties not correct for "ConditionalFormattingIconProperty"');
    }
    function cfnDashboardConditionalFormattingIconPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ConditionalFormattingIconPropertyValidator(properties).assertSuccess(), { CustomCondition: cfnDashboardConditionalFormattingCustomIconConditionPropertyToCloudFormation(properties.customCondition), IconSet: cfnDashboardConditionalFormattingIconSetPropertyToCloudFormation(properties.iconSet) }) : properties;
    }
    function CfnDashboardConditionalFormattingIconPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customCondition", "CustomCondition", properties.CustomCondition != null ? CfnDashboardConditionalFormattingCustomIconConditionPropertyFromCloudFormation(properties.CustomCondition) : void 0), ret.addPropertyResult("iconSet", "IconSet", properties.IconSet != null ? CfnDashboardConditionalFormattingIconSetPropertyFromCloudFormation(properties.IconSet) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ConditionalFormattingIconDisplayConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("iconDisplayOption", cdk.validateString)(properties.iconDisplayOption)), errors.wrap('supplied properties not correct for "ConditionalFormattingIconDisplayConfigurationProperty"');
    }
    function cfnDashboardConditionalFormattingIconDisplayConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ConditionalFormattingIconDisplayConfigurationPropertyValidator(properties).assertSuccess(), { IconDisplayOption: cdk.stringToCloudFormation(properties.iconDisplayOption) }) : properties;
    }
    function CfnDashboardConditionalFormattingIconDisplayConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("iconDisplayOption", "IconDisplayOption", properties.IconDisplayOption != null ? cfn_parse.FromCloudFormation.getString(properties.IconDisplayOption) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ConditionalFormattingIconSetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.collect(cdk.propertyValidator("iconSetType", cdk.validateString)(properties.iconSetType)), errors.wrap('supplied properties not correct for "ConditionalFormattingIconSetProperty"');
    }
    function cfnDashboardConditionalFormattingIconSetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ConditionalFormattingIconSetPropertyValidator(properties).assertSuccess(), { Expression: cdk.stringToCloudFormation(properties.expression), IconSetType: cdk.stringToCloudFormation(properties.iconSetType) }) : properties;
    }
    function CfnDashboardConditionalFormattingIconSetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getString(properties.Expression)), ret.addPropertyResult("iconSetType", "IconSetType", properties.IconSetType != null ? cfn_parse.FromCloudFormation.getString(properties.IconSetType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ConditionalFormattingSolidColorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.wrap('supplied properties not correct for "ConditionalFormattingSolidColorProperty"');
    }
    function cfnDashboardConditionalFormattingSolidColorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ConditionalFormattingSolidColorPropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color), Expression: cdk.stringToCloudFormation(properties.expression) }) : properties;
    }
    function CfnDashboardConditionalFormattingSolidColorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", properties.Color != null ? cfn_parse.FromCloudFormation.getString(properties.Color) : void 0), ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getString(properties.Expression)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ContributionAnalysisDefaultPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contributorDimensions", cdk.requiredValidator)(properties.contributorDimensions)), errors.collect(cdk.propertyValidator("contributorDimensions", cdk.listValidator(CfnDashboard_ColumnIdentifierPropertyValidator))(properties.contributorDimensions)), errors.collect(cdk.propertyValidator("measureFieldId", cdk.requiredValidator)(properties.measureFieldId)), errors.collect(cdk.propertyValidator("measureFieldId", cdk.validateString)(properties.measureFieldId)), errors.wrap('supplied properties not correct for "ContributionAnalysisDefaultProperty"');
    }
    function cfnDashboardContributionAnalysisDefaultPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ContributionAnalysisDefaultPropertyValidator(properties).assertSuccess(), { ContributorDimensions: cdk.listMapper(cfnDashboardColumnIdentifierPropertyToCloudFormation)(properties.contributorDimensions), MeasureFieldId: cdk.stringToCloudFormation(properties.measureFieldId) }) : properties;
    }
    function CfnDashboardContributionAnalysisDefaultPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contributorDimensions", "ContributorDimensions", cfn_parse.FromCloudFormation.getArray(CfnDashboardColumnIdentifierPropertyFromCloudFormation)(properties.ContributorDimensions)), ret.addPropertyResult("measureFieldId", "MeasureFieldId", cfn_parse.FromCloudFormation.getString(properties.MeasureFieldId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_CurrencyDisplayFormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("decimalPlacesConfiguration", CfnDashboard_DecimalPlacesConfigurationPropertyValidator)(properties.decimalPlacesConfiguration)), errors.collect(cdk.propertyValidator("negativeValueConfiguration", CfnDashboard_NegativeValueConfigurationPropertyValidator)(properties.negativeValueConfiguration)), errors.collect(cdk.propertyValidator("nullValueFormatConfiguration", CfnDashboard_NullValueFormatConfigurationPropertyValidator)(properties.nullValueFormatConfiguration)), errors.collect(cdk.propertyValidator("numberScale", cdk.validateString)(properties.numberScale)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.collect(cdk.propertyValidator("separatorConfiguration", CfnDashboard_NumericSeparatorConfigurationPropertyValidator)(properties.separatorConfiguration)), errors.collect(cdk.propertyValidator("suffix", cdk.validateString)(properties.suffix)), errors.collect(cdk.propertyValidator("symbol", cdk.validateString)(properties.symbol)), errors.wrap('supplied properties not correct for "CurrencyDisplayFormatConfigurationProperty"');
    }
    function cfnDashboardCurrencyDisplayFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_CurrencyDisplayFormatConfigurationPropertyValidator(properties).assertSuccess(), { DecimalPlacesConfiguration: cfnDashboardDecimalPlacesConfigurationPropertyToCloudFormation(properties.decimalPlacesConfiguration), NegativeValueConfiguration: cfnDashboardNegativeValueConfigurationPropertyToCloudFormation(properties.negativeValueConfiguration), NullValueFormatConfiguration: cfnDashboardNullValueFormatConfigurationPropertyToCloudFormation(properties.nullValueFormatConfiguration), NumberScale: cdk.stringToCloudFormation(properties.numberScale), Prefix: cdk.stringToCloudFormation(properties.prefix), SeparatorConfiguration: cfnDashboardNumericSeparatorConfigurationPropertyToCloudFormation(properties.separatorConfiguration), Suffix: cdk.stringToCloudFormation(properties.suffix), Symbol: cdk.stringToCloudFormation(properties.symbol) }) : properties;
    }
    function CfnDashboardCurrencyDisplayFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("decimalPlacesConfiguration", "DecimalPlacesConfiguration", properties.DecimalPlacesConfiguration != null ? CfnDashboardDecimalPlacesConfigurationPropertyFromCloudFormation(properties.DecimalPlacesConfiguration) : void 0), ret.addPropertyResult("negativeValueConfiguration", "NegativeValueConfiguration", properties.NegativeValueConfiguration != null ? CfnDashboardNegativeValueConfigurationPropertyFromCloudFormation(properties.NegativeValueConfiguration) : void 0), ret.addPropertyResult("nullValueFormatConfiguration", "NullValueFormatConfiguration", properties.NullValueFormatConfiguration != null ? CfnDashboardNullValueFormatConfigurationPropertyFromCloudFormation(properties.NullValueFormatConfiguration) : void 0), ret.addPropertyResult("numberScale", "NumberScale", properties.NumberScale != null ? cfn_parse.FromCloudFormation.getString(properties.NumberScale) : void 0), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addPropertyResult("separatorConfiguration", "SeparatorConfiguration", properties.SeparatorConfiguration != null ? CfnDashboardNumericSeparatorConfigurationPropertyFromCloudFormation(properties.SeparatorConfiguration) : void 0), ret.addPropertyResult("suffix", "Suffix", properties.Suffix != null ? cfn_parse.FromCloudFormation.getString(properties.Suffix) : void 0), ret.addPropertyResult("symbol", "Symbol", properties.Symbol != null ? cfn_parse.FromCloudFormation.getString(properties.Symbol) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_CustomActionFilterOperationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("selectedFieldsConfiguration", cdk.requiredValidator)(properties.selectedFieldsConfiguration)), errors.collect(cdk.propertyValidator("selectedFieldsConfiguration", CfnDashboard_FilterOperationSelectedFieldsConfigurationPropertyValidator)(properties.selectedFieldsConfiguration)), errors.collect(cdk.propertyValidator("targetVisualsConfiguration", cdk.requiredValidator)(properties.targetVisualsConfiguration)), errors.collect(cdk.propertyValidator("targetVisualsConfiguration", CfnDashboard_FilterOperationTargetVisualsConfigurationPropertyValidator)(properties.targetVisualsConfiguration)), errors.wrap('supplied properties not correct for "CustomActionFilterOperationProperty"');
    }
    function cfnDashboardCustomActionFilterOperationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_CustomActionFilterOperationPropertyValidator(properties).assertSuccess(), { SelectedFieldsConfiguration: cfnDashboardFilterOperationSelectedFieldsConfigurationPropertyToCloudFormation(properties.selectedFieldsConfiguration), TargetVisualsConfiguration: cfnDashboardFilterOperationTargetVisualsConfigurationPropertyToCloudFormation(properties.targetVisualsConfiguration) }) : properties;
    }
    function CfnDashboardCustomActionFilterOperationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("selectedFieldsConfiguration", "SelectedFieldsConfiguration", CfnDashboardFilterOperationSelectedFieldsConfigurationPropertyFromCloudFormation(properties.SelectedFieldsConfiguration)), ret.addPropertyResult("targetVisualsConfiguration", "TargetVisualsConfiguration", CfnDashboardFilterOperationTargetVisualsConfigurationPropertyFromCloudFormation(properties.TargetVisualsConfiguration)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_CustomActionNavigationOperationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("localNavigationConfiguration", CfnDashboard_LocalNavigationConfigurationPropertyValidator)(properties.localNavigationConfiguration)), errors.wrap('supplied properties not correct for "CustomActionNavigationOperationProperty"');
    }
    function cfnDashboardCustomActionNavigationOperationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_CustomActionNavigationOperationPropertyValidator(properties).assertSuccess(), { LocalNavigationConfiguration: cfnDashboardLocalNavigationConfigurationPropertyToCloudFormation(properties.localNavigationConfiguration) }) : properties;
    }
    function CfnDashboardCustomActionNavigationOperationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("localNavigationConfiguration", "LocalNavigationConfiguration", properties.LocalNavigationConfiguration != null ? CfnDashboardLocalNavigationConfigurationPropertyFromCloudFormation(properties.LocalNavigationConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_CustomActionSetParametersOperationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("parameterValueConfigurations", cdk.requiredValidator)(properties.parameterValueConfigurations)), errors.collect(cdk.propertyValidator("parameterValueConfigurations", cdk.listValidator(CfnDashboard_SetParameterValueConfigurationPropertyValidator))(properties.parameterValueConfigurations)), errors.wrap('supplied properties not correct for "CustomActionSetParametersOperationProperty"');
    }
    function cfnDashboardCustomActionSetParametersOperationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_CustomActionSetParametersOperationPropertyValidator(properties).assertSuccess(), { ParameterValueConfigurations: cdk.listMapper(cfnDashboardSetParameterValueConfigurationPropertyToCloudFormation)(properties.parameterValueConfigurations) }) : properties;
    }
    function CfnDashboardCustomActionSetParametersOperationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("parameterValueConfigurations", "ParameterValueConfigurations", cfn_parse.FromCloudFormation.getArray(CfnDashboardSetParameterValueConfigurationPropertyFromCloudFormation)(properties.ParameterValueConfigurations)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_CustomActionURLOperationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("urlTarget", cdk.requiredValidator)(properties.urlTarget)), errors.collect(cdk.propertyValidator("urlTarget", cdk.validateString)(properties.urlTarget)), errors.collect(cdk.propertyValidator("urlTemplate", cdk.requiredValidator)(properties.urlTemplate)), errors.collect(cdk.propertyValidator("urlTemplate", cdk.validateString)(properties.urlTemplate)), errors.wrap('supplied properties not correct for "CustomActionURLOperationProperty"');
    }
    function cfnDashboardCustomActionURLOperationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_CustomActionURLOperationPropertyValidator(properties).assertSuccess(), { URLTarget: cdk.stringToCloudFormation(properties.urlTarget), URLTemplate: cdk.stringToCloudFormation(properties.urlTemplate) }) : properties;
    }
    function CfnDashboardCustomActionURLOperationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("urlTarget", "URLTarget", cfn_parse.FromCloudFormation.getString(properties.URLTarget)), ret.addPropertyResult("urlTemplate", "URLTemplate", cfn_parse.FromCloudFormation.getString(properties.URLTemplate)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_CustomColorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.requiredValidator)(properties.color)), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.collect(cdk.propertyValidator("fieldValue", cdk.validateString)(properties.fieldValue)), errors.collect(cdk.propertyValidator("specialValue", cdk.validateString)(properties.specialValue)), errors.wrap('supplied properties not correct for "CustomColorProperty"');
    }
    function cfnDashboardCustomColorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_CustomColorPropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color), FieldValue: cdk.stringToCloudFormation(properties.fieldValue), SpecialValue: cdk.stringToCloudFormation(properties.specialValue) }) : properties;
    }
    function CfnDashboardCustomColorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", cfn_parse.FromCloudFormation.getString(properties.Color)), ret.addPropertyResult("fieldValue", "FieldValue", properties.FieldValue != null ? cfn_parse.FromCloudFormation.getString(properties.FieldValue) : void 0), ret.addPropertyResult("specialValue", "SpecialValue", properties.SpecialValue != null ? cfn_parse.FromCloudFormation.getString(properties.SpecialValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_CustomContentConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contentType", cdk.validateString)(properties.contentType)), errors.collect(cdk.propertyValidator("contentUrl", cdk.validateString)(properties.contentUrl)), errors.collect(cdk.propertyValidator("imageScaling", cdk.validateString)(properties.imageScaling)), errors.wrap('supplied properties not correct for "CustomContentConfigurationProperty"');
    }
    function cfnDashboardCustomContentConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_CustomContentConfigurationPropertyValidator(properties).assertSuccess(), { ContentType: cdk.stringToCloudFormation(properties.contentType), ContentUrl: cdk.stringToCloudFormation(properties.contentUrl), ImageScaling: cdk.stringToCloudFormation(properties.imageScaling) }) : properties;
    }
    function CfnDashboardCustomContentConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contentType", "ContentType", properties.ContentType != null ? cfn_parse.FromCloudFormation.getString(properties.ContentType) : void 0), ret.addPropertyResult("contentUrl", "ContentUrl", properties.ContentUrl != null ? cfn_parse.FromCloudFormation.getString(properties.ContentUrl) : void 0), ret.addPropertyResult("imageScaling", "ImageScaling", properties.ImageScaling != null ? cfn_parse.FromCloudFormation.getString(properties.ImageScaling) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_CustomContentVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnDashboard_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnDashboard_CustomContentConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.requiredValidator)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.validateString)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("subtitle", CfnDashboard_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnDashboard_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "CustomContentVisualProperty"');
    }
    function cfnDashboardCustomContentVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_CustomContentVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnDashboardVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnDashboardCustomContentConfigurationPropertyToCloudFormation(properties.chartConfiguration), DataSetIdentifier: cdk.stringToCloudFormation(properties.dataSetIdentifier), Subtitle: cfnDashboardVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnDashboardVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnDashboardCustomContentVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnDashboardCustomContentConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("dataSetIdentifier", "DataSetIdentifier", cfn_parse.FromCloudFormation.getString(properties.DataSetIdentifier)), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnDashboardVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnDashboardVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_CustomFilterConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryValue", cdk.validateString)(properties.categoryValue)), errors.collect(cdk.propertyValidator("matchOperator", cdk.requiredValidator)(properties.matchOperator)), errors.collect(cdk.propertyValidator("matchOperator", cdk.validateString)(properties.matchOperator)), errors.collect(cdk.propertyValidator("nullOption", cdk.requiredValidator)(properties.nullOption)), errors.collect(cdk.propertyValidator("nullOption", cdk.validateString)(properties.nullOption)), errors.collect(cdk.propertyValidator("parameterName", cdk.validateString)(properties.parameterName)), errors.collect(cdk.propertyValidator("selectAllOptions", cdk.validateString)(properties.selectAllOptions)), errors.wrap('supplied properties not correct for "CustomFilterConfigurationProperty"');
    }
    function cfnDashboardCustomFilterConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_CustomFilterConfigurationPropertyValidator(properties).assertSuccess(), { CategoryValue: cdk.stringToCloudFormation(properties.categoryValue), MatchOperator: cdk.stringToCloudFormation(properties.matchOperator), NullOption: cdk.stringToCloudFormation(properties.nullOption), ParameterName: cdk.stringToCloudFormation(properties.parameterName), SelectAllOptions: cdk.stringToCloudFormation(properties.selectAllOptions) }) : properties;
    }
    function CfnDashboardCustomFilterConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryValue", "CategoryValue", properties.CategoryValue != null ? cfn_parse.FromCloudFormation.getString(properties.CategoryValue) : void 0), ret.addPropertyResult("matchOperator", "MatchOperator", cfn_parse.FromCloudFormation.getString(properties.MatchOperator)), ret.addPropertyResult("nullOption", "NullOption", cfn_parse.FromCloudFormation.getString(properties.NullOption)), ret.addPropertyResult("parameterName", "ParameterName", properties.ParameterName != null ? cfn_parse.FromCloudFormation.getString(properties.ParameterName) : void 0), ret.addPropertyResult("selectAllOptions", "SelectAllOptions", properties.SelectAllOptions != null ? cfn_parse.FromCloudFormation.getString(properties.SelectAllOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_CustomFilterListConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryValues", cdk.listValidator(cdk.validateString))(properties.categoryValues)), errors.collect(cdk.propertyValidator("matchOperator", cdk.requiredValidator)(properties.matchOperator)), errors.collect(cdk.propertyValidator("matchOperator", cdk.validateString)(properties.matchOperator)), errors.collect(cdk.propertyValidator("nullOption", cdk.requiredValidator)(properties.nullOption)), errors.collect(cdk.propertyValidator("nullOption", cdk.validateString)(properties.nullOption)), errors.collect(cdk.propertyValidator("selectAllOptions", cdk.validateString)(properties.selectAllOptions)), errors.wrap('supplied properties not correct for "CustomFilterListConfigurationProperty"');
    }
    function cfnDashboardCustomFilterListConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_CustomFilterListConfigurationPropertyValidator(properties).assertSuccess(), { CategoryValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.categoryValues), MatchOperator: cdk.stringToCloudFormation(properties.matchOperator), NullOption: cdk.stringToCloudFormation(properties.nullOption), SelectAllOptions: cdk.stringToCloudFormation(properties.selectAllOptions) }) : properties;
    }
    function CfnDashboardCustomFilterListConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryValues", "CategoryValues", properties.CategoryValues != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CategoryValues) : void 0), ret.addPropertyResult("matchOperator", "MatchOperator", cfn_parse.FromCloudFormation.getString(properties.MatchOperator)), ret.addPropertyResult("nullOption", "NullOption", cfn_parse.FromCloudFormation.getString(properties.NullOption)), ret.addPropertyResult("selectAllOptions", "SelectAllOptions", properties.SelectAllOptions != null ? cfn_parse.FromCloudFormation.getString(properties.SelectAllOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_CustomNarrativeOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("narrative", cdk.requiredValidator)(properties.narrative)), errors.collect(cdk.propertyValidator("narrative", cdk.validateString)(properties.narrative)), errors.wrap('supplied properties not correct for "CustomNarrativeOptionsProperty"');
    }
    function cfnDashboardCustomNarrativeOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_CustomNarrativeOptionsPropertyValidator(properties).assertSuccess(), { Narrative: cdk.stringToCloudFormation(properties.narrative) }) : properties;
    }
    function CfnDashboardCustomNarrativeOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("narrative", "Narrative", cfn_parse.FromCloudFormation.getString(properties.Narrative)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_CustomParameterValuesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateTimeValues", cdk.listValidator(cdk.validateString))(properties.dateTimeValues)), errors.collect(cdk.propertyValidator("decimalValues", cdk.listValidator(cdk.validateNumber))(properties.decimalValues)), errors.collect(cdk.propertyValidator("integerValues", cdk.listValidator(cdk.validateNumber))(properties.integerValues)), errors.collect(cdk.propertyValidator("stringValues", cdk.listValidator(cdk.validateString))(properties.stringValues)), errors.wrap('supplied properties not correct for "CustomParameterValuesProperty"');
    }
    function cfnDashboardCustomParameterValuesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_CustomParameterValuesPropertyValidator(properties).assertSuccess(), { DateTimeValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.dateTimeValues), DecimalValues: cdk.listMapper(cdk.numberToCloudFormation)(properties.decimalValues), IntegerValues: cdk.listMapper(cdk.numberToCloudFormation)(properties.integerValues), StringValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.stringValues) }) : properties;
    }
    function CfnDashboardCustomParameterValuesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateTimeValues", "DateTimeValues", properties.DateTimeValues != null ? cfn_parse.FromCloudFormation.getStringArray(properties.DateTimeValues) : void 0), ret.addPropertyResult("decimalValues", "DecimalValues", properties.DecimalValues != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getNumber)(properties.DecimalValues) : void 0), ret.addPropertyResult("integerValues", "IntegerValues", properties.IntegerValues != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getNumber)(properties.IntegerValues) : void 0), ret.addPropertyResult("stringValues", "StringValues", properties.StringValues != null ? cfn_parse.FromCloudFormation.getStringArray(properties.StringValues) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_CustomValuesConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customValues", cdk.requiredValidator)(properties.customValues)), errors.collect(cdk.propertyValidator("customValues", CfnDashboard_CustomParameterValuesPropertyValidator)(properties.customValues)), errors.collect(cdk.propertyValidator("includeNullValue", cdk.validateBoolean)(properties.includeNullValue)), errors.wrap('supplied properties not correct for "CustomValuesConfigurationProperty"');
    }
    function cfnDashboardCustomValuesConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_CustomValuesConfigurationPropertyValidator(properties).assertSuccess(), { CustomValues: cfnDashboardCustomParameterValuesPropertyToCloudFormation(properties.customValues), IncludeNullValue: cdk.booleanToCloudFormation(properties.includeNullValue) }) : properties;
    }
    function CfnDashboardCustomValuesConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customValues", "CustomValues", CfnDashboardCustomParameterValuesPropertyFromCloudFormation(properties.CustomValues)), ret.addPropertyResult("includeNullValue", "IncludeNullValue", properties.IncludeNullValue != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeNullValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DashboardPublishOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("adHocFilteringOption", CfnDashboard_AdHocFilteringOptionPropertyValidator)(properties.adHocFilteringOption)), errors.collect(cdk.propertyValidator("dataPointDrillUpDownOption", CfnDashboard_DataPointDrillUpDownOptionPropertyValidator)(properties.dataPointDrillUpDownOption)), errors.collect(cdk.propertyValidator("dataPointMenuLabelOption", CfnDashboard_DataPointMenuLabelOptionPropertyValidator)(properties.dataPointMenuLabelOption)), errors.collect(cdk.propertyValidator("dataPointTooltipOption", CfnDashboard_DataPointTooltipOptionPropertyValidator)(properties.dataPointTooltipOption)), errors.collect(cdk.propertyValidator("exportToCsvOption", CfnDashboard_ExportToCSVOptionPropertyValidator)(properties.exportToCsvOption)), errors.collect(cdk.propertyValidator("exportWithHiddenFieldsOption", CfnDashboard_ExportWithHiddenFieldsOptionPropertyValidator)(properties.exportWithHiddenFieldsOption)), errors.collect(cdk.propertyValidator("sheetControlsOption", CfnDashboard_SheetControlsOptionPropertyValidator)(properties.sheetControlsOption)), errors.collect(cdk.propertyValidator("sheetLayoutElementMaximizationOption", CfnDashboard_SheetLayoutElementMaximizationOptionPropertyValidator)(properties.sheetLayoutElementMaximizationOption)), errors.collect(cdk.propertyValidator("visualAxisSortOption", CfnDashboard_VisualAxisSortOptionPropertyValidator)(properties.visualAxisSortOption)), errors.collect(cdk.propertyValidator("visualMenuOption", CfnDashboard_VisualMenuOptionPropertyValidator)(properties.visualMenuOption)), errors.collect(cdk.propertyValidator("visualPublishOptions", CfnDashboard_DashboardVisualPublishOptionsPropertyValidator)(properties.visualPublishOptions)), errors.wrap('supplied properties not correct for "DashboardPublishOptionsProperty"');
    }
    function cfnDashboardDashboardPublishOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DashboardPublishOptionsPropertyValidator(properties).assertSuccess(), { AdHocFilteringOption: cfnDashboardAdHocFilteringOptionPropertyToCloudFormation(properties.adHocFilteringOption), DataPointDrillUpDownOption: cfnDashboardDataPointDrillUpDownOptionPropertyToCloudFormation(properties.dataPointDrillUpDownOption), DataPointMenuLabelOption: cfnDashboardDataPointMenuLabelOptionPropertyToCloudFormation(properties.dataPointMenuLabelOption), DataPointTooltipOption: cfnDashboardDataPointTooltipOptionPropertyToCloudFormation(properties.dataPointTooltipOption), ExportToCSVOption: cfnDashboardExportToCSVOptionPropertyToCloudFormation(properties.exportToCsvOption), ExportWithHiddenFieldsOption: cfnDashboardExportWithHiddenFieldsOptionPropertyToCloudFormation(properties.exportWithHiddenFieldsOption), SheetControlsOption: cfnDashboardSheetControlsOptionPropertyToCloudFormation(properties.sheetControlsOption), SheetLayoutElementMaximizationOption: cfnDashboardSheetLayoutElementMaximizationOptionPropertyToCloudFormation(properties.sheetLayoutElementMaximizationOption), VisualAxisSortOption: cfnDashboardVisualAxisSortOptionPropertyToCloudFormation(properties.visualAxisSortOption), VisualMenuOption: cfnDashboardVisualMenuOptionPropertyToCloudFormation(properties.visualMenuOption), VisualPublishOptions: cfnDashboardDashboardVisualPublishOptionsPropertyToCloudFormation(properties.visualPublishOptions) }) : properties;
    }
    function CfnDashboardDashboardPublishOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("adHocFilteringOption", "AdHocFilteringOption", properties.AdHocFilteringOption != null ? CfnDashboardAdHocFilteringOptionPropertyFromCloudFormation(properties.AdHocFilteringOption) : void 0), ret.addPropertyResult("dataPointDrillUpDownOption", "DataPointDrillUpDownOption", properties.DataPointDrillUpDownOption != null ? CfnDashboardDataPointDrillUpDownOptionPropertyFromCloudFormation(properties.DataPointDrillUpDownOption) : void 0), ret.addPropertyResult("dataPointMenuLabelOption", "DataPointMenuLabelOption", properties.DataPointMenuLabelOption != null ? CfnDashboardDataPointMenuLabelOptionPropertyFromCloudFormation(properties.DataPointMenuLabelOption) : void 0), ret.addPropertyResult("dataPointTooltipOption", "DataPointTooltipOption", properties.DataPointTooltipOption != null ? CfnDashboardDataPointTooltipOptionPropertyFromCloudFormation(properties.DataPointTooltipOption) : void 0), ret.addPropertyResult("exportToCsvOption", "ExportToCSVOption", properties.ExportToCSVOption != null ? CfnDashboardExportToCSVOptionPropertyFromCloudFormation(properties.ExportToCSVOption) : void 0), ret.addPropertyResult("exportWithHiddenFieldsOption", "ExportWithHiddenFieldsOption", properties.ExportWithHiddenFieldsOption != null ? CfnDashboardExportWithHiddenFieldsOptionPropertyFromCloudFormation(properties.ExportWithHiddenFieldsOption) : void 0), ret.addPropertyResult("sheetControlsOption", "SheetControlsOption", properties.SheetControlsOption != null ? CfnDashboardSheetControlsOptionPropertyFromCloudFormation(properties.SheetControlsOption) : void 0), ret.addPropertyResult("sheetLayoutElementMaximizationOption", "SheetLayoutElementMaximizationOption", properties.SheetLayoutElementMaximizationOption != null ? CfnDashboardSheetLayoutElementMaximizationOptionPropertyFromCloudFormation(properties.SheetLayoutElementMaximizationOption) : void 0), ret.addPropertyResult("visualAxisSortOption", "VisualAxisSortOption", properties.VisualAxisSortOption != null ? CfnDashboardVisualAxisSortOptionPropertyFromCloudFormation(properties.VisualAxisSortOption) : void 0), ret.addPropertyResult("visualMenuOption", "VisualMenuOption", properties.VisualMenuOption != null ? CfnDashboardVisualMenuOptionPropertyFromCloudFormation(properties.VisualMenuOption) : void 0), ret.addPropertyResult("visualPublishOptions", "VisualPublishOptions", properties.VisualPublishOptions != null ? CfnDashboardDashboardVisualPublishOptionsPropertyFromCloudFormation(properties.VisualPublishOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DashboardSourceEntityPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sourceTemplate", CfnDashboard_DashboardSourceTemplatePropertyValidator)(properties.sourceTemplate)), errors.wrap('supplied properties not correct for "DashboardSourceEntityProperty"');
    }
    function cfnDashboardDashboardSourceEntityPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DashboardSourceEntityPropertyValidator(properties).assertSuccess(), { SourceTemplate: cfnDashboardDashboardSourceTemplatePropertyToCloudFormation(properties.sourceTemplate) }) : properties;
    }
    function CfnDashboardDashboardSourceEntityPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sourceTemplate", "SourceTemplate", properties.SourceTemplate != null ? CfnDashboardDashboardSourceTemplatePropertyFromCloudFormation(properties.SourceTemplate) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DashboardSourceTemplatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.requiredValidator)(properties.arn)), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("dataSetReferences", cdk.requiredValidator)(properties.dataSetReferences)), errors.collect(cdk.propertyValidator("dataSetReferences", cdk.listValidator(CfnDashboard_DataSetReferencePropertyValidator))(properties.dataSetReferences)), errors.wrap('supplied properties not correct for "DashboardSourceTemplateProperty"');
    }
    function cfnDashboardDashboardSourceTemplatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DashboardSourceTemplatePropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn), DataSetReferences: cdk.listMapper(cfnDashboardDataSetReferencePropertyToCloudFormation)(properties.dataSetReferences) }) : properties;
    }
    function CfnDashboardDashboardSourceTemplatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", cfn_parse.FromCloudFormation.getString(properties.Arn)), ret.addPropertyResult("dataSetReferences", "DataSetReferences", cfn_parse.FromCloudFormation.getArray(CfnDashboardDataSetReferencePropertyFromCloudFormation)(properties.DataSetReferences)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DashboardVersionDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("analysisDefaults", CfnDashboard_AnalysisDefaultsPropertyValidator)(properties.analysisDefaults)), errors.collect(cdk.propertyValidator("calculatedFields", cdk.listValidator(CfnDashboard_CalculatedFieldPropertyValidator))(properties.calculatedFields)), errors.collect(cdk.propertyValidator("columnConfigurations", cdk.listValidator(CfnDashboard_ColumnConfigurationPropertyValidator))(properties.columnConfigurations)), errors.collect(cdk.propertyValidator("dataSetIdentifierDeclarations", cdk.requiredValidator)(properties.dataSetIdentifierDeclarations)), errors.collect(cdk.propertyValidator("dataSetIdentifierDeclarations", cdk.listValidator(CfnDashboard_DataSetIdentifierDeclarationPropertyValidator))(properties.dataSetIdentifierDeclarations)), errors.collect(cdk.propertyValidator("filterGroups", cdk.listValidator(CfnDashboard_FilterGroupPropertyValidator))(properties.filterGroups)), errors.collect(cdk.propertyValidator("parameterDeclarations", cdk.listValidator(CfnDashboard_ParameterDeclarationPropertyValidator))(properties.parameterDeclarations)), errors.collect(cdk.propertyValidator("sheets", cdk.listValidator(CfnDashboard_SheetDefinitionPropertyValidator))(properties.sheets)), errors.wrap('supplied properties not correct for "DashboardVersionDefinitionProperty"');
    }
    function cfnDashboardDashboardVersionDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DashboardVersionDefinitionPropertyValidator(properties).assertSuccess(), { AnalysisDefaults: cfnDashboardAnalysisDefaultsPropertyToCloudFormation(properties.analysisDefaults), CalculatedFields: cdk.listMapper(cfnDashboardCalculatedFieldPropertyToCloudFormation)(properties.calculatedFields), ColumnConfigurations: cdk.listMapper(cfnDashboardColumnConfigurationPropertyToCloudFormation)(properties.columnConfigurations), DataSetIdentifierDeclarations: cdk.listMapper(cfnDashboardDataSetIdentifierDeclarationPropertyToCloudFormation)(properties.dataSetIdentifierDeclarations), FilterGroups: cdk.listMapper(cfnDashboardFilterGroupPropertyToCloudFormation)(properties.filterGroups), ParameterDeclarations: cdk.listMapper(cfnDashboardParameterDeclarationPropertyToCloudFormation)(properties.parameterDeclarations), Sheets: cdk.listMapper(cfnDashboardSheetDefinitionPropertyToCloudFormation)(properties.sheets) }) : properties;
    }
    function CfnDashboardDashboardVersionDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("analysisDefaults", "AnalysisDefaults", properties.AnalysisDefaults != null ? CfnDashboardAnalysisDefaultsPropertyFromCloudFormation(properties.AnalysisDefaults) : void 0), ret.addPropertyResult("calculatedFields", "CalculatedFields", properties.CalculatedFields != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardCalculatedFieldPropertyFromCloudFormation)(properties.CalculatedFields) : void 0), ret.addPropertyResult("columnConfigurations", "ColumnConfigurations", properties.ColumnConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardColumnConfigurationPropertyFromCloudFormation)(properties.ColumnConfigurations) : void 0), ret.addPropertyResult("dataSetIdentifierDeclarations", "DataSetIdentifierDeclarations", cfn_parse.FromCloudFormation.getArray(CfnDashboardDataSetIdentifierDeclarationPropertyFromCloudFormation)(properties.DataSetIdentifierDeclarations)), ret.addPropertyResult("filterGroups", "FilterGroups", properties.FilterGroups != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardFilterGroupPropertyFromCloudFormation)(properties.FilterGroups) : void 0), ret.addPropertyResult("parameterDeclarations", "ParameterDeclarations", properties.ParameterDeclarations != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardParameterDeclarationPropertyFromCloudFormation)(properties.ParameterDeclarations) : void 0), ret.addPropertyResult("sheets", "Sheets", properties.Sheets != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardSheetDefinitionPropertyFromCloudFormation)(properties.Sheets) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DashboardVisualPublishOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("exportHiddenFieldsOption", CfnDashboard_ExportHiddenFieldsOptionPropertyValidator)(properties.exportHiddenFieldsOption)), errors.wrap('supplied properties not correct for "DashboardVisualPublishOptionsProperty"');
    }
    function cfnDashboardDashboardVisualPublishOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DashboardVisualPublishOptionsPropertyValidator(properties).assertSuccess(), { ExportHiddenFieldsOption: cfnDashboardExportHiddenFieldsOptionPropertyToCloudFormation(properties.exportHiddenFieldsOption) }) : properties;
    }
    function CfnDashboardDashboardVisualPublishOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("exportHiddenFieldsOption", "ExportHiddenFieldsOption", properties.ExportHiddenFieldsOption != null ? CfnDashboardExportHiddenFieldsOptionPropertyFromCloudFormation(properties.ExportHiddenFieldsOption) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DataBarsOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("negativeColor", cdk.validateString)(properties.negativeColor)), errors.collect(cdk.propertyValidator("positiveColor", cdk.validateString)(properties.positiveColor)), errors.wrap('supplied properties not correct for "DataBarsOptionsProperty"');
    }
    function cfnDashboardDataBarsOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DataBarsOptionsPropertyValidator(properties).assertSuccess(), { FieldId: cdk.stringToCloudFormation(properties.fieldId), NegativeColor: cdk.stringToCloudFormation(properties.negativeColor), PositiveColor: cdk.stringToCloudFormation(properties.positiveColor) }) : properties;
    }
    function CfnDashboardDataBarsOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("negativeColor", "NegativeColor", properties.NegativeColor != null ? cfn_parse.FromCloudFormation.getString(properties.NegativeColor) : void 0), ret.addPropertyResult("positiveColor", "PositiveColor", properties.PositiveColor != null ? cfn_parse.FromCloudFormation.getString(properties.PositiveColor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DataColorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.collect(cdk.propertyValidator("dataValue", cdk.validateNumber)(properties.dataValue)), errors.wrap('supplied properties not correct for "DataColorProperty"');
    }
    function cfnDashboardDataColorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DataColorPropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color), DataValue: cdk.numberToCloudFormation(properties.dataValue) }) : properties;
    }
    function CfnDashboardDataColorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", properties.Color != null ? cfn_parse.FromCloudFormation.getString(properties.Color) : void 0), ret.addPropertyResult("dataValue", "DataValue", properties.DataValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.DataValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DataFieldSeriesItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("axisBinding", cdk.requiredValidator)(properties.axisBinding)), errors.collect(cdk.propertyValidator("axisBinding", cdk.validateString)(properties.axisBinding)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldValue", cdk.validateString)(properties.fieldValue)), errors.collect(cdk.propertyValidator("settings", CfnDashboard_LineChartSeriesSettingsPropertyValidator)(properties.settings)), errors.wrap('supplied properties not correct for "DataFieldSeriesItemProperty"');
    }
    function cfnDashboardDataFieldSeriesItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DataFieldSeriesItemPropertyValidator(properties).assertSuccess(), { AxisBinding: cdk.stringToCloudFormation(properties.axisBinding), FieldId: cdk.stringToCloudFormation(properties.fieldId), FieldValue: cdk.stringToCloudFormation(properties.fieldValue), Settings: cfnDashboardLineChartSeriesSettingsPropertyToCloudFormation(properties.settings) }) : properties;
    }
    function CfnDashboardDataFieldSeriesItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("axisBinding", "AxisBinding", cfn_parse.FromCloudFormation.getString(properties.AxisBinding)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("fieldValue", "FieldValue", properties.FieldValue != null ? cfn_parse.FromCloudFormation.getString(properties.FieldValue) : void 0), ret.addPropertyResult("settings", "Settings", properties.Settings != null ? CfnDashboardLineChartSeriesSettingsPropertyFromCloudFormation(properties.Settings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DataLabelOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryLabelVisibility", cdk.validateString)(properties.categoryLabelVisibility)), errors.collect(cdk.propertyValidator("dataLabelTypes", cdk.listValidator(CfnDashboard_DataLabelTypePropertyValidator))(properties.dataLabelTypes)), errors.collect(cdk.propertyValidator("labelColor", cdk.validateString)(properties.labelColor)), errors.collect(cdk.propertyValidator("labelContent", cdk.validateString)(properties.labelContent)), errors.collect(cdk.propertyValidator("labelFontConfiguration", CfnDashboard_FontConfigurationPropertyValidator)(properties.labelFontConfiguration)), errors.collect(cdk.propertyValidator("measureLabelVisibility", cdk.validateString)(properties.measureLabelVisibility)), errors.collect(cdk.propertyValidator("overlap", cdk.validateString)(properties.overlap)), errors.collect(cdk.propertyValidator("position", cdk.validateString)(properties.position)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "DataLabelOptionsProperty"');
    }
    function cfnDashboardDataLabelOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DataLabelOptionsPropertyValidator(properties).assertSuccess(), { CategoryLabelVisibility: cdk.stringToCloudFormation(properties.categoryLabelVisibility), DataLabelTypes: cdk.listMapper(cfnDashboardDataLabelTypePropertyToCloudFormation)(properties.dataLabelTypes), LabelColor: cdk.stringToCloudFormation(properties.labelColor), LabelContent: cdk.stringToCloudFormation(properties.labelContent), LabelFontConfiguration: cfnDashboardFontConfigurationPropertyToCloudFormation(properties.labelFontConfiguration), MeasureLabelVisibility: cdk.stringToCloudFormation(properties.measureLabelVisibility), Overlap: cdk.stringToCloudFormation(properties.overlap), Position: cdk.stringToCloudFormation(properties.position), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnDashboardDataLabelOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryLabelVisibility", "CategoryLabelVisibility", properties.CategoryLabelVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.CategoryLabelVisibility) : void 0), ret.addPropertyResult("dataLabelTypes", "DataLabelTypes", properties.DataLabelTypes != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDataLabelTypePropertyFromCloudFormation)(properties.DataLabelTypes) : void 0), ret.addPropertyResult("labelColor", "LabelColor", properties.LabelColor != null ? cfn_parse.FromCloudFormation.getString(properties.LabelColor) : void 0), ret.addPropertyResult("labelContent", "LabelContent", properties.LabelContent != null ? cfn_parse.FromCloudFormation.getString(properties.LabelContent) : void 0), ret.addPropertyResult("labelFontConfiguration", "LabelFontConfiguration", properties.LabelFontConfiguration != null ? CfnDashboardFontConfigurationPropertyFromCloudFormation(properties.LabelFontConfiguration) : void 0), ret.addPropertyResult("measureLabelVisibility", "MeasureLabelVisibility", properties.MeasureLabelVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.MeasureLabelVisibility) : void 0), ret.addPropertyResult("overlap", "Overlap", properties.Overlap != null ? cfn_parse.FromCloudFormation.getString(properties.Overlap) : void 0), ret.addPropertyResult("position", "Position", properties.Position != null ? cfn_parse.FromCloudFormation.getString(properties.Position) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DataLabelTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataPathLabelType", CfnDashboard_DataPathLabelTypePropertyValidator)(properties.dataPathLabelType)), errors.collect(cdk.propertyValidator("fieldLabelType", CfnDashboard_FieldLabelTypePropertyValidator)(properties.fieldLabelType)), errors.collect(cdk.propertyValidator("maximumLabelType", CfnDashboard_MaximumLabelTypePropertyValidator)(properties.maximumLabelType)), errors.collect(cdk.propertyValidator("minimumLabelType", CfnDashboard_MinimumLabelTypePropertyValidator)(properties.minimumLabelType)), errors.collect(cdk.propertyValidator("rangeEndsLabelType", CfnDashboard_RangeEndsLabelTypePropertyValidator)(properties.rangeEndsLabelType)), errors.wrap('supplied properties not correct for "DataLabelTypeProperty"');
    }
    function cfnDashboardDataLabelTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DataLabelTypePropertyValidator(properties).assertSuccess(), { DataPathLabelType: cfnDashboardDataPathLabelTypePropertyToCloudFormation(properties.dataPathLabelType), FieldLabelType: cfnDashboardFieldLabelTypePropertyToCloudFormation(properties.fieldLabelType), MaximumLabelType: cfnDashboardMaximumLabelTypePropertyToCloudFormation(properties.maximumLabelType), MinimumLabelType: cfnDashboardMinimumLabelTypePropertyToCloudFormation(properties.minimumLabelType), RangeEndsLabelType: cfnDashboardRangeEndsLabelTypePropertyToCloudFormation(properties.rangeEndsLabelType) }) : properties;
    }
    function CfnDashboardDataLabelTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataPathLabelType", "DataPathLabelType", properties.DataPathLabelType != null ? CfnDashboardDataPathLabelTypePropertyFromCloudFormation(properties.DataPathLabelType) : void 0), ret.addPropertyResult("fieldLabelType", "FieldLabelType", properties.FieldLabelType != null ? CfnDashboardFieldLabelTypePropertyFromCloudFormation(properties.FieldLabelType) : void 0), ret.addPropertyResult("maximumLabelType", "MaximumLabelType", properties.MaximumLabelType != null ? CfnDashboardMaximumLabelTypePropertyFromCloudFormation(properties.MaximumLabelType) : void 0), ret.addPropertyResult("minimumLabelType", "MinimumLabelType", properties.MinimumLabelType != null ? CfnDashboardMinimumLabelTypePropertyFromCloudFormation(properties.MinimumLabelType) : void 0), ret.addPropertyResult("rangeEndsLabelType", "RangeEndsLabelType", properties.RangeEndsLabelType != null ? CfnDashboardRangeEndsLabelTypePropertyFromCloudFormation(properties.RangeEndsLabelType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DataPathColorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.requiredValidator)(properties.color)), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.collect(cdk.propertyValidator("element", cdk.requiredValidator)(properties.element)), errors.collect(cdk.propertyValidator("element", CfnDashboard_DataPathValuePropertyValidator)(properties.element)), errors.collect(cdk.propertyValidator("timeGranularity", cdk.validateString)(properties.timeGranularity)), errors.wrap('supplied properties not correct for "DataPathColorProperty"');
    }
    function cfnDashboardDataPathColorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DataPathColorPropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color), Element: cfnDashboardDataPathValuePropertyToCloudFormation(properties.element), TimeGranularity: cdk.stringToCloudFormation(properties.timeGranularity) }) : properties;
    }
    function CfnDashboardDataPathColorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", cfn_parse.FromCloudFormation.getString(properties.Color)), ret.addPropertyResult("element", "Element", CfnDashboardDataPathValuePropertyFromCloudFormation(properties.Element)), ret.addPropertyResult("timeGranularity", "TimeGranularity", properties.TimeGranularity != null ? cfn_parse.FromCloudFormation.getString(properties.TimeGranularity) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DataPathLabelTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldValue", cdk.validateString)(properties.fieldValue)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "DataPathLabelTypeProperty"');
    }
    function cfnDashboardDataPathLabelTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DataPathLabelTypePropertyValidator(properties).assertSuccess(), { FieldId: cdk.stringToCloudFormation(properties.fieldId), FieldValue: cdk.stringToCloudFormation(properties.fieldValue), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnDashboardDataPathLabelTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldId", "FieldId", properties.FieldId != null ? cfn_parse.FromCloudFormation.getString(properties.FieldId) : void 0), ret.addPropertyResult("fieldValue", "FieldValue", properties.FieldValue != null ? cfn_parse.FromCloudFormation.getString(properties.FieldValue) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DataPathSortPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("direction", cdk.requiredValidator)(properties.direction)), errors.collect(cdk.propertyValidator("direction", cdk.validateString)(properties.direction)), errors.collect(cdk.propertyValidator("sortPaths", cdk.requiredValidator)(properties.sortPaths)), errors.collect(cdk.propertyValidator("sortPaths", cdk.listValidator(CfnDashboard_DataPathValuePropertyValidator))(properties.sortPaths)), errors.wrap('supplied properties not correct for "DataPathSortProperty"');
    }
    function cfnDashboardDataPathSortPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DataPathSortPropertyValidator(properties).assertSuccess(), { Direction: cdk.stringToCloudFormation(properties.direction), SortPaths: cdk.listMapper(cfnDashboardDataPathValuePropertyToCloudFormation)(properties.sortPaths) }) : properties;
    }
    function CfnDashboardDataPathSortPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("direction", "Direction", cfn_parse.FromCloudFormation.getString(properties.Direction)), ret.addPropertyResult("sortPaths", "SortPaths", cfn_parse.FromCloudFormation.getArray(CfnDashboardDataPathValuePropertyFromCloudFormation)(properties.SortPaths)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DataPathValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldValue", cdk.requiredValidator)(properties.fieldValue)), errors.collect(cdk.propertyValidator("fieldValue", cdk.validateString)(properties.fieldValue)), errors.wrap('supplied properties not correct for "DataPathValueProperty"');
    }
    function cfnDashboardDataPathValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DataPathValuePropertyValidator(properties).assertSuccess(), { FieldId: cdk.stringToCloudFormation(properties.fieldId), FieldValue: cdk.stringToCloudFormation(properties.fieldValue) }) : properties;
    }
    function CfnDashboardDataPathValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("fieldValue", "FieldValue", cfn_parse.FromCloudFormation.getString(properties.FieldValue)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DataPointDrillUpDownOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availabilityStatus", cdk.validateString)(properties.availabilityStatus)), errors.wrap('supplied properties not correct for "DataPointDrillUpDownOptionProperty"');
    }
    function cfnDashboardDataPointDrillUpDownOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DataPointDrillUpDownOptionPropertyValidator(properties).assertSuccess(), { AvailabilityStatus: cdk.stringToCloudFormation(properties.availabilityStatus) }) : properties;
    }
    function CfnDashboardDataPointDrillUpDownOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("availabilityStatus", "AvailabilityStatus", properties.AvailabilityStatus != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityStatus) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DataPointMenuLabelOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availabilityStatus", cdk.validateString)(properties.availabilityStatus)), errors.wrap('supplied properties not correct for "DataPointMenuLabelOptionProperty"');
    }
    function cfnDashboardDataPointMenuLabelOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DataPointMenuLabelOptionPropertyValidator(properties).assertSuccess(), { AvailabilityStatus: cdk.stringToCloudFormation(properties.availabilityStatus) }) : properties;
    }
    function CfnDashboardDataPointMenuLabelOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("availabilityStatus", "AvailabilityStatus", properties.AvailabilityStatus != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityStatus) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DataPointTooltipOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availabilityStatus", cdk.validateString)(properties.availabilityStatus)), errors.wrap('supplied properties not correct for "DataPointTooltipOptionProperty"');
    }
    function cfnDashboardDataPointTooltipOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DataPointTooltipOptionPropertyValidator(properties).assertSuccess(), { AvailabilityStatus: cdk.stringToCloudFormation(properties.availabilityStatus) }) : properties;
    }
    function CfnDashboardDataPointTooltipOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("availabilityStatus", "AvailabilityStatus", properties.AvailabilityStatus != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityStatus) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DataSetIdentifierDeclarationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataSetArn", cdk.requiredValidator)(properties.dataSetArn)), errors.collect(cdk.propertyValidator("dataSetArn", cdk.validateString)(properties.dataSetArn)), errors.collect(cdk.propertyValidator("identifier", cdk.requiredValidator)(properties.identifier)), errors.collect(cdk.propertyValidator("identifier", cdk.validateString)(properties.identifier)), errors.wrap('supplied properties not correct for "DataSetIdentifierDeclarationProperty"');
    }
    function cfnDashboardDataSetIdentifierDeclarationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DataSetIdentifierDeclarationPropertyValidator(properties).assertSuccess(), { DataSetArn: cdk.stringToCloudFormation(properties.dataSetArn), Identifier: cdk.stringToCloudFormation(properties.identifier) }) : properties;
    }
    function CfnDashboardDataSetIdentifierDeclarationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataSetArn", "DataSetArn", cfn_parse.FromCloudFormation.getString(properties.DataSetArn)), ret.addPropertyResult("identifier", "Identifier", cfn_parse.FromCloudFormation.getString(properties.Identifier)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DataSetReferencePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataSetArn", cdk.requiredValidator)(properties.dataSetArn)), errors.collect(cdk.propertyValidator("dataSetArn", cdk.validateString)(properties.dataSetArn)), errors.collect(cdk.propertyValidator("dataSetPlaceholder", cdk.requiredValidator)(properties.dataSetPlaceholder)), errors.collect(cdk.propertyValidator("dataSetPlaceholder", cdk.validateString)(properties.dataSetPlaceholder)), errors.wrap('supplied properties not correct for "DataSetReferenceProperty"');
    }
    function cfnDashboardDataSetReferencePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DataSetReferencePropertyValidator(properties).assertSuccess(), { DataSetArn: cdk.stringToCloudFormation(properties.dataSetArn), DataSetPlaceholder: cdk.stringToCloudFormation(properties.dataSetPlaceholder) }) : properties;
    }
    function CfnDashboardDataSetReferencePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataSetArn", "DataSetArn", cfn_parse.FromCloudFormation.getString(properties.DataSetArn)), ret.addPropertyResult("dataSetPlaceholder", "DataSetPlaceholder", cfn_parse.FromCloudFormation.getString(properties.DataSetPlaceholder)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DateAxisOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("missingDateVisibility", cdk.validateString)(properties.missingDateVisibility)), errors.wrap('supplied properties not correct for "DateAxisOptionsProperty"');
    }
    function cfnDashboardDateAxisOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DateAxisOptionsPropertyValidator(properties).assertSuccess(), { MissingDateVisibility: cdk.stringToCloudFormation(properties.missingDateVisibility) }) : properties;
    }
    function CfnDashboardDateAxisOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("missingDateVisibility", "MissingDateVisibility", properties.MissingDateVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.MissingDateVisibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DateDimensionFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnDashboard_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("dateGranularity", cdk.validateString)(properties.dateGranularity)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("formatConfiguration", CfnDashboard_DateTimeFormatConfigurationPropertyValidator)(properties.formatConfiguration)), errors.collect(cdk.propertyValidator("hierarchyId", cdk.validateString)(properties.hierarchyId)), errors.wrap('supplied properties not correct for "DateDimensionFieldProperty"');
    }
    function cfnDashboardDateDimensionFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DateDimensionFieldPropertyValidator(properties).assertSuccess(), { Column: cfnDashboardColumnIdentifierPropertyToCloudFormation(properties.column), DateGranularity: cdk.stringToCloudFormation(properties.dateGranularity), FieldId: cdk.stringToCloudFormation(properties.fieldId), FormatConfiguration: cfnDashboardDateTimeFormatConfigurationPropertyToCloudFormation(properties.formatConfiguration), HierarchyId: cdk.stringToCloudFormation(properties.hierarchyId) }) : properties;
    }
    function CfnDashboardDateDimensionFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", CfnDashboardColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("dateGranularity", "DateGranularity", properties.DateGranularity != null ? cfn_parse.FromCloudFormation.getString(properties.DateGranularity) : void 0), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("formatConfiguration", "FormatConfiguration", properties.FormatConfiguration != null ? CfnDashboardDateTimeFormatConfigurationPropertyFromCloudFormation(properties.FormatConfiguration) : void 0), ret.addPropertyResult("hierarchyId", "HierarchyId", properties.HierarchyId != null ? cfn_parse.FromCloudFormation.getString(properties.HierarchyId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DateMeasureFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationFunction", cdk.validateString)(properties.aggregationFunction)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnDashboard_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("formatConfiguration", CfnDashboard_DateTimeFormatConfigurationPropertyValidator)(properties.formatConfiguration)), errors.wrap('supplied properties not correct for "DateMeasureFieldProperty"');
    }
    function cfnDashboardDateMeasureFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DateMeasureFieldPropertyValidator(properties).assertSuccess(), { AggregationFunction: cdk.stringToCloudFormation(properties.aggregationFunction), Column: cfnDashboardColumnIdentifierPropertyToCloudFormation(properties.column), FieldId: cdk.stringToCloudFormation(properties.fieldId), FormatConfiguration: cfnDashboardDateTimeFormatConfigurationPropertyToCloudFormation(properties.formatConfiguration) }) : properties;
    }
    function CfnDashboardDateMeasureFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationFunction", "AggregationFunction", properties.AggregationFunction != null ? cfn_parse.FromCloudFormation.getString(properties.AggregationFunction) : void 0), ret.addPropertyResult("column", "Column", CfnDashboardColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("formatConfiguration", "FormatConfiguration", properties.FormatConfiguration != null ? CfnDashboardDateTimeFormatConfigurationPropertyFromCloudFormation(properties.FormatConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DateTimeDefaultValuesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dynamicValue", CfnDashboard_DynamicDefaultValuePropertyValidator)(properties.dynamicValue)), errors.collect(cdk.propertyValidator("rollingDate", CfnDashboard_RollingDateConfigurationPropertyValidator)(properties.rollingDate)), errors.collect(cdk.propertyValidator("staticValues", cdk.listValidator(cdk.validateString))(properties.staticValues)), errors.wrap('supplied properties not correct for "DateTimeDefaultValuesProperty"');
    }
    function cfnDashboardDateTimeDefaultValuesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DateTimeDefaultValuesPropertyValidator(properties).assertSuccess(), { DynamicValue: cfnDashboardDynamicDefaultValuePropertyToCloudFormation(properties.dynamicValue), RollingDate: cfnDashboardRollingDateConfigurationPropertyToCloudFormation(properties.rollingDate), StaticValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.staticValues) }) : properties;
    }
    function CfnDashboardDateTimeDefaultValuesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dynamicValue", "DynamicValue", properties.DynamicValue != null ? CfnDashboardDynamicDefaultValuePropertyFromCloudFormation(properties.DynamicValue) : void 0), ret.addPropertyResult("rollingDate", "RollingDate", properties.RollingDate != null ? CfnDashboardRollingDateConfigurationPropertyFromCloudFormation(properties.RollingDate) : void 0), ret.addPropertyResult("staticValues", "StaticValues", properties.StaticValues != null ? cfn_parse.FromCloudFormation.getStringArray(properties.StaticValues) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DateTimeFormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateTimeFormat", cdk.validateString)(properties.dateTimeFormat)), errors.collect(cdk.propertyValidator("nullValueFormatConfiguration", CfnDashboard_NullValueFormatConfigurationPropertyValidator)(properties.nullValueFormatConfiguration)), errors.collect(cdk.propertyValidator("numericFormatConfiguration", CfnDashboard_NumericFormatConfigurationPropertyValidator)(properties.numericFormatConfiguration)), errors.wrap('supplied properties not correct for "DateTimeFormatConfigurationProperty"');
    }
    function cfnDashboardDateTimeFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DateTimeFormatConfigurationPropertyValidator(properties).assertSuccess(), { DateTimeFormat: cdk.stringToCloudFormation(properties.dateTimeFormat), NullValueFormatConfiguration: cfnDashboardNullValueFormatConfigurationPropertyToCloudFormation(properties.nullValueFormatConfiguration), NumericFormatConfiguration: cfnDashboardNumericFormatConfigurationPropertyToCloudFormation(properties.numericFormatConfiguration) }) : properties;
    }
    function CfnDashboardDateTimeFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateTimeFormat", "DateTimeFormat", properties.DateTimeFormat != null ? cfn_parse.FromCloudFormation.getString(properties.DateTimeFormat) : void 0), ret.addPropertyResult("nullValueFormatConfiguration", "NullValueFormatConfiguration", properties.NullValueFormatConfiguration != null ? CfnDashboardNullValueFormatConfigurationPropertyFromCloudFormation(properties.NullValueFormatConfiguration) : void 0), ret.addPropertyResult("numericFormatConfiguration", "NumericFormatConfiguration", properties.NumericFormatConfiguration != null ? CfnDashboardNumericFormatConfigurationPropertyFromCloudFormation(properties.NumericFormatConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DateTimeHierarchyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("drillDownFilters", cdk.listValidator(CfnDashboard_DrillDownFilterPropertyValidator))(properties.drillDownFilters)), errors.collect(cdk.propertyValidator("hierarchyId", cdk.requiredValidator)(properties.hierarchyId)), errors.collect(cdk.propertyValidator("hierarchyId", cdk.validateString)(properties.hierarchyId)), errors.wrap('supplied properties not correct for "DateTimeHierarchyProperty"');
    }
    function cfnDashboardDateTimeHierarchyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DateTimeHierarchyPropertyValidator(properties).assertSuccess(), { DrillDownFilters: cdk.listMapper(cfnDashboardDrillDownFilterPropertyToCloudFormation)(properties.drillDownFilters), HierarchyId: cdk.stringToCloudFormation(properties.hierarchyId) }) : properties;
    }
    function CfnDashboardDateTimeHierarchyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("drillDownFilters", "DrillDownFilters", properties.DrillDownFilters != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDrillDownFilterPropertyFromCloudFormation)(properties.DrillDownFilters) : void 0), ret.addPropertyResult("hierarchyId", "HierarchyId", cfn_parse.FromCloudFormation.getString(properties.HierarchyId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DateTimeParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("values", cdk.requiredValidator)(properties.values)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "DateTimeParameterProperty"');
    }
    function cfnDashboardDateTimeParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DateTimeParameterPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnDashboardDateTimeParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("values", "Values", cfn_parse.FromCloudFormation.getStringArray(properties.Values)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DateTimeParameterDeclarationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultValues", CfnDashboard_DateTimeDefaultValuesPropertyValidator)(properties.defaultValues)), errors.collect(cdk.propertyValidator("mappedDataSetParameters", cdk.listValidator(CfnDashboard_MappedDataSetParameterPropertyValidator))(properties.mappedDataSetParameters)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("timeGranularity", cdk.validateString)(properties.timeGranularity)), errors.collect(cdk.propertyValidator("valueWhenUnset", CfnDashboard_DateTimeValueWhenUnsetConfigurationPropertyValidator)(properties.valueWhenUnset)), errors.wrap('supplied properties not correct for "DateTimeParameterDeclarationProperty"');
    }
    function cfnDashboardDateTimeParameterDeclarationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DateTimeParameterDeclarationPropertyValidator(properties).assertSuccess(), { DefaultValues: cfnDashboardDateTimeDefaultValuesPropertyToCloudFormation(properties.defaultValues), MappedDataSetParameters: cdk.listMapper(cfnDashboardMappedDataSetParameterPropertyToCloudFormation)(properties.mappedDataSetParameters), Name: cdk.stringToCloudFormation(properties.name), TimeGranularity: cdk.stringToCloudFormation(properties.timeGranularity), ValueWhenUnset: cfnDashboardDateTimeValueWhenUnsetConfigurationPropertyToCloudFormation(properties.valueWhenUnset) }) : properties;
    }
    function CfnDashboardDateTimeParameterDeclarationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultValues", "DefaultValues", properties.DefaultValues != null ? CfnDashboardDateTimeDefaultValuesPropertyFromCloudFormation(properties.DefaultValues) : void 0), ret.addPropertyResult("mappedDataSetParameters", "MappedDataSetParameters", properties.MappedDataSetParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMappedDataSetParameterPropertyFromCloudFormation)(properties.MappedDataSetParameters) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("timeGranularity", "TimeGranularity", properties.TimeGranularity != null ? cfn_parse.FromCloudFormation.getString(properties.TimeGranularity) : void 0), ret.addPropertyResult("valueWhenUnset", "ValueWhenUnset", properties.ValueWhenUnset != null ? CfnDashboardDateTimeValueWhenUnsetConfigurationPropertyFromCloudFormation(properties.ValueWhenUnset) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DateTimePickerControlDisplayOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateTimeFormat", cdk.validateString)(properties.dateTimeFormat)), errors.collect(cdk.propertyValidator("titleOptions", CfnDashboard_LabelOptionsPropertyValidator)(properties.titleOptions)), errors.wrap('supplied properties not correct for "DateTimePickerControlDisplayOptionsProperty"');
    }
    function cfnDashboardDateTimePickerControlDisplayOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DateTimePickerControlDisplayOptionsPropertyValidator(properties).assertSuccess(), { DateTimeFormat: cdk.stringToCloudFormation(properties.dateTimeFormat), TitleOptions: cfnDashboardLabelOptionsPropertyToCloudFormation(properties.titleOptions) }) : properties;
    }
    function CfnDashboardDateTimePickerControlDisplayOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateTimeFormat", "DateTimeFormat", properties.DateTimeFormat != null ? cfn_parse.FromCloudFormation.getString(properties.DateTimeFormat) : void 0), ret.addPropertyResult("titleOptions", "TitleOptions", properties.TitleOptions != null ? CfnDashboardLabelOptionsPropertyFromCloudFormation(properties.TitleOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DateTimeValueWhenUnsetConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customValue", cdk.validateString)(properties.customValue)), errors.collect(cdk.propertyValidator("valueWhenUnsetOption", cdk.validateString)(properties.valueWhenUnsetOption)), errors.wrap('supplied properties not correct for "DateTimeValueWhenUnsetConfigurationProperty"');
    }
    function cfnDashboardDateTimeValueWhenUnsetConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DateTimeValueWhenUnsetConfigurationPropertyValidator(properties).assertSuccess(), { CustomValue: cdk.stringToCloudFormation(properties.customValue), ValueWhenUnsetOption: cdk.stringToCloudFormation(properties.valueWhenUnsetOption) }) : properties;
    }
    function CfnDashboardDateTimeValueWhenUnsetConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customValue", "CustomValue", properties.CustomValue != null ? cfn_parse.FromCloudFormation.getString(properties.CustomValue) : void 0), ret.addPropertyResult("valueWhenUnsetOption", "ValueWhenUnsetOption", properties.ValueWhenUnsetOption != null ? cfn_parse.FromCloudFormation.getString(properties.ValueWhenUnsetOption) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DecimalDefaultValuesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dynamicValue", CfnDashboard_DynamicDefaultValuePropertyValidator)(properties.dynamicValue)), errors.collect(cdk.propertyValidator("staticValues", cdk.listValidator(cdk.validateNumber))(properties.staticValues)), errors.wrap('supplied properties not correct for "DecimalDefaultValuesProperty"');
    }
    function cfnDashboardDecimalDefaultValuesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DecimalDefaultValuesPropertyValidator(properties).assertSuccess(), { DynamicValue: cfnDashboardDynamicDefaultValuePropertyToCloudFormation(properties.dynamicValue), StaticValues: cdk.listMapper(cdk.numberToCloudFormation)(properties.staticValues) }) : properties;
    }
    function CfnDashboardDecimalDefaultValuesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dynamicValue", "DynamicValue", properties.DynamicValue != null ? CfnDashboardDynamicDefaultValuePropertyFromCloudFormation(properties.DynamicValue) : void 0), ret.addPropertyResult("staticValues", "StaticValues", properties.StaticValues != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getNumber)(properties.StaticValues) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DecimalParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("values", cdk.requiredValidator)(properties.values)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateNumber))(properties.values)), errors.wrap('supplied properties not correct for "DecimalParameterProperty"');
    }
    function cfnDashboardDecimalParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DecimalParameterPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Values: cdk.listMapper(cdk.numberToCloudFormation)(properties.values) }) : properties;
    }
    function CfnDashboardDecimalParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("values", "Values", cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getNumber)(properties.Values)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DecimalParameterDeclarationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultValues", CfnDashboard_DecimalDefaultValuesPropertyValidator)(properties.defaultValues)), errors.collect(cdk.propertyValidator("mappedDataSetParameters", cdk.listValidator(CfnDashboard_MappedDataSetParameterPropertyValidator))(properties.mappedDataSetParameters)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("parameterValueType", cdk.requiredValidator)(properties.parameterValueType)), errors.collect(cdk.propertyValidator("parameterValueType", cdk.validateString)(properties.parameterValueType)), errors.collect(cdk.propertyValidator("valueWhenUnset", CfnDashboard_DecimalValueWhenUnsetConfigurationPropertyValidator)(properties.valueWhenUnset)), errors.wrap('supplied properties not correct for "DecimalParameterDeclarationProperty"');
    }
    function cfnDashboardDecimalParameterDeclarationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DecimalParameterDeclarationPropertyValidator(properties).assertSuccess(), { DefaultValues: cfnDashboardDecimalDefaultValuesPropertyToCloudFormation(properties.defaultValues), MappedDataSetParameters: cdk.listMapper(cfnDashboardMappedDataSetParameterPropertyToCloudFormation)(properties.mappedDataSetParameters), Name: cdk.stringToCloudFormation(properties.name), ParameterValueType: cdk.stringToCloudFormation(properties.parameterValueType), ValueWhenUnset: cfnDashboardDecimalValueWhenUnsetConfigurationPropertyToCloudFormation(properties.valueWhenUnset) }) : properties;
    }
    function CfnDashboardDecimalParameterDeclarationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultValues", "DefaultValues", properties.DefaultValues != null ? CfnDashboardDecimalDefaultValuesPropertyFromCloudFormation(properties.DefaultValues) : void 0), ret.addPropertyResult("mappedDataSetParameters", "MappedDataSetParameters", properties.MappedDataSetParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMappedDataSetParameterPropertyFromCloudFormation)(properties.MappedDataSetParameters) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("parameterValueType", "ParameterValueType", cfn_parse.FromCloudFormation.getString(properties.ParameterValueType)), ret.addPropertyResult("valueWhenUnset", "ValueWhenUnset", properties.ValueWhenUnset != null ? CfnDashboardDecimalValueWhenUnsetConfigurationPropertyFromCloudFormation(properties.ValueWhenUnset) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DecimalPlacesConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("decimalPlaces", cdk.requiredValidator)(properties.decimalPlaces)), errors.collect(cdk.propertyValidator("decimalPlaces", cdk.validateNumber)(properties.decimalPlaces)), errors.wrap('supplied properties not correct for "DecimalPlacesConfigurationProperty"');
    }
    function cfnDashboardDecimalPlacesConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DecimalPlacesConfigurationPropertyValidator(properties).assertSuccess(), { DecimalPlaces: cdk.numberToCloudFormation(properties.decimalPlaces) }) : properties;
    }
    function CfnDashboardDecimalPlacesConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("decimalPlaces", "DecimalPlaces", cfn_parse.FromCloudFormation.getNumber(properties.DecimalPlaces)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DecimalValueWhenUnsetConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customValue", cdk.validateNumber)(properties.customValue)), errors.collect(cdk.propertyValidator("valueWhenUnsetOption", cdk.validateString)(properties.valueWhenUnsetOption)), errors.wrap('supplied properties not correct for "DecimalValueWhenUnsetConfigurationProperty"');
    }
    function cfnDashboardDecimalValueWhenUnsetConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DecimalValueWhenUnsetConfigurationPropertyValidator(properties).assertSuccess(), { CustomValue: cdk.numberToCloudFormation(properties.customValue), ValueWhenUnsetOption: cdk.stringToCloudFormation(properties.valueWhenUnsetOption) }) : properties;
    }
    function CfnDashboardDecimalValueWhenUnsetConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customValue", "CustomValue", properties.CustomValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.CustomValue) : void 0), ret.addPropertyResult("valueWhenUnsetOption", "ValueWhenUnsetOption", properties.ValueWhenUnsetOption != null ? cfn_parse.FromCloudFormation.getString(properties.ValueWhenUnsetOption) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DefaultFreeFormLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("canvasSizeOptions", cdk.requiredValidator)(properties.canvasSizeOptions)), errors.collect(cdk.propertyValidator("canvasSizeOptions", CfnDashboard_FreeFormLayoutCanvasSizeOptionsPropertyValidator)(properties.canvasSizeOptions)), errors.wrap('supplied properties not correct for "DefaultFreeFormLayoutConfigurationProperty"');
    }
    function cfnDashboardDefaultFreeFormLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DefaultFreeFormLayoutConfigurationPropertyValidator(properties).assertSuccess(), { CanvasSizeOptions: cfnDashboardFreeFormLayoutCanvasSizeOptionsPropertyToCloudFormation(properties.canvasSizeOptions) }) : properties;
    }
    function CfnDashboardDefaultFreeFormLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("canvasSizeOptions", "CanvasSizeOptions", CfnDashboardFreeFormLayoutCanvasSizeOptionsPropertyFromCloudFormation(properties.CanvasSizeOptions)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DefaultGridLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("canvasSizeOptions", cdk.requiredValidator)(properties.canvasSizeOptions)), errors.collect(cdk.propertyValidator("canvasSizeOptions", CfnDashboard_GridLayoutCanvasSizeOptionsPropertyValidator)(properties.canvasSizeOptions)), errors.wrap('supplied properties not correct for "DefaultGridLayoutConfigurationProperty"');
    }
    function cfnDashboardDefaultGridLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DefaultGridLayoutConfigurationPropertyValidator(properties).assertSuccess(), { CanvasSizeOptions: cfnDashboardGridLayoutCanvasSizeOptionsPropertyToCloudFormation(properties.canvasSizeOptions) }) : properties;
    }
    function CfnDashboardDefaultGridLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("canvasSizeOptions", "CanvasSizeOptions", CfnDashboardGridLayoutCanvasSizeOptionsPropertyFromCloudFormation(properties.CanvasSizeOptions)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DefaultInteractiveLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("freeForm", CfnDashboard_DefaultFreeFormLayoutConfigurationPropertyValidator)(properties.freeForm)), errors.collect(cdk.propertyValidator("grid", CfnDashboard_DefaultGridLayoutConfigurationPropertyValidator)(properties.grid)), errors.wrap('supplied properties not correct for "DefaultInteractiveLayoutConfigurationProperty"');
    }
    function cfnDashboardDefaultInteractiveLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DefaultInteractiveLayoutConfigurationPropertyValidator(properties).assertSuccess(), { FreeForm: cfnDashboardDefaultFreeFormLayoutConfigurationPropertyToCloudFormation(properties.freeForm), Grid: cfnDashboardDefaultGridLayoutConfigurationPropertyToCloudFormation(properties.grid) }) : properties;
    }
    function CfnDashboardDefaultInteractiveLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("freeForm", "FreeForm", properties.FreeForm != null ? CfnDashboardDefaultFreeFormLayoutConfigurationPropertyFromCloudFormation(properties.FreeForm) : void 0), ret.addPropertyResult("grid", "Grid", properties.Grid != null ? CfnDashboardDefaultGridLayoutConfigurationPropertyFromCloudFormation(properties.Grid) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DefaultNewSheetConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("interactiveLayoutConfiguration", CfnDashboard_DefaultInteractiveLayoutConfigurationPropertyValidator)(properties.interactiveLayoutConfiguration)), errors.collect(cdk.propertyValidator("paginatedLayoutConfiguration", CfnDashboard_DefaultPaginatedLayoutConfigurationPropertyValidator)(properties.paginatedLayoutConfiguration)), errors.collect(cdk.propertyValidator("sheetContentType", cdk.validateString)(properties.sheetContentType)), errors.wrap('supplied properties not correct for "DefaultNewSheetConfigurationProperty"');
    }
    function cfnDashboardDefaultNewSheetConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DefaultNewSheetConfigurationPropertyValidator(properties).assertSuccess(), { InteractiveLayoutConfiguration: cfnDashboardDefaultInteractiveLayoutConfigurationPropertyToCloudFormation(properties.interactiveLayoutConfiguration), PaginatedLayoutConfiguration: cfnDashboardDefaultPaginatedLayoutConfigurationPropertyToCloudFormation(properties.paginatedLayoutConfiguration), SheetContentType: cdk.stringToCloudFormation(properties.sheetContentType) }) : properties;
    }
    function CfnDashboardDefaultNewSheetConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("interactiveLayoutConfiguration", "InteractiveLayoutConfiguration", properties.InteractiveLayoutConfiguration != null ? CfnDashboardDefaultInteractiveLayoutConfigurationPropertyFromCloudFormation(properties.InteractiveLayoutConfiguration) : void 0), ret.addPropertyResult("paginatedLayoutConfiguration", "PaginatedLayoutConfiguration", properties.PaginatedLayoutConfiguration != null ? CfnDashboardDefaultPaginatedLayoutConfigurationPropertyFromCloudFormation(properties.PaginatedLayoutConfiguration) : void 0), ret.addPropertyResult("sheetContentType", "SheetContentType", properties.SheetContentType != null ? cfn_parse.FromCloudFormation.getString(properties.SheetContentType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DefaultPaginatedLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sectionBased", CfnDashboard_DefaultSectionBasedLayoutConfigurationPropertyValidator)(properties.sectionBased)), errors.wrap('supplied properties not correct for "DefaultPaginatedLayoutConfigurationProperty"');
    }
    function cfnDashboardDefaultPaginatedLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DefaultPaginatedLayoutConfigurationPropertyValidator(properties).assertSuccess(), { SectionBased: cfnDashboardDefaultSectionBasedLayoutConfigurationPropertyToCloudFormation(properties.sectionBased) }) : properties;
    }
    function CfnDashboardDefaultPaginatedLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sectionBased", "SectionBased", properties.SectionBased != null ? CfnDashboardDefaultSectionBasedLayoutConfigurationPropertyFromCloudFormation(properties.SectionBased) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DefaultSectionBasedLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("canvasSizeOptions", cdk.requiredValidator)(properties.canvasSizeOptions)), errors.collect(cdk.propertyValidator("canvasSizeOptions", CfnDashboard_SectionBasedLayoutCanvasSizeOptionsPropertyValidator)(properties.canvasSizeOptions)), errors.wrap('supplied properties not correct for "DefaultSectionBasedLayoutConfigurationProperty"');
    }
    function cfnDashboardDefaultSectionBasedLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DefaultSectionBasedLayoutConfigurationPropertyValidator(properties).assertSuccess(), { CanvasSizeOptions: cfnDashboardSectionBasedLayoutCanvasSizeOptionsPropertyToCloudFormation(properties.canvasSizeOptions) }) : properties;
    }
    function CfnDashboardDefaultSectionBasedLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("canvasSizeOptions", "CanvasSizeOptions", CfnDashboardSectionBasedLayoutCanvasSizeOptionsPropertyFromCloudFormation(properties.CanvasSizeOptions)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DestinationParameterValueConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customValuesConfiguration", CfnDashboard_CustomValuesConfigurationPropertyValidator)(properties.customValuesConfiguration)), errors.collect(cdk.propertyValidator("selectAllValueOptions", cdk.validateString)(properties.selectAllValueOptions)), errors.collect(cdk.propertyValidator("sourceField", cdk.validateString)(properties.sourceField)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.validateString)(properties.sourceParameterName)), errors.wrap('supplied properties not correct for "DestinationParameterValueConfigurationProperty"');
    }
    function cfnDashboardDestinationParameterValueConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DestinationParameterValueConfigurationPropertyValidator(properties).assertSuccess(), { CustomValuesConfiguration: cfnDashboardCustomValuesConfigurationPropertyToCloudFormation(properties.customValuesConfiguration), SelectAllValueOptions: cdk.stringToCloudFormation(properties.selectAllValueOptions), SourceField: cdk.stringToCloudFormation(properties.sourceField), SourceParameterName: cdk.stringToCloudFormation(properties.sourceParameterName) }) : properties;
    }
    function CfnDashboardDestinationParameterValueConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customValuesConfiguration", "CustomValuesConfiguration", properties.CustomValuesConfiguration != null ? CfnDashboardCustomValuesConfigurationPropertyFromCloudFormation(properties.CustomValuesConfiguration) : void 0), ret.addPropertyResult("selectAllValueOptions", "SelectAllValueOptions", properties.SelectAllValueOptions != null ? cfn_parse.FromCloudFormation.getString(properties.SelectAllValueOptions) : void 0), ret.addPropertyResult("sourceField", "SourceField", properties.SourceField != null ? cfn_parse.FromCloudFormation.getString(properties.SourceField) : void 0), ret.addPropertyResult("sourceParameterName", "SourceParameterName", properties.SourceParameterName != null ? cfn_parse.FromCloudFormation.getString(properties.SourceParameterName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DimensionFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoricalDimensionField", CfnDashboard_CategoricalDimensionFieldPropertyValidator)(properties.categoricalDimensionField)), errors.collect(cdk.propertyValidator("dateDimensionField", CfnDashboard_DateDimensionFieldPropertyValidator)(properties.dateDimensionField)), errors.collect(cdk.propertyValidator("numericalDimensionField", CfnDashboard_NumericalDimensionFieldPropertyValidator)(properties.numericalDimensionField)), errors.wrap('supplied properties not correct for "DimensionFieldProperty"');
    }
    function cfnDashboardDimensionFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DimensionFieldPropertyValidator(properties).assertSuccess(), { CategoricalDimensionField: cfnDashboardCategoricalDimensionFieldPropertyToCloudFormation(properties.categoricalDimensionField), DateDimensionField: cfnDashboardDateDimensionFieldPropertyToCloudFormation(properties.dateDimensionField), NumericalDimensionField: cfnDashboardNumericalDimensionFieldPropertyToCloudFormation(properties.numericalDimensionField) }) : properties;
    }
    function CfnDashboardDimensionFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoricalDimensionField", "CategoricalDimensionField", properties.CategoricalDimensionField != null ? CfnDashboardCategoricalDimensionFieldPropertyFromCloudFormation(properties.CategoricalDimensionField) : void 0), ret.addPropertyResult("dateDimensionField", "DateDimensionField", properties.DateDimensionField != null ? CfnDashboardDateDimensionFieldPropertyFromCloudFormation(properties.DateDimensionField) : void 0), ret.addPropertyResult("numericalDimensionField", "NumericalDimensionField", properties.NumericalDimensionField != null ? CfnDashboardNumericalDimensionFieldPropertyFromCloudFormation(properties.NumericalDimensionField) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DonutCenterOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("labelVisibility", cdk.validateString)(properties.labelVisibility)), errors.wrap('supplied properties not correct for "DonutCenterOptionsProperty"');
    }
    function cfnDashboardDonutCenterOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DonutCenterOptionsPropertyValidator(properties).assertSuccess(), { LabelVisibility: cdk.stringToCloudFormation(properties.labelVisibility) }) : properties;
    }
    function CfnDashboardDonutCenterOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("labelVisibility", "LabelVisibility", properties.LabelVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.LabelVisibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DonutOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arcOptions", CfnDashboard_ArcOptionsPropertyValidator)(properties.arcOptions)), errors.collect(cdk.propertyValidator("donutCenterOptions", CfnDashboard_DonutCenterOptionsPropertyValidator)(properties.donutCenterOptions)), errors.wrap('supplied properties not correct for "DonutOptionsProperty"');
    }
    function cfnDashboardDonutOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DonutOptionsPropertyValidator(properties).assertSuccess(), { ArcOptions: cfnDashboardArcOptionsPropertyToCloudFormation(properties.arcOptions), DonutCenterOptions: cfnDashboardDonutCenterOptionsPropertyToCloudFormation(properties.donutCenterOptions) }) : properties;
    }
    function CfnDashboardDonutOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arcOptions", "ArcOptions", properties.ArcOptions != null ? CfnDashboardArcOptionsPropertyFromCloudFormation(properties.ArcOptions) : void 0), ret.addPropertyResult("donutCenterOptions", "DonutCenterOptions", properties.DonutCenterOptions != null ? CfnDashboardDonutCenterOptionsPropertyFromCloudFormation(properties.DonutCenterOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DrillDownFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryFilter", CfnDashboard_CategoryDrillDownFilterPropertyValidator)(properties.categoryFilter)), errors.collect(cdk.propertyValidator("numericEqualityFilter", CfnDashboard_NumericEqualityDrillDownFilterPropertyValidator)(properties.numericEqualityFilter)), errors.collect(cdk.propertyValidator("timeRangeFilter", CfnDashboard_TimeRangeDrillDownFilterPropertyValidator)(properties.timeRangeFilter)), errors.wrap('supplied properties not correct for "DrillDownFilterProperty"');
    }
    function cfnDashboardDrillDownFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DrillDownFilterPropertyValidator(properties).assertSuccess(), { CategoryFilter: cfnDashboardCategoryDrillDownFilterPropertyToCloudFormation(properties.categoryFilter), NumericEqualityFilter: cfnDashboardNumericEqualityDrillDownFilterPropertyToCloudFormation(properties.numericEqualityFilter), TimeRangeFilter: cfnDashboardTimeRangeDrillDownFilterPropertyToCloudFormation(properties.timeRangeFilter) }) : properties;
    }
    function CfnDashboardDrillDownFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryFilter", "CategoryFilter", properties.CategoryFilter != null ? CfnDashboardCategoryDrillDownFilterPropertyFromCloudFormation(properties.CategoryFilter) : void 0), ret.addPropertyResult("numericEqualityFilter", "NumericEqualityFilter", properties.NumericEqualityFilter != null ? CfnDashboardNumericEqualityDrillDownFilterPropertyFromCloudFormation(properties.NumericEqualityFilter) : void 0), ret.addPropertyResult("timeRangeFilter", "TimeRangeFilter", properties.TimeRangeFilter != null ? CfnDashboardTimeRangeDrillDownFilterPropertyFromCloudFormation(properties.TimeRangeFilter) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DropDownControlDisplayOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("selectAllOptions", CfnDashboard_ListControlSelectAllOptionsPropertyValidator)(properties.selectAllOptions)), errors.collect(cdk.propertyValidator("titleOptions", CfnDashboard_LabelOptionsPropertyValidator)(properties.titleOptions)), errors.wrap('supplied properties not correct for "DropDownControlDisplayOptionsProperty"');
    }
    function cfnDashboardDropDownControlDisplayOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DropDownControlDisplayOptionsPropertyValidator(properties).assertSuccess(), { SelectAllOptions: cfnDashboardListControlSelectAllOptionsPropertyToCloudFormation(properties.selectAllOptions), TitleOptions: cfnDashboardLabelOptionsPropertyToCloudFormation(properties.titleOptions) }) : properties;
    }
    function CfnDashboardDropDownControlDisplayOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("selectAllOptions", "SelectAllOptions", properties.SelectAllOptions != null ? CfnDashboardListControlSelectAllOptionsPropertyFromCloudFormation(properties.SelectAllOptions) : void 0), ret.addPropertyResult("titleOptions", "TitleOptions", properties.TitleOptions != null ? CfnDashboardLabelOptionsPropertyFromCloudFormation(properties.TitleOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_DynamicDefaultValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultValueColumn", cdk.requiredValidator)(properties.defaultValueColumn)), errors.collect(cdk.propertyValidator("defaultValueColumn", CfnDashboard_ColumnIdentifierPropertyValidator)(properties.defaultValueColumn)), errors.collect(cdk.propertyValidator("groupNameColumn", CfnDashboard_ColumnIdentifierPropertyValidator)(properties.groupNameColumn)), errors.collect(cdk.propertyValidator("userNameColumn", CfnDashboard_ColumnIdentifierPropertyValidator)(properties.userNameColumn)), errors.wrap('supplied properties not correct for "DynamicDefaultValueProperty"');
    }
    function cfnDashboardDynamicDefaultValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_DynamicDefaultValuePropertyValidator(properties).assertSuccess(), { DefaultValueColumn: cfnDashboardColumnIdentifierPropertyToCloudFormation(properties.defaultValueColumn), GroupNameColumn: cfnDashboardColumnIdentifierPropertyToCloudFormation(properties.groupNameColumn), UserNameColumn: cfnDashboardColumnIdentifierPropertyToCloudFormation(properties.userNameColumn) }) : properties;
    }
    function CfnDashboardDynamicDefaultValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultValueColumn", "DefaultValueColumn", CfnDashboardColumnIdentifierPropertyFromCloudFormation(properties.DefaultValueColumn)), ret.addPropertyResult("groupNameColumn", "GroupNameColumn", properties.GroupNameColumn != null ? CfnDashboardColumnIdentifierPropertyFromCloudFormation(properties.GroupNameColumn) : void 0), ret.addPropertyResult("userNameColumn", "UserNameColumn", properties.UserNameColumn != null ? CfnDashboardColumnIdentifierPropertyFromCloudFormation(properties.UserNameColumn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_EmptyVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnDashboard_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.requiredValidator)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.validateString)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "EmptyVisualProperty"');
    }
    function cfnDashboardEmptyVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_EmptyVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnDashboardVisualCustomActionPropertyToCloudFormation)(properties.actions), DataSetIdentifier: cdk.stringToCloudFormation(properties.dataSetIdentifier), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnDashboardEmptyVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("dataSetIdentifier", "DataSetIdentifier", cfn_parse.FromCloudFormation.getString(properties.DataSetIdentifier)), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ExcludePeriodConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("amount", cdk.requiredValidator)(properties.amount)), errors.collect(cdk.propertyValidator("amount", cdk.validateNumber)(properties.amount)), errors.collect(cdk.propertyValidator("granularity", cdk.requiredValidator)(properties.granularity)), errors.collect(cdk.propertyValidator("granularity", cdk.validateString)(properties.granularity)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "ExcludePeriodConfigurationProperty"');
    }
    function cfnDashboardExcludePeriodConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ExcludePeriodConfigurationPropertyValidator(properties).assertSuccess(), { Amount: cdk.numberToCloudFormation(properties.amount), Granularity: cdk.stringToCloudFormation(properties.granularity), Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnDashboardExcludePeriodConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("amount", "Amount", cfn_parse.FromCloudFormation.getNumber(properties.Amount)), ret.addPropertyResult("granularity", "Granularity", cfn_parse.FromCloudFormation.getString(properties.Granularity)), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ExplicitHierarchyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columns", cdk.requiredValidator)(properties.columns)), errors.collect(cdk.propertyValidator("columns", cdk.listValidator(CfnDashboard_ColumnIdentifierPropertyValidator))(properties.columns)), errors.collect(cdk.propertyValidator("drillDownFilters", cdk.listValidator(CfnDashboard_DrillDownFilterPropertyValidator))(properties.drillDownFilters)), errors.collect(cdk.propertyValidator("hierarchyId", cdk.requiredValidator)(properties.hierarchyId)), errors.collect(cdk.propertyValidator("hierarchyId", cdk.validateString)(properties.hierarchyId)), errors.wrap('supplied properties not correct for "ExplicitHierarchyProperty"');
    }
    function cfnDashboardExplicitHierarchyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ExplicitHierarchyPropertyValidator(properties).assertSuccess(), { Columns: cdk.listMapper(cfnDashboardColumnIdentifierPropertyToCloudFormation)(properties.columns), DrillDownFilters: cdk.listMapper(cfnDashboardDrillDownFilterPropertyToCloudFormation)(properties.drillDownFilters), HierarchyId: cdk.stringToCloudFormation(properties.hierarchyId) }) : properties;
    }
    function CfnDashboardExplicitHierarchyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columns", "Columns", cfn_parse.FromCloudFormation.getArray(CfnDashboardColumnIdentifierPropertyFromCloudFormation)(properties.Columns)), ret.addPropertyResult("drillDownFilters", "DrillDownFilters", properties.DrillDownFilters != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDrillDownFilterPropertyFromCloudFormation)(properties.DrillDownFilters) : void 0), ret.addPropertyResult("hierarchyId", "HierarchyId", cfn_parse.FromCloudFormation.getString(properties.HierarchyId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ExportHiddenFieldsOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availabilityStatus", cdk.validateString)(properties.availabilityStatus)), errors.wrap('supplied properties not correct for "ExportHiddenFieldsOptionProperty"');
    }
    function cfnDashboardExportHiddenFieldsOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ExportHiddenFieldsOptionPropertyValidator(properties).assertSuccess(), { AvailabilityStatus: cdk.stringToCloudFormation(properties.availabilityStatus) }) : properties;
    }
    function CfnDashboardExportHiddenFieldsOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("availabilityStatus", "AvailabilityStatus", properties.AvailabilityStatus != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityStatus) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ExportToCSVOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availabilityStatus", cdk.validateString)(properties.availabilityStatus)), errors.wrap('supplied properties not correct for "ExportToCSVOptionProperty"');
    }
    function cfnDashboardExportToCSVOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ExportToCSVOptionPropertyValidator(properties).assertSuccess(), { AvailabilityStatus: cdk.stringToCloudFormation(properties.availabilityStatus) }) : properties;
    }
    function CfnDashboardExportToCSVOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("availabilityStatus", "AvailabilityStatus", properties.AvailabilityStatus != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityStatus) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ExportWithHiddenFieldsOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availabilityStatus", cdk.validateString)(properties.availabilityStatus)), errors.wrap('supplied properties not correct for "ExportWithHiddenFieldsOptionProperty"');
    }
    function cfnDashboardExportWithHiddenFieldsOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ExportWithHiddenFieldsOptionPropertyValidator(properties).assertSuccess(), { AvailabilityStatus: cdk.stringToCloudFormation(properties.availabilityStatus) }) : properties;
    }
    function CfnDashboardExportWithHiddenFieldsOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("availabilityStatus", "AvailabilityStatus", properties.AvailabilityStatus != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityStatus) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FieldBasedTooltipPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationVisibility", cdk.validateString)(properties.aggregationVisibility)), errors.collect(cdk.propertyValidator("tooltipFields", cdk.listValidator(CfnDashboard_TooltipItemPropertyValidator))(properties.tooltipFields)), errors.collect(cdk.propertyValidator("tooltipTitleType", cdk.validateString)(properties.tooltipTitleType)), errors.wrap('supplied properties not correct for "FieldBasedTooltipProperty"');
    }
    function cfnDashboardFieldBasedTooltipPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FieldBasedTooltipPropertyValidator(properties).assertSuccess(), { AggregationVisibility: cdk.stringToCloudFormation(properties.aggregationVisibility), TooltipFields: cdk.listMapper(cfnDashboardTooltipItemPropertyToCloudFormation)(properties.tooltipFields), TooltipTitleType: cdk.stringToCloudFormation(properties.tooltipTitleType) }) : properties;
    }
    function CfnDashboardFieldBasedTooltipPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationVisibility", "AggregationVisibility", properties.AggregationVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.AggregationVisibility) : void 0), ret.addPropertyResult("tooltipFields", "TooltipFields", properties.TooltipFields != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardTooltipItemPropertyFromCloudFormation)(properties.TooltipFields) : void 0), ret.addPropertyResult("tooltipTitleType", "TooltipTitleType", properties.TooltipTitleType != null ? cfn_parse.FromCloudFormation.getString(properties.TooltipTitleType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FieldLabelTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "FieldLabelTypeProperty"');
    }
    function cfnDashboardFieldLabelTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FieldLabelTypePropertyValidator(properties).assertSuccess(), { FieldId: cdk.stringToCloudFormation(properties.fieldId), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnDashboardFieldLabelTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldId", "FieldId", properties.FieldId != null ? cfn_parse.FromCloudFormation.getString(properties.FieldId) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FieldSeriesItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("axisBinding", cdk.requiredValidator)(properties.axisBinding)), errors.collect(cdk.propertyValidator("axisBinding", cdk.validateString)(properties.axisBinding)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("settings", CfnDashboard_LineChartSeriesSettingsPropertyValidator)(properties.settings)), errors.wrap('supplied properties not correct for "FieldSeriesItemProperty"');
    }
    function cfnDashboardFieldSeriesItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FieldSeriesItemPropertyValidator(properties).assertSuccess(), { AxisBinding: cdk.stringToCloudFormation(properties.axisBinding), FieldId: cdk.stringToCloudFormation(properties.fieldId), Settings: cfnDashboardLineChartSeriesSettingsPropertyToCloudFormation(properties.settings) }) : properties;
    }
    function CfnDashboardFieldSeriesItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("axisBinding", "AxisBinding", cfn_parse.FromCloudFormation.getString(properties.AxisBinding)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("settings", "Settings", properties.Settings != null ? CfnDashboardLineChartSeriesSettingsPropertyFromCloudFormation(properties.Settings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FieldSortPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("direction", cdk.requiredValidator)(properties.direction)), errors.collect(cdk.propertyValidator("direction", cdk.validateString)(properties.direction)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.wrap('supplied properties not correct for "FieldSortProperty"');
    }
    function cfnDashboardFieldSortPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FieldSortPropertyValidator(properties).assertSuccess(), { Direction: cdk.stringToCloudFormation(properties.direction), FieldId: cdk.stringToCloudFormation(properties.fieldId) }) : properties;
    }
    function CfnDashboardFieldSortPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("direction", "Direction", cfn_parse.FromCloudFormation.getString(properties.Direction)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FieldSortOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnSort", CfnDashboard_ColumnSortPropertyValidator)(properties.columnSort)), errors.collect(cdk.propertyValidator("fieldSort", CfnDashboard_FieldSortPropertyValidator)(properties.fieldSort)), errors.wrap('supplied properties not correct for "FieldSortOptionsProperty"');
    }
    function cfnDashboardFieldSortOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FieldSortOptionsPropertyValidator(properties).assertSuccess(), { ColumnSort: cfnDashboardColumnSortPropertyToCloudFormation(properties.columnSort), FieldSort: cfnDashboardFieldSortPropertyToCloudFormation(properties.fieldSort) }) : properties;
    }
    function CfnDashboardFieldSortOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columnSort", "ColumnSort", properties.ColumnSort != null ? CfnDashboardColumnSortPropertyFromCloudFormation(properties.ColumnSort) : void 0), ret.addPropertyResult("fieldSort", "FieldSort", properties.FieldSort != null ? CfnDashboardFieldSortPropertyFromCloudFormation(properties.FieldSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FieldTooltipItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("label", cdk.validateString)(properties.label)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "FieldTooltipItemProperty"');
    }
    function cfnDashboardFieldTooltipItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FieldTooltipItemPropertyValidator(properties).assertSuccess(), { FieldId: cdk.stringToCloudFormation(properties.fieldId), Label: cdk.stringToCloudFormation(properties.label), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnDashboardFieldTooltipItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("label", "Label", properties.Label != null ? cfn_parse.FromCloudFormation.getString(properties.Label) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FilledMapAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("geospatial", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.geospatial)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnDashboard_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "FilledMapAggregatedFieldWellsProperty"');
    }
    function cfnDashboardFilledMapAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FilledMapAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Geospatial: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.geospatial), Values: cdk.listMapper(cfnDashboardMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnDashboardFilledMapAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("geospatial", "Geospatial", properties.Geospatial != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.Geospatial) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FilledMapConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("conditionalFormattingOptions", cdk.requiredValidator)(properties.conditionalFormattingOptions)), errors.collect(cdk.propertyValidator("conditionalFormattingOptions", cdk.listValidator(CfnDashboard_FilledMapConditionalFormattingOptionPropertyValidator))(properties.conditionalFormattingOptions)), errors.wrap('supplied properties not correct for "FilledMapConditionalFormattingProperty"');
    }
    function cfnDashboardFilledMapConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FilledMapConditionalFormattingPropertyValidator(properties).assertSuccess(), { ConditionalFormattingOptions: cdk.listMapper(cfnDashboardFilledMapConditionalFormattingOptionPropertyToCloudFormation)(properties.conditionalFormattingOptions) }) : properties;
    }
    function CfnDashboardFilledMapConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("conditionalFormattingOptions", "ConditionalFormattingOptions", cfn_parse.FromCloudFormation.getArray(CfnDashboardFilledMapConditionalFormattingOptionPropertyFromCloudFormation)(properties.ConditionalFormattingOptions)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FilledMapConditionalFormattingOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("shape", cdk.requiredValidator)(properties.shape)), errors.collect(cdk.propertyValidator("shape", CfnDashboard_FilledMapShapeConditionalFormattingPropertyValidator)(properties.shape)), errors.wrap('supplied properties not correct for "FilledMapConditionalFormattingOptionProperty"');
    }
    function cfnDashboardFilledMapConditionalFormattingOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FilledMapConditionalFormattingOptionPropertyValidator(properties).assertSuccess(), { Shape: cfnDashboardFilledMapShapeConditionalFormattingPropertyToCloudFormation(properties.shape) }) : properties;
    }
    function CfnDashboardFilledMapConditionalFormattingOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("shape", "Shape", CfnDashboardFilledMapShapeConditionalFormattingPropertyFromCloudFormation(properties.Shape)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FilledMapConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldWells", CfnDashboard_FilledMapFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("legend", CfnDashboard_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("mapStyleOptions", CfnDashboard_GeospatialMapStyleOptionsPropertyValidator)(properties.mapStyleOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnDashboard_FilledMapSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tooltip", CfnDashboard_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.collect(cdk.propertyValidator("windowOptions", CfnDashboard_GeospatialWindowOptionsPropertyValidator)(properties.windowOptions)), errors.wrap('supplied properties not correct for "FilledMapConfigurationProperty"');
    }
    function cfnDashboardFilledMapConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FilledMapConfigurationPropertyValidator(properties).assertSuccess(), { FieldWells: cfnDashboardFilledMapFieldWellsPropertyToCloudFormation(properties.fieldWells), Legend: cfnDashboardLegendOptionsPropertyToCloudFormation(properties.legend), MapStyleOptions: cfnDashboardGeospatialMapStyleOptionsPropertyToCloudFormation(properties.mapStyleOptions), SortConfiguration: cfnDashboardFilledMapSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), Tooltip: cfnDashboardTooltipOptionsPropertyToCloudFormation(properties.tooltip), WindowOptions: cfnDashboardGeospatialWindowOptionsPropertyToCloudFormation(properties.windowOptions) }) : properties;
    }
    function CfnDashboardFilledMapConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnDashboardFilledMapFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnDashboardLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("mapStyleOptions", "MapStyleOptions", properties.MapStyleOptions != null ? CfnDashboardGeospatialMapStyleOptionsPropertyFromCloudFormation(properties.MapStyleOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnDashboardFilledMapSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnDashboardTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addPropertyResult("windowOptions", "WindowOptions", properties.WindowOptions != null ? CfnDashboardGeospatialWindowOptionsPropertyFromCloudFormation(properties.WindowOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FilledMapFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("filledMapAggregatedFieldWells", CfnDashboard_FilledMapAggregatedFieldWellsPropertyValidator)(properties.filledMapAggregatedFieldWells)), errors.wrap('supplied properties not correct for "FilledMapFieldWellsProperty"');
    }
    function cfnDashboardFilledMapFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FilledMapFieldWellsPropertyValidator(properties).assertSuccess(), { FilledMapAggregatedFieldWells: cfnDashboardFilledMapAggregatedFieldWellsPropertyToCloudFormation(properties.filledMapAggregatedFieldWells) }) : properties;
    }
    function CfnDashboardFilledMapFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("filledMapAggregatedFieldWells", "FilledMapAggregatedFieldWells", properties.FilledMapAggregatedFieldWells != null ? CfnDashboardFilledMapAggregatedFieldWellsPropertyFromCloudFormation(properties.FilledMapAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FilledMapShapeConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("format", CfnDashboard_ShapeConditionalFormatPropertyValidator)(properties.format)), errors.wrap('supplied properties not correct for "FilledMapShapeConditionalFormattingProperty"');
    }
    function cfnDashboardFilledMapShapeConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FilledMapShapeConditionalFormattingPropertyValidator(properties).assertSuccess(), { FieldId: cdk.stringToCloudFormation(properties.fieldId), Format: cfnDashboardShapeConditionalFormatPropertyToCloudFormation(properties.format) }) : properties;
    }
    function CfnDashboardFilledMapShapeConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("format", "Format", properties.Format != null ? CfnDashboardShapeConditionalFormatPropertyFromCloudFormation(properties.Format) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FilledMapSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categorySort", cdk.listValidator(CfnDashboard_FieldSortOptionsPropertyValidator))(properties.categorySort)), errors.wrap('supplied properties not correct for "FilledMapSortConfigurationProperty"');
    }
    function cfnDashboardFilledMapSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FilledMapSortConfigurationPropertyValidator(properties).assertSuccess(), { CategorySort: cdk.listMapper(cfnDashboardFieldSortOptionsPropertyToCloudFormation)(properties.categorySort) }) : properties;
    }
    function CfnDashboardFilledMapSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categorySort", "CategorySort", properties.CategorySort != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardFieldSortOptionsPropertyFromCloudFormation)(properties.CategorySort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FilledMapVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnDashboard_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnDashboard_FilledMapConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnDashboard_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("conditionalFormatting", CfnDashboard_FilledMapConditionalFormattingPropertyValidator)(properties.conditionalFormatting)), errors.collect(cdk.propertyValidator("subtitle", CfnDashboard_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnDashboard_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "FilledMapVisualProperty"');
    }
    function cfnDashboardFilledMapVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FilledMapVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnDashboardVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnDashboardFilledMapConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnDashboardColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), ConditionalFormatting: cfnDashboardFilledMapConditionalFormattingPropertyToCloudFormation(properties.conditionalFormatting), Subtitle: cfnDashboardVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnDashboardVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnDashboardFilledMapVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnDashboardFilledMapConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("conditionalFormatting", "ConditionalFormatting", properties.ConditionalFormatting != null ? CfnDashboardFilledMapConditionalFormattingPropertyFromCloudFormation(properties.ConditionalFormatting) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnDashboardVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnDashboardVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryFilter", CfnDashboard_CategoryFilterPropertyValidator)(properties.categoryFilter)), errors.collect(cdk.propertyValidator("numericEqualityFilter", CfnDashboard_NumericEqualityFilterPropertyValidator)(properties.numericEqualityFilter)), errors.collect(cdk.propertyValidator("numericRangeFilter", CfnDashboard_NumericRangeFilterPropertyValidator)(properties.numericRangeFilter)), errors.collect(cdk.propertyValidator("relativeDatesFilter", CfnDashboard_RelativeDatesFilterPropertyValidator)(properties.relativeDatesFilter)), errors.collect(cdk.propertyValidator("timeEqualityFilter", CfnDashboard_TimeEqualityFilterPropertyValidator)(properties.timeEqualityFilter)), errors.collect(cdk.propertyValidator("timeRangeFilter", CfnDashboard_TimeRangeFilterPropertyValidator)(properties.timeRangeFilter)), errors.collect(cdk.propertyValidator("topBottomFilter", CfnDashboard_TopBottomFilterPropertyValidator)(properties.topBottomFilter)), errors.wrap('supplied properties not correct for "FilterProperty"');
    }
    function cfnDashboardFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FilterPropertyValidator(properties).assertSuccess(), { CategoryFilter: cfnDashboardCategoryFilterPropertyToCloudFormation(properties.categoryFilter), NumericEqualityFilter: cfnDashboardNumericEqualityFilterPropertyToCloudFormation(properties.numericEqualityFilter), NumericRangeFilter: cfnDashboardNumericRangeFilterPropertyToCloudFormation(properties.numericRangeFilter), RelativeDatesFilter: cfnDashboardRelativeDatesFilterPropertyToCloudFormation(properties.relativeDatesFilter), TimeEqualityFilter: cfnDashboardTimeEqualityFilterPropertyToCloudFormation(properties.timeEqualityFilter), TimeRangeFilter: cfnDashboardTimeRangeFilterPropertyToCloudFormation(properties.timeRangeFilter), TopBottomFilter: cfnDashboardTopBottomFilterPropertyToCloudFormation(properties.topBottomFilter) }) : properties;
    }
    function CfnDashboardFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryFilter", "CategoryFilter", properties.CategoryFilter != null ? CfnDashboardCategoryFilterPropertyFromCloudFormation(properties.CategoryFilter) : void 0), ret.addPropertyResult("numericEqualityFilter", "NumericEqualityFilter", properties.NumericEqualityFilter != null ? CfnDashboardNumericEqualityFilterPropertyFromCloudFormation(properties.NumericEqualityFilter) : void 0), ret.addPropertyResult("numericRangeFilter", "NumericRangeFilter", properties.NumericRangeFilter != null ? CfnDashboardNumericRangeFilterPropertyFromCloudFormation(properties.NumericRangeFilter) : void 0), ret.addPropertyResult("relativeDatesFilter", "RelativeDatesFilter", properties.RelativeDatesFilter != null ? CfnDashboardRelativeDatesFilterPropertyFromCloudFormation(properties.RelativeDatesFilter) : void 0), ret.addPropertyResult("timeEqualityFilter", "TimeEqualityFilter", properties.TimeEqualityFilter != null ? CfnDashboardTimeEqualityFilterPropertyFromCloudFormation(properties.TimeEqualityFilter) : void 0), ret.addPropertyResult("timeRangeFilter", "TimeRangeFilter", properties.TimeRangeFilter != null ? CfnDashboardTimeRangeFilterPropertyFromCloudFormation(properties.TimeRangeFilter) : void 0), ret.addPropertyResult("topBottomFilter", "TopBottomFilter", properties.TopBottomFilter != null ? CfnDashboardTopBottomFilterPropertyFromCloudFormation(properties.TopBottomFilter) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FilterControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateTimePicker", CfnDashboard_FilterDateTimePickerControlPropertyValidator)(properties.dateTimePicker)), errors.collect(cdk.propertyValidator("dropdown", CfnDashboard_FilterDropDownControlPropertyValidator)(properties.dropdown)), errors.collect(cdk.propertyValidator("list", CfnDashboard_FilterListControlPropertyValidator)(properties.list)), errors.collect(cdk.propertyValidator("relativeDateTime", CfnDashboard_FilterRelativeDateTimeControlPropertyValidator)(properties.relativeDateTime)), errors.collect(cdk.propertyValidator("slider", CfnDashboard_FilterSliderControlPropertyValidator)(properties.slider)), errors.collect(cdk.propertyValidator("textArea", CfnDashboard_FilterTextAreaControlPropertyValidator)(properties.textArea)), errors.collect(cdk.propertyValidator("textField", CfnDashboard_FilterTextFieldControlPropertyValidator)(properties.textField)), errors.wrap('supplied properties not correct for "FilterControlProperty"');
    }
    function cfnDashboardFilterControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FilterControlPropertyValidator(properties).assertSuccess(), { DateTimePicker: cfnDashboardFilterDateTimePickerControlPropertyToCloudFormation(properties.dateTimePicker), Dropdown: cfnDashboardFilterDropDownControlPropertyToCloudFormation(properties.dropdown), List: cfnDashboardFilterListControlPropertyToCloudFormation(properties.list), RelativeDateTime: cfnDashboardFilterRelativeDateTimeControlPropertyToCloudFormation(properties.relativeDateTime), Slider: cfnDashboardFilterSliderControlPropertyToCloudFormation(properties.slider), TextArea: cfnDashboardFilterTextAreaControlPropertyToCloudFormation(properties.textArea), TextField: cfnDashboardFilterTextFieldControlPropertyToCloudFormation(properties.textField) }) : properties;
    }
    function CfnDashboardFilterControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateTimePicker", "DateTimePicker", properties.DateTimePicker != null ? CfnDashboardFilterDateTimePickerControlPropertyFromCloudFormation(properties.DateTimePicker) : void 0), ret.addPropertyResult("dropdown", "Dropdown", properties.Dropdown != null ? CfnDashboardFilterDropDownControlPropertyFromCloudFormation(properties.Dropdown) : void 0), ret.addPropertyResult("list", "List", properties.List != null ? CfnDashboardFilterListControlPropertyFromCloudFormation(properties.List) : void 0), ret.addPropertyResult("relativeDateTime", "RelativeDateTime", properties.RelativeDateTime != null ? CfnDashboardFilterRelativeDateTimeControlPropertyFromCloudFormation(properties.RelativeDateTime) : void 0), ret.addPropertyResult("slider", "Slider", properties.Slider != null ? CfnDashboardFilterSliderControlPropertyFromCloudFormation(properties.Slider) : void 0), ret.addPropertyResult("textArea", "TextArea", properties.TextArea != null ? CfnDashboardFilterTextAreaControlPropertyFromCloudFormation(properties.TextArea) : void 0), ret.addPropertyResult("textField", "TextField", properties.TextField != null ? CfnDashboardFilterTextFieldControlPropertyFromCloudFormation(properties.TextField) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FilterDateTimePickerControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("displayOptions", CfnDashboard_DateTimePickerControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("filterControlId", cdk.requiredValidator)(properties.filterControlId)), errors.collect(cdk.propertyValidator("filterControlId", cdk.validateString)(properties.filterControlId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.requiredValidator)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.validateString)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "FilterDateTimePickerControlProperty"');
    }
    function cfnDashboardFilterDateTimePickerControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FilterDateTimePickerControlPropertyValidator(properties).assertSuccess(), { DisplayOptions: cfnDashboardDateTimePickerControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), FilterControlId: cdk.stringToCloudFormation(properties.filterControlId), SourceFilterId: cdk.stringToCloudFormation(properties.sourceFilterId), Title: cdk.stringToCloudFormation(properties.title), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnDashboardFilterDateTimePickerControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnDashboardDateTimePickerControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("filterControlId", "FilterControlId", cfn_parse.FromCloudFormation.getString(properties.FilterControlId)), ret.addPropertyResult("sourceFilterId", "SourceFilterId", cfn_parse.FromCloudFormation.getString(properties.SourceFilterId)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FilterDropDownControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cascadingControlConfiguration", CfnDashboard_CascadingControlConfigurationPropertyValidator)(properties.cascadingControlConfiguration)), errors.collect(cdk.propertyValidator("displayOptions", CfnDashboard_DropDownControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("filterControlId", cdk.requiredValidator)(properties.filterControlId)), errors.collect(cdk.propertyValidator("filterControlId", cdk.validateString)(properties.filterControlId)), errors.collect(cdk.propertyValidator("selectableValues", CfnDashboard_FilterSelectableValuesPropertyValidator)(properties.selectableValues)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.requiredValidator)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.validateString)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "FilterDropDownControlProperty"');
    }
    function cfnDashboardFilterDropDownControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FilterDropDownControlPropertyValidator(properties).assertSuccess(), { CascadingControlConfiguration: cfnDashboardCascadingControlConfigurationPropertyToCloudFormation(properties.cascadingControlConfiguration), DisplayOptions: cfnDashboardDropDownControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), FilterControlId: cdk.stringToCloudFormation(properties.filterControlId), SelectableValues: cfnDashboardFilterSelectableValuesPropertyToCloudFormation(properties.selectableValues), SourceFilterId: cdk.stringToCloudFormation(properties.sourceFilterId), Title: cdk.stringToCloudFormation(properties.title), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnDashboardFilterDropDownControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cascadingControlConfiguration", "CascadingControlConfiguration", properties.CascadingControlConfiguration != null ? CfnDashboardCascadingControlConfigurationPropertyFromCloudFormation(properties.CascadingControlConfiguration) : void 0), ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnDashboardDropDownControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("filterControlId", "FilterControlId", cfn_parse.FromCloudFormation.getString(properties.FilterControlId)), ret.addPropertyResult("selectableValues", "SelectableValues", properties.SelectableValues != null ? CfnDashboardFilterSelectableValuesPropertyFromCloudFormation(properties.SelectableValues) : void 0), ret.addPropertyResult("sourceFilterId", "SourceFilterId", cfn_parse.FromCloudFormation.getString(properties.SourceFilterId)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FilterGroupPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("crossDataset", cdk.requiredValidator)(properties.crossDataset)), errors.collect(cdk.propertyValidator("crossDataset", cdk.validateString)(properties.crossDataset)), errors.collect(cdk.propertyValidator("filterGroupId", cdk.requiredValidator)(properties.filterGroupId)), errors.collect(cdk.propertyValidator("filterGroupId", cdk.validateString)(properties.filterGroupId)), errors.collect(cdk.propertyValidator("filters", cdk.requiredValidator)(properties.filters)), errors.collect(cdk.propertyValidator("filters", cdk.listValidator(CfnDashboard_FilterPropertyValidator))(properties.filters)), errors.collect(cdk.propertyValidator("scopeConfiguration", cdk.requiredValidator)(properties.scopeConfiguration)), errors.collect(cdk.propertyValidator("scopeConfiguration", CfnDashboard_FilterScopeConfigurationPropertyValidator)(properties.scopeConfiguration)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "FilterGroupProperty"');
    }
    function cfnDashboardFilterGroupPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FilterGroupPropertyValidator(properties).assertSuccess(), { CrossDataset: cdk.stringToCloudFormation(properties.crossDataset), FilterGroupId: cdk.stringToCloudFormation(properties.filterGroupId), Filters: cdk.listMapper(cfnDashboardFilterPropertyToCloudFormation)(properties.filters), ScopeConfiguration: cfnDashboardFilterScopeConfigurationPropertyToCloudFormation(properties.scopeConfiguration), Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnDashboardFilterGroupPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("crossDataset", "CrossDataset", cfn_parse.FromCloudFormation.getString(properties.CrossDataset)), ret.addPropertyResult("filterGroupId", "FilterGroupId", cfn_parse.FromCloudFormation.getString(properties.FilterGroupId)), ret.addPropertyResult("filters", "Filters", cfn_parse.FromCloudFormation.getArray(CfnDashboardFilterPropertyFromCloudFormation)(properties.Filters)), ret.addPropertyResult("scopeConfiguration", "ScopeConfiguration", CfnDashboardFilterScopeConfigurationPropertyFromCloudFormation(properties.ScopeConfiguration)), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FilterListConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryValues", cdk.listValidator(cdk.validateString))(properties.categoryValues)), errors.collect(cdk.propertyValidator("matchOperator", cdk.requiredValidator)(properties.matchOperator)), errors.collect(cdk.propertyValidator("matchOperator", cdk.validateString)(properties.matchOperator)), errors.collect(cdk.propertyValidator("selectAllOptions", cdk.validateString)(properties.selectAllOptions)), errors.wrap('supplied properties not correct for "FilterListConfigurationProperty"');
    }
    function cfnDashboardFilterListConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FilterListConfigurationPropertyValidator(properties).assertSuccess(), { CategoryValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.categoryValues), MatchOperator: cdk.stringToCloudFormation(properties.matchOperator), SelectAllOptions: cdk.stringToCloudFormation(properties.selectAllOptions) }) : properties;
    }
    function CfnDashboardFilterListConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryValues", "CategoryValues", properties.CategoryValues != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CategoryValues) : void 0), ret.addPropertyResult("matchOperator", "MatchOperator", cfn_parse.FromCloudFormation.getString(properties.MatchOperator)), ret.addPropertyResult("selectAllOptions", "SelectAllOptions", properties.SelectAllOptions != null ? cfn_parse.FromCloudFormation.getString(properties.SelectAllOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FilterListControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cascadingControlConfiguration", CfnDashboard_CascadingControlConfigurationPropertyValidator)(properties.cascadingControlConfiguration)), errors.collect(cdk.propertyValidator("displayOptions", CfnDashboard_ListControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("filterControlId", cdk.requiredValidator)(properties.filterControlId)), errors.collect(cdk.propertyValidator("filterControlId", cdk.validateString)(properties.filterControlId)), errors.collect(cdk.propertyValidator("selectableValues", CfnDashboard_FilterSelectableValuesPropertyValidator)(properties.selectableValues)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.requiredValidator)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.validateString)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "FilterListControlProperty"');
    }
    function cfnDashboardFilterListControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FilterListControlPropertyValidator(properties).assertSuccess(), { CascadingControlConfiguration: cfnDashboardCascadingControlConfigurationPropertyToCloudFormation(properties.cascadingControlConfiguration), DisplayOptions: cfnDashboardListControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), FilterControlId: cdk.stringToCloudFormation(properties.filterControlId), SelectableValues: cfnDashboardFilterSelectableValuesPropertyToCloudFormation(properties.selectableValues), SourceFilterId: cdk.stringToCloudFormation(properties.sourceFilterId), Title: cdk.stringToCloudFormation(properties.title), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnDashboardFilterListControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cascadingControlConfiguration", "CascadingControlConfiguration", properties.CascadingControlConfiguration != null ? CfnDashboardCascadingControlConfigurationPropertyFromCloudFormation(properties.CascadingControlConfiguration) : void 0), ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnDashboardListControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("filterControlId", "FilterControlId", cfn_parse.FromCloudFormation.getString(properties.FilterControlId)), ret.addPropertyResult("selectableValues", "SelectableValues", properties.SelectableValues != null ? CfnDashboardFilterSelectableValuesPropertyFromCloudFormation(properties.SelectableValues) : void 0), ret.addPropertyResult("sourceFilterId", "SourceFilterId", cfn_parse.FromCloudFormation.getString(properties.SourceFilterId)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FilterOperationSelectedFieldsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("selectedFieldOptions", cdk.validateString)(properties.selectedFieldOptions)), errors.collect(cdk.propertyValidator("selectedFields", cdk.listValidator(cdk.validateString))(properties.selectedFields)), errors.wrap('supplied properties not correct for "FilterOperationSelectedFieldsConfigurationProperty"');
    }
    function cfnDashboardFilterOperationSelectedFieldsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FilterOperationSelectedFieldsConfigurationPropertyValidator(properties).assertSuccess(), { SelectedFieldOptions: cdk.stringToCloudFormation(properties.selectedFieldOptions), SelectedFields: cdk.listMapper(cdk.stringToCloudFormation)(properties.selectedFields) }) : properties;
    }
    function CfnDashboardFilterOperationSelectedFieldsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("selectedFieldOptions", "SelectedFieldOptions", properties.SelectedFieldOptions != null ? cfn_parse.FromCloudFormation.getString(properties.SelectedFieldOptions) : void 0), ret.addPropertyResult("selectedFields", "SelectedFields", properties.SelectedFields != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SelectedFields) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FilterOperationTargetVisualsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sameSheetTargetVisualConfiguration", CfnDashboard_SameSheetTargetVisualConfigurationPropertyValidator)(properties.sameSheetTargetVisualConfiguration)), errors.wrap('supplied properties not correct for "FilterOperationTargetVisualsConfigurationProperty"');
    }
    function cfnDashboardFilterOperationTargetVisualsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FilterOperationTargetVisualsConfigurationPropertyValidator(properties).assertSuccess(), { SameSheetTargetVisualConfiguration: cfnDashboardSameSheetTargetVisualConfigurationPropertyToCloudFormation(properties.sameSheetTargetVisualConfiguration) }) : properties;
    }
    function CfnDashboardFilterOperationTargetVisualsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sameSheetTargetVisualConfiguration", "SameSheetTargetVisualConfiguration", properties.SameSheetTargetVisualConfiguration != null ? CfnDashboardSameSheetTargetVisualConfigurationPropertyFromCloudFormation(properties.SameSheetTargetVisualConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FilterRelativeDateTimeControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("displayOptions", CfnDashboard_RelativeDateTimeControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("filterControlId", cdk.requiredValidator)(properties.filterControlId)), errors.collect(cdk.propertyValidator("filterControlId", cdk.validateString)(properties.filterControlId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.requiredValidator)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.validateString)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.wrap('supplied properties not correct for "FilterRelativeDateTimeControlProperty"');
    }
    function cfnDashboardFilterRelativeDateTimeControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FilterRelativeDateTimeControlPropertyValidator(properties).assertSuccess(), { DisplayOptions: cfnDashboardRelativeDateTimeControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), FilterControlId: cdk.stringToCloudFormation(properties.filterControlId), SourceFilterId: cdk.stringToCloudFormation(properties.sourceFilterId), Title: cdk.stringToCloudFormation(properties.title) }) : properties;
    }
    function CfnDashboardFilterRelativeDateTimeControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnDashboardRelativeDateTimeControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("filterControlId", "FilterControlId", cfn_parse.FromCloudFormation.getString(properties.FilterControlId)), ret.addPropertyResult("sourceFilterId", "SourceFilterId", cfn_parse.FromCloudFormation.getString(properties.SourceFilterId)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FilterScopeConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("selectedSheets", CfnDashboard_SelectedSheetsFilterScopeConfigurationPropertyValidator)(properties.selectedSheets)), errors.wrap('supplied properties not correct for "FilterScopeConfigurationProperty"');
    }
    function cfnDashboardFilterScopeConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FilterScopeConfigurationPropertyValidator(properties).assertSuccess(), { SelectedSheets: cfnDashboardSelectedSheetsFilterScopeConfigurationPropertyToCloudFormation(properties.selectedSheets) }) : properties;
    }
    function CfnDashboardFilterScopeConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("selectedSheets", "SelectedSheets", properties.SelectedSheets != null ? CfnDashboardSelectedSheetsFilterScopeConfigurationPropertyFromCloudFormation(properties.SelectedSheets) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FilterSelectableValuesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "FilterSelectableValuesProperty"');
    }
    function cfnDashboardFilterSelectableValuesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FilterSelectableValuesPropertyValidator(properties).assertSuccess(), { Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnDashboardFilterSelectableValuesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FilterSliderControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("displayOptions", CfnDashboard_SliderControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("filterControlId", cdk.requiredValidator)(properties.filterControlId)), errors.collect(cdk.propertyValidator("filterControlId", cdk.validateString)(properties.filterControlId)), errors.collect(cdk.propertyValidator("maximumValue", cdk.requiredValidator)(properties.maximumValue)), errors.collect(cdk.propertyValidator("maximumValue", cdk.validateNumber)(properties.maximumValue)), errors.collect(cdk.propertyValidator("minimumValue", cdk.requiredValidator)(properties.minimumValue)), errors.collect(cdk.propertyValidator("minimumValue", cdk.validateNumber)(properties.minimumValue)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.requiredValidator)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.validateString)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("stepSize", cdk.requiredValidator)(properties.stepSize)), errors.collect(cdk.propertyValidator("stepSize", cdk.validateNumber)(properties.stepSize)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "FilterSliderControlProperty"');
    }
    function cfnDashboardFilterSliderControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FilterSliderControlPropertyValidator(properties).assertSuccess(), { DisplayOptions: cfnDashboardSliderControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), FilterControlId: cdk.stringToCloudFormation(properties.filterControlId), MaximumValue: cdk.numberToCloudFormation(properties.maximumValue), MinimumValue: cdk.numberToCloudFormation(properties.minimumValue), SourceFilterId: cdk.stringToCloudFormation(properties.sourceFilterId), StepSize: cdk.numberToCloudFormation(properties.stepSize), Title: cdk.stringToCloudFormation(properties.title), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnDashboardFilterSliderControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnDashboardSliderControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("filterControlId", "FilterControlId", cfn_parse.FromCloudFormation.getString(properties.FilterControlId)), ret.addPropertyResult("maximumValue", "MaximumValue", cfn_parse.FromCloudFormation.getNumber(properties.MaximumValue)), ret.addPropertyResult("minimumValue", "MinimumValue", cfn_parse.FromCloudFormation.getNumber(properties.MinimumValue)), ret.addPropertyResult("sourceFilterId", "SourceFilterId", cfn_parse.FromCloudFormation.getString(properties.SourceFilterId)), ret.addPropertyResult("stepSize", "StepSize", cfn_parse.FromCloudFormation.getNumber(properties.StepSize)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FilterTextAreaControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("delimiter", cdk.validateString)(properties.delimiter)), errors.collect(cdk.propertyValidator("displayOptions", CfnDashboard_TextAreaControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("filterControlId", cdk.requiredValidator)(properties.filterControlId)), errors.collect(cdk.propertyValidator("filterControlId", cdk.validateString)(properties.filterControlId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.requiredValidator)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.validateString)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.wrap('supplied properties not correct for "FilterTextAreaControlProperty"');
    }
    function cfnDashboardFilterTextAreaControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FilterTextAreaControlPropertyValidator(properties).assertSuccess(), { Delimiter: cdk.stringToCloudFormation(properties.delimiter), DisplayOptions: cfnDashboardTextAreaControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), FilterControlId: cdk.stringToCloudFormation(properties.filterControlId), SourceFilterId: cdk.stringToCloudFormation(properties.sourceFilterId), Title: cdk.stringToCloudFormation(properties.title) }) : properties;
    }
    function CfnDashboardFilterTextAreaControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("delimiter", "Delimiter", properties.Delimiter != null ? cfn_parse.FromCloudFormation.getString(properties.Delimiter) : void 0), ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnDashboardTextAreaControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("filterControlId", "FilterControlId", cfn_parse.FromCloudFormation.getString(properties.FilterControlId)), ret.addPropertyResult("sourceFilterId", "SourceFilterId", cfn_parse.FromCloudFormation.getString(properties.SourceFilterId)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FilterTextFieldControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("displayOptions", CfnDashboard_TextFieldControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("filterControlId", cdk.requiredValidator)(properties.filterControlId)), errors.collect(cdk.propertyValidator("filterControlId", cdk.validateString)(properties.filterControlId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.requiredValidator)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.validateString)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.wrap('supplied properties not correct for "FilterTextFieldControlProperty"');
    }
    function cfnDashboardFilterTextFieldControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FilterTextFieldControlPropertyValidator(properties).assertSuccess(), { DisplayOptions: cfnDashboardTextFieldControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), FilterControlId: cdk.stringToCloudFormation(properties.filterControlId), SourceFilterId: cdk.stringToCloudFormation(properties.sourceFilterId), Title: cdk.stringToCloudFormation(properties.title) }) : properties;
    }
    function CfnDashboardFilterTextFieldControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnDashboardTextFieldControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("filterControlId", "FilterControlId", cfn_parse.FromCloudFormation.getString(properties.FilterControlId)), ret.addPropertyResult("sourceFilterId", "SourceFilterId", cfn_parse.FromCloudFormation.getString(properties.SourceFilterId)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FontConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fontColor", cdk.validateString)(properties.fontColor)), errors.collect(cdk.propertyValidator("fontDecoration", cdk.validateString)(properties.fontDecoration)), errors.collect(cdk.propertyValidator("fontSize", CfnDashboard_FontSizePropertyValidator)(properties.fontSize)), errors.collect(cdk.propertyValidator("fontStyle", cdk.validateString)(properties.fontStyle)), errors.collect(cdk.propertyValidator("fontWeight", CfnDashboard_FontWeightPropertyValidator)(properties.fontWeight)), errors.wrap('supplied properties not correct for "FontConfigurationProperty"');
    }
    function cfnDashboardFontConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FontConfigurationPropertyValidator(properties).assertSuccess(), { FontColor: cdk.stringToCloudFormation(properties.fontColor), FontDecoration: cdk.stringToCloudFormation(properties.fontDecoration), FontSize: cfnDashboardFontSizePropertyToCloudFormation(properties.fontSize), FontStyle: cdk.stringToCloudFormation(properties.fontStyle), FontWeight: cfnDashboardFontWeightPropertyToCloudFormation(properties.fontWeight) }) : properties;
    }
    function CfnDashboardFontConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fontColor", "FontColor", properties.FontColor != null ? cfn_parse.FromCloudFormation.getString(properties.FontColor) : void 0), ret.addPropertyResult("fontDecoration", "FontDecoration", properties.FontDecoration != null ? cfn_parse.FromCloudFormation.getString(properties.FontDecoration) : void 0), ret.addPropertyResult("fontSize", "FontSize", properties.FontSize != null ? CfnDashboardFontSizePropertyFromCloudFormation(properties.FontSize) : void 0), ret.addPropertyResult("fontStyle", "FontStyle", properties.FontStyle != null ? cfn_parse.FromCloudFormation.getString(properties.FontStyle) : void 0), ret.addPropertyResult("fontWeight", "FontWeight", properties.FontWeight != null ? CfnDashboardFontWeightPropertyFromCloudFormation(properties.FontWeight) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FontSizePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("relative", cdk.validateString)(properties.relative)), errors.wrap('supplied properties not correct for "FontSizeProperty"');
    }
    function cfnDashboardFontSizePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FontSizePropertyValidator(properties).assertSuccess(), { Relative: cdk.stringToCloudFormation(properties.relative) }) : properties;
    }
    function CfnDashboardFontSizePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("relative", "Relative", properties.Relative != null ? cfn_parse.FromCloudFormation.getString(properties.Relative) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FontWeightPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "FontWeightProperty"');
    }
    function cfnDashboardFontWeightPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FontWeightPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnDashboardFontWeightPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ForecastComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computationId", cdk.requiredValidator)(properties.computationId)), errors.collect(cdk.propertyValidator("computationId", cdk.validateString)(properties.computationId)), errors.collect(cdk.propertyValidator("customSeasonalityValue", cdk.validateNumber)(properties.customSeasonalityValue)), errors.collect(cdk.propertyValidator("lowerBoundary", cdk.validateNumber)(properties.lowerBoundary)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("periodsBackward", cdk.validateNumber)(properties.periodsBackward)), errors.collect(cdk.propertyValidator("periodsForward", cdk.validateNumber)(properties.periodsForward)), errors.collect(cdk.propertyValidator("predictionInterval", cdk.validateNumber)(properties.predictionInterval)), errors.collect(cdk.propertyValidator("seasonality", cdk.validateString)(properties.seasonality)), errors.collect(cdk.propertyValidator("time", cdk.requiredValidator)(properties.time)), errors.collect(cdk.propertyValidator("time", CfnDashboard_DimensionFieldPropertyValidator)(properties.time)), errors.collect(cdk.propertyValidator("upperBoundary", cdk.validateNumber)(properties.upperBoundary)), errors.collect(cdk.propertyValidator("value", CfnDashboard_MeasureFieldPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "ForecastComputationProperty"');
    }
    function cfnDashboardForecastComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ForecastComputationPropertyValidator(properties).assertSuccess(), { ComputationId: cdk.stringToCloudFormation(properties.computationId), CustomSeasonalityValue: cdk.numberToCloudFormation(properties.customSeasonalityValue), LowerBoundary: cdk.numberToCloudFormation(properties.lowerBoundary), Name: cdk.stringToCloudFormation(properties.name), PeriodsBackward: cdk.numberToCloudFormation(properties.periodsBackward), PeriodsForward: cdk.numberToCloudFormation(properties.periodsForward), PredictionInterval: cdk.numberToCloudFormation(properties.predictionInterval), Seasonality: cdk.stringToCloudFormation(properties.seasonality), Time: cfnDashboardDimensionFieldPropertyToCloudFormation(properties.time), UpperBoundary: cdk.numberToCloudFormation(properties.upperBoundary), Value: cfnDashboardMeasureFieldPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnDashboardForecastComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computationId", "ComputationId", cfn_parse.FromCloudFormation.getString(properties.ComputationId)), ret.addPropertyResult("customSeasonalityValue", "CustomSeasonalityValue", properties.CustomSeasonalityValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.CustomSeasonalityValue) : void 0), ret.addPropertyResult("lowerBoundary", "LowerBoundary", properties.LowerBoundary != null ? cfn_parse.FromCloudFormation.getNumber(properties.LowerBoundary) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("periodsBackward", "PeriodsBackward", properties.PeriodsBackward != null ? cfn_parse.FromCloudFormation.getNumber(properties.PeriodsBackward) : void 0), ret.addPropertyResult("periodsForward", "PeriodsForward", properties.PeriodsForward != null ? cfn_parse.FromCloudFormation.getNumber(properties.PeriodsForward) : void 0), ret.addPropertyResult("predictionInterval", "PredictionInterval", properties.PredictionInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.PredictionInterval) : void 0), ret.addPropertyResult("seasonality", "Seasonality", properties.Seasonality != null ? cfn_parse.FromCloudFormation.getString(properties.Seasonality) : void 0), ret.addPropertyResult("time", "Time", CfnDashboardDimensionFieldPropertyFromCloudFormation(properties.Time)), ret.addPropertyResult("upperBoundary", "UpperBoundary", properties.UpperBoundary != null ? cfn_parse.FromCloudFormation.getNumber(properties.UpperBoundary) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? CfnDashboardMeasureFieldPropertyFromCloudFormation(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ForecastConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("forecastProperties", CfnDashboard_TimeBasedForecastPropertiesPropertyValidator)(properties.forecastProperties)), errors.collect(cdk.propertyValidator("scenario", CfnDashboard_ForecastScenarioPropertyValidator)(properties.scenario)), errors.wrap('supplied properties not correct for "ForecastConfigurationProperty"');
    }
    function cfnDashboardForecastConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ForecastConfigurationPropertyValidator(properties).assertSuccess(), { ForecastProperties: cfnDashboardTimeBasedForecastPropertiesPropertyToCloudFormation(properties.forecastProperties), Scenario: cfnDashboardForecastScenarioPropertyToCloudFormation(properties.scenario) }) : properties;
    }
    function CfnDashboardForecastConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("forecastProperties", "ForecastProperties", properties.ForecastProperties != null ? CfnDashboardTimeBasedForecastPropertiesPropertyFromCloudFormation(properties.ForecastProperties) : void 0), ret.addPropertyResult("scenario", "Scenario", properties.Scenario != null ? CfnDashboardForecastScenarioPropertyFromCloudFormation(properties.Scenario) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ForecastScenarioPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("whatIfPointScenario", CfnDashboard_WhatIfPointScenarioPropertyValidator)(properties.whatIfPointScenario)), errors.collect(cdk.propertyValidator("whatIfRangeScenario", CfnDashboard_WhatIfRangeScenarioPropertyValidator)(properties.whatIfRangeScenario)), errors.wrap('supplied properties not correct for "ForecastScenarioProperty"');
    }
    function cfnDashboardForecastScenarioPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ForecastScenarioPropertyValidator(properties).assertSuccess(), { WhatIfPointScenario: cfnDashboardWhatIfPointScenarioPropertyToCloudFormation(properties.whatIfPointScenario), WhatIfRangeScenario: cfnDashboardWhatIfRangeScenarioPropertyToCloudFormation(properties.whatIfRangeScenario) }) : properties;
    }
    function CfnDashboardForecastScenarioPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("whatIfPointScenario", "WhatIfPointScenario", properties.WhatIfPointScenario != null ? CfnDashboardWhatIfPointScenarioPropertyFromCloudFormation(properties.WhatIfPointScenario) : void 0), ret.addPropertyResult("whatIfRangeScenario", "WhatIfRangeScenario", properties.WhatIfRangeScenario != null ? CfnDashboardWhatIfRangeScenarioPropertyFromCloudFormation(properties.WhatIfRangeScenario) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateTimeFormatConfiguration", CfnDashboard_DateTimeFormatConfigurationPropertyValidator)(properties.dateTimeFormatConfiguration)), errors.collect(cdk.propertyValidator("numberFormatConfiguration", CfnDashboard_NumberFormatConfigurationPropertyValidator)(properties.numberFormatConfiguration)), errors.collect(cdk.propertyValidator("stringFormatConfiguration", CfnDashboard_StringFormatConfigurationPropertyValidator)(properties.stringFormatConfiguration)), errors.wrap('supplied properties not correct for "FormatConfigurationProperty"');
    }
    function cfnDashboardFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FormatConfigurationPropertyValidator(properties).assertSuccess(), { DateTimeFormatConfiguration: cfnDashboardDateTimeFormatConfigurationPropertyToCloudFormation(properties.dateTimeFormatConfiguration), NumberFormatConfiguration: cfnDashboardNumberFormatConfigurationPropertyToCloudFormation(properties.numberFormatConfiguration), StringFormatConfiguration: cfnDashboardStringFormatConfigurationPropertyToCloudFormation(properties.stringFormatConfiguration) }) : properties;
    }
    function CfnDashboardFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateTimeFormatConfiguration", "DateTimeFormatConfiguration", properties.DateTimeFormatConfiguration != null ? CfnDashboardDateTimeFormatConfigurationPropertyFromCloudFormation(properties.DateTimeFormatConfiguration) : void 0), ret.addPropertyResult("numberFormatConfiguration", "NumberFormatConfiguration", properties.NumberFormatConfiguration != null ? CfnDashboardNumberFormatConfigurationPropertyFromCloudFormation(properties.NumberFormatConfiguration) : void 0), ret.addPropertyResult("stringFormatConfiguration", "StringFormatConfiguration", properties.StringFormatConfiguration != null ? CfnDashboardStringFormatConfigurationPropertyFromCloudFormation(properties.StringFormatConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FreeFormLayoutCanvasSizeOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("screenCanvasSizeOptions", CfnDashboard_FreeFormLayoutScreenCanvasSizeOptionsPropertyValidator)(properties.screenCanvasSizeOptions)), errors.wrap('supplied properties not correct for "FreeFormLayoutCanvasSizeOptionsProperty"');
    }
    function cfnDashboardFreeFormLayoutCanvasSizeOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FreeFormLayoutCanvasSizeOptionsPropertyValidator(properties).assertSuccess(), { ScreenCanvasSizeOptions: cfnDashboardFreeFormLayoutScreenCanvasSizeOptionsPropertyToCloudFormation(properties.screenCanvasSizeOptions) }) : properties;
    }
    function CfnDashboardFreeFormLayoutCanvasSizeOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("screenCanvasSizeOptions", "ScreenCanvasSizeOptions", properties.ScreenCanvasSizeOptions != null ? CfnDashboardFreeFormLayoutScreenCanvasSizeOptionsPropertyFromCloudFormation(properties.ScreenCanvasSizeOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FreeFormLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("canvasSizeOptions", CfnDashboard_FreeFormLayoutCanvasSizeOptionsPropertyValidator)(properties.canvasSizeOptions)), errors.collect(cdk.propertyValidator("elements", cdk.requiredValidator)(properties.elements)), errors.collect(cdk.propertyValidator("elements", cdk.listValidator(CfnDashboard_FreeFormLayoutElementPropertyValidator))(properties.elements)), errors.wrap('supplied properties not correct for "FreeFormLayoutConfigurationProperty"');
    }
    function cfnDashboardFreeFormLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FreeFormLayoutConfigurationPropertyValidator(properties).assertSuccess(), { CanvasSizeOptions: cfnDashboardFreeFormLayoutCanvasSizeOptionsPropertyToCloudFormation(properties.canvasSizeOptions), Elements: cdk.listMapper(cfnDashboardFreeFormLayoutElementPropertyToCloudFormation)(properties.elements) }) : properties;
    }
    function CfnDashboardFreeFormLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("canvasSizeOptions", "CanvasSizeOptions", properties.CanvasSizeOptions != null ? CfnDashboardFreeFormLayoutCanvasSizeOptionsPropertyFromCloudFormation(properties.CanvasSizeOptions) : void 0), ret.addPropertyResult("elements", "Elements", cfn_parse.FromCloudFormation.getArray(CfnDashboardFreeFormLayoutElementPropertyFromCloudFormation)(properties.Elements)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FreeFormLayoutElementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("backgroundStyle", CfnDashboard_FreeFormLayoutElementBackgroundStylePropertyValidator)(properties.backgroundStyle)), errors.collect(cdk.propertyValidator("borderStyle", CfnDashboard_FreeFormLayoutElementBorderStylePropertyValidator)(properties.borderStyle)), errors.collect(cdk.propertyValidator("elementId", cdk.requiredValidator)(properties.elementId)), errors.collect(cdk.propertyValidator("elementId", cdk.validateString)(properties.elementId)), errors.collect(cdk.propertyValidator("elementType", cdk.requiredValidator)(properties.elementType)), errors.collect(cdk.propertyValidator("elementType", cdk.validateString)(properties.elementType)), errors.collect(cdk.propertyValidator("height", cdk.requiredValidator)(properties.height)), errors.collect(cdk.propertyValidator("height", cdk.validateString)(properties.height)), errors.collect(cdk.propertyValidator("loadingAnimation", CfnDashboard_LoadingAnimationPropertyValidator)(properties.loadingAnimation)), errors.collect(cdk.propertyValidator("renderingRules", cdk.listValidator(CfnDashboard_SheetElementRenderingRulePropertyValidator))(properties.renderingRules)), errors.collect(cdk.propertyValidator("selectedBorderStyle", CfnDashboard_FreeFormLayoutElementBorderStylePropertyValidator)(properties.selectedBorderStyle)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.collect(cdk.propertyValidator("width", cdk.requiredValidator)(properties.width)), errors.collect(cdk.propertyValidator("width", cdk.validateString)(properties.width)), errors.collect(cdk.propertyValidator("xAxisLocation", cdk.requiredValidator)(properties.xAxisLocation)), errors.collect(cdk.propertyValidator("xAxisLocation", cdk.validateString)(properties.xAxisLocation)), errors.collect(cdk.propertyValidator("yAxisLocation", cdk.requiredValidator)(properties.yAxisLocation)), errors.collect(cdk.propertyValidator("yAxisLocation", cdk.validateString)(properties.yAxisLocation)), errors.wrap('supplied properties not correct for "FreeFormLayoutElementProperty"');
    }
    function cfnDashboardFreeFormLayoutElementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FreeFormLayoutElementPropertyValidator(properties).assertSuccess(), { BackgroundStyle: cfnDashboardFreeFormLayoutElementBackgroundStylePropertyToCloudFormation(properties.backgroundStyle), BorderStyle: cfnDashboardFreeFormLayoutElementBorderStylePropertyToCloudFormation(properties.borderStyle), ElementId: cdk.stringToCloudFormation(properties.elementId), ElementType: cdk.stringToCloudFormation(properties.elementType), Height: cdk.stringToCloudFormation(properties.height), LoadingAnimation: cfnDashboardLoadingAnimationPropertyToCloudFormation(properties.loadingAnimation), RenderingRules: cdk.listMapper(cfnDashboardSheetElementRenderingRulePropertyToCloudFormation)(properties.renderingRules), SelectedBorderStyle: cfnDashboardFreeFormLayoutElementBorderStylePropertyToCloudFormation(properties.selectedBorderStyle), Visibility: cdk.stringToCloudFormation(properties.visibility), Width: cdk.stringToCloudFormation(properties.width), XAxisLocation: cdk.stringToCloudFormation(properties.xAxisLocation), YAxisLocation: cdk.stringToCloudFormation(properties.yAxisLocation) }) : properties;
    }
    function CfnDashboardFreeFormLayoutElementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("backgroundStyle", "BackgroundStyle", properties.BackgroundStyle != null ? CfnDashboardFreeFormLayoutElementBackgroundStylePropertyFromCloudFormation(properties.BackgroundStyle) : void 0), ret.addPropertyResult("borderStyle", "BorderStyle", properties.BorderStyle != null ? CfnDashboardFreeFormLayoutElementBorderStylePropertyFromCloudFormation(properties.BorderStyle) : void 0), ret.addPropertyResult("elementId", "ElementId", cfn_parse.FromCloudFormation.getString(properties.ElementId)), ret.addPropertyResult("elementType", "ElementType", cfn_parse.FromCloudFormation.getString(properties.ElementType)), ret.addPropertyResult("height", "Height", cfn_parse.FromCloudFormation.getString(properties.Height)), ret.addPropertyResult("loadingAnimation", "LoadingAnimation", properties.LoadingAnimation != null ? CfnDashboardLoadingAnimationPropertyFromCloudFormation(properties.LoadingAnimation) : void 0), ret.addPropertyResult("renderingRules", "RenderingRules", properties.RenderingRules != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardSheetElementRenderingRulePropertyFromCloudFormation)(properties.RenderingRules) : void 0), ret.addPropertyResult("selectedBorderStyle", "SelectedBorderStyle", properties.SelectedBorderStyle != null ? CfnDashboardFreeFormLayoutElementBorderStylePropertyFromCloudFormation(properties.SelectedBorderStyle) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addPropertyResult("width", "Width", cfn_parse.FromCloudFormation.getString(properties.Width)), ret.addPropertyResult("xAxisLocation", "XAxisLocation", cfn_parse.FromCloudFormation.getString(properties.XAxisLocation)), ret.addPropertyResult("yAxisLocation", "YAxisLocation", cfn_parse.FromCloudFormation.getString(properties.YAxisLocation)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FreeFormLayoutElementBackgroundStylePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "FreeFormLayoutElementBackgroundStyleProperty"');
    }
    function cfnDashboardFreeFormLayoutElementBackgroundStylePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FreeFormLayoutElementBackgroundStylePropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnDashboardFreeFormLayoutElementBackgroundStylePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", properties.Color != null ? cfn_parse.FromCloudFormation.getString(properties.Color) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FreeFormLayoutElementBorderStylePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "FreeFormLayoutElementBorderStyleProperty"');
    }
    function cfnDashboardFreeFormLayoutElementBorderStylePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FreeFormLayoutElementBorderStylePropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnDashboardFreeFormLayoutElementBorderStylePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", properties.Color != null ? cfn_parse.FromCloudFormation.getString(properties.Color) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FreeFormLayoutScreenCanvasSizeOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("optimizedViewPortWidth", cdk.requiredValidator)(properties.optimizedViewPortWidth)), errors.collect(cdk.propertyValidator("optimizedViewPortWidth", cdk.validateString)(properties.optimizedViewPortWidth)), errors.wrap('supplied properties not correct for "FreeFormLayoutScreenCanvasSizeOptionsProperty"');
    }
    function cfnDashboardFreeFormLayoutScreenCanvasSizeOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FreeFormLayoutScreenCanvasSizeOptionsPropertyValidator(properties).assertSuccess(), { OptimizedViewPortWidth: cdk.stringToCloudFormation(properties.optimizedViewPortWidth) }) : properties;
    }
    function CfnDashboardFreeFormLayoutScreenCanvasSizeOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("optimizedViewPortWidth", "OptimizedViewPortWidth", cfn_parse.FromCloudFormation.getString(properties.OptimizedViewPortWidth)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FreeFormSectionLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("elements", cdk.requiredValidator)(properties.elements)), errors.collect(cdk.propertyValidator("elements", cdk.listValidator(CfnDashboard_FreeFormLayoutElementPropertyValidator))(properties.elements)), errors.wrap('supplied properties not correct for "FreeFormSectionLayoutConfigurationProperty"');
    }
    function cfnDashboardFreeFormSectionLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FreeFormSectionLayoutConfigurationPropertyValidator(properties).assertSuccess(), { Elements: cdk.listMapper(cfnDashboardFreeFormLayoutElementPropertyToCloudFormation)(properties.elements) }) : properties;
    }
    function CfnDashboardFreeFormSectionLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("elements", "Elements", cfn_parse.FromCloudFormation.getArray(CfnDashboardFreeFormLayoutElementPropertyFromCloudFormation)(properties.Elements)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FunnelChartAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("category", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.category)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnDashboard_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "FunnelChartAggregatedFieldWellsProperty"');
    }
    function cfnDashboardFunnelChartAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FunnelChartAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Category: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.category), Values: cdk.listMapper(cfnDashboardMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnDashboardFunnelChartAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("category", "Category", properties.Category != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.Category) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FunnelChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryLabelOptions", CfnDashboard_ChartAxisLabelOptionsPropertyValidator)(properties.categoryLabelOptions)), errors.collect(cdk.propertyValidator("dataLabelOptions", CfnDashboard_FunnelChartDataLabelOptionsPropertyValidator)(properties.dataLabelOptions)), errors.collect(cdk.propertyValidator("fieldWells", CfnDashboard_FunnelChartFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnDashboard_FunnelChartSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tooltip", CfnDashboard_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.collect(cdk.propertyValidator("valueLabelOptions", CfnDashboard_ChartAxisLabelOptionsPropertyValidator)(properties.valueLabelOptions)), errors.collect(cdk.propertyValidator("visualPalette", CfnDashboard_VisualPalettePropertyValidator)(properties.visualPalette)), errors.wrap('supplied properties not correct for "FunnelChartConfigurationProperty"');
    }
    function cfnDashboardFunnelChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FunnelChartConfigurationPropertyValidator(properties).assertSuccess(), { CategoryLabelOptions: cfnDashboardChartAxisLabelOptionsPropertyToCloudFormation(properties.categoryLabelOptions), DataLabelOptions: cfnDashboardFunnelChartDataLabelOptionsPropertyToCloudFormation(properties.dataLabelOptions), FieldWells: cfnDashboardFunnelChartFieldWellsPropertyToCloudFormation(properties.fieldWells), SortConfiguration: cfnDashboardFunnelChartSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), Tooltip: cfnDashboardTooltipOptionsPropertyToCloudFormation(properties.tooltip), ValueLabelOptions: cfnDashboardChartAxisLabelOptionsPropertyToCloudFormation(properties.valueLabelOptions), VisualPalette: cfnDashboardVisualPalettePropertyToCloudFormation(properties.visualPalette) }) : properties;
    }
    function CfnDashboardFunnelChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryLabelOptions", "CategoryLabelOptions", properties.CategoryLabelOptions != null ? CfnDashboardChartAxisLabelOptionsPropertyFromCloudFormation(properties.CategoryLabelOptions) : void 0), ret.addPropertyResult("dataLabelOptions", "DataLabelOptions", properties.DataLabelOptions != null ? CfnDashboardFunnelChartDataLabelOptionsPropertyFromCloudFormation(properties.DataLabelOptions) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnDashboardFunnelChartFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnDashboardFunnelChartSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnDashboardTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addPropertyResult("valueLabelOptions", "ValueLabelOptions", properties.ValueLabelOptions != null ? CfnDashboardChartAxisLabelOptionsPropertyFromCloudFormation(properties.ValueLabelOptions) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnDashboardVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FunnelChartDataLabelOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryLabelVisibility", cdk.validateString)(properties.categoryLabelVisibility)), errors.collect(cdk.propertyValidator("labelColor", cdk.validateString)(properties.labelColor)), errors.collect(cdk.propertyValidator("labelFontConfiguration", CfnDashboard_FontConfigurationPropertyValidator)(properties.labelFontConfiguration)), errors.collect(cdk.propertyValidator("measureDataLabelStyle", cdk.validateString)(properties.measureDataLabelStyle)), errors.collect(cdk.propertyValidator("measureLabelVisibility", cdk.validateString)(properties.measureLabelVisibility)), errors.collect(cdk.propertyValidator("position", cdk.validateString)(properties.position)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "FunnelChartDataLabelOptionsProperty"');
    }
    function cfnDashboardFunnelChartDataLabelOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FunnelChartDataLabelOptionsPropertyValidator(properties).assertSuccess(), { CategoryLabelVisibility: cdk.stringToCloudFormation(properties.categoryLabelVisibility), LabelColor: cdk.stringToCloudFormation(properties.labelColor), LabelFontConfiguration: cfnDashboardFontConfigurationPropertyToCloudFormation(properties.labelFontConfiguration), MeasureDataLabelStyle: cdk.stringToCloudFormation(properties.measureDataLabelStyle), MeasureLabelVisibility: cdk.stringToCloudFormation(properties.measureLabelVisibility), Position: cdk.stringToCloudFormation(properties.position), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnDashboardFunnelChartDataLabelOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryLabelVisibility", "CategoryLabelVisibility", properties.CategoryLabelVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.CategoryLabelVisibility) : void 0), ret.addPropertyResult("labelColor", "LabelColor", properties.LabelColor != null ? cfn_parse.FromCloudFormation.getString(properties.LabelColor) : void 0), ret.addPropertyResult("labelFontConfiguration", "LabelFontConfiguration", properties.LabelFontConfiguration != null ? CfnDashboardFontConfigurationPropertyFromCloudFormation(properties.LabelFontConfiguration) : void 0), ret.addPropertyResult("measureDataLabelStyle", "MeasureDataLabelStyle", properties.MeasureDataLabelStyle != null ? cfn_parse.FromCloudFormation.getString(properties.MeasureDataLabelStyle) : void 0), ret.addPropertyResult("measureLabelVisibility", "MeasureLabelVisibility", properties.MeasureLabelVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.MeasureLabelVisibility) : void 0), ret.addPropertyResult("position", "Position", properties.Position != null ? cfn_parse.FromCloudFormation.getString(properties.Position) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FunnelChartFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("funnelChartAggregatedFieldWells", CfnDashboard_FunnelChartAggregatedFieldWellsPropertyValidator)(properties.funnelChartAggregatedFieldWells)), errors.wrap('supplied properties not correct for "FunnelChartFieldWellsProperty"');
    }
    function cfnDashboardFunnelChartFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FunnelChartFieldWellsPropertyValidator(properties).assertSuccess(), { FunnelChartAggregatedFieldWells: cfnDashboardFunnelChartAggregatedFieldWellsPropertyToCloudFormation(properties.funnelChartAggregatedFieldWells) }) : properties;
    }
    function CfnDashboardFunnelChartFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("funnelChartAggregatedFieldWells", "FunnelChartAggregatedFieldWells", properties.FunnelChartAggregatedFieldWells != null ? CfnDashboardFunnelChartAggregatedFieldWellsPropertyFromCloudFormation(properties.FunnelChartAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FunnelChartSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryItemsLimit", CfnDashboard_ItemsLimitConfigurationPropertyValidator)(properties.categoryItemsLimit)), errors.collect(cdk.propertyValidator("categorySort", cdk.listValidator(CfnDashboard_FieldSortOptionsPropertyValidator))(properties.categorySort)), errors.wrap('supplied properties not correct for "FunnelChartSortConfigurationProperty"');
    }
    function cfnDashboardFunnelChartSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FunnelChartSortConfigurationPropertyValidator(properties).assertSuccess(), { CategoryItemsLimit: cfnDashboardItemsLimitConfigurationPropertyToCloudFormation(properties.categoryItemsLimit), CategorySort: cdk.listMapper(cfnDashboardFieldSortOptionsPropertyToCloudFormation)(properties.categorySort) }) : properties;
    }
    function CfnDashboardFunnelChartSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryItemsLimit", "CategoryItemsLimit", properties.CategoryItemsLimit != null ? CfnDashboardItemsLimitConfigurationPropertyFromCloudFormation(properties.CategoryItemsLimit) : void 0), ret.addPropertyResult("categorySort", "CategorySort", properties.CategorySort != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardFieldSortOptionsPropertyFromCloudFormation)(properties.CategorySort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_FunnelChartVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnDashboard_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnDashboard_FunnelChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnDashboard_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnDashboard_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnDashboard_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "FunnelChartVisualProperty"');
    }
    function cfnDashboardFunnelChartVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_FunnelChartVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnDashboardVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnDashboardFunnelChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnDashboardColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnDashboardVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnDashboardVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnDashboardFunnelChartVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnDashboardFunnelChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnDashboardVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnDashboardVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_GaugeChartArcConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("foregroundColor", CfnDashboard_ConditionalFormattingColorPropertyValidator)(properties.foregroundColor)), errors.wrap('supplied properties not correct for "GaugeChartArcConditionalFormattingProperty"');
    }
    function cfnDashboardGaugeChartArcConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_GaugeChartArcConditionalFormattingPropertyValidator(properties).assertSuccess(), { ForegroundColor: cfnDashboardConditionalFormattingColorPropertyToCloudFormation(properties.foregroundColor) }) : properties;
    }
    function CfnDashboardGaugeChartArcConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("foregroundColor", "ForegroundColor", properties.ForegroundColor != null ? CfnDashboardConditionalFormattingColorPropertyFromCloudFormation(properties.ForegroundColor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_GaugeChartConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("conditionalFormattingOptions", cdk.listValidator(CfnDashboard_GaugeChartConditionalFormattingOptionPropertyValidator))(properties.conditionalFormattingOptions)), errors.wrap('supplied properties not correct for "GaugeChartConditionalFormattingProperty"');
    }
    function cfnDashboardGaugeChartConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_GaugeChartConditionalFormattingPropertyValidator(properties).assertSuccess(), { ConditionalFormattingOptions: cdk.listMapper(cfnDashboardGaugeChartConditionalFormattingOptionPropertyToCloudFormation)(properties.conditionalFormattingOptions) }) : properties;
    }
    function CfnDashboardGaugeChartConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("conditionalFormattingOptions", "ConditionalFormattingOptions", properties.ConditionalFormattingOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardGaugeChartConditionalFormattingOptionPropertyFromCloudFormation)(properties.ConditionalFormattingOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_GaugeChartConditionalFormattingOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arc", CfnDashboard_GaugeChartArcConditionalFormattingPropertyValidator)(properties.arc)), errors.collect(cdk.propertyValidator("primaryValue", CfnDashboard_GaugeChartPrimaryValueConditionalFormattingPropertyValidator)(properties.primaryValue)), errors.wrap('supplied properties not correct for "GaugeChartConditionalFormattingOptionProperty"');
    }
    function cfnDashboardGaugeChartConditionalFormattingOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_GaugeChartConditionalFormattingOptionPropertyValidator(properties).assertSuccess(), { Arc: cfnDashboardGaugeChartArcConditionalFormattingPropertyToCloudFormation(properties.arc), PrimaryValue: cfnDashboardGaugeChartPrimaryValueConditionalFormattingPropertyToCloudFormation(properties.primaryValue) }) : properties;
    }
    function CfnDashboardGaugeChartConditionalFormattingOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arc", "Arc", properties.Arc != null ? CfnDashboardGaugeChartArcConditionalFormattingPropertyFromCloudFormation(properties.Arc) : void 0), ret.addPropertyResult("primaryValue", "PrimaryValue", properties.PrimaryValue != null ? CfnDashboardGaugeChartPrimaryValueConditionalFormattingPropertyFromCloudFormation(properties.PrimaryValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_GaugeChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataLabels", CfnDashboard_DataLabelOptionsPropertyValidator)(properties.dataLabels)), errors.collect(cdk.propertyValidator("fieldWells", CfnDashboard_GaugeChartFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("gaugeChartOptions", CfnDashboard_GaugeChartOptionsPropertyValidator)(properties.gaugeChartOptions)), errors.collect(cdk.propertyValidator("tooltipOptions", CfnDashboard_TooltipOptionsPropertyValidator)(properties.tooltipOptions)), errors.collect(cdk.propertyValidator("visualPalette", CfnDashboard_VisualPalettePropertyValidator)(properties.visualPalette)), errors.wrap('supplied properties not correct for "GaugeChartConfigurationProperty"');
    }
    function cfnDashboardGaugeChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_GaugeChartConfigurationPropertyValidator(properties).assertSuccess(), { DataLabels: cfnDashboardDataLabelOptionsPropertyToCloudFormation(properties.dataLabels), FieldWells: cfnDashboardGaugeChartFieldWellsPropertyToCloudFormation(properties.fieldWells), GaugeChartOptions: cfnDashboardGaugeChartOptionsPropertyToCloudFormation(properties.gaugeChartOptions), TooltipOptions: cfnDashboardTooltipOptionsPropertyToCloudFormation(properties.tooltipOptions), VisualPalette: cfnDashboardVisualPalettePropertyToCloudFormation(properties.visualPalette) }) : properties;
    }
    function CfnDashboardGaugeChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataLabels", "DataLabels", properties.DataLabels != null ? CfnDashboardDataLabelOptionsPropertyFromCloudFormation(properties.DataLabels) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnDashboardGaugeChartFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("gaugeChartOptions", "GaugeChartOptions", properties.GaugeChartOptions != null ? CfnDashboardGaugeChartOptionsPropertyFromCloudFormation(properties.GaugeChartOptions) : void 0), ret.addPropertyResult("tooltipOptions", "TooltipOptions", properties.TooltipOptions != null ? CfnDashboardTooltipOptionsPropertyFromCloudFormation(properties.TooltipOptions) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnDashboardVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_GaugeChartFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("targetValues", cdk.listValidator(CfnDashboard_MeasureFieldPropertyValidator))(properties.targetValues)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnDashboard_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "GaugeChartFieldWellsProperty"');
    }
    function cfnDashboardGaugeChartFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_GaugeChartFieldWellsPropertyValidator(properties).assertSuccess(), { TargetValues: cdk.listMapper(cfnDashboardMeasureFieldPropertyToCloudFormation)(properties.targetValues), Values: cdk.listMapper(cfnDashboardMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnDashboardGaugeChartFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("targetValues", "TargetValues", properties.TargetValues != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMeasureFieldPropertyFromCloudFormation)(properties.TargetValues) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_GaugeChartOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arc", CfnDashboard_ArcConfigurationPropertyValidator)(properties.arc)), errors.collect(cdk.propertyValidator("arcAxis", CfnDashboard_ArcAxisConfigurationPropertyValidator)(properties.arcAxis)), errors.collect(cdk.propertyValidator("comparison", CfnDashboard_ComparisonConfigurationPropertyValidator)(properties.comparison)), errors.collect(cdk.propertyValidator("primaryValueDisplayType", cdk.validateString)(properties.primaryValueDisplayType)), errors.collect(cdk.propertyValidator("primaryValueFontConfiguration", CfnDashboard_FontConfigurationPropertyValidator)(properties.primaryValueFontConfiguration)), errors.wrap('supplied properties not correct for "GaugeChartOptionsProperty"');
    }
    function cfnDashboardGaugeChartOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_GaugeChartOptionsPropertyValidator(properties).assertSuccess(), { Arc: cfnDashboardArcConfigurationPropertyToCloudFormation(properties.arc), ArcAxis: cfnDashboardArcAxisConfigurationPropertyToCloudFormation(properties.arcAxis), Comparison: cfnDashboardComparisonConfigurationPropertyToCloudFormation(properties.comparison), PrimaryValueDisplayType: cdk.stringToCloudFormation(properties.primaryValueDisplayType), PrimaryValueFontConfiguration: cfnDashboardFontConfigurationPropertyToCloudFormation(properties.primaryValueFontConfiguration) }) : properties;
    }
    function CfnDashboardGaugeChartOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arc", "Arc", properties.Arc != null ? CfnDashboardArcConfigurationPropertyFromCloudFormation(properties.Arc) : void 0), ret.addPropertyResult("arcAxis", "ArcAxis", properties.ArcAxis != null ? CfnDashboardArcAxisConfigurationPropertyFromCloudFormation(properties.ArcAxis) : void 0), ret.addPropertyResult("comparison", "Comparison", properties.Comparison != null ? CfnDashboardComparisonConfigurationPropertyFromCloudFormation(properties.Comparison) : void 0), ret.addPropertyResult("primaryValueDisplayType", "PrimaryValueDisplayType", properties.PrimaryValueDisplayType != null ? cfn_parse.FromCloudFormation.getString(properties.PrimaryValueDisplayType) : void 0), ret.addPropertyResult("primaryValueFontConfiguration", "PrimaryValueFontConfiguration", properties.PrimaryValueFontConfiguration != null ? CfnDashboardFontConfigurationPropertyFromCloudFormation(properties.PrimaryValueFontConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_GaugeChartPrimaryValueConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("icon", CfnDashboard_ConditionalFormattingIconPropertyValidator)(properties.icon)), errors.collect(cdk.propertyValidator("textColor", CfnDashboard_ConditionalFormattingColorPropertyValidator)(properties.textColor)), errors.wrap('supplied properties not correct for "GaugeChartPrimaryValueConditionalFormattingProperty"');
    }
    function cfnDashboardGaugeChartPrimaryValueConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_GaugeChartPrimaryValueConditionalFormattingPropertyValidator(properties).assertSuccess(), { Icon: cfnDashboardConditionalFormattingIconPropertyToCloudFormation(properties.icon), TextColor: cfnDashboardConditionalFormattingColorPropertyToCloudFormation(properties.textColor) }) : properties;
    }
    function CfnDashboardGaugeChartPrimaryValueConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("icon", "Icon", properties.Icon != null ? CfnDashboardConditionalFormattingIconPropertyFromCloudFormation(properties.Icon) : void 0), ret.addPropertyResult("textColor", "TextColor", properties.TextColor != null ? CfnDashboardConditionalFormattingColorPropertyFromCloudFormation(properties.TextColor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_GaugeChartVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnDashboard_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnDashboard_GaugeChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("conditionalFormatting", CfnDashboard_GaugeChartConditionalFormattingPropertyValidator)(properties.conditionalFormatting)), errors.collect(cdk.propertyValidator("subtitle", CfnDashboard_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnDashboard_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "GaugeChartVisualProperty"');
    }
    function cfnDashboardGaugeChartVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_GaugeChartVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnDashboardVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnDashboardGaugeChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), ConditionalFormatting: cfnDashboardGaugeChartConditionalFormattingPropertyToCloudFormation(properties.conditionalFormatting), Subtitle: cfnDashboardVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnDashboardVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnDashboardGaugeChartVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnDashboardGaugeChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("conditionalFormatting", "ConditionalFormatting", properties.ConditionalFormatting != null ? CfnDashboardGaugeChartConditionalFormattingPropertyFromCloudFormation(properties.ConditionalFormatting) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnDashboardVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnDashboardVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_GeospatialCoordinateBoundsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("east", cdk.requiredValidator)(properties.east)), errors.collect(cdk.propertyValidator("east", cdk.validateNumber)(properties.east)), errors.collect(cdk.propertyValidator("north", cdk.requiredValidator)(properties.north)), errors.collect(cdk.propertyValidator("north", cdk.validateNumber)(properties.north)), errors.collect(cdk.propertyValidator("south", cdk.requiredValidator)(properties.south)), errors.collect(cdk.propertyValidator("south", cdk.validateNumber)(properties.south)), errors.collect(cdk.propertyValidator("west", cdk.requiredValidator)(properties.west)), errors.collect(cdk.propertyValidator("west", cdk.validateNumber)(properties.west)), errors.wrap('supplied properties not correct for "GeospatialCoordinateBoundsProperty"');
    }
    function cfnDashboardGeospatialCoordinateBoundsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_GeospatialCoordinateBoundsPropertyValidator(properties).assertSuccess(), { East: cdk.numberToCloudFormation(properties.east), North: cdk.numberToCloudFormation(properties.north), South: cdk.numberToCloudFormation(properties.south), West: cdk.numberToCloudFormation(properties.west) }) : properties;
    }
    function CfnDashboardGeospatialCoordinateBoundsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("east", "East", cfn_parse.FromCloudFormation.getNumber(properties.East)), ret.addPropertyResult("north", "North", cfn_parse.FromCloudFormation.getNumber(properties.North)), ret.addPropertyResult("south", "South", cfn_parse.FromCloudFormation.getNumber(properties.South)), ret.addPropertyResult("west", "West", cfn_parse.FromCloudFormation.getNumber(properties.West)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_GeospatialMapAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("colors", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.colors)), errors.collect(cdk.propertyValidator("geospatial", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.geospatial)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnDashboard_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "GeospatialMapAggregatedFieldWellsProperty"');
    }
    function cfnDashboardGeospatialMapAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_GeospatialMapAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Colors: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.colors), Geospatial: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.geospatial), Values: cdk.listMapper(cfnDashboardMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnDashboardGeospatialMapAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("colors", "Colors", properties.Colors != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.Colors) : void 0), ret.addPropertyResult("geospatial", "Geospatial", properties.Geospatial != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.Geospatial) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_GeospatialMapConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldWells", CfnDashboard_GeospatialMapFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("legend", CfnDashboard_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("mapStyleOptions", CfnDashboard_GeospatialMapStyleOptionsPropertyValidator)(properties.mapStyleOptions)), errors.collect(cdk.propertyValidator("pointStyleOptions", CfnDashboard_GeospatialPointStyleOptionsPropertyValidator)(properties.pointStyleOptions)), errors.collect(cdk.propertyValidator("tooltip", CfnDashboard_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.collect(cdk.propertyValidator("visualPalette", CfnDashboard_VisualPalettePropertyValidator)(properties.visualPalette)), errors.collect(cdk.propertyValidator("windowOptions", CfnDashboard_GeospatialWindowOptionsPropertyValidator)(properties.windowOptions)), errors.wrap('supplied properties not correct for "GeospatialMapConfigurationProperty"');
    }
    function cfnDashboardGeospatialMapConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_GeospatialMapConfigurationPropertyValidator(properties).assertSuccess(), { FieldWells: cfnDashboardGeospatialMapFieldWellsPropertyToCloudFormation(properties.fieldWells), Legend: cfnDashboardLegendOptionsPropertyToCloudFormation(properties.legend), MapStyleOptions: cfnDashboardGeospatialMapStyleOptionsPropertyToCloudFormation(properties.mapStyleOptions), PointStyleOptions: cfnDashboardGeospatialPointStyleOptionsPropertyToCloudFormation(properties.pointStyleOptions), Tooltip: cfnDashboardTooltipOptionsPropertyToCloudFormation(properties.tooltip), VisualPalette: cfnDashboardVisualPalettePropertyToCloudFormation(properties.visualPalette), WindowOptions: cfnDashboardGeospatialWindowOptionsPropertyToCloudFormation(properties.windowOptions) }) : properties;
    }
    function CfnDashboardGeospatialMapConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnDashboardGeospatialMapFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnDashboardLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("mapStyleOptions", "MapStyleOptions", properties.MapStyleOptions != null ? CfnDashboardGeospatialMapStyleOptionsPropertyFromCloudFormation(properties.MapStyleOptions) : void 0), ret.addPropertyResult("pointStyleOptions", "PointStyleOptions", properties.PointStyleOptions != null ? CfnDashboardGeospatialPointStyleOptionsPropertyFromCloudFormation(properties.PointStyleOptions) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnDashboardTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnDashboardVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addPropertyResult("windowOptions", "WindowOptions", properties.WindowOptions != null ? CfnDashboardGeospatialWindowOptionsPropertyFromCloudFormation(properties.WindowOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_GeospatialMapFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("geospatialMapAggregatedFieldWells", CfnDashboard_GeospatialMapAggregatedFieldWellsPropertyValidator)(properties.geospatialMapAggregatedFieldWells)), errors.wrap('supplied properties not correct for "GeospatialMapFieldWellsProperty"');
    }
    function cfnDashboardGeospatialMapFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_GeospatialMapFieldWellsPropertyValidator(properties).assertSuccess(), { GeospatialMapAggregatedFieldWells: cfnDashboardGeospatialMapAggregatedFieldWellsPropertyToCloudFormation(properties.geospatialMapAggregatedFieldWells) }) : properties;
    }
    function CfnDashboardGeospatialMapFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("geospatialMapAggregatedFieldWells", "GeospatialMapAggregatedFieldWells", properties.GeospatialMapAggregatedFieldWells != null ? CfnDashboardGeospatialMapAggregatedFieldWellsPropertyFromCloudFormation(properties.GeospatialMapAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_GeospatialMapStyleOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("baseMapStyle", cdk.validateString)(properties.baseMapStyle)), errors.wrap('supplied properties not correct for "GeospatialMapStyleOptionsProperty"');
    }
    function cfnDashboardGeospatialMapStyleOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_GeospatialMapStyleOptionsPropertyValidator(properties).assertSuccess(), { BaseMapStyle: cdk.stringToCloudFormation(properties.baseMapStyle) }) : properties;
    }
    function CfnDashboardGeospatialMapStyleOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("baseMapStyle", "BaseMapStyle", properties.BaseMapStyle != null ? cfn_parse.FromCloudFormation.getString(properties.BaseMapStyle) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_GeospatialMapVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnDashboard_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnDashboard_GeospatialMapConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnDashboard_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnDashboard_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnDashboard_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "GeospatialMapVisualProperty"');
    }
    function cfnDashboardGeospatialMapVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_GeospatialMapVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnDashboardVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnDashboardGeospatialMapConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnDashboardColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnDashboardVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnDashboardVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnDashboardGeospatialMapVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnDashboardGeospatialMapConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnDashboardVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnDashboardVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_GeospatialPointStyleOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clusterMarkerConfiguration", CfnDashboard_ClusterMarkerConfigurationPropertyValidator)(properties.clusterMarkerConfiguration)), errors.collect(cdk.propertyValidator("selectedPointStyle", cdk.validateString)(properties.selectedPointStyle)), errors.wrap('supplied properties not correct for "GeospatialPointStyleOptionsProperty"');
    }
    function cfnDashboardGeospatialPointStyleOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_GeospatialPointStyleOptionsPropertyValidator(properties).assertSuccess(), { ClusterMarkerConfiguration: cfnDashboardClusterMarkerConfigurationPropertyToCloudFormation(properties.clusterMarkerConfiguration), SelectedPointStyle: cdk.stringToCloudFormation(properties.selectedPointStyle) }) : properties;
    }
    function CfnDashboardGeospatialPointStyleOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clusterMarkerConfiguration", "ClusterMarkerConfiguration", properties.ClusterMarkerConfiguration != null ? CfnDashboardClusterMarkerConfigurationPropertyFromCloudFormation(properties.ClusterMarkerConfiguration) : void 0), ret.addPropertyResult("selectedPointStyle", "SelectedPointStyle", properties.SelectedPointStyle != null ? cfn_parse.FromCloudFormation.getString(properties.SelectedPointStyle) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_GeospatialWindowOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bounds", CfnDashboard_GeospatialCoordinateBoundsPropertyValidator)(properties.bounds)), errors.collect(cdk.propertyValidator("mapZoomMode", cdk.validateString)(properties.mapZoomMode)), errors.wrap('supplied properties not correct for "GeospatialWindowOptionsProperty"');
    }
    function cfnDashboardGeospatialWindowOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_GeospatialWindowOptionsPropertyValidator(properties).assertSuccess(), { Bounds: cfnDashboardGeospatialCoordinateBoundsPropertyToCloudFormation(properties.bounds), MapZoomMode: cdk.stringToCloudFormation(properties.mapZoomMode) }) : properties;
    }
    function CfnDashboardGeospatialWindowOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bounds", "Bounds", properties.Bounds != null ? CfnDashboardGeospatialCoordinateBoundsPropertyFromCloudFormation(properties.Bounds) : void 0), ret.addPropertyResult("mapZoomMode", "MapZoomMode", properties.MapZoomMode != null ? cfn_parse.FromCloudFormation.getString(properties.MapZoomMode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_GlobalTableBorderOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sideSpecificBorder", CfnDashboard_TableSideBorderOptionsPropertyValidator)(properties.sideSpecificBorder)), errors.collect(cdk.propertyValidator("uniformBorder", CfnDashboard_TableBorderOptionsPropertyValidator)(properties.uniformBorder)), errors.wrap('supplied properties not correct for "GlobalTableBorderOptionsProperty"');
    }
    function cfnDashboardGlobalTableBorderOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_GlobalTableBorderOptionsPropertyValidator(properties).assertSuccess(), { SideSpecificBorder: cfnDashboardTableSideBorderOptionsPropertyToCloudFormation(properties.sideSpecificBorder), UniformBorder: cfnDashboardTableBorderOptionsPropertyToCloudFormation(properties.uniformBorder) }) : properties;
    }
    function CfnDashboardGlobalTableBorderOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sideSpecificBorder", "SideSpecificBorder", properties.SideSpecificBorder != null ? CfnDashboardTableSideBorderOptionsPropertyFromCloudFormation(properties.SideSpecificBorder) : void 0), ret.addPropertyResult("uniformBorder", "UniformBorder", properties.UniformBorder != null ? CfnDashboardTableBorderOptionsPropertyFromCloudFormation(properties.UniformBorder) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_GradientColorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("stops", cdk.listValidator(CfnDashboard_GradientStopPropertyValidator))(properties.stops)), errors.wrap('supplied properties not correct for "GradientColorProperty"');
    }
    function cfnDashboardGradientColorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_GradientColorPropertyValidator(properties).assertSuccess(), { Stops: cdk.listMapper(cfnDashboardGradientStopPropertyToCloudFormation)(properties.stops) }) : properties;
    }
    function CfnDashboardGradientColorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("stops", "Stops", properties.Stops != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardGradientStopPropertyFromCloudFormation)(properties.Stops) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_GradientStopPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.collect(cdk.propertyValidator("dataValue", cdk.validateNumber)(properties.dataValue)), errors.collect(cdk.propertyValidator("gradientOffset", cdk.requiredValidator)(properties.gradientOffset)), errors.collect(cdk.propertyValidator("gradientOffset", cdk.validateNumber)(properties.gradientOffset)), errors.wrap('supplied properties not correct for "GradientStopProperty"');
    }
    function cfnDashboardGradientStopPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_GradientStopPropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color), DataValue: cdk.numberToCloudFormation(properties.dataValue), GradientOffset: cdk.numberToCloudFormation(properties.gradientOffset) }) : properties;
    }
    function CfnDashboardGradientStopPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", properties.Color != null ? cfn_parse.FromCloudFormation.getString(properties.Color) : void 0), ret.addPropertyResult("dataValue", "DataValue", properties.DataValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.DataValue) : void 0), ret.addPropertyResult("gradientOffset", "GradientOffset", cfn_parse.FromCloudFormation.getNumber(properties.GradientOffset)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_GridLayoutCanvasSizeOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("screenCanvasSizeOptions", CfnDashboard_GridLayoutScreenCanvasSizeOptionsPropertyValidator)(properties.screenCanvasSizeOptions)), errors.wrap('supplied properties not correct for "GridLayoutCanvasSizeOptionsProperty"');
    }
    function cfnDashboardGridLayoutCanvasSizeOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_GridLayoutCanvasSizeOptionsPropertyValidator(properties).assertSuccess(), { ScreenCanvasSizeOptions: cfnDashboardGridLayoutScreenCanvasSizeOptionsPropertyToCloudFormation(properties.screenCanvasSizeOptions) }) : properties;
    }
    function CfnDashboardGridLayoutCanvasSizeOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("screenCanvasSizeOptions", "ScreenCanvasSizeOptions", properties.ScreenCanvasSizeOptions != null ? CfnDashboardGridLayoutScreenCanvasSizeOptionsPropertyFromCloudFormation(properties.ScreenCanvasSizeOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_GridLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("canvasSizeOptions", CfnDashboard_GridLayoutCanvasSizeOptionsPropertyValidator)(properties.canvasSizeOptions)), errors.collect(cdk.propertyValidator("elements", cdk.requiredValidator)(properties.elements)), errors.collect(cdk.propertyValidator("elements", cdk.listValidator(CfnDashboard_GridLayoutElementPropertyValidator))(properties.elements)), errors.wrap('supplied properties not correct for "GridLayoutConfigurationProperty"');
    }
    function cfnDashboardGridLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_GridLayoutConfigurationPropertyValidator(properties).assertSuccess(), { CanvasSizeOptions: cfnDashboardGridLayoutCanvasSizeOptionsPropertyToCloudFormation(properties.canvasSizeOptions), Elements: cdk.listMapper(cfnDashboardGridLayoutElementPropertyToCloudFormation)(properties.elements) }) : properties;
    }
    function CfnDashboardGridLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("canvasSizeOptions", "CanvasSizeOptions", properties.CanvasSizeOptions != null ? CfnDashboardGridLayoutCanvasSizeOptionsPropertyFromCloudFormation(properties.CanvasSizeOptions) : void 0), ret.addPropertyResult("elements", "Elements", cfn_parse.FromCloudFormation.getArray(CfnDashboardGridLayoutElementPropertyFromCloudFormation)(properties.Elements)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_GridLayoutElementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnIndex", cdk.validateNumber)(properties.columnIndex)), errors.collect(cdk.propertyValidator("columnSpan", cdk.requiredValidator)(properties.columnSpan)), errors.collect(cdk.propertyValidator("columnSpan", cdk.validateNumber)(properties.columnSpan)), errors.collect(cdk.propertyValidator("elementId", cdk.requiredValidator)(properties.elementId)), errors.collect(cdk.propertyValidator("elementId", cdk.validateString)(properties.elementId)), errors.collect(cdk.propertyValidator("elementType", cdk.requiredValidator)(properties.elementType)), errors.collect(cdk.propertyValidator("elementType", cdk.validateString)(properties.elementType)), errors.collect(cdk.propertyValidator("rowIndex", cdk.validateNumber)(properties.rowIndex)), errors.collect(cdk.propertyValidator("rowSpan", cdk.requiredValidator)(properties.rowSpan)), errors.collect(cdk.propertyValidator("rowSpan", cdk.validateNumber)(properties.rowSpan)), errors.wrap('supplied properties not correct for "GridLayoutElementProperty"');
    }
    function cfnDashboardGridLayoutElementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_GridLayoutElementPropertyValidator(properties).assertSuccess(), { ColumnIndex: cdk.numberToCloudFormation(properties.columnIndex), ColumnSpan: cdk.numberToCloudFormation(properties.columnSpan), ElementId: cdk.stringToCloudFormation(properties.elementId), ElementType: cdk.stringToCloudFormation(properties.elementType), RowIndex: cdk.numberToCloudFormation(properties.rowIndex), RowSpan: cdk.numberToCloudFormation(properties.rowSpan) }) : properties;
    }
    function CfnDashboardGridLayoutElementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columnIndex", "ColumnIndex", properties.ColumnIndex != null ? cfn_parse.FromCloudFormation.getNumber(properties.ColumnIndex) : void 0), ret.addPropertyResult("columnSpan", "ColumnSpan", cfn_parse.FromCloudFormation.getNumber(properties.ColumnSpan)), ret.addPropertyResult("elementId", "ElementId", cfn_parse.FromCloudFormation.getString(properties.ElementId)), ret.addPropertyResult("elementType", "ElementType", cfn_parse.FromCloudFormation.getString(properties.ElementType)), ret.addPropertyResult("rowIndex", "RowIndex", properties.RowIndex != null ? cfn_parse.FromCloudFormation.getNumber(properties.RowIndex) : void 0), ret.addPropertyResult("rowSpan", "RowSpan", cfn_parse.FromCloudFormation.getNumber(properties.RowSpan)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_GridLayoutScreenCanvasSizeOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("optimizedViewPortWidth", cdk.validateString)(properties.optimizedViewPortWidth)), errors.collect(cdk.propertyValidator("resizeOption", cdk.requiredValidator)(properties.resizeOption)), errors.collect(cdk.propertyValidator("resizeOption", cdk.validateString)(properties.resizeOption)), errors.wrap('supplied properties not correct for "GridLayoutScreenCanvasSizeOptionsProperty"');
    }
    function cfnDashboardGridLayoutScreenCanvasSizeOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_GridLayoutScreenCanvasSizeOptionsPropertyValidator(properties).assertSuccess(), { OptimizedViewPortWidth: cdk.stringToCloudFormation(properties.optimizedViewPortWidth), ResizeOption: cdk.stringToCloudFormation(properties.resizeOption) }) : properties;
    }
    function CfnDashboardGridLayoutScreenCanvasSizeOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("optimizedViewPortWidth", "OptimizedViewPortWidth", properties.OptimizedViewPortWidth != null ? cfn_parse.FromCloudFormation.getString(properties.OptimizedViewPortWidth) : void 0), ret.addPropertyResult("resizeOption", "ResizeOption", cfn_parse.FromCloudFormation.getString(properties.ResizeOption)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_GrowthRateComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computationId", cdk.requiredValidator)(properties.computationId)), errors.collect(cdk.propertyValidator("computationId", cdk.validateString)(properties.computationId)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("periodSize", cdk.validateNumber)(properties.periodSize)), errors.collect(cdk.propertyValidator("time", cdk.requiredValidator)(properties.time)), errors.collect(cdk.propertyValidator("time", CfnDashboard_DimensionFieldPropertyValidator)(properties.time)), errors.collect(cdk.propertyValidator("value", CfnDashboard_MeasureFieldPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "GrowthRateComputationProperty"');
    }
    function cfnDashboardGrowthRateComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_GrowthRateComputationPropertyValidator(properties).assertSuccess(), { ComputationId: cdk.stringToCloudFormation(properties.computationId), Name: cdk.stringToCloudFormation(properties.name), PeriodSize: cdk.numberToCloudFormation(properties.periodSize), Time: cfnDashboardDimensionFieldPropertyToCloudFormation(properties.time), Value: cfnDashboardMeasureFieldPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnDashboardGrowthRateComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computationId", "ComputationId", cfn_parse.FromCloudFormation.getString(properties.ComputationId)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("periodSize", "PeriodSize", properties.PeriodSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.PeriodSize) : void 0), ret.addPropertyResult("time", "Time", CfnDashboardDimensionFieldPropertyFromCloudFormation(properties.Time)), ret.addPropertyResult("value", "Value", properties.Value != null ? CfnDashboardMeasureFieldPropertyFromCloudFormation(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_HeaderFooterSectionConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("layout", cdk.requiredValidator)(properties.layout)), errors.collect(cdk.propertyValidator("layout", CfnDashboard_SectionLayoutConfigurationPropertyValidator)(properties.layout)), errors.collect(cdk.propertyValidator("sectionId", cdk.requiredValidator)(properties.sectionId)), errors.collect(cdk.propertyValidator("sectionId", cdk.validateString)(properties.sectionId)), errors.collect(cdk.propertyValidator("style", CfnDashboard_SectionStylePropertyValidator)(properties.style)), errors.wrap('supplied properties not correct for "HeaderFooterSectionConfigurationProperty"');
    }
    function cfnDashboardHeaderFooterSectionConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_HeaderFooterSectionConfigurationPropertyValidator(properties).assertSuccess(), { Layout: cfnDashboardSectionLayoutConfigurationPropertyToCloudFormation(properties.layout), SectionId: cdk.stringToCloudFormation(properties.sectionId), Style: cfnDashboardSectionStylePropertyToCloudFormation(properties.style) }) : properties;
    }
    function CfnDashboardHeaderFooterSectionConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("layout", "Layout", CfnDashboardSectionLayoutConfigurationPropertyFromCloudFormation(properties.Layout)), ret.addPropertyResult("sectionId", "SectionId", cfn_parse.FromCloudFormation.getString(properties.SectionId)), ret.addPropertyResult("style", "Style", properties.Style != null ? CfnDashboardSectionStylePropertyFromCloudFormation(properties.Style) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_HeatMapAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columns", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.columns)), errors.collect(cdk.propertyValidator("rows", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.rows)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnDashboard_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "HeatMapAggregatedFieldWellsProperty"');
    }
    function cfnDashboardHeatMapAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_HeatMapAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Columns: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.columns), Rows: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.rows), Values: cdk.listMapper(cfnDashboardMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnDashboardHeatMapAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columns", "Columns", properties.Columns != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.Columns) : void 0), ret.addPropertyResult("rows", "Rows", properties.Rows != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.Rows) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_HeatMapConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("colorScale", CfnDashboard_ColorScalePropertyValidator)(properties.colorScale)), errors.collect(cdk.propertyValidator("columnLabelOptions", CfnDashboard_ChartAxisLabelOptionsPropertyValidator)(properties.columnLabelOptions)), errors.collect(cdk.propertyValidator("dataLabels", CfnDashboard_DataLabelOptionsPropertyValidator)(properties.dataLabels)), errors.collect(cdk.propertyValidator("fieldWells", CfnDashboard_HeatMapFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("legend", CfnDashboard_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("rowLabelOptions", CfnDashboard_ChartAxisLabelOptionsPropertyValidator)(properties.rowLabelOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnDashboard_HeatMapSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tooltip", CfnDashboard_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.wrap('supplied properties not correct for "HeatMapConfigurationProperty"');
    }
    function cfnDashboardHeatMapConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_HeatMapConfigurationPropertyValidator(properties).assertSuccess(), { ColorScale: cfnDashboardColorScalePropertyToCloudFormation(properties.colorScale), ColumnLabelOptions: cfnDashboardChartAxisLabelOptionsPropertyToCloudFormation(properties.columnLabelOptions), DataLabels: cfnDashboardDataLabelOptionsPropertyToCloudFormation(properties.dataLabels), FieldWells: cfnDashboardHeatMapFieldWellsPropertyToCloudFormation(properties.fieldWells), Legend: cfnDashboardLegendOptionsPropertyToCloudFormation(properties.legend), RowLabelOptions: cfnDashboardChartAxisLabelOptionsPropertyToCloudFormation(properties.rowLabelOptions), SortConfiguration: cfnDashboardHeatMapSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), Tooltip: cfnDashboardTooltipOptionsPropertyToCloudFormation(properties.tooltip) }) : properties;
    }
    function CfnDashboardHeatMapConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("colorScale", "ColorScale", properties.ColorScale != null ? CfnDashboardColorScalePropertyFromCloudFormation(properties.ColorScale) : void 0), ret.addPropertyResult("columnLabelOptions", "ColumnLabelOptions", properties.ColumnLabelOptions != null ? CfnDashboardChartAxisLabelOptionsPropertyFromCloudFormation(properties.ColumnLabelOptions) : void 0), ret.addPropertyResult("dataLabels", "DataLabels", properties.DataLabels != null ? CfnDashboardDataLabelOptionsPropertyFromCloudFormation(properties.DataLabels) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnDashboardHeatMapFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnDashboardLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("rowLabelOptions", "RowLabelOptions", properties.RowLabelOptions != null ? CfnDashboardChartAxisLabelOptionsPropertyFromCloudFormation(properties.RowLabelOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnDashboardHeatMapSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnDashboardTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_HeatMapFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("heatMapAggregatedFieldWells", CfnDashboard_HeatMapAggregatedFieldWellsPropertyValidator)(properties.heatMapAggregatedFieldWells)), errors.wrap('supplied properties not correct for "HeatMapFieldWellsProperty"');
    }
    function cfnDashboardHeatMapFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_HeatMapFieldWellsPropertyValidator(properties).assertSuccess(), { HeatMapAggregatedFieldWells: cfnDashboardHeatMapAggregatedFieldWellsPropertyToCloudFormation(properties.heatMapAggregatedFieldWells) }) : properties;
    }
    function CfnDashboardHeatMapFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("heatMapAggregatedFieldWells", "HeatMapAggregatedFieldWells", properties.HeatMapAggregatedFieldWells != null ? CfnDashboardHeatMapAggregatedFieldWellsPropertyFromCloudFormation(properties.HeatMapAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_HeatMapSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("heatMapColumnItemsLimitConfiguration", CfnDashboard_ItemsLimitConfigurationPropertyValidator)(properties.heatMapColumnItemsLimitConfiguration)), errors.collect(cdk.propertyValidator("heatMapColumnSort", cdk.listValidator(CfnDashboard_FieldSortOptionsPropertyValidator))(properties.heatMapColumnSort)), errors.collect(cdk.propertyValidator("heatMapRowItemsLimitConfiguration", CfnDashboard_ItemsLimitConfigurationPropertyValidator)(properties.heatMapRowItemsLimitConfiguration)), errors.collect(cdk.propertyValidator("heatMapRowSort", cdk.listValidator(CfnDashboard_FieldSortOptionsPropertyValidator))(properties.heatMapRowSort)), errors.wrap('supplied properties not correct for "HeatMapSortConfigurationProperty"');
    }
    function cfnDashboardHeatMapSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_HeatMapSortConfigurationPropertyValidator(properties).assertSuccess(), { HeatMapColumnItemsLimitConfiguration: cfnDashboardItemsLimitConfigurationPropertyToCloudFormation(properties.heatMapColumnItemsLimitConfiguration), HeatMapColumnSort: cdk.listMapper(cfnDashboardFieldSortOptionsPropertyToCloudFormation)(properties.heatMapColumnSort), HeatMapRowItemsLimitConfiguration: cfnDashboardItemsLimitConfigurationPropertyToCloudFormation(properties.heatMapRowItemsLimitConfiguration), HeatMapRowSort: cdk.listMapper(cfnDashboardFieldSortOptionsPropertyToCloudFormation)(properties.heatMapRowSort) }) : properties;
    }
    function CfnDashboardHeatMapSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("heatMapColumnItemsLimitConfiguration", "HeatMapColumnItemsLimitConfiguration", properties.HeatMapColumnItemsLimitConfiguration != null ? CfnDashboardItemsLimitConfigurationPropertyFromCloudFormation(properties.HeatMapColumnItemsLimitConfiguration) : void 0), ret.addPropertyResult("heatMapColumnSort", "HeatMapColumnSort", properties.HeatMapColumnSort != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardFieldSortOptionsPropertyFromCloudFormation)(properties.HeatMapColumnSort) : void 0), ret.addPropertyResult("heatMapRowItemsLimitConfiguration", "HeatMapRowItemsLimitConfiguration", properties.HeatMapRowItemsLimitConfiguration != null ? CfnDashboardItemsLimitConfigurationPropertyFromCloudFormation(properties.HeatMapRowItemsLimitConfiguration) : void 0), ret.addPropertyResult("heatMapRowSort", "HeatMapRowSort", properties.HeatMapRowSort != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardFieldSortOptionsPropertyFromCloudFormation)(properties.HeatMapRowSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_HeatMapVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnDashboard_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnDashboard_HeatMapConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnDashboard_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnDashboard_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnDashboard_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "HeatMapVisualProperty"');
    }
    function cfnDashboardHeatMapVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_HeatMapVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnDashboardVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnDashboardHeatMapConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnDashboardColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnDashboardVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnDashboardVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnDashboardHeatMapVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnDashboardHeatMapConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnDashboardVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnDashboardVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_HistogramAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnDashboard_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "HistogramAggregatedFieldWellsProperty"');
    }
    function cfnDashboardHistogramAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_HistogramAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Values: cdk.listMapper(cfnDashboardMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnDashboardHistogramAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_HistogramBinOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("binCount", CfnDashboard_BinCountOptionsPropertyValidator)(properties.binCount)), errors.collect(cdk.propertyValidator("binWidth", CfnDashboard_BinWidthOptionsPropertyValidator)(properties.binWidth)), errors.collect(cdk.propertyValidator("selectedBinType", cdk.validateString)(properties.selectedBinType)), errors.collect(cdk.propertyValidator("startValue", cdk.validateNumber)(properties.startValue)), errors.wrap('supplied properties not correct for "HistogramBinOptionsProperty"');
    }
    function cfnDashboardHistogramBinOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_HistogramBinOptionsPropertyValidator(properties).assertSuccess(), { BinCount: cfnDashboardBinCountOptionsPropertyToCloudFormation(properties.binCount), BinWidth: cfnDashboardBinWidthOptionsPropertyToCloudFormation(properties.binWidth), SelectedBinType: cdk.stringToCloudFormation(properties.selectedBinType), StartValue: cdk.numberToCloudFormation(properties.startValue) }) : properties;
    }
    function CfnDashboardHistogramBinOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("binCount", "BinCount", properties.BinCount != null ? CfnDashboardBinCountOptionsPropertyFromCloudFormation(properties.BinCount) : void 0), ret.addPropertyResult("binWidth", "BinWidth", properties.BinWidth != null ? CfnDashboardBinWidthOptionsPropertyFromCloudFormation(properties.BinWidth) : void 0), ret.addPropertyResult("selectedBinType", "SelectedBinType", properties.SelectedBinType != null ? cfn_parse.FromCloudFormation.getString(properties.SelectedBinType) : void 0), ret.addPropertyResult("startValue", "StartValue", properties.StartValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.StartValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_HistogramConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("binOptions", CfnDashboard_HistogramBinOptionsPropertyValidator)(properties.binOptions)), errors.collect(cdk.propertyValidator("dataLabels", CfnDashboard_DataLabelOptionsPropertyValidator)(properties.dataLabels)), errors.collect(cdk.propertyValidator("fieldWells", CfnDashboard_HistogramFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("tooltip", CfnDashboard_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.collect(cdk.propertyValidator("visualPalette", CfnDashboard_VisualPalettePropertyValidator)(properties.visualPalette)), errors.collect(cdk.propertyValidator("xAxisDisplayOptions", CfnDashboard_AxisDisplayOptionsPropertyValidator)(properties.xAxisDisplayOptions)), errors.collect(cdk.propertyValidator("xAxisLabelOptions", CfnDashboard_ChartAxisLabelOptionsPropertyValidator)(properties.xAxisLabelOptions)), errors.collect(cdk.propertyValidator("yAxisDisplayOptions", CfnDashboard_AxisDisplayOptionsPropertyValidator)(properties.yAxisDisplayOptions)), errors.wrap('supplied properties not correct for "HistogramConfigurationProperty"');
    }
    function cfnDashboardHistogramConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_HistogramConfigurationPropertyValidator(properties).assertSuccess(), { BinOptions: cfnDashboardHistogramBinOptionsPropertyToCloudFormation(properties.binOptions), DataLabels: cfnDashboardDataLabelOptionsPropertyToCloudFormation(properties.dataLabels), FieldWells: cfnDashboardHistogramFieldWellsPropertyToCloudFormation(properties.fieldWells), Tooltip: cfnDashboardTooltipOptionsPropertyToCloudFormation(properties.tooltip), VisualPalette: cfnDashboardVisualPalettePropertyToCloudFormation(properties.visualPalette), XAxisDisplayOptions: cfnDashboardAxisDisplayOptionsPropertyToCloudFormation(properties.xAxisDisplayOptions), XAxisLabelOptions: cfnDashboardChartAxisLabelOptionsPropertyToCloudFormation(properties.xAxisLabelOptions), YAxisDisplayOptions: cfnDashboardAxisDisplayOptionsPropertyToCloudFormation(properties.yAxisDisplayOptions) }) : properties;
    }
    function CfnDashboardHistogramConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("binOptions", "BinOptions", properties.BinOptions != null ? CfnDashboardHistogramBinOptionsPropertyFromCloudFormation(properties.BinOptions) : void 0), ret.addPropertyResult("dataLabels", "DataLabels", properties.DataLabels != null ? CfnDashboardDataLabelOptionsPropertyFromCloudFormation(properties.DataLabels) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnDashboardHistogramFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnDashboardTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnDashboardVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addPropertyResult("xAxisDisplayOptions", "XAxisDisplayOptions", properties.XAxisDisplayOptions != null ? CfnDashboardAxisDisplayOptionsPropertyFromCloudFormation(properties.XAxisDisplayOptions) : void 0), ret.addPropertyResult("xAxisLabelOptions", "XAxisLabelOptions", properties.XAxisLabelOptions != null ? CfnDashboardChartAxisLabelOptionsPropertyFromCloudFormation(properties.XAxisLabelOptions) : void 0), ret.addPropertyResult("yAxisDisplayOptions", "YAxisDisplayOptions", properties.YAxisDisplayOptions != null ? CfnDashboardAxisDisplayOptionsPropertyFromCloudFormation(properties.YAxisDisplayOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_HistogramFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("histogramAggregatedFieldWells", CfnDashboard_HistogramAggregatedFieldWellsPropertyValidator)(properties.histogramAggregatedFieldWells)), errors.wrap('supplied properties not correct for "HistogramFieldWellsProperty"');
    }
    function cfnDashboardHistogramFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_HistogramFieldWellsPropertyValidator(properties).assertSuccess(), { HistogramAggregatedFieldWells: cfnDashboardHistogramAggregatedFieldWellsPropertyToCloudFormation(properties.histogramAggregatedFieldWells) }) : properties;
    }
    function CfnDashboardHistogramFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("histogramAggregatedFieldWells", "HistogramAggregatedFieldWells", properties.HistogramAggregatedFieldWells != null ? CfnDashboardHistogramAggregatedFieldWellsPropertyFromCloudFormation(properties.HistogramAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_HistogramVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnDashboard_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnDashboard_HistogramConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("subtitle", CfnDashboard_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnDashboard_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "HistogramVisualProperty"');
    }
    function cfnDashboardHistogramVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_HistogramVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnDashboardVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnDashboardHistogramConfigurationPropertyToCloudFormation(properties.chartConfiguration), Subtitle: cfnDashboardVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnDashboardVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnDashboardHistogramVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnDashboardHistogramConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnDashboardVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnDashboardVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_InsightConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computations", cdk.listValidator(CfnDashboard_ComputationPropertyValidator))(properties.computations)), errors.collect(cdk.propertyValidator("customNarrative", CfnDashboard_CustomNarrativeOptionsPropertyValidator)(properties.customNarrative)), errors.wrap('supplied properties not correct for "InsightConfigurationProperty"');
    }
    function cfnDashboardInsightConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_InsightConfigurationPropertyValidator(properties).assertSuccess(), { Computations: cdk.listMapper(cfnDashboardComputationPropertyToCloudFormation)(properties.computations), CustomNarrative: cfnDashboardCustomNarrativeOptionsPropertyToCloudFormation(properties.customNarrative) }) : properties;
    }
    function CfnDashboardInsightConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computations", "Computations", properties.Computations != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardComputationPropertyFromCloudFormation)(properties.Computations) : void 0), ret.addPropertyResult("customNarrative", "CustomNarrative", properties.CustomNarrative != null ? CfnDashboardCustomNarrativeOptionsPropertyFromCloudFormation(properties.CustomNarrative) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_InsightVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnDashboard_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.requiredValidator)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.validateString)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("insightConfiguration", CfnDashboard_InsightConfigurationPropertyValidator)(properties.insightConfiguration)), errors.collect(cdk.propertyValidator("subtitle", CfnDashboard_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnDashboard_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "InsightVisualProperty"');
    }
    function cfnDashboardInsightVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_InsightVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnDashboardVisualCustomActionPropertyToCloudFormation)(properties.actions), DataSetIdentifier: cdk.stringToCloudFormation(properties.dataSetIdentifier), InsightConfiguration: cfnDashboardInsightConfigurationPropertyToCloudFormation(properties.insightConfiguration), Subtitle: cfnDashboardVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnDashboardVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnDashboardInsightVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("dataSetIdentifier", "DataSetIdentifier", cfn_parse.FromCloudFormation.getString(properties.DataSetIdentifier)), ret.addPropertyResult("insightConfiguration", "InsightConfiguration", properties.InsightConfiguration != null ? CfnDashboardInsightConfigurationPropertyFromCloudFormation(properties.InsightConfiguration) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnDashboardVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnDashboardVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_IntegerDefaultValuesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dynamicValue", CfnDashboard_DynamicDefaultValuePropertyValidator)(properties.dynamicValue)), errors.collect(cdk.propertyValidator("staticValues", cdk.listValidator(cdk.validateNumber))(properties.staticValues)), errors.wrap('supplied properties not correct for "IntegerDefaultValuesProperty"');
    }
    function cfnDashboardIntegerDefaultValuesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_IntegerDefaultValuesPropertyValidator(properties).assertSuccess(), { DynamicValue: cfnDashboardDynamicDefaultValuePropertyToCloudFormation(properties.dynamicValue), StaticValues: cdk.listMapper(cdk.numberToCloudFormation)(properties.staticValues) }) : properties;
    }
    function CfnDashboardIntegerDefaultValuesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dynamicValue", "DynamicValue", properties.DynamicValue != null ? CfnDashboardDynamicDefaultValuePropertyFromCloudFormation(properties.DynamicValue) : void 0), ret.addPropertyResult("staticValues", "StaticValues", properties.StaticValues != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getNumber)(properties.StaticValues) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_IntegerParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("values", cdk.requiredValidator)(properties.values)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateNumber))(properties.values)), errors.wrap('supplied properties not correct for "IntegerParameterProperty"');
    }
    function cfnDashboardIntegerParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_IntegerParameterPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Values: cdk.listMapper(cdk.numberToCloudFormation)(properties.values) }) : properties;
    }
    function CfnDashboardIntegerParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("values", "Values", cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getNumber)(properties.Values)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_IntegerParameterDeclarationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultValues", CfnDashboard_IntegerDefaultValuesPropertyValidator)(properties.defaultValues)), errors.collect(cdk.propertyValidator("mappedDataSetParameters", cdk.listValidator(CfnDashboard_MappedDataSetParameterPropertyValidator))(properties.mappedDataSetParameters)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("parameterValueType", cdk.requiredValidator)(properties.parameterValueType)), errors.collect(cdk.propertyValidator("parameterValueType", cdk.validateString)(properties.parameterValueType)), errors.collect(cdk.propertyValidator("valueWhenUnset", CfnDashboard_IntegerValueWhenUnsetConfigurationPropertyValidator)(properties.valueWhenUnset)), errors.wrap('supplied properties not correct for "IntegerParameterDeclarationProperty"');
    }
    function cfnDashboardIntegerParameterDeclarationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_IntegerParameterDeclarationPropertyValidator(properties).assertSuccess(), { DefaultValues: cfnDashboardIntegerDefaultValuesPropertyToCloudFormation(properties.defaultValues), MappedDataSetParameters: cdk.listMapper(cfnDashboardMappedDataSetParameterPropertyToCloudFormation)(properties.mappedDataSetParameters), Name: cdk.stringToCloudFormation(properties.name), ParameterValueType: cdk.stringToCloudFormation(properties.parameterValueType), ValueWhenUnset: cfnDashboardIntegerValueWhenUnsetConfigurationPropertyToCloudFormation(properties.valueWhenUnset) }) : properties;
    }
    function CfnDashboardIntegerParameterDeclarationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultValues", "DefaultValues", properties.DefaultValues != null ? CfnDashboardIntegerDefaultValuesPropertyFromCloudFormation(properties.DefaultValues) : void 0), ret.addPropertyResult("mappedDataSetParameters", "MappedDataSetParameters", properties.MappedDataSetParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMappedDataSetParameterPropertyFromCloudFormation)(properties.MappedDataSetParameters) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("parameterValueType", "ParameterValueType", cfn_parse.FromCloudFormation.getString(properties.ParameterValueType)), ret.addPropertyResult("valueWhenUnset", "ValueWhenUnset", properties.ValueWhenUnset != null ? CfnDashboardIntegerValueWhenUnsetConfigurationPropertyFromCloudFormation(properties.ValueWhenUnset) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_IntegerValueWhenUnsetConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customValue", cdk.validateNumber)(properties.customValue)), errors.collect(cdk.propertyValidator("valueWhenUnsetOption", cdk.validateString)(properties.valueWhenUnsetOption)), errors.wrap('supplied properties not correct for "IntegerValueWhenUnsetConfigurationProperty"');
    }
    function cfnDashboardIntegerValueWhenUnsetConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_IntegerValueWhenUnsetConfigurationPropertyValidator(properties).assertSuccess(), { CustomValue: cdk.numberToCloudFormation(properties.customValue), ValueWhenUnsetOption: cdk.stringToCloudFormation(properties.valueWhenUnsetOption) }) : properties;
    }
    function CfnDashboardIntegerValueWhenUnsetConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customValue", "CustomValue", properties.CustomValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.CustomValue) : void 0), ret.addPropertyResult("valueWhenUnsetOption", "ValueWhenUnsetOption", properties.ValueWhenUnsetOption != null ? cfn_parse.FromCloudFormation.getString(properties.ValueWhenUnsetOption) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ItemsLimitConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("itemsLimit", cdk.validateNumber)(properties.itemsLimit)), errors.collect(cdk.propertyValidator("otherCategories", cdk.validateString)(properties.otherCategories)), errors.wrap('supplied properties not correct for "ItemsLimitConfigurationProperty"');
    }
    function cfnDashboardItemsLimitConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ItemsLimitConfigurationPropertyValidator(properties).assertSuccess(), { ItemsLimit: cdk.numberToCloudFormation(properties.itemsLimit), OtherCategories: cdk.stringToCloudFormation(properties.otherCategories) }) : properties;
    }
    function CfnDashboardItemsLimitConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("itemsLimit", "ItemsLimit", properties.ItemsLimit != null ? cfn_parse.FromCloudFormation.getNumber(properties.ItemsLimit) : void 0), ret.addPropertyResult("otherCategories", "OtherCategories", properties.OtherCategories != null ? cfn_parse.FromCloudFormation.getString(properties.OtherCategories) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_KPIConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("conditionalFormattingOptions", cdk.listValidator(CfnDashboard_KPIConditionalFormattingOptionPropertyValidator))(properties.conditionalFormattingOptions)), errors.wrap('supplied properties not correct for "KPIConditionalFormattingProperty"');
    }
    function cfnDashboardKPIConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_KPIConditionalFormattingPropertyValidator(properties).assertSuccess(), { ConditionalFormattingOptions: cdk.listMapper(cfnDashboardKPIConditionalFormattingOptionPropertyToCloudFormation)(properties.conditionalFormattingOptions) }) : properties;
    }
    function CfnDashboardKPIConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("conditionalFormattingOptions", "ConditionalFormattingOptions", properties.ConditionalFormattingOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardKPIConditionalFormattingOptionPropertyFromCloudFormation)(properties.ConditionalFormattingOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_KPIConditionalFormattingOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("primaryValue", CfnDashboard_KPIPrimaryValueConditionalFormattingPropertyValidator)(properties.primaryValue)), errors.collect(cdk.propertyValidator("progressBar", CfnDashboard_KPIProgressBarConditionalFormattingPropertyValidator)(properties.progressBar)), errors.wrap('supplied properties not correct for "KPIConditionalFormattingOptionProperty"');
    }
    function cfnDashboardKPIConditionalFormattingOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_KPIConditionalFormattingOptionPropertyValidator(properties).assertSuccess(), { PrimaryValue: cfnDashboardKPIPrimaryValueConditionalFormattingPropertyToCloudFormation(properties.primaryValue), ProgressBar: cfnDashboardKPIProgressBarConditionalFormattingPropertyToCloudFormation(properties.progressBar) }) : properties;
    }
    function CfnDashboardKPIConditionalFormattingOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("primaryValue", "PrimaryValue", properties.PrimaryValue != null ? CfnDashboardKPIPrimaryValueConditionalFormattingPropertyFromCloudFormation(properties.PrimaryValue) : void 0), ret.addPropertyResult("progressBar", "ProgressBar", properties.ProgressBar != null ? CfnDashboardKPIProgressBarConditionalFormattingPropertyFromCloudFormation(properties.ProgressBar) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_KPIConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldWells", CfnDashboard_KPIFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("kpiOptions", CfnDashboard_KPIOptionsPropertyValidator)(properties.kpiOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnDashboard_KPISortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.wrap('supplied properties not correct for "KPIConfigurationProperty"');
    }
    function cfnDashboardKPIConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_KPIConfigurationPropertyValidator(properties).assertSuccess(), { FieldWells: cfnDashboardKPIFieldWellsPropertyToCloudFormation(properties.fieldWells), KPIOptions: cfnDashboardKPIOptionsPropertyToCloudFormation(properties.kpiOptions), SortConfiguration: cfnDashboardKPISortConfigurationPropertyToCloudFormation(properties.sortConfiguration) }) : properties;
    }
    function CfnDashboardKPIConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnDashboardKPIFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("kpiOptions", "KPIOptions", properties.KPIOptions != null ? CfnDashboardKPIOptionsPropertyFromCloudFormation(properties.KPIOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnDashboardKPISortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_KPIFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("targetValues", cdk.listValidator(CfnDashboard_MeasureFieldPropertyValidator))(properties.targetValues)), errors.collect(cdk.propertyValidator("trendGroups", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.trendGroups)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnDashboard_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "KPIFieldWellsProperty"');
    }
    function cfnDashboardKPIFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_KPIFieldWellsPropertyValidator(properties).assertSuccess(), { TargetValues: cdk.listMapper(cfnDashboardMeasureFieldPropertyToCloudFormation)(properties.targetValues), TrendGroups: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.trendGroups), Values: cdk.listMapper(cfnDashboardMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnDashboardKPIFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("targetValues", "TargetValues", properties.TargetValues != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMeasureFieldPropertyFromCloudFormation)(properties.TargetValues) : void 0), ret.addPropertyResult("trendGroups", "TrendGroups", properties.TrendGroups != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.TrendGroups) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_KPIOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("comparison", CfnDashboard_ComparisonConfigurationPropertyValidator)(properties.comparison)), errors.collect(cdk.propertyValidator("primaryValueDisplayType", cdk.validateString)(properties.primaryValueDisplayType)), errors.collect(cdk.propertyValidator("primaryValueFontConfiguration", CfnDashboard_FontConfigurationPropertyValidator)(properties.primaryValueFontConfiguration)), errors.collect(cdk.propertyValidator("progressBar", CfnDashboard_ProgressBarOptionsPropertyValidator)(properties.progressBar)), errors.collect(cdk.propertyValidator("secondaryValue", CfnDashboard_SecondaryValueOptionsPropertyValidator)(properties.secondaryValue)), errors.collect(cdk.propertyValidator("secondaryValueFontConfiguration", CfnDashboard_FontConfigurationPropertyValidator)(properties.secondaryValueFontConfiguration)), errors.collect(cdk.propertyValidator("trendArrows", CfnDashboard_TrendArrowOptionsPropertyValidator)(properties.trendArrows)), errors.wrap('supplied properties not correct for "KPIOptionsProperty"');
    }
    function cfnDashboardKPIOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_KPIOptionsPropertyValidator(properties).assertSuccess(), { Comparison: cfnDashboardComparisonConfigurationPropertyToCloudFormation(properties.comparison), PrimaryValueDisplayType: cdk.stringToCloudFormation(properties.primaryValueDisplayType), PrimaryValueFontConfiguration: cfnDashboardFontConfigurationPropertyToCloudFormation(properties.primaryValueFontConfiguration), ProgressBar: cfnDashboardProgressBarOptionsPropertyToCloudFormation(properties.progressBar), SecondaryValue: cfnDashboardSecondaryValueOptionsPropertyToCloudFormation(properties.secondaryValue), SecondaryValueFontConfiguration: cfnDashboardFontConfigurationPropertyToCloudFormation(properties.secondaryValueFontConfiguration), TrendArrows: cfnDashboardTrendArrowOptionsPropertyToCloudFormation(properties.trendArrows) }) : properties;
    }
    function CfnDashboardKPIOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("comparison", "Comparison", properties.Comparison != null ? CfnDashboardComparisonConfigurationPropertyFromCloudFormation(properties.Comparison) : void 0), ret.addPropertyResult("primaryValueDisplayType", "PrimaryValueDisplayType", properties.PrimaryValueDisplayType != null ? cfn_parse.FromCloudFormation.getString(properties.PrimaryValueDisplayType) : void 0), ret.addPropertyResult("primaryValueFontConfiguration", "PrimaryValueFontConfiguration", properties.PrimaryValueFontConfiguration != null ? CfnDashboardFontConfigurationPropertyFromCloudFormation(properties.PrimaryValueFontConfiguration) : void 0), ret.addPropertyResult("progressBar", "ProgressBar", properties.ProgressBar != null ? CfnDashboardProgressBarOptionsPropertyFromCloudFormation(properties.ProgressBar) : void 0), ret.addPropertyResult("secondaryValue", "SecondaryValue", properties.SecondaryValue != null ? CfnDashboardSecondaryValueOptionsPropertyFromCloudFormation(properties.SecondaryValue) : void 0), ret.addPropertyResult("secondaryValueFontConfiguration", "SecondaryValueFontConfiguration", properties.SecondaryValueFontConfiguration != null ? CfnDashboardFontConfigurationPropertyFromCloudFormation(properties.SecondaryValueFontConfiguration) : void 0), ret.addPropertyResult("trendArrows", "TrendArrows", properties.TrendArrows != null ? CfnDashboardTrendArrowOptionsPropertyFromCloudFormation(properties.TrendArrows) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_KPIPrimaryValueConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("icon", CfnDashboard_ConditionalFormattingIconPropertyValidator)(properties.icon)), errors.collect(cdk.propertyValidator("textColor", CfnDashboard_ConditionalFormattingColorPropertyValidator)(properties.textColor)), errors.wrap('supplied properties not correct for "KPIPrimaryValueConditionalFormattingProperty"');
    }
    function cfnDashboardKPIPrimaryValueConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_KPIPrimaryValueConditionalFormattingPropertyValidator(properties).assertSuccess(), { Icon: cfnDashboardConditionalFormattingIconPropertyToCloudFormation(properties.icon), TextColor: cfnDashboardConditionalFormattingColorPropertyToCloudFormation(properties.textColor) }) : properties;
    }
    function CfnDashboardKPIPrimaryValueConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("icon", "Icon", properties.Icon != null ? CfnDashboardConditionalFormattingIconPropertyFromCloudFormation(properties.Icon) : void 0), ret.addPropertyResult("textColor", "TextColor", properties.TextColor != null ? CfnDashboardConditionalFormattingColorPropertyFromCloudFormation(properties.TextColor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_KPIProgressBarConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("foregroundColor", CfnDashboard_ConditionalFormattingColorPropertyValidator)(properties.foregroundColor)), errors.wrap('supplied properties not correct for "KPIProgressBarConditionalFormattingProperty"');
    }
    function cfnDashboardKPIProgressBarConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_KPIProgressBarConditionalFormattingPropertyValidator(properties).assertSuccess(), { ForegroundColor: cfnDashboardConditionalFormattingColorPropertyToCloudFormation(properties.foregroundColor) }) : properties;
    }
    function CfnDashboardKPIProgressBarConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("foregroundColor", "ForegroundColor", properties.ForegroundColor != null ? CfnDashboardConditionalFormattingColorPropertyFromCloudFormation(properties.ForegroundColor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_KPISortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("trendGroupSort", cdk.listValidator(CfnDashboard_FieldSortOptionsPropertyValidator))(properties.trendGroupSort)), errors.wrap('supplied properties not correct for "KPISortConfigurationProperty"');
    }
    function cfnDashboardKPISortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_KPISortConfigurationPropertyValidator(properties).assertSuccess(), { TrendGroupSort: cdk.listMapper(cfnDashboardFieldSortOptionsPropertyToCloudFormation)(properties.trendGroupSort) }) : properties;
    }
    function CfnDashboardKPISortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("trendGroupSort", "TrendGroupSort", properties.TrendGroupSort != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardFieldSortOptionsPropertyFromCloudFormation)(properties.TrendGroupSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_KPIVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnDashboard_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnDashboard_KPIConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnDashboard_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("conditionalFormatting", CfnDashboard_KPIConditionalFormattingPropertyValidator)(properties.conditionalFormatting)), errors.collect(cdk.propertyValidator("subtitle", CfnDashboard_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnDashboard_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "KPIVisualProperty"');
    }
    function cfnDashboardKPIVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_KPIVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnDashboardVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnDashboardKPIConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnDashboardColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), ConditionalFormatting: cfnDashboardKPIConditionalFormattingPropertyToCloudFormation(properties.conditionalFormatting), Subtitle: cfnDashboardVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnDashboardVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnDashboardKPIVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnDashboardKPIConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("conditionalFormatting", "ConditionalFormatting", properties.ConditionalFormatting != null ? CfnDashboardKPIConditionalFormattingPropertyFromCloudFormation(properties.ConditionalFormatting) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnDashboardVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnDashboardVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_LabelOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customLabel", cdk.validateString)(properties.customLabel)), errors.collect(cdk.propertyValidator("fontConfiguration", CfnDashboard_FontConfigurationPropertyValidator)(properties.fontConfiguration)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "LabelOptionsProperty"');
    }
    function cfnDashboardLabelOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_LabelOptionsPropertyValidator(properties).assertSuccess(), { CustomLabel: cdk.stringToCloudFormation(properties.customLabel), FontConfiguration: cfnDashboardFontConfigurationPropertyToCloudFormation(properties.fontConfiguration), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnDashboardLabelOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customLabel", "CustomLabel", properties.CustomLabel != null ? cfn_parse.FromCloudFormation.getString(properties.CustomLabel) : void 0), ret.addPropertyResult("fontConfiguration", "FontConfiguration", properties.FontConfiguration != null ? CfnDashboardFontConfigurationPropertyFromCloudFormation(properties.FontConfiguration) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_LayoutPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configuration", cdk.requiredValidator)(properties.configuration)), errors.collect(cdk.propertyValidator("configuration", CfnDashboard_LayoutConfigurationPropertyValidator)(properties.configuration)), errors.wrap('supplied properties not correct for "LayoutProperty"');
    }
    function cfnDashboardLayoutPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_LayoutPropertyValidator(properties).assertSuccess(), { Configuration: cfnDashboardLayoutConfigurationPropertyToCloudFormation(properties.configuration) }) : properties;
    }
    function CfnDashboardLayoutPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configuration", "Configuration", CfnDashboardLayoutConfigurationPropertyFromCloudFormation(properties.Configuration)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_LayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("freeFormLayout", CfnDashboard_FreeFormLayoutConfigurationPropertyValidator)(properties.freeFormLayout)), errors.collect(cdk.propertyValidator("gridLayout", CfnDashboard_GridLayoutConfigurationPropertyValidator)(properties.gridLayout)), errors.collect(cdk.propertyValidator("sectionBasedLayout", CfnDashboard_SectionBasedLayoutConfigurationPropertyValidator)(properties.sectionBasedLayout)), errors.wrap('supplied properties not correct for "LayoutConfigurationProperty"');
    }
    function cfnDashboardLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_LayoutConfigurationPropertyValidator(properties).assertSuccess(), { FreeFormLayout: cfnDashboardFreeFormLayoutConfigurationPropertyToCloudFormation(properties.freeFormLayout), GridLayout: cfnDashboardGridLayoutConfigurationPropertyToCloudFormation(properties.gridLayout), SectionBasedLayout: cfnDashboardSectionBasedLayoutConfigurationPropertyToCloudFormation(properties.sectionBasedLayout) }) : properties;
    }
    function CfnDashboardLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("freeFormLayout", "FreeFormLayout", properties.FreeFormLayout != null ? CfnDashboardFreeFormLayoutConfigurationPropertyFromCloudFormation(properties.FreeFormLayout) : void 0), ret.addPropertyResult("gridLayout", "GridLayout", properties.GridLayout != null ? CfnDashboardGridLayoutConfigurationPropertyFromCloudFormation(properties.GridLayout) : void 0), ret.addPropertyResult("sectionBasedLayout", "SectionBasedLayout", properties.SectionBasedLayout != null ? CfnDashboardSectionBasedLayoutConfigurationPropertyFromCloudFormation(properties.SectionBasedLayout) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_LegendOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("height", cdk.validateString)(properties.height)), errors.collect(cdk.propertyValidator("position", cdk.validateString)(properties.position)), errors.collect(cdk.propertyValidator("title", CfnDashboard_LabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.collect(cdk.propertyValidator("width", cdk.validateString)(properties.width)), errors.wrap('supplied properties not correct for "LegendOptionsProperty"');
    }
    function cfnDashboardLegendOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_LegendOptionsPropertyValidator(properties).assertSuccess(), { Height: cdk.stringToCloudFormation(properties.height), Position: cdk.stringToCloudFormation(properties.position), Title: cfnDashboardLabelOptionsPropertyToCloudFormation(properties.title), Visibility: cdk.stringToCloudFormation(properties.visibility), Width: cdk.stringToCloudFormation(properties.width) }) : properties;
    }
    function CfnDashboardLegendOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("height", "Height", properties.Height != null ? cfn_parse.FromCloudFormation.getString(properties.Height) : void 0), ret.addPropertyResult("position", "Position", properties.Position != null ? cfn_parse.FromCloudFormation.getString(properties.Position) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnDashboardLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addPropertyResult("width", "Width", properties.Width != null ? cfn_parse.FromCloudFormation.getString(properties.Width) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_LineChartAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("category", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.category)), errors.collect(cdk.propertyValidator("colors", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.colors)), errors.collect(cdk.propertyValidator("smallMultiples", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.smallMultiples)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnDashboard_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "LineChartAggregatedFieldWellsProperty"');
    }
    function cfnDashboardLineChartAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_LineChartAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Category: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.category), Colors: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.colors), SmallMultiples: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.smallMultiples), Values: cdk.listMapper(cfnDashboardMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnDashboardLineChartAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("category", "Category", properties.Category != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.Category) : void 0), ret.addPropertyResult("colors", "Colors", properties.Colors != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.Colors) : void 0), ret.addPropertyResult("smallMultiples", "SmallMultiples", properties.SmallMultiples != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.SmallMultiples) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_LineChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contributionAnalysisDefaults", cdk.listValidator(CfnDashboard_ContributionAnalysisDefaultPropertyValidator))(properties.contributionAnalysisDefaults)), errors.collect(cdk.propertyValidator("dataLabels", CfnDashboard_DataLabelOptionsPropertyValidator)(properties.dataLabels)), errors.collect(cdk.propertyValidator("defaultSeriesSettings", CfnDashboard_LineChartDefaultSeriesSettingsPropertyValidator)(properties.defaultSeriesSettings)), errors.collect(cdk.propertyValidator("fieldWells", CfnDashboard_LineChartFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("forecastConfigurations", cdk.listValidator(CfnDashboard_ForecastConfigurationPropertyValidator))(properties.forecastConfigurations)), errors.collect(cdk.propertyValidator("legend", CfnDashboard_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("primaryYAxisDisplayOptions", CfnDashboard_LineSeriesAxisDisplayOptionsPropertyValidator)(properties.primaryYAxisDisplayOptions)), errors.collect(cdk.propertyValidator("primaryYAxisLabelOptions", CfnDashboard_ChartAxisLabelOptionsPropertyValidator)(properties.primaryYAxisLabelOptions)), errors.collect(cdk.propertyValidator("referenceLines", cdk.listValidator(CfnDashboard_ReferenceLinePropertyValidator))(properties.referenceLines)), errors.collect(cdk.propertyValidator("secondaryYAxisDisplayOptions", CfnDashboard_LineSeriesAxisDisplayOptionsPropertyValidator)(properties.secondaryYAxisDisplayOptions)), errors.collect(cdk.propertyValidator("secondaryYAxisLabelOptions", CfnDashboard_ChartAxisLabelOptionsPropertyValidator)(properties.secondaryYAxisLabelOptions)), errors.collect(cdk.propertyValidator("series", cdk.listValidator(CfnDashboard_SeriesItemPropertyValidator))(properties.series)), errors.collect(cdk.propertyValidator("smallMultiplesOptions", CfnDashboard_SmallMultiplesOptionsPropertyValidator)(properties.smallMultiplesOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnDashboard_LineChartSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tooltip", CfnDashboard_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("visualPalette", CfnDashboard_VisualPalettePropertyValidator)(properties.visualPalette)), errors.collect(cdk.propertyValidator("xAxisDisplayOptions", CfnDashboard_AxisDisplayOptionsPropertyValidator)(properties.xAxisDisplayOptions)), errors.collect(cdk.propertyValidator("xAxisLabelOptions", CfnDashboard_ChartAxisLabelOptionsPropertyValidator)(properties.xAxisLabelOptions)), errors.wrap('supplied properties not correct for "LineChartConfigurationProperty"');
    }
    function cfnDashboardLineChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_LineChartConfigurationPropertyValidator(properties).assertSuccess(), { ContributionAnalysisDefaults: cdk.listMapper(cfnDashboardContributionAnalysisDefaultPropertyToCloudFormation)(properties.contributionAnalysisDefaults), DataLabels: cfnDashboardDataLabelOptionsPropertyToCloudFormation(properties.dataLabels), DefaultSeriesSettings: cfnDashboardLineChartDefaultSeriesSettingsPropertyToCloudFormation(properties.defaultSeriesSettings), FieldWells: cfnDashboardLineChartFieldWellsPropertyToCloudFormation(properties.fieldWells), ForecastConfigurations: cdk.listMapper(cfnDashboardForecastConfigurationPropertyToCloudFormation)(properties.forecastConfigurations), Legend: cfnDashboardLegendOptionsPropertyToCloudFormation(properties.legend), PrimaryYAxisDisplayOptions: cfnDashboardLineSeriesAxisDisplayOptionsPropertyToCloudFormation(properties.primaryYAxisDisplayOptions), PrimaryYAxisLabelOptions: cfnDashboardChartAxisLabelOptionsPropertyToCloudFormation(properties.primaryYAxisLabelOptions), ReferenceLines: cdk.listMapper(cfnDashboardReferenceLinePropertyToCloudFormation)(properties.referenceLines), SecondaryYAxisDisplayOptions: cfnDashboardLineSeriesAxisDisplayOptionsPropertyToCloudFormation(properties.secondaryYAxisDisplayOptions), SecondaryYAxisLabelOptions: cfnDashboardChartAxisLabelOptionsPropertyToCloudFormation(properties.secondaryYAxisLabelOptions), Series: cdk.listMapper(cfnDashboardSeriesItemPropertyToCloudFormation)(properties.series), SmallMultiplesOptions: cfnDashboardSmallMultiplesOptionsPropertyToCloudFormation(properties.smallMultiplesOptions), SortConfiguration: cfnDashboardLineChartSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), Tooltip: cfnDashboardTooltipOptionsPropertyToCloudFormation(properties.tooltip), Type: cdk.stringToCloudFormation(properties.type), VisualPalette: cfnDashboardVisualPalettePropertyToCloudFormation(properties.visualPalette), XAxisDisplayOptions: cfnDashboardAxisDisplayOptionsPropertyToCloudFormation(properties.xAxisDisplayOptions), XAxisLabelOptions: cfnDashboardChartAxisLabelOptionsPropertyToCloudFormation(properties.xAxisLabelOptions) }) : properties;
    }
    function CfnDashboardLineChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contributionAnalysisDefaults", "ContributionAnalysisDefaults", properties.ContributionAnalysisDefaults != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardContributionAnalysisDefaultPropertyFromCloudFormation)(properties.ContributionAnalysisDefaults) : void 0), ret.addPropertyResult("dataLabels", "DataLabels", properties.DataLabels != null ? CfnDashboardDataLabelOptionsPropertyFromCloudFormation(properties.DataLabels) : void 0), ret.addPropertyResult("defaultSeriesSettings", "DefaultSeriesSettings", properties.DefaultSeriesSettings != null ? CfnDashboardLineChartDefaultSeriesSettingsPropertyFromCloudFormation(properties.DefaultSeriesSettings) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnDashboardLineChartFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("forecastConfigurations", "ForecastConfigurations", properties.ForecastConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardForecastConfigurationPropertyFromCloudFormation)(properties.ForecastConfigurations) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnDashboardLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("primaryYAxisDisplayOptions", "PrimaryYAxisDisplayOptions", properties.PrimaryYAxisDisplayOptions != null ? CfnDashboardLineSeriesAxisDisplayOptionsPropertyFromCloudFormation(properties.PrimaryYAxisDisplayOptions) : void 0), ret.addPropertyResult("primaryYAxisLabelOptions", "PrimaryYAxisLabelOptions", properties.PrimaryYAxisLabelOptions != null ? CfnDashboardChartAxisLabelOptionsPropertyFromCloudFormation(properties.PrimaryYAxisLabelOptions) : void 0), ret.addPropertyResult("referenceLines", "ReferenceLines", properties.ReferenceLines != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardReferenceLinePropertyFromCloudFormation)(properties.ReferenceLines) : void 0), ret.addPropertyResult("secondaryYAxisDisplayOptions", "SecondaryYAxisDisplayOptions", properties.SecondaryYAxisDisplayOptions != null ? CfnDashboardLineSeriesAxisDisplayOptionsPropertyFromCloudFormation(properties.SecondaryYAxisDisplayOptions) : void 0), ret.addPropertyResult("secondaryYAxisLabelOptions", "SecondaryYAxisLabelOptions", properties.SecondaryYAxisLabelOptions != null ? CfnDashboardChartAxisLabelOptionsPropertyFromCloudFormation(properties.SecondaryYAxisLabelOptions) : void 0), ret.addPropertyResult("series", "Series", properties.Series != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardSeriesItemPropertyFromCloudFormation)(properties.Series) : void 0), ret.addPropertyResult("smallMultiplesOptions", "SmallMultiplesOptions", properties.SmallMultiplesOptions != null ? CfnDashboardSmallMultiplesOptionsPropertyFromCloudFormation(properties.SmallMultiplesOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnDashboardLineChartSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnDashboardTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnDashboardVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addPropertyResult("xAxisDisplayOptions", "XAxisDisplayOptions", properties.XAxisDisplayOptions != null ? CfnDashboardAxisDisplayOptionsPropertyFromCloudFormation(properties.XAxisDisplayOptions) : void 0), ret.addPropertyResult("xAxisLabelOptions", "XAxisLabelOptions", properties.XAxisLabelOptions != null ? CfnDashboardChartAxisLabelOptionsPropertyFromCloudFormation(properties.XAxisLabelOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_LineChartDefaultSeriesSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("axisBinding", cdk.validateString)(properties.axisBinding)), errors.collect(cdk.propertyValidator("lineStyleSettings", CfnDashboard_LineChartLineStyleSettingsPropertyValidator)(properties.lineStyleSettings)), errors.collect(cdk.propertyValidator("markerStyleSettings", CfnDashboard_LineChartMarkerStyleSettingsPropertyValidator)(properties.markerStyleSettings)), errors.wrap('supplied properties not correct for "LineChartDefaultSeriesSettingsProperty"');
    }
    function cfnDashboardLineChartDefaultSeriesSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_LineChartDefaultSeriesSettingsPropertyValidator(properties).assertSuccess(), { AxisBinding: cdk.stringToCloudFormation(properties.axisBinding), LineStyleSettings: cfnDashboardLineChartLineStyleSettingsPropertyToCloudFormation(properties.lineStyleSettings), MarkerStyleSettings: cfnDashboardLineChartMarkerStyleSettingsPropertyToCloudFormation(properties.markerStyleSettings) }) : properties;
    }
    function CfnDashboardLineChartDefaultSeriesSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("axisBinding", "AxisBinding", properties.AxisBinding != null ? cfn_parse.FromCloudFormation.getString(properties.AxisBinding) : void 0), ret.addPropertyResult("lineStyleSettings", "LineStyleSettings", properties.LineStyleSettings != null ? CfnDashboardLineChartLineStyleSettingsPropertyFromCloudFormation(properties.LineStyleSettings) : void 0), ret.addPropertyResult("markerStyleSettings", "MarkerStyleSettings", properties.MarkerStyleSettings != null ? CfnDashboardLineChartMarkerStyleSettingsPropertyFromCloudFormation(properties.MarkerStyleSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_LineChartFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("lineChartAggregatedFieldWells", CfnDashboard_LineChartAggregatedFieldWellsPropertyValidator)(properties.lineChartAggregatedFieldWells)), errors.wrap('supplied properties not correct for "LineChartFieldWellsProperty"');
    }
    function cfnDashboardLineChartFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_LineChartFieldWellsPropertyValidator(properties).assertSuccess(), { LineChartAggregatedFieldWells: cfnDashboardLineChartAggregatedFieldWellsPropertyToCloudFormation(properties.lineChartAggregatedFieldWells) }) : properties;
    }
    function CfnDashboardLineChartFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("lineChartAggregatedFieldWells", "LineChartAggregatedFieldWells", properties.LineChartAggregatedFieldWells != null ? CfnDashboardLineChartAggregatedFieldWellsPropertyFromCloudFormation(properties.LineChartAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_LineChartLineStyleSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("lineInterpolation", cdk.validateString)(properties.lineInterpolation)), errors.collect(cdk.propertyValidator("lineStyle", cdk.validateString)(properties.lineStyle)), errors.collect(cdk.propertyValidator("lineVisibility", cdk.validateString)(properties.lineVisibility)), errors.collect(cdk.propertyValidator("lineWidth", cdk.validateString)(properties.lineWidth)), errors.wrap('supplied properties not correct for "LineChartLineStyleSettingsProperty"');
    }
    function cfnDashboardLineChartLineStyleSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_LineChartLineStyleSettingsPropertyValidator(properties).assertSuccess(), { LineInterpolation: cdk.stringToCloudFormation(properties.lineInterpolation), LineStyle: cdk.stringToCloudFormation(properties.lineStyle), LineVisibility: cdk.stringToCloudFormation(properties.lineVisibility), LineWidth: cdk.stringToCloudFormation(properties.lineWidth) }) : properties;
    }
    function CfnDashboardLineChartLineStyleSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("lineInterpolation", "LineInterpolation", properties.LineInterpolation != null ? cfn_parse.FromCloudFormation.getString(properties.LineInterpolation) : void 0), ret.addPropertyResult("lineStyle", "LineStyle", properties.LineStyle != null ? cfn_parse.FromCloudFormation.getString(properties.LineStyle) : void 0), ret.addPropertyResult("lineVisibility", "LineVisibility", properties.LineVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.LineVisibility) : void 0), ret.addPropertyResult("lineWidth", "LineWidth", properties.LineWidth != null ? cfn_parse.FromCloudFormation.getString(properties.LineWidth) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_LineChartMarkerStyleSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("markerColor", cdk.validateString)(properties.markerColor)), errors.collect(cdk.propertyValidator("markerShape", cdk.validateString)(properties.markerShape)), errors.collect(cdk.propertyValidator("markerSize", cdk.validateString)(properties.markerSize)), errors.collect(cdk.propertyValidator("markerVisibility", cdk.validateString)(properties.markerVisibility)), errors.wrap('supplied properties not correct for "LineChartMarkerStyleSettingsProperty"');
    }
    function cfnDashboardLineChartMarkerStyleSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_LineChartMarkerStyleSettingsPropertyValidator(properties).assertSuccess(), { MarkerColor: cdk.stringToCloudFormation(properties.markerColor), MarkerShape: cdk.stringToCloudFormation(properties.markerShape), MarkerSize: cdk.stringToCloudFormation(properties.markerSize), MarkerVisibility: cdk.stringToCloudFormation(properties.markerVisibility) }) : properties;
    }
    function CfnDashboardLineChartMarkerStyleSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("markerColor", "MarkerColor", properties.MarkerColor != null ? cfn_parse.FromCloudFormation.getString(properties.MarkerColor) : void 0), ret.addPropertyResult("markerShape", "MarkerShape", properties.MarkerShape != null ? cfn_parse.FromCloudFormation.getString(properties.MarkerShape) : void 0), ret.addPropertyResult("markerSize", "MarkerSize", properties.MarkerSize != null ? cfn_parse.FromCloudFormation.getString(properties.MarkerSize) : void 0), ret.addPropertyResult("markerVisibility", "MarkerVisibility", properties.MarkerVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.MarkerVisibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_LineChartSeriesSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("lineStyleSettings", CfnDashboard_LineChartLineStyleSettingsPropertyValidator)(properties.lineStyleSettings)), errors.collect(cdk.propertyValidator("markerStyleSettings", CfnDashboard_LineChartMarkerStyleSettingsPropertyValidator)(properties.markerStyleSettings)), errors.wrap('supplied properties not correct for "LineChartSeriesSettingsProperty"');
    }
    function cfnDashboardLineChartSeriesSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_LineChartSeriesSettingsPropertyValidator(properties).assertSuccess(), { LineStyleSettings: cfnDashboardLineChartLineStyleSettingsPropertyToCloudFormation(properties.lineStyleSettings), MarkerStyleSettings: cfnDashboardLineChartMarkerStyleSettingsPropertyToCloudFormation(properties.markerStyleSettings) }) : properties;
    }
    function CfnDashboardLineChartSeriesSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("lineStyleSettings", "LineStyleSettings", properties.LineStyleSettings != null ? CfnDashboardLineChartLineStyleSettingsPropertyFromCloudFormation(properties.LineStyleSettings) : void 0), ret.addPropertyResult("markerStyleSettings", "MarkerStyleSettings", properties.MarkerStyleSettings != null ? CfnDashboardLineChartMarkerStyleSettingsPropertyFromCloudFormation(properties.MarkerStyleSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_LineChartSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryItemsLimitConfiguration", CfnDashboard_ItemsLimitConfigurationPropertyValidator)(properties.categoryItemsLimitConfiguration)), errors.collect(cdk.propertyValidator("categorySort", cdk.listValidator(CfnDashboard_FieldSortOptionsPropertyValidator))(properties.categorySort)), errors.collect(cdk.propertyValidator("colorItemsLimitConfiguration", CfnDashboard_ItemsLimitConfigurationPropertyValidator)(properties.colorItemsLimitConfiguration)), errors.collect(cdk.propertyValidator("smallMultiplesLimitConfiguration", CfnDashboard_ItemsLimitConfigurationPropertyValidator)(properties.smallMultiplesLimitConfiguration)), errors.collect(cdk.propertyValidator("smallMultiplesSort", cdk.listValidator(CfnDashboard_FieldSortOptionsPropertyValidator))(properties.smallMultiplesSort)), errors.wrap('supplied properties not correct for "LineChartSortConfigurationProperty"');
    }
    function cfnDashboardLineChartSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_LineChartSortConfigurationPropertyValidator(properties).assertSuccess(), { CategoryItemsLimitConfiguration: cfnDashboardItemsLimitConfigurationPropertyToCloudFormation(properties.categoryItemsLimitConfiguration), CategorySort: cdk.listMapper(cfnDashboardFieldSortOptionsPropertyToCloudFormation)(properties.categorySort), ColorItemsLimitConfiguration: cfnDashboardItemsLimitConfigurationPropertyToCloudFormation(properties.colorItemsLimitConfiguration), SmallMultiplesLimitConfiguration: cfnDashboardItemsLimitConfigurationPropertyToCloudFormation(properties.smallMultiplesLimitConfiguration), SmallMultiplesSort: cdk.listMapper(cfnDashboardFieldSortOptionsPropertyToCloudFormation)(properties.smallMultiplesSort) }) : properties;
    }
    function CfnDashboardLineChartSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryItemsLimitConfiguration", "CategoryItemsLimitConfiguration", properties.CategoryItemsLimitConfiguration != null ? CfnDashboardItemsLimitConfigurationPropertyFromCloudFormation(properties.CategoryItemsLimitConfiguration) : void 0), ret.addPropertyResult("categorySort", "CategorySort", properties.CategorySort != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardFieldSortOptionsPropertyFromCloudFormation)(properties.CategorySort) : void 0), ret.addPropertyResult("colorItemsLimitConfiguration", "ColorItemsLimitConfiguration", properties.ColorItemsLimitConfiguration != null ? CfnDashboardItemsLimitConfigurationPropertyFromCloudFormation(properties.ColorItemsLimitConfiguration) : void 0), ret.addPropertyResult("smallMultiplesLimitConfiguration", "SmallMultiplesLimitConfiguration", properties.SmallMultiplesLimitConfiguration != null ? CfnDashboardItemsLimitConfigurationPropertyFromCloudFormation(properties.SmallMultiplesLimitConfiguration) : void 0), ret.addPropertyResult("smallMultiplesSort", "SmallMultiplesSort", properties.SmallMultiplesSort != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardFieldSortOptionsPropertyFromCloudFormation)(properties.SmallMultiplesSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_LineChartVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnDashboard_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnDashboard_LineChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnDashboard_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnDashboard_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnDashboard_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "LineChartVisualProperty"');
    }
    function cfnDashboardLineChartVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_LineChartVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnDashboardVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnDashboardLineChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnDashboardColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnDashboardVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnDashboardVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnDashboardLineChartVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnDashboardLineChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnDashboardVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnDashboardVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_LineSeriesAxisDisplayOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("axisOptions", CfnDashboard_AxisDisplayOptionsPropertyValidator)(properties.axisOptions)), errors.collect(cdk.propertyValidator("missingDataConfigurations", cdk.listValidator(CfnDashboard_MissingDataConfigurationPropertyValidator))(properties.missingDataConfigurations)), errors.wrap('supplied properties not correct for "LineSeriesAxisDisplayOptionsProperty"');
    }
    function cfnDashboardLineSeriesAxisDisplayOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_LineSeriesAxisDisplayOptionsPropertyValidator(properties).assertSuccess(), { AxisOptions: cfnDashboardAxisDisplayOptionsPropertyToCloudFormation(properties.axisOptions), MissingDataConfigurations: cdk.listMapper(cfnDashboardMissingDataConfigurationPropertyToCloudFormation)(properties.missingDataConfigurations) }) : properties;
    }
    function CfnDashboardLineSeriesAxisDisplayOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("axisOptions", "AxisOptions", properties.AxisOptions != null ? CfnDashboardAxisDisplayOptionsPropertyFromCloudFormation(properties.AxisOptions) : void 0), ret.addPropertyResult("missingDataConfigurations", "MissingDataConfigurations", properties.MissingDataConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMissingDataConfigurationPropertyFromCloudFormation)(properties.MissingDataConfigurations) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ListControlDisplayOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("searchOptions", CfnDashboard_ListControlSearchOptionsPropertyValidator)(properties.searchOptions)), errors.collect(cdk.propertyValidator("selectAllOptions", CfnDashboard_ListControlSelectAllOptionsPropertyValidator)(properties.selectAllOptions)), errors.collect(cdk.propertyValidator("titleOptions", CfnDashboard_LabelOptionsPropertyValidator)(properties.titleOptions)), errors.wrap('supplied properties not correct for "ListControlDisplayOptionsProperty"');
    }
    function cfnDashboardListControlDisplayOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ListControlDisplayOptionsPropertyValidator(properties).assertSuccess(), { SearchOptions: cfnDashboardListControlSearchOptionsPropertyToCloudFormation(properties.searchOptions), SelectAllOptions: cfnDashboardListControlSelectAllOptionsPropertyToCloudFormation(properties.selectAllOptions), TitleOptions: cfnDashboardLabelOptionsPropertyToCloudFormation(properties.titleOptions) }) : properties;
    }
    function CfnDashboardListControlDisplayOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("searchOptions", "SearchOptions", properties.SearchOptions != null ? CfnDashboardListControlSearchOptionsPropertyFromCloudFormation(properties.SearchOptions) : void 0), ret.addPropertyResult("selectAllOptions", "SelectAllOptions", properties.SelectAllOptions != null ? CfnDashboardListControlSelectAllOptionsPropertyFromCloudFormation(properties.SelectAllOptions) : void 0), ret.addPropertyResult("titleOptions", "TitleOptions", properties.TitleOptions != null ? CfnDashboardLabelOptionsPropertyFromCloudFormation(properties.TitleOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ListControlSearchOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "ListControlSearchOptionsProperty"');
    }
    function cfnDashboardListControlSearchOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ListControlSearchOptionsPropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnDashboardListControlSearchOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ListControlSelectAllOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "ListControlSelectAllOptionsProperty"');
    }
    function cfnDashboardListControlSelectAllOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ListControlSelectAllOptionsPropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnDashboardListControlSelectAllOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_LoadingAnimationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "LoadingAnimationProperty"');
    }
    function cfnDashboardLoadingAnimationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_LoadingAnimationPropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnDashboardLoadingAnimationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_LocalNavigationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("targetSheetId", cdk.requiredValidator)(properties.targetSheetId)), errors.collect(cdk.propertyValidator("targetSheetId", cdk.validateString)(properties.targetSheetId)), errors.wrap('supplied properties not correct for "LocalNavigationConfigurationProperty"');
    }
    function cfnDashboardLocalNavigationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_LocalNavigationConfigurationPropertyValidator(properties).assertSuccess(), { TargetSheetId: cdk.stringToCloudFormation(properties.targetSheetId) }) : properties;
    }
    function CfnDashboardLocalNavigationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("targetSheetId", "TargetSheetId", cfn_parse.FromCloudFormation.getString(properties.TargetSheetId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_LongFormatTextPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("plainText", cdk.validateString)(properties.plainText)), errors.collect(cdk.propertyValidator("richText", cdk.validateString)(properties.richText)), errors.wrap('supplied properties not correct for "LongFormatTextProperty"');
    }
    function cfnDashboardLongFormatTextPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_LongFormatTextPropertyValidator(properties).assertSuccess(), { PlainText: cdk.stringToCloudFormation(properties.plainText), RichText: cdk.stringToCloudFormation(properties.richText) }) : properties;
    }
    function CfnDashboardLongFormatTextPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("plainText", "PlainText", properties.PlainText != null ? cfn_parse.FromCloudFormation.getString(properties.PlainText) : void 0), ret.addPropertyResult("richText", "RichText", properties.RichText != null ? cfn_parse.FromCloudFormation.getString(properties.RichText) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_MappedDataSetParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.requiredValidator)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.validateString)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("dataSetParameterName", cdk.requiredValidator)(properties.dataSetParameterName)), errors.collect(cdk.propertyValidator("dataSetParameterName", cdk.validateString)(properties.dataSetParameterName)), errors.wrap('supplied properties not correct for "MappedDataSetParameterProperty"');
    }
    function cfnDashboardMappedDataSetParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_MappedDataSetParameterPropertyValidator(properties).assertSuccess(), { DataSetIdentifier: cdk.stringToCloudFormation(properties.dataSetIdentifier), DataSetParameterName: cdk.stringToCloudFormation(properties.dataSetParameterName) }) : properties;
    }
    function CfnDashboardMappedDataSetParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataSetIdentifier", "DataSetIdentifier", cfn_parse.FromCloudFormation.getString(properties.DataSetIdentifier)), ret.addPropertyResult("dataSetParameterName", "DataSetParameterName", cfn_parse.FromCloudFormation.getString(properties.DataSetParameterName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_MaximumLabelTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "MaximumLabelTypeProperty"');
    }
    function cfnDashboardMaximumLabelTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_MaximumLabelTypePropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnDashboardMaximumLabelTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_MaximumMinimumComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computationId", cdk.requiredValidator)(properties.computationId)), errors.collect(cdk.propertyValidator("computationId", cdk.validateString)(properties.computationId)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("time", cdk.requiredValidator)(properties.time)), errors.collect(cdk.propertyValidator("time", CfnDashboard_DimensionFieldPropertyValidator)(properties.time)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", CfnDashboard_MeasureFieldPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "MaximumMinimumComputationProperty"');
    }
    function cfnDashboardMaximumMinimumComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_MaximumMinimumComputationPropertyValidator(properties).assertSuccess(), { ComputationId: cdk.stringToCloudFormation(properties.computationId), Name: cdk.stringToCloudFormation(properties.name), Time: cfnDashboardDimensionFieldPropertyToCloudFormation(properties.time), Type: cdk.stringToCloudFormation(properties.type), Value: cfnDashboardMeasureFieldPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnDashboardMaximumMinimumComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computationId", "ComputationId", cfn_parse.FromCloudFormation.getString(properties.ComputationId)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("time", "Time", CfnDashboardDimensionFieldPropertyFromCloudFormation(properties.Time)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("value", "Value", properties.Value != null ? CfnDashboardMeasureFieldPropertyFromCloudFormation(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_MeasureFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("calculatedMeasureField", CfnDashboard_CalculatedMeasureFieldPropertyValidator)(properties.calculatedMeasureField)), errors.collect(cdk.propertyValidator("categoricalMeasureField", CfnDashboard_CategoricalMeasureFieldPropertyValidator)(properties.categoricalMeasureField)), errors.collect(cdk.propertyValidator("dateMeasureField", CfnDashboard_DateMeasureFieldPropertyValidator)(properties.dateMeasureField)), errors.collect(cdk.propertyValidator("numericalMeasureField", CfnDashboard_NumericalMeasureFieldPropertyValidator)(properties.numericalMeasureField)), errors.wrap('supplied properties not correct for "MeasureFieldProperty"');
    }
    function cfnDashboardMeasureFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_MeasureFieldPropertyValidator(properties).assertSuccess(), { CalculatedMeasureField: cfnDashboardCalculatedMeasureFieldPropertyToCloudFormation(properties.calculatedMeasureField), CategoricalMeasureField: cfnDashboardCategoricalMeasureFieldPropertyToCloudFormation(properties.categoricalMeasureField), DateMeasureField: cfnDashboardDateMeasureFieldPropertyToCloudFormation(properties.dateMeasureField), NumericalMeasureField: cfnDashboardNumericalMeasureFieldPropertyToCloudFormation(properties.numericalMeasureField) }) : properties;
    }
    function CfnDashboardMeasureFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("calculatedMeasureField", "CalculatedMeasureField", properties.CalculatedMeasureField != null ? CfnDashboardCalculatedMeasureFieldPropertyFromCloudFormation(properties.CalculatedMeasureField) : void 0), ret.addPropertyResult("categoricalMeasureField", "CategoricalMeasureField", properties.CategoricalMeasureField != null ? CfnDashboardCategoricalMeasureFieldPropertyFromCloudFormation(properties.CategoricalMeasureField) : void 0), ret.addPropertyResult("dateMeasureField", "DateMeasureField", properties.DateMeasureField != null ? CfnDashboardDateMeasureFieldPropertyFromCloudFormation(properties.DateMeasureField) : void 0), ret.addPropertyResult("numericalMeasureField", "NumericalMeasureField", properties.NumericalMeasureField != null ? CfnDashboardNumericalMeasureFieldPropertyFromCloudFormation(properties.NumericalMeasureField) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_MetricComparisonComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computationId", cdk.requiredValidator)(properties.computationId)), errors.collect(cdk.propertyValidator("computationId", cdk.validateString)(properties.computationId)), errors.collect(cdk.propertyValidator("fromValue", cdk.requiredValidator)(properties.fromValue)), errors.collect(cdk.propertyValidator("fromValue", CfnDashboard_MeasureFieldPropertyValidator)(properties.fromValue)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("targetValue", cdk.requiredValidator)(properties.targetValue)), errors.collect(cdk.propertyValidator("targetValue", CfnDashboard_MeasureFieldPropertyValidator)(properties.targetValue)), errors.collect(cdk.propertyValidator("time", cdk.requiredValidator)(properties.time)), errors.collect(cdk.propertyValidator("time", CfnDashboard_DimensionFieldPropertyValidator)(properties.time)), errors.wrap('supplied properties not correct for "MetricComparisonComputationProperty"');
    }
    function cfnDashboardMetricComparisonComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_MetricComparisonComputationPropertyValidator(properties).assertSuccess(), { ComputationId: cdk.stringToCloudFormation(properties.computationId), FromValue: cfnDashboardMeasureFieldPropertyToCloudFormation(properties.fromValue), Name: cdk.stringToCloudFormation(properties.name), TargetValue: cfnDashboardMeasureFieldPropertyToCloudFormation(properties.targetValue), Time: cfnDashboardDimensionFieldPropertyToCloudFormation(properties.time) }) : properties;
    }
    function CfnDashboardMetricComparisonComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computationId", "ComputationId", cfn_parse.FromCloudFormation.getString(properties.ComputationId)), ret.addPropertyResult("fromValue", "FromValue", CfnDashboardMeasureFieldPropertyFromCloudFormation(properties.FromValue)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("targetValue", "TargetValue", CfnDashboardMeasureFieldPropertyFromCloudFormation(properties.TargetValue)), ret.addPropertyResult("time", "Time", CfnDashboardDimensionFieldPropertyFromCloudFormation(properties.Time)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_MinimumLabelTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "MinimumLabelTypeProperty"');
    }
    function cfnDashboardMinimumLabelTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_MinimumLabelTypePropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnDashboardMinimumLabelTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_MissingDataConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("treatmentOption", cdk.validateString)(properties.treatmentOption)), errors.wrap('supplied properties not correct for "MissingDataConfigurationProperty"');
    }
    function cfnDashboardMissingDataConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_MissingDataConfigurationPropertyValidator(properties).assertSuccess(), { TreatmentOption: cdk.stringToCloudFormation(properties.treatmentOption) }) : properties;
    }
    function CfnDashboardMissingDataConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("treatmentOption", "TreatmentOption", properties.TreatmentOption != null ? cfn_parse.FromCloudFormation.getString(properties.TreatmentOption) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_NegativeValueConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("displayMode", cdk.requiredValidator)(properties.displayMode)), errors.collect(cdk.propertyValidator("displayMode", cdk.validateString)(properties.displayMode)), errors.wrap('supplied properties not correct for "NegativeValueConfigurationProperty"');
    }
    function cfnDashboardNegativeValueConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_NegativeValueConfigurationPropertyValidator(properties).assertSuccess(), { DisplayMode: cdk.stringToCloudFormation(properties.displayMode) }) : properties;
    }
    function CfnDashboardNegativeValueConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("displayMode", "DisplayMode", cfn_parse.FromCloudFormation.getString(properties.DisplayMode)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_NullValueFormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("nullString", cdk.requiredValidator)(properties.nullString)), errors.collect(cdk.propertyValidator("nullString", cdk.validateString)(properties.nullString)), errors.wrap('supplied properties not correct for "NullValueFormatConfigurationProperty"');
    }
    function cfnDashboardNullValueFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_NullValueFormatConfigurationPropertyValidator(properties).assertSuccess(), { NullString: cdk.stringToCloudFormation(properties.nullString) }) : properties;
    }
    function CfnDashboardNullValueFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("nullString", "NullString", cfn_parse.FromCloudFormation.getString(properties.NullString)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_NumberDisplayFormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("decimalPlacesConfiguration", CfnDashboard_DecimalPlacesConfigurationPropertyValidator)(properties.decimalPlacesConfiguration)), errors.collect(cdk.propertyValidator("negativeValueConfiguration", CfnDashboard_NegativeValueConfigurationPropertyValidator)(properties.negativeValueConfiguration)), errors.collect(cdk.propertyValidator("nullValueFormatConfiguration", CfnDashboard_NullValueFormatConfigurationPropertyValidator)(properties.nullValueFormatConfiguration)), errors.collect(cdk.propertyValidator("numberScale", cdk.validateString)(properties.numberScale)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.collect(cdk.propertyValidator("separatorConfiguration", CfnDashboard_NumericSeparatorConfigurationPropertyValidator)(properties.separatorConfiguration)), errors.collect(cdk.propertyValidator("suffix", cdk.validateString)(properties.suffix)), errors.wrap('supplied properties not correct for "NumberDisplayFormatConfigurationProperty"');
    }
    function cfnDashboardNumberDisplayFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_NumberDisplayFormatConfigurationPropertyValidator(properties).assertSuccess(), { DecimalPlacesConfiguration: cfnDashboardDecimalPlacesConfigurationPropertyToCloudFormation(properties.decimalPlacesConfiguration), NegativeValueConfiguration: cfnDashboardNegativeValueConfigurationPropertyToCloudFormation(properties.negativeValueConfiguration), NullValueFormatConfiguration: cfnDashboardNullValueFormatConfigurationPropertyToCloudFormation(properties.nullValueFormatConfiguration), NumberScale: cdk.stringToCloudFormation(properties.numberScale), Prefix: cdk.stringToCloudFormation(properties.prefix), SeparatorConfiguration: cfnDashboardNumericSeparatorConfigurationPropertyToCloudFormation(properties.separatorConfiguration), Suffix: cdk.stringToCloudFormation(properties.suffix) }) : properties;
    }
    function CfnDashboardNumberDisplayFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("decimalPlacesConfiguration", "DecimalPlacesConfiguration", properties.DecimalPlacesConfiguration != null ? CfnDashboardDecimalPlacesConfigurationPropertyFromCloudFormation(properties.DecimalPlacesConfiguration) : void 0), ret.addPropertyResult("negativeValueConfiguration", "NegativeValueConfiguration", properties.NegativeValueConfiguration != null ? CfnDashboardNegativeValueConfigurationPropertyFromCloudFormation(properties.NegativeValueConfiguration) : void 0), ret.addPropertyResult("nullValueFormatConfiguration", "NullValueFormatConfiguration", properties.NullValueFormatConfiguration != null ? CfnDashboardNullValueFormatConfigurationPropertyFromCloudFormation(properties.NullValueFormatConfiguration) : void 0), ret.addPropertyResult("numberScale", "NumberScale", properties.NumberScale != null ? cfn_parse.FromCloudFormation.getString(properties.NumberScale) : void 0), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addPropertyResult("separatorConfiguration", "SeparatorConfiguration", properties.SeparatorConfiguration != null ? CfnDashboardNumericSeparatorConfigurationPropertyFromCloudFormation(properties.SeparatorConfiguration) : void 0), ret.addPropertyResult("suffix", "Suffix", properties.Suffix != null ? cfn_parse.FromCloudFormation.getString(properties.Suffix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_NumberFormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("formatConfiguration", CfnDashboard_NumericFormatConfigurationPropertyValidator)(properties.formatConfiguration)), errors.wrap('supplied properties not correct for "NumberFormatConfigurationProperty"');
    }
    function cfnDashboardNumberFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_NumberFormatConfigurationPropertyValidator(properties).assertSuccess(), { FormatConfiguration: cfnDashboardNumericFormatConfigurationPropertyToCloudFormation(properties.formatConfiguration) }) : properties;
    }
    function CfnDashboardNumberFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("formatConfiguration", "FormatConfiguration", properties.FormatConfiguration != null ? CfnDashboardNumericFormatConfigurationPropertyFromCloudFormation(properties.FormatConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_NumericAxisOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("range", CfnDashboard_AxisDisplayRangePropertyValidator)(properties.range)), errors.collect(cdk.propertyValidator("scale", CfnDashboard_AxisScalePropertyValidator)(properties.scale)), errors.wrap('supplied properties not correct for "NumericAxisOptionsProperty"');
    }
    function cfnDashboardNumericAxisOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_NumericAxisOptionsPropertyValidator(properties).assertSuccess(), { Range: cfnDashboardAxisDisplayRangePropertyToCloudFormation(properties.range), Scale: cfnDashboardAxisScalePropertyToCloudFormation(properties.scale) }) : properties;
    }
    function CfnDashboardNumericAxisOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("range", "Range", properties.Range != null ? CfnDashboardAxisDisplayRangePropertyFromCloudFormation(properties.Range) : void 0), ret.addPropertyResult("scale", "Scale", properties.Scale != null ? CfnDashboardAxisScalePropertyFromCloudFormation(properties.Scale) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_NumericEqualityDrillDownFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnDashboard_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "NumericEqualityDrillDownFilterProperty"');
    }
    function cfnDashboardNumericEqualityDrillDownFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_NumericEqualityDrillDownFilterPropertyValidator(properties).assertSuccess(), { Column: cfnDashboardColumnIdentifierPropertyToCloudFormation(properties.column), Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnDashboardNumericEqualityDrillDownFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", CfnDashboardColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getNumber(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_NumericEqualityFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationFunction", CfnDashboard_AggregationFunctionPropertyValidator)(properties.aggregationFunction)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnDashboard_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("filterId", cdk.requiredValidator)(properties.filterId)), errors.collect(cdk.propertyValidator("filterId", cdk.validateString)(properties.filterId)), errors.collect(cdk.propertyValidator("matchOperator", cdk.requiredValidator)(properties.matchOperator)), errors.collect(cdk.propertyValidator("matchOperator", cdk.validateString)(properties.matchOperator)), errors.collect(cdk.propertyValidator("nullOption", cdk.requiredValidator)(properties.nullOption)), errors.collect(cdk.propertyValidator("nullOption", cdk.validateString)(properties.nullOption)), errors.collect(cdk.propertyValidator("parameterName", cdk.validateString)(properties.parameterName)), errors.collect(cdk.propertyValidator("selectAllOptions", cdk.validateString)(properties.selectAllOptions)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "NumericEqualityFilterProperty"');
    }
    function cfnDashboardNumericEqualityFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_NumericEqualityFilterPropertyValidator(properties).assertSuccess(), { AggregationFunction: cfnDashboardAggregationFunctionPropertyToCloudFormation(properties.aggregationFunction), Column: cfnDashboardColumnIdentifierPropertyToCloudFormation(properties.column), FilterId: cdk.stringToCloudFormation(properties.filterId), MatchOperator: cdk.stringToCloudFormation(properties.matchOperator), NullOption: cdk.stringToCloudFormation(properties.nullOption), ParameterName: cdk.stringToCloudFormation(properties.parameterName), SelectAllOptions: cdk.stringToCloudFormation(properties.selectAllOptions), Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnDashboardNumericEqualityFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationFunction", "AggregationFunction", properties.AggregationFunction != null ? CfnDashboardAggregationFunctionPropertyFromCloudFormation(properties.AggregationFunction) : void 0), ret.addPropertyResult("column", "Column", CfnDashboardColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("filterId", "FilterId", cfn_parse.FromCloudFormation.getString(properties.FilterId)), ret.addPropertyResult("matchOperator", "MatchOperator", cfn_parse.FromCloudFormation.getString(properties.MatchOperator)), ret.addPropertyResult("nullOption", "NullOption", cfn_parse.FromCloudFormation.getString(properties.NullOption)), ret.addPropertyResult("parameterName", "ParameterName", properties.ParameterName != null ? cfn_parse.FromCloudFormation.getString(properties.ParameterName) : void 0), ret.addPropertyResult("selectAllOptions", "SelectAllOptions", properties.SelectAllOptions != null ? cfn_parse.FromCloudFormation.getString(properties.SelectAllOptions) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getNumber(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_NumericFormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("currencyDisplayFormatConfiguration", CfnDashboard_CurrencyDisplayFormatConfigurationPropertyValidator)(properties.currencyDisplayFormatConfiguration)), errors.collect(cdk.propertyValidator("numberDisplayFormatConfiguration", CfnDashboard_NumberDisplayFormatConfigurationPropertyValidator)(properties.numberDisplayFormatConfiguration)), errors.collect(cdk.propertyValidator("percentageDisplayFormatConfiguration", CfnDashboard_PercentageDisplayFormatConfigurationPropertyValidator)(properties.percentageDisplayFormatConfiguration)), errors.wrap('supplied properties not correct for "NumericFormatConfigurationProperty"');
    }
    function cfnDashboardNumericFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_NumericFormatConfigurationPropertyValidator(properties).assertSuccess(), { CurrencyDisplayFormatConfiguration: cfnDashboardCurrencyDisplayFormatConfigurationPropertyToCloudFormation(properties.currencyDisplayFormatConfiguration), NumberDisplayFormatConfiguration: cfnDashboardNumberDisplayFormatConfigurationPropertyToCloudFormation(properties.numberDisplayFormatConfiguration), PercentageDisplayFormatConfiguration: cfnDashboardPercentageDisplayFormatConfigurationPropertyToCloudFormation(properties.percentageDisplayFormatConfiguration) }) : properties;
    }
    function CfnDashboardNumericFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("currencyDisplayFormatConfiguration", "CurrencyDisplayFormatConfiguration", properties.CurrencyDisplayFormatConfiguration != null ? CfnDashboardCurrencyDisplayFormatConfigurationPropertyFromCloudFormation(properties.CurrencyDisplayFormatConfiguration) : void 0), ret.addPropertyResult("numberDisplayFormatConfiguration", "NumberDisplayFormatConfiguration", properties.NumberDisplayFormatConfiguration != null ? CfnDashboardNumberDisplayFormatConfigurationPropertyFromCloudFormation(properties.NumberDisplayFormatConfiguration) : void 0), ret.addPropertyResult("percentageDisplayFormatConfiguration", "PercentageDisplayFormatConfiguration", properties.PercentageDisplayFormatConfiguration != null ? CfnDashboardPercentageDisplayFormatConfigurationPropertyFromCloudFormation(properties.PercentageDisplayFormatConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_NumericRangeFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationFunction", CfnDashboard_AggregationFunctionPropertyValidator)(properties.aggregationFunction)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnDashboard_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("filterId", cdk.requiredValidator)(properties.filterId)), errors.collect(cdk.propertyValidator("filterId", cdk.validateString)(properties.filterId)), errors.collect(cdk.propertyValidator("includeMaximum", cdk.validateBoolean)(properties.includeMaximum)), errors.collect(cdk.propertyValidator("includeMinimum", cdk.validateBoolean)(properties.includeMinimum)), errors.collect(cdk.propertyValidator("nullOption", cdk.requiredValidator)(properties.nullOption)), errors.collect(cdk.propertyValidator("nullOption", cdk.validateString)(properties.nullOption)), errors.collect(cdk.propertyValidator("rangeMaximum", CfnDashboard_NumericRangeFilterValuePropertyValidator)(properties.rangeMaximum)), errors.collect(cdk.propertyValidator("rangeMinimum", CfnDashboard_NumericRangeFilterValuePropertyValidator)(properties.rangeMinimum)), errors.collect(cdk.propertyValidator("selectAllOptions", cdk.validateString)(properties.selectAllOptions)), errors.wrap('supplied properties not correct for "NumericRangeFilterProperty"');
    }
    function cfnDashboardNumericRangeFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_NumericRangeFilterPropertyValidator(properties).assertSuccess(), { AggregationFunction: cfnDashboardAggregationFunctionPropertyToCloudFormation(properties.aggregationFunction), Column: cfnDashboardColumnIdentifierPropertyToCloudFormation(properties.column), FilterId: cdk.stringToCloudFormation(properties.filterId), IncludeMaximum: cdk.booleanToCloudFormation(properties.includeMaximum), IncludeMinimum: cdk.booleanToCloudFormation(properties.includeMinimum), NullOption: cdk.stringToCloudFormation(properties.nullOption), RangeMaximum: cfnDashboardNumericRangeFilterValuePropertyToCloudFormation(properties.rangeMaximum), RangeMinimum: cfnDashboardNumericRangeFilterValuePropertyToCloudFormation(properties.rangeMinimum), SelectAllOptions: cdk.stringToCloudFormation(properties.selectAllOptions) }) : properties;
    }
    function CfnDashboardNumericRangeFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationFunction", "AggregationFunction", properties.AggregationFunction != null ? CfnDashboardAggregationFunctionPropertyFromCloudFormation(properties.AggregationFunction) : void 0), ret.addPropertyResult("column", "Column", CfnDashboardColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("filterId", "FilterId", cfn_parse.FromCloudFormation.getString(properties.FilterId)), ret.addPropertyResult("includeMaximum", "IncludeMaximum", properties.IncludeMaximum != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeMaximum) : void 0), ret.addPropertyResult("includeMinimum", "IncludeMinimum", properties.IncludeMinimum != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeMinimum) : void 0), ret.addPropertyResult("nullOption", "NullOption", cfn_parse.FromCloudFormation.getString(properties.NullOption)), ret.addPropertyResult("rangeMaximum", "RangeMaximum", properties.RangeMaximum != null ? CfnDashboardNumericRangeFilterValuePropertyFromCloudFormation(properties.RangeMaximum) : void 0), ret.addPropertyResult("rangeMinimum", "RangeMinimum", properties.RangeMinimum != null ? CfnDashboardNumericRangeFilterValuePropertyFromCloudFormation(properties.RangeMinimum) : void 0), ret.addPropertyResult("selectAllOptions", "SelectAllOptions", properties.SelectAllOptions != null ? cfn_parse.FromCloudFormation.getString(properties.SelectAllOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_NumericRangeFilterValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("parameter", cdk.validateString)(properties.parameter)), errors.collect(cdk.propertyValidator("staticValue", cdk.validateNumber)(properties.staticValue)), errors.wrap('supplied properties not correct for "NumericRangeFilterValueProperty"');
    }
    function cfnDashboardNumericRangeFilterValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_NumericRangeFilterValuePropertyValidator(properties).assertSuccess(), { Parameter: cdk.stringToCloudFormation(properties.parameter), StaticValue: cdk.numberToCloudFormation(properties.staticValue) }) : properties;
    }
    function CfnDashboardNumericRangeFilterValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("parameter", "Parameter", properties.Parameter != null ? cfn_parse.FromCloudFormation.getString(properties.Parameter) : void 0), ret.addPropertyResult("staticValue", "StaticValue", properties.StaticValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.StaticValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_NumericSeparatorConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("decimalSeparator", cdk.validateString)(properties.decimalSeparator)), errors.collect(cdk.propertyValidator("thousandsSeparator", CfnDashboard_ThousandSeparatorOptionsPropertyValidator)(properties.thousandsSeparator)), errors.wrap('supplied properties not correct for "NumericSeparatorConfigurationProperty"');
    }
    function cfnDashboardNumericSeparatorConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_NumericSeparatorConfigurationPropertyValidator(properties).assertSuccess(), { DecimalSeparator: cdk.stringToCloudFormation(properties.decimalSeparator), ThousandsSeparator: cfnDashboardThousandSeparatorOptionsPropertyToCloudFormation(properties.thousandsSeparator) }) : properties;
    }
    function CfnDashboardNumericSeparatorConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("decimalSeparator", "DecimalSeparator", properties.DecimalSeparator != null ? cfn_parse.FromCloudFormation.getString(properties.DecimalSeparator) : void 0), ret.addPropertyResult("thousandsSeparator", "ThousandsSeparator", properties.ThousandsSeparator != null ? CfnDashboardThousandSeparatorOptionsPropertyFromCloudFormation(properties.ThousandsSeparator) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_NumericalAggregationFunctionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("percentileAggregation", CfnDashboard_PercentileAggregationPropertyValidator)(properties.percentileAggregation)), errors.collect(cdk.propertyValidator("simpleNumericalAggregation", cdk.validateString)(properties.simpleNumericalAggregation)), errors.wrap('supplied properties not correct for "NumericalAggregationFunctionProperty"');
    }
    function cfnDashboardNumericalAggregationFunctionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_NumericalAggregationFunctionPropertyValidator(properties).assertSuccess(), { PercentileAggregation: cfnDashboardPercentileAggregationPropertyToCloudFormation(properties.percentileAggregation), SimpleNumericalAggregation: cdk.stringToCloudFormation(properties.simpleNumericalAggregation) }) : properties;
    }
    function CfnDashboardNumericalAggregationFunctionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("percentileAggregation", "PercentileAggregation", properties.PercentileAggregation != null ? CfnDashboardPercentileAggregationPropertyFromCloudFormation(properties.PercentileAggregation) : void 0), ret.addPropertyResult("simpleNumericalAggregation", "SimpleNumericalAggregation", properties.SimpleNumericalAggregation != null ? cfn_parse.FromCloudFormation.getString(properties.SimpleNumericalAggregation) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_NumericalDimensionFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnDashboard_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("formatConfiguration", CfnDashboard_NumberFormatConfigurationPropertyValidator)(properties.formatConfiguration)), errors.collect(cdk.propertyValidator("hierarchyId", cdk.validateString)(properties.hierarchyId)), errors.wrap('supplied properties not correct for "NumericalDimensionFieldProperty"');
    }
    function cfnDashboardNumericalDimensionFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_NumericalDimensionFieldPropertyValidator(properties).assertSuccess(), { Column: cfnDashboardColumnIdentifierPropertyToCloudFormation(properties.column), FieldId: cdk.stringToCloudFormation(properties.fieldId), FormatConfiguration: cfnDashboardNumberFormatConfigurationPropertyToCloudFormation(properties.formatConfiguration), HierarchyId: cdk.stringToCloudFormation(properties.hierarchyId) }) : properties;
    }
    function CfnDashboardNumericalDimensionFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", CfnDashboardColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("formatConfiguration", "FormatConfiguration", properties.FormatConfiguration != null ? CfnDashboardNumberFormatConfigurationPropertyFromCloudFormation(properties.FormatConfiguration) : void 0), ret.addPropertyResult("hierarchyId", "HierarchyId", properties.HierarchyId != null ? cfn_parse.FromCloudFormation.getString(properties.HierarchyId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_NumericalMeasureFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationFunction", CfnDashboard_NumericalAggregationFunctionPropertyValidator)(properties.aggregationFunction)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnDashboard_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("formatConfiguration", CfnDashboard_NumberFormatConfigurationPropertyValidator)(properties.formatConfiguration)), errors.wrap('supplied properties not correct for "NumericalMeasureFieldProperty"');
    }
    function cfnDashboardNumericalMeasureFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_NumericalMeasureFieldPropertyValidator(properties).assertSuccess(), { AggregationFunction: cfnDashboardNumericalAggregationFunctionPropertyToCloudFormation(properties.aggregationFunction), Column: cfnDashboardColumnIdentifierPropertyToCloudFormation(properties.column), FieldId: cdk.stringToCloudFormation(properties.fieldId), FormatConfiguration: cfnDashboardNumberFormatConfigurationPropertyToCloudFormation(properties.formatConfiguration) }) : properties;
    }
    function CfnDashboardNumericalMeasureFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationFunction", "AggregationFunction", properties.AggregationFunction != null ? CfnDashboardNumericalAggregationFunctionPropertyFromCloudFormation(properties.AggregationFunction) : void 0), ret.addPropertyResult("column", "Column", CfnDashboardColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("formatConfiguration", "FormatConfiguration", properties.FormatConfiguration != null ? CfnDashboardNumberFormatConfigurationPropertyFromCloudFormation(properties.FormatConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PaginationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("pageNumber", cdk.requiredValidator)(properties.pageNumber)), errors.collect(cdk.propertyValidator("pageNumber", cdk.validateNumber)(properties.pageNumber)), errors.collect(cdk.propertyValidator("pageSize", cdk.requiredValidator)(properties.pageSize)), errors.collect(cdk.propertyValidator("pageSize", cdk.validateNumber)(properties.pageSize)), errors.wrap('supplied properties not correct for "PaginationConfigurationProperty"');
    }
    function cfnDashboardPaginationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PaginationConfigurationPropertyValidator(properties).assertSuccess(), { PageNumber: cdk.numberToCloudFormation(properties.pageNumber), PageSize: cdk.numberToCloudFormation(properties.pageSize) }) : properties;
    }
    function CfnDashboardPaginationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("pageNumber", "PageNumber", cfn_parse.FromCloudFormation.getNumber(properties.PageNumber)), ret.addPropertyResult("pageSize", "PageSize", cfn_parse.FromCloudFormation.getNumber(properties.PageSize)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PanelConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("backgroundColor", cdk.validateString)(properties.backgroundColor)), errors.collect(cdk.propertyValidator("backgroundVisibility", cdk.validateString)(properties.backgroundVisibility)), errors.collect(cdk.propertyValidator("borderColor", cdk.validateString)(properties.borderColor)), errors.collect(cdk.propertyValidator("borderStyle", cdk.validateString)(properties.borderStyle)), errors.collect(cdk.propertyValidator("borderThickness", cdk.validateString)(properties.borderThickness)), errors.collect(cdk.propertyValidator("borderVisibility", cdk.validateString)(properties.borderVisibility)), errors.collect(cdk.propertyValidator("gutterSpacing", cdk.validateString)(properties.gutterSpacing)), errors.collect(cdk.propertyValidator("gutterVisibility", cdk.validateString)(properties.gutterVisibility)), errors.collect(cdk.propertyValidator("title", CfnDashboard_PanelTitleOptionsPropertyValidator)(properties.title)), errors.wrap('supplied properties not correct for "PanelConfigurationProperty"');
    }
    function cfnDashboardPanelConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PanelConfigurationPropertyValidator(properties).assertSuccess(), { BackgroundColor: cdk.stringToCloudFormation(properties.backgroundColor), BackgroundVisibility: cdk.stringToCloudFormation(properties.backgroundVisibility), BorderColor: cdk.stringToCloudFormation(properties.borderColor), BorderStyle: cdk.stringToCloudFormation(properties.borderStyle), BorderThickness: cdk.stringToCloudFormation(properties.borderThickness), BorderVisibility: cdk.stringToCloudFormation(properties.borderVisibility), GutterSpacing: cdk.stringToCloudFormation(properties.gutterSpacing), GutterVisibility: cdk.stringToCloudFormation(properties.gutterVisibility), Title: cfnDashboardPanelTitleOptionsPropertyToCloudFormation(properties.title) }) : properties;
    }
    function CfnDashboardPanelConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("backgroundColor", "BackgroundColor", properties.BackgroundColor != null ? cfn_parse.FromCloudFormation.getString(properties.BackgroundColor) : void 0), ret.addPropertyResult("backgroundVisibility", "BackgroundVisibility", properties.BackgroundVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.BackgroundVisibility) : void 0), ret.addPropertyResult("borderColor", "BorderColor", properties.BorderColor != null ? cfn_parse.FromCloudFormation.getString(properties.BorderColor) : void 0), ret.addPropertyResult("borderStyle", "BorderStyle", properties.BorderStyle != null ? cfn_parse.FromCloudFormation.getString(properties.BorderStyle) : void 0), ret.addPropertyResult("borderThickness", "BorderThickness", properties.BorderThickness != null ? cfn_parse.FromCloudFormation.getString(properties.BorderThickness) : void 0), ret.addPropertyResult("borderVisibility", "BorderVisibility", properties.BorderVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.BorderVisibility) : void 0), ret.addPropertyResult("gutterSpacing", "GutterSpacing", properties.GutterSpacing != null ? cfn_parse.FromCloudFormation.getString(properties.GutterSpacing) : void 0), ret.addPropertyResult("gutterVisibility", "GutterVisibility", properties.GutterVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.GutterVisibility) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnDashboardPanelTitleOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PanelTitleOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fontConfiguration", CfnDashboard_FontConfigurationPropertyValidator)(properties.fontConfiguration)), errors.collect(cdk.propertyValidator("horizontalTextAlignment", cdk.validateString)(properties.horizontalTextAlignment)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "PanelTitleOptionsProperty"');
    }
    function cfnDashboardPanelTitleOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PanelTitleOptionsPropertyValidator(properties).assertSuccess(), { FontConfiguration: cfnDashboardFontConfigurationPropertyToCloudFormation(properties.fontConfiguration), HorizontalTextAlignment: cdk.stringToCloudFormation(properties.horizontalTextAlignment), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnDashboardPanelTitleOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fontConfiguration", "FontConfiguration", properties.FontConfiguration != null ? CfnDashboardFontConfigurationPropertyFromCloudFormation(properties.FontConfiguration) : void 0), ret.addPropertyResult("horizontalTextAlignment", "HorizontalTextAlignment", properties.HorizontalTextAlignment != null ? cfn_parse.FromCloudFormation.getString(properties.HorizontalTextAlignment) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ParameterControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateTimePicker", CfnDashboard_ParameterDateTimePickerControlPropertyValidator)(properties.dateTimePicker)), errors.collect(cdk.propertyValidator("dropdown", CfnDashboard_ParameterDropDownControlPropertyValidator)(properties.dropdown)), errors.collect(cdk.propertyValidator("list", CfnDashboard_ParameterListControlPropertyValidator)(properties.list)), errors.collect(cdk.propertyValidator("slider", CfnDashboard_ParameterSliderControlPropertyValidator)(properties.slider)), errors.collect(cdk.propertyValidator("textArea", CfnDashboard_ParameterTextAreaControlPropertyValidator)(properties.textArea)), errors.collect(cdk.propertyValidator("textField", CfnDashboard_ParameterTextFieldControlPropertyValidator)(properties.textField)), errors.wrap('supplied properties not correct for "ParameterControlProperty"');
    }
    function cfnDashboardParameterControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ParameterControlPropertyValidator(properties).assertSuccess(), { DateTimePicker: cfnDashboardParameterDateTimePickerControlPropertyToCloudFormation(properties.dateTimePicker), Dropdown: cfnDashboardParameterDropDownControlPropertyToCloudFormation(properties.dropdown), List: cfnDashboardParameterListControlPropertyToCloudFormation(properties.list), Slider: cfnDashboardParameterSliderControlPropertyToCloudFormation(properties.slider), TextArea: cfnDashboardParameterTextAreaControlPropertyToCloudFormation(properties.textArea), TextField: cfnDashboardParameterTextFieldControlPropertyToCloudFormation(properties.textField) }) : properties;
    }
    function CfnDashboardParameterControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateTimePicker", "DateTimePicker", properties.DateTimePicker != null ? CfnDashboardParameterDateTimePickerControlPropertyFromCloudFormation(properties.DateTimePicker) : void 0), ret.addPropertyResult("dropdown", "Dropdown", properties.Dropdown != null ? CfnDashboardParameterDropDownControlPropertyFromCloudFormation(properties.Dropdown) : void 0), ret.addPropertyResult("list", "List", properties.List != null ? CfnDashboardParameterListControlPropertyFromCloudFormation(properties.List) : void 0), ret.addPropertyResult("slider", "Slider", properties.Slider != null ? CfnDashboardParameterSliderControlPropertyFromCloudFormation(properties.Slider) : void 0), ret.addPropertyResult("textArea", "TextArea", properties.TextArea != null ? CfnDashboardParameterTextAreaControlPropertyFromCloudFormation(properties.TextArea) : void 0), ret.addPropertyResult("textField", "TextField", properties.TextField != null ? CfnDashboardParameterTextFieldControlPropertyFromCloudFormation(properties.TextField) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ParameterDateTimePickerControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("displayOptions", CfnDashboard_DateTimePickerControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.requiredValidator)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.validateString)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.requiredValidator)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.validateString)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.wrap('supplied properties not correct for "ParameterDateTimePickerControlProperty"');
    }
    function cfnDashboardParameterDateTimePickerControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ParameterDateTimePickerControlPropertyValidator(properties).assertSuccess(), { DisplayOptions: cfnDashboardDateTimePickerControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), ParameterControlId: cdk.stringToCloudFormation(properties.parameterControlId), SourceParameterName: cdk.stringToCloudFormation(properties.sourceParameterName), Title: cdk.stringToCloudFormation(properties.title) }) : properties;
    }
    function CfnDashboardParameterDateTimePickerControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnDashboardDateTimePickerControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("parameterControlId", "ParameterControlId", cfn_parse.FromCloudFormation.getString(properties.ParameterControlId)), ret.addPropertyResult("sourceParameterName", "SourceParameterName", cfn_parse.FromCloudFormation.getString(properties.SourceParameterName)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ParameterDeclarationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateTimeParameterDeclaration", CfnDashboard_DateTimeParameterDeclarationPropertyValidator)(properties.dateTimeParameterDeclaration)), errors.collect(cdk.propertyValidator("decimalParameterDeclaration", CfnDashboard_DecimalParameterDeclarationPropertyValidator)(properties.decimalParameterDeclaration)), errors.collect(cdk.propertyValidator("integerParameterDeclaration", CfnDashboard_IntegerParameterDeclarationPropertyValidator)(properties.integerParameterDeclaration)), errors.collect(cdk.propertyValidator("stringParameterDeclaration", CfnDashboard_StringParameterDeclarationPropertyValidator)(properties.stringParameterDeclaration)), errors.wrap('supplied properties not correct for "ParameterDeclarationProperty"');
    }
    function cfnDashboardParameterDeclarationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ParameterDeclarationPropertyValidator(properties).assertSuccess(), { DateTimeParameterDeclaration: cfnDashboardDateTimeParameterDeclarationPropertyToCloudFormation(properties.dateTimeParameterDeclaration), DecimalParameterDeclaration: cfnDashboardDecimalParameterDeclarationPropertyToCloudFormation(properties.decimalParameterDeclaration), IntegerParameterDeclaration: cfnDashboardIntegerParameterDeclarationPropertyToCloudFormation(properties.integerParameterDeclaration), StringParameterDeclaration: cfnDashboardStringParameterDeclarationPropertyToCloudFormation(properties.stringParameterDeclaration) }) : properties;
    }
    function CfnDashboardParameterDeclarationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateTimeParameterDeclaration", "DateTimeParameterDeclaration", properties.DateTimeParameterDeclaration != null ? CfnDashboardDateTimeParameterDeclarationPropertyFromCloudFormation(properties.DateTimeParameterDeclaration) : void 0), ret.addPropertyResult("decimalParameterDeclaration", "DecimalParameterDeclaration", properties.DecimalParameterDeclaration != null ? CfnDashboardDecimalParameterDeclarationPropertyFromCloudFormation(properties.DecimalParameterDeclaration) : void 0), ret.addPropertyResult("integerParameterDeclaration", "IntegerParameterDeclaration", properties.IntegerParameterDeclaration != null ? CfnDashboardIntegerParameterDeclarationPropertyFromCloudFormation(properties.IntegerParameterDeclaration) : void 0), ret.addPropertyResult("stringParameterDeclaration", "StringParameterDeclaration", properties.StringParameterDeclaration != null ? CfnDashboardStringParameterDeclarationPropertyFromCloudFormation(properties.StringParameterDeclaration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ParameterDropDownControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cascadingControlConfiguration", CfnDashboard_CascadingControlConfigurationPropertyValidator)(properties.cascadingControlConfiguration)), errors.collect(cdk.propertyValidator("displayOptions", CfnDashboard_DropDownControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.requiredValidator)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.validateString)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("selectableValues", CfnDashboard_ParameterSelectableValuesPropertyValidator)(properties.selectableValues)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.requiredValidator)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.validateString)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "ParameterDropDownControlProperty"');
    }
    function cfnDashboardParameterDropDownControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ParameterDropDownControlPropertyValidator(properties).assertSuccess(), { CascadingControlConfiguration: cfnDashboardCascadingControlConfigurationPropertyToCloudFormation(properties.cascadingControlConfiguration), DisplayOptions: cfnDashboardDropDownControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), ParameterControlId: cdk.stringToCloudFormation(properties.parameterControlId), SelectableValues: cfnDashboardParameterSelectableValuesPropertyToCloudFormation(properties.selectableValues), SourceParameterName: cdk.stringToCloudFormation(properties.sourceParameterName), Title: cdk.stringToCloudFormation(properties.title), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnDashboardParameterDropDownControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cascadingControlConfiguration", "CascadingControlConfiguration", properties.CascadingControlConfiguration != null ? CfnDashboardCascadingControlConfigurationPropertyFromCloudFormation(properties.CascadingControlConfiguration) : void 0), ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnDashboardDropDownControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("parameterControlId", "ParameterControlId", cfn_parse.FromCloudFormation.getString(properties.ParameterControlId)), ret.addPropertyResult("selectableValues", "SelectableValues", properties.SelectableValues != null ? CfnDashboardParameterSelectableValuesPropertyFromCloudFormation(properties.SelectableValues) : void 0), ret.addPropertyResult("sourceParameterName", "SourceParameterName", cfn_parse.FromCloudFormation.getString(properties.SourceParameterName)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ParameterListControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cascadingControlConfiguration", CfnDashboard_CascadingControlConfigurationPropertyValidator)(properties.cascadingControlConfiguration)), errors.collect(cdk.propertyValidator("displayOptions", CfnDashboard_ListControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.requiredValidator)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.validateString)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("selectableValues", CfnDashboard_ParameterSelectableValuesPropertyValidator)(properties.selectableValues)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.requiredValidator)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.validateString)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "ParameterListControlProperty"');
    }
    function cfnDashboardParameterListControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ParameterListControlPropertyValidator(properties).assertSuccess(), { CascadingControlConfiguration: cfnDashboardCascadingControlConfigurationPropertyToCloudFormation(properties.cascadingControlConfiguration), DisplayOptions: cfnDashboardListControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), ParameterControlId: cdk.stringToCloudFormation(properties.parameterControlId), SelectableValues: cfnDashboardParameterSelectableValuesPropertyToCloudFormation(properties.selectableValues), SourceParameterName: cdk.stringToCloudFormation(properties.sourceParameterName), Title: cdk.stringToCloudFormation(properties.title), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnDashboardParameterListControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cascadingControlConfiguration", "CascadingControlConfiguration", properties.CascadingControlConfiguration != null ? CfnDashboardCascadingControlConfigurationPropertyFromCloudFormation(properties.CascadingControlConfiguration) : void 0), ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnDashboardListControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("parameterControlId", "ParameterControlId", cfn_parse.FromCloudFormation.getString(properties.ParameterControlId)), ret.addPropertyResult("selectableValues", "SelectableValues", properties.SelectableValues != null ? CfnDashboardParameterSelectableValuesPropertyFromCloudFormation(properties.SelectableValues) : void 0), ret.addPropertyResult("sourceParameterName", "SourceParameterName", cfn_parse.FromCloudFormation.getString(properties.SourceParameterName)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ParameterSelectableValuesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("linkToDataSetColumn", CfnDashboard_ColumnIdentifierPropertyValidator)(properties.linkToDataSetColumn)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "ParameterSelectableValuesProperty"');
    }
    function cfnDashboardParameterSelectableValuesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ParameterSelectableValuesPropertyValidator(properties).assertSuccess(), { LinkToDataSetColumn: cfnDashboardColumnIdentifierPropertyToCloudFormation(properties.linkToDataSetColumn), Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnDashboardParameterSelectableValuesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("linkToDataSetColumn", "LinkToDataSetColumn", properties.LinkToDataSetColumn != null ? CfnDashboardColumnIdentifierPropertyFromCloudFormation(properties.LinkToDataSetColumn) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ParameterSliderControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("displayOptions", CfnDashboard_SliderControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("maximumValue", cdk.requiredValidator)(properties.maximumValue)), errors.collect(cdk.propertyValidator("maximumValue", cdk.validateNumber)(properties.maximumValue)), errors.collect(cdk.propertyValidator("minimumValue", cdk.requiredValidator)(properties.minimumValue)), errors.collect(cdk.propertyValidator("minimumValue", cdk.validateNumber)(properties.minimumValue)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.requiredValidator)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.validateString)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.requiredValidator)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.validateString)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("stepSize", cdk.requiredValidator)(properties.stepSize)), errors.collect(cdk.propertyValidator("stepSize", cdk.validateNumber)(properties.stepSize)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.wrap('supplied properties not correct for "ParameterSliderControlProperty"');
    }
    function cfnDashboardParameterSliderControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ParameterSliderControlPropertyValidator(properties).assertSuccess(), { DisplayOptions: cfnDashboardSliderControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), MaximumValue: cdk.numberToCloudFormation(properties.maximumValue), MinimumValue: cdk.numberToCloudFormation(properties.minimumValue), ParameterControlId: cdk.stringToCloudFormation(properties.parameterControlId), SourceParameterName: cdk.stringToCloudFormation(properties.sourceParameterName), StepSize: cdk.numberToCloudFormation(properties.stepSize), Title: cdk.stringToCloudFormation(properties.title) }) : properties;
    }
    function CfnDashboardParameterSliderControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnDashboardSliderControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("maximumValue", "MaximumValue", cfn_parse.FromCloudFormation.getNumber(properties.MaximumValue)), ret.addPropertyResult("minimumValue", "MinimumValue", cfn_parse.FromCloudFormation.getNumber(properties.MinimumValue)), ret.addPropertyResult("parameterControlId", "ParameterControlId", cfn_parse.FromCloudFormation.getString(properties.ParameterControlId)), ret.addPropertyResult("sourceParameterName", "SourceParameterName", cfn_parse.FromCloudFormation.getString(properties.SourceParameterName)), ret.addPropertyResult("stepSize", "StepSize", cfn_parse.FromCloudFormation.getNumber(properties.StepSize)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ParameterTextAreaControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("delimiter", cdk.validateString)(properties.delimiter)), errors.collect(cdk.propertyValidator("displayOptions", CfnDashboard_TextAreaControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.requiredValidator)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.validateString)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.requiredValidator)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.validateString)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.wrap('supplied properties not correct for "ParameterTextAreaControlProperty"');
    }
    function cfnDashboardParameterTextAreaControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ParameterTextAreaControlPropertyValidator(properties).assertSuccess(), { Delimiter: cdk.stringToCloudFormation(properties.delimiter), DisplayOptions: cfnDashboardTextAreaControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), ParameterControlId: cdk.stringToCloudFormation(properties.parameterControlId), SourceParameterName: cdk.stringToCloudFormation(properties.sourceParameterName), Title: cdk.stringToCloudFormation(properties.title) }) : properties;
    }
    function CfnDashboardParameterTextAreaControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("delimiter", "Delimiter", properties.Delimiter != null ? cfn_parse.FromCloudFormation.getString(properties.Delimiter) : void 0), ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnDashboardTextAreaControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("parameterControlId", "ParameterControlId", cfn_parse.FromCloudFormation.getString(properties.ParameterControlId)), ret.addPropertyResult("sourceParameterName", "SourceParameterName", cfn_parse.FromCloudFormation.getString(properties.SourceParameterName)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ParameterTextFieldControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("displayOptions", CfnDashboard_TextFieldControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.requiredValidator)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.validateString)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.requiredValidator)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.validateString)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.wrap('supplied properties not correct for "ParameterTextFieldControlProperty"');
    }
    function cfnDashboardParameterTextFieldControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ParameterTextFieldControlPropertyValidator(properties).assertSuccess(), { DisplayOptions: cfnDashboardTextFieldControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), ParameterControlId: cdk.stringToCloudFormation(properties.parameterControlId), SourceParameterName: cdk.stringToCloudFormation(properties.sourceParameterName), Title: cdk.stringToCloudFormation(properties.title) }) : properties;
    }
    function CfnDashboardParameterTextFieldControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnDashboardTextFieldControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("parameterControlId", "ParameterControlId", cfn_parse.FromCloudFormation.getString(properties.ParameterControlId)), ret.addPropertyResult("sourceParameterName", "SourceParameterName", cfn_parse.FromCloudFormation.getString(properties.SourceParameterName)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateTimeParameters", cdk.listValidator(CfnDashboard_DateTimeParameterPropertyValidator))(properties.dateTimeParameters)), errors.collect(cdk.propertyValidator("decimalParameters", cdk.listValidator(CfnDashboard_DecimalParameterPropertyValidator))(properties.decimalParameters)), errors.collect(cdk.propertyValidator("integerParameters", cdk.listValidator(CfnDashboard_IntegerParameterPropertyValidator))(properties.integerParameters)), errors.collect(cdk.propertyValidator("stringParameters", cdk.listValidator(CfnDashboard_StringParameterPropertyValidator))(properties.stringParameters)), errors.wrap('supplied properties not correct for "ParametersProperty"');
    }
    function cfnDashboardParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ParametersPropertyValidator(properties).assertSuccess(), { DateTimeParameters: cdk.listMapper(cfnDashboardDateTimeParameterPropertyToCloudFormation)(properties.dateTimeParameters), DecimalParameters: cdk.listMapper(cfnDashboardDecimalParameterPropertyToCloudFormation)(properties.decimalParameters), IntegerParameters: cdk.listMapper(cfnDashboardIntegerParameterPropertyToCloudFormation)(properties.integerParameters), StringParameters: cdk.listMapper(cfnDashboardStringParameterPropertyToCloudFormation)(properties.stringParameters) }) : properties;
    }
    function CfnDashboardParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateTimeParameters", "DateTimeParameters", properties.DateTimeParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDateTimeParameterPropertyFromCloudFormation)(properties.DateTimeParameters) : void 0), ret.addPropertyResult("decimalParameters", "DecimalParameters", properties.DecimalParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDecimalParameterPropertyFromCloudFormation)(properties.DecimalParameters) : void 0), ret.addPropertyResult("integerParameters", "IntegerParameters", properties.IntegerParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardIntegerParameterPropertyFromCloudFormation)(properties.IntegerParameters) : void 0), ret.addPropertyResult("stringParameters", "StringParameters", properties.StringParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardStringParameterPropertyFromCloudFormation)(properties.StringParameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PercentVisibleRangePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("from", cdk.validateNumber)(properties.from)), errors.collect(cdk.propertyValidator("to", cdk.validateNumber)(properties.to)), errors.wrap('supplied properties not correct for "PercentVisibleRangeProperty"');
    }
    function cfnDashboardPercentVisibleRangePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PercentVisibleRangePropertyValidator(properties).assertSuccess(), { From: cdk.numberToCloudFormation(properties.from), To: cdk.numberToCloudFormation(properties.to) }) : properties;
    }
    function CfnDashboardPercentVisibleRangePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("from", "From", properties.From != null ? cfn_parse.FromCloudFormation.getNumber(properties.From) : void 0), ret.addPropertyResult("to", "To", properties.To != null ? cfn_parse.FromCloudFormation.getNumber(properties.To) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PercentageDisplayFormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("decimalPlacesConfiguration", CfnDashboard_DecimalPlacesConfigurationPropertyValidator)(properties.decimalPlacesConfiguration)), errors.collect(cdk.propertyValidator("negativeValueConfiguration", CfnDashboard_NegativeValueConfigurationPropertyValidator)(properties.negativeValueConfiguration)), errors.collect(cdk.propertyValidator("nullValueFormatConfiguration", CfnDashboard_NullValueFormatConfigurationPropertyValidator)(properties.nullValueFormatConfiguration)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.collect(cdk.propertyValidator("separatorConfiguration", CfnDashboard_NumericSeparatorConfigurationPropertyValidator)(properties.separatorConfiguration)), errors.collect(cdk.propertyValidator("suffix", cdk.validateString)(properties.suffix)), errors.wrap('supplied properties not correct for "PercentageDisplayFormatConfigurationProperty"');
    }
    function cfnDashboardPercentageDisplayFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PercentageDisplayFormatConfigurationPropertyValidator(properties).assertSuccess(), { DecimalPlacesConfiguration: cfnDashboardDecimalPlacesConfigurationPropertyToCloudFormation(properties.decimalPlacesConfiguration), NegativeValueConfiguration: cfnDashboardNegativeValueConfigurationPropertyToCloudFormation(properties.negativeValueConfiguration), NullValueFormatConfiguration: cfnDashboardNullValueFormatConfigurationPropertyToCloudFormation(properties.nullValueFormatConfiguration), Prefix: cdk.stringToCloudFormation(properties.prefix), SeparatorConfiguration: cfnDashboardNumericSeparatorConfigurationPropertyToCloudFormation(properties.separatorConfiguration), Suffix: cdk.stringToCloudFormation(properties.suffix) }) : properties;
    }
    function CfnDashboardPercentageDisplayFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("decimalPlacesConfiguration", "DecimalPlacesConfiguration", properties.DecimalPlacesConfiguration != null ? CfnDashboardDecimalPlacesConfigurationPropertyFromCloudFormation(properties.DecimalPlacesConfiguration) : void 0), ret.addPropertyResult("negativeValueConfiguration", "NegativeValueConfiguration", properties.NegativeValueConfiguration != null ? CfnDashboardNegativeValueConfigurationPropertyFromCloudFormation(properties.NegativeValueConfiguration) : void 0), ret.addPropertyResult("nullValueFormatConfiguration", "NullValueFormatConfiguration", properties.NullValueFormatConfiguration != null ? CfnDashboardNullValueFormatConfigurationPropertyFromCloudFormation(properties.NullValueFormatConfiguration) : void 0), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addPropertyResult("separatorConfiguration", "SeparatorConfiguration", properties.SeparatorConfiguration != null ? CfnDashboardNumericSeparatorConfigurationPropertyFromCloudFormation(properties.SeparatorConfiguration) : void 0), ret.addPropertyResult("suffix", "Suffix", properties.Suffix != null ? cfn_parse.FromCloudFormation.getString(properties.Suffix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PercentileAggregationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("percentileValue", cdk.validateNumber)(properties.percentileValue)), errors.wrap('supplied properties not correct for "PercentileAggregationProperty"');
    }
    function cfnDashboardPercentileAggregationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PercentileAggregationPropertyValidator(properties).assertSuccess(), { PercentileValue: cdk.numberToCloudFormation(properties.percentileValue) }) : properties;
    }
    function CfnDashboardPercentileAggregationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("percentileValue", "PercentileValue", properties.PercentileValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.PercentileValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PeriodOverPeriodComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computationId", cdk.requiredValidator)(properties.computationId)), errors.collect(cdk.propertyValidator("computationId", cdk.validateString)(properties.computationId)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("time", cdk.requiredValidator)(properties.time)), errors.collect(cdk.propertyValidator("time", CfnDashboard_DimensionFieldPropertyValidator)(properties.time)), errors.collect(cdk.propertyValidator("value", CfnDashboard_MeasureFieldPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "PeriodOverPeriodComputationProperty"');
    }
    function cfnDashboardPeriodOverPeriodComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PeriodOverPeriodComputationPropertyValidator(properties).assertSuccess(), { ComputationId: cdk.stringToCloudFormation(properties.computationId), Name: cdk.stringToCloudFormation(properties.name), Time: cfnDashboardDimensionFieldPropertyToCloudFormation(properties.time), Value: cfnDashboardMeasureFieldPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnDashboardPeriodOverPeriodComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computationId", "ComputationId", cfn_parse.FromCloudFormation.getString(properties.ComputationId)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("time", "Time", CfnDashboardDimensionFieldPropertyFromCloudFormation(properties.Time)), ret.addPropertyResult("value", "Value", properties.Value != null ? CfnDashboardMeasureFieldPropertyFromCloudFormation(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PeriodToDateComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computationId", cdk.requiredValidator)(properties.computationId)), errors.collect(cdk.propertyValidator("computationId", cdk.validateString)(properties.computationId)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("periodTimeGranularity", cdk.validateString)(properties.periodTimeGranularity)), errors.collect(cdk.propertyValidator("time", cdk.requiredValidator)(properties.time)), errors.collect(cdk.propertyValidator("time", CfnDashboard_DimensionFieldPropertyValidator)(properties.time)), errors.collect(cdk.propertyValidator("value", CfnDashboard_MeasureFieldPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "PeriodToDateComputationProperty"');
    }
    function cfnDashboardPeriodToDateComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PeriodToDateComputationPropertyValidator(properties).assertSuccess(), { ComputationId: cdk.stringToCloudFormation(properties.computationId), Name: cdk.stringToCloudFormation(properties.name), PeriodTimeGranularity: cdk.stringToCloudFormation(properties.periodTimeGranularity), Time: cfnDashboardDimensionFieldPropertyToCloudFormation(properties.time), Value: cfnDashboardMeasureFieldPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnDashboardPeriodToDateComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computationId", "ComputationId", cfn_parse.FromCloudFormation.getString(properties.ComputationId)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("periodTimeGranularity", "PeriodTimeGranularity", properties.PeriodTimeGranularity != null ? cfn_parse.FromCloudFormation.getString(properties.PeriodTimeGranularity) : void 0), ret.addPropertyResult("time", "Time", CfnDashboardDimensionFieldPropertyFromCloudFormation(properties.Time)), ret.addPropertyResult("value", "Value", properties.Value != null ? CfnDashboardMeasureFieldPropertyFromCloudFormation(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PieChartAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("category", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.category)), errors.collect(cdk.propertyValidator("smallMultiples", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.smallMultiples)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnDashboard_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "PieChartAggregatedFieldWellsProperty"');
    }
    function cfnDashboardPieChartAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PieChartAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Category: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.category), SmallMultiples: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.smallMultiples), Values: cdk.listMapper(cfnDashboardMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnDashboardPieChartAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("category", "Category", properties.Category != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.Category) : void 0), ret.addPropertyResult("smallMultiples", "SmallMultiples", properties.SmallMultiples != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.SmallMultiples) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PieChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryLabelOptions", CfnDashboard_ChartAxisLabelOptionsPropertyValidator)(properties.categoryLabelOptions)), errors.collect(cdk.propertyValidator("contributionAnalysisDefaults", cdk.listValidator(CfnDashboard_ContributionAnalysisDefaultPropertyValidator))(properties.contributionAnalysisDefaults)), errors.collect(cdk.propertyValidator("dataLabels", CfnDashboard_DataLabelOptionsPropertyValidator)(properties.dataLabels)), errors.collect(cdk.propertyValidator("donutOptions", CfnDashboard_DonutOptionsPropertyValidator)(properties.donutOptions)), errors.collect(cdk.propertyValidator("fieldWells", CfnDashboard_PieChartFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("legend", CfnDashboard_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("smallMultiplesOptions", CfnDashboard_SmallMultiplesOptionsPropertyValidator)(properties.smallMultiplesOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnDashboard_PieChartSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tooltip", CfnDashboard_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.collect(cdk.propertyValidator("valueLabelOptions", CfnDashboard_ChartAxisLabelOptionsPropertyValidator)(properties.valueLabelOptions)), errors.collect(cdk.propertyValidator("visualPalette", CfnDashboard_VisualPalettePropertyValidator)(properties.visualPalette)), errors.wrap('supplied properties not correct for "PieChartConfigurationProperty"');
    }
    function cfnDashboardPieChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PieChartConfigurationPropertyValidator(properties).assertSuccess(), { CategoryLabelOptions: cfnDashboardChartAxisLabelOptionsPropertyToCloudFormation(properties.categoryLabelOptions), ContributionAnalysisDefaults: cdk.listMapper(cfnDashboardContributionAnalysisDefaultPropertyToCloudFormation)(properties.contributionAnalysisDefaults), DataLabels: cfnDashboardDataLabelOptionsPropertyToCloudFormation(properties.dataLabels), DonutOptions: cfnDashboardDonutOptionsPropertyToCloudFormation(properties.donutOptions), FieldWells: cfnDashboardPieChartFieldWellsPropertyToCloudFormation(properties.fieldWells), Legend: cfnDashboardLegendOptionsPropertyToCloudFormation(properties.legend), SmallMultiplesOptions: cfnDashboardSmallMultiplesOptionsPropertyToCloudFormation(properties.smallMultiplesOptions), SortConfiguration: cfnDashboardPieChartSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), Tooltip: cfnDashboardTooltipOptionsPropertyToCloudFormation(properties.tooltip), ValueLabelOptions: cfnDashboardChartAxisLabelOptionsPropertyToCloudFormation(properties.valueLabelOptions), VisualPalette: cfnDashboardVisualPalettePropertyToCloudFormation(properties.visualPalette) }) : properties;
    }
    function CfnDashboardPieChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryLabelOptions", "CategoryLabelOptions", properties.CategoryLabelOptions != null ? CfnDashboardChartAxisLabelOptionsPropertyFromCloudFormation(properties.CategoryLabelOptions) : void 0), ret.addPropertyResult("contributionAnalysisDefaults", "ContributionAnalysisDefaults", properties.ContributionAnalysisDefaults != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardContributionAnalysisDefaultPropertyFromCloudFormation)(properties.ContributionAnalysisDefaults) : void 0), ret.addPropertyResult("dataLabels", "DataLabels", properties.DataLabels != null ? CfnDashboardDataLabelOptionsPropertyFromCloudFormation(properties.DataLabels) : void 0), ret.addPropertyResult("donutOptions", "DonutOptions", properties.DonutOptions != null ? CfnDashboardDonutOptionsPropertyFromCloudFormation(properties.DonutOptions) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnDashboardPieChartFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnDashboardLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("smallMultiplesOptions", "SmallMultiplesOptions", properties.SmallMultiplesOptions != null ? CfnDashboardSmallMultiplesOptionsPropertyFromCloudFormation(properties.SmallMultiplesOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnDashboardPieChartSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnDashboardTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addPropertyResult("valueLabelOptions", "ValueLabelOptions", properties.ValueLabelOptions != null ? CfnDashboardChartAxisLabelOptionsPropertyFromCloudFormation(properties.ValueLabelOptions) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnDashboardVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PieChartFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("pieChartAggregatedFieldWells", CfnDashboard_PieChartAggregatedFieldWellsPropertyValidator)(properties.pieChartAggregatedFieldWells)), errors.wrap('supplied properties not correct for "PieChartFieldWellsProperty"');
    }
    function cfnDashboardPieChartFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PieChartFieldWellsPropertyValidator(properties).assertSuccess(), { PieChartAggregatedFieldWells: cfnDashboardPieChartAggregatedFieldWellsPropertyToCloudFormation(properties.pieChartAggregatedFieldWells) }) : properties;
    }
    function CfnDashboardPieChartFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("pieChartAggregatedFieldWells", "PieChartAggregatedFieldWells", properties.PieChartAggregatedFieldWells != null ? CfnDashboardPieChartAggregatedFieldWellsPropertyFromCloudFormation(properties.PieChartAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PieChartSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryItemsLimit", CfnDashboard_ItemsLimitConfigurationPropertyValidator)(properties.categoryItemsLimit)), errors.collect(cdk.propertyValidator("categorySort", cdk.listValidator(CfnDashboard_FieldSortOptionsPropertyValidator))(properties.categorySort)), errors.collect(cdk.propertyValidator("smallMultiplesLimitConfiguration", CfnDashboard_ItemsLimitConfigurationPropertyValidator)(properties.smallMultiplesLimitConfiguration)), errors.collect(cdk.propertyValidator("smallMultiplesSort", cdk.listValidator(CfnDashboard_FieldSortOptionsPropertyValidator))(properties.smallMultiplesSort)), errors.wrap('supplied properties not correct for "PieChartSortConfigurationProperty"');
    }
    function cfnDashboardPieChartSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PieChartSortConfigurationPropertyValidator(properties).assertSuccess(), { CategoryItemsLimit: cfnDashboardItemsLimitConfigurationPropertyToCloudFormation(properties.categoryItemsLimit), CategorySort: cdk.listMapper(cfnDashboardFieldSortOptionsPropertyToCloudFormation)(properties.categorySort), SmallMultiplesLimitConfiguration: cfnDashboardItemsLimitConfigurationPropertyToCloudFormation(properties.smallMultiplesLimitConfiguration), SmallMultiplesSort: cdk.listMapper(cfnDashboardFieldSortOptionsPropertyToCloudFormation)(properties.smallMultiplesSort) }) : properties;
    }
    function CfnDashboardPieChartSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryItemsLimit", "CategoryItemsLimit", properties.CategoryItemsLimit != null ? CfnDashboardItemsLimitConfigurationPropertyFromCloudFormation(properties.CategoryItemsLimit) : void 0), ret.addPropertyResult("categorySort", "CategorySort", properties.CategorySort != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardFieldSortOptionsPropertyFromCloudFormation)(properties.CategorySort) : void 0), ret.addPropertyResult("smallMultiplesLimitConfiguration", "SmallMultiplesLimitConfiguration", properties.SmallMultiplesLimitConfiguration != null ? CfnDashboardItemsLimitConfigurationPropertyFromCloudFormation(properties.SmallMultiplesLimitConfiguration) : void 0), ret.addPropertyResult("smallMultiplesSort", "SmallMultiplesSort", properties.SmallMultiplesSort != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardFieldSortOptionsPropertyFromCloudFormation)(properties.SmallMultiplesSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PieChartVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnDashboard_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnDashboard_PieChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnDashboard_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnDashboard_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnDashboard_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "PieChartVisualProperty"');
    }
    function cfnDashboardPieChartVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PieChartVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnDashboardVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnDashboardPieChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnDashboardColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnDashboardVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnDashboardVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnDashboardPieChartVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnDashboardPieChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnDashboardVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnDashboardVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PivotFieldSortOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("sortBy", cdk.requiredValidator)(properties.sortBy)), errors.collect(cdk.propertyValidator("sortBy", CfnDashboard_PivotTableSortByPropertyValidator)(properties.sortBy)), errors.wrap('supplied properties not correct for "PivotFieldSortOptionsProperty"');
    }
    function cfnDashboardPivotFieldSortOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PivotFieldSortOptionsPropertyValidator(properties).assertSuccess(), { FieldId: cdk.stringToCloudFormation(properties.fieldId), SortBy: cfnDashboardPivotTableSortByPropertyToCloudFormation(properties.sortBy) }) : properties;
    }
    function CfnDashboardPivotFieldSortOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("sortBy", "SortBy", CfnDashboardPivotTableSortByPropertyFromCloudFormation(properties.SortBy)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PivotTableAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columns", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.columns)), errors.collect(cdk.propertyValidator("rows", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.rows)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnDashboard_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "PivotTableAggregatedFieldWellsProperty"');
    }
    function cfnDashboardPivotTableAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PivotTableAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Columns: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.columns), Rows: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.rows), Values: cdk.listMapper(cfnDashboardMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnDashboardPivotTableAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columns", "Columns", properties.Columns != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.Columns) : void 0), ret.addPropertyResult("rows", "Rows", properties.Rows != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.Rows) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PivotTableCellConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("scope", CfnDashboard_PivotTableConditionalFormattingScopePropertyValidator)(properties.scope)), errors.collect(cdk.propertyValidator("textFormat", CfnDashboard_TextConditionalFormatPropertyValidator)(properties.textFormat)), errors.wrap('supplied properties not correct for "PivotTableCellConditionalFormattingProperty"');
    }
    function cfnDashboardPivotTableCellConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PivotTableCellConditionalFormattingPropertyValidator(properties).assertSuccess(), { FieldId: cdk.stringToCloudFormation(properties.fieldId), Scope: cfnDashboardPivotTableConditionalFormattingScopePropertyToCloudFormation(properties.scope), TextFormat: cfnDashboardTextConditionalFormatPropertyToCloudFormation(properties.textFormat) }) : properties;
    }
    function CfnDashboardPivotTableCellConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("scope", "Scope", properties.Scope != null ? CfnDashboardPivotTableConditionalFormattingScopePropertyFromCloudFormation(properties.Scope) : void 0), ret.addPropertyResult("textFormat", "TextFormat", properties.TextFormat != null ? CfnDashboardTextConditionalFormatPropertyFromCloudFormation(properties.TextFormat) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PivotTableConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("conditionalFormattingOptions", cdk.listValidator(CfnDashboard_PivotTableConditionalFormattingOptionPropertyValidator))(properties.conditionalFormattingOptions)), errors.wrap('supplied properties not correct for "PivotTableConditionalFormattingProperty"');
    }
    function cfnDashboardPivotTableConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PivotTableConditionalFormattingPropertyValidator(properties).assertSuccess(), { ConditionalFormattingOptions: cdk.listMapper(cfnDashboardPivotTableConditionalFormattingOptionPropertyToCloudFormation)(properties.conditionalFormattingOptions) }) : properties;
    }
    function CfnDashboardPivotTableConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("conditionalFormattingOptions", "ConditionalFormattingOptions", properties.ConditionalFormattingOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardPivotTableConditionalFormattingOptionPropertyFromCloudFormation)(properties.ConditionalFormattingOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PivotTableConditionalFormattingOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cell", CfnDashboard_PivotTableCellConditionalFormattingPropertyValidator)(properties.cell)), errors.wrap('supplied properties not correct for "PivotTableConditionalFormattingOptionProperty"');
    }
    function cfnDashboardPivotTableConditionalFormattingOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PivotTableConditionalFormattingOptionPropertyValidator(properties).assertSuccess(), { Cell: cfnDashboardPivotTableCellConditionalFormattingPropertyToCloudFormation(properties.cell) }) : properties;
    }
    function CfnDashboardPivotTableConditionalFormattingOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cell", "Cell", properties.Cell != null ? CfnDashboardPivotTableCellConditionalFormattingPropertyFromCloudFormation(properties.Cell) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PivotTableConditionalFormattingScopePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("role", cdk.validateString)(properties.role)), errors.wrap('supplied properties not correct for "PivotTableConditionalFormattingScopeProperty"');
    }
    function cfnDashboardPivotTableConditionalFormattingScopePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PivotTableConditionalFormattingScopePropertyValidator(properties).assertSuccess(), { Role: cdk.stringToCloudFormation(properties.role) }) : properties;
    }
    function CfnDashboardPivotTableConditionalFormattingScopePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("role", "Role", properties.Role != null ? cfn_parse.FromCloudFormation.getString(properties.Role) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PivotTableConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldOptions", CfnDashboard_PivotTableFieldOptionsPropertyValidator)(properties.fieldOptions)), errors.collect(cdk.propertyValidator("fieldWells", CfnDashboard_PivotTableFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("paginatedReportOptions", CfnDashboard_PivotTablePaginatedReportOptionsPropertyValidator)(properties.paginatedReportOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnDashboard_PivotTableSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tableOptions", CfnDashboard_PivotTableOptionsPropertyValidator)(properties.tableOptions)), errors.collect(cdk.propertyValidator("totalOptions", CfnDashboard_PivotTableTotalOptionsPropertyValidator)(properties.totalOptions)), errors.wrap('supplied properties not correct for "PivotTableConfigurationProperty"');
    }
    function cfnDashboardPivotTableConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PivotTableConfigurationPropertyValidator(properties).assertSuccess(), { FieldOptions: cfnDashboardPivotTableFieldOptionsPropertyToCloudFormation(properties.fieldOptions), FieldWells: cfnDashboardPivotTableFieldWellsPropertyToCloudFormation(properties.fieldWells), PaginatedReportOptions: cfnDashboardPivotTablePaginatedReportOptionsPropertyToCloudFormation(properties.paginatedReportOptions), SortConfiguration: cfnDashboardPivotTableSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), TableOptions: cfnDashboardPivotTableOptionsPropertyToCloudFormation(properties.tableOptions), TotalOptions: cfnDashboardPivotTableTotalOptionsPropertyToCloudFormation(properties.totalOptions) }) : properties;
    }
    function CfnDashboardPivotTableConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldOptions", "FieldOptions", properties.FieldOptions != null ? CfnDashboardPivotTableFieldOptionsPropertyFromCloudFormation(properties.FieldOptions) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnDashboardPivotTableFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("paginatedReportOptions", "PaginatedReportOptions", properties.PaginatedReportOptions != null ? CfnDashboardPivotTablePaginatedReportOptionsPropertyFromCloudFormation(properties.PaginatedReportOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnDashboardPivotTableSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tableOptions", "TableOptions", properties.TableOptions != null ? CfnDashboardPivotTableOptionsPropertyFromCloudFormation(properties.TableOptions) : void 0), ret.addPropertyResult("totalOptions", "TotalOptions", properties.TotalOptions != null ? CfnDashboardPivotTableTotalOptionsPropertyFromCloudFormation(properties.TotalOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PivotTableDataPathOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataPathList", cdk.requiredValidator)(properties.dataPathList)), errors.collect(cdk.propertyValidator("dataPathList", cdk.listValidator(CfnDashboard_DataPathValuePropertyValidator))(properties.dataPathList)), errors.collect(cdk.propertyValidator("width", cdk.validateString)(properties.width)), errors.wrap('supplied properties not correct for "PivotTableDataPathOptionProperty"');
    }
    function cfnDashboardPivotTableDataPathOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PivotTableDataPathOptionPropertyValidator(properties).assertSuccess(), { DataPathList: cdk.listMapper(cfnDashboardDataPathValuePropertyToCloudFormation)(properties.dataPathList), Width: cdk.stringToCloudFormation(properties.width) }) : properties;
    }
    function CfnDashboardPivotTableDataPathOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataPathList", "DataPathList", cfn_parse.FromCloudFormation.getArray(CfnDashboardDataPathValuePropertyFromCloudFormation)(properties.DataPathList)), ret.addPropertyResult("width", "Width", properties.Width != null ? cfn_parse.FromCloudFormation.getString(properties.Width) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PivotTableFieldOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customLabel", cdk.validateString)(properties.customLabel)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "PivotTableFieldOptionProperty"');
    }
    function cfnDashboardPivotTableFieldOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PivotTableFieldOptionPropertyValidator(properties).assertSuccess(), { CustomLabel: cdk.stringToCloudFormation(properties.customLabel), FieldId: cdk.stringToCloudFormation(properties.fieldId), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnDashboardPivotTableFieldOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customLabel", "CustomLabel", properties.CustomLabel != null ? cfn_parse.FromCloudFormation.getString(properties.CustomLabel) : void 0), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PivotTableFieldOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataPathOptions", cdk.listValidator(CfnDashboard_PivotTableDataPathOptionPropertyValidator))(properties.dataPathOptions)), errors.collect(cdk.propertyValidator("selectedFieldOptions", cdk.listValidator(CfnDashboard_PivotTableFieldOptionPropertyValidator))(properties.selectedFieldOptions)), errors.wrap('supplied properties not correct for "PivotTableFieldOptionsProperty"');
    }
    function cfnDashboardPivotTableFieldOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PivotTableFieldOptionsPropertyValidator(properties).assertSuccess(), { DataPathOptions: cdk.listMapper(cfnDashboardPivotTableDataPathOptionPropertyToCloudFormation)(properties.dataPathOptions), SelectedFieldOptions: cdk.listMapper(cfnDashboardPivotTableFieldOptionPropertyToCloudFormation)(properties.selectedFieldOptions) }) : properties;
    }
    function CfnDashboardPivotTableFieldOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataPathOptions", "DataPathOptions", properties.DataPathOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardPivotTableDataPathOptionPropertyFromCloudFormation)(properties.DataPathOptions) : void 0), ret.addPropertyResult("selectedFieldOptions", "SelectedFieldOptions", properties.SelectedFieldOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardPivotTableFieldOptionPropertyFromCloudFormation)(properties.SelectedFieldOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PivotTableFieldSubtotalOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.wrap('supplied properties not correct for "PivotTableFieldSubtotalOptionsProperty"');
    }
    function cfnDashboardPivotTableFieldSubtotalOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PivotTableFieldSubtotalOptionsPropertyValidator(properties).assertSuccess(), { FieldId: cdk.stringToCloudFormation(properties.fieldId) }) : properties;
    }
    function CfnDashboardPivotTableFieldSubtotalOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldId", "FieldId", properties.FieldId != null ? cfn_parse.FromCloudFormation.getString(properties.FieldId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PivotTableFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("pivotTableAggregatedFieldWells", CfnDashboard_PivotTableAggregatedFieldWellsPropertyValidator)(properties.pivotTableAggregatedFieldWells)), errors.wrap('supplied properties not correct for "PivotTableFieldWellsProperty"');
    }
    function cfnDashboardPivotTableFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PivotTableFieldWellsPropertyValidator(properties).assertSuccess(), { PivotTableAggregatedFieldWells: cfnDashboardPivotTableAggregatedFieldWellsPropertyToCloudFormation(properties.pivotTableAggregatedFieldWells) }) : properties;
    }
    function CfnDashboardPivotTableFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("pivotTableAggregatedFieldWells", "PivotTableAggregatedFieldWells", properties.PivotTableAggregatedFieldWells != null ? CfnDashboardPivotTableAggregatedFieldWellsPropertyFromCloudFormation(properties.PivotTableAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PivotTableOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cellStyle", CfnDashboard_TableCellStylePropertyValidator)(properties.cellStyle)), errors.collect(cdk.propertyValidator("columnHeaderStyle", CfnDashboard_TableCellStylePropertyValidator)(properties.columnHeaderStyle)), errors.collect(cdk.propertyValidator("columnNamesVisibility", cdk.validateString)(properties.columnNamesVisibility)), errors.collect(cdk.propertyValidator("metricPlacement", cdk.validateString)(properties.metricPlacement)), errors.collect(cdk.propertyValidator("rowAlternateColorOptions", CfnDashboard_RowAlternateColorOptionsPropertyValidator)(properties.rowAlternateColorOptions)), errors.collect(cdk.propertyValidator("rowFieldNamesStyle", CfnDashboard_TableCellStylePropertyValidator)(properties.rowFieldNamesStyle)), errors.collect(cdk.propertyValidator("rowHeaderStyle", CfnDashboard_TableCellStylePropertyValidator)(properties.rowHeaderStyle)), errors.collect(cdk.propertyValidator("singleMetricVisibility", cdk.validateString)(properties.singleMetricVisibility)), errors.collect(cdk.propertyValidator("toggleButtonsVisibility", cdk.validateString)(properties.toggleButtonsVisibility)), errors.wrap('supplied properties not correct for "PivotTableOptionsProperty"');
    }
    function cfnDashboardPivotTableOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PivotTableOptionsPropertyValidator(properties).assertSuccess(), { CellStyle: cfnDashboardTableCellStylePropertyToCloudFormation(properties.cellStyle), ColumnHeaderStyle: cfnDashboardTableCellStylePropertyToCloudFormation(properties.columnHeaderStyle), ColumnNamesVisibility: cdk.stringToCloudFormation(properties.columnNamesVisibility), MetricPlacement: cdk.stringToCloudFormation(properties.metricPlacement), RowAlternateColorOptions: cfnDashboardRowAlternateColorOptionsPropertyToCloudFormation(properties.rowAlternateColorOptions), RowFieldNamesStyle: cfnDashboardTableCellStylePropertyToCloudFormation(properties.rowFieldNamesStyle), RowHeaderStyle: cfnDashboardTableCellStylePropertyToCloudFormation(properties.rowHeaderStyle), SingleMetricVisibility: cdk.stringToCloudFormation(properties.singleMetricVisibility), ToggleButtonsVisibility: cdk.stringToCloudFormation(properties.toggleButtonsVisibility) }) : properties;
    }
    function CfnDashboardPivotTableOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cellStyle", "CellStyle", properties.CellStyle != null ? CfnDashboardTableCellStylePropertyFromCloudFormation(properties.CellStyle) : void 0), ret.addPropertyResult("columnHeaderStyle", "ColumnHeaderStyle", properties.ColumnHeaderStyle != null ? CfnDashboardTableCellStylePropertyFromCloudFormation(properties.ColumnHeaderStyle) : void 0), ret.addPropertyResult("columnNamesVisibility", "ColumnNamesVisibility", properties.ColumnNamesVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.ColumnNamesVisibility) : void 0), ret.addPropertyResult("metricPlacement", "MetricPlacement", properties.MetricPlacement != null ? cfn_parse.FromCloudFormation.getString(properties.MetricPlacement) : void 0), ret.addPropertyResult("rowAlternateColorOptions", "RowAlternateColorOptions", properties.RowAlternateColorOptions != null ? CfnDashboardRowAlternateColorOptionsPropertyFromCloudFormation(properties.RowAlternateColorOptions) : void 0), ret.addPropertyResult("rowFieldNamesStyle", "RowFieldNamesStyle", properties.RowFieldNamesStyle != null ? CfnDashboardTableCellStylePropertyFromCloudFormation(properties.RowFieldNamesStyle) : void 0), ret.addPropertyResult("rowHeaderStyle", "RowHeaderStyle", properties.RowHeaderStyle != null ? CfnDashboardTableCellStylePropertyFromCloudFormation(properties.RowHeaderStyle) : void 0), ret.addPropertyResult("singleMetricVisibility", "SingleMetricVisibility", properties.SingleMetricVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.SingleMetricVisibility) : void 0), ret.addPropertyResult("toggleButtonsVisibility", "ToggleButtonsVisibility", properties.ToggleButtonsVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.ToggleButtonsVisibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PivotTablePaginatedReportOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("overflowColumnHeaderVisibility", cdk.validateString)(properties.overflowColumnHeaderVisibility)), errors.collect(cdk.propertyValidator("verticalOverflowVisibility", cdk.validateString)(properties.verticalOverflowVisibility)), errors.wrap('supplied properties not correct for "PivotTablePaginatedReportOptionsProperty"');
    }
    function cfnDashboardPivotTablePaginatedReportOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PivotTablePaginatedReportOptionsPropertyValidator(properties).assertSuccess(), { OverflowColumnHeaderVisibility: cdk.stringToCloudFormation(properties.overflowColumnHeaderVisibility), VerticalOverflowVisibility: cdk.stringToCloudFormation(properties.verticalOverflowVisibility) }) : properties;
    }
    function CfnDashboardPivotTablePaginatedReportOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("overflowColumnHeaderVisibility", "OverflowColumnHeaderVisibility", properties.OverflowColumnHeaderVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.OverflowColumnHeaderVisibility) : void 0), ret.addPropertyResult("verticalOverflowVisibility", "VerticalOverflowVisibility", properties.VerticalOverflowVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.VerticalOverflowVisibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PivotTableSortByPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", CfnDashboard_ColumnSortPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("dataPath", CfnDashboard_DataPathSortPropertyValidator)(properties.dataPath)), errors.collect(cdk.propertyValidator("field", CfnDashboard_FieldSortPropertyValidator)(properties.field)), errors.wrap('supplied properties not correct for "PivotTableSortByProperty"');
    }
    function cfnDashboardPivotTableSortByPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PivotTableSortByPropertyValidator(properties).assertSuccess(), { Column: cfnDashboardColumnSortPropertyToCloudFormation(properties.column), DataPath: cfnDashboardDataPathSortPropertyToCloudFormation(properties.dataPath), Field: cfnDashboardFieldSortPropertyToCloudFormation(properties.field) }) : properties;
    }
    function CfnDashboardPivotTableSortByPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", properties.Column != null ? CfnDashboardColumnSortPropertyFromCloudFormation(properties.Column) : void 0), ret.addPropertyResult("dataPath", "DataPath", properties.DataPath != null ? CfnDashboardDataPathSortPropertyFromCloudFormation(properties.DataPath) : void 0), ret.addPropertyResult("field", "Field", properties.Field != null ? CfnDashboardFieldSortPropertyFromCloudFormation(properties.Field) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PivotTableSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldSortOptions", cdk.listValidator(CfnDashboard_PivotFieldSortOptionsPropertyValidator))(properties.fieldSortOptions)), errors.wrap('supplied properties not correct for "PivotTableSortConfigurationProperty"');
    }
    function cfnDashboardPivotTableSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PivotTableSortConfigurationPropertyValidator(properties).assertSuccess(), { FieldSortOptions: cdk.listMapper(cfnDashboardPivotFieldSortOptionsPropertyToCloudFormation)(properties.fieldSortOptions) }) : properties;
    }
    function CfnDashboardPivotTableSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldSortOptions", "FieldSortOptions", properties.FieldSortOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardPivotFieldSortOptionsPropertyFromCloudFormation)(properties.FieldSortOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PivotTableTotalOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnSubtotalOptions", CfnDashboard_SubtotalOptionsPropertyValidator)(properties.columnSubtotalOptions)), errors.collect(cdk.propertyValidator("columnTotalOptions", CfnDashboard_PivotTotalOptionsPropertyValidator)(properties.columnTotalOptions)), errors.collect(cdk.propertyValidator("rowSubtotalOptions", CfnDashboard_SubtotalOptionsPropertyValidator)(properties.rowSubtotalOptions)), errors.collect(cdk.propertyValidator("rowTotalOptions", CfnDashboard_PivotTotalOptionsPropertyValidator)(properties.rowTotalOptions)), errors.wrap('supplied properties not correct for "PivotTableTotalOptionsProperty"');
    }
    function cfnDashboardPivotTableTotalOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PivotTableTotalOptionsPropertyValidator(properties).assertSuccess(), { ColumnSubtotalOptions: cfnDashboardSubtotalOptionsPropertyToCloudFormation(properties.columnSubtotalOptions), ColumnTotalOptions: cfnDashboardPivotTotalOptionsPropertyToCloudFormation(properties.columnTotalOptions), RowSubtotalOptions: cfnDashboardSubtotalOptionsPropertyToCloudFormation(properties.rowSubtotalOptions), RowTotalOptions: cfnDashboardPivotTotalOptionsPropertyToCloudFormation(properties.rowTotalOptions) }) : properties;
    }
    function CfnDashboardPivotTableTotalOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columnSubtotalOptions", "ColumnSubtotalOptions", properties.ColumnSubtotalOptions != null ? CfnDashboardSubtotalOptionsPropertyFromCloudFormation(properties.ColumnSubtotalOptions) : void 0), ret.addPropertyResult("columnTotalOptions", "ColumnTotalOptions", properties.ColumnTotalOptions != null ? CfnDashboardPivotTotalOptionsPropertyFromCloudFormation(properties.ColumnTotalOptions) : void 0), ret.addPropertyResult("rowSubtotalOptions", "RowSubtotalOptions", properties.RowSubtotalOptions != null ? CfnDashboardSubtotalOptionsPropertyFromCloudFormation(properties.RowSubtotalOptions) : void 0), ret.addPropertyResult("rowTotalOptions", "RowTotalOptions", properties.RowTotalOptions != null ? CfnDashboardPivotTotalOptionsPropertyFromCloudFormation(properties.RowTotalOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PivotTableVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnDashboard_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnDashboard_PivotTableConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("conditionalFormatting", CfnDashboard_PivotTableConditionalFormattingPropertyValidator)(properties.conditionalFormatting)), errors.collect(cdk.propertyValidator("subtitle", CfnDashboard_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnDashboard_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "PivotTableVisualProperty"');
    }
    function cfnDashboardPivotTableVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PivotTableVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnDashboardVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnDashboardPivotTableConfigurationPropertyToCloudFormation(properties.chartConfiguration), ConditionalFormatting: cfnDashboardPivotTableConditionalFormattingPropertyToCloudFormation(properties.conditionalFormatting), Subtitle: cfnDashboardVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnDashboardVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnDashboardPivotTableVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnDashboardPivotTableConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("conditionalFormatting", "ConditionalFormatting", properties.ConditionalFormatting != null ? CfnDashboardPivotTableConditionalFormattingPropertyFromCloudFormation(properties.ConditionalFormatting) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnDashboardVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnDashboardVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PivotTotalOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customLabel", cdk.validateString)(properties.customLabel)), errors.collect(cdk.propertyValidator("metricHeaderCellStyle", CfnDashboard_TableCellStylePropertyValidator)(properties.metricHeaderCellStyle)), errors.collect(cdk.propertyValidator("placement", cdk.validateString)(properties.placement)), errors.collect(cdk.propertyValidator("scrollStatus", cdk.validateString)(properties.scrollStatus)), errors.collect(cdk.propertyValidator("totalCellStyle", CfnDashboard_TableCellStylePropertyValidator)(properties.totalCellStyle)), errors.collect(cdk.propertyValidator("totalsVisibility", cdk.validateString)(properties.totalsVisibility)), errors.collect(cdk.propertyValidator("valueCellStyle", CfnDashboard_TableCellStylePropertyValidator)(properties.valueCellStyle)), errors.wrap('supplied properties not correct for "PivotTotalOptionsProperty"');
    }
    function cfnDashboardPivotTotalOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PivotTotalOptionsPropertyValidator(properties).assertSuccess(), { CustomLabel: cdk.stringToCloudFormation(properties.customLabel), MetricHeaderCellStyle: cfnDashboardTableCellStylePropertyToCloudFormation(properties.metricHeaderCellStyle), Placement: cdk.stringToCloudFormation(properties.placement), ScrollStatus: cdk.stringToCloudFormation(properties.scrollStatus), TotalCellStyle: cfnDashboardTableCellStylePropertyToCloudFormation(properties.totalCellStyle), TotalsVisibility: cdk.stringToCloudFormation(properties.totalsVisibility), ValueCellStyle: cfnDashboardTableCellStylePropertyToCloudFormation(properties.valueCellStyle) }) : properties;
    }
    function CfnDashboardPivotTotalOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customLabel", "CustomLabel", properties.CustomLabel != null ? cfn_parse.FromCloudFormation.getString(properties.CustomLabel) : void 0), ret.addPropertyResult("metricHeaderCellStyle", "MetricHeaderCellStyle", properties.MetricHeaderCellStyle != null ? CfnDashboardTableCellStylePropertyFromCloudFormation(properties.MetricHeaderCellStyle) : void 0), ret.addPropertyResult("placement", "Placement", properties.Placement != null ? cfn_parse.FromCloudFormation.getString(properties.Placement) : void 0), ret.addPropertyResult("scrollStatus", "ScrollStatus", properties.ScrollStatus != null ? cfn_parse.FromCloudFormation.getString(properties.ScrollStatus) : void 0), ret.addPropertyResult("totalCellStyle", "TotalCellStyle", properties.TotalCellStyle != null ? CfnDashboardTableCellStylePropertyFromCloudFormation(properties.TotalCellStyle) : void 0), ret.addPropertyResult("totalsVisibility", "TotalsVisibility", properties.TotalsVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.TotalsVisibility) : void 0), ret.addPropertyResult("valueCellStyle", "ValueCellStyle", properties.ValueCellStyle != null ? CfnDashboardTableCellStylePropertyFromCloudFormation(properties.ValueCellStyle) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_PredefinedHierarchyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columns", cdk.requiredValidator)(properties.columns)), errors.collect(cdk.propertyValidator("columns", cdk.listValidator(CfnDashboard_ColumnIdentifierPropertyValidator))(properties.columns)), errors.collect(cdk.propertyValidator("drillDownFilters", cdk.listValidator(CfnDashboard_DrillDownFilterPropertyValidator))(properties.drillDownFilters)), errors.collect(cdk.propertyValidator("hierarchyId", cdk.requiredValidator)(properties.hierarchyId)), errors.collect(cdk.propertyValidator("hierarchyId", cdk.validateString)(properties.hierarchyId)), errors.wrap('supplied properties not correct for "PredefinedHierarchyProperty"');
    }
    function cfnDashboardPredefinedHierarchyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_PredefinedHierarchyPropertyValidator(properties).assertSuccess(), { Columns: cdk.listMapper(cfnDashboardColumnIdentifierPropertyToCloudFormation)(properties.columns), DrillDownFilters: cdk.listMapper(cfnDashboardDrillDownFilterPropertyToCloudFormation)(properties.drillDownFilters), HierarchyId: cdk.stringToCloudFormation(properties.hierarchyId) }) : properties;
    }
    function CfnDashboardPredefinedHierarchyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columns", "Columns", cfn_parse.FromCloudFormation.getArray(CfnDashboardColumnIdentifierPropertyFromCloudFormation)(properties.Columns)), ret.addPropertyResult("drillDownFilters", "DrillDownFilters", properties.DrillDownFilters != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDrillDownFilterPropertyFromCloudFormation)(properties.DrillDownFilters) : void 0), ret.addPropertyResult("hierarchyId", "HierarchyId", cfn_parse.FromCloudFormation.getString(properties.HierarchyId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ProgressBarOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "ProgressBarOptionsProperty"');
    }
    function cfnDashboardProgressBarOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ProgressBarOptionsPropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnDashboardProgressBarOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_RadarChartAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("category", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.category)), errors.collect(cdk.propertyValidator("color", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.color)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnDashboard_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "RadarChartAggregatedFieldWellsProperty"');
    }
    function cfnDashboardRadarChartAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_RadarChartAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Category: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.category), Color: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.color), Values: cdk.listMapper(cfnDashboardMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnDashboardRadarChartAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("category", "Category", properties.Category != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.Category) : void 0), ret.addPropertyResult("color", "Color", properties.Color != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.Color) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_RadarChartAreaStyleSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "RadarChartAreaStyleSettingsProperty"');
    }
    function cfnDashboardRadarChartAreaStyleSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_RadarChartAreaStyleSettingsPropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnDashboardRadarChartAreaStyleSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_RadarChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alternateBandColorsVisibility", cdk.validateString)(properties.alternateBandColorsVisibility)), errors.collect(cdk.propertyValidator("alternateBandEvenColor", cdk.validateString)(properties.alternateBandEvenColor)), errors.collect(cdk.propertyValidator("alternateBandOddColor", cdk.validateString)(properties.alternateBandOddColor)), errors.collect(cdk.propertyValidator("baseSeriesSettings", CfnDashboard_RadarChartSeriesSettingsPropertyValidator)(properties.baseSeriesSettings)), errors.collect(cdk.propertyValidator("categoryAxis", CfnDashboard_AxisDisplayOptionsPropertyValidator)(properties.categoryAxis)), errors.collect(cdk.propertyValidator("categoryLabelOptions", CfnDashboard_ChartAxisLabelOptionsPropertyValidator)(properties.categoryLabelOptions)), errors.collect(cdk.propertyValidator("colorAxis", CfnDashboard_AxisDisplayOptionsPropertyValidator)(properties.colorAxis)), errors.collect(cdk.propertyValidator("colorLabelOptions", CfnDashboard_ChartAxisLabelOptionsPropertyValidator)(properties.colorLabelOptions)), errors.collect(cdk.propertyValidator("fieldWells", CfnDashboard_RadarChartFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("legend", CfnDashboard_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("shape", cdk.validateString)(properties.shape)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnDashboard_RadarChartSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("startAngle", cdk.validateNumber)(properties.startAngle)), errors.collect(cdk.propertyValidator("visualPalette", CfnDashboard_VisualPalettePropertyValidator)(properties.visualPalette)), errors.wrap('supplied properties not correct for "RadarChartConfigurationProperty"');
    }
    function cfnDashboardRadarChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_RadarChartConfigurationPropertyValidator(properties).assertSuccess(), { AlternateBandColorsVisibility: cdk.stringToCloudFormation(properties.alternateBandColorsVisibility), AlternateBandEvenColor: cdk.stringToCloudFormation(properties.alternateBandEvenColor), AlternateBandOddColor: cdk.stringToCloudFormation(properties.alternateBandOddColor), BaseSeriesSettings: cfnDashboardRadarChartSeriesSettingsPropertyToCloudFormation(properties.baseSeriesSettings), CategoryAxis: cfnDashboardAxisDisplayOptionsPropertyToCloudFormation(properties.categoryAxis), CategoryLabelOptions: cfnDashboardChartAxisLabelOptionsPropertyToCloudFormation(properties.categoryLabelOptions), ColorAxis: cfnDashboardAxisDisplayOptionsPropertyToCloudFormation(properties.colorAxis), ColorLabelOptions: cfnDashboardChartAxisLabelOptionsPropertyToCloudFormation(properties.colorLabelOptions), FieldWells: cfnDashboardRadarChartFieldWellsPropertyToCloudFormation(properties.fieldWells), Legend: cfnDashboardLegendOptionsPropertyToCloudFormation(properties.legend), Shape: cdk.stringToCloudFormation(properties.shape), SortConfiguration: cfnDashboardRadarChartSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), StartAngle: cdk.numberToCloudFormation(properties.startAngle), VisualPalette: cfnDashboardVisualPalettePropertyToCloudFormation(properties.visualPalette) }) : properties;
    }
    function CfnDashboardRadarChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alternateBandColorsVisibility", "AlternateBandColorsVisibility", properties.AlternateBandColorsVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.AlternateBandColorsVisibility) : void 0), ret.addPropertyResult("alternateBandEvenColor", "AlternateBandEvenColor", properties.AlternateBandEvenColor != null ? cfn_parse.FromCloudFormation.getString(properties.AlternateBandEvenColor) : void 0), ret.addPropertyResult("alternateBandOddColor", "AlternateBandOddColor", properties.AlternateBandOddColor != null ? cfn_parse.FromCloudFormation.getString(properties.AlternateBandOddColor) : void 0), ret.addPropertyResult("baseSeriesSettings", "BaseSeriesSettings", properties.BaseSeriesSettings != null ? CfnDashboardRadarChartSeriesSettingsPropertyFromCloudFormation(properties.BaseSeriesSettings) : void 0), ret.addPropertyResult("categoryAxis", "CategoryAxis", properties.CategoryAxis != null ? CfnDashboardAxisDisplayOptionsPropertyFromCloudFormation(properties.CategoryAxis) : void 0), ret.addPropertyResult("categoryLabelOptions", "CategoryLabelOptions", properties.CategoryLabelOptions != null ? CfnDashboardChartAxisLabelOptionsPropertyFromCloudFormation(properties.CategoryLabelOptions) : void 0), ret.addPropertyResult("colorAxis", "ColorAxis", properties.ColorAxis != null ? CfnDashboardAxisDisplayOptionsPropertyFromCloudFormation(properties.ColorAxis) : void 0), ret.addPropertyResult("colorLabelOptions", "ColorLabelOptions", properties.ColorLabelOptions != null ? CfnDashboardChartAxisLabelOptionsPropertyFromCloudFormation(properties.ColorLabelOptions) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnDashboardRadarChartFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnDashboardLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("shape", "Shape", properties.Shape != null ? cfn_parse.FromCloudFormation.getString(properties.Shape) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnDashboardRadarChartSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("startAngle", "StartAngle", properties.StartAngle != null ? cfn_parse.FromCloudFormation.getNumber(properties.StartAngle) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnDashboardVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_RadarChartFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("radarChartAggregatedFieldWells", CfnDashboard_RadarChartAggregatedFieldWellsPropertyValidator)(properties.radarChartAggregatedFieldWells)), errors.wrap('supplied properties not correct for "RadarChartFieldWellsProperty"');
    }
    function cfnDashboardRadarChartFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_RadarChartFieldWellsPropertyValidator(properties).assertSuccess(), { RadarChartAggregatedFieldWells: cfnDashboardRadarChartAggregatedFieldWellsPropertyToCloudFormation(properties.radarChartAggregatedFieldWells) }) : properties;
    }
    function CfnDashboardRadarChartFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("radarChartAggregatedFieldWells", "RadarChartAggregatedFieldWells", properties.RadarChartAggregatedFieldWells != null ? CfnDashboardRadarChartAggregatedFieldWellsPropertyFromCloudFormation(properties.RadarChartAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_RadarChartSeriesSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("areaStyleSettings", CfnDashboard_RadarChartAreaStyleSettingsPropertyValidator)(properties.areaStyleSettings)), errors.wrap('supplied properties not correct for "RadarChartSeriesSettingsProperty"');
    }
    function cfnDashboardRadarChartSeriesSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_RadarChartSeriesSettingsPropertyValidator(properties).assertSuccess(), { AreaStyleSettings: cfnDashboardRadarChartAreaStyleSettingsPropertyToCloudFormation(properties.areaStyleSettings) }) : properties;
    }
    function CfnDashboardRadarChartSeriesSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("areaStyleSettings", "AreaStyleSettings", properties.AreaStyleSettings != null ? CfnDashboardRadarChartAreaStyleSettingsPropertyFromCloudFormation(properties.AreaStyleSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_RadarChartSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryItemsLimit", CfnDashboard_ItemsLimitConfigurationPropertyValidator)(properties.categoryItemsLimit)), errors.collect(cdk.propertyValidator("categorySort", cdk.listValidator(CfnDashboard_FieldSortOptionsPropertyValidator))(properties.categorySort)), errors.collect(cdk.propertyValidator("colorItemsLimit", CfnDashboard_ItemsLimitConfigurationPropertyValidator)(properties.colorItemsLimit)), errors.collect(cdk.propertyValidator("colorSort", cdk.listValidator(CfnDashboard_FieldSortOptionsPropertyValidator))(properties.colorSort)), errors.wrap('supplied properties not correct for "RadarChartSortConfigurationProperty"');
    }
    function cfnDashboardRadarChartSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_RadarChartSortConfigurationPropertyValidator(properties).assertSuccess(), { CategoryItemsLimit: cfnDashboardItemsLimitConfigurationPropertyToCloudFormation(properties.categoryItemsLimit), CategorySort: cdk.listMapper(cfnDashboardFieldSortOptionsPropertyToCloudFormation)(properties.categorySort), ColorItemsLimit: cfnDashboardItemsLimitConfigurationPropertyToCloudFormation(properties.colorItemsLimit), ColorSort: cdk.listMapper(cfnDashboardFieldSortOptionsPropertyToCloudFormation)(properties.colorSort) }) : properties;
    }
    function CfnDashboardRadarChartSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryItemsLimit", "CategoryItemsLimit", properties.CategoryItemsLimit != null ? CfnDashboardItemsLimitConfigurationPropertyFromCloudFormation(properties.CategoryItemsLimit) : void 0), ret.addPropertyResult("categorySort", "CategorySort", properties.CategorySort != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardFieldSortOptionsPropertyFromCloudFormation)(properties.CategorySort) : void 0), ret.addPropertyResult("colorItemsLimit", "ColorItemsLimit", properties.ColorItemsLimit != null ? CfnDashboardItemsLimitConfigurationPropertyFromCloudFormation(properties.ColorItemsLimit) : void 0), ret.addPropertyResult("colorSort", "ColorSort", properties.ColorSort != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardFieldSortOptionsPropertyFromCloudFormation)(properties.ColorSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_RadarChartVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnDashboard_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnDashboard_RadarChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnDashboard_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnDashboard_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnDashboard_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "RadarChartVisualProperty"');
    }
    function cfnDashboardRadarChartVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_RadarChartVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnDashboardVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnDashboardRadarChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnDashboardColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnDashboardVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnDashboardVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnDashboardRadarChartVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnDashboardRadarChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnDashboardVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnDashboardVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_RangeEndsLabelTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "RangeEndsLabelTypeProperty"');
    }
    function cfnDashboardRangeEndsLabelTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_RangeEndsLabelTypePropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnDashboardRangeEndsLabelTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ReferenceLinePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataConfiguration", cdk.requiredValidator)(properties.dataConfiguration)), errors.collect(cdk.propertyValidator("dataConfiguration", CfnDashboard_ReferenceLineDataConfigurationPropertyValidator)(properties.dataConfiguration)), errors.collect(cdk.propertyValidator("labelConfiguration", CfnDashboard_ReferenceLineLabelConfigurationPropertyValidator)(properties.labelConfiguration)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.collect(cdk.propertyValidator("styleConfiguration", CfnDashboard_ReferenceLineStyleConfigurationPropertyValidator)(properties.styleConfiguration)), errors.wrap('supplied properties not correct for "ReferenceLineProperty"');
    }
    function cfnDashboardReferenceLinePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ReferenceLinePropertyValidator(properties).assertSuccess(), { DataConfiguration: cfnDashboardReferenceLineDataConfigurationPropertyToCloudFormation(properties.dataConfiguration), LabelConfiguration: cfnDashboardReferenceLineLabelConfigurationPropertyToCloudFormation(properties.labelConfiguration), Status: cdk.stringToCloudFormation(properties.status), StyleConfiguration: cfnDashboardReferenceLineStyleConfigurationPropertyToCloudFormation(properties.styleConfiguration) }) : properties;
    }
    function CfnDashboardReferenceLinePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataConfiguration", "DataConfiguration", CfnDashboardReferenceLineDataConfigurationPropertyFromCloudFormation(properties.DataConfiguration)), ret.addPropertyResult("labelConfiguration", "LabelConfiguration", properties.LabelConfiguration != null ? CfnDashboardReferenceLineLabelConfigurationPropertyFromCloudFormation(properties.LabelConfiguration) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addPropertyResult("styleConfiguration", "StyleConfiguration", properties.StyleConfiguration != null ? CfnDashboardReferenceLineStyleConfigurationPropertyFromCloudFormation(properties.StyleConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ReferenceLineCustomLabelConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customLabel", cdk.requiredValidator)(properties.customLabel)), errors.collect(cdk.propertyValidator("customLabel", cdk.validateString)(properties.customLabel)), errors.wrap('supplied properties not correct for "ReferenceLineCustomLabelConfigurationProperty"');
    }
    function cfnDashboardReferenceLineCustomLabelConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ReferenceLineCustomLabelConfigurationPropertyValidator(properties).assertSuccess(), { CustomLabel: cdk.stringToCloudFormation(properties.customLabel) }) : properties;
    }
    function CfnDashboardReferenceLineCustomLabelConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customLabel", "CustomLabel", cfn_parse.FromCloudFormation.getString(properties.CustomLabel)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ReferenceLineDataConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("axisBinding", cdk.validateString)(properties.axisBinding)), errors.collect(cdk.propertyValidator("dynamicConfiguration", CfnDashboard_ReferenceLineDynamicDataConfigurationPropertyValidator)(properties.dynamicConfiguration)), errors.collect(cdk.propertyValidator("staticConfiguration", CfnDashboard_ReferenceLineStaticDataConfigurationPropertyValidator)(properties.staticConfiguration)), errors.wrap('supplied properties not correct for "ReferenceLineDataConfigurationProperty"');
    }
    function cfnDashboardReferenceLineDataConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ReferenceLineDataConfigurationPropertyValidator(properties).assertSuccess(), { AxisBinding: cdk.stringToCloudFormation(properties.axisBinding), DynamicConfiguration: cfnDashboardReferenceLineDynamicDataConfigurationPropertyToCloudFormation(properties.dynamicConfiguration), StaticConfiguration: cfnDashboardReferenceLineStaticDataConfigurationPropertyToCloudFormation(properties.staticConfiguration) }) : properties;
    }
    function CfnDashboardReferenceLineDataConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("axisBinding", "AxisBinding", properties.AxisBinding != null ? cfn_parse.FromCloudFormation.getString(properties.AxisBinding) : void 0), ret.addPropertyResult("dynamicConfiguration", "DynamicConfiguration", properties.DynamicConfiguration != null ? CfnDashboardReferenceLineDynamicDataConfigurationPropertyFromCloudFormation(properties.DynamicConfiguration) : void 0), ret.addPropertyResult("staticConfiguration", "StaticConfiguration", properties.StaticConfiguration != null ? CfnDashboardReferenceLineStaticDataConfigurationPropertyFromCloudFormation(properties.StaticConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ReferenceLineDynamicDataConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("calculation", cdk.requiredValidator)(properties.calculation)), errors.collect(cdk.propertyValidator("calculation", CfnDashboard_NumericalAggregationFunctionPropertyValidator)(properties.calculation)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnDashboard_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("measureAggregationFunction", cdk.requiredValidator)(properties.measureAggregationFunction)), errors.collect(cdk.propertyValidator("measureAggregationFunction", CfnDashboard_AggregationFunctionPropertyValidator)(properties.measureAggregationFunction)), errors.wrap('supplied properties not correct for "ReferenceLineDynamicDataConfigurationProperty"');
    }
    function cfnDashboardReferenceLineDynamicDataConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ReferenceLineDynamicDataConfigurationPropertyValidator(properties).assertSuccess(), { Calculation: cfnDashboardNumericalAggregationFunctionPropertyToCloudFormation(properties.calculation), Column: cfnDashboardColumnIdentifierPropertyToCloudFormation(properties.column), MeasureAggregationFunction: cfnDashboardAggregationFunctionPropertyToCloudFormation(properties.measureAggregationFunction) }) : properties;
    }
    function CfnDashboardReferenceLineDynamicDataConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("calculation", "Calculation", CfnDashboardNumericalAggregationFunctionPropertyFromCloudFormation(properties.Calculation)), ret.addPropertyResult("column", "Column", CfnDashboardColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("measureAggregationFunction", "MeasureAggregationFunction", CfnDashboardAggregationFunctionPropertyFromCloudFormation(properties.MeasureAggregationFunction)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ReferenceLineLabelConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customLabelConfiguration", CfnDashboard_ReferenceLineCustomLabelConfigurationPropertyValidator)(properties.customLabelConfiguration)), errors.collect(cdk.propertyValidator("fontColor", cdk.validateString)(properties.fontColor)), errors.collect(cdk.propertyValidator("fontConfiguration", CfnDashboard_FontConfigurationPropertyValidator)(properties.fontConfiguration)), errors.collect(cdk.propertyValidator("horizontalPosition", cdk.validateString)(properties.horizontalPosition)), errors.collect(cdk.propertyValidator("valueLabelConfiguration", CfnDashboard_ReferenceLineValueLabelConfigurationPropertyValidator)(properties.valueLabelConfiguration)), errors.collect(cdk.propertyValidator("verticalPosition", cdk.validateString)(properties.verticalPosition)), errors.wrap('supplied properties not correct for "ReferenceLineLabelConfigurationProperty"');
    }
    function cfnDashboardReferenceLineLabelConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ReferenceLineLabelConfigurationPropertyValidator(properties).assertSuccess(), { CustomLabelConfiguration: cfnDashboardReferenceLineCustomLabelConfigurationPropertyToCloudFormation(properties.customLabelConfiguration), FontColor: cdk.stringToCloudFormation(properties.fontColor), FontConfiguration: cfnDashboardFontConfigurationPropertyToCloudFormation(properties.fontConfiguration), HorizontalPosition: cdk.stringToCloudFormation(properties.horizontalPosition), ValueLabelConfiguration: cfnDashboardReferenceLineValueLabelConfigurationPropertyToCloudFormation(properties.valueLabelConfiguration), VerticalPosition: cdk.stringToCloudFormation(properties.verticalPosition) }) : properties;
    }
    function CfnDashboardReferenceLineLabelConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customLabelConfiguration", "CustomLabelConfiguration", properties.CustomLabelConfiguration != null ? CfnDashboardReferenceLineCustomLabelConfigurationPropertyFromCloudFormation(properties.CustomLabelConfiguration) : void 0), ret.addPropertyResult("fontColor", "FontColor", properties.FontColor != null ? cfn_parse.FromCloudFormation.getString(properties.FontColor) : void 0), ret.addPropertyResult("fontConfiguration", "FontConfiguration", properties.FontConfiguration != null ? CfnDashboardFontConfigurationPropertyFromCloudFormation(properties.FontConfiguration) : void 0), ret.addPropertyResult("horizontalPosition", "HorizontalPosition", properties.HorizontalPosition != null ? cfn_parse.FromCloudFormation.getString(properties.HorizontalPosition) : void 0), ret.addPropertyResult("valueLabelConfiguration", "ValueLabelConfiguration", properties.ValueLabelConfiguration != null ? CfnDashboardReferenceLineValueLabelConfigurationPropertyFromCloudFormation(properties.ValueLabelConfiguration) : void 0), ret.addPropertyResult("verticalPosition", "VerticalPosition", properties.VerticalPosition != null ? cfn_parse.FromCloudFormation.getString(properties.VerticalPosition) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ReferenceLineStaticDataConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "ReferenceLineStaticDataConfigurationProperty"');
    }
    function cfnDashboardReferenceLineStaticDataConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ReferenceLineStaticDataConfigurationPropertyValidator(properties).assertSuccess(), { Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnDashboardReferenceLineStaticDataConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getNumber(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ReferenceLineStyleConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.collect(cdk.propertyValidator("pattern", cdk.validateString)(properties.pattern)), errors.wrap('supplied properties not correct for "ReferenceLineStyleConfigurationProperty"');
    }
    function cfnDashboardReferenceLineStyleConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ReferenceLineStyleConfigurationPropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color), Pattern: cdk.stringToCloudFormation(properties.pattern) }) : properties;
    }
    function CfnDashboardReferenceLineStyleConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", properties.Color != null ? cfn_parse.FromCloudFormation.getString(properties.Color) : void 0), ret.addPropertyResult("pattern", "Pattern", properties.Pattern != null ? cfn_parse.FromCloudFormation.getString(properties.Pattern) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ReferenceLineValueLabelConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("formatConfiguration", CfnDashboard_NumericFormatConfigurationPropertyValidator)(properties.formatConfiguration)), errors.collect(cdk.propertyValidator("relativePosition", cdk.validateString)(properties.relativePosition)), errors.wrap('supplied properties not correct for "ReferenceLineValueLabelConfigurationProperty"');
    }
    function cfnDashboardReferenceLineValueLabelConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ReferenceLineValueLabelConfigurationPropertyValidator(properties).assertSuccess(), { FormatConfiguration: cfnDashboardNumericFormatConfigurationPropertyToCloudFormation(properties.formatConfiguration), RelativePosition: cdk.stringToCloudFormation(properties.relativePosition) }) : properties;
    }
    function CfnDashboardReferenceLineValueLabelConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("formatConfiguration", "FormatConfiguration", properties.FormatConfiguration != null ? CfnDashboardNumericFormatConfigurationPropertyFromCloudFormation(properties.FormatConfiguration) : void 0), ret.addPropertyResult("relativePosition", "RelativePosition", properties.RelativePosition != null ? cfn_parse.FromCloudFormation.getString(properties.RelativePosition) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_RelativeDateTimeControlDisplayOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateTimeFormat", cdk.validateString)(properties.dateTimeFormat)), errors.collect(cdk.propertyValidator("titleOptions", CfnDashboard_LabelOptionsPropertyValidator)(properties.titleOptions)), errors.wrap('supplied properties not correct for "RelativeDateTimeControlDisplayOptionsProperty"');
    }
    function cfnDashboardRelativeDateTimeControlDisplayOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_RelativeDateTimeControlDisplayOptionsPropertyValidator(properties).assertSuccess(), { DateTimeFormat: cdk.stringToCloudFormation(properties.dateTimeFormat), TitleOptions: cfnDashboardLabelOptionsPropertyToCloudFormation(properties.titleOptions) }) : properties;
    }
    function CfnDashboardRelativeDateTimeControlDisplayOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateTimeFormat", "DateTimeFormat", properties.DateTimeFormat != null ? cfn_parse.FromCloudFormation.getString(properties.DateTimeFormat) : void 0), ret.addPropertyResult("titleOptions", "TitleOptions", properties.TitleOptions != null ? CfnDashboardLabelOptionsPropertyFromCloudFormation(properties.TitleOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_RelativeDatesFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("anchorDateConfiguration", cdk.requiredValidator)(properties.anchorDateConfiguration)), errors.collect(cdk.propertyValidator("anchorDateConfiguration", CfnDashboard_AnchorDateConfigurationPropertyValidator)(properties.anchorDateConfiguration)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnDashboard_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("excludePeriodConfiguration", CfnDashboard_ExcludePeriodConfigurationPropertyValidator)(properties.excludePeriodConfiguration)), errors.collect(cdk.propertyValidator("filterId", cdk.requiredValidator)(properties.filterId)), errors.collect(cdk.propertyValidator("filterId", cdk.validateString)(properties.filterId)), errors.collect(cdk.propertyValidator("minimumGranularity", cdk.validateString)(properties.minimumGranularity)), errors.collect(cdk.propertyValidator("nullOption", cdk.requiredValidator)(properties.nullOption)), errors.collect(cdk.propertyValidator("nullOption", cdk.validateString)(properties.nullOption)), errors.collect(cdk.propertyValidator("parameterName", cdk.validateString)(properties.parameterName)), errors.collect(cdk.propertyValidator("relativeDateType", cdk.requiredValidator)(properties.relativeDateType)), errors.collect(cdk.propertyValidator("relativeDateType", cdk.validateString)(properties.relativeDateType)), errors.collect(cdk.propertyValidator("relativeDateValue", cdk.validateNumber)(properties.relativeDateValue)), errors.collect(cdk.propertyValidator("timeGranularity", cdk.requiredValidator)(properties.timeGranularity)), errors.collect(cdk.propertyValidator("timeGranularity", cdk.validateString)(properties.timeGranularity)), errors.wrap('supplied properties not correct for "RelativeDatesFilterProperty"');
    }
    function cfnDashboardRelativeDatesFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_RelativeDatesFilterPropertyValidator(properties).assertSuccess(), { AnchorDateConfiguration: cfnDashboardAnchorDateConfigurationPropertyToCloudFormation(properties.anchorDateConfiguration), Column: cfnDashboardColumnIdentifierPropertyToCloudFormation(properties.column), ExcludePeriodConfiguration: cfnDashboardExcludePeriodConfigurationPropertyToCloudFormation(properties.excludePeriodConfiguration), FilterId: cdk.stringToCloudFormation(properties.filterId), MinimumGranularity: cdk.stringToCloudFormation(properties.minimumGranularity), NullOption: cdk.stringToCloudFormation(properties.nullOption), ParameterName: cdk.stringToCloudFormation(properties.parameterName), RelativeDateType: cdk.stringToCloudFormation(properties.relativeDateType), RelativeDateValue: cdk.numberToCloudFormation(properties.relativeDateValue), TimeGranularity: cdk.stringToCloudFormation(properties.timeGranularity) }) : properties;
    }
    function CfnDashboardRelativeDatesFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("anchorDateConfiguration", "AnchorDateConfiguration", CfnDashboardAnchorDateConfigurationPropertyFromCloudFormation(properties.AnchorDateConfiguration)), ret.addPropertyResult("column", "Column", CfnDashboardColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("excludePeriodConfiguration", "ExcludePeriodConfiguration", properties.ExcludePeriodConfiguration != null ? CfnDashboardExcludePeriodConfigurationPropertyFromCloudFormation(properties.ExcludePeriodConfiguration) : void 0), ret.addPropertyResult("filterId", "FilterId", cfn_parse.FromCloudFormation.getString(properties.FilterId)), ret.addPropertyResult("minimumGranularity", "MinimumGranularity", properties.MinimumGranularity != null ? cfn_parse.FromCloudFormation.getString(properties.MinimumGranularity) : void 0), ret.addPropertyResult("nullOption", "NullOption", cfn_parse.FromCloudFormation.getString(properties.NullOption)), ret.addPropertyResult("parameterName", "ParameterName", properties.ParameterName != null ? cfn_parse.FromCloudFormation.getString(properties.ParameterName) : void 0), ret.addPropertyResult("relativeDateType", "RelativeDateType", cfn_parse.FromCloudFormation.getString(properties.RelativeDateType)), ret.addPropertyResult("relativeDateValue", "RelativeDateValue", properties.RelativeDateValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.RelativeDateValue) : void 0), ret.addPropertyResult("timeGranularity", "TimeGranularity", cfn_parse.FromCloudFormation.getString(properties.TimeGranularity)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ResourcePermissionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.requiredValidator)(properties.actions)), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(cdk.validateString))(properties.actions)), errors.collect(cdk.propertyValidator("principal", cdk.requiredValidator)(properties.principal)), errors.collect(cdk.propertyValidator("principal", cdk.validateString)(properties.principal)), errors.collect(cdk.propertyValidator("resource", cdk.validateString)(properties.resource)), errors.wrap('supplied properties not correct for "ResourcePermissionProperty"');
    }
    function cfnDashboardResourcePermissionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ResourcePermissionPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cdk.stringToCloudFormation)(properties.actions), Principal: cdk.stringToCloudFormation(properties.principal), Resource: cdk.stringToCloudFormation(properties.resource) }) : properties;
    }
    function CfnDashboardResourcePermissionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", cfn_parse.FromCloudFormation.getStringArray(properties.Actions)), ret.addPropertyResult("principal", "Principal", cfn_parse.FromCloudFormation.getString(properties.Principal)), ret.addPropertyResult("resource", "Resource", properties.Resource != null ? cfn_parse.FromCloudFormation.getString(properties.Resource) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_RollingDateConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.validateString)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.wrap('supplied properties not correct for "RollingDateConfigurationProperty"');
    }
    function cfnDashboardRollingDateConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_RollingDateConfigurationPropertyValidator(properties).assertSuccess(), { DataSetIdentifier: cdk.stringToCloudFormation(properties.dataSetIdentifier), Expression: cdk.stringToCloudFormation(properties.expression) }) : properties;
    }
    function CfnDashboardRollingDateConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataSetIdentifier", "DataSetIdentifier", properties.DataSetIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.DataSetIdentifier) : void 0), ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getString(properties.Expression)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_RowAlternateColorOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("rowAlternateColors", cdk.listValidator(cdk.validateString))(properties.rowAlternateColors)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "RowAlternateColorOptionsProperty"');
    }
    function cfnDashboardRowAlternateColorOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_RowAlternateColorOptionsPropertyValidator(properties).assertSuccess(), { RowAlternateColors: cdk.listMapper(cdk.stringToCloudFormation)(properties.rowAlternateColors), Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnDashboardRowAlternateColorOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("rowAlternateColors", "RowAlternateColors", properties.RowAlternateColors != null ? cfn_parse.FromCloudFormation.getStringArray(properties.RowAlternateColors) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_SameSheetTargetVisualConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("targetVisualOptions", cdk.validateString)(properties.targetVisualOptions)), errors.collect(cdk.propertyValidator("targetVisuals", cdk.listValidator(cdk.validateString))(properties.targetVisuals)), errors.wrap('supplied properties not correct for "SameSheetTargetVisualConfigurationProperty"');
    }
    function cfnDashboardSameSheetTargetVisualConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_SameSheetTargetVisualConfigurationPropertyValidator(properties).assertSuccess(), { TargetVisualOptions: cdk.stringToCloudFormation(properties.targetVisualOptions), TargetVisuals: cdk.listMapper(cdk.stringToCloudFormation)(properties.targetVisuals) }) : properties;
    }
    function CfnDashboardSameSheetTargetVisualConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("targetVisualOptions", "TargetVisualOptions", properties.TargetVisualOptions != null ? cfn_parse.FromCloudFormation.getString(properties.TargetVisualOptions) : void 0), ret.addPropertyResult("targetVisuals", "TargetVisuals", properties.TargetVisuals != null ? cfn_parse.FromCloudFormation.getStringArray(properties.TargetVisuals) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_SankeyDiagramAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destination", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.destination)), errors.collect(cdk.propertyValidator("source", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.source)), errors.collect(cdk.propertyValidator("weight", cdk.listValidator(CfnDashboard_MeasureFieldPropertyValidator))(properties.weight)), errors.wrap('supplied properties not correct for "SankeyDiagramAggregatedFieldWellsProperty"');
    }
    function cfnDashboardSankeyDiagramAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_SankeyDiagramAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Destination: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.destination), Source: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.source), Weight: cdk.listMapper(cfnDashboardMeasureFieldPropertyToCloudFormation)(properties.weight) }) : properties;
    }
    function CfnDashboardSankeyDiagramAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destination", "Destination", properties.Destination != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.Destination) : void 0), ret.addPropertyResult("source", "Source", properties.Source != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.Source) : void 0), ret.addPropertyResult("weight", "Weight", properties.Weight != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMeasureFieldPropertyFromCloudFormation)(properties.Weight) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_SankeyDiagramChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataLabels", CfnDashboard_DataLabelOptionsPropertyValidator)(properties.dataLabels)), errors.collect(cdk.propertyValidator("fieldWells", CfnDashboard_SankeyDiagramFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnDashboard_SankeyDiagramSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.wrap('supplied properties not correct for "SankeyDiagramChartConfigurationProperty"');
    }
    function cfnDashboardSankeyDiagramChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_SankeyDiagramChartConfigurationPropertyValidator(properties).assertSuccess(), { DataLabels: cfnDashboardDataLabelOptionsPropertyToCloudFormation(properties.dataLabels), FieldWells: cfnDashboardSankeyDiagramFieldWellsPropertyToCloudFormation(properties.fieldWells), SortConfiguration: cfnDashboardSankeyDiagramSortConfigurationPropertyToCloudFormation(properties.sortConfiguration) }) : properties;
    }
    function CfnDashboardSankeyDiagramChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataLabels", "DataLabels", properties.DataLabels != null ? CfnDashboardDataLabelOptionsPropertyFromCloudFormation(properties.DataLabels) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnDashboardSankeyDiagramFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnDashboardSankeyDiagramSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_SankeyDiagramFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sankeyDiagramAggregatedFieldWells", CfnDashboard_SankeyDiagramAggregatedFieldWellsPropertyValidator)(properties.sankeyDiagramAggregatedFieldWells)), errors.wrap('supplied properties not correct for "SankeyDiagramFieldWellsProperty"');
    }
    function cfnDashboardSankeyDiagramFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_SankeyDiagramFieldWellsPropertyValidator(properties).assertSuccess(), { SankeyDiagramAggregatedFieldWells: cfnDashboardSankeyDiagramAggregatedFieldWellsPropertyToCloudFormation(properties.sankeyDiagramAggregatedFieldWells) }) : properties;
    }
    function CfnDashboardSankeyDiagramFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sankeyDiagramAggregatedFieldWells", "SankeyDiagramAggregatedFieldWells", properties.SankeyDiagramAggregatedFieldWells != null ? CfnDashboardSankeyDiagramAggregatedFieldWellsPropertyFromCloudFormation(properties.SankeyDiagramAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_SankeyDiagramSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationItemsLimit", CfnDashboard_ItemsLimitConfigurationPropertyValidator)(properties.destinationItemsLimit)), errors.collect(cdk.propertyValidator("sourceItemsLimit", CfnDashboard_ItemsLimitConfigurationPropertyValidator)(properties.sourceItemsLimit)), errors.collect(cdk.propertyValidator("weightSort", cdk.listValidator(CfnDashboard_FieldSortOptionsPropertyValidator))(properties.weightSort)), errors.wrap('supplied properties not correct for "SankeyDiagramSortConfigurationProperty"');
    }
    function cfnDashboardSankeyDiagramSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_SankeyDiagramSortConfigurationPropertyValidator(properties).assertSuccess(), { DestinationItemsLimit: cfnDashboardItemsLimitConfigurationPropertyToCloudFormation(properties.destinationItemsLimit), SourceItemsLimit: cfnDashboardItemsLimitConfigurationPropertyToCloudFormation(properties.sourceItemsLimit), WeightSort: cdk.listMapper(cfnDashboardFieldSortOptionsPropertyToCloudFormation)(properties.weightSort) }) : properties;
    }
    function CfnDashboardSankeyDiagramSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationItemsLimit", "DestinationItemsLimit", properties.DestinationItemsLimit != null ? CfnDashboardItemsLimitConfigurationPropertyFromCloudFormation(properties.DestinationItemsLimit) : void 0), ret.addPropertyResult("sourceItemsLimit", "SourceItemsLimit", properties.SourceItemsLimit != null ? CfnDashboardItemsLimitConfigurationPropertyFromCloudFormation(properties.SourceItemsLimit) : void 0), ret.addPropertyResult("weightSort", "WeightSort", properties.WeightSort != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardFieldSortOptionsPropertyFromCloudFormation)(properties.WeightSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_SankeyDiagramVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnDashboard_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnDashboard_SankeyDiagramChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("subtitle", CfnDashboard_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnDashboard_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "SankeyDiagramVisualProperty"');
    }
    function cfnDashboardSankeyDiagramVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_SankeyDiagramVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnDashboardVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnDashboardSankeyDiagramChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), Subtitle: cfnDashboardVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnDashboardVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnDashboardSankeyDiagramVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnDashboardSankeyDiagramChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnDashboardVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnDashboardVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ScatterPlotCategoricallyAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("category", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.category)), errors.collect(cdk.propertyValidator("size", cdk.listValidator(CfnDashboard_MeasureFieldPropertyValidator))(properties.size)), errors.collect(cdk.propertyValidator("xAxis", cdk.listValidator(CfnDashboard_MeasureFieldPropertyValidator))(properties.xAxis)), errors.collect(cdk.propertyValidator("yAxis", cdk.listValidator(CfnDashboard_MeasureFieldPropertyValidator))(properties.yAxis)), errors.wrap('supplied properties not correct for "ScatterPlotCategoricallyAggregatedFieldWellsProperty"');
    }
    function cfnDashboardScatterPlotCategoricallyAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ScatterPlotCategoricallyAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Category: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.category), Size: cdk.listMapper(cfnDashboardMeasureFieldPropertyToCloudFormation)(properties.size), XAxis: cdk.listMapper(cfnDashboardMeasureFieldPropertyToCloudFormation)(properties.xAxis), YAxis: cdk.listMapper(cfnDashboardMeasureFieldPropertyToCloudFormation)(properties.yAxis) }) : properties;
    }
    function CfnDashboardScatterPlotCategoricallyAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("category", "Category", properties.Category != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.Category) : void 0), ret.addPropertyResult("size", "Size", properties.Size != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMeasureFieldPropertyFromCloudFormation)(properties.Size) : void 0), ret.addPropertyResult("xAxis", "XAxis", properties.XAxis != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMeasureFieldPropertyFromCloudFormation)(properties.XAxis) : void 0), ret.addPropertyResult("yAxis", "YAxis", properties.YAxis != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMeasureFieldPropertyFromCloudFormation)(properties.YAxis) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ScatterPlotConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataLabels", CfnDashboard_DataLabelOptionsPropertyValidator)(properties.dataLabels)), errors.collect(cdk.propertyValidator("fieldWells", CfnDashboard_ScatterPlotFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("legend", CfnDashboard_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("tooltip", CfnDashboard_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.collect(cdk.propertyValidator("visualPalette", CfnDashboard_VisualPalettePropertyValidator)(properties.visualPalette)), errors.collect(cdk.propertyValidator("xAxisDisplayOptions", CfnDashboard_AxisDisplayOptionsPropertyValidator)(properties.xAxisDisplayOptions)), errors.collect(cdk.propertyValidator("xAxisLabelOptions", CfnDashboard_ChartAxisLabelOptionsPropertyValidator)(properties.xAxisLabelOptions)), errors.collect(cdk.propertyValidator("yAxisDisplayOptions", CfnDashboard_AxisDisplayOptionsPropertyValidator)(properties.yAxisDisplayOptions)), errors.collect(cdk.propertyValidator("yAxisLabelOptions", CfnDashboard_ChartAxisLabelOptionsPropertyValidator)(properties.yAxisLabelOptions)), errors.wrap('supplied properties not correct for "ScatterPlotConfigurationProperty"');
    }
    function cfnDashboardScatterPlotConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ScatterPlotConfigurationPropertyValidator(properties).assertSuccess(), { DataLabels: cfnDashboardDataLabelOptionsPropertyToCloudFormation(properties.dataLabels), FieldWells: cfnDashboardScatterPlotFieldWellsPropertyToCloudFormation(properties.fieldWells), Legend: cfnDashboardLegendOptionsPropertyToCloudFormation(properties.legend), Tooltip: cfnDashboardTooltipOptionsPropertyToCloudFormation(properties.tooltip), VisualPalette: cfnDashboardVisualPalettePropertyToCloudFormation(properties.visualPalette), XAxisDisplayOptions: cfnDashboardAxisDisplayOptionsPropertyToCloudFormation(properties.xAxisDisplayOptions), XAxisLabelOptions: cfnDashboardChartAxisLabelOptionsPropertyToCloudFormation(properties.xAxisLabelOptions), YAxisDisplayOptions: cfnDashboardAxisDisplayOptionsPropertyToCloudFormation(properties.yAxisDisplayOptions), YAxisLabelOptions: cfnDashboardChartAxisLabelOptionsPropertyToCloudFormation(properties.yAxisLabelOptions) }) : properties;
    }
    function CfnDashboardScatterPlotConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataLabels", "DataLabels", properties.DataLabels != null ? CfnDashboardDataLabelOptionsPropertyFromCloudFormation(properties.DataLabels) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnDashboardScatterPlotFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnDashboardLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnDashboardTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnDashboardVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addPropertyResult("xAxisDisplayOptions", "XAxisDisplayOptions", properties.XAxisDisplayOptions != null ? CfnDashboardAxisDisplayOptionsPropertyFromCloudFormation(properties.XAxisDisplayOptions) : void 0), ret.addPropertyResult("xAxisLabelOptions", "XAxisLabelOptions", properties.XAxisLabelOptions != null ? CfnDashboardChartAxisLabelOptionsPropertyFromCloudFormation(properties.XAxisLabelOptions) : void 0), ret.addPropertyResult("yAxisDisplayOptions", "YAxisDisplayOptions", properties.YAxisDisplayOptions != null ? CfnDashboardAxisDisplayOptionsPropertyFromCloudFormation(properties.YAxisDisplayOptions) : void 0), ret.addPropertyResult("yAxisLabelOptions", "YAxisLabelOptions", properties.YAxisLabelOptions != null ? CfnDashboardChartAxisLabelOptionsPropertyFromCloudFormation(properties.YAxisLabelOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ScatterPlotFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("scatterPlotCategoricallyAggregatedFieldWells", CfnDashboard_ScatterPlotCategoricallyAggregatedFieldWellsPropertyValidator)(properties.scatterPlotCategoricallyAggregatedFieldWells)), errors.collect(cdk.propertyValidator("scatterPlotUnaggregatedFieldWells", CfnDashboard_ScatterPlotUnaggregatedFieldWellsPropertyValidator)(properties.scatterPlotUnaggregatedFieldWells)), errors.wrap('supplied properties not correct for "ScatterPlotFieldWellsProperty"');
    }
    function cfnDashboardScatterPlotFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ScatterPlotFieldWellsPropertyValidator(properties).assertSuccess(), { ScatterPlotCategoricallyAggregatedFieldWells: cfnDashboardScatterPlotCategoricallyAggregatedFieldWellsPropertyToCloudFormation(properties.scatterPlotCategoricallyAggregatedFieldWells), ScatterPlotUnaggregatedFieldWells: cfnDashboardScatterPlotUnaggregatedFieldWellsPropertyToCloudFormation(properties.scatterPlotUnaggregatedFieldWells) }) : properties;
    }
    function CfnDashboardScatterPlotFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("scatterPlotCategoricallyAggregatedFieldWells", "ScatterPlotCategoricallyAggregatedFieldWells", properties.ScatterPlotCategoricallyAggregatedFieldWells != null ? CfnDashboardScatterPlotCategoricallyAggregatedFieldWellsPropertyFromCloudFormation(properties.ScatterPlotCategoricallyAggregatedFieldWells) : void 0), ret.addPropertyResult("scatterPlotUnaggregatedFieldWells", "ScatterPlotUnaggregatedFieldWells", properties.ScatterPlotUnaggregatedFieldWells != null ? CfnDashboardScatterPlotUnaggregatedFieldWellsPropertyFromCloudFormation(properties.ScatterPlotUnaggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ScatterPlotUnaggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("size", cdk.listValidator(CfnDashboard_MeasureFieldPropertyValidator))(properties.size)), errors.collect(cdk.propertyValidator("xAxis", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.xAxis)), errors.collect(cdk.propertyValidator("yAxis", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.yAxis)), errors.wrap('supplied properties not correct for "ScatterPlotUnaggregatedFieldWellsProperty"');
    }
    function cfnDashboardScatterPlotUnaggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ScatterPlotUnaggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Size: cdk.listMapper(cfnDashboardMeasureFieldPropertyToCloudFormation)(properties.size), XAxis: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.xAxis), YAxis: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.yAxis) }) : properties;
    }
    function CfnDashboardScatterPlotUnaggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("size", "Size", properties.Size != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMeasureFieldPropertyFromCloudFormation)(properties.Size) : void 0), ret.addPropertyResult("xAxis", "XAxis", properties.XAxis != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.XAxis) : void 0), ret.addPropertyResult("yAxis", "YAxis", properties.YAxis != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.YAxis) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ScatterPlotVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnDashboard_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnDashboard_ScatterPlotConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnDashboard_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnDashboard_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnDashboard_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "ScatterPlotVisualProperty"');
    }
    function cfnDashboardScatterPlotVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ScatterPlotVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnDashboardVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnDashboardScatterPlotConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnDashboardColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnDashboardVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnDashboardVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnDashboardScatterPlotVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnDashboardScatterPlotConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnDashboardVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnDashboardVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ScrollBarOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.collect(cdk.propertyValidator("visibleRange", CfnDashboard_VisibleRangeOptionsPropertyValidator)(properties.visibleRange)), errors.wrap('supplied properties not correct for "ScrollBarOptionsProperty"');
    }
    function cfnDashboardScrollBarOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ScrollBarOptionsPropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility), VisibleRange: cfnDashboardVisibleRangeOptionsPropertyToCloudFormation(properties.visibleRange) }) : properties;
    }
    function CfnDashboardScrollBarOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addPropertyResult("visibleRange", "VisibleRange", properties.VisibleRange != null ? CfnDashboardVisibleRangeOptionsPropertyFromCloudFormation(properties.VisibleRange) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_SecondaryValueOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "SecondaryValueOptionsProperty"');
    }
    function cfnDashboardSecondaryValueOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_SecondaryValueOptionsPropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnDashboardSecondaryValueOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_SectionAfterPageBreakPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "SectionAfterPageBreakProperty"');
    }
    function cfnDashboardSectionAfterPageBreakPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_SectionAfterPageBreakPropertyValidator(properties).assertSuccess(), { Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnDashboardSectionAfterPageBreakPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_SectionBasedLayoutCanvasSizeOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("paperCanvasSizeOptions", CfnDashboard_SectionBasedLayoutPaperCanvasSizeOptionsPropertyValidator)(properties.paperCanvasSizeOptions)), errors.wrap('supplied properties not correct for "SectionBasedLayoutCanvasSizeOptionsProperty"');
    }
    function cfnDashboardSectionBasedLayoutCanvasSizeOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_SectionBasedLayoutCanvasSizeOptionsPropertyValidator(properties).assertSuccess(), { PaperCanvasSizeOptions: cfnDashboardSectionBasedLayoutPaperCanvasSizeOptionsPropertyToCloudFormation(properties.paperCanvasSizeOptions) }) : properties;
    }
    function CfnDashboardSectionBasedLayoutCanvasSizeOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("paperCanvasSizeOptions", "PaperCanvasSizeOptions", properties.PaperCanvasSizeOptions != null ? CfnDashboardSectionBasedLayoutPaperCanvasSizeOptionsPropertyFromCloudFormation(properties.PaperCanvasSizeOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_SectionBasedLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bodySections", cdk.requiredValidator)(properties.bodySections)), errors.collect(cdk.propertyValidator("bodySections", cdk.listValidator(CfnDashboard_BodySectionConfigurationPropertyValidator))(properties.bodySections)), errors.collect(cdk.propertyValidator("canvasSizeOptions", cdk.requiredValidator)(properties.canvasSizeOptions)), errors.collect(cdk.propertyValidator("canvasSizeOptions", CfnDashboard_SectionBasedLayoutCanvasSizeOptionsPropertyValidator)(properties.canvasSizeOptions)), errors.collect(cdk.propertyValidator("footerSections", cdk.requiredValidator)(properties.footerSections)), errors.collect(cdk.propertyValidator("footerSections", cdk.listValidator(CfnDashboard_HeaderFooterSectionConfigurationPropertyValidator))(properties.footerSections)), errors.collect(cdk.propertyValidator("headerSections", cdk.requiredValidator)(properties.headerSections)), errors.collect(cdk.propertyValidator("headerSections", cdk.listValidator(CfnDashboard_HeaderFooterSectionConfigurationPropertyValidator))(properties.headerSections)), errors.wrap('supplied properties not correct for "SectionBasedLayoutConfigurationProperty"');
    }
    function cfnDashboardSectionBasedLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_SectionBasedLayoutConfigurationPropertyValidator(properties).assertSuccess(), { BodySections: cdk.listMapper(cfnDashboardBodySectionConfigurationPropertyToCloudFormation)(properties.bodySections), CanvasSizeOptions: cfnDashboardSectionBasedLayoutCanvasSizeOptionsPropertyToCloudFormation(properties.canvasSizeOptions), FooterSections: cdk.listMapper(cfnDashboardHeaderFooterSectionConfigurationPropertyToCloudFormation)(properties.footerSections), HeaderSections: cdk.listMapper(cfnDashboardHeaderFooterSectionConfigurationPropertyToCloudFormation)(properties.headerSections) }) : properties;
    }
    function CfnDashboardSectionBasedLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bodySections", "BodySections", cfn_parse.FromCloudFormation.getArray(CfnDashboardBodySectionConfigurationPropertyFromCloudFormation)(properties.BodySections)), ret.addPropertyResult("canvasSizeOptions", "CanvasSizeOptions", CfnDashboardSectionBasedLayoutCanvasSizeOptionsPropertyFromCloudFormation(properties.CanvasSizeOptions)), ret.addPropertyResult("footerSections", "FooterSections", cfn_parse.FromCloudFormation.getArray(CfnDashboardHeaderFooterSectionConfigurationPropertyFromCloudFormation)(properties.FooterSections)), ret.addPropertyResult("headerSections", "HeaderSections", cfn_parse.FromCloudFormation.getArray(CfnDashboardHeaderFooterSectionConfigurationPropertyFromCloudFormation)(properties.HeaderSections)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_SectionBasedLayoutPaperCanvasSizeOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("paperMargin", CfnDashboard_SpacingPropertyValidator)(properties.paperMargin)), errors.collect(cdk.propertyValidator("paperOrientation", cdk.validateString)(properties.paperOrientation)), errors.collect(cdk.propertyValidator("paperSize", cdk.validateString)(properties.paperSize)), errors.wrap('supplied properties not correct for "SectionBasedLayoutPaperCanvasSizeOptionsProperty"');
    }
    function cfnDashboardSectionBasedLayoutPaperCanvasSizeOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_SectionBasedLayoutPaperCanvasSizeOptionsPropertyValidator(properties).assertSuccess(), { PaperMargin: cfnDashboardSpacingPropertyToCloudFormation(properties.paperMargin), PaperOrientation: cdk.stringToCloudFormation(properties.paperOrientation), PaperSize: cdk.stringToCloudFormation(properties.paperSize) }) : properties;
    }
    function CfnDashboardSectionBasedLayoutPaperCanvasSizeOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("paperMargin", "PaperMargin", properties.PaperMargin != null ? CfnDashboardSpacingPropertyFromCloudFormation(properties.PaperMargin) : void 0), ret.addPropertyResult("paperOrientation", "PaperOrientation", properties.PaperOrientation != null ? cfn_parse.FromCloudFormation.getString(properties.PaperOrientation) : void 0), ret.addPropertyResult("paperSize", "PaperSize", properties.PaperSize != null ? cfn_parse.FromCloudFormation.getString(properties.PaperSize) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_SectionLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("freeFormLayout", cdk.requiredValidator)(properties.freeFormLayout)), errors.collect(cdk.propertyValidator("freeFormLayout", CfnDashboard_FreeFormSectionLayoutConfigurationPropertyValidator)(properties.freeFormLayout)), errors.wrap('supplied properties not correct for "SectionLayoutConfigurationProperty"');
    }
    function cfnDashboardSectionLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_SectionLayoutConfigurationPropertyValidator(properties).assertSuccess(), { FreeFormLayout: cfnDashboardFreeFormSectionLayoutConfigurationPropertyToCloudFormation(properties.freeFormLayout) }) : properties;
    }
    function CfnDashboardSectionLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("freeFormLayout", "FreeFormLayout", CfnDashboardFreeFormSectionLayoutConfigurationPropertyFromCloudFormation(properties.FreeFormLayout)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_SectionPageBreakConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("after", CfnDashboard_SectionAfterPageBreakPropertyValidator)(properties.after)), errors.wrap('supplied properties not correct for "SectionPageBreakConfigurationProperty"');
    }
    function cfnDashboardSectionPageBreakConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_SectionPageBreakConfigurationPropertyValidator(properties).assertSuccess(), { After: cfnDashboardSectionAfterPageBreakPropertyToCloudFormation(properties.after) }) : properties;
    }
    function CfnDashboardSectionPageBreakConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("after", "After", properties.After != null ? CfnDashboardSectionAfterPageBreakPropertyFromCloudFormation(properties.After) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_SectionStylePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("height", cdk.validateString)(properties.height)), errors.collect(cdk.propertyValidator("padding", CfnDashboard_SpacingPropertyValidator)(properties.padding)), errors.wrap('supplied properties not correct for "SectionStyleProperty"');
    }
    function cfnDashboardSectionStylePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_SectionStylePropertyValidator(properties).assertSuccess(), { Height: cdk.stringToCloudFormation(properties.height), Padding: cfnDashboardSpacingPropertyToCloudFormation(properties.padding) }) : properties;
    }
    function CfnDashboardSectionStylePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("height", "Height", properties.Height != null ? cfn_parse.FromCloudFormation.getString(properties.Height) : void 0), ret.addPropertyResult("padding", "Padding", properties.Padding != null ? CfnDashboardSpacingPropertyFromCloudFormation(properties.Padding) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_SelectedSheetsFilterScopeConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sheetVisualScopingConfigurations", cdk.listValidator(CfnDashboard_SheetVisualScopingConfigurationPropertyValidator))(properties.sheetVisualScopingConfigurations)), errors.wrap('supplied properties not correct for "SelectedSheetsFilterScopeConfigurationProperty"');
    }
    function cfnDashboardSelectedSheetsFilterScopeConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_SelectedSheetsFilterScopeConfigurationPropertyValidator(properties).assertSuccess(), { SheetVisualScopingConfigurations: cdk.listMapper(cfnDashboardSheetVisualScopingConfigurationPropertyToCloudFormation)(properties.sheetVisualScopingConfigurations) }) : properties;
    }
    function CfnDashboardSelectedSheetsFilterScopeConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sheetVisualScopingConfigurations", "SheetVisualScopingConfigurations", properties.SheetVisualScopingConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardSheetVisualScopingConfigurationPropertyFromCloudFormation)(properties.SheetVisualScopingConfigurations) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_SeriesItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataFieldSeriesItem", CfnDashboard_DataFieldSeriesItemPropertyValidator)(properties.dataFieldSeriesItem)), errors.collect(cdk.propertyValidator("fieldSeriesItem", CfnDashboard_FieldSeriesItemPropertyValidator)(properties.fieldSeriesItem)), errors.wrap('supplied properties not correct for "SeriesItemProperty"');
    }
    function cfnDashboardSeriesItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_SeriesItemPropertyValidator(properties).assertSuccess(), { DataFieldSeriesItem: cfnDashboardDataFieldSeriesItemPropertyToCloudFormation(properties.dataFieldSeriesItem), FieldSeriesItem: cfnDashboardFieldSeriesItemPropertyToCloudFormation(properties.fieldSeriesItem) }) : properties;
    }
    function CfnDashboardSeriesItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataFieldSeriesItem", "DataFieldSeriesItem", properties.DataFieldSeriesItem != null ? CfnDashboardDataFieldSeriesItemPropertyFromCloudFormation(properties.DataFieldSeriesItem) : void 0), ret.addPropertyResult("fieldSeriesItem", "FieldSeriesItem", properties.FieldSeriesItem != null ? CfnDashboardFieldSeriesItemPropertyFromCloudFormation(properties.FieldSeriesItem) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_SetParameterValueConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationParameterName", cdk.requiredValidator)(properties.destinationParameterName)), errors.collect(cdk.propertyValidator("destinationParameterName", cdk.validateString)(properties.destinationParameterName)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", CfnDashboard_DestinationParameterValueConfigurationPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "SetParameterValueConfigurationProperty"');
    }
    function cfnDashboardSetParameterValueConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_SetParameterValueConfigurationPropertyValidator(properties).assertSuccess(), { DestinationParameterName: cdk.stringToCloudFormation(properties.destinationParameterName), Value: cfnDashboardDestinationParameterValueConfigurationPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnDashboardSetParameterValueConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationParameterName", "DestinationParameterName", cfn_parse.FromCloudFormation.getString(properties.DestinationParameterName)), ret.addPropertyResult("value", "Value", CfnDashboardDestinationParameterValueConfigurationPropertyFromCloudFormation(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ShapeConditionalFormatPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("backgroundColor", cdk.requiredValidator)(properties.backgroundColor)), errors.collect(cdk.propertyValidator("backgroundColor", CfnDashboard_ConditionalFormattingColorPropertyValidator)(properties.backgroundColor)), errors.wrap('supplied properties not correct for "ShapeConditionalFormatProperty"');
    }
    function cfnDashboardShapeConditionalFormatPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ShapeConditionalFormatPropertyValidator(properties).assertSuccess(), { BackgroundColor: cfnDashboardConditionalFormattingColorPropertyToCloudFormation(properties.backgroundColor) }) : properties;
    }
    function CfnDashboardShapeConditionalFormatPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("backgroundColor", "BackgroundColor", CfnDashboardConditionalFormattingColorPropertyFromCloudFormation(properties.BackgroundColor)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_SheetControlLayoutPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configuration", cdk.requiredValidator)(properties.configuration)), errors.collect(cdk.propertyValidator("configuration", CfnDashboard_SheetControlLayoutConfigurationPropertyValidator)(properties.configuration)), errors.wrap('supplied properties not correct for "SheetControlLayoutProperty"');
    }
    function cfnDashboardSheetControlLayoutPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_SheetControlLayoutPropertyValidator(properties).assertSuccess(), { Configuration: cfnDashboardSheetControlLayoutConfigurationPropertyToCloudFormation(properties.configuration) }) : properties;
    }
    function CfnDashboardSheetControlLayoutPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configuration", "Configuration", CfnDashboardSheetControlLayoutConfigurationPropertyFromCloudFormation(properties.Configuration)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_SheetControlLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("gridLayout", CfnDashboard_GridLayoutConfigurationPropertyValidator)(properties.gridLayout)), errors.wrap('supplied properties not correct for "SheetControlLayoutConfigurationProperty"');
    }
    function cfnDashboardSheetControlLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_SheetControlLayoutConfigurationPropertyValidator(properties).assertSuccess(), { GridLayout: cfnDashboardGridLayoutConfigurationPropertyToCloudFormation(properties.gridLayout) }) : properties;
    }
    function CfnDashboardSheetControlLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("gridLayout", "GridLayout", properties.GridLayout != null ? CfnDashboardGridLayoutConfigurationPropertyFromCloudFormation(properties.GridLayout) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_SheetControlsOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibilityState", cdk.validateString)(properties.visibilityState)), errors.wrap('supplied properties not correct for "SheetControlsOptionProperty"');
    }
    function cfnDashboardSheetControlsOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_SheetControlsOptionPropertyValidator(properties).assertSuccess(), { VisibilityState: cdk.stringToCloudFormation(properties.visibilityState) }) : properties;
    }
    function CfnDashboardSheetControlsOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibilityState", "VisibilityState", properties.VisibilityState != null ? cfn_parse.FromCloudFormation.getString(properties.VisibilityState) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_SheetDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contentType", cdk.validateString)(properties.contentType)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("filterControls", cdk.listValidator(CfnDashboard_FilterControlPropertyValidator))(properties.filterControls)), errors.collect(cdk.propertyValidator("layouts", cdk.listValidator(CfnDashboard_LayoutPropertyValidator))(properties.layouts)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("parameterControls", cdk.listValidator(CfnDashboard_ParameterControlPropertyValidator))(properties.parameterControls)), errors.collect(cdk.propertyValidator("sheetControlLayouts", cdk.listValidator(CfnDashboard_SheetControlLayoutPropertyValidator))(properties.sheetControlLayouts)), errors.collect(cdk.propertyValidator("sheetId", cdk.requiredValidator)(properties.sheetId)), errors.collect(cdk.propertyValidator("sheetId", cdk.validateString)(properties.sheetId)), errors.collect(cdk.propertyValidator("textBoxes", cdk.listValidator(CfnDashboard_SheetTextBoxPropertyValidator))(properties.textBoxes)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.collect(cdk.propertyValidator("visuals", cdk.listValidator(CfnDashboard_VisualPropertyValidator))(properties.visuals)), errors.wrap('supplied properties not correct for "SheetDefinitionProperty"');
    }
    function cfnDashboardSheetDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_SheetDefinitionPropertyValidator(properties).assertSuccess(), { ContentType: cdk.stringToCloudFormation(properties.contentType), Description: cdk.stringToCloudFormation(properties.description), FilterControls: cdk.listMapper(cfnDashboardFilterControlPropertyToCloudFormation)(properties.filterControls), Layouts: cdk.listMapper(cfnDashboardLayoutPropertyToCloudFormation)(properties.layouts), Name: cdk.stringToCloudFormation(properties.name), ParameterControls: cdk.listMapper(cfnDashboardParameterControlPropertyToCloudFormation)(properties.parameterControls), SheetControlLayouts: cdk.listMapper(cfnDashboardSheetControlLayoutPropertyToCloudFormation)(properties.sheetControlLayouts), SheetId: cdk.stringToCloudFormation(properties.sheetId), TextBoxes: cdk.listMapper(cfnDashboardSheetTextBoxPropertyToCloudFormation)(properties.textBoxes), Title: cdk.stringToCloudFormation(properties.title), Visuals: cdk.listMapper(cfnDashboardVisualPropertyToCloudFormation)(properties.visuals) }) : properties;
    }
    function CfnDashboardSheetDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contentType", "ContentType", properties.ContentType != null ? cfn_parse.FromCloudFormation.getString(properties.ContentType) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("filterControls", "FilterControls", properties.FilterControls != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardFilterControlPropertyFromCloudFormation)(properties.FilterControls) : void 0), ret.addPropertyResult("layouts", "Layouts", properties.Layouts != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardLayoutPropertyFromCloudFormation)(properties.Layouts) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("parameterControls", "ParameterControls", properties.ParameterControls != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardParameterControlPropertyFromCloudFormation)(properties.ParameterControls) : void 0), ret.addPropertyResult("sheetControlLayouts", "SheetControlLayouts", properties.SheetControlLayouts != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardSheetControlLayoutPropertyFromCloudFormation)(properties.SheetControlLayouts) : void 0), ret.addPropertyResult("sheetId", "SheetId", cfn_parse.FromCloudFormation.getString(properties.SheetId)), ret.addPropertyResult("textBoxes", "TextBoxes", properties.TextBoxes != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardSheetTextBoxPropertyFromCloudFormation)(properties.TextBoxes) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? cfn_parse.FromCloudFormation.getString(properties.Title) : void 0), ret.addPropertyResult("visuals", "Visuals", properties.Visuals != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardVisualPropertyFromCloudFormation)(properties.Visuals) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_SheetElementConfigurationOverridesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "SheetElementConfigurationOverridesProperty"');
    }
    function cfnDashboardSheetElementConfigurationOverridesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_SheetElementConfigurationOverridesPropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnDashboardSheetElementConfigurationOverridesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_SheetElementRenderingRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configurationOverrides", cdk.requiredValidator)(properties.configurationOverrides)), errors.collect(cdk.propertyValidator("configurationOverrides", CfnDashboard_SheetElementConfigurationOverridesPropertyValidator)(properties.configurationOverrides)), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.wrap('supplied properties not correct for "SheetElementRenderingRuleProperty"');
    }
    function cfnDashboardSheetElementRenderingRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_SheetElementRenderingRulePropertyValidator(properties).assertSuccess(), { ConfigurationOverrides: cfnDashboardSheetElementConfigurationOverridesPropertyToCloudFormation(properties.configurationOverrides), Expression: cdk.stringToCloudFormation(properties.expression) }) : properties;
    }
    function CfnDashboardSheetElementRenderingRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configurationOverrides", "ConfigurationOverrides", CfnDashboardSheetElementConfigurationOverridesPropertyFromCloudFormation(properties.ConfigurationOverrides)), ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getString(properties.Expression)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_SheetLayoutElementMaximizationOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availabilityStatus", cdk.validateString)(properties.availabilityStatus)), errors.wrap('supplied properties not correct for "SheetLayoutElementMaximizationOptionProperty"');
    }
    function cfnDashboardSheetLayoutElementMaximizationOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_SheetLayoutElementMaximizationOptionPropertyValidator(properties).assertSuccess(), { AvailabilityStatus: cdk.stringToCloudFormation(properties.availabilityStatus) }) : properties;
    }
    function CfnDashboardSheetLayoutElementMaximizationOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("availabilityStatus", "AvailabilityStatus", properties.AvailabilityStatus != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityStatus) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_SheetTextBoxPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("content", cdk.validateString)(properties.content)), errors.collect(cdk.propertyValidator("sheetTextBoxId", cdk.requiredValidator)(properties.sheetTextBoxId)), errors.collect(cdk.propertyValidator("sheetTextBoxId", cdk.validateString)(properties.sheetTextBoxId)), errors.wrap('supplied properties not correct for "SheetTextBoxProperty"');
    }
    function cfnDashboardSheetTextBoxPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_SheetTextBoxPropertyValidator(properties).assertSuccess(), { Content: cdk.stringToCloudFormation(properties.content), SheetTextBoxId: cdk.stringToCloudFormation(properties.sheetTextBoxId) }) : properties;
    }
    function CfnDashboardSheetTextBoxPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("content", "Content", properties.Content != null ? cfn_parse.FromCloudFormation.getString(properties.Content) : void 0), ret.addPropertyResult("sheetTextBoxId", "SheetTextBoxId", cfn_parse.FromCloudFormation.getString(properties.SheetTextBoxId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_SheetVisualScopingConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("scope", cdk.requiredValidator)(properties.scope)), errors.collect(cdk.propertyValidator("scope", cdk.validateString)(properties.scope)), errors.collect(cdk.propertyValidator("sheetId", cdk.requiredValidator)(properties.sheetId)), errors.collect(cdk.propertyValidator("sheetId", cdk.validateString)(properties.sheetId)), errors.collect(cdk.propertyValidator("visualIds", cdk.listValidator(cdk.validateString))(properties.visualIds)), errors.wrap('supplied properties not correct for "SheetVisualScopingConfigurationProperty"');
    }
    function cfnDashboardSheetVisualScopingConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_SheetVisualScopingConfigurationPropertyValidator(properties).assertSuccess(), { Scope: cdk.stringToCloudFormation(properties.scope), SheetId: cdk.stringToCloudFormation(properties.sheetId), VisualIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.visualIds) }) : properties;
    }
    function CfnDashboardSheetVisualScopingConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("scope", "Scope", cfn_parse.FromCloudFormation.getString(properties.Scope)), ret.addPropertyResult("sheetId", "SheetId", cfn_parse.FromCloudFormation.getString(properties.SheetId)), ret.addPropertyResult("visualIds", "VisualIds", properties.VisualIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.VisualIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ShortFormatTextPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("plainText", cdk.validateString)(properties.plainText)), errors.collect(cdk.propertyValidator("richText", cdk.validateString)(properties.richText)), errors.wrap('supplied properties not correct for "ShortFormatTextProperty"');
    }
    function cfnDashboardShortFormatTextPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ShortFormatTextPropertyValidator(properties).assertSuccess(), { PlainText: cdk.stringToCloudFormation(properties.plainText), RichText: cdk.stringToCloudFormation(properties.richText) }) : properties;
    }
    function CfnDashboardShortFormatTextPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("plainText", "PlainText", properties.PlainText != null ? cfn_parse.FromCloudFormation.getString(properties.PlainText) : void 0), ret.addPropertyResult("richText", "RichText", properties.RichText != null ? cfn_parse.FromCloudFormation.getString(properties.RichText) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_SimpleClusterMarkerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.wrap('supplied properties not correct for "SimpleClusterMarkerProperty"');
    }
    function cfnDashboardSimpleClusterMarkerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_SimpleClusterMarkerPropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color) }) : properties;
    }
    function CfnDashboardSimpleClusterMarkerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", properties.Color != null ? cfn_parse.FromCloudFormation.getString(properties.Color) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_SliderControlDisplayOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("titleOptions", CfnDashboard_LabelOptionsPropertyValidator)(properties.titleOptions)), errors.wrap('supplied properties not correct for "SliderControlDisplayOptionsProperty"');
    }
    function cfnDashboardSliderControlDisplayOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_SliderControlDisplayOptionsPropertyValidator(properties).assertSuccess(), { TitleOptions: cfnDashboardLabelOptionsPropertyToCloudFormation(properties.titleOptions) }) : properties;
    }
    function CfnDashboardSliderControlDisplayOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("titleOptions", "TitleOptions", properties.TitleOptions != null ? CfnDashboardLabelOptionsPropertyFromCloudFormation(properties.TitleOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_SmallMultiplesOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxVisibleColumns", cdk.validateNumber)(properties.maxVisibleColumns)), errors.collect(cdk.propertyValidator("maxVisibleRows", cdk.validateNumber)(properties.maxVisibleRows)), errors.collect(cdk.propertyValidator("panelConfiguration", CfnDashboard_PanelConfigurationPropertyValidator)(properties.panelConfiguration)), errors.wrap('supplied properties not correct for "SmallMultiplesOptionsProperty"');
    }
    function cfnDashboardSmallMultiplesOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_SmallMultiplesOptionsPropertyValidator(properties).assertSuccess(), { MaxVisibleColumns: cdk.numberToCloudFormation(properties.maxVisibleColumns), MaxVisibleRows: cdk.numberToCloudFormation(properties.maxVisibleRows), PanelConfiguration: cfnDashboardPanelConfigurationPropertyToCloudFormation(properties.panelConfiguration) }) : properties;
    }
    function CfnDashboardSmallMultiplesOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxVisibleColumns", "MaxVisibleColumns", properties.MaxVisibleColumns != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxVisibleColumns) : void 0), ret.addPropertyResult("maxVisibleRows", "MaxVisibleRows", properties.MaxVisibleRows != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxVisibleRows) : void 0), ret.addPropertyResult("panelConfiguration", "PanelConfiguration", properties.PanelConfiguration != null ? CfnDashboardPanelConfigurationPropertyFromCloudFormation(properties.PanelConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_SpacingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bottom", cdk.validateString)(properties.bottom)), errors.collect(cdk.propertyValidator("left", cdk.validateString)(properties.left)), errors.collect(cdk.propertyValidator("right", cdk.validateString)(properties.right)), errors.collect(cdk.propertyValidator("top", cdk.validateString)(properties.top)), errors.wrap('supplied properties not correct for "SpacingProperty"');
    }
    function cfnDashboardSpacingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_SpacingPropertyValidator(properties).assertSuccess(), { Bottom: cdk.stringToCloudFormation(properties.bottom), Left: cdk.stringToCloudFormation(properties.left), Right: cdk.stringToCloudFormation(properties.right), Top: cdk.stringToCloudFormation(properties.top) }) : properties;
    }
    function CfnDashboardSpacingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bottom", "Bottom", properties.Bottom != null ? cfn_parse.FromCloudFormation.getString(properties.Bottom) : void 0), ret.addPropertyResult("left", "Left", properties.Left != null ? cfn_parse.FromCloudFormation.getString(properties.Left) : void 0), ret.addPropertyResult("right", "Right", properties.Right != null ? cfn_parse.FromCloudFormation.getString(properties.Right) : void 0), ret.addPropertyResult("top", "Top", properties.Top != null ? cfn_parse.FromCloudFormation.getString(properties.Top) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_StringDefaultValuesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dynamicValue", CfnDashboard_DynamicDefaultValuePropertyValidator)(properties.dynamicValue)), errors.collect(cdk.propertyValidator("staticValues", cdk.listValidator(cdk.validateString))(properties.staticValues)), errors.wrap('supplied properties not correct for "StringDefaultValuesProperty"');
    }
    function cfnDashboardStringDefaultValuesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_StringDefaultValuesPropertyValidator(properties).assertSuccess(), { DynamicValue: cfnDashboardDynamicDefaultValuePropertyToCloudFormation(properties.dynamicValue), StaticValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.staticValues) }) : properties;
    }
    function CfnDashboardStringDefaultValuesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dynamicValue", "DynamicValue", properties.DynamicValue != null ? CfnDashboardDynamicDefaultValuePropertyFromCloudFormation(properties.DynamicValue) : void 0), ret.addPropertyResult("staticValues", "StaticValues", properties.StaticValues != null ? cfn_parse.FromCloudFormation.getStringArray(properties.StaticValues) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_StringFormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("nullValueFormatConfiguration", CfnDashboard_NullValueFormatConfigurationPropertyValidator)(properties.nullValueFormatConfiguration)), errors.collect(cdk.propertyValidator("numericFormatConfiguration", CfnDashboard_NumericFormatConfigurationPropertyValidator)(properties.numericFormatConfiguration)), errors.wrap('supplied properties not correct for "StringFormatConfigurationProperty"');
    }
    function cfnDashboardStringFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_StringFormatConfigurationPropertyValidator(properties).assertSuccess(), { NullValueFormatConfiguration: cfnDashboardNullValueFormatConfigurationPropertyToCloudFormation(properties.nullValueFormatConfiguration), NumericFormatConfiguration: cfnDashboardNumericFormatConfigurationPropertyToCloudFormation(properties.numericFormatConfiguration) }) : properties;
    }
    function CfnDashboardStringFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("nullValueFormatConfiguration", "NullValueFormatConfiguration", properties.NullValueFormatConfiguration != null ? CfnDashboardNullValueFormatConfigurationPropertyFromCloudFormation(properties.NullValueFormatConfiguration) : void 0), ret.addPropertyResult("numericFormatConfiguration", "NumericFormatConfiguration", properties.NumericFormatConfiguration != null ? CfnDashboardNumericFormatConfigurationPropertyFromCloudFormation(properties.NumericFormatConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_StringParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("values", cdk.requiredValidator)(properties.values)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "StringParameterProperty"');
    }
    function cfnDashboardStringParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_StringParameterPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnDashboardStringParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("values", "Values", cfn_parse.FromCloudFormation.getStringArray(properties.Values)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_StringParameterDeclarationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultValues", CfnDashboard_StringDefaultValuesPropertyValidator)(properties.defaultValues)), errors.collect(cdk.propertyValidator("mappedDataSetParameters", cdk.listValidator(CfnDashboard_MappedDataSetParameterPropertyValidator))(properties.mappedDataSetParameters)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("parameterValueType", cdk.requiredValidator)(properties.parameterValueType)), errors.collect(cdk.propertyValidator("parameterValueType", cdk.validateString)(properties.parameterValueType)), errors.collect(cdk.propertyValidator("valueWhenUnset", CfnDashboard_StringValueWhenUnsetConfigurationPropertyValidator)(properties.valueWhenUnset)), errors.wrap('supplied properties not correct for "StringParameterDeclarationProperty"');
    }
    function cfnDashboardStringParameterDeclarationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_StringParameterDeclarationPropertyValidator(properties).assertSuccess(), { DefaultValues: cfnDashboardStringDefaultValuesPropertyToCloudFormation(properties.defaultValues), MappedDataSetParameters: cdk.listMapper(cfnDashboardMappedDataSetParameterPropertyToCloudFormation)(properties.mappedDataSetParameters), Name: cdk.stringToCloudFormation(properties.name), ParameterValueType: cdk.stringToCloudFormation(properties.parameterValueType), ValueWhenUnset: cfnDashboardStringValueWhenUnsetConfigurationPropertyToCloudFormation(properties.valueWhenUnset) }) : properties;
    }
    function CfnDashboardStringParameterDeclarationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultValues", "DefaultValues", properties.DefaultValues != null ? CfnDashboardStringDefaultValuesPropertyFromCloudFormation(properties.DefaultValues) : void 0), ret.addPropertyResult("mappedDataSetParameters", "MappedDataSetParameters", properties.MappedDataSetParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMappedDataSetParameterPropertyFromCloudFormation)(properties.MappedDataSetParameters) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("parameterValueType", "ParameterValueType", cfn_parse.FromCloudFormation.getString(properties.ParameterValueType)), ret.addPropertyResult("valueWhenUnset", "ValueWhenUnset", properties.ValueWhenUnset != null ? CfnDashboardStringValueWhenUnsetConfigurationPropertyFromCloudFormation(properties.ValueWhenUnset) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_StringValueWhenUnsetConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customValue", cdk.validateString)(properties.customValue)), errors.collect(cdk.propertyValidator("valueWhenUnsetOption", cdk.validateString)(properties.valueWhenUnsetOption)), errors.wrap('supplied properties not correct for "StringValueWhenUnsetConfigurationProperty"');
    }
    function cfnDashboardStringValueWhenUnsetConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_StringValueWhenUnsetConfigurationPropertyValidator(properties).assertSuccess(), { CustomValue: cdk.stringToCloudFormation(properties.customValue), ValueWhenUnsetOption: cdk.stringToCloudFormation(properties.valueWhenUnsetOption) }) : properties;
    }
    function CfnDashboardStringValueWhenUnsetConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customValue", "CustomValue", properties.CustomValue != null ? cfn_parse.FromCloudFormation.getString(properties.CustomValue) : void 0), ret.addPropertyResult("valueWhenUnsetOption", "ValueWhenUnsetOption", properties.ValueWhenUnsetOption != null ? cfn_parse.FromCloudFormation.getString(properties.ValueWhenUnsetOption) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_SubtotalOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customLabel", cdk.validateString)(properties.customLabel)), errors.collect(cdk.propertyValidator("fieldLevel", cdk.validateString)(properties.fieldLevel)), errors.collect(cdk.propertyValidator("fieldLevelOptions", cdk.listValidator(CfnDashboard_PivotTableFieldSubtotalOptionsPropertyValidator))(properties.fieldLevelOptions)), errors.collect(cdk.propertyValidator("metricHeaderCellStyle", CfnDashboard_TableCellStylePropertyValidator)(properties.metricHeaderCellStyle)), errors.collect(cdk.propertyValidator("totalCellStyle", CfnDashboard_TableCellStylePropertyValidator)(properties.totalCellStyle)), errors.collect(cdk.propertyValidator("totalsVisibility", cdk.validateString)(properties.totalsVisibility)), errors.collect(cdk.propertyValidator("valueCellStyle", CfnDashboard_TableCellStylePropertyValidator)(properties.valueCellStyle)), errors.wrap('supplied properties not correct for "SubtotalOptionsProperty"');
    }
    function cfnDashboardSubtotalOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_SubtotalOptionsPropertyValidator(properties).assertSuccess(), { CustomLabel: cdk.stringToCloudFormation(properties.customLabel), FieldLevel: cdk.stringToCloudFormation(properties.fieldLevel), FieldLevelOptions: cdk.listMapper(cfnDashboardPivotTableFieldSubtotalOptionsPropertyToCloudFormation)(properties.fieldLevelOptions), MetricHeaderCellStyle: cfnDashboardTableCellStylePropertyToCloudFormation(properties.metricHeaderCellStyle), TotalCellStyle: cfnDashboardTableCellStylePropertyToCloudFormation(properties.totalCellStyle), TotalsVisibility: cdk.stringToCloudFormation(properties.totalsVisibility), ValueCellStyle: cfnDashboardTableCellStylePropertyToCloudFormation(properties.valueCellStyle) }) : properties;
    }
    function CfnDashboardSubtotalOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customLabel", "CustomLabel", properties.CustomLabel != null ? cfn_parse.FromCloudFormation.getString(properties.CustomLabel) : void 0), ret.addPropertyResult("fieldLevel", "FieldLevel", properties.FieldLevel != null ? cfn_parse.FromCloudFormation.getString(properties.FieldLevel) : void 0), ret.addPropertyResult("fieldLevelOptions", "FieldLevelOptions", properties.FieldLevelOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardPivotTableFieldSubtotalOptionsPropertyFromCloudFormation)(properties.FieldLevelOptions) : void 0), ret.addPropertyResult("metricHeaderCellStyle", "MetricHeaderCellStyle", properties.MetricHeaderCellStyle != null ? CfnDashboardTableCellStylePropertyFromCloudFormation(properties.MetricHeaderCellStyle) : void 0), ret.addPropertyResult("totalCellStyle", "TotalCellStyle", properties.TotalCellStyle != null ? CfnDashboardTableCellStylePropertyFromCloudFormation(properties.TotalCellStyle) : void 0), ret.addPropertyResult("totalsVisibility", "TotalsVisibility", properties.TotalsVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.TotalsVisibility) : void 0), ret.addPropertyResult("valueCellStyle", "ValueCellStyle", properties.ValueCellStyle != null ? CfnDashboardTableCellStylePropertyFromCloudFormation(properties.ValueCellStyle) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TableAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groupBy", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.groupBy)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnDashboard_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "TableAggregatedFieldWellsProperty"');
    }
    function cfnDashboardTableAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TableAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { GroupBy: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.groupBy), Values: cdk.listMapper(cfnDashboardMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnDashboardTableAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupBy", "GroupBy", properties.GroupBy != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.GroupBy) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TableBorderOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.collect(cdk.propertyValidator("style", cdk.validateString)(properties.style)), errors.collect(cdk.propertyValidator("thickness", cdk.validateNumber)(properties.thickness)), errors.wrap('supplied properties not correct for "TableBorderOptionsProperty"');
    }
    function cfnDashboardTableBorderOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TableBorderOptionsPropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color), Style: cdk.stringToCloudFormation(properties.style), Thickness: cdk.numberToCloudFormation(properties.thickness) }) : properties;
    }
    function CfnDashboardTableBorderOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", properties.Color != null ? cfn_parse.FromCloudFormation.getString(properties.Color) : void 0), ret.addPropertyResult("style", "Style", properties.Style != null ? cfn_parse.FromCloudFormation.getString(properties.Style) : void 0), ret.addPropertyResult("thickness", "Thickness", properties.Thickness != null ? cfn_parse.FromCloudFormation.getNumber(properties.Thickness) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TableCellConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("textFormat", CfnDashboard_TextConditionalFormatPropertyValidator)(properties.textFormat)), errors.wrap('supplied properties not correct for "TableCellConditionalFormattingProperty"');
    }
    function cfnDashboardTableCellConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TableCellConditionalFormattingPropertyValidator(properties).assertSuccess(), { FieldId: cdk.stringToCloudFormation(properties.fieldId), TextFormat: cfnDashboardTextConditionalFormatPropertyToCloudFormation(properties.textFormat) }) : properties;
    }
    function CfnDashboardTableCellConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("textFormat", "TextFormat", properties.TextFormat != null ? CfnDashboardTextConditionalFormatPropertyFromCloudFormation(properties.TextFormat) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TableCellImageSizingConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("tableCellImageScalingConfiguration", cdk.validateString)(properties.tableCellImageScalingConfiguration)), errors.wrap('supplied properties not correct for "TableCellImageSizingConfigurationProperty"');
    }
    function cfnDashboardTableCellImageSizingConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TableCellImageSizingConfigurationPropertyValidator(properties).assertSuccess(), { TableCellImageScalingConfiguration: cdk.stringToCloudFormation(properties.tableCellImageScalingConfiguration) }) : properties;
    }
    function CfnDashboardTableCellImageSizingConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("tableCellImageScalingConfiguration", "TableCellImageScalingConfiguration", properties.TableCellImageScalingConfiguration != null ? cfn_parse.FromCloudFormation.getString(properties.TableCellImageScalingConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TableCellStylePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("backgroundColor", cdk.validateString)(properties.backgroundColor)), errors.collect(cdk.propertyValidator("border", CfnDashboard_GlobalTableBorderOptionsPropertyValidator)(properties.border)), errors.collect(cdk.propertyValidator("fontConfiguration", CfnDashboard_FontConfigurationPropertyValidator)(properties.fontConfiguration)), errors.collect(cdk.propertyValidator("height", cdk.validateNumber)(properties.height)), errors.collect(cdk.propertyValidator("horizontalTextAlignment", cdk.validateString)(properties.horizontalTextAlignment)), errors.collect(cdk.propertyValidator("textWrap", cdk.validateString)(properties.textWrap)), errors.collect(cdk.propertyValidator("verticalTextAlignment", cdk.validateString)(properties.verticalTextAlignment)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "TableCellStyleProperty"');
    }
    function cfnDashboardTableCellStylePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TableCellStylePropertyValidator(properties).assertSuccess(), { BackgroundColor: cdk.stringToCloudFormation(properties.backgroundColor), Border: cfnDashboardGlobalTableBorderOptionsPropertyToCloudFormation(properties.border), FontConfiguration: cfnDashboardFontConfigurationPropertyToCloudFormation(properties.fontConfiguration), Height: cdk.numberToCloudFormation(properties.height), HorizontalTextAlignment: cdk.stringToCloudFormation(properties.horizontalTextAlignment), TextWrap: cdk.stringToCloudFormation(properties.textWrap), VerticalTextAlignment: cdk.stringToCloudFormation(properties.verticalTextAlignment), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnDashboardTableCellStylePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("backgroundColor", "BackgroundColor", properties.BackgroundColor != null ? cfn_parse.FromCloudFormation.getString(properties.BackgroundColor) : void 0), ret.addPropertyResult("border", "Border", properties.Border != null ? CfnDashboardGlobalTableBorderOptionsPropertyFromCloudFormation(properties.Border) : void 0), ret.addPropertyResult("fontConfiguration", "FontConfiguration", properties.FontConfiguration != null ? CfnDashboardFontConfigurationPropertyFromCloudFormation(properties.FontConfiguration) : void 0), ret.addPropertyResult("height", "Height", properties.Height != null ? cfn_parse.FromCloudFormation.getNumber(properties.Height) : void 0), ret.addPropertyResult("horizontalTextAlignment", "HorizontalTextAlignment", properties.HorizontalTextAlignment != null ? cfn_parse.FromCloudFormation.getString(properties.HorizontalTextAlignment) : void 0), ret.addPropertyResult("textWrap", "TextWrap", properties.TextWrap != null ? cfn_parse.FromCloudFormation.getString(properties.TextWrap) : void 0), ret.addPropertyResult("verticalTextAlignment", "VerticalTextAlignment", properties.VerticalTextAlignment != null ? cfn_parse.FromCloudFormation.getString(properties.VerticalTextAlignment) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TableConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("conditionalFormattingOptions", cdk.listValidator(CfnDashboard_TableConditionalFormattingOptionPropertyValidator))(properties.conditionalFormattingOptions)), errors.wrap('supplied properties not correct for "TableConditionalFormattingProperty"');
    }
    function cfnDashboardTableConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TableConditionalFormattingPropertyValidator(properties).assertSuccess(), { ConditionalFormattingOptions: cdk.listMapper(cfnDashboardTableConditionalFormattingOptionPropertyToCloudFormation)(properties.conditionalFormattingOptions) }) : properties;
    }
    function CfnDashboardTableConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("conditionalFormattingOptions", "ConditionalFormattingOptions", properties.ConditionalFormattingOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardTableConditionalFormattingOptionPropertyFromCloudFormation)(properties.ConditionalFormattingOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TableConditionalFormattingOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cell", CfnDashboard_TableCellConditionalFormattingPropertyValidator)(properties.cell)), errors.collect(cdk.propertyValidator("row", CfnDashboard_TableRowConditionalFormattingPropertyValidator)(properties.row)), errors.wrap('supplied properties not correct for "TableConditionalFormattingOptionProperty"');
    }
    function cfnDashboardTableConditionalFormattingOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TableConditionalFormattingOptionPropertyValidator(properties).assertSuccess(), { Cell: cfnDashboardTableCellConditionalFormattingPropertyToCloudFormation(properties.cell), Row: cfnDashboardTableRowConditionalFormattingPropertyToCloudFormation(properties.row) }) : properties;
    }
    function CfnDashboardTableConditionalFormattingOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cell", "Cell", properties.Cell != null ? CfnDashboardTableCellConditionalFormattingPropertyFromCloudFormation(properties.Cell) : void 0), ret.addPropertyResult("row", "Row", properties.Row != null ? CfnDashboardTableRowConditionalFormattingPropertyFromCloudFormation(properties.Row) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TableConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldOptions", CfnDashboard_TableFieldOptionsPropertyValidator)(properties.fieldOptions)), errors.collect(cdk.propertyValidator("fieldWells", CfnDashboard_TableFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("paginatedReportOptions", CfnDashboard_TablePaginatedReportOptionsPropertyValidator)(properties.paginatedReportOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnDashboard_TableSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tableInlineVisualizations", cdk.listValidator(CfnDashboard_TableInlineVisualizationPropertyValidator))(properties.tableInlineVisualizations)), errors.collect(cdk.propertyValidator("tableOptions", CfnDashboard_TableOptionsPropertyValidator)(properties.tableOptions)), errors.collect(cdk.propertyValidator("totalOptions", CfnDashboard_TotalOptionsPropertyValidator)(properties.totalOptions)), errors.wrap('supplied properties not correct for "TableConfigurationProperty"');
    }
    function cfnDashboardTableConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TableConfigurationPropertyValidator(properties).assertSuccess(), { FieldOptions: cfnDashboardTableFieldOptionsPropertyToCloudFormation(properties.fieldOptions), FieldWells: cfnDashboardTableFieldWellsPropertyToCloudFormation(properties.fieldWells), PaginatedReportOptions: cfnDashboardTablePaginatedReportOptionsPropertyToCloudFormation(properties.paginatedReportOptions), SortConfiguration: cfnDashboardTableSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), TableInlineVisualizations: cdk.listMapper(cfnDashboardTableInlineVisualizationPropertyToCloudFormation)(properties.tableInlineVisualizations), TableOptions: cfnDashboardTableOptionsPropertyToCloudFormation(properties.tableOptions), TotalOptions: cfnDashboardTotalOptionsPropertyToCloudFormation(properties.totalOptions) }) : properties;
    }
    function CfnDashboardTableConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldOptions", "FieldOptions", properties.FieldOptions != null ? CfnDashboardTableFieldOptionsPropertyFromCloudFormation(properties.FieldOptions) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnDashboardTableFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("paginatedReportOptions", "PaginatedReportOptions", properties.PaginatedReportOptions != null ? CfnDashboardTablePaginatedReportOptionsPropertyFromCloudFormation(properties.PaginatedReportOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnDashboardTableSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tableInlineVisualizations", "TableInlineVisualizations", properties.TableInlineVisualizations != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardTableInlineVisualizationPropertyFromCloudFormation)(properties.TableInlineVisualizations) : void 0), ret.addPropertyResult("tableOptions", "TableOptions", properties.TableOptions != null ? CfnDashboardTableOptionsPropertyFromCloudFormation(properties.TableOptions) : void 0), ret.addPropertyResult("totalOptions", "TotalOptions", properties.TotalOptions != null ? CfnDashboardTotalOptionsPropertyFromCloudFormation(properties.TotalOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TableFieldCustomIconContentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("icon", cdk.validateString)(properties.icon)), errors.wrap('supplied properties not correct for "TableFieldCustomIconContentProperty"');
    }
    function cfnDashboardTableFieldCustomIconContentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TableFieldCustomIconContentPropertyValidator(properties).assertSuccess(), { Icon: cdk.stringToCloudFormation(properties.icon) }) : properties;
    }
    function CfnDashboardTableFieldCustomIconContentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("icon", "Icon", properties.Icon != null ? cfn_parse.FromCloudFormation.getString(properties.Icon) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TableFieldCustomTextContentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fontConfiguration", cdk.requiredValidator)(properties.fontConfiguration)), errors.collect(cdk.propertyValidator("fontConfiguration", CfnDashboard_FontConfigurationPropertyValidator)(properties.fontConfiguration)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TableFieldCustomTextContentProperty"');
    }
    function cfnDashboardTableFieldCustomTextContentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TableFieldCustomTextContentPropertyValidator(properties).assertSuccess(), { FontConfiguration: cfnDashboardFontConfigurationPropertyToCloudFormation(properties.fontConfiguration), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnDashboardTableFieldCustomTextContentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fontConfiguration", "FontConfiguration", CfnDashboardFontConfigurationPropertyFromCloudFormation(properties.FontConfiguration)), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TableFieldImageConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sizingOptions", CfnDashboard_TableCellImageSizingConfigurationPropertyValidator)(properties.sizingOptions)), errors.wrap('supplied properties not correct for "TableFieldImageConfigurationProperty"');
    }
    function cfnDashboardTableFieldImageConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TableFieldImageConfigurationPropertyValidator(properties).assertSuccess(), { SizingOptions: cfnDashboardTableCellImageSizingConfigurationPropertyToCloudFormation(properties.sizingOptions) }) : properties;
    }
    function CfnDashboardTableFieldImageConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sizingOptions", "SizingOptions", properties.SizingOptions != null ? CfnDashboardTableCellImageSizingConfigurationPropertyFromCloudFormation(properties.SizingOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TableFieldLinkConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("content", cdk.requiredValidator)(properties.content)), errors.collect(cdk.propertyValidator("content", CfnDashboard_TableFieldLinkContentConfigurationPropertyValidator)(properties.content)), errors.collect(cdk.propertyValidator("target", cdk.requiredValidator)(properties.target)), errors.collect(cdk.propertyValidator("target", cdk.validateString)(properties.target)), errors.wrap('supplied properties not correct for "TableFieldLinkConfigurationProperty"');
    }
    function cfnDashboardTableFieldLinkConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TableFieldLinkConfigurationPropertyValidator(properties).assertSuccess(), { Content: cfnDashboardTableFieldLinkContentConfigurationPropertyToCloudFormation(properties.content), Target: cdk.stringToCloudFormation(properties.target) }) : properties;
    }
    function CfnDashboardTableFieldLinkConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("content", "Content", CfnDashboardTableFieldLinkContentConfigurationPropertyFromCloudFormation(properties.Content)), ret.addPropertyResult("target", "Target", cfn_parse.FromCloudFormation.getString(properties.Target)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TableFieldLinkContentConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customIconContent", CfnDashboard_TableFieldCustomIconContentPropertyValidator)(properties.customIconContent)), errors.collect(cdk.propertyValidator("customTextContent", CfnDashboard_TableFieldCustomTextContentPropertyValidator)(properties.customTextContent)), errors.wrap('supplied properties not correct for "TableFieldLinkContentConfigurationProperty"');
    }
    function cfnDashboardTableFieldLinkContentConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TableFieldLinkContentConfigurationPropertyValidator(properties).assertSuccess(), { CustomIconContent: cfnDashboardTableFieldCustomIconContentPropertyToCloudFormation(properties.customIconContent), CustomTextContent: cfnDashboardTableFieldCustomTextContentPropertyToCloudFormation(properties.customTextContent) }) : properties;
    }
    function CfnDashboardTableFieldLinkContentConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customIconContent", "CustomIconContent", properties.CustomIconContent != null ? CfnDashboardTableFieldCustomIconContentPropertyFromCloudFormation(properties.CustomIconContent) : void 0), ret.addPropertyResult("customTextContent", "CustomTextContent", properties.CustomTextContent != null ? CfnDashboardTableFieldCustomTextContentPropertyFromCloudFormation(properties.CustomTextContent) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TableFieldOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customLabel", cdk.validateString)(properties.customLabel)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("urlStyling", CfnDashboard_TableFieldURLConfigurationPropertyValidator)(properties.urlStyling)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.collect(cdk.propertyValidator("width", cdk.validateString)(properties.width)), errors.wrap('supplied properties not correct for "TableFieldOptionProperty"');
    }
    function cfnDashboardTableFieldOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TableFieldOptionPropertyValidator(properties).assertSuccess(), { CustomLabel: cdk.stringToCloudFormation(properties.customLabel), FieldId: cdk.stringToCloudFormation(properties.fieldId), URLStyling: cfnDashboardTableFieldURLConfigurationPropertyToCloudFormation(properties.urlStyling), Visibility: cdk.stringToCloudFormation(properties.visibility), Width: cdk.stringToCloudFormation(properties.width) }) : properties;
    }
    function CfnDashboardTableFieldOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customLabel", "CustomLabel", properties.CustomLabel != null ? cfn_parse.FromCloudFormation.getString(properties.CustomLabel) : void 0), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("urlStyling", "URLStyling", properties.URLStyling != null ? CfnDashboardTableFieldURLConfigurationPropertyFromCloudFormation(properties.URLStyling) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addPropertyResult("width", "Width", properties.Width != null ? cfn_parse.FromCloudFormation.getString(properties.Width) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TableFieldOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("order", cdk.listValidator(cdk.validateString))(properties.order)), errors.collect(cdk.propertyValidator("selectedFieldOptions", cdk.listValidator(CfnDashboard_TableFieldOptionPropertyValidator))(properties.selectedFieldOptions)), errors.wrap('supplied properties not correct for "TableFieldOptionsProperty"');
    }
    function cfnDashboardTableFieldOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TableFieldOptionsPropertyValidator(properties).assertSuccess(), { Order: cdk.listMapper(cdk.stringToCloudFormation)(properties.order), SelectedFieldOptions: cdk.listMapper(cfnDashboardTableFieldOptionPropertyToCloudFormation)(properties.selectedFieldOptions) }) : properties;
    }
    function CfnDashboardTableFieldOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("order", "Order", properties.Order != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Order) : void 0), ret.addPropertyResult("selectedFieldOptions", "SelectedFieldOptions", properties.SelectedFieldOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardTableFieldOptionPropertyFromCloudFormation)(properties.SelectedFieldOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TableFieldURLConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("imageConfiguration", CfnDashboard_TableFieldImageConfigurationPropertyValidator)(properties.imageConfiguration)), errors.collect(cdk.propertyValidator("linkConfiguration", CfnDashboard_TableFieldLinkConfigurationPropertyValidator)(properties.linkConfiguration)), errors.wrap('supplied properties not correct for "TableFieldURLConfigurationProperty"');
    }
    function cfnDashboardTableFieldURLConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TableFieldURLConfigurationPropertyValidator(properties).assertSuccess(), { ImageConfiguration: cfnDashboardTableFieldImageConfigurationPropertyToCloudFormation(properties.imageConfiguration), LinkConfiguration: cfnDashboardTableFieldLinkConfigurationPropertyToCloudFormation(properties.linkConfiguration) }) : properties;
    }
    function CfnDashboardTableFieldURLConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("imageConfiguration", "ImageConfiguration", properties.ImageConfiguration != null ? CfnDashboardTableFieldImageConfigurationPropertyFromCloudFormation(properties.ImageConfiguration) : void 0), ret.addPropertyResult("linkConfiguration", "LinkConfiguration", properties.LinkConfiguration != null ? CfnDashboardTableFieldLinkConfigurationPropertyFromCloudFormation(properties.LinkConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TableFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("tableAggregatedFieldWells", CfnDashboard_TableAggregatedFieldWellsPropertyValidator)(properties.tableAggregatedFieldWells)), errors.collect(cdk.propertyValidator("tableUnaggregatedFieldWells", CfnDashboard_TableUnaggregatedFieldWellsPropertyValidator)(properties.tableUnaggregatedFieldWells)), errors.wrap('supplied properties not correct for "TableFieldWellsProperty"');
    }
    function cfnDashboardTableFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TableFieldWellsPropertyValidator(properties).assertSuccess(), { TableAggregatedFieldWells: cfnDashboardTableAggregatedFieldWellsPropertyToCloudFormation(properties.tableAggregatedFieldWells), TableUnaggregatedFieldWells: cfnDashboardTableUnaggregatedFieldWellsPropertyToCloudFormation(properties.tableUnaggregatedFieldWells) }) : properties;
    }
    function CfnDashboardTableFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("tableAggregatedFieldWells", "TableAggregatedFieldWells", properties.TableAggregatedFieldWells != null ? CfnDashboardTableAggregatedFieldWellsPropertyFromCloudFormation(properties.TableAggregatedFieldWells) : void 0), ret.addPropertyResult("tableUnaggregatedFieldWells", "TableUnaggregatedFieldWells", properties.TableUnaggregatedFieldWells != null ? CfnDashboardTableUnaggregatedFieldWellsPropertyFromCloudFormation(properties.TableUnaggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TableInlineVisualizationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataBars", CfnDashboard_DataBarsOptionsPropertyValidator)(properties.dataBars)), errors.wrap('supplied properties not correct for "TableInlineVisualizationProperty"');
    }
    function cfnDashboardTableInlineVisualizationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TableInlineVisualizationPropertyValidator(properties).assertSuccess(), { DataBars: cfnDashboardDataBarsOptionsPropertyToCloudFormation(properties.dataBars) }) : properties;
    }
    function CfnDashboardTableInlineVisualizationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataBars", "DataBars", properties.DataBars != null ? CfnDashboardDataBarsOptionsPropertyFromCloudFormation(properties.DataBars) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TableOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cellStyle", CfnDashboard_TableCellStylePropertyValidator)(properties.cellStyle)), errors.collect(cdk.propertyValidator("headerStyle", CfnDashboard_TableCellStylePropertyValidator)(properties.headerStyle)), errors.collect(cdk.propertyValidator("orientation", cdk.validateString)(properties.orientation)), errors.collect(cdk.propertyValidator("rowAlternateColorOptions", CfnDashboard_RowAlternateColorOptionsPropertyValidator)(properties.rowAlternateColorOptions)), errors.wrap('supplied properties not correct for "TableOptionsProperty"');
    }
    function cfnDashboardTableOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TableOptionsPropertyValidator(properties).assertSuccess(), { CellStyle: cfnDashboardTableCellStylePropertyToCloudFormation(properties.cellStyle), HeaderStyle: cfnDashboardTableCellStylePropertyToCloudFormation(properties.headerStyle), Orientation: cdk.stringToCloudFormation(properties.orientation), RowAlternateColorOptions: cfnDashboardRowAlternateColorOptionsPropertyToCloudFormation(properties.rowAlternateColorOptions) }) : properties;
    }
    function CfnDashboardTableOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cellStyle", "CellStyle", properties.CellStyle != null ? CfnDashboardTableCellStylePropertyFromCloudFormation(properties.CellStyle) : void 0), ret.addPropertyResult("headerStyle", "HeaderStyle", properties.HeaderStyle != null ? CfnDashboardTableCellStylePropertyFromCloudFormation(properties.HeaderStyle) : void 0), ret.addPropertyResult("orientation", "Orientation", properties.Orientation != null ? cfn_parse.FromCloudFormation.getString(properties.Orientation) : void 0), ret.addPropertyResult("rowAlternateColorOptions", "RowAlternateColorOptions", properties.RowAlternateColorOptions != null ? CfnDashboardRowAlternateColorOptionsPropertyFromCloudFormation(properties.RowAlternateColorOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TablePaginatedReportOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("overflowColumnHeaderVisibility", cdk.validateString)(properties.overflowColumnHeaderVisibility)), errors.collect(cdk.propertyValidator("verticalOverflowVisibility", cdk.validateString)(properties.verticalOverflowVisibility)), errors.wrap('supplied properties not correct for "TablePaginatedReportOptionsProperty"');
    }
    function cfnDashboardTablePaginatedReportOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TablePaginatedReportOptionsPropertyValidator(properties).assertSuccess(), { OverflowColumnHeaderVisibility: cdk.stringToCloudFormation(properties.overflowColumnHeaderVisibility), VerticalOverflowVisibility: cdk.stringToCloudFormation(properties.verticalOverflowVisibility) }) : properties;
    }
    function CfnDashboardTablePaginatedReportOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("overflowColumnHeaderVisibility", "OverflowColumnHeaderVisibility", properties.OverflowColumnHeaderVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.OverflowColumnHeaderVisibility) : void 0), ret.addPropertyResult("verticalOverflowVisibility", "VerticalOverflowVisibility", properties.VerticalOverflowVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.VerticalOverflowVisibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TableRowConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("backgroundColor", CfnDashboard_ConditionalFormattingColorPropertyValidator)(properties.backgroundColor)), errors.collect(cdk.propertyValidator("textColor", CfnDashboard_ConditionalFormattingColorPropertyValidator)(properties.textColor)), errors.wrap('supplied properties not correct for "TableRowConditionalFormattingProperty"');
    }
    function cfnDashboardTableRowConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TableRowConditionalFormattingPropertyValidator(properties).assertSuccess(), { BackgroundColor: cfnDashboardConditionalFormattingColorPropertyToCloudFormation(properties.backgroundColor), TextColor: cfnDashboardConditionalFormattingColorPropertyToCloudFormation(properties.textColor) }) : properties;
    }
    function CfnDashboardTableRowConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("backgroundColor", "BackgroundColor", properties.BackgroundColor != null ? CfnDashboardConditionalFormattingColorPropertyFromCloudFormation(properties.BackgroundColor) : void 0), ret.addPropertyResult("textColor", "TextColor", properties.TextColor != null ? CfnDashboardConditionalFormattingColorPropertyFromCloudFormation(properties.TextColor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TableSideBorderOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bottom", CfnDashboard_TableBorderOptionsPropertyValidator)(properties.bottom)), errors.collect(cdk.propertyValidator("innerHorizontal", CfnDashboard_TableBorderOptionsPropertyValidator)(properties.innerHorizontal)), errors.collect(cdk.propertyValidator("innerVertical", CfnDashboard_TableBorderOptionsPropertyValidator)(properties.innerVertical)), errors.collect(cdk.propertyValidator("left", CfnDashboard_TableBorderOptionsPropertyValidator)(properties.left)), errors.collect(cdk.propertyValidator("right", CfnDashboard_TableBorderOptionsPropertyValidator)(properties.right)), errors.collect(cdk.propertyValidator("top", CfnDashboard_TableBorderOptionsPropertyValidator)(properties.top)), errors.wrap('supplied properties not correct for "TableSideBorderOptionsProperty"');
    }
    function cfnDashboardTableSideBorderOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TableSideBorderOptionsPropertyValidator(properties).assertSuccess(), { Bottom: cfnDashboardTableBorderOptionsPropertyToCloudFormation(properties.bottom), InnerHorizontal: cfnDashboardTableBorderOptionsPropertyToCloudFormation(properties.innerHorizontal), InnerVertical: cfnDashboardTableBorderOptionsPropertyToCloudFormation(properties.innerVertical), Left: cfnDashboardTableBorderOptionsPropertyToCloudFormation(properties.left), Right: cfnDashboardTableBorderOptionsPropertyToCloudFormation(properties.right), Top: cfnDashboardTableBorderOptionsPropertyToCloudFormation(properties.top) }) : properties;
    }
    function CfnDashboardTableSideBorderOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bottom", "Bottom", properties.Bottom != null ? CfnDashboardTableBorderOptionsPropertyFromCloudFormation(properties.Bottom) : void 0), ret.addPropertyResult("innerHorizontal", "InnerHorizontal", properties.InnerHorizontal != null ? CfnDashboardTableBorderOptionsPropertyFromCloudFormation(properties.InnerHorizontal) : void 0), ret.addPropertyResult("innerVertical", "InnerVertical", properties.InnerVertical != null ? CfnDashboardTableBorderOptionsPropertyFromCloudFormation(properties.InnerVertical) : void 0), ret.addPropertyResult("left", "Left", properties.Left != null ? CfnDashboardTableBorderOptionsPropertyFromCloudFormation(properties.Left) : void 0), ret.addPropertyResult("right", "Right", properties.Right != null ? CfnDashboardTableBorderOptionsPropertyFromCloudFormation(properties.Right) : void 0), ret.addPropertyResult("top", "Top", properties.Top != null ? CfnDashboardTableBorderOptionsPropertyFromCloudFormation(properties.Top) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TableSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("paginationConfiguration", CfnDashboard_PaginationConfigurationPropertyValidator)(properties.paginationConfiguration)), errors.collect(cdk.propertyValidator("rowSort", cdk.listValidator(CfnDashboard_FieldSortOptionsPropertyValidator))(properties.rowSort)), errors.wrap('supplied properties not correct for "TableSortConfigurationProperty"');
    }
    function cfnDashboardTableSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TableSortConfigurationPropertyValidator(properties).assertSuccess(), { PaginationConfiguration: cfnDashboardPaginationConfigurationPropertyToCloudFormation(properties.paginationConfiguration), RowSort: cdk.listMapper(cfnDashboardFieldSortOptionsPropertyToCloudFormation)(properties.rowSort) }) : properties;
    }
    function CfnDashboardTableSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("paginationConfiguration", "PaginationConfiguration", properties.PaginationConfiguration != null ? CfnDashboardPaginationConfigurationPropertyFromCloudFormation(properties.PaginationConfiguration) : void 0), ret.addPropertyResult("rowSort", "RowSort", properties.RowSort != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardFieldSortOptionsPropertyFromCloudFormation)(properties.RowSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TableUnaggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnDashboard_UnaggregatedFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "TableUnaggregatedFieldWellsProperty"');
    }
    function cfnDashboardTableUnaggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TableUnaggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Values: cdk.listMapper(cfnDashboardUnaggregatedFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnDashboardTableUnaggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardUnaggregatedFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TableVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnDashboard_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnDashboard_TableConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("conditionalFormatting", CfnDashboard_TableConditionalFormattingPropertyValidator)(properties.conditionalFormatting)), errors.collect(cdk.propertyValidator("subtitle", CfnDashboard_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnDashboard_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "TableVisualProperty"');
    }
    function cfnDashboardTableVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TableVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnDashboardVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnDashboardTableConfigurationPropertyToCloudFormation(properties.chartConfiguration), ConditionalFormatting: cfnDashboardTableConditionalFormattingPropertyToCloudFormation(properties.conditionalFormatting), Subtitle: cfnDashboardVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnDashboardVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnDashboardTableVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnDashboardTableConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("conditionalFormatting", "ConditionalFormatting", properties.ConditionalFormatting != null ? CfnDashboardTableConditionalFormattingPropertyFromCloudFormation(properties.ConditionalFormatting) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnDashboardVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnDashboardVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TextAreaControlDisplayOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("placeholderOptions", CfnDashboard_TextControlPlaceholderOptionsPropertyValidator)(properties.placeholderOptions)), errors.collect(cdk.propertyValidator("titleOptions", CfnDashboard_LabelOptionsPropertyValidator)(properties.titleOptions)), errors.wrap('supplied properties not correct for "TextAreaControlDisplayOptionsProperty"');
    }
    function cfnDashboardTextAreaControlDisplayOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TextAreaControlDisplayOptionsPropertyValidator(properties).assertSuccess(), { PlaceholderOptions: cfnDashboardTextControlPlaceholderOptionsPropertyToCloudFormation(properties.placeholderOptions), TitleOptions: cfnDashboardLabelOptionsPropertyToCloudFormation(properties.titleOptions) }) : properties;
    }
    function CfnDashboardTextAreaControlDisplayOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("placeholderOptions", "PlaceholderOptions", properties.PlaceholderOptions != null ? CfnDashboardTextControlPlaceholderOptionsPropertyFromCloudFormation(properties.PlaceholderOptions) : void 0), ret.addPropertyResult("titleOptions", "TitleOptions", properties.TitleOptions != null ? CfnDashboardLabelOptionsPropertyFromCloudFormation(properties.TitleOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TextConditionalFormatPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("backgroundColor", CfnDashboard_ConditionalFormattingColorPropertyValidator)(properties.backgroundColor)), errors.collect(cdk.propertyValidator("icon", CfnDashboard_ConditionalFormattingIconPropertyValidator)(properties.icon)), errors.collect(cdk.propertyValidator("textColor", CfnDashboard_ConditionalFormattingColorPropertyValidator)(properties.textColor)), errors.wrap('supplied properties not correct for "TextConditionalFormatProperty"');
    }
    function cfnDashboardTextConditionalFormatPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TextConditionalFormatPropertyValidator(properties).assertSuccess(), { BackgroundColor: cfnDashboardConditionalFormattingColorPropertyToCloudFormation(properties.backgroundColor), Icon: cfnDashboardConditionalFormattingIconPropertyToCloudFormation(properties.icon), TextColor: cfnDashboardConditionalFormattingColorPropertyToCloudFormation(properties.textColor) }) : properties;
    }
    function CfnDashboardTextConditionalFormatPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("backgroundColor", "BackgroundColor", properties.BackgroundColor != null ? CfnDashboardConditionalFormattingColorPropertyFromCloudFormation(properties.BackgroundColor) : void 0), ret.addPropertyResult("icon", "Icon", properties.Icon != null ? CfnDashboardConditionalFormattingIconPropertyFromCloudFormation(properties.Icon) : void 0), ret.addPropertyResult("textColor", "TextColor", properties.TextColor != null ? CfnDashboardConditionalFormattingColorPropertyFromCloudFormation(properties.TextColor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TextControlPlaceholderOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "TextControlPlaceholderOptionsProperty"');
    }
    function cfnDashboardTextControlPlaceholderOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TextControlPlaceholderOptionsPropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnDashboardTextControlPlaceholderOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TextFieldControlDisplayOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("placeholderOptions", CfnDashboard_TextControlPlaceholderOptionsPropertyValidator)(properties.placeholderOptions)), errors.collect(cdk.propertyValidator("titleOptions", CfnDashboard_LabelOptionsPropertyValidator)(properties.titleOptions)), errors.wrap('supplied properties not correct for "TextFieldControlDisplayOptionsProperty"');
    }
    function cfnDashboardTextFieldControlDisplayOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TextFieldControlDisplayOptionsPropertyValidator(properties).assertSuccess(), { PlaceholderOptions: cfnDashboardTextControlPlaceholderOptionsPropertyToCloudFormation(properties.placeholderOptions), TitleOptions: cfnDashboardLabelOptionsPropertyToCloudFormation(properties.titleOptions) }) : properties;
    }
    function CfnDashboardTextFieldControlDisplayOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("placeholderOptions", "PlaceholderOptions", properties.PlaceholderOptions != null ? CfnDashboardTextControlPlaceholderOptionsPropertyFromCloudFormation(properties.PlaceholderOptions) : void 0), ret.addPropertyResult("titleOptions", "TitleOptions", properties.TitleOptions != null ? CfnDashboardLabelOptionsPropertyFromCloudFormation(properties.TitleOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_ThousandSeparatorOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("symbol", cdk.validateString)(properties.symbol)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "ThousandSeparatorOptionsProperty"');
    }
    function cfnDashboardThousandSeparatorOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_ThousandSeparatorOptionsPropertyValidator(properties).assertSuccess(), { Symbol: cdk.stringToCloudFormation(properties.symbol), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnDashboardThousandSeparatorOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("symbol", "Symbol", properties.Symbol != null ? cfn_parse.FromCloudFormation.getString(properties.Symbol) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TimeBasedForecastPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("lowerBoundary", cdk.validateNumber)(properties.lowerBoundary)), errors.collect(cdk.propertyValidator("periodsBackward", cdk.validateNumber)(properties.periodsBackward)), errors.collect(cdk.propertyValidator("periodsForward", cdk.validateNumber)(properties.periodsForward)), errors.collect(cdk.propertyValidator("predictionInterval", cdk.validateNumber)(properties.predictionInterval)), errors.collect(cdk.propertyValidator("seasonality", cdk.validateNumber)(properties.seasonality)), errors.collect(cdk.propertyValidator("upperBoundary", cdk.validateNumber)(properties.upperBoundary)), errors.wrap('supplied properties not correct for "TimeBasedForecastPropertiesProperty"');
    }
    function cfnDashboardTimeBasedForecastPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TimeBasedForecastPropertiesPropertyValidator(properties).assertSuccess(), { LowerBoundary: cdk.numberToCloudFormation(properties.lowerBoundary), PeriodsBackward: cdk.numberToCloudFormation(properties.periodsBackward), PeriodsForward: cdk.numberToCloudFormation(properties.periodsForward), PredictionInterval: cdk.numberToCloudFormation(properties.predictionInterval), Seasonality: cdk.numberToCloudFormation(properties.seasonality), UpperBoundary: cdk.numberToCloudFormation(properties.upperBoundary) }) : properties;
    }
    function CfnDashboardTimeBasedForecastPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("lowerBoundary", "LowerBoundary", properties.LowerBoundary != null ? cfn_parse.FromCloudFormation.getNumber(properties.LowerBoundary) : void 0), ret.addPropertyResult("periodsBackward", "PeriodsBackward", properties.PeriodsBackward != null ? cfn_parse.FromCloudFormation.getNumber(properties.PeriodsBackward) : void 0), ret.addPropertyResult("periodsForward", "PeriodsForward", properties.PeriodsForward != null ? cfn_parse.FromCloudFormation.getNumber(properties.PeriodsForward) : void 0), ret.addPropertyResult("predictionInterval", "PredictionInterval", properties.PredictionInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.PredictionInterval) : void 0), ret.addPropertyResult("seasonality", "Seasonality", properties.Seasonality != null ? cfn_parse.FromCloudFormation.getNumber(properties.Seasonality) : void 0), ret.addPropertyResult("upperBoundary", "UpperBoundary", properties.UpperBoundary != null ? cfn_parse.FromCloudFormation.getNumber(properties.UpperBoundary) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TimeEqualityFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnDashboard_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("filterId", cdk.requiredValidator)(properties.filterId)), errors.collect(cdk.propertyValidator("filterId", cdk.validateString)(properties.filterId)), errors.collect(cdk.propertyValidator("parameterName", cdk.validateString)(properties.parameterName)), errors.collect(cdk.propertyValidator("timeGranularity", cdk.validateString)(properties.timeGranularity)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TimeEqualityFilterProperty"');
    }
    function cfnDashboardTimeEqualityFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TimeEqualityFilterPropertyValidator(properties).assertSuccess(), { Column: cfnDashboardColumnIdentifierPropertyToCloudFormation(properties.column), FilterId: cdk.stringToCloudFormation(properties.filterId), ParameterName: cdk.stringToCloudFormation(properties.parameterName), TimeGranularity: cdk.stringToCloudFormation(properties.timeGranularity), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnDashboardTimeEqualityFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", CfnDashboardColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("filterId", "FilterId", cfn_parse.FromCloudFormation.getString(properties.FilterId)), ret.addPropertyResult("parameterName", "ParameterName", properties.ParameterName != null ? cfn_parse.FromCloudFormation.getString(properties.ParameterName) : void 0), ret.addPropertyResult("timeGranularity", "TimeGranularity", properties.TimeGranularity != null ? cfn_parse.FromCloudFormation.getString(properties.TimeGranularity) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TimeRangeDrillDownFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnDashboard_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("rangeMaximum", cdk.requiredValidator)(properties.rangeMaximum)), errors.collect(cdk.propertyValidator("rangeMaximum", cdk.validateString)(properties.rangeMaximum)), errors.collect(cdk.propertyValidator("rangeMinimum", cdk.requiredValidator)(properties.rangeMinimum)), errors.collect(cdk.propertyValidator("rangeMinimum", cdk.validateString)(properties.rangeMinimum)), errors.collect(cdk.propertyValidator("timeGranularity", cdk.requiredValidator)(properties.timeGranularity)), errors.collect(cdk.propertyValidator("timeGranularity", cdk.validateString)(properties.timeGranularity)), errors.wrap('supplied properties not correct for "TimeRangeDrillDownFilterProperty"');
    }
    function cfnDashboardTimeRangeDrillDownFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TimeRangeDrillDownFilterPropertyValidator(properties).assertSuccess(), { Column: cfnDashboardColumnIdentifierPropertyToCloudFormation(properties.column), RangeMaximum: cdk.stringToCloudFormation(properties.rangeMaximum), RangeMinimum: cdk.stringToCloudFormation(properties.rangeMinimum), TimeGranularity: cdk.stringToCloudFormation(properties.timeGranularity) }) : properties;
    }
    function CfnDashboardTimeRangeDrillDownFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", CfnDashboardColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("rangeMaximum", "RangeMaximum", cfn_parse.FromCloudFormation.getString(properties.RangeMaximum)), ret.addPropertyResult("rangeMinimum", "RangeMinimum", cfn_parse.FromCloudFormation.getString(properties.RangeMinimum)), ret.addPropertyResult("timeGranularity", "TimeGranularity", cfn_parse.FromCloudFormation.getString(properties.TimeGranularity)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TimeRangeFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnDashboard_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("excludePeriodConfiguration", CfnDashboard_ExcludePeriodConfigurationPropertyValidator)(properties.excludePeriodConfiguration)), errors.collect(cdk.propertyValidator("filterId", cdk.requiredValidator)(properties.filterId)), errors.collect(cdk.propertyValidator("filterId", cdk.validateString)(properties.filterId)), errors.collect(cdk.propertyValidator("includeMaximum", cdk.validateBoolean)(properties.includeMaximum)), errors.collect(cdk.propertyValidator("includeMinimum", cdk.validateBoolean)(properties.includeMinimum)), errors.collect(cdk.propertyValidator("nullOption", cdk.requiredValidator)(properties.nullOption)), errors.collect(cdk.propertyValidator("nullOption", cdk.validateString)(properties.nullOption)), errors.collect(cdk.propertyValidator("rangeMaximumValue", CfnDashboard_TimeRangeFilterValuePropertyValidator)(properties.rangeMaximumValue)), errors.collect(cdk.propertyValidator("rangeMinimumValue", CfnDashboard_TimeRangeFilterValuePropertyValidator)(properties.rangeMinimumValue)), errors.collect(cdk.propertyValidator("timeGranularity", cdk.validateString)(properties.timeGranularity)), errors.wrap('supplied properties not correct for "TimeRangeFilterProperty"');
    }
    function cfnDashboardTimeRangeFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TimeRangeFilterPropertyValidator(properties).assertSuccess(), { Column: cfnDashboardColumnIdentifierPropertyToCloudFormation(properties.column), ExcludePeriodConfiguration: cfnDashboardExcludePeriodConfigurationPropertyToCloudFormation(properties.excludePeriodConfiguration), FilterId: cdk.stringToCloudFormation(properties.filterId), IncludeMaximum: cdk.booleanToCloudFormation(properties.includeMaximum), IncludeMinimum: cdk.booleanToCloudFormation(properties.includeMinimum), NullOption: cdk.stringToCloudFormation(properties.nullOption), RangeMaximumValue: cfnDashboardTimeRangeFilterValuePropertyToCloudFormation(properties.rangeMaximumValue), RangeMinimumValue: cfnDashboardTimeRangeFilterValuePropertyToCloudFormation(properties.rangeMinimumValue), TimeGranularity: cdk.stringToCloudFormation(properties.timeGranularity) }) : properties;
    }
    function CfnDashboardTimeRangeFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", CfnDashboardColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("excludePeriodConfiguration", "ExcludePeriodConfiguration", properties.ExcludePeriodConfiguration != null ? CfnDashboardExcludePeriodConfigurationPropertyFromCloudFormation(properties.ExcludePeriodConfiguration) : void 0), ret.addPropertyResult("filterId", "FilterId", cfn_parse.FromCloudFormation.getString(properties.FilterId)), ret.addPropertyResult("includeMaximum", "IncludeMaximum", properties.IncludeMaximum != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeMaximum) : void 0), ret.addPropertyResult("includeMinimum", "IncludeMinimum", properties.IncludeMinimum != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeMinimum) : void 0), ret.addPropertyResult("nullOption", "NullOption", cfn_parse.FromCloudFormation.getString(properties.NullOption)), ret.addPropertyResult("rangeMaximumValue", "RangeMaximumValue", properties.RangeMaximumValue != null ? CfnDashboardTimeRangeFilterValuePropertyFromCloudFormation(properties.RangeMaximumValue) : void 0), ret.addPropertyResult("rangeMinimumValue", "RangeMinimumValue", properties.RangeMinimumValue != null ? CfnDashboardTimeRangeFilterValuePropertyFromCloudFormation(properties.RangeMinimumValue) : void 0), ret.addPropertyResult("timeGranularity", "TimeGranularity", properties.TimeGranularity != null ? cfn_parse.FromCloudFormation.getString(properties.TimeGranularity) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TimeRangeFilterValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("parameter", cdk.validateString)(properties.parameter)), errors.collect(cdk.propertyValidator("rollingDate", CfnDashboard_RollingDateConfigurationPropertyValidator)(properties.rollingDate)), errors.collect(cdk.propertyValidator("staticValue", cdk.validateString)(properties.staticValue)), errors.wrap('supplied properties not correct for "TimeRangeFilterValueProperty"');
    }
    function cfnDashboardTimeRangeFilterValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TimeRangeFilterValuePropertyValidator(properties).assertSuccess(), { Parameter: cdk.stringToCloudFormation(properties.parameter), RollingDate: cfnDashboardRollingDateConfigurationPropertyToCloudFormation(properties.rollingDate), StaticValue: cdk.stringToCloudFormation(properties.staticValue) }) : properties;
    }
    function CfnDashboardTimeRangeFilterValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("parameter", "Parameter", properties.Parameter != null ? cfn_parse.FromCloudFormation.getString(properties.Parameter) : void 0), ret.addPropertyResult("rollingDate", "RollingDate", properties.RollingDate != null ? CfnDashboardRollingDateConfigurationPropertyFromCloudFormation(properties.RollingDate) : void 0), ret.addPropertyResult("staticValue", "StaticValue", properties.StaticValue != null ? cfn_parse.FromCloudFormation.getString(properties.StaticValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TooltipItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnTooltipItem", CfnDashboard_ColumnTooltipItemPropertyValidator)(properties.columnTooltipItem)), errors.collect(cdk.propertyValidator("fieldTooltipItem", CfnDashboard_FieldTooltipItemPropertyValidator)(properties.fieldTooltipItem)), errors.wrap('supplied properties not correct for "TooltipItemProperty"');
    }
    function cfnDashboardTooltipItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TooltipItemPropertyValidator(properties).assertSuccess(), { ColumnTooltipItem: cfnDashboardColumnTooltipItemPropertyToCloudFormation(properties.columnTooltipItem), FieldTooltipItem: cfnDashboardFieldTooltipItemPropertyToCloudFormation(properties.fieldTooltipItem) }) : properties;
    }
    function CfnDashboardTooltipItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columnTooltipItem", "ColumnTooltipItem", properties.ColumnTooltipItem != null ? CfnDashboardColumnTooltipItemPropertyFromCloudFormation(properties.ColumnTooltipItem) : void 0), ret.addPropertyResult("fieldTooltipItem", "FieldTooltipItem", properties.FieldTooltipItem != null ? CfnDashboardFieldTooltipItemPropertyFromCloudFormation(properties.FieldTooltipItem) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TooltipOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldBasedTooltip", CfnDashboard_FieldBasedTooltipPropertyValidator)(properties.fieldBasedTooltip)), errors.collect(cdk.propertyValidator("selectedTooltipType", cdk.validateString)(properties.selectedTooltipType)), errors.collect(cdk.propertyValidator("tooltipVisibility", cdk.validateString)(properties.tooltipVisibility)), errors.wrap('supplied properties not correct for "TooltipOptionsProperty"');
    }
    function cfnDashboardTooltipOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TooltipOptionsPropertyValidator(properties).assertSuccess(), { FieldBasedTooltip: cfnDashboardFieldBasedTooltipPropertyToCloudFormation(properties.fieldBasedTooltip), SelectedTooltipType: cdk.stringToCloudFormation(properties.selectedTooltipType), TooltipVisibility: cdk.stringToCloudFormation(properties.tooltipVisibility) }) : properties;
    }
    function CfnDashboardTooltipOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldBasedTooltip", "FieldBasedTooltip", properties.FieldBasedTooltip != null ? CfnDashboardFieldBasedTooltipPropertyFromCloudFormation(properties.FieldBasedTooltip) : void 0), ret.addPropertyResult("selectedTooltipType", "SelectedTooltipType", properties.SelectedTooltipType != null ? cfn_parse.FromCloudFormation.getString(properties.SelectedTooltipType) : void 0), ret.addPropertyResult("tooltipVisibility", "TooltipVisibility", properties.TooltipVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.TooltipVisibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TopBottomFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationSortConfigurations", cdk.requiredValidator)(properties.aggregationSortConfigurations)), errors.collect(cdk.propertyValidator("aggregationSortConfigurations", cdk.listValidator(CfnDashboard_AggregationSortConfigurationPropertyValidator))(properties.aggregationSortConfigurations)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnDashboard_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("filterId", cdk.requiredValidator)(properties.filterId)), errors.collect(cdk.propertyValidator("filterId", cdk.validateString)(properties.filterId)), errors.collect(cdk.propertyValidator("limit", cdk.validateNumber)(properties.limit)), errors.collect(cdk.propertyValidator("parameterName", cdk.validateString)(properties.parameterName)), errors.collect(cdk.propertyValidator("timeGranularity", cdk.validateString)(properties.timeGranularity)), errors.wrap('supplied properties not correct for "TopBottomFilterProperty"');
    }
    function cfnDashboardTopBottomFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TopBottomFilterPropertyValidator(properties).assertSuccess(), { AggregationSortConfigurations: cdk.listMapper(cfnDashboardAggregationSortConfigurationPropertyToCloudFormation)(properties.aggregationSortConfigurations), Column: cfnDashboardColumnIdentifierPropertyToCloudFormation(properties.column), FilterId: cdk.stringToCloudFormation(properties.filterId), Limit: cdk.numberToCloudFormation(properties.limit), ParameterName: cdk.stringToCloudFormation(properties.parameterName), TimeGranularity: cdk.stringToCloudFormation(properties.timeGranularity) }) : properties;
    }
    function CfnDashboardTopBottomFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationSortConfigurations", "AggregationSortConfigurations", cfn_parse.FromCloudFormation.getArray(CfnDashboardAggregationSortConfigurationPropertyFromCloudFormation)(properties.AggregationSortConfigurations)), ret.addPropertyResult("column", "Column", CfnDashboardColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("filterId", "FilterId", cfn_parse.FromCloudFormation.getString(properties.FilterId)), ret.addPropertyResult("limit", "Limit", properties.Limit != null ? cfn_parse.FromCloudFormation.getNumber(properties.Limit) : void 0), ret.addPropertyResult("parameterName", "ParameterName", properties.ParameterName != null ? cfn_parse.FromCloudFormation.getString(properties.ParameterName) : void 0), ret.addPropertyResult("timeGranularity", "TimeGranularity", properties.TimeGranularity != null ? cfn_parse.FromCloudFormation.getString(properties.TimeGranularity) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TopBottomMoversComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("category", cdk.requiredValidator)(properties.category)), errors.collect(cdk.propertyValidator("category", CfnDashboard_DimensionFieldPropertyValidator)(properties.category)), errors.collect(cdk.propertyValidator("computationId", cdk.requiredValidator)(properties.computationId)), errors.collect(cdk.propertyValidator("computationId", cdk.validateString)(properties.computationId)), errors.collect(cdk.propertyValidator("moverSize", cdk.validateNumber)(properties.moverSize)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("sortOrder", cdk.validateString)(properties.sortOrder)), errors.collect(cdk.propertyValidator("time", cdk.requiredValidator)(properties.time)), errors.collect(cdk.propertyValidator("time", CfnDashboard_DimensionFieldPropertyValidator)(properties.time)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", CfnDashboard_MeasureFieldPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "TopBottomMoversComputationProperty"');
    }
    function cfnDashboardTopBottomMoversComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TopBottomMoversComputationPropertyValidator(properties).assertSuccess(), { Category: cfnDashboardDimensionFieldPropertyToCloudFormation(properties.category), ComputationId: cdk.stringToCloudFormation(properties.computationId), MoverSize: cdk.numberToCloudFormation(properties.moverSize), Name: cdk.stringToCloudFormation(properties.name), SortOrder: cdk.stringToCloudFormation(properties.sortOrder), Time: cfnDashboardDimensionFieldPropertyToCloudFormation(properties.time), Type: cdk.stringToCloudFormation(properties.type), Value: cfnDashboardMeasureFieldPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnDashboardTopBottomMoversComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("category", "Category", CfnDashboardDimensionFieldPropertyFromCloudFormation(properties.Category)), ret.addPropertyResult("computationId", "ComputationId", cfn_parse.FromCloudFormation.getString(properties.ComputationId)), ret.addPropertyResult("moverSize", "MoverSize", properties.MoverSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.MoverSize) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("sortOrder", "SortOrder", properties.SortOrder != null ? cfn_parse.FromCloudFormation.getString(properties.SortOrder) : void 0), ret.addPropertyResult("time", "Time", CfnDashboardDimensionFieldPropertyFromCloudFormation(properties.Time)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("value", "Value", properties.Value != null ? CfnDashboardMeasureFieldPropertyFromCloudFormation(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TopBottomRankedComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("category", cdk.requiredValidator)(properties.category)), errors.collect(cdk.propertyValidator("category", CfnDashboard_DimensionFieldPropertyValidator)(properties.category)), errors.collect(cdk.propertyValidator("computationId", cdk.requiredValidator)(properties.computationId)), errors.collect(cdk.propertyValidator("computationId", cdk.validateString)(properties.computationId)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("resultSize", cdk.validateNumber)(properties.resultSize)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", CfnDashboard_MeasureFieldPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "TopBottomRankedComputationProperty"');
    }
    function cfnDashboardTopBottomRankedComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TopBottomRankedComputationPropertyValidator(properties).assertSuccess(), { Category: cfnDashboardDimensionFieldPropertyToCloudFormation(properties.category), ComputationId: cdk.stringToCloudFormation(properties.computationId), Name: cdk.stringToCloudFormation(properties.name), ResultSize: cdk.numberToCloudFormation(properties.resultSize), Type: cdk.stringToCloudFormation(properties.type), Value: cfnDashboardMeasureFieldPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnDashboardTopBottomRankedComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("category", "Category", CfnDashboardDimensionFieldPropertyFromCloudFormation(properties.Category)), ret.addPropertyResult("computationId", "ComputationId", cfn_parse.FromCloudFormation.getString(properties.ComputationId)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("resultSize", "ResultSize", properties.ResultSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.ResultSize) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("value", "Value", properties.Value != null ? CfnDashboardMeasureFieldPropertyFromCloudFormation(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TotalAggregationComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computationId", cdk.requiredValidator)(properties.computationId)), errors.collect(cdk.propertyValidator("computationId", cdk.validateString)(properties.computationId)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", CfnDashboard_MeasureFieldPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "TotalAggregationComputationProperty"');
    }
    function cfnDashboardTotalAggregationComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TotalAggregationComputationPropertyValidator(properties).assertSuccess(), { ComputationId: cdk.stringToCloudFormation(properties.computationId), Name: cdk.stringToCloudFormation(properties.name), Value: cfnDashboardMeasureFieldPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnDashboardTotalAggregationComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computationId", "ComputationId", cfn_parse.FromCloudFormation.getString(properties.ComputationId)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("value", "Value", CfnDashboardMeasureFieldPropertyFromCloudFormation(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TotalOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customLabel", cdk.validateString)(properties.customLabel)), errors.collect(cdk.propertyValidator("placement", cdk.validateString)(properties.placement)), errors.collect(cdk.propertyValidator("scrollStatus", cdk.validateString)(properties.scrollStatus)), errors.collect(cdk.propertyValidator("totalCellStyle", CfnDashboard_TableCellStylePropertyValidator)(properties.totalCellStyle)), errors.collect(cdk.propertyValidator("totalsVisibility", cdk.validateString)(properties.totalsVisibility)), errors.wrap('supplied properties not correct for "TotalOptionsProperty"');
    }
    function cfnDashboardTotalOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TotalOptionsPropertyValidator(properties).assertSuccess(), { CustomLabel: cdk.stringToCloudFormation(properties.customLabel), Placement: cdk.stringToCloudFormation(properties.placement), ScrollStatus: cdk.stringToCloudFormation(properties.scrollStatus), TotalCellStyle: cfnDashboardTableCellStylePropertyToCloudFormation(properties.totalCellStyle), TotalsVisibility: cdk.stringToCloudFormation(properties.totalsVisibility) }) : properties;
    }
    function CfnDashboardTotalOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customLabel", "CustomLabel", properties.CustomLabel != null ? cfn_parse.FromCloudFormation.getString(properties.CustomLabel) : void 0), ret.addPropertyResult("placement", "Placement", properties.Placement != null ? cfn_parse.FromCloudFormation.getString(properties.Placement) : void 0), ret.addPropertyResult("scrollStatus", "ScrollStatus", properties.ScrollStatus != null ? cfn_parse.FromCloudFormation.getString(properties.ScrollStatus) : void 0), ret.addPropertyResult("totalCellStyle", "TotalCellStyle", properties.TotalCellStyle != null ? CfnDashboardTableCellStylePropertyFromCloudFormation(properties.TotalCellStyle) : void 0), ret.addPropertyResult("totalsVisibility", "TotalsVisibility", properties.TotalsVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.TotalsVisibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TreeMapAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("colors", cdk.listValidator(CfnDashboard_MeasureFieldPropertyValidator))(properties.colors)), errors.collect(cdk.propertyValidator("groups", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.groups)), errors.collect(cdk.propertyValidator("sizes", cdk.listValidator(CfnDashboard_MeasureFieldPropertyValidator))(properties.sizes)), errors.wrap('supplied properties not correct for "TreeMapAggregatedFieldWellsProperty"');
    }
    function cfnDashboardTreeMapAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TreeMapAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Colors: cdk.listMapper(cfnDashboardMeasureFieldPropertyToCloudFormation)(properties.colors), Groups: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.groups), Sizes: cdk.listMapper(cfnDashboardMeasureFieldPropertyToCloudFormation)(properties.sizes) }) : properties;
    }
    function CfnDashboardTreeMapAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("colors", "Colors", properties.Colors != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMeasureFieldPropertyFromCloudFormation)(properties.Colors) : void 0), ret.addPropertyResult("groups", "Groups", properties.Groups != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.Groups) : void 0), ret.addPropertyResult("sizes", "Sizes", properties.Sizes != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMeasureFieldPropertyFromCloudFormation)(properties.Sizes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TreeMapConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("colorLabelOptions", CfnDashboard_ChartAxisLabelOptionsPropertyValidator)(properties.colorLabelOptions)), errors.collect(cdk.propertyValidator("colorScale", CfnDashboard_ColorScalePropertyValidator)(properties.colorScale)), errors.collect(cdk.propertyValidator("dataLabels", CfnDashboard_DataLabelOptionsPropertyValidator)(properties.dataLabels)), errors.collect(cdk.propertyValidator("fieldWells", CfnDashboard_TreeMapFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("groupLabelOptions", CfnDashboard_ChartAxisLabelOptionsPropertyValidator)(properties.groupLabelOptions)), errors.collect(cdk.propertyValidator("legend", CfnDashboard_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("sizeLabelOptions", CfnDashboard_ChartAxisLabelOptionsPropertyValidator)(properties.sizeLabelOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnDashboard_TreeMapSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tooltip", CfnDashboard_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.wrap('supplied properties not correct for "TreeMapConfigurationProperty"');
    }
    function cfnDashboardTreeMapConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TreeMapConfigurationPropertyValidator(properties).assertSuccess(), { ColorLabelOptions: cfnDashboardChartAxisLabelOptionsPropertyToCloudFormation(properties.colorLabelOptions), ColorScale: cfnDashboardColorScalePropertyToCloudFormation(properties.colorScale), DataLabels: cfnDashboardDataLabelOptionsPropertyToCloudFormation(properties.dataLabels), FieldWells: cfnDashboardTreeMapFieldWellsPropertyToCloudFormation(properties.fieldWells), GroupLabelOptions: cfnDashboardChartAxisLabelOptionsPropertyToCloudFormation(properties.groupLabelOptions), Legend: cfnDashboardLegendOptionsPropertyToCloudFormation(properties.legend), SizeLabelOptions: cfnDashboardChartAxisLabelOptionsPropertyToCloudFormation(properties.sizeLabelOptions), SortConfiguration: cfnDashboardTreeMapSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), Tooltip: cfnDashboardTooltipOptionsPropertyToCloudFormation(properties.tooltip) }) : properties;
    }
    function CfnDashboardTreeMapConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("colorLabelOptions", "ColorLabelOptions", properties.ColorLabelOptions != null ? CfnDashboardChartAxisLabelOptionsPropertyFromCloudFormation(properties.ColorLabelOptions) : void 0), ret.addPropertyResult("colorScale", "ColorScale", properties.ColorScale != null ? CfnDashboardColorScalePropertyFromCloudFormation(properties.ColorScale) : void 0), ret.addPropertyResult("dataLabels", "DataLabels", properties.DataLabels != null ? CfnDashboardDataLabelOptionsPropertyFromCloudFormation(properties.DataLabels) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnDashboardTreeMapFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("groupLabelOptions", "GroupLabelOptions", properties.GroupLabelOptions != null ? CfnDashboardChartAxisLabelOptionsPropertyFromCloudFormation(properties.GroupLabelOptions) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnDashboardLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("sizeLabelOptions", "SizeLabelOptions", properties.SizeLabelOptions != null ? CfnDashboardChartAxisLabelOptionsPropertyFromCloudFormation(properties.SizeLabelOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnDashboardTreeMapSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnDashboardTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TreeMapFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("treeMapAggregatedFieldWells", CfnDashboard_TreeMapAggregatedFieldWellsPropertyValidator)(properties.treeMapAggregatedFieldWells)), errors.wrap('supplied properties not correct for "TreeMapFieldWellsProperty"');
    }
    function cfnDashboardTreeMapFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TreeMapFieldWellsPropertyValidator(properties).assertSuccess(), { TreeMapAggregatedFieldWells: cfnDashboardTreeMapAggregatedFieldWellsPropertyToCloudFormation(properties.treeMapAggregatedFieldWells) }) : properties;
    }
    function CfnDashboardTreeMapFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("treeMapAggregatedFieldWells", "TreeMapAggregatedFieldWells", properties.TreeMapAggregatedFieldWells != null ? CfnDashboardTreeMapAggregatedFieldWellsPropertyFromCloudFormation(properties.TreeMapAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TreeMapSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("treeMapGroupItemsLimitConfiguration", CfnDashboard_ItemsLimitConfigurationPropertyValidator)(properties.treeMapGroupItemsLimitConfiguration)), errors.collect(cdk.propertyValidator("treeMapSort", cdk.listValidator(CfnDashboard_FieldSortOptionsPropertyValidator))(properties.treeMapSort)), errors.wrap('supplied properties not correct for "TreeMapSortConfigurationProperty"');
    }
    function cfnDashboardTreeMapSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TreeMapSortConfigurationPropertyValidator(properties).assertSuccess(), { TreeMapGroupItemsLimitConfiguration: cfnDashboardItemsLimitConfigurationPropertyToCloudFormation(properties.treeMapGroupItemsLimitConfiguration), TreeMapSort: cdk.listMapper(cfnDashboardFieldSortOptionsPropertyToCloudFormation)(properties.treeMapSort) }) : properties;
    }
    function CfnDashboardTreeMapSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("treeMapGroupItemsLimitConfiguration", "TreeMapGroupItemsLimitConfiguration", properties.TreeMapGroupItemsLimitConfiguration != null ? CfnDashboardItemsLimitConfigurationPropertyFromCloudFormation(properties.TreeMapGroupItemsLimitConfiguration) : void 0), ret.addPropertyResult("treeMapSort", "TreeMapSort", properties.TreeMapSort != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardFieldSortOptionsPropertyFromCloudFormation)(properties.TreeMapSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TreeMapVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnDashboard_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnDashboard_TreeMapConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnDashboard_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnDashboard_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnDashboard_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "TreeMapVisualProperty"');
    }
    function cfnDashboardTreeMapVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TreeMapVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnDashboardVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnDashboardTreeMapConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnDashboardColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnDashboardVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnDashboardVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnDashboardTreeMapVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnDashboardTreeMapConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnDashboardVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnDashboardVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_TrendArrowOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "TrendArrowOptionsProperty"');
    }
    function cfnDashboardTrendArrowOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_TrendArrowOptionsPropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnDashboardTrendArrowOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_UnaggregatedFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnDashboard_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("formatConfiguration", CfnDashboard_FormatConfigurationPropertyValidator)(properties.formatConfiguration)), errors.wrap('supplied properties not correct for "UnaggregatedFieldProperty"');
    }
    function cfnDashboardUnaggregatedFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_UnaggregatedFieldPropertyValidator(properties).assertSuccess(), { Column: cfnDashboardColumnIdentifierPropertyToCloudFormation(properties.column), FieldId: cdk.stringToCloudFormation(properties.fieldId), FormatConfiguration: cfnDashboardFormatConfigurationPropertyToCloudFormation(properties.formatConfiguration) }) : properties;
    }
    function CfnDashboardUnaggregatedFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", CfnDashboardColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("formatConfiguration", "FormatConfiguration", properties.FormatConfiguration != null ? CfnDashboardFormatConfigurationPropertyFromCloudFormation(properties.FormatConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_UniqueValuesComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("category", cdk.requiredValidator)(properties.category)), errors.collect(cdk.propertyValidator("category", CfnDashboard_DimensionFieldPropertyValidator)(properties.category)), errors.collect(cdk.propertyValidator("computationId", cdk.requiredValidator)(properties.computationId)), errors.collect(cdk.propertyValidator("computationId", cdk.validateString)(properties.computationId)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "UniqueValuesComputationProperty"');
    }
    function cfnDashboardUniqueValuesComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_UniqueValuesComputationPropertyValidator(properties).assertSuccess(), { Category: cfnDashboardDimensionFieldPropertyToCloudFormation(properties.category), ComputationId: cdk.stringToCloudFormation(properties.computationId), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnDashboardUniqueValuesComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("category", "Category", CfnDashboardDimensionFieldPropertyFromCloudFormation(properties.Category)), ret.addPropertyResult("computationId", "ComputationId", cfn_parse.FromCloudFormation.getString(properties.ComputationId)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_VisibleRangeOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("percentRange", CfnDashboard_PercentVisibleRangePropertyValidator)(properties.percentRange)), errors.wrap('supplied properties not correct for "VisibleRangeOptionsProperty"');
    }
    function cfnDashboardVisibleRangeOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_VisibleRangeOptionsPropertyValidator(properties).assertSuccess(), { PercentRange: cfnDashboardPercentVisibleRangePropertyToCloudFormation(properties.percentRange) }) : properties;
    }
    function CfnDashboardVisibleRangeOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("percentRange", "PercentRange", properties.PercentRange != null ? CfnDashboardPercentVisibleRangePropertyFromCloudFormation(properties.PercentRange) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_VisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("barChartVisual", CfnDashboard_BarChartVisualPropertyValidator)(properties.barChartVisual)), errors.collect(cdk.propertyValidator("boxPlotVisual", CfnDashboard_BoxPlotVisualPropertyValidator)(properties.boxPlotVisual)), errors.collect(cdk.propertyValidator("comboChartVisual", CfnDashboard_ComboChartVisualPropertyValidator)(properties.comboChartVisual)), errors.collect(cdk.propertyValidator("customContentVisual", CfnDashboard_CustomContentVisualPropertyValidator)(properties.customContentVisual)), errors.collect(cdk.propertyValidator("emptyVisual", CfnDashboard_EmptyVisualPropertyValidator)(properties.emptyVisual)), errors.collect(cdk.propertyValidator("filledMapVisual", CfnDashboard_FilledMapVisualPropertyValidator)(properties.filledMapVisual)), errors.collect(cdk.propertyValidator("funnelChartVisual", CfnDashboard_FunnelChartVisualPropertyValidator)(properties.funnelChartVisual)), errors.collect(cdk.propertyValidator("gaugeChartVisual", CfnDashboard_GaugeChartVisualPropertyValidator)(properties.gaugeChartVisual)), errors.collect(cdk.propertyValidator("geospatialMapVisual", CfnDashboard_GeospatialMapVisualPropertyValidator)(properties.geospatialMapVisual)), errors.collect(cdk.propertyValidator("heatMapVisual", CfnDashboard_HeatMapVisualPropertyValidator)(properties.heatMapVisual)), errors.collect(cdk.propertyValidator("histogramVisual", CfnDashboard_HistogramVisualPropertyValidator)(properties.histogramVisual)), errors.collect(cdk.propertyValidator("insightVisual", CfnDashboard_InsightVisualPropertyValidator)(properties.insightVisual)), errors.collect(cdk.propertyValidator("kpiVisual", CfnDashboard_KPIVisualPropertyValidator)(properties.kpiVisual)), errors.collect(cdk.propertyValidator("lineChartVisual", CfnDashboard_LineChartVisualPropertyValidator)(properties.lineChartVisual)), errors.collect(cdk.propertyValidator("pieChartVisual", CfnDashboard_PieChartVisualPropertyValidator)(properties.pieChartVisual)), errors.collect(cdk.propertyValidator("pivotTableVisual", CfnDashboard_PivotTableVisualPropertyValidator)(properties.pivotTableVisual)), errors.collect(cdk.propertyValidator("radarChartVisual", CfnDashboard_RadarChartVisualPropertyValidator)(properties.radarChartVisual)), errors.collect(cdk.propertyValidator("sankeyDiagramVisual", CfnDashboard_SankeyDiagramVisualPropertyValidator)(properties.sankeyDiagramVisual)), errors.collect(cdk.propertyValidator("scatterPlotVisual", CfnDashboard_ScatterPlotVisualPropertyValidator)(properties.scatterPlotVisual)), errors.collect(cdk.propertyValidator("tableVisual", CfnDashboard_TableVisualPropertyValidator)(properties.tableVisual)), errors.collect(cdk.propertyValidator("treeMapVisual", CfnDashboard_TreeMapVisualPropertyValidator)(properties.treeMapVisual)), errors.collect(cdk.propertyValidator("waterfallVisual", CfnDashboard_WaterfallVisualPropertyValidator)(properties.waterfallVisual)), errors.collect(cdk.propertyValidator("wordCloudVisual", CfnDashboard_WordCloudVisualPropertyValidator)(properties.wordCloudVisual)), errors.wrap('supplied properties not correct for "VisualProperty"');
    }
    function cfnDashboardVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_VisualPropertyValidator(properties).assertSuccess(), { BarChartVisual: cfnDashboardBarChartVisualPropertyToCloudFormation(properties.barChartVisual), BoxPlotVisual: cfnDashboardBoxPlotVisualPropertyToCloudFormation(properties.boxPlotVisual), ComboChartVisual: cfnDashboardComboChartVisualPropertyToCloudFormation(properties.comboChartVisual), CustomContentVisual: cfnDashboardCustomContentVisualPropertyToCloudFormation(properties.customContentVisual), EmptyVisual: cfnDashboardEmptyVisualPropertyToCloudFormation(properties.emptyVisual), FilledMapVisual: cfnDashboardFilledMapVisualPropertyToCloudFormation(properties.filledMapVisual), FunnelChartVisual: cfnDashboardFunnelChartVisualPropertyToCloudFormation(properties.funnelChartVisual), GaugeChartVisual: cfnDashboardGaugeChartVisualPropertyToCloudFormation(properties.gaugeChartVisual), GeospatialMapVisual: cfnDashboardGeospatialMapVisualPropertyToCloudFormation(properties.geospatialMapVisual), HeatMapVisual: cfnDashboardHeatMapVisualPropertyToCloudFormation(properties.heatMapVisual), HistogramVisual: cfnDashboardHistogramVisualPropertyToCloudFormation(properties.histogramVisual), InsightVisual: cfnDashboardInsightVisualPropertyToCloudFormation(properties.insightVisual), KPIVisual: cfnDashboardKPIVisualPropertyToCloudFormation(properties.kpiVisual), LineChartVisual: cfnDashboardLineChartVisualPropertyToCloudFormation(properties.lineChartVisual), PieChartVisual: cfnDashboardPieChartVisualPropertyToCloudFormation(properties.pieChartVisual), PivotTableVisual: cfnDashboardPivotTableVisualPropertyToCloudFormation(properties.pivotTableVisual), RadarChartVisual: cfnDashboardRadarChartVisualPropertyToCloudFormation(properties.radarChartVisual), SankeyDiagramVisual: cfnDashboardSankeyDiagramVisualPropertyToCloudFormation(properties.sankeyDiagramVisual), ScatterPlotVisual: cfnDashboardScatterPlotVisualPropertyToCloudFormation(properties.scatterPlotVisual), TableVisual: cfnDashboardTableVisualPropertyToCloudFormation(properties.tableVisual), TreeMapVisual: cfnDashboardTreeMapVisualPropertyToCloudFormation(properties.treeMapVisual), WaterfallVisual: cfnDashboardWaterfallVisualPropertyToCloudFormation(properties.waterfallVisual), WordCloudVisual: cfnDashboardWordCloudVisualPropertyToCloudFormation(properties.wordCloudVisual) }) : properties;
    }
    function CfnDashboardVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("barChartVisual", "BarChartVisual", properties.BarChartVisual != null ? CfnDashboardBarChartVisualPropertyFromCloudFormation(properties.BarChartVisual) : void 0), ret.addPropertyResult("boxPlotVisual", "BoxPlotVisual", properties.BoxPlotVisual != null ? CfnDashboardBoxPlotVisualPropertyFromCloudFormation(properties.BoxPlotVisual) : void 0), ret.addPropertyResult("comboChartVisual", "ComboChartVisual", properties.ComboChartVisual != null ? CfnDashboardComboChartVisualPropertyFromCloudFormation(properties.ComboChartVisual) : void 0), ret.addPropertyResult("customContentVisual", "CustomContentVisual", properties.CustomContentVisual != null ? CfnDashboardCustomContentVisualPropertyFromCloudFormation(properties.CustomContentVisual) : void 0), ret.addPropertyResult("emptyVisual", "EmptyVisual", properties.EmptyVisual != null ? CfnDashboardEmptyVisualPropertyFromCloudFormation(properties.EmptyVisual) : void 0), ret.addPropertyResult("filledMapVisual", "FilledMapVisual", properties.FilledMapVisual != null ? CfnDashboardFilledMapVisualPropertyFromCloudFormation(properties.FilledMapVisual) : void 0), ret.addPropertyResult("funnelChartVisual", "FunnelChartVisual", properties.FunnelChartVisual != null ? CfnDashboardFunnelChartVisualPropertyFromCloudFormation(properties.FunnelChartVisual) : void 0), ret.addPropertyResult("gaugeChartVisual", "GaugeChartVisual", properties.GaugeChartVisual != null ? CfnDashboardGaugeChartVisualPropertyFromCloudFormation(properties.GaugeChartVisual) : void 0), ret.addPropertyResult("geospatialMapVisual", "GeospatialMapVisual", properties.GeospatialMapVisual != null ? CfnDashboardGeospatialMapVisualPropertyFromCloudFormation(properties.GeospatialMapVisual) : void 0), ret.addPropertyResult("heatMapVisual", "HeatMapVisual", properties.HeatMapVisual != null ? CfnDashboardHeatMapVisualPropertyFromCloudFormation(properties.HeatMapVisual) : void 0), ret.addPropertyResult("histogramVisual", "HistogramVisual", properties.HistogramVisual != null ? CfnDashboardHistogramVisualPropertyFromCloudFormation(properties.HistogramVisual) : void 0), ret.addPropertyResult("insightVisual", "InsightVisual", properties.InsightVisual != null ? CfnDashboardInsightVisualPropertyFromCloudFormation(properties.InsightVisual) : void 0), ret.addPropertyResult("kpiVisual", "KPIVisual", properties.KPIVisual != null ? CfnDashboardKPIVisualPropertyFromCloudFormation(properties.KPIVisual) : void 0), ret.addPropertyResult("lineChartVisual", "LineChartVisual", properties.LineChartVisual != null ? CfnDashboardLineChartVisualPropertyFromCloudFormation(properties.LineChartVisual) : void 0), ret.addPropertyResult("pieChartVisual", "PieChartVisual", properties.PieChartVisual != null ? CfnDashboardPieChartVisualPropertyFromCloudFormation(properties.PieChartVisual) : void 0), ret.addPropertyResult("pivotTableVisual", "PivotTableVisual", properties.PivotTableVisual != null ? CfnDashboardPivotTableVisualPropertyFromCloudFormation(properties.PivotTableVisual) : void 0), ret.addPropertyResult("radarChartVisual", "RadarChartVisual", properties.RadarChartVisual != null ? CfnDashboardRadarChartVisualPropertyFromCloudFormation(properties.RadarChartVisual) : void 0), ret.addPropertyResult("sankeyDiagramVisual", "SankeyDiagramVisual", properties.SankeyDiagramVisual != null ? CfnDashboardSankeyDiagramVisualPropertyFromCloudFormation(properties.SankeyDiagramVisual) : void 0), ret.addPropertyResult("scatterPlotVisual", "ScatterPlotVisual", properties.ScatterPlotVisual != null ? CfnDashboardScatterPlotVisualPropertyFromCloudFormation(properties.ScatterPlotVisual) : void 0), ret.addPropertyResult("tableVisual", "TableVisual", properties.TableVisual != null ? CfnDashboardTableVisualPropertyFromCloudFormation(properties.TableVisual) : void 0), ret.addPropertyResult("treeMapVisual", "TreeMapVisual", properties.TreeMapVisual != null ? CfnDashboardTreeMapVisualPropertyFromCloudFormation(properties.TreeMapVisual) : void 0), ret.addPropertyResult("waterfallVisual", "WaterfallVisual", properties.WaterfallVisual != null ? CfnDashboardWaterfallVisualPropertyFromCloudFormation(properties.WaterfallVisual) : void 0), ret.addPropertyResult("wordCloudVisual", "WordCloudVisual", properties.WordCloudVisual != null ? CfnDashboardWordCloudVisualPropertyFromCloudFormation(properties.WordCloudVisual) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_VisualAxisSortOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availabilityStatus", cdk.validateString)(properties.availabilityStatus)), errors.wrap('supplied properties not correct for "VisualAxisSortOptionProperty"');
    }
    function cfnDashboardVisualAxisSortOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_VisualAxisSortOptionPropertyValidator(properties).assertSuccess(), { AvailabilityStatus: cdk.stringToCloudFormation(properties.availabilityStatus) }) : properties;
    }
    function CfnDashboardVisualAxisSortOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("availabilityStatus", "AvailabilityStatus", properties.AvailabilityStatus != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityStatus) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_VisualCustomActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actionOperations", cdk.requiredValidator)(properties.actionOperations)), errors.collect(cdk.propertyValidator("actionOperations", cdk.listValidator(CfnDashboard_VisualCustomActionOperationPropertyValidator))(properties.actionOperations)), errors.collect(cdk.propertyValidator("customActionId", cdk.requiredValidator)(properties.customActionId)), errors.collect(cdk.propertyValidator("customActionId", cdk.validateString)(properties.customActionId)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.collect(cdk.propertyValidator("trigger", cdk.requiredValidator)(properties.trigger)), errors.collect(cdk.propertyValidator("trigger", cdk.validateString)(properties.trigger)), errors.wrap('supplied properties not correct for "VisualCustomActionProperty"');
    }
    function cfnDashboardVisualCustomActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_VisualCustomActionPropertyValidator(properties).assertSuccess(), { ActionOperations: cdk.listMapper(cfnDashboardVisualCustomActionOperationPropertyToCloudFormation)(properties.actionOperations), CustomActionId: cdk.stringToCloudFormation(properties.customActionId), Name: cdk.stringToCloudFormation(properties.name), Status: cdk.stringToCloudFormation(properties.status), Trigger: cdk.stringToCloudFormation(properties.trigger) }) : properties;
    }
    function CfnDashboardVisualCustomActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actionOperations", "ActionOperations", cfn_parse.FromCloudFormation.getArray(CfnDashboardVisualCustomActionOperationPropertyFromCloudFormation)(properties.ActionOperations)), ret.addPropertyResult("customActionId", "CustomActionId", cfn_parse.FromCloudFormation.getString(properties.CustomActionId)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addPropertyResult("trigger", "Trigger", cfn_parse.FromCloudFormation.getString(properties.Trigger)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_VisualCustomActionOperationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("filterOperation", CfnDashboard_CustomActionFilterOperationPropertyValidator)(properties.filterOperation)), errors.collect(cdk.propertyValidator("navigationOperation", CfnDashboard_CustomActionNavigationOperationPropertyValidator)(properties.navigationOperation)), errors.collect(cdk.propertyValidator("setParametersOperation", CfnDashboard_CustomActionSetParametersOperationPropertyValidator)(properties.setParametersOperation)), errors.collect(cdk.propertyValidator("urlOperation", CfnDashboard_CustomActionURLOperationPropertyValidator)(properties.urlOperation)), errors.wrap('supplied properties not correct for "VisualCustomActionOperationProperty"');
    }
    function cfnDashboardVisualCustomActionOperationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_VisualCustomActionOperationPropertyValidator(properties).assertSuccess(), { FilterOperation: cfnDashboardCustomActionFilterOperationPropertyToCloudFormation(properties.filterOperation), NavigationOperation: cfnDashboardCustomActionNavigationOperationPropertyToCloudFormation(properties.navigationOperation), SetParametersOperation: cfnDashboardCustomActionSetParametersOperationPropertyToCloudFormation(properties.setParametersOperation), URLOperation: cfnDashboardCustomActionURLOperationPropertyToCloudFormation(properties.urlOperation) }) : properties;
    }
    function CfnDashboardVisualCustomActionOperationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("filterOperation", "FilterOperation", properties.FilterOperation != null ? CfnDashboardCustomActionFilterOperationPropertyFromCloudFormation(properties.FilterOperation) : void 0), ret.addPropertyResult("navigationOperation", "NavigationOperation", properties.NavigationOperation != null ? CfnDashboardCustomActionNavigationOperationPropertyFromCloudFormation(properties.NavigationOperation) : void 0), ret.addPropertyResult("setParametersOperation", "SetParametersOperation", properties.SetParametersOperation != null ? CfnDashboardCustomActionSetParametersOperationPropertyFromCloudFormation(properties.SetParametersOperation) : void 0), ret.addPropertyResult("urlOperation", "URLOperation", properties.URLOperation != null ? CfnDashboardCustomActionURLOperationPropertyFromCloudFormation(properties.URLOperation) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_VisualMenuOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availabilityStatus", cdk.validateString)(properties.availabilityStatus)), errors.wrap('supplied properties not correct for "VisualMenuOptionProperty"');
    }
    function cfnDashboardVisualMenuOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_VisualMenuOptionPropertyValidator(properties).assertSuccess(), { AvailabilityStatus: cdk.stringToCloudFormation(properties.availabilityStatus) }) : properties;
    }
    function CfnDashboardVisualMenuOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("availabilityStatus", "AvailabilityStatus", properties.AvailabilityStatus != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityStatus) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_VisualPalettePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("chartColor", cdk.validateString)(properties.chartColor)), errors.collect(cdk.propertyValidator("colorMap", cdk.listValidator(CfnDashboard_DataPathColorPropertyValidator))(properties.colorMap)), errors.wrap('supplied properties not correct for "VisualPaletteProperty"');
    }
    function cfnDashboardVisualPalettePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_VisualPalettePropertyValidator(properties).assertSuccess(), { ChartColor: cdk.stringToCloudFormation(properties.chartColor), ColorMap: cdk.listMapper(cfnDashboardDataPathColorPropertyToCloudFormation)(properties.colorMap) }) : properties;
    }
    function CfnDashboardVisualPalettePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("chartColor", "ChartColor", properties.ChartColor != null ? cfn_parse.FromCloudFormation.getString(properties.ChartColor) : void 0), ret.addPropertyResult("colorMap", "ColorMap", properties.ColorMap != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDataPathColorPropertyFromCloudFormation)(properties.ColorMap) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_VisualSubtitleLabelOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("formatText", CfnDashboard_LongFormatTextPropertyValidator)(properties.formatText)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "VisualSubtitleLabelOptionsProperty"');
    }
    function cfnDashboardVisualSubtitleLabelOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_VisualSubtitleLabelOptionsPropertyValidator(properties).assertSuccess(), { FormatText: cfnDashboardLongFormatTextPropertyToCloudFormation(properties.formatText), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnDashboardVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("formatText", "FormatText", properties.FormatText != null ? CfnDashboardLongFormatTextPropertyFromCloudFormation(properties.FormatText) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_VisualTitleLabelOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("formatText", CfnDashboard_ShortFormatTextPropertyValidator)(properties.formatText)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "VisualTitleLabelOptionsProperty"');
    }
    function cfnDashboardVisualTitleLabelOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_VisualTitleLabelOptionsPropertyValidator(properties).assertSuccess(), { FormatText: cfnDashboardShortFormatTextPropertyToCloudFormation(properties.formatText), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnDashboardVisualTitleLabelOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("formatText", "FormatText", properties.FormatText != null ? CfnDashboardShortFormatTextPropertyFromCloudFormation(properties.FormatText) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_WaterfallChartAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("breakdowns", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.breakdowns)), errors.collect(cdk.propertyValidator("categories", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.categories)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnDashboard_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "WaterfallChartAggregatedFieldWellsProperty"');
    }
    function cfnDashboardWaterfallChartAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_WaterfallChartAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Breakdowns: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.breakdowns), Categories: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.categories), Values: cdk.listMapper(cfnDashboardMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnDashboardWaterfallChartAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("breakdowns", "Breakdowns", properties.Breakdowns != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.Breakdowns) : void 0), ret.addPropertyResult("categories", "Categories", properties.Categories != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.Categories) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_WaterfallChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryAxisDisplayOptions", CfnDashboard_AxisDisplayOptionsPropertyValidator)(properties.categoryAxisDisplayOptions)), errors.collect(cdk.propertyValidator("categoryAxisLabelOptions", CfnDashboard_ChartAxisLabelOptionsPropertyValidator)(properties.categoryAxisLabelOptions)), errors.collect(cdk.propertyValidator("dataLabels", CfnDashboard_DataLabelOptionsPropertyValidator)(properties.dataLabels)), errors.collect(cdk.propertyValidator("fieldWells", CfnDashboard_WaterfallChartFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("legend", CfnDashboard_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("primaryYAxisDisplayOptions", CfnDashboard_AxisDisplayOptionsPropertyValidator)(properties.primaryYAxisDisplayOptions)), errors.collect(cdk.propertyValidator("primaryYAxisLabelOptions", CfnDashboard_ChartAxisLabelOptionsPropertyValidator)(properties.primaryYAxisLabelOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnDashboard_WaterfallChartSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("visualPalette", CfnDashboard_VisualPalettePropertyValidator)(properties.visualPalette)), errors.collect(cdk.propertyValidator("waterfallChartOptions", CfnDashboard_WaterfallChartOptionsPropertyValidator)(properties.waterfallChartOptions)), errors.wrap('supplied properties not correct for "WaterfallChartConfigurationProperty"');
    }
    function cfnDashboardWaterfallChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_WaterfallChartConfigurationPropertyValidator(properties).assertSuccess(), { CategoryAxisDisplayOptions: cfnDashboardAxisDisplayOptionsPropertyToCloudFormation(properties.categoryAxisDisplayOptions), CategoryAxisLabelOptions: cfnDashboardChartAxisLabelOptionsPropertyToCloudFormation(properties.categoryAxisLabelOptions), DataLabels: cfnDashboardDataLabelOptionsPropertyToCloudFormation(properties.dataLabels), FieldWells: cfnDashboardWaterfallChartFieldWellsPropertyToCloudFormation(properties.fieldWells), Legend: cfnDashboardLegendOptionsPropertyToCloudFormation(properties.legend), PrimaryYAxisDisplayOptions: cfnDashboardAxisDisplayOptionsPropertyToCloudFormation(properties.primaryYAxisDisplayOptions), PrimaryYAxisLabelOptions: cfnDashboardChartAxisLabelOptionsPropertyToCloudFormation(properties.primaryYAxisLabelOptions), SortConfiguration: cfnDashboardWaterfallChartSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), VisualPalette: cfnDashboardVisualPalettePropertyToCloudFormation(properties.visualPalette), WaterfallChartOptions: cfnDashboardWaterfallChartOptionsPropertyToCloudFormation(properties.waterfallChartOptions) }) : properties;
    }
    function CfnDashboardWaterfallChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryAxisDisplayOptions", "CategoryAxisDisplayOptions", properties.CategoryAxisDisplayOptions != null ? CfnDashboardAxisDisplayOptionsPropertyFromCloudFormation(properties.CategoryAxisDisplayOptions) : void 0), ret.addPropertyResult("categoryAxisLabelOptions", "CategoryAxisLabelOptions", properties.CategoryAxisLabelOptions != null ? CfnDashboardChartAxisLabelOptionsPropertyFromCloudFormation(properties.CategoryAxisLabelOptions) : void 0), ret.addPropertyResult("dataLabels", "DataLabels", properties.DataLabels != null ? CfnDashboardDataLabelOptionsPropertyFromCloudFormation(properties.DataLabels) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnDashboardWaterfallChartFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnDashboardLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("primaryYAxisDisplayOptions", "PrimaryYAxisDisplayOptions", properties.PrimaryYAxisDisplayOptions != null ? CfnDashboardAxisDisplayOptionsPropertyFromCloudFormation(properties.PrimaryYAxisDisplayOptions) : void 0), ret.addPropertyResult("primaryYAxisLabelOptions", "PrimaryYAxisLabelOptions", properties.PrimaryYAxisLabelOptions != null ? CfnDashboardChartAxisLabelOptionsPropertyFromCloudFormation(properties.PrimaryYAxisLabelOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnDashboardWaterfallChartSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnDashboardVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addPropertyResult("waterfallChartOptions", "WaterfallChartOptions", properties.WaterfallChartOptions != null ? CfnDashboardWaterfallChartOptionsPropertyFromCloudFormation(properties.WaterfallChartOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_WaterfallChartFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("waterfallChartAggregatedFieldWells", CfnDashboard_WaterfallChartAggregatedFieldWellsPropertyValidator)(properties.waterfallChartAggregatedFieldWells)), errors.wrap('supplied properties not correct for "WaterfallChartFieldWellsProperty"');
    }
    function cfnDashboardWaterfallChartFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_WaterfallChartFieldWellsPropertyValidator(properties).assertSuccess(), { WaterfallChartAggregatedFieldWells: cfnDashboardWaterfallChartAggregatedFieldWellsPropertyToCloudFormation(properties.waterfallChartAggregatedFieldWells) }) : properties;
    }
    function CfnDashboardWaterfallChartFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("waterfallChartAggregatedFieldWells", "WaterfallChartAggregatedFieldWells", properties.WaterfallChartAggregatedFieldWells != null ? CfnDashboardWaterfallChartAggregatedFieldWellsPropertyFromCloudFormation(properties.WaterfallChartAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_WaterfallChartOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("totalBarLabel", cdk.validateString)(properties.totalBarLabel)), errors.wrap('supplied properties not correct for "WaterfallChartOptionsProperty"');
    }
    function cfnDashboardWaterfallChartOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_WaterfallChartOptionsPropertyValidator(properties).assertSuccess(), { TotalBarLabel: cdk.stringToCloudFormation(properties.totalBarLabel) }) : properties;
    }
    function CfnDashboardWaterfallChartOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("totalBarLabel", "TotalBarLabel", properties.TotalBarLabel != null ? cfn_parse.FromCloudFormation.getString(properties.TotalBarLabel) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_WaterfallChartSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("breakdownItemsLimit", CfnDashboard_ItemsLimitConfigurationPropertyValidator)(properties.breakdownItemsLimit)), errors.collect(cdk.propertyValidator("categorySort", cdk.listValidator(CfnDashboard_FieldSortOptionsPropertyValidator))(properties.categorySort)), errors.wrap('supplied properties not correct for "WaterfallChartSortConfigurationProperty"');
    }
    function cfnDashboardWaterfallChartSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_WaterfallChartSortConfigurationPropertyValidator(properties).assertSuccess(), { BreakdownItemsLimit: cfnDashboardItemsLimitConfigurationPropertyToCloudFormation(properties.breakdownItemsLimit), CategorySort: cdk.listMapper(cfnDashboardFieldSortOptionsPropertyToCloudFormation)(properties.categorySort) }) : properties;
    }
    function CfnDashboardWaterfallChartSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("breakdownItemsLimit", "BreakdownItemsLimit", properties.BreakdownItemsLimit != null ? CfnDashboardItemsLimitConfigurationPropertyFromCloudFormation(properties.BreakdownItemsLimit) : void 0), ret.addPropertyResult("categorySort", "CategorySort", properties.CategorySort != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardFieldSortOptionsPropertyFromCloudFormation)(properties.CategorySort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_WaterfallVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnDashboard_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnDashboard_WaterfallChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnDashboard_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnDashboard_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnDashboard_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "WaterfallVisualProperty"');
    }
    function cfnDashboardWaterfallVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_WaterfallVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnDashboardVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnDashboardWaterfallChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnDashboardColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnDashboardVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnDashboardVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnDashboardWaterfallVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnDashboardWaterfallChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnDashboardVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnDashboardVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_WhatIfPointScenarioPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("date", cdk.requiredValidator)(properties.date)), errors.collect(cdk.propertyValidator("date", cdk.validateString)(properties.date)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "WhatIfPointScenarioProperty"');
    }
    function cfnDashboardWhatIfPointScenarioPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_WhatIfPointScenarioPropertyValidator(properties).assertSuccess(), { Date: cdk.stringToCloudFormation(properties.date), Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnDashboardWhatIfPointScenarioPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("date", "Date", cfn_parse.FromCloudFormation.getString(properties.Date)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getNumber(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_WhatIfRangeScenarioPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endDate", cdk.requiredValidator)(properties.endDate)), errors.collect(cdk.propertyValidator("endDate", cdk.validateString)(properties.endDate)), errors.collect(cdk.propertyValidator("startDate", cdk.requiredValidator)(properties.startDate)), errors.collect(cdk.propertyValidator("startDate", cdk.validateString)(properties.startDate)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "WhatIfRangeScenarioProperty"');
    }
    function cfnDashboardWhatIfRangeScenarioPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_WhatIfRangeScenarioPropertyValidator(properties).assertSuccess(), { EndDate: cdk.stringToCloudFormation(properties.endDate), StartDate: cdk.stringToCloudFormation(properties.startDate), Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnDashboardWhatIfRangeScenarioPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endDate", "EndDate", cfn_parse.FromCloudFormation.getString(properties.EndDate)), ret.addPropertyResult("startDate", "StartDate", cfn_parse.FromCloudFormation.getString(properties.StartDate)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getNumber(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_WordCloudAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groupBy", cdk.listValidator(CfnDashboard_DimensionFieldPropertyValidator))(properties.groupBy)), errors.collect(cdk.propertyValidator("size", cdk.listValidator(CfnDashboard_MeasureFieldPropertyValidator))(properties.size)), errors.wrap('supplied properties not correct for "WordCloudAggregatedFieldWellsProperty"');
    }
    function cfnDashboardWordCloudAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_WordCloudAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { GroupBy: cdk.listMapper(cfnDashboardDimensionFieldPropertyToCloudFormation)(properties.groupBy), Size: cdk.listMapper(cfnDashboardMeasureFieldPropertyToCloudFormation)(properties.size) }) : properties;
    }
    function CfnDashboardWordCloudAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupBy", "GroupBy", properties.GroupBy != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardDimensionFieldPropertyFromCloudFormation)(properties.GroupBy) : void 0), ret.addPropertyResult("size", "Size", properties.Size != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardMeasureFieldPropertyFromCloudFormation)(properties.Size) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_WordCloudChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryLabelOptions", CfnDashboard_ChartAxisLabelOptionsPropertyValidator)(properties.categoryLabelOptions)), errors.collect(cdk.propertyValidator("fieldWells", CfnDashboard_WordCloudFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnDashboard_WordCloudSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("wordCloudOptions", CfnDashboard_WordCloudOptionsPropertyValidator)(properties.wordCloudOptions)), errors.wrap('supplied properties not correct for "WordCloudChartConfigurationProperty"');
    }
    function cfnDashboardWordCloudChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_WordCloudChartConfigurationPropertyValidator(properties).assertSuccess(), { CategoryLabelOptions: cfnDashboardChartAxisLabelOptionsPropertyToCloudFormation(properties.categoryLabelOptions), FieldWells: cfnDashboardWordCloudFieldWellsPropertyToCloudFormation(properties.fieldWells), SortConfiguration: cfnDashboardWordCloudSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), WordCloudOptions: cfnDashboardWordCloudOptionsPropertyToCloudFormation(properties.wordCloudOptions) }) : properties;
    }
    function CfnDashboardWordCloudChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryLabelOptions", "CategoryLabelOptions", properties.CategoryLabelOptions != null ? CfnDashboardChartAxisLabelOptionsPropertyFromCloudFormation(properties.CategoryLabelOptions) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnDashboardWordCloudFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnDashboardWordCloudSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("wordCloudOptions", "WordCloudOptions", properties.WordCloudOptions != null ? CfnDashboardWordCloudOptionsPropertyFromCloudFormation(properties.WordCloudOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_WordCloudFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("wordCloudAggregatedFieldWells", CfnDashboard_WordCloudAggregatedFieldWellsPropertyValidator)(properties.wordCloudAggregatedFieldWells)), errors.wrap('supplied properties not correct for "WordCloudFieldWellsProperty"');
    }
    function cfnDashboardWordCloudFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_WordCloudFieldWellsPropertyValidator(properties).assertSuccess(), { WordCloudAggregatedFieldWells: cfnDashboardWordCloudAggregatedFieldWellsPropertyToCloudFormation(properties.wordCloudAggregatedFieldWells) }) : properties;
    }
    function CfnDashboardWordCloudFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("wordCloudAggregatedFieldWells", "WordCloudAggregatedFieldWells", properties.WordCloudAggregatedFieldWells != null ? CfnDashboardWordCloudAggregatedFieldWellsPropertyFromCloudFormation(properties.WordCloudAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_WordCloudOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudLayout", cdk.validateString)(properties.cloudLayout)), errors.collect(cdk.propertyValidator("maximumStringLength", cdk.validateNumber)(properties.maximumStringLength)), errors.collect(cdk.propertyValidator("wordCasing", cdk.validateString)(properties.wordCasing)), errors.collect(cdk.propertyValidator("wordOrientation", cdk.validateString)(properties.wordOrientation)), errors.collect(cdk.propertyValidator("wordPadding", cdk.validateString)(properties.wordPadding)), errors.collect(cdk.propertyValidator("wordScaling", cdk.validateString)(properties.wordScaling)), errors.wrap('supplied properties not correct for "WordCloudOptionsProperty"');
    }
    function cfnDashboardWordCloudOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_WordCloudOptionsPropertyValidator(properties).assertSuccess(), { CloudLayout: cdk.stringToCloudFormation(properties.cloudLayout), MaximumStringLength: cdk.numberToCloudFormation(properties.maximumStringLength), WordCasing: cdk.stringToCloudFormation(properties.wordCasing), WordOrientation: cdk.stringToCloudFormation(properties.wordOrientation), WordPadding: cdk.stringToCloudFormation(properties.wordPadding), WordScaling: cdk.stringToCloudFormation(properties.wordScaling) }) : properties;
    }
    function CfnDashboardWordCloudOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudLayout", "CloudLayout", properties.CloudLayout != null ? cfn_parse.FromCloudFormation.getString(properties.CloudLayout) : void 0), ret.addPropertyResult("maximumStringLength", "MaximumStringLength", properties.MaximumStringLength != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumStringLength) : void 0), ret.addPropertyResult("wordCasing", "WordCasing", properties.WordCasing != null ? cfn_parse.FromCloudFormation.getString(properties.WordCasing) : void 0), ret.addPropertyResult("wordOrientation", "WordOrientation", properties.WordOrientation != null ? cfn_parse.FromCloudFormation.getString(properties.WordOrientation) : void 0), ret.addPropertyResult("wordPadding", "WordPadding", properties.WordPadding != null ? cfn_parse.FromCloudFormation.getString(properties.WordPadding) : void 0), ret.addPropertyResult("wordScaling", "WordScaling", properties.WordScaling != null ? cfn_parse.FromCloudFormation.getString(properties.WordScaling) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_WordCloudSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryItemsLimit", CfnDashboard_ItemsLimitConfigurationPropertyValidator)(properties.categoryItemsLimit)), errors.collect(cdk.propertyValidator("categorySort", cdk.listValidator(CfnDashboard_FieldSortOptionsPropertyValidator))(properties.categorySort)), errors.wrap('supplied properties not correct for "WordCloudSortConfigurationProperty"');
    }
    function cfnDashboardWordCloudSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_WordCloudSortConfigurationPropertyValidator(properties).assertSuccess(), { CategoryItemsLimit: cfnDashboardItemsLimitConfigurationPropertyToCloudFormation(properties.categoryItemsLimit), CategorySort: cdk.listMapper(cfnDashboardFieldSortOptionsPropertyToCloudFormation)(properties.categorySort) }) : properties;
    }
    function CfnDashboardWordCloudSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryItemsLimit", "CategoryItemsLimit", properties.CategoryItemsLimit != null ? CfnDashboardItemsLimitConfigurationPropertyFromCloudFormation(properties.CategoryItemsLimit) : void 0), ret.addPropertyResult("categorySort", "CategorySort", properties.CategorySort != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardFieldSortOptionsPropertyFromCloudFormation)(properties.CategorySort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDashboard_WordCloudVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnDashboard_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnDashboard_WordCloudChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnDashboard_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnDashboard_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnDashboard_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "WordCloudVisualProperty"');
    }
    function cfnDashboardWordCloudVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDashboard_WordCloudVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnDashboardVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnDashboardWordCloudChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnDashboardColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnDashboardVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnDashboardVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnDashboardWordCloudVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnDashboardWordCloudChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnDashboardColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnDashboardVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnDashboardVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("awsAccountId", cdk.validateString)(properties.awsAccountId)), errors.collect(cdk.propertyValidator("columnGroups", cdk.listValidator(CfnDataSet_ColumnGroupPropertyValidator))(properties.columnGroups)), errors.collect(cdk.propertyValidator("columnLevelPermissionRules", cdk.listValidator(CfnDataSet_ColumnLevelPermissionRulePropertyValidator))(properties.columnLevelPermissionRules)), errors.collect(cdk.propertyValidator("dataSetId", cdk.validateString)(properties.dataSetId)), errors.collect(cdk.propertyValidator("dataSetUsageConfiguration", CfnDataSet_DataSetUsageConfigurationPropertyValidator)(properties.dataSetUsageConfiguration)), errors.collect(cdk.propertyValidator("fieldFolders", cdk.hashValidator(CfnDataSet_FieldFolderPropertyValidator))(properties.fieldFolders)), errors.collect(cdk.propertyValidator("importMode", cdk.validateString)(properties.importMode)), errors.collect(cdk.propertyValidator("ingestionWaitPolicy", CfnDataSet_IngestionWaitPolicyPropertyValidator)(properties.ingestionWaitPolicy)), errors.collect(cdk.propertyValidator("logicalTableMap", cdk.hashValidator(CfnDataSet_LogicalTablePropertyValidator))(properties.logicalTableMap)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("permissions", cdk.listValidator(CfnDataSet_ResourcePermissionPropertyValidator))(properties.permissions)), errors.collect(cdk.propertyValidator("physicalTableMap", cdk.hashValidator(CfnDataSet_PhysicalTablePropertyValidator))(properties.physicalTableMap)), errors.collect(cdk.propertyValidator("rowLevelPermissionDataSet", CfnDataSet_RowLevelPermissionDataSetPropertyValidator)(properties.rowLevelPermissionDataSet)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDataSetProps"');
    }
    function cfnDataSetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSetPropsValidator(properties).assertSuccess(), { AwsAccountId: cdk.stringToCloudFormation(properties.awsAccountId), ColumnGroups: cdk.listMapper(cfnDataSetColumnGroupPropertyToCloudFormation)(properties.columnGroups), ColumnLevelPermissionRules: cdk.listMapper(cfnDataSetColumnLevelPermissionRulePropertyToCloudFormation)(properties.columnLevelPermissionRules), DataSetId: cdk.stringToCloudFormation(properties.dataSetId), DataSetUsageConfiguration: cfnDataSetDataSetUsageConfigurationPropertyToCloudFormation(properties.dataSetUsageConfiguration), FieldFolders: cdk.hashMapper(cfnDataSetFieldFolderPropertyToCloudFormation)(properties.fieldFolders), ImportMode: cdk.stringToCloudFormation(properties.importMode), IngestionWaitPolicy: cfnDataSetIngestionWaitPolicyPropertyToCloudFormation(properties.ingestionWaitPolicy), LogicalTableMap: cdk.hashMapper(cfnDataSetLogicalTablePropertyToCloudFormation)(properties.logicalTableMap), Name: cdk.stringToCloudFormation(properties.name), Permissions: cdk.listMapper(cfnDataSetResourcePermissionPropertyToCloudFormation)(properties.permissions), PhysicalTableMap: cdk.hashMapper(cfnDataSetPhysicalTablePropertyToCloudFormation)(properties.physicalTableMap), RowLevelPermissionDataSet: cfnDataSetRowLevelPermissionDataSetPropertyToCloudFormation(properties.rowLevelPermissionDataSet), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDataSetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("awsAccountId", "AwsAccountId", properties.AwsAccountId != null ? cfn_parse.FromCloudFormation.getString(properties.AwsAccountId) : void 0), ret.addPropertyResult("columnGroups", "ColumnGroups", properties.ColumnGroups != null ? cfn_parse.FromCloudFormation.getArray(CfnDataSetColumnGroupPropertyFromCloudFormation)(properties.ColumnGroups) : void 0), ret.addPropertyResult("columnLevelPermissionRules", "ColumnLevelPermissionRules", properties.ColumnLevelPermissionRules != null ? cfn_parse.FromCloudFormation.getArray(CfnDataSetColumnLevelPermissionRulePropertyFromCloudFormation)(properties.ColumnLevelPermissionRules) : void 0), ret.addPropertyResult("dataSetId", "DataSetId", properties.DataSetId != null ? cfn_parse.FromCloudFormation.getString(properties.DataSetId) : void 0), ret.addPropertyResult("dataSetUsageConfiguration", "DataSetUsageConfiguration", properties.DataSetUsageConfiguration != null ? CfnDataSetDataSetUsageConfigurationPropertyFromCloudFormation(properties.DataSetUsageConfiguration) : void 0), ret.addPropertyResult("fieldFolders", "FieldFolders", properties.FieldFolders != null ? cfn_parse.FromCloudFormation.getMap(CfnDataSetFieldFolderPropertyFromCloudFormation)(properties.FieldFolders) : void 0), ret.addPropertyResult("importMode", "ImportMode", properties.ImportMode != null ? cfn_parse.FromCloudFormation.getString(properties.ImportMode) : void 0), ret.addPropertyResult("ingestionWaitPolicy", "IngestionWaitPolicy", properties.IngestionWaitPolicy != null ? CfnDataSetIngestionWaitPolicyPropertyFromCloudFormation(properties.IngestionWaitPolicy) : void 0), ret.addPropertyResult("logicalTableMap", "LogicalTableMap", properties.LogicalTableMap != null ? cfn_parse.FromCloudFormation.getMap(CfnDataSetLogicalTablePropertyFromCloudFormation)(properties.LogicalTableMap) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("permissions", "Permissions", properties.Permissions != null ? cfn_parse.FromCloudFormation.getArray(CfnDataSetResourcePermissionPropertyFromCloudFormation)(properties.Permissions) : void 0), ret.addPropertyResult("physicalTableMap", "PhysicalTableMap", properties.PhysicalTableMap != null ? cfn_parse.FromCloudFormation.getMap(CfnDataSetPhysicalTablePropertyFromCloudFormation)(properties.PhysicalTableMap) : void 0), ret.addPropertyResult("rowLevelPermissionDataSet", "RowLevelPermissionDataSet", properties.RowLevelPermissionDataSet != null ? CfnDataSetRowLevelPermissionDataSetPropertyFromCloudFormation(properties.RowLevelPermissionDataSet) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDataSet = class _CfnDataSet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDataSetPropsFromCloudFormation(resourceProperties), ret = new _CfnDataSet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnDataSet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_quicksight_CfnDataSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDataSet), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrConsumedSpiceCapacityInBytes = this.getAtt("ConsumedSpiceCapacityInBytes", cdk.ResolutionTypeHint.STRING), this.attrCreatedTime = cdk.Token.asString(this.getAtt("CreatedTime", cdk.ResolutionTypeHint.STRING)), this.attrLastUpdatedTime = cdk.Token.asString(this.getAtt("LastUpdatedTime", cdk.ResolutionTypeHint.STRING)), this.attrOutputColumns = this.getAtt("OutputColumns", cdk.ResolutionTypeHint.STRING), this.awsAccountId = props.awsAccountId, this.columnGroups = props.columnGroups, this.columnLevelPermissionRules = props.columnLevelPermissionRules, this.dataSetId = props.dataSetId, this.dataSetUsageConfiguration = props.dataSetUsageConfiguration, this.fieldFolders = props.fieldFolders, this.importMode = props.importMode, this.ingestionWaitPolicy = props.ingestionWaitPolicy, this.logicalTableMap = props.logicalTableMap, this.name = props.name, this.permissions = props.permissions, this.physicalTableMap = props.physicalTableMap, this.rowLevelPermissionDataSet = props.rowLevelPermissionDataSet, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::QuickSight::DataSet", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDataSet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { awsAccountId: this.awsAccountId, columnGroups: this.columnGroups, columnLevelPermissionRules: this.columnLevelPermissionRules, dataSetId: this.dataSetId, dataSetUsageConfiguration: this.dataSetUsageConfiguration, fieldFolders: this.fieldFolders, importMode: this.importMode, ingestionWaitPolicy: this.ingestionWaitPolicy, logicalTableMap: this.logicalTableMap, name: this.name, permissions: this.permissions, physicalTableMap: this.physicalTableMap, rowLevelPermissionDataSet: this.rowLevelPermissionDataSet, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDataSetPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnDataSet[_c] = { fqn: "aws-cdk-lib.aws_quicksight.CfnDataSet", version: "2.80.0" }, CfnDataSet.CFN_RESOURCE_TYPE_NAME = "AWS::QuickSight::DataSet", exports2.CfnDataSet = CfnDataSet;
    function CfnDataSet_CalculatedColumnPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnId", cdk.requiredValidator)(properties.columnId)), errors.collect(cdk.propertyValidator("columnId", cdk.validateString)(properties.columnId)), errors.collect(cdk.propertyValidator("columnName", cdk.requiredValidator)(properties.columnName)), errors.collect(cdk.propertyValidator("columnName", cdk.validateString)(properties.columnName)), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.wrap('supplied properties not correct for "CalculatedColumnProperty"');
    }
    function cfnDataSetCalculatedColumnPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSet_CalculatedColumnPropertyValidator(properties).assertSuccess(), { ColumnId: cdk.stringToCloudFormation(properties.columnId), ColumnName: cdk.stringToCloudFormation(properties.columnName), Expression: cdk.stringToCloudFormation(properties.expression) }) : properties;
    }
    function CfnDataSetCalculatedColumnPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columnId", "ColumnId", cfn_parse.FromCloudFormation.getString(properties.ColumnId)), ret.addPropertyResult("columnName", "ColumnName", cfn_parse.FromCloudFormation.getString(properties.ColumnName)), ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getString(properties.Expression)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSet_CastColumnTypeOperationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnName", cdk.requiredValidator)(properties.columnName)), errors.collect(cdk.propertyValidator("columnName", cdk.validateString)(properties.columnName)), errors.collect(cdk.propertyValidator("format", cdk.validateString)(properties.format)), errors.collect(cdk.propertyValidator("newColumnType", cdk.requiredValidator)(properties.newColumnType)), errors.collect(cdk.propertyValidator("newColumnType", cdk.validateString)(properties.newColumnType)), errors.wrap('supplied properties not correct for "CastColumnTypeOperationProperty"');
    }
    function cfnDataSetCastColumnTypeOperationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSet_CastColumnTypeOperationPropertyValidator(properties).assertSuccess(), { ColumnName: cdk.stringToCloudFormation(properties.columnName), Format: cdk.stringToCloudFormation(properties.format), NewColumnType: cdk.stringToCloudFormation(properties.newColumnType) }) : properties;
    }
    function CfnDataSetCastColumnTypeOperationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columnName", "ColumnName", cfn_parse.FromCloudFormation.getString(properties.ColumnName)), ret.addPropertyResult("format", "Format", properties.Format != null ? cfn_parse.FromCloudFormation.getString(properties.Format) : void 0), ret.addPropertyResult("newColumnType", "NewColumnType", cfn_parse.FromCloudFormation.getString(properties.NewColumnType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSet_ColumnDescriptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("text", cdk.validateString)(properties.text)), errors.wrap('supplied properties not correct for "ColumnDescriptionProperty"');
    }
    function cfnDataSetColumnDescriptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSet_ColumnDescriptionPropertyValidator(properties).assertSuccess(), { Text: cdk.stringToCloudFormation(properties.text) }) : properties;
    }
    function CfnDataSetColumnDescriptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("text", "Text", properties.Text != null ? cfn_parse.FromCloudFormation.getString(properties.Text) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSet_ColumnGroupPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("geoSpatialColumnGroup", CfnDataSet_GeoSpatialColumnGroupPropertyValidator)(properties.geoSpatialColumnGroup)), errors.wrap('supplied properties not correct for "ColumnGroupProperty"');
    }
    function cfnDataSetColumnGroupPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSet_ColumnGroupPropertyValidator(properties).assertSuccess(), { GeoSpatialColumnGroup: cfnDataSetGeoSpatialColumnGroupPropertyToCloudFormation(properties.geoSpatialColumnGroup) }) : properties;
    }
    function CfnDataSetColumnGroupPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("geoSpatialColumnGroup", "GeoSpatialColumnGroup", properties.GeoSpatialColumnGroup != null ? CfnDataSetGeoSpatialColumnGroupPropertyFromCloudFormation(properties.GeoSpatialColumnGroup) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSet_ColumnLevelPermissionRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnNames", cdk.listValidator(cdk.validateString))(properties.columnNames)), errors.collect(cdk.propertyValidator("principals", cdk.listValidator(cdk.validateString))(properties.principals)), errors.wrap('supplied properties not correct for "ColumnLevelPermissionRuleProperty"');
    }
    function cfnDataSetColumnLevelPermissionRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSet_ColumnLevelPermissionRulePropertyValidator(properties).assertSuccess(), { ColumnNames: cdk.listMapper(cdk.stringToCloudFormation)(properties.columnNames), Principals: cdk.listMapper(cdk.stringToCloudFormation)(properties.principals) }) : properties;
    }
    function CfnDataSetColumnLevelPermissionRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columnNames", "ColumnNames", properties.ColumnNames != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ColumnNames) : void 0), ret.addPropertyResult("principals", "Principals", properties.Principals != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Principals) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSet_ColumnTagPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnDescription", CfnDataSet_ColumnDescriptionPropertyValidator)(properties.columnDescription)), errors.collect(cdk.propertyValidator("columnGeographicRole", cdk.validateString)(properties.columnGeographicRole)), errors.wrap('supplied properties not correct for "ColumnTagProperty"');
    }
    function cfnDataSetColumnTagPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSet_ColumnTagPropertyValidator(properties).assertSuccess(), { ColumnDescription: cfnDataSetColumnDescriptionPropertyToCloudFormation(properties.columnDescription), ColumnGeographicRole: cdk.stringToCloudFormation(properties.columnGeographicRole) }) : properties;
    }
    function CfnDataSetColumnTagPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columnDescription", "ColumnDescription", properties.ColumnDescription != null ? CfnDataSetColumnDescriptionPropertyFromCloudFormation(properties.ColumnDescription) : void 0), ret.addPropertyResult("columnGeographicRole", "ColumnGeographicRole", properties.ColumnGeographicRole != null ? cfn_parse.FromCloudFormation.getString(properties.ColumnGeographicRole) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSet_CreateColumnsOperationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columns", cdk.requiredValidator)(properties.columns)), errors.collect(cdk.propertyValidator("columns", cdk.listValidator(CfnDataSet_CalculatedColumnPropertyValidator))(properties.columns)), errors.wrap('supplied properties not correct for "CreateColumnsOperationProperty"');
    }
    function cfnDataSetCreateColumnsOperationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSet_CreateColumnsOperationPropertyValidator(properties).assertSuccess(), { Columns: cdk.listMapper(cfnDataSetCalculatedColumnPropertyToCloudFormation)(properties.columns) }) : properties;
    }
    function CfnDataSetCreateColumnsOperationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columns", "Columns", cfn_parse.FromCloudFormation.getArray(CfnDataSetCalculatedColumnPropertyFromCloudFormation)(properties.Columns)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSet_CustomSqlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columns", cdk.requiredValidator)(properties.columns)), errors.collect(cdk.propertyValidator("columns", cdk.listValidator(CfnDataSet_InputColumnPropertyValidator))(properties.columns)), errors.collect(cdk.propertyValidator("dataSourceArn", cdk.requiredValidator)(properties.dataSourceArn)), errors.collect(cdk.propertyValidator("dataSourceArn", cdk.validateString)(properties.dataSourceArn)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("sqlQuery", cdk.requiredValidator)(properties.sqlQuery)), errors.collect(cdk.propertyValidator("sqlQuery", cdk.validateString)(properties.sqlQuery)), errors.wrap('supplied properties not correct for "CustomSqlProperty"');
    }
    function cfnDataSetCustomSqlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSet_CustomSqlPropertyValidator(properties).assertSuccess(), { Columns: cdk.listMapper(cfnDataSetInputColumnPropertyToCloudFormation)(properties.columns), DataSourceArn: cdk.stringToCloudFormation(properties.dataSourceArn), Name: cdk.stringToCloudFormation(properties.name), SqlQuery: cdk.stringToCloudFormation(properties.sqlQuery) }) : properties;
    }
    function CfnDataSetCustomSqlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columns", "Columns", cfn_parse.FromCloudFormation.getArray(CfnDataSetInputColumnPropertyFromCloudFormation)(properties.Columns)), ret.addPropertyResult("dataSourceArn", "DataSourceArn", cfn_parse.FromCloudFormation.getString(properties.DataSourceArn)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("sqlQuery", "SqlQuery", cfn_parse.FromCloudFormation.getString(properties.SqlQuery)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSet_DataSetUsageConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("disableUseAsDirectQuerySource", cdk.validateBoolean)(properties.disableUseAsDirectQuerySource)), errors.collect(cdk.propertyValidator("disableUseAsImportedSource", cdk.validateBoolean)(properties.disableUseAsImportedSource)), errors.wrap('supplied properties not correct for "DataSetUsageConfigurationProperty"');
    }
    function cfnDataSetDataSetUsageConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSet_DataSetUsageConfigurationPropertyValidator(properties).assertSuccess(), { DisableUseAsDirectQuerySource: cdk.booleanToCloudFormation(properties.disableUseAsDirectQuerySource), DisableUseAsImportedSource: cdk.booleanToCloudFormation(properties.disableUseAsImportedSource) }) : properties;
    }
    function CfnDataSetDataSetUsageConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("disableUseAsDirectQuerySource", "DisableUseAsDirectQuerySource", properties.DisableUseAsDirectQuerySource != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DisableUseAsDirectQuerySource) : void 0), ret.addPropertyResult("disableUseAsImportedSource", "DisableUseAsImportedSource", properties.DisableUseAsImportedSource != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DisableUseAsImportedSource) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSet_FieldFolderPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columns", cdk.listValidator(cdk.validateString))(properties.columns)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.wrap('supplied properties not correct for "FieldFolderProperty"');
    }
    function cfnDataSetFieldFolderPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSet_FieldFolderPropertyValidator(properties).assertSuccess(), { Columns: cdk.listMapper(cdk.stringToCloudFormation)(properties.columns), Description: cdk.stringToCloudFormation(properties.description) }) : properties;
    }
    function CfnDataSetFieldFolderPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columns", "Columns", properties.Columns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Columns) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSet_FilterOperationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("conditionExpression", cdk.requiredValidator)(properties.conditionExpression)), errors.collect(cdk.propertyValidator("conditionExpression", cdk.validateString)(properties.conditionExpression)), errors.wrap('supplied properties not correct for "FilterOperationProperty"');
    }
    function cfnDataSetFilterOperationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSet_FilterOperationPropertyValidator(properties).assertSuccess(), { ConditionExpression: cdk.stringToCloudFormation(properties.conditionExpression) }) : properties;
    }
    function CfnDataSetFilterOperationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("conditionExpression", "ConditionExpression", cfn_parse.FromCloudFormation.getString(properties.ConditionExpression)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSet_GeoSpatialColumnGroupPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columns", cdk.requiredValidator)(properties.columns)), errors.collect(cdk.propertyValidator("columns", cdk.listValidator(cdk.validateString))(properties.columns)), errors.collect(cdk.propertyValidator("countryCode", cdk.validateString)(properties.countryCode)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "GeoSpatialColumnGroupProperty"');
    }
    function cfnDataSetGeoSpatialColumnGroupPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSet_GeoSpatialColumnGroupPropertyValidator(properties).assertSuccess(), { Columns: cdk.listMapper(cdk.stringToCloudFormation)(properties.columns), CountryCode: cdk.stringToCloudFormation(properties.countryCode), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnDataSetGeoSpatialColumnGroupPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columns", "Columns", cfn_parse.FromCloudFormation.getStringArray(properties.Columns)), ret.addPropertyResult("countryCode", "CountryCode", properties.CountryCode != null ? cfn_parse.FromCloudFormation.getString(properties.CountryCode) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSet_IngestionWaitPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ingestionWaitTimeInHours", cdk.validateNumber)(properties.ingestionWaitTimeInHours)), errors.collect(cdk.propertyValidator("waitForSpiceIngestion", cdk.validateBoolean)(properties.waitForSpiceIngestion)), errors.wrap('supplied properties not correct for "IngestionWaitPolicyProperty"');
    }
    function cfnDataSetIngestionWaitPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSet_IngestionWaitPolicyPropertyValidator(properties).assertSuccess(), { IngestionWaitTimeInHours: cdk.numberToCloudFormation(properties.ingestionWaitTimeInHours), WaitForSpiceIngestion: cdk.booleanToCloudFormation(properties.waitForSpiceIngestion) }) : properties;
    }
    function CfnDataSetIngestionWaitPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ingestionWaitTimeInHours", "IngestionWaitTimeInHours", properties.IngestionWaitTimeInHours != null ? cfn_parse.FromCloudFormation.getNumber(properties.IngestionWaitTimeInHours) : void 0), ret.addPropertyResult("waitForSpiceIngestion", "WaitForSpiceIngestion", properties.WaitForSpiceIngestion != null ? cfn_parse.FromCloudFormation.getBoolean(properties.WaitForSpiceIngestion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSet_InputColumnPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "InputColumnProperty"');
    }
    function cfnDataSetInputColumnPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSet_InputColumnPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnDataSetInputColumnPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSet_JoinInstructionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("leftJoinKeyProperties", CfnDataSet_JoinKeyPropertiesPropertyValidator)(properties.leftJoinKeyProperties)), errors.collect(cdk.propertyValidator("leftOperand", cdk.requiredValidator)(properties.leftOperand)), errors.collect(cdk.propertyValidator("leftOperand", cdk.validateString)(properties.leftOperand)), errors.collect(cdk.propertyValidator("onClause", cdk.requiredValidator)(properties.onClause)), errors.collect(cdk.propertyValidator("onClause", cdk.validateString)(properties.onClause)), errors.collect(cdk.propertyValidator("rightJoinKeyProperties", CfnDataSet_JoinKeyPropertiesPropertyValidator)(properties.rightJoinKeyProperties)), errors.collect(cdk.propertyValidator("rightOperand", cdk.requiredValidator)(properties.rightOperand)), errors.collect(cdk.propertyValidator("rightOperand", cdk.validateString)(properties.rightOperand)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "JoinInstructionProperty"');
    }
    function cfnDataSetJoinInstructionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSet_JoinInstructionPropertyValidator(properties).assertSuccess(), { LeftJoinKeyProperties: cfnDataSetJoinKeyPropertiesPropertyToCloudFormation(properties.leftJoinKeyProperties), LeftOperand: cdk.stringToCloudFormation(properties.leftOperand), OnClause: cdk.stringToCloudFormation(properties.onClause), RightJoinKeyProperties: cfnDataSetJoinKeyPropertiesPropertyToCloudFormation(properties.rightJoinKeyProperties), RightOperand: cdk.stringToCloudFormation(properties.rightOperand), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnDataSetJoinInstructionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("leftJoinKeyProperties", "LeftJoinKeyProperties", properties.LeftJoinKeyProperties != null ? CfnDataSetJoinKeyPropertiesPropertyFromCloudFormation(properties.LeftJoinKeyProperties) : void 0), ret.addPropertyResult("leftOperand", "LeftOperand", cfn_parse.FromCloudFormation.getString(properties.LeftOperand)), ret.addPropertyResult("onClause", "OnClause", cfn_parse.FromCloudFormation.getString(properties.OnClause)), ret.addPropertyResult("rightJoinKeyProperties", "RightJoinKeyProperties", properties.RightJoinKeyProperties != null ? CfnDataSetJoinKeyPropertiesPropertyFromCloudFormation(properties.RightJoinKeyProperties) : void 0), ret.addPropertyResult("rightOperand", "RightOperand", cfn_parse.FromCloudFormation.getString(properties.RightOperand)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSet_JoinKeyPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("uniqueKey", cdk.validateBoolean)(properties.uniqueKey)), errors.wrap('supplied properties not correct for "JoinKeyPropertiesProperty"');
    }
    function cfnDataSetJoinKeyPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSet_JoinKeyPropertiesPropertyValidator(properties).assertSuccess(), { UniqueKey: cdk.booleanToCloudFormation(properties.uniqueKey) }) : properties;
    }
    function CfnDataSetJoinKeyPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("uniqueKey", "UniqueKey", properties.UniqueKey != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UniqueKey) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSet_LogicalTablePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alias", cdk.requiredValidator)(properties.alias)), errors.collect(cdk.propertyValidator("alias", cdk.validateString)(properties.alias)), errors.collect(cdk.propertyValidator("dataTransforms", cdk.listValidator(CfnDataSet_TransformOperationPropertyValidator))(properties.dataTransforms)), errors.collect(cdk.propertyValidator("source", cdk.requiredValidator)(properties.source)), errors.collect(cdk.propertyValidator("source", CfnDataSet_LogicalTableSourcePropertyValidator)(properties.source)), errors.wrap('supplied properties not correct for "LogicalTableProperty"');
    }
    function cfnDataSetLogicalTablePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSet_LogicalTablePropertyValidator(properties).assertSuccess(), { Alias: cdk.stringToCloudFormation(properties.alias), DataTransforms: cdk.listMapper(cfnDataSetTransformOperationPropertyToCloudFormation)(properties.dataTransforms), Source: cfnDataSetLogicalTableSourcePropertyToCloudFormation(properties.source) }) : properties;
    }
    function CfnDataSetLogicalTablePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alias", "Alias", cfn_parse.FromCloudFormation.getString(properties.Alias)), ret.addPropertyResult("dataTransforms", "DataTransforms", properties.DataTransforms != null ? cfn_parse.FromCloudFormation.getArray(CfnDataSetTransformOperationPropertyFromCloudFormation)(properties.DataTransforms) : void 0), ret.addPropertyResult("source", "Source", CfnDataSetLogicalTableSourcePropertyFromCloudFormation(properties.Source)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSet_LogicalTableSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataSetArn", cdk.validateString)(properties.dataSetArn)), errors.collect(cdk.propertyValidator("joinInstruction", CfnDataSet_JoinInstructionPropertyValidator)(properties.joinInstruction)), errors.collect(cdk.propertyValidator("physicalTableId", cdk.validateString)(properties.physicalTableId)), errors.wrap('supplied properties not correct for "LogicalTableSourceProperty"');
    }
    function cfnDataSetLogicalTableSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSet_LogicalTableSourcePropertyValidator(properties).assertSuccess(), { DataSetArn: cdk.stringToCloudFormation(properties.dataSetArn), JoinInstruction: cfnDataSetJoinInstructionPropertyToCloudFormation(properties.joinInstruction), PhysicalTableId: cdk.stringToCloudFormation(properties.physicalTableId) }) : properties;
    }
    function CfnDataSetLogicalTableSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataSetArn", "DataSetArn", properties.DataSetArn != null ? cfn_parse.FromCloudFormation.getString(properties.DataSetArn) : void 0), ret.addPropertyResult("joinInstruction", "JoinInstruction", properties.JoinInstruction != null ? CfnDataSetJoinInstructionPropertyFromCloudFormation(properties.JoinInstruction) : void 0), ret.addPropertyResult("physicalTableId", "PhysicalTableId", properties.PhysicalTableId != null ? cfn_parse.FromCloudFormation.getString(properties.PhysicalTableId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSet_PhysicalTablePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customSql", CfnDataSet_CustomSqlPropertyValidator)(properties.customSql)), errors.collect(cdk.propertyValidator("relationalTable", CfnDataSet_RelationalTablePropertyValidator)(properties.relationalTable)), errors.collect(cdk.propertyValidator("s3Source", CfnDataSet_S3SourcePropertyValidator)(properties.s3Source)), errors.wrap('supplied properties not correct for "PhysicalTableProperty"');
    }
    function cfnDataSetPhysicalTablePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSet_PhysicalTablePropertyValidator(properties).assertSuccess(), { CustomSql: cfnDataSetCustomSqlPropertyToCloudFormation(properties.customSql), RelationalTable: cfnDataSetRelationalTablePropertyToCloudFormation(properties.relationalTable), S3Source: cfnDataSetS3SourcePropertyToCloudFormation(properties.s3Source) }) : properties;
    }
    function CfnDataSetPhysicalTablePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customSql", "CustomSql", properties.CustomSql != null ? CfnDataSetCustomSqlPropertyFromCloudFormation(properties.CustomSql) : void 0), ret.addPropertyResult("relationalTable", "RelationalTable", properties.RelationalTable != null ? CfnDataSetRelationalTablePropertyFromCloudFormation(properties.RelationalTable) : void 0), ret.addPropertyResult("s3Source", "S3Source", properties.S3Source != null ? CfnDataSetS3SourcePropertyFromCloudFormation(properties.S3Source) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSet_ProjectOperationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("projectedColumns", cdk.requiredValidator)(properties.projectedColumns)), errors.collect(cdk.propertyValidator("projectedColumns", cdk.listValidator(cdk.validateString))(properties.projectedColumns)), errors.wrap('supplied properties not correct for "ProjectOperationProperty"');
    }
    function cfnDataSetProjectOperationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSet_ProjectOperationPropertyValidator(properties).assertSuccess(), { ProjectedColumns: cdk.listMapper(cdk.stringToCloudFormation)(properties.projectedColumns) }) : properties;
    }
    function CfnDataSetProjectOperationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("projectedColumns", "ProjectedColumns", cfn_parse.FromCloudFormation.getStringArray(properties.ProjectedColumns)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSet_RelationalTablePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalog", cdk.validateString)(properties.catalog)), errors.collect(cdk.propertyValidator("dataSourceArn", cdk.requiredValidator)(properties.dataSourceArn)), errors.collect(cdk.propertyValidator("dataSourceArn", cdk.validateString)(properties.dataSourceArn)), errors.collect(cdk.propertyValidator("inputColumns", cdk.requiredValidator)(properties.inputColumns)), errors.collect(cdk.propertyValidator("inputColumns", cdk.listValidator(CfnDataSet_InputColumnPropertyValidator))(properties.inputColumns)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("schema", cdk.validateString)(properties.schema)), errors.wrap('supplied properties not correct for "RelationalTableProperty"');
    }
    function cfnDataSetRelationalTablePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSet_RelationalTablePropertyValidator(properties).assertSuccess(), { Catalog: cdk.stringToCloudFormation(properties.catalog), DataSourceArn: cdk.stringToCloudFormation(properties.dataSourceArn), InputColumns: cdk.listMapper(cfnDataSetInputColumnPropertyToCloudFormation)(properties.inputColumns), Name: cdk.stringToCloudFormation(properties.name), Schema: cdk.stringToCloudFormation(properties.schema) }) : properties;
    }
    function CfnDataSetRelationalTablePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalog", "Catalog", properties.Catalog != null ? cfn_parse.FromCloudFormation.getString(properties.Catalog) : void 0), ret.addPropertyResult("dataSourceArn", "DataSourceArn", cfn_parse.FromCloudFormation.getString(properties.DataSourceArn)), ret.addPropertyResult("inputColumns", "InputColumns", cfn_parse.FromCloudFormation.getArray(CfnDataSetInputColumnPropertyFromCloudFormation)(properties.InputColumns)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("schema", "Schema", properties.Schema != null ? cfn_parse.FromCloudFormation.getString(properties.Schema) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSet_RenameColumnOperationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnName", cdk.requiredValidator)(properties.columnName)), errors.collect(cdk.propertyValidator("columnName", cdk.validateString)(properties.columnName)), errors.collect(cdk.propertyValidator("newColumnName", cdk.requiredValidator)(properties.newColumnName)), errors.collect(cdk.propertyValidator("newColumnName", cdk.validateString)(properties.newColumnName)), errors.wrap('supplied properties not correct for "RenameColumnOperationProperty"');
    }
    function cfnDataSetRenameColumnOperationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSet_RenameColumnOperationPropertyValidator(properties).assertSuccess(), { ColumnName: cdk.stringToCloudFormation(properties.columnName), NewColumnName: cdk.stringToCloudFormation(properties.newColumnName) }) : properties;
    }
    function CfnDataSetRenameColumnOperationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columnName", "ColumnName", cfn_parse.FromCloudFormation.getString(properties.ColumnName)), ret.addPropertyResult("newColumnName", "NewColumnName", cfn_parse.FromCloudFormation.getString(properties.NewColumnName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSet_ResourcePermissionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.requiredValidator)(properties.actions)), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(cdk.validateString))(properties.actions)), errors.collect(cdk.propertyValidator("principal", cdk.requiredValidator)(properties.principal)), errors.collect(cdk.propertyValidator("principal", cdk.validateString)(properties.principal)), errors.wrap('supplied properties not correct for "ResourcePermissionProperty"');
    }
    function cfnDataSetResourcePermissionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSet_ResourcePermissionPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cdk.stringToCloudFormation)(properties.actions), Principal: cdk.stringToCloudFormation(properties.principal) }) : properties;
    }
    function CfnDataSetResourcePermissionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", cfn_parse.FromCloudFormation.getStringArray(properties.Actions)), ret.addPropertyResult("principal", "Principal", cfn_parse.FromCloudFormation.getString(properties.Principal)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSet_RowLevelPermissionDataSetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.requiredValidator)(properties.arn)), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("formatVersion", cdk.validateString)(properties.formatVersion)), errors.collect(cdk.propertyValidator("namespace", cdk.validateString)(properties.namespace)), errors.collect(cdk.propertyValidator("permissionPolicy", cdk.requiredValidator)(properties.permissionPolicy)), errors.collect(cdk.propertyValidator("permissionPolicy", cdk.validateString)(properties.permissionPolicy)), errors.wrap('supplied properties not correct for "RowLevelPermissionDataSetProperty"');
    }
    function cfnDataSetRowLevelPermissionDataSetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSet_RowLevelPermissionDataSetPropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn), FormatVersion: cdk.stringToCloudFormation(properties.formatVersion), Namespace: cdk.stringToCloudFormation(properties.namespace), PermissionPolicy: cdk.stringToCloudFormation(properties.permissionPolicy) }) : properties;
    }
    function CfnDataSetRowLevelPermissionDataSetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", cfn_parse.FromCloudFormation.getString(properties.Arn)), ret.addPropertyResult("formatVersion", "FormatVersion", properties.FormatVersion != null ? cfn_parse.FromCloudFormation.getString(properties.FormatVersion) : void 0), ret.addPropertyResult("namespace", "Namespace", properties.Namespace != null ? cfn_parse.FromCloudFormation.getString(properties.Namespace) : void 0), ret.addPropertyResult("permissionPolicy", "PermissionPolicy", cfn_parse.FromCloudFormation.getString(properties.PermissionPolicy)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSet_S3SourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataSourceArn", cdk.requiredValidator)(properties.dataSourceArn)), errors.collect(cdk.propertyValidator("dataSourceArn", cdk.validateString)(properties.dataSourceArn)), errors.collect(cdk.propertyValidator("inputColumns", cdk.requiredValidator)(properties.inputColumns)), errors.collect(cdk.propertyValidator("inputColumns", cdk.listValidator(CfnDataSet_InputColumnPropertyValidator))(properties.inputColumns)), errors.collect(cdk.propertyValidator("uploadSettings", CfnDataSet_UploadSettingsPropertyValidator)(properties.uploadSettings)), errors.wrap('supplied properties not correct for "S3SourceProperty"');
    }
    function cfnDataSetS3SourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSet_S3SourcePropertyValidator(properties).assertSuccess(), { DataSourceArn: cdk.stringToCloudFormation(properties.dataSourceArn), InputColumns: cdk.listMapper(cfnDataSetInputColumnPropertyToCloudFormation)(properties.inputColumns), UploadSettings: cfnDataSetUploadSettingsPropertyToCloudFormation(properties.uploadSettings) }) : properties;
    }
    function CfnDataSetS3SourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataSourceArn", "DataSourceArn", cfn_parse.FromCloudFormation.getString(properties.DataSourceArn)), ret.addPropertyResult("inputColumns", "InputColumns", cfn_parse.FromCloudFormation.getArray(CfnDataSetInputColumnPropertyFromCloudFormation)(properties.InputColumns)), ret.addPropertyResult("uploadSettings", "UploadSettings", properties.UploadSettings != null ? CfnDataSetUploadSettingsPropertyFromCloudFormation(properties.UploadSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSet_TagColumnOperationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnName", cdk.requiredValidator)(properties.columnName)), errors.collect(cdk.propertyValidator("columnName", cdk.validateString)(properties.columnName)), errors.collect(cdk.propertyValidator("tags", cdk.requiredValidator)(properties.tags)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(CfnDataSet_ColumnTagPropertyValidator))(properties.tags)), errors.wrap('supplied properties not correct for "TagColumnOperationProperty"');
    }
    function cfnDataSetTagColumnOperationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSet_TagColumnOperationPropertyValidator(properties).assertSuccess(), { ColumnName: cdk.stringToCloudFormation(properties.columnName), Tags: cdk.listMapper(cfnDataSetColumnTagPropertyToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDataSetTagColumnOperationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columnName", "ColumnName", cfn_parse.FromCloudFormation.getString(properties.ColumnName)), ret.addPropertyResult("tags", "Tags", cfn_parse.FromCloudFormation.getArray(CfnDataSetColumnTagPropertyFromCloudFormation)(properties.Tags)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSet_TransformOperationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("castColumnTypeOperation", CfnDataSet_CastColumnTypeOperationPropertyValidator)(properties.castColumnTypeOperation)), errors.collect(cdk.propertyValidator("createColumnsOperation", CfnDataSet_CreateColumnsOperationPropertyValidator)(properties.createColumnsOperation)), errors.collect(cdk.propertyValidator("filterOperation", CfnDataSet_FilterOperationPropertyValidator)(properties.filterOperation)), errors.collect(cdk.propertyValidator("projectOperation", CfnDataSet_ProjectOperationPropertyValidator)(properties.projectOperation)), errors.collect(cdk.propertyValidator("renameColumnOperation", CfnDataSet_RenameColumnOperationPropertyValidator)(properties.renameColumnOperation)), errors.collect(cdk.propertyValidator("tagColumnOperation", CfnDataSet_TagColumnOperationPropertyValidator)(properties.tagColumnOperation)), errors.wrap('supplied properties not correct for "TransformOperationProperty"');
    }
    function cfnDataSetTransformOperationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSet_TransformOperationPropertyValidator(properties).assertSuccess(), { CastColumnTypeOperation: cfnDataSetCastColumnTypeOperationPropertyToCloudFormation(properties.castColumnTypeOperation), CreateColumnsOperation: cfnDataSetCreateColumnsOperationPropertyToCloudFormation(properties.createColumnsOperation), FilterOperation: cfnDataSetFilterOperationPropertyToCloudFormation(properties.filterOperation), ProjectOperation: cfnDataSetProjectOperationPropertyToCloudFormation(properties.projectOperation), RenameColumnOperation: cfnDataSetRenameColumnOperationPropertyToCloudFormation(properties.renameColumnOperation), TagColumnOperation: cfnDataSetTagColumnOperationPropertyToCloudFormation(properties.tagColumnOperation) }) : properties;
    }
    function CfnDataSetTransformOperationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("castColumnTypeOperation", "CastColumnTypeOperation", properties.CastColumnTypeOperation != null ? CfnDataSetCastColumnTypeOperationPropertyFromCloudFormation(properties.CastColumnTypeOperation) : void 0), ret.addPropertyResult("createColumnsOperation", "CreateColumnsOperation", properties.CreateColumnsOperation != null ? CfnDataSetCreateColumnsOperationPropertyFromCloudFormation(properties.CreateColumnsOperation) : void 0), ret.addPropertyResult("filterOperation", "FilterOperation", properties.FilterOperation != null ? CfnDataSetFilterOperationPropertyFromCloudFormation(properties.FilterOperation) : void 0), ret.addPropertyResult("projectOperation", "ProjectOperation", properties.ProjectOperation != null ? CfnDataSetProjectOperationPropertyFromCloudFormation(properties.ProjectOperation) : void 0), ret.addPropertyResult("renameColumnOperation", "RenameColumnOperation", properties.RenameColumnOperation != null ? CfnDataSetRenameColumnOperationPropertyFromCloudFormation(properties.RenameColumnOperation) : void 0), ret.addPropertyResult("tagColumnOperation", "TagColumnOperation", properties.TagColumnOperation != null ? CfnDataSetTagColumnOperationPropertyFromCloudFormation(properties.TagColumnOperation) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSet_UploadSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containsHeader", cdk.validateBoolean)(properties.containsHeader)), errors.collect(cdk.propertyValidator("delimiter", cdk.validateString)(properties.delimiter)), errors.collect(cdk.propertyValidator("format", cdk.validateString)(properties.format)), errors.collect(cdk.propertyValidator("startFromRow", cdk.validateNumber)(properties.startFromRow)), errors.collect(cdk.propertyValidator("textQualifier", cdk.validateString)(properties.textQualifier)), errors.wrap('supplied properties not correct for "UploadSettingsProperty"');
    }
    function cfnDataSetUploadSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSet_UploadSettingsPropertyValidator(properties).assertSuccess(), { ContainsHeader: cdk.booleanToCloudFormation(properties.containsHeader), Delimiter: cdk.stringToCloudFormation(properties.delimiter), Format: cdk.stringToCloudFormation(properties.format), StartFromRow: cdk.numberToCloudFormation(properties.startFromRow), TextQualifier: cdk.stringToCloudFormation(properties.textQualifier) }) : properties;
    }
    function CfnDataSetUploadSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containsHeader", "ContainsHeader", properties.ContainsHeader != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ContainsHeader) : void 0), ret.addPropertyResult("delimiter", "Delimiter", properties.Delimiter != null ? cfn_parse.FromCloudFormation.getString(properties.Delimiter) : void 0), ret.addPropertyResult("format", "Format", properties.Format != null ? cfn_parse.FromCloudFormation.getString(properties.Format) : void 0), ret.addPropertyResult("startFromRow", "StartFromRow", properties.StartFromRow != null ? cfn_parse.FromCloudFormation.getNumber(properties.StartFromRow) : void 0), ret.addPropertyResult("textQualifier", "TextQualifier", properties.TextQualifier != null ? cfn_parse.FromCloudFormation.getString(properties.TextQualifier) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSourcePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alternateDataSourceParameters", cdk.listValidator(CfnDataSource_DataSourceParametersPropertyValidator))(properties.alternateDataSourceParameters)), errors.collect(cdk.propertyValidator("awsAccountId", cdk.validateString)(properties.awsAccountId)), errors.collect(cdk.propertyValidator("credentials", CfnDataSource_DataSourceCredentialsPropertyValidator)(properties.credentials)), errors.collect(cdk.propertyValidator("dataSourceId", cdk.validateString)(properties.dataSourceId)), errors.collect(cdk.propertyValidator("dataSourceParameters", CfnDataSource_DataSourceParametersPropertyValidator)(properties.dataSourceParameters)), errors.collect(cdk.propertyValidator("errorInfo", CfnDataSource_DataSourceErrorInfoPropertyValidator)(properties.errorInfo)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("permissions", cdk.listValidator(CfnDataSource_ResourcePermissionPropertyValidator))(properties.permissions)), errors.collect(cdk.propertyValidator("sslProperties", CfnDataSource_SslPropertiesPropertyValidator)(properties.sslProperties)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("vpcConnectionProperties", CfnDataSource_VpcConnectionPropertiesPropertyValidator)(properties.vpcConnectionProperties)), errors.wrap('supplied properties not correct for "CfnDataSourceProps"');
    }
    function cfnDataSourcePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSourcePropsValidator(properties).assertSuccess(), { AlternateDataSourceParameters: cdk.listMapper(cfnDataSourceDataSourceParametersPropertyToCloudFormation)(properties.alternateDataSourceParameters), AwsAccountId: cdk.stringToCloudFormation(properties.awsAccountId), Credentials: cfnDataSourceDataSourceCredentialsPropertyToCloudFormation(properties.credentials), DataSourceId: cdk.stringToCloudFormation(properties.dataSourceId), DataSourceParameters: cfnDataSourceDataSourceParametersPropertyToCloudFormation(properties.dataSourceParameters), ErrorInfo: cfnDataSourceDataSourceErrorInfoPropertyToCloudFormation(properties.errorInfo), Name: cdk.stringToCloudFormation(properties.name), Permissions: cdk.listMapper(cfnDataSourceResourcePermissionPropertyToCloudFormation)(properties.permissions), SslProperties: cfnDataSourceSslPropertiesPropertyToCloudFormation(properties.sslProperties), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), Type: cdk.stringToCloudFormation(properties.type), VpcConnectionProperties: cfnDataSourceVpcConnectionPropertiesPropertyToCloudFormation(properties.vpcConnectionProperties) }) : properties;
    }
    function CfnDataSourcePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alternateDataSourceParameters", "AlternateDataSourceParameters", properties.AlternateDataSourceParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnDataSourceDataSourceParametersPropertyFromCloudFormation)(properties.AlternateDataSourceParameters) : void 0), ret.addPropertyResult("awsAccountId", "AwsAccountId", properties.AwsAccountId != null ? cfn_parse.FromCloudFormation.getString(properties.AwsAccountId) : void 0), ret.addPropertyResult("credentials", "Credentials", properties.Credentials != null ? CfnDataSourceDataSourceCredentialsPropertyFromCloudFormation(properties.Credentials) : void 0), ret.addPropertyResult("dataSourceId", "DataSourceId", properties.DataSourceId != null ? cfn_parse.FromCloudFormation.getString(properties.DataSourceId) : void 0), ret.addPropertyResult("dataSourceParameters", "DataSourceParameters", properties.DataSourceParameters != null ? CfnDataSourceDataSourceParametersPropertyFromCloudFormation(properties.DataSourceParameters) : void 0), ret.addPropertyResult("errorInfo", "ErrorInfo", properties.ErrorInfo != null ? CfnDataSourceDataSourceErrorInfoPropertyFromCloudFormation(properties.ErrorInfo) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("permissions", "Permissions", properties.Permissions != null ? cfn_parse.FromCloudFormation.getArray(CfnDataSourceResourcePermissionPropertyFromCloudFormation)(properties.Permissions) : void 0), ret.addPropertyResult("sslProperties", "SslProperties", properties.SslProperties != null ? CfnDataSourceSslPropertiesPropertyFromCloudFormation(properties.SslProperties) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addPropertyResult("vpcConnectionProperties", "VpcConnectionProperties", properties.VpcConnectionProperties != null ? CfnDataSourceVpcConnectionPropertiesPropertyFromCloudFormation(properties.VpcConnectionProperties) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDataSource = class _CfnDataSource extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDataSourcePropsFromCloudFormation(resourceProperties), ret = new _CfnDataSource(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnDataSource.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_quicksight_CfnDataSourceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDataSource), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreatedTime = cdk.Token.asString(this.getAtt("CreatedTime", cdk.ResolutionTypeHint.STRING)), this.attrLastUpdatedTime = cdk.Token.asString(this.getAtt("LastUpdatedTime", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.alternateDataSourceParameters = props.alternateDataSourceParameters, this.awsAccountId = props.awsAccountId, this.credentials = props.credentials, this.dataSourceId = props.dataSourceId, this.dataSourceParameters = props.dataSourceParameters, this.errorInfo = props.errorInfo, this.name = props.name, this.permissions = props.permissions, this.sslProperties = props.sslProperties, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::QuickSight::DataSource", props.tags, { tagPropertyName: "tags" }), this.type = props.type, this.vpcConnectionProperties = props.vpcConnectionProperties;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDataSource.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { alternateDataSourceParameters: this.alternateDataSourceParameters, awsAccountId: this.awsAccountId, credentials: this.credentials, dataSourceId: this.dataSourceId, dataSourceParameters: this.dataSourceParameters, errorInfo: this.errorInfo, name: this.name, permissions: this.permissions, sslProperties: this.sslProperties, tags: this.tags.renderTags(), type: this.type, vpcConnectionProperties: this.vpcConnectionProperties };
      }
      renderProperties(props) {
        return cfnDataSourcePropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnDataSource[_d] = { fqn: "aws-cdk-lib.aws_quicksight.CfnDataSource", version: "2.80.0" }, CfnDataSource.CFN_RESOURCE_TYPE_NAME = "AWS::QuickSight::DataSource", exports2.CfnDataSource = CfnDataSource;
    function CfnDataSource_AmazonElasticsearchParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("domain", cdk.requiredValidator)(properties.domain)), errors.collect(cdk.propertyValidator("domain", cdk.validateString)(properties.domain)), errors.wrap('supplied properties not correct for "AmazonElasticsearchParametersProperty"');
    }
    function cfnDataSourceAmazonElasticsearchParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_AmazonElasticsearchParametersPropertyValidator(properties).assertSuccess(), { Domain: cdk.stringToCloudFormation(properties.domain) }) : properties;
    }
    function CfnDataSourceAmazonElasticsearchParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("domain", "Domain", cfn_parse.FromCloudFormation.getString(properties.Domain)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_AmazonOpenSearchParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("domain", cdk.requiredValidator)(properties.domain)), errors.collect(cdk.propertyValidator("domain", cdk.validateString)(properties.domain)), errors.wrap('supplied properties not correct for "AmazonOpenSearchParametersProperty"');
    }
    function cfnDataSourceAmazonOpenSearchParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_AmazonOpenSearchParametersPropertyValidator(properties).assertSuccess(), { Domain: cdk.stringToCloudFormation(properties.domain) }) : properties;
    }
    function CfnDataSourceAmazonOpenSearchParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("domain", "Domain", cfn_parse.FromCloudFormation.getString(properties.Domain)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_AthenaParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("workGroup", cdk.validateString)(properties.workGroup)), errors.wrap('supplied properties not correct for "AthenaParametersProperty"');
    }
    function cfnDataSourceAthenaParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_AthenaParametersPropertyValidator(properties).assertSuccess(), { WorkGroup: cdk.stringToCloudFormation(properties.workGroup) }) : properties;
    }
    function CfnDataSourceAthenaParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("workGroup", "WorkGroup", properties.WorkGroup != null ? cfn_parse.FromCloudFormation.getString(properties.WorkGroup) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_AuroraParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("database", cdk.requiredValidator)(properties.database)), errors.collect(cdk.propertyValidator("database", cdk.validateString)(properties.database)), errors.collect(cdk.propertyValidator("host", cdk.requiredValidator)(properties.host)), errors.collect(cdk.propertyValidator("host", cdk.validateString)(properties.host)), errors.collect(cdk.propertyValidator("port", cdk.requiredValidator)(properties.port)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.wrap('supplied properties not correct for "AuroraParametersProperty"');
    }
    function cfnDataSourceAuroraParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_AuroraParametersPropertyValidator(properties).assertSuccess(), { Database: cdk.stringToCloudFormation(properties.database), Host: cdk.stringToCloudFormation(properties.host), Port: cdk.numberToCloudFormation(properties.port) }) : properties;
    }
    function CfnDataSourceAuroraParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("database", "Database", cfn_parse.FromCloudFormation.getString(properties.Database)), ret.addPropertyResult("host", "Host", cfn_parse.FromCloudFormation.getString(properties.Host)), ret.addPropertyResult("port", "Port", cfn_parse.FromCloudFormation.getNumber(properties.Port)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_AuroraPostgreSqlParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("database", cdk.requiredValidator)(properties.database)), errors.collect(cdk.propertyValidator("database", cdk.validateString)(properties.database)), errors.collect(cdk.propertyValidator("host", cdk.requiredValidator)(properties.host)), errors.collect(cdk.propertyValidator("host", cdk.validateString)(properties.host)), errors.collect(cdk.propertyValidator("port", cdk.requiredValidator)(properties.port)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.wrap('supplied properties not correct for "AuroraPostgreSqlParametersProperty"');
    }
    function cfnDataSourceAuroraPostgreSqlParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_AuroraPostgreSqlParametersPropertyValidator(properties).assertSuccess(), { Database: cdk.stringToCloudFormation(properties.database), Host: cdk.stringToCloudFormation(properties.host), Port: cdk.numberToCloudFormation(properties.port) }) : properties;
    }
    function CfnDataSourceAuroraPostgreSqlParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("database", "Database", cfn_parse.FromCloudFormation.getString(properties.Database)), ret.addPropertyResult("host", "Host", cfn_parse.FromCloudFormation.getString(properties.Host)), ret.addPropertyResult("port", "Port", cfn_parse.FromCloudFormation.getNumber(properties.Port)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_CredentialPairPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alternateDataSourceParameters", cdk.listValidator(CfnDataSource_DataSourceParametersPropertyValidator))(properties.alternateDataSourceParameters)), errors.collect(cdk.propertyValidator("password", cdk.requiredValidator)(properties.password)), errors.collect(cdk.propertyValidator("password", cdk.validateString)(properties.password)), errors.collect(cdk.propertyValidator("username", cdk.requiredValidator)(properties.username)), errors.collect(cdk.propertyValidator("username", cdk.validateString)(properties.username)), errors.wrap('supplied properties not correct for "CredentialPairProperty"');
    }
    function cfnDataSourceCredentialPairPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_CredentialPairPropertyValidator(properties).assertSuccess(), { AlternateDataSourceParameters: cdk.listMapper(cfnDataSourceDataSourceParametersPropertyToCloudFormation)(properties.alternateDataSourceParameters), Password: cdk.stringToCloudFormation(properties.password), Username: cdk.stringToCloudFormation(properties.username) }) : properties;
    }
    function CfnDataSourceCredentialPairPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alternateDataSourceParameters", "AlternateDataSourceParameters", properties.AlternateDataSourceParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnDataSourceDataSourceParametersPropertyFromCloudFormation)(properties.AlternateDataSourceParameters) : void 0), ret.addPropertyResult("password", "Password", cfn_parse.FromCloudFormation.getString(properties.Password)), ret.addPropertyResult("username", "Username", cfn_parse.FromCloudFormation.getString(properties.Username)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_DataSourceCredentialsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("copySourceArn", cdk.validateString)(properties.copySourceArn)), errors.collect(cdk.propertyValidator("credentialPair", CfnDataSource_CredentialPairPropertyValidator)(properties.credentialPair)), errors.collect(cdk.propertyValidator("secretArn", cdk.validateString)(properties.secretArn)), errors.wrap('supplied properties not correct for "DataSourceCredentialsProperty"');
    }
    function cfnDataSourceDataSourceCredentialsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_DataSourceCredentialsPropertyValidator(properties).assertSuccess(), { CopySourceArn: cdk.stringToCloudFormation(properties.copySourceArn), CredentialPair: cfnDataSourceCredentialPairPropertyToCloudFormation(properties.credentialPair), SecretArn: cdk.stringToCloudFormation(properties.secretArn) }) : properties;
    }
    function CfnDataSourceDataSourceCredentialsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("copySourceArn", "CopySourceArn", properties.CopySourceArn != null ? cfn_parse.FromCloudFormation.getString(properties.CopySourceArn) : void 0), ret.addPropertyResult("credentialPair", "CredentialPair", properties.CredentialPair != null ? CfnDataSourceCredentialPairPropertyFromCloudFormation(properties.CredentialPair) : void 0), ret.addPropertyResult("secretArn", "SecretArn", properties.SecretArn != null ? cfn_parse.FromCloudFormation.getString(properties.SecretArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_DataSourceErrorInfoPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("message", cdk.validateString)(properties.message)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "DataSourceErrorInfoProperty"');
    }
    function cfnDataSourceDataSourceErrorInfoPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_DataSourceErrorInfoPropertyValidator(properties).assertSuccess(), { Message: cdk.stringToCloudFormation(properties.message), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnDataSourceDataSourceErrorInfoPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("message", "Message", properties.Message != null ? cfn_parse.FromCloudFormation.getString(properties.Message) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_DataSourceParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("amazonElasticsearchParameters", CfnDataSource_AmazonElasticsearchParametersPropertyValidator)(properties.amazonElasticsearchParameters)), errors.collect(cdk.propertyValidator("amazonOpenSearchParameters", CfnDataSource_AmazonOpenSearchParametersPropertyValidator)(properties.amazonOpenSearchParameters)), errors.collect(cdk.propertyValidator("athenaParameters", CfnDataSource_AthenaParametersPropertyValidator)(properties.athenaParameters)), errors.collect(cdk.propertyValidator("auroraParameters", CfnDataSource_AuroraParametersPropertyValidator)(properties.auroraParameters)), errors.collect(cdk.propertyValidator("auroraPostgreSqlParameters", CfnDataSource_AuroraPostgreSqlParametersPropertyValidator)(properties.auroraPostgreSqlParameters)), errors.collect(cdk.propertyValidator("databricksParameters", CfnDataSource_DatabricksParametersPropertyValidator)(properties.databricksParameters)), errors.collect(cdk.propertyValidator("mariaDbParameters", CfnDataSource_MariaDbParametersPropertyValidator)(properties.mariaDbParameters)), errors.collect(cdk.propertyValidator("mySqlParameters", CfnDataSource_MySqlParametersPropertyValidator)(properties.mySqlParameters)), errors.collect(cdk.propertyValidator("oracleParameters", CfnDataSource_OracleParametersPropertyValidator)(properties.oracleParameters)), errors.collect(cdk.propertyValidator("postgreSqlParameters", CfnDataSource_PostgreSqlParametersPropertyValidator)(properties.postgreSqlParameters)), errors.collect(cdk.propertyValidator("prestoParameters", CfnDataSource_PrestoParametersPropertyValidator)(properties.prestoParameters)), errors.collect(cdk.propertyValidator("rdsParameters", CfnDataSource_RdsParametersPropertyValidator)(properties.rdsParameters)), errors.collect(cdk.propertyValidator("redshiftParameters", CfnDataSource_RedshiftParametersPropertyValidator)(properties.redshiftParameters)), errors.collect(cdk.propertyValidator("s3Parameters", CfnDataSource_S3ParametersPropertyValidator)(properties.s3Parameters)), errors.collect(cdk.propertyValidator("snowflakeParameters", CfnDataSource_SnowflakeParametersPropertyValidator)(properties.snowflakeParameters)), errors.collect(cdk.propertyValidator("sparkParameters", CfnDataSource_SparkParametersPropertyValidator)(properties.sparkParameters)), errors.collect(cdk.propertyValidator("sqlServerParameters", CfnDataSource_SqlServerParametersPropertyValidator)(properties.sqlServerParameters)), errors.collect(cdk.propertyValidator("teradataParameters", CfnDataSource_TeradataParametersPropertyValidator)(properties.teradataParameters)), errors.wrap('supplied properties not correct for "DataSourceParametersProperty"');
    }
    function cfnDataSourceDataSourceParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_DataSourceParametersPropertyValidator(properties).assertSuccess(), { AmazonElasticsearchParameters: cfnDataSourceAmazonElasticsearchParametersPropertyToCloudFormation(properties.amazonElasticsearchParameters), AmazonOpenSearchParameters: cfnDataSourceAmazonOpenSearchParametersPropertyToCloudFormation(properties.amazonOpenSearchParameters), AthenaParameters: cfnDataSourceAthenaParametersPropertyToCloudFormation(properties.athenaParameters), AuroraParameters: cfnDataSourceAuroraParametersPropertyToCloudFormation(properties.auroraParameters), AuroraPostgreSqlParameters: cfnDataSourceAuroraPostgreSqlParametersPropertyToCloudFormation(properties.auroraPostgreSqlParameters), DatabricksParameters: cfnDataSourceDatabricksParametersPropertyToCloudFormation(properties.databricksParameters), MariaDbParameters: cfnDataSourceMariaDbParametersPropertyToCloudFormation(properties.mariaDbParameters), MySqlParameters: cfnDataSourceMySqlParametersPropertyToCloudFormation(properties.mySqlParameters), OracleParameters: cfnDataSourceOracleParametersPropertyToCloudFormation(properties.oracleParameters), PostgreSqlParameters: cfnDataSourcePostgreSqlParametersPropertyToCloudFormation(properties.postgreSqlParameters), PrestoParameters: cfnDataSourcePrestoParametersPropertyToCloudFormation(properties.prestoParameters), RdsParameters: cfnDataSourceRdsParametersPropertyToCloudFormation(properties.rdsParameters), RedshiftParameters: cfnDataSourceRedshiftParametersPropertyToCloudFormation(properties.redshiftParameters), S3Parameters: cfnDataSourceS3ParametersPropertyToCloudFormation(properties.s3Parameters), SnowflakeParameters: cfnDataSourceSnowflakeParametersPropertyToCloudFormation(properties.snowflakeParameters), SparkParameters: cfnDataSourceSparkParametersPropertyToCloudFormation(properties.sparkParameters), SqlServerParameters: cfnDataSourceSqlServerParametersPropertyToCloudFormation(properties.sqlServerParameters), TeradataParameters: cfnDataSourceTeradataParametersPropertyToCloudFormation(properties.teradataParameters) }) : properties;
    }
    function CfnDataSourceDataSourceParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("amazonElasticsearchParameters", "AmazonElasticsearchParameters", properties.AmazonElasticsearchParameters != null ? CfnDataSourceAmazonElasticsearchParametersPropertyFromCloudFormation(properties.AmazonElasticsearchParameters) : void 0), ret.addPropertyResult("amazonOpenSearchParameters", "AmazonOpenSearchParameters", properties.AmazonOpenSearchParameters != null ? CfnDataSourceAmazonOpenSearchParametersPropertyFromCloudFormation(properties.AmazonOpenSearchParameters) : void 0), ret.addPropertyResult("athenaParameters", "AthenaParameters", properties.AthenaParameters != null ? CfnDataSourceAthenaParametersPropertyFromCloudFormation(properties.AthenaParameters) : void 0), ret.addPropertyResult("auroraParameters", "AuroraParameters", properties.AuroraParameters != null ? CfnDataSourceAuroraParametersPropertyFromCloudFormation(properties.AuroraParameters) : void 0), ret.addPropertyResult("auroraPostgreSqlParameters", "AuroraPostgreSqlParameters", properties.AuroraPostgreSqlParameters != null ? CfnDataSourceAuroraPostgreSqlParametersPropertyFromCloudFormation(properties.AuroraPostgreSqlParameters) : void 0), ret.addPropertyResult("databricksParameters", "DatabricksParameters", properties.DatabricksParameters != null ? CfnDataSourceDatabricksParametersPropertyFromCloudFormation(properties.DatabricksParameters) : void 0), ret.addPropertyResult("mariaDbParameters", "MariaDbParameters", properties.MariaDbParameters != null ? CfnDataSourceMariaDbParametersPropertyFromCloudFormation(properties.MariaDbParameters) : void 0), ret.addPropertyResult("mySqlParameters", "MySqlParameters", properties.MySqlParameters != null ? CfnDataSourceMySqlParametersPropertyFromCloudFormation(properties.MySqlParameters) : void 0), ret.addPropertyResult("oracleParameters", "OracleParameters", properties.OracleParameters != null ? CfnDataSourceOracleParametersPropertyFromCloudFormation(properties.OracleParameters) : void 0), ret.addPropertyResult("postgreSqlParameters", "PostgreSqlParameters", properties.PostgreSqlParameters != null ? CfnDataSourcePostgreSqlParametersPropertyFromCloudFormation(properties.PostgreSqlParameters) : void 0), ret.addPropertyResult("prestoParameters", "PrestoParameters", properties.PrestoParameters != null ? CfnDataSourcePrestoParametersPropertyFromCloudFormation(properties.PrestoParameters) : void 0), ret.addPropertyResult("rdsParameters", "RdsParameters", properties.RdsParameters != null ? CfnDataSourceRdsParametersPropertyFromCloudFormation(properties.RdsParameters) : void 0), ret.addPropertyResult("redshiftParameters", "RedshiftParameters", properties.RedshiftParameters != null ? CfnDataSourceRedshiftParametersPropertyFromCloudFormation(properties.RedshiftParameters) : void 0), ret.addPropertyResult("s3Parameters", "S3Parameters", properties.S3Parameters != null ? CfnDataSourceS3ParametersPropertyFromCloudFormation(properties.S3Parameters) : void 0), ret.addPropertyResult("snowflakeParameters", "SnowflakeParameters", properties.SnowflakeParameters != null ? CfnDataSourceSnowflakeParametersPropertyFromCloudFormation(properties.SnowflakeParameters) : void 0), ret.addPropertyResult("sparkParameters", "SparkParameters", properties.SparkParameters != null ? CfnDataSourceSparkParametersPropertyFromCloudFormation(properties.SparkParameters) : void 0), ret.addPropertyResult("sqlServerParameters", "SqlServerParameters", properties.SqlServerParameters != null ? CfnDataSourceSqlServerParametersPropertyFromCloudFormation(properties.SqlServerParameters) : void 0), ret.addPropertyResult("teradataParameters", "TeradataParameters", properties.TeradataParameters != null ? CfnDataSourceTeradataParametersPropertyFromCloudFormation(properties.TeradataParameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_DatabricksParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("host", cdk.requiredValidator)(properties.host)), errors.collect(cdk.propertyValidator("host", cdk.validateString)(properties.host)), errors.collect(cdk.propertyValidator("port", cdk.requiredValidator)(properties.port)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("sqlEndpointPath", cdk.requiredValidator)(properties.sqlEndpointPath)), errors.collect(cdk.propertyValidator("sqlEndpointPath", cdk.validateString)(properties.sqlEndpointPath)), errors.wrap('supplied properties not correct for "DatabricksParametersProperty"');
    }
    function cfnDataSourceDatabricksParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_DatabricksParametersPropertyValidator(properties).assertSuccess(), { Host: cdk.stringToCloudFormation(properties.host), Port: cdk.numberToCloudFormation(properties.port), SqlEndpointPath: cdk.stringToCloudFormation(properties.sqlEndpointPath) }) : properties;
    }
    function CfnDataSourceDatabricksParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("host", "Host", cfn_parse.FromCloudFormation.getString(properties.Host)), ret.addPropertyResult("port", "Port", cfn_parse.FromCloudFormation.getNumber(properties.Port)), ret.addPropertyResult("sqlEndpointPath", "SqlEndpointPath", cfn_parse.FromCloudFormation.getString(properties.SqlEndpointPath)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_ManifestFileLocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.requiredValidator)(properties.bucket)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.wrap('supplied properties not correct for "ManifestFileLocationProperty"');
    }
    function cfnDataSourceManifestFileLocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_ManifestFileLocationPropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), Key: cdk.stringToCloudFormation(properties.key) }) : properties;
    }
    function CfnDataSourceManifestFileLocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", cfn_parse.FromCloudFormation.getString(properties.Bucket)), ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_MariaDbParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("database", cdk.requiredValidator)(properties.database)), errors.collect(cdk.propertyValidator("database", cdk.validateString)(properties.database)), errors.collect(cdk.propertyValidator("host", cdk.requiredValidator)(properties.host)), errors.collect(cdk.propertyValidator("host", cdk.validateString)(properties.host)), errors.collect(cdk.propertyValidator("port", cdk.requiredValidator)(properties.port)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.wrap('supplied properties not correct for "MariaDbParametersProperty"');
    }
    function cfnDataSourceMariaDbParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_MariaDbParametersPropertyValidator(properties).assertSuccess(), { Database: cdk.stringToCloudFormation(properties.database), Host: cdk.stringToCloudFormation(properties.host), Port: cdk.numberToCloudFormation(properties.port) }) : properties;
    }
    function CfnDataSourceMariaDbParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("database", "Database", cfn_parse.FromCloudFormation.getString(properties.Database)), ret.addPropertyResult("host", "Host", cfn_parse.FromCloudFormation.getString(properties.Host)), ret.addPropertyResult("port", "Port", cfn_parse.FromCloudFormation.getNumber(properties.Port)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_MySqlParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("database", cdk.requiredValidator)(properties.database)), errors.collect(cdk.propertyValidator("database", cdk.validateString)(properties.database)), errors.collect(cdk.propertyValidator("host", cdk.requiredValidator)(properties.host)), errors.collect(cdk.propertyValidator("host", cdk.validateString)(properties.host)), errors.collect(cdk.propertyValidator("port", cdk.requiredValidator)(properties.port)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.wrap('supplied properties not correct for "MySqlParametersProperty"');
    }
    function cfnDataSourceMySqlParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_MySqlParametersPropertyValidator(properties).assertSuccess(), { Database: cdk.stringToCloudFormation(properties.database), Host: cdk.stringToCloudFormation(properties.host), Port: cdk.numberToCloudFormation(properties.port) }) : properties;
    }
    function CfnDataSourceMySqlParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("database", "Database", cfn_parse.FromCloudFormation.getString(properties.Database)), ret.addPropertyResult("host", "Host", cfn_parse.FromCloudFormation.getString(properties.Host)), ret.addPropertyResult("port", "Port", cfn_parse.FromCloudFormation.getNumber(properties.Port)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_OracleParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("database", cdk.requiredValidator)(properties.database)), errors.collect(cdk.propertyValidator("database", cdk.validateString)(properties.database)), errors.collect(cdk.propertyValidator("host", cdk.requiredValidator)(properties.host)), errors.collect(cdk.propertyValidator("host", cdk.validateString)(properties.host)), errors.collect(cdk.propertyValidator("port", cdk.requiredValidator)(properties.port)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.wrap('supplied properties not correct for "OracleParametersProperty"');
    }
    function cfnDataSourceOracleParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_OracleParametersPropertyValidator(properties).assertSuccess(), { Database: cdk.stringToCloudFormation(properties.database), Host: cdk.stringToCloudFormation(properties.host), Port: cdk.numberToCloudFormation(properties.port) }) : properties;
    }
    function CfnDataSourceOracleParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("database", "Database", cfn_parse.FromCloudFormation.getString(properties.Database)), ret.addPropertyResult("host", "Host", cfn_parse.FromCloudFormation.getString(properties.Host)), ret.addPropertyResult("port", "Port", cfn_parse.FromCloudFormation.getNumber(properties.Port)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_PostgreSqlParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("database", cdk.requiredValidator)(properties.database)), errors.collect(cdk.propertyValidator("database", cdk.validateString)(properties.database)), errors.collect(cdk.propertyValidator("host", cdk.requiredValidator)(properties.host)), errors.collect(cdk.propertyValidator("host", cdk.validateString)(properties.host)), errors.collect(cdk.propertyValidator("port", cdk.requiredValidator)(properties.port)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.wrap('supplied properties not correct for "PostgreSqlParametersProperty"');
    }
    function cfnDataSourcePostgreSqlParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_PostgreSqlParametersPropertyValidator(properties).assertSuccess(), { Database: cdk.stringToCloudFormation(properties.database), Host: cdk.stringToCloudFormation(properties.host), Port: cdk.numberToCloudFormation(properties.port) }) : properties;
    }
    function CfnDataSourcePostgreSqlParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("database", "Database", cfn_parse.FromCloudFormation.getString(properties.Database)), ret.addPropertyResult("host", "Host", cfn_parse.FromCloudFormation.getString(properties.Host)), ret.addPropertyResult("port", "Port", cfn_parse.FromCloudFormation.getNumber(properties.Port)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_PrestoParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("catalog", cdk.requiredValidator)(properties.catalog)), errors.collect(cdk.propertyValidator("catalog", cdk.validateString)(properties.catalog)), errors.collect(cdk.propertyValidator("host", cdk.requiredValidator)(properties.host)), errors.collect(cdk.propertyValidator("host", cdk.validateString)(properties.host)), errors.collect(cdk.propertyValidator("port", cdk.requiredValidator)(properties.port)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.wrap('supplied properties not correct for "PrestoParametersProperty"');
    }
    function cfnDataSourcePrestoParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_PrestoParametersPropertyValidator(properties).assertSuccess(), { Catalog: cdk.stringToCloudFormation(properties.catalog), Host: cdk.stringToCloudFormation(properties.host), Port: cdk.numberToCloudFormation(properties.port) }) : properties;
    }
    function CfnDataSourcePrestoParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("catalog", "Catalog", cfn_parse.FromCloudFormation.getString(properties.Catalog)), ret.addPropertyResult("host", "Host", cfn_parse.FromCloudFormation.getString(properties.Host)), ret.addPropertyResult("port", "Port", cfn_parse.FromCloudFormation.getNumber(properties.Port)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_RdsParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("database", cdk.requiredValidator)(properties.database)), errors.collect(cdk.propertyValidator("database", cdk.validateString)(properties.database)), errors.collect(cdk.propertyValidator("instanceId", cdk.requiredValidator)(properties.instanceId)), errors.collect(cdk.propertyValidator("instanceId", cdk.validateString)(properties.instanceId)), errors.wrap('supplied properties not correct for "RdsParametersProperty"');
    }
    function cfnDataSourceRdsParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_RdsParametersPropertyValidator(properties).assertSuccess(), { Database: cdk.stringToCloudFormation(properties.database), InstanceId: cdk.stringToCloudFormation(properties.instanceId) }) : properties;
    }
    function CfnDataSourceRdsParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("database", "Database", cfn_parse.FromCloudFormation.getString(properties.Database)), ret.addPropertyResult("instanceId", "InstanceId", cfn_parse.FromCloudFormation.getString(properties.InstanceId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_RedshiftParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clusterId", cdk.validateString)(properties.clusterId)), errors.collect(cdk.propertyValidator("database", cdk.requiredValidator)(properties.database)), errors.collect(cdk.propertyValidator("database", cdk.validateString)(properties.database)), errors.collect(cdk.propertyValidator("host", cdk.validateString)(properties.host)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.wrap('supplied properties not correct for "RedshiftParametersProperty"');
    }
    function cfnDataSourceRedshiftParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_RedshiftParametersPropertyValidator(properties).assertSuccess(), { ClusterId: cdk.stringToCloudFormation(properties.clusterId), Database: cdk.stringToCloudFormation(properties.database), Host: cdk.stringToCloudFormation(properties.host), Port: cdk.numberToCloudFormation(properties.port) }) : properties;
    }
    function CfnDataSourceRedshiftParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clusterId", "ClusterId", properties.ClusterId != null ? cfn_parse.FromCloudFormation.getString(properties.ClusterId) : void 0), ret.addPropertyResult("database", "Database", cfn_parse.FromCloudFormation.getString(properties.Database)), ret.addPropertyResult("host", "Host", properties.Host != null ? cfn_parse.FromCloudFormation.getString(properties.Host) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_ResourcePermissionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.requiredValidator)(properties.actions)), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(cdk.validateString))(properties.actions)), errors.collect(cdk.propertyValidator("principal", cdk.requiredValidator)(properties.principal)), errors.collect(cdk.propertyValidator("principal", cdk.validateString)(properties.principal)), errors.wrap('supplied properties not correct for "ResourcePermissionProperty"');
    }
    function cfnDataSourceResourcePermissionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_ResourcePermissionPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cdk.stringToCloudFormation)(properties.actions), Principal: cdk.stringToCloudFormation(properties.principal) }) : properties;
    }
    function CfnDataSourceResourcePermissionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", cfn_parse.FromCloudFormation.getStringArray(properties.Actions)), ret.addPropertyResult("principal", "Principal", cfn_parse.FromCloudFormation.getString(properties.Principal)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_S3ParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("manifestFileLocation", cdk.requiredValidator)(properties.manifestFileLocation)), errors.collect(cdk.propertyValidator("manifestFileLocation", CfnDataSource_ManifestFileLocationPropertyValidator)(properties.manifestFileLocation)), errors.wrap('supplied properties not correct for "S3ParametersProperty"');
    }
    function cfnDataSourceS3ParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_S3ParametersPropertyValidator(properties).assertSuccess(), { ManifestFileLocation: cfnDataSourceManifestFileLocationPropertyToCloudFormation(properties.manifestFileLocation) }) : properties;
    }
    function CfnDataSourceS3ParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("manifestFileLocation", "ManifestFileLocation", CfnDataSourceManifestFileLocationPropertyFromCloudFormation(properties.ManifestFileLocation)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_SnowflakeParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("database", cdk.requiredValidator)(properties.database)), errors.collect(cdk.propertyValidator("database", cdk.validateString)(properties.database)), errors.collect(cdk.propertyValidator("host", cdk.requiredValidator)(properties.host)), errors.collect(cdk.propertyValidator("host", cdk.validateString)(properties.host)), errors.collect(cdk.propertyValidator("warehouse", cdk.requiredValidator)(properties.warehouse)), errors.collect(cdk.propertyValidator("warehouse", cdk.validateString)(properties.warehouse)), errors.wrap('supplied properties not correct for "SnowflakeParametersProperty"');
    }
    function cfnDataSourceSnowflakeParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_SnowflakeParametersPropertyValidator(properties).assertSuccess(), { Database: cdk.stringToCloudFormation(properties.database), Host: cdk.stringToCloudFormation(properties.host), Warehouse: cdk.stringToCloudFormation(properties.warehouse) }) : properties;
    }
    function CfnDataSourceSnowflakeParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("database", "Database", cfn_parse.FromCloudFormation.getString(properties.Database)), ret.addPropertyResult("host", "Host", cfn_parse.FromCloudFormation.getString(properties.Host)), ret.addPropertyResult("warehouse", "Warehouse", cfn_parse.FromCloudFormation.getString(properties.Warehouse)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_SparkParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("host", cdk.requiredValidator)(properties.host)), errors.collect(cdk.propertyValidator("host", cdk.validateString)(properties.host)), errors.collect(cdk.propertyValidator("port", cdk.requiredValidator)(properties.port)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.wrap('supplied properties not correct for "SparkParametersProperty"');
    }
    function cfnDataSourceSparkParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_SparkParametersPropertyValidator(properties).assertSuccess(), { Host: cdk.stringToCloudFormation(properties.host), Port: cdk.numberToCloudFormation(properties.port) }) : properties;
    }
    function CfnDataSourceSparkParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("host", "Host", cfn_parse.FromCloudFormation.getString(properties.Host)), ret.addPropertyResult("port", "Port", cfn_parse.FromCloudFormation.getNumber(properties.Port)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_SqlServerParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("database", cdk.requiredValidator)(properties.database)), errors.collect(cdk.propertyValidator("database", cdk.validateString)(properties.database)), errors.collect(cdk.propertyValidator("host", cdk.requiredValidator)(properties.host)), errors.collect(cdk.propertyValidator("host", cdk.validateString)(properties.host)), errors.collect(cdk.propertyValidator("port", cdk.requiredValidator)(properties.port)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.wrap('supplied properties not correct for "SqlServerParametersProperty"');
    }
    function cfnDataSourceSqlServerParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_SqlServerParametersPropertyValidator(properties).assertSuccess(), { Database: cdk.stringToCloudFormation(properties.database), Host: cdk.stringToCloudFormation(properties.host), Port: cdk.numberToCloudFormation(properties.port) }) : properties;
    }
    function CfnDataSourceSqlServerParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("database", "Database", cfn_parse.FromCloudFormation.getString(properties.Database)), ret.addPropertyResult("host", "Host", cfn_parse.FromCloudFormation.getString(properties.Host)), ret.addPropertyResult("port", "Port", cfn_parse.FromCloudFormation.getNumber(properties.Port)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_SslPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("disableSsl", cdk.validateBoolean)(properties.disableSsl)), errors.wrap('supplied properties not correct for "SslPropertiesProperty"');
    }
    function cfnDataSourceSslPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_SslPropertiesPropertyValidator(properties).assertSuccess(), { DisableSsl: cdk.booleanToCloudFormation(properties.disableSsl) }) : properties;
    }
    function CfnDataSourceSslPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("disableSsl", "DisableSsl", properties.DisableSsl != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DisableSsl) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_TeradataParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("database", cdk.requiredValidator)(properties.database)), errors.collect(cdk.propertyValidator("database", cdk.validateString)(properties.database)), errors.collect(cdk.propertyValidator("host", cdk.requiredValidator)(properties.host)), errors.collect(cdk.propertyValidator("host", cdk.validateString)(properties.host)), errors.collect(cdk.propertyValidator("port", cdk.requiredValidator)(properties.port)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.wrap('supplied properties not correct for "TeradataParametersProperty"');
    }
    function cfnDataSourceTeradataParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_TeradataParametersPropertyValidator(properties).assertSuccess(), { Database: cdk.stringToCloudFormation(properties.database), Host: cdk.stringToCloudFormation(properties.host), Port: cdk.numberToCloudFormation(properties.port) }) : properties;
    }
    function CfnDataSourceTeradataParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("database", "Database", cfn_parse.FromCloudFormation.getString(properties.Database)), ret.addPropertyResult("host", "Host", cfn_parse.FromCloudFormation.getString(properties.Host)), ret.addPropertyResult("port", "Port", cfn_parse.FromCloudFormation.getNumber(properties.Port)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataSource_VpcConnectionPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("vpcConnectionArn", cdk.requiredValidator)(properties.vpcConnectionArn)), errors.collect(cdk.propertyValidator("vpcConnectionArn", cdk.validateString)(properties.vpcConnectionArn)), errors.wrap('supplied properties not correct for "VpcConnectionPropertiesProperty"');
    }
    function cfnDataSourceVpcConnectionPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataSource_VpcConnectionPropertiesPropertyValidator(properties).assertSuccess(), { VpcConnectionArn: cdk.stringToCloudFormation(properties.vpcConnectionArn) }) : properties;
    }
    function CfnDataSourceVpcConnectionPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("vpcConnectionArn", "VpcConnectionArn", cfn_parse.FromCloudFormation.getString(properties.VpcConnectionArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRefreshSchedulePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("awsAccountId", cdk.validateString)(properties.awsAccountId)), errors.collect(cdk.propertyValidator("dataSetId", cdk.validateString)(properties.dataSetId)), errors.collect(cdk.propertyValidator("schedule", CfnRefreshSchedule_RefreshScheduleMapPropertyValidator)(properties.schedule)), errors.wrap('supplied properties not correct for "CfnRefreshScheduleProps"');
    }
    function cfnRefreshSchedulePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRefreshSchedulePropsValidator(properties).assertSuccess(), { AwsAccountId: cdk.stringToCloudFormation(properties.awsAccountId), DataSetId: cdk.stringToCloudFormation(properties.dataSetId), Schedule: cfnRefreshScheduleRefreshScheduleMapPropertyToCloudFormation(properties.schedule) }) : properties;
    }
    function CfnRefreshSchedulePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("awsAccountId", "AwsAccountId", properties.AwsAccountId != null ? cfn_parse.FromCloudFormation.getString(properties.AwsAccountId) : void 0), ret.addPropertyResult("dataSetId", "DataSetId", properties.DataSetId != null ? cfn_parse.FromCloudFormation.getString(properties.DataSetId) : void 0), ret.addPropertyResult("schedule", "Schedule", properties.Schedule != null ? CfnRefreshScheduleRefreshScheduleMapPropertyFromCloudFormation(properties.Schedule) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRefreshSchedule = class _CfnRefreshSchedule extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRefreshSchedulePropsFromCloudFormation(resourceProperties), ret = new _CfnRefreshSchedule(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnRefreshSchedule.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_quicksight_CfnRefreshScheduleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRefreshSchedule), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.awsAccountId = props.awsAccountId, this.dataSetId = props.dataSetId, this.schedule = props.schedule;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRefreshSchedule.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { awsAccountId: this.awsAccountId, dataSetId: this.dataSetId, schedule: this.schedule };
      }
      renderProperties(props) {
        return cfnRefreshSchedulePropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnRefreshSchedule[_e] = { fqn: "aws-cdk-lib.aws_quicksight.CfnRefreshSchedule", version: "2.80.0" }, CfnRefreshSchedule.CFN_RESOURCE_TYPE_NAME = "AWS::QuickSight::RefreshSchedule", exports2.CfnRefreshSchedule = CfnRefreshSchedule;
    function CfnRefreshSchedule_RefreshOnDayPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dayOfMonth", cdk.validateString)(properties.dayOfMonth)), errors.collect(cdk.propertyValidator("dayOfWeek", cdk.validateString)(properties.dayOfWeek)), errors.wrap('supplied properties not correct for "RefreshOnDayProperty"');
    }
    function cfnRefreshScheduleRefreshOnDayPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRefreshSchedule_RefreshOnDayPropertyValidator(properties).assertSuccess(), { DayOfMonth: cdk.stringToCloudFormation(properties.dayOfMonth), DayOfWeek: cdk.stringToCloudFormation(properties.dayOfWeek) }) : properties;
    }
    function CfnRefreshScheduleRefreshOnDayPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dayOfMonth", "DayOfMonth", properties.DayOfMonth != null ? cfn_parse.FromCloudFormation.getString(properties.DayOfMonth) : void 0), ret.addPropertyResult("dayOfWeek", "DayOfWeek", properties.DayOfWeek != null ? cfn_parse.FromCloudFormation.getString(properties.DayOfWeek) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRefreshSchedule_RefreshScheduleMapPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("refreshType", cdk.validateString)(properties.refreshType)), errors.collect(cdk.propertyValidator("scheduleFrequency", CfnRefreshSchedule_ScheduleFrequencyPropertyValidator)(properties.scheduleFrequency)), errors.collect(cdk.propertyValidator("scheduleId", cdk.validateString)(properties.scheduleId)), errors.collect(cdk.propertyValidator("startAfterDateTime", cdk.validateString)(properties.startAfterDateTime)), errors.wrap('supplied properties not correct for "RefreshScheduleMapProperty"');
    }
    function cfnRefreshScheduleRefreshScheduleMapPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRefreshSchedule_RefreshScheduleMapPropertyValidator(properties).assertSuccess(), { RefreshType: cdk.stringToCloudFormation(properties.refreshType), ScheduleFrequency: cfnRefreshScheduleScheduleFrequencyPropertyToCloudFormation(properties.scheduleFrequency), ScheduleId: cdk.stringToCloudFormation(properties.scheduleId), StartAfterDateTime: cdk.stringToCloudFormation(properties.startAfterDateTime) }) : properties;
    }
    function CfnRefreshScheduleRefreshScheduleMapPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("refreshType", "RefreshType", properties.RefreshType != null ? cfn_parse.FromCloudFormation.getString(properties.RefreshType) : void 0), ret.addPropertyResult("scheduleFrequency", "ScheduleFrequency", properties.ScheduleFrequency != null ? CfnRefreshScheduleScheduleFrequencyPropertyFromCloudFormation(properties.ScheduleFrequency) : void 0), ret.addPropertyResult("scheduleId", "ScheduleId", properties.ScheduleId != null ? cfn_parse.FromCloudFormation.getString(properties.ScheduleId) : void 0), ret.addPropertyResult("startAfterDateTime", "StartAfterDateTime", properties.StartAfterDateTime != null ? cfn_parse.FromCloudFormation.getString(properties.StartAfterDateTime) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRefreshSchedule_ScheduleFrequencyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("interval", cdk.validateString)(properties.interval)), errors.collect(cdk.propertyValidator("refreshOnDay", CfnRefreshSchedule_RefreshOnDayPropertyValidator)(properties.refreshOnDay)), errors.collect(cdk.propertyValidator("timeOfTheDay", cdk.validateString)(properties.timeOfTheDay)), errors.collect(cdk.propertyValidator("timeZone", cdk.validateString)(properties.timeZone)), errors.wrap('supplied properties not correct for "ScheduleFrequencyProperty"');
    }
    function cfnRefreshScheduleScheduleFrequencyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRefreshSchedule_ScheduleFrequencyPropertyValidator(properties).assertSuccess(), { Interval: cdk.stringToCloudFormation(properties.interval), RefreshOnDay: cfnRefreshScheduleRefreshOnDayPropertyToCloudFormation(properties.refreshOnDay), TimeOfTheDay: cdk.stringToCloudFormation(properties.timeOfTheDay), TimeZone: cdk.stringToCloudFormation(properties.timeZone) }) : properties;
    }
    function CfnRefreshScheduleScheduleFrequencyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("interval", "Interval", properties.Interval != null ? cfn_parse.FromCloudFormation.getString(properties.Interval) : void 0), ret.addPropertyResult("refreshOnDay", "RefreshOnDay", properties.RefreshOnDay != null ? CfnRefreshScheduleRefreshOnDayPropertyFromCloudFormation(properties.RefreshOnDay) : void 0), ret.addPropertyResult("timeOfTheDay", "TimeOfTheDay", properties.TimeOfTheDay != null ? cfn_parse.FromCloudFormation.getString(properties.TimeOfTheDay) : void 0), ret.addPropertyResult("timeZone", "TimeZone", properties.TimeZone != null ? cfn_parse.FromCloudFormation.getString(properties.TimeZone) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplatePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("awsAccountId", cdk.requiredValidator)(properties.awsAccountId)), errors.collect(cdk.propertyValidator("awsAccountId", cdk.validateString)(properties.awsAccountId)), errors.collect(cdk.propertyValidator("definition", CfnTemplate_TemplateVersionDefinitionPropertyValidator)(properties.definition)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("permissions", cdk.listValidator(CfnTemplate_ResourcePermissionPropertyValidator))(properties.permissions)), errors.collect(cdk.propertyValidator("sourceEntity", CfnTemplate_TemplateSourceEntityPropertyValidator)(properties.sourceEntity)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("templateId", cdk.requiredValidator)(properties.templateId)), errors.collect(cdk.propertyValidator("templateId", cdk.validateString)(properties.templateId)), errors.collect(cdk.propertyValidator("versionDescription", cdk.validateString)(properties.versionDescription)), errors.wrap('supplied properties not correct for "CfnTemplateProps"');
    }
    function cfnTemplatePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplatePropsValidator(properties).assertSuccess(), { AwsAccountId: cdk.stringToCloudFormation(properties.awsAccountId), TemplateId: cdk.stringToCloudFormation(properties.templateId), Definition: cfnTemplateTemplateVersionDefinitionPropertyToCloudFormation(properties.definition), Name: cdk.stringToCloudFormation(properties.name), Permissions: cdk.listMapper(cfnTemplateResourcePermissionPropertyToCloudFormation)(properties.permissions), SourceEntity: cfnTemplateTemplateSourceEntityPropertyToCloudFormation(properties.sourceEntity), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VersionDescription: cdk.stringToCloudFormation(properties.versionDescription) }) : properties;
    }
    function CfnTemplatePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("awsAccountId", "AwsAccountId", cfn_parse.FromCloudFormation.getString(properties.AwsAccountId)), ret.addPropertyResult("templateId", "TemplateId", cfn_parse.FromCloudFormation.getString(properties.TemplateId)), ret.addPropertyResult("definition", "Definition", properties.Definition != null ? CfnTemplateTemplateVersionDefinitionPropertyFromCloudFormation(properties.Definition) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("permissions", "Permissions", properties.Permissions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateResourcePermissionPropertyFromCloudFormation)(properties.Permissions) : void 0), ret.addPropertyResult("sourceEntity", "SourceEntity", properties.SourceEntity != null ? CfnTemplateTemplateSourceEntityPropertyFromCloudFormation(properties.SourceEntity) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("versionDescription", "VersionDescription", properties.VersionDescription != null ? cfn_parse.FromCloudFormation.getString(properties.VersionDescription) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTemplate = class _CfnTemplate extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTemplatePropsFromCloudFormation(resourceProperties), ret = new _CfnTemplate(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTemplate.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_quicksight_CfnTemplateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTemplate), error;
        }
        cdk.requireProperty(props, "awsAccountId", this), cdk.requireProperty(props, "templateId", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreatedTime = cdk.Token.asString(this.getAtt("CreatedTime", cdk.ResolutionTypeHint.STRING)), this.attrLastUpdatedTime = cdk.Token.asString(this.getAtt("LastUpdatedTime", cdk.ResolutionTypeHint.STRING)), this.attrVersionCreatedTime = cdk.Token.asString(this.getAtt("Version.CreatedTime", cdk.ResolutionTypeHint.STRING)), this.attrVersionDataSetConfigurations = this.getAtt("Version.DataSetConfigurations", cdk.ResolutionTypeHint.STRING), this.attrVersionDescription = cdk.Token.asString(this.getAtt("Version.Description", cdk.ResolutionTypeHint.STRING)), this.attrVersionErrors = this.getAtt("Version.Errors", cdk.ResolutionTypeHint.STRING), this.attrVersionSheets = this.getAtt("Version.Sheets", cdk.ResolutionTypeHint.STRING), this.attrVersionSourceEntityArn = cdk.Token.asString(this.getAtt("Version.SourceEntityArn", cdk.ResolutionTypeHint.STRING)), this.attrVersionStatus = cdk.Token.asString(this.getAtt("Version.Status", cdk.ResolutionTypeHint.STRING)), this.attrVersionThemeArn = cdk.Token.asString(this.getAtt("Version.ThemeArn", cdk.ResolutionTypeHint.STRING)), this.attrVersionVersionNumber = this.getAtt("Version.VersionNumber", cdk.ResolutionTypeHint.STRING), this.awsAccountId = props.awsAccountId, this.templateId = props.templateId, this.definition = props.definition, this.name = props.name, this.permissions = props.permissions, this.sourceEntity = props.sourceEntity, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::QuickSight::Template", props.tags, { tagPropertyName: "tags" }), this.versionDescription = props.versionDescription;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTemplate.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { awsAccountId: this.awsAccountId, templateId: this.templateId, definition: this.definition, name: this.name, permissions: this.permissions, sourceEntity: this.sourceEntity, tags: this.tags.renderTags(), versionDescription: this.versionDescription };
      }
      renderProperties(props) {
        return cfnTemplatePropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnTemplate[_f] = { fqn: "aws-cdk-lib.aws_quicksight.CfnTemplate", version: "2.80.0" }, CfnTemplate.CFN_RESOURCE_TYPE_NAME = "AWS::QuickSight::Template", exports2.CfnTemplate = CfnTemplate;
    function CfnTemplate_AggregationFunctionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoricalAggregationFunction", cdk.validateString)(properties.categoricalAggregationFunction)), errors.collect(cdk.propertyValidator("dateAggregationFunction", cdk.validateString)(properties.dateAggregationFunction)), errors.collect(cdk.propertyValidator("numericalAggregationFunction", CfnTemplate_NumericalAggregationFunctionPropertyValidator)(properties.numericalAggregationFunction)), errors.wrap('supplied properties not correct for "AggregationFunctionProperty"');
    }
    function cfnTemplateAggregationFunctionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_AggregationFunctionPropertyValidator(properties).assertSuccess(), { CategoricalAggregationFunction: cdk.stringToCloudFormation(properties.categoricalAggregationFunction), DateAggregationFunction: cdk.stringToCloudFormation(properties.dateAggregationFunction), NumericalAggregationFunction: cfnTemplateNumericalAggregationFunctionPropertyToCloudFormation(properties.numericalAggregationFunction) }) : properties;
    }
    function CfnTemplateAggregationFunctionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoricalAggregationFunction", "CategoricalAggregationFunction", properties.CategoricalAggregationFunction != null ? cfn_parse.FromCloudFormation.getString(properties.CategoricalAggregationFunction) : void 0), ret.addPropertyResult("dateAggregationFunction", "DateAggregationFunction", properties.DateAggregationFunction != null ? cfn_parse.FromCloudFormation.getString(properties.DateAggregationFunction) : void 0), ret.addPropertyResult("numericalAggregationFunction", "NumericalAggregationFunction", properties.NumericalAggregationFunction != null ? CfnTemplateNumericalAggregationFunctionPropertyFromCloudFormation(properties.NumericalAggregationFunction) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_AggregationSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationFunction", cdk.requiredValidator)(properties.aggregationFunction)), errors.collect(cdk.propertyValidator("aggregationFunction", CfnTemplate_AggregationFunctionPropertyValidator)(properties.aggregationFunction)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnTemplate_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("sortDirection", cdk.requiredValidator)(properties.sortDirection)), errors.collect(cdk.propertyValidator("sortDirection", cdk.validateString)(properties.sortDirection)), errors.wrap('supplied properties not correct for "AggregationSortConfigurationProperty"');
    }
    function cfnTemplateAggregationSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_AggregationSortConfigurationPropertyValidator(properties).assertSuccess(), { AggregationFunction: cfnTemplateAggregationFunctionPropertyToCloudFormation(properties.aggregationFunction), Column: cfnTemplateColumnIdentifierPropertyToCloudFormation(properties.column), SortDirection: cdk.stringToCloudFormation(properties.sortDirection) }) : properties;
    }
    function CfnTemplateAggregationSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationFunction", "AggregationFunction", CfnTemplateAggregationFunctionPropertyFromCloudFormation(properties.AggregationFunction)), ret.addPropertyResult("column", "Column", CfnTemplateColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("sortDirection", "SortDirection", cfn_parse.FromCloudFormation.getString(properties.SortDirection)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_AnalysisDefaultsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultNewSheetConfiguration", cdk.requiredValidator)(properties.defaultNewSheetConfiguration)), errors.collect(cdk.propertyValidator("defaultNewSheetConfiguration", CfnTemplate_DefaultNewSheetConfigurationPropertyValidator)(properties.defaultNewSheetConfiguration)), errors.wrap('supplied properties not correct for "AnalysisDefaultsProperty"');
    }
    function cfnTemplateAnalysisDefaultsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_AnalysisDefaultsPropertyValidator(properties).assertSuccess(), { DefaultNewSheetConfiguration: cfnTemplateDefaultNewSheetConfigurationPropertyToCloudFormation(properties.defaultNewSheetConfiguration) }) : properties;
    }
    function CfnTemplateAnalysisDefaultsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultNewSheetConfiguration", "DefaultNewSheetConfiguration", CfnTemplateDefaultNewSheetConfigurationPropertyFromCloudFormation(properties.DefaultNewSheetConfiguration)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_AnchorDateConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("anchorOption", cdk.validateString)(properties.anchorOption)), errors.collect(cdk.propertyValidator("parameterName", cdk.validateString)(properties.parameterName)), errors.wrap('supplied properties not correct for "AnchorDateConfigurationProperty"');
    }
    function cfnTemplateAnchorDateConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_AnchorDateConfigurationPropertyValidator(properties).assertSuccess(), { AnchorOption: cdk.stringToCloudFormation(properties.anchorOption), ParameterName: cdk.stringToCloudFormation(properties.parameterName) }) : properties;
    }
    function CfnTemplateAnchorDateConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("anchorOption", "AnchorOption", properties.AnchorOption != null ? cfn_parse.FromCloudFormation.getString(properties.AnchorOption) : void 0), ret.addPropertyResult("parameterName", "ParameterName", properties.ParameterName != null ? cfn_parse.FromCloudFormation.getString(properties.ParameterName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ArcAxisConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("range", CfnTemplate_ArcAxisDisplayRangePropertyValidator)(properties.range)), errors.collect(cdk.propertyValidator("reserveRange", cdk.validateNumber)(properties.reserveRange)), errors.wrap('supplied properties not correct for "ArcAxisConfigurationProperty"');
    }
    function cfnTemplateArcAxisConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ArcAxisConfigurationPropertyValidator(properties).assertSuccess(), { Range: cfnTemplateArcAxisDisplayRangePropertyToCloudFormation(properties.range), ReserveRange: cdk.numberToCloudFormation(properties.reserveRange) }) : properties;
    }
    function CfnTemplateArcAxisConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("range", "Range", properties.Range != null ? CfnTemplateArcAxisDisplayRangePropertyFromCloudFormation(properties.Range) : void 0), ret.addPropertyResult("reserveRange", "ReserveRange", properties.ReserveRange != null ? cfn_parse.FromCloudFormation.getNumber(properties.ReserveRange) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ArcAxisDisplayRangePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("max", cdk.validateNumber)(properties.max)), errors.collect(cdk.propertyValidator("min", cdk.validateNumber)(properties.min)), errors.wrap('supplied properties not correct for "ArcAxisDisplayRangeProperty"');
    }
    function cfnTemplateArcAxisDisplayRangePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ArcAxisDisplayRangePropertyValidator(properties).assertSuccess(), { Max: cdk.numberToCloudFormation(properties.max), Min: cdk.numberToCloudFormation(properties.min) }) : properties;
    }
    function CfnTemplateArcAxisDisplayRangePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("max", "Max", properties.Max != null ? cfn_parse.FromCloudFormation.getNumber(properties.Max) : void 0), ret.addPropertyResult("min", "Min", properties.Min != null ? cfn_parse.FromCloudFormation.getNumber(properties.Min) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ArcConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arcAngle", cdk.validateNumber)(properties.arcAngle)), errors.collect(cdk.propertyValidator("arcThickness", cdk.validateString)(properties.arcThickness)), errors.wrap('supplied properties not correct for "ArcConfigurationProperty"');
    }
    function cfnTemplateArcConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ArcConfigurationPropertyValidator(properties).assertSuccess(), { ArcAngle: cdk.numberToCloudFormation(properties.arcAngle), ArcThickness: cdk.stringToCloudFormation(properties.arcThickness) }) : properties;
    }
    function CfnTemplateArcConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arcAngle", "ArcAngle", properties.ArcAngle != null ? cfn_parse.FromCloudFormation.getNumber(properties.ArcAngle) : void 0), ret.addPropertyResult("arcThickness", "ArcThickness", properties.ArcThickness != null ? cfn_parse.FromCloudFormation.getString(properties.ArcThickness) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ArcOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arcThickness", cdk.validateString)(properties.arcThickness)), errors.wrap('supplied properties not correct for "ArcOptionsProperty"');
    }
    function cfnTemplateArcOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ArcOptionsPropertyValidator(properties).assertSuccess(), { ArcThickness: cdk.stringToCloudFormation(properties.arcThickness) }) : properties;
    }
    function CfnTemplateArcOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arcThickness", "ArcThickness", properties.ArcThickness != null ? cfn_parse.FromCloudFormation.getString(properties.ArcThickness) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_AxisDataOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateAxisOptions", CfnTemplate_DateAxisOptionsPropertyValidator)(properties.dateAxisOptions)), errors.collect(cdk.propertyValidator("numericAxisOptions", CfnTemplate_NumericAxisOptionsPropertyValidator)(properties.numericAxisOptions)), errors.wrap('supplied properties not correct for "AxisDataOptionsProperty"');
    }
    function cfnTemplateAxisDataOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_AxisDataOptionsPropertyValidator(properties).assertSuccess(), { DateAxisOptions: cfnTemplateDateAxisOptionsPropertyToCloudFormation(properties.dateAxisOptions), NumericAxisOptions: cfnTemplateNumericAxisOptionsPropertyToCloudFormation(properties.numericAxisOptions) }) : properties;
    }
    function CfnTemplateAxisDataOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateAxisOptions", "DateAxisOptions", properties.DateAxisOptions != null ? CfnTemplateDateAxisOptionsPropertyFromCloudFormation(properties.DateAxisOptions) : void 0), ret.addPropertyResult("numericAxisOptions", "NumericAxisOptions", properties.NumericAxisOptions != null ? CfnTemplateNumericAxisOptionsPropertyFromCloudFormation(properties.NumericAxisOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_AxisDisplayMinMaxRangePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maximum", cdk.validateNumber)(properties.maximum)), errors.collect(cdk.propertyValidator("minimum", cdk.validateNumber)(properties.minimum)), errors.wrap('supplied properties not correct for "AxisDisplayMinMaxRangeProperty"');
    }
    function cfnTemplateAxisDisplayMinMaxRangePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_AxisDisplayMinMaxRangePropertyValidator(properties).assertSuccess(), { Maximum: cdk.numberToCloudFormation(properties.maximum), Minimum: cdk.numberToCloudFormation(properties.minimum) }) : properties;
    }
    function CfnTemplateAxisDisplayMinMaxRangePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maximum", "Maximum", properties.Maximum != null ? cfn_parse.FromCloudFormation.getNumber(properties.Maximum) : void 0), ret.addPropertyResult("minimum", "Minimum", properties.Minimum != null ? cfn_parse.FromCloudFormation.getNumber(properties.Minimum) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_AxisDisplayOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("axisLineVisibility", cdk.validateString)(properties.axisLineVisibility)), errors.collect(cdk.propertyValidator("axisOffset", cdk.validateString)(properties.axisOffset)), errors.collect(cdk.propertyValidator("dataOptions", CfnTemplate_AxisDataOptionsPropertyValidator)(properties.dataOptions)), errors.collect(cdk.propertyValidator("gridLineVisibility", cdk.validateString)(properties.gridLineVisibility)), errors.collect(cdk.propertyValidator("scrollbarOptions", CfnTemplate_ScrollBarOptionsPropertyValidator)(properties.scrollbarOptions)), errors.collect(cdk.propertyValidator("tickLabelOptions", CfnTemplate_AxisTickLabelOptionsPropertyValidator)(properties.tickLabelOptions)), errors.wrap('supplied properties not correct for "AxisDisplayOptionsProperty"');
    }
    function cfnTemplateAxisDisplayOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_AxisDisplayOptionsPropertyValidator(properties).assertSuccess(), { AxisLineVisibility: cdk.stringToCloudFormation(properties.axisLineVisibility), AxisOffset: cdk.stringToCloudFormation(properties.axisOffset), DataOptions: cfnTemplateAxisDataOptionsPropertyToCloudFormation(properties.dataOptions), GridLineVisibility: cdk.stringToCloudFormation(properties.gridLineVisibility), ScrollbarOptions: cfnTemplateScrollBarOptionsPropertyToCloudFormation(properties.scrollbarOptions), TickLabelOptions: cfnTemplateAxisTickLabelOptionsPropertyToCloudFormation(properties.tickLabelOptions) }) : properties;
    }
    function CfnTemplateAxisDisplayOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("axisLineVisibility", "AxisLineVisibility", properties.AxisLineVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.AxisLineVisibility) : void 0), ret.addPropertyResult("axisOffset", "AxisOffset", properties.AxisOffset != null ? cfn_parse.FromCloudFormation.getString(properties.AxisOffset) : void 0), ret.addPropertyResult("dataOptions", "DataOptions", properties.DataOptions != null ? CfnTemplateAxisDataOptionsPropertyFromCloudFormation(properties.DataOptions) : void 0), ret.addPropertyResult("gridLineVisibility", "GridLineVisibility", properties.GridLineVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.GridLineVisibility) : void 0), ret.addPropertyResult("scrollbarOptions", "ScrollbarOptions", properties.ScrollbarOptions != null ? CfnTemplateScrollBarOptionsPropertyFromCloudFormation(properties.ScrollbarOptions) : void 0), ret.addPropertyResult("tickLabelOptions", "TickLabelOptions", properties.TickLabelOptions != null ? CfnTemplateAxisTickLabelOptionsPropertyFromCloudFormation(properties.TickLabelOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_AxisDisplayRangePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataDriven", cdk.validateObject)(properties.dataDriven)), errors.collect(cdk.propertyValidator("minMax", CfnTemplate_AxisDisplayMinMaxRangePropertyValidator)(properties.minMax)), errors.wrap('supplied properties not correct for "AxisDisplayRangeProperty"');
    }
    function cfnTemplateAxisDisplayRangePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_AxisDisplayRangePropertyValidator(properties).assertSuccess(), { DataDriven: cdk.objectToCloudFormation(properties.dataDriven), MinMax: cfnTemplateAxisDisplayMinMaxRangePropertyToCloudFormation(properties.minMax) }) : properties;
    }
    function CfnTemplateAxisDisplayRangePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataDriven", "DataDriven", properties.DataDriven != null ? cfn_parse.FromCloudFormation.getAny(properties.DataDriven) : void 0), ret.addPropertyResult("minMax", "MinMax", properties.MinMax != null ? CfnTemplateAxisDisplayMinMaxRangePropertyFromCloudFormation(properties.MinMax) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_AxisLabelOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applyTo", CfnTemplate_AxisLabelReferenceOptionsPropertyValidator)(properties.applyTo)), errors.collect(cdk.propertyValidator("customLabel", cdk.validateString)(properties.customLabel)), errors.collect(cdk.propertyValidator("fontConfiguration", CfnTemplate_FontConfigurationPropertyValidator)(properties.fontConfiguration)), errors.wrap('supplied properties not correct for "AxisLabelOptionsProperty"');
    }
    function cfnTemplateAxisLabelOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_AxisLabelOptionsPropertyValidator(properties).assertSuccess(), { ApplyTo: cfnTemplateAxisLabelReferenceOptionsPropertyToCloudFormation(properties.applyTo), CustomLabel: cdk.stringToCloudFormation(properties.customLabel), FontConfiguration: cfnTemplateFontConfigurationPropertyToCloudFormation(properties.fontConfiguration) }) : properties;
    }
    function CfnTemplateAxisLabelOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applyTo", "ApplyTo", properties.ApplyTo != null ? CfnTemplateAxisLabelReferenceOptionsPropertyFromCloudFormation(properties.ApplyTo) : void 0), ret.addPropertyResult("customLabel", "CustomLabel", properties.CustomLabel != null ? cfn_parse.FromCloudFormation.getString(properties.CustomLabel) : void 0), ret.addPropertyResult("fontConfiguration", "FontConfiguration", properties.FontConfiguration != null ? CfnTemplateFontConfigurationPropertyFromCloudFormation(properties.FontConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_AxisLabelReferenceOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnTemplate_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.wrap('supplied properties not correct for "AxisLabelReferenceOptionsProperty"');
    }
    function cfnTemplateAxisLabelReferenceOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_AxisLabelReferenceOptionsPropertyValidator(properties).assertSuccess(), { Column: cfnTemplateColumnIdentifierPropertyToCloudFormation(properties.column), FieldId: cdk.stringToCloudFormation(properties.fieldId) }) : properties;
    }
    function CfnTemplateAxisLabelReferenceOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", CfnTemplateColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_AxisLinearScalePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("stepCount", cdk.validateNumber)(properties.stepCount)), errors.collect(cdk.propertyValidator("stepSize", cdk.validateNumber)(properties.stepSize)), errors.wrap('supplied properties not correct for "AxisLinearScaleProperty"');
    }
    function cfnTemplateAxisLinearScalePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_AxisLinearScalePropertyValidator(properties).assertSuccess(), { StepCount: cdk.numberToCloudFormation(properties.stepCount), StepSize: cdk.numberToCloudFormation(properties.stepSize) }) : properties;
    }
    function CfnTemplateAxisLinearScalePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("stepCount", "StepCount", properties.StepCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.StepCount) : void 0), ret.addPropertyResult("stepSize", "StepSize", properties.StepSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.StepSize) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_AxisLogarithmicScalePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("base", cdk.validateNumber)(properties.base)), errors.wrap('supplied properties not correct for "AxisLogarithmicScaleProperty"');
    }
    function cfnTemplateAxisLogarithmicScalePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_AxisLogarithmicScalePropertyValidator(properties).assertSuccess(), { Base: cdk.numberToCloudFormation(properties.base) }) : properties;
    }
    function CfnTemplateAxisLogarithmicScalePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("base", "Base", properties.Base != null ? cfn_parse.FromCloudFormation.getNumber(properties.Base) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_AxisScalePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("linear", CfnTemplate_AxisLinearScalePropertyValidator)(properties.linear)), errors.collect(cdk.propertyValidator("logarithmic", CfnTemplate_AxisLogarithmicScalePropertyValidator)(properties.logarithmic)), errors.wrap('supplied properties not correct for "AxisScaleProperty"');
    }
    function cfnTemplateAxisScalePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_AxisScalePropertyValidator(properties).assertSuccess(), { Linear: cfnTemplateAxisLinearScalePropertyToCloudFormation(properties.linear), Logarithmic: cfnTemplateAxisLogarithmicScalePropertyToCloudFormation(properties.logarithmic) }) : properties;
    }
    function CfnTemplateAxisScalePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("linear", "Linear", properties.Linear != null ? CfnTemplateAxisLinearScalePropertyFromCloudFormation(properties.Linear) : void 0), ret.addPropertyResult("logarithmic", "Logarithmic", properties.Logarithmic != null ? CfnTemplateAxisLogarithmicScalePropertyFromCloudFormation(properties.Logarithmic) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_AxisTickLabelOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("labelOptions", CfnTemplate_LabelOptionsPropertyValidator)(properties.labelOptions)), errors.collect(cdk.propertyValidator("rotationAngle", cdk.validateNumber)(properties.rotationAngle)), errors.wrap('supplied properties not correct for "AxisTickLabelOptionsProperty"');
    }
    function cfnTemplateAxisTickLabelOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_AxisTickLabelOptionsPropertyValidator(properties).assertSuccess(), { LabelOptions: cfnTemplateLabelOptionsPropertyToCloudFormation(properties.labelOptions), RotationAngle: cdk.numberToCloudFormation(properties.rotationAngle) }) : properties;
    }
    function CfnTemplateAxisTickLabelOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("labelOptions", "LabelOptions", properties.LabelOptions != null ? CfnTemplateLabelOptionsPropertyFromCloudFormation(properties.LabelOptions) : void 0), ret.addPropertyResult("rotationAngle", "RotationAngle", properties.RotationAngle != null ? cfn_parse.FromCloudFormation.getNumber(properties.RotationAngle) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_BarChartAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("category", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.category)), errors.collect(cdk.propertyValidator("colors", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.colors)), errors.collect(cdk.propertyValidator("smallMultiples", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.smallMultiples)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnTemplate_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "BarChartAggregatedFieldWellsProperty"');
    }
    function cfnTemplateBarChartAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_BarChartAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Category: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.category), Colors: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.colors), SmallMultiples: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.smallMultiples), Values: cdk.listMapper(cfnTemplateMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnTemplateBarChartAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("category", "Category", properties.Category != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.Category) : void 0), ret.addPropertyResult("colors", "Colors", properties.Colors != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.Colors) : void 0), ret.addPropertyResult("smallMultiples", "SmallMultiples", properties.SmallMultiples != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.SmallMultiples) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_BarChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("barsArrangement", cdk.validateString)(properties.barsArrangement)), errors.collect(cdk.propertyValidator("categoryAxis", CfnTemplate_AxisDisplayOptionsPropertyValidator)(properties.categoryAxis)), errors.collect(cdk.propertyValidator("categoryLabelOptions", CfnTemplate_ChartAxisLabelOptionsPropertyValidator)(properties.categoryLabelOptions)), errors.collect(cdk.propertyValidator("colorLabelOptions", CfnTemplate_ChartAxisLabelOptionsPropertyValidator)(properties.colorLabelOptions)), errors.collect(cdk.propertyValidator("contributionAnalysisDefaults", cdk.listValidator(CfnTemplate_ContributionAnalysisDefaultPropertyValidator))(properties.contributionAnalysisDefaults)), errors.collect(cdk.propertyValidator("dataLabels", CfnTemplate_DataLabelOptionsPropertyValidator)(properties.dataLabels)), errors.collect(cdk.propertyValidator("fieldWells", CfnTemplate_BarChartFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("legend", CfnTemplate_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("orientation", cdk.validateString)(properties.orientation)), errors.collect(cdk.propertyValidator("referenceLines", cdk.listValidator(CfnTemplate_ReferenceLinePropertyValidator))(properties.referenceLines)), errors.collect(cdk.propertyValidator("smallMultiplesOptions", CfnTemplate_SmallMultiplesOptionsPropertyValidator)(properties.smallMultiplesOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnTemplate_BarChartSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tooltip", CfnTemplate_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.collect(cdk.propertyValidator("valueAxis", CfnTemplate_AxisDisplayOptionsPropertyValidator)(properties.valueAxis)), errors.collect(cdk.propertyValidator("valueLabelOptions", CfnTemplate_ChartAxisLabelOptionsPropertyValidator)(properties.valueLabelOptions)), errors.collect(cdk.propertyValidator("visualPalette", CfnTemplate_VisualPalettePropertyValidator)(properties.visualPalette)), errors.wrap('supplied properties not correct for "BarChartConfigurationProperty"');
    }
    function cfnTemplateBarChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_BarChartConfigurationPropertyValidator(properties).assertSuccess(), { BarsArrangement: cdk.stringToCloudFormation(properties.barsArrangement), CategoryAxis: cfnTemplateAxisDisplayOptionsPropertyToCloudFormation(properties.categoryAxis), CategoryLabelOptions: cfnTemplateChartAxisLabelOptionsPropertyToCloudFormation(properties.categoryLabelOptions), ColorLabelOptions: cfnTemplateChartAxisLabelOptionsPropertyToCloudFormation(properties.colorLabelOptions), ContributionAnalysisDefaults: cdk.listMapper(cfnTemplateContributionAnalysisDefaultPropertyToCloudFormation)(properties.contributionAnalysisDefaults), DataLabels: cfnTemplateDataLabelOptionsPropertyToCloudFormation(properties.dataLabels), FieldWells: cfnTemplateBarChartFieldWellsPropertyToCloudFormation(properties.fieldWells), Legend: cfnTemplateLegendOptionsPropertyToCloudFormation(properties.legend), Orientation: cdk.stringToCloudFormation(properties.orientation), ReferenceLines: cdk.listMapper(cfnTemplateReferenceLinePropertyToCloudFormation)(properties.referenceLines), SmallMultiplesOptions: cfnTemplateSmallMultiplesOptionsPropertyToCloudFormation(properties.smallMultiplesOptions), SortConfiguration: cfnTemplateBarChartSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), Tooltip: cfnTemplateTooltipOptionsPropertyToCloudFormation(properties.tooltip), ValueAxis: cfnTemplateAxisDisplayOptionsPropertyToCloudFormation(properties.valueAxis), ValueLabelOptions: cfnTemplateChartAxisLabelOptionsPropertyToCloudFormation(properties.valueLabelOptions), VisualPalette: cfnTemplateVisualPalettePropertyToCloudFormation(properties.visualPalette) }) : properties;
    }
    function CfnTemplateBarChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("barsArrangement", "BarsArrangement", properties.BarsArrangement != null ? cfn_parse.FromCloudFormation.getString(properties.BarsArrangement) : void 0), ret.addPropertyResult("categoryAxis", "CategoryAxis", properties.CategoryAxis != null ? CfnTemplateAxisDisplayOptionsPropertyFromCloudFormation(properties.CategoryAxis) : void 0), ret.addPropertyResult("categoryLabelOptions", "CategoryLabelOptions", properties.CategoryLabelOptions != null ? CfnTemplateChartAxisLabelOptionsPropertyFromCloudFormation(properties.CategoryLabelOptions) : void 0), ret.addPropertyResult("colorLabelOptions", "ColorLabelOptions", properties.ColorLabelOptions != null ? CfnTemplateChartAxisLabelOptionsPropertyFromCloudFormation(properties.ColorLabelOptions) : void 0), ret.addPropertyResult("contributionAnalysisDefaults", "ContributionAnalysisDefaults", properties.ContributionAnalysisDefaults != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateContributionAnalysisDefaultPropertyFromCloudFormation)(properties.ContributionAnalysisDefaults) : void 0), ret.addPropertyResult("dataLabels", "DataLabels", properties.DataLabels != null ? CfnTemplateDataLabelOptionsPropertyFromCloudFormation(properties.DataLabels) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnTemplateBarChartFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnTemplateLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("orientation", "Orientation", properties.Orientation != null ? cfn_parse.FromCloudFormation.getString(properties.Orientation) : void 0), ret.addPropertyResult("referenceLines", "ReferenceLines", properties.ReferenceLines != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateReferenceLinePropertyFromCloudFormation)(properties.ReferenceLines) : void 0), ret.addPropertyResult("smallMultiplesOptions", "SmallMultiplesOptions", properties.SmallMultiplesOptions != null ? CfnTemplateSmallMultiplesOptionsPropertyFromCloudFormation(properties.SmallMultiplesOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnTemplateBarChartSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnTemplateTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addPropertyResult("valueAxis", "ValueAxis", properties.ValueAxis != null ? CfnTemplateAxisDisplayOptionsPropertyFromCloudFormation(properties.ValueAxis) : void 0), ret.addPropertyResult("valueLabelOptions", "ValueLabelOptions", properties.ValueLabelOptions != null ? CfnTemplateChartAxisLabelOptionsPropertyFromCloudFormation(properties.ValueLabelOptions) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnTemplateVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_BarChartFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("barChartAggregatedFieldWells", CfnTemplate_BarChartAggregatedFieldWellsPropertyValidator)(properties.barChartAggregatedFieldWells)), errors.wrap('supplied properties not correct for "BarChartFieldWellsProperty"');
    }
    function cfnTemplateBarChartFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_BarChartFieldWellsPropertyValidator(properties).assertSuccess(), { BarChartAggregatedFieldWells: cfnTemplateBarChartAggregatedFieldWellsPropertyToCloudFormation(properties.barChartAggregatedFieldWells) }) : properties;
    }
    function CfnTemplateBarChartFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("barChartAggregatedFieldWells", "BarChartAggregatedFieldWells", properties.BarChartAggregatedFieldWells != null ? CfnTemplateBarChartAggregatedFieldWellsPropertyFromCloudFormation(properties.BarChartAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_BarChartSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryItemsLimit", CfnTemplate_ItemsLimitConfigurationPropertyValidator)(properties.categoryItemsLimit)), errors.collect(cdk.propertyValidator("categorySort", cdk.listValidator(CfnTemplate_FieldSortOptionsPropertyValidator))(properties.categorySort)), errors.collect(cdk.propertyValidator("colorItemsLimit", CfnTemplate_ItemsLimitConfigurationPropertyValidator)(properties.colorItemsLimit)), errors.collect(cdk.propertyValidator("colorSort", cdk.listValidator(CfnTemplate_FieldSortOptionsPropertyValidator))(properties.colorSort)), errors.collect(cdk.propertyValidator("smallMultiplesLimitConfiguration", CfnTemplate_ItemsLimitConfigurationPropertyValidator)(properties.smallMultiplesLimitConfiguration)), errors.collect(cdk.propertyValidator("smallMultiplesSort", cdk.listValidator(CfnTemplate_FieldSortOptionsPropertyValidator))(properties.smallMultiplesSort)), errors.wrap('supplied properties not correct for "BarChartSortConfigurationProperty"');
    }
    function cfnTemplateBarChartSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_BarChartSortConfigurationPropertyValidator(properties).assertSuccess(), { CategoryItemsLimit: cfnTemplateItemsLimitConfigurationPropertyToCloudFormation(properties.categoryItemsLimit), CategorySort: cdk.listMapper(cfnTemplateFieldSortOptionsPropertyToCloudFormation)(properties.categorySort), ColorItemsLimit: cfnTemplateItemsLimitConfigurationPropertyToCloudFormation(properties.colorItemsLimit), ColorSort: cdk.listMapper(cfnTemplateFieldSortOptionsPropertyToCloudFormation)(properties.colorSort), SmallMultiplesLimitConfiguration: cfnTemplateItemsLimitConfigurationPropertyToCloudFormation(properties.smallMultiplesLimitConfiguration), SmallMultiplesSort: cdk.listMapper(cfnTemplateFieldSortOptionsPropertyToCloudFormation)(properties.smallMultiplesSort) }) : properties;
    }
    function CfnTemplateBarChartSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryItemsLimit", "CategoryItemsLimit", properties.CategoryItemsLimit != null ? CfnTemplateItemsLimitConfigurationPropertyFromCloudFormation(properties.CategoryItemsLimit) : void 0), ret.addPropertyResult("categorySort", "CategorySort", properties.CategorySort != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateFieldSortOptionsPropertyFromCloudFormation)(properties.CategorySort) : void 0), ret.addPropertyResult("colorItemsLimit", "ColorItemsLimit", properties.ColorItemsLimit != null ? CfnTemplateItemsLimitConfigurationPropertyFromCloudFormation(properties.ColorItemsLimit) : void 0), ret.addPropertyResult("colorSort", "ColorSort", properties.ColorSort != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateFieldSortOptionsPropertyFromCloudFormation)(properties.ColorSort) : void 0), ret.addPropertyResult("smallMultiplesLimitConfiguration", "SmallMultiplesLimitConfiguration", properties.SmallMultiplesLimitConfiguration != null ? CfnTemplateItemsLimitConfigurationPropertyFromCloudFormation(properties.SmallMultiplesLimitConfiguration) : void 0), ret.addPropertyResult("smallMultiplesSort", "SmallMultiplesSort", properties.SmallMultiplesSort != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateFieldSortOptionsPropertyFromCloudFormation)(properties.SmallMultiplesSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_BarChartVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnTemplate_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnTemplate_BarChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnTemplate_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnTemplate_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnTemplate_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "BarChartVisualProperty"');
    }
    function cfnTemplateBarChartVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_BarChartVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnTemplateVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnTemplateBarChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnTemplateColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnTemplateVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnTemplateVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnTemplateBarChartVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnTemplateBarChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnTemplateVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnTemplateVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_BinCountOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "BinCountOptionsProperty"');
    }
    function cfnTemplateBinCountOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_BinCountOptionsPropertyValidator(properties).assertSuccess(), { Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnTemplateBinCountOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getNumber(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_BinWidthOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("binCountLimit", cdk.validateNumber)(properties.binCountLimit)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "BinWidthOptionsProperty"');
    }
    function cfnTemplateBinWidthOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_BinWidthOptionsPropertyValidator(properties).assertSuccess(), { BinCountLimit: cdk.numberToCloudFormation(properties.binCountLimit), Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnTemplateBinWidthOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("binCountLimit", "BinCountLimit", properties.BinCountLimit != null ? cfn_parse.FromCloudFormation.getNumber(properties.BinCountLimit) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getNumber(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_BodySectionConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("content", cdk.requiredValidator)(properties.content)), errors.collect(cdk.propertyValidator("content", CfnTemplate_BodySectionContentPropertyValidator)(properties.content)), errors.collect(cdk.propertyValidator("pageBreakConfiguration", CfnTemplate_SectionPageBreakConfigurationPropertyValidator)(properties.pageBreakConfiguration)), errors.collect(cdk.propertyValidator("sectionId", cdk.requiredValidator)(properties.sectionId)), errors.collect(cdk.propertyValidator("sectionId", cdk.validateString)(properties.sectionId)), errors.collect(cdk.propertyValidator("style", CfnTemplate_SectionStylePropertyValidator)(properties.style)), errors.wrap('supplied properties not correct for "BodySectionConfigurationProperty"');
    }
    function cfnTemplateBodySectionConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_BodySectionConfigurationPropertyValidator(properties).assertSuccess(), { Content: cfnTemplateBodySectionContentPropertyToCloudFormation(properties.content), PageBreakConfiguration: cfnTemplateSectionPageBreakConfigurationPropertyToCloudFormation(properties.pageBreakConfiguration), SectionId: cdk.stringToCloudFormation(properties.sectionId), Style: cfnTemplateSectionStylePropertyToCloudFormation(properties.style) }) : properties;
    }
    function CfnTemplateBodySectionConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("content", "Content", CfnTemplateBodySectionContentPropertyFromCloudFormation(properties.Content)), ret.addPropertyResult("pageBreakConfiguration", "PageBreakConfiguration", properties.PageBreakConfiguration != null ? CfnTemplateSectionPageBreakConfigurationPropertyFromCloudFormation(properties.PageBreakConfiguration) : void 0), ret.addPropertyResult("sectionId", "SectionId", cfn_parse.FromCloudFormation.getString(properties.SectionId)), ret.addPropertyResult("style", "Style", properties.Style != null ? CfnTemplateSectionStylePropertyFromCloudFormation(properties.Style) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_BodySectionContentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("layout", CfnTemplate_SectionLayoutConfigurationPropertyValidator)(properties.layout)), errors.wrap('supplied properties not correct for "BodySectionContentProperty"');
    }
    function cfnTemplateBodySectionContentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_BodySectionContentPropertyValidator(properties).assertSuccess(), { Layout: cfnTemplateSectionLayoutConfigurationPropertyToCloudFormation(properties.layout) }) : properties;
    }
    function CfnTemplateBodySectionContentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("layout", "Layout", properties.Layout != null ? CfnTemplateSectionLayoutConfigurationPropertyFromCloudFormation(properties.Layout) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_BoxPlotAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groupBy", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.groupBy)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnTemplate_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "BoxPlotAggregatedFieldWellsProperty"');
    }
    function cfnTemplateBoxPlotAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_BoxPlotAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { GroupBy: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.groupBy), Values: cdk.listMapper(cfnTemplateMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnTemplateBoxPlotAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupBy", "GroupBy", properties.GroupBy != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.GroupBy) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_BoxPlotChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("boxPlotOptions", CfnTemplate_BoxPlotOptionsPropertyValidator)(properties.boxPlotOptions)), errors.collect(cdk.propertyValidator("categoryAxis", CfnTemplate_AxisDisplayOptionsPropertyValidator)(properties.categoryAxis)), errors.collect(cdk.propertyValidator("categoryLabelOptions", CfnTemplate_ChartAxisLabelOptionsPropertyValidator)(properties.categoryLabelOptions)), errors.collect(cdk.propertyValidator("fieldWells", CfnTemplate_BoxPlotFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("legend", CfnTemplate_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("primaryYAxisDisplayOptions", CfnTemplate_AxisDisplayOptionsPropertyValidator)(properties.primaryYAxisDisplayOptions)), errors.collect(cdk.propertyValidator("primaryYAxisLabelOptions", CfnTemplate_ChartAxisLabelOptionsPropertyValidator)(properties.primaryYAxisLabelOptions)), errors.collect(cdk.propertyValidator("referenceLines", cdk.listValidator(CfnTemplate_ReferenceLinePropertyValidator))(properties.referenceLines)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnTemplate_BoxPlotSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tooltip", CfnTemplate_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.collect(cdk.propertyValidator("visualPalette", CfnTemplate_VisualPalettePropertyValidator)(properties.visualPalette)), errors.wrap('supplied properties not correct for "BoxPlotChartConfigurationProperty"');
    }
    function cfnTemplateBoxPlotChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_BoxPlotChartConfigurationPropertyValidator(properties).assertSuccess(), { BoxPlotOptions: cfnTemplateBoxPlotOptionsPropertyToCloudFormation(properties.boxPlotOptions), CategoryAxis: cfnTemplateAxisDisplayOptionsPropertyToCloudFormation(properties.categoryAxis), CategoryLabelOptions: cfnTemplateChartAxisLabelOptionsPropertyToCloudFormation(properties.categoryLabelOptions), FieldWells: cfnTemplateBoxPlotFieldWellsPropertyToCloudFormation(properties.fieldWells), Legend: cfnTemplateLegendOptionsPropertyToCloudFormation(properties.legend), PrimaryYAxisDisplayOptions: cfnTemplateAxisDisplayOptionsPropertyToCloudFormation(properties.primaryYAxisDisplayOptions), PrimaryYAxisLabelOptions: cfnTemplateChartAxisLabelOptionsPropertyToCloudFormation(properties.primaryYAxisLabelOptions), ReferenceLines: cdk.listMapper(cfnTemplateReferenceLinePropertyToCloudFormation)(properties.referenceLines), SortConfiguration: cfnTemplateBoxPlotSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), Tooltip: cfnTemplateTooltipOptionsPropertyToCloudFormation(properties.tooltip), VisualPalette: cfnTemplateVisualPalettePropertyToCloudFormation(properties.visualPalette) }) : properties;
    }
    function CfnTemplateBoxPlotChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("boxPlotOptions", "BoxPlotOptions", properties.BoxPlotOptions != null ? CfnTemplateBoxPlotOptionsPropertyFromCloudFormation(properties.BoxPlotOptions) : void 0), ret.addPropertyResult("categoryAxis", "CategoryAxis", properties.CategoryAxis != null ? CfnTemplateAxisDisplayOptionsPropertyFromCloudFormation(properties.CategoryAxis) : void 0), ret.addPropertyResult("categoryLabelOptions", "CategoryLabelOptions", properties.CategoryLabelOptions != null ? CfnTemplateChartAxisLabelOptionsPropertyFromCloudFormation(properties.CategoryLabelOptions) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnTemplateBoxPlotFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnTemplateLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("primaryYAxisDisplayOptions", "PrimaryYAxisDisplayOptions", properties.PrimaryYAxisDisplayOptions != null ? CfnTemplateAxisDisplayOptionsPropertyFromCloudFormation(properties.PrimaryYAxisDisplayOptions) : void 0), ret.addPropertyResult("primaryYAxisLabelOptions", "PrimaryYAxisLabelOptions", properties.PrimaryYAxisLabelOptions != null ? CfnTemplateChartAxisLabelOptionsPropertyFromCloudFormation(properties.PrimaryYAxisLabelOptions) : void 0), ret.addPropertyResult("referenceLines", "ReferenceLines", properties.ReferenceLines != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateReferenceLinePropertyFromCloudFormation)(properties.ReferenceLines) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnTemplateBoxPlotSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnTemplateTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnTemplateVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_BoxPlotFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("boxPlotAggregatedFieldWells", CfnTemplate_BoxPlotAggregatedFieldWellsPropertyValidator)(properties.boxPlotAggregatedFieldWells)), errors.wrap('supplied properties not correct for "BoxPlotFieldWellsProperty"');
    }
    function cfnTemplateBoxPlotFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_BoxPlotFieldWellsPropertyValidator(properties).assertSuccess(), { BoxPlotAggregatedFieldWells: cfnTemplateBoxPlotAggregatedFieldWellsPropertyToCloudFormation(properties.boxPlotAggregatedFieldWells) }) : properties;
    }
    function CfnTemplateBoxPlotFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("boxPlotAggregatedFieldWells", "BoxPlotAggregatedFieldWells", properties.BoxPlotAggregatedFieldWells != null ? CfnTemplateBoxPlotAggregatedFieldWellsPropertyFromCloudFormation(properties.BoxPlotAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_BoxPlotOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allDataPointsVisibility", cdk.validateString)(properties.allDataPointsVisibility)), errors.collect(cdk.propertyValidator("outlierVisibility", cdk.validateString)(properties.outlierVisibility)), errors.collect(cdk.propertyValidator("styleOptions", CfnTemplate_BoxPlotStyleOptionsPropertyValidator)(properties.styleOptions)), errors.wrap('supplied properties not correct for "BoxPlotOptionsProperty"');
    }
    function cfnTemplateBoxPlotOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_BoxPlotOptionsPropertyValidator(properties).assertSuccess(), { AllDataPointsVisibility: cdk.stringToCloudFormation(properties.allDataPointsVisibility), OutlierVisibility: cdk.stringToCloudFormation(properties.outlierVisibility), StyleOptions: cfnTemplateBoxPlotStyleOptionsPropertyToCloudFormation(properties.styleOptions) }) : properties;
    }
    function CfnTemplateBoxPlotOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allDataPointsVisibility", "AllDataPointsVisibility", properties.AllDataPointsVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.AllDataPointsVisibility) : void 0), ret.addPropertyResult("outlierVisibility", "OutlierVisibility", properties.OutlierVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.OutlierVisibility) : void 0), ret.addPropertyResult("styleOptions", "StyleOptions", properties.StyleOptions != null ? CfnTemplateBoxPlotStyleOptionsPropertyFromCloudFormation(properties.StyleOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_BoxPlotSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categorySort", cdk.listValidator(CfnTemplate_FieldSortOptionsPropertyValidator))(properties.categorySort)), errors.collect(cdk.propertyValidator("paginationConfiguration", CfnTemplate_PaginationConfigurationPropertyValidator)(properties.paginationConfiguration)), errors.wrap('supplied properties not correct for "BoxPlotSortConfigurationProperty"');
    }
    function cfnTemplateBoxPlotSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_BoxPlotSortConfigurationPropertyValidator(properties).assertSuccess(), { CategorySort: cdk.listMapper(cfnTemplateFieldSortOptionsPropertyToCloudFormation)(properties.categorySort), PaginationConfiguration: cfnTemplatePaginationConfigurationPropertyToCloudFormation(properties.paginationConfiguration) }) : properties;
    }
    function CfnTemplateBoxPlotSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categorySort", "CategorySort", properties.CategorySort != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateFieldSortOptionsPropertyFromCloudFormation)(properties.CategorySort) : void 0), ret.addPropertyResult("paginationConfiguration", "PaginationConfiguration", properties.PaginationConfiguration != null ? CfnTemplatePaginationConfigurationPropertyFromCloudFormation(properties.PaginationConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_BoxPlotStyleOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fillStyle", cdk.validateString)(properties.fillStyle)), errors.wrap('supplied properties not correct for "BoxPlotStyleOptionsProperty"');
    }
    function cfnTemplateBoxPlotStyleOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_BoxPlotStyleOptionsPropertyValidator(properties).assertSuccess(), { FillStyle: cdk.stringToCloudFormation(properties.fillStyle) }) : properties;
    }
    function CfnTemplateBoxPlotStyleOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fillStyle", "FillStyle", properties.FillStyle != null ? cfn_parse.FromCloudFormation.getString(properties.FillStyle) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_BoxPlotVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnTemplate_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnTemplate_BoxPlotChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnTemplate_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnTemplate_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnTemplate_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "BoxPlotVisualProperty"');
    }
    function cfnTemplateBoxPlotVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_BoxPlotVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnTemplateVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnTemplateBoxPlotChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnTemplateColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnTemplateVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnTemplateVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnTemplateBoxPlotVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnTemplateBoxPlotChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnTemplateVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnTemplateVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_CalculatedFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.requiredValidator)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.validateString)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "CalculatedFieldProperty"');
    }
    function cfnTemplateCalculatedFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_CalculatedFieldPropertyValidator(properties).assertSuccess(), { DataSetIdentifier: cdk.stringToCloudFormation(properties.dataSetIdentifier), Expression: cdk.stringToCloudFormation(properties.expression), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnTemplateCalculatedFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataSetIdentifier", "DataSetIdentifier", cfn_parse.FromCloudFormation.getString(properties.DataSetIdentifier)), ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getString(properties.Expression)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_CalculatedMeasureFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.wrap('supplied properties not correct for "CalculatedMeasureFieldProperty"');
    }
    function cfnTemplateCalculatedMeasureFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_CalculatedMeasureFieldPropertyValidator(properties).assertSuccess(), { Expression: cdk.stringToCloudFormation(properties.expression), FieldId: cdk.stringToCloudFormation(properties.fieldId) }) : properties;
    }
    function CfnTemplateCalculatedMeasureFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getString(properties.Expression)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_CascadingControlConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sourceControls", cdk.listValidator(CfnTemplate_CascadingControlSourcePropertyValidator))(properties.sourceControls)), errors.wrap('supplied properties not correct for "CascadingControlConfigurationProperty"');
    }
    function cfnTemplateCascadingControlConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_CascadingControlConfigurationPropertyValidator(properties).assertSuccess(), { SourceControls: cdk.listMapper(cfnTemplateCascadingControlSourcePropertyToCloudFormation)(properties.sourceControls) }) : properties;
    }
    function CfnTemplateCascadingControlConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sourceControls", "SourceControls", properties.SourceControls != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateCascadingControlSourcePropertyFromCloudFormation)(properties.SourceControls) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_CascadingControlSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnToMatch", CfnTemplate_ColumnIdentifierPropertyValidator)(properties.columnToMatch)), errors.collect(cdk.propertyValidator("sourceSheetControlId", cdk.validateString)(properties.sourceSheetControlId)), errors.wrap('supplied properties not correct for "CascadingControlSourceProperty"');
    }
    function cfnTemplateCascadingControlSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_CascadingControlSourcePropertyValidator(properties).assertSuccess(), { ColumnToMatch: cfnTemplateColumnIdentifierPropertyToCloudFormation(properties.columnToMatch), SourceSheetControlId: cdk.stringToCloudFormation(properties.sourceSheetControlId) }) : properties;
    }
    function CfnTemplateCascadingControlSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columnToMatch", "ColumnToMatch", properties.ColumnToMatch != null ? CfnTemplateColumnIdentifierPropertyFromCloudFormation(properties.ColumnToMatch) : void 0), ret.addPropertyResult("sourceSheetControlId", "SourceSheetControlId", properties.SourceSheetControlId != null ? cfn_parse.FromCloudFormation.getString(properties.SourceSheetControlId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_CategoricalDimensionFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnTemplate_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("formatConfiguration", CfnTemplate_StringFormatConfigurationPropertyValidator)(properties.formatConfiguration)), errors.collect(cdk.propertyValidator("hierarchyId", cdk.validateString)(properties.hierarchyId)), errors.wrap('supplied properties not correct for "CategoricalDimensionFieldProperty"');
    }
    function cfnTemplateCategoricalDimensionFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_CategoricalDimensionFieldPropertyValidator(properties).assertSuccess(), { Column: cfnTemplateColumnIdentifierPropertyToCloudFormation(properties.column), FieldId: cdk.stringToCloudFormation(properties.fieldId), FormatConfiguration: cfnTemplateStringFormatConfigurationPropertyToCloudFormation(properties.formatConfiguration), HierarchyId: cdk.stringToCloudFormation(properties.hierarchyId) }) : properties;
    }
    function CfnTemplateCategoricalDimensionFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", CfnTemplateColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("formatConfiguration", "FormatConfiguration", properties.FormatConfiguration != null ? CfnTemplateStringFormatConfigurationPropertyFromCloudFormation(properties.FormatConfiguration) : void 0), ret.addPropertyResult("hierarchyId", "HierarchyId", properties.HierarchyId != null ? cfn_parse.FromCloudFormation.getString(properties.HierarchyId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_CategoricalMeasureFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationFunction", cdk.validateString)(properties.aggregationFunction)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnTemplate_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("formatConfiguration", CfnTemplate_StringFormatConfigurationPropertyValidator)(properties.formatConfiguration)), errors.wrap('supplied properties not correct for "CategoricalMeasureFieldProperty"');
    }
    function cfnTemplateCategoricalMeasureFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_CategoricalMeasureFieldPropertyValidator(properties).assertSuccess(), { AggregationFunction: cdk.stringToCloudFormation(properties.aggregationFunction), Column: cfnTemplateColumnIdentifierPropertyToCloudFormation(properties.column), FieldId: cdk.stringToCloudFormation(properties.fieldId), FormatConfiguration: cfnTemplateStringFormatConfigurationPropertyToCloudFormation(properties.formatConfiguration) }) : properties;
    }
    function CfnTemplateCategoricalMeasureFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationFunction", "AggregationFunction", properties.AggregationFunction != null ? cfn_parse.FromCloudFormation.getString(properties.AggregationFunction) : void 0), ret.addPropertyResult("column", "Column", CfnTemplateColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("formatConfiguration", "FormatConfiguration", properties.FormatConfiguration != null ? CfnTemplateStringFormatConfigurationPropertyFromCloudFormation(properties.FormatConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_CategoryDrillDownFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryValues", cdk.requiredValidator)(properties.categoryValues)), errors.collect(cdk.propertyValidator("categoryValues", cdk.listValidator(cdk.validateString))(properties.categoryValues)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnTemplate_ColumnIdentifierPropertyValidator)(properties.column)), errors.wrap('supplied properties not correct for "CategoryDrillDownFilterProperty"');
    }
    function cfnTemplateCategoryDrillDownFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_CategoryDrillDownFilterPropertyValidator(properties).assertSuccess(), { CategoryValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.categoryValues), Column: cfnTemplateColumnIdentifierPropertyToCloudFormation(properties.column) }) : properties;
    }
    function CfnTemplateCategoryDrillDownFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryValues", "CategoryValues", cfn_parse.FromCloudFormation.getStringArray(properties.CategoryValues)), ret.addPropertyResult("column", "Column", CfnTemplateColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_CategoryFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnTemplate_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("configuration", cdk.requiredValidator)(properties.configuration)), errors.collect(cdk.propertyValidator("configuration", CfnTemplate_CategoryFilterConfigurationPropertyValidator)(properties.configuration)), errors.collect(cdk.propertyValidator("filterId", cdk.requiredValidator)(properties.filterId)), errors.collect(cdk.propertyValidator("filterId", cdk.validateString)(properties.filterId)), errors.wrap('supplied properties not correct for "CategoryFilterProperty"');
    }
    function cfnTemplateCategoryFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_CategoryFilterPropertyValidator(properties).assertSuccess(), { Column: cfnTemplateColumnIdentifierPropertyToCloudFormation(properties.column), Configuration: cfnTemplateCategoryFilterConfigurationPropertyToCloudFormation(properties.configuration), FilterId: cdk.stringToCloudFormation(properties.filterId) }) : properties;
    }
    function CfnTemplateCategoryFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", CfnTemplateColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("configuration", "Configuration", CfnTemplateCategoryFilterConfigurationPropertyFromCloudFormation(properties.Configuration)), ret.addPropertyResult("filterId", "FilterId", cfn_parse.FromCloudFormation.getString(properties.FilterId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_CategoryFilterConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customFilterConfiguration", CfnTemplate_CustomFilterConfigurationPropertyValidator)(properties.customFilterConfiguration)), errors.collect(cdk.propertyValidator("customFilterListConfiguration", CfnTemplate_CustomFilterListConfigurationPropertyValidator)(properties.customFilterListConfiguration)), errors.collect(cdk.propertyValidator("filterListConfiguration", CfnTemplate_FilterListConfigurationPropertyValidator)(properties.filterListConfiguration)), errors.wrap('supplied properties not correct for "CategoryFilterConfigurationProperty"');
    }
    function cfnTemplateCategoryFilterConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_CategoryFilterConfigurationPropertyValidator(properties).assertSuccess(), { CustomFilterConfiguration: cfnTemplateCustomFilterConfigurationPropertyToCloudFormation(properties.customFilterConfiguration), CustomFilterListConfiguration: cfnTemplateCustomFilterListConfigurationPropertyToCloudFormation(properties.customFilterListConfiguration), FilterListConfiguration: cfnTemplateFilterListConfigurationPropertyToCloudFormation(properties.filterListConfiguration) }) : properties;
    }
    function CfnTemplateCategoryFilterConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customFilterConfiguration", "CustomFilterConfiguration", properties.CustomFilterConfiguration != null ? CfnTemplateCustomFilterConfigurationPropertyFromCloudFormation(properties.CustomFilterConfiguration) : void 0), ret.addPropertyResult("customFilterListConfiguration", "CustomFilterListConfiguration", properties.CustomFilterListConfiguration != null ? CfnTemplateCustomFilterListConfigurationPropertyFromCloudFormation(properties.CustomFilterListConfiguration) : void 0), ret.addPropertyResult("filterListConfiguration", "FilterListConfiguration", properties.FilterListConfiguration != null ? CfnTemplateFilterListConfigurationPropertyFromCloudFormation(properties.FilterListConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ChartAxisLabelOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("axisLabelOptions", cdk.listValidator(CfnTemplate_AxisLabelOptionsPropertyValidator))(properties.axisLabelOptions)), errors.collect(cdk.propertyValidator("sortIconVisibility", cdk.validateString)(properties.sortIconVisibility)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "ChartAxisLabelOptionsProperty"');
    }
    function cfnTemplateChartAxisLabelOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ChartAxisLabelOptionsPropertyValidator(properties).assertSuccess(), { AxisLabelOptions: cdk.listMapper(cfnTemplateAxisLabelOptionsPropertyToCloudFormation)(properties.axisLabelOptions), SortIconVisibility: cdk.stringToCloudFormation(properties.sortIconVisibility), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnTemplateChartAxisLabelOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("axisLabelOptions", "AxisLabelOptions", properties.AxisLabelOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateAxisLabelOptionsPropertyFromCloudFormation)(properties.AxisLabelOptions) : void 0), ret.addPropertyResult("sortIconVisibility", "SortIconVisibility", properties.SortIconVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.SortIconVisibility) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ClusterMarkerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("simpleClusterMarker", CfnTemplate_SimpleClusterMarkerPropertyValidator)(properties.simpleClusterMarker)), errors.wrap('supplied properties not correct for "ClusterMarkerProperty"');
    }
    function cfnTemplateClusterMarkerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ClusterMarkerPropertyValidator(properties).assertSuccess(), { SimpleClusterMarker: cfnTemplateSimpleClusterMarkerPropertyToCloudFormation(properties.simpleClusterMarker) }) : properties;
    }
    function CfnTemplateClusterMarkerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("simpleClusterMarker", "SimpleClusterMarker", properties.SimpleClusterMarker != null ? CfnTemplateSimpleClusterMarkerPropertyFromCloudFormation(properties.SimpleClusterMarker) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ClusterMarkerConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clusterMarker", CfnTemplate_ClusterMarkerPropertyValidator)(properties.clusterMarker)), errors.wrap('supplied properties not correct for "ClusterMarkerConfigurationProperty"');
    }
    function cfnTemplateClusterMarkerConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ClusterMarkerConfigurationPropertyValidator(properties).assertSuccess(), { ClusterMarker: cfnTemplateClusterMarkerPropertyToCloudFormation(properties.clusterMarker) }) : properties;
    }
    function CfnTemplateClusterMarkerConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clusterMarker", "ClusterMarker", properties.ClusterMarker != null ? CfnTemplateClusterMarkerPropertyFromCloudFormation(properties.ClusterMarker) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ColorScalePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("colorFillType", cdk.requiredValidator)(properties.colorFillType)), errors.collect(cdk.propertyValidator("colorFillType", cdk.validateString)(properties.colorFillType)), errors.collect(cdk.propertyValidator("colors", cdk.requiredValidator)(properties.colors)), errors.collect(cdk.propertyValidator("colors", cdk.listValidator(CfnTemplate_DataColorPropertyValidator))(properties.colors)), errors.collect(cdk.propertyValidator("nullValueColor", CfnTemplate_DataColorPropertyValidator)(properties.nullValueColor)), errors.wrap('supplied properties not correct for "ColorScaleProperty"');
    }
    function cfnTemplateColorScalePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ColorScalePropertyValidator(properties).assertSuccess(), { ColorFillType: cdk.stringToCloudFormation(properties.colorFillType), Colors: cdk.listMapper(cfnTemplateDataColorPropertyToCloudFormation)(properties.colors), NullValueColor: cfnTemplateDataColorPropertyToCloudFormation(properties.nullValueColor) }) : properties;
    }
    function CfnTemplateColorScalePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("colorFillType", "ColorFillType", cfn_parse.FromCloudFormation.getString(properties.ColorFillType)), ret.addPropertyResult("colors", "Colors", cfn_parse.FromCloudFormation.getArray(CfnTemplateDataColorPropertyFromCloudFormation)(properties.Colors)), ret.addPropertyResult("nullValueColor", "NullValueColor", properties.NullValueColor != null ? CfnTemplateDataColorPropertyFromCloudFormation(properties.NullValueColor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ColorsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customColors", cdk.listValidator(CfnTemplate_CustomColorPropertyValidator))(properties.customColors)), errors.wrap('supplied properties not correct for "ColorsConfigurationProperty"');
    }
    function cfnTemplateColorsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ColorsConfigurationPropertyValidator(properties).assertSuccess(), { CustomColors: cdk.listMapper(cfnTemplateCustomColorPropertyToCloudFormation)(properties.customColors) }) : properties;
    }
    function CfnTemplateColorsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customColors", "CustomColors", properties.CustomColors != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateCustomColorPropertyFromCloudFormation)(properties.CustomColors) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ColumnConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("colorsConfiguration", CfnTemplate_ColorsConfigurationPropertyValidator)(properties.colorsConfiguration)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnTemplate_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("formatConfiguration", CfnTemplate_FormatConfigurationPropertyValidator)(properties.formatConfiguration)), errors.collect(cdk.propertyValidator("role", cdk.validateString)(properties.role)), errors.wrap('supplied properties not correct for "ColumnConfigurationProperty"');
    }
    function cfnTemplateColumnConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ColumnConfigurationPropertyValidator(properties).assertSuccess(), { ColorsConfiguration: cfnTemplateColorsConfigurationPropertyToCloudFormation(properties.colorsConfiguration), Column: cfnTemplateColumnIdentifierPropertyToCloudFormation(properties.column), FormatConfiguration: cfnTemplateFormatConfigurationPropertyToCloudFormation(properties.formatConfiguration), Role: cdk.stringToCloudFormation(properties.role) }) : properties;
    }
    function CfnTemplateColumnConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("colorsConfiguration", "ColorsConfiguration", properties.ColorsConfiguration != null ? CfnTemplateColorsConfigurationPropertyFromCloudFormation(properties.ColorsConfiguration) : void 0), ret.addPropertyResult("column", "Column", CfnTemplateColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("formatConfiguration", "FormatConfiguration", properties.FormatConfiguration != null ? CfnTemplateFormatConfigurationPropertyFromCloudFormation(properties.FormatConfiguration) : void 0), ret.addPropertyResult("role", "Role", properties.Role != null ? cfn_parse.FromCloudFormation.getString(properties.Role) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ColumnGroupColumnSchemaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "ColumnGroupColumnSchemaProperty"');
    }
    function cfnTemplateColumnGroupColumnSchemaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ColumnGroupColumnSchemaPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnTemplateColumnGroupColumnSchemaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ColumnGroupSchemaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnGroupColumnSchemaList", cdk.listValidator(CfnTemplate_ColumnGroupColumnSchemaPropertyValidator))(properties.columnGroupColumnSchemaList)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "ColumnGroupSchemaProperty"');
    }
    function cfnTemplateColumnGroupSchemaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ColumnGroupSchemaPropertyValidator(properties).assertSuccess(), { ColumnGroupColumnSchemaList: cdk.listMapper(cfnTemplateColumnGroupColumnSchemaPropertyToCloudFormation)(properties.columnGroupColumnSchemaList), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnTemplateColumnGroupSchemaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columnGroupColumnSchemaList", "ColumnGroupColumnSchemaList", properties.ColumnGroupColumnSchemaList != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateColumnGroupColumnSchemaPropertyFromCloudFormation)(properties.ColumnGroupColumnSchemaList) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ColumnHierarchyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateTimeHierarchy", CfnTemplate_DateTimeHierarchyPropertyValidator)(properties.dateTimeHierarchy)), errors.collect(cdk.propertyValidator("explicitHierarchy", CfnTemplate_ExplicitHierarchyPropertyValidator)(properties.explicitHierarchy)), errors.collect(cdk.propertyValidator("predefinedHierarchy", CfnTemplate_PredefinedHierarchyPropertyValidator)(properties.predefinedHierarchy)), errors.wrap('supplied properties not correct for "ColumnHierarchyProperty"');
    }
    function cfnTemplateColumnHierarchyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ColumnHierarchyPropertyValidator(properties).assertSuccess(), { DateTimeHierarchy: cfnTemplateDateTimeHierarchyPropertyToCloudFormation(properties.dateTimeHierarchy), ExplicitHierarchy: cfnTemplateExplicitHierarchyPropertyToCloudFormation(properties.explicitHierarchy), PredefinedHierarchy: cfnTemplatePredefinedHierarchyPropertyToCloudFormation(properties.predefinedHierarchy) }) : properties;
    }
    function CfnTemplateColumnHierarchyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateTimeHierarchy", "DateTimeHierarchy", properties.DateTimeHierarchy != null ? CfnTemplateDateTimeHierarchyPropertyFromCloudFormation(properties.DateTimeHierarchy) : void 0), ret.addPropertyResult("explicitHierarchy", "ExplicitHierarchy", properties.ExplicitHierarchy != null ? CfnTemplateExplicitHierarchyPropertyFromCloudFormation(properties.ExplicitHierarchy) : void 0), ret.addPropertyResult("predefinedHierarchy", "PredefinedHierarchy", properties.PredefinedHierarchy != null ? CfnTemplatePredefinedHierarchyPropertyFromCloudFormation(properties.PredefinedHierarchy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ColumnIdentifierPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnName", cdk.requiredValidator)(properties.columnName)), errors.collect(cdk.propertyValidator("columnName", cdk.validateString)(properties.columnName)), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.requiredValidator)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.validateString)(properties.dataSetIdentifier)), errors.wrap('supplied properties not correct for "ColumnIdentifierProperty"');
    }
    function cfnTemplateColumnIdentifierPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ColumnIdentifierPropertyValidator(properties).assertSuccess(), { ColumnName: cdk.stringToCloudFormation(properties.columnName), DataSetIdentifier: cdk.stringToCloudFormation(properties.dataSetIdentifier) }) : properties;
    }
    function CfnTemplateColumnIdentifierPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columnName", "ColumnName", cfn_parse.FromCloudFormation.getString(properties.ColumnName)), ret.addPropertyResult("dataSetIdentifier", "DataSetIdentifier", cfn_parse.FromCloudFormation.getString(properties.DataSetIdentifier)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ColumnSchemaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataType", cdk.validateString)(properties.dataType)), errors.collect(cdk.propertyValidator("geographicRole", cdk.validateString)(properties.geographicRole)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "ColumnSchemaProperty"');
    }
    function cfnTemplateColumnSchemaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ColumnSchemaPropertyValidator(properties).assertSuccess(), { DataType: cdk.stringToCloudFormation(properties.dataType), GeographicRole: cdk.stringToCloudFormation(properties.geographicRole), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnTemplateColumnSchemaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataType", "DataType", properties.DataType != null ? cfn_parse.FromCloudFormation.getString(properties.DataType) : void 0), ret.addPropertyResult("geographicRole", "GeographicRole", properties.GeographicRole != null ? cfn_parse.FromCloudFormation.getString(properties.GeographicRole) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ColumnSortPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationFunction", CfnTemplate_AggregationFunctionPropertyValidator)(properties.aggregationFunction)), errors.collect(cdk.propertyValidator("direction", cdk.requiredValidator)(properties.direction)), errors.collect(cdk.propertyValidator("direction", cdk.validateString)(properties.direction)), errors.collect(cdk.propertyValidator("sortBy", cdk.requiredValidator)(properties.sortBy)), errors.collect(cdk.propertyValidator("sortBy", CfnTemplate_ColumnIdentifierPropertyValidator)(properties.sortBy)), errors.wrap('supplied properties not correct for "ColumnSortProperty"');
    }
    function cfnTemplateColumnSortPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ColumnSortPropertyValidator(properties).assertSuccess(), { AggregationFunction: cfnTemplateAggregationFunctionPropertyToCloudFormation(properties.aggregationFunction), Direction: cdk.stringToCloudFormation(properties.direction), SortBy: cfnTemplateColumnIdentifierPropertyToCloudFormation(properties.sortBy) }) : properties;
    }
    function CfnTemplateColumnSortPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationFunction", "AggregationFunction", properties.AggregationFunction != null ? CfnTemplateAggregationFunctionPropertyFromCloudFormation(properties.AggregationFunction) : void 0), ret.addPropertyResult("direction", "Direction", cfn_parse.FromCloudFormation.getString(properties.Direction)), ret.addPropertyResult("sortBy", "SortBy", CfnTemplateColumnIdentifierPropertyFromCloudFormation(properties.SortBy)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ColumnTooltipItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregation", CfnTemplate_AggregationFunctionPropertyValidator)(properties.aggregation)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnTemplate_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("label", cdk.validateString)(properties.label)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "ColumnTooltipItemProperty"');
    }
    function cfnTemplateColumnTooltipItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ColumnTooltipItemPropertyValidator(properties).assertSuccess(), { Aggregation: cfnTemplateAggregationFunctionPropertyToCloudFormation(properties.aggregation), Column: cfnTemplateColumnIdentifierPropertyToCloudFormation(properties.column), Label: cdk.stringToCloudFormation(properties.label), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnTemplateColumnTooltipItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregation", "Aggregation", properties.Aggregation != null ? CfnTemplateAggregationFunctionPropertyFromCloudFormation(properties.Aggregation) : void 0), ret.addPropertyResult("column", "Column", CfnTemplateColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("label", "Label", properties.Label != null ? cfn_parse.FromCloudFormation.getString(properties.Label) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ComboChartAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("barValues", cdk.listValidator(CfnTemplate_MeasureFieldPropertyValidator))(properties.barValues)), errors.collect(cdk.propertyValidator("category", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.category)), errors.collect(cdk.propertyValidator("colors", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.colors)), errors.collect(cdk.propertyValidator("lineValues", cdk.listValidator(CfnTemplate_MeasureFieldPropertyValidator))(properties.lineValues)), errors.wrap('supplied properties not correct for "ComboChartAggregatedFieldWellsProperty"');
    }
    function cfnTemplateComboChartAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ComboChartAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { BarValues: cdk.listMapper(cfnTemplateMeasureFieldPropertyToCloudFormation)(properties.barValues), Category: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.category), Colors: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.colors), LineValues: cdk.listMapper(cfnTemplateMeasureFieldPropertyToCloudFormation)(properties.lineValues) }) : properties;
    }
    function CfnTemplateComboChartAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("barValues", "BarValues", properties.BarValues != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMeasureFieldPropertyFromCloudFormation)(properties.BarValues) : void 0), ret.addPropertyResult("category", "Category", properties.Category != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.Category) : void 0), ret.addPropertyResult("colors", "Colors", properties.Colors != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.Colors) : void 0), ret.addPropertyResult("lineValues", "LineValues", properties.LineValues != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMeasureFieldPropertyFromCloudFormation)(properties.LineValues) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ComboChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("barDataLabels", CfnTemplate_DataLabelOptionsPropertyValidator)(properties.barDataLabels)), errors.collect(cdk.propertyValidator("barsArrangement", cdk.validateString)(properties.barsArrangement)), errors.collect(cdk.propertyValidator("categoryAxis", CfnTemplate_AxisDisplayOptionsPropertyValidator)(properties.categoryAxis)), errors.collect(cdk.propertyValidator("categoryLabelOptions", CfnTemplate_ChartAxisLabelOptionsPropertyValidator)(properties.categoryLabelOptions)), errors.collect(cdk.propertyValidator("colorLabelOptions", CfnTemplate_ChartAxisLabelOptionsPropertyValidator)(properties.colorLabelOptions)), errors.collect(cdk.propertyValidator("fieldWells", CfnTemplate_ComboChartFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("legend", CfnTemplate_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("lineDataLabels", CfnTemplate_DataLabelOptionsPropertyValidator)(properties.lineDataLabels)), errors.collect(cdk.propertyValidator("primaryYAxisDisplayOptions", CfnTemplate_AxisDisplayOptionsPropertyValidator)(properties.primaryYAxisDisplayOptions)), errors.collect(cdk.propertyValidator("primaryYAxisLabelOptions", CfnTemplate_ChartAxisLabelOptionsPropertyValidator)(properties.primaryYAxisLabelOptions)), errors.collect(cdk.propertyValidator("referenceLines", cdk.listValidator(CfnTemplate_ReferenceLinePropertyValidator))(properties.referenceLines)), errors.collect(cdk.propertyValidator("secondaryYAxisDisplayOptions", CfnTemplate_AxisDisplayOptionsPropertyValidator)(properties.secondaryYAxisDisplayOptions)), errors.collect(cdk.propertyValidator("secondaryYAxisLabelOptions", CfnTemplate_ChartAxisLabelOptionsPropertyValidator)(properties.secondaryYAxisLabelOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnTemplate_ComboChartSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tooltip", CfnTemplate_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.collect(cdk.propertyValidator("visualPalette", CfnTemplate_VisualPalettePropertyValidator)(properties.visualPalette)), errors.wrap('supplied properties not correct for "ComboChartConfigurationProperty"');
    }
    function cfnTemplateComboChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ComboChartConfigurationPropertyValidator(properties).assertSuccess(), { BarDataLabels: cfnTemplateDataLabelOptionsPropertyToCloudFormation(properties.barDataLabels), BarsArrangement: cdk.stringToCloudFormation(properties.barsArrangement), CategoryAxis: cfnTemplateAxisDisplayOptionsPropertyToCloudFormation(properties.categoryAxis), CategoryLabelOptions: cfnTemplateChartAxisLabelOptionsPropertyToCloudFormation(properties.categoryLabelOptions), ColorLabelOptions: cfnTemplateChartAxisLabelOptionsPropertyToCloudFormation(properties.colorLabelOptions), FieldWells: cfnTemplateComboChartFieldWellsPropertyToCloudFormation(properties.fieldWells), Legend: cfnTemplateLegendOptionsPropertyToCloudFormation(properties.legend), LineDataLabels: cfnTemplateDataLabelOptionsPropertyToCloudFormation(properties.lineDataLabels), PrimaryYAxisDisplayOptions: cfnTemplateAxisDisplayOptionsPropertyToCloudFormation(properties.primaryYAxisDisplayOptions), PrimaryYAxisLabelOptions: cfnTemplateChartAxisLabelOptionsPropertyToCloudFormation(properties.primaryYAxisLabelOptions), ReferenceLines: cdk.listMapper(cfnTemplateReferenceLinePropertyToCloudFormation)(properties.referenceLines), SecondaryYAxisDisplayOptions: cfnTemplateAxisDisplayOptionsPropertyToCloudFormation(properties.secondaryYAxisDisplayOptions), SecondaryYAxisLabelOptions: cfnTemplateChartAxisLabelOptionsPropertyToCloudFormation(properties.secondaryYAxisLabelOptions), SortConfiguration: cfnTemplateComboChartSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), Tooltip: cfnTemplateTooltipOptionsPropertyToCloudFormation(properties.tooltip), VisualPalette: cfnTemplateVisualPalettePropertyToCloudFormation(properties.visualPalette) }) : properties;
    }
    function CfnTemplateComboChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("barDataLabels", "BarDataLabels", properties.BarDataLabels != null ? CfnTemplateDataLabelOptionsPropertyFromCloudFormation(properties.BarDataLabels) : void 0), ret.addPropertyResult("barsArrangement", "BarsArrangement", properties.BarsArrangement != null ? cfn_parse.FromCloudFormation.getString(properties.BarsArrangement) : void 0), ret.addPropertyResult("categoryAxis", "CategoryAxis", properties.CategoryAxis != null ? CfnTemplateAxisDisplayOptionsPropertyFromCloudFormation(properties.CategoryAxis) : void 0), ret.addPropertyResult("categoryLabelOptions", "CategoryLabelOptions", properties.CategoryLabelOptions != null ? CfnTemplateChartAxisLabelOptionsPropertyFromCloudFormation(properties.CategoryLabelOptions) : void 0), ret.addPropertyResult("colorLabelOptions", "ColorLabelOptions", properties.ColorLabelOptions != null ? CfnTemplateChartAxisLabelOptionsPropertyFromCloudFormation(properties.ColorLabelOptions) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnTemplateComboChartFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnTemplateLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("lineDataLabels", "LineDataLabels", properties.LineDataLabels != null ? CfnTemplateDataLabelOptionsPropertyFromCloudFormation(properties.LineDataLabels) : void 0), ret.addPropertyResult("primaryYAxisDisplayOptions", "PrimaryYAxisDisplayOptions", properties.PrimaryYAxisDisplayOptions != null ? CfnTemplateAxisDisplayOptionsPropertyFromCloudFormation(properties.PrimaryYAxisDisplayOptions) : void 0), ret.addPropertyResult("primaryYAxisLabelOptions", "PrimaryYAxisLabelOptions", properties.PrimaryYAxisLabelOptions != null ? CfnTemplateChartAxisLabelOptionsPropertyFromCloudFormation(properties.PrimaryYAxisLabelOptions) : void 0), ret.addPropertyResult("referenceLines", "ReferenceLines", properties.ReferenceLines != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateReferenceLinePropertyFromCloudFormation)(properties.ReferenceLines) : void 0), ret.addPropertyResult("secondaryYAxisDisplayOptions", "SecondaryYAxisDisplayOptions", properties.SecondaryYAxisDisplayOptions != null ? CfnTemplateAxisDisplayOptionsPropertyFromCloudFormation(properties.SecondaryYAxisDisplayOptions) : void 0), ret.addPropertyResult("secondaryYAxisLabelOptions", "SecondaryYAxisLabelOptions", properties.SecondaryYAxisLabelOptions != null ? CfnTemplateChartAxisLabelOptionsPropertyFromCloudFormation(properties.SecondaryYAxisLabelOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnTemplateComboChartSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnTemplateTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnTemplateVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ComboChartFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("comboChartAggregatedFieldWells", CfnTemplate_ComboChartAggregatedFieldWellsPropertyValidator)(properties.comboChartAggregatedFieldWells)), errors.wrap('supplied properties not correct for "ComboChartFieldWellsProperty"');
    }
    function cfnTemplateComboChartFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ComboChartFieldWellsPropertyValidator(properties).assertSuccess(), { ComboChartAggregatedFieldWells: cfnTemplateComboChartAggregatedFieldWellsPropertyToCloudFormation(properties.comboChartAggregatedFieldWells) }) : properties;
    }
    function CfnTemplateComboChartFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("comboChartAggregatedFieldWells", "ComboChartAggregatedFieldWells", properties.ComboChartAggregatedFieldWells != null ? CfnTemplateComboChartAggregatedFieldWellsPropertyFromCloudFormation(properties.ComboChartAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ComboChartSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryItemsLimit", CfnTemplate_ItemsLimitConfigurationPropertyValidator)(properties.categoryItemsLimit)), errors.collect(cdk.propertyValidator("categorySort", cdk.listValidator(CfnTemplate_FieldSortOptionsPropertyValidator))(properties.categorySort)), errors.collect(cdk.propertyValidator("colorItemsLimit", CfnTemplate_ItemsLimitConfigurationPropertyValidator)(properties.colorItemsLimit)), errors.collect(cdk.propertyValidator("colorSort", cdk.listValidator(CfnTemplate_FieldSortOptionsPropertyValidator))(properties.colorSort)), errors.wrap('supplied properties not correct for "ComboChartSortConfigurationProperty"');
    }
    function cfnTemplateComboChartSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ComboChartSortConfigurationPropertyValidator(properties).assertSuccess(), { CategoryItemsLimit: cfnTemplateItemsLimitConfigurationPropertyToCloudFormation(properties.categoryItemsLimit), CategorySort: cdk.listMapper(cfnTemplateFieldSortOptionsPropertyToCloudFormation)(properties.categorySort), ColorItemsLimit: cfnTemplateItemsLimitConfigurationPropertyToCloudFormation(properties.colorItemsLimit), ColorSort: cdk.listMapper(cfnTemplateFieldSortOptionsPropertyToCloudFormation)(properties.colorSort) }) : properties;
    }
    function CfnTemplateComboChartSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryItemsLimit", "CategoryItemsLimit", properties.CategoryItemsLimit != null ? CfnTemplateItemsLimitConfigurationPropertyFromCloudFormation(properties.CategoryItemsLimit) : void 0), ret.addPropertyResult("categorySort", "CategorySort", properties.CategorySort != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateFieldSortOptionsPropertyFromCloudFormation)(properties.CategorySort) : void 0), ret.addPropertyResult("colorItemsLimit", "ColorItemsLimit", properties.ColorItemsLimit != null ? CfnTemplateItemsLimitConfigurationPropertyFromCloudFormation(properties.ColorItemsLimit) : void 0), ret.addPropertyResult("colorSort", "ColorSort", properties.ColorSort != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateFieldSortOptionsPropertyFromCloudFormation)(properties.ColorSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ComboChartVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnTemplate_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnTemplate_ComboChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnTemplate_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnTemplate_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnTemplate_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "ComboChartVisualProperty"');
    }
    function cfnTemplateComboChartVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ComboChartVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnTemplateVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnTemplateComboChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnTemplateColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnTemplateVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnTemplateVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnTemplateComboChartVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnTemplateComboChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnTemplateVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnTemplateVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ComparisonConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("comparisonFormat", CfnTemplate_ComparisonFormatConfigurationPropertyValidator)(properties.comparisonFormat)), errors.collect(cdk.propertyValidator("comparisonMethod", cdk.validateString)(properties.comparisonMethod)), errors.wrap('supplied properties not correct for "ComparisonConfigurationProperty"');
    }
    function cfnTemplateComparisonConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ComparisonConfigurationPropertyValidator(properties).assertSuccess(), { ComparisonFormat: cfnTemplateComparisonFormatConfigurationPropertyToCloudFormation(properties.comparisonFormat), ComparisonMethod: cdk.stringToCloudFormation(properties.comparisonMethod) }) : properties;
    }
    function CfnTemplateComparisonConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("comparisonFormat", "ComparisonFormat", properties.ComparisonFormat != null ? CfnTemplateComparisonFormatConfigurationPropertyFromCloudFormation(properties.ComparisonFormat) : void 0), ret.addPropertyResult("comparisonMethod", "ComparisonMethod", properties.ComparisonMethod != null ? cfn_parse.FromCloudFormation.getString(properties.ComparisonMethod) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ComparisonFormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("numberDisplayFormatConfiguration", CfnTemplate_NumberDisplayFormatConfigurationPropertyValidator)(properties.numberDisplayFormatConfiguration)), errors.collect(cdk.propertyValidator("percentageDisplayFormatConfiguration", CfnTemplate_PercentageDisplayFormatConfigurationPropertyValidator)(properties.percentageDisplayFormatConfiguration)), errors.wrap('supplied properties not correct for "ComparisonFormatConfigurationProperty"');
    }
    function cfnTemplateComparisonFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ComparisonFormatConfigurationPropertyValidator(properties).assertSuccess(), { NumberDisplayFormatConfiguration: cfnTemplateNumberDisplayFormatConfigurationPropertyToCloudFormation(properties.numberDisplayFormatConfiguration), PercentageDisplayFormatConfiguration: cfnTemplatePercentageDisplayFormatConfigurationPropertyToCloudFormation(properties.percentageDisplayFormatConfiguration) }) : properties;
    }
    function CfnTemplateComparisonFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("numberDisplayFormatConfiguration", "NumberDisplayFormatConfiguration", properties.NumberDisplayFormatConfiguration != null ? CfnTemplateNumberDisplayFormatConfigurationPropertyFromCloudFormation(properties.NumberDisplayFormatConfiguration) : void 0), ret.addPropertyResult("percentageDisplayFormatConfiguration", "PercentageDisplayFormatConfiguration", properties.PercentageDisplayFormatConfiguration != null ? CfnTemplatePercentageDisplayFormatConfigurationPropertyFromCloudFormation(properties.PercentageDisplayFormatConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("forecast", CfnTemplate_ForecastComputationPropertyValidator)(properties.forecast)), errors.collect(cdk.propertyValidator("growthRate", CfnTemplate_GrowthRateComputationPropertyValidator)(properties.growthRate)), errors.collect(cdk.propertyValidator("maximumMinimum", CfnTemplate_MaximumMinimumComputationPropertyValidator)(properties.maximumMinimum)), errors.collect(cdk.propertyValidator("metricComparison", CfnTemplate_MetricComparisonComputationPropertyValidator)(properties.metricComparison)), errors.collect(cdk.propertyValidator("periodOverPeriod", CfnTemplate_PeriodOverPeriodComputationPropertyValidator)(properties.periodOverPeriod)), errors.collect(cdk.propertyValidator("periodToDate", CfnTemplate_PeriodToDateComputationPropertyValidator)(properties.periodToDate)), errors.collect(cdk.propertyValidator("topBottomMovers", CfnTemplate_TopBottomMoversComputationPropertyValidator)(properties.topBottomMovers)), errors.collect(cdk.propertyValidator("topBottomRanked", CfnTemplate_TopBottomRankedComputationPropertyValidator)(properties.topBottomRanked)), errors.collect(cdk.propertyValidator("totalAggregation", CfnTemplate_TotalAggregationComputationPropertyValidator)(properties.totalAggregation)), errors.collect(cdk.propertyValidator("uniqueValues", CfnTemplate_UniqueValuesComputationPropertyValidator)(properties.uniqueValues)), errors.wrap('supplied properties not correct for "ComputationProperty"');
    }
    function cfnTemplateComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ComputationPropertyValidator(properties).assertSuccess(), { Forecast: cfnTemplateForecastComputationPropertyToCloudFormation(properties.forecast), GrowthRate: cfnTemplateGrowthRateComputationPropertyToCloudFormation(properties.growthRate), MaximumMinimum: cfnTemplateMaximumMinimumComputationPropertyToCloudFormation(properties.maximumMinimum), MetricComparison: cfnTemplateMetricComparisonComputationPropertyToCloudFormation(properties.metricComparison), PeriodOverPeriod: cfnTemplatePeriodOverPeriodComputationPropertyToCloudFormation(properties.periodOverPeriod), PeriodToDate: cfnTemplatePeriodToDateComputationPropertyToCloudFormation(properties.periodToDate), TopBottomMovers: cfnTemplateTopBottomMoversComputationPropertyToCloudFormation(properties.topBottomMovers), TopBottomRanked: cfnTemplateTopBottomRankedComputationPropertyToCloudFormation(properties.topBottomRanked), TotalAggregation: cfnTemplateTotalAggregationComputationPropertyToCloudFormation(properties.totalAggregation), UniqueValues: cfnTemplateUniqueValuesComputationPropertyToCloudFormation(properties.uniqueValues) }) : properties;
    }
    function CfnTemplateComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("forecast", "Forecast", properties.Forecast != null ? CfnTemplateForecastComputationPropertyFromCloudFormation(properties.Forecast) : void 0), ret.addPropertyResult("growthRate", "GrowthRate", properties.GrowthRate != null ? CfnTemplateGrowthRateComputationPropertyFromCloudFormation(properties.GrowthRate) : void 0), ret.addPropertyResult("maximumMinimum", "MaximumMinimum", properties.MaximumMinimum != null ? CfnTemplateMaximumMinimumComputationPropertyFromCloudFormation(properties.MaximumMinimum) : void 0), ret.addPropertyResult("metricComparison", "MetricComparison", properties.MetricComparison != null ? CfnTemplateMetricComparisonComputationPropertyFromCloudFormation(properties.MetricComparison) : void 0), ret.addPropertyResult("periodOverPeriod", "PeriodOverPeriod", properties.PeriodOverPeriod != null ? CfnTemplatePeriodOverPeriodComputationPropertyFromCloudFormation(properties.PeriodOverPeriod) : void 0), ret.addPropertyResult("periodToDate", "PeriodToDate", properties.PeriodToDate != null ? CfnTemplatePeriodToDateComputationPropertyFromCloudFormation(properties.PeriodToDate) : void 0), ret.addPropertyResult("topBottomMovers", "TopBottomMovers", properties.TopBottomMovers != null ? CfnTemplateTopBottomMoversComputationPropertyFromCloudFormation(properties.TopBottomMovers) : void 0), ret.addPropertyResult("topBottomRanked", "TopBottomRanked", properties.TopBottomRanked != null ? CfnTemplateTopBottomRankedComputationPropertyFromCloudFormation(properties.TopBottomRanked) : void 0), ret.addPropertyResult("totalAggregation", "TotalAggregation", properties.TotalAggregation != null ? CfnTemplateTotalAggregationComputationPropertyFromCloudFormation(properties.TotalAggregation) : void 0), ret.addPropertyResult("uniqueValues", "UniqueValues", properties.UniqueValues != null ? CfnTemplateUniqueValuesComputationPropertyFromCloudFormation(properties.UniqueValues) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ConditionalFormattingColorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("gradient", CfnTemplate_ConditionalFormattingGradientColorPropertyValidator)(properties.gradient)), errors.collect(cdk.propertyValidator("solid", CfnTemplate_ConditionalFormattingSolidColorPropertyValidator)(properties.solid)), errors.wrap('supplied properties not correct for "ConditionalFormattingColorProperty"');
    }
    function cfnTemplateConditionalFormattingColorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ConditionalFormattingColorPropertyValidator(properties).assertSuccess(), { Gradient: cfnTemplateConditionalFormattingGradientColorPropertyToCloudFormation(properties.gradient), Solid: cfnTemplateConditionalFormattingSolidColorPropertyToCloudFormation(properties.solid) }) : properties;
    }
    function CfnTemplateConditionalFormattingColorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("gradient", "Gradient", properties.Gradient != null ? CfnTemplateConditionalFormattingGradientColorPropertyFromCloudFormation(properties.Gradient) : void 0), ret.addPropertyResult("solid", "Solid", properties.Solid != null ? CfnTemplateConditionalFormattingSolidColorPropertyFromCloudFormation(properties.Solid) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ConditionalFormattingCustomIconConditionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.collect(cdk.propertyValidator("displayConfiguration", CfnTemplate_ConditionalFormattingIconDisplayConfigurationPropertyValidator)(properties.displayConfiguration)), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.collect(cdk.propertyValidator("iconOptions", cdk.requiredValidator)(properties.iconOptions)), errors.collect(cdk.propertyValidator("iconOptions", CfnTemplate_ConditionalFormattingCustomIconOptionsPropertyValidator)(properties.iconOptions)), errors.wrap('supplied properties not correct for "ConditionalFormattingCustomIconConditionProperty"');
    }
    function cfnTemplateConditionalFormattingCustomIconConditionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ConditionalFormattingCustomIconConditionPropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color), DisplayConfiguration: cfnTemplateConditionalFormattingIconDisplayConfigurationPropertyToCloudFormation(properties.displayConfiguration), Expression: cdk.stringToCloudFormation(properties.expression), IconOptions: cfnTemplateConditionalFormattingCustomIconOptionsPropertyToCloudFormation(properties.iconOptions) }) : properties;
    }
    function CfnTemplateConditionalFormattingCustomIconConditionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", properties.Color != null ? cfn_parse.FromCloudFormation.getString(properties.Color) : void 0), ret.addPropertyResult("displayConfiguration", "DisplayConfiguration", properties.DisplayConfiguration != null ? CfnTemplateConditionalFormattingIconDisplayConfigurationPropertyFromCloudFormation(properties.DisplayConfiguration) : void 0), ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getString(properties.Expression)), ret.addPropertyResult("iconOptions", "IconOptions", CfnTemplateConditionalFormattingCustomIconOptionsPropertyFromCloudFormation(properties.IconOptions)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ConditionalFormattingCustomIconOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("icon", cdk.validateString)(properties.icon)), errors.collect(cdk.propertyValidator("unicodeIcon", cdk.validateString)(properties.unicodeIcon)), errors.wrap('supplied properties not correct for "ConditionalFormattingCustomIconOptionsProperty"');
    }
    function cfnTemplateConditionalFormattingCustomIconOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ConditionalFormattingCustomIconOptionsPropertyValidator(properties).assertSuccess(), { Icon: cdk.stringToCloudFormation(properties.icon), UnicodeIcon: cdk.stringToCloudFormation(properties.unicodeIcon) }) : properties;
    }
    function CfnTemplateConditionalFormattingCustomIconOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("icon", "Icon", properties.Icon != null ? cfn_parse.FromCloudFormation.getString(properties.Icon) : void 0), ret.addPropertyResult("unicodeIcon", "UnicodeIcon", properties.UnicodeIcon != null ? cfn_parse.FromCloudFormation.getString(properties.UnicodeIcon) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ConditionalFormattingGradientColorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.requiredValidator)(properties.color)), errors.collect(cdk.propertyValidator("color", CfnTemplate_GradientColorPropertyValidator)(properties.color)), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.wrap('supplied properties not correct for "ConditionalFormattingGradientColorProperty"');
    }
    function cfnTemplateConditionalFormattingGradientColorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ConditionalFormattingGradientColorPropertyValidator(properties).assertSuccess(), { Color: cfnTemplateGradientColorPropertyToCloudFormation(properties.color), Expression: cdk.stringToCloudFormation(properties.expression) }) : properties;
    }
    function CfnTemplateConditionalFormattingGradientColorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", CfnTemplateGradientColorPropertyFromCloudFormation(properties.Color)), ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getString(properties.Expression)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ConditionalFormattingIconPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customCondition", CfnTemplate_ConditionalFormattingCustomIconConditionPropertyValidator)(properties.customCondition)), errors.collect(cdk.propertyValidator("iconSet", CfnTemplate_ConditionalFormattingIconSetPropertyValidator)(properties.iconSet)), errors.wrap('supplied properties not correct for "ConditionalFormattingIconProperty"');
    }
    function cfnTemplateConditionalFormattingIconPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ConditionalFormattingIconPropertyValidator(properties).assertSuccess(), { CustomCondition: cfnTemplateConditionalFormattingCustomIconConditionPropertyToCloudFormation(properties.customCondition), IconSet: cfnTemplateConditionalFormattingIconSetPropertyToCloudFormation(properties.iconSet) }) : properties;
    }
    function CfnTemplateConditionalFormattingIconPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customCondition", "CustomCondition", properties.CustomCondition != null ? CfnTemplateConditionalFormattingCustomIconConditionPropertyFromCloudFormation(properties.CustomCondition) : void 0), ret.addPropertyResult("iconSet", "IconSet", properties.IconSet != null ? CfnTemplateConditionalFormattingIconSetPropertyFromCloudFormation(properties.IconSet) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ConditionalFormattingIconDisplayConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("iconDisplayOption", cdk.validateString)(properties.iconDisplayOption)), errors.wrap('supplied properties not correct for "ConditionalFormattingIconDisplayConfigurationProperty"');
    }
    function cfnTemplateConditionalFormattingIconDisplayConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ConditionalFormattingIconDisplayConfigurationPropertyValidator(properties).assertSuccess(), { IconDisplayOption: cdk.stringToCloudFormation(properties.iconDisplayOption) }) : properties;
    }
    function CfnTemplateConditionalFormattingIconDisplayConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("iconDisplayOption", "IconDisplayOption", properties.IconDisplayOption != null ? cfn_parse.FromCloudFormation.getString(properties.IconDisplayOption) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ConditionalFormattingIconSetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.collect(cdk.propertyValidator("iconSetType", cdk.validateString)(properties.iconSetType)), errors.wrap('supplied properties not correct for "ConditionalFormattingIconSetProperty"');
    }
    function cfnTemplateConditionalFormattingIconSetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ConditionalFormattingIconSetPropertyValidator(properties).assertSuccess(), { Expression: cdk.stringToCloudFormation(properties.expression), IconSetType: cdk.stringToCloudFormation(properties.iconSetType) }) : properties;
    }
    function CfnTemplateConditionalFormattingIconSetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getString(properties.Expression)), ret.addPropertyResult("iconSetType", "IconSetType", properties.IconSetType != null ? cfn_parse.FromCloudFormation.getString(properties.IconSetType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ConditionalFormattingSolidColorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.wrap('supplied properties not correct for "ConditionalFormattingSolidColorProperty"');
    }
    function cfnTemplateConditionalFormattingSolidColorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ConditionalFormattingSolidColorPropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color), Expression: cdk.stringToCloudFormation(properties.expression) }) : properties;
    }
    function CfnTemplateConditionalFormattingSolidColorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", properties.Color != null ? cfn_parse.FromCloudFormation.getString(properties.Color) : void 0), ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getString(properties.Expression)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ContributionAnalysisDefaultPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contributorDimensions", cdk.requiredValidator)(properties.contributorDimensions)), errors.collect(cdk.propertyValidator("contributorDimensions", cdk.listValidator(CfnTemplate_ColumnIdentifierPropertyValidator))(properties.contributorDimensions)), errors.collect(cdk.propertyValidator("measureFieldId", cdk.requiredValidator)(properties.measureFieldId)), errors.collect(cdk.propertyValidator("measureFieldId", cdk.validateString)(properties.measureFieldId)), errors.wrap('supplied properties not correct for "ContributionAnalysisDefaultProperty"');
    }
    function cfnTemplateContributionAnalysisDefaultPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ContributionAnalysisDefaultPropertyValidator(properties).assertSuccess(), { ContributorDimensions: cdk.listMapper(cfnTemplateColumnIdentifierPropertyToCloudFormation)(properties.contributorDimensions), MeasureFieldId: cdk.stringToCloudFormation(properties.measureFieldId) }) : properties;
    }
    function CfnTemplateContributionAnalysisDefaultPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contributorDimensions", "ContributorDimensions", cfn_parse.FromCloudFormation.getArray(CfnTemplateColumnIdentifierPropertyFromCloudFormation)(properties.ContributorDimensions)), ret.addPropertyResult("measureFieldId", "MeasureFieldId", cfn_parse.FromCloudFormation.getString(properties.MeasureFieldId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_CurrencyDisplayFormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("decimalPlacesConfiguration", CfnTemplate_DecimalPlacesConfigurationPropertyValidator)(properties.decimalPlacesConfiguration)), errors.collect(cdk.propertyValidator("negativeValueConfiguration", CfnTemplate_NegativeValueConfigurationPropertyValidator)(properties.negativeValueConfiguration)), errors.collect(cdk.propertyValidator("nullValueFormatConfiguration", CfnTemplate_NullValueFormatConfigurationPropertyValidator)(properties.nullValueFormatConfiguration)), errors.collect(cdk.propertyValidator("numberScale", cdk.validateString)(properties.numberScale)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.collect(cdk.propertyValidator("separatorConfiguration", CfnTemplate_NumericSeparatorConfigurationPropertyValidator)(properties.separatorConfiguration)), errors.collect(cdk.propertyValidator("suffix", cdk.validateString)(properties.suffix)), errors.collect(cdk.propertyValidator("symbol", cdk.validateString)(properties.symbol)), errors.wrap('supplied properties not correct for "CurrencyDisplayFormatConfigurationProperty"');
    }
    function cfnTemplateCurrencyDisplayFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_CurrencyDisplayFormatConfigurationPropertyValidator(properties).assertSuccess(), { DecimalPlacesConfiguration: cfnTemplateDecimalPlacesConfigurationPropertyToCloudFormation(properties.decimalPlacesConfiguration), NegativeValueConfiguration: cfnTemplateNegativeValueConfigurationPropertyToCloudFormation(properties.negativeValueConfiguration), NullValueFormatConfiguration: cfnTemplateNullValueFormatConfigurationPropertyToCloudFormation(properties.nullValueFormatConfiguration), NumberScale: cdk.stringToCloudFormation(properties.numberScale), Prefix: cdk.stringToCloudFormation(properties.prefix), SeparatorConfiguration: cfnTemplateNumericSeparatorConfigurationPropertyToCloudFormation(properties.separatorConfiguration), Suffix: cdk.stringToCloudFormation(properties.suffix), Symbol: cdk.stringToCloudFormation(properties.symbol) }) : properties;
    }
    function CfnTemplateCurrencyDisplayFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("decimalPlacesConfiguration", "DecimalPlacesConfiguration", properties.DecimalPlacesConfiguration != null ? CfnTemplateDecimalPlacesConfigurationPropertyFromCloudFormation(properties.DecimalPlacesConfiguration) : void 0), ret.addPropertyResult("negativeValueConfiguration", "NegativeValueConfiguration", properties.NegativeValueConfiguration != null ? CfnTemplateNegativeValueConfigurationPropertyFromCloudFormation(properties.NegativeValueConfiguration) : void 0), ret.addPropertyResult("nullValueFormatConfiguration", "NullValueFormatConfiguration", properties.NullValueFormatConfiguration != null ? CfnTemplateNullValueFormatConfigurationPropertyFromCloudFormation(properties.NullValueFormatConfiguration) : void 0), ret.addPropertyResult("numberScale", "NumberScale", properties.NumberScale != null ? cfn_parse.FromCloudFormation.getString(properties.NumberScale) : void 0), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addPropertyResult("separatorConfiguration", "SeparatorConfiguration", properties.SeparatorConfiguration != null ? CfnTemplateNumericSeparatorConfigurationPropertyFromCloudFormation(properties.SeparatorConfiguration) : void 0), ret.addPropertyResult("suffix", "Suffix", properties.Suffix != null ? cfn_parse.FromCloudFormation.getString(properties.Suffix) : void 0), ret.addPropertyResult("symbol", "Symbol", properties.Symbol != null ? cfn_parse.FromCloudFormation.getString(properties.Symbol) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_CustomActionFilterOperationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("selectedFieldsConfiguration", cdk.requiredValidator)(properties.selectedFieldsConfiguration)), errors.collect(cdk.propertyValidator("selectedFieldsConfiguration", CfnTemplate_FilterOperationSelectedFieldsConfigurationPropertyValidator)(properties.selectedFieldsConfiguration)), errors.collect(cdk.propertyValidator("targetVisualsConfiguration", cdk.requiredValidator)(properties.targetVisualsConfiguration)), errors.collect(cdk.propertyValidator("targetVisualsConfiguration", CfnTemplate_FilterOperationTargetVisualsConfigurationPropertyValidator)(properties.targetVisualsConfiguration)), errors.wrap('supplied properties not correct for "CustomActionFilterOperationProperty"');
    }
    function cfnTemplateCustomActionFilterOperationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_CustomActionFilterOperationPropertyValidator(properties).assertSuccess(), { SelectedFieldsConfiguration: cfnTemplateFilterOperationSelectedFieldsConfigurationPropertyToCloudFormation(properties.selectedFieldsConfiguration), TargetVisualsConfiguration: cfnTemplateFilterOperationTargetVisualsConfigurationPropertyToCloudFormation(properties.targetVisualsConfiguration) }) : properties;
    }
    function CfnTemplateCustomActionFilterOperationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("selectedFieldsConfiguration", "SelectedFieldsConfiguration", CfnTemplateFilterOperationSelectedFieldsConfigurationPropertyFromCloudFormation(properties.SelectedFieldsConfiguration)), ret.addPropertyResult("targetVisualsConfiguration", "TargetVisualsConfiguration", CfnTemplateFilterOperationTargetVisualsConfigurationPropertyFromCloudFormation(properties.TargetVisualsConfiguration)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_CustomActionNavigationOperationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("localNavigationConfiguration", CfnTemplate_LocalNavigationConfigurationPropertyValidator)(properties.localNavigationConfiguration)), errors.wrap('supplied properties not correct for "CustomActionNavigationOperationProperty"');
    }
    function cfnTemplateCustomActionNavigationOperationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_CustomActionNavigationOperationPropertyValidator(properties).assertSuccess(), { LocalNavigationConfiguration: cfnTemplateLocalNavigationConfigurationPropertyToCloudFormation(properties.localNavigationConfiguration) }) : properties;
    }
    function CfnTemplateCustomActionNavigationOperationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("localNavigationConfiguration", "LocalNavigationConfiguration", properties.LocalNavigationConfiguration != null ? CfnTemplateLocalNavigationConfigurationPropertyFromCloudFormation(properties.LocalNavigationConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_CustomActionSetParametersOperationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("parameterValueConfigurations", cdk.requiredValidator)(properties.parameterValueConfigurations)), errors.collect(cdk.propertyValidator("parameterValueConfigurations", cdk.listValidator(CfnTemplate_SetParameterValueConfigurationPropertyValidator))(properties.parameterValueConfigurations)), errors.wrap('supplied properties not correct for "CustomActionSetParametersOperationProperty"');
    }
    function cfnTemplateCustomActionSetParametersOperationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_CustomActionSetParametersOperationPropertyValidator(properties).assertSuccess(), { ParameterValueConfigurations: cdk.listMapper(cfnTemplateSetParameterValueConfigurationPropertyToCloudFormation)(properties.parameterValueConfigurations) }) : properties;
    }
    function CfnTemplateCustomActionSetParametersOperationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("parameterValueConfigurations", "ParameterValueConfigurations", cfn_parse.FromCloudFormation.getArray(CfnTemplateSetParameterValueConfigurationPropertyFromCloudFormation)(properties.ParameterValueConfigurations)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_CustomActionURLOperationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("urlTarget", cdk.requiredValidator)(properties.urlTarget)), errors.collect(cdk.propertyValidator("urlTarget", cdk.validateString)(properties.urlTarget)), errors.collect(cdk.propertyValidator("urlTemplate", cdk.requiredValidator)(properties.urlTemplate)), errors.collect(cdk.propertyValidator("urlTemplate", cdk.validateString)(properties.urlTemplate)), errors.wrap('supplied properties not correct for "CustomActionURLOperationProperty"');
    }
    function cfnTemplateCustomActionURLOperationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_CustomActionURLOperationPropertyValidator(properties).assertSuccess(), { URLTarget: cdk.stringToCloudFormation(properties.urlTarget), URLTemplate: cdk.stringToCloudFormation(properties.urlTemplate) }) : properties;
    }
    function CfnTemplateCustomActionURLOperationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("urlTarget", "URLTarget", cfn_parse.FromCloudFormation.getString(properties.URLTarget)), ret.addPropertyResult("urlTemplate", "URLTemplate", cfn_parse.FromCloudFormation.getString(properties.URLTemplate)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_CustomColorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.requiredValidator)(properties.color)), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.collect(cdk.propertyValidator("fieldValue", cdk.validateString)(properties.fieldValue)), errors.collect(cdk.propertyValidator("specialValue", cdk.validateString)(properties.specialValue)), errors.wrap('supplied properties not correct for "CustomColorProperty"');
    }
    function cfnTemplateCustomColorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_CustomColorPropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color), FieldValue: cdk.stringToCloudFormation(properties.fieldValue), SpecialValue: cdk.stringToCloudFormation(properties.specialValue) }) : properties;
    }
    function CfnTemplateCustomColorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", cfn_parse.FromCloudFormation.getString(properties.Color)), ret.addPropertyResult("fieldValue", "FieldValue", properties.FieldValue != null ? cfn_parse.FromCloudFormation.getString(properties.FieldValue) : void 0), ret.addPropertyResult("specialValue", "SpecialValue", properties.SpecialValue != null ? cfn_parse.FromCloudFormation.getString(properties.SpecialValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_CustomContentConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contentType", cdk.validateString)(properties.contentType)), errors.collect(cdk.propertyValidator("contentUrl", cdk.validateString)(properties.contentUrl)), errors.collect(cdk.propertyValidator("imageScaling", cdk.validateString)(properties.imageScaling)), errors.wrap('supplied properties not correct for "CustomContentConfigurationProperty"');
    }
    function cfnTemplateCustomContentConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_CustomContentConfigurationPropertyValidator(properties).assertSuccess(), { ContentType: cdk.stringToCloudFormation(properties.contentType), ContentUrl: cdk.stringToCloudFormation(properties.contentUrl), ImageScaling: cdk.stringToCloudFormation(properties.imageScaling) }) : properties;
    }
    function CfnTemplateCustomContentConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contentType", "ContentType", properties.ContentType != null ? cfn_parse.FromCloudFormation.getString(properties.ContentType) : void 0), ret.addPropertyResult("contentUrl", "ContentUrl", properties.ContentUrl != null ? cfn_parse.FromCloudFormation.getString(properties.ContentUrl) : void 0), ret.addPropertyResult("imageScaling", "ImageScaling", properties.ImageScaling != null ? cfn_parse.FromCloudFormation.getString(properties.ImageScaling) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_CustomContentVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnTemplate_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnTemplate_CustomContentConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.requiredValidator)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.validateString)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("subtitle", CfnTemplate_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnTemplate_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "CustomContentVisualProperty"');
    }
    function cfnTemplateCustomContentVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_CustomContentVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnTemplateVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnTemplateCustomContentConfigurationPropertyToCloudFormation(properties.chartConfiguration), DataSetIdentifier: cdk.stringToCloudFormation(properties.dataSetIdentifier), Subtitle: cfnTemplateVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnTemplateVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnTemplateCustomContentVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnTemplateCustomContentConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("dataSetIdentifier", "DataSetIdentifier", cfn_parse.FromCloudFormation.getString(properties.DataSetIdentifier)), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnTemplateVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnTemplateVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_CustomFilterConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryValue", cdk.validateString)(properties.categoryValue)), errors.collect(cdk.propertyValidator("matchOperator", cdk.requiredValidator)(properties.matchOperator)), errors.collect(cdk.propertyValidator("matchOperator", cdk.validateString)(properties.matchOperator)), errors.collect(cdk.propertyValidator("nullOption", cdk.requiredValidator)(properties.nullOption)), errors.collect(cdk.propertyValidator("nullOption", cdk.validateString)(properties.nullOption)), errors.collect(cdk.propertyValidator("parameterName", cdk.validateString)(properties.parameterName)), errors.collect(cdk.propertyValidator("selectAllOptions", cdk.validateString)(properties.selectAllOptions)), errors.wrap('supplied properties not correct for "CustomFilterConfigurationProperty"');
    }
    function cfnTemplateCustomFilterConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_CustomFilterConfigurationPropertyValidator(properties).assertSuccess(), { CategoryValue: cdk.stringToCloudFormation(properties.categoryValue), MatchOperator: cdk.stringToCloudFormation(properties.matchOperator), NullOption: cdk.stringToCloudFormation(properties.nullOption), ParameterName: cdk.stringToCloudFormation(properties.parameterName), SelectAllOptions: cdk.stringToCloudFormation(properties.selectAllOptions) }) : properties;
    }
    function CfnTemplateCustomFilterConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryValue", "CategoryValue", properties.CategoryValue != null ? cfn_parse.FromCloudFormation.getString(properties.CategoryValue) : void 0), ret.addPropertyResult("matchOperator", "MatchOperator", cfn_parse.FromCloudFormation.getString(properties.MatchOperator)), ret.addPropertyResult("nullOption", "NullOption", cfn_parse.FromCloudFormation.getString(properties.NullOption)), ret.addPropertyResult("parameterName", "ParameterName", properties.ParameterName != null ? cfn_parse.FromCloudFormation.getString(properties.ParameterName) : void 0), ret.addPropertyResult("selectAllOptions", "SelectAllOptions", properties.SelectAllOptions != null ? cfn_parse.FromCloudFormation.getString(properties.SelectAllOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_CustomFilterListConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryValues", cdk.listValidator(cdk.validateString))(properties.categoryValues)), errors.collect(cdk.propertyValidator("matchOperator", cdk.requiredValidator)(properties.matchOperator)), errors.collect(cdk.propertyValidator("matchOperator", cdk.validateString)(properties.matchOperator)), errors.collect(cdk.propertyValidator("nullOption", cdk.requiredValidator)(properties.nullOption)), errors.collect(cdk.propertyValidator("nullOption", cdk.validateString)(properties.nullOption)), errors.collect(cdk.propertyValidator("selectAllOptions", cdk.validateString)(properties.selectAllOptions)), errors.wrap('supplied properties not correct for "CustomFilterListConfigurationProperty"');
    }
    function cfnTemplateCustomFilterListConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_CustomFilterListConfigurationPropertyValidator(properties).assertSuccess(), { CategoryValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.categoryValues), MatchOperator: cdk.stringToCloudFormation(properties.matchOperator), NullOption: cdk.stringToCloudFormation(properties.nullOption), SelectAllOptions: cdk.stringToCloudFormation(properties.selectAllOptions) }) : properties;
    }
    function CfnTemplateCustomFilterListConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryValues", "CategoryValues", properties.CategoryValues != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CategoryValues) : void 0), ret.addPropertyResult("matchOperator", "MatchOperator", cfn_parse.FromCloudFormation.getString(properties.MatchOperator)), ret.addPropertyResult("nullOption", "NullOption", cfn_parse.FromCloudFormation.getString(properties.NullOption)), ret.addPropertyResult("selectAllOptions", "SelectAllOptions", properties.SelectAllOptions != null ? cfn_parse.FromCloudFormation.getString(properties.SelectAllOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_CustomNarrativeOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("narrative", cdk.requiredValidator)(properties.narrative)), errors.collect(cdk.propertyValidator("narrative", cdk.validateString)(properties.narrative)), errors.wrap('supplied properties not correct for "CustomNarrativeOptionsProperty"');
    }
    function cfnTemplateCustomNarrativeOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_CustomNarrativeOptionsPropertyValidator(properties).assertSuccess(), { Narrative: cdk.stringToCloudFormation(properties.narrative) }) : properties;
    }
    function CfnTemplateCustomNarrativeOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("narrative", "Narrative", cfn_parse.FromCloudFormation.getString(properties.Narrative)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_CustomParameterValuesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateTimeValues", cdk.listValidator(cdk.validateString))(properties.dateTimeValues)), errors.collect(cdk.propertyValidator("decimalValues", cdk.listValidator(cdk.validateNumber))(properties.decimalValues)), errors.collect(cdk.propertyValidator("integerValues", cdk.listValidator(cdk.validateNumber))(properties.integerValues)), errors.collect(cdk.propertyValidator("stringValues", cdk.listValidator(cdk.validateString))(properties.stringValues)), errors.wrap('supplied properties not correct for "CustomParameterValuesProperty"');
    }
    function cfnTemplateCustomParameterValuesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_CustomParameterValuesPropertyValidator(properties).assertSuccess(), { DateTimeValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.dateTimeValues), DecimalValues: cdk.listMapper(cdk.numberToCloudFormation)(properties.decimalValues), IntegerValues: cdk.listMapper(cdk.numberToCloudFormation)(properties.integerValues), StringValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.stringValues) }) : properties;
    }
    function CfnTemplateCustomParameterValuesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateTimeValues", "DateTimeValues", properties.DateTimeValues != null ? cfn_parse.FromCloudFormation.getStringArray(properties.DateTimeValues) : void 0), ret.addPropertyResult("decimalValues", "DecimalValues", properties.DecimalValues != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getNumber)(properties.DecimalValues) : void 0), ret.addPropertyResult("integerValues", "IntegerValues", properties.IntegerValues != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getNumber)(properties.IntegerValues) : void 0), ret.addPropertyResult("stringValues", "StringValues", properties.StringValues != null ? cfn_parse.FromCloudFormation.getStringArray(properties.StringValues) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_CustomValuesConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customValues", cdk.requiredValidator)(properties.customValues)), errors.collect(cdk.propertyValidator("customValues", CfnTemplate_CustomParameterValuesPropertyValidator)(properties.customValues)), errors.collect(cdk.propertyValidator("includeNullValue", cdk.validateBoolean)(properties.includeNullValue)), errors.wrap('supplied properties not correct for "CustomValuesConfigurationProperty"');
    }
    function cfnTemplateCustomValuesConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_CustomValuesConfigurationPropertyValidator(properties).assertSuccess(), { CustomValues: cfnTemplateCustomParameterValuesPropertyToCloudFormation(properties.customValues), IncludeNullValue: cdk.booleanToCloudFormation(properties.includeNullValue) }) : properties;
    }
    function CfnTemplateCustomValuesConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customValues", "CustomValues", CfnTemplateCustomParameterValuesPropertyFromCloudFormation(properties.CustomValues)), ret.addPropertyResult("includeNullValue", "IncludeNullValue", properties.IncludeNullValue != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeNullValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DataBarsOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("negativeColor", cdk.validateString)(properties.negativeColor)), errors.collect(cdk.propertyValidator("positiveColor", cdk.validateString)(properties.positiveColor)), errors.wrap('supplied properties not correct for "DataBarsOptionsProperty"');
    }
    function cfnTemplateDataBarsOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DataBarsOptionsPropertyValidator(properties).assertSuccess(), { FieldId: cdk.stringToCloudFormation(properties.fieldId), NegativeColor: cdk.stringToCloudFormation(properties.negativeColor), PositiveColor: cdk.stringToCloudFormation(properties.positiveColor) }) : properties;
    }
    function CfnTemplateDataBarsOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("negativeColor", "NegativeColor", properties.NegativeColor != null ? cfn_parse.FromCloudFormation.getString(properties.NegativeColor) : void 0), ret.addPropertyResult("positiveColor", "PositiveColor", properties.PositiveColor != null ? cfn_parse.FromCloudFormation.getString(properties.PositiveColor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DataColorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.collect(cdk.propertyValidator("dataValue", cdk.validateNumber)(properties.dataValue)), errors.wrap('supplied properties not correct for "DataColorProperty"');
    }
    function cfnTemplateDataColorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DataColorPropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color), DataValue: cdk.numberToCloudFormation(properties.dataValue) }) : properties;
    }
    function CfnTemplateDataColorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", properties.Color != null ? cfn_parse.FromCloudFormation.getString(properties.Color) : void 0), ret.addPropertyResult("dataValue", "DataValue", properties.DataValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.DataValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DataFieldSeriesItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("axisBinding", cdk.requiredValidator)(properties.axisBinding)), errors.collect(cdk.propertyValidator("axisBinding", cdk.validateString)(properties.axisBinding)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldValue", cdk.validateString)(properties.fieldValue)), errors.collect(cdk.propertyValidator("settings", CfnTemplate_LineChartSeriesSettingsPropertyValidator)(properties.settings)), errors.wrap('supplied properties not correct for "DataFieldSeriesItemProperty"');
    }
    function cfnTemplateDataFieldSeriesItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DataFieldSeriesItemPropertyValidator(properties).assertSuccess(), { AxisBinding: cdk.stringToCloudFormation(properties.axisBinding), FieldId: cdk.stringToCloudFormation(properties.fieldId), FieldValue: cdk.stringToCloudFormation(properties.fieldValue), Settings: cfnTemplateLineChartSeriesSettingsPropertyToCloudFormation(properties.settings) }) : properties;
    }
    function CfnTemplateDataFieldSeriesItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("axisBinding", "AxisBinding", cfn_parse.FromCloudFormation.getString(properties.AxisBinding)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("fieldValue", "FieldValue", properties.FieldValue != null ? cfn_parse.FromCloudFormation.getString(properties.FieldValue) : void 0), ret.addPropertyResult("settings", "Settings", properties.Settings != null ? CfnTemplateLineChartSeriesSettingsPropertyFromCloudFormation(properties.Settings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DataLabelOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryLabelVisibility", cdk.validateString)(properties.categoryLabelVisibility)), errors.collect(cdk.propertyValidator("dataLabelTypes", cdk.listValidator(CfnTemplate_DataLabelTypePropertyValidator))(properties.dataLabelTypes)), errors.collect(cdk.propertyValidator("labelColor", cdk.validateString)(properties.labelColor)), errors.collect(cdk.propertyValidator("labelContent", cdk.validateString)(properties.labelContent)), errors.collect(cdk.propertyValidator("labelFontConfiguration", CfnTemplate_FontConfigurationPropertyValidator)(properties.labelFontConfiguration)), errors.collect(cdk.propertyValidator("measureLabelVisibility", cdk.validateString)(properties.measureLabelVisibility)), errors.collect(cdk.propertyValidator("overlap", cdk.validateString)(properties.overlap)), errors.collect(cdk.propertyValidator("position", cdk.validateString)(properties.position)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "DataLabelOptionsProperty"');
    }
    function cfnTemplateDataLabelOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DataLabelOptionsPropertyValidator(properties).assertSuccess(), { CategoryLabelVisibility: cdk.stringToCloudFormation(properties.categoryLabelVisibility), DataLabelTypes: cdk.listMapper(cfnTemplateDataLabelTypePropertyToCloudFormation)(properties.dataLabelTypes), LabelColor: cdk.stringToCloudFormation(properties.labelColor), LabelContent: cdk.stringToCloudFormation(properties.labelContent), LabelFontConfiguration: cfnTemplateFontConfigurationPropertyToCloudFormation(properties.labelFontConfiguration), MeasureLabelVisibility: cdk.stringToCloudFormation(properties.measureLabelVisibility), Overlap: cdk.stringToCloudFormation(properties.overlap), Position: cdk.stringToCloudFormation(properties.position), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnTemplateDataLabelOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryLabelVisibility", "CategoryLabelVisibility", properties.CategoryLabelVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.CategoryLabelVisibility) : void 0), ret.addPropertyResult("dataLabelTypes", "DataLabelTypes", properties.DataLabelTypes != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDataLabelTypePropertyFromCloudFormation)(properties.DataLabelTypes) : void 0), ret.addPropertyResult("labelColor", "LabelColor", properties.LabelColor != null ? cfn_parse.FromCloudFormation.getString(properties.LabelColor) : void 0), ret.addPropertyResult("labelContent", "LabelContent", properties.LabelContent != null ? cfn_parse.FromCloudFormation.getString(properties.LabelContent) : void 0), ret.addPropertyResult("labelFontConfiguration", "LabelFontConfiguration", properties.LabelFontConfiguration != null ? CfnTemplateFontConfigurationPropertyFromCloudFormation(properties.LabelFontConfiguration) : void 0), ret.addPropertyResult("measureLabelVisibility", "MeasureLabelVisibility", properties.MeasureLabelVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.MeasureLabelVisibility) : void 0), ret.addPropertyResult("overlap", "Overlap", properties.Overlap != null ? cfn_parse.FromCloudFormation.getString(properties.Overlap) : void 0), ret.addPropertyResult("position", "Position", properties.Position != null ? cfn_parse.FromCloudFormation.getString(properties.Position) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DataLabelTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataPathLabelType", CfnTemplate_DataPathLabelTypePropertyValidator)(properties.dataPathLabelType)), errors.collect(cdk.propertyValidator("fieldLabelType", CfnTemplate_FieldLabelTypePropertyValidator)(properties.fieldLabelType)), errors.collect(cdk.propertyValidator("maximumLabelType", CfnTemplate_MaximumLabelTypePropertyValidator)(properties.maximumLabelType)), errors.collect(cdk.propertyValidator("minimumLabelType", CfnTemplate_MinimumLabelTypePropertyValidator)(properties.minimumLabelType)), errors.collect(cdk.propertyValidator("rangeEndsLabelType", CfnTemplate_RangeEndsLabelTypePropertyValidator)(properties.rangeEndsLabelType)), errors.wrap('supplied properties not correct for "DataLabelTypeProperty"');
    }
    function cfnTemplateDataLabelTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DataLabelTypePropertyValidator(properties).assertSuccess(), { DataPathLabelType: cfnTemplateDataPathLabelTypePropertyToCloudFormation(properties.dataPathLabelType), FieldLabelType: cfnTemplateFieldLabelTypePropertyToCloudFormation(properties.fieldLabelType), MaximumLabelType: cfnTemplateMaximumLabelTypePropertyToCloudFormation(properties.maximumLabelType), MinimumLabelType: cfnTemplateMinimumLabelTypePropertyToCloudFormation(properties.minimumLabelType), RangeEndsLabelType: cfnTemplateRangeEndsLabelTypePropertyToCloudFormation(properties.rangeEndsLabelType) }) : properties;
    }
    function CfnTemplateDataLabelTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataPathLabelType", "DataPathLabelType", properties.DataPathLabelType != null ? CfnTemplateDataPathLabelTypePropertyFromCloudFormation(properties.DataPathLabelType) : void 0), ret.addPropertyResult("fieldLabelType", "FieldLabelType", properties.FieldLabelType != null ? CfnTemplateFieldLabelTypePropertyFromCloudFormation(properties.FieldLabelType) : void 0), ret.addPropertyResult("maximumLabelType", "MaximumLabelType", properties.MaximumLabelType != null ? CfnTemplateMaximumLabelTypePropertyFromCloudFormation(properties.MaximumLabelType) : void 0), ret.addPropertyResult("minimumLabelType", "MinimumLabelType", properties.MinimumLabelType != null ? CfnTemplateMinimumLabelTypePropertyFromCloudFormation(properties.MinimumLabelType) : void 0), ret.addPropertyResult("rangeEndsLabelType", "RangeEndsLabelType", properties.RangeEndsLabelType != null ? CfnTemplateRangeEndsLabelTypePropertyFromCloudFormation(properties.RangeEndsLabelType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DataPathColorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.requiredValidator)(properties.color)), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.collect(cdk.propertyValidator("element", cdk.requiredValidator)(properties.element)), errors.collect(cdk.propertyValidator("element", CfnTemplate_DataPathValuePropertyValidator)(properties.element)), errors.collect(cdk.propertyValidator("timeGranularity", cdk.validateString)(properties.timeGranularity)), errors.wrap('supplied properties not correct for "DataPathColorProperty"');
    }
    function cfnTemplateDataPathColorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DataPathColorPropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color), Element: cfnTemplateDataPathValuePropertyToCloudFormation(properties.element), TimeGranularity: cdk.stringToCloudFormation(properties.timeGranularity) }) : properties;
    }
    function CfnTemplateDataPathColorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", cfn_parse.FromCloudFormation.getString(properties.Color)), ret.addPropertyResult("element", "Element", CfnTemplateDataPathValuePropertyFromCloudFormation(properties.Element)), ret.addPropertyResult("timeGranularity", "TimeGranularity", properties.TimeGranularity != null ? cfn_parse.FromCloudFormation.getString(properties.TimeGranularity) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DataPathLabelTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldValue", cdk.validateString)(properties.fieldValue)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "DataPathLabelTypeProperty"');
    }
    function cfnTemplateDataPathLabelTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DataPathLabelTypePropertyValidator(properties).assertSuccess(), { FieldId: cdk.stringToCloudFormation(properties.fieldId), FieldValue: cdk.stringToCloudFormation(properties.fieldValue), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnTemplateDataPathLabelTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldId", "FieldId", properties.FieldId != null ? cfn_parse.FromCloudFormation.getString(properties.FieldId) : void 0), ret.addPropertyResult("fieldValue", "FieldValue", properties.FieldValue != null ? cfn_parse.FromCloudFormation.getString(properties.FieldValue) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DataPathSortPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("direction", cdk.requiredValidator)(properties.direction)), errors.collect(cdk.propertyValidator("direction", cdk.validateString)(properties.direction)), errors.collect(cdk.propertyValidator("sortPaths", cdk.requiredValidator)(properties.sortPaths)), errors.collect(cdk.propertyValidator("sortPaths", cdk.listValidator(CfnTemplate_DataPathValuePropertyValidator))(properties.sortPaths)), errors.wrap('supplied properties not correct for "DataPathSortProperty"');
    }
    function cfnTemplateDataPathSortPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DataPathSortPropertyValidator(properties).assertSuccess(), { Direction: cdk.stringToCloudFormation(properties.direction), SortPaths: cdk.listMapper(cfnTemplateDataPathValuePropertyToCloudFormation)(properties.sortPaths) }) : properties;
    }
    function CfnTemplateDataPathSortPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("direction", "Direction", cfn_parse.FromCloudFormation.getString(properties.Direction)), ret.addPropertyResult("sortPaths", "SortPaths", cfn_parse.FromCloudFormation.getArray(CfnTemplateDataPathValuePropertyFromCloudFormation)(properties.SortPaths)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DataPathValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldValue", cdk.requiredValidator)(properties.fieldValue)), errors.collect(cdk.propertyValidator("fieldValue", cdk.validateString)(properties.fieldValue)), errors.wrap('supplied properties not correct for "DataPathValueProperty"');
    }
    function cfnTemplateDataPathValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DataPathValuePropertyValidator(properties).assertSuccess(), { FieldId: cdk.stringToCloudFormation(properties.fieldId), FieldValue: cdk.stringToCloudFormation(properties.fieldValue) }) : properties;
    }
    function CfnTemplateDataPathValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("fieldValue", "FieldValue", cfn_parse.FromCloudFormation.getString(properties.FieldValue)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DataSetConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnGroupSchemaList", cdk.listValidator(CfnTemplate_ColumnGroupSchemaPropertyValidator))(properties.columnGroupSchemaList)), errors.collect(cdk.propertyValidator("dataSetSchema", CfnTemplate_DataSetSchemaPropertyValidator)(properties.dataSetSchema)), errors.collect(cdk.propertyValidator("placeholder", cdk.validateString)(properties.placeholder)), errors.wrap('supplied properties not correct for "DataSetConfigurationProperty"');
    }
    function cfnTemplateDataSetConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DataSetConfigurationPropertyValidator(properties).assertSuccess(), { ColumnGroupSchemaList: cdk.listMapper(cfnTemplateColumnGroupSchemaPropertyToCloudFormation)(properties.columnGroupSchemaList), DataSetSchema: cfnTemplateDataSetSchemaPropertyToCloudFormation(properties.dataSetSchema), Placeholder: cdk.stringToCloudFormation(properties.placeholder) }) : properties;
    }
    function CfnTemplateDataSetConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columnGroupSchemaList", "ColumnGroupSchemaList", properties.ColumnGroupSchemaList != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateColumnGroupSchemaPropertyFromCloudFormation)(properties.ColumnGroupSchemaList) : void 0), ret.addPropertyResult("dataSetSchema", "DataSetSchema", properties.DataSetSchema != null ? CfnTemplateDataSetSchemaPropertyFromCloudFormation(properties.DataSetSchema) : void 0), ret.addPropertyResult("placeholder", "Placeholder", properties.Placeholder != null ? cfn_parse.FromCloudFormation.getString(properties.Placeholder) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DataSetReferencePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataSetArn", cdk.requiredValidator)(properties.dataSetArn)), errors.collect(cdk.propertyValidator("dataSetArn", cdk.validateString)(properties.dataSetArn)), errors.collect(cdk.propertyValidator("dataSetPlaceholder", cdk.requiredValidator)(properties.dataSetPlaceholder)), errors.collect(cdk.propertyValidator("dataSetPlaceholder", cdk.validateString)(properties.dataSetPlaceholder)), errors.wrap('supplied properties not correct for "DataSetReferenceProperty"');
    }
    function cfnTemplateDataSetReferencePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DataSetReferencePropertyValidator(properties).assertSuccess(), { DataSetArn: cdk.stringToCloudFormation(properties.dataSetArn), DataSetPlaceholder: cdk.stringToCloudFormation(properties.dataSetPlaceholder) }) : properties;
    }
    function CfnTemplateDataSetReferencePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataSetArn", "DataSetArn", cfn_parse.FromCloudFormation.getString(properties.DataSetArn)), ret.addPropertyResult("dataSetPlaceholder", "DataSetPlaceholder", cfn_parse.FromCloudFormation.getString(properties.DataSetPlaceholder)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DataSetSchemaPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnSchemaList", cdk.listValidator(CfnTemplate_ColumnSchemaPropertyValidator))(properties.columnSchemaList)), errors.wrap('supplied properties not correct for "DataSetSchemaProperty"');
    }
    function cfnTemplateDataSetSchemaPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DataSetSchemaPropertyValidator(properties).assertSuccess(), { ColumnSchemaList: cdk.listMapper(cfnTemplateColumnSchemaPropertyToCloudFormation)(properties.columnSchemaList) }) : properties;
    }
    function CfnTemplateDataSetSchemaPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columnSchemaList", "ColumnSchemaList", properties.ColumnSchemaList != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateColumnSchemaPropertyFromCloudFormation)(properties.ColumnSchemaList) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DateAxisOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("missingDateVisibility", cdk.validateString)(properties.missingDateVisibility)), errors.wrap('supplied properties not correct for "DateAxisOptionsProperty"');
    }
    function cfnTemplateDateAxisOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DateAxisOptionsPropertyValidator(properties).assertSuccess(), { MissingDateVisibility: cdk.stringToCloudFormation(properties.missingDateVisibility) }) : properties;
    }
    function CfnTemplateDateAxisOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("missingDateVisibility", "MissingDateVisibility", properties.MissingDateVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.MissingDateVisibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DateDimensionFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnTemplate_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("dateGranularity", cdk.validateString)(properties.dateGranularity)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("formatConfiguration", CfnTemplate_DateTimeFormatConfigurationPropertyValidator)(properties.formatConfiguration)), errors.collect(cdk.propertyValidator("hierarchyId", cdk.validateString)(properties.hierarchyId)), errors.wrap('supplied properties not correct for "DateDimensionFieldProperty"');
    }
    function cfnTemplateDateDimensionFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DateDimensionFieldPropertyValidator(properties).assertSuccess(), { Column: cfnTemplateColumnIdentifierPropertyToCloudFormation(properties.column), DateGranularity: cdk.stringToCloudFormation(properties.dateGranularity), FieldId: cdk.stringToCloudFormation(properties.fieldId), FormatConfiguration: cfnTemplateDateTimeFormatConfigurationPropertyToCloudFormation(properties.formatConfiguration), HierarchyId: cdk.stringToCloudFormation(properties.hierarchyId) }) : properties;
    }
    function CfnTemplateDateDimensionFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", CfnTemplateColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("dateGranularity", "DateGranularity", properties.DateGranularity != null ? cfn_parse.FromCloudFormation.getString(properties.DateGranularity) : void 0), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("formatConfiguration", "FormatConfiguration", properties.FormatConfiguration != null ? CfnTemplateDateTimeFormatConfigurationPropertyFromCloudFormation(properties.FormatConfiguration) : void 0), ret.addPropertyResult("hierarchyId", "HierarchyId", properties.HierarchyId != null ? cfn_parse.FromCloudFormation.getString(properties.HierarchyId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DateMeasureFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationFunction", cdk.validateString)(properties.aggregationFunction)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnTemplate_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("formatConfiguration", CfnTemplate_DateTimeFormatConfigurationPropertyValidator)(properties.formatConfiguration)), errors.wrap('supplied properties not correct for "DateMeasureFieldProperty"');
    }
    function cfnTemplateDateMeasureFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DateMeasureFieldPropertyValidator(properties).assertSuccess(), { AggregationFunction: cdk.stringToCloudFormation(properties.aggregationFunction), Column: cfnTemplateColumnIdentifierPropertyToCloudFormation(properties.column), FieldId: cdk.stringToCloudFormation(properties.fieldId), FormatConfiguration: cfnTemplateDateTimeFormatConfigurationPropertyToCloudFormation(properties.formatConfiguration) }) : properties;
    }
    function CfnTemplateDateMeasureFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationFunction", "AggregationFunction", properties.AggregationFunction != null ? cfn_parse.FromCloudFormation.getString(properties.AggregationFunction) : void 0), ret.addPropertyResult("column", "Column", CfnTemplateColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("formatConfiguration", "FormatConfiguration", properties.FormatConfiguration != null ? CfnTemplateDateTimeFormatConfigurationPropertyFromCloudFormation(properties.FormatConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DateTimeDefaultValuesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dynamicValue", CfnTemplate_DynamicDefaultValuePropertyValidator)(properties.dynamicValue)), errors.collect(cdk.propertyValidator("rollingDate", CfnTemplate_RollingDateConfigurationPropertyValidator)(properties.rollingDate)), errors.collect(cdk.propertyValidator("staticValues", cdk.listValidator(cdk.validateString))(properties.staticValues)), errors.wrap('supplied properties not correct for "DateTimeDefaultValuesProperty"');
    }
    function cfnTemplateDateTimeDefaultValuesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DateTimeDefaultValuesPropertyValidator(properties).assertSuccess(), { DynamicValue: cfnTemplateDynamicDefaultValuePropertyToCloudFormation(properties.dynamicValue), RollingDate: cfnTemplateRollingDateConfigurationPropertyToCloudFormation(properties.rollingDate), StaticValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.staticValues) }) : properties;
    }
    function CfnTemplateDateTimeDefaultValuesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dynamicValue", "DynamicValue", properties.DynamicValue != null ? CfnTemplateDynamicDefaultValuePropertyFromCloudFormation(properties.DynamicValue) : void 0), ret.addPropertyResult("rollingDate", "RollingDate", properties.RollingDate != null ? CfnTemplateRollingDateConfigurationPropertyFromCloudFormation(properties.RollingDate) : void 0), ret.addPropertyResult("staticValues", "StaticValues", properties.StaticValues != null ? cfn_parse.FromCloudFormation.getStringArray(properties.StaticValues) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DateTimeFormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateTimeFormat", cdk.validateString)(properties.dateTimeFormat)), errors.collect(cdk.propertyValidator("nullValueFormatConfiguration", CfnTemplate_NullValueFormatConfigurationPropertyValidator)(properties.nullValueFormatConfiguration)), errors.collect(cdk.propertyValidator("numericFormatConfiguration", CfnTemplate_NumericFormatConfigurationPropertyValidator)(properties.numericFormatConfiguration)), errors.wrap('supplied properties not correct for "DateTimeFormatConfigurationProperty"');
    }
    function cfnTemplateDateTimeFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DateTimeFormatConfigurationPropertyValidator(properties).assertSuccess(), { DateTimeFormat: cdk.stringToCloudFormation(properties.dateTimeFormat), NullValueFormatConfiguration: cfnTemplateNullValueFormatConfigurationPropertyToCloudFormation(properties.nullValueFormatConfiguration), NumericFormatConfiguration: cfnTemplateNumericFormatConfigurationPropertyToCloudFormation(properties.numericFormatConfiguration) }) : properties;
    }
    function CfnTemplateDateTimeFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateTimeFormat", "DateTimeFormat", properties.DateTimeFormat != null ? cfn_parse.FromCloudFormation.getString(properties.DateTimeFormat) : void 0), ret.addPropertyResult("nullValueFormatConfiguration", "NullValueFormatConfiguration", properties.NullValueFormatConfiguration != null ? CfnTemplateNullValueFormatConfigurationPropertyFromCloudFormation(properties.NullValueFormatConfiguration) : void 0), ret.addPropertyResult("numericFormatConfiguration", "NumericFormatConfiguration", properties.NumericFormatConfiguration != null ? CfnTemplateNumericFormatConfigurationPropertyFromCloudFormation(properties.NumericFormatConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DateTimeHierarchyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("drillDownFilters", cdk.listValidator(CfnTemplate_DrillDownFilterPropertyValidator))(properties.drillDownFilters)), errors.collect(cdk.propertyValidator("hierarchyId", cdk.requiredValidator)(properties.hierarchyId)), errors.collect(cdk.propertyValidator("hierarchyId", cdk.validateString)(properties.hierarchyId)), errors.wrap('supplied properties not correct for "DateTimeHierarchyProperty"');
    }
    function cfnTemplateDateTimeHierarchyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DateTimeHierarchyPropertyValidator(properties).assertSuccess(), { DrillDownFilters: cdk.listMapper(cfnTemplateDrillDownFilterPropertyToCloudFormation)(properties.drillDownFilters), HierarchyId: cdk.stringToCloudFormation(properties.hierarchyId) }) : properties;
    }
    function CfnTemplateDateTimeHierarchyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("drillDownFilters", "DrillDownFilters", properties.DrillDownFilters != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDrillDownFilterPropertyFromCloudFormation)(properties.DrillDownFilters) : void 0), ret.addPropertyResult("hierarchyId", "HierarchyId", cfn_parse.FromCloudFormation.getString(properties.HierarchyId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DateTimeParameterDeclarationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultValues", CfnTemplate_DateTimeDefaultValuesPropertyValidator)(properties.defaultValues)), errors.collect(cdk.propertyValidator("mappedDataSetParameters", cdk.listValidator(CfnTemplate_MappedDataSetParameterPropertyValidator))(properties.mappedDataSetParameters)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("timeGranularity", cdk.validateString)(properties.timeGranularity)), errors.collect(cdk.propertyValidator("valueWhenUnset", CfnTemplate_DateTimeValueWhenUnsetConfigurationPropertyValidator)(properties.valueWhenUnset)), errors.wrap('supplied properties not correct for "DateTimeParameterDeclarationProperty"');
    }
    function cfnTemplateDateTimeParameterDeclarationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DateTimeParameterDeclarationPropertyValidator(properties).assertSuccess(), { DefaultValues: cfnTemplateDateTimeDefaultValuesPropertyToCloudFormation(properties.defaultValues), MappedDataSetParameters: cdk.listMapper(cfnTemplateMappedDataSetParameterPropertyToCloudFormation)(properties.mappedDataSetParameters), Name: cdk.stringToCloudFormation(properties.name), TimeGranularity: cdk.stringToCloudFormation(properties.timeGranularity), ValueWhenUnset: cfnTemplateDateTimeValueWhenUnsetConfigurationPropertyToCloudFormation(properties.valueWhenUnset) }) : properties;
    }
    function CfnTemplateDateTimeParameterDeclarationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultValues", "DefaultValues", properties.DefaultValues != null ? CfnTemplateDateTimeDefaultValuesPropertyFromCloudFormation(properties.DefaultValues) : void 0), ret.addPropertyResult("mappedDataSetParameters", "MappedDataSetParameters", properties.MappedDataSetParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMappedDataSetParameterPropertyFromCloudFormation)(properties.MappedDataSetParameters) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("timeGranularity", "TimeGranularity", properties.TimeGranularity != null ? cfn_parse.FromCloudFormation.getString(properties.TimeGranularity) : void 0), ret.addPropertyResult("valueWhenUnset", "ValueWhenUnset", properties.ValueWhenUnset != null ? CfnTemplateDateTimeValueWhenUnsetConfigurationPropertyFromCloudFormation(properties.ValueWhenUnset) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DateTimePickerControlDisplayOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateTimeFormat", cdk.validateString)(properties.dateTimeFormat)), errors.collect(cdk.propertyValidator("titleOptions", CfnTemplate_LabelOptionsPropertyValidator)(properties.titleOptions)), errors.wrap('supplied properties not correct for "DateTimePickerControlDisplayOptionsProperty"');
    }
    function cfnTemplateDateTimePickerControlDisplayOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DateTimePickerControlDisplayOptionsPropertyValidator(properties).assertSuccess(), { DateTimeFormat: cdk.stringToCloudFormation(properties.dateTimeFormat), TitleOptions: cfnTemplateLabelOptionsPropertyToCloudFormation(properties.titleOptions) }) : properties;
    }
    function CfnTemplateDateTimePickerControlDisplayOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateTimeFormat", "DateTimeFormat", properties.DateTimeFormat != null ? cfn_parse.FromCloudFormation.getString(properties.DateTimeFormat) : void 0), ret.addPropertyResult("titleOptions", "TitleOptions", properties.TitleOptions != null ? CfnTemplateLabelOptionsPropertyFromCloudFormation(properties.TitleOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DateTimeValueWhenUnsetConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customValue", cdk.validateString)(properties.customValue)), errors.collect(cdk.propertyValidator("valueWhenUnsetOption", cdk.validateString)(properties.valueWhenUnsetOption)), errors.wrap('supplied properties not correct for "DateTimeValueWhenUnsetConfigurationProperty"');
    }
    function cfnTemplateDateTimeValueWhenUnsetConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DateTimeValueWhenUnsetConfigurationPropertyValidator(properties).assertSuccess(), { CustomValue: cdk.stringToCloudFormation(properties.customValue), ValueWhenUnsetOption: cdk.stringToCloudFormation(properties.valueWhenUnsetOption) }) : properties;
    }
    function CfnTemplateDateTimeValueWhenUnsetConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customValue", "CustomValue", properties.CustomValue != null ? cfn_parse.FromCloudFormation.getString(properties.CustomValue) : void 0), ret.addPropertyResult("valueWhenUnsetOption", "ValueWhenUnsetOption", properties.ValueWhenUnsetOption != null ? cfn_parse.FromCloudFormation.getString(properties.ValueWhenUnsetOption) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DecimalDefaultValuesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dynamicValue", CfnTemplate_DynamicDefaultValuePropertyValidator)(properties.dynamicValue)), errors.collect(cdk.propertyValidator("staticValues", cdk.listValidator(cdk.validateNumber))(properties.staticValues)), errors.wrap('supplied properties not correct for "DecimalDefaultValuesProperty"');
    }
    function cfnTemplateDecimalDefaultValuesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DecimalDefaultValuesPropertyValidator(properties).assertSuccess(), { DynamicValue: cfnTemplateDynamicDefaultValuePropertyToCloudFormation(properties.dynamicValue), StaticValues: cdk.listMapper(cdk.numberToCloudFormation)(properties.staticValues) }) : properties;
    }
    function CfnTemplateDecimalDefaultValuesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dynamicValue", "DynamicValue", properties.DynamicValue != null ? CfnTemplateDynamicDefaultValuePropertyFromCloudFormation(properties.DynamicValue) : void 0), ret.addPropertyResult("staticValues", "StaticValues", properties.StaticValues != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getNumber)(properties.StaticValues) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DecimalParameterDeclarationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultValues", CfnTemplate_DecimalDefaultValuesPropertyValidator)(properties.defaultValues)), errors.collect(cdk.propertyValidator("mappedDataSetParameters", cdk.listValidator(CfnTemplate_MappedDataSetParameterPropertyValidator))(properties.mappedDataSetParameters)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("parameterValueType", cdk.requiredValidator)(properties.parameterValueType)), errors.collect(cdk.propertyValidator("parameterValueType", cdk.validateString)(properties.parameterValueType)), errors.collect(cdk.propertyValidator("valueWhenUnset", CfnTemplate_DecimalValueWhenUnsetConfigurationPropertyValidator)(properties.valueWhenUnset)), errors.wrap('supplied properties not correct for "DecimalParameterDeclarationProperty"');
    }
    function cfnTemplateDecimalParameterDeclarationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DecimalParameterDeclarationPropertyValidator(properties).assertSuccess(), { DefaultValues: cfnTemplateDecimalDefaultValuesPropertyToCloudFormation(properties.defaultValues), MappedDataSetParameters: cdk.listMapper(cfnTemplateMappedDataSetParameterPropertyToCloudFormation)(properties.mappedDataSetParameters), Name: cdk.stringToCloudFormation(properties.name), ParameterValueType: cdk.stringToCloudFormation(properties.parameterValueType), ValueWhenUnset: cfnTemplateDecimalValueWhenUnsetConfigurationPropertyToCloudFormation(properties.valueWhenUnset) }) : properties;
    }
    function CfnTemplateDecimalParameterDeclarationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultValues", "DefaultValues", properties.DefaultValues != null ? CfnTemplateDecimalDefaultValuesPropertyFromCloudFormation(properties.DefaultValues) : void 0), ret.addPropertyResult("mappedDataSetParameters", "MappedDataSetParameters", properties.MappedDataSetParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMappedDataSetParameterPropertyFromCloudFormation)(properties.MappedDataSetParameters) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("parameterValueType", "ParameterValueType", cfn_parse.FromCloudFormation.getString(properties.ParameterValueType)), ret.addPropertyResult("valueWhenUnset", "ValueWhenUnset", properties.ValueWhenUnset != null ? CfnTemplateDecimalValueWhenUnsetConfigurationPropertyFromCloudFormation(properties.ValueWhenUnset) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DecimalPlacesConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("decimalPlaces", cdk.requiredValidator)(properties.decimalPlaces)), errors.collect(cdk.propertyValidator("decimalPlaces", cdk.validateNumber)(properties.decimalPlaces)), errors.wrap('supplied properties not correct for "DecimalPlacesConfigurationProperty"');
    }
    function cfnTemplateDecimalPlacesConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DecimalPlacesConfigurationPropertyValidator(properties).assertSuccess(), { DecimalPlaces: cdk.numberToCloudFormation(properties.decimalPlaces) }) : properties;
    }
    function CfnTemplateDecimalPlacesConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("decimalPlaces", "DecimalPlaces", cfn_parse.FromCloudFormation.getNumber(properties.DecimalPlaces)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DecimalValueWhenUnsetConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customValue", cdk.validateNumber)(properties.customValue)), errors.collect(cdk.propertyValidator("valueWhenUnsetOption", cdk.validateString)(properties.valueWhenUnsetOption)), errors.wrap('supplied properties not correct for "DecimalValueWhenUnsetConfigurationProperty"');
    }
    function cfnTemplateDecimalValueWhenUnsetConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DecimalValueWhenUnsetConfigurationPropertyValidator(properties).assertSuccess(), { CustomValue: cdk.numberToCloudFormation(properties.customValue), ValueWhenUnsetOption: cdk.stringToCloudFormation(properties.valueWhenUnsetOption) }) : properties;
    }
    function CfnTemplateDecimalValueWhenUnsetConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customValue", "CustomValue", properties.CustomValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.CustomValue) : void 0), ret.addPropertyResult("valueWhenUnsetOption", "ValueWhenUnsetOption", properties.ValueWhenUnsetOption != null ? cfn_parse.FromCloudFormation.getString(properties.ValueWhenUnsetOption) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DefaultFreeFormLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("canvasSizeOptions", cdk.requiredValidator)(properties.canvasSizeOptions)), errors.collect(cdk.propertyValidator("canvasSizeOptions", CfnTemplate_FreeFormLayoutCanvasSizeOptionsPropertyValidator)(properties.canvasSizeOptions)), errors.wrap('supplied properties not correct for "DefaultFreeFormLayoutConfigurationProperty"');
    }
    function cfnTemplateDefaultFreeFormLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DefaultFreeFormLayoutConfigurationPropertyValidator(properties).assertSuccess(), { CanvasSizeOptions: cfnTemplateFreeFormLayoutCanvasSizeOptionsPropertyToCloudFormation(properties.canvasSizeOptions) }) : properties;
    }
    function CfnTemplateDefaultFreeFormLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("canvasSizeOptions", "CanvasSizeOptions", CfnTemplateFreeFormLayoutCanvasSizeOptionsPropertyFromCloudFormation(properties.CanvasSizeOptions)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DefaultGridLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("canvasSizeOptions", cdk.requiredValidator)(properties.canvasSizeOptions)), errors.collect(cdk.propertyValidator("canvasSizeOptions", CfnTemplate_GridLayoutCanvasSizeOptionsPropertyValidator)(properties.canvasSizeOptions)), errors.wrap('supplied properties not correct for "DefaultGridLayoutConfigurationProperty"');
    }
    function cfnTemplateDefaultGridLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DefaultGridLayoutConfigurationPropertyValidator(properties).assertSuccess(), { CanvasSizeOptions: cfnTemplateGridLayoutCanvasSizeOptionsPropertyToCloudFormation(properties.canvasSizeOptions) }) : properties;
    }
    function CfnTemplateDefaultGridLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("canvasSizeOptions", "CanvasSizeOptions", CfnTemplateGridLayoutCanvasSizeOptionsPropertyFromCloudFormation(properties.CanvasSizeOptions)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DefaultInteractiveLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("freeForm", CfnTemplate_DefaultFreeFormLayoutConfigurationPropertyValidator)(properties.freeForm)), errors.collect(cdk.propertyValidator("grid", CfnTemplate_DefaultGridLayoutConfigurationPropertyValidator)(properties.grid)), errors.wrap('supplied properties not correct for "DefaultInteractiveLayoutConfigurationProperty"');
    }
    function cfnTemplateDefaultInteractiveLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DefaultInteractiveLayoutConfigurationPropertyValidator(properties).assertSuccess(), { FreeForm: cfnTemplateDefaultFreeFormLayoutConfigurationPropertyToCloudFormation(properties.freeForm), Grid: cfnTemplateDefaultGridLayoutConfigurationPropertyToCloudFormation(properties.grid) }) : properties;
    }
    function CfnTemplateDefaultInteractiveLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("freeForm", "FreeForm", properties.FreeForm != null ? CfnTemplateDefaultFreeFormLayoutConfigurationPropertyFromCloudFormation(properties.FreeForm) : void 0), ret.addPropertyResult("grid", "Grid", properties.Grid != null ? CfnTemplateDefaultGridLayoutConfigurationPropertyFromCloudFormation(properties.Grid) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DefaultNewSheetConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("interactiveLayoutConfiguration", CfnTemplate_DefaultInteractiveLayoutConfigurationPropertyValidator)(properties.interactiveLayoutConfiguration)), errors.collect(cdk.propertyValidator("paginatedLayoutConfiguration", CfnTemplate_DefaultPaginatedLayoutConfigurationPropertyValidator)(properties.paginatedLayoutConfiguration)), errors.collect(cdk.propertyValidator("sheetContentType", cdk.validateString)(properties.sheetContentType)), errors.wrap('supplied properties not correct for "DefaultNewSheetConfigurationProperty"');
    }
    function cfnTemplateDefaultNewSheetConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DefaultNewSheetConfigurationPropertyValidator(properties).assertSuccess(), { InteractiveLayoutConfiguration: cfnTemplateDefaultInteractiveLayoutConfigurationPropertyToCloudFormation(properties.interactiveLayoutConfiguration), PaginatedLayoutConfiguration: cfnTemplateDefaultPaginatedLayoutConfigurationPropertyToCloudFormation(properties.paginatedLayoutConfiguration), SheetContentType: cdk.stringToCloudFormation(properties.sheetContentType) }) : properties;
    }
    function CfnTemplateDefaultNewSheetConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("interactiveLayoutConfiguration", "InteractiveLayoutConfiguration", properties.InteractiveLayoutConfiguration != null ? CfnTemplateDefaultInteractiveLayoutConfigurationPropertyFromCloudFormation(properties.InteractiveLayoutConfiguration) : void 0), ret.addPropertyResult("paginatedLayoutConfiguration", "PaginatedLayoutConfiguration", properties.PaginatedLayoutConfiguration != null ? CfnTemplateDefaultPaginatedLayoutConfigurationPropertyFromCloudFormation(properties.PaginatedLayoutConfiguration) : void 0), ret.addPropertyResult("sheetContentType", "SheetContentType", properties.SheetContentType != null ? cfn_parse.FromCloudFormation.getString(properties.SheetContentType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DefaultPaginatedLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sectionBased", CfnTemplate_DefaultSectionBasedLayoutConfigurationPropertyValidator)(properties.sectionBased)), errors.wrap('supplied properties not correct for "DefaultPaginatedLayoutConfigurationProperty"');
    }
    function cfnTemplateDefaultPaginatedLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DefaultPaginatedLayoutConfigurationPropertyValidator(properties).assertSuccess(), { SectionBased: cfnTemplateDefaultSectionBasedLayoutConfigurationPropertyToCloudFormation(properties.sectionBased) }) : properties;
    }
    function CfnTemplateDefaultPaginatedLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sectionBased", "SectionBased", properties.SectionBased != null ? CfnTemplateDefaultSectionBasedLayoutConfigurationPropertyFromCloudFormation(properties.SectionBased) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DefaultSectionBasedLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("canvasSizeOptions", cdk.requiredValidator)(properties.canvasSizeOptions)), errors.collect(cdk.propertyValidator("canvasSizeOptions", CfnTemplate_SectionBasedLayoutCanvasSizeOptionsPropertyValidator)(properties.canvasSizeOptions)), errors.wrap('supplied properties not correct for "DefaultSectionBasedLayoutConfigurationProperty"');
    }
    function cfnTemplateDefaultSectionBasedLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DefaultSectionBasedLayoutConfigurationPropertyValidator(properties).assertSuccess(), { CanvasSizeOptions: cfnTemplateSectionBasedLayoutCanvasSizeOptionsPropertyToCloudFormation(properties.canvasSizeOptions) }) : properties;
    }
    function CfnTemplateDefaultSectionBasedLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("canvasSizeOptions", "CanvasSizeOptions", CfnTemplateSectionBasedLayoutCanvasSizeOptionsPropertyFromCloudFormation(properties.CanvasSizeOptions)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DestinationParameterValueConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customValuesConfiguration", CfnTemplate_CustomValuesConfigurationPropertyValidator)(properties.customValuesConfiguration)), errors.collect(cdk.propertyValidator("selectAllValueOptions", cdk.validateString)(properties.selectAllValueOptions)), errors.collect(cdk.propertyValidator("sourceField", cdk.validateString)(properties.sourceField)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.validateString)(properties.sourceParameterName)), errors.wrap('supplied properties not correct for "DestinationParameterValueConfigurationProperty"');
    }
    function cfnTemplateDestinationParameterValueConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DestinationParameterValueConfigurationPropertyValidator(properties).assertSuccess(), { CustomValuesConfiguration: cfnTemplateCustomValuesConfigurationPropertyToCloudFormation(properties.customValuesConfiguration), SelectAllValueOptions: cdk.stringToCloudFormation(properties.selectAllValueOptions), SourceField: cdk.stringToCloudFormation(properties.sourceField), SourceParameterName: cdk.stringToCloudFormation(properties.sourceParameterName) }) : properties;
    }
    function CfnTemplateDestinationParameterValueConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customValuesConfiguration", "CustomValuesConfiguration", properties.CustomValuesConfiguration != null ? CfnTemplateCustomValuesConfigurationPropertyFromCloudFormation(properties.CustomValuesConfiguration) : void 0), ret.addPropertyResult("selectAllValueOptions", "SelectAllValueOptions", properties.SelectAllValueOptions != null ? cfn_parse.FromCloudFormation.getString(properties.SelectAllValueOptions) : void 0), ret.addPropertyResult("sourceField", "SourceField", properties.SourceField != null ? cfn_parse.FromCloudFormation.getString(properties.SourceField) : void 0), ret.addPropertyResult("sourceParameterName", "SourceParameterName", properties.SourceParameterName != null ? cfn_parse.FromCloudFormation.getString(properties.SourceParameterName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DimensionFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoricalDimensionField", CfnTemplate_CategoricalDimensionFieldPropertyValidator)(properties.categoricalDimensionField)), errors.collect(cdk.propertyValidator("dateDimensionField", CfnTemplate_DateDimensionFieldPropertyValidator)(properties.dateDimensionField)), errors.collect(cdk.propertyValidator("numericalDimensionField", CfnTemplate_NumericalDimensionFieldPropertyValidator)(properties.numericalDimensionField)), errors.wrap('supplied properties not correct for "DimensionFieldProperty"');
    }
    function cfnTemplateDimensionFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DimensionFieldPropertyValidator(properties).assertSuccess(), { CategoricalDimensionField: cfnTemplateCategoricalDimensionFieldPropertyToCloudFormation(properties.categoricalDimensionField), DateDimensionField: cfnTemplateDateDimensionFieldPropertyToCloudFormation(properties.dateDimensionField), NumericalDimensionField: cfnTemplateNumericalDimensionFieldPropertyToCloudFormation(properties.numericalDimensionField) }) : properties;
    }
    function CfnTemplateDimensionFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoricalDimensionField", "CategoricalDimensionField", properties.CategoricalDimensionField != null ? CfnTemplateCategoricalDimensionFieldPropertyFromCloudFormation(properties.CategoricalDimensionField) : void 0), ret.addPropertyResult("dateDimensionField", "DateDimensionField", properties.DateDimensionField != null ? CfnTemplateDateDimensionFieldPropertyFromCloudFormation(properties.DateDimensionField) : void 0), ret.addPropertyResult("numericalDimensionField", "NumericalDimensionField", properties.NumericalDimensionField != null ? CfnTemplateNumericalDimensionFieldPropertyFromCloudFormation(properties.NumericalDimensionField) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DonutCenterOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("labelVisibility", cdk.validateString)(properties.labelVisibility)), errors.wrap('supplied properties not correct for "DonutCenterOptionsProperty"');
    }
    function cfnTemplateDonutCenterOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DonutCenterOptionsPropertyValidator(properties).assertSuccess(), { LabelVisibility: cdk.stringToCloudFormation(properties.labelVisibility) }) : properties;
    }
    function CfnTemplateDonutCenterOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("labelVisibility", "LabelVisibility", properties.LabelVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.LabelVisibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DonutOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arcOptions", CfnTemplate_ArcOptionsPropertyValidator)(properties.arcOptions)), errors.collect(cdk.propertyValidator("donutCenterOptions", CfnTemplate_DonutCenterOptionsPropertyValidator)(properties.donutCenterOptions)), errors.wrap('supplied properties not correct for "DonutOptionsProperty"');
    }
    function cfnTemplateDonutOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DonutOptionsPropertyValidator(properties).assertSuccess(), { ArcOptions: cfnTemplateArcOptionsPropertyToCloudFormation(properties.arcOptions), DonutCenterOptions: cfnTemplateDonutCenterOptionsPropertyToCloudFormation(properties.donutCenterOptions) }) : properties;
    }
    function CfnTemplateDonutOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arcOptions", "ArcOptions", properties.ArcOptions != null ? CfnTemplateArcOptionsPropertyFromCloudFormation(properties.ArcOptions) : void 0), ret.addPropertyResult("donutCenterOptions", "DonutCenterOptions", properties.DonutCenterOptions != null ? CfnTemplateDonutCenterOptionsPropertyFromCloudFormation(properties.DonutCenterOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DrillDownFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryFilter", CfnTemplate_CategoryDrillDownFilterPropertyValidator)(properties.categoryFilter)), errors.collect(cdk.propertyValidator("numericEqualityFilter", CfnTemplate_NumericEqualityDrillDownFilterPropertyValidator)(properties.numericEqualityFilter)), errors.collect(cdk.propertyValidator("timeRangeFilter", CfnTemplate_TimeRangeDrillDownFilterPropertyValidator)(properties.timeRangeFilter)), errors.wrap('supplied properties not correct for "DrillDownFilterProperty"');
    }
    function cfnTemplateDrillDownFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DrillDownFilterPropertyValidator(properties).assertSuccess(), { CategoryFilter: cfnTemplateCategoryDrillDownFilterPropertyToCloudFormation(properties.categoryFilter), NumericEqualityFilter: cfnTemplateNumericEqualityDrillDownFilterPropertyToCloudFormation(properties.numericEqualityFilter), TimeRangeFilter: cfnTemplateTimeRangeDrillDownFilterPropertyToCloudFormation(properties.timeRangeFilter) }) : properties;
    }
    function CfnTemplateDrillDownFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryFilter", "CategoryFilter", properties.CategoryFilter != null ? CfnTemplateCategoryDrillDownFilterPropertyFromCloudFormation(properties.CategoryFilter) : void 0), ret.addPropertyResult("numericEqualityFilter", "NumericEqualityFilter", properties.NumericEqualityFilter != null ? CfnTemplateNumericEqualityDrillDownFilterPropertyFromCloudFormation(properties.NumericEqualityFilter) : void 0), ret.addPropertyResult("timeRangeFilter", "TimeRangeFilter", properties.TimeRangeFilter != null ? CfnTemplateTimeRangeDrillDownFilterPropertyFromCloudFormation(properties.TimeRangeFilter) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DropDownControlDisplayOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("selectAllOptions", CfnTemplate_ListControlSelectAllOptionsPropertyValidator)(properties.selectAllOptions)), errors.collect(cdk.propertyValidator("titleOptions", CfnTemplate_LabelOptionsPropertyValidator)(properties.titleOptions)), errors.wrap('supplied properties not correct for "DropDownControlDisplayOptionsProperty"');
    }
    function cfnTemplateDropDownControlDisplayOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DropDownControlDisplayOptionsPropertyValidator(properties).assertSuccess(), { SelectAllOptions: cfnTemplateListControlSelectAllOptionsPropertyToCloudFormation(properties.selectAllOptions), TitleOptions: cfnTemplateLabelOptionsPropertyToCloudFormation(properties.titleOptions) }) : properties;
    }
    function CfnTemplateDropDownControlDisplayOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("selectAllOptions", "SelectAllOptions", properties.SelectAllOptions != null ? CfnTemplateListControlSelectAllOptionsPropertyFromCloudFormation(properties.SelectAllOptions) : void 0), ret.addPropertyResult("titleOptions", "TitleOptions", properties.TitleOptions != null ? CfnTemplateLabelOptionsPropertyFromCloudFormation(properties.TitleOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_DynamicDefaultValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultValueColumn", cdk.requiredValidator)(properties.defaultValueColumn)), errors.collect(cdk.propertyValidator("defaultValueColumn", CfnTemplate_ColumnIdentifierPropertyValidator)(properties.defaultValueColumn)), errors.collect(cdk.propertyValidator("groupNameColumn", CfnTemplate_ColumnIdentifierPropertyValidator)(properties.groupNameColumn)), errors.collect(cdk.propertyValidator("userNameColumn", CfnTemplate_ColumnIdentifierPropertyValidator)(properties.userNameColumn)), errors.wrap('supplied properties not correct for "DynamicDefaultValueProperty"');
    }
    function cfnTemplateDynamicDefaultValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_DynamicDefaultValuePropertyValidator(properties).assertSuccess(), { DefaultValueColumn: cfnTemplateColumnIdentifierPropertyToCloudFormation(properties.defaultValueColumn), GroupNameColumn: cfnTemplateColumnIdentifierPropertyToCloudFormation(properties.groupNameColumn), UserNameColumn: cfnTemplateColumnIdentifierPropertyToCloudFormation(properties.userNameColumn) }) : properties;
    }
    function CfnTemplateDynamicDefaultValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultValueColumn", "DefaultValueColumn", CfnTemplateColumnIdentifierPropertyFromCloudFormation(properties.DefaultValueColumn)), ret.addPropertyResult("groupNameColumn", "GroupNameColumn", properties.GroupNameColumn != null ? CfnTemplateColumnIdentifierPropertyFromCloudFormation(properties.GroupNameColumn) : void 0), ret.addPropertyResult("userNameColumn", "UserNameColumn", properties.UserNameColumn != null ? CfnTemplateColumnIdentifierPropertyFromCloudFormation(properties.UserNameColumn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_EmptyVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnTemplate_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.requiredValidator)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.validateString)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "EmptyVisualProperty"');
    }
    function cfnTemplateEmptyVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_EmptyVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnTemplateVisualCustomActionPropertyToCloudFormation)(properties.actions), DataSetIdentifier: cdk.stringToCloudFormation(properties.dataSetIdentifier), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnTemplateEmptyVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("dataSetIdentifier", "DataSetIdentifier", cfn_parse.FromCloudFormation.getString(properties.DataSetIdentifier)), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ExcludePeriodConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("amount", cdk.requiredValidator)(properties.amount)), errors.collect(cdk.propertyValidator("amount", cdk.validateNumber)(properties.amount)), errors.collect(cdk.propertyValidator("granularity", cdk.requiredValidator)(properties.granularity)), errors.collect(cdk.propertyValidator("granularity", cdk.validateString)(properties.granularity)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "ExcludePeriodConfigurationProperty"');
    }
    function cfnTemplateExcludePeriodConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ExcludePeriodConfigurationPropertyValidator(properties).assertSuccess(), { Amount: cdk.numberToCloudFormation(properties.amount), Granularity: cdk.stringToCloudFormation(properties.granularity), Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnTemplateExcludePeriodConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("amount", "Amount", cfn_parse.FromCloudFormation.getNumber(properties.Amount)), ret.addPropertyResult("granularity", "Granularity", cfn_parse.FromCloudFormation.getString(properties.Granularity)), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ExplicitHierarchyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columns", cdk.requiredValidator)(properties.columns)), errors.collect(cdk.propertyValidator("columns", cdk.listValidator(CfnTemplate_ColumnIdentifierPropertyValidator))(properties.columns)), errors.collect(cdk.propertyValidator("drillDownFilters", cdk.listValidator(CfnTemplate_DrillDownFilterPropertyValidator))(properties.drillDownFilters)), errors.collect(cdk.propertyValidator("hierarchyId", cdk.requiredValidator)(properties.hierarchyId)), errors.collect(cdk.propertyValidator("hierarchyId", cdk.validateString)(properties.hierarchyId)), errors.wrap('supplied properties not correct for "ExplicitHierarchyProperty"');
    }
    function cfnTemplateExplicitHierarchyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ExplicitHierarchyPropertyValidator(properties).assertSuccess(), { Columns: cdk.listMapper(cfnTemplateColumnIdentifierPropertyToCloudFormation)(properties.columns), DrillDownFilters: cdk.listMapper(cfnTemplateDrillDownFilterPropertyToCloudFormation)(properties.drillDownFilters), HierarchyId: cdk.stringToCloudFormation(properties.hierarchyId) }) : properties;
    }
    function CfnTemplateExplicitHierarchyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columns", "Columns", cfn_parse.FromCloudFormation.getArray(CfnTemplateColumnIdentifierPropertyFromCloudFormation)(properties.Columns)), ret.addPropertyResult("drillDownFilters", "DrillDownFilters", properties.DrillDownFilters != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDrillDownFilterPropertyFromCloudFormation)(properties.DrillDownFilters) : void 0), ret.addPropertyResult("hierarchyId", "HierarchyId", cfn_parse.FromCloudFormation.getString(properties.HierarchyId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FieldBasedTooltipPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationVisibility", cdk.validateString)(properties.aggregationVisibility)), errors.collect(cdk.propertyValidator("tooltipFields", cdk.listValidator(CfnTemplate_TooltipItemPropertyValidator))(properties.tooltipFields)), errors.collect(cdk.propertyValidator("tooltipTitleType", cdk.validateString)(properties.tooltipTitleType)), errors.wrap('supplied properties not correct for "FieldBasedTooltipProperty"');
    }
    function cfnTemplateFieldBasedTooltipPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FieldBasedTooltipPropertyValidator(properties).assertSuccess(), { AggregationVisibility: cdk.stringToCloudFormation(properties.aggregationVisibility), TooltipFields: cdk.listMapper(cfnTemplateTooltipItemPropertyToCloudFormation)(properties.tooltipFields), TooltipTitleType: cdk.stringToCloudFormation(properties.tooltipTitleType) }) : properties;
    }
    function CfnTemplateFieldBasedTooltipPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationVisibility", "AggregationVisibility", properties.AggregationVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.AggregationVisibility) : void 0), ret.addPropertyResult("tooltipFields", "TooltipFields", properties.TooltipFields != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateTooltipItemPropertyFromCloudFormation)(properties.TooltipFields) : void 0), ret.addPropertyResult("tooltipTitleType", "TooltipTitleType", properties.TooltipTitleType != null ? cfn_parse.FromCloudFormation.getString(properties.TooltipTitleType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FieldLabelTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "FieldLabelTypeProperty"');
    }
    function cfnTemplateFieldLabelTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FieldLabelTypePropertyValidator(properties).assertSuccess(), { FieldId: cdk.stringToCloudFormation(properties.fieldId), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnTemplateFieldLabelTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldId", "FieldId", properties.FieldId != null ? cfn_parse.FromCloudFormation.getString(properties.FieldId) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FieldSeriesItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("axisBinding", cdk.requiredValidator)(properties.axisBinding)), errors.collect(cdk.propertyValidator("axisBinding", cdk.validateString)(properties.axisBinding)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("settings", CfnTemplate_LineChartSeriesSettingsPropertyValidator)(properties.settings)), errors.wrap('supplied properties not correct for "FieldSeriesItemProperty"');
    }
    function cfnTemplateFieldSeriesItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FieldSeriesItemPropertyValidator(properties).assertSuccess(), { AxisBinding: cdk.stringToCloudFormation(properties.axisBinding), FieldId: cdk.stringToCloudFormation(properties.fieldId), Settings: cfnTemplateLineChartSeriesSettingsPropertyToCloudFormation(properties.settings) }) : properties;
    }
    function CfnTemplateFieldSeriesItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("axisBinding", "AxisBinding", cfn_parse.FromCloudFormation.getString(properties.AxisBinding)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("settings", "Settings", properties.Settings != null ? CfnTemplateLineChartSeriesSettingsPropertyFromCloudFormation(properties.Settings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FieldSortPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("direction", cdk.requiredValidator)(properties.direction)), errors.collect(cdk.propertyValidator("direction", cdk.validateString)(properties.direction)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.wrap('supplied properties not correct for "FieldSortProperty"');
    }
    function cfnTemplateFieldSortPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FieldSortPropertyValidator(properties).assertSuccess(), { Direction: cdk.stringToCloudFormation(properties.direction), FieldId: cdk.stringToCloudFormation(properties.fieldId) }) : properties;
    }
    function CfnTemplateFieldSortPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("direction", "Direction", cfn_parse.FromCloudFormation.getString(properties.Direction)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FieldSortOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnSort", CfnTemplate_ColumnSortPropertyValidator)(properties.columnSort)), errors.collect(cdk.propertyValidator("fieldSort", CfnTemplate_FieldSortPropertyValidator)(properties.fieldSort)), errors.wrap('supplied properties not correct for "FieldSortOptionsProperty"');
    }
    function cfnTemplateFieldSortOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FieldSortOptionsPropertyValidator(properties).assertSuccess(), { ColumnSort: cfnTemplateColumnSortPropertyToCloudFormation(properties.columnSort), FieldSort: cfnTemplateFieldSortPropertyToCloudFormation(properties.fieldSort) }) : properties;
    }
    function CfnTemplateFieldSortOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columnSort", "ColumnSort", properties.ColumnSort != null ? CfnTemplateColumnSortPropertyFromCloudFormation(properties.ColumnSort) : void 0), ret.addPropertyResult("fieldSort", "FieldSort", properties.FieldSort != null ? CfnTemplateFieldSortPropertyFromCloudFormation(properties.FieldSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FieldTooltipItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("label", cdk.validateString)(properties.label)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "FieldTooltipItemProperty"');
    }
    function cfnTemplateFieldTooltipItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FieldTooltipItemPropertyValidator(properties).assertSuccess(), { FieldId: cdk.stringToCloudFormation(properties.fieldId), Label: cdk.stringToCloudFormation(properties.label), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnTemplateFieldTooltipItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("label", "Label", properties.Label != null ? cfn_parse.FromCloudFormation.getString(properties.Label) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FilledMapAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("geospatial", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.geospatial)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnTemplate_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "FilledMapAggregatedFieldWellsProperty"');
    }
    function cfnTemplateFilledMapAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FilledMapAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Geospatial: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.geospatial), Values: cdk.listMapper(cfnTemplateMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnTemplateFilledMapAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("geospatial", "Geospatial", properties.Geospatial != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.Geospatial) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FilledMapConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("conditionalFormattingOptions", cdk.requiredValidator)(properties.conditionalFormattingOptions)), errors.collect(cdk.propertyValidator("conditionalFormattingOptions", cdk.listValidator(CfnTemplate_FilledMapConditionalFormattingOptionPropertyValidator))(properties.conditionalFormattingOptions)), errors.wrap('supplied properties not correct for "FilledMapConditionalFormattingProperty"');
    }
    function cfnTemplateFilledMapConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FilledMapConditionalFormattingPropertyValidator(properties).assertSuccess(), { ConditionalFormattingOptions: cdk.listMapper(cfnTemplateFilledMapConditionalFormattingOptionPropertyToCloudFormation)(properties.conditionalFormattingOptions) }) : properties;
    }
    function CfnTemplateFilledMapConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("conditionalFormattingOptions", "ConditionalFormattingOptions", cfn_parse.FromCloudFormation.getArray(CfnTemplateFilledMapConditionalFormattingOptionPropertyFromCloudFormation)(properties.ConditionalFormattingOptions)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FilledMapConditionalFormattingOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("shape", cdk.requiredValidator)(properties.shape)), errors.collect(cdk.propertyValidator("shape", CfnTemplate_FilledMapShapeConditionalFormattingPropertyValidator)(properties.shape)), errors.wrap('supplied properties not correct for "FilledMapConditionalFormattingOptionProperty"');
    }
    function cfnTemplateFilledMapConditionalFormattingOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FilledMapConditionalFormattingOptionPropertyValidator(properties).assertSuccess(), { Shape: cfnTemplateFilledMapShapeConditionalFormattingPropertyToCloudFormation(properties.shape) }) : properties;
    }
    function CfnTemplateFilledMapConditionalFormattingOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("shape", "Shape", CfnTemplateFilledMapShapeConditionalFormattingPropertyFromCloudFormation(properties.Shape)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FilledMapConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldWells", CfnTemplate_FilledMapFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("legend", CfnTemplate_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("mapStyleOptions", CfnTemplate_GeospatialMapStyleOptionsPropertyValidator)(properties.mapStyleOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnTemplate_FilledMapSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tooltip", CfnTemplate_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.collect(cdk.propertyValidator("windowOptions", CfnTemplate_GeospatialWindowOptionsPropertyValidator)(properties.windowOptions)), errors.wrap('supplied properties not correct for "FilledMapConfigurationProperty"');
    }
    function cfnTemplateFilledMapConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FilledMapConfigurationPropertyValidator(properties).assertSuccess(), { FieldWells: cfnTemplateFilledMapFieldWellsPropertyToCloudFormation(properties.fieldWells), Legend: cfnTemplateLegendOptionsPropertyToCloudFormation(properties.legend), MapStyleOptions: cfnTemplateGeospatialMapStyleOptionsPropertyToCloudFormation(properties.mapStyleOptions), SortConfiguration: cfnTemplateFilledMapSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), Tooltip: cfnTemplateTooltipOptionsPropertyToCloudFormation(properties.tooltip), WindowOptions: cfnTemplateGeospatialWindowOptionsPropertyToCloudFormation(properties.windowOptions) }) : properties;
    }
    function CfnTemplateFilledMapConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnTemplateFilledMapFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnTemplateLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("mapStyleOptions", "MapStyleOptions", properties.MapStyleOptions != null ? CfnTemplateGeospatialMapStyleOptionsPropertyFromCloudFormation(properties.MapStyleOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnTemplateFilledMapSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnTemplateTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addPropertyResult("windowOptions", "WindowOptions", properties.WindowOptions != null ? CfnTemplateGeospatialWindowOptionsPropertyFromCloudFormation(properties.WindowOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FilledMapFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("filledMapAggregatedFieldWells", CfnTemplate_FilledMapAggregatedFieldWellsPropertyValidator)(properties.filledMapAggregatedFieldWells)), errors.wrap('supplied properties not correct for "FilledMapFieldWellsProperty"');
    }
    function cfnTemplateFilledMapFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FilledMapFieldWellsPropertyValidator(properties).assertSuccess(), { FilledMapAggregatedFieldWells: cfnTemplateFilledMapAggregatedFieldWellsPropertyToCloudFormation(properties.filledMapAggregatedFieldWells) }) : properties;
    }
    function CfnTemplateFilledMapFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("filledMapAggregatedFieldWells", "FilledMapAggregatedFieldWells", properties.FilledMapAggregatedFieldWells != null ? CfnTemplateFilledMapAggregatedFieldWellsPropertyFromCloudFormation(properties.FilledMapAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FilledMapShapeConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("format", CfnTemplate_ShapeConditionalFormatPropertyValidator)(properties.format)), errors.wrap('supplied properties not correct for "FilledMapShapeConditionalFormattingProperty"');
    }
    function cfnTemplateFilledMapShapeConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FilledMapShapeConditionalFormattingPropertyValidator(properties).assertSuccess(), { FieldId: cdk.stringToCloudFormation(properties.fieldId), Format: cfnTemplateShapeConditionalFormatPropertyToCloudFormation(properties.format) }) : properties;
    }
    function CfnTemplateFilledMapShapeConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("format", "Format", properties.Format != null ? CfnTemplateShapeConditionalFormatPropertyFromCloudFormation(properties.Format) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FilledMapSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categorySort", cdk.listValidator(CfnTemplate_FieldSortOptionsPropertyValidator))(properties.categorySort)), errors.wrap('supplied properties not correct for "FilledMapSortConfigurationProperty"');
    }
    function cfnTemplateFilledMapSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FilledMapSortConfigurationPropertyValidator(properties).assertSuccess(), { CategorySort: cdk.listMapper(cfnTemplateFieldSortOptionsPropertyToCloudFormation)(properties.categorySort) }) : properties;
    }
    function CfnTemplateFilledMapSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categorySort", "CategorySort", properties.CategorySort != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateFieldSortOptionsPropertyFromCloudFormation)(properties.CategorySort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FilledMapVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnTemplate_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnTemplate_FilledMapConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnTemplate_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("conditionalFormatting", CfnTemplate_FilledMapConditionalFormattingPropertyValidator)(properties.conditionalFormatting)), errors.collect(cdk.propertyValidator("subtitle", CfnTemplate_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnTemplate_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "FilledMapVisualProperty"');
    }
    function cfnTemplateFilledMapVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FilledMapVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnTemplateVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnTemplateFilledMapConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnTemplateColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), ConditionalFormatting: cfnTemplateFilledMapConditionalFormattingPropertyToCloudFormation(properties.conditionalFormatting), Subtitle: cfnTemplateVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnTemplateVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnTemplateFilledMapVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnTemplateFilledMapConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("conditionalFormatting", "ConditionalFormatting", properties.ConditionalFormatting != null ? CfnTemplateFilledMapConditionalFormattingPropertyFromCloudFormation(properties.ConditionalFormatting) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnTemplateVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnTemplateVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryFilter", CfnTemplate_CategoryFilterPropertyValidator)(properties.categoryFilter)), errors.collect(cdk.propertyValidator("numericEqualityFilter", CfnTemplate_NumericEqualityFilterPropertyValidator)(properties.numericEqualityFilter)), errors.collect(cdk.propertyValidator("numericRangeFilter", CfnTemplate_NumericRangeFilterPropertyValidator)(properties.numericRangeFilter)), errors.collect(cdk.propertyValidator("relativeDatesFilter", CfnTemplate_RelativeDatesFilterPropertyValidator)(properties.relativeDatesFilter)), errors.collect(cdk.propertyValidator("timeEqualityFilter", CfnTemplate_TimeEqualityFilterPropertyValidator)(properties.timeEqualityFilter)), errors.collect(cdk.propertyValidator("timeRangeFilter", CfnTemplate_TimeRangeFilterPropertyValidator)(properties.timeRangeFilter)), errors.collect(cdk.propertyValidator("topBottomFilter", CfnTemplate_TopBottomFilterPropertyValidator)(properties.topBottomFilter)), errors.wrap('supplied properties not correct for "FilterProperty"');
    }
    function cfnTemplateFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FilterPropertyValidator(properties).assertSuccess(), { CategoryFilter: cfnTemplateCategoryFilterPropertyToCloudFormation(properties.categoryFilter), NumericEqualityFilter: cfnTemplateNumericEqualityFilterPropertyToCloudFormation(properties.numericEqualityFilter), NumericRangeFilter: cfnTemplateNumericRangeFilterPropertyToCloudFormation(properties.numericRangeFilter), RelativeDatesFilter: cfnTemplateRelativeDatesFilterPropertyToCloudFormation(properties.relativeDatesFilter), TimeEqualityFilter: cfnTemplateTimeEqualityFilterPropertyToCloudFormation(properties.timeEqualityFilter), TimeRangeFilter: cfnTemplateTimeRangeFilterPropertyToCloudFormation(properties.timeRangeFilter), TopBottomFilter: cfnTemplateTopBottomFilterPropertyToCloudFormation(properties.topBottomFilter) }) : properties;
    }
    function CfnTemplateFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryFilter", "CategoryFilter", properties.CategoryFilter != null ? CfnTemplateCategoryFilterPropertyFromCloudFormation(properties.CategoryFilter) : void 0), ret.addPropertyResult("numericEqualityFilter", "NumericEqualityFilter", properties.NumericEqualityFilter != null ? CfnTemplateNumericEqualityFilterPropertyFromCloudFormation(properties.NumericEqualityFilter) : void 0), ret.addPropertyResult("numericRangeFilter", "NumericRangeFilter", properties.NumericRangeFilter != null ? CfnTemplateNumericRangeFilterPropertyFromCloudFormation(properties.NumericRangeFilter) : void 0), ret.addPropertyResult("relativeDatesFilter", "RelativeDatesFilter", properties.RelativeDatesFilter != null ? CfnTemplateRelativeDatesFilterPropertyFromCloudFormation(properties.RelativeDatesFilter) : void 0), ret.addPropertyResult("timeEqualityFilter", "TimeEqualityFilter", properties.TimeEqualityFilter != null ? CfnTemplateTimeEqualityFilterPropertyFromCloudFormation(properties.TimeEqualityFilter) : void 0), ret.addPropertyResult("timeRangeFilter", "TimeRangeFilter", properties.TimeRangeFilter != null ? CfnTemplateTimeRangeFilterPropertyFromCloudFormation(properties.TimeRangeFilter) : void 0), ret.addPropertyResult("topBottomFilter", "TopBottomFilter", properties.TopBottomFilter != null ? CfnTemplateTopBottomFilterPropertyFromCloudFormation(properties.TopBottomFilter) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FilterControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateTimePicker", CfnTemplate_FilterDateTimePickerControlPropertyValidator)(properties.dateTimePicker)), errors.collect(cdk.propertyValidator("dropdown", CfnTemplate_FilterDropDownControlPropertyValidator)(properties.dropdown)), errors.collect(cdk.propertyValidator("list", CfnTemplate_FilterListControlPropertyValidator)(properties.list)), errors.collect(cdk.propertyValidator("relativeDateTime", CfnTemplate_FilterRelativeDateTimeControlPropertyValidator)(properties.relativeDateTime)), errors.collect(cdk.propertyValidator("slider", CfnTemplate_FilterSliderControlPropertyValidator)(properties.slider)), errors.collect(cdk.propertyValidator("textArea", CfnTemplate_FilterTextAreaControlPropertyValidator)(properties.textArea)), errors.collect(cdk.propertyValidator("textField", CfnTemplate_FilterTextFieldControlPropertyValidator)(properties.textField)), errors.wrap('supplied properties not correct for "FilterControlProperty"');
    }
    function cfnTemplateFilterControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FilterControlPropertyValidator(properties).assertSuccess(), { DateTimePicker: cfnTemplateFilterDateTimePickerControlPropertyToCloudFormation(properties.dateTimePicker), Dropdown: cfnTemplateFilterDropDownControlPropertyToCloudFormation(properties.dropdown), List: cfnTemplateFilterListControlPropertyToCloudFormation(properties.list), RelativeDateTime: cfnTemplateFilterRelativeDateTimeControlPropertyToCloudFormation(properties.relativeDateTime), Slider: cfnTemplateFilterSliderControlPropertyToCloudFormation(properties.slider), TextArea: cfnTemplateFilterTextAreaControlPropertyToCloudFormation(properties.textArea), TextField: cfnTemplateFilterTextFieldControlPropertyToCloudFormation(properties.textField) }) : properties;
    }
    function CfnTemplateFilterControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateTimePicker", "DateTimePicker", properties.DateTimePicker != null ? CfnTemplateFilterDateTimePickerControlPropertyFromCloudFormation(properties.DateTimePicker) : void 0), ret.addPropertyResult("dropdown", "Dropdown", properties.Dropdown != null ? CfnTemplateFilterDropDownControlPropertyFromCloudFormation(properties.Dropdown) : void 0), ret.addPropertyResult("list", "List", properties.List != null ? CfnTemplateFilterListControlPropertyFromCloudFormation(properties.List) : void 0), ret.addPropertyResult("relativeDateTime", "RelativeDateTime", properties.RelativeDateTime != null ? CfnTemplateFilterRelativeDateTimeControlPropertyFromCloudFormation(properties.RelativeDateTime) : void 0), ret.addPropertyResult("slider", "Slider", properties.Slider != null ? CfnTemplateFilterSliderControlPropertyFromCloudFormation(properties.Slider) : void 0), ret.addPropertyResult("textArea", "TextArea", properties.TextArea != null ? CfnTemplateFilterTextAreaControlPropertyFromCloudFormation(properties.TextArea) : void 0), ret.addPropertyResult("textField", "TextField", properties.TextField != null ? CfnTemplateFilterTextFieldControlPropertyFromCloudFormation(properties.TextField) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FilterDateTimePickerControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("displayOptions", CfnTemplate_DateTimePickerControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("filterControlId", cdk.requiredValidator)(properties.filterControlId)), errors.collect(cdk.propertyValidator("filterControlId", cdk.validateString)(properties.filterControlId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.requiredValidator)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.validateString)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "FilterDateTimePickerControlProperty"');
    }
    function cfnTemplateFilterDateTimePickerControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FilterDateTimePickerControlPropertyValidator(properties).assertSuccess(), { DisplayOptions: cfnTemplateDateTimePickerControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), FilterControlId: cdk.stringToCloudFormation(properties.filterControlId), SourceFilterId: cdk.stringToCloudFormation(properties.sourceFilterId), Title: cdk.stringToCloudFormation(properties.title), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnTemplateFilterDateTimePickerControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnTemplateDateTimePickerControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("filterControlId", "FilterControlId", cfn_parse.FromCloudFormation.getString(properties.FilterControlId)), ret.addPropertyResult("sourceFilterId", "SourceFilterId", cfn_parse.FromCloudFormation.getString(properties.SourceFilterId)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FilterDropDownControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cascadingControlConfiguration", CfnTemplate_CascadingControlConfigurationPropertyValidator)(properties.cascadingControlConfiguration)), errors.collect(cdk.propertyValidator("displayOptions", CfnTemplate_DropDownControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("filterControlId", cdk.requiredValidator)(properties.filterControlId)), errors.collect(cdk.propertyValidator("filterControlId", cdk.validateString)(properties.filterControlId)), errors.collect(cdk.propertyValidator("selectableValues", CfnTemplate_FilterSelectableValuesPropertyValidator)(properties.selectableValues)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.requiredValidator)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.validateString)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "FilterDropDownControlProperty"');
    }
    function cfnTemplateFilterDropDownControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FilterDropDownControlPropertyValidator(properties).assertSuccess(), { CascadingControlConfiguration: cfnTemplateCascadingControlConfigurationPropertyToCloudFormation(properties.cascadingControlConfiguration), DisplayOptions: cfnTemplateDropDownControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), FilterControlId: cdk.stringToCloudFormation(properties.filterControlId), SelectableValues: cfnTemplateFilterSelectableValuesPropertyToCloudFormation(properties.selectableValues), SourceFilterId: cdk.stringToCloudFormation(properties.sourceFilterId), Title: cdk.stringToCloudFormation(properties.title), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnTemplateFilterDropDownControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cascadingControlConfiguration", "CascadingControlConfiguration", properties.CascadingControlConfiguration != null ? CfnTemplateCascadingControlConfigurationPropertyFromCloudFormation(properties.CascadingControlConfiguration) : void 0), ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnTemplateDropDownControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("filterControlId", "FilterControlId", cfn_parse.FromCloudFormation.getString(properties.FilterControlId)), ret.addPropertyResult("selectableValues", "SelectableValues", properties.SelectableValues != null ? CfnTemplateFilterSelectableValuesPropertyFromCloudFormation(properties.SelectableValues) : void 0), ret.addPropertyResult("sourceFilterId", "SourceFilterId", cfn_parse.FromCloudFormation.getString(properties.SourceFilterId)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FilterGroupPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("crossDataset", cdk.requiredValidator)(properties.crossDataset)), errors.collect(cdk.propertyValidator("crossDataset", cdk.validateString)(properties.crossDataset)), errors.collect(cdk.propertyValidator("filterGroupId", cdk.requiredValidator)(properties.filterGroupId)), errors.collect(cdk.propertyValidator("filterGroupId", cdk.validateString)(properties.filterGroupId)), errors.collect(cdk.propertyValidator("filters", cdk.requiredValidator)(properties.filters)), errors.collect(cdk.propertyValidator("filters", cdk.listValidator(CfnTemplate_FilterPropertyValidator))(properties.filters)), errors.collect(cdk.propertyValidator("scopeConfiguration", cdk.requiredValidator)(properties.scopeConfiguration)), errors.collect(cdk.propertyValidator("scopeConfiguration", CfnTemplate_FilterScopeConfigurationPropertyValidator)(properties.scopeConfiguration)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "FilterGroupProperty"');
    }
    function cfnTemplateFilterGroupPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FilterGroupPropertyValidator(properties).assertSuccess(), { CrossDataset: cdk.stringToCloudFormation(properties.crossDataset), FilterGroupId: cdk.stringToCloudFormation(properties.filterGroupId), Filters: cdk.listMapper(cfnTemplateFilterPropertyToCloudFormation)(properties.filters), ScopeConfiguration: cfnTemplateFilterScopeConfigurationPropertyToCloudFormation(properties.scopeConfiguration), Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnTemplateFilterGroupPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("crossDataset", "CrossDataset", cfn_parse.FromCloudFormation.getString(properties.CrossDataset)), ret.addPropertyResult("filterGroupId", "FilterGroupId", cfn_parse.FromCloudFormation.getString(properties.FilterGroupId)), ret.addPropertyResult("filters", "Filters", cfn_parse.FromCloudFormation.getArray(CfnTemplateFilterPropertyFromCloudFormation)(properties.Filters)), ret.addPropertyResult("scopeConfiguration", "ScopeConfiguration", CfnTemplateFilterScopeConfigurationPropertyFromCloudFormation(properties.ScopeConfiguration)), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FilterListConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryValues", cdk.listValidator(cdk.validateString))(properties.categoryValues)), errors.collect(cdk.propertyValidator("matchOperator", cdk.requiredValidator)(properties.matchOperator)), errors.collect(cdk.propertyValidator("matchOperator", cdk.validateString)(properties.matchOperator)), errors.collect(cdk.propertyValidator("selectAllOptions", cdk.validateString)(properties.selectAllOptions)), errors.wrap('supplied properties not correct for "FilterListConfigurationProperty"');
    }
    function cfnTemplateFilterListConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FilterListConfigurationPropertyValidator(properties).assertSuccess(), { CategoryValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.categoryValues), MatchOperator: cdk.stringToCloudFormation(properties.matchOperator), SelectAllOptions: cdk.stringToCloudFormation(properties.selectAllOptions) }) : properties;
    }
    function CfnTemplateFilterListConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryValues", "CategoryValues", properties.CategoryValues != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CategoryValues) : void 0), ret.addPropertyResult("matchOperator", "MatchOperator", cfn_parse.FromCloudFormation.getString(properties.MatchOperator)), ret.addPropertyResult("selectAllOptions", "SelectAllOptions", properties.SelectAllOptions != null ? cfn_parse.FromCloudFormation.getString(properties.SelectAllOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FilterListControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cascadingControlConfiguration", CfnTemplate_CascadingControlConfigurationPropertyValidator)(properties.cascadingControlConfiguration)), errors.collect(cdk.propertyValidator("displayOptions", CfnTemplate_ListControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("filterControlId", cdk.requiredValidator)(properties.filterControlId)), errors.collect(cdk.propertyValidator("filterControlId", cdk.validateString)(properties.filterControlId)), errors.collect(cdk.propertyValidator("selectableValues", CfnTemplate_FilterSelectableValuesPropertyValidator)(properties.selectableValues)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.requiredValidator)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.validateString)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "FilterListControlProperty"');
    }
    function cfnTemplateFilterListControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FilterListControlPropertyValidator(properties).assertSuccess(), { CascadingControlConfiguration: cfnTemplateCascadingControlConfigurationPropertyToCloudFormation(properties.cascadingControlConfiguration), DisplayOptions: cfnTemplateListControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), FilterControlId: cdk.stringToCloudFormation(properties.filterControlId), SelectableValues: cfnTemplateFilterSelectableValuesPropertyToCloudFormation(properties.selectableValues), SourceFilterId: cdk.stringToCloudFormation(properties.sourceFilterId), Title: cdk.stringToCloudFormation(properties.title), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnTemplateFilterListControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cascadingControlConfiguration", "CascadingControlConfiguration", properties.CascadingControlConfiguration != null ? CfnTemplateCascadingControlConfigurationPropertyFromCloudFormation(properties.CascadingControlConfiguration) : void 0), ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnTemplateListControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("filterControlId", "FilterControlId", cfn_parse.FromCloudFormation.getString(properties.FilterControlId)), ret.addPropertyResult("selectableValues", "SelectableValues", properties.SelectableValues != null ? CfnTemplateFilterSelectableValuesPropertyFromCloudFormation(properties.SelectableValues) : void 0), ret.addPropertyResult("sourceFilterId", "SourceFilterId", cfn_parse.FromCloudFormation.getString(properties.SourceFilterId)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FilterOperationSelectedFieldsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("selectedFieldOptions", cdk.validateString)(properties.selectedFieldOptions)), errors.collect(cdk.propertyValidator("selectedFields", cdk.listValidator(cdk.validateString))(properties.selectedFields)), errors.wrap('supplied properties not correct for "FilterOperationSelectedFieldsConfigurationProperty"');
    }
    function cfnTemplateFilterOperationSelectedFieldsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FilterOperationSelectedFieldsConfigurationPropertyValidator(properties).assertSuccess(), { SelectedFieldOptions: cdk.stringToCloudFormation(properties.selectedFieldOptions), SelectedFields: cdk.listMapper(cdk.stringToCloudFormation)(properties.selectedFields) }) : properties;
    }
    function CfnTemplateFilterOperationSelectedFieldsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("selectedFieldOptions", "SelectedFieldOptions", properties.SelectedFieldOptions != null ? cfn_parse.FromCloudFormation.getString(properties.SelectedFieldOptions) : void 0), ret.addPropertyResult("selectedFields", "SelectedFields", properties.SelectedFields != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SelectedFields) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FilterOperationTargetVisualsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sameSheetTargetVisualConfiguration", CfnTemplate_SameSheetTargetVisualConfigurationPropertyValidator)(properties.sameSheetTargetVisualConfiguration)), errors.wrap('supplied properties not correct for "FilterOperationTargetVisualsConfigurationProperty"');
    }
    function cfnTemplateFilterOperationTargetVisualsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FilterOperationTargetVisualsConfigurationPropertyValidator(properties).assertSuccess(), { SameSheetTargetVisualConfiguration: cfnTemplateSameSheetTargetVisualConfigurationPropertyToCloudFormation(properties.sameSheetTargetVisualConfiguration) }) : properties;
    }
    function CfnTemplateFilterOperationTargetVisualsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sameSheetTargetVisualConfiguration", "SameSheetTargetVisualConfiguration", properties.SameSheetTargetVisualConfiguration != null ? CfnTemplateSameSheetTargetVisualConfigurationPropertyFromCloudFormation(properties.SameSheetTargetVisualConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FilterRelativeDateTimeControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("displayOptions", CfnTemplate_RelativeDateTimeControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("filterControlId", cdk.requiredValidator)(properties.filterControlId)), errors.collect(cdk.propertyValidator("filterControlId", cdk.validateString)(properties.filterControlId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.requiredValidator)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.validateString)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.wrap('supplied properties not correct for "FilterRelativeDateTimeControlProperty"');
    }
    function cfnTemplateFilterRelativeDateTimeControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FilterRelativeDateTimeControlPropertyValidator(properties).assertSuccess(), { DisplayOptions: cfnTemplateRelativeDateTimeControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), FilterControlId: cdk.stringToCloudFormation(properties.filterControlId), SourceFilterId: cdk.stringToCloudFormation(properties.sourceFilterId), Title: cdk.stringToCloudFormation(properties.title) }) : properties;
    }
    function CfnTemplateFilterRelativeDateTimeControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnTemplateRelativeDateTimeControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("filterControlId", "FilterControlId", cfn_parse.FromCloudFormation.getString(properties.FilterControlId)), ret.addPropertyResult("sourceFilterId", "SourceFilterId", cfn_parse.FromCloudFormation.getString(properties.SourceFilterId)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FilterScopeConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("selectedSheets", CfnTemplate_SelectedSheetsFilterScopeConfigurationPropertyValidator)(properties.selectedSheets)), errors.wrap('supplied properties not correct for "FilterScopeConfigurationProperty"');
    }
    function cfnTemplateFilterScopeConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FilterScopeConfigurationPropertyValidator(properties).assertSuccess(), { SelectedSheets: cfnTemplateSelectedSheetsFilterScopeConfigurationPropertyToCloudFormation(properties.selectedSheets) }) : properties;
    }
    function CfnTemplateFilterScopeConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("selectedSheets", "SelectedSheets", properties.SelectedSheets != null ? CfnTemplateSelectedSheetsFilterScopeConfigurationPropertyFromCloudFormation(properties.SelectedSheets) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FilterSelectableValuesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "FilterSelectableValuesProperty"');
    }
    function cfnTemplateFilterSelectableValuesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FilterSelectableValuesPropertyValidator(properties).assertSuccess(), { Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnTemplateFilterSelectableValuesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FilterSliderControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("displayOptions", CfnTemplate_SliderControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("filterControlId", cdk.requiredValidator)(properties.filterControlId)), errors.collect(cdk.propertyValidator("filterControlId", cdk.validateString)(properties.filterControlId)), errors.collect(cdk.propertyValidator("maximumValue", cdk.requiredValidator)(properties.maximumValue)), errors.collect(cdk.propertyValidator("maximumValue", cdk.validateNumber)(properties.maximumValue)), errors.collect(cdk.propertyValidator("minimumValue", cdk.requiredValidator)(properties.minimumValue)), errors.collect(cdk.propertyValidator("minimumValue", cdk.validateNumber)(properties.minimumValue)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.requiredValidator)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.validateString)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("stepSize", cdk.requiredValidator)(properties.stepSize)), errors.collect(cdk.propertyValidator("stepSize", cdk.validateNumber)(properties.stepSize)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "FilterSliderControlProperty"');
    }
    function cfnTemplateFilterSliderControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FilterSliderControlPropertyValidator(properties).assertSuccess(), { DisplayOptions: cfnTemplateSliderControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), FilterControlId: cdk.stringToCloudFormation(properties.filterControlId), MaximumValue: cdk.numberToCloudFormation(properties.maximumValue), MinimumValue: cdk.numberToCloudFormation(properties.minimumValue), SourceFilterId: cdk.stringToCloudFormation(properties.sourceFilterId), StepSize: cdk.numberToCloudFormation(properties.stepSize), Title: cdk.stringToCloudFormation(properties.title), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnTemplateFilterSliderControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnTemplateSliderControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("filterControlId", "FilterControlId", cfn_parse.FromCloudFormation.getString(properties.FilterControlId)), ret.addPropertyResult("maximumValue", "MaximumValue", cfn_parse.FromCloudFormation.getNumber(properties.MaximumValue)), ret.addPropertyResult("minimumValue", "MinimumValue", cfn_parse.FromCloudFormation.getNumber(properties.MinimumValue)), ret.addPropertyResult("sourceFilterId", "SourceFilterId", cfn_parse.FromCloudFormation.getString(properties.SourceFilterId)), ret.addPropertyResult("stepSize", "StepSize", cfn_parse.FromCloudFormation.getNumber(properties.StepSize)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FilterTextAreaControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("delimiter", cdk.validateString)(properties.delimiter)), errors.collect(cdk.propertyValidator("displayOptions", CfnTemplate_TextAreaControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("filterControlId", cdk.requiredValidator)(properties.filterControlId)), errors.collect(cdk.propertyValidator("filterControlId", cdk.validateString)(properties.filterControlId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.requiredValidator)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.validateString)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.wrap('supplied properties not correct for "FilterTextAreaControlProperty"');
    }
    function cfnTemplateFilterTextAreaControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FilterTextAreaControlPropertyValidator(properties).assertSuccess(), { Delimiter: cdk.stringToCloudFormation(properties.delimiter), DisplayOptions: cfnTemplateTextAreaControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), FilterControlId: cdk.stringToCloudFormation(properties.filterControlId), SourceFilterId: cdk.stringToCloudFormation(properties.sourceFilterId), Title: cdk.stringToCloudFormation(properties.title) }) : properties;
    }
    function CfnTemplateFilterTextAreaControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("delimiter", "Delimiter", properties.Delimiter != null ? cfn_parse.FromCloudFormation.getString(properties.Delimiter) : void 0), ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnTemplateTextAreaControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("filterControlId", "FilterControlId", cfn_parse.FromCloudFormation.getString(properties.FilterControlId)), ret.addPropertyResult("sourceFilterId", "SourceFilterId", cfn_parse.FromCloudFormation.getString(properties.SourceFilterId)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FilterTextFieldControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("displayOptions", CfnTemplate_TextFieldControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("filterControlId", cdk.requiredValidator)(properties.filterControlId)), errors.collect(cdk.propertyValidator("filterControlId", cdk.validateString)(properties.filterControlId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.requiredValidator)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("sourceFilterId", cdk.validateString)(properties.sourceFilterId)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.wrap('supplied properties not correct for "FilterTextFieldControlProperty"');
    }
    function cfnTemplateFilterTextFieldControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FilterTextFieldControlPropertyValidator(properties).assertSuccess(), { DisplayOptions: cfnTemplateTextFieldControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), FilterControlId: cdk.stringToCloudFormation(properties.filterControlId), SourceFilterId: cdk.stringToCloudFormation(properties.sourceFilterId), Title: cdk.stringToCloudFormation(properties.title) }) : properties;
    }
    function CfnTemplateFilterTextFieldControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnTemplateTextFieldControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("filterControlId", "FilterControlId", cfn_parse.FromCloudFormation.getString(properties.FilterControlId)), ret.addPropertyResult("sourceFilterId", "SourceFilterId", cfn_parse.FromCloudFormation.getString(properties.SourceFilterId)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FontConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fontColor", cdk.validateString)(properties.fontColor)), errors.collect(cdk.propertyValidator("fontDecoration", cdk.validateString)(properties.fontDecoration)), errors.collect(cdk.propertyValidator("fontSize", CfnTemplate_FontSizePropertyValidator)(properties.fontSize)), errors.collect(cdk.propertyValidator("fontStyle", cdk.validateString)(properties.fontStyle)), errors.collect(cdk.propertyValidator("fontWeight", CfnTemplate_FontWeightPropertyValidator)(properties.fontWeight)), errors.wrap('supplied properties not correct for "FontConfigurationProperty"');
    }
    function cfnTemplateFontConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FontConfigurationPropertyValidator(properties).assertSuccess(), { FontColor: cdk.stringToCloudFormation(properties.fontColor), FontDecoration: cdk.stringToCloudFormation(properties.fontDecoration), FontSize: cfnTemplateFontSizePropertyToCloudFormation(properties.fontSize), FontStyle: cdk.stringToCloudFormation(properties.fontStyle), FontWeight: cfnTemplateFontWeightPropertyToCloudFormation(properties.fontWeight) }) : properties;
    }
    function CfnTemplateFontConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fontColor", "FontColor", properties.FontColor != null ? cfn_parse.FromCloudFormation.getString(properties.FontColor) : void 0), ret.addPropertyResult("fontDecoration", "FontDecoration", properties.FontDecoration != null ? cfn_parse.FromCloudFormation.getString(properties.FontDecoration) : void 0), ret.addPropertyResult("fontSize", "FontSize", properties.FontSize != null ? CfnTemplateFontSizePropertyFromCloudFormation(properties.FontSize) : void 0), ret.addPropertyResult("fontStyle", "FontStyle", properties.FontStyle != null ? cfn_parse.FromCloudFormation.getString(properties.FontStyle) : void 0), ret.addPropertyResult("fontWeight", "FontWeight", properties.FontWeight != null ? CfnTemplateFontWeightPropertyFromCloudFormation(properties.FontWeight) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FontSizePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("relative", cdk.validateString)(properties.relative)), errors.wrap('supplied properties not correct for "FontSizeProperty"');
    }
    function cfnTemplateFontSizePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FontSizePropertyValidator(properties).assertSuccess(), { Relative: cdk.stringToCloudFormation(properties.relative) }) : properties;
    }
    function CfnTemplateFontSizePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("relative", "Relative", properties.Relative != null ? cfn_parse.FromCloudFormation.getString(properties.Relative) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FontWeightPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "FontWeightProperty"');
    }
    function cfnTemplateFontWeightPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FontWeightPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnTemplateFontWeightPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ForecastComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computationId", cdk.requiredValidator)(properties.computationId)), errors.collect(cdk.propertyValidator("computationId", cdk.validateString)(properties.computationId)), errors.collect(cdk.propertyValidator("customSeasonalityValue", cdk.validateNumber)(properties.customSeasonalityValue)), errors.collect(cdk.propertyValidator("lowerBoundary", cdk.validateNumber)(properties.lowerBoundary)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("periodsBackward", cdk.validateNumber)(properties.periodsBackward)), errors.collect(cdk.propertyValidator("periodsForward", cdk.validateNumber)(properties.periodsForward)), errors.collect(cdk.propertyValidator("predictionInterval", cdk.validateNumber)(properties.predictionInterval)), errors.collect(cdk.propertyValidator("seasonality", cdk.validateString)(properties.seasonality)), errors.collect(cdk.propertyValidator("time", cdk.requiredValidator)(properties.time)), errors.collect(cdk.propertyValidator("time", CfnTemplate_DimensionFieldPropertyValidator)(properties.time)), errors.collect(cdk.propertyValidator("upperBoundary", cdk.validateNumber)(properties.upperBoundary)), errors.collect(cdk.propertyValidator("value", CfnTemplate_MeasureFieldPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "ForecastComputationProperty"');
    }
    function cfnTemplateForecastComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ForecastComputationPropertyValidator(properties).assertSuccess(), { ComputationId: cdk.stringToCloudFormation(properties.computationId), CustomSeasonalityValue: cdk.numberToCloudFormation(properties.customSeasonalityValue), LowerBoundary: cdk.numberToCloudFormation(properties.lowerBoundary), Name: cdk.stringToCloudFormation(properties.name), PeriodsBackward: cdk.numberToCloudFormation(properties.periodsBackward), PeriodsForward: cdk.numberToCloudFormation(properties.periodsForward), PredictionInterval: cdk.numberToCloudFormation(properties.predictionInterval), Seasonality: cdk.stringToCloudFormation(properties.seasonality), Time: cfnTemplateDimensionFieldPropertyToCloudFormation(properties.time), UpperBoundary: cdk.numberToCloudFormation(properties.upperBoundary), Value: cfnTemplateMeasureFieldPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnTemplateForecastComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computationId", "ComputationId", cfn_parse.FromCloudFormation.getString(properties.ComputationId)), ret.addPropertyResult("customSeasonalityValue", "CustomSeasonalityValue", properties.CustomSeasonalityValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.CustomSeasonalityValue) : void 0), ret.addPropertyResult("lowerBoundary", "LowerBoundary", properties.LowerBoundary != null ? cfn_parse.FromCloudFormation.getNumber(properties.LowerBoundary) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("periodsBackward", "PeriodsBackward", properties.PeriodsBackward != null ? cfn_parse.FromCloudFormation.getNumber(properties.PeriodsBackward) : void 0), ret.addPropertyResult("periodsForward", "PeriodsForward", properties.PeriodsForward != null ? cfn_parse.FromCloudFormation.getNumber(properties.PeriodsForward) : void 0), ret.addPropertyResult("predictionInterval", "PredictionInterval", properties.PredictionInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.PredictionInterval) : void 0), ret.addPropertyResult("seasonality", "Seasonality", properties.Seasonality != null ? cfn_parse.FromCloudFormation.getString(properties.Seasonality) : void 0), ret.addPropertyResult("time", "Time", CfnTemplateDimensionFieldPropertyFromCloudFormation(properties.Time)), ret.addPropertyResult("upperBoundary", "UpperBoundary", properties.UpperBoundary != null ? cfn_parse.FromCloudFormation.getNumber(properties.UpperBoundary) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? CfnTemplateMeasureFieldPropertyFromCloudFormation(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ForecastConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("forecastProperties", CfnTemplate_TimeBasedForecastPropertiesPropertyValidator)(properties.forecastProperties)), errors.collect(cdk.propertyValidator("scenario", CfnTemplate_ForecastScenarioPropertyValidator)(properties.scenario)), errors.wrap('supplied properties not correct for "ForecastConfigurationProperty"');
    }
    function cfnTemplateForecastConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ForecastConfigurationPropertyValidator(properties).assertSuccess(), { ForecastProperties: cfnTemplateTimeBasedForecastPropertiesPropertyToCloudFormation(properties.forecastProperties), Scenario: cfnTemplateForecastScenarioPropertyToCloudFormation(properties.scenario) }) : properties;
    }
    function CfnTemplateForecastConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("forecastProperties", "ForecastProperties", properties.ForecastProperties != null ? CfnTemplateTimeBasedForecastPropertiesPropertyFromCloudFormation(properties.ForecastProperties) : void 0), ret.addPropertyResult("scenario", "Scenario", properties.Scenario != null ? CfnTemplateForecastScenarioPropertyFromCloudFormation(properties.Scenario) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ForecastScenarioPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("whatIfPointScenario", CfnTemplate_WhatIfPointScenarioPropertyValidator)(properties.whatIfPointScenario)), errors.collect(cdk.propertyValidator("whatIfRangeScenario", CfnTemplate_WhatIfRangeScenarioPropertyValidator)(properties.whatIfRangeScenario)), errors.wrap('supplied properties not correct for "ForecastScenarioProperty"');
    }
    function cfnTemplateForecastScenarioPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ForecastScenarioPropertyValidator(properties).assertSuccess(), { WhatIfPointScenario: cfnTemplateWhatIfPointScenarioPropertyToCloudFormation(properties.whatIfPointScenario), WhatIfRangeScenario: cfnTemplateWhatIfRangeScenarioPropertyToCloudFormation(properties.whatIfRangeScenario) }) : properties;
    }
    function CfnTemplateForecastScenarioPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("whatIfPointScenario", "WhatIfPointScenario", properties.WhatIfPointScenario != null ? CfnTemplateWhatIfPointScenarioPropertyFromCloudFormation(properties.WhatIfPointScenario) : void 0), ret.addPropertyResult("whatIfRangeScenario", "WhatIfRangeScenario", properties.WhatIfRangeScenario != null ? CfnTemplateWhatIfRangeScenarioPropertyFromCloudFormation(properties.WhatIfRangeScenario) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateTimeFormatConfiguration", CfnTemplate_DateTimeFormatConfigurationPropertyValidator)(properties.dateTimeFormatConfiguration)), errors.collect(cdk.propertyValidator("numberFormatConfiguration", CfnTemplate_NumberFormatConfigurationPropertyValidator)(properties.numberFormatConfiguration)), errors.collect(cdk.propertyValidator("stringFormatConfiguration", CfnTemplate_StringFormatConfigurationPropertyValidator)(properties.stringFormatConfiguration)), errors.wrap('supplied properties not correct for "FormatConfigurationProperty"');
    }
    function cfnTemplateFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FormatConfigurationPropertyValidator(properties).assertSuccess(), { DateTimeFormatConfiguration: cfnTemplateDateTimeFormatConfigurationPropertyToCloudFormation(properties.dateTimeFormatConfiguration), NumberFormatConfiguration: cfnTemplateNumberFormatConfigurationPropertyToCloudFormation(properties.numberFormatConfiguration), StringFormatConfiguration: cfnTemplateStringFormatConfigurationPropertyToCloudFormation(properties.stringFormatConfiguration) }) : properties;
    }
    function CfnTemplateFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateTimeFormatConfiguration", "DateTimeFormatConfiguration", properties.DateTimeFormatConfiguration != null ? CfnTemplateDateTimeFormatConfigurationPropertyFromCloudFormation(properties.DateTimeFormatConfiguration) : void 0), ret.addPropertyResult("numberFormatConfiguration", "NumberFormatConfiguration", properties.NumberFormatConfiguration != null ? CfnTemplateNumberFormatConfigurationPropertyFromCloudFormation(properties.NumberFormatConfiguration) : void 0), ret.addPropertyResult("stringFormatConfiguration", "StringFormatConfiguration", properties.StringFormatConfiguration != null ? CfnTemplateStringFormatConfigurationPropertyFromCloudFormation(properties.StringFormatConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FreeFormLayoutCanvasSizeOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("screenCanvasSizeOptions", CfnTemplate_FreeFormLayoutScreenCanvasSizeOptionsPropertyValidator)(properties.screenCanvasSizeOptions)), errors.wrap('supplied properties not correct for "FreeFormLayoutCanvasSizeOptionsProperty"');
    }
    function cfnTemplateFreeFormLayoutCanvasSizeOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FreeFormLayoutCanvasSizeOptionsPropertyValidator(properties).assertSuccess(), { ScreenCanvasSizeOptions: cfnTemplateFreeFormLayoutScreenCanvasSizeOptionsPropertyToCloudFormation(properties.screenCanvasSizeOptions) }) : properties;
    }
    function CfnTemplateFreeFormLayoutCanvasSizeOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("screenCanvasSizeOptions", "ScreenCanvasSizeOptions", properties.ScreenCanvasSizeOptions != null ? CfnTemplateFreeFormLayoutScreenCanvasSizeOptionsPropertyFromCloudFormation(properties.ScreenCanvasSizeOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FreeFormLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("canvasSizeOptions", CfnTemplate_FreeFormLayoutCanvasSizeOptionsPropertyValidator)(properties.canvasSizeOptions)), errors.collect(cdk.propertyValidator("elements", cdk.requiredValidator)(properties.elements)), errors.collect(cdk.propertyValidator("elements", cdk.listValidator(CfnTemplate_FreeFormLayoutElementPropertyValidator))(properties.elements)), errors.wrap('supplied properties not correct for "FreeFormLayoutConfigurationProperty"');
    }
    function cfnTemplateFreeFormLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FreeFormLayoutConfigurationPropertyValidator(properties).assertSuccess(), { CanvasSizeOptions: cfnTemplateFreeFormLayoutCanvasSizeOptionsPropertyToCloudFormation(properties.canvasSizeOptions), Elements: cdk.listMapper(cfnTemplateFreeFormLayoutElementPropertyToCloudFormation)(properties.elements) }) : properties;
    }
    function CfnTemplateFreeFormLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("canvasSizeOptions", "CanvasSizeOptions", properties.CanvasSizeOptions != null ? CfnTemplateFreeFormLayoutCanvasSizeOptionsPropertyFromCloudFormation(properties.CanvasSizeOptions) : void 0), ret.addPropertyResult("elements", "Elements", cfn_parse.FromCloudFormation.getArray(CfnTemplateFreeFormLayoutElementPropertyFromCloudFormation)(properties.Elements)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FreeFormLayoutElementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("backgroundStyle", CfnTemplate_FreeFormLayoutElementBackgroundStylePropertyValidator)(properties.backgroundStyle)), errors.collect(cdk.propertyValidator("borderStyle", CfnTemplate_FreeFormLayoutElementBorderStylePropertyValidator)(properties.borderStyle)), errors.collect(cdk.propertyValidator("elementId", cdk.requiredValidator)(properties.elementId)), errors.collect(cdk.propertyValidator("elementId", cdk.validateString)(properties.elementId)), errors.collect(cdk.propertyValidator("elementType", cdk.requiredValidator)(properties.elementType)), errors.collect(cdk.propertyValidator("elementType", cdk.validateString)(properties.elementType)), errors.collect(cdk.propertyValidator("height", cdk.requiredValidator)(properties.height)), errors.collect(cdk.propertyValidator("height", cdk.validateString)(properties.height)), errors.collect(cdk.propertyValidator("loadingAnimation", CfnTemplate_LoadingAnimationPropertyValidator)(properties.loadingAnimation)), errors.collect(cdk.propertyValidator("renderingRules", cdk.listValidator(CfnTemplate_SheetElementRenderingRulePropertyValidator))(properties.renderingRules)), errors.collect(cdk.propertyValidator("selectedBorderStyle", CfnTemplate_FreeFormLayoutElementBorderStylePropertyValidator)(properties.selectedBorderStyle)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.collect(cdk.propertyValidator("width", cdk.requiredValidator)(properties.width)), errors.collect(cdk.propertyValidator("width", cdk.validateString)(properties.width)), errors.collect(cdk.propertyValidator("xAxisLocation", cdk.requiredValidator)(properties.xAxisLocation)), errors.collect(cdk.propertyValidator("xAxisLocation", cdk.validateString)(properties.xAxisLocation)), errors.collect(cdk.propertyValidator("yAxisLocation", cdk.requiredValidator)(properties.yAxisLocation)), errors.collect(cdk.propertyValidator("yAxisLocation", cdk.validateString)(properties.yAxisLocation)), errors.wrap('supplied properties not correct for "FreeFormLayoutElementProperty"');
    }
    function cfnTemplateFreeFormLayoutElementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FreeFormLayoutElementPropertyValidator(properties).assertSuccess(), { BackgroundStyle: cfnTemplateFreeFormLayoutElementBackgroundStylePropertyToCloudFormation(properties.backgroundStyle), BorderStyle: cfnTemplateFreeFormLayoutElementBorderStylePropertyToCloudFormation(properties.borderStyle), ElementId: cdk.stringToCloudFormation(properties.elementId), ElementType: cdk.stringToCloudFormation(properties.elementType), Height: cdk.stringToCloudFormation(properties.height), LoadingAnimation: cfnTemplateLoadingAnimationPropertyToCloudFormation(properties.loadingAnimation), RenderingRules: cdk.listMapper(cfnTemplateSheetElementRenderingRulePropertyToCloudFormation)(properties.renderingRules), SelectedBorderStyle: cfnTemplateFreeFormLayoutElementBorderStylePropertyToCloudFormation(properties.selectedBorderStyle), Visibility: cdk.stringToCloudFormation(properties.visibility), Width: cdk.stringToCloudFormation(properties.width), XAxisLocation: cdk.stringToCloudFormation(properties.xAxisLocation), YAxisLocation: cdk.stringToCloudFormation(properties.yAxisLocation) }) : properties;
    }
    function CfnTemplateFreeFormLayoutElementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("backgroundStyle", "BackgroundStyle", properties.BackgroundStyle != null ? CfnTemplateFreeFormLayoutElementBackgroundStylePropertyFromCloudFormation(properties.BackgroundStyle) : void 0), ret.addPropertyResult("borderStyle", "BorderStyle", properties.BorderStyle != null ? CfnTemplateFreeFormLayoutElementBorderStylePropertyFromCloudFormation(properties.BorderStyle) : void 0), ret.addPropertyResult("elementId", "ElementId", cfn_parse.FromCloudFormation.getString(properties.ElementId)), ret.addPropertyResult("elementType", "ElementType", cfn_parse.FromCloudFormation.getString(properties.ElementType)), ret.addPropertyResult("height", "Height", cfn_parse.FromCloudFormation.getString(properties.Height)), ret.addPropertyResult("loadingAnimation", "LoadingAnimation", properties.LoadingAnimation != null ? CfnTemplateLoadingAnimationPropertyFromCloudFormation(properties.LoadingAnimation) : void 0), ret.addPropertyResult("renderingRules", "RenderingRules", properties.RenderingRules != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateSheetElementRenderingRulePropertyFromCloudFormation)(properties.RenderingRules) : void 0), ret.addPropertyResult("selectedBorderStyle", "SelectedBorderStyle", properties.SelectedBorderStyle != null ? CfnTemplateFreeFormLayoutElementBorderStylePropertyFromCloudFormation(properties.SelectedBorderStyle) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addPropertyResult("width", "Width", cfn_parse.FromCloudFormation.getString(properties.Width)), ret.addPropertyResult("xAxisLocation", "XAxisLocation", cfn_parse.FromCloudFormation.getString(properties.XAxisLocation)), ret.addPropertyResult("yAxisLocation", "YAxisLocation", cfn_parse.FromCloudFormation.getString(properties.YAxisLocation)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FreeFormLayoutElementBackgroundStylePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "FreeFormLayoutElementBackgroundStyleProperty"');
    }
    function cfnTemplateFreeFormLayoutElementBackgroundStylePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FreeFormLayoutElementBackgroundStylePropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnTemplateFreeFormLayoutElementBackgroundStylePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", properties.Color != null ? cfn_parse.FromCloudFormation.getString(properties.Color) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FreeFormLayoutElementBorderStylePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "FreeFormLayoutElementBorderStyleProperty"');
    }
    function cfnTemplateFreeFormLayoutElementBorderStylePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FreeFormLayoutElementBorderStylePropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnTemplateFreeFormLayoutElementBorderStylePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", properties.Color != null ? cfn_parse.FromCloudFormation.getString(properties.Color) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FreeFormLayoutScreenCanvasSizeOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("optimizedViewPortWidth", cdk.requiredValidator)(properties.optimizedViewPortWidth)), errors.collect(cdk.propertyValidator("optimizedViewPortWidth", cdk.validateString)(properties.optimizedViewPortWidth)), errors.wrap('supplied properties not correct for "FreeFormLayoutScreenCanvasSizeOptionsProperty"');
    }
    function cfnTemplateFreeFormLayoutScreenCanvasSizeOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FreeFormLayoutScreenCanvasSizeOptionsPropertyValidator(properties).assertSuccess(), { OptimizedViewPortWidth: cdk.stringToCloudFormation(properties.optimizedViewPortWidth) }) : properties;
    }
    function CfnTemplateFreeFormLayoutScreenCanvasSizeOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("optimizedViewPortWidth", "OptimizedViewPortWidth", cfn_parse.FromCloudFormation.getString(properties.OptimizedViewPortWidth)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FreeFormSectionLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("elements", cdk.requiredValidator)(properties.elements)), errors.collect(cdk.propertyValidator("elements", cdk.listValidator(CfnTemplate_FreeFormLayoutElementPropertyValidator))(properties.elements)), errors.wrap('supplied properties not correct for "FreeFormSectionLayoutConfigurationProperty"');
    }
    function cfnTemplateFreeFormSectionLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FreeFormSectionLayoutConfigurationPropertyValidator(properties).assertSuccess(), { Elements: cdk.listMapper(cfnTemplateFreeFormLayoutElementPropertyToCloudFormation)(properties.elements) }) : properties;
    }
    function CfnTemplateFreeFormSectionLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("elements", "Elements", cfn_parse.FromCloudFormation.getArray(CfnTemplateFreeFormLayoutElementPropertyFromCloudFormation)(properties.Elements)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FunnelChartAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("category", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.category)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnTemplate_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "FunnelChartAggregatedFieldWellsProperty"');
    }
    function cfnTemplateFunnelChartAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FunnelChartAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Category: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.category), Values: cdk.listMapper(cfnTemplateMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnTemplateFunnelChartAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("category", "Category", properties.Category != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.Category) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FunnelChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryLabelOptions", CfnTemplate_ChartAxisLabelOptionsPropertyValidator)(properties.categoryLabelOptions)), errors.collect(cdk.propertyValidator("dataLabelOptions", CfnTemplate_FunnelChartDataLabelOptionsPropertyValidator)(properties.dataLabelOptions)), errors.collect(cdk.propertyValidator("fieldWells", CfnTemplate_FunnelChartFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnTemplate_FunnelChartSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tooltip", CfnTemplate_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.collect(cdk.propertyValidator("valueLabelOptions", CfnTemplate_ChartAxisLabelOptionsPropertyValidator)(properties.valueLabelOptions)), errors.collect(cdk.propertyValidator("visualPalette", CfnTemplate_VisualPalettePropertyValidator)(properties.visualPalette)), errors.wrap('supplied properties not correct for "FunnelChartConfigurationProperty"');
    }
    function cfnTemplateFunnelChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FunnelChartConfigurationPropertyValidator(properties).assertSuccess(), { CategoryLabelOptions: cfnTemplateChartAxisLabelOptionsPropertyToCloudFormation(properties.categoryLabelOptions), DataLabelOptions: cfnTemplateFunnelChartDataLabelOptionsPropertyToCloudFormation(properties.dataLabelOptions), FieldWells: cfnTemplateFunnelChartFieldWellsPropertyToCloudFormation(properties.fieldWells), SortConfiguration: cfnTemplateFunnelChartSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), Tooltip: cfnTemplateTooltipOptionsPropertyToCloudFormation(properties.tooltip), ValueLabelOptions: cfnTemplateChartAxisLabelOptionsPropertyToCloudFormation(properties.valueLabelOptions), VisualPalette: cfnTemplateVisualPalettePropertyToCloudFormation(properties.visualPalette) }) : properties;
    }
    function CfnTemplateFunnelChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryLabelOptions", "CategoryLabelOptions", properties.CategoryLabelOptions != null ? CfnTemplateChartAxisLabelOptionsPropertyFromCloudFormation(properties.CategoryLabelOptions) : void 0), ret.addPropertyResult("dataLabelOptions", "DataLabelOptions", properties.DataLabelOptions != null ? CfnTemplateFunnelChartDataLabelOptionsPropertyFromCloudFormation(properties.DataLabelOptions) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnTemplateFunnelChartFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnTemplateFunnelChartSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnTemplateTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addPropertyResult("valueLabelOptions", "ValueLabelOptions", properties.ValueLabelOptions != null ? CfnTemplateChartAxisLabelOptionsPropertyFromCloudFormation(properties.ValueLabelOptions) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnTemplateVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FunnelChartDataLabelOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryLabelVisibility", cdk.validateString)(properties.categoryLabelVisibility)), errors.collect(cdk.propertyValidator("labelColor", cdk.validateString)(properties.labelColor)), errors.collect(cdk.propertyValidator("labelFontConfiguration", CfnTemplate_FontConfigurationPropertyValidator)(properties.labelFontConfiguration)), errors.collect(cdk.propertyValidator("measureDataLabelStyle", cdk.validateString)(properties.measureDataLabelStyle)), errors.collect(cdk.propertyValidator("measureLabelVisibility", cdk.validateString)(properties.measureLabelVisibility)), errors.collect(cdk.propertyValidator("position", cdk.validateString)(properties.position)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "FunnelChartDataLabelOptionsProperty"');
    }
    function cfnTemplateFunnelChartDataLabelOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FunnelChartDataLabelOptionsPropertyValidator(properties).assertSuccess(), { CategoryLabelVisibility: cdk.stringToCloudFormation(properties.categoryLabelVisibility), LabelColor: cdk.stringToCloudFormation(properties.labelColor), LabelFontConfiguration: cfnTemplateFontConfigurationPropertyToCloudFormation(properties.labelFontConfiguration), MeasureDataLabelStyle: cdk.stringToCloudFormation(properties.measureDataLabelStyle), MeasureLabelVisibility: cdk.stringToCloudFormation(properties.measureLabelVisibility), Position: cdk.stringToCloudFormation(properties.position), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnTemplateFunnelChartDataLabelOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryLabelVisibility", "CategoryLabelVisibility", properties.CategoryLabelVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.CategoryLabelVisibility) : void 0), ret.addPropertyResult("labelColor", "LabelColor", properties.LabelColor != null ? cfn_parse.FromCloudFormation.getString(properties.LabelColor) : void 0), ret.addPropertyResult("labelFontConfiguration", "LabelFontConfiguration", properties.LabelFontConfiguration != null ? CfnTemplateFontConfigurationPropertyFromCloudFormation(properties.LabelFontConfiguration) : void 0), ret.addPropertyResult("measureDataLabelStyle", "MeasureDataLabelStyle", properties.MeasureDataLabelStyle != null ? cfn_parse.FromCloudFormation.getString(properties.MeasureDataLabelStyle) : void 0), ret.addPropertyResult("measureLabelVisibility", "MeasureLabelVisibility", properties.MeasureLabelVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.MeasureLabelVisibility) : void 0), ret.addPropertyResult("position", "Position", properties.Position != null ? cfn_parse.FromCloudFormation.getString(properties.Position) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FunnelChartFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("funnelChartAggregatedFieldWells", CfnTemplate_FunnelChartAggregatedFieldWellsPropertyValidator)(properties.funnelChartAggregatedFieldWells)), errors.wrap('supplied properties not correct for "FunnelChartFieldWellsProperty"');
    }
    function cfnTemplateFunnelChartFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FunnelChartFieldWellsPropertyValidator(properties).assertSuccess(), { FunnelChartAggregatedFieldWells: cfnTemplateFunnelChartAggregatedFieldWellsPropertyToCloudFormation(properties.funnelChartAggregatedFieldWells) }) : properties;
    }
    function CfnTemplateFunnelChartFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("funnelChartAggregatedFieldWells", "FunnelChartAggregatedFieldWells", properties.FunnelChartAggregatedFieldWells != null ? CfnTemplateFunnelChartAggregatedFieldWellsPropertyFromCloudFormation(properties.FunnelChartAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FunnelChartSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryItemsLimit", CfnTemplate_ItemsLimitConfigurationPropertyValidator)(properties.categoryItemsLimit)), errors.collect(cdk.propertyValidator("categorySort", cdk.listValidator(CfnTemplate_FieldSortOptionsPropertyValidator))(properties.categorySort)), errors.wrap('supplied properties not correct for "FunnelChartSortConfigurationProperty"');
    }
    function cfnTemplateFunnelChartSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FunnelChartSortConfigurationPropertyValidator(properties).assertSuccess(), { CategoryItemsLimit: cfnTemplateItemsLimitConfigurationPropertyToCloudFormation(properties.categoryItemsLimit), CategorySort: cdk.listMapper(cfnTemplateFieldSortOptionsPropertyToCloudFormation)(properties.categorySort) }) : properties;
    }
    function CfnTemplateFunnelChartSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryItemsLimit", "CategoryItemsLimit", properties.CategoryItemsLimit != null ? CfnTemplateItemsLimitConfigurationPropertyFromCloudFormation(properties.CategoryItemsLimit) : void 0), ret.addPropertyResult("categorySort", "CategorySort", properties.CategorySort != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateFieldSortOptionsPropertyFromCloudFormation)(properties.CategorySort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_FunnelChartVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnTemplate_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnTemplate_FunnelChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnTemplate_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnTemplate_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnTemplate_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "FunnelChartVisualProperty"');
    }
    function cfnTemplateFunnelChartVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_FunnelChartVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnTemplateVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnTemplateFunnelChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnTemplateColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnTemplateVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnTemplateVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnTemplateFunnelChartVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnTemplateFunnelChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnTemplateVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnTemplateVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_GaugeChartArcConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("foregroundColor", CfnTemplate_ConditionalFormattingColorPropertyValidator)(properties.foregroundColor)), errors.wrap('supplied properties not correct for "GaugeChartArcConditionalFormattingProperty"');
    }
    function cfnTemplateGaugeChartArcConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_GaugeChartArcConditionalFormattingPropertyValidator(properties).assertSuccess(), { ForegroundColor: cfnTemplateConditionalFormattingColorPropertyToCloudFormation(properties.foregroundColor) }) : properties;
    }
    function CfnTemplateGaugeChartArcConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("foregroundColor", "ForegroundColor", properties.ForegroundColor != null ? CfnTemplateConditionalFormattingColorPropertyFromCloudFormation(properties.ForegroundColor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_GaugeChartConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("conditionalFormattingOptions", cdk.listValidator(CfnTemplate_GaugeChartConditionalFormattingOptionPropertyValidator))(properties.conditionalFormattingOptions)), errors.wrap('supplied properties not correct for "GaugeChartConditionalFormattingProperty"');
    }
    function cfnTemplateGaugeChartConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_GaugeChartConditionalFormattingPropertyValidator(properties).assertSuccess(), { ConditionalFormattingOptions: cdk.listMapper(cfnTemplateGaugeChartConditionalFormattingOptionPropertyToCloudFormation)(properties.conditionalFormattingOptions) }) : properties;
    }
    function CfnTemplateGaugeChartConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("conditionalFormattingOptions", "ConditionalFormattingOptions", properties.ConditionalFormattingOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateGaugeChartConditionalFormattingOptionPropertyFromCloudFormation)(properties.ConditionalFormattingOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_GaugeChartConditionalFormattingOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arc", CfnTemplate_GaugeChartArcConditionalFormattingPropertyValidator)(properties.arc)), errors.collect(cdk.propertyValidator("primaryValue", CfnTemplate_GaugeChartPrimaryValueConditionalFormattingPropertyValidator)(properties.primaryValue)), errors.wrap('supplied properties not correct for "GaugeChartConditionalFormattingOptionProperty"');
    }
    function cfnTemplateGaugeChartConditionalFormattingOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_GaugeChartConditionalFormattingOptionPropertyValidator(properties).assertSuccess(), { Arc: cfnTemplateGaugeChartArcConditionalFormattingPropertyToCloudFormation(properties.arc), PrimaryValue: cfnTemplateGaugeChartPrimaryValueConditionalFormattingPropertyToCloudFormation(properties.primaryValue) }) : properties;
    }
    function CfnTemplateGaugeChartConditionalFormattingOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arc", "Arc", properties.Arc != null ? CfnTemplateGaugeChartArcConditionalFormattingPropertyFromCloudFormation(properties.Arc) : void 0), ret.addPropertyResult("primaryValue", "PrimaryValue", properties.PrimaryValue != null ? CfnTemplateGaugeChartPrimaryValueConditionalFormattingPropertyFromCloudFormation(properties.PrimaryValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_GaugeChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataLabels", CfnTemplate_DataLabelOptionsPropertyValidator)(properties.dataLabels)), errors.collect(cdk.propertyValidator("fieldWells", CfnTemplate_GaugeChartFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("gaugeChartOptions", CfnTemplate_GaugeChartOptionsPropertyValidator)(properties.gaugeChartOptions)), errors.collect(cdk.propertyValidator("tooltipOptions", CfnTemplate_TooltipOptionsPropertyValidator)(properties.tooltipOptions)), errors.collect(cdk.propertyValidator("visualPalette", CfnTemplate_VisualPalettePropertyValidator)(properties.visualPalette)), errors.wrap('supplied properties not correct for "GaugeChartConfigurationProperty"');
    }
    function cfnTemplateGaugeChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_GaugeChartConfigurationPropertyValidator(properties).assertSuccess(), { DataLabels: cfnTemplateDataLabelOptionsPropertyToCloudFormation(properties.dataLabels), FieldWells: cfnTemplateGaugeChartFieldWellsPropertyToCloudFormation(properties.fieldWells), GaugeChartOptions: cfnTemplateGaugeChartOptionsPropertyToCloudFormation(properties.gaugeChartOptions), TooltipOptions: cfnTemplateTooltipOptionsPropertyToCloudFormation(properties.tooltipOptions), VisualPalette: cfnTemplateVisualPalettePropertyToCloudFormation(properties.visualPalette) }) : properties;
    }
    function CfnTemplateGaugeChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataLabels", "DataLabels", properties.DataLabels != null ? CfnTemplateDataLabelOptionsPropertyFromCloudFormation(properties.DataLabels) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnTemplateGaugeChartFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("gaugeChartOptions", "GaugeChartOptions", properties.GaugeChartOptions != null ? CfnTemplateGaugeChartOptionsPropertyFromCloudFormation(properties.GaugeChartOptions) : void 0), ret.addPropertyResult("tooltipOptions", "TooltipOptions", properties.TooltipOptions != null ? CfnTemplateTooltipOptionsPropertyFromCloudFormation(properties.TooltipOptions) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnTemplateVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_GaugeChartFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("targetValues", cdk.listValidator(CfnTemplate_MeasureFieldPropertyValidator))(properties.targetValues)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnTemplate_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "GaugeChartFieldWellsProperty"');
    }
    function cfnTemplateGaugeChartFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_GaugeChartFieldWellsPropertyValidator(properties).assertSuccess(), { TargetValues: cdk.listMapper(cfnTemplateMeasureFieldPropertyToCloudFormation)(properties.targetValues), Values: cdk.listMapper(cfnTemplateMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnTemplateGaugeChartFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("targetValues", "TargetValues", properties.TargetValues != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMeasureFieldPropertyFromCloudFormation)(properties.TargetValues) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_GaugeChartOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arc", CfnTemplate_ArcConfigurationPropertyValidator)(properties.arc)), errors.collect(cdk.propertyValidator("arcAxis", CfnTemplate_ArcAxisConfigurationPropertyValidator)(properties.arcAxis)), errors.collect(cdk.propertyValidator("comparison", CfnTemplate_ComparisonConfigurationPropertyValidator)(properties.comparison)), errors.collect(cdk.propertyValidator("primaryValueDisplayType", cdk.validateString)(properties.primaryValueDisplayType)), errors.collect(cdk.propertyValidator("primaryValueFontConfiguration", CfnTemplate_FontConfigurationPropertyValidator)(properties.primaryValueFontConfiguration)), errors.wrap('supplied properties not correct for "GaugeChartOptionsProperty"');
    }
    function cfnTemplateGaugeChartOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_GaugeChartOptionsPropertyValidator(properties).assertSuccess(), { Arc: cfnTemplateArcConfigurationPropertyToCloudFormation(properties.arc), ArcAxis: cfnTemplateArcAxisConfigurationPropertyToCloudFormation(properties.arcAxis), Comparison: cfnTemplateComparisonConfigurationPropertyToCloudFormation(properties.comparison), PrimaryValueDisplayType: cdk.stringToCloudFormation(properties.primaryValueDisplayType), PrimaryValueFontConfiguration: cfnTemplateFontConfigurationPropertyToCloudFormation(properties.primaryValueFontConfiguration) }) : properties;
    }
    function CfnTemplateGaugeChartOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arc", "Arc", properties.Arc != null ? CfnTemplateArcConfigurationPropertyFromCloudFormation(properties.Arc) : void 0), ret.addPropertyResult("arcAxis", "ArcAxis", properties.ArcAxis != null ? CfnTemplateArcAxisConfigurationPropertyFromCloudFormation(properties.ArcAxis) : void 0), ret.addPropertyResult("comparison", "Comparison", properties.Comparison != null ? CfnTemplateComparisonConfigurationPropertyFromCloudFormation(properties.Comparison) : void 0), ret.addPropertyResult("primaryValueDisplayType", "PrimaryValueDisplayType", properties.PrimaryValueDisplayType != null ? cfn_parse.FromCloudFormation.getString(properties.PrimaryValueDisplayType) : void 0), ret.addPropertyResult("primaryValueFontConfiguration", "PrimaryValueFontConfiguration", properties.PrimaryValueFontConfiguration != null ? CfnTemplateFontConfigurationPropertyFromCloudFormation(properties.PrimaryValueFontConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_GaugeChartPrimaryValueConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("icon", CfnTemplate_ConditionalFormattingIconPropertyValidator)(properties.icon)), errors.collect(cdk.propertyValidator("textColor", CfnTemplate_ConditionalFormattingColorPropertyValidator)(properties.textColor)), errors.wrap('supplied properties not correct for "GaugeChartPrimaryValueConditionalFormattingProperty"');
    }
    function cfnTemplateGaugeChartPrimaryValueConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_GaugeChartPrimaryValueConditionalFormattingPropertyValidator(properties).assertSuccess(), { Icon: cfnTemplateConditionalFormattingIconPropertyToCloudFormation(properties.icon), TextColor: cfnTemplateConditionalFormattingColorPropertyToCloudFormation(properties.textColor) }) : properties;
    }
    function CfnTemplateGaugeChartPrimaryValueConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("icon", "Icon", properties.Icon != null ? CfnTemplateConditionalFormattingIconPropertyFromCloudFormation(properties.Icon) : void 0), ret.addPropertyResult("textColor", "TextColor", properties.TextColor != null ? CfnTemplateConditionalFormattingColorPropertyFromCloudFormation(properties.TextColor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_GaugeChartVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnTemplate_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnTemplate_GaugeChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("conditionalFormatting", CfnTemplate_GaugeChartConditionalFormattingPropertyValidator)(properties.conditionalFormatting)), errors.collect(cdk.propertyValidator("subtitle", CfnTemplate_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnTemplate_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "GaugeChartVisualProperty"');
    }
    function cfnTemplateGaugeChartVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_GaugeChartVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnTemplateVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnTemplateGaugeChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), ConditionalFormatting: cfnTemplateGaugeChartConditionalFormattingPropertyToCloudFormation(properties.conditionalFormatting), Subtitle: cfnTemplateVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnTemplateVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnTemplateGaugeChartVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnTemplateGaugeChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("conditionalFormatting", "ConditionalFormatting", properties.ConditionalFormatting != null ? CfnTemplateGaugeChartConditionalFormattingPropertyFromCloudFormation(properties.ConditionalFormatting) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnTemplateVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnTemplateVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_GeospatialCoordinateBoundsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("east", cdk.requiredValidator)(properties.east)), errors.collect(cdk.propertyValidator("east", cdk.validateNumber)(properties.east)), errors.collect(cdk.propertyValidator("north", cdk.requiredValidator)(properties.north)), errors.collect(cdk.propertyValidator("north", cdk.validateNumber)(properties.north)), errors.collect(cdk.propertyValidator("south", cdk.requiredValidator)(properties.south)), errors.collect(cdk.propertyValidator("south", cdk.validateNumber)(properties.south)), errors.collect(cdk.propertyValidator("west", cdk.requiredValidator)(properties.west)), errors.collect(cdk.propertyValidator("west", cdk.validateNumber)(properties.west)), errors.wrap('supplied properties not correct for "GeospatialCoordinateBoundsProperty"');
    }
    function cfnTemplateGeospatialCoordinateBoundsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_GeospatialCoordinateBoundsPropertyValidator(properties).assertSuccess(), { East: cdk.numberToCloudFormation(properties.east), North: cdk.numberToCloudFormation(properties.north), South: cdk.numberToCloudFormation(properties.south), West: cdk.numberToCloudFormation(properties.west) }) : properties;
    }
    function CfnTemplateGeospatialCoordinateBoundsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("east", "East", cfn_parse.FromCloudFormation.getNumber(properties.East)), ret.addPropertyResult("north", "North", cfn_parse.FromCloudFormation.getNumber(properties.North)), ret.addPropertyResult("south", "South", cfn_parse.FromCloudFormation.getNumber(properties.South)), ret.addPropertyResult("west", "West", cfn_parse.FromCloudFormation.getNumber(properties.West)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_GeospatialMapAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("colors", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.colors)), errors.collect(cdk.propertyValidator("geospatial", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.geospatial)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnTemplate_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "GeospatialMapAggregatedFieldWellsProperty"');
    }
    function cfnTemplateGeospatialMapAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_GeospatialMapAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Colors: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.colors), Geospatial: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.geospatial), Values: cdk.listMapper(cfnTemplateMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnTemplateGeospatialMapAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("colors", "Colors", properties.Colors != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.Colors) : void 0), ret.addPropertyResult("geospatial", "Geospatial", properties.Geospatial != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.Geospatial) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_GeospatialMapConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldWells", CfnTemplate_GeospatialMapFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("legend", CfnTemplate_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("mapStyleOptions", CfnTemplate_GeospatialMapStyleOptionsPropertyValidator)(properties.mapStyleOptions)), errors.collect(cdk.propertyValidator("pointStyleOptions", CfnTemplate_GeospatialPointStyleOptionsPropertyValidator)(properties.pointStyleOptions)), errors.collect(cdk.propertyValidator("tooltip", CfnTemplate_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.collect(cdk.propertyValidator("visualPalette", CfnTemplate_VisualPalettePropertyValidator)(properties.visualPalette)), errors.collect(cdk.propertyValidator("windowOptions", CfnTemplate_GeospatialWindowOptionsPropertyValidator)(properties.windowOptions)), errors.wrap('supplied properties not correct for "GeospatialMapConfigurationProperty"');
    }
    function cfnTemplateGeospatialMapConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_GeospatialMapConfigurationPropertyValidator(properties).assertSuccess(), { FieldWells: cfnTemplateGeospatialMapFieldWellsPropertyToCloudFormation(properties.fieldWells), Legend: cfnTemplateLegendOptionsPropertyToCloudFormation(properties.legend), MapStyleOptions: cfnTemplateGeospatialMapStyleOptionsPropertyToCloudFormation(properties.mapStyleOptions), PointStyleOptions: cfnTemplateGeospatialPointStyleOptionsPropertyToCloudFormation(properties.pointStyleOptions), Tooltip: cfnTemplateTooltipOptionsPropertyToCloudFormation(properties.tooltip), VisualPalette: cfnTemplateVisualPalettePropertyToCloudFormation(properties.visualPalette), WindowOptions: cfnTemplateGeospatialWindowOptionsPropertyToCloudFormation(properties.windowOptions) }) : properties;
    }
    function CfnTemplateGeospatialMapConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnTemplateGeospatialMapFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnTemplateLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("mapStyleOptions", "MapStyleOptions", properties.MapStyleOptions != null ? CfnTemplateGeospatialMapStyleOptionsPropertyFromCloudFormation(properties.MapStyleOptions) : void 0), ret.addPropertyResult("pointStyleOptions", "PointStyleOptions", properties.PointStyleOptions != null ? CfnTemplateGeospatialPointStyleOptionsPropertyFromCloudFormation(properties.PointStyleOptions) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnTemplateTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnTemplateVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addPropertyResult("windowOptions", "WindowOptions", properties.WindowOptions != null ? CfnTemplateGeospatialWindowOptionsPropertyFromCloudFormation(properties.WindowOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_GeospatialMapFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("geospatialMapAggregatedFieldWells", CfnTemplate_GeospatialMapAggregatedFieldWellsPropertyValidator)(properties.geospatialMapAggregatedFieldWells)), errors.wrap('supplied properties not correct for "GeospatialMapFieldWellsProperty"');
    }
    function cfnTemplateGeospatialMapFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_GeospatialMapFieldWellsPropertyValidator(properties).assertSuccess(), { GeospatialMapAggregatedFieldWells: cfnTemplateGeospatialMapAggregatedFieldWellsPropertyToCloudFormation(properties.geospatialMapAggregatedFieldWells) }) : properties;
    }
    function CfnTemplateGeospatialMapFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("geospatialMapAggregatedFieldWells", "GeospatialMapAggregatedFieldWells", properties.GeospatialMapAggregatedFieldWells != null ? CfnTemplateGeospatialMapAggregatedFieldWellsPropertyFromCloudFormation(properties.GeospatialMapAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_GeospatialMapStyleOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("baseMapStyle", cdk.validateString)(properties.baseMapStyle)), errors.wrap('supplied properties not correct for "GeospatialMapStyleOptionsProperty"');
    }
    function cfnTemplateGeospatialMapStyleOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_GeospatialMapStyleOptionsPropertyValidator(properties).assertSuccess(), { BaseMapStyle: cdk.stringToCloudFormation(properties.baseMapStyle) }) : properties;
    }
    function CfnTemplateGeospatialMapStyleOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("baseMapStyle", "BaseMapStyle", properties.BaseMapStyle != null ? cfn_parse.FromCloudFormation.getString(properties.BaseMapStyle) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_GeospatialMapVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnTemplate_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnTemplate_GeospatialMapConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnTemplate_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnTemplate_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnTemplate_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "GeospatialMapVisualProperty"');
    }
    function cfnTemplateGeospatialMapVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_GeospatialMapVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnTemplateVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnTemplateGeospatialMapConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnTemplateColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnTemplateVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnTemplateVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnTemplateGeospatialMapVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnTemplateGeospatialMapConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnTemplateVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnTemplateVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_GeospatialPointStyleOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clusterMarkerConfiguration", CfnTemplate_ClusterMarkerConfigurationPropertyValidator)(properties.clusterMarkerConfiguration)), errors.collect(cdk.propertyValidator("selectedPointStyle", cdk.validateString)(properties.selectedPointStyle)), errors.wrap('supplied properties not correct for "GeospatialPointStyleOptionsProperty"');
    }
    function cfnTemplateGeospatialPointStyleOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_GeospatialPointStyleOptionsPropertyValidator(properties).assertSuccess(), { ClusterMarkerConfiguration: cfnTemplateClusterMarkerConfigurationPropertyToCloudFormation(properties.clusterMarkerConfiguration), SelectedPointStyle: cdk.stringToCloudFormation(properties.selectedPointStyle) }) : properties;
    }
    function CfnTemplateGeospatialPointStyleOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clusterMarkerConfiguration", "ClusterMarkerConfiguration", properties.ClusterMarkerConfiguration != null ? CfnTemplateClusterMarkerConfigurationPropertyFromCloudFormation(properties.ClusterMarkerConfiguration) : void 0), ret.addPropertyResult("selectedPointStyle", "SelectedPointStyle", properties.SelectedPointStyle != null ? cfn_parse.FromCloudFormation.getString(properties.SelectedPointStyle) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_GeospatialWindowOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bounds", CfnTemplate_GeospatialCoordinateBoundsPropertyValidator)(properties.bounds)), errors.collect(cdk.propertyValidator("mapZoomMode", cdk.validateString)(properties.mapZoomMode)), errors.wrap('supplied properties not correct for "GeospatialWindowOptionsProperty"');
    }
    function cfnTemplateGeospatialWindowOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_GeospatialWindowOptionsPropertyValidator(properties).assertSuccess(), { Bounds: cfnTemplateGeospatialCoordinateBoundsPropertyToCloudFormation(properties.bounds), MapZoomMode: cdk.stringToCloudFormation(properties.mapZoomMode) }) : properties;
    }
    function CfnTemplateGeospatialWindowOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bounds", "Bounds", properties.Bounds != null ? CfnTemplateGeospatialCoordinateBoundsPropertyFromCloudFormation(properties.Bounds) : void 0), ret.addPropertyResult("mapZoomMode", "MapZoomMode", properties.MapZoomMode != null ? cfn_parse.FromCloudFormation.getString(properties.MapZoomMode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_GlobalTableBorderOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sideSpecificBorder", CfnTemplate_TableSideBorderOptionsPropertyValidator)(properties.sideSpecificBorder)), errors.collect(cdk.propertyValidator("uniformBorder", CfnTemplate_TableBorderOptionsPropertyValidator)(properties.uniformBorder)), errors.wrap('supplied properties not correct for "GlobalTableBorderOptionsProperty"');
    }
    function cfnTemplateGlobalTableBorderOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_GlobalTableBorderOptionsPropertyValidator(properties).assertSuccess(), { SideSpecificBorder: cfnTemplateTableSideBorderOptionsPropertyToCloudFormation(properties.sideSpecificBorder), UniformBorder: cfnTemplateTableBorderOptionsPropertyToCloudFormation(properties.uniformBorder) }) : properties;
    }
    function CfnTemplateGlobalTableBorderOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sideSpecificBorder", "SideSpecificBorder", properties.SideSpecificBorder != null ? CfnTemplateTableSideBorderOptionsPropertyFromCloudFormation(properties.SideSpecificBorder) : void 0), ret.addPropertyResult("uniformBorder", "UniformBorder", properties.UniformBorder != null ? CfnTemplateTableBorderOptionsPropertyFromCloudFormation(properties.UniformBorder) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_GradientColorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("stops", cdk.listValidator(CfnTemplate_GradientStopPropertyValidator))(properties.stops)), errors.wrap('supplied properties not correct for "GradientColorProperty"');
    }
    function cfnTemplateGradientColorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_GradientColorPropertyValidator(properties).assertSuccess(), { Stops: cdk.listMapper(cfnTemplateGradientStopPropertyToCloudFormation)(properties.stops) }) : properties;
    }
    function CfnTemplateGradientColorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("stops", "Stops", properties.Stops != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateGradientStopPropertyFromCloudFormation)(properties.Stops) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_GradientStopPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.collect(cdk.propertyValidator("dataValue", cdk.validateNumber)(properties.dataValue)), errors.collect(cdk.propertyValidator("gradientOffset", cdk.requiredValidator)(properties.gradientOffset)), errors.collect(cdk.propertyValidator("gradientOffset", cdk.validateNumber)(properties.gradientOffset)), errors.wrap('supplied properties not correct for "GradientStopProperty"');
    }
    function cfnTemplateGradientStopPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_GradientStopPropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color), DataValue: cdk.numberToCloudFormation(properties.dataValue), GradientOffset: cdk.numberToCloudFormation(properties.gradientOffset) }) : properties;
    }
    function CfnTemplateGradientStopPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", properties.Color != null ? cfn_parse.FromCloudFormation.getString(properties.Color) : void 0), ret.addPropertyResult("dataValue", "DataValue", properties.DataValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.DataValue) : void 0), ret.addPropertyResult("gradientOffset", "GradientOffset", cfn_parse.FromCloudFormation.getNumber(properties.GradientOffset)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_GridLayoutCanvasSizeOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("screenCanvasSizeOptions", CfnTemplate_GridLayoutScreenCanvasSizeOptionsPropertyValidator)(properties.screenCanvasSizeOptions)), errors.wrap('supplied properties not correct for "GridLayoutCanvasSizeOptionsProperty"');
    }
    function cfnTemplateGridLayoutCanvasSizeOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_GridLayoutCanvasSizeOptionsPropertyValidator(properties).assertSuccess(), { ScreenCanvasSizeOptions: cfnTemplateGridLayoutScreenCanvasSizeOptionsPropertyToCloudFormation(properties.screenCanvasSizeOptions) }) : properties;
    }
    function CfnTemplateGridLayoutCanvasSizeOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("screenCanvasSizeOptions", "ScreenCanvasSizeOptions", properties.ScreenCanvasSizeOptions != null ? CfnTemplateGridLayoutScreenCanvasSizeOptionsPropertyFromCloudFormation(properties.ScreenCanvasSizeOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_GridLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("canvasSizeOptions", CfnTemplate_GridLayoutCanvasSizeOptionsPropertyValidator)(properties.canvasSizeOptions)), errors.collect(cdk.propertyValidator("elements", cdk.requiredValidator)(properties.elements)), errors.collect(cdk.propertyValidator("elements", cdk.listValidator(CfnTemplate_GridLayoutElementPropertyValidator))(properties.elements)), errors.wrap('supplied properties not correct for "GridLayoutConfigurationProperty"');
    }
    function cfnTemplateGridLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_GridLayoutConfigurationPropertyValidator(properties).assertSuccess(), { CanvasSizeOptions: cfnTemplateGridLayoutCanvasSizeOptionsPropertyToCloudFormation(properties.canvasSizeOptions), Elements: cdk.listMapper(cfnTemplateGridLayoutElementPropertyToCloudFormation)(properties.elements) }) : properties;
    }
    function CfnTemplateGridLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("canvasSizeOptions", "CanvasSizeOptions", properties.CanvasSizeOptions != null ? CfnTemplateGridLayoutCanvasSizeOptionsPropertyFromCloudFormation(properties.CanvasSizeOptions) : void 0), ret.addPropertyResult("elements", "Elements", cfn_parse.FromCloudFormation.getArray(CfnTemplateGridLayoutElementPropertyFromCloudFormation)(properties.Elements)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_GridLayoutElementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnIndex", cdk.validateNumber)(properties.columnIndex)), errors.collect(cdk.propertyValidator("columnSpan", cdk.requiredValidator)(properties.columnSpan)), errors.collect(cdk.propertyValidator("columnSpan", cdk.validateNumber)(properties.columnSpan)), errors.collect(cdk.propertyValidator("elementId", cdk.requiredValidator)(properties.elementId)), errors.collect(cdk.propertyValidator("elementId", cdk.validateString)(properties.elementId)), errors.collect(cdk.propertyValidator("elementType", cdk.requiredValidator)(properties.elementType)), errors.collect(cdk.propertyValidator("elementType", cdk.validateString)(properties.elementType)), errors.collect(cdk.propertyValidator("rowIndex", cdk.validateNumber)(properties.rowIndex)), errors.collect(cdk.propertyValidator("rowSpan", cdk.requiredValidator)(properties.rowSpan)), errors.collect(cdk.propertyValidator("rowSpan", cdk.validateNumber)(properties.rowSpan)), errors.wrap('supplied properties not correct for "GridLayoutElementProperty"');
    }
    function cfnTemplateGridLayoutElementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_GridLayoutElementPropertyValidator(properties).assertSuccess(), { ColumnIndex: cdk.numberToCloudFormation(properties.columnIndex), ColumnSpan: cdk.numberToCloudFormation(properties.columnSpan), ElementId: cdk.stringToCloudFormation(properties.elementId), ElementType: cdk.stringToCloudFormation(properties.elementType), RowIndex: cdk.numberToCloudFormation(properties.rowIndex), RowSpan: cdk.numberToCloudFormation(properties.rowSpan) }) : properties;
    }
    function CfnTemplateGridLayoutElementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columnIndex", "ColumnIndex", properties.ColumnIndex != null ? cfn_parse.FromCloudFormation.getNumber(properties.ColumnIndex) : void 0), ret.addPropertyResult("columnSpan", "ColumnSpan", cfn_parse.FromCloudFormation.getNumber(properties.ColumnSpan)), ret.addPropertyResult("elementId", "ElementId", cfn_parse.FromCloudFormation.getString(properties.ElementId)), ret.addPropertyResult("elementType", "ElementType", cfn_parse.FromCloudFormation.getString(properties.ElementType)), ret.addPropertyResult("rowIndex", "RowIndex", properties.RowIndex != null ? cfn_parse.FromCloudFormation.getNumber(properties.RowIndex) : void 0), ret.addPropertyResult("rowSpan", "RowSpan", cfn_parse.FromCloudFormation.getNumber(properties.RowSpan)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_GridLayoutScreenCanvasSizeOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("optimizedViewPortWidth", cdk.validateString)(properties.optimizedViewPortWidth)), errors.collect(cdk.propertyValidator("resizeOption", cdk.requiredValidator)(properties.resizeOption)), errors.collect(cdk.propertyValidator("resizeOption", cdk.validateString)(properties.resizeOption)), errors.wrap('supplied properties not correct for "GridLayoutScreenCanvasSizeOptionsProperty"');
    }
    function cfnTemplateGridLayoutScreenCanvasSizeOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_GridLayoutScreenCanvasSizeOptionsPropertyValidator(properties).assertSuccess(), { OptimizedViewPortWidth: cdk.stringToCloudFormation(properties.optimizedViewPortWidth), ResizeOption: cdk.stringToCloudFormation(properties.resizeOption) }) : properties;
    }
    function CfnTemplateGridLayoutScreenCanvasSizeOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("optimizedViewPortWidth", "OptimizedViewPortWidth", properties.OptimizedViewPortWidth != null ? cfn_parse.FromCloudFormation.getString(properties.OptimizedViewPortWidth) : void 0), ret.addPropertyResult("resizeOption", "ResizeOption", cfn_parse.FromCloudFormation.getString(properties.ResizeOption)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_GrowthRateComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computationId", cdk.requiredValidator)(properties.computationId)), errors.collect(cdk.propertyValidator("computationId", cdk.validateString)(properties.computationId)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("periodSize", cdk.validateNumber)(properties.periodSize)), errors.collect(cdk.propertyValidator("time", cdk.requiredValidator)(properties.time)), errors.collect(cdk.propertyValidator("time", CfnTemplate_DimensionFieldPropertyValidator)(properties.time)), errors.collect(cdk.propertyValidator("value", CfnTemplate_MeasureFieldPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "GrowthRateComputationProperty"');
    }
    function cfnTemplateGrowthRateComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_GrowthRateComputationPropertyValidator(properties).assertSuccess(), { ComputationId: cdk.stringToCloudFormation(properties.computationId), Name: cdk.stringToCloudFormation(properties.name), PeriodSize: cdk.numberToCloudFormation(properties.periodSize), Time: cfnTemplateDimensionFieldPropertyToCloudFormation(properties.time), Value: cfnTemplateMeasureFieldPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnTemplateGrowthRateComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computationId", "ComputationId", cfn_parse.FromCloudFormation.getString(properties.ComputationId)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("periodSize", "PeriodSize", properties.PeriodSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.PeriodSize) : void 0), ret.addPropertyResult("time", "Time", CfnTemplateDimensionFieldPropertyFromCloudFormation(properties.Time)), ret.addPropertyResult("value", "Value", properties.Value != null ? CfnTemplateMeasureFieldPropertyFromCloudFormation(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_HeaderFooterSectionConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("layout", cdk.requiredValidator)(properties.layout)), errors.collect(cdk.propertyValidator("layout", CfnTemplate_SectionLayoutConfigurationPropertyValidator)(properties.layout)), errors.collect(cdk.propertyValidator("sectionId", cdk.requiredValidator)(properties.sectionId)), errors.collect(cdk.propertyValidator("sectionId", cdk.validateString)(properties.sectionId)), errors.collect(cdk.propertyValidator("style", CfnTemplate_SectionStylePropertyValidator)(properties.style)), errors.wrap('supplied properties not correct for "HeaderFooterSectionConfigurationProperty"');
    }
    function cfnTemplateHeaderFooterSectionConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_HeaderFooterSectionConfigurationPropertyValidator(properties).assertSuccess(), { Layout: cfnTemplateSectionLayoutConfigurationPropertyToCloudFormation(properties.layout), SectionId: cdk.stringToCloudFormation(properties.sectionId), Style: cfnTemplateSectionStylePropertyToCloudFormation(properties.style) }) : properties;
    }
    function CfnTemplateHeaderFooterSectionConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("layout", "Layout", CfnTemplateSectionLayoutConfigurationPropertyFromCloudFormation(properties.Layout)), ret.addPropertyResult("sectionId", "SectionId", cfn_parse.FromCloudFormation.getString(properties.SectionId)), ret.addPropertyResult("style", "Style", properties.Style != null ? CfnTemplateSectionStylePropertyFromCloudFormation(properties.Style) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_HeatMapAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columns", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.columns)), errors.collect(cdk.propertyValidator("rows", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.rows)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnTemplate_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "HeatMapAggregatedFieldWellsProperty"');
    }
    function cfnTemplateHeatMapAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_HeatMapAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Columns: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.columns), Rows: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.rows), Values: cdk.listMapper(cfnTemplateMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnTemplateHeatMapAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columns", "Columns", properties.Columns != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.Columns) : void 0), ret.addPropertyResult("rows", "Rows", properties.Rows != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.Rows) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_HeatMapConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("colorScale", CfnTemplate_ColorScalePropertyValidator)(properties.colorScale)), errors.collect(cdk.propertyValidator("columnLabelOptions", CfnTemplate_ChartAxisLabelOptionsPropertyValidator)(properties.columnLabelOptions)), errors.collect(cdk.propertyValidator("dataLabels", CfnTemplate_DataLabelOptionsPropertyValidator)(properties.dataLabels)), errors.collect(cdk.propertyValidator("fieldWells", CfnTemplate_HeatMapFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("legend", CfnTemplate_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("rowLabelOptions", CfnTemplate_ChartAxisLabelOptionsPropertyValidator)(properties.rowLabelOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnTemplate_HeatMapSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tooltip", CfnTemplate_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.wrap('supplied properties not correct for "HeatMapConfigurationProperty"');
    }
    function cfnTemplateHeatMapConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_HeatMapConfigurationPropertyValidator(properties).assertSuccess(), { ColorScale: cfnTemplateColorScalePropertyToCloudFormation(properties.colorScale), ColumnLabelOptions: cfnTemplateChartAxisLabelOptionsPropertyToCloudFormation(properties.columnLabelOptions), DataLabels: cfnTemplateDataLabelOptionsPropertyToCloudFormation(properties.dataLabels), FieldWells: cfnTemplateHeatMapFieldWellsPropertyToCloudFormation(properties.fieldWells), Legend: cfnTemplateLegendOptionsPropertyToCloudFormation(properties.legend), RowLabelOptions: cfnTemplateChartAxisLabelOptionsPropertyToCloudFormation(properties.rowLabelOptions), SortConfiguration: cfnTemplateHeatMapSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), Tooltip: cfnTemplateTooltipOptionsPropertyToCloudFormation(properties.tooltip) }) : properties;
    }
    function CfnTemplateHeatMapConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("colorScale", "ColorScale", properties.ColorScale != null ? CfnTemplateColorScalePropertyFromCloudFormation(properties.ColorScale) : void 0), ret.addPropertyResult("columnLabelOptions", "ColumnLabelOptions", properties.ColumnLabelOptions != null ? CfnTemplateChartAxisLabelOptionsPropertyFromCloudFormation(properties.ColumnLabelOptions) : void 0), ret.addPropertyResult("dataLabels", "DataLabels", properties.DataLabels != null ? CfnTemplateDataLabelOptionsPropertyFromCloudFormation(properties.DataLabels) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnTemplateHeatMapFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnTemplateLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("rowLabelOptions", "RowLabelOptions", properties.RowLabelOptions != null ? CfnTemplateChartAxisLabelOptionsPropertyFromCloudFormation(properties.RowLabelOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnTemplateHeatMapSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnTemplateTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_HeatMapFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("heatMapAggregatedFieldWells", CfnTemplate_HeatMapAggregatedFieldWellsPropertyValidator)(properties.heatMapAggregatedFieldWells)), errors.wrap('supplied properties not correct for "HeatMapFieldWellsProperty"');
    }
    function cfnTemplateHeatMapFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_HeatMapFieldWellsPropertyValidator(properties).assertSuccess(), { HeatMapAggregatedFieldWells: cfnTemplateHeatMapAggregatedFieldWellsPropertyToCloudFormation(properties.heatMapAggregatedFieldWells) }) : properties;
    }
    function CfnTemplateHeatMapFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("heatMapAggregatedFieldWells", "HeatMapAggregatedFieldWells", properties.HeatMapAggregatedFieldWells != null ? CfnTemplateHeatMapAggregatedFieldWellsPropertyFromCloudFormation(properties.HeatMapAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_HeatMapSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("heatMapColumnItemsLimitConfiguration", CfnTemplate_ItemsLimitConfigurationPropertyValidator)(properties.heatMapColumnItemsLimitConfiguration)), errors.collect(cdk.propertyValidator("heatMapColumnSort", cdk.listValidator(CfnTemplate_FieldSortOptionsPropertyValidator))(properties.heatMapColumnSort)), errors.collect(cdk.propertyValidator("heatMapRowItemsLimitConfiguration", CfnTemplate_ItemsLimitConfigurationPropertyValidator)(properties.heatMapRowItemsLimitConfiguration)), errors.collect(cdk.propertyValidator("heatMapRowSort", cdk.listValidator(CfnTemplate_FieldSortOptionsPropertyValidator))(properties.heatMapRowSort)), errors.wrap('supplied properties not correct for "HeatMapSortConfigurationProperty"');
    }
    function cfnTemplateHeatMapSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_HeatMapSortConfigurationPropertyValidator(properties).assertSuccess(), { HeatMapColumnItemsLimitConfiguration: cfnTemplateItemsLimitConfigurationPropertyToCloudFormation(properties.heatMapColumnItemsLimitConfiguration), HeatMapColumnSort: cdk.listMapper(cfnTemplateFieldSortOptionsPropertyToCloudFormation)(properties.heatMapColumnSort), HeatMapRowItemsLimitConfiguration: cfnTemplateItemsLimitConfigurationPropertyToCloudFormation(properties.heatMapRowItemsLimitConfiguration), HeatMapRowSort: cdk.listMapper(cfnTemplateFieldSortOptionsPropertyToCloudFormation)(properties.heatMapRowSort) }) : properties;
    }
    function CfnTemplateHeatMapSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("heatMapColumnItemsLimitConfiguration", "HeatMapColumnItemsLimitConfiguration", properties.HeatMapColumnItemsLimitConfiguration != null ? CfnTemplateItemsLimitConfigurationPropertyFromCloudFormation(properties.HeatMapColumnItemsLimitConfiguration) : void 0), ret.addPropertyResult("heatMapColumnSort", "HeatMapColumnSort", properties.HeatMapColumnSort != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateFieldSortOptionsPropertyFromCloudFormation)(properties.HeatMapColumnSort) : void 0), ret.addPropertyResult("heatMapRowItemsLimitConfiguration", "HeatMapRowItemsLimitConfiguration", properties.HeatMapRowItemsLimitConfiguration != null ? CfnTemplateItemsLimitConfigurationPropertyFromCloudFormation(properties.HeatMapRowItemsLimitConfiguration) : void 0), ret.addPropertyResult("heatMapRowSort", "HeatMapRowSort", properties.HeatMapRowSort != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateFieldSortOptionsPropertyFromCloudFormation)(properties.HeatMapRowSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_HeatMapVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnTemplate_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnTemplate_HeatMapConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnTemplate_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnTemplate_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnTemplate_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "HeatMapVisualProperty"');
    }
    function cfnTemplateHeatMapVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_HeatMapVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnTemplateVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnTemplateHeatMapConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnTemplateColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnTemplateVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnTemplateVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnTemplateHeatMapVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnTemplateHeatMapConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnTemplateVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnTemplateVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_HistogramAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnTemplate_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "HistogramAggregatedFieldWellsProperty"');
    }
    function cfnTemplateHistogramAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_HistogramAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Values: cdk.listMapper(cfnTemplateMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnTemplateHistogramAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_HistogramBinOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("binCount", CfnTemplate_BinCountOptionsPropertyValidator)(properties.binCount)), errors.collect(cdk.propertyValidator("binWidth", CfnTemplate_BinWidthOptionsPropertyValidator)(properties.binWidth)), errors.collect(cdk.propertyValidator("selectedBinType", cdk.validateString)(properties.selectedBinType)), errors.collect(cdk.propertyValidator("startValue", cdk.validateNumber)(properties.startValue)), errors.wrap('supplied properties not correct for "HistogramBinOptionsProperty"');
    }
    function cfnTemplateHistogramBinOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_HistogramBinOptionsPropertyValidator(properties).assertSuccess(), { BinCount: cfnTemplateBinCountOptionsPropertyToCloudFormation(properties.binCount), BinWidth: cfnTemplateBinWidthOptionsPropertyToCloudFormation(properties.binWidth), SelectedBinType: cdk.stringToCloudFormation(properties.selectedBinType), StartValue: cdk.numberToCloudFormation(properties.startValue) }) : properties;
    }
    function CfnTemplateHistogramBinOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("binCount", "BinCount", properties.BinCount != null ? CfnTemplateBinCountOptionsPropertyFromCloudFormation(properties.BinCount) : void 0), ret.addPropertyResult("binWidth", "BinWidth", properties.BinWidth != null ? CfnTemplateBinWidthOptionsPropertyFromCloudFormation(properties.BinWidth) : void 0), ret.addPropertyResult("selectedBinType", "SelectedBinType", properties.SelectedBinType != null ? cfn_parse.FromCloudFormation.getString(properties.SelectedBinType) : void 0), ret.addPropertyResult("startValue", "StartValue", properties.StartValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.StartValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_HistogramConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("binOptions", CfnTemplate_HistogramBinOptionsPropertyValidator)(properties.binOptions)), errors.collect(cdk.propertyValidator("dataLabels", CfnTemplate_DataLabelOptionsPropertyValidator)(properties.dataLabels)), errors.collect(cdk.propertyValidator("fieldWells", CfnTemplate_HistogramFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("tooltip", CfnTemplate_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.collect(cdk.propertyValidator("visualPalette", CfnTemplate_VisualPalettePropertyValidator)(properties.visualPalette)), errors.collect(cdk.propertyValidator("xAxisDisplayOptions", CfnTemplate_AxisDisplayOptionsPropertyValidator)(properties.xAxisDisplayOptions)), errors.collect(cdk.propertyValidator("xAxisLabelOptions", CfnTemplate_ChartAxisLabelOptionsPropertyValidator)(properties.xAxisLabelOptions)), errors.collect(cdk.propertyValidator("yAxisDisplayOptions", CfnTemplate_AxisDisplayOptionsPropertyValidator)(properties.yAxisDisplayOptions)), errors.wrap('supplied properties not correct for "HistogramConfigurationProperty"');
    }
    function cfnTemplateHistogramConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_HistogramConfigurationPropertyValidator(properties).assertSuccess(), { BinOptions: cfnTemplateHistogramBinOptionsPropertyToCloudFormation(properties.binOptions), DataLabels: cfnTemplateDataLabelOptionsPropertyToCloudFormation(properties.dataLabels), FieldWells: cfnTemplateHistogramFieldWellsPropertyToCloudFormation(properties.fieldWells), Tooltip: cfnTemplateTooltipOptionsPropertyToCloudFormation(properties.tooltip), VisualPalette: cfnTemplateVisualPalettePropertyToCloudFormation(properties.visualPalette), XAxisDisplayOptions: cfnTemplateAxisDisplayOptionsPropertyToCloudFormation(properties.xAxisDisplayOptions), XAxisLabelOptions: cfnTemplateChartAxisLabelOptionsPropertyToCloudFormation(properties.xAxisLabelOptions), YAxisDisplayOptions: cfnTemplateAxisDisplayOptionsPropertyToCloudFormation(properties.yAxisDisplayOptions) }) : properties;
    }
    function CfnTemplateHistogramConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("binOptions", "BinOptions", properties.BinOptions != null ? CfnTemplateHistogramBinOptionsPropertyFromCloudFormation(properties.BinOptions) : void 0), ret.addPropertyResult("dataLabels", "DataLabels", properties.DataLabels != null ? CfnTemplateDataLabelOptionsPropertyFromCloudFormation(properties.DataLabels) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnTemplateHistogramFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnTemplateTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnTemplateVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addPropertyResult("xAxisDisplayOptions", "XAxisDisplayOptions", properties.XAxisDisplayOptions != null ? CfnTemplateAxisDisplayOptionsPropertyFromCloudFormation(properties.XAxisDisplayOptions) : void 0), ret.addPropertyResult("xAxisLabelOptions", "XAxisLabelOptions", properties.XAxisLabelOptions != null ? CfnTemplateChartAxisLabelOptionsPropertyFromCloudFormation(properties.XAxisLabelOptions) : void 0), ret.addPropertyResult("yAxisDisplayOptions", "YAxisDisplayOptions", properties.YAxisDisplayOptions != null ? CfnTemplateAxisDisplayOptionsPropertyFromCloudFormation(properties.YAxisDisplayOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_HistogramFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("histogramAggregatedFieldWells", CfnTemplate_HistogramAggregatedFieldWellsPropertyValidator)(properties.histogramAggregatedFieldWells)), errors.wrap('supplied properties not correct for "HistogramFieldWellsProperty"');
    }
    function cfnTemplateHistogramFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_HistogramFieldWellsPropertyValidator(properties).assertSuccess(), { HistogramAggregatedFieldWells: cfnTemplateHistogramAggregatedFieldWellsPropertyToCloudFormation(properties.histogramAggregatedFieldWells) }) : properties;
    }
    function CfnTemplateHistogramFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("histogramAggregatedFieldWells", "HistogramAggregatedFieldWells", properties.HistogramAggregatedFieldWells != null ? CfnTemplateHistogramAggregatedFieldWellsPropertyFromCloudFormation(properties.HistogramAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_HistogramVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnTemplate_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnTemplate_HistogramConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("subtitle", CfnTemplate_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnTemplate_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "HistogramVisualProperty"');
    }
    function cfnTemplateHistogramVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_HistogramVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnTemplateVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnTemplateHistogramConfigurationPropertyToCloudFormation(properties.chartConfiguration), Subtitle: cfnTemplateVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnTemplateVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnTemplateHistogramVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnTemplateHistogramConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnTemplateVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnTemplateVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_InsightConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computations", cdk.listValidator(CfnTemplate_ComputationPropertyValidator))(properties.computations)), errors.collect(cdk.propertyValidator("customNarrative", CfnTemplate_CustomNarrativeOptionsPropertyValidator)(properties.customNarrative)), errors.wrap('supplied properties not correct for "InsightConfigurationProperty"');
    }
    function cfnTemplateInsightConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_InsightConfigurationPropertyValidator(properties).assertSuccess(), { Computations: cdk.listMapper(cfnTemplateComputationPropertyToCloudFormation)(properties.computations), CustomNarrative: cfnTemplateCustomNarrativeOptionsPropertyToCloudFormation(properties.customNarrative) }) : properties;
    }
    function CfnTemplateInsightConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computations", "Computations", properties.Computations != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateComputationPropertyFromCloudFormation)(properties.Computations) : void 0), ret.addPropertyResult("customNarrative", "CustomNarrative", properties.CustomNarrative != null ? CfnTemplateCustomNarrativeOptionsPropertyFromCloudFormation(properties.CustomNarrative) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_InsightVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnTemplate_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.requiredValidator)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.validateString)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("insightConfiguration", CfnTemplate_InsightConfigurationPropertyValidator)(properties.insightConfiguration)), errors.collect(cdk.propertyValidator("subtitle", CfnTemplate_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnTemplate_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "InsightVisualProperty"');
    }
    function cfnTemplateInsightVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_InsightVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnTemplateVisualCustomActionPropertyToCloudFormation)(properties.actions), DataSetIdentifier: cdk.stringToCloudFormation(properties.dataSetIdentifier), InsightConfiguration: cfnTemplateInsightConfigurationPropertyToCloudFormation(properties.insightConfiguration), Subtitle: cfnTemplateVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnTemplateVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnTemplateInsightVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("dataSetIdentifier", "DataSetIdentifier", cfn_parse.FromCloudFormation.getString(properties.DataSetIdentifier)), ret.addPropertyResult("insightConfiguration", "InsightConfiguration", properties.InsightConfiguration != null ? CfnTemplateInsightConfigurationPropertyFromCloudFormation(properties.InsightConfiguration) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnTemplateVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnTemplateVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_IntegerDefaultValuesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dynamicValue", CfnTemplate_DynamicDefaultValuePropertyValidator)(properties.dynamicValue)), errors.collect(cdk.propertyValidator("staticValues", cdk.listValidator(cdk.validateNumber))(properties.staticValues)), errors.wrap('supplied properties not correct for "IntegerDefaultValuesProperty"');
    }
    function cfnTemplateIntegerDefaultValuesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_IntegerDefaultValuesPropertyValidator(properties).assertSuccess(), { DynamicValue: cfnTemplateDynamicDefaultValuePropertyToCloudFormation(properties.dynamicValue), StaticValues: cdk.listMapper(cdk.numberToCloudFormation)(properties.staticValues) }) : properties;
    }
    function CfnTemplateIntegerDefaultValuesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dynamicValue", "DynamicValue", properties.DynamicValue != null ? CfnTemplateDynamicDefaultValuePropertyFromCloudFormation(properties.DynamicValue) : void 0), ret.addPropertyResult("staticValues", "StaticValues", properties.StaticValues != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getNumber)(properties.StaticValues) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_IntegerParameterDeclarationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultValues", CfnTemplate_IntegerDefaultValuesPropertyValidator)(properties.defaultValues)), errors.collect(cdk.propertyValidator("mappedDataSetParameters", cdk.listValidator(CfnTemplate_MappedDataSetParameterPropertyValidator))(properties.mappedDataSetParameters)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("parameterValueType", cdk.requiredValidator)(properties.parameterValueType)), errors.collect(cdk.propertyValidator("parameterValueType", cdk.validateString)(properties.parameterValueType)), errors.collect(cdk.propertyValidator("valueWhenUnset", CfnTemplate_IntegerValueWhenUnsetConfigurationPropertyValidator)(properties.valueWhenUnset)), errors.wrap('supplied properties not correct for "IntegerParameterDeclarationProperty"');
    }
    function cfnTemplateIntegerParameterDeclarationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_IntegerParameterDeclarationPropertyValidator(properties).assertSuccess(), { DefaultValues: cfnTemplateIntegerDefaultValuesPropertyToCloudFormation(properties.defaultValues), MappedDataSetParameters: cdk.listMapper(cfnTemplateMappedDataSetParameterPropertyToCloudFormation)(properties.mappedDataSetParameters), Name: cdk.stringToCloudFormation(properties.name), ParameterValueType: cdk.stringToCloudFormation(properties.parameterValueType), ValueWhenUnset: cfnTemplateIntegerValueWhenUnsetConfigurationPropertyToCloudFormation(properties.valueWhenUnset) }) : properties;
    }
    function CfnTemplateIntegerParameterDeclarationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultValues", "DefaultValues", properties.DefaultValues != null ? CfnTemplateIntegerDefaultValuesPropertyFromCloudFormation(properties.DefaultValues) : void 0), ret.addPropertyResult("mappedDataSetParameters", "MappedDataSetParameters", properties.MappedDataSetParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMappedDataSetParameterPropertyFromCloudFormation)(properties.MappedDataSetParameters) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("parameterValueType", "ParameterValueType", cfn_parse.FromCloudFormation.getString(properties.ParameterValueType)), ret.addPropertyResult("valueWhenUnset", "ValueWhenUnset", properties.ValueWhenUnset != null ? CfnTemplateIntegerValueWhenUnsetConfigurationPropertyFromCloudFormation(properties.ValueWhenUnset) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_IntegerValueWhenUnsetConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customValue", cdk.validateNumber)(properties.customValue)), errors.collect(cdk.propertyValidator("valueWhenUnsetOption", cdk.validateString)(properties.valueWhenUnsetOption)), errors.wrap('supplied properties not correct for "IntegerValueWhenUnsetConfigurationProperty"');
    }
    function cfnTemplateIntegerValueWhenUnsetConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_IntegerValueWhenUnsetConfigurationPropertyValidator(properties).assertSuccess(), { CustomValue: cdk.numberToCloudFormation(properties.customValue), ValueWhenUnsetOption: cdk.stringToCloudFormation(properties.valueWhenUnsetOption) }) : properties;
    }
    function CfnTemplateIntegerValueWhenUnsetConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customValue", "CustomValue", properties.CustomValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.CustomValue) : void 0), ret.addPropertyResult("valueWhenUnsetOption", "ValueWhenUnsetOption", properties.ValueWhenUnsetOption != null ? cfn_parse.FromCloudFormation.getString(properties.ValueWhenUnsetOption) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ItemsLimitConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("itemsLimit", cdk.validateNumber)(properties.itemsLimit)), errors.collect(cdk.propertyValidator("otherCategories", cdk.validateString)(properties.otherCategories)), errors.wrap('supplied properties not correct for "ItemsLimitConfigurationProperty"');
    }
    function cfnTemplateItemsLimitConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ItemsLimitConfigurationPropertyValidator(properties).assertSuccess(), { ItemsLimit: cdk.numberToCloudFormation(properties.itemsLimit), OtherCategories: cdk.stringToCloudFormation(properties.otherCategories) }) : properties;
    }
    function CfnTemplateItemsLimitConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("itemsLimit", "ItemsLimit", properties.ItemsLimit != null ? cfn_parse.FromCloudFormation.getNumber(properties.ItemsLimit) : void 0), ret.addPropertyResult("otherCategories", "OtherCategories", properties.OtherCategories != null ? cfn_parse.FromCloudFormation.getString(properties.OtherCategories) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_KPIConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("conditionalFormattingOptions", cdk.listValidator(CfnTemplate_KPIConditionalFormattingOptionPropertyValidator))(properties.conditionalFormattingOptions)), errors.wrap('supplied properties not correct for "KPIConditionalFormattingProperty"');
    }
    function cfnTemplateKPIConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_KPIConditionalFormattingPropertyValidator(properties).assertSuccess(), { ConditionalFormattingOptions: cdk.listMapper(cfnTemplateKPIConditionalFormattingOptionPropertyToCloudFormation)(properties.conditionalFormattingOptions) }) : properties;
    }
    function CfnTemplateKPIConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("conditionalFormattingOptions", "ConditionalFormattingOptions", properties.ConditionalFormattingOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateKPIConditionalFormattingOptionPropertyFromCloudFormation)(properties.ConditionalFormattingOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_KPIConditionalFormattingOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("primaryValue", CfnTemplate_KPIPrimaryValueConditionalFormattingPropertyValidator)(properties.primaryValue)), errors.collect(cdk.propertyValidator("progressBar", CfnTemplate_KPIProgressBarConditionalFormattingPropertyValidator)(properties.progressBar)), errors.wrap('supplied properties not correct for "KPIConditionalFormattingOptionProperty"');
    }
    function cfnTemplateKPIConditionalFormattingOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_KPIConditionalFormattingOptionPropertyValidator(properties).assertSuccess(), { PrimaryValue: cfnTemplateKPIPrimaryValueConditionalFormattingPropertyToCloudFormation(properties.primaryValue), ProgressBar: cfnTemplateKPIProgressBarConditionalFormattingPropertyToCloudFormation(properties.progressBar) }) : properties;
    }
    function CfnTemplateKPIConditionalFormattingOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("primaryValue", "PrimaryValue", properties.PrimaryValue != null ? CfnTemplateKPIPrimaryValueConditionalFormattingPropertyFromCloudFormation(properties.PrimaryValue) : void 0), ret.addPropertyResult("progressBar", "ProgressBar", properties.ProgressBar != null ? CfnTemplateKPIProgressBarConditionalFormattingPropertyFromCloudFormation(properties.ProgressBar) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_KPIConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldWells", CfnTemplate_KPIFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("kpiOptions", CfnTemplate_KPIOptionsPropertyValidator)(properties.kpiOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnTemplate_KPISortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.wrap('supplied properties not correct for "KPIConfigurationProperty"');
    }
    function cfnTemplateKPIConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_KPIConfigurationPropertyValidator(properties).assertSuccess(), { FieldWells: cfnTemplateKPIFieldWellsPropertyToCloudFormation(properties.fieldWells), KPIOptions: cfnTemplateKPIOptionsPropertyToCloudFormation(properties.kpiOptions), SortConfiguration: cfnTemplateKPISortConfigurationPropertyToCloudFormation(properties.sortConfiguration) }) : properties;
    }
    function CfnTemplateKPIConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnTemplateKPIFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("kpiOptions", "KPIOptions", properties.KPIOptions != null ? CfnTemplateKPIOptionsPropertyFromCloudFormation(properties.KPIOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnTemplateKPISortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_KPIFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("targetValues", cdk.listValidator(CfnTemplate_MeasureFieldPropertyValidator))(properties.targetValues)), errors.collect(cdk.propertyValidator("trendGroups", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.trendGroups)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnTemplate_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "KPIFieldWellsProperty"');
    }
    function cfnTemplateKPIFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_KPIFieldWellsPropertyValidator(properties).assertSuccess(), { TargetValues: cdk.listMapper(cfnTemplateMeasureFieldPropertyToCloudFormation)(properties.targetValues), TrendGroups: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.trendGroups), Values: cdk.listMapper(cfnTemplateMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnTemplateKPIFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("targetValues", "TargetValues", properties.TargetValues != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMeasureFieldPropertyFromCloudFormation)(properties.TargetValues) : void 0), ret.addPropertyResult("trendGroups", "TrendGroups", properties.TrendGroups != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.TrendGroups) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_KPIOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("comparison", CfnTemplate_ComparisonConfigurationPropertyValidator)(properties.comparison)), errors.collect(cdk.propertyValidator("primaryValueDisplayType", cdk.validateString)(properties.primaryValueDisplayType)), errors.collect(cdk.propertyValidator("primaryValueFontConfiguration", CfnTemplate_FontConfigurationPropertyValidator)(properties.primaryValueFontConfiguration)), errors.collect(cdk.propertyValidator("progressBar", CfnTemplate_ProgressBarOptionsPropertyValidator)(properties.progressBar)), errors.collect(cdk.propertyValidator("secondaryValue", CfnTemplate_SecondaryValueOptionsPropertyValidator)(properties.secondaryValue)), errors.collect(cdk.propertyValidator("secondaryValueFontConfiguration", CfnTemplate_FontConfigurationPropertyValidator)(properties.secondaryValueFontConfiguration)), errors.collect(cdk.propertyValidator("trendArrows", CfnTemplate_TrendArrowOptionsPropertyValidator)(properties.trendArrows)), errors.wrap('supplied properties not correct for "KPIOptionsProperty"');
    }
    function cfnTemplateKPIOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_KPIOptionsPropertyValidator(properties).assertSuccess(), { Comparison: cfnTemplateComparisonConfigurationPropertyToCloudFormation(properties.comparison), PrimaryValueDisplayType: cdk.stringToCloudFormation(properties.primaryValueDisplayType), PrimaryValueFontConfiguration: cfnTemplateFontConfigurationPropertyToCloudFormation(properties.primaryValueFontConfiguration), ProgressBar: cfnTemplateProgressBarOptionsPropertyToCloudFormation(properties.progressBar), SecondaryValue: cfnTemplateSecondaryValueOptionsPropertyToCloudFormation(properties.secondaryValue), SecondaryValueFontConfiguration: cfnTemplateFontConfigurationPropertyToCloudFormation(properties.secondaryValueFontConfiguration), TrendArrows: cfnTemplateTrendArrowOptionsPropertyToCloudFormation(properties.trendArrows) }) : properties;
    }
    function CfnTemplateKPIOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("comparison", "Comparison", properties.Comparison != null ? CfnTemplateComparisonConfigurationPropertyFromCloudFormation(properties.Comparison) : void 0), ret.addPropertyResult("primaryValueDisplayType", "PrimaryValueDisplayType", properties.PrimaryValueDisplayType != null ? cfn_parse.FromCloudFormation.getString(properties.PrimaryValueDisplayType) : void 0), ret.addPropertyResult("primaryValueFontConfiguration", "PrimaryValueFontConfiguration", properties.PrimaryValueFontConfiguration != null ? CfnTemplateFontConfigurationPropertyFromCloudFormation(properties.PrimaryValueFontConfiguration) : void 0), ret.addPropertyResult("progressBar", "ProgressBar", properties.ProgressBar != null ? CfnTemplateProgressBarOptionsPropertyFromCloudFormation(properties.ProgressBar) : void 0), ret.addPropertyResult("secondaryValue", "SecondaryValue", properties.SecondaryValue != null ? CfnTemplateSecondaryValueOptionsPropertyFromCloudFormation(properties.SecondaryValue) : void 0), ret.addPropertyResult("secondaryValueFontConfiguration", "SecondaryValueFontConfiguration", properties.SecondaryValueFontConfiguration != null ? CfnTemplateFontConfigurationPropertyFromCloudFormation(properties.SecondaryValueFontConfiguration) : void 0), ret.addPropertyResult("trendArrows", "TrendArrows", properties.TrendArrows != null ? CfnTemplateTrendArrowOptionsPropertyFromCloudFormation(properties.TrendArrows) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_KPIPrimaryValueConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("icon", CfnTemplate_ConditionalFormattingIconPropertyValidator)(properties.icon)), errors.collect(cdk.propertyValidator("textColor", CfnTemplate_ConditionalFormattingColorPropertyValidator)(properties.textColor)), errors.wrap('supplied properties not correct for "KPIPrimaryValueConditionalFormattingProperty"');
    }
    function cfnTemplateKPIPrimaryValueConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_KPIPrimaryValueConditionalFormattingPropertyValidator(properties).assertSuccess(), { Icon: cfnTemplateConditionalFormattingIconPropertyToCloudFormation(properties.icon), TextColor: cfnTemplateConditionalFormattingColorPropertyToCloudFormation(properties.textColor) }) : properties;
    }
    function CfnTemplateKPIPrimaryValueConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("icon", "Icon", properties.Icon != null ? CfnTemplateConditionalFormattingIconPropertyFromCloudFormation(properties.Icon) : void 0), ret.addPropertyResult("textColor", "TextColor", properties.TextColor != null ? CfnTemplateConditionalFormattingColorPropertyFromCloudFormation(properties.TextColor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_KPIProgressBarConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("foregroundColor", CfnTemplate_ConditionalFormattingColorPropertyValidator)(properties.foregroundColor)), errors.wrap('supplied properties not correct for "KPIProgressBarConditionalFormattingProperty"');
    }
    function cfnTemplateKPIProgressBarConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_KPIProgressBarConditionalFormattingPropertyValidator(properties).assertSuccess(), { ForegroundColor: cfnTemplateConditionalFormattingColorPropertyToCloudFormation(properties.foregroundColor) }) : properties;
    }
    function CfnTemplateKPIProgressBarConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("foregroundColor", "ForegroundColor", properties.ForegroundColor != null ? CfnTemplateConditionalFormattingColorPropertyFromCloudFormation(properties.ForegroundColor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_KPISortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("trendGroupSort", cdk.listValidator(CfnTemplate_FieldSortOptionsPropertyValidator))(properties.trendGroupSort)), errors.wrap('supplied properties not correct for "KPISortConfigurationProperty"');
    }
    function cfnTemplateKPISortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_KPISortConfigurationPropertyValidator(properties).assertSuccess(), { TrendGroupSort: cdk.listMapper(cfnTemplateFieldSortOptionsPropertyToCloudFormation)(properties.trendGroupSort) }) : properties;
    }
    function CfnTemplateKPISortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("trendGroupSort", "TrendGroupSort", properties.TrendGroupSort != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateFieldSortOptionsPropertyFromCloudFormation)(properties.TrendGroupSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_KPIVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnTemplate_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnTemplate_KPIConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnTemplate_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("conditionalFormatting", CfnTemplate_KPIConditionalFormattingPropertyValidator)(properties.conditionalFormatting)), errors.collect(cdk.propertyValidator("subtitle", CfnTemplate_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnTemplate_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "KPIVisualProperty"');
    }
    function cfnTemplateKPIVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_KPIVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnTemplateVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnTemplateKPIConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnTemplateColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), ConditionalFormatting: cfnTemplateKPIConditionalFormattingPropertyToCloudFormation(properties.conditionalFormatting), Subtitle: cfnTemplateVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnTemplateVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnTemplateKPIVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnTemplateKPIConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("conditionalFormatting", "ConditionalFormatting", properties.ConditionalFormatting != null ? CfnTemplateKPIConditionalFormattingPropertyFromCloudFormation(properties.ConditionalFormatting) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnTemplateVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnTemplateVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_LabelOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customLabel", cdk.validateString)(properties.customLabel)), errors.collect(cdk.propertyValidator("fontConfiguration", CfnTemplate_FontConfigurationPropertyValidator)(properties.fontConfiguration)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "LabelOptionsProperty"');
    }
    function cfnTemplateLabelOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_LabelOptionsPropertyValidator(properties).assertSuccess(), { CustomLabel: cdk.stringToCloudFormation(properties.customLabel), FontConfiguration: cfnTemplateFontConfigurationPropertyToCloudFormation(properties.fontConfiguration), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnTemplateLabelOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customLabel", "CustomLabel", properties.CustomLabel != null ? cfn_parse.FromCloudFormation.getString(properties.CustomLabel) : void 0), ret.addPropertyResult("fontConfiguration", "FontConfiguration", properties.FontConfiguration != null ? CfnTemplateFontConfigurationPropertyFromCloudFormation(properties.FontConfiguration) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_LayoutPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configuration", cdk.requiredValidator)(properties.configuration)), errors.collect(cdk.propertyValidator("configuration", CfnTemplate_LayoutConfigurationPropertyValidator)(properties.configuration)), errors.wrap('supplied properties not correct for "LayoutProperty"');
    }
    function cfnTemplateLayoutPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_LayoutPropertyValidator(properties).assertSuccess(), { Configuration: cfnTemplateLayoutConfigurationPropertyToCloudFormation(properties.configuration) }) : properties;
    }
    function CfnTemplateLayoutPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configuration", "Configuration", CfnTemplateLayoutConfigurationPropertyFromCloudFormation(properties.Configuration)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_LayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("freeFormLayout", CfnTemplate_FreeFormLayoutConfigurationPropertyValidator)(properties.freeFormLayout)), errors.collect(cdk.propertyValidator("gridLayout", CfnTemplate_GridLayoutConfigurationPropertyValidator)(properties.gridLayout)), errors.collect(cdk.propertyValidator("sectionBasedLayout", CfnTemplate_SectionBasedLayoutConfigurationPropertyValidator)(properties.sectionBasedLayout)), errors.wrap('supplied properties not correct for "LayoutConfigurationProperty"');
    }
    function cfnTemplateLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_LayoutConfigurationPropertyValidator(properties).assertSuccess(), { FreeFormLayout: cfnTemplateFreeFormLayoutConfigurationPropertyToCloudFormation(properties.freeFormLayout), GridLayout: cfnTemplateGridLayoutConfigurationPropertyToCloudFormation(properties.gridLayout), SectionBasedLayout: cfnTemplateSectionBasedLayoutConfigurationPropertyToCloudFormation(properties.sectionBasedLayout) }) : properties;
    }
    function CfnTemplateLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("freeFormLayout", "FreeFormLayout", properties.FreeFormLayout != null ? CfnTemplateFreeFormLayoutConfigurationPropertyFromCloudFormation(properties.FreeFormLayout) : void 0), ret.addPropertyResult("gridLayout", "GridLayout", properties.GridLayout != null ? CfnTemplateGridLayoutConfigurationPropertyFromCloudFormation(properties.GridLayout) : void 0), ret.addPropertyResult("sectionBasedLayout", "SectionBasedLayout", properties.SectionBasedLayout != null ? CfnTemplateSectionBasedLayoutConfigurationPropertyFromCloudFormation(properties.SectionBasedLayout) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_LegendOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("height", cdk.validateString)(properties.height)), errors.collect(cdk.propertyValidator("position", cdk.validateString)(properties.position)), errors.collect(cdk.propertyValidator("title", CfnTemplate_LabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.collect(cdk.propertyValidator("width", cdk.validateString)(properties.width)), errors.wrap('supplied properties not correct for "LegendOptionsProperty"');
    }
    function cfnTemplateLegendOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_LegendOptionsPropertyValidator(properties).assertSuccess(), { Height: cdk.stringToCloudFormation(properties.height), Position: cdk.stringToCloudFormation(properties.position), Title: cfnTemplateLabelOptionsPropertyToCloudFormation(properties.title), Visibility: cdk.stringToCloudFormation(properties.visibility), Width: cdk.stringToCloudFormation(properties.width) }) : properties;
    }
    function CfnTemplateLegendOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("height", "Height", properties.Height != null ? cfn_parse.FromCloudFormation.getString(properties.Height) : void 0), ret.addPropertyResult("position", "Position", properties.Position != null ? cfn_parse.FromCloudFormation.getString(properties.Position) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnTemplateLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addPropertyResult("width", "Width", properties.Width != null ? cfn_parse.FromCloudFormation.getString(properties.Width) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_LineChartAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("category", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.category)), errors.collect(cdk.propertyValidator("colors", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.colors)), errors.collect(cdk.propertyValidator("smallMultiples", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.smallMultiples)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnTemplate_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "LineChartAggregatedFieldWellsProperty"');
    }
    function cfnTemplateLineChartAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_LineChartAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Category: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.category), Colors: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.colors), SmallMultiples: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.smallMultiples), Values: cdk.listMapper(cfnTemplateMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnTemplateLineChartAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("category", "Category", properties.Category != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.Category) : void 0), ret.addPropertyResult("colors", "Colors", properties.Colors != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.Colors) : void 0), ret.addPropertyResult("smallMultiples", "SmallMultiples", properties.SmallMultiples != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.SmallMultiples) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_LineChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contributionAnalysisDefaults", cdk.listValidator(CfnTemplate_ContributionAnalysisDefaultPropertyValidator))(properties.contributionAnalysisDefaults)), errors.collect(cdk.propertyValidator("dataLabels", CfnTemplate_DataLabelOptionsPropertyValidator)(properties.dataLabels)), errors.collect(cdk.propertyValidator("defaultSeriesSettings", CfnTemplate_LineChartDefaultSeriesSettingsPropertyValidator)(properties.defaultSeriesSettings)), errors.collect(cdk.propertyValidator("fieldWells", CfnTemplate_LineChartFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("forecastConfigurations", cdk.listValidator(CfnTemplate_ForecastConfigurationPropertyValidator))(properties.forecastConfigurations)), errors.collect(cdk.propertyValidator("legend", CfnTemplate_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("primaryYAxisDisplayOptions", CfnTemplate_LineSeriesAxisDisplayOptionsPropertyValidator)(properties.primaryYAxisDisplayOptions)), errors.collect(cdk.propertyValidator("primaryYAxisLabelOptions", CfnTemplate_ChartAxisLabelOptionsPropertyValidator)(properties.primaryYAxisLabelOptions)), errors.collect(cdk.propertyValidator("referenceLines", cdk.listValidator(CfnTemplate_ReferenceLinePropertyValidator))(properties.referenceLines)), errors.collect(cdk.propertyValidator("secondaryYAxisDisplayOptions", CfnTemplate_LineSeriesAxisDisplayOptionsPropertyValidator)(properties.secondaryYAxisDisplayOptions)), errors.collect(cdk.propertyValidator("secondaryYAxisLabelOptions", CfnTemplate_ChartAxisLabelOptionsPropertyValidator)(properties.secondaryYAxisLabelOptions)), errors.collect(cdk.propertyValidator("series", cdk.listValidator(CfnTemplate_SeriesItemPropertyValidator))(properties.series)), errors.collect(cdk.propertyValidator("smallMultiplesOptions", CfnTemplate_SmallMultiplesOptionsPropertyValidator)(properties.smallMultiplesOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnTemplate_LineChartSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tooltip", CfnTemplate_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("visualPalette", CfnTemplate_VisualPalettePropertyValidator)(properties.visualPalette)), errors.collect(cdk.propertyValidator("xAxisDisplayOptions", CfnTemplate_AxisDisplayOptionsPropertyValidator)(properties.xAxisDisplayOptions)), errors.collect(cdk.propertyValidator("xAxisLabelOptions", CfnTemplate_ChartAxisLabelOptionsPropertyValidator)(properties.xAxisLabelOptions)), errors.wrap('supplied properties not correct for "LineChartConfigurationProperty"');
    }
    function cfnTemplateLineChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_LineChartConfigurationPropertyValidator(properties).assertSuccess(), { ContributionAnalysisDefaults: cdk.listMapper(cfnTemplateContributionAnalysisDefaultPropertyToCloudFormation)(properties.contributionAnalysisDefaults), DataLabels: cfnTemplateDataLabelOptionsPropertyToCloudFormation(properties.dataLabels), DefaultSeriesSettings: cfnTemplateLineChartDefaultSeriesSettingsPropertyToCloudFormation(properties.defaultSeriesSettings), FieldWells: cfnTemplateLineChartFieldWellsPropertyToCloudFormation(properties.fieldWells), ForecastConfigurations: cdk.listMapper(cfnTemplateForecastConfigurationPropertyToCloudFormation)(properties.forecastConfigurations), Legend: cfnTemplateLegendOptionsPropertyToCloudFormation(properties.legend), PrimaryYAxisDisplayOptions: cfnTemplateLineSeriesAxisDisplayOptionsPropertyToCloudFormation(properties.primaryYAxisDisplayOptions), PrimaryYAxisLabelOptions: cfnTemplateChartAxisLabelOptionsPropertyToCloudFormation(properties.primaryYAxisLabelOptions), ReferenceLines: cdk.listMapper(cfnTemplateReferenceLinePropertyToCloudFormation)(properties.referenceLines), SecondaryYAxisDisplayOptions: cfnTemplateLineSeriesAxisDisplayOptionsPropertyToCloudFormation(properties.secondaryYAxisDisplayOptions), SecondaryYAxisLabelOptions: cfnTemplateChartAxisLabelOptionsPropertyToCloudFormation(properties.secondaryYAxisLabelOptions), Series: cdk.listMapper(cfnTemplateSeriesItemPropertyToCloudFormation)(properties.series), SmallMultiplesOptions: cfnTemplateSmallMultiplesOptionsPropertyToCloudFormation(properties.smallMultiplesOptions), SortConfiguration: cfnTemplateLineChartSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), Tooltip: cfnTemplateTooltipOptionsPropertyToCloudFormation(properties.tooltip), Type: cdk.stringToCloudFormation(properties.type), VisualPalette: cfnTemplateVisualPalettePropertyToCloudFormation(properties.visualPalette), XAxisDisplayOptions: cfnTemplateAxisDisplayOptionsPropertyToCloudFormation(properties.xAxisDisplayOptions), XAxisLabelOptions: cfnTemplateChartAxisLabelOptionsPropertyToCloudFormation(properties.xAxisLabelOptions) }) : properties;
    }
    function CfnTemplateLineChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contributionAnalysisDefaults", "ContributionAnalysisDefaults", properties.ContributionAnalysisDefaults != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateContributionAnalysisDefaultPropertyFromCloudFormation)(properties.ContributionAnalysisDefaults) : void 0), ret.addPropertyResult("dataLabels", "DataLabels", properties.DataLabels != null ? CfnTemplateDataLabelOptionsPropertyFromCloudFormation(properties.DataLabels) : void 0), ret.addPropertyResult("defaultSeriesSettings", "DefaultSeriesSettings", properties.DefaultSeriesSettings != null ? CfnTemplateLineChartDefaultSeriesSettingsPropertyFromCloudFormation(properties.DefaultSeriesSettings) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnTemplateLineChartFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("forecastConfigurations", "ForecastConfigurations", properties.ForecastConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateForecastConfigurationPropertyFromCloudFormation)(properties.ForecastConfigurations) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnTemplateLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("primaryYAxisDisplayOptions", "PrimaryYAxisDisplayOptions", properties.PrimaryYAxisDisplayOptions != null ? CfnTemplateLineSeriesAxisDisplayOptionsPropertyFromCloudFormation(properties.PrimaryYAxisDisplayOptions) : void 0), ret.addPropertyResult("primaryYAxisLabelOptions", "PrimaryYAxisLabelOptions", properties.PrimaryYAxisLabelOptions != null ? CfnTemplateChartAxisLabelOptionsPropertyFromCloudFormation(properties.PrimaryYAxisLabelOptions) : void 0), ret.addPropertyResult("referenceLines", "ReferenceLines", properties.ReferenceLines != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateReferenceLinePropertyFromCloudFormation)(properties.ReferenceLines) : void 0), ret.addPropertyResult("secondaryYAxisDisplayOptions", "SecondaryYAxisDisplayOptions", properties.SecondaryYAxisDisplayOptions != null ? CfnTemplateLineSeriesAxisDisplayOptionsPropertyFromCloudFormation(properties.SecondaryYAxisDisplayOptions) : void 0), ret.addPropertyResult("secondaryYAxisLabelOptions", "SecondaryYAxisLabelOptions", properties.SecondaryYAxisLabelOptions != null ? CfnTemplateChartAxisLabelOptionsPropertyFromCloudFormation(properties.SecondaryYAxisLabelOptions) : void 0), ret.addPropertyResult("series", "Series", properties.Series != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateSeriesItemPropertyFromCloudFormation)(properties.Series) : void 0), ret.addPropertyResult("smallMultiplesOptions", "SmallMultiplesOptions", properties.SmallMultiplesOptions != null ? CfnTemplateSmallMultiplesOptionsPropertyFromCloudFormation(properties.SmallMultiplesOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnTemplateLineChartSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnTemplateTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnTemplateVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addPropertyResult("xAxisDisplayOptions", "XAxisDisplayOptions", properties.XAxisDisplayOptions != null ? CfnTemplateAxisDisplayOptionsPropertyFromCloudFormation(properties.XAxisDisplayOptions) : void 0), ret.addPropertyResult("xAxisLabelOptions", "XAxisLabelOptions", properties.XAxisLabelOptions != null ? CfnTemplateChartAxisLabelOptionsPropertyFromCloudFormation(properties.XAxisLabelOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_LineChartDefaultSeriesSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("axisBinding", cdk.validateString)(properties.axisBinding)), errors.collect(cdk.propertyValidator("lineStyleSettings", CfnTemplate_LineChartLineStyleSettingsPropertyValidator)(properties.lineStyleSettings)), errors.collect(cdk.propertyValidator("markerStyleSettings", CfnTemplate_LineChartMarkerStyleSettingsPropertyValidator)(properties.markerStyleSettings)), errors.wrap('supplied properties not correct for "LineChartDefaultSeriesSettingsProperty"');
    }
    function cfnTemplateLineChartDefaultSeriesSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_LineChartDefaultSeriesSettingsPropertyValidator(properties).assertSuccess(), { AxisBinding: cdk.stringToCloudFormation(properties.axisBinding), LineStyleSettings: cfnTemplateLineChartLineStyleSettingsPropertyToCloudFormation(properties.lineStyleSettings), MarkerStyleSettings: cfnTemplateLineChartMarkerStyleSettingsPropertyToCloudFormation(properties.markerStyleSettings) }) : properties;
    }
    function CfnTemplateLineChartDefaultSeriesSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("axisBinding", "AxisBinding", properties.AxisBinding != null ? cfn_parse.FromCloudFormation.getString(properties.AxisBinding) : void 0), ret.addPropertyResult("lineStyleSettings", "LineStyleSettings", properties.LineStyleSettings != null ? CfnTemplateLineChartLineStyleSettingsPropertyFromCloudFormation(properties.LineStyleSettings) : void 0), ret.addPropertyResult("markerStyleSettings", "MarkerStyleSettings", properties.MarkerStyleSettings != null ? CfnTemplateLineChartMarkerStyleSettingsPropertyFromCloudFormation(properties.MarkerStyleSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_LineChartFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("lineChartAggregatedFieldWells", CfnTemplate_LineChartAggregatedFieldWellsPropertyValidator)(properties.lineChartAggregatedFieldWells)), errors.wrap('supplied properties not correct for "LineChartFieldWellsProperty"');
    }
    function cfnTemplateLineChartFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_LineChartFieldWellsPropertyValidator(properties).assertSuccess(), { LineChartAggregatedFieldWells: cfnTemplateLineChartAggregatedFieldWellsPropertyToCloudFormation(properties.lineChartAggregatedFieldWells) }) : properties;
    }
    function CfnTemplateLineChartFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("lineChartAggregatedFieldWells", "LineChartAggregatedFieldWells", properties.LineChartAggregatedFieldWells != null ? CfnTemplateLineChartAggregatedFieldWellsPropertyFromCloudFormation(properties.LineChartAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_LineChartLineStyleSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("lineInterpolation", cdk.validateString)(properties.lineInterpolation)), errors.collect(cdk.propertyValidator("lineStyle", cdk.validateString)(properties.lineStyle)), errors.collect(cdk.propertyValidator("lineVisibility", cdk.validateString)(properties.lineVisibility)), errors.collect(cdk.propertyValidator("lineWidth", cdk.validateString)(properties.lineWidth)), errors.wrap('supplied properties not correct for "LineChartLineStyleSettingsProperty"');
    }
    function cfnTemplateLineChartLineStyleSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_LineChartLineStyleSettingsPropertyValidator(properties).assertSuccess(), { LineInterpolation: cdk.stringToCloudFormation(properties.lineInterpolation), LineStyle: cdk.stringToCloudFormation(properties.lineStyle), LineVisibility: cdk.stringToCloudFormation(properties.lineVisibility), LineWidth: cdk.stringToCloudFormation(properties.lineWidth) }) : properties;
    }
    function CfnTemplateLineChartLineStyleSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("lineInterpolation", "LineInterpolation", properties.LineInterpolation != null ? cfn_parse.FromCloudFormation.getString(properties.LineInterpolation) : void 0), ret.addPropertyResult("lineStyle", "LineStyle", properties.LineStyle != null ? cfn_parse.FromCloudFormation.getString(properties.LineStyle) : void 0), ret.addPropertyResult("lineVisibility", "LineVisibility", properties.LineVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.LineVisibility) : void 0), ret.addPropertyResult("lineWidth", "LineWidth", properties.LineWidth != null ? cfn_parse.FromCloudFormation.getString(properties.LineWidth) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_LineChartMarkerStyleSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("markerColor", cdk.validateString)(properties.markerColor)), errors.collect(cdk.propertyValidator("markerShape", cdk.validateString)(properties.markerShape)), errors.collect(cdk.propertyValidator("markerSize", cdk.validateString)(properties.markerSize)), errors.collect(cdk.propertyValidator("markerVisibility", cdk.validateString)(properties.markerVisibility)), errors.wrap('supplied properties not correct for "LineChartMarkerStyleSettingsProperty"');
    }
    function cfnTemplateLineChartMarkerStyleSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_LineChartMarkerStyleSettingsPropertyValidator(properties).assertSuccess(), { MarkerColor: cdk.stringToCloudFormation(properties.markerColor), MarkerShape: cdk.stringToCloudFormation(properties.markerShape), MarkerSize: cdk.stringToCloudFormation(properties.markerSize), MarkerVisibility: cdk.stringToCloudFormation(properties.markerVisibility) }) : properties;
    }
    function CfnTemplateLineChartMarkerStyleSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("markerColor", "MarkerColor", properties.MarkerColor != null ? cfn_parse.FromCloudFormation.getString(properties.MarkerColor) : void 0), ret.addPropertyResult("markerShape", "MarkerShape", properties.MarkerShape != null ? cfn_parse.FromCloudFormation.getString(properties.MarkerShape) : void 0), ret.addPropertyResult("markerSize", "MarkerSize", properties.MarkerSize != null ? cfn_parse.FromCloudFormation.getString(properties.MarkerSize) : void 0), ret.addPropertyResult("markerVisibility", "MarkerVisibility", properties.MarkerVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.MarkerVisibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_LineChartSeriesSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("lineStyleSettings", CfnTemplate_LineChartLineStyleSettingsPropertyValidator)(properties.lineStyleSettings)), errors.collect(cdk.propertyValidator("markerStyleSettings", CfnTemplate_LineChartMarkerStyleSettingsPropertyValidator)(properties.markerStyleSettings)), errors.wrap('supplied properties not correct for "LineChartSeriesSettingsProperty"');
    }
    function cfnTemplateLineChartSeriesSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_LineChartSeriesSettingsPropertyValidator(properties).assertSuccess(), { LineStyleSettings: cfnTemplateLineChartLineStyleSettingsPropertyToCloudFormation(properties.lineStyleSettings), MarkerStyleSettings: cfnTemplateLineChartMarkerStyleSettingsPropertyToCloudFormation(properties.markerStyleSettings) }) : properties;
    }
    function CfnTemplateLineChartSeriesSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("lineStyleSettings", "LineStyleSettings", properties.LineStyleSettings != null ? CfnTemplateLineChartLineStyleSettingsPropertyFromCloudFormation(properties.LineStyleSettings) : void 0), ret.addPropertyResult("markerStyleSettings", "MarkerStyleSettings", properties.MarkerStyleSettings != null ? CfnTemplateLineChartMarkerStyleSettingsPropertyFromCloudFormation(properties.MarkerStyleSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_LineChartSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryItemsLimitConfiguration", CfnTemplate_ItemsLimitConfigurationPropertyValidator)(properties.categoryItemsLimitConfiguration)), errors.collect(cdk.propertyValidator("categorySort", cdk.listValidator(CfnTemplate_FieldSortOptionsPropertyValidator))(properties.categorySort)), errors.collect(cdk.propertyValidator("colorItemsLimitConfiguration", CfnTemplate_ItemsLimitConfigurationPropertyValidator)(properties.colorItemsLimitConfiguration)), errors.collect(cdk.propertyValidator("smallMultiplesLimitConfiguration", CfnTemplate_ItemsLimitConfigurationPropertyValidator)(properties.smallMultiplesLimitConfiguration)), errors.collect(cdk.propertyValidator("smallMultiplesSort", cdk.listValidator(CfnTemplate_FieldSortOptionsPropertyValidator))(properties.smallMultiplesSort)), errors.wrap('supplied properties not correct for "LineChartSortConfigurationProperty"');
    }
    function cfnTemplateLineChartSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_LineChartSortConfigurationPropertyValidator(properties).assertSuccess(), { CategoryItemsLimitConfiguration: cfnTemplateItemsLimitConfigurationPropertyToCloudFormation(properties.categoryItemsLimitConfiguration), CategorySort: cdk.listMapper(cfnTemplateFieldSortOptionsPropertyToCloudFormation)(properties.categorySort), ColorItemsLimitConfiguration: cfnTemplateItemsLimitConfigurationPropertyToCloudFormation(properties.colorItemsLimitConfiguration), SmallMultiplesLimitConfiguration: cfnTemplateItemsLimitConfigurationPropertyToCloudFormation(properties.smallMultiplesLimitConfiguration), SmallMultiplesSort: cdk.listMapper(cfnTemplateFieldSortOptionsPropertyToCloudFormation)(properties.smallMultiplesSort) }) : properties;
    }
    function CfnTemplateLineChartSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryItemsLimitConfiguration", "CategoryItemsLimitConfiguration", properties.CategoryItemsLimitConfiguration != null ? CfnTemplateItemsLimitConfigurationPropertyFromCloudFormation(properties.CategoryItemsLimitConfiguration) : void 0), ret.addPropertyResult("categorySort", "CategorySort", properties.CategorySort != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateFieldSortOptionsPropertyFromCloudFormation)(properties.CategorySort) : void 0), ret.addPropertyResult("colorItemsLimitConfiguration", "ColorItemsLimitConfiguration", properties.ColorItemsLimitConfiguration != null ? CfnTemplateItemsLimitConfigurationPropertyFromCloudFormation(properties.ColorItemsLimitConfiguration) : void 0), ret.addPropertyResult("smallMultiplesLimitConfiguration", "SmallMultiplesLimitConfiguration", properties.SmallMultiplesLimitConfiguration != null ? CfnTemplateItemsLimitConfigurationPropertyFromCloudFormation(properties.SmallMultiplesLimitConfiguration) : void 0), ret.addPropertyResult("smallMultiplesSort", "SmallMultiplesSort", properties.SmallMultiplesSort != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateFieldSortOptionsPropertyFromCloudFormation)(properties.SmallMultiplesSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_LineChartVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnTemplate_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnTemplate_LineChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnTemplate_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnTemplate_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnTemplate_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "LineChartVisualProperty"');
    }
    function cfnTemplateLineChartVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_LineChartVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnTemplateVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnTemplateLineChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnTemplateColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnTemplateVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnTemplateVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnTemplateLineChartVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnTemplateLineChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnTemplateVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnTemplateVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_LineSeriesAxisDisplayOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("axisOptions", CfnTemplate_AxisDisplayOptionsPropertyValidator)(properties.axisOptions)), errors.collect(cdk.propertyValidator("missingDataConfigurations", cdk.listValidator(CfnTemplate_MissingDataConfigurationPropertyValidator))(properties.missingDataConfigurations)), errors.wrap('supplied properties not correct for "LineSeriesAxisDisplayOptionsProperty"');
    }
    function cfnTemplateLineSeriesAxisDisplayOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_LineSeriesAxisDisplayOptionsPropertyValidator(properties).assertSuccess(), { AxisOptions: cfnTemplateAxisDisplayOptionsPropertyToCloudFormation(properties.axisOptions), MissingDataConfigurations: cdk.listMapper(cfnTemplateMissingDataConfigurationPropertyToCloudFormation)(properties.missingDataConfigurations) }) : properties;
    }
    function CfnTemplateLineSeriesAxisDisplayOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("axisOptions", "AxisOptions", properties.AxisOptions != null ? CfnTemplateAxisDisplayOptionsPropertyFromCloudFormation(properties.AxisOptions) : void 0), ret.addPropertyResult("missingDataConfigurations", "MissingDataConfigurations", properties.MissingDataConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMissingDataConfigurationPropertyFromCloudFormation)(properties.MissingDataConfigurations) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ListControlDisplayOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("searchOptions", CfnTemplate_ListControlSearchOptionsPropertyValidator)(properties.searchOptions)), errors.collect(cdk.propertyValidator("selectAllOptions", CfnTemplate_ListControlSelectAllOptionsPropertyValidator)(properties.selectAllOptions)), errors.collect(cdk.propertyValidator("titleOptions", CfnTemplate_LabelOptionsPropertyValidator)(properties.titleOptions)), errors.wrap('supplied properties not correct for "ListControlDisplayOptionsProperty"');
    }
    function cfnTemplateListControlDisplayOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ListControlDisplayOptionsPropertyValidator(properties).assertSuccess(), { SearchOptions: cfnTemplateListControlSearchOptionsPropertyToCloudFormation(properties.searchOptions), SelectAllOptions: cfnTemplateListControlSelectAllOptionsPropertyToCloudFormation(properties.selectAllOptions), TitleOptions: cfnTemplateLabelOptionsPropertyToCloudFormation(properties.titleOptions) }) : properties;
    }
    function CfnTemplateListControlDisplayOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("searchOptions", "SearchOptions", properties.SearchOptions != null ? CfnTemplateListControlSearchOptionsPropertyFromCloudFormation(properties.SearchOptions) : void 0), ret.addPropertyResult("selectAllOptions", "SelectAllOptions", properties.SelectAllOptions != null ? CfnTemplateListControlSelectAllOptionsPropertyFromCloudFormation(properties.SelectAllOptions) : void 0), ret.addPropertyResult("titleOptions", "TitleOptions", properties.TitleOptions != null ? CfnTemplateLabelOptionsPropertyFromCloudFormation(properties.TitleOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ListControlSearchOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "ListControlSearchOptionsProperty"');
    }
    function cfnTemplateListControlSearchOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ListControlSearchOptionsPropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnTemplateListControlSearchOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ListControlSelectAllOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "ListControlSelectAllOptionsProperty"');
    }
    function cfnTemplateListControlSelectAllOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ListControlSelectAllOptionsPropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnTemplateListControlSelectAllOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_LoadingAnimationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "LoadingAnimationProperty"');
    }
    function cfnTemplateLoadingAnimationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_LoadingAnimationPropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnTemplateLoadingAnimationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_LocalNavigationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("targetSheetId", cdk.requiredValidator)(properties.targetSheetId)), errors.collect(cdk.propertyValidator("targetSheetId", cdk.validateString)(properties.targetSheetId)), errors.wrap('supplied properties not correct for "LocalNavigationConfigurationProperty"');
    }
    function cfnTemplateLocalNavigationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_LocalNavigationConfigurationPropertyValidator(properties).assertSuccess(), { TargetSheetId: cdk.stringToCloudFormation(properties.targetSheetId) }) : properties;
    }
    function CfnTemplateLocalNavigationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("targetSheetId", "TargetSheetId", cfn_parse.FromCloudFormation.getString(properties.TargetSheetId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_LongFormatTextPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("plainText", cdk.validateString)(properties.plainText)), errors.collect(cdk.propertyValidator("richText", cdk.validateString)(properties.richText)), errors.wrap('supplied properties not correct for "LongFormatTextProperty"');
    }
    function cfnTemplateLongFormatTextPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_LongFormatTextPropertyValidator(properties).assertSuccess(), { PlainText: cdk.stringToCloudFormation(properties.plainText), RichText: cdk.stringToCloudFormation(properties.richText) }) : properties;
    }
    function CfnTemplateLongFormatTextPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("plainText", "PlainText", properties.PlainText != null ? cfn_parse.FromCloudFormation.getString(properties.PlainText) : void 0), ret.addPropertyResult("richText", "RichText", properties.RichText != null ? cfn_parse.FromCloudFormation.getString(properties.RichText) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_MappedDataSetParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.requiredValidator)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.validateString)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("dataSetParameterName", cdk.requiredValidator)(properties.dataSetParameterName)), errors.collect(cdk.propertyValidator("dataSetParameterName", cdk.validateString)(properties.dataSetParameterName)), errors.wrap('supplied properties not correct for "MappedDataSetParameterProperty"');
    }
    function cfnTemplateMappedDataSetParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_MappedDataSetParameterPropertyValidator(properties).assertSuccess(), { DataSetIdentifier: cdk.stringToCloudFormation(properties.dataSetIdentifier), DataSetParameterName: cdk.stringToCloudFormation(properties.dataSetParameterName) }) : properties;
    }
    function CfnTemplateMappedDataSetParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataSetIdentifier", "DataSetIdentifier", cfn_parse.FromCloudFormation.getString(properties.DataSetIdentifier)), ret.addPropertyResult("dataSetParameterName", "DataSetParameterName", cfn_parse.FromCloudFormation.getString(properties.DataSetParameterName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_MaximumLabelTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "MaximumLabelTypeProperty"');
    }
    function cfnTemplateMaximumLabelTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_MaximumLabelTypePropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnTemplateMaximumLabelTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_MaximumMinimumComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computationId", cdk.requiredValidator)(properties.computationId)), errors.collect(cdk.propertyValidator("computationId", cdk.validateString)(properties.computationId)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("time", cdk.requiredValidator)(properties.time)), errors.collect(cdk.propertyValidator("time", CfnTemplate_DimensionFieldPropertyValidator)(properties.time)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", CfnTemplate_MeasureFieldPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "MaximumMinimumComputationProperty"');
    }
    function cfnTemplateMaximumMinimumComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_MaximumMinimumComputationPropertyValidator(properties).assertSuccess(), { ComputationId: cdk.stringToCloudFormation(properties.computationId), Name: cdk.stringToCloudFormation(properties.name), Time: cfnTemplateDimensionFieldPropertyToCloudFormation(properties.time), Type: cdk.stringToCloudFormation(properties.type), Value: cfnTemplateMeasureFieldPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnTemplateMaximumMinimumComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computationId", "ComputationId", cfn_parse.FromCloudFormation.getString(properties.ComputationId)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("time", "Time", CfnTemplateDimensionFieldPropertyFromCloudFormation(properties.Time)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("value", "Value", properties.Value != null ? CfnTemplateMeasureFieldPropertyFromCloudFormation(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_MeasureFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("calculatedMeasureField", CfnTemplate_CalculatedMeasureFieldPropertyValidator)(properties.calculatedMeasureField)), errors.collect(cdk.propertyValidator("categoricalMeasureField", CfnTemplate_CategoricalMeasureFieldPropertyValidator)(properties.categoricalMeasureField)), errors.collect(cdk.propertyValidator("dateMeasureField", CfnTemplate_DateMeasureFieldPropertyValidator)(properties.dateMeasureField)), errors.collect(cdk.propertyValidator("numericalMeasureField", CfnTemplate_NumericalMeasureFieldPropertyValidator)(properties.numericalMeasureField)), errors.wrap('supplied properties not correct for "MeasureFieldProperty"');
    }
    function cfnTemplateMeasureFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_MeasureFieldPropertyValidator(properties).assertSuccess(), { CalculatedMeasureField: cfnTemplateCalculatedMeasureFieldPropertyToCloudFormation(properties.calculatedMeasureField), CategoricalMeasureField: cfnTemplateCategoricalMeasureFieldPropertyToCloudFormation(properties.categoricalMeasureField), DateMeasureField: cfnTemplateDateMeasureFieldPropertyToCloudFormation(properties.dateMeasureField), NumericalMeasureField: cfnTemplateNumericalMeasureFieldPropertyToCloudFormation(properties.numericalMeasureField) }) : properties;
    }
    function CfnTemplateMeasureFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("calculatedMeasureField", "CalculatedMeasureField", properties.CalculatedMeasureField != null ? CfnTemplateCalculatedMeasureFieldPropertyFromCloudFormation(properties.CalculatedMeasureField) : void 0), ret.addPropertyResult("categoricalMeasureField", "CategoricalMeasureField", properties.CategoricalMeasureField != null ? CfnTemplateCategoricalMeasureFieldPropertyFromCloudFormation(properties.CategoricalMeasureField) : void 0), ret.addPropertyResult("dateMeasureField", "DateMeasureField", properties.DateMeasureField != null ? CfnTemplateDateMeasureFieldPropertyFromCloudFormation(properties.DateMeasureField) : void 0), ret.addPropertyResult("numericalMeasureField", "NumericalMeasureField", properties.NumericalMeasureField != null ? CfnTemplateNumericalMeasureFieldPropertyFromCloudFormation(properties.NumericalMeasureField) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_MetricComparisonComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computationId", cdk.requiredValidator)(properties.computationId)), errors.collect(cdk.propertyValidator("computationId", cdk.validateString)(properties.computationId)), errors.collect(cdk.propertyValidator("fromValue", cdk.requiredValidator)(properties.fromValue)), errors.collect(cdk.propertyValidator("fromValue", CfnTemplate_MeasureFieldPropertyValidator)(properties.fromValue)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("targetValue", cdk.requiredValidator)(properties.targetValue)), errors.collect(cdk.propertyValidator("targetValue", CfnTemplate_MeasureFieldPropertyValidator)(properties.targetValue)), errors.collect(cdk.propertyValidator("time", cdk.requiredValidator)(properties.time)), errors.collect(cdk.propertyValidator("time", CfnTemplate_DimensionFieldPropertyValidator)(properties.time)), errors.wrap('supplied properties not correct for "MetricComparisonComputationProperty"');
    }
    function cfnTemplateMetricComparisonComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_MetricComparisonComputationPropertyValidator(properties).assertSuccess(), { ComputationId: cdk.stringToCloudFormation(properties.computationId), FromValue: cfnTemplateMeasureFieldPropertyToCloudFormation(properties.fromValue), Name: cdk.stringToCloudFormation(properties.name), TargetValue: cfnTemplateMeasureFieldPropertyToCloudFormation(properties.targetValue), Time: cfnTemplateDimensionFieldPropertyToCloudFormation(properties.time) }) : properties;
    }
    function CfnTemplateMetricComparisonComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computationId", "ComputationId", cfn_parse.FromCloudFormation.getString(properties.ComputationId)), ret.addPropertyResult("fromValue", "FromValue", CfnTemplateMeasureFieldPropertyFromCloudFormation(properties.FromValue)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("targetValue", "TargetValue", CfnTemplateMeasureFieldPropertyFromCloudFormation(properties.TargetValue)), ret.addPropertyResult("time", "Time", CfnTemplateDimensionFieldPropertyFromCloudFormation(properties.Time)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_MinimumLabelTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "MinimumLabelTypeProperty"');
    }
    function cfnTemplateMinimumLabelTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_MinimumLabelTypePropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnTemplateMinimumLabelTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_MissingDataConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("treatmentOption", cdk.validateString)(properties.treatmentOption)), errors.wrap('supplied properties not correct for "MissingDataConfigurationProperty"');
    }
    function cfnTemplateMissingDataConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_MissingDataConfigurationPropertyValidator(properties).assertSuccess(), { TreatmentOption: cdk.stringToCloudFormation(properties.treatmentOption) }) : properties;
    }
    function CfnTemplateMissingDataConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("treatmentOption", "TreatmentOption", properties.TreatmentOption != null ? cfn_parse.FromCloudFormation.getString(properties.TreatmentOption) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_NegativeValueConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("displayMode", cdk.requiredValidator)(properties.displayMode)), errors.collect(cdk.propertyValidator("displayMode", cdk.validateString)(properties.displayMode)), errors.wrap('supplied properties not correct for "NegativeValueConfigurationProperty"');
    }
    function cfnTemplateNegativeValueConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_NegativeValueConfigurationPropertyValidator(properties).assertSuccess(), { DisplayMode: cdk.stringToCloudFormation(properties.displayMode) }) : properties;
    }
    function CfnTemplateNegativeValueConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("displayMode", "DisplayMode", cfn_parse.FromCloudFormation.getString(properties.DisplayMode)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_NullValueFormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("nullString", cdk.requiredValidator)(properties.nullString)), errors.collect(cdk.propertyValidator("nullString", cdk.validateString)(properties.nullString)), errors.wrap('supplied properties not correct for "NullValueFormatConfigurationProperty"');
    }
    function cfnTemplateNullValueFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_NullValueFormatConfigurationPropertyValidator(properties).assertSuccess(), { NullString: cdk.stringToCloudFormation(properties.nullString) }) : properties;
    }
    function CfnTemplateNullValueFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("nullString", "NullString", cfn_parse.FromCloudFormation.getString(properties.NullString)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_NumberDisplayFormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("decimalPlacesConfiguration", CfnTemplate_DecimalPlacesConfigurationPropertyValidator)(properties.decimalPlacesConfiguration)), errors.collect(cdk.propertyValidator("negativeValueConfiguration", CfnTemplate_NegativeValueConfigurationPropertyValidator)(properties.negativeValueConfiguration)), errors.collect(cdk.propertyValidator("nullValueFormatConfiguration", CfnTemplate_NullValueFormatConfigurationPropertyValidator)(properties.nullValueFormatConfiguration)), errors.collect(cdk.propertyValidator("numberScale", cdk.validateString)(properties.numberScale)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.collect(cdk.propertyValidator("separatorConfiguration", CfnTemplate_NumericSeparatorConfigurationPropertyValidator)(properties.separatorConfiguration)), errors.collect(cdk.propertyValidator("suffix", cdk.validateString)(properties.suffix)), errors.wrap('supplied properties not correct for "NumberDisplayFormatConfigurationProperty"');
    }
    function cfnTemplateNumberDisplayFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_NumberDisplayFormatConfigurationPropertyValidator(properties).assertSuccess(), { DecimalPlacesConfiguration: cfnTemplateDecimalPlacesConfigurationPropertyToCloudFormation(properties.decimalPlacesConfiguration), NegativeValueConfiguration: cfnTemplateNegativeValueConfigurationPropertyToCloudFormation(properties.negativeValueConfiguration), NullValueFormatConfiguration: cfnTemplateNullValueFormatConfigurationPropertyToCloudFormation(properties.nullValueFormatConfiguration), NumberScale: cdk.stringToCloudFormation(properties.numberScale), Prefix: cdk.stringToCloudFormation(properties.prefix), SeparatorConfiguration: cfnTemplateNumericSeparatorConfigurationPropertyToCloudFormation(properties.separatorConfiguration), Suffix: cdk.stringToCloudFormation(properties.suffix) }) : properties;
    }
    function CfnTemplateNumberDisplayFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("decimalPlacesConfiguration", "DecimalPlacesConfiguration", properties.DecimalPlacesConfiguration != null ? CfnTemplateDecimalPlacesConfigurationPropertyFromCloudFormation(properties.DecimalPlacesConfiguration) : void 0), ret.addPropertyResult("negativeValueConfiguration", "NegativeValueConfiguration", properties.NegativeValueConfiguration != null ? CfnTemplateNegativeValueConfigurationPropertyFromCloudFormation(properties.NegativeValueConfiguration) : void 0), ret.addPropertyResult("nullValueFormatConfiguration", "NullValueFormatConfiguration", properties.NullValueFormatConfiguration != null ? CfnTemplateNullValueFormatConfigurationPropertyFromCloudFormation(properties.NullValueFormatConfiguration) : void 0), ret.addPropertyResult("numberScale", "NumberScale", properties.NumberScale != null ? cfn_parse.FromCloudFormation.getString(properties.NumberScale) : void 0), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addPropertyResult("separatorConfiguration", "SeparatorConfiguration", properties.SeparatorConfiguration != null ? CfnTemplateNumericSeparatorConfigurationPropertyFromCloudFormation(properties.SeparatorConfiguration) : void 0), ret.addPropertyResult("suffix", "Suffix", properties.Suffix != null ? cfn_parse.FromCloudFormation.getString(properties.Suffix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_NumberFormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("formatConfiguration", CfnTemplate_NumericFormatConfigurationPropertyValidator)(properties.formatConfiguration)), errors.wrap('supplied properties not correct for "NumberFormatConfigurationProperty"');
    }
    function cfnTemplateNumberFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_NumberFormatConfigurationPropertyValidator(properties).assertSuccess(), { FormatConfiguration: cfnTemplateNumericFormatConfigurationPropertyToCloudFormation(properties.formatConfiguration) }) : properties;
    }
    function CfnTemplateNumberFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("formatConfiguration", "FormatConfiguration", properties.FormatConfiguration != null ? CfnTemplateNumericFormatConfigurationPropertyFromCloudFormation(properties.FormatConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_NumericAxisOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("range", CfnTemplate_AxisDisplayRangePropertyValidator)(properties.range)), errors.collect(cdk.propertyValidator("scale", CfnTemplate_AxisScalePropertyValidator)(properties.scale)), errors.wrap('supplied properties not correct for "NumericAxisOptionsProperty"');
    }
    function cfnTemplateNumericAxisOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_NumericAxisOptionsPropertyValidator(properties).assertSuccess(), { Range: cfnTemplateAxisDisplayRangePropertyToCloudFormation(properties.range), Scale: cfnTemplateAxisScalePropertyToCloudFormation(properties.scale) }) : properties;
    }
    function CfnTemplateNumericAxisOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("range", "Range", properties.Range != null ? CfnTemplateAxisDisplayRangePropertyFromCloudFormation(properties.Range) : void 0), ret.addPropertyResult("scale", "Scale", properties.Scale != null ? CfnTemplateAxisScalePropertyFromCloudFormation(properties.Scale) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_NumericEqualityDrillDownFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnTemplate_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "NumericEqualityDrillDownFilterProperty"');
    }
    function cfnTemplateNumericEqualityDrillDownFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_NumericEqualityDrillDownFilterPropertyValidator(properties).assertSuccess(), { Column: cfnTemplateColumnIdentifierPropertyToCloudFormation(properties.column), Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnTemplateNumericEqualityDrillDownFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", CfnTemplateColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getNumber(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_NumericEqualityFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationFunction", CfnTemplate_AggregationFunctionPropertyValidator)(properties.aggregationFunction)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnTemplate_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("filterId", cdk.requiredValidator)(properties.filterId)), errors.collect(cdk.propertyValidator("filterId", cdk.validateString)(properties.filterId)), errors.collect(cdk.propertyValidator("matchOperator", cdk.requiredValidator)(properties.matchOperator)), errors.collect(cdk.propertyValidator("matchOperator", cdk.validateString)(properties.matchOperator)), errors.collect(cdk.propertyValidator("nullOption", cdk.requiredValidator)(properties.nullOption)), errors.collect(cdk.propertyValidator("nullOption", cdk.validateString)(properties.nullOption)), errors.collect(cdk.propertyValidator("parameterName", cdk.validateString)(properties.parameterName)), errors.collect(cdk.propertyValidator("selectAllOptions", cdk.validateString)(properties.selectAllOptions)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "NumericEqualityFilterProperty"');
    }
    function cfnTemplateNumericEqualityFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_NumericEqualityFilterPropertyValidator(properties).assertSuccess(), { AggregationFunction: cfnTemplateAggregationFunctionPropertyToCloudFormation(properties.aggregationFunction), Column: cfnTemplateColumnIdentifierPropertyToCloudFormation(properties.column), FilterId: cdk.stringToCloudFormation(properties.filterId), MatchOperator: cdk.stringToCloudFormation(properties.matchOperator), NullOption: cdk.stringToCloudFormation(properties.nullOption), ParameterName: cdk.stringToCloudFormation(properties.parameterName), SelectAllOptions: cdk.stringToCloudFormation(properties.selectAllOptions), Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnTemplateNumericEqualityFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationFunction", "AggregationFunction", properties.AggregationFunction != null ? CfnTemplateAggregationFunctionPropertyFromCloudFormation(properties.AggregationFunction) : void 0), ret.addPropertyResult("column", "Column", CfnTemplateColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("filterId", "FilterId", cfn_parse.FromCloudFormation.getString(properties.FilterId)), ret.addPropertyResult("matchOperator", "MatchOperator", cfn_parse.FromCloudFormation.getString(properties.MatchOperator)), ret.addPropertyResult("nullOption", "NullOption", cfn_parse.FromCloudFormation.getString(properties.NullOption)), ret.addPropertyResult("parameterName", "ParameterName", properties.ParameterName != null ? cfn_parse.FromCloudFormation.getString(properties.ParameterName) : void 0), ret.addPropertyResult("selectAllOptions", "SelectAllOptions", properties.SelectAllOptions != null ? cfn_parse.FromCloudFormation.getString(properties.SelectAllOptions) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getNumber(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_NumericFormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("currencyDisplayFormatConfiguration", CfnTemplate_CurrencyDisplayFormatConfigurationPropertyValidator)(properties.currencyDisplayFormatConfiguration)), errors.collect(cdk.propertyValidator("numberDisplayFormatConfiguration", CfnTemplate_NumberDisplayFormatConfigurationPropertyValidator)(properties.numberDisplayFormatConfiguration)), errors.collect(cdk.propertyValidator("percentageDisplayFormatConfiguration", CfnTemplate_PercentageDisplayFormatConfigurationPropertyValidator)(properties.percentageDisplayFormatConfiguration)), errors.wrap('supplied properties not correct for "NumericFormatConfigurationProperty"');
    }
    function cfnTemplateNumericFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_NumericFormatConfigurationPropertyValidator(properties).assertSuccess(), { CurrencyDisplayFormatConfiguration: cfnTemplateCurrencyDisplayFormatConfigurationPropertyToCloudFormation(properties.currencyDisplayFormatConfiguration), NumberDisplayFormatConfiguration: cfnTemplateNumberDisplayFormatConfigurationPropertyToCloudFormation(properties.numberDisplayFormatConfiguration), PercentageDisplayFormatConfiguration: cfnTemplatePercentageDisplayFormatConfigurationPropertyToCloudFormation(properties.percentageDisplayFormatConfiguration) }) : properties;
    }
    function CfnTemplateNumericFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("currencyDisplayFormatConfiguration", "CurrencyDisplayFormatConfiguration", properties.CurrencyDisplayFormatConfiguration != null ? CfnTemplateCurrencyDisplayFormatConfigurationPropertyFromCloudFormation(properties.CurrencyDisplayFormatConfiguration) : void 0), ret.addPropertyResult("numberDisplayFormatConfiguration", "NumberDisplayFormatConfiguration", properties.NumberDisplayFormatConfiguration != null ? CfnTemplateNumberDisplayFormatConfigurationPropertyFromCloudFormation(properties.NumberDisplayFormatConfiguration) : void 0), ret.addPropertyResult("percentageDisplayFormatConfiguration", "PercentageDisplayFormatConfiguration", properties.PercentageDisplayFormatConfiguration != null ? CfnTemplatePercentageDisplayFormatConfigurationPropertyFromCloudFormation(properties.PercentageDisplayFormatConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_NumericRangeFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationFunction", CfnTemplate_AggregationFunctionPropertyValidator)(properties.aggregationFunction)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnTemplate_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("filterId", cdk.requiredValidator)(properties.filterId)), errors.collect(cdk.propertyValidator("filterId", cdk.validateString)(properties.filterId)), errors.collect(cdk.propertyValidator("includeMaximum", cdk.validateBoolean)(properties.includeMaximum)), errors.collect(cdk.propertyValidator("includeMinimum", cdk.validateBoolean)(properties.includeMinimum)), errors.collect(cdk.propertyValidator("nullOption", cdk.requiredValidator)(properties.nullOption)), errors.collect(cdk.propertyValidator("nullOption", cdk.validateString)(properties.nullOption)), errors.collect(cdk.propertyValidator("rangeMaximum", CfnTemplate_NumericRangeFilterValuePropertyValidator)(properties.rangeMaximum)), errors.collect(cdk.propertyValidator("rangeMinimum", CfnTemplate_NumericRangeFilterValuePropertyValidator)(properties.rangeMinimum)), errors.collect(cdk.propertyValidator("selectAllOptions", cdk.validateString)(properties.selectAllOptions)), errors.wrap('supplied properties not correct for "NumericRangeFilterProperty"');
    }
    function cfnTemplateNumericRangeFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_NumericRangeFilterPropertyValidator(properties).assertSuccess(), { AggregationFunction: cfnTemplateAggregationFunctionPropertyToCloudFormation(properties.aggregationFunction), Column: cfnTemplateColumnIdentifierPropertyToCloudFormation(properties.column), FilterId: cdk.stringToCloudFormation(properties.filterId), IncludeMaximum: cdk.booleanToCloudFormation(properties.includeMaximum), IncludeMinimum: cdk.booleanToCloudFormation(properties.includeMinimum), NullOption: cdk.stringToCloudFormation(properties.nullOption), RangeMaximum: cfnTemplateNumericRangeFilterValuePropertyToCloudFormation(properties.rangeMaximum), RangeMinimum: cfnTemplateNumericRangeFilterValuePropertyToCloudFormation(properties.rangeMinimum), SelectAllOptions: cdk.stringToCloudFormation(properties.selectAllOptions) }) : properties;
    }
    function CfnTemplateNumericRangeFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationFunction", "AggregationFunction", properties.AggregationFunction != null ? CfnTemplateAggregationFunctionPropertyFromCloudFormation(properties.AggregationFunction) : void 0), ret.addPropertyResult("column", "Column", CfnTemplateColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("filterId", "FilterId", cfn_parse.FromCloudFormation.getString(properties.FilterId)), ret.addPropertyResult("includeMaximum", "IncludeMaximum", properties.IncludeMaximum != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeMaximum) : void 0), ret.addPropertyResult("includeMinimum", "IncludeMinimum", properties.IncludeMinimum != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeMinimum) : void 0), ret.addPropertyResult("nullOption", "NullOption", cfn_parse.FromCloudFormation.getString(properties.NullOption)), ret.addPropertyResult("rangeMaximum", "RangeMaximum", properties.RangeMaximum != null ? CfnTemplateNumericRangeFilterValuePropertyFromCloudFormation(properties.RangeMaximum) : void 0), ret.addPropertyResult("rangeMinimum", "RangeMinimum", properties.RangeMinimum != null ? CfnTemplateNumericRangeFilterValuePropertyFromCloudFormation(properties.RangeMinimum) : void 0), ret.addPropertyResult("selectAllOptions", "SelectAllOptions", properties.SelectAllOptions != null ? cfn_parse.FromCloudFormation.getString(properties.SelectAllOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_NumericRangeFilterValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("parameter", cdk.validateString)(properties.parameter)), errors.collect(cdk.propertyValidator("staticValue", cdk.validateNumber)(properties.staticValue)), errors.wrap('supplied properties not correct for "NumericRangeFilterValueProperty"');
    }
    function cfnTemplateNumericRangeFilterValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_NumericRangeFilterValuePropertyValidator(properties).assertSuccess(), { Parameter: cdk.stringToCloudFormation(properties.parameter), StaticValue: cdk.numberToCloudFormation(properties.staticValue) }) : properties;
    }
    function CfnTemplateNumericRangeFilterValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("parameter", "Parameter", properties.Parameter != null ? cfn_parse.FromCloudFormation.getString(properties.Parameter) : void 0), ret.addPropertyResult("staticValue", "StaticValue", properties.StaticValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.StaticValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_NumericSeparatorConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("decimalSeparator", cdk.validateString)(properties.decimalSeparator)), errors.collect(cdk.propertyValidator("thousandsSeparator", CfnTemplate_ThousandSeparatorOptionsPropertyValidator)(properties.thousandsSeparator)), errors.wrap('supplied properties not correct for "NumericSeparatorConfigurationProperty"');
    }
    function cfnTemplateNumericSeparatorConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_NumericSeparatorConfigurationPropertyValidator(properties).assertSuccess(), { DecimalSeparator: cdk.stringToCloudFormation(properties.decimalSeparator), ThousandsSeparator: cfnTemplateThousandSeparatorOptionsPropertyToCloudFormation(properties.thousandsSeparator) }) : properties;
    }
    function CfnTemplateNumericSeparatorConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("decimalSeparator", "DecimalSeparator", properties.DecimalSeparator != null ? cfn_parse.FromCloudFormation.getString(properties.DecimalSeparator) : void 0), ret.addPropertyResult("thousandsSeparator", "ThousandsSeparator", properties.ThousandsSeparator != null ? CfnTemplateThousandSeparatorOptionsPropertyFromCloudFormation(properties.ThousandsSeparator) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_NumericalAggregationFunctionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("percentileAggregation", CfnTemplate_PercentileAggregationPropertyValidator)(properties.percentileAggregation)), errors.collect(cdk.propertyValidator("simpleNumericalAggregation", cdk.validateString)(properties.simpleNumericalAggregation)), errors.wrap('supplied properties not correct for "NumericalAggregationFunctionProperty"');
    }
    function cfnTemplateNumericalAggregationFunctionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_NumericalAggregationFunctionPropertyValidator(properties).assertSuccess(), { PercentileAggregation: cfnTemplatePercentileAggregationPropertyToCloudFormation(properties.percentileAggregation), SimpleNumericalAggregation: cdk.stringToCloudFormation(properties.simpleNumericalAggregation) }) : properties;
    }
    function CfnTemplateNumericalAggregationFunctionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("percentileAggregation", "PercentileAggregation", properties.PercentileAggregation != null ? CfnTemplatePercentileAggregationPropertyFromCloudFormation(properties.PercentileAggregation) : void 0), ret.addPropertyResult("simpleNumericalAggregation", "SimpleNumericalAggregation", properties.SimpleNumericalAggregation != null ? cfn_parse.FromCloudFormation.getString(properties.SimpleNumericalAggregation) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_NumericalDimensionFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnTemplate_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("formatConfiguration", CfnTemplate_NumberFormatConfigurationPropertyValidator)(properties.formatConfiguration)), errors.collect(cdk.propertyValidator("hierarchyId", cdk.validateString)(properties.hierarchyId)), errors.wrap('supplied properties not correct for "NumericalDimensionFieldProperty"');
    }
    function cfnTemplateNumericalDimensionFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_NumericalDimensionFieldPropertyValidator(properties).assertSuccess(), { Column: cfnTemplateColumnIdentifierPropertyToCloudFormation(properties.column), FieldId: cdk.stringToCloudFormation(properties.fieldId), FormatConfiguration: cfnTemplateNumberFormatConfigurationPropertyToCloudFormation(properties.formatConfiguration), HierarchyId: cdk.stringToCloudFormation(properties.hierarchyId) }) : properties;
    }
    function CfnTemplateNumericalDimensionFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", CfnTemplateColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("formatConfiguration", "FormatConfiguration", properties.FormatConfiguration != null ? CfnTemplateNumberFormatConfigurationPropertyFromCloudFormation(properties.FormatConfiguration) : void 0), ret.addPropertyResult("hierarchyId", "HierarchyId", properties.HierarchyId != null ? cfn_parse.FromCloudFormation.getString(properties.HierarchyId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_NumericalMeasureFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationFunction", CfnTemplate_NumericalAggregationFunctionPropertyValidator)(properties.aggregationFunction)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnTemplate_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("formatConfiguration", CfnTemplate_NumberFormatConfigurationPropertyValidator)(properties.formatConfiguration)), errors.wrap('supplied properties not correct for "NumericalMeasureFieldProperty"');
    }
    function cfnTemplateNumericalMeasureFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_NumericalMeasureFieldPropertyValidator(properties).assertSuccess(), { AggregationFunction: cfnTemplateNumericalAggregationFunctionPropertyToCloudFormation(properties.aggregationFunction), Column: cfnTemplateColumnIdentifierPropertyToCloudFormation(properties.column), FieldId: cdk.stringToCloudFormation(properties.fieldId), FormatConfiguration: cfnTemplateNumberFormatConfigurationPropertyToCloudFormation(properties.formatConfiguration) }) : properties;
    }
    function CfnTemplateNumericalMeasureFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationFunction", "AggregationFunction", properties.AggregationFunction != null ? CfnTemplateNumericalAggregationFunctionPropertyFromCloudFormation(properties.AggregationFunction) : void 0), ret.addPropertyResult("column", "Column", CfnTemplateColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("formatConfiguration", "FormatConfiguration", properties.FormatConfiguration != null ? CfnTemplateNumberFormatConfigurationPropertyFromCloudFormation(properties.FormatConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PaginationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("pageNumber", cdk.requiredValidator)(properties.pageNumber)), errors.collect(cdk.propertyValidator("pageNumber", cdk.validateNumber)(properties.pageNumber)), errors.collect(cdk.propertyValidator("pageSize", cdk.requiredValidator)(properties.pageSize)), errors.collect(cdk.propertyValidator("pageSize", cdk.validateNumber)(properties.pageSize)), errors.wrap('supplied properties not correct for "PaginationConfigurationProperty"');
    }
    function cfnTemplatePaginationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PaginationConfigurationPropertyValidator(properties).assertSuccess(), { PageNumber: cdk.numberToCloudFormation(properties.pageNumber), PageSize: cdk.numberToCloudFormation(properties.pageSize) }) : properties;
    }
    function CfnTemplatePaginationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("pageNumber", "PageNumber", cfn_parse.FromCloudFormation.getNumber(properties.PageNumber)), ret.addPropertyResult("pageSize", "PageSize", cfn_parse.FromCloudFormation.getNumber(properties.PageSize)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PanelConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("backgroundColor", cdk.validateString)(properties.backgroundColor)), errors.collect(cdk.propertyValidator("backgroundVisibility", cdk.validateString)(properties.backgroundVisibility)), errors.collect(cdk.propertyValidator("borderColor", cdk.validateString)(properties.borderColor)), errors.collect(cdk.propertyValidator("borderStyle", cdk.validateString)(properties.borderStyle)), errors.collect(cdk.propertyValidator("borderThickness", cdk.validateString)(properties.borderThickness)), errors.collect(cdk.propertyValidator("borderVisibility", cdk.validateString)(properties.borderVisibility)), errors.collect(cdk.propertyValidator("gutterSpacing", cdk.validateString)(properties.gutterSpacing)), errors.collect(cdk.propertyValidator("gutterVisibility", cdk.validateString)(properties.gutterVisibility)), errors.collect(cdk.propertyValidator("title", CfnTemplate_PanelTitleOptionsPropertyValidator)(properties.title)), errors.wrap('supplied properties not correct for "PanelConfigurationProperty"');
    }
    function cfnTemplatePanelConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PanelConfigurationPropertyValidator(properties).assertSuccess(), { BackgroundColor: cdk.stringToCloudFormation(properties.backgroundColor), BackgroundVisibility: cdk.stringToCloudFormation(properties.backgroundVisibility), BorderColor: cdk.stringToCloudFormation(properties.borderColor), BorderStyle: cdk.stringToCloudFormation(properties.borderStyle), BorderThickness: cdk.stringToCloudFormation(properties.borderThickness), BorderVisibility: cdk.stringToCloudFormation(properties.borderVisibility), GutterSpacing: cdk.stringToCloudFormation(properties.gutterSpacing), GutterVisibility: cdk.stringToCloudFormation(properties.gutterVisibility), Title: cfnTemplatePanelTitleOptionsPropertyToCloudFormation(properties.title) }) : properties;
    }
    function CfnTemplatePanelConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("backgroundColor", "BackgroundColor", properties.BackgroundColor != null ? cfn_parse.FromCloudFormation.getString(properties.BackgroundColor) : void 0), ret.addPropertyResult("backgroundVisibility", "BackgroundVisibility", properties.BackgroundVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.BackgroundVisibility) : void 0), ret.addPropertyResult("borderColor", "BorderColor", properties.BorderColor != null ? cfn_parse.FromCloudFormation.getString(properties.BorderColor) : void 0), ret.addPropertyResult("borderStyle", "BorderStyle", properties.BorderStyle != null ? cfn_parse.FromCloudFormation.getString(properties.BorderStyle) : void 0), ret.addPropertyResult("borderThickness", "BorderThickness", properties.BorderThickness != null ? cfn_parse.FromCloudFormation.getString(properties.BorderThickness) : void 0), ret.addPropertyResult("borderVisibility", "BorderVisibility", properties.BorderVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.BorderVisibility) : void 0), ret.addPropertyResult("gutterSpacing", "GutterSpacing", properties.GutterSpacing != null ? cfn_parse.FromCloudFormation.getString(properties.GutterSpacing) : void 0), ret.addPropertyResult("gutterVisibility", "GutterVisibility", properties.GutterVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.GutterVisibility) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnTemplatePanelTitleOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PanelTitleOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fontConfiguration", CfnTemplate_FontConfigurationPropertyValidator)(properties.fontConfiguration)), errors.collect(cdk.propertyValidator("horizontalTextAlignment", cdk.validateString)(properties.horizontalTextAlignment)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "PanelTitleOptionsProperty"');
    }
    function cfnTemplatePanelTitleOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PanelTitleOptionsPropertyValidator(properties).assertSuccess(), { FontConfiguration: cfnTemplateFontConfigurationPropertyToCloudFormation(properties.fontConfiguration), HorizontalTextAlignment: cdk.stringToCloudFormation(properties.horizontalTextAlignment), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnTemplatePanelTitleOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fontConfiguration", "FontConfiguration", properties.FontConfiguration != null ? CfnTemplateFontConfigurationPropertyFromCloudFormation(properties.FontConfiguration) : void 0), ret.addPropertyResult("horizontalTextAlignment", "HorizontalTextAlignment", properties.HorizontalTextAlignment != null ? cfn_parse.FromCloudFormation.getString(properties.HorizontalTextAlignment) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ParameterControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateTimePicker", CfnTemplate_ParameterDateTimePickerControlPropertyValidator)(properties.dateTimePicker)), errors.collect(cdk.propertyValidator("dropdown", CfnTemplate_ParameterDropDownControlPropertyValidator)(properties.dropdown)), errors.collect(cdk.propertyValidator("list", CfnTemplate_ParameterListControlPropertyValidator)(properties.list)), errors.collect(cdk.propertyValidator("slider", CfnTemplate_ParameterSliderControlPropertyValidator)(properties.slider)), errors.collect(cdk.propertyValidator("textArea", CfnTemplate_ParameterTextAreaControlPropertyValidator)(properties.textArea)), errors.collect(cdk.propertyValidator("textField", CfnTemplate_ParameterTextFieldControlPropertyValidator)(properties.textField)), errors.wrap('supplied properties not correct for "ParameterControlProperty"');
    }
    function cfnTemplateParameterControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ParameterControlPropertyValidator(properties).assertSuccess(), { DateTimePicker: cfnTemplateParameterDateTimePickerControlPropertyToCloudFormation(properties.dateTimePicker), Dropdown: cfnTemplateParameterDropDownControlPropertyToCloudFormation(properties.dropdown), List: cfnTemplateParameterListControlPropertyToCloudFormation(properties.list), Slider: cfnTemplateParameterSliderControlPropertyToCloudFormation(properties.slider), TextArea: cfnTemplateParameterTextAreaControlPropertyToCloudFormation(properties.textArea), TextField: cfnTemplateParameterTextFieldControlPropertyToCloudFormation(properties.textField) }) : properties;
    }
    function CfnTemplateParameterControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateTimePicker", "DateTimePicker", properties.DateTimePicker != null ? CfnTemplateParameterDateTimePickerControlPropertyFromCloudFormation(properties.DateTimePicker) : void 0), ret.addPropertyResult("dropdown", "Dropdown", properties.Dropdown != null ? CfnTemplateParameterDropDownControlPropertyFromCloudFormation(properties.Dropdown) : void 0), ret.addPropertyResult("list", "List", properties.List != null ? CfnTemplateParameterListControlPropertyFromCloudFormation(properties.List) : void 0), ret.addPropertyResult("slider", "Slider", properties.Slider != null ? CfnTemplateParameterSliderControlPropertyFromCloudFormation(properties.Slider) : void 0), ret.addPropertyResult("textArea", "TextArea", properties.TextArea != null ? CfnTemplateParameterTextAreaControlPropertyFromCloudFormation(properties.TextArea) : void 0), ret.addPropertyResult("textField", "TextField", properties.TextField != null ? CfnTemplateParameterTextFieldControlPropertyFromCloudFormation(properties.TextField) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ParameterDateTimePickerControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("displayOptions", CfnTemplate_DateTimePickerControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.requiredValidator)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.validateString)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.requiredValidator)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.validateString)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.wrap('supplied properties not correct for "ParameterDateTimePickerControlProperty"');
    }
    function cfnTemplateParameterDateTimePickerControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ParameterDateTimePickerControlPropertyValidator(properties).assertSuccess(), { DisplayOptions: cfnTemplateDateTimePickerControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), ParameterControlId: cdk.stringToCloudFormation(properties.parameterControlId), SourceParameterName: cdk.stringToCloudFormation(properties.sourceParameterName), Title: cdk.stringToCloudFormation(properties.title) }) : properties;
    }
    function CfnTemplateParameterDateTimePickerControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnTemplateDateTimePickerControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("parameterControlId", "ParameterControlId", cfn_parse.FromCloudFormation.getString(properties.ParameterControlId)), ret.addPropertyResult("sourceParameterName", "SourceParameterName", cfn_parse.FromCloudFormation.getString(properties.SourceParameterName)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ParameterDeclarationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateTimeParameterDeclaration", CfnTemplate_DateTimeParameterDeclarationPropertyValidator)(properties.dateTimeParameterDeclaration)), errors.collect(cdk.propertyValidator("decimalParameterDeclaration", CfnTemplate_DecimalParameterDeclarationPropertyValidator)(properties.decimalParameterDeclaration)), errors.collect(cdk.propertyValidator("integerParameterDeclaration", CfnTemplate_IntegerParameterDeclarationPropertyValidator)(properties.integerParameterDeclaration)), errors.collect(cdk.propertyValidator("stringParameterDeclaration", CfnTemplate_StringParameterDeclarationPropertyValidator)(properties.stringParameterDeclaration)), errors.wrap('supplied properties not correct for "ParameterDeclarationProperty"');
    }
    function cfnTemplateParameterDeclarationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ParameterDeclarationPropertyValidator(properties).assertSuccess(), { DateTimeParameterDeclaration: cfnTemplateDateTimeParameterDeclarationPropertyToCloudFormation(properties.dateTimeParameterDeclaration), DecimalParameterDeclaration: cfnTemplateDecimalParameterDeclarationPropertyToCloudFormation(properties.decimalParameterDeclaration), IntegerParameterDeclaration: cfnTemplateIntegerParameterDeclarationPropertyToCloudFormation(properties.integerParameterDeclaration), StringParameterDeclaration: cfnTemplateStringParameterDeclarationPropertyToCloudFormation(properties.stringParameterDeclaration) }) : properties;
    }
    function CfnTemplateParameterDeclarationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateTimeParameterDeclaration", "DateTimeParameterDeclaration", properties.DateTimeParameterDeclaration != null ? CfnTemplateDateTimeParameterDeclarationPropertyFromCloudFormation(properties.DateTimeParameterDeclaration) : void 0), ret.addPropertyResult("decimalParameterDeclaration", "DecimalParameterDeclaration", properties.DecimalParameterDeclaration != null ? CfnTemplateDecimalParameterDeclarationPropertyFromCloudFormation(properties.DecimalParameterDeclaration) : void 0), ret.addPropertyResult("integerParameterDeclaration", "IntegerParameterDeclaration", properties.IntegerParameterDeclaration != null ? CfnTemplateIntegerParameterDeclarationPropertyFromCloudFormation(properties.IntegerParameterDeclaration) : void 0), ret.addPropertyResult("stringParameterDeclaration", "StringParameterDeclaration", properties.StringParameterDeclaration != null ? CfnTemplateStringParameterDeclarationPropertyFromCloudFormation(properties.StringParameterDeclaration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ParameterDropDownControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cascadingControlConfiguration", CfnTemplate_CascadingControlConfigurationPropertyValidator)(properties.cascadingControlConfiguration)), errors.collect(cdk.propertyValidator("displayOptions", CfnTemplate_DropDownControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.requiredValidator)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.validateString)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("selectableValues", CfnTemplate_ParameterSelectableValuesPropertyValidator)(properties.selectableValues)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.requiredValidator)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.validateString)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "ParameterDropDownControlProperty"');
    }
    function cfnTemplateParameterDropDownControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ParameterDropDownControlPropertyValidator(properties).assertSuccess(), { CascadingControlConfiguration: cfnTemplateCascadingControlConfigurationPropertyToCloudFormation(properties.cascadingControlConfiguration), DisplayOptions: cfnTemplateDropDownControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), ParameterControlId: cdk.stringToCloudFormation(properties.parameterControlId), SelectableValues: cfnTemplateParameterSelectableValuesPropertyToCloudFormation(properties.selectableValues), SourceParameterName: cdk.stringToCloudFormation(properties.sourceParameterName), Title: cdk.stringToCloudFormation(properties.title), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnTemplateParameterDropDownControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cascadingControlConfiguration", "CascadingControlConfiguration", properties.CascadingControlConfiguration != null ? CfnTemplateCascadingControlConfigurationPropertyFromCloudFormation(properties.CascadingControlConfiguration) : void 0), ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnTemplateDropDownControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("parameterControlId", "ParameterControlId", cfn_parse.FromCloudFormation.getString(properties.ParameterControlId)), ret.addPropertyResult("selectableValues", "SelectableValues", properties.SelectableValues != null ? CfnTemplateParameterSelectableValuesPropertyFromCloudFormation(properties.SelectableValues) : void 0), ret.addPropertyResult("sourceParameterName", "SourceParameterName", cfn_parse.FromCloudFormation.getString(properties.SourceParameterName)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ParameterListControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cascadingControlConfiguration", CfnTemplate_CascadingControlConfigurationPropertyValidator)(properties.cascadingControlConfiguration)), errors.collect(cdk.propertyValidator("displayOptions", CfnTemplate_ListControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.requiredValidator)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.validateString)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("selectableValues", CfnTemplate_ParameterSelectableValuesPropertyValidator)(properties.selectableValues)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.requiredValidator)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.validateString)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "ParameterListControlProperty"');
    }
    function cfnTemplateParameterListControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ParameterListControlPropertyValidator(properties).assertSuccess(), { CascadingControlConfiguration: cfnTemplateCascadingControlConfigurationPropertyToCloudFormation(properties.cascadingControlConfiguration), DisplayOptions: cfnTemplateListControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), ParameterControlId: cdk.stringToCloudFormation(properties.parameterControlId), SelectableValues: cfnTemplateParameterSelectableValuesPropertyToCloudFormation(properties.selectableValues), SourceParameterName: cdk.stringToCloudFormation(properties.sourceParameterName), Title: cdk.stringToCloudFormation(properties.title), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnTemplateParameterListControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cascadingControlConfiguration", "CascadingControlConfiguration", properties.CascadingControlConfiguration != null ? CfnTemplateCascadingControlConfigurationPropertyFromCloudFormation(properties.CascadingControlConfiguration) : void 0), ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnTemplateListControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("parameterControlId", "ParameterControlId", cfn_parse.FromCloudFormation.getString(properties.ParameterControlId)), ret.addPropertyResult("selectableValues", "SelectableValues", properties.SelectableValues != null ? CfnTemplateParameterSelectableValuesPropertyFromCloudFormation(properties.SelectableValues) : void 0), ret.addPropertyResult("sourceParameterName", "SourceParameterName", cfn_parse.FromCloudFormation.getString(properties.SourceParameterName)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ParameterSelectableValuesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("linkToDataSetColumn", CfnTemplate_ColumnIdentifierPropertyValidator)(properties.linkToDataSetColumn)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "ParameterSelectableValuesProperty"');
    }
    function cfnTemplateParameterSelectableValuesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ParameterSelectableValuesPropertyValidator(properties).assertSuccess(), { LinkToDataSetColumn: cfnTemplateColumnIdentifierPropertyToCloudFormation(properties.linkToDataSetColumn), Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnTemplateParameterSelectableValuesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("linkToDataSetColumn", "LinkToDataSetColumn", properties.LinkToDataSetColumn != null ? CfnTemplateColumnIdentifierPropertyFromCloudFormation(properties.LinkToDataSetColumn) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ParameterSliderControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("displayOptions", CfnTemplate_SliderControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("maximumValue", cdk.requiredValidator)(properties.maximumValue)), errors.collect(cdk.propertyValidator("maximumValue", cdk.validateNumber)(properties.maximumValue)), errors.collect(cdk.propertyValidator("minimumValue", cdk.requiredValidator)(properties.minimumValue)), errors.collect(cdk.propertyValidator("minimumValue", cdk.validateNumber)(properties.minimumValue)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.requiredValidator)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.validateString)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.requiredValidator)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.validateString)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("stepSize", cdk.requiredValidator)(properties.stepSize)), errors.collect(cdk.propertyValidator("stepSize", cdk.validateNumber)(properties.stepSize)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.wrap('supplied properties not correct for "ParameterSliderControlProperty"');
    }
    function cfnTemplateParameterSliderControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ParameterSliderControlPropertyValidator(properties).assertSuccess(), { DisplayOptions: cfnTemplateSliderControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), MaximumValue: cdk.numberToCloudFormation(properties.maximumValue), MinimumValue: cdk.numberToCloudFormation(properties.minimumValue), ParameterControlId: cdk.stringToCloudFormation(properties.parameterControlId), SourceParameterName: cdk.stringToCloudFormation(properties.sourceParameterName), StepSize: cdk.numberToCloudFormation(properties.stepSize), Title: cdk.stringToCloudFormation(properties.title) }) : properties;
    }
    function CfnTemplateParameterSliderControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnTemplateSliderControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("maximumValue", "MaximumValue", cfn_parse.FromCloudFormation.getNumber(properties.MaximumValue)), ret.addPropertyResult("minimumValue", "MinimumValue", cfn_parse.FromCloudFormation.getNumber(properties.MinimumValue)), ret.addPropertyResult("parameterControlId", "ParameterControlId", cfn_parse.FromCloudFormation.getString(properties.ParameterControlId)), ret.addPropertyResult("sourceParameterName", "SourceParameterName", cfn_parse.FromCloudFormation.getString(properties.SourceParameterName)), ret.addPropertyResult("stepSize", "StepSize", cfn_parse.FromCloudFormation.getNumber(properties.StepSize)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ParameterTextAreaControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("delimiter", cdk.validateString)(properties.delimiter)), errors.collect(cdk.propertyValidator("displayOptions", CfnTemplate_TextAreaControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.requiredValidator)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.validateString)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.requiredValidator)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.validateString)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.wrap('supplied properties not correct for "ParameterTextAreaControlProperty"');
    }
    function cfnTemplateParameterTextAreaControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ParameterTextAreaControlPropertyValidator(properties).assertSuccess(), { Delimiter: cdk.stringToCloudFormation(properties.delimiter), DisplayOptions: cfnTemplateTextAreaControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), ParameterControlId: cdk.stringToCloudFormation(properties.parameterControlId), SourceParameterName: cdk.stringToCloudFormation(properties.sourceParameterName), Title: cdk.stringToCloudFormation(properties.title) }) : properties;
    }
    function CfnTemplateParameterTextAreaControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("delimiter", "Delimiter", properties.Delimiter != null ? cfn_parse.FromCloudFormation.getString(properties.Delimiter) : void 0), ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnTemplateTextAreaControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("parameterControlId", "ParameterControlId", cfn_parse.FromCloudFormation.getString(properties.ParameterControlId)), ret.addPropertyResult("sourceParameterName", "SourceParameterName", cfn_parse.FromCloudFormation.getString(properties.SourceParameterName)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ParameterTextFieldControlPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("displayOptions", CfnTemplate_TextFieldControlDisplayOptionsPropertyValidator)(properties.displayOptions)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.requiredValidator)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("parameterControlId", cdk.validateString)(properties.parameterControlId)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.requiredValidator)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("sourceParameterName", cdk.validateString)(properties.sourceParameterName)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.wrap('supplied properties not correct for "ParameterTextFieldControlProperty"');
    }
    function cfnTemplateParameterTextFieldControlPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ParameterTextFieldControlPropertyValidator(properties).assertSuccess(), { DisplayOptions: cfnTemplateTextFieldControlDisplayOptionsPropertyToCloudFormation(properties.displayOptions), ParameterControlId: cdk.stringToCloudFormation(properties.parameterControlId), SourceParameterName: cdk.stringToCloudFormation(properties.sourceParameterName), Title: cdk.stringToCloudFormation(properties.title) }) : properties;
    }
    function CfnTemplateParameterTextFieldControlPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("displayOptions", "DisplayOptions", properties.DisplayOptions != null ? CfnTemplateTextFieldControlDisplayOptionsPropertyFromCloudFormation(properties.DisplayOptions) : void 0), ret.addPropertyResult("parameterControlId", "ParameterControlId", cfn_parse.FromCloudFormation.getString(properties.ParameterControlId)), ret.addPropertyResult("sourceParameterName", "SourceParameterName", cfn_parse.FromCloudFormation.getString(properties.SourceParameterName)), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PercentVisibleRangePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("from", cdk.validateNumber)(properties.from)), errors.collect(cdk.propertyValidator("to", cdk.validateNumber)(properties.to)), errors.wrap('supplied properties not correct for "PercentVisibleRangeProperty"');
    }
    function cfnTemplatePercentVisibleRangePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PercentVisibleRangePropertyValidator(properties).assertSuccess(), { From: cdk.numberToCloudFormation(properties.from), To: cdk.numberToCloudFormation(properties.to) }) : properties;
    }
    function CfnTemplatePercentVisibleRangePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("from", "From", properties.From != null ? cfn_parse.FromCloudFormation.getNumber(properties.From) : void 0), ret.addPropertyResult("to", "To", properties.To != null ? cfn_parse.FromCloudFormation.getNumber(properties.To) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PercentageDisplayFormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("decimalPlacesConfiguration", CfnTemplate_DecimalPlacesConfigurationPropertyValidator)(properties.decimalPlacesConfiguration)), errors.collect(cdk.propertyValidator("negativeValueConfiguration", CfnTemplate_NegativeValueConfigurationPropertyValidator)(properties.negativeValueConfiguration)), errors.collect(cdk.propertyValidator("nullValueFormatConfiguration", CfnTemplate_NullValueFormatConfigurationPropertyValidator)(properties.nullValueFormatConfiguration)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.collect(cdk.propertyValidator("separatorConfiguration", CfnTemplate_NumericSeparatorConfigurationPropertyValidator)(properties.separatorConfiguration)), errors.collect(cdk.propertyValidator("suffix", cdk.validateString)(properties.suffix)), errors.wrap('supplied properties not correct for "PercentageDisplayFormatConfigurationProperty"');
    }
    function cfnTemplatePercentageDisplayFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PercentageDisplayFormatConfigurationPropertyValidator(properties).assertSuccess(), { DecimalPlacesConfiguration: cfnTemplateDecimalPlacesConfigurationPropertyToCloudFormation(properties.decimalPlacesConfiguration), NegativeValueConfiguration: cfnTemplateNegativeValueConfigurationPropertyToCloudFormation(properties.negativeValueConfiguration), NullValueFormatConfiguration: cfnTemplateNullValueFormatConfigurationPropertyToCloudFormation(properties.nullValueFormatConfiguration), Prefix: cdk.stringToCloudFormation(properties.prefix), SeparatorConfiguration: cfnTemplateNumericSeparatorConfigurationPropertyToCloudFormation(properties.separatorConfiguration), Suffix: cdk.stringToCloudFormation(properties.suffix) }) : properties;
    }
    function CfnTemplatePercentageDisplayFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("decimalPlacesConfiguration", "DecimalPlacesConfiguration", properties.DecimalPlacesConfiguration != null ? CfnTemplateDecimalPlacesConfigurationPropertyFromCloudFormation(properties.DecimalPlacesConfiguration) : void 0), ret.addPropertyResult("negativeValueConfiguration", "NegativeValueConfiguration", properties.NegativeValueConfiguration != null ? CfnTemplateNegativeValueConfigurationPropertyFromCloudFormation(properties.NegativeValueConfiguration) : void 0), ret.addPropertyResult("nullValueFormatConfiguration", "NullValueFormatConfiguration", properties.NullValueFormatConfiguration != null ? CfnTemplateNullValueFormatConfigurationPropertyFromCloudFormation(properties.NullValueFormatConfiguration) : void 0), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addPropertyResult("separatorConfiguration", "SeparatorConfiguration", properties.SeparatorConfiguration != null ? CfnTemplateNumericSeparatorConfigurationPropertyFromCloudFormation(properties.SeparatorConfiguration) : void 0), ret.addPropertyResult("suffix", "Suffix", properties.Suffix != null ? cfn_parse.FromCloudFormation.getString(properties.Suffix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PercentileAggregationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("percentileValue", cdk.validateNumber)(properties.percentileValue)), errors.wrap('supplied properties not correct for "PercentileAggregationProperty"');
    }
    function cfnTemplatePercentileAggregationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PercentileAggregationPropertyValidator(properties).assertSuccess(), { PercentileValue: cdk.numberToCloudFormation(properties.percentileValue) }) : properties;
    }
    function CfnTemplatePercentileAggregationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("percentileValue", "PercentileValue", properties.PercentileValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.PercentileValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PeriodOverPeriodComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computationId", cdk.requiredValidator)(properties.computationId)), errors.collect(cdk.propertyValidator("computationId", cdk.validateString)(properties.computationId)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("time", cdk.requiredValidator)(properties.time)), errors.collect(cdk.propertyValidator("time", CfnTemplate_DimensionFieldPropertyValidator)(properties.time)), errors.collect(cdk.propertyValidator("value", CfnTemplate_MeasureFieldPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "PeriodOverPeriodComputationProperty"');
    }
    function cfnTemplatePeriodOverPeriodComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PeriodOverPeriodComputationPropertyValidator(properties).assertSuccess(), { ComputationId: cdk.stringToCloudFormation(properties.computationId), Name: cdk.stringToCloudFormation(properties.name), Time: cfnTemplateDimensionFieldPropertyToCloudFormation(properties.time), Value: cfnTemplateMeasureFieldPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnTemplatePeriodOverPeriodComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computationId", "ComputationId", cfn_parse.FromCloudFormation.getString(properties.ComputationId)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("time", "Time", CfnTemplateDimensionFieldPropertyFromCloudFormation(properties.Time)), ret.addPropertyResult("value", "Value", properties.Value != null ? CfnTemplateMeasureFieldPropertyFromCloudFormation(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PeriodToDateComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computationId", cdk.requiredValidator)(properties.computationId)), errors.collect(cdk.propertyValidator("computationId", cdk.validateString)(properties.computationId)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("periodTimeGranularity", cdk.validateString)(properties.periodTimeGranularity)), errors.collect(cdk.propertyValidator("time", cdk.requiredValidator)(properties.time)), errors.collect(cdk.propertyValidator("time", CfnTemplate_DimensionFieldPropertyValidator)(properties.time)), errors.collect(cdk.propertyValidator("value", CfnTemplate_MeasureFieldPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "PeriodToDateComputationProperty"');
    }
    function cfnTemplatePeriodToDateComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PeriodToDateComputationPropertyValidator(properties).assertSuccess(), { ComputationId: cdk.stringToCloudFormation(properties.computationId), Name: cdk.stringToCloudFormation(properties.name), PeriodTimeGranularity: cdk.stringToCloudFormation(properties.periodTimeGranularity), Time: cfnTemplateDimensionFieldPropertyToCloudFormation(properties.time), Value: cfnTemplateMeasureFieldPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnTemplatePeriodToDateComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computationId", "ComputationId", cfn_parse.FromCloudFormation.getString(properties.ComputationId)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("periodTimeGranularity", "PeriodTimeGranularity", properties.PeriodTimeGranularity != null ? cfn_parse.FromCloudFormation.getString(properties.PeriodTimeGranularity) : void 0), ret.addPropertyResult("time", "Time", CfnTemplateDimensionFieldPropertyFromCloudFormation(properties.Time)), ret.addPropertyResult("value", "Value", properties.Value != null ? CfnTemplateMeasureFieldPropertyFromCloudFormation(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PieChartAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("category", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.category)), errors.collect(cdk.propertyValidator("smallMultiples", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.smallMultiples)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnTemplate_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "PieChartAggregatedFieldWellsProperty"');
    }
    function cfnTemplatePieChartAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PieChartAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Category: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.category), SmallMultiples: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.smallMultiples), Values: cdk.listMapper(cfnTemplateMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnTemplatePieChartAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("category", "Category", properties.Category != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.Category) : void 0), ret.addPropertyResult("smallMultiples", "SmallMultiples", properties.SmallMultiples != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.SmallMultiples) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PieChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryLabelOptions", CfnTemplate_ChartAxisLabelOptionsPropertyValidator)(properties.categoryLabelOptions)), errors.collect(cdk.propertyValidator("contributionAnalysisDefaults", cdk.listValidator(CfnTemplate_ContributionAnalysisDefaultPropertyValidator))(properties.contributionAnalysisDefaults)), errors.collect(cdk.propertyValidator("dataLabels", CfnTemplate_DataLabelOptionsPropertyValidator)(properties.dataLabels)), errors.collect(cdk.propertyValidator("donutOptions", CfnTemplate_DonutOptionsPropertyValidator)(properties.donutOptions)), errors.collect(cdk.propertyValidator("fieldWells", CfnTemplate_PieChartFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("legend", CfnTemplate_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("smallMultiplesOptions", CfnTemplate_SmallMultiplesOptionsPropertyValidator)(properties.smallMultiplesOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnTemplate_PieChartSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tooltip", CfnTemplate_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.collect(cdk.propertyValidator("valueLabelOptions", CfnTemplate_ChartAxisLabelOptionsPropertyValidator)(properties.valueLabelOptions)), errors.collect(cdk.propertyValidator("visualPalette", CfnTemplate_VisualPalettePropertyValidator)(properties.visualPalette)), errors.wrap('supplied properties not correct for "PieChartConfigurationProperty"');
    }
    function cfnTemplatePieChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PieChartConfigurationPropertyValidator(properties).assertSuccess(), { CategoryLabelOptions: cfnTemplateChartAxisLabelOptionsPropertyToCloudFormation(properties.categoryLabelOptions), ContributionAnalysisDefaults: cdk.listMapper(cfnTemplateContributionAnalysisDefaultPropertyToCloudFormation)(properties.contributionAnalysisDefaults), DataLabels: cfnTemplateDataLabelOptionsPropertyToCloudFormation(properties.dataLabels), DonutOptions: cfnTemplateDonutOptionsPropertyToCloudFormation(properties.donutOptions), FieldWells: cfnTemplatePieChartFieldWellsPropertyToCloudFormation(properties.fieldWells), Legend: cfnTemplateLegendOptionsPropertyToCloudFormation(properties.legend), SmallMultiplesOptions: cfnTemplateSmallMultiplesOptionsPropertyToCloudFormation(properties.smallMultiplesOptions), SortConfiguration: cfnTemplatePieChartSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), Tooltip: cfnTemplateTooltipOptionsPropertyToCloudFormation(properties.tooltip), ValueLabelOptions: cfnTemplateChartAxisLabelOptionsPropertyToCloudFormation(properties.valueLabelOptions), VisualPalette: cfnTemplateVisualPalettePropertyToCloudFormation(properties.visualPalette) }) : properties;
    }
    function CfnTemplatePieChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryLabelOptions", "CategoryLabelOptions", properties.CategoryLabelOptions != null ? CfnTemplateChartAxisLabelOptionsPropertyFromCloudFormation(properties.CategoryLabelOptions) : void 0), ret.addPropertyResult("contributionAnalysisDefaults", "ContributionAnalysisDefaults", properties.ContributionAnalysisDefaults != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateContributionAnalysisDefaultPropertyFromCloudFormation)(properties.ContributionAnalysisDefaults) : void 0), ret.addPropertyResult("dataLabels", "DataLabels", properties.DataLabels != null ? CfnTemplateDataLabelOptionsPropertyFromCloudFormation(properties.DataLabels) : void 0), ret.addPropertyResult("donutOptions", "DonutOptions", properties.DonutOptions != null ? CfnTemplateDonutOptionsPropertyFromCloudFormation(properties.DonutOptions) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnTemplatePieChartFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnTemplateLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("smallMultiplesOptions", "SmallMultiplesOptions", properties.SmallMultiplesOptions != null ? CfnTemplateSmallMultiplesOptionsPropertyFromCloudFormation(properties.SmallMultiplesOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnTemplatePieChartSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnTemplateTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addPropertyResult("valueLabelOptions", "ValueLabelOptions", properties.ValueLabelOptions != null ? CfnTemplateChartAxisLabelOptionsPropertyFromCloudFormation(properties.ValueLabelOptions) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnTemplateVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PieChartFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("pieChartAggregatedFieldWells", CfnTemplate_PieChartAggregatedFieldWellsPropertyValidator)(properties.pieChartAggregatedFieldWells)), errors.wrap('supplied properties not correct for "PieChartFieldWellsProperty"');
    }
    function cfnTemplatePieChartFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PieChartFieldWellsPropertyValidator(properties).assertSuccess(), { PieChartAggregatedFieldWells: cfnTemplatePieChartAggregatedFieldWellsPropertyToCloudFormation(properties.pieChartAggregatedFieldWells) }) : properties;
    }
    function CfnTemplatePieChartFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("pieChartAggregatedFieldWells", "PieChartAggregatedFieldWells", properties.PieChartAggregatedFieldWells != null ? CfnTemplatePieChartAggregatedFieldWellsPropertyFromCloudFormation(properties.PieChartAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PieChartSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryItemsLimit", CfnTemplate_ItemsLimitConfigurationPropertyValidator)(properties.categoryItemsLimit)), errors.collect(cdk.propertyValidator("categorySort", cdk.listValidator(CfnTemplate_FieldSortOptionsPropertyValidator))(properties.categorySort)), errors.collect(cdk.propertyValidator("smallMultiplesLimitConfiguration", CfnTemplate_ItemsLimitConfigurationPropertyValidator)(properties.smallMultiplesLimitConfiguration)), errors.collect(cdk.propertyValidator("smallMultiplesSort", cdk.listValidator(CfnTemplate_FieldSortOptionsPropertyValidator))(properties.smallMultiplesSort)), errors.wrap('supplied properties not correct for "PieChartSortConfigurationProperty"');
    }
    function cfnTemplatePieChartSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PieChartSortConfigurationPropertyValidator(properties).assertSuccess(), { CategoryItemsLimit: cfnTemplateItemsLimitConfigurationPropertyToCloudFormation(properties.categoryItemsLimit), CategorySort: cdk.listMapper(cfnTemplateFieldSortOptionsPropertyToCloudFormation)(properties.categorySort), SmallMultiplesLimitConfiguration: cfnTemplateItemsLimitConfigurationPropertyToCloudFormation(properties.smallMultiplesLimitConfiguration), SmallMultiplesSort: cdk.listMapper(cfnTemplateFieldSortOptionsPropertyToCloudFormation)(properties.smallMultiplesSort) }) : properties;
    }
    function CfnTemplatePieChartSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryItemsLimit", "CategoryItemsLimit", properties.CategoryItemsLimit != null ? CfnTemplateItemsLimitConfigurationPropertyFromCloudFormation(properties.CategoryItemsLimit) : void 0), ret.addPropertyResult("categorySort", "CategorySort", properties.CategorySort != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateFieldSortOptionsPropertyFromCloudFormation)(properties.CategorySort) : void 0), ret.addPropertyResult("smallMultiplesLimitConfiguration", "SmallMultiplesLimitConfiguration", properties.SmallMultiplesLimitConfiguration != null ? CfnTemplateItemsLimitConfigurationPropertyFromCloudFormation(properties.SmallMultiplesLimitConfiguration) : void 0), ret.addPropertyResult("smallMultiplesSort", "SmallMultiplesSort", properties.SmallMultiplesSort != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateFieldSortOptionsPropertyFromCloudFormation)(properties.SmallMultiplesSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PieChartVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnTemplate_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnTemplate_PieChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnTemplate_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnTemplate_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnTemplate_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "PieChartVisualProperty"');
    }
    function cfnTemplatePieChartVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PieChartVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnTemplateVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnTemplatePieChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnTemplateColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnTemplateVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnTemplateVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnTemplatePieChartVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnTemplatePieChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnTemplateVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnTemplateVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PivotFieldSortOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("sortBy", cdk.requiredValidator)(properties.sortBy)), errors.collect(cdk.propertyValidator("sortBy", CfnTemplate_PivotTableSortByPropertyValidator)(properties.sortBy)), errors.wrap('supplied properties not correct for "PivotFieldSortOptionsProperty"');
    }
    function cfnTemplatePivotFieldSortOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PivotFieldSortOptionsPropertyValidator(properties).assertSuccess(), { FieldId: cdk.stringToCloudFormation(properties.fieldId), SortBy: cfnTemplatePivotTableSortByPropertyToCloudFormation(properties.sortBy) }) : properties;
    }
    function CfnTemplatePivotFieldSortOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("sortBy", "SortBy", CfnTemplatePivotTableSortByPropertyFromCloudFormation(properties.SortBy)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PivotTableAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columns", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.columns)), errors.collect(cdk.propertyValidator("rows", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.rows)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnTemplate_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "PivotTableAggregatedFieldWellsProperty"');
    }
    function cfnTemplatePivotTableAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PivotTableAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Columns: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.columns), Rows: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.rows), Values: cdk.listMapper(cfnTemplateMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnTemplatePivotTableAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columns", "Columns", properties.Columns != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.Columns) : void 0), ret.addPropertyResult("rows", "Rows", properties.Rows != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.Rows) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PivotTableCellConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("scope", CfnTemplate_PivotTableConditionalFormattingScopePropertyValidator)(properties.scope)), errors.collect(cdk.propertyValidator("textFormat", CfnTemplate_TextConditionalFormatPropertyValidator)(properties.textFormat)), errors.wrap('supplied properties not correct for "PivotTableCellConditionalFormattingProperty"');
    }
    function cfnTemplatePivotTableCellConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PivotTableCellConditionalFormattingPropertyValidator(properties).assertSuccess(), { FieldId: cdk.stringToCloudFormation(properties.fieldId), Scope: cfnTemplatePivotTableConditionalFormattingScopePropertyToCloudFormation(properties.scope), TextFormat: cfnTemplateTextConditionalFormatPropertyToCloudFormation(properties.textFormat) }) : properties;
    }
    function CfnTemplatePivotTableCellConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("scope", "Scope", properties.Scope != null ? CfnTemplatePivotTableConditionalFormattingScopePropertyFromCloudFormation(properties.Scope) : void 0), ret.addPropertyResult("textFormat", "TextFormat", properties.TextFormat != null ? CfnTemplateTextConditionalFormatPropertyFromCloudFormation(properties.TextFormat) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PivotTableConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("conditionalFormattingOptions", cdk.listValidator(CfnTemplate_PivotTableConditionalFormattingOptionPropertyValidator))(properties.conditionalFormattingOptions)), errors.wrap('supplied properties not correct for "PivotTableConditionalFormattingProperty"');
    }
    function cfnTemplatePivotTableConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PivotTableConditionalFormattingPropertyValidator(properties).assertSuccess(), { ConditionalFormattingOptions: cdk.listMapper(cfnTemplatePivotTableConditionalFormattingOptionPropertyToCloudFormation)(properties.conditionalFormattingOptions) }) : properties;
    }
    function CfnTemplatePivotTableConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("conditionalFormattingOptions", "ConditionalFormattingOptions", properties.ConditionalFormattingOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplatePivotTableConditionalFormattingOptionPropertyFromCloudFormation)(properties.ConditionalFormattingOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PivotTableConditionalFormattingOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cell", CfnTemplate_PivotTableCellConditionalFormattingPropertyValidator)(properties.cell)), errors.wrap('supplied properties not correct for "PivotTableConditionalFormattingOptionProperty"');
    }
    function cfnTemplatePivotTableConditionalFormattingOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PivotTableConditionalFormattingOptionPropertyValidator(properties).assertSuccess(), { Cell: cfnTemplatePivotTableCellConditionalFormattingPropertyToCloudFormation(properties.cell) }) : properties;
    }
    function CfnTemplatePivotTableConditionalFormattingOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cell", "Cell", properties.Cell != null ? CfnTemplatePivotTableCellConditionalFormattingPropertyFromCloudFormation(properties.Cell) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PivotTableConditionalFormattingScopePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("role", cdk.validateString)(properties.role)), errors.wrap('supplied properties not correct for "PivotTableConditionalFormattingScopeProperty"');
    }
    function cfnTemplatePivotTableConditionalFormattingScopePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PivotTableConditionalFormattingScopePropertyValidator(properties).assertSuccess(), { Role: cdk.stringToCloudFormation(properties.role) }) : properties;
    }
    function CfnTemplatePivotTableConditionalFormattingScopePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("role", "Role", properties.Role != null ? cfn_parse.FromCloudFormation.getString(properties.Role) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PivotTableConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldOptions", CfnTemplate_PivotTableFieldOptionsPropertyValidator)(properties.fieldOptions)), errors.collect(cdk.propertyValidator("fieldWells", CfnTemplate_PivotTableFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("paginatedReportOptions", CfnTemplate_PivotTablePaginatedReportOptionsPropertyValidator)(properties.paginatedReportOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnTemplate_PivotTableSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tableOptions", CfnTemplate_PivotTableOptionsPropertyValidator)(properties.tableOptions)), errors.collect(cdk.propertyValidator("totalOptions", CfnTemplate_PivotTableTotalOptionsPropertyValidator)(properties.totalOptions)), errors.wrap('supplied properties not correct for "PivotTableConfigurationProperty"');
    }
    function cfnTemplatePivotTableConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PivotTableConfigurationPropertyValidator(properties).assertSuccess(), { FieldOptions: cfnTemplatePivotTableFieldOptionsPropertyToCloudFormation(properties.fieldOptions), FieldWells: cfnTemplatePivotTableFieldWellsPropertyToCloudFormation(properties.fieldWells), PaginatedReportOptions: cfnTemplatePivotTablePaginatedReportOptionsPropertyToCloudFormation(properties.paginatedReportOptions), SortConfiguration: cfnTemplatePivotTableSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), TableOptions: cfnTemplatePivotTableOptionsPropertyToCloudFormation(properties.tableOptions), TotalOptions: cfnTemplatePivotTableTotalOptionsPropertyToCloudFormation(properties.totalOptions) }) : properties;
    }
    function CfnTemplatePivotTableConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldOptions", "FieldOptions", properties.FieldOptions != null ? CfnTemplatePivotTableFieldOptionsPropertyFromCloudFormation(properties.FieldOptions) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnTemplatePivotTableFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("paginatedReportOptions", "PaginatedReportOptions", properties.PaginatedReportOptions != null ? CfnTemplatePivotTablePaginatedReportOptionsPropertyFromCloudFormation(properties.PaginatedReportOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnTemplatePivotTableSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tableOptions", "TableOptions", properties.TableOptions != null ? CfnTemplatePivotTableOptionsPropertyFromCloudFormation(properties.TableOptions) : void 0), ret.addPropertyResult("totalOptions", "TotalOptions", properties.TotalOptions != null ? CfnTemplatePivotTableTotalOptionsPropertyFromCloudFormation(properties.TotalOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PivotTableDataPathOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataPathList", cdk.requiredValidator)(properties.dataPathList)), errors.collect(cdk.propertyValidator("dataPathList", cdk.listValidator(CfnTemplate_DataPathValuePropertyValidator))(properties.dataPathList)), errors.collect(cdk.propertyValidator("width", cdk.validateString)(properties.width)), errors.wrap('supplied properties not correct for "PivotTableDataPathOptionProperty"');
    }
    function cfnTemplatePivotTableDataPathOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PivotTableDataPathOptionPropertyValidator(properties).assertSuccess(), { DataPathList: cdk.listMapper(cfnTemplateDataPathValuePropertyToCloudFormation)(properties.dataPathList), Width: cdk.stringToCloudFormation(properties.width) }) : properties;
    }
    function CfnTemplatePivotTableDataPathOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataPathList", "DataPathList", cfn_parse.FromCloudFormation.getArray(CfnTemplateDataPathValuePropertyFromCloudFormation)(properties.DataPathList)), ret.addPropertyResult("width", "Width", properties.Width != null ? cfn_parse.FromCloudFormation.getString(properties.Width) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PivotTableFieldOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customLabel", cdk.validateString)(properties.customLabel)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "PivotTableFieldOptionProperty"');
    }
    function cfnTemplatePivotTableFieldOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PivotTableFieldOptionPropertyValidator(properties).assertSuccess(), { CustomLabel: cdk.stringToCloudFormation(properties.customLabel), FieldId: cdk.stringToCloudFormation(properties.fieldId), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnTemplatePivotTableFieldOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customLabel", "CustomLabel", properties.CustomLabel != null ? cfn_parse.FromCloudFormation.getString(properties.CustomLabel) : void 0), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PivotTableFieldOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataPathOptions", cdk.listValidator(CfnTemplate_PivotTableDataPathOptionPropertyValidator))(properties.dataPathOptions)), errors.collect(cdk.propertyValidator("selectedFieldOptions", cdk.listValidator(CfnTemplate_PivotTableFieldOptionPropertyValidator))(properties.selectedFieldOptions)), errors.wrap('supplied properties not correct for "PivotTableFieldOptionsProperty"');
    }
    function cfnTemplatePivotTableFieldOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PivotTableFieldOptionsPropertyValidator(properties).assertSuccess(), { DataPathOptions: cdk.listMapper(cfnTemplatePivotTableDataPathOptionPropertyToCloudFormation)(properties.dataPathOptions), SelectedFieldOptions: cdk.listMapper(cfnTemplatePivotTableFieldOptionPropertyToCloudFormation)(properties.selectedFieldOptions) }) : properties;
    }
    function CfnTemplatePivotTableFieldOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataPathOptions", "DataPathOptions", properties.DataPathOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplatePivotTableDataPathOptionPropertyFromCloudFormation)(properties.DataPathOptions) : void 0), ret.addPropertyResult("selectedFieldOptions", "SelectedFieldOptions", properties.SelectedFieldOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplatePivotTableFieldOptionPropertyFromCloudFormation)(properties.SelectedFieldOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PivotTableFieldSubtotalOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.wrap('supplied properties not correct for "PivotTableFieldSubtotalOptionsProperty"');
    }
    function cfnTemplatePivotTableFieldSubtotalOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PivotTableFieldSubtotalOptionsPropertyValidator(properties).assertSuccess(), { FieldId: cdk.stringToCloudFormation(properties.fieldId) }) : properties;
    }
    function CfnTemplatePivotTableFieldSubtotalOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldId", "FieldId", properties.FieldId != null ? cfn_parse.FromCloudFormation.getString(properties.FieldId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PivotTableFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("pivotTableAggregatedFieldWells", CfnTemplate_PivotTableAggregatedFieldWellsPropertyValidator)(properties.pivotTableAggregatedFieldWells)), errors.wrap('supplied properties not correct for "PivotTableFieldWellsProperty"');
    }
    function cfnTemplatePivotTableFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PivotTableFieldWellsPropertyValidator(properties).assertSuccess(), { PivotTableAggregatedFieldWells: cfnTemplatePivotTableAggregatedFieldWellsPropertyToCloudFormation(properties.pivotTableAggregatedFieldWells) }) : properties;
    }
    function CfnTemplatePivotTableFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("pivotTableAggregatedFieldWells", "PivotTableAggregatedFieldWells", properties.PivotTableAggregatedFieldWells != null ? CfnTemplatePivotTableAggregatedFieldWellsPropertyFromCloudFormation(properties.PivotTableAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PivotTableOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cellStyle", CfnTemplate_TableCellStylePropertyValidator)(properties.cellStyle)), errors.collect(cdk.propertyValidator("columnHeaderStyle", CfnTemplate_TableCellStylePropertyValidator)(properties.columnHeaderStyle)), errors.collect(cdk.propertyValidator("columnNamesVisibility", cdk.validateString)(properties.columnNamesVisibility)), errors.collect(cdk.propertyValidator("metricPlacement", cdk.validateString)(properties.metricPlacement)), errors.collect(cdk.propertyValidator("rowAlternateColorOptions", CfnTemplate_RowAlternateColorOptionsPropertyValidator)(properties.rowAlternateColorOptions)), errors.collect(cdk.propertyValidator("rowFieldNamesStyle", CfnTemplate_TableCellStylePropertyValidator)(properties.rowFieldNamesStyle)), errors.collect(cdk.propertyValidator("rowHeaderStyle", CfnTemplate_TableCellStylePropertyValidator)(properties.rowHeaderStyle)), errors.collect(cdk.propertyValidator("singleMetricVisibility", cdk.validateString)(properties.singleMetricVisibility)), errors.collect(cdk.propertyValidator("toggleButtonsVisibility", cdk.validateString)(properties.toggleButtonsVisibility)), errors.wrap('supplied properties not correct for "PivotTableOptionsProperty"');
    }
    function cfnTemplatePivotTableOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PivotTableOptionsPropertyValidator(properties).assertSuccess(), { CellStyle: cfnTemplateTableCellStylePropertyToCloudFormation(properties.cellStyle), ColumnHeaderStyle: cfnTemplateTableCellStylePropertyToCloudFormation(properties.columnHeaderStyle), ColumnNamesVisibility: cdk.stringToCloudFormation(properties.columnNamesVisibility), MetricPlacement: cdk.stringToCloudFormation(properties.metricPlacement), RowAlternateColorOptions: cfnTemplateRowAlternateColorOptionsPropertyToCloudFormation(properties.rowAlternateColorOptions), RowFieldNamesStyle: cfnTemplateTableCellStylePropertyToCloudFormation(properties.rowFieldNamesStyle), RowHeaderStyle: cfnTemplateTableCellStylePropertyToCloudFormation(properties.rowHeaderStyle), SingleMetricVisibility: cdk.stringToCloudFormation(properties.singleMetricVisibility), ToggleButtonsVisibility: cdk.stringToCloudFormation(properties.toggleButtonsVisibility) }) : properties;
    }
    function CfnTemplatePivotTableOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cellStyle", "CellStyle", properties.CellStyle != null ? CfnTemplateTableCellStylePropertyFromCloudFormation(properties.CellStyle) : void 0), ret.addPropertyResult("columnHeaderStyle", "ColumnHeaderStyle", properties.ColumnHeaderStyle != null ? CfnTemplateTableCellStylePropertyFromCloudFormation(properties.ColumnHeaderStyle) : void 0), ret.addPropertyResult("columnNamesVisibility", "ColumnNamesVisibility", properties.ColumnNamesVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.ColumnNamesVisibility) : void 0), ret.addPropertyResult("metricPlacement", "MetricPlacement", properties.MetricPlacement != null ? cfn_parse.FromCloudFormation.getString(properties.MetricPlacement) : void 0), ret.addPropertyResult("rowAlternateColorOptions", "RowAlternateColorOptions", properties.RowAlternateColorOptions != null ? CfnTemplateRowAlternateColorOptionsPropertyFromCloudFormation(properties.RowAlternateColorOptions) : void 0), ret.addPropertyResult("rowFieldNamesStyle", "RowFieldNamesStyle", properties.RowFieldNamesStyle != null ? CfnTemplateTableCellStylePropertyFromCloudFormation(properties.RowFieldNamesStyle) : void 0), ret.addPropertyResult("rowHeaderStyle", "RowHeaderStyle", properties.RowHeaderStyle != null ? CfnTemplateTableCellStylePropertyFromCloudFormation(properties.RowHeaderStyle) : void 0), ret.addPropertyResult("singleMetricVisibility", "SingleMetricVisibility", properties.SingleMetricVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.SingleMetricVisibility) : void 0), ret.addPropertyResult("toggleButtonsVisibility", "ToggleButtonsVisibility", properties.ToggleButtonsVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.ToggleButtonsVisibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PivotTablePaginatedReportOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("overflowColumnHeaderVisibility", cdk.validateString)(properties.overflowColumnHeaderVisibility)), errors.collect(cdk.propertyValidator("verticalOverflowVisibility", cdk.validateString)(properties.verticalOverflowVisibility)), errors.wrap('supplied properties not correct for "PivotTablePaginatedReportOptionsProperty"');
    }
    function cfnTemplatePivotTablePaginatedReportOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PivotTablePaginatedReportOptionsPropertyValidator(properties).assertSuccess(), { OverflowColumnHeaderVisibility: cdk.stringToCloudFormation(properties.overflowColumnHeaderVisibility), VerticalOverflowVisibility: cdk.stringToCloudFormation(properties.verticalOverflowVisibility) }) : properties;
    }
    function CfnTemplatePivotTablePaginatedReportOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("overflowColumnHeaderVisibility", "OverflowColumnHeaderVisibility", properties.OverflowColumnHeaderVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.OverflowColumnHeaderVisibility) : void 0), ret.addPropertyResult("verticalOverflowVisibility", "VerticalOverflowVisibility", properties.VerticalOverflowVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.VerticalOverflowVisibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PivotTableSortByPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", CfnTemplate_ColumnSortPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("dataPath", CfnTemplate_DataPathSortPropertyValidator)(properties.dataPath)), errors.collect(cdk.propertyValidator("field", CfnTemplate_FieldSortPropertyValidator)(properties.field)), errors.wrap('supplied properties not correct for "PivotTableSortByProperty"');
    }
    function cfnTemplatePivotTableSortByPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PivotTableSortByPropertyValidator(properties).assertSuccess(), { Column: cfnTemplateColumnSortPropertyToCloudFormation(properties.column), DataPath: cfnTemplateDataPathSortPropertyToCloudFormation(properties.dataPath), Field: cfnTemplateFieldSortPropertyToCloudFormation(properties.field) }) : properties;
    }
    function CfnTemplatePivotTableSortByPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", properties.Column != null ? CfnTemplateColumnSortPropertyFromCloudFormation(properties.Column) : void 0), ret.addPropertyResult("dataPath", "DataPath", properties.DataPath != null ? CfnTemplateDataPathSortPropertyFromCloudFormation(properties.DataPath) : void 0), ret.addPropertyResult("field", "Field", properties.Field != null ? CfnTemplateFieldSortPropertyFromCloudFormation(properties.Field) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PivotTableSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldSortOptions", cdk.listValidator(CfnTemplate_PivotFieldSortOptionsPropertyValidator))(properties.fieldSortOptions)), errors.wrap('supplied properties not correct for "PivotTableSortConfigurationProperty"');
    }
    function cfnTemplatePivotTableSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PivotTableSortConfigurationPropertyValidator(properties).assertSuccess(), { FieldSortOptions: cdk.listMapper(cfnTemplatePivotFieldSortOptionsPropertyToCloudFormation)(properties.fieldSortOptions) }) : properties;
    }
    function CfnTemplatePivotTableSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldSortOptions", "FieldSortOptions", properties.FieldSortOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplatePivotFieldSortOptionsPropertyFromCloudFormation)(properties.FieldSortOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PivotTableTotalOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnSubtotalOptions", CfnTemplate_SubtotalOptionsPropertyValidator)(properties.columnSubtotalOptions)), errors.collect(cdk.propertyValidator("columnTotalOptions", CfnTemplate_PivotTotalOptionsPropertyValidator)(properties.columnTotalOptions)), errors.collect(cdk.propertyValidator("rowSubtotalOptions", CfnTemplate_SubtotalOptionsPropertyValidator)(properties.rowSubtotalOptions)), errors.collect(cdk.propertyValidator("rowTotalOptions", CfnTemplate_PivotTotalOptionsPropertyValidator)(properties.rowTotalOptions)), errors.wrap('supplied properties not correct for "PivotTableTotalOptionsProperty"');
    }
    function cfnTemplatePivotTableTotalOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PivotTableTotalOptionsPropertyValidator(properties).assertSuccess(), { ColumnSubtotalOptions: cfnTemplateSubtotalOptionsPropertyToCloudFormation(properties.columnSubtotalOptions), ColumnTotalOptions: cfnTemplatePivotTotalOptionsPropertyToCloudFormation(properties.columnTotalOptions), RowSubtotalOptions: cfnTemplateSubtotalOptionsPropertyToCloudFormation(properties.rowSubtotalOptions), RowTotalOptions: cfnTemplatePivotTotalOptionsPropertyToCloudFormation(properties.rowTotalOptions) }) : properties;
    }
    function CfnTemplatePivotTableTotalOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columnSubtotalOptions", "ColumnSubtotalOptions", properties.ColumnSubtotalOptions != null ? CfnTemplateSubtotalOptionsPropertyFromCloudFormation(properties.ColumnSubtotalOptions) : void 0), ret.addPropertyResult("columnTotalOptions", "ColumnTotalOptions", properties.ColumnTotalOptions != null ? CfnTemplatePivotTotalOptionsPropertyFromCloudFormation(properties.ColumnTotalOptions) : void 0), ret.addPropertyResult("rowSubtotalOptions", "RowSubtotalOptions", properties.RowSubtotalOptions != null ? CfnTemplateSubtotalOptionsPropertyFromCloudFormation(properties.RowSubtotalOptions) : void 0), ret.addPropertyResult("rowTotalOptions", "RowTotalOptions", properties.RowTotalOptions != null ? CfnTemplatePivotTotalOptionsPropertyFromCloudFormation(properties.RowTotalOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PivotTableVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnTemplate_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnTemplate_PivotTableConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("conditionalFormatting", CfnTemplate_PivotTableConditionalFormattingPropertyValidator)(properties.conditionalFormatting)), errors.collect(cdk.propertyValidator("subtitle", CfnTemplate_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnTemplate_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "PivotTableVisualProperty"');
    }
    function cfnTemplatePivotTableVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PivotTableVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnTemplateVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnTemplatePivotTableConfigurationPropertyToCloudFormation(properties.chartConfiguration), ConditionalFormatting: cfnTemplatePivotTableConditionalFormattingPropertyToCloudFormation(properties.conditionalFormatting), Subtitle: cfnTemplateVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnTemplateVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnTemplatePivotTableVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnTemplatePivotTableConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("conditionalFormatting", "ConditionalFormatting", properties.ConditionalFormatting != null ? CfnTemplatePivotTableConditionalFormattingPropertyFromCloudFormation(properties.ConditionalFormatting) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnTemplateVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnTemplateVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PivotTotalOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customLabel", cdk.validateString)(properties.customLabel)), errors.collect(cdk.propertyValidator("metricHeaderCellStyle", CfnTemplate_TableCellStylePropertyValidator)(properties.metricHeaderCellStyle)), errors.collect(cdk.propertyValidator("placement", cdk.validateString)(properties.placement)), errors.collect(cdk.propertyValidator("scrollStatus", cdk.validateString)(properties.scrollStatus)), errors.collect(cdk.propertyValidator("totalCellStyle", CfnTemplate_TableCellStylePropertyValidator)(properties.totalCellStyle)), errors.collect(cdk.propertyValidator("totalsVisibility", cdk.validateString)(properties.totalsVisibility)), errors.collect(cdk.propertyValidator("valueCellStyle", CfnTemplate_TableCellStylePropertyValidator)(properties.valueCellStyle)), errors.wrap('supplied properties not correct for "PivotTotalOptionsProperty"');
    }
    function cfnTemplatePivotTotalOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PivotTotalOptionsPropertyValidator(properties).assertSuccess(), { CustomLabel: cdk.stringToCloudFormation(properties.customLabel), MetricHeaderCellStyle: cfnTemplateTableCellStylePropertyToCloudFormation(properties.metricHeaderCellStyle), Placement: cdk.stringToCloudFormation(properties.placement), ScrollStatus: cdk.stringToCloudFormation(properties.scrollStatus), TotalCellStyle: cfnTemplateTableCellStylePropertyToCloudFormation(properties.totalCellStyle), TotalsVisibility: cdk.stringToCloudFormation(properties.totalsVisibility), ValueCellStyle: cfnTemplateTableCellStylePropertyToCloudFormation(properties.valueCellStyle) }) : properties;
    }
    function CfnTemplatePivotTotalOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customLabel", "CustomLabel", properties.CustomLabel != null ? cfn_parse.FromCloudFormation.getString(properties.CustomLabel) : void 0), ret.addPropertyResult("metricHeaderCellStyle", "MetricHeaderCellStyle", properties.MetricHeaderCellStyle != null ? CfnTemplateTableCellStylePropertyFromCloudFormation(properties.MetricHeaderCellStyle) : void 0), ret.addPropertyResult("placement", "Placement", properties.Placement != null ? cfn_parse.FromCloudFormation.getString(properties.Placement) : void 0), ret.addPropertyResult("scrollStatus", "ScrollStatus", properties.ScrollStatus != null ? cfn_parse.FromCloudFormation.getString(properties.ScrollStatus) : void 0), ret.addPropertyResult("totalCellStyle", "TotalCellStyle", properties.TotalCellStyle != null ? CfnTemplateTableCellStylePropertyFromCloudFormation(properties.TotalCellStyle) : void 0), ret.addPropertyResult("totalsVisibility", "TotalsVisibility", properties.TotalsVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.TotalsVisibility) : void 0), ret.addPropertyResult("valueCellStyle", "ValueCellStyle", properties.ValueCellStyle != null ? CfnTemplateTableCellStylePropertyFromCloudFormation(properties.ValueCellStyle) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_PredefinedHierarchyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columns", cdk.requiredValidator)(properties.columns)), errors.collect(cdk.propertyValidator("columns", cdk.listValidator(CfnTemplate_ColumnIdentifierPropertyValidator))(properties.columns)), errors.collect(cdk.propertyValidator("drillDownFilters", cdk.listValidator(CfnTemplate_DrillDownFilterPropertyValidator))(properties.drillDownFilters)), errors.collect(cdk.propertyValidator("hierarchyId", cdk.requiredValidator)(properties.hierarchyId)), errors.collect(cdk.propertyValidator("hierarchyId", cdk.validateString)(properties.hierarchyId)), errors.wrap('supplied properties not correct for "PredefinedHierarchyProperty"');
    }
    function cfnTemplatePredefinedHierarchyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_PredefinedHierarchyPropertyValidator(properties).assertSuccess(), { Columns: cdk.listMapper(cfnTemplateColumnIdentifierPropertyToCloudFormation)(properties.columns), DrillDownFilters: cdk.listMapper(cfnTemplateDrillDownFilterPropertyToCloudFormation)(properties.drillDownFilters), HierarchyId: cdk.stringToCloudFormation(properties.hierarchyId) }) : properties;
    }
    function CfnTemplatePredefinedHierarchyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columns", "Columns", cfn_parse.FromCloudFormation.getArray(CfnTemplateColumnIdentifierPropertyFromCloudFormation)(properties.Columns)), ret.addPropertyResult("drillDownFilters", "DrillDownFilters", properties.DrillDownFilters != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDrillDownFilterPropertyFromCloudFormation)(properties.DrillDownFilters) : void 0), ret.addPropertyResult("hierarchyId", "HierarchyId", cfn_parse.FromCloudFormation.getString(properties.HierarchyId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ProgressBarOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "ProgressBarOptionsProperty"');
    }
    function cfnTemplateProgressBarOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ProgressBarOptionsPropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnTemplateProgressBarOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_RadarChartAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("category", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.category)), errors.collect(cdk.propertyValidator("color", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.color)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnTemplate_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "RadarChartAggregatedFieldWellsProperty"');
    }
    function cfnTemplateRadarChartAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_RadarChartAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Category: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.category), Color: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.color), Values: cdk.listMapper(cfnTemplateMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnTemplateRadarChartAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("category", "Category", properties.Category != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.Category) : void 0), ret.addPropertyResult("color", "Color", properties.Color != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.Color) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_RadarChartAreaStyleSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "RadarChartAreaStyleSettingsProperty"');
    }
    function cfnTemplateRadarChartAreaStyleSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_RadarChartAreaStyleSettingsPropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnTemplateRadarChartAreaStyleSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_RadarChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alternateBandColorsVisibility", cdk.validateString)(properties.alternateBandColorsVisibility)), errors.collect(cdk.propertyValidator("alternateBandEvenColor", cdk.validateString)(properties.alternateBandEvenColor)), errors.collect(cdk.propertyValidator("alternateBandOddColor", cdk.validateString)(properties.alternateBandOddColor)), errors.collect(cdk.propertyValidator("baseSeriesSettings", CfnTemplate_RadarChartSeriesSettingsPropertyValidator)(properties.baseSeriesSettings)), errors.collect(cdk.propertyValidator("categoryAxis", CfnTemplate_AxisDisplayOptionsPropertyValidator)(properties.categoryAxis)), errors.collect(cdk.propertyValidator("categoryLabelOptions", CfnTemplate_ChartAxisLabelOptionsPropertyValidator)(properties.categoryLabelOptions)), errors.collect(cdk.propertyValidator("colorAxis", CfnTemplate_AxisDisplayOptionsPropertyValidator)(properties.colorAxis)), errors.collect(cdk.propertyValidator("colorLabelOptions", CfnTemplate_ChartAxisLabelOptionsPropertyValidator)(properties.colorLabelOptions)), errors.collect(cdk.propertyValidator("fieldWells", CfnTemplate_RadarChartFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("legend", CfnTemplate_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("shape", cdk.validateString)(properties.shape)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnTemplate_RadarChartSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("startAngle", cdk.validateNumber)(properties.startAngle)), errors.collect(cdk.propertyValidator("visualPalette", CfnTemplate_VisualPalettePropertyValidator)(properties.visualPalette)), errors.wrap('supplied properties not correct for "RadarChartConfigurationProperty"');
    }
    function cfnTemplateRadarChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_RadarChartConfigurationPropertyValidator(properties).assertSuccess(), { AlternateBandColorsVisibility: cdk.stringToCloudFormation(properties.alternateBandColorsVisibility), AlternateBandEvenColor: cdk.stringToCloudFormation(properties.alternateBandEvenColor), AlternateBandOddColor: cdk.stringToCloudFormation(properties.alternateBandOddColor), BaseSeriesSettings: cfnTemplateRadarChartSeriesSettingsPropertyToCloudFormation(properties.baseSeriesSettings), CategoryAxis: cfnTemplateAxisDisplayOptionsPropertyToCloudFormation(properties.categoryAxis), CategoryLabelOptions: cfnTemplateChartAxisLabelOptionsPropertyToCloudFormation(properties.categoryLabelOptions), ColorAxis: cfnTemplateAxisDisplayOptionsPropertyToCloudFormation(properties.colorAxis), ColorLabelOptions: cfnTemplateChartAxisLabelOptionsPropertyToCloudFormation(properties.colorLabelOptions), FieldWells: cfnTemplateRadarChartFieldWellsPropertyToCloudFormation(properties.fieldWells), Legend: cfnTemplateLegendOptionsPropertyToCloudFormation(properties.legend), Shape: cdk.stringToCloudFormation(properties.shape), SortConfiguration: cfnTemplateRadarChartSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), StartAngle: cdk.numberToCloudFormation(properties.startAngle), VisualPalette: cfnTemplateVisualPalettePropertyToCloudFormation(properties.visualPalette) }) : properties;
    }
    function CfnTemplateRadarChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alternateBandColorsVisibility", "AlternateBandColorsVisibility", properties.AlternateBandColorsVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.AlternateBandColorsVisibility) : void 0), ret.addPropertyResult("alternateBandEvenColor", "AlternateBandEvenColor", properties.AlternateBandEvenColor != null ? cfn_parse.FromCloudFormation.getString(properties.AlternateBandEvenColor) : void 0), ret.addPropertyResult("alternateBandOddColor", "AlternateBandOddColor", properties.AlternateBandOddColor != null ? cfn_parse.FromCloudFormation.getString(properties.AlternateBandOddColor) : void 0), ret.addPropertyResult("baseSeriesSettings", "BaseSeriesSettings", properties.BaseSeriesSettings != null ? CfnTemplateRadarChartSeriesSettingsPropertyFromCloudFormation(properties.BaseSeriesSettings) : void 0), ret.addPropertyResult("categoryAxis", "CategoryAxis", properties.CategoryAxis != null ? CfnTemplateAxisDisplayOptionsPropertyFromCloudFormation(properties.CategoryAxis) : void 0), ret.addPropertyResult("categoryLabelOptions", "CategoryLabelOptions", properties.CategoryLabelOptions != null ? CfnTemplateChartAxisLabelOptionsPropertyFromCloudFormation(properties.CategoryLabelOptions) : void 0), ret.addPropertyResult("colorAxis", "ColorAxis", properties.ColorAxis != null ? CfnTemplateAxisDisplayOptionsPropertyFromCloudFormation(properties.ColorAxis) : void 0), ret.addPropertyResult("colorLabelOptions", "ColorLabelOptions", properties.ColorLabelOptions != null ? CfnTemplateChartAxisLabelOptionsPropertyFromCloudFormation(properties.ColorLabelOptions) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnTemplateRadarChartFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnTemplateLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("shape", "Shape", properties.Shape != null ? cfn_parse.FromCloudFormation.getString(properties.Shape) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnTemplateRadarChartSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("startAngle", "StartAngle", properties.StartAngle != null ? cfn_parse.FromCloudFormation.getNumber(properties.StartAngle) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnTemplateVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_RadarChartFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("radarChartAggregatedFieldWells", CfnTemplate_RadarChartAggregatedFieldWellsPropertyValidator)(properties.radarChartAggregatedFieldWells)), errors.wrap('supplied properties not correct for "RadarChartFieldWellsProperty"');
    }
    function cfnTemplateRadarChartFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_RadarChartFieldWellsPropertyValidator(properties).assertSuccess(), { RadarChartAggregatedFieldWells: cfnTemplateRadarChartAggregatedFieldWellsPropertyToCloudFormation(properties.radarChartAggregatedFieldWells) }) : properties;
    }
    function CfnTemplateRadarChartFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("radarChartAggregatedFieldWells", "RadarChartAggregatedFieldWells", properties.RadarChartAggregatedFieldWells != null ? CfnTemplateRadarChartAggregatedFieldWellsPropertyFromCloudFormation(properties.RadarChartAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_RadarChartSeriesSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("areaStyleSettings", CfnTemplate_RadarChartAreaStyleSettingsPropertyValidator)(properties.areaStyleSettings)), errors.wrap('supplied properties not correct for "RadarChartSeriesSettingsProperty"');
    }
    function cfnTemplateRadarChartSeriesSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_RadarChartSeriesSettingsPropertyValidator(properties).assertSuccess(), { AreaStyleSettings: cfnTemplateRadarChartAreaStyleSettingsPropertyToCloudFormation(properties.areaStyleSettings) }) : properties;
    }
    function CfnTemplateRadarChartSeriesSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("areaStyleSettings", "AreaStyleSettings", properties.AreaStyleSettings != null ? CfnTemplateRadarChartAreaStyleSettingsPropertyFromCloudFormation(properties.AreaStyleSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_RadarChartSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryItemsLimit", CfnTemplate_ItemsLimitConfigurationPropertyValidator)(properties.categoryItemsLimit)), errors.collect(cdk.propertyValidator("categorySort", cdk.listValidator(CfnTemplate_FieldSortOptionsPropertyValidator))(properties.categorySort)), errors.collect(cdk.propertyValidator("colorItemsLimit", CfnTemplate_ItemsLimitConfigurationPropertyValidator)(properties.colorItemsLimit)), errors.collect(cdk.propertyValidator("colorSort", cdk.listValidator(CfnTemplate_FieldSortOptionsPropertyValidator))(properties.colorSort)), errors.wrap('supplied properties not correct for "RadarChartSortConfigurationProperty"');
    }
    function cfnTemplateRadarChartSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_RadarChartSortConfigurationPropertyValidator(properties).assertSuccess(), { CategoryItemsLimit: cfnTemplateItemsLimitConfigurationPropertyToCloudFormation(properties.categoryItemsLimit), CategorySort: cdk.listMapper(cfnTemplateFieldSortOptionsPropertyToCloudFormation)(properties.categorySort), ColorItemsLimit: cfnTemplateItemsLimitConfigurationPropertyToCloudFormation(properties.colorItemsLimit), ColorSort: cdk.listMapper(cfnTemplateFieldSortOptionsPropertyToCloudFormation)(properties.colorSort) }) : properties;
    }
    function CfnTemplateRadarChartSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryItemsLimit", "CategoryItemsLimit", properties.CategoryItemsLimit != null ? CfnTemplateItemsLimitConfigurationPropertyFromCloudFormation(properties.CategoryItemsLimit) : void 0), ret.addPropertyResult("categorySort", "CategorySort", properties.CategorySort != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateFieldSortOptionsPropertyFromCloudFormation)(properties.CategorySort) : void 0), ret.addPropertyResult("colorItemsLimit", "ColorItemsLimit", properties.ColorItemsLimit != null ? CfnTemplateItemsLimitConfigurationPropertyFromCloudFormation(properties.ColorItemsLimit) : void 0), ret.addPropertyResult("colorSort", "ColorSort", properties.ColorSort != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateFieldSortOptionsPropertyFromCloudFormation)(properties.ColorSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_RadarChartVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnTemplate_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnTemplate_RadarChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnTemplate_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnTemplate_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnTemplate_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "RadarChartVisualProperty"');
    }
    function cfnTemplateRadarChartVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_RadarChartVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnTemplateVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnTemplateRadarChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnTemplateColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnTemplateVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnTemplateVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnTemplateRadarChartVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnTemplateRadarChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnTemplateVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnTemplateVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_RangeEndsLabelTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "RangeEndsLabelTypeProperty"');
    }
    function cfnTemplateRangeEndsLabelTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_RangeEndsLabelTypePropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnTemplateRangeEndsLabelTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ReferenceLinePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataConfiguration", cdk.requiredValidator)(properties.dataConfiguration)), errors.collect(cdk.propertyValidator("dataConfiguration", CfnTemplate_ReferenceLineDataConfigurationPropertyValidator)(properties.dataConfiguration)), errors.collect(cdk.propertyValidator("labelConfiguration", CfnTemplate_ReferenceLineLabelConfigurationPropertyValidator)(properties.labelConfiguration)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.collect(cdk.propertyValidator("styleConfiguration", CfnTemplate_ReferenceLineStyleConfigurationPropertyValidator)(properties.styleConfiguration)), errors.wrap('supplied properties not correct for "ReferenceLineProperty"');
    }
    function cfnTemplateReferenceLinePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ReferenceLinePropertyValidator(properties).assertSuccess(), { DataConfiguration: cfnTemplateReferenceLineDataConfigurationPropertyToCloudFormation(properties.dataConfiguration), LabelConfiguration: cfnTemplateReferenceLineLabelConfigurationPropertyToCloudFormation(properties.labelConfiguration), Status: cdk.stringToCloudFormation(properties.status), StyleConfiguration: cfnTemplateReferenceLineStyleConfigurationPropertyToCloudFormation(properties.styleConfiguration) }) : properties;
    }
    function CfnTemplateReferenceLinePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataConfiguration", "DataConfiguration", CfnTemplateReferenceLineDataConfigurationPropertyFromCloudFormation(properties.DataConfiguration)), ret.addPropertyResult("labelConfiguration", "LabelConfiguration", properties.LabelConfiguration != null ? CfnTemplateReferenceLineLabelConfigurationPropertyFromCloudFormation(properties.LabelConfiguration) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addPropertyResult("styleConfiguration", "StyleConfiguration", properties.StyleConfiguration != null ? CfnTemplateReferenceLineStyleConfigurationPropertyFromCloudFormation(properties.StyleConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ReferenceLineCustomLabelConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customLabel", cdk.requiredValidator)(properties.customLabel)), errors.collect(cdk.propertyValidator("customLabel", cdk.validateString)(properties.customLabel)), errors.wrap('supplied properties not correct for "ReferenceLineCustomLabelConfigurationProperty"');
    }
    function cfnTemplateReferenceLineCustomLabelConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ReferenceLineCustomLabelConfigurationPropertyValidator(properties).assertSuccess(), { CustomLabel: cdk.stringToCloudFormation(properties.customLabel) }) : properties;
    }
    function CfnTemplateReferenceLineCustomLabelConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customLabel", "CustomLabel", cfn_parse.FromCloudFormation.getString(properties.CustomLabel)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ReferenceLineDataConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("axisBinding", cdk.validateString)(properties.axisBinding)), errors.collect(cdk.propertyValidator("dynamicConfiguration", CfnTemplate_ReferenceLineDynamicDataConfigurationPropertyValidator)(properties.dynamicConfiguration)), errors.collect(cdk.propertyValidator("staticConfiguration", CfnTemplate_ReferenceLineStaticDataConfigurationPropertyValidator)(properties.staticConfiguration)), errors.wrap('supplied properties not correct for "ReferenceLineDataConfigurationProperty"');
    }
    function cfnTemplateReferenceLineDataConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ReferenceLineDataConfigurationPropertyValidator(properties).assertSuccess(), { AxisBinding: cdk.stringToCloudFormation(properties.axisBinding), DynamicConfiguration: cfnTemplateReferenceLineDynamicDataConfigurationPropertyToCloudFormation(properties.dynamicConfiguration), StaticConfiguration: cfnTemplateReferenceLineStaticDataConfigurationPropertyToCloudFormation(properties.staticConfiguration) }) : properties;
    }
    function CfnTemplateReferenceLineDataConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("axisBinding", "AxisBinding", properties.AxisBinding != null ? cfn_parse.FromCloudFormation.getString(properties.AxisBinding) : void 0), ret.addPropertyResult("dynamicConfiguration", "DynamicConfiguration", properties.DynamicConfiguration != null ? CfnTemplateReferenceLineDynamicDataConfigurationPropertyFromCloudFormation(properties.DynamicConfiguration) : void 0), ret.addPropertyResult("staticConfiguration", "StaticConfiguration", properties.StaticConfiguration != null ? CfnTemplateReferenceLineStaticDataConfigurationPropertyFromCloudFormation(properties.StaticConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ReferenceLineDynamicDataConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("calculation", cdk.requiredValidator)(properties.calculation)), errors.collect(cdk.propertyValidator("calculation", CfnTemplate_NumericalAggregationFunctionPropertyValidator)(properties.calculation)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnTemplate_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("measureAggregationFunction", cdk.requiredValidator)(properties.measureAggregationFunction)), errors.collect(cdk.propertyValidator("measureAggregationFunction", CfnTemplate_AggregationFunctionPropertyValidator)(properties.measureAggregationFunction)), errors.wrap('supplied properties not correct for "ReferenceLineDynamicDataConfigurationProperty"');
    }
    function cfnTemplateReferenceLineDynamicDataConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ReferenceLineDynamicDataConfigurationPropertyValidator(properties).assertSuccess(), { Calculation: cfnTemplateNumericalAggregationFunctionPropertyToCloudFormation(properties.calculation), Column: cfnTemplateColumnIdentifierPropertyToCloudFormation(properties.column), MeasureAggregationFunction: cfnTemplateAggregationFunctionPropertyToCloudFormation(properties.measureAggregationFunction) }) : properties;
    }
    function CfnTemplateReferenceLineDynamicDataConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("calculation", "Calculation", CfnTemplateNumericalAggregationFunctionPropertyFromCloudFormation(properties.Calculation)), ret.addPropertyResult("column", "Column", CfnTemplateColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("measureAggregationFunction", "MeasureAggregationFunction", CfnTemplateAggregationFunctionPropertyFromCloudFormation(properties.MeasureAggregationFunction)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ReferenceLineLabelConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customLabelConfiguration", CfnTemplate_ReferenceLineCustomLabelConfigurationPropertyValidator)(properties.customLabelConfiguration)), errors.collect(cdk.propertyValidator("fontColor", cdk.validateString)(properties.fontColor)), errors.collect(cdk.propertyValidator("fontConfiguration", CfnTemplate_FontConfigurationPropertyValidator)(properties.fontConfiguration)), errors.collect(cdk.propertyValidator("horizontalPosition", cdk.validateString)(properties.horizontalPosition)), errors.collect(cdk.propertyValidator("valueLabelConfiguration", CfnTemplate_ReferenceLineValueLabelConfigurationPropertyValidator)(properties.valueLabelConfiguration)), errors.collect(cdk.propertyValidator("verticalPosition", cdk.validateString)(properties.verticalPosition)), errors.wrap('supplied properties not correct for "ReferenceLineLabelConfigurationProperty"');
    }
    function cfnTemplateReferenceLineLabelConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ReferenceLineLabelConfigurationPropertyValidator(properties).assertSuccess(), { CustomLabelConfiguration: cfnTemplateReferenceLineCustomLabelConfigurationPropertyToCloudFormation(properties.customLabelConfiguration), FontColor: cdk.stringToCloudFormation(properties.fontColor), FontConfiguration: cfnTemplateFontConfigurationPropertyToCloudFormation(properties.fontConfiguration), HorizontalPosition: cdk.stringToCloudFormation(properties.horizontalPosition), ValueLabelConfiguration: cfnTemplateReferenceLineValueLabelConfigurationPropertyToCloudFormation(properties.valueLabelConfiguration), VerticalPosition: cdk.stringToCloudFormation(properties.verticalPosition) }) : properties;
    }
    function CfnTemplateReferenceLineLabelConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customLabelConfiguration", "CustomLabelConfiguration", properties.CustomLabelConfiguration != null ? CfnTemplateReferenceLineCustomLabelConfigurationPropertyFromCloudFormation(properties.CustomLabelConfiguration) : void 0), ret.addPropertyResult("fontColor", "FontColor", properties.FontColor != null ? cfn_parse.FromCloudFormation.getString(properties.FontColor) : void 0), ret.addPropertyResult("fontConfiguration", "FontConfiguration", properties.FontConfiguration != null ? CfnTemplateFontConfigurationPropertyFromCloudFormation(properties.FontConfiguration) : void 0), ret.addPropertyResult("horizontalPosition", "HorizontalPosition", properties.HorizontalPosition != null ? cfn_parse.FromCloudFormation.getString(properties.HorizontalPosition) : void 0), ret.addPropertyResult("valueLabelConfiguration", "ValueLabelConfiguration", properties.ValueLabelConfiguration != null ? CfnTemplateReferenceLineValueLabelConfigurationPropertyFromCloudFormation(properties.ValueLabelConfiguration) : void 0), ret.addPropertyResult("verticalPosition", "VerticalPosition", properties.VerticalPosition != null ? cfn_parse.FromCloudFormation.getString(properties.VerticalPosition) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ReferenceLineStaticDataConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "ReferenceLineStaticDataConfigurationProperty"');
    }
    function cfnTemplateReferenceLineStaticDataConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ReferenceLineStaticDataConfigurationPropertyValidator(properties).assertSuccess(), { Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnTemplateReferenceLineStaticDataConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getNumber(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ReferenceLineStyleConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.collect(cdk.propertyValidator("pattern", cdk.validateString)(properties.pattern)), errors.wrap('supplied properties not correct for "ReferenceLineStyleConfigurationProperty"');
    }
    function cfnTemplateReferenceLineStyleConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ReferenceLineStyleConfigurationPropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color), Pattern: cdk.stringToCloudFormation(properties.pattern) }) : properties;
    }
    function CfnTemplateReferenceLineStyleConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", properties.Color != null ? cfn_parse.FromCloudFormation.getString(properties.Color) : void 0), ret.addPropertyResult("pattern", "Pattern", properties.Pattern != null ? cfn_parse.FromCloudFormation.getString(properties.Pattern) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ReferenceLineValueLabelConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("formatConfiguration", CfnTemplate_NumericFormatConfigurationPropertyValidator)(properties.formatConfiguration)), errors.collect(cdk.propertyValidator("relativePosition", cdk.validateString)(properties.relativePosition)), errors.wrap('supplied properties not correct for "ReferenceLineValueLabelConfigurationProperty"');
    }
    function cfnTemplateReferenceLineValueLabelConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ReferenceLineValueLabelConfigurationPropertyValidator(properties).assertSuccess(), { FormatConfiguration: cfnTemplateNumericFormatConfigurationPropertyToCloudFormation(properties.formatConfiguration), RelativePosition: cdk.stringToCloudFormation(properties.relativePosition) }) : properties;
    }
    function CfnTemplateReferenceLineValueLabelConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("formatConfiguration", "FormatConfiguration", properties.FormatConfiguration != null ? CfnTemplateNumericFormatConfigurationPropertyFromCloudFormation(properties.FormatConfiguration) : void 0), ret.addPropertyResult("relativePosition", "RelativePosition", properties.RelativePosition != null ? cfn_parse.FromCloudFormation.getString(properties.RelativePosition) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_RelativeDateTimeControlDisplayOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dateTimeFormat", cdk.validateString)(properties.dateTimeFormat)), errors.collect(cdk.propertyValidator("titleOptions", CfnTemplate_LabelOptionsPropertyValidator)(properties.titleOptions)), errors.wrap('supplied properties not correct for "RelativeDateTimeControlDisplayOptionsProperty"');
    }
    function cfnTemplateRelativeDateTimeControlDisplayOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_RelativeDateTimeControlDisplayOptionsPropertyValidator(properties).assertSuccess(), { DateTimeFormat: cdk.stringToCloudFormation(properties.dateTimeFormat), TitleOptions: cfnTemplateLabelOptionsPropertyToCloudFormation(properties.titleOptions) }) : properties;
    }
    function CfnTemplateRelativeDateTimeControlDisplayOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dateTimeFormat", "DateTimeFormat", properties.DateTimeFormat != null ? cfn_parse.FromCloudFormation.getString(properties.DateTimeFormat) : void 0), ret.addPropertyResult("titleOptions", "TitleOptions", properties.TitleOptions != null ? CfnTemplateLabelOptionsPropertyFromCloudFormation(properties.TitleOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_RelativeDatesFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("anchorDateConfiguration", cdk.requiredValidator)(properties.anchorDateConfiguration)), errors.collect(cdk.propertyValidator("anchorDateConfiguration", CfnTemplate_AnchorDateConfigurationPropertyValidator)(properties.anchorDateConfiguration)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnTemplate_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("excludePeriodConfiguration", CfnTemplate_ExcludePeriodConfigurationPropertyValidator)(properties.excludePeriodConfiguration)), errors.collect(cdk.propertyValidator("filterId", cdk.requiredValidator)(properties.filterId)), errors.collect(cdk.propertyValidator("filterId", cdk.validateString)(properties.filterId)), errors.collect(cdk.propertyValidator("minimumGranularity", cdk.validateString)(properties.minimumGranularity)), errors.collect(cdk.propertyValidator("nullOption", cdk.requiredValidator)(properties.nullOption)), errors.collect(cdk.propertyValidator("nullOption", cdk.validateString)(properties.nullOption)), errors.collect(cdk.propertyValidator("parameterName", cdk.validateString)(properties.parameterName)), errors.collect(cdk.propertyValidator("relativeDateType", cdk.requiredValidator)(properties.relativeDateType)), errors.collect(cdk.propertyValidator("relativeDateType", cdk.validateString)(properties.relativeDateType)), errors.collect(cdk.propertyValidator("relativeDateValue", cdk.validateNumber)(properties.relativeDateValue)), errors.collect(cdk.propertyValidator("timeGranularity", cdk.requiredValidator)(properties.timeGranularity)), errors.collect(cdk.propertyValidator("timeGranularity", cdk.validateString)(properties.timeGranularity)), errors.wrap('supplied properties not correct for "RelativeDatesFilterProperty"');
    }
    function cfnTemplateRelativeDatesFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_RelativeDatesFilterPropertyValidator(properties).assertSuccess(), { AnchorDateConfiguration: cfnTemplateAnchorDateConfigurationPropertyToCloudFormation(properties.anchorDateConfiguration), Column: cfnTemplateColumnIdentifierPropertyToCloudFormation(properties.column), ExcludePeriodConfiguration: cfnTemplateExcludePeriodConfigurationPropertyToCloudFormation(properties.excludePeriodConfiguration), FilterId: cdk.stringToCloudFormation(properties.filterId), MinimumGranularity: cdk.stringToCloudFormation(properties.minimumGranularity), NullOption: cdk.stringToCloudFormation(properties.nullOption), ParameterName: cdk.stringToCloudFormation(properties.parameterName), RelativeDateType: cdk.stringToCloudFormation(properties.relativeDateType), RelativeDateValue: cdk.numberToCloudFormation(properties.relativeDateValue), TimeGranularity: cdk.stringToCloudFormation(properties.timeGranularity) }) : properties;
    }
    function CfnTemplateRelativeDatesFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("anchorDateConfiguration", "AnchorDateConfiguration", CfnTemplateAnchorDateConfigurationPropertyFromCloudFormation(properties.AnchorDateConfiguration)), ret.addPropertyResult("column", "Column", CfnTemplateColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("excludePeriodConfiguration", "ExcludePeriodConfiguration", properties.ExcludePeriodConfiguration != null ? CfnTemplateExcludePeriodConfigurationPropertyFromCloudFormation(properties.ExcludePeriodConfiguration) : void 0), ret.addPropertyResult("filterId", "FilterId", cfn_parse.FromCloudFormation.getString(properties.FilterId)), ret.addPropertyResult("minimumGranularity", "MinimumGranularity", properties.MinimumGranularity != null ? cfn_parse.FromCloudFormation.getString(properties.MinimumGranularity) : void 0), ret.addPropertyResult("nullOption", "NullOption", cfn_parse.FromCloudFormation.getString(properties.NullOption)), ret.addPropertyResult("parameterName", "ParameterName", properties.ParameterName != null ? cfn_parse.FromCloudFormation.getString(properties.ParameterName) : void 0), ret.addPropertyResult("relativeDateType", "RelativeDateType", cfn_parse.FromCloudFormation.getString(properties.RelativeDateType)), ret.addPropertyResult("relativeDateValue", "RelativeDateValue", properties.RelativeDateValue != null ? cfn_parse.FromCloudFormation.getNumber(properties.RelativeDateValue) : void 0), ret.addPropertyResult("timeGranularity", "TimeGranularity", cfn_parse.FromCloudFormation.getString(properties.TimeGranularity)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ResourcePermissionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.requiredValidator)(properties.actions)), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(cdk.validateString))(properties.actions)), errors.collect(cdk.propertyValidator("principal", cdk.requiredValidator)(properties.principal)), errors.collect(cdk.propertyValidator("principal", cdk.validateString)(properties.principal)), errors.collect(cdk.propertyValidator("resource", cdk.validateString)(properties.resource)), errors.wrap('supplied properties not correct for "ResourcePermissionProperty"');
    }
    function cfnTemplateResourcePermissionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ResourcePermissionPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cdk.stringToCloudFormation)(properties.actions), Principal: cdk.stringToCloudFormation(properties.principal), Resource: cdk.stringToCloudFormation(properties.resource) }) : properties;
    }
    function CfnTemplateResourcePermissionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", cfn_parse.FromCloudFormation.getStringArray(properties.Actions)), ret.addPropertyResult("principal", "Principal", cfn_parse.FromCloudFormation.getString(properties.Principal)), ret.addPropertyResult("resource", "Resource", properties.Resource != null ? cfn_parse.FromCloudFormation.getString(properties.Resource) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_RollingDateConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataSetIdentifier", cdk.validateString)(properties.dataSetIdentifier)), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.wrap('supplied properties not correct for "RollingDateConfigurationProperty"');
    }
    function cfnTemplateRollingDateConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_RollingDateConfigurationPropertyValidator(properties).assertSuccess(), { DataSetIdentifier: cdk.stringToCloudFormation(properties.dataSetIdentifier), Expression: cdk.stringToCloudFormation(properties.expression) }) : properties;
    }
    function CfnTemplateRollingDateConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataSetIdentifier", "DataSetIdentifier", properties.DataSetIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.DataSetIdentifier) : void 0), ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getString(properties.Expression)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_RowAlternateColorOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("rowAlternateColors", cdk.listValidator(cdk.validateString))(properties.rowAlternateColors)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "RowAlternateColorOptionsProperty"');
    }
    function cfnTemplateRowAlternateColorOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_RowAlternateColorOptionsPropertyValidator(properties).assertSuccess(), { RowAlternateColors: cdk.listMapper(cdk.stringToCloudFormation)(properties.rowAlternateColors), Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnTemplateRowAlternateColorOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("rowAlternateColors", "RowAlternateColors", properties.RowAlternateColors != null ? cfn_parse.FromCloudFormation.getStringArray(properties.RowAlternateColors) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_SameSheetTargetVisualConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("targetVisualOptions", cdk.validateString)(properties.targetVisualOptions)), errors.collect(cdk.propertyValidator("targetVisuals", cdk.listValidator(cdk.validateString))(properties.targetVisuals)), errors.wrap('supplied properties not correct for "SameSheetTargetVisualConfigurationProperty"');
    }
    function cfnTemplateSameSheetTargetVisualConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_SameSheetTargetVisualConfigurationPropertyValidator(properties).assertSuccess(), { TargetVisualOptions: cdk.stringToCloudFormation(properties.targetVisualOptions), TargetVisuals: cdk.listMapper(cdk.stringToCloudFormation)(properties.targetVisuals) }) : properties;
    }
    function CfnTemplateSameSheetTargetVisualConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("targetVisualOptions", "TargetVisualOptions", properties.TargetVisualOptions != null ? cfn_parse.FromCloudFormation.getString(properties.TargetVisualOptions) : void 0), ret.addPropertyResult("targetVisuals", "TargetVisuals", properties.TargetVisuals != null ? cfn_parse.FromCloudFormation.getStringArray(properties.TargetVisuals) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_SankeyDiagramAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destination", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.destination)), errors.collect(cdk.propertyValidator("source", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.source)), errors.collect(cdk.propertyValidator("weight", cdk.listValidator(CfnTemplate_MeasureFieldPropertyValidator))(properties.weight)), errors.wrap('supplied properties not correct for "SankeyDiagramAggregatedFieldWellsProperty"');
    }
    function cfnTemplateSankeyDiagramAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_SankeyDiagramAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Destination: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.destination), Source: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.source), Weight: cdk.listMapper(cfnTemplateMeasureFieldPropertyToCloudFormation)(properties.weight) }) : properties;
    }
    function CfnTemplateSankeyDiagramAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destination", "Destination", properties.Destination != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.Destination) : void 0), ret.addPropertyResult("source", "Source", properties.Source != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.Source) : void 0), ret.addPropertyResult("weight", "Weight", properties.Weight != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMeasureFieldPropertyFromCloudFormation)(properties.Weight) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_SankeyDiagramChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataLabels", CfnTemplate_DataLabelOptionsPropertyValidator)(properties.dataLabels)), errors.collect(cdk.propertyValidator("fieldWells", CfnTemplate_SankeyDiagramFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnTemplate_SankeyDiagramSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.wrap('supplied properties not correct for "SankeyDiagramChartConfigurationProperty"');
    }
    function cfnTemplateSankeyDiagramChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_SankeyDiagramChartConfigurationPropertyValidator(properties).assertSuccess(), { DataLabels: cfnTemplateDataLabelOptionsPropertyToCloudFormation(properties.dataLabels), FieldWells: cfnTemplateSankeyDiagramFieldWellsPropertyToCloudFormation(properties.fieldWells), SortConfiguration: cfnTemplateSankeyDiagramSortConfigurationPropertyToCloudFormation(properties.sortConfiguration) }) : properties;
    }
    function CfnTemplateSankeyDiagramChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataLabels", "DataLabels", properties.DataLabels != null ? CfnTemplateDataLabelOptionsPropertyFromCloudFormation(properties.DataLabels) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnTemplateSankeyDiagramFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnTemplateSankeyDiagramSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_SankeyDiagramFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sankeyDiagramAggregatedFieldWells", CfnTemplate_SankeyDiagramAggregatedFieldWellsPropertyValidator)(properties.sankeyDiagramAggregatedFieldWells)), errors.wrap('supplied properties not correct for "SankeyDiagramFieldWellsProperty"');
    }
    function cfnTemplateSankeyDiagramFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_SankeyDiagramFieldWellsPropertyValidator(properties).assertSuccess(), { SankeyDiagramAggregatedFieldWells: cfnTemplateSankeyDiagramAggregatedFieldWellsPropertyToCloudFormation(properties.sankeyDiagramAggregatedFieldWells) }) : properties;
    }
    function CfnTemplateSankeyDiagramFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sankeyDiagramAggregatedFieldWells", "SankeyDiagramAggregatedFieldWells", properties.SankeyDiagramAggregatedFieldWells != null ? CfnTemplateSankeyDiagramAggregatedFieldWellsPropertyFromCloudFormation(properties.SankeyDiagramAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_SankeyDiagramSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationItemsLimit", CfnTemplate_ItemsLimitConfigurationPropertyValidator)(properties.destinationItemsLimit)), errors.collect(cdk.propertyValidator("sourceItemsLimit", CfnTemplate_ItemsLimitConfigurationPropertyValidator)(properties.sourceItemsLimit)), errors.collect(cdk.propertyValidator("weightSort", cdk.listValidator(CfnTemplate_FieldSortOptionsPropertyValidator))(properties.weightSort)), errors.wrap('supplied properties not correct for "SankeyDiagramSortConfigurationProperty"');
    }
    function cfnTemplateSankeyDiagramSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_SankeyDiagramSortConfigurationPropertyValidator(properties).assertSuccess(), { DestinationItemsLimit: cfnTemplateItemsLimitConfigurationPropertyToCloudFormation(properties.destinationItemsLimit), SourceItemsLimit: cfnTemplateItemsLimitConfigurationPropertyToCloudFormation(properties.sourceItemsLimit), WeightSort: cdk.listMapper(cfnTemplateFieldSortOptionsPropertyToCloudFormation)(properties.weightSort) }) : properties;
    }
    function CfnTemplateSankeyDiagramSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationItemsLimit", "DestinationItemsLimit", properties.DestinationItemsLimit != null ? CfnTemplateItemsLimitConfigurationPropertyFromCloudFormation(properties.DestinationItemsLimit) : void 0), ret.addPropertyResult("sourceItemsLimit", "SourceItemsLimit", properties.SourceItemsLimit != null ? CfnTemplateItemsLimitConfigurationPropertyFromCloudFormation(properties.SourceItemsLimit) : void 0), ret.addPropertyResult("weightSort", "WeightSort", properties.WeightSort != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateFieldSortOptionsPropertyFromCloudFormation)(properties.WeightSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_SankeyDiagramVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnTemplate_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnTemplate_SankeyDiagramChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("subtitle", CfnTemplate_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnTemplate_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "SankeyDiagramVisualProperty"');
    }
    function cfnTemplateSankeyDiagramVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_SankeyDiagramVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnTemplateVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnTemplateSankeyDiagramChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), Subtitle: cfnTemplateVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnTemplateVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnTemplateSankeyDiagramVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnTemplateSankeyDiagramChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnTemplateVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnTemplateVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ScatterPlotCategoricallyAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("category", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.category)), errors.collect(cdk.propertyValidator("size", cdk.listValidator(CfnTemplate_MeasureFieldPropertyValidator))(properties.size)), errors.collect(cdk.propertyValidator("xAxis", cdk.listValidator(CfnTemplate_MeasureFieldPropertyValidator))(properties.xAxis)), errors.collect(cdk.propertyValidator("yAxis", cdk.listValidator(CfnTemplate_MeasureFieldPropertyValidator))(properties.yAxis)), errors.wrap('supplied properties not correct for "ScatterPlotCategoricallyAggregatedFieldWellsProperty"');
    }
    function cfnTemplateScatterPlotCategoricallyAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ScatterPlotCategoricallyAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Category: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.category), Size: cdk.listMapper(cfnTemplateMeasureFieldPropertyToCloudFormation)(properties.size), XAxis: cdk.listMapper(cfnTemplateMeasureFieldPropertyToCloudFormation)(properties.xAxis), YAxis: cdk.listMapper(cfnTemplateMeasureFieldPropertyToCloudFormation)(properties.yAxis) }) : properties;
    }
    function CfnTemplateScatterPlotCategoricallyAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("category", "Category", properties.Category != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.Category) : void 0), ret.addPropertyResult("size", "Size", properties.Size != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMeasureFieldPropertyFromCloudFormation)(properties.Size) : void 0), ret.addPropertyResult("xAxis", "XAxis", properties.XAxis != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMeasureFieldPropertyFromCloudFormation)(properties.XAxis) : void 0), ret.addPropertyResult("yAxis", "YAxis", properties.YAxis != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMeasureFieldPropertyFromCloudFormation)(properties.YAxis) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ScatterPlotConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataLabels", CfnTemplate_DataLabelOptionsPropertyValidator)(properties.dataLabels)), errors.collect(cdk.propertyValidator("fieldWells", CfnTemplate_ScatterPlotFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("legend", CfnTemplate_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("tooltip", CfnTemplate_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.collect(cdk.propertyValidator("visualPalette", CfnTemplate_VisualPalettePropertyValidator)(properties.visualPalette)), errors.collect(cdk.propertyValidator("xAxisDisplayOptions", CfnTemplate_AxisDisplayOptionsPropertyValidator)(properties.xAxisDisplayOptions)), errors.collect(cdk.propertyValidator("xAxisLabelOptions", CfnTemplate_ChartAxisLabelOptionsPropertyValidator)(properties.xAxisLabelOptions)), errors.collect(cdk.propertyValidator("yAxisDisplayOptions", CfnTemplate_AxisDisplayOptionsPropertyValidator)(properties.yAxisDisplayOptions)), errors.collect(cdk.propertyValidator("yAxisLabelOptions", CfnTemplate_ChartAxisLabelOptionsPropertyValidator)(properties.yAxisLabelOptions)), errors.wrap('supplied properties not correct for "ScatterPlotConfigurationProperty"');
    }
    function cfnTemplateScatterPlotConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ScatterPlotConfigurationPropertyValidator(properties).assertSuccess(), { DataLabels: cfnTemplateDataLabelOptionsPropertyToCloudFormation(properties.dataLabels), FieldWells: cfnTemplateScatterPlotFieldWellsPropertyToCloudFormation(properties.fieldWells), Legend: cfnTemplateLegendOptionsPropertyToCloudFormation(properties.legend), Tooltip: cfnTemplateTooltipOptionsPropertyToCloudFormation(properties.tooltip), VisualPalette: cfnTemplateVisualPalettePropertyToCloudFormation(properties.visualPalette), XAxisDisplayOptions: cfnTemplateAxisDisplayOptionsPropertyToCloudFormation(properties.xAxisDisplayOptions), XAxisLabelOptions: cfnTemplateChartAxisLabelOptionsPropertyToCloudFormation(properties.xAxisLabelOptions), YAxisDisplayOptions: cfnTemplateAxisDisplayOptionsPropertyToCloudFormation(properties.yAxisDisplayOptions), YAxisLabelOptions: cfnTemplateChartAxisLabelOptionsPropertyToCloudFormation(properties.yAxisLabelOptions) }) : properties;
    }
    function CfnTemplateScatterPlotConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataLabels", "DataLabels", properties.DataLabels != null ? CfnTemplateDataLabelOptionsPropertyFromCloudFormation(properties.DataLabels) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnTemplateScatterPlotFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnTemplateLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnTemplateTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnTemplateVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addPropertyResult("xAxisDisplayOptions", "XAxisDisplayOptions", properties.XAxisDisplayOptions != null ? CfnTemplateAxisDisplayOptionsPropertyFromCloudFormation(properties.XAxisDisplayOptions) : void 0), ret.addPropertyResult("xAxisLabelOptions", "XAxisLabelOptions", properties.XAxisLabelOptions != null ? CfnTemplateChartAxisLabelOptionsPropertyFromCloudFormation(properties.XAxisLabelOptions) : void 0), ret.addPropertyResult("yAxisDisplayOptions", "YAxisDisplayOptions", properties.YAxisDisplayOptions != null ? CfnTemplateAxisDisplayOptionsPropertyFromCloudFormation(properties.YAxisDisplayOptions) : void 0), ret.addPropertyResult("yAxisLabelOptions", "YAxisLabelOptions", properties.YAxisLabelOptions != null ? CfnTemplateChartAxisLabelOptionsPropertyFromCloudFormation(properties.YAxisLabelOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ScatterPlotFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("scatterPlotCategoricallyAggregatedFieldWells", CfnTemplate_ScatterPlotCategoricallyAggregatedFieldWellsPropertyValidator)(properties.scatterPlotCategoricallyAggregatedFieldWells)), errors.collect(cdk.propertyValidator("scatterPlotUnaggregatedFieldWells", CfnTemplate_ScatterPlotUnaggregatedFieldWellsPropertyValidator)(properties.scatterPlotUnaggregatedFieldWells)), errors.wrap('supplied properties not correct for "ScatterPlotFieldWellsProperty"');
    }
    function cfnTemplateScatterPlotFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ScatterPlotFieldWellsPropertyValidator(properties).assertSuccess(), { ScatterPlotCategoricallyAggregatedFieldWells: cfnTemplateScatterPlotCategoricallyAggregatedFieldWellsPropertyToCloudFormation(properties.scatterPlotCategoricallyAggregatedFieldWells), ScatterPlotUnaggregatedFieldWells: cfnTemplateScatterPlotUnaggregatedFieldWellsPropertyToCloudFormation(properties.scatterPlotUnaggregatedFieldWells) }) : properties;
    }
    function CfnTemplateScatterPlotFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("scatterPlotCategoricallyAggregatedFieldWells", "ScatterPlotCategoricallyAggregatedFieldWells", properties.ScatterPlotCategoricallyAggregatedFieldWells != null ? CfnTemplateScatterPlotCategoricallyAggregatedFieldWellsPropertyFromCloudFormation(properties.ScatterPlotCategoricallyAggregatedFieldWells) : void 0), ret.addPropertyResult("scatterPlotUnaggregatedFieldWells", "ScatterPlotUnaggregatedFieldWells", properties.ScatterPlotUnaggregatedFieldWells != null ? CfnTemplateScatterPlotUnaggregatedFieldWellsPropertyFromCloudFormation(properties.ScatterPlotUnaggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ScatterPlotUnaggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("size", cdk.listValidator(CfnTemplate_MeasureFieldPropertyValidator))(properties.size)), errors.collect(cdk.propertyValidator("xAxis", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.xAxis)), errors.collect(cdk.propertyValidator("yAxis", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.yAxis)), errors.wrap('supplied properties not correct for "ScatterPlotUnaggregatedFieldWellsProperty"');
    }
    function cfnTemplateScatterPlotUnaggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ScatterPlotUnaggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Size: cdk.listMapper(cfnTemplateMeasureFieldPropertyToCloudFormation)(properties.size), XAxis: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.xAxis), YAxis: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.yAxis) }) : properties;
    }
    function CfnTemplateScatterPlotUnaggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("size", "Size", properties.Size != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMeasureFieldPropertyFromCloudFormation)(properties.Size) : void 0), ret.addPropertyResult("xAxis", "XAxis", properties.XAxis != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.XAxis) : void 0), ret.addPropertyResult("yAxis", "YAxis", properties.YAxis != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.YAxis) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ScatterPlotVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnTemplate_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnTemplate_ScatterPlotConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnTemplate_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnTemplate_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnTemplate_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "ScatterPlotVisualProperty"');
    }
    function cfnTemplateScatterPlotVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ScatterPlotVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnTemplateVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnTemplateScatterPlotConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnTemplateColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnTemplateVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnTemplateVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnTemplateScatterPlotVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnTemplateScatterPlotConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnTemplateVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnTemplateVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ScrollBarOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.collect(cdk.propertyValidator("visibleRange", CfnTemplate_VisibleRangeOptionsPropertyValidator)(properties.visibleRange)), errors.wrap('supplied properties not correct for "ScrollBarOptionsProperty"');
    }
    function cfnTemplateScrollBarOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ScrollBarOptionsPropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility), VisibleRange: cfnTemplateVisibleRangeOptionsPropertyToCloudFormation(properties.visibleRange) }) : properties;
    }
    function CfnTemplateScrollBarOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addPropertyResult("visibleRange", "VisibleRange", properties.VisibleRange != null ? CfnTemplateVisibleRangeOptionsPropertyFromCloudFormation(properties.VisibleRange) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_SecondaryValueOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "SecondaryValueOptionsProperty"');
    }
    function cfnTemplateSecondaryValueOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_SecondaryValueOptionsPropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnTemplateSecondaryValueOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_SectionAfterPageBreakPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "SectionAfterPageBreakProperty"');
    }
    function cfnTemplateSectionAfterPageBreakPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_SectionAfterPageBreakPropertyValidator(properties).assertSuccess(), { Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnTemplateSectionAfterPageBreakPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_SectionBasedLayoutCanvasSizeOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("paperCanvasSizeOptions", CfnTemplate_SectionBasedLayoutPaperCanvasSizeOptionsPropertyValidator)(properties.paperCanvasSizeOptions)), errors.wrap('supplied properties not correct for "SectionBasedLayoutCanvasSizeOptionsProperty"');
    }
    function cfnTemplateSectionBasedLayoutCanvasSizeOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_SectionBasedLayoutCanvasSizeOptionsPropertyValidator(properties).assertSuccess(), { PaperCanvasSizeOptions: cfnTemplateSectionBasedLayoutPaperCanvasSizeOptionsPropertyToCloudFormation(properties.paperCanvasSizeOptions) }) : properties;
    }
    function CfnTemplateSectionBasedLayoutCanvasSizeOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("paperCanvasSizeOptions", "PaperCanvasSizeOptions", properties.PaperCanvasSizeOptions != null ? CfnTemplateSectionBasedLayoutPaperCanvasSizeOptionsPropertyFromCloudFormation(properties.PaperCanvasSizeOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_SectionBasedLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bodySections", cdk.requiredValidator)(properties.bodySections)), errors.collect(cdk.propertyValidator("bodySections", cdk.listValidator(CfnTemplate_BodySectionConfigurationPropertyValidator))(properties.bodySections)), errors.collect(cdk.propertyValidator("canvasSizeOptions", cdk.requiredValidator)(properties.canvasSizeOptions)), errors.collect(cdk.propertyValidator("canvasSizeOptions", CfnTemplate_SectionBasedLayoutCanvasSizeOptionsPropertyValidator)(properties.canvasSizeOptions)), errors.collect(cdk.propertyValidator("footerSections", cdk.requiredValidator)(properties.footerSections)), errors.collect(cdk.propertyValidator("footerSections", cdk.listValidator(CfnTemplate_HeaderFooterSectionConfigurationPropertyValidator))(properties.footerSections)), errors.collect(cdk.propertyValidator("headerSections", cdk.requiredValidator)(properties.headerSections)), errors.collect(cdk.propertyValidator("headerSections", cdk.listValidator(CfnTemplate_HeaderFooterSectionConfigurationPropertyValidator))(properties.headerSections)), errors.wrap('supplied properties not correct for "SectionBasedLayoutConfigurationProperty"');
    }
    function cfnTemplateSectionBasedLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_SectionBasedLayoutConfigurationPropertyValidator(properties).assertSuccess(), { BodySections: cdk.listMapper(cfnTemplateBodySectionConfigurationPropertyToCloudFormation)(properties.bodySections), CanvasSizeOptions: cfnTemplateSectionBasedLayoutCanvasSizeOptionsPropertyToCloudFormation(properties.canvasSizeOptions), FooterSections: cdk.listMapper(cfnTemplateHeaderFooterSectionConfigurationPropertyToCloudFormation)(properties.footerSections), HeaderSections: cdk.listMapper(cfnTemplateHeaderFooterSectionConfigurationPropertyToCloudFormation)(properties.headerSections) }) : properties;
    }
    function CfnTemplateSectionBasedLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bodySections", "BodySections", cfn_parse.FromCloudFormation.getArray(CfnTemplateBodySectionConfigurationPropertyFromCloudFormation)(properties.BodySections)), ret.addPropertyResult("canvasSizeOptions", "CanvasSizeOptions", CfnTemplateSectionBasedLayoutCanvasSizeOptionsPropertyFromCloudFormation(properties.CanvasSizeOptions)), ret.addPropertyResult("footerSections", "FooterSections", cfn_parse.FromCloudFormation.getArray(CfnTemplateHeaderFooterSectionConfigurationPropertyFromCloudFormation)(properties.FooterSections)), ret.addPropertyResult("headerSections", "HeaderSections", cfn_parse.FromCloudFormation.getArray(CfnTemplateHeaderFooterSectionConfigurationPropertyFromCloudFormation)(properties.HeaderSections)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_SectionBasedLayoutPaperCanvasSizeOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("paperMargin", CfnTemplate_SpacingPropertyValidator)(properties.paperMargin)), errors.collect(cdk.propertyValidator("paperOrientation", cdk.validateString)(properties.paperOrientation)), errors.collect(cdk.propertyValidator("paperSize", cdk.validateString)(properties.paperSize)), errors.wrap('supplied properties not correct for "SectionBasedLayoutPaperCanvasSizeOptionsProperty"');
    }
    function cfnTemplateSectionBasedLayoutPaperCanvasSizeOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_SectionBasedLayoutPaperCanvasSizeOptionsPropertyValidator(properties).assertSuccess(), { PaperMargin: cfnTemplateSpacingPropertyToCloudFormation(properties.paperMargin), PaperOrientation: cdk.stringToCloudFormation(properties.paperOrientation), PaperSize: cdk.stringToCloudFormation(properties.paperSize) }) : properties;
    }
    function CfnTemplateSectionBasedLayoutPaperCanvasSizeOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("paperMargin", "PaperMargin", properties.PaperMargin != null ? CfnTemplateSpacingPropertyFromCloudFormation(properties.PaperMargin) : void 0), ret.addPropertyResult("paperOrientation", "PaperOrientation", properties.PaperOrientation != null ? cfn_parse.FromCloudFormation.getString(properties.PaperOrientation) : void 0), ret.addPropertyResult("paperSize", "PaperSize", properties.PaperSize != null ? cfn_parse.FromCloudFormation.getString(properties.PaperSize) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_SectionLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("freeFormLayout", cdk.requiredValidator)(properties.freeFormLayout)), errors.collect(cdk.propertyValidator("freeFormLayout", CfnTemplate_FreeFormSectionLayoutConfigurationPropertyValidator)(properties.freeFormLayout)), errors.wrap('supplied properties not correct for "SectionLayoutConfigurationProperty"');
    }
    function cfnTemplateSectionLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_SectionLayoutConfigurationPropertyValidator(properties).assertSuccess(), { FreeFormLayout: cfnTemplateFreeFormSectionLayoutConfigurationPropertyToCloudFormation(properties.freeFormLayout) }) : properties;
    }
    function CfnTemplateSectionLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("freeFormLayout", "FreeFormLayout", CfnTemplateFreeFormSectionLayoutConfigurationPropertyFromCloudFormation(properties.FreeFormLayout)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_SectionPageBreakConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("after", CfnTemplate_SectionAfterPageBreakPropertyValidator)(properties.after)), errors.wrap('supplied properties not correct for "SectionPageBreakConfigurationProperty"');
    }
    function cfnTemplateSectionPageBreakConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_SectionPageBreakConfigurationPropertyValidator(properties).assertSuccess(), { After: cfnTemplateSectionAfterPageBreakPropertyToCloudFormation(properties.after) }) : properties;
    }
    function CfnTemplateSectionPageBreakConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("after", "After", properties.After != null ? CfnTemplateSectionAfterPageBreakPropertyFromCloudFormation(properties.After) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_SectionStylePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("height", cdk.validateString)(properties.height)), errors.collect(cdk.propertyValidator("padding", CfnTemplate_SpacingPropertyValidator)(properties.padding)), errors.wrap('supplied properties not correct for "SectionStyleProperty"');
    }
    function cfnTemplateSectionStylePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_SectionStylePropertyValidator(properties).assertSuccess(), { Height: cdk.stringToCloudFormation(properties.height), Padding: cfnTemplateSpacingPropertyToCloudFormation(properties.padding) }) : properties;
    }
    function CfnTemplateSectionStylePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("height", "Height", properties.Height != null ? cfn_parse.FromCloudFormation.getString(properties.Height) : void 0), ret.addPropertyResult("padding", "Padding", properties.Padding != null ? CfnTemplateSpacingPropertyFromCloudFormation(properties.Padding) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_SelectedSheetsFilterScopeConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sheetVisualScopingConfigurations", cdk.listValidator(CfnTemplate_SheetVisualScopingConfigurationPropertyValidator))(properties.sheetVisualScopingConfigurations)), errors.wrap('supplied properties not correct for "SelectedSheetsFilterScopeConfigurationProperty"');
    }
    function cfnTemplateSelectedSheetsFilterScopeConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_SelectedSheetsFilterScopeConfigurationPropertyValidator(properties).assertSuccess(), { SheetVisualScopingConfigurations: cdk.listMapper(cfnTemplateSheetVisualScopingConfigurationPropertyToCloudFormation)(properties.sheetVisualScopingConfigurations) }) : properties;
    }
    function CfnTemplateSelectedSheetsFilterScopeConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sheetVisualScopingConfigurations", "SheetVisualScopingConfigurations", properties.SheetVisualScopingConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateSheetVisualScopingConfigurationPropertyFromCloudFormation)(properties.SheetVisualScopingConfigurations) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_SeriesItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataFieldSeriesItem", CfnTemplate_DataFieldSeriesItemPropertyValidator)(properties.dataFieldSeriesItem)), errors.collect(cdk.propertyValidator("fieldSeriesItem", CfnTemplate_FieldSeriesItemPropertyValidator)(properties.fieldSeriesItem)), errors.wrap('supplied properties not correct for "SeriesItemProperty"');
    }
    function cfnTemplateSeriesItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_SeriesItemPropertyValidator(properties).assertSuccess(), { DataFieldSeriesItem: cfnTemplateDataFieldSeriesItemPropertyToCloudFormation(properties.dataFieldSeriesItem), FieldSeriesItem: cfnTemplateFieldSeriesItemPropertyToCloudFormation(properties.fieldSeriesItem) }) : properties;
    }
    function CfnTemplateSeriesItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataFieldSeriesItem", "DataFieldSeriesItem", properties.DataFieldSeriesItem != null ? CfnTemplateDataFieldSeriesItemPropertyFromCloudFormation(properties.DataFieldSeriesItem) : void 0), ret.addPropertyResult("fieldSeriesItem", "FieldSeriesItem", properties.FieldSeriesItem != null ? CfnTemplateFieldSeriesItemPropertyFromCloudFormation(properties.FieldSeriesItem) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_SetParameterValueConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationParameterName", cdk.requiredValidator)(properties.destinationParameterName)), errors.collect(cdk.propertyValidator("destinationParameterName", cdk.validateString)(properties.destinationParameterName)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", CfnTemplate_DestinationParameterValueConfigurationPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "SetParameterValueConfigurationProperty"');
    }
    function cfnTemplateSetParameterValueConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_SetParameterValueConfigurationPropertyValidator(properties).assertSuccess(), { DestinationParameterName: cdk.stringToCloudFormation(properties.destinationParameterName), Value: cfnTemplateDestinationParameterValueConfigurationPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnTemplateSetParameterValueConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationParameterName", "DestinationParameterName", cfn_parse.FromCloudFormation.getString(properties.DestinationParameterName)), ret.addPropertyResult("value", "Value", CfnTemplateDestinationParameterValueConfigurationPropertyFromCloudFormation(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ShapeConditionalFormatPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("backgroundColor", cdk.requiredValidator)(properties.backgroundColor)), errors.collect(cdk.propertyValidator("backgroundColor", CfnTemplate_ConditionalFormattingColorPropertyValidator)(properties.backgroundColor)), errors.wrap('supplied properties not correct for "ShapeConditionalFormatProperty"');
    }
    function cfnTemplateShapeConditionalFormatPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ShapeConditionalFormatPropertyValidator(properties).assertSuccess(), { BackgroundColor: cfnTemplateConditionalFormattingColorPropertyToCloudFormation(properties.backgroundColor) }) : properties;
    }
    function CfnTemplateShapeConditionalFormatPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("backgroundColor", "BackgroundColor", CfnTemplateConditionalFormattingColorPropertyFromCloudFormation(properties.BackgroundColor)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_SheetControlLayoutPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configuration", cdk.requiredValidator)(properties.configuration)), errors.collect(cdk.propertyValidator("configuration", CfnTemplate_SheetControlLayoutConfigurationPropertyValidator)(properties.configuration)), errors.wrap('supplied properties not correct for "SheetControlLayoutProperty"');
    }
    function cfnTemplateSheetControlLayoutPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_SheetControlLayoutPropertyValidator(properties).assertSuccess(), { Configuration: cfnTemplateSheetControlLayoutConfigurationPropertyToCloudFormation(properties.configuration) }) : properties;
    }
    function CfnTemplateSheetControlLayoutPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configuration", "Configuration", CfnTemplateSheetControlLayoutConfigurationPropertyFromCloudFormation(properties.Configuration)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_SheetControlLayoutConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("gridLayout", CfnTemplate_GridLayoutConfigurationPropertyValidator)(properties.gridLayout)), errors.wrap('supplied properties not correct for "SheetControlLayoutConfigurationProperty"');
    }
    function cfnTemplateSheetControlLayoutConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_SheetControlLayoutConfigurationPropertyValidator(properties).assertSuccess(), { GridLayout: cfnTemplateGridLayoutConfigurationPropertyToCloudFormation(properties.gridLayout) }) : properties;
    }
    function CfnTemplateSheetControlLayoutConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("gridLayout", "GridLayout", properties.GridLayout != null ? CfnTemplateGridLayoutConfigurationPropertyFromCloudFormation(properties.GridLayout) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_SheetDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contentType", cdk.validateString)(properties.contentType)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("filterControls", cdk.listValidator(CfnTemplate_FilterControlPropertyValidator))(properties.filterControls)), errors.collect(cdk.propertyValidator("layouts", cdk.listValidator(CfnTemplate_LayoutPropertyValidator))(properties.layouts)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("parameterControls", cdk.listValidator(CfnTemplate_ParameterControlPropertyValidator))(properties.parameterControls)), errors.collect(cdk.propertyValidator("sheetControlLayouts", cdk.listValidator(CfnTemplate_SheetControlLayoutPropertyValidator))(properties.sheetControlLayouts)), errors.collect(cdk.propertyValidator("sheetId", cdk.requiredValidator)(properties.sheetId)), errors.collect(cdk.propertyValidator("sheetId", cdk.validateString)(properties.sheetId)), errors.collect(cdk.propertyValidator("textBoxes", cdk.listValidator(CfnTemplate_SheetTextBoxPropertyValidator))(properties.textBoxes)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.collect(cdk.propertyValidator("visuals", cdk.listValidator(CfnTemplate_VisualPropertyValidator))(properties.visuals)), errors.wrap('supplied properties not correct for "SheetDefinitionProperty"');
    }
    function cfnTemplateSheetDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_SheetDefinitionPropertyValidator(properties).assertSuccess(), { ContentType: cdk.stringToCloudFormation(properties.contentType), Description: cdk.stringToCloudFormation(properties.description), FilterControls: cdk.listMapper(cfnTemplateFilterControlPropertyToCloudFormation)(properties.filterControls), Layouts: cdk.listMapper(cfnTemplateLayoutPropertyToCloudFormation)(properties.layouts), Name: cdk.stringToCloudFormation(properties.name), ParameterControls: cdk.listMapper(cfnTemplateParameterControlPropertyToCloudFormation)(properties.parameterControls), SheetControlLayouts: cdk.listMapper(cfnTemplateSheetControlLayoutPropertyToCloudFormation)(properties.sheetControlLayouts), SheetId: cdk.stringToCloudFormation(properties.sheetId), TextBoxes: cdk.listMapper(cfnTemplateSheetTextBoxPropertyToCloudFormation)(properties.textBoxes), Title: cdk.stringToCloudFormation(properties.title), Visuals: cdk.listMapper(cfnTemplateVisualPropertyToCloudFormation)(properties.visuals) }) : properties;
    }
    function CfnTemplateSheetDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contentType", "ContentType", properties.ContentType != null ? cfn_parse.FromCloudFormation.getString(properties.ContentType) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("filterControls", "FilterControls", properties.FilterControls != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateFilterControlPropertyFromCloudFormation)(properties.FilterControls) : void 0), ret.addPropertyResult("layouts", "Layouts", properties.Layouts != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateLayoutPropertyFromCloudFormation)(properties.Layouts) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("parameterControls", "ParameterControls", properties.ParameterControls != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateParameterControlPropertyFromCloudFormation)(properties.ParameterControls) : void 0), ret.addPropertyResult("sheetControlLayouts", "SheetControlLayouts", properties.SheetControlLayouts != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateSheetControlLayoutPropertyFromCloudFormation)(properties.SheetControlLayouts) : void 0), ret.addPropertyResult("sheetId", "SheetId", cfn_parse.FromCloudFormation.getString(properties.SheetId)), ret.addPropertyResult("textBoxes", "TextBoxes", properties.TextBoxes != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateSheetTextBoxPropertyFromCloudFormation)(properties.TextBoxes) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? cfn_parse.FromCloudFormation.getString(properties.Title) : void 0), ret.addPropertyResult("visuals", "Visuals", properties.Visuals != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateVisualPropertyFromCloudFormation)(properties.Visuals) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_SheetElementConfigurationOverridesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "SheetElementConfigurationOverridesProperty"');
    }
    function cfnTemplateSheetElementConfigurationOverridesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_SheetElementConfigurationOverridesPropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnTemplateSheetElementConfigurationOverridesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_SheetElementRenderingRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configurationOverrides", cdk.requiredValidator)(properties.configurationOverrides)), errors.collect(cdk.propertyValidator("configurationOverrides", CfnTemplate_SheetElementConfigurationOverridesPropertyValidator)(properties.configurationOverrides)), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.wrap('supplied properties not correct for "SheetElementRenderingRuleProperty"');
    }
    function cfnTemplateSheetElementRenderingRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_SheetElementRenderingRulePropertyValidator(properties).assertSuccess(), { ConfigurationOverrides: cfnTemplateSheetElementConfigurationOverridesPropertyToCloudFormation(properties.configurationOverrides), Expression: cdk.stringToCloudFormation(properties.expression) }) : properties;
    }
    function CfnTemplateSheetElementRenderingRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configurationOverrides", "ConfigurationOverrides", CfnTemplateSheetElementConfigurationOverridesPropertyFromCloudFormation(properties.ConfigurationOverrides)), ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getString(properties.Expression)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_SheetTextBoxPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("content", cdk.validateString)(properties.content)), errors.collect(cdk.propertyValidator("sheetTextBoxId", cdk.requiredValidator)(properties.sheetTextBoxId)), errors.collect(cdk.propertyValidator("sheetTextBoxId", cdk.validateString)(properties.sheetTextBoxId)), errors.wrap('supplied properties not correct for "SheetTextBoxProperty"');
    }
    function cfnTemplateSheetTextBoxPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_SheetTextBoxPropertyValidator(properties).assertSuccess(), { Content: cdk.stringToCloudFormation(properties.content), SheetTextBoxId: cdk.stringToCloudFormation(properties.sheetTextBoxId) }) : properties;
    }
    function CfnTemplateSheetTextBoxPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("content", "Content", properties.Content != null ? cfn_parse.FromCloudFormation.getString(properties.Content) : void 0), ret.addPropertyResult("sheetTextBoxId", "SheetTextBoxId", cfn_parse.FromCloudFormation.getString(properties.SheetTextBoxId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_SheetVisualScopingConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("scope", cdk.requiredValidator)(properties.scope)), errors.collect(cdk.propertyValidator("scope", cdk.validateString)(properties.scope)), errors.collect(cdk.propertyValidator("sheetId", cdk.requiredValidator)(properties.sheetId)), errors.collect(cdk.propertyValidator("sheetId", cdk.validateString)(properties.sheetId)), errors.collect(cdk.propertyValidator("visualIds", cdk.listValidator(cdk.validateString))(properties.visualIds)), errors.wrap('supplied properties not correct for "SheetVisualScopingConfigurationProperty"');
    }
    function cfnTemplateSheetVisualScopingConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_SheetVisualScopingConfigurationPropertyValidator(properties).assertSuccess(), { Scope: cdk.stringToCloudFormation(properties.scope), SheetId: cdk.stringToCloudFormation(properties.sheetId), VisualIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.visualIds) }) : properties;
    }
    function CfnTemplateSheetVisualScopingConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("scope", "Scope", cfn_parse.FromCloudFormation.getString(properties.Scope)), ret.addPropertyResult("sheetId", "SheetId", cfn_parse.FromCloudFormation.getString(properties.SheetId)), ret.addPropertyResult("visualIds", "VisualIds", properties.VisualIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.VisualIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ShortFormatTextPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("plainText", cdk.validateString)(properties.plainText)), errors.collect(cdk.propertyValidator("richText", cdk.validateString)(properties.richText)), errors.wrap('supplied properties not correct for "ShortFormatTextProperty"');
    }
    function cfnTemplateShortFormatTextPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ShortFormatTextPropertyValidator(properties).assertSuccess(), { PlainText: cdk.stringToCloudFormation(properties.plainText), RichText: cdk.stringToCloudFormation(properties.richText) }) : properties;
    }
    function CfnTemplateShortFormatTextPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("plainText", "PlainText", properties.PlainText != null ? cfn_parse.FromCloudFormation.getString(properties.PlainText) : void 0), ret.addPropertyResult("richText", "RichText", properties.RichText != null ? cfn_parse.FromCloudFormation.getString(properties.RichText) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_SimpleClusterMarkerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.wrap('supplied properties not correct for "SimpleClusterMarkerProperty"');
    }
    function cfnTemplateSimpleClusterMarkerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_SimpleClusterMarkerPropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color) }) : properties;
    }
    function CfnTemplateSimpleClusterMarkerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", properties.Color != null ? cfn_parse.FromCloudFormation.getString(properties.Color) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_SliderControlDisplayOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("titleOptions", CfnTemplate_LabelOptionsPropertyValidator)(properties.titleOptions)), errors.wrap('supplied properties not correct for "SliderControlDisplayOptionsProperty"');
    }
    function cfnTemplateSliderControlDisplayOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_SliderControlDisplayOptionsPropertyValidator(properties).assertSuccess(), { TitleOptions: cfnTemplateLabelOptionsPropertyToCloudFormation(properties.titleOptions) }) : properties;
    }
    function CfnTemplateSliderControlDisplayOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("titleOptions", "TitleOptions", properties.TitleOptions != null ? CfnTemplateLabelOptionsPropertyFromCloudFormation(properties.TitleOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_SmallMultiplesOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxVisibleColumns", cdk.validateNumber)(properties.maxVisibleColumns)), errors.collect(cdk.propertyValidator("maxVisibleRows", cdk.validateNumber)(properties.maxVisibleRows)), errors.collect(cdk.propertyValidator("panelConfiguration", CfnTemplate_PanelConfigurationPropertyValidator)(properties.panelConfiguration)), errors.wrap('supplied properties not correct for "SmallMultiplesOptionsProperty"');
    }
    function cfnTemplateSmallMultiplesOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_SmallMultiplesOptionsPropertyValidator(properties).assertSuccess(), { MaxVisibleColumns: cdk.numberToCloudFormation(properties.maxVisibleColumns), MaxVisibleRows: cdk.numberToCloudFormation(properties.maxVisibleRows), PanelConfiguration: cfnTemplatePanelConfigurationPropertyToCloudFormation(properties.panelConfiguration) }) : properties;
    }
    function CfnTemplateSmallMultiplesOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxVisibleColumns", "MaxVisibleColumns", properties.MaxVisibleColumns != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxVisibleColumns) : void 0), ret.addPropertyResult("maxVisibleRows", "MaxVisibleRows", properties.MaxVisibleRows != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxVisibleRows) : void 0), ret.addPropertyResult("panelConfiguration", "PanelConfiguration", properties.PanelConfiguration != null ? CfnTemplatePanelConfigurationPropertyFromCloudFormation(properties.PanelConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_SpacingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bottom", cdk.validateString)(properties.bottom)), errors.collect(cdk.propertyValidator("left", cdk.validateString)(properties.left)), errors.collect(cdk.propertyValidator("right", cdk.validateString)(properties.right)), errors.collect(cdk.propertyValidator("top", cdk.validateString)(properties.top)), errors.wrap('supplied properties not correct for "SpacingProperty"');
    }
    function cfnTemplateSpacingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_SpacingPropertyValidator(properties).assertSuccess(), { Bottom: cdk.stringToCloudFormation(properties.bottom), Left: cdk.stringToCloudFormation(properties.left), Right: cdk.stringToCloudFormation(properties.right), Top: cdk.stringToCloudFormation(properties.top) }) : properties;
    }
    function CfnTemplateSpacingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bottom", "Bottom", properties.Bottom != null ? cfn_parse.FromCloudFormation.getString(properties.Bottom) : void 0), ret.addPropertyResult("left", "Left", properties.Left != null ? cfn_parse.FromCloudFormation.getString(properties.Left) : void 0), ret.addPropertyResult("right", "Right", properties.Right != null ? cfn_parse.FromCloudFormation.getString(properties.Right) : void 0), ret.addPropertyResult("top", "Top", properties.Top != null ? cfn_parse.FromCloudFormation.getString(properties.Top) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_StringDefaultValuesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dynamicValue", CfnTemplate_DynamicDefaultValuePropertyValidator)(properties.dynamicValue)), errors.collect(cdk.propertyValidator("staticValues", cdk.listValidator(cdk.validateString))(properties.staticValues)), errors.wrap('supplied properties not correct for "StringDefaultValuesProperty"');
    }
    function cfnTemplateStringDefaultValuesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_StringDefaultValuesPropertyValidator(properties).assertSuccess(), { DynamicValue: cfnTemplateDynamicDefaultValuePropertyToCloudFormation(properties.dynamicValue), StaticValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.staticValues) }) : properties;
    }
    function CfnTemplateStringDefaultValuesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dynamicValue", "DynamicValue", properties.DynamicValue != null ? CfnTemplateDynamicDefaultValuePropertyFromCloudFormation(properties.DynamicValue) : void 0), ret.addPropertyResult("staticValues", "StaticValues", properties.StaticValues != null ? cfn_parse.FromCloudFormation.getStringArray(properties.StaticValues) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_StringFormatConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("nullValueFormatConfiguration", CfnTemplate_NullValueFormatConfigurationPropertyValidator)(properties.nullValueFormatConfiguration)), errors.collect(cdk.propertyValidator("numericFormatConfiguration", CfnTemplate_NumericFormatConfigurationPropertyValidator)(properties.numericFormatConfiguration)), errors.wrap('supplied properties not correct for "StringFormatConfigurationProperty"');
    }
    function cfnTemplateStringFormatConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_StringFormatConfigurationPropertyValidator(properties).assertSuccess(), { NullValueFormatConfiguration: cfnTemplateNullValueFormatConfigurationPropertyToCloudFormation(properties.nullValueFormatConfiguration), NumericFormatConfiguration: cfnTemplateNumericFormatConfigurationPropertyToCloudFormation(properties.numericFormatConfiguration) }) : properties;
    }
    function CfnTemplateStringFormatConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("nullValueFormatConfiguration", "NullValueFormatConfiguration", properties.NullValueFormatConfiguration != null ? CfnTemplateNullValueFormatConfigurationPropertyFromCloudFormation(properties.NullValueFormatConfiguration) : void 0), ret.addPropertyResult("numericFormatConfiguration", "NumericFormatConfiguration", properties.NumericFormatConfiguration != null ? CfnTemplateNumericFormatConfigurationPropertyFromCloudFormation(properties.NumericFormatConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_StringParameterDeclarationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultValues", CfnTemplate_StringDefaultValuesPropertyValidator)(properties.defaultValues)), errors.collect(cdk.propertyValidator("mappedDataSetParameters", cdk.listValidator(CfnTemplate_MappedDataSetParameterPropertyValidator))(properties.mappedDataSetParameters)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("parameterValueType", cdk.requiredValidator)(properties.parameterValueType)), errors.collect(cdk.propertyValidator("parameterValueType", cdk.validateString)(properties.parameterValueType)), errors.collect(cdk.propertyValidator("valueWhenUnset", CfnTemplate_StringValueWhenUnsetConfigurationPropertyValidator)(properties.valueWhenUnset)), errors.wrap('supplied properties not correct for "StringParameterDeclarationProperty"');
    }
    function cfnTemplateStringParameterDeclarationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_StringParameterDeclarationPropertyValidator(properties).assertSuccess(), { DefaultValues: cfnTemplateStringDefaultValuesPropertyToCloudFormation(properties.defaultValues), MappedDataSetParameters: cdk.listMapper(cfnTemplateMappedDataSetParameterPropertyToCloudFormation)(properties.mappedDataSetParameters), Name: cdk.stringToCloudFormation(properties.name), ParameterValueType: cdk.stringToCloudFormation(properties.parameterValueType), ValueWhenUnset: cfnTemplateStringValueWhenUnsetConfigurationPropertyToCloudFormation(properties.valueWhenUnset) }) : properties;
    }
    function CfnTemplateStringParameterDeclarationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultValues", "DefaultValues", properties.DefaultValues != null ? CfnTemplateStringDefaultValuesPropertyFromCloudFormation(properties.DefaultValues) : void 0), ret.addPropertyResult("mappedDataSetParameters", "MappedDataSetParameters", properties.MappedDataSetParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMappedDataSetParameterPropertyFromCloudFormation)(properties.MappedDataSetParameters) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("parameterValueType", "ParameterValueType", cfn_parse.FromCloudFormation.getString(properties.ParameterValueType)), ret.addPropertyResult("valueWhenUnset", "ValueWhenUnset", properties.ValueWhenUnset != null ? CfnTemplateStringValueWhenUnsetConfigurationPropertyFromCloudFormation(properties.ValueWhenUnset) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_StringValueWhenUnsetConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customValue", cdk.validateString)(properties.customValue)), errors.collect(cdk.propertyValidator("valueWhenUnsetOption", cdk.validateString)(properties.valueWhenUnsetOption)), errors.wrap('supplied properties not correct for "StringValueWhenUnsetConfigurationProperty"');
    }
    function cfnTemplateStringValueWhenUnsetConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_StringValueWhenUnsetConfigurationPropertyValidator(properties).assertSuccess(), { CustomValue: cdk.stringToCloudFormation(properties.customValue), ValueWhenUnsetOption: cdk.stringToCloudFormation(properties.valueWhenUnsetOption) }) : properties;
    }
    function CfnTemplateStringValueWhenUnsetConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customValue", "CustomValue", properties.CustomValue != null ? cfn_parse.FromCloudFormation.getString(properties.CustomValue) : void 0), ret.addPropertyResult("valueWhenUnsetOption", "ValueWhenUnsetOption", properties.ValueWhenUnsetOption != null ? cfn_parse.FromCloudFormation.getString(properties.ValueWhenUnsetOption) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_SubtotalOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customLabel", cdk.validateString)(properties.customLabel)), errors.collect(cdk.propertyValidator("fieldLevel", cdk.validateString)(properties.fieldLevel)), errors.collect(cdk.propertyValidator("fieldLevelOptions", cdk.listValidator(CfnTemplate_PivotTableFieldSubtotalOptionsPropertyValidator))(properties.fieldLevelOptions)), errors.collect(cdk.propertyValidator("metricHeaderCellStyle", CfnTemplate_TableCellStylePropertyValidator)(properties.metricHeaderCellStyle)), errors.collect(cdk.propertyValidator("totalCellStyle", CfnTemplate_TableCellStylePropertyValidator)(properties.totalCellStyle)), errors.collect(cdk.propertyValidator("totalsVisibility", cdk.validateString)(properties.totalsVisibility)), errors.collect(cdk.propertyValidator("valueCellStyle", CfnTemplate_TableCellStylePropertyValidator)(properties.valueCellStyle)), errors.wrap('supplied properties not correct for "SubtotalOptionsProperty"');
    }
    function cfnTemplateSubtotalOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_SubtotalOptionsPropertyValidator(properties).assertSuccess(), { CustomLabel: cdk.stringToCloudFormation(properties.customLabel), FieldLevel: cdk.stringToCloudFormation(properties.fieldLevel), FieldLevelOptions: cdk.listMapper(cfnTemplatePivotTableFieldSubtotalOptionsPropertyToCloudFormation)(properties.fieldLevelOptions), MetricHeaderCellStyle: cfnTemplateTableCellStylePropertyToCloudFormation(properties.metricHeaderCellStyle), TotalCellStyle: cfnTemplateTableCellStylePropertyToCloudFormation(properties.totalCellStyle), TotalsVisibility: cdk.stringToCloudFormation(properties.totalsVisibility), ValueCellStyle: cfnTemplateTableCellStylePropertyToCloudFormation(properties.valueCellStyle) }) : properties;
    }
    function CfnTemplateSubtotalOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customLabel", "CustomLabel", properties.CustomLabel != null ? cfn_parse.FromCloudFormation.getString(properties.CustomLabel) : void 0), ret.addPropertyResult("fieldLevel", "FieldLevel", properties.FieldLevel != null ? cfn_parse.FromCloudFormation.getString(properties.FieldLevel) : void 0), ret.addPropertyResult("fieldLevelOptions", "FieldLevelOptions", properties.FieldLevelOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplatePivotTableFieldSubtotalOptionsPropertyFromCloudFormation)(properties.FieldLevelOptions) : void 0), ret.addPropertyResult("metricHeaderCellStyle", "MetricHeaderCellStyle", properties.MetricHeaderCellStyle != null ? CfnTemplateTableCellStylePropertyFromCloudFormation(properties.MetricHeaderCellStyle) : void 0), ret.addPropertyResult("totalCellStyle", "TotalCellStyle", properties.TotalCellStyle != null ? CfnTemplateTableCellStylePropertyFromCloudFormation(properties.TotalCellStyle) : void 0), ret.addPropertyResult("totalsVisibility", "TotalsVisibility", properties.TotalsVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.TotalsVisibility) : void 0), ret.addPropertyResult("valueCellStyle", "ValueCellStyle", properties.ValueCellStyle != null ? CfnTemplateTableCellStylePropertyFromCloudFormation(properties.ValueCellStyle) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TableAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groupBy", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.groupBy)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnTemplate_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "TableAggregatedFieldWellsProperty"');
    }
    function cfnTemplateTableAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TableAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { GroupBy: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.groupBy), Values: cdk.listMapper(cfnTemplateMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnTemplateTableAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupBy", "GroupBy", properties.GroupBy != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.GroupBy) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TableBorderOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("color", cdk.validateString)(properties.color)), errors.collect(cdk.propertyValidator("style", cdk.validateString)(properties.style)), errors.collect(cdk.propertyValidator("thickness", cdk.validateNumber)(properties.thickness)), errors.wrap('supplied properties not correct for "TableBorderOptionsProperty"');
    }
    function cfnTemplateTableBorderOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TableBorderOptionsPropertyValidator(properties).assertSuccess(), { Color: cdk.stringToCloudFormation(properties.color), Style: cdk.stringToCloudFormation(properties.style), Thickness: cdk.numberToCloudFormation(properties.thickness) }) : properties;
    }
    function CfnTemplateTableBorderOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("color", "Color", properties.Color != null ? cfn_parse.FromCloudFormation.getString(properties.Color) : void 0), ret.addPropertyResult("style", "Style", properties.Style != null ? cfn_parse.FromCloudFormation.getString(properties.Style) : void 0), ret.addPropertyResult("thickness", "Thickness", properties.Thickness != null ? cfn_parse.FromCloudFormation.getNumber(properties.Thickness) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TableCellConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("textFormat", CfnTemplate_TextConditionalFormatPropertyValidator)(properties.textFormat)), errors.wrap('supplied properties not correct for "TableCellConditionalFormattingProperty"');
    }
    function cfnTemplateTableCellConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TableCellConditionalFormattingPropertyValidator(properties).assertSuccess(), { FieldId: cdk.stringToCloudFormation(properties.fieldId), TextFormat: cfnTemplateTextConditionalFormatPropertyToCloudFormation(properties.textFormat) }) : properties;
    }
    function CfnTemplateTableCellConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("textFormat", "TextFormat", properties.TextFormat != null ? CfnTemplateTextConditionalFormatPropertyFromCloudFormation(properties.TextFormat) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TableCellImageSizingConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("tableCellImageScalingConfiguration", cdk.validateString)(properties.tableCellImageScalingConfiguration)), errors.wrap('supplied properties not correct for "TableCellImageSizingConfigurationProperty"');
    }
    function cfnTemplateTableCellImageSizingConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TableCellImageSizingConfigurationPropertyValidator(properties).assertSuccess(), { TableCellImageScalingConfiguration: cdk.stringToCloudFormation(properties.tableCellImageScalingConfiguration) }) : properties;
    }
    function CfnTemplateTableCellImageSizingConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("tableCellImageScalingConfiguration", "TableCellImageScalingConfiguration", properties.TableCellImageScalingConfiguration != null ? cfn_parse.FromCloudFormation.getString(properties.TableCellImageScalingConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TableCellStylePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("backgroundColor", cdk.validateString)(properties.backgroundColor)), errors.collect(cdk.propertyValidator("border", CfnTemplate_GlobalTableBorderOptionsPropertyValidator)(properties.border)), errors.collect(cdk.propertyValidator("fontConfiguration", CfnTemplate_FontConfigurationPropertyValidator)(properties.fontConfiguration)), errors.collect(cdk.propertyValidator("height", cdk.validateNumber)(properties.height)), errors.collect(cdk.propertyValidator("horizontalTextAlignment", cdk.validateString)(properties.horizontalTextAlignment)), errors.collect(cdk.propertyValidator("textWrap", cdk.validateString)(properties.textWrap)), errors.collect(cdk.propertyValidator("verticalTextAlignment", cdk.validateString)(properties.verticalTextAlignment)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "TableCellStyleProperty"');
    }
    function cfnTemplateTableCellStylePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TableCellStylePropertyValidator(properties).assertSuccess(), { BackgroundColor: cdk.stringToCloudFormation(properties.backgroundColor), Border: cfnTemplateGlobalTableBorderOptionsPropertyToCloudFormation(properties.border), FontConfiguration: cfnTemplateFontConfigurationPropertyToCloudFormation(properties.fontConfiguration), Height: cdk.numberToCloudFormation(properties.height), HorizontalTextAlignment: cdk.stringToCloudFormation(properties.horizontalTextAlignment), TextWrap: cdk.stringToCloudFormation(properties.textWrap), VerticalTextAlignment: cdk.stringToCloudFormation(properties.verticalTextAlignment), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnTemplateTableCellStylePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("backgroundColor", "BackgroundColor", properties.BackgroundColor != null ? cfn_parse.FromCloudFormation.getString(properties.BackgroundColor) : void 0), ret.addPropertyResult("border", "Border", properties.Border != null ? CfnTemplateGlobalTableBorderOptionsPropertyFromCloudFormation(properties.Border) : void 0), ret.addPropertyResult("fontConfiguration", "FontConfiguration", properties.FontConfiguration != null ? CfnTemplateFontConfigurationPropertyFromCloudFormation(properties.FontConfiguration) : void 0), ret.addPropertyResult("height", "Height", properties.Height != null ? cfn_parse.FromCloudFormation.getNumber(properties.Height) : void 0), ret.addPropertyResult("horizontalTextAlignment", "HorizontalTextAlignment", properties.HorizontalTextAlignment != null ? cfn_parse.FromCloudFormation.getString(properties.HorizontalTextAlignment) : void 0), ret.addPropertyResult("textWrap", "TextWrap", properties.TextWrap != null ? cfn_parse.FromCloudFormation.getString(properties.TextWrap) : void 0), ret.addPropertyResult("verticalTextAlignment", "VerticalTextAlignment", properties.VerticalTextAlignment != null ? cfn_parse.FromCloudFormation.getString(properties.VerticalTextAlignment) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TableConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("conditionalFormattingOptions", cdk.listValidator(CfnTemplate_TableConditionalFormattingOptionPropertyValidator))(properties.conditionalFormattingOptions)), errors.wrap('supplied properties not correct for "TableConditionalFormattingProperty"');
    }
    function cfnTemplateTableConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TableConditionalFormattingPropertyValidator(properties).assertSuccess(), { ConditionalFormattingOptions: cdk.listMapper(cfnTemplateTableConditionalFormattingOptionPropertyToCloudFormation)(properties.conditionalFormattingOptions) }) : properties;
    }
    function CfnTemplateTableConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("conditionalFormattingOptions", "ConditionalFormattingOptions", properties.ConditionalFormattingOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateTableConditionalFormattingOptionPropertyFromCloudFormation)(properties.ConditionalFormattingOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TableConditionalFormattingOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cell", CfnTemplate_TableCellConditionalFormattingPropertyValidator)(properties.cell)), errors.collect(cdk.propertyValidator("row", CfnTemplate_TableRowConditionalFormattingPropertyValidator)(properties.row)), errors.wrap('supplied properties not correct for "TableConditionalFormattingOptionProperty"');
    }
    function cfnTemplateTableConditionalFormattingOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TableConditionalFormattingOptionPropertyValidator(properties).assertSuccess(), { Cell: cfnTemplateTableCellConditionalFormattingPropertyToCloudFormation(properties.cell), Row: cfnTemplateTableRowConditionalFormattingPropertyToCloudFormation(properties.row) }) : properties;
    }
    function CfnTemplateTableConditionalFormattingOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cell", "Cell", properties.Cell != null ? CfnTemplateTableCellConditionalFormattingPropertyFromCloudFormation(properties.Cell) : void 0), ret.addPropertyResult("row", "Row", properties.Row != null ? CfnTemplateTableRowConditionalFormattingPropertyFromCloudFormation(properties.Row) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TableConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldOptions", CfnTemplate_TableFieldOptionsPropertyValidator)(properties.fieldOptions)), errors.collect(cdk.propertyValidator("fieldWells", CfnTemplate_TableFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("paginatedReportOptions", CfnTemplate_TablePaginatedReportOptionsPropertyValidator)(properties.paginatedReportOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnTemplate_TableSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tableInlineVisualizations", cdk.listValidator(CfnTemplate_TableInlineVisualizationPropertyValidator))(properties.tableInlineVisualizations)), errors.collect(cdk.propertyValidator("tableOptions", CfnTemplate_TableOptionsPropertyValidator)(properties.tableOptions)), errors.collect(cdk.propertyValidator("totalOptions", CfnTemplate_TotalOptionsPropertyValidator)(properties.totalOptions)), errors.wrap('supplied properties not correct for "TableConfigurationProperty"');
    }
    function cfnTemplateTableConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TableConfigurationPropertyValidator(properties).assertSuccess(), { FieldOptions: cfnTemplateTableFieldOptionsPropertyToCloudFormation(properties.fieldOptions), FieldWells: cfnTemplateTableFieldWellsPropertyToCloudFormation(properties.fieldWells), PaginatedReportOptions: cfnTemplateTablePaginatedReportOptionsPropertyToCloudFormation(properties.paginatedReportOptions), SortConfiguration: cfnTemplateTableSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), TableInlineVisualizations: cdk.listMapper(cfnTemplateTableInlineVisualizationPropertyToCloudFormation)(properties.tableInlineVisualizations), TableOptions: cfnTemplateTableOptionsPropertyToCloudFormation(properties.tableOptions), TotalOptions: cfnTemplateTotalOptionsPropertyToCloudFormation(properties.totalOptions) }) : properties;
    }
    function CfnTemplateTableConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldOptions", "FieldOptions", properties.FieldOptions != null ? CfnTemplateTableFieldOptionsPropertyFromCloudFormation(properties.FieldOptions) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnTemplateTableFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("paginatedReportOptions", "PaginatedReportOptions", properties.PaginatedReportOptions != null ? CfnTemplateTablePaginatedReportOptionsPropertyFromCloudFormation(properties.PaginatedReportOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnTemplateTableSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tableInlineVisualizations", "TableInlineVisualizations", properties.TableInlineVisualizations != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateTableInlineVisualizationPropertyFromCloudFormation)(properties.TableInlineVisualizations) : void 0), ret.addPropertyResult("tableOptions", "TableOptions", properties.TableOptions != null ? CfnTemplateTableOptionsPropertyFromCloudFormation(properties.TableOptions) : void 0), ret.addPropertyResult("totalOptions", "TotalOptions", properties.TotalOptions != null ? CfnTemplateTotalOptionsPropertyFromCloudFormation(properties.TotalOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TableFieldCustomIconContentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("icon", cdk.validateString)(properties.icon)), errors.wrap('supplied properties not correct for "TableFieldCustomIconContentProperty"');
    }
    function cfnTemplateTableFieldCustomIconContentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TableFieldCustomIconContentPropertyValidator(properties).assertSuccess(), { Icon: cdk.stringToCloudFormation(properties.icon) }) : properties;
    }
    function CfnTemplateTableFieldCustomIconContentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("icon", "Icon", properties.Icon != null ? cfn_parse.FromCloudFormation.getString(properties.Icon) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TableFieldCustomTextContentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fontConfiguration", cdk.requiredValidator)(properties.fontConfiguration)), errors.collect(cdk.propertyValidator("fontConfiguration", CfnTemplate_FontConfigurationPropertyValidator)(properties.fontConfiguration)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TableFieldCustomTextContentProperty"');
    }
    function cfnTemplateTableFieldCustomTextContentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TableFieldCustomTextContentPropertyValidator(properties).assertSuccess(), { FontConfiguration: cfnTemplateFontConfigurationPropertyToCloudFormation(properties.fontConfiguration), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnTemplateTableFieldCustomTextContentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fontConfiguration", "FontConfiguration", CfnTemplateFontConfigurationPropertyFromCloudFormation(properties.FontConfiguration)), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TableFieldImageConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sizingOptions", CfnTemplate_TableCellImageSizingConfigurationPropertyValidator)(properties.sizingOptions)), errors.wrap('supplied properties not correct for "TableFieldImageConfigurationProperty"');
    }
    function cfnTemplateTableFieldImageConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TableFieldImageConfigurationPropertyValidator(properties).assertSuccess(), { SizingOptions: cfnTemplateTableCellImageSizingConfigurationPropertyToCloudFormation(properties.sizingOptions) }) : properties;
    }
    function CfnTemplateTableFieldImageConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sizingOptions", "SizingOptions", properties.SizingOptions != null ? CfnTemplateTableCellImageSizingConfigurationPropertyFromCloudFormation(properties.SizingOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TableFieldLinkConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("content", cdk.requiredValidator)(properties.content)), errors.collect(cdk.propertyValidator("content", CfnTemplate_TableFieldLinkContentConfigurationPropertyValidator)(properties.content)), errors.collect(cdk.propertyValidator("target", cdk.requiredValidator)(properties.target)), errors.collect(cdk.propertyValidator("target", cdk.validateString)(properties.target)), errors.wrap('supplied properties not correct for "TableFieldLinkConfigurationProperty"');
    }
    function cfnTemplateTableFieldLinkConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TableFieldLinkConfigurationPropertyValidator(properties).assertSuccess(), { Content: cfnTemplateTableFieldLinkContentConfigurationPropertyToCloudFormation(properties.content), Target: cdk.stringToCloudFormation(properties.target) }) : properties;
    }
    function CfnTemplateTableFieldLinkConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("content", "Content", CfnTemplateTableFieldLinkContentConfigurationPropertyFromCloudFormation(properties.Content)), ret.addPropertyResult("target", "Target", cfn_parse.FromCloudFormation.getString(properties.Target)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TableFieldLinkContentConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customIconContent", CfnTemplate_TableFieldCustomIconContentPropertyValidator)(properties.customIconContent)), errors.collect(cdk.propertyValidator("customTextContent", CfnTemplate_TableFieldCustomTextContentPropertyValidator)(properties.customTextContent)), errors.wrap('supplied properties not correct for "TableFieldLinkContentConfigurationProperty"');
    }
    function cfnTemplateTableFieldLinkContentConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TableFieldLinkContentConfigurationPropertyValidator(properties).assertSuccess(), { CustomIconContent: cfnTemplateTableFieldCustomIconContentPropertyToCloudFormation(properties.customIconContent), CustomTextContent: cfnTemplateTableFieldCustomTextContentPropertyToCloudFormation(properties.customTextContent) }) : properties;
    }
    function CfnTemplateTableFieldLinkContentConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customIconContent", "CustomIconContent", properties.CustomIconContent != null ? CfnTemplateTableFieldCustomIconContentPropertyFromCloudFormation(properties.CustomIconContent) : void 0), ret.addPropertyResult("customTextContent", "CustomTextContent", properties.CustomTextContent != null ? CfnTemplateTableFieldCustomTextContentPropertyFromCloudFormation(properties.CustomTextContent) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TableFieldOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customLabel", cdk.validateString)(properties.customLabel)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("urlStyling", CfnTemplate_TableFieldURLConfigurationPropertyValidator)(properties.urlStyling)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.collect(cdk.propertyValidator("width", cdk.validateString)(properties.width)), errors.wrap('supplied properties not correct for "TableFieldOptionProperty"');
    }
    function cfnTemplateTableFieldOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TableFieldOptionPropertyValidator(properties).assertSuccess(), { CustomLabel: cdk.stringToCloudFormation(properties.customLabel), FieldId: cdk.stringToCloudFormation(properties.fieldId), URLStyling: cfnTemplateTableFieldURLConfigurationPropertyToCloudFormation(properties.urlStyling), Visibility: cdk.stringToCloudFormation(properties.visibility), Width: cdk.stringToCloudFormation(properties.width) }) : properties;
    }
    function CfnTemplateTableFieldOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customLabel", "CustomLabel", properties.CustomLabel != null ? cfn_parse.FromCloudFormation.getString(properties.CustomLabel) : void 0), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("urlStyling", "URLStyling", properties.URLStyling != null ? CfnTemplateTableFieldURLConfigurationPropertyFromCloudFormation(properties.URLStyling) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addPropertyResult("width", "Width", properties.Width != null ? cfn_parse.FromCloudFormation.getString(properties.Width) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TableFieldOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("order", cdk.listValidator(cdk.validateString))(properties.order)), errors.collect(cdk.propertyValidator("selectedFieldOptions", cdk.listValidator(CfnTemplate_TableFieldOptionPropertyValidator))(properties.selectedFieldOptions)), errors.wrap('supplied properties not correct for "TableFieldOptionsProperty"');
    }
    function cfnTemplateTableFieldOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TableFieldOptionsPropertyValidator(properties).assertSuccess(), { Order: cdk.listMapper(cdk.stringToCloudFormation)(properties.order), SelectedFieldOptions: cdk.listMapper(cfnTemplateTableFieldOptionPropertyToCloudFormation)(properties.selectedFieldOptions) }) : properties;
    }
    function CfnTemplateTableFieldOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("order", "Order", properties.Order != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Order) : void 0), ret.addPropertyResult("selectedFieldOptions", "SelectedFieldOptions", properties.SelectedFieldOptions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateTableFieldOptionPropertyFromCloudFormation)(properties.SelectedFieldOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TableFieldURLConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("imageConfiguration", CfnTemplate_TableFieldImageConfigurationPropertyValidator)(properties.imageConfiguration)), errors.collect(cdk.propertyValidator("linkConfiguration", CfnTemplate_TableFieldLinkConfigurationPropertyValidator)(properties.linkConfiguration)), errors.wrap('supplied properties not correct for "TableFieldURLConfigurationProperty"');
    }
    function cfnTemplateTableFieldURLConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TableFieldURLConfigurationPropertyValidator(properties).assertSuccess(), { ImageConfiguration: cfnTemplateTableFieldImageConfigurationPropertyToCloudFormation(properties.imageConfiguration), LinkConfiguration: cfnTemplateTableFieldLinkConfigurationPropertyToCloudFormation(properties.linkConfiguration) }) : properties;
    }
    function CfnTemplateTableFieldURLConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("imageConfiguration", "ImageConfiguration", properties.ImageConfiguration != null ? CfnTemplateTableFieldImageConfigurationPropertyFromCloudFormation(properties.ImageConfiguration) : void 0), ret.addPropertyResult("linkConfiguration", "LinkConfiguration", properties.LinkConfiguration != null ? CfnTemplateTableFieldLinkConfigurationPropertyFromCloudFormation(properties.LinkConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TableFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("tableAggregatedFieldWells", CfnTemplate_TableAggregatedFieldWellsPropertyValidator)(properties.tableAggregatedFieldWells)), errors.collect(cdk.propertyValidator("tableUnaggregatedFieldWells", CfnTemplate_TableUnaggregatedFieldWellsPropertyValidator)(properties.tableUnaggregatedFieldWells)), errors.wrap('supplied properties not correct for "TableFieldWellsProperty"');
    }
    function cfnTemplateTableFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TableFieldWellsPropertyValidator(properties).assertSuccess(), { TableAggregatedFieldWells: cfnTemplateTableAggregatedFieldWellsPropertyToCloudFormation(properties.tableAggregatedFieldWells), TableUnaggregatedFieldWells: cfnTemplateTableUnaggregatedFieldWellsPropertyToCloudFormation(properties.tableUnaggregatedFieldWells) }) : properties;
    }
    function CfnTemplateTableFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("tableAggregatedFieldWells", "TableAggregatedFieldWells", properties.TableAggregatedFieldWells != null ? CfnTemplateTableAggregatedFieldWellsPropertyFromCloudFormation(properties.TableAggregatedFieldWells) : void 0), ret.addPropertyResult("tableUnaggregatedFieldWells", "TableUnaggregatedFieldWells", properties.TableUnaggregatedFieldWells != null ? CfnTemplateTableUnaggregatedFieldWellsPropertyFromCloudFormation(properties.TableUnaggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TableInlineVisualizationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataBars", CfnTemplate_DataBarsOptionsPropertyValidator)(properties.dataBars)), errors.wrap('supplied properties not correct for "TableInlineVisualizationProperty"');
    }
    function cfnTemplateTableInlineVisualizationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TableInlineVisualizationPropertyValidator(properties).assertSuccess(), { DataBars: cfnTemplateDataBarsOptionsPropertyToCloudFormation(properties.dataBars) }) : properties;
    }
    function CfnTemplateTableInlineVisualizationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataBars", "DataBars", properties.DataBars != null ? CfnTemplateDataBarsOptionsPropertyFromCloudFormation(properties.DataBars) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TableOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cellStyle", CfnTemplate_TableCellStylePropertyValidator)(properties.cellStyle)), errors.collect(cdk.propertyValidator("headerStyle", CfnTemplate_TableCellStylePropertyValidator)(properties.headerStyle)), errors.collect(cdk.propertyValidator("orientation", cdk.validateString)(properties.orientation)), errors.collect(cdk.propertyValidator("rowAlternateColorOptions", CfnTemplate_RowAlternateColorOptionsPropertyValidator)(properties.rowAlternateColorOptions)), errors.wrap('supplied properties not correct for "TableOptionsProperty"');
    }
    function cfnTemplateTableOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TableOptionsPropertyValidator(properties).assertSuccess(), { CellStyle: cfnTemplateTableCellStylePropertyToCloudFormation(properties.cellStyle), HeaderStyle: cfnTemplateTableCellStylePropertyToCloudFormation(properties.headerStyle), Orientation: cdk.stringToCloudFormation(properties.orientation), RowAlternateColorOptions: cfnTemplateRowAlternateColorOptionsPropertyToCloudFormation(properties.rowAlternateColorOptions) }) : properties;
    }
    function CfnTemplateTableOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cellStyle", "CellStyle", properties.CellStyle != null ? CfnTemplateTableCellStylePropertyFromCloudFormation(properties.CellStyle) : void 0), ret.addPropertyResult("headerStyle", "HeaderStyle", properties.HeaderStyle != null ? CfnTemplateTableCellStylePropertyFromCloudFormation(properties.HeaderStyle) : void 0), ret.addPropertyResult("orientation", "Orientation", properties.Orientation != null ? cfn_parse.FromCloudFormation.getString(properties.Orientation) : void 0), ret.addPropertyResult("rowAlternateColorOptions", "RowAlternateColorOptions", properties.RowAlternateColorOptions != null ? CfnTemplateRowAlternateColorOptionsPropertyFromCloudFormation(properties.RowAlternateColorOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TablePaginatedReportOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("overflowColumnHeaderVisibility", cdk.validateString)(properties.overflowColumnHeaderVisibility)), errors.collect(cdk.propertyValidator("verticalOverflowVisibility", cdk.validateString)(properties.verticalOverflowVisibility)), errors.wrap('supplied properties not correct for "TablePaginatedReportOptionsProperty"');
    }
    function cfnTemplateTablePaginatedReportOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TablePaginatedReportOptionsPropertyValidator(properties).assertSuccess(), { OverflowColumnHeaderVisibility: cdk.stringToCloudFormation(properties.overflowColumnHeaderVisibility), VerticalOverflowVisibility: cdk.stringToCloudFormation(properties.verticalOverflowVisibility) }) : properties;
    }
    function CfnTemplateTablePaginatedReportOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("overflowColumnHeaderVisibility", "OverflowColumnHeaderVisibility", properties.OverflowColumnHeaderVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.OverflowColumnHeaderVisibility) : void 0), ret.addPropertyResult("verticalOverflowVisibility", "VerticalOverflowVisibility", properties.VerticalOverflowVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.VerticalOverflowVisibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TableRowConditionalFormattingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("backgroundColor", CfnTemplate_ConditionalFormattingColorPropertyValidator)(properties.backgroundColor)), errors.collect(cdk.propertyValidator("textColor", CfnTemplate_ConditionalFormattingColorPropertyValidator)(properties.textColor)), errors.wrap('supplied properties not correct for "TableRowConditionalFormattingProperty"');
    }
    function cfnTemplateTableRowConditionalFormattingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TableRowConditionalFormattingPropertyValidator(properties).assertSuccess(), { BackgroundColor: cfnTemplateConditionalFormattingColorPropertyToCloudFormation(properties.backgroundColor), TextColor: cfnTemplateConditionalFormattingColorPropertyToCloudFormation(properties.textColor) }) : properties;
    }
    function CfnTemplateTableRowConditionalFormattingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("backgroundColor", "BackgroundColor", properties.BackgroundColor != null ? CfnTemplateConditionalFormattingColorPropertyFromCloudFormation(properties.BackgroundColor) : void 0), ret.addPropertyResult("textColor", "TextColor", properties.TextColor != null ? CfnTemplateConditionalFormattingColorPropertyFromCloudFormation(properties.TextColor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TableSideBorderOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bottom", CfnTemplate_TableBorderOptionsPropertyValidator)(properties.bottom)), errors.collect(cdk.propertyValidator("innerHorizontal", CfnTemplate_TableBorderOptionsPropertyValidator)(properties.innerHorizontal)), errors.collect(cdk.propertyValidator("innerVertical", CfnTemplate_TableBorderOptionsPropertyValidator)(properties.innerVertical)), errors.collect(cdk.propertyValidator("left", CfnTemplate_TableBorderOptionsPropertyValidator)(properties.left)), errors.collect(cdk.propertyValidator("right", CfnTemplate_TableBorderOptionsPropertyValidator)(properties.right)), errors.collect(cdk.propertyValidator("top", CfnTemplate_TableBorderOptionsPropertyValidator)(properties.top)), errors.wrap('supplied properties not correct for "TableSideBorderOptionsProperty"');
    }
    function cfnTemplateTableSideBorderOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TableSideBorderOptionsPropertyValidator(properties).assertSuccess(), { Bottom: cfnTemplateTableBorderOptionsPropertyToCloudFormation(properties.bottom), InnerHorizontal: cfnTemplateTableBorderOptionsPropertyToCloudFormation(properties.innerHorizontal), InnerVertical: cfnTemplateTableBorderOptionsPropertyToCloudFormation(properties.innerVertical), Left: cfnTemplateTableBorderOptionsPropertyToCloudFormation(properties.left), Right: cfnTemplateTableBorderOptionsPropertyToCloudFormation(properties.right), Top: cfnTemplateTableBorderOptionsPropertyToCloudFormation(properties.top) }) : properties;
    }
    function CfnTemplateTableSideBorderOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bottom", "Bottom", properties.Bottom != null ? CfnTemplateTableBorderOptionsPropertyFromCloudFormation(properties.Bottom) : void 0), ret.addPropertyResult("innerHorizontal", "InnerHorizontal", properties.InnerHorizontal != null ? CfnTemplateTableBorderOptionsPropertyFromCloudFormation(properties.InnerHorizontal) : void 0), ret.addPropertyResult("innerVertical", "InnerVertical", properties.InnerVertical != null ? CfnTemplateTableBorderOptionsPropertyFromCloudFormation(properties.InnerVertical) : void 0), ret.addPropertyResult("left", "Left", properties.Left != null ? CfnTemplateTableBorderOptionsPropertyFromCloudFormation(properties.Left) : void 0), ret.addPropertyResult("right", "Right", properties.Right != null ? CfnTemplateTableBorderOptionsPropertyFromCloudFormation(properties.Right) : void 0), ret.addPropertyResult("top", "Top", properties.Top != null ? CfnTemplateTableBorderOptionsPropertyFromCloudFormation(properties.Top) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TableSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("paginationConfiguration", CfnTemplate_PaginationConfigurationPropertyValidator)(properties.paginationConfiguration)), errors.collect(cdk.propertyValidator("rowSort", cdk.listValidator(CfnTemplate_FieldSortOptionsPropertyValidator))(properties.rowSort)), errors.wrap('supplied properties not correct for "TableSortConfigurationProperty"');
    }
    function cfnTemplateTableSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TableSortConfigurationPropertyValidator(properties).assertSuccess(), { PaginationConfiguration: cfnTemplatePaginationConfigurationPropertyToCloudFormation(properties.paginationConfiguration), RowSort: cdk.listMapper(cfnTemplateFieldSortOptionsPropertyToCloudFormation)(properties.rowSort) }) : properties;
    }
    function CfnTemplateTableSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("paginationConfiguration", "PaginationConfiguration", properties.PaginationConfiguration != null ? CfnTemplatePaginationConfigurationPropertyFromCloudFormation(properties.PaginationConfiguration) : void 0), ret.addPropertyResult("rowSort", "RowSort", properties.RowSort != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateFieldSortOptionsPropertyFromCloudFormation)(properties.RowSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TableUnaggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnTemplate_UnaggregatedFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "TableUnaggregatedFieldWellsProperty"');
    }
    function cfnTemplateTableUnaggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TableUnaggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Values: cdk.listMapper(cfnTemplateUnaggregatedFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnTemplateTableUnaggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateUnaggregatedFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TableVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnTemplate_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnTemplate_TableConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("conditionalFormatting", CfnTemplate_TableConditionalFormattingPropertyValidator)(properties.conditionalFormatting)), errors.collect(cdk.propertyValidator("subtitle", CfnTemplate_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnTemplate_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "TableVisualProperty"');
    }
    function cfnTemplateTableVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TableVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnTemplateVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnTemplateTableConfigurationPropertyToCloudFormation(properties.chartConfiguration), ConditionalFormatting: cfnTemplateTableConditionalFormattingPropertyToCloudFormation(properties.conditionalFormatting), Subtitle: cfnTemplateVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnTemplateVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnTemplateTableVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnTemplateTableConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("conditionalFormatting", "ConditionalFormatting", properties.ConditionalFormatting != null ? CfnTemplateTableConditionalFormattingPropertyFromCloudFormation(properties.ConditionalFormatting) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnTemplateVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnTemplateVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TemplateSourceAnalysisPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.requiredValidator)(properties.arn)), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("dataSetReferences", cdk.requiredValidator)(properties.dataSetReferences)), errors.collect(cdk.propertyValidator("dataSetReferences", cdk.listValidator(CfnTemplate_DataSetReferencePropertyValidator))(properties.dataSetReferences)), errors.wrap('supplied properties not correct for "TemplateSourceAnalysisProperty"');
    }
    function cfnTemplateTemplateSourceAnalysisPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TemplateSourceAnalysisPropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn), DataSetReferences: cdk.listMapper(cfnTemplateDataSetReferencePropertyToCloudFormation)(properties.dataSetReferences) }) : properties;
    }
    function CfnTemplateTemplateSourceAnalysisPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", cfn_parse.FromCloudFormation.getString(properties.Arn)), ret.addPropertyResult("dataSetReferences", "DataSetReferences", cfn_parse.FromCloudFormation.getArray(CfnTemplateDataSetReferencePropertyFromCloudFormation)(properties.DataSetReferences)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TemplateSourceEntityPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sourceAnalysis", CfnTemplate_TemplateSourceAnalysisPropertyValidator)(properties.sourceAnalysis)), errors.collect(cdk.propertyValidator("sourceTemplate", CfnTemplate_TemplateSourceTemplatePropertyValidator)(properties.sourceTemplate)), errors.wrap('supplied properties not correct for "TemplateSourceEntityProperty"');
    }
    function cfnTemplateTemplateSourceEntityPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TemplateSourceEntityPropertyValidator(properties).assertSuccess(), { SourceAnalysis: cfnTemplateTemplateSourceAnalysisPropertyToCloudFormation(properties.sourceAnalysis), SourceTemplate: cfnTemplateTemplateSourceTemplatePropertyToCloudFormation(properties.sourceTemplate) }) : properties;
    }
    function CfnTemplateTemplateSourceEntityPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sourceAnalysis", "SourceAnalysis", properties.SourceAnalysis != null ? CfnTemplateTemplateSourceAnalysisPropertyFromCloudFormation(properties.SourceAnalysis) : void 0), ret.addPropertyResult("sourceTemplate", "SourceTemplate", properties.SourceTemplate != null ? CfnTemplateTemplateSourceTemplatePropertyFromCloudFormation(properties.SourceTemplate) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TemplateSourceTemplatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.requiredValidator)(properties.arn)), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.wrap('supplied properties not correct for "TemplateSourceTemplateProperty"');
    }
    function cfnTemplateTemplateSourceTemplatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TemplateSourceTemplatePropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn) }) : properties;
    }
    function CfnTemplateTemplateSourceTemplatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", cfn_parse.FromCloudFormation.getString(properties.Arn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TemplateVersionDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("analysisDefaults", CfnTemplate_AnalysisDefaultsPropertyValidator)(properties.analysisDefaults)), errors.collect(cdk.propertyValidator("calculatedFields", cdk.listValidator(CfnTemplate_CalculatedFieldPropertyValidator))(properties.calculatedFields)), errors.collect(cdk.propertyValidator("columnConfigurations", cdk.listValidator(CfnTemplate_ColumnConfigurationPropertyValidator))(properties.columnConfigurations)), errors.collect(cdk.propertyValidator("dataSetConfigurations", cdk.requiredValidator)(properties.dataSetConfigurations)), errors.collect(cdk.propertyValidator("dataSetConfigurations", cdk.listValidator(CfnTemplate_DataSetConfigurationPropertyValidator))(properties.dataSetConfigurations)), errors.collect(cdk.propertyValidator("filterGroups", cdk.listValidator(CfnTemplate_FilterGroupPropertyValidator))(properties.filterGroups)), errors.collect(cdk.propertyValidator("parameterDeclarations", cdk.listValidator(CfnTemplate_ParameterDeclarationPropertyValidator))(properties.parameterDeclarations)), errors.collect(cdk.propertyValidator("sheets", cdk.listValidator(CfnTemplate_SheetDefinitionPropertyValidator))(properties.sheets)), errors.wrap('supplied properties not correct for "TemplateVersionDefinitionProperty"');
    }
    function cfnTemplateTemplateVersionDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TemplateVersionDefinitionPropertyValidator(properties).assertSuccess(), { AnalysisDefaults: cfnTemplateAnalysisDefaultsPropertyToCloudFormation(properties.analysisDefaults), CalculatedFields: cdk.listMapper(cfnTemplateCalculatedFieldPropertyToCloudFormation)(properties.calculatedFields), ColumnConfigurations: cdk.listMapper(cfnTemplateColumnConfigurationPropertyToCloudFormation)(properties.columnConfigurations), DataSetConfigurations: cdk.listMapper(cfnTemplateDataSetConfigurationPropertyToCloudFormation)(properties.dataSetConfigurations), FilterGroups: cdk.listMapper(cfnTemplateFilterGroupPropertyToCloudFormation)(properties.filterGroups), ParameterDeclarations: cdk.listMapper(cfnTemplateParameterDeclarationPropertyToCloudFormation)(properties.parameterDeclarations), Sheets: cdk.listMapper(cfnTemplateSheetDefinitionPropertyToCloudFormation)(properties.sheets) }) : properties;
    }
    function CfnTemplateTemplateVersionDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("analysisDefaults", "AnalysisDefaults", properties.AnalysisDefaults != null ? CfnTemplateAnalysisDefaultsPropertyFromCloudFormation(properties.AnalysisDefaults) : void 0), ret.addPropertyResult("calculatedFields", "CalculatedFields", properties.CalculatedFields != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateCalculatedFieldPropertyFromCloudFormation)(properties.CalculatedFields) : void 0), ret.addPropertyResult("columnConfigurations", "ColumnConfigurations", properties.ColumnConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateColumnConfigurationPropertyFromCloudFormation)(properties.ColumnConfigurations) : void 0), ret.addPropertyResult("dataSetConfigurations", "DataSetConfigurations", cfn_parse.FromCloudFormation.getArray(CfnTemplateDataSetConfigurationPropertyFromCloudFormation)(properties.DataSetConfigurations)), ret.addPropertyResult("filterGroups", "FilterGroups", properties.FilterGroups != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateFilterGroupPropertyFromCloudFormation)(properties.FilterGroups) : void 0), ret.addPropertyResult("parameterDeclarations", "ParameterDeclarations", properties.ParameterDeclarations != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateParameterDeclarationPropertyFromCloudFormation)(properties.ParameterDeclarations) : void 0), ret.addPropertyResult("sheets", "Sheets", properties.Sheets != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateSheetDefinitionPropertyFromCloudFormation)(properties.Sheets) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TextAreaControlDisplayOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("placeholderOptions", CfnTemplate_TextControlPlaceholderOptionsPropertyValidator)(properties.placeholderOptions)), errors.collect(cdk.propertyValidator("titleOptions", CfnTemplate_LabelOptionsPropertyValidator)(properties.titleOptions)), errors.wrap('supplied properties not correct for "TextAreaControlDisplayOptionsProperty"');
    }
    function cfnTemplateTextAreaControlDisplayOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TextAreaControlDisplayOptionsPropertyValidator(properties).assertSuccess(), { PlaceholderOptions: cfnTemplateTextControlPlaceholderOptionsPropertyToCloudFormation(properties.placeholderOptions), TitleOptions: cfnTemplateLabelOptionsPropertyToCloudFormation(properties.titleOptions) }) : properties;
    }
    function CfnTemplateTextAreaControlDisplayOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("placeholderOptions", "PlaceholderOptions", properties.PlaceholderOptions != null ? CfnTemplateTextControlPlaceholderOptionsPropertyFromCloudFormation(properties.PlaceholderOptions) : void 0), ret.addPropertyResult("titleOptions", "TitleOptions", properties.TitleOptions != null ? CfnTemplateLabelOptionsPropertyFromCloudFormation(properties.TitleOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TextConditionalFormatPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("backgroundColor", CfnTemplate_ConditionalFormattingColorPropertyValidator)(properties.backgroundColor)), errors.collect(cdk.propertyValidator("icon", CfnTemplate_ConditionalFormattingIconPropertyValidator)(properties.icon)), errors.collect(cdk.propertyValidator("textColor", CfnTemplate_ConditionalFormattingColorPropertyValidator)(properties.textColor)), errors.wrap('supplied properties not correct for "TextConditionalFormatProperty"');
    }
    function cfnTemplateTextConditionalFormatPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TextConditionalFormatPropertyValidator(properties).assertSuccess(), { BackgroundColor: cfnTemplateConditionalFormattingColorPropertyToCloudFormation(properties.backgroundColor), Icon: cfnTemplateConditionalFormattingIconPropertyToCloudFormation(properties.icon), TextColor: cfnTemplateConditionalFormattingColorPropertyToCloudFormation(properties.textColor) }) : properties;
    }
    function CfnTemplateTextConditionalFormatPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("backgroundColor", "BackgroundColor", properties.BackgroundColor != null ? CfnTemplateConditionalFormattingColorPropertyFromCloudFormation(properties.BackgroundColor) : void 0), ret.addPropertyResult("icon", "Icon", properties.Icon != null ? CfnTemplateConditionalFormattingIconPropertyFromCloudFormation(properties.Icon) : void 0), ret.addPropertyResult("textColor", "TextColor", properties.TextColor != null ? CfnTemplateConditionalFormattingColorPropertyFromCloudFormation(properties.TextColor) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TextControlPlaceholderOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "TextControlPlaceholderOptionsProperty"');
    }
    function cfnTemplateTextControlPlaceholderOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TextControlPlaceholderOptionsPropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnTemplateTextControlPlaceholderOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TextFieldControlDisplayOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("placeholderOptions", CfnTemplate_TextControlPlaceholderOptionsPropertyValidator)(properties.placeholderOptions)), errors.collect(cdk.propertyValidator("titleOptions", CfnTemplate_LabelOptionsPropertyValidator)(properties.titleOptions)), errors.wrap('supplied properties not correct for "TextFieldControlDisplayOptionsProperty"');
    }
    function cfnTemplateTextFieldControlDisplayOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TextFieldControlDisplayOptionsPropertyValidator(properties).assertSuccess(), { PlaceholderOptions: cfnTemplateTextControlPlaceholderOptionsPropertyToCloudFormation(properties.placeholderOptions), TitleOptions: cfnTemplateLabelOptionsPropertyToCloudFormation(properties.titleOptions) }) : properties;
    }
    function CfnTemplateTextFieldControlDisplayOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("placeholderOptions", "PlaceholderOptions", properties.PlaceholderOptions != null ? CfnTemplateTextControlPlaceholderOptionsPropertyFromCloudFormation(properties.PlaceholderOptions) : void 0), ret.addPropertyResult("titleOptions", "TitleOptions", properties.TitleOptions != null ? CfnTemplateLabelOptionsPropertyFromCloudFormation(properties.TitleOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_ThousandSeparatorOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("symbol", cdk.validateString)(properties.symbol)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "ThousandSeparatorOptionsProperty"');
    }
    function cfnTemplateThousandSeparatorOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_ThousandSeparatorOptionsPropertyValidator(properties).assertSuccess(), { Symbol: cdk.stringToCloudFormation(properties.symbol), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnTemplateThousandSeparatorOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("symbol", "Symbol", properties.Symbol != null ? cfn_parse.FromCloudFormation.getString(properties.Symbol) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TimeBasedForecastPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("lowerBoundary", cdk.validateNumber)(properties.lowerBoundary)), errors.collect(cdk.propertyValidator("periodsBackward", cdk.validateNumber)(properties.periodsBackward)), errors.collect(cdk.propertyValidator("periodsForward", cdk.validateNumber)(properties.periodsForward)), errors.collect(cdk.propertyValidator("predictionInterval", cdk.validateNumber)(properties.predictionInterval)), errors.collect(cdk.propertyValidator("seasonality", cdk.validateNumber)(properties.seasonality)), errors.collect(cdk.propertyValidator("upperBoundary", cdk.validateNumber)(properties.upperBoundary)), errors.wrap('supplied properties not correct for "TimeBasedForecastPropertiesProperty"');
    }
    function cfnTemplateTimeBasedForecastPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TimeBasedForecastPropertiesPropertyValidator(properties).assertSuccess(), { LowerBoundary: cdk.numberToCloudFormation(properties.lowerBoundary), PeriodsBackward: cdk.numberToCloudFormation(properties.periodsBackward), PeriodsForward: cdk.numberToCloudFormation(properties.periodsForward), PredictionInterval: cdk.numberToCloudFormation(properties.predictionInterval), Seasonality: cdk.numberToCloudFormation(properties.seasonality), UpperBoundary: cdk.numberToCloudFormation(properties.upperBoundary) }) : properties;
    }
    function CfnTemplateTimeBasedForecastPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("lowerBoundary", "LowerBoundary", properties.LowerBoundary != null ? cfn_parse.FromCloudFormation.getNumber(properties.LowerBoundary) : void 0), ret.addPropertyResult("periodsBackward", "PeriodsBackward", properties.PeriodsBackward != null ? cfn_parse.FromCloudFormation.getNumber(properties.PeriodsBackward) : void 0), ret.addPropertyResult("periodsForward", "PeriodsForward", properties.PeriodsForward != null ? cfn_parse.FromCloudFormation.getNumber(properties.PeriodsForward) : void 0), ret.addPropertyResult("predictionInterval", "PredictionInterval", properties.PredictionInterval != null ? cfn_parse.FromCloudFormation.getNumber(properties.PredictionInterval) : void 0), ret.addPropertyResult("seasonality", "Seasonality", properties.Seasonality != null ? cfn_parse.FromCloudFormation.getNumber(properties.Seasonality) : void 0), ret.addPropertyResult("upperBoundary", "UpperBoundary", properties.UpperBoundary != null ? cfn_parse.FromCloudFormation.getNumber(properties.UpperBoundary) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TimeEqualityFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnTemplate_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("filterId", cdk.requiredValidator)(properties.filterId)), errors.collect(cdk.propertyValidator("filterId", cdk.validateString)(properties.filterId)), errors.collect(cdk.propertyValidator("parameterName", cdk.validateString)(properties.parameterName)), errors.collect(cdk.propertyValidator("timeGranularity", cdk.validateString)(properties.timeGranularity)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TimeEqualityFilterProperty"');
    }
    function cfnTemplateTimeEqualityFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TimeEqualityFilterPropertyValidator(properties).assertSuccess(), { Column: cfnTemplateColumnIdentifierPropertyToCloudFormation(properties.column), FilterId: cdk.stringToCloudFormation(properties.filterId), ParameterName: cdk.stringToCloudFormation(properties.parameterName), TimeGranularity: cdk.stringToCloudFormation(properties.timeGranularity), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnTemplateTimeEqualityFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", CfnTemplateColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("filterId", "FilterId", cfn_parse.FromCloudFormation.getString(properties.FilterId)), ret.addPropertyResult("parameterName", "ParameterName", properties.ParameterName != null ? cfn_parse.FromCloudFormation.getString(properties.ParameterName) : void 0), ret.addPropertyResult("timeGranularity", "TimeGranularity", properties.TimeGranularity != null ? cfn_parse.FromCloudFormation.getString(properties.TimeGranularity) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getString(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TimeRangeDrillDownFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnTemplate_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("rangeMaximum", cdk.requiredValidator)(properties.rangeMaximum)), errors.collect(cdk.propertyValidator("rangeMaximum", cdk.validateString)(properties.rangeMaximum)), errors.collect(cdk.propertyValidator("rangeMinimum", cdk.requiredValidator)(properties.rangeMinimum)), errors.collect(cdk.propertyValidator("rangeMinimum", cdk.validateString)(properties.rangeMinimum)), errors.collect(cdk.propertyValidator("timeGranularity", cdk.requiredValidator)(properties.timeGranularity)), errors.collect(cdk.propertyValidator("timeGranularity", cdk.validateString)(properties.timeGranularity)), errors.wrap('supplied properties not correct for "TimeRangeDrillDownFilterProperty"');
    }
    function cfnTemplateTimeRangeDrillDownFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TimeRangeDrillDownFilterPropertyValidator(properties).assertSuccess(), { Column: cfnTemplateColumnIdentifierPropertyToCloudFormation(properties.column), RangeMaximum: cdk.stringToCloudFormation(properties.rangeMaximum), RangeMinimum: cdk.stringToCloudFormation(properties.rangeMinimum), TimeGranularity: cdk.stringToCloudFormation(properties.timeGranularity) }) : properties;
    }
    function CfnTemplateTimeRangeDrillDownFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", CfnTemplateColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("rangeMaximum", "RangeMaximum", cfn_parse.FromCloudFormation.getString(properties.RangeMaximum)), ret.addPropertyResult("rangeMinimum", "RangeMinimum", cfn_parse.FromCloudFormation.getString(properties.RangeMinimum)), ret.addPropertyResult("timeGranularity", "TimeGranularity", cfn_parse.FromCloudFormation.getString(properties.TimeGranularity)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TimeRangeFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnTemplate_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("excludePeriodConfiguration", CfnTemplate_ExcludePeriodConfigurationPropertyValidator)(properties.excludePeriodConfiguration)), errors.collect(cdk.propertyValidator("filterId", cdk.requiredValidator)(properties.filterId)), errors.collect(cdk.propertyValidator("filterId", cdk.validateString)(properties.filterId)), errors.collect(cdk.propertyValidator("includeMaximum", cdk.validateBoolean)(properties.includeMaximum)), errors.collect(cdk.propertyValidator("includeMinimum", cdk.validateBoolean)(properties.includeMinimum)), errors.collect(cdk.propertyValidator("nullOption", cdk.requiredValidator)(properties.nullOption)), errors.collect(cdk.propertyValidator("nullOption", cdk.validateString)(properties.nullOption)), errors.collect(cdk.propertyValidator("rangeMaximumValue", CfnTemplate_TimeRangeFilterValuePropertyValidator)(properties.rangeMaximumValue)), errors.collect(cdk.propertyValidator("rangeMinimumValue", CfnTemplate_TimeRangeFilterValuePropertyValidator)(properties.rangeMinimumValue)), errors.collect(cdk.propertyValidator("timeGranularity", cdk.validateString)(properties.timeGranularity)), errors.wrap('supplied properties not correct for "TimeRangeFilterProperty"');
    }
    function cfnTemplateTimeRangeFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TimeRangeFilterPropertyValidator(properties).assertSuccess(), { Column: cfnTemplateColumnIdentifierPropertyToCloudFormation(properties.column), ExcludePeriodConfiguration: cfnTemplateExcludePeriodConfigurationPropertyToCloudFormation(properties.excludePeriodConfiguration), FilterId: cdk.stringToCloudFormation(properties.filterId), IncludeMaximum: cdk.booleanToCloudFormation(properties.includeMaximum), IncludeMinimum: cdk.booleanToCloudFormation(properties.includeMinimum), NullOption: cdk.stringToCloudFormation(properties.nullOption), RangeMaximumValue: cfnTemplateTimeRangeFilterValuePropertyToCloudFormation(properties.rangeMaximumValue), RangeMinimumValue: cfnTemplateTimeRangeFilterValuePropertyToCloudFormation(properties.rangeMinimumValue), TimeGranularity: cdk.stringToCloudFormation(properties.timeGranularity) }) : properties;
    }
    function CfnTemplateTimeRangeFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", CfnTemplateColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("excludePeriodConfiguration", "ExcludePeriodConfiguration", properties.ExcludePeriodConfiguration != null ? CfnTemplateExcludePeriodConfigurationPropertyFromCloudFormation(properties.ExcludePeriodConfiguration) : void 0), ret.addPropertyResult("filterId", "FilterId", cfn_parse.FromCloudFormation.getString(properties.FilterId)), ret.addPropertyResult("includeMaximum", "IncludeMaximum", properties.IncludeMaximum != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeMaximum) : void 0), ret.addPropertyResult("includeMinimum", "IncludeMinimum", properties.IncludeMinimum != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeMinimum) : void 0), ret.addPropertyResult("nullOption", "NullOption", cfn_parse.FromCloudFormation.getString(properties.NullOption)), ret.addPropertyResult("rangeMaximumValue", "RangeMaximumValue", properties.RangeMaximumValue != null ? CfnTemplateTimeRangeFilterValuePropertyFromCloudFormation(properties.RangeMaximumValue) : void 0), ret.addPropertyResult("rangeMinimumValue", "RangeMinimumValue", properties.RangeMinimumValue != null ? CfnTemplateTimeRangeFilterValuePropertyFromCloudFormation(properties.RangeMinimumValue) : void 0), ret.addPropertyResult("timeGranularity", "TimeGranularity", properties.TimeGranularity != null ? cfn_parse.FromCloudFormation.getString(properties.TimeGranularity) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TimeRangeFilterValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("parameter", cdk.validateString)(properties.parameter)), errors.collect(cdk.propertyValidator("rollingDate", CfnTemplate_RollingDateConfigurationPropertyValidator)(properties.rollingDate)), errors.collect(cdk.propertyValidator("staticValue", cdk.validateString)(properties.staticValue)), errors.wrap('supplied properties not correct for "TimeRangeFilterValueProperty"');
    }
    function cfnTemplateTimeRangeFilterValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TimeRangeFilterValuePropertyValidator(properties).assertSuccess(), { Parameter: cdk.stringToCloudFormation(properties.parameter), RollingDate: cfnTemplateRollingDateConfigurationPropertyToCloudFormation(properties.rollingDate), StaticValue: cdk.stringToCloudFormation(properties.staticValue) }) : properties;
    }
    function CfnTemplateTimeRangeFilterValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("parameter", "Parameter", properties.Parameter != null ? cfn_parse.FromCloudFormation.getString(properties.Parameter) : void 0), ret.addPropertyResult("rollingDate", "RollingDate", properties.RollingDate != null ? CfnTemplateRollingDateConfigurationPropertyFromCloudFormation(properties.RollingDate) : void 0), ret.addPropertyResult("staticValue", "StaticValue", properties.StaticValue != null ? cfn_parse.FromCloudFormation.getString(properties.StaticValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TooltipItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("columnTooltipItem", CfnTemplate_ColumnTooltipItemPropertyValidator)(properties.columnTooltipItem)), errors.collect(cdk.propertyValidator("fieldTooltipItem", CfnTemplate_FieldTooltipItemPropertyValidator)(properties.fieldTooltipItem)), errors.wrap('supplied properties not correct for "TooltipItemProperty"');
    }
    function cfnTemplateTooltipItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TooltipItemPropertyValidator(properties).assertSuccess(), { ColumnTooltipItem: cfnTemplateColumnTooltipItemPropertyToCloudFormation(properties.columnTooltipItem), FieldTooltipItem: cfnTemplateFieldTooltipItemPropertyToCloudFormation(properties.fieldTooltipItem) }) : properties;
    }
    function CfnTemplateTooltipItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("columnTooltipItem", "ColumnTooltipItem", properties.ColumnTooltipItem != null ? CfnTemplateColumnTooltipItemPropertyFromCloudFormation(properties.ColumnTooltipItem) : void 0), ret.addPropertyResult("fieldTooltipItem", "FieldTooltipItem", properties.FieldTooltipItem != null ? CfnTemplateFieldTooltipItemPropertyFromCloudFormation(properties.FieldTooltipItem) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TooltipOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldBasedTooltip", CfnTemplate_FieldBasedTooltipPropertyValidator)(properties.fieldBasedTooltip)), errors.collect(cdk.propertyValidator("selectedTooltipType", cdk.validateString)(properties.selectedTooltipType)), errors.collect(cdk.propertyValidator("tooltipVisibility", cdk.validateString)(properties.tooltipVisibility)), errors.wrap('supplied properties not correct for "TooltipOptionsProperty"');
    }
    function cfnTemplateTooltipOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TooltipOptionsPropertyValidator(properties).assertSuccess(), { FieldBasedTooltip: cfnTemplateFieldBasedTooltipPropertyToCloudFormation(properties.fieldBasedTooltip), SelectedTooltipType: cdk.stringToCloudFormation(properties.selectedTooltipType), TooltipVisibility: cdk.stringToCloudFormation(properties.tooltipVisibility) }) : properties;
    }
    function CfnTemplateTooltipOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldBasedTooltip", "FieldBasedTooltip", properties.FieldBasedTooltip != null ? CfnTemplateFieldBasedTooltipPropertyFromCloudFormation(properties.FieldBasedTooltip) : void 0), ret.addPropertyResult("selectedTooltipType", "SelectedTooltipType", properties.SelectedTooltipType != null ? cfn_parse.FromCloudFormation.getString(properties.SelectedTooltipType) : void 0), ret.addPropertyResult("tooltipVisibility", "TooltipVisibility", properties.TooltipVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.TooltipVisibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TopBottomFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregationSortConfigurations", cdk.requiredValidator)(properties.aggregationSortConfigurations)), errors.collect(cdk.propertyValidator("aggregationSortConfigurations", cdk.listValidator(CfnTemplate_AggregationSortConfigurationPropertyValidator))(properties.aggregationSortConfigurations)), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnTemplate_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("filterId", cdk.requiredValidator)(properties.filterId)), errors.collect(cdk.propertyValidator("filterId", cdk.validateString)(properties.filterId)), errors.collect(cdk.propertyValidator("limit", cdk.validateNumber)(properties.limit)), errors.collect(cdk.propertyValidator("parameterName", cdk.validateString)(properties.parameterName)), errors.collect(cdk.propertyValidator("timeGranularity", cdk.validateString)(properties.timeGranularity)), errors.wrap('supplied properties not correct for "TopBottomFilterProperty"');
    }
    function cfnTemplateTopBottomFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TopBottomFilterPropertyValidator(properties).assertSuccess(), { AggregationSortConfigurations: cdk.listMapper(cfnTemplateAggregationSortConfigurationPropertyToCloudFormation)(properties.aggregationSortConfigurations), Column: cfnTemplateColumnIdentifierPropertyToCloudFormation(properties.column), FilterId: cdk.stringToCloudFormation(properties.filterId), Limit: cdk.numberToCloudFormation(properties.limit), ParameterName: cdk.stringToCloudFormation(properties.parameterName), TimeGranularity: cdk.stringToCloudFormation(properties.timeGranularity) }) : properties;
    }
    function CfnTemplateTopBottomFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregationSortConfigurations", "AggregationSortConfigurations", cfn_parse.FromCloudFormation.getArray(CfnTemplateAggregationSortConfigurationPropertyFromCloudFormation)(properties.AggregationSortConfigurations)), ret.addPropertyResult("column", "Column", CfnTemplateColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("filterId", "FilterId", cfn_parse.FromCloudFormation.getString(properties.FilterId)), ret.addPropertyResult("limit", "Limit", properties.Limit != null ? cfn_parse.FromCloudFormation.getNumber(properties.Limit) : void 0), ret.addPropertyResult("parameterName", "ParameterName", properties.ParameterName != null ? cfn_parse.FromCloudFormation.getString(properties.ParameterName) : void 0), ret.addPropertyResult("timeGranularity", "TimeGranularity", properties.TimeGranularity != null ? cfn_parse.FromCloudFormation.getString(properties.TimeGranularity) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TopBottomMoversComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("category", cdk.requiredValidator)(properties.category)), errors.collect(cdk.propertyValidator("category", CfnTemplate_DimensionFieldPropertyValidator)(properties.category)), errors.collect(cdk.propertyValidator("computationId", cdk.requiredValidator)(properties.computationId)), errors.collect(cdk.propertyValidator("computationId", cdk.validateString)(properties.computationId)), errors.collect(cdk.propertyValidator("moverSize", cdk.validateNumber)(properties.moverSize)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("sortOrder", cdk.validateString)(properties.sortOrder)), errors.collect(cdk.propertyValidator("time", cdk.requiredValidator)(properties.time)), errors.collect(cdk.propertyValidator("time", CfnTemplate_DimensionFieldPropertyValidator)(properties.time)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", CfnTemplate_MeasureFieldPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "TopBottomMoversComputationProperty"');
    }
    function cfnTemplateTopBottomMoversComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TopBottomMoversComputationPropertyValidator(properties).assertSuccess(), { Category: cfnTemplateDimensionFieldPropertyToCloudFormation(properties.category), ComputationId: cdk.stringToCloudFormation(properties.computationId), MoverSize: cdk.numberToCloudFormation(properties.moverSize), Name: cdk.stringToCloudFormation(properties.name), SortOrder: cdk.stringToCloudFormation(properties.sortOrder), Time: cfnTemplateDimensionFieldPropertyToCloudFormation(properties.time), Type: cdk.stringToCloudFormation(properties.type), Value: cfnTemplateMeasureFieldPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnTemplateTopBottomMoversComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("category", "Category", CfnTemplateDimensionFieldPropertyFromCloudFormation(properties.Category)), ret.addPropertyResult("computationId", "ComputationId", cfn_parse.FromCloudFormation.getString(properties.ComputationId)), ret.addPropertyResult("moverSize", "MoverSize", properties.MoverSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.MoverSize) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("sortOrder", "SortOrder", properties.SortOrder != null ? cfn_parse.FromCloudFormation.getString(properties.SortOrder) : void 0), ret.addPropertyResult("time", "Time", CfnTemplateDimensionFieldPropertyFromCloudFormation(properties.Time)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("value", "Value", properties.Value != null ? CfnTemplateMeasureFieldPropertyFromCloudFormation(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TopBottomRankedComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("category", cdk.requiredValidator)(properties.category)), errors.collect(cdk.propertyValidator("category", CfnTemplate_DimensionFieldPropertyValidator)(properties.category)), errors.collect(cdk.propertyValidator("computationId", cdk.requiredValidator)(properties.computationId)), errors.collect(cdk.propertyValidator("computationId", cdk.validateString)(properties.computationId)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("resultSize", cdk.validateNumber)(properties.resultSize)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", CfnTemplate_MeasureFieldPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "TopBottomRankedComputationProperty"');
    }
    function cfnTemplateTopBottomRankedComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TopBottomRankedComputationPropertyValidator(properties).assertSuccess(), { Category: cfnTemplateDimensionFieldPropertyToCloudFormation(properties.category), ComputationId: cdk.stringToCloudFormation(properties.computationId), Name: cdk.stringToCloudFormation(properties.name), ResultSize: cdk.numberToCloudFormation(properties.resultSize), Type: cdk.stringToCloudFormation(properties.type), Value: cfnTemplateMeasureFieldPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnTemplateTopBottomRankedComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("category", "Category", CfnTemplateDimensionFieldPropertyFromCloudFormation(properties.Category)), ret.addPropertyResult("computationId", "ComputationId", cfn_parse.FromCloudFormation.getString(properties.ComputationId)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("resultSize", "ResultSize", properties.ResultSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.ResultSize) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("value", "Value", properties.Value != null ? CfnTemplateMeasureFieldPropertyFromCloudFormation(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TotalAggregationComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computationId", cdk.requiredValidator)(properties.computationId)), errors.collect(cdk.propertyValidator("computationId", cdk.validateString)(properties.computationId)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", CfnTemplate_MeasureFieldPropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "TotalAggregationComputationProperty"');
    }
    function cfnTemplateTotalAggregationComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TotalAggregationComputationPropertyValidator(properties).assertSuccess(), { ComputationId: cdk.stringToCloudFormation(properties.computationId), Name: cdk.stringToCloudFormation(properties.name), Value: cfnTemplateMeasureFieldPropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnTemplateTotalAggregationComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computationId", "ComputationId", cfn_parse.FromCloudFormation.getString(properties.ComputationId)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("value", "Value", CfnTemplateMeasureFieldPropertyFromCloudFormation(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TotalOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customLabel", cdk.validateString)(properties.customLabel)), errors.collect(cdk.propertyValidator("placement", cdk.validateString)(properties.placement)), errors.collect(cdk.propertyValidator("scrollStatus", cdk.validateString)(properties.scrollStatus)), errors.collect(cdk.propertyValidator("totalCellStyle", CfnTemplate_TableCellStylePropertyValidator)(properties.totalCellStyle)), errors.collect(cdk.propertyValidator("totalsVisibility", cdk.validateString)(properties.totalsVisibility)), errors.wrap('supplied properties not correct for "TotalOptionsProperty"');
    }
    function cfnTemplateTotalOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TotalOptionsPropertyValidator(properties).assertSuccess(), { CustomLabel: cdk.stringToCloudFormation(properties.customLabel), Placement: cdk.stringToCloudFormation(properties.placement), ScrollStatus: cdk.stringToCloudFormation(properties.scrollStatus), TotalCellStyle: cfnTemplateTableCellStylePropertyToCloudFormation(properties.totalCellStyle), TotalsVisibility: cdk.stringToCloudFormation(properties.totalsVisibility) }) : properties;
    }
    function CfnTemplateTotalOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customLabel", "CustomLabel", properties.CustomLabel != null ? cfn_parse.FromCloudFormation.getString(properties.CustomLabel) : void 0), ret.addPropertyResult("placement", "Placement", properties.Placement != null ? cfn_parse.FromCloudFormation.getString(properties.Placement) : void 0), ret.addPropertyResult("scrollStatus", "ScrollStatus", properties.ScrollStatus != null ? cfn_parse.FromCloudFormation.getString(properties.ScrollStatus) : void 0), ret.addPropertyResult("totalCellStyle", "TotalCellStyle", properties.TotalCellStyle != null ? CfnTemplateTableCellStylePropertyFromCloudFormation(properties.TotalCellStyle) : void 0), ret.addPropertyResult("totalsVisibility", "TotalsVisibility", properties.TotalsVisibility != null ? cfn_parse.FromCloudFormation.getString(properties.TotalsVisibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TreeMapAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("colors", cdk.listValidator(CfnTemplate_MeasureFieldPropertyValidator))(properties.colors)), errors.collect(cdk.propertyValidator("groups", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.groups)), errors.collect(cdk.propertyValidator("sizes", cdk.listValidator(CfnTemplate_MeasureFieldPropertyValidator))(properties.sizes)), errors.wrap('supplied properties not correct for "TreeMapAggregatedFieldWellsProperty"');
    }
    function cfnTemplateTreeMapAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TreeMapAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Colors: cdk.listMapper(cfnTemplateMeasureFieldPropertyToCloudFormation)(properties.colors), Groups: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.groups), Sizes: cdk.listMapper(cfnTemplateMeasureFieldPropertyToCloudFormation)(properties.sizes) }) : properties;
    }
    function CfnTemplateTreeMapAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("colors", "Colors", properties.Colors != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMeasureFieldPropertyFromCloudFormation)(properties.Colors) : void 0), ret.addPropertyResult("groups", "Groups", properties.Groups != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.Groups) : void 0), ret.addPropertyResult("sizes", "Sizes", properties.Sizes != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMeasureFieldPropertyFromCloudFormation)(properties.Sizes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TreeMapConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("colorLabelOptions", CfnTemplate_ChartAxisLabelOptionsPropertyValidator)(properties.colorLabelOptions)), errors.collect(cdk.propertyValidator("colorScale", CfnTemplate_ColorScalePropertyValidator)(properties.colorScale)), errors.collect(cdk.propertyValidator("dataLabels", CfnTemplate_DataLabelOptionsPropertyValidator)(properties.dataLabels)), errors.collect(cdk.propertyValidator("fieldWells", CfnTemplate_TreeMapFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("groupLabelOptions", CfnTemplate_ChartAxisLabelOptionsPropertyValidator)(properties.groupLabelOptions)), errors.collect(cdk.propertyValidator("legend", CfnTemplate_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("sizeLabelOptions", CfnTemplate_ChartAxisLabelOptionsPropertyValidator)(properties.sizeLabelOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnTemplate_TreeMapSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("tooltip", CfnTemplate_TooltipOptionsPropertyValidator)(properties.tooltip)), errors.wrap('supplied properties not correct for "TreeMapConfigurationProperty"');
    }
    function cfnTemplateTreeMapConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TreeMapConfigurationPropertyValidator(properties).assertSuccess(), { ColorLabelOptions: cfnTemplateChartAxisLabelOptionsPropertyToCloudFormation(properties.colorLabelOptions), ColorScale: cfnTemplateColorScalePropertyToCloudFormation(properties.colorScale), DataLabels: cfnTemplateDataLabelOptionsPropertyToCloudFormation(properties.dataLabels), FieldWells: cfnTemplateTreeMapFieldWellsPropertyToCloudFormation(properties.fieldWells), GroupLabelOptions: cfnTemplateChartAxisLabelOptionsPropertyToCloudFormation(properties.groupLabelOptions), Legend: cfnTemplateLegendOptionsPropertyToCloudFormation(properties.legend), SizeLabelOptions: cfnTemplateChartAxisLabelOptionsPropertyToCloudFormation(properties.sizeLabelOptions), SortConfiguration: cfnTemplateTreeMapSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), Tooltip: cfnTemplateTooltipOptionsPropertyToCloudFormation(properties.tooltip) }) : properties;
    }
    function CfnTemplateTreeMapConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("colorLabelOptions", "ColorLabelOptions", properties.ColorLabelOptions != null ? CfnTemplateChartAxisLabelOptionsPropertyFromCloudFormation(properties.ColorLabelOptions) : void 0), ret.addPropertyResult("colorScale", "ColorScale", properties.ColorScale != null ? CfnTemplateColorScalePropertyFromCloudFormation(properties.ColorScale) : void 0), ret.addPropertyResult("dataLabels", "DataLabels", properties.DataLabels != null ? CfnTemplateDataLabelOptionsPropertyFromCloudFormation(properties.DataLabels) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnTemplateTreeMapFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("groupLabelOptions", "GroupLabelOptions", properties.GroupLabelOptions != null ? CfnTemplateChartAxisLabelOptionsPropertyFromCloudFormation(properties.GroupLabelOptions) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnTemplateLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("sizeLabelOptions", "SizeLabelOptions", properties.SizeLabelOptions != null ? CfnTemplateChartAxisLabelOptionsPropertyFromCloudFormation(properties.SizeLabelOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnTemplateTreeMapSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("tooltip", "Tooltip", properties.Tooltip != null ? CfnTemplateTooltipOptionsPropertyFromCloudFormation(properties.Tooltip) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TreeMapFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("treeMapAggregatedFieldWells", CfnTemplate_TreeMapAggregatedFieldWellsPropertyValidator)(properties.treeMapAggregatedFieldWells)), errors.wrap('supplied properties not correct for "TreeMapFieldWellsProperty"');
    }
    function cfnTemplateTreeMapFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TreeMapFieldWellsPropertyValidator(properties).assertSuccess(), { TreeMapAggregatedFieldWells: cfnTemplateTreeMapAggregatedFieldWellsPropertyToCloudFormation(properties.treeMapAggregatedFieldWells) }) : properties;
    }
    function CfnTemplateTreeMapFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("treeMapAggregatedFieldWells", "TreeMapAggregatedFieldWells", properties.TreeMapAggregatedFieldWells != null ? CfnTemplateTreeMapAggregatedFieldWellsPropertyFromCloudFormation(properties.TreeMapAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TreeMapSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("treeMapGroupItemsLimitConfiguration", CfnTemplate_ItemsLimitConfigurationPropertyValidator)(properties.treeMapGroupItemsLimitConfiguration)), errors.collect(cdk.propertyValidator("treeMapSort", cdk.listValidator(CfnTemplate_FieldSortOptionsPropertyValidator))(properties.treeMapSort)), errors.wrap('supplied properties not correct for "TreeMapSortConfigurationProperty"');
    }
    function cfnTemplateTreeMapSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TreeMapSortConfigurationPropertyValidator(properties).assertSuccess(), { TreeMapGroupItemsLimitConfiguration: cfnTemplateItemsLimitConfigurationPropertyToCloudFormation(properties.treeMapGroupItemsLimitConfiguration), TreeMapSort: cdk.listMapper(cfnTemplateFieldSortOptionsPropertyToCloudFormation)(properties.treeMapSort) }) : properties;
    }
    function CfnTemplateTreeMapSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("treeMapGroupItemsLimitConfiguration", "TreeMapGroupItemsLimitConfiguration", properties.TreeMapGroupItemsLimitConfiguration != null ? CfnTemplateItemsLimitConfigurationPropertyFromCloudFormation(properties.TreeMapGroupItemsLimitConfiguration) : void 0), ret.addPropertyResult("treeMapSort", "TreeMapSort", properties.TreeMapSort != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateFieldSortOptionsPropertyFromCloudFormation)(properties.TreeMapSort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TreeMapVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnTemplate_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnTemplate_TreeMapConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnTemplate_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnTemplate_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnTemplate_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "TreeMapVisualProperty"');
    }
    function cfnTemplateTreeMapVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TreeMapVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnTemplateVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnTemplateTreeMapConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnTemplateColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnTemplateVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnTemplateVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnTemplateTreeMapVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnTemplateTreeMapConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnTemplateVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnTemplateVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_TrendArrowOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "TrendArrowOptionsProperty"');
    }
    function cfnTemplateTrendArrowOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TrendArrowOptionsPropertyValidator(properties).assertSuccess(), { Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnTemplateTrendArrowOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_UnaggregatedFieldPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("column", cdk.requiredValidator)(properties.column)), errors.collect(cdk.propertyValidator("column", CfnTemplate_ColumnIdentifierPropertyValidator)(properties.column)), errors.collect(cdk.propertyValidator("fieldId", cdk.requiredValidator)(properties.fieldId)), errors.collect(cdk.propertyValidator("fieldId", cdk.validateString)(properties.fieldId)), errors.collect(cdk.propertyValidator("formatConfiguration", CfnTemplate_FormatConfigurationPropertyValidator)(properties.formatConfiguration)), errors.wrap('supplied properties not correct for "UnaggregatedFieldProperty"');
    }
    function cfnTemplateUnaggregatedFieldPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_UnaggregatedFieldPropertyValidator(properties).assertSuccess(), { Column: cfnTemplateColumnIdentifierPropertyToCloudFormation(properties.column), FieldId: cdk.stringToCloudFormation(properties.fieldId), FormatConfiguration: cfnTemplateFormatConfigurationPropertyToCloudFormation(properties.formatConfiguration) }) : properties;
    }
    function CfnTemplateUnaggregatedFieldPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("column", "Column", CfnTemplateColumnIdentifierPropertyFromCloudFormation(properties.Column)), ret.addPropertyResult("fieldId", "FieldId", cfn_parse.FromCloudFormation.getString(properties.FieldId)), ret.addPropertyResult("formatConfiguration", "FormatConfiguration", properties.FormatConfiguration != null ? CfnTemplateFormatConfigurationPropertyFromCloudFormation(properties.FormatConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_UniqueValuesComputationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("category", cdk.requiredValidator)(properties.category)), errors.collect(cdk.propertyValidator("category", CfnTemplate_DimensionFieldPropertyValidator)(properties.category)), errors.collect(cdk.propertyValidator("computationId", cdk.requiredValidator)(properties.computationId)), errors.collect(cdk.propertyValidator("computationId", cdk.validateString)(properties.computationId)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "UniqueValuesComputationProperty"');
    }
    function cfnTemplateUniqueValuesComputationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_UniqueValuesComputationPropertyValidator(properties).assertSuccess(), { Category: cfnTemplateDimensionFieldPropertyToCloudFormation(properties.category), ComputationId: cdk.stringToCloudFormation(properties.computationId), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnTemplateUniqueValuesComputationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("category", "Category", CfnTemplateDimensionFieldPropertyFromCloudFormation(properties.Category)), ret.addPropertyResult("computationId", "ComputationId", cfn_parse.FromCloudFormation.getString(properties.ComputationId)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_VisibleRangeOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("percentRange", CfnTemplate_PercentVisibleRangePropertyValidator)(properties.percentRange)), errors.wrap('supplied properties not correct for "VisibleRangeOptionsProperty"');
    }
    function cfnTemplateVisibleRangeOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_VisibleRangeOptionsPropertyValidator(properties).assertSuccess(), { PercentRange: cfnTemplatePercentVisibleRangePropertyToCloudFormation(properties.percentRange) }) : properties;
    }
    function CfnTemplateVisibleRangeOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("percentRange", "PercentRange", properties.PercentRange != null ? CfnTemplatePercentVisibleRangePropertyFromCloudFormation(properties.PercentRange) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_VisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("barChartVisual", CfnTemplate_BarChartVisualPropertyValidator)(properties.barChartVisual)), errors.collect(cdk.propertyValidator("boxPlotVisual", CfnTemplate_BoxPlotVisualPropertyValidator)(properties.boxPlotVisual)), errors.collect(cdk.propertyValidator("comboChartVisual", CfnTemplate_ComboChartVisualPropertyValidator)(properties.comboChartVisual)), errors.collect(cdk.propertyValidator("customContentVisual", CfnTemplate_CustomContentVisualPropertyValidator)(properties.customContentVisual)), errors.collect(cdk.propertyValidator("emptyVisual", CfnTemplate_EmptyVisualPropertyValidator)(properties.emptyVisual)), errors.collect(cdk.propertyValidator("filledMapVisual", CfnTemplate_FilledMapVisualPropertyValidator)(properties.filledMapVisual)), errors.collect(cdk.propertyValidator("funnelChartVisual", CfnTemplate_FunnelChartVisualPropertyValidator)(properties.funnelChartVisual)), errors.collect(cdk.propertyValidator("gaugeChartVisual", CfnTemplate_GaugeChartVisualPropertyValidator)(properties.gaugeChartVisual)), errors.collect(cdk.propertyValidator("geospatialMapVisual", CfnTemplate_GeospatialMapVisualPropertyValidator)(properties.geospatialMapVisual)), errors.collect(cdk.propertyValidator("heatMapVisual", CfnTemplate_HeatMapVisualPropertyValidator)(properties.heatMapVisual)), errors.collect(cdk.propertyValidator("histogramVisual", CfnTemplate_HistogramVisualPropertyValidator)(properties.histogramVisual)), errors.collect(cdk.propertyValidator("insightVisual", CfnTemplate_InsightVisualPropertyValidator)(properties.insightVisual)), errors.collect(cdk.propertyValidator("kpiVisual", CfnTemplate_KPIVisualPropertyValidator)(properties.kpiVisual)), errors.collect(cdk.propertyValidator("lineChartVisual", CfnTemplate_LineChartVisualPropertyValidator)(properties.lineChartVisual)), errors.collect(cdk.propertyValidator("pieChartVisual", CfnTemplate_PieChartVisualPropertyValidator)(properties.pieChartVisual)), errors.collect(cdk.propertyValidator("pivotTableVisual", CfnTemplate_PivotTableVisualPropertyValidator)(properties.pivotTableVisual)), errors.collect(cdk.propertyValidator("radarChartVisual", CfnTemplate_RadarChartVisualPropertyValidator)(properties.radarChartVisual)), errors.collect(cdk.propertyValidator("sankeyDiagramVisual", CfnTemplate_SankeyDiagramVisualPropertyValidator)(properties.sankeyDiagramVisual)), errors.collect(cdk.propertyValidator("scatterPlotVisual", CfnTemplate_ScatterPlotVisualPropertyValidator)(properties.scatterPlotVisual)), errors.collect(cdk.propertyValidator("tableVisual", CfnTemplate_TableVisualPropertyValidator)(properties.tableVisual)), errors.collect(cdk.propertyValidator("treeMapVisual", CfnTemplate_TreeMapVisualPropertyValidator)(properties.treeMapVisual)), errors.collect(cdk.propertyValidator("waterfallVisual", CfnTemplate_WaterfallVisualPropertyValidator)(properties.waterfallVisual)), errors.collect(cdk.propertyValidator("wordCloudVisual", CfnTemplate_WordCloudVisualPropertyValidator)(properties.wordCloudVisual)), errors.wrap('supplied properties not correct for "VisualProperty"');
    }
    function cfnTemplateVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_VisualPropertyValidator(properties).assertSuccess(), { BarChartVisual: cfnTemplateBarChartVisualPropertyToCloudFormation(properties.barChartVisual), BoxPlotVisual: cfnTemplateBoxPlotVisualPropertyToCloudFormation(properties.boxPlotVisual), ComboChartVisual: cfnTemplateComboChartVisualPropertyToCloudFormation(properties.comboChartVisual), CustomContentVisual: cfnTemplateCustomContentVisualPropertyToCloudFormation(properties.customContentVisual), EmptyVisual: cfnTemplateEmptyVisualPropertyToCloudFormation(properties.emptyVisual), FilledMapVisual: cfnTemplateFilledMapVisualPropertyToCloudFormation(properties.filledMapVisual), FunnelChartVisual: cfnTemplateFunnelChartVisualPropertyToCloudFormation(properties.funnelChartVisual), GaugeChartVisual: cfnTemplateGaugeChartVisualPropertyToCloudFormation(properties.gaugeChartVisual), GeospatialMapVisual: cfnTemplateGeospatialMapVisualPropertyToCloudFormation(properties.geospatialMapVisual), HeatMapVisual: cfnTemplateHeatMapVisualPropertyToCloudFormation(properties.heatMapVisual), HistogramVisual: cfnTemplateHistogramVisualPropertyToCloudFormation(properties.histogramVisual), InsightVisual: cfnTemplateInsightVisualPropertyToCloudFormation(properties.insightVisual), KPIVisual: cfnTemplateKPIVisualPropertyToCloudFormation(properties.kpiVisual), LineChartVisual: cfnTemplateLineChartVisualPropertyToCloudFormation(properties.lineChartVisual), PieChartVisual: cfnTemplatePieChartVisualPropertyToCloudFormation(properties.pieChartVisual), PivotTableVisual: cfnTemplatePivotTableVisualPropertyToCloudFormation(properties.pivotTableVisual), RadarChartVisual: cfnTemplateRadarChartVisualPropertyToCloudFormation(properties.radarChartVisual), SankeyDiagramVisual: cfnTemplateSankeyDiagramVisualPropertyToCloudFormation(properties.sankeyDiagramVisual), ScatterPlotVisual: cfnTemplateScatterPlotVisualPropertyToCloudFormation(properties.scatterPlotVisual), TableVisual: cfnTemplateTableVisualPropertyToCloudFormation(properties.tableVisual), TreeMapVisual: cfnTemplateTreeMapVisualPropertyToCloudFormation(properties.treeMapVisual), WaterfallVisual: cfnTemplateWaterfallVisualPropertyToCloudFormation(properties.waterfallVisual), WordCloudVisual: cfnTemplateWordCloudVisualPropertyToCloudFormation(properties.wordCloudVisual) }) : properties;
    }
    function CfnTemplateVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("barChartVisual", "BarChartVisual", properties.BarChartVisual != null ? CfnTemplateBarChartVisualPropertyFromCloudFormation(properties.BarChartVisual) : void 0), ret.addPropertyResult("boxPlotVisual", "BoxPlotVisual", properties.BoxPlotVisual != null ? CfnTemplateBoxPlotVisualPropertyFromCloudFormation(properties.BoxPlotVisual) : void 0), ret.addPropertyResult("comboChartVisual", "ComboChartVisual", properties.ComboChartVisual != null ? CfnTemplateComboChartVisualPropertyFromCloudFormation(properties.ComboChartVisual) : void 0), ret.addPropertyResult("customContentVisual", "CustomContentVisual", properties.CustomContentVisual != null ? CfnTemplateCustomContentVisualPropertyFromCloudFormation(properties.CustomContentVisual) : void 0), ret.addPropertyResult("emptyVisual", "EmptyVisual", properties.EmptyVisual != null ? CfnTemplateEmptyVisualPropertyFromCloudFormation(properties.EmptyVisual) : void 0), ret.addPropertyResult("filledMapVisual", "FilledMapVisual", properties.FilledMapVisual != null ? CfnTemplateFilledMapVisualPropertyFromCloudFormation(properties.FilledMapVisual) : void 0), ret.addPropertyResult("funnelChartVisual", "FunnelChartVisual", properties.FunnelChartVisual != null ? CfnTemplateFunnelChartVisualPropertyFromCloudFormation(properties.FunnelChartVisual) : void 0), ret.addPropertyResult("gaugeChartVisual", "GaugeChartVisual", properties.GaugeChartVisual != null ? CfnTemplateGaugeChartVisualPropertyFromCloudFormation(properties.GaugeChartVisual) : void 0), ret.addPropertyResult("geospatialMapVisual", "GeospatialMapVisual", properties.GeospatialMapVisual != null ? CfnTemplateGeospatialMapVisualPropertyFromCloudFormation(properties.GeospatialMapVisual) : void 0), ret.addPropertyResult("heatMapVisual", "HeatMapVisual", properties.HeatMapVisual != null ? CfnTemplateHeatMapVisualPropertyFromCloudFormation(properties.HeatMapVisual) : void 0), ret.addPropertyResult("histogramVisual", "HistogramVisual", properties.HistogramVisual != null ? CfnTemplateHistogramVisualPropertyFromCloudFormation(properties.HistogramVisual) : void 0), ret.addPropertyResult("insightVisual", "InsightVisual", properties.InsightVisual != null ? CfnTemplateInsightVisualPropertyFromCloudFormation(properties.InsightVisual) : void 0), ret.addPropertyResult("kpiVisual", "KPIVisual", properties.KPIVisual != null ? CfnTemplateKPIVisualPropertyFromCloudFormation(properties.KPIVisual) : void 0), ret.addPropertyResult("lineChartVisual", "LineChartVisual", properties.LineChartVisual != null ? CfnTemplateLineChartVisualPropertyFromCloudFormation(properties.LineChartVisual) : void 0), ret.addPropertyResult("pieChartVisual", "PieChartVisual", properties.PieChartVisual != null ? CfnTemplatePieChartVisualPropertyFromCloudFormation(properties.PieChartVisual) : void 0), ret.addPropertyResult("pivotTableVisual", "PivotTableVisual", properties.PivotTableVisual != null ? CfnTemplatePivotTableVisualPropertyFromCloudFormation(properties.PivotTableVisual) : void 0), ret.addPropertyResult("radarChartVisual", "RadarChartVisual", properties.RadarChartVisual != null ? CfnTemplateRadarChartVisualPropertyFromCloudFormation(properties.RadarChartVisual) : void 0), ret.addPropertyResult("sankeyDiagramVisual", "SankeyDiagramVisual", properties.SankeyDiagramVisual != null ? CfnTemplateSankeyDiagramVisualPropertyFromCloudFormation(properties.SankeyDiagramVisual) : void 0), ret.addPropertyResult("scatterPlotVisual", "ScatterPlotVisual", properties.ScatterPlotVisual != null ? CfnTemplateScatterPlotVisualPropertyFromCloudFormation(properties.ScatterPlotVisual) : void 0), ret.addPropertyResult("tableVisual", "TableVisual", properties.TableVisual != null ? CfnTemplateTableVisualPropertyFromCloudFormation(properties.TableVisual) : void 0), ret.addPropertyResult("treeMapVisual", "TreeMapVisual", properties.TreeMapVisual != null ? CfnTemplateTreeMapVisualPropertyFromCloudFormation(properties.TreeMapVisual) : void 0), ret.addPropertyResult("waterfallVisual", "WaterfallVisual", properties.WaterfallVisual != null ? CfnTemplateWaterfallVisualPropertyFromCloudFormation(properties.WaterfallVisual) : void 0), ret.addPropertyResult("wordCloudVisual", "WordCloudVisual", properties.WordCloudVisual != null ? CfnTemplateWordCloudVisualPropertyFromCloudFormation(properties.WordCloudVisual) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_VisualCustomActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actionOperations", cdk.requiredValidator)(properties.actionOperations)), errors.collect(cdk.propertyValidator("actionOperations", cdk.listValidator(CfnTemplate_VisualCustomActionOperationPropertyValidator))(properties.actionOperations)), errors.collect(cdk.propertyValidator("customActionId", cdk.requiredValidator)(properties.customActionId)), errors.collect(cdk.propertyValidator("customActionId", cdk.validateString)(properties.customActionId)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.collect(cdk.propertyValidator("trigger", cdk.requiredValidator)(properties.trigger)), errors.collect(cdk.propertyValidator("trigger", cdk.validateString)(properties.trigger)), errors.wrap('supplied properties not correct for "VisualCustomActionProperty"');
    }
    function cfnTemplateVisualCustomActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_VisualCustomActionPropertyValidator(properties).assertSuccess(), { ActionOperations: cdk.listMapper(cfnTemplateVisualCustomActionOperationPropertyToCloudFormation)(properties.actionOperations), CustomActionId: cdk.stringToCloudFormation(properties.customActionId), Name: cdk.stringToCloudFormation(properties.name), Status: cdk.stringToCloudFormation(properties.status), Trigger: cdk.stringToCloudFormation(properties.trigger) }) : properties;
    }
    function CfnTemplateVisualCustomActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actionOperations", "ActionOperations", cfn_parse.FromCloudFormation.getArray(CfnTemplateVisualCustomActionOperationPropertyFromCloudFormation)(properties.ActionOperations)), ret.addPropertyResult("customActionId", "CustomActionId", cfn_parse.FromCloudFormation.getString(properties.CustomActionId)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addPropertyResult("trigger", "Trigger", cfn_parse.FromCloudFormation.getString(properties.Trigger)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_VisualCustomActionOperationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("filterOperation", CfnTemplate_CustomActionFilterOperationPropertyValidator)(properties.filterOperation)), errors.collect(cdk.propertyValidator("navigationOperation", CfnTemplate_CustomActionNavigationOperationPropertyValidator)(properties.navigationOperation)), errors.collect(cdk.propertyValidator("setParametersOperation", CfnTemplate_CustomActionSetParametersOperationPropertyValidator)(properties.setParametersOperation)), errors.collect(cdk.propertyValidator("urlOperation", CfnTemplate_CustomActionURLOperationPropertyValidator)(properties.urlOperation)), errors.wrap('supplied properties not correct for "VisualCustomActionOperationProperty"');
    }
    function cfnTemplateVisualCustomActionOperationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_VisualCustomActionOperationPropertyValidator(properties).assertSuccess(), { FilterOperation: cfnTemplateCustomActionFilterOperationPropertyToCloudFormation(properties.filterOperation), NavigationOperation: cfnTemplateCustomActionNavigationOperationPropertyToCloudFormation(properties.navigationOperation), SetParametersOperation: cfnTemplateCustomActionSetParametersOperationPropertyToCloudFormation(properties.setParametersOperation), URLOperation: cfnTemplateCustomActionURLOperationPropertyToCloudFormation(properties.urlOperation) }) : properties;
    }
    function CfnTemplateVisualCustomActionOperationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("filterOperation", "FilterOperation", properties.FilterOperation != null ? CfnTemplateCustomActionFilterOperationPropertyFromCloudFormation(properties.FilterOperation) : void 0), ret.addPropertyResult("navigationOperation", "NavigationOperation", properties.NavigationOperation != null ? CfnTemplateCustomActionNavigationOperationPropertyFromCloudFormation(properties.NavigationOperation) : void 0), ret.addPropertyResult("setParametersOperation", "SetParametersOperation", properties.SetParametersOperation != null ? CfnTemplateCustomActionSetParametersOperationPropertyFromCloudFormation(properties.SetParametersOperation) : void 0), ret.addPropertyResult("urlOperation", "URLOperation", properties.URLOperation != null ? CfnTemplateCustomActionURLOperationPropertyFromCloudFormation(properties.URLOperation) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_VisualPalettePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("chartColor", cdk.validateString)(properties.chartColor)), errors.collect(cdk.propertyValidator("colorMap", cdk.listValidator(CfnTemplate_DataPathColorPropertyValidator))(properties.colorMap)), errors.wrap('supplied properties not correct for "VisualPaletteProperty"');
    }
    function cfnTemplateVisualPalettePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_VisualPalettePropertyValidator(properties).assertSuccess(), { ChartColor: cdk.stringToCloudFormation(properties.chartColor), ColorMap: cdk.listMapper(cfnTemplateDataPathColorPropertyToCloudFormation)(properties.colorMap) }) : properties;
    }
    function CfnTemplateVisualPalettePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("chartColor", "ChartColor", properties.ChartColor != null ? cfn_parse.FromCloudFormation.getString(properties.ChartColor) : void 0), ret.addPropertyResult("colorMap", "ColorMap", properties.ColorMap != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDataPathColorPropertyFromCloudFormation)(properties.ColorMap) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_VisualSubtitleLabelOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("formatText", CfnTemplate_LongFormatTextPropertyValidator)(properties.formatText)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "VisualSubtitleLabelOptionsProperty"');
    }
    function cfnTemplateVisualSubtitleLabelOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_VisualSubtitleLabelOptionsPropertyValidator(properties).assertSuccess(), { FormatText: cfnTemplateLongFormatTextPropertyToCloudFormation(properties.formatText), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnTemplateVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("formatText", "FormatText", properties.FormatText != null ? CfnTemplateLongFormatTextPropertyFromCloudFormation(properties.FormatText) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_VisualTitleLabelOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("formatText", CfnTemplate_ShortFormatTextPropertyValidator)(properties.formatText)), errors.collect(cdk.propertyValidator("visibility", cdk.validateString)(properties.visibility)), errors.wrap('supplied properties not correct for "VisualTitleLabelOptionsProperty"');
    }
    function cfnTemplateVisualTitleLabelOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_VisualTitleLabelOptionsPropertyValidator(properties).assertSuccess(), { FormatText: cfnTemplateShortFormatTextPropertyToCloudFormation(properties.formatText), Visibility: cdk.stringToCloudFormation(properties.visibility) }) : properties;
    }
    function CfnTemplateVisualTitleLabelOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("formatText", "FormatText", properties.FormatText != null ? CfnTemplateShortFormatTextPropertyFromCloudFormation(properties.FormatText) : void 0), ret.addPropertyResult("visibility", "Visibility", properties.Visibility != null ? cfn_parse.FromCloudFormation.getString(properties.Visibility) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_WaterfallChartAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("breakdowns", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.breakdowns)), errors.collect(cdk.propertyValidator("categories", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.categories)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(CfnTemplate_MeasureFieldPropertyValidator))(properties.values)), errors.wrap('supplied properties not correct for "WaterfallChartAggregatedFieldWellsProperty"');
    }
    function cfnTemplateWaterfallChartAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_WaterfallChartAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { Breakdowns: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.breakdowns), Categories: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.categories), Values: cdk.listMapper(cfnTemplateMeasureFieldPropertyToCloudFormation)(properties.values) }) : properties;
    }
    function CfnTemplateWaterfallChartAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("breakdowns", "Breakdowns", properties.Breakdowns != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.Breakdowns) : void 0), ret.addPropertyResult("categories", "Categories", properties.Categories != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.Categories) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMeasureFieldPropertyFromCloudFormation)(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_WaterfallChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryAxisDisplayOptions", CfnTemplate_AxisDisplayOptionsPropertyValidator)(properties.categoryAxisDisplayOptions)), errors.collect(cdk.propertyValidator("categoryAxisLabelOptions", CfnTemplate_ChartAxisLabelOptionsPropertyValidator)(properties.categoryAxisLabelOptions)), errors.collect(cdk.propertyValidator("dataLabels", CfnTemplate_DataLabelOptionsPropertyValidator)(properties.dataLabels)), errors.collect(cdk.propertyValidator("fieldWells", CfnTemplate_WaterfallChartFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("legend", CfnTemplate_LegendOptionsPropertyValidator)(properties.legend)), errors.collect(cdk.propertyValidator("primaryYAxisDisplayOptions", CfnTemplate_AxisDisplayOptionsPropertyValidator)(properties.primaryYAxisDisplayOptions)), errors.collect(cdk.propertyValidator("primaryYAxisLabelOptions", CfnTemplate_ChartAxisLabelOptionsPropertyValidator)(properties.primaryYAxisLabelOptions)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnTemplate_WaterfallChartSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("visualPalette", CfnTemplate_VisualPalettePropertyValidator)(properties.visualPalette)), errors.collect(cdk.propertyValidator("waterfallChartOptions", CfnTemplate_WaterfallChartOptionsPropertyValidator)(properties.waterfallChartOptions)), errors.wrap('supplied properties not correct for "WaterfallChartConfigurationProperty"');
    }
    function cfnTemplateWaterfallChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_WaterfallChartConfigurationPropertyValidator(properties).assertSuccess(), { CategoryAxisDisplayOptions: cfnTemplateAxisDisplayOptionsPropertyToCloudFormation(properties.categoryAxisDisplayOptions), CategoryAxisLabelOptions: cfnTemplateChartAxisLabelOptionsPropertyToCloudFormation(properties.categoryAxisLabelOptions), DataLabels: cfnTemplateDataLabelOptionsPropertyToCloudFormation(properties.dataLabels), FieldWells: cfnTemplateWaterfallChartFieldWellsPropertyToCloudFormation(properties.fieldWells), Legend: cfnTemplateLegendOptionsPropertyToCloudFormation(properties.legend), PrimaryYAxisDisplayOptions: cfnTemplateAxisDisplayOptionsPropertyToCloudFormation(properties.primaryYAxisDisplayOptions), PrimaryYAxisLabelOptions: cfnTemplateChartAxisLabelOptionsPropertyToCloudFormation(properties.primaryYAxisLabelOptions), SortConfiguration: cfnTemplateWaterfallChartSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), VisualPalette: cfnTemplateVisualPalettePropertyToCloudFormation(properties.visualPalette), WaterfallChartOptions: cfnTemplateWaterfallChartOptionsPropertyToCloudFormation(properties.waterfallChartOptions) }) : properties;
    }
    function CfnTemplateWaterfallChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryAxisDisplayOptions", "CategoryAxisDisplayOptions", properties.CategoryAxisDisplayOptions != null ? CfnTemplateAxisDisplayOptionsPropertyFromCloudFormation(properties.CategoryAxisDisplayOptions) : void 0), ret.addPropertyResult("categoryAxisLabelOptions", "CategoryAxisLabelOptions", properties.CategoryAxisLabelOptions != null ? CfnTemplateChartAxisLabelOptionsPropertyFromCloudFormation(properties.CategoryAxisLabelOptions) : void 0), ret.addPropertyResult("dataLabels", "DataLabels", properties.DataLabels != null ? CfnTemplateDataLabelOptionsPropertyFromCloudFormation(properties.DataLabels) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnTemplateWaterfallChartFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("legend", "Legend", properties.Legend != null ? CfnTemplateLegendOptionsPropertyFromCloudFormation(properties.Legend) : void 0), ret.addPropertyResult("primaryYAxisDisplayOptions", "PrimaryYAxisDisplayOptions", properties.PrimaryYAxisDisplayOptions != null ? CfnTemplateAxisDisplayOptionsPropertyFromCloudFormation(properties.PrimaryYAxisDisplayOptions) : void 0), ret.addPropertyResult("primaryYAxisLabelOptions", "PrimaryYAxisLabelOptions", properties.PrimaryYAxisLabelOptions != null ? CfnTemplateChartAxisLabelOptionsPropertyFromCloudFormation(properties.PrimaryYAxisLabelOptions) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnTemplateWaterfallChartSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("visualPalette", "VisualPalette", properties.VisualPalette != null ? CfnTemplateVisualPalettePropertyFromCloudFormation(properties.VisualPalette) : void 0), ret.addPropertyResult("waterfallChartOptions", "WaterfallChartOptions", properties.WaterfallChartOptions != null ? CfnTemplateWaterfallChartOptionsPropertyFromCloudFormation(properties.WaterfallChartOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_WaterfallChartFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("waterfallChartAggregatedFieldWells", CfnTemplate_WaterfallChartAggregatedFieldWellsPropertyValidator)(properties.waterfallChartAggregatedFieldWells)), errors.wrap('supplied properties not correct for "WaterfallChartFieldWellsProperty"');
    }
    function cfnTemplateWaterfallChartFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_WaterfallChartFieldWellsPropertyValidator(properties).assertSuccess(), { WaterfallChartAggregatedFieldWells: cfnTemplateWaterfallChartAggregatedFieldWellsPropertyToCloudFormation(properties.waterfallChartAggregatedFieldWells) }) : properties;
    }
    function CfnTemplateWaterfallChartFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("waterfallChartAggregatedFieldWells", "WaterfallChartAggregatedFieldWells", properties.WaterfallChartAggregatedFieldWells != null ? CfnTemplateWaterfallChartAggregatedFieldWellsPropertyFromCloudFormation(properties.WaterfallChartAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_WaterfallChartOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("totalBarLabel", cdk.validateString)(properties.totalBarLabel)), errors.wrap('supplied properties not correct for "WaterfallChartOptionsProperty"');
    }
    function cfnTemplateWaterfallChartOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_WaterfallChartOptionsPropertyValidator(properties).assertSuccess(), { TotalBarLabel: cdk.stringToCloudFormation(properties.totalBarLabel) }) : properties;
    }
    function CfnTemplateWaterfallChartOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("totalBarLabel", "TotalBarLabel", properties.TotalBarLabel != null ? cfn_parse.FromCloudFormation.getString(properties.TotalBarLabel) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_WaterfallChartSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("breakdownItemsLimit", CfnTemplate_ItemsLimitConfigurationPropertyValidator)(properties.breakdownItemsLimit)), errors.collect(cdk.propertyValidator("categorySort", cdk.listValidator(CfnTemplate_FieldSortOptionsPropertyValidator))(properties.categorySort)), errors.wrap('supplied properties not correct for "WaterfallChartSortConfigurationProperty"');
    }
    function cfnTemplateWaterfallChartSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_WaterfallChartSortConfigurationPropertyValidator(properties).assertSuccess(), { BreakdownItemsLimit: cfnTemplateItemsLimitConfigurationPropertyToCloudFormation(properties.breakdownItemsLimit), CategorySort: cdk.listMapper(cfnTemplateFieldSortOptionsPropertyToCloudFormation)(properties.categorySort) }) : properties;
    }
    function CfnTemplateWaterfallChartSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("breakdownItemsLimit", "BreakdownItemsLimit", properties.BreakdownItemsLimit != null ? CfnTemplateItemsLimitConfigurationPropertyFromCloudFormation(properties.BreakdownItemsLimit) : void 0), ret.addPropertyResult("categorySort", "CategorySort", properties.CategorySort != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateFieldSortOptionsPropertyFromCloudFormation)(properties.CategorySort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_WaterfallVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnTemplate_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnTemplate_WaterfallChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnTemplate_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnTemplate_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnTemplate_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "WaterfallVisualProperty"');
    }
    function cfnTemplateWaterfallVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_WaterfallVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnTemplateVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnTemplateWaterfallChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnTemplateColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnTemplateVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnTemplateVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnTemplateWaterfallVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnTemplateWaterfallChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnTemplateVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnTemplateVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_WhatIfPointScenarioPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("date", cdk.requiredValidator)(properties.date)), errors.collect(cdk.propertyValidator("date", cdk.validateString)(properties.date)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "WhatIfPointScenarioProperty"');
    }
    function cfnTemplateWhatIfPointScenarioPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_WhatIfPointScenarioPropertyValidator(properties).assertSuccess(), { Date: cdk.stringToCloudFormation(properties.date), Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnTemplateWhatIfPointScenarioPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("date", "Date", cfn_parse.FromCloudFormation.getString(properties.Date)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getNumber(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_WhatIfRangeScenarioPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endDate", cdk.requiredValidator)(properties.endDate)), errors.collect(cdk.propertyValidator("endDate", cdk.validateString)(properties.endDate)), errors.collect(cdk.propertyValidator("startDate", cdk.requiredValidator)(properties.startDate)), errors.collect(cdk.propertyValidator("startDate", cdk.validateString)(properties.startDate)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "WhatIfRangeScenarioProperty"');
    }
    function cfnTemplateWhatIfRangeScenarioPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_WhatIfRangeScenarioPropertyValidator(properties).assertSuccess(), { EndDate: cdk.stringToCloudFormation(properties.endDate), StartDate: cdk.stringToCloudFormation(properties.startDate), Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnTemplateWhatIfRangeScenarioPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endDate", "EndDate", cfn_parse.FromCloudFormation.getString(properties.EndDate)), ret.addPropertyResult("startDate", "StartDate", cfn_parse.FromCloudFormation.getString(properties.StartDate)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getNumber(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_WordCloudAggregatedFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("groupBy", cdk.listValidator(CfnTemplate_DimensionFieldPropertyValidator))(properties.groupBy)), errors.collect(cdk.propertyValidator("size", cdk.listValidator(CfnTemplate_MeasureFieldPropertyValidator))(properties.size)), errors.wrap('supplied properties not correct for "WordCloudAggregatedFieldWellsProperty"');
    }
    function cfnTemplateWordCloudAggregatedFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_WordCloudAggregatedFieldWellsPropertyValidator(properties).assertSuccess(), { GroupBy: cdk.listMapper(cfnTemplateDimensionFieldPropertyToCloudFormation)(properties.groupBy), Size: cdk.listMapper(cfnTemplateMeasureFieldPropertyToCloudFormation)(properties.size) }) : properties;
    }
    function CfnTemplateWordCloudAggregatedFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("groupBy", "GroupBy", properties.GroupBy != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateDimensionFieldPropertyFromCloudFormation)(properties.GroupBy) : void 0), ret.addPropertyResult("size", "Size", properties.Size != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateMeasureFieldPropertyFromCloudFormation)(properties.Size) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_WordCloudChartConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryLabelOptions", CfnTemplate_ChartAxisLabelOptionsPropertyValidator)(properties.categoryLabelOptions)), errors.collect(cdk.propertyValidator("fieldWells", CfnTemplate_WordCloudFieldWellsPropertyValidator)(properties.fieldWells)), errors.collect(cdk.propertyValidator("sortConfiguration", CfnTemplate_WordCloudSortConfigurationPropertyValidator)(properties.sortConfiguration)), errors.collect(cdk.propertyValidator("wordCloudOptions", CfnTemplate_WordCloudOptionsPropertyValidator)(properties.wordCloudOptions)), errors.wrap('supplied properties not correct for "WordCloudChartConfigurationProperty"');
    }
    function cfnTemplateWordCloudChartConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_WordCloudChartConfigurationPropertyValidator(properties).assertSuccess(), { CategoryLabelOptions: cfnTemplateChartAxisLabelOptionsPropertyToCloudFormation(properties.categoryLabelOptions), FieldWells: cfnTemplateWordCloudFieldWellsPropertyToCloudFormation(properties.fieldWells), SortConfiguration: cfnTemplateWordCloudSortConfigurationPropertyToCloudFormation(properties.sortConfiguration), WordCloudOptions: cfnTemplateWordCloudOptionsPropertyToCloudFormation(properties.wordCloudOptions) }) : properties;
    }
    function CfnTemplateWordCloudChartConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryLabelOptions", "CategoryLabelOptions", properties.CategoryLabelOptions != null ? CfnTemplateChartAxisLabelOptionsPropertyFromCloudFormation(properties.CategoryLabelOptions) : void 0), ret.addPropertyResult("fieldWells", "FieldWells", properties.FieldWells != null ? CfnTemplateWordCloudFieldWellsPropertyFromCloudFormation(properties.FieldWells) : void 0), ret.addPropertyResult("sortConfiguration", "SortConfiguration", properties.SortConfiguration != null ? CfnTemplateWordCloudSortConfigurationPropertyFromCloudFormation(properties.SortConfiguration) : void 0), ret.addPropertyResult("wordCloudOptions", "WordCloudOptions", properties.WordCloudOptions != null ? CfnTemplateWordCloudOptionsPropertyFromCloudFormation(properties.WordCloudOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_WordCloudFieldWellsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("wordCloudAggregatedFieldWells", CfnTemplate_WordCloudAggregatedFieldWellsPropertyValidator)(properties.wordCloudAggregatedFieldWells)), errors.wrap('supplied properties not correct for "WordCloudFieldWellsProperty"');
    }
    function cfnTemplateWordCloudFieldWellsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_WordCloudFieldWellsPropertyValidator(properties).assertSuccess(), { WordCloudAggregatedFieldWells: cfnTemplateWordCloudAggregatedFieldWellsPropertyToCloudFormation(properties.wordCloudAggregatedFieldWells) }) : properties;
    }
    function CfnTemplateWordCloudFieldWellsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("wordCloudAggregatedFieldWells", "WordCloudAggregatedFieldWells", properties.WordCloudAggregatedFieldWells != null ? CfnTemplateWordCloudAggregatedFieldWellsPropertyFromCloudFormation(properties.WordCloudAggregatedFieldWells) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_WordCloudOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudLayout", cdk.validateString)(properties.cloudLayout)), errors.collect(cdk.propertyValidator("maximumStringLength", cdk.validateNumber)(properties.maximumStringLength)), errors.collect(cdk.propertyValidator("wordCasing", cdk.validateString)(properties.wordCasing)), errors.collect(cdk.propertyValidator("wordOrientation", cdk.validateString)(properties.wordOrientation)), errors.collect(cdk.propertyValidator("wordPadding", cdk.validateString)(properties.wordPadding)), errors.collect(cdk.propertyValidator("wordScaling", cdk.validateString)(properties.wordScaling)), errors.wrap('supplied properties not correct for "WordCloudOptionsProperty"');
    }
    function cfnTemplateWordCloudOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_WordCloudOptionsPropertyValidator(properties).assertSuccess(), { CloudLayout: cdk.stringToCloudFormation(properties.cloudLayout), MaximumStringLength: cdk.numberToCloudFormation(properties.maximumStringLength), WordCasing: cdk.stringToCloudFormation(properties.wordCasing), WordOrientation: cdk.stringToCloudFormation(properties.wordOrientation), WordPadding: cdk.stringToCloudFormation(properties.wordPadding), WordScaling: cdk.stringToCloudFormation(properties.wordScaling) }) : properties;
    }
    function CfnTemplateWordCloudOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudLayout", "CloudLayout", properties.CloudLayout != null ? cfn_parse.FromCloudFormation.getString(properties.CloudLayout) : void 0), ret.addPropertyResult("maximumStringLength", "MaximumStringLength", properties.MaximumStringLength != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumStringLength) : void 0), ret.addPropertyResult("wordCasing", "WordCasing", properties.WordCasing != null ? cfn_parse.FromCloudFormation.getString(properties.WordCasing) : void 0), ret.addPropertyResult("wordOrientation", "WordOrientation", properties.WordOrientation != null ? cfn_parse.FromCloudFormation.getString(properties.WordOrientation) : void 0), ret.addPropertyResult("wordPadding", "WordPadding", properties.WordPadding != null ? cfn_parse.FromCloudFormation.getString(properties.WordPadding) : void 0), ret.addPropertyResult("wordScaling", "WordScaling", properties.WordScaling != null ? cfn_parse.FromCloudFormation.getString(properties.WordScaling) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_WordCloudSortConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("categoryItemsLimit", CfnTemplate_ItemsLimitConfigurationPropertyValidator)(properties.categoryItemsLimit)), errors.collect(cdk.propertyValidator("categorySort", cdk.listValidator(CfnTemplate_FieldSortOptionsPropertyValidator))(properties.categorySort)), errors.wrap('supplied properties not correct for "WordCloudSortConfigurationProperty"');
    }
    function cfnTemplateWordCloudSortConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_WordCloudSortConfigurationPropertyValidator(properties).assertSuccess(), { CategoryItemsLimit: cfnTemplateItemsLimitConfigurationPropertyToCloudFormation(properties.categoryItemsLimit), CategorySort: cdk.listMapper(cfnTemplateFieldSortOptionsPropertyToCloudFormation)(properties.categorySort) }) : properties;
    }
    function CfnTemplateWordCloudSortConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("categoryItemsLimit", "CategoryItemsLimit", properties.CategoryItemsLimit != null ? CfnTemplateItemsLimitConfigurationPropertyFromCloudFormation(properties.CategoryItemsLimit) : void 0), ret.addPropertyResult("categorySort", "CategorySort", properties.CategorySort != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateFieldSortOptionsPropertyFromCloudFormation)(properties.CategorySort) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTemplate_WordCloudVisualPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnTemplate_VisualCustomActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chartConfiguration", CfnTemplate_WordCloudChartConfigurationPropertyValidator)(properties.chartConfiguration)), errors.collect(cdk.propertyValidator("columnHierarchies", cdk.listValidator(CfnTemplate_ColumnHierarchyPropertyValidator))(properties.columnHierarchies)), errors.collect(cdk.propertyValidator("subtitle", CfnTemplate_VisualSubtitleLabelOptionsPropertyValidator)(properties.subtitle)), errors.collect(cdk.propertyValidator("title", CfnTemplate_VisualTitleLabelOptionsPropertyValidator)(properties.title)), errors.collect(cdk.propertyValidator("visualId", cdk.requiredValidator)(properties.visualId)), errors.collect(cdk.propertyValidator("visualId", cdk.validateString)(properties.visualId)), errors.wrap('supplied properties not correct for "WordCloudVisualProperty"');
    }
    function cfnTemplateWordCloudVisualPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_WordCloudVisualPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnTemplateVisualCustomActionPropertyToCloudFormation)(properties.actions), ChartConfiguration: cfnTemplateWordCloudChartConfigurationPropertyToCloudFormation(properties.chartConfiguration), ColumnHierarchies: cdk.listMapper(cfnTemplateColumnHierarchyPropertyToCloudFormation)(properties.columnHierarchies), Subtitle: cfnTemplateVisualSubtitleLabelOptionsPropertyToCloudFormation(properties.subtitle), Title: cfnTemplateVisualTitleLabelOptionsPropertyToCloudFormation(properties.title), VisualId: cdk.stringToCloudFormation(properties.visualId) }) : properties;
    }
    function CfnTemplateWordCloudVisualPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateVisualCustomActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chartConfiguration", "ChartConfiguration", properties.ChartConfiguration != null ? CfnTemplateWordCloudChartConfigurationPropertyFromCloudFormation(properties.ChartConfiguration) : void 0), ret.addPropertyResult("columnHierarchies", "ColumnHierarchies", properties.ColumnHierarchies != null ? cfn_parse.FromCloudFormation.getArray(CfnTemplateColumnHierarchyPropertyFromCloudFormation)(properties.ColumnHierarchies) : void 0), ret.addPropertyResult("subtitle", "Subtitle", properties.Subtitle != null ? CfnTemplateVisualSubtitleLabelOptionsPropertyFromCloudFormation(properties.Subtitle) : void 0), ret.addPropertyResult("title", "Title", properties.Title != null ? CfnTemplateVisualTitleLabelOptionsPropertyFromCloudFormation(properties.Title) : void 0), ret.addPropertyResult("visualId", "VisualId", cfn_parse.FromCloudFormation.getString(properties.VisualId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnThemePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("awsAccountId", cdk.requiredValidator)(properties.awsAccountId)), errors.collect(cdk.propertyValidator("awsAccountId", cdk.validateString)(properties.awsAccountId)), errors.collect(cdk.propertyValidator("baseThemeId", cdk.validateString)(properties.baseThemeId)), errors.collect(cdk.propertyValidator("configuration", CfnTheme_ThemeConfigurationPropertyValidator)(properties.configuration)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("permissions", cdk.listValidator(CfnTheme_ResourcePermissionPropertyValidator))(properties.permissions)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("themeId", cdk.requiredValidator)(properties.themeId)), errors.collect(cdk.propertyValidator("themeId", cdk.validateString)(properties.themeId)), errors.collect(cdk.propertyValidator("versionDescription", cdk.validateString)(properties.versionDescription)), errors.wrap('supplied properties not correct for "CfnThemeProps"');
    }
    function cfnThemePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnThemePropsValidator(properties).assertSuccess(), { AwsAccountId: cdk.stringToCloudFormation(properties.awsAccountId), ThemeId: cdk.stringToCloudFormation(properties.themeId), BaseThemeId: cdk.stringToCloudFormation(properties.baseThemeId), Configuration: cfnThemeThemeConfigurationPropertyToCloudFormation(properties.configuration), Name: cdk.stringToCloudFormation(properties.name), Permissions: cdk.listMapper(cfnThemeResourcePermissionPropertyToCloudFormation)(properties.permissions), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VersionDescription: cdk.stringToCloudFormation(properties.versionDescription) }) : properties;
    }
    function CfnThemePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("awsAccountId", "AwsAccountId", cfn_parse.FromCloudFormation.getString(properties.AwsAccountId)), ret.addPropertyResult("themeId", "ThemeId", cfn_parse.FromCloudFormation.getString(properties.ThemeId)), ret.addPropertyResult("baseThemeId", "BaseThemeId", properties.BaseThemeId != null ? cfn_parse.FromCloudFormation.getString(properties.BaseThemeId) : void 0), ret.addPropertyResult("configuration", "Configuration", properties.Configuration != null ? CfnThemeThemeConfigurationPropertyFromCloudFormation(properties.Configuration) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("permissions", "Permissions", properties.Permissions != null ? cfn_parse.FromCloudFormation.getArray(CfnThemeResourcePermissionPropertyFromCloudFormation)(properties.Permissions) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("versionDescription", "VersionDescription", properties.VersionDescription != null ? cfn_parse.FromCloudFormation.getString(properties.VersionDescription) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTheme = class _CfnTheme extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnThemePropsFromCloudFormation(resourceProperties), ret = new _CfnTheme(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTheme.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_quicksight_CfnThemeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTheme), error;
        }
        cdk.requireProperty(props, "awsAccountId", this), cdk.requireProperty(props, "themeId", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreatedTime = cdk.Token.asString(this.getAtt("CreatedTime", cdk.ResolutionTypeHint.STRING)), this.attrLastUpdatedTime = cdk.Token.asString(this.getAtt("LastUpdatedTime", cdk.ResolutionTypeHint.STRING)), this.attrType = cdk.Token.asString(this.getAtt("Type", cdk.ResolutionTypeHint.STRING)), this.attrVersionArn = cdk.Token.asString(this.getAtt("Version.Arn", cdk.ResolutionTypeHint.STRING)), this.attrVersionBaseThemeId = cdk.Token.asString(this.getAtt("Version.BaseThemeId", cdk.ResolutionTypeHint.STRING)), this.attrVersionCreatedTime = cdk.Token.asString(this.getAtt("Version.CreatedTime", cdk.ResolutionTypeHint.STRING)), this.attrVersionDescription = cdk.Token.asString(this.getAtt("Version.Description", cdk.ResolutionTypeHint.STRING)), this.attrVersionErrors = this.getAtt("Version.Errors", cdk.ResolutionTypeHint.STRING), this.attrVersionStatus = cdk.Token.asString(this.getAtt("Version.Status", cdk.ResolutionTypeHint.STRING)), this.attrVersionVersionNumber = this.getAtt("Version.VersionNumber", cdk.ResolutionTypeHint.STRING), this.awsAccountId = props.awsAccountId, this.themeId = props.themeId, this.baseThemeId = props.baseThemeId, this.configuration = props.configuration, this.name = props.name, this.permissions = props.permissions, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::QuickSight::Theme", props.tags, { tagPropertyName: "tags" }), this.versionDescription = props.versionDescription;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTheme.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { awsAccountId: this.awsAccountId, themeId: this.themeId, baseThemeId: this.baseThemeId, configuration: this.configuration, name: this.name, permissions: this.permissions, tags: this.tags.renderTags(), versionDescription: this.versionDescription };
      }
      renderProperties(props) {
        return cfnThemePropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnTheme[_g] = { fqn: "aws-cdk-lib.aws_quicksight.CfnTheme", version: "2.80.0" }, CfnTheme.CFN_RESOURCE_TYPE_NAME = "AWS::QuickSight::Theme", exports2.CfnTheme = CfnTheme;
    function CfnTheme_BorderStylePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("show", cdk.validateBoolean)(properties.show)), errors.wrap('supplied properties not correct for "BorderStyleProperty"');
    }
    function cfnThemeBorderStylePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTheme_BorderStylePropertyValidator(properties).assertSuccess(), { Show: cdk.booleanToCloudFormation(properties.show) }) : properties;
    }
    function CfnThemeBorderStylePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("show", "Show", properties.Show != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Show) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTheme_DataColorPalettePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("colors", cdk.listValidator(cdk.validateString))(properties.colors)), errors.collect(cdk.propertyValidator("emptyFillColor", cdk.validateString)(properties.emptyFillColor)), errors.collect(cdk.propertyValidator("minMaxGradient", cdk.listValidator(cdk.validateString))(properties.minMaxGradient)), errors.wrap('supplied properties not correct for "DataColorPaletteProperty"');
    }
    function cfnThemeDataColorPalettePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTheme_DataColorPalettePropertyValidator(properties).assertSuccess(), { Colors: cdk.listMapper(cdk.stringToCloudFormation)(properties.colors), EmptyFillColor: cdk.stringToCloudFormation(properties.emptyFillColor), MinMaxGradient: cdk.listMapper(cdk.stringToCloudFormation)(properties.minMaxGradient) }) : properties;
    }
    function CfnThemeDataColorPalettePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("colors", "Colors", properties.Colors != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Colors) : void 0), ret.addPropertyResult("emptyFillColor", "EmptyFillColor", properties.EmptyFillColor != null ? cfn_parse.FromCloudFormation.getString(properties.EmptyFillColor) : void 0), ret.addPropertyResult("minMaxGradient", "MinMaxGradient", properties.MinMaxGradient != null ? cfn_parse.FromCloudFormation.getStringArray(properties.MinMaxGradient) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTheme_FontPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fontFamily", cdk.validateString)(properties.fontFamily)), errors.wrap('supplied properties not correct for "FontProperty"');
    }
    function cfnThemeFontPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTheme_FontPropertyValidator(properties).assertSuccess(), { FontFamily: cdk.stringToCloudFormation(properties.fontFamily) }) : properties;
    }
    function CfnThemeFontPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fontFamily", "FontFamily", properties.FontFamily != null ? cfn_parse.FromCloudFormation.getString(properties.FontFamily) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTheme_GutterStylePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("show", cdk.validateBoolean)(properties.show)), errors.wrap('supplied properties not correct for "GutterStyleProperty"');
    }
    function cfnThemeGutterStylePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTheme_GutterStylePropertyValidator(properties).assertSuccess(), { Show: cdk.booleanToCloudFormation(properties.show) }) : properties;
    }
    function CfnThemeGutterStylePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("show", "Show", properties.Show != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Show) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTheme_MarginStylePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("show", cdk.validateBoolean)(properties.show)), errors.wrap('supplied properties not correct for "MarginStyleProperty"');
    }
    function cfnThemeMarginStylePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTheme_MarginStylePropertyValidator(properties).assertSuccess(), { Show: cdk.booleanToCloudFormation(properties.show) }) : properties;
    }
    function CfnThemeMarginStylePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("show", "Show", properties.Show != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Show) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTheme_ResourcePermissionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.requiredValidator)(properties.actions)), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(cdk.validateString))(properties.actions)), errors.collect(cdk.propertyValidator("principal", cdk.requiredValidator)(properties.principal)), errors.collect(cdk.propertyValidator("principal", cdk.validateString)(properties.principal)), errors.wrap('supplied properties not correct for "ResourcePermissionProperty"');
    }
    function cfnThemeResourcePermissionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTheme_ResourcePermissionPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cdk.stringToCloudFormation)(properties.actions), Principal: cdk.stringToCloudFormation(properties.principal) }) : properties;
    }
    function CfnThemeResourcePermissionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", cfn_parse.FromCloudFormation.getStringArray(properties.Actions)), ret.addPropertyResult("principal", "Principal", cfn_parse.FromCloudFormation.getString(properties.Principal)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTheme_SheetStylePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("tile", CfnTheme_TileStylePropertyValidator)(properties.tile)), errors.collect(cdk.propertyValidator("tileLayout", CfnTheme_TileLayoutStylePropertyValidator)(properties.tileLayout)), errors.wrap('supplied properties not correct for "SheetStyleProperty"');
    }
    function cfnThemeSheetStylePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTheme_SheetStylePropertyValidator(properties).assertSuccess(), { Tile: cfnThemeTileStylePropertyToCloudFormation(properties.tile), TileLayout: cfnThemeTileLayoutStylePropertyToCloudFormation(properties.tileLayout) }) : properties;
    }
    function CfnThemeSheetStylePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("tile", "Tile", properties.Tile != null ? CfnThemeTileStylePropertyFromCloudFormation(properties.Tile) : void 0), ret.addPropertyResult("tileLayout", "TileLayout", properties.TileLayout != null ? CfnThemeTileLayoutStylePropertyFromCloudFormation(properties.TileLayout) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTheme_ThemeConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataColorPalette", CfnTheme_DataColorPalettePropertyValidator)(properties.dataColorPalette)), errors.collect(cdk.propertyValidator("sheet", CfnTheme_SheetStylePropertyValidator)(properties.sheet)), errors.collect(cdk.propertyValidator("typography", CfnTheme_TypographyPropertyValidator)(properties.typography)), errors.collect(cdk.propertyValidator("uiColorPalette", CfnTheme_UIColorPalettePropertyValidator)(properties.uiColorPalette)), errors.wrap('supplied properties not correct for "ThemeConfigurationProperty"');
    }
    function cfnThemeThemeConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTheme_ThemeConfigurationPropertyValidator(properties).assertSuccess(), { DataColorPalette: cfnThemeDataColorPalettePropertyToCloudFormation(properties.dataColorPalette), Sheet: cfnThemeSheetStylePropertyToCloudFormation(properties.sheet), Typography: cfnThemeTypographyPropertyToCloudFormation(properties.typography), UIColorPalette: cfnThemeUIColorPalettePropertyToCloudFormation(properties.uiColorPalette) }) : properties;
    }
    function CfnThemeThemeConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataColorPalette", "DataColorPalette", properties.DataColorPalette != null ? CfnThemeDataColorPalettePropertyFromCloudFormation(properties.DataColorPalette) : void 0), ret.addPropertyResult("sheet", "Sheet", properties.Sheet != null ? CfnThemeSheetStylePropertyFromCloudFormation(properties.Sheet) : void 0), ret.addPropertyResult("typography", "Typography", properties.Typography != null ? CfnThemeTypographyPropertyFromCloudFormation(properties.Typography) : void 0), ret.addPropertyResult("uiColorPalette", "UIColorPalette", properties.UIColorPalette != null ? CfnThemeUIColorPalettePropertyFromCloudFormation(properties.UIColorPalette) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTheme_TileLayoutStylePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("gutter", CfnTheme_GutterStylePropertyValidator)(properties.gutter)), errors.collect(cdk.propertyValidator("margin", CfnTheme_MarginStylePropertyValidator)(properties.margin)), errors.wrap('supplied properties not correct for "TileLayoutStyleProperty"');
    }
    function cfnThemeTileLayoutStylePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTheme_TileLayoutStylePropertyValidator(properties).assertSuccess(), { Gutter: cfnThemeGutterStylePropertyToCloudFormation(properties.gutter), Margin: cfnThemeMarginStylePropertyToCloudFormation(properties.margin) }) : properties;
    }
    function CfnThemeTileLayoutStylePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("gutter", "Gutter", properties.Gutter != null ? CfnThemeGutterStylePropertyFromCloudFormation(properties.Gutter) : void 0), ret.addPropertyResult("margin", "Margin", properties.Margin != null ? CfnThemeMarginStylePropertyFromCloudFormation(properties.Margin) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTheme_TileStylePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("border", CfnTheme_BorderStylePropertyValidator)(properties.border)), errors.wrap('supplied properties not correct for "TileStyleProperty"');
    }
    function cfnThemeTileStylePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTheme_TileStylePropertyValidator(properties).assertSuccess(), { Border: cfnThemeBorderStylePropertyToCloudFormation(properties.border) }) : properties;
    }
    function CfnThemeTileStylePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("border", "Border", properties.Border != null ? CfnThemeBorderStylePropertyFromCloudFormation(properties.Border) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTheme_TypographyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fontFamilies", cdk.listValidator(CfnTheme_FontPropertyValidator))(properties.fontFamilies)), errors.wrap('supplied properties not correct for "TypographyProperty"');
    }
    function cfnThemeTypographyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTheme_TypographyPropertyValidator(properties).assertSuccess(), { FontFamilies: cdk.listMapper(cfnThemeFontPropertyToCloudFormation)(properties.fontFamilies) }) : properties;
    }
    function CfnThemeTypographyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fontFamilies", "FontFamilies", properties.FontFamilies != null ? cfn_parse.FromCloudFormation.getArray(CfnThemeFontPropertyFromCloudFormation)(properties.FontFamilies) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTheme_UIColorPalettePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accent", cdk.validateString)(properties.accent)), errors.collect(cdk.propertyValidator("accentForeground", cdk.validateString)(properties.accentForeground)), errors.collect(cdk.propertyValidator("danger", cdk.validateString)(properties.danger)), errors.collect(cdk.propertyValidator("dangerForeground", cdk.validateString)(properties.dangerForeground)), errors.collect(cdk.propertyValidator("dimension", cdk.validateString)(properties.dimension)), errors.collect(cdk.propertyValidator("dimensionForeground", cdk.validateString)(properties.dimensionForeground)), errors.collect(cdk.propertyValidator("measure", cdk.validateString)(properties.measure)), errors.collect(cdk.propertyValidator("measureForeground", cdk.validateString)(properties.measureForeground)), errors.collect(cdk.propertyValidator("primaryBackground", cdk.validateString)(properties.primaryBackground)), errors.collect(cdk.propertyValidator("primaryForeground", cdk.validateString)(properties.primaryForeground)), errors.collect(cdk.propertyValidator("secondaryBackground", cdk.validateString)(properties.secondaryBackground)), errors.collect(cdk.propertyValidator("secondaryForeground", cdk.validateString)(properties.secondaryForeground)), errors.collect(cdk.propertyValidator("success", cdk.validateString)(properties.success)), errors.collect(cdk.propertyValidator("successForeground", cdk.validateString)(properties.successForeground)), errors.collect(cdk.propertyValidator("warning", cdk.validateString)(properties.warning)), errors.collect(cdk.propertyValidator("warningForeground", cdk.validateString)(properties.warningForeground)), errors.wrap('supplied properties not correct for "UIColorPaletteProperty"');
    }
    function cfnThemeUIColorPalettePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTheme_UIColorPalettePropertyValidator(properties).assertSuccess(), { Accent: cdk.stringToCloudFormation(properties.accent), AccentForeground: cdk.stringToCloudFormation(properties.accentForeground), Danger: cdk.stringToCloudFormation(properties.danger), DangerForeground: cdk.stringToCloudFormation(properties.dangerForeground), Dimension: cdk.stringToCloudFormation(properties.dimension), DimensionForeground: cdk.stringToCloudFormation(properties.dimensionForeground), Measure: cdk.stringToCloudFormation(properties.measure), MeasureForeground: cdk.stringToCloudFormation(properties.measureForeground), PrimaryBackground: cdk.stringToCloudFormation(properties.primaryBackground), PrimaryForeground: cdk.stringToCloudFormation(properties.primaryForeground), SecondaryBackground: cdk.stringToCloudFormation(properties.secondaryBackground), SecondaryForeground: cdk.stringToCloudFormation(properties.secondaryForeground), Success: cdk.stringToCloudFormation(properties.success), SuccessForeground: cdk.stringToCloudFormation(properties.successForeground), Warning: cdk.stringToCloudFormation(properties.warning), WarningForeground: cdk.stringToCloudFormation(properties.warningForeground) }) : properties;
    }
    function CfnThemeUIColorPalettePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accent", "Accent", properties.Accent != null ? cfn_parse.FromCloudFormation.getString(properties.Accent) : void 0), ret.addPropertyResult("accentForeground", "AccentForeground", properties.AccentForeground != null ? cfn_parse.FromCloudFormation.getString(properties.AccentForeground) : void 0), ret.addPropertyResult("danger", "Danger", properties.Danger != null ? cfn_parse.FromCloudFormation.getString(properties.Danger) : void 0), ret.addPropertyResult("dangerForeground", "DangerForeground", properties.DangerForeground != null ? cfn_parse.FromCloudFormation.getString(properties.DangerForeground) : void 0), ret.addPropertyResult("dimension", "Dimension", properties.Dimension != null ? cfn_parse.FromCloudFormation.getString(properties.Dimension) : void 0), ret.addPropertyResult("dimensionForeground", "DimensionForeground", properties.DimensionForeground != null ? cfn_parse.FromCloudFormation.getString(properties.DimensionForeground) : void 0), ret.addPropertyResult("measure", "Measure", properties.Measure != null ? cfn_parse.FromCloudFormation.getString(properties.Measure) : void 0), ret.addPropertyResult("measureForeground", "MeasureForeground", properties.MeasureForeground != null ? cfn_parse.FromCloudFormation.getString(properties.MeasureForeground) : void 0), ret.addPropertyResult("primaryBackground", "PrimaryBackground", properties.PrimaryBackground != null ? cfn_parse.FromCloudFormation.getString(properties.PrimaryBackground) : void 0), ret.addPropertyResult("primaryForeground", "PrimaryForeground", properties.PrimaryForeground != null ? cfn_parse.FromCloudFormation.getString(properties.PrimaryForeground) : void 0), ret.addPropertyResult("secondaryBackground", "SecondaryBackground", properties.SecondaryBackground != null ? cfn_parse.FromCloudFormation.getString(properties.SecondaryBackground) : void 0), ret.addPropertyResult("secondaryForeground", "SecondaryForeground", properties.SecondaryForeground != null ? cfn_parse.FromCloudFormation.getString(properties.SecondaryForeground) : void 0), ret.addPropertyResult("success", "Success", properties.Success != null ? cfn_parse.FromCloudFormation.getString(properties.Success) : void 0), ret.addPropertyResult("successForeground", "SuccessForeground", properties.SuccessForeground != null ? cfn_parse.FromCloudFormation.getString(properties.SuccessForeground) : void 0), ret.addPropertyResult("warning", "Warning", properties.Warning != null ? cfn_parse.FromCloudFormation.getString(properties.Warning) : void 0), ret.addPropertyResult("warningForeground", "WarningForeground", properties.WarningForeground != null ? cfn_parse.FromCloudFormation.getString(properties.WarningForeground) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVPCConnectionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availabilityStatus", cdk.validateString)(properties.availabilityStatus)), errors.collect(cdk.propertyValidator("awsAccountId", cdk.validateString)(properties.awsAccountId)), errors.collect(cdk.propertyValidator("dnsResolvers", cdk.listValidator(cdk.validateString))(properties.dnsResolvers)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpcConnectionId", cdk.validateString)(properties.vpcConnectionId)), errors.wrap('supplied properties not correct for "CfnVPCConnectionProps"');
    }
    function cfnVPCConnectionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVPCConnectionPropsValidator(properties).assertSuccess(), { AvailabilityStatus: cdk.stringToCloudFormation(properties.availabilityStatus), AwsAccountId: cdk.stringToCloudFormation(properties.awsAccountId), DnsResolvers: cdk.listMapper(cdk.stringToCloudFormation)(properties.dnsResolvers), Name: cdk.stringToCloudFormation(properties.name), RoleArn: cdk.stringToCloudFormation(properties.roleArn), SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VPCConnectionId: cdk.stringToCloudFormation(properties.vpcConnectionId) }) : properties;
    }
    function CfnVPCConnectionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("availabilityStatus", "AvailabilityStatus", properties.AvailabilityStatus != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityStatus) : void 0), ret.addPropertyResult("awsAccountId", "AwsAccountId", properties.AwsAccountId != null ? cfn_parse.FromCloudFormation.getString(properties.AwsAccountId) : void 0), ret.addPropertyResult("dnsResolvers", "DnsResolvers", properties.DnsResolvers != null ? cfn_parse.FromCloudFormation.getStringArray(properties.DnsResolvers) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("subnetIds", "SubnetIds", properties.SubnetIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("vpcConnectionId", "VPCConnectionId", properties.VPCConnectionId != null ? cfn_parse.FromCloudFormation.getString(properties.VPCConnectionId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVPCConnection = class _CfnVPCConnection extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVPCConnectionPropsFromCloudFormation(resourceProperties), ret = new _CfnVPCConnection(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnVPCConnection.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_quicksight_CfnVPCConnectionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVPCConnection), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreatedTime = cdk.Token.asString(this.getAtt("CreatedTime", cdk.ResolutionTypeHint.STRING)), this.attrLastUpdatedTime = cdk.Token.asString(this.getAtt("LastUpdatedTime", cdk.ResolutionTypeHint.STRING)), this.attrNetworkInterfaces = this.getAtt("NetworkInterfaces", cdk.ResolutionTypeHint.STRING), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.attrVpcId = cdk.Token.asString(this.getAtt("VPCId", cdk.ResolutionTypeHint.STRING)), this.availabilityStatus = props.availabilityStatus, this.awsAccountId = props.awsAccountId, this.dnsResolvers = props.dnsResolvers, this.name = props.name, this.roleArn = props.roleArn, this.securityGroupIds = props.securityGroupIds, this.subnetIds = props.subnetIds, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::QuickSight::VPCConnection", props.tags, { tagPropertyName: "tags" }), this.vpcConnectionId = props.vpcConnectionId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVPCConnection.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { availabilityStatus: this.availabilityStatus, awsAccountId: this.awsAccountId, dnsResolvers: this.dnsResolvers, name: this.name, roleArn: this.roleArn, securityGroupIds: this.securityGroupIds, subnetIds: this.subnetIds, tags: this.tags.renderTags(), vpcConnectionId: this.vpcConnectionId };
      }
      renderProperties(props) {
        return cfnVPCConnectionPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnVPCConnection[_h] = { fqn: "aws-cdk-lib.aws_quicksight.CfnVPCConnection", version: "2.80.0" }, CfnVPCConnection.CFN_RESOURCE_TYPE_NAME = "AWS::QuickSight::VPCConnection", exports2.CfnVPCConnection = CfnVPCConnection;
  }
});

// node_modules/aws-cdk-lib/aws-quicksight/lib/index.js
var require_lib214 = __commonJS({
  "node_modules/aws-cdk-lib/aws-quicksight/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_quicksight_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-quicksight/index.js
var require_aws_quicksight = __commonJS({
  "node_modules/aws-cdk-lib/aws-quicksight/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib214(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-ram/lib/ram.generated.js
var require_ram_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-ram/lib/ram.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnResourceShare = exports2.CfnPermission = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnPermissionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("policyTemplate", cdk.requiredValidator)(properties.policyTemplate)), errors.collect(cdk.propertyValidator("policyTemplate", cdk.validateObject)(properties.policyTemplate)), errors.collect(cdk.propertyValidator("resourceType", cdk.requiredValidator)(properties.resourceType)), errors.collect(cdk.propertyValidator("resourceType", cdk.validateString)(properties.resourceType)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnPermissionProps"');
    }
    function cfnPermissionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPermissionPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), PolicyTemplate: cdk.objectToCloudFormation(properties.policyTemplate), ResourceType: cdk.stringToCloudFormation(properties.resourceType), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnPermissionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("policyTemplate", "PolicyTemplate", cfn_parse.FromCloudFormation.getAny(properties.PolicyTemplate)), ret.addPropertyResult("resourceType", "ResourceType", cfn_parse.FromCloudFormation.getString(properties.ResourceType)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPermission = class _CfnPermission extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPermissionPropsFromCloudFormation(resourceProperties), ret = new _CfnPermission(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPermission.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ram_CfnPermissionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPermission), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "policyTemplate", this), cdk.requireProperty(props, "resourceType", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrIsResourceTypeDefault = this.getAtt("IsResourceTypeDefault", cdk.ResolutionTypeHint.STRING), this.attrPermissionType = cdk.Token.asString(this.getAtt("PermissionType", cdk.ResolutionTypeHint.STRING)), this.attrVersion = cdk.Token.asString(this.getAtt("Version", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.policyTemplate = props.policyTemplate, this.resourceType = props.resourceType, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::RAM::Permission", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPermission.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, policyTemplate: this.policyTemplate, resourceType: this.resourceType, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnPermissionPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnPermission[_a] = { fqn: "aws-cdk-lib.aws_ram.CfnPermission", version: "2.80.0" }, CfnPermission.CFN_RESOURCE_TYPE_NAME = "AWS::RAM::Permission", exports2.CfnPermission = CfnPermission;
    function CfnResourceSharePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowExternalPrincipals", cdk.validateBoolean)(properties.allowExternalPrincipals)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("permissionArns", cdk.listValidator(cdk.validateString))(properties.permissionArns)), errors.collect(cdk.propertyValidator("principals", cdk.listValidator(cdk.validateString))(properties.principals)), errors.collect(cdk.propertyValidator("resourceArns", cdk.listValidator(cdk.validateString))(properties.resourceArns)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnResourceShareProps"');
    }
    function cfnResourceSharePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceSharePropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), AllowExternalPrincipals: cdk.booleanToCloudFormation(properties.allowExternalPrincipals), PermissionArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.permissionArns), Principals: cdk.listMapper(cdk.stringToCloudFormation)(properties.principals), ResourceArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.resourceArns), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnResourceSharePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("allowExternalPrincipals", "AllowExternalPrincipals", properties.AllowExternalPrincipals != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllowExternalPrincipals) : void 0), ret.addPropertyResult("permissionArns", "PermissionArns", properties.PermissionArns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.PermissionArns) : void 0), ret.addPropertyResult("principals", "Principals", properties.Principals != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Principals) : void 0), ret.addPropertyResult("resourceArns", "ResourceArns", properties.ResourceArns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ResourceArns) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResourceShare = class _CfnResourceShare extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResourceSharePropsFromCloudFormation(resourceProperties), ret = new _CfnResourceShare(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnResourceShare.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ram_CfnResourceShareProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResourceShare), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.allowExternalPrincipals = props.allowExternalPrincipals, this.permissionArns = props.permissionArns, this.principals = props.principals, this.resourceArns = props.resourceArns, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::RAM::ResourceShare", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResourceShare.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, allowExternalPrincipals: this.allowExternalPrincipals, permissionArns: this.permissionArns, principals: this.principals, resourceArns: this.resourceArns, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnResourceSharePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnResourceShare[_b] = { fqn: "aws-cdk-lib.aws_ram.CfnResourceShare", version: "2.80.0" }, CfnResourceShare.CFN_RESOURCE_TYPE_NAME = "AWS::RAM::ResourceShare", exports2.CfnResourceShare = CfnResourceShare;
  }
});

// node_modules/aws-cdk-lib/aws-ram/lib/index.js
var require_lib215 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ram/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_ram_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-ram/index.js
var require_aws_ram = __commonJS({
  "node_modules/aws-cdk-lib/aws-ram/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib215(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-redshift/lib/redshift.generated.js
var require_redshift_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-redshift/lib/redshift.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnScheduledAction = exports2.CfnEventSubscription = exports2.CfnEndpointAuthorization = exports2.CfnEndpointAccess = exports2.CfnClusterSubnetGroup = exports2.CfnClusterSecurityGroupIngress = exports2.CfnClusterSecurityGroup = exports2.CfnClusterParameterGroup = exports2.CfnCluster = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnClusterPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowVersionUpgrade", cdk.validateBoolean)(properties.allowVersionUpgrade)), errors.collect(cdk.propertyValidator("aquaConfigurationStatus", cdk.validateString)(properties.aquaConfigurationStatus)), errors.collect(cdk.propertyValidator("automatedSnapshotRetentionPeriod", cdk.validateNumber)(properties.automatedSnapshotRetentionPeriod)), errors.collect(cdk.propertyValidator("availabilityZone", cdk.validateString)(properties.availabilityZone)), errors.collect(cdk.propertyValidator("availabilityZoneRelocation", cdk.validateBoolean)(properties.availabilityZoneRelocation)), errors.collect(cdk.propertyValidator("availabilityZoneRelocationStatus", cdk.validateString)(properties.availabilityZoneRelocationStatus)), errors.collect(cdk.propertyValidator("classic", cdk.validateBoolean)(properties.classic)), errors.collect(cdk.propertyValidator("clusterIdentifier", cdk.validateString)(properties.clusterIdentifier)), errors.collect(cdk.propertyValidator("clusterParameterGroupName", cdk.validateString)(properties.clusterParameterGroupName)), errors.collect(cdk.propertyValidator("clusterSecurityGroups", cdk.listValidator(cdk.validateString))(properties.clusterSecurityGroups)), errors.collect(cdk.propertyValidator("clusterSubnetGroupName", cdk.validateString)(properties.clusterSubnetGroupName)), errors.collect(cdk.propertyValidator("clusterType", cdk.requiredValidator)(properties.clusterType)), errors.collect(cdk.propertyValidator("clusterType", cdk.validateString)(properties.clusterType)), errors.collect(cdk.propertyValidator("clusterVersion", cdk.validateString)(properties.clusterVersion)), errors.collect(cdk.propertyValidator("dbName", cdk.requiredValidator)(properties.dbName)), errors.collect(cdk.propertyValidator("dbName", cdk.validateString)(properties.dbName)), errors.collect(cdk.propertyValidator("deferMaintenance", cdk.validateBoolean)(properties.deferMaintenance)), errors.collect(cdk.propertyValidator("deferMaintenanceDuration", cdk.validateNumber)(properties.deferMaintenanceDuration)), errors.collect(cdk.propertyValidator("deferMaintenanceEndTime", cdk.validateString)(properties.deferMaintenanceEndTime)), errors.collect(cdk.propertyValidator("deferMaintenanceStartTime", cdk.validateString)(properties.deferMaintenanceStartTime)), errors.collect(cdk.propertyValidator("destinationRegion", cdk.validateString)(properties.destinationRegion)), errors.collect(cdk.propertyValidator("elasticIp", cdk.validateString)(properties.elasticIp)), errors.collect(cdk.propertyValidator("encrypted", cdk.validateBoolean)(properties.encrypted)), errors.collect(cdk.propertyValidator("endpoint", CfnCluster_EndpointPropertyValidator)(properties.endpoint)), errors.collect(cdk.propertyValidator("enhancedVpcRouting", cdk.validateBoolean)(properties.enhancedVpcRouting)), errors.collect(cdk.propertyValidator("hsmClientCertificateIdentifier", cdk.validateString)(properties.hsmClientCertificateIdentifier)), errors.collect(cdk.propertyValidator("hsmConfigurationIdentifier", cdk.validateString)(properties.hsmConfigurationIdentifier)), errors.collect(cdk.propertyValidator("iamRoles", cdk.listValidator(cdk.validateString))(properties.iamRoles)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("loggingProperties", CfnCluster_LoggingPropertiesPropertyValidator)(properties.loggingProperties)), errors.collect(cdk.propertyValidator("maintenanceTrackName", cdk.validateString)(properties.maintenanceTrackName)), errors.collect(cdk.propertyValidator("manualSnapshotRetentionPeriod", cdk.validateNumber)(properties.manualSnapshotRetentionPeriod)), errors.collect(cdk.propertyValidator("masterUserPassword", cdk.requiredValidator)(properties.masterUserPassword)), errors.collect(cdk.propertyValidator("masterUserPassword", cdk.validateString)(properties.masterUserPassword)), errors.collect(cdk.propertyValidator("masterUsername", cdk.requiredValidator)(properties.masterUsername)), errors.collect(cdk.propertyValidator("masterUsername", cdk.validateString)(properties.masterUsername)), errors.collect(cdk.propertyValidator("nodeType", cdk.requiredValidator)(properties.nodeType)), errors.collect(cdk.propertyValidator("nodeType", cdk.validateString)(properties.nodeType)), errors.collect(cdk.propertyValidator("numberOfNodes", cdk.validateNumber)(properties.numberOfNodes)), errors.collect(cdk.propertyValidator("ownerAccount", cdk.validateString)(properties.ownerAccount)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("preferredMaintenanceWindow", cdk.validateString)(properties.preferredMaintenanceWindow)), errors.collect(cdk.propertyValidator("publiclyAccessible", cdk.validateBoolean)(properties.publiclyAccessible)), errors.collect(cdk.propertyValidator("resourceAction", cdk.validateString)(properties.resourceAction)), errors.collect(cdk.propertyValidator("revisionTarget", cdk.validateString)(properties.revisionTarget)), errors.collect(cdk.propertyValidator("rotateEncryptionKey", cdk.validateBoolean)(properties.rotateEncryptionKey)), errors.collect(cdk.propertyValidator("snapshotClusterIdentifier", cdk.validateString)(properties.snapshotClusterIdentifier)), errors.collect(cdk.propertyValidator("snapshotCopyGrantName", cdk.validateString)(properties.snapshotCopyGrantName)), errors.collect(cdk.propertyValidator("snapshotCopyManual", cdk.validateBoolean)(properties.snapshotCopyManual)), errors.collect(cdk.propertyValidator("snapshotCopyRetentionPeriod", cdk.validateNumber)(properties.snapshotCopyRetentionPeriod)), errors.collect(cdk.propertyValidator("snapshotIdentifier", cdk.validateString)(properties.snapshotIdentifier)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpcSecurityGroupIds", cdk.listValidator(cdk.validateString))(properties.vpcSecurityGroupIds)), errors.wrap('supplied properties not correct for "CfnClusterProps"');
    }
    function cfnClusterPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClusterPropsValidator(properties).assertSuccess(), { ClusterType: cdk.stringToCloudFormation(properties.clusterType), DBName: cdk.stringToCloudFormation(properties.dbName), MasterUsername: cdk.stringToCloudFormation(properties.masterUsername), MasterUserPassword: cdk.stringToCloudFormation(properties.masterUserPassword), NodeType: cdk.stringToCloudFormation(properties.nodeType), AllowVersionUpgrade: cdk.booleanToCloudFormation(properties.allowVersionUpgrade), AquaConfigurationStatus: cdk.stringToCloudFormation(properties.aquaConfigurationStatus), AutomatedSnapshotRetentionPeriod: cdk.numberToCloudFormation(properties.automatedSnapshotRetentionPeriod), AvailabilityZone: cdk.stringToCloudFormation(properties.availabilityZone), AvailabilityZoneRelocation: cdk.booleanToCloudFormation(properties.availabilityZoneRelocation), AvailabilityZoneRelocationStatus: cdk.stringToCloudFormation(properties.availabilityZoneRelocationStatus), Classic: cdk.booleanToCloudFormation(properties.classic), ClusterIdentifier: cdk.stringToCloudFormation(properties.clusterIdentifier), ClusterParameterGroupName: cdk.stringToCloudFormation(properties.clusterParameterGroupName), ClusterSecurityGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.clusterSecurityGroups), ClusterSubnetGroupName: cdk.stringToCloudFormation(properties.clusterSubnetGroupName), ClusterVersion: cdk.stringToCloudFormation(properties.clusterVersion), DeferMaintenance: cdk.booleanToCloudFormation(properties.deferMaintenance), DeferMaintenanceDuration: cdk.numberToCloudFormation(properties.deferMaintenanceDuration), DeferMaintenanceEndTime: cdk.stringToCloudFormation(properties.deferMaintenanceEndTime), DeferMaintenanceStartTime: cdk.stringToCloudFormation(properties.deferMaintenanceStartTime), DestinationRegion: cdk.stringToCloudFormation(properties.destinationRegion), ElasticIp: cdk.stringToCloudFormation(properties.elasticIp), Encrypted: cdk.booleanToCloudFormation(properties.encrypted), Endpoint: cfnClusterEndpointPropertyToCloudFormation(properties.endpoint), EnhancedVpcRouting: cdk.booleanToCloudFormation(properties.enhancedVpcRouting), HsmClientCertificateIdentifier: cdk.stringToCloudFormation(properties.hsmClientCertificateIdentifier), HsmConfigurationIdentifier: cdk.stringToCloudFormation(properties.hsmConfigurationIdentifier), IamRoles: cdk.listMapper(cdk.stringToCloudFormation)(properties.iamRoles), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), LoggingProperties: cfnClusterLoggingPropertiesPropertyToCloudFormation(properties.loggingProperties), MaintenanceTrackName: cdk.stringToCloudFormation(properties.maintenanceTrackName), ManualSnapshotRetentionPeriod: cdk.numberToCloudFormation(properties.manualSnapshotRetentionPeriod), NumberOfNodes: cdk.numberToCloudFormation(properties.numberOfNodes), OwnerAccount: cdk.stringToCloudFormation(properties.ownerAccount), Port: cdk.numberToCloudFormation(properties.port), PreferredMaintenanceWindow: cdk.stringToCloudFormation(properties.preferredMaintenanceWindow), PubliclyAccessible: cdk.booleanToCloudFormation(properties.publiclyAccessible), ResourceAction: cdk.stringToCloudFormation(properties.resourceAction), RevisionTarget: cdk.stringToCloudFormation(properties.revisionTarget), RotateEncryptionKey: cdk.booleanToCloudFormation(properties.rotateEncryptionKey), SnapshotClusterIdentifier: cdk.stringToCloudFormation(properties.snapshotClusterIdentifier), SnapshotCopyGrantName: cdk.stringToCloudFormation(properties.snapshotCopyGrantName), SnapshotCopyManual: cdk.booleanToCloudFormation(properties.snapshotCopyManual), SnapshotCopyRetentionPeriod: cdk.numberToCloudFormation(properties.snapshotCopyRetentionPeriod), SnapshotIdentifier: cdk.stringToCloudFormation(properties.snapshotIdentifier), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VpcSecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.vpcSecurityGroupIds) }) : properties;
    }
    function CfnClusterPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clusterType", "ClusterType", cfn_parse.FromCloudFormation.getString(properties.ClusterType)), ret.addPropertyResult("dbName", "DBName", cfn_parse.FromCloudFormation.getString(properties.DBName)), ret.addPropertyResult("masterUsername", "MasterUsername", cfn_parse.FromCloudFormation.getString(properties.MasterUsername)), ret.addPropertyResult("masterUserPassword", "MasterUserPassword", cfn_parse.FromCloudFormation.getString(properties.MasterUserPassword)), ret.addPropertyResult("nodeType", "NodeType", cfn_parse.FromCloudFormation.getString(properties.NodeType)), ret.addPropertyResult("allowVersionUpgrade", "AllowVersionUpgrade", properties.AllowVersionUpgrade != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllowVersionUpgrade) : void 0), ret.addPropertyResult("aquaConfigurationStatus", "AquaConfigurationStatus", properties.AquaConfigurationStatus != null ? cfn_parse.FromCloudFormation.getString(properties.AquaConfigurationStatus) : void 0), ret.addPropertyResult("automatedSnapshotRetentionPeriod", "AutomatedSnapshotRetentionPeriod", properties.AutomatedSnapshotRetentionPeriod != null ? cfn_parse.FromCloudFormation.getNumber(properties.AutomatedSnapshotRetentionPeriod) : void 0), ret.addPropertyResult("availabilityZone", "AvailabilityZone", properties.AvailabilityZone != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityZone) : void 0), ret.addPropertyResult("availabilityZoneRelocation", "AvailabilityZoneRelocation", properties.AvailabilityZoneRelocation != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AvailabilityZoneRelocation) : void 0), ret.addPropertyResult("availabilityZoneRelocationStatus", "AvailabilityZoneRelocationStatus", properties.AvailabilityZoneRelocationStatus != null ? cfn_parse.FromCloudFormation.getString(properties.AvailabilityZoneRelocationStatus) : void 0), ret.addPropertyResult("classic", "Classic", properties.Classic != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Classic) : void 0), ret.addPropertyResult("clusterIdentifier", "ClusterIdentifier", properties.ClusterIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.ClusterIdentifier) : void 0), ret.addPropertyResult("clusterParameterGroupName", "ClusterParameterGroupName", properties.ClusterParameterGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.ClusterParameterGroupName) : void 0), ret.addPropertyResult("clusterSecurityGroups", "ClusterSecurityGroups", properties.ClusterSecurityGroups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ClusterSecurityGroups) : void 0), ret.addPropertyResult("clusterSubnetGroupName", "ClusterSubnetGroupName", properties.ClusterSubnetGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.ClusterSubnetGroupName) : void 0), ret.addPropertyResult("clusterVersion", "ClusterVersion", properties.ClusterVersion != null ? cfn_parse.FromCloudFormation.getString(properties.ClusterVersion) : void 0), ret.addPropertyResult("deferMaintenance", "DeferMaintenance", properties.DeferMaintenance != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeferMaintenance) : void 0), ret.addPropertyResult("deferMaintenanceDuration", "DeferMaintenanceDuration", properties.DeferMaintenanceDuration != null ? cfn_parse.FromCloudFormation.getNumber(properties.DeferMaintenanceDuration) : void 0), ret.addPropertyResult("deferMaintenanceEndTime", "DeferMaintenanceEndTime", properties.DeferMaintenanceEndTime != null ? cfn_parse.FromCloudFormation.getString(properties.DeferMaintenanceEndTime) : void 0), ret.addPropertyResult("deferMaintenanceStartTime", "DeferMaintenanceStartTime", properties.DeferMaintenanceStartTime != null ? cfn_parse.FromCloudFormation.getString(properties.DeferMaintenanceStartTime) : void 0), ret.addPropertyResult("destinationRegion", "DestinationRegion", properties.DestinationRegion != null ? cfn_parse.FromCloudFormation.getString(properties.DestinationRegion) : void 0), ret.addPropertyResult("elasticIp", "ElasticIp", properties.ElasticIp != null ? cfn_parse.FromCloudFormation.getString(properties.ElasticIp) : void 0), ret.addPropertyResult("encrypted", "Encrypted", properties.Encrypted != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Encrypted) : void 0), ret.addPropertyResult("endpoint", "Endpoint", properties.Endpoint != null ? CfnClusterEndpointPropertyFromCloudFormation(properties.Endpoint) : void 0), ret.addPropertyResult("enhancedVpcRouting", "EnhancedVpcRouting", properties.EnhancedVpcRouting != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnhancedVpcRouting) : void 0), ret.addPropertyResult("hsmClientCertificateIdentifier", "HsmClientCertificateIdentifier", properties.HsmClientCertificateIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.HsmClientCertificateIdentifier) : void 0), ret.addPropertyResult("hsmConfigurationIdentifier", "HsmConfigurationIdentifier", properties.HsmConfigurationIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.HsmConfigurationIdentifier) : void 0), ret.addPropertyResult("iamRoles", "IamRoles", properties.IamRoles != null ? cfn_parse.FromCloudFormation.getStringArray(properties.IamRoles) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("loggingProperties", "LoggingProperties", properties.LoggingProperties != null ? CfnClusterLoggingPropertiesPropertyFromCloudFormation(properties.LoggingProperties) : void 0), ret.addPropertyResult("maintenanceTrackName", "MaintenanceTrackName", properties.MaintenanceTrackName != null ? cfn_parse.FromCloudFormation.getString(properties.MaintenanceTrackName) : void 0), ret.addPropertyResult("manualSnapshotRetentionPeriod", "ManualSnapshotRetentionPeriod", properties.ManualSnapshotRetentionPeriod != null ? cfn_parse.FromCloudFormation.getNumber(properties.ManualSnapshotRetentionPeriod) : void 0), ret.addPropertyResult("numberOfNodes", "NumberOfNodes", properties.NumberOfNodes != null ? cfn_parse.FromCloudFormation.getNumber(properties.NumberOfNodes) : void 0), ret.addPropertyResult("ownerAccount", "OwnerAccount", properties.OwnerAccount != null ? cfn_parse.FromCloudFormation.getString(properties.OwnerAccount) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addPropertyResult("preferredMaintenanceWindow", "PreferredMaintenanceWindow", properties.PreferredMaintenanceWindow != null ? cfn_parse.FromCloudFormation.getString(properties.PreferredMaintenanceWindow) : void 0), ret.addPropertyResult("publiclyAccessible", "PubliclyAccessible", properties.PubliclyAccessible != null ? cfn_parse.FromCloudFormation.getBoolean(properties.PubliclyAccessible) : void 0), ret.addPropertyResult("resourceAction", "ResourceAction", properties.ResourceAction != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceAction) : void 0), ret.addPropertyResult("revisionTarget", "RevisionTarget", properties.RevisionTarget != null ? cfn_parse.FromCloudFormation.getString(properties.RevisionTarget) : void 0), ret.addPropertyResult("rotateEncryptionKey", "RotateEncryptionKey", properties.RotateEncryptionKey != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RotateEncryptionKey) : void 0), ret.addPropertyResult("snapshotClusterIdentifier", "SnapshotClusterIdentifier", properties.SnapshotClusterIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.SnapshotClusterIdentifier) : void 0), ret.addPropertyResult("snapshotCopyGrantName", "SnapshotCopyGrantName", properties.SnapshotCopyGrantName != null ? cfn_parse.FromCloudFormation.getString(properties.SnapshotCopyGrantName) : void 0), ret.addPropertyResult("snapshotCopyManual", "SnapshotCopyManual", properties.SnapshotCopyManual != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SnapshotCopyManual) : void 0), ret.addPropertyResult("snapshotCopyRetentionPeriod", "SnapshotCopyRetentionPeriod", properties.SnapshotCopyRetentionPeriod != null ? cfn_parse.FromCloudFormation.getNumber(properties.SnapshotCopyRetentionPeriod) : void 0), ret.addPropertyResult("snapshotIdentifier", "SnapshotIdentifier", properties.SnapshotIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.SnapshotIdentifier) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("vpcSecurityGroupIds", "VpcSecurityGroupIds", properties.VpcSecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.VpcSecurityGroupIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCluster = class _CfnCluster extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnClusterPropsFromCloudFormation(resourceProperties), ret = new _CfnCluster(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCluster.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_redshift_CfnClusterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCluster), error;
        }
        cdk.requireProperty(props, "clusterType", this), cdk.requireProperty(props, "dbName", this), cdk.requireProperty(props, "masterUserPassword", this), cdk.requireProperty(props, "masterUsername", this), cdk.requireProperty(props, "nodeType", this), this.attrDeferMaintenanceIdentifier = cdk.Token.asString(this.getAtt("DeferMaintenanceIdentifier", cdk.ResolutionTypeHint.STRING)), this.attrEndpointAddress = cdk.Token.asString(this.getAtt("Endpoint.Address", cdk.ResolutionTypeHint.STRING)), this.attrEndpointPort = cdk.Token.asString(this.getAtt("Endpoint.Port", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.clusterType = props.clusterType, this.dbName = props.dbName, this.masterUsername = props.masterUsername, this.masterUserPassword = props.masterUserPassword, this.nodeType = props.nodeType, this.allowVersionUpgrade = props.allowVersionUpgrade, this.aquaConfigurationStatus = props.aquaConfigurationStatus, this.automatedSnapshotRetentionPeriod = props.automatedSnapshotRetentionPeriod, this.availabilityZone = props.availabilityZone, this.availabilityZoneRelocation = props.availabilityZoneRelocation, this.availabilityZoneRelocationStatus = props.availabilityZoneRelocationStatus, this.classic = props.classic, this.clusterIdentifier = props.clusterIdentifier, this.clusterParameterGroupName = props.clusterParameterGroupName, this.clusterSecurityGroups = props.clusterSecurityGroups, this.clusterSubnetGroupName = props.clusterSubnetGroupName, this.clusterVersion = props.clusterVersion, this.deferMaintenance = props.deferMaintenance, this.deferMaintenanceDuration = props.deferMaintenanceDuration, this.deferMaintenanceEndTime = props.deferMaintenanceEndTime, this.deferMaintenanceStartTime = props.deferMaintenanceStartTime, this.destinationRegion = props.destinationRegion, this.elasticIp = props.elasticIp, this.encrypted = props.encrypted, this.endpoint = props.endpoint, this.enhancedVpcRouting = props.enhancedVpcRouting, this.hsmClientCertificateIdentifier = props.hsmClientCertificateIdentifier, this.hsmConfigurationIdentifier = props.hsmConfigurationIdentifier, this.iamRoles = props.iamRoles, this.kmsKeyId = props.kmsKeyId, this.loggingProperties = props.loggingProperties, this.maintenanceTrackName = props.maintenanceTrackName, this.manualSnapshotRetentionPeriod = props.manualSnapshotRetentionPeriod, this.numberOfNodes = props.numberOfNodes, this.ownerAccount = props.ownerAccount, this.port = props.port, this.preferredMaintenanceWindow = props.preferredMaintenanceWindow, this.publiclyAccessible = props.publiclyAccessible, this.resourceAction = props.resourceAction, this.revisionTarget = props.revisionTarget, this.rotateEncryptionKey = props.rotateEncryptionKey, this.snapshotClusterIdentifier = props.snapshotClusterIdentifier, this.snapshotCopyGrantName = props.snapshotCopyGrantName, this.snapshotCopyManual = props.snapshotCopyManual, this.snapshotCopyRetentionPeriod = props.snapshotCopyRetentionPeriod, this.snapshotIdentifier = props.snapshotIdentifier, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Redshift::Cluster", props.tags, { tagPropertyName: "tags" }), this.vpcSecurityGroupIds = props.vpcSecurityGroupIds, this.node.scope && cdk.Resource.isResource(this.node.scope) && this.node.addValidation({ validate: () => this.cfnOptions.deletionPolicy === void 0 ? ["'AWS::Redshift::Cluster' is a stateful resource type, and you must specify a Removal Policy for it. Call 'resource.applyRemovalPolicy()'."] : [] });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCluster.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { clusterType: this.clusterType, dbName: this.dbName, masterUsername: this.masterUsername, masterUserPassword: this.masterUserPassword, nodeType: this.nodeType, allowVersionUpgrade: this.allowVersionUpgrade, aquaConfigurationStatus: this.aquaConfigurationStatus, automatedSnapshotRetentionPeriod: this.automatedSnapshotRetentionPeriod, availabilityZone: this.availabilityZone, availabilityZoneRelocation: this.availabilityZoneRelocation, availabilityZoneRelocationStatus: this.availabilityZoneRelocationStatus, classic: this.classic, clusterIdentifier: this.clusterIdentifier, clusterParameterGroupName: this.clusterParameterGroupName, clusterSecurityGroups: this.clusterSecurityGroups, clusterSubnetGroupName: this.clusterSubnetGroupName, clusterVersion: this.clusterVersion, deferMaintenance: this.deferMaintenance, deferMaintenanceDuration: this.deferMaintenanceDuration, deferMaintenanceEndTime: this.deferMaintenanceEndTime, deferMaintenanceStartTime: this.deferMaintenanceStartTime, destinationRegion: this.destinationRegion, elasticIp: this.elasticIp, encrypted: this.encrypted, endpoint: this.endpoint, enhancedVpcRouting: this.enhancedVpcRouting, hsmClientCertificateIdentifier: this.hsmClientCertificateIdentifier, hsmConfigurationIdentifier: this.hsmConfigurationIdentifier, iamRoles: this.iamRoles, kmsKeyId: this.kmsKeyId, loggingProperties: this.loggingProperties, maintenanceTrackName: this.maintenanceTrackName, manualSnapshotRetentionPeriod: this.manualSnapshotRetentionPeriod, numberOfNodes: this.numberOfNodes, ownerAccount: this.ownerAccount, port: this.port, preferredMaintenanceWindow: this.preferredMaintenanceWindow, publiclyAccessible: this.publiclyAccessible, resourceAction: this.resourceAction, revisionTarget: this.revisionTarget, rotateEncryptionKey: this.rotateEncryptionKey, snapshotClusterIdentifier: this.snapshotClusterIdentifier, snapshotCopyGrantName: this.snapshotCopyGrantName, snapshotCopyManual: this.snapshotCopyManual, snapshotCopyRetentionPeriod: this.snapshotCopyRetentionPeriod, snapshotIdentifier: this.snapshotIdentifier, tags: this.tags.renderTags(), vpcSecurityGroupIds: this.vpcSecurityGroupIds };
      }
      renderProperties(props) {
        return cfnClusterPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnCluster[_a] = { fqn: "aws-cdk-lib.aws_redshift.CfnCluster", version: "2.80.0" }, CfnCluster.CFN_RESOURCE_TYPE_NAME = "AWS::Redshift::Cluster", exports2.CfnCluster = CfnCluster;
    function CfnCluster_EndpointPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("address", cdk.validateString)(properties.address)), errors.collect(cdk.propertyValidator("port", cdk.validateString)(properties.port)), errors.wrap('supplied properties not correct for "EndpointProperty"');
    }
    function cfnClusterEndpointPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_EndpointPropertyValidator(properties).assertSuccess(), { Address: cdk.stringToCloudFormation(properties.address), Port: cdk.stringToCloudFormation(properties.port) }) : properties;
    }
    function CfnClusterEndpointPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("address", "Address", properties.Address != null ? cfn_parse.FromCloudFormation.getString(properties.Address) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getString(properties.Port) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCluster_LoggingPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketName", cdk.requiredValidator)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.collect(cdk.propertyValidator("s3KeyPrefix", cdk.validateString)(properties.s3KeyPrefix)), errors.wrap('supplied properties not correct for "LoggingPropertiesProperty"');
    }
    function cfnClusterLoggingPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCluster_LoggingPropertiesPropertyValidator(properties).assertSuccess(), { BucketName: cdk.stringToCloudFormation(properties.bucketName), S3KeyPrefix: cdk.stringToCloudFormation(properties.s3KeyPrefix) }) : properties;
    }
    function CfnClusterLoggingPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketName", "BucketName", cfn_parse.FromCloudFormation.getString(properties.BucketName)), ret.addPropertyResult("s3KeyPrefix", "S3KeyPrefix", properties.S3KeyPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.S3KeyPrefix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnClusterParameterGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.requiredValidator)(properties.description)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("parameterGroupFamily", cdk.requiredValidator)(properties.parameterGroupFamily)), errors.collect(cdk.propertyValidator("parameterGroupFamily", cdk.validateString)(properties.parameterGroupFamily)), errors.collect(cdk.propertyValidator("parameterGroupName", cdk.validateString)(properties.parameterGroupName)), errors.collect(cdk.propertyValidator("parameters", cdk.listValidator(CfnClusterParameterGroup_ParameterPropertyValidator))(properties.parameters)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnClusterParameterGroupProps"');
    }
    function cfnClusterParameterGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClusterParameterGroupPropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), ParameterGroupFamily: cdk.stringToCloudFormation(properties.parameterGroupFamily), ParameterGroupName: cdk.stringToCloudFormation(properties.parameterGroupName), Parameters: cdk.listMapper(cfnClusterParameterGroupParameterPropertyToCloudFormation)(properties.parameters), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnClusterParameterGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", cfn_parse.FromCloudFormation.getString(properties.Description)), ret.addPropertyResult("parameterGroupFamily", "ParameterGroupFamily", cfn_parse.FromCloudFormation.getString(properties.ParameterGroupFamily)), ret.addPropertyResult("parameterGroupName", "ParameterGroupName", properties.ParameterGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.ParameterGroupName) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getArray(CfnClusterParameterGroupParameterPropertyFromCloudFormation)(properties.Parameters) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnClusterParameterGroup = class _CfnClusterParameterGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnClusterParameterGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnClusterParameterGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnClusterParameterGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_redshift_CfnClusterParameterGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnClusterParameterGroup), error;
        }
        cdk.requireProperty(props, "description", this), cdk.requireProperty(props, "parameterGroupFamily", this), this.description = props.description, this.parameterGroupFamily = props.parameterGroupFamily, this.parameterGroupName = props.parameterGroupName, this.parameters = props.parameters, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Redshift::ClusterParameterGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnClusterParameterGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, parameterGroupFamily: this.parameterGroupFamily, parameterGroupName: this.parameterGroupName, parameters: this.parameters, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnClusterParameterGroupPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnClusterParameterGroup[_b] = { fqn: "aws-cdk-lib.aws_redshift.CfnClusterParameterGroup", version: "2.80.0" }, CfnClusterParameterGroup.CFN_RESOURCE_TYPE_NAME = "AWS::Redshift::ClusterParameterGroup", exports2.CfnClusterParameterGroup = CfnClusterParameterGroup;
    function CfnClusterParameterGroup_ParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("parameterName", cdk.requiredValidator)(properties.parameterName)), errors.collect(cdk.propertyValidator("parameterName", cdk.validateString)(properties.parameterName)), errors.collect(cdk.propertyValidator("parameterValue", cdk.requiredValidator)(properties.parameterValue)), errors.collect(cdk.propertyValidator("parameterValue", cdk.validateString)(properties.parameterValue)), errors.wrap('supplied properties not correct for "ParameterProperty"');
    }
    function cfnClusterParameterGroupParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClusterParameterGroup_ParameterPropertyValidator(properties).assertSuccess(), { ParameterName: cdk.stringToCloudFormation(properties.parameterName), ParameterValue: cdk.stringToCloudFormation(properties.parameterValue) }) : properties;
    }
    function CfnClusterParameterGroupParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("parameterName", "ParameterName", cfn_parse.FromCloudFormation.getString(properties.ParameterName)), ret.addPropertyResult("parameterValue", "ParameterValue", cfn_parse.FromCloudFormation.getString(properties.ParameterValue)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnClusterSecurityGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.requiredValidator)(properties.description)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnClusterSecurityGroupProps"');
    }
    function cfnClusterSecurityGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClusterSecurityGroupPropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnClusterSecurityGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", cfn_parse.FromCloudFormation.getString(properties.Description)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnClusterSecurityGroup = class _CfnClusterSecurityGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnClusterSecurityGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnClusterSecurityGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnClusterSecurityGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_redshift_CfnClusterSecurityGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnClusterSecurityGroup), error;
        }
        cdk.requireProperty(props, "description", this), this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Redshift::ClusterSecurityGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnClusterSecurityGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnClusterSecurityGroupPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnClusterSecurityGroup[_c] = { fqn: "aws-cdk-lib.aws_redshift.CfnClusterSecurityGroup", version: "2.80.0" }, CfnClusterSecurityGroup.CFN_RESOURCE_TYPE_NAME = "AWS::Redshift::ClusterSecurityGroup", exports2.CfnClusterSecurityGroup = CfnClusterSecurityGroup;
    function CfnClusterSecurityGroupIngressPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cidrip", cdk.validateString)(properties.cidrip)), errors.collect(cdk.propertyValidator("clusterSecurityGroupName", cdk.requiredValidator)(properties.clusterSecurityGroupName)), errors.collect(cdk.propertyValidator("clusterSecurityGroupName", cdk.validateString)(properties.clusterSecurityGroupName)), errors.collect(cdk.propertyValidator("ec2SecurityGroupName", cdk.validateString)(properties.ec2SecurityGroupName)), errors.collect(cdk.propertyValidator("ec2SecurityGroupOwnerId", cdk.validateString)(properties.ec2SecurityGroupOwnerId)), errors.wrap('supplied properties not correct for "CfnClusterSecurityGroupIngressProps"');
    }
    function cfnClusterSecurityGroupIngressPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClusterSecurityGroupIngressPropsValidator(properties).assertSuccess(), { ClusterSecurityGroupName: cdk.stringToCloudFormation(properties.clusterSecurityGroupName), CIDRIP: cdk.stringToCloudFormation(properties.cidrip), EC2SecurityGroupName: cdk.stringToCloudFormation(properties.ec2SecurityGroupName), EC2SecurityGroupOwnerId: cdk.stringToCloudFormation(properties.ec2SecurityGroupOwnerId) }) : properties;
    }
    function CfnClusterSecurityGroupIngressPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clusterSecurityGroupName", "ClusterSecurityGroupName", cfn_parse.FromCloudFormation.getString(properties.ClusterSecurityGroupName)), ret.addPropertyResult("cidrip", "CIDRIP", properties.CIDRIP != null ? cfn_parse.FromCloudFormation.getString(properties.CIDRIP) : void 0), ret.addPropertyResult("ec2SecurityGroupName", "EC2SecurityGroupName", properties.EC2SecurityGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.EC2SecurityGroupName) : void 0), ret.addPropertyResult("ec2SecurityGroupOwnerId", "EC2SecurityGroupOwnerId", properties.EC2SecurityGroupOwnerId != null ? cfn_parse.FromCloudFormation.getString(properties.EC2SecurityGroupOwnerId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnClusterSecurityGroupIngress = class _CfnClusterSecurityGroupIngress extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnClusterSecurityGroupIngressPropsFromCloudFormation(resourceProperties), ret = new _CfnClusterSecurityGroupIngress(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnClusterSecurityGroupIngress.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_redshift_CfnClusterSecurityGroupIngressProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnClusterSecurityGroupIngress), error;
        }
        cdk.requireProperty(props, "clusterSecurityGroupName", this), this.clusterSecurityGroupName = props.clusterSecurityGroupName, this.cidrip = props.cidrip, this.ec2SecurityGroupName = props.ec2SecurityGroupName, this.ec2SecurityGroupOwnerId = props.ec2SecurityGroupOwnerId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnClusterSecurityGroupIngress.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { clusterSecurityGroupName: this.clusterSecurityGroupName, cidrip: this.cidrip, ec2SecurityGroupName: this.ec2SecurityGroupName, ec2SecurityGroupOwnerId: this.ec2SecurityGroupOwnerId };
      }
      renderProperties(props) {
        return cfnClusterSecurityGroupIngressPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnClusterSecurityGroupIngress[_d] = { fqn: "aws-cdk-lib.aws_redshift.CfnClusterSecurityGroupIngress", version: "2.80.0" }, CfnClusterSecurityGroupIngress.CFN_RESOURCE_TYPE_NAME = "AWS::Redshift::ClusterSecurityGroupIngress", exports2.CfnClusterSecurityGroupIngress = CfnClusterSecurityGroupIngress;
    function CfnClusterSubnetGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.requiredValidator)(properties.description)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("subnetIds", cdk.requiredValidator)(properties.subnetIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnClusterSubnetGroupProps"');
    }
    function cfnClusterSubnetGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClusterSubnetGroupPropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnClusterSubnetGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", cfn_parse.FromCloudFormation.getString(properties.Description)), ret.addPropertyResult("subnetIds", "SubnetIds", cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnClusterSubnetGroup = class _CfnClusterSubnetGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnClusterSubnetGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnClusterSubnetGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnClusterSubnetGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_redshift_CfnClusterSubnetGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnClusterSubnetGroup), error;
        }
        cdk.requireProperty(props, "description", this), cdk.requireProperty(props, "subnetIds", this), this.attrClusterSubnetGroupName = cdk.Token.asString(this.getAtt("ClusterSubnetGroupName", cdk.ResolutionTypeHint.STRING)), this.description = props.description, this.subnetIds = props.subnetIds, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Redshift::ClusterSubnetGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnClusterSubnetGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, subnetIds: this.subnetIds, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnClusterSubnetGroupPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnClusterSubnetGroup[_e] = { fqn: "aws-cdk-lib.aws_redshift.CfnClusterSubnetGroup", version: "2.80.0" }, CfnClusterSubnetGroup.CFN_RESOURCE_TYPE_NAME = "AWS::Redshift::ClusterSubnetGroup", exports2.CfnClusterSubnetGroup = CfnClusterSubnetGroup;
    function CfnEndpointAccessPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clusterIdentifier", cdk.requiredValidator)(properties.clusterIdentifier)), errors.collect(cdk.propertyValidator("clusterIdentifier", cdk.validateString)(properties.clusterIdentifier)), errors.collect(cdk.propertyValidator("endpointName", cdk.requiredValidator)(properties.endpointName)), errors.collect(cdk.propertyValidator("endpointName", cdk.validateString)(properties.endpointName)), errors.collect(cdk.propertyValidator("resourceOwner", cdk.validateString)(properties.resourceOwner)), errors.collect(cdk.propertyValidator("subnetGroupName", cdk.requiredValidator)(properties.subnetGroupName)), errors.collect(cdk.propertyValidator("subnetGroupName", cdk.validateString)(properties.subnetGroupName)), errors.collect(cdk.propertyValidator("vpcSecurityGroupIds", cdk.requiredValidator)(properties.vpcSecurityGroupIds)), errors.collect(cdk.propertyValidator("vpcSecurityGroupIds", cdk.listValidator(cdk.validateString))(properties.vpcSecurityGroupIds)), errors.wrap('supplied properties not correct for "CfnEndpointAccessProps"');
    }
    function cfnEndpointAccessPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpointAccessPropsValidator(properties).assertSuccess(), { ClusterIdentifier: cdk.stringToCloudFormation(properties.clusterIdentifier), EndpointName: cdk.stringToCloudFormation(properties.endpointName), SubnetGroupName: cdk.stringToCloudFormation(properties.subnetGroupName), VpcSecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.vpcSecurityGroupIds), ResourceOwner: cdk.stringToCloudFormation(properties.resourceOwner) }) : properties;
    }
    function CfnEndpointAccessPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clusterIdentifier", "ClusterIdentifier", cfn_parse.FromCloudFormation.getString(properties.ClusterIdentifier)), ret.addPropertyResult("endpointName", "EndpointName", cfn_parse.FromCloudFormation.getString(properties.EndpointName)), ret.addPropertyResult("subnetGroupName", "SubnetGroupName", cfn_parse.FromCloudFormation.getString(properties.SubnetGroupName)), ret.addPropertyResult("vpcSecurityGroupIds", "VpcSecurityGroupIds", cfn_parse.FromCloudFormation.getStringArray(properties.VpcSecurityGroupIds)), ret.addPropertyResult("resourceOwner", "ResourceOwner", properties.ResourceOwner != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceOwner) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEndpointAccess = class _CfnEndpointAccess extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEndpointAccessPropsFromCloudFormation(resourceProperties), ret = new _CfnEndpointAccess(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEndpointAccess.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_redshift_CfnEndpointAccessProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEndpointAccess), error;
        }
        cdk.requireProperty(props, "clusterIdentifier", this), cdk.requireProperty(props, "endpointName", this), cdk.requireProperty(props, "subnetGroupName", this), cdk.requireProperty(props, "vpcSecurityGroupIds", this), this.attrAddress = cdk.Token.asString(this.getAtt("Address", cdk.ResolutionTypeHint.STRING)), this.attrEndpointCreateTime = cdk.Token.asString(this.getAtt("EndpointCreateTime", cdk.ResolutionTypeHint.STRING)), this.attrEndpointStatus = cdk.Token.asString(this.getAtt("EndpointStatus", cdk.ResolutionTypeHint.STRING)), this.attrPort = cdk.Token.asNumber(this.getAtt("Port", cdk.ResolutionTypeHint.NUMBER)), this.attrVpcEndpointNetworkInterfaces = this.getAtt("VpcEndpoint.NetworkInterfaces", cdk.ResolutionTypeHint.STRING), this.attrVpcEndpointVpcEndpointId = cdk.Token.asString(this.getAtt("VpcEndpoint.VpcEndpointId", cdk.ResolutionTypeHint.STRING)), this.attrVpcEndpointVpcId = cdk.Token.asString(this.getAtt("VpcEndpoint.VpcId", cdk.ResolutionTypeHint.STRING)), this.attrVpcSecurityGroups = this.getAtt("VpcSecurityGroups", cdk.ResolutionTypeHint.STRING), this.clusterIdentifier = props.clusterIdentifier, this.endpointName = props.endpointName, this.subnetGroupName = props.subnetGroupName, this.vpcSecurityGroupIds = props.vpcSecurityGroupIds, this.resourceOwner = props.resourceOwner;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEndpointAccess.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { clusterIdentifier: this.clusterIdentifier, endpointName: this.endpointName, subnetGroupName: this.subnetGroupName, vpcSecurityGroupIds: this.vpcSecurityGroupIds, resourceOwner: this.resourceOwner };
      }
      renderProperties(props) {
        return cfnEndpointAccessPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnEndpointAccess[_f] = { fqn: "aws-cdk-lib.aws_redshift.CfnEndpointAccess", version: "2.80.0" }, CfnEndpointAccess.CFN_RESOURCE_TYPE_NAME = "AWS::Redshift::EndpointAccess", exports2.CfnEndpointAccess = CfnEndpointAccess;
    function CfnEndpointAuthorizationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("account", cdk.requiredValidator)(properties.account)), errors.collect(cdk.propertyValidator("account", cdk.validateString)(properties.account)), errors.collect(cdk.propertyValidator("clusterIdentifier", cdk.requiredValidator)(properties.clusterIdentifier)), errors.collect(cdk.propertyValidator("clusterIdentifier", cdk.validateString)(properties.clusterIdentifier)), errors.collect(cdk.propertyValidator("force", cdk.validateBoolean)(properties.force)), errors.collect(cdk.propertyValidator("vpcIds", cdk.listValidator(cdk.validateString))(properties.vpcIds)), errors.wrap('supplied properties not correct for "CfnEndpointAuthorizationProps"');
    }
    function cfnEndpointAuthorizationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpointAuthorizationPropsValidator(properties).assertSuccess(), { Account: cdk.stringToCloudFormation(properties.account), ClusterIdentifier: cdk.stringToCloudFormation(properties.clusterIdentifier), Force: cdk.booleanToCloudFormation(properties.force), VpcIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.vpcIds) }) : properties;
    }
    function CfnEndpointAuthorizationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("account", "Account", cfn_parse.FromCloudFormation.getString(properties.Account)), ret.addPropertyResult("clusterIdentifier", "ClusterIdentifier", cfn_parse.FromCloudFormation.getString(properties.ClusterIdentifier)), ret.addPropertyResult("force", "Force", properties.Force != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Force) : void 0), ret.addPropertyResult("vpcIds", "VpcIds", properties.VpcIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.VpcIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEndpointAuthorization = class _CfnEndpointAuthorization extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEndpointAuthorizationPropsFromCloudFormation(resourceProperties), ret = new _CfnEndpointAuthorization(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEndpointAuthorization.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_redshift_CfnEndpointAuthorizationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEndpointAuthorization), error;
        }
        cdk.requireProperty(props, "account", this), cdk.requireProperty(props, "clusterIdentifier", this), this.attrAllowedAllVpCs = this.getAtt("AllowedAllVPCs", cdk.ResolutionTypeHint.STRING), this.attrAllowedVpCs = cdk.Token.asList(this.getAtt("AllowedVPCs", cdk.ResolutionTypeHint.STRING_LIST)), this.attrAuthorizeTime = cdk.Token.asString(this.getAtt("AuthorizeTime", cdk.ResolutionTypeHint.STRING)), this.attrClusterStatus = cdk.Token.asString(this.getAtt("ClusterStatus", cdk.ResolutionTypeHint.STRING)), this.attrEndpointCount = cdk.Token.asNumber(this.getAtt("EndpointCount", cdk.ResolutionTypeHint.NUMBER)), this.attrGrantee = cdk.Token.asString(this.getAtt("Grantee", cdk.ResolutionTypeHint.STRING)), this.attrGrantor = cdk.Token.asString(this.getAtt("Grantor", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.account = props.account, this.clusterIdentifier = props.clusterIdentifier, this.force = props.force, this.vpcIds = props.vpcIds;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEndpointAuthorization.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { account: this.account, clusterIdentifier: this.clusterIdentifier, force: this.force, vpcIds: this.vpcIds };
      }
      renderProperties(props) {
        return cfnEndpointAuthorizationPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnEndpointAuthorization[_g] = { fqn: "aws-cdk-lib.aws_redshift.CfnEndpointAuthorization", version: "2.80.0" }, CfnEndpointAuthorization.CFN_RESOURCE_TYPE_NAME = "AWS::Redshift::EndpointAuthorization", exports2.CfnEndpointAuthorization = CfnEndpointAuthorization;
    function CfnEventSubscriptionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("eventCategories", cdk.listValidator(cdk.validateString))(properties.eventCategories)), errors.collect(cdk.propertyValidator("severity", cdk.validateString)(properties.severity)), errors.collect(cdk.propertyValidator("snsTopicArn", cdk.validateString)(properties.snsTopicArn)), errors.collect(cdk.propertyValidator("sourceIds", cdk.listValidator(cdk.validateString))(properties.sourceIds)), errors.collect(cdk.propertyValidator("sourceType", cdk.validateString)(properties.sourceType)), errors.collect(cdk.propertyValidator("subscriptionName", cdk.requiredValidator)(properties.subscriptionName)), errors.collect(cdk.propertyValidator("subscriptionName", cdk.validateString)(properties.subscriptionName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnEventSubscriptionProps"');
    }
    function cfnEventSubscriptionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEventSubscriptionPropsValidator(properties).assertSuccess(), { SubscriptionName: cdk.stringToCloudFormation(properties.subscriptionName), Enabled: cdk.booleanToCloudFormation(properties.enabled), EventCategories: cdk.listMapper(cdk.stringToCloudFormation)(properties.eventCategories), Severity: cdk.stringToCloudFormation(properties.severity), SnsTopicArn: cdk.stringToCloudFormation(properties.snsTopicArn), SourceIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.sourceIds), SourceType: cdk.stringToCloudFormation(properties.sourceType), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnEventSubscriptionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("subscriptionName", "SubscriptionName", cfn_parse.FromCloudFormation.getString(properties.SubscriptionName)), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("eventCategories", "EventCategories", properties.EventCategories != null ? cfn_parse.FromCloudFormation.getStringArray(properties.EventCategories) : void 0), ret.addPropertyResult("severity", "Severity", properties.Severity != null ? cfn_parse.FromCloudFormation.getString(properties.Severity) : void 0), ret.addPropertyResult("snsTopicArn", "SnsTopicArn", properties.SnsTopicArn != null ? cfn_parse.FromCloudFormation.getString(properties.SnsTopicArn) : void 0), ret.addPropertyResult("sourceIds", "SourceIds", properties.SourceIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SourceIds) : void 0), ret.addPropertyResult("sourceType", "SourceType", properties.SourceType != null ? cfn_parse.FromCloudFormation.getString(properties.SourceType) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEventSubscription = class _CfnEventSubscription extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEventSubscriptionPropsFromCloudFormation(resourceProperties), ret = new _CfnEventSubscription(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEventSubscription.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_redshift_CfnEventSubscriptionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEventSubscription), error;
        }
        cdk.requireProperty(props, "subscriptionName", this), this.attrCustSubscriptionId = cdk.Token.asString(this.getAtt("CustSubscriptionId", cdk.ResolutionTypeHint.STRING)), this.attrCustomerAwsId = cdk.Token.asString(this.getAtt("CustomerAwsId", cdk.ResolutionTypeHint.STRING)), this.attrEventCategoriesList = cdk.Token.asList(this.getAtt("EventCategoriesList", cdk.ResolutionTypeHint.STRING_LIST)), this.attrSourceIdsList = cdk.Token.asList(this.getAtt("SourceIdsList", cdk.ResolutionTypeHint.STRING_LIST)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.attrSubscriptionCreationTime = cdk.Token.asString(this.getAtt("SubscriptionCreationTime", cdk.ResolutionTypeHint.STRING)), this.subscriptionName = props.subscriptionName, this.enabled = props.enabled, this.eventCategories = props.eventCategories, this.severity = props.severity, this.snsTopicArn = props.snsTopicArn, this.sourceIds = props.sourceIds, this.sourceType = props.sourceType, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Redshift::EventSubscription", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEventSubscription.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { subscriptionName: this.subscriptionName, enabled: this.enabled, eventCategories: this.eventCategories, severity: this.severity, snsTopicArn: this.snsTopicArn, sourceIds: this.sourceIds, sourceType: this.sourceType, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnEventSubscriptionPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnEventSubscription[_h] = { fqn: "aws-cdk-lib.aws_redshift.CfnEventSubscription", version: "2.80.0" }, CfnEventSubscription.CFN_RESOURCE_TYPE_NAME = "AWS::Redshift::EventSubscription", exports2.CfnEventSubscription = CfnEventSubscription;
    function CfnScheduledActionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enable", cdk.validateBoolean)(properties.enable)), errors.collect(cdk.propertyValidator("endTime", cdk.validateString)(properties.endTime)), errors.collect(cdk.propertyValidator("iamRole", cdk.validateString)(properties.iamRole)), errors.collect(cdk.propertyValidator("schedule", cdk.validateString)(properties.schedule)), errors.collect(cdk.propertyValidator("scheduledActionDescription", cdk.validateString)(properties.scheduledActionDescription)), errors.collect(cdk.propertyValidator("scheduledActionName", cdk.requiredValidator)(properties.scheduledActionName)), errors.collect(cdk.propertyValidator("scheduledActionName", cdk.validateString)(properties.scheduledActionName)), errors.collect(cdk.propertyValidator("startTime", cdk.validateString)(properties.startTime)), errors.collect(cdk.propertyValidator("targetAction", CfnScheduledAction_ScheduledActionTypePropertyValidator)(properties.targetAction)), errors.wrap('supplied properties not correct for "CfnScheduledActionProps"');
    }
    function cfnScheduledActionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScheduledActionPropsValidator(properties).assertSuccess(), { ScheduledActionName: cdk.stringToCloudFormation(properties.scheduledActionName), Enable: cdk.booleanToCloudFormation(properties.enable), EndTime: cdk.stringToCloudFormation(properties.endTime), IamRole: cdk.stringToCloudFormation(properties.iamRole), Schedule: cdk.stringToCloudFormation(properties.schedule), ScheduledActionDescription: cdk.stringToCloudFormation(properties.scheduledActionDescription), StartTime: cdk.stringToCloudFormation(properties.startTime), TargetAction: cfnScheduledActionScheduledActionTypePropertyToCloudFormation(properties.targetAction) }) : properties;
    }
    function CfnScheduledActionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("scheduledActionName", "ScheduledActionName", cfn_parse.FromCloudFormation.getString(properties.ScheduledActionName)), ret.addPropertyResult("enable", "Enable", properties.Enable != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enable) : void 0), ret.addPropertyResult("endTime", "EndTime", properties.EndTime != null ? cfn_parse.FromCloudFormation.getString(properties.EndTime) : void 0), ret.addPropertyResult("iamRole", "IamRole", properties.IamRole != null ? cfn_parse.FromCloudFormation.getString(properties.IamRole) : void 0), ret.addPropertyResult("schedule", "Schedule", properties.Schedule != null ? cfn_parse.FromCloudFormation.getString(properties.Schedule) : void 0), ret.addPropertyResult("scheduledActionDescription", "ScheduledActionDescription", properties.ScheduledActionDescription != null ? cfn_parse.FromCloudFormation.getString(properties.ScheduledActionDescription) : void 0), ret.addPropertyResult("startTime", "StartTime", properties.StartTime != null ? cfn_parse.FromCloudFormation.getString(properties.StartTime) : void 0), ret.addPropertyResult("targetAction", "TargetAction", properties.TargetAction != null ? CfnScheduledActionScheduledActionTypePropertyFromCloudFormation(properties.TargetAction) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnScheduledAction = class _CfnScheduledAction extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnScheduledActionPropsFromCloudFormation(resourceProperties), ret = new _CfnScheduledAction(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnScheduledAction.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_redshift_CfnScheduledActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnScheduledAction), error;
        }
        cdk.requireProperty(props, "scheduledActionName", this), this.attrNextInvocations = cdk.Token.asList(this.getAtt("NextInvocations", cdk.ResolutionTypeHint.STRING_LIST)), this.attrState = cdk.Token.asString(this.getAtt("State", cdk.ResolutionTypeHint.STRING)), this.scheduledActionName = props.scheduledActionName, this.enable = props.enable, this.endTime = props.endTime, this.iamRole = props.iamRole, this.schedule = props.schedule, this.scheduledActionDescription = props.scheduledActionDescription, this.startTime = props.startTime, this.targetAction = props.targetAction;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnScheduledAction.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { scheduledActionName: this.scheduledActionName, enable: this.enable, endTime: this.endTime, iamRole: this.iamRole, schedule: this.schedule, scheduledActionDescription: this.scheduledActionDescription, startTime: this.startTime, targetAction: this.targetAction };
      }
      renderProperties(props) {
        return cfnScheduledActionPropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnScheduledAction[_j] = { fqn: "aws-cdk-lib.aws_redshift.CfnScheduledAction", version: "2.80.0" }, CfnScheduledAction.CFN_RESOURCE_TYPE_NAME = "AWS::Redshift::ScheduledAction", exports2.CfnScheduledAction = CfnScheduledAction;
    function CfnScheduledAction_PauseClusterMessagePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clusterIdentifier", cdk.requiredValidator)(properties.clusterIdentifier)), errors.collect(cdk.propertyValidator("clusterIdentifier", cdk.validateString)(properties.clusterIdentifier)), errors.wrap('supplied properties not correct for "PauseClusterMessageProperty"');
    }
    function cfnScheduledActionPauseClusterMessagePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScheduledAction_PauseClusterMessagePropertyValidator(properties).assertSuccess(), { ClusterIdentifier: cdk.stringToCloudFormation(properties.clusterIdentifier) }) : properties;
    }
    function CfnScheduledActionPauseClusterMessagePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clusterIdentifier", "ClusterIdentifier", cfn_parse.FromCloudFormation.getString(properties.ClusterIdentifier)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScheduledAction_ResizeClusterMessagePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("classic", cdk.validateBoolean)(properties.classic)), errors.collect(cdk.propertyValidator("clusterIdentifier", cdk.requiredValidator)(properties.clusterIdentifier)), errors.collect(cdk.propertyValidator("clusterIdentifier", cdk.validateString)(properties.clusterIdentifier)), errors.collect(cdk.propertyValidator("clusterType", cdk.validateString)(properties.clusterType)), errors.collect(cdk.propertyValidator("nodeType", cdk.validateString)(properties.nodeType)), errors.collect(cdk.propertyValidator("numberOfNodes", cdk.validateNumber)(properties.numberOfNodes)), errors.wrap('supplied properties not correct for "ResizeClusterMessageProperty"');
    }
    function cfnScheduledActionResizeClusterMessagePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScheduledAction_ResizeClusterMessagePropertyValidator(properties).assertSuccess(), { Classic: cdk.booleanToCloudFormation(properties.classic), ClusterIdentifier: cdk.stringToCloudFormation(properties.clusterIdentifier), ClusterType: cdk.stringToCloudFormation(properties.clusterType), NodeType: cdk.stringToCloudFormation(properties.nodeType), NumberOfNodes: cdk.numberToCloudFormation(properties.numberOfNodes) }) : properties;
    }
    function CfnScheduledActionResizeClusterMessagePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("classic", "Classic", properties.Classic != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Classic) : void 0), ret.addPropertyResult("clusterIdentifier", "ClusterIdentifier", cfn_parse.FromCloudFormation.getString(properties.ClusterIdentifier)), ret.addPropertyResult("clusterType", "ClusterType", properties.ClusterType != null ? cfn_parse.FromCloudFormation.getString(properties.ClusterType) : void 0), ret.addPropertyResult("nodeType", "NodeType", properties.NodeType != null ? cfn_parse.FromCloudFormation.getString(properties.NodeType) : void 0), ret.addPropertyResult("numberOfNodes", "NumberOfNodes", properties.NumberOfNodes != null ? cfn_parse.FromCloudFormation.getNumber(properties.NumberOfNodes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScheduledAction_ResumeClusterMessagePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clusterIdentifier", cdk.requiredValidator)(properties.clusterIdentifier)), errors.collect(cdk.propertyValidator("clusterIdentifier", cdk.validateString)(properties.clusterIdentifier)), errors.wrap('supplied properties not correct for "ResumeClusterMessageProperty"');
    }
    function cfnScheduledActionResumeClusterMessagePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScheduledAction_ResumeClusterMessagePropertyValidator(properties).assertSuccess(), { ClusterIdentifier: cdk.stringToCloudFormation(properties.clusterIdentifier) }) : properties;
    }
    function CfnScheduledActionResumeClusterMessagePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clusterIdentifier", "ClusterIdentifier", cfn_parse.FromCloudFormation.getString(properties.ClusterIdentifier)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScheduledAction_ScheduledActionTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("pauseCluster", CfnScheduledAction_PauseClusterMessagePropertyValidator)(properties.pauseCluster)), errors.collect(cdk.propertyValidator("resizeCluster", CfnScheduledAction_ResizeClusterMessagePropertyValidator)(properties.resizeCluster)), errors.collect(cdk.propertyValidator("resumeCluster", CfnScheduledAction_ResumeClusterMessagePropertyValidator)(properties.resumeCluster)), errors.wrap('supplied properties not correct for "ScheduledActionTypeProperty"');
    }
    function cfnScheduledActionScheduledActionTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScheduledAction_ScheduledActionTypePropertyValidator(properties).assertSuccess(), { PauseCluster: cfnScheduledActionPauseClusterMessagePropertyToCloudFormation(properties.pauseCluster), ResizeCluster: cfnScheduledActionResizeClusterMessagePropertyToCloudFormation(properties.resizeCluster), ResumeCluster: cfnScheduledActionResumeClusterMessagePropertyToCloudFormation(properties.resumeCluster) }) : properties;
    }
    function CfnScheduledActionScheduledActionTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("pauseCluster", "PauseCluster", properties.PauseCluster != null ? CfnScheduledActionPauseClusterMessagePropertyFromCloudFormation(properties.PauseCluster) : void 0), ret.addPropertyResult("resizeCluster", "ResizeCluster", properties.ResizeCluster != null ? CfnScheduledActionResizeClusterMessagePropertyFromCloudFormation(properties.ResizeCluster) : void 0), ret.addPropertyResult("resumeCluster", "ResumeCluster", properties.ResumeCluster != null ? CfnScheduledActionResumeClusterMessagePropertyFromCloudFormation(properties.ResumeCluster) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-redshift/lib/index.js
var require_lib216 = __commonJS({
  "node_modules/aws-cdk-lib/aws-redshift/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_redshift_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-redshift/index.js
var require_aws_redshift = __commonJS({
  "node_modules/aws-cdk-lib/aws-redshift/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib216(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-redshiftserverless/lib/redshiftserverless.generated.js
var require_redshiftserverless_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-redshiftserverless/lib/redshiftserverless.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnWorkgroup = exports2.CfnNamespace = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnNamespacePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("adminUserPassword", cdk.validateString)(properties.adminUserPassword)), errors.collect(cdk.propertyValidator("adminUsername", cdk.validateString)(properties.adminUsername)), errors.collect(cdk.propertyValidator("dbName", cdk.validateString)(properties.dbName)), errors.collect(cdk.propertyValidator("defaultIamRoleArn", cdk.validateString)(properties.defaultIamRoleArn)), errors.collect(cdk.propertyValidator("finalSnapshotName", cdk.validateString)(properties.finalSnapshotName)), errors.collect(cdk.propertyValidator("finalSnapshotRetentionPeriod", cdk.validateNumber)(properties.finalSnapshotRetentionPeriod)), errors.collect(cdk.propertyValidator("iamRoles", cdk.listValidator(cdk.validateString))(properties.iamRoles)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("logExports", cdk.listValidator(cdk.validateString))(properties.logExports)), errors.collect(cdk.propertyValidator("namespaceName", cdk.requiredValidator)(properties.namespaceName)), errors.collect(cdk.propertyValidator("namespaceName", cdk.validateString)(properties.namespaceName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnNamespaceProps"');
    }
    function cfnNamespacePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNamespacePropsValidator(properties).assertSuccess(), { NamespaceName: cdk.stringToCloudFormation(properties.namespaceName), AdminUsername: cdk.stringToCloudFormation(properties.adminUsername), AdminUserPassword: cdk.stringToCloudFormation(properties.adminUserPassword), DbName: cdk.stringToCloudFormation(properties.dbName), DefaultIamRoleArn: cdk.stringToCloudFormation(properties.defaultIamRoleArn), FinalSnapshotName: cdk.stringToCloudFormation(properties.finalSnapshotName), FinalSnapshotRetentionPeriod: cdk.numberToCloudFormation(properties.finalSnapshotRetentionPeriod), IamRoles: cdk.listMapper(cdk.stringToCloudFormation)(properties.iamRoles), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), LogExports: cdk.listMapper(cdk.stringToCloudFormation)(properties.logExports), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnNamespacePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("namespaceName", "NamespaceName", cfn_parse.FromCloudFormation.getString(properties.NamespaceName)), ret.addPropertyResult("adminUsername", "AdminUsername", properties.AdminUsername != null ? cfn_parse.FromCloudFormation.getString(properties.AdminUsername) : void 0), ret.addPropertyResult("adminUserPassword", "AdminUserPassword", properties.AdminUserPassword != null ? cfn_parse.FromCloudFormation.getString(properties.AdminUserPassword) : void 0), ret.addPropertyResult("dbName", "DbName", properties.DbName != null ? cfn_parse.FromCloudFormation.getString(properties.DbName) : void 0), ret.addPropertyResult("defaultIamRoleArn", "DefaultIamRoleArn", properties.DefaultIamRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultIamRoleArn) : void 0), ret.addPropertyResult("finalSnapshotName", "FinalSnapshotName", properties.FinalSnapshotName != null ? cfn_parse.FromCloudFormation.getString(properties.FinalSnapshotName) : void 0), ret.addPropertyResult("finalSnapshotRetentionPeriod", "FinalSnapshotRetentionPeriod", properties.FinalSnapshotRetentionPeriod != null ? cfn_parse.FromCloudFormation.getNumber(properties.FinalSnapshotRetentionPeriod) : void 0), ret.addPropertyResult("iamRoles", "IamRoles", properties.IamRoles != null ? cfn_parse.FromCloudFormation.getStringArray(properties.IamRoles) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("logExports", "LogExports", properties.LogExports != null ? cfn_parse.FromCloudFormation.getStringArray(properties.LogExports) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnNamespace = class _CfnNamespace extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnNamespacePropsFromCloudFormation(resourceProperties), ret = new _CfnNamespace(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnNamespace.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_redshiftserverless_CfnNamespaceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnNamespace), error;
        }
        cdk.requireProperty(props, "namespaceName", this), this.attrNamespaceAdminUsername = cdk.Token.asString(this.getAtt("Namespace.AdminUsername", cdk.ResolutionTypeHint.STRING)), this.attrNamespaceCreationDate = cdk.Token.asString(this.getAtt("Namespace.CreationDate", cdk.ResolutionTypeHint.STRING)), this.attrNamespaceDbName = cdk.Token.asString(this.getAtt("Namespace.DbName", cdk.ResolutionTypeHint.STRING)), this.attrNamespaceDefaultIamRoleArn = cdk.Token.asString(this.getAtt("Namespace.DefaultIamRoleArn", cdk.ResolutionTypeHint.STRING)), this.attrNamespaceIamRoles = cdk.Token.asList(this.getAtt("Namespace.IamRoles", cdk.ResolutionTypeHint.STRING_LIST)), this.attrNamespaceKmsKeyId = cdk.Token.asString(this.getAtt("Namespace.KmsKeyId", cdk.ResolutionTypeHint.STRING)), this.attrNamespaceLogExports = cdk.Token.asList(this.getAtt("Namespace.LogExports", cdk.ResolutionTypeHint.STRING_LIST)), this.attrNamespaceNamespaceArn = cdk.Token.asString(this.getAtt("Namespace.NamespaceArn", cdk.ResolutionTypeHint.STRING)), this.attrNamespaceNamespaceId = cdk.Token.asString(this.getAtt("Namespace.NamespaceId", cdk.ResolutionTypeHint.STRING)), this.attrNamespaceNamespaceName = cdk.Token.asString(this.getAtt("Namespace.NamespaceName", cdk.ResolutionTypeHint.STRING)), this.attrNamespaceStatus = cdk.Token.asString(this.getAtt("Namespace.Status", cdk.ResolutionTypeHint.STRING)), this.namespaceName = props.namespaceName, this.adminUsername = props.adminUsername, this.adminUserPassword = props.adminUserPassword, this.dbName = props.dbName, this.defaultIamRoleArn = props.defaultIamRoleArn, this.finalSnapshotName = props.finalSnapshotName, this.finalSnapshotRetentionPeriod = props.finalSnapshotRetentionPeriod, this.iamRoles = props.iamRoles, this.kmsKeyId = props.kmsKeyId, this.logExports = props.logExports, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::RedshiftServerless::Namespace", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnNamespace.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { namespaceName: this.namespaceName, adminUsername: this.adminUsername, adminUserPassword: this.adminUserPassword, dbName: this.dbName, defaultIamRoleArn: this.defaultIamRoleArn, finalSnapshotName: this.finalSnapshotName, finalSnapshotRetentionPeriod: this.finalSnapshotRetentionPeriod, iamRoles: this.iamRoles, kmsKeyId: this.kmsKeyId, logExports: this.logExports, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnNamespacePropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnNamespace[_a] = { fqn: "aws-cdk-lib.aws_redshiftserverless.CfnNamespace", version: "2.80.0" }, CfnNamespace.CFN_RESOURCE_TYPE_NAME = "AWS::RedshiftServerless::Namespace", exports2.CfnNamespace = CfnNamespace;
    function CfnWorkgroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("baseCapacity", cdk.validateNumber)(properties.baseCapacity)), errors.collect(cdk.propertyValidator("configParameters", cdk.listValidator(CfnWorkgroup_ConfigParameterPropertyValidator))(properties.configParameters)), errors.collect(cdk.propertyValidator("enhancedVpcRouting", cdk.validateBoolean)(properties.enhancedVpcRouting)), errors.collect(cdk.propertyValidator("namespaceName", cdk.validateString)(properties.namespaceName)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("publiclyAccessible", cdk.validateBoolean)(properties.publiclyAccessible)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("workgroupName", cdk.requiredValidator)(properties.workgroupName)), errors.collect(cdk.propertyValidator("workgroupName", cdk.validateString)(properties.workgroupName)), errors.wrap('supplied properties not correct for "CfnWorkgroupProps"');
    }
    function cfnWorkgroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkgroupPropsValidator(properties).assertSuccess(), { WorkgroupName: cdk.stringToCloudFormation(properties.workgroupName), BaseCapacity: cdk.numberToCloudFormation(properties.baseCapacity), ConfigParameters: cdk.listMapper(cfnWorkgroupConfigParameterPropertyToCloudFormation)(properties.configParameters), EnhancedVpcRouting: cdk.booleanToCloudFormation(properties.enhancedVpcRouting), NamespaceName: cdk.stringToCloudFormation(properties.namespaceName), Port: cdk.numberToCloudFormation(properties.port), PubliclyAccessible: cdk.booleanToCloudFormation(properties.publiclyAccessible), SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnWorkgroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("workgroupName", "WorkgroupName", cfn_parse.FromCloudFormation.getString(properties.WorkgroupName)), ret.addPropertyResult("baseCapacity", "BaseCapacity", properties.BaseCapacity != null ? cfn_parse.FromCloudFormation.getNumber(properties.BaseCapacity) : void 0), ret.addPropertyResult("configParameters", "ConfigParameters", properties.ConfigParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnWorkgroupConfigParameterPropertyFromCloudFormation)(properties.ConfigParameters) : void 0), ret.addPropertyResult("enhancedVpcRouting", "EnhancedVpcRouting", properties.EnhancedVpcRouting != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnhancedVpcRouting) : void 0), ret.addPropertyResult("namespaceName", "NamespaceName", properties.NamespaceName != null ? cfn_parse.FromCloudFormation.getString(properties.NamespaceName) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addPropertyResult("publiclyAccessible", "PubliclyAccessible", properties.PubliclyAccessible != null ? cfn_parse.FromCloudFormation.getBoolean(properties.PubliclyAccessible) : void 0), ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("subnetIds", "SubnetIds", properties.SubnetIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnWorkgroup = class _CfnWorkgroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnWorkgroupPropsFromCloudFormation(resourceProperties), ret = new _CfnWorkgroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnWorkgroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_redshiftserverless_CfnWorkgroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnWorkgroup), error;
        }
        cdk.requireProperty(props, "workgroupName", this), this.attrWorkgroupBaseCapacity = cdk.Token.asNumber(this.getAtt("Workgroup.BaseCapacity", cdk.ResolutionTypeHint.NUMBER)), this.attrWorkgroupConfigParameters = this.getAtt("Workgroup.ConfigParameters", cdk.ResolutionTypeHint.STRING), this.attrWorkgroupCreationDate = cdk.Token.asString(this.getAtt("Workgroup.CreationDate", cdk.ResolutionTypeHint.STRING)), this.attrWorkgroupEndpointAddress = cdk.Token.asString(this.getAtt("Workgroup.Endpoint.Address", cdk.ResolutionTypeHint.STRING)), this.attrWorkgroupEndpointPort = cdk.Token.asNumber(this.getAtt("Workgroup.Endpoint.Port", cdk.ResolutionTypeHint.NUMBER)), this.attrWorkgroupEndpointVpcEndpoints = this.getAtt("Workgroup.Endpoint.VpcEndpoints", cdk.ResolutionTypeHint.STRING), this.attrWorkgroupEnhancedVpcRouting = this.getAtt("Workgroup.EnhancedVpcRouting", cdk.ResolutionTypeHint.STRING), this.attrWorkgroupNamespaceName = cdk.Token.asString(this.getAtt("Workgroup.NamespaceName", cdk.ResolutionTypeHint.STRING)), this.attrWorkgroupPubliclyAccessible = this.getAtt("Workgroup.PubliclyAccessible", cdk.ResolutionTypeHint.STRING), this.attrWorkgroupSecurityGroupIds = cdk.Token.asList(this.getAtt("Workgroup.SecurityGroupIds", cdk.ResolutionTypeHint.STRING_LIST)), this.attrWorkgroupStatus = cdk.Token.asString(this.getAtt("Workgroup.Status", cdk.ResolutionTypeHint.STRING)), this.attrWorkgroupSubnetIds = cdk.Token.asList(this.getAtt("Workgroup.SubnetIds", cdk.ResolutionTypeHint.STRING_LIST)), this.attrWorkgroupWorkgroupArn = cdk.Token.asString(this.getAtt("Workgroup.WorkgroupArn", cdk.ResolutionTypeHint.STRING)), this.attrWorkgroupWorkgroupId = cdk.Token.asString(this.getAtt("Workgroup.WorkgroupId", cdk.ResolutionTypeHint.STRING)), this.attrWorkgroupWorkgroupName = cdk.Token.asString(this.getAtt("Workgroup.WorkgroupName", cdk.ResolutionTypeHint.STRING)), this.workgroupName = props.workgroupName, this.baseCapacity = props.baseCapacity, this.configParameters = props.configParameters, this.enhancedVpcRouting = props.enhancedVpcRouting, this.namespaceName = props.namespaceName, this.port = props.port, this.publiclyAccessible = props.publiclyAccessible, this.securityGroupIds = props.securityGroupIds, this.subnetIds = props.subnetIds, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::RedshiftServerless::Workgroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnWorkgroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { workgroupName: this.workgroupName, baseCapacity: this.baseCapacity, configParameters: this.configParameters, enhancedVpcRouting: this.enhancedVpcRouting, namespaceName: this.namespaceName, port: this.port, publiclyAccessible: this.publiclyAccessible, securityGroupIds: this.securityGroupIds, subnetIds: this.subnetIds, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnWorkgroupPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnWorkgroup[_b] = { fqn: "aws-cdk-lib.aws_redshiftserverless.CfnWorkgroup", version: "2.80.0" }, CfnWorkgroup.CFN_RESOURCE_TYPE_NAME = "AWS::RedshiftServerless::Workgroup", exports2.CfnWorkgroup = CfnWorkgroup;
    function CfnWorkgroup_ConfigParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("parameterKey", cdk.validateString)(properties.parameterKey)), errors.collect(cdk.propertyValidator("parameterValue", cdk.validateString)(properties.parameterValue)), errors.wrap('supplied properties not correct for "ConfigParameterProperty"');
    }
    function cfnWorkgroupConfigParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkgroup_ConfigParameterPropertyValidator(properties).assertSuccess(), { ParameterKey: cdk.stringToCloudFormation(properties.parameterKey), ParameterValue: cdk.stringToCloudFormation(properties.parameterValue) }) : properties;
    }
    function CfnWorkgroupConfigParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("parameterKey", "ParameterKey", properties.ParameterKey != null ? cfn_parse.FromCloudFormation.getString(properties.ParameterKey) : void 0), ret.addPropertyResult("parameterValue", "ParameterValue", properties.ParameterValue != null ? cfn_parse.FromCloudFormation.getString(properties.ParameterValue) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-redshiftserverless/lib/index.js
var require_lib217 = __commonJS({
  "node_modules/aws-cdk-lib/aws-redshiftserverless/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_redshiftserverless_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-redshiftserverless/index.js
var require_aws_redshiftserverless = __commonJS({
  "node_modules/aws-cdk-lib/aws-redshiftserverless/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib217(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-refactorspaces/lib/refactorspaces.generated.js
var require_refactorspaces_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-refactorspaces/lib/refactorspaces.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnService = exports2.CfnRoute = exports2.CfnEnvironment = exports2.CfnApplication = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnApplicationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("apiGatewayProxy", CfnApplication_ApiGatewayProxyInputPropertyValidator)(properties.apiGatewayProxy)), errors.collect(cdk.propertyValidator("environmentIdentifier", cdk.requiredValidator)(properties.environmentIdentifier)), errors.collect(cdk.propertyValidator("environmentIdentifier", cdk.validateString)(properties.environmentIdentifier)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("proxyType", cdk.requiredValidator)(properties.proxyType)), errors.collect(cdk.propertyValidator("proxyType", cdk.validateString)(properties.proxyType)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpcId", cdk.requiredValidator)(properties.vpcId)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "CfnApplicationProps"');
    }
    function cfnApplicationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationPropsValidator(properties).assertSuccess(), { EnvironmentIdentifier: cdk.stringToCloudFormation(properties.environmentIdentifier), Name: cdk.stringToCloudFormation(properties.name), ProxyType: cdk.stringToCloudFormation(properties.proxyType), VpcId: cdk.stringToCloudFormation(properties.vpcId), ApiGatewayProxy: cfnApplicationApiGatewayProxyInputPropertyToCloudFormation(properties.apiGatewayProxy), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnApplicationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("environmentIdentifier", "EnvironmentIdentifier", cfn_parse.FromCloudFormation.getString(properties.EnvironmentIdentifier)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("proxyType", "ProxyType", cfn_parse.FromCloudFormation.getString(properties.ProxyType)), ret.addPropertyResult("vpcId", "VpcId", cfn_parse.FromCloudFormation.getString(properties.VpcId)), ret.addPropertyResult("apiGatewayProxy", "ApiGatewayProxy", properties.ApiGatewayProxy != null ? CfnApplicationApiGatewayProxyInputPropertyFromCloudFormation(properties.ApiGatewayProxy) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApplication = class _CfnApplication extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApplicationPropsFromCloudFormation(resourceProperties), ret = new _CfnApplication(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApplication.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_refactorspaces_CfnApplicationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApplication), error;
        }
        cdk.requireProperty(props, "environmentIdentifier", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "proxyType", this), cdk.requireProperty(props, "vpcId", this), this.attrApiGatewayId = cdk.Token.asString(this.getAtt("ApiGatewayId", cdk.ResolutionTypeHint.STRING)), this.attrApplicationIdentifier = cdk.Token.asString(this.getAtt("ApplicationIdentifier", cdk.ResolutionTypeHint.STRING)), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrNlbArn = cdk.Token.asString(this.getAtt("NlbArn", cdk.ResolutionTypeHint.STRING)), this.attrNlbName = cdk.Token.asString(this.getAtt("NlbName", cdk.ResolutionTypeHint.STRING)), this.attrProxyUrl = cdk.Token.asString(this.getAtt("ProxyUrl", cdk.ResolutionTypeHint.STRING)), this.attrStageName = cdk.Token.asString(this.getAtt("StageName", cdk.ResolutionTypeHint.STRING)), this.attrVpcLinkId = cdk.Token.asString(this.getAtt("VpcLinkId", cdk.ResolutionTypeHint.STRING)), this.environmentIdentifier = props.environmentIdentifier, this.name = props.name, this.proxyType = props.proxyType, this.vpcId = props.vpcId, this.apiGatewayProxy = props.apiGatewayProxy, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::RefactorSpaces::Application", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApplication.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { environmentIdentifier: this.environmentIdentifier, name: this.name, proxyType: this.proxyType, vpcId: this.vpcId, apiGatewayProxy: this.apiGatewayProxy, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnApplicationPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnApplication[_a] = { fqn: "aws-cdk-lib.aws_refactorspaces.CfnApplication", version: "2.80.0" }, CfnApplication.CFN_RESOURCE_TYPE_NAME = "AWS::RefactorSpaces::Application", exports2.CfnApplication = CfnApplication;
    function CfnApplication_ApiGatewayProxyInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endpointType", cdk.validateString)(properties.endpointType)), errors.collect(cdk.propertyValidator("stageName", cdk.validateString)(properties.stageName)), errors.wrap('supplied properties not correct for "ApiGatewayProxyInputProperty"');
    }
    function cfnApplicationApiGatewayProxyInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_ApiGatewayProxyInputPropertyValidator(properties).assertSuccess(), { EndpointType: cdk.stringToCloudFormation(properties.endpointType), StageName: cdk.stringToCloudFormation(properties.stageName) }) : properties;
    }
    function CfnApplicationApiGatewayProxyInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endpointType", "EndpointType", properties.EndpointType != null ? cfn_parse.FromCloudFormation.getString(properties.EndpointType) : void 0), ret.addPropertyResult("stageName", "StageName", properties.StageName != null ? cfn_parse.FromCloudFormation.getString(properties.StageName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEnvironmentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("networkFabricType", cdk.requiredValidator)(properties.networkFabricType)), errors.collect(cdk.propertyValidator("networkFabricType", cdk.validateString)(properties.networkFabricType)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnEnvironmentProps"');
    }
    function cfnEnvironmentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEnvironmentPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), NetworkFabricType: cdk.stringToCloudFormation(properties.networkFabricType), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnEnvironmentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("networkFabricType", "NetworkFabricType", cfn_parse.FromCloudFormation.getString(properties.NetworkFabricType)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEnvironment = class _CfnEnvironment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEnvironmentPropsFromCloudFormation(resourceProperties), ret = new _CfnEnvironment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEnvironment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_refactorspaces_CfnEnvironmentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEnvironment), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "networkFabricType", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrEnvironmentIdentifier = cdk.Token.asString(this.getAtt("EnvironmentIdentifier", cdk.ResolutionTypeHint.STRING)), this.attrTransitGatewayId = cdk.Token.asString(this.getAtt("TransitGatewayId", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.networkFabricType = props.networkFabricType, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::RefactorSpaces::Environment", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEnvironment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, networkFabricType: this.networkFabricType, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnEnvironmentPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnEnvironment[_b] = { fqn: "aws-cdk-lib.aws_refactorspaces.CfnEnvironment", version: "2.80.0" }, CfnEnvironment.CFN_RESOURCE_TYPE_NAME = "AWS::RefactorSpaces::Environment", exports2.CfnEnvironment = CfnEnvironment;
    function CfnRoutePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationIdentifier", cdk.requiredValidator)(properties.applicationIdentifier)), errors.collect(cdk.propertyValidator("applicationIdentifier", cdk.validateString)(properties.applicationIdentifier)), errors.collect(cdk.propertyValidator("defaultRoute", CfnRoute_DefaultRouteInputPropertyValidator)(properties.defaultRoute)), errors.collect(cdk.propertyValidator("environmentIdentifier", cdk.requiredValidator)(properties.environmentIdentifier)), errors.collect(cdk.propertyValidator("environmentIdentifier", cdk.validateString)(properties.environmentIdentifier)), errors.collect(cdk.propertyValidator("routeType", cdk.requiredValidator)(properties.routeType)), errors.collect(cdk.propertyValidator("routeType", cdk.validateString)(properties.routeType)), errors.collect(cdk.propertyValidator("serviceIdentifier", cdk.requiredValidator)(properties.serviceIdentifier)), errors.collect(cdk.propertyValidator("serviceIdentifier", cdk.validateString)(properties.serviceIdentifier)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("uriPathRoute", CfnRoute_UriPathRouteInputPropertyValidator)(properties.uriPathRoute)), errors.wrap('supplied properties not correct for "CfnRouteProps"');
    }
    function cfnRoutePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoutePropsValidator(properties).assertSuccess(), { ApplicationIdentifier: cdk.stringToCloudFormation(properties.applicationIdentifier), EnvironmentIdentifier: cdk.stringToCloudFormation(properties.environmentIdentifier), RouteType: cdk.stringToCloudFormation(properties.routeType), ServiceIdentifier: cdk.stringToCloudFormation(properties.serviceIdentifier), DefaultRoute: cfnRouteDefaultRouteInputPropertyToCloudFormation(properties.defaultRoute), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), UriPathRoute: cfnRouteUriPathRouteInputPropertyToCloudFormation(properties.uriPathRoute) }) : properties;
    }
    function CfnRoutePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationIdentifier", "ApplicationIdentifier", cfn_parse.FromCloudFormation.getString(properties.ApplicationIdentifier)), ret.addPropertyResult("environmentIdentifier", "EnvironmentIdentifier", cfn_parse.FromCloudFormation.getString(properties.EnvironmentIdentifier)), ret.addPropertyResult("routeType", "RouteType", cfn_parse.FromCloudFormation.getString(properties.RouteType)), ret.addPropertyResult("serviceIdentifier", "ServiceIdentifier", cfn_parse.FromCloudFormation.getString(properties.ServiceIdentifier)), ret.addPropertyResult("defaultRoute", "DefaultRoute", properties.DefaultRoute != null ? CfnRouteDefaultRouteInputPropertyFromCloudFormation(properties.DefaultRoute) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("uriPathRoute", "UriPathRoute", properties.UriPathRoute != null ? CfnRouteUriPathRouteInputPropertyFromCloudFormation(properties.UriPathRoute) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRoute = class _CfnRoute extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRoutePropsFromCloudFormation(resourceProperties), ret = new _CfnRoute(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRoute.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_refactorspaces_CfnRouteProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRoute), error;
        }
        cdk.requireProperty(props, "applicationIdentifier", this), cdk.requireProperty(props, "environmentIdentifier", this), cdk.requireProperty(props, "routeType", this), cdk.requireProperty(props, "serviceIdentifier", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrPathResourceToId = cdk.Token.asString(this.getAtt("PathResourceToId", cdk.ResolutionTypeHint.STRING)), this.attrRouteIdentifier = cdk.Token.asString(this.getAtt("RouteIdentifier", cdk.ResolutionTypeHint.STRING)), this.applicationIdentifier = props.applicationIdentifier, this.environmentIdentifier = props.environmentIdentifier, this.routeType = props.routeType, this.serviceIdentifier = props.serviceIdentifier, this.defaultRoute = props.defaultRoute, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::RefactorSpaces::Route", props.tags, { tagPropertyName: "tags" }), this.uriPathRoute = props.uriPathRoute;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRoute.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationIdentifier: this.applicationIdentifier, environmentIdentifier: this.environmentIdentifier, routeType: this.routeType, serviceIdentifier: this.serviceIdentifier, defaultRoute: this.defaultRoute, tags: this.tags.renderTags(), uriPathRoute: this.uriPathRoute };
      }
      renderProperties(props) {
        return cfnRoutePropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnRoute[_c] = { fqn: "aws-cdk-lib.aws_refactorspaces.CfnRoute", version: "2.80.0" }, CfnRoute.CFN_RESOURCE_TYPE_NAME = "AWS::RefactorSpaces::Route", exports2.CfnRoute = CfnRoute;
    function CfnRoute_DefaultRouteInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("activationState", cdk.requiredValidator)(properties.activationState)), errors.collect(cdk.propertyValidator("activationState", cdk.validateString)(properties.activationState)), errors.wrap('supplied properties not correct for "DefaultRouteInputProperty"');
    }
    function cfnRouteDefaultRouteInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoute_DefaultRouteInputPropertyValidator(properties).assertSuccess(), { ActivationState: cdk.stringToCloudFormation(properties.activationState) }) : properties;
    }
    function CfnRouteDefaultRouteInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("activationState", "ActivationState", cfn_parse.FromCloudFormation.getString(properties.ActivationState)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRoute_UriPathRouteInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("activationState", cdk.requiredValidator)(properties.activationState)), errors.collect(cdk.propertyValidator("activationState", cdk.validateString)(properties.activationState)), errors.collect(cdk.propertyValidator("includeChildPaths", cdk.validateBoolean)(properties.includeChildPaths)), errors.collect(cdk.propertyValidator("methods", cdk.listValidator(cdk.validateString))(properties.methods)), errors.collect(cdk.propertyValidator("sourcePath", cdk.validateString)(properties.sourcePath)), errors.wrap('supplied properties not correct for "UriPathRouteInputProperty"');
    }
    function cfnRouteUriPathRouteInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoute_UriPathRouteInputPropertyValidator(properties).assertSuccess(), { ActivationState: cdk.stringToCloudFormation(properties.activationState), IncludeChildPaths: cdk.booleanToCloudFormation(properties.includeChildPaths), Methods: cdk.listMapper(cdk.stringToCloudFormation)(properties.methods), SourcePath: cdk.stringToCloudFormation(properties.sourcePath) }) : properties;
    }
    function CfnRouteUriPathRouteInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("activationState", "ActivationState", cfn_parse.FromCloudFormation.getString(properties.ActivationState)), ret.addPropertyResult("includeChildPaths", "IncludeChildPaths", properties.IncludeChildPaths != null ? cfn_parse.FromCloudFormation.getBoolean(properties.IncludeChildPaths) : void 0), ret.addPropertyResult("methods", "Methods", properties.Methods != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Methods) : void 0), ret.addPropertyResult("sourcePath", "SourcePath", properties.SourcePath != null ? cfn_parse.FromCloudFormation.getString(properties.SourcePath) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnServicePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationIdentifier", cdk.requiredValidator)(properties.applicationIdentifier)), errors.collect(cdk.propertyValidator("applicationIdentifier", cdk.validateString)(properties.applicationIdentifier)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("endpointType", cdk.requiredValidator)(properties.endpointType)), errors.collect(cdk.propertyValidator("endpointType", cdk.validateString)(properties.endpointType)), errors.collect(cdk.propertyValidator("environmentIdentifier", cdk.requiredValidator)(properties.environmentIdentifier)), errors.collect(cdk.propertyValidator("environmentIdentifier", cdk.validateString)(properties.environmentIdentifier)), errors.collect(cdk.propertyValidator("lambdaEndpoint", CfnService_LambdaEndpointInputPropertyValidator)(properties.lambdaEndpoint)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("urlEndpoint", CfnService_UrlEndpointInputPropertyValidator)(properties.urlEndpoint)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "CfnServiceProps"');
    }
    function cfnServicePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnServicePropsValidator(properties).assertSuccess(), { ApplicationIdentifier: cdk.stringToCloudFormation(properties.applicationIdentifier), EndpointType: cdk.stringToCloudFormation(properties.endpointType), EnvironmentIdentifier: cdk.stringToCloudFormation(properties.environmentIdentifier), Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), LambdaEndpoint: cfnServiceLambdaEndpointInputPropertyToCloudFormation(properties.lambdaEndpoint), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), UrlEndpoint: cfnServiceUrlEndpointInputPropertyToCloudFormation(properties.urlEndpoint), VpcId: cdk.stringToCloudFormation(properties.vpcId) }) : properties;
    }
    function CfnServicePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationIdentifier", "ApplicationIdentifier", cfn_parse.FromCloudFormation.getString(properties.ApplicationIdentifier)), ret.addPropertyResult("endpointType", "EndpointType", cfn_parse.FromCloudFormation.getString(properties.EndpointType)), ret.addPropertyResult("environmentIdentifier", "EnvironmentIdentifier", cfn_parse.FromCloudFormation.getString(properties.EnvironmentIdentifier)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("lambdaEndpoint", "LambdaEndpoint", properties.LambdaEndpoint != null ? CfnServiceLambdaEndpointInputPropertyFromCloudFormation(properties.LambdaEndpoint) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("urlEndpoint", "UrlEndpoint", properties.UrlEndpoint != null ? CfnServiceUrlEndpointInputPropertyFromCloudFormation(properties.UrlEndpoint) : void 0), ret.addPropertyResult("vpcId", "VpcId", properties.VpcId != null ? cfn_parse.FromCloudFormation.getString(properties.VpcId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnService = class _CfnService extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnServicePropsFromCloudFormation(resourceProperties), ret = new _CfnService(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnService.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_refactorspaces_CfnServiceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnService), error;
        }
        cdk.requireProperty(props, "applicationIdentifier", this), cdk.requireProperty(props, "endpointType", this), cdk.requireProperty(props, "environmentIdentifier", this), cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrServiceIdentifier = cdk.Token.asString(this.getAtt("ServiceIdentifier", cdk.ResolutionTypeHint.STRING)), this.applicationIdentifier = props.applicationIdentifier, this.endpointType = props.endpointType, this.environmentIdentifier = props.environmentIdentifier, this.name = props.name, this.description = props.description, this.lambdaEndpoint = props.lambdaEndpoint, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::RefactorSpaces::Service", props.tags, { tagPropertyName: "tags" }), this.urlEndpoint = props.urlEndpoint, this.vpcId = props.vpcId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnService.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationIdentifier: this.applicationIdentifier, endpointType: this.endpointType, environmentIdentifier: this.environmentIdentifier, name: this.name, description: this.description, lambdaEndpoint: this.lambdaEndpoint, tags: this.tags.renderTags(), urlEndpoint: this.urlEndpoint, vpcId: this.vpcId };
      }
      renderProperties(props) {
        return cfnServicePropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnService[_d] = { fqn: "aws-cdk-lib.aws_refactorspaces.CfnService", version: "2.80.0" }, CfnService.CFN_RESOURCE_TYPE_NAME = "AWS::RefactorSpaces::Service", exports2.CfnService = CfnService;
    function CfnService_LambdaEndpointInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.requiredValidator)(properties.arn)), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.wrap('supplied properties not correct for "LambdaEndpointInputProperty"');
    }
    function cfnServiceLambdaEndpointInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_LambdaEndpointInputPropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn) }) : properties;
    }
    function CfnServiceLambdaEndpointInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", cfn_parse.FromCloudFormation.getString(properties.Arn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnService_UrlEndpointInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("healthUrl", cdk.validateString)(properties.healthUrl)), errors.collect(cdk.propertyValidator("url", cdk.requiredValidator)(properties.url)), errors.collect(cdk.propertyValidator("url", cdk.validateString)(properties.url)), errors.wrap('supplied properties not correct for "UrlEndpointInputProperty"');
    }
    function cfnServiceUrlEndpointInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_UrlEndpointInputPropertyValidator(properties).assertSuccess(), { HealthUrl: cdk.stringToCloudFormation(properties.healthUrl), Url: cdk.stringToCloudFormation(properties.url) }) : properties;
    }
    function CfnServiceUrlEndpointInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("healthUrl", "HealthUrl", properties.HealthUrl != null ? cfn_parse.FromCloudFormation.getString(properties.HealthUrl) : void 0), ret.addPropertyResult("url", "Url", cfn_parse.FromCloudFormation.getString(properties.Url)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-refactorspaces/lib/index.js
var require_lib218 = __commonJS({
  "node_modules/aws-cdk-lib/aws-refactorspaces/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_refactorspaces_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-refactorspaces/index.js
var require_aws_refactorspaces = __commonJS({
  "node_modules/aws-cdk-lib/aws-refactorspaces/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib218(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-rekognition/lib/rekognition.generated.js
var require_rekognition_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-rekognition/lib/rekognition.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnStreamProcessor = exports2.CfnProject = exports2.CfnCollection = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnCollectionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("collectionId", cdk.requiredValidator)(properties.collectionId)), errors.collect(cdk.propertyValidator("collectionId", cdk.validateString)(properties.collectionId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnCollectionProps"');
    }
    function cfnCollectionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCollectionPropsValidator(properties).assertSuccess(), { CollectionId: cdk.stringToCloudFormation(properties.collectionId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnCollectionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("collectionId", "CollectionId", cfn_parse.FromCloudFormation.getString(properties.CollectionId)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCollection = class _CfnCollection extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCollectionPropsFromCloudFormation(resourceProperties), ret = new _CfnCollection(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCollection.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rekognition_CfnCollectionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCollection), error;
        }
        cdk.requireProperty(props, "collectionId", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.collectionId = props.collectionId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Rekognition::Collection", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCollection.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { collectionId: this.collectionId, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnCollectionPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnCollection[_a] = { fqn: "aws-cdk-lib.aws_rekognition.CfnCollection", version: "2.80.0" }, CfnCollection.CFN_RESOURCE_TYPE_NAME = "AWS::Rekognition::Collection", exports2.CfnCollection = CfnCollection;
    function CfnProjectPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("projectName", cdk.requiredValidator)(properties.projectName)), errors.collect(cdk.propertyValidator("projectName", cdk.validateString)(properties.projectName)), errors.wrap('supplied properties not correct for "CfnProjectProps"');
    }
    function cfnProjectPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProjectPropsValidator(properties).assertSuccess(), { ProjectName: cdk.stringToCloudFormation(properties.projectName) }) : properties;
    }
    function CfnProjectPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("projectName", "ProjectName", cfn_parse.FromCloudFormation.getString(properties.ProjectName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnProject = class _CfnProject extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnProjectPropsFromCloudFormation(resourceProperties), ret = new _CfnProject(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnProject.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rekognition_CfnProjectProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnProject), error;
        }
        cdk.requireProperty(props, "projectName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.projectName = props.projectName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnProject.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { projectName: this.projectName };
      }
      renderProperties(props) {
        return cfnProjectPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnProject[_b] = { fqn: "aws-cdk-lib.aws_rekognition.CfnProject", version: "2.80.0" }, CfnProject.CFN_RESOURCE_TYPE_NAME = "AWS::Rekognition::Project", exports2.CfnProject = CfnProject;
    function CfnStreamProcessorPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("boundingBoxRegionsOfInterest", cdk.listValidator(CfnStreamProcessor_BoundingBoxPropertyValidator))(properties.boundingBoxRegionsOfInterest)), errors.collect(cdk.propertyValidator("connectedHomeSettings", CfnStreamProcessor_ConnectedHomeSettingsPropertyValidator)(properties.connectedHomeSettings)), errors.collect(cdk.propertyValidator("dataSharingPreference", CfnStreamProcessor_DataSharingPreferencePropertyValidator)(properties.dataSharingPreference)), errors.collect(cdk.propertyValidator("faceSearchSettings", CfnStreamProcessor_FaceSearchSettingsPropertyValidator)(properties.faceSearchSettings)), errors.collect(cdk.propertyValidator("kinesisDataStream", CfnStreamProcessor_KinesisDataStreamPropertyValidator)(properties.kinesisDataStream)), errors.collect(cdk.propertyValidator("kinesisVideoStream", cdk.requiredValidator)(properties.kinesisVideoStream)), errors.collect(cdk.propertyValidator("kinesisVideoStream", CfnStreamProcessor_KinesisVideoStreamPropertyValidator)(properties.kinesisVideoStream)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("notificationChannel", CfnStreamProcessor_NotificationChannelPropertyValidator)(properties.notificationChannel)), errors.collect(cdk.propertyValidator("polygonRegionsOfInterest", cdk.validateObject)(properties.polygonRegionsOfInterest)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("s3Destination", CfnStreamProcessor_S3DestinationPropertyValidator)(properties.s3Destination)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnStreamProcessorProps"');
    }
    function cfnStreamProcessorPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStreamProcessorPropsValidator(properties).assertSuccess(), { KinesisVideoStream: cfnStreamProcessorKinesisVideoStreamPropertyToCloudFormation(properties.kinesisVideoStream), RoleArn: cdk.stringToCloudFormation(properties.roleArn), BoundingBoxRegionsOfInterest: cdk.listMapper(cfnStreamProcessorBoundingBoxPropertyToCloudFormation)(properties.boundingBoxRegionsOfInterest), ConnectedHomeSettings: cfnStreamProcessorConnectedHomeSettingsPropertyToCloudFormation(properties.connectedHomeSettings), DataSharingPreference: cfnStreamProcessorDataSharingPreferencePropertyToCloudFormation(properties.dataSharingPreference), FaceSearchSettings: cfnStreamProcessorFaceSearchSettingsPropertyToCloudFormation(properties.faceSearchSettings), KinesisDataStream: cfnStreamProcessorKinesisDataStreamPropertyToCloudFormation(properties.kinesisDataStream), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), Name: cdk.stringToCloudFormation(properties.name), NotificationChannel: cfnStreamProcessorNotificationChannelPropertyToCloudFormation(properties.notificationChannel), PolygonRegionsOfInterest: cdk.objectToCloudFormation(properties.polygonRegionsOfInterest), S3Destination: cfnStreamProcessorS3DestinationPropertyToCloudFormation(properties.s3Destination), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnStreamProcessorPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kinesisVideoStream", "KinesisVideoStream", CfnStreamProcessorKinesisVideoStreamPropertyFromCloudFormation(properties.KinesisVideoStream)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("boundingBoxRegionsOfInterest", "BoundingBoxRegionsOfInterest", properties.BoundingBoxRegionsOfInterest != null ? cfn_parse.FromCloudFormation.getArray(CfnStreamProcessorBoundingBoxPropertyFromCloudFormation)(properties.BoundingBoxRegionsOfInterest) : void 0), ret.addPropertyResult("connectedHomeSettings", "ConnectedHomeSettings", properties.ConnectedHomeSettings != null ? CfnStreamProcessorConnectedHomeSettingsPropertyFromCloudFormation(properties.ConnectedHomeSettings) : void 0), ret.addPropertyResult("dataSharingPreference", "DataSharingPreference", properties.DataSharingPreference != null ? CfnStreamProcessorDataSharingPreferencePropertyFromCloudFormation(properties.DataSharingPreference) : void 0), ret.addPropertyResult("faceSearchSettings", "FaceSearchSettings", properties.FaceSearchSettings != null ? CfnStreamProcessorFaceSearchSettingsPropertyFromCloudFormation(properties.FaceSearchSettings) : void 0), ret.addPropertyResult("kinesisDataStream", "KinesisDataStream", properties.KinesisDataStream != null ? CfnStreamProcessorKinesisDataStreamPropertyFromCloudFormation(properties.KinesisDataStream) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("notificationChannel", "NotificationChannel", properties.NotificationChannel != null ? CfnStreamProcessorNotificationChannelPropertyFromCloudFormation(properties.NotificationChannel) : void 0), ret.addPropertyResult("polygonRegionsOfInterest", "PolygonRegionsOfInterest", properties.PolygonRegionsOfInterest != null ? cfn_parse.FromCloudFormation.getAny(properties.PolygonRegionsOfInterest) : void 0), ret.addPropertyResult("s3Destination", "S3Destination", properties.S3Destination != null ? CfnStreamProcessorS3DestinationPropertyFromCloudFormation(properties.S3Destination) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnStreamProcessor = class _CfnStreamProcessor extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnStreamProcessorPropsFromCloudFormation(resourceProperties), ret = new _CfnStreamProcessor(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnStreamProcessor.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rekognition_CfnStreamProcessorProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnStreamProcessor), error;
        }
        cdk.requireProperty(props, "kinesisVideoStream", this), cdk.requireProperty(props, "roleArn", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.attrStatusMessage = cdk.Token.asString(this.getAtt("StatusMessage", cdk.ResolutionTypeHint.STRING)), this.kinesisVideoStream = props.kinesisVideoStream, this.roleArn = props.roleArn, this.boundingBoxRegionsOfInterest = props.boundingBoxRegionsOfInterest, this.connectedHomeSettings = props.connectedHomeSettings, this.dataSharingPreference = props.dataSharingPreference, this.faceSearchSettings = props.faceSearchSettings, this.kinesisDataStream = props.kinesisDataStream, this.kmsKeyId = props.kmsKeyId, this.name = props.name, this.notificationChannel = props.notificationChannel, this.polygonRegionsOfInterest = props.polygonRegionsOfInterest, this.s3Destination = props.s3Destination, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Rekognition::StreamProcessor", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStreamProcessor.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { kinesisVideoStream: this.kinesisVideoStream, roleArn: this.roleArn, boundingBoxRegionsOfInterest: this.boundingBoxRegionsOfInterest, connectedHomeSettings: this.connectedHomeSettings, dataSharingPreference: this.dataSharingPreference, faceSearchSettings: this.faceSearchSettings, kinesisDataStream: this.kinesisDataStream, kmsKeyId: this.kmsKeyId, name: this.name, notificationChannel: this.notificationChannel, polygonRegionsOfInterest: this.polygonRegionsOfInterest, s3Destination: this.s3Destination, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnStreamProcessorPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnStreamProcessor[_c] = { fqn: "aws-cdk-lib.aws_rekognition.CfnStreamProcessor", version: "2.80.0" }, CfnStreamProcessor.CFN_RESOURCE_TYPE_NAME = "AWS::Rekognition::StreamProcessor", exports2.CfnStreamProcessor = CfnStreamProcessor;
    function CfnStreamProcessor_BoundingBoxPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("height", cdk.requiredValidator)(properties.height)), errors.collect(cdk.propertyValidator("height", cdk.validateNumber)(properties.height)), errors.collect(cdk.propertyValidator("left", cdk.requiredValidator)(properties.left)), errors.collect(cdk.propertyValidator("left", cdk.validateNumber)(properties.left)), errors.collect(cdk.propertyValidator("top", cdk.requiredValidator)(properties.top)), errors.collect(cdk.propertyValidator("top", cdk.validateNumber)(properties.top)), errors.collect(cdk.propertyValidator("width", cdk.requiredValidator)(properties.width)), errors.collect(cdk.propertyValidator("width", cdk.validateNumber)(properties.width)), errors.wrap('supplied properties not correct for "BoundingBoxProperty"');
    }
    function cfnStreamProcessorBoundingBoxPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStreamProcessor_BoundingBoxPropertyValidator(properties).assertSuccess(), { Height: cdk.numberToCloudFormation(properties.height), Left: cdk.numberToCloudFormation(properties.left), Top: cdk.numberToCloudFormation(properties.top), Width: cdk.numberToCloudFormation(properties.width) }) : properties;
    }
    function CfnStreamProcessorBoundingBoxPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("height", "Height", cfn_parse.FromCloudFormation.getNumber(properties.Height)), ret.addPropertyResult("left", "Left", cfn_parse.FromCloudFormation.getNumber(properties.Left)), ret.addPropertyResult("top", "Top", cfn_parse.FromCloudFormation.getNumber(properties.Top)), ret.addPropertyResult("width", "Width", cfn_parse.FromCloudFormation.getNumber(properties.Width)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStreamProcessor_ConnectedHomeSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("labels", cdk.requiredValidator)(properties.labels)), errors.collect(cdk.propertyValidator("labels", cdk.listValidator(cdk.validateString))(properties.labels)), errors.collect(cdk.propertyValidator("minConfidence", cdk.validateNumber)(properties.minConfidence)), errors.wrap('supplied properties not correct for "ConnectedHomeSettingsProperty"');
    }
    function cfnStreamProcessorConnectedHomeSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStreamProcessor_ConnectedHomeSettingsPropertyValidator(properties).assertSuccess(), { Labels: cdk.listMapper(cdk.stringToCloudFormation)(properties.labels), MinConfidence: cdk.numberToCloudFormation(properties.minConfidence) }) : properties;
    }
    function CfnStreamProcessorConnectedHomeSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("labels", "Labels", cfn_parse.FromCloudFormation.getStringArray(properties.Labels)), ret.addPropertyResult("minConfidence", "MinConfidence", properties.MinConfidence != null ? cfn_parse.FromCloudFormation.getNumber(properties.MinConfidence) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStreamProcessor_DataSharingPreferencePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("optIn", cdk.requiredValidator)(properties.optIn)), errors.collect(cdk.propertyValidator("optIn", cdk.validateBoolean)(properties.optIn)), errors.wrap('supplied properties not correct for "DataSharingPreferenceProperty"');
    }
    function cfnStreamProcessorDataSharingPreferencePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStreamProcessor_DataSharingPreferencePropertyValidator(properties).assertSuccess(), { OptIn: cdk.booleanToCloudFormation(properties.optIn) }) : properties;
    }
    function CfnStreamProcessorDataSharingPreferencePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("optIn", "OptIn", cfn_parse.FromCloudFormation.getBoolean(properties.OptIn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStreamProcessor_FaceSearchSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("collectionId", cdk.requiredValidator)(properties.collectionId)), errors.collect(cdk.propertyValidator("collectionId", cdk.validateString)(properties.collectionId)), errors.collect(cdk.propertyValidator("faceMatchThreshold", cdk.validateNumber)(properties.faceMatchThreshold)), errors.wrap('supplied properties not correct for "FaceSearchSettingsProperty"');
    }
    function cfnStreamProcessorFaceSearchSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStreamProcessor_FaceSearchSettingsPropertyValidator(properties).assertSuccess(), { CollectionId: cdk.stringToCloudFormation(properties.collectionId), FaceMatchThreshold: cdk.numberToCloudFormation(properties.faceMatchThreshold) }) : properties;
    }
    function CfnStreamProcessorFaceSearchSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("collectionId", "CollectionId", cfn_parse.FromCloudFormation.getString(properties.CollectionId)), ret.addPropertyResult("faceMatchThreshold", "FaceMatchThreshold", properties.FaceMatchThreshold != null ? cfn_parse.FromCloudFormation.getNumber(properties.FaceMatchThreshold) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStreamProcessor_KinesisDataStreamPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.requiredValidator)(properties.arn)), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.wrap('supplied properties not correct for "KinesisDataStreamProperty"');
    }
    function cfnStreamProcessorKinesisDataStreamPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStreamProcessor_KinesisDataStreamPropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn) }) : properties;
    }
    function CfnStreamProcessorKinesisDataStreamPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", cfn_parse.FromCloudFormation.getString(properties.Arn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStreamProcessor_KinesisVideoStreamPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.requiredValidator)(properties.arn)), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.wrap('supplied properties not correct for "KinesisVideoStreamProperty"');
    }
    function cfnStreamProcessorKinesisVideoStreamPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStreamProcessor_KinesisVideoStreamPropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn) }) : properties;
    }
    function CfnStreamProcessorKinesisVideoStreamPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", cfn_parse.FromCloudFormation.getString(properties.Arn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStreamProcessor_NotificationChannelPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.requiredValidator)(properties.arn)), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.wrap('supplied properties not correct for "NotificationChannelProperty"');
    }
    function cfnStreamProcessorNotificationChannelPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStreamProcessor_NotificationChannelPropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn) }) : properties;
    }
    function CfnStreamProcessorNotificationChannelPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", cfn_parse.FromCloudFormation.getString(properties.Arn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnStreamProcessor_S3DestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketName", cdk.requiredValidator)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.collect(cdk.propertyValidator("objectKeyPrefix", cdk.validateString)(properties.objectKeyPrefix)), errors.wrap('supplied properties not correct for "S3DestinationProperty"');
    }
    function cfnStreamProcessorS3DestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStreamProcessor_S3DestinationPropertyValidator(properties).assertSuccess(), { BucketName: cdk.stringToCloudFormation(properties.bucketName), ObjectKeyPrefix: cdk.stringToCloudFormation(properties.objectKeyPrefix) }) : properties;
    }
    function CfnStreamProcessorS3DestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketName", "BucketName", cfn_parse.FromCloudFormation.getString(properties.BucketName)), ret.addPropertyResult("objectKeyPrefix", "ObjectKeyPrefix", properties.ObjectKeyPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.ObjectKeyPrefix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-rekognition/lib/index.js
var require_lib219 = __commonJS({
  "node_modules/aws-cdk-lib/aws-rekognition/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_rekognition_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-rekognition/index.js
var require_aws_rekognition = __commonJS({
  "node_modules/aws-cdk-lib/aws-rekognition/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib219(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-resiliencehub/lib/resiliencehub.generated.js
var require_resiliencehub_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-resiliencehub/lib/resiliencehub.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnResiliencyPolicy = exports2.CfnApp = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAppPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("appAssessmentSchedule", cdk.validateString)(properties.appAssessmentSchedule)), errors.collect(cdk.propertyValidator("appTemplateBody", cdk.requiredValidator)(properties.appTemplateBody)), errors.collect(cdk.propertyValidator("appTemplateBody", cdk.validateString)(properties.appTemplateBody)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("resiliencyPolicyArn", cdk.validateString)(properties.resiliencyPolicyArn)), errors.collect(cdk.propertyValidator("resourceMappings", cdk.requiredValidator)(properties.resourceMappings)), errors.collect(cdk.propertyValidator("resourceMappings", cdk.listValidator(CfnApp_ResourceMappingPropertyValidator))(properties.resourceMappings)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.wrap('supplied properties not correct for "CfnAppProps"');
    }
    function cfnAppPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAppPropsValidator(properties).assertSuccess(), { AppTemplateBody: cdk.stringToCloudFormation(properties.appTemplateBody), Name: cdk.stringToCloudFormation(properties.name), ResourceMappings: cdk.listMapper(cfnAppResourceMappingPropertyToCloudFormation)(properties.resourceMappings), AppAssessmentSchedule: cdk.stringToCloudFormation(properties.appAssessmentSchedule), Description: cdk.stringToCloudFormation(properties.description), ResiliencyPolicyArn: cdk.stringToCloudFormation(properties.resiliencyPolicyArn), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnAppPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("appTemplateBody", "AppTemplateBody", cfn_parse.FromCloudFormation.getString(properties.AppTemplateBody)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("resourceMappings", "ResourceMappings", cfn_parse.FromCloudFormation.getArray(CfnAppResourceMappingPropertyFromCloudFormation)(properties.ResourceMappings)), ret.addPropertyResult("appAssessmentSchedule", "AppAssessmentSchedule", properties.AppAssessmentSchedule != null ? cfn_parse.FromCloudFormation.getString(properties.AppAssessmentSchedule) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("resiliencyPolicyArn", "ResiliencyPolicyArn", properties.ResiliencyPolicyArn != null ? cfn_parse.FromCloudFormation.getString(properties.ResiliencyPolicyArn) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApp = class _CfnApp extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAppPropsFromCloudFormation(resourceProperties), ret = new _CfnApp(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApp.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_resiliencehub_CfnAppProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApp), error;
        }
        cdk.requireProperty(props, "appTemplateBody", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "resourceMappings", this), this.attrAppArn = cdk.Token.asString(this.getAtt("AppArn", cdk.ResolutionTypeHint.STRING)), this.appTemplateBody = props.appTemplateBody, this.name = props.name, this.resourceMappings = props.resourceMappings, this.appAssessmentSchedule = props.appAssessmentSchedule, this.description = props.description, this.resiliencyPolicyArn = props.resiliencyPolicyArn, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::ResilienceHub::App", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApp.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { appTemplateBody: this.appTemplateBody, name: this.name, resourceMappings: this.resourceMappings, appAssessmentSchedule: this.appAssessmentSchedule, description: this.description, resiliencyPolicyArn: this.resiliencyPolicyArn, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnAppPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnApp[_a] = { fqn: "aws-cdk-lib.aws_resiliencehub.CfnApp", version: "2.80.0" }, CfnApp.CFN_RESOURCE_TYPE_NAME = "AWS::ResilienceHub::App", exports2.CfnApp = CfnApp;
    function CfnApp_PhysicalResourceIdPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("awsAccountId", cdk.validateString)(properties.awsAccountId)), errors.collect(cdk.propertyValidator("awsRegion", cdk.validateString)(properties.awsRegion)), errors.collect(cdk.propertyValidator("identifier", cdk.requiredValidator)(properties.identifier)), errors.collect(cdk.propertyValidator("identifier", cdk.validateString)(properties.identifier)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "PhysicalResourceIdProperty"');
    }
    function cfnAppPhysicalResourceIdPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApp_PhysicalResourceIdPropertyValidator(properties).assertSuccess(), { AwsAccountId: cdk.stringToCloudFormation(properties.awsAccountId), AwsRegion: cdk.stringToCloudFormation(properties.awsRegion), Identifier: cdk.stringToCloudFormation(properties.identifier), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnAppPhysicalResourceIdPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("awsAccountId", "AwsAccountId", properties.AwsAccountId != null ? cfn_parse.FromCloudFormation.getString(properties.AwsAccountId) : void 0), ret.addPropertyResult("awsRegion", "AwsRegion", properties.AwsRegion != null ? cfn_parse.FromCloudFormation.getString(properties.AwsRegion) : void 0), ret.addPropertyResult("identifier", "Identifier", cfn_parse.FromCloudFormation.getString(properties.Identifier)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnApp_ResourceMappingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logicalStackName", cdk.validateString)(properties.logicalStackName)), errors.collect(cdk.propertyValidator("mappingType", cdk.requiredValidator)(properties.mappingType)), errors.collect(cdk.propertyValidator("mappingType", cdk.validateString)(properties.mappingType)), errors.collect(cdk.propertyValidator("physicalResourceId", cdk.requiredValidator)(properties.physicalResourceId)), errors.collect(cdk.propertyValidator("physicalResourceId", CfnApp_PhysicalResourceIdPropertyValidator)(properties.physicalResourceId)), errors.collect(cdk.propertyValidator("resourceName", cdk.validateString)(properties.resourceName)), errors.collect(cdk.propertyValidator("terraformSourceName", cdk.validateString)(properties.terraformSourceName)), errors.wrap('supplied properties not correct for "ResourceMappingProperty"');
    }
    function cfnAppResourceMappingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApp_ResourceMappingPropertyValidator(properties).assertSuccess(), { LogicalStackName: cdk.stringToCloudFormation(properties.logicalStackName), MappingType: cdk.stringToCloudFormation(properties.mappingType), PhysicalResourceId: cfnAppPhysicalResourceIdPropertyToCloudFormation(properties.physicalResourceId), ResourceName: cdk.stringToCloudFormation(properties.resourceName), TerraformSourceName: cdk.stringToCloudFormation(properties.terraformSourceName) }) : properties;
    }
    function CfnAppResourceMappingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logicalStackName", "LogicalStackName", properties.LogicalStackName != null ? cfn_parse.FromCloudFormation.getString(properties.LogicalStackName) : void 0), ret.addPropertyResult("mappingType", "MappingType", cfn_parse.FromCloudFormation.getString(properties.MappingType)), ret.addPropertyResult("physicalResourceId", "PhysicalResourceId", CfnAppPhysicalResourceIdPropertyFromCloudFormation(properties.PhysicalResourceId)), ret.addPropertyResult("resourceName", "ResourceName", properties.ResourceName != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceName) : void 0), ret.addPropertyResult("terraformSourceName", "TerraformSourceName", properties.TerraformSourceName != null ? cfn_parse.FromCloudFormation.getString(properties.TerraformSourceName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResiliencyPolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataLocationConstraint", cdk.validateString)(properties.dataLocationConstraint)), errors.collect(cdk.propertyValidator("policy", cdk.requiredValidator)(properties.policy)), errors.collect(cdk.propertyValidator("policy", cdk.hashValidator(CfnResiliencyPolicy_FailurePolicyPropertyValidator))(properties.policy)), errors.collect(cdk.propertyValidator("policyDescription", cdk.validateString)(properties.policyDescription)), errors.collect(cdk.propertyValidator("policyName", cdk.requiredValidator)(properties.policyName)), errors.collect(cdk.propertyValidator("policyName", cdk.validateString)(properties.policyName)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.collect(cdk.propertyValidator("tier", cdk.requiredValidator)(properties.tier)), errors.collect(cdk.propertyValidator("tier", cdk.validateString)(properties.tier)), errors.wrap('supplied properties not correct for "CfnResiliencyPolicyProps"');
    }
    function cfnResiliencyPolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResiliencyPolicyPropsValidator(properties).assertSuccess(), { Policy: cdk.hashMapper(cfnResiliencyPolicyFailurePolicyPropertyToCloudFormation)(properties.policy), PolicyName: cdk.stringToCloudFormation(properties.policyName), Tier: cdk.stringToCloudFormation(properties.tier), DataLocationConstraint: cdk.stringToCloudFormation(properties.dataLocationConstraint), PolicyDescription: cdk.stringToCloudFormation(properties.policyDescription), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnResiliencyPolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("policy", "Policy", cfn_parse.FromCloudFormation.getMap(CfnResiliencyPolicyFailurePolicyPropertyFromCloudFormation)(properties.Policy)), ret.addPropertyResult("policyName", "PolicyName", cfn_parse.FromCloudFormation.getString(properties.PolicyName)), ret.addPropertyResult("tier", "Tier", cfn_parse.FromCloudFormation.getString(properties.Tier)), ret.addPropertyResult("dataLocationConstraint", "DataLocationConstraint", properties.DataLocationConstraint != null ? cfn_parse.FromCloudFormation.getString(properties.DataLocationConstraint) : void 0), ret.addPropertyResult("policyDescription", "PolicyDescription", properties.PolicyDescription != null ? cfn_parse.FromCloudFormation.getString(properties.PolicyDescription) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResiliencyPolicy = class _CfnResiliencyPolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResiliencyPolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnResiliencyPolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnResiliencyPolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_resiliencehub_CfnResiliencyPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResiliencyPolicy), error;
        }
        cdk.requireProperty(props, "policy", this), cdk.requireProperty(props, "policyName", this), cdk.requireProperty(props, "tier", this), this.attrPolicyArn = cdk.Token.asString(this.getAtt("PolicyArn", cdk.ResolutionTypeHint.STRING)), this.policy = props.policy, this.policyName = props.policyName, this.tier = props.tier, this.dataLocationConstraint = props.dataLocationConstraint, this.policyDescription = props.policyDescription, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::ResilienceHub::ResiliencyPolicy", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResiliencyPolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { policy: this.policy, policyName: this.policyName, tier: this.tier, dataLocationConstraint: this.dataLocationConstraint, policyDescription: this.policyDescription, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnResiliencyPolicyPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnResiliencyPolicy[_b] = { fqn: "aws-cdk-lib.aws_resiliencehub.CfnResiliencyPolicy", version: "2.80.0" }, CfnResiliencyPolicy.CFN_RESOURCE_TYPE_NAME = "AWS::ResilienceHub::ResiliencyPolicy", exports2.CfnResiliencyPolicy = CfnResiliencyPolicy;
    function CfnResiliencyPolicy_FailurePolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("rpoInSecs", cdk.requiredValidator)(properties.rpoInSecs)), errors.collect(cdk.propertyValidator("rpoInSecs", cdk.validateNumber)(properties.rpoInSecs)), errors.collect(cdk.propertyValidator("rtoInSecs", cdk.requiredValidator)(properties.rtoInSecs)), errors.collect(cdk.propertyValidator("rtoInSecs", cdk.validateNumber)(properties.rtoInSecs)), errors.wrap('supplied properties not correct for "FailurePolicyProperty"');
    }
    function cfnResiliencyPolicyFailurePolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResiliencyPolicy_FailurePolicyPropertyValidator(properties).assertSuccess(), { RpoInSecs: cdk.numberToCloudFormation(properties.rpoInSecs), RtoInSecs: cdk.numberToCloudFormation(properties.rtoInSecs) }) : properties;
    }
    function CfnResiliencyPolicyFailurePolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("rpoInSecs", "RpoInSecs", cfn_parse.FromCloudFormation.getNumber(properties.RpoInSecs)), ret.addPropertyResult("rtoInSecs", "RtoInSecs", cfn_parse.FromCloudFormation.getNumber(properties.RtoInSecs)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-resiliencehub/lib/index.js
var require_lib220 = __commonJS({
  "node_modules/aws-cdk-lib/aws-resiliencehub/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_resiliencehub_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-resiliencehub/index.js
var require_aws_resiliencehub = __commonJS({
  "node_modules/aws-cdk-lib/aws-resiliencehub/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib220(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-resourceexplorer2/lib/resourceexplorer2.generated.js
var require_resourceexplorer2_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-resourceexplorer2/lib/resourceexplorer2.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnView = exports2.CfnIndex = exports2.CfnDefaultViewAssociation = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnDefaultViewAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("viewArn", cdk.requiredValidator)(properties.viewArn)), errors.collect(cdk.propertyValidator("viewArn", cdk.validateString)(properties.viewArn)), errors.wrap('supplied properties not correct for "CfnDefaultViewAssociationProps"');
    }
    function cfnDefaultViewAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDefaultViewAssociationPropsValidator(properties).assertSuccess(), { ViewArn: cdk.stringToCloudFormation(properties.viewArn) }) : properties;
    }
    function CfnDefaultViewAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("viewArn", "ViewArn", cfn_parse.FromCloudFormation.getString(properties.ViewArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDefaultViewAssociation = class _CfnDefaultViewAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDefaultViewAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnDefaultViewAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDefaultViewAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_resourceexplorer2_CfnDefaultViewAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDefaultViewAssociation), error;
        }
        cdk.requireProperty(props, "viewArn", this), this.attrAssociatedAwsPrincipal = cdk.Token.asString(this.getAtt("AssociatedAwsPrincipal", cdk.ResolutionTypeHint.STRING)), this.viewArn = props.viewArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDefaultViewAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { viewArn: this.viewArn };
      }
      renderProperties(props) {
        return cfnDefaultViewAssociationPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnDefaultViewAssociation[_a] = { fqn: "aws-cdk-lib.aws_resourceexplorer2.CfnDefaultViewAssociation", version: "2.80.0" }, CfnDefaultViewAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::ResourceExplorer2::DefaultViewAssociation", exports2.CfnDefaultViewAssociation = CfnDefaultViewAssociation;
    function CfnIndexPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnIndexProps"');
    }
    function cfnIndexPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIndexPropsValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnIndexPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnIndex = class _CfnIndex extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnIndexPropsFromCloudFormation(resourceProperties), ret = new _CfnIndex(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnIndex.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_resourceexplorer2_CfnIndexProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnIndex), error;
        }
        cdk.requireProperty(props, "type", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrIndexState = cdk.Token.asString(this.getAtt("IndexState", cdk.ResolutionTypeHint.STRING)), this.type = props.type, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::ResourceExplorer2::Index", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnIndex.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { type: this.type, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnIndexPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnIndex[_b] = { fqn: "aws-cdk-lib.aws_resourceexplorer2.CfnIndex", version: "2.80.0" }, CfnIndex.CFN_RESOURCE_TYPE_NAME = "AWS::ResourceExplorer2::Index", exports2.CfnIndex = CfnIndex;
    function CfnViewPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("filters", CfnView_FiltersPropertyValidator)(properties.filters)), errors.collect(cdk.propertyValidator("includedProperties", cdk.listValidator(CfnView_IncludedPropertyPropertyValidator))(properties.includedProperties)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.collect(cdk.propertyValidator("viewName", cdk.requiredValidator)(properties.viewName)), errors.collect(cdk.propertyValidator("viewName", cdk.validateString)(properties.viewName)), errors.wrap('supplied properties not correct for "CfnViewProps"');
    }
    function cfnViewPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnViewPropsValidator(properties).assertSuccess(), { ViewName: cdk.stringToCloudFormation(properties.viewName), Filters: cfnViewFiltersPropertyToCloudFormation(properties.filters), IncludedProperties: cdk.listMapper(cfnViewIncludedPropertyPropertyToCloudFormation)(properties.includedProperties), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnViewPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("viewName", "ViewName", cfn_parse.FromCloudFormation.getString(properties.ViewName)), ret.addPropertyResult("filters", "Filters", properties.Filters != null ? CfnViewFiltersPropertyFromCloudFormation(properties.Filters) : void 0), ret.addPropertyResult("includedProperties", "IncludedProperties", properties.IncludedProperties != null ? cfn_parse.FromCloudFormation.getArray(CfnViewIncludedPropertyPropertyFromCloudFormation)(properties.IncludedProperties) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnView = class _CfnView extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnViewPropsFromCloudFormation(resourceProperties), ret = new _CfnView(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnView.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_resourceexplorer2_CfnViewProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnView), error;
        }
        cdk.requireProperty(props, "viewName", this), this.attrViewArn = cdk.Token.asString(this.getAtt("ViewArn", cdk.ResolutionTypeHint.STRING)), this.viewName = props.viewName, this.filters = props.filters, this.includedProperties = props.includedProperties, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::ResourceExplorer2::View", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnView.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { viewName: this.viewName, filters: this.filters, includedProperties: this.includedProperties, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnViewPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnView[_c] = { fqn: "aws-cdk-lib.aws_resourceexplorer2.CfnView", version: "2.80.0" }, CfnView.CFN_RESOURCE_TYPE_NAME = "AWS::ResourceExplorer2::View", exports2.CfnView = CfnView;
    function CfnView_FiltersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("filterString", cdk.requiredValidator)(properties.filterString)), errors.collect(cdk.propertyValidator("filterString", cdk.validateString)(properties.filterString)), errors.wrap('supplied properties not correct for "FiltersProperty"');
    }
    function cfnViewFiltersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnView_FiltersPropertyValidator(properties).assertSuccess(), { FilterString: cdk.stringToCloudFormation(properties.filterString) }) : properties;
    }
    function CfnViewFiltersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("filterString", "FilterString", cfn_parse.FromCloudFormation.getString(properties.FilterString)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnView_IncludedPropertyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "IncludedPropertyProperty"');
    }
    function cfnViewIncludedPropertyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnView_IncludedPropertyPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnViewIncludedPropertyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-resourceexplorer2/lib/index.js
var require_lib221 = __commonJS({
  "node_modules/aws-cdk-lib/aws-resourceexplorer2/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_resourceexplorer2_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-resourceexplorer2/index.js
var require_aws_resourceexplorer2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-resourceexplorer2/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib221(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-resourcegroups/lib/resourcegroups.generated.js
var require_resourcegroups_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-resourcegroups/lib/resourcegroups.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnGroup = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configuration", cdk.listValidator(CfnGroup_ConfigurationItemPropertyValidator))(properties.configuration)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("resourceQuery", CfnGroup_ResourceQueryPropertyValidator)(properties.resourceQuery)), errors.collect(cdk.propertyValidator("resources", cdk.listValidator(cdk.validateString))(properties.resources)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnGroupProps"');
    }
    function cfnGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGroupPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Configuration: cdk.listMapper(cfnGroupConfigurationItemPropertyToCloudFormation)(properties.configuration), Description: cdk.stringToCloudFormation(properties.description), ResourceQuery: cfnGroupResourceQueryPropertyToCloudFormation(properties.resourceQuery), Resources: cdk.listMapper(cdk.stringToCloudFormation)(properties.resources), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("configuration", "Configuration", properties.Configuration != null ? cfn_parse.FromCloudFormation.getArray(CfnGroupConfigurationItemPropertyFromCloudFormation)(properties.Configuration) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("resourceQuery", "ResourceQuery", properties.ResourceQuery != null ? CfnGroupResourceQueryPropertyFromCloudFormation(properties.ResourceQuery) : void 0), ret.addPropertyResult("resources", "Resources", properties.Resources != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Resources) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnGroup = class _CfnGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_resourcegroups_CfnGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnGroup), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.configuration = props.configuration, this.description = props.description, this.resourceQuery = props.resourceQuery, this.resources = props.resources, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ResourceGroups::Group", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, configuration: this.configuration, description: this.description, resourceQuery: this.resourceQuery, resources: this.resources, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnGroupPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnGroup[_a] = { fqn: "aws-cdk-lib.aws_resourcegroups.CfnGroup", version: "2.80.0" }, CfnGroup.CFN_RESOURCE_TYPE_NAME = "AWS::ResourceGroups::Group", exports2.CfnGroup = CfnGroup;
    function CfnGroup_ConfigurationItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("parameters", cdk.listValidator(CfnGroup_ConfigurationParameterPropertyValidator))(properties.parameters)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "ConfigurationItemProperty"');
    }
    function cfnGroupConfigurationItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGroup_ConfigurationItemPropertyValidator(properties).assertSuccess(), { Parameters: cdk.listMapper(cfnGroupConfigurationParameterPropertyToCloudFormation)(properties.parameters), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnGroupConfigurationItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getArray(CfnGroupConfigurationParameterPropertyFromCloudFormation)(properties.Parameters) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGroup_ConfigurationParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "ConfigurationParameterProperty"');
    }
    function cfnGroupConfigurationParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGroup_ConfigurationParameterPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnGroupConfigurationParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGroup_QueryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceTypeFilters", cdk.listValidator(cdk.validateString))(properties.resourceTypeFilters)), errors.collect(cdk.propertyValidator("stackIdentifier", cdk.validateString)(properties.stackIdentifier)), errors.collect(cdk.propertyValidator("tagFilters", cdk.listValidator(CfnGroup_TagFilterPropertyValidator))(properties.tagFilters)), errors.wrap('supplied properties not correct for "QueryProperty"');
    }
    function cfnGroupQueryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGroup_QueryPropertyValidator(properties).assertSuccess(), { ResourceTypeFilters: cdk.listMapper(cdk.stringToCloudFormation)(properties.resourceTypeFilters), StackIdentifier: cdk.stringToCloudFormation(properties.stackIdentifier), TagFilters: cdk.listMapper(cfnGroupTagFilterPropertyToCloudFormation)(properties.tagFilters) }) : properties;
    }
    function CfnGroupQueryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceTypeFilters", "ResourceTypeFilters", properties.ResourceTypeFilters != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ResourceTypeFilters) : void 0), ret.addPropertyResult("stackIdentifier", "StackIdentifier", properties.StackIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.StackIdentifier) : void 0), ret.addPropertyResult("tagFilters", "TagFilters", properties.TagFilters != null ? cfn_parse.FromCloudFormation.getArray(CfnGroupTagFilterPropertyFromCloudFormation)(properties.TagFilters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGroup_ResourceQueryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("query", CfnGroup_QueryPropertyValidator)(properties.query)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "ResourceQueryProperty"');
    }
    function cfnGroupResourceQueryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGroup_ResourceQueryPropertyValidator(properties).assertSuccess(), { Query: cfnGroupQueryPropertyToCloudFormation(properties.query), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnGroupResourceQueryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("query", "Query", properties.Query != null ? CfnGroupQueryPropertyFromCloudFormation(properties.Query) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGroup_TagFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "TagFilterProperty"');
    }
    function cfnGroupTagFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGroup_TagFilterPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnGroupTagFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addPropertyResult("values", "Values", properties.Values != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Values) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-resourcegroups/lib/index.js
var require_lib222 = __commonJS({
  "node_modules/aws-cdk-lib/aws-resourcegroups/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_resourcegroups_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-resourcegroups/index.js
var require_aws_resourcegroups = __commonJS({
  "node_modules/aws-cdk-lib/aws-resourcegroups/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib222(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-robomaker/lib/robomaker.generated.js
var require_robomaker_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-robomaker/lib/robomaker.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnSimulationApplicationVersion = exports2.CfnSimulationApplication = exports2.CfnRobotApplicationVersion = exports2.CfnRobotApplication = exports2.CfnRobot = exports2.CfnFleet = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnFleetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.wrap('supplied properties not correct for "CfnFleetProps"');
    }
    function cfnFleetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFleetPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnFleetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFleet = class _CfnFleet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFleetPropsFromCloudFormation(resourceProperties), ret = new _CfnFleet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnFleet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_robomaker_CfnFleetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFleet), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::RoboMaker::Fleet", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFleet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnFleetPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnFleet[_a] = { fqn: "aws-cdk-lib.aws_robomaker.CfnFleet", version: "2.80.0" }, CfnFleet.CFN_RESOURCE_TYPE_NAME = "AWS::RoboMaker::Fleet", exports2.CfnFleet = CfnFleet;
    function CfnRobotPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("architecture", cdk.requiredValidator)(properties.architecture)), errors.collect(cdk.propertyValidator("architecture", cdk.validateString)(properties.architecture)), errors.collect(cdk.propertyValidator("fleet", cdk.validateString)(properties.fleet)), errors.collect(cdk.propertyValidator("greengrassGroupId", cdk.requiredValidator)(properties.greengrassGroupId)), errors.collect(cdk.propertyValidator("greengrassGroupId", cdk.validateString)(properties.greengrassGroupId)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.wrap('supplied properties not correct for "CfnRobotProps"');
    }
    function cfnRobotPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRobotPropsValidator(properties).assertSuccess(), { Architecture: cdk.stringToCloudFormation(properties.architecture), GreengrassGroupId: cdk.stringToCloudFormation(properties.greengrassGroupId), Fleet: cdk.stringToCloudFormation(properties.fleet), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnRobotPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("architecture", "Architecture", cfn_parse.FromCloudFormation.getString(properties.Architecture)), ret.addPropertyResult("greengrassGroupId", "GreengrassGroupId", cfn_parse.FromCloudFormation.getString(properties.GreengrassGroupId)), ret.addPropertyResult("fleet", "Fleet", properties.Fleet != null ? cfn_parse.FromCloudFormation.getString(properties.Fleet) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRobot = class _CfnRobot extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRobotPropsFromCloudFormation(resourceProperties), ret = new _CfnRobot(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRobot.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_robomaker_CfnRobotProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRobot), error;
        }
        cdk.requireProperty(props, "architecture", this), cdk.requireProperty(props, "greengrassGroupId", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.architecture = props.architecture, this.greengrassGroupId = props.greengrassGroupId, this.fleet = props.fleet, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::RoboMaker::Robot", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRobot.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { architecture: this.architecture, greengrassGroupId: this.greengrassGroupId, fleet: this.fleet, name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnRobotPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnRobot[_b] = { fqn: "aws-cdk-lib.aws_robomaker.CfnRobot", version: "2.80.0" }, CfnRobot.CFN_RESOURCE_TYPE_NAME = "AWS::RoboMaker::Robot", exports2.CfnRobot = CfnRobot;
    function CfnRobotApplicationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("currentRevisionId", cdk.validateString)(properties.currentRevisionId)), errors.collect(cdk.propertyValidator("environment", cdk.validateString)(properties.environment)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("robotSoftwareSuite", cdk.requiredValidator)(properties.robotSoftwareSuite)), errors.collect(cdk.propertyValidator("robotSoftwareSuite", CfnRobotApplication_RobotSoftwareSuitePropertyValidator)(properties.robotSoftwareSuite)), errors.collect(cdk.propertyValidator("sources", cdk.listValidator(CfnRobotApplication_SourceConfigPropertyValidator))(properties.sources)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.wrap('supplied properties not correct for "CfnRobotApplicationProps"');
    }
    function cfnRobotApplicationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRobotApplicationPropsValidator(properties).assertSuccess(), { RobotSoftwareSuite: cfnRobotApplicationRobotSoftwareSuitePropertyToCloudFormation(properties.robotSoftwareSuite), CurrentRevisionId: cdk.stringToCloudFormation(properties.currentRevisionId), Environment: cdk.stringToCloudFormation(properties.environment), Name: cdk.stringToCloudFormation(properties.name), Sources: cdk.listMapper(cfnRobotApplicationSourceConfigPropertyToCloudFormation)(properties.sources), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnRobotApplicationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("robotSoftwareSuite", "RobotSoftwareSuite", CfnRobotApplicationRobotSoftwareSuitePropertyFromCloudFormation(properties.RobotSoftwareSuite)), ret.addPropertyResult("currentRevisionId", "CurrentRevisionId", properties.CurrentRevisionId != null ? cfn_parse.FromCloudFormation.getString(properties.CurrentRevisionId) : void 0), ret.addPropertyResult("environment", "Environment", properties.Environment != null ? cfn_parse.FromCloudFormation.getString(properties.Environment) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("sources", "Sources", properties.Sources != null ? cfn_parse.FromCloudFormation.getArray(CfnRobotApplicationSourceConfigPropertyFromCloudFormation)(properties.Sources) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRobotApplication = class _CfnRobotApplication extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRobotApplicationPropsFromCloudFormation(resourceProperties), ret = new _CfnRobotApplication(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRobotApplication.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_robomaker_CfnRobotApplicationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRobotApplication), error;
        }
        cdk.requireProperty(props, "robotSoftwareSuite", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCurrentRevisionId = cdk.Token.asString(this.getAtt("CurrentRevisionId", cdk.ResolutionTypeHint.STRING)), this.robotSoftwareSuite = props.robotSoftwareSuite, this.currentRevisionId = props.currentRevisionId, this.environment = props.environment, this.name = props.name, this.sources = props.sources, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::RoboMaker::RobotApplication", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRobotApplication.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { robotSoftwareSuite: this.robotSoftwareSuite, currentRevisionId: this.currentRevisionId, environment: this.environment, name: this.name, sources: this.sources, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnRobotApplicationPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnRobotApplication[_c] = { fqn: "aws-cdk-lib.aws_robomaker.CfnRobotApplication", version: "2.80.0" }, CfnRobotApplication.CFN_RESOURCE_TYPE_NAME = "AWS::RoboMaker::RobotApplication", exports2.CfnRobotApplication = CfnRobotApplication;
    function CfnRobotApplication_RobotSoftwareSuitePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "RobotSoftwareSuiteProperty"');
    }
    function cfnRobotApplicationRobotSoftwareSuitePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRobotApplication_RobotSoftwareSuitePropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnRobotApplicationRobotSoftwareSuitePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getString(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRobotApplication_SourceConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("architecture", cdk.requiredValidator)(properties.architecture)), errors.collect(cdk.propertyValidator("architecture", cdk.validateString)(properties.architecture)), errors.collect(cdk.propertyValidator("s3Bucket", cdk.requiredValidator)(properties.s3Bucket)), errors.collect(cdk.propertyValidator("s3Bucket", cdk.validateString)(properties.s3Bucket)), errors.collect(cdk.propertyValidator("s3Key", cdk.requiredValidator)(properties.s3Key)), errors.collect(cdk.propertyValidator("s3Key", cdk.validateString)(properties.s3Key)), errors.wrap('supplied properties not correct for "SourceConfigProperty"');
    }
    function cfnRobotApplicationSourceConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRobotApplication_SourceConfigPropertyValidator(properties).assertSuccess(), { Architecture: cdk.stringToCloudFormation(properties.architecture), S3Bucket: cdk.stringToCloudFormation(properties.s3Bucket), S3Key: cdk.stringToCloudFormation(properties.s3Key) }) : properties;
    }
    function CfnRobotApplicationSourceConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("architecture", "Architecture", cfn_parse.FromCloudFormation.getString(properties.Architecture)), ret.addPropertyResult("s3Bucket", "S3Bucket", cfn_parse.FromCloudFormation.getString(properties.S3Bucket)), ret.addPropertyResult("s3Key", "S3Key", cfn_parse.FromCloudFormation.getString(properties.S3Key)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRobotApplicationVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("application", cdk.requiredValidator)(properties.application)), errors.collect(cdk.propertyValidator("application", cdk.validateString)(properties.application)), errors.collect(cdk.propertyValidator("currentRevisionId", cdk.validateString)(properties.currentRevisionId)), errors.wrap('supplied properties not correct for "CfnRobotApplicationVersionProps"');
    }
    function cfnRobotApplicationVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRobotApplicationVersionPropsValidator(properties).assertSuccess(), { Application: cdk.stringToCloudFormation(properties.application), CurrentRevisionId: cdk.stringToCloudFormation(properties.currentRevisionId) }) : properties;
    }
    function CfnRobotApplicationVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("application", "Application", cfn_parse.FromCloudFormation.getString(properties.Application)), ret.addPropertyResult("currentRevisionId", "CurrentRevisionId", properties.CurrentRevisionId != null ? cfn_parse.FromCloudFormation.getString(properties.CurrentRevisionId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRobotApplicationVersion = class _CfnRobotApplicationVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRobotApplicationVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnRobotApplicationVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRobotApplicationVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_robomaker_CfnRobotApplicationVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRobotApplicationVersion), error;
        }
        cdk.requireProperty(props, "application", this), this.attrApplicationVersion = cdk.Token.asString(this.getAtt("ApplicationVersion", cdk.ResolutionTypeHint.STRING)), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.application = props.application, this.currentRevisionId = props.currentRevisionId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRobotApplicationVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { application: this.application, currentRevisionId: this.currentRevisionId };
      }
      renderProperties(props) {
        return cfnRobotApplicationVersionPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnRobotApplicationVersion[_d] = { fqn: "aws-cdk-lib.aws_robomaker.CfnRobotApplicationVersion", version: "2.80.0" }, CfnRobotApplicationVersion.CFN_RESOURCE_TYPE_NAME = "AWS::RoboMaker::RobotApplicationVersion", exports2.CfnRobotApplicationVersion = CfnRobotApplicationVersion;
    function CfnSimulationApplicationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("currentRevisionId", cdk.validateString)(properties.currentRevisionId)), errors.collect(cdk.propertyValidator("environment", cdk.validateString)(properties.environment)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("renderingEngine", CfnSimulationApplication_RenderingEnginePropertyValidator)(properties.renderingEngine)), errors.collect(cdk.propertyValidator("robotSoftwareSuite", cdk.requiredValidator)(properties.robotSoftwareSuite)), errors.collect(cdk.propertyValidator("robotSoftwareSuite", CfnSimulationApplication_RobotSoftwareSuitePropertyValidator)(properties.robotSoftwareSuite)), errors.collect(cdk.propertyValidator("simulationSoftwareSuite", cdk.requiredValidator)(properties.simulationSoftwareSuite)), errors.collect(cdk.propertyValidator("simulationSoftwareSuite", CfnSimulationApplication_SimulationSoftwareSuitePropertyValidator)(properties.simulationSoftwareSuite)), errors.collect(cdk.propertyValidator("sources", cdk.listValidator(CfnSimulationApplication_SourceConfigPropertyValidator))(properties.sources)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.wrap('supplied properties not correct for "CfnSimulationApplicationProps"');
    }
    function cfnSimulationApplicationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSimulationApplicationPropsValidator(properties).assertSuccess(), { RobotSoftwareSuite: cfnSimulationApplicationRobotSoftwareSuitePropertyToCloudFormation(properties.robotSoftwareSuite), SimulationSoftwareSuite: cfnSimulationApplicationSimulationSoftwareSuitePropertyToCloudFormation(properties.simulationSoftwareSuite), CurrentRevisionId: cdk.stringToCloudFormation(properties.currentRevisionId), Environment: cdk.stringToCloudFormation(properties.environment), Name: cdk.stringToCloudFormation(properties.name), RenderingEngine: cfnSimulationApplicationRenderingEnginePropertyToCloudFormation(properties.renderingEngine), Sources: cdk.listMapper(cfnSimulationApplicationSourceConfigPropertyToCloudFormation)(properties.sources), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnSimulationApplicationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("robotSoftwareSuite", "RobotSoftwareSuite", CfnSimulationApplicationRobotSoftwareSuitePropertyFromCloudFormation(properties.RobotSoftwareSuite)), ret.addPropertyResult("simulationSoftwareSuite", "SimulationSoftwareSuite", CfnSimulationApplicationSimulationSoftwareSuitePropertyFromCloudFormation(properties.SimulationSoftwareSuite)), ret.addPropertyResult("currentRevisionId", "CurrentRevisionId", properties.CurrentRevisionId != null ? cfn_parse.FromCloudFormation.getString(properties.CurrentRevisionId) : void 0), ret.addPropertyResult("environment", "Environment", properties.Environment != null ? cfn_parse.FromCloudFormation.getString(properties.Environment) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("renderingEngine", "RenderingEngine", properties.RenderingEngine != null ? CfnSimulationApplicationRenderingEnginePropertyFromCloudFormation(properties.RenderingEngine) : void 0), ret.addPropertyResult("sources", "Sources", properties.Sources != null ? cfn_parse.FromCloudFormation.getArray(CfnSimulationApplicationSourceConfigPropertyFromCloudFormation)(properties.Sources) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSimulationApplication = class _CfnSimulationApplication extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSimulationApplicationPropsFromCloudFormation(resourceProperties), ret = new _CfnSimulationApplication(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSimulationApplication.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_robomaker_CfnSimulationApplicationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSimulationApplication), error;
        }
        cdk.requireProperty(props, "robotSoftwareSuite", this), cdk.requireProperty(props, "simulationSoftwareSuite", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCurrentRevisionId = cdk.Token.asString(this.getAtt("CurrentRevisionId", cdk.ResolutionTypeHint.STRING)), this.robotSoftwareSuite = props.robotSoftwareSuite, this.simulationSoftwareSuite = props.simulationSoftwareSuite, this.currentRevisionId = props.currentRevisionId, this.environment = props.environment, this.name = props.name, this.renderingEngine = props.renderingEngine, this.sources = props.sources, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::RoboMaker::SimulationApplication", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSimulationApplication.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { robotSoftwareSuite: this.robotSoftwareSuite, simulationSoftwareSuite: this.simulationSoftwareSuite, currentRevisionId: this.currentRevisionId, environment: this.environment, name: this.name, renderingEngine: this.renderingEngine, sources: this.sources, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnSimulationApplicationPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnSimulationApplication[_e] = { fqn: "aws-cdk-lib.aws_robomaker.CfnSimulationApplication", version: "2.80.0" }, CfnSimulationApplication.CFN_RESOURCE_TYPE_NAME = "AWS::RoboMaker::SimulationApplication", exports2.CfnSimulationApplication = CfnSimulationApplication;
    function CfnSimulationApplication_RenderingEnginePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("version", cdk.requiredValidator)(properties.version)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "RenderingEngineProperty"');
    }
    function cfnSimulationApplicationRenderingEnginePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSimulationApplication_RenderingEnginePropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnSimulationApplicationRenderingEnginePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("version", "Version", cfn_parse.FromCloudFormation.getString(properties.Version)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSimulationApplication_RobotSoftwareSuitePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "RobotSoftwareSuiteProperty"');
    }
    function cfnSimulationApplicationRobotSoftwareSuitePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSimulationApplication_RobotSoftwareSuitePropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnSimulationApplicationRobotSoftwareSuitePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getString(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSimulationApplication_SimulationSoftwareSuitePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "SimulationSoftwareSuiteProperty"');
    }
    function cfnSimulationApplicationSimulationSoftwareSuitePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSimulationApplication_SimulationSoftwareSuitePropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnSimulationApplicationSimulationSoftwareSuitePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getString(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSimulationApplication_SourceConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("architecture", cdk.requiredValidator)(properties.architecture)), errors.collect(cdk.propertyValidator("architecture", cdk.validateString)(properties.architecture)), errors.collect(cdk.propertyValidator("s3Bucket", cdk.requiredValidator)(properties.s3Bucket)), errors.collect(cdk.propertyValidator("s3Bucket", cdk.validateString)(properties.s3Bucket)), errors.collect(cdk.propertyValidator("s3Key", cdk.requiredValidator)(properties.s3Key)), errors.collect(cdk.propertyValidator("s3Key", cdk.validateString)(properties.s3Key)), errors.wrap('supplied properties not correct for "SourceConfigProperty"');
    }
    function cfnSimulationApplicationSourceConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSimulationApplication_SourceConfigPropertyValidator(properties).assertSuccess(), { Architecture: cdk.stringToCloudFormation(properties.architecture), S3Bucket: cdk.stringToCloudFormation(properties.s3Bucket), S3Key: cdk.stringToCloudFormation(properties.s3Key) }) : properties;
    }
    function CfnSimulationApplicationSourceConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("architecture", "Architecture", cfn_parse.FromCloudFormation.getString(properties.Architecture)), ret.addPropertyResult("s3Bucket", "S3Bucket", cfn_parse.FromCloudFormation.getString(properties.S3Bucket)), ret.addPropertyResult("s3Key", "S3Key", cfn_parse.FromCloudFormation.getString(properties.S3Key)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSimulationApplicationVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("application", cdk.requiredValidator)(properties.application)), errors.collect(cdk.propertyValidator("application", cdk.validateString)(properties.application)), errors.collect(cdk.propertyValidator("currentRevisionId", cdk.validateString)(properties.currentRevisionId)), errors.wrap('supplied properties not correct for "CfnSimulationApplicationVersionProps"');
    }
    function cfnSimulationApplicationVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSimulationApplicationVersionPropsValidator(properties).assertSuccess(), { Application: cdk.stringToCloudFormation(properties.application), CurrentRevisionId: cdk.stringToCloudFormation(properties.currentRevisionId) }) : properties;
    }
    function CfnSimulationApplicationVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("application", "Application", cfn_parse.FromCloudFormation.getString(properties.Application)), ret.addPropertyResult("currentRevisionId", "CurrentRevisionId", properties.CurrentRevisionId != null ? cfn_parse.FromCloudFormation.getString(properties.CurrentRevisionId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSimulationApplicationVersion = class _CfnSimulationApplicationVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSimulationApplicationVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnSimulationApplicationVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSimulationApplicationVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_robomaker_CfnSimulationApplicationVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSimulationApplicationVersion), error;
        }
        cdk.requireProperty(props, "application", this), this.attrApplicationVersion = cdk.Token.asString(this.getAtt("ApplicationVersion", cdk.ResolutionTypeHint.STRING)), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.application = props.application, this.currentRevisionId = props.currentRevisionId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSimulationApplicationVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { application: this.application, currentRevisionId: this.currentRevisionId };
      }
      renderProperties(props) {
        return cfnSimulationApplicationVersionPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnSimulationApplicationVersion[_f] = { fqn: "aws-cdk-lib.aws_robomaker.CfnSimulationApplicationVersion", version: "2.80.0" }, CfnSimulationApplicationVersion.CFN_RESOURCE_TYPE_NAME = "AWS::RoboMaker::SimulationApplicationVersion", exports2.CfnSimulationApplicationVersion = CfnSimulationApplicationVersion;
  }
});

// node_modules/aws-cdk-lib/aws-robomaker/lib/index.js
var require_lib223 = __commonJS({
  "node_modules/aws-cdk-lib/aws-robomaker/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_robomaker_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-robomaker/index.js
var require_aws_robomaker = __commonJS({
  "node_modules/aws-cdk-lib/aws-robomaker/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib223(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-rolesanywhere/lib/rolesanywhere.generated.js
var require_rolesanywhere_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-rolesanywhere/lib/rolesanywhere.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnTrustAnchor = exports2.CfnProfile = exports2.CfnCRL = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnCRLPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("crlData", cdk.requiredValidator)(properties.crlData)), errors.collect(cdk.propertyValidator("crlData", cdk.validateString)(properties.crlData)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("trustAnchorArn", cdk.validateString)(properties.trustAnchorArn)), errors.wrap('supplied properties not correct for "CfnCRLProps"');
    }
    function cfnCRLPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCRLPropsValidator(properties).assertSuccess(), { CrlData: cdk.stringToCloudFormation(properties.crlData), Name: cdk.stringToCloudFormation(properties.name), Enabled: cdk.booleanToCloudFormation(properties.enabled), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TrustAnchorArn: cdk.stringToCloudFormation(properties.trustAnchorArn) }) : properties;
    }
    function CfnCRLPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("crlData", "CrlData", cfn_parse.FromCloudFormation.getString(properties.CrlData)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("trustAnchorArn", "TrustAnchorArn", properties.TrustAnchorArn != null ? cfn_parse.FromCloudFormation.getString(properties.TrustAnchorArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCRL = class _CfnCRL extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCRLPropsFromCloudFormation(resourceProperties), ret = new _CfnCRL(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCRL.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rolesanywhere_CfnCRLProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCRL), error;
        }
        cdk.requireProperty(props, "crlData", this), cdk.requireProperty(props, "name", this), this.attrCrlId = cdk.Token.asString(this.getAtt("CrlId", cdk.ResolutionTypeHint.STRING)), this.crlData = props.crlData, this.name = props.name, this.enabled = props.enabled, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::RolesAnywhere::CRL", props.tags, { tagPropertyName: "tags" }), this.trustAnchorArn = props.trustAnchorArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCRL.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { crlData: this.crlData, name: this.name, enabled: this.enabled, tags: this.tags.renderTags(), trustAnchorArn: this.trustAnchorArn };
      }
      renderProperties(props) {
        return cfnCRLPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnCRL[_a] = { fqn: "aws-cdk-lib.aws_rolesanywhere.CfnCRL", version: "2.80.0" }, CfnCRL.CFN_RESOURCE_TYPE_NAME = "AWS::RolesAnywhere::CRL", exports2.CfnCRL = CfnCRL;
    function CfnProfilePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("durationSeconds", cdk.validateNumber)(properties.durationSeconds)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("managedPolicyArns", cdk.listValidator(cdk.validateString))(properties.managedPolicyArns)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("requireInstanceProperties", cdk.validateBoolean)(properties.requireInstanceProperties)), errors.collect(cdk.propertyValidator("roleArns", cdk.requiredValidator)(properties.roleArns)), errors.collect(cdk.propertyValidator("roleArns", cdk.listValidator(cdk.validateString))(properties.roleArns)), errors.collect(cdk.propertyValidator("sessionPolicy", cdk.validateString)(properties.sessionPolicy)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnProfileProps"');
    }
    function cfnProfilePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProfilePropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), RoleArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.roleArns), DurationSeconds: cdk.numberToCloudFormation(properties.durationSeconds), Enabled: cdk.booleanToCloudFormation(properties.enabled), ManagedPolicyArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.managedPolicyArns), RequireInstanceProperties: cdk.booleanToCloudFormation(properties.requireInstanceProperties), SessionPolicy: cdk.stringToCloudFormation(properties.sessionPolicy), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnProfilePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("roleArns", "RoleArns", cfn_parse.FromCloudFormation.getStringArray(properties.RoleArns)), ret.addPropertyResult("durationSeconds", "DurationSeconds", properties.DurationSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.DurationSeconds) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("managedPolicyArns", "ManagedPolicyArns", properties.ManagedPolicyArns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ManagedPolicyArns) : void 0), ret.addPropertyResult("requireInstanceProperties", "RequireInstanceProperties", properties.RequireInstanceProperties != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RequireInstanceProperties) : void 0), ret.addPropertyResult("sessionPolicy", "SessionPolicy", properties.SessionPolicy != null ? cfn_parse.FromCloudFormation.getString(properties.SessionPolicy) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnProfile = class _CfnProfile extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnProfilePropsFromCloudFormation(resourceProperties), ret = new _CfnProfile(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnProfile.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rolesanywhere_CfnProfileProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnProfile), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "roleArns", this), this.attrProfileArn = cdk.Token.asString(this.getAtt("ProfileArn", cdk.ResolutionTypeHint.STRING)), this.attrProfileId = cdk.Token.asString(this.getAtt("ProfileId", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.roleArns = props.roleArns, this.durationSeconds = props.durationSeconds, this.enabled = props.enabled, this.managedPolicyArns = props.managedPolicyArns, this.requireInstanceProperties = props.requireInstanceProperties, this.sessionPolicy = props.sessionPolicy, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::RolesAnywhere::Profile", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnProfile.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, roleArns: this.roleArns, durationSeconds: this.durationSeconds, enabled: this.enabled, managedPolicyArns: this.managedPolicyArns, requireInstanceProperties: this.requireInstanceProperties, sessionPolicy: this.sessionPolicy, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnProfilePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnProfile[_b] = { fqn: "aws-cdk-lib.aws_rolesanywhere.CfnProfile", version: "2.80.0" }, CfnProfile.CFN_RESOURCE_TYPE_NAME = "AWS::RolesAnywhere::Profile", exports2.CfnProfile = CfnProfile;
    function CfnTrustAnchorPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("source", cdk.requiredValidator)(properties.source)), errors.collect(cdk.propertyValidator("source", CfnTrustAnchor_SourcePropertyValidator)(properties.source)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnTrustAnchorProps"');
    }
    function cfnTrustAnchorPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTrustAnchorPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Source: cfnTrustAnchorSourcePropertyToCloudFormation(properties.source), Enabled: cdk.booleanToCloudFormation(properties.enabled), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnTrustAnchorPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("source", "Source", CfnTrustAnchorSourcePropertyFromCloudFormation(properties.Source)), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTrustAnchor = class _CfnTrustAnchor extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTrustAnchorPropsFromCloudFormation(resourceProperties), ret = new _CfnTrustAnchor(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTrustAnchor.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rolesanywhere_CfnTrustAnchorProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTrustAnchor), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "source", this), this.attrTrustAnchorArn = cdk.Token.asString(this.getAtt("TrustAnchorArn", cdk.ResolutionTypeHint.STRING)), this.attrTrustAnchorId = cdk.Token.asString(this.getAtt("TrustAnchorId", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.source = props.source, this.enabled = props.enabled, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::RolesAnywhere::TrustAnchor", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTrustAnchor.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, source: this.source, enabled: this.enabled, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnTrustAnchorPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnTrustAnchor[_c] = { fqn: "aws-cdk-lib.aws_rolesanywhere.CfnTrustAnchor", version: "2.80.0" }, CfnTrustAnchor.CFN_RESOURCE_TYPE_NAME = "AWS::RolesAnywhere::TrustAnchor", exports2.CfnTrustAnchor = CfnTrustAnchor;
    function CfnTrustAnchor_SourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sourceData", CfnTrustAnchor_SourceDataPropertyValidator)(properties.sourceData)), errors.collect(cdk.propertyValidator("sourceType", cdk.validateString)(properties.sourceType)), errors.wrap('supplied properties not correct for "SourceProperty"');
    }
    function cfnTrustAnchorSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTrustAnchor_SourcePropertyValidator(properties).assertSuccess(), { SourceData: cfnTrustAnchorSourceDataPropertyToCloudFormation(properties.sourceData), SourceType: cdk.stringToCloudFormation(properties.sourceType) }) : properties;
    }
    function CfnTrustAnchorSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sourceData", "SourceData", properties.SourceData != null ? CfnTrustAnchorSourceDataPropertyFromCloudFormation(properties.SourceData) : void 0), ret.addPropertyResult("sourceType", "SourceType", properties.SourceType != null ? cfn_parse.FromCloudFormation.getString(properties.SourceType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTrustAnchor_SourceDataPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acmPcaArn", cdk.validateString)(properties.acmPcaArn)), errors.collect(cdk.propertyValidator("x509CertificateData", cdk.validateString)(properties.x509CertificateData)), errors.wrap('supplied properties not correct for "SourceDataProperty"');
    }
    function cfnTrustAnchorSourceDataPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTrustAnchor_SourceDataPropertyValidator(properties).assertSuccess(), { AcmPcaArn: cdk.stringToCloudFormation(properties.acmPcaArn), X509CertificateData: cdk.stringToCloudFormation(properties.x509CertificateData) }) : properties;
    }
    function CfnTrustAnchorSourceDataPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("acmPcaArn", "AcmPcaArn", properties.AcmPcaArn != null ? cfn_parse.FromCloudFormation.getString(properties.AcmPcaArn) : void 0), ret.addPropertyResult("x509CertificateData", "X509CertificateData", properties.X509CertificateData != null ? cfn_parse.FromCloudFormation.getString(properties.X509CertificateData) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-rolesanywhere/lib/index.js
var require_lib224 = __commonJS({
  "node_modules/aws-cdk-lib/aws-rolesanywhere/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_rolesanywhere_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-rolesanywhere/index.js
var require_aws_rolesanywhere = __commonJS({
  "node_modules/aws-cdk-lib/aws-rolesanywhere/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib224(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-route53-patterns/lib/website-redirect.js
var require_website_redirect = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53-patterns/lib/website-redirect.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.HttpsRedirect = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var aws_certificatemanager_1 = require_aws_certificatemanager();
    var aws_cloudfront_1 = require_aws_cloudfront();
    var aws_route53_1 = require_aws_route53();
    var aws_route53_targets_1 = require_aws_route53_targets();
    var aws_s3_1 = require_aws_s3();
    var core_1 = require_core2();
    var helpers_internal_1 = require_helpers_internal();
    var cx_api_1 = require_cx_api();
    var HttpsRedirect = class _HttpsRedirect extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_patterns_HttpsRedirectProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _HttpsRedirect), error;
        }
        const domainNames = props.recordNames ?? [props.zone.zoneName];
        if (props.certificate) {
          const certificateRegion = core_1.Stack.of(this).splitArn(props.certificate.certificateArn, core_1.ArnFormat.SLASH_RESOURCE_NAME).region;
          if (!core_1.Token.isUnresolved(certificateRegion) && certificateRegion !== "us-east-1")
            throw new Error(`The certificate must be in the us-east-1 region and the certificate you provided is in ${certificateRegion}.`);
        }
        const redirectCert = props.certificate ?? this.createCertificate(domainNames, props.zone), redirectBucket = new aws_s3_1.Bucket(this, "RedirectBucket", { websiteRedirect: { hostName: props.targetDomain, protocol: aws_s3_1.RedirectProtocol.HTTPS }, removalPolicy: core_1.RemovalPolicy.DESTROY, blockPublicAccess: aws_s3_1.BlockPublicAccess.BLOCK_ALL }), redirectDist = new aws_cloudfront_1.CloudFrontWebDistribution(this, "RedirectDistribution", { defaultRootObject: "", originConfigs: [{ behaviors: [{ isDefaultBehavior: true }], customOriginSource: { domainName: redirectBucket.bucketWebsiteDomainName, originProtocolPolicy: aws_cloudfront_1.OriginProtocolPolicy.HTTP_ONLY } }], viewerCertificate: aws_cloudfront_1.ViewerCertificate.fromAcmCertificate(redirectCert, { aliases: domainNames }), comment: `Redirect to ${props.targetDomain} from ${domainNames.join(", ")}`, priceClass: aws_cloudfront_1.PriceClass.PRICE_CLASS_ALL, viewerProtocolPolicy: aws_cloudfront_1.ViewerProtocolPolicy.REDIRECT_TO_HTTPS });
        domainNames.forEach((domainName) => {
          const hash = (0, helpers_internal_1.md5hash)(domainName).slice(0, 6), aliasProps = { recordName: domainName, zone: props.zone, target: aws_route53_1.RecordTarget.fromAlias(new aws_route53_targets_1.CloudFrontTarget(redirectDist)) };
          new aws_route53_1.ARecord(this, `RedirectAliasRecord${hash}`, aliasProps), new aws_route53_1.AaaaRecord(this, `RedirectAliasRecordSix${hash}`, aliasProps);
        });
      }
      certificateScope() {
        const stack = core_1.Stack.of(this), parent = stack.node.scope;
        if (!parent)
          throw new Error(`Stack ${stack.stackId} must be created in the scope of an App or Stage`);
        if (core_1.Token.isUnresolved(stack.region))
          throw new Error(`When ${cx_api_1.ROUTE53_PATTERNS_USE_CERTIFICATE} is enabled, a region must be defined on the Stack`);
        if (stack.region !== "us-east-1") {
          const stackId = `certificate-redirect-stack-${stack.node.addr}`;
          return parent.node.tryFindChild(stackId) ?? new core_1.Stack(parent, stackId, { env: { region: "us-east-1", account: stack.account } });
        }
        return this;
      }
      createCertificate(domainNames, zone) {
        if (core_1.FeatureFlags.of(this).isEnabled(cx_api_1.ROUTE53_PATTERNS_USE_CERTIFICATE)) {
          const id = this.certificateScope() === this ? "RedirectCertificate" : "RedirectCertificate" + this.node.addr;
          return new aws_certificatemanager_1.Certificate(this.certificateScope(), id, { domainName: domainNames[0], subjectAlternativeNames: domainNames, validation: aws_certificatemanager_1.CertificateValidation.fromDns(zone) });
        } else
          return new aws_certificatemanager_1.DnsValidatedCertificate(this, "RedirectCertificate", { domainName: domainNames[0], subjectAlternativeNames: domainNames, hostedZone: zone, region: "us-east-1" });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, HttpsRedirect[_a] = { fqn: "aws-cdk-lib.aws_route53_patterns.HttpsRedirect", version: "2.80.0" }, exports2.HttpsRedirect = HttpsRedirect;
  }
});

// node_modules/aws-cdk-lib/aws-route53-patterns/lib/index.js
var require_lib225 = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53-patterns/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_website_redirect(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-route53-patterns/index.js
var require_aws_route53_patterns = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53-patterns/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib225(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-route53recoverycontrol/lib/route53recoverycontrol.generated.js
var require_route53recoverycontrol_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53recoverycontrol/lib/route53recoverycontrol.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnSafetyRule = exports2.CfnRoutingControl = exports2.CfnControlPanel = exports2.CfnCluster = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnClusterPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnClusterProps"');
    }
    function cfnClusterPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnClusterPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnClusterPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCluster = class _CfnCluster extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnClusterPropsFromCloudFormation(resourceProperties), ret = new _CfnCluster(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCluster.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53recoverycontrol_CfnClusterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCluster), error;
        }
        cdk.requireProperty(props, "name", this), this.attrClusterArn = cdk.Token.asString(this.getAtt("ClusterArn", cdk.ResolutionTypeHint.STRING)), this.attrClusterEndpoints = this.getAtt("ClusterEndpoints", cdk.ResolutionTypeHint.STRING), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Route53RecoveryControl::Cluster", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCluster.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnClusterPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnCluster[_a] = { fqn: "aws-cdk-lib.aws_route53recoverycontrol.CfnCluster", version: "2.80.0" }, CfnCluster.CFN_RESOURCE_TYPE_NAME = "AWS::Route53RecoveryControl::Cluster", exports2.CfnCluster = CfnCluster;
    function CfnControlPanelPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clusterArn", cdk.validateString)(properties.clusterArn)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnControlPanelProps"');
    }
    function cfnControlPanelPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnControlPanelPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), ClusterArn: cdk.stringToCloudFormation(properties.clusterArn), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnControlPanelPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("clusterArn", "ClusterArn", properties.ClusterArn != null ? cfn_parse.FromCloudFormation.getString(properties.ClusterArn) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnControlPanel = class _CfnControlPanel extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnControlPanelPropsFromCloudFormation(resourceProperties), ret = new _CfnControlPanel(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnControlPanel.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53recoverycontrol_CfnControlPanelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnControlPanel), error;
        }
        cdk.requireProperty(props, "name", this), this.attrControlPanelArn = cdk.Token.asString(this.getAtt("ControlPanelArn", cdk.ResolutionTypeHint.STRING)), this.attrDefaultControlPanel = this.getAtt("DefaultControlPanel", cdk.ResolutionTypeHint.STRING), this.attrRoutingControlCount = cdk.Token.asNumber(this.getAtt("RoutingControlCount", cdk.ResolutionTypeHint.NUMBER)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.clusterArn = props.clusterArn, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Route53RecoveryControl::ControlPanel", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnControlPanel.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, clusterArn: this.clusterArn, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnControlPanelPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnControlPanel[_b] = { fqn: "aws-cdk-lib.aws_route53recoverycontrol.CfnControlPanel", version: "2.80.0" }, CfnControlPanel.CFN_RESOURCE_TYPE_NAME = "AWS::Route53RecoveryControl::ControlPanel", exports2.CfnControlPanel = CfnControlPanel;
    function CfnRoutingControlPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clusterArn", cdk.validateString)(properties.clusterArn)), errors.collect(cdk.propertyValidator("controlPanelArn", cdk.validateString)(properties.controlPanelArn)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "CfnRoutingControlProps"');
    }
    function cfnRoutingControlPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRoutingControlPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), ClusterArn: cdk.stringToCloudFormation(properties.clusterArn), ControlPanelArn: cdk.stringToCloudFormation(properties.controlPanelArn) }) : properties;
    }
    function CfnRoutingControlPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("clusterArn", "ClusterArn", properties.ClusterArn != null ? cfn_parse.FromCloudFormation.getString(properties.ClusterArn) : void 0), ret.addPropertyResult("controlPanelArn", "ControlPanelArn", properties.ControlPanelArn != null ? cfn_parse.FromCloudFormation.getString(properties.ControlPanelArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRoutingControl = class _CfnRoutingControl extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRoutingControlPropsFromCloudFormation(resourceProperties), ret = new _CfnRoutingControl(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRoutingControl.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53recoverycontrol_CfnRoutingControlProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRoutingControl), error;
        }
        cdk.requireProperty(props, "name", this), this.attrRoutingControlArn = cdk.Token.asString(this.getAtt("RoutingControlArn", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.clusterArn = props.clusterArn, this.controlPanelArn = props.controlPanelArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRoutingControl.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, clusterArn: this.clusterArn, controlPanelArn: this.controlPanelArn };
      }
      renderProperties(props) {
        return cfnRoutingControlPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnRoutingControl[_c] = { fqn: "aws-cdk-lib.aws_route53recoverycontrol.CfnRoutingControl", version: "2.80.0" }, CfnRoutingControl.CFN_RESOURCE_TYPE_NAME = "AWS::Route53RecoveryControl::RoutingControl", exports2.CfnRoutingControl = CfnRoutingControl;
    function CfnSafetyRulePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("assertionRule", CfnSafetyRule_AssertionRulePropertyValidator)(properties.assertionRule)), errors.collect(cdk.propertyValidator("controlPanelArn", cdk.requiredValidator)(properties.controlPanelArn)), errors.collect(cdk.propertyValidator("controlPanelArn", cdk.validateString)(properties.controlPanelArn)), errors.collect(cdk.propertyValidator("gatingRule", CfnSafetyRule_GatingRulePropertyValidator)(properties.gatingRule)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("ruleConfig", cdk.requiredValidator)(properties.ruleConfig)), errors.collect(cdk.propertyValidator("ruleConfig", CfnSafetyRule_RuleConfigPropertyValidator)(properties.ruleConfig)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnSafetyRuleProps"');
    }
    function cfnSafetyRulePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSafetyRulePropsValidator(properties).assertSuccess(), { ControlPanelArn: cdk.stringToCloudFormation(properties.controlPanelArn), Name: cdk.stringToCloudFormation(properties.name), RuleConfig: cfnSafetyRuleRuleConfigPropertyToCloudFormation(properties.ruleConfig), AssertionRule: cfnSafetyRuleAssertionRulePropertyToCloudFormation(properties.assertionRule), GatingRule: cfnSafetyRuleGatingRulePropertyToCloudFormation(properties.gatingRule), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnSafetyRulePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("controlPanelArn", "ControlPanelArn", cfn_parse.FromCloudFormation.getString(properties.ControlPanelArn)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("ruleConfig", "RuleConfig", CfnSafetyRuleRuleConfigPropertyFromCloudFormation(properties.RuleConfig)), ret.addPropertyResult("assertionRule", "AssertionRule", properties.AssertionRule != null ? CfnSafetyRuleAssertionRulePropertyFromCloudFormation(properties.AssertionRule) : void 0), ret.addPropertyResult("gatingRule", "GatingRule", properties.GatingRule != null ? CfnSafetyRuleGatingRulePropertyFromCloudFormation(properties.GatingRule) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSafetyRule = class _CfnSafetyRule extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSafetyRulePropsFromCloudFormation(resourceProperties), ret = new _CfnSafetyRule(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSafetyRule.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53recoverycontrol_CfnSafetyRuleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSafetyRule), error;
        }
        cdk.requireProperty(props, "controlPanelArn", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "ruleConfig", this), this.attrSafetyRuleArn = cdk.Token.asString(this.getAtt("SafetyRuleArn", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.controlPanelArn = props.controlPanelArn, this.name = props.name, this.ruleConfig = props.ruleConfig, this.assertionRule = props.assertionRule, this.gatingRule = props.gatingRule, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Route53RecoveryControl::SafetyRule", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSafetyRule.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { controlPanelArn: this.controlPanelArn, name: this.name, ruleConfig: this.ruleConfig, assertionRule: this.assertionRule, gatingRule: this.gatingRule, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnSafetyRulePropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnSafetyRule[_d] = { fqn: "aws-cdk-lib.aws_route53recoverycontrol.CfnSafetyRule", version: "2.80.0" }, CfnSafetyRule.CFN_RESOURCE_TYPE_NAME = "AWS::Route53RecoveryControl::SafetyRule", exports2.CfnSafetyRule = CfnSafetyRule;
    function CfnSafetyRule_AssertionRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("assertedControls", cdk.requiredValidator)(properties.assertedControls)), errors.collect(cdk.propertyValidator("assertedControls", cdk.listValidator(cdk.validateString))(properties.assertedControls)), errors.collect(cdk.propertyValidator("waitPeriodMs", cdk.requiredValidator)(properties.waitPeriodMs)), errors.collect(cdk.propertyValidator("waitPeriodMs", cdk.validateNumber)(properties.waitPeriodMs)), errors.wrap('supplied properties not correct for "AssertionRuleProperty"');
    }
    function cfnSafetyRuleAssertionRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSafetyRule_AssertionRulePropertyValidator(properties).assertSuccess(), { AssertedControls: cdk.listMapper(cdk.stringToCloudFormation)(properties.assertedControls), WaitPeriodMs: cdk.numberToCloudFormation(properties.waitPeriodMs) }) : properties;
    }
    function CfnSafetyRuleAssertionRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("assertedControls", "AssertedControls", cfn_parse.FromCloudFormation.getStringArray(properties.AssertedControls)), ret.addPropertyResult("waitPeriodMs", "WaitPeriodMs", cfn_parse.FromCloudFormation.getNumber(properties.WaitPeriodMs)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSafetyRule_GatingRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("gatingControls", cdk.requiredValidator)(properties.gatingControls)), errors.collect(cdk.propertyValidator("gatingControls", cdk.listValidator(cdk.validateString))(properties.gatingControls)), errors.collect(cdk.propertyValidator("targetControls", cdk.requiredValidator)(properties.targetControls)), errors.collect(cdk.propertyValidator("targetControls", cdk.listValidator(cdk.validateString))(properties.targetControls)), errors.collect(cdk.propertyValidator("waitPeriodMs", cdk.requiredValidator)(properties.waitPeriodMs)), errors.collect(cdk.propertyValidator("waitPeriodMs", cdk.validateNumber)(properties.waitPeriodMs)), errors.wrap('supplied properties not correct for "GatingRuleProperty"');
    }
    function cfnSafetyRuleGatingRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSafetyRule_GatingRulePropertyValidator(properties).assertSuccess(), { GatingControls: cdk.listMapper(cdk.stringToCloudFormation)(properties.gatingControls), TargetControls: cdk.listMapper(cdk.stringToCloudFormation)(properties.targetControls), WaitPeriodMs: cdk.numberToCloudFormation(properties.waitPeriodMs) }) : properties;
    }
    function CfnSafetyRuleGatingRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("gatingControls", "GatingControls", cfn_parse.FromCloudFormation.getStringArray(properties.GatingControls)), ret.addPropertyResult("targetControls", "TargetControls", cfn_parse.FromCloudFormation.getStringArray(properties.TargetControls)), ret.addPropertyResult("waitPeriodMs", "WaitPeriodMs", cfn_parse.FromCloudFormation.getNumber(properties.WaitPeriodMs)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSafetyRule_RuleConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("inverted", cdk.requiredValidator)(properties.inverted)), errors.collect(cdk.propertyValidator("inverted", cdk.validateBoolean)(properties.inverted)), errors.collect(cdk.propertyValidator("threshold", cdk.requiredValidator)(properties.threshold)), errors.collect(cdk.propertyValidator("threshold", cdk.validateNumber)(properties.threshold)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "RuleConfigProperty"');
    }
    function cfnSafetyRuleRuleConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSafetyRule_RuleConfigPropertyValidator(properties).assertSuccess(), { Inverted: cdk.booleanToCloudFormation(properties.inverted), Threshold: cdk.numberToCloudFormation(properties.threshold), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnSafetyRuleRuleConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("inverted", "Inverted", cfn_parse.FromCloudFormation.getBoolean(properties.Inverted)), ret.addPropertyResult("threshold", "Threshold", cfn_parse.FromCloudFormation.getNumber(properties.Threshold)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-route53recoverycontrol/lib/index.js
var require_lib226 = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53recoverycontrol/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_route53recoverycontrol_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-route53recoverycontrol/index.js
var require_aws_route53recoverycontrol = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53recoverycontrol/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib226(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-route53recoveryreadiness/lib/route53recoveryreadiness.generated.js
var require_route53recoveryreadiness_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53recoveryreadiness/lib/route53recoveryreadiness.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnResourceSet = exports2.CfnRecoveryGroup = exports2.CfnReadinessCheck = exports2.CfnCell = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnCellPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cellName", cdk.validateString)(properties.cellName)), errors.collect(cdk.propertyValidator("cells", cdk.listValidator(cdk.validateString))(properties.cells)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnCellProps"');
    }
    function cfnCellPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCellPropsValidator(properties).assertSuccess(), { CellName: cdk.stringToCloudFormation(properties.cellName), Cells: cdk.listMapper(cdk.stringToCloudFormation)(properties.cells), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnCellPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cellName", "CellName", properties.CellName != null ? cfn_parse.FromCloudFormation.getString(properties.CellName) : void 0), ret.addPropertyResult("cells", "Cells", properties.Cells != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Cells) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCell = class _CfnCell extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCellPropsFromCloudFormation(resourceProperties), ret = new _CfnCell(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnCell.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53recoveryreadiness_CfnCellProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCell), error;
        }
        this.attrCellArn = cdk.Token.asString(this.getAtt("CellArn", cdk.ResolutionTypeHint.STRING)), this.attrParentReadinessScopes = cdk.Token.asList(this.getAtt("ParentReadinessScopes", cdk.ResolutionTypeHint.STRING_LIST)), this.cellName = props.cellName, this.cells = props.cells, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Route53RecoveryReadiness::Cell", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCell.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { cellName: this.cellName, cells: this.cells, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnCellPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnCell[_a] = { fqn: "aws-cdk-lib.aws_route53recoveryreadiness.CfnCell", version: "2.80.0" }, CfnCell.CFN_RESOURCE_TYPE_NAME = "AWS::Route53RecoveryReadiness::Cell", exports2.CfnCell = CfnCell;
    function CfnReadinessCheckPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("readinessCheckName", cdk.validateString)(properties.readinessCheckName)), errors.collect(cdk.propertyValidator("resourceSetName", cdk.validateString)(properties.resourceSetName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnReadinessCheckProps"');
    }
    function cfnReadinessCheckPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReadinessCheckPropsValidator(properties).assertSuccess(), { ReadinessCheckName: cdk.stringToCloudFormation(properties.readinessCheckName), ResourceSetName: cdk.stringToCloudFormation(properties.resourceSetName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnReadinessCheckPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("readinessCheckName", "ReadinessCheckName", properties.ReadinessCheckName != null ? cfn_parse.FromCloudFormation.getString(properties.ReadinessCheckName) : void 0), ret.addPropertyResult("resourceSetName", "ResourceSetName", properties.ResourceSetName != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceSetName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnReadinessCheck = class _CfnReadinessCheck extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnReadinessCheckPropsFromCloudFormation(resourceProperties), ret = new _CfnReadinessCheck(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnReadinessCheck.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53recoveryreadiness_CfnReadinessCheckProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnReadinessCheck), error;
        }
        this.attrReadinessCheckArn = cdk.Token.asString(this.getAtt("ReadinessCheckArn", cdk.ResolutionTypeHint.STRING)), this.readinessCheckName = props.readinessCheckName, this.resourceSetName = props.resourceSetName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Route53RecoveryReadiness::ReadinessCheck", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnReadinessCheck.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { readinessCheckName: this.readinessCheckName, resourceSetName: this.resourceSetName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnReadinessCheckPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnReadinessCheck[_b] = { fqn: "aws-cdk-lib.aws_route53recoveryreadiness.CfnReadinessCheck", version: "2.80.0" }, CfnReadinessCheck.CFN_RESOURCE_TYPE_NAME = "AWS::Route53RecoveryReadiness::ReadinessCheck", exports2.CfnReadinessCheck = CfnReadinessCheck;
    function CfnRecoveryGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cells", cdk.listValidator(cdk.validateString))(properties.cells)), errors.collect(cdk.propertyValidator("recoveryGroupName", cdk.validateString)(properties.recoveryGroupName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnRecoveryGroupProps"');
    }
    function cfnRecoveryGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRecoveryGroupPropsValidator(properties).assertSuccess(), { Cells: cdk.listMapper(cdk.stringToCloudFormation)(properties.cells), RecoveryGroupName: cdk.stringToCloudFormation(properties.recoveryGroupName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnRecoveryGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cells", "Cells", properties.Cells != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Cells) : void 0), ret.addPropertyResult("recoveryGroupName", "RecoveryGroupName", properties.RecoveryGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.RecoveryGroupName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRecoveryGroup = class _CfnRecoveryGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRecoveryGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnRecoveryGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnRecoveryGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53recoveryreadiness_CfnRecoveryGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRecoveryGroup), error;
        }
        this.attrRecoveryGroupArn = cdk.Token.asString(this.getAtt("RecoveryGroupArn", cdk.ResolutionTypeHint.STRING)), this.cells = props.cells, this.recoveryGroupName = props.recoveryGroupName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Route53RecoveryReadiness::RecoveryGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRecoveryGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { cells: this.cells, recoveryGroupName: this.recoveryGroupName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnRecoveryGroupPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnRecoveryGroup[_c] = { fqn: "aws-cdk-lib.aws_route53recoveryreadiness.CfnRecoveryGroup", version: "2.80.0" }, CfnRecoveryGroup.CFN_RESOURCE_TYPE_NAME = "AWS::Route53RecoveryReadiness::RecoveryGroup", exports2.CfnRecoveryGroup = CfnRecoveryGroup;
    function CfnResourceSetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceSetName", cdk.validateString)(properties.resourceSetName)), errors.collect(cdk.propertyValidator("resourceSetType", cdk.requiredValidator)(properties.resourceSetType)), errors.collect(cdk.propertyValidator("resourceSetType", cdk.validateString)(properties.resourceSetType)), errors.collect(cdk.propertyValidator("resources", cdk.requiredValidator)(properties.resources)), errors.collect(cdk.propertyValidator("resources", cdk.listValidator(CfnResourceSet_ResourcePropertyValidator))(properties.resources)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnResourceSetProps"');
    }
    function cfnResourceSetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceSetPropsValidator(properties).assertSuccess(), { Resources: cdk.listMapper(cfnResourceSetResourcePropertyToCloudFormation)(properties.resources), ResourceSetType: cdk.stringToCloudFormation(properties.resourceSetType), ResourceSetName: cdk.stringToCloudFormation(properties.resourceSetName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnResourceSetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resources", "Resources", cfn_parse.FromCloudFormation.getArray(CfnResourceSetResourcePropertyFromCloudFormation)(properties.Resources)), ret.addPropertyResult("resourceSetType", "ResourceSetType", cfn_parse.FromCloudFormation.getString(properties.ResourceSetType)), ret.addPropertyResult("resourceSetName", "ResourceSetName", properties.ResourceSetName != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceSetName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResourceSet = class _CfnResourceSet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResourceSetPropsFromCloudFormation(resourceProperties), ret = new _CfnResourceSet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnResourceSet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53recoveryreadiness_CfnResourceSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResourceSet), error;
        }
        cdk.requireProperty(props, "resourceSetType", this), cdk.requireProperty(props, "resources", this), this.attrResourceSetArn = cdk.Token.asString(this.getAtt("ResourceSetArn", cdk.ResolutionTypeHint.STRING)), this.resources = props.resources, this.resourceSetType = props.resourceSetType, this.resourceSetName = props.resourceSetName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Route53RecoveryReadiness::ResourceSet", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResourceSet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { resources: this.resources, resourceSetType: this.resourceSetType, resourceSetName: this.resourceSetName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnResourceSetPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnResourceSet[_d] = { fqn: "aws-cdk-lib.aws_route53recoveryreadiness.CfnResourceSet", version: "2.80.0" }, CfnResourceSet.CFN_RESOURCE_TYPE_NAME = "AWS::Route53RecoveryReadiness::ResourceSet", exports2.CfnResourceSet = CfnResourceSet;
    function CfnResourceSet_DNSTargetResourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.collect(cdk.propertyValidator("hostedZoneArn", cdk.validateString)(properties.hostedZoneArn)), errors.collect(cdk.propertyValidator("recordSetId", cdk.validateString)(properties.recordSetId)), errors.collect(cdk.propertyValidator("recordType", cdk.validateString)(properties.recordType)), errors.collect(cdk.propertyValidator("targetResource", CfnResourceSet_TargetResourcePropertyValidator)(properties.targetResource)), errors.wrap('supplied properties not correct for "DNSTargetResourceProperty"');
    }
    function cfnResourceSetDNSTargetResourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceSet_DNSTargetResourcePropertyValidator(properties).assertSuccess(), { DomainName: cdk.stringToCloudFormation(properties.domainName), HostedZoneArn: cdk.stringToCloudFormation(properties.hostedZoneArn), RecordSetId: cdk.stringToCloudFormation(properties.recordSetId), RecordType: cdk.stringToCloudFormation(properties.recordType), TargetResource: cfnResourceSetTargetResourcePropertyToCloudFormation(properties.targetResource) }) : properties;
    }
    function CfnResourceSetDNSTargetResourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("domainName", "DomainName", properties.DomainName != null ? cfn_parse.FromCloudFormation.getString(properties.DomainName) : void 0), ret.addPropertyResult("hostedZoneArn", "HostedZoneArn", properties.HostedZoneArn != null ? cfn_parse.FromCloudFormation.getString(properties.HostedZoneArn) : void 0), ret.addPropertyResult("recordSetId", "RecordSetId", properties.RecordSetId != null ? cfn_parse.FromCloudFormation.getString(properties.RecordSetId) : void 0), ret.addPropertyResult("recordType", "RecordType", properties.RecordType != null ? cfn_parse.FromCloudFormation.getString(properties.RecordType) : void 0), ret.addPropertyResult("targetResource", "TargetResource", properties.TargetResource != null ? CfnResourceSetTargetResourcePropertyFromCloudFormation(properties.TargetResource) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourceSet_NLBResourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.wrap('supplied properties not correct for "NLBResourceProperty"');
    }
    function cfnResourceSetNLBResourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceSet_NLBResourcePropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn) }) : properties;
    }
    function CfnResourceSetNLBResourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", properties.Arn != null ? cfn_parse.FromCloudFormation.getString(properties.Arn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourceSet_R53ResourceRecordPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.collect(cdk.propertyValidator("recordSetId", cdk.validateString)(properties.recordSetId)), errors.wrap('supplied properties not correct for "R53ResourceRecordProperty"');
    }
    function cfnResourceSetR53ResourceRecordPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceSet_R53ResourceRecordPropertyValidator(properties).assertSuccess(), { DomainName: cdk.stringToCloudFormation(properties.domainName), RecordSetId: cdk.stringToCloudFormation(properties.recordSetId) }) : properties;
    }
    function CfnResourceSetR53ResourceRecordPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("domainName", "DomainName", properties.DomainName != null ? cfn_parse.FromCloudFormation.getString(properties.DomainName) : void 0), ret.addPropertyResult("recordSetId", "RecordSetId", properties.RecordSetId != null ? cfn_parse.FromCloudFormation.getString(properties.RecordSetId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourceSet_ResourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("componentId", cdk.validateString)(properties.componentId)), errors.collect(cdk.propertyValidator("dnsTargetResource", CfnResourceSet_DNSTargetResourcePropertyValidator)(properties.dnsTargetResource)), errors.collect(cdk.propertyValidator("readinessScopes", cdk.listValidator(cdk.validateString))(properties.readinessScopes)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.wrap('supplied properties not correct for "ResourceProperty"');
    }
    function cfnResourceSetResourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceSet_ResourcePropertyValidator(properties).assertSuccess(), { ComponentId: cdk.stringToCloudFormation(properties.componentId), DnsTargetResource: cfnResourceSetDNSTargetResourcePropertyToCloudFormation(properties.dnsTargetResource), ReadinessScopes: cdk.listMapper(cdk.stringToCloudFormation)(properties.readinessScopes), ResourceArn: cdk.stringToCloudFormation(properties.resourceArn) }) : properties;
    }
    function CfnResourceSetResourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("componentId", "ComponentId", properties.ComponentId != null ? cfn_parse.FromCloudFormation.getString(properties.ComponentId) : void 0), ret.addPropertyResult("dnsTargetResource", "DnsTargetResource", properties.DnsTargetResource != null ? CfnResourceSetDNSTargetResourcePropertyFromCloudFormation(properties.DnsTargetResource) : void 0), ret.addPropertyResult("readinessScopes", "ReadinessScopes", properties.ReadinessScopes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ReadinessScopes) : void 0), ret.addPropertyResult("resourceArn", "ResourceArn", properties.ResourceArn != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourceSet_TargetResourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("nlbResource", CfnResourceSet_NLBResourcePropertyValidator)(properties.nlbResource)), errors.collect(cdk.propertyValidator("r53Resource", CfnResourceSet_R53ResourceRecordPropertyValidator)(properties.r53Resource)), errors.wrap('supplied properties not correct for "TargetResourceProperty"');
    }
    function cfnResourceSetTargetResourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceSet_TargetResourcePropertyValidator(properties).assertSuccess(), { NLBResource: cfnResourceSetNLBResourcePropertyToCloudFormation(properties.nlbResource), R53Resource: cfnResourceSetR53ResourceRecordPropertyToCloudFormation(properties.r53Resource) }) : properties;
    }
    function CfnResourceSetTargetResourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("nlbResource", "NLBResource", properties.NLBResource != null ? CfnResourceSetNLBResourcePropertyFromCloudFormation(properties.NLBResource) : void 0), ret.addPropertyResult("r53Resource", "R53Resource", properties.R53Resource != null ? CfnResourceSetR53ResourceRecordPropertyFromCloudFormation(properties.R53Resource) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-route53recoveryreadiness/lib/index.js
var require_lib227 = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53recoveryreadiness/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_route53recoveryreadiness_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-route53recoveryreadiness/index.js
var require_aws_route53recoveryreadiness = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53recoveryreadiness/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib227(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-route53resolver/lib/route53resolver.generated.js
var require_route53resolver_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53resolver/lib/route53resolver.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnResolverRuleAssociation = exports2.CfnResolverRule = exports2.CfnResolverQueryLoggingConfigAssociation = exports2.CfnResolverQueryLoggingConfig = exports2.CfnResolverEndpoint = exports2.CfnResolverDNSSECConfig = exports2.CfnResolverConfig = exports2.CfnFirewallRuleGroupAssociation = exports2.CfnFirewallRuleGroup = exports2.CfnFirewallDomainList = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnFirewallDomainListPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("domainFileUrl", cdk.validateString)(properties.domainFileUrl)), errors.collect(cdk.propertyValidator("domains", cdk.listValidator(cdk.validateString))(properties.domains)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnFirewallDomainListProps"');
    }
    function cfnFirewallDomainListPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFirewallDomainListPropsValidator(properties).assertSuccess(), { DomainFileUrl: cdk.stringToCloudFormation(properties.domainFileUrl), Domains: cdk.listMapper(cdk.stringToCloudFormation)(properties.domains), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnFirewallDomainListPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("domainFileUrl", "DomainFileUrl", properties.DomainFileUrl != null ? cfn_parse.FromCloudFormation.getString(properties.DomainFileUrl) : void 0), ret.addPropertyResult("domains", "Domains", properties.Domains != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Domains) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFirewallDomainList = class _CfnFirewallDomainList extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFirewallDomainListPropsFromCloudFormation(resourceProperties), ret = new _CfnFirewallDomainList(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnFirewallDomainList.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53resolver_CfnFirewallDomainListProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFirewallDomainList), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrCreatorRequestId = cdk.Token.asString(this.getAtt("CreatorRequestId", cdk.ResolutionTypeHint.STRING)), this.attrDomainCount = cdk.Token.asNumber(this.getAtt("DomainCount", cdk.ResolutionTypeHint.NUMBER)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrManagedOwnerName = cdk.Token.asString(this.getAtt("ManagedOwnerName", cdk.ResolutionTypeHint.STRING)), this.attrModificationTime = cdk.Token.asString(this.getAtt("ModificationTime", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.attrStatusMessage = cdk.Token.asString(this.getAtt("StatusMessage", cdk.ResolutionTypeHint.STRING)), this.domainFileUrl = props.domainFileUrl, this.domains = props.domains, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Route53Resolver::FirewallDomainList", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFirewallDomainList.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { domainFileUrl: this.domainFileUrl, domains: this.domains, name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnFirewallDomainListPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnFirewallDomainList[_a] = { fqn: "aws-cdk-lib.aws_route53resolver.CfnFirewallDomainList", version: "2.80.0" }, CfnFirewallDomainList.CFN_RESOURCE_TYPE_NAME = "AWS::Route53Resolver::FirewallDomainList", exports2.CfnFirewallDomainList = CfnFirewallDomainList;
    function CfnFirewallRuleGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("firewallRules", cdk.listValidator(CfnFirewallRuleGroup_FirewallRulePropertyValidator))(properties.firewallRules)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnFirewallRuleGroupProps"');
    }
    function cfnFirewallRuleGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFirewallRuleGroupPropsValidator(properties).assertSuccess(), { FirewallRules: cdk.listMapper(cfnFirewallRuleGroupFirewallRulePropertyToCloudFormation)(properties.firewallRules), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnFirewallRuleGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("firewallRules", "FirewallRules", properties.FirewallRules != null ? cfn_parse.FromCloudFormation.getArray(CfnFirewallRuleGroupFirewallRulePropertyFromCloudFormation)(properties.FirewallRules) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFirewallRuleGroup = class _CfnFirewallRuleGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFirewallRuleGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnFirewallRuleGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnFirewallRuleGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53resolver_CfnFirewallRuleGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFirewallRuleGroup), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrCreatorRequestId = cdk.Token.asString(this.getAtt("CreatorRequestId", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrModificationTime = cdk.Token.asString(this.getAtt("ModificationTime", cdk.ResolutionTypeHint.STRING)), this.attrOwnerId = cdk.Token.asString(this.getAtt("OwnerId", cdk.ResolutionTypeHint.STRING)), this.attrRuleCount = cdk.Token.asNumber(this.getAtt("RuleCount", cdk.ResolutionTypeHint.NUMBER)), this.attrShareStatus = cdk.Token.asString(this.getAtt("ShareStatus", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.attrStatusMessage = cdk.Token.asString(this.getAtt("StatusMessage", cdk.ResolutionTypeHint.STRING)), this.firewallRules = props.firewallRules, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Route53Resolver::FirewallRuleGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFirewallRuleGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { firewallRules: this.firewallRules, name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnFirewallRuleGroupPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnFirewallRuleGroup[_b] = { fqn: "aws-cdk-lib.aws_route53resolver.CfnFirewallRuleGroup", version: "2.80.0" }, CfnFirewallRuleGroup.CFN_RESOURCE_TYPE_NAME = "AWS::Route53Resolver::FirewallRuleGroup", exports2.CfnFirewallRuleGroup = CfnFirewallRuleGroup;
    function CfnFirewallRuleGroup_FirewallRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.requiredValidator)(properties.action)), errors.collect(cdk.propertyValidator("action", cdk.validateString)(properties.action)), errors.collect(cdk.propertyValidator("blockOverrideDnsType", cdk.validateString)(properties.blockOverrideDnsType)), errors.collect(cdk.propertyValidator("blockOverrideDomain", cdk.validateString)(properties.blockOverrideDomain)), errors.collect(cdk.propertyValidator("blockOverrideTtl", cdk.validateNumber)(properties.blockOverrideTtl)), errors.collect(cdk.propertyValidator("blockResponse", cdk.validateString)(properties.blockResponse)), errors.collect(cdk.propertyValidator("firewallDomainListId", cdk.requiredValidator)(properties.firewallDomainListId)), errors.collect(cdk.propertyValidator("firewallDomainListId", cdk.validateString)(properties.firewallDomainListId)), errors.collect(cdk.propertyValidator("priority", cdk.requiredValidator)(properties.priority)), errors.collect(cdk.propertyValidator("priority", cdk.validateNumber)(properties.priority)), errors.wrap('supplied properties not correct for "FirewallRuleProperty"');
    }
    function cfnFirewallRuleGroupFirewallRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFirewallRuleGroup_FirewallRulePropertyValidator(properties).assertSuccess(), { Action: cdk.stringToCloudFormation(properties.action), BlockOverrideDnsType: cdk.stringToCloudFormation(properties.blockOverrideDnsType), BlockOverrideDomain: cdk.stringToCloudFormation(properties.blockOverrideDomain), BlockOverrideTtl: cdk.numberToCloudFormation(properties.blockOverrideTtl), BlockResponse: cdk.stringToCloudFormation(properties.blockResponse), FirewallDomainListId: cdk.stringToCloudFormation(properties.firewallDomainListId), Priority: cdk.numberToCloudFormation(properties.priority) }) : properties;
    }
    function CfnFirewallRuleGroupFirewallRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", cfn_parse.FromCloudFormation.getString(properties.Action)), ret.addPropertyResult("blockOverrideDnsType", "BlockOverrideDnsType", properties.BlockOverrideDnsType != null ? cfn_parse.FromCloudFormation.getString(properties.BlockOverrideDnsType) : void 0), ret.addPropertyResult("blockOverrideDomain", "BlockOverrideDomain", properties.BlockOverrideDomain != null ? cfn_parse.FromCloudFormation.getString(properties.BlockOverrideDomain) : void 0), ret.addPropertyResult("blockOverrideTtl", "BlockOverrideTtl", properties.BlockOverrideTtl != null ? cfn_parse.FromCloudFormation.getNumber(properties.BlockOverrideTtl) : void 0), ret.addPropertyResult("blockResponse", "BlockResponse", properties.BlockResponse != null ? cfn_parse.FromCloudFormation.getString(properties.BlockResponse) : void 0), ret.addPropertyResult("firewallDomainListId", "FirewallDomainListId", cfn_parse.FromCloudFormation.getString(properties.FirewallDomainListId)), ret.addPropertyResult("priority", "Priority", cfn_parse.FromCloudFormation.getNumber(properties.Priority)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFirewallRuleGroupAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("firewallRuleGroupId", cdk.requiredValidator)(properties.firewallRuleGroupId)), errors.collect(cdk.propertyValidator("firewallRuleGroupId", cdk.validateString)(properties.firewallRuleGroupId)), errors.collect(cdk.propertyValidator("mutationProtection", cdk.validateString)(properties.mutationProtection)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("priority", cdk.requiredValidator)(properties.priority)), errors.collect(cdk.propertyValidator("priority", cdk.validateNumber)(properties.priority)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpcId", cdk.requiredValidator)(properties.vpcId)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "CfnFirewallRuleGroupAssociationProps"');
    }
    function cfnFirewallRuleGroupAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFirewallRuleGroupAssociationPropsValidator(properties).assertSuccess(), { FirewallRuleGroupId: cdk.stringToCloudFormation(properties.firewallRuleGroupId), Priority: cdk.numberToCloudFormation(properties.priority), VpcId: cdk.stringToCloudFormation(properties.vpcId), MutationProtection: cdk.stringToCloudFormation(properties.mutationProtection), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnFirewallRuleGroupAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("firewallRuleGroupId", "FirewallRuleGroupId", cfn_parse.FromCloudFormation.getString(properties.FirewallRuleGroupId)), ret.addPropertyResult("priority", "Priority", cfn_parse.FromCloudFormation.getNumber(properties.Priority)), ret.addPropertyResult("vpcId", "VpcId", cfn_parse.FromCloudFormation.getString(properties.VpcId)), ret.addPropertyResult("mutationProtection", "MutationProtection", properties.MutationProtection != null ? cfn_parse.FromCloudFormation.getString(properties.MutationProtection) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFirewallRuleGroupAssociation = class _CfnFirewallRuleGroupAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFirewallRuleGroupAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnFirewallRuleGroupAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFirewallRuleGroupAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53resolver_CfnFirewallRuleGroupAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFirewallRuleGroupAssociation), error;
        }
        cdk.requireProperty(props, "firewallRuleGroupId", this), cdk.requireProperty(props, "priority", this), cdk.requireProperty(props, "vpcId", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrCreatorRequestId = cdk.Token.asString(this.getAtt("CreatorRequestId", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrManagedOwnerName = cdk.Token.asString(this.getAtt("ManagedOwnerName", cdk.ResolutionTypeHint.STRING)), this.attrModificationTime = cdk.Token.asString(this.getAtt("ModificationTime", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.attrStatusMessage = cdk.Token.asString(this.getAtt("StatusMessage", cdk.ResolutionTypeHint.STRING)), this.firewallRuleGroupId = props.firewallRuleGroupId, this.priority = props.priority, this.vpcId = props.vpcId, this.mutationProtection = props.mutationProtection, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Route53Resolver::FirewallRuleGroupAssociation", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFirewallRuleGroupAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { firewallRuleGroupId: this.firewallRuleGroupId, priority: this.priority, vpcId: this.vpcId, mutationProtection: this.mutationProtection, name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnFirewallRuleGroupAssociationPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnFirewallRuleGroupAssociation[_c] = { fqn: "aws-cdk-lib.aws_route53resolver.CfnFirewallRuleGroupAssociation", version: "2.80.0" }, CfnFirewallRuleGroupAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::Route53Resolver::FirewallRuleGroupAssociation", exports2.CfnFirewallRuleGroupAssociation = CfnFirewallRuleGroupAssociation;
    function CfnResolverConfigPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autodefinedReverseFlag", cdk.requiredValidator)(properties.autodefinedReverseFlag)), errors.collect(cdk.propertyValidator("autodefinedReverseFlag", cdk.validateString)(properties.autodefinedReverseFlag)), errors.collect(cdk.propertyValidator("resourceId", cdk.requiredValidator)(properties.resourceId)), errors.collect(cdk.propertyValidator("resourceId", cdk.validateString)(properties.resourceId)), errors.wrap('supplied properties not correct for "CfnResolverConfigProps"');
    }
    function cfnResolverConfigPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResolverConfigPropsValidator(properties).assertSuccess(), { AutodefinedReverseFlag: cdk.stringToCloudFormation(properties.autodefinedReverseFlag), ResourceId: cdk.stringToCloudFormation(properties.resourceId) }) : properties;
    }
    function CfnResolverConfigPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("autodefinedReverseFlag", "AutodefinedReverseFlag", cfn_parse.FromCloudFormation.getString(properties.AutodefinedReverseFlag)), ret.addPropertyResult("resourceId", "ResourceId", cfn_parse.FromCloudFormation.getString(properties.ResourceId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResolverConfig = class _CfnResolverConfig extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResolverConfigPropsFromCloudFormation(resourceProperties), ret = new _CfnResolverConfig(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnResolverConfig.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53resolver_CfnResolverConfigProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResolverConfig), error;
        }
        cdk.requireProperty(props, "autodefinedReverseFlag", this), cdk.requireProperty(props, "resourceId", this), this.attrAutodefinedReverse = cdk.Token.asString(this.getAtt("AutodefinedReverse", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrOwnerId = cdk.Token.asString(this.getAtt("OwnerId", cdk.ResolutionTypeHint.STRING)), this.autodefinedReverseFlag = props.autodefinedReverseFlag, this.resourceId = props.resourceId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResolverConfig.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { autodefinedReverseFlag: this.autodefinedReverseFlag, resourceId: this.resourceId };
      }
      renderProperties(props) {
        return cfnResolverConfigPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnResolverConfig[_d] = { fqn: "aws-cdk-lib.aws_route53resolver.CfnResolverConfig", version: "2.80.0" }, CfnResolverConfig.CFN_RESOURCE_TYPE_NAME = "AWS::Route53Resolver::ResolverConfig", exports2.CfnResolverConfig = CfnResolverConfig;
    function CfnResolverDNSSECConfigPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceId", cdk.validateString)(properties.resourceId)), errors.wrap('supplied properties not correct for "CfnResolverDNSSECConfigProps"');
    }
    function cfnResolverDNSSECConfigPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResolverDNSSECConfigPropsValidator(properties).assertSuccess(), { ResourceId: cdk.stringToCloudFormation(properties.resourceId) }) : properties;
    }
    function CfnResolverDNSSECConfigPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceId", "ResourceId", properties.ResourceId != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResolverDNSSECConfig = class _CfnResolverDNSSECConfig extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResolverDNSSECConfigPropsFromCloudFormation(resourceProperties), ret = new _CfnResolverDNSSECConfig(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnResolverDNSSECConfig.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53resolver_CfnResolverDNSSECConfigProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResolverDNSSECConfig), error;
        }
        this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrOwnerId = cdk.Token.asString(this.getAtt("OwnerId", cdk.ResolutionTypeHint.STRING)), this.attrValidationStatus = cdk.Token.asString(this.getAtt("ValidationStatus", cdk.ResolutionTypeHint.STRING)), this.resourceId = props.resourceId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResolverDNSSECConfig.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { resourceId: this.resourceId };
      }
      renderProperties(props) {
        return cfnResolverDNSSECConfigPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnResolverDNSSECConfig[_e] = { fqn: "aws-cdk-lib.aws_route53resolver.CfnResolverDNSSECConfig", version: "2.80.0" }, CfnResolverDNSSECConfig.CFN_RESOURCE_TYPE_NAME = "AWS::Route53Resolver::ResolverDNSSECConfig", exports2.CfnResolverDNSSECConfig = CfnResolverDNSSECConfig;
    function CfnResolverEndpointPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("direction", cdk.requiredValidator)(properties.direction)), errors.collect(cdk.propertyValidator("direction", cdk.validateString)(properties.direction)), errors.collect(cdk.propertyValidator("ipAddresses", cdk.requiredValidator)(properties.ipAddresses)), errors.collect(cdk.propertyValidator("ipAddresses", cdk.listValidator(CfnResolverEndpoint_IpAddressRequestPropertyValidator))(properties.ipAddresses)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("outpostArn", cdk.validateString)(properties.outpostArn)), errors.collect(cdk.propertyValidator("preferredInstanceType", cdk.validateString)(properties.preferredInstanceType)), errors.collect(cdk.propertyValidator("resolverEndpointType", cdk.validateString)(properties.resolverEndpointType)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.requiredValidator)(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnResolverEndpointProps"');
    }
    function cfnResolverEndpointPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResolverEndpointPropsValidator(properties).assertSuccess(), { Direction: cdk.stringToCloudFormation(properties.direction), IpAddresses: cdk.listMapper(cfnResolverEndpointIpAddressRequestPropertyToCloudFormation)(properties.ipAddresses), SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), Name: cdk.stringToCloudFormation(properties.name), OutpostArn: cdk.stringToCloudFormation(properties.outpostArn), PreferredInstanceType: cdk.stringToCloudFormation(properties.preferredInstanceType), ResolverEndpointType: cdk.stringToCloudFormation(properties.resolverEndpointType), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnResolverEndpointPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("direction", "Direction", cfn_parse.FromCloudFormation.getString(properties.Direction)), ret.addPropertyResult("ipAddresses", "IpAddresses", cfn_parse.FromCloudFormation.getArray(CfnResolverEndpointIpAddressRequestPropertyFromCloudFormation)(properties.IpAddresses)), ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("outpostArn", "OutpostArn", properties.OutpostArn != null ? cfn_parse.FromCloudFormation.getString(properties.OutpostArn) : void 0), ret.addPropertyResult("preferredInstanceType", "PreferredInstanceType", properties.PreferredInstanceType != null ? cfn_parse.FromCloudFormation.getString(properties.PreferredInstanceType) : void 0), ret.addPropertyResult("resolverEndpointType", "ResolverEndpointType", properties.ResolverEndpointType != null ? cfn_parse.FromCloudFormation.getString(properties.ResolverEndpointType) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResolverEndpoint = class _CfnResolverEndpoint extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResolverEndpointPropsFromCloudFormation(resourceProperties), ret = new _CfnResolverEndpoint(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnResolverEndpoint.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53resolver_CfnResolverEndpointProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResolverEndpoint), error;
        }
        cdk.requireProperty(props, "direction", this), cdk.requireProperty(props, "ipAddresses", this), cdk.requireProperty(props, "securityGroupIds", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrDirection = cdk.Token.asString(this.getAtt("Direction", cdk.ResolutionTypeHint.STRING)), this.attrHostVpcId = cdk.Token.asString(this.getAtt("HostVPCId", cdk.ResolutionTypeHint.STRING)), this.attrIpAddressCount = cdk.Token.asString(this.getAtt("IpAddressCount", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.attrOutpostArn = cdk.Token.asString(this.getAtt("OutpostArn", cdk.ResolutionTypeHint.STRING)), this.attrPreferredInstanceType = cdk.Token.asString(this.getAtt("PreferredInstanceType", cdk.ResolutionTypeHint.STRING)), this.attrResolverEndpointId = cdk.Token.asString(this.getAtt("ResolverEndpointId", cdk.ResolutionTypeHint.STRING)), this.attrResolverEndpointType = cdk.Token.asString(this.getAtt("ResolverEndpointType", cdk.ResolutionTypeHint.STRING)), this.direction = props.direction, this.ipAddresses = props.ipAddresses, this.securityGroupIds = props.securityGroupIds, this.name = props.name, this.outpostArn = props.outpostArn, this.preferredInstanceType = props.preferredInstanceType, this.resolverEndpointType = props.resolverEndpointType, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Route53Resolver::ResolverEndpoint", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResolverEndpoint.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { direction: this.direction, ipAddresses: this.ipAddresses, securityGroupIds: this.securityGroupIds, name: this.name, outpostArn: this.outpostArn, preferredInstanceType: this.preferredInstanceType, resolverEndpointType: this.resolverEndpointType, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnResolverEndpointPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnResolverEndpoint[_f] = { fqn: "aws-cdk-lib.aws_route53resolver.CfnResolverEndpoint", version: "2.80.0" }, CfnResolverEndpoint.CFN_RESOURCE_TYPE_NAME = "AWS::Route53Resolver::ResolverEndpoint", exports2.CfnResolverEndpoint = CfnResolverEndpoint;
    function CfnResolverEndpoint_IpAddressRequestPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ip", cdk.validateString)(properties.ip)), errors.collect(cdk.propertyValidator("ipv6", cdk.validateString)(properties.ipv6)), errors.collect(cdk.propertyValidator("subnetId", cdk.requiredValidator)(properties.subnetId)), errors.collect(cdk.propertyValidator("subnetId", cdk.validateString)(properties.subnetId)), errors.wrap('supplied properties not correct for "IpAddressRequestProperty"');
    }
    function cfnResolverEndpointIpAddressRequestPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResolverEndpoint_IpAddressRequestPropertyValidator(properties).assertSuccess(), { Ip: cdk.stringToCloudFormation(properties.ip), Ipv6: cdk.stringToCloudFormation(properties.ipv6), SubnetId: cdk.stringToCloudFormation(properties.subnetId) }) : properties;
    }
    function CfnResolverEndpointIpAddressRequestPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ip", "Ip", properties.Ip != null ? cfn_parse.FromCloudFormation.getString(properties.Ip) : void 0), ret.addPropertyResult("ipv6", "Ipv6", properties.Ipv6 != null ? cfn_parse.FromCloudFormation.getString(properties.Ipv6) : void 0), ret.addPropertyResult("subnetId", "SubnetId", cfn_parse.FromCloudFormation.getString(properties.SubnetId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResolverQueryLoggingConfigPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationArn", cdk.validateString)(properties.destinationArn)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "CfnResolverQueryLoggingConfigProps"');
    }
    function cfnResolverQueryLoggingConfigPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResolverQueryLoggingConfigPropsValidator(properties).assertSuccess(), { DestinationArn: cdk.stringToCloudFormation(properties.destinationArn), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnResolverQueryLoggingConfigPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationArn", "DestinationArn", properties.DestinationArn != null ? cfn_parse.FromCloudFormation.getString(properties.DestinationArn) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResolverQueryLoggingConfig = class _CfnResolverQueryLoggingConfig extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResolverQueryLoggingConfigPropsFromCloudFormation(resourceProperties), ret = new _CfnResolverQueryLoggingConfig(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnResolverQueryLoggingConfig.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53resolver_CfnResolverQueryLoggingConfigProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResolverQueryLoggingConfig), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrAssociationCount = cdk.Token.asNumber(this.getAtt("AssociationCount", cdk.ResolutionTypeHint.NUMBER)), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrCreatorRequestId = cdk.Token.asString(this.getAtt("CreatorRequestId", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrOwnerId = cdk.Token.asString(this.getAtt("OwnerId", cdk.ResolutionTypeHint.STRING)), this.attrShareStatus = cdk.Token.asString(this.getAtt("ShareStatus", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.destinationArn = props.destinationArn, this.name = props.name;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResolverQueryLoggingConfig.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { destinationArn: this.destinationArn, name: this.name };
      }
      renderProperties(props) {
        return cfnResolverQueryLoggingConfigPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnResolverQueryLoggingConfig[_g] = { fqn: "aws-cdk-lib.aws_route53resolver.CfnResolverQueryLoggingConfig", version: "2.80.0" }, CfnResolverQueryLoggingConfig.CFN_RESOURCE_TYPE_NAME = "AWS::Route53Resolver::ResolverQueryLoggingConfig", exports2.CfnResolverQueryLoggingConfig = CfnResolverQueryLoggingConfig;
    function CfnResolverQueryLoggingConfigAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resolverQueryLogConfigId", cdk.validateString)(properties.resolverQueryLogConfigId)), errors.collect(cdk.propertyValidator("resourceId", cdk.validateString)(properties.resourceId)), errors.wrap('supplied properties not correct for "CfnResolverQueryLoggingConfigAssociationProps"');
    }
    function cfnResolverQueryLoggingConfigAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResolverQueryLoggingConfigAssociationPropsValidator(properties).assertSuccess(), { ResolverQueryLogConfigId: cdk.stringToCloudFormation(properties.resolverQueryLogConfigId), ResourceId: cdk.stringToCloudFormation(properties.resourceId) }) : properties;
    }
    function CfnResolverQueryLoggingConfigAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resolverQueryLogConfigId", "ResolverQueryLogConfigId", properties.ResolverQueryLogConfigId != null ? cfn_parse.FromCloudFormation.getString(properties.ResolverQueryLogConfigId) : void 0), ret.addPropertyResult("resourceId", "ResourceId", properties.ResourceId != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResolverQueryLoggingConfigAssociation = class _CfnResolverQueryLoggingConfigAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResolverQueryLoggingConfigAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnResolverQueryLoggingConfigAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnResolverQueryLoggingConfigAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53resolver_CfnResolverQueryLoggingConfigAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResolverQueryLoggingConfigAssociation), error;
        }
        this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrError = cdk.Token.asString(this.getAtt("Error", cdk.ResolutionTypeHint.STRING)), this.attrErrorMessage = cdk.Token.asString(this.getAtt("ErrorMessage", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.resolverQueryLogConfigId = props.resolverQueryLogConfigId, this.resourceId = props.resourceId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResolverQueryLoggingConfigAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { resolverQueryLogConfigId: this.resolverQueryLogConfigId, resourceId: this.resourceId };
      }
      renderProperties(props) {
        return cfnResolverQueryLoggingConfigAssociationPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnResolverQueryLoggingConfigAssociation[_h] = { fqn: "aws-cdk-lib.aws_route53resolver.CfnResolverQueryLoggingConfigAssociation", version: "2.80.0" }, CfnResolverQueryLoggingConfigAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::Route53Resolver::ResolverQueryLoggingConfigAssociation", exports2.CfnResolverQueryLoggingConfigAssociation = CfnResolverQueryLoggingConfigAssociation;
    function CfnResolverRulePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("domainName", cdk.requiredValidator)(properties.domainName)), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("resolverEndpointId", cdk.validateString)(properties.resolverEndpointId)), errors.collect(cdk.propertyValidator("ruleType", cdk.requiredValidator)(properties.ruleType)), errors.collect(cdk.propertyValidator("ruleType", cdk.validateString)(properties.ruleType)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("targetIps", cdk.listValidator(CfnResolverRule_TargetAddressPropertyValidator))(properties.targetIps)), errors.wrap('supplied properties not correct for "CfnResolverRuleProps"');
    }
    function cfnResolverRulePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResolverRulePropsValidator(properties).assertSuccess(), { DomainName: cdk.stringToCloudFormation(properties.domainName), RuleType: cdk.stringToCloudFormation(properties.ruleType), Name: cdk.stringToCloudFormation(properties.name), ResolverEndpointId: cdk.stringToCloudFormation(properties.resolverEndpointId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TargetIps: cdk.listMapper(cfnResolverRuleTargetAddressPropertyToCloudFormation)(properties.targetIps) }) : properties;
    }
    function CfnResolverRulePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("domainName", "DomainName", cfn_parse.FromCloudFormation.getString(properties.DomainName)), ret.addPropertyResult("ruleType", "RuleType", cfn_parse.FromCloudFormation.getString(properties.RuleType)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("resolverEndpointId", "ResolverEndpointId", properties.ResolverEndpointId != null ? cfn_parse.FromCloudFormation.getString(properties.ResolverEndpointId) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("targetIps", "TargetIps", properties.TargetIps != null ? cfn_parse.FromCloudFormation.getArray(CfnResolverRuleTargetAddressPropertyFromCloudFormation)(properties.TargetIps) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResolverRule = class _CfnResolverRule extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResolverRulePropsFromCloudFormation(resourceProperties), ret = new _CfnResolverRule(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnResolverRule.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53resolver_CfnResolverRuleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResolverRule), error;
        }
        cdk.requireProperty(props, "domainName", this), cdk.requireProperty(props, "ruleType", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrDomainName = cdk.Token.asString(this.getAtt("DomainName", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.attrResolverEndpointId = cdk.Token.asString(this.getAtt("ResolverEndpointId", cdk.ResolutionTypeHint.STRING)), this.attrResolverRuleId = cdk.Token.asString(this.getAtt("ResolverRuleId", cdk.ResolutionTypeHint.STRING)), this.attrTargetIps = this.getAtt("TargetIps", cdk.ResolutionTypeHint.STRING), this.domainName = props.domainName, this.ruleType = props.ruleType, this.name = props.name, this.resolverEndpointId = props.resolverEndpointId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Route53Resolver::ResolverRule", props.tags, { tagPropertyName: "tags" }), this.targetIps = props.targetIps;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResolverRule.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { domainName: this.domainName, ruleType: this.ruleType, name: this.name, resolverEndpointId: this.resolverEndpointId, tags: this.tags.renderTags(), targetIps: this.targetIps };
      }
      renderProperties(props) {
        return cfnResolverRulePropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnResolverRule[_j] = { fqn: "aws-cdk-lib.aws_route53resolver.CfnResolverRule", version: "2.80.0" }, CfnResolverRule.CFN_RESOURCE_TYPE_NAME = "AWS::Route53Resolver::ResolverRule", exports2.CfnResolverRule = CfnResolverRule;
    function CfnResolverRule_TargetAddressPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ip", cdk.validateString)(properties.ip)), errors.collect(cdk.propertyValidator("ipv6", cdk.validateString)(properties.ipv6)), errors.collect(cdk.propertyValidator("port", cdk.validateString)(properties.port)), errors.wrap('supplied properties not correct for "TargetAddressProperty"');
    }
    function cfnResolverRuleTargetAddressPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResolverRule_TargetAddressPropertyValidator(properties).assertSuccess(), { Ip: cdk.stringToCloudFormation(properties.ip), Ipv6: cdk.stringToCloudFormation(properties.ipv6), Port: cdk.stringToCloudFormation(properties.port) }) : properties;
    }
    function CfnResolverRuleTargetAddressPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ip", "Ip", properties.Ip != null ? cfn_parse.FromCloudFormation.getString(properties.Ip) : void 0), ret.addPropertyResult("ipv6", "Ipv6", properties.Ipv6 != null ? cfn_parse.FromCloudFormation.getString(properties.Ipv6) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getString(properties.Port) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResolverRuleAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("resolverRuleId", cdk.requiredValidator)(properties.resolverRuleId)), errors.collect(cdk.propertyValidator("resolverRuleId", cdk.validateString)(properties.resolverRuleId)), errors.collect(cdk.propertyValidator("vpcId", cdk.requiredValidator)(properties.vpcId)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "CfnResolverRuleAssociationProps"');
    }
    function cfnResolverRuleAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResolverRuleAssociationPropsValidator(properties).assertSuccess(), { ResolverRuleId: cdk.stringToCloudFormation(properties.resolverRuleId), VPCId: cdk.stringToCloudFormation(properties.vpcId), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnResolverRuleAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resolverRuleId", "ResolverRuleId", cfn_parse.FromCloudFormation.getString(properties.ResolverRuleId)), ret.addPropertyResult("vpcId", "VPCId", cfn_parse.FromCloudFormation.getString(properties.VPCId)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResolverRuleAssociation = class _CfnResolverRuleAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResolverRuleAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnResolverRuleAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnResolverRuleAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53resolver_CfnResolverRuleAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResolverRuleAssociation), error;
        }
        cdk.requireProperty(props, "resolverRuleId", this), cdk.requireProperty(props, "vpcId", this), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.attrResolverRuleAssociationId = cdk.Token.asString(this.getAtt("ResolverRuleAssociationId", cdk.ResolutionTypeHint.STRING)), this.attrResolverRuleId = cdk.Token.asString(this.getAtt("ResolverRuleId", cdk.ResolutionTypeHint.STRING)), this.attrVpcId = cdk.Token.asString(this.getAtt("VPCId", cdk.ResolutionTypeHint.STRING)), this.resolverRuleId = props.resolverRuleId, this.vpcId = props.vpcId, this.name = props.name;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResolverRuleAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { resolverRuleId: this.resolverRuleId, vpcId: this.vpcId, name: this.name };
      }
      renderProperties(props) {
        return cfnResolverRuleAssociationPropsToCloudFormation(props);
      }
    };
    _k = JSII_RTTI_SYMBOL_1, CfnResolverRuleAssociation[_k] = { fqn: "aws-cdk-lib.aws_route53resolver.CfnResolverRuleAssociation", version: "2.80.0" }, CfnResolverRuleAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::Route53Resolver::ResolverRuleAssociation", exports2.CfnResolverRuleAssociation = CfnResolverRuleAssociation;
  }
});

// node_modules/aws-cdk-lib/aws-route53resolver/lib/index.js
var require_lib228 = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53resolver/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_route53resolver_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-route53resolver/index.js
var require_aws_route53resolver = __commonJS({
  "node_modules/aws-cdk-lib/aws-route53resolver/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib228(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-rum/lib/rum.generated.js
var require_rum_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-rum/lib/rum.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnAppMonitor = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAppMonitorPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("appMonitorConfiguration", CfnAppMonitor_AppMonitorConfigurationPropertyValidator)(properties.appMonitorConfiguration)), errors.collect(cdk.propertyValidator("customEvents", CfnAppMonitor_CustomEventsPropertyValidator)(properties.customEvents)), errors.collect(cdk.propertyValidator("cwLogEnabled", cdk.validateBoolean)(properties.cwLogEnabled)), errors.collect(cdk.propertyValidator("domain", cdk.requiredValidator)(properties.domain)), errors.collect(cdk.propertyValidator("domain", cdk.validateString)(properties.domain)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnAppMonitorProps"');
    }
    function cfnAppMonitorPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAppMonitorPropsValidator(properties).assertSuccess(), { Domain: cdk.stringToCloudFormation(properties.domain), Name: cdk.stringToCloudFormation(properties.name), AppMonitorConfiguration: cfnAppMonitorAppMonitorConfigurationPropertyToCloudFormation(properties.appMonitorConfiguration), CustomEvents: cfnAppMonitorCustomEventsPropertyToCloudFormation(properties.customEvents), CwLogEnabled: cdk.booleanToCloudFormation(properties.cwLogEnabled), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnAppMonitorPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("domain", "Domain", cfn_parse.FromCloudFormation.getString(properties.Domain)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("appMonitorConfiguration", "AppMonitorConfiguration", properties.AppMonitorConfiguration != null ? CfnAppMonitorAppMonitorConfigurationPropertyFromCloudFormation(properties.AppMonitorConfiguration) : void 0), ret.addPropertyResult("customEvents", "CustomEvents", properties.CustomEvents != null ? CfnAppMonitorCustomEventsPropertyFromCloudFormation(properties.CustomEvents) : void 0), ret.addPropertyResult("cwLogEnabled", "CwLogEnabled", properties.CwLogEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CwLogEnabled) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAppMonitor = class _CfnAppMonitor extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAppMonitorPropsFromCloudFormation(resourceProperties), ret = new _CfnAppMonitor(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAppMonitor.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_rum_CfnAppMonitorProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAppMonitor), error;
        }
        cdk.requireProperty(props, "domain", this), cdk.requireProperty(props, "name", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.domain = props.domain, this.name = props.name, this.appMonitorConfiguration = props.appMonitorConfiguration, this.customEvents = props.customEvents, this.cwLogEnabled = props.cwLogEnabled, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::RUM::AppMonitor", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAppMonitor.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { domain: this.domain, name: this.name, appMonitorConfiguration: this.appMonitorConfiguration, customEvents: this.customEvents, cwLogEnabled: this.cwLogEnabled, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnAppMonitorPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAppMonitor[_a] = { fqn: "aws-cdk-lib.aws_rum.CfnAppMonitor", version: "2.80.0" }, CfnAppMonitor.CFN_RESOURCE_TYPE_NAME = "AWS::RUM::AppMonitor", exports2.CfnAppMonitor = CfnAppMonitor;
    function CfnAppMonitor_AppMonitorConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowCookies", cdk.validateBoolean)(properties.allowCookies)), errors.collect(cdk.propertyValidator("enableXRay", cdk.validateBoolean)(properties.enableXRay)), errors.collect(cdk.propertyValidator("excludedPages", cdk.listValidator(cdk.validateString))(properties.excludedPages)), errors.collect(cdk.propertyValidator("favoritePages", cdk.listValidator(cdk.validateString))(properties.favoritePages)), errors.collect(cdk.propertyValidator("guestRoleArn", cdk.validateString)(properties.guestRoleArn)), errors.collect(cdk.propertyValidator("identityPoolId", cdk.validateString)(properties.identityPoolId)), errors.collect(cdk.propertyValidator("includedPages", cdk.listValidator(cdk.validateString))(properties.includedPages)), errors.collect(cdk.propertyValidator("metricDestinations", cdk.listValidator(CfnAppMonitor_MetricDestinationPropertyValidator))(properties.metricDestinations)), errors.collect(cdk.propertyValidator("sessionSampleRate", cdk.validateNumber)(properties.sessionSampleRate)), errors.collect(cdk.propertyValidator("telemetries", cdk.listValidator(cdk.validateString))(properties.telemetries)), errors.wrap('supplied properties not correct for "AppMonitorConfigurationProperty"');
    }
    function cfnAppMonitorAppMonitorConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAppMonitor_AppMonitorConfigurationPropertyValidator(properties).assertSuccess(), { AllowCookies: cdk.booleanToCloudFormation(properties.allowCookies), EnableXRay: cdk.booleanToCloudFormation(properties.enableXRay), ExcludedPages: cdk.listMapper(cdk.stringToCloudFormation)(properties.excludedPages), FavoritePages: cdk.listMapper(cdk.stringToCloudFormation)(properties.favoritePages), GuestRoleArn: cdk.stringToCloudFormation(properties.guestRoleArn), IdentityPoolId: cdk.stringToCloudFormation(properties.identityPoolId), IncludedPages: cdk.listMapper(cdk.stringToCloudFormation)(properties.includedPages), MetricDestinations: cdk.listMapper(cfnAppMonitorMetricDestinationPropertyToCloudFormation)(properties.metricDestinations), SessionSampleRate: cdk.numberToCloudFormation(properties.sessionSampleRate), Telemetries: cdk.listMapper(cdk.stringToCloudFormation)(properties.telemetries) }) : properties;
    }
    function CfnAppMonitorAppMonitorConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowCookies", "AllowCookies", properties.AllowCookies != null ? cfn_parse.FromCloudFormation.getBoolean(properties.AllowCookies) : void 0), ret.addPropertyResult("enableXRay", "EnableXRay", properties.EnableXRay != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableXRay) : void 0), ret.addPropertyResult("excludedPages", "ExcludedPages", properties.ExcludedPages != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExcludedPages) : void 0), ret.addPropertyResult("favoritePages", "FavoritePages", properties.FavoritePages != null ? cfn_parse.FromCloudFormation.getStringArray(properties.FavoritePages) : void 0), ret.addPropertyResult("guestRoleArn", "GuestRoleArn", properties.GuestRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.GuestRoleArn) : void 0), ret.addPropertyResult("identityPoolId", "IdentityPoolId", properties.IdentityPoolId != null ? cfn_parse.FromCloudFormation.getString(properties.IdentityPoolId) : void 0), ret.addPropertyResult("includedPages", "IncludedPages", properties.IncludedPages != null ? cfn_parse.FromCloudFormation.getStringArray(properties.IncludedPages) : void 0), ret.addPropertyResult("metricDestinations", "MetricDestinations", properties.MetricDestinations != null ? cfn_parse.FromCloudFormation.getArray(CfnAppMonitorMetricDestinationPropertyFromCloudFormation)(properties.MetricDestinations) : void 0), ret.addPropertyResult("sessionSampleRate", "SessionSampleRate", properties.SessionSampleRate != null ? cfn_parse.FromCloudFormation.getNumber(properties.SessionSampleRate) : void 0), ret.addPropertyResult("telemetries", "Telemetries", properties.Telemetries != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Telemetries) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAppMonitor_CustomEventsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "CustomEventsProperty"');
    }
    function cfnAppMonitorCustomEventsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAppMonitor_CustomEventsPropertyValidator(properties).assertSuccess(), { Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnAppMonitorCustomEventsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAppMonitor_MetricDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dimensionKeys", cdk.hashValidator(cdk.validateString))(properties.dimensionKeys)), errors.collect(cdk.propertyValidator("eventPattern", cdk.validateString)(properties.eventPattern)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("namespace", cdk.validateString)(properties.namespace)), errors.collect(cdk.propertyValidator("unitLabel", cdk.validateString)(properties.unitLabel)), errors.collect(cdk.propertyValidator("valueKey", cdk.validateString)(properties.valueKey)), errors.wrap('supplied properties not correct for "MetricDefinitionProperty"');
    }
    function cfnAppMonitorMetricDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAppMonitor_MetricDefinitionPropertyValidator(properties).assertSuccess(), { DimensionKeys: cdk.hashMapper(cdk.stringToCloudFormation)(properties.dimensionKeys), EventPattern: cdk.stringToCloudFormation(properties.eventPattern), Name: cdk.stringToCloudFormation(properties.name), Namespace: cdk.stringToCloudFormation(properties.namespace), UnitLabel: cdk.stringToCloudFormation(properties.unitLabel), ValueKey: cdk.stringToCloudFormation(properties.valueKey) }) : properties;
    }
    function CfnAppMonitorMetricDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dimensionKeys", "DimensionKeys", properties.DimensionKeys != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.DimensionKeys) : void 0), ret.addPropertyResult("eventPattern", "EventPattern", properties.EventPattern != null ? cfn_parse.FromCloudFormation.getString(properties.EventPattern) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("namespace", "Namespace", properties.Namespace != null ? cfn_parse.FromCloudFormation.getString(properties.Namespace) : void 0), ret.addPropertyResult("unitLabel", "UnitLabel", properties.UnitLabel != null ? cfn_parse.FromCloudFormation.getString(properties.UnitLabel) : void 0), ret.addPropertyResult("valueKey", "ValueKey", properties.ValueKey != null ? cfn_parse.FromCloudFormation.getString(properties.ValueKey) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAppMonitor_MetricDestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destination", cdk.requiredValidator)(properties.destination)), errors.collect(cdk.propertyValidator("destination", cdk.validateString)(properties.destination)), errors.collect(cdk.propertyValidator("destinationArn", cdk.validateString)(properties.destinationArn)), errors.collect(cdk.propertyValidator("iamRoleArn", cdk.validateString)(properties.iamRoleArn)), errors.collect(cdk.propertyValidator("metricDefinitions", cdk.listValidator(CfnAppMonitor_MetricDefinitionPropertyValidator))(properties.metricDefinitions)), errors.wrap('supplied properties not correct for "MetricDestinationProperty"');
    }
    function cfnAppMonitorMetricDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAppMonitor_MetricDestinationPropertyValidator(properties).assertSuccess(), { Destination: cdk.stringToCloudFormation(properties.destination), DestinationArn: cdk.stringToCloudFormation(properties.destinationArn), IamRoleArn: cdk.stringToCloudFormation(properties.iamRoleArn), MetricDefinitions: cdk.listMapper(cfnAppMonitorMetricDefinitionPropertyToCloudFormation)(properties.metricDefinitions) }) : properties;
    }
    function CfnAppMonitorMetricDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destination", "Destination", cfn_parse.FromCloudFormation.getString(properties.Destination)), ret.addPropertyResult("destinationArn", "DestinationArn", properties.DestinationArn != null ? cfn_parse.FromCloudFormation.getString(properties.DestinationArn) : void 0), ret.addPropertyResult("iamRoleArn", "IamRoleArn", properties.IamRoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.IamRoleArn) : void 0), ret.addPropertyResult("metricDefinitions", "MetricDefinitions", properties.MetricDefinitions != null ? cfn_parse.FromCloudFormation.getArray(CfnAppMonitorMetricDefinitionPropertyFromCloudFormation)(properties.MetricDefinitions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-rum/lib/index.js
var require_lib229 = __commonJS({
  "node_modules/aws-cdk-lib/aws-rum/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_rum_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-rum/index.js
var require_aws_rum = __commonJS({
  "node_modules/aws-cdk-lib/aws-rum/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib229(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-s3-deployment/lib/bucket-deployment.js
var require_bucket_deployment = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3-deployment/lib/bucket-deployment.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Expires = exports2.StorageClass = exports2.ServerSideEncryption = exports2.CacheControl = exports2.BucketDeployment = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var path = require("path");
    var case_1 = require_Case();
    var constructs_1 = require_lib2();
    var efs = require_aws_efs();
    var iam = require_aws_iam();
    var lambda2 = require_aws_lambda();
    var s3 = require_aws_s3();
    var cdk = require_core2();
    var lambda_layer_awscli_1 = require_lambda_layer_awscli();
    var CUSTOM_RESOURCE_OWNER_TAG = "aws-cdk:cr-owned";
    var BucketDeployment = class _BucketDeployment extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id), this.requestDestinationArn = false;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_deployment_BucketDeploymentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _BucketDeployment), error;
        }
        if (props.distributionPaths) {
          if (!props.distribution)
            throw new Error("Distribution must be specified if distribution paths are specified");
          if (!cdk.Token.isUnresolved(props.distributionPaths) && !props.distributionPaths.every((distributionPath) => cdk.Token.isUnresolved(distributionPath) || distributionPath.startsWith("/")))
            throw new Error('Distribution paths must start with "/"');
        }
        if (props.useEfs && !props.vpc)
          throw new Error("Vpc must be specified if useEfs is set");
        this.destinationBucket = props.destinationBucket;
        const accessPointPath = "/lambda";
        let accessPoint;
        if (props.useEfs && props.vpc) {
          const accessMode = "0777", fileSystem = this.getOrCreateEfsFileSystem(scope, { vpc: props.vpc, removalPolicy: cdk.RemovalPolicy.DESTROY });
          accessPoint = fileSystem.addAccessPoint("AccessPoint", { path: accessPointPath, createAcl: { ownerUid: "1001", ownerGid: "1001", permissions: accessMode }, posixUser: { uid: "1001", gid: "1001" } }), accessPoint.node.addDependency(fileSystem.mountTargetsAvailable);
        }
        props.vpc && this.node.addDependency(props.vpc);
        const mountPath = `/mnt${accessPointPath}`, handler2 = new lambda2.SingletonFunction(this, "CustomResourceHandler", { uuid: this.renderSingletonUuid(props.memoryLimit, props.ephemeralStorageSize, props.vpc), code: lambda2.Code.fromAsset(path.join(__dirname, "lambda")), layers: [new lambda_layer_awscli_1.AwsCliLayer(this, "AwsCliLayer")], runtime: lambda2.Runtime.PYTHON_3_9, environment: { ...props.useEfs ? { MOUNT_PATH: mountPath } : void 0, AWS_CA_BUNDLE: "/etc/pki/ca-trust/extracted/pem/tls-ca-bundle.pem" }, handler: "index.handler", lambdaPurpose: "Custom::CDKBucketDeployment", timeout: cdk.Duration.minutes(15), role: props.role, memorySize: props.memoryLimit, ephemeralStorageSize: props.ephemeralStorageSize, vpc: props.vpc, vpcSubnets: props.vpcSubnets, filesystem: accessPoint ? lambda2.FileSystem.fromEfsAccessPoint(accessPoint, mountPath) : void 0, logRetention: props.logRetention }), handlerRole = handler2.role;
        if (!handlerRole)
          throw new Error("lambda.SingletonFunction should have created a Role");
        this.handlerRole = handlerRole, this.sources = props.sources.map((source) => source.bind(this, { handlerRole: this.handlerRole })), this.destinationBucket.grantReadWrite(handler2), props.accessControl && this.destinationBucket.grantPutAcl(handler2), props.distribution && handler2.addToRolePolicy(new iam.PolicyStatement({ effect: iam.Effect.ALLOW, actions: ["cloudfront:GetInvalidation", "cloudfront:CreateInvalidation"], resources: ["*"] }));
        const _this = this;
        this.node.addValidation({ validate() {
          return _this.sources.some((source) => source.markers) && props.extract == false ? ["Some sources are incompatible with extract=false; sources with deploy-time values (such as 'snsTopic.topicArn') must be extracted."] : [];
        } });
        const crUniqueId = `CustomResource${this.renderUniqueId(props.memoryLimit, props.ephemeralStorageSize, props.vpc)}`;
        this.cr = new cdk.CustomResource(this, crUniqueId, { serviceToken: handler2.functionArn, resourceType: "Custom::CDKBucketDeployment", properties: { SourceBucketNames: cdk.Lazy.list({ produce: () => this.sources.map((source) => source.bucket.bucketName) }), SourceObjectKeys: cdk.Lazy.list({ produce: () => this.sources.map((source) => source.zipObjectKey) }), SourceMarkers: cdk.Lazy.any({ produce: () => this.sources.reduce((acc, source) => (source.markers ? acc.push(source.markers) : this.sources.length > 1 && acc.push({}), acc), []) }, { omitEmptyArray: true }), DestinationBucketName: this.destinationBucket.bucketName, DestinationBucketKeyPrefix: props.destinationKeyPrefix, RetainOnDelete: props.retainOnDelete, Extract: props.extract, Prune: props.prune ?? true, Exclude: props.exclude, Include: props.include, UserMetadata: props.metadata ? mapUserMetadata(props.metadata) : void 0, SystemMetadata: mapSystemMetadata(props), DistributionId: props.distribution?.distributionId, DistributionPaths: props.distributionPaths, SignContent: props.signContent, DestinationBucketArn: cdk.Lazy.string({ produce: () => this.requestDestinationArn ? this.destinationBucket.bucketArn : void 0 }) } });
        let prefix = props.destinationKeyPrefix ? `:${props.destinationKeyPrefix}` : "";
        prefix += `:${this.cr.node.addr.slice(-8)}`;
        const tagKey = CUSTOM_RESOURCE_OWNER_TAG + prefix;
        if (!cdk.Token.isUnresolved(tagKey) && tagKey.length > 128)
          throw new Error('The BucketDeployment construct requires that the "destinationKeyPrefix" be <=104 characters.');
        cdk.Tags.of(this.destinationBucket).add(tagKey, "true");
      }
      get deployedBucket() {
        return this.requestDestinationArn = true, this._deployedBucket = this._deployedBucket ?? s3.Bucket.fromBucketAttributes(this, "DestinationBucket", { bucketArn: cdk.Token.asString(this.cr.getAtt("DestinationBucketArn")), region: this.destinationBucket.env.region, account: this.destinationBucket.env.account, isWebsite: this.destinationBucket.isWebsite }), this._deployedBucket;
      }
      get objectKeys() {
        return cdk.Token.asList(this.cr.getAtt("SourceObjectKeys"));
      }
      addSource(source) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_deployment_ISource(source);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addSource), error;
        }
        this.sources.push(source.bind(this, { handlerRole: this.handlerRole }));
      }
      renderUniqueId(memoryLimit, ephemeralStorageSize, vpc) {
        let uuid = "";
        if (memoryLimit) {
          if (cdk.Token.isUnresolved(memoryLimit))
            throw new Error("Can't use tokens when specifying 'memoryLimit' since we use it to identify the singleton custom resource handler.");
          uuid += `-${memoryLimit.toString()}MiB`;
        }
        if (ephemeralStorageSize) {
          if (ephemeralStorageSize.isUnresolved())
            throw new Error("Can't use tokens when specifying 'ephemeralStorageSize' since we use it to identify the singleton custom resource handler.");
          uuid += `-${ephemeralStorageSize.toMebibytes().toString()}MiB`;
        }
        return vpc && (uuid += `-${vpc.node.addr}`), uuid;
      }
      renderSingletonUuid(memoryLimit, ephemeralStorageSize, vpc) {
        let uuid = "8693BB64-9689-44B6-9AAF-B0CC9EB8756C";
        return uuid += this.renderUniqueId(memoryLimit, ephemeralStorageSize, vpc), uuid;
      }
      getOrCreateEfsFileSystem(scope, fileSystemProps) {
        const stack = cdk.Stack.of(scope), uuid = `BucketDeploymentEFS-VPC-${fileSystemProps.vpc.node.addr}`;
        return stack.node.tryFindChild(uuid) ?? new efs.FileSystem(scope, uuid, fileSystemProps);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, BucketDeployment[_a] = { fqn: "aws-cdk-lib.aws_s3_deployment.BucketDeployment", version: "2.80.0" }, exports2.BucketDeployment = BucketDeployment;
    function mapUserMetadata(metadata) {
      const mapKey = (key) => key.toLowerCase();
      return Object.keys(metadata).reduce((o, key) => ({ ...o, [mapKey(key)]: metadata[key] }), {});
    }
    function mapSystemMetadata(metadata) {
      const res = {};
      return metadata.cacheControl && (res["cache-control"] = metadata.cacheControl.map((c) => c.value).join(", ")), metadata.expires && (res.expires = metadata.expires.date.toUTCString()), metadata.contentDisposition && (res["content-disposition"] = metadata.contentDisposition), metadata.contentEncoding && (res["content-encoding"] = metadata.contentEncoding), metadata.contentLanguage && (res["content-language"] = metadata.contentLanguage), metadata.contentType && (res["content-type"] = metadata.contentType), metadata.serverSideEncryption && (res.sse = metadata.serverSideEncryption), metadata.storageClass && (res["storage-class"] = metadata.storageClass), metadata.websiteRedirectLocation && (res["website-redirect"] = metadata.websiteRedirectLocation), metadata.serverSideEncryptionAwsKmsKeyId && (res["sse-kms-key-id"] = metadata.serverSideEncryptionAwsKmsKeyId), metadata.serverSideEncryptionCustomerAlgorithm && (res["sse-c-copy-source"] = metadata.serverSideEncryptionCustomerAlgorithm), metadata.accessControl && (res.acl = (0, case_1.kebab)(metadata.accessControl.toString())), Object.keys(res).length === 0 ? void 0 : res;
    }
    var CacheControl = class _CacheControl {
      static mustRevalidate() {
        return new _CacheControl("must-revalidate");
      }
      static noCache() {
        return new _CacheControl("no-cache");
      }
      static noTransform() {
        return new _CacheControl("no-transform");
      }
      static setPublic() {
        return new _CacheControl("public");
      }
      static setPrivate() {
        return new _CacheControl("private");
      }
      static proxyRevalidate() {
        return new _CacheControl("proxy-revalidate");
      }
      static maxAge(t) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Duration(t);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.maxAge), error;
        }
        return new _CacheControl(`max-age=${t.toSeconds()}`);
      }
      static sMaxAge(t) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Duration(t);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.sMaxAge), error;
        }
        return new _CacheControl(`s-maxage=${t.toSeconds()}`);
      }
      static fromString(s) {
        return new _CacheControl(s);
      }
      constructor(value) {
        this.value = value;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CacheControl[_b] = { fqn: "aws-cdk-lib.aws_s3_deployment.CacheControl", version: "2.80.0" }, exports2.CacheControl = CacheControl;
    var ServerSideEncryption;
    (function(ServerSideEncryption2) {
      ServerSideEncryption2.AES_256 = "AES256", ServerSideEncryption2.AWS_KMS = "aws:kms";
    })(ServerSideEncryption = exports2.ServerSideEncryption || (exports2.ServerSideEncryption = {}));
    var StorageClass;
    (function(StorageClass2) {
      StorageClass2.STANDARD = "STANDARD", StorageClass2.REDUCED_REDUNDANCY = "REDUCED_REDUNDANCY", StorageClass2.STANDARD_IA = "STANDARD_IA", StorageClass2.ONEZONE_IA = "ONEZONE_IA", StorageClass2.INTELLIGENT_TIERING = "INTELLIGENT_TIERING", StorageClass2.GLACIER = "GLACIER", StorageClass2.DEEP_ARCHIVE = "DEEP_ARCHIVE";
    })(StorageClass = exports2.StorageClass || (exports2.StorageClass = {}));
    var Expires = class _Expires {
      static atDate(d) {
        return new _Expires(d.toUTCString());
      }
      static atTimestamp(t) {
        return _Expires.atDate(new Date(t));
      }
      static after(t) {
        return _Expires.atDate(new Date(Date.now() + t.toMilliseconds()));
      }
      static fromString(s) {
        return new _Expires(s);
      }
      constructor(value) {
        this.value = value;
      }
    };
    _c = JSII_RTTI_SYMBOL_1, Expires[_c] = { fqn: "aws-cdk-lib.aws_s3_deployment.Expires", version: "2.80.0" }, exports2.Expires = Expires;
  }
});

// node_modules/aws-cdk-lib/aws-s3-deployment/lib/render-data.js
var require_render_data = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3-deployment/lib/render-data.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.renderData = void 0;
    var core_1 = require_core2();
    function renderData(scope, data) {
      const obj = core_1.Stack.of(scope).resolve(data);
      if (typeof obj == "string")
        return { text: obj, markers: {} };
      if (typeof obj != "object")
        throw new Error(`Unexpected: after resolve() data must either be a string or a CloudFormation intrinsic. Got: ${JSON.stringify(obj)}`);
      let markerIndex = 0;
      const markers = {}, result = new Array(), fnJoin = obj["Fn::Join"];
      if (fnJoin) {
        const sep = fnJoin[0], parts = fnJoin[1];
        if (sep !== "")
          throw new Error(`Unexpected "Fn::Join", expecting separator to be an empty string but got "${sep}"`);
        for (const part of parts) {
          if (typeof part == "string") {
            result.push(part);
            continue;
          }
          if (typeof part == "object") {
            addMarker(part);
            continue;
          }
          throw new Error(`Unexpected "Fn::Join" part, expecting string or object but got ${typeof part}`);
        }
      } else if (obj.Ref || obj["Fn::GetAtt"])
        addMarker(obj);
      else
        throw new Error('Unexpected: Expecting `resolve()` to return "Fn::Join", "Ref" or "Fn::GetAtt"');
      function addMarker(part) {
        const keys = Object.keys(part);
        if (keys.length !== 1 || keys[0] != "Ref" && keys[0] != "Fn::GetAtt")
          throw new Error(`Invalid CloudFormation reference. "Ref" or "Fn::GetAtt". Got ${JSON.stringify(part)}`);
        const marker = `<<marker:0xbaba:${markerIndex++}>>`;
        result.push(marker), markers[marker] = part;
      }
      return { text: result.join(""), markers };
    }
    exports2.renderData = renderData;
  }
});

// node_modules/aws-cdk-lib/aws-s3-deployment/lib/source.js
var require_source2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3-deployment/lib/source.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Source = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var fs = require("fs");
    var path_1 = require("path");
    var render_data_1 = require_render_data();
    var s3_assets = require_aws_s3_assets();
    var core_1 = require_core2();
    var Source = class _Source {
      static bucket(bucket, zipObjectKey) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_IBucket(bucket);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bucket), error;
        }
        return { bind: (_, context) => {
          if (!context)
            throw new Error("To use a Source.bucket(), context must be provided");
          return bucket.grantRead(context.handlerRole), { bucket, zipObjectKey };
        } };
      }
      static asset(path, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_assets_AssetOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.asset), error;
        }
        return { bind(scope, context) {
          if (!context)
            throw new Error("To use a Source.asset(), context must be provided");
          let id = 1;
          for (; scope.node.tryFindChild(`Asset${id}`); )
            id++;
          const asset = new s3_assets.Asset(scope, `Asset${id}`, { path, ...options });
          if (!asset.isZipArchive)
            throw new Error("Asset path must be either a .zip file or a directory");
          return asset.grantRead(context.handlerRole), { bucket: asset.bucket, zipObjectKey: asset.s3ObjectKey };
        } };
      }
      static data(objectKey, data) {
        return { bind: (scope, context) => {
          const workdir = core_1.FileSystem.mkdtemp("s3-deployment"), outputPath = (0, path_1.join)(workdir, objectKey), rendered = (0, render_data_1.renderData)(scope, data);
          fs.mkdirSync((0, path_1.dirname)(outputPath), { recursive: true }), fs.writeFileSync(outputPath, rendered.text);
          const asset = this.asset(workdir).bind(scope, context);
          return { bucket: asset.bucket, zipObjectKey: asset.zipObjectKey, markers: rendered.markers };
        } };
      }
      static jsonData(objectKey, obj) {
        return { bind: (scope, context) => _Source.data(objectKey, core_1.Stack.of(scope).toJsonString(obj)).bind(scope, context) };
      }
      static yamlData(objectKey, obj) {
        return { bind: (scope, context) => _Source.data(objectKey, core_1.Stack.of(scope).toYamlString(obj)).bind(scope, context) };
      }
      constructor() {
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Source[_a] = { fqn: "aws-cdk-lib.aws_s3_deployment.Source", version: "2.80.0" }, exports2.Source = Source;
  }
});

// node_modules/aws-cdk-lib/aws-s3-deployment/lib/index.js
var require_lib230 = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3-deployment/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_bucket_deployment(), exports2), __exportStar(require_source2(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-s3-deployment/index.js
var require_aws_s3_deployment = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3-deployment/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib230(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-s3objectlambda/lib/s3objectlambda.generated.js
var require_s3objectlambda_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3objectlambda/lib/s3objectlambda.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnAccessPointPolicy = exports2.CfnAccessPoint = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAccessPointPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("objectLambdaConfiguration", cdk.requiredValidator)(properties.objectLambdaConfiguration)), errors.collect(cdk.propertyValidator("objectLambdaConfiguration", CfnAccessPoint_ObjectLambdaConfigurationPropertyValidator)(properties.objectLambdaConfiguration)), errors.wrap('supplied properties not correct for "CfnAccessPointProps"');
    }
    function cfnAccessPointPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccessPointPropsValidator(properties).assertSuccess(), { ObjectLambdaConfiguration: cfnAccessPointObjectLambdaConfigurationPropertyToCloudFormation(properties.objectLambdaConfiguration), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnAccessPointPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("objectLambdaConfiguration", "ObjectLambdaConfiguration", CfnAccessPointObjectLambdaConfigurationPropertyFromCloudFormation(properties.ObjectLambdaConfiguration)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAccessPoint = class _CfnAccessPoint extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAccessPointPropsFromCloudFormation(resourceProperties), ret = new _CfnAccessPoint(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAccessPoint.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3objectlambda_CfnAccessPointProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAccessPoint), error;
        }
        cdk.requireProperty(props, "objectLambdaConfiguration", this), this.attrAliasStatus = cdk.Token.asString(this.getAtt("Alias.Status", cdk.ResolutionTypeHint.STRING)), this.attrAliasValue = cdk.Token.asString(this.getAtt("Alias.Value", cdk.ResolutionTypeHint.STRING)), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreationDate = cdk.Token.asString(this.getAtt("CreationDate", cdk.ResolutionTypeHint.STRING)), this.attrPolicyStatusIsPublic = this.getAtt("PolicyStatus.IsPublic", cdk.ResolutionTypeHint.STRING), this.attrPublicAccessBlockConfigurationBlockPublicAcls = this.getAtt("PublicAccessBlockConfiguration.BlockPublicAcls", cdk.ResolutionTypeHint.STRING), this.attrPublicAccessBlockConfigurationBlockPublicPolicy = this.getAtt("PublicAccessBlockConfiguration.BlockPublicPolicy", cdk.ResolutionTypeHint.STRING), this.attrPublicAccessBlockConfigurationIgnorePublicAcls = this.getAtt("PublicAccessBlockConfiguration.IgnorePublicAcls", cdk.ResolutionTypeHint.STRING), this.attrPublicAccessBlockConfigurationRestrictPublicBuckets = this.getAtt("PublicAccessBlockConfiguration.RestrictPublicBuckets", cdk.ResolutionTypeHint.STRING), this.objectLambdaConfiguration = props.objectLambdaConfiguration, this.name = props.name;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAccessPoint.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { objectLambdaConfiguration: this.objectLambdaConfiguration, name: this.name };
      }
      renderProperties(props) {
        return cfnAccessPointPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAccessPoint[_a] = { fqn: "aws-cdk-lib.aws_s3objectlambda.CfnAccessPoint", version: "2.80.0" }, CfnAccessPoint.CFN_RESOURCE_TYPE_NAME = "AWS::S3ObjectLambda::AccessPoint", exports2.CfnAccessPoint = CfnAccessPoint;
    function CfnAccessPoint_ObjectLambdaConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allowedFeatures", cdk.listValidator(cdk.validateString))(properties.allowedFeatures)), errors.collect(cdk.propertyValidator("cloudWatchMetricsEnabled", cdk.validateBoolean)(properties.cloudWatchMetricsEnabled)), errors.collect(cdk.propertyValidator("supportingAccessPoint", cdk.requiredValidator)(properties.supportingAccessPoint)), errors.collect(cdk.propertyValidator("supportingAccessPoint", cdk.validateString)(properties.supportingAccessPoint)), errors.collect(cdk.propertyValidator("transformationConfigurations", cdk.requiredValidator)(properties.transformationConfigurations)), errors.collect(cdk.propertyValidator("transformationConfigurations", cdk.listValidator(CfnAccessPoint_TransformationConfigurationPropertyValidator))(properties.transformationConfigurations)), errors.wrap('supplied properties not correct for "ObjectLambdaConfigurationProperty"');
    }
    function cfnAccessPointObjectLambdaConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccessPoint_ObjectLambdaConfigurationPropertyValidator(properties).assertSuccess(), { AllowedFeatures: cdk.listMapper(cdk.stringToCloudFormation)(properties.allowedFeatures), CloudWatchMetricsEnabled: cdk.booleanToCloudFormation(properties.cloudWatchMetricsEnabled), SupportingAccessPoint: cdk.stringToCloudFormation(properties.supportingAccessPoint), TransformationConfigurations: cdk.listMapper(cfnAccessPointTransformationConfigurationPropertyToCloudFormation)(properties.transformationConfigurations) }) : properties;
    }
    function CfnAccessPointObjectLambdaConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allowedFeatures", "AllowedFeatures", properties.AllowedFeatures != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AllowedFeatures) : void 0), ret.addPropertyResult("cloudWatchMetricsEnabled", "CloudWatchMetricsEnabled", properties.CloudWatchMetricsEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CloudWatchMetricsEnabled) : void 0), ret.addPropertyResult("supportingAccessPoint", "SupportingAccessPoint", cfn_parse.FromCloudFormation.getString(properties.SupportingAccessPoint)), ret.addPropertyResult("transformationConfigurations", "TransformationConfigurations", cfn_parse.FromCloudFormation.getArray(CfnAccessPointTransformationConfigurationPropertyFromCloudFormation)(properties.TransformationConfigurations)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAccessPoint_TransformationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.requiredValidator)(properties.actions)), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(cdk.validateString))(properties.actions)), errors.collect(cdk.propertyValidator("contentTransformation", cdk.requiredValidator)(properties.contentTransformation)), errors.collect(cdk.propertyValidator("contentTransformation", cdk.validateObject)(properties.contentTransformation)), errors.wrap('supplied properties not correct for "TransformationConfigurationProperty"');
    }
    function cfnAccessPointTransformationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccessPoint_TransformationConfigurationPropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cdk.stringToCloudFormation)(properties.actions), ContentTransformation: cdk.objectToCloudFormation(properties.contentTransformation) }) : properties;
    }
    function CfnAccessPointTransformationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", cfn_parse.FromCloudFormation.getStringArray(properties.Actions)), ret.addPropertyResult("contentTransformation", "ContentTransformation", cfn_parse.FromCloudFormation.getAny(properties.ContentTransformation)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAccessPointPolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("objectLambdaAccessPoint", cdk.requiredValidator)(properties.objectLambdaAccessPoint)), errors.collect(cdk.propertyValidator("objectLambdaAccessPoint", cdk.validateString)(properties.objectLambdaAccessPoint)), errors.collect(cdk.propertyValidator("policyDocument", cdk.requiredValidator)(properties.policyDocument)), errors.collect(cdk.propertyValidator("policyDocument", cdk.validateObject)(properties.policyDocument)), errors.wrap('supplied properties not correct for "CfnAccessPointPolicyProps"');
    }
    function cfnAccessPointPolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccessPointPolicyPropsValidator(properties).assertSuccess(), { ObjectLambdaAccessPoint: cdk.stringToCloudFormation(properties.objectLambdaAccessPoint), PolicyDocument: cdk.objectToCloudFormation(properties.policyDocument) }) : properties;
    }
    function CfnAccessPointPolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("objectLambdaAccessPoint", "ObjectLambdaAccessPoint", cfn_parse.FromCloudFormation.getString(properties.ObjectLambdaAccessPoint)), ret.addPropertyResult("policyDocument", "PolicyDocument", cfn_parse.FromCloudFormation.getAny(properties.PolicyDocument)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAccessPointPolicy = class _CfnAccessPointPolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAccessPointPolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnAccessPointPolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAccessPointPolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3objectlambda_CfnAccessPointPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAccessPointPolicy), error;
        }
        cdk.requireProperty(props, "objectLambdaAccessPoint", this), cdk.requireProperty(props, "policyDocument", this), this.objectLambdaAccessPoint = props.objectLambdaAccessPoint, this.policyDocument = props.policyDocument;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAccessPointPolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { objectLambdaAccessPoint: this.objectLambdaAccessPoint, policyDocument: this.policyDocument };
      }
      renderProperties(props) {
        return cfnAccessPointPolicyPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnAccessPointPolicy[_b] = { fqn: "aws-cdk-lib.aws_s3objectlambda.CfnAccessPointPolicy", version: "2.80.0" }, CfnAccessPointPolicy.CFN_RESOURCE_TYPE_NAME = "AWS::S3ObjectLambda::AccessPointPolicy", exports2.CfnAccessPointPolicy = CfnAccessPointPolicy;
  }
});

// node_modules/aws-cdk-lib/aws-s3objectlambda/lib/index.js
var require_lib231 = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3objectlambda/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_s3objectlambda_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-s3objectlambda/index.js
var require_aws_s3objectlambda = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3objectlambda/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib231(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-s3outposts/lib/s3outposts.generated.js
var require_s3outposts_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3outposts/lib/s3outposts.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnEndpoint = exports2.CfnBucketPolicy = exports2.CfnBucket = exports2.CfnAccessPoint = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAccessPointPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.requiredValidator)(properties.bucket)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("policy", cdk.validateObject)(properties.policy)), errors.collect(cdk.propertyValidator("vpcConfiguration", cdk.requiredValidator)(properties.vpcConfiguration)), errors.collect(cdk.propertyValidator("vpcConfiguration", CfnAccessPoint_VpcConfigurationPropertyValidator)(properties.vpcConfiguration)), errors.wrap('supplied properties not correct for "CfnAccessPointProps"');
    }
    function cfnAccessPointPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccessPointPropsValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), Name: cdk.stringToCloudFormation(properties.name), VpcConfiguration: cfnAccessPointVpcConfigurationPropertyToCloudFormation(properties.vpcConfiguration), Policy: cdk.objectToCloudFormation(properties.policy) }) : properties;
    }
    function CfnAccessPointPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", cfn_parse.FromCloudFormation.getString(properties.Bucket)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("vpcConfiguration", "VpcConfiguration", CfnAccessPointVpcConfigurationPropertyFromCloudFormation(properties.VpcConfiguration)), ret.addPropertyResult("policy", "Policy", properties.Policy != null ? cfn_parse.FromCloudFormation.getAny(properties.Policy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAccessPoint = class _CfnAccessPoint extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAccessPointPropsFromCloudFormation(resourceProperties), ret = new _CfnAccessPoint(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAccessPoint.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3outposts_CfnAccessPointProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAccessPoint), error;
        }
        cdk.requireProperty(props, "bucket", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "vpcConfiguration", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.bucket = props.bucket, this.name = props.name, this.vpcConfiguration = props.vpcConfiguration, this.policy = props.policy;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAccessPoint.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { bucket: this.bucket, name: this.name, vpcConfiguration: this.vpcConfiguration, policy: this.policy };
      }
      renderProperties(props) {
        return cfnAccessPointPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAccessPoint[_a] = { fqn: "aws-cdk-lib.aws_s3outposts.CfnAccessPoint", version: "2.80.0" }, CfnAccessPoint.CFN_RESOURCE_TYPE_NAME = "AWS::S3Outposts::AccessPoint", exports2.CfnAccessPoint = CfnAccessPoint;
    function CfnAccessPoint_VpcConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "VpcConfigurationProperty"');
    }
    function cfnAccessPointVpcConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccessPoint_VpcConfigurationPropertyValidator(properties).assertSuccess(), { VpcId: cdk.stringToCloudFormation(properties.vpcId) }) : properties;
    }
    function CfnAccessPointVpcConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("vpcId", "VpcId", properties.VpcId != null ? cfn_parse.FromCloudFormation.getString(properties.VpcId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucketPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketName", cdk.requiredValidator)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.collect(cdk.propertyValidator("lifecycleConfiguration", CfnBucket_LifecycleConfigurationPropertyValidator)(properties.lifecycleConfiguration)), errors.collect(cdk.propertyValidator("outpostId", cdk.requiredValidator)(properties.outpostId)), errors.collect(cdk.propertyValidator("outpostId", cdk.validateString)(properties.outpostId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnBucketProps"');
    }
    function cfnBucketPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucketPropsValidator(properties).assertSuccess(), { BucketName: cdk.stringToCloudFormation(properties.bucketName), OutpostId: cdk.stringToCloudFormation(properties.outpostId), LifecycleConfiguration: cfnBucketLifecycleConfigurationPropertyToCloudFormation(properties.lifecycleConfiguration), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnBucketPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketName", "BucketName", cfn_parse.FromCloudFormation.getString(properties.BucketName)), ret.addPropertyResult("outpostId", "OutpostId", cfn_parse.FromCloudFormation.getString(properties.OutpostId)), ret.addPropertyResult("lifecycleConfiguration", "LifecycleConfiguration", properties.LifecycleConfiguration != null ? CfnBucketLifecycleConfigurationPropertyFromCloudFormation(properties.LifecycleConfiguration) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnBucket = class _CfnBucket extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnBucketPropsFromCloudFormation(resourceProperties), ret = new _CfnBucket(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnBucket.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3outposts_CfnBucketProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnBucket), error;
        }
        cdk.requireProperty(props, "bucketName", this), cdk.requireProperty(props, "outpostId", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.bucketName = props.bucketName, this.outpostId = props.outpostId, this.lifecycleConfiguration = props.lifecycleConfiguration, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::S3Outposts::Bucket", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnBucket.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { bucketName: this.bucketName, outpostId: this.outpostId, lifecycleConfiguration: this.lifecycleConfiguration, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnBucketPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnBucket[_b] = { fqn: "aws-cdk-lib.aws_s3outposts.CfnBucket", version: "2.80.0" }, CfnBucket.CFN_RESOURCE_TYPE_NAME = "AWS::S3Outposts::Bucket", exports2.CfnBucket = CfnBucket;
    function CfnBucket_AbortIncompleteMultipartUploadPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("daysAfterInitiation", cdk.requiredValidator)(properties.daysAfterInitiation)), errors.collect(cdk.propertyValidator("daysAfterInitiation", cdk.validateNumber)(properties.daysAfterInitiation)), errors.wrap('supplied properties not correct for "AbortIncompleteMultipartUploadProperty"');
    }
    function cfnBucketAbortIncompleteMultipartUploadPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_AbortIncompleteMultipartUploadPropertyValidator(properties).assertSuccess(), { DaysAfterInitiation: cdk.numberToCloudFormation(properties.daysAfterInitiation) }) : properties;
    }
    function CfnBucketAbortIncompleteMultipartUploadPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("daysAfterInitiation", "DaysAfterInitiation", cfn_parse.FromCloudFormation.getNumber(properties.DaysAfterInitiation)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_LifecycleConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("rules", cdk.requiredValidator)(properties.rules)), errors.collect(cdk.propertyValidator("rules", cdk.listValidator(CfnBucket_RulePropertyValidator))(properties.rules)), errors.wrap('supplied properties not correct for "LifecycleConfigurationProperty"');
    }
    function cfnBucketLifecycleConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_LifecycleConfigurationPropertyValidator(properties).assertSuccess(), { Rules: cdk.listMapper(cfnBucketRulePropertyToCloudFormation)(properties.rules) }) : properties;
    }
    function CfnBucketLifecycleConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("rules", "Rules", cfn_parse.FromCloudFormation.getArray(CfnBucketRulePropertyFromCloudFormation)(properties.Rules)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucket_RulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("abortIncompleteMultipartUpload", CfnBucket_AbortIncompleteMultipartUploadPropertyValidator)(properties.abortIncompleteMultipartUpload)), errors.collect(cdk.propertyValidator("expirationDate", cdk.validateString)(properties.expirationDate)), errors.collect(cdk.propertyValidator("expirationInDays", cdk.validateNumber)(properties.expirationInDays)), errors.collect(cdk.propertyValidator("filter", cdk.validateObject)(properties.filter)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("status", cdk.requiredValidator)(properties.status)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "RuleProperty"');
    }
    function cfnBucketRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucket_RulePropertyValidator(properties).assertSuccess(), { AbortIncompleteMultipartUpload: cfnBucketAbortIncompleteMultipartUploadPropertyToCloudFormation(properties.abortIncompleteMultipartUpload), ExpirationDate: cdk.stringToCloudFormation(properties.expirationDate), ExpirationInDays: cdk.numberToCloudFormation(properties.expirationInDays), Filter: cdk.objectToCloudFormation(properties.filter), Id: cdk.stringToCloudFormation(properties.id), Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnBucketRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("abortIncompleteMultipartUpload", "AbortIncompleteMultipartUpload", properties.AbortIncompleteMultipartUpload != null ? CfnBucketAbortIncompleteMultipartUploadPropertyFromCloudFormation(properties.AbortIncompleteMultipartUpload) : void 0), ret.addPropertyResult("expirationDate", "ExpirationDate", properties.ExpirationDate != null ? cfn_parse.FromCloudFormation.getString(properties.ExpirationDate) : void 0), ret.addPropertyResult("expirationInDays", "ExpirationInDays", properties.ExpirationInDays != null ? cfn_parse.FromCloudFormation.getNumber(properties.ExpirationInDays) : void 0), ret.addPropertyResult("filter", "Filter", properties.Filter != null ? cfn_parse.FromCloudFormation.getAny(properties.Filter) : void 0), ret.addPropertyResult("id", "Id", properties.Id != null ? cfn_parse.FromCloudFormation.getString(properties.Id) : void 0), ret.addPropertyResult("status", "Status", cfn_parse.FromCloudFormation.getString(properties.Status)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnBucketPolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.requiredValidator)(properties.bucket)), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("policyDocument", cdk.requiredValidator)(properties.policyDocument)), errors.collect(cdk.propertyValidator("policyDocument", cdk.validateObject)(properties.policyDocument)), errors.wrap('supplied properties not correct for "CfnBucketPolicyProps"');
    }
    function cfnBucketPolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnBucketPolicyPropsValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), PolicyDocument: cdk.objectToCloudFormation(properties.policyDocument) }) : properties;
    }
    function CfnBucketPolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", cfn_parse.FromCloudFormation.getString(properties.Bucket)), ret.addPropertyResult("policyDocument", "PolicyDocument", cfn_parse.FromCloudFormation.getAny(properties.PolicyDocument)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnBucketPolicy = class _CfnBucketPolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnBucketPolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnBucketPolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnBucketPolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3outposts_CfnBucketPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnBucketPolicy), error;
        }
        cdk.requireProperty(props, "bucket", this), cdk.requireProperty(props, "policyDocument", this), this.bucket = props.bucket, this.policyDocument = props.policyDocument;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnBucketPolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { bucket: this.bucket, policyDocument: this.policyDocument };
      }
      renderProperties(props) {
        return cfnBucketPolicyPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnBucketPolicy[_c] = { fqn: "aws-cdk-lib.aws_s3outposts.CfnBucketPolicy", version: "2.80.0" }, CfnBucketPolicy.CFN_RESOURCE_TYPE_NAME = "AWS::S3Outposts::BucketPolicy", exports2.CfnBucketPolicy = CfnBucketPolicy;
    function CfnEndpointPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessType", cdk.validateString)(properties.accessType)), errors.collect(cdk.propertyValidator("customerOwnedIpv4Pool", cdk.validateString)(properties.customerOwnedIpv4Pool)), errors.collect(cdk.propertyValidator("outpostId", cdk.requiredValidator)(properties.outpostId)), errors.collect(cdk.propertyValidator("outpostId", cdk.validateString)(properties.outpostId)), errors.collect(cdk.propertyValidator("securityGroupId", cdk.requiredValidator)(properties.securityGroupId)), errors.collect(cdk.propertyValidator("securityGroupId", cdk.validateString)(properties.securityGroupId)), errors.collect(cdk.propertyValidator("subnetId", cdk.requiredValidator)(properties.subnetId)), errors.collect(cdk.propertyValidator("subnetId", cdk.validateString)(properties.subnetId)), errors.wrap('supplied properties not correct for "CfnEndpointProps"');
    }
    function cfnEndpointPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpointPropsValidator(properties).assertSuccess(), { OutpostId: cdk.stringToCloudFormation(properties.outpostId), SecurityGroupId: cdk.stringToCloudFormation(properties.securityGroupId), SubnetId: cdk.stringToCloudFormation(properties.subnetId), AccessType: cdk.stringToCloudFormation(properties.accessType), CustomerOwnedIpv4Pool: cdk.stringToCloudFormation(properties.customerOwnedIpv4Pool) }) : properties;
    }
    function CfnEndpointPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("outpostId", "OutpostId", cfn_parse.FromCloudFormation.getString(properties.OutpostId)), ret.addPropertyResult("securityGroupId", "SecurityGroupId", cfn_parse.FromCloudFormation.getString(properties.SecurityGroupId)), ret.addPropertyResult("subnetId", "SubnetId", cfn_parse.FromCloudFormation.getString(properties.SubnetId)), ret.addPropertyResult("accessType", "AccessType", properties.AccessType != null ? cfn_parse.FromCloudFormation.getString(properties.AccessType) : void 0), ret.addPropertyResult("customerOwnedIpv4Pool", "CustomerOwnedIpv4Pool", properties.CustomerOwnedIpv4Pool != null ? cfn_parse.FromCloudFormation.getString(properties.CustomerOwnedIpv4Pool) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEndpoint = class _CfnEndpoint extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEndpointPropsFromCloudFormation(resourceProperties), ret = new _CfnEndpoint(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEndpoint.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3outposts_CfnEndpointProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEndpoint), error;
        }
        cdk.requireProperty(props, "outpostId", this), cdk.requireProperty(props, "securityGroupId", this), cdk.requireProperty(props, "subnetId", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCidrBlock = cdk.Token.asString(this.getAtt("CidrBlock", cdk.ResolutionTypeHint.STRING)), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrNetworkInterfaces = this.getAtt("NetworkInterfaces", cdk.ResolutionTypeHint.STRING), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.outpostId = props.outpostId, this.securityGroupId = props.securityGroupId, this.subnetId = props.subnetId, this.accessType = props.accessType, this.customerOwnedIpv4Pool = props.customerOwnedIpv4Pool;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEndpoint.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { outpostId: this.outpostId, securityGroupId: this.securityGroupId, subnetId: this.subnetId, accessType: this.accessType, customerOwnedIpv4Pool: this.customerOwnedIpv4Pool };
      }
      renderProperties(props) {
        return cfnEndpointPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnEndpoint[_d] = { fqn: "aws-cdk-lib.aws_s3outposts.CfnEndpoint", version: "2.80.0" }, CfnEndpoint.CFN_RESOURCE_TYPE_NAME = "AWS::S3Outposts::Endpoint", exports2.CfnEndpoint = CfnEndpoint;
  }
});

// node_modules/aws-cdk-lib/aws-s3outposts/lib/index.js
var require_lib232 = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3outposts/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_s3outposts_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-s3outposts/index.js
var require_aws_s3outposts = __commonJS({
  "node_modules/aws-cdk-lib/aws-s3outposts/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib232(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-sagemaker/lib/sagemaker.generated.js
var require_sagemaker_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-sagemaker/lib/sagemaker.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    var _l;
    var _m;
    var _o;
    var _p;
    var _q;
    var _r;
    var _s;
    var _t;
    var _u;
    var _v;
    var _w;
    var _x;
    var _y;
    var _z;
    var _0;
    var _1;
    var _2;
    var _3;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnWorkteam = exports2.CfnUserProfile = exports2.CfnSpace = exports2.CfnProject = exports2.CfnPipeline = exports2.CfnNotebookInstanceLifecycleConfig = exports2.CfnNotebookInstance = exports2.CfnMonitoringSchedule = exports2.CfnModelQualityJobDefinition = exports2.CfnModelPackageGroup = exports2.CfnModelPackage = exports2.CfnModelExplainabilityJobDefinition = exports2.CfnModelCard = exports2.CfnModelBiasJobDefinition = exports2.CfnModel = exports2.CfnInferenceExperiment = exports2.CfnImageVersion = exports2.CfnImage = exports2.CfnFeatureGroup = exports2.CfnEndpointConfig = exports2.CfnEndpoint = exports2.CfnDomain = exports2.CfnDeviceFleet = exports2.CfnDevice = exports2.CfnDataQualityJobDefinition = exports2.CfnCodeRepository = exports2.CfnAppImageConfig = exports2.CfnApp = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAppPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("appName", cdk.requiredValidator)(properties.appName)), errors.collect(cdk.propertyValidator("appName", cdk.validateString)(properties.appName)), errors.collect(cdk.propertyValidator("appType", cdk.requiredValidator)(properties.appType)), errors.collect(cdk.propertyValidator("appType", cdk.validateString)(properties.appType)), errors.collect(cdk.propertyValidator("domainId", cdk.requiredValidator)(properties.domainId)), errors.collect(cdk.propertyValidator("domainId", cdk.validateString)(properties.domainId)), errors.collect(cdk.propertyValidator("resourceSpec", CfnApp_ResourceSpecPropertyValidator)(properties.resourceSpec)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("userProfileName", cdk.requiredValidator)(properties.userProfileName)), errors.collect(cdk.propertyValidator("userProfileName", cdk.validateString)(properties.userProfileName)), errors.wrap('supplied properties not correct for "CfnAppProps"');
    }
    function cfnAppPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAppPropsValidator(properties).assertSuccess(), { AppName: cdk.stringToCloudFormation(properties.appName), AppType: cdk.stringToCloudFormation(properties.appType), DomainId: cdk.stringToCloudFormation(properties.domainId), UserProfileName: cdk.stringToCloudFormation(properties.userProfileName), ResourceSpec: cfnAppResourceSpecPropertyToCloudFormation(properties.resourceSpec), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnAppPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("appName", "AppName", cfn_parse.FromCloudFormation.getString(properties.AppName)), ret.addPropertyResult("appType", "AppType", cfn_parse.FromCloudFormation.getString(properties.AppType)), ret.addPropertyResult("domainId", "DomainId", cfn_parse.FromCloudFormation.getString(properties.DomainId)), ret.addPropertyResult("userProfileName", "UserProfileName", cfn_parse.FromCloudFormation.getString(properties.UserProfileName)), ret.addPropertyResult("resourceSpec", "ResourceSpec", properties.ResourceSpec != null ? CfnAppResourceSpecPropertyFromCloudFormation(properties.ResourceSpec) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApp = class _CfnApp extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAppPropsFromCloudFormation(resourceProperties), ret = new _CfnApp(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApp.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sagemaker_CfnAppProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApp), error;
        }
        cdk.requireProperty(props, "appName", this), cdk.requireProperty(props, "appType", this), cdk.requireProperty(props, "domainId", this), cdk.requireProperty(props, "userProfileName", this), this.attrAppArn = cdk.Token.asString(this.getAtt("AppArn", cdk.ResolutionTypeHint.STRING)), this.appName = props.appName, this.appType = props.appType, this.domainId = props.domainId, this.userProfileName = props.userProfileName, this.resourceSpec = props.resourceSpec, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SageMaker::App", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApp.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { appName: this.appName, appType: this.appType, domainId: this.domainId, userProfileName: this.userProfileName, resourceSpec: this.resourceSpec, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnAppPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnApp[_a] = { fqn: "aws-cdk-lib.aws_sagemaker.CfnApp", version: "2.80.0" }, CfnApp.CFN_RESOURCE_TYPE_NAME = "AWS::SageMaker::App", exports2.CfnApp = CfnApp;
    function CfnApp_ResourceSpecPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("sageMakerImageArn", cdk.validateString)(properties.sageMakerImageArn)), errors.collect(cdk.propertyValidator("sageMakerImageVersionArn", cdk.validateString)(properties.sageMakerImageVersionArn)), errors.wrap('supplied properties not correct for "ResourceSpecProperty"');
    }
    function cfnAppResourceSpecPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApp_ResourceSpecPropertyValidator(properties).assertSuccess(), { InstanceType: cdk.stringToCloudFormation(properties.instanceType), SageMakerImageArn: cdk.stringToCloudFormation(properties.sageMakerImageArn), SageMakerImageVersionArn: cdk.stringToCloudFormation(properties.sageMakerImageVersionArn) }) : properties;
    }
    function CfnAppResourceSpecPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceType", "InstanceType", properties.InstanceType != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceType) : void 0), ret.addPropertyResult("sageMakerImageArn", "SageMakerImageArn", properties.SageMakerImageArn != null ? cfn_parse.FromCloudFormation.getString(properties.SageMakerImageArn) : void 0), ret.addPropertyResult("sageMakerImageVersionArn", "SageMakerImageVersionArn", properties.SageMakerImageVersionArn != null ? cfn_parse.FromCloudFormation.getString(properties.SageMakerImageVersionArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAppImageConfigPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("appImageConfigName", cdk.requiredValidator)(properties.appImageConfigName)), errors.collect(cdk.propertyValidator("appImageConfigName", cdk.validateString)(properties.appImageConfigName)), errors.collect(cdk.propertyValidator("kernelGatewayImageConfig", CfnAppImageConfig_KernelGatewayImageConfigPropertyValidator)(properties.kernelGatewayImageConfig)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnAppImageConfigProps"');
    }
    function cfnAppImageConfigPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAppImageConfigPropsValidator(properties).assertSuccess(), { AppImageConfigName: cdk.stringToCloudFormation(properties.appImageConfigName), KernelGatewayImageConfig: cfnAppImageConfigKernelGatewayImageConfigPropertyToCloudFormation(properties.kernelGatewayImageConfig), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnAppImageConfigPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("appImageConfigName", "AppImageConfigName", cfn_parse.FromCloudFormation.getString(properties.AppImageConfigName)), ret.addPropertyResult("kernelGatewayImageConfig", "KernelGatewayImageConfig", properties.KernelGatewayImageConfig != null ? CfnAppImageConfigKernelGatewayImageConfigPropertyFromCloudFormation(properties.KernelGatewayImageConfig) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAppImageConfig = class _CfnAppImageConfig extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAppImageConfigPropsFromCloudFormation(resourceProperties), ret = new _CfnAppImageConfig(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAppImageConfig.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sagemaker_CfnAppImageConfigProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAppImageConfig), error;
        }
        cdk.requireProperty(props, "appImageConfigName", this), this.attrAppImageConfigArn = cdk.Token.asString(this.getAtt("AppImageConfigArn", cdk.ResolutionTypeHint.STRING)), this.appImageConfigName = props.appImageConfigName, this.kernelGatewayImageConfig = props.kernelGatewayImageConfig, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SageMaker::AppImageConfig", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAppImageConfig.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { appImageConfigName: this.appImageConfigName, kernelGatewayImageConfig: this.kernelGatewayImageConfig, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnAppImageConfigPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnAppImageConfig[_b] = { fqn: "aws-cdk-lib.aws_sagemaker.CfnAppImageConfig", version: "2.80.0" }, CfnAppImageConfig.CFN_RESOURCE_TYPE_NAME = "AWS::SageMaker::AppImageConfig", exports2.CfnAppImageConfig = CfnAppImageConfig;
    function CfnAppImageConfig_FileSystemConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultGid", cdk.validateNumber)(properties.defaultGid)), errors.collect(cdk.propertyValidator("defaultUid", cdk.validateNumber)(properties.defaultUid)), errors.collect(cdk.propertyValidator("mountPath", cdk.validateString)(properties.mountPath)), errors.wrap('supplied properties not correct for "FileSystemConfigProperty"');
    }
    function cfnAppImageConfigFileSystemConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAppImageConfig_FileSystemConfigPropertyValidator(properties).assertSuccess(), { DefaultGid: cdk.numberToCloudFormation(properties.defaultGid), DefaultUid: cdk.numberToCloudFormation(properties.defaultUid), MountPath: cdk.stringToCloudFormation(properties.mountPath) }) : properties;
    }
    function CfnAppImageConfigFileSystemConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultGid", "DefaultGid", properties.DefaultGid != null ? cfn_parse.FromCloudFormation.getNumber(properties.DefaultGid) : void 0), ret.addPropertyResult("defaultUid", "DefaultUid", properties.DefaultUid != null ? cfn_parse.FromCloudFormation.getNumber(properties.DefaultUid) : void 0), ret.addPropertyResult("mountPath", "MountPath", properties.MountPath != null ? cfn_parse.FromCloudFormation.getString(properties.MountPath) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAppImageConfig_KernelGatewayImageConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fileSystemConfig", CfnAppImageConfig_FileSystemConfigPropertyValidator)(properties.fileSystemConfig)), errors.collect(cdk.propertyValidator("kernelSpecs", cdk.requiredValidator)(properties.kernelSpecs)), errors.collect(cdk.propertyValidator("kernelSpecs", cdk.listValidator(CfnAppImageConfig_KernelSpecPropertyValidator))(properties.kernelSpecs)), errors.wrap('supplied properties not correct for "KernelGatewayImageConfigProperty"');
    }
    function cfnAppImageConfigKernelGatewayImageConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAppImageConfig_KernelGatewayImageConfigPropertyValidator(properties).assertSuccess(), { FileSystemConfig: cfnAppImageConfigFileSystemConfigPropertyToCloudFormation(properties.fileSystemConfig), KernelSpecs: cdk.listMapper(cfnAppImageConfigKernelSpecPropertyToCloudFormation)(properties.kernelSpecs) }) : properties;
    }
    function CfnAppImageConfigKernelGatewayImageConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fileSystemConfig", "FileSystemConfig", properties.FileSystemConfig != null ? CfnAppImageConfigFileSystemConfigPropertyFromCloudFormation(properties.FileSystemConfig) : void 0), ret.addPropertyResult("kernelSpecs", "KernelSpecs", cfn_parse.FromCloudFormation.getArray(CfnAppImageConfigKernelSpecPropertyFromCloudFormation)(properties.KernelSpecs)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAppImageConfig_KernelSpecPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("displayName", cdk.validateString)(properties.displayName)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "KernelSpecProperty"');
    }
    function cfnAppImageConfigKernelSpecPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAppImageConfig_KernelSpecPropertyValidator(properties).assertSuccess(), { DisplayName: cdk.stringToCloudFormation(properties.displayName), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnAppImageConfigKernelSpecPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("displayName", "DisplayName", properties.DisplayName != null ? cfn_parse.FromCloudFormation.getString(properties.DisplayName) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCodeRepositoryPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("codeRepositoryName", cdk.validateString)(properties.codeRepositoryName)), errors.collect(cdk.propertyValidator("gitConfig", cdk.requiredValidator)(properties.gitConfig)), errors.collect(cdk.propertyValidator("gitConfig", CfnCodeRepository_GitConfigPropertyValidator)(properties.gitConfig)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnCodeRepositoryProps"');
    }
    function cfnCodeRepositoryPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCodeRepositoryPropsValidator(properties).assertSuccess(), { GitConfig: cfnCodeRepositoryGitConfigPropertyToCloudFormation(properties.gitConfig), CodeRepositoryName: cdk.stringToCloudFormation(properties.codeRepositoryName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnCodeRepositoryPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("gitConfig", "GitConfig", CfnCodeRepositoryGitConfigPropertyFromCloudFormation(properties.GitConfig)), ret.addPropertyResult("codeRepositoryName", "CodeRepositoryName", properties.CodeRepositoryName != null ? cfn_parse.FromCloudFormation.getString(properties.CodeRepositoryName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCodeRepository = class _CfnCodeRepository extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCodeRepositoryPropsFromCloudFormation(resourceProperties), ret = new _CfnCodeRepository(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCodeRepository.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sagemaker_CfnCodeRepositoryProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCodeRepository), error;
        }
        cdk.requireProperty(props, "gitConfig", this), this.attrCodeRepositoryName = cdk.Token.asString(this.getAtt("CodeRepositoryName", cdk.ResolutionTypeHint.STRING)), this.gitConfig = props.gitConfig, this.codeRepositoryName = props.codeRepositoryName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SageMaker::CodeRepository", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCodeRepository.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { gitConfig: this.gitConfig, codeRepositoryName: this.codeRepositoryName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnCodeRepositoryPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnCodeRepository[_c] = { fqn: "aws-cdk-lib.aws_sagemaker.CfnCodeRepository", version: "2.80.0" }, CfnCodeRepository.CFN_RESOURCE_TYPE_NAME = "AWS::SageMaker::CodeRepository", exports2.CfnCodeRepository = CfnCodeRepository;
    function CfnCodeRepository_GitConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("branch", cdk.validateString)(properties.branch)), errors.collect(cdk.propertyValidator("repositoryUrl", cdk.requiredValidator)(properties.repositoryUrl)), errors.collect(cdk.propertyValidator("repositoryUrl", cdk.validateString)(properties.repositoryUrl)), errors.collect(cdk.propertyValidator("secretArn", cdk.validateString)(properties.secretArn)), errors.wrap('supplied properties not correct for "GitConfigProperty"');
    }
    function cfnCodeRepositoryGitConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCodeRepository_GitConfigPropertyValidator(properties).assertSuccess(), { Branch: cdk.stringToCloudFormation(properties.branch), RepositoryUrl: cdk.stringToCloudFormation(properties.repositoryUrl), SecretArn: cdk.stringToCloudFormation(properties.secretArn) }) : properties;
    }
    function CfnCodeRepositoryGitConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("branch", "Branch", properties.Branch != null ? cfn_parse.FromCloudFormation.getString(properties.Branch) : void 0), ret.addPropertyResult("repositoryUrl", "RepositoryUrl", cfn_parse.FromCloudFormation.getString(properties.RepositoryUrl)), ret.addPropertyResult("secretArn", "SecretArn", properties.SecretArn != null ? cfn_parse.FromCloudFormation.getString(properties.SecretArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataQualityJobDefinitionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataQualityAppSpecification", cdk.requiredValidator)(properties.dataQualityAppSpecification)), errors.collect(cdk.propertyValidator("dataQualityAppSpecification", CfnDataQualityJobDefinition_DataQualityAppSpecificationPropertyValidator)(properties.dataQualityAppSpecification)), errors.collect(cdk.propertyValidator("dataQualityBaselineConfig", CfnDataQualityJobDefinition_DataQualityBaselineConfigPropertyValidator)(properties.dataQualityBaselineConfig)), errors.collect(cdk.propertyValidator("dataQualityJobInput", cdk.requiredValidator)(properties.dataQualityJobInput)), errors.collect(cdk.propertyValidator("dataQualityJobInput", CfnDataQualityJobDefinition_DataQualityJobInputPropertyValidator)(properties.dataQualityJobInput)), errors.collect(cdk.propertyValidator("dataQualityJobOutputConfig", cdk.requiredValidator)(properties.dataQualityJobOutputConfig)), errors.collect(cdk.propertyValidator("dataQualityJobOutputConfig", CfnDataQualityJobDefinition_MonitoringOutputConfigPropertyValidator)(properties.dataQualityJobOutputConfig)), errors.collect(cdk.propertyValidator("endpointName", cdk.validateString)(properties.endpointName)), errors.collect(cdk.propertyValidator("jobDefinitionName", cdk.validateString)(properties.jobDefinitionName)), errors.collect(cdk.propertyValidator("jobResources", cdk.requiredValidator)(properties.jobResources)), errors.collect(cdk.propertyValidator("jobResources", CfnDataQualityJobDefinition_MonitoringResourcesPropertyValidator)(properties.jobResources)), errors.collect(cdk.propertyValidator("networkConfig", CfnDataQualityJobDefinition_NetworkConfigPropertyValidator)(properties.networkConfig)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("stoppingCondition", CfnDataQualityJobDefinition_StoppingConditionPropertyValidator)(properties.stoppingCondition)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDataQualityJobDefinitionProps"');
    }
    function cfnDataQualityJobDefinitionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataQualityJobDefinitionPropsValidator(properties).assertSuccess(), { DataQualityAppSpecification: cfnDataQualityJobDefinitionDataQualityAppSpecificationPropertyToCloudFormation(properties.dataQualityAppSpecification), DataQualityJobInput: cfnDataQualityJobDefinitionDataQualityJobInputPropertyToCloudFormation(properties.dataQualityJobInput), DataQualityJobOutputConfig: cfnDataQualityJobDefinitionMonitoringOutputConfigPropertyToCloudFormation(properties.dataQualityJobOutputConfig), JobResources: cfnDataQualityJobDefinitionMonitoringResourcesPropertyToCloudFormation(properties.jobResources), RoleArn: cdk.stringToCloudFormation(properties.roleArn), DataQualityBaselineConfig: cfnDataQualityJobDefinitionDataQualityBaselineConfigPropertyToCloudFormation(properties.dataQualityBaselineConfig), EndpointName: cdk.stringToCloudFormation(properties.endpointName), JobDefinitionName: cdk.stringToCloudFormation(properties.jobDefinitionName), NetworkConfig: cfnDataQualityJobDefinitionNetworkConfigPropertyToCloudFormation(properties.networkConfig), StoppingCondition: cfnDataQualityJobDefinitionStoppingConditionPropertyToCloudFormation(properties.stoppingCondition), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDataQualityJobDefinitionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataQualityAppSpecification", "DataQualityAppSpecification", CfnDataQualityJobDefinitionDataQualityAppSpecificationPropertyFromCloudFormation(properties.DataQualityAppSpecification)), ret.addPropertyResult("dataQualityJobInput", "DataQualityJobInput", CfnDataQualityJobDefinitionDataQualityJobInputPropertyFromCloudFormation(properties.DataQualityJobInput)), ret.addPropertyResult("dataQualityJobOutputConfig", "DataQualityJobOutputConfig", CfnDataQualityJobDefinitionMonitoringOutputConfigPropertyFromCloudFormation(properties.DataQualityJobOutputConfig)), ret.addPropertyResult("jobResources", "JobResources", CfnDataQualityJobDefinitionMonitoringResourcesPropertyFromCloudFormation(properties.JobResources)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("dataQualityBaselineConfig", "DataQualityBaselineConfig", properties.DataQualityBaselineConfig != null ? CfnDataQualityJobDefinitionDataQualityBaselineConfigPropertyFromCloudFormation(properties.DataQualityBaselineConfig) : void 0), ret.addPropertyResult("endpointName", "EndpointName", properties.EndpointName != null ? cfn_parse.FromCloudFormation.getString(properties.EndpointName) : void 0), ret.addPropertyResult("jobDefinitionName", "JobDefinitionName", properties.JobDefinitionName != null ? cfn_parse.FromCloudFormation.getString(properties.JobDefinitionName) : void 0), ret.addPropertyResult("networkConfig", "NetworkConfig", properties.NetworkConfig != null ? CfnDataQualityJobDefinitionNetworkConfigPropertyFromCloudFormation(properties.NetworkConfig) : void 0), ret.addPropertyResult("stoppingCondition", "StoppingCondition", properties.StoppingCondition != null ? CfnDataQualityJobDefinitionStoppingConditionPropertyFromCloudFormation(properties.StoppingCondition) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDataQualityJobDefinition = class _CfnDataQualityJobDefinition extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDataQualityJobDefinitionPropsFromCloudFormation(resourceProperties), ret = new _CfnDataQualityJobDefinition(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDataQualityJobDefinition.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sagemaker_CfnDataQualityJobDefinitionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDataQualityJobDefinition), error;
        }
        cdk.requireProperty(props, "dataQualityAppSpecification", this), cdk.requireProperty(props, "dataQualityJobInput", this), cdk.requireProperty(props, "dataQualityJobOutputConfig", this), cdk.requireProperty(props, "jobResources", this), cdk.requireProperty(props, "roleArn", this), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrJobDefinitionArn = cdk.Token.asString(this.getAtt("JobDefinitionArn", cdk.ResolutionTypeHint.STRING)), this.dataQualityAppSpecification = props.dataQualityAppSpecification, this.dataQualityJobInput = props.dataQualityJobInput, this.dataQualityJobOutputConfig = props.dataQualityJobOutputConfig, this.jobResources = props.jobResources, this.roleArn = props.roleArn, this.dataQualityBaselineConfig = props.dataQualityBaselineConfig, this.endpointName = props.endpointName, this.jobDefinitionName = props.jobDefinitionName, this.networkConfig = props.networkConfig, this.stoppingCondition = props.stoppingCondition, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SageMaker::DataQualityJobDefinition", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDataQualityJobDefinition.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { dataQualityAppSpecification: this.dataQualityAppSpecification, dataQualityJobInput: this.dataQualityJobInput, dataQualityJobOutputConfig: this.dataQualityJobOutputConfig, jobResources: this.jobResources, roleArn: this.roleArn, dataQualityBaselineConfig: this.dataQualityBaselineConfig, endpointName: this.endpointName, jobDefinitionName: this.jobDefinitionName, networkConfig: this.networkConfig, stoppingCondition: this.stoppingCondition, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDataQualityJobDefinitionPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnDataQualityJobDefinition[_d] = { fqn: "aws-cdk-lib.aws_sagemaker.CfnDataQualityJobDefinition", version: "2.80.0" }, CfnDataQualityJobDefinition.CFN_RESOURCE_TYPE_NAME = "AWS::SageMaker::DataQualityJobDefinition", exports2.CfnDataQualityJobDefinition = CfnDataQualityJobDefinition;
    function CfnDataQualityJobDefinition_BatchTransformInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataCapturedDestinationS3Uri", cdk.requiredValidator)(properties.dataCapturedDestinationS3Uri)), errors.collect(cdk.propertyValidator("dataCapturedDestinationS3Uri", cdk.validateString)(properties.dataCapturedDestinationS3Uri)), errors.collect(cdk.propertyValidator("datasetFormat", cdk.requiredValidator)(properties.datasetFormat)), errors.collect(cdk.propertyValidator("datasetFormat", CfnDataQualityJobDefinition_DatasetFormatPropertyValidator)(properties.datasetFormat)), errors.collect(cdk.propertyValidator("localPath", cdk.requiredValidator)(properties.localPath)), errors.collect(cdk.propertyValidator("localPath", cdk.validateString)(properties.localPath)), errors.collect(cdk.propertyValidator("s3DataDistributionType", cdk.validateString)(properties.s3DataDistributionType)), errors.collect(cdk.propertyValidator("s3InputMode", cdk.validateString)(properties.s3InputMode)), errors.wrap('supplied properties not correct for "BatchTransformInputProperty"');
    }
    function cfnDataQualityJobDefinitionBatchTransformInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataQualityJobDefinition_BatchTransformInputPropertyValidator(properties).assertSuccess(), { DataCapturedDestinationS3Uri: cdk.stringToCloudFormation(properties.dataCapturedDestinationS3Uri), DatasetFormat: cfnDataQualityJobDefinitionDatasetFormatPropertyToCloudFormation(properties.datasetFormat), LocalPath: cdk.stringToCloudFormation(properties.localPath), S3DataDistributionType: cdk.stringToCloudFormation(properties.s3DataDistributionType), S3InputMode: cdk.stringToCloudFormation(properties.s3InputMode) }) : properties;
    }
    function CfnDataQualityJobDefinitionBatchTransformInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataCapturedDestinationS3Uri", "DataCapturedDestinationS3Uri", cfn_parse.FromCloudFormation.getString(properties.DataCapturedDestinationS3Uri)), ret.addPropertyResult("datasetFormat", "DatasetFormat", CfnDataQualityJobDefinitionDatasetFormatPropertyFromCloudFormation(properties.DatasetFormat)), ret.addPropertyResult("localPath", "LocalPath", cfn_parse.FromCloudFormation.getString(properties.LocalPath)), ret.addPropertyResult("s3DataDistributionType", "S3DataDistributionType", properties.S3DataDistributionType != null ? cfn_parse.FromCloudFormation.getString(properties.S3DataDistributionType) : void 0), ret.addPropertyResult("s3InputMode", "S3InputMode", properties.S3InputMode != null ? cfn_parse.FromCloudFormation.getString(properties.S3InputMode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataQualityJobDefinition_ClusterConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceCount", cdk.requiredValidator)(properties.instanceCount)), errors.collect(cdk.propertyValidator("instanceCount", cdk.validateNumber)(properties.instanceCount)), errors.collect(cdk.propertyValidator("instanceType", cdk.requiredValidator)(properties.instanceType)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("volumeKmsKeyId", cdk.validateString)(properties.volumeKmsKeyId)), errors.collect(cdk.propertyValidator("volumeSizeInGb", cdk.requiredValidator)(properties.volumeSizeInGb)), errors.collect(cdk.propertyValidator("volumeSizeInGb", cdk.validateNumber)(properties.volumeSizeInGb)), errors.wrap('supplied properties not correct for "ClusterConfigProperty"');
    }
    function cfnDataQualityJobDefinitionClusterConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataQualityJobDefinition_ClusterConfigPropertyValidator(properties).assertSuccess(), { InstanceCount: cdk.numberToCloudFormation(properties.instanceCount), InstanceType: cdk.stringToCloudFormation(properties.instanceType), VolumeKmsKeyId: cdk.stringToCloudFormation(properties.volumeKmsKeyId), VolumeSizeInGB: cdk.numberToCloudFormation(properties.volumeSizeInGb) }) : properties;
    }
    function CfnDataQualityJobDefinitionClusterConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceCount", "InstanceCount", cfn_parse.FromCloudFormation.getNumber(properties.InstanceCount)), ret.addPropertyResult("instanceType", "InstanceType", cfn_parse.FromCloudFormation.getString(properties.InstanceType)), ret.addPropertyResult("volumeKmsKeyId", "VolumeKmsKeyId", properties.VolumeKmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.VolumeKmsKeyId) : void 0), ret.addPropertyResult("volumeSizeInGb", "VolumeSizeInGB", cfn_parse.FromCloudFormation.getNumber(properties.VolumeSizeInGB)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataQualityJobDefinition_ConstraintsResourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3Uri", cdk.validateString)(properties.s3Uri)), errors.wrap('supplied properties not correct for "ConstraintsResourceProperty"');
    }
    function cfnDataQualityJobDefinitionConstraintsResourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataQualityJobDefinition_ConstraintsResourcePropertyValidator(properties).assertSuccess(), { S3Uri: cdk.stringToCloudFormation(properties.s3Uri) }) : properties;
    }
    function CfnDataQualityJobDefinitionConstraintsResourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Uri", "S3Uri", properties.S3Uri != null ? cfn_parse.FromCloudFormation.getString(properties.S3Uri) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataQualityJobDefinition_CsvPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("header", cdk.validateBoolean)(properties.header)), errors.wrap('supplied properties not correct for "CsvProperty"');
    }
    function cfnDataQualityJobDefinitionCsvPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataQualityJobDefinition_CsvPropertyValidator(properties).assertSuccess(), { Header: cdk.booleanToCloudFormation(properties.header) }) : properties;
    }
    function CfnDataQualityJobDefinitionCsvPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("header", "Header", properties.Header != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Header) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataQualityJobDefinition_DataQualityAppSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containerArguments", cdk.listValidator(cdk.validateString))(properties.containerArguments)), errors.collect(cdk.propertyValidator("containerEntrypoint", cdk.listValidator(cdk.validateString))(properties.containerEntrypoint)), errors.collect(cdk.propertyValidator("environment", cdk.hashValidator(cdk.validateString))(properties.environment)), errors.collect(cdk.propertyValidator("imageUri", cdk.requiredValidator)(properties.imageUri)), errors.collect(cdk.propertyValidator("imageUri", cdk.validateString)(properties.imageUri)), errors.collect(cdk.propertyValidator("postAnalyticsProcessorSourceUri", cdk.validateString)(properties.postAnalyticsProcessorSourceUri)), errors.collect(cdk.propertyValidator("recordPreprocessorSourceUri", cdk.validateString)(properties.recordPreprocessorSourceUri)), errors.wrap('supplied properties not correct for "DataQualityAppSpecificationProperty"');
    }
    function cfnDataQualityJobDefinitionDataQualityAppSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataQualityJobDefinition_DataQualityAppSpecificationPropertyValidator(properties).assertSuccess(), { ContainerArguments: cdk.listMapper(cdk.stringToCloudFormation)(properties.containerArguments), ContainerEntrypoint: cdk.listMapper(cdk.stringToCloudFormation)(properties.containerEntrypoint), Environment: cdk.hashMapper(cdk.stringToCloudFormation)(properties.environment), ImageUri: cdk.stringToCloudFormation(properties.imageUri), PostAnalyticsProcessorSourceUri: cdk.stringToCloudFormation(properties.postAnalyticsProcessorSourceUri), RecordPreprocessorSourceUri: cdk.stringToCloudFormation(properties.recordPreprocessorSourceUri) }) : properties;
    }
    function CfnDataQualityJobDefinitionDataQualityAppSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containerArguments", "ContainerArguments", properties.ContainerArguments != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ContainerArguments) : void 0), ret.addPropertyResult("containerEntrypoint", "ContainerEntrypoint", properties.ContainerEntrypoint != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ContainerEntrypoint) : void 0), ret.addPropertyResult("environment", "Environment", properties.Environment != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Environment) : void 0), ret.addPropertyResult("imageUri", "ImageUri", cfn_parse.FromCloudFormation.getString(properties.ImageUri)), ret.addPropertyResult("postAnalyticsProcessorSourceUri", "PostAnalyticsProcessorSourceUri", properties.PostAnalyticsProcessorSourceUri != null ? cfn_parse.FromCloudFormation.getString(properties.PostAnalyticsProcessorSourceUri) : void 0), ret.addPropertyResult("recordPreprocessorSourceUri", "RecordPreprocessorSourceUri", properties.RecordPreprocessorSourceUri != null ? cfn_parse.FromCloudFormation.getString(properties.RecordPreprocessorSourceUri) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataQualityJobDefinition_DataQualityBaselineConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("baseliningJobName", cdk.validateString)(properties.baseliningJobName)), errors.collect(cdk.propertyValidator("constraintsResource", CfnDataQualityJobDefinition_ConstraintsResourcePropertyValidator)(properties.constraintsResource)), errors.collect(cdk.propertyValidator("statisticsResource", CfnDataQualityJobDefinition_StatisticsResourcePropertyValidator)(properties.statisticsResource)), errors.wrap('supplied properties not correct for "DataQualityBaselineConfigProperty"');
    }
    function cfnDataQualityJobDefinitionDataQualityBaselineConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataQualityJobDefinition_DataQualityBaselineConfigPropertyValidator(properties).assertSuccess(), { BaseliningJobName: cdk.stringToCloudFormation(properties.baseliningJobName), ConstraintsResource: cfnDataQualityJobDefinitionConstraintsResourcePropertyToCloudFormation(properties.constraintsResource), StatisticsResource: cfnDataQualityJobDefinitionStatisticsResourcePropertyToCloudFormation(properties.statisticsResource) }) : properties;
    }
    function CfnDataQualityJobDefinitionDataQualityBaselineConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("baseliningJobName", "BaseliningJobName", properties.BaseliningJobName != null ? cfn_parse.FromCloudFormation.getString(properties.BaseliningJobName) : void 0), ret.addPropertyResult("constraintsResource", "ConstraintsResource", properties.ConstraintsResource != null ? CfnDataQualityJobDefinitionConstraintsResourcePropertyFromCloudFormation(properties.ConstraintsResource) : void 0), ret.addPropertyResult("statisticsResource", "StatisticsResource", properties.StatisticsResource != null ? CfnDataQualityJobDefinitionStatisticsResourcePropertyFromCloudFormation(properties.StatisticsResource) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataQualityJobDefinition_DataQualityJobInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("batchTransformInput", CfnDataQualityJobDefinition_BatchTransformInputPropertyValidator)(properties.batchTransformInput)), errors.collect(cdk.propertyValidator("endpointInput", CfnDataQualityJobDefinition_EndpointInputPropertyValidator)(properties.endpointInput)), errors.wrap('supplied properties not correct for "DataQualityJobInputProperty"');
    }
    function cfnDataQualityJobDefinitionDataQualityJobInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataQualityJobDefinition_DataQualityJobInputPropertyValidator(properties).assertSuccess(), { BatchTransformInput: cfnDataQualityJobDefinitionBatchTransformInputPropertyToCloudFormation(properties.batchTransformInput), EndpointInput: cfnDataQualityJobDefinitionEndpointInputPropertyToCloudFormation(properties.endpointInput) }) : properties;
    }
    function CfnDataQualityJobDefinitionDataQualityJobInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("batchTransformInput", "BatchTransformInput", properties.BatchTransformInput != null ? CfnDataQualityJobDefinitionBatchTransformInputPropertyFromCloudFormation(properties.BatchTransformInput) : void 0), ret.addPropertyResult("endpointInput", "EndpointInput", properties.EndpointInput != null ? CfnDataQualityJobDefinitionEndpointInputPropertyFromCloudFormation(properties.EndpointInput) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataQualityJobDefinition_DatasetFormatPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("csv", CfnDataQualityJobDefinition_CsvPropertyValidator)(properties.csv)), errors.collect(cdk.propertyValidator("json", CfnDataQualityJobDefinition_JsonPropertyValidator)(properties.json)), errors.collect(cdk.propertyValidator("parquet", cdk.validateBoolean)(properties.parquet)), errors.wrap('supplied properties not correct for "DatasetFormatProperty"');
    }
    function cfnDataQualityJobDefinitionDatasetFormatPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataQualityJobDefinition_DatasetFormatPropertyValidator(properties).assertSuccess(), { Csv: cfnDataQualityJobDefinitionCsvPropertyToCloudFormation(properties.csv), Json: cfnDataQualityJobDefinitionJsonPropertyToCloudFormation(properties.json), Parquet: cdk.booleanToCloudFormation(properties.parquet) }) : properties;
    }
    function CfnDataQualityJobDefinitionDatasetFormatPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("csv", "Csv", properties.Csv != null ? CfnDataQualityJobDefinitionCsvPropertyFromCloudFormation(properties.Csv) : void 0), ret.addPropertyResult("json", "Json", properties.Json != null ? CfnDataQualityJobDefinitionJsonPropertyFromCloudFormation(properties.Json) : void 0), ret.addPropertyResult("parquet", "Parquet", properties.Parquet != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Parquet) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataQualityJobDefinition_EndpointInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endpointName", cdk.requiredValidator)(properties.endpointName)), errors.collect(cdk.propertyValidator("endpointName", cdk.validateString)(properties.endpointName)), errors.collect(cdk.propertyValidator("localPath", cdk.requiredValidator)(properties.localPath)), errors.collect(cdk.propertyValidator("localPath", cdk.validateString)(properties.localPath)), errors.collect(cdk.propertyValidator("s3DataDistributionType", cdk.validateString)(properties.s3DataDistributionType)), errors.collect(cdk.propertyValidator("s3InputMode", cdk.validateString)(properties.s3InputMode)), errors.wrap('supplied properties not correct for "EndpointInputProperty"');
    }
    function cfnDataQualityJobDefinitionEndpointInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataQualityJobDefinition_EndpointInputPropertyValidator(properties).assertSuccess(), { EndpointName: cdk.stringToCloudFormation(properties.endpointName), LocalPath: cdk.stringToCloudFormation(properties.localPath), S3DataDistributionType: cdk.stringToCloudFormation(properties.s3DataDistributionType), S3InputMode: cdk.stringToCloudFormation(properties.s3InputMode) }) : properties;
    }
    function CfnDataQualityJobDefinitionEndpointInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endpointName", "EndpointName", cfn_parse.FromCloudFormation.getString(properties.EndpointName)), ret.addPropertyResult("localPath", "LocalPath", cfn_parse.FromCloudFormation.getString(properties.LocalPath)), ret.addPropertyResult("s3DataDistributionType", "S3DataDistributionType", properties.S3DataDistributionType != null ? cfn_parse.FromCloudFormation.getString(properties.S3DataDistributionType) : void 0), ret.addPropertyResult("s3InputMode", "S3InputMode", properties.S3InputMode != null ? cfn_parse.FromCloudFormation.getString(properties.S3InputMode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataQualityJobDefinition_JsonPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("line", cdk.validateBoolean)(properties.line)), errors.wrap('supplied properties not correct for "JsonProperty"');
    }
    function cfnDataQualityJobDefinitionJsonPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataQualityJobDefinition_JsonPropertyValidator(properties).assertSuccess(), { Line: cdk.booleanToCloudFormation(properties.line) }) : properties;
    }
    function CfnDataQualityJobDefinitionJsonPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("line", "Line", properties.Line != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Line) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataQualityJobDefinition_MonitoringOutputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3Output", cdk.requiredValidator)(properties.s3Output)), errors.collect(cdk.propertyValidator("s3Output", CfnDataQualityJobDefinition_S3OutputPropertyValidator)(properties.s3Output)), errors.wrap('supplied properties not correct for "MonitoringOutputProperty"');
    }
    function cfnDataQualityJobDefinitionMonitoringOutputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataQualityJobDefinition_MonitoringOutputPropertyValidator(properties).assertSuccess(), { S3Output: cfnDataQualityJobDefinitionS3OutputPropertyToCloudFormation(properties.s3Output) }) : properties;
    }
    function CfnDataQualityJobDefinitionMonitoringOutputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Output", "S3Output", CfnDataQualityJobDefinitionS3OutputPropertyFromCloudFormation(properties.S3Output)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataQualityJobDefinition_MonitoringOutputConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("monitoringOutputs", cdk.requiredValidator)(properties.monitoringOutputs)), errors.collect(cdk.propertyValidator("monitoringOutputs", cdk.listValidator(CfnDataQualityJobDefinition_MonitoringOutputPropertyValidator))(properties.monitoringOutputs)), errors.wrap('supplied properties not correct for "MonitoringOutputConfigProperty"');
    }
    function cfnDataQualityJobDefinitionMonitoringOutputConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataQualityJobDefinition_MonitoringOutputConfigPropertyValidator(properties).assertSuccess(), { KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), MonitoringOutputs: cdk.listMapper(cfnDataQualityJobDefinitionMonitoringOutputPropertyToCloudFormation)(properties.monitoringOutputs) }) : properties;
    }
    function CfnDataQualityJobDefinitionMonitoringOutputConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("monitoringOutputs", "MonitoringOutputs", cfn_parse.FromCloudFormation.getArray(CfnDataQualityJobDefinitionMonitoringOutputPropertyFromCloudFormation)(properties.MonitoringOutputs)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataQualityJobDefinition_MonitoringResourcesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clusterConfig", cdk.requiredValidator)(properties.clusterConfig)), errors.collect(cdk.propertyValidator("clusterConfig", CfnDataQualityJobDefinition_ClusterConfigPropertyValidator)(properties.clusterConfig)), errors.wrap('supplied properties not correct for "MonitoringResourcesProperty"');
    }
    function cfnDataQualityJobDefinitionMonitoringResourcesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataQualityJobDefinition_MonitoringResourcesPropertyValidator(properties).assertSuccess(), { ClusterConfig: cfnDataQualityJobDefinitionClusterConfigPropertyToCloudFormation(properties.clusterConfig) }) : properties;
    }
    function CfnDataQualityJobDefinitionMonitoringResourcesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clusterConfig", "ClusterConfig", CfnDataQualityJobDefinitionClusterConfigPropertyFromCloudFormation(properties.ClusterConfig)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataQualityJobDefinition_NetworkConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enableInterContainerTrafficEncryption", cdk.validateBoolean)(properties.enableInterContainerTrafficEncryption)), errors.collect(cdk.propertyValidator("enableNetworkIsolation", cdk.validateBoolean)(properties.enableNetworkIsolation)), errors.collect(cdk.propertyValidator("vpcConfig", CfnDataQualityJobDefinition_VpcConfigPropertyValidator)(properties.vpcConfig)), errors.wrap('supplied properties not correct for "NetworkConfigProperty"');
    }
    function cfnDataQualityJobDefinitionNetworkConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataQualityJobDefinition_NetworkConfigPropertyValidator(properties).assertSuccess(), { EnableInterContainerTrafficEncryption: cdk.booleanToCloudFormation(properties.enableInterContainerTrafficEncryption), EnableNetworkIsolation: cdk.booleanToCloudFormation(properties.enableNetworkIsolation), VpcConfig: cfnDataQualityJobDefinitionVpcConfigPropertyToCloudFormation(properties.vpcConfig) }) : properties;
    }
    function CfnDataQualityJobDefinitionNetworkConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enableInterContainerTrafficEncryption", "EnableInterContainerTrafficEncryption", properties.EnableInterContainerTrafficEncryption != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableInterContainerTrafficEncryption) : void 0), ret.addPropertyResult("enableNetworkIsolation", "EnableNetworkIsolation", properties.EnableNetworkIsolation != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableNetworkIsolation) : void 0), ret.addPropertyResult("vpcConfig", "VpcConfig", properties.VpcConfig != null ? CfnDataQualityJobDefinitionVpcConfigPropertyFromCloudFormation(properties.VpcConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataQualityJobDefinition_S3OutputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("localPath", cdk.requiredValidator)(properties.localPath)), errors.collect(cdk.propertyValidator("localPath", cdk.validateString)(properties.localPath)), errors.collect(cdk.propertyValidator("s3UploadMode", cdk.validateString)(properties.s3UploadMode)), errors.collect(cdk.propertyValidator("s3Uri", cdk.requiredValidator)(properties.s3Uri)), errors.collect(cdk.propertyValidator("s3Uri", cdk.validateString)(properties.s3Uri)), errors.wrap('supplied properties not correct for "S3OutputProperty"');
    }
    function cfnDataQualityJobDefinitionS3OutputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataQualityJobDefinition_S3OutputPropertyValidator(properties).assertSuccess(), { LocalPath: cdk.stringToCloudFormation(properties.localPath), S3UploadMode: cdk.stringToCloudFormation(properties.s3UploadMode), S3Uri: cdk.stringToCloudFormation(properties.s3Uri) }) : properties;
    }
    function CfnDataQualityJobDefinitionS3OutputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("localPath", "LocalPath", cfn_parse.FromCloudFormation.getString(properties.LocalPath)), ret.addPropertyResult("s3UploadMode", "S3UploadMode", properties.S3UploadMode != null ? cfn_parse.FromCloudFormation.getString(properties.S3UploadMode) : void 0), ret.addPropertyResult("s3Uri", "S3Uri", cfn_parse.FromCloudFormation.getString(properties.S3Uri)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataQualityJobDefinition_StatisticsResourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3Uri", cdk.validateString)(properties.s3Uri)), errors.wrap('supplied properties not correct for "StatisticsResourceProperty"');
    }
    function cfnDataQualityJobDefinitionStatisticsResourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataQualityJobDefinition_StatisticsResourcePropertyValidator(properties).assertSuccess(), { S3Uri: cdk.stringToCloudFormation(properties.s3Uri) }) : properties;
    }
    function CfnDataQualityJobDefinitionStatisticsResourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Uri", "S3Uri", properties.S3Uri != null ? cfn_parse.FromCloudFormation.getString(properties.S3Uri) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataQualityJobDefinition_StoppingConditionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxRuntimeInSeconds", cdk.requiredValidator)(properties.maxRuntimeInSeconds)), errors.collect(cdk.propertyValidator("maxRuntimeInSeconds", cdk.validateNumber)(properties.maxRuntimeInSeconds)), errors.wrap('supplied properties not correct for "StoppingConditionProperty"');
    }
    function cfnDataQualityJobDefinitionStoppingConditionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataQualityJobDefinition_StoppingConditionPropertyValidator(properties).assertSuccess(), { MaxRuntimeInSeconds: cdk.numberToCloudFormation(properties.maxRuntimeInSeconds) }) : properties;
    }
    function CfnDataQualityJobDefinitionStoppingConditionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxRuntimeInSeconds", "MaxRuntimeInSeconds", cfn_parse.FromCloudFormation.getNumber(properties.MaxRuntimeInSeconds)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDataQualityJobDefinition_VpcConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.requiredValidator)(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnets", cdk.requiredValidator)(properties.subnets)), errors.collect(cdk.propertyValidator("subnets", cdk.listValidator(cdk.validateString))(properties.subnets)), errors.wrap('supplied properties not correct for "VpcConfigProperty"');
    }
    function cfnDataQualityJobDefinitionVpcConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDataQualityJobDefinition_VpcConfigPropertyValidator(properties).assertSuccess(), { SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), Subnets: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnets) }) : properties;
    }
    function CfnDataQualityJobDefinitionVpcConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds)), ret.addPropertyResult("subnets", "Subnets", cfn_parse.FromCloudFormation.getStringArray(properties.Subnets)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDevicePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("device", CfnDevice_DevicePropertyValidator)(properties.device)), errors.collect(cdk.propertyValidator("deviceFleetName", cdk.requiredValidator)(properties.deviceFleetName)), errors.collect(cdk.propertyValidator("deviceFleetName", cdk.validateString)(properties.deviceFleetName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDeviceProps"');
    }
    function cfnDevicePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDevicePropsValidator(properties).assertSuccess(), { DeviceFleetName: cdk.stringToCloudFormation(properties.deviceFleetName), Device: cfnDeviceDevicePropertyToCloudFormation(properties.device), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDevicePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deviceFleetName", "DeviceFleetName", cfn_parse.FromCloudFormation.getString(properties.DeviceFleetName)), ret.addPropertyResult("device", "Device", properties.Device != null ? CfnDeviceDevicePropertyFromCloudFormation(properties.Device) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDevice = class _CfnDevice extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDevicePropsFromCloudFormation(resourceProperties), ret = new _CfnDevice(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDevice.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sagemaker_CfnDeviceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDevice), error;
        }
        cdk.requireProperty(props, "deviceFleetName", this), this.deviceFleetName = props.deviceFleetName, this.device = props.device, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SageMaker::Device", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDevice.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { deviceFleetName: this.deviceFleetName, device: this.device, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDevicePropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnDevice[_e] = { fqn: "aws-cdk-lib.aws_sagemaker.CfnDevice", version: "2.80.0" }, CfnDevice.CFN_RESOURCE_TYPE_NAME = "AWS::SageMaker::Device", exports2.CfnDevice = CfnDevice;
    function CfnDevice_DevicePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("deviceName", cdk.requiredValidator)(properties.deviceName)), errors.collect(cdk.propertyValidator("deviceName", cdk.validateString)(properties.deviceName)), errors.collect(cdk.propertyValidator("iotThingName", cdk.validateString)(properties.iotThingName)), errors.wrap('supplied properties not correct for "DeviceProperty"');
    }
    function cfnDeviceDevicePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDevice_DevicePropertyValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), DeviceName: cdk.stringToCloudFormation(properties.deviceName), IotThingName: cdk.stringToCloudFormation(properties.iotThingName) }) : properties;
    }
    function CfnDeviceDevicePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("deviceName", "DeviceName", cfn_parse.FromCloudFormation.getString(properties.DeviceName)), ret.addPropertyResult("iotThingName", "IotThingName", properties.IotThingName != null ? cfn_parse.FromCloudFormation.getString(properties.IotThingName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDeviceFleetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("deviceFleetName", cdk.requiredValidator)(properties.deviceFleetName)), errors.collect(cdk.propertyValidator("deviceFleetName", cdk.validateString)(properties.deviceFleetName)), errors.collect(cdk.propertyValidator("outputConfig", cdk.requiredValidator)(properties.outputConfig)), errors.collect(cdk.propertyValidator("outputConfig", CfnDeviceFleet_EdgeOutputConfigPropertyValidator)(properties.outputConfig)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDeviceFleetProps"');
    }
    function cfnDeviceFleetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeviceFleetPropsValidator(properties).assertSuccess(), { DeviceFleetName: cdk.stringToCloudFormation(properties.deviceFleetName), OutputConfig: cfnDeviceFleetEdgeOutputConfigPropertyToCloudFormation(properties.outputConfig), RoleArn: cdk.stringToCloudFormation(properties.roleArn), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDeviceFleetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deviceFleetName", "DeviceFleetName", cfn_parse.FromCloudFormation.getString(properties.DeviceFleetName)), ret.addPropertyResult("outputConfig", "OutputConfig", CfnDeviceFleetEdgeOutputConfigPropertyFromCloudFormation(properties.OutputConfig)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDeviceFleet = class _CfnDeviceFleet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDeviceFleetPropsFromCloudFormation(resourceProperties), ret = new _CfnDeviceFleet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDeviceFleet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sagemaker_CfnDeviceFleetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDeviceFleet), error;
        }
        cdk.requireProperty(props, "deviceFleetName", this), cdk.requireProperty(props, "outputConfig", this), cdk.requireProperty(props, "roleArn", this), this.deviceFleetName = props.deviceFleetName, this.outputConfig = props.outputConfig, this.roleArn = props.roleArn, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SageMaker::DeviceFleet", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDeviceFleet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { deviceFleetName: this.deviceFleetName, outputConfig: this.outputConfig, roleArn: this.roleArn, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDeviceFleetPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnDeviceFleet[_f] = { fqn: "aws-cdk-lib.aws_sagemaker.CfnDeviceFleet", version: "2.80.0" }, CfnDeviceFleet.CFN_RESOURCE_TYPE_NAME = "AWS::SageMaker::DeviceFleet", exports2.CfnDeviceFleet = CfnDeviceFleet;
    function CfnDeviceFleet_EdgeOutputConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("s3OutputLocation", cdk.requiredValidator)(properties.s3OutputLocation)), errors.collect(cdk.propertyValidator("s3OutputLocation", cdk.validateString)(properties.s3OutputLocation)), errors.wrap('supplied properties not correct for "EdgeOutputConfigProperty"');
    }
    function cfnDeviceFleetEdgeOutputConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDeviceFleet_EdgeOutputConfigPropertyValidator(properties).assertSuccess(), { KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), S3OutputLocation: cdk.stringToCloudFormation(properties.s3OutputLocation) }) : properties;
    }
    function CfnDeviceFleetEdgeOutputConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("s3OutputLocation", "S3OutputLocation", cfn_parse.FromCloudFormation.getString(properties.S3OutputLocation)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomainPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("appNetworkAccessType", cdk.validateString)(properties.appNetworkAccessType)), errors.collect(cdk.propertyValidator("appSecurityGroupManagement", cdk.validateString)(properties.appSecurityGroupManagement)), errors.collect(cdk.propertyValidator("authMode", cdk.requiredValidator)(properties.authMode)), errors.collect(cdk.propertyValidator("authMode", cdk.validateString)(properties.authMode)), errors.collect(cdk.propertyValidator("defaultSpaceSettings", CfnDomain_DefaultSpaceSettingsPropertyValidator)(properties.defaultSpaceSettings)), errors.collect(cdk.propertyValidator("defaultUserSettings", cdk.requiredValidator)(properties.defaultUserSettings)), errors.collect(cdk.propertyValidator("defaultUserSettings", CfnDomain_UserSettingsPropertyValidator)(properties.defaultUserSettings)), errors.collect(cdk.propertyValidator("domainName", cdk.requiredValidator)(properties.domainName)), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.collect(cdk.propertyValidator("domainSettings", CfnDomain_DomainSettingsPropertyValidator)(properties.domainSettings)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("subnetIds", cdk.requiredValidator)(properties.subnetIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpcId", cdk.requiredValidator)(properties.vpcId)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "CfnDomainProps"');
    }
    function cfnDomainPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomainPropsValidator(properties).assertSuccess(), { AuthMode: cdk.stringToCloudFormation(properties.authMode), DefaultUserSettings: cfnDomainUserSettingsPropertyToCloudFormation(properties.defaultUserSettings), DomainName: cdk.stringToCloudFormation(properties.domainName), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds), VpcId: cdk.stringToCloudFormation(properties.vpcId), AppNetworkAccessType: cdk.stringToCloudFormation(properties.appNetworkAccessType), AppSecurityGroupManagement: cdk.stringToCloudFormation(properties.appSecurityGroupManagement), DefaultSpaceSettings: cfnDomainDefaultSpaceSettingsPropertyToCloudFormation(properties.defaultSpaceSettings), DomainSettings: cfnDomainDomainSettingsPropertyToCloudFormation(properties.domainSettings), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDomainPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authMode", "AuthMode", cfn_parse.FromCloudFormation.getString(properties.AuthMode)), ret.addPropertyResult("defaultUserSettings", "DefaultUserSettings", CfnDomainUserSettingsPropertyFromCloudFormation(properties.DefaultUserSettings)), ret.addPropertyResult("domainName", "DomainName", cfn_parse.FromCloudFormation.getString(properties.DomainName)), ret.addPropertyResult("subnetIds", "SubnetIds", cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds)), ret.addPropertyResult("vpcId", "VpcId", cfn_parse.FromCloudFormation.getString(properties.VpcId)), ret.addPropertyResult("appNetworkAccessType", "AppNetworkAccessType", properties.AppNetworkAccessType != null ? cfn_parse.FromCloudFormation.getString(properties.AppNetworkAccessType) : void 0), ret.addPropertyResult("appSecurityGroupManagement", "AppSecurityGroupManagement", properties.AppSecurityGroupManagement != null ? cfn_parse.FromCloudFormation.getString(properties.AppSecurityGroupManagement) : void 0), ret.addPropertyResult("defaultSpaceSettings", "DefaultSpaceSettings", properties.DefaultSpaceSettings != null ? CfnDomainDefaultSpaceSettingsPropertyFromCloudFormation(properties.DefaultSpaceSettings) : void 0), ret.addPropertyResult("domainSettings", "DomainSettings", properties.DomainSettings != null ? CfnDomainDomainSettingsPropertyFromCloudFormation(properties.DomainSettings) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDomain = class _CfnDomain extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDomainPropsFromCloudFormation(resourceProperties), ret = new _CfnDomain(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDomain.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sagemaker_CfnDomainProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDomain), error;
        }
        cdk.requireProperty(props, "authMode", this), cdk.requireProperty(props, "defaultUserSettings", this), cdk.requireProperty(props, "domainName", this), cdk.requireProperty(props, "subnetIds", this), cdk.requireProperty(props, "vpcId", this), this.attrDomainArn = cdk.Token.asString(this.getAtt("DomainArn", cdk.ResolutionTypeHint.STRING)), this.attrDomainId = cdk.Token.asString(this.getAtt("DomainId", cdk.ResolutionTypeHint.STRING)), this.attrHomeEfsFileSystemId = cdk.Token.asString(this.getAtt("HomeEfsFileSystemId", cdk.ResolutionTypeHint.STRING)), this.attrSecurityGroupIdForDomainBoundary = cdk.Token.asString(this.getAtt("SecurityGroupIdForDomainBoundary", cdk.ResolutionTypeHint.STRING)), this.attrSingleSignOnManagedApplicationInstanceId = cdk.Token.asString(this.getAtt("SingleSignOnManagedApplicationInstanceId", cdk.ResolutionTypeHint.STRING)), this.attrUrl = cdk.Token.asString(this.getAtt("Url", cdk.ResolutionTypeHint.STRING)), this.authMode = props.authMode, this.defaultUserSettings = props.defaultUserSettings, this.domainName = props.domainName, this.subnetIds = props.subnetIds, this.vpcId = props.vpcId, this.appNetworkAccessType = props.appNetworkAccessType, this.appSecurityGroupManagement = props.appSecurityGroupManagement, this.defaultSpaceSettings = props.defaultSpaceSettings, this.domainSettings = props.domainSettings, this.kmsKeyId = props.kmsKeyId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SageMaker::Domain", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDomain.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { authMode: this.authMode, defaultUserSettings: this.defaultUserSettings, domainName: this.domainName, subnetIds: this.subnetIds, vpcId: this.vpcId, appNetworkAccessType: this.appNetworkAccessType, appSecurityGroupManagement: this.appSecurityGroupManagement, defaultSpaceSettings: this.defaultSpaceSettings, domainSettings: this.domainSettings, kmsKeyId: this.kmsKeyId, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDomainPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnDomain[_g] = { fqn: "aws-cdk-lib.aws_sagemaker.CfnDomain", version: "2.80.0" }, CfnDomain.CFN_RESOURCE_TYPE_NAME = "AWS::SageMaker::Domain", exports2.CfnDomain = CfnDomain;
    function CfnDomain_CustomImagePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("appImageConfigName", cdk.requiredValidator)(properties.appImageConfigName)), errors.collect(cdk.propertyValidator("appImageConfigName", cdk.validateString)(properties.appImageConfigName)), errors.collect(cdk.propertyValidator("imageName", cdk.requiredValidator)(properties.imageName)), errors.collect(cdk.propertyValidator("imageName", cdk.validateString)(properties.imageName)), errors.collect(cdk.propertyValidator("imageVersionNumber", cdk.validateNumber)(properties.imageVersionNumber)), errors.wrap('supplied properties not correct for "CustomImageProperty"');
    }
    function cfnDomainCustomImagePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_CustomImagePropertyValidator(properties).assertSuccess(), { AppImageConfigName: cdk.stringToCloudFormation(properties.appImageConfigName), ImageName: cdk.stringToCloudFormation(properties.imageName), ImageVersionNumber: cdk.numberToCloudFormation(properties.imageVersionNumber) }) : properties;
    }
    function CfnDomainCustomImagePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("appImageConfigName", "AppImageConfigName", cfn_parse.FromCloudFormation.getString(properties.AppImageConfigName)), ret.addPropertyResult("imageName", "ImageName", cfn_parse.FromCloudFormation.getString(properties.ImageName)), ret.addPropertyResult("imageVersionNumber", "ImageVersionNumber", properties.ImageVersionNumber != null ? cfn_parse.FromCloudFormation.getNumber(properties.ImageVersionNumber) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_DefaultSpaceSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("executionRole", cdk.requiredValidator)(properties.executionRole)), errors.collect(cdk.propertyValidator("executionRole", cdk.validateString)(properties.executionRole)), errors.collect(cdk.propertyValidator("jupyterServerAppSettings", CfnDomain_JupyterServerAppSettingsPropertyValidator)(properties.jupyterServerAppSettings)), errors.collect(cdk.propertyValidator("kernelGatewayAppSettings", CfnDomain_KernelGatewayAppSettingsPropertyValidator)(properties.kernelGatewayAppSettings)), errors.collect(cdk.propertyValidator("securityGroups", cdk.listValidator(cdk.validateString))(properties.securityGroups)), errors.wrap('supplied properties not correct for "DefaultSpaceSettingsProperty"');
    }
    function cfnDomainDefaultSpaceSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_DefaultSpaceSettingsPropertyValidator(properties).assertSuccess(), { ExecutionRole: cdk.stringToCloudFormation(properties.executionRole), JupyterServerAppSettings: cfnDomainJupyterServerAppSettingsPropertyToCloudFormation(properties.jupyterServerAppSettings), KernelGatewayAppSettings: cfnDomainKernelGatewayAppSettingsPropertyToCloudFormation(properties.kernelGatewayAppSettings), SecurityGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroups) }) : properties;
    }
    function CfnDomainDefaultSpaceSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("executionRole", "ExecutionRole", cfn_parse.FromCloudFormation.getString(properties.ExecutionRole)), ret.addPropertyResult("jupyterServerAppSettings", "JupyterServerAppSettings", properties.JupyterServerAppSettings != null ? CfnDomainJupyterServerAppSettingsPropertyFromCloudFormation(properties.JupyterServerAppSettings) : void 0), ret.addPropertyResult("kernelGatewayAppSettings", "KernelGatewayAppSettings", properties.KernelGatewayAppSettings != null ? CfnDomainKernelGatewayAppSettingsPropertyFromCloudFormation(properties.KernelGatewayAppSettings) : void 0), ret.addPropertyResult("securityGroups", "SecurityGroups", properties.SecurityGroups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroups) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_DomainSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("rStudioServerProDomainSettings", CfnDomain_RStudioServerProDomainSettingsPropertyValidator)(properties.rStudioServerProDomainSettings)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.wrap('supplied properties not correct for "DomainSettingsProperty"');
    }
    function cfnDomainDomainSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_DomainSettingsPropertyValidator(properties).assertSuccess(), { RStudioServerProDomainSettings: cfnDomainRStudioServerProDomainSettingsPropertyToCloudFormation(properties.rStudioServerProDomainSettings), SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds) }) : properties;
    }
    function CfnDomainDomainSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("rStudioServerProDomainSettings", "RStudioServerProDomainSettings", properties.RStudioServerProDomainSettings != null ? CfnDomainRStudioServerProDomainSettingsPropertyFromCloudFormation(properties.RStudioServerProDomainSettings) : void 0), ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_JupyterServerAppSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultResourceSpec", CfnDomain_ResourceSpecPropertyValidator)(properties.defaultResourceSpec)), errors.wrap('supplied properties not correct for "JupyterServerAppSettingsProperty"');
    }
    function cfnDomainJupyterServerAppSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_JupyterServerAppSettingsPropertyValidator(properties).assertSuccess(), { DefaultResourceSpec: cfnDomainResourceSpecPropertyToCloudFormation(properties.defaultResourceSpec) }) : properties;
    }
    function CfnDomainJupyterServerAppSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultResourceSpec", "DefaultResourceSpec", properties.DefaultResourceSpec != null ? CfnDomainResourceSpecPropertyFromCloudFormation(properties.DefaultResourceSpec) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_KernelGatewayAppSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customImages", cdk.listValidator(CfnDomain_CustomImagePropertyValidator))(properties.customImages)), errors.collect(cdk.propertyValidator("defaultResourceSpec", CfnDomain_ResourceSpecPropertyValidator)(properties.defaultResourceSpec)), errors.wrap('supplied properties not correct for "KernelGatewayAppSettingsProperty"');
    }
    function cfnDomainKernelGatewayAppSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_KernelGatewayAppSettingsPropertyValidator(properties).assertSuccess(), { CustomImages: cdk.listMapper(cfnDomainCustomImagePropertyToCloudFormation)(properties.customImages), DefaultResourceSpec: cfnDomainResourceSpecPropertyToCloudFormation(properties.defaultResourceSpec) }) : properties;
    }
    function CfnDomainKernelGatewayAppSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customImages", "CustomImages", properties.CustomImages != null ? cfn_parse.FromCloudFormation.getArray(CfnDomainCustomImagePropertyFromCloudFormation)(properties.CustomImages) : void 0), ret.addPropertyResult("defaultResourceSpec", "DefaultResourceSpec", properties.DefaultResourceSpec != null ? CfnDomainResourceSpecPropertyFromCloudFormation(properties.DefaultResourceSpec) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_RSessionAppSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customImages", cdk.listValidator(CfnDomain_CustomImagePropertyValidator))(properties.customImages)), errors.collect(cdk.propertyValidator("defaultResourceSpec", CfnDomain_ResourceSpecPropertyValidator)(properties.defaultResourceSpec)), errors.wrap('supplied properties not correct for "RSessionAppSettingsProperty"');
    }
    function cfnDomainRSessionAppSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_RSessionAppSettingsPropertyValidator(properties).assertSuccess(), { CustomImages: cdk.listMapper(cfnDomainCustomImagePropertyToCloudFormation)(properties.customImages), DefaultResourceSpec: cfnDomainResourceSpecPropertyToCloudFormation(properties.defaultResourceSpec) }) : properties;
    }
    function CfnDomainRSessionAppSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customImages", "CustomImages", properties.CustomImages != null ? cfn_parse.FromCloudFormation.getArray(CfnDomainCustomImagePropertyFromCloudFormation)(properties.CustomImages) : void 0), ret.addPropertyResult("defaultResourceSpec", "DefaultResourceSpec", properties.DefaultResourceSpec != null ? CfnDomainResourceSpecPropertyFromCloudFormation(properties.DefaultResourceSpec) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_RStudioServerProAppSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessStatus", cdk.validateString)(properties.accessStatus)), errors.collect(cdk.propertyValidator("userGroup", cdk.validateString)(properties.userGroup)), errors.wrap('supplied properties not correct for "RStudioServerProAppSettingsProperty"');
    }
    function cfnDomainRStudioServerProAppSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_RStudioServerProAppSettingsPropertyValidator(properties).assertSuccess(), { AccessStatus: cdk.stringToCloudFormation(properties.accessStatus), UserGroup: cdk.stringToCloudFormation(properties.userGroup) }) : properties;
    }
    function CfnDomainRStudioServerProAppSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessStatus", "AccessStatus", properties.AccessStatus != null ? cfn_parse.FromCloudFormation.getString(properties.AccessStatus) : void 0), ret.addPropertyResult("userGroup", "UserGroup", properties.UserGroup != null ? cfn_parse.FromCloudFormation.getString(properties.UserGroup) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_RStudioServerProDomainSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultResourceSpec", CfnDomain_ResourceSpecPropertyValidator)(properties.defaultResourceSpec)), errors.collect(cdk.propertyValidator("domainExecutionRoleArn", cdk.requiredValidator)(properties.domainExecutionRoleArn)), errors.collect(cdk.propertyValidator("domainExecutionRoleArn", cdk.validateString)(properties.domainExecutionRoleArn)), errors.collect(cdk.propertyValidator("rStudioConnectUrl", cdk.validateString)(properties.rStudioConnectUrl)), errors.collect(cdk.propertyValidator("rStudioPackageManagerUrl", cdk.validateString)(properties.rStudioPackageManagerUrl)), errors.wrap('supplied properties not correct for "RStudioServerProDomainSettingsProperty"');
    }
    function cfnDomainRStudioServerProDomainSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_RStudioServerProDomainSettingsPropertyValidator(properties).assertSuccess(), { DefaultResourceSpec: cfnDomainResourceSpecPropertyToCloudFormation(properties.defaultResourceSpec), DomainExecutionRoleArn: cdk.stringToCloudFormation(properties.domainExecutionRoleArn), RStudioConnectUrl: cdk.stringToCloudFormation(properties.rStudioConnectUrl), RStudioPackageManagerUrl: cdk.stringToCloudFormation(properties.rStudioPackageManagerUrl) }) : properties;
    }
    function CfnDomainRStudioServerProDomainSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultResourceSpec", "DefaultResourceSpec", properties.DefaultResourceSpec != null ? CfnDomainResourceSpecPropertyFromCloudFormation(properties.DefaultResourceSpec) : void 0), ret.addPropertyResult("domainExecutionRoleArn", "DomainExecutionRoleArn", cfn_parse.FromCloudFormation.getString(properties.DomainExecutionRoleArn)), ret.addPropertyResult("rStudioConnectUrl", "RStudioConnectUrl", properties.RStudioConnectUrl != null ? cfn_parse.FromCloudFormation.getString(properties.RStudioConnectUrl) : void 0), ret.addPropertyResult("rStudioPackageManagerUrl", "RStudioPackageManagerUrl", properties.RStudioPackageManagerUrl != null ? cfn_parse.FromCloudFormation.getString(properties.RStudioPackageManagerUrl) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_ResourceSpecPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("lifecycleConfigArn", cdk.validateString)(properties.lifecycleConfigArn)), errors.collect(cdk.propertyValidator("sageMakerImageArn", cdk.validateString)(properties.sageMakerImageArn)), errors.collect(cdk.propertyValidator("sageMakerImageVersionArn", cdk.validateString)(properties.sageMakerImageVersionArn)), errors.wrap('supplied properties not correct for "ResourceSpecProperty"');
    }
    function cfnDomainResourceSpecPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_ResourceSpecPropertyValidator(properties).assertSuccess(), { InstanceType: cdk.stringToCloudFormation(properties.instanceType), LifecycleConfigArn: cdk.stringToCloudFormation(properties.lifecycleConfigArn), SageMakerImageArn: cdk.stringToCloudFormation(properties.sageMakerImageArn), SageMakerImageVersionArn: cdk.stringToCloudFormation(properties.sageMakerImageVersionArn) }) : properties;
    }
    function CfnDomainResourceSpecPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceType", "InstanceType", properties.InstanceType != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceType) : void 0), ret.addPropertyResult("lifecycleConfigArn", "LifecycleConfigArn", properties.LifecycleConfigArn != null ? cfn_parse.FromCloudFormation.getString(properties.LifecycleConfigArn) : void 0), ret.addPropertyResult("sageMakerImageArn", "SageMakerImageArn", properties.SageMakerImageArn != null ? cfn_parse.FromCloudFormation.getString(properties.SageMakerImageArn) : void 0), ret.addPropertyResult("sageMakerImageVersionArn", "SageMakerImageVersionArn", properties.SageMakerImageVersionArn != null ? cfn_parse.FromCloudFormation.getString(properties.SageMakerImageVersionArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_SharingSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("notebookOutputOption", cdk.validateString)(properties.notebookOutputOption)), errors.collect(cdk.propertyValidator("s3KmsKeyId", cdk.validateString)(properties.s3KmsKeyId)), errors.collect(cdk.propertyValidator("s3OutputPath", cdk.validateString)(properties.s3OutputPath)), errors.wrap('supplied properties not correct for "SharingSettingsProperty"');
    }
    function cfnDomainSharingSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_SharingSettingsPropertyValidator(properties).assertSuccess(), { NotebookOutputOption: cdk.stringToCloudFormation(properties.notebookOutputOption), S3KmsKeyId: cdk.stringToCloudFormation(properties.s3KmsKeyId), S3OutputPath: cdk.stringToCloudFormation(properties.s3OutputPath) }) : properties;
    }
    function CfnDomainSharingSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("notebookOutputOption", "NotebookOutputOption", properties.NotebookOutputOption != null ? cfn_parse.FromCloudFormation.getString(properties.NotebookOutputOption) : void 0), ret.addPropertyResult("s3KmsKeyId", "S3KmsKeyId", properties.S3KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.S3KmsKeyId) : void 0), ret.addPropertyResult("s3OutputPath", "S3OutputPath", properties.S3OutputPath != null ? cfn_parse.FromCloudFormation.getString(properties.S3OutputPath) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDomain_UserSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("executionRole", cdk.requiredValidator)(properties.executionRole)), errors.collect(cdk.propertyValidator("executionRole", cdk.validateString)(properties.executionRole)), errors.collect(cdk.propertyValidator("jupyterServerAppSettings", CfnDomain_JupyterServerAppSettingsPropertyValidator)(properties.jupyterServerAppSettings)), errors.collect(cdk.propertyValidator("kernelGatewayAppSettings", CfnDomain_KernelGatewayAppSettingsPropertyValidator)(properties.kernelGatewayAppSettings)), errors.collect(cdk.propertyValidator("rSessionAppSettings", CfnDomain_RSessionAppSettingsPropertyValidator)(properties.rSessionAppSettings)), errors.collect(cdk.propertyValidator("rStudioServerProAppSettings", CfnDomain_RStudioServerProAppSettingsPropertyValidator)(properties.rStudioServerProAppSettings)), errors.collect(cdk.propertyValidator("securityGroups", cdk.listValidator(cdk.validateString))(properties.securityGroups)), errors.collect(cdk.propertyValidator("sharingSettings", CfnDomain_SharingSettingsPropertyValidator)(properties.sharingSettings)), errors.wrap('supplied properties not correct for "UserSettingsProperty"');
    }
    function cfnDomainUserSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_UserSettingsPropertyValidator(properties).assertSuccess(), { ExecutionRole: cdk.stringToCloudFormation(properties.executionRole), JupyterServerAppSettings: cfnDomainJupyterServerAppSettingsPropertyToCloudFormation(properties.jupyterServerAppSettings), KernelGatewayAppSettings: cfnDomainKernelGatewayAppSettingsPropertyToCloudFormation(properties.kernelGatewayAppSettings), RSessionAppSettings: cfnDomainRSessionAppSettingsPropertyToCloudFormation(properties.rSessionAppSettings), RStudioServerProAppSettings: cfnDomainRStudioServerProAppSettingsPropertyToCloudFormation(properties.rStudioServerProAppSettings), SecurityGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroups), SharingSettings: cfnDomainSharingSettingsPropertyToCloudFormation(properties.sharingSettings) }) : properties;
    }
    function CfnDomainUserSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("executionRole", "ExecutionRole", cfn_parse.FromCloudFormation.getString(properties.ExecutionRole)), ret.addPropertyResult("jupyterServerAppSettings", "JupyterServerAppSettings", properties.JupyterServerAppSettings != null ? CfnDomainJupyterServerAppSettingsPropertyFromCloudFormation(properties.JupyterServerAppSettings) : void 0), ret.addPropertyResult("kernelGatewayAppSettings", "KernelGatewayAppSettings", properties.KernelGatewayAppSettings != null ? CfnDomainKernelGatewayAppSettingsPropertyFromCloudFormation(properties.KernelGatewayAppSettings) : void 0), ret.addPropertyResult("rSessionAppSettings", "RSessionAppSettings", properties.RSessionAppSettings != null ? CfnDomainRSessionAppSettingsPropertyFromCloudFormation(properties.RSessionAppSettings) : void 0), ret.addPropertyResult("rStudioServerProAppSettings", "RStudioServerProAppSettings", properties.RStudioServerProAppSettings != null ? CfnDomainRStudioServerProAppSettingsPropertyFromCloudFormation(properties.RStudioServerProAppSettings) : void 0), ret.addPropertyResult("securityGroups", "SecurityGroups", properties.SecurityGroups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroups) : void 0), ret.addPropertyResult("sharingSettings", "SharingSettings", properties.SharingSettings != null ? CfnDomainSharingSettingsPropertyFromCloudFormation(properties.SharingSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpointPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deploymentConfig", CfnEndpoint_DeploymentConfigPropertyValidator)(properties.deploymentConfig)), errors.collect(cdk.propertyValidator("endpointConfigName", cdk.requiredValidator)(properties.endpointConfigName)), errors.collect(cdk.propertyValidator("endpointConfigName", cdk.validateString)(properties.endpointConfigName)), errors.collect(cdk.propertyValidator("endpointName", cdk.validateString)(properties.endpointName)), errors.collect(cdk.propertyValidator("excludeRetainedVariantProperties", cdk.listValidator(CfnEndpoint_VariantPropertyPropertyValidator))(properties.excludeRetainedVariantProperties)), errors.collect(cdk.propertyValidator("retainAllVariantProperties", cdk.validateBoolean)(properties.retainAllVariantProperties)), errors.collect(cdk.propertyValidator("retainDeploymentConfig", cdk.validateBoolean)(properties.retainDeploymentConfig)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnEndpointProps"');
    }
    function cfnEndpointPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpointPropsValidator(properties).assertSuccess(), { EndpointConfigName: cdk.stringToCloudFormation(properties.endpointConfigName), DeploymentConfig: cfnEndpointDeploymentConfigPropertyToCloudFormation(properties.deploymentConfig), EndpointName: cdk.stringToCloudFormation(properties.endpointName), ExcludeRetainedVariantProperties: cdk.listMapper(cfnEndpointVariantPropertyPropertyToCloudFormation)(properties.excludeRetainedVariantProperties), RetainAllVariantProperties: cdk.booleanToCloudFormation(properties.retainAllVariantProperties), RetainDeploymentConfig: cdk.booleanToCloudFormation(properties.retainDeploymentConfig), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnEndpointPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endpointConfigName", "EndpointConfigName", cfn_parse.FromCloudFormation.getString(properties.EndpointConfigName)), ret.addPropertyResult("deploymentConfig", "DeploymentConfig", properties.DeploymentConfig != null ? CfnEndpointDeploymentConfigPropertyFromCloudFormation(properties.DeploymentConfig) : void 0), ret.addPropertyResult("endpointName", "EndpointName", properties.EndpointName != null ? cfn_parse.FromCloudFormation.getString(properties.EndpointName) : void 0), ret.addPropertyResult("excludeRetainedVariantProperties", "ExcludeRetainedVariantProperties", properties.ExcludeRetainedVariantProperties != null ? cfn_parse.FromCloudFormation.getArray(CfnEndpointVariantPropertyPropertyFromCloudFormation)(properties.ExcludeRetainedVariantProperties) : void 0), ret.addPropertyResult("retainAllVariantProperties", "RetainAllVariantProperties", properties.RetainAllVariantProperties != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RetainAllVariantProperties) : void 0), ret.addPropertyResult("retainDeploymentConfig", "RetainDeploymentConfig", properties.RetainDeploymentConfig != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RetainDeploymentConfig) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEndpoint = class _CfnEndpoint extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEndpointPropsFromCloudFormation(resourceProperties), ret = new _CfnEndpoint(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEndpoint.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sagemaker_CfnEndpointProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEndpoint), error;
        }
        cdk.requireProperty(props, "endpointConfigName", this), this.attrEndpointName = cdk.Token.asString(this.getAtt("EndpointName", cdk.ResolutionTypeHint.STRING)), this.endpointConfigName = props.endpointConfigName, this.deploymentConfig = props.deploymentConfig, this.endpointName = props.endpointName, this.excludeRetainedVariantProperties = props.excludeRetainedVariantProperties, this.retainAllVariantProperties = props.retainAllVariantProperties, this.retainDeploymentConfig = props.retainDeploymentConfig, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SageMaker::Endpoint", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEndpoint.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { endpointConfigName: this.endpointConfigName, deploymentConfig: this.deploymentConfig, endpointName: this.endpointName, excludeRetainedVariantProperties: this.excludeRetainedVariantProperties, retainAllVariantProperties: this.retainAllVariantProperties, retainDeploymentConfig: this.retainDeploymentConfig, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnEndpointPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnEndpoint[_h] = { fqn: "aws-cdk-lib.aws_sagemaker.CfnEndpoint", version: "2.80.0" }, CfnEndpoint.CFN_RESOURCE_TYPE_NAME = "AWS::SageMaker::Endpoint", exports2.CfnEndpoint = CfnEndpoint;
    function CfnEndpoint_AlarmPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alarmName", cdk.requiredValidator)(properties.alarmName)), errors.collect(cdk.propertyValidator("alarmName", cdk.validateString)(properties.alarmName)), errors.wrap('supplied properties not correct for "AlarmProperty"');
    }
    function cfnEndpointAlarmPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpoint_AlarmPropertyValidator(properties).assertSuccess(), { AlarmName: cdk.stringToCloudFormation(properties.alarmName) }) : properties;
    }
    function CfnEndpointAlarmPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alarmName", "AlarmName", cfn_parse.FromCloudFormation.getString(properties.AlarmName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpoint_AutoRollbackConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alarms", cdk.requiredValidator)(properties.alarms)), errors.collect(cdk.propertyValidator("alarms", cdk.listValidator(CfnEndpoint_AlarmPropertyValidator))(properties.alarms)), errors.wrap('supplied properties not correct for "AutoRollbackConfigProperty"');
    }
    function cfnEndpointAutoRollbackConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpoint_AutoRollbackConfigPropertyValidator(properties).assertSuccess(), { Alarms: cdk.listMapper(cfnEndpointAlarmPropertyToCloudFormation)(properties.alarms) }) : properties;
    }
    function CfnEndpointAutoRollbackConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alarms", "Alarms", cfn_parse.FromCloudFormation.getArray(CfnEndpointAlarmPropertyFromCloudFormation)(properties.Alarms)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpoint_BlueGreenUpdatePolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maximumExecutionTimeoutInSeconds", cdk.validateNumber)(properties.maximumExecutionTimeoutInSeconds)), errors.collect(cdk.propertyValidator("terminationWaitInSeconds", cdk.validateNumber)(properties.terminationWaitInSeconds)), errors.collect(cdk.propertyValidator("trafficRoutingConfiguration", cdk.requiredValidator)(properties.trafficRoutingConfiguration)), errors.collect(cdk.propertyValidator("trafficRoutingConfiguration", CfnEndpoint_TrafficRoutingConfigPropertyValidator)(properties.trafficRoutingConfiguration)), errors.wrap('supplied properties not correct for "BlueGreenUpdatePolicyProperty"');
    }
    function cfnEndpointBlueGreenUpdatePolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpoint_BlueGreenUpdatePolicyPropertyValidator(properties).assertSuccess(), { MaximumExecutionTimeoutInSeconds: cdk.numberToCloudFormation(properties.maximumExecutionTimeoutInSeconds), TerminationWaitInSeconds: cdk.numberToCloudFormation(properties.terminationWaitInSeconds), TrafficRoutingConfiguration: cfnEndpointTrafficRoutingConfigPropertyToCloudFormation(properties.trafficRoutingConfiguration) }) : properties;
    }
    function CfnEndpointBlueGreenUpdatePolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maximumExecutionTimeoutInSeconds", "MaximumExecutionTimeoutInSeconds", properties.MaximumExecutionTimeoutInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumExecutionTimeoutInSeconds) : void 0), ret.addPropertyResult("terminationWaitInSeconds", "TerminationWaitInSeconds", properties.TerminationWaitInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.TerminationWaitInSeconds) : void 0), ret.addPropertyResult("trafficRoutingConfiguration", "TrafficRoutingConfiguration", CfnEndpointTrafficRoutingConfigPropertyFromCloudFormation(properties.TrafficRoutingConfiguration)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpoint_CapacitySizePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "CapacitySizeProperty"');
    }
    function cfnEndpointCapacitySizePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpoint_CapacitySizePropertyValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type), Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnEndpointCapacitySizePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getNumber(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpoint_DeploymentConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("autoRollbackConfiguration", CfnEndpoint_AutoRollbackConfigPropertyValidator)(properties.autoRollbackConfiguration)), errors.collect(cdk.propertyValidator("blueGreenUpdatePolicy", cdk.requiredValidator)(properties.blueGreenUpdatePolicy)), errors.collect(cdk.propertyValidator("blueGreenUpdatePolicy", CfnEndpoint_BlueGreenUpdatePolicyPropertyValidator)(properties.blueGreenUpdatePolicy)), errors.wrap('supplied properties not correct for "DeploymentConfigProperty"');
    }
    function cfnEndpointDeploymentConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpoint_DeploymentConfigPropertyValidator(properties).assertSuccess(), { AutoRollbackConfiguration: cfnEndpointAutoRollbackConfigPropertyToCloudFormation(properties.autoRollbackConfiguration), BlueGreenUpdatePolicy: cfnEndpointBlueGreenUpdatePolicyPropertyToCloudFormation(properties.blueGreenUpdatePolicy) }) : properties;
    }
    function CfnEndpointDeploymentConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("autoRollbackConfiguration", "AutoRollbackConfiguration", properties.AutoRollbackConfiguration != null ? CfnEndpointAutoRollbackConfigPropertyFromCloudFormation(properties.AutoRollbackConfiguration) : void 0), ret.addPropertyResult("blueGreenUpdatePolicy", "BlueGreenUpdatePolicy", CfnEndpointBlueGreenUpdatePolicyPropertyFromCloudFormation(properties.BlueGreenUpdatePolicy)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpoint_TrafficRoutingConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("canarySize", CfnEndpoint_CapacitySizePropertyValidator)(properties.canarySize)), errors.collect(cdk.propertyValidator("linearStepSize", CfnEndpoint_CapacitySizePropertyValidator)(properties.linearStepSize)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("waitIntervalInSeconds", cdk.validateNumber)(properties.waitIntervalInSeconds)), errors.wrap('supplied properties not correct for "TrafficRoutingConfigProperty"');
    }
    function cfnEndpointTrafficRoutingConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpoint_TrafficRoutingConfigPropertyValidator(properties).assertSuccess(), { CanarySize: cfnEndpointCapacitySizePropertyToCloudFormation(properties.canarySize), LinearStepSize: cfnEndpointCapacitySizePropertyToCloudFormation(properties.linearStepSize), Type: cdk.stringToCloudFormation(properties.type), WaitIntervalInSeconds: cdk.numberToCloudFormation(properties.waitIntervalInSeconds) }) : properties;
    }
    function CfnEndpointTrafficRoutingConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("canarySize", "CanarySize", properties.CanarySize != null ? CfnEndpointCapacitySizePropertyFromCloudFormation(properties.CanarySize) : void 0), ret.addPropertyResult("linearStepSize", "LinearStepSize", properties.LinearStepSize != null ? CfnEndpointCapacitySizePropertyFromCloudFormation(properties.LinearStepSize) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("waitIntervalInSeconds", "WaitIntervalInSeconds", properties.WaitIntervalInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.WaitIntervalInSeconds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpoint_VariantPropertyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("variantPropertyType", cdk.validateString)(properties.variantPropertyType)), errors.wrap('supplied properties not correct for "VariantPropertyProperty"');
    }
    function cfnEndpointVariantPropertyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpoint_VariantPropertyPropertyValidator(properties).assertSuccess(), { VariantPropertyType: cdk.stringToCloudFormation(properties.variantPropertyType) }) : properties;
    }
    function CfnEndpointVariantPropertyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("variantPropertyType", "VariantPropertyType", properties.VariantPropertyType != null ? cfn_parse.FromCloudFormation.getString(properties.VariantPropertyType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpointConfigPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("asyncInferenceConfig", CfnEndpointConfig_AsyncInferenceConfigPropertyValidator)(properties.asyncInferenceConfig)), errors.collect(cdk.propertyValidator("dataCaptureConfig", CfnEndpointConfig_DataCaptureConfigPropertyValidator)(properties.dataCaptureConfig)), errors.collect(cdk.propertyValidator("endpointConfigName", cdk.validateString)(properties.endpointConfigName)), errors.collect(cdk.propertyValidator("explainerConfig", CfnEndpointConfig_ExplainerConfigPropertyValidator)(properties.explainerConfig)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("productionVariants", cdk.requiredValidator)(properties.productionVariants)), errors.collect(cdk.propertyValidator("productionVariants", cdk.listValidator(CfnEndpointConfig_ProductionVariantPropertyValidator))(properties.productionVariants)), errors.collect(cdk.propertyValidator("shadowProductionVariants", cdk.listValidator(CfnEndpointConfig_ProductionVariantPropertyValidator))(properties.shadowProductionVariants)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnEndpointConfigProps"');
    }
    function cfnEndpointConfigPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpointConfigPropsValidator(properties).assertSuccess(), { ProductionVariants: cdk.listMapper(cfnEndpointConfigProductionVariantPropertyToCloudFormation)(properties.productionVariants), AsyncInferenceConfig: cfnEndpointConfigAsyncInferenceConfigPropertyToCloudFormation(properties.asyncInferenceConfig), DataCaptureConfig: cfnEndpointConfigDataCaptureConfigPropertyToCloudFormation(properties.dataCaptureConfig), EndpointConfigName: cdk.stringToCloudFormation(properties.endpointConfigName), ExplainerConfig: cfnEndpointConfigExplainerConfigPropertyToCloudFormation(properties.explainerConfig), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), ShadowProductionVariants: cdk.listMapper(cfnEndpointConfigProductionVariantPropertyToCloudFormation)(properties.shadowProductionVariants), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnEndpointConfigPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("productionVariants", "ProductionVariants", cfn_parse.FromCloudFormation.getArray(CfnEndpointConfigProductionVariantPropertyFromCloudFormation)(properties.ProductionVariants)), ret.addPropertyResult("asyncInferenceConfig", "AsyncInferenceConfig", properties.AsyncInferenceConfig != null ? CfnEndpointConfigAsyncInferenceConfigPropertyFromCloudFormation(properties.AsyncInferenceConfig) : void 0), ret.addPropertyResult("dataCaptureConfig", "DataCaptureConfig", properties.DataCaptureConfig != null ? CfnEndpointConfigDataCaptureConfigPropertyFromCloudFormation(properties.DataCaptureConfig) : void 0), ret.addPropertyResult("endpointConfigName", "EndpointConfigName", properties.EndpointConfigName != null ? cfn_parse.FromCloudFormation.getString(properties.EndpointConfigName) : void 0), ret.addPropertyResult("explainerConfig", "ExplainerConfig", properties.ExplainerConfig != null ? CfnEndpointConfigExplainerConfigPropertyFromCloudFormation(properties.ExplainerConfig) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("shadowProductionVariants", "ShadowProductionVariants", properties.ShadowProductionVariants != null ? cfn_parse.FromCloudFormation.getArray(CfnEndpointConfigProductionVariantPropertyFromCloudFormation)(properties.ShadowProductionVariants) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEndpointConfig = class _CfnEndpointConfig extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEndpointConfigPropsFromCloudFormation(resourceProperties), ret = new _CfnEndpointConfig(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEndpointConfig.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sagemaker_CfnEndpointConfigProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEndpointConfig), error;
        }
        cdk.requireProperty(props, "productionVariants", this), this.attrEndpointConfigName = cdk.Token.asString(this.getAtt("EndpointConfigName", cdk.ResolutionTypeHint.STRING)), this.productionVariants = props.productionVariants, this.asyncInferenceConfig = props.asyncInferenceConfig, this.dataCaptureConfig = props.dataCaptureConfig, this.endpointConfigName = props.endpointConfigName, this.explainerConfig = props.explainerConfig, this.kmsKeyId = props.kmsKeyId, this.shadowProductionVariants = props.shadowProductionVariants, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SageMaker::EndpointConfig", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEndpointConfig.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { productionVariants: this.productionVariants, asyncInferenceConfig: this.asyncInferenceConfig, dataCaptureConfig: this.dataCaptureConfig, endpointConfigName: this.endpointConfigName, explainerConfig: this.explainerConfig, kmsKeyId: this.kmsKeyId, shadowProductionVariants: this.shadowProductionVariants, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnEndpointConfigPropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnEndpointConfig[_j] = { fqn: "aws-cdk-lib.aws_sagemaker.CfnEndpointConfig", version: "2.80.0" }, CfnEndpointConfig.CFN_RESOURCE_TYPE_NAME = "AWS::SageMaker::EndpointConfig", exports2.CfnEndpointConfig = CfnEndpointConfig;
    function CfnEndpointConfig_AsyncInferenceClientConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxConcurrentInvocationsPerInstance", cdk.validateNumber)(properties.maxConcurrentInvocationsPerInstance)), errors.wrap('supplied properties not correct for "AsyncInferenceClientConfigProperty"');
    }
    function cfnEndpointConfigAsyncInferenceClientConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpointConfig_AsyncInferenceClientConfigPropertyValidator(properties).assertSuccess(), { MaxConcurrentInvocationsPerInstance: cdk.numberToCloudFormation(properties.maxConcurrentInvocationsPerInstance) }) : properties;
    }
    function CfnEndpointConfigAsyncInferenceClientConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxConcurrentInvocationsPerInstance", "MaxConcurrentInvocationsPerInstance", properties.MaxConcurrentInvocationsPerInstance != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxConcurrentInvocationsPerInstance) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpointConfig_AsyncInferenceConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clientConfig", CfnEndpointConfig_AsyncInferenceClientConfigPropertyValidator)(properties.clientConfig)), errors.collect(cdk.propertyValidator("outputConfig", cdk.requiredValidator)(properties.outputConfig)), errors.collect(cdk.propertyValidator("outputConfig", CfnEndpointConfig_AsyncInferenceOutputConfigPropertyValidator)(properties.outputConfig)), errors.wrap('supplied properties not correct for "AsyncInferenceConfigProperty"');
    }
    function cfnEndpointConfigAsyncInferenceConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpointConfig_AsyncInferenceConfigPropertyValidator(properties).assertSuccess(), { ClientConfig: cfnEndpointConfigAsyncInferenceClientConfigPropertyToCloudFormation(properties.clientConfig), OutputConfig: cfnEndpointConfigAsyncInferenceOutputConfigPropertyToCloudFormation(properties.outputConfig) }) : properties;
    }
    function CfnEndpointConfigAsyncInferenceConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clientConfig", "ClientConfig", properties.ClientConfig != null ? CfnEndpointConfigAsyncInferenceClientConfigPropertyFromCloudFormation(properties.ClientConfig) : void 0), ret.addPropertyResult("outputConfig", "OutputConfig", CfnEndpointConfigAsyncInferenceOutputConfigPropertyFromCloudFormation(properties.OutputConfig)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpointConfig_AsyncInferenceNotificationConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("errorTopic", cdk.validateString)(properties.errorTopic)), errors.collect(cdk.propertyValidator("includeInferenceResponseIn", cdk.listValidator(cdk.validateString))(properties.includeInferenceResponseIn)), errors.collect(cdk.propertyValidator("successTopic", cdk.validateString)(properties.successTopic)), errors.wrap('supplied properties not correct for "AsyncInferenceNotificationConfigProperty"');
    }
    function cfnEndpointConfigAsyncInferenceNotificationConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpointConfig_AsyncInferenceNotificationConfigPropertyValidator(properties).assertSuccess(), { ErrorTopic: cdk.stringToCloudFormation(properties.errorTopic), IncludeInferenceResponseIn: cdk.listMapper(cdk.stringToCloudFormation)(properties.includeInferenceResponseIn), SuccessTopic: cdk.stringToCloudFormation(properties.successTopic) }) : properties;
    }
    function CfnEndpointConfigAsyncInferenceNotificationConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("errorTopic", "ErrorTopic", properties.ErrorTopic != null ? cfn_parse.FromCloudFormation.getString(properties.ErrorTopic) : void 0), ret.addPropertyResult("includeInferenceResponseIn", "IncludeInferenceResponseIn", properties.IncludeInferenceResponseIn != null ? cfn_parse.FromCloudFormation.getStringArray(properties.IncludeInferenceResponseIn) : void 0), ret.addPropertyResult("successTopic", "SuccessTopic", properties.SuccessTopic != null ? cfn_parse.FromCloudFormation.getString(properties.SuccessTopic) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpointConfig_AsyncInferenceOutputConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("notificationConfig", CfnEndpointConfig_AsyncInferenceNotificationConfigPropertyValidator)(properties.notificationConfig)), errors.collect(cdk.propertyValidator("s3FailurePath", cdk.validateString)(properties.s3FailurePath)), errors.collect(cdk.propertyValidator("s3OutputPath", cdk.validateString)(properties.s3OutputPath)), errors.wrap('supplied properties not correct for "AsyncInferenceOutputConfigProperty"');
    }
    function cfnEndpointConfigAsyncInferenceOutputConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpointConfig_AsyncInferenceOutputConfigPropertyValidator(properties).assertSuccess(), { KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), NotificationConfig: cfnEndpointConfigAsyncInferenceNotificationConfigPropertyToCloudFormation(properties.notificationConfig), S3FailurePath: cdk.stringToCloudFormation(properties.s3FailurePath), S3OutputPath: cdk.stringToCloudFormation(properties.s3OutputPath) }) : properties;
    }
    function CfnEndpointConfigAsyncInferenceOutputConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("notificationConfig", "NotificationConfig", properties.NotificationConfig != null ? CfnEndpointConfigAsyncInferenceNotificationConfigPropertyFromCloudFormation(properties.NotificationConfig) : void 0), ret.addPropertyResult("s3FailurePath", "S3FailurePath", properties.S3FailurePath != null ? cfn_parse.FromCloudFormation.getString(properties.S3FailurePath) : void 0), ret.addPropertyResult("s3OutputPath", "S3OutputPath", properties.S3OutputPath != null ? cfn_parse.FromCloudFormation.getString(properties.S3OutputPath) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpointConfig_CaptureContentTypeHeaderPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("csvContentTypes", cdk.listValidator(cdk.validateString))(properties.csvContentTypes)), errors.collect(cdk.propertyValidator("jsonContentTypes", cdk.listValidator(cdk.validateString))(properties.jsonContentTypes)), errors.wrap('supplied properties not correct for "CaptureContentTypeHeaderProperty"');
    }
    function cfnEndpointConfigCaptureContentTypeHeaderPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpointConfig_CaptureContentTypeHeaderPropertyValidator(properties).assertSuccess(), { CsvContentTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.csvContentTypes), JsonContentTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.jsonContentTypes) }) : properties;
    }
    function CfnEndpointConfigCaptureContentTypeHeaderPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("csvContentTypes", "CsvContentTypes", properties.CsvContentTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CsvContentTypes) : void 0), ret.addPropertyResult("jsonContentTypes", "JsonContentTypes", properties.JsonContentTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.JsonContentTypes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpointConfig_CaptureOptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("captureMode", cdk.requiredValidator)(properties.captureMode)), errors.collect(cdk.propertyValidator("captureMode", cdk.validateString)(properties.captureMode)), errors.wrap('supplied properties not correct for "CaptureOptionProperty"');
    }
    function cfnEndpointConfigCaptureOptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpointConfig_CaptureOptionPropertyValidator(properties).assertSuccess(), { CaptureMode: cdk.stringToCloudFormation(properties.captureMode) }) : properties;
    }
    function CfnEndpointConfigCaptureOptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("captureMode", "CaptureMode", cfn_parse.FromCloudFormation.getString(properties.CaptureMode)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpointConfig_ClarifyExplainerConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enableExplanations", cdk.validateString)(properties.enableExplanations)), errors.collect(cdk.propertyValidator("inferenceConfig", CfnEndpointConfig_ClarifyInferenceConfigPropertyValidator)(properties.inferenceConfig)), errors.collect(cdk.propertyValidator("shapConfig", cdk.requiredValidator)(properties.shapConfig)), errors.collect(cdk.propertyValidator("shapConfig", CfnEndpointConfig_ClarifyShapConfigPropertyValidator)(properties.shapConfig)), errors.wrap('supplied properties not correct for "ClarifyExplainerConfigProperty"');
    }
    function cfnEndpointConfigClarifyExplainerConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpointConfig_ClarifyExplainerConfigPropertyValidator(properties).assertSuccess(), { EnableExplanations: cdk.stringToCloudFormation(properties.enableExplanations), InferenceConfig: cfnEndpointConfigClarifyInferenceConfigPropertyToCloudFormation(properties.inferenceConfig), ShapConfig: cfnEndpointConfigClarifyShapConfigPropertyToCloudFormation(properties.shapConfig) }) : properties;
    }
    function CfnEndpointConfigClarifyExplainerConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enableExplanations", "EnableExplanations", properties.EnableExplanations != null ? cfn_parse.FromCloudFormation.getString(properties.EnableExplanations) : void 0), ret.addPropertyResult("inferenceConfig", "InferenceConfig", properties.InferenceConfig != null ? CfnEndpointConfigClarifyInferenceConfigPropertyFromCloudFormation(properties.InferenceConfig) : void 0), ret.addPropertyResult("shapConfig", "ShapConfig", CfnEndpointConfigClarifyShapConfigPropertyFromCloudFormation(properties.ShapConfig)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpointConfig_ClarifyInferenceConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contentTemplate", cdk.validateString)(properties.contentTemplate)), errors.collect(cdk.propertyValidator("featureHeaders", cdk.listValidator(cdk.validateString))(properties.featureHeaders)), errors.collect(cdk.propertyValidator("featureTypes", cdk.listValidator(cdk.validateString))(properties.featureTypes)), errors.collect(cdk.propertyValidator("featuresAttribute", cdk.validateString)(properties.featuresAttribute)), errors.collect(cdk.propertyValidator("labelAttribute", cdk.validateString)(properties.labelAttribute)), errors.collect(cdk.propertyValidator("labelHeaders", cdk.listValidator(cdk.validateString))(properties.labelHeaders)), errors.collect(cdk.propertyValidator("labelIndex", cdk.validateNumber)(properties.labelIndex)), errors.collect(cdk.propertyValidator("maxPayloadInMb", cdk.validateNumber)(properties.maxPayloadInMb)), errors.collect(cdk.propertyValidator("maxRecordCount", cdk.validateNumber)(properties.maxRecordCount)), errors.collect(cdk.propertyValidator("probabilityAttribute", cdk.validateString)(properties.probabilityAttribute)), errors.collect(cdk.propertyValidator("probabilityIndex", cdk.validateNumber)(properties.probabilityIndex)), errors.wrap('supplied properties not correct for "ClarifyInferenceConfigProperty"');
    }
    function cfnEndpointConfigClarifyInferenceConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpointConfig_ClarifyInferenceConfigPropertyValidator(properties).assertSuccess(), { ContentTemplate: cdk.stringToCloudFormation(properties.contentTemplate), FeatureHeaders: cdk.listMapper(cdk.stringToCloudFormation)(properties.featureHeaders), FeatureTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.featureTypes), FeaturesAttribute: cdk.stringToCloudFormation(properties.featuresAttribute), LabelAttribute: cdk.stringToCloudFormation(properties.labelAttribute), LabelHeaders: cdk.listMapper(cdk.stringToCloudFormation)(properties.labelHeaders), LabelIndex: cdk.numberToCloudFormation(properties.labelIndex), MaxPayloadInMB: cdk.numberToCloudFormation(properties.maxPayloadInMb), MaxRecordCount: cdk.numberToCloudFormation(properties.maxRecordCount), ProbabilityAttribute: cdk.stringToCloudFormation(properties.probabilityAttribute), ProbabilityIndex: cdk.numberToCloudFormation(properties.probabilityIndex) }) : properties;
    }
    function CfnEndpointConfigClarifyInferenceConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contentTemplate", "ContentTemplate", properties.ContentTemplate != null ? cfn_parse.FromCloudFormation.getString(properties.ContentTemplate) : void 0), ret.addPropertyResult("featureHeaders", "FeatureHeaders", properties.FeatureHeaders != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getString)(properties.FeatureHeaders) : void 0), ret.addPropertyResult("featureTypes", "FeatureTypes", properties.FeatureTypes != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getString)(properties.FeatureTypes) : void 0), ret.addPropertyResult("featuresAttribute", "FeaturesAttribute", properties.FeaturesAttribute != null ? cfn_parse.FromCloudFormation.getString(properties.FeaturesAttribute) : void 0), ret.addPropertyResult("labelAttribute", "LabelAttribute", properties.LabelAttribute != null ? cfn_parse.FromCloudFormation.getString(properties.LabelAttribute) : void 0), ret.addPropertyResult("labelHeaders", "LabelHeaders", properties.LabelHeaders != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getString)(properties.LabelHeaders) : void 0), ret.addPropertyResult("labelIndex", "LabelIndex", properties.LabelIndex != null ? cfn_parse.FromCloudFormation.getNumber(properties.LabelIndex) : void 0), ret.addPropertyResult("maxPayloadInMb", "MaxPayloadInMB", properties.MaxPayloadInMB != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxPayloadInMB) : void 0), ret.addPropertyResult("maxRecordCount", "MaxRecordCount", properties.MaxRecordCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxRecordCount) : void 0), ret.addPropertyResult("probabilityAttribute", "ProbabilityAttribute", properties.ProbabilityAttribute != null ? cfn_parse.FromCloudFormation.getString(properties.ProbabilityAttribute) : void 0), ret.addPropertyResult("probabilityIndex", "ProbabilityIndex", properties.ProbabilityIndex != null ? cfn_parse.FromCloudFormation.getNumber(properties.ProbabilityIndex) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpointConfig_ClarifyShapBaselineConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mimeType", cdk.validateString)(properties.mimeType)), errors.collect(cdk.propertyValidator("shapBaseline", cdk.validateString)(properties.shapBaseline)), errors.collect(cdk.propertyValidator("shapBaselineUri", cdk.validateString)(properties.shapBaselineUri)), errors.wrap('supplied properties not correct for "ClarifyShapBaselineConfigProperty"');
    }
    function cfnEndpointConfigClarifyShapBaselineConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpointConfig_ClarifyShapBaselineConfigPropertyValidator(properties).assertSuccess(), { MimeType: cdk.stringToCloudFormation(properties.mimeType), ShapBaseline: cdk.stringToCloudFormation(properties.shapBaseline), ShapBaselineUri: cdk.stringToCloudFormation(properties.shapBaselineUri) }) : properties;
    }
    function CfnEndpointConfigClarifyShapBaselineConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mimeType", "MimeType", properties.MimeType != null ? cfn_parse.FromCloudFormation.getString(properties.MimeType) : void 0), ret.addPropertyResult("shapBaseline", "ShapBaseline", properties.ShapBaseline != null ? cfn_parse.FromCloudFormation.getString(properties.ShapBaseline) : void 0), ret.addPropertyResult("shapBaselineUri", "ShapBaselineUri", properties.ShapBaselineUri != null ? cfn_parse.FromCloudFormation.getString(properties.ShapBaselineUri) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpointConfig_ClarifyShapConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("numberOfSamples", cdk.validateNumber)(properties.numberOfSamples)), errors.collect(cdk.propertyValidator("seed", cdk.validateNumber)(properties.seed)), errors.collect(cdk.propertyValidator("shapBaselineConfig", cdk.requiredValidator)(properties.shapBaselineConfig)), errors.collect(cdk.propertyValidator("shapBaselineConfig", CfnEndpointConfig_ClarifyShapBaselineConfigPropertyValidator)(properties.shapBaselineConfig)), errors.collect(cdk.propertyValidator("textConfig", CfnEndpointConfig_ClarifyTextConfigPropertyValidator)(properties.textConfig)), errors.collect(cdk.propertyValidator("useLogit", cdk.validateBoolean)(properties.useLogit)), errors.wrap('supplied properties not correct for "ClarifyShapConfigProperty"');
    }
    function cfnEndpointConfigClarifyShapConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpointConfig_ClarifyShapConfigPropertyValidator(properties).assertSuccess(), { NumberOfSamples: cdk.numberToCloudFormation(properties.numberOfSamples), Seed: cdk.numberToCloudFormation(properties.seed), ShapBaselineConfig: cfnEndpointConfigClarifyShapBaselineConfigPropertyToCloudFormation(properties.shapBaselineConfig), TextConfig: cfnEndpointConfigClarifyTextConfigPropertyToCloudFormation(properties.textConfig), UseLogit: cdk.booleanToCloudFormation(properties.useLogit) }) : properties;
    }
    function CfnEndpointConfigClarifyShapConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("numberOfSamples", "NumberOfSamples", properties.NumberOfSamples != null ? cfn_parse.FromCloudFormation.getNumber(properties.NumberOfSamples) : void 0), ret.addPropertyResult("seed", "Seed", properties.Seed != null ? cfn_parse.FromCloudFormation.getNumber(properties.Seed) : void 0), ret.addPropertyResult("shapBaselineConfig", "ShapBaselineConfig", CfnEndpointConfigClarifyShapBaselineConfigPropertyFromCloudFormation(properties.ShapBaselineConfig)), ret.addPropertyResult("textConfig", "TextConfig", properties.TextConfig != null ? CfnEndpointConfigClarifyTextConfigPropertyFromCloudFormation(properties.TextConfig) : void 0), ret.addPropertyResult("useLogit", "UseLogit", properties.UseLogit != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UseLogit) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpointConfig_ClarifyTextConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("granularity", cdk.requiredValidator)(properties.granularity)), errors.collect(cdk.propertyValidator("granularity", cdk.validateString)(properties.granularity)), errors.collect(cdk.propertyValidator("language", cdk.requiredValidator)(properties.language)), errors.collect(cdk.propertyValidator("language", cdk.validateString)(properties.language)), errors.wrap('supplied properties not correct for "ClarifyTextConfigProperty"');
    }
    function cfnEndpointConfigClarifyTextConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpointConfig_ClarifyTextConfigPropertyValidator(properties).assertSuccess(), { Granularity: cdk.stringToCloudFormation(properties.granularity), Language: cdk.stringToCloudFormation(properties.language) }) : properties;
    }
    function CfnEndpointConfigClarifyTextConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("granularity", "Granularity", cfn_parse.FromCloudFormation.getString(properties.Granularity)), ret.addPropertyResult("language", "Language", cfn_parse.FromCloudFormation.getString(properties.Language)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpointConfig_DataCaptureConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("captureContentTypeHeader", CfnEndpointConfig_CaptureContentTypeHeaderPropertyValidator)(properties.captureContentTypeHeader)), errors.collect(cdk.propertyValidator("captureOptions", cdk.requiredValidator)(properties.captureOptions)), errors.collect(cdk.propertyValidator("captureOptions", cdk.listValidator(CfnEndpointConfig_CaptureOptionPropertyValidator))(properties.captureOptions)), errors.collect(cdk.propertyValidator("destinationS3Uri", cdk.requiredValidator)(properties.destinationS3Uri)), errors.collect(cdk.propertyValidator("destinationS3Uri", cdk.validateString)(properties.destinationS3Uri)), errors.collect(cdk.propertyValidator("enableCapture", cdk.validateBoolean)(properties.enableCapture)), errors.collect(cdk.propertyValidator("initialSamplingPercentage", cdk.requiredValidator)(properties.initialSamplingPercentage)), errors.collect(cdk.propertyValidator("initialSamplingPercentage", cdk.validateNumber)(properties.initialSamplingPercentage)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.wrap('supplied properties not correct for "DataCaptureConfigProperty"');
    }
    function cfnEndpointConfigDataCaptureConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpointConfig_DataCaptureConfigPropertyValidator(properties).assertSuccess(), { CaptureContentTypeHeader: cfnEndpointConfigCaptureContentTypeHeaderPropertyToCloudFormation(properties.captureContentTypeHeader), CaptureOptions: cdk.listMapper(cfnEndpointConfigCaptureOptionPropertyToCloudFormation)(properties.captureOptions), DestinationS3Uri: cdk.stringToCloudFormation(properties.destinationS3Uri), EnableCapture: cdk.booleanToCloudFormation(properties.enableCapture), InitialSamplingPercentage: cdk.numberToCloudFormation(properties.initialSamplingPercentage), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId) }) : properties;
    }
    function CfnEndpointConfigDataCaptureConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("captureContentTypeHeader", "CaptureContentTypeHeader", properties.CaptureContentTypeHeader != null ? CfnEndpointConfigCaptureContentTypeHeaderPropertyFromCloudFormation(properties.CaptureContentTypeHeader) : void 0), ret.addPropertyResult("captureOptions", "CaptureOptions", cfn_parse.FromCloudFormation.getArray(CfnEndpointConfigCaptureOptionPropertyFromCloudFormation)(properties.CaptureOptions)), ret.addPropertyResult("destinationS3Uri", "DestinationS3Uri", cfn_parse.FromCloudFormation.getString(properties.DestinationS3Uri)), ret.addPropertyResult("enableCapture", "EnableCapture", properties.EnableCapture != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableCapture) : void 0), ret.addPropertyResult("initialSamplingPercentage", "InitialSamplingPercentage", cfn_parse.FromCloudFormation.getNumber(properties.InitialSamplingPercentage)), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpointConfig_ExplainerConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clarifyExplainerConfig", CfnEndpointConfig_ClarifyExplainerConfigPropertyValidator)(properties.clarifyExplainerConfig)), errors.wrap('supplied properties not correct for "ExplainerConfigProperty"');
    }
    function cfnEndpointConfigExplainerConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpointConfig_ExplainerConfigPropertyValidator(properties).assertSuccess(), { ClarifyExplainerConfig: cfnEndpointConfigClarifyExplainerConfigPropertyToCloudFormation(properties.clarifyExplainerConfig) }) : properties;
    }
    function CfnEndpointConfigExplainerConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clarifyExplainerConfig", "ClarifyExplainerConfig", properties.ClarifyExplainerConfig != null ? CfnEndpointConfigClarifyExplainerConfigPropertyFromCloudFormation(properties.ClarifyExplainerConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpointConfig_ProductionVariantPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acceleratorType", cdk.validateString)(properties.acceleratorType)), errors.collect(cdk.propertyValidator("containerStartupHealthCheckTimeoutInSeconds", cdk.validateNumber)(properties.containerStartupHealthCheckTimeoutInSeconds)), errors.collect(cdk.propertyValidator("enableSsmAccess", cdk.validateBoolean)(properties.enableSsmAccess)), errors.collect(cdk.propertyValidator("initialInstanceCount", cdk.validateNumber)(properties.initialInstanceCount)), errors.collect(cdk.propertyValidator("initialVariantWeight", cdk.requiredValidator)(properties.initialVariantWeight)), errors.collect(cdk.propertyValidator("initialVariantWeight", cdk.validateNumber)(properties.initialVariantWeight)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("modelDataDownloadTimeoutInSeconds", cdk.validateNumber)(properties.modelDataDownloadTimeoutInSeconds)), errors.collect(cdk.propertyValidator("modelName", cdk.requiredValidator)(properties.modelName)), errors.collect(cdk.propertyValidator("modelName", cdk.validateString)(properties.modelName)), errors.collect(cdk.propertyValidator("serverlessConfig", CfnEndpointConfig_ServerlessConfigPropertyValidator)(properties.serverlessConfig)), errors.collect(cdk.propertyValidator("variantName", cdk.requiredValidator)(properties.variantName)), errors.collect(cdk.propertyValidator("variantName", cdk.validateString)(properties.variantName)), errors.collect(cdk.propertyValidator("volumeSizeInGb", cdk.validateNumber)(properties.volumeSizeInGb)), errors.wrap('supplied properties not correct for "ProductionVariantProperty"');
    }
    function cfnEndpointConfigProductionVariantPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpointConfig_ProductionVariantPropertyValidator(properties).assertSuccess(), { AcceleratorType: cdk.stringToCloudFormation(properties.acceleratorType), ContainerStartupHealthCheckTimeoutInSeconds: cdk.numberToCloudFormation(properties.containerStartupHealthCheckTimeoutInSeconds), EnableSSMAccess: cdk.booleanToCloudFormation(properties.enableSsmAccess), InitialInstanceCount: cdk.numberToCloudFormation(properties.initialInstanceCount), InitialVariantWeight: cdk.numberToCloudFormation(properties.initialVariantWeight), InstanceType: cdk.stringToCloudFormation(properties.instanceType), ModelDataDownloadTimeoutInSeconds: cdk.numberToCloudFormation(properties.modelDataDownloadTimeoutInSeconds), ModelName: cdk.stringToCloudFormation(properties.modelName), ServerlessConfig: cfnEndpointConfigServerlessConfigPropertyToCloudFormation(properties.serverlessConfig), VariantName: cdk.stringToCloudFormation(properties.variantName), VolumeSizeInGB: cdk.numberToCloudFormation(properties.volumeSizeInGb) }) : properties;
    }
    function CfnEndpointConfigProductionVariantPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("acceleratorType", "AcceleratorType", properties.AcceleratorType != null ? cfn_parse.FromCloudFormation.getString(properties.AcceleratorType) : void 0), ret.addPropertyResult("containerStartupHealthCheckTimeoutInSeconds", "ContainerStartupHealthCheckTimeoutInSeconds", properties.ContainerStartupHealthCheckTimeoutInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.ContainerStartupHealthCheckTimeoutInSeconds) : void 0), ret.addPropertyResult("enableSsmAccess", "EnableSSMAccess", properties.EnableSSMAccess != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableSSMAccess) : void 0), ret.addPropertyResult("initialInstanceCount", "InitialInstanceCount", properties.InitialInstanceCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.InitialInstanceCount) : void 0), ret.addPropertyResult("initialVariantWeight", "InitialVariantWeight", cfn_parse.FromCloudFormation.getNumber(properties.InitialVariantWeight)), ret.addPropertyResult("instanceType", "InstanceType", properties.InstanceType != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceType) : void 0), ret.addPropertyResult("modelDataDownloadTimeoutInSeconds", "ModelDataDownloadTimeoutInSeconds", properties.ModelDataDownloadTimeoutInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.ModelDataDownloadTimeoutInSeconds) : void 0), ret.addPropertyResult("modelName", "ModelName", cfn_parse.FromCloudFormation.getString(properties.ModelName)), ret.addPropertyResult("serverlessConfig", "ServerlessConfig", properties.ServerlessConfig != null ? CfnEndpointConfigServerlessConfigPropertyFromCloudFormation(properties.ServerlessConfig) : void 0), ret.addPropertyResult("variantName", "VariantName", cfn_parse.FromCloudFormation.getString(properties.VariantName)), ret.addPropertyResult("volumeSizeInGb", "VolumeSizeInGB", properties.VolumeSizeInGB != null ? cfn_parse.FromCloudFormation.getNumber(properties.VolumeSizeInGB) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEndpointConfig_ServerlessConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxConcurrency", cdk.requiredValidator)(properties.maxConcurrency)), errors.collect(cdk.propertyValidator("maxConcurrency", cdk.validateNumber)(properties.maxConcurrency)), errors.collect(cdk.propertyValidator("memorySizeInMb", cdk.requiredValidator)(properties.memorySizeInMb)), errors.collect(cdk.propertyValidator("memorySizeInMb", cdk.validateNumber)(properties.memorySizeInMb)), errors.collect(cdk.propertyValidator("provisionedConcurrency", cdk.validateNumber)(properties.provisionedConcurrency)), errors.wrap('supplied properties not correct for "ServerlessConfigProperty"');
    }
    function cfnEndpointConfigServerlessConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEndpointConfig_ServerlessConfigPropertyValidator(properties).assertSuccess(), { MaxConcurrency: cdk.numberToCloudFormation(properties.maxConcurrency), MemorySizeInMB: cdk.numberToCloudFormation(properties.memorySizeInMb), ProvisionedConcurrency: cdk.numberToCloudFormation(properties.provisionedConcurrency) }) : properties;
    }
    function CfnEndpointConfigServerlessConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxConcurrency", "MaxConcurrency", cfn_parse.FromCloudFormation.getNumber(properties.MaxConcurrency)), ret.addPropertyResult("memorySizeInMb", "MemorySizeInMB", cfn_parse.FromCloudFormation.getNumber(properties.MemorySizeInMB)), ret.addPropertyResult("provisionedConcurrency", "ProvisionedConcurrency", properties.ProvisionedConcurrency != null ? cfn_parse.FromCloudFormation.getNumber(properties.ProvisionedConcurrency) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnFeatureGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("eventTimeFeatureName", cdk.requiredValidator)(properties.eventTimeFeatureName)), errors.collect(cdk.propertyValidator("eventTimeFeatureName", cdk.validateString)(properties.eventTimeFeatureName)), errors.collect(cdk.propertyValidator("featureDefinitions", cdk.requiredValidator)(properties.featureDefinitions)), errors.collect(cdk.propertyValidator("featureDefinitions", cdk.listValidator(CfnFeatureGroup_FeatureDefinitionPropertyValidator))(properties.featureDefinitions)), errors.collect(cdk.propertyValidator("featureGroupName", cdk.requiredValidator)(properties.featureGroupName)), errors.collect(cdk.propertyValidator("featureGroupName", cdk.validateString)(properties.featureGroupName)), errors.collect(cdk.propertyValidator("offlineStoreConfig", cdk.validateObject)(properties.offlineStoreConfig)), errors.collect(cdk.propertyValidator("onlineStoreConfig", cdk.validateObject)(properties.onlineStoreConfig)), errors.collect(cdk.propertyValidator("recordIdentifierFeatureName", cdk.requiredValidator)(properties.recordIdentifierFeatureName)), errors.collect(cdk.propertyValidator("recordIdentifierFeatureName", cdk.validateString)(properties.recordIdentifierFeatureName)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnFeatureGroupProps"');
    }
    function cfnFeatureGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFeatureGroupPropsValidator(properties).assertSuccess(), { EventTimeFeatureName: cdk.stringToCloudFormation(properties.eventTimeFeatureName), FeatureDefinitions: cdk.listMapper(cfnFeatureGroupFeatureDefinitionPropertyToCloudFormation)(properties.featureDefinitions), FeatureGroupName: cdk.stringToCloudFormation(properties.featureGroupName), RecordIdentifierFeatureName: cdk.stringToCloudFormation(properties.recordIdentifierFeatureName), Description: cdk.stringToCloudFormation(properties.description), OfflineStoreConfig: cdk.objectToCloudFormation(properties.offlineStoreConfig), OnlineStoreConfig: cdk.objectToCloudFormation(properties.onlineStoreConfig), RoleArn: cdk.stringToCloudFormation(properties.roleArn), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnFeatureGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("eventTimeFeatureName", "EventTimeFeatureName", cfn_parse.FromCloudFormation.getString(properties.EventTimeFeatureName)), ret.addPropertyResult("featureDefinitions", "FeatureDefinitions", cfn_parse.FromCloudFormation.getArray(CfnFeatureGroupFeatureDefinitionPropertyFromCloudFormation)(properties.FeatureDefinitions)), ret.addPropertyResult("featureGroupName", "FeatureGroupName", cfn_parse.FromCloudFormation.getString(properties.FeatureGroupName)), ret.addPropertyResult("recordIdentifierFeatureName", "RecordIdentifierFeatureName", cfn_parse.FromCloudFormation.getString(properties.RecordIdentifierFeatureName)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("offlineStoreConfig", "OfflineStoreConfig", properties.OfflineStoreConfig != null ? cfn_parse.FromCloudFormation.getAny(properties.OfflineStoreConfig) : void 0), ret.addPropertyResult("onlineStoreConfig", "OnlineStoreConfig", properties.OnlineStoreConfig != null ? cfn_parse.FromCloudFormation.getAny(properties.OnlineStoreConfig) : void 0), ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnFeatureGroup = class _CfnFeatureGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnFeatureGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnFeatureGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnFeatureGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sagemaker_CfnFeatureGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnFeatureGroup), error;
        }
        cdk.requireProperty(props, "eventTimeFeatureName", this), cdk.requireProperty(props, "featureDefinitions", this), cdk.requireProperty(props, "featureGroupName", this), cdk.requireProperty(props, "recordIdentifierFeatureName", this), this.eventTimeFeatureName = props.eventTimeFeatureName, this.featureDefinitions = props.featureDefinitions, this.featureGroupName = props.featureGroupName, this.recordIdentifierFeatureName = props.recordIdentifierFeatureName, this.description = props.description, this.offlineStoreConfig = props.offlineStoreConfig, this.onlineStoreConfig = props.onlineStoreConfig, this.roleArn = props.roleArn, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SageMaker::FeatureGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnFeatureGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { eventTimeFeatureName: this.eventTimeFeatureName, featureDefinitions: this.featureDefinitions, featureGroupName: this.featureGroupName, recordIdentifierFeatureName: this.recordIdentifierFeatureName, description: this.description, offlineStoreConfig: this.offlineStoreConfig, onlineStoreConfig: this.onlineStoreConfig, roleArn: this.roleArn, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnFeatureGroupPropsToCloudFormation(props);
      }
    };
    _k = JSII_RTTI_SYMBOL_1, CfnFeatureGroup[_k] = { fqn: "aws-cdk-lib.aws_sagemaker.CfnFeatureGroup", version: "2.80.0" }, CfnFeatureGroup.CFN_RESOURCE_TYPE_NAME = "AWS::SageMaker::FeatureGroup", exports2.CfnFeatureGroup = CfnFeatureGroup;
    function CfnFeatureGroup_FeatureDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("featureName", cdk.requiredValidator)(properties.featureName)), errors.collect(cdk.propertyValidator("featureName", cdk.validateString)(properties.featureName)), errors.collect(cdk.propertyValidator("featureType", cdk.requiredValidator)(properties.featureType)), errors.collect(cdk.propertyValidator("featureType", cdk.validateString)(properties.featureType)), errors.wrap('supplied properties not correct for "FeatureDefinitionProperty"');
    }
    function cfnFeatureGroupFeatureDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnFeatureGroup_FeatureDefinitionPropertyValidator(properties).assertSuccess(), { FeatureName: cdk.stringToCloudFormation(properties.featureName), FeatureType: cdk.stringToCloudFormation(properties.featureType) }) : properties;
    }
    function CfnFeatureGroupFeatureDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("featureName", "FeatureName", cfn_parse.FromCloudFormation.getString(properties.FeatureName)), ret.addPropertyResult("featureType", "FeatureType", cfn_parse.FromCloudFormation.getString(properties.FeatureType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnImagePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("imageDescription", cdk.validateString)(properties.imageDescription)), errors.collect(cdk.propertyValidator("imageDisplayName", cdk.validateString)(properties.imageDisplayName)), errors.collect(cdk.propertyValidator("imageName", cdk.requiredValidator)(properties.imageName)), errors.collect(cdk.propertyValidator("imageName", cdk.validateString)(properties.imageName)), errors.collect(cdk.propertyValidator("imageRoleArn", cdk.requiredValidator)(properties.imageRoleArn)), errors.collect(cdk.propertyValidator("imageRoleArn", cdk.validateString)(properties.imageRoleArn)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnImageProps"');
    }
    function cfnImagePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnImagePropsValidator(properties).assertSuccess(), { ImageName: cdk.stringToCloudFormation(properties.imageName), ImageRoleArn: cdk.stringToCloudFormation(properties.imageRoleArn), ImageDescription: cdk.stringToCloudFormation(properties.imageDescription), ImageDisplayName: cdk.stringToCloudFormation(properties.imageDisplayName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnImagePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("imageName", "ImageName", cfn_parse.FromCloudFormation.getString(properties.ImageName)), ret.addPropertyResult("imageRoleArn", "ImageRoleArn", cfn_parse.FromCloudFormation.getString(properties.ImageRoleArn)), ret.addPropertyResult("imageDescription", "ImageDescription", properties.ImageDescription != null ? cfn_parse.FromCloudFormation.getString(properties.ImageDescription) : void 0), ret.addPropertyResult("imageDisplayName", "ImageDisplayName", properties.ImageDisplayName != null ? cfn_parse.FromCloudFormation.getString(properties.ImageDisplayName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnImage = class _CfnImage extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnImagePropsFromCloudFormation(resourceProperties), ret = new _CfnImage(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnImage.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sagemaker_CfnImageProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnImage), error;
        }
        cdk.requireProperty(props, "imageName", this), cdk.requireProperty(props, "imageRoleArn", this), this.attrImageArn = cdk.Token.asString(this.getAtt("ImageArn", cdk.ResolutionTypeHint.STRING)), this.imageName = props.imageName, this.imageRoleArn = props.imageRoleArn, this.imageDescription = props.imageDescription, this.imageDisplayName = props.imageDisplayName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SageMaker::Image", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnImage.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { imageName: this.imageName, imageRoleArn: this.imageRoleArn, imageDescription: this.imageDescription, imageDisplayName: this.imageDisplayName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnImagePropsToCloudFormation(props);
      }
    };
    _l = JSII_RTTI_SYMBOL_1, CfnImage[_l] = { fqn: "aws-cdk-lib.aws_sagemaker.CfnImage", version: "2.80.0" }, CfnImage.CFN_RESOURCE_TYPE_NAME = "AWS::SageMaker::Image", exports2.CfnImage = CfnImage;
    function CfnImageVersionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("baseImage", cdk.requiredValidator)(properties.baseImage)), errors.collect(cdk.propertyValidator("baseImage", cdk.validateString)(properties.baseImage)), errors.collect(cdk.propertyValidator("imageName", cdk.requiredValidator)(properties.imageName)), errors.collect(cdk.propertyValidator("imageName", cdk.validateString)(properties.imageName)), errors.wrap('supplied properties not correct for "CfnImageVersionProps"');
    }
    function cfnImageVersionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnImageVersionPropsValidator(properties).assertSuccess(), { BaseImage: cdk.stringToCloudFormation(properties.baseImage), ImageName: cdk.stringToCloudFormation(properties.imageName) }) : properties;
    }
    function CfnImageVersionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("baseImage", "BaseImage", cfn_parse.FromCloudFormation.getString(properties.BaseImage)), ret.addPropertyResult("imageName", "ImageName", cfn_parse.FromCloudFormation.getString(properties.ImageName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnImageVersion = class _CfnImageVersion extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnImageVersionPropsFromCloudFormation(resourceProperties), ret = new _CfnImageVersion(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnImageVersion.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sagemaker_CfnImageVersionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnImageVersion), error;
        }
        cdk.requireProperty(props, "baseImage", this), cdk.requireProperty(props, "imageName", this), this.attrContainerImage = cdk.Token.asString(this.getAtt("ContainerImage", cdk.ResolutionTypeHint.STRING)), this.attrImageArn = cdk.Token.asString(this.getAtt("ImageArn", cdk.ResolutionTypeHint.STRING)), this.attrImageVersionArn = cdk.Token.asString(this.getAtt("ImageVersionArn", cdk.ResolutionTypeHint.STRING)), this.attrVersion = cdk.Token.asNumber(this.getAtt("Version", cdk.ResolutionTypeHint.NUMBER)), this.baseImage = props.baseImage, this.imageName = props.imageName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnImageVersion.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { baseImage: this.baseImage, imageName: this.imageName };
      }
      renderProperties(props) {
        return cfnImageVersionPropsToCloudFormation(props);
      }
    };
    _m = JSII_RTTI_SYMBOL_1, CfnImageVersion[_m] = { fqn: "aws-cdk-lib.aws_sagemaker.CfnImageVersion", version: "2.80.0" }, CfnImageVersion.CFN_RESOURCE_TYPE_NAME = "AWS::SageMaker::ImageVersion", exports2.CfnImageVersion = CfnImageVersion;
    function CfnInferenceExperimentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataStorageConfig", CfnInferenceExperiment_DataStorageConfigPropertyValidator)(properties.dataStorageConfig)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("desiredState", cdk.validateString)(properties.desiredState)), errors.collect(cdk.propertyValidator("endpointName", cdk.requiredValidator)(properties.endpointName)), errors.collect(cdk.propertyValidator("endpointName", cdk.validateString)(properties.endpointName)), errors.collect(cdk.propertyValidator("kmsKey", cdk.validateString)(properties.kmsKey)), errors.collect(cdk.propertyValidator("modelVariants", cdk.requiredValidator)(properties.modelVariants)), errors.collect(cdk.propertyValidator("modelVariants", cdk.listValidator(CfnInferenceExperiment_ModelVariantConfigPropertyValidator))(properties.modelVariants)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("schedule", CfnInferenceExperiment_InferenceExperimentSchedulePropertyValidator)(properties.schedule)), errors.collect(cdk.propertyValidator("shadowModeConfig", CfnInferenceExperiment_ShadowModeConfigPropertyValidator)(properties.shadowModeConfig)), errors.collect(cdk.propertyValidator("statusReason", cdk.validateString)(properties.statusReason)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnInferenceExperimentProps"');
    }
    function cfnInferenceExperimentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInferenceExperimentPropsValidator(properties).assertSuccess(), { EndpointName: cdk.stringToCloudFormation(properties.endpointName), ModelVariants: cdk.listMapper(cfnInferenceExperimentModelVariantConfigPropertyToCloudFormation)(properties.modelVariants), Name: cdk.stringToCloudFormation(properties.name), RoleArn: cdk.stringToCloudFormation(properties.roleArn), Type: cdk.stringToCloudFormation(properties.type), DataStorageConfig: cfnInferenceExperimentDataStorageConfigPropertyToCloudFormation(properties.dataStorageConfig), Description: cdk.stringToCloudFormation(properties.description), DesiredState: cdk.stringToCloudFormation(properties.desiredState), KmsKey: cdk.stringToCloudFormation(properties.kmsKey), Schedule: cfnInferenceExperimentInferenceExperimentSchedulePropertyToCloudFormation(properties.schedule), ShadowModeConfig: cfnInferenceExperimentShadowModeConfigPropertyToCloudFormation(properties.shadowModeConfig), StatusReason: cdk.stringToCloudFormation(properties.statusReason), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnInferenceExperimentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endpointName", "EndpointName", cfn_parse.FromCloudFormation.getString(properties.EndpointName)), ret.addPropertyResult("modelVariants", "ModelVariants", cfn_parse.FromCloudFormation.getArray(CfnInferenceExperimentModelVariantConfigPropertyFromCloudFormation)(properties.ModelVariants)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("dataStorageConfig", "DataStorageConfig", properties.DataStorageConfig != null ? CfnInferenceExperimentDataStorageConfigPropertyFromCloudFormation(properties.DataStorageConfig) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("desiredState", "DesiredState", properties.DesiredState != null ? cfn_parse.FromCloudFormation.getString(properties.DesiredState) : void 0), ret.addPropertyResult("kmsKey", "KmsKey", properties.KmsKey != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKey) : void 0), ret.addPropertyResult("schedule", "Schedule", properties.Schedule != null ? CfnInferenceExperimentInferenceExperimentSchedulePropertyFromCloudFormation(properties.Schedule) : void 0), ret.addPropertyResult("shadowModeConfig", "ShadowModeConfig", properties.ShadowModeConfig != null ? CfnInferenceExperimentShadowModeConfigPropertyFromCloudFormation(properties.ShadowModeConfig) : void 0), ret.addPropertyResult("statusReason", "StatusReason", properties.StatusReason != null ? cfn_parse.FromCloudFormation.getString(properties.StatusReason) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnInferenceExperiment = class _CfnInferenceExperiment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnInferenceExperimentPropsFromCloudFormation(resourceProperties), ret = new _CfnInferenceExperiment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnInferenceExperiment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sagemaker_CfnInferenceExperimentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnInferenceExperiment), error;
        }
        cdk.requireProperty(props, "endpointName", this), cdk.requireProperty(props, "modelVariants", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "roleArn", this), cdk.requireProperty(props, "type", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrEndpointMetadataEndpointConfigName = cdk.Token.asString(this.getAtt("EndpointMetadata.EndpointConfigName", cdk.ResolutionTypeHint.STRING)), this.attrEndpointMetadataEndpointName = cdk.Token.asString(this.getAtt("EndpointMetadata.EndpointName", cdk.ResolutionTypeHint.STRING)), this.attrEndpointMetadataEndpointStatus = cdk.Token.asString(this.getAtt("EndpointMetadata.EndpointStatus", cdk.ResolutionTypeHint.STRING)), this.attrLastModifiedTime = cdk.Token.asString(this.getAtt("LastModifiedTime", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.endpointName = props.endpointName, this.modelVariants = props.modelVariants, this.name = props.name, this.roleArn = props.roleArn, this.type = props.type, this.dataStorageConfig = props.dataStorageConfig, this.description = props.description, this.desiredState = props.desiredState, this.kmsKey = props.kmsKey, this.schedule = props.schedule, this.shadowModeConfig = props.shadowModeConfig, this.statusReason = props.statusReason, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SageMaker::InferenceExperiment", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnInferenceExperiment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { endpointName: this.endpointName, modelVariants: this.modelVariants, name: this.name, roleArn: this.roleArn, type: this.type, dataStorageConfig: this.dataStorageConfig, description: this.description, desiredState: this.desiredState, kmsKey: this.kmsKey, schedule: this.schedule, shadowModeConfig: this.shadowModeConfig, statusReason: this.statusReason, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnInferenceExperimentPropsToCloudFormation(props);
      }
    };
    _o = JSII_RTTI_SYMBOL_1, CfnInferenceExperiment[_o] = { fqn: "aws-cdk-lib.aws_sagemaker.CfnInferenceExperiment", version: "2.80.0" }, CfnInferenceExperiment.CFN_RESOURCE_TYPE_NAME = "AWS::SageMaker::InferenceExperiment", exports2.CfnInferenceExperiment = CfnInferenceExperiment;
    function CfnInferenceExperiment_CaptureContentTypeHeaderPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("csvContentTypes", cdk.listValidator(cdk.validateString))(properties.csvContentTypes)), errors.collect(cdk.propertyValidator("jsonContentTypes", cdk.listValidator(cdk.validateString))(properties.jsonContentTypes)), errors.wrap('supplied properties not correct for "CaptureContentTypeHeaderProperty"');
    }
    function cfnInferenceExperimentCaptureContentTypeHeaderPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInferenceExperiment_CaptureContentTypeHeaderPropertyValidator(properties).assertSuccess(), { CsvContentTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.csvContentTypes), JsonContentTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.jsonContentTypes) }) : properties;
    }
    function CfnInferenceExperimentCaptureContentTypeHeaderPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("csvContentTypes", "CsvContentTypes", properties.CsvContentTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CsvContentTypes) : void 0), ret.addPropertyResult("jsonContentTypes", "JsonContentTypes", properties.JsonContentTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.JsonContentTypes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInferenceExperiment_DataStorageConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contentType", CfnInferenceExperiment_CaptureContentTypeHeaderPropertyValidator)(properties.contentType)), errors.collect(cdk.propertyValidator("destination", cdk.requiredValidator)(properties.destination)), errors.collect(cdk.propertyValidator("destination", cdk.validateString)(properties.destination)), errors.collect(cdk.propertyValidator("kmsKey", cdk.validateString)(properties.kmsKey)), errors.wrap('supplied properties not correct for "DataStorageConfigProperty"');
    }
    function cfnInferenceExperimentDataStorageConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInferenceExperiment_DataStorageConfigPropertyValidator(properties).assertSuccess(), { ContentType: cfnInferenceExperimentCaptureContentTypeHeaderPropertyToCloudFormation(properties.contentType), Destination: cdk.stringToCloudFormation(properties.destination), KmsKey: cdk.stringToCloudFormation(properties.kmsKey) }) : properties;
    }
    function CfnInferenceExperimentDataStorageConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contentType", "ContentType", properties.ContentType != null ? CfnInferenceExperimentCaptureContentTypeHeaderPropertyFromCloudFormation(properties.ContentType) : void 0), ret.addPropertyResult("destination", "Destination", cfn_parse.FromCloudFormation.getString(properties.Destination)), ret.addPropertyResult("kmsKey", "KmsKey", properties.KmsKey != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKey) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInferenceExperiment_InferenceExperimentSchedulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endTime", cdk.validateString)(properties.endTime)), errors.collect(cdk.propertyValidator("startTime", cdk.validateString)(properties.startTime)), errors.wrap('supplied properties not correct for "InferenceExperimentScheduleProperty"');
    }
    function cfnInferenceExperimentInferenceExperimentSchedulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInferenceExperiment_InferenceExperimentSchedulePropertyValidator(properties).assertSuccess(), { EndTime: cdk.stringToCloudFormation(properties.endTime), StartTime: cdk.stringToCloudFormation(properties.startTime) }) : properties;
    }
    function CfnInferenceExperimentInferenceExperimentSchedulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endTime", "EndTime", properties.EndTime != null ? cfn_parse.FromCloudFormation.getString(properties.EndTime) : void 0), ret.addPropertyResult("startTime", "StartTime", properties.StartTime != null ? cfn_parse.FromCloudFormation.getString(properties.StartTime) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInferenceExperiment_ModelInfrastructureConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("infrastructureType", cdk.requiredValidator)(properties.infrastructureType)), errors.collect(cdk.propertyValidator("infrastructureType", cdk.validateString)(properties.infrastructureType)), errors.collect(cdk.propertyValidator("realTimeInferenceConfig", cdk.requiredValidator)(properties.realTimeInferenceConfig)), errors.collect(cdk.propertyValidator("realTimeInferenceConfig", CfnInferenceExperiment_RealTimeInferenceConfigPropertyValidator)(properties.realTimeInferenceConfig)), errors.wrap('supplied properties not correct for "ModelInfrastructureConfigProperty"');
    }
    function cfnInferenceExperimentModelInfrastructureConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInferenceExperiment_ModelInfrastructureConfigPropertyValidator(properties).assertSuccess(), { InfrastructureType: cdk.stringToCloudFormation(properties.infrastructureType), RealTimeInferenceConfig: cfnInferenceExperimentRealTimeInferenceConfigPropertyToCloudFormation(properties.realTimeInferenceConfig) }) : properties;
    }
    function CfnInferenceExperimentModelInfrastructureConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("infrastructureType", "InfrastructureType", cfn_parse.FromCloudFormation.getString(properties.InfrastructureType)), ret.addPropertyResult("realTimeInferenceConfig", "RealTimeInferenceConfig", CfnInferenceExperimentRealTimeInferenceConfigPropertyFromCloudFormation(properties.RealTimeInferenceConfig)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInferenceExperiment_ModelVariantConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("infrastructureConfig", cdk.requiredValidator)(properties.infrastructureConfig)), errors.collect(cdk.propertyValidator("infrastructureConfig", CfnInferenceExperiment_ModelInfrastructureConfigPropertyValidator)(properties.infrastructureConfig)), errors.collect(cdk.propertyValidator("modelName", cdk.requiredValidator)(properties.modelName)), errors.collect(cdk.propertyValidator("modelName", cdk.validateString)(properties.modelName)), errors.collect(cdk.propertyValidator("variantName", cdk.requiredValidator)(properties.variantName)), errors.collect(cdk.propertyValidator("variantName", cdk.validateString)(properties.variantName)), errors.wrap('supplied properties not correct for "ModelVariantConfigProperty"');
    }
    function cfnInferenceExperimentModelVariantConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInferenceExperiment_ModelVariantConfigPropertyValidator(properties).assertSuccess(), { InfrastructureConfig: cfnInferenceExperimentModelInfrastructureConfigPropertyToCloudFormation(properties.infrastructureConfig), ModelName: cdk.stringToCloudFormation(properties.modelName), VariantName: cdk.stringToCloudFormation(properties.variantName) }) : properties;
    }
    function CfnInferenceExperimentModelVariantConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("infrastructureConfig", "InfrastructureConfig", CfnInferenceExperimentModelInfrastructureConfigPropertyFromCloudFormation(properties.InfrastructureConfig)), ret.addPropertyResult("modelName", "ModelName", cfn_parse.FromCloudFormation.getString(properties.ModelName)), ret.addPropertyResult("variantName", "VariantName", cfn_parse.FromCloudFormation.getString(properties.VariantName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInferenceExperiment_RealTimeInferenceConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceCount", cdk.requiredValidator)(properties.instanceCount)), errors.collect(cdk.propertyValidator("instanceCount", cdk.validateNumber)(properties.instanceCount)), errors.collect(cdk.propertyValidator("instanceType", cdk.requiredValidator)(properties.instanceType)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.wrap('supplied properties not correct for "RealTimeInferenceConfigProperty"');
    }
    function cfnInferenceExperimentRealTimeInferenceConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInferenceExperiment_RealTimeInferenceConfigPropertyValidator(properties).assertSuccess(), { InstanceCount: cdk.numberToCloudFormation(properties.instanceCount), InstanceType: cdk.stringToCloudFormation(properties.instanceType) }) : properties;
    }
    function CfnInferenceExperimentRealTimeInferenceConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceCount", "InstanceCount", cfn_parse.FromCloudFormation.getNumber(properties.InstanceCount)), ret.addPropertyResult("instanceType", "InstanceType", cfn_parse.FromCloudFormation.getString(properties.InstanceType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInferenceExperiment_ShadowModeConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("shadowModelVariants", cdk.requiredValidator)(properties.shadowModelVariants)), errors.collect(cdk.propertyValidator("shadowModelVariants", cdk.listValidator(CfnInferenceExperiment_ShadowModelVariantConfigPropertyValidator))(properties.shadowModelVariants)), errors.collect(cdk.propertyValidator("sourceModelVariantName", cdk.requiredValidator)(properties.sourceModelVariantName)), errors.collect(cdk.propertyValidator("sourceModelVariantName", cdk.validateString)(properties.sourceModelVariantName)), errors.wrap('supplied properties not correct for "ShadowModeConfigProperty"');
    }
    function cfnInferenceExperimentShadowModeConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInferenceExperiment_ShadowModeConfigPropertyValidator(properties).assertSuccess(), { ShadowModelVariants: cdk.listMapper(cfnInferenceExperimentShadowModelVariantConfigPropertyToCloudFormation)(properties.shadowModelVariants), SourceModelVariantName: cdk.stringToCloudFormation(properties.sourceModelVariantName) }) : properties;
    }
    function CfnInferenceExperimentShadowModeConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("shadowModelVariants", "ShadowModelVariants", cfn_parse.FromCloudFormation.getArray(CfnInferenceExperimentShadowModelVariantConfigPropertyFromCloudFormation)(properties.ShadowModelVariants)), ret.addPropertyResult("sourceModelVariantName", "SourceModelVariantName", cfn_parse.FromCloudFormation.getString(properties.SourceModelVariantName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInferenceExperiment_ShadowModelVariantConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("samplingPercentage", cdk.requiredValidator)(properties.samplingPercentage)), errors.collect(cdk.propertyValidator("samplingPercentage", cdk.validateNumber)(properties.samplingPercentage)), errors.collect(cdk.propertyValidator("shadowModelVariantName", cdk.requiredValidator)(properties.shadowModelVariantName)), errors.collect(cdk.propertyValidator("shadowModelVariantName", cdk.validateString)(properties.shadowModelVariantName)), errors.wrap('supplied properties not correct for "ShadowModelVariantConfigProperty"');
    }
    function cfnInferenceExperimentShadowModelVariantConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInferenceExperiment_ShadowModelVariantConfigPropertyValidator(properties).assertSuccess(), { SamplingPercentage: cdk.numberToCloudFormation(properties.samplingPercentage), ShadowModelVariantName: cdk.stringToCloudFormation(properties.shadowModelVariantName) }) : properties;
    }
    function CfnInferenceExperimentShadowModelVariantConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("samplingPercentage", "SamplingPercentage", cfn_parse.FromCloudFormation.getNumber(properties.SamplingPercentage)), ret.addPropertyResult("shadowModelVariantName", "ShadowModelVariantName", cfn_parse.FromCloudFormation.getString(properties.ShadowModelVariantName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containers", cdk.listValidator(CfnModel_ContainerDefinitionPropertyValidator))(properties.containers)), errors.collect(cdk.propertyValidator("enableNetworkIsolation", cdk.validateBoolean)(properties.enableNetworkIsolation)), errors.collect(cdk.propertyValidator("executionRoleArn", cdk.requiredValidator)(properties.executionRoleArn)), errors.collect(cdk.propertyValidator("executionRoleArn", cdk.validateString)(properties.executionRoleArn)), errors.collect(cdk.propertyValidator("inferenceExecutionConfig", CfnModel_InferenceExecutionConfigPropertyValidator)(properties.inferenceExecutionConfig)), errors.collect(cdk.propertyValidator("modelName", cdk.validateString)(properties.modelName)), errors.collect(cdk.propertyValidator("primaryContainer", CfnModel_ContainerDefinitionPropertyValidator)(properties.primaryContainer)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpcConfig", CfnModel_VpcConfigPropertyValidator)(properties.vpcConfig)), errors.wrap('supplied properties not correct for "CfnModelProps"');
    }
    function cfnModelPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPropsValidator(properties).assertSuccess(), { ExecutionRoleArn: cdk.stringToCloudFormation(properties.executionRoleArn), Containers: cdk.listMapper(cfnModelContainerDefinitionPropertyToCloudFormation)(properties.containers), EnableNetworkIsolation: cdk.booleanToCloudFormation(properties.enableNetworkIsolation), InferenceExecutionConfig: cfnModelInferenceExecutionConfigPropertyToCloudFormation(properties.inferenceExecutionConfig), ModelName: cdk.stringToCloudFormation(properties.modelName), PrimaryContainer: cfnModelContainerDefinitionPropertyToCloudFormation(properties.primaryContainer), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VpcConfig: cfnModelVpcConfigPropertyToCloudFormation(properties.vpcConfig) }) : properties;
    }
    function CfnModelPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("executionRoleArn", "ExecutionRoleArn", cfn_parse.FromCloudFormation.getString(properties.ExecutionRoleArn)), ret.addPropertyResult("containers", "Containers", properties.Containers != null ? cfn_parse.FromCloudFormation.getArray(CfnModelContainerDefinitionPropertyFromCloudFormation)(properties.Containers) : void 0), ret.addPropertyResult("enableNetworkIsolation", "EnableNetworkIsolation", properties.EnableNetworkIsolation != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableNetworkIsolation) : void 0), ret.addPropertyResult("inferenceExecutionConfig", "InferenceExecutionConfig", properties.InferenceExecutionConfig != null ? CfnModelInferenceExecutionConfigPropertyFromCloudFormation(properties.InferenceExecutionConfig) : void 0), ret.addPropertyResult("modelName", "ModelName", properties.ModelName != null ? cfn_parse.FromCloudFormation.getString(properties.ModelName) : void 0), ret.addPropertyResult("primaryContainer", "PrimaryContainer", properties.PrimaryContainer != null ? CfnModelContainerDefinitionPropertyFromCloudFormation(properties.PrimaryContainer) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("vpcConfig", "VpcConfig", properties.VpcConfig != null ? CfnModelVpcConfigPropertyFromCloudFormation(properties.VpcConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnModel = class _CfnModel extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnModelPropsFromCloudFormation(resourceProperties), ret = new _CfnModel(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnModel.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sagemaker_CfnModelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnModel), error;
        }
        cdk.requireProperty(props, "executionRoleArn", this), this.attrModelName = cdk.Token.asString(this.getAtt("ModelName", cdk.ResolutionTypeHint.STRING)), this.executionRoleArn = props.executionRoleArn, this.containers = props.containers, this.enableNetworkIsolation = props.enableNetworkIsolation, this.inferenceExecutionConfig = props.inferenceExecutionConfig, this.modelName = props.modelName, this.primaryContainer = props.primaryContainer, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SageMaker::Model", props.tags, { tagPropertyName: "tags" }), this.vpcConfig = props.vpcConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnModel.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { executionRoleArn: this.executionRoleArn, containers: this.containers, enableNetworkIsolation: this.enableNetworkIsolation, inferenceExecutionConfig: this.inferenceExecutionConfig, modelName: this.modelName, primaryContainer: this.primaryContainer, tags: this.tags.renderTags(), vpcConfig: this.vpcConfig };
      }
      renderProperties(props) {
        return cfnModelPropsToCloudFormation(props);
      }
    };
    _p = JSII_RTTI_SYMBOL_1, CfnModel[_p] = { fqn: "aws-cdk-lib.aws_sagemaker.CfnModel", version: "2.80.0" }, CfnModel.CFN_RESOURCE_TYPE_NAME = "AWS::SageMaker::Model", exports2.CfnModel = CfnModel;
    function CfnModel_ContainerDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containerHostname", cdk.validateString)(properties.containerHostname)), errors.collect(cdk.propertyValidator("environment", cdk.validateObject)(properties.environment)), errors.collect(cdk.propertyValidator("image", cdk.validateString)(properties.image)), errors.collect(cdk.propertyValidator("imageConfig", CfnModel_ImageConfigPropertyValidator)(properties.imageConfig)), errors.collect(cdk.propertyValidator("inferenceSpecificationName", cdk.validateString)(properties.inferenceSpecificationName)), errors.collect(cdk.propertyValidator("mode", cdk.validateString)(properties.mode)), errors.collect(cdk.propertyValidator("modelDataUrl", cdk.validateString)(properties.modelDataUrl)), errors.collect(cdk.propertyValidator("modelPackageName", cdk.validateString)(properties.modelPackageName)), errors.collect(cdk.propertyValidator("multiModelConfig", CfnModel_MultiModelConfigPropertyValidator)(properties.multiModelConfig)), errors.wrap('supplied properties not correct for "ContainerDefinitionProperty"');
    }
    function cfnModelContainerDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModel_ContainerDefinitionPropertyValidator(properties).assertSuccess(), { ContainerHostname: cdk.stringToCloudFormation(properties.containerHostname), Environment: cdk.objectToCloudFormation(properties.environment), Image: cdk.stringToCloudFormation(properties.image), ImageConfig: cfnModelImageConfigPropertyToCloudFormation(properties.imageConfig), InferenceSpecificationName: cdk.stringToCloudFormation(properties.inferenceSpecificationName), Mode: cdk.stringToCloudFormation(properties.mode), ModelDataUrl: cdk.stringToCloudFormation(properties.modelDataUrl), ModelPackageName: cdk.stringToCloudFormation(properties.modelPackageName), MultiModelConfig: cfnModelMultiModelConfigPropertyToCloudFormation(properties.multiModelConfig) }) : properties;
    }
    function CfnModelContainerDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containerHostname", "ContainerHostname", properties.ContainerHostname != null ? cfn_parse.FromCloudFormation.getString(properties.ContainerHostname) : void 0), ret.addPropertyResult("environment", "Environment", properties.Environment != null ? cfn_parse.FromCloudFormation.getAny(properties.Environment) : void 0), ret.addPropertyResult("image", "Image", properties.Image != null ? cfn_parse.FromCloudFormation.getString(properties.Image) : void 0), ret.addPropertyResult("imageConfig", "ImageConfig", properties.ImageConfig != null ? CfnModelImageConfigPropertyFromCloudFormation(properties.ImageConfig) : void 0), ret.addPropertyResult("inferenceSpecificationName", "InferenceSpecificationName", properties.InferenceSpecificationName != null ? cfn_parse.FromCloudFormation.getString(properties.InferenceSpecificationName) : void 0), ret.addPropertyResult("mode", "Mode", properties.Mode != null ? cfn_parse.FromCloudFormation.getString(properties.Mode) : void 0), ret.addPropertyResult("modelDataUrl", "ModelDataUrl", properties.ModelDataUrl != null ? cfn_parse.FromCloudFormation.getString(properties.ModelDataUrl) : void 0), ret.addPropertyResult("modelPackageName", "ModelPackageName", properties.ModelPackageName != null ? cfn_parse.FromCloudFormation.getString(properties.ModelPackageName) : void 0), ret.addPropertyResult("multiModelConfig", "MultiModelConfig", properties.MultiModelConfig != null ? CfnModelMultiModelConfigPropertyFromCloudFormation(properties.MultiModelConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModel_ImageConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("repositoryAccessMode", cdk.requiredValidator)(properties.repositoryAccessMode)), errors.collect(cdk.propertyValidator("repositoryAccessMode", cdk.validateString)(properties.repositoryAccessMode)), errors.collect(cdk.propertyValidator("repositoryAuthConfig", CfnModel_RepositoryAuthConfigPropertyValidator)(properties.repositoryAuthConfig)), errors.wrap('supplied properties not correct for "ImageConfigProperty"');
    }
    function cfnModelImageConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModel_ImageConfigPropertyValidator(properties).assertSuccess(), { RepositoryAccessMode: cdk.stringToCloudFormation(properties.repositoryAccessMode), RepositoryAuthConfig: cfnModelRepositoryAuthConfigPropertyToCloudFormation(properties.repositoryAuthConfig) }) : properties;
    }
    function CfnModelImageConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("repositoryAccessMode", "RepositoryAccessMode", cfn_parse.FromCloudFormation.getString(properties.RepositoryAccessMode)), ret.addPropertyResult("repositoryAuthConfig", "RepositoryAuthConfig", properties.RepositoryAuthConfig != null ? CfnModelRepositoryAuthConfigPropertyFromCloudFormation(properties.RepositoryAuthConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModel_InferenceExecutionConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("mode", cdk.requiredValidator)(properties.mode)), errors.collect(cdk.propertyValidator("mode", cdk.validateString)(properties.mode)), errors.wrap('supplied properties not correct for "InferenceExecutionConfigProperty"');
    }
    function cfnModelInferenceExecutionConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModel_InferenceExecutionConfigPropertyValidator(properties).assertSuccess(), { Mode: cdk.stringToCloudFormation(properties.mode) }) : properties;
    }
    function CfnModelInferenceExecutionConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("mode", "Mode", cfn_parse.FromCloudFormation.getString(properties.Mode)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModel_MultiModelConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("modelCacheSetting", cdk.validateString)(properties.modelCacheSetting)), errors.wrap('supplied properties not correct for "MultiModelConfigProperty"');
    }
    function cfnModelMultiModelConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModel_MultiModelConfigPropertyValidator(properties).assertSuccess(), { ModelCacheSetting: cdk.stringToCloudFormation(properties.modelCacheSetting) }) : properties;
    }
    function CfnModelMultiModelConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("modelCacheSetting", "ModelCacheSetting", properties.ModelCacheSetting != null ? cfn_parse.FromCloudFormation.getString(properties.ModelCacheSetting) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModel_RepositoryAuthConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("repositoryCredentialsProviderArn", cdk.requiredValidator)(properties.repositoryCredentialsProviderArn)), errors.collect(cdk.propertyValidator("repositoryCredentialsProviderArn", cdk.validateString)(properties.repositoryCredentialsProviderArn)), errors.wrap('supplied properties not correct for "RepositoryAuthConfigProperty"');
    }
    function cfnModelRepositoryAuthConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModel_RepositoryAuthConfigPropertyValidator(properties).assertSuccess(), { RepositoryCredentialsProviderArn: cdk.stringToCloudFormation(properties.repositoryCredentialsProviderArn) }) : properties;
    }
    function CfnModelRepositoryAuthConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("repositoryCredentialsProviderArn", "RepositoryCredentialsProviderArn", cfn_parse.FromCloudFormation.getString(properties.RepositoryCredentialsProviderArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModel_VpcConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.requiredValidator)(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnets", cdk.requiredValidator)(properties.subnets)), errors.collect(cdk.propertyValidator("subnets", cdk.listValidator(cdk.validateString))(properties.subnets)), errors.wrap('supplied properties not correct for "VpcConfigProperty"');
    }
    function cfnModelVpcConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModel_VpcConfigPropertyValidator(properties).assertSuccess(), { SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), Subnets: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnets) }) : properties;
    }
    function CfnModelVpcConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds)), ret.addPropertyResult("subnets", "Subnets", cfn_parse.FromCloudFormation.getStringArray(properties.Subnets)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelBiasJobDefinitionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endpointName", cdk.validateString)(properties.endpointName)), errors.collect(cdk.propertyValidator("jobDefinitionName", cdk.validateString)(properties.jobDefinitionName)), errors.collect(cdk.propertyValidator("jobResources", cdk.requiredValidator)(properties.jobResources)), errors.collect(cdk.propertyValidator("jobResources", CfnModelBiasJobDefinition_MonitoringResourcesPropertyValidator)(properties.jobResources)), errors.collect(cdk.propertyValidator("modelBiasAppSpecification", cdk.requiredValidator)(properties.modelBiasAppSpecification)), errors.collect(cdk.propertyValidator("modelBiasAppSpecification", CfnModelBiasJobDefinition_ModelBiasAppSpecificationPropertyValidator)(properties.modelBiasAppSpecification)), errors.collect(cdk.propertyValidator("modelBiasBaselineConfig", CfnModelBiasJobDefinition_ModelBiasBaselineConfigPropertyValidator)(properties.modelBiasBaselineConfig)), errors.collect(cdk.propertyValidator("modelBiasJobInput", cdk.requiredValidator)(properties.modelBiasJobInput)), errors.collect(cdk.propertyValidator("modelBiasJobInput", CfnModelBiasJobDefinition_ModelBiasJobInputPropertyValidator)(properties.modelBiasJobInput)), errors.collect(cdk.propertyValidator("modelBiasJobOutputConfig", cdk.requiredValidator)(properties.modelBiasJobOutputConfig)), errors.collect(cdk.propertyValidator("modelBiasJobOutputConfig", CfnModelBiasJobDefinition_MonitoringOutputConfigPropertyValidator)(properties.modelBiasJobOutputConfig)), errors.collect(cdk.propertyValidator("networkConfig", CfnModelBiasJobDefinition_NetworkConfigPropertyValidator)(properties.networkConfig)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("stoppingCondition", CfnModelBiasJobDefinition_StoppingConditionPropertyValidator)(properties.stoppingCondition)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnModelBiasJobDefinitionProps"');
    }
    function cfnModelBiasJobDefinitionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelBiasJobDefinitionPropsValidator(properties).assertSuccess(), { JobResources: cfnModelBiasJobDefinitionMonitoringResourcesPropertyToCloudFormation(properties.jobResources), ModelBiasAppSpecification: cfnModelBiasJobDefinitionModelBiasAppSpecificationPropertyToCloudFormation(properties.modelBiasAppSpecification), ModelBiasJobInput: cfnModelBiasJobDefinitionModelBiasJobInputPropertyToCloudFormation(properties.modelBiasJobInput), ModelBiasJobOutputConfig: cfnModelBiasJobDefinitionMonitoringOutputConfigPropertyToCloudFormation(properties.modelBiasJobOutputConfig), RoleArn: cdk.stringToCloudFormation(properties.roleArn), EndpointName: cdk.stringToCloudFormation(properties.endpointName), JobDefinitionName: cdk.stringToCloudFormation(properties.jobDefinitionName), ModelBiasBaselineConfig: cfnModelBiasJobDefinitionModelBiasBaselineConfigPropertyToCloudFormation(properties.modelBiasBaselineConfig), NetworkConfig: cfnModelBiasJobDefinitionNetworkConfigPropertyToCloudFormation(properties.networkConfig), StoppingCondition: cfnModelBiasJobDefinitionStoppingConditionPropertyToCloudFormation(properties.stoppingCondition), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnModelBiasJobDefinitionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("jobResources", "JobResources", CfnModelBiasJobDefinitionMonitoringResourcesPropertyFromCloudFormation(properties.JobResources)), ret.addPropertyResult("modelBiasAppSpecification", "ModelBiasAppSpecification", CfnModelBiasJobDefinitionModelBiasAppSpecificationPropertyFromCloudFormation(properties.ModelBiasAppSpecification)), ret.addPropertyResult("modelBiasJobInput", "ModelBiasJobInput", CfnModelBiasJobDefinitionModelBiasJobInputPropertyFromCloudFormation(properties.ModelBiasJobInput)), ret.addPropertyResult("modelBiasJobOutputConfig", "ModelBiasJobOutputConfig", CfnModelBiasJobDefinitionMonitoringOutputConfigPropertyFromCloudFormation(properties.ModelBiasJobOutputConfig)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("endpointName", "EndpointName", properties.EndpointName != null ? cfn_parse.FromCloudFormation.getString(properties.EndpointName) : void 0), ret.addPropertyResult("jobDefinitionName", "JobDefinitionName", properties.JobDefinitionName != null ? cfn_parse.FromCloudFormation.getString(properties.JobDefinitionName) : void 0), ret.addPropertyResult("modelBiasBaselineConfig", "ModelBiasBaselineConfig", properties.ModelBiasBaselineConfig != null ? CfnModelBiasJobDefinitionModelBiasBaselineConfigPropertyFromCloudFormation(properties.ModelBiasBaselineConfig) : void 0), ret.addPropertyResult("networkConfig", "NetworkConfig", properties.NetworkConfig != null ? CfnModelBiasJobDefinitionNetworkConfigPropertyFromCloudFormation(properties.NetworkConfig) : void 0), ret.addPropertyResult("stoppingCondition", "StoppingCondition", properties.StoppingCondition != null ? CfnModelBiasJobDefinitionStoppingConditionPropertyFromCloudFormation(properties.StoppingCondition) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnModelBiasJobDefinition = class _CfnModelBiasJobDefinition extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnModelBiasJobDefinitionPropsFromCloudFormation(resourceProperties), ret = new _CfnModelBiasJobDefinition(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnModelBiasJobDefinition.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sagemaker_CfnModelBiasJobDefinitionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnModelBiasJobDefinition), error;
        }
        cdk.requireProperty(props, "jobResources", this), cdk.requireProperty(props, "modelBiasAppSpecification", this), cdk.requireProperty(props, "modelBiasJobInput", this), cdk.requireProperty(props, "modelBiasJobOutputConfig", this), cdk.requireProperty(props, "roleArn", this), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrJobDefinitionArn = cdk.Token.asString(this.getAtt("JobDefinitionArn", cdk.ResolutionTypeHint.STRING)), this.jobResources = props.jobResources, this.modelBiasAppSpecification = props.modelBiasAppSpecification, this.modelBiasJobInput = props.modelBiasJobInput, this.modelBiasJobOutputConfig = props.modelBiasJobOutputConfig, this.roleArn = props.roleArn, this.endpointName = props.endpointName, this.jobDefinitionName = props.jobDefinitionName, this.modelBiasBaselineConfig = props.modelBiasBaselineConfig, this.networkConfig = props.networkConfig, this.stoppingCondition = props.stoppingCondition, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SageMaker::ModelBiasJobDefinition", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnModelBiasJobDefinition.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { jobResources: this.jobResources, modelBiasAppSpecification: this.modelBiasAppSpecification, modelBiasJobInput: this.modelBiasJobInput, modelBiasJobOutputConfig: this.modelBiasJobOutputConfig, roleArn: this.roleArn, endpointName: this.endpointName, jobDefinitionName: this.jobDefinitionName, modelBiasBaselineConfig: this.modelBiasBaselineConfig, networkConfig: this.networkConfig, stoppingCondition: this.stoppingCondition, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnModelBiasJobDefinitionPropsToCloudFormation(props);
      }
    };
    _q = JSII_RTTI_SYMBOL_1, CfnModelBiasJobDefinition[_q] = { fqn: "aws-cdk-lib.aws_sagemaker.CfnModelBiasJobDefinition", version: "2.80.0" }, CfnModelBiasJobDefinition.CFN_RESOURCE_TYPE_NAME = "AWS::SageMaker::ModelBiasJobDefinition", exports2.CfnModelBiasJobDefinition = CfnModelBiasJobDefinition;
    function CfnModelBiasJobDefinition_BatchTransformInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataCapturedDestinationS3Uri", cdk.requiredValidator)(properties.dataCapturedDestinationS3Uri)), errors.collect(cdk.propertyValidator("dataCapturedDestinationS3Uri", cdk.validateString)(properties.dataCapturedDestinationS3Uri)), errors.collect(cdk.propertyValidator("datasetFormat", cdk.requiredValidator)(properties.datasetFormat)), errors.collect(cdk.propertyValidator("datasetFormat", CfnModelBiasJobDefinition_DatasetFormatPropertyValidator)(properties.datasetFormat)), errors.collect(cdk.propertyValidator("endTimeOffset", cdk.validateString)(properties.endTimeOffset)), errors.collect(cdk.propertyValidator("featuresAttribute", cdk.validateString)(properties.featuresAttribute)), errors.collect(cdk.propertyValidator("inferenceAttribute", cdk.validateString)(properties.inferenceAttribute)), errors.collect(cdk.propertyValidator("localPath", cdk.requiredValidator)(properties.localPath)), errors.collect(cdk.propertyValidator("localPath", cdk.validateString)(properties.localPath)), errors.collect(cdk.propertyValidator("probabilityAttribute", cdk.validateString)(properties.probabilityAttribute)), errors.collect(cdk.propertyValidator("probabilityThresholdAttribute", cdk.validateNumber)(properties.probabilityThresholdAttribute)), errors.collect(cdk.propertyValidator("s3DataDistributionType", cdk.validateString)(properties.s3DataDistributionType)), errors.collect(cdk.propertyValidator("s3InputMode", cdk.validateString)(properties.s3InputMode)), errors.collect(cdk.propertyValidator("startTimeOffset", cdk.validateString)(properties.startTimeOffset)), errors.wrap('supplied properties not correct for "BatchTransformInputProperty"');
    }
    function cfnModelBiasJobDefinitionBatchTransformInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelBiasJobDefinition_BatchTransformInputPropertyValidator(properties).assertSuccess(), { DataCapturedDestinationS3Uri: cdk.stringToCloudFormation(properties.dataCapturedDestinationS3Uri), DatasetFormat: cfnModelBiasJobDefinitionDatasetFormatPropertyToCloudFormation(properties.datasetFormat), EndTimeOffset: cdk.stringToCloudFormation(properties.endTimeOffset), FeaturesAttribute: cdk.stringToCloudFormation(properties.featuresAttribute), InferenceAttribute: cdk.stringToCloudFormation(properties.inferenceAttribute), LocalPath: cdk.stringToCloudFormation(properties.localPath), ProbabilityAttribute: cdk.stringToCloudFormation(properties.probabilityAttribute), ProbabilityThresholdAttribute: cdk.numberToCloudFormation(properties.probabilityThresholdAttribute), S3DataDistributionType: cdk.stringToCloudFormation(properties.s3DataDistributionType), S3InputMode: cdk.stringToCloudFormation(properties.s3InputMode), StartTimeOffset: cdk.stringToCloudFormation(properties.startTimeOffset) }) : properties;
    }
    function CfnModelBiasJobDefinitionBatchTransformInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataCapturedDestinationS3Uri", "DataCapturedDestinationS3Uri", cfn_parse.FromCloudFormation.getString(properties.DataCapturedDestinationS3Uri)), ret.addPropertyResult("datasetFormat", "DatasetFormat", CfnModelBiasJobDefinitionDatasetFormatPropertyFromCloudFormation(properties.DatasetFormat)), ret.addPropertyResult("endTimeOffset", "EndTimeOffset", properties.EndTimeOffset != null ? cfn_parse.FromCloudFormation.getString(properties.EndTimeOffset) : void 0), ret.addPropertyResult("featuresAttribute", "FeaturesAttribute", properties.FeaturesAttribute != null ? cfn_parse.FromCloudFormation.getString(properties.FeaturesAttribute) : void 0), ret.addPropertyResult("inferenceAttribute", "InferenceAttribute", properties.InferenceAttribute != null ? cfn_parse.FromCloudFormation.getString(properties.InferenceAttribute) : void 0), ret.addPropertyResult("localPath", "LocalPath", cfn_parse.FromCloudFormation.getString(properties.LocalPath)), ret.addPropertyResult("probabilityAttribute", "ProbabilityAttribute", properties.ProbabilityAttribute != null ? cfn_parse.FromCloudFormation.getString(properties.ProbabilityAttribute) : void 0), ret.addPropertyResult("probabilityThresholdAttribute", "ProbabilityThresholdAttribute", properties.ProbabilityThresholdAttribute != null ? cfn_parse.FromCloudFormation.getNumber(properties.ProbabilityThresholdAttribute) : void 0), ret.addPropertyResult("s3DataDistributionType", "S3DataDistributionType", properties.S3DataDistributionType != null ? cfn_parse.FromCloudFormation.getString(properties.S3DataDistributionType) : void 0), ret.addPropertyResult("s3InputMode", "S3InputMode", properties.S3InputMode != null ? cfn_parse.FromCloudFormation.getString(properties.S3InputMode) : void 0), ret.addPropertyResult("startTimeOffset", "StartTimeOffset", properties.StartTimeOffset != null ? cfn_parse.FromCloudFormation.getString(properties.StartTimeOffset) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelBiasJobDefinition_ClusterConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceCount", cdk.requiredValidator)(properties.instanceCount)), errors.collect(cdk.propertyValidator("instanceCount", cdk.validateNumber)(properties.instanceCount)), errors.collect(cdk.propertyValidator("instanceType", cdk.requiredValidator)(properties.instanceType)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("volumeKmsKeyId", cdk.validateString)(properties.volumeKmsKeyId)), errors.collect(cdk.propertyValidator("volumeSizeInGb", cdk.requiredValidator)(properties.volumeSizeInGb)), errors.collect(cdk.propertyValidator("volumeSizeInGb", cdk.validateNumber)(properties.volumeSizeInGb)), errors.wrap('supplied properties not correct for "ClusterConfigProperty"');
    }
    function cfnModelBiasJobDefinitionClusterConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelBiasJobDefinition_ClusterConfigPropertyValidator(properties).assertSuccess(), { InstanceCount: cdk.numberToCloudFormation(properties.instanceCount), InstanceType: cdk.stringToCloudFormation(properties.instanceType), VolumeKmsKeyId: cdk.stringToCloudFormation(properties.volumeKmsKeyId), VolumeSizeInGB: cdk.numberToCloudFormation(properties.volumeSizeInGb) }) : properties;
    }
    function CfnModelBiasJobDefinitionClusterConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceCount", "InstanceCount", cfn_parse.FromCloudFormation.getNumber(properties.InstanceCount)), ret.addPropertyResult("instanceType", "InstanceType", cfn_parse.FromCloudFormation.getString(properties.InstanceType)), ret.addPropertyResult("volumeKmsKeyId", "VolumeKmsKeyId", properties.VolumeKmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.VolumeKmsKeyId) : void 0), ret.addPropertyResult("volumeSizeInGb", "VolumeSizeInGB", cfn_parse.FromCloudFormation.getNumber(properties.VolumeSizeInGB)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelBiasJobDefinition_ConstraintsResourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3Uri", cdk.validateString)(properties.s3Uri)), errors.wrap('supplied properties not correct for "ConstraintsResourceProperty"');
    }
    function cfnModelBiasJobDefinitionConstraintsResourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelBiasJobDefinition_ConstraintsResourcePropertyValidator(properties).assertSuccess(), { S3Uri: cdk.stringToCloudFormation(properties.s3Uri) }) : properties;
    }
    function CfnModelBiasJobDefinitionConstraintsResourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Uri", "S3Uri", properties.S3Uri != null ? cfn_parse.FromCloudFormation.getString(properties.S3Uri) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelBiasJobDefinition_CsvPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("header", cdk.validateBoolean)(properties.header)), errors.wrap('supplied properties not correct for "CsvProperty"');
    }
    function cfnModelBiasJobDefinitionCsvPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelBiasJobDefinition_CsvPropertyValidator(properties).assertSuccess(), { Header: cdk.booleanToCloudFormation(properties.header) }) : properties;
    }
    function CfnModelBiasJobDefinitionCsvPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("header", "Header", properties.Header != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Header) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelBiasJobDefinition_DatasetFormatPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("csv", CfnModelBiasJobDefinition_CsvPropertyValidator)(properties.csv)), errors.collect(cdk.propertyValidator("json", CfnModelBiasJobDefinition_JsonPropertyValidator)(properties.json)), errors.collect(cdk.propertyValidator("parquet", cdk.validateBoolean)(properties.parquet)), errors.wrap('supplied properties not correct for "DatasetFormatProperty"');
    }
    function cfnModelBiasJobDefinitionDatasetFormatPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelBiasJobDefinition_DatasetFormatPropertyValidator(properties).assertSuccess(), { Csv: cfnModelBiasJobDefinitionCsvPropertyToCloudFormation(properties.csv), Json: cfnModelBiasJobDefinitionJsonPropertyToCloudFormation(properties.json), Parquet: cdk.booleanToCloudFormation(properties.parquet) }) : properties;
    }
    function CfnModelBiasJobDefinitionDatasetFormatPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("csv", "Csv", properties.Csv != null ? CfnModelBiasJobDefinitionCsvPropertyFromCloudFormation(properties.Csv) : void 0), ret.addPropertyResult("json", "Json", properties.Json != null ? CfnModelBiasJobDefinitionJsonPropertyFromCloudFormation(properties.Json) : void 0), ret.addPropertyResult("parquet", "Parquet", properties.Parquet != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Parquet) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelBiasJobDefinition_EndpointInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endTimeOffset", cdk.validateString)(properties.endTimeOffset)), errors.collect(cdk.propertyValidator("endpointName", cdk.requiredValidator)(properties.endpointName)), errors.collect(cdk.propertyValidator("endpointName", cdk.validateString)(properties.endpointName)), errors.collect(cdk.propertyValidator("featuresAttribute", cdk.validateString)(properties.featuresAttribute)), errors.collect(cdk.propertyValidator("inferenceAttribute", cdk.validateString)(properties.inferenceAttribute)), errors.collect(cdk.propertyValidator("localPath", cdk.requiredValidator)(properties.localPath)), errors.collect(cdk.propertyValidator("localPath", cdk.validateString)(properties.localPath)), errors.collect(cdk.propertyValidator("probabilityAttribute", cdk.validateString)(properties.probabilityAttribute)), errors.collect(cdk.propertyValidator("probabilityThresholdAttribute", cdk.validateNumber)(properties.probabilityThresholdAttribute)), errors.collect(cdk.propertyValidator("s3DataDistributionType", cdk.validateString)(properties.s3DataDistributionType)), errors.collect(cdk.propertyValidator("s3InputMode", cdk.validateString)(properties.s3InputMode)), errors.collect(cdk.propertyValidator("startTimeOffset", cdk.validateString)(properties.startTimeOffset)), errors.wrap('supplied properties not correct for "EndpointInputProperty"');
    }
    function cfnModelBiasJobDefinitionEndpointInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelBiasJobDefinition_EndpointInputPropertyValidator(properties).assertSuccess(), { EndTimeOffset: cdk.stringToCloudFormation(properties.endTimeOffset), EndpointName: cdk.stringToCloudFormation(properties.endpointName), FeaturesAttribute: cdk.stringToCloudFormation(properties.featuresAttribute), InferenceAttribute: cdk.stringToCloudFormation(properties.inferenceAttribute), LocalPath: cdk.stringToCloudFormation(properties.localPath), ProbabilityAttribute: cdk.stringToCloudFormation(properties.probabilityAttribute), ProbabilityThresholdAttribute: cdk.numberToCloudFormation(properties.probabilityThresholdAttribute), S3DataDistributionType: cdk.stringToCloudFormation(properties.s3DataDistributionType), S3InputMode: cdk.stringToCloudFormation(properties.s3InputMode), StartTimeOffset: cdk.stringToCloudFormation(properties.startTimeOffset) }) : properties;
    }
    function CfnModelBiasJobDefinitionEndpointInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endTimeOffset", "EndTimeOffset", properties.EndTimeOffset != null ? cfn_parse.FromCloudFormation.getString(properties.EndTimeOffset) : void 0), ret.addPropertyResult("endpointName", "EndpointName", cfn_parse.FromCloudFormation.getString(properties.EndpointName)), ret.addPropertyResult("featuresAttribute", "FeaturesAttribute", properties.FeaturesAttribute != null ? cfn_parse.FromCloudFormation.getString(properties.FeaturesAttribute) : void 0), ret.addPropertyResult("inferenceAttribute", "InferenceAttribute", properties.InferenceAttribute != null ? cfn_parse.FromCloudFormation.getString(properties.InferenceAttribute) : void 0), ret.addPropertyResult("localPath", "LocalPath", cfn_parse.FromCloudFormation.getString(properties.LocalPath)), ret.addPropertyResult("probabilityAttribute", "ProbabilityAttribute", properties.ProbabilityAttribute != null ? cfn_parse.FromCloudFormation.getString(properties.ProbabilityAttribute) : void 0), ret.addPropertyResult("probabilityThresholdAttribute", "ProbabilityThresholdAttribute", properties.ProbabilityThresholdAttribute != null ? cfn_parse.FromCloudFormation.getNumber(properties.ProbabilityThresholdAttribute) : void 0), ret.addPropertyResult("s3DataDistributionType", "S3DataDistributionType", properties.S3DataDistributionType != null ? cfn_parse.FromCloudFormation.getString(properties.S3DataDistributionType) : void 0), ret.addPropertyResult("s3InputMode", "S3InputMode", properties.S3InputMode != null ? cfn_parse.FromCloudFormation.getString(properties.S3InputMode) : void 0), ret.addPropertyResult("startTimeOffset", "StartTimeOffset", properties.StartTimeOffset != null ? cfn_parse.FromCloudFormation.getString(properties.StartTimeOffset) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelBiasJobDefinition_JsonPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("line", cdk.validateBoolean)(properties.line)), errors.wrap('supplied properties not correct for "JsonProperty"');
    }
    function cfnModelBiasJobDefinitionJsonPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelBiasJobDefinition_JsonPropertyValidator(properties).assertSuccess(), { Line: cdk.booleanToCloudFormation(properties.line) }) : properties;
    }
    function CfnModelBiasJobDefinitionJsonPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("line", "Line", properties.Line != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Line) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelBiasJobDefinition_ModelBiasAppSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configUri", cdk.requiredValidator)(properties.configUri)), errors.collect(cdk.propertyValidator("configUri", cdk.validateString)(properties.configUri)), errors.collect(cdk.propertyValidator("environment", cdk.hashValidator(cdk.validateString))(properties.environment)), errors.collect(cdk.propertyValidator("imageUri", cdk.requiredValidator)(properties.imageUri)), errors.collect(cdk.propertyValidator("imageUri", cdk.validateString)(properties.imageUri)), errors.wrap('supplied properties not correct for "ModelBiasAppSpecificationProperty"');
    }
    function cfnModelBiasJobDefinitionModelBiasAppSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelBiasJobDefinition_ModelBiasAppSpecificationPropertyValidator(properties).assertSuccess(), { ConfigUri: cdk.stringToCloudFormation(properties.configUri), Environment: cdk.hashMapper(cdk.stringToCloudFormation)(properties.environment), ImageUri: cdk.stringToCloudFormation(properties.imageUri) }) : properties;
    }
    function CfnModelBiasJobDefinitionModelBiasAppSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configUri", "ConfigUri", cfn_parse.FromCloudFormation.getString(properties.ConfigUri)), ret.addPropertyResult("environment", "Environment", properties.Environment != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Environment) : void 0), ret.addPropertyResult("imageUri", "ImageUri", cfn_parse.FromCloudFormation.getString(properties.ImageUri)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelBiasJobDefinition_ModelBiasBaselineConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("baseliningJobName", cdk.validateString)(properties.baseliningJobName)), errors.collect(cdk.propertyValidator("constraintsResource", CfnModelBiasJobDefinition_ConstraintsResourcePropertyValidator)(properties.constraintsResource)), errors.wrap('supplied properties not correct for "ModelBiasBaselineConfigProperty"');
    }
    function cfnModelBiasJobDefinitionModelBiasBaselineConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelBiasJobDefinition_ModelBiasBaselineConfigPropertyValidator(properties).assertSuccess(), { BaseliningJobName: cdk.stringToCloudFormation(properties.baseliningJobName), ConstraintsResource: cfnModelBiasJobDefinitionConstraintsResourcePropertyToCloudFormation(properties.constraintsResource) }) : properties;
    }
    function CfnModelBiasJobDefinitionModelBiasBaselineConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("baseliningJobName", "BaseliningJobName", properties.BaseliningJobName != null ? cfn_parse.FromCloudFormation.getString(properties.BaseliningJobName) : void 0), ret.addPropertyResult("constraintsResource", "ConstraintsResource", properties.ConstraintsResource != null ? CfnModelBiasJobDefinitionConstraintsResourcePropertyFromCloudFormation(properties.ConstraintsResource) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelBiasJobDefinition_ModelBiasJobInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("batchTransformInput", CfnModelBiasJobDefinition_BatchTransformInputPropertyValidator)(properties.batchTransformInput)), errors.collect(cdk.propertyValidator("endpointInput", CfnModelBiasJobDefinition_EndpointInputPropertyValidator)(properties.endpointInput)), errors.collect(cdk.propertyValidator("groundTruthS3Input", cdk.requiredValidator)(properties.groundTruthS3Input)), errors.collect(cdk.propertyValidator("groundTruthS3Input", CfnModelBiasJobDefinition_MonitoringGroundTruthS3InputPropertyValidator)(properties.groundTruthS3Input)), errors.wrap('supplied properties not correct for "ModelBiasJobInputProperty"');
    }
    function cfnModelBiasJobDefinitionModelBiasJobInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelBiasJobDefinition_ModelBiasJobInputPropertyValidator(properties).assertSuccess(), { BatchTransformInput: cfnModelBiasJobDefinitionBatchTransformInputPropertyToCloudFormation(properties.batchTransformInput), EndpointInput: cfnModelBiasJobDefinitionEndpointInputPropertyToCloudFormation(properties.endpointInput), GroundTruthS3Input: cfnModelBiasJobDefinitionMonitoringGroundTruthS3InputPropertyToCloudFormation(properties.groundTruthS3Input) }) : properties;
    }
    function CfnModelBiasJobDefinitionModelBiasJobInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("batchTransformInput", "BatchTransformInput", properties.BatchTransformInput != null ? CfnModelBiasJobDefinitionBatchTransformInputPropertyFromCloudFormation(properties.BatchTransformInput) : void 0), ret.addPropertyResult("endpointInput", "EndpointInput", properties.EndpointInput != null ? CfnModelBiasJobDefinitionEndpointInputPropertyFromCloudFormation(properties.EndpointInput) : void 0), ret.addPropertyResult("groundTruthS3Input", "GroundTruthS3Input", CfnModelBiasJobDefinitionMonitoringGroundTruthS3InputPropertyFromCloudFormation(properties.GroundTruthS3Input)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelBiasJobDefinition_MonitoringGroundTruthS3InputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3Uri", cdk.requiredValidator)(properties.s3Uri)), errors.collect(cdk.propertyValidator("s3Uri", cdk.validateString)(properties.s3Uri)), errors.wrap('supplied properties not correct for "MonitoringGroundTruthS3InputProperty"');
    }
    function cfnModelBiasJobDefinitionMonitoringGroundTruthS3InputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelBiasJobDefinition_MonitoringGroundTruthS3InputPropertyValidator(properties).assertSuccess(), { S3Uri: cdk.stringToCloudFormation(properties.s3Uri) }) : properties;
    }
    function CfnModelBiasJobDefinitionMonitoringGroundTruthS3InputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Uri", "S3Uri", cfn_parse.FromCloudFormation.getString(properties.S3Uri)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelBiasJobDefinition_MonitoringOutputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3Output", cdk.requiredValidator)(properties.s3Output)), errors.collect(cdk.propertyValidator("s3Output", CfnModelBiasJobDefinition_S3OutputPropertyValidator)(properties.s3Output)), errors.wrap('supplied properties not correct for "MonitoringOutputProperty"');
    }
    function cfnModelBiasJobDefinitionMonitoringOutputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelBiasJobDefinition_MonitoringOutputPropertyValidator(properties).assertSuccess(), { S3Output: cfnModelBiasJobDefinitionS3OutputPropertyToCloudFormation(properties.s3Output) }) : properties;
    }
    function CfnModelBiasJobDefinitionMonitoringOutputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Output", "S3Output", CfnModelBiasJobDefinitionS3OutputPropertyFromCloudFormation(properties.S3Output)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelBiasJobDefinition_MonitoringOutputConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("monitoringOutputs", cdk.requiredValidator)(properties.monitoringOutputs)), errors.collect(cdk.propertyValidator("monitoringOutputs", cdk.listValidator(CfnModelBiasJobDefinition_MonitoringOutputPropertyValidator))(properties.monitoringOutputs)), errors.wrap('supplied properties not correct for "MonitoringOutputConfigProperty"');
    }
    function cfnModelBiasJobDefinitionMonitoringOutputConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelBiasJobDefinition_MonitoringOutputConfigPropertyValidator(properties).assertSuccess(), { KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), MonitoringOutputs: cdk.listMapper(cfnModelBiasJobDefinitionMonitoringOutputPropertyToCloudFormation)(properties.monitoringOutputs) }) : properties;
    }
    function CfnModelBiasJobDefinitionMonitoringOutputConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("monitoringOutputs", "MonitoringOutputs", cfn_parse.FromCloudFormation.getArray(CfnModelBiasJobDefinitionMonitoringOutputPropertyFromCloudFormation)(properties.MonitoringOutputs)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelBiasJobDefinition_MonitoringResourcesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clusterConfig", cdk.requiredValidator)(properties.clusterConfig)), errors.collect(cdk.propertyValidator("clusterConfig", CfnModelBiasJobDefinition_ClusterConfigPropertyValidator)(properties.clusterConfig)), errors.wrap('supplied properties not correct for "MonitoringResourcesProperty"');
    }
    function cfnModelBiasJobDefinitionMonitoringResourcesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelBiasJobDefinition_MonitoringResourcesPropertyValidator(properties).assertSuccess(), { ClusterConfig: cfnModelBiasJobDefinitionClusterConfigPropertyToCloudFormation(properties.clusterConfig) }) : properties;
    }
    function CfnModelBiasJobDefinitionMonitoringResourcesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clusterConfig", "ClusterConfig", CfnModelBiasJobDefinitionClusterConfigPropertyFromCloudFormation(properties.ClusterConfig)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelBiasJobDefinition_NetworkConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enableInterContainerTrafficEncryption", cdk.validateBoolean)(properties.enableInterContainerTrafficEncryption)), errors.collect(cdk.propertyValidator("enableNetworkIsolation", cdk.validateBoolean)(properties.enableNetworkIsolation)), errors.collect(cdk.propertyValidator("vpcConfig", CfnModelBiasJobDefinition_VpcConfigPropertyValidator)(properties.vpcConfig)), errors.wrap('supplied properties not correct for "NetworkConfigProperty"');
    }
    function cfnModelBiasJobDefinitionNetworkConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelBiasJobDefinition_NetworkConfigPropertyValidator(properties).assertSuccess(), { EnableInterContainerTrafficEncryption: cdk.booleanToCloudFormation(properties.enableInterContainerTrafficEncryption), EnableNetworkIsolation: cdk.booleanToCloudFormation(properties.enableNetworkIsolation), VpcConfig: cfnModelBiasJobDefinitionVpcConfigPropertyToCloudFormation(properties.vpcConfig) }) : properties;
    }
    function CfnModelBiasJobDefinitionNetworkConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enableInterContainerTrafficEncryption", "EnableInterContainerTrafficEncryption", properties.EnableInterContainerTrafficEncryption != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableInterContainerTrafficEncryption) : void 0), ret.addPropertyResult("enableNetworkIsolation", "EnableNetworkIsolation", properties.EnableNetworkIsolation != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableNetworkIsolation) : void 0), ret.addPropertyResult("vpcConfig", "VpcConfig", properties.VpcConfig != null ? CfnModelBiasJobDefinitionVpcConfigPropertyFromCloudFormation(properties.VpcConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelBiasJobDefinition_S3OutputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("localPath", cdk.requiredValidator)(properties.localPath)), errors.collect(cdk.propertyValidator("localPath", cdk.validateString)(properties.localPath)), errors.collect(cdk.propertyValidator("s3UploadMode", cdk.validateString)(properties.s3UploadMode)), errors.collect(cdk.propertyValidator("s3Uri", cdk.requiredValidator)(properties.s3Uri)), errors.collect(cdk.propertyValidator("s3Uri", cdk.validateString)(properties.s3Uri)), errors.wrap('supplied properties not correct for "S3OutputProperty"');
    }
    function cfnModelBiasJobDefinitionS3OutputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelBiasJobDefinition_S3OutputPropertyValidator(properties).assertSuccess(), { LocalPath: cdk.stringToCloudFormation(properties.localPath), S3UploadMode: cdk.stringToCloudFormation(properties.s3UploadMode), S3Uri: cdk.stringToCloudFormation(properties.s3Uri) }) : properties;
    }
    function CfnModelBiasJobDefinitionS3OutputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("localPath", "LocalPath", cfn_parse.FromCloudFormation.getString(properties.LocalPath)), ret.addPropertyResult("s3UploadMode", "S3UploadMode", properties.S3UploadMode != null ? cfn_parse.FromCloudFormation.getString(properties.S3UploadMode) : void 0), ret.addPropertyResult("s3Uri", "S3Uri", cfn_parse.FromCloudFormation.getString(properties.S3Uri)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelBiasJobDefinition_StoppingConditionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxRuntimeInSeconds", cdk.requiredValidator)(properties.maxRuntimeInSeconds)), errors.collect(cdk.propertyValidator("maxRuntimeInSeconds", cdk.validateNumber)(properties.maxRuntimeInSeconds)), errors.wrap('supplied properties not correct for "StoppingConditionProperty"');
    }
    function cfnModelBiasJobDefinitionStoppingConditionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelBiasJobDefinition_StoppingConditionPropertyValidator(properties).assertSuccess(), { MaxRuntimeInSeconds: cdk.numberToCloudFormation(properties.maxRuntimeInSeconds) }) : properties;
    }
    function CfnModelBiasJobDefinitionStoppingConditionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxRuntimeInSeconds", "MaxRuntimeInSeconds", cfn_parse.FromCloudFormation.getNumber(properties.MaxRuntimeInSeconds)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelBiasJobDefinition_VpcConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.requiredValidator)(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnets", cdk.requiredValidator)(properties.subnets)), errors.collect(cdk.propertyValidator("subnets", cdk.listValidator(cdk.validateString))(properties.subnets)), errors.wrap('supplied properties not correct for "VpcConfigProperty"');
    }
    function cfnModelBiasJobDefinitionVpcConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelBiasJobDefinition_VpcConfigPropertyValidator(properties).assertSuccess(), { SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), Subnets: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnets) }) : properties;
    }
    function CfnModelBiasJobDefinitionVpcConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds)), ret.addPropertyResult("subnets", "Subnets", cfn_parse.FromCloudFormation.getStringArray(properties.Subnets)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelCardPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("content", cdk.requiredValidator)(properties.content)), errors.collect(cdk.propertyValidator("content", CfnModelCard_ContentPropertyValidator)(properties.content)), errors.collect(cdk.propertyValidator("createdBy", CfnModelCard_UserContextPropertyValidator)(properties.createdBy)), errors.collect(cdk.propertyValidator("lastModifiedBy", CfnModelCard_UserContextPropertyValidator)(properties.lastModifiedBy)), errors.collect(cdk.propertyValidator("modelCardName", cdk.requiredValidator)(properties.modelCardName)), errors.collect(cdk.propertyValidator("modelCardName", cdk.validateString)(properties.modelCardName)), errors.collect(cdk.propertyValidator("modelCardStatus", cdk.requiredValidator)(properties.modelCardStatus)), errors.collect(cdk.propertyValidator("modelCardStatus", cdk.validateString)(properties.modelCardStatus)), errors.collect(cdk.propertyValidator("securityConfig", CfnModelCard_SecurityConfigPropertyValidator)(properties.securityConfig)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnModelCardProps"');
    }
    function cfnModelCardPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelCardPropsValidator(properties).assertSuccess(), { Content: cfnModelCardContentPropertyToCloudFormation(properties.content), ModelCardName: cdk.stringToCloudFormation(properties.modelCardName), ModelCardStatus: cdk.stringToCloudFormation(properties.modelCardStatus), CreatedBy: cfnModelCardUserContextPropertyToCloudFormation(properties.createdBy), LastModifiedBy: cfnModelCardUserContextPropertyToCloudFormation(properties.lastModifiedBy), SecurityConfig: cfnModelCardSecurityConfigPropertyToCloudFormation(properties.securityConfig), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnModelCardPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("content", "Content", CfnModelCardContentPropertyFromCloudFormation(properties.Content)), ret.addPropertyResult("modelCardName", "ModelCardName", cfn_parse.FromCloudFormation.getString(properties.ModelCardName)), ret.addPropertyResult("modelCardStatus", "ModelCardStatus", cfn_parse.FromCloudFormation.getString(properties.ModelCardStatus)), ret.addPropertyResult("createdBy", "CreatedBy", properties.CreatedBy != null ? CfnModelCardUserContextPropertyFromCloudFormation(properties.CreatedBy) : void 0), ret.addPropertyResult("lastModifiedBy", "LastModifiedBy", properties.LastModifiedBy != null ? CfnModelCardUserContextPropertyFromCloudFormation(properties.LastModifiedBy) : void 0), ret.addPropertyResult("securityConfig", "SecurityConfig", properties.SecurityConfig != null ? CfnModelCardSecurityConfigPropertyFromCloudFormation(properties.SecurityConfig) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnModelCard = class _CfnModelCard extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnModelCardPropsFromCloudFormation(resourceProperties), ret = new _CfnModelCard(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnModelCard.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sagemaker_CfnModelCardProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnModelCard), error;
        }
        cdk.requireProperty(props, "content", this), cdk.requireProperty(props, "modelCardName", this), cdk.requireProperty(props, "modelCardStatus", this), this.attrCreatedByDomainId = cdk.Token.asString(this.getAtt("CreatedBy.DomainId", cdk.ResolutionTypeHint.STRING)), this.attrCreatedByUserProfileArn = cdk.Token.asString(this.getAtt("CreatedBy.UserProfileArn", cdk.ResolutionTypeHint.STRING)), this.attrCreatedByUserProfileName = cdk.Token.asString(this.getAtt("CreatedBy.UserProfileName", cdk.ResolutionTypeHint.STRING)), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrLastModifiedByDomainId = cdk.Token.asString(this.getAtt("LastModifiedBy.DomainId", cdk.ResolutionTypeHint.STRING)), this.attrLastModifiedByUserProfileArn = cdk.Token.asString(this.getAtt("LastModifiedBy.UserProfileArn", cdk.ResolutionTypeHint.STRING)), this.attrLastModifiedByUserProfileName = cdk.Token.asString(this.getAtt("LastModifiedBy.UserProfileName", cdk.ResolutionTypeHint.STRING)), this.attrLastModifiedTime = cdk.Token.asString(this.getAtt("LastModifiedTime", cdk.ResolutionTypeHint.STRING)), this.attrModelCardArn = cdk.Token.asString(this.getAtt("ModelCardArn", cdk.ResolutionTypeHint.STRING)), this.attrModelCardProcessingStatus = cdk.Token.asString(this.getAtt("ModelCardProcessingStatus", cdk.ResolutionTypeHint.STRING)), this.attrModelCardVersion = cdk.Token.asNumber(this.getAtt("ModelCardVersion", cdk.ResolutionTypeHint.NUMBER)), this.content = props.content, this.modelCardName = props.modelCardName, this.modelCardStatus = props.modelCardStatus, this.createdBy = props.createdBy, this.lastModifiedBy = props.lastModifiedBy, this.securityConfig = props.securityConfig, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SageMaker::ModelCard", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnModelCard.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { content: this.content, modelCardName: this.modelCardName, modelCardStatus: this.modelCardStatus, createdBy: this.createdBy, lastModifiedBy: this.lastModifiedBy, securityConfig: this.securityConfig, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnModelCardPropsToCloudFormation(props);
      }
    };
    _r = JSII_RTTI_SYMBOL_1, CfnModelCard[_r] = { fqn: "aws-cdk-lib.aws_sagemaker.CfnModelCard", version: "2.80.0" }, CfnModelCard.CFN_RESOURCE_TYPE_NAME = "AWS::SageMaker::ModelCard", exports2.CfnModelCard = CfnModelCard;
    function CfnModelCard_AdditionalInformationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("caveatsAndRecommendations", cdk.validateString)(properties.caveatsAndRecommendations)), errors.collect(cdk.propertyValidator("customDetails", cdk.hashValidator(cdk.validateString))(properties.customDetails)), errors.collect(cdk.propertyValidator("ethicalConsiderations", cdk.validateString)(properties.ethicalConsiderations)), errors.wrap('supplied properties not correct for "AdditionalInformationProperty"');
    }
    function cfnModelCardAdditionalInformationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelCard_AdditionalInformationPropertyValidator(properties).assertSuccess(), { CaveatsAndRecommendations: cdk.stringToCloudFormation(properties.caveatsAndRecommendations), CustomDetails: cdk.hashMapper(cdk.stringToCloudFormation)(properties.customDetails), EthicalConsiderations: cdk.stringToCloudFormation(properties.ethicalConsiderations) }) : properties;
    }
    function CfnModelCardAdditionalInformationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("caveatsAndRecommendations", "CaveatsAndRecommendations", properties.CaveatsAndRecommendations != null ? cfn_parse.FromCloudFormation.getString(properties.CaveatsAndRecommendations) : void 0), ret.addPropertyResult("customDetails", "CustomDetails", properties.CustomDetails != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.CustomDetails) : void 0), ret.addPropertyResult("ethicalConsiderations", "EthicalConsiderations", properties.EthicalConsiderations != null ? cfn_parse.FromCloudFormation.getString(properties.EthicalConsiderations) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelCard_BusinessDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("businessProblem", cdk.validateString)(properties.businessProblem)), errors.collect(cdk.propertyValidator("businessStakeholders", cdk.validateString)(properties.businessStakeholders)), errors.collect(cdk.propertyValidator("lineOfBusiness", cdk.validateString)(properties.lineOfBusiness)), errors.wrap('supplied properties not correct for "BusinessDetailsProperty"');
    }
    function cfnModelCardBusinessDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelCard_BusinessDetailsPropertyValidator(properties).assertSuccess(), { BusinessProblem: cdk.stringToCloudFormation(properties.businessProblem), BusinessStakeholders: cdk.stringToCloudFormation(properties.businessStakeholders), LineOfBusiness: cdk.stringToCloudFormation(properties.lineOfBusiness) }) : properties;
    }
    function CfnModelCardBusinessDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("businessProblem", "BusinessProblem", properties.BusinessProblem != null ? cfn_parse.FromCloudFormation.getString(properties.BusinessProblem) : void 0), ret.addPropertyResult("businessStakeholders", "BusinessStakeholders", properties.BusinessStakeholders != null ? cfn_parse.FromCloudFormation.getString(properties.BusinessStakeholders) : void 0), ret.addPropertyResult("lineOfBusiness", "LineOfBusiness", properties.LineOfBusiness != null ? cfn_parse.FromCloudFormation.getString(properties.LineOfBusiness) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelCard_ContainerPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("image", cdk.requiredValidator)(properties.image)), errors.collect(cdk.propertyValidator("image", cdk.validateString)(properties.image)), errors.collect(cdk.propertyValidator("modelDataUrl", cdk.validateString)(properties.modelDataUrl)), errors.collect(cdk.propertyValidator("nearestModelName", cdk.validateString)(properties.nearestModelName)), errors.wrap('supplied properties not correct for "ContainerProperty"');
    }
    function cfnModelCardContainerPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelCard_ContainerPropertyValidator(properties).assertSuccess(), { Image: cdk.stringToCloudFormation(properties.image), ModelDataUrl: cdk.stringToCloudFormation(properties.modelDataUrl), NearestModelName: cdk.stringToCloudFormation(properties.nearestModelName) }) : properties;
    }
    function CfnModelCardContainerPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("image", "Image", cfn_parse.FromCloudFormation.getString(properties.Image)), ret.addPropertyResult("modelDataUrl", "ModelDataUrl", properties.ModelDataUrl != null ? cfn_parse.FromCloudFormation.getString(properties.ModelDataUrl) : void 0), ret.addPropertyResult("nearestModelName", "NearestModelName", properties.NearestModelName != null ? cfn_parse.FromCloudFormation.getString(properties.NearestModelName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelCard_ContentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("additionalInformation", CfnModelCard_AdditionalInformationPropertyValidator)(properties.additionalInformation)), errors.collect(cdk.propertyValidator("businessDetails", CfnModelCard_BusinessDetailsPropertyValidator)(properties.businessDetails)), errors.collect(cdk.propertyValidator("evaluationDetails", cdk.listValidator(CfnModelCard_EvaluationDetailPropertyValidator))(properties.evaluationDetails)), errors.collect(cdk.propertyValidator("intendedUses", CfnModelCard_IntendedUsesPropertyValidator)(properties.intendedUses)), errors.collect(cdk.propertyValidator("modelOverview", CfnModelCard_ModelOverviewPropertyValidator)(properties.modelOverview)), errors.collect(cdk.propertyValidator("modelPackageDetails", CfnModelCard_ModelPackageDetailsPropertyValidator)(properties.modelPackageDetails)), errors.collect(cdk.propertyValidator("trainingDetails", CfnModelCard_TrainingDetailsPropertyValidator)(properties.trainingDetails)), errors.wrap('supplied properties not correct for "ContentProperty"');
    }
    function cfnModelCardContentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelCard_ContentPropertyValidator(properties).assertSuccess(), { AdditionalInformation: cfnModelCardAdditionalInformationPropertyToCloudFormation(properties.additionalInformation), BusinessDetails: cfnModelCardBusinessDetailsPropertyToCloudFormation(properties.businessDetails), EvaluationDetails: cdk.listMapper(cfnModelCardEvaluationDetailPropertyToCloudFormation)(properties.evaluationDetails), IntendedUses: cfnModelCardIntendedUsesPropertyToCloudFormation(properties.intendedUses), ModelOverview: cfnModelCardModelOverviewPropertyToCloudFormation(properties.modelOverview), ModelPackageDetails: cfnModelCardModelPackageDetailsPropertyToCloudFormation(properties.modelPackageDetails), TrainingDetails: cfnModelCardTrainingDetailsPropertyToCloudFormation(properties.trainingDetails) }) : properties;
    }
    function CfnModelCardContentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("additionalInformation", "AdditionalInformation", properties.AdditionalInformation != null ? CfnModelCardAdditionalInformationPropertyFromCloudFormation(properties.AdditionalInformation) : void 0), ret.addPropertyResult("businessDetails", "BusinessDetails", properties.BusinessDetails != null ? CfnModelCardBusinessDetailsPropertyFromCloudFormation(properties.BusinessDetails) : void 0), ret.addPropertyResult("evaluationDetails", "EvaluationDetails", properties.EvaluationDetails != null ? cfn_parse.FromCloudFormation.getArray(CfnModelCardEvaluationDetailPropertyFromCloudFormation)(properties.EvaluationDetails) : void 0), ret.addPropertyResult("intendedUses", "IntendedUses", properties.IntendedUses != null ? CfnModelCardIntendedUsesPropertyFromCloudFormation(properties.IntendedUses) : void 0), ret.addPropertyResult("modelOverview", "ModelOverview", properties.ModelOverview != null ? CfnModelCardModelOverviewPropertyFromCloudFormation(properties.ModelOverview) : void 0), ret.addPropertyResult("modelPackageDetails", "ModelPackageDetails", properties.ModelPackageDetails != null ? CfnModelCardModelPackageDetailsPropertyFromCloudFormation(properties.ModelPackageDetails) : void 0), ret.addPropertyResult("trainingDetails", "TrainingDetails", properties.TrainingDetails != null ? CfnModelCardTrainingDetailsPropertyFromCloudFormation(properties.TrainingDetails) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelCard_EvaluationDetailPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("datasets", cdk.listValidator(cdk.validateString))(properties.datasets)), errors.collect(cdk.propertyValidator("evaluationJobArn", cdk.validateString)(properties.evaluationJobArn)), errors.collect(cdk.propertyValidator("evaluationObservation", cdk.validateString)(properties.evaluationObservation)), errors.collect(cdk.propertyValidator("metadata", cdk.hashValidator(cdk.validateString))(properties.metadata)), errors.collect(cdk.propertyValidator("metricGroups", cdk.listValidator(CfnModelCard_MetricGroupPropertyValidator))(properties.metricGroups)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "EvaluationDetailProperty"');
    }
    function cfnModelCardEvaluationDetailPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelCard_EvaluationDetailPropertyValidator(properties).assertSuccess(), { Datasets: cdk.listMapper(cdk.stringToCloudFormation)(properties.datasets), EvaluationJobArn: cdk.stringToCloudFormation(properties.evaluationJobArn), EvaluationObservation: cdk.stringToCloudFormation(properties.evaluationObservation), Metadata: cdk.hashMapper(cdk.stringToCloudFormation)(properties.metadata), MetricGroups: cdk.listMapper(cfnModelCardMetricGroupPropertyToCloudFormation)(properties.metricGroups), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnModelCardEvaluationDetailPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("datasets", "Datasets", properties.Datasets != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Datasets) : void 0), ret.addPropertyResult("evaluationJobArn", "EvaluationJobArn", properties.EvaluationJobArn != null ? cfn_parse.FromCloudFormation.getString(properties.EvaluationJobArn) : void 0), ret.addPropertyResult("evaluationObservation", "EvaluationObservation", properties.EvaluationObservation != null ? cfn_parse.FromCloudFormation.getString(properties.EvaluationObservation) : void 0), ret.addPropertyResult("metadata", "Metadata", properties.Metadata != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Metadata) : void 0), ret.addPropertyResult("metricGroups", "MetricGroups", properties.MetricGroups != null ? cfn_parse.FromCloudFormation.getArray(CfnModelCardMetricGroupPropertyFromCloudFormation)(properties.MetricGroups) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelCard_FunctionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("condition", cdk.validateString)(properties.condition)), errors.collect(cdk.propertyValidator("facet", cdk.validateString)(properties.facet)), errors.collect(cdk.propertyValidator("function", cdk.validateString)(properties.function)), errors.wrap('supplied properties not correct for "FunctionProperty"');
    }
    function cfnModelCardFunctionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelCard_FunctionPropertyValidator(properties).assertSuccess(), { Condition: cdk.stringToCloudFormation(properties.condition), Facet: cdk.stringToCloudFormation(properties.facet), Function: cdk.stringToCloudFormation(properties.function) }) : properties;
    }
    function CfnModelCardFunctionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("condition", "Condition", properties.Condition != null ? cfn_parse.FromCloudFormation.getString(properties.Condition) : void 0), ret.addPropertyResult("facet", "Facet", properties.Facet != null ? cfn_parse.FromCloudFormation.getString(properties.Facet) : void 0), ret.addPropertyResult("function", "Function", properties.Function != null ? cfn_parse.FromCloudFormation.getString(properties.Function) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelCard_InferenceEnvironmentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containerImage", cdk.listValidator(cdk.validateString))(properties.containerImage)), errors.wrap('supplied properties not correct for "InferenceEnvironmentProperty"');
    }
    function cfnModelCardInferenceEnvironmentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelCard_InferenceEnvironmentPropertyValidator(properties).assertSuccess(), { ContainerImage: cdk.listMapper(cdk.stringToCloudFormation)(properties.containerImage) }) : properties;
    }
    function CfnModelCardInferenceEnvironmentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containerImage", "ContainerImage", properties.ContainerImage != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ContainerImage) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelCard_InferenceSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containers", cdk.requiredValidator)(properties.containers)), errors.collect(cdk.propertyValidator("containers", cdk.listValidator(CfnModelCard_ContainerPropertyValidator))(properties.containers)), errors.wrap('supplied properties not correct for "InferenceSpecificationProperty"');
    }
    function cfnModelCardInferenceSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelCard_InferenceSpecificationPropertyValidator(properties).assertSuccess(), { Containers: cdk.listMapper(cfnModelCardContainerPropertyToCloudFormation)(properties.containers) }) : properties;
    }
    function CfnModelCardInferenceSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containers", "Containers", cfn_parse.FromCloudFormation.getArray(CfnModelCardContainerPropertyFromCloudFormation)(properties.Containers)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelCard_IntendedUsesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("explanationsForRiskRating", cdk.validateString)(properties.explanationsForRiskRating)), errors.collect(cdk.propertyValidator("factorsAffectingModelEfficiency", cdk.validateString)(properties.factorsAffectingModelEfficiency)), errors.collect(cdk.propertyValidator("intendedUses", cdk.validateString)(properties.intendedUses)), errors.collect(cdk.propertyValidator("purposeOfModel", cdk.validateString)(properties.purposeOfModel)), errors.collect(cdk.propertyValidator("riskRating", cdk.validateString)(properties.riskRating)), errors.wrap('supplied properties not correct for "IntendedUsesProperty"');
    }
    function cfnModelCardIntendedUsesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelCard_IntendedUsesPropertyValidator(properties).assertSuccess(), { ExplanationsForRiskRating: cdk.stringToCloudFormation(properties.explanationsForRiskRating), FactorsAffectingModelEfficiency: cdk.stringToCloudFormation(properties.factorsAffectingModelEfficiency), IntendedUses: cdk.stringToCloudFormation(properties.intendedUses), PurposeOfModel: cdk.stringToCloudFormation(properties.purposeOfModel), RiskRating: cdk.stringToCloudFormation(properties.riskRating) }) : properties;
    }
    function CfnModelCardIntendedUsesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("explanationsForRiskRating", "ExplanationsForRiskRating", properties.ExplanationsForRiskRating != null ? cfn_parse.FromCloudFormation.getString(properties.ExplanationsForRiskRating) : void 0), ret.addPropertyResult("factorsAffectingModelEfficiency", "FactorsAffectingModelEfficiency", properties.FactorsAffectingModelEfficiency != null ? cfn_parse.FromCloudFormation.getString(properties.FactorsAffectingModelEfficiency) : void 0), ret.addPropertyResult("intendedUses", "IntendedUses", properties.IntendedUses != null ? cfn_parse.FromCloudFormation.getString(properties.IntendedUses) : void 0), ret.addPropertyResult("purposeOfModel", "PurposeOfModel", properties.PurposeOfModel != null ? cfn_parse.FromCloudFormation.getString(properties.PurposeOfModel) : void 0), ret.addPropertyResult("riskRating", "RiskRating", properties.RiskRating != null ? cfn_parse.FromCloudFormation.getString(properties.RiskRating) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelCard_MetricDataItemsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("notes", cdk.validateString)(properties.notes)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateObject)(properties.value)), errors.collect(cdk.propertyValidator("xAxisName", cdk.listValidator(cdk.validateString))(properties.xAxisName)), errors.collect(cdk.propertyValidator("yAxisName", cdk.listValidator(cdk.validateString))(properties.yAxisName)), errors.wrap('supplied properties not correct for "MetricDataItemsProperty"');
    }
    function cfnModelCardMetricDataItemsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelCard_MetricDataItemsPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Notes: cdk.stringToCloudFormation(properties.notes), Type: cdk.stringToCloudFormation(properties.type), Value: cdk.objectToCloudFormation(properties.value), XAxisName: cdk.listMapper(cdk.stringToCloudFormation)(properties.xAxisName), YAxisName: cdk.listMapper(cdk.stringToCloudFormation)(properties.yAxisName) }) : properties;
    }
    function CfnModelCardMetricDataItemsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("notes", "Notes", properties.Notes != null ? cfn_parse.FromCloudFormation.getString(properties.Notes) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getAny(properties.Value)), ret.addPropertyResult("xAxisName", "XAxisName", properties.XAxisName != null ? cfn_parse.FromCloudFormation.getStringArray(properties.XAxisName) : void 0), ret.addPropertyResult("yAxisName", "YAxisName", properties.YAxisName != null ? cfn_parse.FromCloudFormation.getStringArray(properties.YAxisName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelCard_MetricGroupPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("metricData", cdk.requiredValidator)(properties.metricData)), errors.collect(cdk.propertyValidator("metricData", cdk.listValidator(CfnModelCard_MetricDataItemsPropertyValidator))(properties.metricData)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "MetricGroupProperty"');
    }
    function cfnModelCardMetricGroupPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelCard_MetricGroupPropertyValidator(properties).assertSuccess(), { MetricData: cdk.listMapper(cfnModelCardMetricDataItemsPropertyToCloudFormation)(properties.metricData), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnModelCardMetricGroupPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("metricData", "MetricData", cfn_parse.FromCloudFormation.getArray(CfnModelCardMetricDataItemsPropertyFromCloudFormation)(properties.MetricData)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelCard_ModelOverviewPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("algorithmType", cdk.validateString)(properties.algorithmType)), errors.collect(cdk.propertyValidator("inferenceEnvironment", CfnModelCard_InferenceEnvironmentPropertyValidator)(properties.inferenceEnvironment)), errors.collect(cdk.propertyValidator("modelArtifact", cdk.listValidator(cdk.validateString))(properties.modelArtifact)), errors.collect(cdk.propertyValidator("modelCreator", cdk.validateString)(properties.modelCreator)), errors.collect(cdk.propertyValidator("modelDescription", cdk.validateString)(properties.modelDescription)), errors.collect(cdk.propertyValidator("modelId", cdk.validateString)(properties.modelId)), errors.collect(cdk.propertyValidator("modelName", cdk.validateString)(properties.modelName)), errors.collect(cdk.propertyValidator("modelOwner", cdk.validateString)(properties.modelOwner)), errors.collect(cdk.propertyValidator("modelVersion", cdk.validateNumber)(properties.modelVersion)), errors.collect(cdk.propertyValidator("problemType", cdk.validateString)(properties.problemType)), errors.wrap('supplied properties not correct for "ModelOverviewProperty"');
    }
    function cfnModelCardModelOverviewPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelCard_ModelOverviewPropertyValidator(properties).assertSuccess(), { AlgorithmType: cdk.stringToCloudFormation(properties.algorithmType), InferenceEnvironment: cfnModelCardInferenceEnvironmentPropertyToCloudFormation(properties.inferenceEnvironment), ModelArtifact: cdk.listMapper(cdk.stringToCloudFormation)(properties.modelArtifact), ModelCreator: cdk.stringToCloudFormation(properties.modelCreator), ModelDescription: cdk.stringToCloudFormation(properties.modelDescription), ModelId: cdk.stringToCloudFormation(properties.modelId), ModelName: cdk.stringToCloudFormation(properties.modelName), ModelOwner: cdk.stringToCloudFormation(properties.modelOwner), ModelVersion: cdk.numberToCloudFormation(properties.modelVersion), ProblemType: cdk.stringToCloudFormation(properties.problemType) }) : properties;
    }
    function CfnModelCardModelOverviewPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("algorithmType", "AlgorithmType", properties.AlgorithmType != null ? cfn_parse.FromCloudFormation.getString(properties.AlgorithmType) : void 0), ret.addPropertyResult("inferenceEnvironment", "InferenceEnvironment", properties.InferenceEnvironment != null ? CfnModelCardInferenceEnvironmentPropertyFromCloudFormation(properties.InferenceEnvironment) : void 0), ret.addPropertyResult("modelArtifact", "ModelArtifact", properties.ModelArtifact != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ModelArtifact) : void 0), ret.addPropertyResult("modelCreator", "ModelCreator", properties.ModelCreator != null ? cfn_parse.FromCloudFormation.getString(properties.ModelCreator) : void 0), ret.addPropertyResult("modelDescription", "ModelDescription", properties.ModelDescription != null ? cfn_parse.FromCloudFormation.getString(properties.ModelDescription) : void 0), ret.addPropertyResult("modelId", "ModelId", properties.ModelId != null ? cfn_parse.FromCloudFormation.getString(properties.ModelId) : void 0), ret.addPropertyResult("modelName", "ModelName", properties.ModelName != null ? cfn_parse.FromCloudFormation.getString(properties.ModelName) : void 0), ret.addPropertyResult("modelOwner", "ModelOwner", properties.ModelOwner != null ? cfn_parse.FromCloudFormation.getString(properties.ModelOwner) : void 0), ret.addPropertyResult("modelVersion", "ModelVersion", properties.ModelVersion != null ? cfn_parse.FromCloudFormation.getNumber(properties.ModelVersion) : void 0), ret.addPropertyResult("problemType", "ProblemType", properties.ProblemType != null ? cfn_parse.FromCloudFormation.getString(properties.ProblemType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelCard_ModelPackageCreatorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("userProfileName", cdk.validateString)(properties.userProfileName)), errors.wrap('supplied properties not correct for "ModelPackageCreatorProperty"');
    }
    function cfnModelCardModelPackageCreatorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelCard_ModelPackageCreatorPropertyValidator(properties).assertSuccess(), { UserProfileName: cdk.stringToCloudFormation(properties.userProfileName) }) : properties;
    }
    function CfnModelCardModelPackageCreatorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("userProfileName", "UserProfileName", properties.UserProfileName != null ? cfn_parse.FromCloudFormation.getString(properties.UserProfileName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelCard_ModelPackageDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("approvalDescription", cdk.validateString)(properties.approvalDescription)), errors.collect(cdk.propertyValidator("createdBy", CfnModelCard_ModelPackageCreatorPropertyValidator)(properties.createdBy)), errors.collect(cdk.propertyValidator("domain", cdk.validateString)(properties.domain)), errors.collect(cdk.propertyValidator("inferenceSpecification", CfnModelCard_InferenceSpecificationPropertyValidator)(properties.inferenceSpecification)), errors.collect(cdk.propertyValidator("modelApprovalStatus", cdk.validateString)(properties.modelApprovalStatus)), errors.collect(cdk.propertyValidator("modelPackageArn", cdk.validateString)(properties.modelPackageArn)), errors.collect(cdk.propertyValidator("modelPackageDescription", cdk.validateString)(properties.modelPackageDescription)), errors.collect(cdk.propertyValidator("modelPackageGroupName", cdk.validateString)(properties.modelPackageGroupName)), errors.collect(cdk.propertyValidator("modelPackageName", cdk.validateString)(properties.modelPackageName)), errors.collect(cdk.propertyValidator("modelPackageStatus", cdk.validateString)(properties.modelPackageStatus)), errors.collect(cdk.propertyValidator("modelPackageVersion", cdk.validateNumber)(properties.modelPackageVersion)), errors.collect(cdk.propertyValidator("sourceAlgorithms", cdk.listValidator(CfnModelCard_SourceAlgorithmPropertyValidator))(properties.sourceAlgorithms)), errors.collect(cdk.propertyValidator("task", cdk.validateString)(properties.task)), errors.wrap('supplied properties not correct for "ModelPackageDetailsProperty"');
    }
    function cfnModelCardModelPackageDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelCard_ModelPackageDetailsPropertyValidator(properties).assertSuccess(), { ApprovalDescription: cdk.stringToCloudFormation(properties.approvalDescription), CreatedBy: cfnModelCardModelPackageCreatorPropertyToCloudFormation(properties.createdBy), Domain: cdk.stringToCloudFormation(properties.domain), InferenceSpecification: cfnModelCardInferenceSpecificationPropertyToCloudFormation(properties.inferenceSpecification), ModelApprovalStatus: cdk.stringToCloudFormation(properties.modelApprovalStatus), ModelPackageArn: cdk.stringToCloudFormation(properties.modelPackageArn), ModelPackageDescription: cdk.stringToCloudFormation(properties.modelPackageDescription), ModelPackageGroupName: cdk.stringToCloudFormation(properties.modelPackageGroupName), ModelPackageName: cdk.stringToCloudFormation(properties.modelPackageName), ModelPackageStatus: cdk.stringToCloudFormation(properties.modelPackageStatus), ModelPackageVersion: cdk.numberToCloudFormation(properties.modelPackageVersion), SourceAlgorithms: cdk.listMapper(cfnModelCardSourceAlgorithmPropertyToCloudFormation)(properties.sourceAlgorithms), Task: cdk.stringToCloudFormation(properties.task) }) : properties;
    }
    function CfnModelCardModelPackageDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("approvalDescription", "ApprovalDescription", properties.ApprovalDescription != null ? cfn_parse.FromCloudFormation.getString(properties.ApprovalDescription) : void 0), ret.addPropertyResult("createdBy", "CreatedBy", properties.CreatedBy != null ? CfnModelCardModelPackageCreatorPropertyFromCloudFormation(properties.CreatedBy) : void 0), ret.addPropertyResult("domain", "Domain", properties.Domain != null ? cfn_parse.FromCloudFormation.getString(properties.Domain) : void 0), ret.addPropertyResult("inferenceSpecification", "InferenceSpecification", properties.InferenceSpecification != null ? CfnModelCardInferenceSpecificationPropertyFromCloudFormation(properties.InferenceSpecification) : void 0), ret.addPropertyResult("modelApprovalStatus", "ModelApprovalStatus", properties.ModelApprovalStatus != null ? cfn_parse.FromCloudFormation.getString(properties.ModelApprovalStatus) : void 0), ret.addPropertyResult("modelPackageArn", "ModelPackageArn", properties.ModelPackageArn != null ? cfn_parse.FromCloudFormation.getString(properties.ModelPackageArn) : void 0), ret.addPropertyResult("modelPackageDescription", "ModelPackageDescription", properties.ModelPackageDescription != null ? cfn_parse.FromCloudFormation.getString(properties.ModelPackageDescription) : void 0), ret.addPropertyResult("modelPackageGroupName", "ModelPackageGroupName", properties.ModelPackageGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.ModelPackageGroupName) : void 0), ret.addPropertyResult("modelPackageName", "ModelPackageName", properties.ModelPackageName != null ? cfn_parse.FromCloudFormation.getString(properties.ModelPackageName) : void 0), ret.addPropertyResult("modelPackageStatus", "ModelPackageStatus", properties.ModelPackageStatus != null ? cfn_parse.FromCloudFormation.getString(properties.ModelPackageStatus) : void 0), ret.addPropertyResult("modelPackageVersion", "ModelPackageVersion", properties.ModelPackageVersion != null ? cfn_parse.FromCloudFormation.getNumber(properties.ModelPackageVersion) : void 0), ret.addPropertyResult("sourceAlgorithms", "SourceAlgorithms", properties.SourceAlgorithms != null ? cfn_parse.FromCloudFormation.getArray(CfnModelCardSourceAlgorithmPropertyFromCloudFormation)(properties.SourceAlgorithms) : void 0), ret.addPropertyResult("task", "Task", properties.Task != null ? cfn_parse.FromCloudFormation.getString(properties.Task) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelCard_ObjectiveFunctionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("function", CfnModelCard_FunctionPropertyValidator)(properties.function)), errors.collect(cdk.propertyValidator("notes", cdk.validateString)(properties.notes)), errors.wrap('supplied properties not correct for "ObjectiveFunctionProperty"');
    }
    function cfnModelCardObjectiveFunctionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelCard_ObjectiveFunctionPropertyValidator(properties).assertSuccess(), { Function: cfnModelCardFunctionPropertyToCloudFormation(properties.function), Notes: cdk.stringToCloudFormation(properties.notes) }) : properties;
    }
    function CfnModelCardObjectiveFunctionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("function", "Function", properties.Function != null ? CfnModelCardFunctionPropertyFromCloudFormation(properties.Function) : void 0), ret.addPropertyResult("notes", "Notes", properties.Notes != null ? cfn_parse.FromCloudFormation.getString(properties.Notes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelCard_SecurityConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.wrap('supplied properties not correct for "SecurityConfigProperty"');
    }
    function cfnModelCardSecurityConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelCard_SecurityConfigPropertyValidator(properties).assertSuccess(), { KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId) }) : properties;
    }
    function CfnModelCardSecurityConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelCard_SourceAlgorithmPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("algorithmName", cdk.requiredValidator)(properties.algorithmName)), errors.collect(cdk.propertyValidator("algorithmName", cdk.validateString)(properties.algorithmName)), errors.collect(cdk.propertyValidator("modelDataUrl", cdk.validateString)(properties.modelDataUrl)), errors.wrap('supplied properties not correct for "SourceAlgorithmProperty"');
    }
    function cfnModelCardSourceAlgorithmPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelCard_SourceAlgorithmPropertyValidator(properties).assertSuccess(), { AlgorithmName: cdk.stringToCloudFormation(properties.algorithmName), ModelDataUrl: cdk.stringToCloudFormation(properties.modelDataUrl) }) : properties;
    }
    function CfnModelCardSourceAlgorithmPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("algorithmName", "AlgorithmName", cfn_parse.FromCloudFormation.getString(properties.AlgorithmName)), ret.addPropertyResult("modelDataUrl", "ModelDataUrl", properties.ModelDataUrl != null ? cfn_parse.FromCloudFormation.getString(properties.ModelDataUrl) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelCard_TrainingDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("objectiveFunction", CfnModelCard_ObjectiveFunctionPropertyValidator)(properties.objectiveFunction)), errors.collect(cdk.propertyValidator("trainingJobDetails", CfnModelCard_TrainingJobDetailsPropertyValidator)(properties.trainingJobDetails)), errors.collect(cdk.propertyValidator("trainingObservations", cdk.validateString)(properties.trainingObservations)), errors.wrap('supplied properties not correct for "TrainingDetailsProperty"');
    }
    function cfnModelCardTrainingDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelCard_TrainingDetailsPropertyValidator(properties).assertSuccess(), { ObjectiveFunction: cfnModelCardObjectiveFunctionPropertyToCloudFormation(properties.objectiveFunction), TrainingJobDetails: cfnModelCardTrainingJobDetailsPropertyToCloudFormation(properties.trainingJobDetails), TrainingObservations: cdk.stringToCloudFormation(properties.trainingObservations) }) : properties;
    }
    function CfnModelCardTrainingDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("objectiveFunction", "ObjectiveFunction", properties.ObjectiveFunction != null ? CfnModelCardObjectiveFunctionPropertyFromCloudFormation(properties.ObjectiveFunction) : void 0), ret.addPropertyResult("trainingJobDetails", "TrainingJobDetails", properties.TrainingJobDetails != null ? CfnModelCardTrainingJobDetailsPropertyFromCloudFormation(properties.TrainingJobDetails) : void 0), ret.addPropertyResult("trainingObservations", "TrainingObservations", properties.TrainingObservations != null ? cfn_parse.FromCloudFormation.getString(properties.TrainingObservations) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelCard_TrainingEnvironmentPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containerImage", cdk.listValidator(cdk.validateString))(properties.containerImage)), errors.wrap('supplied properties not correct for "TrainingEnvironmentProperty"');
    }
    function cfnModelCardTrainingEnvironmentPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelCard_TrainingEnvironmentPropertyValidator(properties).assertSuccess(), { ContainerImage: cdk.listMapper(cdk.stringToCloudFormation)(properties.containerImage) }) : properties;
    }
    function CfnModelCardTrainingEnvironmentPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containerImage", "ContainerImage", properties.ContainerImage != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ContainerImage) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelCard_TrainingHyperParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "TrainingHyperParameterProperty"');
    }
    function cfnModelCardTrainingHyperParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelCard_TrainingHyperParameterPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnModelCardTrainingHyperParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelCard_TrainingJobDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("hyperParameters", cdk.listValidator(CfnModelCard_TrainingHyperParameterPropertyValidator))(properties.hyperParameters)), errors.collect(cdk.propertyValidator("trainingArn", cdk.validateString)(properties.trainingArn)), errors.collect(cdk.propertyValidator("trainingDatasets", cdk.listValidator(cdk.validateString))(properties.trainingDatasets)), errors.collect(cdk.propertyValidator("trainingEnvironment", CfnModelCard_TrainingEnvironmentPropertyValidator)(properties.trainingEnvironment)), errors.collect(cdk.propertyValidator("trainingMetrics", cdk.listValidator(CfnModelCard_TrainingMetricPropertyValidator))(properties.trainingMetrics)), errors.collect(cdk.propertyValidator("userProvidedHyperParameters", cdk.listValidator(CfnModelCard_TrainingHyperParameterPropertyValidator))(properties.userProvidedHyperParameters)), errors.collect(cdk.propertyValidator("userProvidedTrainingMetrics", cdk.listValidator(CfnModelCard_TrainingMetricPropertyValidator))(properties.userProvidedTrainingMetrics)), errors.wrap('supplied properties not correct for "TrainingJobDetailsProperty"');
    }
    function cfnModelCardTrainingJobDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelCard_TrainingJobDetailsPropertyValidator(properties).assertSuccess(), { HyperParameters: cdk.listMapper(cfnModelCardTrainingHyperParameterPropertyToCloudFormation)(properties.hyperParameters), TrainingArn: cdk.stringToCloudFormation(properties.trainingArn), TrainingDatasets: cdk.listMapper(cdk.stringToCloudFormation)(properties.trainingDatasets), TrainingEnvironment: cfnModelCardTrainingEnvironmentPropertyToCloudFormation(properties.trainingEnvironment), TrainingMetrics: cdk.listMapper(cfnModelCardTrainingMetricPropertyToCloudFormation)(properties.trainingMetrics), UserProvidedHyperParameters: cdk.listMapper(cfnModelCardTrainingHyperParameterPropertyToCloudFormation)(properties.userProvidedHyperParameters), UserProvidedTrainingMetrics: cdk.listMapper(cfnModelCardTrainingMetricPropertyToCloudFormation)(properties.userProvidedTrainingMetrics) }) : properties;
    }
    function CfnModelCardTrainingJobDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("hyperParameters", "HyperParameters", properties.HyperParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnModelCardTrainingHyperParameterPropertyFromCloudFormation)(properties.HyperParameters) : void 0), ret.addPropertyResult("trainingArn", "TrainingArn", properties.TrainingArn != null ? cfn_parse.FromCloudFormation.getString(properties.TrainingArn) : void 0), ret.addPropertyResult("trainingDatasets", "TrainingDatasets", properties.TrainingDatasets != null ? cfn_parse.FromCloudFormation.getStringArray(properties.TrainingDatasets) : void 0), ret.addPropertyResult("trainingEnvironment", "TrainingEnvironment", properties.TrainingEnvironment != null ? CfnModelCardTrainingEnvironmentPropertyFromCloudFormation(properties.TrainingEnvironment) : void 0), ret.addPropertyResult("trainingMetrics", "TrainingMetrics", properties.TrainingMetrics != null ? cfn_parse.FromCloudFormation.getArray(CfnModelCardTrainingMetricPropertyFromCloudFormation)(properties.TrainingMetrics) : void 0), ret.addPropertyResult("userProvidedHyperParameters", "UserProvidedHyperParameters", properties.UserProvidedHyperParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnModelCardTrainingHyperParameterPropertyFromCloudFormation)(properties.UserProvidedHyperParameters) : void 0), ret.addPropertyResult("userProvidedTrainingMetrics", "UserProvidedTrainingMetrics", properties.UserProvidedTrainingMetrics != null ? cfn_parse.FromCloudFormation.getArray(CfnModelCardTrainingMetricPropertyFromCloudFormation)(properties.UserProvidedTrainingMetrics) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelCard_TrainingMetricPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("notes", cdk.validateString)(properties.notes)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "TrainingMetricProperty"');
    }
    function cfnModelCardTrainingMetricPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelCard_TrainingMetricPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Notes: cdk.stringToCloudFormation(properties.notes), Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnModelCardTrainingMetricPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("notes", "Notes", properties.Notes != null ? cfn_parse.FromCloudFormation.getString(properties.Notes) : void 0), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getNumber(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelCard_UserContextPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("domainId", cdk.validateString)(properties.domainId)), errors.collect(cdk.propertyValidator("userProfileArn", cdk.validateString)(properties.userProfileArn)), errors.collect(cdk.propertyValidator("userProfileName", cdk.validateString)(properties.userProfileName)), errors.wrap('supplied properties not correct for "UserContextProperty"');
    }
    function cfnModelCardUserContextPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelCard_UserContextPropertyValidator(properties).assertSuccess(), { DomainId: cdk.stringToCloudFormation(properties.domainId), UserProfileArn: cdk.stringToCloudFormation(properties.userProfileArn), UserProfileName: cdk.stringToCloudFormation(properties.userProfileName) }) : properties;
    }
    function CfnModelCardUserContextPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("domainId", "DomainId", properties.DomainId != null ? cfn_parse.FromCloudFormation.getString(properties.DomainId) : void 0), ret.addPropertyResult("userProfileArn", "UserProfileArn", properties.UserProfileArn != null ? cfn_parse.FromCloudFormation.getString(properties.UserProfileArn) : void 0), ret.addPropertyResult("userProfileName", "UserProfileName", properties.UserProfileName != null ? cfn_parse.FromCloudFormation.getString(properties.UserProfileName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelExplainabilityJobDefinitionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endpointName", cdk.validateString)(properties.endpointName)), errors.collect(cdk.propertyValidator("jobDefinitionName", cdk.validateString)(properties.jobDefinitionName)), errors.collect(cdk.propertyValidator("jobResources", cdk.requiredValidator)(properties.jobResources)), errors.collect(cdk.propertyValidator("jobResources", CfnModelExplainabilityJobDefinition_MonitoringResourcesPropertyValidator)(properties.jobResources)), errors.collect(cdk.propertyValidator("modelExplainabilityAppSpecification", cdk.requiredValidator)(properties.modelExplainabilityAppSpecification)), errors.collect(cdk.propertyValidator("modelExplainabilityAppSpecification", CfnModelExplainabilityJobDefinition_ModelExplainabilityAppSpecificationPropertyValidator)(properties.modelExplainabilityAppSpecification)), errors.collect(cdk.propertyValidator("modelExplainabilityBaselineConfig", CfnModelExplainabilityJobDefinition_ModelExplainabilityBaselineConfigPropertyValidator)(properties.modelExplainabilityBaselineConfig)), errors.collect(cdk.propertyValidator("modelExplainabilityJobInput", cdk.requiredValidator)(properties.modelExplainabilityJobInput)), errors.collect(cdk.propertyValidator("modelExplainabilityJobInput", CfnModelExplainabilityJobDefinition_ModelExplainabilityJobInputPropertyValidator)(properties.modelExplainabilityJobInput)), errors.collect(cdk.propertyValidator("modelExplainabilityJobOutputConfig", cdk.requiredValidator)(properties.modelExplainabilityJobOutputConfig)), errors.collect(cdk.propertyValidator("modelExplainabilityJobOutputConfig", CfnModelExplainabilityJobDefinition_MonitoringOutputConfigPropertyValidator)(properties.modelExplainabilityJobOutputConfig)), errors.collect(cdk.propertyValidator("networkConfig", CfnModelExplainabilityJobDefinition_NetworkConfigPropertyValidator)(properties.networkConfig)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("stoppingCondition", CfnModelExplainabilityJobDefinition_StoppingConditionPropertyValidator)(properties.stoppingCondition)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnModelExplainabilityJobDefinitionProps"');
    }
    function cfnModelExplainabilityJobDefinitionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelExplainabilityJobDefinitionPropsValidator(properties).assertSuccess(), { JobResources: cfnModelExplainabilityJobDefinitionMonitoringResourcesPropertyToCloudFormation(properties.jobResources), ModelExplainabilityAppSpecification: cfnModelExplainabilityJobDefinitionModelExplainabilityAppSpecificationPropertyToCloudFormation(properties.modelExplainabilityAppSpecification), ModelExplainabilityJobInput: cfnModelExplainabilityJobDefinitionModelExplainabilityJobInputPropertyToCloudFormation(properties.modelExplainabilityJobInput), ModelExplainabilityJobOutputConfig: cfnModelExplainabilityJobDefinitionMonitoringOutputConfigPropertyToCloudFormation(properties.modelExplainabilityJobOutputConfig), RoleArn: cdk.stringToCloudFormation(properties.roleArn), EndpointName: cdk.stringToCloudFormation(properties.endpointName), JobDefinitionName: cdk.stringToCloudFormation(properties.jobDefinitionName), ModelExplainabilityBaselineConfig: cfnModelExplainabilityJobDefinitionModelExplainabilityBaselineConfigPropertyToCloudFormation(properties.modelExplainabilityBaselineConfig), NetworkConfig: cfnModelExplainabilityJobDefinitionNetworkConfigPropertyToCloudFormation(properties.networkConfig), StoppingCondition: cfnModelExplainabilityJobDefinitionStoppingConditionPropertyToCloudFormation(properties.stoppingCondition), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnModelExplainabilityJobDefinitionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("jobResources", "JobResources", CfnModelExplainabilityJobDefinitionMonitoringResourcesPropertyFromCloudFormation(properties.JobResources)), ret.addPropertyResult("modelExplainabilityAppSpecification", "ModelExplainabilityAppSpecification", CfnModelExplainabilityJobDefinitionModelExplainabilityAppSpecificationPropertyFromCloudFormation(properties.ModelExplainabilityAppSpecification)), ret.addPropertyResult("modelExplainabilityJobInput", "ModelExplainabilityJobInput", CfnModelExplainabilityJobDefinitionModelExplainabilityJobInputPropertyFromCloudFormation(properties.ModelExplainabilityJobInput)), ret.addPropertyResult("modelExplainabilityJobOutputConfig", "ModelExplainabilityJobOutputConfig", CfnModelExplainabilityJobDefinitionMonitoringOutputConfigPropertyFromCloudFormation(properties.ModelExplainabilityJobOutputConfig)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("endpointName", "EndpointName", properties.EndpointName != null ? cfn_parse.FromCloudFormation.getString(properties.EndpointName) : void 0), ret.addPropertyResult("jobDefinitionName", "JobDefinitionName", properties.JobDefinitionName != null ? cfn_parse.FromCloudFormation.getString(properties.JobDefinitionName) : void 0), ret.addPropertyResult("modelExplainabilityBaselineConfig", "ModelExplainabilityBaselineConfig", properties.ModelExplainabilityBaselineConfig != null ? CfnModelExplainabilityJobDefinitionModelExplainabilityBaselineConfigPropertyFromCloudFormation(properties.ModelExplainabilityBaselineConfig) : void 0), ret.addPropertyResult("networkConfig", "NetworkConfig", properties.NetworkConfig != null ? CfnModelExplainabilityJobDefinitionNetworkConfigPropertyFromCloudFormation(properties.NetworkConfig) : void 0), ret.addPropertyResult("stoppingCondition", "StoppingCondition", properties.StoppingCondition != null ? CfnModelExplainabilityJobDefinitionStoppingConditionPropertyFromCloudFormation(properties.StoppingCondition) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnModelExplainabilityJobDefinition = class _CfnModelExplainabilityJobDefinition extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnModelExplainabilityJobDefinitionPropsFromCloudFormation(resourceProperties), ret = new _CfnModelExplainabilityJobDefinition(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnModelExplainabilityJobDefinition.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sagemaker_CfnModelExplainabilityJobDefinitionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnModelExplainabilityJobDefinition), error;
        }
        cdk.requireProperty(props, "jobResources", this), cdk.requireProperty(props, "modelExplainabilityAppSpecification", this), cdk.requireProperty(props, "modelExplainabilityJobInput", this), cdk.requireProperty(props, "modelExplainabilityJobOutputConfig", this), cdk.requireProperty(props, "roleArn", this), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrJobDefinitionArn = cdk.Token.asString(this.getAtt("JobDefinitionArn", cdk.ResolutionTypeHint.STRING)), this.jobResources = props.jobResources, this.modelExplainabilityAppSpecification = props.modelExplainabilityAppSpecification, this.modelExplainabilityJobInput = props.modelExplainabilityJobInput, this.modelExplainabilityJobOutputConfig = props.modelExplainabilityJobOutputConfig, this.roleArn = props.roleArn, this.endpointName = props.endpointName, this.jobDefinitionName = props.jobDefinitionName, this.modelExplainabilityBaselineConfig = props.modelExplainabilityBaselineConfig, this.networkConfig = props.networkConfig, this.stoppingCondition = props.stoppingCondition, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SageMaker::ModelExplainabilityJobDefinition", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnModelExplainabilityJobDefinition.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { jobResources: this.jobResources, modelExplainabilityAppSpecification: this.modelExplainabilityAppSpecification, modelExplainabilityJobInput: this.modelExplainabilityJobInput, modelExplainabilityJobOutputConfig: this.modelExplainabilityJobOutputConfig, roleArn: this.roleArn, endpointName: this.endpointName, jobDefinitionName: this.jobDefinitionName, modelExplainabilityBaselineConfig: this.modelExplainabilityBaselineConfig, networkConfig: this.networkConfig, stoppingCondition: this.stoppingCondition, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnModelExplainabilityJobDefinitionPropsToCloudFormation(props);
      }
    };
    _s = JSII_RTTI_SYMBOL_1, CfnModelExplainabilityJobDefinition[_s] = { fqn: "aws-cdk-lib.aws_sagemaker.CfnModelExplainabilityJobDefinition", version: "2.80.0" }, CfnModelExplainabilityJobDefinition.CFN_RESOURCE_TYPE_NAME = "AWS::SageMaker::ModelExplainabilityJobDefinition", exports2.CfnModelExplainabilityJobDefinition = CfnModelExplainabilityJobDefinition;
    function CfnModelExplainabilityJobDefinition_BatchTransformInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataCapturedDestinationS3Uri", cdk.requiredValidator)(properties.dataCapturedDestinationS3Uri)), errors.collect(cdk.propertyValidator("dataCapturedDestinationS3Uri", cdk.validateString)(properties.dataCapturedDestinationS3Uri)), errors.collect(cdk.propertyValidator("datasetFormat", cdk.requiredValidator)(properties.datasetFormat)), errors.collect(cdk.propertyValidator("datasetFormat", CfnModelExplainabilityJobDefinition_DatasetFormatPropertyValidator)(properties.datasetFormat)), errors.collect(cdk.propertyValidator("featuresAttribute", cdk.validateString)(properties.featuresAttribute)), errors.collect(cdk.propertyValidator("inferenceAttribute", cdk.validateString)(properties.inferenceAttribute)), errors.collect(cdk.propertyValidator("localPath", cdk.requiredValidator)(properties.localPath)), errors.collect(cdk.propertyValidator("localPath", cdk.validateString)(properties.localPath)), errors.collect(cdk.propertyValidator("probabilityAttribute", cdk.validateString)(properties.probabilityAttribute)), errors.collect(cdk.propertyValidator("s3DataDistributionType", cdk.validateString)(properties.s3DataDistributionType)), errors.collect(cdk.propertyValidator("s3InputMode", cdk.validateString)(properties.s3InputMode)), errors.wrap('supplied properties not correct for "BatchTransformInputProperty"');
    }
    function cfnModelExplainabilityJobDefinitionBatchTransformInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelExplainabilityJobDefinition_BatchTransformInputPropertyValidator(properties).assertSuccess(), { DataCapturedDestinationS3Uri: cdk.stringToCloudFormation(properties.dataCapturedDestinationS3Uri), DatasetFormat: cfnModelExplainabilityJobDefinitionDatasetFormatPropertyToCloudFormation(properties.datasetFormat), FeaturesAttribute: cdk.stringToCloudFormation(properties.featuresAttribute), InferenceAttribute: cdk.stringToCloudFormation(properties.inferenceAttribute), LocalPath: cdk.stringToCloudFormation(properties.localPath), ProbabilityAttribute: cdk.stringToCloudFormation(properties.probabilityAttribute), S3DataDistributionType: cdk.stringToCloudFormation(properties.s3DataDistributionType), S3InputMode: cdk.stringToCloudFormation(properties.s3InputMode) }) : properties;
    }
    function CfnModelExplainabilityJobDefinitionBatchTransformInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataCapturedDestinationS3Uri", "DataCapturedDestinationS3Uri", cfn_parse.FromCloudFormation.getString(properties.DataCapturedDestinationS3Uri)), ret.addPropertyResult("datasetFormat", "DatasetFormat", CfnModelExplainabilityJobDefinitionDatasetFormatPropertyFromCloudFormation(properties.DatasetFormat)), ret.addPropertyResult("featuresAttribute", "FeaturesAttribute", properties.FeaturesAttribute != null ? cfn_parse.FromCloudFormation.getString(properties.FeaturesAttribute) : void 0), ret.addPropertyResult("inferenceAttribute", "InferenceAttribute", properties.InferenceAttribute != null ? cfn_parse.FromCloudFormation.getString(properties.InferenceAttribute) : void 0), ret.addPropertyResult("localPath", "LocalPath", cfn_parse.FromCloudFormation.getString(properties.LocalPath)), ret.addPropertyResult("probabilityAttribute", "ProbabilityAttribute", properties.ProbabilityAttribute != null ? cfn_parse.FromCloudFormation.getString(properties.ProbabilityAttribute) : void 0), ret.addPropertyResult("s3DataDistributionType", "S3DataDistributionType", properties.S3DataDistributionType != null ? cfn_parse.FromCloudFormation.getString(properties.S3DataDistributionType) : void 0), ret.addPropertyResult("s3InputMode", "S3InputMode", properties.S3InputMode != null ? cfn_parse.FromCloudFormation.getString(properties.S3InputMode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelExplainabilityJobDefinition_ClusterConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceCount", cdk.requiredValidator)(properties.instanceCount)), errors.collect(cdk.propertyValidator("instanceCount", cdk.validateNumber)(properties.instanceCount)), errors.collect(cdk.propertyValidator("instanceType", cdk.requiredValidator)(properties.instanceType)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("volumeKmsKeyId", cdk.validateString)(properties.volumeKmsKeyId)), errors.collect(cdk.propertyValidator("volumeSizeInGb", cdk.requiredValidator)(properties.volumeSizeInGb)), errors.collect(cdk.propertyValidator("volumeSizeInGb", cdk.validateNumber)(properties.volumeSizeInGb)), errors.wrap('supplied properties not correct for "ClusterConfigProperty"');
    }
    function cfnModelExplainabilityJobDefinitionClusterConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelExplainabilityJobDefinition_ClusterConfigPropertyValidator(properties).assertSuccess(), { InstanceCount: cdk.numberToCloudFormation(properties.instanceCount), InstanceType: cdk.stringToCloudFormation(properties.instanceType), VolumeKmsKeyId: cdk.stringToCloudFormation(properties.volumeKmsKeyId), VolumeSizeInGB: cdk.numberToCloudFormation(properties.volumeSizeInGb) }) : properties;
    }
    function CfnModelExplainabilityJobDefinitionClusterConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceCount", "InstanceCount", cfn_parse.FromCloudFormation.getNumber(properties.InstanceCount)), ret.addPropertyResult("instanceType", "InstanceType", cfn_parse.FromCloudFormation.getString(properties.InstanceType)), ret.addPropertyResult("volumeKmsKeyId", "VolumeKmsKeyId", properties.VolumeKmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.VolumeKmsKeyId) : void 0), ret.addPropertyResult("volumeSizeInGb", "VolumeSizeInGB", cfn_parse.FromCloudFormation.getNumber(properties.VolumeSizeInGB)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelExplainabilityJobDefinition_ConstraintsResourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3Uri", cdk.validateString)(properties.s3Uri)), errors.wrap('supplied properties not correct for "ConstraintsResourceProperty"');
    }
    function cfnModelExplainabilityJobDefinitionConstraintsResourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelExplainabilityJobDefinition_ConstraintsResourcePropertyValidator(properties).assertSuccess(), { S3Uri: cdk.stringToCloudFormation(properties.s3Uri) }) : properties;
    }
    function CfnModelExplainabilityJobDefinitionConstraintsResourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Uri", "S3Uri", properties.S3Uri != null ? cfn_parse.FromCloudFormation.getString(properties.S3Uri) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelExplainabilityJobDefinition_CsvPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("header", cdk.validateBoolean)(properties.header)), errors.wrap('supplied properties not correct for "CsvProperty"');
    }
    function cfnModelExplainabilityJobDefinitionCsvPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelExplainabilityJobDefinition_CsvPropertyValidator(properties).assertSuccess(), { Header: cdk.booleanToCloudFormation(properties.header) }) : properties;
    }
    function CfnModelExplainabilityJobDefinitionCsvPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("header", "Header", properties.Header != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Header) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelExplainabilityJobDefinition_DatasetFormatPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("csv", CfnModelExplainabilityJobDefinition_CsvPropertyValidator)(properties.csv)), errors.collect(cdk.propertyValidator("json", CfnModelExplainabilityJobDefinition_JsonPropertyValidator)(properties.json)), errors.collect(cdk.propertyValidator("parquet", cdk.validateBoolean)(properties.parquet)), errors.wrap('supplied properties not correct for "DatasetFormatProperty"');
    }
    function cfnModelExplainabilityJobDefinitionDatasetFormatPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelExplainabilityJobDefinition_DatasetFormatPropertyValidator(properties).assertSuccess(), { Csv: cfnModelExplainabilityJobDefinitionCsvPropertyToCloudFormation(properties.csv), Json: cfnModelExplainabilityJobDefinitionJsonPropertyToCloudFormation(properties.json), Parquet: cdk.booleanToCloudFormation(properties.parquet) }) : properties;
    }
    function CfnModelExplainabilityJobDefinitionDatasetFormatPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("csv", "Csv", properties.Csv != null ? CfnModelExplainabilityJobDefinitionCsvPropertyFromCloudFormation(properties.Csv) : void 0), ret.addPropertyResult("json", "Json", properties.Json != null ? CfnModelExplainabilityJobDefinitionJsonPropertyFromCloudFormation(properties.Json) : void 0), ret.addPropertyResult("parquet", "Parquet", properties.Parquet != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Parquet) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelExplainabilityJobDefinition_EndpointInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endpointName", cdk.requiredValidator)(properties.endpointName)), errors.collect(cdk.propertyValidator("endpointName", cdk.validateString)(properties.endpointName)), errors.collect(cdk.propertyValidator("featuresAttribute", cdk.validateString)(properties.featuresAttribute)), errors.collect(cdk.propertyValidator("inferenceAttribute", cdk.validateString)(properties.inferenceAttribute)), errors.collect(cdk.propertyValidator("localPath", cdk.requiredValidator)(properties.localPath)), errors.collect(cdk.propertyValidator("localPath", cdk.validateString)(properties.localPath)), errors.collect(cdk.propertyValidator("probabilityAttribute", cdk.validateString)(properties.probabilityAttribute)), errors.collect(cdk.propertyValidator("s3DataDistributionType", cdk.validateString)(properties.s3DataDistributionType)), errors.collect(cdk.propertyValidator("s3InputMode", cdk.validateString)(properties.s3InputMode)), errors.wrap('supplied properties not correct for "EndpointInputProperty"');
    }
    function cfnModelExplainabilityJobDefinitionEndpointInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelExplainabilityJobDefinition_EndpointInputPropertyValidator(properties).assertSuccess(), { EndpointName: cdk.stringToCloudFormation(properties.endpointName), FeaturesAttribute: cdk.stringToCloudFormation(properties.featuresAttribute), InferenceAttribute: cdk.stringToCloudFormation(properties.inferenceAttribute), LocalPath: cdk.stringToCloudFormation(properties.localPath), ProbabilityAttribute: cdk.stringToCloudFormation(properties.probabilityAttribute), S3DataDistributionType: cdk.stringToCloudFormation(properties.s3DataDistributionType), S3InputMode: cdk.stringToCloudFormation(properties.s3InputMode) }) : properties;
    }
    function CfnModelExplainabilityJobDefinitionEndpointInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endpointName", "EndpointName", cfn_parse.FromCloudFormation.getString(properties.EndpointName)), ret.addPropertyResult("featuresAttribute", "FeaturesAttribute", properties.FeaturesAttribute != null ? cfn_parse.FromCloudFormation.getString(properties.FeaturesAttribute) : void 0), ret.addPropertyResult("inferenceAttribute", "InferenceAttribute", properties.InferenceAttribute != null ? cfn_parse.FromCloudFormation.getString(properties.InferenceAttribute) : void 0), ret.addPropertyResult("localPath", "LocalPath", cfn_parse.FromCloudFormation.getString(properties.LocalPath)), ret.addPropertyResult("probabilityAttribute", "ProbabilityAttribute", properties.ProbabilityAttribute != null ? cfn_parse.FromCloudFormation.getString(properties.ProbabilityAttribute) : void 0), ret.addPropertyResult("s3DataDistributionType", "S3DataDistributionType", properties.S3DataDistributionType != null ? cfn_parse.FromCloudFormation.getString(properties.S3DataDistributionType) : void 0), ret.addPropertyResult("s3InputMode", "S3InputMode", properties.S3InputMode != null ? cfn_parse.FromCloudFormation.getString(properties.S3InputMode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelExplainabilityJobDefinition_JsonPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("line", cdk.validateBoolean)(properties.line)), errors.wrap('supplied properties not correct for "JsonProperty"');
    }
    function cfnModelExplainabilityJobDefinitionJsonPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelExplainabilityJobDefinition_JsonPropertyValidator(properties).assertSuccess(), { Line: cdk.booleanToCloudFormation(properties.line) }) : properties;
    }
    function CfnModelExplainabilityJobDefinitionJsonPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("line", "Line", properties.Line != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Line) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelExplainabilityJobDefinition_ModelExplainabilityAppSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configUri", cdk.requiredValidator)(properties.configUri)), errors.collect(cdk.propertyValidator("configUri", cdk.validateString)(properties.configUri)), errors.collect(cdk.propertyValidator("environment", cdk.hashValidator(cdk.validateString))(properties.environment)), errors.collect(cdk.propertyValidator("imageUri", cdk.requiredValidator)(properties.imageUri)), errors.collect(cdk.propertyValidator("imageUri", cdk.validateString)(properties.imageUri)), errors.wrap('supplied properties not correct for "ModelExplainabilityAppSpecificationProperty"');
    }
    function cfnModelExplainabilityJobDefinitionModelExplainabilityAppSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelExplainabilityJobDefinition_ModelExplainabilityAppSpecificationPropertyValidator(properties).assertSuccess(), { ConfigUri: cdk.stringToCloudFormation(properties.configUri), Environment: cdk.hashMapper(cdk.stringToCloudFormation)(properties.environment), ImageUri: cdk.stringToCloudFormation(properties.imageUri) }) : properties;
    }
    function CfnModelExplainabilityJobDefinitionModelExplainabilityAppSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configUri", "ConfigUri", cfn_parse.FromCloudFormation.getString(properties.ConfigUri)), ret.addPropertyResult("environment", "Environment", properties.Environment != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Environment) : void 0), ret.addPropertyResult("imageUri", "ImageUri", cfn_parse.FromCloudFormation.getString(properties.ImageUri)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelExplainabilityJobDefinition_ModelExplainabilityBaselineConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("baseliningJobName", cdk.validateString)(properties.baseliningJobName)), errors.collect(cdk.propertyValidator("constraintsResource", CfnModelExplainabilityJobDefinition_ConstraintsResourcePropertyValidator)(properties.constraintsResource)), errors.wrap('supplied properties not correct for "ModelExplainabilityBaselineConfigProperty"');
    }
    function cfnModelExplainabilityJobDefinitionModelExplainabilityBaselineConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelExplainabilityJobDefinition_ModelExplainabilityBaselineConfigPropertyValidator(properties).assertSuccess(), { BaseliningJobName: cdk.stringToCloudFormation(properties.baseliningJobName), ConstraintsResource: cfnModelExplainabilityJobDefinitionConstraintsResourcePropertyToCloudFormation(properties.constraintsResource) }) : properties;
    }
    function CfnModelExplainabilityJobDefinitionModelExplainabilityBaselineConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("baseliningJobName", "BaseliningJobName", properties.BaseliningJobName != null ? cfn_parse.FromCloudFormation.getString(properties.BaseliningJobName) : void 0), ret.addPropertyResult("constraintsResource", "ConstraintsResource", properties.ConstraintsResource != null ? CfnModelExplainabilityJobDefinitionConstraintsResourcePropertyFromCloudFormation(properties.ConstraintsResource) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelExplainabilityJobDefinition_ModelExplainabilityJobInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("batchTransformInput", CfnModelExplainabilityJobDefinition_BatchTransformInputPropertyValidator)(properties.batchTransformInput)), errors.collect(cdk.propertyValidator("endpointInput", CfnModelExplainabilityJobDefinition_EndpointInputPropertyValidator)(properties.endpointInput)), errors.wrap('supplied properties not correct for "ModelExplainabilityJobInputProperty"');
    }
    function cfnModelExplainabilityJobDefinitionModelExplainabilityJobInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelExplainabilityJobDefinition_ModelExplainabilityJobInputPropertyValidator(properties).assertSuccess(), { BatchTransformInput: cfnModelExplainabilityJobDefinitionBatchTransformInputPropertyToCloudFormation(properties.batchTransformInput), EndpointInput: cfnModelExplainabilityJobDefinitionEndpointInputPropertyToCloudFormation(properties.endpointInput) }) : properties;
    }
    function CfnModelExplainabilityJobDefinitionModelExplainabilityJobInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("batchTransformInput", "BatchTransformInput", properties.BatchTransformInput != null ? CfnModelExplainabilityJobDefinitionBatchTransformInputPropertyFromCloudFormation(properties.BatchTransformInput) : void 0), ret.addPropertyResult("endpointInput", "EndpointInput", properties.EndpointInput != null ? CfnModelExplainabilityJobDefinitionEndpointInputPropertyFromCloudFormation(properties.EndpointInput) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelExplainabilityJobDefinition_MonitoringOutputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3Output", cdk.requiredValidator)(properties.s3Output)), errors.collect(cdk.propertyValidator("s3Output", CfnModelExplainabilityJobDefinition_S3OutputPropertyValidator)(properties.s3Output)), errors.wrap('supplied properties not correct for "MonitoringOutputProperty"');
    }
    function cfnModelExplainabilityJobDefinitionMonitoringOutputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelExplainabilityJobDefinition_MonitoringOutputPropertyValidator(properties).assertSuccess(), { S3Output: cfnModelExplainabilityJobDefinitionS3OutputPropertyToCloudFormation(properties.s3Output) }) : properties;
    }
    function CfnModelExplainabilityJobDefinitionMonitoringOutputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Output", "S3Output", CfnModelExplainabilityJobDefinitionS3OutputPropertyFromCloudFormation(properties.S3Output)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelExplainabilityJobDefinition_MonitoringOutputConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("monitoringOutputs", cdk.requiredValidator)(properties.monitoringOutputs)), errors.collect(cdk.propertyValidator("monitoringOutputs", cdk.listValidator(CfnModelExplainabilityJobDefinition_MonitoringOutputPropertyValidator))(properties.monitoringOutputs)), errors.wrap('supplied properties not correct for "MonitoringOutputConfigProperty"');
    }
    function cfnModelExplainabilityJobDefinitionMonitoringOutputConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelExplainabilityJobDefinition_MonitoringOutputConfigPropertyValidator(properties).assertSuccess(), { KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), MonitoringOutputs: cdk.listMapper(cfnModelExplainabilityJobDefinitionMonitoringOutputPropertyToCloudFormation)(properties.monitoringOutputs) }) : properties;
    }
    function CfnModelExplainabilityJobDefinitionMonitoringOutputConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("monitoringOutputs", "MonitoringOutputs", cfn_parse.FromCloudFormation.getArray(CfnModelExplainabilityJobDefinitionMonitoringOutputPropertyFromCloudFormation)(properties.MonitoringOutputs)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelExplainabilityJobDefinition_MonitoringResourcesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clusterConfig", cdk.requiredValidator)(properties.clusterConfig)), errors.collect(cdk.propertyValidator("clusterConfig", CfnModelExplainabilityJobDefinition_ClusterConfigPropertyValidator)(properties.clusterConfig)), errors.wrap('supplied properties not correct for "MonitoringResourcesProperty"');
    }
    function cfnModelExplainabilityJobDefinitionMonitoringResourcesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelExplainabilityJobDefinition_MonitoringResourcesPropertyValidator(properties).assertSuccess(), { ClusterConfig: cfnModelExplainabilityJobDefinitionClusterConfigPropertyToCloudFormation(properties.clusterConfig) }) : properties;
    }
    function CfnModelExplainabilityJobDefinitionMonitoringResourcesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clusterConfig", "ClusterConfig", CfnModelExplainabilityJobDefinitionClusterConfigPropertyFromCloudFormation(properties.ClusterConfig)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelExplainabilityJobDefinition_NetworkConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enableInterContainerTrafficEncryption", cdk.validateBoolean)(properties.enableInterContainerTrafficEncryption)), errors.collect(cdk.propertyValidator("enableNetworkIsolation", cdk.validateBoolean)(properties.enableNetworkIsolation)), errors.collect(cdk.propertyValidator("vpcConfig", CfnModelExplainabilityJobDefinition_VpcConfigPropertyValidator)(properties.vpcConfig)), errors.wrap('supplied properties not correct for "NetworkConfigProperty"');
    }
    function cfnModelExplainabilityJobDefinitionNetworkConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelExplainabilityJobDefinition_NetworkConfigPropertyValidator(properties).assertSuccess(), { EnableInterContainerTrafficEncryption: cdk.booleanToCloudFormation(properties.enableInterContainerTrafficEncryption), EnableNetworkIsolation: cdk.booleanToCloudFormation(properties.enableNetworkIsolation), VpcConfig: cfnModelExplainabilityJobDefinitionVpcConfigPropertyToCloudFormation(properties.vpcConfig) }) : properties;
    }
    function CfnModelExplainabilityJobDefinitionNetworkConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enableInterContainerTrafficEncryption", "EnableInterContainerTrafficEncryption", properties.EnableInterContainerTrafficEncryption != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableInterContainerTrafficEncryption) : void 0), ret.addPropertyResult("enableNetworkIsolation", "EnableNetworkIsolation", properties.EnableNetworkIsolation != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableNetworkIsolation) : void 0), ret.addPropertyResult("vpcConfig", "VpcConfig", properties.VpcConfig != null ? CfnModelExplainabilityJobDefinitionVpcConfigPropertyFromCloudFormation(properties.VpcConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelExplainabilityJobDefinition_S3OutputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("localPath", cdk.requiredValidator)(properties.localPath)), errors.collect(cdk.propertyValidator("localPath", cdk.validateString)(properties.localPath)), errors.collect(cdk.propertyValidator("s3UploadMode", cdk.validateString)(properties.s3UploadMode)), errors.collect(cdk.propertyValidator("s3Uri", cdk.requiredValidator)(properties.s3Uri)), errors.collect(cdk.propertyValidator("s3Uri", cdk.validateString)(properties.s3Uri)), errors.wrap('supplied properties not correct for "S3OutputProperty"');
    }
    function cfnModelExplainabilityJobDefinitionS3OutputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelExplainabilityJobDefinition_S3OutputPropertyValidator(properties).assertSuccess(), { LocalPath: cdk.stringToCloudFormation(properties.localPath), S3UploadMode: cdk.stringToCloudFormation(properties.s3UploadMode), S3Uri: cdk.stringToCloudFormation(properties.s3Uri) }) : properties;
    }
    function CfnModelExplainabilityJobDefinitionS3OutputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("localPath", "LocalPath", cfn_parse.FromCloudFormation.getString(properties.LocalPath)), ret.addPropertyResult("s3UploadMode", "S3UploadMode", properties.S3UploadMode != null ? cfn_parse.FromCloudFormation.getString(properties.S3UploadMode) : void 0), ret.addPropertyResult("s3Uri", "S3Uri", cfn_parse.FromCloudFormation.getString(properties.S3Uri)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelExplainabilityJobDefinition_StoppingConditionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxRuntimeInSeconds", cdk.requiredValidator)(properties.maxRuntimeInSeconds)), errors.collect(cdk.propertyValidator("maxRuntimeInSeconds", cdk.validateNumber)(properties.maxRuntimeInSeconds)), errors.wrap('supplied properties not correct for "StoppingConditionProperty"');
    }
    function cfnModelExplainabilityJobDefinitionStoppingConditionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelExplainabilityJobDefinition_StoppingConditionPropertyValidator(properties).assertSuccess(), { MaxRuntimeInSeconds: cdk.numberToCloudFormation(properties.maxRuntimeInSeconds) }) : properties;
    }
    function CfnModelExplainabilityJobDefinitionStoppingConditionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxRuntimeInSeconds", "MaxRuntimeInSeconds", cfn_parse.FromCloudFormation.getNumber(properties.MaxRuntimeInSeconds)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelExplainabilityJobDefinition_VpcConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.requiredValidator)(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnets", cdk.requiredValidator)(properties.subnets)), errors.collect(cdk.propertyValidator("subnets", cdk.listValidator(cdk.validateString))(properties.subnets)), errors.wrap('supplied properties not correct for "VpcConfigProperty"');
    }
    function cfnModelExplainabilityJobDefinitionVpcConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelExplainabilityJobDefinition_VpcConfigPropertyValidator(properties).assertSuccess(), { SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), Subnets: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnets) }) : properties;
    }
    function CfnModelExplainabilityJobDefinitionVpcConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds)), ret.addPropertyResult("subnets", "Subnets", cfn_parse.FromCloudFormation.getStringArray(properties.Subnets)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPackagePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("additionalInferenceSpecificationDefinition", CfnModelPackage_AdditionalInferenceSpecificationDefinitionPropertyValidator)(properties.additionalInferenceSpecificationDefinition)), errors.collect(cdk.propertyValidator("additionalInferenceSpecifications", cdk.listValidator(CfnModelPackage_AdditionalInferenceSpecificationDefinitionPropertyValidator))(properties.additionalInferenceSpecifications)), errors.collect(cdk.propertyValidator("additionalInferenceSpecificationsToAdd", cdk.listValidator(CfnModelPackage_AdditionalInferenceSpecificationDefinitionPropertyValidator))(properties.additionalInferenceSpecificationsToAdd)), errors.collect(cdk.propertyValidator("approvalDescription", cdk.validateString)(properties.approvalDescription)), errors.collect(cdk.propertyValidator("certifyForMarketplace", cdk.validateBoolean)(properties.certifyForMarketplace)), errors.collect(cdk.propertyValidator("clientToken", cdk.validateString)(properties.clientToken)), errors.collect(cdk.propertyValidator("createdBy", CfnModelPackage_UserContextPropertyValidator)(properties.createdBy)), errors.collect(cdk.propertyValidator("customerMetadataProperties", cdk.hashValidator(cdk.validateString))(properties.customerMetadataProperties)), errors.collect(cdk.propertyValidator("domain", cdk.validateString)(properties.domain)), errors.collect(cdk.propertyValidator("driftCheckBaselines", CfnModelPackage_DriftCheckBaselinesPropertyValidator)(properties.driftCheckBaselines)), errors.collect(cdk.propertyValidator("environment", cdk.hashValidator(cdk.validateString))(properties.environment)), errors.collect(cdk.propertyValidator("inferenceSpecification", CfnModelPackage_InferenceSpecificationPropertyValidator)(properties.inferenceSpecification)), errors.collect(cdk.propertyValidator("lastModifiedBy", CfnModelPackage_UserContextPropertyValidator)(properties.lastModifiedBy)), errors.collect(cdk.propertyValidator("lastModifiedTime", cdk.validateString)(properties.lastModifiedTime)), errors.collect(cdk.propertyValidator("metadataProperties", CfnModelPackage_MetadataPropertiesPropertyValidator)(properties.metadataProperties)), errors.collect(cdk.propertyValidator("modelApprovalStatus", cdk.validateString)(properties.modelApprovalStatus)), errors.collect(cdk.propertyValidator("modelMetrics", CfnModelPackage_ModelMetricsPropertyValidator)(properties.modelMetrics)), errors.collect(cdk.propertyValidator("modelPackageDescription", cdk.validateString)(properties.modelPackageDescription)), errors.collect(cdk.propertyValidator("modelPackageGroupName", cdk.validateString)(properties.modelPackageGroupName)), errors.collect(cdk.propertyValidator("modelPackageName", cdk.validateString)(properties.modelPackageName)), errors.collect(cdk.propertyValidator("modelPackageStatusDetails", CfnModelPackage_ModelPackageStatusDetailsPropertyValidator)(properties.modelPackageStatusDetails)), errors.collect(cdk.propertyValidator("modelPackageStatusItem", CfnModelPackage_ModelPackageStatusItemPropertyValidator)(properties.modelPackageStatusItem)), errors.collect(cdk.propertyValidator("modelPackageVersion", cdk.validateNumber)(properties.modelPackageVersion)), errors.collect(cdk.propertyValidator("samplePayloadUrl", cdk.validateString)(properties.samplePayloadUrl)), errors.collect(cdk.propertyValidator("sourceAlgorithmSpecification", CfnModelPackage_SourceAlgorithmSpecificationPropertyValidator)(properties.sourceAlgorithmSpecification)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("task", cdk.validateString)(properties.task)), errors.collect(cdk.propertyValidator("validationSpecification", CfnModelPackage_ValidationSpecificationPropertyValidator)(properties.validationSpecification)), errors.wrap('supplied properties not correct for "CfnModelPackageProps"');
    }
    function cfnModelPackagePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPackagePropsValidator(properties).assertSuccess(), { AdditionalInferenceSpecificationDefinition: cfnModelPackageAdditionalInferenceSpecificationDefinitionPropertyToCloudFormation(properties.additionalInferenceSpecificationDefinition), AdditionalInferenceSpecifications: cdk.listMapper(cfnModelPackageAdditionalInferenceSpecificationDefinitionPropertyToCloudFormation)(properties.additionalInferenceSpecifications), AdditionalInferenceSpecificationsToAdd: cdk.listMapper(cfnModelPackageAdditionalInferenceSpecificationDefinitionPropertyToCloudFormation)(properties.additionalInferenceSpecificationsToAdd), ApprovalDescription: cdk.stringToCloudFormation(properties.approvalDescription), CertifyForMarketplace: cdk.booleanToCloudFormation(properties.certifyForMarketplace), ClientToken: cdk.stringToCloudFormation(properties.clientToken), CreatedBy: cfnModelPackageUserContextPropertyToCloudFormation(properties.createdBy), CustomerMetadataProperties: cdk.hashMapper(cdk.stringToCloudFormation)(properties.customerMetadataProperties), Domain: cdk.stringToCloudFormation(properties.domain), DriftCheckBaselines: cfnModelPackageDriftCheckBaselinesPropertyToCloudFormation(properties.driftCheckBaselines), Environment: cdk.hashMapper(cdk.stringToCloudFormation)(properties.environment), InferenceSpecification: cfnModelPackageInferenceSpecificationPropertyToCloudFormation(properties.inferenceSpecification), LastModifiedBy: cfnModelPackageUserContextPropertyToCloudFormation(properties.lastModifiedBy), LastModifiedTime: cdk.stringToCloudFormation(properties.lastModifiedTime), MetadataProperties: cfnModelPackageMetadataPropertiesPropertyToCloudFormation(properties.metadataProperties), ModelApprovalStatus: cdk.stringToCloudFormation(properties.modelApprovalStatus), ModelMetrics: cfnModelPackageModelMetricsPropertyToCloudFormation(properties.modelMetrics), ModelPackageDescription: cdk.stringToCloudFormation(properties.modelPackageDescription), ModelPackageGroupName: cdk.stringToCloudFormation(properties.modelPackageGroupName), ModelPackageName: cdk.stringToCloudFormation(properties.modelPackageName), ModelPackageStatusDetails: cfnModelPackageModelPackageStatusDetailsPropertyToCloudFormation(properties.modelPackageStatusDetails), ModelPackageStatusItem: cfnModelPackageModelPackageStatusItemPropertyToCloudFormation(properties.modelPackageStatusItem), ModelPackageVersion: cdk.numberToCloudFormation(properties.modelPackageVersion), SamplePayloadUrl: cdk.stringToCloudFormation(properties.samplePayloadUrl), SourceAlgorithmSpecification: cfnModelPackageSourceAlgorithmSpecificationPropertyToCloudFormation(properties.sourceAlgorithmSpecification), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), Task: cdk.stringToCloudFormation(properties.task), ValidationSpecification: cfnModelPackageValidationSpecificationPropertyToCloudFormation(properties.validationSpecification) }) : properties;
    }
    function CfnModelPackagePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("additionalInferenceSpecificationDefinition", "AdditionalInferenceSpecificationDefinition", properties.AdditionalInferenceSpecificationDefinition != null ? CfnModelPackageAdditionalInferenceSpecificationDefinitionPropertyFromCloudFormation(properties.AdditionalInferenceSpecificationDefinition) : void 0), ret.addPropertyResult("additionalInferenceSpecifications", "AdditionalInferenceSpecifications", properties.AdditionalInferenceSpecifications != null ? cfn_parse.FromCloudFormation.getArray(CfnModelPackageAdditionalInferenceSpecificationDefinitionPropertyFromCloudFormation)(properties.AdditionalInferenceSpecifications) : void 0), ret.addPropertyResult("additionalInferenceSpecificationsToAdd", "AdditionalInferenceSpecificationsToAdd", properties.AdditionalInferenceSpecificationsToAdd != null ? cfn_parse.FromCloudFormation.getArray(CfnModelPackageAdditionalInferenceSpecificationDefinitionPropertyFromCloudFormation)(properties.AdditionalInferenceSpecificationsToAdd) : void 0), ret.addPropertyResult("approvalDescription", "ApprovalDescription", properties.ApprovalDescription != null ? cfn_parse.FromCloudFormation.getString(properties.ApprovalDescription) : void 0), ret.addPropertyResult("certifyForMarketplace", "CertifyForMarketplace", properties.CertifyForMarketplace != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CertifyForMarketplace) : void 0), ret.addPropertyResult("clientToken", "ClientToken", properties.ClientToken != null ? cfn_parse.FromCloudFormation.getString(properties.ClientToken) : void 0), ret.addPropertyResult("createdBy", "CreatedBy", properties.CreatedBy != null ? CfnModelPackageUserContextPropertyFromCloudFormation(properties.CreatedBy) : void 0), ret.addPropertyResult("customerMetadataProperties", "CustomerMetadataProperties", properties.CustomerMetadataProperties != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.CustomerMetadataProperties) : void 0), ret.addPropertyResult("domain", "Domain", properties.Domain != null ? cfn_parse.FromCloudFormation.getString(properties.Domain) : void 0), ret.addPropertyResult("driftCheckBaselines", "DriftCheckBaselines", properties.DriftCheckBaselines != null ? CfnModelPackageDriftCheckBaselinesPropertyFromCloudFormation(properties.DriftCheckBaselines) : void 0), ret.addPropertyResult("environment", "Environment", properties.Environment != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Environment) : void 0), ret.addPropertyResult("inferenceSpecification", "InferenceSpecification", properties.InferenceSpecification != null ? CfnModelPackageInferenceSpecificationPropertyFromCloudFormation(properties.InferenceSpecification) : void 0), ret.addPropertyResult("lastModifiedBy", "LastModifiedBy", properties.LastModifiedBy != null ? CfnModelPackageUserContextPropertyFromCloudFormation(properties.LastModifiedBy) : void 0), ret.addPropertyResult("lastModifiedTime", "LastModifiedTime", properties.LastModifiedTime != null ? cfn_parse.FromCloudFormation.getString(properties.LastModifiedTime) : void 0), ret.addPropertyResult("metadataProperties", "MetadataProperties", properties.MetadataProperties != null ? CfnModelPackageMetadataPropertiesPropertyFromCloudFormation(properties.MetadataProperties) : void 0), ret.addPropertyResult("modelApprovalStatus", "ModelApprovalStatus", properties.ModelApprovalStatus != null ? cfn_parse.FromCloudFormation.getString(properties.ModelApprovalStatus) : void 0), ret.addPropertyResult("modelMetrics", "ModelMetrics", properties.ModelMetrics != null ? CfnModelPackageModelMetricsPropertyFromCloudFormation(properties.ModelMetrics) : void 0), ret.addPropertyResult("modelPackageDescription", "ModelPackageDescription", properties.ModelPackageDescription != null ? cfn_parse.FromCloudFormation.getString(properties.ModelPackageDescription) : void 0), ret.addPropertyResult("modelPackageGroupName", "ModelPackageGroupName", properties.ModelPackageGroupName != null ? cfn_parse.FromCloudFormation.getString(properties.ModelPackageGroupName) : void 0), ret.addPropertyResult("modelPackageName", "ModelPackageName", properties.ModelPackageName != null ? cfn_parse.FromCloudFormation.getString(properties.ModelPackageName) : void 0), ret.addPropertyResult("modelPackageStatusDetails", "ModelPackageStatusDetails", properties.ModelPackageStatusDetails != null ? CfnModelPackageModelPackageStatusDetailsPropertyFromCloudFormation(properties.ModelPackageStatusDetails) : void 0), ret.addPropertyResult("modelPackageStatusItem", "ModelPackageStatusItem", properties.ModelPackageStatusItem != null ? CfnModelPackageModelPackageStatusItemPropertyFromCloudFormation(properties.ModelPackageStatusItem) : void 0), ret.addPropertyResult("modelPackageVersion", "ModelPackageVersion", properties.ModelPackageVersion != null ? cfn_parse.FromCloudFormation.getNumber(properties.ModelPackageVersion) : void 0), ret.addPropertyResult("samplePayloadUrl", "SamplePayloadUrl", properties.SamplePayloadUrl != null ? cfn_parse.FromCloudFormation.getString(properties.SamplePayloadUrl) : void 0), ret.addPropertyResult("sourceAlgorithmSpecification", "SourceAlgorithmSpecification", properties.SourceAlgorithmSpecification != null ? CfnModelPackageSourceAlgorithmSpecificationPropertyFromCloudFormation(properties.SourceAlgorithmSpecification) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("task", "Task", properties.Task != null ? cfn_parse.FromCloudFormation.getString(properties.Task) : void 0), ret.addPropertyResult("validationSpecification", "ValidationSpecification", properties.ValidationSpecification != null ? CfnModelPackageValidationSpecificationPropertyFromCloudFormation(properties.ValidationSpecification) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnModelPackage = class _CfnModelPackage extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnModelPackagePropsFromCloudFormation(resourceProperties), ret = new _CfnModelPackage(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnModelPackage.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sagemaker_CfnModelPackageProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnModelPackage), error;
        }
        this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrModelPackageArn = cdk.Token.asString(this.getAtt("ModelPackageArn", cdk.ResolutionTypeHint.STRING)), this.attrModelPackageStatus = cdk.Token.asString(this.getAtt("ModelPackageStatus", cdk.ResolutionTypeHint.STRING)), this.additionalInferenceSpecificationDefinition = props.additionalInferenceSpecificationDefinition, this.additionalInferenceSpecifications = props.additionalInferenceSpecifications, this.additionalInferenceSpecificationsToAdd = props.additionalInferenceSpecificationsToAdd, this.approvalDescription = props.approvalDescription, this.certifyForMarketplace = props.certifyForMarketplace, this.clientToken = props.clientToken, this.createdBy = props.createdBy, this.customerMetadataProperties = props.customerMetadataProperties, this.domain = props.domain, this.driftCheckBaselines = props.driftCheckBaselines, this.environment = props.environment, this.inferenceSpecification = props.inferenceSpecification, this.lastModifiedBy = props.lastModifiedBy, this.lastModifiedTime = props.lastModifiedTime, this.metadataProperties = props.metadataProperties, this.modelApprovalStatus = props.modelApprovalStatus, this.modelMetrics = props.modelMetrics, this.modelPackageDescription = props.modelPackageDescription, this.modelPackageGroupName = props.modelPackageGroupName, this.modelPackageName = props.modelPackageName, this.modelPackageStatusDetails = props.modelPackageStatusDetails, this.modelPackageStatusItem = props.modelPackageStatusItem, this.modelPackageVersion = props.modelPackageVersion, this.samplePayloadUrl = props.samplePayloadUrl, this.sourceAlgorithmSpecification = props.sourceAlgorithmSpecification, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SageMaker::ModelPackage", props.tags, { tagPropertyName: "tags" }), this.task = props.task, this.validationSpecification = props.validationSpecification;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnModelPackage.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { additionalInferenceSpecificationDefinition: this.additionalInferenceSpecificationDefinition, additionalInferenceSpecifications: this.additionalInferenceSpecifications, additionalInferenceSpecificationsToAdd: this.additionalInferenceSpecificationsToAdd, approvalDescription: this.approvalDescription, certifyForMarketplace: this.certifyForMarketplace, clientToken: this.clientToken, createdBy: this.createdBy, customerMetadataProperties: this.customerMetadataProperties, domain: this.domain, driftCheckBaselines: this.driftCheckBaselines, environment: this.environment, inferenceSpecification: this.inferenceSpecification, lastModifiedBy: this.lastModifiedBy, lastModifiedTime: this.lastModifiedTime, metadataProperties: this.metadataProperties, modelApprovalStatus: this.modelApprovalStatus, modelMetrics: this.modelMetrics, modelPackageDescription: this.modelPackageDescription, modelPackageGroupName: this.modelPackageGroupName, modelPackageName: this.modelPackageName, modelPackageStatusDetails: this.modelPackageStatusDetails, modelPackageStatusItem: this.modelPackageStatusItem, modelPackageVersion: this.modelPackageVersion, samplePayloadUrl: this.samplePayloadUrl, sourceAlgorithmSpecification: this.sourceAlgorithmSpecification, tags: this.tags.renderTags(), task: this.task, validationSpecification: this.validationSpecification };
      }
      renderProperties(props) {
        return cfnModelPackagePropsToCloudFormation(props);
      }
    };
    _t = JSII_RTTI_SYMBOL_1, CfnModelPackage[_t] = { fqn: "aws-cdk-lib.aws_sagemaker.CfnModelPackage", version: "2.80.0" }, CfnModelPackage.CFN_RESOURCE_TYPE_NAME = "AWS::SageMaker::ModelPackage", exports2.CfnModelPackage = CfnModelPackage;
    function CfnModelPackage_AdditionalInferenceSpecificationDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containers", cdk.requiredValidator)(properties.containers)), errors.collect(cdk.propertyValidator("containers", cdk.listValidator(CfnModelPackage_ModelPackageContainerDefinitionPropertyValidator))(properties.containers)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("supportedContentTypes", cdk.listValidator(cdk.validateString))(properties.supportedContentTypes)), errors.collect(cdk.propertyValidator("supportedRealtimeInferenceInstanceTypes", cdk.listValidator(cdk.validateString))(properties.supportedRealtimeInferenceInstanceTypes)), errors.collect(cdk.propertyValidator("supportedResponseMimeTypes", cdk.listValidator(cdk.validateString))(properties.supportedResponseMimeTypes)), errors.collect(cdk.propertyValidator("supportedTransformInstanceTypes", cdk.listValidator(cdk.validateString))(properties.supportedTransformInstanceTypes)), errors.wrap('supplied properties not correct for "AdditionalInferenceSpecificationDefinitionProperty"');
    }
    function cfnModelPackageAdditionalInferenceSpecificationDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPackage_AdditionalInferenceSpecificationDefinitionPropertyValidator(properties).assertSuccess(), { Containers: cdk.listMapper(cfnModelPackageModelPackageContainerDefinitionPropertyToCloudFormation)(properties.containers), Description: cdk.stringToCloudFormation(properties.description), Name: cdk.stringToCloudFormation(properties.name), SupportedContentTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.supportedContentTypes), SupportedRealtimeInferenceInstanceTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.supportedRealtimeInferenceInstanceTypes), SupportedResponseMIMETypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.supportedResponseMimeTypes), SupportedTransformInstanceTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.supportedTransformInstanceTypes) }) : properties;
    }
    function CfnModelPackageAdditionalInferenceSpecificationDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containers", "Containers", cfn_parse.FromCloudFormation.getArray(CfnModelPackageModelPackageContainerDefinitionPropertyFromCloudFormation)(properties.Containers)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("supportedContentTypes", "SupportedContentTypes", properties.SupportedContentTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SupportedContentTypes) : void 0), ret.addPropertyResult("supportedRealtimeInferenceInstanceTypes", "SupportedRealtimeInferenceInstanceTypes", properties.SupportedRealtimeInferenceInstanceTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SupportedRealtimeInferenceInstanceTypes) : void 0), ret.addPropertyResult("supportedResponseMimeTypes", "SupportedResponseMIMETypes", properties.SupportedResponseMIMETypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SupportedResponseMIMETypes) : void 0), ret.addPropertyResult("supportedTransformInstanceTypes", "SupportedTransformInstanceTypes", properties.SupportedTransformInstanceTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SupportedTransformInstanceTypes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPackage_BiasPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("postTrainingReport", CfnModelPackage_MetricsSourcePropertyValidator)(properties.postTrainingReport)), errors.collect(cdk.propertyValidator("preTrainingReport", CfnModelPackage_MetricsSourcePropertyValidator)(properties.preTrainingReport)), errors.collect(cdk.propertyValidator("report", CfnModelPackage_MetricsSourcePropertyValidator)(properties.report)), errors.wrap('supplied properties not correct for "BiasProperty"');
    }
    function cfnModelPackageBiasPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPackage_BiasPropertyValidator(properties).assertSuccess(), { PostTrainingReport: cfnModelPackageMetricsSourcePropertyToCloudFormation(properties.postTrainingReport), PreTrainingReport: cfnModelPackageMetricsSourcePropertyToCloudFormation(properties.preTrainingReport), Report: cfnModelPackageMetricsSourcePropertyToCloudFormation(properties.report) }) : properties;
    }
    function CfnModelPackageBiasPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("postTrainingReport", "PostTrainingReport", properties.PostTrainingReport != null ? CfnModelPackageMetricsSourcePropertyFromCloudFormation(properties.PostTrainingReport) : void 0), ret.addPropertyResult("preTrainingReport", "PreTrainingReport", properties.PreTrainingReport != null ? CfnModelPackageMetricsSourcePropertyFromCloudFormation(properties.PreTrainingReport) : void 0), ret.addPropertyResult("report", "Report", properties.Report != null ? CfnModelPackageMetricsSourcePropertyFromCloudFormation(properties.Report) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPackage_DataSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3DataSource", cdk.requiredValidator)(properties.s3DataSource)), errors.collect(cdk.propertyValidator("s3DataSource", CfnModelPackage_S3DataSourcePropertyValidator)(properties.s3DataSource)), errors.wrap('supplied properties not correct for "DataSourceProperty"');
    }
    function cfnModelPackageDataSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPackage_DataSourcePropertyValidator(properties).assertSuccess(), { S3DataSource: cfnModelPackageS3DataSourcePropertyToCloudFormation(properties.s3DataSource) }) : properties;
    }
    function CfnModelPackageDataSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3DataSource", "S3DataSource", CfnModelPackageS3DataSourcePropertyFromCloudFormation(properties.S3DataSource)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPackage_DriftCheckBaselinesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bias", CfnModelPackage_DriftCheckBiasPropertyValidator)(properties.bias)), errors.collect(cdk.propertyValidator("explainability", CfnModelPackage_DriftCheckExplainabilityPropertyValidator)(properties.explainability)), errors.collect(cdk.propertyValidator("modelDataQuality", CfnModelPackage_DriftCheckModelDataQualityPropertyValidator)(properties.modelDataQuality)), errors.collect(cdk.propertyValidator("modelQuality", CfnModelPackage_DriftCheckModelQualityPropertyValidator)(properties.modelQuality)), errors.wrap('supplied properties not correct for "DriftCheckBaselinesProperty"');
    }
    function cfnModelPackageDriftCheckBaselinesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPackage_DriftCheckBaselinesPropertyValidator(properties).assertSuccess(), { Bias: cfnModelPackageDriftCheckBiasPropertyToCloudFormation(properties.bias), Explainability: cfnModelPackageDriftCheckExplainabilityPropertyToCloudFormation(properties.explainability), ModelDataQuality: cfnModelPackageDriftCheckModelDataQualityPropertyToCloudFormation(properties.modelDataQuality), ModelQuality: cfnModelPackageDriftCheckModelQualityPropertyToCloudFormation(properties.modelQuality) }) : properties;
    }
    function CfnModelPackageDriftCheckBaselinesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bias", "Bias", properties.Bias != null ? CfnModelPackageDriftCheckBiasPropertyFromCloudFormation(properties.Bias) : void 0), ret.addPropertyResult("explainability", "Explainability", properties.Explainability != null ? CfnModelPackageDriftCheckExplainabilityPropertyFromCloudFormation(properties.Explainability) : void 0), ret.addPropertyResult("modelDataQuality", "ModelDataQuality", properties.ModelDataQuality != null ? CfnModelPackageDriftCheckModelDataQualityPropertyFromCloudFormation(properties.ModelDataQuality) : void 0), ret.addPropertyResult("modelQuality", "ModelQuality", properties.ModelQuality != null ? CfnModelPackageDriftCheckModelQualityPropertyFromCloudFormation(properties.ModelQuality) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPackage_DriftCheckBiasPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configFile", CfnModelPackage_FileSourcePropertyValidator)(properties.configFile)), errors.collect(cdk.propertyValidator("postTrainingConstraints", CfnModelPackage_MetricsSourcePropertyValidator)(properties.postTrainingConstraints)), errors.collect(cdk.propertyValidator("preTrainingConstraints", CfnModelPackage_MetricsSourcePropertyValidator)(properties.preTrainingConstraints)), errors.wrap('supplied properties not correct for "DriftCheckBiasProperty"');
    }
    function cfnModelPackageDriftCheckBiasPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPackage_DriftCheckBiasPropertyValidator(properties).assertSuccess(), { ConfigFile: cfnModelPackageFileSourcePropertyToCloudFormation(properties.configFile), PostTrainingConstraints: cfnModelPackageMetricsSourcePropertyToCloudFormation(properties.postTrainingConstraints), PreTrainingConstraints: cfnModelPackageMetricsSourcePropertyToCloudFormation(properties.preTrainingConstraints) }) : properties;
    }
    function CfnModelPackageDriftCheckBiasPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configFile", "ConfigFile", properties.ConfigFile != null ? CfnModelPackageFileSourcePropertyFromCloudFormation(properties.ConfigFile) : void 0), ret.addPropertyResult("postTrainingConstraints", "PostTrainingConstraints", properties.PostTrainingConstraints != null ? CfnModelPackageMetricsSourcePropertyFromCloudFormation(properties.PostTrainingConstraints) : void 0), ret.addPropertyResult("preTrainingConstraints", "PreTrainingConstraints", properties.PreTrainingConstraints != null ? CfnModelPackageMetricsSourcePropertyFromCloudFormation(properties.PreTrainingConstraints) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPackage_DriftCheckExplainabilityPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configFile", CfnModelPackage_FileSourcePropertyValidator)(properties.configFile)), errors.collect(cdk.propertyValidator("constraints", CfnModelPackage_MetricsSourcePropertyValidator)(properties.constraints)), errors.wrap('supplied properties not correct for "DriftCheckExplainabilityProperty"');
    }
    function cfnModelPackageDriftCheckExplainabilityPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPackage_DriftCheckExplainabilityPropertyValidator(properties).assertSuccess(), { ConfigFile: cfnModelPackageFileSourcePropertyToCloudFormation(properties.configFile), Constraints: cfnModelPackageMetricsSourcePropertyToCloudFormation(properties.constraints) }) : properties;
    }
    function CfnModelPackageDriftCheckExplainabilityPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configFile", "ConfigFile", properties.ConfigFile != null ? CfnModelPackageFileSourcePropertyFromCloudFormation(properties.ConfigFile) : void 0), ret.addPropertyResult("constraints", "Constraints", properties.Constraints != null ? CfnModelPackageMetricsSourcePropertyFromCloudFormation(properties.Constraints) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPackage_DriftCheckModelDataQualityPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("constraints", CfnModelPackage_MetricsSourcePropertyValidator)(properties.constraints)), errors.collect(cdk.propertyValidator("statistics", CfnModelPackage_MetricsSourcePropertyValidator)(properties.statistics)), errors.wrap('supplied properties not correct for "DriftCheckModelDataQualityProperty"');
    }
    function cfnModelPackageDriftCheckModelDataQualityPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPackage_DriftCheckModelDataQualityPropertyValidator(properties).assertSuccess(), { Constraints: cfnModelPackageMetricsSourcePropertyToCloudFormation(properties.constraints), Statistics: cfnModelPackageMetricsSourcePropertyToCloudFormation(properties.statistics) }) : properties;
    }
    function CfnModelPackageDriftCheckModelDataQualityPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("constraints", "Constraints", properties.Constraints != null ? CfnModelPackageMetricsSourcePropertyFromCloudFormation(properties.Constraints) : void 0), ret.addPropertyResult("statistics", "Statistics", properties.Statistics != null ? CfnModelPackageMetricsSourcePropertyFromCloudFormation(properties.Statistics) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPackage_DriftCheckModelQualityPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("constraints", CfnModelPackage_MetricsSourcePropertyValidator)(properties.constraints)), errors.collect(cdk.propertyValidator("statistics", CfnModelPackage_MetricsSourcePropertyValidator)(properties.statistics)), errors.wrap('supplied properties not correct for "DriftCheckModelQualityProperty"');
    }
    function cfnModelPackageDriftCheckModelQualityPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPackage_DriftCheckModelQualityPropertyValidator(properties).assertSuccess(), { Constraints: cfnModelPackageMetricsSourcePropertyToCloudFormation(properties.constraints), Statistics: cfnModelPackageMetricsSourcePropertyToCloudFormation(properties.statistics) }) : properties;
    }
    function CfnModelPackageDriftCheckModelQualityPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("constraints", "Constraints", properties.Constraints != null ? CfnModelPackageMetricsSourcePropertyFromCloudFormation(properties.Constraints) : void 0), ret.addPropertyResult("statistics", "Statistics", properties.Statistics != null ? CfnModelPackageMetricsSourcePropertyFromCloudFormation(properties.Statistics) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPackage_ExplainabilityPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("report", CfnModelPackage_MetricsSourcePropertyValidator)(properties.report)), errors.wrap('supplied properties not correct for "ExplainabilityProperty"');
    }
    function cfnModelPackageExplainabilityPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPackage_ExplainabilityPropertyValidator(properties).assertSuccess(), { Report: cfnModelPackageMetricsSourcePropertyToCloudFormation(properties.report) }) : properties;
    }
    function CfnModelPackageExplainabilityPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("report", "Report", properties.Report != null ? CfnModelPackageMetricsSourcePropertyFromCloudFormation(properties.Report) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPackage_FileSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contentDigest", cdk.validateString)(properties.contentDigest)), errors.collect(cdk.propertyValidator("contentType", cdk.validateString)(properties.contentType)), errors.collect(cdk.propertyValidator("s3Uri", cdk.requiredValidator)(properties.s3Uri)), errors.collect(cdk.propertyValidator("s3Uri", cdk.validateString)(properties.s3Uri)), errors.wrap('supplied properties not correct for "FileSourceProperty"');
    }
    function cfnModelPackageFileSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPackage_FileSourcePropertyValidator(properties).assertSuccess(), { ContentDigest: cdk.stringToCloudFormation(properties.contentDigest), ContentType: cdk.stringToCloudFormation(properties.contentType), S3Uri: cdk.stringToCloudFormation(properties.s3Uri) }) : properties;
    }
    function CfnModelPackageFileSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contentDigest", "ContentDigest", properties.ContentDigest != null ? cfn_parse.FromCloudFormation.getString(properties.ContentDigest) : void 0), ret.addPropertyResult("contentType", "ContentType", properties.ContentType != null ? cfn_parse.FromCloudFormation.getString(properties.ContentType) : void 0), ret.addPropertyResult("s3Uri", "S3Uri", cfn_parse.FromCloudFormation.getString(properties.S3Uri)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPackage_InferenceSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containers", cdk.requiredValidator)(properties.containers)), errors.collect(cdk.propertyValidator("containers", cdk.listValidator(CfnModelPackage_ModelPackageContainerDefinitionPropertyValidator))(properties.containers)), errors.collect(cdk.propertyValidator("supportedContentTypes", cdk.requiredValidator)(properties.supportedContentTypes)), errors.collect(cdk.propertyValidator("supportedContentTypes", cdk.listValidator(cdk.validateString))(properties.supportedContentTypes)), errors.collect(cdk.propertyValidator("supportedRealtimeInferenceInstanceTypes", cdk.listValidator(cdk.validateString))(properties.supportedRealtimeInferenceInstanceTypes)), errors.collect(cdk.propertyValidator("supportedResponseMimeTypes", cdk.requiredValidator)(properties.supportedResponseMimeTypes)), errors.collect(cdk.propertyValidator("supportedResponseMimeTypes", cdk.listValidator(cdk.validateString))(properties.supportedResponseMimeTypes)), errors.collect(cdk.propertyValidator("supportedTransformInstanceTypes", cdk.listValidator(cdk.validateString))(properties.supportedTransformInstanceTypes)), errors.wrap('supplied properties not correct for "InferenceSpecificationProperty"');
    }
    function cfnModelPackageInferenceSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPackage_InferenceSpecificationPropertyValidator(properties).assertSuccess(), { Containers: cdk.listMapper(cfnModelPackageModelPackageContainerDefinitionPropertyToCloudFormation)(properties.containers), SupportedContentTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.supportedContentTypes), SupportedRealtimeInferenceInstanceTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.supportedRealtimeInferenceInstanceTypes), SupportedResponseMIMETypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.supportedResponseMimeTypes), SupportedTransformInstanceTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.supportedTransformInstanceTypes) }) : properties;
    }
    function CfnModelPackageInferenceSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containers", "Containers", cfn_parse.FromCloudFormation.getArray(CfnModelPackageModelPackageContainerDefinitionPropertyFromCloudFormation)(properties.Containers)), ret.addPropertyResult("supportedContentTypes", "SupportedContentTypes", cfn_parse.FromCloudFormation.getStringArray(properties.SupportedContentTypes)), ret.addPropertyResult("supportedRealtimeInferenceInstanceTypes", "SupportedRealtimeInferenceInstanceTypes", properties.SupportedRealtimeInferenceInstanceTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SupportedRealtimeInferenceInstanceTypes) : void 0), ret.addPropertyResult("supportedResponseMimeTypes", "SupportedResponseMIMETypes", cfn_parse.FromCloudFormation.getStringArray(properties.SupportedResponseMIMETypes)), ret.addPropertyResult("supportedTransformInstanceTypes", "SupportedTransformInstanceTypes", properties.SupportedTransformInstanceTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SupportedTransformInstanceTypes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPackage_MetadataPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("commitId", cdk.validateString)(properties.commitId)), errors.collect(cdk.propertyValidator("generatedBy", cdk.validateString)(properties.generatedBy)), errors.collect(cdk.propertyValidator("projectId", cdk.validateString)(properties.projectId)), errors.collect(cdk.propertyValidator("repository", cdk.validateString)(properties.repository)), errors.wrap('supplied properties not correct for "MetadataPropertiesProperty"');
    }
    function cfnModelPackageMetadataPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPackage_MetadataPropertiesPropertyValidator(properties).assertSuccess(), { CommitId: cdk.stringToCloudFormation(properties.commitId), GeneratedBy: cdk.stringToCloudFormation(properties.generatedBy), ProjectId: cdk.stringToCloudFormation(properties.projectId), Repository: cdk.stringToCloudFormation(properties.repository) }) : properties;
    }
    function CfnModelPackageMetadataPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("commitId", "CommitId", properties.CommitId != null ? cfn_parse.FromCloudFormation.getString(properties.CommitId) : void 0), ret.addPropertyResult("generatedBy", "GeneratedBy", properties.GeneratedBy != null ? cfn_parse.FromCloudFormation.getString(properties.GeneratedBy) : void 0), ret.addPropertyResult("projectId", "ProjectId", properties.ProjectId != null ? cfn_parse.FromCloudFormation.getString(properties.ProjectId) : void 0), ret.addPropertyResult("repository", "Repository", properties.Repository != null ? cfn_parse.FromCloudFormation.getString(properties.Repository) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPackage_MetricsSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contentDigest", cdk.validateString)(properties.contentDigest)), errors.collect(cdk.propertyValidator("contentType", cdk.requiredValidator)(properties.contentType)), errors.collect(cdk.propertyValidator("contentType", cdk.validateString)(properties.contentType)), errors.collect(cdk.propertyValidator("s3Uri", cdk.requiredValidator)(properties.s3Uri)), errors.collect(cdk.propertyValidator("s3Uri", cdk.validateString)(properties.s3Uri)), errors.wrap('supplied properties not correct for "MetricsSourceProperty"');
    }
    function cfnModelPackageMetricsSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPackage_MetricsSourcePropertyValidator(properties).assertSuccess(), { ContentDigest: cdk.stringToCloudFormation(properties.contentDigest), ContentType: cdk.stringToCloudFormation(properties.contentType), S3Uri: cdk.stringToCloudFormation(properties.s3Uri) }) : properties;
    }
    function CfnModelPackageMetricsSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contentDigest", "ContentDigest", properties.ContentDigest != null ? cfn_parse.FromCloudFormation.getString(properties.ContentDigest) : void 0), ret.addPropertyResult("contentType", "ContentType", cfn_parse.FromCloudFormation.getString(properties.ContentType)), ret.addPropertyResult("s3Uri", "S3Uri", cfn_parse.FromCloudFormation.getString(properties.S3Uri)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPackage_ModelDataQualityPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("constraints", CfnModelPackage_MetricsSourcePropertyValidator)(properties.constraints)), errors.collect(cdk.propertyValidator("statistics", CfnModelPackage_MetricsSourcePropertyValidator)(properties.statistics)), errors.wrap('supplied properties not correct for "ModelDataQualityProperty"');
    }
    function cfnModelPackageModelDataQualityPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPackage_ModelDataQualityPropertyValidator(properties).assertSuccess(), { Constraints: cfnModelPackageMetricsSourcePropertyToCloudFormation(properties.constraints), Statistics: cfnModelPackageMetricsSourcePropertyToCloudFormation(properties.statistics) }) : properties;
    }
    function CfnModelPackageModelDataQualityPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("constraints", "Constraints", properties.Constraints != null ? CfnModelPackageMetricsSourcePropertyFromCloudFormation(properties.Constraints) : void 0), ret.addPropertyResult("statistics", "Statistics", properties.Statistics != null ? CfnModelPackageMetricsSourcePropertyFromCloudFormation(properties.Statistics) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPackage_ModelMetricsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bias", CfnModelPackage_BiasPropertyValidator)(properties.bias)), errors.collect(cdk.propertyValidator("explainability", CfnModelPackage_ExplainabilityPropertyValidator)(properties.explainability)), errors.collect(cdk.propertyValidator("modelDataQuality", CfnModelPackage_ModelDataQualityPropertyValidator)(properties.modelDataQuality)), errors.collect(cdk.propertyValidator("modelQuality", CfnModelPackage_ModelQualityPropertyValidator)(properties.modelQuality)), errors.wrap('supplied properties not correct for "ModelMetricsProperty"');
    }
    function cfnModelPackageModelMetricsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPackage_ModelMetricsPropertyValidator(properties).assertSuccess(), { Bias: cfnModelPackageBiasPropertyToCloudFormation(properties.bias), Explainability: cfnModelPackageExplainabilityPropertyToCloudFormation(properties.explainability), ModelDataQuality: cfnModelPackageModelDataQualityPropertyToCloudFormation(properties.modelDataQuality), ModelQuality: cfnModelPackageModelQualityPropertyToCloudFormation(properties.modelQuality) }) : properties;
    }
    function CfnModelPackageModelMetricsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bias", "Bias", properties.Bias != null ? CfnModelPackageBiasPropertyFromCloudFormation(properties.Bias) : void 0), ret.addPropertyResult("explainability", "Explainability", properties.Explainability != null ? CfnModelPackageExplainabilityPropertyFromCloudFormation(properties.Explainability) : void 0), ret.addPropertyResult("modelDataQuality", "ModelDataQuality", properties.ModelDataQuality != null ? CfnModelPackageModelDataQualityPropertyFromCloudFormation(properties.ModelDataQuality) : void 0), ret.addPropertyResult("modelQuality", "ModelQuality", properties.ModelQuality != null ? CfnModelPackageModelQualityPropertyFromCloudFormation(properties.ModelQuality) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPackage_ModelPackageContainerDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containerHostname", cdk.validateString)(properties.containerHostname)), errors.collect(cdk.propertyValidator("environment", cdk.hashValidator(cdk.validateString))(properties.environment)), errors.collect(cdk.propertyValidator("framework", cdk.validateString)(properties.framework)), errors.collect(cdk.propertyValidator("frameworkVersion", cdk.validateString)(properties.frameworkVersion)), errors.collect(cdk.propertyValidator("image", cdk.requiredValidator)(properties.image)), errors.collect(cdk.propertyValidator("image", cdk.validateString)(properties.image)), errors.collect(cdk.propertyValidator("imageDigest", cdk.validateString)(properties.imageDigest)), errors.collect(cdk.propertyValidator("modelDataUrl", cdk.validateString)(properties.modelDataUrl)), errors.collect(cdk.propertyValidator("modelInput", cdk.validateObject)(properties.modelInput)), errors.collect(cdk.propertyValidator("nearestModelName", cdk.validateString)(properties.nearestModelName)), errors.collect(cdk.propertyValidator("productId", cdk.validateString)(properties.productId)), errors.wrap('supplied properties not correct for "ModelPackageContainerDefinitionProperty"');
    }
    function cfnModelPackageModelPackageContainerDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPackage_ModelPackageContainerDefinitionPropertyValidator(properties).assertSuccess(), { ContainerHostname: cdk.stringToCloudFormation(properties.containerHostname), Environment: cdk.hashMapper(cdk.stringToCloudFormation)(properties.environment), Framework: cdk.stringToCloudFormation(properties.framework), FrameworkVersion: cdk.stringToCloudFormation(properties.frameworkVersion), Image: cdk.stringToCloudFormation(properties.image), ImageDigest: cdk.stringToCloudFormation(properties.imageDigest), ModelDataUrl: cdk.stringToCloudFormation(properties.modelDataUrl), ModelInput: cdk.objectToCloudFormation(properties.modelInput), NearestModelName: cdk.stringToCloudFormation(properties.nearestModelName), ProductId: cdk.stringToCloudFormation(properties.productId) }) : properties;
    }
    function CfnModelPackageModelPackageContainerDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containerHostname", "ContainerHostname", properties.ContainerHostname != null ? cfn_parse.FromCloudFormation.getString(properties.ContainerHostname) : void 0), ret.addPropertyResult("environment", "Environment", properties.Environment != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Environment) : void 0), ret.addPropertyResult("framework", "Framework", properties.Framework != null ? cfn_parse.FromCloudFormation.getString(properties.Framework) : void 0), ret.addPropertyResult("frameworkVersion", "FrameworkVersion", properties.FrameworkVersion != null ? cfn_parse.FromCloudFormation.getString(properties.FrameworkVersion) : void 0), ret.addPropertyResult("image", "Image", cfn_parse.FromCloudFormation.getString(properties.Image)), ret.addPropertyResult("imageDigest", "ImageDigest", properties.ImageDigest != null ? cfn_parse.FromCloudFormation.getString(properties.ImageDigest) : void 0), ret.addPropertyResult("modelDataUrl", "ModelDataUrl", properties.ModelDataUrl != null ? cfn_parse.FromCloudFormation.getString(properties.ModelDataUrl) : void 0), ret.addPropertyResult("modelInput", "ModelInput", properties.ModelInput != null ? cfn_parse.FromCloudFormation.getAny(properties.ModelInput) : void 0), ret.addPropertyResult("nearestModelName", "NearestModelName", properties.NearestModelName != null ? cfn_parse.FromCloudFormation.getString(properties.NearestModelName) : void 0), ret.addPropertyResult("productId", "ProductId", properties.ProductId != null ? cfn_parse.FromCloudFormation.getString(properties.ProductId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPackage_ModelPackageStatusDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("imageScanStatuses", cdk.listValidator(CfnModelPackage_ModelPackageStatusItemPropertyValidator))(properties.imageScanStatuses)), errors.collect(cdk.propertyValidator("validationStatuses", cdk.requiredValidator)(properties.validationStatuses)), errors.collect(cdk.propertyValidator("validationStatuses", cdk.listValidator(CfnModelPackage_ModelPackageStatusItemPropertyValidator))(properties.validationStatuses)), errors.wrap('supplied properties not correct for "ModelPackageStatusDetailsProperty"');
    }
    function cfnModelPackageModelPackageStatusDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPackage_ModelPackageStatusDetailsPropertyValidator(properties).assertSuccess(), { ImageScanStatuses: cdk.listMapper(cfnModelPackageModelPackageStatusItemPropertyToCloudFormation)(properties.imageScanStatuses), ValidationStatuses: cdk.listMapper(cfnModelPackageModelPackageStatusItemPropertyToCloudFormation)(properties.validationStatuses) }) : properties;
    }
    function CfnModelPackageModelPackageStatusDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("imageScanStatuses", "ImageScanStatuses", properties.ImageScanStatuses != null ? cfn_parse.FromCloudFormation.getArray(CfnModelPackageModelPackageStatusItemPropertyFromCloudFormation)(properties.ImageScanStatuses) : void 0), ret.addPropertyResult("validationStatuses", "ValidationStatuses", cfn_parse.FromCloudFormation.getArray(CfnModelPackageModelPackageStatusItemPropertyFromCloudFormation)(properties.ValidationStatuses)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPackage_ModelPackageStatusItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("failureReason", cdk.validateString)(properties.failureReason)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("status", cdk.requiredValidator)(properties.status)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.wrap('supplied properties not correct for "ModelPackageStatusItemProperty"');
    }
    function cfnModelPackageModelPackageStatusItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPackage_ModelPackageStatusItemPropertyValidator(properties).assertSuccess(), { FailureReason: cdk.stringToCloudFormation(properties.failureReason), Name: cdk.stringToCloudFormation(properties.name), Status: cdk.stringToCloudFormation(properties.status) }) : properties;
    }
    function CfnModelPackageModelPackageStatusItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("failureReason", "FailureReason", properties.FailureReason != null ? cfn_parse.FromCloudFormation.getString(properties.FailureReason) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("status", "Status", cfn_parse.FromCloudFormation.getString(properties.Status)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPackage_ModelQualityPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("constraints", CfnModelPackage_MetricsSourcePropertyValidator)(properties.constraints)), errors.collect(cdk.propertyValidator("statistics", CfnModelPackage_MetricsSourcePropertyValidator)(properties.statistics)), errors.wrap('supplied properties not correct for "ModelQualityProperty"');
    }
    function cfnModelPackageModelQualityPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPackage_ModelQualityPropertyValidator(properties).assertSuccess(), { Constraints: cfnModelPackageMetricsSourcePropertyToCloudFormation(properties.constraints), Statistics: cfnModelPackageMetricsSourcePropertyToCloudFormation(properties.statistics) }) : properties;
    }
    function CfnModelPackageModelQualityPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("constraints", "Constraints", properties.Constraints != null ? CfnModelPackageMetricsSourcePropertyFromCloudFormation(properties.Constraints) : void 0), ret.addPropertyResult("statistics", "Statistics", properties.Statistics != null ? CfnModelPackageMetricsSourcePropertyFromCloudFormation(properties.Statistics) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPackage_S3DataSourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3DataType", cdk.requiredValidator)(properties.s3DataType)), errors.collect(cdk.propertyValidator("s3DataType", cdk.validateString)(properties.s3DataType)), errors.collect(cdk.propertyValidator("s3Uri", cdk.requiredValidator)(properties.s3Uri)), errors.collect(cdk.propertyValidator("s3Uri", cdk.validateString)(properties.s3Uri)), errors.wrap('supplied properties not correct for "S3DataSourceProperty"');
    }
    function cfnModelPackageS3DataSourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPackage_S3DataSourcePropertyValidator(properties).assertSuccess(), { S3DataType: cdk.stringToCloudFormation(properties.s3DataType), S3Uri: cdk.stringToCloudFormation(properties.s3Uri) }) : properties;
    }
    function CfnModelPackageS3DataSourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3DataType", "S3DataType", cfn_parse.FromCloudFormation.getString(properties.S3DataType)), ret.addPropertyResult("s3Uri", "S3Uri", cfn_parse.FromCloudFormation.getString(properties.S3Uri)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPackage_SourceAlgorithmPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("algorithmName", cdk.requiredValidator)(properties.algorithmName)), errors.collect(cdk.propertyValidator("algorithmName", cdk.validateString)(properties.algorithmName)), errors.collect(cdk.propertyValidator("modelDataUrl", cdk.validateString)(properties.modelDataUrl)), errors.wrap('supplied properties not correct for "SourceAlgorithmProperty"');
    }
    function cfnModelPackageSourceAlgorithmPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPackage_SourceAlgorithmPropertyValidator(properties).assertSuccess(), { AlgorithmName: cdk.stringToCloudFormation(properties.algorithmName), ModelDataUrl: cdk.stringToCloudFormation(properties.modelDataUrl) }) : properties;
    }
    function CfnModelPackageSourceAlgorithmPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("algorithmName", "AlgorithmName", cfn_parse.FromCloudFormation.getString(properties.AlgorithmName)), ret.addPropertyResult("modelDataUrl", "ModelDataUrl", properties.ModelDataUrl != null ? cfn_parse.FromCloudFormation.getString(properties.ModelDataUrl) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPackage_SourceAlgorithmSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sourceAlgorithms", cdk.requiredValidator)(properties.sourceAlgorithms)), errors.collect(cdk.propertyValidator("sourceAlgorithms", cdk.listValidator(CfnModelPackage_SourceAlgorithmPropertyValidator))(properties.sourceAlgorithms)), errors.wrap('supplied properties not correct for "SourceAlgorithmSpecificationProperty"');
    }
    function cfnModelPackageSourceAlgorithmSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPackage_SourceAlgorithmSpecificationPropertyValidator(properties).assertSuccess(), { SourceAlgorithms: cdk.listMapper(cfnModelPackageSourceAlgorithmPropertyToCloudFormation)(properties.sourceAlgorithms) }) : properties;
    }
    function CfnModelPackageSourceAlgorithmSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sourceAlgorithms", "SourceAlgorithms", cfn_parse.FromCloudFormation.getArray(CfnModelPackageSourceAlgorithmPropertyFromCloudFormation)(properties.SourceAlgorithms)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPackage_TransformInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("compressionType", cdk.validateString)(properties.compressionType)), errors.collect(cdk.propertyValidator("contentType", cdk.validateString)(properties.contentType)), errors.collect(cdk.propertyValidator("dataSource", cdk.requiredValidator)(properties.dataSource)), errors.collect(cdk.propertyValidator("dataSource", CfnModelPackage_DataSourcePropertyValidator)(properties.dataSource)), errors.collect(cdk.propertyValidator("splitType", cdk.validateString)(properties.splitType)), errors.wrap('supplied properties not correct for "TransformInputProperty"');
    }
    function cfnModelPackageTransformInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPackage_TransformInputPropertyValidator(properties).assertSuccess(), { CompressionType: cdk.stringToCloudFormation(properties.compressionType), ContentType: cdk.stringToCloudFormation(properties.contentType), DataSource: cfnModelPackageDataSourcePropertyToCloudFormation(properties.dataSource), SplitType: cdk.stringToCloudFormation(properties.splitType) }) : properties;
    }
    function CfnModelPackageTransformInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("compressionType", "CompressionType", properties.CompressionType != null ? cfn_parse.FromCloudFormation.getString(properties.CompressionType) : void 0), ret.addPropertyResult("contentType", "ContentType", properties.ContentType != null ? cfn_parse.FromCloudFormation.getString(properties.ContentType) : void 0), ret.addPropertyResult("dataSource", "DataSource", CfnModelPackageDataSourcePropertyFromCloudFormation(properties.DataSource)), ret.addPropertyResult("splitType", "SplitType", properties.SplitType != null ? cfn_parse.FromCloudFormation.getString(properties.SplitType) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPackage_TransformJobDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("batchStrategy", cdk.validateString)(properties.batchStrategy)), errors.collect(cdk.propertyValidator("environment", cdk.hashValidator(cdk.validateString))(properties.environment)), errors.collect(cdk.propertyValidator("maxConcurrentTransforms", cdk.validateNumber)(properties.maxConcurrentTransforms)), errors.collect(cdk.propertyValidator("maxPayloadInMb", cdk.validateNumber)(properties.maxPayloadInMb)), errors.collect(cdk.propertyValidator("transformInput", cdk.requiredValidator)(properties.transformInput)), errors.collect(cdk.propertyValidator("transformInput", CfnModelPackage_TransformInputPropertyValidator)(properties.transformInput)), errors.collect(cdk.propertyValidator("transformOutput", cdk.requiredValidator)(properties.transformOutput)), errors.collect(cdk.propertyValidator("transformOutput", CfnModelPackage_TransformOutputPropertyValidator)(properties.transformOutput)), errors.collect(cdk.propertyValidator("transformResources", cdk.requiredValidator)(properties.transformResources)), errors.collect(cdk.propertyValidator("transformResources", CfnModelPackage_TransformResourcesPropertyValidator)(properties.transformResources)), errors.wrap('supplied properties not correct for "TransformJobDefinitionProperty"');
    }
    function cfnModelPackageTransformJobDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPackage_TransformJobDefinitionPropertyValidator(properties).assertSuccess(), { BatchStrategy: cdk.stringToCloudFormation(properties.batchStrategy), Environment: cdk.hashMapper(cdk.stringToCloudFormation)(properties.environment), MaxConcurrentTransforms: cdk.numberToCloudFormation(properties.maxConcurrentTransforms), MaxPayloadInMB: cdk.numberToCloudFormation(properties.maxPayloadInMb), TransformInput: cfnModelPackageTransformInputPropertyToCloudFormation(properties.transformInput), TransformOutput: cfnModelPackageTransformOutputPropertyToCloudFormation(properties.transformOutput), TransformResources: cfnModelPackageTransformResourcesPropertyToCloudFormation(properties.transformResources) }) : properties;
    }
    function CfnModelPackageTransformJobDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("batchStrategy", "BatchStrategy", properties.BatchStrategy != null ? cfn_parse.FromCloudFormation.getString(properties.BatchStrategy) : void 0), ret.addPropertyResult("environment", "Environment", properties.Environment != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Environment) : void 0), ret.addPropertyResult("maxConcurrentTransforms", "MaxConcurrentTransforms", properties.MaxConcurrentTransforms != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxConcurrentTransforms) : void 0), ret.addPropertyResult("maxPayloadInMb", "MaxPayloadInMB", properties.MaxPayloadInMB != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaxPayloadInMB) : void 0), ret.addPropertyResult("transformInput", "TransformInput", CfnModelPackageTransformInputPropertyFromCloudFormation(properties.TransformInput)), ret.addPropertyResult("transformOutput", "TransformOutput", CfnModelPackageTransformOutputPropertyFromCloudFormation(properties.TransformOutput)), ret.addPropertyResult("transformResources", "TransformResources", CfnModelPackageTransformResourcesPropertyFromCloudFormation(properties.TransformResources)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPackage_TransformOutputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accept", cdk.validateString)(properties.accept)), errors.collect(cdk.propertyValidator("assembleWith", cdk.validateString)(properties.assembleWith)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("s3OutputPath", cdk.requiredValidator)(properties.s3OutputPath)), errors.collect(cdk.propertyValidator("s3OutputPath", cdk.validateString)(properties.s3OutputPath)), errors.wrap('supplied properties not correct for "TransformOutputProperty"');
    }
    function cfnModelPackageTransformOutputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPackage_TransformOutputPropertyValidator(properties).assertSuccess(), { Accept: cdk.stringToCloudFormation(properties.accept), AssembleWith: cdk.stringToCloudFormation(properties.assembleWith), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), S3OutputPath: cdk.stringToCloudFormation(properties.s3OutputPath) }) : properties;
    }
    function CfnModelPackageTransformOutputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accept", "Accept", properties.Accept != null ? cfn_parse.FromCloudFormation.getString(properties.Accept) : void 0), ret.addPropertyResult("assembleWith", "AssembleWith", properties.AssembleWith != null ? cfn_parse.FromCloudFormation.getString(properties.AssembleWith) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("s3OutputPath", "S3OutputPath", cfn_parse.FromCloudFormation.getString(properties.S3OutputPath)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPackage_TransformResourcesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceCount", cdk.requiredValidator)(properties.instanceCount)), errors.collect(cdk.propertyValidator("instanceCount", cdk.validateNumber)(properties.instanceCount)), errors.collect(cdk.propertyValidator("instanceType", cdk.requiredValidator)(properties.instanceType)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("volumeKmsKeyId", cdk.validateString)(properties.volumeKmsKeyId)), errors.wrap('supplied properties not correct for "TransformResourcesProperty"');
    }
    function cfnModelPackageTransformResourcesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPackage_TransformResourcesPropertyValidator(properties).assertSuccess(), { InstanceCount: cdk.numberToCloudFormation(properties.instanceCount), InstanceType: cdk.stringToCloudFormation(properties.instanceType), VolumeKmsKeyId: cdk.stringToCloudFormation(properties.volumeKmsKeyId) }) : properties;
    }
    function CfnModelPackageTransformResourcesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceCount", "InstanceCount", cfn_parse.FromCloudFormation.getNumber(properties.InstanceCount)), ret.addPropertyResult("instanceType", "InstanceType", cfn_parse.FromCloudFormation.getString(properties.InstanceType)), ret.addPropertyResult("volumeKmsKeyId", "VolumeKmsKeyId", properties.VolumeKmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.VolumeKmsKeyId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPackage_UserContextPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("domainId", cdk.validateString)(properties.domainId)), errors.collect(cdk.propertyValidator("userProfileArn", cdk.validateString)(properties.userProfileArn)), errors.collect(cdk.propertyValidator("userProfileName", cdk.validateString)(properties.userProfileName)), errors.wrap('supplied properties not correct for "UserContextProperty"');
    }
    function cfnModelPackageUserContextPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPackage_UserContextPropertyValidator(properties).assertSuccess(), { DomainId: cdk.stringToCloudFormation(properties.domainId), UserProfileArn: cdk.stringToCloudFormation(properties.userProfileArn), UserProfileName: cdk.stringToCloudFormation(properties.userProfileName) }) : properties;
    }
    function CfnModelPackageUserContextPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("domainId", "DomainId", properties.DomainId != null ? cfn_parse.FromCloudFormation.getString(properties.DomainId) : void 0), ret.addPropertyResult("userProfileArn", "UserProfileArn", properties.UserProfileArn != null ? cfn_parse.FromCloudFormation.getString(properties.UserProfileArn) : void 0), ret.addPropertyResult("userProfileName", "UserProfileName", properties.UserProfileName != null ? cfn_parse.FromCloudFormation.getString(properties.UserProfileName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPackage_ValidationProfilePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("profileName", cdk.requiredValidator)(properties.profileName)), errors.collect(cdk.propertyValidator("profileName", cdk.validateString)(properties.profileName)), errors.collect(cdk.propertyValidator("transformJobDefinition", cdk.requiredValidator)(properties.transformJobDefinition)), errors.collect(cdk.propertyValidator("transformJobDefinition", CfnModelPackage_TransformJobDefinitionPropertyValidator)(properties.transformJobDefinition)), errors.wrap('supplied properties not correct for "ValidationProfileProperty"');
    }
    function cfnModelPackageValidationProfilePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPackage_ValidationProfilePropertyValidator(properties).assertSuccess(), { ProfileName: cdk.stringToCloudFormation(properties.profileName), TransformJobDefinition: cfnModelPackageTransformJobDefinitionPropertyToCloudFormation(properties.transformJobDefinition) }) : properties;
    }
    function CfnModelPackageValidationProfilePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("profileName", "ProfileName", cfn_parse.FromCloudFormation.getString(properties.ProfileName)), ret.addPropertyResult("transformJobDefinition", "TransformJobDefinition", CfnModelPackageTransformJobDefinitionPropertyFromCloudFormation(properties.TransformJobDefinition)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPackage_ValidationSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("validationProfiles", cdk.requiredValidator)(properties.validationProfiles)), errors.collect(cdk.propertyValidator("validationProfiles", cdk.listValidator(CfnModelPackage_ValidationProfilePropertyValidator))(properties.validationProfiles)), errors.collect(cdk.propertyValidator("validationRole", cdk.requiredValidator)(properties.validationRole)), errors.collect(cdk.propertyValidator("validationRole", cdk.validateString)(properties.validationRole)), errors.wrap('supplied properties not correct for "ValidationSpecificationProperty"');
    }
    function cfnModelPackageValidationSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPackage_ValidationSpecificationPropertyValidator(properties).assertSuccess(), { ValidationProfiles: cdk.listMapper(cfnModelPackageValidationProfilePropertyToCloudFormation)(properties.validationProfiles), ValidationRole: cdk.stringToCloudFormation(properties.validationRole) }) : properties;
    }
    function CfnModelPackageValidationSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("validationProfiles", "ValidationProfiles", cfn_parse.FromCloudFormation.getArray(CfnModelPackageValidationProfilePropertyFromCloudFormation)(properties.ValidationProfiles)), ret.addPropertyResult("validationRole", "ValidationRole", cfn_parse.FromCloudFormation.getString(properties.ValidationRole)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelPackageGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("modelPackageGroupDescription", cdk.validateString)(properties.modelPackageGroupDescription)), errors.collect(cdk.propertyValidator("modelPackageGroupName", cdk.requiredValidator)(properties.modelPackageGroupName)), errors.collect(cdk.propertyValidator("modelPackageGroupName", cdk.validateString)(properties.modelPackageGroupName)), errors.collect(cdk.propertyValidator("modelPackageGroupPolicy", cdk.validateObject)(properties.modelPackageGroupPolicy)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnModelPackageGroupProps"');
    }
    function cfnModelPackageGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelPackageGroupPropsValidator(properties).assertSuccess(), { ModelPackageGroupName: cdk.stringToCloudFormation(properties.modelPackageGroupName), ModelPackageGroupDescription: cdk.stringToCloudFormation(properties.modelPackageGroupDescription), ModelPackageGroupPolicy: cdk.objectToCloudFormation(properties.modelPackageGroupPolicy), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnModelPackageGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("modelPackageGroupName", "ModelPackageGroupName", cfn_parse.FromCloudFormation.getString(properties.ModelPackageGroupName)), ret.addPropertyResult("modelPackageGroupDescription", "ModelPackageGroupDescription", properties.ModelPackageGroupDescription != null ? cfn_parse.FromCloudFormation.getString(properties.ModelPackageGroupDescription) : void 0), ret.addPropertyResult("modelPackageGroupPolicy", "ModelPackageGroupPolicy", properties.ModelPackageGroupPolicy != null ? cfn_parse.FromCloudFormation.getAny(properties.ModelPackageGroupPolicy) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnModelPackageGroup = class _CfnModelPackageGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnModelPackageGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnModelPackageGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnModelPackageGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sagemaker_CfnModelPackageGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnModelPackageGroup), error;
        }
        cdk.requireProperty(props, "modelPackageGroupName", this), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrModelPackageGroupArn = cdk.Token.asString(this.getAtt("ModelPackageGroupArn", cdk.ResolutionTypeHint.STRING)), this.attrModelPackageGroupStatus = cdk.Token.asString(this.getAtt("ModelPackageGroupStatus", cdk.ResolutionTypeHint.STRING)), this.modelPackageGroupName = props.modelPackageGroupName, this.modelPackageGroupDescription = props.modelPackageGroupDescription, this.modelPackageGroupPolicy = props.modelPackageGroupPolicy, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SageMaker::ModelPackageGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnModelPackageGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { modelPackageGroupName: this.modelPackageGroupName, modelPackageGroupDescription: this.modelPackageGroupDescription, modelPackageGroupPolicy: this.modelPackageGroupPolicy, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnModelPackageGroupPropsToCloudFormation(props);
      }
    };
    _u = JSII_RTTI_SYMBOL_1, CfnModelPackageGroup[_u] = { fqn: "aws-cdk-lib.aws_sagemaker.CfnModelPackageGroup", version: "2.80.0" }, CfnModelPackageGroup.CFN_RESOURCE_TYPE_NAME = "AWS::SageMaker::ModelPackageGroup", exports2.CfnModelPackageGroup = CfnModelPackageGroup;
    function CfnModelQualityJobDefinitionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endpointName", cdk.validateString)(properties.endpointName)), errors.collect(cdk.propertyValidator("jobDefinitionName", cdk.validateString)(properties.jobDefinitionName)), errors.collect(cdk.propertyValidator("jobResources", cdk.requiredValidator)(properties.jobResources)), errors.collect(cdk.propertyValidator("jobResources", CfnModelQualityJobDefinition_MonitoringResourcesPropertyValidator)(properties.jobResources)), errors.collect(cdk.propertyValidator("modelQualityAppSpecification", cdk.requiredValidator)(properties.modelQualityAppSpecification)), errors.collect(cdk.propertyValidator("modelQualityAppSpecification", CfnModelQualityJobDefinition_ModelQualityAppSpecificationPropertyValidator)(properties.modelQualityAppSpecification)), errors.collect(cdk.propertyValidator("modelQualityBaselineConfig", CfnModelQualityJobDefinition_ModelQualityBaselineConfigPropertyValidator)(properties.modelQualityBaselineConfig)), errors.collect(cdk.propertyValidator("modelQualityJobInput", cdk.requiredValidator)(properties.modelQualityJobInput)), errors.collect(cdk.propertyValidator("modelQualityJobInput", CfnModelQualityJobDefinition_ModelQualityJobInputPropertyValidator)(properties.modelQualityJobInput)), errors.collect(cdk.propertyValidator("modelQualityJobOutputConfig", cdk.requiredValidator)(properties.modelQualityJobOutputConfig)), errors.collect(cdk.propertyValidator("modelQualityJobOutputConfig", CfnModelQualityJobDefinition_MonitoringOutputConfigPropertyValidator)(properties.modelQualityJobOutputConfig)), errors.collect(cdk.propertyValidator("networkConfig", CfnModelQualityJobDefinition_NetworkConfigPropertyValidator)(properties.networkConfig)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("stoppingCondition", CfnModelQualityJobDefinition_StoppingConditionPropertyValidator)(properties.stoppingCondition)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnModelQualityJobDefinitionProps"');
    }
    function cfnModelQualityJobDefinitionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelQualityJobDefinitionPropsValidator(properties).assertSuccess(), { JobResources: cfnModelQualityJobDefinitionMonitoringResourcesPropertyToCloudFormation(properties.jobResources), ModelQualityAppSpecification: cfnModelQualityJobDefinitionModelQualityAppSpecificationPropertyToCloudFormation(properties.modelQualityAppSpecification), ModelQualityJobInput: cfnModelQualityJobDefinitionModelQualityJobInputPropertyToCloudFormation(properties.modelQualityJobInput), ModelQualityJobOutputConfig: cfnModelQualityJobDefinitionMonitoringOutputConfigPropertyToCloudFormation(properties.modelQualityJobOutputConfig), RoleArn: cdk.stringToCloudFormation(properties.roleArn), EndpointName: cdk.stringToCloudFormation(properties.endpointName), JobDefinitionName: cdk.stringToCloudFormation(properties.jobDefinitionName), ModelQualityBaselineConfig: cfnModelQualityJobDefinitionModelQualityBaselineConfigPropertyToCloudFormation(properties.modelQualityBaselineConfig), NetworkConfig: cfnModelQualityJobDefinitionNetworkConfigPropertyToCloudFormation(properties.networkConfig), StoppingCondition: cfnModelQualityJobDefinitionStoppingConditionPropertyToCloudFormation(properties.stoppingCondition), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnModelQualityJobDefinitionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("jobResources", "JobResources", CfnModelQualityJobDefinitionMonitoringResourcesPropertyFromCloudFormation(properties.JobResources)), ret.addPropertyResult("modelQualityAppSpecification", "ModelQualityAppSpecification", CfnModelQualityJobDefinitionModelQualityAppSpecificationPropertyFromCloudFormation(properties.ModelQualityAppSpecification)), ret.addPropertyResult("modelQualityJobInput", "ModelQualityJobInput", CfnModelQualityJobDefinitionModelQualityJobInputPropertyFromCloudFormation(properties.ModelQualityJobInput)), ret.addPropertyResult("modelQualityJobOutputConfig", "ModelQualityJobOutputConfig", CfnModelQualityJobDefinitionMonitoringOutputConfigPropertyFromCloudFormation(properties.ModelQualityJobOutputConfig)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("endpointName", "EndpointName", properties.EndpointName != null ? cfn_parse.FromCloudFormation.getString(properties.EndpointName) : void 0), ret.addPropertyResult("jobDefinitionName", "JobDefinitionName", properties.JobDefinitionName != null ? cfn_parse.FromCloudFormation.getString(properties.JobDefinitionName) : void 0), ret.addPropertyResult("modelQualityBaselineConfig", "ModelQualityBaselineConfig", properties.ModelQualityBaselineConfig != null ? CfnModelQualityJobDefinitionModelQualityBaselineConfigPropertyFromCloudFormation(properties.ModelQualityBaselineConfig) : void 0), ret.addPropertyResult("networkConfig", "NetworkConfig", properties.NetworkConfig != null ? CfnModelQualityJobDefinitionNetworkConfigPropertyFromCloudFormation(properties.NetworkConfig) : void 0), ret.addPropertyResult("stoppingCondition", "StoppingCondition", properties.StoppingCondition != null ? CfnModelQualityJobDefinitionStoppingConditionPropertyFromCloudFormation(properties.StoppingCondition) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnModelQualityJobDefinition = class _CfnModelQualityJobDefinition extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnModelQualityJobDefinitionPropsFromCloudFormation(resourceProperties), ret = new _CfnModelQualityJobDefinition(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnModelQualityJobDefinition.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sagemaker_CfnModelQualityJobDefinitionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnModelQualityJobDefinition), error;
        }
        cdk.requireProperty(props, "jobResources", this), cdk.requireProperty(props, "modelQualityAppSpecification", this), cdk.requireProperty(props, "modelQualityJobInput", this), cdk.requireProperty(props, "modelQualityJobOutputConfig", this), cdk.requireProperty(props, "roleArn", this), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrJobDefinitionArn = cdk.Token.asString(this.getAtt("JobDefinitionArn", cdk.ResolutionTypeHint.STRING)), this.jobResources = props.jobResources, this.modelQualityAppSpecification = props.modelQualityAppSpecification, this.modelQualityJobInput = props.modelQualityJobInput, this.modelQualityJobOutputConfig = props.modelQualityJobOutputConfig, this.roleArn = props.roleArn, this.endpointName = props.endpointName, this.jobDefinitionName = props.jobDefinitionName, this.modelQualityBaselineConfig = props.modelQualityBaselineConfig, this.networkConfig = props.networkConfig, this.stoppingCondition = props.stoppingCondition, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SageMaker::ModelQualityJobDefinition", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnModelQualityJobDefinition.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { jobResources: this.jobResources, modelQualityAppSpecification: this.modelQualityAppSpecification, modelQualityJobInput: this.modelQualityJobInput, modelQualityJobOutputConfig: this.modelQualityJobOutputConfig, roleArn: this.roleArn, endpointName: this.endpointName, jobDefinitionName: this.jobDefinitionName, modelQualityBaselineConfig: this.modelQualityBaselineConfig, networkConfig: this.networkConfig, stoppingCondition: this.stoppingCondition, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnModelQualityJobDefinitionPropsToCloudFormation(props);
      }
    };
    _v = JSII_RTTI_SYMBOL_1, CfnModelQualityJobDefinition[_v] = { fqn: "aws-cdk-lib.aws_sagemaker.CfnModelQualityJobDefinition", version: "2.80.0" }, CfnModelQualityJobDefinition.CFN_RESOURCE_TYPE_NAME = "AWS::SageMaker::ModelQualityJobDefinition", exports2.CfnModelQualityJobDefinition = CfnModelQualityJobDefinition;
    function CfnModelQualityJobDefinition_BatchTransformInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataCapturedDestinationS3Uri", cdk.requiredValidator)(properties.dataCapturedDestinationS3Uri)), errors.collect(cdk.propertyValidator("dataCapturedDestinationS3Uri", cdk.validateString)(properties.dataCapturedDestinationS3Uri)), errors.collect(cdk.propertyValidator("datasetFormat", cdk.requiredValidator)(properties.datasetFormat)), errors.collect(cdk.propertyValidator("datasetFormat", CfnModelQualityJobDefinition_DatasetFormatPropertyValidator)(properties.datasetFormat)), errors.collect(cdk.propertyValidator("endTimeOffset", cdk.validateString)(properties.endTimeOffset)), errors.collect(cdk.propertyValidator("inferenceAttribute", cdk.validateString)(properties.inferenceAttribute)), errors.collect(cdk.propertyValidator("localPath", cdk.requiredValidator)(properties.localPath)), errors.collect(cdk.propertyValidator("localPath", cdk.validateString)(properties.localPath)), errors.collect(cdk.propertyValidator("probabilityAttribute", cdk.validateString)(properties.probabilityAttribute)), errors.collect(cdk.propertyValidator("probabilityThresholdAttribute", cdk.validateNumber)(properties.probabilityThresholdAttribute)), errors.collect(cdk.propertyValidator("s3DataDistributionType", cdk.validateString)(properties.s3DataDistributionType)), errors.collect(cdk.propertyValidator("s3InputMode", cdk.validateString)(properties.s3InputMode)), errors.collect(cdk.propertyValidator("startTimeOffset", cdk.validateString)(properties.startTimeOffset)), errors.wrap('supplied properties not correct for "BatchTransformInputProperty"');
    }
    function cfnModelQualityJobDefinitionBatchTransformInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelQualityJobDefinition_BatchTransformInputPropertyValidator(properties).assertSuccess(), { DataCapturedDestinationS3Uri: cdk.stringToCloudFormation(properties.dataCapturedDestinationS3Uri), DatasetFormat: cfnModelQualityJobDefinitionDatasetFormatPropertyToCloudFormation(properties.datasetFormat), EndTimeOffset: cdk.stringToCloudFormation(properties.endTimeOffset), InferenceAttribute: cdk.stringToCloudFormation(properties.inferenceAttribute), LocalPath: cdk.stringToCloudFormation(properties.localPath), ProbabilityAttribute: cdk.stringToCloudFormation(properties.probabilityAttribute), ProbabilityThresholdAttribute: cdk.numberToCloudFormation(properties.probabilityThresholdAttribute), S3DataDistributionType: cdk.stringToCloudFormation(properties.s3DataDistributionType), S3InputMode: cdk.stringToCloudFormation(properties.s3InputMode), StartTimeOffset: cdk.stringToCloudFormation(properties.startTimeOffset) }) : properties;
    }
    function CfnModelQualityJobDefinitionBatchTransformInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataCapturedDestinationS3Uri", "DataCapturedDestinationS3Uri", cfn_parse.FromCloudFormation.getString(properties.DataCapturedDestinationS3Uri)), ret.addPropertyResult("datasetFormat", "DatasetFormat", CfnModelQualityJobDefinitionDatasetFormatPropertyFromCloudFormation(properties.DatasetFormat)), ret.addPropertyResult("endTimeOffset", "EndTimeOffset", properties.EndTimeOffset != null ? cfn_parse.FromCloudFormation.getString(properties.EndTimeOffset) : void 0), ret.addPropertyResult("inferenceAttribute", "InferenceAttribute", properties.InferenceAttribute != null ? cfn_parse.FromCloudFormation.getString(properties.InferenceAttribute) : void 0), ret.addPropertyResult("localPath", "LocalPath", cfn_parse.FromCloudFormation.getString(properties.LocalPath)), ret.addPropertyResult("probabilityAttribute", "ProbabilityAttribute", properties.ProbabilityAttribute != null ? cfn_parse.FromCloudFormation.getString(properties.ProbabilityAttribute) : void 0), ret.addPropertyResult("probabilityThresholdAttribute", "ProbabilityThresholdAttribute", properties.ProbabilityThresholdAttribute != null ? cfn_parse.FromCloudFormation.getNumber(properties.ProbabilityThresholdAttribute) : void 0), ret.addPropertyResult("s3DataDistributionType", "S3DataDistributionType", properties.S3DataDistributionType != null ? cfn_parse.FromCloudFormation.getString(properties.S3DataDistributionType) : void 0), ret.addPropertyResult("s3InputMode", "S3InputMode", properties.S3InputMode != null ? cfn_parse.FromCloudFormation.getString(properties.S3InputMode) : void 0), ret.addPropertyResult("startTimeOffset", "StartTimeOffset", properties.StartTimeOffset != null ? cfn_parse.FromCloudFormation.getString(properties.StartTimeOffset) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelQualityJobDefinition_ClusterConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceCount", cdk.requiredValidator)(properties.instanceCount)), errors.collect(cdk.propertyValidator("instanceCount", cdk.validateNumber)(properties.instanceCount)), errors.collect(cdk.propertyValidator("instanceType", cdk.requiredValidator)(properties.instanceType)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("volumeKmsKeyId", cdk.validateString)(properties.volumeKmsKeyId)), errors.collect(cdk.propertyValidator("volumeSizeInGb", cdk.requiredValidator)(properties.volumeSizeInGb)), errors.collect(cdk.propertyValidator("volumeSizeInGb", cdk.validateNumber)(properties.volumeSizeInGb)), errors.wrap('supplied properties not correct for "ClusterConfigProperty"');
    }
    function cfnModelQualityJobDefinitionClusterConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelQualityJobDefinition_ClusterConfigPropertyValidator(properties).assertSuccess(), { InstanceCount: cdk.numberToCloudFormation(properties.instanceCount), InstanceType: cdk.stringToCloudFormation(properties.instanceType), VolumeKmsKeyId: cdk.stringToCloudFormation(properties.volumeKmsKeyId), VolumeSizeInGB: cdk.numberToCloudFormation(properties.volumeSizeInGb) }) : properties;
    }
    function CfnModelQualityJobDefinitionClusterConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceCount", "InstanceCount", cfn_parse.FromCloudFormation.getNumber(properties.InstanceCount)), ret.addPropertyResult("instanceType", "InstanceType", cfn_parse.FromCloudFormation.getString(properties.InstanceType)), ret.addPropertyResult("volumeKmsKeyId", "VolumeKmsKeyId", properties.VolumeKmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.VolumeKmsKeyId) : void 0), ret.addPropertyResult("volumeSizeInGb", "VolumeSizeInGB", cfn_parse.FromCloudFormation.getNumber(properties.VolumeSizeInGB)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelQualityJobDefinition_ConstraintsResourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3Uri", cdk.validateString)(properties.s3Uri)), errors.wrap('supplied properties not correct for "ConstraintsResourceProperty"');
    }
    function cfnModelQualityJobDefinitionConstraintsResourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelQualityJobDefinition_ConstraintsResourcePropertyValidator(properties).assertSuccess(), { S3Uri: cdk.stringToCloudFormation(properties.s3Uri) }) : properties;
    }
    function CfnModelQualityJobDefinitionConstraintsResourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Uri", "S3Uri", properties.S3Uri != null ? cfn_parse.FromCloudFormation.getString(properties.S3Uri) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelQualityJobDefinition_CsvPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("header", cdk.validateBoolean)(properties.header)), errors.wrap('supplied properties not correct for "CsvProperty"');
    }
    function cfnModelQualityJobDefinitionCsvPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelQualityJobDefinition_CsvPropertyValidator(properties).assertSuccess(), { Header: cdk.booleanToCloudFormation(properties.header) }) : properties;
    }
    function CfnModelQualityJobDefinitionCsvPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("header", "Header", properties.Header != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Header) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelQualityJobDefinition_DatasetFormatPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("csv", CfnModelQualityJobDefinition_CsvPropertyValidator)(properties.csv)), errors.collect(cdk.propertyValidator("json", CfnModelQualityJobDefinition_JsonPropertyValidator)(properties.json)), errors.collect(cdk.propertyValidator("parquet", cdk.validateBoolean)(properties.parquet)), errors.wrap('supplied properties not correct for "DatasetFormatProperty"');
    }
    function cfnModelQualityJobDefinitionDatasetFormatPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelQualityJobDefinition_DatasetFormatPropertyValidator(properties).assertSuccess(), { Csv: cfnModelQualityJobDefinitionCsvPropertyToCloudFormation(properties.csv), Json: cfnModelQualityJobDefinitionJsonPropertyToCloudFormation(properties.json), Parquet: cdk.booleanToCloudFormation(properties.parquet) }) : properties;
    }
    function CfnModelQualityJobDefinitionDatasetFormatPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("csv", "Csv", properties.Csv != null ? CfnModelQualityJobDefinitionCsvPropertyFromCloudFormation(properties.Csv) : void 0), ret.addPropertyResult("json", "Json", properties.Json != null ? CfnModelQualityJobDefinitionJsonPropertyFromCloudFormation(properties.Json) : void 0), ret.addPropertyResult("parquet", "Parquet", properties.Parquet != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Parquet) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelQualityJobDefinition_EndpointInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endTimeOffset", cdk.validateString)(properties.endTimeOffset)), errors.collect(cdk.propertyValidator("endpointName", cdk.requiredValidator)(properties.endpointName)), errors.collect(cdk.propertyValidator("endpointName", cdk.validateString)(properties.endpointName)), errors.collect(cdk.propertyValidator("inferenceAttribute", cdk.validateString)(properties.inferenceAttribute)), errors.collect(cdk.propertyValidator("localPath", cdk.requiredValidator)(properties.localPath)), errors.collect(cdk.propertyValidator("localPath", cdk.validateString)(properties.localPath)), errors.collect(cdk.propertyValidator("probabilityAttribute", cdk.validateString)(properties.probabilityAttribute)), errors.collect(cdk.propertyValidator("probabilityThresholdAttribute", cdk.validateNumber)(properties.probabilityThresholdAttribute)), errors.collect(cdk.propertyValidator("s3DataDistributionType", cdk.validateString)(properties.s3DataDistributionType)), errors.collect(cdk.propertyValidator("s3InputMode", cdk.validateString)(properties.s3InputMode)), errors.collect(cdk.propertyValidator("startTimeOffset", cdk.validateString)(properties.startTimeOffset)), errors.wrap('supplied properties not correct for "EndpointInputProperty"');
    }
    function cfnModelQualityJobDefinitionEndpointInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelQualityJobDefinition_EndpointInputPropertyValidator(properties).assertSuccess(), { EndTimeOffset: cdk.stringToCloudFormation(properties.endTimeOffset), EndpointName: cdk.stringToCloudFormation(properties.endpointName), InferenceAttribute: cdk.stringToCloudFormation(properties.inferenceAttribute), LocalPath: cdk.stringToCloudFormation(properties.localPath), ProbabilityAttribute: cdk.stringToCloudFormation(properties.probabilityAttribute), ProbabilityThresholdAttribute: cdk.numberToCloudFormation(properties.probabilityThresholdAttribute), S3DataDistributionType: cdk.stringToCloudFormation(properties.s3DataDistributionType), S3InputMode: cdk.stringToCloudFormation(properties.s3InputMode), StartTimeOffset: cdk.stringToCloudFormation(properties.startTimeOffset) }) : properties;
    }
    function CfnModelQualityJobDefinitionEndpointInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endTimeOffset", "EndTimeOffset", properties.EndTimeOffset != null ? cfn_parse.FromCloudFormation.getString(properties.EndTimeOffset) : void 0), ret.addPropertyResult("endpointName", "EndpointName", cfn_parse.FromCloudFormation.getString(properties.EndpointName)), ret.addPropertyResult("inferenceAttribute", "InferenceAttribute", properties.InferenceAttribute != null ? cfn_parse.FromCloudFormation.getString(properties.InferenceAttribute) : void 0), ret.addPropertyResult("localPath", "LocalPath", cfn_parse.FromCloudFormation.getString(properties.LocalPath)), ret.addPropertyResult("probabilityAttribute", "ProbabilityAttribute", properties.ProbabilityAttribute != null ? cfn_parse.FromCloudFormation.getString(properties.ProbabilityAttribute) : void 0), ret.addPropertyResult("probabilityThresholdAttribute", "ProbabilityThresholdAttribute", properties.ProbabilityThresholdAttribute != null ? cfn_parse.FromCloudFormation.getNumber(properties.ProbabilityThresholdAttribute) : void 0), ret.addPropertyResult("s3DataDistributionType", "S3DataDistributionType", properties.S3DataDistributionType != null ? cfn_parse.FromCloudFormation.getString(properties.S3DataDistributionType) : void 0), ret.addPropertyResult("s3InputMode", "S3InputMode", properties.S3InputMode != null ? cfn_parse.FromCloudFormation.getString(properties.S3InputMode) : void 0), ret.addPropertyResult("startTimeOffset", "StartTimeOffset", properties.StartTimeOffset != null ? cfn_parse.FromCloudFormation.getString(properties.StartTimeOffset) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelQualityJobDefinition_JsonPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("line", cdk.validateBoolean)(properties.line)), errors.wrap('supplied properties not correct for "JsonProperty"');
    }
    function cfnModelQualityJobDefinitionJsonPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelQualityJobDefinition_JsonPropertyValidator(properties).assertSuccess(), { Line: cdk.booleanToCloudFormation(properties.line) }) : properties;
    }
    function CfnModelQualityJobDefinitionJsonPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("line", "Line", properties.Line != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Line) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelQualityJobDefinition_ModelQualityAppSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containerArguments", cdk.listValidator(cdk.validateString))(properties.containerArguments)), errors.collect(cdk.propertyValidator("containerEntrypoint", cdk.listValidator(cdk.validateString))(properties.containerEntrypoint)), errors.collect(cdk.propertyValidator("environment", cdk.hashValidator(cdk.validateString))(properties.environment)), errors.collect(cdk.propertyValidator("imageUri", cdk.requiredValidator)(properties.imageUri)), errors.collect(cdk.propertyValidator("imageUri", cdk.validateString)(properties.imageUri)), errors.collect(cdk.propertyValidator("postAnalyticsProcessorSourceUri", cdk.validateString)(properties.postAnalyticsProcessorSourceUri)), errors.collect(cdk.propertyValidator("problemType", cdk.requiredValidator)(properties.problemType)), errors.collect(cdk.propertyValidator("problemType", cdk.validateString)(properties.problemType)), errors.collect(cdk.propertyValidator("recordPreprocessorSourceUri", cdk.validateString)(properties.recordPreprocessorSourceUri)), errors.wrap('supplied properties not correct for "ModelQualityAppSpecificationProperty"');
    }
    function cfnModelQualityJobDefinitionModelQualityAppSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelQualityJobDefinition_ModelQualityAppSpecificationPropertyValidator(properties).assertSuccess(), { ContainerArguments: cdk.listMapper(cdk.stringToCloudFormation)(properties.containerArguments), ContainerEntrypoint: cdk.listMapper(cdk.stringToCloudFormation)(properties.containerEntrypoint), Environment: cdk.hashMapper(cdk.stringToCloudFormation)(properties.environment), ImageUri: cdk.stringToCloudFormation(properties.imageUri), PostAnalyticsProcessorSourceUri: cdk.stringToCloudFormation(properties.postAnalyticsProcessorSourceUri), ProblemType: cdk.stringToCloudFormation(properties.problemType), RecordPreprocessorSourceUri: cdk.stringToCloudFormation(properties.recordPreprocessorSourceUri) }) : properties;
    }
    function CfnModelQualityJobDefinitionModelQualityAppSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containerArguments", "ContainerArguments", properties.ContainerArguments != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ContainerArguments) : void 0), ret.addPropertyResult("containerEntrypoint", "ContainerEntrypoint", properties.ContainerEntrypoint != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ContainerEntrypoint) : void 0), ret.addPropertyResult("environment", "Environment", properties.Environment != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Environment) : void 0), ret.addPropertyResult("imageUri", "ImageUri", cfn_parse.FromCloudFormation.getString(properties.ImageUri)), ret.addPropertyResult("postAnalyticsProcessorSourceUri", "PostAnalyticsProcessorSourceUri", properties.PostAnalyticsProcessorSourceUri != null ? cfn_parse.FromCloudFormation.getString(properties.PostAnalyticsProcessorSourceUri) : void 0), ret.addPropertyResult("problemType", "ProblemType", cfn_parse.FromCloudFormation.getString(properties.ProblemType)), ret.addPropertyResult("recordPreprocessorSourceUri", "RecordPreprocessorSourceUri", properties.RecordPreprocessorSourceUri != null ? cfn_parse.FromCloudFormation.getString(properties.RecordPreprocessorSourceUri) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelQualityJobDefinition_ModelQualityBaselineConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("baseliningJobName", cdk.validateString)(properties.baseliningJobName)), errors.collect(cdk.propertyValidator("constraintsResource", CfnModelQualityJobDefinition_ConstraintsResourcePropertyValidator)(properties.constraintsResource)), errors.wrap('supplied properties not correct for "ModelQualityBaselineConfigProperty"');
    }
    function cfnModelQualityJobDefinitionModelQualityBaselineConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelQualityJobDefinition_ModelQualityBaselineConfigPropertyValidator(properties).assertSuccess(), { BaseliningJobName: cdk.stringToCloudFormation(properties.baseliningJobName), ConstraintsResource: cfnModelQualityJobDefinitionConstraintsResourcePropertyToCloudFormation(properties.constraintsResource) }) : properties;
    }
    function CfnModelQualityJobDefinitionModelQualityBaselineConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("baseliningJobName", "BaseliningJobName", properties.BaseliningJobName != null ? cfn_parse.FromCloudFormation.getString(properties.BaseliningJobName) : void 0), ret.addPropertyResult("constraintsResource", "ConstraintsResource", properties.ConstraintsResource != null ? CfnModelQualityJobDefinitionConstraintsResourcePropertyFromCloudFormation(properties.ConstraintsResource) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelQualityJobDefinition_ModelQualityJobInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("batchTransformInput", CfnModelQualityJobDefinition_BatchTransformInputPropertyValidator)(properties.batchTransformInput)), errors.collect(cdk.propertyValidator("endpointInput", CfnModelQualityJobDefinition_EndpointInputPropertyValidator)(properties.endpointInput)), errors.collect(cdk.propertyValidator("groundTruthS3Input", cdk.requiredValidator)(properties.groundTruthS3Input)), errors.collect(cdk.propertyValidator("groundTruthS3Input", CfnModelQualityJobDefinition_MonitoringGroundTruthS3InputPropertyValidator)(properties.groundTruthS3Input)), errors.wrap('supplied properties not correct for "ModelQualityJobInputProperty"');
    }
    function cfnModelQualityJobDefinitionModelQualityJobInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelQualityJobDefinition_ModelQualityJobInputPropertyValidator(properties).assertSuccess(), { BatchTransformInput: cfnModelQualityJobDefinitionBatchTransformInputPropertyToCloudFormation(properties.batchTransformInput), EndpointInput: cfnModelQualityJobDefinitionEndpointInputPropertyToCloudFormation(properties.endpointInput), GroundTruthS3Input: cfnModelQualityJobDefinitionMonitoringGroundTruthS3InputPropertyToCloudFormation(properties.groundTruthS3Input) }) : properties;
    }
    function CfnModelQualityJobDefinitionModelQualityJobInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("batchTransformInput", "BatchTransformInput", properties.BatchTransformInput != null ? CfnModelQualityJobDefinitionBatchTransformInputPropertyFromCloudFormation(properties.BatchTransformInput) : void 0), ret.addPropertyResult("endpointInput", "EndpointInput", properties.EndpointInput != null ? CfnModelQualityJobDefinitionEndpointInputPropertyFromCloudFormation(properties.EndpointInput) : void 0), ret.addPropertyResult("groundTruthS3Input", "GroundTruthS3Input", CfnModelQualityJobDefinitionMonitoringGroundTruthS3InputPropertyFromCloudFormation(properties.GroundTruthS3Input)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelQualityJobDefinition_MonitoringGroundTruthS3InputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3Uri", cdk.requiredValidator)(properties.s3Uri)), errors.collect(cdk.propertyValidator("s3Uri", cdk.validateString)(properties.s3Uri)), errors.wrap('supplied properties not correct for "MonitoringGroundTruthS3InputProperty"');
    }
    function cfnModelQualityJobDefinitionMonitoringGroundTruthS3InputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelQualityJobDefinition_MonitoringGroundTruthS3InputPropertyValidator(properties).assertSuccess(), { S3Uri: cdk.stringToCloudFormation(properties.s3Uri) }) : properties;
    }
    function CfnModelQualityJobDefinitionMonitoringGroundTruthS3InputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Uri", "S3Uri", cfn_parse.FromCloudFormation.getString(properties.S3Uri)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelQualityJobDefinition_MonitoringOutputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3Output", cdk.requiredValidator)(properties.s3Output)), errors.collect(cdk.propertyValidator("s3Output", CfnModelQualityJobDefinition_S3OutputPropertyValidator)(properties.s3Output)), errors.wrap('supplied properties not correct for "MonitoringOutputProperty"');
    }
    function cfnModelQualityJobDefinitionMonitoringOutputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelQualityJobDefinition_MonitoringOutputPropertyValidator(properties).assertSuccess(), { S3Output: cfnModelQualityJobDefinitionS3OutputPropertyToCloudFormation(properties.s3Output) }) : properties;
    }
    function CfnModelQualityJobDefinitionMonitoringOutputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Output", "S3Output", CfnModelQualityJobDefinitionS3OutputPropertyFromCloudFormation(properties.S3Output)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelQualityJobDefinition_MonitoringOutputConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("monitoringOutputs", cdk.requiredValidator)(properties.monitoringOutputs)), errors.collect(cdk.propertyValidator("monitoringOutputs", cdk.listValidator(CfnModelQualityJobDefinition_MonitoringOutputPropertyValidator))(properties.monitoringOutputs)), errors.wrap('supplied properties not correct for "MonitoringOutputConfigProperty"');
    }
    function cfnModelQualityJobDefinitionMonitoringOutputConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelQualityJobDefinition_MonitoringOutputConfigPropertyValidator(properties).assertSuccess(), { KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), MonitoringOutputs: cdk.listMapper(cfnModelQualityJobDefinitionMonitoringOutputPropertyToCloudFormation)(properties.monitoringOutputs) }) : properties;
    }
    function CfnModelQualityJobDefinitionMonitoringOutputConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("monitoringOutputs", "MonitoringOutputs", cfn_parse.FromCloudFormation.getArray(CfnModelQualityJobDefinitionMonitoringOutputPropertyFromCloudFormation)(properties.MonitoringOutputs)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelQualityJobDefinition_MonitoringResourcesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clusterConfig", cdk.requiredValidator)(properties.clusterConfig)), errors.collect(cdk.propertyValidator("clusterConfig", CfnModelQualityJobDefinition_ClusterConfigPropertyValidator)(properties.clusterConfig)), errors.wrap('supplied properties not correct for "MonitoringResourcesProperty"');
    }
    function cfnModelQualityJobDefinitionMonitoringResourcesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelQualityJobDefinition_MonitoringResourcesPropertyValidator(properties).assertSuccess(), { ClusterConfig: cfnModelQualityJobDefinitionClusterConfigPropertyToCloudFormation(properties.clusterConfig) }) : properties;
    }
    function CfnModelQualityJobDefinitionMonitoringResourcesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clusterConfig", "ClusterConfig", CfnModelQualityJobDefinitionClusterConfigPropertyFromCloudFormation(properties.ClusterConfig)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelQualityJobDefinition_NetworkConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enableInterContainerTrafficEncryption", cdk.validateBoolean)(properties.enableInterContainerTrafficEncryption)), errors.collect(cdk.propertyValidator("enableNetworkIsolation", cdk.validateBoolean)(properties.enableNetworkIsolation)), errors.collect(cdk.propertyValidator("vpcConfig", CfnModelQualityJobDefinition_VpcConfigPropertyValidator)(properties.vpcConfig)), errors.wrap('supplied properties not correct for "NetworkConfigProperty"');
    }
    function cfnModelQualityJobDefinitionNetworkConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelQualityJobDefinition_NetworkConfigPropertyValidator(properties).assertSuccess(), { EnableInterContainerTrafficEncryption: cdk.booleanToCloudFormation(properties.enableInterContainerTrafficEncryption), EnableNetworkIsolation: cdk.booleanToCloudFormation(properties.enableNetworkIsolation), VpcConfig: cfnModelQualityJobDefinitionVpcConfigPropertyToCloudFormation(properties.vpcConfig) }) : properties;
    }
    function CfnModelQualityJobDefinitionNetworkConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enableInterContainerTrafficEncryption", "EnableInterContainerTrafficEncryption", properties.EnableInterContainerTrafficEncryption != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableInterContainerTrafficEncryption) : void 0), ret.addPropertyResult("enableNetworkIsolation", "EnableNetworkIsolation", properties.EnableNetworkIsolation != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableNetworkIsolation) : void 0), ret.addPropertyResult("vpcConfig", "VpcConfig", properties.VpcConfig != null ? CfnModelQualityJobDefinitionVpcConfigPropertyFromCloudFormation(properties.VpcConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelQualityJobDefinition_S3OutputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("localPath", cdk.requiredValidator)(properties.localPath)), errors.collect(cdk.propertyValidator("localPath", cdk.validateString)(properties.localPath)), errors.collect(cdk.propertyValidator("s3UploadMode", cdk.validateString)(properties.s3UploadMode)), errors.collect(cdk.propertyValidator("s3Uri", cdk.requiredValidator)(properties.s3Uri)), errors.collect(cdk.propertyValidator("s3Uri", cdk.validateString)(properties.s3Uri)), errors.wrap('supplied properties not correct for "S3OutputProperty"');
    }
    function cfnModelQualityJobDefinitionS3OutputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelQualityJobDefinition_S3OutputPropertyValidator(properties).assertSuccess(), { LocalPath: cdk.stringToCloudFormation(properties.localPath), S3UploadMode: cdk.stringToCloudFormation(properties.s3UploadMode), S3Uri: cdk.stringToCloudFormation(properties.s3Uri) }) : properties;
    }
    function CfnModelQualityJobDefinitionS3OutputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("localPath", "LocalPath", cfn_parse.FromCloudFormation.getString(properties.LocalPath)), ret.addPropertyResult("s3UploadMode", "S3UploadMode", properties.S3UploadMode != null ? cfn_parse.FromCloudFormation.getString(properties.S3UploadMode) : void 0), ret.addPropertyResult("s3Uri", "S3Uri", cfn_parse.FromCloudFormation.getString(properties.S3Uri)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelQualityJobDefinition_StoppingConditionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxRuntimeInSeconds", cdk.requiredValidator)(properties.maxRuntimeInSeconds)), errors.collect(cdk.propertyValidator("maxRuntimeInSeconds", cdk.validateNumber)(properties.maxRuntimeInSeconds)), errors.wrap('supplied properties not correct for "StoppingConditionProperty"');
    }
    function cfnModelQualityJobDefinitionStoppingConditionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelQualityJobDefinition_StoppingConditionPropertyValidator(properties).assertSuccess(), { MaxRuntimeInSeconds: cdk.numberToCloudFormation(properties.maxRuntimeInSeconds) }) : properties;
    }
    function CfnModelQualityJobDefinitionStoppingConditionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxRuntimeInSeconds", "MaxRuntimeInSeconds", cfn_parse.FromCloudFormation.getNumber(properties.MaxRuntimeInSeconds)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnModelQualityJobDefinition_VpcConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.requiredValidator)(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnets", cdk.requiredValidator)(properties.subnets)), errors.collect(cdk.propertyValidator("subnets", cdk.listValidator(cdk.validateString))(properties.subnets)), errors.wrap('supplied properties not correct for "VpcConfigProperty"');
    }
    function cfnModelQualityJobDefinitionVpcConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnModelQualityJobDefinition_VpcConfigPropertyValidator(properties).assertSuccess(), { SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), Subnets: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnets) }) : properties;
    }
    function CfnModelQualityJobDefinitionVpcConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds)), ret.addPropertyResult("subnets", "Subnets", cfn_parse.FromCloudFormation.getStringArray(properties.Subnets)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMonitoringSchedulePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endpointName", cdk.validateString)(properties.endpointName)), errors.collect(cdk.propertyValidator("failureReason", cdk.validateString)(properties.failureReason)), errors.collect(cdk.propertyValidator("lastMonitoringExecutionSummary", CfnMonitoringSchedule_MonitoringExecutionSummaryPropertyValidator)(properties.lastMonitoringExecutionSummary)), errors.collect(cdk.propertyValidator("monitoringScheduleConfig", cdk.requiredValidator)(properties.monitoringScheduleConfig)), errors.collect(cdk.propertyValidator("monitoringScheduleConfig", CfnMonitoringSchedule_MonitoringScheduleConfigPropertyValidator)(properties.monitoringScheduleConfig)), errors.collect(cdk.propertyValidator("monitoringScheduleName", cdk.requiredValidator)(properties.monitoringScheduleName)), errors.collect(cdk.propertyValidator("monitoringScheduleName", cdk.validateString)(properties.monitoringScheduleName)), errors.collect(cdk.propertyValidator("monitoringScheduleStatus", cdk.validateString)(properties.monitoringScheduleStatus)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnMonitoringScheduleProps"');
    }
    function cfnMonitoringSchedulePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMonitoringSchedulePropsValidator(properties).assertSuccess(), { MonitoringScheduleConfig: cfnMonitoringScheduleMonitoringScheduleConfigPropertyToCloudFormation(properties.monitoringScheduleConfig), MonitoringScheduleName: cdk.stringToCloudFormation(properties.monitoringScheduleName), EndpointName: cdk.stringToCloudFormation(properties.endpointName), FailureReason: cdk.stringToCloudFormation(properties.failureReason), LastMonitoringExecutionSummary: cfnMonitoringScheduleMonitoringExecutionSummaryPropertyToCloudFormation(properties.lastMonitoringExecutionSummary), MonitoringScheduleStatus: cdk.stringToCloudFormation(properties.monitoringScheduleStatus), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnMonitoringSchedulePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("monitoringScheduleConfig", "MonitoringScheduleConfig", CfnMonitoringScheduleMonitoringScheduleConfigPropertyFromCloudFormation(properties.MonitoringScheduleConfig)), ret.addPropertyResult("monitoringScheduleName", "MonitoringScheduleName", cfn_parse.FromCloudFormation.getString(properties.MonitoringScheduleName)), ret.addPropertyResult("endpointName", "EndpointName", properties.EndpointName != null ? cfn_parse.FromCloudFormation.getString(properties.EndpointName) : void 0), ret.addPropertyResult("failureReason", "FailureReason", properties.FailureReason != null ? cfn_parse.FromCloudFormation.getString(properties.FailureReason) : void 0), ret.addPropertyResult("lastMonitoringExecutionSummary", "LastMonitoringExecutionSummary", properties.LastMonitoringExecutionSummary != null ? CfnMonitoringScheduleMonitoringExecutionSummaryPropertyFromCloudFormation(properties.LastMonitoringExecutionSummary) : void 0), ret.addPropertyResult("monitoringScheduleStatus", "MonitoringScheduleStatus", properties.MonitoringScheduleStatus != null ? cfn_parse.FromCloudFormation.getString(properties.MonitoringScheduleStatus) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnMonitoringSchedule = class _CfnMonitoringSchedule extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnMonitoringSchedulePropsFromCloudFormation(resourceProperties), ret = new _CfnMonitoringSchedule(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnMonitoringSchedule.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sagemaker_CfnMonitoringScheduleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnMonitoringSchedule), error;
        }
        cdk.requireProperty(props, "monitoringScheduleConfig", this), cdk.requireProperty(props, "monitoringScheduleName", this), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrLastModifiedTime = cdk.Token.asString(this.getAtt("LastModifiedTime", cdk.ResolutionTypeHint.STRING)), this.attrMonitoringScheduleArn = cdk.Token.asString(this.getAtt("MonitoringScheduleArn", cdk.ResolutionTypeHint.STRING)), this.monitoringScheduleConfig = props.monitoringScheduleConfig, this.monitoringScheduleName = props.monitoringScheduleName, this.endpointName = props.endpointName, this.failureReason = props.failureReason, this.lastMonitoringExecutionSummary = props.lastMonitoringExecutionSummary, this.monitoringScheduleStatus = props.monitoringScheduleStatus, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SageMaker::MonitoringSchedule", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnMonitoringSchedule.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { monitoringScheduleConfig: this.monitoringScheduleConfig, monitoringScheduleName: this.monitoringScheduleName, endpointName: this.endpointName, failureReason: this.failureReason, lastMonitoringExecutionSummary: this.lastMonitoringExecutionSummary, monitoringScheduleStatus: this.monitoringScheduleStatus, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnMonitoringSchedulePropsToCloudFormation(props);
      }
    };
    _w = JSII_RTTI_SYMBOL_1, CfnMonitoringSchedule[_w] = { fqn: "aws-cdk-lib.aws_sagemaker.CfnMonitoringSchedule", version: "2.80.0" }, CfnMonitoringSchedule.CFN_RESOURCE_TYPE_NAME = "AWS::SageMaker::MonitoringSchedule", exports2.CfnMonitoringSchedule = CfnMonitoringSchedule;
    function CfnMonitoringSchedule_BaselineConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("constraintsResource", CfnMonitoringSchedule_ConstraintsResourcePropertyValidator)(properties.constraintsResource)), errors.collect(cdk.propertyValidator("statisticsResource", CfnMonitoringSchedule_StatisticsResourcePropertyValidator)(properties.statisticsResource)), errors.wrap('supplied properties not correct for "BaselineConfigProperty"');
    }
    function cfnMonitoringScheduleBaselineConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMonitoringSchedule_BaselineConfigPropertyValidator(properties).assertSuccess(), { ConstraintsResource: cfnMonitoringScheduleConstraintsResourcePropertyToCloudFormation(properties.constraintsResource), StatisticsResource: cfnMonitoringScheduleStatisticsResourcePropertyToCloudFormation(properties.statisticsResource) }) : properties;
    }
    function CfnMonitoringScheduleBaselineConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("constraintsResource", "ConstraintsResource", properties.ConstraintsResource != null ? CfnMonitoringScheduleConstraintsResourcePropertyFromCloudFormation(properties.ConstraintsResource) : void 0), ret.addPropertyResult("statisticsResource", "StatisticsResource", properties.StatisticsResource != null ? CfnMonitoringScheduleStatisticsResourcePropertyFromCloudFormation(properties.StatisticsResource) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMonitoringSchedule_BatchTransformInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataCapturedDestinationS3Uri", cdk.requiredValidator)(properties.dataCapturedDestinationS3Uri)), errors.collect(cdk.propertyValidator("dataCapturedDestinationS3Uri", cdk.validateString)(properties.dataCapturedDestinationS3Uri)), errors.collect(cdk.propertyValidator("datasetFormat", cdk.requiredValidator)(properties.datasetFormat)), errors.collect(cdk.propertyValidator("datasetFormat", CfnMonitoringSchedule_DatasetFormatPropertyValidator)(properties.datasetFormat)), errors.collect(cdk.propertyValidator("localPath", cdk.requiredValidator)(properties.localPath)), errors.collect(cdk.propertyValidator("localPath", cdk.validateString)(properties.localPath)), errors.collect(cdk.propertyValidator("s3DataDistributionType", cdk.validateString)(properties.s3DataDistributionType)), errors.collect(cdk.propertyValidator("s3InputMode", cdk.validateString)(properties.s3InputMode)), errors.wrap('supplied properties not correct for "BatchTransformInputProperty"');
    }
    function cfnMonitoringScheduleBatchTransformInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMonitoringSchedule_BatchTransformInputPropertyValidator(properties).assertSuccess(), { DataCapturedDestinationS3Uri: cdk.stringToCloudFormation(properties.dataCapturedDestinationS3Uri), DatasetFormat: cfnMonitoringScheduleDatasetFormatPropertyToCloudFormation(properties.datasetFormat), LocalPath: cdk.stringToCloudFormation(properties.localPath), S3DataDistributionType: cdk.stringToCloudFormation(properties.s3DataDistributionType), S3InputMode: cdk.stringToCloudFormation(properties.s3InputMode) }) : properties;
    }
    function CfnMonitoringScheduleBatchTransformInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataCapturedDestinationS3Uri", "DataCapturedDestinationS3Uri", cfn_parse.FromCloudFormation.getString(properties.DataCapturedDestinationS3Uri)), ret.addPropertyResult("datasetFormat", "DatasetFormat", CfnMonitoringScheduleDatasetFormatPropertyFromCloudFormation(properties.DatasetFormat)), ret.addPropertyResult("localPath", "LocalPath", cfn_parse.FromCloudFormation.getString(properties.LocalPath)), ret.addPropertyResult("s3DataDistributionType", "S3DataDistributionType", properties.S3DataDistributionType != null ? cfn_parse.FromCloudFormation.getString(properties.S3DataDistributionType) : void 0), ret.addPropertyResult("s3InputMode", "S3InputMode", properties.S3InputMode != null ? cfn_parse.FromCloudFormation.getString(properties.S3InputMode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMonitoringSchedule_ClusterConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceCount", cdk.requiredValidator)(properties.instanceCount)), errors.collect(cdk.propertyValidator("instanceCount", cdk.validateNumber)(properties.instanceCount)), errors.collect(cdk.propertyValidator("instanceType", cdk.requiredValidator)(properties.instanceType)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("volumeKmsKeyId", cdk.validateString)(properties.volumeKmsKeyId)), errors.collect(cdk.propertyValidator("volumeSizeInGb", cdk.requiredValidator)(properties.volumeSizeInGb)), errors.collect(cdk.propertyValidator("volumeSizeInGb", cdk.validateNumber)(properties.volumeSizeInGb)), errors.wrap('supplied properties not correct for "ClusterConfigProperty"');
    }
    function cfnMonitoringScheduleClusterConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMonitoringSchedule_ClusterConfigPropertyValidator(properties).assertSuccess(), { InstanceCount: cdk.numberToCloudFormation(properties.instanceCount), InstanceType: cdk.stringToCloudFormation(properties.instanceType), VolumeKmsKeyId: cdk.stringToCloudFormation(properties.volumeKmsKeyId), VolumeSizeInGB: cdk.numberToCloudFormation(properties.volumeSizeInGb) }) : properties;
    }
    function CfnMonitoringScheduleClusterConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceCount", "InstanceCount", cfn_parse.FromCloudFormation.getNumber(properties.InstanceCount)), ret.addPropertyResult("instanceType", "InstanceType", cfn_parse.FromCloudFormation.getString(properties.InstanceType)), ret.addPropertyResult("volumeKmsKeyId", "VolumeKmsKeyId", properties.VolumeKmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.VolumeKmsKeyId) : void 0), ret.addPropertyResult("volumeSizeInGb", "VolumeSizeInGB", cfn_parse.FromCloudFormation.getNumber(properties.VolumeSizeInGB)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMonitoringSchedule_ConstraintsResourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3Uri", cdk.validateString)(properties.s3Uri)), errors.wrap('supplied properties not correct for "ConstraintsResourceProperty"');
    }
    function cfnMonitoringScheduleConstraintsResourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMonitoringSchedule_ConstraintsResourcePropertyValidator(properties).assertSuccess(), { S3Uri: cdk.stringToCloudFormation(properties.s3Uri) }) : properties;
    }
    function CfnMonitoringScheduleConstraintsResourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Uri", "S3Uri", properties.S3Uri != null ? cfn_parse.FromCloudFormation.getString(properties.S3Uri) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMonitoringSchedule_CsvPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("header", cdk.validateBoolean)(properties.header)), errors.wrap('supplied properties not correct for "CsvProperty"');
    }
    function cfnMonitoringScheduleCsvPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMonitoringSchedule_CsvPropertyValidator(properties).assertSuccess(), { Header: cdk.booleanToCloudFormation(properties.header) }) : properties;
    }
    function CfnMonitoringScheduleCsvPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("header", "Header", properties.Header != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Header) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMonitoringSchedule_DatasetFormatPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("csv", CfnMonitoringSchedule_CsvPropertyValidator)(properties.csv)), errors.collect(cdk.propertyValidator("json", CfnMonitoringSchedule_JsonPropertyValidator)(properties.json)), errors.collect(cdk.propertyValidator("parquet", cdk.validateBoolean)(properties.parquet)), errors.wrap('supplied properties not correct for "DatasetFormatProperty"');
    }
    function cfnMonitoringScheduleDatasetFormatPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMonitoringSchedule_DatasetFormatPropertyValidator(properties).assertSuccess(), { Csv: cfnMonitoringScheduleCsvPropertyToCloudFormation(properties.csv), Json: cfnMonitoringScheduleJsonPropertyToCloudFormation(properties.json), Parquet: cdk.booleanToCloudFormation(properties.parquet) }) : properties;
    }
    function CfnMonitoringScheduleDatasetFormatPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("csv", "Csv", properties.Csv != null ? CfnMonitoringScheduleCsvPropertyFromCloudFormation(properties.Csv) : void 0), ret.addPropertyResult("json", "Json", properties.Json != null ? CfnMonitoringScheduleJsonPropertyFromCloudFormation(properties.Json) : void 0), ret.addPropertyResult("parquet", "Parquet", properties.Parquet != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Parquet) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMonitoringSchedule_EndpointInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endpointName", cdk.requiredValidator)(properties.endpointName)), errors.collect(cdk.propertyValidator("endpointName", cdk.validateString)(properties.endpointName)), errors.collect(cdk.propertyValidator("localPath", cdk.requiredValidator)(properties.localPath)), errors.collect(cdk.propertyValidator("localPath", cdk.validateString)(properties.localPath)), errors.collect(cdk.propertyValidator("s3DataDistributionType", cdk.validateString)(properties.s3DataDistributionType)), errors.collect(cdk.propertyValidator("s3InputMode", cdk.validateString)(properties.s3InputMode)), errors.wrap('supplied properties not correct for "EndpointInputProperty"');
    }
    function cfnMonitoringScheduleEndpointInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMonitoringSchedule_EndpointInputPropertyValidator(properties).assertSuccess(), { EndpointName: cdk.stringToCloudFormation(properties.endpointName), LocalPath: cdk.stringToCloudFormation(properties.localPath), S3DataDistributionType: cdk.stringToCloudFormation(properties.s3DataDistributionType), S3InputMode: cdk.stringToCloudFormation(properties.s3InputMode) }) : properties;
    }
    function CfnMonitoringScheduleEndpointInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endpointName", "EndpointName", cfn_parse.FromCloudFormation.getString(properties.EndpointName)), ret.addPropertyResult("localPath", "LocalPath", cfn_parse.FromCloudFormation.getString(properties.LocalPath)), ret.addPropertyResult("s3DataDistributionType", "S3DataDistributionType", properties.S3DataDistributionType != null ? cfn_parse.FromCloudFormation.getString(properties.S3DataDistributionType) : void 0), ret.addPropertyResult("s3InputMode", "S3InputMode", properties.S3InputMode != null ? cfn_parse.FromCloudFormation.getString(properties.S3InputMode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMonitoringSchedule_JsonPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("line", cdk.validateBoolean)(properties.line)), errors.wrap('supplied properties not correct for "JsonProperty"');
    }
    function cfnMonitoringScheduleJsonPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMonitoringSchedule_JsonPropertyValidator(properties).assertSuccess(), { Line: cdk.booleanToCloudFormation(properties.line) }) : properties;
    }
    function CfnMonitoringScheduleJsonPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("line", "Line", properties.Line != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Line) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMonitoringSchedule_MonitoringAppSpecificationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("containerArguments", cdk.listValidator(cdk.validateString))(properties.containerArguments)), errors.collect(cdk.propertyValidator("containerEntrypoint", cdk.listValidator(cdk.validateString))(properties.containerEntrypoint)), errors.collect(cdk.propertyValidator("imageUri", cdk.requiredValidator)(properties.imageUri)), errors.collect(cdk.propertyValidator("imageUri", cdk.validateString)(properties.imageUri)), errors.collect(cdk.propertyValidator("postAnalyticsProcessorSourceUri", cdk.validateString)(properties.postAnalyticsProcessorSourceUri)), errors.collect(cdk.propertyValidator("recordPreprocessorSourceUri", cdk.validateString)(properties.recordPreprocessorSourceUri)), errors.wrap('supplied properties not correct for "MonitoringAppSpecificationProperty"');
    }
    function cfnMonitoringScheduleMonitoringAppSpecificationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMonitoringSchedule_MonitoringAppSpecificationPropertyValidator(properties).assertSuccess(), { ContainerArguments: cdk.listMapper(cdk.stringToCloudFormation)(properties.containerArguments), ContainerEntrypoint: cdk.listMapper(cdk.stringToCloudFormation)(properties.containerEntrypoint), ImageUri: cdk.stringToCloudFormation(properties.imageUri), PostAnalyticsProcessorSourceUri: cdk.stringToCloudFormation(properties.postAnalyticsProcessorSourceUri), RecordPreprocessorSourceUri: cdk.stringToCloudFormation(properties.recordPreprocessorSourceUri) }) : properties;
    }
    function CfnMonitoringScheduleMonitoringAppSpecificationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("containerArguments", "ContainerArguments", properties.ContainerArguments != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ContainerArguments) : void 0), ret.addPropertyResult("containerEntrypoint", "ContainerEntrypoint", properties.ContainerEntrypoint != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ContainerEntrypoint) : void 0), ret.addPropertyResult("imageUri", "ImageUri", cfn_parse.FromCloudFormation.getString(properties.ImageUri)), ret.addPropertyResult("postAnalyticsProcessorSourceUri", "PostAnalyticsProcessorSourceUri", properties.PostAnalyticsProcessorSourceUri != null ? cfn_parse.FromCloudFormation.getString(properties.PostAnalyticsProcessorSourceUri) : void 0), ret.addPropertyResult("recordPreprocessorSourceUri", "RecordPreprocessorSourceUri", properties.RecordPreprocessorSourceUri != null ? cfn_parse.FromCloudFormation.getString(properties.RecordPreprocessorSourceUri) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMonitoringSchedule_MonitoringExecutionSummaryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("creationTime", cdk.requiredValidator)(properties.creationTime)), errors.collect(cdk.propertyValidator("creationTime", cdk.validateString)(properties.creationTime)), errors.collect(cdk.propertyValidator("endpointName", cdk.validateString)(properties.endpointName)), errors.collect(cdk.propertyValidator("failureReason", cdk.validateString)(properties.failureReason)), errors.collect(cdk.propertyValidator("lastModifiedTime", cdk.requiredValidator)(properties.lastModifiedTime)), errors.collect(cdk.propertyValidator("lastModifiedTime", cdk.validateString)(properties.lastModifiedTime)), errors.collect(cdk.propertyValidator("monitoringExecutionStatus", cdk.requiredValidator)(properties.monitoringExecutionStatus)), errors.collect(cdk.propertyValidator("monitoringExecutionStatus", cdk.validateString)(properties.monitoringExecutionStatus)), errors.collect(cdk.propertyValidator("monitoringScheduleName", cdk.requiredValidator)(properties.monitoringScheduleName)), errors.collect(cdk.propertyValidator("monitoringScheduleName", cdk.validateString)(properties.monitoringScheduleName)), errors.collect(cdk.propertyValidator("processingJobArn", cdk.validateString)(properties.processingJobArn)), errors.collect(cdk.propertyValidator("scheduledTime", cdk.requiredValidator)(properties.scheduledTime)), errors.collect(cdk.propertyValidator("scheduledTime", cdk.validateString)(properties.scheduledTime)), errors.wrap('supplied properties not correct for "MonitoringExecutionSummaryProperty"');
    }
    function cfnMonitoringScheduleMonitoringExecutionSummaryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMonitoringSchedule_MonitoringExecutionSummaryPropertyValidator(properties).assertSuccess(), { CreationTime: cdk.stringToCloudFormation(properties.creationTime), EndpointName: cdk.stringToCloudFormation(properties.endpointName), FailureReason: cdk.stringToCloudFormation(properties.failureReason), LastModifiedTime: cdk.stringToCloudFormation(properties.lastModifiedTime), MonitoringExecutionStatus: cdk.stringToCloudFormation(properties.monitoringExecutionStatus), MonitoringScheduleName: cdk.stringToCloudFormation(properties.monitoringScheduleName), ProcessingJobArn: cdk.stringToCloudFormation(properties.processingJobArn), ScheduledTime: cdk.stringToCloudFormation(properties.scheduledTime) }) : properties;
    }
    function CfnMonitoringScheduleMonitoringExecutionSummaryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("creationTime", "CreationTime", cfn_parse.FromCloudFormation.getString(properties.CreationTime)), ret.addPropertyResult("endpointName", "EndpointName", properties.EndpointName != null ? cfn_parse.FromCloudFormation.getString(properties.EndpointName) : void 0), ret.addPropertyResult("failureReason", "FailureReason", properties.FailureReason != null ? cfn_parse.FromCloudFormation.getString(properties.FailureReason) : void 0), ret.addPropertyResult("lastModifiedTime", "LastModifiedTime", cfn_parse.FromCloudFormation.getString(properties.LastModifiedTime)), ret.addPropertyResult("monitoringExecutionStatus", "MonitoringExecutionStatus", cfn_parse.FromCloudFormation.getString(properties.MonitoringExecutionStatus)), ret.addPropertyResult("monitoringScheduleName", "MonitoringScheduleName", cfn_parse.FromCloudFormation.getString(properties.MonitoringScheduleName)), ret.addPropertyResult("processingJobArn", "ProcessingJobArn", properties.ProcessingJobArn != null ? cfn_parse.FromCloudFormation.getString(properties.ProcessingJobArn) : void 0), ret.addPropertyResult("scheduledTime", "ScheduledTime", cfn_parse.FromCloudFormation.getString(properties.ScheduledTime)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMonitoringSchedule_MonitoringInputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("batchTransformInput", CfnMonitoringSchedule_BatchTransformInputPropertyValidator)(properties.batchTransformInput)), errors.collect(cdk.propertyValidator("endpointInput", CfnMonitoringSchedule_EndpointInputPropertyValidator)(properties.endpointInput)), errors.wrap('supplied properties not correct for "MonitoringInputProperty"');
    }
    function cfnMonitoringScheduleMonitoringInputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMonitoringSchedule_MonitoringInputPropertyValidator(properties).assertSuccess(), { BatchTransformInput: cfnMonitoringScheduleBatchTransformInputPropertyToCloudFormation(properties.batchTransformInput), EndpointInput: cfnMonitoringScheduleEndpointInputPropertyToCloudFormation(properties.endpointInput) }) : properties;
    }
    function CfnMonitoringScheduleMonitoringInputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("batchTransformInput", "BatchTransformInput", properties.BatchTransformInput != null ? CfnMonitoringScheduleBatchTransformInputPropertyFromCloudFormation(properties.BatchTransformInput) : void 0), ret.addPropertyResult("endpointInput", "EndpointInput", properties.EndpointInput != null ? CfnMonitoringScheduleEndpointInputPropertyFromCloudFormation(properties.EndpointInput) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMonitoringSchedule_MonitoringJobDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("baselineConfig", CfnMonitoringSchedule_BaselineConfigPropertyValidator)(properties.baselineConfig)), errors.collect(cdk.propertyValidator("environment", cdk.hashValidator(cdk.validateString))(properties.environment)), errors.collect(cdk.propertyValidator("monitoringAppSpecification", cdk.requiredValidator)(properties.monitoringAppSpecification)), errors.collect(cdk.propertyValidator("monitoringAppSpecification", CfnMonitoringSchedule_MonitoringAppSpecificationPropertyValidator)(properties.monitoringAppSpecification)), errors.collect(cdk.propertyValidator("monitoringInputs", cdk.requiredValidator)(properties.monitoringInputs)), errors.collect(cdk.propertyValidator("monitoringInputs", cdk.listValidator(CfnMonitoringSchedule_MonitoringInputPropertyValidator))(properties.monitoringInputs)), errors.collect(cdk.propertyValidator("monitoringOutputConfig", cdk.requiredValidator)(properties.monitoringOutputConfig)), errors.collect(cdk.propertyValidator("monitoringOutputConfig", CfnMonitoringSchedule_MonitoringOutputConfigPropertyValidator)(properties.monitoringOutputConfig)), errors.collect(cdk.propertyValidator("monitoringResources", cdk.requiredValidator)(properties.monitoringResources)), errors.collect(cdk.propertyValidator("monitoringResources", CfnMonitoringSchedule_MonitoringResourcesPropertyValidator)(properties.monitoringResources)), errors.collect(cdk.propertyValidator("networkConfig", CfnMonitoringSchedule_NetworkConfigPropertyValidator)(properties.networkConfig)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("stoppingCondition", CfnMonitoringSchedule_StoppingConditionPropertyValidator)(properties.stoppingCondition)), errors.wrap('supplied properties not correct for "MonitoringJobDefinitionProperty"');
    }
    function cfnMonitoringScheduleMonitoringJobDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMonitoringSchedule_MonitoringJobDefinitionPropertyValidator(properties).assertSuccess(), { BaselineConfig: cfnMonitoringScheduleBaselineConfigPropertyToCloudFormation(properties.baselineConfig), Environment: cdk.hashMapper(cdk.stringToCloudFormation)(properties.environment), MonitoringAppSpecification: cfnMonitoringScheduleMonitoringAppSpecificationPropertyToCloudFormation(properties.monitoringAppSpecification), MonitoringInputs: cdk.listMapper(cfnMonitoringScheduleMonitoringInputPropertyToCloudFormation)(properties.monitoringInputs), MonitoringOutputConfig: cfnMonitoringScheduleMonitoringOutputConfigPropertyToCloudFormation(properties.monitoringOutputConfig), MonitoringResources: cfnMonitoringScheduleMonitoringResourcesPropertyToCloudFormation(properties.monitoringResources), NetworkConfig: cfnMonitoringScheduleNetworkConfigPropertyToCloudFormation(properties.networkConfig), RoleArn: cdk.stringToCloudFormation(properties.roleArn), StoppingCondition: cfnMonitoringScheduleStoppingConditionPropertyToCloudFormation(properties.stoppingCondition) }) : properties;
    }
    function CfnMonitoringScheduleMonitoringJobDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("baselineConfig", "BaselineConfig", properties.BaselineConfig != null ? CfnMonitoringScheduleBaselineConfigPropertyFromCloudFormation(properties.BaselineConfig) : void 0), ret.addPropertyResult("environment", "Environment", properties.Environment != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Environment) : void 0), ret.addPropertyResult("monitoringAppSpecification", "MonitoringAppSpecification", CfnMonitoringScheduleMonitoringAppSpecificationPropertyFromCloudFormation(properties.MonitoringAppSpecification)), ret.addPropertyResult("monitoringInputs", "MonitoringInputs", cfn_parse.FromCloudFormation.getArray(CfnMonitoringScheduleMonitoringInputPropertyFromCloudFormation)(properties.MonitoringInputs)), ret.addPropertyResult("monitoringOutputConfig", "MonitoringOutputConfig", CfnMonitoringScheduleMonitoringOutputConfigPropertyFromCloudFormation(properties.MonitoringOutputConfig)), ret.addPropertyResult("monitoringResources", "MonitoringResources", CfnMonitoringScheduleMonitoringResourcesPropertyFromCloudFormation(properties.MonitoringResources)), ret.addPropertyResult("networkConfig", "NetworkConfig", properties.NetworkConfig != null ? CfnMonitoringScheduleNetworkConfigPropertyFromCloudFormation(properties.NetworkConfig) : void 0), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("stoppingCondition", "StoppingCondition", properties.StoppingCondition != null ? CfnMonitoringScheduleStoppingConditionPropertyFromCloudFormation(properties.StoppingCondition) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMonitoringSchedule_MonitoringOutputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3Output", cdk.requiredValidator)(properties.s3Output)), errors.collect(cdk.propertyValidator("s3Output", CfnMonitoringSchedule_S3OutputPropertyValidator)(properties.s3Output)), errors.wrap('supplied properties not correct for "MonitoringOutputProperty"');
    }
    function cfnMonitoringScheduleMonitoringOutputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMonitoringSchedule_MonitoringOutputPropertyValidator(properties).assertSuccess(), { S3Output: cfnMonitoringScheduleS3OutputPropertyToCloudFormation(properties.s3Output) }) : properties;
    }
    function CfnMonitoringScheduleMonitoringOutputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Output", "S3Output", CfnMonitoringScheduleS3OutputPropertyFromCloudFormation(properties.S3Output)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMonitoringSchedule_MonitoringOutputConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("monitoringOutputs", cdk.requiredValidator)(properties.monitoringOutputs)), errors.collect(cdk.propertyValidator("monitoringOutputs", cdk.listValidator(CfnMonitoringSchedule_MonitoringOutputPropertyValidator))(properties.monitoringOutputs)), errors.wrap('supplied properties not correct for "MonitoringOutputConfigProperty"');
    }
    function cfnMonitoringScheduleMonitoringOutputConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMonitoringSchedule_MonitoringOutputConfigPropertyValidator(properties).assertSuccess(), { KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), MonitoringOutputs: cdk.listMapper(cfnMonitoringScheduleMonitoringOutputPropertyToCloudFormation)(properties.monitoringOutputs) }) : properties;
    }
    function CfnMonitoringScheduleMonitoringOutputConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("monitoringOutputs", "MonitoringOutputs", cfn_parse.FromCloudFormation.getArray(CfnMonitoringScheduleMonitoringOutputPropertyFromCloudFormation)(properties.MonitoringOutputs)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMonitoringSchedule_MonitoringResourcesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clusterConfig", cdk.requiredValidator)(properties.clusterConfig)), errors.collect(cdk.propertyValidator("clusterConfig", CfnMonitoringSchedule_ClusterConfigPropertyValidator)(properties.clusterConfig)), errors.wrap('supplied properties not correct for "MonitoringResourcesProperty"');
    }
    function cfnMonitoringScheduleMonitoringResourcesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMonitoringSchedule_MonitoringResourcesPropertyValidator(properties).assertSuccess(), { ClusterConfig: cfnMonitoringScheduleClusterConfigPropertyToCloudFormation(properties.clusterConfig) }) : properties;
    }
    function CfnMonitoringScheduleMonitoringResourcesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("clusterConfig", "ClusterConfig", CfnMonitoringScheduleClusterConfigPropertyFromCloudFormation(properties.ClusterConfig)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMonitoringSchedule_MonitoringScheduleConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("monitoringJobDefinition", CfnMonitoringSchedule_MonitoringJobDefinitionPropertyValidator)(properties.monitoringJobDefinition)), errors.collect(cdk.propertyValidator("monitoringJobDefinitionName", cdk.validateString)(properties.monitoringJobDefinitionName)), errors.collect(cdk.propertyValidator("monitoringType", cdk.validateString)(properties.monitoringType)), errors.collect(cdk.propertyValidator("scheduleConfig", CfnMonitoringSchedule_ScheduleConfigPropertyValidator)(properties.scheduleConfig)), errors.wrap('supplied properties not correct for "MonitoringScheduleConfigProperty"');
    }
    function cfnMonitoringScheduleMonitoringScheduleConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMonitoringSchedule_MonitoringScheduleConfigPropertyValidator(properties).assertSuccess(), { MonitoringJobDefinition: cfnMonitoringScheduleMonitoringJobDefinitionPropertyToCloudFormation(properties.monitoringJobDefinition), MonitoringJobDefinitionName: cdk.stringToCloudFormation(properties.monitoringJobDefinitionName), MonitoringType: cdk.stringToCloudFormation(properties.monitoringType), ScheduleConfig: cfnMonitoringScheduleScheduleConfigPropertyToCloudFormation(properties.scheduleConfig) }) : properties;
    }
    function CfnMonitoringScheduleMonitoringScheduleConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("monitoringJobDefinition", "MonitoringJobDefinition", properties.MonitoringJobDefinition != null ? CfnMonitoringScheduleMonitoringJobDefinitionPropertyFromCloudFormation(properties.MonitoringJobDefinition) : void 0), ret.addPropertyResult("monitoringJobDefinitionName", "MonitoringJobDefinitionName", properties.MonitoringJobDefinitionName != null ? cfn_parse.FromCloudFormation.getString(properties.MonitoringJobDefinitionName) : void 0), ret.addPropertyResult("monitoringType", "MonitoringType", properties.MonitoringType != null ? cfn_parse.FromCloudFormation.getString(properties.MonitoringType) : void 0), ret.addPropertyResult("scheduleConfig", "ScheduleConfig", properties.ScheduleConfig != null ? CfnMonitoringScheduleScheduleConfigPropertyFromCloudFormation(properties.ScheduleConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMonitoringSchedule_NetworkConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enableInterContainerTrafficEncryption", cdk.validateBoolean)(properties.enableInterContainerTrafficEncryption)), errors.collect(cdk.propertyValidator("enableNetworkIsolation", cdk.validateBoolean)(properties.enableNetworkIsolation)), errors.collect(cdk.propertyValidator("vpcConfig", CfnMonitoringSchedule_VpcConfigPropertyValidator)(properties.vpcConfig)), errors.wrap('supplied properties not correct for "NetworkConfigProperty"');
    }
    function cfnMonitoringScheduleNetworkConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMonitoringSchedule_NetworkConfigPropertyValidator(properties).assertSuccess(), { EnableInterContainerTrafficEncryption: cdk.booleanToCloudFormation(properties.enableInterContainerTrafficEncryption), EnableNetworkIsolation: cdk.booleanToCloudFormation(properties.enableNetworkIsolation), VpcConfig: cfnMonitoringScheduleVpcConfigPropertyToCloudFormation(properties.vpcConfig) }) : properties;
    }
    function CfnMonitoringScheduleNetworkConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enableInterContainerTrafficEncryption", "EnableInterContainerTrafficEncryption", properties.EnableInterContainerTrafficEncryption != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableInterContainerTrafficEncryption) : void 0), ret.addPropertyResult("enableNetworkIsolation", "EnableNetworkIsolation", properties.EnableNetworkIsolation != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableNetworkIsolation) : void 0), ret.addPropertyResult("vpcConfig", "VpcConfig", properties.VpcConfig != null ? CfnMonitoringScheduleVpcConfigPropertyFromCloudFormation(properties.VpcConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMonitoringSchedule_S3OutputPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("localPath", cdk.requiredValidator)(properties.localPath)), errors.collect(cdk.propertyValidator("localPath", cdk.validateString)(properties.localPath)), errors.collect(cdk.propertyValidator("s3UploadMode", cdk.validateString)(properties.s3UploadMode)), errors.collect(cdk.propertyValidator("s3Uri", cdk.requiredValidator)(properties.s3Uri)), errors.collect(cdk.propertyValidator("s3Uri", cdk.validateString)(properties.s3Uri)), errors.wrap('supplied properties not correct for "S3OutputProperty"');
    }
    function cfnMonitoringScheduleS3OutputPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMonitoringSchedule_S3OutputPropertyValidator(properties).assertSuccess(), { LocalPath: cdk.stringToCloudFormation(properties.localPath), S3UploadMode: cdk.stringToCloudFormation(properties.s3UploadMode), S3Uri: cdk.stringToCloudFormation(properties.s3Uri) }) : properties;
    }
    function CfnMonitoringScheduleS3OutputPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("localPath", "LocalPath", cfn_parse.FromCloudFormation.getString(properties.LocalPath)), ret.addPropertyResult("s3UploadMode", "S3UploadMode", properties.S3UploadMode != null ? cfn_parse.FromCloudFormation.getString(properties.S3UploadMode) : void 0), ret.addPropertyResult("s3Uri", "S3Uri", cfn_parse.FromCloudFormation.getString(properties.S3Uri)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMonitoringSchedule_ScheduleConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("scheduleExpression", cdk.requiredValidator)(properties.scheduleExpression)), errors.collect(cdk.propertyValidator("scheduleExpression", cdk.validateString)(properties.scheduleExpression)), errors.wrap('supplied properties not correct for "ScheduleConfigProperty"');
    }
    function cfnMonitoringScheduleScheduleConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMonitoringSchedule_ScheduleConfigPropertyValidator(properties).assertSuccess(), { ScheduleExpression: cdk.stringToCloudFormation(properties.scheduleExpression) }) : properties;
    }
    function CfnMonitoringScheduleScheduleConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("scheduleExpression", "ScheduleExpression", cfn_parse.FromCloudFormation.getString(properties.ScheduleExpression)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMonitoringSchedule_StatisticsResourcePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3Uri", cdk.validateString)(properties.s3Uri)), errors.wrap('supplied properties not correct for "StatisticsResourceProperty"');
    }
    function cfnMonitoringScheduleStatisticsResourcePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMonitoringSchedule_StatisticsResourcePropertyValidator(properties).assertSuccess(), { S3Uri: cdk.stringToCloudFormation(properties.s3Uri) }) : properties;
    }
    function CfnMonitoringScheduleStatisticsResourcePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Uri", "S3Uri", properties.S3Uri != null ? cfn_parse.FromCloudFormation.getString(properties.S3Uri) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMonitoringSchedule_StoppingConditionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maxRuntimeInSeconds", cdk.requiredValidator)(properties.maxRuntimeInSeconds)), errors.collect(cdk.propertyValidator("maxRuntimeInSeconds", cdk.validateNumber)(properties.maxRuntimeInSeconds)), errors.wrap('supplied properties not correct for "StoppingConditionProperty"');
    }
    function cfnMonitoringScheduleStoppingConditionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMonitoringSchedule_StoppingConditionPropertyValidator(properties).assertSuccess(), { MaxRuntimeInSeconds: cdk.numberToCloudFormation(properties.maxRuntimeInSeconds) }) : properties;
    }
    function CfnMonitoringScheduleStoppingConditionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maxRuntimeInSeconds", "MaxRuntimeInSeconds", cfn_parse.FromCloudFormation.getNumber(properties.MaxRuntimeInSeconds)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnMonitoringSchedule_VpcConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.requiredValidator)(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnets", cdk.requiredValidator)(properties.subnets)), errors.collect(cdk.propertyValidator("subnets", cdk.listValidator(cdk.validateString))(properties.subnets)), errors.wrap('supplied properties not correct for "VpcConfigProperty"');
    }
    function cfnMonitoringScheduleVpcConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnMonitoringSchedule_VpcConfigPropertyValidator(properties).assertSuccess(), { SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), Subnets: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnets) }) : properties;
    }
    function CfnMonitoringScheduleVpcConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds)), ret.addPropertyResult("subnets", "Subnets", cfn_parse.FromCloudFormation.getStringArray(properties.Subnets)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnNotebookInstancePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acceleratorTypes", cdk.listValidator(cdk.validateString))(properties.acceleratorTypes)), errors.collect(cdk.propertyValidator("additionalCodeRepositories", cdk.listValidator(cdk.validateString))(properties.additionalCodeRepositories)), errors.collect(cdk.propertyValidator("defaultCodeRepository", cdk.validateString)(properties.defaultCodeRepository)), errors.collect(cdk.propertyValidator("directInternetAccess", cdk.validateString)(properties.directInternetAccess)), errors.collect(cdk.propertyValidator("instanceMetadataServiceConfiguration", CfnNotebookInstance_InstanceMetadataServiceConfigurationPropertyValidator)(properties.instanceMetadataServiceConfiguration)), errors.collect(cdk.propertyValidator("instanceType", cdk.requiredValidator)(properties.instanceType)), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("lifecycleConfigName", cdk.validateString)(properties.lifecycleConfigName)), errors.collect(cdk.propertyValidator("notebookInstanceName", cdk.validateString)(properties.notebookInstanceName)), errors.collect(cdk.propertyValidator("platformIdentifier", cdk.validateString)(properties.platformIdentifier)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("rootAccess", cdk.validateString)(properties.rootAccess)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnetId", cdk.validateString)(properties.subnetId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("volumeSizeInGb", cdk.validateNumber)(properties.volumeSizeInGb)), errors.wrap('supplied properties not correct for "CfnNotebookInstanceProps"');
    }
    function cfnNotebookInstancePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNotebookInstancePropsValidator(properties).assertSuccess(), { InstanceType: cdk.stringToCloudFormation(properties.instanceType), RoleArn: cdk.stringToCloudFormation(properties.roleArn), AcceleratorTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.acceleratorTypes), AdditionalCodeRepositories: cdk.listMapper(cdk.stringToCloudFormation)(properties.additionalCodeRepositories), DefaultCodeRepository: cdk.stringToCloudFormation(properties.defaultCodeRepository), DirectInternetAccess: cdk.stringToCloudFormation(properties.directInternetAccess), InstanceMetadataServiceConfiguration: cfnNotebookInstanceInstanceMetadataServiceConfigurationPropertyToCloudFormation(properties.instanceMetadataServiceConfiguration), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), LifecycleConfigName: cdk.stringToCloudFormation(properties.lifecycleConfigName), NotebookInstanceName: cdk.stringToCloudFormation(properties.notebookInstanceName), PlatformIdentifier: cdk.stringToCloudFormation(properties.platformIdentifier), RootAccess: cdk.stringToCloudFormation(properties.rootAccess), SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SubnetId: cdk.stringToCloudFormation(properties.subnetId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VolumeSizeInGB: cdk.numberToCloudFormation(properties.volumeSizeInGb) }) : properties;
    }
    function CfnNotebookInstancePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceType", "InstanceType", cfn_parse.FromCloudFormation.getString(properties.InstanceType)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("acceleratorTypes", "AcceleratorTypes", properties.AcceleratorTypes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AcceleratorTypes) : void 0), ret.addPropertyResult("additionalCodeRepositories", "AdditionalCodeRepositories", properties.AdditionalCodeRepositories != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AdditionalCodeRepositories) : void 0), ret.addPropertyResult("defaultCodeRepository", "DefaultCodeRepository", properties.DefaultCodeRepository != null ? cfn_parse.FromCloudFormation.getString(properties.DefaultCodeRepository) : void 0), ret.addPropertyResult("directInternetAccess", "DirectInternetAccess", properties.DirectInternetAccess != null ? cfn_parse.FromCloudFormation.getString(properties.DirectInternetAccess) : void 0), ret.addPropertyResult("instanceMetadataServiceConfiguration", "InstanceMetadataServiceConfiguration", properties.InstanceMetadataServiceConfiguration != null ? CfnNotebookInstanceInstanceMetadataServiceConfigurationPropertyFromCloudFormation(properties.InstanceMetadataServiceConfiguration) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("lifecycleConfigName", "LifecycleConfigName", properties.LifecycleConfigName != null ? cfn_parse.FromCloudFormation.getString(properties.LifecycleConfigName) : void 0), ret.addPropertyResult("notebookInstanceName", "NotebookInstanceName", properties.NotebookInstanceName != null ? cfn_parse.FromCloudFormation.getString(properties.NotebookInstanceName) : void 0), ret.addPropertyResult("platformIdentifier", "PlatformIdentifier", properties.PlatformIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.PlatformIdentifier) : void 0), ret.addPropertyResult("rootAccess", "RootAccess", properties.RootAccess != null ? cfn_parse.FromCloudFormation.getString(properties.RootAccess) : void 0), ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("subnetId", "SubnetId", properties.SubnetId != null ? cfn_parse.FromCloudFormation.getString(properties.SubnetId) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("volumeSizeInGb", "VolumeSizeInGB", properties.VolumeSizeInGB != null ? cfn_parse.FromCloudFormation.getNumber(properties.VolumeSizeInGB) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnNotebookInstance = class _CfnNotebookInstance extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnNotebookInstancePropsFromCloudFormation(resourceProperties), ret = new _CfnNotebookInstance(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnNotebookInstance.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sagemaker_CfnNotebookInstanceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnNotebookInstance), error;
        }
        cdk.requireProperty(props, "instanceType", this), cdk.requireProperty(props, "roleArn", this), this.attrNotebookInstanceName = cdk.Token.asString(this.getAtt("NotebookInstanceName", cdk.ResolutionTypeHint.STRING)), this.instanceType = props.instanceType, this.roleArn = props.roleArn, this.acceleratorTypes = props.acceleratorTypes, this.additionalCodeRepositories = props.additionalCodeRepositories, this.defaultCodeRepository = props.defaultCodeRepository, this.directInternetAccess = props.directInternetAccess, this.instanceMetadataServiceConfiguration = props.instanceMetadataServiceConfiguration, this.kmsKeyId = props.kmsKeyId, this.lifecycleConfigName = props.lifecycleConfigName, this.notebookInstanceName = props.notebookInstanceName, this.platformIdentifier = props.platformIdentifier, this.rootAccess = props.rootAccess, this.securityGroupIds = props.securityGroupIds, this.subnetId = props.subnetId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SageMaker::NotebookInstance", props.tags, { tagPropertyName: "tags" }), this.volumeSizeInGb = props.volumeSizeInGb;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnNotebookInstance.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { instanceType: this.instanceType, roleArn: this.roleArn, acceleratorTypes: this.acceleratorTypes, additionalCodeRepositories: this.additionalCodeRepositories, defaultCodeRepository: this.defaultCodeRepository, directInternetAccess: this.directInternetAccess, instanceMetadataServiceConfiguration: this.instanceMetadataServiceConfiguration, kmsKeyId: this.kmsKeyId, lifecycleConfigName: this.lifecycleConfigName, notebookInstanceName: this.notebookInstanceName, platformIdentifier: this.platformIdentifier, rootAccess: this.rootAccess, securityGroupIds: this.securityGroupIds, subnetId: this.subnetId, tags: this.tags.renderTags(), volumeSizeInGb: this.volumeSizeInGb };
      }
      renderProperties(props) {
        return cfnNotebookInstancePropsToCloudFormation(props);
      }
    };
    _x = JSII_RTTI_SYMBOL_1, CfnNotebookInstance[_x] = { fqn: "aws-cdk-lib.aws_sagemaker.CfnNotebookInstance", version: "2.80.0" }, CfnNotebookInstance.CFN_RESOURCE_TYPE_NAME = "AWS::SageMaker::NotebookInstance", exports2.CfnNotebookInstance = CfnNotebookInstance;
    function CfnNotebookInstance_InstanceMetadataServiceConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("minimumInstanceMetadataServiceVersion", cdk.requiredValidator)(properties.minimumInstanceMetadataServiceVersion)), errors.collect(cdk.propertyValidator("minimumInstanceMetadataServiceVersion", cdk.validateString)(properties.minimumInstanceMetadataServiceVersion)), errors.wrap('supplied properties not correct for "InstanceMetadataServiceConfigurationProperty"');
    }
    function cfnNotebookInstanceInstanceMetadataServiceConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNotebookInstance_InstanceMetadataServiceConfigurationPropertyValidator(properties).assertSuccess(), { MinimumInstanceMetadataServiceVersion: cdk.stringToCloudFormation(properties.minimumInstanceMetadataServiceVersion) }) : properties;
    }
    function CfnNotebookInstanceInstanceMetadataServiceConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("minimumInstanceMetadataServiceVersion", "MinimumInstanceMetadataServiceVersion", cfn_parse.FromCloudFormation.getString(properties.MinimumInstanceMetadataServiceVersion)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnNotebookInstanceLifecycleConfigPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("notebookInstanceLifecycleConfigName", cdk.validateString)(properties.notebookInstanceLifecycleConfigName)), errors.collect(cdk.propertyValidator("onCreate", cdk.listValidator(CfnNotebookInstanceLifecycleConfig_NotebookInstanceLifecycleHookPropertyValidator))(properties.onCreate)), errors.collect(cdk.propertyValidator("onStart", cdk.listValidator(CfnNotebookInstanceLifecycleConfig_NotebookInstanceLifecycleHookPropertyValidator))(properties.onStart)), errors.wrap('supplied properties not correct for "CfnNotebookInstanceLifecycleConfigProps"');
    }
    function cfnNotebookInstanceLifecycleConfigPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNotebookInstanceLifecycleConfigPropsValidator(properties).assertSuccess(), { NotebookInstanceLifecycleConfigName: cdk.stringToCloudFormation(properties.notebookInstanceLifecycleConfigName), OnCreate: cdk.listMapper(cfnNotebookInstanceLifecycleConfigNotebookInstanceLifecycleHookPropertyToCloudFormation)(properties.onCreate), OnStart: cdk.listMapper(cfnNotebookInstanceLifecycleConfigNotebookInstanceLifecycleHookPropertyToCloudFormation)(properties.onStart) }) : properties;
    }
    function CfnNotebookInstanceLifecycleConfigPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("notebookInstanceLifecycleConfigName", "NotebookInstanceLifecycleConfigName", properties.NotebookInstanceLifecycleConfigName != null ? cfn_parse.FromCloudFormation.getString(properties.NotebookInstanceLifecycleConfigName) : void 0), ret.addPropertyResult("onCreate", "OnCreate", properties.OnCreate != null ? cfn_parse.FromCloudFormation.getArray(CfnNotebookInstanceLifecycleConfigNotebookInstanceLifecycleHookPropertyFromCloudFormation)(properties.OnCreate) : void 0), ret.addPropertyResult("onStart", "OnStart", properties.OnStart != null ? cfn_parse.FromCloudFormation.getArray(CfnNotebookInstanceLifecycleConfigNotebookInstanceLifecycleHookPropertyFromCloudFormation)(properties.OnStart) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnNotebookInstanceLifecycleConfig = class _CfnNotebookInstanceLifecycleConfig extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnNotebookInstanceLifecycleConfigPropsFromCloudFormation(resourceProperties), ret = new _CfnNotebookInstanceLifecycleConfig(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnNotebookInstanceLifecycleConfig.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sagemaker_CfnNotebookInstanceLifecycleConfigProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnNotebookInstanceLifecycleConfig), error;
        }
        this.attrNotebookInstanceLifecycleConfigName = cdk.Token.asString(this.getAtt("NotebookInstanceLifecycleConfigName", cdk.ResolutionTypeHint.STRING)), this.notebookInstanceLifecycleConfigName = props.notebookInstanceLifecycleConfigName, this.onCreate = props.onCreate, this.onStart = props.onStart;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnNotebookInstanceLifecycleConfig.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { notebookInstanceLifecycleConfigName: this.notebookInstanceLifecycleConfigName, onCreate: this.onCreate, onStart: this.onStart };
      }
      renderProperties(props) {
        return cfnNotebookInstanceLifecycleConfigPropsToCloudFormation(props);
      }
    };
    _y = JSII_RTTI_SYMBOL_1, CfnNotebookInstanceLifecycleConfig[_y] = { fqn: "aws-cdk-lib.aws_sagemaker.CfnNotebookInstanceLifecycleConfig", version: "2.80.0" }, CfnNotebookInstanceLifecycleConfig.CFN_RESOURCE_TYPE_NAME = "AWS::SageMaker::NotebookInstanceLifecycleConfig", exports2.CfnNotebookInstanceLifecycleConfig = CfnNotebookInstanceLifecycleConfig;
    function CfnNotebookInstanceLifecycleConfig_NotebookInstanceLifecycleHookPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("content", cdk.validateString)(properties.content)), errors.wrap('supplied properties not correct for "NotebookInstanceLifecycleHookProperty"');
    }
    function cfnNotebookInstanceLifecycleConfigNotebookInstanceLifecycleHookPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnNotebookInstanceLifecycleConfig_NotebookInstanceLifecycleHookPropertyValidator(properties).assertSuccess(), { Content: cdk.stringToCloudFormation(properties.content) }) : properties;
    }
    function CfnNotebookInstanceLifecycleConfigNotebookInstanceLifecycleHookPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("content", "Content", properties.Content != null ? cfn_parse.FromCloudFormation.getString(properties.Content) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPipelinePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("parallelismConfiguration", cdk.validateObject)(properties.parallelismConfiguration)), errors.collect(cdk.propertyValidator("pipelineDefinition", cdk.requiredValidator)(properties.pipelineDefinition)), errors.collect(cdk.propertyValidator("pipelineDefinition", cdk.validateObject)(properties.pipelineDefinition)), errors.collect(cdk.propertyValidator("pipelineDescription", cdk.validateString)(properties.pipelineDescription)), errors.collect(cdk.propertyValidator("pipelineDisplayName", cdk.validateString)(properties.pipelineDisplayName)), errors.collect(cdk.propertyValidator("pipelineName", cdk.requiredValidator)(properties.pipelineName)), errors.collect(cdk.propertyValidator("pipelineName", cdk.validateString)(properties.pipelineName)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnPipelineProps"');
    }
    function cfnPipelinePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPipelinePropsValidator(properties).assertSuccess(), { PipelineDefinition: cdk.objectToCloudFormation(properties.pipelineDefinition), PipelineName: cdk.stringToCloudFormation(properties.pipelineName), RoleArn: cdk.stringToCloudFormation(properties.roleArn), ParallelismConfiguration: cdk.objectToCloudFormation(properties.parallelismConfiguration), PipelineDescription: cdk.stringToCloudFormation(properties.pipelineDescription), PipelineDisplayName: cdk.stringToCloudFormation(properties.pipelineDisplayName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnPipelinePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("pipelineDefinition", "PipelineDefinition", cfn_parse.FromCloudFormation.getAny(properties.PipelineDefinition)), ret.addPropertyResult("pipelineName", "PipelineName", cfn_parse.FromCloudFormation.getString(properties.PipelineName)), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("parallelismConfiguration", "ParallelismConfiguration", properties.ParallelismConfiguration != null ? cfn_parse.FromCloudFormation.getAny(properties.ParallelismConfiguration) : void 0), ret.addPropertyResult("pipelineDescription", "PipelineDescription", properties.PipelineDescription != null ? cfn_parse.FromCloudFormation.getString(properties.PipelineDescription) : void 0), ret.addPropertyResult("pipelineDisplayName", "PipelineDisplayName", properties.PipelineDisplayName != null ? cfn_parse.FromCloudFormation.getString(properties.PipelineDisplayName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPipeline = class _CfnPipeline extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPipelinePropsFromCloudFormation(resourceProperties), ret = new _CfnPipeline(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPipeline.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sagemaker_CfnPipelineProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPipeline), error;
        }
        cdk.requireProperty(props, "pipelineDefinition", this), cdk.requireProperty(props, "pipelineName", this), cdk.requireProperty(props, "roleArn", this), this.pipelineDefinition = props.pipelineDefinition, this.pipelineName = props.pipelineName, this.roleArn = props.roleArn, this.parallelismConfiguration = props.parallelismConfiguration, this.pipelineDescription = props.pipelineDescription, this.pipelineDisplayName = props.pipelineDisplayName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SageMaker::Pipeline", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPipeline.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { pipelineDefinition: this.pipelineDefinition, pipelineName: this.pipelineName, roleArn: this.roleArn, parallelismConfiguration: this.parallelismConfiguration, pipelineDescription: this.pipelineDescription, pipelineDisplayName: this.pipelineDisplayName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnPipelinePropsToCloudFormation(props);
      }
    };
    _z = JSII_RTTI_SYMBOL_1, CfnPipeline[_z] = { fqn: "aws-cdk-lib.aws_sagemaker.CfnPipeline", version: "2.80.0" }, CfnPipeline.CFN_RESOURCE_TYPE_NAME = "AWS::SageMaker::Pipeline", exports2.CfnPipeline = CfnPipeline;
    function CfnProjectPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("projectDescription", cdk.validateString)(properties.projectDescription)), errors.collect(cdk.propertyValidator("projectName", cdk.requiredValidator)(properties.projectName)), errors.collect(cdk.propertyValidator("projectName", cdk.validateString)(properties.projectName)), errors.collect(cdk.propertyValidator("serviceCatalogProvisioningDetails", cdk.requiredValidator)(properties.serviceCatalogProvisioningDetails)), errors.collect(cdk.propertyValidator("serviceCatalogProvisioningDetails", cdk.validateObject)(properties.serviceCatalogProvisioningDetails)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnProjectProps"');
    }
    function cfnProjectPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProjectPropsValidator(properties).assertSuccess(), { ProjectName: cdk.stringToCloudFormation(properties.projectName), ServiceCatalogProvisioningDetails: cdk.objectToCloudFormation(properties.serviceCatalogProvisioningDetails), ProjectDescription: cdk.stringToCloudFormation(properties.projectDescription), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnProjectPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("projectName", "ProjectName", cfn_parse.FromCloudFormation.getString(properties.ProjectName)), ret.addPropertyResult("serviceCatalogProvisioningDetails", "ServiceCatalogProvisioningDetails", cfn_parse.FromCloudFormation.getAny(properties.ServiceCatalogProvisioningDetails)), ret.addPropertyResult("projectDescription", "ProjectDescription", properties.ProjectDescription != null ? cfn_parse.FromCloudFormation.getString(properties.ProjectDescription) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnProject = class _CfnProject extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnProjectPropsFromCloudFormation(resourceProperties), ret = new _CfnProject(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnProject.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sagemaker_CfnProjectProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnProject), error;
        }
        cdk.requireProperty(props, "projectName", this), cdk.requireProperty(props, "serviceCatalogProvisioningDetails", this), this.attrCreationTime = cdk.Token.asString(this.getAtt("CreationTime", cdk.ResolutionTypeHint.STRING)), this.attrProjectArn = cdk.Token.asString(this.getAtt("ProjectArn", cdk.ResolutionTypeHint.STRING)), this.attrProjectId = cdk.Token.asString(this.getAtt("ProjectId", cdk.ResolutionTypeHint.STRING)), this.attrProjectStatus = cdk.Token.asString(this.getAtt("ProjectStatus", cdk.ResolutionTypeHint.STRING)), this.attrServiceCatalogProvisionedProductDetailsProvisionedProductId = cdk.Token.asString(this.getAtt("ServiceCatalogProvisionedProductDetails.ProvisionedProductId", cdk.ResolutionTypeHint.STRING)), this.attrServiceCatalogProvisionedProductDetailsProvisionedProductStatusMessage = cdk.Token.asString(this.getAtt("ServiceCatalogProvisionedProductDetails.ProvisionedProductStatusMessage", cdk.ResolutionTypeHint.STRING)), this.projectName = props.projectName, this.serviceCatalogProvisioningDetails = props.serviceCatalogProvisioningDetails, this.projectDescription = props.projectDescription, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SageMaker::Project", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnProject.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { projectName: this.projectName, serviceCatalogProvisioningDetails: this.serviceCatalogProvisioningDetails, projectDescription: this.projectDescription, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnProjectPropsToCloudFormation(props);
      }
    };
    _0 = JSII_RTTI_SYMBOL_1, CfnProject[_0] = { fqn: "aws-cdk-lib.aws_sagemaker.CfnProject", version: "2.80.0" }, CfnProject.CFN_RESOURCE_TYPE_NAME = "AWS::SageMaker::Project", exports2.CfnProject = CfnProject;
    function CfnSpacePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("domainId", cdk.requiredValidator)(properties.domainId)), errors.collect(cdk.propertyValidator("domainId", cdk.validateString)(properties.domainId)), errors.collect(cdk.propertyValidator("spaceName", cdk.requiredValidator)(properties.spaceName)), errors.collect(cdk.propertyValidator("spaceName", cdk.validateString)(properties.spaceName)), errors.collect(cdk.propertyValidator("spaceSettings", CfnSpace_SpaceSettingsPropertyValidator)(properties.spaceSettings)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnSpaceProps"');
    }
    function cfnSpacePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpacePropsValidator(properties).assertSuccess(), { DomainId: cdk.stringToCloudFormation(properties.domainId), SpaceName: cdk.stringToCloudFormation(properties.spaceName), SpaceSettings: cfnSpaceSpaceSettingsPropertyToCloudFormation(properties.spaceSettings), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnSpacePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("domainId", "DomainId", cfn_parse.FromCloudFormation.getString(properties.DomainId)), ret.addPropertyResult("spaceName", "SpaceName", cfn_parse.FromCloudFormation.getString(properties.SpaceName)), ret.addPropertyResult("spaceSettings", "SpaceSettings", properties.SpaceSettings != null ? CfnSpaceSpaceSettingsPropertyFromCloudFormation(properties.SpaceSettings) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSpace = class _CfnSpace extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSpacePropsFromCloudFormation(resourceProperties), ret = new _CfnSpace(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSpace.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sagemaker_CfnSpaceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSpace), error;
        }
        cdk.requireProperty(props, "domainId", this), cdk.requireProperty(props, "spaceName", this), this.attrSpaceArn = cdk.Token.asString(this.getAtt("SpaceArn", cdk.ResolutionTypeHint.STRING)), this.domainId = props.domainId, this.spaceName = props.spaceName, this.spaceSettings = props.spaceSettings, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SageMaker::Space", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSpace.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { domainId: this.domainId, spaceName: this.spaceName, spaceSettings: this.spaceSettings, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnSpacePropsToCloudFormation(props);
      }
    };
    _1 = JSII_RTTI_SYMBOL_1, CfnSpace[_1] = { fqn: "aws-cdk-lib.aws_sagemaker.CfnSpace", version: "2.80.0" }, CfnSpace.CFN_RESOURCE_TYPE_NAME = "AWS::SageMaker::Space", exports2.CfnSpace = CfnSpace;
    function CfnSpace_CustomImagePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("appImageConfigName", cdk.requiredValidator)(properties.appImageConfigName)), errors.collect(cdk.propertyValidator("appImageConfigName", cdk.validateString)(properties.appImageConfigName)), errors.collect(cdk.propertyValidator("imageName", cdk.requiredValidator)(properties.imageName)), errors.collect(cdk.propertyValidator("imageName", cdk.validateString)(properties.imageName)), errors.collect(cdk.propertyValidator("imageVersionNumber", cdk.validateNumber)(properties.imageVersionNumber)), errors.wrap('supplied properties not correct for "CustomImageProperty"');
    }
    function cfnSpaceCustomImagePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpace_CustomImagePropertyValidator(properties).assertSuccess(), { AppImageConfigName: cdk.stringToCloudFormation(properties.appImageConfigName), ImageName: cdk.stringToCloudFormation(properties.imageName), ImageVersionNumber: cdk.numberToCloudFormation(properties.imageVersionNumber) }) : properties;
    }
    function CfnSpaceCustomImagePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("appImageConfigName", "AppImageConfigName", cfn_parse.FromCloudFormation.getString(properties.AppImageConfigName)), ret.addPropertyResult("imageName", "ImageName", cfn_parse.FromCloudFormation.getString(properties.ImageName)), ret.addPropertyResult("imageVersionNumber", "ImageVersionNumber", properties.ImageVersionNumber != null ? cfn_parse.FromCloudFormation.getNumber(properties.ImageVersionNumber) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpace_JupyterServerAppSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultResourceSpec", CfnSpace_ResourceSpecPropertyValidator)(properties.defaultResourceSpec)), errors.wrap('supplied properties not correct for "JupyterServerAppSettingsProperty"');
    }
    function cfnSpaceJupyterServerAppSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpace_JupyterServerAppSettingsPropertyValidator(properties).assertSuccess(), { DefaultResourceSpec: cfnSpaceResourceSpecPropertyToCloudFormation(properties.defaultResourceSpec) }) : properties;
    }
    function CfnSpaceJupyterServerAppSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultResourceSpec", "DefaultResourceSpec", properties.DefaultResourceSpec != null ? CfnSpaceResourceSpecPropertyFromCloudFormation(properties.DefaultResourceSpec) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpace_KernelGatewayAppSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customImages", cdk.listValidator(CfnSpace_CustomImagePropertyValidator))(properties.customImages)), errors.collect(cdk.propertyValidator("defaultResourceSpec", CfnSpace_ResourceSpecPropertyValidator)(properties.defaultResourceSpec)), errors.wrap('supplied properties not correct for "KernelGatewayAppSettingsProperty"');
    }
    function cfnSpaceKernelGatewayAppSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpace_KernelGatewayAppSettingsPropertyValidator(properties).assertSuccess(), { CustomImages: cdk.listMapper(cfnSpaceCustomImagePropertyToCloudFormation)(properties.customImages), DefaultResourceSpec: cfnSpaceResourceSpecPropertyToCloudFormation(properties.defaultResourceSpec) }) : properties;
    }
    function CfnSpaceKernelGatewayAppSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customImages", "CustomImages", properties.CustomImages != null ? cfn_parse.FromCloudFormation.getArray(CfnSpaceCustomImagePropertyFromCloudFormation)(properties.CustomImages) : void 0), ret.addPropertyResult("defaultResourceSpec", "DefaultResourceSpec", properties.DefaultResourceSpec != null ? CfnSpaceResourceSpecPropertyFromCloudFormation(properties.DefaultResourceSpec) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpace_ResourceSpecPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("sageMakerImageArn", cdk.validateString)(properties.sageMakerImageArn)), errors.collect(cdk.propertyValidator("sageMakerImageVersionArn", cdk.validateString)(properties.sageMakerImageVersionArn)), errors.wrap('supplied properties not correct for "ResourceSpecProperty"');
    }
    function cfnSpaceResourceSpecPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpace_ResourceSpecPropertyValidator(properties).assertSuccess(), { InstanceType: cdk.stringToCloudFormation(properties.instanceType), SageMakerImageArn: cdk.stringToCloudFormation(properties.sageMakerImageArn), SageMakerImageVersionArn: cdk.stringToCloudFormation(properties.sageMakerImageVersionArn) }) : properties;
    }
    function CfnSpaceResourceSpecPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceType", "InstanceType", properties.InstanceType != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceType) : void 0), ret.addPropertyResult("sageMakerImageArn", "SageMakerImageArn", properties.SageMakerImageArn != null ? cfn_parse.FromCloudFormation.getString(properties.SageMakerImageArn) : void 0), ret.addPropertyResult("sageMakerImageVersionArn", "SageMakerImageVersionArn", properties.SageMakerImageVersionArn != null ? cfn_parse.FromCloudFormation.getString(properties.SageMakerImageVersionArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSpace_SpaceSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("jupyterServerAppSettings", CfnSpace_JupyterServerAppSettingsPropertyValidator)(properties.jupyterServerAppSettings)), errors.collect(cdk.propertyValidator("kernelGatewayAppSettings", CfnSpace_KernelGatewayAppSettingsPropertyValidator)(properties.kernelGatewayAppSettings)), errors.wrap('supplied properties not correct for "SpaceSettingsProperty"');
    }
    function cfnSpaceSpaceSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSpace_SpaceSettingsPropertyValidator(properties).assertSuccess(), { JupyterServerAppSettings: cfnSpaceJupyterServerAppSettingsPropertyToCloudFormation(properties.jupyterServerAppSettings), KernelGatewayAppSettings: cfnSpaceKernelGatewayAppSettingsPropertyToCloudFormation(properties.kernelGatewayAppSettings) }) : properties;
    }
    function CfnSpaceSpaceSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("jupyterServerAppSettings", "JupyterServerAppSettings", properties.JupyterServerAppSettings != null ? CfnSpaceJupyterServerAppSettingsPropertyFromCloudFormation(properties.JupyterServerAppSettings) : void 0), ret.addPropertyResult("kernelGatewayAppSettings", "KernelGatewayAppSettings", properties.KernelGatewayAppSettings != null ? CfnSpaceKernelGatewayAppSettingsPropertyFromCloudFormation(properties.KernelGatewayAppSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserProfilePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("domainId", cdk.requiredValidator)(properties.domainId)), errors.collect(cdk.propertyValidator("domainId", cdk.validateString)(properties.domainId)), errors.collect(cdk.propertyValidator("singleSignOnUserIdentifier", cdk.validateString)(properties.singleSignOnUserIdentifier)), errors.collect(cdk.propertyValidator("singleSignOnUserValue", cdk.validateString)(properties.singleSignOnUserValue)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("userProfileName", cdk.requiredValidator)(properties.userProfileName)), errors.collect(cdk.propertyValidator("userProfileName", cdk.validateString)(properties.userProfileName)), errors.collect(cdk.propertyValidator("userSettings", CfnUserProfile_UserSettingsPropertyValidator)(properties.userSettings)), errors.wrap('supplied properties not correct for "CfnUserProfileProps"');
    }
    function cfnUserProfilePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserProfilePropsValidator(properties).assertSuccess(), { DomainId: cdk.stringToCloudFormation(properties.domainId), UserProfileName: cdk.stringToCloudFormation(properties.userProfileName), SingleSignOnUserIdentifier: cdk.stringToCloudFormation(properties.singleSignOnUserIdentifier), SingleSignOnUserValue: cdk.stringToCloudFormation(properties.singleSignOnUserValue), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), UserSettings: cfnUserProfileUserSettingsPropertyToCloudFormation(properties.userSettings) }) : properties;
    }
    function CfnUserProfilePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("domainId", "DomainId", cfn_parse.FromCloudFormation.getString(properties.DomainId)), ret.addPropertyResult("userProfileName", "UserProfileName", cfn_parse.FromCloudFormation.getString(properties.UserProfileName)), ret.addPropertyResult("singleSignOnUserIdentifier", "SingleSignOnUserIdentifier", properties.SingleSignOnUserIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.SingleSignOnUserIdentifier) : void 0), ret.addPropertyResult("singleSignOnUserValue", "SingleSignOnUserValue", properties.SingleSignOnUserValue != null ? cfn_parse.FromCloudFormation.getString(properties.SingleSignOnUserValue) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("userSettings", "UserSettings", properties.UserSettings != null ? CfnUserProfileUserSettingsPropertyFromCloudFormation(properties.UserSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnUserProfile = class _CfnUserProfile extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnUserProfilePropsFromCloudFormation(resourceProperties), ret = new _CfnUserProfile(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnUserProfile.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sagemaker_CfnUserProfileProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnUserProfile), error;
        }
        cdk.requireProperty(props, "domainId", this), cdk.requireProperty(props, "userProfileName", this), this.attrUserProfileArn = cdk.Token.asString(this.getAtt("UserProfileArn", cdk.ResolutionTypeHint.STRING)), this.domainId = props.domainId, this.userProfileName = props.userProfileName, this.singleSignOnUserIdentifier = props.singleSignOnUserIdentifier, this.singleSignOnUserValue = props.singleSignOnUserValue, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SageMaker::UserProfile", props.tags, { tagPropertyName: "tags" }), this.userSettings = props.userSettings;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnUserProfile.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { domainId: this.domainId, userProfileName: this.userProfileName, singleSignOnUserIdentifier: this.singleSignOnUserIdentifier, singleSignOnUserValue: this.singleSignOnUserValue, tags: this.tags.renderTags(), userSettings: this.userSettings };
      }
      renderProperties(props) {
        return cfnUserProfilePropsToCloudFormation(props);
      }
    };
    _2 = JSII_RTTI_SYMBOL_1, CfnUserProfile[_2] = { fqn: "aws-cdk-lib.aws_sagemaker.CfnUserProfile", version: "2.80.0" }, CfnUserProfile.CFN_RESOURCE_TYPE_NAME = "AWS::SageMaker::UserProfile", exports2.CfnUserProfile = CfnUserProfile;
    function CfnUserProfile_CustomImagePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("appImageConfigName", cdk.requiredValidator)(properties.appImageConfigName)), errors.collect(cdk.propertyValidator("appImageConfigName", cdk.validateString)(properties.appImageConfigName)), errors.collect(cdk.propertyValidator("imageName", cdk.requiredValidator)(properties.imageName)), errors.collect(cdk.propertyValidator("imageName", cdk.validateString)(properties.imageName)), errors.collect(cdk.propertyValidator("imageVersionNumber", cdk.validateNumber)(properties.imageVersionNumber)), errors.wrap('supplied properties not correct for "CustomImageProperty"');
    }
    function cfnUserProfileCustomImagePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserProfile_CustomImagePropertyValidator(properties).assertSuccess(), { AppImageConfigName: cdk.stringToCloudFormation(properties.appImageConfigName), ImageName: cdk.stringToCloudFormation(properties.imageName), ImageVersionNumber: cdk.numberToCloudFormation(properties.imageVersionNumber) }) : properties;
    }
    function CfnUserProfileCustomImagePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("appImageConfigName", "AppImageConfigName", cfn_parse.FromCloudFormation.getString(properties.AppImageConfigName)), ret.addPropertyResult("imageName", "ImageName", cfn_parse.FromCloudFormation.getString(properties.ImageName)), ret.addPropertyResult("imageVersionNumber", "ImageVersionNumber", properties.ImageVersionNumber != null ? cfn_parse.FromCloudFormation.getNumber(properties.ImageVersionNumber) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserProfile_JupyterServerAppSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultResourceSpec", CfnUserProfile_ResourceSpecPropertyValidator)(properties.defaultResourceSpec)), errors.wrap('supplied properties not correct for "JupyterServerAppSettingsProperty"');
    }
    function cfnUserProfileJupyterServerAppSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserProfile_JupyterServerAppSettingsPropertyValidator(properties).assertSuccess(), { DefaultResourceSpec: cfnUserProfileResourceSpecPropertyToCloudFormation(properties.defaultResourceSpec) }) : properties;
    }
    function CfnUserProfileJupyterServerAppSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultResourceSpec", "DefaultResourceSpec", properties.DefaultResourceSpec != null ? CfnUserProfileResourceSpecPropertyFromCloudFormation(properties.DefaultResourceSpec) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserProfile_KernelGatewayAppSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customImages", cdk.listValidator(CfnUserProfile_CustomImagePropertyValidator))(properties.customImages)), errors.collect(cdk.propertyValidator("defaultResourceSpec", CfnUserProfile_ResourceSpecPropertyValidator)(properties.defaultResourceSpec)), errors.wrap('supplied properties not correct for "KernelGatewayAppSettingsProperty"');
    }
    function cfnUserProfileKernelGatewayAppSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserProfile_KernelGatewayAppSettingsPropertyValidator(properties).assertSuccess(), { CustomImages: cdk.listMapper(cfnUserProfileCustomImagePropertyToCloudFormation)(properties.customImages), DefaultResourceSpec: cfnUserProfileResourceSpecPropertyToCloudFormation(properties.defaultResourceSpec) }) : properties;
    }
    function CfnUserProfileKernelGatewayAppSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customImages", "CustomImages", properties.CustomImages != null ? cfn_parse.FromCloudFormation.getArray(CfnUserProfileCustomImagePropertyFromCloudFormation)(properties.CustomImages) : void 0), ret.addPropertyResult("defaultResourceSpec", "DefaultResourceSpec", properties.DefaultResourceSpec != null ? CfnUserProfileResourceSpecPropertyFromCloudFormation(properties.DefaultResourceSpec) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserProfile_RStudioServerProAppSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessStatus", cdk.validateString)(properties.accessStatus)), errors.collect(cdk.propertyValidator("userGroup", cdk.validateString)(properties.userGroup)), errors.wrap('supplied properties not correct for "RStudioServerProAppSettingsProperty"');
    }
    function cfnUserProfileRStudioServerProAppSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserProfile_RStudioServerProAppSettingsPropertyValidator(properties).assertSuccess(), { AccessStatus: cdk.stringToCloudFormation(properties.accessStatus), UserGroup: cdk.stringToCloudFormation(properties.userGroup) }) : properties;
    }
    function CfnUserProfileRStudioServerProAppSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessStatus", "AccessStatus", properties.AccessStatus != null ? cfn_parse.FromCloudFormation.getString(properties.AccessStatus) : void 0), ret.addPropertyResult("userGroup", "UserGroup", properties.UserGroup != null ? cfn_parse.FromCloudFormation.getString(properties.UserGroup) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserProfile_ResourceSpecPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceType", cdk.validateString)(properties.instanceType)), errors.collect(cdk.propertyValidator("sageMakerImageArn", cdk.validateString)(properties.sageMakerImageArn)), errors.collect(cdk.propertyValidator("sageMakerImageVersionArn", cdk.validateString)(properties.sageMakerImageVersionArn)), errors.wrap('supplied properties not correct for "ResourceSpecProperty"');
    }
    function cfnUserProfileResourceSpecPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserProfile_ResourceSpecPropertyValidator(properties).assertSuccess(), { InstanceType: cdk.stringToCloudFormation(properties.instanceType), SageMakerImageArn: cdk.stringToCloudFormation(properties.sageMakerImageArn), SageMakerImageVersionArn: cdk.stringToCloudFormation(properties.sageMakerImageVersionArn) }) : properties;
    }
    function CfnUserProfileResourceSpecPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceType", "InstanceType", properties.InstanceType != null ? cfn_parse.FromCloudFormation.getString(properties.InstanceType) : void 0), ret.addPropertyResult("sageMakerImageArn", "SageMakerImageArn", properties.SageMakerImageArn != null ? cfn_parse.FromCloudFormation.getString(properties.SageMakerImageArn) : void 0), ret.addPropertyResult("sageMakerImageVersionArn", "SageMakerImageVersionArn", properties.SageMakerImageVersionArn != null ? cfn_parse.FromCloudFormation.getString(properties.SageMakerImageVersionArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserProfile_SharingSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("notebookOutputOption", cdk.validateString)(properties.notebookOutputOption)), errors.collect(cdk.propertyValidator("s3KmsKeyId", cdk.validateString)(properties.s3KmsKeyId)), errors.collect(cdk.propertyValidator("s3OutputPath", cdk.validateString)(properties.s3OutputPath)), errors.wrap('supplied properties not correct for "SharingSettingsProperty"');
    }
    function cfnUserProfileSharingSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserProfile_SharingSettingsPropertyValidator(properties).assertSuccess(), { NotebookOutputOption: cdk.stringToCloudFormation(properties.notebookOutputOption), S3KmsKeyId: cdk.stringToCloudFormation(properties.s3KmsKeyId), S3OutputPath: cdk.stringToCloudFormation(properties.s3OutputPath) }) : properties;
    }
    function CfnUserProfileSharingSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("notebookOutputOption", "NotebookOutputOption", properties.NotebookOutputOption != null ? cfn_parse.FromCloudFormation.getString(properties.NotebookOutputOption) : void 0), ret.addPropertyResult("s3KmsKeyId", "S3KmsKeyId", properties.S3KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.S3KmsKeyId) : void 0), ret.addPropertyResult("s3OutputPath", "S3OutputPath", properties.S3OutputPath != null ? cfn_parse.FromCloudFormation.getString(properties.S3OutputPath) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserProfile_UserSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("executionRole", cdk.validateString)(properties.executionRole)), errors.collect(cdk.propertyValidator("jupyterServerAppSettings", CfnUserProfile_JupyterServerAppSettingsPropertyValidator)(properties.jupyterServerAppSettings)), errors.collect(cdk.propertyValidator("kernelGatewayAppSettings", CfnUserProfile_KernelGatewayAppSettingsPropertyValidator)(properties.kernelGatewayAppSettings)), errors.collect(cdk.propertyValidator("rStudioServerProAppSettings", CfnUserProfile_RStudioServerProAppSettingsPropertyValidator)(properties.rStudioServerProAppSettings)), errors.collect(cdk.propertyValidator("securityGroups", cdk.listValidator(cdk.validateString))(properties.securityGroups)), errors.collect(cdk.propertyValidator("sharingSettings", CfnUserProfile_SharingSettingsPropertyValidator)(properties.sharingSettings)), errors.wrap('supplied properties not correct for "UserSettingsProperty"');
    }
    function cfnUserProfileUserSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserProfile_UserSettingsPropertyValidator(properties).assertSuccess(), { ExecutionRole: cdk.stringToCloudFormation(properties.executionRole), JupyterServerAppSettings: cfnUserProfileJupyterServerAppSettingsPropertyToCloudFormation(properties.jupyterServerAppSettings), KernelGatewayAppSettings: cfnUserProfileKernelGatewayAppSettingsPropertyToCloudFormation(properties.kernelGatewayAppSettings), RStudioServerProAppSettings: cfnUserProfileRStudioServerProAppSettingsPropertyToCloudFormation(properties.rStudioServerProAppSettings), SecurityGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroups), SharingSettings: cfnUserProfileSharingSettingsPropertyToCloudFormation(properties.sharingSettings) }) : properties;
    }
    function CfnUserProfileUserSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("executionRole", "ExecutionRole", properties.ExecutionRole != null ? cfn_parse.FromCloudFormation.getString(properties.ExecutionRole) : void 0), ret.addPropertyResult("jupyterServerAppSettings", "JupyterServerAppSettings", properties.JupyterServerAppSettings != null ? CfnUserProfileJupyterServerAppSettingsPropertyFromCloudFormation(properties.JupyterServerAppSettings) : void 0), ret.addPropertyResult("kernelGatewayAppSettings", "KernelGatewayAppSettings", properties.KernelGatewayAppSettings != null ? CfnUserProfileKernelGatewayAppSettingsPropertyFromCloudFormation(properties.KernelGatewayAppSettings) : void 0), ret.addPropertyResult("rStudioServerProAppSettings", "RStudioServerProAppSettings", properties.RStudioServerProAppSettings != null ? CfnUserProfileRStudioServerProAppSettingsPropertyFromCloudFormation(properties.RStudioServerProAppSettings) : void 0), ret.addPropertyResult("securityGroups", "SecurityGroups", properties.SecurityGroups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroups) : void 0), ret.addPropertyResult("sharingSettings", "SharingSettings", properties.SharingSettings != null ? CfnUserProfileSharingSettingsPropertyFromCloudFormation(properties.SharingSettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWorkteamPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("memberDefinitions", cdk.listValidator(CfnWorkteam_MemberDefinitionPropertyValidator))(properties.memberDefinitions)), errors.collect(cdk.propertyValidator("notificationConfiguration", CfnWorkteam_NotificationConfigurationPropertyValidator)(properties.notificationConfiguration)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("workforceName", cdk.validateString)(properties.workforceName)), errors.collect(cdk.propertyValidator("workteamName", cdk.validateString)(properties.workteamName)), errors.wrap('supplied properties not correct for "CfnWorkteamProps"');
    }
    function cfnWorkteamPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkteamPropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), MemberDefinitions: cdk.listMapper(cfnWorkteamMemberDefinitionPropertyToCloudFormation)(properties.memberDefinitions), NotificationConfiguration: cfnWorkteamNotificationConfigurationPropertyToCloudFormation(properties.notificationConfiguration), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), WorkforceName: cdk.stringToCloudFormation(properties.workforceName), WorkteamName: cdk.stringToCloudFormation(properties.workteamName) }) : properties;
    }
    function CfnWorkteamPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("memberDefinitions", "MemberDefinitions", properties.MemberDefinitions != null ? cfn_parse.FromCloudFormation.getArray(CfnWorkteamMemberDefinitionPropertyFromCloudFormation)(properties.MemberDefinitions) : void 0), ret.addPropertyResult("notificationConfiguration", "NotificationConfiguration", properties.NotificationConfiguration != null ? CfnWorkteamNotificationConfigurationPropertyFromCloudFormation(properties.NotificationConfiguration) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("workforceName", "WorkforceName", properties.WorkforceName != null ? cfn_parse.FromCloudFormation.getString(properties.WorkforceName) : void 0), ret.addPropertyResult("workteamName", "WorkteamName", properties.WorkteamName != null ? cfn_parse.FromCloudFormation.getString(properties.WorkteamName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnWorkteam = class _CfnWorkteam extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnWorkteamPropsFromCloudFormation(resourceProperties), ret = new _CfnWorkteam(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnWorkteam.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sagemaker_CfnWorkteamProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnWorkteam), error;
        }
        this.attrWorkteamName = cdk.Token.asString(this.getAtt("WorkteamName", cdk.ResolutionTypeHint.STRING)), this.description = props.description, this.memberDefinitions = props.memberDefinitions, this.notificationConfiguration = props.notificationConfiguration, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SageMaker::Workteam", props.tags, { tagPropertyName: "tags" }), this.workforceName = props.workforceName, this.workteamName = props.workteamName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnWorkteam.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description, memberDefinitions: this.memberDefinitions, notificationConfiguration: this.notificationConfiguration, tags: this.tags.renderTags(), workforceName: this.workforceName, workteamName: this.workteamName };
      }
      renderProperties(props) {
        return cfnWorkteamPropsToCloudFormation(props);
      }
    };
    _3 = JSII_RTTI_SYMBOL_1, CfnWorkteam[_3] = { fqn: "aws-cdk-lib.aws_sagemaker.CfnWorkteam", version: "2.80.0" }, CfnWorkteam.CFN_RESOURCE_TYPE_NAME = "AWS::SageMaker::Workteam", exports2.CfnWorkteam = CfnWorkteam;
    function CfnWorkteam_CognitoMemberDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cognitoClientId", cdk.requiredValidator)(properties.cognitoClientId)), errors.collect(cdk.propertyValidator("cognitoClientId", cdk.validateString)(properties.cognitoClientId)), errors.collect(cdk.propertyValidator("cognitoUserGroup", cdk.requiredValidator)(properties.cognitoUserGroup)), errors.collect(cdk.propertyValidator("cognitoUserGroup", cdk.validateString)(properties.cognitoUserGroup)), errors.collect(cdk.propertyValidator("cognitoUserPool", cdk.requiredValidator)(properties.cognitoUserPool)), errors.collect(cdk.propertyValidator("cognitoUserPool", cdk.validateString)(properties.cognitoUserPool)), errors.wrap('supplied properties not correct for "CognitoMemberDefinitionProperty"');
    }
    function cfnWorkteamCognitoMemberDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkteam_CognitoMemberDefinitionPropertyValidator(properties).assertSuccess(), { CognitoClientId: cdk.stringToCloudFormation(properties.cognitoClientId), CognitoUserGroup: cdk.stringToCloudFormation(properties.cognitoUserGroup), CognitoUserPool: cdk.stringToCloudFormation(properties.cognitoUserPool) }) : properties;
    }
    function CfnWorkteamCognitoMemberDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cognitoClientId", "CognitoClientId", cfn_parse.FromCloudFormation.getString(properties.CognitoClientId)), ret.addPropertyResult("cognitoUserGroup", "CognitoUserGroup", cfn_parse.FromCloudFormation.getString(properties.CognitoUserGroup)), ret.addPropertyResult("cognitoUserPool", "CognitoUserPool", cfn_parse.FromCloudFormation.getString(properties.CognitoUserPool)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWorkteam_MemberDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cognitoMemberDefinition", CfnWorkteam_CognitoMemberDefinitionPropertyValidator)(properties.cognitoMemberDefinition)), errors.collect(cdk.propertyValidator("oidcMemberDefinition", CfnWorkteam_OidcMemberDefinitionPropertyValidator)(properties.oidcMemberDefinition)), errors.wrap('supplied properties not correct for "MemberDefinitionProperty"');
    }
    function cfnWorkteamMemberDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkteam_MemberDefinitionPropertyValidator(properties).assertSuccess(), { CognitoMemberDefinition: cfnWorkteamCognitoMemberDefinitionPropertyToCloudFormation(properties.cognitoMemberDefinition), OidcMemberDefinition: cfnWorkteamOidcMemberDefinitionPropertyToCloudFormation(properties.oidcMemberDefinition) }) : properties;
    }
    function CfnWorkteamMemberDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cognitoMemberDefinition", "CognitoMemberDefinition", properties.CognitoMemberDefinition != null ? CfnWorkteamCognitoMemberDefinitionPropertyFromCloudFormation(properties.CognitoMemberDefinition) : void 0), ret.addPropertyResult("oidcMemberDefinition", "OidcMemberDefinition", properties.OidcMemberDefinition != null ? CfnWorkteamOidcMemberDefinitionPropertyFromCloudFormation(properties.OidcMemberDefinition) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWorkteam_NotificationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("notificationTopicArn", cdk.requiredValidator)(properties.notificationTopicArn)), errors.collect(cdk.propertyValidator("notificationTopicArn", cdk.validateString)(properties.notificationTopicArn)), errors.wrap('supplied properties not correct for "NotificationConfigurationProperty"');
    }
    function cfnWorkteamNotificationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkteam_NotificationConfigurationPropertyValidator(properties).assertSuccess(), { NotificationTopicArn: cdk.stringToCloudFormation(properties.notificationTopicArn) }) : properties;
    }
    function CfnWorkteamNotificationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("notificationTopicArn", "NotificationTopicArn", cfn_parse.FromCloudFormation.getString(properties.NotificationTopicArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWorkteam_OidcMemberDefinitionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("oidcGroups", cdk.requiredValidator)(properties.oidcGroups)), errors.collect(cdk.propertyValidator("oidcGroups", cdk.listValidator(cdk.validateString))(properties.oidcGroups)), errors.wrap('supplied properties not correct for "OidcMemberDefinitionProperty"');
    }
    function cfnWorkteamOidcMemberDefinitionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkteam_OidcMemberDefinitionPropertyValidator(properties).assertSuccess(), { OidcGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.oidcGroups) }) : properties;
    }
    function CfnWorkteamOidcMemberDefinitionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("oidcGroups", "OidcGroups", cfn_parse.FromCloudFormation.getStringArray(properties.OidcGroups)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-sagemaker/lib/index.js
var require_lib233 = __commonJS({
  "node_modules/aws-cdk-lib/aws-sagemaker/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_sagemaker_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-sagemaker/index.js
var require_aws_sagemaker = __commonJS({
  "node_modules/aws-cdk-lib/aws-sagemaker/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib233(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-scheduler/lib/scheduler.generated.js
var require_scheduler_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-scheduler/lib/scheduler.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnScheduleGroup = exports2.CfnSchedule = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnSchedulePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("endDate", cdk.validateString)(properties.endDate)), errors.collect(cdk.propertyValidator("flexibleTimeWindow", cdk.requiredValidator)(properties.flexibleTimeWindow)), errors.collect(cdk.propertyValidator("flexibleTimeWindow", CfnSchedule_FlexibleTimeWindowPropertyValidator)(properties.flexibleTimeWindow)), errors.collect(cdk.propertyValidator("groupName", cdk.validateString)(properties.groupName)), errors.collect(cdk.propertyValidator("kmsKeyArn", cdk.validateString)(properties.kmsKeyArn)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("scheduleExpression", cdk.requiredValidator)(properties.scheduleExpression)), errors.collect(cdk.propertyValidator("scheduleExpression", cdk.validateString)(properties.scheduleExpression)), errors.collect(cdk.propertyValidator("scheduleExpressionTimezone", cdk.validateString)(properties.scheduleExpressionTimezone)), errors.collect(cdk.propertyValidator("startDate", cdk.validateString)(properties.startDate)), errors.collect(cdk.propertyValidator("state", cdk.validateString)(properties.state)), errors.collect(cdk.propertyValidator("target", cdk.requiredValidator)(properties.target)), errors.collect(cdk.propertyValidator("target", CfnSchedule_TargetPropertyValidator)(properties.target)), errors.wrap('supplied properties not correct for "CfnScheduleProps"');
    }
    function cfnSchedulePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSchedulePropsValidator(properties).assertSuccess(), { FlexibleTimeWindow: cfnScheduleFlexibleTimeWindowPropertyToCloudFormation(properties.flexibleTimeWindow), ScheduleExpression: cdk.stringToCloudFormation(properties.scheduleExpression), Target: cfnScheduleTargetPropertyToCloudFormation(properties.target), Description: cdk.stringToCloudFormation(properties.description), EndDate: cdk.stringToCloudFormation(properties.endDate), GroupName: cdk.stringToCloudFormation(properties.groupName), KmsKeyArn: cdk.stringToCloudFormation(properties.kmsKeyArn), Name: cdk.stringToCloudFormation(properties.name), ScheduleExpressionTimezone: cdk.stringToCloudFormation(properties.scheduleExpressionTimezone), StartDate: cdk.stringToCloudFormation(properties.startDate), State: cdk.stringToCloudFormation(properties.state) }) : properties;
    }
    function CfnSchedulePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("flexibleTimeWindow", "FlexibleTimeWindow", CfnScheduleFlexibleTimeWindowPropertyFromCloudFormation(properties.FlexibleTimeWindow)), ret.addPropertyResult("scheduleExpression", "ScheduleExpression", cfn_parse.FromCloudFormation.getString(properties.ScheduleExpression)), ret.addPropertyResult("target", "Target", CfnScheduleTargetPropertyFromCloudFormation(properties.Target)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("endDate", "EndDate", properties.EndDate != null ? cfn_parse.FromCloudFormation.getString(properties.EndDate) : void 0), ret.addPropertyResult("groupName", "GroupName", properties.GroupName != null ? cfn_parse.FromCloudFormation.getString(properties.GroupName) : void 0), ret.addPropertyResult("kmsKeyArn", "KmsKeyArn", properties.KmsKeyArn != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyArn) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("scheduleExpressionTimezone", "ScheduleExpressionTimezone", properties.ScheduleExpressionTimezone != null ? cfn_parse.FromCloudFormation.getString(properties.ScheduleExpressionTimezone) : void 0), ret.addPropertyResult("startDate", "StartDate", properties.StartDate != null ? cfn_parse.FromCloudFormation.getString(properties.StartDate) : void 0), ret.addPropertyResult("state", "State", properties.State != null ? cfn_parse.FromCloudFormation.getString(properties.State) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSchedule = class _CfnSchedule extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSchedulePropsFromCloudFormation(resourceProperties), ret = new _CfnSchedule(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSchedule.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_scheduler_CfnScheduleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSchedule), error;
        }
        cdk.requireProperty(props, "flexibleTimeWindow", this), cdk.requireProperty(props, "scheduleExpression", this), cdk.requireProperty(props, "target", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.flexibleTimeWindow = props.flexibleTimeWindow, this.scheduleExpression = props.scheduleExpression, this.target = props.target, this.description = props.description, this.endDate = props.endDate, this.groupName = props.groupName, this.kmsKeyArn = props.kmsKeyArn, this.name = props.name, this.scheduleExpressionTimezone = props.scheduleExpressionTimezone, this.startDate = props.startDate, this.state = props.state;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSchedule.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { flexibleTimeWindow: this.flexibleTimeWindow, scheduleExpression: this.scheduleExpression, target: this.target, description: this.description, endDate: this.endDate, groupName: this.groupName, kmsKeyArn: this.kmsKeyArn, name: this.name, scheduleExpressionTimezone: this.scheduleExpressionTimezone, startDate: this.startDate, state: this.state };
      }
      renderProperties(props) {
        return cfnSchedulePropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnSchedule[_a] = { fqn: "aws-cdk-lib.aws_scheduler.CfnSchedule", version: "2.80.0" }, CfnSchedule.CFN_RESOURCE_TYPE_NAME = "AWS::Scheduler::Schedule", exports2.CfnSchedule = CfnSchedule;
    function CfnSchedule_AwsVpcConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("assignPublicIp", cdk.validateString)(properties.assignPublicIp)), errors.collect(cdk.propertyValidator("securityGroups", cdk.listValidator(cdk.validateString))(properties.securityGroups)), errors.collect(cdk.propertyValidator("subnets", cdk.requiredValidator)(properties.subnets)), errors.collect(cdk.propertyValidator("subnets", cdk.listValidator(cdk.validateString))(properties.subnets)), errors.wrap('supplied properties not correct for "AwsVpcConfigurationProperty"');
    }
    function cfnScheduleAwsVpcConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSchedule_AwsVpcConfigurationPropertyValidator(properties).assertSuccess(), { AssignPublicIp: cdk.stringToCloudFormation(properties.assignPublicIp), SecurityGroups: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroups), Subnets: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnets) }) : properties;
    }
    function CfnScheduleAwsVpcConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("assignPublicIp", "AssignPublicIp", properties.AssignPublicIp != null ? cfn_parse.FromCloudFormation.getString(properties.AssignPublicIp) : void 0), ret.addPropertyResult("securityGroups", "SecurityGroups", properties.SecurityGroups != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroups) : void 0), ret.addPropertyResult("subnets", "Subnets", cfn_parse.FromCloudFormation.getStringArray(properties.Subnets)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSchedule_CapacityProviderStrategyItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("base", cdk.validateNumber)(properties.base)), errors.collect(cdk.propertyValidator("capacityProvider", cdk.requiredValidator)(properties.capacityProvider)), errors.collect(cdk.propertyValidator("capacityProvider", cdk.validateString)(properties.capacityProvider)), errors.collect(cdk.propertyValidator("weight", cdk.validateNumber)(properties.weight)), errors.wrap('supplied properties not correct for "CapacityProviderStrategyItemProperty"');
    }
    function cfnScheduleCapacityProviderStrategyItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSchedule_CapacityProviderStrategyItemPropertyValidator(properties).assertSuccess(), { Base: cdk.numberToCloudFormation(properties.base), CapacityProvider: cdk.stringToCloudFormation(properties.capacityProvider), Weight: cdk.numberToCloudFormation(properties.weight) }) : properties;
    }
    function CfnScheduleCapacityProviderStrategyItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("base", "Base", properties.Base != null ? cfn_parse.FromCloudFormation.getNumber(properties.Base) : void 0), ret.addPropertyResult("capacityProvider", "CapacityProvider", cfn_parse.FromCloudFormation.getString(properties.CapacityProvider)), ret.addPropertyResult("weight", "Weight", properties.Weight != null ? cfn_parse.FromCloudFormation.getNumber(properties.Weight) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSchedule_DeadLetterConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.wrap('supplied properties not correct for "DeadLetterConfigProperty"');
    }
    function cfnScheduleDeadLetterConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSchedule_DeadLetterConfigPropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn) }) : properties;
    }
    function CfnScheduleDeadLetterConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", properties.Arn != null ? cfn_parse.FromCloudFormation.getString(properties.Arn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSchedule_EcsParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("capacityProviderStrategy", cdk.listValidator(CfnSchedule_CapacityProviderStrategyItemPropertyValidator))(properties.capacityProviderStrategy)), errors.collect(cdk.propertyValidator("enableEcsManagedTags", cdk.validateBoolean)(properties.enableEcsManagedTags)), errors.collect(cdk.propertyValidator("enableExecuteCommand", cdk.validateBoolean)(properties.enableExecuteCommand)), errors.collect(cdk.propertyValidator("group", cdk.validateString)(properties.group)), errors.collect(cdk.propertyValidator("launchType", cdk.validateString)(properties.launchType)), errors.collect(cdk.propertyValidator("networkConfiguration", CfnSchedule_NetworkConfigurationPropertyValidator)(properties.networkConfiguration)), errors.collect(cdk.propertyValidator("placementConstraints", cdk.listValidator(CfnSchedule_PlacementConstraintPropertyValidator))(properties.placementConstraints)), errors.collect(cdk.propertyValidator("placementStrategy", cdk.listValidator(CfnSchedule_PlacementStrategyPropertyValidator))(properties.placementStrategy)), errors.collect(cdk.propertyValidator("platformVersion", cdk.validateString)(properties.platformVersion)), errors.collect(cdk.propertyValidator("propagateTags", cdk.validateString)(properties.propagateTags)), errors.collect(cdk.propertyValidator("referenceId", cdk.validateString)(properties.referenceId)), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.collect(cdk.propertyValidator("taskCount", cdk.validateNumber)(properties.taskCount)), errors.collect(cdk.propertyValidator("taskDefinitionArn", cdk.requiredValidator)(properties.taskDefinitionArn)), errors.collect(cdk.propertyValidator("taskDefinitionArn", cdk.validateString)(properties.taskDefinitionArn)), errors.wrap('supplied properties not correct for "EcsParametersProperty"');
    }
    function cfnScheduleEcsParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSchedule_EcsParametersPropertyValidator(properties).assertSuccess(), { CapacityProviderStrategy: cdk.listMapper(cfnScheduleCapacityProviderStrategyItemPropertyToCloudFormation)(properties.capacityProviderStrategy), EnableECSManagedTags: cdk.booleanToCloudFormation(properties.enableEcsManagedTags), EnableExecuteCommand: cdk.booleanToCloudFormation(properties.enableExecuteCommand), Group: cdk.stringToCloudFormation(properties.group), LaunchType: cdk.stringToCloudFormation(properties.launchType), NetworkConfiguration: cfnScheduleNetworkConfigurationPropertyToCloudFormation(properties.networkConfiguration), PlacementConstraints: cdk.listMapper(cfnSchedulePlacementConstraintPropertyToCloudFormation)(properties.placementConstraints), PlacementStrategy: cdk.listMapper(cfnSchedulePlacementStrategyPropertyToCloudFormation)(properties.placementStrategy), PlatformVersion: cdk.stringToCloudFormation(properties.platformVersion), PropagateTags: cdk.stringToCloudFormation(properties.propagateTags), ReferenceId: cdk.stringToCloudFormation(properties.referenceId), Tags: cdk.objectToCloudFormation(properties.tags), TaskCount: cdk.numberToCloudFormation(properties.taskCount), TaskDefinitionArn: cdk.stringToCloudFormation(properties.taskDefinitionArn) }) : properties;
    }
    function CfnScheduleEcsParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("capacityProviderStrategy", "CapacityProviderStrategy", properties.CapacityProviderStrategy != null ? cfn_parse.FromCloudFormation.getArray(CfnScheduleCapacityProviderStrategyItemPropertyFromCloudFormation)(properties.CapacityProviderStrategy) : void 0), ret.addPropertyResult("enableEcsManagedTags", "EnableECSManagedTags", properties.EnableECSManagedTags != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableECSManagedTags) : void 0), ret.addPropertyResult("enableExecuteCommand", "EnableExecuteCommand", properties.EnableExecuteCommand != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EnableExecuteCommand) : void 0), ret.addPropertyResult("group", "Group", properties.Group != null ? cfn_parse.FromCloudFormation.getString(properties.Group) : void 0), ret.addPropertyResult("launchType", "LaunchType", properties.LaunchType != null ? cfn_parse.FromCloudFormation.getString(properties.LaunchType) : void 0), ret.addPropertyResult("networkConfiguration", "NetworkConfiguration", properties.NetworkConfiguration != null ? CfnScheduleNetworkConfigurationPropertyFromCloudFormation(properties.NetworkConfiguration) : void 0), ret.addPropertyResult("placementConstraints", "PlacementConstraints", properties.PlacementConstraints != null ? cfn_parse.FromCloudFormation.getArray(CfnSchedulePlacementConstraintPropertyFromCloudFormation)(properties.PlacementConstraints) : void 0), ret.addPropertyResult("placementStrategy", "PlacementStrategy", properties.PlacementStrategy != null ? cfn_parse.FromCloudFormation.getArray(CfnSchedulePlacementStrategyPropertyFromCloudFormation)(properties.PlacementStrategy) : void 0), ret.addPropertyResult("platformVersion", "PlatformVersion", properties.PlatformVersion != null ? cfn_parse.FromCloudFormation.getString(properties.PlatformVersion) : void 0), ret.addPropertyResult("propagateTags", "PropagateTags", properties.PropagateTags != null ? cfn_parse.FromCloudFormation.getString(properties.PropagateTags) : void 0), ret.addPropertyResult("referenceId", "ReferenceId", properties.ReferenceId != null ? cfn_parse.FromCloudFormation.getString(properties.ReferenceId) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addPropertyResult("taskCount", "TaskCount", properties.TaskCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.TaskCount) : void 0), ret.addPropertyResult("taskDefinitionArn", "TaskDefinitionArn", cfn_parse.FromCloudFormation.getString(properties.TaskDefinitionArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSchedule_EventBridgeParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("detailType", cdk.requiredValidator)(properties.detailType)), errors.collect(cdk.propertyValidator("detailType", cdk.validateString)(properties.detailType)), errors.collect(cdk.propertyValidator("source", cdk.requiredValidator)(properties.source)), errors.collect(cdk.propertyValidator("source", cdk.validateString)(properties.source)), errors.wrap('supplied properties not correct for "EventBridgeParametersProperty"');
    }
    function cfnScheduleEventBridgeParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSchedule_EventBridgeParametersPropertyValidator(properties).assertSuccess(), { DetailType: cdk.stringToCloudFormation(properties.detailType), Source: cdk.stringToCloudFormation(properties.source) }) : properties;
    }
    function CfnScheduleEventBridgeParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("detailType", "DetailType", cfn_parse.FromCloudFormation.getString(properties.DetailType)), ret.addPropertyResult("source", "Source", cfn_parse.FromCloudFormation.getString(properties.Source)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSchedule_FlexibleTimeWindowPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maximumWindowInMinutes", cdk.validateNumber)(properties.maximumWindowInMinutes)), errors.collect(cdk.propertyValidator("mode", cdk.requiredValidator)(properties.mode)), errors.collect(cdk.propertyValidator("mode", cdk.validateString)(properties.mode)), errors.wrap('supplied properties not correct for "FlexibleTimeWindowProperty"');
    }
    function cfnScheduleFlexibleTimeWindowPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSchedule_FlexibleTimeWindowPropertyValidator(properties).assertSuccess(), { MaximumWindowInMinutes: cdk.numberToCloudFormation(properties.maximumWindowInMinutes), Mode: cdk.stringToCloudFormation(properties.mode) }) : properties;
    }
    function CfnScheduleFlexibleTimeWindowPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maximumWindowInMinutes", "MaximumWindowInMinutes", properties.MaximumWindowInMinutes != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumWindowInMinutes) : void 0), ret.addPropertyResult("mode", "Mode", cfn_parse.FromCloudFormation.getString(properties.Mode)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSchedule_KinesisParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("partitionKey", cdk.requiredValidator)(properties.partitionKey)), errors.collect(cdk.propertyValidator("partitionKey", cdk.validateString)(properties.partitionKey)), errors.wrap('supplied properties not correct for "KinesisParametersProperty"');
    }
    function cfnScheduleKinesisParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSchedule_KinesisParametersPropertyValidator(properties).assertSuccess(), { PartitionKey: cdk.stringToCloudFormation(properties.partitionKey) }) : properties;
    }
    function CfnScheduleKinesisParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("partitionKey", "PartitionKey", cfn_parse.FromCloudFormation.getString(properties.PartitionKey)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSchedule_NetworkConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("awsvpcConfiguration", CfnSchedule_AwsVpcConfigurationPropertyValidator)(properties.awsvpcConfiguration)), errors.wrap('supplied properties not correct for "NetworkConfigurationProperty"');
    }
    function cfnScheduleNetworkConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSchedule_NetworkConfigurationPropertyValidator(properties).assertSuccess(), { AwsvpcConfiguration: cfnScheduleAwsVpcConfigurationPropertyToCloudFormation(properties.awsvpcConfiguration) }) : properties;
    }
    function CfnScheduleNetworkConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("awsvpcConfiguration", "AwsvpcConfiguration", properties.AwsvpcConfiguration != null ? CfnScheduleAwsVpcConfigurationPropertyFromCloudFormation(properties.AwsvpcConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSchedule_PlacementConstraintPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "PlacementConstraintProperty"');
    }
    function cfnSchedulePlacementConstraintPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSchedule_PlacementConstraintPropertyValidator(properties).assertSuccess(), { Expression: cdk.stringToCloudFormation(properties.expression), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnSchedulePlacementConstraintPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("expression", "Expression", properties.Expression != null ? cfn_parse.FromCloudFormation.getString(properties.Expression) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSchedule_PlacementStrategyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("field", cdk.validateString)(properties.field)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "PlacementStrategyProperty"');
    }
    function cfnSchedulePlacementStrategyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSchedule_PlacementStrategyPropertyValidator(properties).assertSuccess(), { Field: cdk.stringToCloudFormation(properties.field), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnSchedulePlacementStrategyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("field", "Field", properties.Field != null ? cfn_parse.FromCloudFormation.getString(properties.Field) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSchedule_RetryPolicyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("maximumEventAgeInSeconds", cdk.validateNumber)(properties.maximumEventAgeInSeconds)), errors.collect(cdk.propertyValidator("maximumRetryAttempts", cdk.validateNumber)(properties.maximumRetryAttempts)), errors.wrap('supplied properties not correct for "RetryPolicyProperty"');
    }
    function cfnScheduleRetryPolicyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSchedule_RetryPolicyPropertyValidator(properties).assertSuccess(), { MaximumEventAgeInSeconds: cdk.numberToCloudFormation(properties.maximumEventAgeInSeconds), MaximumRetryAttempts: cdk.numberToCloudFormation(properties.maximumRetryAttempts) }) : properties;
    }
    function CfnScheduleRetryPolicyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("maximumEventAgeInSeconds", "MaximumEventAgeInSeconds", properties.MaximumEventAgeInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumEventAgeInSeconds) : void 0), ret.addPropertyResult("maximumRetryAttempts", "MaximumRetryAttempts", properties.MaximumRetryAttempts != null ? cfn_parse.FromCloudFormation.getNumber(properties.MaximumRetryAttempts) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSchedule_SageMakerPipelineParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "SageMakerPipelineParameterProperty"');
    }
    function cfnScheduleSageMakerPipelineParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSchedule_SageMakerPipelineParameterPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnScheduleSageMakerPipelineParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSchedule_SageMakerPipelineParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("pipelineParameterList", cdk.listValidator(CfnSchedule_SageMakerPipelineParameterPropertyValidator))(properties.pipelineParameterList)), errors.wrap('supplied properties not correct for "SageMakerPipelineParametersProperty"');
    }
    function cfnScheduleSageMakerPipelineParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSchedule_SageMakerPipelineParametersPropertyValidator(properties).assertSuccess(), { PipelineParameterList: cdk.listMapper(cfnScheduleSageMakerPipelineParameterPropertyToCloudFormation)(properties.pipelineParameterList) }) : properties;
    }
    function CfnScheduleSageMakerPipelineParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("pipelineParameterList", "PipelineParameterList", properties.PipelineParameterList != null ? cfn_parse.FromCloudFormation.getArray(CfnScheduleSageMakerPipelineParameterPropertyFromCloudFormation)(properties.PipelineParameterList) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSchedule_SqsParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("messageGroupId", cdk.validateString)(properties.messageGroupId)), errors.wrap('supplied properties not correct for "SqsParametersProperty"');
    }
    function cfnScheduleSqsParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSchedule_SqsParametersPropertyValidator(properties).assertSuccess(), { MessageGroupId: cdk.stringToCloudFormation(properties.messageGroupId) }) : properties;
    }
    function CfnScheduleSqsParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("messageGroupId", "MessageGroupId", properties.MessageGroupId != null ? cfn_parse.FromCloudFormation.getString(properties.MessageGroupId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSchedule_TargetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.requiredValidator)(properties.arn)), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("deadLetterConfig", CfnSchedule_DeadLetterConfigPropertyValidator)(properties.deadLetterConfig)), errors.collect(cdk.propertyValidator("ecsParameters", CfnSchedule_EcsParametersPropertyValidator)(properties.ecsParameters)), errors.collect(cdk.propertyValidator("eventBridgeParameters", CfnSchedule_EventBridgeParametersPropertyValidator)(properties.eventBridgeParameters)), errors.collect(cdk.propertyValidator("input", cdk.validateString)(properties.input)), errors.collect(cdk.propertyValidator("kinesisParameters", CfnSchedule_KinesisParametersPropertyValidator)(properties.kinesisParameters)), errors.collect(cdk.propertyValidator("retryPolicy", CfnSchedule_RetryPolicyPropertyValidator)(properties.retryPolicy)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("sageMakerPipelineParameters", CfnSchedule_SageMakerPipelineParametersPropertyValidator)(properties.sageMakerPipelineParameters)), errors.collect(cdk.propertyValidator("sqsParameters", CfnSchedule_SqsParametersPropertyValidator)(properties.sqsParameters)), errors.wrap('supplied properties not correct for "TargetProperty"');
    }
    function cfnScheduleTargetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSchedule_TargetPropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn), DeadLetterConfig: cfnScheduleDeadLetterConfigPropertyToCloudFormation(properties.deadLetterConfig), EcsParameters: cfnScheduleEcsParametersPropertyToCloudFormation(properties.ecsParameters), EventBridgeParameters: cfnScheduleEventBridgeParametersPropertyToCloudFormation(properties.eventBridgeParameters), Input: cdk.stringToCloudFormation(properties.input), KinesisParameters: cfnScheduleKinesisParametersPropertyToCloudFormation(properties.kinesisParameters), RetryPolicy: cfnScheduleRetryPolicyPropertyToCloudFormation(properties.retryPolicy), RoleArn: cdk.stringToCloudFormation(properties.roleArn), SageMakerPipelineParameters: cfnScheduleSageMakerPipelineParametersPropertyToCloudFormation(properties.sageMakerPipelineParameters), SqsParameters: cfnScheduleSqsParametersPropertyToCloudFormation(properties.sqsParameters) }) : properties;
    }
    function CfnScheduleTargetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", cfn_parse.FromCloudFormation.getString(properties.Arn)), ret.addPropertyResult("deadLetterConfig", "DeadLetterConfig", properties.DeadLetterConfig != null ? CfnScheduleDeadLetterConfigPropertyFromCloudFormation(properties.DeadLetterConfig) : void 0), ret.addPropertyResult("ecsParameters", "EcsParameters", properties.EcsParameters != null ? CfnScheduleEcsParametersPropertyFromCloudFormation(properties.EcsParameters) : void 0), ret.addPropertyResult("eventBridgeParameters", "EventBridgeParameters", properties.EventBridgeParameters != null ? CfnScheduleEventBridgeParametersPropertyFromCloudFormation(properties.EventBridgeParameters) : void 0), ret.addPropertyResult("input", "Input", properties.Input != null ? cfn_parse.FromCloudFormation.getString(properties.Input) : void 0), ret.addPropertyResult("kinesisParameters", "KinesisParameters", properties.KinesisParameters != null ? CfnScheduleKinesisParametersPropertyFromCloudFormation(properties.KinesisParameters) : void 0), ret.addPropertyResult("retryPolicy", "RetryPolicy", properties.RetryPolicy != null ? CfnScheduleRetryPolicyPropertyFromCloudFormation(properties.RetryPolicy) : void 0), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("sageMakerPipelineParameters", "SageMakerPipelineParameters", properties.SageMakerPipelineParameters != null ? CfnScheduleSageMakerPipelineParametersPropertyFromCloudFormation(properties.SageMakerPipelineParameters) : void 0), ret.addPropertyResult("sqsParameters", "SqsParameters", properties.SqsParameters != null ? CfnScheduleSqsParametersPropertyFromCloudFormation(properties.SqsParameters) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScheduleGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnScheduleGroupProps"');
    }
    function cfnScheduleGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScheduleGroupPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnScheduleGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnScheduleGroup = class _CfnScheduleGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnScheduleGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnScheduleGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnScheduleGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_scheduler_CfnScheduleGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnScheduleGroup), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreationDate = cdk.Token.asString(this.getAtt("CreationDate", cdk.ResolutionTypeHint.STRING)), this.attrLastModificationDate = cdk.Token.asString(this.getAtt("LastModificationDate", cdk.ResolutionTypeHint.STRING)), this.attrState = cdk.Token.asString(this.getAtt("State", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Scheduler::ScheduleGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnScheduleGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnScheduleGroupPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnScheduleGroup[_b] = { fqn: "aws-cdk-lib.aws_scheduler.CfnScheduleGroup", version: "2.80.0" }, CfnScheduleGroup.CFN_RESOURCE_TYPE_NAME = "AWS::Scheduler::ScheduleGroup", exports2.CfnScheduleGroup = CfnScheduleGroup;
  }
});

// node_modules/aws-cdk-lib/aws-scheduler/lib/index.js
var require_lib234 = __commonJS({
  "node_modules/aws-cdk-lib/aws-scheduler/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_scheduler_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-scheduler/index.js
var require_aws_scheduler = __commonJS({
  "node_modules/aws-cdk-lib/aws-scheduler/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib234(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-sdb/lib/sdb.generated.js
var require_sdb_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-sdb/lib/sdb.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnDomain = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnDomainPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.wrap('supplied properties not correct for "CfnDomainProps"');
    }
    function cfnDomainPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomainPropsValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description) }) : properties;
    }
    function CfnDomainPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDomain = class _CfnDomain extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDomainPropsFromCloudFormation(resourceProperties), ret = new _CfnDomain(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnDomain.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sdb_CfnDomainProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDomain), error;
        }
        this.description = props.description, this.node.scope && cdk.Resource.isResource(this.node.scope) && this.node.addValidation({ validate: () => this.cfnOptions.deletionPolicy === void 0 ? ["'AWS::SDB::Domain' is a stateful resource type, and you must specify a Removal Policy for it. Call 'resource.applyRemovalPolicy()'."] : [] });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDomain.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { description: this.description };
      }
      renderProperties(props) {
        return cfnDomainPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnDomain[_a] = { fqn: "aws-cdk-lib.aws_sdb.CfnDomain", version: "2.80.0" }, CfnDomain.CFN_RESOURCE_TYPE_NAME = "AWS::SDB::Domain", exports2.CfnDomain = CfnDomain;
  }
});

// node_modules/aws-cdk-lib/aws-sdb/lib/index.js
var require_lib235 = __commonJS({
  "node_modules/aws-cdk-lib/aws-sdb/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_sdb_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-sdb/index.js
var require_aws_sdb = __commonJS({
  "node_modules/aws-cdk-lib/aws-sdb/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib235(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-securityhub/lib/securityhub.generated.js
var require_securityhub_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-securityhub/lib/securityhub.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnHub = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnHubPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("tags", cdk.validateObject)(properties.tags)), errors.wrap('supplied properties not correct for "CfnHubProps"');
    }
    function cfnHubPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnHubPropsValidator(properties).assertSuccess(), { Tags: cdk.objectToCloudFormation(properties.tags) }) : properties;
    }
    function CfnHubPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getAny(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnHub = class _CfnHub extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnHubPropsFromCloudFormation(resourceProperties), ret = new _CfnHub(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnHub.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_securityhub_CfnHubProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnHub), error;
        }
        this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::SecurityHub::Hub", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnHub.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnHubPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnHub[_a] = { fqn: "aws-cdk-lib.aws_securityhub.CfnHub", version: "2.80.0" }, CfnHub.CFN_RESOURCE_TYPE_NAME = "AWS::SecurityHub::Hub", exports2.CfnHub = CfnHub;
  }
});

// node_modules/aws-cdk-lib/aws-securityhub/lib/index.js
var require_lib236 = __commonJS({
  "node_modules/aws-cdk-lib/aws-securityhub/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_securityhub_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-securityhub/index.js
var require_aws_securityhub = __commonJS({
  "node_modules/aws-cdk-lib/aws-securityhub/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib236(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-servicecatalog/lib/common.js
var require_common5 = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicecatalog/lib/common.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.MessageLanguage = exports2.DEFAULT_PRODUCT_STACK_SNAPSHOT_DIRECTORY = void 0, exports2.DEFAULT_PRODUCT_STACK_SNAPSHOT_DIRECTORY = "product-stack-snapshots";
    var MessageLanguage;
    (function(MessageLanguage2) {
      MessageLanguage2.EN = "en", MessageLanguage2.JP = "jp", MessageLanguage2.ZH = "zh";
    })(MessageLanguage = exports2.MessageLanguage || (exports2.MessageLanguage = {}));
  }
});

// node_modules/aws-cdk-lib/aws-servicecatalog/lib/constraints.js
var require_constraints = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicecatalog/lib/constraints.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-servicecatalog/lib/private/util.js
var require_util20 = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicecatalog/lib/private/util.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.hashValues = void 0;
    var crypto = require("crypto");
    function hashValues(...ids) {
      const sha256 = crypto.createHash("sha256");
      return ids.forEach((val) => sha256.update(val)), sha256.digest("hex").slice(0, 12);
    }
    exports2.hashValues = hashValues;
  }
});

// node_modules/aws-cdk-lib/aws-servicecatalog/lib/cloudformation-template.js
var require_cloudformation_template = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicecatalog/lib/cloudformation-template.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CloudFormationTemplate = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var util_1 = require_util20();
    var s3_assets = require_aws_s3_assets();
    var CloudFormationTemplate = class {
      static fromUrl(url) {
        return new CloudFormationUrlTemplate(url);
      }
      static fromAsset(path, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_assets_AssetOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromAsset), error;
        }
        return new CloudFormationAssetTemplate(path, options);
      }
      static fromProductStack(productStack) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicecatalog_ProductStack(productStack);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromProductStack), error;
        }
        return new CloudFormationProductStackTemplate(productStack);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CloudFormationTemplate[_a] = { fqn: "aws-cdk-lib.aws_servicecatalog.CloudFormationTemplate", version: "2.80.0" }, exports2.CloudFormationTemplate = CloudFormationTemplate;
    var CloudFormationUrlTemplate = class extends CloudFormationTemplate {
      constructor(url) {
        super(), this.url = url;
      }
      bind(_scope) {
        return { httpUrl: this.url };
      }
    };
    var CloudFormationAssetTemplate = class extends CloudFormationTemplate {
      constructor(path, options = {}) {
        super(), this.path = path, this.options = options;
      }
      bind(scope) {
        return this.asset || (this.asset = new s3_assets.Asset(scope, `Template${(0, util_1.hashValues)(this.path)}`, { path: this.path, ...this.options })), { httpUrl: this.asset.httpUrl };
      }
    };
    var CloudFormationProductStackTemplate = class extends CloudFormationTemplate {
      constructor(productStack) {
        super(), this.productStack = productStack;
      }
      bind(_scope) {
        return { httpUrl: this.productStack._getTemplateUrl(), assetBucket: this.productStack._getAssetBucket() };
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-servicecatalog/lib/private/validation.js
var require_validation4 = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicecatalog/lib/private/validation.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.InputValidator = void 0;
    var cdk = require_core2();
    var InputValidator = class {
      static validateLength(resourceName, inputName, minLength, maxLength, inputString) {
        if (!cdk.Token.isUnresolved(inputString) && inputString !== void 0 && (inputString.length < minLength || inputString.length > maxLength))
          throw new Error(`Invalid ${inputName} for resource ${resourceName}, must have length between ${minLength} and ${maxLength}, got: '${this.truncateString(inputString, 100)}'`);
      }
      static validateRegex(resourceName, inputName, regexp, inputString) {
        if (!cdk.Token.isUnresolved(inputString) && inputString !== void 0 && !regexp.test(inputString))
          throw new Error(`Invalid ${inputName} for resource ${resourceName}, must match regex pattern ${regexp}, got: '${this.truncateString(inputString, 100)}'`);
      }
      static validateUrl(resourceName, inputName, inputString) {
        this.validateRegex(resourceName, inputName, /^https?:\/\/.*/, inputString);
      }
      static validateEmail(resourceName, inputName, inputString) {
        this.validateRegex(resourceName, inputName, /^[\w\d.%+\-]+@[a-z\d.\-]+\.[a-z]{2,4}$/i, inputString);
      }
      static validateRoleNameSetForLocalLaunchRole(role) {
        if (role.node.defaultChild && cdk.Token.isUnresolved(role.node.defaultChild.roleName))
          throw new Error(`Role ${role.node.id} used for Local Launch Role must have roleName explicitly set`);
      }
      static truncateString(string, maxLength) {
        return string.length > maxLength ? string.substring(0, maxLength) + "[truncated]" : string;
      }
    };
    exports2.InputValidator = InputValidator;
  }
});

// node_modules/aws-cdk-lib/aws-servicecatalog/lib/servicecatalog.generated.js
var require_servicecatalog_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicecatalog/lib/servicecatalog.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    var _l;
    var _m;
    var _o;
    var _p;
    var _q;
    var _r;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnTagOptionAssociation = exports2.CfnTagOption = exports2.CfnStackSetConstraint = exports2.CfnServiceActionAssociation = exports2.CfnServiceAction = exports2.CfnResourceUpdateConstraint = exports2.CfnPortfolioShare = exports2.CfnPortfolioProductAssociation = exports2.CfnPortfolioPrincipalAssociation = exports2.CfnPortfolio = exports2.CfnLaunchTemplateConstraint = exports2.CfnLaunchRoleConstraint = exports2.CfnLaunchNotificationConstraint = exports2.CfnCloudFormationProvisionedProduct = exports2.CfnCloudFormationProduct = exports2.CfnAcceptedPortfolioShare = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAcceptedPortfolioSharePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acceptLanguage", cdk.validateString)(properties.acceptLanguage)), errors.collect(cdk.propertyValidator("portfolioId", cdk.requiredValidator)(properties.portfolioId)), errors.collect(cdk.propertyValidator("portfolioId", cdk.validateString)(properties.portfolioId)), errors.wrap('supplied properties not correct for "CfnAcceptedPortfolioShareProps"');
    }
    function cfnAcceptedPortfolioSharePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAcceptedPortfolioSharePropsValidator(properties).assertSuccess(), { PortfolioId: cdk.stringToCloudFormation(properties.portfolioId), AcceptLanguage: cdk.stringToCloudFormation(properties.acceptLanguage) }) : properties;
    }
    function CfnAcceptedPortfolioSharePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("portfolioId", "PortfolioId", cfn_parse.FromCloudFormation.getString(properties.PortfolioId)), ret.addPropertyResult("acceptLanguage", "AcceptLanguage", properties.AcceptLanguage != null ? cfn_parse.FromCloudFormation.getString(properties.AcceptLanguage) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAcceptedPortfolioShare = class _CfnAcceptedPortfolioShare extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAcceptedPortfolioSharePropsFromCloudFormation(resourceProperties), ret = new _CfnAcceptedPortfolioShare(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAcceptedPortfolioShare.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicecatalog_CfnAcceptedPortfolioShareProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAcceptedPortfolioShare), error;
        }
        cdk.requireProperty(props, "portfolioId", this), this.portfolioId = props.portfolioId, this.acceptLanguage = props.acceptLanguage;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAcceptedPortfolioShare.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { portfolioId: this.portfolioId, acceptLanguage: this.acceptLanguage };
      }
      renderProperties(props) {
        return cfnAcceptedPortfolioSharePropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAcceptedPortfolioShare[_a] = { fqn: "aws-cdk-lib.aws_servicecatalog.CfnAcceptedPortfolioShare", version: "2.80.0" }, CfnAcceptedPortfolioShare.CFN_RESOURCE_TYPE_NAME = "AWS::ServiceCatalog::AcceptedPortfolioShare", exports2.CfnAcceptedPortfolioShare = CfnAcceptedPortfolioShare;
    function CfnCloudFormationProductPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acceptLanguage", cdk.validateString)(properties.acceptLanguage)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("distributor", cdk.validateString)(properties.distributor)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("owner", cdk.requiredValidator)(properties.owner)), errors.collect(cdk.propertyValidator("owner", cdk.validateString)(properties.owner)), errors.collect(cdk.propertyValidator("productType", cdk.validateString)(properties.productType)), errors.collect(cdk.propertyValidator("provisioningArtifactParameters", cdk.listValidator(CfnCloudFormationProduct_ProvisioningArtifactPropertiesPropertyValidator))(properties.provisioningArtifactParameters)), errors.collect(cdk.propertyValidator("replaceProvisioningArtifacts", cdk.validateBoolean)(properties.replaceProvisioningArtifacts)), errors.collect(cdk.propertyValidator("sourceConnection", CfnCloudFormationProduct_SourceConnectionPropertyValidator)(properties.sourceConnection)), errors.collect(cdk.propertyValidator("supportDescription", cdk.validateString)(properties.supportDescription)), errors.collect(cdk.propertyValidator("supportEmail", cdk.validateString)(properties.supportEmail)), errors.collect(cdk.propertyValidator("supportUrl", cdk.validateString)(properties.supportUrl)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnCloudFormationProductProps"');
    }
    function cfnCloudFormationProductPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCloudFormationProductPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Owner: cdk.stringToCloudFormation(properties.owner), AcceptLanguage: cdk.stringToCloudFormation(properties.acceptLanguage), Description: cdk.stringToCloudFormation(properties.description), Distributor: cdk.stringToCloudFormation(properties.distributor), ProductType: cdk.stringToCloudFormation(properties.productType), ProvisioningArtifactParameters: cdk.listMapper(cfnCloudFormationProductProvisioningArtifactPropertiesPropertyToCloudFormation)(properties.provisioningArtifactParameters), ReplaceProvisioningArtifacts: cdk.booleanToCloudFormation(properties.replaceProvisioningArtifacts), SourceConnection: cfnCloudFormationProductSourceConnectionPropertyToCloudFormation(properties.sourceConnection), SupportDescription: cdk.stringToCloudFormation(properties.supportDescription), SupportEmail: cdk.stringToCloudFormation(properties.supportEmail), SupportUrl: cdk.stringToCloudFormation(properties.supportUrl), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnCloudFormationProductPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("owner", "Owner", cfn_parse.FromCloudFormation.getString(properties.Owner)), ret.addPropertyResult("acceptLanguage", "AcceptLanguage", properties.AcceptLanguage != null ? cfn_parse.FromCloudFormation.getString(properties.AcceptLanguage) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("distributor", "Distributor", properties.Distributor != null ? cfn_parse.FromCloudFormation.getString(properties.Distributor) : void 0), ret.addPropertyResult("productType", "ProductType", properties.ProductType != null ? cfn_parse.FromCloudFormation.getString(properties.ProductType) : void 0), ret.addPropertyResult("provisioningArtifactParameters", "ProvisioningArtifactParameters", properties.ProvisioningArtifactParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnCloudFormationProductProvisioningArtifactPropertiesPropertyFromCloudFormation)(properties.ProvisioningArtifactParameters) : void 0), ret.addPropertyResult("replaceProvisioningArtifacts", "ReplaceProvisioningArtifacts", properties.ReplaceProvisioningArtifacts != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ReplaceProvisioningArtifacts) : void 0), ret.addPropertyResult("sourceConnection", "SourceConnection", properties.SourceConnection != null ? CfnCloudFormationProductSourceConnectionPropertyFromCloudFormation(properties.SourceConnection) : void 0), ret.addPropertyResult("supportDescription", "SupportDescription", properties.SupportDescription != null ? cfn_parse.FromCloudFormation.getString(properties.SupportDescription) : void 0), ret.addPropertyResult("supportEmail", "SupportEmail", properties.SupportEmail != null ? cfn_parse.FromCloudFormation.getString(properties.SupportEmail) : void 0), ret.addPropertyResult("supportUrl", "SupportUrl", properties.SupportUrl != null ? cfn_parse.FromCloudFormation.getString(properties.SupportUrl) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCloudFormationProduct = class _CfnCloudFormationProduct extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCloudFormationProductPropsFromCloudFormation(resourceProperties), ret = new _CfnCloudFormationProduct(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCloudFormationProduct.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicecatalog_CfnCloudFormationProductProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCloudFormationProduct), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "owner", this), this.attrProductName = cdk.Token.asString(this.getAtt("ProductName", cdk.ResolutionTypeHint.STRING)), this.attrProvisioningArtifactIds = cdk.Token.asString(this.getAtt("ProvisioningArtifactIds", cdk.ResolutionTypeHint.STRING)), this.attrProvisioningArtifactNames = cdk.Token.asString(this.getAtt("ProvisioningArtifactNames", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.owner = props.owner, this.acceptLanguage = props.acceptLanguage, this.description = props.description, this.distributor = props.distributor, this.productType = props.productType, this.provisioningArtifactParameters = props.provisioningArtifactParameters, this.replaceProvisioningArtifacts = props.replaceProvisioningArtifacts, this.sourceConnection = props.sourceConnection, this.supportDescription = props.supportDescription, this.supportEmail = props.supportEmail, this.supportUrl = props.supportUrl, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ServiceCatalog::CloudFormationProduct", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCloudFormationProduct.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, owner: this.owner, acceptLanguage: this.acceptLanguage, description: this.description, distributor: this.distributor, productType: this.productType, provisioningArtifactParameters: this.provisioningArtifactParameters, replaceProvisioningArtifacts: this.replaceProvisioningArtifacts, sourceConnection: this.sourceConnection, supportDescription: this.supportDescription, supportEmail: this.supportEmail, supportUrl: this.supportUrl, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnCloudFormationProductPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnCloudFormationProduct[_b] = { fqn: "aws-cdk-lib.aws_servicecatalog.CfnCloudFormationProduct", version: "2.80.0" }, CfnCloudFormationProduct.CFN_RESOURCE_TYPE_NAME = "AWS::ServiceCatalog::CloudFormationProduct", exports2.CfnCloudFormationProduct = CfnCloudFormationProduct;
    function CfnCloudFormationProduct_CodeStarParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("artifactPath", cdk.requiredValidator)(properties.artifactPath)), errors.collect(cdk.propertyValidator("artifactPath", cdk.validateString)(properties.artifactPath)), errors.collect(cdk.propertyValidator("branch", cdk.requiredValidator)(properties.branch)), errors.collect(cdk.propertyValidator("branch", cdk.validateString)(properties.branch)), errors.collect(cdk.propertyValidator("connectionArn", cdk.requiredValidator)(properties.connectionArn)), errors.collect(cdk.propertyValidator("connectionArn", cdk.validateString)(properties.connectionArn)), errors.collect(cdk.propertyValidator("repository", cdk.requiredValidator)(properties.repository)), errors.collect(cdk.propertyValidator("repository", cdk.validateString)(properties.repository)), errors.wrap('supplied properties not correct for "CodeStarParametersProperty"');
    }
    function cfnCloudFormationProductCodeStarParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCloudFormationProduct_CodeStarParametersPropertyValidator(properties).assertSuccess(), { ArtifactPath: cdk.stringToCloudFormation(properties.artifactPath), Branch: cdk.stringToCloudFormation(properties.branch), ConnectionArn: cdk.stringToCloudFormation(properties.connectionArn), Repository: cdk.stringToCloudFormation(properties.repository) }) : properties;
    }
    function CfnCloudFormationProductCodeStarParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("artifactPath", "ArtifactPath", cfn_parse.FromCloudFormation.getString(properties.ArtifactPath)), ret.addPropertyResult("branch", "Branch", cfn_parse.FromCloudFormation.getString(properties.Branch)), ret.addPropertyResult("connectionArn", "ConnectionArn", cfn_parse.FromCloudFormation.getString(properties.ConnectionArn)), ret.addPropertyResult("repository", "Repository", cfn_parse.FromCloudFormation.getString(properties.Repository)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCloudFormationProduct_ConnectionParametersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("codeStar", CfnCloudFormationProduct_CodeStarParametersPropertyValidator)(properties.codeStar)), errors.wrap('supplied properties not correct for "ConnectionParametersProperty"');
    }
    function cfnCloudFormationProductConnectionParametersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCloudFormationProduct_ConnectionParametersPropertyValidator(properties).assertSuccess(), { CodeStar: cfnCloudFormationProductCodeStarParametersPropertyToCloudFormation(properties.codeStar) }) : properties;
    }
    function CfnCloudFormationProductConnectionParametersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("codeStar", "CodeStar", properties.CodeStar != null ? CfnCloudFormationProductCodeStarParametersPropertyFromCloudFormation(properties.CodeStar) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCloudFormationProduct_ProvisioningArtifactPropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("disableTemplateValidation", cdk.validateBoolean)(properties.disableTemplateValidation)), errors.collect(cdk.propertyValidator("info", cdk.requiredValidator)(properties.info)), errors.collect(cdk.propertyValidator("info", cdk.validateObject)(properties.info)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "ProvisioningArtifactPropertiesProperty"');
    }
    function cfnCloudFormationProductProvisioningArtifactPropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCloudFormationProduct_ProvisioningArtifactPropertiesPropertyValidator(properties).assertSuccess(), { Description: cdk.stringToCloudFormation(properties.description), DisableTemplateValidation: cdk.booleanToCloudFormation(properties.disableTemplateValidation), Info: cdk.objectToCloudFormation(properties.info), Name: cdk.stringToCloudFormation(properties.name), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnCloudFormationProductProvisioningArtifactPropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("disableTemplateValidation", "DisableTemplateValidation", properties.DisableTemplateValidation != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DisableTemplateValidation) : void 0), ret.addPropertyResult("info", "Info", cfn_parse.FromCloudFormation.getAny(properties.Info)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCloudFormationProduct_SourceConnectionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectionParameters", cdk.requiredValidator)(properties.connectionParameters)), errors.collect(cdk.propertyValidator("connectionParameters", CfnCloudFormationProduct_ConnectionParametersPropertyValidator)(properties.connectionParameters)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "SourceConnectionProperty"');
    }
    function cfnCloudFormationProductSourceConnectionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCloudFormationProduct_SourceConnectionPropertyValidator(properties).assertSuccess(), { ConnectionParameters: cfnCloudFormationProductConnectionParametersPropertyToCloudFormation(properties.connectionParameters), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnCloudFormationProductSourceConnectionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectionParameters", "ConnectionParameters", CfnCloudFormationProductConnectionParametersPropertyFromCloudFormation(properties.ConnectionParameters)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCloudFormationProvisionedProductPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acceptLanguage", cdk.validateString)(properties.acceptLanguage)), errors.collect(cdk.propertyValidator("notificationArns", cdk.listValidator(cdk.validateString))(properties.notificationArns)), errors.collect(cdk.propertyValidator("pathId", cdk.validateString)(properties.pathId)), errors.collect(cdk.propertyValidator("pathName", cdk.validateString)(properties.pathName)), errors.collect(cdk.propertyValidator("productId", cdk.validateString)(properties.productId)), errors.collect(cdk.propertyValidator("productName", cdk.validateString)(properties.productName)), errors.collect(cdk.propertyValidator("provisionedProductName", cdk.validateString)(properties.provisionedProductName)), errors.collect(cdk.propertyValidator("provisioningArtifactId", cdk.validateString)(properties.provisioningArtifactId)), errors.collect(cdk.propertyValidator("provisioningArtifactName", cdk.validateString)(properties.provisioningArtifactName)), errors.collect(cdk.propertyValidator("provisioningParameters", cdk.listValidator(CfnCloudFormationProvisionedProduct_ProvisioningParameterPropertyValidator))(properties.provisioningParameters)), errors.collect(cdk.propertyValidator("provisioningPreferences", CfnCloudFormationProvisionedProduct_ProvisioningPreferencesPropertyValidator)(properties.provisioningPreferences)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnCloudFormationProvisionedProductProps"');
    }
    function cfnCloudFormationProvisionedProductPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCloudFormationProvisionedProductPropsValidator(properties).assertSuccess(), { AcceptLanguage: cdk.stringToCloudFormation(properties.acceptLanguage), NotificationArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.notificationArns), PathId: cdk.stringToCloudFormation(properties.pathId), PathName: cdk.stringToCloudFormation(properties.pathName), ProductId: cdk.stringToCloudFormation(properties.productId), ProductName: cdk.stringToCloudFormation(properties.productName), ProvisionedProductName: cdk.stringToCloudFormation(properties.provisionedProductName), ProvisioningArtifactId: cdk.stringToCloudFormation(properties.provisioningArtifactId), ProvisioningArtifactName: cdk.stringToCloudFormation(properties.provisioningArtifactName), ProvisioningParameters: cdk.listMapper(cfnCloudFormationProvisionedProductProvisioningParameterPropertyToCloudFormation)(properties.provisioningParameters), ProvisioningPreferences: cfnCloudFormationProvisionedProductProvisioningPreferencesPropertyToCloudFormation(properties.provisioningPreferences), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnCloudFormationProvisionedProductPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("acceptLanguage", "AcceptLanguage", properties.AcceptLanguage != null ? cfn_parse.FromCloudFormation.getString(properties.AcceptLanguage) : void 0), ret.addPropertyResult("notificationArns", "NotificationArns", properties.NotificationArns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.NotificationArns) : void 0), ret.addPropertyResult("pathId", "PathId", properties.PathId != null ? cfn_parse.FromCloudFormation.getString(properties.PathId) : void 0), ret.addPropertyResult("pathName", "PathName", properties.PathName != null ? cfn_parse.FromCloudFormation.getString(properties.PathName) : void 0), ret.addPropertyResult("productId", "ProductId", properties.ProductId != null ? cfn_parse.FromCloudFormation.getString(properties.ProductId) : void 0), ret.addPropertyResult("productName", "ProductName", properties.ProductName != null ? cfn_parse.FromCloudFormation.getString(properties.ProductName) : void 0), ret.addPropertyResult("provisionedProductName", "ProvisionedProductName", properties.ProvisionedProductName != null ? cfn_parse.FromCloudFormation.getString(properties.ProvisionedProductName) : void 0), ret.addPropertyResult("provisioningArtifactId", "ProvisioningArtifactId", properties.ProvisioningArtifactId != null ? cfn_parse.FromCloudFormation.getString(properties.ProvisioningArtifactId) : void 0), ret.addPropertyResult("provisioningArtifactName", "ProvisioningArtifactName", properties.ProvisioningArtifactName != null ? cfn_parse.FromCloudFormation.getString(properties.ProvisioningArtifactName) : void 0), ret.addPropertyResult("provisioningParameters", "ProvisioningParameters", properties.ProvisioningParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnCloudFormationProvisionedProductProvisioningParameterPropertyFromCloudFormation)(properties.ProvisioningParameters) : void 0), ret.addPropertyResult("provisioningPreferences", "ProvisioningPreferences", properties.ProvisioningPreferences != null ? CfnCloudFormationProvisionedProductProvisioningPreferencesPropertyFromCloudFormation(properties.ProvisioningPreferences) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCloudFormationProvisionedProduct = class _CfnCloudFormationProvisionedProduct extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCloudFormationProvisionedProductPropsFromCloudFormation(resourceProperties), ret = new _CfnCloudFormationProvisionedProduct(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnCloudFormationProvisionedProduct.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicecatalog_CfnCloudFormationProvisionedProductProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCloudFormationProvisionedProduct), error;
        }
        this.attrCloudformationStackArn = cdk.Token.asString(this.getAtt("CloudformationStackArn", cdk.ResolutionTypeHint.STRING)), this.attrOutputs = this.getAtt("Outputs", cdk.ResolutionTypeHint.STRING), this.attrProvisionedProductId = cdk.Token.asString(this.getAtt("ProvisionedProductId", cdk.ResolutionTypeHint.STRING)), this.attrRecordId = cdk.Token.asString(this.getAtt("RecordId", cdk.ResolutionTypeHint.STRING)), this.acceptLanguage = props.acceptLanguage, this.notificationArns = props.notificationArns, this.pathId = props.pathId, this.pathName = props.pathName, this.productId = props.productId, this.productName = props.productName, this.provisionedProductName = props.provisionedProductName, this.provisioningArtifactId = props.provisioningArtifactId, this.provisioningArtifactName = props.provisioningArtifactName, this.provisioningParameters = props.provisioningParameters, this.provisioningPreferences = props.provisioningPreferences, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ServiceCatalog::CloudFormationProvisionedProduct", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCloudFormationProvisionedProduct.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { acceptLanguage: this.acceptLanguage, notificationArns: this.notificationArns, pathId: this.pathId, pathName: this.pathName, productId: this.productId, productName: this.productName, provisionedProductName: this.provisionedProductName, provisioningArtifactId: this.provisioningArtifactId, provisioningArtifactName: this.provisioningArtifactName, provisioningParameters: this.provisioningParameters, provisioningPreferences: this.provisioningPreferences, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnCloudFormationProvisionedProductPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnCloudFormationProvisionedProduct[_c] = { fqn: "aws-cdk-lib.aws_servicecatalog.CfnCloudFormationProvisionedProduct", version: "2.80.0" }, CfnCloudFormationProvisionedProduct.CFN_RESOURCE_TYPE_NAME = "AWS::ServiceCatalog::CloudFormationProvisionedProduct", exports2.CfnCloudFormationProvisionedProduct = CfnCloudFormationProvisionedProduct;
    function CfnCloudFormationProvisionedProduct_ProvisioningParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "ProvisioningParameterProperty"');
    }
    function cfnCloudFormationProvisionedProductProvisioningParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCloudFormationProvisionedProduct_ProvisioningParameterPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnCloudFormationProvisionedProductProvisioningParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCloudFormationProvisionedProduct_ProvisioningPreferencesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("stackSetAccounts", cdk.listValidator(cdk.validateString))(properties.stackSetAccounts)), errors.collect(cdk.propertyValidator("stackSetFailureToleranceCount", cdk.validateNumber)(properties.stackSetFailureToleranceCount)), errors.collect(cdk.propertyValidator("stackSetFailureTolerancePercentage", cdk.validateNumber)(properties.stackSetFailureTolerancePercentage)), errors.collect(cdk.propertyValidator("stackSetMaxConcurrencyCount", cdk.validateNumber)(properties.stackSetMaxConcurrencyCount)), errors.collect(cdk.propertyValidator("stackSetMaxConcurrencyPercentage", cdk.validateNumber)(properties.stackSetMaxConcurrencyPercentage)), errors.collect(cdk.propertyValidator("stackSetOperationType", cdk.validateString)(properties.stackSetOperationType)), errors.collect(cdk.propertyValidator("stackSetRegions", cdk.listValidator(cdk.validateString))(properties.stackSetRegions)), errors.wrap('supplied properties not correct for "ProvisioningPreferencesProperty"');
    }
    function cfnCloudFormationProvisionedProductProvisioningPreferencesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCloudFormationProvisionedProduct_ProvisioningPreferencesPropertyValidator(properties).assertSuccess(), { StackSetAccounts: cdk.listMapper(cdk.stringToCloudFormation)(properties.stackSetAccounts), StackSetFailureToleranceCount: cdk.numberToCloudFormation(properties.stackSetFailureToleranceCount), StackSetFailureTolerancePercentage: cdk.numberToCloudFormation(properties.stackSetFailureTolerancePercentage), StackSetMaxConcurrencyCount: cdk.numberToCloudFormation(properties.stackSetMaxConcurrencyCount), StackSetMaxConcurrencyPercentage: cdk.numberToCloudFormation(properties.stackSetMaxConcurrencyPercentage), StackSetOperationType: cdk.stringToCloudFormation(properties.stackSetOperationType), StackSetRegions: cdk.listMapper(cdk.stringToCloudFormation)(properties.stackSetRegions) }) : properties;
    }
    function CfnCloudFormationProvisionedProductProvisioningPreferencesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("stackSetAccounts", "StackSetAccounts", properties.StackSetAccounts != null ? cfn_parse.FromCloudFormation.getStringArray(properties.StackSetAccounts) : void 0), ret.addPropertyResult("stackSetFailureToleranceCount", "StackSetFailureToleranceCount", properties.StackSetFailureToleranceCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.StackSetFailureToleranceCount) : void 0), ret.addPropertyResult("stackSetFailureTolerancePercentage", "StackSetFailureTolerancePercentage", properties.StackSetFailureTolerancePercentage != null ? cfn_parse.FromCloudFormation.getNumber(properties.StackSetFailureTolerancePercentage) : void 0), ret.addPropertyResult("stackSetMaxConcurrencyCount", "StackSetMaxConcurrencyCount", properties.StackSetMaxConcurrencyCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.StackSetMaxConcurrencyCount) : void 0), ret.addPropertyResult("stackSetMaxConcurrencyPercentage", "StackSetMaxConcurrencyPercentage", properties.StackSetMaxConcurrencyPercentage != null ? cfn_parse.FromCloudFormation.getNumber(properties.StackSetMaxConcurrencyPercentage) : void 0), ret.addPropertyResult("stackSetOperationType", "StackSetOperationType", properties.StackSetOperationType != null ? cfn_parse.FromCloudFormation.getString(properties.StackSetOperationType) : void 0), ret.addPropertyResult("stackSetRegions", "StackSetRegions", properties.StackSetRegions != null ? cfn_parse.FromCloudFormation.getStringArray(properties.StackSetRegions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnLaunchNotificationConstraintPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acceptLanguage", cdk.validateString)(properties.acceptLanguage)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("notificationArns", cdk.requiredValidator)(properties.notificationArns)), errors.collect(cdk.propertyValidator("notificationArns", cdk.listValidator(cdk.validateString))(properties.notificationArns)), errors.collect(cdk.propertyValidator("portfolioId", cdk.requiredValidator)(properties.portfolioId)), errors.collect(cdk.propertyValidator("portfolioId", cdk.validateString)(properties.portfolioId)), errors.collect(cdk.propertyValidator("productId", cdk.requiredValidator)(properties.productId)), errors.collect(cdk.propertyValidator("productId", cdk.validateString)(properties.productId)), errors.wrap('supplied properties not correct for "CfnLaunchNotificationConstraintProps"');
    }
    function cfnLaunchNotificationConstraintPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchNotificationConstraintPropsValidator(properties).assertSuccess(), { NotificationArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.notificationArns), PortfolioId: cdk.stringToCloudFormation(properties.portfolioId), ProductId: cdk.stringToCloudFormation(properties.productId), AcceptLanguage: cdk.stringToCloudFormation(properties.acceptLanguage), Description: cdk.stringToCloudFormation(properties.description) }) : properties;
    }
    function CfnLaunchNotificationConstraintPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("notificationArns", "NotificationArns", cfn_parse.FromCloudFormation.getStringArray(properties.NotificationArns)), ret.addPropertyResult("portfolioId", "PortfolioId", cfn_parse.FromCloudFormation.getString(properties.PortfolioId)), ret.addPropertyResult("productId", "ProductId", cfn_parse.FromCloudFormation.getString(properties.ProductId)), ret.addPropertyResult("acceptLanguage", "AcceptLanguage", properties.AcceptLanguage != null ? cfn_parse.FromCloudFormation.getString(properties.AcceptLanguage) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLaunchNotificationConstraint = class _CfnLaunchNotificationConstraint extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLaunchNotificationConstraintPropsFromCloudFormation(resourceProperties), ret = new _CfnLaunchNotificationConstraint(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLaunchNotificationConstraint.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicecatalog_CfnLaunchNotificationConstraintProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLaunchNotificationConstraint), error;
        }
        cdk.requireProperty(props, "notificationArns", this), cdk.requireProperty(props, "portfolioId", this), cdk.requireProperty(props, "productId", this), this.notificationArns = props.notificationArns, this.portfolioId = props.portfolioId, this.productId = props.productId, this.acceptLanguage = props.acceptLanguage, this.description = props.description;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLaunchNotificationConstraint.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { notificationArns: this.notificationArns, portfolioId: this.portfolioId, productId: this.productId, acceptLanguage: this.acceptLanguage, description: this.description };
      }
      renderProperties(props) {
        return cfnLaunchNotificationConstraintPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnLaunchNotificationConstraint[_d] = { fqn: "aws-cdk-lib.aws_servicecatalog.CfnLaunchNotificationConstraint", version: "2.80.0" }, CfnLaunchNotificationConstraint.CFN_RESOURCE_TYPE_NAME = "AWS::ServiceCatalog::LaunchNotificationConstraint", exports2.CfnLaunchNotificationConstraint = CfnLaunchNotificationConstraint;
    function CfnLaunchRoleConstraintPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acceptLanguage", cdk.validateString)(properties.acceptLanguage)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("localRoleName", cdk.validateString)(properties.localRoleName)), errors.collect(cdk.propertyValidator("portfolioId", cdk.requiredValidator)(properties.portfolioId)), errors.collect(cdk.propertyValidator("portfolioId", cdk.validateString)(properties.portfolioId)), errors.collect(cdk.propertyValidator("productId", cdk.requiredValidator)(properties.productId)), errors.collect(cdk.propertyValidator("productId", cdk.validateString)(properties.productId)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.wrap('supplied properties not correct for "CfnLaunchRoleConstraintProps"');
    }
    function cfnLaunchRoleConstraintPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchRoleConstraintPropsValidator(properties).assertSuccess(), { PortfolioId: cdk.stringToCloudFormation(properties.portfolioId), ProductId: cdk.stringToCloudFormation(properties.productId), AcceptLanguage: cdk.stringToCloudFormation(properties.acceptLanguage), Description: cdk.stringToCloudFormation(properties.description), LocalRoleName: cdk.stringToCloudFormation(properties.localRoleName), RoleArn: cdk.stringToCloudFormation(properties.roleArn) }) : properties;
    }
    function CfnLaunchRoleConstraintPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("portfolioId", "PortfolioId", cfn_parse.FromCloudFormation.getString(properties.PortfolioId)), ret.addPropertyResult("productId", "ProductId", cfn_parse.FromCloudFormation.getString(properties.ProductId)), ret.addPropertyResult("acceptLanguage", "AcceptLanguage", properties.AcceptLanguage != null ? cfn_parse.FromCloudFormation.getString(properties.AcceptLanguage) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("localRoleName", "LocalRoleName", properties.LocalRoleName != null ? cfn_parse.FromCloudFormation.getString(properties.LocalRoleName) : void 0), ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLaunchRoleConstraint = class _CfnLaunchRoleConstraint extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLaunchRoleConstraintPropsFromCloudFormation(resourceProperties), ret = new _CfnLaunchRoleConstraint(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLaunchRoleConstraint.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicecatalog_CfnLaunchRoleConstraintProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLaunchRoleConstraint), error;
        }
        cdk.requireProperty(props, "portfolioId", this), cdk.requireProperty(props, "productId", this), this.portfolioId = props.portfolioId, this.productId = props.productId, this.acceptLanguage = props.acceptLanguage, this.description = props.description, this.localRoleName = props.localRoleName, this.roleArn = props.roleArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLaunchRoleConstraint.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { portfolioId: this.portfolioId, productId: this.productId, acceptLanguage: this.acceptLanguage, description: this.description, localRoleName: this.localRoleName, roleArn: this.roleArn };
      }
      renderProperties(props) {
        return cfnLaunchRoleConstraintPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnLaunchRoleConstraint[_e] = { fqn: "aws-cdk-lib.aws_servicecatalog.CfnLaunchRoleConstraint", version: "2.80.0" }, CfnLaunchRoleConstraint.CFN_RESOURCE_TYPE_NAME = "AWS::ServiceCatalog::LaunchRoleConstraint", exports2.CfnLaunchRoleConstraint = CfnLaunchRoleConstraint;
    function CfnLaunchTemplateConstraintPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acceptLanguage", cdk.validateString)(properties.acceptLanguage)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("portfolioId", cdk.requiredValidator)(properties.portfolioId)), errors.collect(cdk.propertyValidator("portfolioId", cdk.validateString)(properties.portfolioId)), errors.collect(cdk.propertyValidator("productId", cdk.requiredValidator)(properties.productId)), errors.collect(cdk.propertyValidator("productId", cdk.validateString)(properties.productId)), errors.collect(cdk.propertyValidator("rules", cdk.requiredValidator)(properties.rules)), errors.collect(cdk.propertyValidator("rules", cdk.validateString)(properties.rules)), errors.wrap('supplied properties not correct for "CfnLaunchTemplateConstraintProps"');
    }
    function cfnLaunchTemplateConstraintPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLaunchTemplateConstraintPropsValidator(properties).assertSuccess(), { PortfolioId: cdk.stringToCloudFormation(properties.portfolioId), ProductId: cdk.stringToCloudFormation(properties.productId), Rules: cdk.stringToCloudFormation(properties.rules), AcceptLanguage: cdk.stringToCloudFormation(properties.acceptLanguage), Description: cdk.stringToCloudFormation(properties.description) }) : properties;
    }
    function CfnLaunchTemplateConstraintPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("portfolioId", "PortfolioId", cfn_parse.FromCloudFormation.getString(properties.PortfolioId)), ret.addPropertyResult("productId", "ProductId", cfn_parse.FromCloudFormation.getString(properties.ProductId)), ret.addPropertyResult("rules", "Rules", cfn_parse.FromCloudFormation.getString(properties.Rules)), ret.addPropertyResult("acceptLanguage", "AcceptLanguage", properties.AcceptLanguage != null ? cfn_parse.FromCloudFormation.getString(properties.AcceptLanguage) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLaunchTemplateConstraint = class _CfnLaunchTemplateConstraint extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLaunchTemplateConstraintPropsFromCloudFormation(resourceProperties), ret = new _CfnLaunchTemplateConstraint(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLaunchTemplateConstraint.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicecatalog_CfnLaunchTemplateConstraintProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLaunchTemplateConstraint), error;
        }
        cdk.requireProperty(props, "portfolioId", this), cdk.requireProperty(props, "productId", this), cdk.requireProperty(props, "rules", this), this.portfolioId = props.portfolioId, this.productId = props.productId, this.rules = props.rules, this.acceptLanguage = props.acceptLanguage, this.description = props.description;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLaunchTemplateConstraint.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { portfolioId: this.portfolioId, productId: this.productId, rules: this.rules, acceptLanguage: this.acceptLanguage, description: this.description };
      }
      renderProperties(props) {
        return cfnLaunchTemplateConstraintPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnLaunchTemplateConstraint[_f] = { fqn: "aws-cdk-lib.aws_servicecatalog.CfnLaunchTemplateConstraint", version: "2.80.0" }, CfnLaunchTemplateConstraint.CFN_RESOURCE_TYPE_NAME = "AWS::ServiceCatalog::LaunchTemplateConstraint", exports2.CfnLaunchTemplateConstraint = CfnLaunchTemplateConstraint;
    function CfnPortfolioPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acceptLanguage", cdk.validateString)(properties.acceptLanguage)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("displayName", cdk.requiredValidator)(properties.displayName)), errors.collect(cdk.propertyValidator("displayName", cdk.validateString)(properties.displayName)), errors.collect(cdk.propertyValidator("providerName", cdk.requiredValidator)(properties.providerName)), errors.collect(cdk.propertyValidator("providerName", cdk.validateString)(properties.providerName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnPortfolioProps"');
    }
    function cfnPortfolioPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPortfolioPropsValidator(properties).assertSuccess(), { DisplayName: cdk.stringToCloudFormation(properties.displayName), ProviderName: cdk.stringToCloudFormation(properties.providerName), AcceptLanguage: cdk.stringToCloudFormation(properties.acceptLanguage), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnPortfolioPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("displayName", "DisplayName", cfn_parse.FromCloudFormation.getString(properties.DisplayName)), ret.addPropertyResult("providerName", "ProviderName", cfn_parse.FromCloudFormation.getString(properties.ProviderName)), ret.addPropertyResult("acceptLanguage", "AcceptLanguage", properties.AcceptLanguage != null ? cfn_parse.FromCloudFormation.getString(properties.AcceptLanguage) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPortfolio = class _CfnPortfolio extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPortfolioPropsFromCloudFormation(resourceProperties), ret = new _CfnPortfolio(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPortfolio.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicecatalog_CfnPortfolioProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPortfolio), error;
        }
        cdk.requireProperty(props, "displayName", this), cdk.requireProperty(props, "providerName", this), this.attrPortfolioName = cdk.Token.asString(this.getAtt("PortfolioName", cdk.ResolutionTypeHint.STRING)), this.displayName = props.displayName, this.providerName = props.providerName, this.acceptLanguage = props.acceptLanguage, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::ServiceCatalog::Portfolio", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPortfolio.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { displayName: this.displayName, providerName: this.providerName, acceptLanguage: this.acceptLanguage, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnPortfolioPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnPortfolio[_g] = { fqn: "aws-cdk-lib.aws_servicecatalog.CfnPortfolio", version: "2.80.0" }, CfnPortfolio.CFN_RESOURCE_TYPE_NAME = "AWS::ServiceCatalog::Portfolio", exports2.CfnPortfolio = CfnPortfolio;
    function CfnPortfolioPrincipalAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acceptLanguage", cdk.validateString)(properties.acceptLanguage)), errors.collect(cdk.propertyValidator("portfolioId", cdk.requiredValidator)(properties.portfolioId)), errors.collect(cdk.propertyValidator("portfolioId", cdk.validateString)(properties.portfolioId)), errors.collect(cdk.propertyValidator("principalArn", cdk.requiredValidator)(properties.principalArn)), errors.collect(cdk.propertyValidator("principalArn", cdk.validateString)(properties.principalArn)), errors.collect(cdk.propertyValidator("principalType", cdk.requiredValidator)(properties.principalType)), errors.collect(cdk.propertyValidator("principalType", cdk.validateString)(properties.principalType)), errors.wrap('supplied properties not correct for "CfnPortfolioPrincipalAssociationProps"');
    }
    function cfnPortfolioPrincipalAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPortfolioPrincipalAssociationPropsValidator(properties).assertSuccess(), { PortfolioId: cdk.stringToCloudFormation(properties.portfolioId), PrincipalARN: cdk.stringToCloudFormation(properties.principalArn), PrincipalType: cdk.stringToCloudFormation(properties.principalType), AcceptLanguage: cdk.stringToCloudFormation(properties.acceptLanguage) }) : properties;
    }
    function CfnPortfolioPrincipalAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("portfolioId", "PortfolioId", cfn_parse.FromCloudFormation.getString(properties.PortfolioId)), ret.addPropertyResult("principalArn", "PrincipalARN", cfn_parse.FromCloudFormation.getString(properties.PrincipalARN)), ret.addPropertyResult("principalType", "PrincipalType", cfn_parse.FromCloudFormation.getString(properties.PrincipalType)), ret.addPropertyResult("acceptLanguage", "AcceptLanguage", properties.AcceptLanguage != null ? cfn_parse.FromCloudFormation.getString(properties.AcceptLanguage) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPortfolioPrincipalAssociation = class _CfnPortfolioPrincipalAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPortfolioPrincipalAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnPortfolioPrincipalAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPortfolioPrincipalAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicecatalog_CfnPortfolioPrincipalAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPortfolioPrincipalAssociation), error;
        }
        cdk.requireProperty(props, "portfolioId", this), cdk.requireProperty(props, "principalArn", this), cdk.requireProperty(props, "principalType", this), this.portfolioId = props.portfolioId, this.principalArn = props.principalArn, this.principalType = props.principalType, this.acceptLanguage = props.acceptLanguage;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPortfolioPrincipalAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { portfolioId: this.portfolioId, principalArn: this.principalArn, principalType: this.principalType, acceptLanguage: this.acceptLanguage };
      }
      renderProperties(props) {
        return cfnPortfolioPrincipalAssociationPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnPortfolioPrincipalAssociation[_h] = { fqn: "aws-cdk-lib.aws_servicecatalog.CfnPortfolioPrincipalAssociation", version: "2.80.0" }, CfnPortfolioPrincipalAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::ServiceCatalog::PortfolioPrincipalAssociation", exports2.CfnPortfolioPrincipalAssociation = CfnPortfolioPrincipalAssociation;
    function CfnPortfolioProductAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acceptLanguage", cdk.validateString)(properties.acceptLanguage)), errors.collect(cdk.propertyValidator("portfolioId", cdk.requiredValidator)(properties.portfolioId)), errors.collect(cdk.propertyValidator("portfolioId", cdk.validateString)(properties.portfolioId)), errors.collect(cdk.propertyValidator("productId", cdk.requiredValidator)(properties.productId)), errors.collect(cdk.propertyValidator("productId", cdk.validateString)(properties.productId)), errors.collect(cdk.propertyValidator("sourcePortfolioId", cdk.validateString)(properties.sourcePortfolioId)), errors.wrap('supplied properties not correct for "CfnPortfolioProductAssociationProps"');
    }
    function cfnPortfolioProductAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPortfolioProductAssociationPropsValidator(properties).assertSuccess(), { PortfolioId: cdk.stringToCloudFormation(properties.portfolioId), ProductId: cdk.stringToCloudFormation(properties.productId), AcceptLanguage: cdk.stringToCloudFormation(properties.acceptLanguage), SourcePortfolioId: cdk.stringToCloudFormation(properties.sourcePortfolioId) }) : properties;
    }
    function CfnPortfolioProductAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("portfolioId", "PortfolioId", cfn_parse.FromCloudFormation.getString(properties.PortfolioId)), ret.addPropertyResult("productId", "ProductId", cfn_parse.FromCloudFormation.getString(properties.ProductId)), ret.addPropertyResult("acceptLanguage", "AcceptLanguage", properties.AcceptLanguage != null ? cfn_parse.FromCloudFormation.getString(properties.AcceptLanguage) : void 0), ret.addPropertyResult("sourcePortfolioId", "SourcePortfolioId", properties.SourcePortfolioId != null ? cfn_parse.FromCloudFormation.getString(properties.SourcePortfolioId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPortfolioProductAssociation = class _CfnPortfolioProductAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPortfolioProductAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnPortfolioProductAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPortfolioProductAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicecatalog_CfnPortfolioProductAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPortfolioProductAssociation), error;
        }
        cdk.requireProperty(props, "portfolioId", this), cdk.requireProperty(props, "productId", this), this.portfolioId = props.portfolioId, this.productId = props.productId, this.acceptLanguage = props.acceptLanguage, this.sourcePortfolioId = props.sourcePortfolioId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPortfolioProductAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { portfolioId: this.portfolioId, productId: this.productId, acceptLanguage: this.acceptLanguage, sourcePortfolioId: this.sourcePortfolioId };
      }
      renderProperties(props) {
        return cfnPortfolioProductAssociationPropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnPortfolioProductAssociation[_j] = { fqn: "aws-cdk-lib.aws_servicecatalog.CfnPortfolioProductAssociation", version: "2.80.0" }, CfnPortfolioProductAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::ServiceCatalog::PortfolioProductAssociation", exports2.CfnPortfolioProductAssociation = CfnPortfolioProductAssociation;
    function CfnPortfolioSharePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acceptLanguage", cdk.validateString)(properties.acceptLanguage)), errors.collect(cdk.propertyValidator("accountId", cdk.requiredValidator)(properties.accountId)), errors.collect(cdk.propertyValidator("accountId", cdk.validateString)(properties.accountId)), errors.collect(cdk.propertyValidator("portfolioId", cdk.requiredValidator)(properties.portfolioId)), errors.collect(cdk.propertyValidator("portfolioId", cdk.validateString)(properties.portfolioId)), errors.collect(cdk.propertyValidator("shareTagOptions", cdk.validateBoolean)(properties.shareTagOptions)), errors.wrap('supplied properties not correct for "CfnPortfolioShareProps"');
    }
    function cfnPortfolioSharePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPortfolioSharePropsValidator(properties).assertSuccess(), { AccountId: cdk.stringToCloudFormation(properties.accountId), PortfolioId: cdk.stringToCloudFormation(properties.portfolioId), AcceptLanguage: cdk.stringToCloudFormation(properties.acceptLanguage), ShareTagOptions: cdk.booleanToCloudFormation(properties.shareTagOptions) }) : properties;
    }
    function CfnPortfolioSharePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accountId", "AccountId", cfn_parse.FromCloudFormation.getString(properties.AccountId)), ret.addPropertyResult("portfolioId", "PortfolioId", cfn_parse.FromCloudFormation.getString(properties.PortfolioId)), ret.addPropertyResult("acceptLanguage", "AcceptLanguage", properties.AcceptLanguage != null ? cfn_parse.FromCloudFormation.getString(properties.AcceptLanguage) : void 0), ret.addPropertyResult("shareTagOptions", "ShareTagOptions", properties.ShareTagOptions != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ShareTagOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPortfolioShare = class _CfnPortfolioShare extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPortfolioSharePropsFromCloudFormation(resourceProperties), ret = new _CfnPortfolioShare(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPortfolioShare.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicecatalog_CfnPortfolioShareProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPortfolioShare), error;
        }
        cdk.requireProperty(props, "accountId", this), cdk.requireProperty(props, "portfolioId", this), this.accountId = props.accountId, this.portfolioId = props.portfolioId, this.acceptLanguage = props.acceptLanguage, this.shareTagOptions = props.shareTagOptions;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPortfolioShare.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { accountId: this.accountId, portfolioId: this.portfolioId, acceptLanguage: this.acceptLanguage, shareTagOptions: this.shareTagOptions };
      }
      renderProperties(props) {
        return cfnPortfolioSharePropsToCloudFormation(props);
      }
    };
    _k = JSII_RTTI_SYMBOL_1, CfnPortfolioShare[_k] = { fqn: "aws-cdk-lib.aws_servicecatalog.CfnPortfolioShare", version: "2.80.0" }, CfnPortfolioShare.CFN_RESOURCE_TYPE_NAME = "AWS::ServiceCatalog::PortfolioShare", exports2.CfnPortfolioShare = CfnPortfolioShare;
    function CfnResourceUpdateConstraintPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acceptLanguage", cdk.validateString)(properties.acceptLanguage)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("portfolioId", cdk.requiredValidator)(properties.portfolioId)), errors.collect(cdk.propertyValidator("portfolioId", cdk.validateString)(properties.portfolioId)), errors.collect(cdk.propertyValidator("productId", cdk.requiredValidator)(properties.productId)), errors.collect(cdk.propertyValidator("productId", cdk.validateString)(properties.productId)), errors.collect(cdk.propertyValidator("tagUpdateOnProvisionedProduct", cdk.requiredValidator)(properties.tagUpdateOnProvisionedProduct)), errors.collect(cdk.propertyValidator("tagUpdateOnProvisionedProduct", cdk.validateString)(properties.tagUpdateOnProvisionedProduct)), errors.wrap('supplied properties not correct for "CfnResourceUpdateConstraintProps"');
    }
    function cfnResourceUpdateConstraintPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceUpdateConstraintPropsValidator(properties).assertSuccess(), { PortfolioId: cdk.stringToCloudFormation(properties.portfolioId), ProductId: cdk.stringToCloudFormation(properties.productId), TagUpdateOnProvisionedProduct: cdk.stringToCloudFormation(properties.tagUpdateOnProvisionedProduct), AcceptLanguage: cdk.stringToCloudFormation(properties.acceptLanguage), Description: cdk.stringToCloudFormation(properties.description) }) : properties;
    }
    function CfnResourceUpdateConstraintPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("portfolioId", "PortfolioId", cfn_parse.FromCloudFormation.getString(properties.PortfolioId)), ret.addPropertyResult("productId", "ProductId", cfn_parse.FromCloudFormation.getString(properties.ProductId)), ret.addPropertyResult("tagUpdateOnProvisionedProduct", "TagUpdateOnProvisionedProduct", cfn_parse.FromCloudFormation.getString(properties.TagUpdateOnProvisionedProduct)), ret.addPropertyResult("acceptLanguage", "AcceptLanguage", properties.AcceptLanguage != null ? cfn_parse.FromCloudFormation.getString(properties.AcceptLanguage) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResourceUpdateConstraint = class _CfnResourceUpdateConstraint extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResourceUpdateConstraintPropsFromCloudFormation(resourceProperties), ret = new _CfnResourceUpdateConstraint(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnResourceUpdateConstraint.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicecatalog_CfnResourceUpdateConstraintProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResourceUpdateConstraint), error;
        }
        cdk.requireProperty(props, "portfolioId", this), cdk.requireProperty(props, "productId", this), cdk.requireProperty(props, "tagUpdateOnProvisionedProduct", this), this.portfolioId = props.portfolioId, this.productId = props.productId, this.tagUpdateOnProvisionedProduct = props.tagUpdateOnProvisionedProduct, this.acceptLanguage = props.acceptLanguage, this.description = props.description;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResourceUpdateConstraint.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { portfolioId: this.portfolioId, productId: this.productId, tagUpdateOnProvisionedProduct: this.tagUpdateOnProvisionedProduct, acceptLanguage: this.acceptLanguage, description: this.description };
      }
      renderProperties(props) {
        return cfnResourceUpdateConstraintPropsToCloudFormation(props);
      }
    };
    _l = JSII_RTTI_SYMBOL_1, CfnResourceUpdateConstraint[_l] = { fqn: "aws-cdk-lib.aws_servicecatalog.CfnResourceUpdateConstraint", version: "2.80.0" }, CfnResourceUpdateConstraint.CFN_RESOURCE_TYPE_NAME = "AWS::ServiceCatalog::ResourceUpdateConstraint", exports2.CfnResourceUpdateConstraint = CfnResourceUpdateConstraint;
    function CfnServiceActionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acceptLanguage", cdk.validateString)(properties.acceptLanguage)), errors.collect(cdk.propertyValidator("definition", cdk.requiredValidator)(properties.definition)), errors.collect(cdk.propertyValidator("definition", cdk.listValidator(CfnServiceAction_DefinitionParameterPropertyValidator))(properties.definition)), errors.collect(cdk.propertyValidator("definitionType", cdk.requiredValidator)(properties.definitionType)), errors.collect(cdk.propertyValidator("definitionType", cdk.validateString)(properties.definitionType)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "CfnServiceActionProps"');
    }
    function cfnServiceActionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnServiceActionPropsValidator(properties).assertSuccess(), { Definition: cdk.listMapper(cfnServiceActionDefinitionParameterPropertyToCloudFormation)(properties.definition), DefinitionType: cdk.stringToCloudFormation(properties.definitionType), Name: cdk.stringToCloudFormation(properties.name), AcceptLanguage: cdk.stringToCloudFormation(properties.acceptLanguage), Description: cdk.stringToCloudFormation(properties.description) }) : properties;
    }
    function CfnServiceActionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("definition", "Definition", cfn_parse.FromCloudFormation.getArray(CfnServiceActionDefinitionParameterPropertyFromCloudFormation)(properties.Definition)), ret.addPropertyResult("definitionType", "DefinitionType", cfn_parse.FromCloudFormation.getString(properties.DefinitionType)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("acceptLanguage", "AcceptLanguage", properties.AcceptLanguage != null ? cfn_parse.FromCloudFormation.getString(properties.AcceptLanguage) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnServiceAction = class _CfnServiceAction extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnServiceActionPropsFromCloudFormation(resourceProperties), ret = new _CfnServiceAction(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnServiceAction.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicecatalog_CfnServiceActionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnServiceAction), error;
        }
        cdk.requireProperty(props, "definition", this), cdk.requireProperty(props, "definitionType", this), cdk.requireProperty(props, "name", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.definition = props.definition, this.definitionType = props.definitionType, this.name = props.name, this.acceptLanguage = props.acceptLanguage, this.description = props.description;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnServiceAction.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { definition: this.definition, definitionType: this.definitionType, name: this.name, acceptLanguage: this.acceptLanguage, description: this.description };
      }
      renderProperties(props) {
        return cfnServiceActionPropsToCloudFormation(props);
      }
    };
    _m = JSII_RTTI_SYMBOL_1, CfnServiceAction[_m] = { fqn: "aws-cdk-lib.aws_servicecatalog.CfnServiceAction", version: "2.80.0" }, CfnServiceAction.CFN_RESOURCE_TYPE_NAME = "AWS::ServiceCatalog::ServiceAction", exports2.CfnServiceAction = CfnServiceAction;
    function CfnServiceAction_DefinitionParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "DefinitionParameterProperty"');
    }
    function cfnServiceActionDefinitionParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnServiceAction_DefinitionParameterPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnServiceActionDefinitionParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnServiceActionAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("productId", cdk.requiredValidator)(properties.productId)), errors.collect(cdk.propertyValidator("productId", cdk.validateString)(properties.productId)), errors.collect(cdk.propertyValidator("provisioningArtifactId", cdk.requiredValidator)(properties.provisioningArtifactId)), errors.collect(cdk.propertyValidator("provisioningArtifactId", cdk.validateString)(properties.provisioningArtifactId)), errors.collect(cdk.propertyValidator("serviceActionId", cdk.requiredValidator)(properties.serviceActionId)), errors.collect(cdk.propertyValidator("serviceActionId", cdk.validateString)(properties.serviceActionId)), errors.wrap('supplied properties not correct for "CfnServiceActionAssociationProps"');
    }
    function cfnServiceActionAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnServiceActionAssociationPropsValidator(properties).assertSuccess(), { ProductId: cdk.stringToCloudFormation(properties.productId), ProvisioningArtifactId: cdk.stringToCloudFormation(properties.provisioningArtifactId), ServiceActionId: cdk.stringToCloudFormation(properties.serviceActionId) }) : properties;
    }
    function CfnServiceActionAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("productId", "ProductId", cfn_parse.FromCloudFormation.getString(properties.ProductId)), ret.addPropertyResult("provisioningArtifactId", "ProvisioningArtifactId", cfn_parse.FromCloudFormation.getString(properties.ProvisioningArtifactId)), ret.addPropertyResult("serviceActionId", "ServiceActionId", cfn_parse.FromCloudFormation.getString(properties.ServiceActionId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnServiceActionAssociation = class _CfnServiceActionAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnServiceActionAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnServiceActionAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnServiceActionAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicecatalog_CfnServiceActionAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnServiceActionAssociation), error;
        }
        cdk.requireProperty(props, "productId", this), cdk.requireProperty(props, "provisioningArtifactId", this), cdk.requireProperty(props, "serviceActionId", this), this.productId = props.productId, this.provisioningArtifactId = props.provisioningArtifactId, this.serviceActionId = props.serviceActionId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnServiceActionAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { productId: this.productId, provisioningArtifactId: this.provisioningArtifactId, serviceActionId: this.serviceActionId };
      }
      renderProperties(props) {
        return cfnServiceActionAssociationPropsToCloudFormation(props);
      }
    };
    _o = JSII_RTTI_SYMBOL_1, CfnServiceActionAssociation[_o] = { fqn: "aws-cdk-lib.aws_servicecatalog.CfnServiceActionAssociation", version: "2.80.0" }, CfnServiceActionAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::ServiceCatalog::ServiceActionAssociation", exports2.CfnServiceActionAssociation = CfnServiceActionAssociation;
    function CfnStackSetConstraintPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("acceptLanguage", cdk.validateString)(properties.acceptLanguage)), errors.collect(cdk.propertyValidator("accountList", cdk.requiredValidator)(properties.accountList)), errors.collect(cdk.propertyValidator("accountList", cdk.listValidator(cdk.validateString))(properties.accountList)), errors.collect(cdk.propertyValidator("adminRole", cdk.requiredValidator)(properties.adminRole)), errors.collect(cdk.propertyValidator("adminRole", cdk.validateString)(properties.adminRole)), errors.collect(cdk.propertyValidator("description", cdk.requiredValidator)(properties.description)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("executionRole", cdk.requiredValidator)(properties.executionRole)), errors.collect(cdk.propertyValidator("executionRole", cdk.validateString)(properties.executionRole)), errors.collect(cdk.propertyValidator("portfolioId", cdk.requiredValidator)(properties.portfolioId)), errors.collect(cdk.propertyValidator("portfolioId", cdk.validateString)(properties.portfolioId)), errors.collect(cdk.propertyValidator("productId", cdk.requiredValidator)(properties.productId)), errors.collect(cdk.propertyValidator("productId", cdk.validateString)(properties.productId)), errors.collect(cdk.propertyValidator("regionList", cdk.requiredValidator)(properties.regionList)), errors.collect(cdk.propertyValidator("regionList", cdk.listValidator(cdk.validateString))(properties.regionList)), errors.collect(cdk.propertyValidator("stackInstanceControl", cdk.requiredValidator)(properties.stackInstanceControl)), errors.collect(cdk.propertyValidator("stackInstanceControl", cdk.validateString)(properties.stackInstanceControl)), errors.wrap('supplied properties not correct for "CfnStackSetConstraintProps"');
    }
    function cfnStackSetConstraintPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnStackSetConstraintPropsValidator(properties).assertSuccess(), { AccountList: cdk.listMapper(cdk.stringToCloudFormation)(properties.accountList), AdminRole: cdk.stringToCloudFormation(properties.adminRole), Description: cdk.stringToCloudFormation(properties.description), ExecutionRole: cdk.stringToCloudFormation(properties.executionRole), PortfolioId: cdk.stringToCloudFormation(properties.portfolioId), ProductId: cdk.stringToCloudFormation(properties.productId), RegionList: cdk.listMapper(cdk.stringToCloudFormation)(properties.regionList), StackInstanceControl: cdk.stringToCloudFormation(properties.stackInstanceControl), AcceptLanguage: cdk.stringToCloudFormation(properties.acceptLanguage) }) : properties;
    }
    function CfnStackSetConstraintPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accountList", "AccountList", cfn_parse.FromCloudFormation.getStringArray(properties.AccountList)), ret.addPropertyResult("adminRole", "AdminRole", cfn_parse.FromCloudFormation.getString(properties.AdminRole)), ret.addPropertyResult("description", "Description", cfn_parse.FromCloudFormation.getString(properties.Description)), ret.addPropertyResult("executionRole", "ExecutionRole", cfn_parse.FromCloudFormation.getString(properties.ExecutionRole)), ret.addPropertyResult("portfolioId", "PortfolioId", cfn_parse.FromCloudFormation.getString(properties.PortfolioId)), ret.addPropertyResult("productId", "ProductId", cfn_parse.FromCloudFormation.getString(properties.ProductId)), ret.addPropertyResult("regionList", "RegionList", cfn_parse.FromCloudFormation.getStringArray(properties.RegionList)), ret.addPropertyResult("stackInstanceControl", "StackInstanceControl", cfn_parse.FromCloudFormation.getString(properties.StackInstanceControl)), ret.addPropertyResult("acceptLanguage", "AcceptLanguage", properties.AcceptLanguage != null ? cfn_parse.FromCloudFormation.getString(properties.AcceptLanguage) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnStackSetConstraint = class _CfnStackSetConstraint extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnStackSetConstraintPropsFromCloudFormation(resourceProperties), ret = new _CfnStackSetConstraint(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnStackSetConstraint.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicecatalog_CfnStackSetConstraintProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnStackSetConstraint), error;
        }
        cdk.requireProperty(props, "accountList", this), cdk.requireProperty(props, "adminRole", this), cdk.requireProperty(props, "description", this), cdk.requireProperty(props, "executionRole", this), cdk.requireProperty(props, "portfolioId", this), cdk.requireProperty(props, "productId", this), cdk.requireProperty(props, "regionList", this), cdk.requireProperty(props, "stackInstanceControl", this), this.accountList = props.accountList, this.adminRole = props.adminRole, this.description = props.description, this.executionRole = props.executionRole, this.portfolioId = props.portfolioId, this.productId = props.productId, this.regionList = props.regionList, this.stackInstanceControl = props.stackInstanceControl, this.acceptLanguage = props.acceptLanguage;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnStackSetConstraint.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { accountList: this.accountList, adminRole: this.adminRole, description: this.description, executionRole: this.executionRole, portfolioId: this.portfolioId, productId: this.productId, regionList: this.regionList, stackInstanceControl: this.stackInstanceControl, acceptLanguage: this.acceptLanguage };
      }
      renderProperties(props) {
        return cfnStackSetConstraintPropsToCloudFormation(props);
      }
    };
    _p = JSII_RTTI_SYMBOL_1, CfnStackSetConstraint[_p] = { fqn: "aws-cdk-lib.aws_servicecatalog.CfnStackSetConstraint", version: "2.80.0" }, CfnStackSetConstraint.CFN_RESOURCE_TYPE_NAME = "AWS::ServiceCatalog::StackSetConstraint", exports2.CfnStackSetConstraint = CfnStackSetConstraint;
    function CfnTagOptionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("active", cdk.validateBoolean)(properties.active)), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "CfnTagOptionProps"');
    }
    function cfnTagOptionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTagOptionPropsValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cdk.stringToCloudFormation(properties.value), Active: cdk.booleanToCloudFormation(properties.active) }) : properties;
    }
    function CfnTagOptionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addPropertyResult("active", "Active", properties.Active != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Active) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTagOption = class _CfnTagOption extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTagOptionPropsFromCloudFormation(resourceProperties), ret = new _CfnTagOption(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTagOption.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicecatalog_CfnTagOptionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTagOption), error;
        }
        cdk.requireProperty(props, "key", this), cdk.requireProperty(props, "value", this), this.key = props.key, this.value = props.value, this.active = props.active;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTagOption.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { key: this.key, value: this.value, active: this.active };
      }
      renderProperties(props) {
        return cfnTagOptionPropsToCloudFormation(props);
      }
    };
    _q = JSII_RTTI_SYMBOL_1, CfnTagOption[_q] = { fqn: "aws-cdk-lib.aws_servicecatalog.CfnTagOption", version: "2.80.0" }, CfnTagOption.CFN_RESOURCE_TYPE_NAME = "AWS::ServiceCatalog::TagOption", exports2.CfnTagOption = CfnTagOption;
    function CfnTagOptionAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceId", cdk.requiredValidator)(properties.resourceId)), errors.collect(cdk.propertyValidator("resourceId", cdk.validateString)(properties.resourceId)), errors.collect(cdk.propertyValidator("tagOptionId", cdk.requiredValidator)(properties.tagOptionId)), errors.collect(cdk.propertyValidator("tagOptionId", cdk.validateString)(properties.tagOptionId)), errors.wrap('supplied properties not correct for "CfnTagOptionAssociationProps"');
    }
    function cfnTagOptionAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTagOptionAssociationPropsValidator(properties).assertSuccess(), { ResourceId: cdk.stringToCloudFormation(properties.resourceId), TagOptionId: cdk.stringToCloudFormation(properties.tagOptionId) }) : properties;
    }
    function CfnTagOptionAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceId", "ResourceId", cfn_parse.FromCloudFormation.getString(properties.ResourceId)), ret.addPropertyResult("tagOptionId", "TagOptionId", cfn_parse.FromCloudFormation.getString(properties.TagOptionId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTagOptionAssociation = class _CfnTagOptionAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTagOptionAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnTagOptionAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTagOptionAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicecatalog_CfnTagOptionAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTagOptionAssociation), error;
        }
        cdk.requireProperty(props, "resourceId", this), cdk.requireProperty(props, "tagOptionId", this), this.resourceId = props.resourceId, this.tagOptionId = props.tagOptionId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTagOptionAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { resourceId: this.resourceId, tagOptionId: this.tagOptionId };
      }
      renderProperties(props) {
        return cfnTagOptionAssociationPropsToCloudFormation(props);
      }
    };
    _r = JSII_RTTI_SYMBOL_1, CfnTagOptionAssociation[_r] = { fqn: "aws-cdk-lib.aws_servicecatalog.CfnTagOptionAssociation", version: "2.80.0" }, CfnTagOptionAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::ServiceCatalog::TagOptionAssociation", exports2.CfnTagOptionAssociation = CfnTagOptionAssociation;
  }
});

// node_modules/aws-cdk-lib/aws-servicecatalog/lib/private/association-manager.js
var require_association_manager = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicecatalog/lib/private/association-manager.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AssociationManager = void 0;
    var util_1 = require_util20();
    var validation_1 = require_validation4();
    var servicecatalog_generated_1 = require_servicecatalog_generated();
    var AssociationManager = class {
      static associateProductWithPortfolio(portfolio, product, options) {
        validation_1.InputValidator.validateLength(this.prettyPrintAssociation(portfolio, product), "description", 0, 2e3, options?.description);
        const associationKey = (0, util_1.hashValues)(portfolio.node.addr, product.node.addr, product.stack.node.addr), constructId = `PortfolioProductAssociation${associationKey}`, existingAssociation = portfolio.node.tryFindChild(constructId), cfnAssociation = existingAssociation || new servicecatalog_generated_1.CfnPortfolioProductAssociation(portfolio, constructId, { portfolioId: portfolio.portfolioId, productId: product.productId });
        return { associationKey, cfnPortfolioProductAssociation: cfnAssociation };
      }
      static constrainTagUpdates(portfolio, product, options) {
        const association = this.associateProductWithPortfolio(portfolio, product, options), constructId = `ResourceUpdateConstraint${association.associationKey}`;
        if (!portfolio.node.tryFindChild(constructId))
          new servicecatalog_generated_1.CfnResourceUpdateConstraint(portfolio, constructId, { acceptLanguage: options.messageLanguage, description: options.description, portfolioId: portfolio.portfolioId, productId: product.productId, tagUpdateOnProvisionedProduct: options.allow === false ? "NOT_ALLOWED" : "ALLOWED" }).addDependency(association.cfnPortfolioProductAssociation);
        else
          throw new Error(`Cannot have multiple tag update constraints for association ${this.prettyPrintAssociation(portfolio, product)}`);
      }
      static notifyOnStackEvents(portfolio, product, topic, options) {
        const association = this.associateProductWithPortfolio(portfolio, product, options), constructId = `LaunchNotificationConstraint${(0, util_1.hashValues)(topic.node.addr, topic.stack.node.addr, association.associationKey)}`;
        if (!portfolio.node.tryFindChild(constructId))
          new servicecatalog_generated_1.CfnLaunchNotificationConstraint(portfolio, constructId, { acceptLanguage: options.messageLanguage, description: options.description, portfolioId: portfolio.portfolioId, productId: product.productId, notificationArns: [topic.topicArn] }).addDependency(association.cfnPortfolioProductAssociation);
        else
          throw new Error(`Topic ${topic.node.path} is already subscribed to association ${this.prettyPrintAssociation(portfolio, product)}`);
      }
      static constrainCloudFormationParameters(portfolio, product, options) {
        const association = this.associateProductWithPortfolio(portfolio, product, options), constructId = `LaunchTemplateConstraint${(0, util_1.hashValues)(association.associationKey, options.rule.ruleName)}`;
        if (!portfolio.node.tryFindChild(constructId))
          new servicecatalog_generated_1.CfnLaunchTemplateConstraint(portfolio, constructId, { acceptLanguage: options.messageLanguage, description: options.description, portfolioId: portfolio.portfolioId, productId: product.productId, rules: this.formatTemplateRule(portfolio.stack, options.rule) }).addDependency(association.cfnPortfolioProductAssociation);
        else
          throw new Error(`Provisioning rule ${options.rule.ruleName} already configured on association ${this.prettyPrintAssociation(portfolio, product)}`);
      }
      static setLaunchRole(portfolio, product, launchRole, options) {
        this.setLaunchRoleConstraint(portfolio, product, options, { roleArn: launchRole.roleArn });
      }
      static setLocalLaunchRoleName(portfolio, product, launchRoleName, options) {
        this.setLaunchRoleConstraint(portfolio, product, options, { localRoleName: launchRoleName });
      }
      static deployWithStackSets(portfolio, product, options) {
        const association = this.associateProductWithPortfolio(portfolio, product, options);
        if (portfolio.node.tryFindChild(this.launchRoleConstraintLogicalId(association.associationKey)))
          throw new Error(`Cannot configure StackSet deployment when a launch role is already defined for association ${this.prettyPrintAssociation(portfolio, product)}`);
        const constructId = this.stackSetConstraintLogicalId(association.associationKey);
        if (!portfolio.node.tryFindChild(constructId))
          new servicecatalog_generated_1.CfnStackSetConstraint(portfolio, constructId, { acceptLanguage: options.messageLanguage, description: options.description ?? "", portfolioId: portfolio.portfolioId, productId: product.productId, accountList: options.accounts, regionList: options.regions, adminRole: options.adminRole.roleArn, executionRole: options.executionRoleName, stackInstanceControl: options.allowStackSetInstanceOperations ? "ALLOWED" : "NOT_ALLOWED" }).addDependency(association.cfnPortfolioProductAssociation);
        else
          throw new Error(`Cannot configure multiple StackSet deployment constraints for association ${this.prettyPrintAssociation(portfolio, product)}`);
      }
      static associateTagOptions(resource, resourceId, tagOptions) {
        for (const cfnTagOption of tagOptions._cfnTagOptions) {
          const tagAssocationConstructId = `TagOptionAssociation${(0, util_1.hashValues)(cfnTagOption.key, cfnTagOption.value, resource.node.addr)}`;
          resource.node.tryFindChild(tagAssocationConstructId) || new servicecatalog_generated_1.CfnTagOptionAssociation(resource, tagAssocationConstructId, { resourceId, tagOptionId: cfnTagOption.ref });
        }
      }
      static setLaunchRoleConstraint(portfolio, product, options, roleOptions) {
        const association = this.associateProductWithPortfolio(portfolio, product, options);
        if (portfolio.node.tryFindChild(this.stackSetConstraintLogicalId(association.associationKey)))
          throw new Error(`Cannot set launch role when a StackSet rule is already defined for association ${this.prettyPrintAssociation(portfolio, product)}`);
        const constructId = this.launchRoleConstraintLogicalId(association.associationKey);
        if (!portfolio.node.tryFindChild(constructId))
          new servicecatalog_generated_1.CfnLaunchRoleConstraint(portfolio, constructId, { acceptLanguage: options.messageLanguage, description: options.description, portfolioId: portfolio.portfolioId, productId: product.productId, roleArn: roleOptions.roleArn, localRoleName: roleOptions.localRoleName }).addDependency(association.cfnPortfolioProductAssociation);
        else
          throw new Error(`Cannot set multiple launch roles for association ${this.prettyPrintAssociation(portfolio, product)}`);
      }
      static stackSetConstraintLogicalId(associationKey) {
        return `StackSetConstraint${associationKey}`;
      }
      static launchRoleConstraintLogicalId(associationKey) {
        return `LaunchRoleConstraint${associationKey}`;
      }
      static prettyPrintAssociation(portfolio, product) {
        return `- Portfolio: ${portfolio.node.path} | Product: ${product.node.path}`;
      }
      static formatTemplateRule(stack, rule) {
        return JSON.stringify({ [rule.ruleName]: { Assertions: this.formatAssertions(stack, rule.assertions), RuleCondition: rule.condition ? stack.resolve(rule.condition) : void 0 } });
      }
      static formatAssertions(stack, assertions) {
        return assertions.reduce((formattedAssertions, assertion) => (formattedAssertions.push({ Assert: stack.resolve(assertion.assert), AssertDescription: assertion.description }), formattedAssertions), new Array());
      }
    };
    exports2.AssociationManager = AssociationManager;
  }
});

// node_modules/aws-cdk-lib/aws-servicecatalog/lib/portfolio.js
var require_portfolio = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicecatalog/lib/portfolio.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Portfolio = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var association_manager_1 = require_association_manager();
    var util_1 = require_util20();
    var validation_1 = require_validation4();
    var servicecatalog_generated_1 = require_servicecatalog_generated();
    var iam = require_aws_iam();
    var cdk = require_core2();
    var PortfolioBase = class extends cdk.Resource {
      constructor() {
        super(...arguments), this.associatedPrincipals = /* @__PURE__ */ new Set(), this.assetBuckets = /* @__PURE__ */ new Set(), this.sharedAccounts = [];
      }
      giveAccessToRole(role) {
        this.associatePrincipal(role.roleArn, role.node.addr);
      }
      giveAccessToUser(user) {
        this.associatePrincipal(user.userArn, user.node.addr);
      }
      giveAccessToGroup(group) {
        this.associatePrincipal(group.groupArn, group.node.addr);
      }
      addProduct(product) {
        if (product.assetBuckets)
          for (const bucket of product.assetBuckets)
            this.assetBuckets.add(bucket);
        association_manager_1.AssociationManager.associateProductWithPortfolio(this, product, void 0);
      }
      shareWithAccount(accountId, options = {}) {
        const hashId = this.generateUniqueHash(accountId);
        this.sharedAccounts.push(accountId), new servicecatalog_generated_1.CfnPortfolioShare(this, `PortfolioShare${hashId}`, { portfolioId: this.portfolioId, accountId, shareTagOptions: options.shareTagOptions, acceptLanguage: options.messageLanguage });
      }
      associateTagOptions(tagOptions) {
        association_manager_1.AssociationManager.associateTagOptions(this, this.portfolioId, tagOptions);
      }
      constrainTagUpdates(product, options = {}) {
        association_manager_1.AssociationManager.constrainTagUpdates(this, product, options);
      }
      notifyOnStackEvents(product, topic, options = {}) {
        association_manager_1.AssociationManager.notifyOnStackEvents(this, product, topic, options);
      }
      constrainCloudFormationParameters(product, options) {
        association_manager_1.AssociationManager.constrainCloudFormationParameters(this, product, options);
      }
      setLaunchRole(product, launchRole, options = {}) {
        association_manager_1.AssociationManager.setLaunchRole(this, product, launchRole, options);
      }
      setLocalLaunchRoleName(product, launchRoleName, options = {}) {
        const launchRole = new iam.Role(this, `LaunchRole${launchRoleName}`, { roleName: launchRoleName, assumedBy: new iam.ServicePrincipal("servicecatalog.amazonaws.com") });
        return association_manager_1.AssociationManager.setLocalLaunchRoleName(this, product, launchRole.roleName, options), launchRole;
      }
      setLocalLaunchRole(product, launchRole, options = {}) {
        validation_1.InputValidator.validateRoleNameSetForLocalLaunchRole(launchRole), association_manager_1.AssociationManager.setLocalLaunchRoleName(this, product, launchRole.roleName, options);
      }
      deployWithStackSets(product, options) {
        association_manager_1.AssociationManager.deployWithStackSets(this, product, options);
      }
      associatePrincipal(principalArn, principalId) {
        if (!this.associatedPrincipals.has(principalArn)) {
          const hashId = this.generateUniqueHash(principalId);
          new servicecatalog_generated_1.CfnPortfolioPrincipalAssociation(this, `PortolioPrincipalAssociation${hashId}`, { portfolioId: this.portfolioId, principalArn, principalType: "IAM" }), this.associatedPrincipals.add(principalArn);
        }
      }
      addBucketPermissionsToSharedAccounts() {
        if (this.sharedAccounts.length > 0)
          for (const bucket of this.assetBuckets)
            bucket.grantRead(new iam.CompositePrincipal(...this.sharedAccounts.map((account) => new iam.AccountPrincipal(account))));
      }
    };
    var Portfolio = class _Portfolio extends PortfolioBase {
      static fromPortfolioArn(scope, id, portfolioArn) {
        const portfolioId = cdk.Stack.of(scope).splitArn(portfolioArn, cdk.ArnFormat.SLASH_RESOURCE_NAME).resourceName;
        if (!portfolioId)
          throw new Error("Missing required Portfolio ID from Portfolio ARN: " + portfolioArn);
        class Import extends PortfolioBase {
          constructor() {
            super(...arguments), this.portfolioArn = portfolioArn, this.portfolioId = portfolioId;
          }
          generateUniqueHash(value) {
            return (0, util_1.hashValues)(this.portfolioArn, value);
          }
        }
        return new Import(scope, id, { environmentFromArn: portfolioArn });
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicecatalog_PortfolioProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Portfolio), error;
        }
        this.validatePortfolioProps(props), this.portfolio = new servicecatalog_generated_1.CfnPortfolio(this, "Resource", { displayName: props.displayName, providerName: props.providerName, description: props.description, acceptLanguage: props.messageLanguage }), this.portfolioId = this.portfolio.ref, this.portfolioArn = cdk.Stack.of(this).formatArn({ service: "catalog", resource: "portfolio", resourceName: this.portfolioId }), props.tagOptions !== void 0 && this.associateTagOptions(props.tagOptions);
        const portfolioNodeId = this.node.id;
        cdk.Aspects.of(this).add({ visit(c) {
          c.node.id === portfolioNodeId && c.addBucketPermissionsToSharedAccounts();
        } });
      }
      generateUniqueHash(value) {
        return (0, util_1.hashValues)(cdk.Names.nodeUniqueId(this.portfolio.node), value);
      }
      validatePortfolioProps(props) {
        validation_1.InputValidator.validateLength(this.node.path, "portfolio display name", 1, 100, props.displayName), validation_1.InputValidator.validateLength(this.node.path, "portfolio provider name", 1, 50, props.providerName), validation_1.InputValidator.validateLength(this.node.path, "portfolio description", 0, 2e3, props.description);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Portfolio[_a] = { fqn: "aws-cdk-lib.aws_servicecatalog.Portfolio", version: "2.80.0" }, exports2.Portfolio = Portfolio;
  }
});

// node_modules/aws-cdk-lib/aws-servicecatalog/lib/product.js
var require_product = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicecatalog/lib/product.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CloudFormationProduct = exports2.Product = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var association_manager_1 = require_association_manager();
    var validation_1 = require_validation4();
    var servicecatalog_generated_1 = require_servicecatalog_generated();
    var core_1 = require_core2();
    var ProductBase = class extends core_1.Resource {
      associateTagOptions(tagOptions) {
        association_manager_1.AssociationManager.associateTagOptions(this, this.productId, tagOptions);
      }
    };
    var Product = class extends ProductBase {
      static fromProductArn(scope, id, productArn) {
        const productId = core_1.Stack.of(scope).splitArn(productArn, core_1.ArnFormat.SLASH_RESOURCE_NAME).resourceName;
        if (!productId)
          throw new Error("Missing required Portfolio ID from Portfolio ARN: " + productArn);
        return new class extends ProductBase {
          constructor() {
            super(...arguments), this.productId = productId, this.productArn = productArn, this.assetBuckets = [];
          }
        }(scope, id);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Product[_a] = { fqn: "aws-cdk-lib.aws_servicecatalog.Product", version: "2.80.0" }, exports2.Product = Product;
    var CloudFormationProduct = class _CloudFormationProduct extends Product {
      constructor(scope, id, props) {
        super(scope, id), this.assetBuckets = new Array();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicecatalog_CloudFormationProductProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CloudFormationProduct), error;
        }
        this.validateProductProps(props);
        const product = new servicecatalog_generated_1.CfnCloudFormationProduct(this, "Resource", { acceptLanguage: props.messageLanguage, description: props.description, distributor: props.distributor, name: props.productName, owner: props.owner, provisioningArtifactParameters: this.renderProvisioningArtifacts(props), replaceProvisioningArtifacts: props.replaceProductVersionIds, supportDescription: props.supportDescription, supportEmail: props.supportEmail, supportUrl: props.supportUrl });
        this.productId = product.ref, this.productArn = core_1.Stack.of(this).formatArn({ service: "catalog", resource: "product", resourceName: product.ref }), props.tagOptions !== void 0 && this.associateTagOptions(props.tagOptions);
      }
      renderProvisioningArtifacts(props) {
        return props.productVersions.map((productVersion) => {
          const template = productVersion.cloudFormationTemplate.bind(this);
          return template.assetBucket && this.assetBuckets.push(template.assetBucket), validation_1.InputValidator.validateUrl(this.node.path, "provisioning template url", template.httpUrl), { name: productVersion.productVersionName, description: productVersion.description, disableTemplateValidation: productVersion.validateTemplate === false, info: { LoadTemplateFromURL: template.httpUrl } };
        });
      }
      validateProductProps(props) {
        if (validation_1.InputValidator.validateLength(this.node.path, "product product name", 1, 100, props.productName), validation_1.InputValidator.validateLength(this.node.path, "product owner", 1, 8191, props.owner), validation_1.InputValidator.validateLength(this.node.path, "product description", 0, 8191, props.description), validation_1.InputValidator.validateLength(this.node.path, "product distributor", 0, 8191, props.distributor), validation_1.InputValidator.validateEmail(this.node.path, "support email", props.supportEmail), validation_1.InputValidator.validateUrl(this.node.path, "support url", props.supportUrl), validation_1.InputValidator.validateLength(this.node.path, "support description", 0, 8191, props.supportDescription), props.productVersions.length == 0)
          throw new Error(`Invalid product versions for resource ${this.node.path}, must contain at least 1 product version`);
        props.productVersions.forEach((productVersion) => {
          validation_1.InputValidator.validateLength(this.node.path, "provisioning artifact name", 0, 100, productVersion.productVersionName), validation_1.InputValidator.validateLength(this.node.path, "provisioning artifact description", 0, 8191, productVersion.description);
        });
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CloudFormationProduct[_b] = { fqn: "aws-cdk-lib.aws_servicecatalog.CloudFormationProduct", version: "2.80.0" }, exports2.CloudFormationProduct = CloudFormationProduct;
  }
});

// node_modules/aws-cdk-lib/aws-servicecatalog/lib/private/product-stack-synthesizer.js
var require_product_stack_synthesizer = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicecatalog/lib/private/product-stack-synthesizer.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ProductStackSynthesizer = void 0;
    var path = require("path");
    var aws_s3_deployment_1 = require_aws_s3_deployment();
    var cdk = require_core2();
    var ProductStackSynthesizer = class extends cdk.StackSynthesizer {
      constructor(assetBucket) {
        super(), this.assetBucket = assetBucket;
      }
      addFileAsset(asset) {
        if (!this.assetBucket)
          throw new Error("An Asset Bucket must be provided to use Assets");
        const assetPath = `${cdk.App.of(this.boundStack)?.outdir ?? "cdk.out"}/${asset.fileName}`;
        if (this.bucketDeployment)
          this.bucketDeployment.addSource(aws_s3_deployment_1.Source.asset(assetPath));
        else {
          const parentStack = this.boundStack._getParentStack();
          cdk.Resource.isOwnedResource(this.assetBucket) || cdk.Annotations.of(parentStack).addWarning("[WARNING] Bucket Policy Permissions cannot be added to referenced Bucket. Please make sure your bucket has the correct permissions"), this.bucketDeployment = new aws_s3_deployment_1.BucketDeployment(parentStack, "AssetsBucketDeployment", { sources: [aws_s3_deployment_1.Source.asset(assetPath)], destinationBucket: this.assetBucket, extract: false, prune: false });
        }
        const bucketName = this.physicalNameOfBucket(this.assetBucket);
        if (!asset.fileName)
          throw new Error("Asset file name is undefined");
        const objectKey = `${path.basename(asset.fileName).split(".")[1] + ".zip"}`, s3ObjectUrl = `s3://${bucketName}/${objectKey}`, httpUrl = `https://s3.${bucketName}/${objectKey}`;
        return { bucketName, objectKey, httpUrl, s3ObjectUrl, s3Url: httpUrl };
      }
      physicalNameOfBucket(bucket) {
        let resolvedName;
        if (cdk.Resource.isOwnedResource(bucket) ? resolvedName = cdk.Stack.of(bucket).resolve(bucket.node.defaultChild.bucketName) : resolvedName = bucket.bucketName, resolvedName === void 0)
          throw new Error("A bucketName must be provided to use Assets");
        return resolvedName;
      }
      addDockerImageAsset(_asset) {
        throw new Error("Service Catalog Product Stacks cannot use Assets");
      }
      synthesize(session) {
        this.synthesizeTemplate(session);
      }
    };
    exports2.ProductStackSynthesizer = ProductStackSynthesizer;
  }
});

// node_modules/aws-cdk-lib/aws-servicecatalog/lib/product-stack.js
var require_product_stack = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicecatalog/lib/product-stack.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ProductStack = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var crypto = require("crypto");
    var fs = require("fs");
    var path = require("path");
    var product_stack_synthesizer_1 = require_product_stack_synthesizer();
    var cdk = require_core2();
    var ProductStack = class _ProductStack extends cdk.Stack {
      constructor(scope, id, props = {}) {
        super(scope, id, { synthesizer: new product_stack_synthesizer_1.ProductStackSynthesizer(props.assetBucket) });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicecatalog_ProductStackProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ProductStack), error;
        }
        this._parentStack = findParentStack(scope), this.templateFile = `${cdk.Names.uniqueId(this)}.product.template.json`, this.assetBucket = props.assetBucket;
      }
      _setParentProductStackHistory(parentProductStackHistory) {
        return this._parentProductStackHistory = parentProductStackHistory;
      }
      _getTemplateUrl() {
        return cdk.Lazy.uncachedString({ produce: () => this._templateUrl });
      }
      _getAssetBucket() {
        return this.assetBucket;
      }
      _getParentStack() {
        return this._parentStack;
      }
      _synthesizeTemplate(session) {
        const cfn = JSON.stringify(this._toCloudFormation(), void 0, 2), templateHash = crypto.createHash("sha256").update(cfn).digest("hex");
        this._templateUrl = this._parentStack.synthesizer.addFileAsset({ packaging: cdk.FileAssetPackaging.FILE, sourceHash: templateHash, fileName: this.templateFile }).httpUrl, this._parentProductStackHistory && this._parentProductStackHistory._writeTemplateToSnapshot(cfn), fs.writeFileSync(path.join(session.assembly.outdir, this.templateFile), cfn);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ProductStack[_a] = { fqn: "aws-cdk-lib.aws_servicecatalog.ProductStack", version: "2.80.0" }, exports2.ProductStack = ProductStack;
    function findParentStack(scope) {
      try {
        return cdk.Stack.of(scope);
      } catch {
        throw new Error("Product stacks must be defined within scope of another non-product stack");
      }
    }
  }
});

// node_modules/aws-cdk-lib/aws-servicecatalog/lib/product-stack-history.js
var require_product_stack_history = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicecatalog/lib/product-stack-history.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ProductStackHistory = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var fs = require("fs");
    var path = require("path");
    var constructs_1 = require_lib2();
    var cloudformation_template_1 = require_cloudformation_template();
    var common_1 = require_common5();
    var core_1 = require_core2();
    var ProductStackHistory = class _ProductStackHistory extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicecatalog_ProductStackHistoryProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ProductStackHistory), error;
        }
        props.productStack._setParentProductStackHistory(this), this.props = props;
      }
      currentVersion() {
        return { cloudFormationTemplate: cloudformation_template_1.CloudFormationTemplate.fromProductStack(this.props.productStack), productVersionName: this.props.currentVersionName, description: this.props.description };
      }
      versionFromSnapshot(productVersionName) {
        const productStackSnapshotDirectory = this.props.directory || common_1.DEFAULT_PRODUCT_STACK_SNAPSHOT_DIRECTORY, templateFileKey = `${core_1.Names.uniqueId(this)}.${this.props.productStack.artifactId}.${productVersionName}.product.template.json`, templateFilePath = path.join(productStackSnapshotDirectory, templateFileKey);
        if (!fs.existsSync(templateFilePath))
          throw new Error(`Template ${templateFileKey} cannot be found in ${productStackSnapshotDirectory}`);
        return { cloudFormationTemplate: cloudformation_template_1.CloudFormationTemplate.fromAsset(templateFilePath), productVersionName, description: this.props.description };
      }
      _writeTemplateToSnapshot(cfn) {
        const productStackSnapshotDirectory = this.props.directory || common_1.DEFAULT_PRODUCT_STACK_SNAPSHOT_DIRECTORY;
        fs.existsSync(productStackSnapshotDirectory) || fs.mkdirSync(productStackSnapshotDirectory, { recursive: true });
        const templateFileKey = `${core_1.Names.uniqueId(this)}.${this.props.productStack.artifactId}.${this.props.currentVersionName}.product.template.json`, templateFilePath = path.join(productStackSnapshotDirectory, templateFileKey);
        if (fs.existsSync(templateFilePath) && fs.readFileSync(templateFilePath).toString() !== cfn && this.props.currentVersionLocked)
          throw new Error(`Template has changed for ProductStack Version ${this.props.currentVersionName}.
        ${this.props.currentVersionName} already exist in ${productStackSnapshotDirectory}.
        Since locked has been set to ${this.props.currentVersionLocked},
        Either update the currentVersionName to deploy a new version or deploy the existing ProductStack snapshot.
        If ${this.props.currentVersionName} was unintentionally synthesized and not deployed, 
        delete the corresponding version from ${productStackSnapshotDirectory} and redeploy.`);
        fs.writeFileSync(templateFilePath, cfn);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ProductStackHistory[_a] = { fqn: "aws-cdk-lib.aws_servicecatalog.ProductStackHistory", version: "2.80.0" }, exports2.ProductStackHistory = ProductStackHistory;
  }
});

// node_modules/aws-cdk-lib/aws-servicecatalog/lib/tag-options.js
var require_tag_options = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicecatalog/lib/tag-options.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.TagOptions = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var util_1 = require_util20();
    var validation_1 = require_validation4();
    var servicecatalog_generated_1 = require_servicecatalog_generated();
    var cdk = require_core2();
    var TagOptions = class _TagOptions extends cdk.Resource {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicecatalog_TagOptionsProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _TagOptions), error;
        }
        this._cfnTagOptions = this.createUnderlyingTagOptions(props.allowedValuesForTags);
      }
      createUnderlyingTagOptions(allowedValuesForTags) {
        if (Object.keys(allowedValuesForTags).length === 0)
          throw new Error(`No tag option keys or values were provided for resource ${this.node.path}`);
        var tagOptions = [];
        for (const [tagKey, tagValues] of Object.entries(allowedValuesForTags)) {
          validation_1.InputValidator.validateLength(this.node.addr, "TagOption key", 1, 128, tagKey);
          const uniqueTagValues = new Set(tagValues);
          if (uniqueTagValues.size === 0)
            throw new Error(`No tag option values were provided for tag option key ${tagKey} for resource ${this.node.path}`);
          uniqueTagValues.forEach((tagValue) => {
            validation_1.InputValidator.validateLength(this.node.addr, "TagOption value", 1, 256, tagValue);
            const tagOptionIdentifier = (0, util_1.hashValues)(tagKey, tagValue), tagOption = new servicecatalog_generated_1.CfnTagOption(this, tagOptionIdentifier, { key: tagKey, value: tagValue, active: true });
            tagOptions.push(tagOption);
          });
        }
        return tagOptions;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, TagOptions[_a] = { fqn: "aws-cdk-lib.aws_servicecatalog.TagOptions", version: "2.80.0" }, exports2.TagOptions = TagOptions;
  }
});

// node_modules/aws-cdk-lib/aws-servicecatalog/lib/index.js
var require_lib237 = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicecatalog/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_common5(), exports2), __exportStar(require_constraints(), exports2), __exportStar(require_cloudformation_template(), exports2), __exportStar(require_portfolio(), exports2), __exportStar(require_product(), exports2), __exportStar(require_product_stack(), exports2), __exportStar(require_product_stack_history(), exports2), __exportStar(require_tag_options(), exports2), __exportStar(require_servicecatalog_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-servicecatalog/index.js
var require_aws_servicecatalog = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicecatalog/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib237(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-servicecatalogappregistry/lib/servicecatalogappregistry.generated.js
var require_servicecatalogappregistry_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicecatalogappregistry/lib/servicecatalogappregistry.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnResourceAssociation = exports2.CfnAttributeGroupAssociation = exports2.CfnAttributeGroup = exports2.CfnApplication = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnApplicationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.wrap('supplied properties not correct for "CfnApplicationProps"');
    }
    function cfnApplicationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnApplicationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApplication = class _CfnApplication extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApplicationPropsFromCloudFormation(resourceProperties), ret = new _CfnApplication(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApplication.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicecatalogappregistry_CfnApplicationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApplication), error;
        }
        cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::ServiceCatalogAppRegistry::Application", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApplication.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnApplicationPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnApplication[_a] = { fqn: "aws-cdk-lib.aws_servicecatalogappregistry.CfnApplication", version: "2.80.0" }, CfnApplication.CFN_RESOURCE_TYPE_NAME = "AWS::ServiceCatalogAppRegistry::Application", exports2.CfnApplication = CfnApplication;
    function CfnAttributeGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributes", cdk.requiredValidator)(properties.attributes)), errors.collect(cdk.propertyValidator("attributes", cdk.validateObject)(properties.attributes)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.hashValidator(cdk.validateString))(properties.tags)), errors.wrap('supplied properties not correct for "CfnAttributeGroupProps"');
    }
    function cfnAttributeGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAttributeGroupPropsValidator(properties).assertSuccess(), { Attributes: cdk.objectToCloudFormation(properties.attributes), Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.hashMapper(cdk.stringToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnAttributeGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attributes", "Attributes", cfn_parse.FromCloudFormation.getAny(properties.Attributes)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAttributeGroup = class _CfnAttributeGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAttributeGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnAttributeGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAttributeGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicecatalogappregistry_CfnAttributeGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAttributeGroup), error;
        }
        cdk.requireProperty(props, "attributes", this), cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attributes = props.attributes, this.name = props.name, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.MAP, "AWS::ServiceCatalogAppRegistry::AttributeGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAttributeGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { attributes: this.attributes, name: this.name, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnAttributeGroupPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnAttributeGroup[_b] = { fqn: "aws-cdk-lib.aws_servicecatalogappregistry.CfnAttributeGroup", version: "2.80.0" }, CfnAttributeGroup.CFN_RESOURCE_TYPE_NAME = "AWS::ServiceCatalogAppRegistry::AttributeGroup", exports2.CfnAttributeGroup = CfnAttributeGroup;
    function CfnAttributeGroupAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("application", cdk.requiredValidator)(properties.application)), errors.collect(cdk.propertyValidator("application", cdk.validateString)(properties.application)), errors.collect(cdk.propertyValidator("attributeGroup", cdk.requiredValidator)(properties.attributeGroup)), errors.collect(cdk.propertyValidator("attributeGroup", cdk.validateString)(properties.attributeGroup)), errors.wrap('supplied properties not correct for "CfnAttributeGroupAssociationProps"');
    }
    function cfnAttributeGroupAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAttributeGroupAssociationPropsValidator(properties).assertSuccess(), { Application: cdk.stringToCloudFormation(properties.application), AttributeGroup: cdk.stringToCloudFormation(properties.attributeGroup) }) : properties;
    }
    function CfnAttributeGroupAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("application", "Application", cfn_parse.FromCloudFormation.getString(properties.Application)), ret.addPropertyResult("attributeGroup", "AttributeGroup", cfn_parse.FromCloudFormation.getString(properties.AttributeGroup)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAttributeGroupAssociation = class _CfnAttributeGroupAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAttributeGroupAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnAttributeGroupAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAttributeGroupAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicecatalogappregistry_CfnAttributeGroupAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAttributeGroupAssociation), error;
        }
        cdk.requireProperty(props, "application", this), cdk.requireProperty(props, "attributeGroup", this), this.attrApplicationArn = cdk.Token.asString(this.getAtt("ApplicationArn", cdk.ResolutionTypeHint.STRING)), this.attrAttributeGroupArn = cdk.Token.asString(this.getAtt("AttributeGroupArn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.application = props.application, this.attributeGroup = props.attributeGroup;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAttributeGroupAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { application: this.application, attributeGroup: this.attributeGroup };
      }
      renderProperties(props) {
        return cfnAttributeGroupAssociationPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnAttributeGroupAssociation[_c] = { fqn: "aws-cdk-lib.aws_servicecatalogappregistry.CfnAttributeGroupAssociation", version: "2.80.0" }, CfnAttributeGroupAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::ServiceCatalogAppRegistry::AttributeGroupAssociation", exports2.CfnAttributeGroupAssociation = CfnAttributeGroupAssociation;
    function CfnResourceAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("application", cdk.requiredValidator)(properties.application)), errors.collect(cdk.propertyValidator("application", cdk.validateString)(properties.application)), errors.collect(cdk.propertyValidator("resource", cdk.requiredValidator)(properties.resource)), errors.collect(cdk.propertyValidator("resource", cdk.validateString)(properties.resource)), errors.collect(cdk.propertyValidator("resourceType", cdk.requiredValidator)(properties.resourceType)), errors.collect(cdk.propertyValidator("resourceType", cdk.validateString)(properties.resourceType)), errors.wrap('supplied properties not correct for "CfnResourceAssociationProps"');
    }
    function cfnResourceAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourceAssociationPropsValidator(properties).assertSuccess(), { Application: cdk.stringToCloudFormation(properties.application), Resource: cdk.stringToCloudFormation(properties.resource), ResourceType: cdk.stringToCloudFormation(properties.resourceType) }) : properties;
    }
    function CfnResourceAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("application", "Application", cfn_parse.FromCloudFormation.getString(properties.Application)), ret.addPropertyResult("resource", "Resource", cfn_parse.FromCloudFormation.getString(properties.Resource)), ret.addPropertyResult("resourceType", "ResourceType", cfn_parse.FromCloudFormation.getString(properties.ResourceType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResourceAssociation = class _CfnResourceAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResourceAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnResourceAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnResourceAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_servicecatalogappregistry_CfnResourceAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResourceAssociation), error;
        }
        cdk.requireProperty(props, "application", this), cdk.requireProperty(props, "resource", this), cdk.requireProperty(props, "resourceType", this), this.attrApplicationArn = cdk.Token.asString(this.getAtt("ApplicationArn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrResourceArn = cdk.Token.asString(this.getAtt("ResourceArn", cdk.ResolutionTypeHint.STRING)), this.application = props.application, this.resource = props.resource, this.resourceType = props.resourceType;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResourceAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { application: this.application, resource: this.resource, resourceType: this.resourceType };
      }
      renderProperties(props) {
        return cfnResourceAssociationPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnResourceAssociation[_d] = { fqn: "aws-cdk-lib.aws_servicecatalogappregistry.CfnResourceAssociation", version: "2.80.0" }, CfnResourceAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::ServiceCatalogAppRegistry::ResourceAssociation", exports2.CfnResourceAssociation = CfnResourceAssociation;
  }
});

// node_modules/aws-cdk-lib/aws-servicecatalogappregistry/lib/index.js
var require_lib238 = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicecatalogappregistry/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_servicecatalogappregistry_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-servicecatalogappregistry/index.js
var require_aws_servicecatalogappregistry = __commonJS({
  "node_modules/aws-cdk-lib/aws-servicecatalogappregistry/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib238(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-ses/lib/ses.generated.js
var require_ses_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-ses/lib/ses.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnVdmAttributes = exports2.CfnTemplate = exports2.CfnReceiptRuleSet = exports2.CfnReceiptRule = exports2.CfnReceiptFilter = exports2.CfnEmailIdentity = exports2.CfnDedicatedIpPool = exports2.CfnContactList = exports2.CfnConfigurationSetEventDestination = exports2.CfnConfigurationSet = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnConfigurationSetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deliveryOptions", CfnConfigurationSet_DeliveryOptionsPropertyValidator)(properties.deliveryOptions)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("reputationOptions", CfnConfigurationSet_ReputationOptionsPropertyValidator)(properties.reputationOptions)), errors.collect(cdk.propertyValidator("sendingOptions", CfnConfigurationSet_SendingOptionsPropertyValidator)(properties.sendingOptions)), errors.collect(cdk.propertyValidator("suppressionOptions", CfnConfigurationSet_SuppressionOptionsPropertyValidator)(properties.suppressionOptions)), errors.collect(cdk.propertyValidator("trackingOptions", CfnConfigurationSet_TrackingOptionsPropertyValidator)(properties.trackingOptions)), errors.collect(cdk.propertyValidator("vdmOptions", CfnConfigurationSet_VdmOptionsPropertyValidator)(properties.vdmOptions)), errors.wrap('supplied properties not correct for "CfnConfigurationSetProps"');
    }
    function cfnConfigurationSetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationSetPropsValidator(properties).assertSuccess(), { DeliveryOptions: cfnConfigurationSetDeliveryOptionsPropertyToCloudFormation(properties.deliveryOptions), Name: cdk.stringToCloudFormation(properties.name), ReputationOptions: cfnConfigurationSetReputationOptionsPropertyToCloudFormation(properties.reputationOptions), SendingOptions: cfnConfigurationSetSendingOptionsPropertyToCloudFormation(properties.sendingOptions), SuppressionOptions: cfnConfigurationSetSuppressionOptionsPropertyToCloudFormation(properties.suppressionOptions), TrackingOptions: cfnConfigurationSetTrackingOptionsPropertyToCloudFormation(properties.trackingOptions), VdmOptions: cfnConfigurationSetVdmOptionsPropertyToCloudFormation(properties.vdmOptions) }) : properties;
    }
    function CfnConfigurationSetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deliveryOptions", "DeliveryOptions", properties.DeliveryOptions != null ? CfnConfigurationSetDeliveryOptionsPropertyFromCloudFormation(properties.DeliveryOptions) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("reputationOptions", "ReputationOptions", properties.ReputationOptions != null ? CfnConfigurationSetReputationOptionsPropertyFromCloudFormation(properties.ReputationOptions) : void 0), ret.addPropertyResult("sendingOptions", "SendingOptions", properties.SendingOptions != null ? CfnConfigurationSetSendingOptionsPropertyFromCloudFormation(properties.SendingOptions) : void 0), ret.addPropertyResult("suppressionOptions", "SuppressionOptions", properties.SuppressionOptions != null ? CfnConfigurationSetSuppressionOptionsPropertyFromCloudFormation(properties.SuppressionOptions) : void 0), ret.addPropertyResult("trackingOptions", "TrackingOptions", properties.TrackingOptions != null ? CfnConfigurationSetTrackingOptionsPropertyFromCloudFormation(properties.TrackingOptions) : void 0), ret.addPropertyResult("vdmOptions", "VdmOptions", properties.VdmOptions != null ? CfnConfigurationSetVdmOptionsPropertyFromCloudFormation(properties.VdmOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnConfigurationSet = class _CfnConfigurationSet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnConfigurationSetPropsFromCloudFormation(resourceProperties), ret = new _CfnConfigurationSet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnConfigurationSet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_CfnConfigurationSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnConfigurationSet), error;
        }
        this.deliveryOptions = props.deliveryOptions, this.name = props.name, this.reputationOptions = props.reputationOptions, this.sendingOptions = props.sendingOptions, this.suppressionOptions = props.suppressionOptions, this.trackingOptions = props.trackingOptions, this.vdmOptions = props.vdmOptions;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnConfigurationSet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { deliveryOptions: this.deliveryOptions, name: this.name, reputationOptions: this.reputationOptions, sendingOptions: this.sendingOptions, suppressionOptions: this.suppressionOptions, trackingOptions: this.trackingOptions, vdmOptions: this.vdmOptions };
      }
      renderProperties(props) {
        return cfnConfigurationSetPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnConfigurationSet[_a] = { fqn: "aws-cdk-lib.aws_ses.CfnConfigurationSet", version: "2.80.0" }, CfnConfigurationSet.CFN_RESOURCE_TYPE_NAME = "AWS::SES::ConfigurationSet", exports2.CfnConfigurationSet = CfnConfigurationSet;
    function CfnConfigurationSet_DashboardOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("engagementMetrics", cdk.requiredValidator)(properties.engagementMetrics)), errors.collect(cdk.propertyValidator("engagementMetrics", cdk.validateString)(properties.engagementMetrics)), errors.wrap('supplied properties not correct for "DashboardOptionsProperty"');
    }
    function cfnConfigurationSetDashboardOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationSet_DashboardOptionsPropertyValidator(properties).assertSuccess(), { EngagementMetrics: cdk.stringToCloudFormation(properties.engagementMetrics) }) : properties;
    }
    function CfnConfigurationSetDashboardOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("engagementMetrics", "EngagementMetrics", cfn_parse.FromCloudFormation.getString(properties.EngagementMetrics)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigurationSet_DeliveryOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sendingPoolName", cdk.validateString)(properties.sendingPoolName)), errors.collect(cdk.propertyValidator("tlsPolicy", cdk.validateString)(properties.tlsPolicy)), errors.wrap('supplied properties not correct for "DeliveryOptionsProperty"');
    }
    function cfnConfigurationSetDeliveryOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationSet_DeliveryOptionsPropertyValidator(properties).assertSuccess(), { SendingPoolName: cdk.stringToCloudFormation(properties.sendingPoolName), TlsPolicy: cdk.stringToCloudFormation(properties.tlsPolicy) }) : properties;
    }
    function CfnConfigurationSetDeliveryOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sendingPoolName", "SendingPoolName", properties.SendingPoolName != null ? cfn_parse.FromCloudFormation.getString(properties.SendingPoolName) : void 0), ret.addPropertyResult("tlsPolicy", "TlsPolicy", properties.TlsPolicy != null ? cfn_parse.FromCloudFormation.getString(properties.TlsPolicy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigurationSet_GuardianOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("optimizedSharedDelivery", cdk.requiredValidator)(properties.optimizedSharedDelivery)), errors.collect(cdk.propertyValidator("optimizedSharedDelivery", cdk.validateString)(properties.optimizedSharedDelivery)), errors.wrap('supplied properties not correct for "GuardianOptionsProperty"');
    }
    function cfnConfigurationSetGuardianOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationSet_GuardianOptionsPropertyValidator(properties).assertSuccess(), { OptimizedSharedDelivery: cdk.stringToCloudFormation(properties.optimizedSharedDelivery) }) : properties;
    }
    function CfnConfigurationSetGuardianOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("optimizedSharedDelivery", "OptimizedSharedDelivery", cfn_parse.FromCloudFormation.getString(properties.OptimizedSharedDelivery)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigurationSet_ReputationOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("reputationMetricsEnabled", cdk.validateBoolean)(properties.reputationMetricsEnabled)), errors.wrap('supplied properties not correct for "ReputationOptionsProperty"');
    }
    function cfnConfigurationSetReputationOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationSet_ReputationOptionsPropertyValidator(properties).assertSuccess(), { ReputationMetricsEnabled: cdk.booleanToCloudFormation(properties.reputationMetricsEnabled) }) : properties;
    }
    function CfnConfigurationSetReputationOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("reputationMetricsEnabled", "ReputationMetricsEnabled", properties.ReputationMetricsEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ReputationMetricsEnabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigurationSet_SendingOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sendingEnabled", cdk.validateBoolean)(properties.sendingEnabled)), errors.wrap('supplied properties not correct for "SendingOptionsProperty"');
    }
    function cfnConfigurationSetSendingOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationSet_SendingOptionsPropertyValidator(properties).assertSuccess(), { SendingEnabled: cdk.booleanToCloudFormation(properties.sendingEnabled) }) : properties;
    }
    function CfnConfigurationSetSendingOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sendingEnabled", "SendingEnabled", properties.SendingEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SendingEnabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigurationSet_SuppressionOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("suppressedReasons", cdk.listValidator(cdk.validateString))(properties.suppressedReasons)), errors.wrap('supplied properties not correct for "SuppressionOptionsProperty"');
    }
    function cfnConfigurationSetSuppressionOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationSet_SuppressionOptionsPropertyValidator(properties).assertSuccess(), { SuppressedReasons: cdk.listMapper(cdk.stringToCloudFormation)(properties.suppressedReasons) }) : properties;
    }
    function CfnConfigurationSetSuppressionOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("suppressedReasons", "SuppressedReasons", properties.SuppressedReasons != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SuppressedReasons) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigurationSet_TrackingOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customRedirectDomain", cdk.validateString)(properties.customRedirectDomain)), errors.wrap('supplied properties not correct for "TrackingOptionsProperty"');
    }
    function cfnConfigurationSetTrackingOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationSet_TrackingOptionsPropertyValidator(properties).assertSuccess(), { CustomRedirectDomain: cdk.stringToCloudFormation(properties.customRedirectDomain) }) : properties;
    }
    function CfnConfigurationSetTrackingOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customRedirectDomain", "CustomRedirectDomain", properties.CustomRedirectDomain != null ? cfn_parse.FromCloudFormation.getString(properties.CustomRedirectDomain) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigurationSet_VdmOptionsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dashboardOptions", CfnConfigurationSet_DashboardOptionsPropertyValidator)(properties.dashboardOptions)), errors.collect(cdk.propertyValidator("guardianOptions", CfnConfigurationSet_GuardianOptionsPropertyValidator)(properties.guardianOptions)), errors.wrap('supplied properties not correct for "VdmOptionsProperty"');
    }
    function cfnConfigurationSetVdmOptionsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationSet_VdmOptionsPropertyValidator(properties).assertSuccess(), { DashboardOptions: cfnConfigurationSetDashboardOptionsPropertyToCloudFormation(properties.dashboardOptions), GuardianOptions: cfnConfigurationSetGuardianOptionsPropertyToCloudFormation(properties.guardianOptions) }) : properties;
    }
    function CfnConfigurationSetVdmOptionsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dashboardOptions", "DashboardOptions", properties.DashboardOptions != null ? CfnConfigurationSetDashboardOptionsPropertyFromCloudFormation(properties.DashboardOptions) : void 0), ret.addPropertyResult("guardianOptions", "GuardianOptions", properties.GuardianOptions != null ? CfnConfigurationSetGuardianOptionsPropertyFromCloudFormation(properties.GuardianOptions) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigurationSetEventDestinationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configurationSetName", cdk.requiredValidator)(properties.configurationSetName)), errors.collect(cdk.propertyValidator("configurationSetName", cdk.validateString)(properties.configurationSetName)), errors.collect(cdk.propertyValidator("eventDestination", cdk.requiredValidator)(properties.eventDestination)), errors.collect(cdk.propertyValidator("eventDestination", CfnConfigurationSetEventDestination_EventDestinationPropertyValidator)(properties.eventDestination)), errors.wrap('supplied properties not correct for "CfnConfigurationSetEventDestinationProps"');
    }
    function cfnConfigurationSetEventDestinationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationSetEventDestinationPropsValidator(properties).assertSuccess(), { ConfigurationSetName: cdk.stringToCloudFormation(properties.configurationSetName), EventDestination: cfnConfigurationSetEventDestinationEventDestinationPropertyToCloudFormation(properties.eventDestination) }) : properties;
    }
    function CfnConfigurationSetEventDestinationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configurationSetName", "ConfigurationSetName", cfn_parse.FromCloudFormation.getString(properties.ConfigurationSetName)), ret.addPropertyResult("eventDestination", "EventDestination", CfnConfigurationSetEventDestinationEventDestinationPropertyFromCloudFormation(properties.EventDestination)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnConfigurationSetEventDestination = class _CfnConfigurationSetEventDestination extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnConfigurationSetEventDestinationPropsFromCloudFormation(resourceProperties), ret = new _CfnConfigurationSetEventDestination(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnConfigurationSetEventDestination.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_CfnConfigurationSetEventDestinationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnConfigurationSetEventDestination), error;
        }
        cdk.requireProperty(props, "configurationSetName", this), cdk.requireProperty(props, "eventDestination", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.configurationSetName = props.configurationSetName, this.eventDestination = props.eventDestination;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnConfigurationSetEventDestination.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { configurationSetName: this.configurationSetName, eventDestination: this.eventDestination };
      }
      renderProperties(props) {
        return cfnConfigurationSetEventDestinationPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnConfigurationSetEventDestination[_b] = { fqn: "aws-cdk-lib.aws_ses.CfnConfigurationSetEventDestination", version: "2.80.0" }, CfnConfigurationSetEventDestination.CFN_RESOURCE_TYPE_NAME = "AWS::SES::ConfigurationSetEventDestination", exports2.CfnConfigurationSetEventDestination = CfnConfigurationSetEventDestination;
    function CfnConfigurationSetEventDestination_CloudWatchDestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dimensionConfigurations", cdk.listValidator(CfnConfigurationSetEventDestination_DimensionConfigurationPropertyValidator))(properties.dimensionConfigurations)), errors.wrap('supplied properties not correct for "CloudWatchDestinationProperty"');
    }
    function cfnConfigurationSetEventDestinationCloudWatchDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationSetEventDestination_CloudWatchDestinationPropertyValidator(properties).assertSuccess(), { DimensionConfigurations: cdk.listMapper(cfnConfigurationSetEventDestinationDimensionConfigurationPropertyToCloudFormation)(properties.dimensionConfigurations) }) : properties;
    }
    function CfnConfigurationSetEventDestinationCloudWatchDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dimensionConfigurations", "DimensionConfigurations", properties.DimensionConfigurations != null ? cfn_parse.FromCloudFormation.getArray(CfnConfigurationSetEventDestinationDimensionConfigurationPropertyFromCloudFormation)(properties.DimensionConfigurations) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigurationSetEventDestination_DimensionConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultDimensionValue", cdk.requiredValidator)(properties.defaultDimensionValue)), errors.collect(cdk.propertyValidator("defaultDimensionValue", cdk.validateString)(properties.defaultDimensionValue)), errors.collect(cdk.propertyValidator("dimensionName", cdk.requiredValidator)(properties.dimensionName)), errors.collect(cdk.propertyValidator("dimensionName", cdk.validateString)(properties.dimensionName)), errors.collect(cdk.propertyValidator("dimensionValueSource", cdk.requiredValidator)(properties.dimensionValueSource)), errors.collect(cdk.propertyValidator("dimensionValueSource", cdk.validateString)(properties.dimensionValueSource)), errors.wrap('supplied properties not correct for "DimensionConfigurationProperty"');
    }
    function cfnConfigurationSetEventDestinationDimensionConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationSetEventDestination_DimensionConfigurationPropertyValidator(properties).assertSuccess(), { DefaultDimensionValue: cdk.stringToCloudFormation(properties.defaultDimensionValue), DimensionName: cdk.stringToCloudFormation(properties.dimensionName), DimensionValueSource: cdk.stringToCloudFormation(properties.dimensionValueSource) }) : properties;
    }
    function CfnConfigurationSetEventDestinationDimensionConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultDimensionValue", "DefaultDimensionValue", cfn_parse.FromCloudFormation.getString(properties.DefaultDimensionValue)), ret.addPropertyResult("dimensionName", "DimensionName", cfn_parse.FromCloudFormation.getString(properties.DimensionName)), ret.addPropertyResult("dimensionValueSource", "DimensionValueSource", cfn_parse.FromCloudFormation.getString(properties.DimensionValueSource)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigurationSetEventDestination_EventDestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchDestination", CfnConfigurationSetEventDestination_CloudWatchDestinationPropertyValidator)(properties.cloudWatchDestination)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("kinesisFirehoseDestination", CfnConfigurationSetEventDestination_KinesisFirehoseDestinationPropertyValidator)(properties.kinesisFirehoseDestination)), errors.collect(cdk.propertyValidator("matchingEventTypes", cdk.requiredValidator)(properties.matchingEventTypes)), errors.collect(cdk.propertyValidator("matchingEventTypes", cdk.listValidator(cdk.validateString))(properties.matchingEventTypes)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("snsDestination", CfnConfigurationSetEventDestination_SnsDestinationPropertyValidator)(properties.snsDestination)), errors.wrap('supplied properties not correct for "EventDestinationProperty"');
    }
    function cfnConfigurationSetEventDestinationEventDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationSetEventDestination_EventDestinationPropertyValidator(properties).assertSuccess(), { CloudWatchDestination: cfnConfigurationSetEventDestinationCloudWatchDestinationPropertyToCloudFormation(properties.cloudWatchDestination), Enabled: cdk.booleanToCloudFormation(properties.enabled), KinesisFirehoseDestination: cfnConfigurationSetEventDestinationKinesisFirehoseDestinationPropertyToCloudFormation(properties.kinesisFirehoseDestination), MatchingEventTypes: cdk.listMapper(cdk.stringToCloudFormation)(properties.matchingEventTypes), Name: cdk.stringToCloudFormation(properties.name), SnsDestination: cfnConfigurationSetEventDestinationSnsDestinationPropertyToCloudFormation(properties.snsDestination) }) : properties;
    }
    function CfnConfigurationSetEventDestinationEventDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchDestination", "CloudWatchDestination", properties.CloudWatchDestination != null ? CfnConfigurationSetEventDestinationCloudWatchDestinationPropertyFromCloudFormation(properties.CloudWatchDestination) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("kinesisFirehoseDestination", "KinesisFirehoseDestination", properties.KinesisFirehoseDestination != null ? CfnConfigurationSetEventDestinationKinesisFirehoseDestinationPropertyFromCloudFormation(properties.KinesisFirehoseDestination) : void 0), ret.addPropertyResult("matchingEventTypes", "MatchingEventTypes", cfn_parse.FromCloudFormation.getStringArray(properties.MatchingEventTypes)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("snsDestination", "SnsDestination", properties.SnsDestination != null ? CfnConfigurationSetEventDestinationSnsDestinationPropertyFromCloudFormation(properties.SnsDestination) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigurationSetEventDestination_KinesisFirehoseDestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deliveryStreamArn", cdk.requiredValidator)(properties.deliveryStreamArn)), errors.collect(cdk.propertyValidator("deliveryStreamArn", cdk.validateString)(properties.deliveryStreamArn)), errors.collect(cdk.propertyValidator("iamRoleArn", cdk.requiredValidator)(properties.iamRoleArn)), errors.collect(cdk.propertyValidator("iamRoleArn", cdk.validateString)(properties.iamRoleArn)), errors.wrap('supplied properties not correct for "KinesisFirehoseDestinationProperty"');
    }
    function cfnConfigurationSetEventDestinationKinesisFirehoseDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationSetEventDestination_KinesisFirehoseDestinationPropertyValidator(properties).assertSuccess(), { DeliveryStreamARN: cdk.stringToCloudFormation(properties.deliveryStreamArn), IAMRoleARN: cdk.stringToCloudFormation(properties.iamRoleArn) }) : properties;
    }
    function CfnConfigurationSetEventDestinationKinesisFirehoseDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("deliveryStreamArn", "DeliveryStreamARN", cfn_parse.FromCloudFormation.getString(properties.DeliveryStreamARN)), ret.addPropertyResult("iamRoleArn", "IAMRoleARN", cfn_parse.FromCloudFormation.getString(properties.IAMRoleARN)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnConfigurationSetEventDestination_SnsDestinationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("topicArn", cdk.requiredValidator)(properties.topicArn)), errors.collect(cdk.propertyValidator("topicArn", cdk.validateString)(properties.topicArn)), errors.wrap('supplied properties not correct for "SnsDestinationProperty"');
    }
    function cfnConfigurationSetEventDestinationSnsDestinationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConfigurationSetEventDestination_SnsDestinationPropertyValidator(properties).assertSuccess(), { TopicARN: cdk.stringToCloudFormation(properties.topicArn) }) : properties;
    }
    function CfnConfigurationSetEventDestinationSnsDestinationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("topicArn", "TopicARN", cfn_parse.FromCloudFormation.getString(properties.TopicARN)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnContactListPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contactListName", cdk.validateString)(properties.contactListName)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("topics", cdk.listValidator(CfnContactList_TopicPropertyValidator))(properties.topics)), errors.wrap('supplied properties not correct for "CfnContactListProps"');
    }
    function cfnContactListPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContactListPropsValidator(properties).assertSuccess(), { ContactListName: cdk.stringToCloudFormation(properties.contactListName), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), Topics: cdk.listMapper(cfnContactListTopicPropertyToCloudFormation)(properties.topics) }) : properties;
    }
    function CfnContactListPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contactListName", "ContactListName", properties.ContactListName != null ? cfn_parse.FromCloudFormation.getString(properties.ContactListName) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("topics", "Topics", properties.Topics != null ? cfn_parse.FromCloudFormation.getArray(CfnContactListTopicPropertyFromCloudFormation)(properties.Topics) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnContactList = class _CfnContactList extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnContactListPropsFromCloudFormation(resourceProperties), ret = new _CfnContactList(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnContactList.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_CfnContactListProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnContactList), error;
        }
        this.contactListName = props.contactListName, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SES::ContactList", props.tags, { tagPropertyName: "tags" }), this.topics = props.topics;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnContactList.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { contactListName: this.contactListName, description: this.description, tags: this.tags.renderTags(), topics: this.topics };
      }
      renderProperties(props) {
        return cfnContactListPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnContactList[_c] = { fqn: "aws-cdk-lib.aws_ses.CfnContactList", version: "2.80.0" }, CfnContactList.CFN_RESOURCE_TYPE_NAME = "AWS::SES::ContactList", exports2.CfnContactList = CfnContactList;
    function CfnContactList_TopicPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultSubscriptionStatus", cdk.requiredValidator)(properties.defaultSubscriptionStatus)), errors.collect(cdk.propertyValidator("defaultSubscriptionStatus", cdk.validateString)(properties.defaultSubscriptionStatus)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("displayName", cdk.requiredValidator)(properties.displayName)), errors.collect(cdk.propertyValidator("displayName", cdk.validateString)(properties.displayName)), errors.collect(cdk.propertyValidator("topicName", cdk.requiredValidator)(properties.topicName)), errors.collect(cdk.propertyValidator("topicName", cdk.validateString)(properties.topicName)), errors.wrap('supplied properties not correct for "TopicProperty"');
    }
    function cfnContactListTopicPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContactList_TopicPropertyValidator(properties).assertSuccess(), { DefaultSubscriptionStatus: cdk.stringToCloudFormation(properties.defaultSubscriptionStatus), Description: cdk.stringToCloudFormation(properties.description), DisplayName: cdk.stringToCloudFormation(properties.displayName), TopicName: cdk.stringToCloudFormation(properties.topicName) }) : properties;
    }
    function CfnContactListTopicPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultSubscriptionStatus", "DefaultSubscriptionStatus", cfn_parse.FromCloudFormation.getString(properties.DefaultSubscriptionStatus)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("displayName", "DisplayName", cfn_parse.FromCloudFormation.getString(properties.DisplayName)), ret.addPropertyResult("topicName", "TopicName", cfn_parse.FromCloudFormation.getString(properties.TopicName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnDedicatedIpPoolPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("poolName", cdk.validateString)(properties.poolName)), errors.collect(cdk.propertyValidator("scalingMode", cdk.validateString)(properties.scalingMode)), errors.wrap('supplied properties not correct for "CfnDedicatedIpPoolProps"');
    }
    function cfnDedicatedIpPoolPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDedicatedIpPoolPropsValidator(properties).assertSuccess(), { PoolName: cdk.stringToCloudFormation(properties.poolName), ScalingMode: cdk.stringToCloudFormation(properties.scalingMode) }) : properties;
    }
    function CfnDedicatedIpPoolPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("poolName", "PoolName", properties.PoolName != null ? cfn_parse.FromCloudFormation.getString(properties.PoolName) : void 0), ret.addPropertyResult("scalingMode", "ScalingMode", properties.ScalingMode != null ? cfn_parse.FromCloudFormation.getString(properties.ScalingMode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDedicatedIpPool = class _CfnDedicatedIpPool extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDedicatedIpPoolPropsFromCloudFormation(resourceProperties), ret = new _CfnDedicatedIpPool(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnDedicatedIpPool.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_CfnDedicatedIpPoolProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDedicatedIpPool), error;
        }
        this.poolName = props.poolName, this.scalingMode = props.scalingMode;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDedicatedIpPool.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { poolName: this.poolName, scalingMode: this.scalingMode };
      }
      renderProperties(props) {
        return cfnDedicatedIpPoolPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnDedicatedIpPool[_d] = { fqn: "aws-cdk-lib.aws_ses.CfnDedicatedIpPool", version: "2.80.0" }, CfnDedicatedIpPool.CFN_RESOURCE_TYPE_NAME = "AWS::SES::DedicatedIpPool", exports2.CfnDedicatedIpPool = CfnDedicatedIpPool;
    function CfnEmailIdentityPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configurationSetAttributes", CfnEmailIdentity_ConfigurationSetAttributesPropertyValidator)(properties.configurationSetAttributes)), errors.collect(cdk.propertyValidator("dkimAttributes", CfnEmailIdentity_DkimAttributesPropertyValidator)(properties.dkimAttributes)), errors.collect(cdk.propertyValidator("dkimSigningAttributes", CfnEmailIdentity_DkimSigningAttributesPropertyValidator)(properties.dkimSigningAttributes)), errors.collect(cdk.propertyValidator("emailIdentity", cdk.requiredValidator)(properties.emailIdentity)), errors.collect(cdk.propertyValidator("emailIdentity", cdk.validateString)(properties.emailIdentity)), errors.collect(cdk.propertyValidator("feedbackAttributes", CfnEmailIdentity_FeedbackAttributesPropertyValidator)(properties.feedbackAttributes)), errors.collect(cdk.propertyValidator("mailFromAttributes", CfnEmailIdentity_MailFromAttributesPropertyValidator)(properties.mailFromAttributes)), errors.wrap('supplied properties not correct for "CfnEmailIdentityProps"');
    }
    function cfnEmailIdentityPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEmailIdentityPropsValidator(properties).assertSuccess(), { EmailIdentity: cdk.stringToCloudFormation(properties.emailIdentity), ConfigurationSetAttributes: cfnEmailIdentityConfigurationSetAttributesPropertyToCloudFormation(properties.configurationSetAttributes), DkimAttributes: cfnEmailIdentityDkimAttributesPropertyToCloudFormation(properties.dkimAttributes), DkimSigningAttributes: cfnEmailIdentityDkimSigningAttributesPropertyToCloudFormation(properties.dkimSigningAttributes), FeedbackAttributes: cfnEmailIdentityFeedbackAttributesPropertyToCloudFormation(properties.feedbackAttributes), MailFromAttributes: cfnEmailIdentityMailFromAttributesPropertyToCloudFormation(properties.mailFromAttributes) }) : properties;
    }
    function CfnEmailIdentityPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("emailIdentity", "EmailIdentity", cfn_parse.FromCloudFormation.getString(properties.EmailIdentity)), ret.addPropertyResult("configurationSetAttributes", "ConfigurationSetAttributes", properties.ConfigurationSetAttributes != null ? CfnEmailIdentityConfigurationSetAttributesPropertyFromCloudFormation(properties.ConfigurationSetAttributes) : void 0), ret.addPropertyResult("dkimAttributes", "DkimAttributes", properties.DkimAttributes != null ? CfnEmailIdentityDkimAttributesPropertyFromCloudFormation(properties.DkimAttributes) : void 0), ret.addPropertyResult("dkimSigningAttributes", "DkimSigningAttributes", properties.DkimSigningAttributes != null ? CfnEmailIdentityDkimSigningAttributesPropertyFromCloudFormation(properties.DkimSigningAttributes) : void 0), ret.addPropertyResult("feedbackAttributes", "FeedbackAttributes", properties.FeedbackAttributes != null ? CfnEmailIdentityFeedbackAttributesPropertyFromCloudFormation(properties.FeedbackAttributes) : void 0), ret.addPropertyResult("mailFromAttributes", "MailFromAttributes", properties.MailFromAttributes != null ? CfnEmailIdentityMailFromAttributesPropertyFromCloudFormation(properties.MailFromAttributes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnEmailIdentity = class _CfnEmailIdentity extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnEmailIdentityPropsFromCloudFormation(resourceProperties), ret = new _CfnEmailIdentity(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnEmailIdentity.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_CfnEmailIdentityProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnEmailIdentity), error;
        }
        cdk.requireProperty(props, "emailIdentity", this), this.attrDkimDnsTokenName1 = cdk.Token.asString(this.getAtt("DkimDNSTokenName1", cdk.ResolutionTypeHint.STRING)), this.attrDkimDnsTokenName2 = cdk.Token.asString(this.getAtt("DkimDNSTokenName2", cdk.ResolutionTypeHint.STRING)), this.attrDkimDnsTokenName3 = cdk.Token.asString(this.getAtt("DkimDNSTokenName3", cdk.ResolutionTypeHint.STRING)), this.attrDkimDnsTokenValue1 = cdk.Token.asString(this.getAtt("DkimDNSTokenValue1", cdk.ResolutionTypeHint.STRING)), this.attrDkimDnsTokenValue2 = cdk.Token.asString(this.getAtt("DkimDNSTokenValue2", cdk.ResolutionTypeHint.STRING)), this.attrDkimDnsTokenValue3 = cdk.Token.asString(this.getAtt("DkimDNSTokenValue3", cdk.ResolutionTypeHint.STRING)), this.emailIdentity = props.emailIdentity, this.configurationSetAttributes = props.configurationSetAttributes, this.dkimAttributes = props.dkimAttributes, this.dkimSigningAttributes = props.dkimSigningAttributes, this.feedbackAttributes = props.feedbackAttributes, this.mailFromAttributes = props.mailFromAttributes;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnEmailIdentity.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { emailIdentity: this.emailIdentity, configurationSetAttributes: this.configurationSetAttributes, dkimAttributes: this.dkimAttributes, dkimSigningAttributes: this.dkimSigningAttributes, feedbackAttributes: this.feedbackAttributes, mailFromAttributes: this.mailFromAttributes };
      }
      renderProperties(props) {
        return cfnEmailIdentityPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnEmailIdentity[_e] = { fqn: "aws-cdk-lib.aws_ses.CfnEmailIdentity", version: "2.80.0" }, CfnEmailIdentity.CFN_RESOURCE_TYPE_NAME = "AWS::SES::EmailIdentity", exports2.CfnEmailIdentity = CfnEmailIdentity;
    function CfnEmailIdentity_ConfigurationSetAttributesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("configurationSetName", cdk.validateString)(properties.configurationSetName)), errors.wrap('supplied properties not correct for "ConfigurationSetAttributesProperty"');
    }
    function cfnEmailIdentityConfigurationSetAttributesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEmailIdentity_ConfigurationSetAttributesPropertyValidator(properties).assertSuccess(), { ConfigurationSetName: cdk.stringToCloudFormation(properties.configurationSetName) }) : properties;
    }
    function CfnEmailIdentityConfigurationSetAttributesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("configurationSetName", "ConfigurationSetName", properties.ConfigurationSetName != null ? cfn_parse.FromCloudFormation.getString(properties.ConfigurationSetName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEmailIdentity_DkimAttributesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("signingEnabled", cdk.validateBoolean)(properties.signingEnabled)), errors.wrap('supplied properties not correct for "DkimAttributesProperty"');
    }
    function cfnEmailIdentityDkimAttributesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEmailIdentity_DkimAttributesPropertyValidator(properties).assertSuccess(), { SigningEnabled: cdk.booleanToCloudFormation(properties.signingEnabled) }) : properties;
    }
    function CfnEmailIdentityDkimAttributesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("signingEnabled", "SigningEnabled", properties.SigningEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.SigningEnabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEmailIdentity_DkimSigningAttributesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("domainSigningPrivateKey", cdk.validateString)(properties.domainSigningPrivateKey)), errors.collect(cdk.propertyValidator("domainSigningSelector", cdk.validateString)(properties.domainSigningSelector)), errors.collect(cdk.propertyValidator("nextSigningKeyLength", cdk.validateString)(properties.nextSigningKeyLength)), errors.wrap('supplied properties not correct for "DkimSigningAttributesProperty"');
    }
    function cfnEmailIdentityDkimSigningAttributesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEmailIdentity_DkimSigningAttributesPropertyValidator(properties).assertSuccess(), { DomainSigningPrivateKey: cdk.stringToCloudFormation(properties.domainSigningPrivateKey), DomainSigningSelector: cdk.stringToCloudFormation(properties.domainSigningSelector), NextSigningKeyLength: cdk.stringToCloudFormation(properties.nextSigningKeyLength) }) : properties;
    }
    function CfnEmailIdentityDkimSigningAttributesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("domainSigningPrivateKey", "DomainSigningPrivateKey", properties.DomainSigningPrivateKey != null ? cfn_parse.FromCloudFormation.getString(properties.DomainSigningPrivateKey) : void 0), ret.addPropertyResult("domainSigningSelector", "DomainSigningSelector", properties.DomainSigningSelector != null ? cfn_parse.FromCloudFormation.getString(properties.DomainSigningSelector) : void 0), ret.addPropertyResult("nextSigningKeyLength", "NextSigningKeyLength", properties.NextSigningKeyLength != null ? cfn_parse.FromCloudFormation.getString(properties.NextSigningKeyLength) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEmailIdentity_FeedbackAttributesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("emailForwardingEnabled", cdk.validateBoolean)(properties.emailForwardingEnabled)), errors.wrap('supplied properties not correct for "FeedbackAttributesProperty"');
    }
    function cfnEmailIdentityFeedbackAttributesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEmailIdentity_FeedbackAttributesPropertyValidator(properties).assertSuccess(), { EmailForwardingEnabled: cdk.booleanToCloudFormation(properties.emailForwardingEnabled) }) : properties;
    }
    function CfnEmailIdentityFeedbackAttributesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("emailForwardingEnabled", "EmailForwardingEnabled", properties.EmailForwardingEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.EmailForwardingEnabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnEmailIdentity_MailFromAttributesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("behaviorOnMxFailure", cdk.validateString)(properties.behaviorOnMxFailure)), errors.collect(cdk.propertyValidator("mailFromDomain", cdk.validateString)(properties.mailFromDomain)), errors.wrap('supplied properties not correct for "MailFromAttributesProperty"');
    }
    function cfnEmailIdentityMailFromAttributesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnEmailIdentity_MailFromAttributesPropertyValidator(properties).assertSuccess(), { BehaviorOnMxFailure: cdk.stringToCloudFormation(properties.behaviorOnMxFailure), MailFromDomain: cdk.stringToCloudFormation(properties.mailFromDomain) }) : properties;
    }
    function CfnEmailIdentityMailFromAttributesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("behaviorOnMxFailure", "BehaviorOnMxFailure", properties.BehaviorOnMxFailure != null ? cfn_parse.FromCloudFormation.getString(properties.BehaviorOnMxFailure) : void 0), ret.addPropertyResult("mailFromDomain", "MailFromDomain", properties.MailFromDomain != null ? cfn_parse.FromCloudFormation.getString(properties.MailFromDomain) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnReceiptFilterPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("filter", cdk.requiredValidator)(properties.filter)), errors.collect(cdk.propertyValidator("filter", CfnReceiptFilter_FilterPropertyValidator)(properties.filter)), errors.wrap('supplied properties not correct for "CfnReceiptFilterProps"');
    }
    function cfnReceiptFilterPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReceiptFilterPropsValidator(properties).assertSuccess(), { Filter: cfnReceiptFilterFilterPropertyToCloudFormation(properties.filter) }) : properties;
    }
    function CfnReceiptFilterPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("filter", "Filter", CfnReceiptFilterFilterPropertyFromCloudFormation(properties.Filter)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnReceiptFilter = class _CfnReceiptFilter extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnReceiptFilterPropsFromCloudFormation(resourceProperties), ret = new _CfnReceiptFilter(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnReceiptFilter.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_CfnReceiptFilterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnReceiptFilter), error;
        }
        cdk.requireProperty(props, "filter", this), this.filter = props.filter;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnReceiptFilter.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { filter: this.filter };
      }
      renderProperties(props) {
        return cfnReceiptFilterPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnReceiptFilter[_f] = { fqn: "aws-cdk-lib.aws_ses.CfnReceiptFilter", version: "2.80.0" }, CfnReceiptFilter.CFN_RESOURCE_TYPE_NAME = "AWS::SES::ReceiptFilter", exports2.CfnReceiptFilter = CfnReceiptFilter;
    function CfnReceiptFilter_FilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ipFilter", cdk.requiredValidator)(properties.ipFilter)), errors.collect(cdk.propertyValidator("ipFilter", CfnReceiptFilter_IpFilterPropertyValidator)(properties.ipFilter)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "FilterProperty"');
    }
    function cfnReceiptFilterFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReceiptFilter_FilterPropertyValidator(properties).assertSuccess(), { IpFilter: cfnReceiptFilterIpFilterPropertyToCloudFormation(properties.ipFilter), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnReceiptFilterFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ipFilter", "IpFilter", CfnReceiptFilterIpFilterPropertyFromCloudFormation(properties.IpFilter)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnReceiptFilter_IpFilterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cidr", cdk.requiredValidator)(properties.cidr)), errors.collect(cdk.propertyValidator("cidr", cdk.validateString)(properties.cidr)), errors.collect(cdk.propertyValidator("policy", cdk.requiredValidator)(properties.policy)), errors.collect(cdk.propertyValidator("policy", cdk.validateString)(properties.policy)), errors.wrap('supplied properties not correct for "IpFilterProperty"');
    }
    function cfnReceiptFilterIpFilterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReceiptFilter_IpFilterPropertyValidator(properties).assertSuccess(), { Cidr: cdk.stringToCloudFormation(properties.cidr), Policy: cdk.stringToCloudFormation(properties.policy) }) : properties;
    }
    function CfnReceiptFilterIpFilterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cidr", "Cidr", cfn_parse.FromCloudFormation.getString(properties.Cidr)), ret.addPropertyResult("policy", "Policy", cfn_parse.FromCloudFormation.getString(properties.Policy)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnReceiptRulePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("after", cdk.validateString)(properties.after)), errors.collect(cdk.propertyValidator("rule", cdk.requiredValidator)(properties.rule)), errors.collect(cdk.propertyValidator("rule", CfnReceiptRule_RulePropertyValidator)(properties.rule)), errors.collect(cdk.propertyValidator("ruleSetName", cdk.requiredValidator)(properties.ruleSetName)), errors.collect(cdk.propertyValidator("ruleSetName", cdk.validateString)(properties.ruleSetName)), errors.wrap('supplied properties not correct for "CfnReceiptRuleProps"');
    }
    function cfnReceiptRulePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReceiptRulePropsValidator(properties).assertSuccess(), { Rule: cfnReceiptRuleRulePropertyToCloudFormation(properties.rule), RuleSetName: cdk.stringToCloudFormation(properties.ruleSetName), After: cdk.stringToCloudFormation(properties.after) }) : properties;
    }
    function CfnReceiptRulePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("rule", "Rule", CfnReceiptRuleRulePropertyFromCloudFormation(properties.Rule)), ret.addPropertyResult("ruleSetName", "RuleSetName", cfn_parse.FromCloudFormation.getString(properties.RuleSetName)), ret.addPropertyResult("after", "After", properties.After != null ? cfn_parse.FromCloudFormation.getString(properties.After) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnReceiptRule = class _CfnReceiptRule extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnReceiptRulePropsFromCloudFormation(resourceProperties), ret = new _CfnReceiptRule(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnReceiptRule.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_CfnReceiptRuleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnReceiptRule), error;
        }
        cdk.requireProperty(props, "rule", this), cdk.requireProperty(props, "ruleSetName", this), this.rule = props.rule, this.ruleSetName = props.ruleSetName, this.after = props.after;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnReceiptRule.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { rule: this.rule, ruleSetName: this.ruleSetName, after: this.after };
      }
      renderProperties(props) {
        return cfnReceiptRulePropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnReceiptRule[_g] = { fqn: "aws-cdk-lib.aws_ses.CfnReceiptRule", version: "2.80.0" }, CfnReceiptRule.CFN_RESOURCE_TYPE_NAME = "AWS::SES::ReceiptRule", exports2.CfnReceiptRule = CfnReceiptRule;
    function CfnReceiptRule_ActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("addHeaderAction", CfnReceiptRule_AddHeaderActionPropertyValidator)(properties.addHeaderAction)), errors.collect(cdk.propertyValidator("bounceAction", CfnReceiptRule_BounceActionPropertyValidator)(properties.bounceAction)), errors.collect(cdk.propertyValidator("lambdaAction", CfnReceiptRule_LambdaActionPropertyValidator)(properties.lambdaAction)), errors.collect(cdk.propertyValidator("s3Action", CfnReceiptRule_S3ActionPropertyValidator)(properties.s3Action)), errors.collect(cdk.propertyValidator("snsAction", CfnReceiptRule_SNSActionPropertyValidator)(properties.snsAction)), errors.collect(cdk.propertyValidator("stopAction", CfnReceiptRule_StopActionPropertyValidator)(properties.stopAction)), errors.collect(cdk.propertyValidator("workmailAction", CfnReceiptRule_WorkmailActionPropertyValidator)(properties.workmailAction)), errors.wrap('supplied properties not correct for "ActionProperty"');
    }
    function cfnReceiptRuleActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReceiptRule_ActionPropertyValidator(properties).assertSuccess(), { AddHeaderAction: cfnReceiptRuleAddHeaderActionPropertyToCloudFormation(properties.addHeaderAction), BounceAction: cfnReceiptRuleBounceActionPropertyToCloudFormation(properties.bounceAction), LambdaAction: cfnReceiptRuleLambdaActionPropertyToCloudFormation(properties.lambdaAction), S3Action: cfnReceiptRuleS3ActionPropertyToCloudFormation(properties.s3Action), SNSAction: cfnReceiptRuleSNSActionPropertyToCloudFormation(properties.snsAction), StopAction: cfnReceiptRuleStopActionPropertyToCloudFormation(properties.stopAction), WorkmailAction: cfnReceiptRuleWorkmailActionPropertyToCloudFormation(properties.workmailAction) }) : properties;
    }
    function CfnReceiptRuleActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("addHeaderAction", "AddHeaderAction", properties.AddHeaderAction != null ? CfnReceiptRuleAddHeaderActionPropertyFromCloudFormation(properties.AddHeaderAction) : void 0), ret.addPropertyResult("bounceAction", "BounceAction", properties.BounceAction != null ? CfnReceiptRuleBounceActionPropertyFromCloudFormation(properties.BounceAction) : void 0), ret.addPropertyResult("lambdaAction", "LambdaAction", properties.LambdaAction != null ? CfnReceiptRuleLambdaActionPropertyFromCloudFormation(properties.LambdaAction) : void 0), ret.addPropertyResult("s3Action", "S3Action", properties.S3Action != null ? CfnReceiptRuleS3ActionPropertyFromCloudFormation(properties.S3Action) : void 0), ret.addPropertyResult("snsAction", "SNSAction", properties.SNSAction != null ? CfnReceiptRuleSNSActionPropertyFromCloudFormation(properties.SNSAction) : void 0), ret.addPropertyResult("stopAction", "StopAction", properties.StopAction != null ? CfnReceiptRuleStopActionPropertyFromCloudFormation(properties.StopAction) : void 0), ret.addPropertyResult("workmailAction", "WorkmailAction", properties.WorkmailAction != null ? CfnReceiptRuleWorkmailActionPropertyFromCloudFormation(properties.WorkmailAction) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnReceiptRule_AddHeaderActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("headerName", cdk.requiredValidator)(properties.headerName)), errors.collect(cdk.propertyValidator("headerName", cdk.validateString)(properties.headerName)), errors.collect(cdk.propertyValidator("headerValue", cdk.requiredValidator)(properties.headerValue)), errors.collect(cdk.propertyValidator("headerValue", cdk.validateString)(properties.headerValue)), errors.wrap('supplied properties not correct for "AddHeaderActionProperty"');
    }
    function cfnReceiptRuleAddHeaderActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReceiptRule_AddHeaderActionPropertyValidator(properties).assertSuccess(), { HeaderName: cdk.stringToCloudFormation(properties.headerName), HeaderValue: cdk.stringToCloudFormation(properties.headerValue) }) : properties;
    }
    function CfnReceiptRuleAddHeaderActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("headerName", "HeaderName", cfn_parse.FromCloudFormation.getString(properties.HeaderName)), ret.addPropertyResult("headerValue", "HeaderValue", cfn_parse.FromCloudFormation.getString(properties.HeaderValue)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnReceiptRule_BounceActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("message", cdk.requiredValidator)(properties.message)), errors.collect(cdk.propertyValidator("message", cdk.validateString)(properties.message)), errors.collect(cdk.propertyValidator("sender", cdk.requiredValidator)(properties.sender)), errors.collect(cdk.propertyValidator("sender", cdk.validateString)(properties.sender)), errors.collect(cdk.propertyValidator("smtpReplyCode", cdk.requiredValidator)(properties.smtpReplyCode)), errors.collect(cdk.propertyValidator("smtpReplyCode", cdk.validateString)(properties.smtpReplyCode)), errors.collect(cdk.propertyValidator("statusCode", cdk.validateString)(properties.statusCode)), errors.collect(cdk.propertyValidator("topicArn", cdk.validateString)(properties.topicArn)), errors.wrap('supplied properties not correct for "BounceActionProperty"');
    }
    function cfnReceiptRuleBounceActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReceiptRule_BounceActionPropertyValidator(properties).assertSuccess(), { Message: cdk.stringToCloudFormation(properties.message), Sender: cdk.stringToCloudFormation(properties.sender), SmtpReplyCode: cdk.stringToCloudFormation(properties.smtpReplyCode), StatusCode: cdk.stringToCloudFormation(properties.statusCode), TopicArn: cdk.stringToCloudFormation(properties.topicArn) }) : properties;
    }
    function CfnReceiptRuleBounceActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("message", "Message", cfn_parse.FromCloudFormation.getString(properties.Message)), ret.addPropertyResult("sender", "Sender", cfn_parse.FromCloudFormation.getString(properties.Sender)), ret.addPropertyResult("smtpReplyCode", "SmtpReplyCode", cfn_parse.FromCloudFormation.getString(properties.SmtpReplyCode)), ret.addPropertyResult("statusCode", "StatusCode", properties.StatusCode != null ? cfn_parse.FromCloudFormation.getString(properties.StatusCode) : void 0), ret.addPropertyResult("topicArn", "TopicArn", properties.TopicArn != null ? cfn_parse.FromCloudFormation.getString(properties.TopicArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnReceiptRule_LambdaActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("functionArn", cdk.requiredValidator)(properties.functionArn)), errors.collect(cdk.propertyValidator("functionArn", cdk.validateString)(properties.functionArn)), errors.collect(cdk.propertyValidator("invocationType", cdk.validateString)(properties.invocationType)), errors.collect(cdk.propertyValidator("topicArn", cdk.validateString)(properties.topicArn)), errors.wrap('supplied properties not correct for "LambdaActionProperty"');
    }
    function cfnReceiptRuleLambdaActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReceiptRule_LambdaActionPropertyValidator(properties).assertSuccess(), { FunctionArn: cdk.stringToCloudFormation(properties.functionArn), InvocationType: cdk.stringToCloudFormation(properties.invocationType), TopicArn: cdk.stringToCloudFormation(properties.topicArn) }) : properties;
    }
    function CfnReceiptRuleLambdaActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("functionArn", "FunctionArn", cfn_parse.FromCloudFormation.getString(properties.FunctionArn)), ret.addPropertyResult("invocationType", "InvocationType", properties.InvocationType != null ? cfn_parse.FromCloudFormation.getString(properties.InvocationType) : void 0), ret.addPropertyResult("topicArn", "TopicArn", properties.TopicArn != null ? cfn_parse.FromCloudFormation.getString(properties.TopicArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnReceiptRule_RulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnReceiptRule_ActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("recipients", cdk.listValidator(cdk.validateString))(properties.recipients)), errors.collect(cdk.propertyValidator("scanEnabled", cdk.validateBoolean)(properties.scanEnabled)), errors.collect(cdk.propertyValidator("tlsPolicy", cdk.validateString)(properties.tlsPolicy)), errors.wrap('supplied properties not correct for "RuleProperty"');
    }
    function cfnReceiptRuleRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReceiptRule_RulePropertyValidator(properties).assertSuccess(), { Actions: cdk.listMapper(cfnReceiptRuleActionPropertyToCloudFormation)(properties.actions), Enabled: cdk.booleanToCloudFormation(properties.enabled), Name: cdk.stringToCloudFormation(properties.name), Recipients: cdk.listMapper(cdk.stringToCloudFormation)(properties.recipients), ScanEnabled: cdk.booleanToCloudFormation(properties.scanEnabled), TlsPolicy: cdk.stringToCloudFormation(properties.tlsPolicy) }) : properties;
    }
    function CfnReceiptRuleRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnReceiptRuleActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("recipients", "Recipients", properties.Recipients != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Recipients) : void 0), ret.addPropertyResult("scanEnabled", "ScanEnabled", properties.ScanEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ScanEnabled) : void 0), ret.addPropertyResult("tlsPolicy", "TlsPolicy", properties.TlsPolicy != null ? cfn_parse.FromCloudFormation.getString(properties.TlsPolicy) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnReceiptRule_S3ActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketName", cdk.requiredValidator)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.collect(cdk.propertyValidator("kmsKeyArn", cdk.validateString)(properties.kmsKeyArn)), errors.collect(cdk.propertyValidator("objectKeyPrefix", cdk.validateString)(properties.objectKeyPrefix)), errors.collect(cdk.propertyValidator("topicArn", cdk.validateString)(properties.topicArn)), errors.wrap('supplied properties not correct for "S3ActionProperty"');
    }
    function cfnReceiptRuleS3ActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReceiptRule_S3ActionPropertyValidator(properties).assertSuccess(), { BucketName: cdk.stringToCloudFormation(properties.bucketName), KmsKeyArn: cdk.stringToCloudFormation(properties.kmsKeyArn), ObjectKeyPrefix: cdk.stringToCloudFormation(properties.objectKeyPrefix), TopicArn: cdk.stringToCloudFormation(properties.topicArn) }) : properties;
    }
    function CfnReceiptRuleS3ActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketName", "BucketName", cfn_parse.FromCloudFormation.getString(properties.BucketName)), ret.addPropertyResult("kmsKeyArn", "KmsKeyArn", properties.KmsKeyArn != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyArn) : void 0), ret.addPropertyResult("objectKeyPrefix", "ObjectKeyPrefix", properties.ObjectKeyPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.ObjectKeyPrefix) : void 0), ret.addPropertyResult("topicArn", "TopicArn", properties.TopicArn != null ? cfn_parse.FromCloudFormation.getString(properties.TopicArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnReceiptRule_SNSActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("encoding", cdk.validateString)(properties.encoding)), errors.collect(cdk.propertyValidator("topicArn", cdk.validateString)(properties.topicArn)), errors.wrap('supplied properties not correct for "SNSActionProperty"');
    }
    function cfnReceiptRuleSNSActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReceiptRule_SNSActionPropertyValidator(properties).assertSuccess(), { Encoding: cdk.stringToCloudFormation(properties.encoding), TopicArn: cdk.stringToCloudFormation(properties.topicArn) }) : properties;
    }
    function CfnReceiptRuleSNSActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("encoding", "Encoding", properties.Encoding != null ? cfn_parse.FromCloudFormation.getString(properties.Encoding) : void 0), ret.addPropertyResult("topicArn", "TopicArn", properties.TopicArn != null ? cfn_parse.FromCloudFormation.getString(properties.TopicArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnReceiptRule_StopActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("scope", cdk.requiredValidator)(properties.scope)), errors.collect(cdk.propertyValidator("scope", cdk.validateString)(properties.scope)), errors.collect(cdk.propertyValidator("topicArn", cdk.validateString)(properties.topicArn)), errors.wrap('supplied properties not correct for "StopActionProperty"');
    }
    function cfnReceiptRuleStopActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReceiptRule_StopActionPropertyValidator(properties).assertSuccess(), { Scope: cdk.stringToCloudFormation(properties.scope), TopicArn: cdk.stringToCloudFormation(properties.topicArn) }) : properties;
    }
    function CfnReceiptRuleStopActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("scope", "Scope", cfn_parse.FromCloudFormation.getString(properties.Scope)), ret.addPropertyResult("topicArn", "TopicArn", properties.TopicArn != null ? cfn_parse.FromCloudFormation.getString(properties.TopicArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnReceiptRule_WorkmailActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("organizationArn", cdk.requiredValidator)(properties.organizationArn)), errors.collect(cdk.propertyValidator("organizationArn", cdk.validateString)(properties.organizationArn)), errors.collect(cdk.propertyValidator("topicArn", cdk.validateString)(properties.topicArn)), errors.wrap('supplied properties not correct for "WorkmailActionProperty"');
    }
    function cfnReceiptRuleWorkmailActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReceiptRule_WorkmailActionPropertyValidator(properties).assertSuccess(), { OrganizationArn: cdk.stringToCloudFormation(properties.organizationArn), TopicArn: cdk.stringToCloudFormation(properties.topicArn) }) : properties;
    }
    function CfnReceiptRuleWorkmailActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("organizationArn", "OrganizationArn", cfn_parse.FromCloudFormation.getString(properties.OrganizationArn)), ret.addPropertyResult("topicArn", "TopicArn", properties.TopicArn != null ? cfn_parse.FromCloudFormation.getString(properties.TopicArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnReceiptRuleSetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ruleSetName", cdk.validateString)(properties.ruleSetName)), errors.wrap('supplied properties not correct for "CfnReceiptRuleSetProps"');
    }
    function cfnReceiptRuleSetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReceiptRuleSetPropsValidator(properties).assertSuccess(), { RuleSetName: cdk.stringToCloudFormation(properties.ruleSetName) }) : properties;
    }
    function CfnReceiptRuleSetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ruleSetName", "RuleSetName", properties.RuleSetName != null ? cfn_parse.FromCloudFormation.getString(properties.RuleSetName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnReceiptRuleSet = class _CfnReceiptRuleSet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnReceiptRuleSetPropsFromCloudFormation(resourceProperties), ret = new _CfnReceiptRuleSet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnReceiptRuleSet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_CfnReceiptRuleSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnReceiptRuleSet), error;
        }
        this.ruleSetName = props.ruleSetName;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnReceiptRuleSet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { ruleSetName: this.ruleSetName };
      }
      renderProperties(props) {
        return cfnReceiptRuleSetPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnReceiptRuleSet[_h] = { fqn: "aws-cdk-lib.aws_ses.CfnReceiptRuleSet", version: "2.80.0" }, CfnReceiptRuleSet.CFN_RESOURCE_TYPE_NAME = "AWS::SES::ReceiptRuleSet", exports2.CfnReceiptRuleSet = CfnReceiptRuleSet;
    function CfnTemplatePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("template", CfnTemplate_TemplatePropertyValidator)(properties.template)), errors.wrap('supplied properties not correct for "CfnTemplateProps"');
    }
    function cfnTemplatePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplatePropsValidator(properties).assertSuccess(), { Template: cfnTemplateTemplatePropertyToCloudFormation(properties.template) }) : properties;
    }
    function CfnTemplatePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("template", "Template", properties.Template != null ? CfnTemplateTemplatePropertyFromCloudFormation(properties.Template) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTemplate = class _CfnTemplate extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTemplatePropsFromCloudFormation(resourceProperties), ret = new _CfnTemplate(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnTemplate.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_CfnTemplateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTemplate), error;
        }
        this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.template = props.template;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTemplate.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { template: this.template };
      }
      renderProperties(props) {
        return cfnTemplatePropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnTemplate[_j] = { fqn: "aws-cdk-lib.aws_ses.CfnTemplate", version: "2.80.0" }, CfnTemplate.CFN_RESOURCE_TYPE_NAME = "AWS::SES::Template", exports2.CfnTemplate = CfnTemplate;
    function CfnTemplate_TemplatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("htmlPart", cdk.validateString)(properties.htmlPart)), errors.collect(cdk.propertyValidator("subjectPart", cdk.requiredValidator)(properties.subjectPart)), errors.collect(cdk.propertyValidator("subjectPart", cdk.validateString)(properties.subjectPart)), errors.collect(cdk.propertyValidator("templateName", cdk.validateString)(properties.templateName)), errors.collect(cdk.propertyValidator("textPart", cdk.validateString)(properties.textPart)), errors.wrap('supplied properties not correct for "TemplateProperty"');
    }
    function cfnTemplateTemplatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTemplate_TemplatePropertyValidator(properties).assertSuccess(), { HtmlPart: cdk.stringToCloudFormation(properties.htmlPart), SubjectPart: cdk.stringToCloudFormation(properties.subjectPart), TemplateName: cdk.stringToCloudFormation(properties.templateName), TextPart: cdk.stringToCloudFormation(properties.textPart) }) : properties;
    }
    function CfnTemplateTemplatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("htmlPart", "HtmlPart", properties.HtmlPart != null ? cfn_parse.FromCloudFormation.getString(properties.HtmlPart) : void 0), ret.addPropertyResult("subjectPart", "SubjectPart", cfn_parse.FromCloudFormation.getString(properties.SubjectPart)), ret.addPropertyResult("templateName", "TemplateName", properties.TemplateName != null ? cfn_parse.FromCloudFormation.getString(properties.TemplateName) : void 0), ret.addPropertyResult("textPart", "TextPart", properties.TextPart != null ? cfn_parse.FromCloudFormation.getString(properties.TextPart) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVdmAttributesPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dashboardAttributes", CfnVdmAttributes_DashboardAttributesPropertyValidator)(properties.dashboardAttributes)), errors.collect(cdk.propertyValidator("guardianAttributes", CfnVdmAttributes_GuardianAttributesPropertyValidator)(properties.guardianAttributes)), errors.wrap('supplied properties not correct for "CfnVdmAttributesProps"');
    }
    function cfnVdmAttributesPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVdmAttributesPropsValidator(properties).assertSuccess(), { DashboardAttributes: cfnVdmAttributesDashboardAttributesPropertyToCloudFormation(properties.dashboardAttributes), GuardianAttributes: cfnVdmAttributesGuardianAttributesPropertyToCloudFormation(properties.guardianAttributes) }) : properties;
    }
    function CfnVdmAttributesPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dashboardAttributes", "DashboardAttributes", properties.DashboardAttributes != null ? CfnVdmAttributesDashboardAttributesPropertyFromCloudFormation(properties.DashboardAttributes) : void 0), ret.addPropertyResult("guardianAttributes", "GuardianAttributes", properties.GuardianAttributes != null ? CfnVdmAttributesGuardianAttributesPropertyFromCloudFormation(properties.GuardianAttributes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnVdmAttributes = class _CfnVdmAttributes extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnVdmAttributesPropsFromCloudFormation(resourceProperties), ret = new _CfnVdmAttributes(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnVdmAttributes.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_CfnVdmAttributesProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnVdmAttributes), error;
        }
        this.attrVdmAttributesResourceId = cdk.Token.asString(this.getAtt("VdmAttributesResourceId", cdk.ResolutionTypeHint.STRING)), this.dashboardAttributes = props.dashboardAttributes, this.guardianAttributes = props.guardianAttributes;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnVdmAttributes.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { dashboardAttributes: this.dashboardAttributes, guardianAttributes: this.guardianAttributes };
      }
      renderProperties(props) {
        return cfnVdmAttributesPropsToCloudFormation(props);
      }
    };
    _k = JSII_RTTI_SYMBOL_1, CfnVdmAttributes[_k] = { fqn: "aws-cdk-lib.aws_ses.CfnVdmAttributes", version: "2.80.0" }, CfnVdmAttributes.CFN_RESOURCE_TYPE_NAME = "AWS::SES::VdmAttributes", exports2.CfnVdmAttributes = CfnVdmAttributes;
    function CfnVdmAttributes_DashboardAttributesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("engagementMetrics", cdk.validateString)(properties.engagementMetrics)), errors.wrap('supplied properties not correct for "DashboardAttributesProperty"');
    }
    function cfnVdmAttributesDashboardAttributesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVdmAttributes_DashboardAttributesPropertyValidator(properties).assertSuccess(), { EngagementMetrics: cdk.stringToCloudFormation(properties.engagementMetrics) }) : properties;
    }
    function CfnVdmAttributesDashboardAttributesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("engagementMetrics", "EngagementMetrics", properties.EngagementMetrics != null ? cfn_parse.FromCloudFormation.getString(properties.EngagementMetrics) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnVdmAttributes_GuardianAttributesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("optimizedSharedDelivery", cdk.validateString)(properties.optimizedSharedDelivery)), errors.wrap('supplied properties not correct for "GuardianAttributesProperty"');
    }
    function cfnVdmAttributesGuardianAttributesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnVdmAttributes_GuardianAttributesPropertyValidator(properties).assertSuccess(), { OptimizedSharedDelivery: cdk.stringToCloudFormation(properties.optimizedSharedDelivery) }) : properties;
    }
    function CfnVdmAttributesGuardianAttributesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("optimizedSharedDelivery", "OptimizedSharedDelivery", properties.OptimizedSharedDelivery != null ? cfn_parse.FromCloudFormation.getString(properties.OptimizedSharedDelivery) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-ses/lib/receipt-rule.js
var require_receipt_rule = __commonJS({
  "node_modules/aws-cdk-lib/aws-ses/lib/receipt-rule.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DropSpamReceiptRule = exports2.ReceiptRule = exports2.TlsPolicy = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var path = require("path");
    var constructs_1 = require_lib2();
    var ses_generated_1 = require_ses_generated();
    var iam = require_aws_iam();
    var lambda2 = require_aws_lambda();
    var core_1 = require_core2();
    var TlsPolicy;
    (function(TlsPolicy2) {
      TlsPolicy2.OPTIONAL = "Optional", TlsPolicy2.REQUIRE = "Require";
    })(TlsPolicy = exports2.TlsPolicy || (exports2.TlsPolicy = {}));
    var ReceiptRule = class _ReceiptRule extends core_1.Resource {
      static fromReceiptRuleName(scope, id, receiptRuleName) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.receiptRuleName = receiptRuleName;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.receiptRuleName }), this.actions = new Array();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_ReceiptRuleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ReceiptRule), error;
        }
        const resource = new ses_generated_1.CfnReceiptRule(this, "Resource", { after: props.after?.receiptRuleName, rule: { actions: core_1.Lazy.any({ produce: () => this.renderActions() }), enabled: props.enabled ?? true, name: this.physicalName, recipients: props.recipients, scanEnabled: props.scanEnabled, tlsPolicy: props.tlsPolicy }, ruleSetName: props.ruleSet.receiptRuleSetName });
        this.receiptRuleName = resource.ref;
        for (const action of props.actions || [])
          this.addAction(action);
      }
      addAction(action) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_IReceiptRuleAction(action);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addAction), error;
        }
        this.actions.push(action.bind(this));
      }
      renderActions() {
        if (this.actions.length !== 0)
          return this.actions;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ReceiptRule[_a] = { fqn: "aws-cdk-lib.aws_ses.ReceiptRule", version: "2.80.0" }, exports2.ReceiptRule = ReceiptRule;
    var DropSpamReceiptRule = class _DropSpamReceiptRule extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_DropSpamReceiptRuleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _DropSpamReceiptRule), error;
        }
        const fn = new lambda2.SingletonFunction(this, "Function", { runtime: lambda2.Runtime.NODEJS_14_X, handler: "index.handler", code: lambda2.Code.fromAsset(path.join(__dirname, "drop-spam-handler")), uuid: "224e77f9-a32e-4b4d-ac32-983477abba16" });
        fn.addPermission("AllowSes", { action: "lambda:InvokeFunction", principal: new iam.ServicePrincipal("ses.amazonaws.com"), sourceAccount: core_1.Aws.ACCOUNT_ID }), this.rule = new ReceiptRule(this, "Rule", { actions: [{ bind: () => ({ lambdaAction: { functionArn: fn.functionArn, invocationType: "RequestResponse" } }) }], scanEnabled: true, ruleSet: props.ruleSet });
      }
    };
    _b = JSII_RTTI_SYMBOL_1, DropSpamReceiptRule[_b] = { fqn: "aws-cdk-lib.aws_ses.DropSpamReceiptRule", version: "2.80.0" }, exports2.DropSpamReceiptRule = DropSpamReceiptRule;
  }
});

// node_modules/aws-cdk-lib/aws-ses/lib/receipt-rule-set.js
var require_receipt_rule_set = __commonJS({
  "node_modules/aws-cdk-lib/aws-ses/lib/receipt-rule-set.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ReceiptRuleSet = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var receipt_rule_1 = require_receipt_rule();
    var ses_generated_1 = require_ses_generated();
    var core_1 = require_core2();
    var ReceiptRuleSetBase = class extends core_1.Resource {
      addRule(id, options) {
        return this.lastAddedRule = new receipt_rule_1.ReceiptRule(this, id, { after: this.lastAddedRule ?? void 0, ruleSet: this, ...options }), this.lastAddedRule;
      }
      addDropSpamRule() {
        const dropSpam = new receipt_rule_1.DropSpamReceiptRule(this, "DropSpam", { ruleSet: this });
        this.lastAddedRule = dropSpam.rule;
      }
    };
    var ReceiptRuleSet = class _ReceiptRuleSet extends ReceiptRuleSetBase {
      static fromReceiptRuleSetName(scope, id, receiptRuleSetName) {
        class Import extends ReceiptRuleSetBase {
          constructor() {
            super(...arguments), this.receiptRuleSetName = receiptRuleSetName;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.receiptRuleSetName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_ReceiptRuleSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ReceiptRuleSet), error;
        }
        const resource = new ses_generated_1.CfnReceiptRuleSet(this, "Resource", { ruleSetName: this.physicalName });
        this.receiptRuleSetName = resource.ref, props && (props.dropSpam && this.addDropSpamRule(), (props.rules || []).forEach((ruleOption, idx) => this.addRule(`Rule${idx}`, ruleOption)));
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ReceiptRuleSet[_a] = { fqn: "aws-cdk-lib.aws_ses.ReceiptRuleSet", version: "2.80.0" }, exports2.ReceiptRuleSet = ReceiptRuleSet;
  }
});

// node_modules/aws-cdk-lib/aws-ses/lib/receipt-rule-action.js
var require_receipt_rule_action = __commonJS({
  "node_modules/aws-cdk-lib/aws-ses/lib/receipt-rule-action.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-ses/lib/receipt-filter.js
var require_receipt_filter = __commonJS({
  "node_modules/aws-cdk-lib/aws-ses/lib/receipt-filter.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.WhiteListReceiptFilter = exports2.AllowListReceiptFilter = exports2.ReceiptFilter = exports2.ReceiptFilterPolicy = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var ses_generated_1 = require_ses_generated();
    var core_1 = require_core2();
    var ReceiptFilterPolicy;
    (function(ReceiptFilterPolicy2) {
      ReceiptFilterPolicy2.ALLOW = "Allow", ReceiptFilterPolicy2.BLOCK = "Block";
    })(ReceiptFilterPolicy = exports2.ReceiptFilterPolicy || (exports2.ReceiptFilterPolicy = {}));
    var ReceiptFilter = class _ReceiptFilter extends core_1.Resource {
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.receiptFilterName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_ReceiptFilterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ReceiptFilter), error;
        }
        new ses_generated_1.CfnReceiptFilter(this, "Resource", { filter: { ipFilter: { cidr: props.ip || "0.0.0.0/0", policy: props.policy || ReceiptFilterPolicy.BLOCK }, name: this.physicalName } });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ReceiptFilter[_a] = { fqn: "aws-cdk-lib.aws_ses.ReceiptFilter", version: "2.80.0" }, exports2.ReceiptFilter = ReceiptFilter;
    var AllowListReceiptFilter = class _AllowListReceiptFilter extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_AllowListReceiptFilterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AllowListReceiptFilter), error;
        }
        new ReceiptFilter(this, "BlockAll"), props.ips.forEach((ip) => {
          new ReceiptFilter(this, `Allow${ip.replace(/[^\d]/g, "")}`, { ip, policy: ReceiptFilterPolicy.ALLOW });
        });
      }
    };
    _b = JSII_RTTI_SYMBOL_1, AllowListReceiptFilter[_b] = { fqn: "aws-cdk-lib.aws_ses.AllowListReceiptFilter", version: "2.80.0" }, exports2.AllowListReceiptFilter = AllowListReceiptFilter;
    var WhiteListReceiptFilter = class extends AllowListReceiptFilter {
      constructor(scope, id, props) {
        super(scope, id, props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, WhiteListReceiptFilter[_c] = { fqn: "aws-cdk-lib.aws_ses.WhiteListReceiptFilter", version: "2.80.0" }, exports2.WhiteListReceiptFilter = WhiteListReceiptFilter;
  }
});

// node_modules/aws-cdk-lib/aws-ses/lib/dedicated-ip-pool.js
var require_dedicated_ip_pool = __commonJS({
  "node_modules/aws-cdk-lib/aws-ses/lib/dedicated-ip-pool.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DedicatedIpPool = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var ses_generated_1 = require_ses_generated();
    var core_1 = require_core2();
    var DedicatedIpPool = class _DedicatedIpPool extends core_1.Resource {
      static fromDedicatedIpPoolName(scope, id, dedicatedIpPoolName) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.dedicatedIpPoolName = dedicatedIpPoolName;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.dedicatedIpPoolName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_DedicatedIpPoolProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _DedicatedIpPool), error;
        }
        const pool = new ses_generated_1.CfnDedicatedIpPool(this, "Resource", { poolName: this.physicalName });
        this.dedicatedIpPoolName = pool.ref;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, DedicatedIpPool[_a] = { fqn: "aws-cdk-lib.aws_ses.DedicatedIpPool", version: "2.80.0" }, exports2.DedicatedIpPool = DedicatedIpPool;
  }
});

// node_modules/aws-cdk-lib/aws-ses/lib/configuration-set-event-destination.js
var require_configuration_set_event_destination = __commonJS({
  "node_modules/aws-cdk-lib/aws-ses/lib/configuration-set-event-destination.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ConfigurationSetEventDestination = exports2.CloudWatchDimensionSource = exports2.EmailSendingEvent = exports2.EventDestination = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var ses_generated_1 = require_ses_generated();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var EventDestination = class {
      static snsTopic(topic) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sns_ITopic(topic);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.snsTopic), error;
        }
        return { topic };
      }
      static cloudWatchDimensions(dimensions) {
        return { dimensions };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EventDestination[_a] = { fqn: "aws-cdk-lib.aws_ses.EventDestination", version: "2.80.0" }, exports2.EventDestination = EventDestination;
    var EmailSendingEvent;
    (function(EmailSendingEvent2) {
      EmailSendingEvent2.SEND = "send", EmailSendingEvent2.REJECT = "reject", EmailSendingEvent2.BOUNCE = "bounce", EmailSendingEvent2.COMPLAINT = "complaint", EmailSendingEvent2.DELIVERY = "delivery", EmailSendingEvent2.OPEN = "open", EmailSendingEvent2.CLICK = "click", EmailSendingEvent2.RENDERING_FAILURE = "renderingFailure", EmailSendingEvent2.DELIVERY_DELAY = "deliveryDelay", EmailSendingEvent2.SUBSCRIPTION = "subscription";
    })(EmailSendingEvent = exports2.EmailSendingEvent || (exports2.EmailSendingEvent = {}));
    var CloudWatchDimensionSource;
    (function(CloudWatchDimensionSource2) {
      CloudWatchDimensionSource2.EMAIL_HEADER = "emailHeader", CloudWatchDimensionSource2.LINK_TAG = "linkTag", CloudWatchDimensionSource2.MESSAGE_TAG = "messageTag";
    })(CloudWatchDimensionSource = exports2.CloudWatchDimensionSource || (exports2.CloudWatchDimensionSource = {}));
    var ConfigurationSetEventDestination = class _ConfigurationSetEventDestination extends core_1.Resource {
      static fromConfigurationSetEventDestinationId(scope, id, configurationSetEventDestinationId) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.configurationSetEventDestinationId = configurationSetEventDestinationId;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.configurationSetEventDestinationName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_ConfigurationSetEventDestinationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ConfigurationSetEventDestination), error;
        }
        const configurationSet = new ses_generated_1.CfnConfigurationSetEventDestination(this, "Resource", { configurationSetName: props.configurationSet.configurationSetName, eventDestination: { name: this.physicalName, enabled: props.enabled ?? true, matchingEventTypes: props.events ?? Object.values(EmailSendingEvent), snsDestination: props.destination.topic ? { topicArn: props.destination.topic.topicArn } : void 0, cloudWatchDestination: props.destination.dimensions ? { dimensionConfigurations: props.destination.dimensions.map((dimension) => ({ dimensionValueSource: dimension.source, dimensionName: dimension.name, defaultDimensionValue: dimension.defaultValue })) } : void 0 } });
        if (this.configurationSetEventDestinationId = configurationSet.attrId, props.destination.topic) {
          const result = props.destination.topic.addToResourcePolicy(new iam.PolicyStatement({ actions: ["sns:Publish"], resources: [props.destination.topic.topicArn], principals: [new iam.ServicePrincipal("ses.amazonaws.com")], conditions: { StringEquals: { "AWS:SourceAccount": this.env.account, "AWS:SourceArn": `arn:${core_1.Aws.PARTITION}:ses:${this.env.region}:${this.env.account}:configuration-set/${props.configurationSet.configurationSetName}` } } }));
          result.policyDependable && this.node.addDependency(result.policyDependable);
        }
      }
    };
    _b = JSII_RTTI_SYMBOL_1, ConfigurationSetEventDestination[_b] = { fqn: "aws-cdk-lib.aws_ses.ConfigurationSetEventDestination", version: "2.80.0" }, exports2.ConfigurationSetEventDestination = ConfigurationSetEventDestination;
  }
});

// node_modules/aws-cdk-lib/aws-ses/lib/private/utils.js
var require_utils14 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ses/lib/private/utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.undefinedIfNoKeys = void 0;
    function undefinedIfNoKeys(obj) {
      return Object.values(obj).every((val) => val === void 0) ? void 0 : obj;
    }
    exports2.undefinedIfNoKeys = undefinedIfNoKeys;
  }
});

// node_modules/aws-cdk-lib/aws-ses/lib/configuration-set.js
var require_configuration_set = __commonJS({
  "node_modules/aws-cdk-lib/aws-ses/lib/configuration-set.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ConfigurationSet = exports2.SuppressionReasons = exports2.ConfigurationSetTlsPolicy = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var configuration_set_event_destination_1 = require_configuration_set_event_destination();
    var utils_1 = require_utils14();
    var ses_generated_1 = require_ses_generated();
    var core_1 = require_core2();
    var ConfigurationSetTlsPolicy;
    (function(ConfigurationSetTlsPolicy2) {
      ConfigurationSetTlsPolicy2.REQUIRE = "REQUIRE", ConfigurationSetTlsPolicy2.OPTIONAL = "OPTIONAL";
    })(ConfigurationSetTlsPolicy = exports2.ConfigurationSetTlsPolicy || (exports2.ConfigurationSetTlsPolicy = {}));
    var SuppressionReasons;
    (function(SuppressionReasons2) {
      SuppressionReasons2.BOUNCES_AND_COMPLAINTS = "BOUNCES_AND_COMPLAINTS", SuppressionReasons2.BOUNCES_ONLY = "BOUNCES_ONLY", SuppressionReasons2.COMPLAINTS_ONLY = "COMPLAINTS_ONLY";
    })(SuppressionReasons = exports2.SuppressionReasons || (exports2.SuppressionReasons = {}));
    var ConfigurationSet = class _ConfigurationSet extends core_1.Resource {
      static fromConfigurationSetName(scope, id, configurationSetName) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.configurationSetName = configurationSetName;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { physicalName: props.configurationSetName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_ConfigurationSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ConfigurationSet), error;
        }
        const configurationSet = new ses_generated_1.CfnConfigurationSet(this, "Resource", { deliveryOptions: (0, utils_1.undefinedIfNoKeys)({ sendingPoolName: props.dedicatedIpPool?.dedicatedIpPoolName, tlsPolicy: props.tlsPolicy }), name: this.physicalName, reputationOptions: (0, utils_1.undefinedIfNoKeys)({ reputationMetricsEnabled: props.reputationMetrics }), sendingOptions: (0, utils_1.undefinedIfNoKeys)({ sendingEnabled: props.sendingEnabled }), suppressionOptions: (0, utils_1.undefinedIfNoKeys)({ suppressedReasons: renderSuppressedReasons(props.suppressionReasons) }), trackingOptions: (0, utils_1.undefinedIfNoKeys)({ customRedirectDomain: props.customTrackingRedirectDomain }) });
        this.configurationSetName = configurationSet.ref;
      }
      addEventDestination(id, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_ConfigurationSetEventDestinationOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addEventDestination), error;
        }
        return new configuration_set_event_destination_1.ConfigurationSetEventDestination(this, id, { ...options, configurationSet: this });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ConfigurationSet[_a] = { fqn: "aws-cdk-lib.aws_ses.ConfigurationSet", version: "2.80.0" }, exports2.ConfigurationSet = ConfigurationSet;
    function renderSuppressedReasons(suppressionReasons) {
      if (suppressionReasons)
        switch (suppressionReasons) {
          case SuppressionReasons.BOUNCES_AND_COMPLAINTS:
            return ["BOUNCE", "COMPLAINT"];
          case SuppressionReasons.BOUNCES_ONLY:
            return ["BOUNCE"];
          case SuppressionReasons.COMPLAINTS_ONLY:
            return ["COMPLAINT"];
        }
    }
  }
});

// node_modules/aws-cdk-lib/aws-ses/lib/email-identity.js
var require_email_identity = __commonJS({
  "node_modules/aws-cdk-lib/aws-ses/lib/email-identity.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EmailIdentity = exports2.EasyDkimSigningKeyLength = exports2.DkimIdentity = exports2.MailFromBehaviorOnMxFailure = exports2.Identity = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var utils_1 = require_utils14();
    var ses_generated_1 = require_ses_generated();
    var route53 = require_aws_route53();
    var core_1 = require_core2();
    var Identity = class {
      static email(email) {
        return { value: email };
      }
      static domain(domain) {
        return { value: domain };
      }
      static publicHostedZone(hostedZone) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_route53_IPublicHostedZone(hostedZone);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.publicHostedZone), error;
        }
        return { value: hostedZone.zoneName, hostedZone };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Identity[_a] = { fqn: "aws-cdk-lib.aws_ses.Identity", version: "2.80.0" }, exports2.Identity = Identity;
    var MailFromBehaviorOnMxFailure;
    (function(MailFromBehaviorOnMxFailure2) {
      MailFromBehaviorOnMxFailure2.USE_DEFAULT_VALUE = "USE_DEFAULT_VALUE", MailFromBehaviorOnMxFailure2.REJECT_MESSAGE = "REJECT_MESSAGE";
    })(MailFromBehaviorOnMxFailure = exports2.MailFromBehaviorOnMxFailure || (exports2.MailFromBehaviorOnMxFailure = {}));
    var DkimIdentity = class {
      static easyDkim(signingKeyLength) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_EasyDkimSigningKeyLength(signingKeyLength);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.easyDkim), error;
        }
        return new EasyDkim(signingKeyLength);
      }
      static byoDkim(options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_ByoDkimOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.byoDkim), error;
        }
        return new ByoDkim(options);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, DkimIdentity[_b] = { fqn: "aws-cdk-lib.aws_ses.DkimIdentity", version: "2.80.0" }, exports2.DkimIdentity = DkimIdentity;
    var EasyDkim = class extends DkimIdentity {
      constructor(signingKeyLength) {
        super(), this.signingKeyLength = signingKeyLength;
      }
      bind(emailIdentity, hostedZone) {
        return hostedZone && (new route53.CfnRecordSet(emailIdentity, "DkimDnsToken1", { hostedZoneId: hostedZone.hostedZoneId, name: core_1.Lazy.string({ produce: () => emailIdentity.dkimDnsTokenName1 }), type: "CNAME", resourceRecords: [core_1.Lazy.string({ produce: () => emailIdentity.dkimDnsTokenValue1 })], ttl: "1800" }), new route53.CfnRecordSet(emailIdentity, "DkimDnsToken2", { hostedZoneId: hostedZone.hostedZoneId, name: core_1.Lazy.string({ produce: () => emailIdentity.dkimDnsTokenName2 }), type: "CNAME", resourceRecords: [core_1.Lazy.string({ produce: () => emailIdentity.dkimDnsTokenValue2 })], ttl: "1800" }), new route53.CfnRecordSet(emailIdentity, "DkimDnsToken3", { hostedZoneId: hostedZone.hostedZoneId, name: core_1.Lazy.string({ produce: () => emailIdentity.dkimDnsTokenName3 }), type: "CNAME", resourceRecords: [core_1.Lazy.string({ produce: () => emailIdentity.dkimDnsTokenValue3 })], ttl: "1800" })), this.signingKeyLength ? { nextSigningKeyLength: this.signingKeyLength } : void 0;
      }
    };
    var ByoDkim = class extends DkimIdentity {
      constructor(options) {
        super(), this.options = options;
      }
      bind(emailIdentity, hostedZone) {
        return hostedZone && this.options.publicKey && new route53.TxtRecord(emailIdentity, "DkimTxt", { zone: hostedZone, recordName: `${this.options.selector}._domainkey`, values: [`p=${this.options.publicKey}`] }), { domainSigningPrivateKey: this.options.privateKey.unsafeUnwrap(), domainSigningSelector: this.options.selector };
      }
    };
    var EasyDkimSigningKeyLength;
    (function(EasyDkimSigningKeyLength2) {
      EasyDkimSigningKeyLength2.RSA_1024_BIT = "RSA_1024_BIT", EasyDkimSigningKeyLength2.RSA_2048_BIT = "RSA_2048_BIT";
    })(EasyDkimSigningKeyLength = exports2.EasyDkimSigningKeyLength || (exports2.EasyDkimSigningKeyLength = {}));
    var EmailIdentity = class _EmailIdentity extends core_1.Resource {
      static fromEmailIdentityName(scope, id, emailIdentityName) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.emailIdentityName = emailIdentityName;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_EmailIdentityProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EmailIdentity), error;
        }
        const dkimIdentity = props.dkimIdentity ?? DkimIdentity.easyDkim(), identity = new ses_generated_1.CfnEmailIdentity(this, "Resource", { emailIdentity: props.identity.value, configurationSetAttributes: (0, utils_1.undefinedIfNoKeys)({ configurationSetName: props.configurationSet?.configurationSetName }), dkimAttributes: (0, utils_1.undefinedIfNoKeys)({ signingEnabled: props.dkimSigning }), dkimSigningAttributes: dkimIdentity.bind(this, props.identity.hostedZone), feedbackAttributes: (0, utils_1.undefinedIfNoKeys)({ emailForwardingEnabled: props.feedbackForwarding }), mailFromAttributes: (0, utils_1.undefinedIfNoKeys)({ mailFromDomain: props.mailFromDomain, behaviorOnMxFailure: props.mailFromBehaviorOnMxFailure }) });
        props.mailFromDomain && props.identity.hostedZone && (new route53.MxRecord(this, "MailFromMxRecord", { zone: props.identity.hostedZone, recordName: props.mailFromDomain, values: [{ priority: 10, hostName: `feedback-smtp.${core_1.Stack.of(this).region}.amazonses.com` }] }), new route53.TxtRecord(this, "MailFromTxtRecord", { zone: props.identity.hostedZone, recordName: props.mailFromDomain, values: ["v=spf1 include:amazonses.com ~all"] })), this.emailIdentityName = identity.ref, this.dkimDnsTokenName1 = identity.attrDkimDnsTokenName1, this.dkimDnsTokenName2 = identity.attrDkimDnsTokenName2, this.dkimDnsTokenName3 = identity.attrDkimDnsTokenName3, this.dkimDnsTokenValue1 = identity.attrDkimDnsTokenValue1, this.dkimDnsTokenValue2 = identity.attrDkimDnsTokenValue2, this.dkimDnsTokenValue3 = identity.attrDkimDnsTokenValue3, this.dkimRecords = [{ name: this.dkimDnsTokenName1, value: this.dkimDnsTokenValue1 }, { name: this.dkimDnsTokenName2, value: this.dkimDnsTokenValue2 }, { name: this.dkimDnsTokenName3, value: this.dkimDnsTokenValue3 }];
      }
    };
    _c = JSII_RTTI_SYMBOL_1, EmailIdentity[_c] = { fqn: "aws-cdk-lib.aws_ses.EmailIdentity", version: "2.80.0" }, exports2.EmailIdentity = EmailIdentity;
  }
});

// node_modules/aws-cdk-lib/aws-ses/lib/vdm-attributes.js
var require_vdm_attributes = __commonJS({
  "node_modules/aws-cdk-lib/aws-ses/lib/vdm-attributes.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.VdmAttributes = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var ses_generated_1 = require_ses_generated();
    var core_1 = require_core2();
    var VdmAttributes = class _VdmAttributes extends core_1.Resource {
      static fromVdmAttributesName(scope, id, vdmAttributesName) {
        class Import extends core_1.Resource {
          constructor() {
            super(...arguments), this.vdmAttributesName = vdmAttributesName;
          }
        }
        return new Import(scope, id);
      }
      constructor(scope, id, props = {}) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_VdmAttributesProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _VdmAttributes), error;
        }
        const resource = new ses_generated_1.CfnVdmAttributes(this, "Resource", { dashboardAttributes: { engagementMetrics: booleanToEnabledDisabled(props.engagementMetrics ?? true) }, guardianAttributes: { optimizedSharedDelivery: booleanToEnabledDisabled(props.optimizedSharedDelivery ?? true) } });
        this.vdmAttributesName = resource.ref, this.vdmAttributesResourceId = resource.attrVdmAttributesResourceId;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, VdmAttributes[_a] = { fqn: "aws-cdk-lib.aws_ses.VdmAttributes", version: "2.80.0" }, exports2.VdmAttributes = VdmAttributes;
    function booleanToEnabledDisabled(value) {
      return value === true ? "ENABLED" : "DISABLED";
    }
  }
});

// node_modules/aws-cdk-lib/aws-ses/lib/index.js
var require_lib239 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ses/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_receipt_rule_set(), exports2), __exportStar(require_receipt_rule(), exports2), __exportStar(require_receipt_rule_action(), exports2), __exportStar(require_receipt_filter(), exports2), __exportStar(require_dedicated_ip_pool(), exports2), __exportStar(require_configuration_set(), exports2), __exportStar(require_email_identity(), exports2), __exportStar(require_vdm_attributes(), exports2), __exportStar(require_configuration_set_event_destination(), exports2), __exportStar(require_ses_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-ses/index.js
var require_aws_ses = __commonJS({
  "node_modules/aws-cdk-lib/aws-ses/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib239(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-ses-actions/lib/add-header.js
var require_add_header = __commonJS({
  "node_modules/aws-cdk-lib/aws-ses-actions/lib/add-header.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AddHeader = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var AddHeader = class _AddHeader {
      constructor(props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_actions_AddHeaderProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AddHeader), error;
        }
        if (!/^[a-zA-Z0-9-]{1,50}$/.test(props.name))
          throw new Error("Header `name` must be between 1 and 50 characters, inclusive, and consist of alphanumeric (a-z, A-Z, 0-9) characters and dashes only.");
        if (!/^[^\n\r]{0,2047}$/.test(props.value))
          throw new Error('Header `value` must be less than 2048 characters, and must not contain newline characters ("\r" or "\n").');
        this.name = props.name, this.value = props.value;
      }
      bind(_rule) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_IReceiptRule(_rule);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { addHeaderAction: { headerName: this.name, headerValue: this.value } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AddHeader[_a] = { fqn: "aws-cdk-lib.aws_ses_actions.AddHeader", version: "2.80.0" }, exports2.AddHeader = AddHeader;
  }
});

// node_modules/aws-cdk-lib/aws-ses-actions/lib/bounce.js
var require_bounce = __commonJS({
  "node_modules/aws-cdk-lib/aws-ses-actions/lib/bounce.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Bounce = exports2.BounceTemplate = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var BounceTemplate = class _BounceTemplate {
      constructor(props) {
        this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_actions_BounceTemplateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _BounceTemplate), error;
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, BounceTemplate[_a] = { fqn: "aws-cdk-lib.aws_ses_actions.BounceTemplate", version: "2.80.0" }, BounceTemplate.MAILBOX_DOES_NOT_EXIST = new BounceTemplate({ message: "Mailbox does not exist", smtpReplyCode: "550", statusCode: "5.1.1" }), BounceTemplate.MESSAGE_TOO_LARGE = new BounceTemplate({ message: "Message too large", smtpReplyCode: "552", statusCode: "5.3.4" }), BounceTemplate.MAILBOX_FULL = new BounceTemplate({ message: "Mailbox full", smtpReplyCode: "552", statusCode: "5.2.2" }), BounceTemplate.MESSAGE_CONTENT_REJECTED = new BounceTemplate({ message: "Message content rejected", smtpReplyCode: "500", statusCode: "5.6.1" }), BounceTemplate.TEMPORARY_FAILURE = new BounceTemplate({ message: "Temporary failure", smtpReplyCode: "450", statusCode: "4.0.0" }), exports2.BounceTemplate = BounceTemplate;
    var Bounce = class _Bounce {
      constructor(props) {
        this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_actions_BounceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Bounce), error;
        }
      }
      bind(_rule) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_IReceiptRule(_rule);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { bounceAction: { sender: this.props.sender, smtpReplyCode: this.props.template.props.smtpReplyCode, message: this.props.template.props.message, topicArn: this.props.topic?.topicArn, statusCode: this.props.template.props.statusCode } };
      }
    };
    _b = JSII_RTTI_SYMBOL_1, Bounce[_b] = { fqn: "aws-cdk-lib.aws_ses_actions.Bounce", version: "2.80.0" }, exports2.Bounce = Bounce;
  }
});

// node_modules/aws-cdk-lib/aws-ses-actions/lib/lambda.js
var require_lambda11 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ses-actions/lib/lambda.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Lambda = exports2.LambdaInvocationType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var cdk = require_core2();
    var LambdaInvocationType;
    (function(LambdaInvocationType2) {
      LambdaInvocationType2.EVENT = "Event", LambdaInvocationType2.REQUEST_RESPONSE = "RequestResponse";
    })(LambdaInvocationType = exports2.LambdaInvocationType || (exports2.LambdaInvocationType = {}));
    var Lambda = class _Lambda {
      constructor(props) {
        this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_actions_LambdaProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Lambda), error;
        }
      }
      bind(rule) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_IReceiptRule(rule);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        const permissionId = "AllowSes";
        this.props.function.permissionsNode.tryFindChild(permissionId) || this.props.function.addPermission(permissionId, { action: "lambda:InvokeFunction", principal: new iam.ServicePrincipal("ses.amazonaws.com"), sourceAccount: cdk.Aws.ACCOUNT_ID });
        const permission = this.props.function.permissionsNode.tryFindChild(permissionId);
        return permission ? rule.node.addDependency(permission) : cdk.Annotations.of(rule).addWarning("This rule is using a Lambda action with an imported function. Ensure permission is given to SES to invoke that function."), { lambdaAction: { functionArn: this.props.function.functionArn, invocationType: this.props.invocationType, topicArn: this.props.topic?.topicArn } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Lambda[_a] = { fqn: "aws-cdk-lib.aws_ses_actions.Lambda", version: "2.80.0" }, exports2.Lambda = Lambda;
  }
});

// node_modules/aws-cdk-lib/aws-ses-actions/lib/s3.js
var require_s35 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ses-actions/lib/s3.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.S3 = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var cdk = require_core2();
    var S32 = class _S3 {
      constructor(props) {
        this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_actions_S3Props(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _S3), error;
        }
      }
      bind(rule) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_IReceiptRule(rule);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        const keyPattern = this.props.objectKeyPrefix || "", s3Statement = new iam.PolicyStatement({ actions: ["s3:PutObject"], principals: [new iam.ServicePrincipal("ses.amazonaws.com")], resources: [this.props.bucket.arnForObjects(`${keyPattern}*`)], conditions: { StringEquals: { "aws:Referer": cdk.Aws.ACCOUNT_ID } } });
        this.props.bucket.addToResourcePolicy(s3Statement);
        const policy = this.props.bucket.node.tryFindChild("Policy");
        if (policy ? rule.node.addDependency(policy) : cdk.Annotations.of(rule).addWarning("This rule is using a S3 action with an imported bucket. Ensure permission is given to SES to write to that bucket."), this.props.kmsKey && !/alias\/aws\/ses$/.test(this.props.kmsKey.keyArn)) {
          const kmsStatement = new iam.PolicyStatement({ actions: ["kms:Encrypt", "kms:GenerateDataKey"], principals: [new iam.ServicePrincipal("ses.amazonaws.com")], resources: ["*"], conditions: { Null: { "kms:EncryptionContext:aws:ses:rule-name": "false", "kms:EncryptionContext:aws:ses:message-id": "false" }, StringEquals: { "kms:EncryptionContext:aws:ses:source-account": cdk.Aws.ACCOUNT_ID } } });
          this.props.kmsKey.addToResourcePolicy(kmsStatement);
        }
        return { s3Action: { bucketName: this.props.bucket.bucketName, kmsKeyArn: this.props.kmsKey?.keyArn, objectKeyPrefix: this.props.objectKeyPrefix, topicArn: this.props.topic?.topicArn } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, S32[_a] = { fqn: "aws-cdk-lib.aws_ses_actions.S3", version: "2.80.0" }, exports2.S3 = S32;
  }
});

// node_modules/aws-cdk-lib/aws-ses-actions/lib/sns.js
var require_sns7 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ses-actions/lib/sns.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Sns = exports2.EmailEncoding = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var EmailEncoding;
    (function(EmailEncoding2) {
      EmailEncoding2.BASE64 = "Base64", EmailEncoding2.UTF8 = "UTF-8";
    })(EmailEncoding = exports2.EmailEncoding || (exports2.EmailEncoding = {}));
    var Sns = class _Sns {
      constructor(props) {
        this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_actions_SnsProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Sns), error;
        }
      }
      bind(_rule) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_IReceiptRule(_rule);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { snsAction: { encoding: this.props.encoding, topicArn: this.props.topic.topicArn } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Sns[_a] = { fqn: "aws-cdk-lib.aws_ses_actions.Sns", version: "2.80.0" }, exports2.Sns = Sns;
  }
});

// node_modules/aws-cdk-lib/aws-ses-actions/lib/stop.js
var require_stop = __commonJS({
  "node_modules/aws-cdk-lib/aws-ses-actions/lib/stop.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Stop = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var Stop = class _Stop {
      constructor(props = {}) {
        this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_actions_StopProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Stop), error;
        }
      }
      bind(_rule) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ses_IReceiptRule(_rule);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { stopAction: { scope: "RuleSet", topicArn: this.props.topic?.topicArn } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Stop[_a] = { fqn: "aws-cdk-lib.aws_ses_actions.Stop", version: "2.80.0" }, exports2.Stop = Stop;
  }
});

// node_modules/aws-cdk-lib/aws-ses-actions/lib/index.js
var require_lib240 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ses-actions/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_add_header(), exports2), __exportStar(require_bounce(), exports2), __exportStar(require_lambda11(), exports2), __exportStar(require_s35(), exports2), __exportStar(require_sns7(), exports2), __exportStar(require_stop(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-ses-actions/index.js
var require_aws_ses_actions = __commonJS({
  "node_modules/aws-cdk-lib/aws-ses-actions/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib240(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-signer/lib/signer.generated.js
var require_signer_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-signer/lib/signer.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnSigningProfile = exports2.CfnProfilePermission = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnProfilePermissionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.requiredValidator)(properties.action)), errors.collect(cdk.propertyValidator("action", cdk.validateString)(properties.action)), errors.collect(cdk.propertyValidator("principal", cdk.requiredValidator)(properties.principal)), errors.collect(cdk.propertyValidator("principal", cdk.validateString)(properties.principal)), errors.collect(cdk.propertyValidator("profileName", cdk.requiredValidator)(properties.profileName)), errors.collect(cdk.propertyValidator("profileName", cdk.validateString)(properties.profileName)), errors.collect(cdk.propertyValidator("profileVersion", cdk.validateString)(properties.profileVersion)), errors.collect(cdk.propertyValidator("statementId", cdk.requiredValidator)(properties.statementId)), errors.collect(cdk.propertyValidator("statementId", cdk.validateString)(properties.statementId)), errors.wrap('supplied properties not correct for "CfnProfilePermissionProps"');
    }
    function cfnProfilePermissionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProfilePermissionPropsValidator(properties).assertSuccess(), { Action: cdk.stringToCloudFormation(properties.action), Principal: cdk.stringToCloudFormation(properties.principal), ProfileName: cdk.stringToCloudFormation(properties.profileName), StatementId: cdk.stringToCloudFormation(properties.statementId), ProfileVersion: cdk.stringToCloudFormation(properties.profileVersion) }) : properties;
    }
    function CfnProfilePermissionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", cfn_parse.FromCloudFormation.getString(properties.Action)), ret.addPropertyResult("principal", "Principal", cfn_parse.FromCloudFormation.getString(properties.Principal)), ret.addPropertyResult("profileName", "ProfileName", cfn_parse.FromCloudFormation.getString(properties.ProfileName)), ret.addPropertyResult("statementId", "StatementId", cfn_parse.FromCloudFormation.getString(properties.StatementId)), ret.addPropertyResult("profileVersion", "ProfileVersion", properties.ProfileVersion != null ? cfn_parse.FromCloudFormation.getString(properties.ProfileVersion) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnProfilePermission = class _CfnProfilePermission extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnProfilePermissionPropsFromCloudFormation(resourceProperties), ret = new _CfnProfilePermission(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnProfilePermission.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_signer_CfnProfilePermissionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnProfilePermission), error;
        }
        cdk.requireProperty(props, "action", this), cdk.requireProperty(props, "principal", this), cdk.requireProperty(props, "profileName", this), cdk.requireProperty(props, "statementId", this), this.action = props.action, this.principal = props.principal, this.profileName = props.profileName, this.statementId = props.statementId, this.profileVersion = props.profileVersion;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnProfilePermission.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { action: this.action, principal: this.principal, profileName: this.profileName, statementId: this.statementId, profileVersion: this.profileVersion };
      }
      renderProperties(props) {
        return cfnProfilePermissionPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnProfilePermission[_a] = { fqn: "aws-cdk-lib.aws_signer.CfnProfilePermission", version: "2.80.0" }, CfnProfilePermission.CFN_RESOURCE_TYPE_NAME = "AWS::Signer::ProfilePermission", exports2.CfnProfilePermission = CfnProfilePermission;
    function CfnSigningProfilePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("platformId", cdk.requiredValidator)(properties.platformId)), errors.collect(cdk.propertyValidator("platformId", cdk.validateString)(properties.platformId)), errors.collect(cdk.propertyValidator("signatureValidityPeriod", CfnSigningProfile_SignatureValidityPeriodPropertyValidator)(properties.signatureValidityPeriod)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnSigningProfileProps"');
    }
    function cfnSigningProfilePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSigningProfilePropsValidator(properties).assertSuccess(), { PlatformId: cdk.stringToCloudFormation(properties.platformId), SignatureValidityPeriod: cfnSigningProfileSignatureValidityPeriodPropertyToCloudFormation(properties.signatureValidityPeriod), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnSigningProfilePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("platformId", "PlatformId", cfn_parse.FromCloudFormation.getString(properties.PlatformId)), ret.addPropertyResult("signatureValidityPeriod", "SignatureValidityPeriod", properties.SignatureValidityPeriod != null ? CfnSigningProfileSignatureValidityPeriodPropertyFromCloudFormation(properties.SignatureValidityPeriod) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSigningProfile = class _CfnSigningProfile extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSigningProfilePropsFromCloudFormation(resourceProperties), ret = new _CfnSigningProfile(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSigningProfile.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_signer_CfnSigningProfileProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSigningProfile), error;
        }
        cdk.requireProperty(props, "platformId", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrProfileName = cdk.Token.asString(this.getAtt("ProfileName", cdk.ResolutionTypeHint.STRING)), this.attrProfileVersion = cdk.Token.asString(this.getAtt("ProfileVersion", cdk.ResolutionTypeHint.STRING)), this.attrProfileVersionArn = cdk.Token.asString(this.getAtt("ProfileVersionArn", cdk.ResolutionTypeHint.STRING)), this.platformId = props.platformId, this.signatureValidityPeriod = props.signatureValidityPeriod, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Signer::SigningProfile", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSigningProfile.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { platformId: this.platformId, signatureValidityPeriod: this.signatureValidityPeriod, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnSigningProfilePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnSigningProfile[_b] = { fqn: "aws-cdk-lib.aws_signer.CfnSigningProfile", version: "2.80.0" }, CfnSigningProfile.CFN_RESOURCE_TYPE_NAME = "AWS::Signer::SigningProfile", exports2.CfnSigningProfile = CfnSigningProfile;
    function CfnSigningProfile_SignatureValidityPeriodPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", cdk.validateNumber)(properties.value)), errors.wrap('supplied properties not correct for "SignatureValidityPeriodProperty"');
    }
    function cfnSigningProfileSignatureValidityPeriodPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSigningProfile_SignatureValidityPeriodPropertyValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type), Value: cdk.numberToCloudFormation(properties.value) }) : properties;
    }
    function CfnSigningProfileSignatureValidityPeriodPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addPropertyResult("value", "Value", properties.Value != null ? cfn_parse.FromCloudFormation.getNumber(properties.Value) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-signer/lib/signing-profile.js
var require_signing_profile = __commonJS({
  "node_modules/aws-cdk-lib/aws-signer/lib/signing-profile.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SigningProfile = exports2.Platform = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var signer_generated_1 = require_signer_generated();
    var core_1 = require_core2();
    var Platform = class {
      constructor(platformId) {
        this.platformId = platformId;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Platform[_a] = { fqn: "aws-cdk-lib.aws_signer.Platform", version: "2.80.0" }, Platform.AWS_IOT_DEVICE_MANAGEMENT_SHA256_ECDSA = new Platform("AWSIoTDeviceManagement-SHA256-ECDSA"), Platform.AWS_LAMBDA_SHA384_ECDSA = new Platform("AWSLambda-SHA384-ECDSA"), Platform.AMAZON_FREE_RTOS_TI_CC3220SF = new Platform("AmazonFreeRTOS-TI-CC3220SF"), Platform.AMAZON_FREE_RTOS_DEFAULT = new Platform("AmazonFreeRTOS-Default"), exports2.Platform = Platform;
    var SigningProfile = class _SigningProfile extends core_1.Resource {
      static fromSigningProfileAttributes(scope, id, attrs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_signer_SigningProfileAttributes(attrs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromSigningProfileAttributes), error;
        }
        class Import extends core_1.Resource {
          constructor(signingProfileArn2, signingProfileProfileVersionArn) {
            super(scope, id), this.signingProfileName = attrs.signingProfileName, this.signingProfileVersion = attrs.signingProfileVersion, this.signingProfileArn = signingProfileArn2, this.signingProfileVersionArn = signingProfileProfileVersionArn;
          }
        }
        const signingProfileArn = core_1.Stack.of(scope).formatArn({ service: "signer", resource: "", resourceName: `/signing-profiles/${attrs.signingProfileName}` }), SigningProfileVersionArn = core_1.Stack.of(scope).formatArn({ service: "signer", resource: "", resourceName: `/signing-profiles/${attrs.signingProfileName}/${attrs.signingProfileVersion}` });
        return new Import(signingProfileArn, SigningProfileVersionArn);
      }
      constructor(scope, id, props) {
        super(scope, id, { physicalName: props.signingProfileName });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_signer_SigningProfileProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SigningProfile), error;
        }
        const resource = new signer_generated_1.CfnSigningProfile(this, "Resource", { platformId: props.platform.platformId, signatureValidityPeriod: props.signatureValidity ? { type: "DAYS", value: props.signatureValidity?.toDays() } : { type: "MONTHS", value: 135 } });
        this.signingProfileArn = resource.attrArn, this.signingProfileName = resource.attrProfileName, this.signingProfileVersion = resource.attrProfileVersion, this.signingProfileVersionArn = resource.attrProfileVersionArn;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, SigningProfile[_b] = { fqn: "aws-cdk-lib.aws_signer.SigningProfile", version: "2.80.0" }, exports2.SigningProfile = SigningProfile;
  }
});

// node_modules/aws-cdk-lib/aws-signer/lib/index.js
var require_lib241 = __commonJS({
  "node_modules/aws-cdk-lib/aws-signer/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_signer_generated(), exports2), __exportStar(require_signing_profile(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-signer/index.js
var require_aws_signer = __commonJS({
  "node_modules/aws-cdk-lib/aws-signer/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib241(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-simspaceweaver/lib/simspaceweaver.generated.js
var require_simspaceweaver_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-simspaceweaver/lib/simspaceweaver.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnSimulation = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnSimulationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("schemaS3Location", CfnSimulation_S3LocationPropertyValidator)(properties.schemaS3Location)), errors.wrap('supplied properties not correct for "CfnSimulationProps"');
    }
    function cfnSimulationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSimulationPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), RoleArn: cdk.stringToCloudFormation(properties.roleArn), SchemaS3Location: cfnSimulationS3LocationPropertyToCloudFormation(properties.schemaS3Location) }) : properties;
    }
    function CfnSimulationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("roleArn", "RoleArn", properties.RoleArn != null ? cfn_parse.FromCloudFormation.getString(properties.RoleArn) : void 0), ret.addPropertyResult("schemaS3Location", "SchemaS3Location", properties.SchemaS3Location != null ? CfnSimulationS3LocationPropertyFromCloudFormation(properties.SchemaS3Location) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSimulation = class _CfnSimulation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSimulationPropsFromCloudFormation(resourceProperties), ret = new _CfnSimulation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnSimulation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_simspaceweaver_CfnSimulationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSimulation), error;
        }
        this.attrDescribePayload = cdk.Token.asString(this.getAtt("DescribePayload", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.roleArn = props.roleArn, this.schemaS3Location = props.schemaS3Location;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSimulation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, roleArn: this.roleArn, schemaS3Location: this.schemaS3Location };
      }
      renderProperties(props) {
        return cfnSimulationPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnSimulation[_a] = { fqn: "aws-cdk-lib.aws_simspaceweaver.CfnSimulation", version: "2.80.0" }, CfnSimulation.CFN_RESOURCE_TYPE_NAME = "AWS::SimSpaceWeaver::Simulation", exports2.CfnSimulation = CfnSimulation;
    function CfnSimulation_S3LocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketName", cdk.requiredValidator)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.collect(cdk.propertyValidator("objectKey", cdk.requiredValidator)(properties.objectKey)), errors.collect(cdk.propertyValidator("objectKey", cdk.validateString)(properties.objectKey)), errors.wrap('supplied properties not correct for "S3LocationProperty"');
    }
    function cfnSimulationS3LocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSimulation_S3LocationPropertyValidator(properties).assertSuccess(), { BucketName: cdk.stringToCloudFormation(properties.bucketName), ObjectKey: cdk.stringToCloudFormation(properties.objectKey) }) : properties;
    }
    function CfnSimulationS3LocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketName", "BucketName", cfn_parse.FromCloudFormation.getString(properties.BucketName)), ret.addPropertyResult("objectKey", "ObjectKey", cfn_parse.FromCloudFormation.getString(properties.ObjectKey)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-simspaceweaver/lib/index.js
var require_lib242 = __commonJS({
  "node_modules/aws-cdk-lib/aws-simspaceweaver/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_simspaceweaver_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-simspaceweaver/index.js
var require_aws_simspaceweaver = __commonJS({
  "node_modules/aws-cdk-lib/aws-simspaceweaver/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib242(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-ssmcontacts/lib/ssmcontacts.generated.js
var require_ssmcontacts_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-ssmcontacts/lib/ssmcontacts.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnRotation = exports2.CfnPlan = exports2.CfnContactChannel = exports2.CfnContact = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnContactPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("alias", cdk.requiredValidator)(properties.alias)), errors.collect(cdk.propertyValidator("alias", cdk.validateString)(properties.alias)), errors.collect(cdk.propertyValidator("displayName", cdk.requiredValidator)(properties.displayName)), errors.collect(cdk.propertyValidator("displayName", cdk.validateString)(properties.displayName)), errors.collect(cdk.propertyValidator("plan", cdk.listValidator(CfnContact_StagePropertyValidator))(properties.plan)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnContactProps"');
    }
    function cfnContactPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContactPropsValidator(properties).assertSuccess(), { Alias: cdk.stringToCloudFormation(properties.alias), DisplayName: cdk.stringToCloudFormation(properties.displayName), Type: cdk.stringToCloudFormation(properties.type), Plan: cdk.listMapper(cfnContactStagePropertyToCloudFormation)(properties.plan) }) : properties;
    }
    function CfnContactPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("alias", "Alias", cfn_parse.FromCloudFormation.getString(properties.Alias)), ret.addPropertyResult("displayName", "DisplayName", cfn_parse.FromCloudFormation.getString(properties.DisplayName)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("plan", "Plan", properties.Plan != null ? cfn_parse.FromCloudFormation.getArray(CfnContactStagePropertyFromCloudFormation)(properties.Plan) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnContact = class _CfnContact extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnContactPropsFromCloudFormation(resourceProperties), ret = new _CfnContact(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnContact.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ssmcontacts_CfnContactProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnContact), error;
        }
        cdk.requireProperty(props, "alias", this), cdk.requireProperty(props, "displayName", this), cdk.requireProperty(props, "type", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.alias = props.alias, this.displayName = props.displayName, this.type = props.type, this.plan = props.plan;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnContact.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { alias: this.alias, displayName: this.displayName, type: this.type, plan: this.plan };
      }
      renderProperties(props) {
        return cfnContactPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnContact[_a] = { fqn: "aws-cdk-lib.aws_ssmcontacts.CfnContact", version: "2.80.0" }, CfnContact.CFN_RESOURCE_TYPE_NAME = "AWS::SSMContacts::Contact", exports2.CfnContact = CfnContact;
    function CfnContact_ChannelTargetInfoPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("channelId", cdk.requiredValidator)(properties.channelId)), errors.collect(cdk.propertyValidator("channelId", cdk.validateString)(properties.channelId)), errors.collect(cdk.propertyValidator("retryIntervalInMinutes", cdk.requiredValidator)(properties.retryIntervalInMinutes)), errors.collect(cdk.propertyValidator("retryIntervalInMinutes", cdk.validateNumber)(properties.retryIntervalInMinutes)), errors.wrap('supplied properties not correct for "ChannelTargetInfoProperty"');
    }
    function cfnContactChannelTargetInfoPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContact_ChannelTargetInfoPropertyValidator(properties).assertSuccess(), { ChannelId: cdk.stringToCloudFormation(properties.channelId), RetryIntervalInMinutes: cdk.numberToCloudFormation(properties.retryIntervalInMinutes) }) : properties;
    }
    function CfnContactChannelTargetInfoPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("channelId", "ChannelId", cfn_parse.FromCloudFormation.getString(properties.ChannelId)), ret.addPropertyResult("retryIntervalInMinutes", "RetryIntervalInMinutes", cfn_parse.FromCloudFormation.getNumber(properties.RetryIntervalInMinutes)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnContact_ContactTargetInfoPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contactId", cdk.requiredValidator)(properties.contactId)), errors.collect(cdk.propertyValidator("contactId", cdk.validateString)(properties.contactId)), errors.collect(cdk.propertyValidator("isEssential", cdk.requiredValidator)(properties.isEssential)), errors.collect(cdk.propertyValidator("isEssential", cdk.validateBoolean)(properties.isEssential)), errors.wrap('supplied properties not correct for "ContactTargetInfoProperty"');
    }
    function cfnContactContactTargetInfoPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContact_ContactTargetInfoPropertyValidator(properties).assertSuccess(), { ContactId: cdk.stringToCloudFormation(properties.contactId), IsEssential: cdk.booleanToCloudFormation(properties.isEssential) }) : properties;
    }
    function CfnContactContactTargetInfoPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contactId", "ContactId", cfn_parse.FromCloudFormation.getString(properties.ContactId)), ret.addPropertyResult("isEssential", "IsEssential", cfn_parse.FromCloudFormation.getBoolean(properties.IsEssential)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnContact_StagePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("durationInMinutes", cdk.validateNumber)(properties.durationInMinutes)), errors.collect(cdk.propertyValidator("rotationIds", cdk.listValidator(cdk.validateString))(properties.rotationIds)), errors.collect(cdk.propertyValidator("targets", cdk.listValidator(CfnContact_TargetsPropertyValidator))(properties.targets)), errors.wrap('supplied properties not correct for "StageProperty"');
    }
    function cfnContactStagePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContact_StagePropertyValidator(properties).assertSuccess(), { DurationInMinutes: cdk.numberToCloudFormation(properties.durationInMinutes), RotationIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.rotationIds), Targets: cdk.listMapper(cfnContactTargetsPropertyToCloudFormation)(properties.targets) }) : properties;
    }
    function CfnContactStagePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("durationInMinutes", "DurationInMinutes", properties.DurationInMinutes != null ? cfn_parse.FromCloudFormation.getNumber(properties.DurationInMinutes) : void 0), ret.addPropertyResult("rotationIds", "RotationIds", properties.RotationIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.RotationIds) : void 0), ret.addPropertyResult("targets", "Targets", properties.Targets != null ? cfn_parse.FromCloudFormation.getArray(CfnContactTargetsPropertyFromCloudFormation)(properties.Targets) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnContact_TargetsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("channelTargetInfo", CfnContact_ChannelTargetInfoPropertyValidator)(properties.channelTargetInfo)), errors.collect(cdk.propertyValidator("contactTargetInfo", CfnContact_ContactTargetInfoPropertyValidator)(properties.contactTargetInfo)), errors.wrap('supplied properties not correct for "TargetsProperty"');
    }
    function cfnContactTargetsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContact_TargetsPropertyValidator(properties).assertSuccess(), { ChannelTargetInfo: cfnContactChannelTargetInfoPropertyToCloudFormation(properties.channelTargetInfo), ContactTargetInfo: cfnContactContactTargetInfoPropertyToCloudFormation(properties.contactTargetInfo) }) : properties;
    }
    function CfnContactTargetsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("channelTargetInfo", "ChannelTargetInfo", properties.ChannelTargetInfo != null ? CfnContactChannelTargetInfoPropertyFromCloudFormation(properties.ChannelTargetInfo) : void 0), ret.addPropertyResult("contactTargetInfo", "ContactTargetInfo", properties.ContactTargetInfo != null ? CfnContactContactTargetInfoPropertyFromCloudFormation(properties.ContactTargetInfo) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnContactChannelPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("channelAddress", cdk.requiredValidator)(properties.channelAddress)), errors.collect(cdk.propertyValidator("channelAddress", cdk.validateString)(properties.channelAddress)), errors.collect(cdk.propertyValidator("channelName", cdk.requiredValidator)(properties.channelName)), errors.collect(cdk.propertyValidator("channelName", cdk.validateString)(properties.channelName)), errors.collect(cdk.propertyValidator("channelType", cdk.requiredValidator)(properties.channelType)), errors.collect(cdk.propertyValidator("channelType", cdk.validateString)(properties.channelType)), errors.collect(cdk.propertyValidator("contactId", cdk.requiredValidator)(properties.contactId)), errors.collect(cdk.propertyValidator("contactId", cdk.validateString)(properties.contactId)), errors.collect(cdk.propertyValidator("deferActivation", cdk.validateBoolean)(properties.deferActivation)), errors.wrap('supplied properties not correct for "CfnContactChannelProps"');
    }
    function cfnContactChannelPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnContactChannelPropsValidator(properties).assertSuccess(), { ChannelAddress: cdk.stringToCloudFormation(properties.channelAddress), ChannelName: cdk.stringToCloudFormation(properties.channelName), ChannelType: cdk.stringToCloudFormation(properties.channelType), ContactId: cdk.stringToCloudFormation(properties.contactId), DeferActivation: cdk.booleanToCloudFormation(properties.deferActivation) }) : properties;
    }
    function CfnContactChannelPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("channelAddress", "ChannelAddress", cfn_parse.FromCloudFormation.getString(properties.ChannelAddress)), ret.addPropertyResult("channelName", "ChannelName", cfn_parse.FromCloudFormation.getString(properties.ChannelName)), ret.addPropertyResult("channelType", "ChannelType", cfn_parse.FromCloudFormation.getString(properties.ChannelType)), ret.addPropertyResult("contactId", "ContactId", cfn_parse.FromCloudFormation.getString(properties.ContactId)), ret.addPropertyResult("deferActivation", "DeferActivation", properties.DeferActivation != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeferActivation) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnContactChannel = class _CfnContactChannel extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnContactChannelPropsFromCloudFormation(resourceProperties), ret = new _CfnContactChannel(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnContactChannel.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ssmcontacts_CfnContactChannelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnContactChannel), error;
        }
        cdk.requireProperty(props, "channelAddress", this), cdk.requireProperty(props, "channelName", this), cdk.requireProperty(props, "channelType", this), cdk.requireProperty(props, "contactId", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.channelAddress = props.channelAddress, this.channelName = props.channelName, this.channelType = props.channelType, this.contactId = props.contactId, this.deferActivation = props.deferActivation;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnContactChannel.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { channelAddress: this.channelAddress, channelName: this.channelName, channelType: this.channelType, contactId: this.contactId, deferActivation: this.deferActivation };
      }
      renderProperties(props) {
        return cfnContactChannelPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnContactChannel[_b] = { fqn: "aws-cdk-lib.aws_ssmcontacts.CfnContactChannel", version: "2.80.0" }, CfnContactChannel.CFN_RESOURCE_TYPE_NAME = "AWS::SSMContacts::ContactChannel", exports2.CfnContactChannel = CfnContactChannel;
    function CfnPlanPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contactId", cdk.requiredValidator)(properties.contactId)), errors.collect(cdk.propertyValidator("contactId", cdk.validateString)(properties.contactId)), errors.collect(cdk.propertyValidator("rotationIds", cdk.listValidator(cdk.validateString))(properties.rotationIds)), errors.collect(cdk.propertyValidator("stages", cdk.listValidator(CfnPlan_StagePropertyValidator))(properties.stages)), errors.wrap('supplied properties not correct for "CfnPlanProps"');
    }
    function cfnPlanPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPlanPropsValidator(properties).assertSuccess(), { ContactId: cdk.stringToCloudFormation(properties.contactId), RotationIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.rotationIds), Stages: cdk.listMapper(cfnPlanStagePropertyToCloudFormation)(properties.stages) }) : properties;
    }
    function CfnPlanPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contactId", "ContactId", cfn_parse.FromCloudFormation.getString(properties.ContactId)), ret.addPropertyResult("rotationIds", "RotationIds", properties.RotationIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.RotationIds) : void 0), ret.addPropertyResult("stages", "Stages", properties.Stages != null ? cfn_parse.FromCloudFormation.getArray(CfnPlanStagePropertyFromCloudFormation)(properties.Stages) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPlan = class _CfnPlan extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPlanPropsFromCloudFormation(resourceProperties), ret = new _CfnPlan(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPlan.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ssmcontacts_CfnPlanProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPlan), error;
        }
        cdk.requireProperty(props, "contactId", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.contactId = props.contactId, this.rotationIds = props.rotationIds, this.stages = props.stages;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPlan.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { contactId: this.contactId, rotationIds: this.rotationIds, stages: this.stages };
      }
      renderProperties(props) {
        return cfnPlanPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnPlan[_c] = { fqn: "aws-cdk-lib.aws_ssmcontacts.CfnPlan", version: "2.80.0" }, CfnPlan.CFN_RESOURCE_TYPE_NAME = "AWS::SSMContacts::Plan", exports2.CfnPlan = CfnPlan;
    function CfnPlan_ChannelTargetInfoPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("channelId", cdk.requiredValidator)(properties.channelId)), errors.collect(cdk.propertyValidator("channelId", cdk.validateString)(properties.channelId)), errors.collect(cdk.propertyValidator("retryIntervalInMinutes", cdk.requiredValidator)(properties.retryIntervalInMinutes)), errors.collect(cdk.propertyValidator("retryIntervalInMinutes", cdk.validateNumber)(properties.retryIntervalInMinutes)), errors.wrap('supplied properties not correct for "ChannelTargetInfoProperty"');
    }
    function cfnPlanChannelTargetInfoPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPlan_ChannelTargetInfoPropertyValidator(properties).assertSuccess(), { ChannelId: cdk.stringToCloudFormation(properties.channelId), RetryIntervalInMinutes: cdk.numberToCloudFormation(properties.retryIntervalInMinutes) }) : properties;
    }
    function CfnPlanChannelTargetInfoPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("channelId", "ChannelId", cfn_parse.FromCloudFormation.getString(properties.ChannelId)), ret.addPropertyResult("retryIntervalInMinutes", "RetryIntervalInMinutes", cfn_parse.FromCloudFormation.getNumber(properties.RetryIntervalInMinutes)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPlan_ContactTargetInfoPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contactId", cdk.requiredValidator)(properties.contactId)), errors.collect(cdk.propertyValidator("contactId", cdk.validateString)(properties.contactId)), errors.collect(cdk.propertyValidator("isEssential", cdk.requiredValidator)(properties.isEssential)), errors.collect(cdk.propertyValidator("isEssential", cdk.validateBoolean)(properties.isEssential)), errors.wrap('supplied properties not correct for "ContactTargetInfoProperty"');
    }
    function cfnPlanContactTargetInfoPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPlan_ContactTargetInfoPropertyValidator(properties).assertSuccess(), { ContactId: cdk.stringToCloudFormation(properties.contactId), IsEssential: cdk.booleanToCloudFormation(properties.isEssential) }) : properties;
    }
    function CfnPlanContactTargetInfoPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contactId", "ContactId", cfn_parse.FromCloudFormation.getString(properties.ContactId)), ret.addPropertyResult("isEssential", "IsEssential", cfn_parse.FromCloudFormation.getBoolean(properties.IsEssential)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPlan_StagePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("durationInMinutes", cdk.requiredValidator)(properties.durationInMinutes)), errors.collect(cdk.propertyValidator("durationInMinutes", cdk.validateNumber)(properties.durationInMinutes)), errors.collect(cdk.propertyValidator("targets", cdk.listValidator(CfnPlan_TargetsPropertyValidator))(properties.targets)), errors.wrap('supplied properties not correct for "StageProperty"');
    }
    function cfnPlanStagePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPlan_StagePropertyValidator(properties).assertSuccess(), { DurationInMinutes: cdk.numberToCloudFormation(properties.durationInMinutes), Targets: cdk.listMapper(cfnPlanTargetsPropertyToCloudFormation)(properties.targets) }) : properties;
    }
    function CfnPlanStagePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("durationInMinutes", "DurationInMinutes", cfn_parse.FromCloudFormation.getNumber(properties.DurationInMinutes)), ret.addPropertyResult("targets", "Targets", properties.Targets != null ? cfn_parse.FromCloudFormation.getArray(CfnPlanTargetsPropertyFromCloudFormation)(properties.Targets) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPlan_TargetsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("channelTargetInfo", CfnPlan_ChannelTargetInfoPropertyValidator)(properties.channelTargetInfo)), errors.collect(cdk.propertyValidator("contactTargetInfo", CfnPlan_ContactTargetInfoPropertyValidator)(properties.contactTargetInfo)), errors.wrap('supplied properties not correct for "TargetsProperty"');
    }
    function cfnPlanTargetsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPlan_TargetsPropertyValidator(properties).assertSuccess(), { ChannelTargetInfo: cfnPlanChannelTargetInfoPropertyToCloudFormation(properties.channelTargetInfo), ContactTargetInfo: cfnPlanContactTargetInfoPropertyToCloudFormation(properties.contactTargetInfo) }) : properties;
    }
    function CfnPlanTargetsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("channelTargetInfo", "ChannelTargetInfo", properties.ChannelTargetInfo != null ? CfnPlanChannelTargetInfoPropertyFromCloudFormation(properties.ChannelTargetInfo) : void 0), ret.addPropertyResult("contactTargetInfo", "ContactTargetInfo", properties.ContactTargetInfo != null ? CfnPlanContactTargetInfoPropertyFromCloudFormation(properties.ContactTargetInfo) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRotationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contactIds", cdk.requiredValidator)(properties.contactIds)), errors.collect(cdk.propertyValidator("contactIds", cdk.listValidator(cdk.validateString))(properties.contactIds)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("recurrence", cdk.requiredValidator)(properties.recurrence)), errors.collect(cdk.propertyValidator("recurrence", CfnRotation_RecurrenceSettingsPropertyValidator)(properties.recurrence)), errors.collect(cdk.propertyValidator("startTime", cdk.requiredValidator)(properties.startTime)), errors.collect(cdk.propertyValidator("startTime", cdk.validateString)(properties.startTime)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("timeZoneId", cdk.requiredValidator)(properties.timeZoneId)), errors.collect(cdk.propertyValidator("timeZoneId", cdk.validateString)(properties.timeZoneId)), errors.wrap('supplied properties not correct for "CfnRotationProps"');
    }
    function cfnRotationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRotationPropsValidator(properties).assertSuccess(), { ContactIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.contactIds), Name: cdk.stringToCloudFormation(properties.name), Recurrence: cfnRotationRecurrenceSettingsPropertyToCloudFormation(properties.recurrence), StartTime: cdk.stringToCloudFormation(properties.startTime), TimeZoneId: cdk.stringToCloudFormation(properties.timeZoneId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnRotationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contactIds", "ContactIds", cfn_parse.FromCloudFormation.getStringArray(properties.ContactIds)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("recurrence", "Recurrence", CfnRotationRecurrenceSettingsPropertyFromCloudFormation(properties.Recurrence)), ret.addPropertyResult("startTime", "StartTime", cfn_parse.FromCloudFormation.getString(properties.StartTime)), ret.addPropertyResult("timeZoneId", "TimeZoneId", cfn_parse.FromCloudFormation.getString(properties.TimeZoneId)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRotation = class _CfnRotation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRotationPropsFromCloudFormation(resourceProperties), ret = new _CfnRotation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRotation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ssmcontacts_CfnRotationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRotation), error;
        }
        cdk.requireProperty(props, "contactIds", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "recurrence", this), cdk.requireProperty(props, "startTime", this), cdk.requireProperty(props, "timeZoneId", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.contactIds = props.contactIds, this.name = props.name, this.recurrence = props.recurrence, this.startTime = props.startTime, this.timeZoneId = props.timeZoneId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SSMContacts::Rotation", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRotation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { contactIds: this.contactIds, name: this.name, recurrence: this.recurrence, startTime: this.startTime, timeZoneId: this.timeZoneId, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnRotationPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnRotation[_d] = { fqn: "aws-cdk-lib.aws_ssmcontacts.CfnRotation", version: "2.80.0" }, CfnRotation.CFN_RESOURCE_TYPE_NAME = "AWS::SSMContacts::Rotation", exports2.CfnRotation = CfnRotation;
    function CfnRotation_CoverageTimePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("endTime", cdk.requiredValidator)(properties.endTime)), errors.collect(cdk.propertyValidator("endTime", cdk.validateString)(properties.endTime)), errors.collect(cdk.propertyValidator("startTime", cdk.requiredValidator)(properties.startTime)), errors.collect(cdk.propertyValidator("startTime", cdk.validateString)(properties.startTime)), errors.wrap('supplied properties not correct for "CoverageTimeProperty"');
    }
    function cfnRotationCoverageTimePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRotation_CoverageTimePropertyValidator(properties).assertSuccess(), { EndTime: cdk.stringToCloudFormation(properties.endTime), StartTime: cdk.stringToCloudFormation(properties.startTime) }) : properties;
    }
    function CfnRotationCoverageTimePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("endTime", "EndTime", cfn_parse.FromCloudFormation.getString(properties.EndTime)), ret.addPropertyResult("startTime", "StartTime", cfn_parse.FromCloudFormation.getString(properties.StartTime)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRotation_MonthlySettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dayOfMonth", cdk.requiredValidator)(properties.dayOfMonth)), errors.collect(cdk.propertyValidator("dayOfMonth", cdk.validateNumber)(properties.dayOfMonth)), errors.collect(cdk.propertyValidator("handOffTime", cdk.requiredValidator)(properties.handOffTime)), errors.collect(cdk.propertyValidator("handOffTime", cdk.validateString)(properties.handOffTime)), errors.wrap('supplied properties not correct for "MonthlySettingProperty"');
    }
    function cfnRotationMonthlySettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRotation_MonthlySettingPropertyValidator(properties).assertSuccess(), { DayOfMonth: cdk.numberToCloudFormation(properties.dayOfMonth), HandOffTime: cdk.stringToCloudFormation(properties.handOffTime) }) : properties;
    }
    function CfnRotationMonthlySettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dayOfMonth", "DayOfMonth", cfn_parse.FromCloudFormation.getNumber(properties.DayOfMonth)), ret.addPropertyResult("handOffTime", "HandOffTime", cfn_parse.FromCloudFormation.getString(properties.HandOffTime)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRotation_RecurrenceSettingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dailySettings", cdk.listValidator(cdk.validateString))(properties.dailySettings)), errors.collect(cdk.propertyValidator("monthlySettings", cdk.listValidator(CfnRotation_MonthlySettingPropertyValidator))(properties.monthlySettings)), errors.collect(cdk.propertyValidator("numberOfOnCalls", cdk.requiredValidator)(properties.numberOfOnCalls)), errors.collect(cdk.propertyValidator("numberOfOnCalls", cdk.validateNumber)(properties.numberOfOnCalls)), errors.collect(cdk.propertyValidator("recurrenceMultiplier", cdk.requiredValidator)(properties.recurrenceMultiplier)), errors.collect(cdk.propertyValidator("recurrenceMultiplier", cdk.validateNumber)(properties.recurrenceMultiplier)), errors.collect(cdk.propertyValidator("shiftCoverages", cdk.listValidator(CfnRotation_ShiftCoveragePropertyValidator))(properties.shiftCoverages)), errors.collect(cdk.propertyValidator("weeklySettings", cdk.listValidator(CfnRotation_WeeklySettingPropertyValidator))(properties.weeklySettings)), errors.wrap('supplied properties not correct for "RecurrenceSettingsProperty"');
    }
    function cfnRotationRecurrenceSettingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRotation_RecurrenceSettingsPropertyValidator(properties).assertSuccess(), { DailySettings: cdk.listMapper(cdk.stringToCloudFormation)(properties.dailySettings), MonthlySettings: cdk.listMapper(cfnRotationMonthlySettingPropertyToCloudFormation)(properties.monthlySettings), NumberOfOnCalls: cdk.numberToCloudFormation(properties.numberOfOnCalls), RecurrenceMultiplier: cdk.numberToCloudFormation(properties.recurrenceMultiplier), ShiftCoverages: cdk.listMapper(cfnRotationShiftCoveragePropertyToCloudFormation)(properties.shiftCoverages), WeeklySettings: cdk.listMapper(cfnRotationWeeklySettingPropertyToCloudFormation)(properties.weeklySettings) }) : properties;
    }
    function CfnRotationRecurrenceSettingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dailySettings", "DailySettings", properties.DailySettings != null ? cfn_parse.FromCloudFormation.getStringArray(properties.DailySettings) : void 0), ret.addPropertyResult("monthlySettings", "MonthlySettings", properties.MonthlySettings != null ? cfn_parse.FromCloudFormation.getArray(CfnRotationMonthlySettingPropertyFromCloudFormation)(properties.MonthlySettings) : void 0), ret.addPropertyResult("numberOfOnCalls", "NumberOfOnCalls", cfn_parse.FromCloudFormation.getNumber(properties.NumberOfOnCalls)), ret.addPropertyResult("recurrenceMultiplier", "RecurrenceMultiplier", cfn_parse.FromCloudFormation.getNumber(properties.RecurrenceMultiplier)), ret.addPropertyResult("shiftCoverages", "ShiftCoverages", properties.ShiftCoverages != null ? cfn_parse.FromCloudFormation.getArray(CfnRotationShiftCoveragePropertyFromCloudFormation)(properties.ShiftCoverages) : void 0), ret.addPropertyResult("weeklySettings", "WeeklySettings", properties.WeeklySettings != null ? cfn_parse.FromCloudFormation.getArray(CfnRotationWeeklySettingPropertyFromCloudFormation)(properties.WeeklySettings) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRotation_ShiftCoveragePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("coverageTimes", cdk.requiredValidator)(properties.coverageTimes)), errors.collect(cdk.propertyValidator("coverageTimes", cdk.listValidator(CfnRotation_CoverageTimePropertyValidator))(properties.coverageTimes)), errors.collect(cdk.propertyValidator("dayOfWeek", cdk.requiredValidator)(properties.dayOfWeek)), errors.collect(cdk.propertyValidator("dayOfWeek", cdk.validateString)(properties.dayOfWeek)), errors.wrap('supplied properties not correct for "ShiftCoverageProperty"');
    }
    function cfnRotationShiftCoveragePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRotation_ShiftCoveragePropertyValidator(properties).assertSuccess(), { CoverageTimes: cdk.listMapper(cfnRotationCoverageTimePropertyToCloudFormation)(properties.coverageTimes), DayOfWeek: cdk.stringToCloudFormation(properties.dayOfWeek) }) : properties;
    }
    function CfnRotationShiftCoveragePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("coverageTimes", "CoverageTimes", cfn_parse.FromCloudFormation.getArray(CfnRotationCoverageTimePropertyFromCloudFormation)(properties.CoverageTimes)), ret.addPropertyResult("dayOfWeek", "DayOfWeek", cfn_parse.FromCloudFormation.getString(properties.DayOfWeek)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRotation_WeeklySettingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dayOfWeek", cdk.requiredValidator)(properties.dayOfWeek)), errors.collect(cdk.propertyValidator("dayOfWeek", cdk.validateString)(properties.dayOfWeek)), errors.collect(cdk.propertyValidator("handOffTime", cdk.requiredValidator)(properties.handOffTime)), errors.collect(cdk.propertyValidator("handOffTime", cdk.validateString)(properties.handOffTime)), errors.wrap('supplied properties not correct for "WeeklySettingProperty"');
    }
    function cfnRotationWeeklySettingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRotation_WeeklySettingPropertyValidator(properties).assertSuccess(), { DayOfWeek: cdk.stringToCloudFormation(properties.dayOfWeek), HandOffTime: cdk.stringToCloudFormation(properties.handOffTime) }) : properties;
    }
    function CfnRotationWeeklySettingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dayOfWeek", "DayOfWeek", cfn_parse.FromCloudFormation.getString(properties.DayOfWeek)), ret.addPropertyResult("handOffTime", "HandOffTime", cfn_parse.FromCloudFormation.getString(properties.HandOffTime)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-ssmcontacts/lib/index.js
var require_lib243 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ssmcontacts/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_ssmcontacts_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-ssmcontacts/index.js
var require_aws_ssmcontacts = __commonJS({
  "node_modules/aws-cdk-lib/aws-ssmcontacts/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib243(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-ssmincidents/lib/ssmincidents.generated.js
var require_ssmincidents_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-ssmincidents/lib/ssmincidents.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnResponsePlan = exports2.CfnReplicationSet = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnReplicationSetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("deletionProtected", cdk.validateBoolean)(properties.deletionProtected)), errors.collect(cdk.propertyValidator("regions", cdk.requiredValidator)(properties.regions)), errors.collect(cdk.propertyValidator("regions", cdk.listValidator(CfnReplicationSet_ReplicationRegionPropertyValidator))(properties.regions)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnReplicationSetProps"');
    }
    function cfnReplicationSetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReplicationSetPropsValidator(properties).assertSuccess(), { Regions: cdk.listMapper(cfnReplicationSetReplicationRegionPropertyToCloudFormation)(properties.regions), DeletionProtected: cdk.booleanToCloudFormation(properties.deletionProtected), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnReplicationSetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("regions", "Regions", cfn_parse.FromCloudFormation.getArray(CfnReplicationSetReplicationRegionPropertyFromCloudFormation)(properties.Regions)), ret.addPropertyResult("deletionProtected", "DeletionProtected", properties.DeletionProtected != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeletionProtected) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnReplicationSet = class _CfnReplicationSet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnReplicationSetPropsFromCloudFormation(resourceProperties), ret = new _CfnReplicationSet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnReplicationSet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ssmincidents_CfnReplicationSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnReplicationSet), error;
        }
        cdk.requireProperty(props, "regions", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.regions = props.regions, this.deletionProtected = props.deletionProtected, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SSMIncidents::ReplicationSet", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnReplicationSet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { regions: this.regions, deletionProtected: this.deletionProtected, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnReplicationSetPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnReplicationSet[_a] = { fqn: "aws-cdk-lib.aws_ssmincidents.CfnReplicationSet", version: "2.80.0" }, CfnReplicationSet.CFN_RESOURCE_TYPE_NAME = "AWS::SSMIncidents::ReplicationSet", exports2.CfnReplicationSet = CfnReplicationSet;
    function CfnReplicationSet_RegionConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("sseKmsKeyId", cdk.requiredValidator)(properties.sseKmsKeyId)), errors.collect(cdk.propertyValidator("sseKmsKeyId", cdk.validateString)(properties.sseKmsKeyId)), errors.wrap('supplied properties not correct for "RegionConfigurationProperty"');
    }
    function cfnReplicationSetRegionConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReplicationSet_RegionConfigurationPropertyValidator(properties).assertSuccess(), { SseKmsKeyId: cdk.stringToCloudFormation(properties.sseKmsKeyId) }) : properties;
    }
    function CfnReplicationSetRegionConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("sseKmsKeyId", "SseKmsKeyId", cfn_parse.FromCloudFormation.getString(properties.SseKmsKeyId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnReplicationSet_ReplicationRegionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("regionConfiguration", CfnReplicationSet_RegionConfigurationPropertyValidator)(properties.regionConfiguration)), errors.collect(cdk.propertyValidator("regionName", cdk.validateString)(properties.regionName)), errors.wrap('supplied properties not correct for "ReplicationRegionProperty"');
    }
    function cfnReplicationSetReplicationRegionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnReplicationSet_ReplicationRegionPropertyValidator(properties).assertSuccess(), { RegionConfiguration: cfnReplicationSetRegionConfigurationPropertyToCloudFormation(properties.regionConfiguration), RegionName: cdk.stringToCloudFormation(properties.regionName) }) : properties;
    }
    function CfnReplicationSetReplicationRegionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("regionConfiguration", "RegionConfiguration", properties.RegionConfiguration != null ? CfnReplicationSetRegionConfigurationPropertyFromCloudFormation(properties.RegionConfiguration) : void 0), ret.addPropertyResult("regionName", "RegionName", properties.RegionName != null ? cfn_parse.FromCloudFormation.getString(properties.RegionName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResponsePlanPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actions", cdk.listValidator(CfnResponsePlan_ActionPropertyValidator))(properties.actions)), errors.collect(cdk.propertyValidator("chatChannel", CfnResponsePlan_ChatChannelPropertyValidator)(properties.chatChannel)), errors.collect(cdk.propertyValidator("displayName", cdk.validateString)(properties.displayName)), errors.collect(cdk.propertyValidator("engagements", cdk.listValidator(cdk.validateString))(properties.engagements)), errors.collect(cdk.propertyValidator("incidentTemplate", cdk.requiredValidator)(properties.incidentTemplate)), errors.collect(cdk.propertyValidator("incidentTemplate", CfnResponsePlan_IncidentTemplatePropertyValidator)(properties.incidentTemplate)), errors.collect(cdk.propertyValidator("integrations", cdk.listValidator(CfnResponsePlan_IntegrationPropertyValidator))(properties.integrations)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnResponsePlanProps"');
    }
    function cfnResponsePlanPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResponsePlanPropsValidator(properties).assertSuccess(), { IncidentTemplate: cfnResponsePlanIncidentTemplatePropertyToCloudFormation(properties.incidentTemplate), Name: cdk.stringToCloudFormation(properties.name), Actions: cdk.listMapper(cfnResponsePlanActionPropertyToCloudFormation)(properties.actions), ChatChannel: cfnResponsePlanChatChannelPropertyToCloudFormation(properties.chatChannel), DisplayName: cdk.stringToCloudFormation(properties.displayName), Engagements: cdk.listMapper(cdk.stringToCloudFormation)(properties.engagements), Integrations: cdk.listMapper(cfnResponsePlanIntegrationPropertyToCloudFormation)(properties.integrations), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnResponsePlanPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("incidentTemplate", "IncidentTemplate", CfnResponsePlanIncidentTemplatePropertyFromCloudFormation(properties.IncidentTemplate)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("actions", "Actions", properties.Actions != null ? cfn_parse.FromCloudFormation.getArray(CfnResponsePlanActionPropertyFromCloudFormation)(properties.Actions) : void 0), ret.addPropertyResult("chatChannel", "ChatChannel", properties.ChatChannel != null ? CfnResponsePlanChatChannelPropertyFromCloudFormation(properties.ChatChannel) : void 0), ret.addPropertyResult("displayName", "DisplayName", properties.DisplayName != null ? cfn_parse.FromCloudFormation.getString(properties.DisplayName) : void 0), ret.addPropertyResult("engagements", "Engagements", properties.Engagements != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Engagements) : void 0), ret.addPropertyResult("integrations", "Integrations", properties.Integrations != null ? cfn_parse.FromCloudFormation.getArray(CfnResponsePlanIntegrationPropertyFromCloudFormation)(properties.Integrations) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResponsePlan = class _CfnResponsePlan extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResponsePlanPropsFromCloudFormation(resourceProperties), ret = new _CfnResponsePlan(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnResponsePlan.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ssmincidents_CfnResponsePlanProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResponsePlan), error;
        }
        cdk.requireProperty(props, "incidentTemplate", this), cdk.requireProperty(props, "name", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.incidentTemplate = props.incidentTemplate, this.name = props.name, this.actions = props.actions, this.chatChannel = props.chatChannel, this.displayName = props.displayName, this.engagements = props.engagements, this.integrations = props.integrations, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SSMIncidents::ResponsePlan", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResponsePlan.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { incidentTemplate: this.incidentTemplate, name: this.name, actions: this.actions, chatChannel: this.chatChannel, displayName: this.displayName, engagements: this.engagements, integrations: this.integrations, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnResponsePlanPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnResponsePlan[_b] = { fqn: "aws-cdk-lib.aws_ssmincidents.CfnResponsePlan", version: "2.80.0" }, CfnResponsePlan.CFN_RESOURCE_TYPE_NAME = "AWS::SSMIncidents::ResponsePlan", exports2.CfnResponsePlan = CfnResponsePlan;
    function CfnResponsePlan_ActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ssmAutomation", CfnResponsePlan_SsmAutomationPropertyValidator)(properties.ssmAutomation)), errors.wrap('supplied properties not correct for "ActionProperty"');
    }
    function cfnResponsePlanActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResponsePlan_ActionPropertyValidator(properties).assertSuccess(), { SsmAutomation: cfnResponsePlanSsmAutomationPropertyToCloudFormation(properties.ssmAutomation) }) : properties;
    }
    function CfnResponsePlanActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ssmAutomation", "SsmAutomation", properties.SsmAutomation != null ? CfnResponsePlanSsmAutomationPropertyFromCloudFormation(properties.SsmAutomation) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResponsePlan_ChatChannelPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("chatbotSns", cdk.listValidator(cdk.validateString))(properties.chatbotSns)), errors.wrap('supplied properties not correct for "ChatChannelProperty"');
    }
    function cfnResponsePlanChatChannelPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResponsePlan_ChatChannelPropertyValidator(properties).assertSuccess(), { ChatbotSns: cdk.listMapper(cdk.stringToCloudFormation)(properties.chatbotSns) }) : properties;
    }
    function CfnResponsePlanChatChannelPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("chatbotSns", "ChatbotSns", properties.ChatbotSns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ChatbotSns) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResponsePlan_DynamicSsmParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", CfnResponsePlan_DynamicSsmParameterValuePropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "DynamicSsmParameterProperty"');
    }
    function cfnResponsePlanDynamicSsmParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResponsePlan_DynamicSsmParameterPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cfnResponsePlanDynamicSsmParameterValuePropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnResponsePlanDynamicSsmParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", CfnResponsePlanDynamicSsmParameterValuePropertyFromCloudFormation(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResponsePlan_DynamicSsmParameterValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("variable", cdk.validateString)(properties.variable)), errors.wrap('supplied properties not correct for "DynamicSsmParameterValueProperty"');
    }
    function cfnResponsePlanDynamicSsmParameterValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResponsePlan_DynamicSsmParameterValuePropertyValidator(properties).assertSuccess(), { Variable: cdk.stringToCloudFormation(properties.variable) }) : properties;
    }
    function CfnResponsePlanDynamicSsmParameterValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("variable", "Variable", properties.Variable != null ? cfn_parse.FromCloudFormation.getString(properties.Variable) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResponsePlan_IncidentTemplatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dedupeString", cdk.validateString)(properties.dedupeString)), errors.collect(cdk.propertyValidator("impact", cdk.requiredValidator)(properties.impact)), errors.collect(cdk.propertyValidator("impact", cdk.validateNumber)(properties.impact)), errors.collect(cdk.propertyValidator("incidentTags", cdk.listValidator(cdk.validateCfnTag))(properties.incidentTags)), errors.collect(cdk.propertyValidator("notificationTargets", cdk.listValidator(CfnResponsePlan_NotificationTargetItemPropertyValidator))(properties.notificationTargets)), errors.collect(cdk.propertyValidator("summary", cdk.validateString)(properties.summary)), errors.collect(cdk.propertyValidator("title", cdk.requiredValidator)(properties.title)), errors.collect(cdk.propertyValidator("title", cdk.validateString)(properties.title)), errors.wrap('supplied properties not correct for "IncidentTemplateProperty"');
    }
    function cfnResponsePlanIncidentTemplatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResponsePlan_IncidentTemplatePropertyValidator(properties).assertSuccess(), { DedupeString: cdk.stringToCloudFormation(properties.dedupeString), Impact: cdk.numberToCloudFormation(properties.impact), IncidentTags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.incidentTags), NotificationTargets: cdk.listMapper(cfnResponsePlanNotificationTargetItemPropertyToCloudFormation)(properties.notificationTargets), Summary: cdk.stringToCloudFormation(properties.summary), Title: cdk.stringToCloudFormation(properties.title) }) : properties;
    }
    function CfnResponsePlanIncidentTemplatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dedupeString", "DedupeString", properties.DedupeString != null ? cfn_parse.FromCloudFormation.getString(properties.DedupeString) : void 0), ret.addPropertyResult("impact", "Impact", cfn_parse.FromCloudFormation.getNumber(properties.Impact)), ret.addPropertyResult("incidentTags", "IncidentTags", properties.IncidentTags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.IncidentTags) : void 0), ret.addPropertyResult("notificationTargets", "NotificationTargets", properties.NotificationTargets != null ? cfn_parse.FromCloudFormation.getArray(CfnResponsePlanNotificationTargetItemPropertyFromCloudFormation)(properties.NotificationTargets) : void 0), ret.addPropertyResult("summary", "Summary", properties.Summary != null ? cfn_parse.FromCloudFormation.getString(properties.Summary) : void 0), ret.addPropertyResult("title", "Title", cfn_parse.FromCloudFormation.getString(properties.Title)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResponsePlan_IntegrationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("pagerDutyConfiguration", cdk.requiredValidator)(properties.pagerDutyConfiguration)), errors.collect(cdk.propertyValidator("pagerDutyConfiguration", CfnResponsePlan_PagerDutyConfigurationPropertyValidator)(properties.pagerDutyConfiguration)), errors.wrap('supplied properties not correct for "IntegrationProperty"');
    }
    function cfnResponsePlanIntegrationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResponsePlan_IntegrationPropertyValidator(properties).assertSuccess(), { PagerDutyConfiguration: cfnResponsePlanPagerDutyConfigurationPropertyToCloudFormation(properties.pagerDutyConfiguration) }) : properties;
    }
    function CfnResponsePlanIntegrationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("pagerDutyConfiguration", "PagerDutyConfiguration", CfnResponsePlanPagerDutyConfigurationPropertyFromCloudFormation(properties.PagerDutyConfiguration)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResponsePlan_NotificationTargetItemPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("snsTopicArn", cdk.validateString)(properties.snsTopicArn)), errors.wrap('supplied properties not correct for "NotificationTargetItemProperty"');
    }
    function cfnResponsePlanNotificationTargetItemPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResponsePlan_NotificationTargetItemPropertyValidator(properties).assertSuccess(), { SnsTopicArn: cdk.stringToCloudFormation(properties.snsTopicArn) }) : properties;
    }
    function CfnResponsePlanNotificationTargetItemPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("snsTopicArn", "SnsTopicArn", properties.SnsTopicArn != null ? cfn_parse.FromCloudFormation.getString(properties.SnsTopicArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResponsePlan_PagerDutyConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("pagerDutyIncidentConfiguration", cdk.requiredValidator)(properties.pagerDutyIncidentConfiguration)), errors.collect(cdk.propertyValidator("pagerDutyIncidentConfiguration", CfnResponsePlan_PagerDutyIncidentConfigurationPropertyValidator)(properties.pagerDutyIncidentConfiguration)), errors.collect(cdk.propertyValidator("secretId", cdk.requiredValidator)(properties.secretId)), errors.collect(cdk.propertyValidator("secretId", cdk.validateString)(properties.secretId)), errors.wrap('supplied properties not correct for "PagerDutyConfigurationProperty"');
    }
    function cfnResponsePlanPagerDutyConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResponsePlan_PagerDutyConfigurationPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), PagerDutyIncidentConfiguration: cfnResponsePlanPagerDutyIncidentConfigurationPropertyToCloudFormation(properties.pagerDutyIncidentConfiguration), SecretId: cdk.stringToCloudFormation(properties.secretId) }) : properties;
    }
    function CfnResponsePlanPagerDutyConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("pagerDutyIncidentConfiguration", "PagerDutyIncidentConfiguration", CfnResponsePlanPagerDutyIncidentConfigurationPropertyFromCloudFormation(properties.PagerDutyIncidentConfiguration)), ret.addPropertyResult("secretId", "SecretId", cfn_parse.FromCloudFormation.getString(properties.SecretId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResponsePlan_PagerDutyIncidentConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("serviceId", cdk.requiredValidator)(properties.serviceId)), errors.collect(cdk.propertyValidator("serviceId", cdk.validateString)(properties.serviceId)), errors.wrap('supplied properties not correct for "PagerDutyIncidentConfigurationProperty"');
    }
    function cfnResponsePlanPagerDutyIncidentConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResponsePlan_PagerDutyIncidentConfigurationPropertyValidator(properties).assertSuccess(), { ServiceId: cdk.stringToCloudFormation(properties.serviceId) }) : properties;
    }
    function CfnResponsePlanPagerDutyIncidentConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("serviceId", "ServiceId", cfn_parse.FromCloudFormation.getString(properties.ServiceId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResponsePlan_SsmAutomationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("documentName", cdk.requiredValidator)(properties.documentName)), errors.collect(cdk.propertyValidator("documentName", cdk.validateString)(properties.documentName)), errors.collect(cdk.propertyValidator("documentVersion", cdk.validateString)(properties.documentVersion)), errors.collect(cdk.propertyValidator("dynamicParameters", cdk.listValidator(CfnResponsePlan_DynamicSsmParameterPropertyValidator))(properties.dynamicParameters)), errors.collect(cdk.propertyValidator("parameters", cdk.listValidator(CfnResponsePlan_SsmParameterPropertyValidator))(properties.parameters)), errors.collect(cdk.propertyValidator("roleArn", cdk.requiredValidator)(properties.roleArn)), errors.collect(cdk.propertyValidator("roleArn", cdk.validateString)(properties.roleArn)), errors.collect(cdk.propertyValidator("targetAccount", cdk.validateString)(properties.targetAccount)), errors.wrap('supplied properties not correct for "SsmAutomationProperty"');
    }
    function cfnResponsePlanSsmAutomationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResponsePlan_SsmAutomationPropertyValidator(properties).assertSuccess(), { DocumentName: cdk.stringToCloudFormation(properties.documentName), DocumentVersion: cdk.stringToCloudFormation(properties.documentVersion), DynamicParameters: cdk.listMapper(cfnResponsePlanDynamicSsmParameterPropertyToCloudFormation)(properties.dynamicParameters), Parameters: cdk.listMapper(cfnResponsePlanSsmParameterPropertyToCloudFormation)(properties.parameters), RoleArn: cdk.stringToCloudFormation(properties.roleArn), TargetAccount: cdk.stringToCloudFormation(properties.targetAccount) }) : properties;
    }
    function CfnResponsePlanSsmAutomationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("documentName", "DocumentName", cfn_parse.FromCloudFormation.getString(properties.DocumentName)), ret.addPropertyResult("documentVersion", "DocumentVersion", properties.DocumentVersion != null ? cfn_parse.FromCloudFormation.getString(properties.DocumentVersion) : void 0), ret.addPropertyResult("dynamicParameters", "DynamicParameters", properties.DynamicParameters != null ? cfn_parse.FromCloudFormation.getArray(CfnResponsePlanDynamicSsmParameterPropertyFromCloudFormation)(properties.DynamicParameters) : void 0), ret.addPropertyResult("parameters", "Parameters", properties.Parameters != null ? cfn_parse.FromCloudFormation.getArray(CfnResponsePlanSsmParameterPropertyFromCloudFormation)(properties.Parameters) : void 0), ret.addPropertyResult("roleArn", "RoleArn", cfn_parse.FromCloudFormation.getString(properties.RoleArn)), ret.addPropertyResult("targetAccount", "TargetAccount", properties.TargetAccount != null ? cfn_parse.FromCloudFormation.getString(properties.TargetAccount) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResponsePlan_SsmParameterPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("values", cdk.requiredValidator)(properties.values)), errors.collect(cdk.propertyValidator("values", cdk.listValidator(cdk.validateString))(properties.values)), errors.wrap('supplied properties not correct for "SsmParameterProperty"');
    }
    function cfnResponsePlanSsmParameterPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResponsePlan_SsmParameterPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Values: cdk.listMapper(cdk.stringToCloudFormation)(properties.values) }) : properties;
    }
    function CfnResponsePlanSsmParameterPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("values", "Values", cfn_parse.FromCloudFormation.getStringArray(properties.Values)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-ssmincidents/lib/index.js
var require_lib244 = __commonJS({
  "node_modules/aws-cdk-lib/aws-ssmincidents/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_ssmincidents_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-ssmincidents/index.js
var require_aws_ssmincidents = __commonJS({
  "node_modules/aws-cdk-lib/aws-ssmincidents/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib244(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-sso/lib/sso.generated.js
var require_sso_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-sso/lib/sso.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnPermissionSet = exports2.CfnInstanceAccessControlAttributeConfiguration = exports2.CfnAssignment = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAssignmentPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("instanceArn", cdk.requiredValidator)(properties.instanceArn)), errors.collect(cdk.propertyValidator("instanceArn", cdk.validateString)(properties.instanceArn)), errors.collect(cdk.propertyValidator("permissionSetArn", cdk.requiredValidator)(properties.permissionSetArn)), errors.collect(cdk.propertyValidator("permissionSetArn", cdk.validateString)(properties.permissionSetArn)), errors.collect(cdk.propertyValidator("principalId", cdk.requiredValidator)(properties.principalId)), errors.collect(cdk.propertyValidator("principalId", cdk.validateString)(properties.principalId)), errors.collect(cdk.propertyValidator("principalType", cdk.requiredValidator)(properties.principalType)), errors.collect(cdk.propertyValidator("principalType", cdk.validateString)(properties.principalType)), errors.collect(cdk.propertyValidator("targetId", cdk.requiredValidator)(properties.targetId)), errors.collect(cdk.propertyValidator("targetId", cdk.validateString)(properties.targetId)), errors.collect(cdk.propertyValidator("targetType", cdk.requiredValidator)(properties.targetType)), errors.collect(cdk.propertyValidator("targetType", cdk.validateString)(properties.targetType)), errors.wrap('supplied properties not correct for "CfnAssignmentProps"');
    }
    function cfnAssignmentPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssignmentPropsValidator(properties).assertSuccess(), { InstanceArn: cdk.stringToCloudFormation(properties.instanceArn), PermissionSetArn: cdk.stringToCloudFormation(properties.permissionSetArn), PrincipalId: cdk.stringToCloudFormation(properties.principalId), PrincipalType: cdk.stringToCloudFormation(properties.principalType), TargetId: cdk.stringToCloudFormation(properties.targetId), TargetType: cdk.stringToCloudFormation(properties.targetType) }) : properties;
    }
    function CfnAssignmentPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceArn", "InstanceArn", cfn_parse.FromCloudFormation.getString(properties.InstanceArn)), ret.addPropertyResult("permissionSetArn", "PermissionSetArn", cfn_parse.FromCloudFormation.getString(properties.PermissionSetArn)), ret.addPropertyResult("principalId", "PrincipalId", cfn_parse.FromCloudFormation.getString(properties.PrincipalId)), ret.addPropertyResult("principalType", "PrincipalType", cfn_parse.FromCloudFormation.getString(properties.PrincipalType)), ret.addPropertyResult("targetId", "TargetId", cfn_parse.FromCloudFormation.getString(properties.TargetId)), ret.addPropertyResult("targetType", "TargetType", cfn_parse.FromCloudFormation.getString(properties.TargetType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAssignment = class _CfnAssignment extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAssignmentPropsFromCloudFormation(resourceProperties), ret = new _CfnAssignment(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAssignment.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sso_CfnAssignmentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAssignment), error;
        }
        cdk.requireProperty(props, "instanceArn", this), cdk.requireProperty(props, "permissionSetArn", this), cdk.requireProperty(props, "principalId", this), cdk.requireProperty(props, "principalType", this), cdk.requireProperty(props, "targetId", this), cdk.requireProperty(props, "targetType", this), this.instanceArn = props.instanceArn, this.permissionSetArn = props.permissionSetArn, this.principalId = props.principalId, this.principalType = props.principalType, this.targetId = props.targetId, this.targetType = props.targetType;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAssignment.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { instanceArn: this.instanceArn, permissionSetArn: this.permissionSetArn, principalId: this.principalId, principalType: this.principalType, targetId: this.targetId, targetType: this.targetType };
      }
      renderProperties(props) {
        return cfnAssignmentPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAssignment[_a] = { fqn: "aws-cdk-lib.aws_sso.CfnAssignment", version: "2.80.0" }, CfnAssignment.CFN_RESOURCE_TYPE_NAME = "AWS::SSO::Assignment", exports2.CfnAssignment = CfnAssignment;
    function CfnInstanceAccessControlAttributeConfigurationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessControlAttributes", cdk.listValidator(CfnInstanceAccessControlAttributeConfiguration_AccessControlAttributePropertyValidator))(properties.accessControlAttributes)), errors.collect(cdk.propertyValidator("instanceArn", cdk.requiredValidator)(properties.instanceArn)), errors.collect(cdk.propertyValidator("instanceArn", cdk.validateString)(properties.instanceArn)), errors.wrap('supplied properties not correct for "CfnInstanceAccessControlAttributeConfigurationProps"');
    }
    function cfnInstanceAccessControlAttributeConfigurationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceAccessControlAttributeConfigurationPropsValidator(properties).assertSuccess(), { InstanceArn: cdk.stringToCloudFormation(properties.instanceArn), AccessControlAttributes: cdk.listMapper(cfnInstanceAccessControlAttributeConfigurationAccessControlAttributePropertyToCloudFormation)(properties.accessControlAttributes) }) : properties;
    }
    function CfnInstanceAccessControlAttributeConfigurationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceArn", "InstanceArn", cfn_parse.FromCloudFormation.getString(properties.InstanceArn)), ret.addPropertyResult("accessControlAttributes", "AccessControlAttributes", properties.AccessControlAttributes != null ? cfn_parse.FromCloudFormation.getArray(CfnInstanceAccessControlAttributeConfigurationAccessControlAttributePropertyFromCloudFormation)(properties.AccessControlAttributes) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnInstanceAccessControlAttributeConfiguration = class _CfnInstanceAccessControlAttributeConfiguration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnInstanceAccessControlAttributeConfigurationPropsFromCloudFormation(resourceProperties), ret = new _CfnInstanceAccessControlAttributeConfiguration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnInstanceAccessControlAttributeConfiguration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sso_CfnInstanceAccessControlAttributeConfigurationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnInstanceAccessControlAttributeConfiguration), error;
        }
        cdk.requireProperty(props, "instanceArn", this), this.instanceArn = props.instanceArn, this.accessControlAttributes = props.accessControlAttributes;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnInstanceAccessControlAttributeConfiguration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { instanceArn: this.instanceArn, accessControlAttributes: this.accessControlAttributes };
      }
      renderProperties(props) {
        return cfnInstanceAccessControlAttributeConfigurationPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnInstanceAccessControlAttributeConfiguration[_b] = { fqn: "aws-cdk-lib.aws_sso.CfnInstanceAccessControlAttributeConfiguration", version: "2.80.0" }, CfnInstanceAccessControlAttributeConfiguration.CFN_RESOURCE_TYPE_NAME = "AWS::SSO::InstanceAccessControlAttributeConfiguration", exports2.CfnInstanceAccessControlAttributeConfiguration = CfnInstanceAccessControlAttributeConfiguration;
    function CfnInstanceAccessControlAttributeConfiguration_AccessControlAttributePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", CfnInstanceAccessControlAttributeConfiguration_AccessControlAttributeValuePropertyValidator)(properties.value)), errors.wrap('supplied properties not correct for "AccessControlAttributeProperty"');
    }
    function cfnInstanceAccessControlAttributeConfigurationAccessControlAttributePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceAccessControlAttributeConfiguration_AccessControlAttributePropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Value: cfnInstanceAccessControlAttributeConfigurationAccessControlAttributeValuePropertyToCloudFormation(properties.value) }) : properties;
    }
    function CfnInstanceAccessControlAttributeConfigurationAccessControlAttributePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("value", "Value", CfnInstanceAccessControlAttributeConfigurationAccessControlAttributeValuePropertyFromCloudFormation(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnInstanceAccessControlAttributeConfiguration_AccessControlAttributeValuePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("source", cdk.requiredValidator)(properties.source)), errors.collect(cdk.propertyValidator("source", cdk.listValidator(cdk.validateString))(properties.source)), errors.wrap('supplied properties not correct for "AccessControlAttributeValueProperty"');
    }
    function cfnInstanceAccessControlAttributeConfigurationAccessControlAttributeValuePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnInstanceAccessControlAttributeConfiguration_AccessControlAttributeValuePropertyValidator(properties).assertSuccess(), { Source: cdk.listMapper(cdk.stringToCloudFormation)(properties.source) }) : properties;
    }
    function CfnInstanceAccessControlAttributeConfigurationAccessControlAttributeValuePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("source", "Source", cfn_parse.FromCloudFormation.getStringArray(properties.Source)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPermissionSetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customerManagedPolicyReferences", cdk.listValidator(CfnPermissionSet_CustomerManagedPolicyReferencePropertyValidator))(properties.customerManagedPolicyReferences)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("inlinePolicy", cdk.validateObject)(properties.inlinePolicy)), errors.collect(cdk.propertyValidator("instanceArn", cdk.requiredValidator)(properties.instanceArn)), errors.collect(cdk.propertyValidator("instanceArn", cdk.validateString)(properties.instanceArn)), errors.collect(cdk.propertyValidator("managedPolicies", cdk.listValidator(cdk.validateString))(properties.managedPolicies)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("permissionsBoundary", CfnPermissionSet_PermissionsBoundaryPropertyValidator)(properties.permissionsBoundary)), errors.collect(cdk.propertyValidator("relayStateType", cdk.validateString)(properties.relayStateType)), errors.collect(cdk.propertyValidator("sessionDuration", cdk.validateString)(properties.sessionDuration)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnPermissionSetProps"');
    }
    function cfnPermissionSetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPermissionSetPropsValidator(properties).assertSuccess(), { InstanceArn: cdk.stringToCloudFormation(properties.instanceArn), Name: cdk.stringToCloudFormation(properties.name), CustomerManagedPolicyReferences: cdk.listMapper(cfnPermissionSetCustomerManagedPolicyReferencePropertyToCloudFormation)(properties.customerManagedPolicyReferences), Description: cdk.stringToCloudFormation(properties.description), InlinePolicy: cdk.objectToCloudFormation(properties.inlinePolicy), ManagedPolicies: cdk.listMapper(cdk.stringToCloudFormation)(properties.managedPolicies), PermissionsBoundary: cfnPermissionSetPermissionsBoundaryPropertyToCloudFormation(properties.permissionsBoundary), RelayStateType: cdk.stringToCloudFormation(properties.relayStateType), SessionDuration: cdk.stringToCloudFormation(properties.sessionDuration), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnPermissionSetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("instanceArn", "InstanceArn", cfn_parse.FromCloudFormation.getString(properties.InstanceArn)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("customerManagedPolicyReferences", "CustomerManagedPolicyReferences", properties.CustomerManagedPolicyReferences != null ? cfn_parse.FromCloudFormation.getArray(CfnPermissionSetCustomerManagedPolicyReferencePropertyFromCloudFormation)(properties.CustomerManagedPolicyReferences) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("inlinePolicy", "InlinePolicy", properties.InlinePolicy != null ? cfn_parse.FromCloudFormation.getAny(properties.InlinePolicy) : void 0), ret.addPropertyResult("managedPolicies", "ManagedPolicies", properties.ManagedPolicies != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ManagedPolicies) : void 0), ret.addPropertyResult("permissionsBoundary", "PermissionsBoundary", properties.PermissionsBoundary != null ? CfnPermissionSetPermissionsBoundaryPropertyFromCloudFormation(properties.PermissionsBoundary) : void 0), ret.addPropertyResult("relayStateType", "RelayStateType", properties.RelayStateType != null ? cfn_parse.FromCloudFormation.getString(properties.RelayStateType) : void 0), ret.addPropertyResult("sessionDuration", "SessionDuration", properties.SessionDuration != null ? cfn_parse.FromCloudFormation.getString(properties.SessionDuration) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnPermissionSet = class _CfnPermissionSet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnPermissionSetPropsFromCloudFormation(resourceProperties), ret = new _CfnPermissionSet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnPermissionSet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_sso_CfnPermissionSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnPermissionSet), error;
        }
        cdk.requireProperty(props, "instanceArn", this), cdk.requireProperty(props, "name", this), this.attrPermissionSetArn = cdk.Token.asString(this.getAtt("PermissionSetArn", cdk.ResolutionTypeHint.STRING)), this.instanceArn = props.instanceArn, this.name = props.name, this.customerManagedPolicyReferences = props.customerManagedPolicyReferences, this.description = props.description, this.inlinePolicy = props.inlinePolicy, this.managedPolicies = props.managedPolicies, this.permissionsBoundary = props.permissionsBoundary, this.relayStateType = props.relayStateType, this.sessionDuration = props.sessionDuration, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SSO::PermissionSet", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnPermissionSet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { instanceArn: this.instanceArn, name: this.name, customerManagedPolicyReferences: this.customerManagedPolicyReferences, description: this.description, inlinePolicy: this.inlinePolicy, managedPolicies: this.managedPolicies, permissionsBoundary: this.permissionsBoundary, relayStateType: this.relayStateType, sessionDuration: this.sessionDuration, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnPermissionSetPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnPermissionSet[_c] = { fqn: "aws-cdk-lib.aws_sso.CfnPermissionSet", version: "2.80.0" }, CfnPermissionSet.CFN_RESOURCE_TYPE_NAME = "AWS::SSO::PermissionSet", exports2.CfnPermissionSet = CfnPermissionSet;
    function CfnPermissionSet_CustomerManagedPolicyReferencePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.wrap('supplied properties not correct for "CustomerManagedPolicyReferenceProperty"');
    }
    function cfnPermissionSetCustomerManagedPolicyReferencePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPermissionSet_CustomerManagedPolicyReferencePropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Path: cdk.stringToCloudFormation(properties.path) }) : properties;
    }
    function CfnPermissionSetCustomerManagedPolicyReferencePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("path", "Path", properties.Path != null ? cfn_parse.FromCloudFormation.getString(properties.Path) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnPermissionSet_PermissionsBoundaryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customerManagedPolicyReference", CfnPermissionSet_CustomerManagedPolicyReferencePropertyValidator)(properties.customerManagedPolicyReference)), errors.collect(cdk.propertyValidator("managedPolicyArn", cdk.validateString)(properties.managedPolicyArn)), errors.wrap('supplied properties not correct for "PermissionsBoundaryProperty"');
    }
    function cfnPermissionSetPermissionsBoundaryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnPermissionSet_PermissionsBoundaryPropertyValidator(properties).assertSuccess(), { CustomerManagedPolicyReference: cfnPermissionSetCustomerManagedPolicyReferencePropertyToCloudFormation(properties.customerManagedPolicyReference), ManagedPolicyArn: cdk.stringToCloudFormation(properties.managedPolicyArn) }) : properties;
    }
    function CfnPermissionSetPermissionsBoundaryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customerManagedPolicyReference", "CustomerManagedPolicyReference", properties.CustomerManagedPolicyReference != null ? CfnPermissionSetCustomerManagedPolicyReferencePropertyFromCloudFormation(properties.CustomerManagedPolicyReference) : void 0), ret.addPropertyResult("managedPolicyArn", "ManagedPolicyArn", properties.ManagedPolicyArn != null ? cfn_parse.FromCloudFormation.getString(properties.ManagedPolicyArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-sso/lib/index.js
var require_lib245 = __commonJS({
  "node_modules/aws-cdk-lib/aws-sso/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_sso_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-sso/index.js
var require_aws_sso = __commonJS({
  "node_modules/aws-cdk-lib/aws-sso/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib245(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/lambda/invoke-function.js
var require_invoke_function = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/lambda/invoke-function.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.InvokeFunction = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var InvokeFunction = class {
      constructor(lambdaFunction, props = {}) {
        this.lambdaFunction = lambdaFunction, this.props = props;
      }
      bind(_task) {
        return { resourceArn: this.lambdaFunction.functionArn, policyStatements: [new iam.PolicyStatement({ resources: this.lambdaFunction.resourceArnsForGrantInvoke, actions: ["lambda:InvokeFunction"] })], metricPrefixSingular: "LambdaFunction", metricPrefixPlural: "LambdaFunctions", metricDimensions: { LambdaFunctionArn: this.lambdaFunction.functionArn }, parameters: this.props.payload };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, InvokeFunction[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.InvokeFunction", version: "2.80.0" }, exports2.InvokeFunction = InvokeFunction;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/resource-arn-suffix.js
var require_resource_arn_suffix = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/resource-arn-suffix.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.getResourceArn = void 0;
    var sfn = require_aws_stepfunctions();
    var core_1 = require_core2();
    var resourceArnSuffix = /* @__PURE__ */ new Map();
    resourceArnSuffix.set(sfn.ServiceIntegrationPattern.FIRE_AND_FORGET, ""), resourceArnSuffix.set(sfn.ServiceIntegrationPattern.SYNC, ".sync"), resourceArnSuffix.set(sfn.ServiceIntegrationPattern.WAIT_FOR_TASK_TOKEN, ".waitForTaskToken");
    function getResourceArn(service, api, integrationPattern) {
      if (!service || !api)
        throw new Error("Both 'service' and 'api' must be provided to build the resource ARN.");
      return `arn:${core_1.Aws.PARTITION}:states:::${service}:${api}` + (integrationPattern ? resourceArnSuffix.get(integrationPattern) : "");
    }
    exports2.getResourceArn = getResourceArn;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/lambda/run-lambda-task.js
var require_run_lambda_task = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/lambda/run-lambda-task.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.InvocationType = exports2.RunLambdaTask = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var resource_arn_suffix_1 = require_resource_arn_suffix();
    var RunLambdaTask = class {
      constructor(lambdaFunction, props = {}) {
        if (this.lambdaFunction = lambdaFunction, this.props = props, this.integrationPattern = props.integrationPattern || sfn.ServiceIntegrationPattern.FIRE_AND_FORGET, ![sfn.ServiceIntegrationPattern.FIRE_AND_FORGET, sfn.ServiceIntegrationPattern.WAIT_FOR_TASK_TOKEN].includes(this.integrationPattern))
          throw new Error(`Invalid Service Integration Pattern: ${this.integrationPattern} is not supported to call Lambda.`);
        if (this.integrationPattern === sfn.ServiceIntegrationPattern.WAIT_FOR_TASK_TOKEN && !sfn.FieldUtils.containsTaskToken(props.payload))
          throw new Error("Task Token is missing in payload (pass JsonPath.taskToken somewhere in payload)");
      }
      bind(_task) {
        return { resourceArn: (0, resource_arn_suffix_1.getResourceArn)("lambda", "invoke", this.integrationPattern), policyStatements: [new iam.PolicyStatement({ resources: this.lambdaFunction.resourceArnsForGrantInvoke, actions: ["lambda:InvokeFunction"] })], metricPrefixSingular: "LambdaFunction", metricPrefixPlural: "LambdaFunctions", metricDimensions: { LambdaFunctionArn: this.lambdaFunction.functionArn }, parameters: { FunctionName: this.lambdaFunction.functionName, Payload: this.props.payload ? this.props.payload.value : sfn.TaskInput.fromJsonPathAt("$").value, InvocationType: this.props.invocationType, ClientContext: this.props.clientContext, Qualifier: this.props.qualifier } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, RunLambdaTask[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.RunLambdaTask", version: "2.80.0" }, exports2.RunLambdaTask = RunLambdaTask;
    var InvocationType;
    (function(InvocationType2) {
      InvocationType2.REQUEST_RESPONSE = "RequestResponse", InvocationType2.EVENT = "Event", InvocationType2.DRY_RUN = "DryRun";
    })(InvocationType = exports2.InvocationType || (exports2.InvocationType = {}));
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/private/task-utils.js
var require_task_utils = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/private/task-utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.integrationResourceArn = exports2.validatePatternSupported = void 0;
    var aws_stepfunctions_1 = require_aws_stepfunctions();
    var core_1 = require_core2();
    function validatePatternSupported(integrationPattern, supportedPatterns) {
      if (!supportedPatterns.includes(integrationPattern))
        throw new Error(`Unsupported service integration pattern. Supported Patterns: ${supportedPatterns}. Received: ${integrationPattern}`);
    }
    exports2.validatePatternSupported = validatePatternSupported;
    var resourceArnSuffix = { [aws_stepfunctions_1.IntegrationPattern.REQUEST_RESPONSE]: "", [aws_stepfunctions_1.IntegrationPattern.RUN_JOB]: ".sync", [aws_stepfunctions_1.IntegrationPattern.WAIT_FOR_TASK_TOKEN]: ".waitForTaskToken" };
    function integrationResourceArn(service, api, integrationPattern) {
      if (!service || !api)
        throw new Error("Both 'service' and 'api' must be provided to build the resource ARN.");
      return `arn:${core_1.Aws.PARTITION}:states:::${service}:${api}` + (integrationPattern ? resourceArnSuffix[integrationPattern] : "");
    }
    exports2.integrationResourceArn = integrationResourceArn;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/lambda/invoke.js
var require_invoke = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/lambda/invoke.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.LambdaInvocationType = exports2.LambdaInvoke = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var cdk = require_core2();
    var task_utils_1 = require_task_utils();
    var LambdaInvoke = class _LambdaInvoke extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_LambdaInvokeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _LambdaInvoke), error;
        }
        if (this.integrationPattern = props.integrationPattern ?? sfn.IntegrationPattern.REQUEST_RESPONSE, (0, task_utils_1.validatePatternSupported)(this.integrationPattern, _LambdaInvoke.SUPPORTED_INTEGRATION_PATTERNS), this.integrationPattern === sfn.IntegrationPattern.WAIT_FOR_TASK_TOKEN && !sfn.FieldUtils.containsTaskToken(props.payload))
          throw new Error("Task Token is required in `payload` for callback. Use JsonPath.taskToken to set the token.");
        if (props.payloadResponseOnly && (props.integrationPattern || props.invocationType || props.clientContext || props.qualifier))
          throw new Error("The 'payloadResponseOnly' property cannot be used if 'integrationPattern', 'invocationType', 'clientContext', or 'qualifier' are specified.");
        this.taskMetrics = { metricPrefixSingular: "LambdaFunction", metricPrefixPlural: "LambdaFunctions", metricDimensions: { LambdaFunctionArn: this.props.lambdaFunction.functionArn, ...this.props.qualifier && { Qualifier: this.props.qualifier } } }, this.taskPolicies = [new iam.PolicyStatement({ resources: this.props.lambdaFunction.resourceArnsForGrantInvoke, actions: ["lambda:InvokeFunction"] })], (props.retryOnServiceExceptions ?? true) && this.addRetry({ errors: ["Lambda.ServiceException", "Lambda.AWSLambdaException", "Lambda.SdkClientException"], interval: cdk.Duration.seconds(2), maxAttempts: 6, backoffRate: 2 });
      }
      _renderTask() {
        return this.props.payloadResponseOnly ? { Resource: this.props.lambdaFunction.functionArn, ...this.props.payload && { Parameters: sfn.FieldUtils.renderObject(this.props.payload.value) } } : { Resource: (0, task_utils_1.integrationResourceArn)("lambda", "invoke", this.integrationPattern), Parameters: sfn.FieldUtils.renderObject({ FunctionName: this.props.lambdaFunction.functionArn, Payload: this.props.payload ? this.props.payload.value : sfn.TaskInput.fromJsonPathAt("$").value, InvocationType: this.props.invocationType, ClientContext: this.props.clientContext, Qualifier: this.props.qualifier }) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, LambdaInvoke[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.LambdaInvoke", version: "2.80.0" }, LambdaInvoke.SUPPORTED_INTEGRATION_PATTERNS = [sfn.IntegrationPattern.REQUEST_RESPONSE, sfn.IntegrationPattern.WAIT_FOR_TASK_TOKEN], exports2.LambdaInvoke = LambdaInvoke;
    var LambdaInvocationType;
    (function(LambdaInvocationType2) {
      LambdaInvocationType2.REQUEST_RESPONSE = "RequestResponse", LambdaInvocationType2.EVENT = "Event", LambdaInvocationType2.DRY_RUN = "DryRun";
    })(LambdaInvocationType = exports2.LambdaInvocationType || (exports2.LambdaInvocationType = {}));
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/invoke-activity.js
var require_invoke_activity = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/invoke-activity.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.InvokeActivity = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var InvokeActivity = class {
      constructor(activity, props = {}) {
        this.activity = activity, this.props = props;
      }
      bind(_task) {
        return { resourceArn: this.activity.activityArn, metricDimensions: { ActivityArn: this.activity.activityArn }, heartbeat: this.props.heartbeat, metricPrefixSingular: "Activity", metricPrefixPlural: "Activities" };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, InvokeActivity[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.InvokeActivity", version: "2.80.0" }, exports2.InvokeActivity = InvokeActivity;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/ecs/run-ecs-task-base.js
var require_run_ecs_task_base = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/ecs/run-ecs-task-base.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EcsRunTaskBase = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var ec2 = require_aws_ec2();
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var cdk = require_core2();
    var resource_arn_suffix_1 = require_resource_arn_suffix();
    var EcsRunTaskBase = class {
      constructor(props) {
        if (this.props = props, this.connections = new ec2.Connections(), this.integrationPattern = props.integrationPattern || sfn.ServiceIntegrationPattern.FIRE_AND_FORGET, ![sfn.ServiceIntegrationPattern.FIRE_AND_FORGET, sfn.ServiceIntegrationPattern.WAIT_FOR_TASK_TOKEN, sfn.ServiceIntegrationPattern.SYNC].includes(this.integrationPattern))
          throw new Error(`Invalid Service Integration Pattern: ${this.integrationPattern} is not supported to call ECS.`);
        if (this.integrationPattern === sfn.ServiceIntegrationPattern.WAIT_FOR_TASK_TOKEN && !sfn.FieldUtils.containsTaskToken(props.containerOverrides?.map((override) => override.environment)))
          throw new Error("Task Token is required in at least one `containerOverrides.environment` for callback. Use JsonPath.taskToken to set the token.");
        for (const override of this.props.containerOverrides || []) {
          const name = override.containerDefinition.containerName;
          if (!cdk.Token.isUnresolved(name) && !this.props.taskDefinition.node.tryFindChild(name))
            throw new Error(`Overrides mention container with name '${name}', but no such container in task definition`);
        }
      }
      bind(task) {
        return this.networkConfiguration !== void 0 && (this.securityGroup === void 0 && (this.securityGroup = new ec2.SecurityGroup(task, "SecurityGroup", { vpc: this.props.cluster.vpc })), this.connections.addSecurityGroup(this.securityGroup)), { resourceArn: (0, resource_arn_suffix_1.getResourceArn)("ecs", "runTask", this.integrationPattern), parameters: { Cluster: this.props.cluster.clusterArn, TaskDefinition: this.props.taskDefinition.taskDefinitionArn, NetworkConfiguration: this.networkConfiguration, Overrides: renderOverrides(this.props.containerOverrides), ...this.props.parameters }, policyStatements: this.makePolicyStatements(task) };
      }
      configureAwsVpcNetworking(vpc, assignPublicIp, subnetSelection, securityGroup) {
        subnetSelection === void 0 && (subnetSelection = { subnetType: assignPublicIp ? ec2.SubnetType.PUBLIC : ec2.SubnetType.PRIVATE_WITH_EGRESS }), this.securityGroup = securityGroup, this.networkConfiguration = { AwsvpcConfiguration: { AssignPublicIp: assignPublicIp !== void 0 ? assignPublicIp ? "ENABLED" : "DISABLED" : void 0, Subnets: vpc.selectSubnets(subnetSelection).subnetIds, SecurityGroups: cdk.Lazy.list({ produce: () => [this.securityGroup.securityGroupId] }) } };
      }
      makePolicyStatements(task) {
        const stack = cdk.Stack.of(task), policyStatements = [new iam.PolicyStatement({ actions: ["ecs:RunTask"], resources: [this.props.taskDefinition.taskDefinitionArn] }), new iam.PolicyStatement({ actions: ["ecs:StopTask", "ecs:DescribeTasks"], resources: ["*"] }), new iam.PolicyStatement({ actions: ["iam:PassRole"], resources: cdk.Lazy.list({ produce: () => this.taskExecutionRoles().map((r) => r.roleArn) }) })];
        return this.integrationPattern === sfn.ServiceIntegrationPattern.SYNC && policyStatements.push(new iam.PolicyStatement({ actions: ["events:PutTargets", "events:PutRule", "events:DescribeRule"], resources: [stack.formatArn({ service: "events", resource: "rule", resourceName: "StepFunctionsGetEventsForECSTaskRule" })] })), policyStatements;
      }
      taskExecutionRoles() {
        const ret = new Array();
        return ret.push(this.props.taskDefinition.taskRole), this.props.taskDefinition.executionRole && ret.push(this.props.taskDefinition.executionRole), ret;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EcsRunTaskBase[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.EcsRunTaskBase", version: "2.80.0" }, exports2.EcsRunTaskBase = EcsRunTaskBase;
    function renderOverrides(containerOverrides) {
      if (!containerOverrides)
        return;
      const ret = new Array();
      for (const override of containerOverrides)
        ret.push({ Name: override.containerDefinition.containerName, Command: override.command, Cpu: override.cpu, Memory: override.memoryLimit, MemoryReservation: override.memoryReservation, Environment: override.environment && override.environment.map((e) => ({ Name: e.name, Value: e.value })) });
      return { ContainerOverrides: ret };
    }
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/ecs/run-ecs-task-base-types.js
var require_run_ecs_task_base_types = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/ecs/run-ecs-task-base-types.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/sns/publish-to-topic.js
var require_publish_to_topic = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/sns/publish-to-topic.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PublishToTopic = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var resource_arn_suffix_1 = require_resource_arn_suffix();
    var PublishToTopic = class {
      constructor(topic, props) {
        if (this.topic = topic, this.props = props, this.integrationPattern = props.integrationPattern || sfn.ServiceIntegrationPattern.FIRE_AND_FORGET, ![sfn.ServiceIntegrationPattern.FIRE_AND_FORGET, sfn.ServiceIntegrationPattern.WAIT_FOR_TASK_TOKEN].includes(this.integrationPattern))
          throw new Error(`Invalid Service Integration Pattern: ${this.integrationPattern} is not supported to call SNS.`);
        if (this.integrationPattern === sfn.ServiceIntegrationPattern.WAIT_FOR_TASK_TOKEN && !sfn.FieldUtils.containsTaskToken(props.message))
          throw new Error("Task Token is missing in message (pass JsonPath.taskToken somewhere in message)");
      }
      bind(_task) {
        return { resourceArn: (0, resource_arn_suffix_1.getResourceArn)("sns", "publish", this.integrationPattern), policyStatements: [new iam.PolicyStatement({ actions: ["sns:Publish"], resources: [this.topic.topicArn] })], parameters: { TopicArn: this.topic.topicArn, Message: this.props.message.value, MessageStructure: this.props.messagePerSubscriptionType ? "json" : void 0, Subject: this.props.subject } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, PublishToTopic[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.PublishToTopic", version: "2.80.0" }, exports2.PublishToTopic = PublishToTopic;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/sns/publish.js
var require_publish = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/sns/publish.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SnsPublish = exports2.MessageAttributeDataType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var core_1 = require_core2();
    var task_utils_1 = require_task_utils();
    var MessageAttributeDataType;
    (function(MessageAttributeDataType2) {
      MessageAttributeDataType2.STRING = "String", MessageAttributeDataType2.STRING_ARRAY = "String.Array", MessageAttributeDataType2.NUMBER = "Number", MessageAttributeDataType2.BINARY = "Binary";
    })(MessageAttributeDataType = exports2.MessageAttributeDataType || (exports2.MessageAttributeDataType = {}));
    var SnsPublish = class _SnsPublish extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_SnsPublishProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SnsPublish), error;
        }
        if (this.integrationPattern = props.integrationPattern ?? sfn.IntegrationPattern.REQUEST_RESPONSE, (0, task_utils_1.validatePatternSupported)(this.integrationPattern, _SnsPublish.SUPPORTED_INTEGRATION_PATTERNS), this.integrationPattern === sfn.IntegrationPattern.WAIT_FOR_TASK_TOKEN && !sfn.FieldUtils.containsTaskToken(props.message))
          throw new Error("Task Token is required in `message` Use JsonPath.taskToken to set the token.");
        this.taskPolicies = [new iam.PolicyStatement({ actions: ["sns:Publish"], resources: [this.props.topic.topicArn] })];
      }
      _renderTask() {
        return { Resource: (0, task_utils_1.integrationResourceArn)("sns", "publish", this.integrationPattern), Parameters: sfn.FieldUtils.renderObject({ TopicArn: this.props.topic.topicArn, Message: this.props.message.value, MessageStructure: this.props.messagePerSubscriptionType ? "json" : void 0, MessageAttributes: renderMessageAttributes(this.props.messageAttributes), Subject: this.props.subject }) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SnsPublish[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.SnsPublish", version: "2.80.0" }, SnsPublish.SUPPORTED_INTEGRATION_PATTERNS = [sfn.IntegrationPattern.REQUEST_RESPONSE, sfn.IntegrationPattern.WAIT_FOR_TASK_TOKEN], exports2.SnsPublish = SnsPublish;
    function renderMessageAttributes(attributes) {
      if (attributes === void 0)
        return;
      const renderedAttributes = {};
      return Object.entries(attributes).map(([key, val]) => {
        renderedAttributes[key] = renderMessageAttributeValue(val);
      }), sfn.TaskInput.fromObject(renderedAttributes).value;
    }
    function renderMessageAttributeValue(attribute) {
      const dataType = attribute.dataType;
      if (attribute.value instanceof sfn.TaskInput)
        return { DataType: dataType ?? MessageAttributeDataType.STRING, StringValue: dataType !== MessageAttributeDataType.BINARY ? attribute.value.value : void 0, BinaryValue: dataType === MessageAttributeDataType.BINARY ? attribute.value.value : void 0 };
      if (dataType === MessageAttributeDataType.BINARY)
        return { DataType: dataType, BinaryValue: `${attribute.value}` };
      if (core_1.Token.isUnresolved(attribute.value))
        return { DataType: dataType ?? MessageAttributeDataType.STRING, StringValue: attribute.value };
      if (validateMessageAttribute(attribute), Array.isArray(attribute.value))
        return { DataType: MessageAttributeDataType.STRING_ARRAY, StringValue: JSON.stringify(attribute.value) };
      const value = attribute.value;
      return typeof value == "number" ? { DataType: MessageAttributeDataType.NUMBER, StringValue: `${value}` } : { DataType: MessageAttributeDataType.STRING, StringValue: `${value}` };
    }
    function validateMessageAttribute(attribute) {
      const dataType = attribute.dataType, value = attribute.value;
      if (dataType === void 0)
        return;
      if (Array.isArray(value)) {
        if (dataType !== MessageAttributeDataType.STRING_ARRAY)
          throw new Error(`Requested SNS message attribute type was ${dataType} but ${value} was of type Array`);
        const validArrayTypes = ["string", "boolean", "number"];
        value.forEach((v) => {
          if (v !== null || !validArrayTypes.includes(typeof v))
            throw new Error(`Requested SNS message attribute type was ${typeof value} but Array values must be one of ${validArrayTypes}`);
        });
        return;
      }
      const error = new Error(`Requested SNS message attribute type was ${dataType} but ${value} was of type ${typeof value}`);
      switch (typeof value) {
        case "string":
          if (sfn.JsonPath.isEncodedJsonPath(attribute.value) || dataType === MessageAttributeDataType.STRING || dataType === MessageAttributeDataType.BINARY)
            return;
          throw error;
        case "number":
          if (dataType === MessageAttributeDataType.NUMBER)
            return;
          throw error;
        case "boolean":
          if (dataType === MessageAttributeDataType.STRING)
            return;
          throw error;
        default:
          throw error;
      }
    }
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/sqs/send-to-queue.js
var require_send_to_queue = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/sqs/send-to-queue.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SendToQueue = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var resource_arn_suffix_1 = require_resource_arn_suffix();
    var SendToQueue = class {
      constructor(queue, props) {
        if (this.queue = queue, this.props = props, this.integrationPattern = props.integrationPattern || sfn.ServiceIntegrationPattern.FIRE_AND_FORGET, ![sfn.ServiceIntegrationPattern.FIRE_AND_FORGET, sfn.ServiceIntegrationPattern.WAIT_FOR_TASK_TOKEN].includes(this.integrationPattern))
          throw new Error(`Invalid Service Integration Pattern: ${this.integrationPattern} is not supported to call SQS.`);
        if (props.integrationPattern === sfn.ServiceIntegrationPattern.WAIT_FOR_TASK_TOKEN && !sfn.FieldUtils.containsTaskToken(props.messageBody))
          throw new Error("Task Token is missing in messageBody (pass JsonPath.taskToken somewhere in messageBody)");
      }
      bind(_task) {
        return { resourceArn: (0, resource_arn_suffix_1.getResourceArn)("sqs", "sendMessage", this.integrationPattern), policyStatements: [new iam.PolicyStatement({ actions: ["sqs:SendMessage"], resources: [this.queue.queueArn] })], parameters: { QueueUrl: this.queue.queueUrl, MessageBody: this.props.messageBody.value, DelaySeconds: this.props.delay && this.props.delay.toSeconds(), MessageDeduplicationId: this.props.messageDeduplicationId, MessageGroupId: this.props.messageGroupId } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SendToQueue[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.SendToQueue", version: "2.80.0" }, exports2.SendToQueue = SendToQueue;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/sqs/send-message.js
var require_send_message = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/sqs/send-message.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SqsSendMessage = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var task_utils_1 = require_task_utils();
    var SqsSendMessage = class _SqsSendMessage extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_SqsSendMessageProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SqsSendMessage), error;
        }
        if (this.integrationPattern = props.integrationPattern ?? sfn.IntegrationPattern.REQUEST_RESPONSE, (0, task_utils_1.validatePatternSupported)(this.integrationPattern, _SqsSendMessage.SUPPORTED_INTEGRATION_PATTERNS), props.integrationPattern === sfn.IntegrationPattern.WAIT_FOR_TASK_TOKEN && !sfn.FieldUtils.containsTaskToken(props.messageBody))
          throw new Error("Task Token is required in `messageBody` Use JsonPath.taskToken to set the token.");
        this.taskPolicies = [new iam.PolicyStatement({ actions: ["sqs:SendMessage"], resources: [this.props.queue.queueArn] })], this.props.queue.encryptionMasterKey && this.taskPolicies.push(new iam.PolicyStatement({ actions: ["kms:Decrypt", "kms:GenerateDataKey*"], resources: [this.props.queue.encryptionMasterKey.keyArn] }));
      }
      _renderTask() {
        return { Resource: (0, task_utils_1.integrationResourceArn)("sqs", "sendMessage", this.integrationPattern), Parameters: sfn.FieldUtils.renderObject({ QueueUrl: this.props.queue.queueUrl, MessageBody: this.props.messageBody.value, DelaySeconds: this.props.delay?.toSeconds(), MessageDeduplicationId: this.props.messageDeduplicationId, MessageGroupId: this.props.messageGroupId }) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SqsSendMessage[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.SqsSendMessage", version: "2.80.0" }, SqsSendMessage.SUPPORTED_INTEGRATION_PATTERNS = [sfn.IntegrationPattern.REQUEST_RESPONSE, sfn.IntegrationPattern.WAIT_FOR_TASK_TOKEN], exports2.SqsSendMessage = SqsSendMessage;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/ecs/run-ecs-ec2-task.js
var require_run_ecs_ec2_task = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/ecs/run-ecs-ec2-task.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.RunEcsEc2Task = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var run_ecs_task_base_1 = require_run_ecs_task_base();
    var ecs = require_aws_ecs();
    var RunEcsEc2Task = class extends run_ecs_task_base_1.EcsRunTaskBase {
      constructor(props) {
        if (!props.taskDefinition.isEc2Compatible)
          throw new Error("Supplied TaskDefinition is not configured for compatibility with EC2");
        if (!props.cluster.hasEc2Capacity)
          throw new Error("Cluster for this service needs Ec2 capacity. Call addXxxCapacity() on the cluster.");
        if (!props.taskDefinition.defaultContainer)
          throw new Error("A TaskDefinition must have at least one essential container");
        super({ ...props, parameters: { LaunchType: "EC2", PlacementConstraints: noEmpty(flatten((props.placementConstraints || []).map((c) => c.toJson().map(uppercaseKeys)))), PlacementStrategy: noEmpty(flatten((props.placementStrategies || []).map((c) => c.toJson().map(uppercaseKeys)))) } }), props.taskDefinition.networkMode === ecs.NetworkMode.AWS_VPC ? this.configureAwsVpcNetworking(props.cluster.vpc, void 0, props.subnets, props.securityGroup) : (validateNoNetworkingProps(props), this.connections.addSecurityGroup(...props.cluster.connections.securityGroups));
      }
    };
    _a = JSII_RTTI_SYMBOL_1, RunEcsEc2Task[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.RunEcsEc2Task", version: "2.80.0" }, exports2.RunEcsEc2Task = RunEcsEc2Task;
    function validateNoNetworkingProps(props) {
      if (props.subnets !== void 0 || props.securityGroup !== void 0)
        throw new Error("vpcPlacement and securityGroup can only be used in AwsVpc networking mode");
    }
    function uppercaseKeys(obj) {
      const ret = {};
      for (const key of Object.keys(obj))
        ret[key.slice(0, 1).toUpperCase() + key.slice(1)] = obj[key];
      return ret;
    }
    function flatten(xs) {
      return Array.prototype.concat([], ...xs);
    }
    function noEmpty(xs) {
      if (xs.length !== 0)
        return xs;
    }
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/ecs/run-ecs-fargate-task.js
var require_run_ecs_fargate_task = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/ecs/run-ecs-fargate-task.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.RunEcsFargateTask = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var run_ecs_task_base_1 = require_run_ecs_task_base();
    var RunEcsFargateTask = class extends run_ecs_task_base_1.EcsRunTaskBase {
      constructor(props) {
        if (!props.taskDefinition.isFargateCompatible)
          throw new Error("Supplied TaskDefinition is not configured for compatibility with Fargate");
        if (!props.taskDefinition.defaultContainer)
          throw new Error("A TaskDefinition must have at least one essential container");
        super({ ...props, parameters: { LaunchType: "FARGATE" } }), this.configureAwsVpcNetworking(props.cluster.vpc, props.assignPublicIp, props.subnets, props.securityGroup);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, RunEcsFargateTask[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.RunEcsFargateTask", version: "2.80.0" }, exports2.RunEcsFargateTask = RunEcsFargateTask;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/ecs/run-task.js
var require_run_task = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/ecs/run-task.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EcsRunTask = exports2.EcsEc2LaunchTarget = exports2.EcsFargateLaunchTarget = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var ec2 = require_aws_ec2();
    var ecs = require_aws_ecs();
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var cdk = require_core2();
    var task_utils_1 = require_task_utils();
    var EcsFargateLaunchTarget = class _EcsFargateLaunchTarget {
      constructor(options) {
        this.options = options;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_EcsFargateLaunchTargetOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EcsFargateLaunchTarget), error;
        }
      }
      bind(_task, launchTargetOptions) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_EcsRunTask(_task), jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_LaunchTargetBindOptions(launchTargetOptions);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        if (!launchTargetOptions.taskDefinition.isFargateCompatible)
          throw new Error("Supplied TaskDefinition is not compatible with Fargate");
        return { parameters: { LaunchType: "FARGATE", PlatformVersion: this.options?.platformVersion } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EcsFargateLaunchTarget[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.EcsFargateLaunchTarget", version: "2.80.0" }, exports2.EcsFargateLaunchTarget = EcsFargateLaunchTarget;
    var EcsEc2LaunchTarget = class _EcsEc2LaunchTarget {
      constructor(options) {
        this.options = options;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_EcsEc2LaunchTargetOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EcsEc2LaunchTarget), error;
        }
      }
      bind(_task, launchTargetOptions) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_EcsRunTask(_task), jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_LaunchTargetBindOptions(launchTargetOptions);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        if (!launchTargetOptions.taskDefinition.isEc2Compatible)
          throw new Error("Supplied TaskDefinition is not compatible with EC2");
        if (!launchTargetOptions.cluster?.hasEc2Capacity)
          throw new Error("Cluster for this service needs Ec2 capacity. Call addCapacity() on the cluster.");
        return { parameters: { LaunchType: "EC2", PlacementConstraints: noEmpty(flatten((this.options?.placementConstraints ?? []).map((c) => c.toJson().map(uppercaseKeys)))), PlacementStrategy: noEmpty(flatten((this.options?.placementStrategies ?? []).map((c) => c.toJson().map(uppercaseKeys)))) } };
        function uppercaseKeys(obj) {
          const ret = {};
          for (const key of Object.keys(obj))
            ret[key.slice(0, 1).toUpperCase() + key.slice(1)] = obj[key];
          return ret;
        }
        function flatten(xs) {
          return Array.prototype.concat([], ...xs);
        }
        function noEmpty(xs) {
          if (xs.length !== 0)
            return xs;
        }
      }
    };
    _b = JSII_RTTI_SYMBOL_1, EcsEc2LaunchTarget[_b] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.EcsEc2LaunchTarget", version: "2.80.0" }, exports2.EcsEc2LaunchTarget = EcsEc2LaunchTarget;
    var EcsRunTask = class _EcsRunTask extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props, this.connections = new ec2.Connections(), this.securityGroups = [];
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_EcsRunTaskProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EcsRunTask), error;
        }
        if (this.integrationPattern = props.integrationPattern ?? sfn.IntegrationPattern.REQUEST_RESPONSE, (0, task_utils_1.validatePatternSupported)(this.integrationPattern, _EcsRunTask.SUPPORTED_INTEGRATION_PATTERNS), this.integrationPattern === sfn.IntegrationPattern.WAIT_FOR_TASK_TOKEN && !sfn.FieldUtils.containsTaskToken(props.containerOverrides?.map((override) => override.environment)))
          throw new Error("Task Token is required in at least one `containerOverrides.environment` for callback. Use JsonPath.taskToken to set the token.");
        if (!this.props.taskDefinition.defaultContainer)
          throw new Error("A TaskDefinition must have at least one essential container");
        this.props.taskDefinition.networkMode === ecs.NetworkMode.AWS_VPC ? this.configureAwsVpcNetworking() : (this.validateNoNetworkingProps(), this.connections.addSecurityGroup(...this.props.cluster.connections.securityGroups));
        for (const override of this.props.containerOverrides ?? []) {
          const name = override.containerDefinition.containerName;
          if (!cdk.Token.isUnresolved(name) && !this.props.taskDefinition.findContainer(name))
            throw new Error(`Overrides mention container with name '${name}', but no such container in task definition`);
        }
        this.taskPolicies = this.makePolicyStatements();
      }
      _renderTask() {
        return { Resource: (0, task_utils_1.integrationResourceArn)("ecs", "runTask", this.integrationPattern), Parameters: sfn.FieldUtils.renderObject({ Cluster: this.props.cluster.clusterArn, TaskDefinition: this.props.revisionNumber === void 0 ? this.props.taskDefinition.family : `${this.props.taskDefinition.family}:${this.props.revisionNumber.toString()}`, NetworkConfiguration: this.networkConfiguration, Overrides: renderOverrides(this.props.containerOverrides), PropagateTags: this.props.propagatedTagSource, ...this.props.launchTarget.bind(this, { taskDefinition: this.props.taskDefinition, cluster: this.props.cluster }).parameters }) };
      }
      configureAwsVpcNetworking() {
        const subnetSelection = this.props.subnets ?? { subnetType: this.props.assignPublicIp ? ec2.SubnetType.PUBLIC : ec2.SubnetType.PRIVATE_WITH_EGRESS };
        this.networkConfiguration = { AwsvpcConfiguration: { AssignPublicIp: this.props.assignPublicIp ? this.props.assignPublicIp ? "ENABLED" : "DISABLED" : void 0, Subnets: this.props.cluster.vpc.selectSubnets(subnetSelection).subnetIds, SecurityGroups: cdk.Lazy.list({ produce: () => this.securityGroups?.map((sg) => sg.securityGroupId) }) } }, this.securityGroups = this.props.securityGroups ?? [new ec2.SecurityGroup(this, "SecurityGroup", { vpc: this.props.cluster.vpc })], this.connections.addSecurityGroup(...this.securityGroups);
      }
      validateNoNetworkingProps() {
        if (this.props.subnets !== void 0 || this.props.securityGroups !== void 0)
          throw new Error(`Supplied TaskDefinition must have 'networkMode' of 'AWS_VPC' to use 'vpcSubnets' and 'securityGroup'. Received: ${this.props.taskDefinition.networkMode}`);
      }
      makePolicyStatements() {
        const stack = cdk.Stack.of(this), policyStatements = [new iam.PolicyStatement({ actions: ["ecs:RunTask"], resources: [this.getTaskDefinitionFamilyArn()] }), new iam.PolicyStatement({ actions: ["ecs:StopTask", "ecs:DescribeTasks"], resources: ["*"] }), new iam.PolicyStatement({ actions: ["iam:PassRole"], resources: this.taskExecutionRoles().map((r) => r.roleArn) })];
        return this.integrationPattern === sfn.IntegrationPattern.RUN_JOB && policyStatements.push(new iam.PolicyStatement({ actions: ["events:PutTargets", "events:PutRule", "events:DescribeRule"], resources: [stack.formatArn({ service: "events", resource: "rule", resourceName: "StepFunctionsGetEventsForECSTaskRule" })] })), policyStatements;
      }
      getTaskDefinitionFamilyArn() {
        const arnComponents = cdk.Stack.of(this).splitArn(this.props.taskDefinition.taskDefinitionArn, cdk.ArnFormat.SLASH_RESOURCE_NAME);
        let { resourceName } = arnComponents;
        return resourceName && (resourceName = resourceName.split(":")[0]), cdk.Stack.of(this).formatArn({ partition: arnComponents.partition, service: arnComponents.service, account: arnComponents.account, region: arnComponents.region, resource: arnComponents.resource, arnFormat: arnComponents.arnFormat, resourceName });
      }
      taskExecutionRoles() {
        const ret = new Array();
        return ret.push(this.props.taskDefinition.taskRole), this.props.taskDefinition.executionRole && ret.push(this.props.taskDefinition.executionRole), ret;
      }
    };
    _c = JSII_RTTI_SYMBOL_1, EcsRunTask[_c] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.EcsRunTask", version: "2.80.0" }, EcsRunTask.SUPPORTED_INTEGRATION_PATTERNS = [sfn.IntegrationPattern.REQUEST_RESPONSE, sfn.IntegrationPattern.RUN_JOB, sfn.IntegrationPattern.WAIT_FOR_TASK_TOKEN], exports2.EcsRunTask = EcsRunTask;
    function renderOverrides(containerOverrides) {
      if (!containerOverrides || containerOverrides.length === 0)
        return;
      const ret = new Array();
      for (const override of containerOverrides)
        ret.push({ Name: override.containerDefinition.containerName, Command: override.command, Cpu: override.cpu, Memory: override.memoryLimit, MemoryReservation: override.memoryReservation, Environment: override.environment?.map((e) => ({ Name: e.name, Value: e.value })) });
      return { ContainerOverrides: ret };
    }
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/sagemaker/base-types.js
var require_base_types = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/sagemaker/base-types.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AssembleWith = exports2.SplitType = exports2.BatchStrategy = exports2.AcceleratorType = exports2.AcceleratorClass = exports2.Mode = exports2.ContainerDefinition = exports2.CompressionType = exports2.InputMode = exports2.RecordWrapperType = exports2.S3DataDistributionType = exports2.S3DataType = exports2.DockerImage = exports2.S3Location = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var aws_ecr_assets_1 = require_aws_ecr_assets();
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var S3Location = class {
      static fromBucket(bucket, keyPrefix) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_IBucket(bucket);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromBucket), error;
        }
        return new StandardS3Location({ bucket, keyPrefix, uri: bucket.urlForObject(keyPrefix) });
      }
      static fromJsonExpression(expression) {
        return new StandardS3Location({ uri: sfn.JsonPath.stringAt(expression) });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, S3Location[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.S3Location", version: "2.80.0" }, exports2.S3Location = S3Location;
    var DockerImage = class {
      static fromEcrRepository(repository, tagOrDigest = "latest") {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecr_IRepository(repository);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromEcrRepository), error;
        }
        return new StandardDockerImage({ repository, imageUri: repository.repositoryUriForTagOrDigest(tagOrDigest) });
      }
      static fromJsonExpression(expression, allowAnyEcrImagePull = true) {
        return new StandardDockerImage({ imageUri: expression, allowAnyEcrImagePull });
      }
      static fromRegistry(imageUri) {
        return new StandardDockerImage({ imageUri });
      }
      static fromAsset(scope, id, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecr_assets_DockerImageAssetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromAsset), error;
        }
        const asset = new aws_ecr_assets_1.DockerImageAsset(scope, id, props);
        return new StandardDockerImage({ repository: asset.repository, imageUri: asset.imageUri });
      }
    };
    _b = JSII_RTTI_SYMBOL_1, DockerImage[_b] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.DockerImage", version: "2.80.0" }, exports2.DockerImage = DockerImage;
    var S3DataType;
    (function(S3DataType2) {
      S3DataType2.MANIFEST_FILE = "ManifestFile", S3DataType2.S3_PREFIX = "S3Prefix", S3DataType2.AUGMENTED_MANIFEST_FILE = "AugmentedManifestFile";
    })(S3DataType = exports2.S3DataType || (exports2.S3DataType = {}));
    var S3DataDistributionType;
    (function(S3DataDistributionType2) {
      S3DataDistributionType2.FULLY_REPLICATED = "FullyReplicated", S3DataDistributionType2.SHARDED_BY_S3_KEY = "ShardedByS3Key";
    })(S3DataDistributionType = exports2.S3DataDistributionType || (exports2.S3DataDistributionType = {}));
    var RecordWrapperType;
    (function(RecordWrapperType2) {
      RecordWrapperType2.NONE = "None", RecordWrapperType2.RECORD_IO = "RecordIO";
    })(RecordWrapperType = exports2.RecordWrapperType || (exports2.RecordWrapperType = {}));
    var InputMode;
    (function(InputMode2) {
      InputMode2.PIPE = "Pipe", InputMode2.FILE = "File";
    })(InputMode = exports2.InputMode || (exports2.InputMode = {}));
    var CompressionType;
    (function(CompressionType2) {
      CompressionType2.NONE = "None", CompressionType2.GZIP = "Gzip";
    })(CompressionType = exports2.CompressionType || (exports2.CompressionType = {}));
    var ContainerDefinition = class _ContainerDefinition {
      constructor(options) {
        this.options = options;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_ContainerDefinitionOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ContainerDefinition), error;
        }
      }
      bind(task) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_ISageMakerTask(task);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.bind), error;
        }
        return { parameters: { ContainerHostname: this.options.containerHostName, Image: this.options.image?.bind(task).imageUri, Mode: this.options.mode, ModelDataUrl: this.options.modelS3Location?.bind(task, { forReading: true }).uri, ModelPackageName: this.options.modelPackageName, Environment: this.options.environmentVariables?.value } };
      }
    };
    _c = JSII_RTTI_SYMBOL_1, ContainerDefinition[_c] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.ContainerDefinition", version: "2.80.0" }, exports2.ContainerDefinition = ContainerDefinition;
    var Mode;
    (function(Mode2) {
      Mode2.SINGLE_MODEL = "SingleModel", Mode2.MULTI_MODEL = "MultiModel";
    })(Mode = exports2.Mode || (exports2.Mode = {}));
    var AcceleratorClass = class _AcceleratorClass {
      static of(version) {
        return new _AcceleratorClass(version);
      }
      constructor(version) {
        this.version = version;
      }
    };
    _d = JSII_RTTI_SYMBOL_1, AcceleratorClass[_d] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.AcceleratorClass", version: "2.80.0" }, AcceleratorClass.EIA1 = AcceleratorClass.of("eia1"), AcceleratorClass.EIA2 = AcceleratorClass.of("eia2"), exports2.AcceleratorClass = AcceleratorClass;
    var AcceleratorType = class _AcceleratorType {
      static of(acceleratorClass, instanceSize) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_AcceleratorClass(acceleratorClass), jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_InstanceSize(instanceSize);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.of), error;
        }
        return new _AcceleratorType(`ml.${acceleratorClass}.${instanceSize}`);
      }
      constructor(instanceTypeIdentifier) {
        this.instanceTypeIdentifier = instanceTypeIdentifier;
      }
      toString() {
        return this.instanceTypeIdentifier;
      }
    };
    _e = JSII_RTTI_SYMBOL_1, AcceleratorType[_e] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.AcceleratorType", version: "2.80.0" }, exports2.AcceleratorType = AcceleratorType;
    var BatchStrategy;
    (function(BatchStrategy2) {
      BatchStrategy2.MULTI_RECORD = "MultiRecord", BatchStrategy2.SINGLE_RECORD = "SingleRecord";
    })(BatchStrategy = exports2.BatchStrategy || (exports2.BatchStrategy = {}));
    var SplitType;
    (function(SplitType2) {
      SplitType2.NONE = "None", SplitType2.LINE = "Line", SplitType2.RECORD_IO = "RecordIO", SplitType2.TF_RECORD = "TFRecord";
    })(SplitType = exports2.SplitType || (exports2.SplitType = {}));
    var AssembleWith;
    (function(AssembleWith2) {
      AssembleWith2.NONE = "None", AssembleWith2.LINE = "Line";
    })(AssembleWith = exports2.AssembleWith || (exports2.AssembleWith = {}));
    var StandardDockerImage = class extends DockerImage {
      constructor(opts) {
        super(), this.allowAnyEcrImagePull = !!opts.allowAnyEcrImagePull, this.imageUri = opts.imageUri, this.repository = opts.repository;
      }
      bind(task) {
        return this.repository && this.repository.grantPull(task), this.allowAnyEcrImagePull && task.grantPrincipal.addToPrincipalPolicy(new iam.PolicyStatement({ actions: ["ecr:BatchCheckLayerAvailability", "ecr:GetDownloadUrlForLayer", "ecr:BatchGetImage"], resources: ["*"] })), { imageUri: this.imageUri };
      }
    };
    var StandardS3Location = class extends S3Location {
      constructor(opts) {
        super(), this.bucket = opts.bucket, this.keyGlob = `${opts.keyPrefix || ""}*`, this.uri = opts.uri;
      }
      bind(task, opts) {
        if (this.bucket)
          opts.forReading && this.bucket.grantRead(task, this.keyGlob), opts.forWriting && this.bucket.grantWrite(task, this.keyGlob);
        else {
          const actions = new Array();
          opts.forReading && actions.push("s3:GetObject", "s3:ListBucket"), opts.forWriting && actions.push("s3:PutObject"), task.grantPrincipal.addToPrincipalPolicy(new iam.PolicyStatement({ actions, resources: ["*"] }));
        }
        return { uri: this.uri };
      }
    };
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/sagemaker/private/utils.js
var require_utils15 = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/sagemaker/private/utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.renderEnvironment = exports2.renderTags = void 0;
    function renderTags(tags) {
      return tags ? { Tags: Object.keys(tags).map((key) => ({ Key: key, Value: tags[key] })) } : {};
    }
    exports2.renderTags = renderTags;
    function renderEnvironment(environment) {
      return environment ? { Environment: environment } : {};
    }
    exports2.renderEnvironment = renderEnvironment;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/sagemaker/create-training-job.js
var require_create_training_job = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/sagemaker/create-training-job.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SageMakerCreateTrainingJob = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var base_types_1 = require_base_types();
    var utils_1 = require_utils15();
    var ec2 = require_aws_ec2();
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var core_1 = require_core2();
    var task_utils_1 = require_task_utils();
    var SageMakerCreateTrainingJob = class _SageMakerCreateTrainingJob extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props, this.connections = new ec2.Connections(), this.securityGroups = [];
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_SageMakerCreateTrainingJobProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SageMakerCreateTrainingJob), error;
        }
        if (this.integrationPattern = props.integrationPattern || sfn.IntegrationPattern.REQUEST_RESPONSE, (0, task_utils_1.validatePatternSupported)(this.integrationPattern, _SageMakerCreateTrainingJob.SUPPORTED_INTEGRATION_PATTERNS), this.resourceConfig = props.resourceConfig || { instanceCount: 1, instanceType: ec2.InstanceType.of(ec2.InstanceClass.M4, ec2.InstanceSize.XLARGE), volumeSize: core_1.Size.gibibytes(10) }, this.stoppingCondition = props.stoppingCondition || { maxRuntime: core_1.Duration.hours(1) }, !props.algorithmSpecification.algorithmName && !props.algorithmSpecification.trainingImage)
          throw new Error("Must define either an algorithm name or training image URI in the algorithm specification");
        this.algorithmSpecification = props.algorithmSpecification.trainingInputMode ? props.algorithmSpecification : { ...props.algorithmSpecification, trainingInputMode: base_types_1.InputMode.FILE }, this.inputDataConfig = props.inputDataConfig.map((config) => config.dataSource.s3DataSource.s3DataType ? config : { ...config, dataSource: { s3DataSource: { ...config.dataSource.s3DataSource, s3DataType: base_types_1.S3DataType.S3_PREFIX } } }), props.vpcConfig && (this.vpc = props.vpcConfig.vpc, this.subnets = props.vpcConfig.subnets ? this.vpc.selectSubnets(props.vpcConfig.subnets).subnetIds : this.vpc.selectSubnets().subnetIds), this.taskPolicies = this.makePolicyStatements();
      }
      get role() {
        if (this._role === void 0)
          throw new Error("role not available yet--use the object in a Task first");
        return this._role;
      }
      get grantPrincipal() {
        if (this._grantPrincipal === void 0)
          throw new Error("Principal not available yet--use the object in a Task first");
        return this._grantPrincipal;
      }
      addSecurityGroup(securityGroup) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_ISecurityGroup(securityGroup);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addSecurityGroup), error;
        }
        this.securityGroups.push(securityGroup);
      }
      _renderTask() {
        return { Resource: (0, task_utils_1.integrationResourceArn)("sagemaker", "createTrainingJob", this.integrationPattern), Parameters: sfn.FieldUtils.renderObject(this.renderParameters()) };
      }
      renderParameters() {
        return { TrainingJobName: this.props.trainingJobName, EnableNetworkIsolation: this.props.enableNetworkIsolation, RoleArn: this._role.roleArn, ...this.renderAlgorithmSpecification(this.algorithmSpecification), ...this.renderInputDataConfig(this.inputDataConfig), ...this.renderOutputDataConfig(this.props.outputDataConfig), ...this.renderResourceConfig(this.resourceConfig), ...this.renderStoppingCondition(this.stoppingCondition), ...this.renderHyperparameters(this.props.hyperparameters), ...(0, utils_1.renderTags)(this.props.tags), ...this.renderVpcConfig(this.props.vpcConfig), ...(0, utils_1.renderEnvironment)(this.props.environment) };
      }
      renderAlgorithmSpecification(spec) {
        return { AlgorithmSpecification: { TrainingInputMode: spec.trainingInputMode, ...spec.trainingImage ? { TrainingImage: spec.trainingImage.bind(this).imageUri } : {}, ...spec.algorithmName ? { AlgorithmName: spec.algorithmName } : {}, ...spec.metricDefinitions ? { MetricDefinitions: spec.metricDefinitions.map((metric) => ({ Name: metric.name, Regex: metric.regex })) } : {} } };
      }
      renderInputDataConfig(config) {
        return { InputDataConfig: config.map((channel) => ({ ChannelName: channel.channelName, DataSource: { S3DataSource: { S3Uri: channel.dataSource.s3DataSource.s3Location.bind(this, { forReading: true }).uri, S3DataType: channel.dataSource.s3DataSource.s3DataType, ...channel.dataSource.s3DataSource.s3DataDistributionType ? { S3DataDistributionType: channel.dataSource.s3DataSource.s3DataDistributionType } : {}, ...channel.dataSource.s3DataSource.attributeNames ? { AttributeNames: channel.dataSource.s3DataSource.attributeNames } : {} } }, ...channel.compressionType ? { CompressionType: channel.compressionType } : {}, ...channel.contentType ? { ContentType: channel.contentType } : {}, ...channel.inputMode ? { InputMode: channel.inputMode } : {}, ...channel.recordWrapperType ? { RecordWrapperType: channel.recordWrapperType } : {} })) };
      }
      renderOutputDataConfig(config) {
        return { OutputDataConfig: { S3OutputPath: config.s3OutputLocation.bind(this, { forWriting: true }).uri, ...config.encryptionKey ? { KmsKeyId: config.encryptionKey.keyArn } : {} } };
      }
      renderResourceConfig(config) {
        return { ResourceConfig: { InstanceCount: config.instanceCount, InstanceType: sfn.JsonPath.isEncodedJsonPath(config.instanceType.toString()) ? config.instanceType.toString() : `ml.${config.instanceType}`, VolumeSizeInGB: config.volumeSize.toGibibytes(), ...config.volumeEncryptionKey ? { VolumeKmsKeyId: config.volumeEncryptionKey.keyArn } : {} } };
      }
      renderStoppingCondition(config) {
        return { StoppingCondition: { MaxRuntimeInSeconds: config.maxRuntime && config.maxRuntime.toSeconds() } };
      }
      renderHyperparameters(params) {
        return params ? { HyperParameters: params } : {};
      }
      renderVpcConfig(config) {
        return config ? { VpcConfig: { SecurityGroupIds: core_1.Lazy.list({ produce: () => this.securityGroups.map((sg) => sg.securityGroupId) }), Subnets: this.subnets } } : {};
      }
      makePolicyStatements() {
        this._grantPrincipal = this._role = this.props.role || new iam.Role(this, "SagemakerRole", { assumedBy: new iam.ServicePrincipal("sagemaker.amazonaws.com"), inlinePolicies: { CreateTrainingJob: new iam.PolicyDocument({ statements: [new iam.PolicyStatement({ actions: ["cloudwatch:PutMetricData", "logs:CreateLogStream", "logs:PutLogEvents", "logs:CreateLogGroup", "logs:DescribeLogStreams", "ecr:GetAuthorizationToken", ...this.props.vpcConfig ? ["ec2:CreateNetworkInterface", "ec2:CreateNetworkInterfacePermission", "ec2:DeleteNetworkInterface", "ec2:DeleteNetworkInterfacePermission", "ec2:DescribeNetworkInterfaces", "ec2:DescribeVpcs", "ec2:DescribeDhcpOptions", "ec2:DescribeSubnets", "ec2:DescribeSecurityGroups"] : []], resources: ["*"] })] }) } }), this.props.outputDataConfig.encryptionKey && this.props.outputDataConfig.encryptionKey.grantEncrypt(this._role), this.props.resourceConfig && this.props.resourceConfig.volumeEncryptionKey && this.props.resourceConfig.volumeEncryptionKey.grant(this._role, "kms:CreateGrant"), this.vpc && this.securityGroup === void 0 && (this.securityGroup = new ec2.SecurityGroup(this, "TrainJobSecurityGroup", { vpc: this.vpc }), this.connections.addSecurityGroup(this.securityGroup), this.securityGroups.push(this.securityGroup));
        const stack = core_1.Stack.of(this), policyStatements = [new iam.PolicyStatement({ actions: ["sagemaker:CreateTrainingJob", "sagemaker:DescribeTrainingJob", "sagemaker:StopTrainingJob"], resources: [stack.formatArn({ service: "sagemaker", resource: "training-job", resourceName: sfn.JsonPath.isEncodedJsonPath(this.props.trainingJobName) ? "*" : `${this.props.trainingJobName}*` })] }), new iam.PolicyStatement({ actions: ["sagemaker:ListTags"], resources: ["*"] }), new iam.PolicyStatement({ actions: ["iam:PassRole"], resources: [this._role.roleArn], conditions: { StringEquals: { "iam:PassedToService": "sagemaker.amazonaws.com" } } })];
        return this.integrationPattern === sfn.IntegrationPattern.RUN_JOB && policyStatements.push(new iam.PolicyStatement({ actions: ["events:PutTargets", "events:PutRule", "events:DescribeRule"], resources: [stack.formatArn({ service: "events", resource: "rule", resourceName: "StepFunctionsGetEventsForSageMakerTrainingJobsRule" })] })), policyStatements;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SageMakerCreateTrainingJob[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.SageMakerCreateTrainingJob", version: "2.80.0" }, SageMakerCreateTrainingJob.SUPPORTED_INTEGRATION_PATTERNS = [sfn.IntegrationPattern.REQUEST_RESPONSE, sfn.IntegrationPattern.RUN_JOB], exports2.SageMakerCreateTrainingJob = SageMakerCreateTrainingJob;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/sagemaker/create-transform-job.js
var require_create_transform_job = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/sagemaker/create-transform-job.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SageMakerCreateTransformJob = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var base_types_1 = require_base_types();
    var utils_1 = require_utils15();
    var ec2 = require_aws_ec2();
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var core_1 = require_core2();
    var task_utils_1 = require_task_utils();
    var SageMakerCreateTransformJob = class _SageMakerCreateTransformJob extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_SageMakerCreateTransformJobProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SageMakerCreateTransformJob), error;
        }
        this.integrationPattern = props.integrationPattern || sfn.IntegrationPattern.REQUEST_RESPONSE, (0, task_utils_1.validatePatternSupported)(this.integrationPattern, _SageMakerCreateTransformJob.SUPPORTED_INTEGRATION_PATTERNS), props.role && (this._role = props.role), this.transformInput = props.transformInput.transformDataSource.s3DataSource.s3DataType ? props.transformInput : Object.assign({}, props.transformInput, { transformDataSource: { s3DataSource: { ...props.transformInput.transformDataSource.s3DataSource, s3DataType: base_types_1.S3DataType.S3_PREFIX } } }), this.transformResources = props.transformResources || { instanceCount: 1, instanceType: ec2.InstanceType.of(ec2.InstanceClass.M4, ec2.InstanceSize.XLARGE) }, this.taskPolicies = this.makePolicyStatements();
      }
      _renderTask() {
        return { Resource: (0, task_utils_1.integrationResourceArn)("sagemaker", "createTransformJob", this.integrationPattern), Parameters: sfn.FieldUtils.renderObject(this.renderParameters()) };
      }
      get role() {
        if (this._role === void 0)
          throw new Error("role not available yet--use the object in a Task first");
        return this._role;
      }
      renderParameters() {
        return { ...this.props.batchStrategy ? { BatchStrategy: this.props.batchStrategy } : {}, ...(0, utils_1.renderEnvironment)(this.props.environment), ...this.props.maxConcurrentTransforms ? { MaxConcurrentTransforms: this.props.maxConcurrentTransforms } : {}, ...this.props.maxPayload ? { MaxPayloadInMB: this.props.maxPayload.toMebibytes() } : {}, ...this.props.modelClientOptions ? this.renderModelClientOptions(this.props.modelClientOptions) : {}, ModelName: this.props.modelName, ...(0, utils_1.renderTags)(this.props.tags), ...this.renderTransformInput(this.transformInput), TransformJobName: this.props.transformJobName, ...this.renderTransformOutput(this.props.transformOutput), ...this.renderTransformResources(this.transformResources) };
      }
      renderModelClientOptions(options) {
        const retries = options.invocationsMaxRetries;
        if (!core_1.Token.isUnresolved(retries) && retries && (retries < 0 || retries > 3))
          throw new Error(`invocationsMaxRetries should be between 0 and 3. Received: ${retries}.`);
        const timeout = options.invocationsTimeout?.toSeconds();
        if (!core_1.Token.isUnresolved(timeout) && timeout && (timeout < 1 || timeout > 3600))
          throw new Error(`invocationsTimeout should be between 1 and 3600 seconds. Received: ${timeout}.`);
        return { ModelClientConfig: { InvocationsMaxRetries: retries ?? 0, InvocationsTimeoutInSeconds: timeout ?? 60 } };
      }
      renderTransformInput(input) {
        return { TransformInput: { ...input.compressionType ? { CompressionType: input.compressionType } : {}, ...input.contentType ? { ContentType: input.contentType } : {}, DataSource: { S3DataSource: { S3Uri: input.transformDataSource.s3DataSource.s3Uri, S3DataType: input.transformDataSource.s3DataSource.s3DataType } }, ...input.splitType ? { SplitType: input.splitType } : {} } };
      }
      renderTransformOutput(output) {
        return { TransformOutput: { S3OutputPath: output.s3OutputPath, ...output.encryptionKey ? { KmsKeyId: output.encryptionKey.keyArn } : {}, ...output.accept ? { Accept: output.accept } : {}, ...output.assembleWith ? { AssembleWith: output.assembleWith } : {} } };
      }
      renderTransformResources(resources) {
        return { TransformResources: { InstanceCount: resources.instanceCount, InstanceType: sfn.JsonPath.isEncodedJsonPath(resources.instanceType.toString()) ? resources.instanceType.toString() : `ml.${resources.instanceType}`, ...resources.volumeEncryptionKey ? { VolumeKmsKeyId: resources.volumeEncryptionKey.keyArn } : {} } };
      }
      makePolicyStatements() {
        const stack = core_1.Stack.of(this);
        this._role === void 0 && (this._role = new iam.Role(this, "SagemakerTransformRole", { assumedBy: new iam.ServicePrincipal("sagemaker.amazonaws.com"), managedPolicies: [iam.ManagedPolicy.fromAwsManagedPolicyName("AmazonSageMakerFullAccess")] }));
        const policyStatements = [new iam.PolicyStatement({ actions: ["sagemaker:CreateTransformJob", "sagemaker:DescribeTransformJob", "sagemaker:StopTransformJob"], resources: [stack.formatArn({ service: "sagemaker", resource: "transform-job", resourceName: "*" })] }), new iam.PolicyStatement({ actions: ["sagemaker:ListTags"], resources: ["*"] }), new iam.PolicyStatement({ actions: ["iam:PassRole"], resources: [this.role.roleArn], conditions: { StringEquals: { "iam:PassedToService": "sagemaker.amazonaws.com" } } })];
        return this.integrationPattern === sfn.IntegrationPattern.RUN_JOB && policyStatements.push(new iam.PolicyStatement({ actions: ["events:PutTargets", "events:PutRule", "events:DescribeRule"], resources: [stack.formatArn({ service: "events", resource: "rule", resourceName: "StepFunctionsGetEventsForSageMakerTransformJobsRule" })] })), policyStatements;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SageMakerCreateTransformJob[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.SageMakerCreateTransformJob", version: "2.80.0" }, SageMakerCreateTransformJob.SUPPORTED_INTEGRATION_PATTERNS = [sfn.IntegrationPattern.REQUEST_RESPONSE, sfn.IntegrationPattern.RUN_JOB], exports2.SageMakerCreateTransformJob = SageMakerCreateTransformJob;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/sagemaker/create-endpoint.js
var require_create_endpoint = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/sagemaker/create-endpoint.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SageMakerCreateEndpoint = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var cdk = require_core2();
    var task_utils_1 = require_task_utils();
    var SageMakerCreateEndpoint = class _SageMakerCreateEndpoint extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_SageMakerCreateEndpointProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SageMakerCreateEndpoint), error;
        }
        this.integrationPattern = props.integrationPattern || sfn.IntegrationPattern.REQUEST_RESPONSE, (0, task_utils_1.validatePatternSupported)(this.integrationPattern, _SageMakerCreateEndpoint.SUPPORTED_INTEGRATION_PATTERNS), this.taskPolicies = this.makePolicyStatements();
      }
      _renderTask() {
        return { Resource: (0, task_utils_1.integrationResourceArn)("sagemaker", "createEndpoint", this.integrationPattern), Parameters: sfn.FieldUtils.renderObject(this.renderParameters()) };
      }
      renderParameters() {
        return { EndpointConfigName: this.props.endpointConfigName, EndpointName: this.props.endpointName, Tags: this.props.tags?.value };
      }
      makePolicyStatements() {
        const stack = cdk.Stack.of(this);
        return [new iam.PolicyStatement({ actions: ["sagemaker:createEndpoint"], resources: [stack.formatArn({ service: "sagemaker", resource: "endpoint", resourceName: sfn.JsonPath.isEncodedJsonPath(this.props.endpointName) ? "*" : `${this.props.endpointName.toLowerCase()}` }), stack.formatArn({ service: "sagemaker", resource: "endpoint-config", resourceName: sfn.JsonPath.isEncodedJsonPath(this.props.endpointConfigName) ? "*" : `${this.props.endpointConfigName.toLowerCase()}` })] }), new iam.PolicyStatement({ actions: ["sagemaker:ListTags"], resources: ["*"] })];
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SageMakerCreateEndpoint[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.SageMakerCreateEndpoint", version: "2.80.0" }, SageMakerCreateEndpoint.SUPPORTED_INTEGRATION_PATTERNS = [sfn.IntegrationPattern.REQUEST_RESPONSE], exports2.SageMakerCreateEndpoint = SageMakerCreateEndpoint;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/sagemaker/create-endpoint-config.js
var require_create_endpoint_config = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/sagemaker/create-endpoint-config.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SageMakerCreateEndpointConfig = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var cdk = require_core2();
    var task_utils_1 = require_task_utils();
    var SageMakerCreateEndpointConfig = class _SageMakerCreateEndpointConfig extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_SageMakerCreateEndpointConfigProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SageMakerCreateEndpointConfig), error;
        }
        this.integrationPattern = props.integrationPattern || sfn.IntegrationPattern.REQUEST_RESPONSE, (0, task_utils_1.validatePatternSupported)(this.integrationPattern, _SageMakerCreateEndpointConfig.SUPPORTED_INTEGRATION_PATTERNS), this.validateProductionVariants(), this.taskPolicies = this.makePolicyStatements();
      }
      _renderTask() {
        return { Resource: (0, task_utils_1.integrationResourceArn)("sagemaker", "createEndpointConfig", this.integrationPattern), Parameters: sfn.FieldUtils.renderObject(this.renderParameters()) };
      }
      renderParameters() {
        return { EndpointConfigName: this.props.endpointConfigName, Tags: this.props.tags?.value, KmsKeyId: this.props.kmsKey?.keyId, ProductionVariants: this.props.productionVariants.map((variant) => ({ InitialInstanceCount: variant.initialInstanceCount ? variant.initialInstanceCount : 1, InstanceType: sfn.JsonPath.isEncodedJsonPath(variant.instanceType.toString()) ? variant.instanceType.toString() : `ml.${variant.instanceType}`, ModelName: variant.modelName, VariantName: variant.variantName, AcceleratorType: variant.acceleratorType, InitialVariantWeight: variant.initialVariantWeight })) };
      }
      makePolicyStatements() {
        const stack = cdk.Stack.of(this);
        return [new iam.PolicyStatement({ actions: ["sagemaker:CreateEndpointConfig"], resources: [stack.formatArn({ service: "sagemaker", resource: "endpoint-config", resourceName: sfn.JsonPath.isEncodedJsonPath(this.props.endpointConfigName) ? "*" : `${this.props.endpointConfigName.toLowerCase()}` })] }), new iam.PolicyStatement({ actions: ["sagemaker:ListTags"], resources: ["*"] })];
      }
      validateProductionVariants() {
        if (this.props.productionVariants.length < 1 || this.props.productionVariants.length > 10)
          throw new Error("Must specify from 1 to 10 production variants per endpoint configuration");
        this.props.productionVariants.forEach((variant) => {
          if (variant.initialInstanceCount && variant.initialInstanceCount < 1)
            throw new Error("Must define at least one instance");
          if (variant.initialVariantWeight && variant.initialVariantWeight <= 0)
            throw new Error("InitialVariantWeight has minimum value of 0");
        });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SageMakerCreateEndpointConfig[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.SageMakerCreateEndpointConfig", version: "2.80.0" }, SageMakerCreateEndpointConfig.SUPPORTED_INTEGRATION_PATTERNS = [sfn.IntegrationPattern.REQUEST_RESPONSE], exports2.SageMakerCreateEndpointConfig = SageMakerCreateEndpointConfig;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/sagemaker/create-model.js
var require_create_model = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/sagemaker/create-model.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SageMakerCreateModel = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var ec2 = require_aws_ec2();
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var cdk = require_core2();
    var task_utils_1 = require_task_utils();
    var SageMakerCreateModel = class _SageMakerCreateModel extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props, this.connections = new ec2.Connections(), this.securityGroups = [];
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_SageMakerCreateModelProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SageMakerCreateModel), error;
        }
        this.integrationPattern = props.integrationPattern || sfn.IntegrationPattern.REQUEST_RESPONSE, (0, task_utils_1.validatePatternSupported)(this.integrationPattern, _SageMakerCreateModel.SUPPORTED_INTEGRATION_PATTERNS), props.vpc && (this.vpc = props.vpc, this.subnets = props.subnetSelection ? this.vpc.selectSubnets(props.subnetSelection).subnetIds : this.vpc.selectSubnets().subnetIds), this.role = this.props.role || this.createSagemakerRole(), this.grantPrincipal = this.role, this.taskPolicies = this.makePolicyStatements();
      }
      addSecurityGroup(securityGroup) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ec2_ISecurityGroup(securityGroup);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addSecurityGroup), error;
        }
        this.securityGroups.push(securityGroup);
      }
      _renderTask() {
        return { Resource: (0, task_utils_1.integrationResourceArn)("sagemaker", "createModel", this.integrationPattern), Parameters: sfn.FieldUtils.renderObject(this.renderParameters()) };
      }
      renderParameters() {
        return { EnableNetworkIsolation: this.props.enableNetworkIsolation, ExecutionRoleArn: this.role.roleArn, ModelName: this.props.modelName, Tags: this.props.tags?.value, PrimaryContainer: this.props.primaryContainer.bind(this).parameters, Containers: this.props.containers?.map((container) => container.bind(this)), ...this.renderVpcConfig() };
      }
      makePolicyStatements() {
        const stack = cdk.Stack.of(this);
        return [new iam.PolicyStatement({ actions: ["sagemaker:CreateModel"], resources: [stack.formatArn({ service: "sagemaker", resource: "model", resourceName: sfn.JsonPath.isEncodedJsonPath(this.props.modelName) ? "*" : `${this.props.modelName.toLowerCase()}*` })] }), new iam.PolicyStatement({ actions: ["sagemaker:ListTags"], resources: ["*"] }), new iam.PolicyStatement({ actions: ["iam:PassRole"], resources: [this.role.roleArn], conditions: { StringEquals: { "iam:PassedToService": "sagemaker.amazonaws.com" } } })];
      }
      createSagemakerRole() {
        const role = new iam.Role(this, "SagemakerRole", { assumedBy: new iam.ServicePrincipal("sagemaker.amazonaws.com"), inlinePolicies: { CreateModel: new iam.PolicyDocument({ statements: [new iam.PolicyStatement({ actions: ["cloudwatch:PutMetricData", "logs:CreateLogStream", "logs:CreateLogGroup", "logs:PutLogEvents", "logs:DescribeLogStreams", "ecr:GetAuthorizationToken"], resources: ["*"] })] }) } });
        return this.props.vpc && role.addToPrincipalPolicy(new iam.PolicyStatement({ actions: ["ec2:CreateNetworkInterface", "ec2:CreateNetworkInterfacePermission", "ec2:DeleteNetworkInterface", "ec2:DeleteNetworkInterfacePermission", "ec2:DescribeNetworkInterfaces", "ec2:DescribeVpcs", "ec2:DescribeDhcpOptions", "ec2:DescribeSubnets", "ec2:DescribeSecurityGroups"], resources: ["*"] })), role;
      }
      renderVpcConfig() {
        return this.vpc && this.securityGroup === void 0 && (this.securityGroup = new ec2.SecurityGroup(this, "ModelSecurityGroup", { vpc: this.vpc }), this.connections.addSecurityGroup(this.securityGroup), this.securityGroups.push(this.securityGroup)), this.vpc ? { VpcConfig: { SecurityGroupIds: cdk.Lazy.list({ produce: () => this.securityGroups.map((sg) => sg.securityGroupId) }), Subnets: this.subnets } } : {};
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SageMakerCreateModel[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.SageMakerCreateModel", version: "2.80.0" }, SageMakerCreateModel.SUPPORTED_INTEGRATION_PATTERNS = [sfn.IntegrationPattern.REQUEST_RESPONSE], exports2.SageMakerCreateModel = SageMakerCreateModel;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/sagemaker/update-endpoint.js
var require_update_endpoint = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/sagemaker/update-endpoint.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SageMakerUpdateEndpoint = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var cdk = require_core2();
    var task_utils_1 = require_task_utils();
    var SageMakerUpdateEndpoint = class _SageMakerUpdateEndpoint extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_SageMakerUpdateEndpointProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _SageMakerUpdateEndpoint), error;
        }
        this.integrationPattern = props.integrationPattern || sfn.IntegrationPattern.REQUEST_RESPONSE, (0, task_utils_1.validatePatternSupported)(this.integrationPattern, _SageMakerUpdateEndpoint.SUPPORTED_INTEGRATION_PATTERNS), this.taskPolicies = this.makePolicyStatements();
      }
      _renderTask() {
        return { Resource: (0, task_utils_1.integrationResourceArn)("sagemaker", "updateEndpoint", this.integrationPattern), Parameters: sfn.FieldUtils.renderObject(this.renderParameters()) };
      }
      renderParameters() {
        return { EndpointConfigName: this.props.endpointConfigName, EndpointName: this.props.endpointName };
      }
      makePolicyStatements() {
        const stack = cdk.Stack.of(this);
        return [new iam.PolicyStatement({ actions: ["sagemaker:updateEndpoint"], resources: [stack.formatArn({ service: "sagemaker", resource: "endpoint", resourceName: sfn.JsonPath.isEncodedJsonPath(this.props.endpointName) ? "*" : `${this.props.endpointName.toLowerCase()}` }), stack.formatArn({ service: "sagemaker", resource: "endpoint-config", resourceName: sfn.JsonPath.isEncodedJsonPath(this.props.endpointConfigName) ? "*" : `${this.props.endpointConfigName.toLowerCase()}` })] })];
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SageMakerUpdateEndpoint[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.SageMakerUpdateEndpoint", version: "2.80.0" }, SageMakerUpdateEndpoint.SUPPORTED_INTEGRATION_PATTERNS = [sfn.IntegrationPattern.REQUEST_RESPONSE], exports2.SageMakerUpdateEndpoint = SageMakerUpdateEndpoint;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/start-execution.js
var require_start_execution = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/start-execution.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.StartExecution = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var resource_arn_suffix_1 = require_resource_arn_suffix();
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var core_1 = require_core2();
    var StartExecution = class {
      constructor(stateMachine, props = {}) {
        if (this.stateMachine = stateMachine, this.props = props, this.integrationPattern = props.integrationPattern || sfn.ServiceIntegrationPattern.FIRE_AND_FORGET, ![sfn.ServiceIntegrationPattern.FIRE_AND_FORGET, sfn.ServiceIntegrationPattern.SYNC, sfn.ServiceIntegrationPattern.WAIT_FOR_TASK_TOKEN].includes(this.integrationPattern))
          throw new Error(`Invalid Service Integration Pattern: ${this.integrationPattern} is not supported to call Step Functions.`);
        if (this.integrationPattern === sfn.ServiceIntegrationPattern.WAIT_FOR_TASK_TOKEN && !sfn.FieldUtils.containsTaskToken(props.input))
          throw new Error("Task Token is missing in input (pass JsonPath.taskToken somewhere in input)");
      }
      bind(task) {
        return { resourceArn: (0, resource_arn_suffix_1.getResourceArn)("states", "startExecution", this.integrationPattern), policyStatements: this.createScopedAccessPolicy(task), parameters: { Input: this.props.input, StateMachineArn: this.stateMachine.stateMachineArn, Name: this.props.name } };
      }
      createScopedAccessPolicy(task) {
        const stack = core_1.Stack.of(task), policyStatements = [new iam.PolicyStatement({ actions: ["states:StartExecution"], resources: [this.stateMachine.stateMachineArn] })];
        return this.integrationPattern === sfn.ServiceIntegrationPattern.SYNC && (policyStatements.push(new iam.PolicyStatement({ actions: ["states:DescribeExecution", "states:StopExecution"], resources: [stack.formatArn({ service: "states", resource: "execution", arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME, resourceName: `${stack.splitArn(this.stateMachine.stateMachineArn, core_1.ArnFormat.COLON_RESOURCE_NAME).resourceName}*` })] })), policyStatements.push(new iam.PolicyStatement({ actions: ["events:PutTargets", "events:PutRule", "events:DescribeRule"], resources: [stack.formatArn({ service: "events", resource: "rule", resourceName: "StepFunctionsGetEventsForStepFunctionsExecutionRule" })] }))), policyStatements;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, StartExecution[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.StartExecution", version: "2.80.0" }, exports2.StartExecution = StartExecution;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/stepfunctions/start-execution.js
var require_start_execution2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/stepfunctions/start-execution.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.StepFunctionsStartExecution = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var core_1 = require_core2();
    var task_utils_1 = require_task_utils();
    var StepFunctionsStartExecution = class _StepFunctionsStartExecution extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_StepFunctionsStartExecutionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _StepFunctionsStartExecution), error;
        }
        if (this.integrationPattern = props.integrationPattern || sfn.IntegrationPattern.REQUEST_RESPONSE, (0, task_utils_1.validatePatternSupported)(this.integrationPattern, _StepFunctionsStartExecution.SUPPORTED_INTEGRATION_PATTERNS), this.integrationPattern === sfn.IntegrationPattern.WAIT_FOR_TASK_TOKEN && !sfn.FieldUtils.containsTaskToken(props.input))
          throw new Error("Task Token is required in `input` for callback. Use JsonPath.taskToken to set the token.");
        if (this.props.associateWithParent && props.input && props.input.type !== sfn.InputType.OBJECT)
          throw new Error("Could not enable `associateWithParent` because `input` is taken directly from a JSON path. Use `sfn.TaskInput.fromObject` instead.");
        this.taskPolicies = this.createScopedAccessPolicy();
      }
      _renderTask() {
        const suffix = this.integrationPattern === sfn.IntegrationPattern.RUN_JOB ? ":2" : "";
        let input;
        if (this.props.associateWithParent) {
          const associateWithParentEntry = { AWS_STEP_FUNCTIONS_STARTED_BY_EXECUTION_ID: sfn.JsonPath.stringAt("$$.Execution.Id") };
          input = this.props.input ? { ...this.props.input.value, ...associateWithParentEntry } : associateWithParentEntry;
        } else
          input = this.props.input ? this.props.input.value : sfn.TaskInput.fromJsonPathAt("$").value;
        return { Resource: `${(0, task_utils_1.integrationResourceArn)("states", "startExecution", this.integrationPattern)}${suffix}`, Parameters: sfn.FieldUtils.renderObject({ Input: input, StateMachineArn: this.props.stateMachine.stateMachineArn, Name: this.props.name }) };
      }
      createScopedAccessPolicy() {
        const stack = core_1.Stack.of(this), policyStatements = [new iam.PolicyStatement({ actions: ["states:StartExecution"], resources: [this.props.stateMachine.stateMachineArn] })];
        return this.integrationPattern === sfn.IntegrationPattern.RUN_JOB && (policyStatements.push(new iam.PolicyStatement({ actions: ["states:DescribeExecution", "states:StopExecution"], resources: [stack.formatArn({ service: "states", resource: "execution", arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME, resourceName: `${stack.splitArn(this.props.stateMachine.stateMachineArn, core_1.ArnFormat.COLON_RESOURCE_NAME).resourceName}*` })] })), policyStatements.push(new iam.PolicyStatement({ actions: ["events:PutTargets", "events:PutRule", "events:DescribeRule"], resources: [stack.formatArn({ service: "events", resource: "rule", resourceName: "StepFunctionsGetEventsForStepFunctionsExecutionRule" })] }))), policyStatements;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, StepFunctionsStartExecution[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.StepFunctionsStartExecution", version: "2.80.0" }, StepFunctionsStartExecution.SUPPORTED_INTEGRATION_PATTERNS = [sfn.IntegrationPattern.REQUEST_RESPONSE, sfn.IntegrationPattern.RUN_JOB, sfn.IntegrationPattern.WAIT_FOR_TASK_TOKEN], exports2.StepFunctionsStartExecution = StepFunctionsStartExecution;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/stepfunctions/invoke-activity.js
var require_invoke_activity2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/stepfunctions/invoke-activity.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.StepFunctionsInvokeActivity = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var sfn = require_aws_stepfunctions();
    var StepFunctionsInvokeActivity = class _StepFunctionsInvokeActivity extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_StepFunctionsInvokeActivityProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _StepFunctionsInvokeActivity), error;
        }
        this.taskMetrics = { metricDimensions: { ActivityArn: this.props.activity.activityArn }, metricPrefixSingular: "Activity", metricPrefixPlural: "Activities" };
      }
      _renderTask() {
        return { Resource: this.props.activity.activityArn, Parameters: this.props.parameters ? sfn.FieldUtils.renderObject(this.props.parameters) : void 0 };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, StepFunctionsInvokeActivity[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.StepFunctionsInvokeActivity", version: "2.80.0" }, exports2.StepFunctionsInvokeActivity = StepFunctionsInvokeActivity;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/evaluate-expression.js
var require_evaluate_expression = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/evaluate-expression.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EvaluateExpression = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var path = require("path");
    var iam = require_aws_iam();
    var lambda2 = require_aws_lambda();
    var sfn = require_aws_stepfunctions();
    var custom_resources_1 = require_custom_resources();
    var EvaluateExpression = class _EvaluateExpression extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_EvaluateExpressionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EvaluateExpression), error;
        }
        this.evalFn = createEvalFn(this.props.runtime, this), this.taskPolicies = [new iam.PolicyStatement({ resources: this.evalFn.resourceArnsForGrantInvoke, actions: ["lambda:InvokeFunction"] })];
      }
      _renderTask() {
        const matches = this.props.expression.match(/\$[.\[][.a-zA-Z[\]0-9-_]+/g);
        let expressionAttributeValues = {};
        matches && (expressionAttributeValues = matches.reduce((acc, m) => ({ ...acc, [m]: sfn.JsonPath.stringAt(m) }), {}));
        const parameters = { expression: this.props.expression, expressionAttributeValues };
        return { Resource: this.evalFn.functionArn, Parameters: sfn.FieldUtils.renderObject(parameters) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EvaluateExpression[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.EvaluateExpression", version: "2.80.0" }, exports2.EvaluateExpression = EvaluateExpression;
    function createEvalFn(runtime, scope) {
      const lambdaPurpose = "Eval", nodeJsGuids = { [lambda2.Runtime.NODEJS_18_X.name]: "078d40d3-fb4e-4d53-94a7-9c46fc11fe02", [lambda2.Runtime.NODEJS_16_X.name]: "2a430b68-eb4b-4026-9232-ee39b71c1db8", [lambda2.Runtime.NODEJS_14_X.name]: "da2d1181-604e-4a45-8694-1a6abd7fe42d", [lambda2.Runtime.NODEJS_12_X.name]: "2b81e383-aad2-44db-8aaf-b4809ae0e3b4", [lambda2.Runtime.NODEJS_10_X.name]: "a0d2ce44-871b-4e74-87a1-f5e63d7c3bdc" };
      let uuid;
      if (runtime)
        switch (runtime?.name) {
          case lambda2.Runtime.NODEJS_18_X.name:
          case lambda2.Runtime.NODEJS_16_X.name:
          case lambda2.Runtime.NODEJS_14_X.name:
          case lambda2.Runtime.NODEJS_12_X.name:
          case lambda2.Runtime.NODEJS_10_X.name:
            uuid = nodeJsGuids[runtime.name];
            break;
        }
      else
        uuid = "41256dc5-4457-4273-8ed9-17bc818694e5";
      if (uuid)
        return new lambda2.SingletonFunction(scope, "EvalFunction", { runtime: runtime ?? (0, custom_resources_1.builtInCustomResourceNodeRuntime)(scope), uuid, handler: "index.handler", lambdaPurpose, code: lambda2.Code.fromAsset(path.join(__dirname, "eval-nodejs-handler"), { exclude: ["*.ts"] }) });
      throw new Error(`The runtime ${runtime?.name} is currently not supported.`);
    }
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/emr/private/cluster-utils.js
var require_cluster_utils = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/emr/private/cluster-utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.InstanceGroupModifyConfigPropertyToJson = exports2.BootstrapActionConfigToJson = exports2.PlacementTypePropertyToJson = exports2.InstanceGroupConfigPropertyToJson = exports2.AutoScalingPolicyPropertyToJson = exports2.ScalingRulePropertyToJson = exports2.ScalingActionPropertyToJson = exports2.ScalingTriggerPropertyToJson = exports2.MetricDimensionPropertyToJson = exports2.InstanceFleetConfigPropertyToJson = exports2.InstanceFleetProvisioningSpecificationsPropertyToJson = exports2.InstanceTypeConfigPropertyToJson = exports2.EbsConfigurationPropertyToJson = exports2.EbsBlockDeviceConfigPropertyToJson = exports2.ConfigurationPropertyToJson = exports2.ApplicationConfigPropertyToJson = exports2.InstancesConfigPropertyToJson = exports2.KerberosAttributesPropertyToJson = void 0;
    var cdk = require_core2();
    function KerberosAttributesPropertyToJson(property) {
      return { ADDomainJoinPassword: cdk.stringToCloudFormation(property.adDomainJoinPassword), ADDomainJoinUser: cdk.stringToCloudFormation(property.adDomainJoinUser), CrossRealmTrustPrincipalPassword: cdk.stringToCloudFormation(property.crossRealmTrustPrincipalPassword), KdcAdminPassword: cdk.stringToCloudFormation(property.kdcAdminPassword), Realm: cdk.stringToCloudFormation(property.realm) };
    }
    exports2.KerberosAttributesPropertyToJson = KerberosAttributesPropertyToJson;
    function InstancesConfigPropertyToJson(property) {
      return { AdditionalMasterSecurityGroups: cdk.listMapper(cdk.stringToCloudFormation)(property.additionalMasterSecurityGroups), AdditionalSlaveSecurityGroups: cdk.listMapper(cdk.stringToCloudFormation)(property.additionalSlaveSecurityGroups), Ec2KeyName: cdk.stringToCloudFormation(property.ec2KeyName), Ec2SubnetId: cdk.stringToCloudFormation(property.ec2SubnetId), Ec2SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(property.ec2SubnetIds), EmrManagedMasterSecurityGroup: cdk.stringToCloudFormation(property.emrManagedMasterSecurityGroup), EmrManagedSlaveSecurityGroup: cdk.stringToCloudFormation(property.emrManagedSlaveSecurityGroup), HadoopVersion: cdk.stringToCloudFormation(property.hadoopVersion), InstanceCount: cdk.numberToCloudFormation(property.instanceCount), InstanceFleets: cdk.listMapper(InstanceFleetConfigPropertyToJson)(property.instanceFleets), InstanceGroups: cdk.listMapper(InstanceGroupConfigPropertyToJson)(property.instanceGroups), KeepJobFlowAliveWhenNoSteps: true, MasterInstanceType: cdk.stringToCloudFormation(property.masterInstanceType), Placement: property.placement === void 0 ? property.placement : PlacementTypePropertyToJson(property.placement), ServiceAccessSecurityGroup: cdk.stringToCloudFormation(property.serviceAccessSecurityGroup), SlaveInstanceType: cdk.stringToCloudFormation(property.slaveInstanceType), TerminationProtected: cdk.booleanToCloudFormation(property.terminationProtected) };
    }
    exports2.InstancesConfigPropertyToJson = InstancesConfigPropertyToJson;
    function ApplicationConfigPropertyToJson(property) {
      return { Name: cdk.stringToCloudFormation(property.name), Args: cdk.listMapper(cdk.stringToCloudFormation)(property.args), Version: cdk.stringToCloudFormation(property.version), AdditionalInfo: cdk.objectToCloudFormation(property.additionalInfo) };
    }
    exports2.ApplicationConfigPropertyToJson = ApplicationConfigPropertyToJson;
    function ConfigurationPropertyToJson(property) {
      return { Classification: cdk.stringToCloudFormation(property.classification), Properties: cdk.objectToCloudFormation(property.properties), Configurations: cdk.listMapper(ConfigurationPropertyToJson)(property.configurations) };
    }
    exports2.ConfigurationPropertyToJson = ConfigurationPropertyToJson;
    function EbsBlockDeviceConfigPropertyToJson(property) {
      return { VolumeSpecification: { Iops: cdk.numberToCloudFormation(property.volumeSpecification.iops), SizeInGB: property.volumeSpecification.volumeSize?.toGibibytes(), VolumeType: cdk.stringToCloudFormation(property.volumeSpecification.volumeType?.valueOf()) }, VolumesPerInstance: cdk.numberToCloudFormation(property.volumesPerInstance) };
    }
    exports2.EbsBlockDeviceConfigPropertyToJson = EbsBlockDeviceConfigPropertyToJson;
    function EbsConfigurationPropertyToJson(property) {
      return { EbsBlockDeviceConfigs: cdk.listMapper(EbsBlockDeviceConfigPropertyToJson)(property.ebsBlockDeviceConfigs), EbsOptimized: cdk.booleanToCloudFormation(property.ebsOptimized) };
    }
    exports2.EbsConfigurationPropertyToJson = EbsConfigurationPropertyToJson;
    function InstanceTypeConfigPropertyToJson(property) {
      return { BidPrice: cdk.stringToCloudFormation(property.bidPrice), BidPriceAsPercentageOfOnDemandPrice: cdk.numberToCloudFormation(property.bidPriceAsPercentageOfOnDemandPrice), Configurations: cdk.listMapper(ConfigurationPropertyToJson)(property.configurations), EbsConfiguration: property.ebsConfiguration === void 0 ? property.ebsConfiguration : EbsConfigurationPropertyToJson(property.ebsConfiguration), InstanceType: cdk.stringToCloudFormation(property.instanceType?.valueOf()), WeightedCapacity: cdk.numberToCloudFormation(property.weightedCapacity) };
    }
    exports2.InstanceTypeConfigPropertyToJson = InstanceTypeConfigPropertyToJson;
    function InstanceFleetProvisioningSpecificationsPropertyToJson(property) {
      return { SpotSpecification: { AllocationStrategy: cdk.stringToCloudFormation(property.spotSpecification.allocationStrategy), BlockDurationMinutes: cdk.numberToCloudFormation(property.spotSpecification.blockDurationMinutes), TimeoutAction: cdk.stringToCloudFormation(property.spotSpecification.timeoutAction?.valueOf()), TimeoutDurationMinutes: cdk.numberToCloudFormation(property.spotSpecification.timeoutDurationMinutes) } };
    }
    exports2.InstanceFleetProvisioningSpecificationsPropertyToJson = InstanceFleetProvisioningSpecificationsPropertyToJson;
    function InstanceFleetConfigPropertyToJson(property) {
      return { InstanceFleetType: cdk.stringToCloudFormation(property.instanceFleetType?.valueOf()), InstanceTypeConfigs: cdk.listMapper(InstanceTypeConfigPropertyToJson)(property.instanceTypeConfigs), LaunchSpecifications: property.launchSpecifications === void 0 ? property.launchSpecifications : InstanceFleetProvisioningSpecificationsPropertyToJson(property.launchSpecifications), Name: cdk.stringToCloudFormation(property.name), TargetOnDemandCapacity: cdk.numberToCloudFormation(property.targetOnDemandCapacity), TargetSpotCapacity: cdk.numberToCloudFormation(property.targetSpotCapacity) };
    }
    exports2.InstanceFleetConfigPropertyToJson = InstanceFleetConfigPropertyToJson;
    function MetricDimensionPropertyToJson(property) {
      return { Key: cdk.stringToCloudFormation(property.key), Value: cdk.stringToCloudFormation(property.value) };
    }
    exports2.MetricDimensionPropertyToJson = MetricDimensionPropertyToJson;
    function ScalingTriggerPropertyToJson(property) {
      return { CloudWatchAlarmDefinition: { ComparisonOperator: cdk.stringToCloudFormation(property.cloudWatchAlarmDefinition.comparisonOperator?.valueOf()), Dimensions: cdk.listMapper(MetricDimensionPropertyToJson)(property.cloudWatchAlarmDefinition.dimensions), EvaluationPeriods: cdk.numberToCloudFormation(property.cloudWatchAlarmDefinition.evaluationPeriods), MetricName: cdk.stringToCloudFormation(property.cloudWatchAlarmDefinition.metricName), Namespace: cdk.stringToCloudFormation(property.cloudWatchAlarmDefinition.namespace), Period: cdk.numberToCloudFormation(property.cloudWatchAlarmDefinition.period.toSeconds()), Statistic: cdk.stringToCloudFormation(property.cloudWatchAlarmDefinition.statistic?.valueOf()), Threshold: cdk.numberToCloudFormation(property.cloudWatchAlarmDefinition.threshold), Unit: cdk.stringToCloudFormation(property.cloudWatchAlarmDefinition.unit?.valueOf()) } };
    }
    exports2.ScalingTriggerPropertyToJson = ScalingTriggerPropertyToJson;
    function ScalingActionPropertyToJson(property) {
      return { Market: cdk.stringToCloudFormation(property.market?.valueOf()), SimpleScalingPolicyConfiguration: { AdjustmentType: cdk.stringToCloudFormation(property.simpleScalingPolicyConfiguration.adjustmentType), CoolDown: cdk.numberToCloudFormation(property.simpleScalingPolicyConfiguration.coolDown), ScalingAdjustment: cdk.numberToCloudFormation(property.simpleScalingPolicyConfiguration.scalingAdjustment) } };
    }
    exports2.ScalingActionPropertyToJson = ScalingActionPropertyToJson;
    function ScalingRulePropertyToJson(property) {
      return { Action: ScalingActionPropertyToJson(property.action), Description: cdk.stringToCloudFormation(property.description), Name: cdk.stringToCloudFormation(property.name), Trigger: ScalingTriggerPropertyToJson(property.trigger) };
    }
    exports2.ScalingRulePropertyToJson = ScalingRulePropertyToJson;
    function AutoScalingPolicyPropertyToJson(property) {
      return { Constraints: { MaxCapacity: cdk.numberToCloudFormation(property.constraints.maxCapacity), MinCapacity: cdk.numberToCloudFormation(property.constraints.minCapacity) }, Rules: cdk.listMapper(ScalingRulePropertyToJson)(property.rules) };
    }
    exports2.AutoScalingPolicyPropertyToJson = AutoScalingPolicyPropertyToJson;
    function InstanceGroupConfigPropertyToJson(property) {
      return { AutoScalingPolicy: property.autoScalingPolicy === void 0 ? property.autoScalingPolicy : AutoScalingPolicyPropertyToJson(property.autoScalingPolicy), BidPrice: cdk.numberToCloudFormation(property.bidPrice), Configurations: cdk.listMapper(ConfigurationPropertyToJson)(property.configurations), EbsConfiguration: property.ebsConfiguration === void 0 ? property.ebsConfiguration : EbsConfigurationPropertyToJson(property.ebsConfiguration), InstanceCount: cdk.numberToCloudFormation(property.instanceCount), InstanceRole: cdk.stringToCloudFormation(property.instanceRole?.valueOf()), InstanceType: cdk.stringToCloudFormation(property.instanceType), Market: cdk.stringToCloudFormation(property.market?.valueOf()), Name: cdk.stringToCloudFormation(property.name) };
    }
    exports2.InstanceGroupConfigPropertyToJson = InstanceGroupConfigPropertyToJson;
    function PlacementTypePropertyToJson(property) {
      return { AvailabilityZone: cdk.stringToCloudFormation(property.availabilityZone), AvailabilityZones: cdk.listMapper(cdk.stringToCloudFormation)(property.availabilityZones) };
    }
    exports2.PlacementTypePropertyToJson = PlacementTypePropertyToJson;
    function BootstrapActionConfigToJson(property) {
      return { Name: cdk.stringToCloudFormation(property.name), ScriptBootstrapAction: { Path: cdk.stringToCloudFormation(property.scriptBootstrapAction.path), Args: cdk.listMapper(cdk.stringToCloudFormation)(property.scriptBootstrapAction.args) } };
    }
    exports2.BootstrapActionConfigToJson = BootstrapActionConfigToJson;
    function InstanceGroupModifyConfigPropertyToJson(property) {
      return { Configurations: cdk.listMapper(ConfigurationPropertyToJson)(property.configurations), EC2InstanceIdsToTerminate: cdk.listMapper(cdk.stringToCloudFormation)(property.eC2InstanceIdsToTerminate), InstanceCount: cdk.numberToCloudFormation(property.instanceCount), ShrinkPolicy: property.shrinkPolicy === void 0 ? property.shrinkPolicy : ShrinkPolicyPropertyToJson(property.shrinkPolicy) };
    }
    exports2.InstanceGroupModifyConfigPropertyToJson = InstanceGroupModifyConfigPropertyToJson;
    function ShrinkPolicyPropertyToJson(property) {
      return { DecommissionTimeout: cdk.numberToCloudFormation(property.decommissionTimeout?.toSeconds()), InstanceResizePolicy: property.instanceResizePolicy ? InstanceResizePolicyPropertyToJson(property.instanceResizePolicy) : void 0 };
    }
    function InstanceResizePolicyPropertyToJson(property) {
      return { InstancesToProtect: cdk.listMapper(cdk.stringToCloudFormation)(property.instancesToProtect), InstancesToTerminate: cdk.listMapper(cdk.stringToCloudFormation)(property.instancesToTerminate), InstanceTerminationTimeout: cdk.numberToCloudFormation(property.instanceTerminationTimeout?.toSeconds()) };
    }
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/emr/emr-create-cluster.js
var require_emr_create_cluster = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/emr/emr-create-cluster.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EmrCreateCluster = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cluster_utils_1 = require_cluster_utils();
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var cdk = require_core2();
    var cx_api_1 = require_cx_api();
    var task_utils_1 = require_task_utils();
    var EmrCreateCluster = class _EmrCreateCluster extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_EmrCreateClusterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EmrCreateCluster), error;
        }
        if (this.visibleToAllUsers = this.props.visibleToAllUsers ?? true, this.integrationPattern = props.integrationPattern || sfn.IntegrationPattern.RUN_JOB, (0, task_utils_1.validatePatternSupported)(this.integrationPattern, _EmrCreateCluster.SUPPORTED_INTEGRATION_PATTERNS), this._autoScalingRole = this.props.autoScalingRole, this._serviceRole = this.props.serviceRole ?? this.createServiceRole(), this._clusterRole = this.props.clusterRole ?? this.createClusterRole(), this.props.instances.instanceFleets === void 0 || this.props.instances.instanceFleets.length === 0)
          this._autoScalingRole = this._autoScalingRole || this.createAutoScalingRole();
        else if (this._autoScalingRole !== void 0)
          throw new Error("Auto Scaling roles can not be specified with instance fleets.");
        if (this.taskPolicies = this.createPolicyStatements(this._serviceRole, this._clusterRole, this._autoScalingRole), this.props.releaseLabel !== void 0 && !cdk.Token.isUnresolved(this.props.releaseLabel) && this.validateReleaseLabel(this.props.releaseLabel), this.props.stepConcurrencyLevel !== void 0 && !cdk.Token.isUnresolved(this.props.stepConcurrencyLevel)) {
          if (this.props.stepConcurrencyLevel < 1 || this.props.stepConcurrencyLevel > 256)
            throw new Error(`Step concurrency level must be in range [1, 256], but got ${this.props.stepConcurrencyLevel}.`);
          if (this.props.releaseLabel && this.props.stepConcurrencyLevel !== 1) {
            const [major, minor] = this.props.releaseLabel.slice(4).split(".");
            if (Number(major) < 5 || Number(major) === 5 && Number(minor) < 28)
              throw new Error(`Step concurrency is only supported in EMR release version 5.28.0 and above but got ${this.props.releaseLabel}.`);
          }
        }
      }
      get serviceRole() {
        if (this._serviceRole === void 0)
          throw new Error("role not available yet--use the object in a Task first");
        return this._serviceRole;
      }
      get clusterRole() {
        if (this._clusterRole === void 0)
          throw new Error("role not available yet--use the object in a Task first");
        return this._clusterRole;
      }
      get autoScalingRole() {
        if (this._autoScalingRole === void 0)
          throw new Error("role not available yet--use the object in a Task first");
        return this._autoScalingRole;
      }
      _renderTask() {
        return { Resource: (0, task_utils_1.integrationResourceArn)("elasticmapreduce", "createCluster", this.integrationPattern), Parameters: sfn.FieldUtils.renderObject({ Instances: (0, cluster_utils_1.InstancesConfigPropertyToJson)(this.props.instances), JobFlowRole: cdk.stringToCloudFormation(this._clusterRole.roleName), Name: cdk.stringToCloudFormation(this.props.name), ServiceRole: cdk.stringToCloudFormation(this._serviceRole.roleName), AdditionalInfo: cdk.stringToCloudFormation(this.props.additionalInfo), Applications: cdk.listMapper(cluster_utils_1.ApplicationConfigPropertyToJson)(this.props.applications), AutoScalingRole: cdk.stringToCloudFormation(this._autoScalingRole?.roleName), BootstrapActions: cdk.listMapper(cluster_utils_1.BootstrapActionConfigToJson)(this.props.bootstrapActions), Configurations: cdk.listMapper(cluster_utils_1.ConfigurationPropertyToJson)(this.props.configurations), CustomAmiId: cdk.stringToCloudFormation(this.props.customAmiId), EbsRootVolumeSize: this.props.ebsRootVolumeSize?.toGibibytes(), KerberosAttributes: this.props.kerberosAttributes ? (0, cluster_utils_1.KerberosAttributesPropertyToJson)(this.props.kerberosAttributes) : void 0, LogUri: cdk.stringToCloudFormation(this.props.logUri), ReleaseLabel: cdk.stringToCloudFormation(this.props.releaseLabel), ScaleDownBehavior: cdk.stringToCloudFormation(this.props.scaleDownBehavior?.valueOf()), SecurityConfiguration: cdk.stringToCloudFormation(this.props.securityConfiguration), StepConcurrencyLevel: cdk.numberToCloudFormation(this.props.stepConcurrencyLevel), ...this.props.tags ? this.renderTags(this.props.tags) : void 0, VisibleToAllUsers: cdk.booleanToCloudFormation(this.visibleToAllUsers) }) };
      }
      renderTags(tags) {
        return tags ? { Tags: Object.keys(tags).map((key) => ({ Key: key, Value: tags[key] })) } : {};
      }
      createPolicyStatements(serviceRole, clusterRole, autoScalingRole) {
        const stack = cdk.Stack.of(this), policyStatements = [new iam.PolicyStatement({ actions: ["elasticmapreduce:RunJobFlow", "elasticmapreduce:DescribeCluster", "elasticmapreduce:TerminateJobFlows"], resources: ["*"] })];
        return policyStatements.push(new iam.PolicyStatement({ actions: ["iam:PassRole"], resources: [serviceRole.roleArn, clusterRole.roleArn] })), autoScalingRole !== void 0 && policyStatements.push(new iam.PolicyStatement({ actions: ["iam:PassRole"], resources: [autoScalingRole.roleArn] })), this.props.tags && policyStatements.push(new iam.PolicyStatement({ actions: ["elasticmapreduce:AddTags"], resources: [stack.formatArn({ service: "elasticmapreduce", resource: "cluster", resourceName: "*" })] })), this.integrationPattern === sfn.IntegrationPattern.RUN_JOB && policyStatements.push(new iam.PolicyStatement({ actions: ["events:PutTargets", "events:PutRule", "events:DescribeRule"], resources: [stack.formatArn({ service: "events", resource: "rule", resourceName: "StepFunctionsGetEventForEMRRunJobFlowRule" })] })), policyStatements;
      }
      createServiceRole() {
        return cdk.FeatureFlags.of(this).isEnabled(cx_api_1.ENABLE_EMR_SERVICE_POLICY_V2) ? new iam.Role(this, "ServiceRole", { assumedBy: new iam.ServicePrincipal("elasticmapreduce.amazonaws.com", { conditions: { StringEquals: { "aws:RequestTag/for-use-with-amazon-emr-managed-policies": "true" } } }), managedPolicies: [iam.ManagedPolicy.fromAwsManagedPolicyName("service-role/AmazonEMRServicePolicy_v2")] }) : new iam.Role(this, "ServiceRole", { assumedBy: new iam.ServicePrincipal("elasticmapreduce.amazonaws.com"), managedPolicies: [iam.ManagedPolicy.fromAwsManagedPolicyName("service-role/AmazonElasticMapReduceRole")] });
      }
      createClusterRole() {
        const role = new iam.Role(this, "InstanceRole", { assumedBy: new iam.ServicePrincipal("ec2.amazonaws.com") });
        return new iam.CfnInstanceProfile(this, "InstanceProfile", { roles: [role.roleName], instanceProfileName: role.roleName }), role;
      }
      createAutoScalingRole() {
        const role = new iam.Role(this, "AutoScalingRole", { assumedBy: new iam.ServicePrincipal("elasticmapreduce.amazonaws.com"), managedPolicies: [iam.ManagedPolicy.fromAwsManagedPolicyName("service-role/AmazonElasticMapReduceforAutoScalingRole")] });
        return role.assumeRolePolicy?.addStatements(new iam.PolicyStatement({ effect: iam.Effect.ALLOW, principals: [new iam.ServicePrincipal("application-autoscaling.amazonaws.com")], actions: ["sts:AssumeRole"] })), role;
      }
      validateReleaseLabel(releaseLabel) {
        const prefix = releaseLabel.slice(0, 4), versions = releaseLabel.slice(4).split(".");
        if (prefix !== "emr-" || versions.length !== 3 || versions.some((e) => isNotANumber(e)))
          throw new Error(`The release label must be in the format 'emr-x.x.x' but got ${releaseLabel}`);
        return releaseLabel;
        function isNotANumber(value) {
          return value === "" || isNaN(Number(value));
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EmrCreateCluster[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.EmrCreateCluster", version: "2.80.0" }, EmrCreateCluster.SUPPORTED_INTEGRATION_PATTERNS = [sfn.IntegrationPattern.REQUEST_RESPONSE, sfn.IntegrationPattern.RUN_JOB], exports2.EmrCreateCluster = EmrCreateCluster, function(EmrCreateCluster2) {
      let EmrClusterScaleDownBehavior;
      (function(EmrClusterScaleDownBehavior2) {
        EmrClusterScaleDownBehavior2.TERMINATE_AT_INSTANCE_HOUR = "TERMINATE_AT_INSTANCE_HOUR", EmrClusterScaleDownBehavior2.TERMINATE_AT_TASK_COMPLETION = "TERMINATE_AT_TASK_COMPLETION";
      })(EmrClusterScaleDownBehavior = EmrCreateCluster2.EmrClusterScaleDownBehavior || (EmrCreateCluster2.EmrClusterScaleDownBehavior = {}));
      let InstanceRoleType;
      (function(InstanceRoleType2) {
        InstanceRoleType2.MASTER = "MASTER", InstanceRoleType2.CORE = "CORE", InstanceRoleType2.TASK = "TASK";
      })(InstanceRoleType = EmrCreateCluster2.InstanceRoleType || (EmrCreateCluster2.InstanceRoleType = {}));
      let EbsBlockDeviceVolumeType;
      (function(EbsBlockDeviceVolumeType2) {
        EbsBlockDeviceVolumeType2.GP2 = "gp2", EbsBlockDeviceVolumeType2.IO1 = "io1", EbsBlockDeviceVolumeType2.STANDARD = "standard";
      })(EbsBlockDeviceVolumeType = EmrCreateCluster2.EbsBlockDeviceVolumeType || (EmrCreateCluster2.EbsBlockDeviceVolumeType = {}));
      let SpotTimeoutAction;
      (function(SpotTimeoutAction2) {
        SpotTimeoutAction2.SWITCH_TO_ON_DEMAND = "SWITCH_TO_ON_DEMAND", SpotTimeoutAction2.TERMINATE_CLUSTER = "TERMINATE_CLUSTER";
      })(SpotTimeoutAction = EmrCreateCluster2.SpotTimeoutAction || (EmrCreateCluster2.SpotTimeoutAction = {}));
      let SpotAllocationStrategy;
      (function(SpotAllocationStrategy2) {
        SpotAllocationStrategy2.CAPACITY_OPTIMIZED = "capacity-optimized";
      })(SpotAllocationStrategy = EmrCreateCluster2.SpotAllocationStrategy || (EmrCreateCluster2.SpotAllocationStrategy = {}));
      let CloudWatchAlarmComparisonOperator;
      (function(CloudWatchAlarmComparisonOperator2) {
        CloudWatchAlarmComparisonOperator2.GREATER_THAN_OR_EQUAL = "GREATER_THAN_OR_EQUAL", CloudWatchAlarmComparisonOperator2.GREATER_THAN = "GREATER_THAN", CloudWatchAlarmComparisonOperator2.LESS_THAN = "LESS_THAN", CloudWatchAlarmComparisonOperator2.LESS_THAN_OR_EQUAL = "LESS_THAN_OR_EQUAL";
      })(CloudWatchAlarmComparisonOperator = EmrCreateCluster2.CloudWatchAlarmComparisonOperator || (EmrCreateCluster2.CloudWatchAlarmComparisonOperator = {}));
      let CloudWatchAlarmStatistic;
      (function(CloudWatchAlarmStatistic2) {
        CloudWatchAlarmStatistic2.SAMPLE_COUNT = "SAMPLE_COUNT", CloudWatchAlarmStatistic2.AVERAGE = "AVERAGE", CloudWatchAlarmStatistic2.SUM = "SUM", CloudWatchAlarmStatistic2.MINIMUM = "MINIMUM", CloudWatchAlarmStatistic2.MAXIMUM = "MAXIMUM";
      })(CloudWatchAlarmStatistic = EmrCreateCluster2.CloudWatchAlarmStatistic || (EmrCreateCluster2.CloudWatchAlarmStatistic = {}));
      let CloudWatchAlarmUnit;
      (function(CloudWatchAlarmUnit2) {
        CloudWatchAlarmUnit2.NONE = "NONE", CloudWatchAlarmUnit2.SECONDS = "SECONDS", CloudWatchAlarmUnit2.MICRO_SECONDS = "MICRO_SECONDS", CloudWatchAlarmUnit2.MILLI_SECONDS = "MILLI_SECONDS", CloudWatchAlarmUnit2.BYTES = "BYTES", CloudWatchAlarmUnit2.KILO_BYTES = "KILO_BYTES", CloudWatchAlarmUnit2.MEGA_BYTES = "MEGA_BYTES", CloudWatchAlarmUnit2.GIGA_BYTES = "GIGA_BYTES", CloudWatchAlarmUnit2.TERA_BYTES = "TERA_BYTES", CloudWatchAlarmUnit2.BITS = "BITS", CloudWatchAlarmUnit2.KILO_BITS = "KILO_BITS", CloudWatchAlarmUnit2.MEGA_BITS = "MEGA_BITS", CloudWatchAlarmUnit2.GIGA_BITS = "GIGA_BITS", CloudWatchAlarmUnit2.TERA_BITS = "TERA_BITS", CloudWatchAlarmUnit2.PERCENT = "PERCENT", CloudWatchAlarmUnit2.COUNT = "COUNT", CloudWatchAlarmUnit2.BYTES_PER_SECOND = "BYTES_PER_SECOND", CloudWatchAlarmUnit2.KILO_BYTES_PER_SECOND = "KILO_BYTES_PER_SECOND", CloudWatchAlarmUnit2.MEGA_BYTES_PER_SECOND = "MEGA_BYTES_PER_SECOND", CloudWatchAlarmUnit2.GIGA_BYTES_PER_SECOND = "GIGA_BYTES_PER_SECOND", CloudWatchAlarmUnit2.TERA_BYTES_PER_SECOND = "TERA_BYTES_PER_SECOND", CloudWatchAlarmUnit2.BITS_PER_SECOND = "BITS_PER_SECOND", CloudWatchAlarmUnit2.KILO_BITS_PER_SECOND = "KILO_BITS_PER_SECOND", CloudWatchAlarmUnit2.MEGA_BITS_PER_SECOND = "MEGA_BITS_PER_SECOND", CloudWatchAlarmUnit2.GIGA_BITS_PER_SECOND = "GIGA_BITS_PER_SECOND", CloudWatchAlarmUnit2.TERA_BITS_PER_SECOND = "TERA_BITS_PER_SECOND", CloudWatchAlarmUnit2.COUNT_PER_SECOND = "COUNT_PER_SECOND";
      })(CloudWatchAlarmUnit = EmrCreateCluster2.CloudWatchAlarmUnit || (EmrCreateCluster2.CloudWatchAlarmUnit = {}));
      let InstanceMarket;
      (function(InstanceMarket2) {
        InstanceMarket2.ON_DEMAND = "ON_DEMAND", InstanceMarket2.SPOT = "SPOT";
      })(InstanceMarket = EmrCreateCluster2.InstanceMarket || (EmrCreateCluster2.InstanceMarket = {}));
      let ScalingAdjustmentType;
      (function(ScalingAdjustmentType2) {
        ScalingAdjustmentType2.CHANGE_IN_CAPACITY = "CHANGE_IN_CAPACITY", ScalingAdjustmentType2.PERCENT_CHANGE_IN_CAPACITY = "PERCENT_CHANGE_IN_CAPACITY", ScalingAdjustmentType2.EXACT_CAPACITY = "EXACT_CAPACITY";
      })(ScalingAdjustmentType = EmrCreateCluster2.ScalingAdjustmentType || (EmrCreateCluster2.ScalingAdjustmentType = {}));
    }(EmrCreateCluster = exports2.EmrCreateCluster || (exports2.EmrCreateCluster = {})), exports2.EmrCreateCluster = EmrCreateCluster;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/emr/emr-set-cluster-termination-protection.js
var require_emr_set_cluster_termination_protection = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/emr/emr-set-cluster-termination-protection.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EmrSetClusterTerminationProtection = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var core_1 = require_core2();
    var task_utils_1 = require_task_utils();
    var EmrSetClusterTerminationProtection = class _EmrSetClusterTerminationProtection extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_EmrSetClusterTerminationProtectionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EmrSetClusterTerminationProtection), error;
        }
        this.taskPolicies = [new iam.PolicyStatement({ actions: ["elasticmapreduce:SetTerminationProtection"], resources: [core_1.Stack.of(this).formatArn({ service: "elasticmapreduce", resource: "cluster", resourceName: "*" })] })];
      }
      _renderTask() {
        return { Resource: (0, task_utils_1.integrationResourceArn)("elasticmapreduce", "setClusterTerminationProtection", sfn.IntegrationPattern.REQUEST_RESPONSE), Parameters: sfn.FieldUtils.renderObject({ ClusterId: this.props.clusterId, TerminationProtected: this.props.terminationProtected }) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EmrSetClusterTerminationProtection[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.EmrSetClusterTerminationProtection", version: "2.80.0" }, exports2.EmrSetClusterTerminationProtection = EmrSetClusterTerminationProtection;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/emr/emr-terminate-cluster.js
var require_emr_terminate_cluster = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/emr/emr-terminate-cluster.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EmrTerminateCluster = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var core_1 = require_core2();
    var task_utils_1 = require_task_utils();
    var EmrTerminateCluster = class _EmrTerminateCluster extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_EmrTerminateClusterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EmrTerminateCluster), error;
        }
        this.integrationPattern = props.integrationPattern ?? sfn.IntegrationPattern.RUN_JOB, (0, task_utils_1.validatePatternSupported)(this.integrationPattern, _EmrTerminateCluster.SUPPORTED_INTEGRATION_PATTERNS), this.taskPolicies = this.createPolicyStatements();
      }
      _renderTask() {
        return { Resource: (0, task_utils_1.integrationResourceArn)("elasticmapreduce", "terminateCluster", this.integrationPattern), Parameters: sfn.FieldUtils.renderObject({ ClusterId: this.props.clusterId }) };
      }
      createPolicyStatements() {
        const stack = core_1.Stack.of(this), policyStatements = [new iam.PolicyStatement({ actions: ["elasticmapreduce:DescribeCluster", "elasticmapreduce:TerminateJobFlows"], resources: [core_1.Stack.of(this).formatArn({ service: "elasticmapreduce", resource: "cluster", resourceName: "*" })] })];
        return this.integrationPattern === sfn.IntegrationPattern.RUN_JOB && policyStatements.push(new iam.PolicyStatement({ actions: ["events:PutTargets", "events:PutRule", "events:DescribeRule"], resources: [stack.formatArn({ service: "events", resource: "rule", resourceName: "StepFunctionsGetEventForEMRTerminateJobFlowsRule" })] })), policyStatements;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EmrTerminateCluster[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.EmrTerminateCluster", version: "2.80.0" }, EmrTerminateCluster.SUPPORTED_INTEGRATION_PATTERNS = [sfn.IntegrationPattern.REQUEST_RESPONSE, sfn.IntegrationPattern.RUN_JOB], exports2.EmrTerminateCluster = EmrTerminateCluster;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/emr/emr-add-step.js
var require_emr_add_step = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/emr/emr-add-step.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EmrAddStep = exports2.ActionOnFailure = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var core_1 = require_core2();
    var task_utils_1 = require_task_utils();
    var ActionOnFailure;
    (function(ActionOnFailure2) {
      ActionOnFailure2.TERMINATE_CLUSTER = "TERMINATE_CLUSTER", ActionOnFailure2.CANCEL_AND_WAIT = "CANCEL_AND_WAIT", ActionOnFailure2.CONTINUE = "CONTINUE";
    })(ActionOnFailure = exports2.ActionOnFailure || (exports2.ActionOnFailure = {}));
    var EmrAddStep = class _EmrAddStep extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_EmrAddStepProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EmrAddStep), error;
        }
        this.actionOnFailure = props.actionOnFailure ?? ActionOnFailure.CONTINUE, this.integrationPattern = props.integrationPattern ?? sfn.IntegrationPattern.RUN_JOB, (0, task_utils_1.validatePatternSupported)(this.integrationPattern, _EmrAddStep.SUPPORTED_INTEGRATION_PATTERNS), this.taskPolicies = this.createPolicyStatements();
      }
      _renderTask() {
        return { Resource: (0, task_utils_1.integrationResourceArn)("elasticmapreduce", "addStep", this.integrationPattern), Parameters: sfn.FieldUtils.renderObject({ ClusterId: this.props.clusterId, Step: { Name: this.props.name, ActionOnFailure: this.actionOnFailure.valueOf(), HadoopJarStep: { Jar: this.props.jar, MainClass: this.props.mainClass, Args: this.props.args, Properties: this.props.properties === void 0 ? void 0 : Object.entries(this.props.properties).map((kv) => ({ Key: kv[0], Value: kv[1] })) } } }) };
      }
      createPolicyStatements() {
        const stack = core_1.Stack.of(this), policyStatements = [new iam.PolicyStatement({ actions: ["elasticmapreduce:AddJobFlowSteps", "elasticmapreduce:DescribeStep", "elasticmapreduce:CancelSteps"], resources: [stack.formatArn({ service: "elasticmapreduce", resource: "cluster", resourceName: "*" })] })];
        return this.integrationPattern === sfn.IntegrationPattern.RUN_JOB && policyStatements.push(new iam.PolicyStatement({ actions: ["events:PutTargets", "events:PutRule", "events:DescribeRule"], resources: [stack.formatArn({ service: "events", resource: "rule", resourceName: "StepFunctionsGetEventForEMRAddJobFlowStepsRule" })] })), policyStatements;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EmrAddStep[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.EmrAddStep", version: "2.80.0" }, EmrAddStep.SUPPORTED_INTEGRATION_PATTERNS = [sfn.IntegrationPattern.REQUEST_RESPONSE, sfn.IntegrationPattern.RUN_JOB], exports2.EmrAddStep = EmrAddStep;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/emr/emr-cancel-step.js
var require_emr_cancel_step = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/emr/emr-cancel-step.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EmrCancelStep = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var core_1 = require_core2();
    var task_utils_1 = require_task_utils();
    var EmrCancelStep = class _EmrCancelStep extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_EmrCancelStepProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EmrCancelStep), error;
        }
        this.taskPolicies = [new iam.PolicyStatement({ actions: ["elasticmapreduce:CancelSteps"], resources: [core_1.Stack.of(this).formatArn({ service: "elasticmapreduce", resource: "cluster", resourceName: "*" })] })];
      }
      _renderTask() {
        return { Resource: (0, task_utils_1.integrationResourceArn)("elasticmapreduce", "cancelStep", sfn.IntegrationPattern.REQUEST_RESPONSE), Parameters: sfn.FieldUtils.renderObject({ ClusterId: this.props.clusterId, StepId: this.props.stepId }) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EmrCancelStep[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.EmrCancelStep", version: "2.80.0" }, exports2.EmrCancelStep = EmrCancelStep;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/emr/emr-modify-instance-fleet-by-name.js
var require_emr_modify_instance_fleet_by_name = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/emr/emr-modify-instance-fleet-by-name.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EmrModifyInstanceFleetByName = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var core_1 = require_core2();
    var task_utils_1 = require_task_utils();
    var EmrModifyInstanceFleetByName = class _EmrModifyInstanceFleetByName extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_EmrModifyInstanceFleetByNameProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EmrModifyInstanceFleetByName), error;
        }
        this.taskPolicies = [new iam.PolicyStatement({ actions: ["elasticmapreduce:ModifyInstanceFleet", "elasticmapreduce:ListInstanceFleets"], resources: [core_1.Stack.of(this).formatArn({ service: "elasticmapreduce", resource: "cluster", resourceName: "*" })] })];
      }
      _renderTask() {
        return { Resource: (0, task_utils_1.integrationResourceArn)("elasticmapreduce", "modifyInstanceFleetByName", sfn.IntegrationPattern.REQUEST_RESPONSE), Parameters: sfn.FieldUtils.renderObject({ ClusterId: this.props.clusterId, InstanceFleetName: this.props.instanceFleetName, InstanceFleet: { TargetOnDemandCapacity: this.props.targetOnDemandCapacity, TargetSpotCapacity: this.props.targetSpotCapacity } }) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EmrModifyInstanceFleetByName[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.EmrModifyInstanceFleetByName", version: "2.80.0" }, exports2.EmrModifyInstanceFleetByName = EmrModifyInstanceFleetByName;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/emr/emr-modify-instance-group-by-name.js
var require_emr_modify_instance_group_by_name = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/emr/emr-modify-instance-group-by-name.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EmrModifyInstanceGroupByName = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cluster_utils_1 = require_cluster_utils();
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var core_1 = require_core2();
    var task_utils_1 = require_task_utils();
    var EmrModifyInstanceGroupByName = class _EmrModifyInstanceGroupByName extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_EmrModifyInstanceGroupByNameProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EmrModifyInstanceGroupByName), error;
        }
        this.taskPolicies = [new iam.PolicyStatement({ actions: ["elasticmapreduce:ModifyInstanceGroups", "elasticmapreduce:ListInstanceGroups"], resources: [core_1.Stack.of(this).formatArn({ service: "elasticmapreduce", resource: "cluster", resourceName: "*" })] })];
      }
      _renderTask() {
        return { Resource: (0, task_utils_1.integrationResourceArn)("elasticmapreduce", "modifyInstanceGroupByName", sfn.IntegrationPattern.REQUEST_RESPONSE), Parameters: sfn.FieldUtils.renderObject({ ClusterId: this.props.clusterId, InstanceGroupName: this.props.instanceGroupName, InstanceGroup: (0, cluster_utils_1.InstanceGroupModifyConfigPropertyToJson)(this.props.instanceGroup) }) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EmrModifyInstanceGroupByName[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.EmrModifyInstanceGroupByName", version: "2.80.0" }, exports2.EmrModifyInstanceGroupByName = EmrModifyInstanceGroupByName;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/emrcontainers/create-virtual-cluster.js
var require_create_virtual_cluster = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/emrcontainers/create-virtual-cluster.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EmrContainersCreateVirtualCluster = exports2.EksClusterInput = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var core_1 = require_core2();
    var task_utils_1 = require_task_utils();
    var ContainerProviderTypes;
    (function(ContainerProviderTypes2) {
      ContainerProviderTypes2.EKS = "EKS";
    })(ContainerProviderTypes || (ContainerProviderTypes = {}));
    var EksClusterInput = class _EksClusterInput {
      static fromCluster(cluster) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_eks_ICluster(cluster);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromCluster), error;
        }
        return new _EksClusterInput(cluster.clusterName);
      }
      static fromTaskInput(taskInput) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_TaskInput(taskInput);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromTaskInput), error;
        }
        return new _EksClusterInput(taskInput.value);
      }
      constructor(clusterName) {
        this.clusterName = clusterName;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EksClusterInput[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.EksClusterInput", version: "2.80.0" }, exports2.EksClusterInput = EksClusterInput;
    var EmrContainersCreateVirtualCluster = class _EmrContainersCreateVirtualCluster extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_EmrContainersCreateVirtualClusterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EmrContainersCreateVirtualCluster), error;
        }
        this.integrationPattern = props.integrationPattern ?? sfn.IntegrationPattern.REQUEST_RESPONSE, (0, task_utils_1.validatePatternSupported)(this.integrationPattern, _EmrContainersCreateVirtualCluster.SUPPORTED_INTEGRATION_PATTERNS), this.taskPolicies = this.createPolicyStatements();
      }
      _renderTask() {
        return { Resource: (0, task_utils_1.integrationResourceArn)("emr-containers", "createVirtualCluster", this.integrationPattern), Parameters: sfn.FieldUtils.renderObject({ Name: this.props.virtualClusterName ?? sfn.JsonPath.stringAt("States.Format('{}/{}', $$.Execution.Name, $$.State.Name)"), ContainerProvider: { Id: this.props.eksCluster.clusterName, Info: { EksInfo: { Namespace: this.props.eksNamespace ?? "default" } }, Type: ContainerProviderTypes.EKS }, Tags: this.props.tags }) };
      }
      createPolicyStatements() {
        return [new iam.PolicyStatement({ resources: ["*"], actions: ["emr-containers:CreateVirtualCluster"] }), new iam.PolicyStatement({ resources: [core_1.Stack.of(this).formatArn({ service: "iam", region: "", resource: "role/aws-service-role/emr-containers.amazonaws.com", resourceName: "AWSServiceRoleForAmazonEMRContainers" })], actions: ["iam:CreateServiceLinkedRole"], conditions: { StringLike: { "iam:AWSServiceName": "emr-containers.amazonaws.com" } } })];
      }
    };
    _b = JSII_RTTI_SYMBOL_1, EmrContainersCreateVirtualCluster[_b] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.EmrContainersCreateVirtualCluster", version: "2.80.0" }, EmrContainersCreateVirtualCluster.SUPPORTED_INTEGRATION_PATTERNS = [sfn.IntegrationPattern.REQUEST_RESPONSE], exports2.EmrContainersCreateVirtualCluster = EmrContainersCreateVirtualCluster;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/emrcontainers/delete-virtual-cluster.js
var require_delete_virtual_cluster = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/emrcontainers/delete-virtual-cluster.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EmrContainersDeleteVirtualCluster = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var cdk = require_core2();
    var task_utils_1 = require_task_utils();
    var EmrContainersDeleteVirtualCluster = class _EmrContainersDeleteVirtualCluster extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_EmrContainersDeleteVirtualClusterProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EmrContainersDeleteVirtualCluster), error;
        }
        this.integrationPattern = props.integrationPattern ?? sfn.IntegrationPattern.REQUEST_RESPONSE, (0, task_utils_1.validatePatternSupported)(this.integrationPattern, _EmrContainersDeleteVirtualCluster.SUPPORTED_INTEGRATION_PATTERNS), this.taskPolicies = this.createPolicyStatements();
      }
      _renderTask() {
        return { Resource: (0, task_utils_1.integrationResourceArn)("emr-containers", "deleteVirtualCluster", this.integrationPattern), Parameters: sfn.FieldUtils.renderObject({ Id: this.props.virtualClusterId.value }) };
      }
      createPolicyStatements() {
        const actions = ["emr-containers:DeleteVirtualCluster"];
        return this.integrationPattern === sfn.IntegrationPattern.RUN_JOB && actions.push("emr-containers:DescribeVirtualCluster"), [new iam.PolicyStatement({ resources: [cdk.Stack.of(this).formatArn({ arnFormat: cdk.ArnFormat.SLASH_RESOURCE_SLASH_RESOURCE_NAME, service: "emr-containers", resource: "virtualclusters", resourceName: sfn.JsonPath.isEncodedJsonPath(this.props.virtualClusterId.value) ? "*" : this.props.virtualClusterId.value })], actions })];
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EmrContainersDeleteVirtualCluster[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.EmrContainersDeleteVirtualCluster", version: "2.80.0" }, EmrContainersDeleteVirtualCluster.SUPPORTED_INTEGRATION_PATTERNS = [sfn.IntegrationPattern.REQUEST_RESPONSE, sfn.IntegrationPattern.RUN_JOB], exports2.EmrContainersDeleteVirtualCluster = EmrContainersDeleteVirtualCluster;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/emrcontainers/start-job-run.js
var require_start_job_run = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/emrcontainers/start-job-run.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.VirtualClusterInput = exports2.ReleaseLabel = exports2.Classification = exports2.EmrContainersStartJobRun = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var path = require("path");
    var iam = require_aws_iam();
    var lambda2 = require_aws_lambda();
    var logs = require_aws_logs();
    var s3 = require_aws_s3();
    var sfn = require_aws_stepfunctions();
    var cdk = require_core2();
    var cr = require_custom_resources();
    var awscli = require_lambda_layer_awscli();
    var task_utils_1 = require_task_utils();
    var EmrContainersStartJobRun = class _EmrContainersStartJobRun extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props, this.applicationConfigPropertyToJson = (property) => ({ Classification: cdk.stringToCloudFormation(property.classification.classificationStatement), Properties: property.properties ? cdk.objectToCloudFormation(property.properties) : void 0, Configurations: property.nestedConfig ? cdk.listMapper(this.applicationConfigPropertyToJson)(property.nestedConfig) : void 0 }), this.assignLogGroup = () => this.props.monitoring?.logGroup ? this.props.monitoring?.logGroup : this.props.monitoring?.logging ? new logs.LogGroup(this, "Monitoring Log Group") : void 0, this.assignLogBucket = () => this.props.monitoring?.logBucket ? this.props.monitoring?.logBucket : this.props.monitoring?.logging ? new s3.Bucket(this, "Monitoring Bucket") : void 0;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_EmrContainersStartJobRunProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EmrContainersStartJobRun), error;
        }
        if (this.integrationPattern = props.integrationPattern ?? sfn.IntegrationPattern.RUN_JOB, (0, task_utils_1.validatePatternSupported)(this.integrationPattern, _EmrContainersStartJobRun.SUPPORTED_INTEGRATION_PATTERNS), this.props.applicationConfig && this.validateAppConfig(this.props.applicationConfig), this.props.jobDriver.sparkSubmitJobDriver && this.validateSparkSubmitJobDriver(props.jobDriver.sparkSubmitJobDriver), this.props.executionRole === void 0 && sfn.JsonPath.isEncodedJsonPath(props.virtualCluster.id))
          throw new Error("Execution role cannot be undefined when the virtual cluster ID is not a concrete value. Provide an execution role with the correct trust policy");
        this.logGroup = this.assignLogGroup(), this.logBucket = this.assignLogBucket(), this.role = this.props.executionRole ?? this.createJobExecutionRole(), this.grantPrincipal = this.role, this.grantMonitoringPolicies(), this.taskPolicies = this.createPolicyStatements();
      }
      _renderTask() {
        return { Resource: (0, task_utils_1.integrationResourceArn)("emr-containers", "startJobRun", this.integrationPattern), Parameters: sfn.FieldUtils.renderObject({ VirtualClusterId: this.props.virtualCluster.id, Name: this.props.jobName, ExecutionRoleArn: this.role.roleArn, ReleaseLabel: this.props.releaseLabel.label, JobDriver: { SparkSubmitJobDriver: { EntryPoint: this.props.jobDriver.sparkSubmitJobDriver?.entryPoint.value, EntryPointArguments: this.props.jobDriver.sparkSubmitJobDriver?.entryPointArguments?.value, SparkSubmitParameters: this.props.jobDriver.sparkSubmitJobDriver?.sparkSubmitParameters } }, ConfigurationOverrides: { ApplicationConfiguration: cdk.listMapper(this.applicationConfigPropertyToJson)(this.props.applicationConfig), MonitoringConfiguration: { CloudWatchMonitoringConfiguration: this.logGroup ? { LogGroupName: this.logGroup.logGroupName, LogStreamNamePrefix: this.props.monitoring.logStreamNamePrefix } : void 0, PersistentAppUI: this.props.monitoring?.persistentAppUI === false ? "DISABLED" : "ENABLED", S3MonitoringConfiguration: this.logBucket ? { LogUri: this.logBucket.s3UrlForObject() } : void 0 } }, Tags: this.props.tags }) };
      }
      validateAppConfigPropertiesLength(appConfig) {
        if (appConfig?.properties !== void 0 && Object.keys(appConfig.properties).length > 100)
          throw new Error(`Application configuration properties must have 100 or fewer entries. Received ${Object.keys(appConfig.properties).length}`);
      }
      validatePropertiesNestedAppConfigBothNotUndefined(appConfig) {
        if (appConfig?.properties === void 0 && appConfig?.nestedConfig === void 0)
          throw new Error("Application configuration must have either properties or nested app configurations defined.");
      }
      validateAppConfig(config) {
        if (config !== void 0) {
          if (config.length > 100)
            throw new Error(`Application configuration array must have 100 or fewer entries. Received ${config.length}`);
          config.forEach((element) => this.validateAppConfig(element.nestedConfig)), config.forEach((element) => this.validateAppConfigPropertiesLength(element)), config.forEach((element) => this.validatePropertiesNestedAppConfigBothNotUndefined(element));
        }
      }
      isArrayOfStrings(value) {
        return Array.isArray(value) && value.every((item) => typeof item == "string");
      }
      validateEntryPointArguments(entryPointArguments) {
        if (typeof entryPointArguments.value == "string") {
          if (!sfn.JsonPath.isEncodedJsonPath(entryPointArguments.value))
            throw new Error("Entry point arguments must be a string array or an encoded JSON path, but received a non JSON path string");
        } else if (!this.isArrayOfStrings(entryPointArguments.value))
          throw new Error(`Entry point arguments must be a string array or an encoded JSON path but received ${typeof entryPointArguments.value}.`);
      }
      validateEntryPointArgumentsLength(entryPointArguments) {
        if (this.isArrayOfStrings(entryPointArguments.value) && (entryPointArguments.value.length > 10280 || entryPointArguments.value.length < 1))
          throw new Error(`Entry point arguments must be a string array between 1 and 10280 in length. Received ${entryPointArguments.value.length}.`);
      }
      validateSparkSubmitParametersLength(sparkSubmitParameters) {
        if (sparkSubmitParameters.length > 102400 || sparkSubmitParameters.length < 1)
          throw new Error(`Spark submit parameters must be between 1 and 102400 characters in length. Received ${sparkSubmitParameters.length}.`);
      }
      validateEntryPoint(entryPoint) {
        if (!sfn.JsonPath.isEncodedJsonPath(entryPoint.value) && (entryPoint.value.length > 256 || entryPoint.value.length < 1))
          throw new Error(`Entry point must be between 1 and 256 characters in length. Received ${entryPoint.value.length}.`);
      }
      validateSparkSubmitJobDriver(driver) {
        this.validateEntryPoint(driver.entryPoint), driver.entryPointArguments && (this.validateEntryPointArguments(driver.entryPointArguments), this.validateEntryPointArgumentsLength(driver.entryPointArguments)), driver.sparkSubmitParameters && this.validateSparkSubmitParametersLength(driver.sparkSubmitParameters);
      }
      createJobExecutionRole() {
        const jobExecutionRole = new iam.Role(this, "Job-Execution-Role", { assumedBy: new iam.CompositePrincipal(new iam.ServicePrincipal("emr-containers.amazonaws.com"), new iam.ServicePrincipal("states.amazonaws.com")) });
        return this.logBucket?.grantReadWrite(jobExecutionRole), this.logGroup?.grantWrite(jobExecutionRole), this.logGroup?.grant(jobExecutionRole, "logs:DescribeLogStreams"), jobExecutionRole.addToPrincipalPolicy(new iam.PolicyStatement({ resources: [cdk.Stack.of(this).formatArn({ service: "logs", resource: "*" })], actions: ["logs:DescribeLogGroups"] })), this.updateRoleTrustPolicy(jobExecutionRole), jobExecutionRole;
      }
      grantMonitoringPolicies() {
        this.logBucket?.grantReadWrite(this.role), this.logGroup?.grantWrite(this.role), this.logGroup?.grant(this.role, "logs:DescribeLogStreams"), this.role.addToPrincipalPolicy(new iam.PolicyStatement({ resources: [cdk.Stack.of(this).formatArn({ service: "logs", resource: "*" })], actions: ["logs:DescribeLogGroups"] }));
      }
      updateRoleTrustPolicy(role) {
        const eksClusterInfo = new cr.AwsCustomResource(this, "GetEksClusterInfo", { onCreate: { service: "EMRcontainers", action: "describeVirtualCluster", parameters: { id: this.props.virtualCluster.id }, outputPaths: ["virtualCluster.containerProvider.info.eksInfo.namespace", "virtualCluster.containerProvider.id"], physicalResourceId: cr.PhysicalResourceId.of("id") }, policy: cr.AwsCustomResourcePolicy.fromSdkCalls({ resources: cr.AwsCustomResourcePolicy.ANY_RESOURCE }), installLatestAwsSdk: false }), cliLayer = new awscli.AwsCliLayer(this, "awsclilayer"), shellCliLambda = new lambda2.SingletonFunction(this, "Call Update-Role-Trust-Policy", { uuid: "8693BB64-9689-44B6-9AAF-B0CC9EB8757C", runtime: lambda2.Runtime.PYTHON_3_9, handler: "index.handler", code: lambda2.Code.fromAsset(path.join(__dirname, "utils/role-policy")), timeout: cdk.Duration.seconds(30), memorySize: 256, layers: [cliLayer] });
        shellCliLambda.addToRolePolicy(new iam.PolicyStatement({ resources: [cdk.Stack.of(this).formatArn({ service: "eks", resource: "cluster", resourceName: eksClusterInfo.getResponseField("virtualCluster.containerProvider.id") })], actions: ["eks:DescribeCluster"] })), shellCliLambda.addToRolePolicy(new iam.PolicyStatement({ resources: [role.roleArn], actions: ["iam:GetRole", "iam:UpdateAssumeRolePolicy"] }));
        const provider = new cr.Provider(this, "CustomResourceProvider", { onEventHandler: shellCliLambda });
        new cdk.CustomResource(this, "Custom Resource", { properties: { eksNamespace: eksClusterInfo.getResponseField("virtualCluster.containerProvider.info.eksInfo.namespace"), eksClusterId: eksClusterInfo.getResponseField("virtualCluster.containerProvider.id"), roleName: role.roleName }, serviceToken: provider.serviceToken });
      }
      createPolicyStatements() {
        const policyStatements = [new iam.PolicyStatement({ resources: [cdk.Stack.of(this).formatArn({ arnFormat: cdk.ArnFormat.SLASH_RESOURCE_SLASH_RESOURCE_NAME, service: "emr-containers", resource: "virtualclusters", resourceName: sfn.JsonPath.isEncodedJsonPath(this.props.virtualCluster.id) ? "*" : this.props.virtualCluster.id })], actions: ["emr-containers:StartJobRun"], conditions: { StringEquals: { "emr-containers:ExecutionRoleArn": this.role.roleArn } } })];
        return this.integrationPattern === sfn.IntegrationPattern.RUN_JOB && policyStatements.push(new iam.PolicyStatement({ resources: [cdk.Stack.of(this).formatArn({ arnFormat: cdk.ArnFormat.SLASH_RESOURCE_SLASH_RESOURCE_NAME, service: "emr-containers", resource: "virtualclusters", resourceName: sfn.JsonPath.isEncodedJsonPath(this.props.virtualCluster.id) ? "*" : `${this.props.virtualCluster.id}/jobruns/*` })], actions: ["emr-containers:DescribeJobRun", "emr-containers:CancelJobRun"] })), policyStatements;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EmrContainersStartJobRun[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.EmrContainersStartJobRun", version: "2.80.0" }, EmrContainersStartJobRun.SUPPORTED_INTEGRATION_PATTERNS = [sfn.IntegrationPattern.REQUEST_RESPONSE, sfn.IntegrationPattern.RUN_JOB], exports2.EmrContainersStartJobRun = EmrContainersStartJobRun;
    var Classification = class {
      constructor(classificationStatement) {
        this.classificationStatement = classificationStatement;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, Classification[_b] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.Classification", version: "2.80.0" }, Classification.SPARK = new Classification("spark"), Classification.SPARK_DEFAULTS = new Classification("spark-defaults"), Classification.SPARK_ENV = new Classification("spark-env"), Classification.SPARK_HIVE_SITE = new Classification("spark-hive-site"), Classification.SPARK_LOG4J = new Classification("spark-log4j"), Classification.SPARK_METRICS = new Classification("spark-metrics"), exports2.Classification = Classification;
    var ReleaseLabel = class {
      constructor(label) {
        this.label = label;
      }
    };
    _c = JSII_RTTI_SYMBOL_1, ReleaseLabel[_c] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.ReleaseLabel", version: "2.80.0" }, ReleaseLabel.EMR_5_32_0 = new ReleaseLabel("emr-5.32.0-latest"), ReleaseLabel.EMR_5_33_0 = new ReleaseLabel("emr-5.33.0-latest"), ReleaseLabel.EMR_6_2_0 = new ReleaseLabel("emr-6.2.0-latest"), ReleaseLabel.EMR_6_3_0 = new ReleaseLabel("emr-6.3.0-latest"), exports2.ReleaseLabel = ReleaseLabel;
    var VirtualClusterInput = class _VirtualClusterInput {
      static fromTaskInput(taskInput) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_TaskInput(taskInput);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromTaskInput), error;
        }
        return new _VirtualClusterInput(taskInput.value);
      }
      static fromVirtualClusterId(virtualClusterId) {
        return new _VirtualClusterInput(virtualClusterId);
      }
      constructor(id) {
        this.id = id;
      }
    };
    _d = JSII_RTTI_SYMBOL_1, VirtualClusterInput[_d] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.VirtualClusterInput", version: "2.80.0" }, exports2.VirtualClusterInput = VirtualClusterInput;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/glue/run-glue-job-task.js
var require_run_glue_job_task = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/glue/run-glue-job-task.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.RunGlueJobTask = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var core_1 = require_core2();
    var resource_arn_suffix_1 = require_resource_arn_suffix();
    var RunGlueJobTask = class {
      constructor(glueJobName, props = {}) {
        if (this.glueJobName = glueJobName, this.props = props, this.integrationPattern = props.integrationPattern || sfn.ServiceIntegrationPattern.FIRE_AND_FORGET, ![sfn.ServiceIntegrationPattern.FIRE_AND_FORGET, sfn.ServiceIntegrationPattern.SYNC].includes(this.integrationPattern))
          throw new Error(`Invalid Service Integration Pattern: ${this.integrationPattern} is not supported to call Glue.`);
      }
      bind(task) {
        const notificationProperty = this.props.notifyDelayAfter ? { NotifyDelayAfter: this.props.notifyDelayAfter.toMinutes() } : null;
        let iamActions;
        return this.integrationPattern === sfn.ServiceIntegrationPattern.FIRE_AND_FORGET ? iamActions = ["glue:StartJobRun"] : this.integrationPattern === sfn.ServiceIntegrationPattern.SYNC && (iamActions = ["glue:StartJobRun", "glue:GetJobRun", "glue:GetJobRuns", "glue:BatchStopJobRun"]), { resourceArn: (0, resource_arn_suffix_1.getResourceArn)("glue", "startJobRun", this.integrationPattern), policyStatements: [new iam.PolicyStatement({ resources: [core_1.Stack.of(task).formatArn({ service: "glue", resource: "job", resourceName: this.glueJobName })], actions: iamActions })], metricPrefixSingular: "GlueJob", metricPrefixPlural: "GlueJobs", metricDimensions: { GlueJobName: this.glueJobName }, parameters: { JobName: this.glueJobName, Arguments: this.props.arguments, Timeout: this.props.timeout?.toMinutes(), SecurityConfiguration: this.props.securityConfiguration, NotificationProperty: notificationProperty } };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, RunGlueJobTask[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.RunGlueJobTask", version: "2.80.0" }, exports2.RunGlueJobTask = RunGlueJobTask;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/glue/start-job-run.js
var require_start_job_run2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/glue/start-job-run.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.GlueStartJobRun = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var core_1 = require_core2();
    var task_utils_1 = require_task_utils();
    var GlueStartJobRun = class _GlueStartJobRun extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_GlueStartJobRunProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _GlueStartJobRun), error;
        }
        this.integrationPattern = props.integrationPattern ?? sfn.IntegrationPattern.REQUEST_RESPONSE, (0, task_utils_1.validatePatternSupported)(this.integrationPattern, _GlueStartJobRun.SUPPORTED_INTEGRATION_PATTERNS), this.taskPolicies = this.getPolicies(), this.taskMetrics = { metricPrefixSingular: "GlueJob", metricPrefixPlural: "GlueJobs", metricDimensions: { GlueJobName: this.props.glueJobName } };
      }
      _renderTask() {
        const notificationProperty = this.props.notifyDelayAfter ? { NotifyDelayAfter: this.props.notifyDelayAfter.toMinutes() } : null;
        let timeout;
        return this.props.timeout ? timeout = this.props.timeout.toMinutes() : this.props.taskTimeout?.seconds ? timeout = core_1.Duration.seconds(this.props.taskTimeout.seconds).toMinutes() : this.props.taskTimeout?.path && (timeout = sfn.JsonPath.numberAt(this.props.taskTimeout.path)), { Resource: (0, task_utils_1.integrationResourceArn)("glue", "startJobRun", this.integrationPattern), Parameters: sfn.FieldUtils.renderObject({ JobName: this.props.glueJobName, Arguments: this.props.arguments?.value, Timeout: timeout, SecurityConfiguration: this.props.securityConfiguration, NotificationProperty: notificationProperty }), TimeoutSeconds: void 0, TimeoutSecondsPath: void 0 };
      }
      getPolicies() {
        let iamActions;
        return this.integrationPattern === sfn.IntegrationPattern.REQUEST_RESPONSE ? iamActions = ["glue:StartJobRun"] : this.integrationPattern === sfn.IntegrationPattern.RUN_JOB && (iamActions = ["glue:StartJobRun", "glue:GetJobRun", "glue:GetJobRuns", "glue:BatchStopJobRun"]), [new iam.PolicyStatement({ resources: [core_1.Stack.of(this).formatArn({ service: "glue", resource: "job", resourceName: this.props.glueJobName })], actions: iamActions })];
      }
    };
    _a = JSII_RTTI_SYMBOL_1, GlueStartJobRun[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.GlueStartJobRun", version: "2.80.0" }, GlueStartJobRun.SUPPORTED_INTEGRATION_PATTERNS = [sfn.IntegrationPattern.REQUEST_RESPONSE, sfn.IntegrationPattern.RUN_JOB], exports2.GlueStartJobRun = GlueStartJobRun;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/batch/run-batch-job.js
var require_run_batch_job = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/batch/run-batch-job.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.RunBatchJob = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var core_1 = require_core2();
    var resource_arn_suffix_1 = require_resource_arn_suffix();
    var RunBatchJob = class {
      constructor(props) {
        if (this.props = props, this.integrationPattern = props.integrationPattern || sfn.ServiceIntegrationPattern.SYNC, ![sfn.ServiceIntegrationPattern.FIRE_AND_FORGET, sfn.ServiceIntegrationPattern.SYNC].includes(this.integrationPattern))
          throw new Error(`Invalid Service Integration Pattern: ${this.integrationPattern} is not supported to call RunBatchJob.`);
        if ((0, core_1.withResolved)(props.arraySize, (arraySize) => {
          if (arraySize !== void 0 && (arraySize < 2 || arraySize > 1e4))
            throw new Error(`arraySize must be between 2 and 10,000. Received ${arraySize}.`);
        }), props.dependsOn && props.dependsOn.length > 20)
          throw new Error(`dependencies must be 20 or less. Received ${props.dependsOn.length}.`);
        (0, core_1.withResolved)(props.attempts, (attempts) => {
          if (attempts !== void 0 && (attempts < 1 || attempts > 10))
            throw new Error(`attempts must be between 1 and 10. Received ${attempts}.`);
        }), props.timeout !== void 0 && (0, core_1.withResolved)(props.timeout.toSeconds(), (timeout) => {
          if (timeout < 60)
            throw new Error(`timeout must be greater than 60 seconds. Received ${timeout} seconds.`);
        }), props.containerOverrides?.environment && Object.keys(props.containerOverrides.environment).forEach((key) => {
          if (key.match(/^AWS_BATCH/))
            throw new Error(`Invalid environment variable name: ${key}. Environment variable names starting with 'AWS_BATCH' are reserved.`);
        });
      }
      bind(_task) {
        return { resourceArn: (0, resource_arn_suffix_1.getResourceArn)("batch", "submitJob", this.integrationPattern), policyStatements: this.configurePolicyStatements(_task), parameters: { JobDefinition: this.props.jobDefinitionArn, JobName: this.props.jobName, JobQueue: this.props.jobQueueArn, Parameters: this.props.payload, ArrayProperties: this.props.arraySize !== void 0 ? { Size: this.props.arraySize } : void 0, ContainerOverrides: this.props.containerOverrides ? this.configureContainerOverrides(this.props.containerOverrides) : void 0, DependsOn: this.props.dependsOn ? this.props.dependsOn.map((jobDependency) => ({ JobId: jobDependency.jobId, Type: jobDependency.type })) : void 0, RetryStrategy: this.props.attempts !== void 0 ? { Attempts: this.props.attempts } : void 0, Timeout: this.props.timeout ? { AttemptDurationSeconds: this.props.timeout.toSeconds() } : void 0 } };
      }
      configurePolicyStatements(task) {
        return [new iam.PolicyStatement({ resources: [core_1.Stack.of(task).formatArn({ service: "batch", resource: "job-definition", resourceName: "*" }), this.props.jobQueueArn], actions: ["batch:SubmitJob"] }), new iam.PolicyStatement({ resources: [core_1.Stack.of(task).formatArn({ service: "events", resource: "rule/StepFunctionsGetEventsForBatchJobsRule" })], actions: ["events:PutTargets", "events:PutRule", "events:DescribeRule"] })];
      }
      configureContainerOverrides(containerOverrides) {
        let environment;
        containerOverrides.environment && (environment = Object.entries(containerOverrides.environment).map(([key, value]) => ({ Name: key, Value: value })));
        let resources;
        return containerOverrides.gpuCount && (resources = [{ Type: "GPU", Value: `${containerOverrides.gpuCount}` }]), { Command: containerOverrides.command, Environment: environment, InstanceType: containerOverrides.instanceType?.toString(), Memory: containerOverrides.memory, ResourceRequirements: resources, Vcpus: containerOverrides.vcpus };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, RunBatchJob[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.RunBatchJob", version: "2.80.0" }, exports2.RunBatchJob = RunBatchJob;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/batch/submit-job.js
var require_submit_job = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/batch/submit-job.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.BatchSubmitJob = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var core_1 = require_core2();
    var task_utils_1 = require_task_utils();
    var BatchSubmitJob = class _BatchSubmitJob extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_BatchSubmitJobProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _BatchSubmitJob), error;
        }
        if (this.integrationPattern = props.integrationPattern ?? sfn.IntegrationPattern.RUN_JOB, (0, task_utils_1.validatePatternSupported)(this.integrationPattern, _BatchSubmitJob.SUPPORTED_INTEGRATION_PATTERNS), (0, core_1.withResolved)(props.arraySize, (arraySize) => {
          if (arraySize !== void 0 && (arraySize < 2 || arraySize > 1e4))
            throw new Error(`arraySize must be between 2 and 10,000. Received ${arraySize}.`);
        }), props.dependsOn && props.dependsOn.length > 20)
          throw new Error(`dependencies must be 20 or less. Received ${props.dependsOn.length}.`);
        (0, core_1.withResolved)(props.attempts, (attempts) => {
          if (attempts !== void 0 && (attempts < 1 || attempts > 10))
            throw new Error(`attempts must be between 1 and 10. Received ${attempts}.`);
        }), (props.timeout !== void 0 || props.taskTimeout !== void 0) && (0, core_1.withResolved)(props.timeout?.toSeconds(), props.taskTimeout?.seconds, (timeout, taskTimeout) => {
          const definedTimeout = timeout ?? taskTimeout;
          if (definedTimeout && definedTimeout < 60)
            throw new Error(`attempt duration must be greater than 60 seconds. Received ${definedTimeout} seconds.`);
        }), props.containerOverrides?.environment && Object.keys(props.containerOverrides.environment).forEach((key) => {
          if (key.match(/^AWS_BATCH/))
            throw new Error(`Invalid environment variable name: ${key}. Environment variable names starting with 'AWS_BATCH' are reserved.`);
        }), this.taskPolicies = this.configurePolicyStatements();
      }
      _renderTask() {
        let timeout;
        return this.props.timeout ? timeout = this.props.timeout.toSeconds() : this.props.taskTimeout?.seconds ? timeout = this.props.taskTimeout.seconds : this.props.taskTimeout?.path && (timeout = sfn.JsonPath.numberAt(this.props.taskTimeout.path)), { Resource: (0, task_utils_1.integrationResourceArn)("batch", "submitJob", this.integrationPattern), Parameters: sfn.FieldUtils.renderObject({ JobDefinition: this.props.jobDefinitionArn, JobName: this.props.jobName, JobQueue: this.props.jobQueueArn, Parameters: this.props.payload?.value, ArrayProperties: this.props.arraySize !== void 0 ? { Size: this.props.arraySize } : void 0, ContainerOverrides: this.props.containerOverrides ? this.configureContainerOverrides(this.props.containerOverrides) : void 0, DependsOn: this.props.dependsOn ? this.props.dependsOn.map((jobDependency) => ({ JobId: jobDependency.jobId, Type: jobDependency.type })) : void 0, RetryStrategy: this.props.attempts !== void 0 ? { Attempts: this.props.attempts } : void 0, Timeout: timeout ? { AttemptDurationSeconds: timeout } : void 0 }), TimeoutSeconds: void 0, TimeoutSecondsPath: void 0 };
      }
      configurePolicyStatements() {
        return [new iam.PolicyStatement({ resources: [core_1.Stack.of(this).formatArn({ service: "batch", resource: "job-definition", resourceName: "*" }), this.props.jobQueueArn], actions: ["batch:SubmitJob"] }), new iam.PolicyStatement({ resources: [core_1.Stack.of(this).formatArn({ service: "events", resource: "rule/StepFunctionsGetEventsForBatchJobsRule" })], actions: ["events:PutTargets", "events:PutRule", "events:DescribeRule"] })];
      }
      configureContainerOverrides(containerOverrides) {
        let environment;
        containerOverrides.environment && (environment = Object.entries(containerOverrides.environment).map(([key, value]) => ({ Name: key, Value: value })));
        let resources = [];
        return containerOverrides.gpuCount && resources.push({ Type: "GPU", Value: `${containerOverrides.gpuCount}` }), containerOverrides.memory && resources.push({ Type: "MEMORY", Value: `${containerOverrides.memory.toMebibytes()}` }), containerOverrides.vcpus && resources.push({ Type: "VCPU", Value: `${containerOverrides.vcpus}` }), { Command: containerOverrides.command, Environment: environment, InstanceType: containerOverrides.instanceType?.toString(), ResourceRequirements: resources.length ? resources : void 0 };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, BatchSubmitJob[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.BatchSubmitJob", version: "2.80.0" }, BatchSubmitJob.SUPPORTED_INTEGRATION_PATTERNS = [sfn.IntegrationPattern.REQUEST_RESPONSE, sfn.IntegrationPattern.RUN_JOB], exports2.BatchSubmitJob = BatchSubmitJob;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/dynamodb/private/utils.js
var require_utils16 = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/dynamodb/private/utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.validateJsonPath = exports2.transformAttributeValueMap = exports2.getDynamoResourceArn = exports2.DynamoMethod = void 0;
    var sfn = require_aws_stepfunctions();
    var task_utils_1 = require_task_utils();
    var DynamoMethod;
    (function(DynamoMethod2) {
      DynamoMethod2.GET = "Get", DynamoMethod2.PUT = "Put", DynamoMethod2.DELETE = "Delete", DynamoMethod2.UPDATE = "Update";
    })(DynamoMethod = exports2.DynamoMethod || (exports2.DynamoMethod = {}));
    function getDynamoResourceArn(method) {
      return (0, task_utils_1.integrationResourceArn)("dynamodb", `${method.toLowerCase()}Item`, sfn.IntegrationPattern.REQUEST_RESPONSE);
    }
    exports2.getDynamoResourceArn = getDynamoResourceArn;
    function transformAttributeValueMap(attrMap) {
      const transformedValue = {};
      for (const key in attrMap)
        key && (transformedValue[key] = attrMap[key].toObject());
      return attrMap ? transformedValue : void 0;
    }
    exports2.transformAttributeValueMap = transformAttributeValueMap;
    function validateJsonPath(value) {
      if (!value.startsWith("$"))
        throw new Error("Data JSON path values must either be exactly equal to '$' or start with '$.'");
    }
    exports2.validateJsonPath = validateJsonPath;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/dynamodb/get-item.js
var require_get_item = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/dynamodb/get-item.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DynamoGetItem = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var utils_1 = require_utils16();
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var core_1 = require_core2();
    var DynamoGetItem = class _DynamoGetItem extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_DynamoGetItemProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _DynamoGetItem), error;
        }
        this.taskPolicies = [new iam.PolicyStatement({ resources: [core_1.Stack.of(this).formatArn({ service: "dynamodb", resource: "table", resourceName: props.table.tableName })], actions: [`dynamodb:${utils_1.DynamoMethod.GET}Item`] })];
      }
      _renderTask() {
        return { Resource: (0, utils_1.getDynamoResourceArn)(utils_1.DynamoMethod.GET), Parameters: sfn.FieldUtils.renderObject({ Key: (0, utils_1.transformAttributeValueMap)(this.props.key), TableName: this.props.table.tableName, ConsistentRead: this.props.consistentRead ?? false, ExpressionAttributeNames: this.props.expressionAttributeNames, ProjectionExpression: this.configureProjectionExpression(this.props.projectionExpression), ReturnConsumedCapacity: this.props.returnConsumedCapacity }) };
      }
      configureProjectionExpression(expressions) {
        return expressions ? expressions.map((expression) => expression.toString()).join(",") : void 0;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, DynamoGetItem[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.DynamoGetItem", version: "2.80.0" }, exports2.DynamoGetItem = DynamoGetItem;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/dynamodb/put-item.js
var require_put_item = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/dynamodb/put-item.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DynamoPutItem = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var utils_1 = require_utils16();
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var core_1 = require_core2();
    var DynamoPutItem = class _DynamoPutItem extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_DynamoPutItemProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _DynamoPutItem), error;
        }
        this.taskPolicies = [new iam.PolicyStatement({ resources: [core_1.Stack.of(this).formatArn({ service: "dynamodb", resource: "table", resourceName: props.table.tableName })], actions: [`dynamodb:${utils_1.DynamoMethod.PUT}Item`] })];
      }
      _renderTask() {
        return { Resource: (0, utils_1.getDynamoResourceArn)(utils_1.DynamoMethod.PUT), Parameters: sfn.FieldUtils.renderObject({ Item: (0, utils_1.transformAttributeValueMap)(this.props.item), TableName: this.props.table.tableName, ConditionExpression: this.props.conditionExpression, ExpressionAttributeNames: this.props.expressionAttributeNames, ExpressionAttributeValues: (0, utils_1.transformAttributeValueMap)(this.props.expressionAttributeValues), ReturnConsumedCapacity: this.props.returnConsumedCapacity, ReturnItemCollectionMetrics: this.props.returnItemCollectionMetrics, ReturnValues: this.props.returnValues }) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, DynamoPutItem[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.DynamoPutItem", version: "2.80.0" }, exports2.DynamoPutItem = DynamoPutItem;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/dynamodb/update-item.js
var require_update_item = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/dynamodb/update-item.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DynamoUpdateItem = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var utils_1 = require_utils16();
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var core_1 = require_core2();
    var DynamoUpdateItem = class _DynamoUpdateItem extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_DynamoUpdateItemProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _DynamoUpdateItem), error;
        }
        this.taskPolicies = [new iam.PolicyStatement({ resources: [core_1.Stack.of(this).formatArn({ service: "dynamodb", resource: "table", resourceName: props.table.tableName })], actions: [`dynamodb:${utils_1.DynamoMethod.UPDATE}Item`] })];
      }
      _renderTask() {
        return { Resource: (0, utils_1.getDynamoResourceArn)(utils_1.DynamoMethod.UPDATE), Parameters: sfn.FieldUtils.renderObject({ Key: (0, utils_1.transformAttributeValueMap)(this.props.key), TableName: this.props.table.tableName, ConditionExpression: this.props.conditionExpression, ExpressionAttributeNames: this.props.expressionAttributeNames, ExpressionAttributeValues: (0, utils_1.transformAttributeValueMap)(this.props.expressionAttributeValues), ReturnConsumedCapacity: this.props.returnConsumedCapacity, ReturnItemCollectionMetrics: this.props.returnItemCollectionMetrics, ReturnValues: this.props.returnValues, UpdateExpression: this.props.updateExpression }) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, DynamoUpdateItem[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.DynamoUpdateItem", version: "2.80.0" }, exports2.DynamoUpdateItem = DynamoUpdateItem;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/dynamodb/delete-item.js
var require_delete_item = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/dynamodb/delete-item.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DynamoDeleteItem = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var utils_1 = require_utils16();
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var core_1 = require_core2();
    var DynamoDeleteItem = class _DynamoDeleteItem extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_DynamoDeleteItemProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _DynamoDeleteItem), error;
        }
        this.taskPolicies = [new iam.PolicyStatement({ resources: [core_1.Stack.of(this).formatArn({ service: "dynamodb", resource: "table", resourceName: props.table.tableName })], actions: [`dynamodb:${utils_1.DynamoMethod.DELETE}Item`] })];
      }
      _renderTask() {
        return { Resource: (0, utils_1.getDynamoResourceArn)(utils_1.DynamoMethod.DELETE), Parameters: sfn.FieldUtils.renderObject({ Key: (0, utils_1.transformAttributeValueMap)(this.props.key), TableName: this.props.table.tableName, ConditionExpression: this.props.conditionExpression, ExpressionAttributeNames: this.props.expressionAttributeNames, ExpressionAttributeValues: (0, utils_1.transformAttributeValueMap)(this.props.expressionAttributeValues), ReturnConsumedCapacity: this.props.returnConsumedCapacity, ReturnItemCollectionMetrics: this.props.returnItemCollectionMetrics, ReturnValues: this.props.returnValues }) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, DynamoDeleteItem[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.DynamoDeleteItem", version: "2.80.0" }, exports2.DynamoDeleteItem = DynamoDeleteItem;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/dynamodb/shared-types.js
var require_shared_types = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/dynamodb/shared-types.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DynamoAttributeValue = exports2.DynamoProjectionExpression = exports2.DynamoReturnValues = exports2.DynamoItemCollectionMetrics = exports2.DynamoConsumedCapacity = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var utils_1 = require_utils16();
    var DynamoConsumedCapacity;
    (function(DynamoConsumedCapacity2) {
      DynamoConsumedCapacity2.INDEXES = "INDEXES", DynamoConsumedCapacity2.TOTAL = "TOTAL", DynamoConsumedCapacity2.NONE = "NONE";
    })(DynamoConsumedCapacity = exports2.DynamoConsumedCapacity || (exports2.DynamoConsumedCapacity = {}));
    var DynamoItemCollectionMetrics;
    (function(DynamoItemCollectionMetrics2) {
      DynamoItemCollectionMetrics2.SIZE = "SIZE", DynamoItemCollectionMetrics2.NONE = "NONE";
    })(DynamoItemCollectionMetrics = exports2.DynamoItemCollectionMetrics || (exports2.DynamoItemCollectionMetrics = {}));
    var DynamoReturnValues;
    (function(DynamoReturnValues2) {
      DynamoReturnValues2.NONE = "NONE", DynamoReturnValues2.ALL_OLD = "ALL_OLD", DynamoReturnValues2.UPDATED_OLD = "UPDATED_OLD", DynamoReturnValues2.ALL_NEW = "ALL_NEW", DynamoReturnValues2.UPDATED_NEW = "UPDATED_NEW";
    })(DynamoReturnValues = exports2.DynamoReturnValues || (exports2.DynamoReturnValues = {}));
    var DynamoProjectionExpression = class {
      constructor() {
        this.expression = [];
      }
      withAttribute(attr) {
        return this.expression.length ? this.expression.push(`.${attr}`) : this.expression.push(attr), this;
      }
      atIndex(index) {
        if (!this.expression.length)
          throw new Error("Expression must start with an attribute");
        return this.expression.push(`[${index}]`), this;
      }
      toString() {
        return this.expression.join("");
      }
    };
    _a = JSII_RTTI_SYMBOL_1, DynamoProjectionExpression[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.DynamoProjectionExpression", version: "2.80.0" }, exports2.DynamoProjectionExpression = DynamoProjectionExpression;
    var DynamoAttributeValue = class _DynamoAttributeValue {
      static fromString(value) {
        return new _DynamoAttributeValue({ S: value });
      }
      static fromNumber(value) {
        return new _DynamoAttributeValue({ N: value.toString() });
      }
      static numberFromString(value) {
        return new _DynamoAttributeValue({ N: value.toString() });
      }
      static fromBinary(value) {
        return new _DynamoAttributeValue({ B: value });
      }
      static fromStringSet(value) {
        return new _DynamoAttributeValue({ SS: value });
      }
      static fromNumberSet(value) {
        return new _DynamoAttributeValue({ NS: value.map(String) });
      }
      static numberSetFromStrings(value) {
        return new _DynamoAttributeValue({ NS: value });
      }
      static fromBinarySet(value) {
        return new _DynamoAttributeValue({ BS: value });
      }
      static fromMap(value) {
        return new _DynamoAttributeValue({ M: (0, utils_1.transformAttributeValueMap)(value) });
      }
      static mapFromJsonPath(value) {
        return (0, utils_1.validateJsonPath)(value), new _DynamoAttributeValue({ "M.$": value });
      }
      static fromList(value) {
        return new _DynamoAttributeValue({ L: value.map((val) => val.toObject()) });
      }
      static listFromJsonPath(value) {
        return (0, utils_1.validateJsonPath)(value), new _DynamoAttributeValue({ L: value });
      }
      static fromNull(value) {
        return new _DynamoAttributeValue({ NULL: value });
      }
      static fromBoolean(value) {
        return new _DynamoAttributeValue({ BOOL: value });
      }
      static booleanFromJsonPath(value) {
        return (0, utils_1.validateJsonPath)(value), new _DynamoAttributeValue({ BOOL: value.toString() });
      }
      constructor(value) {
        this.attributeValue = value;
      }
      toObject() {
        return this.attributeValue;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, DynamoAttributeValue[_b] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.DynamoAttributeValue", version: "2.80.0" }, exports2.DynamoAttributeValue = DynamoAttributeValue;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/codebuild/start-build.js
var require_start_build = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/codebuild/start-build.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CodeBuildStartBuild = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var codebuild = require_aws_codebuild();
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var cdk = require_core2();
    var task_utils_1 = require_task_utils();
    var CodeBuildStartBuild = class _CodeBuildStartBuild extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_CodeBuildStartBuildProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CodeBuildStartBuild), error;
        }
        this.integrationPattern = props.integrationPattern ?? sfn.IntegrationPattern.REQUEST_RESPONSE, (0, task_utils_1.validatePatternSupported)(this.integrationPattern, _CodeBuildStartBuild.SUPPORTED_INTEGRATION_PATTERNS), this.taskMetrics = { metricPrefixSingular: "CodeBuildProject", metricPrefixPlural: "CodeBuildProjects", metricDimensions: { ProjectArn: this.props.project.projectArn } }, this.taskPolicies = this.configurePolicyStatements();
      }
      configurePolicyStatements() {
        let policyStatements = [new iam.PolicyStatement({ resources: [this.props.project.projectArn], actions: ["codebuild:StartBuild", "codebuild:StopBuild", "codebuild:BatchGetBuilds", "codebuild:BatchGetReports"] })];
        return this.integrationPattern === sfn.IntegrationPattern.RUN_JOB && policyStatements.push(new iam.PolicyStatement({ actions: ["events:PutTargets", "events:PutRule", "events:DescribeRule"], resources: [cdk.Stack.of(this).formatArn({ service: "events", resource: "rule/StepFunctionsGetEventForCodeBuildStartBuildRule" })] })), policyStatements;
      }
      _renderTask() {
        return { Resource: (0, task_utils_1.integrationResourceArn)("codebuild", "startBuild", this.integrationPattern), Parameters: sfn.FieldUtils.renderObject({ ProjectName: this.props.project.projectName, EnvironmentVariablesOverride: this.props.environmentVariablesOverride ? this.serializeEnvVariables(this.props.environmentVariablesOverride) : void 0 }) };
      }
      serializeEnvVariables(environmentVariables) {
        return Object.keys(environmentVariables).map((name) => ({ Name: name, Type: environmentVariables[name].type || codebuild.BuildEnvironmentVariableType.PLAINTEXT, Value: environmentVariables[name].value }));
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CodeBuildStartBuild[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.CodeBuildStartBuild", version: "2.80.0" }, CodeBuildStartBuild.SUPPORTED_INTEGRATION_PATTERNS = [sfn.IntegrationPattern.REQUEST_RESPONSE, sfn.IntegrationPattern.RUN_JOB], exports2.CodeBuildStartBuild = CodeBuildStartBuild;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/athena/start-query-execution.js
var require_start_query_execution = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/athena/start-query-execution.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EncryptionOption = exports2.AthenaStartQueryExecution = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var cdk = require_core2();
    var task_utils_1 = require_task_utils();
    var AthenaStartQueryExecution = class _AthenaStartQueryExecution extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_AthenaStartQueryExecutionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AthenaStartQueryExecution), error;
        }
        this.integrationPattern = props.integrationPattern ?? sfn.IntegrationPattern.REQUEST_RESPONSE, (0, task_utils_1.validatePatternSupported)(this.integrationPattern, _AthenaStartQueryExecution.SUPPORTED_INTEGRATION_PATTERNS), this.taskPolicies = this.createPolicyStatements();
      }
      createPolicyStatements() {
        const policyStatements = [new iam.PolicyStatement({ resources: [cdk.Stack.of(this).formatArn({ service: "athena", resource: "datacatalog", resourceName: this.props.queryExecutionContext?.catalogName ?? "AwsDataCatalog" }), cdk.Stack.of(this).formatArn({ service: "athena", resource: "workgroup", resourceName: this.props.workGroup ?? "primary" })], actions: ["athena:getDataCatalog", "athena:startQueryExecution", "athena:getQueryExecution"] })];
        return policyStatements.push(new iam.PolicyStatement({ actions: ["s3:CreateBucket", "s3:ListBucket", "s3:GetBucketLocation", "s3:GetObject"], resources: ["*"] })), policyStatements.push(new iam.PolicyStatement({ actions: ["s3:AbortMultipartUpload", "s3:ListBucketMultipartUploads", "s3:ListMultipartUploadParts", "s3:PutObject"], resources: [this.props.resultConfiguration?.outputLocation?.bucketName ? cdk.Stack.of(this).formatArn({ region: "", account: "", service: "s3", resource: this.props.resultConfiguration?.outputLocation?.bucketName, resourceName: this.props.resultConfiguration?.outputLocation?.objectKey }) : "*"] })), policyStatements.push(new iam.PolicyStatement({ actions: ["lakeformation:GetDataAccess"], resources: ["*"] })), policyStatements.push(new iam.PolicyStatement({ actions: ["glue:BatchCreatePartition", "glue:BatchDeletePartition", "glue:BatchDeleteTable", "glue:BatchGetPartition", "glue:CreateDatabase", "glue:CreatePartition", "glue:CreateTable", "glue:DeleteDatabase", "glue:DeletePartition", "glue:DeleteTable", "glue:GetDatabase", "glue:GetDatabases", "glue:GetPartition", "glue:GetPartitions", "glue:GetTable", "glue:GetTables", "glue:UpdateDatabase", "glue:UpdatePartition", "glue:UpdateTable"], resources: [cdk.Stack.of(this).formatArn({ service: "glue", resource: "catalog" }), cdk.Stack.of(this).formatArn({ service: "glue", resource: "database", resourceName: this.props.queryExecutionContext?.databaseName ?? "default" }), cdk.Stack.of(this).formatArn({ service: "glue", resource: "table", resourceName: (this.props.queryExecutionContext?.databaseName ?? "default") + "/*" }), cdk.Stack.of(this).formatArn({ service: "glue", resource: "userDefinedFunction", resourceName: (this.props.queryExecutionContext?.databaseName ?? "default") + "/*" })] })), policyStatements;
      }
      renderEncryption() {
        return this.props.resultConfiguration?.encryptionConfiguration !== void 0 ? { EncryptionOption: this.props.resultConfiguration.encryptionConfiguration.encryptionOption, KmsKey: this.props.resultConfiguration.encryptionConfiguration.encryptionKey } : void 0;
      }
      _renderTask() {
        return { Resource: (0, task_utils_1.integrationResourceArn)("athena", "startQueryExecution", this.integrationPattern), Parameters: sfn.FieldUtils.renderObject({ QueryString: this.props.queryString, ClientRequestToken: this.props.clientRequestToken, QueryExecutionContext: this.props.queryExecutionContext?.catalogName || this.props.queryExecutionContext?.databaseName ? { Catalog: this.props.queryExecutionContext?.catalogName, Database: this.props.queryExecutionContext?.databaseName } : void 0, ResultConfiguration: { EncryptionConfiguration: this.renderEncryption(), OutputLocation: this.props.resultConfiguration?.outputLocation ? `s3://${this.props.resultConfiguration.outputLocation.bucketName}/${this.props.resultConfiguration.outputLocation.objectKey}/` : void 0 }, WorkGroup: this.props?.workGroup }) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AthenaStartQueryExecution[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.AthenaStartQueryExecution", version: "2.80.0" }, AthenaStartQueryExecution.SUPPORTED_INTEGRATION_PATTERNS = [sfn.IntegrationPattern.REQUEST_RESPONSE, sfn.IntegrationPattern.RUN_JOB], exports2.AthenaStartQueryExecution = AthenaStartQueryExecution;
    var EncryptionOption;
    (function(EncryptionOption2) {
      EncryptionOption2.S3_MANAGED = "SSE_S3", EncryptionOption2.KMS = "SSE_KMS", EncryptionOption2.CLIENT_SIDE_KMS = "CSE_KMS";
    })(EncryptionOption = exports2.EncryptionOption || (exports2.EncryptionOption = {}));
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/athena/stop-query-execution.js
var require_stop_query_execution = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/athena/stop-query-execution.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AthenaStopQueryExecution = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var task_utils_1 = require_task_utils();
    var AthenaStopQueryExecution = class _AthenaStopQueryExecution extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_AthenaStopQueryExecutionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AthenaStopQueryExecution), error;
        }
        this.integrationPattern = props.integrationPattern ?? sfn.IntegrationPattern.REQUEST_RESPONSE, (0, task_utils_1.validatePatternSupported)(this.integrationPattern, _AthenaStopQueryExecution.SUPPORTED_INTEGRATION_PATTERNS), this.taskPolicies = [new iam.PolicyStatement({ resources: ["*"], actions: ["athena:stopQueryExecution"] })];
      }
      _renderTask() {
        return { Resource: (0, task_utils_1.integrationResourceArn)("athena", "stopQueryExecution", this.integrationPattern), Parameters: sfn.FieldUtils.renderObject({ QueryExecutionId: this.props.queryExecutionId }) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AthenaStopQueryExecution[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.AthenaStopQueryExecution", version: "2.80.0" }, AthenaStopQueryExecution.SUPPORTED_INTEGRATION_PATTERNS = [sfn.IntegrationPattern.REQUEST_RESPONSE], exports2.AthenaStopQueryExecution = AthenaStopQueryExecution;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/athena/get-query-execution.js
var require_get_query_execution = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/athena/get-query-execution.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AthenaGetQueryExecution = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var task_utils_1 = require_task_utils();
    var AthenaGetQueryExecution = class _AthenaGetQueryExecution extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_AthenaGetQueryExecutionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AthenaGetQueryExecution), error;
        }
        this.integrationPattern = props.integrationPattern ?? sfn.IntegrationPattern.REQUEST_RESPONSE, (0, task_utils_1.validatePatternSupported)(this.integrationPattern, _AthenaGetQueryExecution.SUPPORTED_INTEGRATION_PATTERNS), this.taskPolicies = [new iam.PolicyStatement({ resources: ["*"], actions: ["athena:getQueryExecution"] })];
      }
      _renderTask() {
        return { Resource: (0, task_utils_1.integrationResourceArn)("athena", "getQueryExecution", this.integrationPattern), Parameters: sfn.FieldUtils.renderObject({ QueryExecutionId: this.props.queryExecutionId }) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AthenaGetQueryExecution[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.AthenaGetQueryExecution", version: "2.80.0" }, AthenaGetQueryExecution.SUPPORTED_INTEGRATION_PATTERNS = [sfn.IntegrationPattern.REQUEST_RESPONSE], exports2.AthenaGetQueryExecution = AthenaGetQueryExecution;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/athena/get-query-results.js
var require_get_query_results = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/athena/get-query-results.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AthenaGetQueryResults = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var task_utils_1 = require_task_utils();
    var AthenaGetQueryResults = class _AthenaGetQueryResults extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_AthenaGetQueryResultsProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _AthenaGetQueryResults), error;
        }
        this.integrationPattern = props.integrationPattern ?? sfn.IntegrationPattern.REQUEST_RESPONSE, (0, task_utils_1.validatePatternSupported)(this.integrationPattern, _AthenaGetQueryResults.SUPPORTED_INTEGRATION_PATTERNS);
        const policyStatements = [new iam.PolicyStatement({ resources: ["*"], actions: ["athena:getQueryResults"] })];
        policyStatements.push(new iam.PolicyStatement({ actions: ["s3:GetObject"], resources: ["*"] })), this.taskPolicies = policyStatements;
      }
      _renderTask() {
        return { Resource: (0, task_utils_1.integrationResourceArn)("athena", "getQueryResults", this.integrationPattern), Parameters: sfn.FieldUtils.renderObject({ QueryExecutionId: this.props.queryExecutionId, NextToken: this.props.nextToken, MaxResults: this.props.maxResults }) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, AthenaGetQueryResults[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.AthenaGetQueryResults", version: "2.80.0" }, AthenaGetQueryResults.SUPPORTED_INTEGRATION_PATTERNS = [sfn.IntegrationPattern.REQUEST_RESPONSE], exports2.AthenaGetQueryResults = AthenaGetQueryResults;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/databrew/start-job-run.js
var require_start_job_run3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/databrew/start-job-run.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.GlueDataBrewStartJobRun = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var cdk = require_core2();
    var task_utils_1 = require_task_utils();
    var GlueDataBrewStartJobRun = class _GlueDataBrewStartJobRun extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_GlueDataBrewStartJobRunProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _GlueDataBrewStartJobRun), error;
        }
        this.integrationPattern = props.integrationPattern ?? sfn.IntegrationPattern.REQUEST_RESPONSE, (0, task_utils_1.validatePatternSupported)(this.integrationPattern, _GlueDataBrewStartJobRun.SUPPORTED_INTEGRATION_PATTERNS);
        const actions = ["databrew:startJobRun"];
        this.integrationPattern === sfn.IntegrationPattern.RUN_JOB && actions.push("databrew:stopJobRun", "databrew:listJobRuns"), this.taskPolicies = [new iam.PolicyStatement({ resources: [cdk.Stack.of(this).formatArn({ service: "databrew", resource: "job", resourceName: sfn.JsonPath.isEncodedJsonPath(this.props.name) ? "*" : this.props.name })], actions })];
      }
      _renderTask() {
        return { Resource: (0, task_utils_1.integrationResourceArn)("databrew", "startJobRun", this.integrationPattern), Parameters: sfn.FieldUtils.renderObject({ Name: this.props.name }) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, GlueDataBrewStartJobRun[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.GlueDataBrewStartJobRun", version: "2.80.0" }, GlueDataBrewStartJobRun.SUPPORTED_INTEGRATION_PATTERNS = [sfn.IntegrationPattern.REQUEST_RESPONSE, sfn.IntegrationPattern.RUN_JOB], exports2.GlueDataBrewStartJobRun = GlueDataBrewStartJobRun;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/eks/call.js
var require_call = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/eks/call.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.HttpMethods = exports2.EksCall = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var sfn = require_aws_stepfunctions();
    var task_utils_1 = require_task_utils();
    var EksCall = class _EksCall extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_EksCallProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EksCall), error;
        }
        this.integrationPattern = props.integrationPattern ?? sfn.IntegrationPattern.REQUEST_RESPONSE, (0, task_utils_1.validatePatternSupported)(this.integrationPattern, _EksCall.SUPPORTED_INTEGRATION_PATTERNS);
        try {
          this.clusterEndpoint = this.props.cluster.clusterEndpoint;
        } catch {
          throw new Error('The "clusterEndpoint" property must be specified when using an imported Cluster.');
        }
        try {
          this.clusterCertificateAuthorityData = this.props.cluster.clusterCertificateAuthorityData;
        } catch {
          throw new Error('The "clusterCertificateAuthorityData" property must be specified when using an imported Cluster.');
        }
      }
      _renderTask() {
        return { Resource: (0, task_utils_1.integrationResourceArn)("eks", "call", this.integrationPattern), Parameters: sfn.FieldUtils.renderObject({ ClusterName: this.props.cluster.clusterName, CertificateAuthority: this.clusterCertificateAuthorityData, Endpoint: this.clusterEndpoint, Method: this.props.httpMethod, Path: this.props.httpPath, QueryParameters: this.props.queryParameters, RequestBody: this.props.requestBody?.value }) };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EksCall[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.EksCall", version: "2.80.0" }, EksCall.SUPPORTED_INTEGRATION_PATTERNS = [sfn.IntegrationPattern.REQUEST_RESPONSE], exports2.EksCall = EksCall;
    var HttpMethods;
    (function(HttpMethods2) {
      HttpMethods2.GET = "GET", HttpMethods2.POST = "POST", HttpMethods2.PUT = "PUT", HttpMethods2.DELETE = "DELETE", HttpMethods2.PATCH = "PATCH", HttpMethods2.HEAD = "HEAD";
    })(HttpMethods = exports2.HttpMethods || (exports2.HttpMethods = {}));
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/apigateway/base-types.js
var require_base_types2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/apigateway/base-types.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AuthType = exports2.HttpMethod = void 0;
    var HttpMethod;
    (function(HttpMethod2) {
      HttpMethod2.GET = "GET", HttpMethod2.POST = "POST", HttpMethod2.PUT = "PUT", HttpMethod2.DELETE = "DELETE", HttpMethod2.PATCH = "PATCH", HttpMethod2.HEAD = "HEAD", HttpMethod2.OPTIONS = "OPTIONS";
    })(HttpMethod = exports2.HttpMethod || (exports2.HttpMethod = {}));
    var AuthType;
    (function(AuthType2) {
      AuthType2.NO_AUTH = "NO_AUTH", AuthType2.IAM_ROLE = "IAM_ROLE", AuthType2.RESOURCE_POLICY = "RESOURCE_POLICY";
    })(AuthType = exports2.AuthType || (exports2.AuthType = {}));
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/apigateway/base.js
var require_base2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/apigateway/base.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CallApiGatewayEndpointBase = void 0;
    var base_types_1 = require_base_types2();
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var task_utils_1 = require_task_utils();
    var CallApiGatewayEndpointBase = class _CallApiGatewayEndpointBase extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        if (super(scope, id, props), this.baseProps = props, this.integrationPattern = props.integrationPattern ?? sfn.IntegrationPattern.REQUEST_RESPONSE, (0, task_utils_1.validatePatternSupported)(this.integrationPattern, _CallApiGatewayEndpointBase.SUPPORTED_INTEGRATION_PATTERNS), this.integrationPattern === sfn.IntegrationPattern.WAIT_FOR_TASK_TOKEN && !sfn.FieldUtils.containsTaskToken(this.baseProps.headers))
          throw new Error("Task Token is required in `headers` for WAIT_FOR_TASK_TOKEN pattern. Use JsonPath.taskToken to set the token.");
      }
      _renderTask() {
        return { Resource: (0, task_utils_1.integrationResourceArn)("apigateway", "invoke", this.integrationPattern), Parameters: sfn.FieldUtils.renderObject({ ApiEndpoint: this.apiEndpoint, Method: this.baseProps.method, Headers: this.baseProps.headers?.value, Stage: this.stageName, Path: this.baseProps.apiPath, QueryParameters: this.baseProps.queryParameters?.value, RequestBody: this.baseProps.requestBody?.value, AuthType: this.baseProps.authType ? this.baseProps.authType : "NO_AUTH" }) };
      }
      createPolicyStatements() {
        return this.baseProps.authType === base_types_1.AuthType.NO_AUTH ? [] : [new iam.PolicyStatement({ resources: [this.arnForExecuteApi], actions: ["execute-api:Invoke"] })];
      }
    };
    CallApiGatewayEndpointBase.SUPPORTED_INTEGRATION_PATTERNS = [sfn.IntegrationPattern.REQUEST_RESPONSE, sfn.IntegrationPattern.WAIT_FOR_TASK_TOKEN], exports2.CallApiGatewayEndpointBase = CallApiGatewayEndpointBase;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/apigateway/call-rest-api.js
var require_call_rest_api = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/apigateway/call-rest-api.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CallApiGatewayRestApiEndpoint = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var base_1 = require_base2();
    var cdk = require_core2();
    var CallApiGatewayRestApiEndpoint = class _CallApiGatewayRestApiEndpoint extends base_1.CallApiGatewayEndpointBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_CallApiGatewayRestApiEndpointProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CallApiGatewayRestApiEndpoint), error;
        }
        this.apiEndpoint = this.getApiEndpoint(), this.arnForExecuteApi = props.api.arnForExecuteApi(props.method, props.apiPath, props.stageName), this.stageName = props.stageName, this.taskPolicies = this.createPolicyStatements();
      }
      getApiEndpoint() {
        const apiStack = cdk.Stack.of(this.props.api);
        return `${this.props.api.restApiId}.execute-api.${apiStack.region}.${apiStack.urlSuffix}`;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CallApiGatewayRestApiEndpoint[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.CallApiGatewayRestApiEndpoint", version: "2.80.0" }, exports2.CallApiGatewayRestApiEndpoint = CallApiGatewayRestApiEndpoint;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/apigateway/call-http-api.js
var require_call_http_api = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/apigateway/call-http-api.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CallApiGatewayHttpApiEndpoint = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var base_1 = require_base2();
    var cdk = require_core2();
    var CallApiGatewayHttpApiEndpoint = class _CallApiGatewayHttpApiEndpoint extends base_1.CallApiGatewayEndpointBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_CallApiGatewayHttpApiEndpointProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CallApiGatewayHttpApiEndpoint), error;
        }
        this.apiEndpoint = this.getApiEndpoint(), this.arnForExecuteApi = this.getArnForExecuteApi(), this.stageName = props.stageName, this.taskPolicies = this.createPolicyStatements();
      }
      getApiEndpoint() {
        const apiStack = this.props.apiStack;
        return `${this.props.apiId}.execute-api.${apiStack.region}.${apiStack.urlSuffix}`;
      }
      getArnForExecuteApi() {
        const { apiId, stageName, method, apiPath } = this.props;
        return this.props.apiStack.formatArn({ service: "execute-api", resource: apiId, arnFormat: cdk.ArnFormat.SLASH_RESOURCE_NAME, resourceName: `${stageName}/${method}${apiPath}` });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CallApiGatewayHttpApiEndpoint[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.CallApiGatewayHttpApiEndpoint", version: "2.80.0" }, exports2.CallApiGatewayHttpApiEndpoint = CallApiGatewayHttpApiEndpoint;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/apigateway/index.js
var require_apigateway3 = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/apigateway/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_base_types2(), exports2), __exportStar(require_call_rest_api(), exports2), __exportStar(require_call_http_api(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/eventbridge/put-events.js
var require_put_events = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/eventbridge/put-events.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.EventBridgePutEvents = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var cdk = require_core2();
    var task_utils_1 = require_task_utils();
    var EventBridgePutEvents = class _EventBridgePutEvents extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_EventBridgePutEventsProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _EventBridgePutEvents), error;
        }
        if (this.integrationPattern = props.integrationPattern ?? sfn.IntegrationPattern.REQUEST_RESPONSE, (0, task_utils_1.validatePatternSupported)(this.integrationPattern, _EventBridgePutEvents.SUPPORTED_INTEGRATION_PATTERNS), this.integrationPattern === sfn.IntegrationPattern.WAIT_FOR_TASK_TOKEN && !sfn.FieldUtils.containsTaskToken(props.entries.map((entry) => entry.detail)))
          throw new Error("Task Token is required in `entries`. Use JsonPath.taskToken to set the token.");
        this.validateEntries(), this.taskPolicies = [new iam.PolicyStatement({ actions: ["events:PutEvents"], resources: this.eventBusArns })];
      }
      get eventBusArns() {
        return this.props.entries.map((entry) => entry.eventBus ? entry.eventBus.eventBusArn : cdk.Stack.of(this).formatArn({ resource: "event-bus", resourceName: "default", arnFormat: cdk.ArnFormat.SLASH_RESOURCE_NAME, service: "events" }));
      }
      _renderTask() {
        return { Resource: (0, task_utils_1.integrationResourceArn)("events", "putEvents", this.integrationPattern), Parameters: sfn.FieldUtils.renderObject({ Entries: this.renderEntries() }) };
      }
      renderEntries() {
        return this.props.entries.map((entry) => {
          if (entry.source?.startsWith("aws"))
            throw new Error('Event source cannot start with "aws."');
          return { Detail: entry.detail?.value, DetailType: entry.detailType, EventBusName: entry.eventBus?.eventBusArn, Source: entry.source };
        });
      }
      validateEntries() {
        if (this.props.entries.length <= 0)
          throw new Error("Value for property `entries` must be a non-empty array.");
      }
    };
    _a = JSII_RTTI_SYMBOL_1, EventBridgePutEvents[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.EventBridgePutEvents", version: "2.80.0" }, EventBridgePutEvents.SUPPORTED_INTEGRATION_PATTERNS = [sfn.IntegrationPattern.REQUEST_RESPONSE, sfn.IntegrationPattern.WAIT_FOR_TASK_TOKEN], exports2.EventBridgePutEvents = EventBridgePutEvents;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/aws-sdk/call-aws-service.js
var require_call_aws_service = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/aws-sdk/call-aws-service.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CallAwsService = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var iam = require_aws_iam();
    var sfn = require_aws_stepfunctions();
    var core_1 = require_core2();
    var task_utils_1 = require_task_utils();
    var CallAwsService = class _CallAwsService extends sfn.TaskStateBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_stepfunctions_tasks_CallAwsServiceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CallAwsService), error;
        }
        if (this.props.integrationPattern === sfn.IntegrationPattern.RUN_JOB)
          throw new Error("The RUN_JOB integration pattern is not supported for CallAwsService");
        const iamService = { sfn: "states" }[props.service] ?? props.service;
        this.taskPolicies = [new iam.PolicyStatement({ resources: props.iamResources, actions: [props.iamAction ?? `${iamService}:${props.action}`] }), ...props.additionalIamStatements ?? []];
      }
      _renderTask() {
        let service = this.props.service;
        return core_1.Token.isUnresolved(service) || (service = service.toLowerCase()), { Resource: (0, task_utils_1.integrationResourceArn)("aws-sdk", `${service}:${this.props.action}`, this.props.integrationPattern), Parameters: sfn.FieldUtils.renderObject(this.props.parameters) ?? {} };
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CallAwsService[_a] = { fqn: "aws-cdk-lib.aws_stepfunctions_tasks.CallAwsService", version: "2.80.0" }, exports2.CallAwsService = CallAwsService;
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/index.js
var require_lib246 = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_invoke_function(), exports2), __exportStar(require_run_lambda_task(), exports2), __exportStar(require_invoke(), exports2), __exportStar(require_invoke_activity(), exports2), __exportStar(require_run_ecs_task_base(), exports2), __exportStar(require_run_ecs_task_base_types(), exports2), __exportStar(require_publish_to_topic(), exports2), __exportStar(require_publish(), exports2), __exportStar(require_send_to_queue(), exports2), __exportStar(require_send_message(), exports2), __exportStar(require_run_ecs_ec2_task(), exports2), __exportStar(require_run_ecs_fargate_task(), exports2), __exportStar(require_run_task(), exports2), __exportStar(require_base_types(), exports2), __exportStar(require_create_training_job(), exports2), __exportStar(require_create_transform_job(), exports2), __exportStar(require_create_endpoint(), exports2), __exportStar(require_create_endpoint_config(), exports2), __exportStar(require_create_model(), exports2), __exportStar(require_update_endpoint(), exports2), __exportStar(require_start_execution(), exports2), __exportStar(require_start_execution2(), exports2), __exportStar(require_invoke_activity2(), exports2), __exportStar(require_evaluate_expression(), exports2), __exportStar(require_emr_create_cluster(), exports2), __exportStar(require_emr_set_cluster_termination_protection(), exports2), __exportStar(require_emr_terminate_cluster(), exports2), __exportStar(require_emr_add_step(), exports2), __exportStar(require_emr_cancel_step(), exports2), __exportStar(require_emr_modify_instance_fleet_by_name(), exports2), __exportStar(require_emr_modify_instance_group_by_name(), exports2), __exportStar(require_create_virtual_cluster(), exports2), __exportStar(require_delete_virtual_cluster(), exports2), __exportStar(require_start_job_run(), exports2), __exportStar(require_run_glue_job_task(), exports2), __exportStar(require_start_job_run2(), exports2), __exportStar(require_run_batch_job(), exports2), __exportStar(require_submit_job(), exports2), __exportStar(require_get_item(), exports2), __exportStar(require_put_item(), exports2), __exportStar(require_update_item(), exports2), __exportStar(require_delete_item(), exports2), __exportStar(require_shared_types(), exports2), __exportStar(require_start_build(), exports2), __exportStar(require_start_query_execution(), exports2), __exportStar(require_stop_query_execution(), exports2), __exportStar(require_get_query_execution(), exports2), __exportStar(require_get_query_results(), exports2), __exportStar(require_start_job_run3(), exports2), __exportStar(require_call(), exports2), __exportStar(require_apigateway3(), exports2), __exportStar(require_put_events(), exports2), __exportStar(require_call_aws_service(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-stepfunctions-tasks/index.js
var require_aws_stepfunctions_tasks = __commonJS({
  "node_modules/aws-cdk-lib/aws-stepfunctions-tasks/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib246(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-supportapp/lib/supportapp.generated.js
var require_supportapp_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-supportapp/lib/supportapp.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnSlackWorkspaceConfiguration = exports2.CfnSlackChannelConfiguration = exports2.CfnAccountAlias = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAccountAliasPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accountAlias", cdk.requiredValidator)(properties.accountAlias)), errors.collect(cdk.propertyValidator("accountAlias", cdk.validateString)(properties.accountAlias)), errors.wrap('supplied properties not correct for "CfnAccountAliasProps"');
    }
    function cfnAccountAliasPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccountAliasPropsValidator(properties).assertSuccess(), { AccountAlias: cdk.stringToCloudFormation(properties.accountAlias) }) : properties;
    }
    function CfnAccountAliasPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accountAlias", "AccountAlias", cfn_parse.FromCloudFormation.getString(properties.AccountAlias)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAccountAlias = class _CfnAccountAlias extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAccountAliasPropsFromCloudFormation(resourceProperties), ret = new _CfnAccountAlias(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAccountAlias.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_supportapp_CfnAccountAliasProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAccountAlias), error;
        }
        cdk.requireProperty(props, "accountAlias", this), this.attrAccountAliasResourceId = cdk.Token.asString(this.getAtt("AccountAliasResourceId", cdk.ResolutionTypeHint.STRING)), this.accountAlias = props.accountAlias;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAccountAlias.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { accountAlias: this.accountAlias };
      }
      renderProperties(props) {
        return cfnAccountAliasPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAccountAlias[_a] = { fqn: "aws-cdk-lib.aws_supportapp.CfnAccountAlias", version: "2.80.0" }, CfnAccountAlias.CFN_RESOURCE_TYPE_NAME = "AWS::SupportApp::AccountAlias", exports2.CfnAccountAlias = CfnAccountAlias;
    function CfnSlackChannelConfigurationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("channelId", cdk.requiredValidator)(properties.channelId)), errors.collect(cdk.propertyValidator("channelId", cdk.validateString)(properties.channelId)), errors.collect(cdk.propertyValidator("channelName", cdk.validateString)(properties.channelName)), errors.collect(cdk.propertyValidator("channelRoleArn", cdk.requiredValidator)(properties.channelRoleArn)), errors.collect(cdk.propertyValidator("channelRoleArn", cdk.validateString)(properties.channelRoleArn)), errors.collect(cdk.propertyValidator("notifyOnAddCorrespondenceToCase", cdk.validateBoolean)(properties.notifyOnAddCorrespondenceToCase)), errors.collect(cdk.propertyValidator("notifyOnCaseSeverity", cdk.requiredValidator)(properties.notifyOnCaseSeverity)), errors.collect(cdk.propertyValidator("notifyOnCaseSeverity", cdk.validateString)(properties.notifyOnCaseSeverity)), errors.collect(cdk.propertyValidator("notifyOnCreateOrReopenCase", cdk.validateBoolean)(properties.notifyOnCreateOrReopenCase)), errors.collect(cdk.propertyValidator("notifyOnResolveCase", cdk.validateBoolean)(properties.notifyOnResolveCase)), errors.collect(cdk.propertyValidator("teamId", cdk.requiredValidator)(properties.teamId)), errors.collect(cdk.propertyValidator("teamId", cdk.validateString)(properties.teamId)), errors.wrap('supplied properties not correct for "CfnSlackChannelConfigurationProps"');
    }
    function cfnSlackChannelConfigurationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSlackChannelConfigurationPropsValidator(properties).assertSuccess(), { ChannelId: cdk.stringToCloudFormation(properties.channelId), ChannelRoleArn: cdk.stringToCloudFormation(properties.channelRoleArn), NotifyOnCaseSeverity: cdk.stringToCloudFormation(properties.notifyOnCaseSeverity), TeamId: cdk.stringToCloudFormation(properties.teamId), ChannelName: cdk.stringToCloudFormation(properties.channelName), NotifyOnAddCorrespondenceToCase: cdk.booleanToCloudFormation(properties.notifyOnAddCorrespondenceToCase), NotifyOnCreateOrReopenCase: cdk.booleanToCloudFormation(properties.notifyOnCreateOrReopenCase), NotifyOnResolveCase: cdk.booleanToCloudFormation(properties.notifyOnResolveCase) }) : properties;
    }
    function CfnSlackChannelConfigurationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("channelId", "ChannelId", cfn_parse.FromCloudFormation.getString(properties.ChannelId)), ret.addPropertyResult("channelRoleArn", "ChannelRoleArn", cfn_parse.FromCloudFormation.getString(properties.ChannelRoleArn)), ret.addPropertyResult("notifyOnCaseSeverity", "NotifyOnCaseSeverity", cfn_parse.FromCloudFormation.getString(properties.NotifyOnCaseSeverity)), ret.addPropertyResult("teamId", "TeamId", cfn_parse.FromCloudFormation.getString(properties.TeamId)), ret.addPropertyResult("channelName", "ChannelName", properties.ChannelName != null ? cfn_parse.FromCloudFormation.getString(properties.ChannelName) : void 0), ret.addPropertyResult("notifyOnAddCorrespondenceToCase", "NotifyOnAddCorrespondenceToCase", properties.NotifyOnAddCorrespondenceToCase != null ? cfn_parse.FromCloudFormation.getBoolean(properties.NotifyOnAddCorrespondenceToCase) : void 0), ret.addPropertyResult("notifyOnCreateOrReopenCase", "NotifyOnCreateOrReopenCase", properties.NotifyOnCreateOrReopenCase != null ? cfn_parse.FromCloudFormation.getBoolean(properties.NotifyOnCreateOrReopenCase) : void 0), ret.addPropertyResult("notifyOnResolveCase", "NotifyOnResolveCase", properties.NotifyOnResolveCase != null ? cfn_parse.FromCloudFormation.getBoolean(properties.NotifyOnResolveCase) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSlackChannelConfiguration = class _CfnSlackChannelConfiguration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSlackChannelConfigurationPropsFromCloudFormation(resourceProperties), ret = new _CfnSlackChannelConfiguration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSlackChannelConfiguration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_supportapp_CfnSlackChannelConfigurationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSlackChannelConfiguration), error;
        }
        cdk.requireProperty(props, "channelId", this), cdk.requireProperty(props, "channelRoleArn", this), cdk.requireProperty(props, "notifyOnCaseSeverity", this), cdk.requireProperty(props, "teamId", this), this.channelId = props.channelId, this.channelRoleArn = props.channelRoleArn, this.notifyOnCaseSeverity = props.notifyOnCaseSeverity, this.teamId = props.teamId, this.channelName = props.channelName, this.notifyOnAddCorrespondenceToCase = props.notifyOnAddCorrespondenceToCase, this.notifyOnCreateOrReopenCase = props.notifyOnCreateOrReopenCase, this.notifyOnResolveCase = props.notifyOnResolveCase;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSlackChannelConfiguration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { channelId: this.channelId, channelRoleArn: this.channelRoleArn, notifyOnCaseSeverity: this.notifyOnCaseSeverity, teamId: this.teamId, channelName: this.channelName, notifyOnAddCorrespondenceToCase: this.notifyOnAddCorrespondenceToCase, notifyOnCreateOrReopenCase: this.notifyOnCreateOrReopenCase, notifyOnResolveCase: this.notifyOnResolveCase };
      }
      renderProperties(props) {
        return cfnSlackChannelConfigurationPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnSlackChannelConfiguration[_b] = { fqn: "aws-cdk-lib.aws_supportapp.CfnSlackChannelConfiguration", version: "2.80.0" }, CfnSlackChannelConfiguration.CFN_RESOURCE_TYPE_NAME = "AWS::SupportApp::SlackChannelConfiguration", exports2.CfnSlackChannelConfiguration = CfnSlackChannelConfiguration;
    function CfnSlackWorkspaceConfigurationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("teamId", cdk.requiredValidator)(properties.teamId)), errors.collect(cdk.propertyValidator("teamId", cdk.validateString)(properties.teamId)), errors.collect(cdk.propertyValidator("versionId", cdk.validateString)(properties.versionId)), errors.wrap('supplied properties not correct for "CfnSlackWorkspaceConfigurationProps"');
    }
    function cfnSlackWorkspaceConfigurationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSlackWorkspaceConfigurationPropsValidator(properties).assertSuccess(), { TeamId: cdk.stringToCloudFormation(properties.teamId), VersionId: cdk.stringToCloudFormation(properties.versionId) }) : properties;
    }
    function CfnSlackWorkspaceConfigurationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("teamId", "TeamId", cfn_parse.FromCloudFormation.getString(properties.TeamId)), ret.addPropertyResult("versionId", "VersionId", properties.VersionId != null ? cfn_parse.FromCloudFormation.getString(properties.VersionId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSlackWorkspaceConfiguration = class _CfnSlackWorkspaceConfiguration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSlackWorkspaceConfigurationPropsFromCloudFormation(resourceProperties), ret = new _CfnSlackWorkspaceConfiguration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSlackWorkspaceConfiguration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_supportapp_CfnSlackWorkspaceConfigurationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSlackWorkspaceConfiguration), error;
        }
        cdk.requireProperty(props, "teamId", this), this.teamId = props.teamId, this.versionId = props.versionId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSlackWorkspaceConfiguration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { teamId: this.teamId, versionId: this.versionId };
      }
      renderProperties(props) {
        return cfnSlackWorkspaceConfigurationPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnSlackWorkspaceConfiguration[_c] = { fqn: "aws-cdk-lib.aws_supportapp.CfnSlackWorkspaceConfiguration", version: "2.80.0" }, CfnSlackWorkspaceConfiguration.CFN_RESOURCE_TYPE_NAME = "AWS::SupportApp::SlackWorkspaceConfiguration", exports2.CfnSlackWorkspaceConfiguration = CfnSlackWorkspaceConfiguration;
  }
});

// node_modules/aws-cdk-lib/aws-supportapp/lib/index.js
var require_lib247 = __commonJS({
  "node_modules/aws-cdk-lib/aws-supportapp/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_supportapp_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-supportapp/index.js
var require_aws_supportapp = __commonJS({
  "node_modules/aws-cdk-lib/aws-supportapp/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib247(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-synthetics/lib/synthetics.generated.js
var require_synthetics_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-synthetics/lib/synthetics.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnGroup = exports2.CfnCanary = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnCanaryPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("artifactConfig", CfnCanary_ArtifactConfigPropertyValidator)(properties.artifactConfig)), errors.collect(cdk.propertyValidator("artifactS3Location", cdk.requiredValidator)(properties.artifactS3Location)), errors.collect(cdk.propertyValidator("artifactS3Location", cdk.validateString)(properties.artifactS3Location)), errors.collect(cdk.propertyValidator("code", cdk.requiredValidator)(properties.code)), errors.collect(cdk.propertyValidator("code", CfnCanary_CodePropertyValidator)(properties.code)), errors.collect(cdk.propertyValidator("deleteLambdaResourcesOnCanaryDeletion", cdk.validateBoolean)(properties.deleteLambdaResourcesOnCanaryDeletion)), errors.collect(cdk.propertyValidator("executionRoleArn", cdk.requiredValidator)(properties.executionRoleArn)), errors.collect(cdk.propertyValidator("executionRoleArn", cdk.validateString)(properties.executionRoleArn)), errors.collect(cdk.propertyValidator("failureRetentionPeriod", cdk.validateNumber)(properties.failureRetentionPeriod)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("runConfig", CfnCanary_RunConfigPropertyValidator)(properties.runConfig)), errors.collect(cdk.propertyValidator("runtimeVersion", cdk.requiredValidator)(properties.runtimeVersion)), errors.collect(cdk.propertyValidator("runtimeVersion", cdk.validateString)(properties.runtimeVersion)), errors.collect(cdk.propertyValidator("schedule", cdk.requiredValidator)(properties.schedule)), errors.collect(cdk.propertyValidator("schedule", CfnCanary_SchedulePropertyValidator)(properties.schedule)), errors.collect(cdk.propertyValidator("startCanaryAfterCreation", cdk.requiredValidator)(properties.startCanaryAfterCreation)), errors.collect(cdk.propertyValidator("startCanaryAfterCreation", cdk.validateBoolean)(properties.startCanaryAfterCreation)), errors.collect(cdk.propertyValidator("successRetentionPeriod", cdk.validateNumber)(properties.successRetentionPeriod)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpcConfig", CfnCanary_VPCConfigPropertyValidator)(properties.vpcConfig)), errors.collect(cdk.propertyValidator("visualReference", CfnCanary_VisualReferencePropertyValidator)(properties.visualReference)), errors.wrap('supplied properties not correct for "CfnCanaryProps"');
    }
    function cfnCanaryPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCanaryPropsValidator(properties).assertSuccess(), { ArtifactS3Location: cdk.stringToCloudFormation(properties.artifactS3Location), Code: cfnCanaryCodePropertyToCloudFormation(properties.code), ExecutionRoleArn: cdk.stringToCloudFormation(properties.executionRoleArn), Name: cdk.stringToCloudFormation(properties.name), RuntimeVersion: cdk.stringToCloudFormation(properties.runtimeVersion), Schedule: cfnCanarySchedulePropertyToCloudFormation(properties.schedule), StartCanaryAfterCreation: cdk.booleanToCloudFormation(properties.startCanaryAfterCreation), ArtifactConfig: cfnCanaryArtifactConfigPropertyToCloudFormation(properties.artifactConfig), DeleteLambdaResourcesOnCanaryDeletion: cdk.booleanToCloudFormation(properties.deleteLambdaResourcesOnCanaryDeletion), FailureRetentionPeriod: cdk.numberToCloudFormation(properties.failureRetentionPeriod), RunConfig: cfnCanaryRunConfigPropertyToCloudFormation(properties.runConfig), SuccessRetentionPeriod: cdk.numberToCloudFormation(properties.successRetentionPeriod), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VisualReference: cfnCanaryVisualReferencePropertyToCloudFormation(properties.visualReference), VPCConfig: cfnCanaryVPCConfigPropertyToCloudFormation(properties.vpcConfig) }) : properties;
    }
    function CfnCanaryPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("artifactS3Location", "ArtifactS3Location", cfn_parse.FromCloudFormation.getString(properties.ArtifactS3Location)), ret.addPropertyResult("code", "Code", CfnCanaryCodePropertyFromCloudFormation(properties.Code)), ret.addPropertyResult("executionRoleArn", "ExecutionRoleArn", cfn_parse.FromCloudFormation.getString(properties.ExecutionRoleArn)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("runtimeVersion", "RuntimeVersion", cfn_parse.FromCloudFormation.getString(properties.RuntimeVersion)), ret.addPropertyResult("schedule", "Schedule", CfnCanarySchedulePropertyFromCloudFormation(properties.Schedule)), ret.addPropertyResult("startCanaryAfterCreation", "StartCanaryAfterCreation", cfn_parse.FromCloudFormation.getBoolean(properties.StartCanaryAfterCreation)), ret.addPropertyResult("artifactConfig", "ArtifactConfig", properties.ArtifactConfig != null ? CfnCanaryArtifactConfigPropertyFromCloudFormation(properties.ArtifactConfig) : void 0), ret.addPropertyResult("deleteLambdaResourcesOnCanaryDeletion", "DeleteLambdaResourcesOnCanaryDeletion", properties.DeleteLambdaResourcesOnCanaryDeletion != null ? cfn_parse.FromCloudFormation.getBoolean(properties.DeleteLambdaResourcesOnCanaryDeletion) : void 0), ret.addPropertyResult("failureRetentionPeriod", "FailureRetentionPeriod", properties.FailureRetentionPeriod != null ? cfn_parse.FromCloudFormation.getNumber(properties.FailureRetentionPeriod) : void 0), ret.addPropertyResult("runConfig", "RunConfig", properties.RunConfig != null ? CfnCanaryRunConfigPropertyFromCloudFormation(properties.RunConfig) : void 0), ret.addPropertyResult("successRetentionPeriod", "SuccessRetentionPeriod", properties.SuccessRetentionPeriod != null ? cfn_parse.FromCloudFormation.getNumber(properties.SuccessRetentionPeriod) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("visualReference", "VisualReference", properties.VisualReference != null ? CfnCanaryVisualReferencePropertyFromCloudFormation(properties.VisualReference) : void 0), ret.addPropertyResult("vpcConfig", "VPCConfig", properties.VPCConfig != null ? CfnCanaryVPCConfigPropertyFromCloudFormation(properties.VPCConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCanary = class _CfnCanary extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCanaryPropsFromCloudFormation(resourceProperties), ret = new _CfnCanary(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCanary.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_synthetics_CfnCanaryProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCanary), error;
        }
        cdk.requireProperty(props, "artifactS3Location", this), cdk.requireProperty(props, "code", this), cdk.requireProperty(props, "executionRoleArn", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "runtimeVersion", this), cdk.requireProperty(props, "schedule", this), cdk.requireProperty(props, "startCanaryAfterCreation", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrState = cdk.Token.asString(this.getAtt("State", cdk.ResolutionTypeHint.STRING)), this.artifactS3Location = props.artifactS3Location, this.code = props.code, this.executionRoleArn = props.executionRoleArn, this.name = props.name, this.runtimeVersion = props.runtimeVersion, this.schedule = props.schedule, this.startCanaryAfterCreation = props.startCanaryAfterCreation, this.artifactConfig = props.artifactConfig, this.deleteLambdaResourcesOnCanaryDeletion = props.deleteLambdaResourcesOnCanaryDeletion, this.failureRetentionPeriod = props.failureRetentionPeriod, this.runConfig = props.runConfig, this.successRetentionPeriod = props.successRetentionPeriod, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Synthetics::Canary", props.tags, { tagPropertyName: "tags" }), this.visualReference = props.visualReference, this.vpcConfig = props.vpcConfig;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCanary.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { artifactS3Location: this.artifactS3Location, code: this.code, executionRoleArn: this.executionRoleArn, name: this.name, runtimeVersion: this.runtimeVersion, schedule: this.schedule, startCanaryAfterCreation: this.startCanaryAfterCreation, artifactConfig: this.artifactConfig, deleteLambdaResourcesOnCanaryDeletion: this.deleteLambdaResourcesOnCanaryDeletion, failureRetentionPeriod: this.failureRetentionPeriod, runConfig: this.runConfig, successRetentionPeriod: this.successRetentionPeriod, tags: this.tags.renderTags(), visualReference: this.visualReference, vpcConfig: this.vpcConfig };
      }
      renderProperties(props) {
        return cfnCanaryPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnCanary[_a] = { fqn: "aws-cdk-lib.aws_synthetics.CfnCanary", version: "2.80.0" }, CfnCanary.CFN_RESOURCE_TYPE_NAME = "AWS::Synthetics::Canary", exports2.CfnCanary = CfnCanary;
    function CfnCanary_ArtifactConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3Encryption", CfnCanary_S3EncryptionPropertyValidator)(properties.s3Encryption)), errors.wrap('supplied properties not correct for "ArtifactConfigProperty"');
    }
    function cfnCanaryArtifactConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCanary_ArtifactConfigPropertyValidator(properties).assertSuccess(), { S3Encryption: cfnCanaryS3EncryptionPropertyToCloudFormation(properties.s3Encryption) }) : properties;
    }
    function CfnCanaryArtifactConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Encryption", "S3Encryption", properties.S3Encryption != null ? CfnCanaryS3EncryptionPropertyFromCloudFormation(properties.S3Encryption) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCanary_BaseScreenshotPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ignoreCoordinates", cdk.listValidator(cdk.validateString))(properties.ignoreCoordinates)), errors.collect(cdk.propertyValidator("screenshotName", cdk.requiredValidator)(properties.screenshotName)), errors.collect(cdk.propertyValidator("screenshotName", cdk.validateString)(properties.screenshotName)), errors.wrap('supplied properties not correct for "BaseScreenshotProperty"');
    }
    function cfnCanaryBaseScreenshotPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCanary_BaseScreenshotPropertyValidator(properties).assertSuccess(), { IgnoreCoordinates: cdk.listMapper(cdk.stringToCloudFormation)(properties.ignoreCoordinates), ScreenshotName: cdk.stringToCloudFormation(properties.screenshotName) }) : properties;
    }
    function CfnCanaryBaseScreenshotPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ignoreCoordinates", "IgnoreCoordinates", properties.IgnoreCoordinates != null ? cfn_parse.FromCloudFormation.getStringArray(properties.IgnoreCoordinates) : void 0), ret.addPropertyResult("screenshotName", "ScreenshotName", cfn_parse.FromCloudFormation.getString(properties.ScreenshotName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCanary_CodePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("handler", cdk.requiredValidator)(properties.handler)), errors.collect(cdk.propertyValidator("handler", cdk.validateString)(properties.handler)), errors.collect(cdk.propertyValidator("s3Bucket", cdk.validateString)(properties.s3Bucket)), errors.collect(cdk.propertyValidator("s3Key", cdk.validateString)(properties.s3Key)), errors.collect(cdk.propertyValidator("s3ObjectVersion", cdk.validateString)(properties.s3ObjectVersion)), errors.collect(cdk.propertyValidator("script", cdk.validateString)(properties.script)), errors.wrap('supplied properties not correct for "CodeProperty"');
    }
    function cfnCanaryCodePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCanary_CodePropertyValidator(properties).assertSuccess(), { Handler: cdk.stringToCloudFormation(properties.handler), S3Bucket: cdk.stringToCloudFormation(properties.s3Bucket), S3Key: cdk.stringToCloudFormation(properties.s3Key), S3ObjectVersion: cdk.stringToCloudFormation(properties.s3ObjectVersion), Script: cdk.stringToCloudFormation(properties.script) }) : properties;
    }
    function CfnCanaryCodePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("handler", "Handler", cfn_parse.FromCloudFormation.getString(properties.Handler)), ret.addPropertyResult("s3Bucket", "S3Bucket", properties.S3Bucket != null ? cfn_parse.FromCloudFormation.getString(properties.S3Bucket) : void 0), ret.addPropertyResult("s3Key", "S3Key", properties.S3Key != null ? cfn_parse.FromCloudFormation.getString(properties.S3Key) : void 0), ret.addPropertyResult("s3ObjectVersion", "S3ObjectVersion", properties.S3ObjectVersion != null ? cfn_parse.FromCloudFormation.getString(properties.S3ObjectVersion) : void 0), ret.addPropertyResult("script", "Script", properties.Script != null ? cfn_parse.FromCloudFormation.getString(properties.Script) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCanary_RunConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("activeTracing", cdk.validateBoolean)(properties.activeTracing)), errors.collect(cdk.propertyValidator("environmentVariables", cdk.hashValidator(cdk.validateString))(properties.environmentVariables)), errors.collect(cdk.propertyValidator("memoryInMb", cdk.validateNumber)(properties.memoryInMb)), errors.collect(cdk.propertyValidator("timeoutInSeconds", cdk.validateNumber)(properties.timeoutInSeconds)), errors.wrap('supplied properties not correct for "RunConfigProperty"');
    }
    function cfnCanaryRunConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCanary_RunConfigPropertyValidator(properties).assertSuccess(), { ActiveTracing: cdk.booleanToCloudFormation(properties.activeTracing), EnvironmentVariables: cdk.hashMapper(cdk.stringToCloudFormation)(properties.environmentVariables), MemoryInMB: cdk.numberToCloudFormation(properties.memoryInMb), TimeoutInSeconds: cdk.numberToCloudFormation(properties.timeoutInSeconds) }) : properties;
    }
    function CfnCanaryRunConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("activeTracing", "ActiveTracing", properties.ActiveTracing != null ? cfn_parse.FromCloudFormation.getBoolean(properties.ActiveTracing) : void 0), ret.addPropertyResult("environmentVariables", "EnvironmentVariables", properties.EnvironmentVariables != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.EnvironmentVariables) : void 0), ret.addPropertyResult("memoryInMb", "MemoryInMB", properties.MemoryInMB != null ? cfn_parse.FromCloudFormation.getNumber(properties.MemoryInMB) : void 0), ret.addPropertyResult("timeoutInSeconds", "TimeoutInSeconds", properties.TimeoutInSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.TimeoutInSeconds) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCanary_S3EncryptionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("encryptionMode", cdk.validateString)(properties.encryptionMode)), errors.collect(cdk.propertyValidator("kmsKeyArn", cdk.validateString)(properties.kmsKeyArn)), errors.wrap('supplied properties not correct for "S3EncryptionProperty"');
    }
    function cfnCanaryS3EncryptionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCanary_S3EncryptionPropertyValidator(properties).assertSuccess(), { EncryptionMode: cdk.stringToCloudFormation(properties.encryptionMode), KmsKeyArn: cdk.stringToCloudFormation(properties.kmsKeyArn) }) : properties;
    }
    function CfnCanaryS3EncryptionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("encryptionMode", "EncryptionMode", properties.EncryptionMode != null ? cfn_parse.FromCloudFormation.getString(properties.EncryptionMode) : void 0), ret.addPropertyResult("kmsKeyArn", "KmsKeyArn", properties.KmsKeyArn != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyArn) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCanary_SchedulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("durationInSeconds", cdk.validateString)(properties.durationInSeconds)), errors.collect(cdk.propertyValidator("expression", cdk.requiredValidator)(properties.expression)), errors.collect(cdk.propertyValidator("expression", cdk.validateString)(properties.expression)), errors.wrap('supplied properties not correct for "ScheduleProperty"');
    }
    function cfnCanarySchedulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCanary_SchedulePropertyValidator(properties).assertSuccess(), { DurationInSeconds: cdk.stringToCloudFormation(properties.durationInSeconds), Expression: cdk.stringToCloudFormation(properties.expression) }) : properties;
    }
    function CfnCanarySchedulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("durationInSeconds", "DurationInSeconds", properties.DurationInSeconds != null ? cfn_parse.FromCloudFormation.getString(properties.DurationInSeconds) : void 0), ret.addPropertyResult("expression", "Expression", cfn_parse.FromCloudFormation.getString(properties.Expression)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCanary_VPCConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.requiredValidator)(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.requiredValidator)(properties.subnetIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "VPCConfigProperty"');
    }
    function cfnCanaryVPCConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCanary_VPCConfigPropertyValidator(properties).assertSuccess(), { SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds), VpcId: cdk.stringToCloudFormation(properties.vpcId) }) : properties;
    }
    function CfnCanaryVPCConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds)), ret.addPropertyResult("subnetIds", "SubnetIds", cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds)), ret.addPropertyResult("vpcId", "VpcId", properties.VpcId != null ? cfn_parse.FromCloudFormation.getString(properties.VpcId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnCanary_VisualReferencePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("baseCanaryRunId", cdk.requiredValidator)(properties.baseCanaryRunId)), errors.collect(cdk.propertyValidator("baseCanaryRunId", cdk.validateString)(properties.baseCanaryRunId)), errors.collect(cdk.propertyValidator("baseScreenshots", cdk.listValidator(CfnCanary_BaseScreenshotPropertyValidator))(properties.baseScreenshots)), errors.wrap('supplied properties not correct for "VisualReferenceProperty"');
    }
    function cfnCanaryVisualReferencePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCanary_VisualReferencePropertyValidator(properties).assertSuccess(), { BaseCanaryRunId: cdk.stringToCloudFormation(properties.baseCanaryRunId), BaseScreenshots: cdk.listMapper(cfnCanaryBaseScreenshotPropertyToCloudFormation)(properties.baseScreenshots) }) : properties;
    }
    function CfnCanaryVisualReferencePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("baseCanaryRunId", "BaseCanaryRunId", cfn_parse.FromCloudFormation.getString(properties.BaseCanaryRunId)), ret.addPropertyResult("baseScreenshots", "BaseScreenshots", properties.BaseScreenshots != null ? cfn_parse.FromCloudFormation.getArray(CfnCanaryBaseScreenshotPropertyFromCloudFormation)(properties.BaseScreenshots) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("resourceArns", cdk.listValidator(cdk.validateString))(properties.resourceArns)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnGroupProps"');
    }
    function cfnGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGroupPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), ResourceArns: cdk.listMapper(cdk.stringToCloudFormation)(properties.resourceArns), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("resourceArns", "ResourceArns", properties.ResourceArns != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ResourceArns) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnGroup = class _CfnGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_synthetics_CfnGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnGroup), error;
        }
        cdk.requireProperty(props, "name", this), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.resourceArns = props.resourceArns, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Synthetics::Group", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, resourceArns: this.resourceArns, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnGroupPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnGroup[_b] = { fqn: "aws-cdk-lib.aws_synthetics.CfnGroup", version: "2.80.0" }, CfnGroup.CFN_RESOURCE_TYPE_NAME = "AWS::Synthetics::Group", exports2.CfnGroup = CfnGroup;
  }
});

// node_modules/aws-cdk-lib/aws-synthetics/lib/index.js
var require_lib248 = __commonJS({
  "node_modules/aws-cdk-lib/aws-synthetics/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_synthetics_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-synthetics/index.js
var require_aws_synthetics = __commonJS({
  "node_modules/aws-cdk-lib/aws-synthetics/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib248(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-systemsmanagersap/lib/systemsmanagersap.generated.js
var require_systemsmanagersap_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-systemsmanagersap/lib/systemsmanagersap.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnApplication = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnApplicationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("applicationId", cdk.requiredValidator)(properties.applicationId)), errors.collect(cdk.propertyValidator("applicationId", cdk.validateString)(properties.applicationId)), errors.collect(cdk.propertyValidator("applicationType", cdk.requiredValidator)(properties.applicationType)), errors.collect(cdk.propertyValidator("applicationType", cdk.validateString)(properties.applicationType)), errors.collect(cdk.propertyValidator("credentials", cdk.listValidator(CfnApplication_CredentialPropertyValidator))(properties.credentials)), errors.collect(cdk.propertyValidator("instances", cdk.listValidator(cdk.validateString))(properties.instances)), errors.collect(cdk.propertyValidator("sapInstanceNumber", cdk.validateString)(properties.sapInstanceNumber)), errors.collect(cdk.propertyValidator("sid", cdk.validateString)(properties.sid)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnApplicationProps"');
    }
    function cfnApplicationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplicationPropsValidator(properties).assertSuccess(), { ApplicationId: cdk.stringToCloudFormation(properties.applicationId), ApplicationType: cdk.stringToCloudFormation(properties.applicationType), Credentials: cdk.listMapper(cfnApplicationCredentialPropertyToCloudFormation)(properties.credentials), Instances: cdk.listMapper(cdk.stringToCloudFormation)(properties.instances), SapInstanceNumber: cdk.stringToCloudFormation(properties.sapInstanceNumber), Sid: cdk.stringToCloudFormation(properties.sid), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnApplicationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("applicationId", "ApplicationId", cfn_parse.FromCloudFormation.getString(properties.ApplicationId)), ret.addPropertyResult("applicationType", "ApplicationType", cfn_parse.FromCloudFormation.getString(properties.ApplicationType)), ret.addPropertyResult("credentials", "Credentials", properties.Credentials != null ? cfn_parse.FromCloudFormation.getArray(CfnApplicationCredentialPropertyFromCloudFormation)(properties.Credentials) : void 0), ret.addPropertyResult("instances", "Instances", properties.Instances != null ? cfn_parse.FromCloudFormation.getStringArray(properties.Instances) : void 0), ret.addPropertyResult("sapInstanceNumber", "SapInstanceNumber", properties.SapInstanceNumber != null ? cfn_parse.FromCloudFormation.getString(properties.SapInstanceNumber) : void 0), ret.addPropertyResult("sid", "Sid", properties.Sid != null ? cfn_parse.FromCloudFormation.getString(properties.Sid) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnApplication = class _CfnApplication extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnApplicationPropsFromCloudFormation(resourceProperties), ret = new _CfnApplication(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnApplication.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_systemsmanagersap_CfnApplicationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnApplication), error;
        }
        cdk.requireProperty(props, "applicationId", this), cdk.requireProperty(props, "applicationType", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.applicationId = props.applicationId, this.applicationType = props.applicationType, this.credentials = props.credentials, this.instances = props.instances, this.sapInstanceNumber = props.sapInstanceNumber, this.sid = props.sid, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::SystemsManagerSAP::Application", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnApplication.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { applicationId: this.applicationId, applicationType: this.applicationType, credentials: this.credentials, instances: this.instances, sapInstanceNumber: this.sapInstanceNumber, sid: this.sid, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnApplicationPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnApplication[_a] = { fqn: "aws-cdk-lib.aws_systemsmanagersap.CfnApplication", version: "2.80.0" }, CfnApplication.CFN_RESOURCE_TYPE_NAME = "AWS::SystemsManagerSAP::Application", exports2.CfnApplication = CfnApplication;
    function CfnApplication_CredentialPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("credentialType", cdk.validateString)(properties.credentialType)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("secretId", cdk.validateString)(properties.secretId)), errors.wrap('supplied properties not correct for "CredentialProperty"');
    }
    function cfnApplicationCredentialPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnApplication_CredentialPropertyValidator(properties).assertSuccess(), { CredentialType: cdk.stringToCloudFormation(properties.credentialType), DatabaseName: cdk.stringToCloudFormation(properties.databaseName), SecretId: cdk.stringToCloudFormation(properties.secretId) }) : properties;
    }
    function CfnApplicationCredentialPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("credentialType", "CredentialType", properties.CredentialType != null ? cfn_parse.FromCloudFormation.getString(properties.CredentialType) : void 0), ret.addPropertyResult("databaseName", "DatabaseName", properties.DatabaseName != null ? cfn_parse.FromCloudFormation.getString(properties.DatabaseName) : void 0), ret.addPropertyResult("secretId", "SecretId", properties.SecretId != null ? cfn_parse.FromCloudFormation.getString(properties.SecretId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-systemsmanagersap/lib/index.js
var require_lib249 = __commonJS({
  "node_modules/aws-cdk-lib/aws-systemsmanagersap/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_systemsmanagersap_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-systemsmanagersap/index.js
var require_aws_systemsmanagersap = __commonJS({
  "node_modules/aws-cdk-lib/aws-systemsmanagersap/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib249(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-timestream/lib/timestream.generated.js
var require_timestream_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-timestream/lib/timestream.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnTable = exports2.CfnScheduledQuery = exports2.CfnDatabase = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnDatabasePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDatabaseProps"');
    }
    function cfnDatabasePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDatabasePropsValidator(properties).assertSuccess(), { DatabaseName: cdk.stringToCloudFormation(properties.databaseName), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDatabasePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("databaseName", "DatabaseName", properties.DatabaseName != null ? cfn_parse.FromCloudFormation.getString(properties.DatabaseName) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDatabase = class _CfnDatabase extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDatabasePropsFromCloudFormation(resourceProperties), ret = new _CfnDatabase(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnDatabase.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_timestream_CfnDatabaseProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDatabase), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.databaseName = props.databaseName, this.kmsKeyId = props.kmsKeyId, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Timestream::Database", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDatabase.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { databaseName: this.databaseName, kmsKeyId: this.kmsKeyId, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDatabasePropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnDatabase[_a] = { fqn: "aws-cdk-lib.aws_timestream.CfnDatabase", version: "2.80.0" }, CfnDatabase.CFN_RESOURCE_TYPE_NAME = "AWS::Timestream::Database", exports2.CfnDatabase = CfnDatabase;
    function CfnScheduledQueryPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("clientToken", cdk.validateString)(properties.clientToken)), errors.collect(cdk.propertyValidator("errorReportConfiguration", cdk.requiredValidator)(properties.errorReportConfiguration)), errors.collect(cdk.propertyValidator("errorReportConfiguration", CfnScheduledQuery_ErrorReportConfigurationPropertyValidator)(properties.errorReportConfiguration)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("notificationConfiguration", cdk.requiredValidator)(properties.notificationConfiguration)), errors.collect(cdk.propertyValidator("notificationConfiguration", CfnScheduledQuery_NotificationConfigurationPropertyValidator)(properties.notificationConfiguration)), errors.collect(cdk.propertyValidator("queryString", cdk.requiredValidator)(properties.queryString)), errors.collect(cdk.propertyValidator("queryString", cdk.validateString)(properties.queryString)), errors.collect(cdk.propertyValidator("scheduleConfiguration", cdk.requiredValidator)(properties.scheduleConfiguration)), errors.collect(cdk.propertyValidator("scheduleConfiguration", CfnScheduledQuery_ScheduleConfigurationPropertyValidator)(properties.scheduleConfiguration)), errors.collect(cdk.propertyValidator("scheduledQueryExecutionRoleArn", cdk.requiredValidator)(properties.scheduledQueryExecutionRoleArn)), errors.collect(cdk.propertyValidator("scheduledQueryExecutionRoleArn", cdk.validateString)(properties.scheduledQueryExecutionRoleArn)), errors.collect(cdk.propertyValidator("scheduledQueryName", cdk.validateString)(properties.scheduledQueryName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("targetConfiguration", CfnScheduledQuery_TargetConfigurationPropertyValidator)(properties.targetConfiguration)), errors.wrap('supplied properties not correct for "CfnScheduledQueryProps"');
    }
    function cfnScheduledQueryPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScheduledQueryPropsValidator(properties).assertSuccess(), { ErrorReportConfiguration: cfnScheduledQueryErrorReportConfigurationPropertyToCloudFormation(properties.errorReportConfiguration), NotificationConfiguration: cfnScheduledQueryNotificationConfigurationPropertyToCloudFormation(properties.notificationConfiguration), QueryString: cdk.stringToCloudFormation(properties.queryString), ScheduleConfiguration: cfnScheduledQueryScheduleConfigurationPropertyToCloudFormation(properties.scheduleConfiguration), ScheduledQueryExecutionRoleArn: cdk.stringToCloudFormation(properties.scheduledQueryExecutionRoleArn), ClientToken: cdk.stringToCloudFormation(properties.clientToken), KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId), ScheduledQueryName: cdk.stringToCloudFormation(properties.scheduledQueryName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TargetConfiguration: cfnScheduledQueryTargetConfigurationPropertyToCloudFormation(properties.targetConfiguration) }) : properties;
    }
    function CfnScheduledQueryPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("errorReportConfiguration", "ErrorReportConfiguration", CfnScheduledQueryErrorReportConfigurationPropertyFromCloudFormation(properties.ErrorReportConfiguration)), ret.addPropertyResult("notificationConfiguration", "NotificationConfiguration", CfnScheduledQueryNotificationConfigurationPropertyFromCloudFormation(properties.NotificationConfiguration)), ret.addPropertyResult("queryString", "QueryString", cfn_parse.FromCloudFormation.getString(properties.QueryString)), ret.addPropertyResult("scheduleConfiguration", "ScheduleConfiguration", CfnScheduledQueryScheduleConfigurationPropertyFromCloudFormation(properties.ScheduleConfiguration)), ret.addPropertyResult("scheduledQueryExecutionRoleArn", "ScheduledQueryExecutionRoleArn", cfn_parse.FromCloudFormation.getString(properties.ScheduledQueryExecutionRoleArn)), ret.addPropertyResult("clientToken", "ClientToken", properties.ClientToken != null ? cfn_parse.FromCloudFormation.getString(properties.ClientToken) : void 0), ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addPropertyResult("scheduledQueryName", "ScheduledQueryName", properties.ScheduledQueryName != null ? cfn_parse.FromCloudFormation.getString(properties.ScheduledQueryName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("targetConfiguration", "TargetConfiguration", properties.TargetConfiguration != null ? CfnScheduledQueryTargetConfigurationPropertyFromCloudFormation(properties.TargetConfiguration) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnScheduledQuery = class _CfnScheduledQuery extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnScheduledQueryPropsFromCloudFormation(resourceProperties), ret = new _CfnScheduledQuery(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnScheduledQuery.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_timestream_CfnScheduledQueryProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnScheduledQuery), error;
        }
        cdk.requireProperty(props, "errorReportConfiguration", this), cdk.requireProperty(props, "notificationConfiguration", this), cdk.requireProperty(props, "queryString", this), cdk.requireProperty(props, "scheduleConfiguration", this), cdk.requireProperty(props, "scheduledQueryExecutionRoleArn", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrSqErrorReportConfiguration = cdk.Token.asString(this.getAtt("SQErrorReportConfiguration", cdk.ResolutionTypeHint.STRING)), this.attrSqKmsKeyId = cdk.Token.asString(this.getAtt("SQKmsKeyId", cdk.ResolutionTypeHint.STRING)), this.attrSqName = cdk.Token.asString(this.getAtt("SQName", cdk.ResolutionTypeHint.STRING)), this.attrSqNotificationConfiguration = cdk.Token.asString(this.getAtt("SQNotificationConfiguration", cdk.ResolutionTypeHint.STRING)), this.attrSqQueryString = cdk.Token.asString(this.getAtt("SQQueryString", cdk.ResolutionTypeHint.STRING)), this.attrSqScheduleConfiguration = cdk.Token.asString(this.getAtt("SQScheduleConfiguration", cdk.ResolutionTypeHint.STRING)), this.attrSqScheduledQueryExecutionRoleArn = cdk.Token.asString(this.getAtt("SQScheduledQueryExecutionRoleArn", cdk.ResolutionTypeHint.STRING)), this.attrSqTargetConfiguration = cdk.Token.asString(this.getAtt("SQTargetConfiguration", cdk.ResolutionTypeHint.STRING)), this.errorReportConfiguration = props.errorReportConfiguration, this.notificationConfiguration = props.notificationConfiguration, this.queryString = props.queryString, this.scheduleConfiguration = props.scheduleConfiguration, this.scheduledQueryExecutionRoleArn = props.scheduledQueryExecutionRoleArn, this.clientToken = props.clientToken, this.kmsKeyId = props.kmsKeyId, this.scheduledQueryName = props.scheduledQueryName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Timestream::ScheduledQuery", props.tags, { tagPropertyName: "tags" }), this.targetConfiguration = props.targetConfiguration;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnScheduledQuery.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { errorReportConfiguration: this.errorReportConfiguration, notificationConfiguration: this.notificationConfiguration, queryString: this.queryString, scheduleConfiguration: this.scheduleConfiguration, scheduledQueryExecutionRoleArn: this.scheduledQueryExecutionRoleArn, clientToken: this.clientToken, kmsKeyId: this.kmsKeyId, scheduledQueryName: this.scheduledQueryName, tags: this.tags.renderTags(), targetConfiguration: this.targetConfiguration };
      }
      renderProperties(props) {
        return cfnScheduledQueryPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnScheduledQuery[_b] = { fqn: "aws-cdk-lib.aws_timestream.CfnScheduledQuery", version: "2.80.0" }, CfnScheduledQuery.CFN_RESOURCE_TYPE_NAME = "AWS::Timestream::ScheduledQuery", exports2.CfnScheduledQuery = CfnScheduledQuery;
    function CfnScheduledQuery_DimensionMappingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dimensionValueType", cdk.requiredValidator)(properties.dimensionValueType)), errors.collect(cdk.propertyValidator("dimensionValueType", cdk.validateString)(properties.dimensionValueType)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "DimensionMappingProperty"');
    }
    function cfnScheduledQueryDimensionMappingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScheduledQuery_DimensionMappingPropertyValidator(properties).assertSuccess(), { DimensionValueType: cdk.stringToCloudFormation(properties.dimensionValueType), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnScheduledQueryDimensionMappingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dimensionValueType", "DimensionValueType", cfn_parse.FromCloudFormation.getString(properties.DimensionValueType)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScheduledQuery_ErrorReportConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("s3Configuration", cdk.requiredValidator)(properties.s3Configuration)), errors.collect(cdk.propertyValidator("s3Configuration", CfnScheduledQuery_S3ConfigurationPropertyValidator)(properties.s3Configuration)), errors.wrap('supplied properties not correct for "ErrorReportConfigurationProperty"');
    }
    function cfnScheduledQueryErrorReportConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScheduledQuery_ErrorReportConfigurationPropertyValidator(properties).assertSuccess(), { S3Configuration: cfnScheduledQueryS3ConfigurationPropertyToCloudFormation(properties.s3Configuration) }) : properties;
    }
    function CfnScheduledQueryErrorReportConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("s3Configuration", "S3Configuration", CfnScheduledQueryS3ConfigurationPropertyFromCloudFormation(properties.S3Configuration)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScheduledQuery_MixedMeasureMappingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("measureName", cdk.validateString)(properties.measureName)), errors.collect(cdk.propertyValidator("measureValueType", cdk.requiredValidator)(properties.measureValueType)), errors.collect(cdk.propertyValidator("measureValueType", cdk.validateString)(properties.measureValueType)), errors.collect(cdk.propertyValidator("multiMeasureAttributeMappings", cdk.listValidator(CfnScheduledQuery_MultiMeasureAttributeMappingPropertyValidator))(properties.multiMeasureAttributeMappings)), errors.collect(cdk.propertyValidator("sourceColumn", cdk.validateString)(properties.sourceColumn)), errors.collect(cdk.propertyValidator("targetMeasureName", cdk.validateString)(properties.targetMeasureName)), errors.wrap('supplied properties not correct for "MixedMeasureMappingProperty"');
    }
    function cfnScheduledQueryMixedMeasureMappingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScheduledQuery_MixedMeasureMappingPropertyValidator(properties).assertSuccess(), { MeasureName: cdk.stringToCloudFormation(properties.measureName), MeasureValueType: cdk.stringToCloudFormation(properties.measureValueType), MultiMeasureAttributeMappings: cdk.listMapper(cfnScheduledQueryMultiMeasureAttributeMappingPropertyToCloudFormation)(properties.multiMeasureAttributeMappings), SourceColumn: cdk.stringToCloudFormation(properties.sourceColumn), TargetMeasureName: cdk.stringToCloudFormation(properties.targetMeasureName) }) : properties;
    }
    function CfnScheduledQueryMixedMeasureMappingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("measureName", "MeasureName", properties.MeasureName != null ? cfn_parse.FromCloudFormation.getString(properties.MeasureName) : void 0), ret.addPropertyResult("measureValueType", "MeasureValueType", cfn_parse.FromCloudFormation.getString(properties.MeasureValueType)), ret.addPropertyResult("multiMeasureAttributeMappings", "MultiMeasureAttributeMappings", properties.MultiMeasureAttributeMappings != null ? cfn_parse.FromCloudFormation.getArray(CfnScheduledQueryMultiMeasureAttributeMappingPropertyFromCloudFormation)(properties.MultiMeasureAttributeMappings) : void 0), ret.addPropertyResult("sourceColumn", "SourceColumn", properties.SourceColumn != null ? cfn_parse.FromCloudFormation.getString(properties.SourceColumn) : void 0), ret.addPropertyResult("targetMeasureName", "TargetMeasureName", properties.TargetMeasureName != null ? cfn_parse.FromCloudFormation.getString(properties.TargetMeasureName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScheduledQuery_MultiMeasureAttributeMappingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("measureValueType", cdk.requiredValidator)(properties.measureValueType)), errors.collect(cdk.propertyValidator("measureValueType", cdk.validateString)(properties.measureValueType)), errors.collect(cdk.propertyValidator("sourceColumn", cdk.requiredValidator)(properties.sourceColumn)), errors.collect(cdk.propertyValidator("sourceColumn", cdk.validateString)(properties.sourceColumn)), errors.collect(cdk.propertyValidator("targetMultiMeasureAttributeName", cdk.validateString)(properties.targetMultiMeasureAttributeName)), errors.wrap('supplied properties not correct for "MultiMeasureAttributeMappingProperty"');
    }
    function cfnScheduledQueryMultiMeasureAttributeMappingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScheduledQuery_MultiMeasureAttributeMappingPropertyValidator(properties).assertSuccess(), { MeasureValueType: cdk.stringToCloudFormation(properties.measureValueType), SourceColumn: cdk.stringToCloudFormation(properties.sourceColumn), TargetMultiMeasureAttributeName: cdk.stringToCloudFormation(properties.targetMultiMeasureAttributeName) }) : properties;
    }
    function CfnScheduledQueryMultiMeasureAttributeMappingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("measureValueType", "MeasureValueType", cfn_parse.FromCloudFormation.getString(properties.MeasureValueType)), ret.addPropertyResult("sourceColumn", "SourceColumn", cfn_parse.FromCloudFormation.getString(properties.SourceColumn)), ret.addPropertyResult("targetMultiMeasureAttributeName", "TargetMultiMeasureAttributeName", properties.TargetMultiMeasureAttributeName != null ? cfn_parse.FromCloudFormation.getString(properties.TargetMultiMeasureAttributeName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScheduledQuery_MultiMeasureMappingsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("multiMeasureAttributeMappings", cdk.requiredValidator)(properties.multiMeasureAttributeMappings)), errors.collect(cdk.propertyValidator("multiMeasureAttributeMappings", cdk.listValidator(CfnScheduledQuery_MultiMeasureAttributeMappingPropertyValidator))(properties.multiMeasureAttributeMappings)), errors.collect(cdk.propertyValidator("targetMultiMeasureName", cdk.validateString)(properties.targetMultiMeasureName)), errors.wrap('supplied properties not correct for "MultiMeasureMappingsProperty"');
    }
    function cfnScheduledQueryMultiMeasureMappingsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScheduledQuery_MultiMeasureMappingsPropertyValidator(properties).assertSuccess(), { MultiMeasureAttributeMappings: cdk.listMapper(cfnScheduledQueryMultiMeasureAttributeMappingPropertyToCloudFormation)(properties.multiMeasureAttributeMappings), TargetMultiMeasureName: cdk.stringToCloudFormation(properties.targetMultiMeasureName) }) : properties;
    }
    function CfnScheduledQueryMultiMeasureMappingsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("multiMeasureAttributeMappings", "MultiMeasureAttributeMappings", cfn_parse.FromCloudFormation.getArray(CfnScheduledQueryMultiMeasureAttributeMappingPropertyFromCloudFormation)(properties.MultiMeasureAttributeMappings)), ret.addPropertyResult("targetMultiMeasureName", "TargetMultiMeasureName", properties.TargetMultiMeasureName != null ? cfn_parse.FromCloudFormation.getString(properties.TargetMultiMeasureName) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScheduledQuery_NotificationConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("snsConfiguration", cdk.requiredValidator)(properties.snsConfiguration)), errors.collect(cdk.propertyValidator("snsConfiguration", CfnScheduledQuery_SnsConfigurationPropertyValidator)(properties.snsConfiguration)), errors.wrap('supplied properties not correct for "NotificationConfigurationProperty"');
    }
    function cfnScheduledQueryNotificationConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScheduledQuery_NotificationConfigurationPropertyValidator(properties).assertSuccess(), { SnsConfiguration: cfnScheduledQuerySnsConfigurationPropertyToCloudFormation(properties.snsConfiguration) }) : properties;
    }
    function CfnScheduledQueryNotificationConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("snsConfiguration", "SnsConfiguration", CfnScheduledQuerySnsConfigurationPropertyFromCloudFormation(properties.SnsConfiguration)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScheduledQuery_S3ConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucketName", cdk.requiredValidator)(properties.bucketName)), errors.collect(cdk.propertyValidator("bucketName", cdk.validateString)(properties.bucketName)), errors.collect(cdk.propertyValidator("encryptionOption", cdk.validateString)(properties.encryptionOption)), errors.collect(cdk.propertyValidator("objectKeyPrefix", cdk.validateString)(properties.objectKeyPrefix)), errors.wrap('supplied properties not correct for "S3ConfigurationProperty"');
    }
    function cfnScheduledQueryS3ConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScheduledQuery_S3ConfigurationPropertyValidator(properties).assertSuccess(), { BucketName: cdk.stringToCloudFormation(properties.bucketName), EncryptionOption: cdk.stringToCloudFormation(properties.encryptionOption), ObjectKeyPrefix: cdk.stringToCloudFormation(properties.objectKeyPrefix) }) : properties;
    }
    function CfnScheduledQueryS3ConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucketName", "BucketName", cfn_parse.FromCloudFormation.getString(properties.BucketName)), ret.addPropertyResult("encryptionOption", "EncryptionOption", properties.EncryptionOption != null ? cfn_parse.FromCloudFormation.getString(properties.EncryptionOption) : void 0), ret.addPropertyResult("objectKeyPrefix", "ObjectKeyPrefix", properties.ObjectKeyPrefix != null ? cfn_parse.FromCloudFormation.getString(properties.ObjectKeyPrefix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScheduledQuery_ScheduleConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("scheduleExpression", cdk.requiredValidator)(properties.scheduleExpression)), errors.collect(cdk.propertyValidator("scheduleExpression", cdk.validateString)(properties.scheduleExpression)), errors.wrap('supplied properties not correct for "ScheduleConfigurationProperty"');
    }
    function cfnScheduledQueryScheduleConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScheduledQuery_ScheduleConfigurationPropertyValidator(properties).assertSuccess(), { ScheduleExpression: cdk.stringToCloudFormation(properties.scheduleExpression) }) : properties;
    }
    function CfnScheduledQueryScheduleConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("scheduleExpression", "ScheduleExpression", cfn_parse.FromCloudFormation.getString(properties.ScheduleExpression)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScheduledQuery_SnsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("topicArn", cdk.requiredValidator)(properties.topicArn)), errors.collect(cdk.propertyValidator("topicArn", cdk.validateString)(properties.topicArn)), errors.wrap('supplied properties not correct for "SnsConfigurationProperty"');
    }
    function cfnScheduledQuerySnsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScheduledQuery_SnsConfigurationPropertyValidator(properties).assertSuccess(), { TopicArn: cdk.stringToCloudFormation(properties.topicArn) }) : properties;
    }
    function CfnScheduledQuerySnsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("topicArn", "TopicArn", cfn_parse.FromCloudFormation.getString(properties.TopicArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScheduledQuery_TargetConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("timestreamConfiguration", cdk.requiredValidator)(properties.timestreamConfiguration)), errors.collect(cdk.propertyValidator("timestreamConfiguration", CfnScheduledQuery_TimestreamConfigurationPropertyValidator)(properties.timestreamConfiguration)), errors.wrap('supplied properties not correct for "TargetConfigurationProperty"');
    }
    function cfnScheduledQueryTargetConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScheduledQuery_TargetConfigurationPropertyValidator(properties).assertSuccess(), { TimestreamConfiguration: cfnScheduledQueryTimestreamConfigurationPropertyToCloudFormation(properties.timestreamConfiguration) }) : properties;
    }
    function CfnScheduledQueryTargetConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("timestreamConfiguration", "TimestreamConfiguration", CfnScheduledQueryTimestreamConfigurationPropertyFromCloudFormation(properties.TimestreamConfiguration)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnScheduledQuery_TimestreamConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("databaseName", cdk.requiredValidator)(properties.databaseName)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("dimensionMappings", cdk.requiredValidator)(properties.dimensionMappings)), errors.collect(cdk.propertyValidator("dimensionMappings", cdk.listValidator(CfnScheduledQuery_DimensionMappingPropertyValidator))(properties.dimensionMappings)), errors.collect(cdk.propertyValidator("measureNameColumn", cdk.validateString)(properties.measureNameColumn)), errors.collect(cdk.propertyValidator("mixedMeasureMappings", cdk.listValidator(CfnScheduledQuery_MixedMeasureMappingPropertyValidator))(properties.mixedMeasureMappings)), errors.collect(cdk.propertyValidator("multiMeasureMappings", CfnScheduledQuery_MultiMeasureMappingsPropertyValidator)(properties.multiMeasureMappings)), errors.collect(cdk.propertyValidator("tableName", cdk.requiredValidator)(properties.tableName)), errors.collect(cdk.propertyValidator("tableName", cdk.validateString)(properties.tableName)), errors.collect(cdk.propertyValidator("timeColumn", cdk.requiredValidator)(properties.timeColumn)), errors.collect(cdk.propertyValidator("timeColumn", cdk.validateString)(properties.timeColumn)), errors.wrap('supplied properties not correct for "TimestreamConfigurationProperty"');
    }
    function cfnScheduledQueryTimestreamConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnScheduledQuery_TimestreamConfigurationPropertyValidator(properties).assertSuccess(), { DatabaseName: cdk.stringToCloudFormation(properties.databaseName), DimensionMappings: cdk.listMapper(cfnScheduledQueryDimensionMappingPropertyToCloudFormation)(properties.dimensionMappings), MeasureNameColumn: cdk.stringToCloudFormation(properties.measureNameColumn), MixedMeasureMappings: cdk.listMapper(cfnScheduledQueryMixedMeasureMappingPropertyToCloudFormation)(properties.mixedMeasureMappings), MultiMeasureMappings: cfnScheduledQueryMultiMeasureMappingsPropertyToCloudFormation(properties.multiMeasureMappings), TableName: cdk.stringToCloudFormation(properties.tableName), TimeColumn: cdk.stringToCloudFormation(properties.timeColumn) }) : properties;
    }
    function CfnScheduledQueryTimestreamConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("databaseName", "DatabaseName", cfn_parse.FromCloudFormation.getString(properties.DatabaseName)), ret.addPropertyResult("dimensionMappings", "DimensionMappings", cfn_parse.FromCloudFormation.getArray(CfnScheduledQueryDimensionMappingPropertyFromCloudFormation)(properties.DimensionMappings)), ret.addPropertyResult("measureNameColumn", "MeasureNameColumn", properties.MeasureNameColumn != null ? cfn_parse.FromCloudFormation.getString(properties.MeasureNameColumn) : void 0), ret.addPropertyResult("mixedMeasureMappings", "MixedMeasureMappings", properties.MixedMeasureMappings != null ? cfn_parse.FromCloudFormation.getArray(CfnScheduledQueryMixedMeasureMappingPropertyFromCloudFormation)(properties.MixedMeasureMappings) : void 0), ret.addPropertyResult("multiMeasureMappings", "MultiMeasureMappings", properties.MultiMeasureMappings != null ? CfnScheduledQueryMultiMeasureMappingsPropertyFromCloudFormation(properties.MultiMeasureMappings) : void 0), ret.addPropertyResult("tableName", "TableName", cfn_parse.FromCloudFormation.getString(properties.TableName)), ret.addPropertyResult("timeColumn", "TimeColumn", cfn_parse.FromCloudFormation.getString(properties.TimeColumn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTablePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("databaseName", cdk.requiredValidator)(properties.databaseName)), errors.collect(cdk.propertyValidator("databaseName", cdk.validateString)(properties.databaseName)), errors.collect(cdk.propertyValidator("magneticStoreWriteProperties", cdk.validateObject)(properties.magneticStoreWriteProperties)), errors.collect(cdk.propertyValidator("retentionProperties", cdk.validateObject)(properties.retentionProperties)), errors.collect(cdk.propertyValidator("tableName", cdk.validateString)(properties.tableName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnTableProps"');
    }
    function cfnTablePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTablePropsValidator(properties).assertSuccess(), { DatabaseName: cdk.stringToCloudFormation(properties.databaseName), MagneticStoreWriteProperties: cdk.objectToCloudFormation(properties.magneticStoreWriteProperties), RetentionProperties: cdk.objectToCloudFormation(properties.retentionProperties), TableName: cdk.stringToCloudFormation(properties.tableName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnTablePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("databaseName", "DatabaseName", cfn_parse.FromCloudFormation.getString(properties.DatabaseName)), ret.addPropertyResult("magneticStoreWriteProperties", "MagneticStoreWriteProperties", properties.MagneticStoreWriteProperties != null ? cfn_parse.FromCloudFormation.getAny(properties.MagneticStoreWriteProperties) : void 0), ret.addPropertyResult("retentionProperties", "RetentionProperties", properties.RetentionProperties != null ? cfn_parse.FromCloudFormation.getAny(properties.RetentionProperties) : void 0), ret.addPropertyResult("tableName", "TableName", properties.TableName != null ? cfn_parse.FromCloudFormation.getString(properties.TableName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTable = class _CfnTable extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTablePropsFromCloudFormation(resourceProperties), ret = new _CfnTable(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTable.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_timestream_CfnTableProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTable), error;
        }
        cdk.requireProperty(props, "databaseName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrName = cdk.Token.asString(this.getAtt("Name", cdk.ResolutionTypeHint.STRING)), this.databaseName = props.databaseName, this.magneticStoreWriteProperties = props.magneticStoreWriteProperties, this.retentionProperties = props.retentionProperties, this.tableName = props.tableName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Timestream::Table", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTable.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { databaseName: this.databaseName, magneticStoreWriteProperties: this.magneticStoreWriteProperties, retentionProperties: this.retentionProperties, tableName: this.tableName, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnTablePropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnTable[_c] = { fqn: "aws-cdk-lib.aws_timestream.CfnTable", version: "2.80.0" }, CfnTable.CFN_RESOURCE_TYPE_NAME = "AWS::Timestream::Table", exports2.CfnTable = CfnTable;
  }
});

// node_modules/aws-cdk-lib/aws-timestream/lib/index.js
var require_lib250 = __commonJS({
  "node_modules/aws-cdk-lib/aws-timestream/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_timestream_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-timestream/index.js
var require_aws_timestream = __commonJS({
  "node_modules/aws-cdk-lib/aws-timestream/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib250(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-transfer/lib/transfer.generated.js
var require_transfer_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-transfer/lib/transfer.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnWorkflow = exports2.CfnUser = exports2.CfnServer = exports2.CfnProfile = exports2.CfnConnector = exports2.CfnCertificate = exports2.CfnAgreement = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAgreementPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessRole", cdk.requiredValidator)(properties.accessRole)), errors.collect(cdk.propertyValidator("accessRole", cdk.validateString)(properties.accessRole)), errors.collect(cdk.propertyValidator("baseDirectory", cdk.requiredValidator)(properties.baseDirectory)), errors.collect(cdk.propertyValidator("baseDirectory", cdk.validateString)(properties.baseDirectory)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("localProfileId", cdk.requiredValidator)(properties.localProfileId)), errors.collect(cdk.propertyValidator("localProfileId", cdk.validateString)(properties.localProfileId)), errors.collect(cdk.propertyValidator("partnerProfileId", cdk.requiredValidator)(properties.partnerProfileId)), errors.collect(cdk.propertyValidator("partnerProfileId", cdk.validateString)(properties.partnerProfileId)), errors.collect(cdk.propertyValidator("serverId", cdk.requiredValidator)(properties.serverId)), errors.collect(cdk.propertyValidator("serverId", cdk.validateString)(properties.serverId)), errors.collect(cdk.propertyValidator("status", cdk.validateString)(properties.status)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnAgreementProps"');
    }
    function cfnAgreementPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAgreementPropsValidator(properties).assertSuccess(), { AccessRole: cdk.stringToCloudFormation(properties.accessRole), BaseDirectory: cdk.stringToCloudFormation(properties.baseDirectory), LocalProfileId: cdk.stringToCloudFormation(properties.localProfileId), PartnerProfileId: cdk.stringToCloudFormation(properties.partnerProfileId), ServerId: cdk.stringToCloudFormation(properties.serverId), Description: cdk.stringToCloudFormation(properties.description), Status: cdk.stringToCloudFormation(properties.status), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnAgreementPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessRole", "AccessRole", cfn_parse.FromCloudFormation.getString(properties.AccessRole)), ret.addPropertyResult("baseDirectory", "BaseDirectory", cfn_parse.FromCloudFormation.getString(properties.BaseDirectory)), ret.addPropertyResult("localProfileId", "LocalProfileId", cfn_parse.FromCloudFormation.getString(properties.LocalProfileId)), ret.addPropertyResult("partnerProfileId", "PartnerProfileId", cfn_parse.FromCloudFormation.getString(properties.PartnerProfileId)), ret.addPropertyResult("serverId", "ServerId", cfn_parse.FromCloudFormation.getString(properties.ServerId)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("status", "Status", properties.Status != null ? cfn_parse.FromCloudFormation.getString(properties.Status) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAgreement = class _CfnAgreement extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAgreementPropsFromCloudFormation(resourceProperties), ret = new _CfnAgreement(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAgreement.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_transfer_CfnAgreementProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAgreement), error;
        }
        cdk.requireProperty(props, "accessRole", this), cdk.requireProperty(props, "baseDirectory", this), cdk.requireProperty(props, "localProfileId", this), cdk.requireProperty(props, "partnerProfileId", this), cdk.requireProperty(props, "serverId", this), this.attrAgreementId = cdk.Token.asString(this.getAtt("AgreementId", cdk.ResolutionTypeHint.STRING)), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.accessRole = props.accessRole, this.baseDirectory = props.baseDirectory, this.localProfileId = props.localProfileId, this.partnerProfileId = props.partnerProfileId, this.serverId = props.serverId, this.description = props.description, this.status = props.status, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Transfer::Agreement", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAgreement.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { accessRole: this.accessRole, baseDirectory: this.baseDirectory, localProfileId: this.localProfileId, partnerProfileId: this.partnerProfileId, serverId: this.serverId, description: this.description, status: this.status, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnAgreementPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAgreement[_a] = { fqn: "aws-cdk-lib.aws_transfer.CfnAgreement", version: "2.80.0" }, CfnAgreement.CFN_RESOURCE_TYPE_NAME = "AWS::Transfer::Agreement", exports2.CfnAgreement = CfnAgreement;
    function CfnCertificatePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("activeDate", cdk.validateString)(properties.activeDate)), errors.collect(cdk.propertyValidator("certificate", cdk.requiredValidator)(properties.certificate)), errors.collect(cdk.propertyValidator("certificate", cdk.validateString)(properties.certificate)), errors.collect(cdk.propertyValidator("certificateChain", cdk.validateString)(properties.certificateChain)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("inactiveDate", cdk.validateString)(properties.inactiveDate)), errors.collect(cdk.propertyValidator("privateKey", cdk.validateString)(properties.privateKey)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("usage", cdk.requiredValidator)(properties.usage)), errors.collect(cdk.propertyValidator("usage", cdk.validateString)(properties.usage)), errors.wrap('supplied properties not correct for "CfnCertificateProps"');
    }
    function cfnCertificatePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnCertificatePropsValidator(properties).assertSuccess(), { Certificate: cdk.stringToCloudFormation(properties.certificate), Usage: cdk.stringToCloudFormation(properties.usage), ActiveDate: cdk.stringToCloudFormation(properties.activeDate), CertificateChain: cdk.stringToCloudFormation(properties.certificateChain), Description: cdk.stringToCloudFormation(properties.description), InactiveDate: cdk.stringToCloudFormation(properties.inactiveDate), PrivateKey: cdk.stringToCloudFormation(properties.privateKey), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnCertificatePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificate", "Certificate", cfn_parse.FromCloudFormation.getString(properties.Certificate)), ret.addPropertyResult("usage", "Usage", cfn_parse.FromCloudFormation.getString(properties.Usage)), ret.addPropertyResult("activeDate", "ActiveDate", properties.ActiveDate != null ? cfn_parse.FromCloudFormation.getString(properties.ActiveDate) : void 0), ret.addPropertyResult("certificateChain", "CertificateChain", properties.CertificateChain != null ? cfn_parse.FromCloudFormation.getString(properties.CertificateChain) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("inactiveDate", "InactiveDate", properties.InactiveDate != null ? cfn_parse.FromCloudFormation.getString(properties.InactiveDate) : void 0), ret.addPropertyResult("privateKey", "PrivateKey", properties.PrivateKey != null ? cfn_parse.FromCloudFormation.getString(properties.PrivateKey) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnCertificate = class _CfnCertificate extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnCertificatePropsFromCloudFormation(resourceProperties), ret = new _CfnCertificate(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnCertificate.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_transfer_CfnCertificateProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnCertificate), error;
        }
        cdk.requireProperty(props, "certificate", this), cdk.requireProperty(props, "usage", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCertificateId = cdk.Token.asString(this.getAtt("CertificateId", cdk.ResolutionTypeHint.STRING)), this.attrNotAfterDate = cdk.Token.asString(this.getAtt("NotAfterDate", cdk.ResolutionTypeHint.STRING)), this.attrNotBeforeDate = cdk.Token.asString(this.getAtt("NotBeforeDate", cdk.ResolutionTypeHint.STRING)), this.attrSerial = cdk.Token.asString(this.getAtt("Serial", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.attrType = cdk.Token.asString(this.getAtt("Type", cdk.ResolutionTypeHint.STRING)), this.certificate = props.certificate, this.usage = props.usage, this.activeDate = props.activeDate, this.certificateChain = props.certificateChain, this.description = props.description, this.inactiveDate = props.inactiveDate, this.privateKey = props.privateKey, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Transfer::Certificate", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnCertificate.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { certificate: this.certificate, usage: this.usage, activeDate: this.activeDate, certificateChain: this.certificateChain, description: this.description, inactiveDate: this.inactiveDate, privateKey: this.privateKey, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnCertificatePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnCertificate[_b] = { fqn: "aws-cdk-lib.aws_transfer.CfnCertificate", version: "2.80.0" }, CfnCertificate.CFN_RESOURCE_TYPE_NAME = "AWS::Transfer::Certificate", exports2.CfnCertificate = CfnCertificate;
    function CfnConnectorPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("accessRole", cdk.requiredValidator)(properties.accessRole)), errors.collect(cdk.propertyValidator("accessRole", cdk.validateString)(properties.accessRole)), errors.collect(cdk.propertyValidator("as2Config", cdk.requiredValidator)(properties.as2Config)), errors.collect(cdk.propertyValidator("as2Config", cdk.validateObject)(properties.as2Config)), errors.collect(cdk.propertyValidator("loggingRole", cdk.validateString)(properties.loggingRole)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("url", cdk.requiredValidator)(properties.url)), errors.collect(cdk.propertyValidator("url", cdk.validateString)(properties.url)), errors.wrap('supplied properties not correct for "CfnConnectorProps"');
    }
    function cfnConnectorPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectorPropsValidator(properties).assertSuccess(), { AccessRole: cdk.stringToCloudFormation(properties.accessRole), As2Config: cdk.objectToCloudFormation(properties.as2Config), Url: cdk.stringToCloudFormation(properties.url), LoggingRole: cdk.stringToCloudFormation(properties.loggingRole), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnConnectorPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("accessRole", "AccessRole", cfn_parse.FromCloudFormation.getString(properties.AccessRole)), ret.addPropertyResult("as2Config", "As2Config", cfn_parse.FromCloudFormation.getAny(properties.As2Config)), ret.addPropertyResult("url", "Url", cfn_parse.FromCloudFormation.getString(properties.Url)), ret.addPropertyResult("loggingRole", "LoggingRole", properties.LoggingRole != null ? cfn_parse.FromCloudFormation.getString(properties.LoggingRole) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnConnector = class _CfnConnector extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnConnectorPropsFromCloudFormation(resourceProperties), ret = new _CfnConnector(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnConnector.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_transfer_CfnConnectorProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnConnector), error;
        }
        cdk.requireProperty(props, "accessRole", this), cdk.requireProperty(props, "as2Config", this), cdk.requireProperty(props, "url", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrConnectorId = cdk.Token.asString(this.getAtt("ConnectorId", cdk.ResolutionTypeHint.STRING)), this.accessRole = props.accessRole, this.as2Config = props.as2Config, this.url = props.url, this.loggingRole = props.loggingRole, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Transfer::Connector", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnConnector.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { accessRole: this.accessRole, as2Config: this.as2Config, url: this.url, loggingRole: this.loggingRole, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnConnectorPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnConnector[_c] = { fqn: "aws-cdk-lib.aws_transfer.CfnConnector", version: "2.80.0" }, CfnConnector.CFN_RESOURCE_TYPE_NAME = "AWS::Transfer::Connector", exports2.CfnConnector = CfnConnector;
    function CfnProfilePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("as2Id", cdk.requiredValidator)(properties.as2Id)), errors.collect(cdk.propertyValidator("as2Id", cdk.validateString)(properties.as2Id)), errors.collect(cdk.propertyValidator("certificateIds", cdk.listValidator(cdk.validateString))(properties.certificateIds)), errors.collect(cdk.propertyValidator("profileType", cdk.requiredValidator)(properties.profileType)), errors.collect(cdk.propertyValidator("profileType", cdk.validateString)(properties.profileType)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnProfileProps"');
    }
    function cfnProfilePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnProfilePropsValidator(properties).assertSuccess(), { As2Id: cdk.stringToCloudFormation(properties.as2Id), ProfileType: cdk.stringToCloudFormation(properties.profileType), CertificateIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.certificateIds), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnProfilePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("as2Id", "As2Id", cfn_parse.FromCloudFormation.getString(properties.As2Id)), ret.addPropertyResult("profileType", "ProfileType", cfn_parse.FromCloudFormation.getString(properties.ProfileType)), ret.addPropertyResult("certificateIds", "CertificateIds", properties.CertificateIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CertificateIds) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnProfile = class _CfnProfile extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnProfilePropsFromCloudFormation(resourceProperties), ret = new _CfnProfile(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnProfile.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_transfer_CfnProfileProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnProfile), error;
        }
        cdk.requireProperty(props, "as2Id", this), cdk.requireProperty(props, "profileType", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrProfileId = cdk.Token.asString(this.getAtt("ProfileId", cdk.ResolutionTypeHint.STRING)), this.as2Id = props.as2Id, this.profileType = props.profileType, this.certificateIds = props.certificateIds, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Transfer::Profile", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnProfile.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { as2Id: this.as2Id, profileType: this.profileType, certificateIds: this.certificateIds, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnProfilePropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnProfile[_d] = { fqn: "aws-cdk-lib.aws_transfer.CfnProfile", version: "2.80.0" }, CfnProfile.CFN_RESOURCE_TYPE_NAME = "AWS::Transfer::Profile", exports2.CfnProfile = CfnProfile;
    function CfnServerPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("certificate", cdk.validateString)(properties.certificate)), errors.collect(cdk.propertyValidator("domain", cdk.validateString)(properties.domain)), errors.collect(cdk.propertyValidator("endpointDetails", CfnServer_EndpointDetailsPropertyValidator)(properties.endpointDetails)), errors.collect(cdk.propertyValidator("endpointType", cdk.validateString)(properties.endpointType)), errors.collect(cdk.propertyValidator("identityProviderDetails", CfnServer_IdentityProviderDetailsPropertyValidator)(properties.identityProviderDetails)), errors.collect(cdk.propertyValidator("identityProviderType", cdk.validateString)(properties.identityProviderType)), errors.collect(cdk.propertyValidator("loggingRole", cdk.validateString)(properties.loggingRole)), errors.collect(cdk.propertyValidator("postAuthenticationLoginBanner", cdk.validateString)(properties.postAuthenticationLoginBanner)), errors.collect(cdk.propertyValidator("preAuthenticationLoginBanner", cdk.validateString)(properties.preAuthenticationLoginBanner)), errors.collect(cdk.propertyValidator("protocolDetails", CfnServer_ProtocolDetailsPropertyValidator)(properties.protocolDetails)), errors.collect(cdk.propertyValidator("protocols", cdk.listValidator(cdk.validateString))(properties.protocols)), errors.collect(cdk.propertyValidator("securityPolicyName", cdk.validateString)(properties.securityPolicyName)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("workflowDetails", CfnServer_WorkflowDetailsPropertyValidator)(properties.workflowDetails)), errors.wrap('supplied properties not correct for "CfnServerProps"');
    }
    function cfnServerPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnServerPropsValidator(properties).assertSuccess(), { Certificate: cdk.stringToCloudFormation(properties.certificate), Domain: cdk.stringToCloudFormation(properties.domain), EndpointDetails: cfnServerEndpointDetailsPropertyToCloudFormation(properties.endpointDetails), EndpointType: cdk.stringToCloudFormation(properties.endpointType), IdentityProviderDetails: cfnServerIdentityProviderDetailsPropertyToCloudFormation(properties.identityProviderDetails), IdentityProviderType: cdk.stringToCloudFormation(properties.identityProviderType), LoggingRole: cdk.stringToCloudFormation(properties.loggingRole), PostAuthenticationLoginBanner: cdk.stringToCloudFormation(properties.postAuthenticationLoginBanner), PreAuthenticationLoginBanner: cdk.stringToCloudFormation(properties.preAuthenticationLoginBanner), ProtocolDetails: cfnServerProtocolDetailsPropertyToCloudFormation(properties.protocolDetails), Protocols: cdk.listMapper(cdk.stringToCloudFormation)(properties.protocols), SecurityPolicyName: cdk.stringToCloudFormation(properties.securityPolicyName), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), WorkflowDetails: cfnServerWorkflowDetailsPropertyToCloudFormation(properties.workflowDetails) }) : properties;
    }
    function CfnServerPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("certificate", "Certificate", properties.Certificate != null ? cfn_parse.FromCloudFormation.getString(properties.Certificate) : void 0), ret.addPropertyResult("domain", "Domain", properties.Domain != null ? cfn_parse.FromCloudFormation.getString(properties.Domain) : void 0), ret.addPropertyResult("endpointDetails", "EndpointDetails", properties.EndpointDetails != null ? CfnServerEndpointDetailsPropertyFromCloudFormation(properties.EndpointDetails) : void 0), ret.addPropertyResult("endpointType", "EndpointType", properties.EndpointType != null ? cfn_parse.FromCloudFormation.getString(properties.EndpointType) : void 0), ret.addPropertyResult("identityProviderDetails", "IdentityProviderDetails", properties.IdentityProviderDetails != null ? CfnServerIdentityProviderDetailsPropertyFromCloudFormation(properties.IdentityProviderDetails) : void 0), ret.addPropertyResult("identityProviderType", "IdentityProviderType", properties.IdentityProviderType != null ? cfn_parse.FromCloudFormation.getString(properties.IdentityProviderType) : void 0), ret.addPropertyResult("loggingRole", "LoggingRole", properties.LoggingRole != null ? cfn_parse.FromCloudFormation.getString(properties.LoggingRole) : void 0), ret.addPropertyResult("postAuthenticationLoginBanner", "PostAuthenticationLoginBanner", properties.PostAuthenticationLoginBanner != null ? cfn_parse.FromCloudFormation.getString(properties.PostAuthenticationLoginBanner) : void 0), ret.addPropertyResult("preAuthenticationLoginBanner", "PreAuthenticationLoginBanner", properties.PreAuthenticationLoginBanner != null ? cfn_parse.FromCloudFormation.getString(properties.PreAuthenticationLoginBanner) : void 0), ret.addPropertyResult("protocolDetails", "ProtocolDetails", properties.ProtocolDetails != null ? CfnServerProtocolDetailsPropertyFromCloudFormation(properties.ProtocolDetails) : void 0), ret.addPropertyResult("protocols", "Protocols", properties.Protocols != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getString)(properties.Protocols) : void 0), ret.addPropertyResult("securityPolicyName", "SecurityPolicyName", properties.SecurityPolicyName != null ? cfn_parse.FromCloudFormation.getString(properties.SecurityPolicyName) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("workflowDetails", "WorkflowDetails", properties.WorkflowDetails != null ? CfnServerWorkflowDetailsPropertyFromCloudFormation(properties.WorkflowDetails) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnServer = class _CfnServer extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnServerPropsFromCloudFormation(resourceProperties), ret = new _CfnServer(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnServer.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_transfer_CfnServerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnServer), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrServerId = cdk.Token.asString(this.getAtt("ServerId", cdk.ResolutionTypeHint.STRING)), this.certificate = props.certificate, this.domain = props.domain, this.endpointDetails = props.endpointDetails, this.endpointType = props.endpointType, this.identityProviderDetails = props.identityProviderDetails, this.identityProviderType = props.identityProviderType, this.loggingRole = props.loggingRole, this.postAuthenticationLoginBanner = props.postAuthenticationLoginBanner, this.preAuthenticationLoginBanner = props.preAuthenticationLoginBanner, this.protocolDetails = props.protocolDetails, this.protocols = props.protocols, this.securityPolicyName = props.securityPolicyName, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Transfer::Server", props.tags, { tagPropertyName: "tags" }), this.workflowDetails = props.workflowDetails;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnServer.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { certificate: this.certificate, domain: this.domain, endpointDetails: this.endpointDetails, endpointType: this.endpointType, identityProviderDetails: this.identityProviderDetails, identityProviderType: this.identityProviderType, loggingRole: this.loggingRole, postAuthenticationLoginBanner: this.postAuthenticationLoginBanner, preAuthenticationLoginBanner: this.preAuthenticationLoginBanner, protocolDetails: this.protocolDetails, protocols: this.protocols, securityPolicyName: this.securityPolicyName, tags: this.tags.renderTags(), workflowDetails: this.workflowDetails };
      }
      renderProperties(props) {
        return cfnServerPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnServer[_e] = { fqn: "aws-cdk-lib.aws_transfer.CfnServer", version: "2.80.0" }, CfnServer.CFN_RESOURCE_TYPE_NAME = "AWS::Transfer::Server", exports2.CfnServer = CfnServer;
    function CfnServer_EndpointDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("addressAllocationIds", cdk.listValidator(cdk.validateString))(properties.addressAllocationIds)), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("subnetIds", cdk.listValidator(cdk.validateString))(properties.subnetIds)), errors.collect(cdk.propertyValidator("vpcEndpointId", cdk.validateString)(properties.vpcEndpointId)), errors.collect(cdk.propertyValidator("vpcId", cdk.validateString)(properties.vpcId)), errors.wrap('supplied properties not correct for "EndpointDetailsProperty"');
    }
    function cfnServerEndpointDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnServer_EndpointDetailsPropertyValidator(properties).assertSuccess(), { AddressAllocationIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.addressAllocationIds), SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), SubnetIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.subnetIds), VpcEndpointId: cdk.stringToCloudFormation(properties.vpcEndpointId), VpcId: cdk.stringToCloudFormation(properties.vpcId) }) : properties;
    }
    function CfnServerEndpointDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("addressAllocationIds", "AddressAllocationIds", properties.AddressAllocationIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.AddressAllocationIds) : void 0), ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("subnetIds", "SubnetIds", properties.SubnetIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SubnetIds) : void 0), ret.addPropertyResult("vpcEndpointId", "VpcEndpointId", properties.VpcEndpointId != null ? cfn_parse.FromCloudFormation.getString(properties.VpcEndpointId) : void 0), ret.addPropertyResult("vpcId", "VpcId", properties.VpcId != null ? cfn_parse.FromCloudFormation.getString(properties.VpcId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnServer_IdentityProviderDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("directoryId", cdk.validateString)(properties.directoryId)), errors.collect(cdk.propertyValidator("function", cdk.validateString)(properties.function)), errors.collect(cdk.propertyValidator("invocationRole", cdk.validateString)(properties.invocationRole)), errors.collect(cdk.propertyValidator("url", cdk.validateString)(properties.url)), errors.wrap('supplied properties not correct for "IdentityProviderDetailsProperty"');
    }
    function cfnServerIdentityProviderDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnServer_IdentityProviderDetailsPropertyValidator(properties).assertSuccess(), { DirectoryId: cdk.stringToCloudFormation(properties.directoryId), Function: cdk.stringToCloudFormation(properties.function), InvocationRole: cdk.stringToCloudFormation(properties.invocationRole), Url: cdk.stringToCloudFormation(properties.url) }) : properties;
    }
    function CfnServerIdentityProviderDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("directoryId", "DirectoryId", properties.DirectoryId != null ? cfn_parse.FromCloudFormation.getString(properties.DirectoryId) : void 0), ret.addPropertyResult("function", "Function", properties.Function != null ? cfn_parse.FromCloudFormation.getString(properties.Function) : void 0), ret.addPropertyResult("invocationRole", "InvocationRole", properties.InvocationRole != null ? cfn_parse.FromCloudFormation.getString(properties.InvocationRole) : void 0), ret.addPropertyResult("url", "Url", properties.Url != null ? cfn_parse.FromCloudFormation.getString(properties.Url) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnServer_ProtocolDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("as2Transports", cdk.listValidator(cdk.validateString))(properties.as2Transports)), errors.collect(cdk.propertyValidator("passiveIp", cdk.validateString)(properties.passiveIp)), errors.collect(cdk.propertyValidator("setStatOption", cdk.validateString)(properties.setStatOption)), errors.collect(cdk.propertyValidator("tlsSessionResumptionMode", cdk.validateString)(properties.tlsSessionResumptionMode)), errors.wrap('supplied properties not correct for "ProtocolDetailsProperty"');
    }
    function cfnServerProtocolDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnServer_ProtocolDetailsPropertyValidator(properties).assertSuccess(), { As2Transports: cdk.listMapper(cdk.stringToCloudFormation)(properties.as2Transports), PassiveIp: cdk.stringToCloudFormation(properties.passiveIp), SetStatOption: cdk.stringToCloudFormation(properties.setStatOption), TlsSessionResumptionMode: cdk.stringToCloudFormation(properties.tlsSessionResumptionMode) }) : properties;
    }
    function CfnServerProtocolDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("as2Transports", "As2Transports", properties.As2Transports != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getString)(properties.As2Transports) : void 0), ret.addPropertyResult("passiveIp", "PassiveIp", properties.PassiveIp != null ? cfn_parse.FromCloudFormation.getString(properties.PassiveIp) : void 0), ret.addPropertyResult("setStatOption", "SetStatOption", properties.SetStatOption != null ? cfn_parse.FromCloudFormation.getString(properties.SetStatOption) : void 0), ret.addPropertyResult("tlsSessionResumptionMode", "TlsSessionResumptionMode", properties.TlsSessionResumptionMode != null ? cfn_parse.FromCloudFormation.getString(properties.TlsSessionResumptionMode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnServer_WorkflowDetailPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("executionRole", cdk.requiredValidator)(properties.executionRole)), errors.collect(cdk.propertyValidator("executionRole", cdk.validateString)(properties.executionRole)), errors.collect(cdk.propertyValidator("workflowId", cdk.requiredValidator)(properties.workflowId)), errors.collect(cdk.propertyValidator("workflowId", cdk.validateString)(properties.workflowId)), errors.wrap('supplied properties not correct for "WorkflowDetailProperty"');
    }
    function cfnServerWorkflowDetailPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnServer_WorkflowDetailPropertyValidator(properties).assertSuccess(), { ExecutionRole: cdk.stringToCloudFormation(properties.executionRole), WorkflowId: cdk.stringToCloudFormation(properties.workflowId) }) : properties;
    }
    function CfnServerWorkflowDetailPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("executionRole", "ExecutionRole", cfn_parse.FromCloudFormation.getString(properties.ExecutionRole)), ret.addPropertyResult("workflowId", "WorkflowId", cfn_parse.FromCloudFormation.getString(properties.WorkflowId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnServer_WorkflowDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("onPartialUpload", cdk.listValidator(CfnServer_WorkflowDetailPropertyValidator))(properties.onPartialUpload)), errors.collect(cdk.propertyValidator("onUpload", cdk.listValidator(CfnServer_WorkflowDetailPropertyValidator))(properties.onUpload)), errors.wrap('supplied properties not correct for "WorkflowDetailsProperty"');
    }
    function cfnServerWorkflowDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnServer_WorkflowDetailsPropertyValidator(properties).assertSuccess(), { OnPartialUpload: cdk.listMapper(cfnServerWorkflowDetailPropertyToCloudFormation)(properties.onPartialUpload), OnUpload: cdk.listMapper(cfnServerWorkflowDetailPropertyToCloudFormation)(properties.onUpload) }) : properties;
    }
    function CfnServerWorkflowDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("onPartialUpload", "OnPartialUpload", properties.OnPartialUpload != null ? cfn_parse.FromCloudFormation.getArray(CfnServerWorkflowDetailPropertyFromCloudFormation)(properties.OnPartialUpload) : void 0), ret.addPropertyResult("onUpload", "OnUpload", properties.OnUpload != null ? cfn_parse.FromCloudFormation.getArray(CfnServerWorkflowDetailPropertyFromCloudFormation)(properties.OnUpload) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUserPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("homeDirectory", cdk.validateString)(properties.homeDirectory)), errors.collect(cdk.propertyValidator("homeDirectoryMappings", cdk.listValidator(CfnUser_HomeDirectoryMapEntryPropertyValidator))(properties.homeDirectoryMappings)), errors.collect(cdk.propertyValidator("homeDirectoryType", cdk.validateString)(properties.homeDirectoryType)), errors.collect(cdk.propertyValidator("policy", cdk.validateString)(properties.policy)), errors.collect(cdk.propertyValidator("posixProfile", CfnUser_PosixProfilePropertyValidator)(properties.posixProfile)), errors.collect(cdk.propertyValidator("role", cdk.requiredValidator)(properties.role)), errors.collect(cdk.propertyValidator("role", cdk.validateString)(properties.role)), errors.collect(cdk.propertyValidator("serverId", cdk.requiredValidator)(properties.serverId)), errors.collect(cdk.propertyValidator("serverId", cdk.validateString)(properties.serverId)), errors.collect(cdk.propertyValidator("sshPublicKeys", cdk.listValidator(cdk.validateString))(properties.sshPublicKeys)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("userName", cdk.requiredValidator)(properties.userName)), errors.collect(cdk.propertyValidator("userName", cdk.validateString)(properties.userName)), errors.wrap('supplied properties not correct for "CfnUserProps"');
    }
    function cfnUserPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUserPropsValidator(properties).assertSuccess(), { Role: cdk.stringToCloudFormation(properties.role), ServerId: cdk.stringToCloudFormation(properties.serverId), UserName: cdk.stringToCloudFormation(properties.userName), HomeDirectory: cdk.stringToCloudFormation(properties.homeDirectory), HomeDirectoryMappings: cdk.listMapper(cfnUserHomeDirectoryMapEntryPropertyToCloudFormation)(properties.homeDirectoryMappings), HomeDirectoryType: cdk.stringToCloudFormation(properties.homeDirectoryType), Policy: cdk.stringToCloudFormation(properties.policy), PosixProfile: cfnUserPosixProfilePropertyToCloudFormation(properties.posixProfile), SshPublicKeys: cdk.listMapper(cdk.stringToCloudFormation)(properties.sshPublicKeys), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnUserPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("role", "Role", cfn_parse.FromCloudFormation.getString(properties.Role)), ret.addPropertyResult("serverId", "ServerId", cfn_parse.FromCloudFormation.getString(properties.ServerId)), ret.addPropertyResult("userName", "UserName", cfn_parse.FromCloudFormation.getString(properties.UserName)), ret.addPropertyResult("homeDirectory", "HomeDirectory", properties.HomeDirectory != null ? cfn_parse.FromCloudFormation.getString(properties.HomeDirectory) : void 0), ret.addPropertyResult("homeDirectoryMappings", "HomeDirectoryMappings", properties.HomeDirectoryMappings != null ? cfn_parse.FromCloudFormation.getArray(CfnUserHomeDirectoryMapEntryPropertyFromCloudFormation)(properties.HomeDirectoryMappings) : void 0), ret.addPropertyResult("homeDirectoryType", "HomeDirectoryType", properties.HomeDirectoryType != null ? cfn_parse.FromCloudFormation.getString(properties.HomeDirectoryType) : void 0), ret.addPropertyResult("policy", "Policy", properties.Policy != null ? cfn_parse.FromCloudFormation.getString(properties.Policy) : void 0), ret.addPropertyResult("posixProfile", "PosixProfile", properties.PosixProfile != null ? CfnUserPosixProfilePropertyFromCloudFormation(properties.PosixProfile) : void 0), ret.addPropertyResult("sshPublicKeys", "SshPublicKeys", properties.SshPublicKeys != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getString)(properties.SshPublicKeys) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnUser = class _CfnUser extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnUserPropsFromCloudFormation(resourceProperties), ret = new _CfnUser(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnUser.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_transfer_CfnUserProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnUser), error;
        }
        cdk.requireProperty(props, "role", this), cdk.requireProperty(props, "serverId", this), cdk.requireProperty(props, "userName", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrServerId = cdk.Token.asString(this.getAtt("ServerId", cdk.ResolutionTypeHint.STRING)), this.attrUserName = cdk.Token.asString(this.getAtt("UserName", cdk.ResolutionTypeHint.STRING)), this.role = props.role, this.serverId = props.serverId, this.userName = props.userName, this.homeDirectory = props.homeDirectory, this.homeDirectoryMappings = props.homeDirectoryMappings, this.homeDirectoryType = props.homeDirectoryType, this.policy = props.policy, this.posixProfile = props.posixProfile, this.sshPublicKeys = props.sshPublicKeys, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Transfer::User", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnUser.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { role: this.role, serverId: this.serverId, userName: this.userName, homeDirectory: this.homeDirectory, homeDirectoryMappings: this.homeDirectoryMappings, homeDirectoryType: this.homeDirectoryType, policy: this.policy, posixProfile: this.posixProfile, sshPublicKeys: this.sshPublicKeys, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnUserPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnUser[_f] = { fqn: "aws-cdk-lib.aws_transfer.CfnUser", version: "2.80.0" }, CfnUser.CFN_RESOURCE_TYPE_NAME = "AWS::Transfer::User", exports2.CfnUser = CfnUser;
    function CfnUser_HomeDirectoryMapEntryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("entry", cdk.requiredValidator)(properties.entry)), errors.collect(cdk.propertyValidator("entry", cdk.validateString)(properties.entry)), errors.collect(cdk.propertyValidator("target", cdk.requiredValidator)(properties.target)), errors.collect(cdk.propertyValidator("target", cdk.validateString)(properties.target)), errors.wrap('supplied properties not correct for "HomeDirectoryMapEntryProperty"');
    }
    function cfnUserHomeDirectoryMapEntryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUser_HomeDirectoryMapEntryPropertyValidator(properties).assertSuccess(), { Entry: cdk.stringToCloudFormation(properties.entry), Target: cdk.stringToCloudFormation(properties.target) }) : properties;
    }
    function CfnUserHomeDirectoryMapEntryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("entry", "Entry", cfn_parse.FromCloudFormation.getString(properties.Entry)), ret.addPropertyResult("target", "Target", cfn_parse.FromCloudFormation.getString(properties.Target)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnUser_PosixProfilePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("gid", cdk.requiredValidator)(properties.gid)), errors.collect(cdk.propertyValidator("gid", cdk.validateNumber)(properties.gid)), errors.collect(cdk.propertyValidator("secondaryGids", cdk.listValidator(cdk.validateNumber))(properties.secondaryGids)), errors.collect(cdk.propertyValidator("uid", cdk.requiredValidator)(properties.uid)), errors.collect(cdk.propertyValidator("uid", cdk.validateNumber)(properties.uid)), errors.wrap('supplied properties not correct for "PosixProfileProperty"');
    }
    function cfnUserPosixProfilePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnUser_PosixProfilePropertyValidator(properties).assertSuccess(), { Gid: cdk.numberToCloudFormation(properties.gid), SecondaryGids: cdk.listMapper(cdk.numberToCloudFormation)(properties.secondaryGids), Uid: cdk.numberToCloudFormation(properties.uid) }) : properties;
    }
    function CfnUserPosixProfilePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("gid", "Gid", cfn_parse.FromCloudFormation.getNumber(properties.Gid)), ret.addPropertyResult("secondaryGids", "SecondaryGids", properties.SecondaryGids != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getNumber)(properties.SecondaryGids) : void 0), ret.addPropertyResult("uid", "Uid", cfn_parse.FromCloudFormation.getNumber(properties.Uid)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWorkflowPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("onExceptionSteps", cdk.listValidator(CfnWorkflow_WorkflowStepPropertyValidator))(properties.onExceptionSteps)), errors.collect(cdk.propertyValidator("steps", cdk.requiredValidator)(properties.steps)), errors.collect(cdk.propertyValidator("steps", cdk.listValidator(CfnWorkflow_WorkflowStepPropertyValidator))(properties.steps)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnWorkflowProps"');
    }
    function cfnWorkflowPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkflowPropsValidator(properties).assertSuccess(), { Steps: cdk.listMapper(cfnWorkflowWorkflowStepPropertyToCloudFormation)(properties.steps), Description: cdk.stringToCloudFormation(properties.description), OnExceptionSteps: cdk.listMapper(cfnWorkflowWorkflowStepPropertyToCloudFormation)(properties.onExceptionSteps), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnWorkflowPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("steps", "Steps", cfn_parse.FromCloudFormation.getArray(CfnWorkflowWorkflowStepPropertyFromCloudFormation)(properties.Steps)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("onExceptionSteps", "OnExceptionSteps", properties.OnExceptionSteps != null ? cfn_parse.FromCloudFormation.getArray(CfnWorkflowWorkflowStepPropertyFromCloudFormation)(properties.OnExceptionSteps) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnWorkflow = class _CfnWorkflow extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnWorkflowPropsFromCloudFormation(resourceProperties), ret = new _CfnWorkflow(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnWorkflow.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_transfer_CfnWorkflowProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnWorkflow), error;
        }
        cdk.requireProperty(props, "steps", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrWorkflowId = cdk.Token.asString(this.getAtt("WorkflowId", cdk.ResolutionTypeHint.STRING)), this.steps = props.steps, this.description = props.description, this.onExceptionSteps = props.onExceptionSteps, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Transfer::Workflow", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnWorkflow.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { steps: this.steps, description: this.description, onExceptionSteps: this.onExceptionSteps, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnWorkflowPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnWorkflow[_g] = { fqn: "aws-cdk-lib.aws_transfer.CfnWorkflow", version: "2.80.0" }, CfnWorkflow.CFN_RESOURCE_TYPE_NAME = "AWS::Transfer::Workflow", exports2.CfnWorkflow = CfnWorkflow;
    function CfnWorkflow_DecryptStepDetailsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationFileLocation", CfnWorkflow_InputFileLocationPropertyValidator)(properties.destinationFileLocation)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("overwriteExisting", cdk.validateString)(properties.overwriteExisting)), errors.collect(cdk.propertyValidator("sourceFileLocation", cdk.validateString)(properties.sourceFileLocation)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "DecryptStepDetailsProperty"');
    }
    function cfnWorkflowDecryptStepDetailsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkflow_DecryptStepDetailsPropertyValidator(properties).assertSuccess(), { DestinationFileLocation: cfnWorkflowInputFileLocationPropertyToCloudFormation(properties.destinationFileLocation), Name: cdk.stringToCloudFormation(properties.name), OverwriteExisting: cdk.stringToCloudFormation(properties.overwriteExisting), SourceFileLocation: cdk.stringToCloudFormation(properties.sourceFileLocation), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnWorkflowDecryptStepDetailsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationFileLocation", "DestinationFileLocation", properties.DestinationFileLocation != null ? CfnWorkflowInputFileLocationPropertyFromCloudFormation(properties.DestinationFileLocation) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("overwriteExisting", "OverwriteExisting", properties.OverwriteExisting != null ? cfn_parse.FromCloudFormation.getString(properties.OverwriteExisting) : void 0), ret.addPropertyResult("sourceFileLocation", "SourceFileLocation", properties.SourceFileLocation != null ? cfn_parse.FromCloudFormation.getString(properties.SourceFileLocation) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWorkflow_EfsInputFileLocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fileSystemId", cdk.validateString)(properties.fileSystemId)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.wrap('supplied properties not correct for "EfsInputFileLocationProperty"');
    }
    function cfnWorkflowEfsInputFileLocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkflow_EfsInputFileLocationPropertyValidator(properties).assertSuccess(), { FileSystemId: cdk.stringToCloudFormation(properties.fileSystemId), Path: cdk.stringToCloudFormation(properties.path) }) : properties;
    }
    function CfnWorkflowEfsInputFileLocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fileSystemId", "FileSystemId", properties.FileSystemId != null ? cfn_parse.FromCloudFormation.getString(properties.FileSystemId) : void 0), ret.addPropertyResult("path", "Path", properties.Path != null ? cfn_parse.FromCloudFormation.getString(properties.Path) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWorkflow_InputFileLocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("efsFileLocation", CfnWorkflow_EfsInputFileLocationPropertyValidator)(properties.efsFileLocation)), errors.collect(cdk.propertyValidator("s3FileLocation", CfnWorkflow_S3InputFileLocationPropertyValidator)(properties.s3FileLocation)), errors.wrap('supplied properties not correct for "InputFileLocationProperty"');
    }
    function cfnWorkflowInputFileLocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkflow_InputFileLocationPropertyValidator(properties).assertSuccess(), { EfsFileLocation: cfnWorkflowEfsInputFileLocationPropertyToCloudFormation(properties.efsFileLocation), S3FileLocation: cfnWorkflowS3InputFileLocationPropertyToCloudFormation(properties.s3FileLocation) }) : properties;
    }
    function CfnWorkflowInputFileLocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("efsFileLocation", "EfsFileLocation", properties.EfsFileLocation != null ? CfnWorkflowEfsInputFileLocationPropertyFromCloudFormation(properties.EfsFileLocation) : void 0), ret.addPropertyResult("s3FileLocation", "S3FileLocation", properties.S3FileLocation != null ? CfnWorkflowS3InputFileLocationPropertyFromCloudFormation(properties.S3FileLocation) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWorkflow_S3InputFileLocationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bucket", cdk.validateString)(properties.bucket)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.wrap('supplied properties not correct for "S3InputFileLocationProperty"');
    }
    function cfnWorkflowS3InputFileLocationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkflow_S3InputFileLocationPropertyValidator(properties).assertSuccess(), { Bucket: cdk.stringToCloudFormation(properties.bucket), Key: cdk.stringToCloudFormation(properties.key) }) : properties;
    }
    function CfnWorkflowS3InputFileLocationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bucket", "Bucket", properties.Bucket != null ? cfn_parse.FromCloudFormation.getString(properties.Bucket) : void 0), ret.addPropertyResult("key", "Key", properties.Key != null ? cfn_parse.FromCloudFormation.getString(properties.Key) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWorkflow_WorkflowStepPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("copyStepDetails", cdk.validateObject)(properties.copyStepDetails)), errors.collect(cdk.propertyValidator("customStepDetails", cdk.validateObject)(properties.customStepDetails)), errors.collect(cdk.propertyValidator("decryptStepDetails", CfnWorkflow_DecryptStepDetailsPropertyValidator)(properties.decryptStepDetails)), errors.collect(cdk.propertyValidator("deleteStepDetails", cdk.validateObject)(properties.deleteStepDetails)), errors.collect(cdk.propertyValidator("tagStepDetails", cdk.validateObject)(properties.tagStepDetails)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "WorkflowStepProperty"');
    }
    function cfnWorkflowWorkflowStepPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkflow_WorkflowStepPropertyValidator(properties).assertSuccess(), { CopyStepDetails: cdk.objectToCloudFormation(properties.copyStepDetails), CustomStepDetails: cdk.objectToCloudFormation(properties.customStepDetails), DecryptStepDetails: cfnWorkflowDecryptStepDetailsPropertyToCloudFormation(properties.decryptStepDetails), DeleteStepDetails: cdk.objectToCloudFormation(properties.deleteStepDetails), TagStepDetails: cdk.objectToCloudFormation(properties.tagStepDetails), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnWorkflowWorkflowStepPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("copyStepDetails", "CopyStepDetails", properties.CopyStepDetails != null ? cfn_parse.FromCloudFormation.getAny(properties.CopyStepDetails) : void 0), ret.addPropertyResult("customStepDetails", "CustomStepDetails", properties.CustomStepDetails != null ? cfn_parse.FromCloudFormation.getAny(properties.CustomStepDetails) : void 0), ret.addPropertyResult("decryptStepDetails", "DecryptStepDetails", properties.DecryptStepDetails != null ? CfnWorkflowDecryptStepDetailsPropertyFromCloudFormation(properties.DecryptStepDetails) : void 0), ret.addPropertyResult("deleteStepDetails", "DeleteStepDetails", properties.DeleteStepDetails != null ? cfn_parse.FromCloudFormation.getAny(properties.DeleteStepDetails) : void 0), ret.addPropertyResult("tagStepDetails", "TagStepDetails", properties.TagStepDetails != null ? cfn_parse.FromCloudFormation.getAny(properties.TagStepDetails) : void 0), ret.addPropertyResult("type", "Type", properties.Type != null ? cfn_parse.FromCloudFormation.getString(properties.Type) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-transfer/lib/index.js
var require_lib251 = __commonJS({
  "node_modules/aws-cdk-lib/aws-transfer/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_transfer_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-transfer/index.js
var require_aws_transfer = __commonJS({
  "node_modules/aws-cdk-lib/aws-transfer/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib251(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-voiceid/lib/voiceid.generated.js
var require_voiceid_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-voiceid/lib/voiceid.generated.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnDomain = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnDomainPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("serverSideEncryptionConfiguration", cdk.requiredValidator)(properties.serverSideEncryptionConfiguration)), errors.collect(cdk.propertyValidator("serverSideEncryptionConfiguration", CfnDomain_ServerSideEncryptionConfigurationPropertyValidator)(properties.serverSideEncryptionConfiguration)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnDomainProps"');
    }
    function cfnDomainPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomainPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), ServerSideEncryptionConfiguration: cfnDomainServerSideEncryptionConfigurationPropertyToCloudFormation(properties.serverSideEncryptionConfiguration), Description: cdk.stringToCloudFormation(properties.description), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnDomainPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("serverSideEncryptionConfiguration", "ServerSideEncryptionConfiguration", CfnDomainServerSideEncryptionConfigurationPropertyFromCloudFormation(properties.ServerSideEncryptionConfiguration)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnDomain = class _CfnDomain extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnDomainPropsFromCloudFormation(resourceProperties), ret = new _CfnDomain(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnDomain.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_voiceid_CfnDomainProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnDomain), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "serverSideEncryptionConfiguration", this), this.attrDomainId = cdk.Token.asString(this.getAtt("DomainId", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.serverSideEncryptionConfiguration = props.serverSideEncryptionConfiguration, this.description = props.description, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::VoiceID::Domain", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnDomain.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, serverSideEncryptionConfiguration: this.serverSideEncryptionConfiguration, description: this.description, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnDomainPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnDomain[_a] = { fqn: "aws-cdk-lib.aws_voiceid.CfnDomain", version: "2.80.0" }, CfnDomain.CFN_RESOURCE_TYPE_NAME = "AWS::VoiceID::Domain", exports2.CfnDomain = CfnDomain;
    function CfnDomain_ServerSideEncryptionConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.requiredValidator)(properties.kmsKeyId)), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.wrap('supplied properties not correct for "ServerSideEncryptionConfigurationProperty"');
    }
    function cfnDomainServerSideEncryptionConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnDomain_ServerSideEncryptionConfigurationPropertyValidator(properties).assertSuccess(), { KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId) }) : properties;
    }
    function CfnDomainServerSideEncryptionConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsKeyId", "KmsKeyId", cfn_parse.FromCloudFormation.getString(properties.KmsKeyId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-voiceid/lib/index.js
var require_lib252 = __commonJS({
  "node_modules/aws-cdk-lib/aws-voiceid/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_voiceid_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-voiceid/index.js
var require_aws_voiceid = __commonJS({
  "node_modules/aws-cdk-lib/aws-voiceid/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib252(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-vpclattice/lib/vpclattice.generated.js
var require_vpclattice_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-vpclattice/lib/vpclattice.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnTargetGroup = exports2.CfnServiceNetworkVpcAssociation = exports2.CfnServiceNetworkServiceAssociation = exports2.CfnServiceNetwork = exports2.CfnService = exports2.CfnRule = exports2.CfnResourcePolicy = exports2.CfnListener = exports2.CfnAuthPolicy = exports2.CfnAccessLogSubscription = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAccessLogSubscriptionPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("destinationArn", cdk.requiredValidator)(properties.destinationArn)), errors.collect(cdk.propertyValidator("destinationArn", cdk.validateString)(properties.destinationArn)), errors.collect(cdk.propertyValidator("resourceIdentifier", cdk.validateString)(properties.resourceIdentifier)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnAccessLogSubscriptionProps"');
    }
    function cfnAccessLogSubscriptionPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAccessLogSubscriptionPropsValidator(properties).assertSuccess(), { DestinationArn: cdk.stringToCloudFormation(properties.destinationArn), ResourceIdentifier: cdk.stringToCloudFormation(properties.resourceIdentifier), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnAccessLogSubscriptionPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("destinationArn", "DestinationArn", cfn_parse.FromCloudFormation.getString(properties.DestinationArn)), ret.addPropertyResult("resourceIdentifier", "ResourceIdentifier", properties.ResourceIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceIdentifier) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAccessLogSubscription = class _CfnAccessLogSubscription extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAccessLogSubscriptionPropsFromCloudFormation(resourceProperties), ret = new _CfnAccessLogSubscription(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAccessLogSubscription.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_vpclattice_CfnAccessLogSubscriptionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAccessLogSubscription), error;
        }
        cdk.requireProperty(props, "destinationArn", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrResourceArn = cdk.Token.asString(this.getAtt("ResourceArn", cdk.ResolutionTypeHint.STRING)), this.attrResourceId = cdk.Token.asString(this.getAtt("ResourceId", cdk.ResolutionTypeHint.STRING)), this.destinationArn = props.destinationArn, this.resourceIdentifier = props.resourceIdentifier, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::VpcLattice::AccessLogSubscription", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAccessLogSubscription.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { destinationArn: this.destinationArn, resourceIdentifier: this.resourceIdentifier, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnAccessLogSubscriptionPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAccessLogSubscription[_a] = { fqn: "aws-cdk-lib.aws_vpclattice.CfnAccessLogSubscription", version: "2.80.0" }, CfnAccessLogSubscription.CFN_RESOURCE_TYPE_NAME = "AWS::VpcLattice::AccessLogSubscription", exports2.CfnAccessLogSubscription = CfnAccessLogSubscription;
    function CfnAuthPolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("policy", cdk.requiredValidator)(properties.policy)), errors.collect(cdk.propertyValidator("policy", cdk.validateObject)(properties.policy)), errors.collect(cdk.propertyValidator("resourceIdentifier", cdk.requiredValidator)(properties.resourceIdentifier)), errors.collect(cdk.propertyValidator("resourceIdentifier", cdk.validateString)(properties.resourceIdentifier)), errors.wrap('supplied properties not correct for "CfnAuthPolicyProps"');
    }
    function cfnAuthPolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAuthPolicyPropsValidator(properties).assertSuccess(), { Policy: cdk.objectToCloudFormation(properties.policy), ResourceIdentifier: cdk.stringToCloudFormation(properties.resourceIdentifier) }) : properties;
    }
    function CfnAuthPolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("policy", "Policy", cfn_parse.FromCloudFormation.getAny(properties.Policy)), ret.addPropertyResult("resourceIdentifier", "ResourceIdentifier", cfn_parse.FromCloudFormation.getString(properties.ResourceIdentifier)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAuthPolicy = class _CfnAuthPolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAuthPolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnAuthPolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAuthPolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_vpclattice_CfnAuthPolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAuthPolicy), error;
        }
        cdk.requireProperty(props, "policy", this), cdk.requireProperty(props, "resourceIdentifier", this), this.attrState = cdk.Token.asString(this.getAtt("State", cdk.ResolutionTypeHint.STRING)), this.policy = props.policy, this.resourceIdentifier = props.resourceIdentifier;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAuthPolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { policy: this.policy, resourceIdentifier: this.resourceIdentifier };
      }
      renderProperties(props) {
        return cfnAuthPolicyPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnAuthPolicy[_b] = { fqn: "aws-cdk-lib.aws_vpclattice.CfnAuthPolicy", version: "2.80.0" }, CfnAuthPolicy.CFN_RESOURCE_TYPE_NAME = "AWS::VpcLattice::AuthPolicy", exports2.CfnAuthPolicy = CfnAuthPolicy;
    function CfnListenerPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultAction", cdk.requiredValidator)(properties.defaultAction)), errors.collect(cdk.propertyValidator("defaultAction", CfnListener_DefaultActionPropertyValidator)(properties.defaultAction)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("protocol", cdk.requiredValidator)(properties.protocol)), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.collect(cdk.propertyValidator("serviceIdentifier", cdk.validateString)(properties.serviceIdentifier)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnListenerProps"');
    }
    function cfnListenerPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListenerPropsValidator(properties).assertSuccess(), { DefaultAction: cfnListenerDefaultActionPropertyToCloudFormation(properties.defaultAction), Protocol: cdk.stringToCloudFormation(properties.protocol), Name: cdk.stringToCloudFormation(properties.name), Port: cdk.numberToCloudFormation(properties.port), ServiceIdentifier: cdk.stringToCloudFormation(properties.serviceIdentifier), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnListenerPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultAction", "DefaultAction", CfnListenerDefaultActionPropertyFromCloudFormation(properties.DefaultAction)), ret.addPropertyResult("protocol", "Protocol", cfn_parse.FromCloudFormation.getString(properties.Protocol)), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addPropertyResult("serviceIdentifier", "ServiceIdentifier", properties.ServiceIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceIdentifier) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnListener = class _CfnListener extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnListenerPropsFromCloudFormation(resourceProperties), ret = new _CfnListener(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnListener.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_vpclattice_CfnListenerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnListener), error;
        }
        cdk.requireProperty(props, "defaultAction", this), cdk.requireProperty(props, "protocol", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrServiceArn = cdk.Token.asString(this.getAtt("ServiceArn", cdk.ResolutionTypeHint.STRING)), this.attrServiceId = cdk.Token.asString(this.getAtt("ServiceId", cdk.ResolutionTypeHint.STRING)), this.defaultAction = props.defaultAction, this.protocol = props.protocol, this.name = props.name, this.port = props.port, this.serviceIdentifier = props.serviceIdentifier, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::VpcLattice::Listener", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnListener.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { defaultAction: this.defaultAction, protocol: this.protocol, name: this.name, port: this.port, serviceIdentifier: this.serviceIdentifier, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnListenerPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnListener[_c] = { fqn: "aws-cdk-lib.aws_vpclattice.CfnListener", version: "2.80.0" }, CfnListener.CFN_RESOURCE_TYPE_NAME = "AWS::VpcLattice::Listener", exports2.CfnListener = CfnListener;
    function CfnListener_DefaultActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fixedResponse", CfnListener_FixedResponsePropertyValidator)(properties.fixedResponse)), errors.collect(cdk.propertyValidator("forward", CfnListener_ForwardPropertyValidator)(properties.forward)), errors.wrap('supplied properties not correct for "DefaultActionProperty"');
    }
    function cfnListenerDefaultActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListener_DefaultActionPropertyValidator(properties).assertSuccess(), { FixedResponse: cfnListenerFixedResponsePropertyToCloudFormation(properties.fixedResponse), Forward: cfnListenerForwardPropertyToCloudFormation(properties.forward) }) : properties;
    }
    function CfnListenerDefaultActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fixedResponse", "FixedResponse", properties.FixedResponse != null ? CfnListenerFixedResponsePropertyFromCloudFormation(properties.FixedResponse) : void 0), ret.addPropertyResult("forward", "Forward", properties.Forward != null ? CfnListenerForwardPropertyFromCloudFormation(properties.Forward) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnListener_FixedResponsePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("statusCode", cdk.requiredValidator)(properties.statusCode)), errors.collect(cdk.propertyValidator("statusCode", cdk.validateNumber)(properties.statusCode)), errors.wrap('supplied properties not correct for "FixedResponseProperty"');
    }
    function cfnListenerFixedResponsePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListener_FixedResponsePropertyValidator(properties).assertSuccess(), { StatusCode: cdk.numberToCloudFormation(properties.statusCode) }) : properties;
    }
    function CfnListenerFixedResponsePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("statusCode", "StatusCode", cfn_parse.FromCloudFormation.getNumber(properties.StatusCode)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnListener_ForwardPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("targetGroups", cdk.requiredValidator)(properties.targetGroups)), errors.collect(cdk.propertyValidator("targetGroups", cdk.listValidator(CfnListener_WeightedTargetGroupPropertyValidator))(properties.targetGroups)), errors.wrap('supplied properties not correct for "ForwardProperty"');
    }
    function cfnListenerForwardPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListener_ForwardPropertyValidator(properties).assertSuccess(), { TargetGroups: cdk.listMapper(cfnListenerWeightedTargetGroupPropertyToCloudFormation)(properties.targetGroups) }) : properties;
    }
    function CfnListenerForwardPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("targetGroups", "TargetGroups", cfn_parse.FromCloudFormation.getArray(CfnListenerWeightedTargetGroupPropertyFromCloudFormation)(properties.TargetGroups)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnListener_WeightedTargetGroupPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("targetGroupIdentifier", cdk.requiredValidator)(properties.targetGroupIdentifier)), errors.collect(cdk.propertyValidator("targetGroupIdentifier", cdk.validateString)(properties.targetGroupIdentifier)), errors.collect(cdk.propertyValidator("weight", cdk.validateNumber)(properties.weight)), errors.wrap('supplied properties not correct for "WeightedTargetGroupProperty"');
    }
    function cfnListenerWeightedTargetGroupPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnListener_WeightedTargetGroupPropertyValidator(properties).assertSuccess(), { TargetGroupIdentifier: cdk.stringToCloudFormation(properties.targetGroupIdentifier), Weight: cdk.numberToCloudFormation(properties.weight) }) : properties;
    }
    function CfnListenerWeightedTargetGroupPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("targetGroupIdentifier", "TargetGroupIdentifier", cfn_parse.FromCloudFormation.getString(properties.TargetGroupIdentifier)), ret.addPropertyResult("weight", "Weight", properties.Weight != null ? cfn_parse.FromCloudFormation.getNumber(properties.Weight) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourcePolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("policy", cdk.requiredValidator)(properties.policy)), errors.collect(cdk.propertyValidator("policy", cdk.validateObject)(properties.policy)), errors.collect(cdk.propertyValidator("resourceArn", cdk.requiredValidator)(properties.resourceArn)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.wrap('supplied properties not correct for "CfnResourcePolicyProps"');
    }
    function cfnResourcePolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourcePolicyPropsValidator(properties).assertSuccess(), { Policy: cdk.objectToCloudFormation(properties.policy), ResourceArn: cdk.stringToCloudFormation(properties.resourceArn) }) : properties;
    }
    function CfnResourcePolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("policy", "Policy", cfn_parse.FromCloudFormation.getAny(properties.Policy)), ret.addPropertyResult("resourceArn", "ResourceArn", cfn_parse.FromCloudFormation.getString(properties.ResourceArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResourcePolicy = class _CfnResourcePolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResourcePolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnResourcePolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnResourcePolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_vpclattice_CfnResourcePolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResourcePolicy), error;
        }
        cdk.requireProperty(props, "policy", this), cdk.requireProperty(props, "resourceArn", this), this.policy = props.policy, this.resourceArn = props.resourceArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResourcePolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { policy: this.policy, resourceArn: this.resourceArn };
      }
      renderProperties(props) {
        return cfnResourcePolicyPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnResourcePolicy[_d] = { fqn: "aws-cdk-lib.aws_vpclattice.CfnResourcePolicy", version: "2.80.0" }, CfnResourcePolicy.CFN_RESOURCE_TYPE_NAME = "AWS::VpcLattice::ResourcePolicy", exports2.CfnResourcePolicy = CfnResourcePolicy;
    function CfnRulePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.requiredValidator)(properties.action)), errors.collect(cdk.propertyValidator("action", CfnRule_ActionPropertyValidator)(properties.action)), errors.collect(cdk.propertyValidator("listenerIdentifier", cdk.validateString)(properties.listenerIdentifier)), errors.collect(cdk.propertyValidator("match", cdk.requiredValidator)(properties.match)), errors.collect(cdk.propertyValidator("match", CfnRule_MatchPropertyValidator)(properties.match)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("priority", cdk.requiredValidator)(properties.priority)), errors.collect(cdk.propertyValidator("priority", cdk.validateNumber)(properties.priority)), errors.collect(cdk.propertyValidator("serviceIdentifier", cdk.validateString)(properties.serviceIdentifier)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnRuleProps"');
    }
    function cfnRulePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRulePropsValidator(properties).assertSuccess(), { Action: cfnRuleActionPropertyToCloudFormation(properties.action), Match: cfnRuleMatchPropertyToCloudFormation(properties.match), Priority: cdk.numberToCloudFormation(properties.priority), ListenerIdentifier: cdk.stringToCloudFormation(properties.listenerIdentifier), Name: cdk.stringToCloudFormation(properties.name), ServiceIdentifier: cdk.stringToCloudFormation(properties.serviceIdentifier), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnRulePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", CfnRuleActionPropertyFromCloudFormation(properties.Action)), ret.addPropertyResult("match", "Match", CfnRuleMatchPropertyFromCloudFormation(properties.Match)), ret.addPropertyResult("priority", "Priority", cfn_parse.FromCloudFormation.getNumber(properties.Priority)), ret.addPropertyResult("listenerIdentifier", "ListenerIdentifier", properties.ListenerIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.ListenerIdentifier) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("serviceIdentifier", "ServiceIdentifier", properties.ServiceIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceIdentifier) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRule = class _CfnRule extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRulePropsFromCloudFormation(resourceProperties), ret = new _CfnRule(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRule.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_vpclattice_CfnRuleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRule), error;
        }
        cdk.requireProperty(props, "action", this), cdk.requireProperty(props, "match", this), cdk.requireProperty(props, "priority", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.action = props.action, this.match = props.match, this.priority = props.priority, this.listenerIdentifier = props.listenerIdentifier, this.name = props.name, this.serviceIdentifier = props.serviceIdentifier, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::VpcLattice::Rule", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRule.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { action: this.action, match: this.match, priority: this.priority, listenerIdentifier: this.listenerIdentifier, name: this.name, serviceIdentifier: this.serviceIdentifier, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnRulePropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnRule[_e] = { fqn: "aws-cdk-lib.aws_vpclattice.CfnRule", version: "2.80.0" }, CfnRule.CFN_RESOURCE_TYPE_NAME = "AWS::VpcLattice::Rule", exports2.CfnRule = CfnRule;
    function CfnRule_ActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fixedResponse", CfnRule_FixedResponsePropertyValidator)(properties.fixedResponse)), errors.collect(cdk.propertyValidator("forward", CfnRule_ForwardPropertyValidator)(properties.forward)), errors.wrap('supplied properties not correct for "ActionProperty"');
    }
    function cfnRuleActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_ActionPropertyValidator(properties).assertSuccess(), { FixedResponse: cfnRuleFixedResponsePropertyToCloudFormation(properties.fixedResponse), Forward: cfnRuleForwardPropertyToCloudFormation(properties.forward) }) : properties;
    }
    function CfnRuleActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fixedResponse", "FixedResponse", properties.FixedResponse != null ? CfnRuleFixedResponsePropertyFromCloudFormation(properties.FixedResponse) : void 0), ret.addPropertyResult("forward", "Forward", properties.Forward != null ? CfnRuleForwardPropertyFromCloudFormation(properties.Forward) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_FixedResponsePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("statusCode", cdk.requiredValidator)(properties.statusCode)), errors.collect(cdk.propertyValidator("statusCode", cdk.validateNumber)(properties.statusCode)), errors.wrap('supplied properties not correct for "FixedResponseProperty"');
    }
    function cfnRuleFixedResponsePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_FixedResponsePropertyValidator(properties).assertSuccess(), { StatusCode: cdk.numberToCloudFormation(properties.statusCode) }) : properties;
    }
    function CfnRuleFixedResponsePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("statusCode", "StatusCode", cfn_parse.FromCloudFormation.getNumber(properties.StatusCode)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_ForwardPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("targetGroups", cdk.requiredValidator)(properties.targetGroups)), errors.collect(cdk.propertyValidator("targetGroups", cdk.listValidator(CfnRule_WeightedTargetGroupPropertyValidator))(properties.targetGroups)), errors.wrap('supplied properties not correct for "ForwardProperty"');
    }
    function cfnRuleForwardPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_ForwardPropertyValidator(properties).assertSuccess(), { TargetGroups: cdk.listMapper(cfnRuleWeightedTargetGroupPropertyToCloudFormation)(properties.targetGroups) }) : properties;
    }
    function CfnRuleForwardPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("targetGroups", "TargetGroups", cfn_parse.FromCloudFormation.getArray(CfnRuleWeightedTargetGroupPropertyFromCloudFormation)(properties.TargetGroups)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_HeaderMatchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("caseSensitive", cdk.validateBoolean)(properties.caseSensitive)), errors.collect(cdk.propertyValidator("match", cdk.requiredValidator)(properties.match)), errors.collect(cdk.propertyValidator("match", CfnRule_HeaderMatchTypePropertyValidator)(properties.match)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "HeaderMatchProperty"');
    }
    function cfnRuleHeaderMatchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_HeaderMatchPropertyValidator(properties).assertSuccess(), { CaseSensitive: cdk.booleanToCloudFormation(properties.caseSensitive), Match: cfnRuleHeaderMatchTypePropertyToCloudFormation(properties.match), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnRuleHeaderMatchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("caseSensitive", "CaseSensitive", properties.CaseSensitive != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CaseSensitive) : void 0), ret.addPropertyResult("match", "Match", CfnRuleHeaderMatchTypePropertyFromCloudFormation(properties.Match)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_HeaderMatchTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("contains", cdk.validateString)(properties.contains)), errors.collect(cdk.propertyValidator("exact", cdk.validateString)(properties.exact)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.wrap('supplied properties not correct for "HeaderMatchTypeProperty"');
    }
    function cfnRuleHeaderMatchTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_HeaderMatchTypePropertyValidator(properties).assertSuccess(), { Contains: cdk.stringToCloudFormation(properties.contains), Exact: cdk.stringToCloudFormation(properties.exact), Prefix: cdk.stringToCloudFormation(properties.prefix) }) : properties;
    }
    function CfnRuleHeaderMatchTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("contains", "Contains", properties.Contains != null ? cfn_parse.FromCloudFormation.getString(properties.Contains) : void 0), ret.addPropertyResult("exact", "Exact", properties.Exact != null ? cfn_parse.FromCloudFormation.getString(properties.Exact) : void 0), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_HttpMatchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("headerMatches", cdk.listValidator(CfnRule_HeaderMatchPropertyValidator))(properties.headerMatches)), errors.collect(cdk.propertyValidator("method", cdk.validateString)(properties.method)), errors.collect(cdk.propertyValidator("pathMatch", CfnRule_PathMatchPropertyValidator)(properties.pathMatch)), errors.wrap('supplied properties not correct for "HttpMatchProperty"');
    }
    function cfnRuleHttpMatchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_HttpMatchPropertyValidator(properties).assertSuccess(), { HeaderMatches: cdk.listMapper(cfnRuleHeaderMatchPropertyToCloudFormation)(properties.headerMatches), Method: cdk.stringToCloudFormation(properties.method), PathMatch: cfnRulePathMatchPropertyToCloudFormation(properties.pathMatch) }) : properties;
    }
    function CfnRuleHttpMatchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("headerMatches", "HeaderMatches", properties.HeaderMatches != null ? cfn_parse.FromCloudFormation.getArray(CfnRuleHeaderMatchPropertyFromCloudFormation)(properties.HeaderMatches) : void 0), ret.addPropertyResult("method", "Method", properties.Method != null ? cfn_parse.FromCloudFormation.getString(properties.Method) : void 0), ret.addPropertyResult("pathMatch", "PathMatch", properties.PathMatch != null ? CfnRulePathMatchPropertyFromCloudFormation(properties.PathMatch) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_MatchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("httpMatch", cdk.requiredValidator)(properties.httpMatch)), errors.collect(cdk.propertyValidator("httpMatch", CfnRule_HttpMatchPropertyValidator)(properties.httpMatch)), errors.wrap('supplied properties not correct for "MatchProperty"');
    }
    function cfnRuleMatchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_MatchPropertyValidator(properties).assertSuccess(), { HttpMatch: cfnRuleHttpMatchPropertyToCloudFormation(properties.httpMatch) }) : properties;
    }
    function CfnRuleMatchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("httpMatch", "HttpMatch", CfnRuleHttpMatchPropertyFromCloudFormation(properties.HttpMatch)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_PathMatchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("caseSensitive", cdk.validateBoolean)(properties.caseSensitive)), errors.collect(cdk.propertyValidator("match", cdk.requiredValidator)(properties.match)), errors.collect(cdk.propertyValidator("match", CfnRule_PathMatchTypePropertyValidator)(properties.match)), errors.wrap('supplied properties not correct for "PathMatchProperty"');
    }
    function cfnRulePathMatchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_PathMatchPropertyValidator(properties).assertSuccess(), { CaseSensitive: cdk.booleanToCloudFormation(properties.caseSensitive), Match: cfnRulePathMatchTypePropertyToCloudFormation(properties.match) }) : properties;
    }
    function CfnRulePathMatchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("caseSensitive", "CaseSensitive", properties.CaseSensitive != null ? cfn_parse.FromCloudFormation.getBoolean(properties.CaseSensitive) : void 0), ret.addPropertyResult("match", "Match", CfnRulePathMatchTypePropertyFromCloudFormation(properties.Match)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_PathMatchTypePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("exact", cdk.validateString)(properties.exact)), errors.collect(cdk.propertyValidator("prefix", cdk.validateString)(properties.prefix)), errors.wrap('supplied properties not correct for "PathMatchTypeProperty"');
    }
    function cfnRulePathMatchTypePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_PathMatchTypePropertyValidator(properties).assertSuccess(), { Exact: cdk.stringToCloudFormation(properties.exact), Prefix: cdk.stringToCloudFormation(properties.prefix) }) : properties;
    }
    function CfnRulePathMatchTypePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("exact", "Exact", properties.Exact != null ? cfn_parse.FromCloudFormation.getString(properties.Exact) : void 0), ret.addPropertyResult("prefix", "Prefix", properties.Prefix != null ? cfn_parse.FromCloudFormation.getString(properties.Prefix) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRule_WeightedTargetGroupPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("targetGroupIdentifier", cdk.requiredValidator)(properties.targetGroupIdentifier)), errors.collect(cdk.propertyValidator("targetGroupIdentifier", cdk.validateString)(properties.targetGroupIdentifier)), errors.collect(cdk.propertyValidator("weight", cdk.validateNumber)(properties.weight)), errors.wrap('supplied properties not correct for "WeightedTargetGroupProperty"');
    }
    function cfnRuleWeightedTargetGroupPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_WeightedTargetGroupPropertyValidator(properties).assertSuccess(), { TargetGroupIdentifier: cdk.stringToCloudFormation(properties.targetGroupIdentifier), Weight: cdk.numberToCloudFormation(properties.weight) }) : properties;
    }
    function CfnRuleWeightedTargetGroupPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("targetGroupIdentifier", "TargetGroupIdentifier", cfn_parse.FromCloudFormation.getString(properties.TargetGroupIdentifier)), ret.addPropertyResult("weight", "Weight", properties.Weight != null ? cfn_parse.FromCloudFormation.getNumber(properties.Weight) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnServicePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authType", cdk.validateString)(properties.authType)), errors.collect(cdk.propertyValidator("certificateArn", cdk.validateString)(properties.certificateArn)), errors.collect(cdk.propertyValidator("customDomainName", cdk.validateString)(properties.customDomainName)), errors.collect(cdk.propertyValidator("dnsEntry", CfnService_DnsEntryPropertyValidator)(properties.dnsEntry)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnServiceProps"');
    }
    function cfnServicePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnServicePropsValidator(properties).assertSuccess(), { AuthType: cdk.stringToCloudFormation(properties.authType), CertificateArn: cdk.stringToCloudFormation(properties.certificateArn), CustomDomainName: cdk.stringToCloudFormation(properties.customDomainName), DnsEntry: cfnServiceDnsEntryPropertyToCloudFormation(properties.dnsEntry), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnServicePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authType", "AuthType", properties.AuthType != null ? cfn_parse.FromCloudFormation.getString(properties.AuthType) : void 0), ret.addPropertyResult("certificateArn", "CertificateArn", properties.CertificateArn != null ? cfn_parse.FromCloudFormation.getString(properties.CertificateArn) : void 0), ret.addPropertyResult("customDomainName", "CustomDomainName", properties.CustomDomainName != null ? cfn_parse.FromCloudFormation.getString(properties.CustomDomainName) : void 0), ret.addPropertyResult("dnsEntry", "DnsEntry", properties.DnsEntry != null ? CfnServiceDnsEntryPropertyFromCloudFormation(properties.DnsEntry) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnService = class _CfnService extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnServicePropsFromCloudFormation(resourceProperties), ret = new _CfnService(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnService.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_vpclattice_CfnServiceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnService), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreatedAt = cdk.Token.asString(this.getAtt("CreatedAt", cdk.ResolutionTypeHint.STRING)), this.attrDnsEntryDomainName = cdk.Token.asString(this.getAtt("DnsEntry.DomainName", cdk.ResolutionTypeHint.STRING)), this.attrDnsEntryHostedZoneId = cdk.Token.asString(this.getAtt("DnsEntry.HostedZoneId", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrLastUpdatedAt = cdk.Token.asString(this.getAtt("LastUpdatedAt", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.authType = props.authType, this.certificateArn = props.certificateArn, this.customDomainName = props.customDomainName, this.dnsEntry = props.dnsEntry, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::VpcLattice::Service", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnService.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { authType: this.authType, certificateArn: this.certificateArn, customDomainName: this.customDomainName, dnsEntry: this.dnsEntry, name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnServicePropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnService[_f] = { fqn: "aws-cdk-lib.aws_vpclattice.CfnService", version: "2.80.0" }, CfnService.CFN_RESOURCE_TYPE_NAME = "AWS::VpcLattice::Service", exports2.CfnService = CfnService;
    function CfnService_DnsEntryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.collect(cdk.propertyValidator("hostedZoneId", cdk.validateString)(properties.hostedZoneId)), errors.wrap('supplied properties not correct for "DnsEntryProperty"');
    }
    function cfnServiceDnsEntryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnService_DnsEntryPropertyValidator(properties).assertSuccess(), { DomainName: cdk.stringToCloudFormation(properties.domainName), HostedZoneId: cdk.stringToCloudFormation(properties.hostedZoneId) }) : properties;
    }
    function CfnServiceDnsEntryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("domainName", "DomainName", properties.DomainName != null ? cfn_parse.FromCloudFormation.getString(properties.DomainName) : void 0), ret.addPropertyResult("hostedZoneId", "HostedZoneId", properties.HostedZoneId != null ? cfn_parse.FromCloudFormation.getString(properties.HostedZoneId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnServiceNetworkPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("authType", cdk.validateString)(properties.authType)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnServiceNetworkProps"');
    }
    function cfnServiceNetworkPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnServiceNetworkPropsValidator(properties).assertSuccess(), { AuthType: cdk.stringToCloudFormation(properties.authType), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnServiceNetworkPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("authType", "AuthType", properties.AuthType != null ? cfn_parse.FromCloudFormation.getString(properties.AuthType) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnServiceNetwork = class _CfnServiceNetwork extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnServiceNetworkPropsFromCloudFormation(resourceProperties), ret = new _CfnServiceNetwork(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnServiceNetwork.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_vpclattice_CfnServiceNetworkProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnServiceNetwork), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreatedAt = cdk.Token.asString(this.getAtt("CreatedAt", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrLastUpdatedAt = cdk.Token.asString(this.getAtt("LastUpdatedAt", cdk.ResolutionTypeHint.STRING)), this.authType = props.authType, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::VpcLattice::ServiceNetwork", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnServiceNetwork.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { authType: this.authType, name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnServiceNetworkPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnServiceNetwork[_g] = { fqn: "aws-cdk-lib.aws_vpclattice.CfnServiceNetwork", version: "2.80.0" }, CfnServiceNetwork.CFN_RESOURCE_TYPE_NAME = "AWS::VpcLattice::ServiceNetwork", exports2.CfnServiceNetwork = CfnServiceNetwork;
    function CfnServiceNetworkServiceAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dnsEntry", CfnServiceNetworkServiceAssociation_DnsEntryPropertyValidator)(properties.dnsEntry)), errors.collect(cdk.propertyValidator("serviceIdentifier", cdk.validateString)(properties.serviceIdentifier)), errors.collect(cdk.propertyValidator("serviceNetworkIdentifier", cdk.validateString)(properties.serviceNetworkIdentifier)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnServiceNetworkServiceAssociationProps"');
    }
    function cfnServiceNetworkServiceAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnServiceNetworkServiceAssociationPropsValidator(properties).assertSuccess(), { DnsEntry: cfnServiceNetworkServiceAssociationDnsEntryPropertyToCloudFormation(properties.dnsEntry), ServiceIdentifier: cdk.stringToCloudFormation(properties.serviceIdentifier), ServiceNetworkIdentifier: cdk.stringToCloudFormation(properties.serviceNetworkIdentifier), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnServiceNetworkServiceAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dnsEntry", "DnsEntry", properties.DnsEntry != null ? CfnServiceNetworkServiceAssociationDnsEntryPropertyFromCloudFormation(properties.DnsEntry) : void 0), ret.addPropertyResult("serviceIdentifier", "ServiceIdentifier", properties.ServiceIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceIdentifier) : void 0), ret.addPropertyResult("serviceNetworkIdentifier", "ServiceNetworkIdentifier", properties.ServiceNetworkIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceNetworkIdentifier) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnServiceNetworkServiceAssociation = class _CfnServiceNetworkServiceAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnServiceNetworkServiceAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnServiceNetworkServiceAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnServiceNetworkServiceAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_vpclattice_CfnServiceNetworkServiceAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnServiceNetworkServiceAssociation), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreatedAt = cdk.Token.asString(this.getAtt("CreatedAt", cdk.ResolutionTypeHint.STRING)), this.attrDnsEntryDomainName = cdk.Token.asString(this.getAtt("DnsEntry.DomainName", cdk.ResolutionTypeHint.STRING)), this.attrDnsEntryHostedZoneId = cdk.Token.asString(this.getAtt("DnsEntry.HostedZoneId", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrServiceArn = cdk.Token.asString(this.getAtt("ServiceArn", cdk.ResolutionTypeHint.STRING)), this.attrServiceId = cdk.Token.asString(this.getAtt("ServiceId", cdk.ResolutionTypeHint.STRING)), this.attrServiceName = cdk.Token.asString(this.getAtt("ServiceName", cdk.ResolutionTypeHint.STRING)), this.attrServiceNetworkArn = cdk.Token.asString(this.getAtt("ServiceNetworkArn", cdk.ResolutionTypeHint.STRING)), this.attrServiceNetworkId = cdk.Token.asString(this.getAtt("ServiceNetworkId", cdk.ResolutionTypeHint.STRING)), this.attrServiceNetworkName = cdk.Token.asString(this.getAtt("ServiceNetworkName", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.dnsEntry = props.dnsEntry, this.serviceIdentifier = props.serviceIdentifier, this.serviceNetworkIdentifier = props.serviceNetworkIdentifier, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::VpcLattice::ServiceNetworkServiceAssociation", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnServiceNetworkServiceAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { dnsEntry: this.dnsEntry, serviceIdentifier: this.serviceIdentifier, serviceNetworkIdentifier: this.serviceNetworkIdentifier, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnServiceNetworkServiceAssociationPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnServiceNetworkServiceAssociation[_h] = { fqn: "aws-cdk-lib.aws_vpclattice.CfnServiceNetworkServiceAssociation", version: "2.80.0" }, CfnServiceNetworkServiceAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::VpcLattice::ServiceNetworkServiceAssociation", exports2.CfnServiceNetworkServiceAssociation = CfnServiceNetworkServiceAssociation;
    function CfnServiceNetworkServiceAssociation_DnsEntryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("domainName", cdk.validateString)(properties.domainName)), errors.collect(cdk.propertyValidator("hostedZoneId", cdk.validateString)(properties.hostedZoneId)), errors.wrap('supplied properties not correct for "DnsEntryProperty"');
    }
    function cfnServiceNetworkServiceAssociationDnsEntryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnServiceNetworkServiceAssociation_DnsEntryPropertyValidator(properties).assertSuccess(), { DomainName: cdk.stringToCloudFormation(properties.domainName), HostedZoneId: cdk.stringToCloudFormation(properties.hostedZoneId) }) : properties;
    }
    function CfnServiceNetworkServiceAssociationDnsEntryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("domainName", "DomainName", properties.DomainName != null ? cfn_parse.FromCloudFormation.getString(properties.DomainName) : void 0), ret.addPropertyResult("hostedZoneId", "HostedZoneId", properties.HostedZoneId != null ? cfn_parse.FromCloudFormation.getString(properties.HostedZoneId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnServiceNetworkVpcAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("securityGroupIds", cdk.listValidator(cdk.validateString))(properties.securityGroupIds)), errors.collect(cdk.propertyValidator("serviceNetworkIdentifier", cdk.validateString)(properties.serviceNetworkIdentifier)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("vpcIdentifier", cdk.validateString)(properties.vpcIdentifier)), errors.wrap('supplied properties not correct for "CfnServiceNetworkVpcAssociationProps"');
    }
    function cfnServiceNetworkVpcAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnServiceNetworkVpcAssociationPropsValidator(properties).assertSuccess(), { SecurityGroupIds: cdk.listMapper(cdk.stringToCloudFormation)(properties.securityGroupIds), ServiceNetworkIdentifier: cdk.stringToCloudFormation(properties.serviceNetworkIdentifier), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), VpcIdentifier: cdk.stringToCloudFormation(properties.vpcIdentifier) }) : properties;
    }
    function CfnServiceNetworkVpcAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("securityGroupIds", "SecurityGroupIds", properties.SecurityGroupIds != null ? cfn_parse.FromCloudFormation.getStringArray(properties.SecurityGroupIds) : void 0), ret.addPropertyResult("serviceNetworkIdentifier", "ServiceNetworkIdentifier", properties.ServiceNetworkIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceNetworkIdentifier) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("vpcIdentifier", "VpcIdentifier", properties.VpcIdentifier != null ? cfn_parse.FromCloudFormation.getString(properties.VpcIdentifier) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnServiceNetworkVpcAssociation = class _CfnServiceNetworkVpcAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnServiceNetworkVpcAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnServiceNetworkVpcAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnServiceNetworkVpcAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_vpclattice_CfnServiceNetworkVpcAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnServiceNetworkVpcAssociation), error;
        }
        this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreatedAt = cdk.Token.asString(this.getAtt("CreatedAt", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrServiceNetworkArn = cdk.Token.asString(this.getAtt("ServiceNetworkArn", cdk.ResolutionTypeHint.STRING)), this.attrServiceNetworkId = cdk.Token.asString(this.getAtt("ServiceNetworkId", cdk.ResolutionTypeHint.STRING)), this.attrServiceNetworkName = cdk.Token.asString(this.getAtt("ServiceNetworkName", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.attrVpcId = cdk.Token.asString(this.getAtt("VpcId", cdk.ResolutionTypeHint.STRING)), this.securityGroupIds = props.securityGroupIds, this.serviceNetworkIdentifier = props.serviceNetworkIdentifier, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::VpcLattice::ServiceNetworkVpcAssociation", props.tags, { tagPropertyName: "tags" }), this.vpcIdentifier = props.vpcIdentifier;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnServiceNetworkVpcAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { securityGroupIds: this.securityGroupIds, serviceNetworkIdentifier: this.serviceNetworkIdentifier, tags: this.tags.renderTags(), vpcIdentifier: this.vpcIdentifier };
      }
      renderProperties(props) {
        return cfnServiceNetworkVpcAssociationPropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnServiceNetworkVpcAssociation[_j] = { fqn: "aws-cdk-lib.aws_vpclattice.CfnServiceNetworkVpcAssociation", version: "2.80.0" }, CfnServiceNetworkVpcAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::VpcLattice::ServiceNetworkVpcAssociation", exports2.CfnServiceNetworkVpcAssociation = CfnServiceNetworkVpcAssociation;
    function CfnTargetGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("config", CfnTargetGroup_TargetGroupConfigPropertyValidator)(properties.config)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("targets", cdk.listValidator(CfnTargetGroup_TargetPropertyValidator))(properties.targets)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnTargetGroupProps"');
    }
    function cfnTargetGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTargetGroupPropsValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type), Config: cfnTargetGroupTargetGroupConfigPropertyToCloudFormation(properties.config), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), Targets: cdk.listMapper(cfnTargetGroupTargetPropertyToCloudFormation)(properties.targets) }) : properties;
    }
    function CfnTargetGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("config", "Config", properties.Config != null ? CfnTargetGroupTargetGroupConfigPropertyFromCloudFormation(properties.Config) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("targets", "Targets", properties.Targets != null ? cfn_parse.FromCloudFormation.getArray(CfnTargetGroupTargetPropertyFromCloudFormation)(properties.Targets) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnTargetGroup = class _CfnTargetGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnTargetGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnTargetGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnTargetGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_vpclattice_CfnTargetGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnTargetGroup), error;
        }
        cdk.requireProperty(props, "type", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCreatedAt = cdk.Token.asString(this.getAtt("CreatedAt", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrLastUpdatedAt = cdk.Token.asString(this.getAtt("LastUpdatedAt", cdk.ResolutionTypeHint.STRING)), this.attrStatus = cdk.Token.asString(this.getAtt("Status", cdk.ResolutionTypeHint.STRING)), this.type = props.type, this.config = props.config, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::VpcLattice::TargetGroup", props.tags, { tagPropertyName: "tags" }), this.targets = props.targets;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnTargetGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { type: this.type, config: this.config, name: this.name, tags: this.tags.renderTags(), targets: this.targets };
      }
      renderProperties(props) {
        return cfnTargetGroupPropsToCloudFormation(props);
      }
    };
    _k = JSII_RTTI_SYMBOL_1, CfnTargetGroup[_k] = { fqn: "aws-cdk-lib.aws_vpclattice.CfnTargetGroup", version: "2.80.0" }, CfnTargetGroup.CFN_RESOURCE_TYPE_NAME = "AWS::VpcLattice::TargetGroup", exports2.CfnTargetGroup = CfnTargetGroup;
    function CfnTargetGroup_HealthCheckConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("enabled", cdk.validateBoolean)(properties.enabled)), errors.collect(cdk.propertyValidator("healthCheckIntervalSeconds", cdk.validateNumber)(properties.healthCheckIntervalSeconds)), errors.collect(cdk.propertyValidator("healthCheckTimeoutSeconds", cdk.validateNumber)(properties.healthCheckTimeoutSeconds)), errors.collect(cdk.propertyValidator("healthyThresholdCount", cdk.validateNumber)(properties.healthyThresholdCount)), errors.collect(cdk.propertyValidator("matcher", CfnTargetGroup_MatcherPropertyValidator)(properties.matcher)), errors.collect(cdk.propertyValidator("path", cdk.validateString)(properties.path)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.collect(cdk.propertyValidator("protocolVersion", cdk.validateString)(properties.protocolVersion)), errors.collect(cdk.propertyValidator("unhealthyThresholdCount", cdk.validateNumber)(properties.unhealthyThresholdCount)), errors.wrap('supplied properties not correct for "HealthCheckConfigProperty"');
    }
    function cfnTargetGroupHealthCheckConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTargetGroup_HealthCheckConfigPropertyValidator(properties).assertSuccess(), { Enabled: cdk.booleanToCloudFormation(properties.enabled), HealthCheckIntervalSeconds: cdk.numberToCloudFormation(properties.healthCheckIntervalSeconds), HealthCheckTimeoutSeconds: cdk.numberToCloudFormation(properties.healthCheckTimeoutSeconds), HealthyThresholdCount: cdk.numberToCloudFormation(properties.healthyThresholdCount), Matcher: cfnTargetGroupMatcherPropertyToCloudFormation(properties.matcher), Path: cdk.stringToCloudFormation(properties.path), Port: cdk.numberToCloudFormation(properties.port), Protocol: cdk.stringToCloudFormation(properties.protocol), ProtocolVersion: cdk.stringToCloudFormation(properties.protocolVersion), UnhealthyThresholdCount: cdk.numberToCloudFormation(properties.unhealthyThresholdCount) }) : properties;
    }
    function CfnTargetGroupHealthCheckConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("enabled", "Enabled", properties.Enabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.Enabled) : void 0), ret.addPropertyResult("healthCheckIntervalSeconds", "HealthCheckIntervalSeconds", properties.HealthCheckIntervalSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.HealthCheckIntervalSeconds) : void 0), ret.addPropertyResult("healthCheckTimeoutSeconds", "HealthCheckTimeoutSeconds", properties.HealthCheckTimeoutSeconds != null ? cfn_parse.FromCloudFormation.getNumber(properties.HealthCheckTimeoutSeconds) : void 0), ret.addPropertyResult("healthyThresholdCount", "HealthyThresholdCount", properties.HealthyThresholdCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.HealthyThresholdCount) : void 0), ret.addPropertyResult("matcher", "Matcher", properties.Matcher != null ? CfnTargetGroupMatcherPropertyFromCloudFormation(properties.Matcher) : void 0), ret.addPropertyResult("path", "Path", properties.Path != null ? cfn_parse.FromCloudFormation.getString(properties.Path) : void 0), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addPropertyResult("protocol", "Protocol", properties.Protocol != null ? cfn_parse.FromCloudFormation.getString(properties.Protocol) : void 0), ret.addPropertyResult("protocolVersion", "ProtocolVersion", properties.ProtocolVersion != null ? cfn_parse.FromCloudFormation.getString(properties.ProtocolVersion) : void 0), ret.addPropertyResult("unhealthyThresholdCount", "UnhealthyThresholdCount", properties.UnhealthyThresholdCount != null ? cfn_parse.FromCloudFormation.getNumber(properties.UnhealthyThresholdCount) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTargetGroup_MatcherPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("httpCode", cdk.requiredValidator)(properties.httpCode)), errors.collect(cdk.propertyValidator("httpCode", cdk.validateString)(properties.httpCode)), errors.wrap('supplied properties not correct for "MatcherProperty"');
    }
    function cfnTargetGroupMatcherPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTargetGroup_MatcherPropertyValidator(properties).assertSuccess(), { HttpCode: cdk.stringToCloudFormation(properties.httpCode) }) : properties;
    }
    function CfnTargetGroupMatcherPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("httpCode", "HttpCode", cfn_parse.FromCloudFormation.getString(properties.HttpCode)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTargetGroup_TargetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("id", cdk.requiredValidator)(properties.id)), errors.collect(cdk.propertyValidator("id", cdk.validateString)(properties.id)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.wrap('supplied properties not correct for "TargetProperty"');
    }
    function cfnTargetGroupTargetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTargetGroup_TargetPropertyValidator(properties).assertSuccess(), { Id: cdk.stringToCloudFormation(properties.id), Port: cdk.numberToCloudFormation(properties.port) }) : properties;
    }
    function CfnTargetGroupTargetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("id", "Id", cfn_parse.FromCloudFormation.getString(properties.Id)), ret.addPropertyResult("port", "Port", properties.Port != null ? cfn_parse.FromCloudFormation.getNumber(properties.Port) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnTargetGroup_TargetGroupConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("healthCheck", CfnTargetGroup_HealthCheckConfigPropertyValidator)(properties.healthCheck)), errors.collect(cdk.propertyValidator("ipAddressType", cdk.validateString)(properties.ipAddressType)), errors.collect(cdk.propertyValidator("port", cdk.requiredValidator)(properties.port)), errors.collect(cdk.propertyValidator("port", cdk.validateNumber)(properties.port)), errors.collect(cdk.propertyValidator("protocol", cdk.requiredValidator)(properties.protocol)), errors.collect(cdk.propertyValidator("protocol", cdk.validateString)(properties.protocol)), errors.collect(cdk.propertyValidator("protocolVersion", cdk.validateString)(properties.protocolVersion)), errors.collect(cdk.propertyValidator("vpcIdentifier", cdk.requiredValidator)(properties.vpcIdentifier)), errors.collect(cdk.propertyValidator("vpcIdentifier", cdk.validateString)(properties.vpcIdentifier)), errors.wrap('supplied properties not correct for "TargetGroupConfigProperty"');
    }
    function cfnTargetGroupTargetGroupConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnTargetGroup_TargetGroupConfigPropertyValidator(properties).assertSuccess(), { HealthCheck: cfnTargetGroupHealthCheckConfigPropertyToCloudFormation(properties.healthCheck), IpAddressType: cdk.stringToCloudFormation(properties.ipAddressType), Port: cdk.numberToCloudFormation(properties.port), Protocol: cdk.stringToCloudFormation(properties.protocol), ProtocolVersion: cdk.stringToCloudFormation(properties.protocolVersion), VpcIdentifier: cdk.stringToCloudFormation(properties.vpcIdentifier) }) : properties;
    }
    function CfnTargetGroupTargetGroupConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("healthCheck", "HealthCheck", properties.HealthCheck != null ? CfnTargetGroupHealthCheckConfigPropertyFromCloudFormation(properties.HealthCheck) : void 0), ret.addPropertyResult("ipAddressType", "IpAddressType", properties.IpAddressType != null ? cfn_parse.FromCloudFormation.getString(properties.IpAddressType) : void 0), ret.addPropertyResult("port", "Port", cfn_parse.FromCloudFormation.getNumber(properties.Port)), ret.addPropertyResult("protocol", "Protocol", cfn_parse.FromCloudFormation.getString(properties.Protocol)), ret.addPropertyResult("protocolVersion", "ProtocolVersion", properties.ProtocolVersion != null ? cfn_parse.FromCloudFormation.getString(properties.ProtocolVersion) : void 0), ret.addPropertyResult("vpcIdentifier", "VpcIdentifier", cfn_parse.FromCloudFormation.getString(properties.VpcIdentifier)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-vpclattice/lib/index.js
var require_lib253 = __commonJS({
  "node_modules/aws-cdk-lib/aws-vpclattice/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_vpclattice_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-vpclattice/index.js
var require_aws_vpclattice = __commonJS({
  "node_modules/aws-cdk-lib/aws-vpclattice/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib253(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-waf/lib/waf.generated.js
var require_waf_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-waf/lib/waf.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnXssMatchSet = exports2.CfnWebACL = exports2.CfnSqlInjectionMatchSet = exports2.CfnSizeConstraintSet = exports2.CfnRule = exports2.CfnIPSet = exports2.CfnByteMatchSet = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnByteMatchSetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("byteMatchTuples", cdk.listValidator(CfnByteMatchSet_ByteMatchTuplePropertyValidator))(properties.byteMatchTuples)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "CfnByteMatchSetProps"');
    }
    function cfnByteMatchSetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnByteMatchSetPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), ByteMatchTuples: cdk.listMapper(cfnByteMatchSetByteMatchTuplePropertyToCloudFormation)(properties.byteMatchTuples) }) : properties;
    }
    function CfnByteMatchSetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("byteMatchTuples", "ByteMatchTuples", properties.ByteMatchTuples != null ? cfn_parse.FromCloudFormation.getArray(CfnByteMatchSetByteMatchTuplePropertyFromCloudFormation)(properties.ByteMatchTuples) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnByteMatchSet = class _CfnByteMatchSet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnByteMatchSetPropsFromCloudFormation(resourceProperties), ret = new _CfnByteMatchSet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnByteMatchSet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_waf_CfnByteMatchSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnByteMatchSet), error;
        }
        cdk.requireProperty(props, "name", this), this.name = props.name, this.byteMatchTuples = props.byteMatchTuples;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnByteMatchSet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, byteMatchTuples: this.byteMatchTuples };
      }
      renderProperties(props) {
        return cfnByteMatchSetPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnByteMatchSet[_a] = { fqn: "aws-cdk-lib.aws_waf.CfnByteMatchSet", version: "2.80.0" }, CfnByteMatchSet.CFN_RESOURCE_TYPE_NAME = "AWS::WAF::ByteMatchSet", exports2.CfnByteMatchSet = CfnByteMatchSet;
    function CfnByteMatchSet_ByteMatchTuplePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldToMatch", cdk.requiredValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("fieldToMatch", CfnByteMatchSet_FieldToMatchPropertyValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("positionalConstraint", cdk.requiredValidator)(properties.positionalConstraint)), errors.collect(cdk.propertyValidator("positionalConstraint", cdk.validateString)(properties.positionalConstraint)), errors.collect(cdk.propertyValidator("targetString", cdk.validateString)(properties.targetString)), errors.collect(cdk.propertyValidator("targetStringBase64", cdk.validateString)(properties.targetStringBase64)), errors.collect(cdk.propertyValidator("textTransformation", cdk.requiredValidator)(properties.textTransformation)), errors.collect(cdk.propertyValidator("textTransformation", cdk.validateString)(properties.textTransformation)), errors.wrap('supplied properties not correct for "ByteMatchTupleProperty"');
    }
    function cfnByteMatchSetByteMatchTuplePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnByteMatchSet_ByteMatchTuplePropertyValidator(properties).assertSuccess(), { FieldToMatch: cfnByteMatchSetFieldToMatchPropertyToCloudFormation(properties.fieldToMatch), PositionalConstraint: cdk.stringToCloudFormation(properties.positionalConstraint), TargetString: cdk.stringToCloudFormation(properties.targetString), TargetStringBase64: cdk.stringToCloudFormation(properties.targetStringBase64), TextTransformation: cdk.stringToCloudFormation(properties.textTransformation) }) : properties;
    }
    function CfnByteMatchSetByteMatchTuplePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldToMatch", "FieldToMatch", CfnByteMatchSetFieldToMatchPropertyFromCloudFormation(properties.FieldToMatch)), ret.addPropertyResult("positionalConstraint", "PositionalConstraint", cfn_parse.FromCloudFormation.getString(properties.PositionalConstraint)), ret.addPropertyResult("targetString", "TargetString", properties.TargetString != null ? cfn_parse.FromCloudFormation.getString(properties.TargetString) : void 0), ret.addPropertyResult("targetStringBase64", "TargetStringBase64", properties.TargetStringBase64 != null ? cfn_parse.FromCloudFormation.getString(properties.TargetStringBase64) : void 0), ret.addPropertyResult("textTransformation", "TextTransformation", cfn_parse.FromCloudFormation.getString(properties.TextTransformation)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnByteMatchSet_FieldToMatchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("data", cdk.validateString)(properties.data)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "FieldToMatchProperty"');
    }
    function cfnByteMatchSetFieldToMatchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnByteMatchSet_FieldToMatchPropertyValidator(properties).assertSuccess(), { Data: cdk.stringToCloudFormation(properties.data), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnByteMatchSetFieldToMatchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("data", "Data", properties.Data != null ? cfn_parse.FromCloudFormation.getString(properties.Data) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIPSetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ipSetDescriptors", cdk.listValidator(CfnIPSet_IPSetDescriptorPropertyValidator))(properties.ipSetDescriptors)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "CfnIPSetProps"');
    }
    function cfnIPSetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIPSetPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), IPSetDescriptors: cdk.listMapper(cfnIPSetIPSetDescriptorPropertyToCloudFormation)(properties.ipSetDescriptors) }) : properties;
    }
    function CfnIPSetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("ipSetDescriptors", "IPSetDescriptors", properties.IPSetDescriptors != null ? cfn_parse.FromCloudFormation.getArray(CfnIPSetIPSetDescriptorPropertyFromCloudFormation)(properties.IPSetDescriptors) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnIPSet = class _CfnIPSet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnIPSetPropsFromCloudFormation(resourceProperties), ret = new _CfnIPSet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnIPSet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_waf_CfnIPSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnIPSet), error;
        }
        cdk.requireProperty(props, "name", this), this.name = props.name, this.ipSetDescriptors = props.ipSetDescriptors;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnIPSet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, ipSetDescriptors: this.ipSetDescriptors };
      }
      renderProperties(props) {
        return cfnIPSetPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnIPSet[_b] = { fqn: "aws-cdk-lib.aws_waf.CfnIPSet", version: "2.80.0" }, CfnIPSet.CFN_RESOURCE_TYPE_NAME = "AWS::WAF::IPSet", exports2.CfnIPSet = CfnIPSet;
    function CfnIPSet_IPSetDescriptorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "IPSetDescriptorProperty"');
    }
    function cfnIPSetIPSetDescriptorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIPSet_IPSetDescriptorPropertyValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnIPSetIPSetDescriptorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRulePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("metricName", cdk.requiredValidator)(properties.metricName)), errors.collect(cdk.propertyValidator("metricName", cdk.validateString)(properties.metricName)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("predicates", cdk.listValidator(CfnRule_PredicatePropertyValidator))(properties.predicates)), errors.wrap('supplied properties not correct for "CfnRuleProps"');
    }
    function cfnRulePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRulePropsValidator(properties).assertSuccess(), { MetricName: cdk.stringToCloudFormation(properties.metricName), Name: cdk.stringToCloudFormation(properties.name), Predicates: cdk.listMapper(cfnRulePredicatePropertyToCloudFormation)(properties.predicates) }) : properties;
    }
    function CfnRulePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("metricName", "MetricName", cfn_parse.FromCloudFormation.getString(properties.MetricName)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("predicates", "Predicates", properties.Predicates != null ? cfn_parse.FromCloudFormation.getArray(CfnRulePredicatePropertyFromCloudFormation)(properties.Predicates) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRule = class _CfnRule extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRulePropsFromCloudFormation(resourceProperties), ret = new _CfnRule(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRule.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_waf_CfnRuleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRule), error;
        }
        cdk.requireProperty(props, "metricName", this), cdk.requireProperty(props, "name", this), this.metricName = props.metricName, this.name = props.name, this.predicates = props.predicates;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRule.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { metricName: this.metricName, name: this.name, predicates: this.predicates };
      }
      renderProperties(props) {
        return cfnRulePropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnRule[_c] = { fqn: "aws-cdk-lib.aws_waf.CfnRule", version: "2.80.0" }, CfnRule.CFN_RESOURCE_TYPE_NAME = "AWS::WAF::Rule", exports2.CfnRule = CfnRule;
    function CfnRule_PredicatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataId", cdk.requiredValidator)(properties.dataId)), errors.collect(cdk.propertyValidator("dataId", cdk.validateString)(properties.dataId)), errors.collect(cdk.propertyValidator("negated", cdk.requiredValidator)(properties.negated)), errors.collect(cdk.propertyValidator("negated", cdk.validateBoolean)(properties.negated)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "PredicateProperty"');
    }
    function cfnRulePredicatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_PredicatePropertyValidator(properties).assertSuccess(), { DataId: cdk.stringToCloudFormation(properties.dataId), Negated: cdk.booleanToCloudFormation(properties.negated), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnRulePredicatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataId", "DataId", cfn_parse.FromCloudFormation.getString(properties.DataId)), ret.addPropertyResult("negated", "Negated", cfn_parse.FromCloudFormation.getBoolean(properties.Negated)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSizeConstraintSetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("sizeConstraints", cdk.requiredValidator)(properties.sizeConstraints)), errors.collect(cdk.propertyValidator("sizeConstraints", cdk.listValidator(CfnSizeConstraintSet_SizeConstraintPropertyValidator))(properties.sizeConstraints)), errors.wrap('supplied properties not correct for "CfnSizeConstraintSetProps"');
    }
    function cfnSizeConstraintSetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSizeConstraintSetPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), SizeConstraints: cdk.listMapper(cfnSizeConstraintSetSizeConstraintPropertyToCloudFormation)(properties.sizeConstraints) }) : properties;
    }
    function CfnSizeConstraintSetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("sizeConstraints", "SizeConstraints", cfn_parse.FromCloudFormation.getArray(CfnSizeConstraintSetSizeConstraintPropertyFromCloudFormation)(properties.SizeConstraints)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSizeConstraintSet = class _CfnSizeConstraintSet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSizeConstraintSetPropsFromCloudFormation(resourceProperties), ret = new _CfnSizeConstraintSet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSizeConstraintSet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_waf_CfnSizeConstraintSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSizeConstraintSet), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "sizeConstraints", this), this.name = props.name, this.sizeConstraints = props.sizeConstraints;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSizeConstraintSet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, sizeConstraints: this.sizeConstraints };
      }
      renderProperties(props) {
        return cfnSizeConstraintSetPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnSizeConstraintSet[_d] = { fqn: "aws-cdk-lib.aws_waf.CfnSizeConstraintSet", version: "2.80.0" }, CfnSizeConstraintSet.CFN_RESOURCE_TYPE_NAME = "AWS::WAF::SizeConstraintSet", exports2.CfnSizeConstraintSet = CfnSizeConstraintSet;
    function CfnSizeConstraintSet_FieldToMatchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("data", cdk.validateString)(properties.data)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "FieldToMatchProperty"');
    }
    function cfnSizeConstraintSetFieldToMatchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSizeConstraintSet_FieldToMatchPropertyValidator(properties).assertSuccess(), { Data: cdk.stringToCloudFormation(properties.data), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnSizeConstraintSetFieldToMatchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("data", "Data", properties.Data != null ? cfn_parse.FromCloudFormation.getString(properties.Data) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSizeConstraintSet_SizeConstraintPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("comparisonOperator", cdk.requiredValidator)(properties.comparisonOperator)), errors.collect(cdk.propertyValidator("comparisonOperator", cdk.validateString)(properties.comparisonOperator)), errors.collect(cdk.propertyValidator("fieldToMatch", cdk.requiredValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("fieldToMatch", CfnSizeConstraintSet_FieldToMatchPropertyValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("size", cdk.requiredValidator)(properties.size)), errors.collect(cdk.propertyValidator("size", cdk.validateNumber)(properties.size)), errors.collect(cdk.propertyValidator("textTransformation", cdk.requiredValidator)(properties.textTransformation)), errors.collect(cdk.propertyValidator("textTransformation", cdk.validateString)(properties.textTransformation)), errors.wrap('supplied properties not correct for "SizeConstraintProperty"');
    }
    function cfnSizeConstraintSetSizeConstraintPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSizeConstraintSet_SizeConstraintPropertyValidator(properties).assertSuccess(), { ComparisonOperator: cdk.stringToCloudFormation(properties.comparisonOperator), FieldToMatch: cfnSizeConstraintSetFieldToMatchPropertyToCloudFormation(properties.fieldToMatch), Size: cdk.numberToCloudFormation(properties.size), TextTransformation: cdk.stringToCloudFormation(properties.textTransformation) }) : properties;
    }
    function CfnSizeConstraintSetSizeConstraintPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("comparisonOperator", "ComparisonOperator", cfn_parse.FromCloudFormation.getString(properties.ComparisonOperator)), ret.addPropertyResult("fieldToMatch", "FieldToMatch", CfnSizeConstraintSetFieldToMatchPropertyFromCloudFormation(properties.FieldToMatch)), ret.addPropertyResult("size", "Size", cfn_parse.FromCloudFormation.getNumber(properties.Size)), ret.addPropertyResult("textTransformation", "TextTransformation", cfn_parse.FromCloudFormation.getString(properties.TextTransformation)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSqlInjectionMatchSetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("sqlInjectionMatchTuples", cdk.listValidator(CfnSqlInjectionMatchSet_SqlInjectionMatchTuplePropertyValidator))(properties.sqlInjectionMatchTuples)), errors.wrap('supplied properties not correct for "CfnSqlInjectionMatchSetProps"');
    }
    function cfnSqlInjectionMatchSetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSqlInjectionMatchSetPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), SqlInjectionMatchTuples: cdk.listMapper(cfnSqlInjectionMatchSetSqlInjectionMatchTuplePropertyToCloudFormation)(properties.sqlInjectionMatchTuples) }) : properties;
    }
    function CfnSqlInjectionMatchSetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("sqlInjectionMatchTuples", "SqlInjectionMatchTuples", properties.SqlInjectionMatchTuples != null ? cfn_parse.FromCloudFormation.getArray(CfnSqlInjectionMatchSetSqlInjectionMatchTuplePropertyFromCloudFormation)(properties.SqlInjectionMatchTuples) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSqlInjectionMatchSet = class _CfnSqlInjectionMatchSet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSqlInjectionMatchSetPropsFromCloudFormation(resourceProperties), ret = new _CfnSqlInjectionMatchSet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSqlInjectionMatchSet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_waf_CfnSqlInjectionMatchSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSqlInjectionMatchSet), error;
        }
        cdk.requireProperty(props, "name", this), this.name = props.name, this.sqlInjectionMatchTuples = props.sqlInjectionMatchTuples;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSqlInjectionMatchSet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, sqlInjectionMatchTuples: this.sqlInjectionMatchTuples };
      }
      renderProperties(props) {
        return cfnSqlInjectionMatchSetPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnSqlInjectionMatchSet[_e] = { fqn: "aws-cdk-lib.aws_waf.CfnSqlInjectionMatchSet", version: "2.80.0" }, CfnSqlInjectionMatchSet.CFN_RESOURCE_TYPE_NAME = "AWS::WAF::SqlInjectionMatchSet", exports2.CfnSqlInjectionMatchSet = CfnSqlInjectionMatchSet;
    function CfnSqlInjectionMatchSet_FieldToMatchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("data", cdk.validateString)(properties.data)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "FieldToMatchProperty"');
    }
    function cfnSqlInjectionMatchSetFieldToMatchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSqlInjectionMatchSet_FieldToMatchPropertyValidator(properties).assertSuccess(), { Data: cdk.stringToCloudFormation(properties.data), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnSqlInjectionMatchSetFieldToMatchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("data", "Data", properties.Data != null ? cfn_parse.FromCloudFormation.getString(properties.Data) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSqlInjectionMatchSet_SqlInjectionMatchTuplePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldToMatch", cdk.requiredValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("fieldToMatch", CfnSqlInjectionMatchSet_FieldToMatchPropertyValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("textTransformation", cdk.requiredValidator)(properties.textTransformation)), errors.collect(cdk.propertyValidator("textTransformation", cdk.validateString)(properties.textTransformation)), errors.wrap('supplied properties not correct for "SqlInjectionMatchTupleProperty"');
    }
    function cfnSqlInjectionMatchSetSqlInjectionMatchTuplePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSqlInjectionMatchSet_SqlInjectionMatchTuplePropertyValidator(properties).assertSuccess(), { FieldToMatch: cfnSqlInjectionMatchSetFieldToMatchPropertyToCloudFormation(properties.fieldToMatch), TextTransformation: cdk.stringToCloudFormation(properties.textTransformation) }) : properties;
    }
    function CfnSqlInjectionMatchSetSqlInjectionMatchTuplePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldToMatch", "FieldToMatch", CfnSqlInjectionMatchSetFieldToMatchPropertyFromCloudFormation(properties.FieldToMatch)), ret.addPropertyResult("textTransformation", "TextTransformation", cfn_parse.FromCloudFormation.getString(properties.TextTransformation)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACLPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultAction", cdk.requiredValidator)(properties.defaultAction)), errors.collect(cdk.propertyValidator("defaultAction", CfnWebACL_WafActionPropertyValidator)(properties.defaultAction)), errors.collect(cdk.propertyValidator("metricName", cdk.requiredValidator)(properties.metricName)), errors.collect(cdk.propertyValidator("metricName", cdk.validateString)(properties.metricName)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("rules", cdk.listValidator(CfnWebACL_ActivatedRulePropertyValidator))(properties.rules)), errors.wrap('supplied properties not correct for "CfnWebACLProps"');
    }
    function cfnWebACLPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACLPropsValidator(properties).assertSuccess(), { DefaultAction: cfnWebACLWafActionPropertyToCloudFormation(properties.defaultAction), MetricName: cdk.stringToCloudFormation(properties.metricName), Name: cdk.stringToCloudFormation(properties.name), Rules: cdk.listMapper(cfnWebACLActivatedRulePropertyToCloudFormation)(properties.rules) }) : properties;
    }
    function CfnWebACLPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultAction", "DefaultAction", CfnWebACLWafActionPropertyFromCloudFormation(properties.DefaultAction)), ret.addPropertyResult("metricName", "MetricName", cfn_parse.FromCloudFormation.getString(properties.MetricName)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("rules", "Rules", properties.Rules != null ? cfn_parse.FromCloudFormation.getArray(CfnWebACLActivatedRulePropertyFromCloudFormation)(properties.Rules) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnWebACL = class _CfnWebACL extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnWebACLPropsFromCloudFormation(resourceProperties), ret = new _CfnWebACL(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnWebACL.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_waf_CfnWebACLProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnWebACL), error;
        }
        cdk.requireProperty(props, "defaultAction", this), cdk.requireProperty(props, "metricName", this), cdk.requireProperty(props, "name", this), this.defaultAction = props.defaultAction, this.metricName = props.metricName, this.name = props.name, this.rules = props.rules;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnWebACL.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { defaultAction: this.defaultAction, metricName: this.metricName, name: this.name, rules: this.rules };
      }
      renderProperties(props) {
        return cfnWebACLPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnWebACL[_f] = { fqn: "aws-cdk-lib.aws_waf.CfnWebACL", version: "2.80.0" }, CfnWebACL.CFN_RESOURCE_TYPE_NAME = "AWS::WAF::WebACL", exports2.CfnWebACL = CfnWebACL;
    function CfnWebACL_ActivatedRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", CfnWebACL_WafActionPropertyValidator)(properties.action)), errors.collect(cdk.propertyValidator("priority", cdk.requiredValidator)(properties.priority)), errors.collect(cdk.propertyValidator("priority", cdk.validateNumber)(properties.priority)), errors.collect(cdk.propertyValidator("ruleId", cdk.requiredValidator)(properties.ruleId)), errors.collect(cdk.propertyValidator("ruleId", cdk.validateString)(properties.ruleId)), errors.wrap('supplied properties not correct for "ActivatedRuleProperty"');
    }
    function cfnWebACLActivatedRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_ActivatedRulePropertyValidator(properties).assertSuccess(), { Action: cfnWebACLWafActionPropertyToCloudFormation(properties.action), Priority: cdk.numberToCloudFormation(properties.priority), RuleId: cdk.stringToCloudFormation(properties.ruleId) }) : properties;
    }
    function CfnWebACLActivatedRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", properties.Action != null ? CfnWebACLWafActionPropertyFromCloudFormation(properties.Action) : void 0), ret.addPropertyResult("priority", "Priority", cfn_parse.FromCloudFormation.getNumber(properties.Priority)), ret.addPropertyResult("ruleId", "RuleId", cfn_parse.FromCloudFormation.getString(properties.RuleId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_WafActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "WafActionProperty"');
    }
    function cfnWebACLWafActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_WafActionPropertyValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnWebACLWafActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnXssMatchSetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("xssMatchTuples", cdk.requiredValidator)(properties.xssMatchTuples)), errors.collect(cdk.propertyValidator("xssMatchTuples", cdk.listValidator(CfnXssMatchSet_XssMatchTuplePropertyValidator))(properties.xssMatchTuples)), errors.wrap('supplied properties not correct for "CfnXssMatchSetProps"');
    }
    function cfnXssMatchSetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnXssMatchSetPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), XssMatchTuples: cdk.listMapper(cfnXssMatchSetXssMatchTuplePropertyToCloudFormation)(properties.xssMatchTuples) }) : properties;
    }
    function CfnXssMatchSetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("xssMatchTuples", "XssMatchTuples", cfn_parse.FromCloudFormation.getArray(CfnXssMatchSetXssMatchTuplePropertyFromCloudFormation)(properties.XssMatchTuples)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnXssMatchSet = class _CfnXssMatchSet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnXssMatchSetPropsFromCloudFormation(resourceProperties), ret = new _CfnXssMatchSet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnXssMatchSet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_waf_CfnXssMatchSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnXssMatchSet), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "xssMatchTuples", this), this.name = props.name, this.xssMatchTuples = props.xssMatchTuples;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnXssMatchSet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, xssMatchTuples: this.xssMatchTuples };
      }
      renderProperties(props) {
        return cfnXssMatchSetPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnXssMatchSet[_g] = { fqn: "aws-cdk-lib.aws_waf.CfnXssMatchSet", version: "2.80.0" }, CfnXssMatchSet.CFN_RESOURCE_TYPE_NAME = "AWS::WAF::XssMatchSet", exports2.CfnXssMatchSet = CfnXssMatchSet;
    function CfnXssMatchSet_FieldToMatchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("data", cdk.validateString)(properties.data)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "FieldToMatchProperty"');
    }
    function cfnXssMatchSetFieldToMatchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnXssMatchSet_FieldToMatchPropertyValidator(properties).assertSuccess(), { Data: cdk.stringToCloudFormation(properties.data), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnXssMatchSetFieldToMatchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("data", "Data", properties.Data != null ? cfn_parse.FromCloudFormation.getString(properties.Data) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnXssMatchSet_XssMatchTuplePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldToMatch", cdk.requiredValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("fieldToMatch", CfnXssMatchSet_FieldToMatchPropertyValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("textTransformation", cdk.requiredValidator)(properties.textTransformation)), errors.collect(cdk.propertyValidator("textTransformation", cdk.validateString)(properties.textTransformation)), errors.wrap('supplied properties not correct for "XssMatchTupleProperty"');
    }
    function cfnXssMatchSetXssMatchTuplePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnXssMatchSet_XssMatchTuplePropertyValidator(properties).assertSuccess(), { FieldToMatch: cfnXssMatchSetFieldToMatchPropertyToCloudFormation(properties.fieldToMatch), TextTransformation: cdk.stringToCloudFormation(properties.textTransformation) }) : properties;
    }
    function CfnXssMatchSetXssMatchTuplePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldToMatch", "FieldToMatch", CfnXssMatchSetFieldToMatchPropertyFromCloudFormation(properties.FieldToMatch)), ret.addPropertyResult("textTransformation", "TextTransformation", cfn_parse.FromCloudFormation.getString(properties.TextTransformation)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-waf/lib/index.js
var require_lib254 = __commonJS({
  "node_modules/aws-cdk-lib/aws-waf/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_waf_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-waf/index.js
var require_aws_waf = __commonJS({
  "node_modules/aws-cdk-lib/aws-waf/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib254(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-wafregional/lib/wafregional.generated.js
var require_wafregional_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-wafregional/lib/wafregional.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    var _g;
    var _h;
    var _j;
    var _k;
    var _l;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnXssMatchSet = exports2.CfnWebACLAssociation = exports2.CfnWebACL = exports2.CfnSqlInjectionMatchSet = exports2.CfnSizeConstraintSet = exports2.CfnRule = exports2.CfnRegexPatternSet = exports2.CfnRateBasedRule = exports2.CfnIPSet = exports2.CfnGeoMatchSet = exports2.CfnByteMatchSet = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnByteMatchSetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("byteMatchTuples", cdk.listValidator(CfnByteMatchSet_ByteMatchTuplePropertyValidator))(properties.byteMatchTuples)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "CfnByteMatchSetProps"');
    }
    function cfnByteMatchSetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnByteMatchSetPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), ByteMatchTuples: cdk.listMapper(cfnByteMatchSetByteMatchTuplePropertyToCloudFormation)(properties.byteMatchTuples) }) : properties;
    }
    function CfnByteMatchSetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("byteMatchTuples", "ByteMatchTuples", properties.ByteMatchTuples != null ? cfn_parse.FromCloudFormation.getArray(CfnByteMatchSetByteMatchTuplePropertyFromCloudFormation)(properties.ByteMatchTuples) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnByteMatchSet = class _CfnByteMatchSet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnByteMatchSetPropsFromCloudFormation(resourceProperties), ret = new _CfnByteMatchSet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnByteMatchSet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_wafregional_CfnByteMatchSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnByteMatchSet), error;
        }
        cdk.requireProperty(props, "name", this), this.name = props.name, this.byteMatchTuples = props.byteMatchTuples;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnByteMatchSet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, byteMatchTuples: this.byteMatchTuples };
      }
      renderProperties(props) {
        return cfnByteMatchSetPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnByteMatchSet[_a] = { fqn: "aws-cdk-lib.aws_wafregional.CfnByteMatchSet", version: "2.80.0" }, CfnByteMatchSet.CFN_RESOURCE_TYPE_NAME = "AWS::WAFRegional::ByteMatchSet", exports2.CfnByteMatchSet = CfnByteMatchSet;
    function CfnByteMatchSet_ByteMatchTuplePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldToMatch", cdk.requiredValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("fieldToMatch", CfnByteMatchSet_FieldToMatchPropertyValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("positionalConstraint", cdk.requiredValidator)(properties.positionalConstraint)), errors.collect(cdk.propertyValidator("positionalConstraint", cdk.validateString)(properties.positionalConstraint)), errors.collect(cdk.propertyValidator("targetString", cdk.validateString)(properties.targetString)), errors.collect(cdk.propertyValidator("targetStringBase64", cdk.validateString)(properties.targetStringBase64)), errors.collect(cdk.propertyValidator("textTransformation", cdk.requiredValidator)(properties.textTransformation)), errors.collect(cdk.propertyValidator("textTransformation", cdk.validateString)(properties.textTransformation)), errors.wrap('supplied properties not correct for "ByteMatchTupleProperty"');
    }
    function cfnByteMatchSetByteMatchTuplePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnByteMatchSet_ByteMatchTuplePropertyValidator(properties).assertSuccess(), { FieldToMatch: cfnByteMatchSetFieldToMatchPropertyToCloudFormation(properties.fieldToMatch), PositionalConstraint: cdk.stringToCloudFormation(properties.positionalConstraint), TargetString: cdk.stringToCloudFormation(properties.targetString), TargetStringBase64: cdk.stringToCloudFormation(properties.targetStringBase64), TextTransformation: cdk.stringToCloudFormation(properties.textTransformation) }) : properties;
    }
    function CfnByteMatchSetByteMatchTuplePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldToMatch", "FieldToMatch", CfnByteMatchSetFieldToMatchPropertyFromCloudFormation(properties.FieldToMatch)), ret.addPropertyResult("positionalConstraint", "PositionalConstraint", cfn_parse.FromCloudFormation.getString(properties.PositionalConstraint)), ret.addPropertyResult("targetString", "TargetString", properties.TargetString != null ? cfn_parse.FromCloudFormation.getString(properties.TargetString) : void 0), ret.addPropertyResult("targetStringBase64", "TargetStringBase64", properties.TargetStringBase64 != null ? cfn_parse.FromCloudFormation.getString(properties.TargetStringBase64) : void 0), ret.addPropertyResult("textTransformation", "TextTransformation", cfn_parse.FromCloudFormation.getString(properties.TextTransformation)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnByteMatchSet_FieldToMatchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("data", cdk.validateString)(properties.data)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "FieldToMatchProperty"');
    }
    function cfnByteMatchSetFieldToMatchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnByteMatchSet_FieldToMatchPropertyValidator(properties).assertSuccess(), { Data: cdk.stringToCloudFormation(properties.data), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnByteMatchSetFieldToMatchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("data", "Data", properties.Data != null ? cfn_parse.FromCloudFormation.getString(properties.Data) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnGeoMatchSetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("geoMatchConstraints", cdk.listValidator(CfnGeoMatchSet_GeoMatchConstraintPropertyValidator))(properties.geoMatchConstraints)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "CfnGeoMatchSetProps"');
    }
    function cfnGeoMatchSetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGeoMatchSetPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), GeoMatchConstraints: cdk.listMapper(cfnGeoMatchSetGeoMatchConstraintPropertyToCloudFormation)(properties.geoMatchConstraints) }) : properties;
    }
    function CfnGeoMatchSetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("geoMatchConstraints", "GeoMatchConstraints", properties.GeoMatchConstraints != null ? cfn_parse.FromCloudFormation.getArray(CfnGeoMatchSetGeoMatchConstraintPropertyFromCloudFormation)(properties.GeoMatchConstraints) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnGeoMatchSet = class _CfnGeoMatchSet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnGeoMatchSetPropsFromCloudFormation(resourceProperties), ret = new _CfnGeoMatchSet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnGeoMatchSet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_wafregional_CfnGeoMatchSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnGeoMatchSet), error;
        }
        cdk.requireProperty(props, "name", this), this.name = props.name, this.geoMatchConstraints = props.geoMatchConstraints;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnGeoMatchSet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, geoMatchConstraints: this.geoMatchConstraints };
      }
      renderProperties(props) {
        return cfnGeoMatchSetPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnGeoMatchSet[_b] = { fqn: "aws-cdk-lib.aws_wafregional.CfnGeoMatchSet", version: "2.80.0" }, CfnGeoMatchSet.CFN_RESOURCE_TYPE_NAME = "AWS::WAFRegional::GeoMatchSet", exports2.CfnGeoMatchSet = CfnGeoMatchSet;
    function CfnGeoMatchSet_GeoMatchConstraintPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "GeoMatchConstraintProperty"');
    }
    function cfnGeoMatchSetGeoMatchConstraintPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGeoMatchSet_GeoMatchConstraintPropertyValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnGeoMatchSetGeoMatchConstraintPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnIPSetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ipSetDescriptors", cdk.listValidator(CfnIPSet_IPSetDescriptorPropertyValidator))(properties.ipSetDescriptors)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "CfnIPSetProps"');
    }
    function cfnIPSetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIPSetPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), IPSetDescriptors: cdk.listMapper(cfnIPSetIPSetDescriptorPropertyToCloudFormation)(properties.ipSetDescriptors) }) : properties;
    }
    function CfnIPSetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("ipSetDescriptors", "IPSetDescriptors", properties.IPSetDescriptors != null ? cfn_parse.FromCloudFormation.getArray(CfnIPSetIPSetDescriptorPropertyFromCloudFormation)(properties.IPSetDescriptors) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnIPSet = class _CfnIPSet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnIPSetPropsFromCloudFormation(resourceProperties), ret = new _CfnIPSet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnIPSet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_wafregional_CfnIPSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnIPSet), error;
        }
        cdk.requireProperty(props, "name", this), this.name = props.name, this.ipSetDescriptors = props.ipSetDescriptors;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnIPSet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, ipSetDescriptors: this.ipSetDescriptors };
      }
      renderProperties(props) {
        return cfnIPSetPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnIPSet[_c] = { fqn: "aws-cdk-lib.aws_wafregional.CfnIPSet", version: "2.80.0" }, CfnIPSet.CFN_RESOURCE_TYPE_NAME = "AWS::WAFRegional::IPSet", exports2.CfnIPSet = CfnIPSet;
    function CfnIPSet_IPSetDescriptorPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "IPSetDescriptorProperty"');
    }
    function cfnIPSetIPSetDescriptorPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIPSet_IPSetDescriptorPropertyValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnIPSetIPSetDescriptorPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRateBasedRulePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("matchPredicates", cdk.listValidator(CfnRateBasedRule_PredicatePropertyValidator))(properties.matchPredicates)), errors.collect(cdk.propertyValidator("metricName", cdk.requiredValidator)(properties.metricName)), errors.collect(cdk.propertyValidator("metricName", cdk.validateString)(properties.metricName)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("rateKey", cdk.requiredValidator)(properties.rateKey)), errors.collect(cdk.propertyValidator("rateKey", cdk.validateString)(properties.rateKey)), errors.collect(cdk.propertyValidator("rateLimit", cdk.requiredValidator)(properties.rateLimit)), errors.collect(cdk.propertyValidator("rateLimit", cdk.validateNumber)(properties.rateLimit)), errors.wrap('supplied properties not correct for "CfnRateBasedRuleProps"');
    }
    function cfnRateBasedRulePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRateBasedRulePropsValidator(properties).assertSuccess(), { MetricName: cdk.stringToCloudFormation(properties.metricName), Name: cdk.stringToCloudFormation(properties.name), RateKey: cdk.stringToCloudFormation(properties.rateKey), RateLimit: cdk.numberToCloudFormation(properties.rateLimit), MatchPredicates: cdk.listMapper(cfnRateBasedRulePredicatePropertyToCloudFormation)(properties.matchPredicates) }) : properties;
    }
    function CfnRateBasedRulePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("metricName", "MetricName", cfn_parse.FromCloudFormation.getString(properties.MetricName)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("rateKey", "RateKey", cfn_parse.FromCloudFormation.getString(properties.RateKey)), ret.addPropertyResult("rateLimit", "RateLimit", cfn_parse.FromCloudFormation.getNumber(properties.RateLimit)), ret.addPropertyResult("matchPredicates", "MatchPredicates", properties.MatchPredicates != null ? cfn_parse.FromCloudFormation.getArray(CfnRateBasedRulePredicatePropertyFromCloudFormation)(properties.MatchPredicates) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRateBasedRule = class _CfnRateBasedRule extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRateBasedRulePropsFromCloudFormation(resourceProperties), ret = new _CfnRateBasedRule(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRateBasedRule.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_wafregional_CfnRateBasedRuleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRateBasedRule), error;
        }
        cdk.requireProperty(props, "metricName", this), cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "rateKey", this), cdk.requireProperty(props, "rateLimit", this), this.metricName = props.metricName, this.name = props.name, this.rateKey = props.rateKey, this.rateLimit = props.rateLimit, this.matchPredicates = props.matchPredicates;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRateBasedRule.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { metricName: this.metricName, name: this.name, rateKey: this.rateKey, rateLimit: this.rateLimit, matchPredicates: this.matchPredicates };
      }
      renderProperties(props) {
        return cfnRateBasedRulePropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnRateBasedRule[_d] = { fqn: "aws-cdk-lib.aws_wafregional.CfnRateBasedRule", version: "2.80.0" }, CfnRateBasedRule.CFN_RESOURCE_TYPE_NAME = "AWS::WAFRegional::RateBasedRule", exports2.CfnRateBasedRule = CfnRateBasedRule;
    function CfnRateBasedRule_PredicatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataId", cdk.requiredValidator)(properties.dataId)), errors.collect(cdk.propertyValidator("dataId", cdk.validateString)(properties.dataId)), errors.collect(cdk.propertyValidator("negated", cdk.requiredValidator)(properties.negated)), errors.collect(cdk.propertyValidator("negated", cdk.validateBoolean)(properties.negated)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "PredicateProperty"');
    }
    function cfnRateBasedRulePredicatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRateBasedRule_PredicatePropertyValidator(properties).assertSuccess(), { DataId: cdk.stringToCloudFormation(properties.dataId), Negated: cdk.booleanToCloudFormation(properties.negated), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnRateBasedRulePredicatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataId", "DataId", cfn_parse.FromCloudFormation.getString(properties.DataId)), ret.addPropertyResult("negated", "Negated", cfn_parse.FromCloudFormation.getBoolean(properties.Negated)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRegexPatternSetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("regexPatternStrings", cdk.requiredValidator)(properties.regexPatternStrings)), errors.collect(cdk.propertyValidator("regexPatternStrings", cdk.listValidator(cdk.validateString))(properties.regexPatternStrings)), errors.wrap('supplied properties not correct for "CfnRegexPatternSetProps"');
    }
    function cfnRegexPatternSetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRegexPatternSetPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), RegexPatternStrings: cdk.listMapper(cdk.stringToCloudFormation)(properties.regexPatternStrings) }) : properties;
    }
    function CfnRegexPatternSetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("regexPatternStrings", "RegexPatternStrings", cfn_parse.FromCloudFormation.getStringArray(properties.RegexPatternStrings)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRegexPatternSet = class _CfnRegexPatternSet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRegexPatternSetPropsFromCloudFormation(resourceProperties), ret = new _CfnRegexPatternSet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRegexPatternSet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_wafregional_CfnRegexPatternSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRegexPatternSet), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "regexPatternStrings", this), this.name = props.name, this.regexPatternStrings = props.regexPatternStrings;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRegexPatternSet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, regexPatternStrings: this.regexPatternStrings };
      }
      renderProperties(props) {
        return cfnRegexPatternSetPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnRegexPatternSet[_e] = { fqn: "aws-cdk-lib.aws_wafregional.CfnRegexPatternSet", version: "2.80.0" }, CfnRegexPatternSet.CFN_RESOURCE_TYPE_NAME = "AWS::WAFRegional::RegexPatternSet", exports2.CfnRegexPatternSet = CfnRegexPatternSet;
    function CfnRulePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("metricName", cdk.requiredValidator)(properties.metricName)), errors.collect(cdk.propertyValidator("metricName", cdk.validateString)(properties.metricName)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("predicates", cdk.listValidator(CfnRule_PredicatePropertyValidator))(properties.predicates)), errors.wrap('supplied properties not correct for "CfnRuleProps"');
    }
    function cfnRulePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRulePropsValidator(properties).assertSuccess(), { MetricName: cdk.stringToCloudFormation(properties.metricName), Name: cdk.stringToCloudFormation(properties.name), Predicates: cdk.listMapper(cfnRulePredicatePropertyToCloudFormation)(properties.predicates) }) : properties;
    }
    function CfnRulePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("metricName", "MetricName", cfn_parse.FromCloudFormation.getString(properties.MetricName)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("predicates", "Predicates", properties.Predicates != null ? cfn_parse.FromCloudFormation.getArray(CfnRulePredicatePropertyFromCloudFormation)(properties.Predicates) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRule = class _CfnRule extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRulePropsFromCloudFormation(resourceProperties), ret = new _CfnRule(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRule.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_wafregional_CfnRuleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRule), error;
        }
        cdk.requireProperty(props, "metricName", this), cdk.requireProperty(props, "name", this), this.metricName = props.metricName, this.name = props.name, this.predicates = props.predicates;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRule.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { metricName: this.metricName, name: this.name, predicates: this.predicates };
      }
      renderProperties(props) {
        return cfnRulePropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnRule[_f] = { fqn: "aws-cdk-lib.aws_wafregional.CfnRule", version: "2.80.0" }, CfnRule.CFN_RESOURCE_TYPE_NAME = "AWS::WAFRegional::Rule", exports2.CfnRule = CfnRule;
    function CfnRule_PredicatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("dataId", cdk.requiredValidator)(properties.dataId)), errors.collect(cdk.propertyValidator("dataId", cdk.validateString)(properties.dataId)), errors.collect(cdk.propertyValidator("negated", cdk.requiredValidator)(properties.negated)), errors.collect(cdk.propertyValidator("negated", cdk.validateBoolean)(properties.negated)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "PredicateProperty"');
    }
    function cfnRulePredicatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRule_PredicatePropertyValidator(properties).assertSuccess(), { DataId: cdk.stringToCloudFormation(properties.dataId), Negated: cdk.booleanToCloudFormation(properties.negated), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnRulePredicatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("dataId", "DataId", cfn_parse.FromCloudFormation.getString(properties.DataId)), ret.addPropertyResult("negated", "Negated", cfn_parse.FromCloudFormation.getBoolean(properties.Negated)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSizeConstraintSetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("sizeConstraints", cdk.listValidator(CfnSizeConstraintSet_SizeConstraintPropertyValidator))(properties.sizeConstraints)), errors.wrap('supplied properties not correct for "CfnSizeConstraintSetProps"');
    }
    function cfnSizeConstraintSetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSizeConstraintSetPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), SizeConstraints: cdk.listMapper(cfnSizeConstraintSetSizeConstraintPropertyToCloudFormation)(properties.sizeConstraints) }) : properties;
    }
    function CfnSizeConstraintSetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("sizeConstraints", "SizeConstraints", properties.SizeConstraints != null ? cfn_parse.FromCloudFormation.getArray(CfnSizeConstraintSetSizeConstraintPropertyFromCloudFormation)(properties.SizeConstraints) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSizeConstraintSet = class _CfnSizeConstraintSet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSizeConstraintSetPropsFromCloudFormation(resourceProperties), ret = new _CfnSizeConstraintSet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSizeConstraintSet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_wafregional_CfnSizeConstraintSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSizeConstraintSet), error;
        }
        cdk.requireProperty(props, "name", this), this.name = props.name, this.sizeConstraints = props.sizeConstraints;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSizeConstraintSet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, sizeConstraints: this.sizeConstraints };
      }
      renderProperties(props) {
        return cfnSizeConstraintSetPropsToCloudFormation(props);
      }
    };
    _g = JSII_RTTI_SYMBOL_1, CfnSizeConstraintSet[_g] = { fqn: "aws-cdk-lib.aws_wafregional.CfnSizeConstraintSet", version: "2.80.0" }, CfnSizeConstraintSet.CFN_RESOURCE_TYPE_NAME = "AWS::WAFRegional::SizeConstraintSet", exports2.CfnSizeConstraintSet = CfnSizeConstraintSet;
    function CfnSizeConstraintSet_FieldToMatchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("data", cdk.validateString)(properties.data)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "FieldToMatchProperty"');
    }
    function cfnSizeConstraintSetFieldToMatchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSizeConstraintSet_FieldToMatchPropertyValidator(properties).assertSuccess(), { Data: cdk.stringToCloudFormation(properties.data), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnSizeConstraintSetFieldToMatchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("data", "Data", properties.Data != null ? cfn_parse.FromCloudFormation.getString(properties.Data) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSizeConstraintSet_SizeConstraintPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("comparisonOperator", cdk.requiredValidator)(properties.comparisonOperator)), errors.collect(cdk.propertyValidator("comparisonOperator", cdk.validateString)(properties.comparisonOperator)), errors.collect(cdk.propertyValidator("fieldToMatch", cdk.requiredValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("fieldToMatch", CfnSizeConstraintSet_FieldToMatchPropertyValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("size", cdk.requiredValidator)(properties.size)), errors.collect(cdk.propertyValidator("size", cdk.validateNumber)(properties.size)), errors.collect(cdk.propertyValidator("textTransformation", cdk.requiredValidator)(properties.textTransformation)), errors.collect(cdk.propertyValidator("textTransformation", cdk.validateString)(properties.textTransformation)), errors.wrap('supplied properties not correct for "SizeConstraintProperty"');
    }
    function cfnSizeConstraintSetSizeConstraintPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSizeConstraintSet_SizeConstraintPropertyValidator(properties).assertSuccess(), { ComparisonOperator: cdk.stringToCloudFormation(properties.comparisonOperator), FieldToMatch: cfnSizeConstraintSetFieldToMatchPropertyToCloudFormation(properties.fieldToMatch), Size: cdk.numberToCloudFormation(properties.size), TextTransformation: cdk.stringToCloudFormation(properties.textTransformation) }) : properties;
    }
    function CfnSizeConstraintSetSizeConstraintPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("comparisonOperator", "ComparisonOperator", cfn_parse.FromCloudFormation.getString(properties.ComparisonOperator)), ret.addPropertyResult("fieldToMatch", "FieldToMatch", CfnSizeConstraintSetFieldToMatchPropertyFromCloudFormation(properties.FieldToMatch)), ret.addPropertyResult("size", "Size", cfn_parse.FromCloudFormation.getNumber(properties.Size)), ret.addPropertyResult("textTransformation", "TextTransformation", cfn_parse.FromCloudFormation.getString(properties.TextTransformation)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSqlInjectionMatchSetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("sqlInjectionMatchTuples", cdk.listValidator(CfnSqlInjectionMatchSet_SqlInjectionMatchTuplePropertyValidator))(properties.sqlInjectionMatchTuples)), errors.wrap('supplied properties not correct for "CfnSqlInjectionMatchSetProps"');
    }
    function cfnSqlInjectionMatchSetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSqlInjectionMatchSetPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), SqlInjectionMatchTuples: cdk.listMapper(cfnSqlInjectionMatchSetSqlInjectionMatchTuplePropertyToCloudFormation)(properties.sqlInjectionMatchTuples) }) : properties;
    }
    function CfnSqlInjectionMatchSetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("sqlInjectionMatchTuples", "SqlInjectionMatchTuples", properties.SqlInjectionMatchTuples != null ? cfn_parse.FromCloudFormation.getArray(CfnSqlInjectionMatchSetSqlInjectionMatchTuplePropertyFromCloudFormation)(properties.SqlInjectionMatchTuples) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSqlInjectionMatchSet = class _CfnSqlInjectionMatchSet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSqlInjectionMatchSetPropsFromCloudFormation(resourceProperties), ret = new _CfnSqlInjectionMatchSet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnSqlInjectionMatchSet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_wafregional_CfnSqlInjectionMatchSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSqlInjectionMatchSet), error;
        }
        cdk.requireProperty(props, "name", this), this.name = props.name, this.sqlInjectionMatchTuples = props.sqlInjectionMatchTuples;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSqlInjectionMatchSet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, sqlInjectionMatchTuples: this.sqlInjectionMatchTuples };
      }
      renderProperties(props) {
        return cfnSqlInjectionMatchSetPropsToCloudFormation(props);
      }
    };
    _h = JSII_RTTI_SYMBOL_1, CfnSqlInjectionMatchSet[_h] = { fqn: "aws-cdk-lib.aws_wafregional.CfnSqlInjectionMatchSet", version: "2.80.0" }, CfnSqlInjectionMatchSet.CFN_RESOURCE_TYPE_NAME = "AWS::WAFRegional::SqlInjectionMatchSet", exports2.CfnSqlInjectionMatchSet = CfnSqlInjectionMatchSet;
    function CfnSqlInjectionMatchSet_FieldToMatchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("data", cdk.validateString)(properties.data)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "FieldToMatchProperty"');
    }
    function cfnSqlInjectionMatchSetFieldToMatchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSqlInjectionMatchSet_FieldToMatchPropertyValidator(properties).assertSuccess(), { Data: cdk.stringToCloudFormation(properties.data), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnSqlInjectionMatchSetFieldToMatchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("data", "Data", properties.Data != null ? cfn_parse.FromCloudFormation.getString(properties.Data) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSqlInjectionMatchSet_SqlInjectionMatchTuplePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldToMatch", cdk.requiredValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("fieldToMatch", CfnSqlInjectionMatchSet_FieldToMatchPropertyValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("textTransformation", cdk.requiredValidator)(properties.textTransformation)), errors.collect(cdk.propertyValidator("textTransformation", cdk.validateString)(properties.textTransformation)), errors.wrap('supplied properties not correct for "SqlInjectionMatchTupleProperty"');
    }
    function cfnSqlInjectionMatchSetSqlInjectionMatchTuplePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSqlInjectionMatchSet_SqlInjectionMatchTuplePropertyValidator(properties).assertSuccess(), { FieldToMatch: cfnSqlInjectionMatchSetFieldToMatchPropertyToCloudFormation(properties.fieldToMatch), TextTransformation: cdk.stringToCloudFormation(properties.textTransformation) }) : properties;
    }
    function CfnSqlInjectionMatchSetSqlInjectionMatchTuplePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldToMatch", "FieldToMatch", CfnSqlInjectionMatchSetFieldToMatchPropertyFromCloudFormation(properties.FieldToMatch)), ret.addPropertyResult("textTransformation", "TextTransformation", cfn_parse.FromCloudFormation.getString(properties.TextTransformation)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACLPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("defaultAction", cdk.requiredValidator)(properties.defaultAction)), errors.collect(cdk.propertyValidator("defaultAction", CfnWebACL_ActionPropertyValidator)(properties.defaultAction)), errors.collect(cdk.propertyValidator("metricName", cdk.requiredValidator)(properties.metricName)), errors.collect(cdk.propertyValidator("metricName", cdk.validateString)(properties.metricName)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("rules", cdk.listValidator(CfnWebACL_RulePropertyValidator))(properties.rules)), errors.wrap('supplied properties not correct for "CfnWebACLProps"');
    }
    function cfnWebACLPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACLPropsValidator(properties).assertSuccess(), { DefaultAction: cfnWebACLActionPropertyToCloudFormation(properties.defaultAction), MetricName: cdk.stringToCloudFormation(properties.metricName), Name: cdk.stringToCloudFormation(properties.name), Rules: cdk.listMapper(cfnWebACLRulePropertyToCloudFormation)(properties.rules) }) : properties;
    }
    function CfnWebACLPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultAction", "DefaultAction", CfnWebACLActionPropertyFromCloudFormation(properties.DefaultAction)), ret.addPropertyResult("metricName", "MetricName", cfn_parse.FromCloudFormation.getString(properties.MetricName)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("rules", "Rules", properties.Rules != null ? cfn_parse.FromCloudFormation.getArray(CfnWebACLRulePropertyFromCloudFormation)(properties.Rules) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnWebACL = class _CfnWebACL extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnWebACLPropsFromCloudFormation(resourceProperties), ret = new _CfnWebACL(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnWebACL.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_wafregional_CfnWebACLProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnWebACL), error;
        }
        cdk.requireProperty(props, "defaultAction", this), cdk.requireProperty(props, "metricName", this), cdk.requireProperty(props, "name", this), this.defaultAction = props.defaultAction, this.metricName = props.metricName, this.name = props.name, this.rules = props.rules;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnWebACL.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { defaultAction: this.defaultAction, metricName: this.metricName, name: this.name, rules: this.rules };
      }
      renderProperties(props) {
        return cfnWebACLPropsToCloudFormation(props);
      }
    };
    _j = JSII_RTTI_SYMBOL_1, CfnWebACL[_j] = { fqn: "aws-cdk-lib.aws_wafregional.CfnWebACL", version: "2.80.0" }, CfnWebACL.CFN_RESOURCE_TYPE_NAME = "AWS::WAFRegional::WebACL", exports2.CfnWebACL = CfnWebACL;
    function CfnWebACL_ActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "ActionProperty"');
    }
    function cfnWebACLActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_ActionPropertyValidator(properties).assertSuccess(), { Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnWebACLActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_RulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", cdk.requiredValidator)(properties.action)), errors.collect(cdk.propertyValidator("action", CfnWebACL_ActionPropertyValidator)(properties.action)), errors.collect(cdk.propertyValidator("priority", cdk.requiredValidator)(properties.priority)), errors.collect(cdk.propertyValidator("priority", cdk.validateNumber)(properties.priority)), errors.collect(cdk.propertyValidator("ruleId", cdk.requiredValidator)(properties.ruleId)), errors.collect(cdk.propertyValidator("ruleId", cdk.validateString)(properties.ruleId)), errors.wrap('supplied properties not correct for "RuleProperty"');
    }
    function cfnWebACLRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_RulePropertyValidator(properties).assertSuccess(), { Action: cfnWebACLActionPropertyToCloudFormation(properties.action), Priority: cdk.numberToCloudFormation(properties.priority), RuleId: cdk.stringToCloudFormation(properties.ruleId) }) : properties;
    }
    function CfnWebACLRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", CfnWebACLActionPropertyFromCloudFormation(properties.Action)), ret.addPropertyResult("priority", "Priority", cfn_parse.FromCloudFormation.getNumber(properties.Priority)), ret.addPropertyResult("ruleId", "RuleId", cfn_parse.FromCloudFormation.getString(properties.RuleId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACLAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceArn", cdk.requiredValidator)(properties.resourceArn)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.collect(cdk.propertyValidator("webAclId", cdk.requiredValidator)(properties.webAclId)), errors.collect(cdk.propertyValidator("webAclId", cdk.validateString)(properties.webAclId)), errors.wrap('supplied properties not correct for "CfnWebACLAssociationProps"');
    }
    function cfnWebACLAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACLAssociationPropsValidator(properties).assertSuccess(), { ResourceArn: cdk.stringToCloudFormation(properties.resourceArn), WebACLId: cdk.stringToCloudFormation(properties.webAclId) }) : properties;
    }
    function CfnWebACLAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceArn", "ResourceArn", cfn_parse.FromCloudFormation.getString(properties.ResourceArn)), ret.addPropertyResult("webAclId", "WebACLId", cfn_parse.FromCloudFormation.getString(properties.WebACLId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnWebACLAssociation = class _CfnWebACLAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnWebACLAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnWebACLAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnWebACLAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_wafregional_CfnWebACLAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnWebACLAssociation), error;
        }
        cdk.requireProperty(props, "resourceArn", this), cdk.requireProperty(props, "webAclId", this), this.resourceArn = props.resourceArn, this.webAclId = props.webAclId;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnWebACLAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { resourceArn: this.resourceArn, webAclId: this.webAclId };
      }
      renderProperties(props) {
        return cfnWebACLAssociationPropsToCloudFormation(props);
      }
    };
    _k = JSII_RTTI_SYMBOL_1, CfnWebACLAssociation[_k] = { fqn: "aws-cdk-lib.aws_wafregional.CfnWebACLAssociation", version: "2.80.0" }, CfnWebACLAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::WAFRegional::WebACLAssociation", exports2.CfnWebACLAssociation = CfnWebACLAssociation;
    function CfnXssMatchSetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("xssMatchTuples", cdk.listValidator(CfnXssMatchSet_XssMatchTuplePropertyValidator))(properties.xssMatchTuples)), errors.wrap('supplied properties not correct for "CfnXssMatchSetProps"');
    }
    function cfnXssMatchSetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnXssMatchSetPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), XssMatchTuples: cdk.listMapper(cfnXssMatchSetXssMatchTuplePropertyToCloudFormation)(properties.xssMatchTuples) }) : properties;
    }
    function CfnXssMatchSetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("xssMatchTuples", "XssMatchTuples", properties.XssMatchTuples != null ? cfn_parse.FromCloudFormation.getArray(CfnXssMatchSetXssMatchTuplePropertyFromCloudFormation)(properties.XssMatchTuples) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnXssMatchSet = class _CfnXssMatchSet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnXssMatchSetPropsFromCloudFormation(resourceProperties), ret = new _CfnXssMatchSet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnXssMatchSet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_wafregional_CfnXssMatchSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnXssMatchSet), error;
        }
        cdk.requireProperty(props, "name", this), this.name = props.name, this.xssMatchTuples = props.xssMatchTuples;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnXssMatchSet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, xssMatchTuples: this.xssMatchTuples };
      }
      renderProperties(props) {
        return cfnXssMatchSetPropsToCloudFormation(props);
      }
    };
    _l = JSII_RTTI_SYMBOL_1, CfnXssMatchSet[_l] = { fqn: "aws-cdk-lib.aws_wafregional.CfnXssMatchSet", version: "2.80.0" }, CfnXssMatchSet.CFN_RESOURCE_TYPE_NAME = "AWS::WAFRegional::XssMatchSet", exports2.CfnXssMatchSet = CfnXssMatchSet;
    function CfnXssMatchSet_FieldToMatchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("data", cdk.validateString)(properties.data)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "FieldToMatchProperty"');
    }
    function cfnXssMatchSetFieldToMatchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnXssMatchSet_FieldToMatchPropertyValidator(properties).assertSuccess(), { Data: cdk.stringToCloudFormation(properties.data), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnXssMatchSetFieldToMatchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("data", "Data", properties.Data != null ? cfn_parse.FromCloudFormation.getString(properties.Data) : void 0), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnXssMatchSet_XssMatchTuplePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldToMatch", cdk.requiredValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("fieldToMatch", CfnXssMatchSet_FieldToMatchPropertyValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("textTransformation", cdk.requiredValidator)(properties.textTransformation)), errors.collect(cdk.propertyValidator("textTransformation", cdk.validateString)(properties.textTransformation)), errors.wrap('supplied properties not correct for "XssMatchTupleProperty"');
    }
    function cfnXssMatchSetXssMatchTuplePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnXssMatchSet_XssMatchTuplePropertyValidator(properties).assertSuccess(), { FieldToMatch: cfnXssMatchSetFieldToMatchPropertyToCloudFormation(properties.fieldToMatch), TextTransformation: cdk.stringToCloudFormation(properties.textTransformation) }) : properties;
    }
    function CfnXssMatchSetXssMatchTuplePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldToMatch", "FieldToMatch", CfnXssMatchSetFieldToMatchPropertyFromCloudFormation(properties.FieldToMatch)), ret.addPropertyResult("textTransformation", "TextTransformation", cfn_parse.FromCloudFormation.getString(properties.TextTransformation)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-wafregional/lib/index.js
var require_lib255 = __commonJS({
  "node_modules/aws-cdk-lib/aws-wafregional/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_wafregional_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-wafregional/index.js
var require_aws_wafregional = __commonJS({
  "node_modules/aws-cdk-lib/aws-wafregional/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib255(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-wafv2/lib/wafv2.generated.js
var require_wafv2_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-wafv2/lib/wafv2.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    var _d;
    var _e;
    var _f;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnWebACLAssociation = exports2.CfnWebACL = exports2.CfnRuleGroup = exports2.CfnRegexPatternSet = exports2.CfnLoggingConfiguration = exports2.CfnIPSet = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnIPSetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("addresses", cdk.requiredValidator)(properties.addresses)), errors.collect(cdk.propertyValidator("addresses", cdk.listValidator(cdk.validateString))(properties.addresses)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("ipAddressVersion", cdk.requiredValidator)(properties.ipAddressVersion)), errors.collect(cdk.propertyValidator("ipAddressVersion", cdk.validateString)(properties.ipAddressVersion)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("scope", cdk.requiredValidator)(properties.scope)), errors.collect(cdk.propertyValidator("scope", cdk.validateString)(properties.scope)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnIPSetProps"');
    }
    function cfnIPSetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnIPSetPropsValidator(properties).assertSuccess(), { Addresses: cdk.listMapper(cdk.stringToCloudFormation)(properties.addresses), IPAddressVersion: cdk.stringToCloudFormation(properties.ipAddressVersion), Scope: cdk.stringToCloudFormation(properties.scope), Description: cdk.stringToCloudFormation(properties.description), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnIPSetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("addresses", "Addresses", cfn_parse.FromCloudFormation.getStringArray(properties.Addresses)), ret.addPropertyResult("ipAddressVersion", "IPAddressVersion", cfn_parse.FromCloudFormation.getString(properties.IPAddressVersion)), ret.addPropertyResult("scope", "Scope", cfn_parse.FromCloudFormation.getString(properties.Scope)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnIPSet = class _CfnIPSet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnIPSetPropsFromCloudFormation(resourceProperties), ret = new _CfnIPSet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnIPSet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_wafv2_CfnIPSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnIPSet), error;
        }
        cdk.requireProperty(props, "addresses", this), cdk.requireProperty(props, "ipAddressVersion", this), cdk.requireProperty(props, "scope", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.addresses = props.addresses, this.ipAddressVersion = props.ipAddressVersion, this.scope = props.scope, this.description = props.description, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::WAFv2::IPSet", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnIPSet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { addresses: this.addresses, ipAddressVersion: this.ipAddressVersion, scope: this.scope, description: this.description, name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnIPSetPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnIPSet[_a] = { fqn: "aws-cdk-lib.aws_wafv2.CfnIPSet", version: "2.80.0" }, CfnIPSet.CFN_RESOURCE_TYPE_NAME = "AWS::WAFv2::IPSet", exports2.CfnIPSet = CfnIPSet;
    function CfnLoggingConfigurationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("logDestinationConfigs", cdk.requiredValidator)(properties.logDestinationConfigs)), errors.collect(cdk.propertyValidator("logDestinationConfigs", cdk.listValidator(cdk.validateString))(properties.logDestinationConfigs)), errors.collect(cdk.propertyValidator("loggingFilter", cdk.validateObject)(properties.loggingFilter)), errors.collect(cdk.propertyValidator("redactedFields", cdk.listValidator(CfnLoggingConfiguration_FieldToMatchPropertyValidator))(properties.redactedFields)), errors.collect(cdk.propertyValidator("resourceArn", cdk.requiredValidator)(properties.resourceArn)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.wrap('supplied properties not correct for "CfnLoggingConfigurationProps"');
    }
    function cfnLoggingConfigurationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLoggingConfigurationPropsValidator(properties).assertSuccess(), { LogDestinationConfigs: cdk.listMapper(cdk.stringToCloudFormation)(properties.logDestinationConfigs), ResourceArn: cdk.stringToCloudFormation(properties.resourceArn), LoggingFilter: cdk.objectToCloudFormation(properties.loggingFilter), RedactedFields: cdk.listMapper(cfnLoggingConfigurationFieldToMatchPropertyToCloudFormation)(properties.redactedFields) }) : properties;
    }
    function CfnLoggingConfigurationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("logDestinationConfigs", "LogDestinationConfigs", cfn_parse.FromCloudFormation.getStringArray(properties.LogDestinationConfigs)), ret.addPropertyResult("resourceArn", "ResourceArn", cfn_parse.FromCloudFormation.getString(properties.ResourceArn)), ret.addPropertyResult("loggingFilter", "LoggingFilter", properties.LoggingFilter != null ? cfn_parse.FromCloudFormation.getAny(properties.LoggingFilter) : void 0), ret.addPropertyResult("redactedFields", "RedactedFields", properties.RedactedFields != null ? cfn_parse.FromCloudFormation.getArray(CfnLoggingConfigurationFieldToMatchPropertyFromCloudFormation)(properties.RedactedFields) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnLoggingConfiguration = class _CfnLoggingConfiguration extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnLoggingConfigurationPropsFromCloudFormation(resourceProperties), ret = new _CfnLoggingConfiguration(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnLoggingConfiguration.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_wafv2_CfnLoggingConfigurationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnLoggingConfiguration), error;
        }
        cdk.requireProperty(props, "logDestinationConfigs", this), cdk.requireProperty(props, "resourceArn", this), this.attrManagedByFirewallManager = this.getAtt("ManagedByFirewallManager", cdk.ResolutionTypeHint.STRING), this.logDestinationConfigs = props.logDestinationConfigs, this.resourceArn = props.resourceArn, this.loggingFilter = props.loggingFilter, this.redactedFields = props.redactedFields;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnLoggingConfiguration.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { logDestinationConfigs: this.logDestinationConfigs, resourceArn: this.resourceArn, loggingFilter: this.loggingFilter, redactedFields: this.redactedFields };
      }
      renderProperties(props) {
        return cfnLoggingConfigurationPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnLoggingConfiguration[_b] = { fqn: "aws-cdk-lib.aws_wafv2.CfnLoggingConfiguration", version: "2.80.0" }, CfnLoggingConfiguration.CFN_RESOURCE_TYPE_NAME = "AWS::WAFv2::LoggingConfiguration", exports2.CfnLoggingConfiguration = CfnLoggingConfiguration;
    function CfnLoggingConfiguration_FieldToMatchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("jsonBody", cdk.validateObject)(properties.jsonBody)), errors.collect(cdk.propertyValidator("method", cdk.validateObject)(properties.method)), errors.collect(cdk.propertyValidator("queryString", cdk.validateObject)(properties.queryString)), errors.collect(cdk.propertyValidator("singleHeader", cdk.validateObject)(properties.singleHeader)), errors.collect(cdk.propertyValidator("uriPath", cdk.validateObject)(properties.uriPath)), errors.wrap('supplied properties not correct for "FieldToMatchProperty"');
    }
    function cfnLoggingConfigurationFieldToMatchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnLoggingConfiguration_FieldToMatchPropertyValidator(properties).assertSuccess(), { JsonBody: cdk.objectToCloudFormation(properties.jsonBody), Method: cdk.objectToCloudFormation(properties.method), QueryString: cdk.objectToCloudFormation(properties.queryString), SingleHeader: cdk.objectToCloudFormation(properties.singleHeader), UriPath: cdk.objectToCloudFormation(properties.uriPath) }) : properties;
    }
    function CfnLoggingConfigurationFieldToMatchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("jsonBody", "JsonBody", properties.JsonBody != null ? cfn_parse.FromCloudFormation.getAny(properties.JsonBody) : void 0), ret.addPropertyResult("method", "Method", properties.Method != null ? cfn_parse.FromCloudFormation.getAny(properties.Method) : void 0), ret.addPropertyResult("queryString", "QueryString", properties.QueryString != null ? cfn_parse.FromCloudFormation.getAny(properties.QueryString) : void 0), ret.addPropertyResult("singleHeader", "SingleHeader", properties.SingleHeader != null ? cfn_parse.FromCloudFormation.getAny(properties.SingleHeader) : void 0), ret.addPropertyResult("uriPath", "UriPath", properties.UriPath != null ? cfn_parse.FromCloudFormation.getAny(properties.UriPath) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRegexPatternSetPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("regularExpressionList", cdk.requiredValidator)(properties.regularExpressionList)), errors.collect(cdk.propertyValidator("regularExpressionList", cdk.listValidator(cdk.validateString))(properties.regularExpressionList)), errors.collect(cdk.propertyValidator("scope", cdk.requiredValidator)(properties.scope)), errors.collect(cdk.propertyValidator("scope", cdk.validateString)(properties.scope)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnRegexPatternSetProps"');
    }
    function cfnRegexPatternSetPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRegexPatternSetPropsValidator(properties).assertSuccess(), { RegularExpressionList: cdk.listMapper(cdk.stringToCloudFormation)(properties.regularExpressionList), Scope: cdk.stringToCloudFormation(properties.scope), Description: cdk.stringToCloudFormation(properties.description), Name: cdk.stringToCloudFormation(properties.name), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnRegexPatternSetPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("regularExpressionList", "RegularExpressionList", cfn_parse.FromCloudFormation.getStringArray(properties.RegularExpressionList)), ret.addPropertyResult("scope", "Scope", cfn_parse.FromCloudFormation.getString(properties.Scope)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRegexPatternSet = class _CfnRegexPatternSet extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRegexPatternSetPropsFromCloudFormation(resourceProperties), ret = new _CfnRegexPatternSet(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRegexPatternSet.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_wafv2_CfnRegexPatternSetProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRegexPatternSet), error;
        }
        cdk.requireProperty(props, "regularExpressionList", this), cdk.requireProperty(props, "scope", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.regularExpressionList = props.regularExpressionList, this.scope = props.scope, this.description = props.description, this.name = props.name, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::WAFv2::RegexPatternSet", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRegexPatternSet.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { regularExpressionList: this.regularExpressionList, scope: this.scope, description: this.description, name: this.name, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnRegexPatternSetPropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnRegexPatternSet[_c] = { fqn: "aws-cdk-lib.aws_wafv2.CfnRegexPatternSet", version: "2.80.0" }, CfnRegexPatternSet.CFN_RESOURCE_TYPE_NAME = "AWS::WAFv2::RegexPatternSet", exports2.CfnRegexPatternSet = CfnRegexPatternSet;
    function CfnRuleGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("availableLabels", cdk.listValidator(CfnRuleGroup_LabelSummaryPropertyValidator))(properties.availableLabels)), errors.collect(cdk.propertyValidator("capacity", cdk.requiredValidator)(properties.capacity)), errors.collect(cdk.propertyValidator("capacity", cdk.validateNumber)(properties.capacity)), errors.collect(cdk.propertyValidator("consumedLabels", cdk.listValidator(CfnRuleGroup_LabelSummaryPropertyValidator))(properties.consumedLabels)), errors.collect(cdk.propertyValidator("customResponseBodies", cdk.hashValidator(CfnRuleGroup_CustomResponseBodyPropertyValidator))(properties.customResponseBodies)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("rules", cdk.listValidator(CfnRuleGroup_RulePropertyValidator))(properties.rules)), errors.collect(cdk.propertyValidator("scope", cdk.requiredValidator)(properties.scope)), errors.collect(cdk.propertyValidator("scope", cdk.validateString)(properties.scope)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("visibilityConfig", cdk.requiredValidator)(properties.visibilityConfig)), errors.collect(cdk.propertyValidator("visibilityConfig", CfnRuleGroup_VisibilityConfigPropertyValidator)(properties.visibilityConfig)), errors.wrap('supplied properties not correct for "CfnRuleGroupProps"');
    }
    function cfnRuleGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroupPropsValidator(properties).assertSuccess(), { Capacity: cdk.numberToCloudFormation(properties.capacity), Scope: cdk.stringToCloudFormation(properties.scope), VisibilityConfig: cfnRuleGroupVisibilityConfigPropertyToCloudFormation(properties.visibilityConfig), AvailableLabels: cdk.listMapper(cfnRuleGroupLabelSummaryPropertyToCloudFormation)(properties.availableLabels), ConsumedLabels: cdk.listMapper(cfnRuleGroupLabelSummaryPropertyToCloudFormation)(properties.consumedLabels), CustomResponseBodies: cdk.hashMapper(cfnRuleGroupCustomResponseBodyPropertyToCloudFormation)(properties.customResponseBodies), Description: cdk.stringToCloudFormation(properties.description), Name: cdk.stringToCloudFormation(properties.name), Rules: cdk.listMapper(cfnRuleGroupRulePropertyToCloudFormation)(properties.rules), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnRuleGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("capacity", "Capacity", cfn_parse.FromCloudFormation.getNumber(properties.Capacity)), ret.addPropertyResult("scope", "Scope", cfn_parse.FromCloudFormation.getString(properties.Scope)), ret.addPropertyResult("visibilityConfig", "VisibilityConfig", CfnRuleGroupVisibilityConfigPropertyFromCloudFormation(properties.VisibilityConfig)), ret.addPropertyResult("availableLabels", "AvailableLabels", properties.AvailableLabels != null ? cfn_parse.FromCloudFormation.getArray(CfnRuleGroupLabelSummaryPropertyFromCloudFormation)(properties.AvailableLabels) : void 0), ret.addPropertyResult("consumedLabels", "ConsumedLabels", properties.ConsumedLabels != null ? cfn_parse.FromCloudFormation.getArray(CfnRuleGroupLabelSummaryPropertyFromCloudFormation)(properties.ConsumedLabels) : void 0), ret.addPropertyResult("customResponseBodies", "CustomResponseBodies", properties.CustomResponseBodies != null ? cfn_parse.FromCloudFormation.getMap(CfnRuleGroupCustomResponseBodyPropertyFromCloudFormation)(properties.CustomResponseBodies) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("rules", "Rules", properties.Rules != null ? cfn_parse.FromCloudFormation.getArray(CfnRuleGroupRulePropertyFromCloudFormation)(properties.Rules) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnRuleGroup = class _CfnRuleGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnRuleGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnRuleGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnRuleGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_wafv2_CfnRuleGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnRuleGroup), error;
        }
        cdk.requireProperty(props, "capacity", this), cdk.requireProperty(props, "scope", this), cdk.requireProperty(props, "visibilityConfig", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrLabelNamespace = cdk.Token.asString(this.getAtt("LabelNamespace", cdk.ResolutionTypeHint.STRING)), this.capacity = props.capacity, this.scope = props.scope, this.visibilityConfig = props.visibilityConfig, this.availableLabels = props.availableLabels, this.consumedLabels = props.consumedLabels, this.customResponseBodies = props.customResponseBodies, this.description = props.description, this.name = props.name, this.rules = props.rules, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::WAFv2::RuleGroup", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnRuleGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { capacity: this.capacity, scope: this.scope, visibilityConfig: this.visibilityConfig, availableLabels: this.availableLabels, consumedLabels: this.consumedLabels, customResponseBodies: this.customResponseBodies, description: this.description, name: this.name, rules: this.rules, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnRuleGroupPropsToCloudFormation(props);
      }
    };
    _d = JSII_RTTI_SYMBOL_1, CfnRuleGroup[_d] = { fqn: "aws-cdk-lib.aws_wafv2.CfnRuleGroup", version: "2.80.0" }, CfnRuleGroup.CFN_RESOURCE_TYPE_NAME = "AWS::WAFv2::RuleGroup", exports2.CfnRuleGroup = CfnRuleGroup;
    function CfnRuleGroup_AndStatementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("statements", cdk.requiredValidator)(properties.statements)), errors.collect(cdk.propertyValidator("statements", cdk.listValidator(CfnRuleGroup_StatementPropertyValidator))(properties.statements)), errors.wrap('supplied properties not correct for "AndStatementProperty"');
    }
    function cfnRuleGroupAndStatementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_AndStatementPropertyValidator(properties).assertSuccess(), { Statements: cdk.listMapper(cfnRuleGroupStatementPropertyToCloudFormation)(properties.statements) }) : properties;
    }
    function CfnRuleGroupAndStatementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("statements", "Statements", cfn_parse.FromCloudFormation.getArray(CfnRuleGroupStatementPropertyFromCloudFormation)(properties.Statements)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_BodyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("oversizeHandling", cdk.validateString)(properties.oversizeHandling)), errors.wrap('supplied properties not correct for "BodyProperty"');
    }
    function cfnRuleGroupBodyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_BodyPropertyValidator(properties).assertSuccess(), { OversizeHandling: cdk.stringToCloudFormation(properties.oversizeHandling) }) : properties;
    }
    function CfnRuleGroupBodyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("oversizeHandling", "OversizeHandling", properties.OversizeHandling != null ? cfn_parse.FromCloudFormation.getString(properties.OversizeHandling) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_ByteMatchStatementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldToMatch", cdk.requiredValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("fieldToMatch", CfnRuleGroup_FieldToMatchPropertyValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("positionalConstraint", cdk.requiredValidator)(properties.positionalConstraint)), errors.collect(cdk.propertyValidator("positionalConstraint", cdk.validateString)(properties.positionalConstraint)), errors.collect(cdk.propertyValidator("searchString", cdk.validateString)(properties.searchString)), errors.collect(cdk.propertyValidator("searchStringBase64", cdk.validateString)(properties.searchStringBase64)), errors.collect(cdk.propertyValidator("textTransformations", cdk.requiredValidator)(properties.textTransformations)), errors.collect(cdk.propertyValidator("textTransformations", cdk.listValidator(CfnRuleGroup_TextTransformationPropertyValidator))(properties.textTransformations)), errors.wrap('supplied properties not correct for "ByteMatchStatementProperty"');
    }
    function cfnRuleGroupByteMatchStatementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_ByteMatchStatementPropertyValidator(properties).assertSuccess(), { FieldToMatch: cfnRuleGroupFieldToMatchPropertyToCloudFormation(properties.fieldToMatch), PositionalConstraint: cdk.stringToCloudFormation(properties.positionalConstraint), SearchString: cdk.stringToCloudFormation(properties.searchString), SearchStringBase64: cdk.stringToCloudFormation(properties.searchStringBase64), TextTransformations: cdk.listMapper(cfnRuleGroupTextTransformationPropertyToCloudFormation)(properties.textTransformations) }) : properties;
    }
    function CfnRuleGroupByteMatchStatementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldToMatch", "FieldToMatch", CfnRuleGroupFieldToMatchPropertyFromCloudFormation(properties.FieldToMatch)), ret.addPropertyResult("positionalConstraint", "PositionalConstraint", cfn_parse.FromCloudFormation.getString(properties.PositionalConstraint)), ret.addPropertyResult("searchString", "SearchString", properties.SearchString != null ? cfn_parse.FromCloudFormation.getString(properties.SearchString) : void 0), ret.addPropertyResult("searchStringBase64", "SearchStringBase64", properties.SearchStringBase64 != null ? cfn_parse.FromCloudFormation.getString(properties.SearchStringBase64) : void 0), ret.addPropertyResult("textTransformations", "TextTransformations", cfn_parse.FromCloudFormation.getArray(CfnRuleGroupTextTransformationPropertyFromCloudFormation)(properties.TextTransformations)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_CaptchaConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("immunityTimeProperty", CfnRuleGroup_ImmunityTimePropertyPropertyValidator)(properties.immunityTimeProperty)), errors.wrap('supplied properties not correct for "CaptchaConfigProperty"');
    }
    function cfnRuleGroupCaptchaConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_CaptchaConfigPropertyValidator(properties).assertSuccess(), { ImmunityTimeProperty: cfnRuleGroupImmunityTimePropertyPropertyToCloudFormation(properties.immunityTimeProperty) }) : properties;
    }
    function CfnRuleGroupCaptchaConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("immunityTimeProperty", "ImmunityTimeProperty", properties.ImmunityTimeProperty != null ? CfnRuleGroupImmunityTimePropertyPropertyFromCloudFormation(properties.ImmunityTimeProperty) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_ChallengeConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("immunityTimeProperty", CfnRuleGroup_ImmunityTimePropertyPropertyValidator)(properties.immunityTimeProperty)), errors.wrap('supplied properties not correct for "ChallengeConfigProperty"');
    }
    function cfnRuleGroupChallengeConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_ChallengeConfigPropertyValidator(properties).assertSuccess(), { ImmunityTimeProperty: cfnRuleGroupImmunityTimePropertyPropertyToCloudFormation(properties.immunityTimeProperty) }) : properties;
    }
    function CfnRuleGroupChallengeConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("immunityTimeProperty", "ImmunityTimeProperty", properties.ImmunityTimeProperty != null ? CfnRuleGroupImmunityTimePropertyPropertyFromCloudFormation(properties.ImmunityTimeProperty) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_CookieMatchPatternPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("all", cdk.validateObject)(properties.all)), errors.collect(cdk.propertyValidator("excludedCookies", cdk.listValidator(cdk.validateString))(properties.excludedCookies)), errors.collect(cdk.propertyValidator("includedCookies", cdk.listValidator(cdk.validateString))(properties.includedCookies)), errors.wrap('supplied properties not correct for "CookieMatchPatternProperty"');
    }
    function cfnRuleGroupCookieMatchPatternPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_CookieMatchPatternPropertyValidator(properties).assertSuccess(), { All: cdk.objectToCloudFormation(properties.all), ExcludedCookies: cdk.listMapper(cdk.stringToCloudFormation)(properties.excludedCookies), IncludedCookies: cdk.listMapper(cdk.stringToCloudFormation)(properties.includedCookies) }) : properties;
    }
    function CfnRuleGroupCookieMatchPatternPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("all", "All", properties.All != null ? cfn_parse.FromCloudFormation.getAny(properties.All) : void 0), ret.addPropertyResult("excludedCookies", "ExcludedCookies", properties.ExcludedCookies != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExcludedCookies) : void 0), ret.addPropertyResult("includedCookies", "IncludedCookies", properties.IncludedCookies != null ? cfn_parse.FromCloudFormation.getStringArray(properties.IncludedCookies) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_CookiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("matchPattern", cdk.requiredValidator)(properties.matchPattern)), errors.collect(cdk.propertyValidator("matchPattern", CfnRuleGroup_CookieMatchPatternPropertyValidator)(properties.matchPattern)), errors.collect(cdk.propertyValidator("matchScope", cdk.requiredValidator)(properties.matchScope)), errors.collect(cdk.propertyValidator("matchScope", cdk.validateString)(properties.matchScope)), errors.collect(cdk.propertyValidator("oversizeHandling", cdk.requiredValidator)(properties.oversizeHandling)), errors.collect(cdk.propertyValidator("oversizeHandling", cdk.validateString)(properties.oversizeHandling)), errors.wrap('supplied properties not correct for "CookiesProperty"');
    }
    function cfnRuleGroupCookiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_CookiesPropertyValidator(properties).assertSuccess(), { MatchPattern: cfnRuleGroupCookieMatchPatternPropertyToCloudFormation(properties.matchPattern), MatchScope: cdk.stringToCloudFormation(properties.matchScope), OversizeHandling: cdk.stringToCloudFormation(properties.oversizeHandling) }) : properties;
    }
    function CfnRuleGroupCookiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("matchPattern", "MatchPattern", CfnRuleGroupCookieMatchPatternPropertyFromCloudFormation(properties.MatchPattern)), ret.addPropertyResult("matchScope", "MatchScope", cfn_parse.FromCloudFormation.getString(properties.MatchScope)), ret.addPropertyResult("oversizeHandling", "OversizeHandling", cfn_parse.FromCloudFormation.getString(properties.OversizeHandling)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_CustomResponseBodyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("content", cdk.requiredValidator)(properties.content)), errors.collect(cdk.propertyValidator("content", cdk.validateString)(properties.content)), errors.collect(cdk.propertyValidator("contentType", cdk.requiredValidator)(properties.contentType)), errors.collect(cdk.propertyValidator("contentType", cdk.validateString)(properties.contentType)), errors.wrap('supplied properties not correct for "CustomResponseBodyProperty"');
    }
    function cfnRuleGroupCustomResponseBodyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_CustomResponseBodyPropertyValidator(properties).assertSuccess(), { Content: cdk.stringToCloudFormation(properties.content), ContentType: cdk.stringToCloudFormation(properties.contentType) }) : properties;
    }
    function CfnRuleGroupCustomResponseBodyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("content", "Content", cfn_parse.FromCloudFormation.getString(properties.Content)), ret.addPropertyResult("contentType", "ContentType", cfn_parse.FromCloudFormation.getString(properties.ContentType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_FieldToMatchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allQueryArguments", cdk.validateObject)(properties.allQueryArguments)), errors.collect(cdk.propertyValidator("body", CfnRuleGroup_BodyPropertyValidator)(properties.body)), errors.collect(cdk.propertyValidator("cookies", CfnRuleGroup_CookiesPropertyValidator)(properties.cookies)), errors.collect(cdk.propertyValidator("headers", CfnRuleGroup_HeadersPropertyValidator)(properties.headers)), errors.collect(cdk.propertyValidator("jsonBody", CfnRuleGroup_JsonBodyPropertyValidator)(properties.jsonBody)), errors.collect(cdk.propertyValidator("method", cdk.validateObject)(properties.method)), errors.collect(cdk.propertyValidator("queryString", cdk.validateObject)(properties.queryString)), errors.collect(cdk.propertyValidator("singleHeader", cdk.validateObject)(properties.singleHeader)), errors.collect(cdk.propertyValidator("singleQueryArgument", cdk.validateObject)(properties.singleQueryArgument)), errors.collect(cdk.propertyValidator("uriPath", cdk.validateObject)(properties.uriPath)), errors.wrap('supplied properties not correct for "FieldToMatchProperty"');
    }
    function cfnRuleGroupFieldToMatchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_FieldToMatchPropertyValidator(properties).assertSuccess(), { AllQueryArguments: cdk.objectToCloudFormation(properties.allQueryArguments), Body: cfnRuleGroupBodyPropertyToCloudFormation(properties.body), Cookies: cfnRuleGroupCookiesPropertyToCloudFormation(properties.cookies), Headers: cfnRuleGroupHeadersPropertyToCloudFormation(properties.headers), JsonBody: cfnRuleGroupJsonBodyPropertyToCloudFormation(properties.jsonBody), Method: cdk.objectToCloudFormation(properties.method), QueryString: cdk.objectToCloudFormation(properties.queryString), SingleHeader: cdk.objectToCloudFormation(properties.singleHeader), SingleQueryArgument: cdk.objectToCloudFormation(properties.singleQueryArgument), UriPath: cdk.objectToCloudFormation(properties.uriPath) }) : properties;
    }
    function CfnRuleGroupFieldToMatchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allQueryArguments", "AllQueryArguments", properties.AllQueryArguments != null ? cfn_parse.FromCloudFormation.getAny(properties.AllQueryArguments) : void 0), ret.addPropertyResult("body", "Body", properties.Body != null ? CfnRuleGroupBodyPropertyFromCloudFormation(properties.Body) : void 0), ret.addPropertyResult("cookies", "Cookies", properties.Cookies != null ? CfnRuleGroupCookiesPropertyFromCloudFormation(properties.Cookies) : void 0), ret.addPropertyResult("headers", "Headers", properties.Headers != null ? CfnRuleGroupHeadersPropertyFromCloudFormation(properties.Headers) : void 0), ret.addPropertyResult("jsonBody", "JsonBody", properties.JsonBody != null ? CfnRuleGroupJsonBodyPropertyFromCloudFormation(properties.JsonBody) : void 0), ret.addPropertyResult("method", "Method", properties.Method != null ? cfn_parse.FromCloudFormation.getAny(properties.Method) : void 0), ret.addPropertyResult("queryString", "QueryString", properties.QueryString != null ? cfn_parse.FromCloudFormation.getAny(properties.QueryString) : void 0), ret.addPropertyResult("singleHeader", "SingleHeader", properties.SingleHeader != null ? cfn_parse.FromCloudFormation.getAny(properties.SingleHeader) : void 0), ret.addPropertyResult("singleQueryArgument", "SingleQueryArgument", properties.SingleQueryArgument != null ? cfn_parse.FromCloudFormation.getAny(properties.SingleQueryArgument) : void 0), ret.addPropertyResult("uriPath", "UriPath", properties.UriPath != null ? cfn_parse.FromCloudFormation.getAny(properties.UriPath) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_ForwardedIPConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fallbackBehavior", cdk.requiredValidator)(properties.fallbackBehavior)), errors.collect(cdk.propertyValidator("fallbackBehavior", cdk.validateString)(properties.fallbackBehavior)), errors.collect(cdk.propertyValidator("headerName", cdk.requiredValidator)(properties.headerName)), errors.collect(cdk.propertyValidator("headerName", cdk.validateString)(properties.headerName)), errors.wrap('supplied properties not correct for "ForwardedIPConfigurationProperty"');
    }
    function cfnRuleGroupForwardedIPConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_ForwardedIPConfigurationPropertyValidator(properties).assertSuccess(), { FallbackBehavior: cdk.stringToCloudFormation(properties.fallbackBehavior), HeaderName: cdk.stringToCloudFormation(properties.headerName) }) : properties;
    }
    function CfnRuleGroupForwardedIPConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fallbackBehavior", "FallbackBehavior", cfn_parse.FromCloudFormation.getString(properties.FallbackBehavior)), ret.addPropertyResult("headerName", "HeaderName", cfn_parse.FromCloudFormation.getString(properties.HeaderName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_GeoMatchStatementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("countryCodes", cdk.listValidator(cdk.validateString))(properties.countryCodes)), errors.collect(cdk.propertyValidator("forwardedIpConfig", CfnRuleGroup_ForwardedIPConfigurationPropertyValidator)(properties.forwardedIpConfig)), errors.wrap('supplied properties not correct for "GeoMatchStatementProperty"');
    }
    function cfnRuleGroupGeoMatchStatementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_GeoMatchStatementPropertyValidator(properties).assertSuccess(), { CountryCodes: cdk.listMapper(cdk.stringToCloudFormation)(properties.countryCodes), ForwardedIPConfig: cfnRuleGroupForwardedIPConfigurationPropertyToCloudFormation(properties.forwardedIpConfig) }) : properties;
    }
    function CfnRuleGroupGeoMatchStatementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("countryCodes", "CountryCodes", properties.CountryCodes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CountryCodes) : void 0), ret.addPropertyResult("forwardedIpConfig", "ForwardedIPConfig", properties.ForwardedIPConfig != null ? CfnRuleGroupForwardedIPConfigurationPropertyFromCloudFormation(properties.ForwardedIPConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_HeaderMatchPatternPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("all", cdk.validateObject)(properties.all)), errors.collect(cdk.propertyValidator("excludedHeaders", cdk.listValidator(cdk.validateString))(properties.excludedHeaders)), errors.collect(cdk.propertyValidator("includedHeaders", cdk.listValidator(cdk.validateString))(properties.includedHeaders)), errors.wrap('supplied properties not correct for "HeaderMatchPatternProperty"');
    }
    function cfnRuleGroupHeaderMatchPatternPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_HeaderMatchPatternPropertyValidator(properties).assertSuccess(), { All: cdk.objectToCloudFormation(properties.all), ExcludedHeaders: cdk.listMapper(cdk.stringToCloudFormation)(properties.excludedHeaders), IncludedHeaders: cdk.listMapper(cdk.stringToCloudFormation)(properties.includedHeaders) }) : properties;
    }
    function CfnRuleGroupHeaderMatchPatternPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("all", "All", properties.All != null ? cfn_parse.FromCloudFormation.getAny(properties.All) : void 0), ret.addPropertyResult("excludedHeaders", "ExcludedHeaders", properties.ExcludedHeaders != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExcludedHeaders) : void 0), ret.addPropertyResult("includedHeaders", "IncludedHeaders", properties.IncludedHeaders != null ? cfn_parse.FromCloudFormation.getStringArray(properties.IncludedHeaders) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_HeadersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("matchPattern", cdk.requiredValidator)(properties.matchPattern)), errors.collect(cdk.propertyValidator("matchPattern", CfnRuleGroup_HeaderMatchPatternPropertyValidator)(properties.matchPattern)), errors.collect(cdk.propertyValidator("matchScope", cdk.requiredValidator)(properties.matchScope)), errors.collect(cdk.propertyValidator("matchScope", cdk.validateString)(properties.matchScope)), errors.collect(cdk.propertyValidator("oversizeHandling", cdk.requiredValidator)(properties.oversizeHandling)), errors.collect(cdk.propertyValidator("oversizeHandling", cdk.validateString)(properties.oversizeHandling)), errors.wrap('supplied properties not correct for "HeadersProperty"');
    }
    function cfnRuleGroupHeadersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_HeadersPropertyValidator(properties).assertSuccess(), { MatchPattern: cfnRuleGroupHeaderMatchPatternPropertyToCloudFormation(properties.matchPattern), MatchScope: cdk.stringToCloudFormation(properties.matchScope), OversizeHandling: cdk.stringToCloudFormation(properties.oversizeHandling) }) : properties;
    }
    function CfnRuleGroupHeadersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("matchPattern", "MatchPattern", CfnRuleGroupHeaderMatchPatternPropertyFromCloudFormation(properties.MatchPattern)), ret.addPropertyResult("matchScope", "MatchScope", cfn_parse.FromCloudFormation.getString(properties.MatchScope)), ret.addPropertyResult("oversizeHandling", "OversizeHandling", cfn_parse.FromCloudFormation.getString(properties.OversizeHandling)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_IPSetForwardedIPConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fallbackBehavior", cdk.requiredValidator)(properties.fallbackBehavior)), errors.collect(cdk.propertyValidator("fallbackBehavior", cdk.validateString)(properties.fallbackBehavior)), errors.collect(cdk.propertyValidator("headerName", cdk.requiredValidator)(properties.headerName)), errors.collect(cdk.propertyValidator("headerName", cdk.validateString)(properties.headerName)), errors.collect(cdk.propertyValidator("position", cdk.requiredValidator)(properties.position)), errors.collect(cdk.propertyValidator("position", cdk.validateString)(properties.position)), errors.wrap('supplied properties not correct for "IPSetForwardedIPConfigurationProperty"');
    }
    function cfnRuleGroupIPSetForwardedIPConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_IPSetForwardedIPConfigurationPropertyValidator(properties).assertSuccess(), { FallbackBehavior: cdk.stringToCloudFormation(properties.fallbackBehavior), HeaderName: cdk.stringToCloudFormation(properties.headerName), Position: cdk.stringToCloudFormation(properties.position) }) : properties;
    }
    function CfnRuleGroupIPSetForwardedIPConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fallbackBehavior", "FallbackBehavior", cfn_parse.FromCloudFormation.getString(properties.FallbackBehavior)), ret.addPropertyResult("headerName", "HeaderName", cfn_parse.FromCloudFormation.getString(properties.HeaderName)), ret.addPropertyResult("position", "Position", cfn_parse.FromCloudFormation.getString(properties.Position)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_IPSetReferenceStatementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.requiredValidator)(properties.arn)), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("ipSetForwardedIpConfig", CfnRuleGroup_IPSetForwardedIPConfigurationPropertyValidator)(properties.ipSetForwardedIpConfig)), errors.wrap('supplied properties not correct for "IPSetReferenceStatementProperty"');
    }
    function cfnRuleGroupIPSetReferenceStatementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_IPSetReferenceStatementPropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn), IPSetForwardedIPConfig: cfnRuleGroupIPSetForwardedIPConfigurationPropertyToCloudFormation(properties.ipSetForwardedIpConfig) }) : properties;
    }
    function CfnRuleGroupIPSetReferenceStatementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", cfn_parse.FromCloudFormation.getString(properties.Arn)), ret.addPropertyResult("ipSetForwardedIpConfig", "IPSetForwardedIPConfig", properties.IPSetForwardedIPConfig != null ? CfnRuleGroupIPSetForwardedIPConfigurationPropertyFromCloudFormation(properties.IPSetForwardedIPConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_ImmunityTimePropertyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("immunityTime", cdk.requiredValidator)(properties.immunityTime)), errors.collect(cdk.propertyValidator("immunityTime", cdk.validateNumber)(properties.immunityTime)), errors.wrap('supplied properties not correct for "ImmunityTimePropertyProperty"');
    }
    function cfnRuleGroupImmunityTimePropertyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_ImmunityTimePropertyPropertyValidator(properties).assertSuccess(), { ImmunityTime: cdk.numberToCloudFormation(properties.immunityTime) }) : properties;
    }
    function CfnRuleGroupImmunityTimePropertyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("immunityTime", "ImmunityTime", cfn_parse.FromCloudFormation.getNumber(properties.ImmunityTime)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_JsonBodyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("invalidFallbackBehavior", cdk.validateString)(properties.invalidFallbackBehavior)), errors.collect(cdk.propertyValidator("matchPattern", cdk.requiredValidator)(properties.matchPattern)), errors.collect(cdk.propertyValidator("matchPattern", CfnRuleGroup_JsonMatchPatternPropertyValidator)(properties.matchPattern)), errors.collect(cdk.propertyValidator("matchScope", cdk.requiredValidator)(properties.matchScope)), errors.collect(cdk.propertyValidator("matchScope", cdk.validateString)(properties.matchScope)), errors.collect(cdk.propertyValidator("oversizeHandling", cdk.validateString)(properties.oversizeHandling)), errors.wrap('supplied properties not correct for "JsonBodyProperty"');
    }
    function cfnRuleGroupJsonBodyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_JsonBodyPropertyValidator(properties).assertSuccess(), { InvalidFallbackBehavior: cdk.stringToCloudFormation(properties.invalidFallbackBehavior), MatchPattern: cfnRuleGroupJsonMatchPatternPropertyToCloudFormation(properties.matchPattern), MatchScope: cdk.stringToCloudFormation(properties.matchScope), OversizeHandling: cdk.stringToCloudFormation(properties.oversizeHandling) }) : properties;
    }
    function CfnRuleGroupJsonBodyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("invalidFallbackBehavior", "InvalidFallbackBehavior", properties.InvalidFallbackBehavior != null ? cfn_parse.FromCloudFormation.getString(properties.InvalidFallbackBehavior) : void 0), ret.addPropertyResult("matchPattern", "MatchPattern", CfnRuleGroupJsonMatchPatternPropertyFromCloudFormation(properties.MatchPattern)), ret.addPropertyResult("matchScope", "MatchScope", cfn_parse.FromCloudFormation.getString(properties.MatchScope)), ret.addPropertyResult("oversizeHandling", "OversizeHandling", properties.OversizeHandling != null ? cfn_parse.FromCloudFormation.getString(properties.OversizeHandling) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_JsonMatchPatternPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("all", cdk.validateObject)(properties.all)), errors.collect(cdk.propertyValidator("includedPaths", cdk.listValidator(cdk.validateString))(properties.includedPaths)), errors.wrap('supplied properties not correct for "JsonMatchPatternProperty"');
    }
    function cfnRuleGroupJsonMatchPatternPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_JsonMatchPatternPropertyValidator(properties).assertSuccess(), { All: cdk.objectToCloudFormation(properties.all), IncludedPaths: cdk.listMapper(cdk.stringToCloudFormation)(properties.includedPaths) }) : properties;
    }
    function CfnRuleGroupJsonMatchPatternPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("all", "All", properties.All != null ? cfn_parse.FromCloudFormation.getAny(properties.All) : void 0), ret.addPropertyResult("includedPaths", "IncludedPaths", properties.IncludedPaths != null ? cfn_parse.FromCloudFormation.getStringArray(properties.IncludedPaths) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_LabelPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "LabelProperty"');
    }
    function cfnRuleGroupLabelPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_LabelPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnRuleGroupLabelPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_LabelMatchStatementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("scope", cdk.requiredValidator)(properties.scope)), errors.collect(cdk.propertyValidator("scope", cdk.validateString)(properties.scope)), errors.wrap('supplied properties not correct for "LabelMatchStatementProperty"');
    }
    function cfnRuleGroupLabelMatchStatementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_LabelMatchStatementPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Scope: cdk.stringToCloudFormation(properties.scope) }) : properties;
    }
    function CfnRuleGroupLabelMatchStatementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("scope", "Scope", cfn_parse.FromCloudFormation.getString(properties.Scope)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_LabelSummaryPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "LabelSummaryProperty"');
    }
    function cfnRuleGroupLabelSummaryPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_LabelSummaryPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnRuleGroupLabelSummaryPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_NotStatementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("statement", cdk.requiredValidator)(properties.statement)), errors.collect(cdk.propertyValidator("statement", CfnRuleGroup_StatementPropertyValidator)(properties.statement)), errors.wrap('supplied properties not correct for "NotStatementProperty"');
    }
    function cfnRuleGroupNotStatementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_NotStatementPropertyValidator(properties).assertSuccess(), { Statement: cfnRuleGroupStatementPropertyToCloudFormation(properties.statement) }) : properties;
    }
    function CfnRuleGroupNotStatementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("statement", "Statement", CfnRuleGroupStatementPropertyFromCloudFormation(properties.Statement)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_OrStatementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("statements", cdk.requiredValidator)(properties.statements)), errors.collect(cdk.propertyValidator("statements", cdk.listValidator(CfnRuleGroup_StatementPropertyValidator))(properties.statements)), errors.wrap('supplied properties not correct for "OrStatementProperty"');
    }
    function cfnRuleGroupOrStatementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_OrStatementPropertyValidator(properties).assertSuccess(), { Statements: cdk.listMapper(cfnRuleGroupStatementPropertyToCloudFormation)(properties.statements) }) : properties;
    }
    function CfnRuleGroupOrStatementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("statements", "Statements", cfn_parse.FromCloudFormation.getArray(CfnRuleGroupStatementPropertyFromCloudFormation)(properties.Statements)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_RateBasedStatementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregateKeyType", cdk.requiredValidator)(properties.aggregateKeyType)), errors.collect(cdk.propertyValidator("aggregateKeyType", cdk.validateString)(properties.aggregateKeyType)), errors.collect(cdk.propertyValidator("forwardedIpConfig", CfnRuleGroup_ForwardedIPConfigurationPropertyValidator)(properties.forwardedIpConfig)), errors.collect(cdk.propertyValidator("limit", cdk.requiredValidator)(properties.limit)), errors.collect(cdk.propertyValidator("limit", cdk.validateNumber)(properties.limit)), errors.collect(cdk.propertyValidator("scopeDownStatement", CfnRuleGroup_StatementPropertyValidator)(properties.scopeDownStatement)), errors.wrap('supplied properties not correct for "RateBasedStatementProperty"');
    }
    function cfnRuleGroupRateBasedStatementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_RateBasedStatementPropertyValidator(properties).assertSuccess(), { AggregateKeyType: cdk.stringToCloudFormation(properties.aggregateKeyType), ForwardedIPConfig: cfnRuleGroupForwardedIPConfigurationPropertyToCloudFormation(properties.forwardedIpConfig), Limit: cdk.numberToCloudFormation(properties.limit), ScopeDownStatement: cfnRuleGroupStatementPropertyToCloudFormation(properties.scopeDownStatement) }) : properties;
    }
    function CfnRuleGroupRateBasedStatementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregateKeyType", "AggregateKeyType", cfn_parse.FromCloudFormation.getString(properties.AggregateKeyType)), ret.addPropertyResult("forwardedIpConfig", "ForwardedIPConfig", properties.ForwardedIPConfig != null ? CfnRuleGroupForwardedIPConfigurationPropertyFromCloudFormation(properties.ForwardedIPConfig) : void 0), ret.addPropertyResult("limit", "Limit", cfn_parse.FromCloudFormation.getNumber(properties.Limit)), ret.addPropertyResult("scopeDownStatement", "ScopeDownStatement", properties.ScopeDownStatement != null ? CfnRuleGroupStatementPropertyFromCloudFormation(properties.ScopeDownStatement) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_RegexMatchStatementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldToMatch", cdk.requiredValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("fieldToMatch", CfnRuleGroup_FieldToMatchPropertyValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("regexString", cdk.requiredValidator)(properties.regexString)), errors.collect(cdk.propertyValidator("regexString", cdk.validateString)(properties.regexString)), errors.collect(cdk.propertyValidator("textTransformations", cdk.requiredValidator)(properties.textTransformations)), errors.collect(cdk.propertyValidator("textTransformations", cdk.listValidator(CfnRuleGroup_TextTransformationPropertyValidator))(properties.textTransformations)), errors.wrap('supplied properties not correct for "RegexMatchStatementProperty"');
    }
    function cfnRuleGroupRegexMatchStatementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_RegexMatchStatementPropertyValidator(properties).assertSuccess(), { FieldToMatch: cfnRuleGroupFieldToMatchPropertyToCloudFormation(properties.fieldToMatch), RegexString: cdk.stringToCloudFormation(properties.regexString), TextTransformations: cdk.listMapper(cfnRuleGroupTextTransformationPropertyToCloudFormation)(properties.textTransformations) }) : properties;
    }
    function CfnRuleGroupRegexMatchStatementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldToMatch", "FieldToMatch", CfnRuleGroupFieldToMatchPropertyFromCloudFormation(properties.FieldToMatch)), ret.addPropertyResult("regexString", "RegexString", cfn_parse.FromCloudFormation.getString(properties.RegexString)), ret.addPropertyResult("textTransformations", "TextTransformations", cfn_parse.FromCloudFormation.getArray(CfnRuleGroupTextTransformationPropertyFromCloudFormation)(properties.TextTransformations)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_RegexPatternSetReferenceStatementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.requiredValidator)(properties.arn)), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("fieldToMatch", cdk.requiredValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("fieldToMatch", CfnRuleGroup_FieldToMatchPropertyValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("textTransformations", cdk.requiredValidator)(properties.textTransformations)), errors.collect(cdk.propertyValidator("textTransformations", cdk.listValidator(CfnRuleGroup_TextTransformationPropertyValidator))(properties.textTransformations)), errors.wrap('supplied properties not correct for "RegexPatternSetReferenceStatementProperty"');
    }
    function cfnRuleGroupRegexPatternSetReferenceStatementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_RegexPatternSetReferenceStatementPropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn), FieldToMatch: cfnRuleGroupFieldToMatchPropertyToCloudFormation(properties.fieldToMatch), TextTransformations: cdk.listMapper(cfnRuleGroupTextTransformationPropertyToCloudFormation)(properties.textTransformations) }) : properties;
    }
    function CfnRuleGroupRegexPatternSetReferenceStatementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", cfn_parse.FromCloudFormation.getString(properties.Arn)), ret.addPropertyResult("fieldToMatch", "FieldToMatch", CfnRuleGroupFieldToMatchPropertyFromCloudFormation(properties.FieldToMatch)), ret.addPropertyResult("textTransformations", "TextTransformations", cfn_parse.FromCloudFormation.getArray(CfnRuleGroupTextTransformationPropertyFromCloudFormation)(properties.TextTransformations)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_RulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", CfnRuleGroup_RuleActionPropertyValidator)(properties.action)), errors.collect(cdk.propertyValidator("captchaConfig", CfnRuleGroup_CaptchaConfigPropertyValidator)(properties.captchaConfig)), errors.collect(cdk.propertyValidator("challengeConfig", CfnRuleGroup_ChallengeConfigPropertyValidator)(properties.challengeConfig)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("priority", cdk.requiredValidator)(properties.priority)), errors.collect(cdk.propertyValidator("priority", cdk.validateNumber)(properties.priority)), errors.collect(cdk.propertyValidator("ruleLabels", cdk.listValidator(CfnRuleGroup_LabelPropertyValidator))(properties.ruleLabels)), errors.collect(cdk.propertyValidator("statement", cdk.requiredValidator)(properties.statement)), errors.collect(cdk.propertyValidator("statement", CfnRuleGroup_StatementPropertyValidator)(properties.statement)), errors.collect(cdk.propertyValidator("visibilityConfig", cdk.requiredValidator)(properties.visibilityConfig)), errors.collect(cdk.propertyValidator("visibilityConfig", CfnRuleGroup_VisibilityConfigPropertyValidator)(properties.visibilityConfig)), errors.wrap('supplied properties not correct for "RuleProperty"');
    }
    function cfnRuleGroupRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_RulePropertyValidator(properties).assertSuccess(), { Action: cfnRuleGroupRuleActionPropertyToCloudFormation(properties.action), CaptchaConfig: cfnRuleGroupCaptchaConfigPropertyToCloudFormation(properties.captchaConfig), ChallengeConfig: cfnRuleGroupChallengeConfigPropertyToCloudFormation(properties.challengeConfig), Name: cdk.stringToCloudFormation(properties.name), Priority: cdk.numberToCloudFormation(properties.priority), RuleLabels: cdk.listMapper(cfnRuleGroupLabelPropertyToCloudFormation)(properties.ruleLabels), Statement: cfnRuleGroupStatementPropertyToCloudFormation(properties.statement), VisibilityConfig: cfnRuleGroupVisibilityConfigPropertyToCloudFormation(properties.visibilityConfig) }) : properties;
    }
    function CfnRuleGroupRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", properties.Action != null ? CfnRuleGroupRuleActionPropertyFromCloudFormation(properties.Action) : void 0), ret.addPropertyResult("captchaConfig", "CaptchaConfig", properties.CaptchaConfig != null ? CfnRuleGroupCaptchaConfigPropertyFromCloudFormation(properties.CaptchaConfig) : void 0), ret.addPropertyResult("challengeConfig", "ChallengeConfig", properties.ChallengeConfig != null ? CfnRuleGroupChallengeConfigPropertyFromCloudFormation(properties.ChallengeConfig) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("priority", "Priority", cfn_parse.FromCloudFormation.getNumber(properties.Priority)), ret.addPropertyResult("ruleLabels", "RuleLabels", properties.RuleLabels != null ? cfn_parse.FromCloudFormation.getArray(CfnRuleGroupLabelPropertyFromCloudFormation)(properties.RuleLabels) : void 0), ret.addPropertyResult("statement", "Statement", CfnRuleGroupStatementPropertyFromCloudFormation(properties.Statement)), ret.addPropertyResult("visibilityConfig", "VisibilityConfig", CfnRuleGroupVisibilityConfigPropertyFromCloudFormation(properties.VisibilityConfig)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_RuleActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allow", cdk.validateObject)(properties.allow)), errors.collect(cdk.propertyValidator("block", cdk.validateObject)(properties.block)), errors.collect(cdk.propertyValidator("captcha", cdk.validateObject)(properties.captcha)), errors.collect(cdk.propertyValidator("challenge", cdk.validateObject)(properties.challenge)), errors.collect(cdk.propertyValidator("count", cdk.validateObject)(properties.count)), errors.wrap('supplied properties not correct for "RuleActionProperty"');
    }
    function cfnRuleGroupRuleActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_RuleActionPropertyValidator(properties).assertSuccess(), { Allow: cdk.objectToCloudFormation(properties.allow), Block: cdk.objectToCloudFormation(properties.block), Captcha: cdk.objectToCloudFormation(properties.captcha), Challenge: cdk.objectToCloudFormation(properties.challenge), Count: cdk.objectToCloudFormation(properties.count) }) : properties;
    }
    function CfnRuleGroupRuleActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allow", "Allow", properties.Allow != null ? cfn_parse.FromCloudFormation.getAny(properties.Allow) : void 0), ret.addPropertyResult("block", "Block", properties.Block != null ? cfn_parse.FromCloudFormation.getAny(properties.Block) : void 0), ret.addPropertyResult("captcha", "Captcha", properties.Captcha != null ? cfn_parse.FromCloudFormation.getAny(properties.Captcha) : void 0), ret.addPropertyResult("challenge", "Challenge", properties.Challenge != null ? cfn_parse.FromCloudFormation.getAny(properties.Challenge) : void 0), ret.addPropertyResult("count", "Count", properties.Count != null ? cfn_parse.FromCloudFormation.getAny(properties.Count) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_SizeConstraintStatementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("comparisonOperator", cdk.requiredValidator)(properties.comparisonOperator)), errors.collect(cdk.propertyValidator("comparisonOperator", cdk.validateString)(properties.comparisonOperator)), errors.collect(cdk.propertyValidator("fieldToMatch", cdk.requiredValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("fieldToMatch", CfnRuleGroup_FieldToMatchPropertyValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("size", cdk.requiredValidator)(properties.size)), errors.collect(cdk.propertyValidator("size", cdk.validateNumber)(properties.size)), errors.collect(cdk.propertyValidator("textTransformations", cdk.requiredValidator)(properties.textTransformations)), errors.collect(cdk.propertyValidator("textTransformations", cdk.listValidator(CfnRuleGroup_TextTransformationPropertyValidator))(properties.textTransformations)), errors.wrap('supplied properties not correct for "SizeConstraintStatementProperty"');
    }
    function cfnRuleGroupSizeConstraintStatementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_SizeConstraintStatementPropertyValidator(properties).assertSuccess(), { ComparisonOperator: cdk.stringToCloudFormation(properties.comparisonOperator), FieldToMatch: cfnRuleGroupFieldToMatchPropertyToCloudFormation(properties.fieldToMatch), Size: cdk.numberToCloudFormation(properties.size), TextTransformations: cdk.listMapper(cfnRuleGroupTextTransformationPropertyToCloudFormation)(properties.textTransformations) }) : properties;
    }
    function CfnRuleGroupSizeConstraintStatementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("comparisonOperator", "ComparisonOperator", cfn_parse.FromCloudFormation.getString(properties.ComparisonOperator)), ret.addPropertyResult("fieldToMatch", "FieldToMatch", CfnRuleGroupFieldToMatchPropertyFromCloudFormation(properties.FieldToMatch)), ret.addPropertyResult("size", "Size", cfn_parse.FromCloudFormation.getNumber(properties.Size)), ret.addPropertyResult("textTransformations", "TextTransformations", cfn_parse.FromCloudFormation.getArray(CfnRuleGroupTextTransformationPropertyFromCloudFormation)(properties.TextTransformations)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_SqliMatchStatementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldToMatch", cdk.requiredValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("fieldToMatch", CfnRuleGroup_FieldToMatchPropertyValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("sensitivityLevel", cdk.validateString)(properties.sensitivityLevel)), errors.collect(cdk.propertyValidator("textTransformations", cdk.requiredValidator)(properties.textTransformations)), errors.collect(cdk.propertyValidator("textTransformations", cdk.listValidator(CfnRuleGroup_TextTransformationPropertyValidator))(properties.textTransformations)), errors.wrap('supplied properties not correct for "SqliMatchStatementProperty"');
    }
    function cfnRuleGroupSqliMatchStatementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_SqliMatchStatementPropertyValidator(properties).assertSuccess(), { FieldToMatch: cfnRuleGroupFieldToMatchPropertyToCloudFormation(properties.fieldToMatch), SensitivityLevel: cdk.stringToCloudFormation(properties.sensitivityLevel), TextTransformations: cdk.listMapper(cfnRuleGroupTextTransformationPropertyToCloudFormation)(properties.textTransformations) }) : properties;
    }
    function CfnRuleGroupSqliMatchStatementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldToMatch", "FieldToMatch", CfnRuleGroupFieldToMatchPropertyFromCloudFormation(properties.FieldToMatch)), ret.addPropertyResult("sensitivityLevel", "SensitivityLevel", properties.SensitivityLevel != null ? cfn_parse.FromCloudFormation.getString(properties.SensitivityLevel) : void 0), ret.addPropertyResult("textTransformations", "TextTransformations", cfn_parse.FromCloudFormation.getArray(CfnRuleGroupTextTransformationPropertyFromCloudFormation)(properties.TextTransformations)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_StatementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("andStatement", CfnRuleGroup_AndStatementPropertyValidator)(properties.andStatement)), errors.collect(cdk.propertyValidator("byteMatchStatement", CfnRuleGroup_ByteMatchStatementPropertyValidator)(properties.byteMatchStatement)), errors.collect(cdk.propertyValidator("geoMatchStatement", CfnRuleGroup_GeoMatchStatementPropertyValidator)(properties.geoMatchStatement)), errors.collect(cdk.propertyValidator("ipSetReferenceStatement", CfnRuleGroup_IPSetReferenceStatementPropertyValidator)(properties.ipSetReferenceStatement)), errors.collect(cdk.propertyValidator("labelMatchStatement", CfnRuleGroup_LabelMatchStatementPropertyValidator)(properties.labelMatchStatement)), errors.collect(cdk.propertyValidator("notStatement", CfnRuleGroup_NotStatementPropertyValidator)(properties.notStatement)), errors.collect(cdk.propertyValidator("orStatement", CfnRuleGroup_OrStatementPropertyValidator)(properties.orStatement)), errors.collect(cdk.propertyValidator("rateBasedStatement", CfnRuleGroup_RateBasedStatementPropertyValidator)(properties.rateBasedStatement)), errors.collect(cdk.propertyValidator("regexMatchStatement", CfnRuleGroup_RegexMatchStatementPropertyValidator)(properties.regexMatchStatement)), errors.collect(cdk.propertyValidator("regexPatternSetReferenceStatement", CfnRuleGroup_RegexPatternSetReferenceStatementPropertyValidator)(properties.regexPatternSetReferenceStatement)), errors.collect(cdk.propertyValidator("sizeConstraintStatement", CfnRuleGroup_SizeConstraintStatementPropertyValidator)(properties.sizeConstraintStatement)), errors.collect(cdk.propertyValidator("sqliMatchStatement", CfnRuleGroup_SqliMatchStatementPropertyValidator)(properties.sqliMatchStatement)), errors.collect(cdk.propertyValidator("xssMatchStatement", CfnRuleGroup_XssMatchStatementPropertyValidator)(properties.xssMatchStatement)), errors.wrap('supplied properties not correct for "StatementProperty"');
    }
    function cfnRuleGroupStatementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_StatementPropertyValidator(properties).assertSuccess(), { AndStatement: cfnRuleGroupAndStatementPropertyToCloudFormation(properties.andStatement), ByteMatchStatement: cfnRuleGroupByteMatchStatementPropertyToCloudFormation(properties.byteMatchStatement), GeoMatchStatement: cfnRuleGroupGeoMatchStatementPropertyToCloudFormation(properties.geoMatchStatement), IPSetReferenceStatement: cfnRuleGroupIPSetReferenceStatementPropertyToCloudFormation(properties.ipSetReferenceStatement), LabelMatchStatement: cfnRuleGroupLabelMatchStatementPropertyToCloudFormation(properties.labelMatchStatement), NotStatement: cfnRuleGroupNotStatementPropertyToCloudFormation(properties.notStatement), OrStatement: cfnRuleGroupOrStatementPropertyToCloudFormation(properties.orStatement), RateBasedStatement: cfnRuleGroupRateBasedStatementPropertyToCloudFormation(properties.rateBasedStatement), RegexMatchStatement: cfnRuleGroupRegexMatchStatementPropertyToCloudFormation(properties.regexMatchStatement), RegexPatternSetReferenceStatement: cfnRuleGroupRegexPatternSetReferenceStatementPropertyToCloudFormation(properties.regexPatternSetReferenceStatement), SizeConstraintStatement: cfnRuleGroupSizeConstraintStatementPropertyToCloudFormation(properties.sizeConstraintStatement), SqliMatchStatement: cfnRuleGroupSqliMatchStatementPropertyToCloudFormation(properties.sqliMatchStatement), XssMatchStatement: cfnRuleGroupXssMatchStatementPropertyToCloudFormation(properties.xssMatchStatement) }) : properties;
    }
    function CfnRuleGroupStatementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("andStatement", "AndStatement", properties.AndStatement != null ? CfnRuleGroupAndStatementPropertyFromCloudFormation(properties.AndStatement) : void 0), ret.addPropertyResult("byteMatchStatement", "ByteMatchStatement", properties.ByteMatchStatement != null ? CfnRuleGroupByteMatchStatementPropertyFromCloudFormation(properties.ByteMatchStatement) : void 0), ret.addPropertyResult("geoMatchStatement", "GeoMatchStatement", properties.GeoMatchStatement != null ? CfnRuleGroupGeoMatchStatementPropertyFromCloudFormation(properties.GeoMatchStatement) : void 0), ret.addPropertyResult("ipSetReferenceStatement", "IPSetReferenceStatement", properties.IPSetReferenceStatement != null ? CfnRuleGroupIPSetReferenceStatementPropertyFromCloudFormation(properties.IPSetReferenceStatement) : void 0), ret.addPropertyResult("labelMatchStatement", "LabelMatchStatement", properties.LabelMatchStatement != null ? CfnRuleGroupLabelMatchStatementPropertyFromCloudFormation(properties.LabelMatchStatement) : void 0), ret.addPropertyResult("notStatement", "NotStatement", properties.NotStatement != null ? CfnRuleGroupNotStatementPropertyFromCloudFormation(properties.NotStatement) : void 0), ret.addPropertyResult("orStatement", "OrStatement", properties.OrStatement != null ? CfnRuleGroupOrStatementPropertyFromCloudFormation(properties.OrStatement) : void 0), ret.addPropertyResult("rateBasedStatement", "RateBasedStatement", properties.RateBasedStatement != null ? CfnRuleGroupRateBasedStatementPropertyFromCloudFormation(properties.RateBasedStatement) : void 0), ret.addPropertyResult("regexMatchStatement", "RegexMatchStatement", properties.RegexMatchStatement != null ? CfnRuleGroupRegexMatchStatementPropertyFromCloudFormation(properties.RegexMatchStatement) : void 0), ret.addPropertyResult("regexPatternSetReferenceStatement", "RegexPatternSetReferenceStatement", properties.RegexPatternSetReferenceStatement != null ? CfnRuleGroupRegexPatternSetReferenceStatementPropertyFromCloudFormation(properties.RegexPatternSetReferenceStatement) : void 0), ret.addPropertyResult("sizeConstraintStatement", "SizeConstraintStatement", properties.SizeConstraintStatement != null ? CfnRuleGroupSizeConstraintStatementPropertyFromCloudFormation(properties.SizeConstraintStatement) : void 0), ret.addPropertyResult("sqliMatchStatement", "SqliMatchStatement", properties.SqliMatchStatement != null ? CfnRuleGroupSqliMatchStatementPropertyFromCloudFormation(properties.SqliMatchStatement) : void 0), ret.addPropertyResult("xssMatchStatement", "XssMatchStatement", properties.XssMatchStatement != null ? CfnRuleGroupXssMatchStatementPropertyFromCloudFormation(properties.XssMatchStatement) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_TextTransformationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("priority", cdk.requiredValidator)(properties.priority)), errors.collect(cdk.propertyValidator("priority", cdk.validateNumber)(properties.priority)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "TextTransformationProperty"');
    }
    function cfnRuleGroupTextTransformationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_TextTransformationPropertyValidator(properties).assertSuccess(), { Priority: cdk.numberToCloudFormation(properties.priority), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnRuleGroupTextTransformationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("priority", "Priority", cfn_parse.FromCloudFormation.getNumber(properties.Priority)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_VisibilityConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchMetricsEnabled", cdk.requiredValidator)(properties.cloudWatchMetricsEnabled)), errors.collect(cdk.propertyValidator("cloudWatchMetricsEnabled", cdk.validateBoolean)(properties.cloudWatchMetricsEnabled)), errors.collect(cdk.propertyValidator("metricName", cdk.requiredValidator)(properties.metricName)), errors.collect(cdk.propertyValidator("metricName", cdk.validateString)(properties.metricName)), errors.collect(cdk.propertyValidator("sampledRequestsEnabled", cdk.requiredValidator)(properties.sampledRequestsEnabled)), errors.collect(cdk.propertyValidator("sampledRequestsEnabled", cdk.validateBoolean)(properties.sampledRequestsEnabled)), errors.wrap('supplied properties not correct for "VisibilityConfigProperty"');
    }
    function cfnRuleGroupVisibilityConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_VisibilityConfigPropertyValidator(properties).assertSuccess(), { CloudWatchMetricsEnabled: cdk.booleanToCloudFormation(properties.cloudWatchMetricsEnabled), MetricName: cdk.stringToCloudFormation(properties.metricName), SampledRequestsEnabled: cdk.booleanToCloudFormation(properties.sampledRequestsEnabled) }) : properties;
    }
    function CfnRuleGroupVisibilityConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchMetricsEnabled", "CloudWatchMetricsEnabled", cfn_parse.FromCloudFormation.getBoolean(properties.CloudWatchMetricsEnabled)), ret.addPropertyResult("metricName", "MetricName", cfn_parse.FromCloudFormation.getString(properties.MetricName)), ret.addPropertyResult("sampledRequestsEnabled", "SampledRequestsEnabled", cfn_parse.FromCloudFormation.getBoolean(properties.SampledRequestsEnabled)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnRuleGroup_XssMatchStatementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldToMatch", cdk.requiredValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("fieldToMatch", CfnRuleGroup_FieldToMatchPropertyValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("textTransformations", cdk.requiredValidator)(properties.textTransformations)), errors.collect(cdk.propertyValidator("textTransformations", cdk.listValidator(CfnRuleGroup_TextTransformationPropertyValidator))(properties.textTransformations)), errors.wrap('supplied properties not correct for "XssMatchStatementProperty"');
    }
    function cfnRuleGroupXssMatchStatementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnRuleGroup_XssMatchStatementPropertyValidator(properties).assertSuccess(), { FieldToMatch: cfnRuleGroupFieldToMatchPropertyToCloudFormation(properties.fieldToMatch), TextTransformations: cdk.listMapper(cfnRuleGroupTextTransformationPropertyToCloudFormation)(properties.textTransformations) }) : properties;
    }
    function CfnRuleGroupXssMatchStatementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldToMatch", "FieldToMatch", CfnRuleGroupFieldToMatchPropertyFromCloudFormation(properties.FieldToMatch)), ret.addPropertyResult("textTransformations", "TextTransformations", cfn_parse.FromCloudFormation.getArray(CfnRuleGroupTextTransformationPropertyFromCloudFormation)(properties.TextTransformations)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACLPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("captchaConfig", CfnWebACL_CaptchaConfigPropertyValidator)(properties.captchaConfig)), errors.collect(cdk.propertyValidator("challengeConfig", CfnWebACL_ChallengeConfigPropertyValidator)(properties.challengeConfig)), errors.collect(cdk.propertyValidator("customResponseBodies", cdk.hashValidator(CfnWebACL_CustomResponseBodyPropertyValidator))(properties.customResponseBodies)), errors.collect(cdk.propertyValidator("defaultAction", cdk.requiredValidator)(properties.defaultAction)), errors.collect(cdk.propertyValidator("defaultAction", CfnWebACL_DefaultActionPropertyValidator)(properties.defaultAction)), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("rules", cdk.listValidator(CfnWebACL_RulePropertyValidator))(properties.rules)), errors.collect(cdk.propertyValidator("scope", cdk.requiredValidator)(properties.scope)), errors.collect(cdk.propertyValidator("scope", cdk.validateString)(properties.scope)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("tokenDomains", cdk.listValidator(cdk.validateString))(properties.tokenDomains)), errors.collect(cdk.propertyValidator("visibilityConfig", cdk.requiredValidator)(properties.visibilityConfig)), errors.collect(cdk.propertyValidator("visibilityConfig", CfnWebACL_VisibilityConfigPropertyValidator)(properties.visibilityConfig)), errors.wrap('supplied properties not correct for "CfnWebACLProps"');
    }
    function cfnWebACLPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACLPropsValidator(properties).assertSuccess(), { DefaultAction: cfnWebACLDefaultActionPropertyToCloudFormation(properties.defaultAction), Scope: cdk.stringToCloudFormation(properties.scope), VisibilityConfig: cfnWebACLVisibilityConfigPropertyToCloudFormation(properties.visibilityConfig), CaptchaConfig: cfnWebACLCaptchaConfigPropertyToCloudFormation(properties.captchaConfig), ChallengeConfig: cfnWebACLChallengeConfigPropertyToCloudFormation(properties.challengeConfig), CustomResponseBodies: cdk.hashMapper(cfnWebACLCustomResponseBodyPropertyToCloudFormation)(properties.customResponseBodies), Description: cdk.stringToCloudFormation(properties.description), Name: cdk.stringToCloudFormation(properties.name), Rules: cdk.listMapper(cfnWebACLRulePropertyToCloudFormation)(properties.rules), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), TokenDomains: cdk.listMapper(cdk.stringToCloudFormation)(properties.tokenDomains) }) : properties;
    }
    function CfnWebACLPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("defaultAction", "DefaultAction", CfnWebACLDefaultActionPropertyFromCloudFormation(properties.DefaultAction)), ret.addPropertyResult("scope", "Scope", cfn_parse.FromCloudFormation.getString(properties.Scope)), ret.addPropertyResult("visibilityConfig", "VisibilityConfig", CfnWebACLVisibilityConfigPropertyFromCloudFormation(properties.VisibilityConfig)), ret.addPropertyResult("captchaConfig", "CaptchaConfig", properties.CaptchaConfig != null ? CfnWebACLCaptchaConfigPropertyFromCloudFormation(properties.CaptchaConfig) : void 0), ret.addPropertyResult("challengeConfig", "ChallengeConfig", properties.ChallengeConfig != null ? CfnWebACLChallengeConfigPropertyFromCloudFormation(properties.ChallengeConfig) : void 0), ret.addPropertyResult("customResponseBodies", "CustomResponseBodies", properties.CustomResponseBodies != null ? cfn_parse.FromCloudFormation.getMap(CfnWebACLCustomResponseBodyPropertyFromCloudFormation)(properties.CustomResponseBodies) : void 0), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("name", "Name", properties.Name != null ? cfn_parse.FromCloudFormation.getString(properties.Name) : void 0), ret.addPropertyResult("rules", "Rules", properties.Rules != null ? cfn_parse.FromCloudFormation.getArray(CfnWebACLRulePropertyFromCloudFormation)(properties.Rules) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("tokenDomains", "TokenDomains", properties.TokenDomains != null ? cfn_parse.FromCloudFormation.getStringArray(properties.TokenDomains) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnWebACL = class _CfnWebACL extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnWebACLPropsFromCloudFormation(resourceProperties), ret = new _CfnWebACL(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnWebACL.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_wafv2_CfnWebACLProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnWebACL), error;
        }
        cdk.requireProperty(props, "defaultAction", this), cdk.requireProperty(props, "scope", this), cdk.requireProperty(props, "visibilityConfig", this), this.attrArn = cdk.Token.asString(this.getAtt("Arn", cdk.ResolutionTypeHint.STRING)), this.attrCapacity = cdk.Token.asNumber(this.getAtt("Capacity", cdk.ResolutionTypeHint.NUMBER)), this.attrId = cdk.Token.asString(this.getAtt("Id", cdk.ResolutionTypeHint.STRING)), this.attrLabelNamespace = cdk.Token.asString(this.getAtt("LabelNamespace", cdk.ResolutionTypeHint.STRING)), this.defaultAction = props.defaultAction, this.scope = props.scope, this.visibilityConfig = props.visibilityConfig, this.captchaConfig = props.captchaConfig, this.challengeConfig = props.challengeConfig, this.customResponseBodies = props.customResponseBodies, this.description = props.description, this.name = props.name, this.rules = props.rules, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::WAFv2::WebACL", props.tags, { tagPropertyName: "tags" }), this.tokenDomains = props.tokenDomains;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnWebACL.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { defaultAction: this.defaultAction, scope: this.scope, visibilityConfig: this.visibilityConfig, captchaConfig: this.captchaConfig, challengeConfig: this.challengeConfig, customResponseBodies: this.customResponseBodies, description: this.description, name: this.name, rules: this.rules, tags: this.tags.renderTags(), tokenDomains: this.tokenDomains };
      }
      renderProperties(props) {
        return cfnWebACLPropsToCloudFormation(props);
      }
    };
    _e = JSII_RTTI_SYMBOL_1, CfnWebACL[_e] = { fqn: "aws-cdk-lib.aws_wafv2.CfnWebACL", version: "2.80.0" }, CfnWebACL.CFN_RESOURCE_TYPE_NAME = "AWS::WAFv2::WebACL", exports2.CfnWebACL = CfnWebACL;
    function CfnWebACL_AWSManagedRulesATPRuleSetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("loginPath", cdk.requiredValidator)(properties.loginPath)), errors.collect(cdk.propertyValidator("loginPath", cdk.validateString)(properties.loginPath)), errors.collect(cdk.propertyValidator("requestInspection", CfnWebACL_RequestInspectionPropertyValidator)(properties.requestInspection)), errors.collect(cdk.propertyValidator("responseInspection", CfnWebACL_ResponseInspectionPropertyValidator)(properties.responseInspection)), errors.wrap('supplied properties not correct for "AWSManagedRulesATPRuleSetProperty"');
    }
    function cfnWebACLAWSManagedRulesATPRuleSetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_AWSManagedRulesATPRuleSetPropertyValidator(properties).assertSuccess(), { LoginPath: cdk.stringToCloudFormation(properties.loginPath), RequestInspection: cfnWebACLRequestInspectionPropertyToCloudFormation(properties.requestInspection), ResponseInspection: cfnWebACLResponseInspectionPropertyToCloudFormation(properties.responseInspection) }) : properties;
    }
    function CfnWebACLAWSManagedRulesATPRuleSetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("loginPath", "LoginPath", cfn_parse.FromCloudFormation.getString(properties.LoginPath)), ret.addPropertyResult("requestInspection", "RequestInspection", properties.RequestInspection != null ? CfnWebACLRequestInspectionPropertyFromCloudFormation(properties.RequestInspection) : void 0), ret.addPropertyResult("responseInspection", "ResponseInspection", properties.ResponseInspection != null ? CfnWebACLResponseInspectionPropertyFromCloudFormation(properties.ResponseInspection) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_AWSManagedRulesBotControlRuleSetPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("inspectionLevel", cdk.requiredValidator)(properties.inspectionLevel)), errors.collect(cdk.propertyValidator("inspectionLevel", cdk.validateString)(properties.inspectionLevel)), errors.wrap('supplied properties not correct for "AWSManagedRulesBotControlRuleSetProperty"');
    }
    function cfnWebACLAWSManagedRulesBotControlRuleSetPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_AWSManagedRulesBotControlRuleSetPropertyValidator(properties).assertSuccess(), { InspectionLevel: cdk.stringToCloudFormation(properties.inspectionLevel) }) : properties;
    }
    function CfnWebACLAWSManagedRulesBotControlRuleSetPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("inspectionLevel", "InspectionLevel", cfn_parse.FromCloudFormation.getString(properties.InspectionLevel)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_AllowActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customRequestHandling", CfnWebACL_CustomRequestHandlingPropertyValidator)(properties.customRequestHandling)), errors.wrap('supplied properties not correct for "AllowActionProperty"');
    }
    function cfnWebACLAllowActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_AllowActionPropertyValidator(properties).assertSuccess(), { CustomRequestHandling: cfnWebACLCustomRequestHandlingPropertyToCloudFormation(properties.customRequestHandling) }) : properties;
    }
    function CfnWebACLAllowActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customRequestHandling", "CustomRequestHandling", properties.CustomRequestHandling != null ? CfnWebACLCustomRequestHandlingPropertyFromCloudFormation(properties.CustomRequestHandling) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_AndStatementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("statements", cdk.requiredValidator)(properties.statements)), errors.collect(cdk.propertyValidator("statements", cdk.listValidator(CfnWebACL_StatementPropertyValidator))(properties.statements)), errors.wrap('supplied properties not correct for "AndStatementProperty"');
    }
    function cfnWebACLAndStatementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_AndStatementPropertyValidator(properties).assertSuccess(), { Statements: cdk.listMapper(cfnWebACLStatementPropertyToCloudFormation)(properties.statements) }) : properties;
    }
    function CfnWebACLAndStatementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("statements", "Statements", cfn_parse.FromCloudFormation.getArray(CfnWebACLStatementPropertyFromCloudFormation)(properties.Statements)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_BlockActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customResponse", CfnWebACL_CustomResponsePropertyValidator)(properties.customResponse)), errors.wrap('supplied properties not correct for "BlockActionProperty"');
    }
    function cfnWebACLBlockActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_BlockActionPropertyValidator(properties).assertSuccess(), { CustomResponse: cfnWebACLCustomResponsePropertyToCloudFormation(properties.customResponse) }) : properties;
    }
    function CfnWebACLBlockActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customResponse", "CustomResponse", properties.CustomResponse != null ? CfnWebACLCustomResponsePropertyFromCloudFormation(properties.CustomResponse) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_BodyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("oversizeHandling", cdk.validateString)(properties.oversizeHandling)), errors.wrap('supplied properties not correct for "BodyProperty"');
    }
    function cfnWebACLBodyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_BodyPropertyValidator(properties).assertSuccess(), { OversizeHandling: cdk.stringToCloudFormation(properties.oversizeHandling) }) : properties;
    }
    function CfnWebACLBodyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("oversizeHandling", "OversizeHandling", properties.OversizeHandling != null ? cfn_parse.FromCloudFormation.getString(properties.OversizeHandling) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_ByteMatchStatementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldToMatch", cdk.requiredValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("fieldToMatch", CfnWebACL_FieldToMatchPropertyValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("positionalConstraint", cdk.requiredValidator)(properties.positionalConstraint)), errors.collect(cdk.propertyValidator("positionalConstraint", cdk.validateString)(properties.positionalConstraint)), errors.collect(cdk.propertyValidator("searchString", cdk.validateString)(properties.searchString)), errors.collect(cdk.propertyValidator("searchStringBase64", cdk.validateString)(properties.searchStringBase64)), errors.collect(cdk.propertyValidator("textTransformations", cdk.requiredValidator)(properties.textTransformations)), errors.collect(cdk.propertyValidator("textTransformations", cdk.listValidator(CfnWebACL_TextTransformationPropertyValidator))(properties.textTransformations)), errors.wrap('supplied properties not correct for "ByteMatchStatementProperty"');
    }
    function cfnWebACLByteMatchStatementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_ByteMatchStatementPropertyValidator(properties).assertSuccess(), { FieldToMatch: cfnWebACLFieldToMatchPropertyToCloudFormation(properties.fieldToMatch), PositionalConstraint: cdk.stringToCloudFormation(properties.positionalConstraint), SearchString: cdk.stringToCloudFormation(properties.searchString), SearchStringBase64: cdk.stringToCloudFormation(properties.searchStringBase64), TextTransformations: cdk.listMapper(cfnWebACLTextTransformationPropertyToCloudFormation)(properties.textTransformations) }) : properties;
    }
    function CfnWebACLByteMatchStatementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldToMatch", "FieldToMatch", CfnWebACLFieldToMatchPropertyFromCloudFormation(properties.FieldToMatch)), ret.addPropertyResult("positionalConstraint", "PositionalConstraint", cfn_parse.FromCloudFormation.getString(properties.PositionalConstraint)), ret.addPropertyResult("searchString", "SearchString", properties.SearchString != null ? cfn_parse.FromCloudFormation.getString(properties.SearchString) : void 0), ret.addPropertyResult("searchStringBase64", "SearchStringBase64", properties.SearchStringBase64 != null ? cfn_parse.FromCloudFormation.getString(properties.SearchStringBase64) : void 0), ret.addPropertyResult("textTransformations", "TextTransformations", cfn_parse.FromCloudFormation.getArray(CfnWebACLTextTransformationPropertyFromCloudFormation)(properties.TextTransformations)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_CaptchaActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customRequestHandling", CfnWebACL_CustomRequestHandlingPropertyValidator)(properties.customRequestHandling)), errors.wrap('supplied properties not correct for "CaptchaActionProperty"');
    }
    function cfnWebACLCaptchaActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_CaptchaActionPropertyValidator(properties).assertSuccess(), { CustomRequestHandling: cfnWebACLCustomRequestHandlingPropertyToCloudFormation(properties.customRequestHandling) }) : properties;
    }
    function CfnWebACLCaptchaActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customRequestHandling", "CustomRequestHandling", properties.CustomRequestHandling != null ? CfnWebACLCustomRequestHandlingPropertyFromCloudFormation(properties.CustomRequestHandling) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_CaptchaConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("immunityTimeProperty", CfnWebACL_ImmunityTimePropertyPropertyValidator)(properties.immunityTimeProperty)), errors.wrap('supplied properties not correct for "CaptchaConfigProperty"');
    }
    function cfnWebACLCaptchaConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_CaptchaConfigPropertyValidator(properties).assertSuccess(), { ImmunityTimeProperty: cfnWebACLImmunityTimePropertyPropertyToCloudFormation(properties.immunityTimeProperty) }) : properties;
    }
    function CfnWebACLCaptchaConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("immunityTimeProperty", "ImmunityTimeProperty", properties.ImmunityTimeProperty != null ? CfnWebACLImmunityTimePropertyPropertyFromCloudFormation(properties.ImmunityTimeProperty) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_ChallengeActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customRequestHandling", CfnWebACL_CustomRequestHandlingPropertyValidator)(properties.customRequestHandling)), errors.wrap('supplied properties not correct for "ChallengeActionProperty"');
    }
    function cfnWebACLChallengeActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_ChallengeActionPropertyValidator(properties).assertSuccess(), { CustomRequestHandling: cfnWebACLCustomRequestHandlingPropertyToCloudFormation(properties.customRequestHandling) }) : properties;
    }
    function CfnWebACLChallengeActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customRequestHandling", "CustomRequestHandling", properties.CustomRequestHandling != null ? CfnWebACLCustomRequestHandlingPropertyFromCloudFormation(properties.CustomRequestHandling) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_ChallengeConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("immunityTimeProperty", CfnWebACL_ImmunityTimePropertyPropertyValidator)(properties.immunityTimeProperty)), errors.wrap('supplied properties not correct for "ChallengeConfigProperty"');
    }
    function cfnWebACLChallengeConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_ChallengeConfigPropertyValidator(properties).assertSuccess(), { ImmunityTimeProperty: cfnWebACLImmunityTimePropertyPropertyToCloudFormation(properties.immunityTimeProperty) }) : properties;
    }
    function CfnWebACLChallengeConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("immunityTimeProperty", "ImmunityTimeProperty", properties.ImmunityTimeProperty != null ? CfnWebACLImmunityTimePropertyPropertyFromCloudFormation(properties.ImmunityTimeProperty) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_CookieMatchPatternPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("all", cdk.validateObject)(properties.all)), errors.collect(cdk.propertyValidator("excludedCookies", cdk.listValidator(cdk.validateString))(properties.excludedCookies)), errors.collect(cdk.propertyValidator("includedCookies", cdk.listValidator(cdk.validateString))(properties.includedCookies)), errors.wrap('supplied properties not correct for "CookieMatchPatternProperty"');
    }
    function cfnWebACLCookieMatchPatternPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_CookieMatchPatternPropertyValidator(properties).assertSuccess(), { All: cdk.objectToCloudFormation(properties.all), ExcludedCookies: cdk.listMapper(cdk.stringToCloudFormation)(properties.excludedCookies), IncludedCookies: cdk.listMapper(cdk.stringToCloudFormation)(properties.includedCookies) }) : properties;
    }
    function CfnWebACLCookieMatchPatternPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("all", "All", properties.All != null ? cfn_parse.FromCloudFormation.getAny(properties.All) : void 0), ret.addPropertyResult("excludedCookies", "ExcludedCookies", properties.ExcludedCookies != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExcludedCookies) : void 0), ret.addPropertyResult("includedCookies", "IncludedCookies", properties.IncludedCookies != null ? cfn_parse.FromCloudFormation.getStringArray(properties.IncludedCookies) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_CookiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("matchPattern", cdk.requiredValidator)(properties.matchPattern)), errors.collect(cdk.propertyValidator("matchPattern", CfnWebACL_CookieMatchPatternPropertyValidator)(properties.matchPattern)), errors.collect(cdk.propertyValidator("matchScope", cdk.requiredValidator)(properties.matchScope)), errors.collect(cdk.propertyValidator("matchScope", cdk.validateString)(properties.matchScope)), errors.collect(cdk.propertyValidator("oversizeHandling", cdk.requiredValidator)(properties.oversizeHandling)), errors.collect(cdk.propertyValidator("oversizeHandling", cdk.validateString)(properties.oversizeHandling)), errors.wrap('supplied properties not correct for "CookiesProperty"');
    }
    function cfnWebACLCookiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_CookiesPropertyValidator(properties).assertSuccess(), { MatchPattern: cfnWebACLCookieMatchPatternPropertyToCloudFormation(properties.matchPattern), MatchScope: cdk.stringToCloudFormation(properties.matchScope), OversizeHandling: cdk.stringToCloudFormation(properties.oversizeHandling) }) : properties;
    }
    function CfnWebACLCookiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("matchPattern", "MatchPattern", CfnWebACLCookieMatchPatternPropertyFromCloudFormation(properties.MatchPattern)), ret.addPropertyResult("matchScope", "MatchScope", cfn_parse.FromCloudFormation.getString(properties.MatchScope)), ret.addPropertyResult("oversizeHandling", "OversizeHandling", cfn_parse.FromCloudFormation.getString(properties.OversizeHandling)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_CountActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customRequestHandling", CfnWebACL_CustomRequestHandlingPropertyValidator)(properties.customRequestHandling)), errors.wrap('supplied properties not correct for "CountActionProperty"');
    }
    function cfnWebACLCountActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_CountActionPropertyValidator(properties).assertSuccess(), { CustomRequestHandling: cfnWebACLCustomRequestHandlingPropertyToCloudFormation(properties.customRequestHandling) }) : properties;
    }
    function CfnWebACLCountActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customRequestHandling", "CustomRequestHandling", properties.CustomRequestHandling != null ? CfnWebACLCustomRequestHandlingPropertyFromCloudFormation(properties.CustomRequestHandling) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_CustomHTTPHeaderPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("value", cdk.requiredValidator)(properties.value)), errors.collect(cdk.propertyValidator("value", cdk.validateString)(properties.value)), errors.wrap('supplied properties not correct for "CustomHTTPHeaderProperty"');
    }
    function cfnWebACLCustomHTTPHeaderPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_CustomHTTPHeaderPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Value: cdk.stringToCloudFormation(properties.value) }) : properties;
    }
    function CfnWebACLCustomHTTPHeaderPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("value", "Value", cfn_parse.FromCloudFormation.getString(properties.Value)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_CustomRequestHandlingPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("insertHeaders", cdk.requiredValidator)(properties.insertHeaders)), errors.collect(cdk.propertyValidator("insertHeaders", cdk.listValidator(CfnWebACL_CustomHTTPHeaderPropertyValidator))(properties.insertHeaders)), errors.wrap('supplied properties not correct for "CustomRequestHandlingProperty"');
    }
    function cfnWebACLCustomRequestHandlingPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_CustomRequestHandlingPropertyValidator(properties).assertSuccess(), { InsertHeaders: cdk.listMapper(cfnWebACLCustomHTTPHeaderPropertyToCloudFormation)(properties.insertHeaders) }) : properties;
    }
    function CfnWebACLCustomRequestHandlingPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("insertHeaders", "InsertHeaders", cfn_parse.FromCloudFormation.getArray(CfnWebACLCustomHTTPHeaderPropertyFromCloudFormation)(properties.InsertHeaders)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_CustomResponsePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("customResponseBodyKey", cdk.validateString)(properties.customResponseBodyKey)), errors.collect(cdk.propertyValidator("responseCode", cdk.requiredValidator)(properties.responseCode)), errors.collect(cdk.propertyValidator("responseCode", cdk.validateNumber)(properties.responseCode)), errors.collect(cdk.propertyValidator("responseHeaders", cdk.listValidator(CfnWebACL_CustomHTTPHeaderPropertyValidator))(properties.responseHeaders)), errors.wrap('supplied properties not correct for "CustomResponseProperty"');
    }
    function cfnWebACLCustomResponsePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_CustomResponsePropertyValidator(properties).assertSuccess(), { CustomResponseBodyKey: cdk.stringToCloudFormation(properties.customResponseBodyKey), ResponseCode: cdk.numberToCloudFormation(properties.responseCode), ResponseHeaders: cdk.listMapper(cfnWebACLCustomHTTPHeaderPropertyToCloudFormation)(properties.responseHeaders) }) : properties;
    }
    function CfnWebACLCustomResponsePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("customResponseBodyKey", "CustomResponseBodyKey", properties.CustomResponseBodyKey != null ? cfn_parse.FromCloudFormation.getString(properties.CustomResponseBodyKey) : void 0), ret.addPropertyResult("responseCode", "ResponseCode", cfn_parse.FromCloudFormation.getNumber(properties.ResponseCode)), ret.addPropertyResult("responseHeaders", "ResponseHeaders", properties.ResponseHeaders != null ? cfn_parse.FromCloudFormation.getArray(CfnWebACLCustomHTTPHeaderPropertyFromCloudFormation)(properties.ResponseHeaders) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_CustomResponseBodyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("content", cdk.requiredValidator)(properties.content)), errors.collect(cdk.propertyValidator("content", cdk.validateString)(properties.content)), errors.collect(cdk.propertyValidator("contentType", cdk.requiredValidator)(properties.contentType)), errors.collect(cdk.propertyValidator("contentType", cdk.validateString)(properties.contentType)), errors.wrap('supplied properties not correct for "CustomResponseBodyProperty"');
    }
    function cfnWebACLCustomResponseBodyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_CustomResponseBodyPropertyValidator(properties).assertSuccess(), { Content: cdk.stringToCloudFormation(properties.content), ContentType: cdk.stringToCloudFormation(properties.contentType) }) : properties;
    }
    function CfnWebACLCustomResponseBodyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("content", "Content", cfn_parse.FromCloudFormation.getString(properties.Content)), ret.addPropertyResult("contentType", "ContentType", cfn_parse.FromCloudFormation.getString(properties.ContentType)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_DefaultActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allow", CfnWebACL_AllowActionPropertyValidator)(properties.allow)), errors.collect(cdk.propertyValidator("block", CfnWebACL_BlockActionPropertyValidator)(properties.block)), errors.wrap('supplied properties not correct for "DefaultActionProperty"');
    }
    function cfnWebACLDefaultActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_DefaultActionPropertyValidator(properties).assertSuccess(), { Allow: cfnWebACLAllowActionPropertyToCloudFormation(properties.allow), Block: cfnWebACLBlockActionPropertyToCloudFormation(properties.block) }) : properties;
    }
    function CfnWebACLDefaultActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allow", "Allow", properties.Allow != null ? CfnWebACLAllowActionPropertyFromCloudFormation(properties.Allow) : void 0), ret.addPropertyResult("block", "Block", properties.Block != null ? CfnWebACLBlockActionPropertyFromCloudFormation(properties.Block) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_ExcludedRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "ExcludedRuleProperty"');
    }
    function cfnWebACLExcludedRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_ExcludedRulePropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnWebACLExcludedRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_FieldIdentifierPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("identifier", cdk.requiredValidator)(properties.identifier)), errors.collect(cdk.propertyValidator("identifier", cdk.validateString)(properties.identifier)), errors.wrap('supplied properties not correct for "FieldIdentifierProperty"');
    }
    function cfnWebACLFieldIdentifierPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_FieldIdentifierPropertyValidator(properties).assertSuccess(), { Identifier: cdk.stringToCloudFormation(properties.identifier) }) : properties;
    }
    function CfnWebACLFieldIdentifierPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("identifier", "Identifier", cfn_parse.FromCloudFormation.getString(properties.Identifier)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_FieldToMatchPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allQueryArguments", cdk.validateObject)(properties.allQueryArguments)), errors.collect(cdk.propertyValidator("body", CfnWebACL_BodyPropertyValidator)(properties.body)), errors.collect(cdk.propertyValidator("cookies", CfnWebACL_CookiesPropertyValidator)(properties.cookies)), errors.collect(cdk.propertyValidator("headers", CfnWebACL_HeadersPropertyValidator)(properties.headers)), errors.collect(cdk.propertyValidator("jsonBody", CfnWebACL_JsonBodyPropertyValidator)(properties.jsonBody)), errors.collect(cdk.propertyValidator("method", cdk.validateObject)(properties.method)), errors.collect(cdk.propertyValidator("queryString", cdk.validateObject)(properties.queryString)), errors.collect(cdk.propertyValidator("singleHeader", cdk.validateObject)(properties.singleHeader)), errors.collect(cdk.propertyValidator("singleQueryArgument", cdk.validateObject)(properties.singleQueryArgument)), errors.collect(cdk.propertyValidator("uriPath", cdk.validateObject)(properties.uriPath)), errors.wrap('supplied properties not correct for "FieldToMatchProperty"');
    }
    function cfnWebACLFieldToMatchPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_FieldToMatchPropertyValidator(properties).assertSuccess(), { AllQueryArguments: cdk.objectToCloudFormation(properties.allQueryArguments), Body: cfnWebACLBodyPropertyToCloudFormation(properties.body), Cookies: cfnWebACLCookiesPropertyToCloudFormation(properties.cookies), Headers: cfnWebACLHeadersPropertyToCloudFormation(properties.headers), JsonBody: cfnWebACLJsonBodyPropertyToCloudFormation(properties.jsonBody), Method: cdk.objectToCloudFormation(properties.method), QueryString: cdk.objectToCloudFormation(properties.queryString), SingleHeader: cdk.objectToCloudFormation(properties.singleHeader), SingleQueryArgument: cdk.objectToCloudFormation(properties.singleQueryArgument), UriPath: cdk.objectToCloudFormation(properties.uriPath) }) : properties;
    }
    function CfnWebACLFieldToMatchPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allQueryArguments", "AllQueryArguments", properties.AllQueryArguments != null ? cfn_parse.FromCloudFormation.getAny(properties.AllQueryArguments) : void 0), ret.addPropertyResult("body", "Body", properties.Body != null ? CfnWebACLBodyPropertyFromCloudFormation(properties.Body) : void 0), ret.addPropertyResult("cookies", "Cookies", properties.Cookies != null ? CfnWebACLCookiesPropertyFromCloudFormation(properties.Cookies) : void 0), ret.addPropertyResult("headers", "Headers", properties.Headers != null ? CfnWebACLHeadersPropertyFromCloudFormation(properties.Headers) : void 0), ret.addPropertyResult("jsonBody", "JsonBody", properties.JsonBody != null ? CfnWebACLJsonBodyPropertyFromCloudFormation(properties.JsonBody) : void 0), ret.addPropertyResult("method", "Method", properties.Method != null ? cfn_parse.FromCloudFormation.getAny(properties.Method) : void 0), ret.addPropertyResult("queryString", "QueryString", properties.QueryString != null ? cfn_parse.FromCloudFormation.getAny(properties.QueryString) : void 0), ret.addPropertyResult("singleHeader", "SingleHeader", properties.SingleHeader != null ? cfn_parse.FromCloudFormation.getAny(properties.SingleHeader) : void 0), ret.addPropertyResult("singleQueryArgument", "SingleQueryArgument", properties.SingleQueryArgument != null ? cfn_parse.FromCloudFormation.getAny(properties.SingleQueryArgument) : void 0), ret.addPropertyResult("uriPath", "UriPath", properties.UriPath != null ? cfn_parse.FromCloudFormation.getAny(properties.UriPath) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_ForwardedIPConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fallbackBehavior", cdk.requiredValidator)(properties.fallbackBehavior)), errors.collect(cdk.propertyValidator("fallbackBehavior", cdk.validateString)(properties.fallbackBehavior)), errors.collect(cdk.propertyValidator("headerName", cdk.requiredValidator)(properties.headerName)), errors.collect(cdk.propertyValidator("headerName", cdk.validateString)(properties.headerName)), errors.wrap('supplied properties not correct for "ForwardedIPConfigurationProperty"');
    }
    function cfnWebACLForwardedIPConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_ForwardedIPConfigurationPropertyValidator(properties).assertSuccess(), { FallbackBehavior: cdk.stringToCloudFormation(properties.fallbackBehavior), HeaderName: cdk.stringToCloudFormation(properties.headerName) }) : properties;
    }
    function CfnWebACLForwardedIPConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fallbackBehavior", "FallbackBehavior", cfn_parse.FromCloudFormation.getString(properties.FallbackBehavior)), ret.addPropertyResult("headerName", "HeaderName", cfn_parse.FromCloudFormation.getString(properties.HeaderName)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_GeoMatchStatementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("countryCodes", cdk.listValidator(cdk.validateString))(properties.countryCodes)), errors.collect(cdk.propertyValidator("forwardedIpConfig", CfnWebACL_ForwardedIPConfigurationPropertyValidator)(properties.forwardedIpConfig)), errors.wrap('supplied properties not correct for "GeoMatchStatementProperty"');
    }
    function cfnWebACLGeoMatchStatementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_GeoMatchStatementPropertyValidator(properties).assertSuccess(), { CountryCodes: cdk.listMapper(cdk.stringToCloudFormation)(properties.countryCodes), ForwardedIPConfig: cfnWebACLForwardedIPConfigurationPropertyToCloudFormation(properties.forwardedIpConfig) }) : properties;
    }
    function CfnWebACLGeoMatchStatementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("countryCodes", "CountryCodes", properties.CountryCodes != null ? cfn_parse.FromCloudFormation.getStringArray(properties.CountryCodes) : void 0), ret.addPropertyResult("forwardedIpConfig", "ForwardedIPConfig", properties.ForwardedIPConfig != null ? CfnWebACLForwardedIPConfigurationPropertyFromCloudFormation(properties.ForwardedIPConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_HeaderMatchPatternPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("all", cdk.validateObject)(properties.all)), errors.collect(cdk.propertyValidator("excludedHeaders", cdk.listValidator(cdk.validateString))(properties.excludedHeaders)), errors.collect(cdk.propertyValidator("includedHeaders", cdk.listValidator(cdk.validateString))(properties.includedHeaders)), errors.wrap('supplied properties not correct for "HeaderMatchPatternProperty"');
    }
    function cfnWebACLHeaderMatchPatternPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_HeaderMatchPatternPropertyValidator(properties).assertSuccess(), { All: cdk.objectToCloudFormation(properties.all), ExcludedHeaders: cdk.listMapper(cdk.stringToCloudFormation)(properties.excludedHeaders), IncludedHeaders: cdk.listMapper(cdk.stringToCloudFormation)(properties.includedHeaders) }) : properties;
    }
    function CfnWebACLHeaderMatchPatternPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("all", "All", properties.All != null ? cfn_parse.FromCloudFormation.getAny(properties.All) : void 0), ret.addPropertyResult("excludedHeaders", "ExcludedHeaders", properties.ExcludedHeaders != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ExcludedHeaders) : void 0), ret.addPropertyResult("includedHeaders", "IncludedHeaders", properties.IncludedHeaders != null ? cfn_parse.FromCloudFormation.getStringArray(properties.IncludedHeaders) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_HeadersPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("matchPattern", cdk.requiredValidator)(properties.matchPattern)), errors.collect(cdk.propertyValidator("matchPattern", CfnWebACL_HeaderMatchPatternPropertyValidator)(properties.matchPattern)), errors.collect(cdk.propertyValidator("matchScope", cdk.requiredValidator)(properties.matchScope)), errors.collect(cdk.propertyValidator("matchScope", cdk.validateString)(properties.matchScope)), errors.collect(cdk.propertyValidator("oversizeHandling", cdk.requiredValidator)(properties.oversizeHandling)), errors.collect(cdk.propertyValidator("oversizeHandling", cdk.validateString)(properties.oversizeHandling)), errors.wrap('supplied properties not correct for "HeadersProperty"');
    }
    function cfnWebACLHeadersPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_HeadersPropertyValidator(properties).assertSuccess(), { MatchPattern: cfnWebACLHeaderMatchPatternPropertyToCloudFormation(properties.matchPattern), MatchScope: cdk.stringToCloudFormation(properties.matchScope), OversizeHandling: cdk.stringToCloudFormation(properties.oversizeHandling) }) : properties;
    }
    function CfnWebACLHeadersPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("matchPattern", "MatchPattern", CfnWebACLHeaderMatchPatternPropertyFromCloudFormation(properties.MatchPattern)), ret.addPropertyResult("matchScope", "MatchScope", cfn_parse.FromCloudFormation.getString(properties.MatchScope)), ret.addPropertyResult("oversizeHandling", "OversizeHandling", cfn_parse.FromCloudFormation.getString(properties.OversizeHandling)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_IPSetForwardedIPConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fallbackBehavior", cdk.requiredValidator)(properties.fallbackBehavior)), errors.collect(cdk.propertyValidator("fallbackBehavior", cdk.validateString)(properties.fallbackBehavior)), errors.collect(cdk.propertyValidator("headerName", cdk.requiredValidator)(properties.headerName)), errors.collect(cdk.propertyValidator("headerName", cdk.validateString)(properties.headerName)), errors.collect(cdk.propertyValidator("position", cdk.requiredValidator)(properties.position)), errors.collect(cdk.propertyValidator("position", cdk.validateString)(properties.position)), errors.wrap('supplied properties not correct for "IPSetForwardedIPConfigurationProperty"');
    }
    function cfnWebACLIPSetForwardedIPConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_IPSetForwardedIPConfigurationPropertyValidator(properties).assertSuccess(), { FallbackBehavior: cdk.stringToCloudFormation(properties.fallbackBehavior), HeaderName: cdk.stringToCloudFormation(properties.headerName), Position: cdk.stringToCloudFormation(properties.position) }) : properties;
    }
    function CfnWebACLIPSetForwardedIPConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fallbackBehavior", "FallbackBehavior", cfn_parse.FromCloudFormation.getString(properties.FallbackBehavior)), ret.addPropertyResult("headerName", "HeaderName", cfn_parse.FromCloudFormation.getString(properties.HeaderName)), ret.addPropertyResult("position", "Position", cfn_parse.FromCloudFormation.getString(properties.Position)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_IPSetReferenceStatementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.requiredValidator)(properties.arn)), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("ipSetForwardedIpConfig", CfnWebACL_IPSetForwardedIPConfigurationPropertyValidator)(properties.ipSetForwardedIpConfig)), errors.wrap('supplied properties not correct for "IPSetReferenceStatementProperty"');
    }
    function cfnWebACLIPSetReferenceStatementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_IPSetReferenceStatementPropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn), IPSetForwardedIPConfig: cfnWebACLIPSetForwardedIPConfigurationPropertyToCloudFormation(properties.ipSetForwardedIpConfig) }) : properties;
    }
    function CfnWebACLIPSetReferenceStatementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", cfn_parse.FromCloudFormation.getString(properties.Arn)), ret.addPropertyResult("ipSetForwardedIpConfig", "IPSetForwardedIPConfig", properties.IPSetForwardedIPConfig != null ? CfnWebACLIPSetForwardedIPConfigurationPropertyFromCloudFormation(properties.IPSetForwardedIPConfig) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_ImmunityTimePropertyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("immunityTime", cdk.requiredValidator)(properties.immunityTime)), errors.collect(cdk.propertyValidator("immunityTime", cdk.validateNumber)(properties.immunityTime)), errors.wrap('supplied properties not correct for "ImmunityTimePropertyProperty"');
    }
    function cfnWebACLImmunityTimePropertyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_ImmunityTimePropertyPropertyValidator(properties).assertSuccess(), { ImmunityTime: cdk.numberToCloudFormation(properties.immunityTime) }) : properties;
    }
    function CfnWebACLImmunityTimePropertyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("immunityTime", "ImmunityTime", cfn_parse.FromCloudFormation.getNumber(properties.ImmunityTime)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_JsonBodyPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("invalidFallbackBehavior", cdk.validateString)(properties.invalidFallbackBehavior)), errors.collect(cdk.propertyValidator("matchPattern", cdk.requiredValidator)(properties.matchPattern)), errors.collect(cdk.propertyValidator("matchPattern", CfnWebACL_JsonMatchPatternPropertyValidator)(properties.matchPattern)), errors.collect(cdk.propertyValidator("matchScope", cdk.requiredValidator)(properties.matchScope)), errors.collect(cdk.propertyValidator("matchScope", cdk.validateString)(properties.matchScope)), errors.collect(cdk.propertyValidator("oversizeHandling", cdk.validateString)(properties.oversizeHandling)), errors.wrap('supplied properties not correct for "JsonBodyProperty"');
    }
    function cfnWebACLJsonBodyPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_JsonBodyPropertyValidator(properties).assertSuccess(), { InvalidFallbackBehavior: cdk.stringToCloudFormation(properties.invalidFallbackBehavior), MatchPattern: cfnWebACLJsonMatchPatternPropertyToCloudFormation(properties.matchPattern), MatchScope: cdk.stringToCloudFormation(properties.matchScope), OversizeHandling: cdk.stringToCloudFormation(properties.oversizeHandling) }) : properties;
    }
    function CfnWebACLJsonBodyPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("invalidFallbackBehavior", "InvalidFallbackBehavior", properties.InvalidFallbackBehavior != null ? cfn_parse.FromCloudFormation.getString(properties.InvalidFallbackBehavior) : void 0), ret.addPropertyResult("matchPattern", "MatchPattern", CfnWebACLJsonMatchPatternPropertyFromCloudFormation(properties.MatchPattern)), ret.addPropertyResult("matchScope", "MatchScope", cfn_parse.FromCloudFormation.getString(properties.MatchScope)), ret.addPropertyResult("oversizeHandling", "OversizeHandling", properties.OversizeHandling != null ? cfn_parse.FromCloudFormation.getString(properties.OversizeHandling) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_JsonMatchPatternPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("all", cdk.validateObject)(properties.all)), errors.collect(cdk.propertyValidator("includedPaths", cdk.listValidator(cdk.validateString))(properties.includedPaths)), errors.wrap('supplied properties not correct for "JsonMatchPatternProperty"');
    }
    function cfnWebACLJsonMatchPatternPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_JsonMatchPatternPropertyValidator(properties).assertSuccess(), { All: cdk.objectToCloudFormation(properties.all), IncludedPaths: cdk.listMapper(cdk.stringToCloudFormation)(properties.includedPaths) }) : properties;
    }
    function CfnWebACLJsonMatchPatternPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("all", "All", properties.All != null ? cfn_parse.FromCloudFormation.getAny(properties.All) : void 0), ret.addPropertyResult("includedPaths", "IncludedPaths", properties.IncludedPaths != null ? cfn_parse.FromCloudFormation.getStringArray(properties.IncludedPaths) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_LabelPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "LabelProperty"');
    }
    function cfnWebACLLabelPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_LabelPropertyValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnWebACLLabelPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_LabelMatchStatementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("key", cdk.requiredValidator)(properties.key)), errors.collect(cdk.propertyValidator("key", cdk.validateString)(properties.key)), errors.collect(cdk.propertyValidator("scope", cdk.requiredValidator)(properties.scope)), errors.collect(cdk.propertyValidator("scope", cdk.validateString)(properties.scope)), errors.wrap('supplied properties not correct for "LabelMatchStatementProperty"');
    }
    function cfnWebACLLabelMatchStatementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_LabelMatchStatementPropertyValidator(properties).assertSuccess(), { Key: cdk.stringToCloudFormation(properties.key), Scope: cdk.stringToCloudFormation(properties.scope) }) : properties;
    }
    function CfnWebACLLabelMatchStatementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("key", "Key", cfn_parse.FromCloudFormation.getString(properties.Key)), ret.addPropertyResult("scope", "Scope", cfn_parse.FromCloudFormation.getString(properties.Scope)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_ManagedRuleGroupConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("awsManagedRulesAtpRuleSet", CfnWebACL_AWSManagedRulesATPRuleSetPropertyValidator)(properties.awsManagedRulesAtpRuleSet)), errors.collect(cdk.propertyValidator("awsManagedRulesBotControlRuleSet", CfnWebACL_AWSManagedRulesBotControlRuleSetPropertyValidator)(properties.awsManagedRulesBotControlRuleSet)), errors.collect(cdk.propertyValidator("loginPath", cdk.validateString)(properties.loginPath)), errors.collect(cdk.propertyValidator("passwordField", CfnWebACL_FieldIdentifierPropertyValidator)(properties.passwordField)), errors.collect(cdk.propertyValidator("payloadType", cdk.validateString)(properties.payloadType)), errors.collect(cdk.propertyValidator("usernameField", CfnWebACL_FieldIdentifierPropertyValidator)(properties.usernameField)), errors.wrap('supplied properties not correct for "ManagedRuleGroupConfigProperty"');
    }
    function cfnWebACLManagedRuleGroupConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_ManagedRuleGroupConfigPropertyValidator(properties).assertSuccess(), { AWSManagedRulesATPRuleSet: cfnWebACLAWSManagedRulesATPRuleSetPropertyToCloudFormation(properties.awsManagedRulesAtpRuleSet), AWSManagedRulesBotControlRuleSet: cfnWebACLAWSManagedRulesBotControlRuleSetPropertyToCloudFormation(properties.awsManagedRulesBotControlRuleSet), LoginPath: cdk.stringToCloudFormation(properties.loginPath), PasswordField: cfnWebACLFieldIdentifierPropertyToCloudFormation(properties.passwordField), PayloadType: cdk.stringToCloudFormation(properties.payloadType), UsernameField: cfnWebACLFieldIdentifierPropertyToCloudFormation(properties.usernameField) }) : properties;
    }
    function CfnWebACLManagedRuleGroupConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("awsManagedRulesAtpRuleSet", "AWSManagedRulesATPRuleSet", properties.AWSManagedRulesATPRuleSet != null ? CfnWebACLAWSManagedRulesATPRuleSetPropertyFromCloudFormation(properties.AWSManagedRulesATPRuleSet) : void 0), ret.addPropertyResult("awsManagedRulesBotControlRuleSet", "AWSManagedRulesBotControlRuleSet", properties.AWSManagedRulesBotControlRuleSet != null ? CfnWebACLAWSManagedRulesBotControlRuleSetPropertyFromCloudFormation(properties.AWSManagedRulesBotControlRuleSet) : void 0), ret.addPropertyResult("loginPath", "LoginPath", properties.LoginPath != null ? cfn_parse.FromCloudFormation.getString(properties.LoginPath) : void 0), ret.addPropertyResult("passwordField", "PasswordField", properties.PasswordField != null ? CfnWebACLFieldIdentifierPropertyFromCloudFormation(properties.PasswordField) : void 0), ret.addPropertyResult("payloadType", "PayloadType", properties.PayloadType != null ? cfn_parse.FromCloudFormation.getString(properties.PayloadType) : void 0), ret.addPropertyResult("usernameField", "UsernameField", properties.UsernameField != null ? CfnWebACLFieldIdentifierPropertyFromCloudFormation(properties.UsernameField) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_ManagedRuleGroupStatementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("excludedRules", cdk.listValidator(CfnWebACL_ExcludedRulePropertyValidator))(properties.excludedRules)), errors.collect(cdk.propertyValidator("managedRuleGroupConfigs", cdk.listValidator(CfnWebACL_ManagedRuleGroupConfigPropertyValidator))(properties.managedRuleGroupConfigs)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("ruleActionOverrides", cdk.listValidator(CfnWebACL_RuleActionOverridePropertyValidator))(properties.ruleActionOverrides)), errors.collect(cdk.propertyValidator("scopeDownStatement", CfnWebACL_StatementPropertyValidator)(properties.scopeDownStatement)), errors.collect(cdk.propertyValidator("vendorName", cdk.requiredValidator)(properties.vendorName)), errors.collect(cdk.propertyValidator("vendorName", cdk.validateString)(properties.vendorName)), errors.collect(cdk.propertyValidator("version", cdk.validateString)(properties.version)), errors.wrap('supplied properties not correct for "ManagedRuleGroupStatementProperty"');
    }
    function cfnWebACLManagedRuleGroupStatementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_ManagedRuleGroupStatementPropertyValidator(properties).assertSuccess(), { ExcludedRules: cdk.listMapper(cfnWebACLExcludedRulePropertyToCloudFormation)(properties.excludedRules), ManagedRuleGroupConfigs: cdk.listMapper(cfnWebACLManagedRuleGroupConfigPropertyToCloudFormation)(properties.managedRuleGroupConfigs), Name: cdk.stringToCloudFormation(properties.name), RuleActionOverrides: cdk.listMapper(cfnWebACLRuleActionOverridePropertyToCloudFormation)(properties.ruleActionOverrides), ScopeDownStatement: cfnWebACLStatementPropertyToCloudFormation(properties.scopeDownStatement), VendorName: cdk.stringToCloudFormation(properties.vendorName), Version: cdk.stringToCloudFormation(properties.version) }) : properties;
    }
    function CfnWebACLManagedRuleGroupStatementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("excludedRules", "ExcludedRules", properties.ExcludedRules != null ? cfn_parse.FromCloudFormation.getArray(CfnWebACLExcludedRulePropertyFromCloudFormation)(properties.ExcludedRules) : void 0), ret.addPropertyResult("managedRuleGroupConfigs", "ManagedRuleGroupConfigs", properties.ManagedRuleGroupConfigs != null ? cfn_parse.FromCloudFormation.getArray(CfnWebACLManagedRuleGroupConfigPropertyFromCloudFormation)(properties.ManagedRuleGroupConfigs) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("ruleActionOverrides", "RuleActionOverrides", properties.RuleActionOverrides != null ? cfn_parse.FromCloudFormation.getArray(CfnWebACLRuleActionOverridePropertyFromCloudFormation)(properties.RuleActionOverrides) : void 0), ret.addPropertyResult("scopeDownStatement", "ScopeDownStatement", properties.ScopeDownStatement != null ? CfnWebACLStatementPropertyFromCloudFormation(properties.ScopeDownStatement) : void 0), ret.addPropertyResult("vendorName", "VendorName", cfn_parse.FromCloudFormation.getString(properties.VendorName)), ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getString(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_NotStatementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("statement", cdk.requiredValidator)(properties.statement)), errors.collect(cdk.propertyValidator("statement", CfnWebACL_StatementPropertyValidator)(properties.statement)), errors.wrap('supplied properties not correct for "NotStatementProperty"');
    }
    function cfnWebACLNotStatementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_NotStatementPropertyValidator(properties).assertSuccess(), { Statement: cfnWebACLStatementPropertyToCloudFormation(properties.statement) }) : properties;
    }
    function CfnWebACLNotStatementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("statement", "Statement", CfnWebACLStatementPropertyFromCloudFormation(properties.Statement)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_OrStatementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("statements", cdk.requiredValidator)(properties.statements)), errors.collect(cdk.propertyValidator("statements", cdk.listValidator(CfnWebACL_StatementPropertyValidator))(properties.statements)), errors.wrap('supplied properties not correct for "OrStatementProperty"');
    }
    function cfnWebACLOrStatementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_OrStatementPropertyValidator(properties).assertSuccess(), { Statements: cdk.listMapper(cfnWebACLStatementPropertyToCloudFormation)(properties.statements) }) : properties;
    }
    function CfnWebACLOrStatementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("statements", "Statements", cfn_parse.FromCloudFormation.getArray(CfnWebACLStatementPropertyFromCloudFormation)(properties.Statements)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_OverrideActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("count", cdk.validateObject)(properties.count)), errors.collect(cdk.propertyValidator("none", cdk.validateObject)(properties.none)), errors.wrap('supplied properties not correct for "OverrideActionProperty"');
    }
    function cfnWebACLOverrideActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_OverrideActionPropertyValidator(properties).assertSuccess(), { Count: cdk.objectToCloudFormation(properties.count), None: cdk.objectToCloudFormation(properties.none) }) : properties;
    }
    function CfnWebACLOverrideActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("count", "Count", properties.Count != null ? cfn_parse.FromCloudFormation.getAny(properties.Count) : void 0), ret.addPropertyResult("none", "None", properties.None != null ? cfn_parse.FromCloudFormation.getAny(properties.None) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_RateBasedStatementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("aggregateKeyType", cdk.requiredValidator)(properties.aggregateKeyType)), errors.collect(cdk.propertyValidator("aggregateKeyType", cdk.validateString)(properties.aggregateKeyType)), errors.collect(cdk.propertyValidator("forwardedIpConfig", CfnWebACL_ForwardedIPConfigurationPropertyValidator)(properties.forwardedIpConfig)), errors.collect(cdk.propertyValidator("limit", cdk.requiredValidator)(properties.limit)), errors.collect(cdk.propertyValidator("limit", cdk.validateNumber)(properties.limit)), errors.collect(cdk.propertyValidator("scopeDownStatement", CfnWebACL_StatementPropertyValidator)(properties.scopeDownStatement)), errors.wrap('supplied properties not correct for "RateBasedStatementProperty"');
    }
    function cfnWebACLRateBasedStatementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_RateBasedStatementPropertyValidator(properties).assertSuccess(), { AggregateKeyType: cdk.stringToCloudFormation(properties.aggregateKeyType), ForwardedIPConfig: cfnWebACLForwardedIPConfigurationPropertyToCloudFormation(properties.forwardedIpConfig), Limit: cdk.numberToCloudFormation(properties.limit), ScopeDownStatement: cfnWebACLStatementPropertyToCloudFormation(properties.scopeDownStatement) }) : properties;
    }
    function CfnWebACLRateBasedStatementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("aggregateKeyType", "AggregateKeyType", cfn_parse.FromCloudFormation.getString(properties.AggregateKeyType)), ret.addPropertyResult("forwardedIpConfig", "ForwardedIPConfig", properties.ForwardedIPConfig != null ? CfnWebACLForwardedIPConfigurationPropertyFromCloudFormation(properties.ForwardedIPConfig) : void 0), ret.addPropertyResult("limit", "Limit", cfn_parse.FromCloudFormation.getNumber(properties.Limit)), ret.addPropertyResult("scopeDownStatement", "ScopeDownStatement", properties.ScopeDownStatement != null ? CfnWebACLStatementPropertyFromCloudFormation(properties.ScopeDownStatement) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_RegexMatchStatementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldToMatch", cdk.requiredValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("fieldToMatch", CfnWebACL_FieldToMatchPropertyValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("regexString", cdk.requiredValidator)(properties.regexString)), errors.collect(cdk.propertyValidator("regexString", cdk.validateString)(properties.regexString)), errors.collect(cdk.propertyValidator("textTransformations", cdk.requiredValidator)(properties.textTransformations)), errors.collect(cdk.propertyValidator("textTransformations", cdk.listValidator(CfnWebACL_TextTransformationPropertyValidator))(properties.textTransformations)), errors.wrap('supplied properties not correct for "RegexMatchStatementProperty"');
    }
    function cfnWebACLRegexMatchStatementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_RegexMatchStatementPropertyValidator(properties).assertSuccess(), { FieldToMatch: cfnWebACLFieldToMatchPropertyToCloudFormation(properties.fieldToMatch), RegexString: cdk.stringToCloudFormation(properties.regexString), TextTransformations: cdk.listMapper(cfnWebACLTextTransformationPropertyToCloudFormation)(properties.textTransformations) }) : properties;
    }
    function CfnWebACLRegexMatchStatementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldToMatch", "FieldToMatch", CfnWebACLFieldToMatchPropertyFromCloudFormation(properties.FieldToMatch)), ret.addPropertyResult("regexString", "RegexString", cfn_parse.FromCloudFormation.getString(properties.RegexString)), ret.addPropertyResult("textTransformations", "TextTransformations", cfn_parse.FromCloudFormation.getArray(CfnWebACLTextTransformationPropertyFromCloudFormation)(properties.TextTransformations)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_RegexPatternSetReferenceStatementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.requiredValidator)(properties.arn)), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("fieldToMatch", cdk.requiredValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("fieldToMatch", CfnWebACL_FieldToMatchPropertyValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("textTransformations", cdk.requiredValidator)(properties.textTransformations)), errors.collect(cdk.propertyValidator("textTransformations", cdk.listValidator(CfnWebACL_TextTransformationPropertyValidator))(properties.textTransformations)), errors.wrap('supplied properties not correct for "RegexPatternSetReferenceStatementProperty"');
    }
    function cfnWebACLRegexPatternSetReferenceStatementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_RegexPatternSetReferenceStatementPropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn), FieldToMatch: cfnWebACLFieldToMatchPropertyToCloudFormation(properties.fieldToMatch), TextTransformations: cdk.listMapper(cfnWebACLTextTransformationPropertyToCloudFormation)(properties.textTransformations) }) : properties;
    }
    function CfnWebACLRegexPatternSetReferenceStatementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", cfn_parse.FromCloudFormation.getString(properties.Arn)), ret.addPropertyResult("fieldToMatch", "FieldToMatch", CfnWebACLFieldToMatchPropertyFromCloudFormation(properties.FieldToMatch)), ret.addPropertyResult("textTransformations", "TextTransformations", cfn_parse.FromCloudFormation.getArray(CfnWebACLTextTransformationPropertyFromCloudFormation)(properties.TextTransformations)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_RequestInspectionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("passwordField", cdk.requiredValidator)(properties.passwordField)), errors.collect(cdk.propertyValidator("passwordField", CfnWebACL_FieldIdentifierPropertyValidator)(properties.passwordField)), errors.collect(cdk.propertyValidator("payloadType", cdk.requiredValidator)(properties.payloadType)), errors.collect(cdk.propertyValidator("payloadType", cdk.validateString)(properties.payloadType)), errors.collect(cdk.propertyValidator("usernameField", cdk.requiredValidator)(properties.usernameField)), errors.collect(cdk.propertyValidator("usernameField", CfnWebACL_FieldIdentifierPropertyValidator)(properties.usernameField)), errors.wrap('supplied properties not correct for "RequestInspectionProperty"');
    }
    function cfnWebACLRequestInspectionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_RequestInspectionPropertyValidator(properties).assertSuccess(), { PasswordField: cfnWebACLFieldIdentifierPropertyToCloudFormation(properties.passwordField), PayloadType: cdk.stringToCloudFormation(properties.payloadType), UsernameField: cfnWebACLFieldIdentifierPropertyToCloudFormation(properties.usernameField) }) : properties;
    }
    function CfnWebACLRequestInspectionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("passwordField", "PasswordField", CfnWebACLFieldIdentifierPropertyFromCloudFormation(properties.PasswordField)), ret.addPropertyResult("payloadType", "PayloadType", cfn_parse.FromCloudFormation.getString(properties.PayloadType)), ret.addPropertyResult("usernameField", "UsernameField", CfnWebACLFieldIdentifierPropertyFromCloudFormation(properties.UsernameField)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_ResponseInspectionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bodyContains", CfnWebACL_ResponseInspectionBodyContainsPropertyValidator)(properties.bodyContains)), errors.collect(cdk.propertyValidator("header", CfnWebACL_ResponseInspectionHeaderPropertyValidator)(properties.header)), errors.collect(cdk.propertyValidator("json", CfnWebACL_ResponseInspectionJsonPropertyValidator)(properties.json)), errors.collect(cdk.propertyValidator("statusCode", CfnWebACL_ResponseInspectionStatusCodePropertyValidator)(properties.statusCode)), errors.wrap('supplied properties not correct for "ResponseInspectionProperty"');
    }
    function cfnWebACLResponseInspectionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_ResponseInspectionPropertyValidator(properties).assertSuccess(), { BodyContains: cfnWebACLResponseInspectionBodyContainsPropertyToCloudFormation(properties.bodyContains), Header: cfnWebACLResponseInspectionHeaderPropertyToCloudFormation(properties.header), Json: cfnWebACLResponseInspectionJsonPropertyToCloudFormation(properties.json), StatusCode: cfnWebACLResponseInspectionStatusCodePropertyToCloudFormation(properties.statusCode) }) : properties;
    }
    function CfnWebACLResponseInspectionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bodyContains", "BodyContains", properties.BodyContains != null ? CfnWebACLResponseInspectionBodyContainsPropertyFromCloudFormation(properties.BodyContains) : void 0), ret.addPropertyResult("header", "Header", properties.Header != null ? CfnWebACLResponseInspectionHeaderPropertyFromCloudFormation(properties.Header) : void 0), ret.addPropertyResult("json", "Json", properties.Json != null ? CfnWebACLResponseInspectionJsonPropertyFromCloudFormation(properties.Json) : void 0), ret.addPropertyResult("statusCode", "StatusCode", properties.StatusCode != null ? CfnWebACLResponseInspectionStatusCodePropertyFromCloudFormation(properties.StatusCode) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_ResponseInspectionBodyContainsPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("failureStrings", cdk.requiredValidator)(properties.failureStrings)), errors.collect(cdk.propertyValidator("failureStrings", cdk.listValidator(cdk.validateString))(properties.failureStrings)), errors.collect(cdk.propertyValidator("successStrings", cdk.requiredValidator)(properties.successStrings)), errors.collect(cdk.propertyValidator("successStrings", cdk.listValidator(cdk.validateString))(properties.successStrings)), errors.wrap('supplied properties not correct for "ResponseInspectionBodyContainsProperty"');
    }
    function cfnWebACLResponseInspectionBodyContainsPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_ResponseInspectionBodyContainsPropertyValidator(properties).assertSuccess(), { FailureStrings: cdk.listMapper(cdk.stringToCloudFormation)(properties.failureStrings), SuccessStrings: cdk.listMapper(cdk.stringToCloudFormation)(properties.successStrings) }) : properties;
    }
    function CfnWebACLResponseInspectionBodyContainsPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("failureStrings", "FailureStrings", cfn_parse.FromCloudFormation.getStringArray(properties.FailureStrings)), ret.addPropertyResult("successStrings", "SuccessStrings", cfn_parse.FromCloudFormation.getStringArray(properties.SuccessStrings)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_ResponseInspectionHeaderPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("failureValues", cdk.requiredValidator)(properties.failureValues)), errors.collect(cdk.propertyValidator("failureValues", cdk.listValidator(cdk.validateString))(properties.failureValues)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("successValues", cdk.requiredValidator)(properties.successValues)), errors.collect(cdk.propertyValidator("successValues", cdk.listValidator(cdk.validateString))(properties.successValues)), errors.wrap('supplied properties not correct for "ResponseInspectionHeaderProperty"');
    }
    function cfnWebACLResponseInspectionHeaderPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_ResponseInspectionHeaderPropertyValidator(properties).assertSuccess(), { FailureValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.failureValues), Name: cdk.stringToCloudFormation(properties.name), SuccessValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.successValues) }) : properties;
    }
    function CfnWebACLResponseInspectionHeaderPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("failureValues", "FailureValues", cfn_parse.FromCloudFormation.getStringArray(properties.FailureValues)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("successValues", "SuccessValues", cfn_parse.FromCloudFormation.getStringArray(properties.SuccessValues)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_ResponseInspectionJsonPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("failureValues", cdk.requiredValidator)(properties.failureValues)), errors.collect(cdk.propertyValidator("failureValues", cdk.listValidator(cdk.validateString))(properties.failureValues)), errors.collect(cdk.propertyValidator("identifier", cdk.requiredValidator)(properties.identifier)), errors.collect(cdk.propertyValidator("identifier", cdk.validateString)(properties.identifier)), errors.collect(cdk.propertyValidator("successValues", cdk.requiredValidator)(properties.successValues)), errors.collect(cdk.propertyValidator("successValues", cdk.listValidator(cdk.validateString))(properties.successValues)), errors.wrap('supplied properties not correct for "ResponseInspectionJsonProperty"');
    }
    function cfnWebACLResponseInspectionJsonPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_ResponseInspectionJsonPropertyValidator(properties).assertSuccess(), { FailureValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.failureValues), Identifier: cdk.stringToCloudFormation(properties.identifier), SuccessValues: cdk.listMapper(cdk.stringToCloudFormation)(properties.successValues) }) : properties;
    }
    function CfnWebACLResponseInspectionJsonPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("failureValues", "FailureValues", cfn_parse.FromCloudFormation.getStringArray(properties.FailureValues)), ret.addPropertyResult("identifier", "Identifier", cfn_parse.FromCloudFormation.getString(properties.Identifier)), ret.addPropertyResult("successValues", "SuccessValues", cfn_parse.FromCloudFormation.getStringArray(properties.SuccessValues)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_ResponseInspectionStatusCodePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("failureCodes", cdk.requiredValidator)(properties.failureCodes)), errors.collect(cdk.propertyValidator("failureCodes", cdk.listValidator(cdk.validateNumber))(properties.failureCodes)), errors.collect(cdk.propertyValidator("successCodes", cdk.requiredValidator)(properties.successCodes)), errors.collect(cdk.propertyValidator("successCodes", cdk.listValidator(cdk.validateNumber))(properties.successCodes)), errors.wrap('supplied properties not correct for "ResponseInspectionStatusCodeProperty"');
    }
    function cfnWebACLResponseInspectionStatusCodePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_ResponseInspectionStatusCodePropertyValidator(properties).assertSuccess(), { FailureCodes: cdk.listMapper(cdk.numberToCloudFormation)(properties.failureCodes), SuccessCodes: cdk.listMapper(cdk.numberToCloudFormation)(properties.successCodes) }) : properties;
    }
    function CfnWebACLResponseInspectionStatusCodePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("failureCodes", "FailureCodes", cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getNumber)(properties.FailureCodes)), ret.addPropertyResult("successCodes", "SuccessCodes", cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getNumber)(properties.SuccessCodes)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_RulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("action", CfnWebACL_RuleActionPropertyValidator)(properties.action)), errors.collect(cdk.propertyValidator("captchaConfig", CfnWebACL_CaptchaConfigPropertyValidator)(properties.captchaConfig)), errors.collect(cdk.propertyValidator("challengeConfig", CfnWebACL_ChallengeConfigPropertyValidator)(properties.challengeConfig)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("overrideAction", CfnWebACL_OverrideActionPropertyValidator)(properties.overrideAction)), errors.collect(cdk.propertyValidator("priority", cdk.requiredValidator)(properties.priority)), errors.collect(cdk.propertyValidator("priority", cdk.validateNumber)(properties.priority)), errors.collect(cdk.propertyValidator("ruleLabels", cdk.listValidator(CfnWebACL_LabelPropertyValidator))(properties.ruleLabels)), errors.collect(cdk.propertyValidator("statement", cdk.requiredValidator)(properties.statement)), errors.collect(cdk.propertyValidator("statement", CfnWebACL_StatementPropertyValidator)(properties.statement)), errors.collect(cdk.propertyValidator("visibilityConfig", cdk.requiredValidator)(properties.visibilityConfig)), errors.collect(cdk.propertyValidator("visibilityConfig", CfnWebACL_VisibilityConfigPropertyValidator)(properties.visibilityConfig)), errors.wrap('supplied properties not correct for "RuleProperty"');
    }
    function cfnWebACLRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_RulePropertyValidator(properties).assertSuccess(), { Action: cfnWebACLRuleActionPropertyToCloudFormation(properties.action), CaptchaConfig: cfnWebACLCaptchaConfigPropertyToCloudFormation(properties.captchaConfig), ChallengeConfig: cfnWebACLChallengeConfigPropertyToCloudFormation(properties.challengeConfig), Name: cdk.stringToCloudFormation(properties.name), OverrideAction: cfnWebACLOverrideActionPropertyToCloudFormation(properties.overrideAction), Priority: cdk.numberToCloudFormation(properties.priority), RuleLabels: cdk.listMapper(cfnWebACLLabelPropertyToCloudFormation)(properties.ruleLabels), Statement: cfnWebACLStatementPropertyToCloudFormation(properties.statement), VisibilityConfig: cfnWebACLVisibilityConfigPropertyToCloudFormation(properties.visibilityConfig) }) : properties;
    }
    function CfnWebACLRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("action", "Action", properties.Action != null ? CfnWebACLRuleActionPropertyFromCloudFormation(properties.Action) : void 0), ret.addPropertyResult("captchaConfig", "CaptchaConfig", properties.CaptchaConfig != null ? CfnWebACLCaptchaConfigPropertyFromCloudFormation(properties.CaptchaConfig) : void 0), ret.addPropertyResult("challengeConfig", "ChallengeConfig", properties.ChallengeConfig != null ? CfnWebACLChallengeConfigPropertyFromCloudFormation(properties.ChallengeConfig) : void 0), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("overrideAction", "OverrideAction", properties.OverrideAction != null ? CfnWebACLOverrideActionPropertyFromCloudFormation(properties.OverrideAction) : void 0), ret.addPropertyResult("priority", "Priority", cfn_parse.FromCloudFormation.getNumber(properties.Priority)), ret.addPropertyResult("ruleLabels", "RuleLabels", properties.RuleLabels != null ? cfn_parse.FromCloudFormation.getArray(CfnWebACLLabelPropertyFromCloudFormation)(properties.RuleLabels) : void 0), ret.addPropertyResult("statement", "Statement", CfnWebACLStatementPropertyFromCloudFormation(properties.Statement)), ret.addPropertyResult("visibilityConfig", "VisibilityConfig", CfnWebACLVisibilityConfigPropertyFromCloudFormation(properties.VisibilityConfig)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_RuleActionPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("allow", CfnWebACL_AllowActionPropertyValidator)(properties.allow)), errors.collect(cdk.propertyValidator("block", CfnWebACL_BlockActionPropertyValidator)(properties.block)), errors.collect(cdk.propertyValidator("captcha", CfnWebACL_CaptchaActionPropertyValidator)(properties.captcha)), errors.collect(cdk.propertyValidator("challenge", CfnWebACL_ChallengeActionPropertyValidator)(properties.challenge)), errors.collect(cdk.propertyValidator("count", CfnWebACL_CountActionPropertyValidator)(properties.count)), errors.wrap('supplied properties not correct for "RuleActionProperty"');
    }
    function cfnWebACLRuleActionPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_RuleActionPropertyValidator(properties).assertSuccess(), { Allow: cfnWebACLAllowActionPropertyToCloudFormation(properties.allow), Block: cfnWebACLBlockActionPropertyToCloudFormation(properties.block), Captcha: cfnWebACLCaptchaActionPropertyToCloudFormation(properties.captcha), Challenge: cfnWebACLChallengeActionPropertyToCloudFormation(properties.challenge), Count: cfnWebACLCountActionPropertyToCloudFormation(properties.count) }) : properties;
    }
    function CfnWebACLRuleActionPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("allow", "Allow", properties.Allow != null ? CfnWebACLAllowActionPropertyFromCloudFormation(properties.Allow) : void 0), ret.addPropertyResult("block", "Block", properties.Block != null ? CfnWebACLBlockActionPropertyFromCloudFormation(properties.Block) : void 0), ret.addPropertyResult("captcha", "Captcha", properties.Captcha != null ? CfnWebACLCaptchaActionPropertyFromCloudFormation(properties.Captcha) : void 0), ret.addPropertyResult("challenge", "Challenge", properties.Challenge != null ? CfnWebACLChallengeActionPropertyFromCloudFormation(properties.Challenge) : void 0), ret.addPropertyResult("count", "Count", properties.Count != null ? CfnWebACLCountActionPropertyFromCloudFormation(properties.Count) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_RuleActionOverridePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("actionToUse", cdk.requiredValidator)(properties.actionToUse)), errors.collect(cdk.propertyValidator("actionToUse", CfnWebACL_RuleActionPropertyValidator)(properties.actionToUse)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.wrap('supplied properties not correct for "RuleActionOverrideProperty"');
    }
    function cfnWebACLRuleActionOverridePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_RuleActionOverridePropertyValidator(properties).assertSuccess(), { ActionToUse: cfnWebACLRuleActionPropertyToCloudFormation(properties.actionToUse), Name: cdk.stringToCloudFormation(properties.name) }) : properties;
    }
    function CfnWebACLRuleActionOverridePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("actionToUse", "ActionToUse", CfnWebACLRuleActionPropertyFromCloudFormation(properties.ActionToUse)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_RuleGroupReferenceStatementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("arn", cdk.requiredValidator)(properties.arn)), errors.collect(cdk.propertyValidator("arn", cdk.validateString)(properties.arn)), errors.collect(cdk.propertyValidator("excludedRules", cdk.listValidator(CfnWebACL_ExcludedRulePropertyValidator))(properties.excludedRules)), errors.collect(cdk.propertyValidator("ruleActionOverrides", cdk.listValidator(CfnWebACL_RuleActionOverridePropertyValidator))(properties.ruleActionOverrides)), errors.wrap('supplied properties not correct for "RuleGroupReferenceStatementProperty"');
    }
    function cfnWebACLRuleGroupReferenceStatementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_RuleGroupReferenceStatementPropertyValidator(properties).assertSuccess(), { Arn: cdk.stringToCloudFormation(properties.arn), ExcludedRules: cdk.listMapper(cfnWebACLExcludedRulePropertyToCloudFormation)(properties.excludedRules), RuleActionOverrides: cdk.listMapper(cfnWebACLRuleActionOverridePropertyToCloudFormation)(properties.ruleActionOverrides) }) : properties;
    }
    function CfnWebACLRuleGroupReferenceStatementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("arn", "Arn", cfn_parse.FromCloudFormation.getString(properties.Arn)), ret.addPropertyResult("excludedRules", "ExcludedRules", properties.ExcludedRules != null ? cfn_parse.FromCloudFormation.getArray(CfnWebACLExcludedRulePropertyFromCloudFormation)(properties.ExcludedRules) : void 0), ret.addPropertyResult("ruleActionOverrides", "RuleActionOverrides", properties.RuleActionOverrides != null ? cfn_parse.FromCloudFormation.getArray(CfnWebACLRuleActionOverridePropertyFromCloudFormation)(properties.RuleActionOverrides) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_SizeConstraintStatementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("comparisonOperator", cdk.requiredValidator)(properties.comparisonOperator)), errors.collect(cdk.propertyValidator("comparisonOperator", cdk.validateString)(properties.comparisonOperator)), errors.collect(cdk.propertyValidator("fieldToMatch", cdk.requiredValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("fieldToMatch", CfnWebACL_FieldToMatchPropertyValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("size", cdk.requiredValidator)(properties.size)), errors.collect(cdk.propertyValidator("size", cdk.validateNumber)(properties.size)), errors.collect(cdk.propertyValidator("textTransformations", cdk.requiredValidator)(properties.textTransformations)), errors.collect(cdk.propertyValidator("textTransformations", cdk.listValidator(CfnWebACL_TextTransformationPropertyValidator))(properties.textTransformations)), errors.wrap('supplied properties not correct for "SizeConstraintStatementProperty"');
    }
    function cfnWebACLSizeConstraintStatementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_SizeConstraintStatementPropertyValidator(properties).assertSuccess(), { ComparisonOperator: cdk.stringToCloudFormation(properties.comparisonOperator), FieldToMatch: cfnWebACLFieldToMatchPropertyToCloudFormation(properties.fieldToMatch), Size: cdk.numberToCloudFormation(properties.size), TextTransformations: cdk.listMapper(cfnWebACLTextTransformationPropertyToCloudFormation)(properties.textTransformations) }) : properties;
    }
    function CfnWebACLSizeConstraintStatementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("comparisonOperator", "ComparisonOperator", cfn_parse.FromCloudFormation.getString(properties.ComparisonOperator)), ret.addPropertyResult("fieldToMatch", "FieldToMatch", CfnWebACLFieldToMatchPropertyFromCloudFormation(properties.FieldToMatch)), ret.addPropertyResult("size", "Size", cfn_parse.FromCloudFormation.getNumber(properties.Size)), ret.addPropertyResult("textTransformations", "TextTransformations", cfn_parse.FromCloudFormation.getArray(CfnWebACLTextTransformationPropertyFromCloudFormation)(properties.TextTransformations)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_SqliMatchStatementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldToMatch", cdk.requiredValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("fieldToMatch", CfnWebACL_FieldToMatchPropertyValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("sensitivityLevel", cdk.validateString)(properties.sensitivityLevel)), errors.collect(cdk.propertyValidator("textTransformations", cdk.requiredValidator)(properties.textTransformations)), errors.collect(cdk.propertyValidator("textTransformations", cdk.listValidator(CfnWebACL_TextTransformationPropertyValidator))(properties.textTransformations)), errors.wrap('supplied properties not correct for "SqliMatchStatementProperty"');
    }
    function cfnWebACLSqliMatchStatementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_SqliMatchStatementPropertyValidator(properties).assertSuccess(), { FieldToMatch: cfnWebACLFieldToMatchPropertyToCloudFormation(properties.fieldToMatch), SensitivityLevel: cdk.stringToCloudFormation(properties.sensitivityLevel), TextTransformations: cdk.listMapper(cfnWebACLTextTransformationPropertyToCloudFormation)(properties.textTransformations) }) : properties;
    }
    function CfnWebACLSqliMatchStatementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldToMatch", "FieldToMatch", CfnWebACLFieldToMatchPropertyFromCloudFormation(properties.FieldToMatch)), ret.addPropertyResult("sensitivityLevel", "SensitivityLevel", properties.SensitivityLevel != null ? cfn_parse.FromCloudFormation.getString(properties.SensitivityLevel) : void 0), ret.addPropertyResult("textTransformations", "TextTransformations", cfn_parse.FromCloudFormation.getArray(CfnWebACLTextTransformationPropertyFromCloudFormation)(properties.TextTransformations)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_StatementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("andStatement", CfnWebACL_AndStatementPropertyValidator)(properties.andStatement)), errors.collect(cdk.propertyValidator("byteMatchStatement", CfnWebACL_ByteMatchStatementPropertyValidator)(properties.byteMatchStatement)), errors.collect(cdk.propertyValidator("geoMatchStatement", CfnWebACL_GeoMatchStatementPropertyValidator)(properties.geoMatchStatement)), errors.collect(cdk.propertyValidator("ipSetReferenceStatement", CfnWebACL_IPSetReferenceStatementPropertyValidator)(properties.ipSetReferenceStatement)), errors.collect(cdk.propertyValidator("labelMatchStatement", CfnWebACL_LabelMatchStatementPropertyValidator)(properties.labelMatchStatement)), errors.collect(cdk.propertyValidator("managedRuleGroupStatement", CfnWebACL_ManagedRuleGroupStatementPropertyValidator)(properties.managedRuleGroupStatement)), errors.collect(cdk.propertyValidator("notStatement", CfnWebACL_NotStatementPropertyValidator)(properties.notStatement)), errors.collect(cdk.propertyValidator("orStatement", CfnWebACL_OrStatementPropertyValidator)(properties.orStatement)), errors.collect(cdk.propertyValidator("rateBasedStatement", CfnWebACL_RateBasedStatementPropertyValidator)(properties.rateBasedStatement)), errors.collect(cdk.propertyValidator("regexMatchStatement", CfnWebACL_RegexMatchStatementPropertyValidator)(properties.regexMatchStatement)), errors.collect(cdk.propertyValidator("regexPatternSetReferenceStatement", CfnWebACL_RegexPatternSetReferenceStatementPropertyValidator)(properties.regexPatternSetReferenceStatement)), errors.collect(cdk.propertyValidator("ruleGroupReferenceStatement", CfnWebACL_RuleGroupReferenceStatementPropertyValidator)(properties.ruleGroupReferenceStatement)), errors.collect(cdk.propertyValidator("sizeConstraintStatement", CfnWebACL_SizeConstraintStatementPropertyValidator)(properties.sizeConstraintStatement)), errors.collect(cdk.propertyValidator("sqliMatchStatement", CfnWebACL_SqliMatchStatementPropertyValidator)(properties.sqliMatchStatement)), errors.collect(cdk.propertyValidator("xssMatchStatement", CfnWebACL_XssMatchStatementPropertyValidator)(properties.xssMatchStatement)), errors.wrap('supplied properties not correct for "StatementProperty"');
    }
    function cfnWebACLStatementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_StatementPropertyValidator(properties).assertSuccess(), { AndStatement: cfnWebACLAndStatementPropertyToCloudFormation(properties.andStatement), ByteMatchStatement: cfnWebACLByteMatchStatementPropertyToCloudFormation(properties.byteMatchStatement), GeoMatchStatement: cfnWebACLGeoMatchStatementPropertyToCloudFormation(properties.geoMatchStatement), IPSetReferenceStatement: cfnWebACLIPSetReferenceStatementPropertyToCloudFormation(properties.ipSetReferenceStatement), LabelMatchStatement: cfnWebACLLabelMatchStatementPropertyToCloudFormation(properties.labelMatchStatement), ManagedRuleGroupStatement: cfnWebACLManagedRuleGroupStatementPropertyToCloudFormation(properties.managedRuleGroupStatement), NotStatement: cfnWebACLNotStatementPropertyToCloudFormation(properties.notStatement), OrStatement: cfnWebACLOrStatementPropertyToCloudFormation(properties.orStatement), RateBasedStatement: cfnWebACLRateBasedStatementPropertyToCloudFormation(properties.rateBasedStatement), RegexMatchStatement: cfnWebACLRegexMatchStatementPropertyToCloudFormation(properties.regexMatchStatement), RegexPatternSetReferenceStatement: cfnWebACLRegexPatternSetReferenceStatementPropertyToCloudFormation(properties.regexPatternSetReferenceStatement), RuleGroupReferenceStatement: cfnWebACLRuleGroupReferenceStatementPropertyToCloudFormation(properties.ruleGroupReferenceStatement), SizeConstraintStatement: cfnWebACLSizeConstraintStatementPropertyToCloudFormation(properties.sizeConstraintStatement), SqliMatchStatement: cfnWebACLSqliMatchStatementPropertyToCloudFormation(properties.sqliMatchStatement), XssMatchStatement: cfnWebACLXssMatchStatementPropertyToCloudFormation(properties.xssMatchStatement) }) : properties;
    }
    function CfnWebACLStatementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("andStatement", "AndStatement", properties.AndStatement != null ? CfnWebACLAndStatementPropertyFromCloudFormation(properties.AndStatement) : void 0), ret.addPropertyResult("byteMatchStatement", "ByteMatchStatement", properties.ByteMatchStatement != null ? CfnWebACLByteMatchStatementPropertyFromCloudFormation(properties.ByteMatchStatement) : void 0), ret.addPropertyResult("geoMatchStatement", "GeoMatchStatement", properties.GeoMatchStatement != null ? CfnWebACLGeoMatchStatementPropertyFromCloudFormation(properties.GeoMatchStatement) : void 0), ret.addPropertyResult("ipSetReferenceStatement", "IPSetReferenceStatement", properties.IPSetReferenceStatement != null ? CfnWebACLIPSetReferenceStatementPropertyFromCloudFormation(properties.IPSetReferenceStatement) : void 0), ret.addPropertyResult("labelMatchStatement", "LabelMatchStatement", properties.LabelMatchStatement != null ? CfnWebACLLabelMatchStatementPropertyFromCloudFormation(properties.LabelMatchStatement) : void 0), ret.addPropertyResult("managedRuleGroupStatement", "ManagedRuleGroupStatement", properties.ManagedRuleGroupStatement != null ? CfnWebACLManagedRuleGroupStatementPropertyFromCloudFormation(properties.ManagedRuleGroupStatement) : void 0), ret.addPropertyResult("notStatement", "NotStatement", properties.NotStatement != null ? CfnWebACLNotStatementPropertyFromCloudFormation(properties.NotStatement) : void 0), ret.addPropertyResult("orStatement", "OrStatement", properties.OrStatement != null ? CfnWebACLOrStatementPropertyFromCloudFormation(properties.OrStatement) : void 0), ret.addPropertyResult("rateBasedStatement", "RateBasedStatement", properties.RateBasedStatement != null ? CfnWebACLRateBasedStatementPropertyFromCloudFormation(properties.RateBasedStatement) : void 0), ret.addPropertyResult("regexMatchStatement", "RegexMatchStatement", properties.RegexMatchStatement != null ? CfnWebACLRegexMatchStatementPropertyFromCloudFormation(properties.RegexMatchStatement) : void 0), ret.addPropertyResult("regexPatternSetReferenceStatement", "RegexPatternSetReferenceStatement", properties.RegexPatternSetReferenceStatement != null ? CfnWebACLRegexPatternSetReferenceStatementPropertyFromCloudFormation(properties.RegexPatternSetReferenceStatement) : void 0), ret.addPropertyResult("ruleGroupReferenceStatement", "RuleGroupReferenceStatement", properties.RuleGroupReferenceStatement != null ? CfnWebACLRuleGroupReferenceStatementPropertyFromCloudFormation(properties.RuleGroupReferenceStatement) : void 0), ret.addPropertyResult("sizeConstraintStatement", "SizeConstraintStatement", properties.SizeConstraintStatement != null ? CfnWebACLSizeConstraintStatementPropertyFromCloudFormation(properties.SizeConstraintStatement) : void 0), ret.addPropertyResult("sqliMatchStatement", "SqliMatchStatement", properties.SqliMatchStatement != null ? CfnWebACLSqliMatchStatementPropertyFromCloudFormation(properties.SqliMatchStatement) : void 0), ret.addPropertyResult("xssMatchStatement", "XssMatchStatement", properties.XssMatchStatement != null ? CfnWebACLXssMatchStatementPropertyFromCloudFormation(properties.XssMatchStatement) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_TextTransformationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("priority", cdk.requiredValidator)(properties.priority)), errors.collect(cdk.propertyValidator("priority", cdk.validateNumber)(properties.priority)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "TextTransformationProperty"');
    }
    function cfnWebACLTextTransformationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_TextTransformationPropertyValidator(properties).assertSuccess(), { Priority: cdk.numberToCloudFormation(properties.priority), Type: cdk.stringToCloudFormation(properties.type) }) : properties;
    }
    function CfnWebACLTextTransformationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("priority", "Priority", cfn_parse.FromCloudFormation.getNumber(properties.Priority)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_VisibilityConfigPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("cloudWatchMetricsEnabled", cdk.requiredValidator)(properties.cloudWatchMetricsEnabled)), errors.collect(cdk.propertyValidator("cloudWatchMetricsEnabled", cdk.validateBoolean)(properties.cloudWatchMetricsEnabled)), errors.collect(cdk.propertyValidator("metricName", cdk.requiredValidator)(properties.metricName)), errors.collect(cdk.propertyValidator("metricName", cdk.validateString)(properties.metricName)), errors.collect(cdk.propertyValidator("sampledRequestsEnabled", cdk.requiredValidator)(properties.sampledRequestsEnabled)), errors.collect(cdk.propertyValidator("sampledRequestsEnabled", cdk.validateBoolean)(properties.sampledRequestsEnabled)), errors.wrap('supplied properties not correct for "VisibilityConfigProperty"');
    }
    function cfnWebACLVisibilityConfigPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_VisibilityConfigPropertyValidator(properties).assertSuccess(), { CloudWatchMetricsEnabled: cdk.booleanToCloudFormation(properties.cloudWatchMetricsEnabled), MetricName: cdk.stringToCloudFormation(properties.metricName), SampledRequestsEnabled: cdk.booleanToCloudFormation(properties.sampledRequestsEnabled) }) : properties;
    }
    function CfnWebACLVisibilityConfigPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("cloudWatchMetricsEnabled", "CloudWatchMetricsEnabled", cfn_parse.FromCloudFormation.getBoolean(properties.CloudWatchMetricsEnabled)), ret.addPropertyResult("metricName", "MetricName", cfn_parse.FromCloudFormation.getString(properties.MetricName)), ret.addPropertyResult("sampledRequestsEnabled", "SampledRequestsEnabled", cfn_parse.FromCloudFormation.getBoolean(properties.SampledRequestsEnabled)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACL_XssMatchStatementPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("fieldToMatch", cdk.requiredValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("fieldToMatch", CfnWebACL_FieldToMatchPropertyValidator)(properties.fieldToMatch)), errors.collect(cdk.propertyValidator("textTransformations", cdk.requiredValidator)(properties.textTransformations)), errors.collect(cdk.propertyValidator("textTransformations", cdk.listValidator(CfnWebACL_TextTransformationPropertyValidator))(properties.textTransformations)), errors.wrap('supplied properties not correct for "XssMatchStatementProperty"');
    }
    function cfnWebACLXssMatchStatementPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACL_XssMatchStatementPropertyValidator(properties).assertSuccess(), { FieldToMatch: cfnWebACLFieldToMatchPropertyToCloudFormation(properties.fieldToMatch), TextTransformations: cdk.listMapper(cfnWebACLTextTransformationPropertyToCloudFormation)(properties.textTransformations) }) : properties;
    }
    function CfnWebACLXssMatchStatementPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("fieldToMatch", "FieldToMatch", CfnWebACLFieldToMatchPropertyFromCloudFormation(properties.FieldToMatch)), ret.addPropertyResult("textTransformations", "TextTransformations", cfn_parse.FromCloudFormation.getArray(CfnWebACLTextTransformationPropertyFromCloudFormation)(properties.TextTransformations)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnWebACLAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("resourceArn", cdk.requiredValidator)(properties.resourceArn)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.collect(cdk.propertyValidator("webAclArn", cdk.requiredValidator)(properties.webAclArn)), errors.collect(cdk.propertyValidator("webAclArn", cdk.validateString)(properties.webAclArn)), errors.wrap('supplied properties not correct for "CfnWebACLAssociationProps"');
    }
    function cfnWebACLAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWebACLAssociationPropsValidator(properties).assertSuccess(), { ResourceArn: cdk.stringToCloudFormation(properties.resourceArn), WebACLArn: cdk.stringToCloudFormation(properties.webAclArn) }) : properties;
    }
    function CfnWebACLAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("resourceArn", "ResourceArn", cfn_parse.FromCloudFormation.getString(properties.ResourceArn)), ret.addPropertyResult("webAclArn", "WebACLArn", cfn_parse.FromCloudFormation.getString(properties.WebACLArn)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnWebACLAssociation = class _CfnWebACLAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnWebACLAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnWebACLAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnWebACLAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_wafv2_CfnWebACLAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnWebACLAssociation), error;
        }
        cdk.requireProperty(props, "resourceArn", this), cdk.requireProperty(props, "webAclArn", this), this.resourceArn = props.resourceArn, this.webAclArn = props.webAclArn;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnWebACLAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { resourceArn: this.resourceArn, webAclArn: this.webAclArn };
      }
      renderProperties(props) {
        return cfnWebACLAssociationPropsToCloudFormation(props);
      }
    };
    _f = JSII_RTTI_SYMBOL_1, CfnWebACLAssociation[_f] = { fqn: "aws-cdk-lib.aws_wafv2.CfnWebACLAssociation", version: "2.80.0" }, CfnWebACLAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::WAFv2::WebACLAssociation", exports2.CfnWebACLAssociation = CfnWebACLAssociation;
  }
});

// node_modules/aws-cdk-lib/aws-wafv2/lib/index.js
var require_lib256 = __commonJS({
  "node_modules/aws-cdk-lib/aws-wafv2/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_wafv2_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-wafv2/index.js
var require_aws_wafv2 = __commonJS({
  "node_modules/aws-cdk-lib/aws-wafv2/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib256(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-wisdom/lib/wisdom.generated.js
var require_wisdom_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-wisdom/lib/wisdom.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnKnowledgeBase = exports2.CfnAssistantAssociation = exports2.CfnAssistant = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnAssistantPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("serverSideEncryptionConfiguration", CfnAssistant_ServerSideEncryptionConfigurationPropertyValidator)(properties.serverSideEncryptionConfiguration)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("type", cdk.requiredValidator)(properties.type)), errors.collect(cdk.propertyValidator("type", cdk.validateString)(properties.type)), errors.wrap('supplied properties not correct for "CfnAssistantProps"');
    }
    function cfnAssistantPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssistantPropsValidator(properties).assertSuccess(), { Name: cdk.stringToCloudFormation(properties.name), Type: cdk.stringToCloudFormation(properties.type), Description: cdk.stringToCloudFormation(properties.description), ServerSideEncryptionConfiguration: cfnAssistantServerSideEncryptionConfigurationPropertyToCloudFormation(properties.serverSideEncryptionConfiguration), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnAssistantPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("type", "Type", cfn_parse.FromCloudFormation.getString(properties.Type)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("serverSideEncryptionConfiguration", "ServerSideEncryptionConfiguration", properties.ServerSideEncryptionConfiguration != null ? CfnAssistantServerSideEncryptionConfigurationPropertyFromCloudFormation(properties.ServerSideEncryptionConfiguration) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAssistant = class _CfnAssistant extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAssistantPropsFromCloudFormation(resourceProperties), ret = new _CfnAssistant(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAssistant.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_wisdom_CfnAssistantProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAssistant), error;
        }
        cdk.requireProperty(props, "name", this), cdk.requireProperty(props, "type", this), this.attrAssistantArn = cdk.Token.asString(this.getAtt("AssistantArn", cdk.ResolutionTypeHint.STRING)), this.attrAssistantId = cdk.Token.asString(this.getAtt("AssistantId", cdk.ResolutionTypeHint.STRING)), this.name = props.name, this.type = props.type, this.description = props.description, this.serverSideEncryptionConfiguration = props.serverSideEncryptionConfiguration, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Wisdom::Assistant", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAssistant.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { name: this.name, type: this.type, description: this.description, serverSideEncryptionConfiguration: this.serverSideEncryptionConfiguration, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnAssistantPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnAssistant[_a] = { fqn: "aws-cdk-lib.aws_wisdom.CfnAssistant", version: "2.80.0" }, CfnAssistant.CFN_RESOURCE_TYPE_NAME = "AWS::Wisdom::Assistant", exports2.CfnAssistant = CfnAssistant;
    function CfnAssistant_ServerSideEncryptionConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.wrap('supplied properties not correct for "ServerSideEncryptionConfigurationProperty"');
    }
    function cfnAssistantServerSideEncryptionConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssistant_ServerSideEncryptionConfigurationPropertyValidator(properties).assertSuccess(), { KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId) }) : properties;
    }
    function CfnAssistantServerSideEncryptionConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnAssistantAssociationPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("assistantId", cdk.requiredValidator)(properties.assistantId)), errors.collect(cdk.propertyValidator("assistantId", cdk.validateString)(properties.assistantId)), errors.collect(cdk.propertyValidator("association", cdk.requiredValidator)(properties.association)), errors.collect(cdk.propertyValidator("association", CfnAssistantAssociation_AssociationDataPropertyValidator)(properties.association)), errors.collect(cdk.propertyValidator("associationType", cdk.requiredValidator)(properties.associationType)), errors.collect(cdk.propertyValidator("associationType", cdk.validateString)(properties.associationType)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnAssistantAssociationProps"');
    }
    function cfnAssistantAssociationPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssistantAssociationPropsValidator(properties).assertSuccess(), { AssistantId: cdk.stringToCloudFormation(properties.assistantId), Association: cfnAssistantAssociationAssociationDataPropertyToCloudFormation(properties.association), AssociationType: cdk.stringToCloudFormation(properties.associationType), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnAssistantAssociationPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("assistantId", "AssistantId", cfn_parse.FromCloudFormation.getString(properties.AssistantId)), ret.addPropertyResult("association", "Association", CfnAssistantAssociationAssociationDataPropertyFromCloudFormation(properties.Association)), ret.addPropertyResult("associationType", "AssociationType", cfn_parse.FromCloudFormation.getString(properties.AssociationType)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnAssistantAssociation = class _CfnAssistantAssociation extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnAssistantAssociationPropsFromCloudFormation(resourceProperties), ret = new _CfnAssistantAssociation(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnAssistantAssociation.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_wisdom_CfnAssistantAssociationProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnAssistantAssociation), error;
        }
        cdk.requireProperty(props, "assistantId", this), cdk.requireProperty(props, "association", this), cdk.requireProperty(props, "associationType", this), this.attrAssistantArn = cdk.Token.asString(this.getAtt("AssistantArn", cdk.ResolutionTypeHint.STRING)), this.attrAssistantAssociationArn = cdk.Token.asString(this.getAtt("AssistantAssociationArn", cdk.ResolutionTypeHint.STRING)), this.attrAssistantAssociationId = cdk.Token.asString(this.getAtt("AssistantAssociationId", cdk.ResolutionTypeHint.STRING)), this.assistantId = props.assistantId, this.association = props.association, this.associationType = props.associationType, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Wisdom::AssistantAssociation", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnAssistantAssociation.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { assistantId: this.assistantId, association: this.association, associationType: this.associationType, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnAssistantAssociationPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnAssistantAssociation[_b] = { fqn: "aws-cdk-lib.aws_wisdom.CfnAssistantAssociation", version: "2.80.0" }, CfnAssistantAssociation.CFN_RESOURCE_TYPE_NAME = "AWS::Wisdom::AssistantAssociation", exports2.CfnAssistantAssociation = CfnAssistantAssociation;
    function CfnAssistantAssociation_AssociationDataPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("knowledgeBaseId", cdk.requiredValidator)(properties.knowledgeBaseId)), errors.collect(cdk.propertyValidator("knowledgeBaseId", cdk.validateString)(properties.knowledgeBaseId)), errors.wrap('supplied properties not correct for "AssociationDataProperty"');
    }
    function cfnAssistantAssociationAssociationDataPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnAssistantAssociation_AssociationDataPropertyValidator(properties).assertSuccess(), { KnowledgeBaseId: cdk.stringToCloudFormation(properties.knowledgeBaseId) }) : properties;
    }
    function CfnAssistantAssociationAssociationDataPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("knowledgeBaseId", "KnowledgeBaseId", cfn_parse.FromCloudFormation.getString(properties.KnowledgeBaseId)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnKnowledgeBasePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("description", cdk.validateString)(properties.description)), errors.collect(cdk.propertyValidator("knowledgeBaseType", cdk.requiredValidator)(properties.knowledgeBaseType)), errors.collect(cdk.propertyValidator("knowledgeBaseType", cdk.validateString)(properties.knowledgeBaseType)), errors.collect(cdk.propertyValidator("name", cdk.requiredValidator)(properties.name)), errors.collect(cdk.propertyValidator("name", cdk.validateString)(properties.name)), errors.collect(cdk.propertyValidator("renderingConfiguration", CfnKnowledgeBase_RenderingConfigurationPropertyValidator)(properties.renderingConfiguration)), errors.collect(cdk.propertyValidator("serverSideEncryptionConfiguration", CfnKnowledgeBase_ServerSideEncryptionConfigurationPropertyValidator)(properties.serverSideEncryptionConfiguration)), errors.collect(cdk.propertyValidator("sourceConfiguration", CfnKnowledgeBase_SourceConfigurationPropertyValidator)(properties.sourceConfiguration)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnKnowledgeBaseProps"');
    }
    function cfnKnowledgeBasePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnKnowledgeBasePropsValidator(properties).assertSuccess(), { KnowledgeBaseType: cdk.stringToCloudFormation(properties.knowledgeBaseType), Name: cdk.stringToCloudFormation(properties.name), Description: cdk.stringToCloudFormation(properties.description), RenderingConfiguration: cfnKnowledgeBaseRenderingConfigurationPropertyToCloudFormation(properties.renderingConfiguration), ServerSideEncryptionConfiguration: cfnKnowledgeBaseServerSideEncryptionConfigurationPropertyToCloudFormation(properties.serverSideEncryptionConfiguration), SourceConfiguration: cfnKnowledgeBaseSourceConfigurationPropertyToCloudFormation(properties.sourceConfiguration), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnKnowledgeBasePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("knowledgeBaseType", "KnowledgeBaseType", cfn_parse.FromCloudFormation.getString(properties.KnowledgeBaseType)), ret.addPropertyResult("name", "Name", cfn_parse.FromCloudFormation.getString(properties.Name)), ret.addPropertyResult("description", "Description", properties.Description != null ? cfn_parse.FromCloudFormation.getString(properties.Description) : void 0), ret.addPropertyResult("renderingConfiguration", "RenderingConfiguration", properties.RenderingConfiguration != null ? CfnKnowledgeBaseRenderingConfigurationPropertyFromCloudFormation(properties.RenderingConfiguration) : void 0), ret.addPropertyResult("serverSideEncryptionConfiguration", "ServerSideEncryptionConfiguration", properties.ServerSideEncryptionConfiguration != null ? CfnKnowledgeBaseServerSideEncryptionConfigurationPropertyFromCloudFormation(properties.ServerSideEncryptionConfiguration) : void 0), ret.addPropertyResult("sourceConfiguration", "SourceConfiguration", properties.SourceConfiguration != null ? CfnKnowledgeBaseSourceConfigurationPropertyFromCloudFormation(properties.SourceConfiguration) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnKnowledgeBase = class _CfnKnowledgeBase extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnKnowledgeBasePropsFromCloudFormation(resourceProperties), ret = new _CfnKnowledgeBase(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnKnowledgeBase.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_wisdom_CfnKnowledgeBaseProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnKnowledgeBase), error;
        }
        cdk.requireProperty(props, "knowledgeBaseType", this), cdk.requireProperty(props, "name", this), this.attrKnowledgeBaseArn = cdk.Token.asString(this.getAtt("KnowledgeBaseArn", cdk.ResolutionTypeHint.STRING)), this.attrKnowledgeBaseId = cdk.Token.asString(this.getAtt("KnowledgeBaseId", cdk.ResolutionTypeHint.STRING)), this.knowledgeBaseType = props.knowledgeBaseType, this.name = props.name, this.description = props.description, this.renderingConfiguration = props.renderingConfiguration, this.serverSideEncryptionConfiguration = props.serverSideEncryptionConfiguration, this.sourceConfiguration = props.sourceConfiguration, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::Wisdom::KnowledgeBase", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnKnowledgeBase.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { knowledgeBaseType: this.knowledgeBaseType, name: this.name, description: this.description, renderingConfiguration: this.renderingConfiguration, serverSideEncryptionConfiguration: this.serverSideEncryptionConfiguration, sourceConfiguration: this.sourceConfiguration, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnKnowledgeBasePropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnKnowledgeBase[_c] = { fqn: "aws-cdk-lib.aws_wisdom.CfnKnowledgeBase", version: "2.80.0" }, CfnKnowledgeBase.CFN_RESOURCE_TYPE_NAME = "AWS::Wisdom::KnowledgeBase", exports2.CfnKnowledgeBase = CfnKnowledgeBase;
    function CfnKnowledgeBase_AppIntegrationsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("appIntegrationArn", cdk.requiredValidator)(properties.appIntegrationArn)), errors.collect(cdk.propertyValidator("appIntegrationArn", cdk.validateString)(properties.appIntegrationArn)), errors.collect(cdk.propertyValidator("objectFields", cdk.listValidator(cdk.validateString))(properties.objectFields)), errors.wrap('supplied properties not correct for "AppIntegrationsConfigurationProperty"');
    }
    function cfnKnowledgeBaseAppIntegrationsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnKnowledgeBase_AppIntegrationsConfigurationPropertyValidator(properties).assertSuccess(), { AppIntegrationArn: cdk.stringToCloudFormation(properties.appIntegrationArn), ObjectFields: cdk.listMapper(cdk.stringToCloudFormation)(properties.objectFields) }) : properties;
    }
    function CfnKnowledgeBaseAppIntegrationsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("appIntegrationArn", "AppIntegrationArn", cfn_parse.FromCloudFormation.getString(properties.AppIntegrationArn)), ret.addPropertyResult("objectFields", "ObjectFields", properties.ObjectFields != null ? cfn_parse.FromCloudFormation.getStringArray(properties.ObjectFields) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnKnowledgeBase_RenderingConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("templateUri", cdk.validateString)(properties.templateUri)), errors.wrap('supplied properties not correct for "RenderingConfigurationProperty"');
    }
    function cfnKnowledgeBaseRenderingConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnKnowledgeBase_RenderingConfigurationPropertyValidator(properties).assertSuccess(), { TemplateUri: cdk.stringToCloudFormation(properties.templateUri) }) : properties;
    }
    function CfnKnowledgeBaseRenderingConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("templateUri", "TemplateUri", properties.TemplateUri != null ? cfn_parse.FromCloudFormation.getString(properties.TemplateUri) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnKnowledgeBase_ServerSideEncryptionConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("kmsKeyId", cdk.validateString)(properties.kmsKeyId)), errors.wrap('supplied properties not correct for "ServerSideEncryptionConfigurationProperty"');
    }
    function cfnKnowledgeBaseServerSideEncryptionConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnKnowledgeBase_ServerSideEncryptionConfigurationPropertyValidator(properties).assertSuccess(), { KmsKeyId: cdk.stringToCloudFormation(properties.kmsKeyId) }) : properties;
    }
    function CfnKnowledgeBaseServerSideEncryptionConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("kmsKeyId", "KmsKeyId", properties.KmsKeyId != null ? cfn_parse.FromCloudFormation.getString(properties.KmsKeyId) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnKnowledgeBase_SourceConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("appIntegrations", cdk.requiredValidator)(properties.appIntegrations)), errors.collect(cdk.propertyValidator("appIntegrations", CfnKnowledgeBase_AppIntegrationsConfigurationPropertyValidator)(properties.appIntegrations)), errors.wrap('supplied properties not correct for "SourceConfigurationProperty"');
    }
    function cfnKnowledgeBaseSourceConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnKnowledgeBase_SourceConfigurationPropertyValidator(properties).assertSuccess(), { AppIntegrations: cfnKnowledgeBaseAppIntegrationsConfigurationPropertyToCloudFormation(properties.appIntegrations) }) : properties;
    }
    function CfnKnowledgeBaseSourceConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("appIntegrations", "AppIntegrations", CfnKnowledgeBaseAppIntegrationsConfigurationPropertyFromCloudFormation(properties.AppIntegrations)), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-wisdom/lib/index.js
var require_lib257 = __commonJS({
  "node_modules/aws-cdk-lib/aws-wisdom/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_wisdom_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-wisdom/index.js
var require_aws_wisdom = __commonJS({
  "node_modules/aws-cdk-lib/aws-wisdom/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib257(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-workspaces/lib/workspaces.generated.js
var require_workspaces_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-workspaces/lib/workspaces.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnWorkspace = exports2.CfnConnectionAlias = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnConnectionAliasPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("connectionString", cdk.requiredValidator)(properties.connectionString)), errors.collect(cdk.propertyValidator("connectionString", cdk.validateString)(properties.connectionString)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.wrap('supplied properties not correct for "CfnConnectionAliasProps"');
    }
    function cfnConnectionAliasPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnConnectionAliasPropsValidator(properties).assertSuccess(), { ConnectionString: cdk.stringToCloudFormation(properties.connectionString), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnConnectionAliasPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("connectionString", "ConnectionString", cfn_parse.FromCloudFormation.getString(properties.ConnectionString)), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnConnectionAlias = class _CfnConnectionAlias extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnConnectionAliasPropsFromCloudFormation(resourceProperties), ret = new _CfnConnectionAlias(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnConnectionAlias.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_workspaces_CfnConnectionAliasProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnConnectionAlias), error;
        }
        cdk.requireProperty(props, "connectionString", this), this.attrAliasId = cdk.Token.asString(this.getAtt("AliasId", cdk.ResolutionTypeHint.STRING)), this.attrAssociations = this.getAtt("Associations", cdk.ResolutionTypeHint.STRING), this.attrConnectionAliasState = cdk.Token.asString(this.getAtt("ConnectionAliasState", cdk.ResolutionTypeHint.STRING)), this.connectionString = props.connectionString, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::WorkSpaces::ConnectionAlias", props.tags, { tagPropertyName: "tags" });
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnConnectionAlias.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { connectionString: this.connectionString, tags: this.tags.renderTags() };
      }
      renderProperties(props) {
        return cfnConnectionAliasPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnConnectionAlias[_a] = { fqn: "aws-cdk-lib.aws_workspaces.CfnConnectionAlias", version: "2.80.0" }, CfnConnectionAlias.CFN_RESOURCE_TYPE_NAME = "AWS::WorkSpaces::ConnectionAlias", exports2.CfnConnectionAlias = CfnConnectionAlias;
    function CfnWorkspacePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bundleId", cdk.requiredValidator)(properties.bundleId)), errors.collect(cdk.propertyValidator("bundleId", cdk.validateString)(properties.bundleId)), errors.collect(cdk.propertyValidator("directoryId", cdk.requiredValidator)(properties.directoryId)), errors.collect(cdk.propertyValidator("directoryId", cdk.validateString)(properties.directoryId)), errors.collect(cdk.propertyValidator("rootVolumeEncryptionEnabled", cdk.validateBoolean)(properties.rootVolumeEncryptionEnabled)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateCfnTag))(properties.tags)), errors.collect(cdk.propertyValidator("userName", cdk.requiredValidator)(properties.userName)), errors.collect(cdk.propertyValidator("userName", cdk.validateString)(properties.userName)), errors.collect(cdk.propertyValidator("userVolumeEncryptionEnabled", cdk.validateBoolean)(properties.userVolumeEncryptionEnabled)), errors.collect(cdk.propertyValidator("volumeEncryptionKey", cdk.validateString)(properties.volumeEncryptionKey)), errors.collect(cdk.propertyValidator("workspaceProperties", CfnWorkspace_WorkspacePropertiesPropertyValidator)(properties.workspaceProperties)), errors.wrap('supplied properties not correct for "CfnWorkspaceProps"');
    }
    function cfnWorkspacePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkspacePropsValidator(properties).assertSuccess(), { BundleId: cdk.stringToCloudFormation(properties.bundleId), DirectoryId: cdk.stringToCloudFormation(properties.directoryId), UserName: cdk.stringToCloudFormation(properties.userName), RootVolumeEncryptionEnabled: cdk.booleanToCloudFormation(properties.rootVolumeEncryptionEnabled), Tags: cdk.listMapper(cdk.cfnTagToCloudFormation)(properties.tags), UserVolumeEncryptionEnabled: cdk.booleanToCloudFormation(properties.userVolumeEncryptionEnabled), VolumeEncryptionKey: cdk.stringToCloudFormation(properties.volumeEncryptionKey), WorkspaceProperties: cfnWorkspaceWorkspacePropertiesPropertyToCloudFormation(properties.workspaceProperties) }) : properties;
    }
    function CfnWorkspacePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("bundleId", "BundleId", cfn_parse.FromCloudFormation.getString(properties.BundleId)), ret.addPropertyResult("directoryId", "DirectoryId", cfn_parse.FromCloudFormation.getString(properties.DirectoryId)), ret.addPropertyResult("userName", "UserName", cfn_parse.FromCloudFormation.getString(properties.UserName)), ret.addPropertyResult("rootVolumeEncryptionEnabled", "RootVolumeEncryptionEnabled", properties.RootVolumeEncryptionEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.RootVolumeEncryptionEnabled) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getCfnTag)(properties.Tags) : void 0), ret.addPropertyResult("userVolumeEncryptionEnabled", "UserVolumeEncryptionEnabled", properties.UserVolumeEncryptionEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.UserVolumeEncryptionEnabled) : void 0), ret.addPropertyResult("volumeEncryptionKey", "VolumeEncryptionKey", properties.VolumeEncryptionKey != null ? cfn_parse.FromCloudFormation.getString(properties.VolumeEncryptionKey) : void 0), ret.addPropertyResult("workspaceProperties", "WorkspaceProperties", properties.WorkspaceProperties != null ? CfnWorkspaceWorkspacePropertiesPropertyFromCloudFormation(properties.WorkspaceProperties) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnWorkspace = class _CfnWorkspace extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnWorkspacePropsFromCloudFormation(resourceProperties), ret = new _CfnWorkspace(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnWorkspace.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_workspaces_CfnWorkspaceProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnWorkspace), error;
        }
        cdk.requireProperty(props, "bundleId", this), cdk.requireProperty(props, "directoryId", this), cdk.requireProperty(props, "userName", this), this.bundleId = props.bundleId, this.directoryId = props.directoryId, this.userName = props.userName, this.rootVolumeEncryptionEnabled = props.rootVolumeEncryptionEnabled, this.tags = new cdk.TagManager(cdk.TagType.STANDARD, "AWS::WorkSpaces::Workspace", props.tags, { tagPropertyName: "tags" }), this.userVolumeEncryptionEnabled = props.userVolumeEncryptionEnabled, this.volumeEncryptionKey = props.volumeEncryptionKey, this.workspaceProperties = props.workspaceProperties;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnWorkspace.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { bundleId: this.bundleId, directoryId: this.directoryId, userName: this.userName, rootVolumeEncryptionEnabled: this.rootVolumeEncryptionEnabled, tags: this.tags.renderTags(), userVolumeEncryptionEnabled: this.userVolumeEncryptionEnabled, volumeEncryptionKey: this.volumeEncryptionKey, workspaceProperties: this.workspaceProperties };
      }
      renderProperties(props) {
        return cfnWorkspacePropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnWorkspace[_b] = { fqn: "aws-cdk-lib.aws_workspaces.CfnWorkspace", version: "2.80.0" }, CfnWorkspace.CFN_RESOURCE_TYPE_NAME = "AWS::WorkSpaces::Workspace", exports2.CfnWorkspace = CfnWorkspace;
    function CfnWorkspace_WorkspacePropertiesPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("computeTypeName", cdk.validateString)(properties.computeTypeName)), errors.collect(cdk.propertyValidator("rootVolumeSizeGib", cdk.validateNumber)(properties.rootVolumeSizeGib)), errors.collect(cdk.propertyValidator("runningMode", cdk.validateString)(properties.runningMode)), errors.collect(cdk.propertyValidator("runningModeAutoStopTimeoutInMinutes", cdk.validateNumber)(properties.runningModeAutoStopTimeoutInMinutes)), errors.collect(cdk.propertyValidator("userVolumeSizeGib", cdk.validateNumber)(properties.userVolumeSizeGib)), errors.wrap('supplied properties not correct for "WorkspacePropertiesProperty"');
    }
    function cfnWorkspaceWorkspacePropertiesPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnWorkspace_WorkspacePropertiesPropertyValidator(properties).assertSuccess(), { ComputeTypeName: cdk.stringToCloudFormation(properties.computeTypeName), RootVolumeSizeGib: cdk.numberToCloudFormation(properties.rootVolumeSizeGib), RunningMode: cdk.stringToCloudFormation(properties.runningMode), RunningModeAutoStopTimeoutInMinutes: cdk.numberToCloudFormation(properties.runningModeAutoStopTimeoutInMinutes), UserVolumeSizeGib: cdk.numberToCloudFormation(properties.userVolumeSizeGib) }) : properties;
    }
    function CfnWorkspaceWorkspacePropertiesPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("computeTypeName", "ComputeTypeName", properties.ComputeTypeName != null ? cfn_parse.FromCloudFormation.getString(properties.ComputeTypeName) : void 0), ret.addPropertyResult("rootVolumeSizeGib", "RootVolumeSizeGib", properties.RootVolumeSizeGib != null ? cfn_parse.FromCloudFormation.getNumber(properties.RootVolumeSizeGib) : void 0), ret.addPropertyResult("runningMode", "RunningMode", properties.RunningMode != null ? cfn_parse.FromCloudFormation.getString(properties.RunningMode) : void 0), ret.addPropertyResult("runningModeAutoStopTimeoutInMinutes", "RunningModeAutoStopTimeoutInMinutes", properties.RunningModeAutoStopTimeoutInMinutes != null ? cfn_parse.FromCloudFormation.getNumber(properties.RunningModeAutoStopTimeoutInMinutes) : void 0), ret.addPropertyResult("userVolumeSizeGib", "UserVolumeSizeGib", properties.UserVolumeSizeGib != null ? cfn_parse.FromCloudFormation.getNumber(properties.UserVolumeSizeGib) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-workspaces/lib/index.js
var require_lib258 = __commonJS({
  "node_modules/aws-cdk-lib/aws-workspaces/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_workspaces_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-workspaces/index.js
var require_aws_workspaces = __commonJS({
  "node_modules/aws-cdk-lib/aws-workspaces/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib258(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-xray/lib/xray.generated.js
var require_xray_generated = __commonJS({
  "node_modules/aws-cdk-lib/aws-xray/lib/xray.generated.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    var _c;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnSamplingRule = exports2.CfnResourcePolicy = exports2.CfnGroup = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var cdk = require_core2();
    var cfn_parse = require_helpers_internal();
    function CfnGroupPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("filterExpression", cdk.validateString)(properties.filterExpression)), errors.collect(cdk.propertyValidator("groupName", cdk.validateString)(properties.groupName)), errors.collect(cdk.propertyValidator("insightsConfiguration", CfnGroup_InsightsConfigurationPropertyValidator)(properties.insightsConfiguration)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateObject))(properties.tags)), errors.wrap('supplied properties not correct for "CfnGroupProps"');
    }
    function cfnGroupPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGroupPropsValidator(properties).assertSuccess(), { FilterExpression: cdk.stringToCloudFormation(properties.filterExpression), GroupName: cdk.stringToCloudFormation(properties.groupName), InsightsConfiguration: cfnGroupInsightsConfigurationPropertyToCloudFormation(properties.insightsConfiguration), Tags: cdk.listMapper(cdk.objectToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnGroupPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("filterExpression", "FilterExpression", properties.FilterExpression != null ? cfn_parse.FromCloudFormation.getString(properties.FilterExpression) : void 0), ret.addPropertyResult("groupName", "GroupName", properties.GroupName != null ? cfn_parse.FromCloudFormation.getString(properties.GroupName) : void 0), ret.addPropertyResult("insightsConfiguration", "InsightsConfiguration", properties.InsightsConfiguration != null ? CfnGroupInsightsConfigurationPropertyFromCloudFormation(properties.InsightsConfiguration) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getAny)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnGroup = class _CfnGroup extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnGroupPropsFromCloudFormation(resourceProperties), ret = new _CfnGroup(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnGroup.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_xray_CfnGroupProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnGroup), error;
        }
        this.attrGroupArn = cdk.Token.asString(this.getAtt("GroupARN", cdk.ResolutionTypeHint.STRING)), this.filterExpression = props.filterExpression, this.groupName = props.groupName, this.insightsConfiguration = props.insightsConfiguration, this.tags = props.tags;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnGroup.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { filterExpression: this.filterExpression, groupName: this.groupName, insightsConfiguration: this.insightsConfiguration, tags: this.tags };
      }
      renderProperties(props) {
        return cfnGroupPropsToCloudFormation(props);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnGroup[_a] = { fqn: "aws-cdk-lib.aws_xray.CfnGroup", version: "2.80.0" }, CfnGroup.CFN_RESOURCE_TYPE_NAME = "AWS::XRay::Group", exports2.CfnGroup = CfnGroup;
    function CfnGroup_InsightsConfigurationPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("insightsEnabled", cdk.validateBoolean)(properties.insightsEnabled)), errors.collect(cdk.propertyValidator("notificationsEnabled", cdk.validateBoolean)(properties.notificationsEnabled)), errors.wrap('supplied properties not correct for "InsightsConfigurationProperty"');
    }
    function cfnGroupInsightsConfigurationPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnGroup_InsightsConfigurationPropertyValidator(properties).assertSuccess(), { InsightsEnabled: cdk.booleanToCloudFormation(properties.insightsEnabled), NotificationsEnabled: cdk.booleanToCloudFormation(properties.notificationsEnabled) }) : properties;
    }
    function CfnGroupInsightsConfigurationPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("insightsEnabled", "InsightsEnabled", properties.InsightsEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.InsightsEnabled) : void 0), ret.addPropertyResult("notificationsEnabled", "NotificationsEnabled", properties.NotificationsEnabled != null ? cfn_parse.FromCloudFormation.getBoolean(properties.NotificationsEnabled) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnResourcePolicyPropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("bypassPolicyLockoutCheck", cdk.validateBoolean)(properties.bypassPolicyLockoutCheck)), errors.collect(cdk.propertyValidator("policyDocument", cdk.requiredValidator)(properties.policyDocument)), errors.collect(cdk.propertyValidator("policyDocument", cdk.validateString)(properties.policyDocument)), errors.collect(cdk.propertyValidator("policyName", cdk.requiredValidator)(properties.policyName)), errors.collect(cdk.propertyValidator("policyName", cdk.validateString)(properties.policyName)), errors.wrap('supplied properties not correct for "CfnResourcePolicyProps"');
    }
    function cfnResourcePolicyPropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnResourcePolicyPropsValidator(properties).assertSuccess(), { PolicyDocument: cdk.stringToCloudFormation(properties.policyDocument), PolicyName: cdk.stringToCloudFormation(properties.policyName), BypassPolicyLockoutCheck: cdk.booleanToCloudFormation(properties.bypassPolicyLockoutCheck) }) : properties;
    }
    function CfnResourcePolicyPropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("policyDocument", "PolicyDocument", cfn_parse.FromCloudFormation.getString(properties.PolicyDocument)), ret.addPropertyResult("policyName", "PolicyName", cfn_parse.FromCloudFormation.getString(properties.PolicyName)), ret.addPropertyResult("bypassPolicyLockoutCheck", "BypassPolicyLockoutCheck", properties.BypassPolicyLockoutCheck != null ? cfn_parse.FromCloudFormation.getBoolean(properties.BypassPolicyLockoutCheck) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnResourcePolicy = class _CfnResourcePolicy extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnResourcePolicyPropsFromCloudFormation(resourceProperties), ret = new _CfnResourcePolicy(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props) {
        super(scope, id, { type: _CfnResourcePolicy.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_xray_CfnResourcePolicyProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnResourcePolicy), error;
        }
        cdk.requireProperty(props, "policyDocument", this), cdk.requireProperty(props, "policyName", this), this.policyDocument = props.policyDocument, this.policyName = props.policyName, this.bypassPolicyLockoutCheck = props.bypassPolicyLockoutCheck;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnResourcePolicy.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { policyDocument: this.policyDocument, policyName: this.policyName, bypassPolicyLockoutCheck: this.bypassPolicyLockoutCheck };
      }
      renderProperties(props) {
        return cfnResourcePolicyPropsToCloudFormation(props);
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CfnResourcePolicy[_b] = { fqn: "aws-cdk-lib.aws_xray.CfnResourcePolicy", version: "2.80.0" }, CfnResourcePolicy.CFN_RESOURCE_TYPE_NAME = "AWS::XRay::ResourcePolicy", exports2.CfnResourcePolicy = CfnResourcePolicy;
    function CfnSamplingRulePropsValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("ruleName", cdk.validateString)(properties.ruleName)), errors.collect(cdk.propertyValidator("samplingRule", CfnSamplingRule_SamplingRulePropertyValidator)(properties.samplingRule)), errors.collect(cdk.propertyValidator("samplingRuleRecord", CfnSamplingRule_SamplingRuleRecordPropertyValidator)(properties.samplingRuleRecord)), errors.collect(cdk.propertyValidator("samplingRuleUpdate", CfnSamplingRule_SamplingRuleUpdatePropertyValidator)(properties.samplingRuleUpdate)), errors.collect(cdk.propertyValidator("tags", cdk.listValidator(cdk.validateObject))(properties.tags)), errors.wrap('supplied properties not correct for "CfnSamplingRuleProps"');
    }
    function cfnSamplingRulePropsToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSamplingRulePropsValidator(properties).assertSuccess(), { RuleName: cdk.stringToCloudFormation(properties.ruleName), SamplingRule: cfnSamplingRuleSamplingRulePropertyToCloudFormation(properties.samplingRule), SamplingRuleRecord: cfnSamplingRuleSamplingRuleRecordPropertyToCloudFormation(properties.samplingRuleRecord), SamplingRuleUpdate: cfnSamplingRuleSamplingRuleUpdatePropertyToCloudFormation(properties.samplingRuleUpdate), Tags: cdk.listMapper(cdk.objectToCloudFormation)(properties.tags) }) : properties;
    }
    function CfnSamplingRulePropsFromCloudFormation(properties) {
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("ruleName", "RuleName", properties.RuleName != null ? cfn_parse.FromCloudFormation.getString(properties.RuleName) : void 0), ret.addPropertyResult("samplingRule", "SamplingRule", properties.SamplingRule != null ? CfnSamplingRuleSamplingRulePropertyFromCloudFormation(properties.SamplingRule) : void 0), ret.addPropertyResult("samplingRuleRecord", "SamplingRuleRecord", properties.SamplingRuleRecord != null ? CfnSamplingRuleSamplingRuleRecordPropertyFromCloudFormation(properties.SamplingRuleRecord) : void 0), ret.addPropertyResult("samplingRuleUpdate", "SamplingRuleUpdate", properties.SamplingRuleUpdate != null ? CfnSamplingRuleSamplingRuleUpdatePropertyFromCloudFormation(properties.SamplingRuleUpdate) : void 0), ret.addPropertyResult("tags", "Tags", properties.Tags != null ? cfn_parse.FromCloudFormation.getArray(cfn_parse.FromCloudFormation.getAny)(properties.Tags) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    var CfnSamplingRule = class _CfnSamplingRule extends cdk.CfnResource {
      static _fromCloudFormation(scope, id, resourceAttributes, options) {
        resourceAttributes = resourceAttributes || {};
        const resourceProperties = options.parser.parseValue(resourceAttributes.Properties), propsResult = CfnSamplingRulePropsFromCloudFormation(resourceProperties), ret = new _CfnSamplingRule(scope, id, propsResult.value);
        for (const [propKey, propVal] of Object.entries(propsResult.extraProperties))
          ret.addPropertyOverride(propKey, propVal);
        return options.parser.handleAttributes(ret, resourceAttributes, id), ret;
      }
      constructor(scope, id, props = {}) {
        super(scope, id, { type: _CfnSamplingRule.CFN_RESOURCE_TYPE_NAME, properties: props });
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_xray_CfnSamplingRuleProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnSamplingRule), error;
        }
        this.attrRuleArn = cdk.Token.asString(this.getAtt("RuleARN", cdk.ResolutionTypeHint.STRING)), this.ruleName = props.ruleName, this.samplingRule = props.samplingRule, this.samplingRuleRecord = props.samplingRuleRecord, this.samplingRuleUpdate = props.samplingRuleUpdate, this.tags = props.tags;
      }
      inspect(inspector) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_TreeInspector(inspector);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.inspect), error;
        }
        inspector.addAttribute("aws:cdk:cloudformation:type", _CfnSamplingRule.CFN_RESOURCE_TYPE_NAME), inspector.addAttribute("aws:cdk:cloudformation:props", this.cfnProperties);
      }
      get cfnProperties() {
        return { ruleName: this.ruleName, samplingRule: this.samplingRule, samplingRuleRecord: this.samplingRuleRecord, samplingRuleUpdate: this.samplingRuleUpdate, tags: this.tags };
      }
      renderProperties(props) {
        return cfnSamplingRulePropsToCloudFormation(props);
      }
    };
    _c = JSII_RTTI_SYMBOL_1, CfnSamplingRule[_c] = { fqn: "aws-cdk-lib.aws_xray.CfnSamplingRule", version: "2.80.0" }, CfnSamplingRule.CFN_RESOURCE_TYPE_NAME = "AWS::XRay::SamplingRule", exports2.CfnSamplingRule = CfnSamplingRule;
    function CfnSamplingRule_SamplingRulePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributes", cdk.hashValidator(cdk.validateString))(properties.attributes)), errors.collect(cdk.propertyValidator("fixedRate", cdk.validateNumber)(properties.fixedRate)), errors.collect(cdk.propertyValidator("httpMethod", cdk.validateString)(properties.httpMethod)), errors.collect(cdk.propertyValidator("host", cdk.validateString)(properties.host)), errors.collect(cdk.propertyValidator("priority", cdk.validateNumber)(properties.priority)), errors.collect(cdk.propertyValidator("reservoirSize", cdk.validateNumber)(properties.reservoirSize)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.collect(cdk.propertyValidator("ruleArn", cdk.validateString)(properties.ruleArn)), errors.collect(cdk.propertyValidator("ruleName", cdk.validateString)(properties.ruleName)), errors.collect(cdk.propertyValidator("serviceName", cdk.validateString)(properties.serviceName)), errors.collect(cdk.propertyValidator("serviceType", cdk.validateString)(properties.serviceType)), errors.collect(cdk.propertyValidator("urlPath", cdk.validateString)(properties.urlPath)), errors.collect(cdk.propertyValidator("version", cdk.validateNumber)(properties.version)), errors.wrap('supplied properties not correct for "SamplingRuleProperty"');
    }
    function cfnSamplingRuleSamplingRulePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSamplingRule_SamplingRulePropertyValidator(properties).assertSuccess(), { Attributes: cdk.hashMapper(cdk.stringToCloudFormation)(properties.attributes), FixedRate: cdk.numberToCloudFormation(properties.fixedRate), HTTPMethod: cdk.stringToCloudFormation(properties.httpMethod), Host: cdk.stringToCloudFormation(properties.host), Priority: cdk.numberToCloudFormation(properties.priority), ReservoirSize: cdk.numberToCloudFormation(properties.reservoirSize), ResourceARN: cdk.stringToCloudFormation(properties.resourceArn), RuleARN: cdk.stringToCloudFormation(properties.ruleArn), RuleName: cdk.stringToCloudFormation(properties.ruleName), ServiceName: cdk.stringToCloudFormation(properties.serviceName), ServiceType: cdk.stringToCloudFormation(properties.serviceType), URLPath: cdk.stringToCloudFormation(properties.urlPath), Version: cdk.numberToCloudFormation(properties.version) }) : properties;
    }
    function CfnSamplingRuleSamplingRulePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attributes", "Attributes", properties.Attributes != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Attributes) : void 0), ret.addPropertyResult("fixedRate", "FixedRate", properties.FixedRate != null ? cfn_parse.FromCloudFormation.getNumber(properties.FixedRate) : void 0), ret.addPropertyResult("httpMethod", "HTTPMethod", properties.HTTPMethod != null ? cfn_parse.FromCloudFormation.getString(properties.HTTPMethod) : void 0), ret.addPropertyResult("host", "Host", properties.Host != null ? cfn_parse.FromCloudFormation.getString(properties.Host) : void 0), ret.addPropertyResult("priority", "Priority", properties.Priority != null ? cfn_parse.FromCloudFormation.getNumber(properties.Priority) : void 0), ret.addPropertyResult("reservoirSize", "ReservoirSize", properties.ReservoirSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.ReservoirSize) : void 0), ret.addPropertyResult("resourceArn", "ResourceARN", properties.ResourceARN != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceARN) : void 0), ret.addPropertyResult("ruleArn", "RuleARN", properties.RuleARN != null ? cfn_parse.FromCloudFormation.getString(properties.RuleARN) : void 0), ret.addPropertyResult("ruleName", "RuleName", properties.RuleName != null ? cfn_parse.FromCloudFormation.getString(properties.RuleName) : void 0), ret.addPropertyResult("serviceName", "ServiceName", properties.ServiceName != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceName) : void 0), ret.addPropertyResult("serviceType", "ServiceType", properties.ServiceType != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceType) : void 0), ret.addPropertyResult("urlPath", "URLPath", properties.URLPath != null ? cfn_parse.FromCloudFormation.getString(properties.URLPath) : void 0), ret.addPropertyResult("version", "Version", properties.Version != null ? cfn_parse.FromCloudFormation.getNumber(properties.Version) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSamplingRule_SamplingRuleRecordPropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("createdAt", cdk.validateString)(properties.createdAt)), errors.collect(cdk.propertyValidator("modifiedAt", cdk.validateString)(properties.modifiedAt)), errors.collect(cdk.propertyValidator("samplingRule", CfnSamplingRule_SamplingRulePropertyValidator)(properties.samplingRule)), errors.wrap('supplied properties not correct for "SamplingRuleRecordProperty"');
    }
    function cfnSamplingRuleSamplingRuleRecordPropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSamplingRule_SamplingRuleRecordPropertyValidator(properties).assertSuccess(), { CreatedAt: cdk.stringToCloudFormation(properties.createdAt), ModifiedAt: cdk.stringToCloudFormation(properties.modifiedAt), SamplingRule: cfnSamplingRuleSamplingRulePropertyToCloudFormation(properties.samplingRule) }) : properties;
    }
    function CfnSamplingRuleSamplingRuleRecordPropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("createdAt", "CreatedAt", properties.CreatedAt != null ? cfn_parse.FromCloudFormation.getString(properties.CreatedAt) : void 0), ret.addPropertyResult("modifiedAt", "ModifiedAt", properties.ModifiedAt != null ? cfn_parse.FromCloudFormation.getString(properties.ModifiedAt) : void 0), ret.addPropertyResult("samplingRule", "SamplingRule", properties.SamplingRule != null ? CfnSamplingRuleSamplingRulePropertyFromCloudFormation(properties.SamplingRule) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
    function CfnSamplingRule_SamplingRuleUpdatePropertyValidator(properties) {
      if (!cdk.canInspect(properties))
        return cdk.VALIDATION_SUCCESS;
      const errors = new cdk.ValidationResults();
      return typeof properties != "object" && errors.collect(new cdk.ValidationResult("Expected an object, but received: " + JSON.stringify(properties))), errors.collect(cdk.propertyValidator("attributes", cdk.hashValidator(cdk.validateString))(properties.attributes)), errors.collect(cdk.propertyValidator("fixedRate", cdk.validateNumber)(properties.fixedRate)), errors.collect(cdk.propertyValidator("httpMethod", cdk.validateString)(properties.httpMethod)), errors.collect(cdk.propertyValidator("host", cdk.validateString)(properties.host)), errors.collect(cdk.propertyValidator("priority", cdk.validateNumber)(properties.priority)), errors.collect(cdk.propertyValidator("reservoirSize", cdk.validateNumber)(properties.reservoirSize)), errors.collect(cdk.propertyValidator("resourceArn", cdk.validateString)(properties.resourceArn)), errors.collect(cdk.propertyValidator("ruleArn", cdk.validateString)(properties.ruleArn)), errors.collect(cdk.propertyValidator("ruleName", cdk.validateString)(properties.ruleName)), errors.collect(cdk.propertyValidator("serviceName", cdk.validateString)(properties.serviceName)), errors.collect(cdk.propertyValidator("serviceType", cdk.validateString)(properties.serviceType)), errors.collect(cdk.propertyValidator("urlPath", cdk.validateString)(properties.urlPath)), errors.wrap('supplied properties not correct for "SamplingRuleUpdateProperty"');
    }
    function cfnSamplingRuleSamplingRuleUpdatePropertyToCloudFormation(properties) {
      return cdk.canInspect(properties) ? (CfnSamplingRule_SamplingRuleUpdatePropertyValidator(properties).assertSuccess(), { Attributes: cdk.hashMapper(cdk.stringToCloudFormation)(properties.attributes), FixedRate: cdk.numberToCloudFormation(properties.fixedRate), HTTPMethod: cdk.stringToCloudFormation(properties.httpMethod), Host: cdk.stringToCloudFormation(properties.host), Priority: cdk.numberToCloudFormation(properties.priority), ReservoirSize: cdk.numberToCloudFormation(properties.reservoirSize), ResourceARN: cdk.stringToCloudFormation(properties.resourceArn), RuleARN: cdk.stringToCloudFormation(properties.ruleArn), RuleName: cdk.stringToCloudFormation(properties.ruleName), ServiceName: cdk.stringToCloudFormation(properties.serviceName), ServiceType: cdk.stringToCloudFormation(properties.serviceType), URLPath: cdk.stringToCloudFormation(properties.urlPath) }) : properties;
    }
    function CfnSamplingRuleSamplingRuleUpdatePropertyFromCloudFormation(properties) {
      if (cdk.isResolvableObject(properties))
        return new cfn_parse.FromCloudFormationResult(properties);
      if (properties = properties ?? {}, typeof properties != "object")
        return new cfn_parse.FromCloudFormationResult(properties);
      const ret = new cfn_parse.FromCloudFormationPropertyObject();
      return ret.addPropertyResult("attributes", "Attributes", properties.Attributes != null ? cfn_parse.FromCloudFormation.getMap(cfn_parse.FromCloudFormation.getString)(properties.Attributes) : void 0), ret.addPropertyResult("fixedRate", "FixedRate", properties.FixedRate != null ? cfn_parse.FromCloudFormation.getNumber(properties.FixedRate) : void 0), ret.addPropertyResult("httpMethod", "HTTPMethod", properties.HTTPMethod != null ? cfn_parse.FromCloudFormation.getString(properties.HTTPMethod) : void 0), ret.addPropertyResult("host", "Host", properties.Host != null ? cfn_parse.FromCloudFormation.getString(properties.Host) : void 0), ret.addPropertyResult("priority", "Priority", properties.Priority != null ? cfn_parse.FromCloudFormation.getNumber(properties.Priority) : void 0), ret.addPropertyResult("reservoirSize", "ReservoirSize", properties.ReservoirSize != null ? cfn_parse.FromCloudFormation.getNumber(properties.ReservoirSize) : void 0), ret.addPropertyResult("resourceArn", "ResourceARN", properties.ResourceARN != null ? cfn_parse.FromCloudFormation.getString(properties.ResourceARN) : void 0), ret.addPropertyResult("ruleArn", "RuleARN", properties.RuleARN != null ? cfn_parse.FromCloudFormation.getString(properties.RuleARN) : void 0), ret.addPropertyResult("ruleName", "RuleName", properties.RuleName != null ? cfn_parse.FromCloudFormation.getString(properties.RuleName) : void 0), ret.addPropertyResult("serviceName", "ServiceName", properties.ServiceName != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceName) : void 0), ret.addPropertyResult("serviceType", "ServiceType", properties.ServiceType != null ? cfn_parse.FromCloudFormation.getString(properties.ServiceType) : void 0), ret.addPropertyResult("urlPath", "URLPath", properties.URLPath != null ? cfn_parse.FromCloudFormation.getString(properties.URLPath) : void 0), ret.addUnrecognizedPropertiesAsExtra(properties), ret;
    }
  }
});

// node_modules/aws-cdk-lib/aws-xray/lib/index.js
var require_lib259 = __commonJS({
  "node_modules/aws-cdk-lib/aws-xray/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_xray_generated(), exports2);
  }
});

// node_modules/aws-cdk-lib/aws-xray/index.js
var require_aws_xray = __commonJS({
  "node_modules/aws-cdk-lib/aws-xray/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib259(), exports2);
  }
});

// node_modules/aws-cdk-lib/cloudformation-include/lib/private/yaml-cfn.js
var require_yaml_cfn3 = __commonJS({
  "node_modules/aws-cdk-lib/cloudformation-include/lib/private/yaml-cfn.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.deserialize = exports2.serialize = void 0;
    var yaml = require_yaml();
    var yaml_types = require_types3();
    function serialize(obj) {
      const oldFold = yaml_types.strOptions.fold.lineWidth;
      try {
        return yaml_types.strOptions.fold.lineWidth = 0, yaml.stringify(obj, { schema: "yaml-1.1" });
      } finally {
        yaml_types.strOptions.fold.lineWidth = oldFold;
      }
    }
    exports2.serialize = serialize;
    function deserialize(str) {
      return parseYamlStrWithCfnTags(str);
    }
    exports2.deserialize = deserialize;
    function makeTagForCfnIntrinsic(intrinsicName, addFnPrefix) {
      return { identify(value) {
        return typeof value == "string";
      }, tag: `!${intrinsicName}`, resolve: (_doc, cstNode) => {
        const ret = {};
        return ret[addFnPrefix ? `Fn::${intrinsicName}` : intrinsicName] = parseYamlStrWithCfnTags(cstNode.toString().substring(intrinsicName.length + 1)), ret;
      } };
    }
    var shortForms = ["Base64", "Cidr", "FindInMap", "GetAZs", "ImportValue", "Join", "Sub", "Select", "Split", "Transform", "And", "Equals", "If", "Not", "Or", "GetAtt"].map((name) => makeTagForCfnIntrinsic(name, true)).concat(makeTagForCfnIntrinsic("Ref", false), makeTagForCfnIntrinsic("Condition", false));
    function parseYamlStrWithCfnTags(text) {
      return yaml.parse(text, { customTags: shortForms, schema: "core" });
    }
  }
});

// node_modules/aws-cdk-lib/cloudformation-include/lib/file-utils.js
var require_file_utils = __commonJS({
  "node_modules/aws-cdk-lib/cloudformation-include/lib/file-utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.readYamlSync = exports2.readJsonSync = void 0;
    var fs = require("fs");
    var yaml_cfn = require_yaml_cfn3();
    function readJsonSync(filePath) {
      const fileContents = fs.readFileSync(filePath);
      return JSON.parse(fileContents.toString());
    }
    exports2.readJsonSync = readJsonSync;
    function readYamlSync(filePath) {
      const fileContents = fs.readFileSync(filePath);
      return yaml_cfn.deserialize(fileContents.toString());
    }
    exports2.readYamlSync = readYamlSync;
  }
});

// node_modules/aws-cdk-lib/cloudformation-include/lib/cfn-type-to-l1-mapping.js
var require_cfn_type_to_l1_mapping = __commonJS({
  "node_modules/aws-cdk-lib/cloudformation-include/lib/cfn-type-to-l1-mapping.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.lookup = void 0;
    var path = require("path");
    var futils = require_file_utils();
    var cfnTypeToL1Mapping;
    function lookup(cfnType) {
      return cfnTypeToL1Mapping || (cfnTypeToL1Mapping = loadCfnTypeToL1Mapping()), cfnTypeToL1Mapping[cfnType];
    }
    exports2.lookup = lookup;
    function loadCfnTypeToL1Mapping() {
      return futils.readJsonSync(path.join(__dirname, "..", "cfn-types-2-classes.json"));
    }
  }
});

// node_modules/aws-cdk-lib/cloudformation-include/lib/cfn-include.js
var require_cfn_include2 = __commonJS({
  "node_modules/aws-cdk-lib/cloudformation-include/lib/cfn-include.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CfnInclude = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var cfn_type_to_l1_mapping = require_cfn_type_to_l1_mapping();
    var futils = require_file_utils();
    var core = require_core2();
    var cfn_parse = require_helpers_internal();
    var CfnInclude = class _CfnInclude extends core.CfnElement {
      constructor(scope, id, props) {
        super(scope, id), this.conditions = {}, this.resources = {}, this.parameters = {}, this.mappings = {}, this.rules = {}, this.hooks = {}, this.outputs = {}, this.nestedStacks = {};
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_cloudformation_include_CfnIncludeProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CfnInclude), error;
        }
        this.allowCyclicalReferences = props.allowCyclicalReferences ?? false, this.logicalIdToPlaceholderMap = /* @__PURE__ */ new Map(), this.parametersToReplace = props.parameters || {}, this.template = futils.readYamlSync(props.templateFile), this.preserveLogicalIds = props.preserveLogicalIds ?? true;
        for (const logicalId of Object.keys(this.parametersToReplace))
          if (!(logicalId in (this.template.Parameters || {})))
            throw new Error(`Parameter with logical ID '${logicalId}' was not found in the template`);
        this.mappingsScope = new constructs_1.Construct(this, "$Mappings");
        for (const mappingName of Object.keys(this.template.Mappings || {}))
          this.createMapping(mappingName);
        for (const logicalId of Object.keys(this.template.Parameters || {}))
          this.createParameter(logicalId);
        this.conditionsScope = new constructs_1.Construct(this, "$Conditions");
        for (const conditionName of Object.keys(this.template.Conditions || {}))
          this.getOrCreateCondition(conditionName);
        this.rulesScope = new constructs_1.Construct(this, "$Rules");
        for (const ruleName of Object.keys(this.template.Rules || {}))
          this.createRule(ruleName);
        this.nestedStacksToInclude = props.loadNestedStacks || {};
        for (const logicalId of Object.keys(this.template.Resources || {}))
          this.getOrCreateResource(logicalId);
        for (const nestedStackId of Object.keys(props.loadNestedStacks || {}))
          if (!(nestedStackId in this.resources))
            throw new Error(`Nested Stack with logical ID '${nestedStackId}' was not found in the template`);
        this.hooksScope = new constructs_1.Construct(this, "$Hooks");
        for (const hookName of Object.keys(this.template.Hooks || {}))
          this.createHook(hookName);
        const outputScope = new constructs_1.Construct(this, "$Ouputs");
        for (const logicalId of Object.keys(this.template.Outputs || {}))
          this.createOutput(logicalId, outputScope);
      }
      getResource(logicalId) {
        const ret = this.resources[logicalId];
        if (!ret)
          throw new Error(`Resource with logical ID '${logicalId}' was not found in the template`);
        return ret;
      }
      getCondition(conditionName) {
        const ret = this.conditions[conditionName];
        if (!ret)
          throw new Error(`Condition with name '${conditionName}' was not found in the template`);
        return ret;
      }
      getParameter(parameterName) {
        const ret = this.parameters[parameterName];
        if (!ret)
          throw new Error(`Parameter with name '${parameterName}' was not found in the template`);
        return ret;
      }
      getMapping(mappingName) {
        const ret = this.mappings[mappingName];
        if (!ret)
          throw new Error(`Mapping with name '${mappingName}' was not found in the template`);
        return ret;
      }
      getOutput(logicalId) {
        const ret = this.outputs[logicalId];
        if (!ret)
          throw new Error(`Output with logical ID '${logicalId}' was not found in the template`);
        return ret;
      }
      getRule(ruleName) {
        const ret = this.rules[ruleName];
        if (!ret)
          throw new Error(`Rule with name '${ruleName}' was not found in the template`);
        return ret;
      }
      getHook(hookLogicalId) {
        const ret = this.hooks[hookLogicalId];
        if (!ret)
          throw new Error(`Hook with logical ID '${hookLogicalId}' was not found in the template`);
        return ret;
      }
      getNestedStack(logicalId) {
        if (!this.nestedStacks[logicalId])
          throw this.template.Resources[logicalId] ? this.template.Resources[logicalId].Type !== "AWS::CloudFormation::Stack" ? new Error(`Resource with logical ID '${logicalId}' is not a CloudFormation Stack`) : new Error(`Nested Stack '${logicalId}' was not included in the parent template. To retrieve an included nested stack, it must be specified either in the \`loadNestedStacks\` property, or through the \`loadNestedStack\` method`) : new Error(`Nested Stack with logical ID '${logicalId}' was not found in the template`);
        return this.nestedStacks[logicalId];
      }
      loadNestedStack(logicalId, nestedStackProps) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_cloudformation_include_CfnIncludeProps(nestedStackProps);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.loadNestedStack), error;
        }
        if (logicalId in this.nestedStacks)
          throw new Error(`Nested Stack '${logicalId}' was already included in its parent template`);
        const cfnStack = this.resources[logicalId];
        if (!cfnStack)
          throw new Error(`Nested Stack with logical ID '${logicalId}' was not found in the template`);
        if (cfnStack instanceof core.CfnStack)
          return this.node.tryRemoveChild(logicalId), delete this.resources[logicalId], this.nestedStacksToInclude[logicalId] = nestedStackProps, this.getOrCreateResource(logicalId), this.nestedStacks[logicalId];
        throw new Error(`Nested Stack with logical ID '${logicalId}' is not an AWS::CloudFormation::Stack resource`);
      }
      _toCloudFormation() {
        const ret = {};
        for (const section of Object.keys(this.template)) {
          const self2 = this, finder = { findResource(lId) {
            return self2.resources[lId];
          }, findRefTarget(elementName) {
            return self2.resources[elementName] ?? self2.parameters[elementName];
          }, findCondition(conditionName) {
            return self2.conditions[conditionName];
          }, findMapping(mappingName) {
            return self2.mappings[mappingName];
          } }, cfnParser = new cfn_parse.CfnParser({ finder, parameters: this.parametersToReplace });
          switch (section) {
            case "Conditions":
            case "Mappings":
            case "Resources":
            case "Parameters":
            case "Rules":
            case "Hooks":
            case "Outputs":
              break;
            default:
              ret[section] = cfnParser.parseValue(this.template[section]);
          }
        }
        return ret;
      }
      createMapping(mappingName) {
        const cfnParser = new cfn_parse.CfnParser({ finder: { findCondition() {
          throw new Error("Referring to Conditions in Mapping definitions is not allowed");
        }, findMapping() {
          throw new Error("Referring to other Mappings in Mapping definitions is not allowed");
        }, findRefTarget() {
          throw new Error("Using Ref expressions in Mapping definitions is not allowed");
        }, findResource() {
          throw new Error("Using GetAtt expressions in Mapping definitions is not allowed");
        } }, parameters: {} }), cfnMapping = new core.CfnMapping(this.mappingsScope, mappingName, { mapping: cfnParser.parseValue(this.template.Mappings[mappingName]) });
        this.mappings[mappingName] = cfnMapping, this.overrideLogicalIdIfNeeded(cfnMapping, mappingName);
      }
      createParameter(logicalId) {
        if (logicalId in this.parametersToReplace)
          return;
        const expression = new cfn_parse.CfnParser({ finder: { findResource() {
          throw new Error("Using GetAtt expressions in Parameter definitions is not allowed");
        }, findRefTarget() {
          throw new Error("Using Ref expressions in Parameter definitions is not allowed");
        }, findCondition() {
          throw new Error("Referring to Conditions in Parameter definitions is not allowed");
        }, findMapping() {
          throw new Error("Referring to Mappings in Parameter definitions is not allowed");
        } }, parameters: {} }).parseValue(this.template.Parameters[logicalId]), cfnParameter = new core.CfnParameter(this, logicalId, { type: expression.Type, default: expression.Default, allowedPattern: expression.AllowedPattern, allowedValues: expression.AllowedValues, constraintDescription: expression.ConstraintDescription, description: expression.Description, maxLength: expression.MaxLength, maxValue: expression.MaxValue, minLength: expression.MinLength, minValue: expression.MinValue, noEcho: expression.NoEcho });
        this.overrideLogicalIdIfNeeded(cfnParameter, logicalId), this.parameters[logicalId] = cfnParameter;
      }
      createRule(ruleName) {
        const self2 = this, ruleProperties = new cfn_parse.CfnParser({ finder: { findRefTarget(refTarget) {
          return self2.parameters[refTarget];
        }, findResource() {
          throw new Error("Using GetAtt expressions in Rule definitions is not allowed");
        }, findCondition(conditionName) {
          return self2.conditions[conditionName];
        }, findMapping(mappingName) {
          return self2.mappings[mappingName];
        } }, parameters: this.parametersToReplace, context: cfn_parse.CfnParsingContext.RULES }).parseValue(this.template.Rules[ruleName]), rule = new core.CfnRule(this.rulesScope, ruleName, { ruleCondition: ruleProperties.RuleCondition, assertions: ruleProperties.Assertions });
        this.rules[ruleName] = rule, this.overrideLogicalIdIfNeeded(rule, ruleName);
      }
      createHook(hookName) {
        const self2 = this, cfnParser = new cfn_parse.CfnParser({ finder: { findResource(lId) {
          return self2.resources[lId];
        }, findRefTarget(elementName) {
          return self2.resources[elementName] ?? self2.parameters[elementName];
        }, findCondition(conditionName) {
          return self2.conditions[conditionName];
        }, findMapping(mappingName) {
          return self2.mappings[mappingName];
        } }, parameters: this.parametersToReplace }), hookAttributes = this.template.Hooks[hookName];
        let hook;
        switch (hookAttributes.Type) {
          case "AWS::CodeDeploy::BlueGreen":
            hook = core.CfnCodeDeployBlueGreenHook._fromCloudFormation(this.hooksScope, hookName, hookAttributes, { parser: cfnParser });
            break;
          default: {
            const hookProperties = cfnParser.parseValue(hookAttributes.Properties) ?? {};
            hook = new core.CfnHook(this.hooksScope, hookName, { type: hookAttributes.Type, properties: hookProperties });
          }
        }
        this.hooks[hookName] = hook, this.overrideLogicalIdIfNeeded(hook, hookName);
      }
      createOutput(logicalId, scope) {
        const self2 = this, outputAttributes = new cfn_parse.CfnParser({ finder: { findResource(lId) {
          return self2.resources[lId];
        }, findRefTarget(elementName) {
          return self2.resources[elementName] ?? self2.parameters[elementName];
        }, findCondition(conditionName) {
          return self2.conditions[conditionName];
        }, findMapping(mappingName) {
          return self2.mappings[mappingName];
        } }, parameters: this.parametersToReplace }).parseValue(this.template.Outputs[logicalId]), cfnOutput = new core.CfnOutput(scope, logicalId, { value: outputAttributes.Value, description: outputAttributes.Description, exportName: outputAttributes.Export ? outputAttributes.Export.Name : void 0, condition: (() => {
          if (outputAttributes.Condition) {
            if (this.conditions[outputAttributes.Condition])
              return self2.getCondition(outputAttributes.Condition);
          } else
            return;
          throw new Error(`Output with name '${logicalId}' refers to a Condition with name '${outputAttributes.Condition}' which was not found in this template`);
        })() });
        this.overrideLogicalIdIfNeeded(cfnOutput, logicalId), this.outputs[logicalId] = cfnOutput;
      }
      getOrCreateCondition(conditionName) {
        if (conditionName in this.conditions)
          return this.conditions[conditionName];
        const self2 = this, cfnParser = new cfn_parse.CfnParser({ finder: { findResource() {
          throw new Error("Using GetAtt in Condition definitions is not allowed");
        }, findRefTarget(elementName) {
          return self2.parameters[elementName];
        }, findCondition(cName) {
          return cName in (self2.template.Conditions || {}) ? self2.getOrCreateCondition(cName) : void 0;
        }, findMapping(mappingName) {
          return self2.mappings[mappingName];
        } }, context: cfn_parse.CfnParsingContext.CONDITIONS, parameters: this.parametersToReplace }), cfnCondition = new core.CfnCondition(this.conditionsScope, conditionName, { expression: cfnParser.parseValue(this.template.Conditions[conditionName]) });
        return this.overrideLogicalIdIfNeeded(cfnCondition, conditionName), this.conditions[conditionName] = cfnCondition, cfnCondition;
      }
      getPlaceholderID() {
        return `Placeholder${this.logicalIdToPlaceholderMap.size}`;
      }
      getOrCreateResource(logicalId, cycleChain = []) {
        if (cycleChain = cycleChain.concat([logicalId]), cycleChain.length !== new Set(cycleChain).size) {
          if (!this.allowCyclicalReferences)
            throw new Error(`Found a cycle between resources in the template: ${cycleChain.join(" depends on ")}`);
          if (this.logicalIdToPlaceholderMap.get(logicalId))
            return this.resources[this.logicalIdToPlaceholderMap.get(logicalId)];
          let placeholderResourceAttributes = this.template.Resources[logicalId], placeholderId = this.getPlaceholderID();
          this.logicalIdToPlaceholderMap.set(logicalId, placeholderId);
          let placeholderInstance = new core.CfnResource(this, placeholderId, { type: placeholderResourceAttributes.Type, properties: {} });
          return placeholderInstance.overrideLogicalId(placeholderId), this.resources[placeholderId] = placeholderInstance, placeholderInstance;
        }
        const ret = this.resources[logicalId];
        if (ret)
          return ret;
        const self2 = this, finder = { findCondition(conditionName) {
          return self2.conditions[conditionName];
        }, findMapping(mappingName) {
          return self2.mappings[mappingName];
        }, findResource(lId) {
          if (lId in (self2.template.Resources || {}))
            return self2.getOrCreateResource(lId, cycleChain);
        }, findRefTarget(elementName) {
          return elementName in self2.parameters ? self2.parameters[elementName] : this.findResource(elementName);
        } }, cfnParser = new cfn_parse.CfnParser({ finder, parameters: this.parametersToReplace }), resourceAttributes = this.template.Resources[logicalId];
        let l1Instance;
        if (this.nestedStacksToInclude[logicalId])
          l1Instance = this.createNestedStack(logicalId, cfnParser);
        else {
          const l1ClassFqn = cfn_type_to_l1_mapping.lookup(resourceAttributes.Type);
          if (l1ClassFqn && resourceAttributes.Type !== "AWS::CloudFormation::CustomResource") {
            const options = { parser: cfnParser }, [moduleName, ...className] = l1ClassFqn.split(".");
            l1Instance = require(moduleName)[className.join(".")]._fromCloudFormation(this, logicalId, resourceAttributes, options);
          } else
            l1Instance = new core.CfnResource(this, logicalId, { type: resourceAttributes.Type, properties: cfnParser.parseValue(resourceAttributes.Properties) }), cfnParser.handleAttributes(l1Instance, resourceAttributes, logicalId);
        }
        if (this.logicalIdToPlaceholderMap.get(logicalId)) {
          let placeholderId = this.logicalIdToPlaceholderMap.get(logicalId);
          this.resources[placeholderId].overrideLogicalId(logicalId), this.node.tryRemoveChild(placeholderId), delete this.resources[placeholderId];
        }
        this.overrideLogicalIdIfNeeded(l1Instance, logicalId), this.resources[logicalId] = l1Instance;
        const knownAttributes = ["Condition", "DependsOn", "Description", "Metadata", "Properties", "Type", "Version", "CreationPolicy", "DeletionPolicy", "UpdatePolicy", "UpdateReplacePolicy"];
        for (const [attrName, attrValue] of Object.entries(resourceAttributes))
          knownAttributes.includes(attrName) || l1Instance.addOverride(attrName, cfnParser.parseValue(attrValue));
        return l1Instance;
      }
      createNestedStack(nestedStackId, cfnParser) {
        const nestedStackAttributes = (this.template.Resources || {})[nestedStackId] || {};
        if (nestedStackAttributes.Type !== "AWS::CloudFormation::Stack")
          throw new Error(`Nested Stack with logical ID '${nestedStackId}' is not an AWS::CloudFormation::Stack resource`);
        if (nestedStackAttributes.CreationPolicy)
          throw new Error("CreationPolicy is not supported by the AWS::CloudFormation::Stack resource");
        if (nestedStackAttributes.UpdatePolicy)
          throw new Error("UpdatePolicy is not supported by the AWS::CloudFormation::Stack resource");
        const nestedStackProps = cfnParser.parseValue(nestedStackAttributes.Properties), nestedStack = new core.NestedStack(this, nestedStackId, { parameters: this.parametersForNestedStack(nestedStackProps.Parameters, nestedStackId), notificationArns: cfn_parse.FromCloudFormation.getStringArray(nestedStackProps.NotificationARNs).value, timeout: this.timeoutForNestedStack(nestedStackProps.TimeoutInMinutes) }), template = new _CfnInclude(nestedStack, nestedStackId, this.nestedStacksToInclude[nestedStackId]);
        this.nestedStacks[nestedStackId] = { stack: nestedStack, includedTemplate: template };
        const nestedStackResource = nestedStack.nestedStackResource;
        return cfnParser.handleAttributes(nestedStackResource, nestedStackAttributes, nestedStackId), nestedStackResource;
      }
      parametersForNestedStack(parameters, nestedStackId) {
        if (parameters == null)
          return;
        const parametersToReplace = this.nestedStacksToInclude[nestedStackId].parameters ?? {}, ret = {};
        for (const paramName of Object.keys(parameters))
          paramName in parametersToReplace || (ret[paramName] = cfn_parse.FromCloudFormation.getString(parameters[paramName]).value);
        return ret;
      }
      timeoutForNestedStack(value) {
        if (value != null)
          return core.Duration.minutes(cfn_parse.FromCloudFormation.getNumber(value).value);
      }
      overrideLogicalIdIfNeeded(element, id) {
        this.preserveLogicalIds && element.overrideLogicalId(id);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CfnInclude[_a] = { fqn: "aws-cdk-lib.cloudformation_include.CfnInclude", version: "2.80.0" }, exports2.CfnInclude = CfnInclude;
  }
});

// node_modules/aws-cdk-lib/cloudformation-include/lib/index.js
var require_lib260 = __commonJS({
  "node_modules/aws-cdk-lib/cloudformation-include/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_cfn_include2(), exports2);
  }
});

// node_modules/aws-cdk-lib/cloudformation-include/index.js
var require_cloudformation_include = __commonJS({
  "node_modules/aws-cdk-lib/cloudformation-include/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib260(), exports2);
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/private/construct-internals.js
var require_construct_internals = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/private/construct-internals.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.obtainScope = exports2.cloudAssemblyBuildSpecDir = exports2.embeddedAsmPath = exports2.pipelineSynth = exports2.assemblyBuilderOf = exports2.appOf = void 0;
    var path = require("path");
    var constructs_1 = require_lib2();
    var core_1 = require_core2();
    function appOf(construct) {
      const root = constructs_1.Node.of(construct).root;
      if (!core_1.App.isApp(root))
        throw new Error(`Construct must be created under an App, but is not: ${constructs_1.Node.of(construct).path}`);
      return root;
    }
    exports2.appOf = appOf;
    function assemblyBuilderOf(stage) {
      return stage._assemblyBuilder;
    }
    exports2.assemblyBuilderOf = assemblyBuilderOf;
    function pipelineSynth(stage) {
      return stage.synth({ validateOnSynthesis: true });
    }
    exports2.pipelineSynth = pipelineSynth;
    function embeddedAsmPath(scope) {
      const appAsmRoot = assemblyBuilderOf(appOf(scope)).outdir, stage = core_1.Stage.of(scope) ?? appOf(scope), stageAsmRoot = assemblyBuilderOf(stage).outdir;
      return path.relative(appAsmRoot, stageAsmRoot) || ".";
    }
    exports2.embeddedAsmPath = embeddedAsmPath;
    function cloudAssemblyBuildSpecDir(scope) {
      return assemblyBuilderOf(appOf(scope)).outdir;
    }
    exports2.cloudAssemblyBuildSpecDir = cloudAssemblyBuildSpecDir;
    function obtainScope(parent, id) {
      const existing = constructs_1.Node.of(parent).tryFindChild(id);
      return existing || new constructs_1.Construct(parent, id);
    }
    exports2.obtainScope = obtainScope;
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/private/fs.js
var require_fs3 = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/private/fs.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.toPosixPath = void 0;
    var path = require("path");
    function toPosixPath(osPath, currentSep) {
      const regex = new RegExp(`\\${currentSep ?? path.sep}`, "g");
      return osPath.replace(regex, "/");
    }
    exports2.toPosixPath = toPosixPath;
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/legacy/actions/deploy-cdk-stack-action.js
var require_deploy_cdk_stack_action = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/legacy/actions/deploy-cdk-stack-action.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DeployCdkStackAction = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var fs = require("fs");
    var path = require("path");
    var constructs_1 = require_lib2();
    var cpactions = require_aws_codepipeline_actions();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var cxapi = require_cx_api();
    var construct_internals_1 = require_construct_internals();
    var fs_1 = require_fs3();
    var DeployCdkStackAction = class _DeployCdkStackAction {
      static fromStackArtifact(scope, artifact, options) {
        if (!artifact.assumeRoleArn)
          throw new Error(`Stack '${artifact.stackName}' does not have deployment role information; use the 'DefaultStackSynthesizer' synthesizer, or set the '@aws-cdk/core:newStyleStackSynthesis' context key.`);
        const artRegion = artifact.environment.region, region = artRegion === core_1.Stack.of(scope).region || artRegion === cxapi.UNKNOWN_REGION ? void 0 : artRegion, artAccount = artifact.environment.account, account = artAccount === core_1.Stack.of(scope).account || artAccount === cxapi.UNKNOWN_ACCOUNT ? void 0 : artAccount, actionRole = roleFromPlaceholderArn(scope, region, account, artifact.assumeRoleArn), cloudFormationExecutionRole = roleFromPlaceholderArn(scope, region, account, artifact.cloudFormationExecutionRoleArn), appAsmRoot = (0, construct_internals_1.assemblyBuilderOf)((0, construct_internals_1.appOf)(scope)).outdir, fullTemplatePath = path.join(artifact.assembly.directory, artifact.templateFile);
        let fullConfigPath;
        return Object.keys(artifact.tags).length > 0 && (fullConfigPath = `${fullTemplatePath}.config.json`, writeTemplateConfiguration(fullConfigPath, { Tags: artifact.tags })), new _DeployCdkStackAction({ actionRole, cloudFormationExecutionRole, templatePath: (0, fs_1.toPosixPath)(path.relative(appAsmRoot, fullTemplatePath)), templateConfigurationPath: fullConfigPath ? (0, fs_1.toPosixPath)(path.relative(appAsmRoot, fullConfigPath)) : void 0, region, stackArtifactId: artifact.id, dependencyStackArtifactIds: artifact.dependencies.filter(isStackArtifact).map((s) => s.id), stackName: options.stackName ?? artifact.stackName, ...options });
      }
      constructor(props) {
        if (props.output && !props.outputFileName)
          throw new Error("If 'output' is set, 'outputFileName' is also required");
        this.stackArtifactId = props.stackArtifactId, this.dependencyStackArtifactIds = props.dependencyStackArtifactIds ?? [], this.prepareRunOrder = props.prepareRunOrder ?? 1, this.executeRunOrder = props.executeRunOrder ?? this.prepareRunOrder + 1, this.stackName = props.stackName;
        const baseActionName = props.baseActionName ?? this.stackName, changeSetName = props.changeSetName ?? "PipelineChange";
        this.prepareChangeSetAction = new cpactions.CloudFormationCreateReplaceChangeSetAction({ actionName: `${baseActionName}.Prepare`, changeSetName, runOrder: this.prepareRunOrder, stackName: this.stackName, templatePath: props.cloudAssemblyInput.atPath(props.templatePath), adminPermissions: false, role: props.actionRole, deploymentRole: props.cloudFormationExecutionRole, region: props.region, cfnCapabilities: [core_1.CfnCapabilities.NAMED_IAM, core_1.CfnCapabilities.AUTO_EXPAND], templateConfiguration: props.templateConfigurationPath ? props.cloudAssemblyInput.atPath(props.templateConfigurationPath) : void 0 }), this.executeChangeSetAction = new cpactions.CloudFormationExecuteChangeSetAction({ actionName: `${baseActionName}.Deploy`, changeSetName, runOrder: this.executeRunOrder, stackName: this.stackName, role: props.actionRole, region: props.region, outputFileName: props.outputFileName, output: props.output });
      }
      bind(scope, stage, options) {
        return stage.addAction(this.prepareChangeSetAction), this.executeChangeSetAction.bind(scope, stage, options);
      }
      onStateChange(name, target, options) {
        return this.executeChangeSetAction.onStateChange(name, target, options);
      }
      get actionProperties() {
        return this.executeChangeSetAction.actionProperties;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, DeployCdkStackAction[_a] = { fqn: "aws-cdk-lib.pipelines.DeployCdkStackAction", version: "2.80.0" }, exports2.DeployCdkStackAction = DeployCdkStackAction;
    function roleFromPlaceholderArn(scope, region, account, arn) {
      if (!arn)
        return;
      const id = arn;
      let existingRole = constructs_1.Node.of(scope).tryFindChild(`ImmutableRole${id}`);
      if (existingRole || (existingRole = constructs_1.Node.of(scope).tryFindChild(id), existingRole))
        return existingRole;
      const arnToImport = cxapi.EnvironmentPlaceholders.replace(arn, { region: region ?? core_1.Aws.REGION, accountId: account ?? core_1.Aws.ACCOUNT_ID, partition: core_1.Aws.PARTITION });
      return iam.Role.fromRoleArn(scope, id, arnToImport, { mutable: false, addGrantsToResources: true });
    }
    function isStackArtifact(a) {
      return a.constructor.name === "CloudFormationStackArtifact";
    }
    function writeTemplateConfiguration(filename, config) {
      fs.writeFileSync(filename, JSON.stringify(config, void 0, 2), { encoding: "utf-8" });
    }
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/blueprint/asset-type.js
var require_asset_type = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/blueprint/asset-type.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AssetType = void 0;
    var AssetType;
    (function(AssetType2) {
      AssetType2.FILE = "file", AssetType2.DOCKER_IMAGE = "docker-image";
    })(AssetType = exports2.AssetType || (exports2.AssetType = {}));
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/private/default-codebuild-image.js
var require_default_codebuild_image = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/private/default-codebuild-image.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CDKP_DEFAULT_CODEBUILD_IMAGE = void 0;
    var aws_codebuild_1 = require_aws_codebuild();
    exports2.CDKP_DEFAULT_CODEBUILD_IMAGE = aws_codebuild_1.LinuxBuildImage.STANDARD_6_0;
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/legacy/actions/publish-assets-action.js
var require_publish_assets_action = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/legacy/actions/publish-assets-action.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PublishAssetsAction = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var fs = require("fs");
    var path = require("path");
    var constructs_1 = require_lib2();
    var codebuild = require_aws_codebuild();
    var codepipeline_actions = require_aws_codepipeline_actions();
    var core_1 = require_core2();
    var asset_type_1 = require_asset_type();
    var default_codebuild_image_1 = require_default_codebuild_image();
    var fs_1 = require_fs3();
    var PublishAssetsAction = class extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id), this.props = props, this.commands = new Array();
        const installCommand = `npm install -g cdk-assets${props.cdkCliVersion ? `@${props.cdkCliVersion}` : ""}`, buildSpec = codebuild.BuildSpec.fromObject({ version: "0.2", phases: { install: { commands: props.preInstallCommands ? [...props.preInstallCommands, installCommand] : installCommand }, build: { commands: core_1.Lazy.list({ produce: () => this.commands }) } } });
        this.buildSpec = props.buildSpec ? codebuild.mergeBuildSpecs(props.buildSpec, buildSpec) : buildSpec;
        const project = new codebuild.PipelineProject(this, "Default", { projectName: this.props.projectName, environment: { buildImage: default_codebuild_image_1.CDKP_DEFAULT_CODEBUILD_IMAGE, privileged: props.assetType === asset_type_1.AssetType.DOCKER_IMAGE ? true : void 0 }, vpc: props.vpc, subnetSelection: props.subnetSelection, buildSpec: props.createBuildspecFile ? codebuild.BuildSpec.fromSourceFilename(this.getBuildSpecFileName()) : this.buildSpec, role: props.role });
        props.dependable && project.node.addDependency(props.dependable), this.action = new codepipeline_actions.CodeBuildAction({ actionName: props.actionName, project, input: this.props.cloudAssemblyInput, role: props.role, environmentVariables: props.cdkCliVersion ? { CDK_CLI_VERSION: { value: props.cdkCliVersion } } : void 0 }), (0, core_1.attachCustomSynthesis)(this, { onSynthesize: this._onSynth.bind(this) });
      }
      getBuildSpecFileName() {
        return `buildspec-assets-${this.node.path.replace(new RegExp("/", "g"), "-")}.yaml`;
      }
      _onSynth(session) {
        if (this.props.createBuildspecFile) {
          const specFile = path.join(session.outdir, this.getBuildSpecFileName());
          fs.writeFileSync(specFile, core_1.Stack.of(this).resolve(this.buildSpec.toBuildSpec()), { encoding: "utf-8" });
        }
      }
      addPublishCommand(relativeManifestPath, assetSelector) {
        const command = `cdk-assets --path "${(0, fs_1.toPosixPath)(relativeManifestPath)}" --verbose publish "${assetSelector}"`;
        this.commands.includes(command) || this.commands.push(command);
      }
      bind(scope, stage, options) {
        return this.action.bind(scope, stage, options);
      }
      onStateChange(name, target, options) {
        return this.action.onStateChange(name, target, options);
      }
      get actionProperties() {
        return this.action.actionProperties;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, PublishAssetsAction[_a] = { fqn: "aws-cdk-lib.pipelines.PublishAssetsAction", version: "2.80.0" }, exports2.PublishAssetsAction = PublishAssetsAction;
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/docker-credentials.js
var require_docker_credentials = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/docker-credentials.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.dockerCredentialsInstallCommands = exports2.DockerCredentialUsage = exports2.DockerCredential = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var ec2 = require_aws_ec2();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var DockerCredential = class {
      static dockerHub(secret, opts = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_ISecret(secret), jsiiDeprecationWarnings.aws_cdk_lib_pipelines_ExternalDockerCredentialOptions(opts);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.dockerHub), error;
        }
        return new ExternalDockerCredential("https://index.docker.io/v1/", secret, opts);
      }
      static customRegistry(registryDomain, secret, opts = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_secretsmanager_ISecret(secret), jsiiDeprecationWarnings.aws_cdk_lib_pipelines_ExternalDockerCredentialOptions(opts);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.customRegistry), error;
        }
        return new ExternalDockerCredential(registryDomain, secret, opts);
      }
      static ecr(repositories, opts) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_pipelines_EcrDockerCredentialOptions(opts);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.ecr), error;
        }
        return new EcrDockerCredential(repositories, opts ?? {});
      }
      constructor(usages) {
        this.usages = usages;
      }
      _applicableForUsage(usage) {
        return !this.usages || this.usages.includes(usage);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, DockerCredential[_a] = { fqn: "aws-cdk-lib.pipelines.DockerCredential", version: "2.80.0" }, exports2.DockerCredential = DockerCredential;
    var DockerCredentialUsage;
    (function(DockerCredentialUsage2) {
      DockerCredentialUsage2.SYNTH = "SYNTH", DockerCredentialUsage2.SELF_UPDATE = "SELF_UPDATE", DockerCredentialUsage2.ASSET_PUBLISHING = "ASSET_PUBLISHING";
    })(DockerCredentialUsage = exports2.DockerCredentialUsage || (exports2.DockerCredentialUsage = {}));
    var ExternalDockerCredential = class extends DockerCredential {
      constructor(registryDomain, secret, opts) {
        super(opts.usages), this.registryDomain = registryDomain, this.secret = secret, this.opts = opts;
      }
      grantRead(grantee, usage) {
        if (!this._applicableForUsage(usage))
          return;
        this.opts.assumeRole && grantee.grantPrincipal.addToPrincipalPolicy(new iam.PolicyStatement({ actions: ["sts:AssumeRole"], resources: [this.opts.assumeRole.roleArn] }));
        const role = this.opts.assumeRole ?? grantee;
        this.secret.grantRead(role);
      }
      _renderCdkAssetsConfig() {
        return { [this.registryDomain]: { secretsManagerSecretId: this.secret.secretArn, secretsUsernameField: this.opts.secretUsernameField, secretsPasswordField: this.opts.secretPasswordField, assumeRoleArn: this.opts.assumeRole?.roleArn } };
      }
    };
    var EcrDockerCredential = class extends DockerCredential {
      constructor(repositories, opts) {
        if (super(opts.usages), this.repositories = repositories, this.opts = opts, repositories.length === 0)
          throw new Error("must supply at least one `ecr.IRepository` to create an `EcrDockerCredential`");
        this.registryDomain = core_1.Fn.select(0, core_1.Fn.split("/", repositories[0].repositoryUri));
      }
      grantRead(grantee, usage) {
        if (!this._applicableForUsage(usage))
          return;
        this.opts.assumeRole && grantee.grantPrincipal.addToPrincipalPolicy(new iam.PolicyStatement({ actions: ["sts:AssumeRole"], resources: [this.opts.assumeRole.roleArn] }));
        const role = this.opts.assumeRole ?? grantee;
        this.repositories.forEach((repo) => repo.grantPull(role));
      }
      _renderCdkAssetsConfig() {
        return { [this.registryDomain]: { ecrRepository: true, assumeRoleArn: this.opts.assumeRole?.roleArn } };
      }
    };
    function dockerCredentialsInstallCommands(usage, registries, osType) {
      const relevantRegistries = (registries ?? []).filter((reg) => reg._applicableForUsage(usage));
      if (!relevantRegistries || relevantRegistries.length === 0)
        return [];
      const cdkAssetsConfigFile = { version: "1.0", domainCredentials: relevantRegistries.reduce(function(map, registry) {
        return Object.assign(map, registry._renderCdkAssetsConfig()), map;
      }, {}) }, windowsCommands = ["mkdir %USERPROFILE%\\.cdk", `echo '${JSON.stringify(cdkAssetsConfigFile)}' > %USERPROFILE%\\.cdk\\cdk-docker-creds.json`], linuxCommands = ["mkdir $HOME/.cdk", `echo '${JSON.stringify(cdkAssetsConfigFile)}' > $HOME/.cdk/cdk-docker-creds.json`];
      return osType === "both" ? [...windowsCommands.map((c) => `!WINDOWS!${c}`), ...linuxCommands.map((c) => `!LINUX!${c}`)] : osType === ec2.OperatingSystemType.WINDOWS ? windowsCommands : linuxCommands;
    }
    exports2.dockerCredentialsInstallCommands = dockerCredentialsInstallCommands;
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/legacy/actions/update-pipeline-action.js
var require_update_pipeline_action = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/legacy/actions/update-pipeline-action.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.UpdatePipelineAction = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var codebuild = require_aws_codebuild();
    var cpactions = require_aws_codepipeline_actions();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var docker_credentials_1 = require_docker_credentials();
    var construct_internals_1 = require_construct_internals();
    var default_codebuild_image_1 = require_default_codebuild_image();
    var UpdatePipelineAction = class extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id);
        const installSuffix = props.cdkCliVersion ? `@${props.cdkCliVersion}` : "", stackIdentifier = props.pipelineStackHierarchicalId ?? props.pipelineStackName, buildSpec = codebuild.BuildSpec.fromObject({ version: "0.2", phases: { install: { commands: [`npm install -g aws-cdk${installSuffix}`, ...(0, docker_credentials_1.dockerCredentialsInstallCommands)(docker_credentials_1.DockerCredentialUsage.SELF_UPDATE, props.dockerCredentials)] }, build: { commands: [`cdk -a ${(0, construct_internals_1.embeddedAsmPath)(scope)} deploy ${stackIdentifier} --require-approval=never --verbose`] } } }), selfMutationProject = new codebuild.PipelineProject(this, "SelfMutation", { projectName: props.projectName, environment: { buildImage: default_codebuild_image_1.CDKP_DEFAULT_CODEBUILD_IMAGE, privileged: props.privileged ?? false }, buildSpec: props.buildSpec ? codebuild.mergeBuildSpecs(props.buildSpec, buildSpec) : buildSpec });
        selfMutationProject.addToRolePolicy(new iam.PolicyStatement({ actions: ["sts:AssumeRole"], resources: [`arn:*:iam::${core_1.Stack.of(this).account}:role/*`], conditions: { "ForAnyValue:StringEquals": { "iam:ResourceTag/aws-cdk:bootstrap-role": ["image-publishing", "file-publishing", "deploy"] } } })), selfMutationProject.addToRolePolicy(new iam.PolicyStatement({ actions: ["cloudformation:DescribeStacks"], resources: ["*"] })), selfMutationProject.addToRolePolicy(new iam.PolicyStatement({ actions: ["s3:ListBucket"], resources: ["*"] })), (props.dockerCredentials ?? []).forEach((reg) => reg.grantRead(selfMutationProject, docker_credentials_1.DockerCredentialUsage.SELF_UPDATE)), this.action = new cpactions.CodeBuildAction({ actionName: "SelfMutate", input: props.cloudAssemblyInput, project: selfMutationProject, environmentVariables: props.cdkCliVersion ? { CDK_CLI_VERSION: { value: props.cdkCliVersion } } : void 0 });
      }
      bind(scope, stage, options) {
        return this.action.bind(scope, stage, options);
      }
      onStateChange(name, target, options) {
        return this.action.onStateChange(name, target, options);
      }
      get actionProperties() {
        return this.action.actionProperties;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, UpdatePipelineAction[_a] = { fqn: "aws-cdk-lib.pipelines.UpdatePipelineAction", version: "2.80.0" }, exports2.UpdatePipelineAction = UpdatePipelineAction;
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/legacy/actions/index.js
var require_actions = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/legacy/actions/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_deploy_cdk_stack_action(), exports2), __exportStar(require_publish_assets_action(), exports2), __exportStar(require_update_pipeline_action(), exports2);
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/private/application-security-check.js
var require_application_security_check = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/private/application-security-check.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ApplicationSecurityCheck = void 0;
    var path = require("path");
    var constructs_1 = require_lib2();
    var default_codebuild_image_1 = require_default_codebuild_image();
    var codebuild = require_aws_codebuild();
    var iam = require_aws_iam();
    var lambda2 = require_aws_lambda();
    var core_1 = require_core2();
    var custom_resources_1 = require_custom_resources();
    var ApplicationSecurityCheck = class extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id), core_1.Tags.of(props.codePipeline).add("SECURITY_CHECK", "ALLOW_APPROVE", { includeResourceTypes: ["AWS::CodePipeline::Pipeline"] }), this.preApproveLambda = new lambda2.Function(this, "CDKPipelinesAutoApprove", { handler: "index.handler", runtime: (0, custom_resources_1.builtInCustomResourceNodeRuntime)(this), code: lambda2.Code.fromAsset(path.resolve(__dirname, "approve-lambda")), timeout: core_1.Duration.minutes(5) }), this.preApproveLambda.addToRolePolicy(new iam.PolicyStatement({ actions: ["codepipeline:GetPipelineState", "codepipeline:PutApprovalResult"], conditions: { StringEquals: { "aws:ResourceTag/SECURITY_CHECK": "ALLOW_APPROVE" } }, resources: ["*"] }));
        const invokeLambda = `aws lambda invoke --function-name ${this.preApproveLambda.functionName} --invocation-type Event --cli-binary-format raw-in-base64-out --payload "$payload" lambda.out`, publishNotification = `aws sns publish --topic-arn $NOTIFICATION_ARN --subject "$NOTIFICATION_SUBJECT" --message "${["An upcoming change would broaden security changes in $PIPELINE_NAME.", "Review and approve the changes in CodePipeline to proceed with the deployment.", "", "Review the changes in CodeBuild:", "", "$LINK", "", "Approve the changes in CodePipeline (stage $STAGE_NAME, action $ACTION_NAME):", "", "$PIPELINE_LINK"].join(`
`)}"`;
        this.cdkDiffProject = new codebuild.Project(this, "CDKSecurityCheck", { environment: { buildImage: default_codebuild_image_1.CDKP_DEFAULT_CODEBUILD_IMAGE }, buildSpec: codebuild.BuildSpec.fromObject({ version: 0.2, phases: { build: { commands: ["npm install -g aws-cdk", 'export PIPELINE_NAME="$(node -pe \'`${process.env.CODEBUILD_INITIATOR}`.split("/")[1]\')"', `payload="$(node -pe 'JSON.stringify({ "PipelineName": process.env.PIPELINE_NAME, "StageName": process.env.STAGE_NAME, "ActionName": process.env.ACTION_NAME })' )"`, "ARN=$CODEBUILD_BUILD_ARN", 'REGION="$(node -pe \'`${process.env.ARN}`.split(":")[3]\')"', 'ACCOUNT_ID="$(node -pe \'`${process.env.ARN}`.split(":")[4]\')"', 'PROJECT_NAME="$(node -pe \'`${process.env.ARN}`.split(":")[5].split("/")[1]\')"', 'PROJECT_ID="$(node -pe \'`${process.env.ARN}`.split(":")[6]\')"', 'export LINK="https://$REGION.console.aws.amazon.com/codesuite/codebuild/$ACCOUNT_ID/projects/$PROJECT_NAME/build/$PROJECT_NAME:$PROJECT_ID/?region=$REGION"', 'export PIPELINE_LINK="https://$REGION.console.aws.amazon.com/codesuite/codepipeline/pipelines/$PIPELINE_NAME/view?region=$REGION"', ifElse({ condition: "cdk diff -a . --security-only --fail $STAGE_PATH/\\*", thenStatements: [invokeLambda, 'export MESSAGE="No security-impacting changes detected."'], elseStatements: [`[ -z "\${NOTIFICATION_ARN}" ] || ${publishNotification}`, 'export MESSAGE="Deployment would make security-impacting changes. Click the link below to inspect them, then click Approve if all changes are expected."'] })] } }, env: { "exported-variables": ["LINK", "MESSAGE"] } }) }), this.cdkDiffProject.addToRolePolicy(new iam.PolicyStatement({ actions: ["sts:AssumeRole"], resources: ["*"], conditions: { "ForAnyValue:StringEquals": { "iam:ResourceTag/aws-cdk:bootstrap-role": ["deploy"] } } })), this.preApproveLambda.grantInvoke(this.cdkDiffProject);
      }
    };
    exports2.ApplicationSecurityCheck = ApplicationSecurityCheck;
    var ifElse = ({ condition, thenStatements, elseStatements }) => {
      let statement = thenStatements.reduce((acc, ifTrue) => `${acc} ${ifTrue};`, `if ${condition}; then`);
      return elseStatements && (statement = elseStatements.reduce((acc, ifFalse) => `${acc} ${ifFalse};`, `${statement} else`)), `${statement} fi`;
    };
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/private/asset-manifest.js
var require_asset_manifest = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/private/asset-manifest.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.DestinationPattern = exports2.DestinationIdentifier = exports2.DockerImageManifestEntry = exports2.FileManifestEntry = exports2.AssetManifestReader = void 0;
    var fs = require("fs");
    var path = require("path");
    var cloud_assembly_schema_1 = require_cloud_assembly_schema2();
    var AssetManifestReader = class _AssetManifestReader {
      static fromFile(fileName) {
        try {
          const obj = cloud_assembly_schema_1.Manifest.loadAssetManifest(fileName);
          return new _AssetManifestReader(path.dirname(fileName), obj);
        } catch (e) {
          throw new Error(`Cannot read asset manifest '${fileName}': ${e.message}`);
        }
      }
      static fromPath(filePath) {
        let st;
        try {
          st = fs.statSync(filePath);
        } catch (e) {
          throw new Error(`Cannot read asset manifest at '${filePath}': ${e.message}`);
        }
        return st.isDirectory() ? _AssetManifestReader.fromFile(path.join(filePath, _AssetManifestReader.DEFAULT_FILENAME)) : _AssetManifestReader.fromFile(filePath);
      }
      constructor(directory, manifest) {
        this.manifest = manifest, this.directory = directory;
      }
      select(selection) {
        if (selection === void 0)
          return this;
        const ret = { version: this.manifest.version, dockerImages: {}, files: {} };
        for (const assetType of ASSET_TYPES)
          for (const [assetId, asset] of Object.entries(this.manifest[assetType] || {})) {
            const filteredDestinations = filterDict(asset.destinations, (_, destId) => selection.some((sel) => sel.matches(new DestinationIdentifier(assetId, destId))));
            Object.keys(filteredDestinations).length > 0 && (ret[assetType][assetId] = { ...asset, destinations: filteredDestinations });
          }
        return new _AssetManifestReader(this.directory, ret);
      }
      list() {
        return [...describeAssets("file", this.manifest.files || {}), ...describeAssets("docker-image", this.manifest.dockerImages || {})];
        function describeAssets(type, assets) {
          const ret = new Array();
          for (const [assetId, asset] of Object.entries(assets || {})) {
            ret.push(`${assetId} ${type} ${JSON.stringify(asset.source)}`);
            const destStrings = Object.entries(asset.destinations).map(([destId, dest]) => ` ${assetId}:${destId} ${JSON.stringify(dest)}`);
            ret.push(...prefixTreeChars(destStrings, "  "));
          }
          return ret;
        }
      }
      get entries() {
        return [...makeEntries(this.manifest.files || {}, FileManifestEntry), ...makeEntries(this.manifest.dockerImages || {}, DockerImageManifestEntry)];
        function makeEntries(assets, ctor) {
          const ret = new Array();
          for (const [assetId, asset] of Object.entries(assets))
            for (const [destId, destination] of Object.entries(asset.destinations))
              ret.push(new ctor(new DestinationIdentifier(assetId, destId), asset.source, destination));
          return ret;
        }
      }
    };
    AssetManifestReader.DEFAULT_FILENAME = "assets.json", exports2.AssetManifestReader = AssetManifestReader;
    var ASSET_TYPES = ["files", "dockerImages"];
    var FileManifestEntry = class {
      constructor(id, source, destination) {
        this.id = id, this.source = source, this.destination = destination, this.type = "file", this.genericSource = source;
      }
    };
    exports2.FileManifestEntry = FileManifestEntry;
    var DockerImageManifestEntry = class {
      constructor(id, source, destination) {
        this.id = id, this.source = source, this.destination = destination, this.type = "docker-image", this.genericSource = source;
      }
    };
    exports2.DockerImageManifestEntry = DockerImageManifestEntry;
    var DestinationIdentifier = class {
      constructor(assetId, destinationId) {
        this.assetId = assetId, this.destinationId = destinationId;
      }
      toString() {
        return this.destinationId ? `${this.assetId}:${this.destinationId}` : this.assetId;
      }
    };
    exports2.DestinationIdentifier = DestinationIdentifier;
    function filterDict(xs, pred) {
      const ret = {};
      for (const [key, value] of Object.entries(xs))
        pred(value, key) && (ret[key] = value);
      return ret;
    }
    var DestinationPattern = class _DestinationPattern {
      static parse(s) {
        if (!s)
          throw new Error("Empty string is not a valid destination identifier");
        const parts = s.split(":").map((x) => x !== "*" ? x : void 0);
        if (parts.length === 1)
          return new _DestinationPattern(parts[0]);
        if (parts.length === 2)
          return new _DestinationPattern(parts[0] || void 0, parts[1] || void 0);
        throw new Error(`Asset identifier must contain at most 2 ':'-separated parts, got '${s}'`);
      }
      constructor(assetId, destinationId) {
        this.assetId = assetId, this.destinationId = destinationId;
      }
      matches(id) {
        return (this.assetId === void 0 || this.assetId === id.assetId) && (this.destinationId === void 0 || this.destinationId === id.destinationId);
      }
      toString() {
        return `${this.assetId ?? "*"}:${this.destinationId ?? "*"}`;
      }
    };
    exports2.DestinationPattern = DestinationPattern;
    function prefixTreeChars(xs, prefix = "") {
      const ret = new Array();
      for (let i = 0; i < xs.length; i++) {
        const boxChar = i === xs.length - 1 ? "\u2514" : "\u251C";
        ret.push(`${prefix}${boxChar}${xs[i]}`);
      }
      return ret;
    }
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/private/toposort.js
var require_toposort2 = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/private/toposort.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.topologicalSort = void 0;
    function topologicalSort(xs, keyFn, depFn) {
      const remaining = /* @__PURE__ */ new Map();
      for (const element of xs) {
        const key = keyFn(element);
        remaining.set(key, { key, element, dependencies: depFn(element) });
      }
      const ret = new Array();
      for (; remaining.size > 0; ) {
        const selectable = Array.from(remaining.values()).filter((e) => e.dependencies.every((d) => !remaining.has(d)));
        if (selectable.sort((a, b) => a.key < b.key ? -1 : b.key < a.key ? 1 : 0), selectable.length === 0)
          throw new Error(`Could not determine ordering between: ${Array.from(remaining.keys()).join(", ")}`);
        ret.push(selectable.map((s) => s.element));
        for (const selected of selectable)
          remaining.delete(selected.key);
      }
      return ret;
    }
    exports2.topologicalSort = topologicalSort;
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/legacy/stage.js
var require_stage4 = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/legacy/stage.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.StackOutput = exports2.CdkStage = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var actions_1 = require_actions();
    var pipeline_1 = require_pipeline2();
    var codebuild = require_aws_codebuild();
    var cpactions = require_aws_codepipeline_actions();
    var aws_codepipeline_actions_1 = require_aws_codepipeline_actions();
    var core_1 = require_core2();
    var asset_type_1 = require_asset_type();
    var application_security_check_1 = require_application_security_check();
    var asset_manifest_1 = require_asset_manifest();
    var construct_internals_1 = require_construct_internals();
    var toposort_1 = require_toposort2();
    var CdkStage = class extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id), this._nextSequentialRunOrder = 1, this._manualApprovalCounter = 1, this.stacksToDeploy = new Array(), this._prepared = false, scope instanceof pipeline_1.CdkPipeline && (this.pipeline = scope), this.stageName = props.stageName, this.pipelineStage = props.pipelineStage, this.cloudAssemblyArtifact = props.cloudAssemblyArtifact, this.host = props.host, this.confirmBroadeningPermissions = props.confirmBroadeningPermissions ?? false, this.securityNotificationTopic = props.securityNotificationTopic, core_1.Aspects.of(this).add({ visit: () => this.prepareStage() });
      }
      addApplication(appStage, options = {}) {
        const asm = (0, construct_internals_1.pipelineSynth)(appStage), extraRunOrderSpace = options.extraRunOrderSpace ?? 0;
        if ((options.confirmBroadeningPermissions ?? this.confirmBroadeningPermissions) && this.addSecurityCheck(appStage, options), asm.stacks.length === 0)
          throw new Error(`The given Stage construct ('${appStage.node.path}') should contain at least one Stack`);
        const sortedTranches = (0, toposort_1.topologicalSort)(asm.stacks, (stack) => stack.id, (stack) => stack.dependencies.map((d) => d.id));
        for (const stacks of sortedTranches) {
          const runOrder = this.nextSequentialRunOrder(extraRunOrderSpace + 2);
          let executeRunOrder = runOrder + extraRunOrderSpace + 1;
          options.manualApprovals && (this.addManualApprovalAction({ runOrder: runOrder + 1 }), executeRunOrder = this.nextSequentialRunOrder());
          for (const stack of stacks)
            this.addStackArtifactDeployment(stack, { runOrder, executeRunOrder });
        }
      }
      getApplicationSecurityCheck() {
        return this._applicationSecurityCheck ? this._applicationSecurityCheck : (this._applicationSecurityCheck = this.pipeline ? this.pipeline._getApplicationSecurityCheck() : new application_security_check_1.ApplicationSecurityCheck(this, "StageApplicationSecurityCheck", { codePipeline: this.pipelineStage.pipeline }), this._applicationSecurityCheck);
      }
      addStackArtifactDeployment(stackArtifact, options = {}) {
        this.publishAssetDependencies(stackArtifact);
        const runOrder = options.runOrder ?? this.nextSequentialRunOrder(2), executeRunOrder = options.executeRunOrder ?? runOrder + 1;
        this.stacksToDeploy.push({ prepareRunOrder: runOrder, executeRunOrder, stackArtifact }), this.advanceRunOrderPast(runOrder), this.advanceRunOrderPast(executeRunOrder);
      }
      addManualApprovalAction(options = {}) {
        let actionName = options.actionName;
        actionName || (actionName = `ManualApproval${this._manualApprovalCounter > 1 ? this._manualApprovalCounter : ""}`, this._manualApprovalCounter += 1), this.addActions(new cpactions.ManualApprovalAction({ actionName, runOrder: options.runOrder ?? this.nextSequentialRunOrder() }));
      }
      addActions(...actions) {
        for (const action of actions)
          this.pipelineStage.addAction(action);
      }
      nextSequentialRunOrder(count = 1) {
        const ret = this._nextSequentialRunOrder;
        return this._nextSequentialRunOrder += count, ret;
      }
      deploysStack(artifactId) {
        return this.stacksToDeploy.map((s) => s.stackArtifact.id).includes(artifactId);
      }
      prepareStage() {
        if (!this._prepared) {
          this._prepared = true;
          for (const { prepareRunOrder, stackArtifact, executeRunOrder } of this.stacksToDeploy) {
            const artifact = this.host.stackOutputArtifact(stackArtifact.id);
            this.pipelineStage.addAction(actions_1.DeployCdkStackAction.fromStackArtifact(this, stackArtifact, { baseActionName: this.simplifyStackName(stackArtifact.stackName), cloudAssemblyInput: this.cloudAssemblyArtifact, output: artifact, outputFileName: artifact ? "outputs.json" : void 0, prepareRunOrder, executeRunOrder }));
          }
        }
      }
      advanceRunOrderPast(lastUsed) {
        this._nextSequentialRunOrder = Math.max(lastUsed + 1, this._nextSequentialRunOrder);
      }
      simplifyStackName(s) {
        return stripPrefix(s, `${this.stageName}-`);
      }
      addSecurityCheck(appStage, options) {
        const { cdkDiffProject } = this.getApplicationSecurityCheck(), notificationTopic = options?.securityNotificationTopic ?? this.securityNotificationTopic;
        notificationTopic?.grantPublish(cdkDiffProject);
        const appStageName = appStage.stageName, approveActionName = `${appStageName}ManualApproval`, diffAction = new aws_codepipeline_actions_1.CodeBuildAction({ runOrder: this.nextSequentialRunOrder(), actionName: `${appStageName}SecurityCheck`, input: this.cloudAssemblyArtifact, project: cdkDiffProject, variablesNamespace: `${appStageName}SecurityCheck`, environmentVariables: { STAGE_PATH: { value: constructs_1.Node.of(appStage).path, type: codebuild.BuildEnvironmentVariableType.PLAINTEXT }, STAGE_NAME: { value: this.stageName, type: codebuild.BuildEnvironmentVariableType.PLAINTEXT }, ACTION_NAME: { value: approveActionName, type: codebuild.BuildEnvironmentVariableType.PLAINTEXT }, ...notificationTopic ? { NOTIFICATION_ARN: { value: notificationTopic.topicArn, type: codebuild.BuildEnvironmentVariableType.PLAINTEXT }, NOTIFICATION_SUBJECT: { value: `Confirm permission broadening in ${appStageName}`, type: codebuild.BuildEnvironmentVariableType.PLAINTEXT } } : {} } }), approve = new cpactions.ManualApprovalAction({ actionName: approveActionName, runOrder: this.nextSequentialRunOrder(), additionalInformation: `#{${appStageName}SecurityCheck.MESSAGE}`, externalEntityLink: `#{${appStageName}SecurityCheck.LINK}` });
        this.addActions(diffAction, approve);
      }
      publishAssetDependencies(stackArtifact) {
        const assetManifests = stackArtifact.dependencies.filter(isAssetManifest);
        for (const manifestArtifact of assetManifests) {
          const manifest = asset_manifest_1.AssetManifestReader.fromFile(manifestArtifact.file);
          for (const entry of manifest.entries) {
            let assetType;
            if (entry instanceof asset_manifest_1.DockerImageManifestEntry)
              assetType = asset_type_1.AssetType.DOCKER_IMAGE;
            else if (entry instanceof asset_manifest_1.FileManifestEntry) {
              if (entry.source.packaging === "file" && entry.source.path === stackArtifact.templateFile)
                continue;
              assetType = asset_type_1.AssetType.FILE;
            } else
              throw new Error(`Unrecognized asset type: ${entry.type}`);
            if (!entry.destination.assumeRoleArn)
              throw new Error("assumeRoleArn is missing on asset and required");
            this.host.publishAsset({ assetManifestPath: manifestArtifact.file, assetId: entry.id.assetId, assetSelector: entry.id.toString(), assetType, assetPublishingRoleArn: entry.destination.assumeRoleArn });
          }
        }
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CdkStage[_a] = { fqn: "aws-cdk-lib.pipelines.CdkStage", version: "2.80.0" }, exports2.CdkStage = CdkStage;
    var StackOutput = class {
      constructor(artifactFile, outputName) {
        this.artifactFile = artifactFile, this.outputName = outputName;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, StackOutput[_b] = { fqn: "aws-cdk-lib.pipelines.StackOutput", version: "2.80.0" }, exports2.StackOutput = StackOutput;
    function stripPrefix(s, prefix) {
      return s.startsWith(prefix) ? s.slice(prefix.length) : s;
    }
    function isAssetManifest(s) {
      return s.constructor.name === "AssetManifestArtifact";
    }
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/legacy/synths/_util.js
var require_util21 = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/legacy/synths/_util.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.filterEmpty = exports2.copyEnvironmentVariables = void 0;
    function copyEnvironmentVariables(...names) {
      const ret = {};
      for (const name of names)
        process.env[name] && (ret[name] = { value: process.env[name] });
      return ret;
    }
    exports2.copyEnvironmentVariables = copyEnvironmentVariables;
    function filterEmpty(xs) {
      return xs.filter((x) => x);
    }
    exports2.filterEmpty = filterEmpty;
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/legacy/synths/simple-synth-action.js
var require_simple_synth_action = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/legacy/synths/simple-synth-action.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.SimpleSynthAction = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var crypto = require("crypto");
    var path = require("path");
    var _util_1 = require_util21();
    var codebuild = require_aws_codebuild();
    var codepipeline = require_aws_codepipeline();
    var codepipeline_actions = require_aws_codepipeline_actions();
    var ec2 = require_aws_ec2();
    var core_1 = require_core2();
    var docker_credentials_1 = require_docker_credentials();
    var default_codebuild_image_1 = require_default_codebuild_image();
    var fs_1 = require_fs3();
    var DEFAULT_OUTPUT_DIR = "cdk.out";
    var SimpleSynthAction = class _SimpleSynthAction {
      static standardNpmSynth(options) {
        return new _SimpleSynthAction({ ...options, installCommand: options.installCommand ?? "npm ci", synthCommand: options.synthCommand ?? "npx cdk synth", vpc: options.vpc, subnetSelection: options.subnetSelection, environment: { ...options.environment, environmentVariables: { NPM_CONFIG_UNSAFE_PERM: { value: "true" }, ...options.environment?.environmentVariables } } });
      }
      static standardYarnSynth(options) {
        return new _SimpleSynthAction({ ...options, installCommand: options.installCommand ?? "yarn install --frozen-lockfile", synthCommand: options.synthCommand ?? "npx cdk synth", vpc: options.vpc, subnetSelection: options.subnetSelection, environment: { ...options.environment, environmentVariables: { NPM_CONFIG_UNSAFE_PERM: { value: "true" }, ...options.environment?.environmentVariables } } });
      }
      constructor(props) {
        if (this.props = props, this._actionProperties = { actionName: props.actionName ?? "Synth", category: codepipeline.ActionCategory.BUILD, provider: "CodeBuild", artifactBounds: { minInputs: 0, maxInputs: 5, minOutputs: 0, maxOutputs: 5 }, inputs: [props.sourceArtifact], outputs: [props.cloudAssemblyArtifact, ...(props.additionalArtifacts ?? []).map((a) => a.artifact)] }, this.props.installCommand && this.props.installCommands)
          throw new Error("Pass either 'installCommand' or 'installCommands', but not both");
        if (this.props.buildCommand && this.props.buildCommands)
          throw new Error("Pass either 'buildCommand' or 'buildCommands', but not both");
        const addls = props.additionalArtifacts ?? [];
        if (Object.keys(addls).length > 0) {
          if (!props.cloudAssemblyArtifact.artifactName)
            throw new Error("You must give all output artifacts, including the 'cloudAssemblyArtifact', names when using 'additionalArtifacts'");
          for (const addl of addls)
            if (!addl.artifact.artifactName)
              throw new Error("You must give all output artifacts passed to SimpleSynthAction names when using 'additionalArtifacts'");
        }
      }
      get actionProperties() {
        return this._actionProperties;
      }
      get project() {
        if (!this._project)
          throw new Error("Project becomes available after SimpleSynthAction has been bound to a stage");
        return this._project;
      }
      bind(scope, stage, options) {
        const buildCommands = this.props.buildCommands ?? [this.props.buildCommand], installCommands = this.props.installCommands ?? [this.props.installCommand], testCommands = this.props.testCommands ?? [], synthCommand = this.props.synthCommand, environment = { buildImage: default_codebuild_image_1.CDKP_DEFAULT_CODEBUILD_IMAGE, ...this.props.environment }, osType = environment.buildImage instanceof codebuild.WindowsBuildImage ? ec2.OperatingSystemType.WINDOWS : ec2.OperatingSystemType.LINUX, buildSpec = codebuild.BuildSpec.fromObject({ version: "0.2", phases: { pre_build: { commands: (0, _util_1.filterEmpty)([this.props.subdirectory ? `cd ${this.props.subdirectory}` : "", ...installCommands, ...(0, docker_credentials_1.dockerCredentialsInstallCommands)(docker_credentials_1.DockerCredentialUsage.SYNTH, this._dockerCredentials, osType)]) }, build: { commands: (0, _util_1.filterEmpty)([...buildCommands, ...testCommands, synthCommand]) } }, artifacts: renderArtifacts(this) }), environmentVariables = { ...(0, _util_1.copyEnvironmentVariables)(...this.props.copyEnvironmentVariables || []) }, mergedBuildSpec = this.props.buildSpec ? codebuild.mergeBuildSpecs(this.props.buildSpec, buildSpec) : buildSpec, projectConfigHash = hash(core_1.Stack.of(scope).resolve({ environment: serializeBuildEnvironment(environment), buildSpecString: mergedBuildSpec.toBuildSpec(), environmentVariables })), project = new codebuild.PipelineProject(scope, "CdkBuildProject", { projectName: this.props.projectName, environment, vpc: this.props.vpc, subnetSelection: this.props.subnetSelection, buildSpec: mergedBuildSpec, environmentVariables });
        return this.props.rolePolicyStatements !== void 0 && this.props.rolePolicyStatements.forEach((policyStatement) => {
          project.addToRolePolicy(policyStatement);
        }), this._project = project, this._dockerCredentials?.forEach((reg) => reg.grantRead(project.grantPrincipal, docker_credentials_1.DockerCredentialUsage.SYNTH)), this._action = new codepipeline_actions.CodeBuildAction({ actionName: this.actionProperties.actionName, input: this.props.sourceArtifact, outputs: [this.props.cloudAssemblyArtifact, ...(this.props.additionalArtifacts ?? []).map((a) => a.artifact)], environmentVariables: { ...this.props.environmentVariables, _PROJECT_CONFIG_HASH: { value: projectConfigHash } }, project }), this._actionProperties = this._action.actionProperties, this._action.bind(scope, stage, options);
        function renderArtifacts(self2) {
          const cloudAsmArtifactSpec = { "base-directory": (0, fs_1.toPosixPath)(path.join(self2.props.subdirectory ?? ".", DEFAULT_OUTPUT_DIR)), files: "**/*" };
          if (self2.props.additionalArtifacts) {
            const secondary = {};
            if (!self2.props.cloudAssemblyArtifact.artifactName)
              throw new Error("When using additional output artifacts, you must also name the CloudAssembly artifact");
            return secondary[self2.props.cloudAssemblyArtifact.artifactName] = cloudAsmArtifactSpec, self2.props.additionalArtifacts.forEach((art) => {
              if (!art.artifact.artifactName)
                throw new Error("You must give the output artifact a name");
              secondary[art.artifact.artifactName] = { "base-directory": (0, fs_1.toPosixPath)(path.join(self2.props.subdirectory ?? ".", art.directory)), files: "**/*" };
            }), { "secondary-artifacts": secondary };
          }
          return cloudAsmArtifactSpec;
        }
      }
      get grantPrincipal() {
        return this.project.grantPrincipal;
      }
      onStateChange(name, target, options) {
        if (!this._action)
          throw new Error("Need bind() first");
        return this._action.onStateChange(name, target, options);
      }
      _addDockerCredentials(dockerCredentials) {
        this._dockerCredentials = dockerCredentials;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, SimpleSynthAction[_a] = { fqn: "aws-cdk-lib.pipelines.SimpleSynthAction", version: "2.80.0" }, exports2.SimpleSynthAction = SimpleSynthAction;
    function hash(obj) {
      const d = crypto.createHash("sha256");
      return d.update(JSON.stringify(obj)), d.digest("hex");
    }
    function serializeBuildEnvironment(env) {
      return { privileged: env.privileged, environmentVariables: env.environmentVariables, type: env.buildImage?.type, imageId: env.buildImage?.imageId, computeType: env.computeType, imagePullPrincipalType: env.buildImage?.imagePullPrincipalType, secretsManagerArn: env.buildImage?.secretsManagerCredentials?.secretArn };
    }
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/legacy/synths/index.js
var require_synths = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/legacy/synths/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_simple_synth_action(), exports2);
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/private/asset-singleton-role.js
var require_asset_singleton_role = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/private/asset-singleton-role.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.AssetSingletonRole = void 0;
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var AssetSingletonRole = class extends iam.Role {
      constructor(scope, id, props) {
        super(scope, id, props), this._rejectDuplicates = false, this.addToPolicy(new iam.PolicyStatement({ resources: [core_1.Stack.of(this).formatArn({ service: "logs", resource: "log-group", arnFormat: core_1.ArnFormat.COLON_RESOURCE_NAME, resourceName: "/aws/codebuild/*" })], actions: ["logs:CreateLogGroup", "logs:CreateLogStream", "logs:PutLogEvents"] })), this.addToPolicy(new iam.PolicyStatement({ actions: ["codebuild:CreateReportGroup", "codebuild:CreateReport", "codebuild:UpdateReport", "codebuild:BatchPutTestCases", "codebuild:BatchPutCodeCoverages"], resources: [core_1.Stack.of(this).formatArn({ service: "codebuild", resource: "report-group", resourceName: "*" })] })), this.addToPolicy(new iam.PolicyStatement({ resources: ["*"], actions: ["codebuild:BatchGetBuilds", "codebuild:StartBuild", "codebuild:StopBuild"] })), this._rejectDuplicates = true;
      }
      addToPrincipalPolicy(statement) {
        const json = statement.toStatementJson(), acts = JSON.stringify(json.Action), alreadyAdded = ['["logs:CreateLogGroup","logs:CreateLogStream","logs:PutLogEvents"]', '["codebuild:CreateReportGroup","codebuild:CreateReport","codebuild:UpdateReport","codebuild:BatchPutTestCases","codebuild:BatchPutCodeCoverages"]', '["codebuild:BatchGetBuilds","codebuild:StartBuild","codebuild:StopBuild"]'];
        return this._rejectDuplicates && alreadyAdded.includes(acts) ? { statementAdded: true, policyDependable: new class {
        }() } : acts === '["kms:Decrypt","kms:Encrypt","kms:ReEncrypt*","kms:GenerateDataKey*"]' ? { statementAdded: true, policyDependable: new class {
        }() } : super.addToPrincipalPolicy(statement);
      }
      addAssumeRole(roleArn) {
        this._assumeRoleStatement || (this._assumeRoleStatement = new iam.PolicyStatement({ actions: ["sts:AssumeRole"] }), this.addToPrincipalPolicy(this._assumeRoleStatement));
        const MAX_ARNS_PER_STATEMENT = 10;
        this._assumeRoleStatement.addResources(roleArn), this._assumeRoleStatement.resources.length >= MAX_ARNS_PER_STATEMENT && (this._assumeRoleStatement = void 0);
      }
    };
    exports2.AssetSingletonRole = AssetSingletonRole;
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/private/cached-fnsub.js
var require_cached_fnsub = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/private/cached-fnsub.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CachedFnSub = void 0;
    var core_1 = require_core2();
    var CachedFnSub = class {
      constructor() {
        this.cache = /* @__PURE__ */ new Map();
      }
      fnSub(x) {
        const existing = this.cache.get(x);
        if (existing)
          return existing;
        const ret = core_1.Fn.sub(x);
        return this.cache.set(x, ret), ret;
      }
    };
    exports2.CachedFnSub = CachedFnSub;
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/private/cli-version.js
var require_cli_version = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/private/cli-version.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.findUp = exports2.preferredCliVersion = void 0;
    var fs = require("fs");
    var path = require("path");
    function preferredCliVersion() {
      const pjLocation = findUp("package.json", __dirname);
      if (!pjLocation)
        return;
      const pj = JSON.parse(fs.readFileSync(pjLocation, { encoding: "utf-8" }));
      return pj.preferredCdkCliVersion ? `${pj.preferredCdkCliVersion}` : void 0;
    }
    exports2.preferredCliVersion = preferredCliVersion;
    function findUp(name, directory) {
      const absoluteDirectory = path.resolve(directory), file = path.join(directory, name);
      if (fs.existsSync(file))
        return file;
      const { root } = path.parse(absoluteDirectory);
      if (absoluteDirectory != root)
        return findUp(name, path.dirname(absoluteDirectory));
    }
    exports2.findUp = findUp;
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/legacy/pipeline.js
var require_pipeline2 = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/legacy/pipeline.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CdkPipeline = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var path = require("path");
    var constructs_1 = require_lib2();
    var actions_1 = require_actions();
    var stage_1 = require_stage4();
    var synths_1 = require_synths();
    var codepipeline = require_aws_codepipeline();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var asset_type_1 = require_asset_type();
    var docker_credentials_1 = require_docker_credentials();
    var application_security_check_1 = require_application_security_check();
    var asset_singleton_role_1 = require_asset_singleton_role();
    var cached_fnsub_1 = require_cached_fnsub();
    var cli_version_1 = require_cli_version();
    var construct_internals_1 = require_construct_internals();
    var CODE_BUILD_LENGTH_LIMIT = 100;
    var CdkPipeline = class extends constructs_1.Construct {
      constructor(scope, id, props) {
        if (super(scope, id), this._stages = [], this._outputArtifacts = {}, this.cliVersion = props.cdkCliVersion ?? (0, cli_version_1.preferredCliVersion)(), !core_1.App.isApp(this.node.root))
          throw new Error("CdkPipeline must be created under an App");
        this._cloudAssemblyArtifact = props.cloudAssemblyArtifact, this._dockerCredentials = props.dockerCredentials ?? [];
        const pipelineStack = core_1.Stack.of(this);
        if (props.codePipeline) {
          if (props.pipelineName)
            throw new Error("Cannot set 'pipelineName' if an existing CodePipeline is given using 'codePipeline'");
          if (props.crossAccountKeys !== void 0)
            throw new Error("Cannot set 'crossAccountKeys' if an existing CodePipeline is given using 'codePipeline'");
          if (props.enableKeyRotation !== void 0)
            throw new Error("Cannot set 'enableKeyRotation' if an existing CodePipeline is given using 'codePipeline'");
          this._pipeline = props.codePipeline;
        } else
          this._pipeline = new codepipeline.Pipeline(this, "Pipeline", { pipelineName: props.pipelineName, crossAccountKeys: props.crossAccountKeys, enableKeyRotation: props.enableKeyRotation, restartExecutionOnUpdate: true });
        if (props.sourceAction && !props.synthAction)
          throw new Error("When passing a 'sourceAction' you must also pass a 'synthAction' (or a 'codePipeline' that already has both)");
        if (!props.sourceAction && (!props.codePipeline || props.codePipeline.stages.length < 1))
          throw new Error("You must pass a 'sourceAction' (or a 'codePipeline' that already has a Source stage)");
        props.sourceAction && this._pipeline.addStage({ stageName: "Source", actions: [props.sourceAction] }), props.synthAction && (props.synthAction instanceof synths_1.SimpleSynthAction && this._dockerCredentials.length > 0 && props.synthAction._addDockerCredentials(this._dockerCredentials), this._pipeline.addStage({ stageName: "Build", actions: [props.synthAction] })), (props.selfMutating ?? true) && this._pipeline.addStage({ stageName: "UpdatePipeline", actions: [new actions_1.UpdatePipelineAction(this, "UpdatePipeline", { cloudAssemblyInput: this._cloudAssemblyArtifact, pipelineStackHierarchicalId: pipelineStack.node.path, cdkCliVersion: this.cliVersion, projectName: maybeSuffix(props.pipelineName, "-selfupdate"), privileged: props.supportDockerAssets, dockerCredentials: this._dockerCredentials, buildSpec: props.selfMutationBuildSpec })] }), this._assets = new AssetPublishing(this, "Assets", { cloudAssemblyInput: this._cloudAssemblyArtifact, cdkCliVersion: this.cliVersion, pipeline: this._pipeline, projectName: maybeSuffix(props.pipelineName, "-publish"), vpc: props.vpc, subnetSelection: props.subnetSelection, singlePublisherPerType: props.singlePublisherPerType, preInstallCommands: props.assetPreInstallCommands, buildSpec: props.assetBuildSpec, dockerCredentials: this._dockerCredentials }), this.node.addValidation({ validate: () => this.validatePipeline() });
      }
      get codePipeline() {
        return this._pipeline;
      }
      stage(stageName) {
        return this._pipeline.stage(stageName);
      }
      _getApplicationSecurityCheck() {
        return this._applicationSecurityCheck || (this._applicationSecurityCheck = new application_security_check_1.ApplicationSecurityCheck(this, "PipelineApplicationSecurityCheck", { codePipeline: this._pipeline })), this._applicationSecurityCheck;
      }
      addApplicationStage(appStage, options = {}) {
        const stage = this.addStage(appStage.stageName, options);
        return stage.addApplication(appStage, options), stage;
      }
      addStage(stageName, options) {
        const pipelineStage = this._pipeline.addStage({ stageName }), stage = new stage_1.CdkStage(this, stageName, { cloudAssemblyArtifact: this._cloudAssemblyArtifact, pipelineStage, stageName, host: { publishAsset: this._assets.addPublishAssetAction.bind(this._assets), stackOutputArtifact: (artifactId) => this._outputArtifacts[artifactId] }, ...options });
        return this._stages.push(stage), stage;
      }
      stackOutput(cfnOutput) {
        const stack = core_1.Stack.of(cfnOutput);
        if (!this._outputArtifacts[stack.artifactId]) {
          const artifactName = `${stack.artifactId}_Outputs`, compactName = artifactName.slice(artifactName.length - Math.min(artifactName.length, CODE_BUILD_LENGTH_LIMIT));
          this._outputArtifacts[stack.artifactId] = new codepipeline.Artifact(compactName);
        }
        return new stage_1.StackOutput(this._outputArtifacts[stack.artifactId].atPath("outputs.json"), cfnOutput.logicalId);
      }
      validatePipeline() {
        const ret = new Array();
        return ret.push(...this.validateDeployOrder()), ret.push(...this.validateRequestedOutputs()), ret;
      }
      get stackActions() {
        return flatMap(this._pipeline.stages, (s) => s.actions.filter(isDeployAction));
      }
      *validateDeployOrder() {
        const stackActions = this.stackActions;
        for (const stackAction of stackActions)
          for (const depId of stackAction.dependencyStackArtifactIds) {
            const depAction = stackActions.find((s) => s.stackArtifactId === depId);
            depAction === void 0 ? core_1.Annotations.of(this).addWarning(`Stack '${stackAction.stackName}' depends on stack '${depId}', but that dependency is not deployed through the pipeline!`) : depAction.executeRunOrder < stackAction.prepareRunOrder || (yield `Stack '${stackAction.stackName}' depends on stack '${depAction.stackName}', but is deployed before it in the pipeline!`);
          }
      }
      *validateRequestedOutputs() {
        const artifactIds = this.stackActions.map((s) => s.stackArtifactId);
        for (const artifactId of Object.keys(this._outputArtifacts))
          artifactIds.includes(artifactId) || (yield `Trying to use outputs for Stack '${artifactId}', but Stack is not deployed in this pipeline. Add it to the pipeline.`);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CdkPipeline[_a] = { fqn: "aws-cdk-lib.pipelines.CdkPipeline", version: "2.80.0" }, exports2.CdkPipeline = CdkPipeline;
    function isDeployAction(a) {
      return a instanceof actions_1.DeployCdkStackAction;
    }
    function flatMap(xs, f) {
      return Array.prototype.concat([], ...xs.map(f));
    }
    var AssetPublishing = class extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id), this.props = props, this.MAX_PUBLISHERS_PER_STAGE = 50, this.publishers = {}, this.assetRoles = /* @__PURE__ */ new Map(), this.assetAttachedPolicies = {}, this.cachedFnSub = new cached_fnsub_1.CachedFnSub(), this.stages = [], this._fileAssetCtr = 0, this._dockerAssetCtr = 0, this.myCxAsmRoot = path.resolve((0, construct_internals_1.assemblyBuilderOf)((0, construct_internals_1.appOf)(this)).outdir), this.pipeline = this.props.pipeline;
        const stages = this.props.pipeline._stages;
        this.lastStageBeforePublishing = stages.slice(-1)[0], this.dockerCredentials = props.dockerCredentials;
      }
      addPublishAssetAction(command) {
        const relativePath = path.relative(this.myCxAsmRoot, command.assetManifestPath);
        if (relativePath.startsWith(`..${path.sep}`))
          throw new Error(`The asset manifest (${command.assetManifestPath}) cannot be outside the Cloud Assembly directory (${this.myCxAsmRoot}). Please report this error at https://github.com/aws/aws-cdk/issues to help us debug why this is happening.`);
        this.generateAssetRole(command.assetType).addAssumeRole(this.cachedFnSub.fnSub(command.assetPublishingRoleArn));
        const publisherKey = this.props.singlePublisherPerType ? command.assetType.toString() : command.assetId;
        let action = this.publishers[publisherKey];
        if (!action) {
          const stageIndex = this.props.singlePublisherPerType ? 0 : Math.floor((this._fileAssetCtr + this._dockerAssetCtr) / this.MAX_PUBLISHERS_PER_STAGE);
          if (!this.props.singlePublisherPerType && stageIndex >= this.stages.length) {
            const previousStage = this.stages.slice(-1)[0] ?? this.lastStageBeforePublishing;
            this.stages.push(this.pipeline.addStage({ stageName: `Assets${stageIndex > 0 ? stageIndex + 1 : ""}`, placement: { justAfter: previousStage } }));
          } else
            this.props.singlePublisherPerType && this.stages.length == 0 && this.stages.push(this.pipeline.addStage({ stageName: "Assets", placement: { justAfter: this.lastStageBeforePublishing } }));
          const id = this.props.singlePublisherPerType ? command.assetType === asset_type_1.AssetType.FILE ? "FileAsset" : "DockerAsset" : command.assetType === asset_type_1.AssetType.FILE ? `FileAsset${++this._fileAssetCtr}` : `DockerAsset${++this._dockerAssetCtr}`, credsInstallCommands = (0, docker_credentials_1.dockerCredentialsInstallCommands)(docker_credentials_1.DockerCredentialUsage.ASSET_PUBLISHING, this.dockerCredentials);
          action = this.publishers[publisherKey] = new actions_1.PublishAssetsAction(this, id, { actionName: id, cloudAssemblyInput: this.props.cloudAssemblyInput, cdkCliVersion: this.props.cdkCliVersion, assetType: command.assetType, role: this.assetRoles.get(command.assetType), dependable: this.assetAttachedPolicies[command.assetType], vpc: this.props.vpc, subnetSelection: this.props.subnetSelection, buildSpec: this.props.buildSpec, createBuildspecFile: this.props.singlePublisherPerType, preInstallCommands: [...this.props.preInstallCommands ?? [], ...credsInstallCommands] }), this.stages[stageIndex].addAction(action);
        }
        action.addPublishCommand(relativePath, command.assetSelector);
      }
      generateAssetRole(assetType) {
        const existing = this.assetRoles.get(assetType);
        if (existing)
          return existing;
        const rolePrefix = assetType === asset_type_1.AssetType.DOCKER_IMAGE ? "Docker" : "File", assetRole = new asset_singleton_role_1.AssetSingletonRole(this, `${rolePrefix}Role`, { roleName: core_1.PhysicalName.GENERATE_IF_NEEDED, assumedBy: new iam.CompositePrincipal(new iam.ServicePrincipal("codebuild.amazonaws.com"), new iam.AccountPrincipal(core_1.Stack.of(this).account)) });
        return assetType === asset_type_1.AssetType.DOCKER_IMAGE && this.dockerCredentials.forEach((reg) => reg.grantRead(assetRole, docker_credentials_1.DockerCredentialUsage.ASSET_PUBLISHING)), this.assetRoles.set(assetType, assetRole), assetRole;
      }
    };
    function maybeSuffix(x, suffix) {
      if (x !== void 0)
        return `${x}${suffix}`;
    }
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/legacy/validation/shell-script-action.js
var require_shell_script_action = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/legacy/validation/shell-script-action.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ShellScriptAction = void 0;
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var codebuild = require_aws_codebuild();
    var codepipeline = require_aws_codepipeline();
    var codepipeline_actions = require_aws_codepipeline_actions();
    var default_codebuild_image_1 = require_default_codebuild_image();
    var ShellScriptAction = class {
      constructor(props) {
        if (this.props = props, this._actionProperties = { actionName: props.actionName, category: codepipeline.ActionCategory.BUILD, provider: "CodeBuild", artifactBounds: { minInputs: 0, maxInputs: 5, minOutputs: 0, maxOutputs: 5 }, inputs: [], outputs: [] }, Object.keys(props.useOutputs ?? {}).length + (props.additionalArtifacts ?? []).length === 0)
          throw new Error("You must supply either 'useOutputs' or 'additionalArtifacts', since a CodeBuild Action must always have at least one input artifact.");
      }
      get grantPrincipal() {
        return this.project.grantPrincipal;
      }
      get actionProperties() {
        return this._actionProperties;
      }
      bind(scope, stage, options) {
        const inputs = new Array();
        inputs.push(...this.props.additionalArtifacts ?? []);
        const envVarCommands = new Array(), bashOptions = this.props.bashOptions ?? "-eu";
        bashOptions && envVarCommands.push(`set ${bashOptions}`);
        for (const [varName, output] of Object.entries(this.props.useOutputs ?? {})) {
          const outputArtifact = output.artifactFile;
          let artifactIndex = inputs.findIndex((a) => a.artifactName === outputArtifact.artifact.artifactName);
          artifactIndex === -1 && (artifactIndex = inputs.push(outputArtifact.artifact) - 1);
          const dirEnv = artifactIndex === 0 ? "CODEBUILD_SRC_DIR" : `CODEBUILD_SRC_DIR_${outputArtifact.artifact.artifactName}`;
          envVarCommands.push(`export ${varName}="$(node -pe 'require(process.env.${dirEnv} + "/${outputArtifact.fileName}")["${output.outputName}"]')"`);
        }
        this._project = new codebuild.PipelineProject(scope, "Project", { environment: this.props.environment || { buildImage: default_codebuild_image_1.CDKP_DEFAULT_CODEBUILD_IMAGE }, vpc: this.props.vpc, securityGroups: this.props.securityGroups, subnetSelection: this.props.subnetSelection, buildSpec: codebuild.BuildSpec.fromObject({ version: "0.2", phases: { build: { commands: [...envVarCommands, ...this.props.commands] } } }) });
        for (const statement of this.props.rolePolicyStatements ?? [])
          this._project.addToRolePolicy(statement);
        return this._action = new codepipeline_actions.CodeBuildAction({ actionName: this.props.actionName, input: inputs[0], extraInputs: inputs.slice(1), runOrder: this.props.runOrder ?? 100, project: this._project, environmentVariables: this.props.environmentVariables }), this._actionProperties = this._action.actionProperties, this._action.bind(scope, stage, options);
      }
      get project() {
        if (!this._project)
          throw new Error("Project becomes available after ShellScriptAction has been bound to a stage");
        return this._project;
      }
      onStateChange(name, target, options) {
        if (!this._action)
          throw new Error("Need bind() first");
        return this._action.onStateChange(name, target, options);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ShellScriptAction[_a] = { fqn: "aws-cdk-lib.pipelines.ShellScriptAction", version: "2.80.0" }, exports2.ShellScriptAction = ShellScriptAction;
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/legacy/validation/index.js
var require_validation5 = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/legacy/validation/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_shell_script_action(), exports2);
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/legacy/index.js
var require_legacy2 = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/legacy/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_pipeline2(), exports2), __exportStar(require_stage4(), exports2), __exportStar(require_synths(), exports2), __exportStar(require_actions(), exports2), __exportStar(require_validation5(), exports2);
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/blueprint/file-set.js
var require_file_set = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/blueprint/file-set.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.FileSet = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var FileSet = class _FileSet {
      constructor(id, producer) {
        this.id = id, this.primaryOutput = this;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_pipelines_Step(producer);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _FileSet), error;
        }
        this._producer = producer;
      }
      get producer() {
        if (!this._producer)
          throw new Error(`FileSet '${this.id}' doesn't have a producer; call 'fileSet.producedBy()'`);
        return this._producer;
      }
      producedBy(producer) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_pipelines_Step(producer);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.producedBy), error;
        }
        if (this._producer)
          throw new Error(`FileSet '${this.id}' already has a producer (${this._producer}) while setting producer: ${producer}`);
        this._producer = producer;
      }
      toString() {
        return `FileSet(${this.id})`;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, FileSet[_a] = { fqn: "aws-cdk-lib.pipelines.FileSet", version: "2.80.0" }, exports2.FileSet = FileSet;
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/helpers-internal/step-output.js
var require_step_output = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/helpers-internal/step-output.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.StepOutput = void 0;
    var core_1 = require_core2();
    var STEP_OUTPUT_SYM = Symbol.for("@aws-cdk/pipelines.StepOutput");
    var PRODUCED_OUTPUTS_SYM = Symbol.for("@aws-cdk/pipelines.outputs");
    var StepOutput = class {
      static isStepOutput(resolvable) {
        return !!resolvable[STEP_OUTPUT_SYM];
      }
      static findAll(structure) {
        return findAllStepOutputs(structure);
      }
      static producedStepOutputs(step) {
        return step[PRODUCED_OUTPUTS_SYM] ?? [];
      }
      static recordProducer(...outputs) {
        for (const output of outputs) {
          const step = output.step;
          let list = step[PRODUCED_OUTPUTS_SYM];
          list || (list = [], step[PRODUCED_OUTPUTS_SYM] = list), list.push(...outputs);
        }
      }
      constructor(step, engineName, engineSpecificInformation) {
        this.creationStack = [], this.resolution = void 0, this.step = step, this.engineName = engineName, this.engineSpecificInformation = engineSpecificInformation, Object.defineProperty(this, STEP_OUTPUT_SYM, { value: true });
      }
      defineResolution(value) {
        this.resolution = value;
      }
      resolve(_context) {
        if (this.resolution === void 0)
          throw new Error(`Output for step ${this.step} not configured. Either the step is not in the pipeline, the step implementation did not call 'this.discoverReferencedOutputs()', or this engine does not support Outputs for this step.`);
        return this.resolution;
      }
      toString() {
        return core_1.Token.asString(this);
      }
    };
    exports2.StepOutput = StepOutput;
    function findAllStepOutputs(structure) {
      const ret = /* @__PURE__ */ new Set();
      return recurse(structure), Array.from(ret);
      function checkToken(x) {
        return x && StepOutput.isStepOutput(x) ? (ret.add(x), true) : x !== void 0;
      }
      function recurse(x) {
        if (x) {
          if (core_1.Tokenization.isResolvable(x)) {
            checkToken(x);
            return;
          }
          if (Array.isArray(x)) {
            checkToken(core_1.Tokenization.reverseList(x)) || x.forEach(recurse);
            return;
          }
          if (typeof x == "number") {
            checkToken(core_1.Tokenization.reverseNumber(x));
            return;
          }
          if (typeof x == "string") {
            core_1.Tokenization.reverseString(x).tokens.forEach(checkToken);
            return;
          }
          if (typeof x == "object")
            for (const [k, v] of Object.entries(x))
              recurse(k), recurse(v);
        }
      }
    }
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/blueprint/step.js
var require_step = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/blueprint/step.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Step = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var core_1 = require_core2();
    var step_output_1 = require_step_output();
    var Step = class {
      static sequence(steps) {
        for (let i = 1; i < steps.length; i++)
          steps[i].addStepDependency(steps[i - 1]);
        return steps;
      }
      constructor(id) {
        if (this.id = id, this.dependencyFileSets = [], this.isSource = false, this._dependencies = /* @__PURE__ */ new Set(), core_1.Token.isUnresolved(id))
          throw new Error(`Step id cannot be unresolved, got '${id}'`);
      }
      get dependencies() {
        return Array.from(/* @__PURE__ */ new Set([...this.dependencyFileSets.map((f) => f.producer), ...this._dependencies]));
      }
      toString() {
        return `${this.constructor.name}(${this.id})`;
      }
      get primaryOutput() {
        return this._primaryOutput;
      }
      addStepDependency(step) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_pipelines_Step(step);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addStepDependency), error;
        }
        this._dependencies.add(step);
      }
      addDependencyFileSet(fs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_pipelines_FileSet(fs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addDependencyFileSet), error;
        }
        this.dependencyFileSets.push(fs);
      }
      configurePrimaryOutput(fs) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_pipelines_FileSet(fs);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.configurePrimaryOutput), error;
        }
        this._primaryOutput = fs;
      }
      discoverReferencedOutputs(structure) {
        for (const output of step_output_1.StepOutput.findAll(structure))
          this._dependencies.add(output.step), step_output_1.StepOutput.recordProducer(output);
      }
      get consumedStackOutputs() {
        return [];
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Step[_a] = { fqn: "aws-cdk-lib.pipelines.Step", version: "2.80.0" }, exports2.Step = Step;
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/private/javascript.js
var require_javascript = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/private/javascript.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.isDefined = exports2.partition = exports2.maybeSuffix = exports2.noUndefined = exports2.noEmptyObject = exports2.mkdict = exports2.mapValues = exports2.filterEmpty = exports2.flatten = exports2.expectProp = exports2.enumerate = exports2.flatMap = exports2.extract = exports2.addAll = void 0;
    function addAll(into, from) {
      for (const x of from)
        into.add(x);
    }
    exports2.addAll = addAll;
    function extract(from, key) {
      const ret = from.get(key);
      return from.delete(key), ret;
    }
    exports2.extract = extract;
    function* flatMap(xs, fn) {
      for (const x of xs)
        for (const y of fn(x))
          yield y;
    }
    exports2.flatMap = flatMap;
    function* enumerate(xs) {
      let i = 0;
      for (const x of xs)
        yield [i++, x];
    }
    exports2.enumerate = enumerate;
    function expectProp(obj, key) {
      if (!obj[key])
        throw new Error(`Expecting '${String(key)}' to be set!`);
      return obj[key];
    }
    exports2.expectProp = expectProp;
    function* flatten(xs) {
      for (const x of xs)
        for (const y of x)
          yield y;
    }
    exports2.flatten = flatten;
    function filterEmpty(xs) {
      return xs.filter((x) => x);
    }
    exports2.filterEmpty = filterEmpty;
    function mapValues(xs, fn) {
      const ret = {};
      for (const [k, v] of Object.entries(xs))
        ret[k] = fn(v);
      return ret;
    }
    exports2.mapValues = mapValues;
    function mkdict(xs) {
      const ret = {};
      for (const [k, v] of xs)
        ret[k] = v;
      return ret;
    }
    exports2.mkdict = mkdict;
    function noEmptyObject(xs) {
      if (Object.keys(xs).length !== 0)
        return xs;
    }
    exports2.noEmptyObject = noEmptyObject;
    function noUndefined(xs) {
      return mkdict(Object.entries(xs).filter(([_, v]) => isDefined(v)));
    }
    exports2.noUndefined = noUndefined;
    function maybeSuffix(x, suffix) {
      if (x !== void 0)
        return `${x}${suffix}`;
    }
    exports2.maybeSuffix = maybeSuffix;
    function partition(xs, pred) {
      const yes = [], no = [];
      for (const x of xs)
        (pred(x) ? yes : no).push(x);
      return [yes, no];
    }
    exports2.partition = partition;
    function isDefined(x) {
      return x !== void 0;
    }
    exports2.isDefined = isDefined;
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/blueprint/shell-step.js
var require_shell_step = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/blueprint/shell-step.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.StackOutputReference = exports2.ShellStep = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var file_set_1 = require_file_set();
    var step_1 = require_step();
    var core_1 = require_core2();
    var javascript_1 = require_javascript();
    var ShellStep = class _ShellStep extends step_1.Step {
      constructor(id, props) {
        super(id), this.inputs = [], this.outputs = [], this._additionalOutputs = {};
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_pipelines_ShellStepProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ShellStep), error;
        }
        if (this.commands = props.commands, this.installCommands = props.installCommands ?? [], this.env = props.env ?? {}, this.envFromCfnOutputs = (0, javascript_1.mapValues)(props.envFromCfnOutputs ?? {}, StackOutputReference.fromCfnOutput), this.discoverReferencedOutputs({ env: this.env }), props.input) {
          const fileSet = props.input.primaryOutput;
          if (!fileSet)
            throw new Error(`'${id}': primary input should be a step that has produced a file set, got ${props.input}`);
          this.addDependencyFileSet(fileSet), this.inputs.push({ directory: ".", fileSet });
        }
        for (const [directory, step] of Object.entries(props.additionalInputs ?? {})) {
          if (directory === ".")
            throw new Error(`'${id}': input for directory '.' should be passed via 'input' property`);
          const fileSet = step.primaryOutput;
          if (!fileSet)
            throw new Error(`'${id}': additionalInput for directory '${directory}' should be a step that has produced a file set, got ${step}`);
          this.addDependencyFileSet(fileSet), this.inputs.push({ directory, fileSet });
        }
        if (props.primaryOutputDirectory) {
          this._primaryOutputDirectory = props.primaryOutputDirectory;
          const fileSet = new file_set_1.FileSet("Output", this);
          this.configurePrimaryOutput(fileSet), this.outputs.push({ directory: props.primaryOutputDirectory, fileSet });
        }
      }
      primaryOutputDirectory(directory) {
        if (this._primaryOutputDirectory !== void 0) {
          if (this._primaryOutputDirectory !== directory)
            throw new Error(`${this}: primaryOutputDirectory is '${this._primaryOutputDirectory}', cannot be changed to '${directory}'`);
          return this.primaryOutput;
        }
        this._primaryOutputDirectory = directory;
        const fileSet = new file_set_1.FileSet("Output", this);
        return this.configurePrimaryOutput(fileSet), this.outputs.push({ directory, fileSet }), fileSet;
      }
      addOutputDirectory(directory) {
        let fileSet = this._additionalOutputs[directory];
        return fileSet || (fileSet = new file_set_1.FileSet(directory, this), this._additionalOutputs[directory] = fileSet, this.outputs.push({ directory, fileSet })), fileSet;
      }
      get consumedStackOutputs() {
        return Object.values(this.envFromCfnOutputs);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ShellStep[_a] = { fqn: "aws-cdk-lib.pipelines.ShellStep", version: "2.80.0" }, exports2.ShellStep = ShellStep;
    var StackOutputReference = class _StackOutputReference {
      static fromCfnOutput(output) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_CfnOutput(output);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromCfnOutput), error;
        }
        const stack = core_1.Stack.of(output);
        return new _StackOutputReference(stack.node.path, stack.artifactId, stack.resolve(output.logicalId));
      }
      constructor(stackDescription, stackArtifactId, outputName) {
        this.stackDescription = stackDescription, this.stackArtifactId = stackArtifactId, this.outputName = outputName;
      }
      isProducedBy(stack) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_pipelines_StackDeployment(stack);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.isProducedBy), error;
        }
        return stack.stackArtifactId === this.stackArtifactId;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, StackOutputReference[_b] = { fqn: "aws-cdk-lib.pipelines.StackOutputReference", version: "2.80.0" }, exports2.StackOutputReference = StackOutputReference;
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/private/cloud-assembly-internals.js
var require_cloud_assembly_internals = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/private/cloud-assembly-internals.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.isStackArtifact = exports2.isAssetManifest = void 0;
    function isAssetManifest(s) {
      return s.constructor.name === "AssetManifestArtifact";
    }
    exports2.isAssetManifest = isAssetManifest;
    function isStackArtifact(a) {
      return a.constructor.name === "CloudFormationStackArtifact";
    }
    exports2.isStackArtifact = isStackArtifact;
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/blueprint/stack-deployment.js
var require_stack_deployment = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/blueprint/stack-deployment.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.StackDeployment = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var path = require("path");
    var asset_type_1 = require_asset_type();
    var cxapi = require_cx_api();
    var asset_manifest_1 = require_asset_manifest();
    var cloud_assembly_internals_1 = require_cloud_assembly_internals();
    var StackDeployment = class _StackDeployment {
      static fromArtifact(stackArtifact) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_cx_api_CloudFormationStackArtifact(stackArtifact);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromArtifact), error;
        }
        const artRegion = stackArtifact.environment.region, region = artRegion === cxapi.UNKNOWN_REGION ? void 0 : artRegion, artAccount = stackArtifact.environment.account, account = artAccount === cxapi.UNKNOWN_ACCOUNT ? void 0 : artAccount;
        return new _StackDeployment({ account, region, tags: stackArtifact.tags, stackArtifactId: stackArtifact.id, constructPath: stackArtifact.hierarchicalId, stackName: stackArtifact.stackName, absoluteTemplatePath: path.join(stackArtifact.assembly.directory, stackArtifact.templateFile), assumeRoleArn: stackArtifact.assumeRoleArn, executionRoleArn: stackArtifact.cloudFormationExecutionRoleArn, assets: extractStackAssets(stackArtifact), templateS3Uri: stackArtifact.stackTemplateAssetObjectUrl });
      }
      constructor(props) {
        this.stackDependencies = [], this.pre = [], this.changeSet = [], this.post = [], this.stackArtifactId = props.stackArtifactId, this.constructPath = props.constructPath, this.account = props.account, this.region = props.region, this.tags = props.tags ?? {}, this.assumeRoleArn = props.assumeRoleArn, this.executionRoleArn = props.executionRoleArn, this.stackName = props.stackName, this.absoluteTemplatePath = props.absoluteTemplatePath, this.templateUrl = props.templateS3Uri ? s3UrlFromUri(props.templateS3Uri, props.region) : void 0, this.assets = new Array();
        for (const asset of props.assets ?? [])
          asset.isTemplate ? this.templateAsset = asset : this.assets.push(asset);
      }
      addStackDependency(stackDeployment) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_pipelines_StackDeployment(stackDeployment);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addStackDependency), error;
        }
        this.stackDependencies.push(stackDeployment);
      }
      addStackSteps(pre, changeSet, post) {
        this.pre.push(...pre), this.changeSet.push(...changeSet), this.post.push(...post);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, StackDeployment[_a] = { fqn: "aws-cdk-lib.pipelines.StackDeployment", version: "2.80.0" }, exports2.StackDeployment = StackDeployment;
    function extractStackAssets(stackArtifact) {
      const ret = new Array(), assetManifests = stackArtifact.dependencies.filter(cloud_assembly_internals_1.isAssetManifest);
      for (const manifestArtifact of assetManifests) {
        const manifest = asset_manifest_1.AssetManifestReader.fromFile(manifestArtifact.file);
        for (const entry of manifest.entries) {
          let assetType, isTemplate = false;
          if (entry instanceof asset_manifest_1.DockerImageManifestEntry)
            assetType = asset_type_1.AssetType.DOCKER_IMAGE;
          else if (entry instanceof asset_manifest_1.FileManifestEntry)
            isTemplate = entry.source.packaging === "file" && entry.source.path === stackArtifact.templateFile, assetType = asset_type_1.AssetType.FILE;
          else
            throw new Error(`Unrecognized asset type: ${entry.type}`);
          ret.push({ assetManifestPath: manifestArtifact.file, assetId: entry.id.assetId, assetSelector: entry.id.toString(), assetType, assetPublishingRoleArn: entry.destination.assumeRoleArn, isTemplate });
        }
      }
      return ret;
    }
    function s3UrlFromUri(uri, region) {
      const url = uri.split("/");
      return `https://${url[2]}.s3.${region ? `${region}.` : ""}amazonaws.com/${url[3]}`;
    }
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/blueprint/stage-deployment.js
var require_stage_deployment = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/blueprint/stage-deployment.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.StageDeployment = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var stack_deployment_1 = require_stack_deployment();
    var cloud_assembly_internals_1 = require_cloud_assembly_internals();
    var construct_internals_1 = require_construct_internals();
    var StageDeployment = class _StageDeployment {
      static fromStage(stage, props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Stage(stage), jsiiDeprecationWarnings.aws_cdk_lib_pipelines_StageDeploymentProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromStage), error;
        }
        const assembly = (0, construct_internals_1.pipelineSynth)(stage);
        if (assembly.stacks.length === 0)
          throw new Error(`The given Stage construct ('${stage.node.path}') should contain at least one Stack`);
        const stepFromArtifact = /* @__PURE__ */ new Map();
        for (const artifact of assembly.stacks) {
          const step = stack_deployment_1.StackDeployment.fromArtifact(artifact);
          stepFromArtifact.set(artifact, step);
        }
        if (props.stackSteps)
          for (const stackstep of props.stackSteps) {
            const stackArtifact = assembly.getStackArtifact(stackstep.stack.artifactId), thisStep = stepFromArtifact.get(stackArtifact);
            if (!thisStep)
              throw new Error("Logic error: we just added a step for this artifact but it disappeared.");
            thisStep.addStackSteps(stackstep.pre ?? [], stackstep.changeSet ?? [], stackstep.post ?? []);
          }
        for (const artifact of assembly.stacks) {
          const thisStep = stepFromArtifact.get(artifact);
          if (!thisStep)
            throw new Error("Logic error: we just added a step for this artifact but it disappeared.");
          const stackDependencies = artifact.dependencies.filter(cloud_assembly_internals_1.isStackArtifact);
          for (const dep of stackDependencies) {
            const depStep = stepFromArtifact.get(dep);
            if (!depStep)
              throw new Error(`Stack '${artifact.id}' depends on stack not found in same Stage: '${dep.id}'`);
            thisStep.addStackDependency(depStep);
          }
        }
        return new _StageDeployment(Array.from(stepFromArtifact.values()), { stageName: stage.stageName, ...props });
      }
      constructor(stacks, props = {}) {
        this.stacks = stacks, this.stageName = props.stageName ?? "", this.pre = props.pre ?? [], this.post = props.post ?? [], this.stackSteps = props.stackSteps ?? [];
      }
      addPre(...steps) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_pipelines_Step(steps);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addPre), error;
        }
        this.pre.push(...steps);
      }
      addPost(...steps) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_pipelines_Step(steps);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addPost), error;
        }
        this.post.push(...steps);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, StageDeployment[_a] = { fqn: "aws-cdk-lib.pipelines.StageDeployment", version: "2.80.0" }, exports2.StageDeployment = StageDeployment;
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/blueprint/wave.js
var require_wave = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/blueprint/wave.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.Wave = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var stage_deployment_1 = require_stage_deployment();
    var Wave = class _Wave {
      constructor(id, props = {}) {
        this.id = id, this.stages = [];
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_pipelines_WaveProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Wave), error;
        }
        this.pre = props.pre ?? [], this.post = props.post ?? [];
      }
      addStage(stage, options = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Stage(stage), jsiiDeprecationWarnings.aws_cdk_lib_pipelines_AddStageOpts(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addStage), error;
        }
        const ret = stage_deployment_1.StageDeployment.fromStage(stage, options);
        return this.stages.push(ret), ret;
      }
      addPre(...steps) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_pipelines_Step(steps);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addPre), error;
        }
        this.pre.push(...steps);
      }
      addPost(...steps) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_pipelines_Step(steps);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addPost), error;
        }
        this.post.push(...steps);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Wave[_a] = { fqn: "aws-cdk-lib.pipelines.Wave", version: "2.80.0" }, exports2.Wave = Wave;
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/blueprint/manual-approval.js
var require_manual_approval = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/blueprint/manual-approval.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ManualApprovalStep = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var step_1 = require_step();
    var ManualApprovalStep = class _ManualApprovalStep extends step_1.Step {
      constructor(id, props = {}) {
        super(id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_pipelines_ManualApprovalStepProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ManualApprovalStep), error;
        }
        this.comment = props.comment, this.discoverReferencedOutputs(props.comment);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ManualApprovalStep[_a] = { fqn: "aws-cdk-lib.pipelines.ManualApprovalStep", version: "2.80.0" }, exports2.ManualApprovalStep = ManualApprovalStep;
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/blueprint/index.js
var require_blueprint = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/blueprint/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_asset_type(), exports2), __exportStar(require_file_set(), exports2), __exportStar(require_shell_step(), exports2), __exportStar(require_stack_deployment(), exports2), __exportStar(require_stage_deployment(), exports2), __exportStar(require_step(), exports2), __exportStar(require_wave(), exports2), __exportStar(require_manual_approval(), exports2);
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/helpers-internal/toposort.js
var require_toposort3 = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/helpers-internal/toposort.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.topoSort = exports2.printDependencyMap = void 0;
    function printDependencyMap(dependencies) {
      const lines = ["---"];
      for (const [k, vs] of dependencies.entries())
        lines.push(`${k} -> ${Array.from(vs)}`);
      console.log(lines.join(`
`));
    }
    exports2.printDependencyMap = printDependencyMap;
    function topoSort(nodes, dependencies, fail = true) {
      const remaining = new Set(nodes), ret = [];
      for (; remaining.size > 0; ) {
        const selectable = Array.from(remaining.values()).filter((e) => {
          if (!dependencies.has(e))
            throw new Error(`No key for ${e}`);
          return dependencies.get(e).size === 0;
        });
        if (selectable.sort((a, b) => a.id < b.id ? -1 : b.id < a.id ? 1 : 0), selectable.length === 0) {
          const cycle = findCycle(dependencies);
          if (fail)
            throw new Error(`Dependency cycle in graph: ${cycle.map((n) => n.id).join(" => ")}`);
          selectable.push(cycle[0]);
        }
        ret.push(selectable);
        for (const selected of selectable) {
          remaining.delete(selected);
          for (const depSet of dependencies.values())
            depSet.delete(selected);
        }
      }
      return ret;
    }
    exports2.topoSort = topoSort;
    function findCycle(deps) {
      for (const node of deps.keys()) {
        const cycle = recurse(node, [node]);
        if (cycle)
          return cycle;
      }
      throw new Error("No cycle found. Assertion failure!");
      function recurse(node, path) {
        for (const dep of deps.get(node) ?? []) {
          if (dep === path[0])
            return [...path, dep];
          const cycle = recurse(dep, [...path, dep]);
          if (cycle)
            return cycle;
        }
      }
    }
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/helpers-internal/graph.js
var require_graph2 = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/helpers-internal/graph.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.isGraph = exports2.GraphNodeCollection = exports2.Graph = exports2.DependencyBuilders = exports2.DependencyBuilder = exports2.GraphNode = void 0;
    var toposort_1 = require_toposort3();
    var javascript_1 = require_javascript();
    var GraphNode = class _GraphNode {
      static of(id, data) {
        return new _GraphNode(id, { data });
      }
      constructor(id, props = {}) {
        this.id = id, this.dependencies = [], this.data = props.data;
      }
      get uniqueId() {
        return this.ancestorPath(this.root).map((x) => x.id).join("-");
      }
      get allDeps() {
        const fromParent = this.parentGraph?.allDeps ?? [];
        return Array.from(/* @__PURE__ */ new Set([...this.dependencies, ...fromParent]));
      }
      dependOn(...dependencies) {
        if (dependencies.includes(this))
          throw new Error(`Cannot add dependency on self: ${this}`);
        this.dependencies.push(...dependencies.filter(javascript_1.isDefined));
      }
      ancestorPath(upTo) {
        let x = this;
        const ret = [x];
        for (; x.parentGraph && x.parentGraph !== upTo; )
          x = x.parentGraph, ret.unshift(x);
        return ret;
      }
      rootPath() {
        let x = this;
        const ret = [x];
        for (; x.parentGraph; )
          x = x.parentGraph, ret.unshift(x);
        return ret;
      }
      get root() {
        let x = this;
        for (; x.parentGraph; )
          x = x.parentGraph;
        return x;
      }
      get rootGraph() {
        const root = this.root;
        if (!(root instanceof Graph))
          throw new Error(`Expecting a graph as root, got: ${root}`);
        return root;
      }
      get parentGraph() {
        return this._parentGraph;
      }
      _setParentGraph(parentGraph) {
        if (this._parentGraph)
          throw new Error("Node already has a parent");
        this._parentGraph = parentGraph;
      }
      toString() {
        return `${this.constructor.name}(${this.id})`;
      }
    };
    exports2.GraphNode = GraphNode;
    var DependencyBuilder = class {
      constructor() {
        this._producers = [], this._consumers = [];
      }
      dependOn(...targets) {
        for (const target of targets) {
          for (const source of this._consumers)
            source.dependOn(target);
          this._producers.push(target);
        }
        return this;
      }
      dependBy(...sources) {
        for (const source of sources) {
          for (const target of this._producers)
            source.dependOn(target);
          this._consumers.push(source);
        }
        return this;
      }
      get hasUnsatisfiedConsumers() {
        return this._consumers.length > 0 && this._producers.length === 0;
      }
      get consumers() {
        return this._consumers;
      }
      consumersAsString() {
        return this.consumers.map((c) => `${c}`).join(",");
      }
    };
    exports2.DependencyBuilder = DependencyBuilder;
    var DependencyBuilders = class {
      constructor() {
        this.builders = /* @__PURE__ */ new Map();
      }
      for(key) {
        const b = this.builders.get(key);
        if (b)
          return b;
        const ret = new DependencyBuilder();
        return this.builders.set(key, ret), ret;
      }
      get(key) {
        return this.for(key);
      }
      unsatisfiedBuilders() {
        const ret = new Array();
        for (const [k, builder] of this.builders.entries())
          builder.hasUnsatisfiedConsumers && ret.push([k, builder]);
        return ret;
      }
    };
    exports2.DependencyBuilders = DependencyBuilders;
    var Graph = class _Graph extends GraphNode {
      static of(id, data, nodes) {
        return new _Graph(id, { data, nodes });
      }
      constructor(name, props = {}) {
        super(name, props), this.children = /* @__PURE__ */ new Map(), props.nodes && this.add(...props.nodes);
      }
      get nodes() {
        return new Set(this.children.values());
      }
      tryGetChild(name) {
        return this.children.get(name);
      }
      contains(node) {
        return this.nodes.has(node);
      }
      add(...nodes) {
        for (const node of nodes) {
          if (node._setParentGraph(this), this.children.has(node.id))
            throw new Error(`Node with duplicate id: ${node.id}`);
          this.children.set(node.id, node);
        }
      }
      absorb(other) {
        this.add(...other.nodes);
      }
      sortedChildren(fail = true) {
        const nodes = this.nodes, projectedDependencies = projectDependencies(this.deepDependencies(), (node) => {
          for (; !nodes.has(node) && node.parentGraph; )
            node = node.parentGraph;
          return nodes.has(node) ? [node] : [];
        });
        return (0, toposort_1.topoSort)(nodes, projectedDependencies, fail);
      }
      sortedLeaves() {
        const descendantsMap = /* @__PURE__ */ new Map();
        findDescendants(this);
        function findDescendants(node) {
          const ret = [];
          if (node instanceof _Graph)
            for (const child of node.nodes)
              ret.push(...findDescendants(child));
          else
            ret.push(node);
          return descendantsMap.set(node, ret), ret;
        }
        const projectedDependencies = projectDependencies(this.deepDependencies(), (node) => descendantsMap.get(node) ?? []);
        return (0, toposort_1.topoSort)(new Set(projectedDependencies.keys()), projectedDependencies);
      }
      render() {
        const lines = new Array();
        return recurse(this, "", true), lines.join(`
`);
        function recurse(x, indent, last) {
          const bullet = last ? "\u2514\u2500" : "\u251C\u2500", follow = last ? "  " : "\u2502 ";
          if (lines.push(`${indent} ${bullet} ${x}${depString(x)}`), x instanceof _Graph) {
            let i = 0;
            const sortedNodes = Array.prototype.concat.call([], ...x.sortedChildren(false));
            for (const child of sortedNodes)
              recurse(child, `${indent} ${follow} `, i++ == x.nodes.size - 1);
          }
        }
        function depString(node) {
          return node.dependencies.length > 0 ? ` -> ${Array.from(node.dependencies).join(", ")}` : "";
        }
      }
      renderDot() {
        const lines = new Array();
        lines.push("digraph G {"), lines.push('  # Arrows represent an "unlocks" relationship (opposite of dependency). So chosen'), lines.push("  # because the layout looks more natural that way."), lines.push("  # To represent subgraph dependencies, subgraphs are represented by BEGIN/END nodes."), lines.push("  # To render: `dot -Tsvg input.dot > graph.svg`, open in a browser."), lines.push('  node [shape="box"];');
        for (const child of this.nodes)
          recurse(child);
        return lines.push("}"), lines.join(`
`);
        function recurse(node) {
          let dependencySource;
          node instanceof _Graph ? (lines.push(`${graphBegin(node)} [shape="cds", style="filled", fillcolor="#b7deff"];`), lines.push(`${graphEnd(node)} [shape="cds", style="filled", fillcolor="#b7deff"];`), dependencySource = graphBegin(node)) : (dependencySource = nodeLabel(node), lines.push(`${nodeLabel(node)};`));
          for (const dep of node.dependencies) {
            const dst = dep instanceof _Graph ? graphEnd(dep) : nodeLabel(dep);
            lines.push(`${dst} -> ${dependencySource};`);
          }
          if (node instanceof _Graph && node.nodes.size > 0) {
            for (const child of node.nodes)
              recurse(child);
            const sortedChildren = node.sortedChildren(false);
            for (const first of sortedChildren[0]) {
              const src = first instanceof _Graph ? graphBegin(first) : nodeLabel(first);
              lines.push(`${graphBegin(node)} -> ${src};`);
            }
            for (const last of sortedChildren[sortedChildren.length - 1]) {
              const dst = last instanceof _Graph ? graphEnd(last) : nodeLabel(last);
              lines.push(`${dst} -> ${graphEnd(node)};`);
            }
          }
        }
        function id(node) {
          return node.rootPath().slice(1).map((n) => n.id).join(".");
        }
        function nodeLabel(node) {
          return `"${id(node)}"`;
        }
        function graphBegin(node) {
          return `"BEGIN ${id(node)}"`;
        }
        function graphEnd(node) {
          return `"END ${id(node)}"`;
        }
      }
      consoleLog(_indent = 0) {
        process.stdout.write(this.render() + `
`);
      }
      deepDependencies() {
        const ret = /* @__PURE__ */ new Map();
        for (const node of this.nodes)
          recurse(node);
        return ret;
        function recurse(node) {
          let deps = ret.get(node);
          deps || ret.set(node, deps = /* @__PURE__ */ new Set());
          for (let dep of node.dependencies)
            deps.add(dep);
          if (node instanceof _Graph)
            for (const child of node.nodes)
              recurse(child);
        }
      }
      allLeaves() {
        const ret = [];
        return recurse(this), new GraphNodeCollection(ret);
        function recurse(node) {
          if (node instanceof _Graph)
            for (const child of node.nodes)
              recurse(child);
          else
            ret.push(node);
        }
      }
    };
    exports2.Graph = Graph;
    var GraphNodeCollection = class {
      constructor(nodes) {
        this.nodes = Array.from(nodes);
      }
      dependOn(...dependencies) {
        for (const node of this.nodes)
          node.dependOn(...dependencies.filter(javascript_1.isDefined));
      }
      first() {
        const nodes = new Set(this.nodes), sorted = this.nodes[0].rootGraph.sortedLeaves();
        for (const tranche of sorted)
          for (const node of tranche)
            if (nodes.has(node))
              return node;
        throw new Error(`Could not calculate first node between ${this}`);
      }
      commonAncestor() {
        const paths = new Array();
        for (const x of this.nodes)
          paths.push(x.rootPath());
        if (paths.length === 0)
          throw new Error("Cannot find common ancestor between an empty set of nodes");
        if (paths.length === 1) {
          const path = paths[0];
          if (path.length < 2)
            throw new Error(`Cannot find ancestor of node without ancestor: ${path[0]}`);
          return path[path.length - 2];
        }
        const originalPaths = [...paths];
        for (; paths.every((path) => paths[0].length >= 2 && path.length >= 2 && path[1] === paths[0][1]); )
          for (const path of paths)
            path.shift();
        if (paths.some((path) => path.length < 2))
          throw new Error(`Could not determine a shared parent between nodes: ${originalPaths.map((nodes) => nodes.map((n) => n.id).join("/"))}`);
        return paths[0][0];
      }
      toString() {
        return this.nodes.map((n) => `${n}`).join(", ");
      }
    };
    exports2.GraphNodeCollection = GraphNodeCollection;
    function projectDependencies(dependencies, project) {
      for (const node of dependencies.keys()) {
        const projectedNodes = project(node);
        if (projectedNodes.length === 1 && projectedNodes[0] === node)
          continue;
        const deps = (0, javascript_1.extract)(dependencies, node);
        for (const projectedNode of projectedNodes)
          (0, javascript_1.addAll)(dependencies.get(projectedNode), deps);
      }
      for (const [node, deps] of dependencies.entries()) {
        const depset = new Set((0, javascript_1.flatMap)(deps, project));
        depset.delete(node), dependencies.set(node, depset);
      }
      return dependencies;
    }
    function isGraph(x) {
      return x instanceof Graph;
    }
    exports2.isGraph = isGraph;
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/helpers-internal/pipeline-queries.js
var require_pipeline_queries = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/helpers-internal/pipeline-queries.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PipelineQueries = void 0;
    var PipelineQueries = class {
      constructor(pipeline) {
        this.pipeline = pipeline;
      }
      stackOutputsReferenced(stack) {
        const steps = new Array();
        for (const wave of this.pipeline.waves) {
          steps.push(...wave.pre, ...wave.post);
          for (const stage of wave.stages) {
            steps.push(...stage.pre, ...stage.post);
            for (const stackDeployment of stage.stacks)
              steps.push(...stackDeployment.pre, ...stackDeployment.changeSet, ...stackDeployment.post);
          }
        }
        const ret = new Array();
        for (const step of steps)
          for (const outputRef of step.consumedStackOutputs)
            outputRef.isProducedBy(stack) && ret.push(outputRef.outputName);
        return ret;
      }
      producingStack(outputReference) {
        for (const wave of this.pipeline.waves)
          for (const stage of wave.stages)
            for (const stack of stage.stacks)
              if (outputReference.isProducedBy(stack))
                return stack;
        throw new Error(`Stack '${outputReference.stackDescription}' (producing output '${outputReference.outputName}') is not in the pipeline; call 'addStage()' to add the stack's Stage to the pipeline`);
      }
      assetsInStage(stage) {
        const assets = /* @__PURE__ */ new Map();
        for (const stack of stage.stacks)
          for (const asset of stack.assets)
            assets.set(asset.assetSelector, asset);
        return Array.from(assets.values());
      }
    };
    exports2.PipelineQueries = PipelineQueries;
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/helpers-internal/pipeline-graph.js
var require_pipeline_graph = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/helpers-internal/pipeline-graph.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PipelineGraph = void 0;
    var graph_1 = require_graph2();
    var pipeline_queries_1 = require_pipeline_queries();
    var blueprint_1 = require_blueprint();
    var PipelineGraph = class _PipelineGraph {
      constructor(pipeline, props = {}) {
        this.pipeline = pipeline, this.graph = graph_1.Graph.of("", { type: "group" }), this.added = /* @__PURE__ */ new Map(), this.assetNodes = /* @__PURE__ */ new Map(), this.assetNodesByType = /* @__PURE__ */ new Map(), this.stackOutputDependencies = new graph_1.DependencyBuilders(), this.nodeDependencies = new graph_1.DependencyBuilders(), this._fileAssetCtr = 0, this._dockerAssetCtr = 0, this.publishTemplate = props.publishTemplate ?? false, this.prepareStep = props.prepareStep ?? true, this.singlePublisher = props.singlePublisherPerAssetType ?? false, this.queries = new pipeline_queries_1.PipelineQueries(pipeline), pipeline.synth instanceof blueprint_1.Step && (this.synthNode = this.addBuildStep(pipeline.synth), this.synthNode?.data?.type === "step" && (this.synthNode.data.isBuildStep = true)), this.lastPreparationNode = this.synthNode;
        const cloudAssembly = pipeline.synth.primaryOutput?.primaryOutput;
        if (!cloudAssembly)
          throw new Error(`The synth step must produce the cloud assembly artifact, but doesn't: ${pipeline.synth}`);
        if (this.cloudAssemblyFileSet = cloudAssembly, props.selfMutation) {
          const stage = graph_1.Graph.of("UpdatePipeline", { type: "group" });
          this.graph.add(stage), this.selfMutateNode = aGraphNode("SelfMutate", { type: "self-update" }), stage.add(this.selfMutateNode), this.selfMutateNode.dependOn(this.synthNode), this.lastPreparationNode = this.selfMutateNode;
        }
        const waves = pipeline.waves.map((w) => this.addWave(w));
        for (let i = 1; i < waves.length; i++)
          waves[i].dependOn(waves[i - 1]);
        this.addMissingDependencyNodes();
      }
      isSynthNode(node) {
        return this.synthNode === node;
      }
      addBuildStep(step) {
        return this.addStepNode(step, this.topLevelGraph("Build"));
      }
      addWave(wave) {
        const retGraph = wave.stages.length === 1 ? this.addStage(wave.stages[0]) : graph_1.Graph.of(wave.id, { type: "group" }, wave.stages.map((s) => this.addStage(s)));
        return this.addPrePost(wave.pre, wave.post, retGraph), retGraph.dependOn(this.lastPreparationNode), this.graph.add(retGraph), retGraph;
      }
      addStage(stage) {
        const retGraph = graph_1.Graph.of(stage.stageName, { type: "group" }), stackGraphs = /* @__PURE__ */ new Map();
        for (const stack of stage.stacks) {
          const stackGraph = graph_1.Graph.of(this.simpleStackName(stack.stackName, stage.stageName), { type: "stack-group", stack }), prepareNode = this.prepareStep ? aGraphNode("Prepare", { type: "prepare", stack }) : void 0, deployNode = aGraphNode("Deploy", { type: "execute", stack, captureOutputs: this.queries.stackOutputsReferenced(stack).length > 0, withoutChangeSet: prepareNode === void 0 });
          retGraph.add(stackGraph), stackGraph.add(deployNode);
          let firstDeployNode;
          if (prepareNode ? (stackGraph.add(prepareNode), deployNode.dependOn(prepareNode), firstDeployNode = prepareNode) : firstDeployNode = deployNode, stack.changeSet.length > 0)
            if (prepareNode)
              this.addChangeSetNode(stack.changeSet, prepareNode, deployNode, stackGraph);
            else
              throw new Error(`Cannot use 'changeSet' steps for stack '${stack.stackName}': the pipeline does not support them or they have been disabled`);
          const preNodes = this.addPrePost(stack.pre, stack.post, stackGraph);
          preNodes.nodes.length > 0 && (firstDeployNode = preNodes), stackGraphs.set(stack, stackGraph);
          const cloudAssembly = this.cloudAssemblyFileSet;
          if (firstDeployNode.dependOn(this.addStepNode(cloudAssembly.producer, retGraph)), this.publishTemplate) {
            if (!stack.templateAsset)
              throw new Error(`"publishTemplate" is enabled, but stack ${stack.stackArtifactId} does not have a template asset`);
            firstDeployNode.dependOn(this.publishAsset(stack.templateAsset));
          }
          for (const asset of stack.assets) {
            const assetNode = this.publishAsset(asset);
            firstDeployNode.dependOn(assetNode);
          }
          this.queries.stackOutputsReferenced(stack).length > 0 && this.stackOutputDependencies.for(stack).dependOn(deployNode);
        }
        for (const stack of stage.stacks)
          for (const dep of stack.stackDependencies) {
            const stackNode = stackGraphs.get(stack), depNode = stackGraphs.get(dep);
            if (!stackNode)
              throw new Error(`cannot find node for ${stack.stackName}`);
            if (!depNode)
              throw new Error(`cannot find node for ${dep.stackName}`);
            stackNode.dependOn(depNode);
          }
        return this.addPrePost(stage.pre, stage.post, retGraph), retGraph;
      }
      addChangeSetNode(changeSet, prepareNode, deployNode, graph) {
        for (const c of changeSet) {
          const changeSetNode = this.addStepNode(c, graph);
          changeSetNode?.dependOn(prepareNode), deployNode.dependOn(changeSetNode);
        }
      }
      addPrePost(pre, post, parent) {
        const currentNodes = new graph_1.GraphNodeCollection(parent.nodes), preNodes = new graph_1.GraphNodeCollection(new Array());
        for (const p of pre) {
          const preNode = this.addStepNode(p, parent);
          currentNodes.dependOn(preNode), preNodes.nodes.push(preNode);
        }
        for (const p of post)
          this.addStepNode(p, parent)?.dependOn(...currentNodes.nodes);
        return preNodes;
      }
      topLevelGraph(name) {
        let ret = this.graph.tryGetChild(name);
        return ret || (ret = new graph_1.Graph(name), this.graph.add(ret)), ret;
      }
      addStepNode(step, parent) {
        if (step === _PipelineGraph.NO_STEP)
          return;
        const previous = this.added.get(step);
        if (previous)
          return previous;
        const node = aGraphNode(step.id, { type: "step", step });
        step.isSource && (parent = this.topLevelGraph("Source")), parent.add(node), this.added.set(step, node);
        for (const dep of step.dependencies)
          this.nodeDependencies.for(dep).dependBy(node);
        this.nodeDependencies.for(step).dependOn(node);
        for (const output of step.consumedStackOutputs) {
          const stack = this.queries.producingStack(output);
          this.stackOutputDependencies.for(stack).dependBy(node);
        }
        return node;
      }
      addMissingDependencyNodes() {
        let attempts = 20;
        for (; attempts-- > 0; ) {
          const unsatisfied2 = this.nodeDependencies.unsatisfiedBuilders().filter(([s]) => s !== _PipelineGraph.NO_STEP);
          if (unsatisfied2.length === 0)
            return;
          for (const [step, builder] of unsatisfied2) {
            const leftMostConsumer = new graph_1.GraphNodeCollection(builder.consumers).first(), parent = leftMostConsumer.parentGraph;
            if (!parent)
              throw new Error(`Consumer doesn't have a parent graph: ${leftMostConsumer}`);
            this.addStepNode(step, parent);
          }
        }
        const unsatisfied = this.nodeDependencies.unsatisfiedBuilders();
        throw new Error(["Recursion depth too large while adding dependency nodes:", unsatisfied.map(([step, builder]) => `${builder.consumersAsString()} awaiting ${step}.`)].join(" "));
      }
      publishAsset(stackAsset) {
        const assetsGraph = this.topLevelGraph("Assets");
        let assetNode = this.assetNodes.get(stackAsset.assetId);
        if (!assetNode)
          if (this.singlePublisher && this.assetNodesByType.has(stackAsset.assetType))
            assetNode = this.assetNodesByType.get(stackAsset.assetType);
          else {
            const id = stackAsset.assetType === blueprint_1.AssetType.FILE ? this.singlePublisher ? "FileAsset" : `FileAsset${++this._fileAssetCtr}` : this.singlePublisher ? "DockerAsset" : `DockerAsset${++this._dockerAssetCtr}`;
            assetNode = aGraphNode(id, { type: "publish-assets", assets: [] }), assetsGraph.add(assetNode), assetNode.dependOn(this.lastPreparationNode), this.assetNodesByType.set(stackAsset.assetType, assetNode), this.assetNodes.set(stackAsset.assetId, assetNode);
          }
        const data = assetNode.data;
        if (data?.type !== "publish-assets")
          throw new Error(`${assetNode} has the wrong data.type: ${data?.type}`);
        return data.assets.some((a) => a.assetSelector === stackAsset.assetSelector) || data.assets.push(stackAsset), assetNode;
      }
      simpleStackName(stackName, stageName) {
        return stripPrefix(stackName, `${stageName}-`);
      }
    };
    PipelineGraph.NO_STEP = new class extends blueprint_1.Step {
    }("NO_STEP"), exports2.PipelineGraph = PipelineGraph;
    function aGraphNode(id, x) {
      return graph_1.GraphNode.of(id, x);
    }
    function stripPrefix(s, prefix) {
      return s.startsWith(prefix) ? s.slice(prefix.length) : s;
    }
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/helpers-internal/index.js
var require_helpers_internal2 = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/helpers-internal/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_pipeline_graph(), exports2), __exportStar(require_graph2(), exports2), __exportStar(require_step_output(), exports2);
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/codepipeline/artifact-map.js
var require_artifact_map = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/codepipeline/artifact-map.js"(exports2) {
    "use strict";
    var _a;
    var _b;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CodePipelineFileSet = exports2.ArtifactMap = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var crypto = require("crypto");
    var cp = require_aws_codepipeline();
    var blueprint_1 = require_blueprint();
    var helpers_internal_1 = require_helpers_internal2();
    var ArtifactMap = class {
      constructor() {
        this.artifacts = /* @__PURE__ */ new Map(), this.usedNames = /* @__PURE__ */ new Set();
      }
      toCodePipeline(x) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_pipelines_FileSet(x);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.toCodePipeline), error;
        }
        if (x instanceof CodePipelineFileSet)
          return x._artifact;
        let ret = this.artifacts.get(x);
        if (!ret) {
          const artifactName = this.makeUniqueName(`${x.producer.id}.${x.id}`);
          this.usedNames.add(artifactName), this.artifacts.set(x, ret = new cp.Artifact(artifactName));
        }
        return ret;
      }
      makeUniqueName(baseName) {
        let i = 1;
        baseName = sanitizeArtifactName(baseName);
        let name = baseName;
        for (; this.usedNames.has(name); )
          name = `${baseName}${++i}`;
        return name;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ArtifactMap[_a] = { fqn: "aws-cdk-lib.pipelines.ArtifactMap", version: "2.80.0" }, exports2.ArtifactMap = ArtifactMap;
    function sanitizeArtifactName(x) {
      let sani = x.replace(/[^A-Za-z0-9_]/g, "_");
      const maxLength = 100;
      if (sani.length > maxLength) {
        const fingerprint = crypto.createHash("sha256").update(sani).digest("hex").slice(0, 8);
        sani = sani.slice(0, maxLength - fingerprint.length) + fingerprint;
      }
      return sani;
    }
    var CodePipelineFileSet = class _CodePipelineFileSet extends blueprint_1.FileSet {
      static fromArtifact(artifact) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_Artifact(artifact);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.fromArtifact), error;
        }
        return new _CodePipelineFileSet(artifact);
      }
      constructor(artifact) {
        super(artifact.artifactName ?? "Imported", helpers_internal_1.PipelineGraph.NO_STEP), this._artifact = artifact;
      }
    };
    _b = JSII_RTTI_SYMBOL_1, CodePipelineFileSet[_b] = { fqn: "aws-cdk-lib.pipelines.CodePipelineFileSet", version: "2.80.0" }, exports2.CodePipelineFileSet = CodePipelineFileSet;
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/codepipeline/private/buildspecs.js
var require_buildspecs = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/codepipeline/private/buildspecs.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.mergeBuildSpecs = void 0;
    var codebuild = require_aws_codebuild();
    function mergeBuildSpecs(a, b) {
      return !a || !b ? a ?? b : codebuild.mergeBuildSpecs(a, b);
    }
    exports2.mergeBuildSpecs = mergeBuildSpecs;
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/codepipeline/private/outputs.js
var require_outputs2 = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/codepipeline/private/outputs.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.namespaceName = exports2.namespaceStepOutputs = exports2.makeCodePipelineOutput = void 0;
    var helpers_internal_1 = require_helpers_internal2();
    var CODEPIPELINE_ENGINE_NAME = "codepipeline";
    function makeCodePipelineOutput(step, variableName) {
      return new helpers_internal_1.StepOutput(step, CODEPIPELINE_ENGINE_NAME, variableName).toString();
    }
    exports2.makeCodePipelineOutput = makeCodePipelineOutput;
    function namespaceStepOutputs(step, stage, name) {
      let ret;
      for (const output of helpers_internal_1.StepOutput.producedStepOutputs(step)) {
        if (ret = namespaceName(stage, name), output.engineName !== CODEPIPELINE_ENGINE_NAME)
          throw new Error(`Found unrecognized output type: ${output.engineName}`);
        if (typeof output.engineSpecificInformation != "string")
          throw new Error(`CodePipeline requires that 'engineSpecificInformation' is a string, got: ${JSON.stringify(output.engineSpecificInformation)}`);
        output.defineResolution(`#{${ret}.${output.engineSpecificInformation}}`);
      }
      return ret;
    }
    exports2.namespaceStepOutputs = namespaceStepOutputs;
    function namespaceName(stage, name) {
      return `${stage.stageName}/${name}`.replace(/[^a-zA-Z0-9@_-]/g, "@");
    }
    exports2.namespaceName = namespaceName;
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/codepipeline/codebuild-step.js
var require_codebuild_step = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/codepipeline/codebuild-step.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CodeBuildStep = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var buildspecs_1 = require_buildspecs();
    var outputs_1 = require_outputs2();
    var codebuild = require_aws_codebuild();
    var blueprint_1 = require_blueprint();
    var CodeBuildStep = class _CodeBuildStep extends blueprint_1.ShellStep {
      constructor(id, props) {
        super(id, props), this.exportedVariables = /* @__PURE__ */ new Set(), this.exportedVarsRendered = false;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_pipelines_CodeBuildStepProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CodeBuildStep), error;
        }
        this.projectName = props.projectName, this.buildEnvironment = props.buildEnvironment, this._partialBuildSpec = props.partialBuildSpec, this.vpc = props.vpc, this.subnetSelection = props.subnetSelection, this.cache = props.cache, this.role = props.role, this.actionRole = props.actionRole, this.rolePolicyStatements = props.rolePolicyStatements, this.securityGroups = props.securityGroups, this.timeout = props.timeout, this.fileSystemLocations = props.fileSystemLocations, this.logging = props.logging;
      }
      get project() {
        if (!this._project)
          throw new Error("Call pipeline.buildPipeline() before reading this property");
        return this._project;
      }
      get grantPrincipal() {
        return this.project.grantPrincipal;
      }
      get partialBuildSpec() {
        this.exportedVarsRendered = true;
        const varsBuildSpec = this.exportedVariables.size > 0 ? codebuild.BuildSpec.fromObject({ version: "0.2", env: { "exported-variables": Array.from(this.exportedVariables) } }) : void 0;
        return (0, buildspecs_1.mergeBuildSpecs)(varsBuildSpec, this._partialBuildSpec);
      }
      exportedVariable(variableName) {
        if (this.exportedVarsRendered && !this.exportedVariables.has(variableName))
          throw new Error("exportVariable(): Pipeline has already been produced, cannot call this function anymore");
        return this.exportedVariables.add(variableName), (0, outputs_1.makeCodePipelineOutput)(this, variableName);
      }
      _setProject(project) {
        this._project = project;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CodeBuildStep[_a] = { fqn: "aws-cdk-lib.pipelines.CodeBuildStep", version: "2.80.0" }, exports2.CodeBuildStep = CodeBuildStep;
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/codepipeline/confirm-permissions-broadening.js
var require_confirm_permissions_broadening = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/codepipeline/confirm-permissions-broadening.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.ConfirmPermissionsBroadening = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var cpa = require_aws_codepipeline_actions();
    var blueprint_1 = require_blueprint();
    var application_security_check_1 = require_application_security_check();
    var ConfirmPermissionsBroadening = class _ConfirmPermissionsBroadening extends blueprint_1.Step {
      constructor(id, props) {
        super(id), this.props = props;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_pipelines_PermissionsBroadeningCheckProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _ConfirmPermissionsBroadening), error;
        }
      }
      produceAction(stage, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_IStage(stage), jsiiDeprecationWarnings.aws_cdk_lib_pipelines_ProduceActionOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.produceAction), error;
        }
        const sec = this.getOrCreateSecCheck(options.pipeline);
        this.props.notificationTopic?.grantPublish(sec.cdkDiffProject);
        const variablesNamespace = constructs_1.Node.of(this.props.stage).addr, approveActionName = `${options.actionName}.Confirm`;
        return stage.addAction(new cpa.CodeBuildAction({ runOrder: options.runOrder, actionName: `${options.actionName}.Check`, input: options.artifacts.toCodePipeline(options.pipeline.cloudAssemblyFileSet), project: sec.cdkDiffProject, variablesNamespace, environmentVariables: { STAGE_PATH: { value: constructs_1.Node.of(this.props.stage).path }, STAGE_NAME: { value: stage.stageName }, ACTION_NAME: { value: approveActionName }, ...this.props.notificationTopic ? { NOTIFICATION_ARN: { value: this.props.notificationTopic.topicArn }, NOTIFICATION_SUBJECT: { value: `Confirm permission broadening in ${this.props.stage.stageName}` } } : {} } })), stage.addAction(new cpa.ManualApprovalAction({ actionName: approveActionName, runOrder: options.runOrder + 1, additionalInformation: `#{${variablesNamespace}.MESSAGE}`, externalEntityLink: `#{${variablesNamespace}.LINK}` })), { runOrdersConsumed: 2 };
      }
      getOrCreateSecCheck(pipeline) {
        const id = "PipelinesSecurityCheck", existing = constructs_1.Node.of(pipeline).tryFindChild(id);
        if (existing) {
          if (!(existing instanceof application_security_check_1.ApplicationSecurityCheck))
            throw new Error(`Expected '${constructs_1.Node.of(existing).path}' to be 'ApplicationSecurityCheck' but was '${existing}'`);
          return existing;
        }
        return new application_security_check_1.ApplicationSecurityCheck(pipeline, id, { codePipeline: pipeline.pipeline });
      }
    };
    _a = JSII_RTTI_SYMBOL_1, ConfirmPermissionsBroadening[_a] = { fqn: "aws-cdk-lib.pipelines.ConfirmPermissionsBroadening", version: "2.80.0" }, exports2.ConfirmPermissionsBroadening = ConfirmPermissionsBroadening;
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/private/identifiers.js
var require_identifiers2 = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/private/identifiers.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.limitIdentifierLength = exports2.stackVariableNamespace = exports2.actionName = exports2.hash = void 0;
    var crypto = require("crypto");
    function hash(obj) {
      const d = crypto.createHash("sha256");
      return d.update(JSON.stringify(obj)), d.digest("hex");
    }
    exports2.hash = hash;
    function actionName(node, parent) {
      const names = node.ancestorPath(parent).map((n) => n.id).map(sanitizeName), totalMax = 100;
      if (names.join(".").length <= totalMax)
        return names.join(".");
      const componentMin = 15, dots = names.length - 1, maxLength = Math.max(componentMin, Math.floor((totalMax - dots) / names.length)), trimmedNames = names.map((name) => limitIdentifierLength(name, maxLength));
      return limitIdentifierLength(trimmedNames.join("."), totalMax);
    }
    exports2.actionName = actionName;
    function stackVariableNamespace(stack) {
      return limitIdentifierLength(stack.stackArtifactId, 100);
    }
    exports2.stackVariableNamespace = stackVariableNamespace;
    function sanitizeName(x) {
      return x.replace(/[^A-Za-z0-9.@\-_]/g, "_");
    }
    function limitIdentifierLength(s, n) {
      if (s.length <= n)
        return s;
      const h = hash(s).slice(0, 8), mid = Math.floor((n - h.length) / 2);
      return s.slice(0, mid) + h + s.slice(-mid);
    }
    exports2.limitIdentifierLength = limitIdentifierLength;
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/codepipeline/private/codebuild-factory.js
var require_codebuild_factory = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/codepipeline/private/codebuild-factory.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.mergeCodeBuildOptions = exports2.CodeBuildFactory = void 0;
    var fs = require("fs");
    var path = require("path");
    var constructs_1 = require_lib2();
    var buildspecs_1 = require_buildspecs();
    var codebuild = require_aws_codebuild();
    var codepipeline_actions = require_aws_codepipeline_actions();
    var ec2 = require_aws_ec2();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var step_output_1 = require_step_output();
    var construct_internals_1 = require_construct_internals();
    var identifiers_1 = require_identifiers2();
    var javascript_1 = require_javascript();
    var CodeBuildFactory = class _CodeBuildFactory {
      static fromShellStep(constructId, shellStep, additional) {
        return new _CodeBuildFactory(constructId, { commands: shellStep.commands, env: shellStep.env, envFromCfnOutputs: shellStep.envFromCfnOutputs, inputs: shellStep.inputs, outputs: shellStep.outputs, stepId: shellStep.id, installCommands: shellStep.installCommands, producedStepOutputs: step_output_1.StepOutput.producedStepOutputs(shellStep), ...additional });
      }
      static fromCodeBuildStep(constructId, step, additional) {
        const factory = _CodeBuildFactory.fromShellStep(constructId, step, { projectName: step.projectName, role: step.role, actionRole: step.actionRole, ...additional, projectOptions: mergeCodeBuildOptions(additional?.projectOptions, { buildEnvironment: step.buildEnvironment, rolePolicy: step.rolePolicyStatements, securityGroups: step.securityGroups, partialBuildSpec: step.partialBuildSpec, vpc: step.vpc, subnetSelection: step.subnetSelection, cache: step.cache, timeout: step.timeout, fileSystemLocations: step.fileSystemLocations, logging: step.logging }) });
        return { produceAction: (stage, options) => {
          const result = factory.produceAction(stage, options);
          return result.project && step._setProject(result.project), result;
        } };
      }
      constructor(constructId, props) {
        this.constructId = constructId, this.props = props, this.stepId = props.stepId ?? constructId;
      }
      get project() {
        if (!this._project)
          throw new Error("Project becomes available after produce() has been called");
        return this._project;
      }
      produceAction(stage, options) {
        const projectOptions = mergeCodeBuildOptions(options.codeBuildDefaults, this.props.projectOptions);
        if ((!projectOptions.buildEnvironment?.privileged || projectOptions.vpc === void 0) && projectOptions.fileSystemLocations !== void 0 && projectOptions.fileSystemLocations.length != 0)
          throw new Error("Setting fileSystemLocations requires a vpc to be set and privileged to be set to true.");
        const inputs = this.props.inputs ?? [], outputs = this.props.outputs ?? [], mainInput = inputs.find((x) => x.directory === "."), extraInputs = inputs.filter((x) => x.directory !== "."), inputArtifact = mainInput ? options.artifacts.toCodePipeline(mainInput.fileSet) : options.fallbackArtifact, extraInputArtifacts = extraInputs.map((x) => options.artifacts.toCodePipeline(x.fileSet)), outputArtifacts = outputs.map((x) => options.artifacts.toCodePipeline(x.fileSet));
        if (!inputArtifact)
          throw new Error(`CodeBuild action '${this.stepId}' requires an input (and the pipeline doesn't have a Source to fall back to). Add an input or a pipeline source.`);
        const installCommands = [...generateInputArtifactLinkCommands(options.artifacts, extraInputs), ...this.props.installCommands ?? []], buildSpecHere = codebuild.BuildSpec.fromObject({ version: "0.2", phases: { install: (installCommands.length ?? 0) > 0 ? { commands: installCommands } : void 0, build: this.props.commands.length > 0 ? { commands: this.props.commands } : void 0 }, artifacts: (0, javascript_1.noEmptyObject)(renderArtifactsBuildSpec(options.artifacts, this.props.outputs ?? [])) }), env = (0, javascript_1.noUndefined)(this.props.env ?? {}), [actionEnvs, projectEnvs] = (0, javascript_1.partition)(Object.entries(env ?? {}), ([, v]) => containsPipelineVariable(v)), environment = mergeBuildEnvironments(projectOptions?.buildEnvironment ?? {}, { environmentVariables: (0, javascript_1.noEmptyObject)((0, javascript_1.mapValues)((0, javascript_1.mkdict)(projectEnvs), (value) => ({ value }))) }), fullBuildSpec = projectOptions?.partialBuildSpec ? codebuild.mergeBuildSpecs(projectOptions.partialBuildSpec, buildSpecHere) : buildSpecHere, osFromEnvironment = environment.buildImage && environment.buildImage instanceof codebuild.WindowsBuildImage ? ec2.OperatingSystemType.WINDOWS : ec2.OperatingSystemType.LINUX, actualBuildSpec = filterBuildSpecCommands(fullBuildSpec, osFromEnvironment), scope = this.props.scope ?? options.scope;
        let projectBuildSpec;
        if (this.props.passBuildSpecViaCloudAssembly) {
          const relativeSpecFile = `buildspec-${constructs_1.Node.of(scope).addr}-${this.constructId}.yaml`, absSpecFile = path.join((0, construct_internals_1.cloudAssemblyBuildSpecDir)(scope), relativeSpecFile), fileContents = core_1.Stack.of(scope).resolve(actualBuildSpec.toBuildSpec());
          if (typeof fileContents != "string")
            throw new Error(`This BuildSpec contains CloudFormation references and is supported by publishInParallel=false: ${JSON.stringify(fileContents, void 0, 2)}`);
          fs.writeFileSync(absSpecFile, fileContents, { encoding: "utf-8" }), projectBuildSpec = codebuild.BuildSpec.fromSourceFilename(relativeSpecFile);
        } else
          projectBuildSpec = actualBuildSpec;
        const projectConfigHash = (0, identifiers_1.hash)(core_1.Stack.of(scope).resolve({ environment: serializeBuildEnvironment(environment), buildSpecString: actualBuildSpec.toBuildSpec() })), actionName = options.actionName ?? this.stepId;
        let projectScope = scope;
        (this.props.additionalConstructLevel ?? true) && (projectScope = (0, construct_internals_1.obtainScope)(scope, actionName));
        const safePipelineName = core_1.Token.isUnresolved(options.pipeline.pipeline.pipelineName) ? `${core_1.Stack.of(options.pipeline).stackName}/${constructs_1.Node.of(options.pipeline.pipeline).id}` : options.pipeline.pipeline.pipelineName, project = new codebuild.PipelineProject(projectScope, this.constructId, { projectName: this.props.projectName, description: `Pipeline step ${safePipelineName}/${stage.stageName}/${actionName}`.substring(0, 255), environment, vpc: projectOptions.vpc, subnetSelection: projectOptions.subnetSelection, securityGroups: projectOptions.securityGroups, cache: projectOptions.cache, buildSpec: projectBuildSpec, role: this.props.role, timeout: projectOptions.timeout, fileSystemLocations: projectOptions.fileSystemLocations, logging: projectOptions.logging });
        this.props.additionalDependable && project.node.addDependency(this.props.additionalDependable), projectOptions.rolePolicy !== void 0 && projectOptions.rolePolicy.forEach((policyStatement) => {
          project.addToRolePolicy(policyStatement);
        });
        const stackOutputEnv = (0, javascript_1.mapValues)(this.props.envFromCfnOutputs ?? {}, (outputRef) => options.stackOutputsMap.toCodePipeline(outputRef)), configHashEnv = options.beforeSelfMutation ? { _PROJECT_CONFIG_HASH: projectConfigHash } : {}, actionRoleCid = "CodeBuildActionRole", actionRole = this.props.actionRole ?? options.pipeline.node.tryFindChild(actionRoleCid) ?? new iam.Role(options.pipeline, actionRoleCid, { assumedBy: options.pipeline.pipeline.role });
        return stage.addAction(new codepipeline_actions.CodeBuildAction({ actionName, input: inputArtifact, extraInputs: extraInputArtifacts, outputs: outputArtifacts, project, runOrder: options.runOrder, variablesNamespace: options.variablesNamespace, role: actionRole, environmentVariables: (0, javascript_1.noEmptyObject)(cbEnv({ ...(0, javascript_1.mkdict)(actionEnvs), ...configHashEnv, ...stackOutputEnv })) })), this._project = project, { runOrdersConsumed: 1, project };
      }
    };
    exports2.CodeBuildFactory = CodeBuildFactory;
    function generateInputArtifactLinkCommands(artifacts, inputs) {
      return inputs.map((input) => {
        const fragments = [];
        fragments.push(`[ ! -d "${input.directory}" ] || { echo 'additionalInputs: "${input.directory}" must not exist yet. If you want to merge multiple artifacts, use a "cp" command.'; exit 1; }`);
        const parentDirectory = path.dirname(input.directory);
        [".", ".."].includes(parentDirectory) || fragments.push(`mkdir -p -- "${parentDirectory}"`);
        const artifact = artifacts.toCodePipeline(input.fileSet);
        return fragments.push(`ln -s -- "$CODEBUILD_SRC_DIR_${artifact.artifactName}" "${input.directory}"`), fragments.join(" && ");
      });
    }
    function renderArtifactsBuildSpec(artifactMap, outputs) {
      if (outputs.length === 0)
        return {};
      if (outputs.length === 1)
        return { "base-directory": outputs[0].directory, files: "**/*" };
      const secondary = {};
      for (const output of outputs) {
        const art = artifactMap.toCodePipeline(output.fileSet);
        if (!art.artifactName)
          throw new Error("You must give the output artifact a name");
        secondary[art.artifactName] = { "base-directory": output.directory, files: "**/*" };
      }
      return { "secondary-artifacts": secondary };
    }
    function mergeCodeBuildOptions(...opts) {
      const xs = [{}, ...opts.filter(isDefined)];
      for (; xs.length > 1; ) {
        const [a, b] = xs.splice(xs.length - 2, 2);
        xs.push(merge2(a, b));
      }
      return xs[0];
      function merge2(a, b) {
        return { buildEnvironment: mergeBuildEnvironments(a.buildEnvironment, b.buildEnvironment), rolePolicy: definedArray([...a.rolePolicy ?? [], ...b.rolePolicy ?? []]), securityGroups: definedArray([...a.securityGroups ?? [], ...b.securityGroups ?? []]), partialBuildSpec: (0, buildspecs_1.mergeBuildSpecs)(a.partialBuildSpec, b.partialBuildSpec), vpc: b.vpc ?? a.vpc, subnetSelection: b.subnetSelection ?? a.subnetSelection, timeout: b.timeout ?? a.timeout, cache: b.cache ?? a.cache, fileSystemLocations: definedArray([...a.fileSystemLocations ?? [], ...b.fileSystemLocations ?? []]), logging: b.logging ?? a.logging };
      }
    }
    exports2.mergeCodeBuildOptions = mergeCodeBuildOptions;
    function mergeBuildEnvironments(a, b) {
      return !a || !b ? a ?? b : { buildImage: b.buildImage ?? a.buildImage, computeType: b.computeType ?? a.computeType, environmentVariables: { ...a.environmentVariables, ...b.environmentVariables }, privileged: b.privileged ?? a.privileged };
    }
    function isDefined(x) {
      return x !== void 0;
    }
    function serializeBuildEnvironment(env) {
      return { privileged: env.privileged, environmentVariables: env.environmentVariables, type: env.buildImage?.type, imageId: env.buildImage?.imageId, computeType: env.computeType, imagePullPrincipalType: env.buildImage?.imagePullPrincipalType, secretsManagerArn: env.buildImage?.secretsManagerCredentials?.secretArn };
    }
    function containsPipelineVariable(s) {
      return !!s.match(/#\{[^}]+\}/) || step_output_1.StepOutput.findAll(s).length > 0;
    }
    function cbEnv(xs) {
      return (0, javascript_1.mkdict)(Object.entries(xs).filter(([, v]) => v !== void 0).map(([k, v]) => [k, { value: v }]));
    }
    function definedArray(xs) {
      return xs.length > 0 ? xs : void 0;
    }
    function filterBuildSpecCommands(buildSpec, osType) {
      if (!buildSpec.isImmediate)
        return buildSpec;
      const spec = buildSpec.spec, winTag = "!WINDOWS!", linuxTag = "!LINUX!", expectedTag = osType === ec2.OperatingSystemType.WINDOWS ? winTag : linuxTag;
      return codebuild.BuildSpec.fromObject(recurse(spec));
      function recurse(x) {
        if (Array.isArray(x)) {
          const ret = [];
          for (const el of x) {
            const [tag, payload2] = extractTag(el);
            (tag === void 0 || tag === expectedTag) && ret.push(payload2);
          }
          return ret;
        }
        return x && typeof x == "object" ? (0, javascript_1.mapValues)(x, recurse) : x;
      }
      function extractTag(x) {
        if (typeof x != "string")
          return [void 0, x];
        for (const tag of [winTag, linuxTag])
          if (x.startsWith(tag))
            return [tag, x.slice(tag.length)];
        return [void 0, x];
      }
    }
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/codepipeline/stack-outputs-map.js
var require_stack_outputs_map = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/codepipeline/stack-outputs-map.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.StackOutputsMap = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var pipeline_queries_1 = require_pipeline_queries();
    var identifiers_1 = require_identifiers2();
    var StackOutputsMap = class _StackOutputsMap {
      constructor(pipeline) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_pipelines_PipelineBase(pipeline);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _StackOutputsMap), error;
        }
        this.queries = new pipeline_queries_1.PipelineQueries(pipeline);
      }
      toCodePipeline(x) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_pipelines_StackOutputReference(x);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.toCodePipeline), error;
        }
        return `#{${(0, identifiers_1.stackVariableNamespace)(this.queries.producingStack(x))}.${x.outputName}}`;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, StackOutputsMap[_a] = { fqn: "aws-cdk-lib.pipelines.StackOutputsMap", version: "2.80.0" }, exports2.StackOutputsMap = StackOutputsMap;
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/main/pipeline-base.js
var require_pipeline_base = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/main/pipeline-base.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.PipelineBase = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var core_1 = require_core2();
    var blueprint_1 = require_blueprint();
    var PIPELINE_SYMBOL = Symbol.for("@aws-cdk/pipelines.PipelineBase");
    var PipelineBase = class _PipelineBase extends constructs_1.Construct {
      static isPipeline(x) {
        return x !== null && typeof x == "object" && PIPELINE_SYMBOL in x;
      }
      constructor(scope, id, props) {
        super(scope, id), this.built = false;
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_pipelines_PipelineBaseProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _PipelineBase), error;
        }
        if (Object.defineProperty(this, PIPELINE_SYMBOL, { value: true }), props.synth instanceof blueprint_1.ShellStep && !props.synth.primaryOutput && props.synth.primaryOutputDirectory("cdk.out"), !props.synth.primaryOutput)
          throw new Error(`synthStep ${props.synth} must produce a primary output, but is not producing anything. Configure the Step differently or use a different Step type.`);
        this.synth = props.synth, this.waves = [], this.cloudAssemblyFileSet = props.synth.primaryOutput, core_1.Aspects.of(this).add({ visit: () => this.buildJustInTime() });
      }
      addStage(stage, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_Stage(stage), jsiiDeprecationWarnings.aws_cdk_lib_pipelines_AddStageOpts(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addStage), error;
        }
        if (this.built)
          throw new Error("addStage: can't add Stages anymore after buildPipeline() has been called");
        return this.addWave(stage.stageName).addStage(stage, options);
      }
      addWave(id, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_pipelines_WaveOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.addWave), error;
        }
        if (this.built)
          throw new Error("addWave: can't add Waves anymore after buildPipeline() has been called");
        const wave = new blueprint_1.Wave(id, options);
        return this.waves.push(wave), wave;
      }
      buildPipeline() {
        if (this.built)
          throw new Error("build() has already been called: can only call it once");
        this.doBuildPipeline(), this.built = true;
      }
      buildJustInTime() {
        this.built || this.buildPipeline();
      }
    };
    _a = JSII_RTTI_SYMBOL_1, PipelineBase[_a] = { fqn: "aws-cdk-lib.pipelines.PipelineBase", version: "2.80.0" }, exports2.PipelineBase = PipelineBase;
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/main/index.js
var require_main = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/main/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_pipeline_base(), exports2);
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/private/template-configuration.js
var require_template_configuration = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/private/template-configuration.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.writeTemplateConfiguration = void 0;
    var fs = require("fs");
    function writeTemplateConfiguration(filename, config) {
      fs.writeFileSync(filename, JSON.stringify(config, void 0, 2), { encoding: "utf-8" });
    }
    exports2.writeTemplateConfiguration = writeTemplateConfiguration;
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/codepipeline/codepipeline.js
var require_codepipeline3 = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/codepipeline/codepipeline.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CodePipeline = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var fs = require("fs");
    var path = require("path");
    var artifact_map_1 = require_artifact_map();
    var codebuild_step_1 = require_codebuild_step();
    var codebuild_factory_1 = require_codebuild_factory();
    var outputs_1 = require_outputs2();
    var stack_outputs_map_1 = require_stack_outputs_map();
    var cb = require_aws_codebuild();
    var cp = require_aws_codepipeline();
    var cpa = require_aws_codepipeline_actions();
    var iam = require_aws_iam();
    var core_1 = require_core2();
    var cxapi = require_cx_api();
    var blueprint_1 = require_blueprint();
    var docker_credentials_1 = require_docker_credentials();
    var helpers_internal_1 = require_helpers_internal2();
    var main_1 = require_main();
    var asset_singleton_role_1 = require_asset_singleton_role();
    var cached_fnsub_1 = require_cached_fnsub();
    var cli_version_1 = require_cli_version();
    var construct_internals_1 = require_construct_internals();
    var default_codebuild_image_1 = require_default_codebuild_image();
    var fs_1 = require_fs3();
    var identifiers_1 = require_identifiers2();
    var javascript_1 = require_javascript();
    var template_configuration_1 = require_template_configuration();
    var CodePipeline = class _CodePipeline extends main_1.PipelineBase {
      constructor(scope, id, props) {
        super(scope, id, props), this.props = props, this.artifacts = new artifact_map_1.ArtifactMap(), this.cachedFnSub = new cached_fnsub_1.CachedFnSub(), this.assetCodeBuildRoles = /* @__PURE__ */ new Map();
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_pipelines_CodePipelineProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _CodePipeline), error;
        }
        this.selfMutationEnabled = props.selfMutation ?? true, this.dockerCredentials = props.dockerCredentials ?? [], this.singlePublisherPerAssetType = !(props.publishAssetsInParallel ?? true), this.cliVersion = props.cliVersion ?? (0, cli_version_1.preferredCliVersion)(), this.useChangeSets = props.useChangeSets ?? true, this.stackOutputs = new stack_outputs_map_1.StackOutputsMap(this);
      }
      get synthProject() {
        if (!this._synthProject)
          throw new Error("Call pipeline.buildPipeline() before reading this property");
        return this._synthProject;
      }
      get selfMutationProject() {
        if (!this._pipeline)
          throw new Error("Call pipeline.buildPipeline() before reading this property");
        if (!this._selfMutationProject)
          throw new Error("No selfMutationProject since the selfMutation property was set to false");
        return this._selfMutationProject;
      }
      get pipeline() {
        if (!this._pipeline)
          throw new Error("Pipeline not created yet");
        return this._pipeline;
      }
      doBuildPipeline() {
        if (this._pipeline)
          throw new Error("Pipeline already created");
        if (this._myCxAsmRoot = path.resolve((0, construct_internals_1.assemblyBuilderOf)((0, construct_internals_1.appOf)(this)).outdir), this.props.codePipeline) {
          if (this.props.pipelineName)
            throw new Error("Cannot set 'pipelineName' if an existing CodePipeline is given using 'codePipeline'");
          if (this.props.crossAccountKeys !== void 0)
            throw new Error("Cannot set 'crossAccountKeys' if an existing CodePipeline is given using 'codePipeline'");
          if (this.props.enableKeyRotation !== void 0)
            throw new Error("Cannot set 'enableKeyRotation' if an existing CodePipeline is given using 'codePipeline'");
          if (this.props.reuseCrossRegionSupportStacks !== void 0)
            throw new Error("Cannot set 'reuseCrossRegionSupportStacks' if an existing CodePipeline is given using 'codePipeline'");
          if (this.props.role !== void 0)
            throw new Error("Cannot set 'role' if an existing CodePipeline is given using 'codePipeline'");
          if (this.props.artifactBucket !== void 0)
            throw new Error("Cannot set 'artifactBucket' if an existing CodePipeline is given using 'codePipeline'");
          this._pipeline = this.props.codePipeline;
        } else
          this._pipeline = new cp.Pipeline(this, "Pipeline", { pipelineName: this.props.pipelineName, crossAccountKeys: this.props.crossAccountKeys ?? false, reuseCrossRegionSupportStacks: this.props.reuseCrossRegionSupportStacks, restartExecutionOnUpdate: true, role: this.props.role, enableKeyRotation: this.props.enableKeyRotation, artifactBucket: this.props.artifactBucket });
        const graphFromBp = new helpers_internal_1.PipelineGraph(this, { selfMutation: this.selfMutationEnabled, singlePublisherPerAssetType: this.singlePublisherPerAssetType, prepareStep: this.useChangeSets });
        this._cloudAssemblyFileSet = graphFromBp.cloudAssemblyFileSet, this.pipelineStagesAndActionsFromGraph(graphFromBp);
        const dotFile = `${core_1.Names.uniqueId(this)}.dot`;
        fs.writeFileSync(path.join(this.myCxAsmRoot, dotFile), graphFromBp.graph.renderDot().replace(/input\.dot/, dotFile), { encoding: "utf-8" });
      }
      get myCxAsmRoot() {
        if (!this._myCxAsmRoot)
          throw new Error("Can't read 'myCxAsmRoot' if build deployment not called yet");
        return this._myCxAsmRoot;
      }
      get assetsScope() {
        return (0, construct_internals_1.obtainScope)(this, "Assets");
      }
      pipelineStagesAndActionsFromGraph(structure) {
        let beforeSelfMutation = this.selfMutationEnabled;
        for (const stageNode of (0, javascript_1.flatten)(structure.graph.sortedChildren())) {
          if (!(0, helpers_internal_1.isGraph)(stageNode))
            throw new Error(`Top-level children must be graphs, got '${stageNode}'`);
          const chunks = chunkTranches(50, stageNode.sortedLeaves()), actionsOverflowStage = chunks.length > 1;
          for (const [i, tranches] of (0, javascript_1.enumerate)(chunks)) {
            const stageName = actionsOverflowStage ? `${stageNode.id}.${i + 1}` : stageNode.id, pipelineStage = this.pipeline.addStage({ stageName }), sharedParent = new helpers_internal_1.GraphNodeCollection((0, javascript_1.flatten)(tranches)).commonAncestor();
            let runOrder = 1;
            for (const tranche of tranches) {
              const runOrdersConsumed = [0];
              for (const node of tranche) {
                const factory = this.actionFromNode(node), nodeType = this.nodeTypeFromNode(node), name = (0, identifiers_1.actionName)(node, sharedParent), variablesNamespace = node.data?.type === "step" ? (0, outputs_1.namespaceStepOutputs)(node.data.step, pipelineStage, name) : void 0, result = factory.produceAction(pipelineStage, { actionName: name, runOrder, artifacts: this.artifacts, scope: (0, construct_internals_1.obtainScope)(this.pipeline, stageName), fallbackArtifact: this._fallbackArtifact, pipeline: this, codeBuildDefaults: nodeType ? this.codeBuildDefaultsFor(nodeType) : void 0, beforeSelfMutation, variablesNamespace, stackOutputsMap: this.stackOutputs });
                node.data?.type === "self-update" && (beforeSelfMutation = false), this.postProcessNode(node, result), runOrdersConsumed.push(result.runOrdersConsumed);
              }
              runOrder += Math.max(...runOrdersConsumed);
            }
          }
        }
      }
      postProcessNode(node, result) {
        const nodeType = this.nodeTypeFromNode(node);
        if (result.project) {
          const dockerUsage = dockerUsageFromCodeBuild(nodeType ?? CodeBuildProjectType.STEP);
          if (dockerUsage)
            for (const c of this.dockerCredentials)
              c.grantRead(result.project, dockerUsage);
          nodeType === CodeBuildProjectType.SYNTH && (this._synthProject = result.project), nodeType === CodeBuildProjectType.SELF_MUTATE && (this._selfMutationProject = result.project);
        }
        node.data?.type === "step" && node.data.step.primaryOutput?.primaryOutput && !this._fallbackArtifact && (this._fallbackArtifact = this.artifacts.toCodePipeline(node.data.step.primaryOutput?.primaryOutput));
      }
      actionFromNode(node) {
        switch (node.data?.type) {
          case "group":
          case "stack-group":
          case void 0:
            throw new Error(`actionFromNode: did not expect to get group nodes: ${node.data?.type}`);
          case "self-update":
            return this.selfMutateAction();
          case "publish-assets":
            return this.publishAssetsAction(node, node.data.assets);
          case "prepare":
            return this.createChangeSetAction(node.data.stack);
          case "execute":
            return node.data.withoutChangeSet ? this.executeDeploymentAction(node.data.stack, node.data.captureOutputs) : this.executeChangeSetAction(node.data.stack, node.data.captureOutputs);
          case "step":
            return this.actionFromStep(node, node.data.step);
          default:
            throw new Error(`CodePipeline does not support graph nodes of type '${node.data?.type}'. You are probably using a feature this CDK Pipelines implementation does not support.`);
        }
      }
      actionFromStep(node, step) {
        const nodeType = this.nodeTypeFromNode(node);
        if (isCodePipelineActionFactory(step))
          return step;
        if (step instanceof blueprint_1.ShellStep || step instanceof codebuild_step_1.CodeBuildStep) {
          let constructId = nodeType === CodeBuildProjectType.SYNTH ? "CdkBuildProject" : step.id;
          return step instanceof codebuild_step_1.CodeBuildStep ? codebuild_factory_1.CodeBuildFactory.fromCodeBuildStep(constructId, step) : codebuild_factory_1.CodeBuildFactory.fromShellStep(constructId, step);
        }
        if (step instanceof blueprint_1.ManualApprovalStep)
          return { produceAction: (stage, options) => (stage.addAction(new cpa.ManualApprovalAction({ actionName: options.actionName, runOrder: options.runOrder, additionalInformation: step.comment })), { runOrdersConsumed: 1 }) };
        throw new Error(`Deployment step '${step}' is not supported for CodePipeline-backed pipelines`);
      }
      createChangeSetAction(stack) {
        const changeSetName = "PipelineChange", templateArtifact = this.artifacts.toCodePipeline(this._cloudAssemblyFileSet), templateConfigurationPath = this.writeTemplateConfiguration(stack), region = stack.region !== core_1.Stack.of(this).region ? stack.region : void 0, account = stack.account !== core_1.Stack.of(this).account ? stack.account : void 0, relativeTemplatePath = path.relative(this.myCxAsmRoot, stack.absoluteTemplatePath);
        return { produceAction: (stage, options) => (stage.addAction(new cpa.CloudFormationCreateReplaceChangeSetAction({ actionName: options.actionName, runOrder: options.runOrder, changeSetName, stackName: stack.stackName, templatePath: templateArtifact.atPath((0, fs_1.toPosixPath)(relativeTemplatePath)), adminPermissions: true, role: this.roleFromPlaceholderArn(this.pipeline, region, account, stack.assumeRoleArn), deploymentRole: this.roleFromPlaceholderArn(this.pipeline, region, account, stack.executionRoleArn), region, templateConfiguration: templateConfigurationPath ? templateArtifact.atPath((0, fs_1.toPosixPath)(templateConfigurationPath)) : void 0, cfnCapabilities: [core_1.CfnCapabilities.NAMED_IAM, core_1.CfnCapabilities.AUTO_EXPAND] })), { runOrdersConsumed: 1 }) };
      }
      executeChangeSetAction(stack, captureOutputs) {
        const changeSetName = "PipelineChange", region = stack.region !== core_1.Stack.of(this).region ? stack.region : void 0, account = stack.account !== core_1.Stack.of(this).account ? stack.account : void 0;
        return { produceAction: (stage, options) => (stage.addAction(new cpa.CloudFormationExecuteChangeSetAction({ actionName: options.actionName, runOrder: options.runOrder, changeSetName, stackName: stack.stackName, role: this.roleFromPlaceholderArn(this.pipeline, region, account, stack.assumeRoleArn), region, variablesNamespace: captureOutputs ? (0, identifiers_1.stackVariableNamespace)(stack) : void 0 })), { runOrdersConsumed: 1 }) };
      }
      executeDeploymentAction(stack, captureOutputs) {
        const templateArtifact = this.artifacts.toCodePipeline(this._cloudAssemblyFileSet), templateConfigurationPath = this.writeTemplateConfiguration(stack), region = stack.region !== core_1.Stack.of(this).region ? stack.region : void 0, account = stack.account !== core_1.Stack.of(this).account ? stack.account : void 0, relativeTemplatePath = path.relative(this.myCxAsmRoot, stack.absoluteTemplatePath);
        return { produceAction: (stage, options) => (stage.addAction(new cpa.CloudFormationCreateUpdateStackAction({ actionName: options.actionName, runOrder: options.runOrder, stackName: stack.stackName, templatePath: templateArtifact.atPath((0, fs_1.toPosixPath)(relativeTemplatePath)), adminPermissions: true, role: this.roleFromPlaceholderArn(this.pipeline, region, account, stack.assumeRoleArn), deploymentRole: this.roleFromPlaceholderArn(this.pipeline, region, account, stack.executionRoleArn), region, templateConfiguration: templateConfigurationPath ? templateArtifact.atPath((0, fs_1.toPosixPath)(templateConfigurationPath)) : void 0, cfnCapabilities: [core_1.CfnCapabilities.NAMED_IAM, core_1.CfnCapabilities.AUTO_EXPAND], variablesNamespace: captureOutputs ? (0, identifiers_1.stackVariableNamespace)(stack) : void 0 })), { runOrdersConsumed: 1 }) };
      }
      selfMutateAction() {
        const installSuffix = this.cliVersion ? `@${this.cliVersion}` : "", pipelineStack = core_1.Stack.of(this.pipeline), pipelineStackIdentifier = pipelineStack.node.path ?? pipelineStack.stackName, step = new codebuild_step_1.CodeBuildStep("SelfMutate", { projectName: (0, javascript_1.maybeSuffix)(this.props.pipelineName, "-selfupdate"), input: this._cloudAssemblyFileSet, installCommands: [`npm install -g aws-cdk${installSuffix}`], commands: [`cdk -a ${(0, fs_1.toPosixPath)((0, construct_internals_1.embeddedAsmPath)(this.pipeline))} deploy ${pipelineStackIdentifier} --require-approval=never --verbose`], rolePolicyStatements: [new iam.PolicyStatement({ actions: ["sts:AssumeRole"], resources: [`arn:*:iam::${core_1.Stack.of(this.pipeline).account}:role/*`], conditions: { "ForAnyValue:StringEquals": { "iam:ResourceTag/aws-cdk:bootstrap-role": ["image-publishing", "file-publishing", "deploy"] } } }), new iam.PolicyStatement({ actions: ["cloudformation:DescribeStacks"], resources: ["*"] }), new iam.PolicyStatement({ actions: ["s3:ListBucket"], resources: ["*"] })] });
        return codebuild_factory_1.CodeBuildFactory.fromCodeBuildStep("SelfMutation", step, { additionalConstructLevel: false, scope: (0, construct_internals_1.obtainScope)(this, "UpdatePipeline") });
      }
      publishAssetsAction(node, assets) {
        const installSuffix = this.cliVersion ? `@${this.cliVersion}` : "", commands = assets.map((asset) => {
          const relativeAssetManifestPath = path.relative(this.myCxAsmRoot, asset.assetManifestPath);
          return `cdk-assets --path "${(0, fs_1.toPosixPath)(relativeAssetManifestPath)}" --verbose publish "${asset.assetSelector}"`;
        }), assetType = assets[0].assetType;
        if (assets.some((a) => a.assetType !== assetType))
          throw new Error("All assets in a single publishing step must be of the same type");
        const role = this.obtainAssetCodeBuildRole(assets[0].assetType);
        for (const roleArn of assets.flatMap((a) => a.assetPublishingRoleArn ? [a.assetPublishingRoleArn] : []))
          role.addAssumeRole(this.cachedFnSub.fnSub(roleArn));
        const script = new codebuild_step_1.CodeBuildStep(node.id, { commands, installCommands: [`npm install -g cdk-assets${installSuffix}`], input: this._cloudAssemblyFileSet, buildEnvironment: { privileged: assets.some((asset) => asset.assetType === blueprint_1.AssetType.DOCKER_IMAGE) || this.props.codeBuildDefaults?.buildEnvironment?.privileged }, role });
        return codebuild_factory_1.CodeBuildFactory.fromCodeBuildStep(node.id, script, { additionalConstructLevel: false, passBuildSpecViaCloudAssembly: this.singlePublisherPerAssetType, scope: this.assetsScope });
      }
      nodeTypeFromNode(node) {
        if (node.data?.type === "step")
          return node.data?.isBuildStep ? CodeBuildProjectType.SYNTH : CodeBuildProjectType.STEP;
        if (node.data?.type === "publish-assets")
          return CodeBuildProjectType.ASSETS;
        if (node.data?.type === "self-update")
          return CodeBuildProjectType.SELF_MUTATE;
      }
      codeBuildDefaultsFor(nodeType) {
        const defaultOptions = { buildEnvironment: { buildImage: default_codebuild_image_1.CDKP_DEFAULT_CODEBUILD_IMAGE, computeType: cb.ComputeType.SMALL } }, typeBasedCustomizations = { [CodeBuildProjectType.SYNTH]: this.props.dockerEnabledForSynth ? (0, codebuild_factory_1.mergeCodeBuildOptions)(this.props.synthCodeBuildDefaults, { buildEnvironment: { privileged: true } }) : this.props.synthCodeBuildDefaults, [CodeBuildProjectType.ASSETS]: this.props.assetPublishingCodeBuildDefaults, [CodeBuildProjectType.SELF_MUTATE]: this.props.dockerEnabledForSelfMutation ? (0, codebuild_factory_1.mergeCodeBuildOptions)(this.props.selfMutationCodeBuildDefaults, { buildEnvironment: { privileged: true } }) : this.props.selfMutationCodeBuildDefaults, [CodeBuildProjectType.STEP]: {} }, dockerUsage = dockerUsageFromCodeBuild(nodeType), dockerCommands = dockerUsage !== void 0 ? (0, docker_credentials_1.dockerCredentialsInstallCommands)(dockerUsage, this.dockerCredentials, "both") : [], typeBasedDockerCommands = dockerCommands.length > 0 ? { partialBuildSpec: cb.BuildSpec.fromObject({ version: "0.2", phases: { pre_build: { commands: dockerCommands } } }) } : {};
        return (0, codebuild_factory_1.mergeCodeBuildOptions)(defaultOptions, this.props.codeBuildDefaults, typeBasedCustomizations[nodeType], typeBasedDockerCommands);
      }
      roleFromPlaceholderArn(scope, region, account, arn) {
        if (!arn)
          return;
        const id = arn;
        let existingRole = scope.node.tryFindChild(`ImmutableRole${id}`);
        if (existingRole || (existingRole = scope.node.tryFindChild(id), existingRole))
          return existingRole;
        const arnToImport = cxapi.EnvironmentPlaceholders.replace(arn, { region: region ?? core_1.Aws.REGION, accountId: account ?? core_1.Aws.ACCOUNT_ID, partition: core_1.Aws.PARTITION });
        return iam.Role.fromRoleArn(scope, id, arnToImport, { mutable: false, addGrantsToResources: true });
      }
      writeTemplateConfiguration(stack) {
        if (Object.keys(stack.tags).length === 0)
          return;
        const absConfigPath = `${stack.absoluteTemplatePath}.config.json`, relativeConfigPath = path.relative(this.myCxAsmRoot, absConfigPath);
        return (0, template_configuration_1.writeTemplateConfiguration)(absConfigPath, { Tags: (0, javascript_1.noUndefined)(stack.tags) }), relativeConfigPath;
      }
      obtainAssetCodeBuildRole(assetType) {
        const existing = this.assetCodeBuildRoles.get(assetType);
        if (existing)
          return existing;
        const stack = core_1.Stack.of(this), rolePrefix = assetType === blueprint_1.AssetType.DOCKER_IMAGE ? "Docker" : "File", assetRole = new asset_singleton_role_1.AssetSingletonRole(this.assetsScope, `${rolePrefix}Role`, { roleName: core_1.PhysicalName.GENERATE_IF_NEEDED, assumedBy: new iam.CompositePrincipal(new iam.ServicePrincipal("codebuild.amazonaws.com"), new iam.AccountPrincipal(stack.account)) });
        return assetType === blueprint_1.AssetType.DOCKER_IMAGE && this.dockerCredentials.forEach((reg) => reg.grantRead(assetRole, docker_credentials_1.DockerCredentialUsage.ASSET_PUBLISHING)), this.assetCodeBuildRoles.set(assetType, assetRole), assetRole;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CodePipeline[_a] = { fqn: "aws-cdk-lib.pipelines.CodePipeline", version: "2.80.0" }, exports2.CodePipeline = CodePipeline;
    function dockerUsageFromCodeBuild(cbt) {
      switch (cbt) {
        case CodeBuildProjectType.ASSETS:
          return docker_credentials_1.DockerCredentialUsage.ASSET_PUBLISHING;
        case CodeBuildProjectType.SELF_MUTATE:
          return docker_credentials_1.DockerCredentialUsage.SELF_UPDATE;
        case CodeBuildProjectType.SYNTH:
          return docker_credentials_1.DockerCredentialUsage.SYNTH;
        case CodeBuildProjectType.STEP:
          return;
      }
    }
    var CodeBuildProjectType;
    (function(CodeBuildProjectType2) {
      CodeBuildProjectType2.SYNTH = "SYNTH", CodeBuildProjectType2.ASSETS = "ASSETS", CodeBuildProjectType2.SELF_MUTATE = "SELF_MUTATE", CodeBuildProjectType2.STEP = "STEP";
    })(CodeBuildProjectType || (CodeBuildProjectType = {}));
    function chunkTranches(n, xss) {
      const ret = [];
      for (; xss.length > 0; ) {
        const tranches = [];
        let count = 0;
        for (; xss.length > 0; ) {
          const xs = xss[0], spaceRemaining = n - count;
          if (xs.length <= spaceRemaining)
            tranches.push(xs), count += xs.length, xss.shift();
          else {
            tranches.push(xs.splice(0, spaceRemaining)), count = n;
            break;
          }
        }
        ret.push(tranches);
      }
      return ret;
    }
    function isCodePipelineActionFactory(x) {
      return !!x.produceAction;
    }
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/codepipeline/codepipeline-action-factory.js
var require_codepipeline_action_factory = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/codepipeline/codepipeline-action-factory.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/codepipeline/codepipeline-source.js
var require_codepipeline_source2 = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/codepipeline/codepipeline-source.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.CodePipelineSource = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var constructs_1 = require_lib2();
    var outputs_1 = require_outputs2();
    var cp_actions = require_aws_codepipeline_actions();
    var core_1 = require_core2();
    var blueprint_1 = require_blueprint();
    var CodePipelineSource = class extends blueprint_1.Step {
      constructor() {
        super(...arguments), this.isSource = true;
      }
      static gitHub(repoString, branch, props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_pipelines_GitHubSourceOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.gitHub), error;
        }
        return new GitHubSource(repoString, branch, props);
      }
      static s3(bucket, objectKey, props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_s3_IBucket(bucket), jsiiDeprecationWarnings.aws_cdk_lib_pipelines_S3SourceOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.s3), error;
        }
        return new S3Source(bucket, objectKey, props);
      }
      static ecr(repository, props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_ecr_IRepository(repository), jsiiDeprecationWarnings.aws_cdk_lib_pipelines_ECRSourceOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.ecr), error;
        }
        return new ECRSource(repository, props);
      }
      static connection(repoString, branch, props) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_pipelines_ConnectionSourceOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.connection), error;
        }
        return new CodeStarConnectionSource(repoString, branch, props);
      }
      static codeCommit(repository, branch, props = {}) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codecommit_IRepository(repository), jsiiDeprecationWarnings.aws_cdk_lib_pipelines_CodeCommitSourceOptions(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.codeCommit), error;
        }
        return new CodeCommitSource(repository, branch, props);
      }
      produceAction(stage, options) {
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_aws_codepipeline_IStage(stage), jsiiDeprecationWarnings.aws_cdk_lib_pipelines_ProduceActionOptions(options);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, this.produceAction), error;
        }
        const output = options.artifacts.toCodePipeline(this.primaryOutput), action = this.getAction(output, options.actionName, options.runOrder, options.variablesNamespace);
        return stage.addAction(action), { runOrdersConsumed: 1 };
      }
      sourceAttribute(name) {
        return (0, outputs_1.makeCodePipelineOutput)(this, name);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, CodePipelineSource[_a] = { fqn: "aws-cdk-lib.pipelines.CodePipelineSource", version: "2.80.0" }, exports2.CodePipelineSource = CodePipelineSource;
    var GitHubSource = class extends CodePipelineSource {
      constructor(repoString, branch, props) {
        super(repoString), this.branch = branch, this.props = props;
        const parts = repoString.split("/");
        if (core_1.Token.isUnresolved(repoString) || parts.length !== 2)
          throw new Error(`GitHub repository name should be a resolved string like '<owner>/<repo>', got '${repoString}'`);
        this.owner = parts[0], this.repo = parts[1], this.authentication = props.authentication ?? core_1.SecretValue.secretsManager("github-token"), this.configurePrimaryOutput(new blueprint_1.FileSet("Source", this));
      }
      getAction(output, actionName, runOrder, variablesNamespace) {
        return new cp_actions.GitHubSourceAction({ output, actionName: this.props.actionName ?? actionName, runOrder, oauthToken: this.authentication, owner: this.owner, repo: this.repo, branch: this.branch, trigger: this.props.trigger, variablesNamespace });
      }
    };
    var S3Source = class extends CodePipelineSource {
      constructor(bucket, objectKey, props) {
        super(constructs_1.Node.of(bucket).addr), this.bucket = bucket, this.objectKey = objectKey, this.props = props, this.configurePrimaryOutput(new blueprint_1.FileSet("Source", this));
      }
      getAction(output, _actionName, runOrder, variablesNamespace) {
        return new cp_actions.S3SourceAction({ output, actionName: this.props.actionName ?? this.bucket.bucketName, runOrder, bucketKey: this.objectKey, trigger: this.props.trigger, bucket: this.bucket, role: this.props.role, variablesNamespace });
      }
    };
    var ECRSource = class extends CodePipelineSource {
      constructor(repository, props) {
        super(constructs_1.Node.of(repository).addr), this.repository = repository, this.props = props, this.configurePrimaryOutput(new blueprint_1.FileSet("Source", this));
      }
      getAction(output, _actionName, runOrder, variablesNamespace) {
        const formattedRepositoryName = core_1.Fn.join("_", core_1.Fn.split("/", this.repository.repositoryName));
        return new cp_actions.EcrSourceAction({ output, actionName: this.props.actionName ?? formattedRepositoryName, runOrder, repository: this.repository, imageTag: this.props.imageTag, variablesNamespace });
      }
    };
    var CodeStarConnectionSource = class extends CodePipelineSource {
      constructor(repoString, branch, props) {
        super(repoString), this.branch = branch, this.props = props;
        const parts = repoString.split("/");
        if (core_1.Token.isUnresolved(repoString) || parts.length !== 2)
          throw new Error(`CodeStar repository name should be a resolved string like '<owner>/<repo>', got '${repoString}'`);
        this.owner = parts[0], this.repo = parts[1], this.configurePrimaryOutput(new blueprint_1.FileSet("Source", this));
      }
      getAction(output, actionName, runOrder, variablesNamespace) {
        return new cp_actions.CodeStarConnectionsSourceAction({ output, actionName: this.props.actionName ?? actionName, runOrder, connectionArn: this.props.connectionArn, owner: this.owner, repo: this.repo, branch: this.branch, codeBuildCloneOutput: this.props.codeBuildCloneOutput, triggerOnPush: this.props.triggerOnPush, variablesNamespace });
      }
    };
    var CodeCommitSource = class extends CodePipelineSource {
      constructor(repository, branch, props) {
        super(core_1.Token.isUnresolved(repository.repositoryName) ? constructs_1.Node.of(repository).addr : repository.repositoryName), this.repository = repository, this.branch = branch, this.props = props, this.configurePrimaryOutput(new blueprint_1.FileSet("Source", this));
      }
      getAction(output, _actionName, runOrder, variablesNamespace) {
        return new cp_actions.CodeCommitSourceAction({ output, actionName: this.props.actionName ?? this.repository.repositoryName, runOrder, branch: this.branch, trigger: this.props.trigger, repository: this.repository, eventRole: this.props.eventRole, codeBuildCloneOutput: this.props.codeBuildCloneOutput, variablesNamespace });
      }
    };
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/codepipeline/index.js
var require_codepipeline4 = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/codepipeline/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_artifact_map(), exports2), __exportStar(require_codebuild_step(), exports2), __exportStar(require_confirm_permissions_broadening(), exports2), __exportStar(require_codepipeline3(), exports2), __exportStar(require_codepipeline_action_factory(), exports2), __exportStar(require_codepipeline_source2(), exports2), __exportStar(require_stack_outputs_map(), exports2);
  }
});

// node_modules/aws-cdk-lib/pipelines/lib/index.js
var require_lib261 = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_legacy2(), exports2), __exportStar(require_blueprint(), exports2), __exportStar(require_codepipeline4(), exports2), __exportStar(require_main(), exports2), __exportStar(require_docker_credentials(), exports2);
  }
});

// node_modules/aws-cdk-lib/pipelines/index.js
var require_pipelines = __commonJS({
  "node_modules/aws-cdk-lib/pipelines/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib261(), exports2);
  }
});

// node_modules/aws-cdk-lib/triggers/lib/trigger.js
var require_trigger = __commonJS({
  "node_modules/aws-cdk-lib/triggers/lib/trigger.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.TriggerInvalidation = exports2.Trigger = exports2.InvocationType = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var path_1 = require("path");
    var constructs_1 = require_lib2();
    var core_1 = require_core2();
    var InvocationType;
    (function(InvocationType2) {
      InvocationType2.EVENT = "Event", InvocationType2.REQUEST_RESPONSE = "RequestResponse", InvocationType2.DRY_RUN = "DryRun";
    })(InvocationType = exports2.InvocationType || (exports2.InvocationType = {}));
    var Trigger = class _Trigger extends constructs_1.Construct {
      constructor(scope, id, props) {
        super(scope, id);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_triggers_TriggerProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _Trigger), error;
        }
        const handlerArn = this.determineHandlerArn(props), provider = core_1.CustomResourceProvider.getOrCreateProvider(this, "AWSCDK.TriggerCustomResourceProvider", { runtime: (0, core_1.builtInCustomResourceProviderNodeRuntime)(this), codeDirectory: (0, path_1.join)(__dirname, "lambda") });
        provider.addToRolePolicy({ Effect: "Allow", Action: ["lambda:InvokeFunction"], Resource: [`${props.handler.functionArn}:*`] }), new core_1.CustomResource(this, "Default", { resourceType: "Custom::Trigger", serviceToken: provider.serviceToken, properties: { HandlerArn: handlerArn, InvocationType: props.invocationType ?? "RequestResponse", Timeout: props.timeout?.toMilliseconds().toString() ?? core_1.Duration.minutes(2).toMilliseconds().toString() } }), this.executeAfter(...props.executeAfter ?? []), this.executeBefore(...props.executeBefore ?? []);
      }
      executeAfter(...scopes) {
        constructs_1.Node.of(this).addDependency(...scopes);
      }
      executeBefore(...scopes) {
        for (const s of scopes)
          constructs_1.Node.of(s).addDependency(this);
      }
      determineHandlerArn(props) {
        return props.handler.currentVersion.functionArn;
      }
    };
    _a = JSII_RTTI_SYMBOL_1, Trigger[_a] = { fqn: "aws-cdk-lib.triggers.Trigger", version: "2.80.0" }, exports2.Trigger = Trigger;
    var TriggerInvalidation;
    (function(TriggerInvalidation2) {
      TriggerInvalidation2.HANDLER_CHANGE = "WHEN_FUNCTION_CHANGES";
    })(TriggerInvalidation = exports2.TriggerInvalidation || (exports2.TriggerInvalidation = {}));
  }
});

// node_modules/aws-cdk-lib/triggers/lib/trigger-function.js
var require_trigger_function = __commonJS({
  "node_modules/aws-cdk-lib/triggers/lib/trigger-function.js"(exports2) {
    "use strict";
    var _a;
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.TriggerFunction = void 0;
    var jsiiDeprecationWarnings = require_warnings_jsii();
    var JSII_RTTI_SYMBOL_1 = Symbol.for("jsii.rtti");
    var _1 = require_lib262();
    var lambda2 = require_aws_lambda();
    var TriggerFunction = class _TriggerFunction extends lambda2.Function {
      constructor(scope, id, props) {
        super(scope, id, props);
        try {
          jsiiDeprecationWarnings.aws_cdk_lib_triggers_TriggerFunctionProps(props);
        } catch (error) {
          throw process.env.JSII_DEBUG !== "1" && error.name === "DeprecationError" && Error.captureStackTrace(error, _TriggerFunction), error;
        }
        this.trigger = new _1.Trigger(this, "Trigger", { ...props, handler: this });
      }
      executeAfter(...scopes) {
        this.trigger.executeAfter(...scopes);
      }
      executeBefore(...scopes) {
        this.trigger.executeBefore(...scopes);
      }
    };
    _a = JSII_RTTI_SYMBOL_1, TriggerFunction[_a] = { fqn: "aws-cdk-lib.triggers.TriggerFunction", version: "2.80.0" }, exports2.TriggerFunction = TriggerFunction;
  }
});

// node_modules/aws-cdk-lib/triggers/lib/index.js
var require_lib262 = __commonJS({
  "node_modules/aws-cdk-lib/triggers/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_trigger(), exports2), __exportStar(require_trigger_function(), exports2);
  }
});

// node_modules/aws-cdk-lib/triggers/index.js
var require_triggers = __commonJS({
  "node_modules/aws-cdk-lib/triggers/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), __exportStar(require_lib262(), exports2);
  }
});

// node_modules/aws-cdk-lib/index.js
var require_aws_cdk_lib = __commonJS({
  "node_modules/aws-cdk-lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: true, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports22) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports22, p) && __createBinding(exports22, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true }), exports2.aws_codepipeline_actions = exports2.aws_codepipeline = exports2.aws_codegurureviewer = exports2.aws_codeguruprofiler = exports2.aws_codedeploy = exports2.aws_codecommit = exports2.aws_codebuild = exports2.aws_codeartifact = exports2.aws_cloudwatch_actions = exports2.aws_cloudwatch = exports2.aws_cloudtrail = exports2.aws_cloudfront_origins = exports2.aws_cloudfront = exports2.aws_cloudformation = exports2.aws_cloud9 = exports2.aws_chatbot = exports2.aws_certificatemanager = exports2.aws_ce = exports2.aws_cassandra = exports2.aws_budgets = exports2.aws_billingconductor = exports2.aws_batch = exports2.aws_backupgateway = exports2.aws_backup = exports2.aws_autoscalingplans = exports2.aws_autoscaling_hooktargets = exports2.aws_autoscaling_common = exports2.aws_autoscaling = exports2.aws_auditmanager = exports2.aws_athena = exports2.aws_aps = exports2.aws_appsync = exports2.aws_appstream = exports2.aws_apprunner = exports2.aws_appmesh = exports2.aws_applicationinsights = exports2.aws_applicationautoscaling = exports2.aws_appintegrations = exports2.aws_appflow = exports2.aws_appconfig = exports2.aws_apigatewayv2 = exports2.aws_apigateway = exports2.aws_amplifyuibuilder = exports2.aws_amplify = exports2.aws_amazonmq = exports2.aws_acmpca = exports2.aws_accessanalyzer = exports2.assets = exports2.assertions = exports2.alexa_ask = void 0, exports2.aws_frauddetector = exports2.aws_forecast = exports2.aws_fms = exports2.aws_fis = exports2.aws_finspace = exports2.aws_evidently = exports2.aws_eventschemas = exports2.aws_events_targets = exports2.aws_events = exports2.aws_emrserverless = exports2.aws_emrcontainers = exports2.aws_emr = exports2.aws_elasticsearch = exports2.aws_elasticloadbalancingv2_targets = exports2.aws_elasticloadbalancingv2_actions = exports2.aws_elasticloadbalancingv2 = exports2.aws_elasticloadbalancing = exports2.aws_elasticbeanstalk = exports2.aws_elasticache = exports2.aws_eks = exports2.aws_efs = exports2.aws_ecs_patterns = exports2.aws_ecs = exports2.aws_ecr_assets = exports2.aws_ecr = exports2.aws_ec2 = exports2.aws_dynamodb = exports2.aws_docdbelastic = exports2.aws_docdb = exports2.aws_dms = exports2.aws_dlm = exports2.aws_directoryservice = exports2.aws_devopsguru = exports2.aws_devicefarm = exports2.aws_detective = exports2.aws_dax = exports2.aws_datasync = exports2.aws_datapipeline = exports2.aws_databrew = exports2.aws_customerprofiles = exports2.aws_cur = exports2.aws_controltower = exports2.aws_connectcampaigns = exports2.aws_connect = exports2.aws_config = exports2.aws_comprehend = exports2.aws_cognito = exports2.aws_codestarnotifications = exports2.aws_codestarconnections = exports2.aws_codestar = void 0, exports2.aws_logs_destinations = exports2.aws_logs = exports2.aws_location = exports2.aws_lightsail = exports2.aws_licensemanager = exports2.aws_lex = exports2.aws_lambda_nodejs = exports2.aws_lambda_event_sources = exports2.aws_lambda_destinations = exports2.aws_lambda = exports2.aws_lakeformation = exports2.aws_kms = exports2.aws_kinesisvideo = exports2.aws_kinesisfirehose = exports2.aws_kinesisanalyticsv2 = exports2.aws_kinesisanalytics = exports2.aws_kinesis = exports2.aws_kendraranking = exports2.aws_kendra = exports2.aws_kafkaconnect = exports2.aws_ivschat = exports2.aws_ivs = exports2.aws_iotwireless = exports2.aws_iottwinmaker = exports2.aws_iotthingsgraph = exports2.aws_iotsitewise = exports2.aws_iotfleetwise = exports2.aws_iotfleethub = exports2.aws_iotevents = exports2.aws_iotcoredeviceadvisor = exports2.aws_iotanalytics = exports2.aws_iot1click = exports2.aws_iot = exports2.aws_internetmonitor = exports2.aws_inspectorv2 = exports2.aws_inspector = exports2.aws_imagebuilder = exports2.aws_identitystore = exports2.aws_iam = exports2.aws_healthlake = exports2.aws_guardduty = exports2.aws_groundstation = exports2.aws_greengrassv2 = exports2.aws_greengrass = exports2.aws_grafana = exports2.aws_glue = exports2.aws_globalaccelerator_endpoints = exports2.aws_globalaccelerator = exports2.aws_gamelift = exports2.aws_fsx = void 0, exports2.aws_route53recoverycontrol = exports2.aws_route53_targets = exports2.aws_route53_patterns = exports2.aws_route53 = exports2.aws_rolesanywhere = exports2.aws_robomaker = exports2.aws_resourcegroups = exports2.aws_resourceexplorer2 = exports2.aws_resiliencehub = exports2.aws_rekognition = exports2.aws_refactorspaces = exports2.aws_redshiftserverless = exports2.aws_redshift = exports2.aws_rds = exports2.aws_ram = exports2.aws_quicksight = exports2.aws_qldb = exports2.aws_proton = exports2.aws_pipes = exports2.aws_pinpointemail = exports2.aws_pinpoint = exports2.aws_personalize = exports2.aws_panorama = exports2.aws_osis = exports2.aws_organizations = exports2.aws_opsworkscm = exports2.aws_opsworks = exports2.aws_opensearchservice = exports2.aws_opensearchserverless = exports2.aws_omics = exports2.aws_oam = exports2.aws_nimblestudio = exports2.aws_networkmanager = exports2.aws_networkfirewall = exports2.aws_neptune = exports2.aws_mwaa = exports2.aws_msk = exports2.aws_memorydb = exports2.aws_mediatailor = exports2.aws_mediastore = exports2.aws_mediapackage = exports2.aws_medialive = exports2.aws_mediaconvert = exports2.aws_mediaconnect = exports2.aws_managedblockchain = exports2.aws_macie = exports2.aws_m2 = exports2.aws_lookoutvision = exports2.aws_lookoutmetrics = exports2.aws_lookoutequipment = void 0, exports2.lambda_layer_kubectl = exports2.lambda_layer_awscli = exports2.cx_api = exports2.custom_resources = exports2.cloudformation_include = exports2.cloud_assembly_schema = exports2.aws_xray = exports2.aws_workspaces = exports2.aws_wisdom = exports2.aws_wafv2 = exports2.aws_wafregional = exports2.aws_waf = exports2.aws_vpclattice = exports2.aws_voiceid = exports2.aws_transfer = exports2.aws_timestream = exports2.aws_systemsmanagersap = exports2.aws_synthetics = exports2.aws_supportapp = exports2.aws_stepfunctions_tasks = exports2.aws_stepfunctions = exports2.aws_sso = exports2.aws_ssmincidents = exports2.aws_ssmcontacts = exports2.aws_ssm = exports2.aws_sqs = exports2.aws_sns_subscriptions = exports2.aws_sns = exports2.aws_simspaceweaver = exports2.aws_signer = exports2.aws_ses_actions = exports2.aws_ses = exports2.aws_servicediscovery = exports2.aws_servicecatalogappregistry = exports2.aws_servicecatalog = exports2.aws_securityhub = exports2.aws_secretsmanager = exports2.aws_sdb = exports2.aws_scheduler = exports2.aws_sam = exports2.aws_sagemaker = exports2.aws_s3outposts = exports2.aws_s3objectlambda = exports2.aws_s3_notifications = exports2.aws_s3_deployment = exports2.aws_s3_assets = exports2.aws_s3 = exports2.aws_rum = exports2.aws_route53resolver = exports2.aws_route53recoveryreadiness = void 0, exports2.triggers = exports2.region_info = exports2.pipelines = exports2.lambda_layer_node_proxy_agent = void 0, exports2.alexa_ask = require_alexa_ask(), exports2.assertions = require_assertions(), exports2.assets = require_assets4(), exports2.aws_accessanalyzer = require_aws_accessanalyzer(), exports2.aws_acmpca = require_aws_acmpca(), exports2.aws_amazonmq = require_aws_amazonmq(), exports2.aws_amplify = require_aws_amplify(), exports2.aws_amplifyuibuilder = require_aws_amplifyuibuilder(), exports2.aws_apigateway = require_aws_apigateway(), exports2.aws_apigatewayv2 = require_aws_apigatewayv2(), exports2.aws_appconfig = require_aws_appconfig(), exports2.aws_appflow = require_aws_appflow(), exports2.aws_appintegrations = require_aws_appintegrations(), exports2.aws_applicationautoscaling = require_aws_applicationautoscaling(), exports2.aws_applicationinsights = require_aws_applicationinsights(), exports2.aws_appmesh = require_aws_appmesh(), exports2.aws_apprunner = require_aws_apprunner(), exports2.aws_appstream = require_aws_appstream(), exports2.aws_appsync = require_aws_appsync(), exports2.aws_aps = require_aws_aps(), exports2.aws_athena = require_aws_athena(), exports2.aws_auditmanager = require_aws_auditmanager(), exports2.aws_autoscaling = require_aws_autoscaling(), exports2.aws_autoscaling_common = require_aws_autoscaling_common(), exports2.aws_autoscaling_hooktargets = require_aws_autoscaling_hooktargets(), exports2.aws_autoscalingplans = require_aws_autoscalingplans(), exports2.aws_backup = require_aws_backup(), exports2.aws_backupgateway = require_aws_backupgateway(), exports2.aws_batch = require_aws_batch(), exports2.aws_billingconductor = require_aws_billingconductor(), exports2.aws_budgets = require_aws_budgets(), exports2.aws_cassandra = require_aws_cassandra(), exports2.aws_ce = require_aws_ce(), exports2.aws_certificatemanager = require_aws_certificatemanager(), exports2.aws_chatbot = require_aws_chatbot(), exports2.aws_cloud9 = require_aws_cloud9(), exports2.aws_cloudformation = require_aws_cloudformation(), exports2.aws_cloudfront = require_aws_cloudfront(), exports2.aws_cloudfront_origins = require_aws_cloudfront_origins(), exports2.aws_cloudtrail = require_aws_cloudtrail(), exports2.aws_cloudwatch = require_aws_cloudwatch(), exports2.aws_cloudwatch_actions = require_aws_cloudwatch_actions(), exports2.aws_codeartifact = require_aws_codeartifact(), exports2.aws_codebuild = require_aws_codebuild(), exports2.aws_codecommit = require_aws_codecommit(), exports2.aws_codedeploy = require_aws_codedeploy(), exports2.aws_codeguruprofiler = require_aws_codeguruprofiler(), exports2.aws_codegurureviewer = require_aws_codegurureviewer(), exports2.aws_codepipeline = require_aws_codepipeline(), exports2.aws_codepipeline_actions = require_aws_codepipeline_actions(), exports2.aws_codestar = require_aws_codestar(), exports2.aws_codestarconnections = require_aws_codestarconnections(), exports2.aws_codestarnotifications = require_aws_codestarnotifications(), exports2.aws_cognito = require_aws_cognito(), exports2.aws_comprehend = require_aws_comprehend(), exports2.aws_config = require_aws_config(), exports2.aws_connect = require_aws_connect(), exports2.aws_connectcampaigns = require_aws_connectcampaigns(), exports2.aws_controltower = require_aws_controltower(), exports2.aws_cur = require_aws_cur(), exports2.aws_customerprofiles = require_aws_customerprofiles(), exports2.aws_databrew = require_aws_databrew(), exports2.aws_datapipeline = require_aws_datapipeline(), exports2.aws_datasync = require_aws_datasync(), exports2.aws_dax = require_aws_dax(), exports2.aws_detective = require_aws_detective(), exports2.aws_devicefarm = require_aws_devicefarm(), exports2.aws_devopsguru = require_aws_devopsguru(), exports2.aws_directoryservice = require_aws_directoryservice(), exports2.aws_dlm = require_aws_dlm(), exports2.aws_dms = require_aws_dms(), exports2.aws_docdb = require_aws_docdb(), exports2.aws_docdbelastic = require_aws_docdbelastic(), exports2.aws_dynamodb = require_aws_dynamodb(), exports2.aws_ec2 = require_aws_ec2(), exports2.aws_ecr = require_aws_ecr(), exports2.aws_ecr_assets = require_aws_ecr_assets(), exports2.aws_ecs = require_aws_ecs(), exports2.aws_ecs_patterns = require_aws_ecs_patterns(), exports2.aws_efs = require_aws_efs(), exports2.aws_eks = require_aws_eks(), exports2.aws_elasticache = require_aws_elasticache(), exports2.aws_elasticbeanstalk = require_aws_elasticbeanstalk(), exports2.aws_elasticloadbalancing = require_aws_elasticloadbalancing(), exports2.aws_elasticloadbalancingv2 = require_aws_elasticloadbalancingv2(), exports2.aws_elasticloadbalancingv2_actions = require_aws_elasticloadbalancingv2_actions(), exports2.aws_elasticloadbalancingv2_targets = require_aws_elasticloadbalancingv2_targets(), exports2.aws_elasticsearch = require_aws_elasticsearch(), exports2.aws_emr = require_aws_emr(), exports2.aws_emrcontainers = require_aws_emrcontainers(), exports2.aws_emrserverless = require_aws_emrserverless(), exports2.aws_events = require_aws_events(), exports2.aws_events_targets = require_aws_events_targets(), exports2.aws_eventschemas = require_aws_eventschemas(), exports2.aws_evidently = require_aws_evidently(), exports2.aws_finspace = require_aws_finspace(), exports2.aws_fis = require_aws_fis(), exports2.aws_fms = require_aws_fms(), exports2.aws_forecast = require_aws_forecast(), exports2.aws_frauddetector = require_aws_frauddetector(), exports2.aws_fsx = require_aws_fsx(), exports2.aws_gamelift = require_aws_gamelift(), exports2.aws_globalaccelerator = require_aws_globalaccelerator(), exports2.aws_globalaccelerator_endpoints = require_aws_globalaccelerator_endpoints(), exports2.aws_glue = require_aws_glue(), exports2.aws_grafana = require_aws_grafana(), exports2.aws_greengrass = require_aws_greengrass(), exports2.aws_greengrassv2 = require_aws_greengrassv2(), exports2.aws_groundstation = require_aws_groundstation(), exports2.aws_guardduty = require_aws_guardduty(), exports2.aws_healthlake = require_aws_healthlake(), exports2.aws_iam = require_aws_iam(), exports2.aws_identitystore = require_aws_identitystore(), exports2.aws_imagebuilder = require_aws_imagebuilder(), exports2.aws_inspector = require_aws_inspector(), exports2.aws_inspectorv2 = require_aws_inspectorv2(), exports2.aws_internetmonitor = require_aws_internetmonitor(), exports2.aws_iot = require_aws_iot(), exports2.aws_iot1click = require_aws_iot1click(), exports2.aws_iotanalytics = require_aws_iotanalytics(), exports2.aws_iotcoredeviceadvisor = require_aws_iotcoredeviceadvisor(), exports2.aws_iotevents = require_aws_iotevents(), exports2.aws_iotfleethub = require_aws_iotfleethub(), exports2.aws_iotfleetwise = require_aws_iotfleetwise(), exports2.aws_iotsitewise = require_aws_iotsitewise(), exports2.aws_iotthingsgraph = require_aws_iotthingsgraph(), exports2.aws_iottwinmaker = require_aws_iottwinmaker(), exports2.aws_iotwireless = require_aws_iotwireless(), exports2.aws_ivs = require_aws_ivs(), exports2.aws_ivschat = require_aws_ivschat(), exports2.aws_kafkaconnect = require_aws_kafkaconnect(), exports2.aws_kendra = require_aws_kendra(), exports2.aws_kendraranking = require_aws_kendraranking(), exports2.aws_kinesis = require_aws_kinesis(), exports2.aws_kinesisanalytics = require_aws_kinesisanalytics(), exports2.aws_kinesisanalyticsv2 = require_aws_kinesisanalyticsv2(), exports2.aws_kinesisfirehose = require_aws_kinesisfirehose(), exports2.aws_kinesisvideo = require_aws_kinesisvideo(), exports2.aws_kms = require_aws_kms(), exports2.aws_lakeformation = require_aws_lakeformation(), exports2.aws_lambda = require_aws_lambda(), exports2.aws_lambda_destinations = require_aws_lambda_destinations(), exports2.aws_lambda_event_sources = require_aws_lambda_event_sources(), exports2.aws_lambda_nodejs = require_aws_lambda_nodejs(), exports2.aws_lex = require_aws_lex(), exports2.aws_licensemanager = require_aws_licensemanager(), exports2.aws_lightsail = require_aws_lightsail(), exports2.aws_location = require_aws_location(), exports2.aws_logs = require_aws_logs(), exports2.aws_logs_destinations = require_aws_logs_destinations(), exports2.aws_lookoutequipment = require_aws_lookoutequipment(), exports2.aws_lookoutmetrics = require_aws_lookoutmetrics(), exports2.aws_lookoutvision = require_aws_lookoutvision(), exports2.aws_m2 = require_aws_m2(), exports2.aws_macie = require_aws_macie(), exports2.aws_managedblockchain = require_aws_managedblockchain(), exports2.aws_mediaconnect = require_aws_mediaconnect(), exports2.aws_mediaconvert = require_aws_mediaconvert(), exports2.aws_medialive = require_aws_medialive(), exports2.aws_mediapackage = require_aws_mediapackage(), exports2.aws_mediastore = require_aws_mediastore(), exports2.aws_mediatailor = require_aws_mediatailor(), exports2.aws_memorydb = require_aws_memorydb(), exports2.aws_msk = require_aws_msk(), exports2.aws_mwaa = require_aws_mwaa(), exports2.aws_neptune = require_aws_neptune(), exports2.aws_networkfirewall = require_aws_networkfirewall(), exports2.aws_networkmanager = require_aws_networkmanager(), exports2.aws_nimblestudio = require_aws_nimblestudio(), exports2.aws_oam = require_aws_oam(), exports2.aws_omics = require_aws_omics(), exports2.aws_opensearchserverless = require_aws_opensearchserverless(), exports2.aws_opensearchservice = require_aws_opensearchservice(), exports2.aws_opsworks = require_aws_opsworks(), exports2.aws_opsworkscm = require_aws_opsworkscm(), exports2.aws_organizations = require_aws_organizations(), exports2.aws_osis = require_aws_osis(), exports2.aws_panorama = require_aws_panorama(), exports2.aws_personalize = require_aws_personalize(), exports2.aws_pinpoint = require_aws_pinpoint(), exports2.aws_pinpointemail = require_aws_pinpointemail(), exports2.aws_pipes = require_aws_pipes(), exports2.aws_proton = require_aws_proton(), exports2.aws_qldb = require_aws_qldb(), exports2.aws_quicksight = require_aws_quicksight(), exports2.aws_ram = require_aws_ram(), exports2.aws_rds = require_aws_rds(), exports2.aws_redshift = require_aws_redshift(), exports2.aws_redshiftserverless = require_aws_redshiftserverless(), exports2.aws_refactorspaces = require_aws_refactorspaces(), exports2.aws_rekognition = require_aws_rekognition(), exports2.aws_resiliencehub = require_aws_resiliencehub(), exports2.aws_resourceexplorer2 = require_aws_resourceexplorer2(), exports2.aws_resourcegroups = require_aws_resourcegroups(), exports2.aws_robomaker = require_aws_robomaker(), exports2.aws_rolesanywhere = require_aws_rolesanywhere(), exports2.aws_route53 = require_aws_route53(), exports2.aws_route53_patterns = require_aws_route53_patterns(), exports2.aws_route53_targets = require_aws_route53_targets(), exports2.aws_route53recoverycontrol = require_aws_route53recoverycontrol(), exports2.aws_route53recoveryreadiness = require_aws_route53recoveryreadiness(), exports2.aws_route53resolver = require_aws_route53resolver(), exports2.aws_rum = require_aws_rum(), exports2.aws_s3 = require_aws_s3(), exports2.aws_s3_assets = require_aws_s3_assets(), exports2.aws_s3_deployment = require_aws_s3_deployment(), exports2.aws_s3_notifications = require_aws_s3_notifications(), exports2.aws_s3objectlambda = require_aws_s3objectlambda(), exports2.aws_s3outposts = require_aws_s3outposts(), exports2.aws_sagemaker = require_aws_sagemaker(), exports2.aws_sam = require_aws_sam(), exports2.aws_scheduler = require_aws_scheduler(), exports2.aws_sdb = require_aws_sdb(), exports2.aws_secretsmanager = require_aws_secretsmanager(), exports2.aws_securityhub = require_aws_securityhub(), exports2.aws_servicecatalog = require_aws_servicecatalog(), exports2.aws_servicecatalogappregistry = require_aws_servicecatalogappregistry(), exports2.aws_servicediscovery = require_aws_servicediscovery(), exports2.aws_ses = require_aws_ses(), exports2.aws_ses_actions = require_aws_ses_actions(), exports2.aws_signer = require_aws_signer(), exports2.aws_simspaceweaver = require_aws_simspaceweaver(), exports2.aws_sns = require_aws_sns(), exports2.aws_sns_subscriptions = require_aws_sns_subscriptions(), exports2.aws_sqs = require_aws_sqs(), exports2.aws_ssm = require_aws_ssm(), exports2.aws_ssmcontacts = require_aws_ssmcontacts(), exports2.aws_ssmincidents = require_aws_ssmincidents(), exports2.aws_sso = require_aws_sso(), exports2.aws_stepfunctions = require_aws_stepfunctions(), exports2.aws_stepfunctions_tasks = require_aws_stepfunctions_tasks(), exports2.aws_supportapp = require_aws_supportapp(), exports2.aws_synthetics = require_aws_synthetics(), exports2.aws_systemsmanagersap = require_aws_systemsmanagersap(), exports2.aws_timestream = require_aws_timestream(), exports2.aws_transfer = require_aws_transfer(), exports2.aws_voiceid = require_aws_voiceid(), exports2.aws_vpclattice = require_aws_vpclattice(), exports2.aws_waf = require_aws_waf(), exports2.aws_wafregional = require_aws_wafregional(), exports2.aws_wafv2 = require_aws_wafv2(), exports2.aws_wisdom = require_aws_wisdom(), exports2.aws_workspaces = require_aws_workspaces(), exports2.aws_xray = require_aws_xray(), exports2.cloud_assembly_schema = require_cloud_assembly_schema2(), exports2.cloudformation_include = require_cloudformation_include(), exports2.custom_resources = require_custom_resources(), exports2.cx_api = require_cx_api(), exports2.lambda_layer_awscli = require_lambda_layer_awscli(), exports2.lambda_layer_kubectl = require_lambda_layer_kubectl(), exports2.lambda_layer_node_proxy_agent = require_lambda_layer_node_proxy_agent(), exports2.pipelines = require_pipelines(), exports2.region_info = require_region_info2(), exports2.triggers = require_triggers(), __exportStar(require_core2(), exports2);
  }
});

// src/time-windows/calendar/calendar-setup.lambda.ts
var calendar_setup_lambda_exports = {};
__export(calendar_setup_lambda_exports, {
  handler: () => handler
});
module.exports = __toCommonJS(calendar_setup_lambda_exports);
var import_aws_sdk = __toESM(require_aws());

// src/time-windows/calendar/calendar.ts
var import_aws_cdk_lib = __toESM(require_aws_cdk_lib());
var import_aws_iam = __toESM(require_aws_iam());
var import_custom_resources = __toESM(require_custom_resources());

// src/time-windows/calendar/calendar-setup-function.ts
var lambda = __toESM(require_aws_lambda());

// src/time-windows/calendar/calendar-setup.lambda.ts
var handler = async (event) => {
  console.log("Event: %j", { ...event, ResponseURL: "..." });
  const bucketName = event.ResourceProperties.bucketName;
  const calendarName = event.ResourceProperties.calendarName;
  const roleArn = event.ResourceProperties.roleArn;
  let calendar;
  if (event.ResourceProperties.sourceType === "path" /* PATH */) {
    calendar = event.ResourceProperties.calendarBody;
  } else {
    const s3 = roleArn ? await getSession(roleArn) : new import_aws_sdk.S3();
    calendar = (await s3.getObject({
      Bucket: bucketName,
      Key: calendarName
    }).promise()).Body.toString();
  }
  const ssm = new import_aws_sdk.SSM();
  if (event.RequestType === "Create") {
    const createDocumentRepsonse = await ssm.createDocument({
      Name: calendarName,
      Content: calendar,
      DocumentType: "ChangeCalendar",
      DocumentFormat: "TEXT"
    }).promise();
    console.log("Create document: %j", createDocumentRepsonse);
  }
  if (event.RequestType === "Update") {
    const updateDocumentResponse = await ssm.updateDocument({
      Name: calendarName,
      Content: calendar,
      DocumentVersion: "$LATEST"
    }).promise();
    console.log("Update document: %j", updateDocumentResponse);
  }
  if (event.RequestType === "Delete") {
    const deleteDocumentResponse = await ssm.deleteDocument({
      Name: calendarName
    }).promise();
    console.log("Delete document: %j", deleteDocumentResponse);
  }
  return {};
};
var getSession = async (roleArn) => {
  const sts = new import_aws_sdk.STS();
  const crentials = await sts.assumeRole({
    RoleArn: roleArn,
    RoleSessionName: "Calendar-Setup-Role"
  }).promise();
  return new import_aws_sdk.S3({
    credentials: {
      accessKeyId: crentials.Credentials.AccessKeyId,
      secretAccessKey: crentials.Credentials.SecretAccessKey,
      sessionToken: crentials.Credentials?.SessionToken
    }
  });
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  handler
});
/*! Bundled license information:

sax/lib/sax.js:
  (*! http://mths.be/fromcodepoint v0.1.0 by @mathias *)

@balena/dockerignore/ignore.js:
  (**
   * @license
   * Copyright 2020 Balena Ltd.
   *
   * Licensed under the Apache License, Version 2.0 (the "License");
   * you may not use this file except in compliance with the License.
   * You may obtain a copy of the License at
   *
   *    http://www.apache.org/licenses/LICENSE-2.0
   *
   * Unless required by applicable law or agreed to in writing, software
   * distributed under the License is distributed on an "AS IS" BASIS,
   * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   * See the License for the specific language governing permissions and
   * limitations under the License.
   *
   * ------------------------------------------------------------------------
   *
   * Copyright 2018 Zeit, Inc.
   * Licensed under the MIT License. See file LICENSE.md for a full copy.
   *
   * ------------------------------------------------------------------------
   *)

case/dist/Case.js:
  (*! Case - v1.6.2 - 2020-03-24
  * Copyright (c) 2020 Nathan Bubna; Licensed MIT, GPL *)
*/
